-- MySQL dump 10.13  Distrib 8.0.41, for Linux (x86_64)
--
-- Host: localhost    Database: magentodb
-- ------------------------------------------------------
-- Server version	8.0.41-0ubuntu0.24.04.1

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!50503 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `admin_adobe_ims_webapi`
--

DROP TABLE IF EXISTS `admin_adobe_ims_webapi`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `admin_adobe_ims_webapi` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `admin_user_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Admin User Id',
  `access_token_hash` varchar(255) DEFAULT NULL COMMENT 'Access Token Hash',
  `access_token` text COMMENT 'Access Token',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `last_check_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Last check time',
  `access_token_expires_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Access Token Expires At',
  PRIMARY KEY (`id`),
  UNIQUE KEY `ADMIN_ADOBE_IMS_WEBAPI_ACCESS_TOKEN_HASH` (`access_token_hash`),
  KEY `ADMIN_ADOBE_IMS_WEBAPI_ADMIN_USER_ID` (`admin_user_id`),
  CONSTRAINT `ADMIN_ADOBE_IMS_WEBAPI_ADMIN_USER_ID_ADMIN_USER_USER_ID` FOREIGN KEY (`admin_user_id`) REFERENCES `admin_user` (`user_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Admin Adobe IMS Webapi';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `admin_adobe_ims_webapi`
--

LOCK TABLES `admin_adobe_ims_webapi` WRITE;
/*!40000 ALTER TABLE `admin_adobe_ims_webapi` DISABLE KEYS */;
/*!40000 ALTER TABLE `admin_adobe_ims_webapi` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `admin_analytics_usage_version_log`
--

DROP TABLE IF EXISTS `admin_analytics_usage_version_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `admin_analytics_usage_version_log` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Log ID',
  `last_viewed_in_version` varchar(50) NOT NULL COMMENT 'Viewer last viewed on product version',
  PRIMARY KEY (`id`),
  UNIQUE KEY `ADMIN_ANALYTICS_USAGE_VERSION_LOG_LAST_VIEWED_IN_VERSION` (`last_viewed_in_version`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COMMENT='Admin Notification Viewer Log Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `admin_analytics_usage_version_log`
--

LOCK TABLES `admin_analytics_usage_version_log` WRITE;
/*!40000 ALTER TABLE `admin_analytics_usage_version_log` DISABLE KEYS */;
INSERT INTO `admin_analytics_usage_version_log` VALUES (1,'2.4.7');
/*!40000 ALTER TABLE `admin_analytics_usage_version_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `admin_passwords`
--

DROP TABLE IF EXISTS `admin_passwords`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `admin_passwords` (
  `password_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Password ID',
  `user_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'User ID',
  `password_hash` varchar(255) DEFAULT NULL COMMENT 'Password Hash',
  `expires` int unsigned NOT NULL DEFAULT '0' COMMENT 'Deprecated',
  `last_updated` int unsigned NOT NULL DEFAULT '0' COMMENT 'Last Updated',
  PRIMARY KEY (`password_id`),
  KEY `ADMIN_PASSWORDS_USER_ID` (`user_id`),
  CONSTRAINT `ADMIN_PASSWORDS_USER_ID_ADMIN_USER_USER_ID` FOREIGN KEY (`user_id`) REFERENCES `admin_user` (`user_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8mb3 COMMENT='Admin Passwords';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `admin_passwords`
--

LOCK TABLES `admin_passwords` WRITE;
/*!40000 ALTER TABLE `admin_passwords` DISABLE KEYS */;
INSERT INTO `admin_passwords` VALUES (1,1,'8f202df2c4535574e7d4f65125c6000a7cc476f146d41bbc0183cb042d5428f5:olwinBnWyRJX5BlpYANHyuf6WfHEzYre:3_32_2_67108864',0,1722849677),(2,2,'ca7144eab5c5011dc564eb3dcf6d89c538b026871dd967571d839e6ddd03993e:64OWijC4c6Dnc3SvYbzA4qIV0k9e68bp:3_32_2_67108864',0,1723553586),(3,3,'41854b2f02c7c7d9b7a6d951e580d8e8fa357791f335fb8ecde6e3b78bf12c0f:i7g41jtRMHxrhjFYeUjaLK9ZbXwwyCzo:3_32_2_67108864',0,1723553936),(4,1,'7318493687daca3791e349e1bfb699ee5e87d857f4709b64ed01e43dec1c380d:AEXag5lW62K3wZ9d2mW8hsCxdtizvBBQ:3_32_2_67108864',0,1730697675),(5,1,'652a6c9b4f8a7e6d7f388d0d6453f97d6acbbd22ba5f891dda1b3225e1cadc1c:7rmF2J7iVUz4U9x2oXrgQzCr1carSb30:3_32_2_67108864',0,1730698026),(6,1,'fb11b43512a687dd3d9384b66219b9da802dc2b9c32620942f9b503dc73ef351:47innn7e3ISvG9bpmvDtGJNcP4GZdgdZ:3_32_2_67108864',0,1730698348),(7,4,'789222b7379ab774d7a18e463f62c97231146894378acdd440097c57c6bb1d6e:8j3IecDmeuCjEQTqtEM2pbFi1fjBogIx:3_32_2_67108864',0,1736416351),(8,5,'337e659b1bf357be82b4df998345d0fae2bebf0a20ac69bbdf60a70530efe657:Iz9cFT0iOFnaoOe5hnsGEWNz867IROxC:3_32_2_67108864',0,1737382132),(9,6,'fe816e6ffb5a0f8d5eeb3af5aeecce7063ac2b7be73093d3e3411c58e57caf64:xlFpFu6Kj4jV97J10A0PaHB44usydj4q:3_32_2_67108864',0,1737526086),(10,5,'54e522f79073550e17a3ffdce8141071184f932929f548c5d77ef30674780604:7uMVsVHxHYeZNvKsDYpgIMVFeAgBle6l:3_32_2_67108864',0,1737710152),(11,7,'9376d4c51c698f55220dbeb7d372296bb561c5c13cf6e5bb89ccf8ebb866a759:RKc9q3R1p1n5QM3BkSIcOtl0Jy1o6lzj:3_32_2_67108864',0,1738069397);
/*!40000 ALTER TABLE `admin_passwords` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `admin_system_messages`
--

DROP TABLE IF EXISTS `admin_system_messages`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `admin_system_messages` (
  `identity` varchar(100) NOT NULL COMMENT 'Message ID',
  `severity` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Problem type',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Create date',
  PRIMARY KEY (`identity`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Admin System Messages';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `admin_system_messages`
--

LOCK TABLES `admin_system_messages` WRITE;
/*!40000 ALTER TABLE `admin_system_messages` DISABLE KEYS */;
INSERT INTO `admin_system_messages` VALUES ('7c5954236edabc5914c82fdddb8d479e',2,'2024-12-05 08:58:38');
/*!40000 ALTER TABLE `admin_system_messages` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `admin_user`
--

DROP TABLE IF EXISTS `admin_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `admin_user` (
  `user_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'User ID',
  `firstname` varchar(32) DEFAULT NULL COMMENT 'User First Name',
  `lastname` varchar(32) DEFAULT NULL COMMENT 'User Last Name',
  `email` varchar(128) DEFAULT NULL COMMENT 'User Email',
  `username` varchar(40) DEFAULT NULL COMMENT 'User Login',
  `password` varchar(255) NOT NULL COMMENT 'User Password',
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'User Created Time',
  `modified` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'User Modified Time',
  `logdate` timestamp NULL DEFAULT NULL COMMENT 'User Last Login Time',
  `lognum` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'User Login Number',
  `reload_acl_flag` smallint NOT NULL DEFAULT '0' COMMENT 'Reload ACL',
  `is_active` smallint NOT NULL DEFAULT '1' COMMENT 'User Is Active',
  `extra` text COMMENT 'User Extra Data',
  `rp_token` text COMMENT 'Reset Password Link Token',
  `rp_token_created_at` timestamp NULL DEFAULT NULL COMMENT 'Reset Password Link Token Creation Date',
  `interface_locale` varchar(16) NOT NULL DEFAULT 'en_US' COMMENT 'Backend interface locale',
  `failures_num` smallint DEFAULT '0' COMMENT 'Failure Number',
  `first_failure` timestamp NULL DEFAULT NULL COMMENT 'First Failure',
  `lock_expires` timestamp NULL DEFAULT NULL COMMENT 'Expiration Lock Dates',
  PRIMARY KEY (`user_id`),
  UNIQUE KEY `ADMIN_USER_USERNAME` (`username`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8mb3 COMMENT='Admin User Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `admin_user`
--

LOCK TABLES `admin_user` WRITE;
/*!40000 ALTER TABLE `admin_user` DISABLE KEYS */;
INSERT INTO `admin_user` VALUES (1,'Amit','Jha','mr.amitdev@gmail.com','admin','fb11b43512a687dd3d9384b66219b9da802dc2b9c32620942f9b503dc73ef351:47innn7e3ISvG9bpmvDtGJNcP4GZdgdZ:3_32_2_67108864','2024-08-05 09:21:17','2025-01-23 12:00:52','2025-01-23 12:00:52',402,0,1,'{\"configState\":{\"general_region\":\"0\",\"hyva_theme_general_messages\":\"0\",\"hyva_theme_general_alpine_defer\":\"0\",\"admin_usage\":\"1\",\"admin_dashboard\":\"1\",\"admin_security\":\"1\",\"admin_emails\":\"0\",\"admin_startup\":\"0\",\"admin_url\":\"0\",\"admin_grid\":\"0\",\"admin_captcha\":\"0\",\"catalog_search\":\"1\",\"catalog_fields_masks\":\"0\",\"catalog_frontend\":\"0\",\"catalog_review\":\"0\",\"catalog_productalert\":\"0\",\"catalog_productalert_cron\":\"0\",\"catalog_placeholder\":\"0\",\"catalog_recently_products\":\"0\",\"catalog_product_video\":\"1\",\"catalog_price\":\"0\",\"catalog_layered_navigation\":\"0\",\"catalog_seo\":\"0\",\"catalog_navigation\":\"0\",\"catalog_downloadable\":\"0\",\"catalog_custom_options\":\"0\",\"cataloginventory_options\":\"1\",\"cataloginventory_item_options\":\"1\",\"hyva_theme_catalog_frontend\":\"1\",\"mageworx_shippingrules_main\":\"0\",\"mageworx_shippingrules_validation\":\"0\",\"mageworx_shippingrules_developer\":\"0\",\"mageworx_shippingrules_shipping_methods\":\"0\",\"mageworx_shippingrules_countries\":\"0\",\"hyva_theme_catalog_recently_products\":\"1\",\"hyva_theme_catalog_crosssell_products\":\"1\",\"hyva_theme_catalog_hyva_breadcrumbs\":\"1\",\"hyva_theme_experimental_feature_flag\":\"0\",\"ajaxcart_general\":\"1\",\"ajaxcart_success_popup\":\"1\",\"ajaxcart_success_popup_design\":\"1\",\"ajaxcart_quickview_popup\":\"1\",\"ajaxcart_fly_to_cart\":\"1\",\"hyva_compat_base_general\":\"1\",\"hyva_compat_base_rewrite_template\":\"1\",\"mageworx_shipping_calculator_main\":\"1\",\"mageworx_shipping_calculator_shipping_methods\":\"1\",\"general_country\":\"0\",\"general_locale\":\"0\",\"general_store_information\":\"0\",\"general_single_store_mode\":\"0\",\"currency_options\":\"1\",\"currency_fixerio\":\"0\",\"currency_fixerio_apilayer\":\"0\",\"currency_currencyconverterapi\":\"0\",\"currency_import\":\"0\",\"customer_captcha\":\"1\",\"customer_startup\":\"0\",\"customer_account_share\":\"0\",\"customer_online_customers\":\"0\",\"customer_create_account\":\"0\",\"customer_password\":\"0\",\"customer_account_information\":\"0\",\"customer_address\":\"0\",\"customer_address_templates\":\"0\",\"recaptcha_frontend_type_for\":\"1\",\"recaptcha_frontend_failure_messages\":\"0\",\"recaptcha_frontend_type_recaptcha_v3\":\"0\",\"recaptcha_frontend_type_invisible\":\"0\",\"recaptcha_frontend_type_recaptcha\":\"0\",\"mageworx_settings_extensions\":\"0\",\"mageworx_settings_general\":\"0\",\"mageworx_settings_systeminfo\":\"0\",\"magepsycho_massimporterpro_general\":\"0\",\"apptrian_minify_general\":\"1\",\"productlabel_general\":\"1\",\"productlabel_display\":\"0\",\"mst_core_menu\":\"1\",\"web_unsecure\":\"1\",\"web_url\":\"1\",\"carriers_shipping\":\"0\",\"carriers_flatrate\":\"0\",\"carriers_matrixrate\":\"0\",\"carriers_freeshipping\":\"0\",\"carriers_tablerate\":\"0\",\"carriers_customshipping\":\"0\",\"carriers_instore\":\"0\",\"carriers_ups\":\"0\",\"carriers_usps\":\"0\",\"carriers_fedex\":\"0\",\"carriers_dhl\":\"0\",\"dev_debug\":\"1\",\"dev_front_end_development_workflow\":\"0\",\"dev_restrict\":\"0\",\"dev_template\":\"0\",\"dev_translate_inline\":\"0\",\"dev_js\":\"0\",\"dev_css\":\"0\",\"dev_image\":\"0\",\"dev_caching\":\"0\",\"dev_static\":\"0\",\"dev_grid\":\"0\",\"web_secure\":\"1\",\"mst_nav_general\":\"0\",\"mst_nav_styling\":\"0\",\"mageworx_shippingrules_popup\":\"0\",\"mageworx_shippingrules_import\":\"0\",\"mst_core_css\":\"0\"}}',NULL,NULL,'en_US',0,NULL,NULL),(2,'shakeel','shakeel@123','shakeel@nexus-home.com','Data team','ca7144eab5c5011dc564eb3dcf6d89c538b026871dd967571d839e6ddd03993e:64OWijC4c6Dnc3SvYbzA4qIV0k9e68bp:3_32_2_67108864','2024-08-13 12:53:06','2025-01-09 09:50:48','2025-01-09 09:50:48',134,0,1,'{\"configState\":{\"shipping_shipping_policy\":\"1\",\"shipping_origin\":\"0\"}}',NULL,NULL,'en_US',0,NULL,NULL),(3,'ab','usama@1234','usama.javed@nexus-home.com','DataU','41854b2f02c7c7d9b7a6d951e580d8e8fa357791f335fb8ecde6e3b78bf12c0f:i7g41jtRMHxrhjFYeUjaLK9ZbXwwyCzo:3_32_2_67108864','2024-08-13 12:58:56','2025-01-10 13:01:06','2024-09-24 15:05:43',79,0,1,'null',NULL,NULL,'en_US',1,'2025-01-10 13:01:06',NULL),(4,'zohaib1','zohaib2','zohaib.gulfam@nexus-home.com','Zohaib','789222b7379ab774d7a18e463f62c97231146894378acdd440097c57c6bb1d6e:8j3IecDmeuCjEQTqtEM2pbFi1fjBogIx:3_32_2_67108864','2025-01-09 09:52:31','2025-01-09 21:06:10','2025-01-09 10:07:35',1,0,1,'null',NULL,NULL,'en_US',2,'2025-01-09 21:05:46',NULL),(5,'hyva','Banyo','banyo@ko.com','new-hyva','54e522f79073550e17a3ffdce8141071184f932929f548c5d77ef30674780604:7uMVsVHxHYeZNvKsDYpgIMVFeAgBle6l:3_32_2_67108864','2025-01-20 14:08:52','2025-02-05 07:36:35','2025-02-05 07:36:35',131,0,1,'{\"configState\":{\"web_url\":\"1\",\"web_seo\":\"1\",\"web_unsecure\":\"1\",\"web_secure\":\"1\",\"web_default\":\"1\",\"web_cookie\":\"1\",\"web_browser_capabilities\":\"1\",\"general_country\":\"0\",\"general_region\":\"0\",\"general_locale\":\"0\",\"general_store_information\":\"0\",\"general_single_store_mode\":\"0\",\"cms_wysiwyg\":\"1\",\"cms_pagebuilder\":\"1\",\"mageworx_shippingrules_main\":\"0\",\"mageworx_shippingrules_validation\":\"0\",\"mageworx_shippingrules_shipping_methods\":\"0\",\"mageworx_shippingrules_popup\":\"0\",\"mageworx_shippingrules_import\":\"0\",\"mageworx_shippingrules_countries\":\"0\",\"mageworx_shippingrules_developer\":\"0\",\"apptrian_minify_general\":\"1\",\"dev_front_end_development_workflow\":\"0\",\"dev_restrict\":\"0\",\"dev_debug\":\"0\",\"dev_template\":\"0\",\"dev_translate_inline\":\"0\",\"dev_js\":\"0\",\"dev_css\":\"0\",\"dev_image\":\"0\",\"dev_caching\":\"0\",\"dev_static\":\"0\",\"dev_grid\":\"0\",\"hyva_theme_general_messages\":\"1\",\"admin_security\":\"1\",\"admin_emails\":\"0\",\"admin_startup\":\"0\",\"admin_url\":\"0\",\"admin_dashboard\":\"0\",\"admin_grid\":\"0\",\"admin_captcha\":\"0\",\"admin_usage\":\"0\",\"web_default_layouts\":\"0\",\"web_session\":\"1\",\"carriers_instore\":\"0\",\"carriers_shipping\":\"0\",\"carriers_matrixrate\":\"0\",\"carriers_tablerate\":\"0\",\"carriers_customshipping\":\"0\",\"carriers_flatrate\":\"0\",\"vesbrand_general_settings\":\"1\"}}',NULL,NULL,'en_US',0,NULL,NULL),(6,'Mageplaza','Family','hi@mageplaza.com','mageplaza','fe816e6ffb5a0f8d5eeb3af5aeecce7063ac2b7be73093d3e3411c58e57caf64:xlFpFu6Kj4jV97J10A0PaHB44usydj4q:3_32_2_67108864','2025-01-22 06:08:06','2025-01-22 06:13:16','2025-01-22 06:08:44',1,0,1,'{\"configState\":{\"hyva_theme_general_messages\":\"1\",\"hyva_theme_general_alpine_defer\":\"0\"}}',NULL,NULL,'en_US',0,NULL,NULL),(7,'dev','snsfamily','adminsns@gmail.com','adminsns','9376d4c51c698f55220dbeb7d372296bb561c5c13cf6e5bb89ccf8ebb866a759:RKc9q3R1p1n5QM3BkSIcOtl0Jy1o6lzj:3_32_2_67108864','2025-01-28 13:03:17','2025-01-28 13:04:11','2025-01-28 13:04:11',1,0,1,NULL,NULL,NULL,'en_US',0,NULL,NULL);
/*!40000 ALTER TABLE `admin_user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `admin_user_expiration`
--

DROP TABLE IF EXISTS `admin_user_expiration`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `admin_user_expiration` (
  `user_id` int unsigned NOT NULL COMMENT 'User ID',
  `expires_at` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'User Expiration Date',
  PRIMARY KEY (`user_id`),
  CONSTRAINT `ADMIN_USER_EXPIRATION_USER_ID_ADMIN_USER_USER_ID` FOREIGN KEY (`user_id`) REFERENCES `admin_user` (`user_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Admin User expiration dates table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `admin_user_expiration`
--

LOCK TABLES `admin_user_expiration` WRITE;
/*!40000 ALTER TABLE `admin_user_expiration` DISABLE KEYS */;
/*!40000 ALTER TABLE `admin_user_expiration` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `admin_user_session`
--

DROP TABLE IF EXISTS `admin_user_session`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `admin_user_session` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `session_id` varchar(1) DEFAULT NULL COMMENT 'Deprecated: Session ID value no longer used',
  `user_id` int unsigned DEFAULT NULL COMMENT 'Admin User ID',
  `status` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Current Session status',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created Time',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Update Time',
  `ip` varchar(15) NOT NULL COMMENT 'Remote user IP',
  PRIMARY KEY (`id`),
  KEY `ADMIN_USER_SESSION_SESSION_ID` (`session_id`),
  KEY `ADMIN_USER_SESSION_USER_ID` (`user_id`),
  CONSTRAINT `ADMIN_USER_SESSION_USER_ID_ADMIN_USER_USER_ID` FOREIGN KEY (`user_id`) REFERENCES `admin_user` (`user_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=754 DEFAULT CHARSET=utf8mb3 COMMENT='Admin User sessions table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `admin_user_session`
--

LOCK TABLES `admin_user_session` WRITE;
/*!40000 ALTER TABLE `admin_user_session` DISABLE KEYS */;
INSERT INTO `admin_user_session` VALUES (1,NULL,1,1,'2024-08-05 16:52:12','2024-08-05 16:55:04','27.34.70.14'),(2,NULL,1,1,'2024-08-07 06:45:45','2024-08-07 06:46:54','27.34.66.167'),(3,NULL,1,1,'2024-08-07 13:11:57','2024-08-07 13:25:36','27.34.66.215'),(4,NULL,1,1,'2024-08-07 13:41:42','2024-08-07 13:42:51','27.34.66.215'),(5,NULL,1,1,'2024-08-08 09:48:37','2024-08-08 10:00:21','27.34.66.215'),(6,NULL,1,1,'2024-08-09 05:12:41','2024-08-09 05:12:41','27.34.70.66'),(7,NULL,1,1,'2024-08-09 05:39:54','2024-08-09 05:39:54','27.34.70.66'),(8,NULL,1,1,'2024-08-09 08:10:22','2024-08-09 08:17:47','27.34.70.66'),(9,NULL,1,1,'2024-08-11 14:06:01','2024-08-11 14:10:40','27.34.70.15'),(10,NULL,1,2,'2024-08-12 08:31:48','2024-08-12 08:42:02','27.34.70.66'),(11,NULL,1,1,'2024-08-12 08:42:02','2024-08-12 08:46:29','27.34.66.176'),(12,NULL,1,2,'2024-08-12 09:02:08','2024-08-12 09:21:21','27.34.66.176'),(13,NULL,1,1,'2024-08-12 09:21:21','2024-08-12 09:28:17','27.34.70.66'),(14,NULL,1,1,'2024-08-12 11:36:15','2024-08-12 11:36:15','27.34.70.66'),(15,NULL,1,1,'2024-08-12 13:14:20','2024-08-12 13:20:19','27.34.66.176'),(16,NULL,1,2,'2024-08-13 12:24:35','2024-08-13 12:44:48','86.31.86.209'),(17,NULL,1,0,'2024-08-13 12:44:48','2024-08-13 12:49:28','119.155.16.140'),(18,NULL,1,1,'2024-08-13 12:49:29','2024-08-13 12:58:55','86.31.86.209'),(19,NULL,2,1,'2024-08-13 12:54:45','2024-08-13 13:52:33','119.155.16.140'),(20,NULL,2,1,'2024-08-13 14:21:14','2024-08-13 15:29:48','182.185.210.87'),(21,NULL,1,1,'2024-08-13 14:31:59','2024-08-13 14:32:28','27.34.70.38'),(22,NULL,2,1,'2024-08-13 15:46:01','2024-08-13 15:46:43','182.185.210.87'),(23,NULL,1,1,'2024-08-15 06:02:15','2024-08-15 06:04:22','27.34.70.66'),(24,NULL,2,1,'2024-08-15 06:55:48','2024-08-15 07:00:33','182.185.210.87'),(25,NULL,2,1,'2024-08-15 07:23:48','2024-08-15 08:11:15','182.185.210.87'),(26,NULL,2,1,'2024-08-15 08:33:36','2024-08-15 08:52:31','119.155.19.23'),(27,NULL,2,1,'2024-08-15 09:17:57','2024-08-15 09:36:25','119.155.19.23'),(28,NULL,1,1,'2024-08-15 09:19:27','2024-08-15 09:21:51','86.31.86.209'),(29,NULL,1,1,'2024-08-15 09:55:08','2024-08-15 09:57:04','86.31.86.209'),(30,NULL,2,1,'2024-08-15 09:56:11','2024-08-15 10:47:04','119.155.19.23'),(31,NULL,1,2,'2024-08-15 10:33:15','2024-08-15 10:52:24','86.31.86.209'),(32,NULL,1,1,'2024-08-15 10:52:24','2024-08-15 10:54:34','92.119.177.20'),(33,NULL,2,1,'2024-08-15 11:13:17','2024-08-15 12:17:48','119.155.19.23'),(34,NULL,1,2,'2024-08-15 11:36:39','2024-08-15 11:39:01','86.31.86.209'),(35,NULL,1,1,'2024-08-15 11:39:01','2024-08-15 11:48:26','86.31.86.209'),(36,NULL,1,2,'2024-08-15 12:08:12','2024-08-15 12:08:58','27.34.70.66'),(37,NULL,1,2,'2024-08-15 12:08:58','2024-08-15 12:10:13','86.31.86.209'),(38,NULL,1,1,'2024-08-15 12:10:13','2024-08-15 12:10:13','27.34.70.66'),(39,NULL,2,1,'2024-08-15 12:42:54','2024-08-15 12:58:01','119.155.19.23'),(40,NULL,2,1,'2024-08-15 13:17:38','2024-08-15 13:21:06','119.155.19.23'),(41,NULL,3,2,'2024-08-15 13:24:40','2024-08-15 13:26:16','119.155.19.23'),(42,NULL,3,1,'2024-08-15 13:26:16','2024-08-15 13:58:08','119.155.19.23'),(43,NULL,2,1,'2024-08-15 13:56:22','2024-08-15 13:56:22','119.155.19.23'),(44,NULL,3,1,'2024-08-15 14:17:00','2024-08-15 14:29:56','119.155.19.23'),(45,NULL,2,1,'2024-08-15 14:23:28','2024-08-15 14:23:28','119.155.19.23'),(46,NULL,2,1,'2024-08-15 14:46:50','2024-08-15 14:46:50','119.155.19.23'),(47,NULL,3,1,'2024-08-15 14:47:25','2024-08-15 15:08:00','119.155.19.23'),(48,NULL,2,1,'2024-08-15 15:19:20','2024-08-15 15:45:58','119.155.19.23'),(49,NULL,2,1,'2024-08-16 06:53:36','2024-08-16 06:57:59','119.155.19.23'),(50,NULL,2,1,'2024-08-16 07:24:51','2024-08-16 07:26:36','119.155.19.23'),(51,NULL,1,1,'2024-08-16 07:31:15','2024-08-16 07:31:43','27.34.66.219'),(52,NULL,2,0,'2024-08-16 07:49:17','2024-08-16 07:49:46','119.155.19.23'),(53,NULL,2,0,'2024-08-16 07:49:49','2024-08-16 07:50:43','119.155.19.23'),(54,NULL,2,1,'2024-08-16 07:50:47','2024-08-16 08:11:10','119.155.19.23'),(55,NULL,2,1,'2024-08-16 09:59:07','2024-08-16 12:10:33','119.155.19.23'),(56,NULL,1,1,'2024-08-16 11:36:44','2024-08-16 11:37:21','27.34.70.66'),(57,NULL,2,1,'2024-08-16 12:53:33','2024-08-16 13:26:36','119.155.19.23'),(58,NULL,2,2,'2024-08-16 13:42:50','2024-08-16 13:43:53','119.155.19.23'),(59,NULL,2,2,'2024-08-16 13:43:53','2024-08-16 13:44:38','119.155.19.23'),(60,NULL,2,1,'2024-08-16 13:44:38','2024-08-16 13:45:37','119.155.19.23'),(61,NULL,3,1,'2024-08-16 13:45:30','2024-08-16 13:45:30','119.155.19.23'),(62,NULL,2,1,'2024-08-16 14:27:16','2024-08-16 14:56:12','119.155.19.23'),(63,NULL,2,1,'2024-08-16 15:18:01','2024-08-16 15:21:56','182.185.202.221'),(64,NULL,2,1,'2024-08-19 08:57:45','2024-08-19 09:24:54','182.185.202.221'),(65,NULL,1,1,'2024-08-19 09:05:45','2024-08-19 10:14:34','27.34.70.43'),(66,NULL,2,1,'2024-08-19 09:48:37','2024-08-19 09:51:55','182.185.202.221'),(67,NULL,2,1,'2024-08-19 10:17:45','2024-08-19 10:51:55','182.185.202.221'),(68,NULL,2,1,'2024-08-19 11:14:39','2024-08-19 11:19:07','182.185.202.221'),(69,NULL,1,1,'2024-08-19 11:16:20','2024-08-19 11:30:17','27.34.66.221'),(70,NULL,2,1,'2024-08-19 13:51:06','2024-08-19 13:52:59','182.185.202.221'),(71,NULL,2,0,'2024-08-19 14:55:13','2024-08-19 14:57:56','182.185.202.221'),(72,NULL,2,1,'2024-08-19 14:58:00','2024-08-19 15:00:00','182.185.202.221'),(73,NULL,1,1,'2024-08-19 15:01:10','2024-08-19 15:47:58','27.34.70.25'),(74,NULL,2,1,'2024-08-19 16:09:48','2024-08-19 16:11:59','182.185.202.221'),(75,NULL,1,2,'2024-08-20 05:26:46','2024-08-20 06:16:50','27.34.70.66'),(76,NULL,1,2,'2024-08-20 06:16:50','2024-08-20 06:17:51','27.34.66.221'),(77,NULL,1,1,'2024-08-20 06:17:51','2024-08-20 08:34:54','27.34.70.66'),(78,NULL,1,1,'2024-08-20 06:27:37','2024-08-20 06:32:42','27.34.66.221'),(79,NULL,2,1,'2024-08-20 07:27:34','2024-08-20 07:40:12','182.185.202.221'),(80,NULL,2,1,'2024-08-20 08:01:15','2024-08-20 08:02:35','182.185.202.221'),(81,NULL,2,1,'2024-08-20 08:17:49','2024-08-20 08:18:28','182.185.202.221'),(82,NULL,1,1,'2024-08-20 08:27:11','2024-08-20 08:27:11','27.34.66.221'),(83,NULL,1,1,'2024-08-20 09:19:03','2024-08-20 09:22:38','27.34.70.66'),(84,NULL,2,1,'2024-08-20 09:29:03','2024-08-20 09:32:16','182.185.202.221'),(85,NULL,1,1,'2024-08-20 09:43:05','2024-08-20 11:25:21','27.34.70.66'),(86,NULL,2,0,'2024-08-20 09:54:43','2024-08-20 10:00:01','182.185.202.221'),(87,NULL,2,0,'2024-08-20 10:00:07','2024-08-20 10:02:19','182.185.202.221'),(88,NULL,2,0,'2024-08-20 10:02:24','2024-08-20 10:04:59','182.185.202.221'),(89,NULL,2,1,'2024-08-20 10:05:07','2024-08-20 10:10:10','182.185.202.221'),(90,NULL,1,1,'2024-08-20 10:07:49','2024-08-20 11:21:10','27.34.70.66'),(91,NULL,2,1,'2024-08-20 10:31:23','2024-08-20 10:31:23','182.185.202.221'),(92,NULL,1,1,'2024-08-20 11:18:35','2024-08-20 11:19:57','27.34.66.221'),(93,NULL,2,0,'2024-08-20 11:39:15','2024-08-20 11:40:39','182.185.202.221'),(94,NULL,2,0,'2024-08-20 11:40:49','2024-08-20 11:52:58','182.185.202.221'),(95,NULL,2,1,'2024-08-20 11:53:05','2024-08-20 12:19:45','182.185.202.221'),(96,NULL,2,1,'2024-08-20 12:43:17','2024-08-20 13:04:49','182.185.202.221'),(97,NULL,2,1,'2024-08-20 14:13:58','2024-08-20 14:16:44','182.185.202.221'),(98,NULL,2,1,'2024-08-20 14:36:43','2024-08-20 14:37:35','182.185.202.221'),(99,NULL,2,0,'2024-08-20 15:08:01','2024-08-20 15:29:00','182.185.202.221'),(100,NULL,2,1,'2024-08-20 15:29:22','2024-08-20 15:47:14','182.185.202.221'),(101,NULL,2,1,'2024-08-20 16:07:21','2024-08-20 16:29:17','182.185.202.221'),(102,NULL,1,1,'2024-08-21 05:19:04','2024-08-21 05:23:05','27.34.70.66'),(103,NULL,1,1,'2024-08-21 06:20:05','2024-08-21 07:16:42','27.34.70.66'),(104,NULL,2,1,'2024-08-21 07:45:37','2024-08-21 08:11:45','182.185.202.221'),(105,NULL,1,1,'2024-08-21 08:11:13','2024-08-21 08:12:18','27.34.70.66'),(106,NULL,2,1,'2024-08-21 08:39:08','2024-08-21 08:39:38','182.185.202.221'),(107,NULL,2,1,'2024-08-21 09:10:58','2024-08-21 09:11:38','182.185.202.221'),(108,NULL,1,1,'2024-08-21 09:51:00','2024-08-21 09:56:04','27.34.70.66'),(109,NULL,1,1,'2024-08-21 10:03:35','2024-08-21 10:21:53','27.34.70.66'),(110,NULL,2,1,'2024-08-21 10:07:52','2024-08-21 10:29:09','182.185.202.221'),(111,NULL,1,1,'2024-08-21 10:13:50','2024-08-21 10:51:20','27.34.70.66'),(112,NULL,2,1,'2024-08-21 10:59:06','2024-08-21 12:18:12','182.185.202.221'),(113,NULL,1,1,'2024-08-21 11:02:32','2024-08-21 11:10:25','27.34.70.66'),(114,NULL,1,1,'2024-08-21 11:06:28','2024-08-21 12:08:27','27.34.70.66'),(115,NULL,1,1,'2024-08-21 11:38:15','2024-08-21 11:56:50','27.34.70.66'),(116,NULL,1,1,'2024-08-21 13:08:44','2024-08-21 13:09:13','27.34.70.73'),(117,NULL,2,1,'2024-08-21 15:39:21','2024-08-21 15:39:56','182.185.202.221'),(118,NULL,2,1,'2024-08-21 16:10:41','2024-08-21 16:11:17','182.185.202.221'),(119,NULL,1,1,'2024-08-22 05:30:06','2024-08-22 06:25:48','27.34.70.66'),(120,NULL,1,1,'2024-08-22 05:34:57','2024-08-22 05:34:57','27.34.70.66'),(121,NULL,1,1,'2024-08-22 06:35:23','2024-08-22 06:49:44','27.34.70.66'),(122,NULL,1,1,'2024-08-22 06:38:23','2024-08-22 06:52:23','27.34.70.66'),(123,NULL,1,1,'2024-08-22 07:12:28','2024-08-22 08:35:48','27.34.70.66'),(124,NULL,1,1,'2024-08-22 07:35:44','2024-08-22 07:35:44','27.34.70.66'),(125,NULL,1,1,'2024-08-22 08:01:03','2024-08-22 08:03:14','27.34.70.66'),(126,NULL,1,1,'2024-08-22 09:06:24','2024-08-22 09:06:52','27.34.70.66'),(127,NULL,1,1,'2024-08-22 09:31:51','2024-08-22 10:43:44','27.34.70.66'),(128,NULL,1,1,'2024-08-22 09:40:57','2024-08-22 09:42:33','27.34.70.66'),(129,NULL,1,1,'2024-08-22 10:03:42','2024-08-22 10:10:08','27.34.70.66'),(130,NULL,1,1,'2024-08-22 10:30:50','2024-08-22 11:36:39','27.34.70.66'),(131,NULL,1,1,'2024-08-22 11:09:11','2024-08-22 11:19:18','27.34.70.66'),(132,NULL,2,1,'2024-08-22 13:12:58','2024-08-22 13:49:43','182.185.202.221'),(133,NULL,2,1,'2024-08-22 14:24:29','2024-08-22 14:24:29','182.185.202.221'),(134,NULL,2,1,'2024-08-22 14:41:09','2024-08-22 15:47:36','182.185.202.221'),(135,NULL,2,1,'2024-08-22 16:14:05','2024-08-22 16:56:19','182.185.202.221'),(136,NULL,1,1,'2024-08-23 05:51:44','2024-08-23 05:58:53','27.34.70.66'),(137,NULL,1,1,'2024-08-23 06:05:51','2024-08-23 06:16:31','27.34.70.66'),(138,NULL,1,1,'2024-08-23 06:35:55','2024-08-23 06:58:24','27.34.70.66'),(139,NULL,1,1,'2024-08-23 07:30:19','2024-08-23 07:30:19','27.34.70.66'),(140,NULL,2,1,'2024-08-23 07:47:30','2024-08-23 07:47:30','182.185.202.221'),(141,NULL,2,1,'2024-08-23 07:54:09','2024-08-23 07:54:50','72.255.40.107'),(142,NULL,1,1,'2024-08-23 08:02:08','2024-08-23 08:53:31','27.34.70.66'),(143,NULL,2,1,'2024-08-23 09:07:57','2024-08-23 09:10:16','72.255.40.107'),(144,NULL,1,1,'2024-08-23 10:15:05','2024-08-23 10:32:49','182.185.202.221'),(145,NULL,1,1,'2024-08-23 10:22:46','2024-08-23 11:09:27','27.34.70.66'),(146,NULL,1,1,'2024-08-23 11:16:37','2024-08-23 11:35:07','27.34.70.66'),(147,NULL,2,1,'2024-08-23 11:22:16','2024-08-23 11:22:16','72.255.40.107'),(148,NULL,1,1,'2024-08-23 11:25:59','2024-08-23 12:13:37','182.185.202.221'),(149,NULL,1,1,'2024-08-23 11:36:57','2024-08-23 12:01:24','27.34.70.66'),(150,NULL,3,1,'2024-08-23 11:47:35','2024-08-23 12:11:12','139.135.38.34'),(151,NULL,1,1,'2024-08-23 12:44:48','2024-08-23 13:24:48','182.185.202.221'),(152,NULL,1,1,'2024-08-26 05:41:16','2024-08-26 05:59:02','27.34.70.50'),(153,NULL,1,1,'2024-08-26 05:46:13','2024-08-26 05:53:47','27.34.70.50'),(154,NULL,1,1,'2024-08-26 06:14:52','2024-08-26 06:31:24','27.34.70.50'),(155,NULL,1,1,'2024-08-26 06:56:32','2024-08-26 08:43:03','27.34.70.50'),(156,NULL,1,1,'2024-08-26 09:45:04','2024-08-26 10:18:02','27.34.70.50'),(157,NULL,1,1,'2024-08-28 05:52:00','2024-08-28 05:58:26','27.34.70.50'),(158,NULL,1,1,'2024-08-28 06:21:48','2024-08-28 06:23:52','27.34.70.50'),(159,NULL,1,1,'2024-08-28 06:28:13','2024-08-28 06:31:30','27.34.70.50'),(160,NULL,1,1,'2024-08-28 07:33:34','2024-08-28 08:18:29','27.34.70.8'),(161,NULL,1,1,'2024-08-28 09:13:43','2024-08-28 09:32:05','27.34.70.8'),(162,NULL,1,1,'2024-08-28 11:06:12','2024-08-28 11:06:41','27.34.70.8'),(163,NULL,1,1,'2024-08-28 11:29:35','2024-08-28 11:39:42','27.34.70.8'),(164,NULL,1,1,'2024-08-28 12:00:28','2024-08-28 12:05:40','27.34.70.8'),(165,NULL,1,1,'2024-08-28 12:10:01','2024-08-28 12:11:22','27.34.70.8'),(166,NULL,1,1,'2024-08-29 05:35:16','2024-08-29 05:53:35','27.34.70.8'),(167,NULL,3,1,'2024-08-29 08:11:40','2024-08-29 08:36:59','119.155.6.151'),(168,NULL,2,1,'2024-08-29 08:24:44','2024-08-29 08:28:12','119.155.6.151'),(169,NULL,1,1,'2024-08-29 08:56:43','2024-08-29 09:25:20','27.34.70.8'),(170,NULL,3,1,'2024-08-29 09:02:30','2024-08-29 09:43:53','119.155.6.151'),(171,NULL,1,1,'2024-08-29 09:22:09','2024-08-29 10:14:49','27.34.70.8'),(172,NULL,1,1,'2024-08-29 09:51:07','2024-08-29 09:52:13','27.34.70.8'),(173,NULL,1,1,'2024-08-29 11:18:37','2024-08-29 11:20:45','27.34.70.8'),(174,NULL,3,1,'2024-08-29 12:43:57','2024-08-29 12:45:20','119.155.6.151'),(175,NULL,3,1,'2024-08-29 13:04:57','2024-08-29 13:36:23','119.155.6.151'),(176,NULL,3,1,'2024-08-29 13:55:25','2024-08-29 15:23:54','119.155.6.151'),(177,NULL,1,1,'2024-08-30 05:31:27','2024-08-30 05:47:32','27.34.70.8'),(178,NULL,1,1,'2024-08-30 06:05:11','2024-08-30 07:16:18','27.34.70.8'),(179,NULL,3,1,'2024-08-30 06:27:23','2024-08-30 07:24:08','119.155.6.151'),(180,NULL,1,1,'2024-08-30 07:34:14','2024-08-30 08:38:56','27.34.70.8'),(181,NULL,1,1,'2024-08-30 09:17:29','2024-08-30 09:47:29','27.34.70.8'),(182,NULL,1,1,'2024-08-30 09:40:52','2024-08-30 09:45:09','27.34.70.8'),(183,NULL,1,1,'2024-08-30 11:44:46','2024-08-30 12:22:22','27.34.70.8'),(184,NULL,3,1,'2024-08-30 12:34:34','2024-08-30 12:36:32','119.155.6.151'),(185,NULL,1,1,'2024-09-02 05:56:33','2024-09-02 05:59:50','27.34.70.8'),(186,NULL,1,1,'2024-09-02 06:17:52','2024-09-02 07:03:07','27.34.70.8'),(187,NULL,1,1,'2024-09-02 07:21:23','2024-09-02 07:42:01','27.34.70.8'),(188,NULL,3,1,'2024-09-02 09:29:49','2024-09-02 09:53:42','119.155.19.23'),(189,NULL,3,1,'2024-09-02 10:41:41','2024-09-02 11:20:45','119.155.19.23'),(190,NULL,3,1,'2024-09-02 11:37:46','2024-09-02 11:41:50','119.155.25.64'),(191,NULL,1,1,'2024-09-02 11:58:15','2024-09-02 11:58:47','27.34.70.8'),(192,NULL,3,1,'2024-09-02 13:19:31','2024-09-02 13:27:41','119.155.25.64'),(193,NULL,1,1,'2024-09-02 13:31:28','2024-09-02 13:37:57','27.34.70.93'),(194,NULL,3,1,'2024-09-02 13:47:49','2024-09-02 15:03:15','119.155.25.64'),(195,NULL,1,1,'2024-09-03 05:22:04','2024-09-03 05:22:04','27.34.70.8'),(196,NULL,1,1,'2024-09-03 05:23:40','2024-09-03 05:26:51','27.34.70.8'),(197,NULL,1,1,'2024-09-03 05:53:35','2024-09-03 06:30:08','27.34.70.8'),(198,NULL,3,1,'2024-09-03 06:38:48','2024-09-03 06:46:08','119.155.25.64'),(199,NULL,1,1,'2024-09-03 06:46:59','2024-09-03 06:54:01','27.34.70.8'),(200,NULL,3,1,'2024-09-03 07:05:03','2024-09-03 07:50:59','119.155.25.64'),(201,NULL,3,1,'2024-09-03 11:51:11','2024-09-03 12:21:11','119.155.25.64'),(202,NULL,3,1,'2024-09-03 12:42:23','2024-09-03 13:36:16','119.155.25.64'),(203,NULL,3,1,'2024-09-03 13:52:44','2024-09-03 14:01:34','119.155.25.64'),(204,NULL,3,1,'2024-09-03 14:23:52','2024-09-03 15:22:00','119.155.25.64'),(205,NULL,1,1,'2024-09-04 06:02:56','2024-09-04 06:08:57','27.34.70.8'),(206,NULL,1,1,'2024-09-04 06:25:50','2024-09-04 06:49:46','27.34.70.8'),(207,NULL,3,1,'2024-09-04 07:09:40','2024-09-04 08:40:03','119.155.25.64'),(208,NULL,3,1,'2024-09-04 09:04:09','2024-09-04 09:20:54','119.155.25.64'),(209,NULL,3,1,'2024-09-04 10:22:04','2024-09-04 10:33:30','119.155.25.64'),(210,NULL,3,1,'2024-09-04 10:51:47','2024-09-04 11:22:23','119.155.25.64'),(211,NULL,3,1,'2024-09-04 13:50:21','2024-09-04 14:40:17','119.155.25.64'),(212,NULL,3,1,'2024-09-04 14:59:16','2024-09-04 15:13:00','119.155.25.64'),(213,NULL,3,1,'2024-09-05 06:39:07','2024-09-05 06:39:40','119.155.25.64'),(214,NULL,3,1,'2024-09-05 07:03:13','2024-09-05 08:33:06','119.155.25.64'),(215,NULL,1,1,'2024-09-05 08:00:45','2024-09-05 08:04:40','27.34.70.8'),(216,NULL,3,1,'2024-09-05 09:00:15','2024-09-05 09:26:10','119.155.25.64'),(217,NULL,3,1,'2024-09-05 09:30:18','2024-09-05 10:00:30','119.155.25.64'),(218,NULL,1,1,'2024-09-05 10:34:02','2024-09-05 10:41:31','27.34.70.8'),(219,NULL,3,1,'2024-09-05 10:48:52','2024-09-05 11:19:49','119.155.21.158'),(220,NULL,3,1,'2024-09-05 11:40:30','2024-09-05 12:17:13','119.155.21.158'),(221,NULL,3,1,'2024-09-05 12:48:48','2024-09-05 13:26:00','119.155.21.158'),(222,NULL,3,1,'2024-09-05 13:48:03','2024-09-05 14:06:39','119.155.21.158'),(223,NULL,3,1,'2024-09-05 14:23:24','2024-09-05 15:06:56','119.155.21.158'),(224,NULL,3,1,'2024-09-06 07:41:36','2024-09-06 08:13:57','119.155.21.158'),(225,NULL,3,1,'2024-09-06 08:14:24','2024-09-06 08:29:08','119.155.21.158'),(226,NULL,3,1,'2024-09-06 09:01:14','2024-09-06 09:33:40','119.155.21.158'),(227,NULL,1,1,'2024-09-07 05:08:37','2024-09-07 05:18:41','27.34.70.8'),(228,NULL,1,1,'2024-09-07 05:39:19','2024-09-07 05:40:04','27.34.70.8'),(229,NULL,1,1,'2024-09-07 06:52:29','2024-09-07 06:57:07','27.34.70.8'),(230,NULL,1,1,'2024-09-07 09:57:06','2024-09-07 09:58:34','27.34.70.8'),(231,NULL,1,1,'2024-09-09 05:38:50','2024-09-09 05:39:29','27.34.70.8'),(232,NULL,1,1,'2024-09-09 06:27:51','2024-09-09 06:53:07','27.34.70.8'),(233,NULL,1,1,'2024-09-09 08:02:20','2024-09-09 08:10:38','27.34.70.8'),(234,NULL,1,1,'2024-09-09 08:27:04','2024-09-09 08:27:04','27.34.70.8'),(235,NULL,1,1,'2024-09-09 09:56:01','2024-09-09 10:46:56','27.34.70.8'),(236,NULL,1,1,'2024-09-09 11:03:26','2024-09-09 11:04:06','27.34.70.8'),(237,NULL,1,1,'2024-09-09 11:25:41','2024-09-09 12:00:47','27.34.70.8'),(238,NULL,1,1,'2024-09-10 05:25:24','2024-09-10 06:26:01','27.34.70.8'),(239,NULL,3,1,'2024-09-10 07:07:06','2024-09-10 07:44:56','119.155.21.158'),(240,NULL,1,1,'2024-09-10 07:09:36','2024-09-10 08:39:22','27.34.70.8'),(241,NULL,2,1,'2024-09-10 08:07:24','2024-09-10 08:24:52','119.155.21.158'),(242,NULL,1,1,'2024-09-10 09:11:38','2024-09-10 09:17:55','27.34.70.8'),(243,NULL,1,1,'2024-09-10 12:17:35','2024-09-10 12:24:13','27.34.70.8'),(244,NULL,1,1,'2024-09-11 05:37:42','2024-09-11 05:38:17','27.34.70.8'),(245,NULL,1,1,'2024-09-11 08:16:50','2024-09-11 08:16:50','27.34.70.8'),(246,NULL,1,1,'2024-09-11 09:23:03','2024-09-11 09:36:33','27.34.70.8'),(247,NULL,1,1,'2024-09-11 09:57:35','2024-09-11 10:14:29','27.34.70.8'),(248,NULL,1,1,'2024-09-11 10:30:50','2024-09-11 10:38:22','27.34.70.8'),(249,NULL,1,1,'2024-09-11 11:44:45','2024-09-11 11:55:16','27.34.70.8'),(250,NULL,1,1,'2024-09-12 05:20:52','2024-09-12 05:21:49','27.34.70.8'),(251,NULL,1,1,'2024-09-12 05:40:59','2024-09-12 05:46:37','27.34.70.8'),(252,NULL,1,1,'2024-09-12 06:01:46','2024-09-12 06:10:21','27.34.70.8'),(253,NULL,1,1,'2024-09-12 06:50:47','2024-09-12 07:03:06','27.34.70.8'),(254,NULL,1,1,'2024-09-12 07:32:26','2024-09-12 07:33:32','27.34.70.12'),(255,NULL,1,1,'2024-09-12 07:56:45','2024-09-12 07:59:33','27.34.70.8'),(256,NULL,1,1,'2024-09-12 09:28:27','2024-09-12 09:28:27','27.34.70.12'),(257,NULL,1,1,'2024-09-12 09:44:52','2024-09-12 09:44:52','27.34.70.8'),(258,NULL,1,1,'2024-09-12 11:06:59','2024-09-12 11:33:19','27.34.70.12'),(259,NULL,1,1,'2024-09-13 05:31:01','2024-09-13 05:31:01','27.34.70.8'),(260,NULL,1,1,'2024-09-13 06:31:14','2024-09-13 06:34:53','27.34.70.8'),(261,NULL,1,1,'2024-09-13 06:47:33','2024-09-13 06:53:31','27.34.70.8'),(262,NULL,1,1,'2024-09-13 06:52:13','2024-09-13 06:58:18','27.34.70.8'),(263,NULL,1,1,'2024-09-14 07:25:04','2024-09-14 07:39:22','27.34.70.8'),(264,NULL,1,1,'2024-09-14 08:03:09','2024-09-14 08:08:39','27.34.70.8'),(265,NULL,1,1,'2024-09-14 08:25:53','2024-09-14 08:37:13','27.34.70.8'),(266,NULL,1,1,'2024-09-14 09:05:26','2024-09-14 09:48:33','27.34.70.8'),(267,NULL,1,1,'2024-09-14 10:12:45','2024-09-14 10:29:01','27.34.70.8'),(268,NULL,1,1,'2024-09-16 05:35:48','2024-09-16 05:38:52','27.34.70.8'),(269,NULL,1,1,'2024-09-16 06:30:53','2024-09-16 06:30:53','27.34.70.8'),(270,NULL,2,1,'2024-09-16 07:40:23','2024-09-16 07:40:56','119.155.21.158'),(271,NULL,1,1,'2024-09-16 08:00:44','2024-09-16 08:05:23','27.34.70.8'),(272,NULL,3,1,'2024-09-16 08:03:21','2024-09-16 08:25:08','119.155.21.158'),(273,NULL,3,1,'2024-09-16 08:54:18','2024-09-16 09:58:47','119.155.21.158'),(274,NULL,1,1,'2024-09-16 10:03:37','2024-09-16 11:06:12','27.34.70.8'),(275,NULL,3,1,'2024-09-16 11:18:15','2024-09-16 11:53:39','119.155.21.158'),(276,NULL,1,1,'2024-09-16 11:32:08','2024-09-16 11:33:39','27.34.70.8'),(277,NULL,3,1,'2024-09-16 12:13:55','2024-09-16 12:20:45','119.155.21.158'),(278,NULL,3,1,'2024-09-16 12:46:22','2024-09-16 12:56:48','119.155.21.158'),(279,NULL,3,1,'2024-09-16 13:00:35','2024-09-16 13:08:37','119.155.12.143'),(280,NULL,3,1,'2024-09-16 13:46:22','2024-09-16 14:26:05','119.155.12.143'),(281,NULL,3,1,'2024-09-16 15:00:02','2024-09-16 15:16:57','119.155.12.143'),(282,NULL,1,1,'2024-09-17 05:40:59','2024-09-17 05:40:59','27.34.70.8'),(283,NULL,1,1,'2024-09-17 09:14:11','2024-09-17 09:14:46','27.34.70.8'),(284,NULL,1,1,'2024-09-17 09:40:39','2024-09-17 09:44:27','27.34.70.8'),(285,NULL,1,1,'2024-09-17 10:37:14','2024-09-17 10:49:38','27.34.70.8'),(286,NULL,3,1,'2024-09-18 06:55:02','2024-09-18 07:19:49','119.155.12.143'),(287,NULL,3,1,'2024-09-18 07:40:12','2024-09-18 07:41:41','119.155.12.143'),(288,NULL,3,1,'2024-09-18 08:13:08','2024-09-18 08:29:18','119.155.12.143'),(289,NULL,3,1,'2024-09-18 08:53:28','2024-09-18 09:31:16','119.155.12.143'),(290,NULL,3,1,'2024-09-18 11:15:49','2024-09-18 11:43:30','119.155.12.143'),(291,NULL,1,1,'2024-09-18 11:25:23','2024-09-18 11:26:39','27.34.70.8'),(292,NULL,3,1,'2024-09-18 11:44:11','2024-09-18 11:44:47','119.155.12.143'),(293,NULL,3,1,'2024-09-18 12:04:28','2024-09-18 12:33:34','119.155.12.143'),(294,NULL,1,1,'2024-09-18 12:08:04','2024-09-18 12:08:34','27.34.70.8'),(295,NULL,3,1,'2024-09-18 13:32:54','2024-09-18 13:32:54','119.155.12.143'),(296,NULL,3,1,'2024-09-18 13:48:12','2024-09-18 14:11:06','119.155.12.143'),(297,NULL,3,1,'2024-09-18 14:32:56','2024-09-18 14:41:40','119.155.12.143'),(298,NULL,1,1,'2024-09-19 05:11:18','2024-09-19 05:11:18','27.34.70.8'),(299,NULL,1,1,'2024-09-19 05:42:56','2024-09-19 05:43:31','27.34.70.8'),(300,NULL,3,1,'2024-09-19 07:43:32','2024-09-19 08:29:40','119.155.12.143'),(301,NULL,3,1,'2024-09-19 08:52:30','2024-09-19 09:14:07','119.155.12.143'),(302,NULL,3,1,'2024-09-19 09:30:57','2024-09-19 09:32:22','119.155.12.143'),(303,NULL,3,1,'2024-09-19 10:52:09','2024-09-19 11:45:52','119.155.12.143'),(304,NULL,3,1,'2024-09-19 12:05:03','2024-09-19 13:01:36','119.155.12.143'),(305,NULL,3,1,'2024-09-19 13:31:55','2024-09-19 14:13:24','119.155.12.143'),(306,NULL,3,1,'2024-09-19 15:14:26','2024-09-19 15:15:02','119.155.12.143'),(307,NULL,1,1,'2024-09-20 05:24:02','2024-09-20 05:24:02','27.34.70.8'),(308,NULL,1,1,'2024-09-23 07:26:09','2024-09-23 07:27:20','27.34.70.8'),(309,NULL,1,1,'2024-09-23 07:50:09','2024-09-23 07:57:17','27.34.70.8'),(310,NULL,1,1,'2024-09-23 08:30:26','2024-09-23 08:30:57','27.34.70.8'),(311,NULL,1,1,'2024-09-23 08:30:28','2024-09-23 08:38:28','27.34.70.8'),(312,NULL,3,1,'2024-09-23 09:22:30','2024-09-23 09:24:28','119.155.5.50'),(313,NULL,3,1,'2024-09-23 12:26:00','2024-09-23 13:05:20','119.155.5.50'),(314,NULL,2,1,'2024-09-23 12:33:13','2024-09-23 13:02:45','119.155.5.50'),(315,NULL,3,1,'2024-09-23 13:26:19','2024-09-23 15:00:16','119.155.5.50'),(316,NULL,2,1,'2024-09-23 13:37:15','2024-09-23 13:48:14','119.155.5.50'),(317,NULL,3,1,'2024-09-23 15:25:39','2024-09-23 15:26:09','119.155.5.50'),(318,NULL,2,1,'2024-09-23 15:34:16','2024-09-23 15:42:42','119.155.5.50'),(319,NULL,3,1,'2024-09-23 15:47:30','2024-09-23 15:48:23','119.155.5.50'),(320,NULL,1,1,'2024-09-24 05:51:26','2024-09-24 05:51:26','27.34.70.8'),(321,NULL,3,1,'2024-09-24 06:55:06','2024-09-24 07:40:59','119.155.5.50'),(322,NULL,2,1,'2024-09-24 07:27:05','2024-09-24 08:05:31','119.155.5.50'),(323,NULL,3,1,'2024-09-24 07:56:42','2024-09-24 08:06:06','119.155.5.50'),(324,NULL,1,1,'2024-09-24 08:46:21','2024-09-24 08:51:40','27.34.70.98'),(325,NULL,3,1,'2024-09-24 08:49:37','2024-09-24 09:28:15','119.155.5.50'),(326,NULL,3,1,'2024-09-24 10:41:42','2024-09-24 10:43:53','119.155.5.50'),(327,NULL,3,1,'2024-09-24 11:22:53','2024-09-24 11:27:40','119.155.5.50'),(328,NULL,3,1,'2024-09-24 15:05:43','2024-09-24 15:10:40','119.155.5.50'),(329,NULL,1,1,'2024-09-25 09:24:24','2024-09-25 09:28:05','27.34.70.8'),(330,NULL,1,1,'2024-09-25 09:49:59','2024-09-25 10:09:25','27.34.70.8'),(331,NULL,1,1,'2024-09-25 10:12:52','2024-09-25 10:12:52','27.34.70.61'),(332,NULL,1,1,'2024-09-26 09:46:50','2024-09-26 10:01:04','27.34.70.61'),(333,NULL,1,1,'2024-09-27 08:15:01','2024-09-27 08:39:15','27.34.70.44'),(334,NULL,1,1,'2024-09-28 09:20:58','2024-09-28 09:32:02','27.34.70.83'),(335,NULL,1,1,'2024-09-30 08:30:29','2024-09-30 08:47:50','27.34.70.8'),(336,NULL,1,1,'2024-09-30 08:30:39','2024-09-30 08:32:00','27.34.70.8'),(337,NULL,1,1,'2024-10-01 07:52:34','2024-10-01 08:06:24','27.34.70.8'),(338,NULL,1,1,'2024-10-01 08:23:34','2024-10-01 08:35:32','27.34.70.8'),(339,NULL,1,1,'2024-10-01 09:29:43','2024-10-01 09:42:36','27.34.70.8'),(340,NULL,2,1,'2024-10-01 12:14:34','2024-10-01 12:20:48','119.155.5.50'),(341,NULL,1,1,'2024-10-02 05:37:33','2024-10-02 05:38:06','27.34.70.8'),(342,NULL,2,1,'2024-10-02 15:27:45','2024-10-02 15:58:23','119.155.5.50'),(343,NULL,2,1,'2024-10-03 08:00:50','2024-10-03 08:29:05','119.155.5.50'),(344,NULL,2,1,'2024-10-03 09:01:30','2024-10-03 10:27:28','119.155.5.50'),(345,NULL,1,1,'2024-10-03 11:56:21','2024-10-03 11:59:34','27.34.70.8'),(346,NULL,2,1,'2024-10-03 12:00:17','2024-10-03 12:50:08','119.155.5.50'),(347,NULL,2,1,'2024-10-03 13:35:40','2024-10-03 13:57:38','119.155.5.50'),(348,NULL,2,1,'2024-10-03 14:25:59','2024-10-03 15:16:54','119.155.5.50'),(349,NULL,2,1,'2024-10-04 06:34:52','2024-10-04 06:59:51','119.155.5.50'),(350,NULL,2,1,'2024-10-04 07:29:58','2024-10-04 08:14:07','119.155.5.50'),(351,NULL,2,1,'2024-10-04 09:37:19','2024-10-04 09:51:58','119.155.5.50'),(352,NULL,2,1,'2024-10-04 11:25:25','2024-10-04 11:25:25','119.155.5.50'),(353,NULL,2,1,'2024-10-04 12:03:49','2024-10-04 12:40:20','119.155.5.50'),(354,NULL,2,1,'2024-10-04 13:26:13','2024-10-04 14:44:32','119.155.5.50'),(355,NULL,2,1,'2024-10-05 13:37:45','2024-10-05 13:37:45','167.253.48.177'),(356,NULL,2,1,'2024-10-05 13:37:45','2024-10-05 13:37:45','193.93.195.193'),(357,NULL,2,1,'2024-10-07 06:48:51','2024-10-07 07:21:19','119.155.5.50'),(358,NULL,2,1,'2024-10-07 07:23:07','2024-10-07 08:28:16','119.155.5.50'),(359,NULL,2,1,'2024-10-07 09:01:21','2024-10-07 10:16:20','119.155.5.50'),(360,NULL,1,1,'2024-10-07 10:58:33','2024-10-07 11:01:45','27.34.70.8'),(361,NULL,2,1,'2024-10-07 11:20:44','2024-10-07 11:28:31','119.155.5.50'),(362,NULL,2,1,'2024-10-07 11:54:24','2024-10-07 12:48:29','119.155.5.50'),(363,NULL,2,1,'2024-10-07 13:22:18','2024-10-07 14:37:05','119.155.5.50'),(364,NULL,2,1,'2024-10-07 14:39:34','2024-10-07 14:52:26','119.155.5.50'),(365,NULL,1,1,'2024-10-07 14:49:01','2024-10-07 14:59:39','27.34.70.8'),(366,NULL,2,1,'2024-10-07 15:16:07','2024-10-07 15:17:12','119.155.5.50'),(367,NULL,1,1,'2024-10-08 08:30:47','2024-10-08 08:56:34','27.34.70.8'),(368,NULL,2,1,'2024-10-08 09:25:09','2024-10-08 09:26:03','119.155.5.50'),(369,NULL,2,1,'2024-10-08 10:59:46','2024-10-08 11:30:50','119.155.5.50'),(370,NULL,2,1,'2024-10-08 11:52:52','2024-10-08 12:37:20','119.155.5.50'),(371,NULL,2,1,'2024-10-08 13:05:45','2024-10-08 13:15:02','119.155.5.50'),(372,NULL,2,1,'2024-10-08 13:30:24','2024-10-08 13:45:30','119.155.5.50'),(373,NULL,2,1,'2024-10-08 14:12:42','2024-10-08 14:12:42','119.155.5.50'),(374,NULL,2,1,'2024-10-08 14:34:05','2024-10-08 14:35:11','119.155.5.50'),(375,NULL,1,1,'2024-10-09 08:28:05','2024-10-09 08:34:38','27.34.70.8'),(376,NULL,1,1,'2024-10-09 14:41:59','2024-10-09 14:44:27','27.34.70.80'),(377,NULL,2,1,'2024-10-09 15:53:43','2024-10-09 15:56:09','119.155.5.50'),(378,NULL,2,1,'2024-10-10 08:11:13','2024-10-10 08:11:13','119.155.5.50'),(379,NULL,1,1,'2024-10-14 06:18:53','2024-10-14 06:19:37','27.34.70.8'),(380,NULL,1,1,'2024-10-14 06:40:29','2024-10-14 06:55:25','27.34.70.8'),(381,NULL,1,1,'2024-10-14 08:26:21','2024-10-14 08:34:14','27.34.70.8'),(382,NULL,1,1,'2024-10-14 08:40:55','2024-10-14 08:44:24','27.34.70.8'),(383,NULL,1,1,'2024-10-14 09:25:33','2024-10-14 09:26:52','27.34.70.8'),(384,NULL,1,1,'2024-10-14 09:50:10','2024-10-14 10:42:24','27.34.70.8'),(385,NULL,1,1,'2024-10-14 11:41:53','2024-10-14 11:43:31','27.34.70.8'),(386,NULL,1,1,'2024-10-15 05:58:02','2024-10-15 06:04:16','27.34.70.8'),(387,NULL,1,1,'2024-10-15 08:21:21','2024-10-15 08:23:05','27.34.70.8'),(388,NULL,1,1,'2024-10-15 09:38:14','2024-10-15 09:46:22','27.34.70.8'),(389,NULL,2,1,'2024-10-15 10:30:48','2024-10-15 10:30:48','119.155.5.50'),(390,NULL,1,1,'2024-10-17 06:53:06','2024-10-17 06:58:18','27.34.70.8'),(391,NULL,1,1,'2024-10-17 10:12:07','2024-10-17 10:27:21','27.34.70.34'),(392,NULL,2,1,'2024-10-17 14:53:09','2024-10-17 14:59:07','119.155.5.50'),(393,NULL,1,1,'2024-10-18 05:50:28','2024-10-18 06:04:03','27.34.70.8'),(394,NULL,1,1,'2024-10-18 06:46:25','2024-10-18 06:49:43','27.34.70.8'),(395,NULL,1,1,'2024-10-18 07:13:01','2024-10-18 07:30:43','27.34.70.8'),(396,NULL,1,1,'2024-10-18 07:24:53','2024-10-18 07:41:01','27.34.70.34'),(397,NULL,1,1,'2024-10-18 07:59:44','2024-10-18 08:31:06','27.34.70.8'),(398,NULL,2,1,'2024-10-18 08:15:37','2024-10-18 08:17:05','119.155.5.50'),(399,NULL,2,1,'2024-10-18 10:42:37','2024-10-18 10:48:55','39.37.143.1'),(400,NULL,2,1,'2024-10-18 11:09:28','2024-10-18 11:11:21','182.185.182.185'),(401,NULL,2,1,'2024-10-18 11:47:34','2024-10-18 11:52:26','182.185.182.185'),(402,NULL,2,1,'2024-10-18 12:14:58','2024-10-18 12:28:49','182.185.182.185'),(403,NULL,2,1,'2024-10-18 13:45:27','2024-10-18 13:48:15','182.185.182.185'),(404,NULL,2,1,'2024-10-18 14:16:23','2024-10-18 14:22:48','182.185.182.185'),(405,NULL,2,1,'2024-10-18 14:58:10','2024-10-18 15:36:35','182.185.182.185'),(406,NULL,1,1,'2024-10-21 05:16:23','2024-10-21 05:18:03','27.34.70.34'),(407,NULL,1,1,'2024-10-21 05:36:02','2024-10-21 05:57:54','27.34.70.34'),(408,NULL,2,1,'2024-10-21 07:09:10','2024-10-21 08:26:22','182.185.182.185'),(409,NULL,2,1,'2024-10-21 09:00:30','2024-10-21 09:01:32','182.185.182.185'),(410,NULL,2,1,'2024-10-21 09:18:54','2024-10-21 09:24:21','182.185.182.185'),(411,NULL,2,1,'2024-10-21 09:41:27','2024-10-21 09:42:25','182.185.182.185'),(412,NULL,2,1,'2024-10-21 10:10:32','2024-10-21 11:09:53','182.185.182.185'),(413,NULL,2,1,'2024-10-21 11:37:11','2024-10-21 11:40:36','182.185.182.185'),(414,NULL,2,1,'2024-10-21 12:07:41','2024-10-21 12:10:46','182.185.182.185'),(415,NULL,2,1,'2024-10-21 12:48:13','2024-10-21 13:44:27','182.185.182.185'),(416,NULL,2,1,'2024-10-21 14:07:14','2024-10-21 14:17:26','182.185.182.185'),(417,NULL,2,1,'2024-10-21 14:52:39','2024-10-21 15:15:38','182.185.182.185'),(418,NULL,2,1,'2024-10-22 07:17:57','2024-10-22 08:12:52','182.185.182.185'),(419,NULL,2,1,'2024-10-22 08:53:59','2024-10-22 09:01:04','182.185.182.185'),(420,NULL,2,1,'2024-10-22 09:18:01','2024-10-22 09:20:15','182.185.182.185'),(421,NULL,2,1,'2024-10-22 10:14:43','2024-10-22 10:15:24','182.185.182.185'),(422,NULL,2,1,'2024-10-22 13:10:48','2024-10-22 13:45:24','182.185.182.185'),(423,NULL,1,1,'2024-10-22 14:07:56','2024-10-22 14:28:19','182.185.182.185'),(424,NULL,1,1,'2024-10-22 14:49:13','2024-10-22 14:51:21','182.185.182.185'),(425,NULL,1,1,'2024-10-22 15:10:31','2024-10-22 15:11:07','182.185.182.185'),(426,NULL,1,1,'2024-10-22 15:37:45','2024-10-22 15:39:14','182.185.182.185'),(427,NULL,1,1,'2024-10-23 06:12:08','2024-10-23 07:06:50','27.34.70.8'),(428,NULL,1,1,'2024-10-23 07:10:29','2024-10-23 08:08:05','182.185.182.185'),(429,NULL,1,1,'2024-10-23 09:00:34','2024-10-23 09:09:31','182.185.182.185'),(430,NULL,1,1,'2024-10-23 09:24:46','2024-10-23 09:45:22','182.185.182.185'),(431,NULL,1,1,'2024-10-23 09:38:48','2024-10-23 09:40:02','27.34.70.8'),(432,NULL,1,1,'2024-10-23 10:00:57','2024-10-23 10:48:35','182.185.182.185'),(433,NULL,1,1,'2024-10-23 11:09:13','2024-10-23 11:09:45','182.185.182.185'),(434,NULL,1,1,'2024-10-23 11:40:57','2024-10-23 11:45:54','182.185.182.185'),(435,NULL,1,1,'2024-10-23 13:25:06','2024-10-23 13:25:45','182.185.182.185'),(436,NULL,1,1,'2024-10-23 13:46:02','2024-10-23 14:12:09','182.185.182.185'),(437,NULL,1,1,'2024-10-23 14:32:38','2024-10-23 15:11:24','182.185.182.185'),(438,NULL,1,1,'2024-10-24 07:51:25','2024-10-24 08:28:07','182.185.182.185'),(439,NULL,1,1,'2024-10-24 07:57:15','2024-10-24 07:58:52','27.34.70.8'),(440,NULL,1,1,'2024-10-24 08:17:28','2024-10-24 08:18:38','27.34.70.8'),(441,NULL,1,1,'2024-10-24 09:18:14','2024-10-24 10:17:59','182.185.182.185'),(442,NULL,1,1,'2024-10-24 10:36:37','2024-10-24 10:47:48','182.185.182.185'),(443,NULL,1,3,'2024-10-24 11:37:33','2024-10-24 11:37:33','182.185.182.185'),(444,NULL,1,1,'2024-10-24 11:37:33','2024-10-24 12:23:23','182.185.182.185'),(445,NULL,1,1,'2024-10-24 12:47:07','2024-10-24 14:12:42','182.185.182.185'),(446,NULL,1,1,'2024-10-24 14:46:26','2024-10-24 15:42:46','182.185.182.185'),(447,NULL,1,1,'2024-10-25 07:07:52','2024-10-25 08:07:35','182.185.182.185'),(448,NULL,1,1,'2024-10-25 07:19:40','2024-10-25 07:29:33','27.34.70.8'),(449,NULL,1,1,'2024-10-25 09:30:13','2024-10-25 09:58:10','182.185.182.185'),(450,NULL,1,1,'2024-10-25 11:21:30','2024-10-25 11:22:33','27.34.70.8'),(451,NULL,1,1,'2024-10-25 11:52:04','2024-10-25 11:53:10','27.34.70.8'),(452,NULL,1,1,'2024-10-25 12:22:04','2024-10-25 12:22:38','182.185.182.185'),(453,NULL,1,1,'2024-10-25 12:53:09','2024-10-25 14:34:39','182.185.182.185'),(454,NULL,1,1,'2024-10-28 06:51:31','2024-10-28 07:50:55','182.185.182.185'),(455,NULL,1,1,'2024-10-28 08:41:06','2024-10-28 08:55:12','182.185.182.185'),(456,NULL,1,1,'2024-10-28 10:19:35','2024-10-28 10:20:04','27.34.70.118'),(457,NULL,1,1,'2024-10-28 10:21:35','2024-10-28 10:28:32','182.185.182.185'),(458,NULL,1,1,'2024-10-28 10:47:36','2024-10-28 10:47:36','182.185.182.185'),(459,NULL,1,1,'2024-10-28 11:39:24','2024-10-28 11:40:06','182.185.182.185'),(460,NULL,1,1,'2024-10-29 05:27:33','2024-10-29 05:29:12','27.34.70.118'),(461,NULL,1,1,'2024-10-29 05:45:48','2024-10-29 06:07:45','27.34.70.118'),(462,NULL,1,1,'2024-10-29 06:47:50','2024-10-29 06:54:31','27.34.70.118'),(463,NULL,1,1,'2024-10-29 07:49:07','2024-10-29 08:42:20','27.34.70.118'),(464,NULL,1,1,'2024-10-29 09:39:38','2024-10-29 09:59:12','27.34.70.118'),(465,NULL,1,1,'2024-10-29 10:31:41','2024-10-29 11:01:48','182.185.182.185'),(466,NULL,1,1,'2024-10-29 11:15:25','2024-10-29 11:16:08','27.34.70.118'),(467,NULL,1,1,'2024-10-29 11:22:39','2024-10-29 12:18:34','182.185.182.185'),(468,NULL,1,1,'2024-10-29 12:51:09','2024-10-29 12:56:54','182.185.182.185'),(469,NULL,1,1,'2024-10-29 13:12:34','2024-10-29 13:24:52','182.185.182.185'),(470,NULL,1,1,'2024-10-30 07:17:46','2024-10-30 07:56:52','182.185.182.185'),(471,NULL,1,1,'2024-10-30 08:36:28','2024-10-30 08:49:26','27.34.70.118'),(472,NULL,1,1,'2024-10-30 10:00:12','2024-10-30 10:37:46','27.34.70.118'),(473,NULL,1,1,'2024-10-30 10:12:59','2024-10-30 10:15:39','27.34.70.118'),(474,NULL,1,1,'2024-10-31 06:43:21','2024-10-31 06:53:24','182.185.182.185'),(475,NULL,1,1,'2024-10-31 07:13:19','2024-10-31 07:19:44','182.185.182.185'),(476,NULL,1,1,'2024-10-31 07:38:39','2024-10-31 08:30:03','182.185.182.185'),(477,NULL,1,1,'2024-10-31 09:02:15','2024-10-31 10:01:24','182.185.182.185'),(478,NULL,1,1,'2024-10-31 11:23:37','2024-10-31 12:21:07','182.185.182.185'),(479,NULL,1,1,'2024-10-31 12:43:30','2024-10-31 12:56:24','182.185.182.185'),(480,NULL,1,1,'2024-10-31 13:11:58','2024-10-31 14:13:44','182.185.182.185'),(481,NULL,1,1,'2024-11-01 07:33:40','2024-11-01 07:47:07','182.185.182.185'),(482,NULL,1,1,'2024-11-01 08:06:39','2024-11-01 08:14:06','182.185.182.185'),(483,NULL,1,1,'2024-11-01 11:09:57','2024-11-01 11:11:51','182.185.182.185'),(484,NULL,1,1,'2024-11-01 11:44:25','2024-11-01 12:16:55','182.185.182.185'),(485,NULL,1,1,'2024-11-01 12:38:12','2024-11-01 12:38:12','182.185.182.185'),(486,NULL,1,1,'2024-11-01 13:04:09','2024-11-01 13:11:39','182.185.182.185'),(487,NULL,1,1,'2024-11-01 13:43:23','2024-11-01 13:47:03','182.185.182.185'),(488,NULL,1,1,'2024-11-04 05:17:56','2024-11-04 05:33:14','27.34.70.118'),(489,NULL,1,1,'2024-11-04 07:35:39','2024-11-04 07:36:12','27.34.70.118'),(490,NULL,1,1,'2024-11-04 07:52:56','2024-11-04 07:52:56','27.34.70.118'),(491,NULL,1,1,'2024-11-04 11:01:02','2024-11-04 11:06:52','27.34.70.118'),(492,NULL,1,1,'2024-11-04 11:48:22','2024-11-04 11:49:02','182.185.182.185'),(493,NULL,1,1,'2024-11-05 03:17:10','2024-11-05 03:26:10','27.34.70.34'),(494,NULL,1,1,'2024-11-05 05:27:59','2024-11-05 05:31:17','27.34.70.76'),(495,NULL,1,1,'2024-11-05 06:49:03','2024-11-05 06:51:16','27.34.70.76'),(496,NULL,1,1,'2024-11-05 08:19:20','2024-11-05 08:22:57','27.34.70.34'),(497,NULL,1,1,'2024-11-05 10:30:24','2024-11-05 10:38:29','27.34.70.34'),(498,NULL,1,1,'2024-11-06 09:30:34','2024-11-06 09:31:41','182.185.182.185'),(499,NULL,1,1,'2024-11-11 07:24:42','2024-11-11 07:26:44','39.37.134.243'),(500,NULL,1,1,'2024-11-11 09:14:07','2024-11-11 09:16:01','39.37.134.243'),(501,NULL,1,1,'2024-11-11 10:05:22','2024-11-11 10:07:30','39.37.134.243'),(502,NULL,1,1,'2024-11-11 11:07:50','2024-11-11 11:08:38','39.37.134.243'),(503,NULL,1,1,'2024-11-11 11:55:33','2024-11-11 12:02:29','39.37.134.243'),(504,NULL,1,1,'2024-11-11 12:36:03','2024-11-11 13:03:45','39.37.134.243'),(505,NULL,1,1,'2024-11-11 13:21:07','2024-11-11 13:22:20','39.37.134.243'),(506,NULL,1,1,'2024-11-11 14:29:34','2024-11-11 14:33:19','39.37.134.243'),(507,NULL,1,1,'2024-11-12 07:22:56','2024-11-12 07:33:41','39.37.134.243'),(508,NULL,1,1,'2024-11-12 08:06:21','2024-11-12 08:24:28','39.37.134.243'),(509,NULL,1,1,'2024-11-12 09:03:54','2024-11-12 09:05:24','39.37.134.243'),(510,NULL,1,1,'2024-11-12 09:24:56','2024-11-12 11:02:02','39.37.134.243'),(511,NULL,1,1,'2024-11-13 07:37:43','2024-11-13 07:38:18','182.185.173.131'),(512,NULL,1,1,'2024-11-14 09:41:38','2024-11-14 09:41:38','27.34.70.34'),(513,NULL,1,1,'2024-11-14 09:42:13','2024-11-14 09:48:27','86.31.86.209'),(514,NULL,1,1,'2024-11-19 11:19:52','2024-11-19 11:24:17','182.185.140.21'),(515,NULL,1,1,'2024-11-29 09:25:50','2024-11-29 09:26:18','39.37.156.150'),(516,NULL,1,1,'2024-12-03 13:28:42','2024-12-03 13:28:42','27.34.70.95'),(517,NULL,1,1,'2024-12-03 13:29:05','2024-12-03 13:43:21','86.31.86.209'),(518,NULL,1,1,'2024-12-04 06:14:59','2024-12-04 06:14:59','27.34.70.95'),(519,NULL,1,1,'2024-12-04 06:30:26','2024-12-04 06:31:32','27.34.70.95'),(520,NULL,1,1,'2024-12-04 10:52:17','2024-12-04 10:52:17','86.31.86.209'),(521,NULL,1,1,'2024-12-04 12:03:53','2024-12-04 12:18:54','39.37.156.150'),(522,NULL,1,1,'2024-12-04 13:37:49','2024-12-04 13:37:49','27.34.70.95'),(523,NULL,1,1,'2024-12-05 07:27:36','2024-12-05 07:29:09','27.34.70.95'),(524,NULL,1,1,'2024-12-05 08:58:33','2024-12-05 08:58:33','27.34.70.95'),(525,NULL,1,1,'2024-12-05 10:45:51','2024-12-05 10:46:19','37.73.12.2'),(526,NULL,1,1,'2024-12-05 11:59:21','2024-12-05 11:59:21','39.37.156.150'),(527,NULL,1,1,'2024-12-05 12:36:00','2024-12-05 12:37:36','39.37.156.150'),(528,NULL,1,1,'2024-12-06 05:34:20','2024-12-06 05:34:48','27.34.70.95'),(529,NULL,1,1,'2024-12-06 15:47:28','2024-12-06 15:47:28','39.37.156.150'),(530,NULL,1,1,'2024-12-09 11:58:57','2024-12-09 12:07:51','39.37.156.150'),(531,NULL,1,1,'2024-12-10 13:44:47','2024-12-10 13:51:21','182.185.131.198'),(532,NULL,1,3,'2024-12-10 15:25:34','2024-12-10 15:25:34','182.185.131.198'),(533,NULL,1,1,'2024-12-10 15:25:35','2024-12-10 15:27:14','182.185.131.198'),(534,NULL,1,1,'2024-12-11 08:10:41','2024-12-11 08:10:41','27.34.70.63'),(535,NULL,1,1,'2024-12-11 10:38:08','2024-12-11 10:38:41','27.34.70.63'),(536,NULL,1,1,'2024-12-11 10:59:13','2024-12-11 11:26:14','27.34.70.63'),(537,NULL,1,1,'2024-12-11 11:46:09','2024-12-11 11:50:11','27.34.70.63'),(538,NULL,1,0,'2024-12-13 07:49:56','2024-12-13 07:50:16','182.185.131.198'),(539,NULL,1,1,'2024-12-13 07:50:47','2024-12-13 07:50:47','182.185.131.198'),(540,NULL,1,1,'2024-12-13 14:37:35','2024-12-13 14:40:46','182.185.131.198'),(541,NULL,1,1,'2024-12-16 09:39:04','2024-12-16 09:39:04','182.185.131.198'),(542,NULL,1,1,'2024-12-16 09:42:39','2024-12-16 09:57:52','27.34.70.33'),(543,NULL,1,1,'2024-12-17 09:18:56','2024-12-17 09:21:10','182.185.131.198'),(544,NULL,1,1,'2024-12-17 10:29:07','2024-12-17 10:32:52','182.185.131.198'),(545,NULL,1,1,'2024-12-17 10:48:30','2024-12-17 10:52:41','182.185.131.198'),(546,NULL,1,1,'2024-12-23 06:59:46','2024-12-23 07:00:35','27.34.70.33'),(547,NULL,1,1,'2024-12-23 10:39:38','2024-12-23 10:40:06','27.34.70.59'),(548,NULL,1,1,'2024-12-23 11:17:56','2024-12-23 11:17:56','27.34.70.59'),(549,NULL,1,1,'2024-12-23 11:49:49','2024-12-23 11:50:35','27.34.70.59'),(550,NULL,1,1,'2024-12-23 12:49:59','2024-12-23 12:52:00','194.169.170.42'),(551,NULL,1,1,'2024-12-23 14:53:07','2024-12-23 14:53:40','39.46.249.53'),(552,NULL,1,1,'2024-12-24 07:21:46','2024-12-24 07:22:15','39.46.249.53'),(553,NULL,1,1,'2024-12-24 08:33:00','2024-12-24 08:33:00','39.46.249.53'),(554,NULL,1,1,'2024-12-25 03:57:15','2024-12-25 03:59:14','27.34.70.59'),(555,NULL,1,1,'2024-12-27 12:54:02','2024-12-27 12:56:07','39.46.232.244'),(556,NULL,1,1,'2024-12-27 13:12:24','2024-12-27 13:12:24','39.46.232.244'),(557,NULL,1,1,'2024-12-27 14:37:10','2024-12-27 14:56:59','39.37.153.185'),(558,NULL,1,1,'2025-01-03 12:22:17','2025-01-03 12:22:17','39.37.183.204'),(559,NULL,1,3,'2025-01-04 04:54:02','2025-01-04 04:54:02','39.63.149.227'),(560,NULL,1,1,'2025-01-04 04:54:03','2025-01-04 04:54:03','39.63.149.227'),(561,NULL,1,1,'2025-01-06 07:09:01','2025-01-06 07:09:01','39.37.183.204'),(562,NULL,1,1,'2025-01-06 08:02:20','2025-01-06 08:02:20','39.37.183.204'),(563,NULL,1,1,'2025-01-06 08:55:14','2025-01-06 09:08:36','39.37.183.204'),(564,NULL,1,1,'2025-01-06 09:12:27','2025-01-06 09:14:36','39.37.183.204'),(565,NULL,1,1,'2025-01-06 09:40:31','2025-01-06 09:40:31','39.37.183.204'),(566,NULL,1,1,'2025-01-06 10:20:36','2025-01-06 10:31:26','39.37.183.204'),(567,NULL,1,1,'2025-01-06 11:01:22','2025-01-06 11:03:42','39.37.183.204'),(568,NULL,1,1,'2025-01-06 11:34:51','2025-01-06 11:34:51','39.37.183.204'),(569,NULL,1,1,'2025-01-07 07:25:56','2025-01-07 07:44:34','27.34.70.59'),(570,NULL,1,1,'2025-01-07 07:46:17','2025-01-07 07:47:32','39.37.183.204'),(571,NULL,1,1,'2025-01-07 07:48:31','2025-01-07 07:49:02','39.37.183.204'),(572,NULL,1,1,'2025-01-07 08:22:38','2025-01-07 08:22:38','39.37.183.204'),(573,NULL,1,1,'2025-01-07 11:53:46','2025-01-07 11:54:17','39.37.183.204'),(574,NULL,1,1,'2025-01-07 13:11:08','2025-01-07 13:32:34','39.37.183.204'),(575,NULL,1,1,'2025-01-07 13:16:04','2025-01-07 13:41:02','27.34.70.59'),(576,NULL,1,1,'2025-01-07 13:49:44','2025-01-07 13:52:32','39.37.183.204'),(577,NULL,1,1,'2025-01-07 13:54:31','2025-01-07 13:56:39','39.37.183.204'),(578,NULL,1,1,'2025-01-07 14:42:33','2025-01-07 15:15:57','39.37.183.204'),(579,NULL,1,1,'2025-01-07 15:34:03','2025-01-07 15:34:03','39.37.183.204'),(580,NULL,1,1,'2025-01-08 07:24:10','2025-01-08 07:50:50','39.49.160.150'),(581,NULL,1,1,'2025-01-08 08:45:35','2025-01-08 08:47:33','86.31.86.209'),(582,NULL,1,1,'2025-01-08 08:46:12','2025-01-08 08:47:20','39.49.160.150'),(583,NULL,1,1,'2025-01-08 09:26:15','2025-01-08 09:28:51','86.31.86.209'),(584,NULL,1,1,'2025-01-08 10:00:36','2025-01-08 10:16:51','182.185.148.212'),(585,NULL,1,1,'2025-01-08 10:26:00','2025-01-08 10:26:00','86.31.86.209'),(586,NULL,1,1,'2025-01-08 12:57:11','2025-01-08 12:57:59','182.185.148.212'),(587,NULL,1,1,'2025-01-09 07:59:35','2025-01-09 08:00:26','182.185.148.212'),(588,NULL,1,1,'2025-01-09 09:39:27','2025-01-09 10:06:40','182.185.148.212'),(589,NULL,2,1,'2025-01-09 09:47:38','2025-01-09 09:48:07','86.31.86.209'),(590,NULL,1,1,'2025-01-09 09:50:30','2025-01-09 09:50:30','182.185.148.212'),(591,NULL,2,1,'2025-01-09 09:50:48','2025-01-09 09:51:20','86.31.86.209'),(592,NULL,4,1,'2025-01-09 10:07:36','2025-01-09 10:08:04','182.185.148.212'),(593,NULL,1,1,'2025-01-09 21:06:20','2025-01-09 21:30:11','39.46.197.48'),(594,NULL,1,1,'2025-01-10 07:32:25','2025-01-10 07:37:55','182.185.148.212'),(595,NULL,1,1,'2025-01-10 09:23:04','2025-01-10 09:23:04','182.185.148.212'),(596,NULL,1,1,'2025-01-10 09:41:46','2025-01-10 09:41:46','182.185.148.212'),(597,NULL,1,1,'2025-01-10 11:02:30','2025-01-10 11:02:58','182.185.148.212'),(598,NULL,1,1,'2025-01-10 13:22:31','2025-01-10 13:52:23','182.185.148.212'),(599,NULL,1,3,'2025-01-10 17:46:25','2025-01-10 17:46:25','39.46.197.48'),(600,NULL,1,1,'2025-01-10 17:46:26','2025-01-10 17:46:54','39.46.197.48'),(601,NULL,1,1,'2025-01-11 07:03:36','2025-01-11 07:09:34','39.46.227.87'),(602,NULL,1,1,'2025-01-11 07:58:25','2025-01-11 07:58:25','39.46.227.87'),(603,NULL,1,1,'2025-01-13 07:22:52','2025-01-13 07:22:52','39.49.160.13'),(604,NULL,1,1,'2025-01-13 08:31:34','2025-01-13 08:31:34','39.49.160.13'),(605,NULL,1,0,'2025-01-13 08:43:11','2025-01-13 09:04:24','111.88.125.158'),(606,NULL,1,1,'2025-01-13 09:54:20','2025-01-13 10:08:51','39.37.160.223'),(607,NULL,1,1,'2025-01-13 12:14:45','2025-01-13 12:32:07','39.37.160.223'),(608,NULL,1,1,'2025-01-13 13:23:31','2025-01-13 13:24:00','39.37.160.223'),(609,NULL,1,1,'2025-01-14 09:40:14','2025-01-14 09:53:37','39.37.138.1'),(610,NULL,1,1,'2025-01-20 13:58:58','2025-01-20 14:10:08','182.185.180.116'),(611,NULL,1,0,'2025-01-20 14:09:42','2025-01-20 14:12:17','116.72.18.66'),(612,NULL,5,1,'2025-01-20 14:11:53','2025-01-20 14:11:53','116.72.18.66'),(613,NULL,5,1,'2025-01-20 14:42:48','2025-01-20 14:53:48','202.71.5.198'),(614,NULL,5,1,'2025-01-20 15:09:08','2025-01-20 15:09:08','202.71.5.198'),(615,NULL,1,1,'2025-01-20 15:25:36','2025-01-20 15:25:36','182.185.180.116'),(616,NULL,1,1,'2025-01-21 13:12:12','2025-01-21 13:12:55','182.185.180.116'),(617,NULL,6,1,'2025-01-22 06:08:45','2025-01-22 06:13:15','94.156.149.125'),(618,NULL,1,1,'2025-01-22 09:25:06','2025-01-22 09:31:45','182.185.143.35'),(619,NULL,1,1,'2025-01-22 09:53:08','2025-01-22 10:00:19','182.185.143.35'),(620,NULL,1,1,'2025-01-22 10:37:12','2025-01-22 10:37:12','182.185.129.64'),(621,NULL,1,1,'2025-01-22 14:58:23','2025-01-22 14:58:23','182.185.129.64'),(622,NULL,5,1,'2025-01-23 10:27:56','2025-01-23 10:27:56','49.36.71.22'),(623,NULL,1,1,'2025-01-23 10:40:46','2025-01-23 10:44:05','72.255.40.107'),(624,NULL,5,1,'2025-01-23 10:51:24','2025-01-23 11:06:27','135.181.163.188'),(625,NULL,5,1,'2025-01-23 11:40:30','2025-01-23 12:08:35','135.181.163.188'),(626,NULL,1,1,'2025-01-23 12:00:52','2025-01-23 12:00:52','72.255.40.107'),(627,NULL,5,1,'2025-01-23 12:36:42','2025-01-23 12:38:13','135.181.163.188'),(628,NULL,5,1,'2025-01-23 13:01:15','2025-01-23 13:43:19','182.77.62.24'),(629,NULL,5,1,'2025-01-23 13:14:24','2025-01-23 13:14:54','182.77.62.24'),(630,NULL,5,1,'2025-01-23 13:38:34','2025-01-23 13:43:37','182.77.62.24'),(631,NULL,5,1,'2025-01-24 05:02:53','2025-01-24 05:02:53','103.84.198.33'),(632,NULL,5,1,'2025-01-24 09:15:29','2025-01-24 09:16:17','72.255.40.107'),(633,NULL,5,1,'2025-01-24 09:25:49','2025-01-24 10:03:30','86.31.86.209'),(634,NULL,5,1,'2025-01-24 10:36:12','2025-01-24 11:04:05','72.255.40.107'),(635,NULL,5,1,'2025-01-24 11:31:06','2025-01-24 11:38:31','103.84.198.33'),(636,NULL,5,1,'2025-01-24 11:38:25','2025-01-24 11:50:51','86.31.86.209'),(637,NULL,5,1,'2025-01-24 12:21:16','2025-01-24 12:21:50','182.185.158.222'),(638,NULL,5,1,'2025-01-24 12:24:20','2025-01-24 12:24:20','116.72.18.66'),(639,NULL,5,1,'2025-01-24 13:39:23','2025-01-24 14:01:02','162.158.159.49'),(640,NULL,5,1,'2025-01-27 06:51:35','2025-01-27 06:51:35','172.70.114.89'),(641,NULL,5,1,'2025-01-27 07:57:16','2025-01-27 07:58:27','172.70.110.213'),(642,NULL,5,1,'2025-01-27 08:08:16','2025-01-27 08:19:06','172.70.230.56'),(643,NULL,5,1,'2025-01-27 08:09:19','2025-01-27 09:05:51','172.70.110.139'),(644,NULL,5,1,'2025-01-27 08:56:32','2025-01-27 08:58:33','162.158.159.37'),(645,NULL,5,1,'2025-01-27 09:06:54','2025-01-27 09:08:53','172.70.110.247'),(646,NULL,5,1,'2025-01-27 10:16:23','2025-01-27 11:12:25','172.70.231.40'),(647,NULL,5,1,'2025-01-27 10:16:44','2025-01-27 10:19:07','162.158.62.68'),(648,NULL,5,1,'2025-01-27 10:41:14','2025-01-27 10:41:14','162.158.62.96'),(649,NULL,5,1,'2025-01-27 10:42:19','2025-01-27 10:52:44','162.158.155.37'),(650,NULL,5,1,'2025-01-27 10:57:22','2025-01-27 11:12:46','162.158.159.38'),(651,NULL,5,1,'2025-01-27 11:14:27','2025-01-27 11:15:10','162.158.154.246'),(652,NULL,5,1,'2025-01-27 11:16:09','2025-01-27 11:20:03','172.70.110.139'),(653,NULL,5,1,'2025-01-27 11:17:27','2025-01-27 11:27:17','162.158.63.11'),(654,NULL,5,1,'2025-01-27 11:18:57','2025-01-27 11:59:59','162.158.63.11'),(655,NULL,5,1,'2025-01-27 11:27:47','2025-01-27 11:44:10','172.70.230.250'),(656,NULL,5,1,'2025-01-27 11:39:04','2025-01-27 11:44:49','172.70.114.103'),(657,NULL,5,1,'2025-01-27 12:15:43','2025-01-27 12:19:07','162.158.155.15'),(658,NULL,5,1,'2025-01-27 12:56:16','2025-01-27 13:09:15','162.158.62.68'),(659,NULL,5,1,'2025-01-27 13:25:58','2025-01-27 13:35:09','162.158.155.16'),(660,NULL,5,1,'2025-01-27 13:36:59','2025-01-27 14:05:47','172.70.230.163'),(661,NULL,5,1,'2025-01-27 15:20:53','2025-01-27 15:35:40','162.158.154.51'),(662,NULL,5,1,'2025-01-27 15:58:05','2025-01-27 15:58:05','162.158.63.115'),(663,NULL,5,1,'2025-01-27 16:28:14','2025-01-27 16:58:46','172.70.111.143'),(664,NULL,5,1,'2025-01-28 06:37:29','2025-01-28 07:17:09','162.158.63.12'),(665,NULL,5,1,'2025-01-28 07:20:58','2025-01-28 07:40:03','172.70.114.123'),(666,NULL,5,1,'2025-01-28 08:19:05','2025-01-28 08:53:08','162.158.154.203'),(667,NULL,5,1,'2025-01-28 09:05:14','2025-01-28 09:14:15','172.70.230.56'),(668,NULL,5,1,'2025-01-28 09:29:35','2025-01-28 09:58:48','172.70.114.88'),(669,NULL,5,1,'2025-01-28 09:35:01','2025-01-28 10:01:13','162.158.63.9'),(670,NULL,5,1,'2025-01-28 09:57:44','2025-01-28 10:03:13','162.158.63.12'),(671,NULL,5,1,'2025-01-28 09:59:10','2025-01-28 10:00:47','172.70.230.251'),(672,NULL,5,1,'2025-01-28 10:27:16','2025-01-28 10:36:25','172.70.230.162'),(673,NULL,5,1,'2025-01-28 10:30:30','2025-01-28 10:33:21','162.158.154.141'),(674,NULL,5,1,'2025-01-28 10:31:56','2025-01-28 10:45:48','162.158.62.97'),(675,NULL,5,1,'2025-01-28 10:37:56','2025-01-28 10:58:29','172.70.114.130'),(676,NULL,5,1,'2025-01-28 10:58:54','2025-01-28 13:26:57','172.70.110.168'),(677,NULL,5,1,'2025-01-28 12:14:13','2025-01-28 12:39:42','162.158.155.16'),(678,NULL,7,1,'2025-01-28 13:04:12','2025-01-28 13:55:38','172.70.230.117'),(679,NULL,5,1,'2025-01-28 13:12:38','2025-01-28 13:12:38','172.70.111.144'),(680,NULL,5,1,'2025-01-28 14:29:45','2025-01-28 14:45:11','162.158.159.50'),(681,NULL,5,1,'2025-01-28 14:49:03','2025-01-28 15:29:41','162.158.63.11'),(682,NULL,5,1,'2025-01-28 15:08:42','2025-01-28 15:36:49','162.158.63.11'),(683,NULL,5,1,'2025-01-28 15:24:06','2025-01-28 15:24:44','162.158.155.60'),(684,NULL,5,1,'2025-01-28 15:55:09','2025-01-28 16:11:46','172.70.231.40'),(685,NULL,5,1,'2025-01-28 15:56:40','2025-01-28 16:01:13','172.70.114.103'),(686,NULL,5,1,'2025-01-29 07:34:40','2025-01-29 07:51:45','172.70.114.117'),(687,NULL,5,1,'2025-01-29 09:17:44','2025-01-29 09:17:44','172.70.230.250'),(688,NULL,5,1,'2025-01-29 10:05:52','2025-01-29 10:29:15','162.158.159.62'),(689,NULL,5,1,'2025-01-29 11:41:11','2025-01-29 12:17:48','172.70.231.39'),(690,NULL,5,1,'2025-01-29 12:38:26','2025-01-29 12:50:02','172.70.110.213'),(691,NULL,5,1,'2025-01-29 13:17:10','2025-01-29 13:21:21','172.70.110.213'),(692,NULL,5,1,'2025-01-29 13:49:41','2025-01-29 14:00:29','162.158.63.11'),(693,NULL,5,3,'2025-01-29 14:50:05','2025-01-29 15:21:12','162.158.159.38'),(694,NULL,5,1,'2025-01-29 15:21:29','2025-01-29 15:21:29','172.70.114.116'),(695,NULL,5,1,'2025-01-29 15:21:29','2025-01-29 16:02:52','162.158.159.49'),(696,NULL,5,1,'2025-01-29 15:44:55','2025-01-29 15:49:03','172.70.231.40'),(697,NULL,5,1,'2025-01-30 07:42:14','2025-01-30 07:42:44','172.70.114.130'),(698,NULL,5,1,'2025-01-30 13:10:59','2025-01-30 13:12:57','172.70.111.80'),(699,NULL,5,1,'2025-01-30 15:02:37','2025-01-30 15:08:21','172.70.231.39'),(700,NULL,5,1,'2025-01-30 15:07:45','2025-01-30 15:27:45','162.158.159.50'),(701,NULL,5,1,'2025-01-31 05:34:59','2025-01-31 05:38:44','162.158.63.12'),(702,NULL,5,1,'2025-01-31 05:56:20','2025-01-31 05:59:40','162.158.159.49'),(703,NULL,5,1,'2025-01-31 07:39:11','2025-01-31 07:55:54','162.158.158.23'),(704,NULL,5,1,'2025-01-31 07:56:57','2025-01-31 08:24:10','172.70.230.57'),(705,NULL,5,1,'2025-01-31 08:57:57','2025-01-31 09:16:05','172.70.110.2'),(706,NULL,5,1,'2025-01-31 09:20:57','2025-01-31 09:21:58','162.158.155.16'),(707,NULL,5,1,'2025-01-31 09:22:02','2025-01-31 10:45:04','172.70.114.103'),(708,NULL,5,1,'2025-01-31 09:27:25','2025-01-31 10:41:49','162.158.159.17'),(709,NULL,5,1,'2025-01-31 09:45:45','2025-01-31 09:49:19','162.158.159.129'),(710,NULL,5,1,'2025-01-31 09:46:04','2025-01-31 10:53:26','162.158.62.96'),(711,NULL,5,1,'2025-01-31 10:27:07','2025-01-31 10:41:47','172.70.114.131'),(712,NULL,5,1,'2025-01-31 11:51:31','2025-01-31 11:51:31','172.70.114.131'),(713,NULL,5,1,'2025-01-31 13:39:17','2025-01-31 15:11:14','162.158.154.247'),(714,NULL,5,1,'2025-01-31 16:10:29','2025-01-31 16:12:30','162.158.159.37'),(715,NULL,5,1,'2025-01-31 23:17:02','2025-02-01 00:02:06','162.158.155.15'),(716,NULL,5,1,'2025-02-01 04:55:26','2025-02-01 04:56:34','172.70.111.43'),(717,NULL,5,0,'2025-02-01 04:56:16','2025-02-01 06:32:05','172.70.111.44'),(718,NULL,5,1,'2025-02-01 06:21:56','2025-02-01 06:23:00','172.70.114.204'),(719,NULL,5,1,'2025-02-01 06:32:12','2025-02-01 06:48:51','162.158.154.95'),(720,NULL,5,1,'2025-02-01 11:19:26','2025-02-01 11:30:10','172.70.114.89'),(721,NULL,5,1,'2025-02-03 05:29:47','2025-02-03 06:24:10','162.158.155.16'),(722,NULL,5,1,'2025-02-03 07:24:38','2025-02-03 10:05:49','162.158.155.15'),(723,NULL,5,1,'2025-02-03 07:59:18','2025-02-03 08:11:05','172.70.111.143'),(724,NULL,5,1,'2025-02-03 08:15:16','2025-02-03 09:07:07','162.158.63.12'),(725,NULL,5,1,'2025-02-03 09:29:02','2025-02-03 09:30:16','172.70.230.163'),(726,NULL,5,1,'2025-02-03 09:31:33','2025-02-03 10:52:19','172.70.114.131'),(727,NULL,5,1,'2025-02-03 14:53:11','2025-02-03 15:07:32','162.158.155.60'),(728,NULL,5,1,'2025-02-03 15:46:11','2025-02-03 16:26:11','172.70.230.250'),(729,NULL,5,1,'2025-02-03 15:57:00','2025-02-03 16:03:13','162.158.154.246'),(730,NULL,5,1,'2025-02-03 16:23:43','2025-02-03 17:23:12','172.70.231.72'),(731,NULL,5,1,'2025-02-04 06:12:34','2025-02-04 06:15:52','162.158.158.40'),(732,NULL,5,1,'2025-02-04 06:46:54','2025-02-04 12:26:31','172.70.110.212'),(733,NULL,5,0,'2025-02-04 07:32:42','2025-02-04 08:54:19','172.70.111.79'),(734,NULL,5,1,'2025-02-04 08:51:15','2025-02-04 08:51:15','162.158.159.79'),(735,NULL,5,1,'2025-02-04 08:54:23','2025-02-04 10:18:19','162.158.154.246'),(736,NULL,5,1,'2025-02-04 09:09:36','2025-02-04 10:20:44','162.158.63.14'),(737,NULL,5,1,'2025-02-04 10:04:01','2025-02-04 10:21:43','172.70.111.143'),(738,NULL,5,1,'2025-02-04 10:52:41','2025-02-04 11:22:06','172.70.110.169'),(739,NULL,5,1,'2025-02-04 11:11:43','2025-02-04 11:28:56','172.70.230.56'),(740,NULL,5,1,'2025-02-04 11:22:24','2025-02-04 11:23:38','162.158.155.37'),(741,NULL,5,1,'2025-02-04 12:39:32','2025-02-04 12:42:45','172.70.111.80'),(742,NULL,5,1,'2025-02-04 12:44:44','2025-02-04 12:56:27','162.158.158.52'),(743,NULL,5,1,'2025-02-04 13:15:48','2025-02-04 14:11:24','162.158.154.246'),(744,NULL,5,1,'2025-02-04 15:04:19','2025-02-04 15:26:43','172.70.111.80'),(745,NULL,5,1,'2025-02-05 05:02:45','2025-02-05 05:14:05','172.70.230.56'),(746,NULL,5,1,'2025-02-05 05:05:59','2025-02-05 05:12:37','162.158.62.68'),(747,NULL,5,1,'2025-02-05 05:08:17','2025-02-05 05:08:17','162.158.158.132'),(748,NULL,5,1,'2025-02-05 05:12:08','2025-02-05 05:13:11','162.158.63.11'),(749,NULL,5,1,'2025-02-05 05:15:35','2025-02-05 05:16:36','162.158.63.14'),(750,NULL,5,1,'2025-02-05 05:19:14','2025-02-05 06:06:14','162.158.154.246'),(751,NULL,5,1,'2025-02-05 05:52:33','2025-02-05 07:35:21','162.158.158.132'),(752,NULL,5,1,'2025-02-05 07:36:07','2025-02-05 07:44:28','162.158.158.234'),(753,NULL,5,1,'2025-02-05 07:36:35','2025-02-05 07:46:57','162.158.62.9');
/*!40000 ALTER TABLE `admin_user_session` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `adminnotification_inbox`
--

DROP TABLE IF EXISTS `adminnotification_inbox`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `adminnotification_inbox` (
  `notification_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Notification ID',
  `severity` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Problem type',
  `date_added` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Create date',
  `title` varchar(255) NOT NULL COMMENT 'Title',
  `description` text COMMENT 'Description',
  `url` varchar(255) DEFAULT NULL COMMENT 'Url',
  `is_read` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Flag if notification read',
  `is_remove` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Flag if notification might be removed',
  PRIMARY KEY (`notification_id`),
  KEY `ADMINNOTIFICATION_INBOX_SEVERITY` (`severity`),
  KEY `ADMINNOTIFICATION_INBOX_IS_READ` (`is_read`),
  KEY `ADMINNOTIFICATION_INBOX_IS_REMOVE` (`is_remove`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb3 COMMENT='Adminnotification Inbox';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `adminnotification_inbox`
--

LOCK TABLES `adminnotification_inbox` WRITE;
/*!40000 ALTER TABLE `adminnotification_inbox` DISABLE KEYS */;
INSERT INTO `adminnotification_inbox` VALUES (1,4,'2024-08-05 09:21:16','Disable Notice','To improve performance, collecting statistics for the Magento Report module is disabled by default. \nYou can enable it in System Config.','',1,0),(2,3,'2024-11-14 09:41:40','New version 2.1.6 of Magefan Magento 2 Guest to Customer Extension is now available.',' You can download the new version from Magefan Store or update it via composer. Get us in touch if you need our help with an update or you have any questions.\n                                    https://magefan.com/magento2-convert-guest-to-customer?version=2.1.6\n                                 ','https://magefan.com/magento2-convert-guest-to-customer?version=2.1.6',1,0),(3,3,'2024-11-14 09:41:40','New version 2.1.4 of Magefan Magento 2 Command Line Interface Extension is now available.',' You can download the new version from Magefan Store or update it via composer. Get us in touch if you need our help with an update or you have any questions.\n                                    https://magefan.com/magento2-cli-extension?version=2.1.4\n                                 ','https://magefan.com/magento2-cli-extension?version=2.1.4',1,0),(4,3,'2024-11-14 09:41:40','New version 2.12.0 of Magefan Magento 2 Blog Extension is now available.',' You can download the new version from Magefan Store or update it via composer. Get us in touch if you need our help with an update or you have any questions.\n                                    https://magefan.com/magento2-blog-extension?version=2.12.0\n                                 ','https://magefan.com/magento2-blog-extension?version=2.12.0',1,0),(5,4,'2024-11-14 09:41:40','FAQ: How to configure &quot;read more&quot; in your Magento 2 blog post',' If you still don&#039;t know how to configure read more functionality in your magento 2 blog post, please read this article.\n                    Online documentation for Magento 2 blog extension is also available on our website. http://goo.gl/XOEdpy ','http://magefan.com/blog/add-read-more-tag-to-blog-post-content/?from=notification1',1,0),(6,4,'2024-11-07 00:00:00','Have you already added Cookie Consent to your Magento 2? ','Comply with all major data privacy regulations - GDPR, CCPA, LGPD, CNIL. Read more about Magento 2 Cookie Notice Extension  https://magefan.com/magento-2-cookie-consent','https://magefan.com/magento-2-cookie-consent?utm_source=website-admin&amp;utm_medium=adimin-ntf&amp;utm_campaign=new-cookie-consent-extension',1,0),(7,1,'2025-01-29 14:50:10','Attention! Your Blog extension version is extremely outdated. It is strongly recommended to update it to the latest version 2.12.2',' \n                                    https://magefan.com/magento2-blog-extension?ancient=2.9.8                                 ','https://magefan.com/magento2-blog-extension?ancient=2.9.8',1,0),(8,2,'2025-02-04 10:01:34','Your export file is ready','You can pick up your file at export main page','',1,0),(9,2,'2025-02-04 10:01:37','Your export file is ready','You can pick up your file at export main page','',1,0);
/*!40000 ALTER TABLE `adminnotification_inbox` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `adobe_stock_asset`
--

DROP TABLE IF EXISTS `adobe_stock_asset`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `adobe_stock_asset` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `media_gallery_id` int unsigned DEFAULT NULL COMMENT 'Media gallery ID',
  `category_id` int unsigned DEFAULT NULL COMMENT 'Category ID',
  `creator_id` int unsigned DEFAULT NULL COMMENT 'Creator ID',
  `is_licensed` int unsigned NOT NULL DEFAULT '0' COMMENT 'Is Licensed',
  `creation_date` varchar(255) DEFAULT NULL COMMENT 'Creation Date',
  PRIMARY KEY (`id`),
  KEY `ADOBE_STOCK_ASSET_MEDIA_GALLERY_ID_MEDIA_GALLERY_ASSET_ID` (`media_gallery_id`),
  KEY `ADOBE_STOCK_ASSET_ID` (`id`),
  KEY `ADOBE_STOCK_ASSET_CATEGORY_ID` (`category_id`),
  KEY `ADOBE_STOCK_ASSET_CREATOR_ID` (`creator_id`),
  CONSTRAINT `ADOBE_STOCK_ASSET_CATEGORY_ID_ADOBE_STOCK_CATEGORY_ID` FOREIGN KEY (`category_id`) REFERENCES `adobe_stock_category` (`id`) ON DELETE SET NULL,
  CONSTRAINT `ADOBE_STOCK_ASSET_CREATOR_ID_ADOBE_STOCK_CREATOR_ID` FOREIGN KEY (`creator_id`) REFERENCES `adobe_stock_creator` (`id`) ON DELETE SET NULL,
  CONSTRAINT `ADOBE_STOCK_ASSET_MEDIA_GALLERY_ID_MEDIA_GALLERY_ASSET_ID` FOREIGN KEY (`media_gallery_id`) REFERENCES `media_gallery_asset` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Adobe Stock Asset';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `adobe_stock_asset`
--

LOCK TABLES `adobe_stock_asset` WRITE;
/*!40000 ALTER TABLE `adobe_stock_asset` DISABLE KEYS */;
/*!40000 ALTER TABLE `adobe_stock_asset` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `adobe_stock_category`
--

DROP TABLE IF EXISTS `adobe_stock_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `adobe_stock_category` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  PRIMARY KEY (`id`),
  KEY `ADOBE_STOCK_CATEGORY_ID` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Adobe Stock Category';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `adobe_stock_category`
--

LOCK TABLES `adobe_stock_category` WRITE;
/*!40000 ALTER TABLE `adobe_stock_category` DISABLE KEYS */;
/*!40000 ALTER TABLE `adobe_stock_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `adobe_stock_creator`
--

DROP TABLE IF EXISTS `adobe_stock_creator`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `adobe_stock_creator` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `name` varchar(255) DEFAULT NULL COMMENT 'Asset creator''s name',
  PRIMARY KEY (`id`),
  KEY `ADOBE_STOCK_CREATOR_ID` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Adobe Stock Creator';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `adobe_stock_creator`
--

LOCK TABLES `adobe_stock_creator` WRITE;
/*!40000 ALTER TABLE `adobe_stock_creator` DISABLE KEYS */;
/*!40000 ALTER TABLE `adobe_stock_creator` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `adobe_user_profile`
--

DROP TABLE IF EXISTS `adobe_user_profile`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `adobe_user_profile` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `admin_user_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Admin User Id',
  `name` varchar(255) NOT NULL COMMENT 'Display Name',
  `email` varchar(255) NOT NULL COMMENT 'user profile email',
  `image` varchar(255) NOT NULL COMMENT 'user profile avatar',
  `account_type` varchar(255) DEFAULT NULL COMMENT 'Account Type',
  `access_token` text COMMENT 'Access Token',
  `refresh_token` text COMMENT 'Refresh Token',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `access_token_expires_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Access Token Expires At',
  PRIMARY KEY (`id`),
  KEY `ADOBE_USER_PROFILE_ADMIN_USER_ID` (`admin_user_id`),
  CONSTRAINT `ADOBE_USER_PROFILE_ADMIN_USER_ID_ADMIN_USER_USER_ID` FOREIGN KEY (`admin_user_id`) REFERENCES `admin_user` (`user_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Adobe IMS User Profile';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `adobe_user_profile`
--

LOCK TABLES `adobe_user_profile` WRITE;
/*!40000 ALTER TABLE `adobe_user_profile` DISABLE KEYS */;
/*!40000 ALTER TABLE `adobe_user_profile` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `amasty_base_instance_data`
--

DROP TABLE IF EXISTS `amasty_base_instance_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `amasty_base_instance_data` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Record ID',
  `code` varchar(255) NOT NULL COMMENT 'Code',
  `value` mediumtext COMMENT 'Value',
  PRIMARY KEY (`id`),
  UNIQUE KEY `AMASTY_BASE_INSTANCE_DATA_CODE` (`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Amasty Base Instance Data';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `amasty_base_instance_data`
--

LOCK TABLES `amasty_base_instance_data` WRITE;
/*!40000 ALTER TABLE `amasty_base_instance_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `amasty_base_instance_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `amasty_base_instance_hash`
--

DROP TABLE IF EXISTS `amasty_base_instance_hash`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `amasty_base_instance_hash` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Record ID',
  `code` varchar(255) NOT NULL COMMENT 'Code',
  `value` mediumtext COMMENT 'Value',
  `updated_at` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Last Send Date Timestamp',
  PRIMARY KEY (`id`),
  UNIQUE KEY `AMASTY_BASE_INSTANCE_HASH_CODE` (`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Amasty Base Data Send Schedule';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `amasty_base_instance_hash`
--

LOCK TABLES `amasty_base_instance_hash` WRITE;
/*!40000 ALTER TABLE `amasty_base_instance_hash` DISABLE KEYS */;
/*!40000 ALTER TABLE `amasty_base_instance_hash` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `amasty_base_schedule`
--

DROP TABLE IF EXISTS `amasty_base_schedule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `amasty_base_schedule` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Record ID',
  `code` varchar(255) NOT NULL COMMENT 'Code',
  `last_send_date` int unsigned NOT NULL COMMENT 'Last Send Date Timestamp',
  `time_intervals` varchar(255) DEFAULT NULL COMMENT 'Time Intervals to Send',
  PRIMARY KEY (`id`),
  UNIQUE KEY `AMASTY_BASE_SCHEDULE_CODE` (`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Amasty Base Data Send Schedule';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `amasty_base_schedule`
--

LOCK TABLES `amasty_base_schedule` WRITE;
/*!40000 ALTER TABLE `amasty_base_schedule` DISABLE KEYS */;
/*!40000 ALTER TABLE `amasty_base_schedule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `amasty_customtabs_tabs`
--

DROP TABLE IF EXISTS `amasty_customtabs_tabs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `amasty_customtabs_tabs` (
  `tab_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Tab Id',
  `sort_order` smallint unsigned DEFAULT NULL COMMENT 'Sort order',
  `tab_title` varchar(255) NOT NULL COMMENT 'Tab title',
  `tab_name` varchar(255) NOT NULL COMMENT 'Tab name',
  `content` text COMMENT 'Content',
  `customer_groups` varchar(255) NOT NULL COMMENT 'Customer Groups',
  `status` tinyint(1) NOT NULL COMMENT 'Status',
  `is_active` tinyint(1) NOT NULL COMMENT 'Is active',
  `related_enabled` tinyint(1) NOT NULL COMMENT 'Is RELATED ENABLED',
  `upsell_enabled` tinyint(1) NOT NULL COMMENT 'Is UPSELL ENABLED',
  `crosssell_enabled` tinyint(1) NOT NULL COMMENT 'Is CROSSSELL ENABLED',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `conditions_serialized` mediumtext COMMENT 'Conditions Serialized',
  `type` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Tab type',
  `name_in_layout` varchar(50) DEFAULT NULL COMMENT 'Name in Layout (for defualt tabs)',
  `module_name` varchar(50) DEFAULT NULL COMMENT 'Module name for default and 3rd patry extensions',
  `anchor` varchar(255) DEFAULT '' COMMENT 'Anchor',
  PRIMARY KEY (`tab_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Amasty Product tabs table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `amasty_customtabs_tabs`
--

LOCK TABLES `amasty_customtabs_tabs` WRITE;
/*!40000 ALTER TABLE `amasty_customtabs_tabs` DISABLE KEYS */;
/*!40000 ALTER TABLE `amasty_customtabs_tabs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `amasty_customtabs_tabs_rule_index`
--

DROP TABLE IF EXISTS `amasty_customtabs_tabs_rule_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `amasty_customtabs_tabs_rule_index` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id',
  `tab_id` int unsigned NOT NULL COMMENT 'Tab ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `product_id` int unsigned NOT NULL COMMENT 'Product ID',
  PRIMARY KEY (`id`),
  KEY `AMASTY_CUSTOMTABS_TABS_RULE_IDX_PRD_ID_CAT_PRD_ENTT_ENTT_ID` (`product_id`),
  KEY `AMASTY_CUSTOMTABS_TABS_RULE_INDEX_STORE_ID_STORE_STORE_ID` (`store_id`),
  KEY `AMASTY_CUSTOMTABS_TABS_RULE_INDEX_TAB_ID_STORE_ID` (`tab_id`,`store_id`),
  CONSTRAINT `AMASTY_CUSTOMTABS_TABS_RULE_IDX_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `AMASTY_CUSTOMTABS_TABS_RULE_INDEX_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_657391494FC1D5484F54FDACB37B82AE` FOREIGN KEY (`tab_id`) REFERENCES `amasty_customtabs_tabs` (`tab_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Amasty Custom Tabs Rule Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `amasty_customtabs_tabs_rule_index`
--

LOCK TABLES `amasty_customtabs_tabs_rule_index` WRITE;
/*!40000 ALTER TABLE `amasty_customtabs_tabs_rule_index` DISABLE KEYS */;
/*!40000 ALTER TABLE `amasty_customtabs_tabs_rule_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `amasty_customtabs_tabs_store`
--

DROP TABLE IF EXISTS `amasty_customtabs_tabs_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `amasty_customtabs_tabs_store` (
  `tab_id` int unsigned NOT NULL COMMENT 'Tab Id',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store Id',
  UNIQUE KEY `AMASTY_CUSTOMTABS_TABS_STORE_TAB_ID_STORE_ID` (`tab_id`,`store_id`),
  KEY `AMASTY_CUSTOMTABS_TABS_STORE_STORE_ID_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `AMASTY_CUSTOMTABS_TABS_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_BE981C9E843457ACB4E639762C4A95D8` FOREIGN KEY (`tab_id`) REFERENCES `amasty_customtabs_tabs` (`tab_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Amasty Product Tabs store relation table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `amasty_customtabs_tabs_store`
--

LOCK TABLES `amasty_customtabs_tabs_store` WRITE;
/*!40000 ALTER TABLE `amasty_customtabs_tabs_store` DISABLE KEYS */;
/*!40000 ALTER TABLE `amasty_customtabs_tabs_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `authorization_role`
--

DROP TABLE IF EXISTS `authorization_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `authorization_role` (
  `role_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Role ID',
  `parent_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Parent Role ID',
  `tree_level` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Role Tree Level',
  `sort_order` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Role Sort Order',
  `role_type` varchar(1) NOT NULL DEFAULT '0' COMMENT 'Role Type',
  `user_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'User ID',
  `user_type` varchar(16) DEFAULT NULL COMMENT 'User Type',
  `role_name` varchar(50) DEFAULT NULL COMMENT 'Role Name',
  PRIMARY KEY (`role_id`),
  KEY `AUTHORIZATION_ROLE_PARENT_ID_SORT_ORDER` (`parent_id`,`sort_order`),
  KEY `AUTHORIZATION_ROLE_TREE_LEVEL` (`tree_level`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8mb3 COMMENT='Admin Role Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `authorization_role`
--

LOCK TABLES `authorization_role` WRITE;
/*!40000 ALTER TABLE `authorization_role` DISABLE KEYS */;
INSERT INTO `authorization_role` VALUES (1,0,1,1,'G',0,'2','Administrators'),(2,1,2,0,'U',1,'2','admin'),(3,1,2,0,'U',2,'2','shakeel'),(4,1,2,0,'U',3,'2','ab'),(5,0,1,0,'G',0,'2','Accounts '),(6,5,2,0,'U',4,'2','zohaib1'),(8,1,2,0,'U',6,'2','mageplaza'),(9,1,2,0,'U',5,'2','hyva'),(10,1,2,0,'U',7,'2','adminsns');
/*!40000 ALTER TABLE `authorization_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `authorization_rule`
--

DROP TABLE IF EXISTS `authorization_rule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `authorization_rule` (
  `rule_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rule ID',
  `role_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Role ID',
  `resource_id` varchar(255) DEFAULT NULL COMMENT 'Resource ID',
  `privileges` varchar(20) DEFAULT NULL COMMENT 'Privileges',
  `permission` varchar(10) DEFAULT NULL COMMENT 'Permission',
  PRIMARY KEY (`rule_id`),
  KEY `AUTHORIZATION_RULE_RESOURCE_ID_ROLE_ID` (`resource_id`,`role_id`),
  KEY `AUTHORIZATION_RULE_ROLE_ID_RESOURCE_ID` (`role_id`,`resource_id`),
  CONSTRAINT `AUTHORIZATION_RULE_ROLE_ID_AUTHORIZATION_ROLE_ROLE_ID` FOREIGN KEY (`role_id`) REFERENCES `authorization_role` (`role_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=376 DEFAULT CHARSET=utf8mb3 COMMENT='Admin Rule Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `authorization_rule`
--

LOCK TABLES `authorization_rule` WRITE;
/*!40000 ALTER TABLE `authorization_rule` DISABLE KEYS */;
INSERT INTO `authorization_rule` VALUES (1,1,'Magento_Backend::all',NULL,'allow'),(2,5,'Magento_Adminhtml::admin',NULL,'deny'),(3,5,'Magento_Backend::all',NULL,'deny'),(4,5,'Magento_Backend::admin',NULL,'allow'),(5,5,'Magento_Backend::dashboard',NULL,'deny'),(6,5,'Magento_Backend::ves_all_elements',NULL,'deny'),(7,5,'Ves_All::ves_all',NULL,'deny'),(8,5,'Magento_Backend::brand_elements',NULL,'deny'),(9,5,'Ves_Brand::brand',NULL,'deny'),(10,5,'Ves_Brand::brand_edit',NULL,'deny'),(11,5,'Ves_Brand::brand_save',NULL,'deny'),(12,5,'Ves_Brand::brand_delete',NULL,'deny'),(13,5,'Ves_Brand::brand_save_product',NULL,'deny'),(14,5,'Ves_Brand::group',NULL,'deny'),(15,5,'Ves_Brand::group_edit',NULL,'deny'),(16,5,'Ves_Brand::group_save',NULL,'deny'),(17,5,'Ves_Brand::group_delete',NULL,'deny'),(18,5,'Ves_Brand::import',NULL,'deny'),(19,5,'Ves_Brand::import_products',NULL,'deny'),(20,5,'Ves_Brand::import_save',NULL,'deny'),(21,5,'Magento_Analytics::analytics',NULL,'deny'),(22,5,'Magento_Analytics::analytics_api',NULL,'deny'),(23,5,'Magento_Catalog::catalog',NULL,'deny'),(24,5,'Magento_Catalog::catalog_inventory',NULL,'deny'),(25,5,'Magento_Catalog::products',NULL,'deny'),(26,5,'Magento_Catalog::update_attributes',NULL,'deny'),(27,5,'Magento_Catalog::edit_product_design',NULL,'deny'),(28,5,'Magento_Catalog::categories',NULL,'deny'),(29,5,'Magento_Catalog::edit_category_design',NULL,'deny'),(30,5,'Nexus_Catalog::categoryimport',NULL,'deny'),(31,5,'Nexus_Catalog::productlink',NULL,'deny'),(32,5,'Bss_ProductAttachment::main',NULL,'deny'),(33,5,'Bss_ProductAttachment::attachment',NULL,'deny'),(34,5,'Bss_ProductAttachment::delete',NULL,'deny'),(35,5,'Bss_ProductAttachment::save',NULL,'deny'),(36,5,'Magefan_AdminUserGuide::help',NULL,'deny'),(37,5,'Magento_Customer::customer',NULL,'deny'),(38,5,'Magento_Customer::manage',NULL,'deny'),(39,5,'Magento_Customer::actions',NULL,'deny'),(40,5,'Magento_Customer::delete',NULL,'deny'),(41,5,'Magento_Customer::reset_password',NULL,'deny'),(42,5,'Magento_Customer::invalidate_tokens',NULL,'deny'),(43,5,'Magento_LoginAsCustomer::allow_shopping_assistance',NULL,'deny'),(44,5,'Magento_Customer::online',NULL,'deny'),(45,5,'Magento_Customer::group',NULL,'deny'),(46,5,'Magento_LoginAsCustomer::login',NULL,'deny'),(47,5,'Magento_LoginAsCustomerLog::login_log',NULL,'deny'),(48,5,'Magento_Cart::cart',NULL,'deny'),(49,5,'Magento_Cart::manage',NULL,'deny'),(50,5,'Magento_Backend::myaccount',NULL,'deny'),(51,5,'Magento_Backend::marketing',NULL,'deny'),(52,5,'Magento_CatalogRule::promo',NULL,'deny'),(53,5,'Magento_CatalogRule::promo_catalog',NULL,'deny'),(54,5,'Magento_SalesRule::quote',NULL,'deny'),(55,5,'Mageplaza_Smtp::email_marketing_menu',NULL,'deny'),(56,5,'Magento_Backend::marketing_communications',NULL,'deny'),(57,5,'Magento_Email::template',NULL,'deny'),(58,5,'Magento_Newsletter::template',NULL,'deny'),(59,5,'Magento_Newsletter::queue',NULL,'deny'),(60,5,'Magento_Newsletter::subscriber',NULL,'deny'),(61,5,'Magento_Backend::marketing_seo',NULL,'deny'),(62,5,'Magento_Search::search',NULL,'deny'),(63,5,'Magento_Search::synonyms',NULL,'deny'),(64,5,'Magento_UrlRewrite::urlrewrite',NULL,'deny'),(65,5,'Magento_Sitemap::sitemap',NULL,'deny'),(66,5,'Magento_Backend::marketing_user_content',NULL,'deny'),(67,5,'Magento_Review::reviews_all',NULL,'deny'),(68,5,'Magento_Review::pending',NULL,'deny'),(69,5,'Bss_ProductLabel::manage_label',NULL,'deny'),(70,5,'Bss_ProductLabel::edit_label',NULL,'deny'),(71,5,'Bss_ProductLabel::delete_label',NULL,'deny'),(72,5,'Mageplaza_Core::menu',NULL,'deny'),(73,5,'Mageplaza_Smtp::smtp',NULL,'deny'),(74,5,'Mageplaza_Smtp::log',NULL,'deny'),(75,5,'Mageplaza_Smtp::abandoned_cart',NULL,'deny'),(76,5,'Mageplaza_Core::documentation',NULL,'deny'),(77,5,'Mageplaza_Core::userguide',NULL,'deny'),(78,5,'Mageplaza_Core::activate',NULL,'deny'),(79,5,'Magento_Sales::sales',NULL,'allow'),(80,5,'Magento_Sales::sales_operation',NULL,'allow'),(81,5,'Magento_Sales::sales_order',NULL,'allow'),(82,5,'Magento_Sales::actions',NULL,'allow'),(83,5,'Magento_Sales::create',NULL,'allow'),(84,5,'Magento_PaymentServicesPaypal::ordercreate',NULL,'allow'),(85,5,'Magento_Sales::actions_view',NULL,'allow'),(86,5,'Magento_Sales::email',NULL,'allow'),(87,5,'Magento_Sales::reorder',NULL,'allow'),(88,5,'Magento_Sales::actions_edit',NULL,'allow'),(89,5,'Magento_Sales::cancel',NULL,'allow'),(90,5,'Magento_Sales::review_payment',NULL,'allow'),(91,5,'Magento_Sales::capture',NULL,'allow'),(92,5,'Magento_Sales::invoice',NULL,'allow'),(93,5,'Magento_Sales::creditmemo',NULL,'allow'),(94,5,'Magento_Sales::hold',NULL,'allow'),(95,5,'Magento_Sales::unhold',NULL,'allow'),(96,5,'Magento_Sales::ship',NULL,'allow'),(97,5,'Magento_Sales::comment',NULL,'allow'),(98,5,'Magento_Sales::emails',NULL,'allow'),(99,5,'Magento_Paypal::authorization',NULL,'allow'),(100,5,'Magento_PaymentServicesDashboard::paymentservices',NULL,'allow'),(101,5,'Magento_PaymentServicesDashboard::paymentservicesdashboard',NULL,'allow'),(102,5,'Magento_ServiceProxy::services',NULL,'allow'),(103,5,'Magento_Sales::sales_invoice',NULL,'allow'),(104,5,'Magento_Sales::shipment',NULL,'allow'),(105,5,'Magento_Sales::sales_creditmemo',NULL,'allow'),(106,5,'Magento_Paypal::billing_agreement',NULL,'allow'),(107,5,'Magento_Paypal::billing_agreement_actions',NULL,'allow'),(108,5,'Magento_Paypal::billing_agreement_actions_view',NULL,'allow'),(109,5,'Magento_Paypal::actions_manage',NULL,'allow'),(110,5,'Magento_Paypal::use',NULL,'allow'),(111,5,'Magento_Sales::transactions',NULL,'allow'),(112,5,'Magento_Sales::transactions_fetch',NULL,'allow'),(113,5,'Magefan_GuestToCustomer::config_section',NULL,'allow'),(114,5,'Nexus_Sales::order',NULL,'allow'),(115,5,'Magento_Backend::content',NULL,'deny'),(116,5,'Mirasvit_LandingPage::landing',NULL,'deny'),(117,5,'Mirasvit_LandingPage::landing_pages',NULL,'deny'),(118,5,'Magento_Backend::content_elements',NULL,'deny'),(119,5,'Magento_Cms::page',NULL,'deny'),(120,5,'Magento_Cms::save',NULL,'deny'),(121,5,'Magento_Cms::save_design',NULL,'deny'),(122,5,'MSP_CmsImportExport::export_page',NULL,'deny'),(123,5,'Magento_Cms::page_delete',NULL,'deny'),(124,5,'Magento_Cms::block',NULL,'deny'),(125,5,'MSP_CmsImportExport::export_block',NULL,'deny'),(126,5,'MSP_CmsImportExport::import',NULL,'deny'),(127,5,'Magento_Widget::widget_instance',NULL,'deny'),(128,5,'Magento_Cms::media_gallery',NULL,'deny'),(129,5,'Magento_MediaGalleryUiApi::insert_assets',NULL,'deny'),(130,5,'Magento_MediaGalleryUiApi::upload_assets',NULL,'deny'),(131,5,'Magento_MediaGalleryUiApi::edit_assets',NULL,'deny'),(132,5,'Magento_AdobeStockImageAdminUi::media_gallery',NULL,'deny'),(133,5,'Magento_AdobeStockImageAdminUi::save_preview_images',NULL,'deny'),(134,5,'Magento_AdobeStockImageAdminUi::license_images',NULL,'deny'),(135,5,'Magento_MediaGalleryUiApi::delete_assets',NULL,'deny'),(136,5,'Magento_MediaGalleryUiApi::create_folder',NULL,'deny'),(137,5,'Magento_MediaGalleryUiApi::delete_folder',NULL,'deny'),(138,5,'Magento_PageBuilder::templates',NULL,'deny'),(139,5,'Magento_PageBuilder::template_save',NULL,'deny'),(140,5,'Magento_PageBuilder::template_apply',NULL,'deny'),(141,5,'Magento_PageBuilder::template_delete',NULL,'deny'),(142,5,'Magento_Backend::design',NULL,'deny'),(143,5,'Magento_Theme::theme',NULL,'deny'),(144,5,'Magento_Backend::schedule',NULL,'deny'),(145,5,'Magento_Backend::content_translation',NULL,'deny'),(146,5,'Mirasvit_Brand::brand',NULL,'deny'),(147,5,'Mirasvit_Brand::brand_brand',NULL,'deny'),(148,5,'Mirasvit_Brand::attribute',NULL,'deny'),(149,5,'Mirasvit_Brand::brand_settings',NULL,'deny'),(150,5,'Mirasvit_Brand::brand_get_support',NULL,'deny'),(151,5,'Magefan_Community::elements',NULL,'deny'),(152,5,'Magento_Reports::report',NULL,'deny'),(153,5,'Magento_Reports::report_marketing',NULL,'deny'),(154,5,'Magento_Reports::shopcart',NULL,'deny'),(155,5,'Magento_Reports::product',NULL,'deny'),(156,5,'Magento_Reports::abandoned',NULL,'deny'),(157,5,'Magento_Reports::report_search',NULL,'deny'),(158,5,'Magento_Newsletter::problem',NULL,'deny'),(159,5,'Magento_Reports::review',NULL,'deny'),(160,5,'Magento_Reports::review_customer',NULL,'deny'),(161,5,'Magento_Reports::review_product',NULL,'deny'),(162,5,'Magento_Reports::salesroot',NULL,'deny'),(163,5,'Magento_Reports::salesroot_sales',NULL,'deny'),(164,5,'Magento_Reports::tax',NULL,'deny'),(165,5,'Magento_Reports::invoiced',NULL,'deny'),(166,5,'Magento_Reports::shipping',NULL,'deny'),(167,5,'Magento_Reports::refunded',NULL,'deny'),(168,5,'Magento_Reports::coupons',NULL,'deny'),(169,5,'Magento_Paypal::paypal_settlement_reports',NULL,'deny'),(170,5,'Magento_Paypal::paypal_settlement_reports_view',NULL,'deny'),(171,5,'Magento_Paypal::fetch',NULL,'deny'),(172,5,'PayPal_Braintree::settlement_report',NULL,'deny'),(173,5,'Magento_Reports::customers',NULL,'deny'),(174,5,'Magento_Reports::totals',NULL,'deny'),(175,5,'Magento_Reports::customers_orders',NULL,'deny'),(176,5,'Magento_Reports::accounts',NULL,'deny'),(177,5,'Magento_Reports::report_products',NULL,'deny'),(178,5,'Magento_Reports::viewed',NULL,'deny'),(179,5,'Magento_Reports::bestsellers',NULL,'deny'),(180,5,'Magento_Reports::lowstock',NULL,'deny'),(181,5,'Magento_Reports::sold',NULL,'deny'),(182,5,'Magento_Reports::downloads',NULL,'deny'),(183,5,'Magento_Reports::statistics',NULL,'deny'),(184,5,'Magento_Reports::statistics_refresh',NULL,'deny'),(185,5,'Magento_Analytics::business_intelligence',NULL,'deny'),(186,5,'Magento_Analytics::advanced_reporting',NULL,'deny'),(187,5,'Magento_Analytics::bi_essentials',NULL,'deny'),(188,5,'Magento_Backend::stores',NULL,'allow'),(189,5,'Magento_Backend::stores_settings',NULL,'allow'),(190,5,'Magento_Backend::store',NULL,'allow'),(191,5,'Magento_Config::config',NULL,'allow'),(192,5,'Magento_Cms::config_cms',NULL,'allow'),(193,5,'Magento_Catalog::config_catalog',NULL,'allow'),(194,5,'Magento_CatalogSearch::config_catalog_search',NULL,'allow'),(195,5,'Magento_CatalogInventory::cataloginventory',NULL,'allow'),(196,5,'Magento_Payment::payment',NULL,'allow'),(197,5,'Magento_Payment::payment_services',NULL,'allow'),(198,5,'Magento_Contact::contact',NULL,'allow'),(199,5,'Magento_Downloadable::downloadable',NULL,'allow'),(200,5,'Magento_Newsletter::newsletter',NULL,'allow'),(201,5,'Magento_GoogleAnalytics::google',NULL,'allow'),(202,5,'Magento_LoginAsCustomer::config_section',NULL,'allow'),(203,5,'Bss_ProductLabel::config_productlabel',NULL,'allow'),(204,5,'Bss_HyvaCompatBase::config',NULL,'allow'),(205,5,'Mirasvit_LayeredNavigation::navigation',NULL,'allow'),(206,5,'Mirasvit_LayeredNavigation::layered_navigation_group',NULL,'allow'),(207,5,'Hyva_ReactCheckout::config_hyva_react_checkout',NULL,'allow'),(208,5,'MagePal_Reindex::config_magepal_reindex',NULL,'allow'),(209,5,'Magecomp_Deleteorder::config_deleteorder',NULL,'allow'),(210,5,'Magecomp_Storepickup::storepickup_config',NULL,'allow'),(211,5,'Magefan_Community::config_section',NULL,'allow'),(212,5,'Mageplaza_Smtp::configuration',NULL,'allow'),(213,5,'Mageplaza_Smtp::email_marketing',NULL,'allow'),(214,5,'Ves_All::config',NULL,'allow'),(215,5,'Ves_Brand::config_brand',NULL,'allow'),(216,5,'Apptrian_Minify::config_system',NULL,'allow'),(217,5,'Magento_Shipping::carriers',NULL,'allow'),(218,5,'Magento_InventoryInStorePickupApi::inStorePickup',NULL,'allow'),(219,5,'Magento_InventoryInStorePickupApi::notify_orders_are_ready_for_pickup',NULL,'allow'),(220,5,'Magento_Shipping::config_shipping',NULL,'allow'),(221,5,'Magento_Shipping::shipping_policy',NULL,'allow'),(222,5,'Magento_Multishipping::config_multishipping',NULL,'allow'),(223,5,'Magento_ReCaptchaUi::config',NULL,'allow'),(224,5,'Magento_Securitytxt::config',NULL,'allow'),(225,5,'Bss_ProductAttachment::config_attachment',NULL,'allow'),(226,5,'Mageplaza_Core::configuration',NULL,'allow'),(227,5,'Mageplaza_Core::marketplace',NULL,'allow'),(228,5,'Magento_Config::config_general',NULL,'allow'),(229,5,'Magento_Integration::config_oauth',NULL,'allow'),(230,5,'Magento_Webapi::config_webapi',NULL,'allow'),(231,5,'Mirasvit_Core::core_settings',NULL,'allow'),(232,5,'Mirasvit_Core::validator',NULL,'allow'),(233,5,'Magefan_AdminUserGuide::configuration',NULL,'allow'),(234,5,'Magento_Config::web',NULL,'allow'),(235,5,'Magento_Config::config_design',NULL,'allow'),(236,5,'Magento_Customer::config_customer',NULL,'allow'),(237,5,'Magento_Paypal::paypal',NULL,'allow'),(238,5,'MagePsycho_MassImporterPro::config',NULL,'allow'),(239,5,'Magento_Tax::config_tax',NULL,'allow'),(240,5,'Magento_Checkout::checkout',NULL,'allow'),(241,5,'Magento_Sales::config_sales',NULL,'allow'),(242,5,'Magento_Persistent::persistent',NULL,'allow'),(243,5,'Bss_AjaxCart::config_ajaxcart',NULL,'allow'),(244,5,'Bss_FBT::config',NULL,'allow'),(245,5,'Magento_Sales::sales_email',NULL,'allow'),(246,5,'Magento_Sales::sales_pdf',NULL,'allow'),(247,5,'Magento_Reports::reports',NULL,'allow'),(248,5,'Magento_Sitemap::config_sitemap',NULL,'allow'),(249,5,'Bss_AjaxCart::api_ajaxcart',NULL,'allow'),(250,5,'MageWorx_GeoIP::config_geoip',NULL,'allow'),(251,5,'Magento_Config::config_system',NULL,'allow'),(252,5,'Magento_Wishlist::config_wishlist',NULL,'allow'),(253,5,'Bss_InfiniteScroll::config_infinitescroll',NULL,'allow'),(254,5,'Magento_SalesRule::config_promo',NULL,'allow'),(255,5,'MageWorx_ShippingRules::config_shippingrules',NULL,'allow'),(256,5,'MageWorx_Info::config_notification',NULL,'allow'),(257,5,'MageWorx_ShippingCalculatorBase::config_main',NULL,'allow'),(258,5,'MageWorx_Info::config_extensions',NULL,'allow'),(259,5,'MageWorx_Info::config_systeminfo_tab',NULL,'allow'),(260,5,'Magento_Config::config_admin',NULL,'allow'),(261,5,'Magento_Config::trans_email',NULL,'allow'),(262,5,'Magento_Config::dev',NULL,'allow'),(263,5,'Magento_Config::currency',NULL,'allow'),(264,5,'Magento_Rss::rss',NULL,'allow'),(265,5,'Magento_Config::sendfriend',NULL,'allow'),(266,5,'Magento_Csp::config',NULL,'allow'),(267,5,'Magento_Analytics::analytics_settings',NULL,'allow'),(268,5,'Mirasvit_SeoFilter::config_seofilter',NULL,'allow'),(269,5,'Mirasvit_SeoFilter::config_seo_filter_reset',NULL,'allow'),(270,5,'Mirasvit_LayeredNavigation::config_layerednavigation',NULL,'allow'),(271,5,'Mirasvit_Scroll::mst_scroll',NULL,'allow'),(272,5,'Mirasvit_AllProducts::config_all_products',NULL,'allow'),(273,5,'Mirasvit_Brand::config_brand',NULL,'allow'),(274,5,'Magento_NewRelicReporting::config_newrelicreporting',NULL,'allow'),(275,5,'Magento_CheckoutAgreements::checkoutagreement',NULL,'allow'),(276,5,'Magento_Sales::order_statuses',NULL,'allow'),(277,5,'Magento_InventoryApi::inventory',NULL,'allow'),(278,5,'Magento_InventoryApi::source',NULL,'allow'),(279,5,'Magento_InventoryApi::source_edit',NULL,'allow'),(280,5,'Magento_InventoryApi::ship_source_selection',NULL,'allow'),(281,5,'Magento_InventorySourceSelectionApi::source_selection_algorithm',NULL,'allow'),(282,5,'Magento_InventorySourceSelectionApi::source_selection_algorithm_post',NULL,'allow'),(283,5,'Magento_InventoryApi::stock',NULL,'allow'),(284,5,'Magento_InventoryApi::stock_edit',NULL,'allow'),(285,5,'Magento_InventoryApi::stock_delete',NULL,'allow'),(286,5,'Magento_InventoryLowQuantityNotificationApi::low_quantity_notification',NULL,'allow'),(287,5,'Magento_InventoryLowQuantityNotificationApi::stock_create_low_quantity_notification',NULL,'allow'),(288,5,'Magento_InventoryLowQuantityNotificationApi::stock_delete_low_quantity_notification',NULL,'allow'),(289,5,'Magento_InventoryApi::stock_source_link',NULL,'allow'),(290,5,'Magento_InventoryApi::stock_source_item_assign',NULL,'allow'),(291,5,'Magento_InventorySalesApi::stock',NULL,'allow'),(292,5,'Magento_Tax::manage_tax',NULL,'allow'),(293,5,'Magento_CurrencySymbol::system_currency',NULL,'allow'),(294,5,'Magento_CurrencySymbol::currency_rates',NULL,'allow'),(295,5,'Magento_CurrencySymbol::symbols',NULL,'allow'),(296,5,'MageWorx_GeoIP::geoip_relations_grid',NULL,'allow'),(297,5,'Magento_Backend::stores_attributes',NULL,'allow'),(298,5,'Magento_Catalog::attributes_attributes',NULL,'allow'),(299,5,'Magento_Catalog::sets',NULL,'allow'),(300,5,'Magento_Review::ratings',NULL,'allow'),(301,5,'Magento_Swatches::iframe',NULL,'allow'),(302,5,'MageWorx_ShippingRules::shippingrules',NULL,'allow'),(303,5,'MageWorx_ShippingRules::quote',NULL,'allow'),(304,5,'MageWorx_ShippingRules::edit_rules_conditions',NULL,'allow'),(305,5,'MageWorx_ShippingRules::carrier',NULL,'allow'),(306,5,'MageWorx_ShippingRules::zone',NULL,'allow'),(307,5,'MageWorx_ShippingRules::region',NULL,'allow'),(308,5,'MageWorx_ShippingRules::extended_zones',NULL,'allow'),(309,5,'Magento_Backend::stores_other_settings',NULL,'allow'),(310,5,'Mirasvit_Core::menu',NULL,'deny'),(311,5,'Magento_Backend::system',NULL,'deny'),(312,5,'Magento_AdobeIms::adobe_ims',NULL,'deny'),(313,5,'Magento_AdobeIms::actions',NULL,'deny'),(314,5,'Magento_AdobeIms::login',NULL,'deny'),(315,5,'Magento_AdobeIms::logout',NULL,'deny'),(316,5,'Magento_AdobeStockAsset::adobe_stock_asset',NULL,'deny'),(317,5,'Magento_AdobeStockAsset::actions',NULL,'deny'),(318,5,'Magento_AdobeStockAsset::actions_delete',NULL,'deny'),(319,5,'Magento_AdobeStockAsset::actions_save',NULL,'deny'),(320,5,'Magento_AdobeStockAsset::actions_view',NULL,'deny'),(321,5,'Magento_AdobeStockAsset::actions_get',NULL,'deny'),(322,5,'Magento_Backend::convert',NULL,'deny'),(323,5,'Magento_ImportExport::import',NULL,'deny'),(324,5,'Magento_ImportExport::export',NULL,'deny'),(325,5,'Magento_TaxImportExport::import_export',NULL,'deny'),(326,5,'Magento_ImportExport::history',NULL,'deny'),(327,5,'MageWorx_ShippingRules::import_export',NULL,'deny'),(328,5,'Magento_Backend::extensions',NULL,'deny'),(329,5,'Magento_Backend::local',NULL,'deny'),(330,5,'Magento_Backend::custom',NULL,'deny'),(331,5,'Magento_GraphQlServer::admin_graphql',NULL,'deny'),(332,5,'MagePsycho_MassImporterPro::menu_section',NULL,'deny'),(333,5,'MagePsycho_MipPricing::menu_manual_import',NULL,'deny'),(334,5,'MagePsycho_MipPricing::menu_manual_export',NULL,'deny'),(335,5,'MagePsycho_MassImporterPro::import',NULL,'deny'),(336,5,'MagePsycho_MassImporterPro::menu_config',NULL,'deny'),(337,5,'Magento_Integration::extensions',NULL,'deny'),(338,5,'Magento_Integration::integrations',NULL,'deny'),(339,5,'Magento_Backend::tools',NULL,'deny'),(340,5,'Magento_Backend::cache',NULL,'deny'),(341,5,'Magento_Backend::main_actions',NULL,'deny'),(342,5,'Magento_Backend::flush_cache_storage',NULL,'deny'),(343,5,'Magento_Backend::flush_magento_cache',NULL,'deny'),(344,5,'Magento_Backend::mass_actions',NULL,'deny'),(345,5,'Magento_Backend::toggling_cache_type',NULL,'deny'),(346,5,'Magento_Backend::refresh_cache_type',NULL,'deny'),(347,5,'Magento_Backend::additional_cache_management',NULL,'deny'),(348,5,'Magento_Backend::flush_catalog_images',NULL,'deny'),(349,5,'Magento_Backend::flush_js_css',NULL,'deny'),(350,5,'Magento_Backend::flush_static_files',NULL,'deny'),(351,5,'Magento_Backup::backup',NULL,'deny'),(352,5,'Magento_Backup::rollback',NULL,'deny'),(353,5,'Magento_Indexer::index',NULL,'deny'),(354,5,'Magento_Indexer::changeMode',NULL,'deny'),(355,5,'Magento_Indexer::invalidate',NULL,'deny'),(356,5,'Magento_User::acl',NULL,'deny'),(357,5,'Magento_User::acl_users',NULL,'deny'),(358,5,'Magento_User::locks',NULL,'deny'),(359,5,'Magento_User::acl_roles',NULL,'deny'),(360,5,'Magento_Logging::magento_logging',NULL,'deny'),(361,5,'Magento_Logging::magento_logging_events',NULL,'deny'),(362,5,'Magento_Logging::system_magento_logging_bulk_operations',NULL,'deny'),(363,5,'Magento_Backend::system_other_settings',NULL,'deny'),(364,5,'Magento_AdminNotification::adminnotification',NULL,'deny'),(365,5,'Magento_AdminNotification::show_toolbar',NULL,'deny'),(366,5,'Magento_AdminNotification::show_list',NULL,'deny'),(367,5,'Magento_AdminNotification::mark_as_read',NULL,'deny'),(368,5,'Magento_AdminNotification::adminnotification_remove',NULL,'deny'),(369,5,'Magento_Variable::variable',NULL,'deny'),(370,5,'Magento_EncryptionKey::crypt_key',NULL,'deny'),(371,5,'Magento_ServicesId::services',NULL,'deny'),(372,5,'Magento_ServicesId::configuration',NULL,'deny'),(373,5,'Magento_Backend::global_search',NULL,'deny'),(374,5,'Bss_ProductAttachment::product_attachment',NULL,'deny'),(375,5,'Bss_ProductAttachment::api',NULL,'deny');
/*!40000 ALTER TABLE `authorization_rule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `braintree_credit_prices`
--

DROP TABLE IF EXISTS `braintree_credit_prices`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `braintree_credit_prices` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Row ID',
  `product_id` int unsigned NOT NULL COMMENT 'Product Id',
  `term` int NOT NULL COMMENT 'Credit Term',
  `monthly_payment` decimal(12,2) NOT NULL COMMENT 'Monthly Payment',
  `instalment_rate` decimal(12,2) NOT NULL COMMENT 'Instalment Rate',
  `cost_of_purchase` decimal(12,2) NOT NULL COMMENT 'Cost of purchase',
  `total_inc_interest` decimal(12,2) NOT NULL COMMENT 'Total Inc Interest',
  PRIMARY KEY (`id`),
  UNIQUE KEY `BRAINTREE_CREDIT_PRICES_PRODUCT_ID_TERM` (`product_id`,`term`),
  KEY `BRAINTREE_CREDIT_PRICES_PRODUCT_ID` (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Braintree credit rates';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `braintree_credit_prices`
--

LOCK TABLES `braintree_credit_prices` WRITE;
/*!40000 ALTER TABLE `braintree_credit_prices` DISABLE KEYS */;
/*!40000 ALTER TABLE `braintree_credit_prices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `braintree_transaction_details`
--

DROP TABLE IF EXISTS `braintree_transaction_details`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `braintree_transaction_details` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `order_id` int unsigned NOT NULL COMMENT 'Order Id',
  `transaction_source` varchar(12) DEFAULT NULL COMMENT 'Transaction Source',
  PRIMARY KEY (`entity_id`),
  KEY `BRAINTREE_TRANSACTION_DETAILS_ORDER_ID` (`order_id`),
  CONSTRAINT `BRAINTREE_TRANSACTION_DETAILS_ORDER_ID_SALES_ORDER_ENTITY_ID` FOREIGN KEY (`order_id`) REFERENCES `sales_order` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Braintree transaction details table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `braintree_transaction_details`
--

LOCK TABLES `braintree_transaction_details` WRITE;
/*!40000 ALTER TABLE `braintree_transaction_details` DISABLE KEYS */;
/*!40000 ALTER TABLE `braintree_transaction_details` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bss_productattachment_file`
--

DROP TABLE IF EXISTS `bss_productattachment_file`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `bss_productattachment_file` (
  `file_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `title` text NOT NULL COMMENT 'Title',
  `description` text NOT NULL COMMENT 'Description',
  `status` smallint NOT NULL COMMENT 'Status',
  `type` smallint NOT NULL COMMENT 'Type',
  `uploaded_file` text NOT NULL COMMENT 'File Name',
  `size` int NOT NULL COMMENT 'Size',
  `store_id` text NOT NULL COMMENT 'Store View',
  `customer_group` text NOT NULL COMMENT 'Customer Group',
  `limit_time` int NOT NULL COMMENT 'Limit download',
  `position` int NOT NULL COMMENT 'Position',
  `downloaded_time` int NOT NULL COMMENT 'Downloaded Time',
  `show_footer` smallint NOT NULL COMMENT 'Show Footer',
  PRIMARY KEY (`file_id`),
  FULLTEXT KEY `BSS_PRODUCTATTACHMENT_FILE_TITLE_DESCRIPTION` (`title`,`description`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='bss_productattachment_file';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bss_productattachment_file`
--

LOCK TABLES `bss_productattachment_file` WRITE;
/*!40000 ALTER TABLE `bss_productattachment_file` DISABLE KEYS */;
/*!40000 ALTER TABLE `bss_productattachment_file` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bss_productlabel_flat`
--

DROP TABLE IF EXISTS `bss_productlabel_flat`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `bss_productlabel_flat` (
  `label_id` int unsigned NOT NULL COMMENT 'Label Id',
  `product_id` int unsigned NOT NULL COMMENT 'Product Id',
  `store_views` varchar(255) DEFAULT NULL COMMENT 'Store view',
  `image` varchar(255) DEFAULT NULL COMMENT 'Image',
  `image_data` varchar(255) DEFAULT NULL COMMENT 'Image data: width, height, angle, left-percent, top-percent',
  `customer_groups` varchar(255) DEFAULT NULL COMMENT 'Customer groups',
  `valid_start_date` timestamp NULL DEFAULT NULL COMMENT 'Start date apply',
  `valid_end_date` timestamp NULL DEFAULT NULL COMMENT 'Valid end date',
  `priority` int DEFAULT '0' COMMENT 'Priority',
  KEY `BSS_PRODUCTLABEL_FLAT_LABEL_ID` (`label_id`),
  KEY `BSS_PRODUCTLABEL_FLAT_PRODUCT_ID` (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Product Label Flat Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bss_productlabel_flat`
--

LOCK TABLES `bss_productlabel_flat` WRITE;
/*!40000 ALTER TABLE `bss_productlabel_flat` DISABLE KEYS */;
/*!40000 ALTER TABLE `bss_productlabel_flat` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bss_productlabel_label`
--

DROP TABLE IF EXISTS `bss_productlabel_label`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `bss_productlabel_label` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id',
  `name` varchar(255) NOT NULL COMMENT 'Label Name',
  `active` tinyint(1) NOT NULL COMMENT 'Active',
  `store_views` varchar(255) DEFAULT NULL COMMENT 'Store view',
  `image` varchar(255) DEFAULT NULL COMMENT 'Image',
  `image_data` varchar(255) DEFAULT NULL COMMENT 'Image data: width, height, angle, left-percent, top-percent',
  `customer_groups` varchar(255) DEFAULT NULL COMMENT 'Customer groups',
  `valid_start_date` timestamp NULL DEFAULT NULL COMMENT 'Start date apply',
  `valid_end_date` timestamp NULL DEFAULT NULL COMMENT 'Valid end date',
  `priority` int DEFAULT '0' COMMENT 'Priority',
  `apply_outofstock_product` tinyint(1) NOT NULL COMMENT 'Apply for out of stock product',
  `conditions_serialized` mediumtext COMMENT 'Conditions Serialized',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  PRIMARY KEY (`id`),
  KEY `BSS_PRODUCTLABEL_LABEL_ID` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8mb3 COMMENT='Product Label Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bss_productlabel_label`
--

LOCK TABLES `bss_productlabel_label` WRITE;
/*!40000 ALTER TABLE `bss_productlabel_label` DISABLE KEYS */;
INSERT INTO `bss_productlabel_label` VALUES (1,'Trending',0,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,'2024-11-14 04:26:01','2024-11-14 04:26:01'),(2,'Limited',0,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,'2024-11-14 04:26:01','2024-11-14 04:26:01'),(3,'Best Choice',0,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,'2024-11-14 04:26:01','2024-11-14 04:26:01'),(4,'Top 3',0,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,'2024-11-14 04:26:01','2024-11-14 04:26:01'),(5,'Top 5',0,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,'2024-11-14 04:26:01','2024-11-14 04:26:01'),(6,'10% sale',0,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,'2024-11-14 04:26:01','2024-11-14 04:26:01'),(7,'20% sale',0,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,'2024-11-14 04:26:01','2024-11-14 04:26:01'),(8,'50% sale',0,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,'2024-11-14 04:26:01','2024-11-14 04:26:01'),(9,'90% sale',0,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,'2024-11-14 04:26:01','2024-11-14 04:26:01'),(10,'Out of stock',0,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,'2024-11-14 04:26:01','2024-11-14 04:26:01');
/*!40000 ALTER TABLE `bss_productlabel_label` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache`
--

DROP TABLE IF EXISTS `cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cache` (
  `id` varchar(200) NOT NULL COMMENT 'Cache Id',
  `data` mediumblob COMMENT 'Cache Data',
  `create_time` int DEFAULT NULL COMMENT 'Cache Creation Time',
  `update_time` int DEFAULT NULL COMMENT 'Time of Cache Updating',
  `expire_time` int DEFAULT NULL COMMENT 'Cache Expiration Time',
  PRIMARY KEY (`id`),
  KEY `CACHE_EXPIRE_TIME` (`expire_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Caches';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache`
--

LOCK TABLES `cache` WRITE;
/*!40000 ALTER TABLE `cache` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_tag`
--

DROP TABLE IF EXISTS `cache_tag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cache_tag` (
  `tag` varchar(100) NOT NULL COMMENT 'Tag',
  `cache_id` varchar(200) NOT NULL COMMENT 'Cache Id',
  PRIMARY KEY (`tag`,`cache_id`),
  KEY `CACHE_TAG_CACHE_ID` (`cache_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Tag Caches';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_tag`
--

LOCK TABLES `cache_tag` WRITE;
/*!40000 ALTER TABLE `cache_tag` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_tag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `captcha_log`
--

DROP TABLE IF EXISTS `captcha_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `captcha_log` (
  `type` varchar(32) NOT NULL COMMENT 'Type',
  `value` varchar(255) NOT NULL COMMENT 'Value',
  `count` int unsigned NOT NULL DEFAULT '0' COMMENT 'Count',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Update Time',
  PRIMARY KEY (`type`,`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Count Login Attempts';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `captcha_log`
--

LOCK TABLES `captcha_log` WRITE;
/*!40000 ALTER TABLE `captcha_log` DISABLE KEYS */;
INSERT INTO `captcha_log` VALUES ('1','116.72.18.66',1,'2025-01-24 12:32:18'),('1','27.34.70.104',1,'2024-11-12 09:35:06'),('1','27.34.70.118',5,'2024-11-06 05:11:02'),('1','27.34.70.76',3,'2024-11-05 10:32:05'),('2','admin123',1,'2025-01-24 12:32:18'),('2','admin@gmail.com',1,'2024-11-05 10:16:31'),('2','amit',1,'2024-08-05 16:52:04'),('2','DataU',1,'2025-01-10 13:01:06'),('2','shakeel',10,'2024-11-04 11:48:10'),('2','shakeel@nexus-home.com',1,'2024-08-13 12:54:15'),('2','shakeel@nexus-nexus.com',1,'2024-08-13 12:53:40'),('2','sishamsingh999@gmail.com',8,'2024-11-12 09:35:06'),('2','UsamaJ',1,'2025-01-10 13:01:18'),('2','Zohaib',2,'2025-01-09 21:06:10'),('2','zohaib-new',2,'2025-01-31 13:36:39'),('2','zohaib1',2,'2025-01-09 10:07:18');
/*!40000 ALTER TABLE `captcha_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_entity`
--

DROP TABLE IF EXISTS `catalog_category_entity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_entity` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `attribute_set_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Set ID',
  `parent_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Parent Category ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Creation Time',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Update Time',
  `path` varchar(255) NOT NULL COMMENT 'Tree Path',
  `position` int NOT NULL COMMENT 'Position',
  `level` int NOT NULL DEFAULT '0' COMMENT 'Tree Level',
  `children_count` int NOT NULL COMMENT 'Child Count',
  PRIMARY KEY (`entity_id`),
  KEY `CATALOG_CATEGORY_ENTITY_LEVEL` (`level`),
  KEY `CATALOG_CATEGORY_ENTITY_PATH` (`path`)
) ENGINE=InnoDB AUTO_INCREMENT=451 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_entity`
--

LOCK TABLES `catalog_category_entity` WRITE;
/*!40000 ALTER TABLE `catalog_category_entity` DISABLE KEYS */;
INSERT INTO `catalog_category_entity` VALUES (1,3,0,'2024-08-05 09:21:14','2025-01-31 09:48:30','1',0,0,432),(2,3,1,'2024-08-05 09:21:14','2025-01-31 09:48:30','1/2',1,1,429),(3,3,2,'2024-08-08 09:52:20','2025-02-04 11:09:17','1/2/3',1,2,214),(4,3,3,'2024-08-08 09:53:35','2025-02-05 07:41:52','1/2/3/4',4,3,29),(5,3,2,'2024-08-08 09:54:31','2025-02-04 11:17:24','1/2/5',2,2,84),(6,3,7,'2024-08-08 09:54:59','2024-10-23 07:39:36','1/2/7/6',2,3,50),(7,3,2,'2024-08-08 09:55:44','2025-02-04 09:15:56','1/2/7',3,2,98),(8,3,3,'2024-08-08 09:56:29','2025-02-03 09:45:53','1/2/3/8',6,3,19),(9,3,3,'2024-08-08 09:57:10','2025-02-04 11:16:38','1/2/3/9',3,3,23),(10,3,2,'2024-08-08 09:57:39','2024-10-08 13:08:12','1/2/10',5,2,7),(11,3,2,'2024-08-08 09:58:09','2024-10-08 13:08:27','1/2/11',5,2,0),(12,3,2,'2024-08-08 09:58:39','2025-01-31 23:32:23','1/2/12',4,2,41),(15,3,219,'2024-08-13 12:30:42','2025-01-31 23:24:57','1/2/3/219/15',1,4,12),(16,3,15,'2024-08-13 12:33:48','2024-10-25 13:17:25','1/2/3/219/15/16',3,5,0),(17,3,15,'2024-08-13 12:35:22','2024-10-30 07:27:41','1/2/3/219/15/17',1,5,0),(18,3,15,'2024-08-13 12:46:23','2024-10-25 13:24:08','1/2/3/219/15/18',5,5,0),(20,3,15,'2024-08-13 13:12:56','2024-10-03 09:31:59','1/2/3/219/15/20',12,5,0),(21,3,15,'2024-08-13 13:13:35','2024-10-03 09:33:34','1/2/3/219/15/21',13,5,0),(22,3,15,'2024-08-13 13:14:22','2024-10-03 08:29:18','1/2/3/219/15/22',10,5,0),(23,3,203,'2024-08-13 13:16:38','2024-10-03 10:24:27','1/2/3/219/203/23',3,5,0),(24,3,15,'2024-08-13 13:18:14','2024-10-30 07:49:39','1/2/3/219/15/24',11,5,0),(25,3,3,'2024-08-13 13:19:25','2025-02-04 11:15:42','1/2/3/25',2,3,29),(26,3,221,'2024-08-13 13:34:47','2024-10-31 07:57:08','1/2/3/25/221/26',1,5,0),(27,3,221,'2024-08-13 13:35:51','2024-10-31 08:00:23','1/2/3/25/221/27',2,5,0),(28,3,221,'2024-08-13 13:37:07','2024-10-03 10:27:28','1/2/3/25/221/28',6,5,0),(29,3,221,'2024-08-13 13:37:46','2024-10-03 10:27:28','1/2/3/25/221/29',12,5,0),(30,3,221,'2024-08-13 13:38:21','2024-10-31 09:18:06','1/2/3/25/221/30',7,5,0),(31,3,221,'2024-08-13 13:47:01','2024-10-03 10:27:28','1/2/3/25/221/31',8,5,0),(32,3,221,'2024-08-13 13:51:59','2024-10-31 09:14:09','1/2/3/25/221/32',4,5,0),(33,3,221,'2024-08-13 14:26:47','2024-10-31 09:04:02','1/2/3/25/221/33',3,5,0),(34,3,221,'2024-08-13 14:27:48','2024-10-03 10:27:28','1/2/3/25/221/34',11,5,0),(35,3,226,'2024-08-13 14:28:37','2024-10-31 09:49:23','1/2/3/25/226/35',15,5,0),(36,3,226,'2024-08-13 14:29:07','2024-10-31 09:48:49','1/2/3/25/226/36',1,5,0),(37,3,3,'2024-08-13 14:32:20','2025-02-05 06:03:31','1/2/3/37',5,3,38),(38,3,253,'2024-08-13 14:52:00','2024-10-04 12:14:02','1/2/3/37/253/38',1,5,0),(39,3,253,'2024-08-13 14:52:29','2024-10-04 12:14:02','1/2/3/37/253/39',4,5,0),(40,3,253,'2024-08-13 14:53:08','2024-10-04 12:14:02','1/2/3/37/253/40',7,5,0),(41,3,253,'2024-08-13 14:53:36','2024-10-04 12:14:02','1/2/3/37/253/41',8,5,0),(42,3,253,'2024-08-13 14:54:04','2024-10-04 12:14:02','1/2/3/37/253/42',6,5,0),(43,3,253,'2024-08-13 14:54:33','2024-10-04 12:14:02','1/2/3/37/253/43',10,5,0),(44,3,182,'2024-08-13 14:55:03','2024-10-04 12:15:44','1/2/3/37/182/44',1,5,0),(45,3,182,'2024-08-13 14:57:53','2024-10-04 12:19:19','1/2/3/37/182/45',3,5,0),(46,3,3,'2024-08-13 14:59:22','2024-10-04 14:40:09','1/2/3/46',8,3,16),(47,3,295,'2024-08-13 15:01:30','2024-10-04 14:33:07','1/2/3/46/295/47',1,5,0),(48,3,295,'2024-08-13 15:02:32','2024-10-04 14:33:44','1/2/3/46/295/48',2,5,0),(49,3,295,'2024-08-13 15:05:51','2024-10-04 14:34:03','1/2/3/46/295/49',3,5,0),(50,3,295,'2024-08-13 15:06:43','2024-10-04 14:37:13','1/2/3/46/295/50',7,5,0),(51,3,3,'2024-08-13 15:07:30','2024-10-07 06:56:16','1/2/3/51',9,3,2),(52,3,51,'2024-08-13 15:07:59','2024-09-02 14:24:46','1/2/3/51/52',1,4,0),(53,3,51,'2024-08-13 15:13:15','2024-09-02 14:25:42','1/2/3/51/53',2,4,0),(54,3,3,'2024-08-13 15:14:10','2024-10-04 14:30:32','1/2/3/54',7,3,14),(55,3,54,'2024-08-13 15:14:41','2024-10-04 14:30:32','1/2/3/54/55',2,4,6),(56,3,54,'2024-08-13 15:15:44','2024-10-07 06:56:58','1/2/3/54/56',1,4,0),(57,3,3,'2024-08-13 15:17:23','2024-10-07 06:55:59','1/2/3/57',10,3,3),(58,3,57,'2024-08-13 15:21:04','2024-09-02 14:29:15','1/2/3/57/58',1,4,0),(59,3,57,'2024-08-13 15:23:13','2024-09-02 14:30:35','1/2/3/57/59',2,4,0),(60,3,226,'2024-08-13 15:23:41','2024-10-31 09:51:04','1/2/3/25/226/60',16,5,0),(61,3,57,'2024-08-13 15:24:11','2024-10-03 12:10:51','1/2/3/57/61',3,4,0),(62,3,3,'2024-08-13 15:26:33','2024-10-07 06:51:14','1/2/3/62',11,3,3),(63,3,62,'2024-08-13 15:28:47','2024-08-13 15:28:47','1/2/3/62/63',1,4,0),(64,3,62,'2024-08-13 15:29:17','2024-08-13 15:29:17','1/2/3/62/64',2,4,0),(65,3,62,'2024-08-13 15:29:49','2024-08-13 15:29:49','1/2/3/62/65',3,4,0),(66,3,4,'2024-08-15 07:29:39','2024-10-04 08:13:29','1/2/3/4/66',2,4,4),(67,3,66,'2024-08-15 07:31:44','2024-10-04 08:12:32','1/2/3/4/66/67',1,5,0),(68,3,66,'2024-08-15 07:32:08','2024-10-04 08:14:08','1/2/3/4/66/68',4,5,0),(69,3,66,'2024-08-15 07:32:31','2024-10-04 08:13:29','1/2/3/4/66/69',2,5,0),(70,3,66,'2024-08-15 07:37:36','2024-10-04 08:13:29','1/2/3/4/66/70',3,5,0),(71,3,4,'2024-08-15 07:46:39','2025-02-04 12:54:31','1/2/3/4/71',1,4,12),(72,3,71,'2024-08-15 08:07:36','2024-10-04 07:52:01','1/2/3/4/71/72',7,5,0),(73,3,71,'2024-08-15 08:11:15','2024-10-04 07:50:17','1/2/3/4/71/73',8,5,0),(74,3,71,'2024-08-15 08:52:31','2024-10-04 07:52:20','1/2/3/4/71/74',9,5,0),(75,3,71,'2024-08-15 09:29:54','2024-10-04 07:55:01','1/2/3/4/71/75',10,5,0),(76,3,71,'2024-08-15 09:31:34','2024-10-04 07:56:52','1/2/3/4/71/76',11,5,0),(77,3,71,'2024-08-15 10:37:22','2024-10-04 07:57:31','1/2/3/4/71/77',12,5,0),(78,3,71,'2024-08-15 10:37:46','2024-10-03 15:16:23','1/2/3/4/71/78',1,5,0),(79,3,71,'2024-08-15 10:38:30','2024-10-03 15:16:52','1/2/3/4/71/79',2,5,0),(80,3,71,'2024-08-15 10:39:12','2024-10-04 07:46:44','1/2/3/4/71/80',5,5,0),(81,3,71,'2024-08-15 10:40:47','2024-10-04 07:47:09','1/2/3/4/71/81',6,5,0),(82,3,4,'2024-08-15 10:42:40','2024-10-04 09:50:27','1/2/3/4/82',3,4,4),(83,3,82,'2024-08-15 10:43:19','2024-10-04 09:50:57','1/2/3/4/82/83',1,5,0),(84,3,82,'2024-08-15 10:44:10','2024-10-04 09:51:36','1/2/3/4/82/84',2,5,0),(85,3,82,'2024-08-15 10:44:57','2024-10-04 09:51:45','1/2/3/4/82/85',3,5,0),(86,3,82,'2024-08-15 10:47:05','2024-10-04 12:06:53','1/2/3/4/82/86',4,5,0),(87,3,343,'2024-08-15 11:23:08','2024-10-07 09:43:03','1/2/5/343/87',1,4,8),(88,3,87,'2024-08-15 11:23:29','2024-10-25 07:10:40','1/2/5/343/87/88',1,5,0),(89,3,87,'2024-08-15 11:26:04','2024-10-25 07:13:26','1/2/5/343/87/89',2,5,0),(90,3,87,'2024-08-15 11:28:08','2024-10-25 07:14:22','1/2/5/343/87/90',3,5,0),(91,3,87,'2024-08-15 11:40:34','2024-10-25 07:16:27','1/2/5/343/87/91',4,5,0),(92,3,87,'2024-08-15 11:57:07','2024-10-07 09:42:35','1/2/5/343/87/92',5,5,0),(93,3,87,'2024-08-15 12:02:34','2024-10-25 07:27:37','1/2/5/343/87/93',6,5,0),(94,3,87,'2024-08-15 12:02:57','2024-10-25 07:29:26','1/2/5/343/87/94',7,5,0),(95,3,87,'2024-08-15 12:03:39','2024-10-25 09:58:16','1/2/5/343/87/95',8,5,0),(96,3,343,'2024-08-15 12:05:09','2024-10-25 08:05:37','1/2/5/343/96',3,4,1),(97,3,96,'2024-08-15 12:05:30','2024-10-25 08:07:08','1/2/5/343/96/97',1,5,0),(98,3,343,'2024-08-15 12:09:04','2024-10-25 08:07:35','1/2/5/343/98',4,4,1),(99,3,98,'2024-08-15 12:09:27','2024-10-25 09:36:44','1/2/5/343/98/99',1,5,0),(100,3,343,'2024-08-15 12:13:24','2024-10-25 07:44:51','1/2/5/343/100',2,4,5),(101,3,100,'2024-08-15 12:14:06','2024-10-25 07:53:20','1/2/5/343/100/101',3,5,0),(102,3,100,'2024-08-15 12:17:06','2024-10-25 07:49:46','1/2/5/343/100/102',1,5,0),(103,3,100,'2024-08-15 12:17:47','2024-10-25 07:52:30','1/2/5/343/100/103',2,5,0),(104,3,100,'2024-08-15 12:43:52','2024-10-25 07:54:52','1/2/5/343/100/104',4,5,0),(105,3,100,'2024-08-15 12:44:29','2024-10-25 08:01:06','1/2/5/343/100/105',5,5,0),(106,3,318,'2024-08-15 12:45:44','2025-02-03 17:23:23','1/2/5/318/106',1,4,8),(107,3,106,'2024-08-15 12:48:21','2024-10-07 08:25:34','1/2/5/318/106/107',8,5,0),(108,3,313,'2024-08-15 12:52:45','2024-10-23 14:01:16','1/2/5/318/313/108',1,5,0),(109,3,106,'2024-08-15 12:54:01','2024-10-07 08:25:34','1/2/5/318/106/109',7,5,0),(110,3,319,'2024-08-15 12:56:02','2024-10-07 09:06:12','1/2/5/318/319/110',1,5,0),(111,3,6,'2024-08-16 10:32:00','2024-10-07 12:48:41','1/2/7/6/111',1,4,15),(112,3,111,'2024-08-16 10:37:35','2024-10-07 13:28:28','1/2/7/6/111/112',13,5,0),(113,3,111,'2024-08-16 10:38:47','2024-10-21 15:10:58','1/2/7/6/111/113',9,5,0),(114,3,111,'2024-08-16 10:39:11','2024-10-21 15:12:16','1/2/7/6/111/114',10,5,0),(115,3,111,'2024-08-16 10:39:41','2024-10-07 12:48:01','1/2/7/6/111/115',11,5,0),(116,3,111,'2024-08-16 10:40:07','2024-10-07 13:30:49','1/2/7/6/111/116',14,5,0),(117,3,111,'2024-08-16 10:40:51','2024-10-07 12:45:18','1/2/7/6/111/117',7,5,0),(118,3,111,'2024-08-16 10:41:17','2024-10-21 14:17:11','1/2/7/6/111/118',5,5,0),(119,3,111,'2024-08-16 10:42:10','2024-10-07 12:45:37','1/2/7/6/111/119',8,5,0),(120,3,111,'2024-08-16 10:43:17','2024-10-07 12:41:22','1/2/7/6/111/120',2,5,0),(121,3,111,'2024-08-16 10:45:22','2024-10-21 14:11:57','1/2/7/6/111/121',1,5,0),(122,3,111,'2024-08-16 10:46:38','2024-10-07 13:31:15','1/2/7/6/111/122',15,5,0),(123,3,111,'2024-08-16 10:47:23','2024-10-21 14:15:38','1/2/7/6/111/123',4,5,0),(124,3,6,'2024-08-16 10:51:07','2024-10-22 13:24:48','1/2/7/6/124',3,4,6),(125,3,124,'2024-08-16 10:53:13','2024-10-22 13:33:22','1/2/7/6/124/125',2,5,0),(126,3,124,'2024-08-16 10:53:38','2024-10-22 13:37:08','1/2/7/6/124/126',6,5,0),(127,3,124,'2024-08-16 10:57:38','2024-10-07 13:59:17','1/2/7/6/124/127',7,5,0),(128,3,124,'2024-08-16 10:58:36','2024-10-22 13:24:02','1/2/7/6/124/128',1,5,0),(129,3,6,'2024-08-16 11:02:57','2024-10-07 13:39:25','1/2/7/6/129',2,4,5),(130,3,129,'2024-08-16 11:03:22','2024-10-22 08:01:34','1/2/7/6/129/130',2,5,0),(132,3,129,'2024-08-16 11:10:14','2024-10-22 07:42:20','1/2/7/6/129/132',1,5,0),(133,3,129,'2024-08-16 11:11:57','2024-10-07 13:39:25','1/2/7/6/129/133',5,5,0),(134,3,6,'2024-08-16 11:12:38','2024-10-07 14:14:51','1/2/7/6/134',6,4,0),(135,3,367,'2024-08-16 11:14:23','2025-01-31 23:33:48','1/2/7/366/367/135',1,5,0),(136,3,367,'2024-08-16 11:14:49','2024-10-07 12:15:30','1/2/7/366/367/136',2,5,0),(137,3,367,'2024-08-16 11:21:11','2024-10-07 12:15:30','1/2/7/366/367/137',3,5,0),(138,3,367,'2024-08-16 11:24:56','2024-10-07 12:22:44','1/2/7/366/367/138',8,5,0),(139,3,367,'2024-08-16 11:26:36','2024-10-07 12:16:30','1/2/7/366/367/139',5,5,0),(140,3,367,'2024-08-16 11:28:16','2024-10-07 12:21:15','1/2/7/366/367/140',9,5,0),(141,3,367,'2024-08-16 11:28:45','2024-10-07 12:20:32','1/2/7/366/367/141',10,5,0),(142,3,366,'2024-08-16 11:30:13','2024-10-21 13:19:50','1/2/7/366/142',2,4,3),(143,3,142,'2024-08-16 11:34:04','2024-10-21 08:25:44','1/2/7/366/142/143',1,5,0),(144,3,142,'2024-08-16 11:41:32','2024-10-07 12:26:56','1/2/7/366/142/144',2,5,0),(145,3,5,'2024-08-16 11:47:41','2025-02-04 11:19:24','1/2/5/145',2,3,20),(146,3,145,'2024-08-16 11:50:29','2024-10-07 09:38:57','1/2/5/145/146',4,4,0),(147,3,329,'2024-08-16 11:52:52','2024-10-24 12:23:18','1/2/5/145/329/147',4,5,0),(148,3,329,'2024-08-16 11:55:49','2024-10-07 09:24:12','1/2/5/145/329/148',7,5,0),(149,3,145,'2024-08-16 11:56:45','2024-10-07 09:38:57','1/2/5/145/149',5,4,0),(150,3,8,'2024-08-16 11:58:03','2024-10-04 14:10:46','1/2/3/8/150',3,4,0),(151,3,159,'2024-08-16 11:59:55','2024-10-04 13:48:37','1/2/3/8/159/151',4,5,0),(152,3,8,'2024-08-16 12:00:44','2024-10-04 13:58:47','1/2/3/8/152',2,4,9),(153,3,152,'2024-08-16 12:02:23','2024-10-04 13:59:11','1/2/3/8/152/153',8,5,0),(154,3,152,'2024-08-16 12:04:57','2024-10-04 13:55:16','1/2/3/8/152/154',1,5,0),(155,3,152,'2024-08-16 12:10:33','2024-10-04 13:54:08','1/2/3/8/152/155',2,5,0),(156,3,152,'2024-08-16 12:54:39','2024-10-04 14:01:35','1/2/3/8/152/156',9,5,0),(157,3,152,'2024-08-16 12:56:42','2024-10-04 14:01:15','1/2/3/8/152/157',10,5,0),(158,3,152,'2024-08-16 12:58:03','2024-10-04 13:58:47','1/2/3/8/152/158',5,5,0),(159,3,8,'2024-08-16 13:03:39','2024-10-04 13:53:39','1/2/3/8/159',1,4,7),(160,3,159,'2024-08-16 13:04:15','2024-10-04 13:43:49','1/2/3/8/159/160',1,5,0),(161,3,159,'2024-08-16 13:09:30','2024-10-04 13:43:49','1/2/3/8/159/161',2,5,0),(162,3,159,'2024-08-16 13:09:53','2024-10-04 13:43:49','1/2/3/8/159/162',3,5,0),(163,3,2,'2024-08-20 10:15:03','2025-02-04 11:06:35','1/2/163',7,2,0),(164,3,2,'2024-08-20 10:56:14','2024-10-08 12:34:55','1/2/164',8,2,0),(165,3,9,'2024-09-23 12:35:56','2025-01-31 23:19:09','1/2/3/9/165',1,4,5),(166,3,165,'2024-09-23 12:39:04','2024-10-31 14:08:35','1/2/3/9/165/166',1,5,0),(167,3,165,'2024-09-23 12:41:55','2024-11-01 08:13:14','1/2/3/9/165/167',4,5,0),(168,3,165,'2024-09-23 12:42:53','2024-10-03 13:53:45','1/2/3/9/165/168',6,5,0),(169,3,9,'2024-09-23 12:43:36','2024-10-03 14:30:39','1/2/3/9/169',3,4,6),(170,3,9,'2024-09-23 12:46:25','2024-10-03 13:57:13','1/2/3/9/170',2,4,5),(171,3,170,'2024-09-23 12:50:48','2024-10-03 13:54:14','1/2/3/9/170/171',1,5,0),(172,3,170,'2024-09-23 12:51:15','2024-11-01 11:11:13','1/2/3/9/170/172',2,5,0),(173,3,170,'2024-09-23 12:52:17','2024-10-03 13:57:13','1/2/3/9/170/173',4,5,0),(174,3,170,'2024-09-23 12:52:55','2024-10-03 13:57:13','1/2/3/9/170/174',5,5,0),(175,3,169,'2024-09-23 12:53:56','2024-10-03 14:35:33','1/2/3/9/169/175',5,5,0),(176,3,165,'2024-09-23 12:54:47','2024-11-01 08:11:59','1/2/3/9/165/176',3,5,0),(177,3,169,'2024-09-23 12:59:15','2024-11-01 12:15:30','1/2/3/9/169/177',1,5,0),(178,3,169,'2024-09-23 13:00:38','2024-11-01 12:16:49','1/2/3/9/169/178',3,5,0),(179,3,169,'2024-09-23 13:02:45','2024-10-03 13:57:49','1/2/3/9/169/179',4,5,0),(180,3,169,'2024-09-23 13:46:02','2024-11-01 12:16:12','1/2/3/9/169/180',2,5,0),(181,3,169,'2024-09-23 13:48:14','2024-10-03 14:42:44','1/2/3/9/169/181',6,5,0),(182,3,37,'2024-09-23 15:38:54','2024-10-04 12:20:21','1/2/3/37/182',2,4,12),(183,3,182,'2024-09-23 15:39:33','2024-10-04 12:37:23','1/2/3/37/182/183',7,5,0),(184,3,182,'2024-09-23 15:40:31','2024-10-04 12:38:41','1/2/3/37/182/184',8,5,0),(185,3,182,'2024-09-23 15:41:17','2024-10-04 12:39:20','1/2/3/37/182/185',9,5,0),(186,3,182,'2024-09-24 07:29:24','2024-10-04 12:39:30','1/2/3/37/182/186',10,5,0),(187,3,203,'2024-09-24 07:30:18','2024-10-03 10:24:27','1/2/3/219/203/187',7,5,0),(188,3,182,'2024-09-24 07:31:08','2024-10-04 12:39:42','1/2/3/37/182/188',11,5,0),(189,3,182,'2024-09-24 07:32:19','2024-10-04 12:40:29','1/2/3/37/182/189',12,5,0),(190,3,226,'2024-09-24 07:33:42','2024-10-31 09:57:58','1/2/3/25/226/190',18,5,0),(191,3,10,'2024-09-24 07:34:28','2024-10-04 12:15:39','1/2/10/191',1,3,2),(192,3,191,'2024-09-24 07:34:50','2024-09-24 09:03:04','1/2/10/191/192',1,4,0),(193,3,191,'2024-09-24 07:48:40','2024-09-24 09:04:16','1/2/10/191/193',2,4,0),(194,3,10,'2024-09-24 07:49:31','2024-10-04 12:15:39','1/2/10/194',2,3,3),(195,3,194,'2024-09-24 07:50:41','2024-09-24 09:13:08','1/2/10/194/195',1,4,0),(196,3,194,'2024-09-24 08:02:55','2024-09-24 09:14:15','1/2/10/194/196',2,4,0),(197,3,194,'2024-09-24 08:03:55','2024-09-24 09:28:17','1/2/10/194/197',3,4,0),(198,3,15,'2024-10-02 15:45:47','2024-10-25 13:19:17','1/2/3/219/15/198',4,5,0),(199,3,15,'2024-10-02 15:46:26','2024-10-25 13:28:33','1/2/3/219/15/199',6,5,0),(200,3,15,'2024-10-02 15:49:18','2024-10-30 07:29:50','1/2/3/219/15/200',7,5,0),(201,3,15,'2024-10-02 15:50:23','2024-10-03 08:29:18','1/2/3/219/15/201',8,5,0),(202,3,15,'2024-10-02 15:52:26','2024-10-03 08:29:18','1/2/3/219/15/202',9,5,0),(203,3,219,'2024-10-03 08:07:02','2024-10-15 09:46:04','1/2/3/219/203',2,4,5),(204,3,203,'2024-10-03 08:07:38','2024-10-03 08:29:05','1/2/3/219/203/204',1,5,0),(205,3,203,'2024-10-03 08:07:49','2024-10-25 14:14:19','1/2/3/219/203/205',2,5,0),(208,3,203,'2024-10-03 08:09:35','2024-10-31 09:41:50','1/2/3/219/203/208',6,5,0),(209,3,219,'2024-10-03 08:14:20','2024-10-03 08:29:05','1/2/3/219/209',3,4,7),(210,3,209,'2024-10-03 08:14:42','2024-10-29 11:52:36','1/2/3/219/209/210',1,5,0),(211,3,209,'2024-10-03 08:15:02','2024-10-29 11:53:22','1/2/3/219/209/211',2,5,0),(212,3,209,'2024-10-03 08:15:15','2024-10-29 13:24:16','1/2/3/219/209/212',3,5,0),(213,3,209,'2024-10-03 08:15:35','2024-10-29 12:08:07','1/2/3/219/209/213',4,5,0),(214,3,209,'2024-10-03 08:15:50','2024-10-29 12:15:09','1/2/3/219/209/214',5,5,0),(215,3,209,'2024-10-03 08:16:16','2024-10-29 13:14:59','1/2/3/219/209/215',6,5,0),(216,3,209,'2024-10-03 08:16:26','2024-10-29 13:22:03','1/2/3/219/209/216',7,5,0),(219,3,3,'2024-10-03 08:26:53','2025-02-04 11:09:55','1/2/3/219',1,3,27),(221,3,25,'2024-10-03 09:16:23','2024-10-31 09:12:42','1/2/3/25/221',1,4,12),(222,3,221,'2024-10-03 09:17:20','2024-10-31 06:49:47','1/2/3/25/221/222',1,5,0),(223,3,221,'2024-10-03 09:19:13','2024-10-03 10:27:28','1/2/3/25/221/223',5,5,0),(224,3,221,'2024-10-03 09:28:14','2024-10-03 10:27:28','1/2/3/25/221/224',9,5,0),(225,3,221,'2024-10-03 09:28:28','2024-10-03 10:27:28','1/2/3/25/221/225',10,5,0),(226,3,25,'2024-10-03 09:36:48','2024-10-03 12:32:08','1/2/3/25/226',2,4,7),(227,3,226,'2024-10-03 12:16:36','2024-10-31 09:55:59','1/2/3/25/226/227',17,5,0),(229,3,226,'2024-10-03 12:32:08','2024-10-31 11:47:49','1/2/3/25/226/229',19,5,0),(230,3,25,'2024-10-03 12:34:03','2024-10-03 12:42:27','1/2/3/25/230',3,4,7),(231,3,230,'2024-10-03 12:37:31','2024-10-31 13:28:08','1/2/3/25/230/231',1,5,0),(232,3,230,'2024-10-03 12:38:33','2024-10-31 13:32:49','1/2/3/25/230/232',2,5,0),(233,3,230,'2024-10-03 12:40:08','2024-10-31 13:37:45','1/2/3/25/230/233',3,5,0),(234,3,230,'2024-10-03 12:40:24','2024-10-31 13:42:42','1/2/3/25/230/234',4,5,0),(235,3,230,'2024-10-03 12:41:16','2024-10-31 13:47:25','1/2/3/25/230/235',5,5,0),(236,3,230,'2024-10-03 12:42:15','2024-10-31 13:49:41','1/2/3/25/230/236',6,5,0),(237,3,230,'2024-10-03 12:42:27','2024-10-31 13:55:09','1/2/3/25/230/237',7,5,0),(238,3,165,'2024-10-03 13:53:30','2024-10-31 14:10:59','1/2/3/9/165/238',2,5,0),(239,3,170,'2024-10-03 13:57:07','2024-11-01 12:01:46','1/2/3/9/170/239',3,5,0),(240,3,9,'2024-10-03 14:45:24','2024-10-03 14:59:27','1/2/3/9/240',4,4,4),(241,3,240,'2024-10-03 14:58:30','2024-11-12 10:00:03','1/2/3/9/240/241',1,5,0),(242,3,240,'2024-10-03 14:59:07','2024-11-12 10:38:02','1/2/3/9/240/242',2,5,0),(243,3,240,'2024-10-03 14:59:17','2024-11-12 10:49:05','1/2/3/9/240/243',3,5,0),(244,3,240,'2024-10-03 14:59:27','2024-11-12 11:02:03','1/2/3/9/240/244',4,5,0),(245,3,71,'2024-10-04 07:44:35','2024-10-04 07:45:07','1/2/3/4/71/245',3,5,0),(246,3,71,'2024-10-04 07:44:57','2024-10-04 07:45:16','1/2/3/4/71/246',4,5,0),(247,3,4,'2024-10-04 12:07:40','2024-10-04 12:08:44','1/2/3/4/247',4,4,5),(248,3,247,'2024-10-04 12:07:53','2024-10-04 12:07:53','1/2/3/4/247/248',1,5,0),(249,3,247,'2024-10-04 12:08:11','2024-10-04 12:08:11','1/2/3/4/247/249',2,5,0),(250,3,247,'2024-10-04 12:08:22','2024-10-04 12:08:22','1/2/3/4/247/250',3,5,0),(251,3,247,'2024-10-04 12:08:34','2024-10-04 12:08:34','1/2/3/4/247/251',4,5,0),(252,3,247,'2024-10-04 12:08:44','2024-10-04 12:08:44','1/2/3/4/247/252',5,5,0),(253,3,37,'2024-10-04 12:09:34','2025-02-04 11:22:07','1/2/3/37/253',1,4,10),(254,3,253,'2024-10-04 12:10:06','2024-10-04 12:14:02','1/2/3/37/253/254',2,5,0),(255,3,253,'2024-10-04 12:10:18','2024-10-04 12:14:02','1/2/3/37/253/255',3,5,0),(256,3,253,'2024-10-04 12:10:50','2024-10-04 12:14:02','1/2/3/37/253/256',5,5,0),(257,3,253,'2024-10-04 12:11:29','2024-10-04 12:14:02','1/2/3/37/253/257',9,5,0),(258,3,182,'2024-10-04 12:18:48','2024-10-04 12:18:56','1/2/3/37/182/258',2,5,0),(259,3,182,'2024-10-04 12:19:43','2024-10-04 12:20:16','1/2/3/37/182/259',4,5,0),(260,3,182,'2024-10-04 12:19:53','2024-10-04 12:20:19','1/2/3/37/182/260',5,5,0),(261,3,182,'2024-10-04 12:20:04','2024-10-04 12:20:21','1/2/3/37/182/261',6,5,0),(262,3,37,'2024-10-04 13:29:06','2024-10-04 13:42:21','1/2/3/37/262',3,4,13),(263,3,262,'2024-10-04 13:29:26','2024-10-04 13:32:29','1/2/3/37/262/263',1,5,0),(264,3,262,'2024-10-04 13:29:34','2024-10-04 13:32:29','1/2/3/37/262/264',2,5,0),(265,3,262,'2024-10-04 13:29:46','2024-10-04 13:32:29','1/2/3/37/262/265',3,5,0),(266,3,262,'2024-10-04 13:33:12','2024-10-04 13:33:12','1/2/3/37/262/266',4,5,0),(267,3,262,'2024-10-04 13:36:16','2024-10-04 13:36:16','1/2/3/37/262/267',5,5,0),(268,3,262,'2024-10-04 13:36:29','2024-10-04 13:36:29','1/2/3/37/262/268',6,5,0),(269,3,262,'2024-10-04 13:37:41','2024-10-04 13:37:41','1/2/3/37/262/269',7,5,0),(270,3,262,'2024-10-04 13:38:11','2024-10-04 13:38:11','1/2/3/37/262/270',8,5,0),(271,3,262,'2024-10-04 13:38:28','2024-10-04 13:38:28','1/2/3/37/262/271',9,5,0),(272,3,262,'2024-10-04 13:39:45','2024-10-04 13:39:45','1/2/3/37/262/272',10,5,0),(273,3,262,'2024-10-04 13:41:46','2024-10-04 13:41:46','1/2/3/37/262/273',11,5,0),(274,3,262,'2024-10-04 13:42:01','2024-10-04 13:42:01','1/2/3/37/262/274',12,5,0),(275,3,262,'2024-10-04 13:42:21','2024-10-04 13:42:21','1/2/3/37/262/275',13,5,0),(276,3,159,'2024-10-04 13:48:49','2024-10-04 13:48:49','1/2/3/8/159/276',5,5,0),(277,3,159,'2024-10-04 13:49:05','2024-10-04 13:49:05','1/2/3/8/159/277',6,5,0),(278,3,159,'2024-10-04 13:53:39','2024-10-04 13:53:39','1/2/3/8/159/278',7,5,0),(279,3,152,'2024-10-04 13:56:12','2024-10-04 13:56:41','1/2/3/8/152/279',3,5,0),(280,3,152,'2024-10-04 13:57:12','2024-10-04 13:58:07','1/2/3/8/152/280',4,5,0),(282,3,152,'2024-10-04 13:57:52','2024-10-04 13:58:47','1/2/3/8/152/282',7,5,0),(283,3,55,'2024-10-04 14:22:33','2024-10-04 14:22:33','1/2/3/54/55/283',1,5,0),(284,3,55,'2024-10-04 14:22:46','2024-10-04 14:22:46','1/2/3/54/55/284',2,5,0),(285,3,55,'2024-10-04 14:23:36','2024-10-04 14:23:36','1/2/3/54/55/285',3,5,0),(286,3,55,'2024-10-04 14:23:52','2024-10-04 14:23:52','1/2/3/54/55/286',4,5,0),(287,3,55,'2024-10-04 14:26:26','2024-10-04 14:26:26','1/2/3/54/55/287',5,5,0),(288,3,55,'2024-10-04 14:26:35','2024-10-04 14:26:35','1/2/3/54/55/288',6,5,0),(289,3,54,'2024-10-04 14:26:50','2024-10-04 14:30:32','1/2/3/54/289',3,4,5),(290,3,289,'2024-10-04 14:27:00','2024-10-04 14:44:33','1/2/3/54/289/290',1,5,0),(291,3,289,'2024-10-04 14:27:13','2024-10-04 14:27:13','1/2/3/54/289/291',2,5,0),(292,3,289,'2024-10-04 14:27:25','2024-10-04 14:27:25','1/2/3/54/289/292',3,5,0),(293,3,289,'2024-10-04 14:27:38','2024-10-04 14:27:38','1/2/3/54/289/293',4,5,0),(294,3,289,'2024-10-04 14:28:07','2024-10-04 14:28:07','1/2/3/54/289/294',5,5,0),(295,3,46,'2024-10-04 14:31:54','2024-10-04 14:37:37','1/2/3/46/295',1,4,9),(296,3,295,'2024-10-04 14:36:40','2024-10-04 14:37:13','1/2/3/46/295/296',4,5,0),(297,3,295,'2024-10-04 14:36:51','2024-10-04 14:37:13','1/2/3/46/295/297',5,5,0),(298,3,295,'2024-10-04 14:37:02','2024-10-04 14:37:13','1/2/3/46/295/298',6,5,0),(299,3,295,'2024-10-04 14:37:22','2024-10-04 14:37:22','1/2/3/46/295/299',8,5,0),(300,3,295,'2024-10-04 14:37:37','2024-10-04 14:37:37','1/2/3/46/295/300',9,5,0),(301,3,46,'2024-10-04 14:38:02','2024-10-04 14:40:09','1/2/3/46/301',2,4,5),(302,3,301,'2024-10-04 14:38:26','2024-10-04 14:38:27','1/2/3/46/301/302',1,5,0),(303,3,301,'2024-10-04 14:38:53','2024-10-04 14:38:53','1/2/3/46/301/303',2,5,0),(304,3,301,'2024-10-04 14:39:04','2024-10-04 14:39:04','1/2/3/46/301/304',3,5,0),(305,3,301,'2024-10-04 14:39:14','2024-10-04 14:39:14','1/2/3/46/301/305',4,5,0),(306,3,301,'2024-10-04 14:40:09','2024-10-04 14:40:09','1/2/3/46/301/306',5,5,0),(307,3,106,'2024-10-07 07:25:04','2025-02-03 17:23:32','1/2/5/318/106/307',1,5,0),(308,3,106,'2024-10-07 07:25:17','2024-10-23 09:39:49','1/2/5/318/106/308',2,5,0),(309,3,106,'2024-10-07 07:25:29','2024-10-23 10:12:08','1/2/5/318/106/309',3,5,0),(310,3,106,'2024-10-07 07:26:03','2024-10-23 10:13:40','1/2/5/318/106/310',4,5,0),(311,3,106,'2024-10-07 07:26:14','2024-10-23 10:28:58','1/2/5/318/106/311',5,5,0),(312,3,106,'2024-10-07 07:27:02','2024-10-23 10:32:08','1/2/5/318/106/312',6,5,0),(313,3,318,'2024-10-07 07:31:16','2024-10-23 10:34:43','1/2/5/318/313',2,4,5),(314,3,313,'2024-10-07 07:32:16','2024-10-23 14:06:24','1/2/5/318/313/314',2,5,0),(315,3,313,'2024-10-07 07:32:29','2024-10-23 14:09:37','1/2/5/318/313/315',3,5,0),(316,3,313,'2024-10-07 07:32:57','2024-10-07 07:34:44','1/2/5/318/313/316',4,5,0),(317,3,313,'2024-10-07 07:33:22','2024-10-07 07:34:44','1/2/5/318/313/317',5,5,0),(318,3,5,'2024-10-07 07:34:34','2025-02-05 07:05:52','1/2/5/318',1,3,25),(319,3,318,'2024-10-07 07:40:27','2024-10-07 08:26:41','1/2/5/318/319',3,4,3),(321,3,319,'2024-10-07 07:58:19','2024-10-07 08:25:15','1/2/5/318/319/321',3,5,0),(322,3,319,'2024-10-07 08:01:53','2024-10-23 14:49:22','1/2/5/318/319/322',4,5,0),(323,3,318,'2024-10-07 08:07:46','2024-10-07 08:18:05','1/2/5/318/323',4,4,5),(324,3,323,'2024-10-07 08:09:13','2024-10-24 13:12:28','1/2/5/318/323/324',1,5,0),(325,3,323,'2024-10-07 08:10:56','2024-10-24 15:14:09','1/2/5/318/323/325',2,5,0),(326,3,323,'2024-10-07 08:13:05','2024-10-24 14:01:45','1/2/5/318/323/326',3,5,0),(327,3,323,'2024-10-07 08:14:04','2024-10-24 13:16:29','1/2/5/318/323/327',4,5,0),(328,3,323,'2024-10-07 08:18:05','2024-10-24 13:17:59','1/2/5/318/323/328',5,5,0),(329,3,145,'2024-10-07 08:24:29','2024-10-24 10:02:54','1/2/5/145/329',1,4,7),(330,3,329,'2024-10-07 09:07:15','2024-10-24 10:10:02','1/2/5/145/329/330',1,5,0),(331,3,329,'2024-10-07 09:09:30','2024-10-24 12:22:46','1/2/5/145/329/331',2,5,0),(332,3,329,'2024-10-07 09:12:28','2024-10-07 09:12:28','1/2/5/145/329/332',3,5,0),(335,3,329,'2024-10-07 09:15:38','2024-10-07 09:21:20','1/2/5/145/329/335',8,5,0),(336,3,329,'2024-10-07 09:16:53','2024-10-24 13:00:28','1/2/5/145/329/336',9,5,0),(337,3,145,'2024-10-07 09:28:07','2024-10-07 09:38:57','1/2/5/145/337',3,4,5),(338,3,337,'2024-10-07 09:29:58','2024-10-24 13:19:13','1/2/5/145/337/338',1,5,0),(339,3,337,'2024-10-07 09:30:44','2024-10-24 13:42:13','1/2/5/145/337/339',2,5,0),(340,3,337,'2024-10-07 09:32:25','2024-10-24 15:12:06','1/2/5/145/337/340',3,5,0),(341,3,337,'2024-10-07 09:32:48','2024-10-24 15:27:51','1/2/5/145/337/341',4,5,0),(342,3,337,'2024-10-07 09:33:17','2024-10-24 15:32:38','1/2/5/145/337/342',5,5,0),(343,3,5,'2024-10-07 09:35:03','2025-02-05 07:22:38','1/2/5/343',3,3,27),(344,3,145,'2024-10-07 09:38:51','2024-10-07 09:40:21','1/2/5/145/344',2,4,3),(345,3,344,'2024-10-07 09:39:09','2024-10-24 13:01:43','1/2/5/145/344/345',1,5,0),(346,3,344,'2024-10-07 09:39:56','2025-02-04 08:38:51','1/2/5/145/344/346',2,5,0),(347,3,344,'2024-10-07 09:40:21','2024-10-07 09:40:21','1/2/5/145/344/347',3,5,0),(348,3,343,'2024-10-07 09:55:47','2024-10-07 09:59:41','1/2/5/343/348',5,4,1),(349,3,348,'2024-10-07 09:59:41','2024-10-28 07:23:50','1/2/5/343/348/349',1,5,0),(350,3,343,'2024-10-07 10:02:32','2024-10-07 10:12:07','1/2/5/343/350',6,4,5),(351,3,350,'2024-10-07 10:03:05','2024-10-25 09:38:05','1/2/5/343/350/351',1,5,0),(352,3,350,'2024-10-07 10:04:21','2024-10-25 09:38:22','1/2/5/343/350/352',2,5,0),(353,3,350,'2024-10-07 10:10:12','2024-10-25 09:39:08','1/2/5/343/350/353',3,5,0),(354,3,350,'2024-10-07 10:11:00','2024-10-25 09:40:19','1/2/5/343/350/354',4,5,0),(355,3,350,'2024-10-07 10:12:07','2024-10-25 09:43:41','1/2/5/343/350/355',5,5,0),(356,3,5,'2024-10-07 10:14:31','2024-10-07 12:12:44','1/2/5/356',4,3,8),(358,3,356,'2024-10-07 12:06:25','2024-10-07 12:12:44','1/2/5/356/358',1,4,7),(359,3,358,'2024-10-07 12:08:06','2024-10-24 15:34:04','1/2/5/356/358/359',1,5,0),(360,3,358,'2024-10-07 12:09:11','2024-10-24 15:35:15','1/2/5/356/358/360',2,5,0),(361,3,358,'2024-10-07 12:10:40','2024-10-24 15:35:38','1/2/5/356/358/361',3,5,0),(362,3,358,'2024-10-07 12:11:24','2024-10-24 15:35:53','1/2/5/356/358/362',4,5,0),(363,3,358,'2024-10-07 12:11:58','2024-10-07 12:11:58','1/2/5/356/358/363',5,5,0),(364,3,358,'2024-10-07 12:12:14','2024-10-07 12:12:14','1/2/5/356/358/364',6,5,0),(365,3,358,'2024-10-07 12:12:44','2024-10-28 07:06:27','1/2/5/356/358/365',7,5,0),(366,3,7,'2024-10-07 12:14:09','2025-02-04 09:16:30','1/2/7/366',1,3,21),(367,3,366,'2024-10-07 12:14:30','2025-01-31 23:39:20','1/2/7/366/367',1,4,10),(368,3,367,'2024-10-07 12:16:21','2024-10-21 07:49:15','1/2/7/366/367/368',4,5,0),(369,3,367,'2024-10-07 12:16:52','2024-10-07 12:17:00','1/2/7/366/367/369',6,5,0),(370,3,367,'2024-10-07 12:17:52','2024-10-21 07:55:17','1/2/7/366/367/370',7,5,0),(371,3,142,'2024-10-07 12:26:16','2024-10-21 10:47:16','1/2/7/366/142/371',3,5,0),(372,3,366,'2024-10-07 12:27:10','2024-10-07 12:33:16','1/2/7/366/372',3,4,5),(373,3,372,'2024-10-07 12:28:45','2024-10-21 10:59:37','1/2/7/366/372/373',1,5,0),(374,3,372,'2024-10-07 12:29:24','2024-10-21 11:07:37','1/2/7/366/372/374',2,5,0),(375,3,372,'2024-10-07 12:31:23','2024-10-21 12:53:15','1/2/7/366/372/375',3,5,0),(376,3,372,'2024-10-07 12:31:56','2024-10-21 12:57:40','1/2/7/366/372/376',4,5,0),(377,3,372,'2024-10-07 12:33:16','2024-10-21 13:02:36','1/2/7/366/372/377',5,5,0),(378,3,111,'2024-10-07 12:44:04','2024-10-07 12:44:16','1/2/7/6/111/378',3,5,0),(379,3,111,'2024-10-07 12:44:58','2024-10-21 14:57:33','1/2/7/6/111/379',6,5,0),(380,3,111,'2024-10-07 12:48:26','2024-10-07 12:48:41','1/2/7/6/111/380',12,5,0),(381,3,129,'2024-10-07 13:37:45','2024-10-22 08:02:49','1/2/7/6/129/381',3,5,0),(382,3,129,'2024-10-07 13:39:18','2024-10-22 08:04:23','1/2/7/6/129/382',4,5,0),(383,3,124,'2024-10-07 13:58:18','2024-10-22 13:34:25','1/2/7/6/124/383',4,5,0),(384,3,124,'2024-10-07 13:58:50','2024-10-07 13:59:17','1/2/7/6/124/384',5,5,0),(385,3,6,'2024-10-07 14:03:36','2024-10-23 07:39:36','1/2/7/6/385',4,4,3),(386,3,385,'2024-10-07 14:03:55','2024-10-22 14:28:07','1/2/7/6/385/386',1,5,0),(387,3,385,'2024-10-07 14:10:25','2024-10-23 07:30:56','1/2/7/6/385/387',2,5,0),(388,3,6,'2024-10-07 14:14:10','2024-10-07 14:14:51','1/2/7/6/388',5,4,1),(389,3,388,'2024-10-07 14:14:27','2024-10-07 14:14:27','1/2/7/6/388/389',1,5,0),(390,3,6,'2024-10-07 14:16:44','2024-10-08 11:30:50','1/2/7/6/390',7,4,13),(391,3,390,'2024-10-07 14:17:14','2024-10-07 14:17:14','1/2/7/6/390/391',1,5,0),(392,3,390,'2024-10-07 14:19:39','2024-10-08 11:11:22','1/2/7/6/390/392',3,5,0),(393,3,390,'2024-10-07 14:24:57','2024-10-08 11:11:22','1/2/7/6/390/393',4,5,0),(394,3,390,'2024-10-07 14:27:20','2024-10-08 11:11:22','1/2/7/6/390/394',5,5,0),(395,3,390,'2024-10-07 14:33:21','2024-10-08 11:11:22','1/2/7/6/390/395',6,5,0),(396,3,390,'2024-10-07 14:34:49','2024-10-08 11:11:22','1/2/7/6/390/396',7,5,0),(397,3,390,'2024-10-07 14:35:11','2024-10-08 11:11:22','1/2/7/6/390/397',8,5,0),(398,3,390,'2024-10-07 14:35:27','2024-10-08 11:11:22','1/2/7/6/390/398',9,5,0),(399,3,390,'2024-10-07 14:35:55','2024-10-08 11:11:22','1/2/7/6/390/399',2,5,0),(400,3,390,'2024-10-07 14:36:10','2024-10-08 11:11:22','1/2/7/6/390/400',10,5,0),(401,3,390,'2024-10-08 11:24:52','2024-10-08 11:24:53','1/2/7/6/390/401',11,5,0),(402,3,390,'2024-10-08 11:25:56','2024-10-08 11:25:56','1/2/7/6/390/402',12,5,0),(403,3,390,'2024-10-08 11:30:50','2024-10-08 11:30:51','1/2/7/6/390/403',13,5,0),(404,3,12,'2024-10-08 11:59:02','2024-10-18 12:17:52','1/2/12/404',1,3,8),(405,3,404,'2024-10-08 11:59:35','2024-10-18 12:17:52','1/2/12/404/405',2,4,0),(406,3,404,'2024-10-08 12:00:51','2024-10-18 12:27:42','1/2/12/404/406',3,4,0),(407,3,404,'2024-10-08 12:01:45','2024-10-18 14:22:55','1/2/12/404/407',4,4,0),(408,3,404,'2024-10-08 12:03:07','2024-10-18 15:10:40','1/2/12/404/408',5,4,0),(409,3,404,'2024-10-08 12:04:58','2024-10-18 15:12:38','1/2/12/404/409',6,4,0),(410,3,404,'2024-10-08 12:06:05','2024-10-18 15:12:57','1/2/12/404/410',7,4,0),(411,3,404,'2024-10-08 12:07:30','2024-10-18 15:14:39','1/2/12/404/411',8,4,0),(412,3,12,'2024-10-08 12:08:23','2024-10-08 12:21:42','1/2/12/412',2,3,15),(413,3,412,'2024-10-08 12:08:33','2024-10-18 15:15:03','1/2/12/412/413',1,4,0),(414,3,412,'2024-10-08 12:10:06','2024-10-18 15:18:40','1/2/12/412/414',2,4,0),(415,3,412,'2024-10-08 12:10:57','2024-10-18 15:21:18','1/2/12/412/415',3,4,0),(416,3,412,'2024-10-08 12:11:38','2024-10-18 15:21:43','1/2/12/412/416',4,4,0),(417,3,412,'2024-10-08 12:13:13','2024-10-18 15:22:10','1/2/12/412/417',5,4,0),(418,3,412,'2024-10-08 12:14:29','2024-10-18 15:28:02','1/2/12/412/418',6,4,0),(419,3,412,'2024-10-08 12:15:12','2024-10-18 15:28:27','1/2/12/412/419',7,4,0),(420,3,412,'2024-10-08 12:15:49','2024-10-18 15:29:17','1/2/12/412/420',8,4,0),(421,3,412,'2024-10-08 12:16:19','2024-10-08 12:16:19','1/2/12/412/421',9,4,0),(422,3,412,'2024-10-08 12:17:23','2024-10-18 15:30:16','1/2/12/412/422',10,4,0),(423,3,412,'2024-10-08 12:18:40','2024-10-08 12:18:40','1/2/12/412/423',11,4,0),(424,3,412,'2024-10-08 12:18:54','2024-10-18 15:33:49','1/2/12/412/424',12,4,0),(425,3,412,'2024-10-08 12:20:19','2024-10-18 15:34:41','1/2/12/412/425',13,4,0),(426,3,412,'2024-10-08 12:21:15','2024-10-18 15:36:04','1/2/12/412/426',14,4,0),(427,3,412,'2024-10-08 12:21:42','2024-10-18 15:36:30','1/2/12/412/427',15,4,0),(428,3,12,'2024-10-08 12:23:06','2024-10-08 12:29:00','1/2/12/428',3,3,9),(429,3,428,'2024-10-08 12:23:55','2024-10-21 07:18:16','1/2/12/428/429',1,4,0),(430,3,428,'2024-10-08 12:24:11','2024-10-21 07:26:58','1/2/12/428/430',2,4,0),(431,3,428,'2024-10-08 12:25:02','2024-10-21 07:27:29','1/2/12/428/431',3,4,0),(432,3,428,'2024-10-08 12:25:50','2024-10-21 07:28:40','1/2/12/428/432',4,4,0),(433,3,428,'2024-10-08 12:26:20','2024-10-21 07:30:04','1/2/12/428/433',5,4,0),(434,3,428,'2024-10-08 12:26:33','2024-10-21 07:31:01','1/2/12/428/434',6,4,0),(435,3,428,'2024-10-08 12:27:34','2024-10-21 07:32:50','1/2/12/428/435',7,4,0),(436,3,428,'2024-10-08 12:28:19','2024-10-21 07:33:49','1/2/12/428/436',8,4,0),(437,3,428,'2024-10-08 12:29:00','2024-10-21 07:34:29','1/2/12/428/437',9,4,0),(438,3,12,'2024-10-08 12:29:23','2024-10-08 12:32:43','1/2/12/438',4,3,5),(439,3,438,'2024-10-08 12:29:56','2024-10-21 07:35:04','1/2/12/438/439',1,4,0),(440,3,438,'2024-10-08 12:30:34','2024-10-21 07:40:39','1/2/12/438/440',2,4,0),(441,3,438,'2024-10-08 12:30:53','2024-10-21 07:38:31','1/2/12/438/441',3,4,0),(442,3,438,'2024-10-08 12:32:23','2024-10-21 07:39:10','1/2/12/438/442',4,4,0),(443,3,438,'2024-10-08 12:32:43','2024-10-21 07:39:34','1/2/12/438/443',5,4,0),(444,3,404,'2024-10-18 12:17:17','2024-10-18 12:18:09','1/2/12/404/444',1,4,0),(445,3,385,'2024-10-23 07:39:36','2024-10-23 07:41:33','1/2/7/6/385/445',3,5,0),(446,3,1,'2025-01-30 15:20:51','2025-01-30 15:22:01','1/446',2,1,1),(447,3,446,'2025-01-30 15:22:01','2025-01-30 15:22:01','1/446/447',1,2,0),(449,3,2,'2025-01-30 15:23:57','2025-01-31 09:47:57','1/2/449',9,2,0);
/*!40000 ALTER TABLE `catalog_category_entity` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_category_entity_after_insert` AFTER INSERT ON `catalog_category_entity` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalog_category_product_cl` (`entity_id`) VALUES (NEW.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_category_entity_after_update` AFTER UPDATE ON `catalog_category_entity` FOR EACH ROW BEGIN
IF (NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`attribute_set_id` <=> OLD.`attribute_set_id`) OR NOT(NEW.`parent_id` <=> OLD.`parent_id`) OR NOT(NEW.`created_at` <=> OLD.`created_at`) OR NOT(NEW.`path` <=> OLD.`path`) OR NOT(NEW.`position` <=> OLD.`position`) OR NOT(NEW.`level` <=> OLD.`level`) OR NOT(NEW.`children_count` <=> OLD.`children_count`)) THEN INSERT IGNORE INTO `catalog_category_product_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_category_entity_after_delete` AFTER DELETE ON `catalog_category_entity` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalog_category_product_cl` (`entity_id`) VALUES (OLD.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `catalog_category_entity_datetime`
--

DROP TABLE IF EXISTS `catalog_category_entity_datetime`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_entity_datetime` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` datetime DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CATALOG_CATEGORY_ENTITY_DATETIME_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `CATALOG_CATEGORY_ENTITY_DATETIME_ENTITY_ID` (`entity_id`),
  KEY `CATALOG_CATEGORY_ENTITY_DATETIME_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_CATEGORY_ENTITY_DATETIME_STORE_ID` (`store_id`),
  CONSTRAINT `CAT_CTGR_ENTT_DTIME_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_CTGR_ENTT_DTIME_ENTT_ID_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_category_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_CATEGORY_ENTITY_DATETIME_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=629 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Datetime Attribute Backend Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_entity_datetime`
--

LOCK TABLES `catalog_category_entity_datetime` WRITE;
/*!40000 ALTER TABLE `catalog_category_entity_datetime` DISABLE KEYS */;
INSERT INTO `catalog_category_entity_datetime` VALUES (1,61,0,15,NULL),(2,62,0,15,NULL),(3,61,0,3,NULL),(4,62,0,3,NULL),(5,61,0,57,NULL),(6,62,0,57,NULL),(7,61,0,4,NULL),(8,62,0,4,NULL),(9,61,0,5,NULL),(10,62,0,5,NULL),(11,61,0,97,NULL),(12,62,0,97,NULL),(13,61,0,37,NULL),(14,62,0,37,NULL),(15,61,0,6,NULL),(16,62,0,6,NULL),(17,61,0,7,NULL),(18,62,0,7,NULL),(19,61,0,8,NULL),(20,62,0,8,NULL),(21,61,0,154,NULL),(22,62,0,154,NULL),(23,61,0,9,NULL),(24,62,0,9,NULL),(25,61,0,163,NULL),(26,62,0,163,NULL),(27,61,0,16,NULL),(28,62,0,16,NULL),(29,61,0,17,NULL),(30,62,0,17,NULL),(31,61,0,18,NULL),(32,62,0,18,NULL),(33,61,0,10,NULL),(34,62,0,10,NULL),(35,61,0,11,NULL),(36,62,0,11,NULL),(37,61,0,12,NULL),(38,62,0,12,NULL),(41,61,0,164,NULL),(42,62,0,164,NULL),(43,61,0,25,NULL),(44,62,0,25,NULL),(45,61,0,46,NULL),(46,62,0,46,NULL),(47,61,0,51,NULL),(48,62,0,51,NULL),(49,61,0,54,NULL),(50,62,0,54,NULL),(51,61,0,62,NULL),(52,62,0,62,NULL),(53,61,0,21,NULL),(54,62,0,21,NULL),(55,61,0,22,NULL),(56,62,0,22,NULL),(57,61,0,23,NULL),(58,62,0,23,NULL),(59,61,0,24,NULL),(60,62,0,24,NULL),(61,61,0,26,NULL),(62,62,0,26,NULL),(63,61,0,27,NULL),(64,62,0,27,NULL),(65,61,0,28,NULL),(66,62,0,28,NULL),(67,61,0,29,NULL),(68,62,0,29,NULL),(69,61,0,30,NULL),(70,62,0,30,NULL),(71,61,0,31,NULL),(72,62,0,31,NULL),(73,61,0,2,NULL),(74,62,0,2,NULL),(75,61,0,32,NULL),(76,62,0,32,NULL),(77,61,0,33,NULL),(78,62,0,33,NULL),(79,61,0,34,NULL),(80,62,0,34,NULL),(81,61,0,35,NULL),(82,62,0,35,NULL),(83,61,0,36,NULL),(84,62,0,36,NULL),(85,61,0,38,NULL),(86,62,0,38,NULL),(87,61,0,39,NULL),(88,62,0,39,NULL),(89,61,0,40,NULL),(90,62,0,40,NULL),(91,61,0,41,NULL),(92,62,0,41,NULL),(93,61,0,42,NULL),(94,62,0,42,NULL),(95,61,0,43,NULL),(96,62,0,43,NULL),(97,61,0,44,NULL),(98,62,0,44,NULL),(99,61,0,45,NULL),(100,62,0,45,NULL),(101,61,0,47,NULL),(102,62,0,47,NULL),(103,61,0,48,NULL),(104,62,0,48,NULL),(105,61,0,49,NULL),(106,62,0,49,NULL),(107,61,0,50,NULL),(108,62,0,50,NULL),(109,61,0,52,NULL),(110,62,0,52,NULL),(111,61,0,53,NULL),(112,62,0,53,NULL),(113,61,0,58,NULL),(114,62,0,58,NULL),(115,61,0,59,NULL),(116,62,0,59,NULL),(117,61,0,60,NULL),(118,62,0,60,NULL),(119,61,0,61,NULL),(120,62,0,61,NULL),(121,61,0,55,NULL),(122,62,0,55,NULL),(123,61,0,56,NULL),(124,62,0,56,NULL),(125,61,0,71,NULL),(126,62,0,71,NULL),(127,61,0,72,NULL),(128,62,0,72,NULL),(129,61,0,73,NULL),(130,62,0,73,NULL),(131,61,0,74,NULL),(132,62,0,74,NULL),(133,61,0,75,NULL),(134,62,0,75,NULL),(135,61,0,76,NULL),(136,62,0,76,NULL),(137,61,0,77,NULL),(138,62,0,77,NULL),(139,61,0,78,NULL),(140,62,0,78,NULL),(141,61,0,79,NULL),(142,62,0,79,NULL),(143,61,0,80,NULL),(144,62,0,80,NULL),(145,61,0,81,NULL),(146,62,0,81,NULL),(147,61,0,83,NULL),(148,62,0,83,NULL),(149,61,0,84,NULL),(150,62,0,84,NULL),(151,61,0,85,NULL),(152,62,0,85,NULL),(153,61,0,86,NULL),(154,62,0,86,NULL),(155,61,0,67,NULL),(156,62,0,67,NULL),(157,61,0,68,NULL),(158,62,0,68,NULL),(159,61,0,69,NULL),(160,62,0,69,NULL),(161,61,0,70,NULL),(162,62,0,70,NULL),(163,61,0,87,NULL),(164,62,0,87,NULL),(165,61,0,88,NULL),(166,62,0,88,NULL),(167,61,0,89,NULL),(168,62,0,89,NULL),(169,61,0,90,NULL),(170,62,0,90,NULL),(171,61,0,91,NULL),(172,62,0,91,NULL),(173,61,0,92,NULL),(174,62,0,92,NULL),(175,61,0,94,NULL),(176,62,0,94,NULL),(177,61,0,95,NULL),(178,62,0,95,NULL),(179,61,0,93,NULL),(180,62,0,93,NULL),(181,61,0,96,NULL),(182,62,0,96,NULL),(183,61,0,98,NULL),(184,62,0,98,NULL),(185,61,0,99,NULL),(186,62,0,99,NULL),(187,61,0,100,NULL),(188,62,0,100,NULL),(189,61,0,101,NULL),(190,62,0,101,NULL),(191,61,0,102,NULL),(192,62,0,102,NULL),(193,61,0,103,NULL),(194,62,0,103,NULL),(195,61,0,104,NULL),(196,62,0,104,NULL),(197,61,0,105,NULL),(198,62,0,105,NULL),(199,61,0,106,NULL),(200,62,0,106,NULL),(201,61,0,110,NULL),(202,62,0,110,NULL),(203,61,0,108,NULL),(204,62,0,108,NULL),(205,61,0,107,NULL),(206,62,0,107,NULL),(207,61,0,111,NULL),(208,62,0,111,NULL),(209,61,0,112,NULL),(210,62,0,112,NULL),(211,61,0,113,NULL),(212,62,0,113,NULL),(213,61,0,114,NULL),(214,62,0,114,NULL),(215,61,0,115,NULL),(216,62,0,115,NULL),(217,61,0,116,NULL),(218,62,0,116,NULL),(219,61,0,117,NULL),(220,62,0,117,NULL),(221,61,0,118,NULL),(222,62,0,118,NULL),(223,61,0,123,NULL),(224,62,0,123,NULL),(225,61,0,121,NULL),(226,62,0,121,NULL),(227,61,0,122,NULL),(228,62,0,122,NULL),(229,61,0,120,NULL),(230,62,0,120,NULL),(231,61,0,119,NULL),(232,62,0,119,NULL),(233,61,0,124,NULL),(234,62,0,124,NULL),(235,61,0,125,NULL),(236,62,0,125,NULL),(237,61,0,126,NULL),(238,62,0,126,NULL),(239,61,0,127,NULL),(240,62,0,127,NULL),(241,61,0,128,NULL),(242,62,0,128,NULL),(243,61,0,129,NULL),(244,62,0,129,NULL),(245,61,0,130,NULL),(246,62,0,130,NULL),(249,61,0,132,NULL),(250,62,0,132,NULL),(251,61,0,133,NULL),(252,62,0,133,NULL),(253,61,0,134,NULL),(254,62,0,134,NULL),(255,61,0,135,NULL),(256,62,0,135,NULL),(257,61,0,140,NULL),(258,62,0,140,NULL),(259,61,0,141,NULL),(260,62,0,141,NULL),(261,61,0,139,NULL),(262,62,0,139,NULL),(263,61,0,138,NULL),(264,62,0,138,NULL),(265,61,0,137,NULL),(266,62,0,137,NULL),(267,61,0,142,NULL),(268,62,0,142,NULL),(269,61,0,143,NULL),(270,62,0,143,NULL),(271,61,0,144,NULL),(272,62,0,144,NULL),(273,61,0,136,NULL),(274,62,0,136,NULL),(275,61,0,145,NULL),(276,62,0,145,NULL),(277,61,0,146,NULL),(278,62,0,146,NULL),(279,61,0,147,NULL),(280,62,0,147,NULL),(281,61,0,149,NULL),(282,62,0,149,NULL),(283,61,0,151,NULL),(284,62,0,151,NULL),(285,61,0,152,NULL),(286,62,0,152,NULL),(287,61,0,153,NULL),(288,62,0,153,NULL),(289,61,0,155,NULL),(290,62,0,155,NULL),(291,61,0,156,NULL),(292,62,0,156,NULL),(293,61,0,157,NULL),(294,62,0,157,NULL),(295,61,0,158,NULL),(296,62,0,158,NULL),(297,61,0,159,NULL),(298,62,0,159,NULL),(299,61,0,162,NULL),(300,62,0,162,NULL),(301,61,0,161,NULL),(302,62,0,161,NULL),(303,61,0,160,NULL),(304,62,0,160,NULL),(305,61,0,150,NULL),(306,62,0,150,NULL),(307,61,0,166,NULL),(308,62,0,166,NULL),(309,61,0,165,NULL),(310,62,0,165,NULL),(311,61,0,167,NULL),(312,62,0,167,NULL),(313,61,0,169,NULL),(314,62,0,169,NULL),(315,61,0,175,NULL),(316,62,0,175,NULL),(317,61,0,176,NULL),(318,62,0,176,NULL),(319,61,0,177,NULL),(320,62,0,177,NULL),(321,61,0,178,NULL),(322,62,0,178,NULL),(323,61,0,179,NULL),(324,62,0,179,NULL),(325,61,0,180,NULL),(326,62,0,180,NULL),(327,61,0,181,NULL),(328,62,0,181,NULL),(329,61,0,171,NULL),(330,62,0,171,NULL),(331,61,0,172,NULL),(332,62,0,172,NULL),(333,61,0,173,NULL),(334,62,0,173,NULL),(335,61,0,174,NULL),(336,62,0,174,NULL),(337,61,0,182,NULL),(338,62,0,182,NULL),(339,61,0,183,NULL),(340,62,0,183,NULL),(341,61,0,184,NULL),(342,62,0,184,NULL),(343,61,0,185,NULL),(344,62,0,185,NULL),(345,61,0,186,NULL),(346,62,0,186,NULL),(347,61,0,187,NULL),(348,62,0,187,NULL),(349,61,0,189,NULL),(350,62,0,189,NULL),(351,61,0,190,NULL),(352,62,0,190,NULL),(353,61,0,188,NULL),(354,62,0,188,NULL),(355,61,0,191,NULL),(356,62,0,191,NULL),(357,61,0,192,NULL),(358,62,0,192,NULL),(359,61,0,193,NULL),(360,62,0,193,NULL),(361,61,0,194,NULL),(362,62,0,194,NULL),(363,61,0,195,NULL),(364,62,0,195,NULL),(365,61,0,196,NULL),(366,62,0,196,NULL),(367,61,0,197,NULL),(368,62,0,197,NULL),(369,61,0,20,NULL),(370,62,0,20,NULL),(371,61,0,199,NULL),(372,62,0,199,NULL),(375,61,0,168,NULL),(376,62,0,168,NULL),(377,61,0,219,NULL),(378,62,0,219,NULL),(379,61,0,82,NULL),(380,62,0,82,NULL),(381,61,0,262,NULL),(382,62,0,262,NULL),(383,61,0,290,NULL),(384,62,0,290,NULL),(385,61,0,109,NULL),(386,62,0,109,NULL),(387,61,0,318,NULL),(388,62,0,318,NULL),(389,61,0,148,NULL),(390,62,0,148,NULL),(391,61,0,370,NULL),(392,62,0,370,NULL),(393,61,0,203,NULL),(394,62,0,203,NULL),(395,61,0,405,NULL),(396,62,0,405,NULL),(397,61,0,444,NULL),(398,62,0,444,NULL),(399,61,0,406,NULL),(400,62,0,406,NULL),(401,61,0,407,NULL),(402,62,0,407,NULL),(403,61,0,408,NULL),(404,62,0,408,NULL),(405,61,0,409,NULL),(406,62,0,409,NULL),(407,61,0,410,NULL),(408,62,0,410,NULL),(409,61,0,411,NULL),(410,62,0,411,NULL),(411,61,0,413,NULL),(412,62,0,413,NULL),(413,61,0,414,NULL),(414,62,0,414,NULL),(415,61,0,415,NULL),(416,62,0,415,NULL),(417,61,0,416,NULL),(418,62,0,416,NULL),(419,61,0,417,NULL),(420,62,0,417,NULL),(421,61,0,418,NULL),(422,62,0,418,NULL),(423,61,0,419,NULL),(424,62,0,419,NULL),(425,61,0,420,NULL),(426,62,0,420,NULL),(427,61,0,422,NULL),(428,62,0,422,NULL),(429,61,0,424,NULL),(430,62,0,424,NULL),(431,61,0,425,NULL),(432,62,0,425,NULL),(433,61,0,426,NULL),(434,62,0,426,NULL),(435,61,0,427,NULL),(436,62,0,427,NULL),(437,61,0,429,NULL),(438,62,0,429,NULL),(439,61,0,430,NULL),(440,62,0,430,NULL),(441,61,0,431,NULL),(442,62,0,431,NULL),(443,61,0,432,NULL),(444,62,0,432,NULL),(445,61,0,433,NULL),(446,62,0,433,NULL),(447,61,0,434,NULL),(448,62,0,434,NULL),(449,61,0,435,NULL),(450,62,0,435,NULL),(451,61,0,436,NULL),(452,62,0,436,NULL),(453,61,0,437,NULL),(454,62,0,437,NULL),(455,61,0,439,NULL),(456,62,0,439,NULL),(457,61,0,441,NULL),(458,62,0,441,NULL),(459,61,0,442,NULL),(460,62,0,442,NULL),(461,61,0,443,NULL),(462,62,0,443,NULL),(463,61,0,440,NULL),(464,62,0,440,NULL),(465,61,0,368,NULL),(466,62,0,368,NULL),(467,61,0,371,NULL),(468,62,0,371,NULL),(469,61,0,373,NULL),(470,62,0,373,NULL),(471,61,0,374,NULL),(472,62,0,374,NULL),(473,61,0,375,NULL),(474,62,0,375,NULL),(475,61,0,376,NULL),(476,62,0,376,NULL),(477,61,0,377,NULL),(478,62,0,377,NULL),(479,61,0,366,NULL),(480,62,0,366,NULL),(481,61,0,307,NULL),(482,62,0,307,NULL),(483,61,0,379,NULL),(484,62,0,379,NULL),(485,61,0,381,NULL),(486,62,0,381,NULL),(487,61,0,382,NULL),(488,62,0,382,NULL),(489,61,0,383,NULL),(490,62,0,383,NULL),(491,61,0,385,NULL),(492,62,0,385,NULL),(493,61,0,386,NULL),(494,62,0,386,NULL),(495,61,0,387,NULL),(496,62,0,387,NULL),(497,61,0,445,NULL),(498,62,0,445,NULL),(499,61,0,308,NULL),(500,62,0,308,NULL),(501,61,0,309,NULL),(502,62,0,309,NULL),(503,61,0,310,NULL),(504,62,0,310,NULL),(505,61,0,311,NULL),(506,62,0,311,NULL),(507,61,0,312,NULL),(508,62,0,312,NULL),(509,61,0,313,NULL),(510,62,0,313,NULL),(511,61,0,314,NULL),(512,62,0,314,NULL),(513,61,0,315,NULL),(514,62,0,315,NULL),(515,61,0,322,NULL),(516,62,0,322,NULL),(517,61,0,324,NULL),(518,62,0,324,NULL),(519,61,0,325,NULL),(520,62,0,325,NULL),(521,61,0,326,NULL),(522,62,0,326,NULL),(523,61,0,328,NULL),(524,62,0,328,NULL),(525,61,0,327,NULL),(526,62,0,327,NULL),(527,61,0,329,NULL),(528,62,0,329,NULL),(529,61,0,330,NULL),(530,62,0,330,NULL),(531,61,0,331,NULL),(532,62,0,331,NULL),(533,61,0,336,NULL),(534,62,0,336,NULL),(535,61,0,345,NULL),(536,62,0,345,NULL),(537,61,0,346,NULL),(538,62,0,346,NULL),(539,61,0,338,NULL),(540,62,0,338,NULL),(541,61,0,339,NULL),(542,62,0,339,NULL),(543,61,0,340,NULL),(544,62,0,340,NULL),(545,61,0,341,NULL),(546,62,0,341,NULL),(547,61,0,342,NULL),(548,62,0,342,NULL),(549,61,0,359,NULL),(550,62,0,359,NULL),(551,61,0,360,NULL),(552,62,0,360,NULL),(553,61,0,361,NULL),(554,62,0,361,NULL),(555,61,0,362,NULL),(556,62,0,362,NULL),(557,61,0,351,NULL),(558,62,0,351,NULL),(559,61,0,352,NULL),(560,62,0,352,NULL),(561,61,0,353,NULL),(562,62,0,353,NULL),(563,61,0,354,NULL),(564,62,0,354,NULL),(565,61,0,355,NULL),(566,62,0,355,NULL),(567,61,0,198,NULL),(568,62,0,198,NULL),(569,61,0,200,NULL),(570,62,0,200,NULL),(571,61,0,205,NULL),(572,62,0,205,NULL),(573,61,0,365,NULL),(574,62,0,365,NULL),(575,61,0,349,NULL),(576,62,0,349,NULL),(577,61,0,210,NULL),(578,62,0,210,NULL),(579,61,0,211,NULL),(580,62,0,211,NULL),(581,61,0,212,NULL),(582,62,0,212,NULL),(583,61,0,213,NULL),(584,62,0,213,NULL),(585,61,0,214,NULL),(586,62,0,214,NULL),(587,61,0,215,NULL),(588,62,0,215,NULL),(589,61,0,216,NULL),(590,62,0,216,NULL),(591,61,0,221,NULL),(592,62,0,221,NULL),(593,61,0,222,NULL),(594,62,0,222,NULL),(595,61,0,208,NULL),(596,62,0,208,NULL),(597,61,0,227,NULL),(598,62,0,227,NULL),(599,61,0,229,NULL),(600,62,0,229,NULL),(601,61,0,231,NULL),(602,62,0,231,NULL),(603,61,0,232,NULL),(604,62,0,232,NULL),(605,61,0,233,NULL),(606,62,0,233,NULL),(607,61,0,234,NULL),(608,62,0,234,NULL),(609,61,0,235,NULL),(610,62,0,235,NULL),(611,61,0,236,NULL),(612,62,0,236,NULL),(613,61,0,237,NULL),(614,62,0,237,NULL),(615,61,0,238,NULL),(616,62,0,238,NULL),(617,61,0,239,NULL),(618,62,0,239,NULL),(619,61,0,241,NULL),(620,62,0,241,NULL),(621,61,0,242,NULL),(622,62,0,242,NULL),(623,61,0,243,NULL),(624,62,0,243,NULL),(625,61,0,244,NULL),(626,62,0,244,NULL),(627,61,0,449,NULL),(628,62,0,449,NULL);
/*!40000 ALTER TABLE `catalog_category_entity_datetime` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_entity_decimal`
--

DROP TABLE IF EXISTS `catalog_category_entity_decimal`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_entity_decimal` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` decimal(20,6) DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CATALOG_CATEGORY_ENTITY_DECIMAL_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `CATALOG_CATEGORY_ENTITY_DECIMAL_ENTITY_ID` (`entity_id`),
  KEY `CATALOG_CATEGORY_ENTITY_DECIMAL_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_CATEGORY_ENTITY_DECIMAL_STORE_ID` (`store_id`),
  CONSTRAINT `CAT_CTGR_ENTT_DEC_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_CTGR_ENTT_DEC_ENTT_ID_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_category_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_CATEGORY_ENTITY_DECIMAL_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Decimal Attribute Backend Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_entity_decimal`
--

LOCK TABLES `catalog_category_entity_decimal` WRITE;
/*!40000 ALTER TABLE `catalog_category_entity_decimal` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_category_entity_decimal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_entity_int`
--

DROP TABLE IF EXISTS `catalog_category_entity_int`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_entity_int` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` int DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CATALOG_CATEGORY_ENTITY_INT_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `CATALOG_CATEGORY_ENTITY_INT_ENTITY_ID` (`entity_id`),
  KEY `CATALOG_CATEGORY_ENTITY_INT_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_CATEGORY_ENTITY_INT_STORE_ID` (`store_id`),
  CONSTRAINT `CAT_CTGR_ENTT_INT_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_CTGR_ENTT_INT_ENTT_ID_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_category_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_CATEGORY_ENTITY_INT_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=3042 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Integer Attribute Backend Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_entity_int`
--

LOCK TABLES `catalog_category_entity_int` WRITE;
/*!40000 ALTER TABLE `catalog_category_entity_int` DISABLE KEYS */;
INSERT INTO `catalog_category_entity_int` VALUES (1,69,0,1,1),(2,69,0,2,1),(3,46,0,2,1),(4,46,0,3,1),(5,54,0,3,1),(6,69,0,3,1),(7,70,0,3,1),(8,71,0,3,0),(9,46,0,4,1),(10,54,0,4,1),(11,69,0,4,1),(12,70,0,4,0),(13,71,0,4,0),(14,46,0,5,1),(15,54,0,5,1),(16,69,0,5,1),(17,70,0,5,0),(18,71,0,5,0),(19,46,0,6,1),(20,54,0,6,1),(21,69,0,6,1),(22,70,0,6,0),(23,71,0,6,0),(24,46,0,7,1),(25,54,0,7,1),(26,69,0,7,1),(27,70,0,7,0),(28,71,0,7,0),(29,46,0,8,1),(30,54,0,8,1),(31,69,0,8,1),(32,70,0,8,0),(33,71,0,8,0),(34,46,0,9,1),(35,54,0,9,1),(36,69,0,9,1),(37,70,0,9,0),(38,71,0,9,0),(39,46,0,10,0),(40,54,0,10,1),(41,69,0,10,0),(42,70,0,10,0),(43,71,0,10,0),(44,46,0,11,0),(45,54,0,11,1),(46,69,0,11,0),(47,70,0,11,0),(48,71,0,11,0),(49,46,0,12,1),(50,54,0,12,1),(51,69,0,12,1),(52,70,0,12,0),(53,71,0,12,0),(60,46,0,15,1),(61,54,0,15,1),(62,69,0,15,1),(63,70,0,15,0),(64,71,0,15,0),(65,53,0,15,NULL),(66,46,0,16,1),(67,54,0,16,1),(68,69,0,16,1),(69,70,0,16,0),(70,71,0,16,0),(71,46,0,17,1),(72,54,0,17,1),(73,69,0,17,1),(74,70,0,17,0),(75,71,0,17,0),(76,53,0,3,NULL),(77,46,0,18,1),(78,54,0,18,1),(79,69,0,18,1),(80,70,0,18,0),(81,71,0,18,0),(87,46,0,20,0),(88,54,0,20,1),(89,69,0,20,0),(90,70,0,20,0),(91,71,0,20,0),(92,46,0,21,0),(93,54,0,21,1),(94,69,0,21,0),(95,70,0,21,0),(96,71,0,21,0),(97,46,0,22,1),(98,54,0,22,1),(99,69,0,22,1),(100,70,0,22,0),(101,71,0,22,0),(102,46,0,23,0),(103,54,0,23,1),(104,69,0,23,0),(105,70,0,23,0),(106,71,0,23,0),(107,46,0,24,1),(108,54,0,24,1),(109,69,0,24,1),(110,70,0,24,0),(111,71,0,24,0),(112,46,0,25,1),(113,54,0,25,1),(114,69,0,25,1),(115,70,0,25,0),(116,71,0,25,0),(117,46,0,26,1),(118,54,0,26,1),(119,69,0,26,1),(120,70,0,26,0),(121,71,0,26,0),(122,46,0,27,1),(123,54,0,27,1),(124,69,0,27,1),(125,70,0,27,0),(126,71,0,27,0),(127,46,0,28,1),(128,54,0,28,1),(129,69,0,28,1),(130,70,0,28,0),(131,71,0,28,0),(132,46,0,29,0),(133,54,0,29,1),(134,69,0,29,0),(135,70,0,29,0),(136,71,0,29,0),(137,46,0,30,1),(138,54,0,30,1),(139,69,0,30,1),(140,70,0,30,0),(141,71,0,30,0),(142,46,0,31,1),(143,54,0,31,1),(144,69,0,31,1),(145,70,0,31,0),(146,71,0,31,0),(147,46,0,32,1),(148,54,0,32,1),(149,69,0,32,1),(150,70,0,32,0),(151,71,0,32,0),(152,46,0,33,1),(153,54,0,33,1),(154,69,0,33,1),(155,70,0,33,0),(156,71,0,33,0),(157,46,0,34,0),(158,54,0,34,1),(159,69,0,34,0),(160,70,0,34,0),(161,71,0,34,0),(162,46,0,35,0),(163,54,0,35,1),(164,69,0,35,0),(165,70,0,35,0),(166,71,0,35,0),(167,46,0,36,0),(168,54,0,36,1),(169,69,0,36,0),(170,70,0,36,0),(171,71,0,36,0),(172,46,0,37,1),(173,54,0,37,1),(174,69,0,37,1),(175,70,0,37,0),(176,71,0,37,0),(177,46,0,38,0),(178,54,0,38,1),(179,69,0,38,0),(180,70,0,38,0),(181,71,0,38,0),(182,46,0,39,1),(183,54,0,39,1),(184,69,0,39,1),(185,70,0,39,0),(186,71,0,39,0),(187,46,0,40,1),(188,54,0,40,1),(189,69,0,40,1),(190,70,0,40,0),(191,71,0,40,0),(192,46,0,41,1),(193,54,0,41,1),(194,69,0,41,1),(195,70,0,41,0),(196,71,0,41,0),(197,46,0,42,1),(198,54,0,42,1),(199,69,0,42,1),(200,70,0,42,0),(201,71,0,42,0),(202,46,0,43,1),(203,54,0,43,1),(204,69,0,43,1),(205,70,0,43,0),(206,71,0,43,0),(207,46,0,44,1),(208,54,0,44,1),(209,69,0,44,1),(210,70,0,44,0),(211,71,0,44,0),(212,46,0,45,1),(213,54,0,45,1),(214,69,0,45,1),(215,70,0,45,0),(216,71,0,45,0),(217,46,0,46,1),(218,54,0,46,1),(219,69,0,46,1),(220,70,0,46,0),(221,71,0,46,0),(222,46,0,47,1),(223,54,0,47,1),(224,69,0,47,1),(225,70,0,47,0),(226,71,0,47,0),(227,46,0,48,1),(228,54,0,48,1),(229,69,0,48,1),(230,70,0,48,0),(231,71,0,48,0),(232,46,0,49,1),(233,54,0,49,1),(234,69,0,49,1),(235,70,0,49,0),(236,71,0,49,0),(237,46,0,50,1),(238,54,0,50,1),(239,69,0,50,1),(240,70,0,50,0),(241,71,0,50,0),(242,46,0,51,0),(243,54,0,51,1),(244,69,0,51,0),(245,70,0,51,0),(246,71,0,51,0),(247,46,0,52,1),(248,54,0,52,1),(249,69,0,52,1),(250,70,0,52,0),(251,71,0,52,0),(252,46,0,53,1),(253,54,0,53,1),(254,69,0,53,1),(255,70,0,53,0),(256,71,0,53,0),(257,46,0,54,1),(258,54,0,54,1),(259,69,0,54,1),(260,70,0,54,0),(261,71,0,54,0),(262,46,0,55,1),(263,54,0,55,1),(264,69,0,55,1),(265,70,0,55,0),(266,71,0,55,0),(267,46,0,56,0),(268,54,0,56,1),(269,69,0,56,0),(270,70,0,56,0),(271,71,0,56,0),(272,46,0,57,0),(273,54,0,57,1),(274,69,0,57,0),(275,70,0,57,0),(276,71,0,57,0),(277,53,0,57,NULL),(278,46,0,58,1),(279,54,0,58,1),(280,69,0,58,1),(281,70,0,58,0),(282,71,0,58,0),(283,46,0,59,1),(284,54,0,59,1),(285,69,0,59,1),(286,70,0,59,0),(287,71,0,59,0),(288,46,0,60,1),(289,54,0,60,1),(290,69,0,60,1),(291,70,0,60,0),(292,71,0,60,0),(293,46,0,61,1),(294,54,0,61,1),(295,69,0,61,1),(296,70,0,61,0),(297,71,0,61,0),(298,46,0,62,0),(299,54,0,62,1),(300,69,0,62,0),(301,70,0,62,0),(302,71,0,62,0),(303,46,0,63,1),(304,54,0,63,1),(305,69,0,63,1),(306,70,0,63,0),(307,71,0,63,0),(308,46,0,64,1),(309,54,0,64,1),(310,69,0,64,1),(311,70,0,64,0),(312,71,0,64,0),(313,46,0,65,1),(314,54,0,65,1),(315,69,0,65,1),(316,70,0,65,0),(317,71,0,65,0),(318,53,0,4,NULL),(319,46,0,66,1),(320,54,0,66,1),(321,69,0,66,1),(322,70,0,66,0),(323,71,0,66,0),(324,46,0,67,1),(325,54,0,67,1),(326,69,0,67,1),(327,70,0,67,0),(328,71,0,67,0),(329,46,0,68,1),(330,54,0,68,1),(331,69,0,68,1),(332,70,0,68,0),(333,71,0,68,0),(334,46,0,69,1),(335,54,0,69,1),(336,69,0,69,1),(337,70,0,69,0),(338,71,0,69,0),(339,46,0,70,1),(340,54,0,70,1),(341,69,0,70,1),(342,70,0,70,0),(343,71,0,70,0),(344,46,0,71,1),(345,54,0,71,1),(346,69,0,71,1),(347,70,0,71,0),(348,71,0,71,0),(349,46,0,72,0),(350,54,0,72,1),(351,69,0,72,0),(352,70,0,72,0),(353,71,0,72,0),(354,46,0,73,0),(355,54,0,73,1),(356,69,0,73,0),(357,70,0,73,0),(358,71,0,73,0),(359,46,0,74,0),(360,54,0,74,1),(361,69,0,74,0),(362,70,0,74,0),(363,71,0,74,0),(364,46,0,75,0),(365,54,0,75,1),(366,69,0,75,0),(367,70,0,75,0),(368,71,0,75,0),(369,46,0,76,0),(370,54,0,76,1),(371,69,0,76,0),(372,70,0,76,0),(373,71,0,76,0),(374,46,0,77,0),(375,54,0,77,1),(376,69,0,77,0),(377,70,0,77,0),(378,71,0,77,0),(379,46,0,78,1),(380,54,0,78,1),(381,69,0,78,1),(382,70,0,78,0),(383,71,0,78,0),(384,46,0,79,1),(385,54,0,79,1),(386,69,0,79,1),(387,70,0,79,0),(388,71,0,79,0),(389,46,0,80,1),(390,54,0,80,1),(391,69,0,80,1),(392,70,0,80,0),(393,71,0,80,0),(394,46,0,81,1),(395,54,0,81,1),(396,69,0,81,1),(397,70,0,81,0),(398,71,0,81,0),(399,46,0,82,1),(400,54,0,82,1),(401,69,0,82,1),(402,70,0,82,0),(403,71,0,82,0),(404,46,0,83,1),(405,54,0,83,1),(406,69,0,83,1),(407,70,0,83,0),(408,71,0,83,0),(409,46,0,84,1),(410,54,0,84,1),(411,69,0,84,1),(412,70,0,84,0),(413,71,0,84,0),(414,46,0,85,1),(415,54,0,85,1),(416,69,0,85,1),(417,70,0,85,0),(418,71,0,85,0),(419,46,0,86,1),(420,54,0,86,1),(421,69,0,86,1),(422,70,0,86,0),(423,71,0,86,0),(424,53,0,5,NULL),(425,46,0,87,1),(426,54,0,87,1),(427,69,0,87,1),(428,70,0,87,0),(429,71,0,87,0),(430,46,0,88,1),(431,54,0,88,1),(432,69,0,88,1),(433,70,0,88,0),(434,71,0,88,0),(435,46,0,89,1),(436,54,0,89,1),(437,69,0,89,1),(438,70,0,89,0),(439,71,0,89,0),(440,46,0,90,1),(441,54,0,90,1),(442,69,0,90,1),(443,70,0,90,0),(444,71,0,90,0),(445,46,0,91,1),(446,54,0,91,1),(447,69,0,91,1),(448,70,0,91,0),(449,71,0,91,0),(450,46,0,92,1),(451,54,0,92,1),(452,69,0,92,1),(453,70,0,92,0),(454,71,0,92,0),(455,46,0,93,1),(456,54,0,93,1),(457,69,0,93,1),(458,70,0,93,0),(459,71,0,93,0),(460,46,0,94,1),(461,54,0,94,1),(462,69,0,94,1),(463,70,0,94,0),(464,71,0,94,0),(465,46,0,95,1),(466,54,0,95,1),(467,69,0,95,1),(468,70,0,95,0),(469,71,0,95,0),(470,46,0,96,1),(471,54,0,96,1),(472,69,0,96,1),(473,70,0,96,0),(474,71,0,96,0),(475,46,0,97,1),(476,54,0,97,1),(477,69,0,97,1),(478,70,0,97,0),(479,71,0,97,0),(480,53,0,97,NULL),(481,46,0,98,1),(482,54,0,98,1),(483,69,0,98,1),(484,70,0,98,0),(485,71,0,98,0),(486,46,0,99,1),(487,54,0,99,1),(488,69,0,99,1),(489,70,0,99,0),(490,71,0,99,0),(491,46,0,100,1),(492,54,0,100,1),(493,69,0,100,1),(494,70,0,100,0),(495,71,0,100,0),(496,46,0,101,1),(497,54,0,101,1),(498,69,0,101,1),(499,70,0,101,0),(500,71,0,101,0),(501,46,0,102,1),(502,54,0,102,1),(503,69,0,102,1),(504,70,0,102,0),(505,71,0,102,0),(506,46,0,103,1),(507,54,0,103,1),(508,69,0,103,1),(509,70,0,103,0),(510,71,0,103,0),(511,46,0,104,1),(512,54,0,104,1),(513,69,0,104,1),(514,70,0,104,0),(515,71,0,104,0),(516,46,0,105,1),(517,54,0,105,1),(518,69,0,105,1),(519,70,0,105,0),(520,71,0,105,0),(521,46,0,106,1),(522,54,0,106,1),(523,69,0,106,1),(524,70,0,106,0),(525,71,0,106,0),(526,46,0,107,0),(527,54,0,107,1),(528,69,0,107,0),(529,70,0,107,0),(530,71,0,107,0),(531,46,0,108,1),(532,54,0,108,1),(533,69,0,108,1),(534,70,0,108,0),(535,71,0,108,0),(536,46,0,109,0),(537,54,0,109,1),(538,69,0,109,0),(539,70,0,109,0),(540,71,0,109,0),(541,46,0,110,1),(542,54,0,110,1),(543,69,0,110,1),(544,70,0,110,0),(545,71,0,110,0),(546,53,0,37,NULL),(547,53,0,6,NULL),(548,46,0,111,1),(549,54,0,111,1),(550,69,0,111,1),(551,70,0,111,0),(552,71,0,111,0),(553,46,0,112,0),(554,54,0,112,1),(555,69,0,112,0),(556,70,0,112,0),(557,71,0,112,0),(558,46,0,113,1),(559,54,0,113,1),(560,69,0,113,1),(561,70,0,113,0),(562,71,0,113,0),(563,46,0,114,1),(564,54,0,114,1),(565,69,0,114,1),(566,70,0,114,0),(567,71,0,114,0),(568,46,0,115,1),(569,54,0,115,1),(570,69,0,115,1),(571,70,0,115,0),(572,71,0,115,0),(573,46,0,116,0),(574,54,0,116,1),(575,69,0,116,0),(576,70,0,116,0),(577,71,0,116,0),(578,46,0,117,1),(579,54,0,117,1),(580,69,0,117,1),(581,70,0,117,0),(582,71,0,117,0),(583,46,0,118,1),(584,54,0,118,1),(585,69,0,118,1),(586,70,0,118,0),(587,71,0,118,0),(588,46,0,119,1),(589,54,0,119,1),(590,69,0,119,1),(591,70,0,119,0),(592,71,0,119,0),(593,46,0,120,1),(594,54,0,120,1),(595,69,0,120,1),(596,70,0,120,0),(597,71,0,120,0),(598,46,0,121,1),(599,54,0,121,1),(600,69,0,121,1),(601,70,0,121,0),(602,71,0,121,0),(603,46,0,122,0),(604,54,0,122,1),(605,69,0,122,0),(606,70,0,122,0),(607,71,0,122,0),(608,46,0,123,1),(609,54,0,123,1),(610,69,0,123,1),(611,70,0,123,0),(612,71,0,123,0),(613,46,0,124,1),(614,54,0,124,1),(615,69,0,124,1),(616,70,0,124,0),(617,71,0,124,0),(618,46,0,125,1),(619,54,0,125,1),(620,69,0,125,1),(621,70,0,125,0),(622,71,0,125,0),(623,46,0,126,1),(624,54,0,126,1),(625,69,0,126,1),(626,70,0,126,0),(627,71,0,126,0),(628,46,0,127,0),(629,54,0,127,1),(630,69,0,127,0),(631,70,0,127,0),(632,71,0,127,0),(633,46,0,128,1),(634,54,0,128,1),(635,69,0,128,1),(636,70,0,128,0),(637,71,0,128,0),(638,46,0,129,1),(639,54,0,129,1),(640,69,0,129,1),(641,70,0,129,0),(642,71,0,129,0),(643,46,0,130,1),(644,54,0,130,1),(645,69,0,130,1),(646,70,0,130,0),(647,71,0,130,0),(653,46,0,132,1),(654,54,0,132,1),(655,69,0,132,1),(656,70,0,132,0),(657,71,0,132,0),(658,46,0,133,0),(659,54,0,133,1),(660,69,0,133,0),(661,70,0,133,0),(662,71,0,133,0),(663,46,0,134,0),(664,54,0,134,1),(665,69,0,134,0),(666,70,0,134,0),(667,71,0,134,0),(668,53,0,7,NULL),(669,46,0,135,1),(670,54,0,135,1),(671,69,0,135,1),(672,70,0,135,0),(673,71,0,135,0),(674,46,0,136,1),(675,54,0,136,1),(676,69,0,136,1),(677,70,0,136,0),(678,71,0,136,0),(679,46,0,137,1),(680,54,0,137,1),(681,69,0,137,1),(682,70,0,137,0),(683,71,0,137,0),(684,46,0,138,0),(685,54,0,138,1),(686,69,0,138,0),(687,70,0,138,0),(688,71,0,138,0),(689,46,0,139,1),(690,54,0,139,1),(691,69,0,139,1),(692,70,0,139,0),(693,71,0,139,0),(694,46,0,140,0),(695,54,0,140,1),(696,69,0,140,0),(697,70,0,140,0),(698,71,0,140,0),(699,46,0,141,0),(700,54,0,141,1),(701,69,0,141,0),(702,70,0,141,0),(703,71,0,141,0),(704,46,0,142,1),(705,54,0,142,1),(706,69,0,142,1),(707,70,0,142,0),(708,71,0,142,0),(709,46,0,143,1),(710,54,0,143,1),(711,69,0,143,1),(712,70,0,143,0),(713,71,0,143,0),(714,46,0,144,1),(715,54,0,144,1),(716,69,0,144,1),(717,70,0,144,0),(718,71,0,144,0),(719,53,0,8,NULL),(720,46,0,145,1),(721,54,0,145,1),(722,69,0,145,1),(723,70,0,145,0),(724,71,0,145,0),(725,46,0,146,0),(726,54,0,146,1),(727,69,0,146,0),(728,70,0,146,0),(729,71,0,146,0),(730,46,0,147,1),(731,54,0,147,1),(732,69,0,147,1),(733,70,0,147,0),(734,71,0,147,0),(735,46,0,148,1),(736,54,0,148,1),(737,69,0,148,1),(738,70,0,148,0),(739,71,0,148,0),(740,46,0,149,0),(741,54,0,149,1),(742,69,0,149,0),(743,70,0,149,0),(744,71,0,149,0),(745,46,0,150,0),(746,54,0,150,1),(747,69,0,150,0),(748,70,0,150,0),(749,71,0,150,0),(750,46,0,151,1),(751,54,0,151,1),(752,69,0,151,1),(753,70,0,151,0),(754,71,0,151,0),(755,46,0,152,1),(756,54,0,152,1),(757,69,0,152,1),(758,70,0,152,0),(759,71,0,152,0),(760,46,0,153,0),(761,54,0,153,1),(762,69,0,153,0),(763,70,0,153,0),(764,71,0,153,0),(765,46,0,154,1),(766,54,0,154,1),(767,69,0,154,1),(768,70,0,154,0),(769,71,0,154,0),(770,53,0,154,NULL),(771,46,0,155,1),(772,54,0,155,1),(773,69,0,155,1),(774,70,0,155,0),(775,71,0,155,0),(776,46,0,156,0),(777,54,0,156,1),(778,69,0,156,0),(779,70,0,156,0),(780,71,0,156,0),(781,46,0,157,0),(782,54,0,157,1),(783,69,0,157,0),(784,70,0,157,0),(785,71,0,157,0),(786,46,0,158,1),(787,54,0,158,1),(788,69,0,158,1),(789,70,0,158,0),(790,71,0,158,0),(791,46,0,159,1),(792,54,0,159,1),(793,69,0,159,1),(794,70,0,159,0),(795,71,0,159,0),(796,46,0,160,1),(797,54,0,160,1),(798,69,0,160,1),(799,70,0,160,0),(800,71,0,160,0),(801,46,0,161,1),(802,54,0,161,1),(803,69,0,161,1),(804,70,0,161,0),(805,71,0,161,0),(806,46,0,162,1),(807,54,0,162,1),(808,69,0,162,1),(809,70,0,162,0),(810,71,0,162,0),(811,53,0,9,NULL),(812,46,0,163,0),(813,54,0,163,1),(814,69,0,163,0),(815,70,0,163,0),(816,71,0,163,0),(817,53,0,163,NULL),(818,46,0,164,0),(819,54,0,164,1),(820,69,0,164,0),(821,70,0,164,0),(822,71,0,164,0),(823,53,0,16,NULL),(824,53,0,17,NULL),(825,53,0,18,NULL),(826,53,0,10,NULL),(827,53,0,11,NULL),(828,53,0,12,NULL),(832,53,0,164,NULL),(833,53,0,25,NULL),(834,53,0,46,NULL),(835,53,0,51,NULL),(836,53,0,54,NULL),(837,53,0,62,NULL),(838,53,0,21,NULL),(839,53,0,22,NULL),(840,53,0,23,NULL),(841,53,0,24,NULL),(842,53,0,26,NULL),(843,53,0,27,NULL),(844,53,0,28,NULL),(845,53,0,29,NULL),(846,53,0,30,NULL),(847,53,0,31,NULL),(848,53,0,2,NULL),(849,54,0,2,1),(850,70,0,2,0),(851,71,0,2,0),(852,53,0,32,NULL),(853,53,0,33,NULL),(854,53,0,34,NULL),(855,53,0,35,NULL),(856,53,0,36,NULL),(857,53,0,38,NULL),(858,53,0,39,NULL),(859,53,0,40,NULL),(860,53,0,41,NULL),(861,53,0,42,NULL),(862,53,0,43,NULL),(863,53,0,44,NULL),(864,53,0,45,NULL),(865,53,0,47,NULL),(866,53,0,48,NULL),(867,53,0,49,NULL),(868,53,0,50,NULL),(869,53,0,52,NULL),(870,53,0,53,NULL),(871,53,0,58,NULL),(872,53,0,59,NULL),(873,53,0,60,NULL),(874,53,0,61,NULL),(875,53,0,55,NULL),(876,53,0,56,NULL),(877,53,0,71,NULL),(878,53,0,72,NULL),(879,53,0,73,NULL),(880,53,0,74,NULL),(881,53,0,75,NULL),(882,53,0,76,NULL),(883,53,0,77,NULL),(884,53,0,78,NULL),(885,53,0,79,NULL),(886,53,0,80,NULL),(887,53,0,81,NULL),(888,53,0,83,NULL),(889,53,0,84,NULL),(890,53,0,85,NULL),(891,53,0,86,NULL),(892,53,0,67,NULL),(893,53,0,68,NULL),(894,53,0,69,NULL),(895,53,0,70,NULL),(896,53,0,87,NULL),(897,53,0,88,NULL),(898,53,0,89,NULL),(899,53,0,90,NULL),(900,53,0,91,NULL),(901,53,0,92,NULL),(902,53,0,94,NULL),(903,53,0,95,NULL),(904,53,0,93,NULL),(905,53,0,96,NULL),(906,53,0,98,NULL),(907,53,0,99,NULL),(908,53,0,100,NULL),(909,53,0,101,NULL),(910,53,0,102,NULL),(911,53,0,103,NULL),(912,53,0,104,NULL),(913,53,0,105,NULL),(914,53,0,106,NULL),(915,53,0,110,NULL),(916,53,0,108,NULL),(917,53,0,107,NULL),(918,53,0,111,NULL),(919,53,0,112,NULL),(920,53,0,113,NULL),(921,53,0,114,NULL),(922,53,0,115,NULL),(923,53,0,116,NULL),(924,53,0,117,NULL),(925,53,0,118,NULL),(926,53,0,123,NULL),(927,53,0,121,NULL),(928,53,0,122,NULL),(929,53,0,120,NULL),(930,53,0,119,NULL),(931,53,0,124,NULL),(932,53,0,125,NULL),(933,53,0,126,NULL),(934,53,0,127,NULL),(935,53,0,128,NULL),(936,53,0,129,NULL),(937,53,0,130,NULL),(939,53,0,132,NULL),(940,53,0,133,NULL),(941,53,0,134,NULL),(942,53,0,135,NULL),(943,53,0,140,NULL),(944,53,0,141,NULL),(945,53,0,139,NULL),(946,53,0,138,NULL),(947,53,0,137,NULL),(948,53,0,142,NULL),(949,53,0,143,NULL),(950,53,0,144,NULL),(951,53,0,136,NULL),(952,53,0,145,NULL),(953,53,0,146,NULL),(954,53,0,147,NULL),(955,53,0,149,NULL),(956,53,0,151,NULL),(957,53,0,152,NULL),(958,53,0,153,NULL),(959,53,0,155,NULL),(960,53,0,156,NULL),(961,53,0,157,NULL),(962,53,0,158,NULL),(963,53,0,159,NULL),(964,53,0,162,NULL),(965,53,0,161,NULL),(966,53,0,160,NULL),(967,53,0,150,NULL),(968,46,0,165,1),(969,54,0,165,1),(970,69,0,165,1),(971,70,0,165,0),(972,71,0,165,0),(973,46,0,166,1),(974,54,0,166,1),(975,69,0,166,1),(976,70,0,166,0),(977,71,0,166,0),(978,53,0,166,NULL),(979,46,0,167,1),(980,54,0,167,1),(981,69,0,167,1),(982,70,0,167,0),(983,71,0,167,0),(984,46,0,168,1),(985,54,0,168,1),(986,69,0,168,1),(987,70,0,168,0),(988,71,0,168,0),(989,46,0,169,1),(990,54,0,169,1),(991,69,0,169,1),(992,70,0,169,0),(993,71,0,169,0),(994,46,0,170,1),(995,54,0,170,1),(996,69,0,170,1),(997,70,0,170,0),(998,71,0,170,0),(999,53,0,165,NULL),(1000,46,0,171,1),(1001,54,0,171,1),(1002,69,0,171,1),(1003,70,0,171,0),(1004,71,0,171,0),(1005,46,0,172,1),(1006,54,0,172,1),(1007,69,0,172,1),(1008,70,0,172,0),(1009,71,0,172,0),(1010,46,0,173,0),(1011,54,0,173,1),(1012,69,0,173,0),(1013,70,0,173,0),(1014,71,0,173,0),(1015,46,0,174,0),(1016,54,0,174,1),(1017,69,0,174,0),(1018,70,0,174,0),(1019,71,0,174,0),(1020,53,0,167,NULL),(1021,46,0,175,0),(1022,54,0,175,1),(1023,69,0,175,0),(1024,70,0,175,0),(1025,71,0,175,0),(1026,46,0,176,1),(1027,54,0,176,1),(1028,69,0,176,1),(1029,70,0,176,0),(1030,71,0,176,0),(1031,53,0,169,NULL),(1032,46,0,177,1),(1033,54,0,177,1),(1034,69,0,177,1),(1035,70,0,177,0),(1036,71,0,177,0),(1037,53,0,175,NULL),(1038,46,0,178,1),(1039,54,0,178,1),(1040,69,0,178,1),(1041,70,0,178,0),(1042,71,0,178,0),(1043,46,0,179,1),(1044,54,0,179,1),(1045,69,0,179,1),(1046,70,0,179,0),(1047,71,0,179,0),(1048,53,0,176,NULL),(1049,53,0,177,NULL),(1050,46,0,180,1),(1051,54,0,180,1),(1052,69,0,180,1),(1053,70,0,180,0),(1054,71,0,180,0),(1055,46,0,181,1),(1056,54,0,181,1),(1057,69,0,181,1),(1058,70,0,181,0),(1059,71,0,181,0),(1060,53,0,178,NULL),(1061,53,0,179,NULL),(1062,53,0,180,NULL),(1063,53,0,181,NULL),(1064,53,0,171,NULL),(1065,53,0,172,NULL),(1066,53,0,173,NULL),(1067,53,0,174,NULL),(1068,46,0,182,1),(1069,54,0,182,1),(1070,69,0,182,1),(1071,70,0,182,0),(1072,71,0,182,0),(1073,46,0,183,0),(1074,54,0,183,1),(1075,69,0,183,0),(1076,70,0,183,0),(1077,71,0,183,0),(1078,46,0,184,0),(1079,54,0,184,1),(1080,69,0,184,0),(1081,70,0,184,0),(1082,71,0,184,0),(1083,46,0,185,0),(1084,54,0,185,1),(1085,69,0,185,0),(1086,70,0,185,0),(1087,71,0,185,0),(1088,53,0,182,NULL),(1089,53,0,183,NULL),(1090,53,0,184,NULL),(1091,46,0,186,0),(1092,54,0,186,1),(1093,69,0,186,0),(1094,70,0,186,0),(1095,71,0,186,0),(1096,53,0,185,NULL),(1097,46,0,187,1),(1098,54,0,187,1),(1099,69,0,187,1),(1100,70,0,187,0),(1101,71,0,187,0),(1102,53,0,186,NULL),(1103,46,0,188,0),(1104,54,0,188,1),(1105,69,0,188,0),(1106,70,0,188,0),(1107,71,0,188,0),(1108,46,0,189,0),(1109,54,0,189,1),(1110,69,0,189,0),(1111,70,0,189,0),(1112,71,0,189,0),(1113,46,0,190,1),(1114,54,0,190,1),(1115,69,0,190,1),(1116,70,0,190,0),(1117,71,0,190,0),(1118,46,0,191,1),(1119,54,0,191,1),(1120,69,0,191,1),(1121,70,0,191,0),(1122,71,0,191,0),(1123,46,0,192,1),(1124,54,0,192,1),(1125,69,0,192,1),(1126,70,0,192,0),(1127,71,0,192,0),(1128,46,0,193,1),(1129,54,0,193,1),(1130,69,0,193,1),(1131,70,0,193,0),(1132,71,0,193,0),(1133,46,0,194,1),(1134,54,0,194,1),(1135,69,0,194,1),(1136,70,0,194,0),(1137,71,0,194,0),(1138,46,0,195,1),(1139,54,0,195,1),(1140,69,0,195,1),(1141,70,0,195,0),(1142,71,0,195,0),(1143,46,0,196,1),(1144,54,0,196,1),(1145,69,0,196,1),(1146,70,0,196,0),(1147,71,0,196,0),(1148,53,0,187,NULL),(1149,46,0,197,1),(1150,54,0,197,1),(1151,69,0,197,1),(1152,70,0,197,0),(1153,71,0,197,0),(1154,53,0,189,NULL),(1155,53,0,190,NULL),(1156,53,0,188,NULL),(1157,53,0,191,NULL),(1158,53,0,192,NULL),(1159,53,0,193,NULL),(1160,53,0,194,NULL),(1161,53,0,195,NULL),(1162,53,0,196,NULL),(1163,53,0,197,NULL),(1164,151,0,130,0),(1165,151,0,3,0),(1166,53,0,20,NULL),(1167,151,0,20,0),(1168,151,0,21,0),(1169,151,0,23,0),(1170,46,0,198,1),(1171,54,0,198,1),(1172,69,0,198,1),(1173,70,0,198,0),(1174,71,0,198,0),(1175,151,0,198,0),(1176,46,0,199,1),(1177,54,0,199,1),(1178,69,0,199,1),(1179,70,0,199,0),(1180,71,0,199,0),(1181,151,0,199,0),(1182,53,0,199,NULL),(1183,46,0,200,1),(1184,54,0,200,1),(1185,69,0,200,1),(1186,70,0,200,0),(1187,71,0,200,0),(1188,151,0,200,0),(1189,46,0,201,1),(1190,54,0,201,1),(1191,69,0,201,1),(1192,70,0,201,0),(1193,71,0,201,0),(1194,151,0,201,0),(1195,46,0,202,1),(1196,54,0,202,1),(1197,69,0,202,1),(1198,70,0,202,0),(1199,71,0,202,0),(1200,151,0,202,0),(1201,46,0,203,1),(1202,54,0,203,1),(1203,69,0,203,1),(1204,70,0,203,0),(1205,71,0,203,0),(1206,151,0,203,0),(1207,46,0,204,1),(1208,54,0,204,1),(1209,69,0,204,1),(1210,70,0,204,0),(1211,71,0,204,0),(1212,151,0,204,0),(1213,46,0,205,1),(1214,54,0,205,1),(1215,69,0,205,1),(1216,70,0,205,0),(1217,71,0,205,0),(1218,151,0,205,0),(1232,46,0,208,1),(1233,54,0,208,1),(1234,69,0,208,1),(1235,70,0,208,0),(1236,71,0,208,0),(1237,151,0,208,0),(1238,46,0,209,1),(1239,54,0,209,1),(1240,69,0,209,1),(1241,70,0,209,0),(1242,71,0,209,0),(1243,151,0,209,0),(1244,46,0,210,1),(1245,54,0,210,1),(1246,69,0,210,1),(1247,70,0,210,0),(1248,71,0,210,0),(1249,151,0,210,0),(1250,46,0,211,1),(1251,54,0,211,1),(1252,69,0,211,1),(1253,70,0,211,0),(1254,71,0,211,0),(1255,151,0,211,0),(1256,46,0,212,1),(1257,54,0,212,1),(1258,69,0,212,1),(1259,70,0,212,0),(1260,71,0,212,0),(1261,151,0,212,0),(1262,46,0,213,1),(1263,54,0,213,1),(1264,69,0,213,1),(1265,70,0,213,0),(1266,71,0,213,0),(1267,151,0,213,0),(1268,46,0,214,1),(1269,54,0,214,1),(1270,69,0,214,1),(1271,70,0,214,0),(1272,71,0,214,0),(1273,151,0,214,0),(1274,46,0,215,1),(1275,54,0,215,1),(1276,69,0,215,1),(1277,70,0,215,0),(1278,71,0,215,0),(1279,151,0,215,0),(1280,46,0,216,1),(1281,54,0,216,1),(1282,69,0,216,1),(1283,70,0,216,0),(1284,71,0,216,0),(1285,151,0,216,0),(1298,46,0,219,1),(1299,54,0,219,1),(1300,69,0,219,1),(1301,70,0,219,0),(1302,71,0,219,0),(1303,151,0,219,0),(1310,151,0,25,0),(1311,151,0,26,0),(1312,46,0,221,1),(1313,54,0,221,1),(1314,69,0,221,1),(1315,70,0,221,0),(1316,71,0,221,0),(1317,151,0,221,0),(1318,46,0,222,1),(1319,54,0,222,1),(1320,69,0,222,1),(1321,70,0,222,0),(1322,71,0,222,0),(1323,151,0,222,0),(1324,46,0,223,1),(1325,54,0,223,1),(1326,69,0,223,1),(1327,70,0,223,0),(1328,71,0,223,0),(1329,151,0,223,0),(1330,46,0,224,1),(1331,54,0,224,1),(1332,69,0,224,1),(1333,70,0,224,0),(1334,71,0,224,0),(1335,151,0,224,0),(1336,46,0,225,1),(1337,54,0,225,1),(1338,69,0,225,1),(1339,70,0,225,0),(1340,71,0,225,0),(1341,151,0,225,0),(1342,151,0,29,0),(1343,151,0,34,0),(1344,151,0,35,0),(1345,151,0,36,0),(1346,46,0,226,1),(1347,54,0,226,1),(1348,69,0,226,1),(1349,70,0,226,0),(1350,71,0,226,0),(1351,151,0,226,0),(1352,46,0,227,1),(1353,54,0,227,1),(1354,69,0,227,1),(1355,70,0,227,0),(1356,71,0,227,0),(1357,151,0,227,0),(1364,46,0,229,1),(1365,54,0,229,1),(1366,69,0,229,1),(1367,70,0,229,0),(1368,71,0,229,0),(1369,151,0,229,0),(1370,46,0,230,1),(1371,54,0,230,1),(1372,69,0,230,1),(1373,70,0,230,0),(1374,71,0,230,0),(1375,151,0,230,0),(1376,46,0,231,1),(1377,54,0,231,1),(1378,69,0,231,1),(1379,70,0,231,0),(1380,71,0,231,0),(1381,151,0,231,0),(1382,46,0,232,1),(1383,54,0,232,1),(1384,69,0,232,1),(1385,70,0,232,0),(1386,71,0,232,0),(1387,151,0,232,0),(1388,46,0,233,1),(1389,54,0,233,1),(1390,69,0,233,1),(1391,70,0,233,0),(1392,71,0,233,0),(1393,151,0,233,0),(1394,46,0,234,1),(1395,54,0,234,1),(1396,69,0,234,1),(1397,70,0,234,0),(1398,71,0,234,0),(1399,151,0,234,0),(1400,46,0,235,1),(1401,54,0,235,1),(1402,69,0,235,1),(1403,70,0,235,0),(1404,71,0,235,0),(1405,151,0,235,0),(1406,46,0,236,1),(1407,54,0,236,1),(1408,69,0,236,1),(1409,70,0,236,0),(1410,71,0,236,0),(1411,151,0,236,0),(1412,46,0,237,1),(1413,54,0,237,1),(1414,69,0,237,1),(1415,70,0,237,0),(1416,71,0,237,0),(1417,151,0,237,0),(1418,151,0,165,0),(1419,151,0,166,0),(1420,53,0,168,NULL),(1421,151,0,168,0),(1422,46,0,238,1),(1423,54,0,238,1),(1424,69,0,238,1),(1425,70,0,238,0),(1426,71,0,238,0),(1427,151,0,238,0),(1428,151,0,173,0),(1429,151,0,174,0),(1430,46,0,239,1),(1431,54,0,239,1),(1432,69,0,239,1),(1433,70,0,239,0),(1434,71,0,239,0),(1435,151,0,239,0),(1436,151,0,169,0),(1437,151,0,175,0),(1438,151,0,181,0),(1439,46,0,240,1),(1440,54,0,240,1),(1441,69,0,240,1),(1442,70,0,240,0),(1443,71,0,240,0),(1444,151,0,240,0),(1445,46,0,241,1),(1446,54,0,241,1),(1447,69,0,241,1),(1448,70,0,241,0),(1449,71,0,241,0),(1450,151,0,241,0),(1451,46,0,242,1),(1452,54,0,242,1),(1453,69,0,242,1),(1454,70,0,242,0),(1455,71,0,242,0),(1456,151,0,242,0),(1457,46,0,243,1),(1458,54,0,243,1),(1459,69,0,243,1),(1460,70,0,243,0),(1461,71,0,243,0),(1462,151,0,243,0),(1463,46,0,244,1),(1464,54,0,244,1),(1465,69,0,244,1),(1466,70,0,244,0),(1467,71,0,244,0),(1468,151,0,244,0),(1469,151,0,78,0),(1470,151,0,79,0),(1471,53,0,219,NULL),(1472,151,0,4,0),(1473,46,0,245,1),(1474,54,0,245,1),(1475,69,0,245,1),(1476,70,0,245,0),(1477,71,0,245,0),(1478,151,0,245,0),(1479,46,0,246,1),(1480,54,0,246,1),(1481,69,0,246,1),(1482,70,0,246,0),(1483,71,0,246,0),(1484,151,0,246,0),(1485,151,0,80,0),(1486,151,0,72,0),(1487,151,0,73,0),(1488,151,0,74,0),(1489,151,0,75,0),(1490,151,0,76,0),(1491,151,0,77,0),(1492,151,0,67,0),(1493,151,0,68,0),(1494,53,0,82,NULL),(1495,151,0,82,0),(1496,151,0,83,0),(1497,151,0,84,0),(1498,151,0,85,0),(1499,151,0,86,0),(1500,46,0,247,1),(1501,54,0,247,1),(1502,69,0,247,1),(1503,70,0,247,0),(1504,71,0,247,0),(1505,151,0,247,0),(1506,46,0,248,1),(1507,54,0,248,1),(1508,69,0,248,1),(1509,70,0,248,0),(1510,71,0,248,0),(1511,151,0,248,0),(1512,46,0,249,1),(1513,54,0,249,1),(1514,69,0,249,1),(1515,70,0,249,0),(1516,71,0,249,0),(1517,151,0,249,0),(1518,46,0,250,1),(1519,54,0,250,1),(1520,69,0,250,1),(1521,70,0,250,0),(1522,71,0,250,0),(1523,151,0,250,0),(1524,46,0,251,1),(1525,54,0,251,1),(1526,69,0,251,1),(1527,70,0,251,0),(1528,71,0,251,0),(1529,151,0,251,0),(1530,46,0,252,1),(1531,54,0,252,1),(1532,69,0,252,1),(1533,70,0,252,0),(1534,71,0,252,0),(1535,151,0,252,0),(1536,46,0,253,1),(1537,54,0,253,1),(1538,69,0,253,1),(1539,70,0,253,0),(1540,71,0,253,0),(1541,151,0,253,0),(1542,46,0,254,1),(1543,54,0,254,1),(1544,69,0,254,1),(1545,70,0,254,0),(1546,71,0,254,0),(1547,151,0,254,0),(1548,46,0,255,1),(1549,54,0,255,1),(1550,69,0,255,1),(1551,70,0,255,0),(1552,71,0,255,0),(1553,151,0,255,0),(1554,46,0,256,1),(1555,54,0,256,1),(1556,69,0,256,1),(1557,70,0,256,0),(1558,71,0,256,0),(1559,151,0,256,0),(1560,46,0,257,1),(1561,54,0,257,1),(1562,69,0,257,1),(1563,70,0,257,0),(1564,71,0,257,0),(1565,151,0,257,0),(1566,151,0,38,0),(1567,151,0,182,0),(1568,46,0,258,1),(1569,54,0,258,1),(1570,69,0,258,1),(1571,70,0,258,0),(1572,71,0,258,0),(1573,151,0,258,0),(1574,151,0,45,0),(1575,46,0,259,1),(1576,54,0,259,1),(1577,69,0,259,1),(1578,70,0,259,0),(1579,71,0,259,0),(1580,151,0,259,0),(1581,46,0,260,1),(1582,54,0,260,1),(1583,69,0,260,1),(1584,70,0,260,0),(1585,71,0,260,0),(1586,151,0,260,0),(1587,46,0,261,1),(1588,54,0,261,1),(1589,69,0,261,1),(1590,70,0,261,0),(1591,71,0,261,0),(1592,151,0,261,0),(1593,151,0,183,0),(1594,151,0,184,0),(1595,151,0,185,0),(1596,151,0,186,0),(1597,151,0,188,0),(1598,151,0,189,0),(1599,46,0,262,1),(1600,54,0,262,1),(1601,69,0,262,1),(1602,70,0,262,0),(1603,71,0,262,0),(1604,151,0,262,0),(1605,53,0,262,NULL),(1606,46,0,263,1),(1607,54,0,263,1),(1608,69,0,263,1),(1609,70,0,263,0),(1610,71,0,263,0),(1611,151,0,263,0),(1612,46,0,264,1),(1613,54,0,264,1),(1614,69,0,264,1),(1615,70,0,264,0),(1616,71,0,264,0),(1617,151,0,264,0),(1618,46,0,265,1),(1619,54,0,265,1),(1620,69,0,265,1),(1621,70,0,265,0),(1622,71,0,265,0),(1623,151,0,265,0),(1624,46,0,266,1),(1625,54,0,266,1),(1626,69,0,266,1),(1627,70,0,266,0),(1628,71,0,266,0),(1629,151,0,266,0),(1630,46,0,267,1),(1631,54,0,267,1),(1632,69,0,267,1),(1633,70,0,267,0),(1634,71,0,267,0),(1635,151,0,267,0),(1636,46,0,268,1),(1637,54,0,268,1),(1638,69,0,268,1),(1639,70,0,268,0),(1640,71,0,268,0),(1641,151,0,268,0),(1642,46,0,269,1),(1643,54,0,269,1),(1644,69,0,269,1),(1645,70,0,269,0),(1646,71,0,269,0),(1647,151,0,269,0),(1648,46,0,270,1),(1649,54,0,270,1),(1650,69,0,270,1),(1651,70,0,270,0),(1652,71,0,270,0),(1653,151,0,270,0),(1654,46,0,271,1),(1655,54,0,271,1),(1656,69,0,271,1),(1657,70,0,271,0),(1658,71,0,271,0),(1659,151,0,271,0),(1660,46,0,272,1),(1661,54,0,272,1),(1662,69,0,272,1),(1663,70,0,272,0),(1664,71,0,272,0),(1665,151,0,272,0),(1666,46,0,273,1),(1667,54,0,273,1),(1668,69,0,273,1),(1669,70,0,273,0),(1670,71,0,273,0),(1671,151,0,273,0),(1672,46,0,274,1),(1673,54,0,274,1),(1674,69,0,274,1),(1675,70,0,274,0),(1676,71,0,274,0),(1677,151,0,274,0),(1678,46,0,275,1),(1679,54,0,275,1),(1680,69,0,275,1),(1681,70,0,275,0),(1682,71,0,275,0),(1683,151,0,275,0),(1684,151,0,151,0),(1685,46,0,276,1),(1686,54,0,276,1),(1687,69,0,276,1),(1688,70,0,276,0),(1689,71,0,276,0),(1690,151,0,276,0),(1691,46,0,277,1),(1692,54,0,277,1),(1693,69,0,277,1),(1694,70,0,277,0),(1695,71,0,277,0),(1696,151,0,277,0),(1697,46,0,278,1),(1698,54,0,278,1),(1699,69,0,278,1),(1700,70,0,278,0),(1701,71,0,278,0),(1702,151,0,278,0),(1703,151,0,154,0),(1704,46,0,279,1),(1705,54,0,279,1),(1706,69,0,279,1),(1707,70,0,279,0),(1708,71,0,279,0),(1709,151,0,279,0),(1710,46,0,280,1),(1711,54,0,280,1),(1712,69,0,280,1),(1713,70,0,280,0),(1714,71,0,280,0),(1715,151,0,280,0),(1722,46,0,282,1),(1723,54,0,282,1),(1724,69,0,282,1),(1725,70,0,282,0),(1726,71,0,282,0),(1727,151,0,282,0),(1728,151,0,153,0),(1729,151,0,156,0),(1730,151,0,157,0),(1731,151,0,150,0),(1732,151,0,54,0),(1733,151,0,55,0),(1734,46,0,283,1),(1735,54,0,283,1),(1736,69,0,283,1),(1737,70,0,283,0),(1738,71,0,283,0),(1739,151,0,283,0),(1740,46,0,284,1),(1741,54,0,284,1),(1742,69,0,284,1),(1743,70,0,284,0),(1744,71,0,284,0),(1745,151,0,284,0),(1746,46,0,285,1),(1747,54,0,285,1),(1748,69,0,285,1),(1749,70,0,285,0),(1750,71,0,285,0),(1751,151,0,285,0),(1752,46,0,286,1),(1753,54,0,286,1),(1754,69,0,286,1),(1755,70,0,286,0),(1756,71,0,286,0),(1757,151,0,286,0),(1758,46,0,287,1),(1759,54,0,287,1),(1760,69,0,287,1),(1761,70,0,287,0),(1762,71,0,287,0),(1763,151,0,287,0),(1764,46,0,288,1),(1765,54,0,288,1),(1766,69,0,288,1),(1767,70,0,288,0),(1768,71,0,288,0),(1769,151,0,288,0),(1770,46,0,289,1),(1771,54,0,289,1),(1772,69,0,289,1),(1773,70,0,289,0),(1774,71,0,289,0),(1775,151,0,289,0),(1776,46,0,290,1),(1777,54,0,290,1),(1778,69,0,290,1),(1779,70,0,290,0),(1780,71,0,290,0),(1781,151,0,290,0),(1782,46,0,291,1),(1783,54,0,291,1),(1784,69,0,291,1),(1785,70,0,291,0),(1786,71,0,291,0),(1787,151,0,291,0),(1788,46,0,292,1),(1789,54,0,292,1),(1790,69,0,292,1),(1791,70,0,292,0),(1792,71,0,292,0),(1793,151,0,292,0),(1794,46,0,293,1),(1795,54,0,293,1),(1796,69,0,293,1),(1797,70,0,293,0),(1798,71,0,293,0),(1799,151,0,293,0),(1800,46,0,294,1),(1801,54,0,294,1),(1802,69,0,294,1),(1803,70,0,294,0),(1804,71,0,294,0),(1805,151,0,294,0),(1806,151,0,56,0),(1807,46,0,295,1),(1808,54,0,295,1),(1809,69,0,295,1),(1810,70,0,295,0),(1811,71,0,295,0),(1812,151,0,295,0),(1813,151,0,47,0),(1814,151,0,48,0),(1815,151,0,49,0),(1816,46,0,296,1),(1817,54,0,296,1),(1818,69,0,296,1),(1819,70,0,296,0),(1820,71,0,296,0),(1821,151,0,296,0),(1822,46,0,297,1),(1823,54,0,297,1),(1824,69,0,297,1),(1825,70,0,297,0),(1826,71,0,297,0),(1827,151,0,297,0),(1828,46,0,298,1),(1829,54,0,298,1),(1830,69,0,298,1),(1831,70,0,298,0),(1832,71,0,298,0),(1833,151,0,298,0),(1834,46,0,299,1),(1835,54,0,299,1),(1836,69,0,299,1),(1837,70,0,299,0),(1838,71,0,299,0),(1839,151,0,299,0),(1840,46,0,300,1),(1841,54,0,300,1),(1842,69,0,300,1),(1843,70,0,300,0),(1844,71,0,300,0),(1845,151,0,300,0),(1846,46,0,301,1),(1847,54,0,301,1),(1848,69,0,301,1),(1849,70,0,301,0),(1850,71,0,301,0),(1851,151,0,301,0),(1852,46,0,302,1),(1853,54,0,302,1),(1854,69,0,302,1),(1855,70,0,302,0),(1856,71,0,302,0),(1857,151,0,302,0),(1858,46,0,303,1),(1859,54,0,303,1),(1860,69,0,303,1),(1861,70,0,303,0),(1862,71,0,303,0),(1863,151,0,303,0),(1864,46,0,304,1),(1865,54,0,304,1),(1866,69,0,304,1),(1867,70,0,304,0),(1868,71,0,304,0),(1869,151,0,304,0),(1870,46,0,305,1),(1871,54,0,305,1),(1872,69,0,305,1),(1873,70,0,305,0),(1874,71,0,305,0),(1875,151,0,305,0),(1876,46,0,306,1),(1877,54,0,306,1),(1878,69,0,306,1),(1879,70,0,306,0),(1880,71,0,306,0),(1881,151,0,306,0),(1882,53,0,290,NULL),(1883,151,0,62,0),(1884,151,0,57,0),(1885,151,0,51,0),(1886,151,0,5,0),(1887,46,0,307,1),(1888,54,0,307,1),(1889,69,0,307,1),(1890,70,0,307,0),(1891,71,0,307,0),(1892,151,0,307,0),(1893,46,0,308,1),(1894,54,0,308,1),(1895,69,0,308,1),(1896,70,0,308,0),(1897,71,0,308,0),(1898,151,0,308,0),(1899,46,0,309,1),(1900,54,0,309,1),(1901,69,0,309,1),(1902,70,0,309,0),(1903,71,0,309,0),(1904,151,0,309,0),(1905,46,0,310,1),(1906,54,0,310,1),(1907,69,0,310,1),(1908,70,0,310,0),(1909,71,0,310,0),(1910,151,0,310,0),(1911,46,0,311,1),(1912,54,0,311,1),(1913,69,0,311,1),(1914,70,0,311,0),(1915,71,0,311,0),(1916,151,0,311,0),(1917,46,0,312,1),(1918,54,0,312,1),(1919,69,0,312,1),(1920,70,0,312,0),(1921,71,0,312,0),(1922,151,0,312,0),(1923,151,0,107,0),(1924,53,0,109,NULL),(1925,151,0,109,0),(1926,151,0,106,0),(1927,46,0,313,1),(1928,54,0,313,1),(1929,69,0,313,1),(1930,70,0,313,0),(1931,71,0,313,0),(1932,151,0,313,0),(1933,46,0,314,1),(1934,54,0,314,1),(1935,69,0,314,1),(1936,70,0,314,0),(1937,71,0,314,0),(1938,151,0,314,0),(1939,46,0,315,1),(1940,54,0,315,1),(1941,69,0,315,1),(1942,70,0,315,0),(1943,71,0,315,0),(1944,151,0,315,0),(1945,46,0,316,1),(1946,54,0,316,1),(1947,69,0,316,1),(1948,70,0,316,0),(1949,71,0,316,0),(1950,151,0,316,0),(1951,46,0,317,1),(1952,54,0,317,1),(1953,69,0,317,1),(1954,70,0,317,0),(1955,71,0,317,0),(1956,151,0,317,0),(1957,46,0,318,1),(1958,54,0,318,1),(1959,69,0,318,1),(1960,70,0,318,0),(1961,71,0,318,0),(1962,151,0,318,0),(1963,53,0,318,NULL),(1964,46,0,319,1),(1965,54,0,319,1),(1966,69,0,319,1),(1967,70,0,319,0),(1968,71,0,319,0),(1969,151,0,319,0),(1976,46,0,321,1),(1977,54,0,321,1),(1978,69,0,321,1),(1979,70,0,321,0),(1980,71,0,321,0),(1981,151,0,321,0),(1982,46,0,322,1),(1983,54,0,322,1),(1984,69,0,322,1),(1985,70,0,322,0),(1986,71,0,322,0),(1987,151,0,322,0),(1988,46,0,323,1),(1989,54,0,323,1),(1990,69,0,323,1),(1991,70,0,323,0),(1992,71,0,323,0),(1993,151,0,323,0),(1994,46,0,324,1),(1995,54,0,324,1),(1996,69,0,324,1),(1997,70,0,324,0),(1998,71,0,324,0),(1999,151,0,324,0),(2000,46,0,325,1),(2001,54,0,325,1),(2002,69,0,325,1),(2003,70,0,325,0),(2004,71,0,325,0),(2005,151,0,325,0),(2006,46,0,326,1),(2007,54,0,326,1),(2008,69,0,326,1),(2009,70,0,326,0),(2010,71,0,326,0),(2011,151,0,326,0),(2012,46,0,327,1),(2013,54,0,327,1),(2014,69,0,327,1),(2015,70,0,327,0),(2016,71,0,327,0),(2017,151,0,327,0),(2018,46,0,328,1),(2019,54,0,328,1),(2020,69,0,328,1),(2021,70,0,328,0),(2022,71,0,328,0),(2023,151,0,328,0),(2024,46,0,329,1),(2025,54,0,329,1),(2026,69,0,329,1),(2027,70,0,329,0),(2028,71,0,329,0),(2029,151,0,329,0),(2030,151,0,110,0),(2031,46,0,330,1),(2032,54,0,330,1),(2033,69,0,330,1),(2034,70,0,330,0),(2035,71,0,330,0),(2036,151,0,330,0),(2037,46,0,331,1),(2038,54,0,331,1),(2039,69,0,331,1),(2040,70,0,331,0),(2041,71,0,331,0),(2042,151,0,331,0),(2043,46,0,332,1),(2044,54,0,332,1),(2045,69,0,332,1),(2046,70,0,332,0),(2047,71,0,332,0),(2048,151,0,332,0),(2061,46,0,335,1),(2062,54,0,335,1),(2063,69,0,335,1),(2064,70,0,335,0),(2065,71,0,335,0),(2066,151,0,335,0),(2067,46,0,336,1),(2068,54,0,336,1),(2069,69,0,336,1),(2070,70,0,336,0),(2071,71,0,336,0),(2072,151,0,336,0),(2073,151,0,146,0),(2074,151,0,147,0),(2075,53,0,148,NULL),(2076,151,0,148,0),(2077,151,0,149,0),(2078,151,0,87,0),(2079,151,0,96,0),(2080,46,0,337,1),(2081,54,0,337,1),(2082,69,0,337,1),(2083,70,0,337,0),(2084,71,0,337,0),(2085,151,0,337,0),(2086,46,0,338,1),(2087,54,0,338,1),(2088,69,0,338,1),(2089,70,0,338,0),(2090,71,0,338,0),(2091,151,0,338,0),(2092,46,0,339,1),(2093,54,0,339,1),(2094,69,0,339,1),(2095,70,0,339,0),(2096,71,0,339,0),(2097,151,0,339,0),(2098,46,0,340,1),(2099,54,0,340,1),(2100,69,0,340,1),(2101,70,0,340,0),(2102,71,0,340,0),(2103,151,0,340,0),(2104,46,0,341,1),(2105,54,0,341,1),(2106,69,0,341,1),(2107,70,0,341,0),(2108,71,0,341,0),(2109,151,0,341,0),(2110,46,0,342,1),(2111,54,0,342,1),(2112,69,0,342,1),(2113,70,0,342,0),(2114,71,0,342,0),(2115,151,0,342,0),(2116,46,0,343,1),(2117,54,0,343,1),(2118,69,0,343,1),(2119,70,0,343,0),(2120,71,0,343,0),(2121,151,0,343,0),(2122,46,0,344,1),(2123,54,0,344,1),(2124,69,0,344,1),(2125,70,0,344,0),(2126,71,0,344,0),(2127,151,0,344,0),(2128,46,0,345,1),(2129,54,0,345,1),(2130,69,0,345,1),(2131,70,0,345,0),(2132,71,0,345,0),(2133,151,0,345,0),(2134,46,0,346,1),(2135,54,0,346,1),(2136,69,0,346,1),(2137,70,0,346,0),(2138,71,0,346,0),(2139,151,0,346,0),(2140,46,0,347,1),(2141,54,0,347,1),(2142,69,0,347,1),(2143,70,0,347,0),(2144,71,0,347,0),(2145,151,0,347,0),(2146,46,0,348,1),(2147,54,0,348,1),(2148,69,0,348,1),(2149,70,0,348,0),(2150,71,0,348,0),(2151,151,0,348,0),(2152,46,0,349,1),(2153,54,0,349,1),(2154,69,0,349,1),(2155,70,0,349,0),(2156,71,0,349,0),(2157,151,0,349,0),(2158,46,0,350,1),(2159,54,0,350,1),(2160,69,0,350,1),(2161,70,0,350,0),(2162,71,0,350,0),(2163,151,0,350,0),(2164,46,0,351,1),(2165,54,0,351,1),(2166,69,0,351,1),(2167,70,0,351,0),(2168,71,0,351,0),(2169,151,0,351,0),(2170,46,0,352,1),(2171,54,0,352,1),(2172,69,0,352,1),(2173,70,0,352,0),(2174,71,0,352,0),(2175,151,0,352,0),(2176,46,0,353,1),(2177,54,0,353,1),(2178,69,0,353,1),(2179,70,0,353,0),(2180,71,0,353,0),(2181,151,0,353,0),(2182,46,0,354,1),(2183,54,0,354,1),(2184,69,0,354,1),(2185,70,0,354,0),(2186,71,0,354,0),(2187,151,0,354,0),(2188,46,0,355,1),(2189,54,0,355,1),(2190,69,0,355,1),(2191,70,0,355,0),(2192,71,0,355,0),(2193,151,0,355,0),(2194,46,0,356,1),(2195,54,0,356,1),(2196,69,0,356,1),(2197,70,0,356,0),(2198,71,0,356,0),(2199,151,0,356,0),(2206,46,0,358,1),(2207,54,0,358,1),(2208,69,0,358,1),(2209,70,0,358,0),(2210,71,0,358,0),(2211,151,0,358,0),(2212,46,0,359,1),(2213,54,0,359,1),(2214,69,0,359,1),(2215,70,0,359,0),(2216,71,0,359,0),(2217,151,0,359,0),(2218,46,0,360,1),(2219,54,0,360,1),(2220,69,0,360,1),(2221,70,0,360,0),(2222,71,0,360,0),(2223,151,0,360,0),(2224,46,0,361,1),(2225,54,0,361,1),(2226,69,0,361,1),(2227,70,0,361,0),(2228,71,0,361,0),(2229,151,0,361,0),(2230,46,0,362,1),(2231,54,0,362,1),(2232,69,0,362,1),(2233,70,0,362,0),(2234,71,0,362,0),(2235,151,0,362,0),(2236,46,0,363,1),(2237,54,0,363,1),(2238,69,0,363,1),(2239,70,0,363,0),(2240,71,0,363,0),(2241,151,0,363,0),(2242,46,0,364,1),(2243,54,0,364,1),(2244,69,0,364,1),(2245,70,0,364,0),(2246,71,0,364,0),(2247,151,0,364,0),(2248,46,0,365,1),(2249,54,0,365,1),(2250,69,0,365,1),(2251,70,0,365,0),(2252,71,0,365,0),(2253,151,0,365,0),(2254,46,0,366,1),(2255,54,0,366,1),(2256,69,0,366,1),(2257,70,0,366,0),(2258,71,0,366,0),(2259,151,0,366,0),(2260,46,0,367,1),(2261,54,0,367,1),(2262,69,0,367,1),(2263,70,0,367,0),(2264,71,0,367,0),(2265,151,0,367,0),(2266,46,0,368,1),(2267,54,0,368,1),(2268,69,0,368,1),(2269,70,0,368,0),(2270,71,0,368,0),(2271,151,0,368,0),(2272,46,0,369,1),(2273,54,0,369,1),(2274,69,0,369,1),(2275,70,0,369,0),(2276,71,0,369,0),(2277,151,0,369,0),(2278,46,0,370,1),(2279,54,0,370,1),(2280,69,0,370,1),(2281,70,0,370,0),(2282,71,0,370,0),(2283,151,0,370,0),(2284,53,0,370,NULL),(2285,151,0,141,0),(2286,151,0,140,0),(2287,151,0,138,0),(2288,151,0,142,0),(2289,46,0,371,1),(2290,54,0,371,1),(2291,69,0,371,1),(2292,70,0,371,0),(2293,71,0,371,0),(2294,151,0,371,0),(2295,46,0,372,1),(2296,54,0,372,1),(2297,69,0,372,1),(2298,70,0,372,0),(2299,71,0,372,0),(2300,151,0,372,0),(2301,46,0,373,1),(2302,54,0,373,1),(2303,69,0,373,1),(2304,70,0,373,0),(2305,71,0,373,0),(2306,151,0,373,0),(2307,46,0,374,1),(2308,54,0,374,1),(2309,69,0,374,1),(2310,70,0,374,0),(2311,71,0,374,0),(2312,151,0,374,0),(2313,46,0,375,1),(2314,54,0,375,1),(2315,69,0,375,1),(2316,70,0,375,0),(2317,71,0,375,0),(2318,151,0,375,0),(2319,46,0,376,1),(2320,54,0,376,1),(2321,69,0,376,1),(2322,70,0,376,0),(2323,71,0,376,0),(2324,151,0,376,0),(2325,46,0,377,1),(2326,54,0,377,1),(2327,69,0,377,1),(2328,70,0,377,0),(2329,71,0,377,0),(2330,151,0,377,0),(2331,151,0,6,0),(2332,46,0,378,1),(2333,54,0,378,1),(2334,69,0,378,1),(2335,70,0,378,0),(2336,71,0,378,0),(2337,151,0,378,0),(2338,46,0,379,1),(2339,54,0,379,1),(2340,69,0,379,1),(2341,70,0,379,0),(2342,71,0,379,0),(2343,151,0,379,0),(2344,151,0,119,0),(2345,151,0,114,0),(2346,46,0,380,1),(2347,54,0,380,1),(2348,69,0,380,1),(2349,70,0,380,0),(2350,71,0,380,0),(2351,151,0,380,0),(2352,151,0,112,0),(2353,151,0,116,0),(2354,151,0,122,0),(2355,151,0,133,0),(2356,46,0,381,1),(2357,54,0,381,1),(2358,69,0,381,1),(2359,70,0,381,0),(2360,71,0,381,0),(2361,151,0,381,0),(2362,46,0,382,1),(2363,54,0,382,1),(2364,69,0,382,1),(2365,70,0,382,0),(2366,71,0,382,0),(2367,151,0,382,0),(2368,151,0,127,0),(2369,46,0,383,1),(2370,54,0,383,1),(2371,69,0,383,1),(2372,70,0,383,0),(2373,71,0,383,0),(2374,151,0,383,0),(2375,46,0,384,1),(2376,54,0,384,1),(2377,69,0,384,1),(2378,70,0,384,0),(2379,71,0,384,0),(2380,151,0,384,0),(2381,151,0,134,0),(2382,46,0,385,1),(2383,54,0,385,1),(2384,69,0,385,1),(2385,70,0,385,0),(2386,71,0,385,0),(2387,151,0,385,0),(2388,46,0,386,1),(2389,54,0,386,1),(2390,69,0,386,1),(2391,70,0,386,0),(2392,71,0,386,0),(2393,151,0,386,0),(2394,46,0,387,1),(2395,54,0,387,1),(2396,69,0,387,1),(2397,70,0,387,0),(2398,71,0,387,0),(2399,151,0,387,0),(2400,46,0,388,1),(2401,54,0,388,1),(2402,69,0,388,1),(2403,70,0,388,0),(2404,71,0,388,0),(2405,151,0,388,0),(2406,46,0,389,1),(2407,54,0,389,1),(2408,69,0,389,1),(2409,70,0,389,0),(2410,71,0,389,0),(2411,151,0,389,0),(2412,46,0,390,1),(2413,54,0,390,1),(2414,69,0,390,1),(2415,70,0,390,0),(2416,71,0,390,0),(2417,151,0,390,0),(2418,46,0,391,1),(2419,54,0,391,1),(2420,69,0,391,1),(2421,70,0,391,0),(2422,71,0,391,0),(2423,151,0,391,0),(2424,46,0,392,1),(2425,54,0,392,1),(2426,69,0,392,1),(2427,70,0,392,0),(2428,71,0,392,0),(2429,151,0,392,0),(2430,46,0,393,1),(2431,54,0,393,1),(2432,69,0,393,1),(2433,70,0,393,0),(2434,71,0,393,0),(2435,151,0,393,0),(2436,46,0,394,1),(2437,54,0,394,1),(2438,69,0,394,1),(2439,70,0,394,0),(2440,71,0,394,0),(2441,151,0,394,0),(2442,46,0,395,1),(2443,54,0,395,1),(2444,69,0,395,1),(2445,70,0,395,0),(2446,71,0,395,0),(2447,151,0,395,0),(2448,46,0,396,1),(2449,54,0,396,1),(2450,69,0,396,1),(2451,70,0,396,0),(2452,71,0,396,0),(2453,151,0,396,0),(2454,46,0,397,1),(2455,54,0,397,1),(2456,69,0,397,1),(2457,70,0,397,0),(2458,71,0,397,0),(2459,151,0,397,0),(2460,46,0,398,1),(2461,54,0,398,1),(2462,69,0,398,1),(2463,70,0,398,0),(2464,71,0,398,0),(2465,151,0,398,0),(2466,46,0,399,1),(2467,54,0,399,1),(2468,69,0,399,1),(2469,70,0,399,0),(2470,71,0,399,0),(2471,151,0,399,0),(2472,46,0,400,1),(2473,54,0,400,1),(2474,69,0,400,1),(2475,70,0,400,0),(2476,71,0,400,0),(2477,151,0,400,0),(2478,46,0,401,1),(2479,54,0,401,1),(2480,69,0,401,1),(2481,70,0,401,0),(2482,71,0,401,0),(2483,151,0,401,0),(2484,46,0,402,1),(2485,54,0,402,1),(2486,69,0,402,1),(2487,70,0,402,0),(2488,71,0,402,0),(2489,151,0,402,0),(2490,46,0,403,1),(2491,54,0,403,1),(2492,69,0,403,1),(2493,70,0,403,0),(2494,71,0,403,0),(2495,151,0,403,0),(2496,46,0,404,1),(2497,54,0,404,1),(2498,69,0,404,1),(2499,70,0,404,0),(2500,71,0,404,0),(2501,151,0,404,0),(2502,46,0,405,1),(2503,54,0,405,1),(2504,69,0,405,1),(2505,70,0,405,0),(2506,71,0,405,0),(2507,151,0,405,0),(2508,46,0,406,1),(2509,54,0,406,1),(2510,69,0,406,1),(2511,70,0,406,0),(2512,71,0,406,0),(2513,151,0,406,0),(2514,46,0,407,1),(2515,54,0,407,1),(2516,69,0,407,1),(2517,70,0,407,0),(2518,71,0,407,0),(2519,151,0,407,0),(2520,46,0,408,1),(2521,54,0,408,1),(2522,69,0,408,1),(2523,70,0,408,0),(2524,71,0,408,0),(2525,151,0,408,0),(2526,46,0,409,1),(2527,54,0,409,1),(2528,69,0,409,1),(2529,70,0,409,0),(2530,71,0,409,0),(2531,151,0,409,0),(2532,46,0,410,1),(2533,54,0,410,1),(2534,69,0,410,1),(2535,70,0,410,0),(2536,71,0,410,0),(2537,151,0,410,0),(2538,46,0,411,1),(2539,54,0,411,1),(2540,69,0,411,1),(2541,70,0,411,0),(2542,71,0,411,0),(2543,151,0,411,0),(2544,46,0,412,1),(2545,54,0,412,1),(2546,69,0,412,1),(2547,70,0,412,0),(2548,71,0,412,0),(2549,151,0,412,0),(2550,46,0,413,1),(2551,54,0,413,1),(2552,69,0,413,1),(2553,70,0,413,0),(2554,71,0,413,0),(2555,151,0,413,0),(2556,46,0,414,1),(2557,54,0,414,1),(2558,69,0,414,1),(2559,70,0,414,0),(2560,71,0,414,0),(2561,151,0,414,0),(2562,46,0,415,1),(2563,54,0,415,1),(2564,69,0,415,1),(2565,70,0,415,0),(2566,71,0,415,0),(2567,151,0,415,0),(2568,46,0,416,1),(2569,54,0,416,1),(2570,69,0,416,1),(2571,70,0,416,0),(2572,71,0,416,0),(2573,151,0,416,0),(2574,46,0,417,1),(2575,54,0,417,1),(2576,69,0,417,1),(2577,70,0,417,0),(2578,71,0,417,0),(2579,151,0,417,0),(2580,46,0,418,1),(2581,54,0,418,1),(2582,69,0,418,1),(2583,70,0,418,0),(2584,71,0,418,0),(2585,151,0,418,0),(2586,46,0,419,1),(2587,54,0,419,1),(2588,69,0,419,1),(2589,70,0,419,0),(2590,71,0,419,0),(2591,151,0,419,0),(2592,46,0,420,1),(2593,54,0,420,1),(2594,69,0,420,1),(2595,70,0,420,0),(2596,71,0,420,0),(2597,151,0,420,0),(2598,46,0,421,1),(2599,54,0,421,1),(2600,69,0,421,1),(2601,70,0,421,0),(2602,71,0,421,0),(2603,151,0,421,0),(2604,46,0,422,1),(2605,54,0,422,1),(2606,69,0,422,1),(2607,70,0,422,0),(2608,71,0,422,0),(2609,151,0,422,0),(2610,46,0,423,1),(2611,54,0,423,1),(2612,69,0,423,1),(2613,70,0,423,0),(2614,71,0,423,0),(2615,151,0,423,0),(2616,46,0,424,1),(2617,54,0,424,1),(2618,69,0,424,1),(2619,70,0,424,0),(2620,71,0,424,0),(2621,151,0,424,0),(2622,46,0,425,1),(2623,54,0,425,1),(2624,69,0,425,1),(2625,70,0,425,0),(2626,71,0,425,0),(2627,151,0,425,0),(2628,46,0,426,1),(2629,54,0,426,1),(2630,69,0,426,1),(2631,70,0,426,0),(2632,71,0,426,0),(2633,151,0,426,0),(2634,46,0,427,1),(2635,54,0,427,1),(2636,69,0,427,1),(2637,70,0,427,0),(2638,71,0,427,0),(2639,151,0,427,0),(2640,46,0,428,1),(2641,54,0,428,1),(2642,69,0,428,1),(2643,70,0,428,0),(2644,71,0,428,0),(2645,151,0,428,0),(2646,46,0,429,1),(2647,54,0,429,1),(2648,69,0,429,1),(2649,70,0,429,0),(2650,71,0,429,0),(2651,151,0,429,0),(2652,46,0,430,1),(2653,54,0,430,1),(2654,69,0,430,1),(2655,70,0,430,0),(2656,71,0,430,0),(2657,151,0,430,0),(2658,46,0,431,1),(2659,54,0,431,1),(2660,69,0,431,1),(2661,70,0,431,0),(2662,71,0,431,0),(2663,151,0,431,0),(2664,46,0,432,1),(2665,54,0,432,1),(2666,69,0,432,1),(2667,70,0,432,0),(2668,71,0,432,0),(2669,151,0,432,0),(2670,46,0,433,1),(2671,54,0,433,1),(2672,69,0,433,1),(2673,70,0,433,0),(2674,71,0,433,0),(2675,151,0,433,0),(2676,46,0,434,1),(2677,54,0,434,1),(2678,69,0,434,1),(2679,70,0,434,0),(2680,71,0,434,0),(2681,151,0,434,0),(2682,46,0,435,1),(2683,54,0,435,1),(2684,69,0,435,1),(2685,70,0,435,0),(2686,71,0,435,0),(2687,151,0,435,0),(2688,46,0,436,1),(2689,54,0,436,1),(2690,69,0,436,1),(2691,70,0,436,0),(2692,71,0,436,0),(2693,151,0,436,0),(2694,46,0,437,1),(2695,54,0,437,1),(2696,69,0,437,1),(2697,70,0,437,0),(2698,71,0,437,0),(2699,151,0,437,0),(2700,46,0,438,1),(2701,54,0,438,1),(2702,69,0,438,1),(2703,70,0,438,0),(2704,71,0,438,0),(2705,151,0,438,0),(2706,46,0,439,1),(2707,54,0,439,1),(2708,69,0,439,1),(2709,70,0,439,0),(2710,71,0,439,0),(2711,151,0,439,0),(2712,46,0,440,1),(2713,54,0,440,1),(2714,69,0,440,1),(2715,70,0,440,0),(2716,71,0,440,0),(2717,151,0,440,0),(2718,46,0,441,1),(2719,54,0,441,1),(2720,69,0,441,1),(2721,70,0,441,0),(2722,71,0,441,0),(2723,151,0,441,0),(2724,46,0,442,1),(2725,54,0,442,1),(2726,69,0,442,1),(2727,70,0,442,0),(2728,71,0,442,0),(2729,151,0,442,0),(2730,46,0,443,1),(2731,54,0,443,1),(2732,69,0,443,1),(2733,70,0,443,0),(2734,71,0,443,0),(2735,151,0,443,0),(2736,151,0,10,0),(2737,151,0,11,0),(2738,53,0,203,NULL),(2739,53,0,405,NULL),(2740,46,0,444,1),(2741,54,0,444,1),(2742,69,0,444,1),(2743,70,0,444,0),(2744,71,0,444,0),(2745,151,0,444,0),(2746,53,0,444,NULL),(2747,53,0,406,NULL),(2748,53,0,407,NULL),(2749,53,0,408,NULL),(2750,53,0,409,NULL),(2751,53,0,410,NULL),(2752,53,0,411,NULL),(2753,53,0,413,NULL),(2754,53,0,414,NULL),(2755,53,0,415,NULL),(2756,53,0,416,NULL),(2757,53,0,417,NULL),(2758,53,0,418,NULL),(2759,53,0,419,NULL),(2760,53,0,420,NULL),(2761,53,0,422,NULL),(2762,53,0,424,NULL),(2763,53,0,425,NULL),(2764,53,0,426,NULL),(2765,53,0,427,NULL),(2766,53,0,429,NULL),(2767,53,0,430,NULL),(2768,53,0,431,NULL),(2769,53,0,432,NULL),(2770,53,0,433,NULL),(2771,53,0,434,NULL),(2772,53,0,435,NULL),(2773,53,0,436,NULL),(2774,53,0,437,NULL),(2775,53,0,439,NULL),(2776,53,0,441,NULL),(2777,53,0,442,NULL),(2778,53,0,443,NULL),(2779,53,0,440,NULL),(2780,53,0,368,NULL),(2781,151,0,143,0),(2782,53,0,371,NULL),(2783,53,0,373,NULL),(2784,53,0,374,NULL),(2785,53,0,375,NULL),(2786,53,0,376,NULL),(2787,53,0,377,NULL),(2788,53,0,366,NULL),(2789,53,0,307,NULL),(2790,151,0,121,0),(2791,151,0,123,0),(2792,151,0,118,0),(2793,53,0,379,NULL),(2794,151,0,113,0),(2795,151,0,132,0),(2796,53,0,381,NULL),(2797,53,0,382,NULL),(2798,151,0,124,0),(2799,151,0,128,0),(2800,151,0,125,0),(2801,53,0,383,NULL),(2802,151,0,126,0),(2803,53,0,385,NULL),(2804,53,0,386,NULL),(2805,53,0,387,NULL),(2806,46,0,445,1),(2807,54,0,445,1),(2808,69,0,445,1),(2809,70,0,445,0),(2810,71,0,445,0),(2811,151,0,445,0),(2812,53,0,445,NULL),(2813,53,0,308,NULL),(2814,53,0,309,NULL),(2815,53,0,310,NULL),(2816,53,0,311,NULL),(2817,53,0,312,NULL),(2818,53,0,313,NULL),(2819,151,0,108,0),(2820,53,0,314,NULL),(2821,53,0,315,NULL),(2822,53,0,322,NULL),(2823,53,0,324,NULL),(2824,53,0,325,NULL),(2825,53,0,326,NULL),(2826,53,0,328,NULL),(2827,53,0,327,NULL),(2828,151,0,145,0),(2829,53,0,329,NULL),(2830,53,0,330,NULL),(2831,53,0,331,NULL),(2832,53,0,336,NULL),(2833,53,0,345,NULL),(2834,53,0,346,NULL),(2835,53,0,338,NULL),(2836,53,0,339,NULL),(2837,53,0,340,NULL),(2838,53,0,341,NULL),(2839,53,0,342,NULL),(2840,53,0,359,NULL),(2841,53,0,360,NULL),(2842,53,0,361,NULL),(2843,53,0,362,NULL),(2844,151,0,88,0),(2845,151,0,89,0),(2846,151,0,90,0),(2847,151,0,91,0),(2848,151,0,93,0),(2849,151,0,94,0),(2850,151,0,95,0),(2851,151,0,100,0),(2852,151,0,102,0),(2853,151,0,103,0),(2854,151,0,101,0),(2855,151,0,104,0),(2856,151,0,105,0),(2857,151,0,97,0),(2858,151,0,98,0),(2859,151,0,99,0),(2860,53,0,351,NULL),(2861,53,0,352,NULL),(2862,53,0,353,NULL),(2863,53,0,354,NULL),(2864,53,0,355,NULL),(2865,151,0,17,0),(2866,151,0,16,0),(2867,53,0,198,NULL),(2868,151,0,18,0),(2869,53,0,200,NULL),(2870,151,0,24,0),(2871,53,0,205,NULL),(2872,53,0,365,NULL),(2873,53,0,349,NULL),(2874,53,0,210,NULL),(2875,53,0,211,NULL),(2876,53,0,212,NULL),(2877,53,0,213,NULL),(2878,53,0,214,NULL),(2879,53,0,215,NULL),(2880,53,0,216,NULL),(2881,151,0,15,0),(2882,53,0,221,NULL),(2883,53,0,222,NULL),(2884,151,0,27,0),(2885,151,0,33,0),(2886,151,0,32,0),(2887,151,0,30,0),(2888,53,0,208,NULL),(2889,151,0,60,0),(2890,53,0,227,NULL),(2891,151,0,190,0),(2892,53,0,229,NULL),(2893,53,0,231,NULL),(2894,53,0,232,NULL),(2895,53,0,233,NULL),(2896,53,0,234,NULL),(2897,53,0,235,NULL),(2898,53,0,236,NULL),(2899,53,0,237,NULL),(2900,53,0,238,NULL),(2901,151,0,176,0),(2902,151,0,167,0),(2903,151,0,172,0),(2904,53,0,239,NULL),(2905,151,0,177,0),(2906,151,0,180,0),(2907,151,0,178,0),(2908,53,0,241,NULL),(2909,53,0,242,NULL),(2910,53,0,243,NULL),(2911,53,0,244,NULL),(2912,46,0,446,1),(2913,54,0,446,1),(2914,69,0,446,1),(2915,70,0,446,0),(2916,71,0,446,0),(2917,151,0,446,0),(2918,46,0,447,1),(2919,54,0,447,1),(2920,69,0,447,1),(2921,70,0,447,0),(2922,71,0,447,0),(2923,151,0,447,0),(2930,46,0,449,1),(2931,54,0,449,1),(2932,69,0,449,1),(2933,70,0,449,0),(2934,71,0,449,0),(2935,151,0,449,0),(2936,53,0,449,NULL),(2937,151,0,2,0),(2938,163,0,2,0),(2939,163,0,449,0),(2947,163,0,219,0),(2948,163,0,25,0),(2949,163,0,5,1),(2950,163,0,3,1),(2951,163,0,15,1),(2952,151,0,7,0),(2953,163,0,7,1),(2954,151,0,12,0),(2955,163,0,12,1),(2956,151,0,8,0),(2957,163,0,8,1),(2958,151,0,9,0),(2959,163,0,9,0),(2960,163,3,15,0),(2961,163,4,8,0),(2963,163,1,165,1),(2964,163,1,15,0),(2965,163,1,8,0),(2966,163,3,8,0),(2967,163,3,12,0),(2970,163,3,135,1),(2972,163,3,367,1),(2973,46,3,318,1),(2974,69,3,318,1),(2975,163,3,318,1),(2976,163,3,145,1),(2977,163,0,318,0),(2978,163,0,346,0),(2979,163,0,106,0),(2980,163,0,307,0),(2981,163,2,5,0),(2982,46,2,5,0),(2983,69,2,5,1),(2984,151,2,5,0),(2985,163,1,5,1),(2986,163,3,5,0),(2987,163,4,7,0),(2988,163,5,5,0),(2989,46,5,318,1),(2990,69,5,318,1),(2991,163,5,318,0),(2992,46,5,5,1),(2993,69,5,5,1),(2994,46,5,7,1),(2995,69,5,7,1),(2996,163,5,7,0),(2997,46,5,366,1),(2998,69,5,366,1),(2999,163,5,366,1),(3000,46,5,219,1),(3001,69,5,219,1),(3002,163,5,219,1),(3003,46,1,318,1),(3004,69,1,318,1),(3005,163,1,318,0),(3006,163,1,163,0),(3007,46,3,3,1),(3008,69,3,3,1),(3009,163,3,3,0),(3010,46,3,219,1),(3011,69,3,219,1),(3012,163,3,219,1),(3015,163,3,4,1),(3016,46,3,71,1),(3017,69,3,71,1),(3018,163,3,71,0),(3019,163,3,37,1),(3020,46,3,25,1),(3021,69,3,25,1),(3022,163,3,25,1),(3023,46,3,9,1),(3024,69,3,9,1),(3025,163,3,9,1),(3026,46,3,5,1),(3027,69,3,5,1),(3028,46,3,145,1),(3029,69,3,145,1),(3030,46,3,253,1),(3031,69,3,253,1),(3032,163,3,253,1),(3033,151,0,71,0),(3034,163,0,71,0),(3035,163,1,4,1),(3037,46,3,4,1),(3038,163,3,343,1),(3039,163,1,343,1),(3040,69,3,4,1),(3041,151,3,4,0);
/*!40000 ALTER TABLE `catalog_category_entity_int` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_category_entity_int_after_insert` AFTER INSERT ON `catalog_category_entity_int` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalog_category_product_cl` (`entity_id`) VALUES (NEW.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_category_entity_int_after_update` AFTER UPDATE ON `catalog_category_entity_int` FOR EACH ROW BEGIN
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalog_category_product_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_category_entity_int_after_delete` AFTER DELETE ON `catalog_category_entity_int` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalog_category_product_cl` (`entity_id`) VALUES (OLD.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `catalog_category_entity_text`
--

DROP TABLE IF EXISTS `catalog_category_entity_text`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_entity_text` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` mediumtext COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CATALOG_CATEGORY_ENTITY_TEXT_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `CATALOG_CATEGORY_ENTITY_TEXT_ENTITY_ID` (`entity_id`),
  KEY `CATALOG_CATEGORY_ENTITY_TEXT_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_CATEGORY_ENTITY_TEXT_STORE_ID` (`store_id`),
  CONSTRAINT `CAT_CTGR_ENTT_TEXT_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_CTGR_ENTT_TEXT_ENTT_ID_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_category_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_CATEGORY_ENTITY_TEXT_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=1965 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Text Attribute Backend Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_entity_text`
--

LOCK TABLES `catalog_category_entity_text` WRITE;
/*!40000 ALTER TABLE `catalog_category_entity_text` DISABLE KEYS */;
INSERT INTO `catalog_category_entity_text` VALUES (1,50,0,15,'Luxury Toilets'),(2,51,0,15,'Banyo offers a wide range of Luxury Toilets at affordable prices and fast delivery services all over the UK. Modern bathroom toilets are available at super discounts.'),(3,47,0,15,NULL),(4,51,0,16,'Buy Close Coupled Toilets with Cistern and Pan from top manufactures like Laufen, RAK, Vitra in the UK and many more from Banyo. We offer both types of Close Coupled toilet, Open Backed and Fully Back to the wall depending on the buyer\'s preference.'),(5,51,0,17,'At Banyo, we have a variety of contemporary back to wall WC units. Banyo offers the best prices and fast delivery service all over the UK with special discounts on Comfort Height Back to Wall Toilets.'),(6,47,0,3,'<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;!-- section 1 --&gt;\r\n&lt;div class=\"bg-gray-100 p-6 my-40\"&gt;\r\n  &lt;div class=\"flex items-start container\"&gt;\r\n    &lt;!-- Left text section --&gt;\r\n    &lt;div class=\"w-1/2 content-sec\"&gt;\r\n      &lt;h2 class=\"text-3xl font-bold text-blue-900 mb-4\"&gt;Elevate Your &lt;br&gt;Bathroom Experience with &lt;br&gt;Franke Bathroom\r\n        Furniture&lt;/h2&gt;\r\n      &lt;p class=\"text-gray-600 text-base\"&gt;\r\n        Franke is not only a leader in kitchen solutions but also in bathroom innovations,&lt;br&gt; bringing the same level\r\n        of\r\n        craftsmanship and attention to detail to its bathroom &lt;br&gt;furniture. Just as kitchen sinks have evolved into\r\n        both\r\n        functional and fashionable&lt;br&gt; elements, Franke\'s bathroom furniture combines utility with aesthetic appeal,&lt;br&gt;\r\n        transforming your bathroom into a luxurious retreat.\r\n      &lt;/p&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Right image section --&gt;\r\n    &lt;div class=\"w-1/2 flex justify-center relative img-sec\"&gt;\r\n      &lt;div class=\"image-right absolute\"&gt;\r\n        &lt;img src=\"{{media url=.renditions/wysiwyg/bath-tub.png}}\" alt=\"\" class=\"right-img\" /&gt;\r\n      &lt;/div&gt;\r\n    &lt;/div&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;!-- section 2 --&gt;\r\n&lt;div class=\"p-6 top-text bg-blue my-40 middle\"&gt;\r\n  &lt;div class=\"flex flex-wrap items-start  container\"&gt;\r\n    &lt;!-- Left Image section --&gt;\r\n    &lt;div class=\"w-1/2 flex relative img-sec\"&gt;\r\n      &lt;div class=\"image-right absolute\"&gt;\r\n        &lt;img src=\"{{media url=.renditions/wysiwyg/bath2.png}}\" alt=\"\" class=\"right-img\" /&gt;\r\n      &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Right text section --&gt;\r\n    &lt;div class=\"w-1/2 content-sec\"&gt;\r\n      &lt;h2 class=\"text-2xl font-semibold text-white mb-4\"&gt;Straight Baths: &lt;br&gt;Where Simplicity Meets Luxury&lt;/h2&gt;\r\n      &lt;p class=\"text-white text-base my-6\"&gt;\r\n        Straight baths have long been a symbol of classic design, offering a clean, straight-edge look that fits\r\n        effortlessly into any bathroom setting. Franke\'s straight baths are more than just functional—they are a\r\n        statement of style and sophistication. Crafted from high-quality materials, these baths are designed for\r\n        durability and comfort, ensuring that your bathing experience is as relaxing as it is luxurious.\r\n      &lt;/p&gt;\r\n    &lt;/div&gt;\r\n    &lt;p class=\"text-white text-base bottom-full mt-2\"&gt;\r\n      Available in a variety of sizes and finishes, Franke\'s straight baths cater to diverse tastes and bathroom\r\n      dimensions. Whether you\'re looking to create a minimalist bathroom oasis or a lavish retreat, the simple elegance\r\n      of\r\n      a straight bath provides the perfect foundation. The smooth contours and ergonomic design promise a comfortable\r\n      soak\r\n      every time, making it a favored choice for those who appreciate the finer things in life.\r\n    &lt;/p&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;!-- section 3 --&gt;\r\n&lt;div class=\"p-6 bg-gray-100 my-40\"&gt;\r\n  &lt;div class=\"flex flex-wrap items-start  container\"&gt;\r\n\r\n    &lt;!-- Left text section --&gt;\r\n    &lt;div class=\"w-1/2 content-sec\"&gt;\r\n      &lt;h2 class=\"text-2xl font-semibold text-gray-600 mb-4\"&gt;Straight Baths: &lt;br&gt;Versatility Without Compromise&lt;/h2&gt;\r\n      &lt;p class=\"text-gray-600 text-base my-6\"&gt;\r\n        In today’s fast-paced world, versatility is key, and Franke’s shower baths deliver just that. These innovative\r\n        solutions combine the spacious relaxation of a bath with the quick convenience of a shower, offering you the\r\n        best of both worlds. Franke’s shower baths are meticulously designed to optimize space without sacrificing\r\n        style, making them ideal for modern bathrooms where every square inch counts.\r\n      &lt;/p&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Right Image section --&gt;\r\n    &lt;div class=\"w-1/2 flex justify-end relative img-sec\"&gt;\r\n      &lt;div class=\"image-right absolute\"&gt;\r\n        &lt;img src=\"{{media url=.renditions/wysiwyg/bath3.png}}\" alt=\"\" class=\"right-img\" /&gt;\r\n      &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;p class=\"text-gray-600 text-base bottom-full mt-2\"&gt;\r\n      Choose from a range of configurations, including P-shaped and L-shaped designs that maximize showering space while\r\n      still providing ample room for a relaxing bath. The sleek lines and contemporary finishes of Franke’s shower baths\r\n      are not just practical—they’re a stylish addition to any bathroom. Each unit is built with the highest standards\r\n      of quality, ensuring a long-lasting addition to your home that provides comfort and luxury for years to come.\r\n    &lt;/p&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;!-- section 4 --&gt;\r\n&lt;div class=\"p-6 top-text bg-blue my-40 middle\"&gt;\r\n  &lt;div class=\"flex flex-wrap items-start  container\"&gt;\r\n    &lt;!-- Left Image section --&gt;\r\n    &lt;div class=\"w-1/2 flex relative img-sec\"&gt;\r\n      &lt;div class=\"image-right absolute\"&gt;\r\n        &lt;img src=\"{{media url=.renditions/wysiwyg/bath4.png}}\" alt=\"\" class=\"right-img\" /&gt;\r\n      &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Right text section --&gt;\r\n    &lt;div class=\"w-1/2 content-sec\"&gt;\r\n      &lt;h2 class=\"text-2xl font-semibold text-white mb-4\"&gt;Whirlpool Baths: &lt;br&gt;Indulge in Spa-like Luxury at Home&lt;/h2&gt;\r\n      &lt;p class=\"text-white text-base my-6\"&gt;\r\n        Imagine ending your day with a therapeutic massage, right in the comfort of your own home. Franke’s whirlpool\r\n        baths make this dream a reality, transforming your bathroom into a personal spa. Designed with advanced\r\n        hydrotherapy technology, these baths feature strategically placed jets that gently massage your muscles,\r\n        alleviating stress and promoting relaxation.\r\n      &lt;/p&gt;\r\n    &lt;/div&gt;\r\n    &lt;p class=\"text-white text-base bottom-full mt-2\"&gt;\r\n      Franke’s whirlpool baths are the pinnacle of luxury, combining cutting-edge technology with stunning design. Each\r\n      bath is customizable, allowing you to adjust the intensity of the jets and the temperature of the water to create\r\n      a truly personalized experience. Whether you seek relief from sore muscles or simply want to unwind after a long\r\n      day, a Franke whirlpool bath is the ultimate indulgence. Crafted with premium materials and available in a range\r\n      of sizes and styles, these baths are as beautiful as they are functional, making them the centerpiece of any\r\n      luxury bathroom.\r\n    &lt;/p&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;!-- section 5 --&gt;\r\n&lt;div class=\"p-6 bg-gray-100 my-40 mb-0 last-sec\"&gt;\r\n  &lt;div class=\"flex flex-wrap items-start  container\"&gt;\r\n\r\n    &lt;!-- Left text section --&gt;\r\n    &lt;div class=\"w-1/2 content-sec\"&gt;\r\n      &lt;h2 class=\"text-2xl font-semibold text-gray-600 mb-4\"&gt;Countertop Basins: &lt;br&gt;A Fusion of Art and Function&lt;/h2&gt;\r\n      &lt;p class=\"text-gray-600 text-base my-6\"&gt;\r\n        For those who seek a blend of modern aesthetics and functionality, Franke’s countertop basins are the perfect\r\n        solution. These basins are more than just a functional necessity—they are a work of art. Positioned atop a\r\n        vanity or counter, Franke’s countertop basins serve as a striking focal point in any bathroom, exuding elegance\r\n        and sophistication.\r\n      &lt;/p&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Right Image section --&gt;\r\n    &lt;div class=\"w-1/2 flex justify-end relative img-sec\"&gt;\r\n      &lt;div class=\"image-right absolute\"&gt;\r\n        &lt;img src=\"{{media url=.renditions/wysiwyg/bath5.png}}\" alt=\"\" class=\"right-img\" /&gt;\r\n      &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;p class=\"text-gray-600 text-base bottom-full mt-2\"&gt;\r\n      &lt;br&gt;Available in a variety of shapes, from sleek and minimalist to bold and geometric, Franke’s countertop basins\r\n      cater to diverse design preferences. Choose from materials like porcelain, ceramic, or stone, each offering a\r\n      unique texture and finish that complements the overall decor of your bathroom. The elevated position of these\r\n      basins not only adds a touch of luxury but also enhances practicality, making daily routines like washing and\r\n      grooming more comfortable and convenient.\r\n    &lt;/p&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n&lt;!---video section--&gt;\r\n&lt;section class=\"py-16 youtube-box bg-white\"&gt;\r\n        &lt;div class=\"grid grid-cols-3 container\"&gt;\r\n            &lt;div class=\"shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;BetteLux Silhouette - Double Ended Bath&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;div class=\"shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;Hansgrohe Metropol bath mixer floor standing with\r\n                        lever handle&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;div class=\" shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;Hansgrohe Metropol bath mixer floor standing with\r\n                        lever handle&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;div class=\" shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;BetteLux Silhouette - Double Ended Bath&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;div class=\" shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;Hansgrohe Metropol bath mixer floor standing with\r\n                        lever handle&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;div class=\" shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;Hansgrohe Metropol bath mixer floor standing with\r\n                        lever handle&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/section&gt;</div>'),(7,50,0,3,'Bathroom basins, sinks, vanities, suites, furniture, enclosures, taps. suites'),(8,51,0,3,'Banyo offers 0% finance on all bathroom products, including Bath, Toilets, Basins, Bathroom furniture, Shower Enclosures, Taps, Radiators, Mirrors cabinets. Fast & Free delivery.'),(9,50,0,18,'Wall Hung toilets - Wall mounted WC Toilets - Floating Toilet | Banyo'),(10,51,0,18,'Wall Hung toilets are also known as wall-mounted WC or floating toilet. Banyo offers a huge range of high-quality products from all top bathroom brands with affordable prices.'),(13,50,0,20,'Toilets, corner wc, en-suite wc pan, best seller, banyo'),(14,51,0,20,'Corner toilets unit are best for small bathrooms and cloakrooms. At Banyo, we offer a complete range of corner toilets at affordable prices and fast delivery service all over the UK.'),(15,50,0,21,'Bidets, Bathroom , banyo.co.uk, UK'),(16,51,0,21,'Our range of Bidets are made from the best quality durable materials, and they are easy to complement any style of washroom. Banyo offers the best prices in the UK along with the fast delivery service.'),(17,50,0,22,'Urinals Pan'),(18,51,0,22,'Urinals are available in different sizes and styles. Banyo offers RAK ceramics Wall hung Urinals to both commercial and residential clients with the best prices and the fast delivery service all over the UK.'),(19,50,0,23,'Toilets seats, Standard seats'),(20,51,0,23,'Replacement bathroom toilet seats available from brands like Vitra, Kohler, Laufen and Roca with best prices, manufacturer warranty and the fastest delivery service all over the UK.'),(21,50,0,24,'Concealed Cisterns - Toilets - Products , Banyo UK'),(22,51,0,24,'Buy concealed toilet cisterns from Banyo at a discounted price. Easy to install 6Ltr cisterns with complete fittings kit. For the best prices and fast delivery service all over the UK visit Banyo.'),(23,50,0,25,'Bathroom basins, wash basins, vanity  basins, inset basins, wall hung basins, space savers basins, Cloak room basins, small basins, inset basins at banyo.co.uk'),(24,51,0,25,'Banyo offers a huge range of beautiful bathroom basins & Sinks, including both modern and traditional for large and small bathroom. Visit now banyo.co.uk for more info.'),(25,50,0,26,'Bathroom basins\r\ncounter top basins\r\nbathroom basin units\r\nbathroom sinks and cabinets\r\ncloakroom basin vanity units\r\ncountertop bathroom sinks'),(26,51,0,26,'Banyo offers a large variety of bathroom basins in traditional and contemporary styles with fast, free delivery within the UK. buy online today'),(27,50,0,27,'wall hung basin vanity unit\r\nwall hung basin no tap hole\r\nwall hung basin 500mm\r\nlarge wall hung basin\r\nideal standard wall hung basin\r\nwall hung basin with towel rail\r\ntraditional wall hung basin\r\nwall hung cloakroom basin'),(28,51,0,27,'Wall Hung Basins ideal for en-suites and cloakrooms. Fast and free delivery offers by Banyo on most of bathroom products'),(29,50,0,28,'small corner basins for cloakrooms\r\nlarge corner basin\r\ncorner basin vanity unit\r\ncorner basin with pedestal\r\nsmall corner basin 300mm\r\ncorner basin unit\r\ncorner basin with cabinet'),(30,51,0,28,'Corner basins are ideal solution for small spaces. Banyo keeps in stock variety of corner basins with and without pedestals.'),(31,50,0,29,'Bathroom basins, wash basins, vanity  basins, inset basins, wall hung basins, space savers basins, Cloack room basins, small basins, inset basins at banyo.co.uk'),(32,51,0,29,'We stock a huge range of beautiful Cloakroom basins and sinks including modern and traditional basins from £41. Basins in wall hung & pedestal styles.'),(33,50,0,30,'Bathroom basins, wash basins, vanity basins, inset basins, wall hung basins, space savers basins, Cloack room basins, small basins, inset basins at banyo.co.uk'),(34,51,0,30,'Choose vanity basins from a huge range of styles and sizes from banyo.co.uk. Fast and free delivery available on order over £500'),(35,50,0,31,'Bathroom basins, wash basins, vanity  basins, inset basins, wall hung basins, space savers basins, Cloak room basins, small basins, inset basins, semi recessed basins at banyo.co.uk'),(36,51,0,31,'Buy Bathroom Vanity Units & semi recessed basins  from Banyo. Choose froBuy Bathroom Vanity Units & semi recessed basins  from Banyo. Choose from a huge range of styles and sizes to suit your bathroom.m a huge range of styles and sizes to suit your bathroom.'),(37,50,0,32,'Bathroom basins, wash basins, vanity basins, inset basins, wall hung basins, space savers basins, Clock room basins, under counter basins, small basins, inset basins at banyo.co.uk'),(38,51,0,32,'Buy Bathroom Vanity Units & under counter basins from Banyo. Choose from a huge range of styles and sizes to suit your bathroom.'),(39,50,0,33,'Bathroom basins, counter top basins, wash basins, vanity basins, inset basins, wall hung basins, space savers basins, Clockroom basins, small basins, inset basins at banyo.co.uk'),(40,51,0,33,'Counter top basins will give your bathroom a sleek & sophisticated look with a minimalist design; available from all UK main ceramic companies at Banyo.co.uk'),(41,50,0,34,'Sit On Basins   '),(42,51,0,34,'Buy the popular type of bathroom basin which is the sit on basins or inset basins and also called countertop basins, fit neatly in the counter or a vanity counter. Unbeatable Prices! '),(43,50,0,35,'Chrome bottle trap, round, square bottle trap'),(44,51,0,35,'Modern Round and square Bottle Trap for Basin- Chrome Finish Sleek Design, Easy to fit, Fast flow. In stock, fast delivery'),(45,50,0,36,'Basin waste, chrome basin waste, chrome basin waste, plastic, white waste'),(46,51,0,36,'Easy to Fit Bathroom Basin wastes available with and without Overflow waste, Elegant finishes of Vibrant Brushed Nickel, Polished Chrome, Bronze. Best Deal in the UK'),(47,50,0,37,'bathroom baths, bathroom bathtubs, traditional baths, modern baths'),(48,51,0,37,'Banyo offers a wide range of modern bathtubs, traditional baths, corner baths, straight baths, freestanding baths and many more at affordable prices.'),(49,50,0,38,'Straight baths UK,  acrylic straight bath, cheap Straight baths,buy Straight baths'),(50,51,0,38,'Our entire bath selection made from high quality material and durable.Here at banyo straight bath is now available in various sizes and with different shape interior. A stylish and durable bath is an essential element of  every homes. '),(51,50,0,39,'traditional free standing baths, modern free standing baths, steel free standing baths, freestanding bath sale UK '),(52,51,0,39,'Banyo has a wide range of sleek, stylish and contemporary free standing baths ideal for all bathrooms from traditional to modern suite any one.Our extensive selection of modern freestanding baths features a range of pioneering designs of all shapes and sizes.'),(53,50,0,40,'Corner baths ,acrylic baths, cheap Corner baths , buy corner bath'),(54,51,0,40,'We have huge range of corner baths to suit any bathroom and budget.Our Corner baths give you all functionality without any compromising on style and quality. Our extensive range of contemporary corner baths from some of the leading brands in UK, they are durable and easy to install.'),(55,50,0,41,'oval bathtubs uk, Oval Bath sale, buy oval bath  uk, freestanding bath'),(56,51,0,41,'We offer some of the most stylish oval Bathtubs available in the UK for fair and affordable prices. We are sure we will have the entire product and services what you looking for and we proud to provide best quality to all. '),(57,50,0,42,'shower bath set , shower baths uk, cheap shower in Uk, corner shower enclosure'),(58,51,0,42,'Our high quality yet cheap shower tank purpose to get rid of all your aches and tensions, providing you an ideal bathing experience.Our comfort and stylish baths are made in a wide range for peace of mind.'),(59,50,0,43,'Traditional baths UK, roll top baths, round top baths, single ended baths, double ended baths, free standing baths'),(60,51,0,43,'Huge range and styles available in traditional baths from roll top to round top.The design of these certain bathtubs is stunning and create a magnificent impact in any bathroom suite. '),(61,50,0,44,'shower screens uk, shower screen fittings, bath screens sale, glass bath uk, buy bath screens online\r\n'),(62,51,0,44,' A bath screen is not just a practical need, but it also creates a stylish feature within the bathroom. All of our screens are made out of high-quality glass for a finer finish and you can choose from a selection of styles and designs to suit your theme.'),(63,50,0,45,'bath plug, bottle traps, Bath Wastes sale uk, pop up bath waste'),(64,51,0,45,'All the Bath Wastes and bathroom accessories available at the banyo online store would match your existing bathroom fitting and give you a wonderful look at an affordable price.'),(65,50,0,46,'Bathroom Furniture, Banyo, banyo.co.uk, Bathroom Cabinets, Bathroom Storage Furniture, Bathroom Ideas'),(66,51,0,46,'Banyo one of the most trusted and reliable retailer of Bathroom Furniture offers fastest delivery services for the UK residents. To achieve great discounts and guarantee cards with all the products'),(67,50,0,47,'Bathroom Floor Standing Furniture, Banyo, banyo.co.uk, Bathroom Vanity Units, Bathroom Storage Ideas'),(68,51,0,47,'Banyo, the most trusted and reliable retailer of Bathroom Floor Standing Furniture offers fastest delivery services for the UK residents. To achieve great discounts and guarantee cards with all the products'),(69,50,0,48,'Bathroom Wall Hung Furniture, Banyo, banyo.co.uk\r\nbathroom wall hung vanity units'),(70,51,0,48,'Banyo, the most trusted and reliable retailer of Bathroom Wall Hung vanity units offers the fastest delivery services for the UK residents. To achieve great discounts and guarantee cards with all the products'),(71,51,0,49,'Buy Bathroom Furniture Sets, Cloakroom Furniture Units from Banyo with the lowest price offering in the UK and Fast delivery service. All Cloakroom units are available from top brands in the UK.'),(72,50,0,50,'Bathroom WC Units, Banyo, banyo.co.uk'),(73,51,0,50,'Banyo, the most trusted and reliable retailer of Bathroom WC Units, offers fastest delivery services for the UK residents. To achieve great discounts and guarantee cards with all the products'),(74,50,0,51,'bathroom suites, modern bathroom suites, cloakroom bathroom suites'),(75,51,0,51,'Banyo offers a wide range of bathroom suites with affordable prices and manufacturer warranty. Explore our range of modern and traditional bathroom suites for more info call on 0116 274 4059.'),(76,50,0,52,'Cloak Room Suites, Banyo, banyo.co.uk'),(77,51,0,52,'Cloakroom suites and Basins at Banyo are about making space saving goods for the most minuscule cloakrooms and small bathrooms. To get these Bathroom Suites with fastest delivery services, visit banyo.co.uk'),(78,50,0,53,'Comtemporary Suites, Banyo, Bathroom Suites, banyo.co.uk\r\n'),(79,51,0,53,'To make you Contemporary Bathroom look even more classy, Choose from our amazing range of contemporary bath suites at amazingly affordable prices with manufacturer guarantees.'),(80,50,0,54,'Bathroom Mirrors & Cabinets, Banyo, banyo.co.uk'),(81,51,0,54,'Buy Bathroom Mirrors & Cabinets online from Banyo at the Lowest Prices in the UK. We offer a wide range of Rectangular, Oval shaped with Bevelled Edges Mirrors, Wall hung, Stainless steel corner cabinets.'),(82,50,0,55,'Bathroom Mirrors, Banyo, banyo.co.uk'),(83,51,0,55,'Buy Bathroom Mirrors online from Banyo, Lowest prices in the UK. Explore our extensive range of Mirror Cabinets such as rectangular, oval, arched, magnifying and illuminated.'),(84,50,0,56,'Bathroom Mirror Cabinets, Banyo, banyo.co.uk'),(85,51,0,56,'Buy Bathroom Mirror Cabinets online from Banyo. We offer a wide range of wall cabinets in different styles of Aluminium, LED & Steam Free Illuminated and more. Unbeatable Prices!'),(86,50,0,57,'Bathroom frames, Bathroom Plates'),(87,51,0,57,'Buy Bathroom Toilet Frames & Plates from Banyo at the Lowest Prices in the UK. We offer a wide range of bathroom frames and flush plates from brands like Grohe, Gerbit and more.'),(88,47,0,57,NULL),(89,50,0,58,'Bidet Frames'),(90,51,0,58,'Buy Bidet Frame in the UK from Banyo with a special price discount. We offer a wide range of Wall Hung Frame units with special offers and deals. For more information, contact us on 0116 274 4059.'),(91,50,0,59,'Toilet Frame'),(92,51,0,59,'Buy wall hung toilet frame from Banyo at Lowest Prices in the UK. We offer a wide range of frames for Wall Mounted and Back to Wall toilets from brands like Geberit, Grohe, Phoenix and many more.'),(93,50,0,60,'Bathroom Wall Hung Basin Frames'),(94,51,0,60,'Buy Basin Frames from Banyo, your local bathroom Supplies store in Leicester. Wide Range of high-quality Wall Hung Bathroom Frames available from top brands. Best Deals, Low Prices and fast delivery service!'),(95,50,0,61,'Flush plates'),(96,51,0,61,'Buy Flush plates online from Banyo, your local bathroom store in the UK. We offer a wide range of Single & Dual Flush Plates from high-quality brands and special price discounts. '),(97,51,0,62,'Browse our wide range of highly durable Waterproof PVC shower panels available to buy at low prices with fast delivery only at banyo'),(98,50,0,63,'Wall & Ceiling Panels'),(99,51,0,63,'Waterproof Bathroom Ceiling panels in the UK are comprised of a water-resistant substance, making them highly durable. Best for your wet room, shower, and bathroom.'),(100,50,0,64,'Splash Panels'),(101,51,0,64,'Shop our latest bathroom Splashwall wall panels collection. These panels are lightweight and 100% waterproof making them durable and long-lasting.'),(102,50,0,65,'PVC Trims'),(103,51,0,65,'We offer a wide range of PVC trims including premier cladding, coving, and external & internal corner trim. Wide range of colours and styles. Fast UK Delivery.'),(104,47,0,4,NULL),(105,50,0,4,'Matki shower doors enclosures, Ideal standard shower enclosures, Phoenix, Bathroom shower enclosures, cubicle, showers, cubicles, enclosures, doors, pivot, quadrant, hinged, bifold '),(106,51,0,4,'Banyo sells high-quality shower enclosures, and shower doors online from leading brands including Matki, Ideal Standard, Kohler, Hudson Reed, Phoenix and Ultra. There is a large choice of shower enclosures'),(107,50,0,66,'Bathroom shower door, shower enclosure doors, showers, cubicles, enclosures, doors, pivot, quadrant, hinged, bifold, bathroom, banyo'),(108,51,0,66,'Buy shower doors  from leading brands including Matki, Ideal standard, Kohler, Hudson Reed, Phoenix, Premier at unbeatable price from Banyo. '),(109,50,0,67,'Pivot shower doors,700mm Pivot Door, 760mm Pivot Door Shower Enclosures, 800mm Pivot Door Shower Enclosures, 900mm Pivot Shower door'),(110,51,0,67,'Banyo offers a huge range of Pivot Door Shower doors at crazy prices. upto 60% Off Sale. In stock for next day delivery. We will not be beaten on Price'),(111,50,0,68,'Manhattan Hinged Doors, Matki Hinged Doors, Premier Hinged Doors, hinged shower door, hinged shower doors, hinged shower doors,700mm hinged Door, 760mm hinged Door Shower Enclosures, 800mm hinged Door Shower Enclosures, 900mm hinged Shower door '),(112,51,0,68,'Hinged shower door are available in a wide selection of design and size options. You will certainly find a quality product to match your budget and expectations. '),(113,50,0,69,'Sliding Shower Doors, Banyo, 1000mm sliding shower door, 1200mm sliding shower door, 1400mm sliding shower door, sliding shower enclosure'),(114,51,0,69,'Banyo sell a wide variety  of high quality sliding shower doors online from leading brands including Matki,Ideal standard, Kohler, Hudson Reed, Phoenix, Premier. Great Price Guaranteed '),(115,50,0,70,'700mm bi-fold shower door, 750mm bi-fold cubicle door, 800mm shower bi-fold door, 900mm bi-fold shower door, '),(116,51,0,70,'Explore our range of bi-fold shower doors with variety of sizes. View the entire range with matching side panels. Great Price Guaranteed'),(117,50,0,71,'Shower Enclosure, shower cubicles, quadrant, offset quad'),(118,51,0,71,'Taking your time to consider what you want from your shower is so important. Banyo give you full range of Shower cubicles, shower units with wide choices of style and unbeatable prices.'),(119,50,0,72,'Pivot Shower Enclosures, Banyo Bathrooms, shower cubicles'),(120,51,0,72,'Pivot door Shower Enclosures is an exquisite piece of design. This a beautifully efficient piece of family showering designs. This product is also available at Banyo Ltd for Corner installations.'),(121,50,0,73,'Hinged Door, Shower Enclosures, Banyo'),(122,51,0,73,'Buy Hinged Shower Door Enclosure from Banyo, your local online bathroom store with a special price discount. From 700-1200mm(w) to 1800-2099mm(h) sizes available along with Clear Glass and Polished Chrome finish.'),(123,50,0,74,'Sliding Shower Enclosures, Banyo Bathrooms'),(124,51,0,74,'Find Bathroom Suits at Banyo UK. Shop a variety of quality Shower Sliding Doors and Bathroom that are available for purchase online with fastest delivery.'),(125,50,0,75,'Bifold Shower Doors, Banyo.co.uk'),(126,51,0,75,'Bifold doosrs & Enclosures from the Matki Collection. Solid clear safety glass and high-lustre anodized Aluminum frames. Suitable for corner and recess installation Now available at Banyo Ltd. '),(127,50,0,76,'D Shape Shower Enclosures, Premier D Shape Shower Enclosures, Shower Doors, Shower Enclosures'),(128,51,0,76,'Once you have selected you D Shape Shower Enclosures products below, you can choose from our wide range of Enclosures and showers to complete your Bathroom. Manhattan, Matki and Premier'),(129,50,0,77,'Manhattan Walk In Shower, Matki Walk in Shower, Premier Walk In Shower, Matki Shower UK, Walk in Shower Enclosures, Walk in Shower Enclosure, Manhattan Walk In Shower UK, Matki Walk In Shower UK, Premier Walk In Shower UK'),(130,51,0,77,'Walk in shower enclosure is a beautifully designed Chrome finished shower enclosure that offers a generous showering space with easy access. Find Manhattan, Matki and Premier walk in shower with fastest delivery. '),(131,50,0,78,' Matki Quadrant UK, quadrant shower enclosures, shower cubicles, Offset quadrant shower enclosure'),(132,51,0,78,'If it\'s a Quadrant Shower Enclosure you are looking for then you have reached the number one supplier for Quadrant Showers in  UK, here you can find large variety of quadrant shower enclosures at unbeatable prices with fast delivery'),(133,50,0,79,'Matki Pentagons Shower enclosure, Matki Shower Tray, Pentagons, Pentagon Matki, Matki Pentagons, Matki Pentagon UK, Banyo'),(134,51,0,79,'Shop from our stylish range of Pentagons Shower Enclosures. Visit Nexus Showroom for best offers and deals. High Quality enclosures from all leading manufacturers.'),(135,50,0,80,'Manhattan Wet Rooms, Matki Wet Rooms, Premier Wet Rooms, Manhattan Wet Rooms UK, Matki Wet Rooms UK, Premier Wet Rooms UK, Wet Rooms, Banyo.co.uk'),(136,51,0,80,'A wet room panels is a bathroom where the shower area is level with the surrounding floor. Banyo has everything you need to create a stylish and effective Wet Rooms in your home.'),(137,50,0,81,'Manhattan Corner Entry Enclosures, Matki Corner Entry Enclosures, Corner Entry Enclosures, Corner Enclosure, Banyo'),(138,51,0,81,'Corner shower entry enclosures are one of the best and stylish for Uk Bathroom. A huge range of Corner Entry Enclosures at Discount prices available at Banyo with fastest delivery in UK.'),(139,50,0,82,'Manhattan Shower Trays, Matki Shower Trays, Premier Shower Trays, shower trays UK, Banyo, Shower Tray, Manhattan Shower Trays UK, Matki Shower Trays UK, Premier Shower Trays UK, Matki Shower Tray, Shower Trays UK'),(140,51,0,82,'We have fantastic deals on Stone resin Trays, Acrylic trays and Floors. Buy High quality shower trays and floors with wide choice of style and sizes at Banyo'),(141,50,0,83,'Square Shower Trays, Bathroom Shower Enclosure Trays'),(142,51,0,83,'Buy Square Shower Trays online from Banyo, your local store in Leicester. We offer a wide range of Bathroom Shower Enclosure Trays with the lowest prices and fastest delivery service in the UK.'),(143,50,0,84,'Rectangular Shower Trays, Best Deals in the UK, Banyo'),(144,51,0,84,'Buy Rectangular Shower Trays with Best Deals in the UK from Banyo, your local bathroom store. We offer a wide range of shower enclosures, trays and floors with fast delivery and lowest prices.'),(145,50,0,85,'Quadrant Shower Trays, Quadrant Shower Enclosures'),(146,51,0,85,'Buy Quadrant Shower Trays online from Banyo, your local bathroom store in Leicester. We offer a wide range of Quadrant Shower Enclosures with the lowest prices and fast delivery in the UK.'),(147,50,0,86,'Pentagon Shower Trays, Shower Trays Best Prices in the UK'),(148,51,0,86,'Buy Pentagon Shower Trays online from Banyo, your local bathroom store in Leicester. We offer a wide range of Pentagon Shower Enclosures and trays with the Best Prices in the UK.'),(149,47,0,5,NULL),(150,50,0,5,NULL),(151,51,0,5,'\"Get incredible deals on kitchen appliances with the lowest prices. Shop top brands like Neff, Bosch, and Siemens for high-quality products.'),(152,50,0,87,'cooking, baking, kitchen appliances, best deals'),(153,51,0,87,'Buy Cooking & Baking Appliance online with special price discounts at Banyo. We offer a full range of Ovens, Hobs, Steam Appliances, Microwaves, Coffee Machine, Cooker Hoods, Warming Drawers and accessories.'),(154,50,0,88,'Cheap oven, Oven for Sale Uk, Buy Oven in Uk, best oven in uk'),(155,51,0,88,'Are you looking to Buy an Oven? Banyo provide you a full range of kitchen appliance at affordable prices and great deals with super-fast delivery across UK'),(156,50,0,89,'Kitchen hobs gas, kitchen hobs electric, cheap kitchen hobs, kitchen hobs online'),(157,51,0,89,'Everyone\'s different, but the chances are we have a hob that suits you and the way you like to cook. Visit Banyo.co.uk for Hobs with guarantee lowest price and fast delivery in UK. '),(158,50,0,90,'Neff Steam Ovens, Bosch Steam Ovens, Steam Ovens, Steam Oven, Neff Ovens, Bosch Ovens, Steam Oven UK, Steam Ovens Uk'),(159,51,0,90,'Banyo offers fantastic range of Bosch and Neff Steam ovens are incredibly easy to use and maintain. They are extremely safe with double or triple glazed doors and a safety lock that disables all functions. '),(160,50,0,91,'Bosch Built in Appliances, Neff Built in Appliances, Banyo, banyo.co.uk, Microwaves'),(161,51,0,91,'Enjoy great deals on Banyo, We offer special Discount on Bosch Built in Appliances and Neff Built in Appliances. Order now and get Free Delivery in Uk\r\n'),(162,50,0,92,'Compact Coffee Machine, Neff, Siemens, Bosch'),(163,51,0,92,'Buy Compact Coffee Machine online from Banyo with a special price discount. We offer a wide range of top quality Coffee makers from top brands like Neff, Siemens, Bosch. Unbeatable Prices! '),(164,50,0,93,'Hoods, banyo.co.uk'),(165,51,0,93,'Best Deals on Kitchen Cooker Hoods are available at banyo.co.uk. We offer a wide range of extracting hoods with different installation styles, such as canopy, integrated, chimney and island. Unbeatable Prices!'),(166,50,0,94,'Bosch Warming Drawers, Banyo, Neff Warming Drawers, Warming Drawers, Bosch Storage Drawers, Warming Drawers, Neff Warming Drawers, Bosch Warming Drawer, Bosch Storage Drawers'),(167,51,0,94,'Banyo is leading supplier in UK of Neff and Bosch Warming Drawers.  These are a really great extra found in the best of kitchens, great for keeping your food warm until a late family member returns home, or conveniently defrosting and thawing out food.'),(168,50,0,95,'Appliances Accessories'),(169,51,0,95,'Get Cooking Accessories cheapest deals only at banyo. We are one of the most trusted and reliable suppliers of all kitchen appliances across UK.\r\n'),(170,50,0,96,'Neff Washer Dryers, Neff Dryers, Bosch Washer Dryers, Neff washer dryer, washer dryers, Banyo\r\n'),(171,51,0,96,'Banyo is one of the leading supplier in Uk of Neff Washer Dryers and Bosch Washer Dryers. Whatever your laundry basket contains you need an appliance you can rely on to both clean and care for your clothes.\r\n'),(172,50,0,97,'Washing machines, Cheap Washing Machines Deals, Banyo, built-in, freestanding, automatic, bosch washing machines'),(173,51,0,97,'Cheap Washing Machines Deals are available at Banyo. We offer a wide range of high-quality built-in, freestanding & automatic washing machines from top brands like Bosch and Neff. Unbeatable Prices!'),(174,47,0,97,NULL),(175,50,0,98,'Dishwasher sale,Dishwasher cheap deals,Dishwasher in UK,bosh Dishwasher'),(176,51,0,98,'Buy Dishwashers from our Large Appliances range,sparkling clean Dishes and glassware, without the chore of washing by hand, is a luxury most Households are embracing these days.And it’s a luxury we can all afford. '),(177,50,0,99,'Dishwashers sale,integrated Dishwashers,cheap Dishwashers,cheap Dishwashers Uk'),(178,51,0,99,'All dishwashers are designed to fit neatly into your kitchen, so you won’t have to worry about what it will look like or where it will go. For a sleek kitchen look, choose a dishwasher at Banyo. '),(179,50,0,100,'buy Fridge Freezers UK, Bosch Fridge Freezers, Neff Fridge Freezers, Freezers, Fridge Freezers sale , cheap Fridge Freezers'),(180,51,0,100,'Our huge range of latest fridge and freezer bring a little luxury to your kitchen.Large capacity and great storage solutions fridge and freezer at banyo online store are always a brilliant choice for everyone.\r\n'),(181,50,0,101,'Fridge Freezers UK, Bosch Fridge Freezers, Neff Fridge Freezers, Fridge Freezers sale, cheap Fridge Freezers online'),(182,51,0,101,'We believe in offering durable and outstanding products, so we have displayed a series of new fridges freezer that come with perfect features and elegant design.'),(183,50,0,102,'fridges on sale, cheap fridge in uk, buy fridge online, top brands fridge,'),(184,51,0,102,'We provide a great range of exclusive and contemporary fridges with great looks at banyo.Our fridges are available in various sizes and shapes, with delicate looks and are made from high quality material by some top brands, so you don\'t need to worry about damaging.'),(185,50,0,103,'Freezer online sale, best Freezer UK, cheap freezer deal, new freezer in uk'),(186,51,0,103,'All Our freezer are highly efficient, energy saving and stylish.Our Versatile freezers are packed with practical features to fit your entire kitchen suite on affordable prices.'),(187,50,0,104,'Buy Wine Cooler UK, Electric Wine Cooler, Wine Cooler, Built-in Wine Cooler, Buy Neff Wine Cooler'),(188,51,0,104,'Find your  wine coolers from a wide range of contemporary and traditional classic Freestanding Wine Coolers only at banyo. Buy your new wine cooler from Banyo with high quality and super-fast delivery. '),(189,50,0,105,'American Style Fridge Freezers UK, latest design Fridge Freezers, Bosch Fridge Freezer‎, cheap American Fridge Freezers'),(190,51,0,105,'Get fantastic deals on the latest American style Fridge Freezers at banyo.Our American style fridge freezer is energy efficient and has extra internal storage space, providing ideal storage conditions for a wide variety of foods and drinks.'),(191,51,0,106,NULL),(192,50,0,107,'Kitchen Sinks UK: Best Place to Buy an Innovative Sink'),(193,51,0,107,'Inset sink are incredibly popular, designed to fit into your kitchen worktop, and probably is the most convenient method of installing a sink in the kitchen. Whereas Undermount Sinks are perfect for solid granite type surfaces.'),(194,51,0,108,'A quality range of Stainless Steel sinks that compliments any existing or new kitchen design. Corner Sinks, Flushmount Sinks, Inset Sinks, Slim-top Sinks & Undermount Stainless Steel Sinks.'),(195,51,0,109,'Enhance your kitchen with our stylish sink and tap packs. Upgrade your home with functional and elegant designs to suit every kitchen décor.'),(196,51,0,110,'We have a wide range of all kitchen accessories advanced design which will add a stunning look to any kitchen room. a series of all advanced and contemporary kitchen accessories available at banyo online store that would be an ideal choice for anyone.'),(197,47,0,37,'<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;!-- section 1 --&gt;\r\n&lt;div class=\"bg-gray-100 p-6 my-40\"&gt;\r\n  &lt;div class=\"flex items-start container\"&gt;\r\n    &lt;!-- Left text section --&gt;\r\n    &lt;div class=\"w-1/2 content-sec\"&gt;\r\n      &lt;h2 class=\"text-3xl font-bold text-blue-900 mb-4\"&gt;Elevate Your &lt;br&gt;Bathroom Experience with &lt;br&gt;Franke Bathroom\r\n        Furniture&lt;/h2&gt;\r\n      &lt;p class=\"text-gray-600 text-base\"&gt;\r\n        Franke is not only a leader in kitchen solutions but also in bathroom innovations,&lt;br&gt; bringing the same level\r\n        of\r\n        craftsmanship and attention to detail to its bathroom &lt;br&gt;furniture. Just as kitchen sinks have evolved into\r\n        both\r\n        functional and fashionable&lt;br&gt; elements, Franke\'s bathroom furniture combines utility with aesthetic appeal,&lt;br&gt;\r\n        transforming your bathroom into a luxurious retreat.\r\n      &lt;/p&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Right image section --&gt;\r\n    &lt;div class=\"w-1/2 flex justify-center relative img-sec\"&gt;\r\n      &lt;div class=\"image-right absolute\"&gt;\r\n        &lt;img src=\"{{media url=.renditions/wysiwyg/bath-tub.png}}\" alt=\"\" class=\"right-img\" /&gt;\r\n      &lt;/div&gt;\r\n    &lt;/div&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;!-- section 2 --&gt;\r\n&lt;div class=\"p-6 top-text bg-blue my-40 middle\"&gt;\r\n  &lt;div class=\"flex flex-wrap items-start  container\"&gt;\r\n    &lt;!-- Left Image section --&gt;\r\n    &lt;div class=\"w-1/2 flex relative img-sec\"&gt;\r\n      &lt;div class=\"image-right absolute\"&gt;\r\n        &lt;img src=\"{{media url=.renditions/wysiwyg/bath2.png}}\" alt=\"\" class=\"right-img\" /&gt;\r\n      &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Right text section --&gt;\r\n    &lt;div class=\"w-1/2 content-sec\"&gt;\r\n      &lt;h2 class=\"text-2xl font-semibold text-white mb-4\"&gt;Straight Baths: &lt;br&gt;Where Simplicity Meets Luxury&lt;/h2&gt;\r\n      &lt;p class=\"text-white text-base my-6\"&gt;\r\n        Straight baths have long been a symbol of classic design, offering a clean, straight-edge look that fits\r\n        effortlessly into any bathroom setting. Franke\'s straight baths are more than just functional—they are a\r\n        statement of style and sophistication. Crafted from high-quality materials, these baths are designed for\r\n        durability and comfort, ensuring that your bathing experience is as relaxing as it is luxurious.\r\n      &lt;/p&gt;\r\n    &lt;/div&gt;\r\n    &lt;p class=\"text-white text-base bottom-full mt-2\"&gt;\r\n      Available in a variety of sizes and finishes, Franke\'s straight baths cater to diverse tastes and bathroom\r\n      dimensions. Whether you\'re looking to create a minimalist bathroom oasis or a lavish retreat, the simple elegance\r\n      of\r\n      a straight bath provides the perfect foundation. The smooth contours and ergonomic design promise a comfortable\r\n      soak\r\n      every time, making it a favored choice for those who appreciate the finer things in life.\r\n    &lt;/p&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;!-- section 3 --&gt;\r\n&lt;div class=\"p-6 bg-gray-100 my-40\"&gt;\r\n  &lt;div class=\"flex flex-wrap items-start  container\"&gt;\r\n\r\n    &lt;!-- Left text section --&gt;\r\n    &lt;div class=\"w-1/2 content-sec\"&gt;\r\n      &lt;h2 class=\"text-2xl font-semibold text-gray-600 mb-4\"&gt;Straight Baths: &lt;br&gt;Versatility Without Compromise&lt;/h2&gt;\r\n      &lt;p class=\"text-gray-600 text-base my-6\"&gt;\r\n        In today’s fast-paced world, versatility is key, and Franke’s shower baths deliver just that. These innovative\r\n        solutions combine the spacious relaxation of a bath with the quick convenience of a shower, offering you the\r\n        best of both worlds. Franke’s shower baths are meticulously designed to optimize space without sacrificing\r\n        style, making them ideal for modern bathrooms where every square inch counts.\r\n      &lt;/p&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Right Image section --&gt;\r\n    &lt;div class=\"w-1/2 flex justify-end relative img-sec\"&gt;\r\n      &lt;div class=\"image-right absolute\"&gt;\r\n        &lt;img src=\"{{media url=.renditions/wysiwyg/bath3.png}}\" alt=\"\" class=\"right-img\" /&gt;\r\n      &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;p class=\"text-gray-600 text-base bottom-full mt-2\"&gt;\r\n      Choose from a range of configurations, including P-shaped and L-shaped designs that maximize showering space while\r\n      still providing ample room for a relaxing bath. The sleek lines and contemporary finishes of Franke’s shower baths\r\n      are not just practical—they’re a stylish addition to any bathroom. Each unit is built with the highest standards\r\n      of quality, ensuring a long-lasting addition to your home that provides comfort and luxury for years to come.\r\n    &lt;/p&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;!-- section 4 --&gt;\r\n&lt;div class=\"p-6 top-text bg-blue my-40 middle\"&gt;\r\n  &lt;div class=\"flex flex-wrap items-start  container\"&gt;\r\n    &lt;!-- Left Image section --&gt;\r\n    &lt;div class=\"w-1/2 flex relative img-sec\"&gt;\r\n      &lt;div class=\"image-right absolute\"&gt;\r\n        &lt;img src=\"{{media url=.renditions/wysiwyg/bath4.png}}\" alt=\"\" class=\"right-img\" /&gt;\r\n      &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Right text section --&gt;\r\n    &lt;div class=\"w-1/2 content-sec\"&gt;\r\n      &lt;h2 class=\"text-2xl font-semibold text-white mb-4\"&gt;Whirlpool Baths: &lt;br&gt;Indulge in Spa-like Luxury at Home&lt;/h2&gt;\r\n      &lt;p class=\"text-white text-base my-6\"&gt;\r\n        Imagine ending your day with a therapeutic massage, right in the comfort of your own home. Franke’s whirlpool\r\n        baths make this dream a reality, transforming your bathroom into a personal spa. Designed with advanced\r\n        hydrotherapy technology, these baths feature strategically placed jets that gently massage your muscles,\r\n        alleviating stress and promoting relaxation.\r\n      &lt;/p&gt;\r\n    &lt;/div&gt;\r\n    &lt;p class=\"text-white text-base bottom-full mt-2\"&gt;\r\n      Franke’s whirlpool baths are the pinnacle of luxury, combining cutting-edge technology with stunning design. Each\r\n      bath is customizable, allowing you to adjust the intensity of the jets and the temperature of the water to create\r\n      a truly personalized experience. Whether you seek relief from sore muscles or simply want to unwind after a long\r\n      day, a Franke whirlpool bath is the ultimate indulgence. Crafted with premium materials and available in a range\r\n      of sizes and styles, these baths are as beautiful as they are functional, making them the centerpiece of any\r\n      luxury bathroom.\r\n    &lt;/p&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;!-- section 5 --&gt;\r\n&lt;div class=\"p-6 bg-gray-100 my-40 mb-0 last-sec\"&gt;\r\n  &lt;div class=\"flex flex-wrap items-start  container\"&gt;\r\n\r\n    &lt;!-- Left text section --&gt;\r\n    &lt;div class=\"w-1/2 content-sec\"&gt;\r\n      &lt;h2 class=\"text-2xl font-semibold text-gray-600 mb-4\"&gt;Countertop Basins: &lt;br&gt;A Fusion of Art and Function&lt;/h2&gt;\r\n      &lt;p class=\"text-gray-600 text-base my-6\"&gt;\r\n        For those who seek a blend of modern aesthetics and functionality, Franke’s countertop basins are the perfect\r\n        solution. These basins are more than just a functional necessity—they are a work of art. Positioned atop a\r\n        vanity or counter, Franke’s countertop basins serve as a striking focal point in any bathroom, exuding elegance\r\n        and sophistication.\r\n      &lt;/p&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Right Image section --&gt;\r\n    &lt;div class=\"w-1/2 flex justify-end relative img-sec\"&gt;\r\n      &lt;div class=\"image-right absolute\"&gt;\r\n        &lt;img src=\"{{media url=.renditions/wysiwyg/bath5.png}}\" alt=\"\" class=\"right-img\" /&gt;\r\n      &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;p class=\"text-gray-600 text-base bottom-full mt-2\"&gt;\r\n      &lt;br&gt;Available in a variety of shapes, from sleek and minimalist to bold and geometric, Franke’s countertop basins\r\n      cater to diverse design preferences. Choose from materials like porcelain, ceramic, or stone, each offering a\r\n      unique texture and finish that complements the overall decor of your bathroom. The elevated position of these\r\n      basins not only adds a touch of luxury but also enhances practicality, making daily routines like washing and\r\n      grooming more comfortable and convenient.\r\n    &lt;/p&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;</div>'),(198,47,0,6,NULL),(199,50,0,6,'dru gas fires, gazco gas fires, balance flue fires, electric fires, gas fires, fireplaces'),(200,51,0,6,'Browse a wide range of fires - electric & gas. Lowest Price Guaranteed. Easy Returns · 0% Interest-free Finance · Free Delivery · Friendly Staff - Call us - Banyo Fireplaces'),(201,50,0,111,'Gas fires, Dru gas fires, Gazco fires, Balance flue fires,  built in fires'),(202,51,0,111,'The modern & traditional gas fires due to their excellent heat efficiency and clear fire images are found on the hit list of homeowners looking for the best heating products. Banyo lowest price deals & offers'),(203,50,0,112,'dru metro, dru venteo, dru global, dru cosmo, dru excellence, dru centro, gazco riva2 500, gazco studio 1 gas fire, gazco studio 2 gas fire, gazco Studio 22 gas fire, front view gas fires'),(204,51,0,112,'Browse the full range of Front view Gas fires from brands like Dru and Gazco like Dru Metro, Dru Global, Dru Cosmo, Dru Excellence Dru Centro, Gazco Riva 2 500, Gazco Studio1, Studio2 and Studio22. Lowest Price Guaranteed. Easy Returns · 0% Interest Finance · Free Delivery · Friendly Staff - Call us'),(205,50,0,113,'dru global, dru lugo, dru circo, dru paco, dru metro'),(206,51,0,113,'Buy Dru’s full range of corner gas fires like Dru Global, Dru Lugo, Dru Circo, Dru Paco and Dru Metro with affordable price and fast delivery around the UK at Banyo. Lowest price Guaranteed. Easy Returns · 0% Interest Finance · Free Delivery · Friendly Staff - Call us'),(207,50,0,114,'dru lugo, dru metro, dru global, balance flue fires'),(208,51,0,114,'Banyo provides all kind of three-sided gas fires like Dru Lugo, Dru Metro, Dru Global at a reasonable price and fastest delivery around the UK. Buy today at Banyo! Lowest Price Guaranteed. Easy Returns · 0% Interest Finance · Free Delivery · Friendly Staff - Call us'),(209,50,0,115,'dru metro, dru largo, dru cosmo'),(210,51,0,115,'Get Wide selection in double sided gas fires like Dru Metro, Dru Largo and Dru cosmo at good price with guarantees and fastest delivery in UK. For more Visit: Banyo. Lowest price Guaranteed. Easy Returns · 0% Interest Finance · Free Delivery · Friendly Staff - Call us'),(211,50,0,116,'Dru Gas Heaters - banyo , gas heaters for comercial buildings'),(212,51,0,116,'Buy Indoor Wall Mounted Gas Heaters for Home & Commercial use in the UK from Banyo with a special price discount. We offer a wide range of DRU Conventional and Balanced flue heaters. Unbeatable Prices! '),(213,50,0,117,'Hole in the Wall Gas Fires,  Modern Gas fires'),(214,51,0,117,'Banyo offers gas fires which are Designed to fit a variety of fireplace openings. Our hole in the wall gas fires is available in a wide range of styles and sizes. browse our website for best deals'),(215,50,0,118,'High-Efficiency Gas Fires, Banyo Fires, cheap gas fires, Leicester gas fires'),(216,51,0,118,'Explore our full collection of high-efficiency gas fires Boasting an efficiency rating of up to 85%. Call our expert team for more information'),(217,50,0,119,'Energy Efficient, Glass Fronted Gas Fires, Modern fires'),(218,51,0,119,'Glass-fronted gas fires are more Energy efficient than open gas fires. Browse our full range of glass fronted high efficiency gas fires. Price beat promise'),(219,50,0,120,'Inset Gas Fires, Energy Efficient Fires, free delivery'),(220,51,0,120,'Browse our full range of high heat output Inset gas fires from UK main brands. Every day low prices. All gas  fires with full manufacturer guarantee  '),(221,50,0,121,'Wall Mounted Gas Fires, wall hung gas fires,  Huge discount'),(222,51,0,121,'Buy modern wall mounted gas fires at unbeatable prices from Banyo Fireplace Store. Next day delivery available, call for the best price on Wall Hung gas fires contact 0116 274 4059.'),(223,50,0,122,'Balanced Flue Gas Fires, Wall Mounted Fires, Inset Gas Fire deals'),(224,51,0,122,'Browse our full range of balanced flue gas fires from European main brands. Call for the best price and next day delivery'),(225,50,0,123,'flueless gas fires, high-efficiency fireplace, no chimney required'),(226,51,0,123,'Banyo offers an extensive range of Flueless Gas Fires with the lowest prices in the UK. High-Efficiency Fireplaces have a lower heat rating than other fires of 2.5kw but are 100% efficient.'),(227,50,0,124,'Dru multi-fuel stoves, wood-burning stoves, Solid Fuel Stoves'),(228,51,0,124,'Banyo Offers Dru Solid Fuel Stoves and Wood Burning Stoves with great discount and manufacturer guarantee. Save now with amazing sales at banyo.'),(229,50,0,125,'Woodburner, Multi-fuel stoves'),(230,51,0,125,'The modern wood burning & multifuel stoves collection at Banyo offers high-efficiency stoves with Free Standing, Cast Iron, Inset and wall-mounted Fire styles. Price Match Promise Guaranteed!'),(231,50,0,126,'Electric Log Burner Effect Fires'),(232,51,0,126,'Modern Electric Stoves offered by Banyo features the Vertifame Technology with Inset, Freestanding Installations. Fuel bed choices of Log-effects, Coal Effect & Glowing Ember. Unbeatable Prices, Fast delivery!'),(233,50,0,127,'Wood Burning Stoves'),(234,51,0,127,'Banyo offers an extensive range of Eco-Friendly Wood Burning Stoves/ Log Burners with Special Price discounts and are available with Inset, Wall Mounted, Suspended & Freestanding installations. Fast Delivery in the UK!'),(235,50,0,128,'Traditional Gas Stoves, Modern Gas Stove, Double-sided stove'),(236,51,0,128,'Banyo offers a vast collection of traditional gas stoves and modern gas stove designed by popular brands at excellently low prices with fastest free delivery.'),(237,50,0,129,'Gazco electric fires, Radiance Electric Fires, Studio Electric Wall Mounted Fires, Riva2 670 Electric Fires, Electric Fires, Electric Fireplaces, Flame Effect Fires'),(238,51,0,129,'Browse the full range of Contemporary electric fires available in different styles, sizes and Flame effects. LED light and remote control, Call our expert team for best prices and next day delivery in the UK'),(239,50,0,130,'Inset Electric Fires, Electric Fires'),(240,51,0,130,'Buy High Quality Inset Electric fires at Competitive Prices with Free delivery. Premier Supplier of Electric fires. Call us on 0116 2744759'),(243,50,0,132,'wall mounted electric fires, free delivery'),(244,51,0,132,'Banyo offers a full range of Traditional & Contemporary Wall Mounted Electric Fires with Cinderwood, Blazing log, flaming coal and smouldering log effect and LED Flame Effect. Low Prices and Free Delivery! '),(245,50,0,133,'Electric Fires, Surrounds'),(246,51,0,133,'Browse our full range of Modern Electric fireplace and Firesuites with 100% Efficiency Rating - Lowest prices in the UK. Styles available 2 Sided, 3 Sided, Inset, Traditional and Wall Mounted. Fast delivery!'),(247,50,0,134,'Fires Accessories, Banyo, banyo.co.uk'),(248,51,0,134,'Banyo is a trusted retailer supplying all the amazing Fires Accessories in amazingly affordable prices, with manufacturer’s guarantees and fastest delivery services for the UK residents.  '),(249,47,0,7,NULL),(250,50,0,7,'Heated Towel Rails, Radiators & Towel Rails, banyo.co.uk'),(251,51,0,7,'Banyo is the largest retailer supplying Radiators & Towel Rails products by renowned brands with fastest delivery services, great discounts and brands’ original warranty cards.'),(252,50,0,135,'Designer Radiators, Heated towel rails, Chrome, White, Vertical, Horizontal, Delonghi, reina, Zender, Bisque, Banyo, banyo.co.uk'),(253,51,0,135,'Banyo is a trusted supplier of all Designer Radiators products which offers fastest delivery services across UK.'),(254,50,0,136,'Vertical Designer Radiators, Towel Heating Radiators, Modern Radiators,  Towel Radiators, Column Radiators, designer radiators, Zehnder, Bisque, Carisa, Reina'),(255,51,0,136,'Modern Radiators, During the colder months of the year, your home Vertical Designer Radiators heating system will play an imperative role in keeping you toasty warm and comfortable within the confines of your own space.'),(256,50,0,137,'Horizontal Designer Radiators, Aluminium Radiators, Chrome Radiators, Zehnder, Carisa, Reina, Bisque, radiator covers argos, grey radiators, modern radiators, white radiator covers'),(257,51,0,137,'All of Our Branded Horizontal Radiators for Eg, Horizontal Designer Radiators, Aluminum Radiators, and Chrome Radiators have been quality tested by our expert heating team'),(258,50,0,138,'Traditional Radiators, Traditional Towel Rails, White Towel Raditors, traditional raditors, towel rails'),(259,51,0,138,'At Banyo, our collection of Traditional Radiators and Traditional Towel Rails will amaze you with their unique features, designs, and all come tested to the highest standards.'),(260,50,0,139,'Vertical Designer Radiators, Towel Heating Radiators, Modern Radiators,  Towel Radiators, Column Radiators, designer radiators, Zehnder, Bisque, Carisa, Reina, Electric Radiators, Towel Rail Radiator, Bathroom Radiators'),(261,51,0,139,'Electric Radiators: - A Towel Rail Radiator not only adds a touch of class by offering more heat in the bathroom but also help dry your towels also, We will find the right towel rails for you'),(262,50,0,140,'Radiator Valves, Banyo, Bisque Valves, Manual Valves, Thermostatic Valves, Premier radiator valves, Zehnder radiator valves'),(263,51,0,140,'Banyo offers high quality Radiator valves from top brands in united kingdom.we have fastest delivery services across UK.Buy cheap radiator valves only at banyo.'),(264,50,0,141,'Heating Elements, towel rail heating elements, radiator heating elements, white, chrome,  Banyo, banyo.co.uk'),(265,51,0,141,'Buy 150W  - 250W  - 400W - 600W- 800W - 1000W- at  special price from Banyo. Perfect for heating a towel rail radiator where it is too expensive or difficult to plumb in.'),(266,50,0,142,'Towel Radiators, Designer Towel Rails, Heated Towel Rails, Designer Towel Rails, Banyo, Hudson Reed, Rein, Zehnder, Premier, Phoenix, banyo.co.uk'),(267,51,0,142,'For your bathroom design, the towel radiators or towel rails are a feature design that aims to heat your towels before using them. Different Designer Towel Rails are available in stainless steel & copper'),(268,50,0,143,'Heated Towel Rails, Traditional Towel Rails, Electric Towel Rails, Banyo.co.uk'),(269,51,0,143,'The Heated Towel Rails can work with either electricity or hot water- in some Traditional Towel Rails models, the combination of both operating systems gives the best result.\r\n'),(270,50,0,144,'Electric Towel Rails, Chrome Towel Rails, Electric Towel Radiators, Banyo, banyo.co.uk'),(271,51,0,144,'Our range of Electric Towel Radiators has a traditional, classy, and modern look that comes in various sizes and colours. The latest Electric Towel Rails is available from Banyo.co.uk.'),(272,47,0,8,NULL),(273,50,0,8,NULL),(274,51,0,8,'Banyo has an exclusive range of contemporary basin and Shower taps at guaranteed unbeatable prices.To offer peace of mind all our products comes with many years warranty.'),(275,51,0,145,'Buy Kitchen Taps online from Banyo, UK. Wide range of high-quality faucets available in different types of Deck-mounted, filter flow, spray, swivel spout. Low Prices & Fast delivery in the UK. '),(276,51,0,146,'Buy Kitchen Sink taps online from Banyo, your local kitchen appliances store in Leicester. Wide range of Kitchen Taps available from brands like Franke, Blanco, Grohe, Hansgrohe, Hudson Reed, Kohler, Premier, RAK.'),(277,51,0,147,'Buy Instant Hot Water Taps online from Banyo, your local kitchen taps store in Leicester. Wide range of Kitchen Sink Taps available from brands like Blanco and Franke with the lowest prices. '),(278,51,0,148,'Buy Filter Flow Taps from Banyo, your local Kitchen taps store in Leicester, UK. Wide range of Kitchen Sink Taps available from brands like Franke, Blanco with the lowest prices.'),(279,51,0,149,'Buy sensor taps online from Banyo, your local kitchen appliances store in Leicester. Wide range of Kitchen Sink Taps available from top brands with lowest prices.'),(280,50,0,150,'Bathroom Taps, bidet mixer taps, basin taps, bath taps.'),(281,51,0,150,'Buy Bathroom Taps online from Banyo, your local store in Leicester. We offer a wide range of Bidet mixers, Basin and Bath Taps with the lowest prices and fastest delivery in the UK.'),(282,50,0,151,'Bidet Mixers, Banyo, banyo.co.uk'),(283,51,0,151,'Banyo is the largest retailer of Bathroom Bidet Mixers dealing in products by all recognized brands. Banyo offers manufacturer’s guarantee and great discounts with fastest delivery services across UK.'),(284,50,0,152,'Bath Taps, Banyo, banyo.co.uk'),(285,51,0,152,'Banyo is the largest retailer of Bathroom Mixer Taps products by all recognized brands. Banyo offers manufacturer’s guarantee and great discounts with fastest delivery services across UK.'),(286,50,0,153,'Single Bath Taps, Bath Taps, Bathroom Taps, Taps'),(287,51,0,153,'Buy Single Bath Taps Online from Banyo, your local bathroom Taps store in Leicester. Wide range of Bath Taps available from brands like Hudson Reed, Premier with the lowest prices. '),(288,50,0,154,'Mixer Taps, Bath Taps, Bathroom Taps, Taps'),(289,51,0,154,'Buy Mixer Taps online from Banyo, your local bathroom taps store in Leicester. A comprehensive range of Bath Taps is available from top brands with the lowest prices in the UK.'),(290,47,0,154,NULL),(291,50,0,155,'Wall Mounted Taps, Bath Taps, Bathroom Taps, Taps'),(292,51,0,155,'Buy Wall Mounted Taps from Banyo, your local bathroom taps store in Leicester. Wide range of Bath Taps available from brands like Grohe, Hansgrohe, Hudson Reed, Kohler, Roca with lowest prices.'),(293,50,0,156,'Free Standing Taps, Bath Taps, Bathroom Taps'),(294,51,0,156,'Buy Free Standing Taps online from Banyo, your local bathroom tap store in Leicester. Wide range of Bath Taps available from top brands with the lowest prices and fast delivery service. '),(295,50,0,157,'Bath Spouts, Bath Taps, Bathroom Taps, Taps'),(296,51,0,157,'Buy Bath Spouts from Banyo today, with a special price discount. Wide range of Bath taps (shower mixers) available waterfall, freestanding and wall-mounted Tub Faucets.'),(297,50,0,158,'Bath Fillers, Bath Taps, Bathroom Taps, Taps, overflow bath fillers'),(298,51,0,158,'Buy Overflow Bath Filler online from Banyo, your local bathroom taps store in Leicester. Wide range of Bath Filler available from top brands with the lowest prices & fast delivery service in the UK.'),(299,50,0,159,'Basin Taps, Banyo, banyo.co.uk, Shower & Taps'),(300,51,0,159,'Banyo offers Bathroom Basin Taps with manufacturer’s guarantee and fastest delivery services across UK.Gert fantastic deals on Basin Taps only at banyo.'),(301,50,0,160,'Basin Mixer Taps, Basin Taps, Bathroom Taps, Taps'),(302,51,0,160,'Buy Basin Mixer Taps online from Banyo, your local store for bathroom supplies in Leicester. We offer a wide range of Basin Taps with the lowest prices in the UK. '),(303,50,0,161,'Wall Mounted Taps'),(304,51,0,161,'Buy Wall Mounted Taps with best deals in the UK from Banyo, your local bathroom taps store in Leicester. We offer a wide range of basin taps with the lowest prices.'),(305,50,0,162,'sensor taps, basin taps'),(306,51,0,162,'Buy Sensor Taps with best Deals in the UK from Banyo, your local bathroom store in Leicester. Wide range of Basin taps available from top brands with the lowest price in the UK.'),(307,47,0,9,NULL),(308,50,0,9,'Showers & Taps, Banyo, banyo.co.uk, Taps & Showers'),(309,51,0,9,'Banyo is the largest retailer of Showers & Taps dealing in products by all recognized brands. Banyo offers manufacturer’s guarantee and great discounts with fastest delivery services across UK.'),(310,47,0,163,NULL),(311,50,0,163,NULL),(312,51,0,163,NULL),(313,47,0,16,NULL),(314,50,0,16,NULL),(315,47,0,17,NULL),(316,50,0,17,NULL),(317,47,0,18,NULL),(318,47,0,10,NULL),(319,50,0,10,'Accessories, Bathroom Light'),(320,51,0,10,'Buy Bathroom Lights & Accessories Online from Banyo with a special price discount. We offer a wide range of LED shower light, robe hook, soap dish, holder, baskets, toilet roll, circular light and more. '),(321,47,0,11,NULL),(322,50,0,11,NULL),(323,51,0,11,NULL),(324,47,0,12,NULL),(325,50,0,12,NULL),(326,51,0,12,NULL),(330,47,0,164,NULL),(331,50,0,164,NULL),(332,51,0,164,NULL),(333,137,0,164,NULL),(334,138,0,164,NULL),(335,139,0,164,NULL),(336,137,0,12,NULL),(337,138,0,12,NULL),(338,139,0,12,NULL),(339,137,0,163,NULL),(340,138,0,163,NULL),(341,139,0,163,NULL),(342,137,0,3,'The straight baths listed at our online store are moulded out of top-quality materials such as acrylic, steel, and cast iron, with acrylic being the construction material of choice. We have displayed various products in this category in different sizes and materials. 1700mm, 1800mm, and 1500mm are the standard sizes in our collection. The prices range from approx £119 to £8000, and all the products are made in the UK. All the baths we offer deliver a good bathing experience and add gorgeous aesthetics. Whether you are looking for a large or small size bath, or a budget model, we have the one you need - take a pick from our impressive range. \r\n'),(343,138,0,3,'At Banyo, we offer the latest range of high-quality products from brands such Rak ceramics, Geberit, Grohe, Bette, Laufen, Vitra, Roca, HansGrohe, Matki and many more. Since we understand that the bathroom is among the most used places in any home much like a kitchen and a bedroom, we can offer you expert advice, huge choice and expert fitting solutions. Banyo offers a diverse range of products such as but not limited to mirror cabinets, mirrors, bathroom furniture, lighting, baths, vanity units, Extractor fans, toilets and bidets. To keep your bathroom clutter-free, look into bathroom storage solutions. Here you\'ll find plenty of bathroom storage solutions for any size bathroom. Browse our online bathroom showroom & discover our luxury products option.\r\n'),(344,139,0,3,'At Banyo, we offer the latest range of high-quality products from brands such Rak ceramics, Geberit, Grohe, Bette, Laufen, Vitra, Roca, HansGrohe, Matki and many more. Since we understand that the bathroom is among the most used places in any home much like a kitchen and a bedroom, we can offer you expert advice, huge choice and expert fitting solutions. Banyo offers a diverse range of products such as but not limited to mirror cabinets, mirrors, bathroom furniture, lighting, baths, vanity units, Extractor fans, toilets and bidets. To keep your bathroom clutter-free, look into bathroom storage solutions. Here you\'ll find plenty of bathroom storage solutions for any size bathroom. Browse our online bathroom showroom & discover our luxury products option.'),(345,137,0,15,NULL),(346,138,0,15,NULL),(347,139,0,15,NULL),(348,47,0,25,NULL),(349,137,0,25,NULL),(350,138,0,25,NULL),(351,139,0,25,NULL),(352,137,0,37,'The straight baths listed at our online store are moulded out of top-quality materials such as acrylic, steel, and cast iron, with acrylic being the construction material of choice. We have displayed various products in this category in different sizes and materials. 1700mm, 1800mm, and 1500mm are the standard sizes in our collection. The prices range from approx £119 to £8000, and all the products are made in the UK. All the baths we offer deliver a good bathing experience and add gorgeous aesthetics. Whether you are looking for a large or small size bath, or a budget model, we have the one you need - take a pick from our impressive range. '),(353,138,0,37,'At Banyo, we offer the latest range of high-quality products from brands such Rak ceramics, Geberit, Grohe, Bette, Laufen, Vitra, Roca, HansGrohe, Matki and many more. Since we understand that the bathroom is among the most used places in any home much like a kitchen and a bedroom, we can offer you expert advice, huge choice and expert fitting solutions. Banyo offers a diverse range of products such as but not limited to mirror cabinets, mirrors, bathroom furniture, lighting, baths, vanity units, Extractor fans, toilets and bidets. To keep your bathroom clutter-free, look into bathroom storage solutions. Here you\'ll find plenty of bathroom storage solutions for any size bathroom. Browse our online bathroom showroom & discover our luxury products option.'),(354,139,0,37,'At Banyo, we offer the latest range of high-quality products from brands such Rak ceramics, Geberit, Grohe, Bette, Laufen, Vitra, Roca, HansGrohe, Matki and many more. Since we understand that the bathroom is among the most used places in any home much like a kitchen and a bedroom, we can offer you expert advice, huge choice and expert fitting solutions. Banyo offers a diverse range of products such as but not limited to mirror cabinets, mirrors, bathroom furniture, lighting, baths, vanity units, Extractor fans, toilets and bidets. To keep your bathroom clutter-free, look into bathroom storage solutions. Here you\'ll find plenty of bathroom storage solutions for any size bathroom. Browse our online bathroom showroom & discover our luxury products option.'),(355,47,0,46,NULL),(356,137,0,46,NULL),(357,138,0,46,NULL),(358,139,0,46,NULL),(359,47,0,51,NULL),(360,137,0,51,NULL),(361,138,0,51,NULL),(362,139,0,51,NULL),(363,47,0,54,NULL),(364,137,0,54,NULL),(365,138,0,54,NULL),(366,139,0,54,NULL),(367,137,0,57,NULL),(368,138,0,57,NULL),(369,139,0,57,NULL),(370,47,0,62,NULL),(371,50,0,62,NULL),(372,137,0,62,NULL),(373,138,0,62,NULL),(374,139,0,62,NULL),(375,137,0,16,NULL),(376,138,0,16,NULL),(377,139,0,16,NULL),(378,137,0,17,NULL),(379,138,0,17,NULL),(380,139,0,17,NULL),(381,137,0,18,NULL),(382,138,0,18,NULL),(383,139,0,18,NULL),(384,47,0,21,NULL),(385,137,0,21,NULL),(386,138,0,21,NULL),(387,139,0,21,NULL),(388,47,0,22,NULL),(389,137,0,22,NULL),(390,138,0,22,NULL),(391,139,0,22,NULL),(392,47,0,23,NULL),(393,137,0,23,NULL),(394,138,0,23,NULL),(395,139,0,23,NULL),(396,47,0,24,NULL),(397,137,0,24,NULL),(398,138,0,24,NULL),(399,139,0,24,NULL),(400,47,0,26,NULL),(401,137,0,26,NULL),(402,138,0,26,NULL),(403,139,0,26,NULL),(404,47,0,27,NULL),(405,137,0,27,NULL),(406,138,0,27,NULL),(407,139,0,27,NULL),(408,47,0,28,NULL),(409,137,0,28,NULL),(410,138,0,28,NULL),(411,139,0,28,NULL),(412,47,0,29,NULL),(413,137,0,29,NULL),(414,138,0,29,NULL),(415,139,0,29,NULL),(416,47,0,30,NULL),(417,137,0,30,NULL),(418,138,0,30,NULL),(419,139,0,30,NULL),(420,47,0,31,NULL),(421,137,0,31,NULL),(422,138,0,31,NULL),(423,139,0,31,NULL),(424,47,0,2,'<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div>'),(425,50,0,2,NULL),(426,51,0,2,NULL),(427,137,0,2,NULL),(428,138,0,2,NULL),(429,139,0,2,NULL),(430,47,0,32,NULL),(431,137,0,32,NULL),(432,138,0,32,NULL),(433,139,0,32,NULL),(434,47,0,33,NULL),(435,137,0,33,NULL),(436,138,0,33,NULL),(437,139,0,33,NULL),(438,47,0,34,NULL),(439,137,0,34,NULL),(440,138,0,34,NULL),(441,139,0,34,NULL),(442,47,0,35,NULL),(443,137,0,35,NULL),(444,138,0,35,NULL),(445,139,0,35,NULL),(446,47,0,36,NULL),(447,137,0,36,NULL),(448,138,0,36,NULL),(449,139,0,36,NULL),(450,47,0,38,'<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;!-- section 1 --&gt;\r\n&lt;div class=\"bg-gray-100 p-6 my-40\"&gt;\r\n  &lt;div class=\"flex items-start container\"&gt;\r\n    &lt;!-- Left text section --&gt;\r\n    &lt;div class=\"w-1/2\"&gt;\r\n      &lt;h2 class=\"text-3xl font-bold text-blue-900 mb-4\"&gt;Elevate Your &lt;br&gt;Bathroom Experience with &lt;br&gt;Franke Bathroom\r\n        Furniture&lt;/h2&gt;\r\n      &lt;p class=\"text-gray-600 text-base\"&gt;\r\n        Franke is not only a leader in kitchen solutions but also in bathroom innovations,&lt;br&gt; bringing the same level\r\n        of\r\n        craftsmanship and attention to detail to its bathroom &lt;br&gt;furniture. Just as kitchen sinks have evolved into\r\n        both\r\n        functional and fashionable&lt;br&gt; elements, Franke\'s bathroom furniture combines utility with aesthetic appeal,&lt;br&gt;\r\n        transforming your bathroom into a luxurious retreat.\r\n      &lt;/p&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Right image section --&gt;\r\n    &lt;div class=\"w-1/2 flex justify-center relative\"&gt;\r\n      &lt;div class=\"image-right absolute\"&gt;\r\n        &lt;img src=\"{{media url=.renditions/wysiwyg/bath-tub.png}}\" alt=\"\" class=\"right-img\" /&gt;\r\n      &lt;/div&gt;\r\n    &lt;/div&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;!-- section 2 --&gt;\r\n&lt;div class=\"p-6 top-text bg-blue my-40 middle\"&gt;\r\n  &lt;div class=\"flex flex-wrap items-start  container\"&gt;\r\n    &lt;!-- Left Image section --&gt;\r\n    &lt;div class=\"w-1/2 flex relative\"&gt;\r\n      &lt;div class=\"image-right absolute\"&gt;\r\n        &lt;img src=\"{{media url=.renditions/wysiwyg/bath2.png}}\" alt=\"\" class=\"right-img\" /&gt;\r\n      &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Right text section --&gt;\r\n    &lt;div class=\"w-1/2\"&gt;\r\n      &lt;h2 class=\"text-2xl font-semibold text-white mb-4\"&gt;Straight Baths: &lt;br&gt;Where Simplicity Meets Luxury&lt;/h2&gt;\r\n      &lt;p class=\"text-white text-base my-6\"&gt;\r\n        Straight baths have long been a symbol of classic design, offering a clean, straight-edge look that fits\r\n        effortlessly into any bathroom setting. Franke\'s straight baths are more than just functional—they are a\r\n        statement of style and sophistication. Crafted from high-quality materials, these baths are designed for\r\n        durability and comfort, ensuring that your bathing experience is as relaxing as it is luxurious.\r\n      &lt;/p&gt;\r\n    &lt;/div&gt;\r\n    &lt;p class=\"text-white text-base bottom-full mt-2\"&gt;\r\n      Available in a variety of sizes and finishes, Franke\'s straight baths cater to diverse tastes and bathroom\r\n      dimensions. Whether you\'re looking to create a minimalist bathroom oasis or a lavish retreat, the simple elegance\r\n      of\r\n      a straight bath provides the perfect foundation. The smooth contours and ergonomic design promise a comfortable\r\n      soak\r\n      every time, making it a favored choice for those who appreciate the finer things in life.\r\n    &lt;/p&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;!-- section 3 --&gt;\r\n&lt;div class=\"p-6 bg-gray-100 my-40\"&gt;\r\n  &lt;div class=\"flex flex-wrap items-start  container\"&gt;\r\n\r\n    &lt;!-- Left text section --&gt;\r\n    &lt;div class=\"w-1/2\"&gt;\r\n      &lt;h2 class=\"text-2xl font-semibold text-gray-600 mb-4\"&gt;Straight Baths: &lt;br&gt;Versatility Without Compromise&lt;/h2&gt;\r\n      &lt;p class=\"text-gray-600 text-base my-6\"&gt;\r\n        In today’s fast-paced world, versatility is key, and Franke’s shower baths deliver just that. These innovative\r\n        solutions combine the spacious relaxation of a bath with the quick convenience of a shower, offering you the\r\n        best of both worlds. Franke’s shower baths are meticulously designed to optimize space without sacrificing\r\n        style, making them ideal for modern bathrooms where every square inch counts.\r\n      &lt;/p&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Right Image section --&gt;\r\n    &lt;div class=\"w-1/2 flex justify-end relative\"&gt;\r\n      &lt;div class=\"image-right absolute\"&gt;\r\n        &lt;img src=\"{{media url=.renditions/wysiwyg/bath3.png}}\" alt=\"\" class=\"right-img\" /&gt;\r\n      &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;p class=\"text-gray-600 text-base bottom-full mt-2\"&gt;\r\n      Choose from a range of configurations, including P-shaped and L-shaped designs that maximize showering space while\r\n      still providing ample room for a relaxing bath. The sleek lines and contemporary finishes of Franke’s shower baths\r\n      are not just practical—they’re a stylish addition to any bathroom. Each unit is built with the highest standards\r\n      of quality, ensuring a long-lasting addition to your home that provides comfort and luxury for years to come.\r\n    &lt;/p&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;!-- section 4 --&gt;\r\n&lt;div class=\"p-6 top-text bg-blue my-40 middle\"&gt;\r\n  &lt;div class=\"flex flex-wrap items-start  container\"&gt;\r\n    &lt;!-- Left Image section --&gt;\r\n    &lt;div class=\"w-1/2 flex relative\"&gt;\r\n      &lt;div class=\"image-right absolute\"&gt;\r\n&lt;img src=\"{{media url=.renditions/wysiwyg/bath4.png}}\" alt=\"\" class=\"right-img\"/&gt;\r\n      &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Right text section --&gt;\r\n    &lt;div class=\"w-1/2\"&gt;\r\n      &lt;h2 class=\"text-2xl font-semibold text-white mb-4\"&gt;Whirlpool Baths: &lt;br&gt;Indulge in Spa-like Luxury at Home&lt;/h2&gt;\r\n      &lt;p class=\"text-white text-base my-6\"&gt;\r\n        Imagine ending your day with a therapeutic massage, right in the comfort of your own home. Franke’s whirlpool\r\n        baths make this dream a reality, transforming your bathroom into a personal spa. Designed with advanced\r\n        hydrotherapy technology, these baths feature strategically placed jets that gently massage your muscles,\r\n        alleviating stress and promoting relaxation.\r\n      &lt;/p&gt;\r\n    &lt;/div&gt;\r\n    &lt;p class=\"text-white text-base bottom-full mt-2\"&gt;\r\n      Franke’s whirlpool baths are the pinnacle of luxury, combining cutting-edge technology with stunning design. Each\r\n      bath is customizable, allowing you to adjust the intensity of the jets and the temperature of the water to create\r\n      a truly personalized experience. Whether you seek relief from sore muscles or simply want to unwind after a long\r\n      day, a Franke whirlpool bath is the ultimate indulgence. Crafted with premium materials and available in a range\r\n      of sizes and styles, these baths are as beautiful as they are functional, making them the centerpiece of any\r\n      luxury bathroom.\r\n    &lt;/p&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;!-- section 5 --&gt;\r\n&lt;div class=\"p-6 bg-gray-100 my-40 mb-0 last-sec\"&gt;\r\n  &lt;div class=\"flex flex-wrap items-start  container\"&gt;\r\n\r\n    &lt;!-- Left text section --&gt;\r\n    &lt;div class=\"w-1/2\"&gt;\r\n      &lt;h2 class=\"text-2xl font-semibold text-gray-600 mb-4\"&gt;Countertop Basins: &lt;br&gt;A Fusion of Art and Function&lt;/h2&gt;\r\n      &lt;p class=\"text-gray-600 text-base my-6\"&gt;\r\n        For those who seek a blend of modern aesthetics and functionality, Franke’s countertop basins are the perfect\r\n        solution. These basins are more than just a functional necessity—they are a work of art. Positioned atop a\r\n        vanity or counter, Franke’s countertop basins serve as a striking focal point in any bathroom, exuding elegance\r\n        and sophistication.\r\n      &lt;/p&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Right Image section --&gt;\r\n    &lt;div class=\"w-1/2 flex justify-end relative\"&gt;\r\n      &lt;div class=\"image-right absolute\"&gt;\r\n&lt;img src=\"{{media url=.renditions/wysiwyg/bath5.png}}\" alt=\"\" class=\"right-img\"/&gt;\r\n      &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;p class=\"text-gray-600 text-base bottom-full mt-2\"&gt;\r\n      &lt;br&gt;Available in a variety of shapes, from sleek and minimalist to bold and geometric, Franke’s countertop basins\r\n      cater to diverse design preferences. Choose from materials like porcelain, ceramic, or stone, each offering a\r\n      unique texture and finish that complements the overall decor of your bathroom. The elevated position of these\r\n      basins not only adds a touch of luxury but also enhances practicality, making daily routines like washing and\r\n      grooming more comfortable and convenient.\r\n    &lt;/p&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n</div>'),(451,137,0,38,'The straight baths listed at our online store are moulded out of top-quality materials such as acrylic, steel, and cast iron, with acrylic being the construction material of choice. We have displayed various products in this category in different sizes and materials. 1700mm, 1800mm, and 1500mm are the standard sizes in our collection. The prices range from approx £119 to £8000, and all the products are made in the UK. All the baths we offer deliver a good bathing experience and add gorgeous aesthetics. Whether you are looking for a large or small size bath, or a budget model, we have the one you need - take a pick from our impressive range. '),(452,138,0,38,'At Banyo, we offer the latest range of high-quality products from brands such Rak ceramics, Geberit, Grohe, Bette, Laufen, Vitra, Roca, HansGrohe, Matki and many more. Since we understand that the bathroom is among the most used places in any home much like a kitchen and a bedroom, we can offer you expert advice, huge choice and expert fitting solutions. Banyo offers a diverse range of products such as but not limited to mirror cabinets, mirrors, bathroom furniture, lighting, baths, vanity units, Extractor fans, toilets and bidets. To keep your bathroom clutter-free, look into bathroom storage solutions. Here you\'ll find plenty of bathroom storage solutions for any size bathroom. Browse our online bathroom showroom & discover our luxury products option.'),(453,139,0,38,'At Banyo, we offer the latest range of high-quality products from brands such Rak ceramics, Geberit, Grohe, Bette, Laufen, Vitra, Roca, HansGrohe, Matki and many more. Since we understand that the bathroom is among the most used places in any home much like a kitchen and a bedroom, we can offer you expert advice, huge choice and expert fitting solutions. Banyo offers a diverse range of products such as but not limited to mirror cabinets, mirrors, bathroom furniture, lighting, baths, vanity units, Extractor fans, toilets and bidets. To keep your bathroom clutter-free, look into bathroom storage solutions. Here you\'ll find plenty of bathroom storage solutions for any size bathroom. Browse our online bathroom showroom & discover our luxury products option.'),(454,47,0,39,NULL),(455,137,0,39,NULL),(456,138,0,39,NULL),(457,139,0,39,NULL),(458,47,0,40,NULL),(459,137,0,40,NULL),(460,138,0,40,NULL),(461,139,0,40,NULL),(462,47,0,41,NULL),(463,137,0,41,NULL),(464,138,0,41,NULL),(465,139,0,41,NULL),(466,47,0,42,NULL),(467,137,0,42,NULL),(468,138,0,42,NULL),(469,139,0,42,NULL),(470,47,0,43,NULL),(471,137,0,43,NULL),(472,138,0,43,NULL),(473,139,0,43,NULL),(474,47,0,44,NULL),(475,137,0,44,NULL),(476,138,0,44,NULL),(477,139,0,44,NULL),(478,47,0,45,NULL),(479,137,0,45,NULL),(480,138,0,45,NULL),(481,139,0,45,NULL),(482,47,0,47,NULL),(483,137,0,47,NULL),(484,138,0,47,NULL),(485,139,0,47,NULL),(486,47,0,48,NULL),(487,137,0,48,NULL),(488,138,0,48,NULL),(489,139,0,48,NULL),(490,47,0,49,NULL),(491,50,0,49,NULL),(492,137,0,49,NULL),(493,138,0,49,NULL),(494,139,0,49,NULL),(495,47,0,50,NULL),(496,137,0,50,NULL),(497,138,0,50,NULL),(498,139,0,50,NULL),(499,47,0,52,NULL),(500,137,0,52,NULL),(501,138,0,52,NULL),(502,139,0,52,NULL),(503,47,0,53,NULL),(504,137,0,53,NULL),(505,138,0,53,NULL),(506,139,0,53,NULL),(507,47,0,58,NULL),(508,137,0,58,NULL),(509,138,0,58,NULL),(510,139,0,58,NULL),(511,47,0,59,NULL),(512,137,0,59,NULL),(513,138,0,59,NULL),(514,139,0,59,NULL),(515,47,0,60,NULL),(516,137,0,60,NULL),(517,138,0,60,NULL),(518,139,0,60,NULL),(519,47,0,61,NULL),(520,137,0,61,NULL),(521,138,0,61,NULL),(522,139,0,61,NULL),(523,47,0,55,NULL),(524,137,0,55,NULL),(525,138,0,55,NULL),(526,139,0,55,NULL),(527,47,0,56,NULL),(528,137,0,56,NULL),(529,138,0,56,NULL),(530,139,0,56,NULL),(531,137,0,4,NULL),(532,138,0,4,NULL),(533,139,0,4,NULL),(534,47,0,71,NULL),(535,137,0,71,NULL),(536,138,0,71,NULL),(537,139,0,71,NULL),(538,47,0,72,NULL),(539,137,0,72,NULL),(540,138,0,72,NULL),(541,139,0,72,NULL),(542,47,0,73,NULL),(543,137,0,73,NULL),(544,138,0,73,NULL),(545,139,0,73,NULL),(546,47,0,74,NULL),(547,137,0,74,NULL),(548,138,0,74,NULL),(549,139,0,74,NULL),(550,47,0,75,NULL),(551,137,0,75,NULL),(552,138,0,75,NULL),(553,139,0,75,NULL),(554,47,0,76,NULL),(555,137,0,76,NULL),(556,138,0,76,NULL),(557,139,0,76,NULL),(558,47,0,77,NULL),(559,137,0,77,NULL),(560,138,0,77,NULL),(561,139,0,77,NULL),(562,47,0,78,NULL),(563,137,0,78,NULL),(564,138,0,78,NULL),(565,139,0,78,NULL),(566,47,0,79,NULL),(567,137,0,79,NULL),(568,138,0,79,NULL),(569,139,0,79,NULL),(570,47,0,80,NULL),(571,137,0,80,NULL),(572,138,0,80,NULL),(573,139,0,80,NULL),(574,47,0,81,NULL),(575,137,0,81,NULL),(576,138,0,81,NULL),(577,139,0,81,NULL),(578,47,0,83,NULL),(579,137,0,83,NULL),(580,138,0,83,NULL),(581,139,0,83,NULL),(582,47,0,84,NULL),(583,137,0,84,NULL),(584,138,0,84,NULL),(585,139,0,84,NULL),(586,47,0,85,NULL),(587,137,0,85,NULL),(588,138,0,85,NULL),(589,139,0,85,NULL),(590,47,0,86,NULL),(591,137,0,86,NULL),(592,138,0,86,NULL),(593,139,0,86,NULL),(594,47,0,67,NULL),(595,137,0,67,NULL),(596,138,0,67,NULL),(597,139,0,67,NULL),(598,47,0,68,NULL),(599,137,0,68,NULL),(600,138,0,68,NULL),(601,139,0,68,NULL),(602,47,0,69,NULL),(603,137,0,69,NULL),(604,138,0,69,NULL),(605,139,0,69,NULL),(606,47,0,70,NULL),(607,137,0,70,NULL),(608,138,0,70,NULL),(609,139,0,70,NULL),(610,137,0,5,NULL),(611,138,0,5,NULL),(612,139,0,5,NULL),(613,47,0,87,NULL),(614,137,0,87,NULL),(615,138,0,87,NULL),(616,139,0,87,NULL),(617,47,0,88,NULL),(618,137,0,88,NULL),(619,138,0,88,NULL),(620,139,0,88,NULL),(621,47,0,89,NULL),(622,137,0,89,NULL),(623,138,0,89,NULL),(624,139,0,89,NULL),(625,47,0,90,NULL),(626,137,0,90,NULL),(627,138,0,90,NULL),(628,139,0,90,NULL),(629,47,0,91,NULL),(630,137,0,91,NULL),(631,138,0,91,NULL),(632,139,0,91,NULL),(633,47,0,92,NULL),(634,137,0,92,NULL),(635,138,0,92,NULL),(636,139,0,92,NULL),(637,47,0,94,NULL),(638,137,0,94,NULL),(639,138,0,94,NULL),(640,139,0,94,NULL),(641,47,0,95,NULL),(642,137,0,95,NULL),(643,138,0,95,NULL),(644,139,0,95,NULL),(645,47,0,93,NULL),(646,137,0,93,NULL),(647,138,0,93,NULL),(648,139,0,93,NULL),(649,47,0,96,NULL),(650,137,0,96,NULL),(651,138,0,96,NULL),(652,139,0,96,NULL),(653,137,0,97,NULL),(654,138,0,97,NULL),(655,139,0,97,NULL),(656,47,0,98,NULL),(657,137,0,98,NULL),(658,138,0,98,NULL),(659,139,0,98,NULL),(660,47,0,99,NULL),(661,137,0,99,NULL),(662,138,0,99,NULL),(663,139,0,99,NULL),(664,47,0,100,NULL),(665,137,0,100,NULL),(666,138,0,100,NULL),(667,139,0,100,NULL),(668,47,0,101,NULL),(669,137,0,101,NULL),(670,138,0,101,NULL),(671,139,0,101,NULL),(672,47,0,102,NULL),(673,137,0,102,NULL),(674,138,0,102,NULL),(675,139,0,102,NULL),(676,47,0,103,NULL),(677,137,0,103,NULL),(678,138,0,103,NULL),(679,139,0,103,NULL),(680,47,0,104,NULL),(681,137,0,104,NULL),(682,138,0,104,NULL),(683,139,0,104,NULL),(684,47,0,105,NULL),(685,137,0,105,NULL),(686,138,0,105,NULL),(687,139,0,105,NULL),(688,47,0,106,NULL),(689,50,0,106,NULL),(690,137,0,106,NULL),(691,138,0,106,NULL),(692,139,0,106,NULL),(693,47,0,110,NULL),(694,50,0,110,NULL),(695,137,0,110,NULL),(696,138,0,110,NULL),(697,139,0,110,NULL),(698,47,0,108,NULL),(699,50,0,108,NULL),(700,137,0,108,NULL),(701,138,0,108,NULL),(702,139,0,108,NULL),(703,47,0,107,NULL),(704,137,0,107,NULL),(705,138,0,107,NULL),(706,139,0,107,NULL),(707,137,0,6,NULL),(708,138,0,6,NULL),(709,139,0,6,NULL),(710,47,0,111,NULL),(711,137,0,111,NULL),(712,138,0,111,NULL),(713,139,0,111,NULL),(714,47,0,112,NULL),(715,137,0,112,NULL),(716,138,0,112,NULL),(717,139,0,112,NULL),(718,47,0,113,NULL),(719,137,0,113,NULL),(720,138,0,113,NULL),(721,139,0,113,NULL),(722,47,0,114,NULL),(723,137,0,114,NULL),(724,138,0,114,NULL),(725,139,0,114,NULL),(726,47,0,115,NULL),(727,137,0,115,NULL),(728,138,0,115,NULL),(729,139,0,115,NULL),(730,47,0,116,NULL),(731,137,0,116,NULL),(732,138,0,116,NULL),(733,139,0,116,NULL),(734,47,0,117,NULL),(735,137,0,117,NULL),(736,138,0,117,NULL),(737,139,0,117,NULL),(738,47,0,118,NULL),(739,137,0,118,NULL),(740,138,0,118,NULL),(741,139,0,118,NULL),(742,47,0,123,NULL),(743,137,0,123,NULL),(744,138,0,123,NULL),(745,139,0,123,NULL),(746,47,0,121,NULL),(747,137,0,121,NULL),(748,138,0,121,NULL),(749,139,0,121,NULL),(750,47,0,122,NULL),(751,137,0,122,NULL),(752,138,0,122,NULL),(753,139,0,122,NULL),(754,47,0,120,NULL),(755,137,0,120,NULL),(756,138,0,120,NULL),(757,139,0,120,NULL),(758,47,0,119,NULL),(759,137,0,119,NULL),(760,138,0,119,NULL),(761,139,0,119,NULL),(762,47,0,124,NULL),(763,137,0,124,NULL),(764,138,0,124,NULL),(765,139,0,124,NULL),(766,47,0,125,NULL),(767,137,0,125,NULL),(768,138,0,125,NULL),(769,139,0,125,NULL),(770,47,0,126,NULL),(771,137,0,126,NULL),(772,138,0,126,NULL),(773,139,0,126,NULL),(774,47,0,127,NULL),(775,137,0,127,NULL),(776,138,0,127,NULL),(777,139,0,127,NULL),(778,47,0,128,NULL),(779,137,0,128,NULL),(780,138,0,128,NULL),(781,139,0,128,NULL),(782,47,0,129,NULL),(783,137,0,129,NULL),(784,138,0,129,NULL),(785,139,0,129,NULL),(786,47,0,130,NULL),(787,137,0,130,NULL),(788,138,0,130,NULL),(789,139,0,130,NULL),(794,47,0,132,NULL),(795,137,0,132,NULL),(796,138,0,132,NULL),(797,139,0,132,NULL),(798,47,0,133,NULL),(799,137,0,133,NULL),(800,138,0,133,NULL),(801,139,0,133,NULL),(802,47,0,134,NULL),(803,137,0,134,NULL),(804,138,0,134,NULL),(805,139,0,134,NULL),(806,137,0,7,NULL),(807,138,0,7,NULL),(808,139,0,7,NULL),(809,47,0,135,NULL),(810,137,0,135,NULL),(811,138,0,135,NULL),(812,139,0,135,NULL),(813,47,0,140,NULL),(814,137,0,140,NULL),(815,138,0,140,NULL),(816,139,0,140,NULL),(817,47,0,141,NULL),(818,137,0,141,NULL),(819,138,0,141,NULL),(820,139,0,141,NULL),(821,47,0,139,NULL),(822,137,0,139,NULL),(823,138,0,139,NULL),(824,139,0,139,NULL),(825,47,0,138,NULL),(826,137,0,138,NULL),(827,138,0,138,NULL),(828,139,0,138,NULL),(829,47,0,137,NULL),(830,137,0,137,NULL),(831,138,0,137,NULL),(832,139,0,137,NULL),(833,47,0,142,NULL),(834,137,0,142,NULL),(835,138,0,142,NULL),(836,139,0,142,NULL),(837,47,0,143,NULL),(838,137,0,143,NULL),(839,138,0,143,NULL),(840,139,0,143,NULL),(841,47,0,144,NULL),(842,137,0,144,NULL),(843,138,0,144,NULL),(844,139,0,144,NULL),(845,47,0,136,NULL),(846,137,0,136,NULL),(847,138,0,136,NULL),(848,139,0,136,NULL),(849,137,0,8,NULL),(850,138,0,8,NULL),(851,139,0,8,NULL),(852,47,0,145,NULL),(853,50,0,145,NULL),(854,137,0,145,NULL),(855,138,0,145,NULL),(856,139,0,145,NULL),(857,47,0,146,NULL),(858,50,0,146,NULL),(859,137,0,146,NULL),(860,138,0,146,NULL),(861,139,0,146,NULL),(862,47,0,147,NULL),(863,50,0,147,NULL),(864,137,0,147,NULL),(865,138,0,147,NULL),(866,139,0,147,NULL),(867,47,0,149,NULL),(868,50,0,149,NULL),(869,137,0,149,NULL),(870,138,0,149,NULL),(871,139,0,149,NULL),(872,47,0,151,NULL),(873,137,0,151,NULL),(874,138,0,151,NULL),(875,139,0,151,NULL),(876,47,0,152,NULL),(877,137,0,152,NULL),(878,138,0,152,NULL),(879,139,0,152,NULL),(880,47,0,153,NULL),(881,137,0,153,NULL),(882,138,0,153,NULL),(883,139,0,153,NULL),(884,137,0,154,NULL),(885,138,0,154,NULL),(886,139,0,154,NULL),(887,47,0,155,NULL),(888,137,0,155,NULL),(889,138,0,155,NULL),(890,139,0,155,NULL),(891,47,0,156,NULL),(892,137,0,156,NULL),(893,138,0,156,NULL),(894,139,0,156,NULL),(895,47,0,157,NULL),(896,137,0,157,NULL),(897,138,0,157,NULL),(898,139,0,157,NULL),(899,47,0,158,NULL),(900,137,0,158,NULL),(901,138,0,158,NULL),(902,139,0,158,NULL),(903,47,0,159,NULL),(904,137,0,159,NULL),(905,138,0,159,NULL),(906,139,0,159,NULL),(907,47,0,162,NULL),(908,137,0,162,NULL),(909,138,0,162,NULL),(910,139,0,162,NULL),(911,47,0,161,NULL),(912,137,0,161,NULL),(913,138,0,161,NULL),(914,139,0,161,NULL),(915,47,0,160,NULL),(916,137,0,160,NULL),(917,138,0,160,NULL),(918,139,0,160,NULL),(919,47,0,150,NULL),(920,137,0,150,NULL),(921,138,0,150,NULL),(922,139,0,150,NULL),(923,50,0,165,'All Showers, Electric Showers, Thermostatic Shower '),(924,51,0,165,'Browse full range of Showers, Electric showers, Thermostatic showers from UK top selling brands, Hansgrohe, Grohe, Hudsonreed and many more. '),(925,50,0,166,'Complete Showers'),(926,51,0,166,'Browse full range of showers from Hansgrohe, Grohe, Hudson reed, Roca and all top UK brands at unbeatable prices with fast next day delivery'),(927,47,0,166,NULL),(928,137,0,166,NULL),(929,138,0,166,NULL),(930,139,0,166,NULL),(931,137,0,9,NULL),(932,138,0,9,NULL),(933,139,0,9,NULL),(934,50,0,167,'Shower Panels |Hansgrohe | Premier | Hudson Reed - Banyo'),(935,51,0,167,'Banyo offers biggest discount on Shower Panels manufactured by UK top brands, Hansgrohe, Premier, Hudson Reed. We do next day free delivery on ot of our products. '),(936,50,0,168,'Digital Showers, Banyo, banyo.co.uk, Shower & Taps'),(937,51,0,168,'Banyo is the largest retailer of Bathroom Digital Showers dealing in products by all recognized brands. Banyo offers manufacturer’s guarantee and great discounts with fastest delivery services across UK.'),(938,50,0,169,NULL),(939,51,0,169,NULL),(940,50,0,170,'Shower Valves, Banyo, banyo.co.uk, Shower & Taps'),(941,51,0,170,'Banyo offers Shower Valves with manufacturer’s guarantee and great discounts across UK. Buy shower mixer Valve with fastest delivery system will deliver right to your door step in no time at all.'),(942,47,0,165,NULL),(943,137,0,165,NULL),(944,138,0,165,NULL),(945,139,0,165,NULL),(946,50,0,171,'Exposed Valves, Valves, Shower Accessories, Showers'),(947,51,0,171,'Buy Exposed Valves Online from Banyo, Your local bathroom store in Leicester. We offer a wide range of Shower Valves & Accessories with the lowest prices in the UK. Unbeatable Prices offer!'),(948,50,0,172,'Concealed Valves, Valves, Shower Accessories, Showers'),(949,51,0,172,'Buy Concealed Valves online from Banyo, your local bathroom store. Wide range of Shower Valves & Accessories available from brands like Grohe, Hansgrohe, Hudson Reed and Premier. Unbeatable Prices Guaranteed!'),(950,50,0,173,'Thermostatic Valves, Valves, Shower Accessories, Showers'),(951,51,0,173,'Buy Thermostatic Valves Online from Banyo, Your Local bathroom Store in Leicester. We offer a wide range of Shower Valves & Accessories with the lowest prices in the UK. Fast delivery service!'),(952,50,0,174,'Traditional Valves, Valves, Shower Accessories, Showers'),(953,51,0,174,'Buy Traditional Valves Online From Banyo, Your Local Bathroom Store in Leicester. We offer a wide range of Shower Valves & Accessories with the lowest prices and fast delivery service in the UK.'),(954,47,0,167,NULL),(955,137,0,167,NULL),(956,138,0,167,NULL),(957,139,0,167,NULL),(958,50,0,175,'Shower Valves, Banyo, banyo.co.uk, Shower & Taps'),(959,51,0,175,'Banyo is the largest retailer of Bathroom Shower Valves dealing in products by all recognized brands. Banyo offers manufacturer’s guarantee and great discounts with fastest delivery services across UK.'),(960,50,0,176,'Shower Riser Rail Kits, Great Deals, Banyo'),(961,51,0,176,'Buy Shower Riser Rail Kits with Great Deals and offer from Banyo. We offer a wide range of shower accessories from brands like Grohe, Hansgrohe, Hudson Reed and Premier. Unbeatable Prices!'),(962,47,0,169,NULL),(963,137,0,169,NULL),(964,138,0,169,NULL),(965,139,0,169,NULL),(966,50,0,177,'Shower Heads, round, square shower heads'),(967,51,0,177,'Buy Shower Heads online from Banyo, your local bathroom store in Leicester. Wide range of Round, Square Shower Heads from top brands like Grohe, Hudson Reed, Kohler, Matki and Premier. Starting from £29'),(968,47,0,175,NULL),(969,137,0,175,NULL),(970,138,0,175,NULL),(971,139,0,175,NULL),(972,50,0,178,'Shower Arms, Chrome Shower Arm'),(973,51,0,178,'Best Shower Arms Deals available at Banyo, Your local bathroom appliances store. We offer a wide range of Chrome Shower Arm starting from £21. Low prices and fast delivery!'),(974,50,0,179,'Body Jets, Shower Body jets, Best Deals, Banyo'),(975,51,0,179,'Buy Shower Body Jets with best deals from Banyo, your local bathroom store in Leicester. Wide Range of high-quality Body Jets is available from top brands like Hansgrohe and Hudson Reed.'),(976,47,0,176,NULL),(977,137,0,176,NULL),(978,138,0,176,NULL),(979,139,0,176,NULL),(980,47,0,177,NULL),(981,137,0,177,NULL),(982,138,0,177,NULL),(983,139,0,177,NULL),(984,50,0,180,'Shower Hose, Accessories'),(985,51,0,180,'Buy Shower Hose online from Banyo, your local bathroom store in Leicester. Wide range of Shower Accessories available from top brands like Grohe, Hansgrohe, Hudson Reed, Kohler, Matki and Premier.'),(986,50,0,181,'Accessories and Wastes, Banyo, banyo.co.uk, Shower & Taps'),(987,51,0,181,'Banyo is the top kitchens and bathrooms accessories retailer in united kingdom. our products are manufactured from top brands to meet high quality standards and offer durable with powerful performance.'),(988,47,0,178,NULL),(989,137,0,178,NULL),(990,138,0,178,NULL),(991,139,0,178,NULL),(992,47,0,179,NULL),(993,137,0,179,NULL),(994,138,0,179,NULL),(995,139,0,179,NULL),(996,47,0,180,NULL),(997,137,0,180,NULL),(998,138,0,180,NULL),(999,139,0,180,NULL),(1000,47,0,181,NULL),(1001,137,0,181,NULL),(1002,138,0,181,NULL),(1003,139,0,181,NULL),(1004,47,0,171,NULL),(1005,137,0,171,NULL),(1006,138,0,171,NULL),(1007,139,0,171,NULL),(1008,47,0,172,NULL),(1009,137,0,172,NULL),(1010,138,0,172,NULL),(1011,139,0,172,NULL),(1012,47,0,173,NULL),(1013,137,0,173,NULL),(1014,138,0,173,NULL),(1015,139,0,173,NULL),(1016,47,0,174,NULL),(1017,137,0,174,NULL),(1018,138,0,174,NULL),(1019,139,0,174,NULL),(1020,137,0,10,NULL),(1021,138,0,10,NULL),(1022,139,0,10,NULL),(1023,50,0,182,'Bathroom Accessories, Bathroom Suites, Banyo'),(1024,51,0,182,'Buy Bathroom Accessories for your contemporary and old-style washrooms from Banyo with a special price discount. Great deals and offers on Fans, Baskets, Robe Hooks and much more.'),(1025,50,0,183,'Towel Rings '),(1026,51,0,183,'Buy Towel rings from Banyo with a special price discount. We offer a wide range of high-quality bathroom accessories from top brands like ideal standard and Hudson Reed.'),(1027,50,0,184,'Bathroom Extractor Fans'),(1028,51,0,184,'Buy Bathroom Extractor Fans online from Banyo, your local bathroom store. Unbeatable Prices - Fast Delivery in the UK - Wide range of Wall-mounted, inline ceiling fan, breeze fan available. '),(1029,50,0,185,'Robe Hooks'),(1030,51,0,185,'Buy Robe Hooks online from Banyo with a special price discount. Wide range of bathroom accessories from top brands like Hudson Reed, Laufen and Ideal Standard. Unbeatable Prices!'),(1031,47,0,182,NULL),(1032,137,0,182,NULL),(1033,138,0,182,NULL),(1034,139,0,182,NULL),(1035,47,0,183,NULL),(1036,137,0,183,NULL),(1037,138,0,183,NULL),(1038,139,0,183,NULL),(1039,47,0,184,NULL),(1040,137,0,184,NULL),(1041,138,0,184,NULL),(1042,139,0,184,NULL),(1043,50,0,186,'Wire Baskets'),(1044,51,0,186,'Buy Wire Baskets from Banyo with the lowest prices in the UK. We offer a wide range of bathroom accessories from top quality brands like Hudson Reed and more. Fully brushed in chrome finished'),(1045,47,0,185,NULL),(1046,137,0,185,NULL),(1047,138,0,185,NULL),(1048,139,0,185,NULL),(1049,50,0,187,'Toilet Roll Holders '),(1050,51,0,187,'Buy Toilet Roll Holders from Banyo - Low prices guaranteed. We offer a wide range of Bathroom Accessories from top brands like Ideal Standard and Laufen. Fast Delivery in the UK. '),(1051,47,0,186,NULL),(1052,137,0,186,NULL),(1053,138,0,186,NULL),(1054,139,0,186,NULL),(1055,50,0,188,'Bathroom Shelves'),(1056,51,0,188,'Buy Shelves Online from Banyo. We offer a wide range of bathroom accessories from top brands in the UK. Laufen towel holder shelf - Lowest prices and fast delivery!'),(1057,50,0,189,'Urinal Accessories, Bathroom Accessories, Accessories'),(1058,51,0,189,'Buy Urinal Accessories online from Banyo at the lowest price in the UK. We offer a wide range of Bathroom Accessories starting from replacement valves, Partition Panel, Slimline flush, auto cistern and more.'),(1059,50,0,190,'Soap Dishes'),(1060,51,0,190,'Buy Soap Dishes with a special price discount from Banyo, your local bathroom store. We offer a wide range of Bathroom Accessories. Fast delivery in the UK - Unbeatable Prices!'),(1061,50,0,191,'Lights, Accessories'),(1062,51,0,191,'Buy Shower & Ceiling Lights online for your bathroom from Banyo at the lowest prices in the UK. Wide range of LED lights with Cool, Warm effects with elegant shades of white, polished and chrome finish. '),(1063,50,0,192,'Bathroom Mirror Lights'),(1064,51,0,192,'Banyo brings you amazing collection of Bathroom Mirror Lights products for your homes with services like Manufacturer’s Guarantees over all products and fastest delivery services for the UK residents.v'),(1065,50,0,193,'Ceiling Lights '),(1066,51,0,193,'Banyo brings you amazing collection of Ceiling Lights products for your homes with services like Manufacturer’s Guarantees over all products and fastest delivery services for the UK residents.'),(1067,50,0,194,'Neff kitchen accessories, bosch kitchen accessories, siemens kitchen accessories'),(1068,51,0,194,'Wide range of high-quality kitchen accessories from Neff, bosch and siemens are available at Banyo. Low prices, fast delivery and friendly customer support.'),(1069,50,0,195,'Bosch Accessories, Bosch Accessories London, Bosch Accessories Leicester, Bosch Accessories UK, Banyo'),(1070,51,0,195,'Relying on original Accessories from Bosch is always a good idea because the quality, functionality and durability cannot be surpassed by any other brand. You are guaranteed to find the appropriate accessory for your tools in Bosch’s accessories catalogue.'),(1071,50,0,196,'Siemens Accessories, Kitchen Accessories'),(1072,51,0,196,'Buy Siemens Accessories from Banyo, we offer a wide range of high-quality Kitchen Accessories from top brands in the UK. Lowest prices, Fast delivery and friendly customer support.'),(1073,47,0,187,NULL),(1074,137,0,187,NULL),(1075,138,0,187,NULL),(1076,139,0,187,NULL),(1077,50,0,197,'Neff Accessories, Kitchen Accessories'),(1078,51,0,197,'Buy Neff Accessories from Banyo, we offer a wide range of Kitchen Accessories from top quality brands in the UK. Price Match Promise - Fast delivery!'),(1079,47,0,189,NULL),(1080,137,0,189,NULL),(1081,138,0,189,NULL),(1082,139,0,189,NULL),(1083,47,0,190,NULL),(1084,137,0,190,NULL),(1085,138,0,190,NULL),(1086,139,0,190,NULL),(1087,47,0,188,NULL),(1088,137,0,188,NULL),(1089,138,0,188,NULL),(1090,139,0,188,NULL),(1091,47,0,191,NULL),(1092,137,0,191,NULL),(1093,138,0,191,NULL),(1094,139,0,191,NULL),(1095,47,0,192,NULL),(1096,137,0,192,NULL),(1097,138,0,192,NULL),(1098,139,0,192,NULL),(1099,47,0,193,NULL),(1100,137,0,193,NULL),(1101,138,0,193,NULL),(1102,139,0,193,NULL),(1103,47,0,194,NULL),(1104,137,0,194,NULL),(1105,138,0,194,NULL),(1106,139,0,194,NULL),(1107,47,0,195,NULL),(1108,137,0,195,NULL),(1109,138,0,195,NULL),(1110,139,0,195,NULL),(1111,47,0,196,NULL),(1112,137,0,196,NULL),(1113,138,0,196,NULL),(1114,139,0,196,NULL),(1115,47,0,197,NULL),(1116,137,0,197,NULL),(1117,138,0,197,NULL),(1118,139,0,197,NULL),(1119,47,0,20,NULL),(1120,137,0,20,NULL),(1121,138,0,20,NULL),(1122,139,0,20,NULL),(1123,47,0,199,NULL),(1124,50,0,199,NULL),(1125,51,0,199,NULL),(1126,137,0,199,NULL),(1127,138,0,199,NULL),(1128,139,0,199,NULL),(1135,47,0,168,NULL),(1136,137,0,168,NULL),(1137,138,0,168,NULL),(1138,139,0,168,NULL),(1139,47,0,219,NULL),(1140,50,0,219,'Luxury Toilets'),(1141,51,0,219,'Banyo offers a wide range of Luxury Toilets at affordable prices and fast delivery services all over the UK. Modern bathroom toilets are available at super discounts.'),(1142,137,0,219,NULL),(1143,138,0,219,NULL),(1144,139,0,219,NULL),(1145,47,0,82,NULL),(1146,137,0,82,NULL),(1147,138,0,82,NULL),(1148,139,0,82,NULL),(1149,47,0,262,NULL),(1150,50,0,262,NULL),(1151,51,0,262,NULL),(1152,137,0,262,NULL),(1153,138,0,262,NULL),(1154,139,0,262,NULL),(1155,47,0,290,NULL),(1156,50,0,290,NULL),(1157,51,0,290,NULL),(1158,137,0,290,NULL),(1159,138,0,290,NULL),(1160,139,0,290,NULL),(1161,47,0,109,NULL),(1162,50,0,109,NULL),(1163,137,0,109,NULL),(1164,138,0,109,NULL),(1165,139,0,109,NULL),(1166,47,0,318,NULL),(1167,50,0,318,NULL),(1168,51,0,318,'Upgrade your kitchen with our unbeatable deals on top brands like Franke, Blanco, and Reginox for kitchen sinks. Enjoy our Lowest price guarantee & Next day delivery'),(1169,137,0,318,NULL),(1170,138,0,318,NULL),(1171,139,0,318,NULL),(1172,47,0,148,NULL),(1173,50,0,148,NULL),(1174,137,0,148,NULL),(1175,138,0,148,NULL),(1176,139,0,148,NULL),(1177,47,0,370,NULL),(1178,50,0,370,NULL),(1179,51,0,370,NULL),(1180,137,0,370,NULL),(1181,138,0,370,NULL),(1182,139,0,370,NULL),(1183,137,0,11,NULL),(1184,138,0,11,NULL),(1185,139,0,11,NULL),(1186,47,0,203,NULL),(1187,50,0,203,NULL),(1188,51,0,203,NULL),(1189,137,0,203,NULL),(1190,138,0,203,NULL),(1191,139,0,203,NULL),(1192,47,0,405,NULL),(1193,50,0,405,NULL),(1194,51,0,405,NULL),(1195,137,0,405,NULL),(1196,138,0,405,NULL),(1197,139,0,405,NULL),(1198,47,0,444,NULL),(1199,50,0,444,NULL),(1200,51,0,444,NULL),(1201,137,0,444,NULL),(1202,138,0,444,NULL),(1203,139,0,444,NULL),(1204,47,0,406,NULL),(1205,50,0,406,NULL),(1206,51,0,406,NULL),(1207,137,0,406,NULL),(1208,138,0,406,NULL),(1209,139,0,406,NULL),(1210,47,0,407,NULL),(1211,50,0,407,NULL),(1212,51,0,407,NULL),(1213,137,0,407,NULL),(1214,138,0,407,NULL),(1215,139,0,407,NULL),(1216,47,0,408,NULL),(1217,50,0,408,NULL),(1218,51,0,408,NULL),(1219,137,0,408,NULL),(1220,138,0,408,NULL),(1221,139,0,408,NULL),(1222,47,0,409,NULL),(1223,50,0,409,NULL),(1224,51,0,409,NULL),(1225,137,0,409,NULL),(1226,138,0,409,NULL),(1227,139,0,409,NULL),(1228,47,0,410,NULL),(1229,50,0,410,NULL),(1230,51,0,410,NULL),(1231,137,0,410,NULL),(1232,138,0,410,NULL),(1233,139,0,410,NULL),(1234,47,0,411,NULL),(1235,50,0,411,NULL),(1236,51,0,411,NULL),(1237,137,0,411,NULL),(1238,138,0,411,NULL),(1239,139,0,411,NULL),(1240,47,0,413,NULL),(1241,50,0,413,NULL),(1242,51,0,413,NULL),(1243,137,0,413,NULL),(1244,138,0,413,NULL),(1245,139,0,413,NULL),(1246,47,0,414,NULL),(1247,50,0,414,NULL),(1248,51,0,414,NULL),(1249,137,0,414,NULL),(1250,138,0,414,NULL),(1251,139,0,414,NULL),(1252,47,0,415,NULL),(1253,50,0,415,NULL),(1254,51,0,415,NULL),(1255,137,0,415,NULL),(1256,138,0,415,NULL),(1257,139,0,415,NULL),(1258,47,0,416,NULL),(1259,50,0,416,NULL),(1260,51,0,416,NULL),(1261,137,0,416,NULL),(1262,138,0,416,NULL),(1263,139,0,416,NULL),(1264,47,0,417,NULL),(1265,50,0,417,NULL),(1266,51,0,417,NULL),(1267,137,0,417,NULL),(1268,138,0,417,NULL),(1269,139,0,417,NULL),(1270,47,0,418,NULL),(1271,50,0,418,NULL),(1272,51,0,418,NULL),(1273,137,0,418,NULL),(1274,138,0,418,NULL),(1275,139,0,418,NULL),(1276,47,0,419,NULL),(1277,50,0,419,NULL),(1278,51,0,419,NULL),(1279,137,0,419,NULL),(1280,138,0,419,NULL),(1281,139,0,419,NULL),(1282,47,0,420,NULL),(1283,50,0,420,NULL),(1284,51,0,420,NULL),(1285,137,0,420,NULL),(1286,138,0,420,NULL),(1287,139,0,420,NULL),(1288,47,0,422,NULL),(1289,50,0,422,NULL),(1290,51,0,422,NULL),(1291,137,0,422,NULL),(1292,138,0,422,NULL),(1293,139,0,422,NULL),(1294,47,0,424,NULL),(1295,50,0,424,NULL),(1296,51,0,424,NULL),(1297,137,0,424,NULL),(1298,138,0,424,NULL),(1299,139,0,424,NULL),(1300,47,0,425,NULL),(1301,50,0,425,NULL),(1302,51,0,425,NULL),(1303,137,0,425,NULL),(1304,138,0,425,NULL),(1305,139,0,425,NULL),(1306,47,0,426,NULL),(1307,50,0,426,NULL),(1308,51,0,426,NULL),(1309,137,0,426,NULL),(1310,138,0,426,NULL),(1311,139,0,426,NULL),(1312,47,0,427,NULL),(1313,50,0,427,NULL),(1314,51,0,427,NULL),(1315,137,0,427,NULL),(1316,138,0,427,NULL),(1317,139,0,427,NULL),(1318,47,0,429,NULL),(1319,50,0,429,NULL),(1320,51,0,429,NULL),(1321,137,0,429,NULL),(1322,138,0,429,NULL),(1323,139,0,429,NULL),(1324,47,0,430,NULL),(1325,50,0,430,NULL),(1326,51,0,430,NULL),(1327,137,0,430,NULL),(1328,138,0,430,NULL),(1329,139,0,430,NULL),(1330,47,0,431,NULL),(1331,50,0,431,NULL),(1332,51,0,431,NULL),(1333,137,0,431,NULL),(1334,138,0,431,NULL),(1335,139,0,431,NULL),(1336,47,0,432,NULL),(1337,50,0,432,NULL),(1338,51,0,432,NULL),(1339,137,0,432,NULL),(1340,138,0,432,NULL),(1341,139,0,432,NULL),(1342,47,0,433,NULL),(1343,50,0,433,NULL),(1344,51,0,433,NULL),(1345,137,0,433,NULL),(1346,138,0,433,NULL),(1347,139,0,433,NULL),(1348,47,0,434,NULL),(1349,50,0,434,NULL),(1350,51,0,434,NULL),(1351,137,0,434,NULL),(1352,138,0,434,NULL),(1353,139,0,434,NULL),(1354,47,0,435,NULL),(1355,50,0,435,NULL),(1356,51,0,435,NULL),(1357,137,0,435,NULL),(1358,138,0,435,NULL),(1359,139,0,435,NULL),(1360,47,0,436,NULL),(1361,50,0,436,NULL),(1362,51,0,436,NULL),(1363,137,0,436,NULL),(1364,138,0,436,NULL),(1365,139,0,436,NULL),(1366,47,0,437,NULL),(1367,50,0,437,NULL),(1368,51,0,437,NULL),(1369,137,0,437,NULL),(1370,138,0,437,NULL),(1371,139,0,437,NULL),(1372,47,0,439,NULL),(1373,50,0,439,NULL),(1374,51,0,439,NULL),(1375,137,0,439,NULL),(1376,138,0,439,NULL),(1377,139,0,439,NULL),(1378,47,0,441,NULL),(1379,50,0,441,NULL),(1380,51,0,441,NULL),(1381,137,0,441,NULL),(1382,138,0,441,NULL),(1383,139,0,441,NULL),(1384,47,0,442,NULL),(1385,50,0,442,NULL),(1386,51,0,442,NULL),(1387,137,0,442,NULL),(1388,138,0,442,NULL),(1389,139,0,442,NULL),(1390,47,0,443,NULL),(1391,50,0,443,NULL),(1392,51,0,443,NULL),(1393,137,0,443,NULL),(1394,138,0,443,NULL),(1395,139,0,443,NULL),(1396,47,0,440,NULL),(1397,50,0,440,NULL),(1398,51,0,440,NULL),(1399,137,0,440,NULL),(1400,138,0,440,NULL),(1401,139,0,440,NULL),(1402,47,0,368,NULL),(1403,50,0,368,NULL),(1404,51,0,368,NULL),(1405,137,0,368,NULL),(1406,138,0,368,NULL),(1407,139,0,368,NULL),(1408,47,0,371,NULL),(1409,50,0,371,NULL),(1410,51,0,371,NULL),(1411,137,0,371,NULL),(1412,138,0,371,NULL),(1413,139,0,371,NULL),(1414,47,0,373,NULL),(1415,50,0,373,NULL),(1416,51,0,373,NULL),(1417,137,0,373,NULL),(1418,138,0,373,NULL),(1419,139,0,373,NULL),(1420,47,0,374,NULL),(1421,50,0,374,NULL),(1422,51,0,374,NULL),(1423,137,0,374,NULL),(1424,138,0,374,NULL),(1425,139,0,374,NULL),(1426,47,0,375,NULL),(1427,50,0,375,NULL),(1428,51,0,375,NULL),(1429,137,0,375,NULL),(1430,138,0,375,NULL),(1431,139,0,375,NULL),(1432,47,0,376,NULL),(1433,50,0,376,NULL),(1434,51,0,376,NULL),(1435,137,0,376,NULL),(1436,138,0,376,NULL),(1437,139,0,376,NULL),(1438,47,0,377,NULL),(1439,50,0,377,NULL),(1440,51,0,377,NULL),(1441,137,0,377,NULL),(1442,138,0,377,NULL),(1443,139,0,377,NULL),(1444,47,0,366,NULL),(1445,50,0,366,NULL),(1446,51,0,366,NULL),(1447,137,0,366,NULL),(1448,138,0,366,NULL),(1449,139,0,366,NULL),(1450,47,0,307,NULL),(1451,50,0,307,NULL),(1452,51,0,307,NULL),(1453,137,0,307,NULL),(1454,138,0,307,NULL),(1455,139,0,307,NULL),(1456,47,0,379,NULL),(1457,50,0,379,NULL),(1458,51,0,379,NULL),(1459,137,0,379,NULL),(1460,138,0,379,NULL),(1461,139,0,379,NULL),(1462,47,0,381,NULL),(1463,50,0,381,NULL),(1464,51,0,381,NULL),(1465,137,0,381,NULL),(1466,138,0,381,NULL),(1467,139,0,381,NULL),(1468,47,0,382,NULL),(1469,50,0,382,NULL),(1470,51,0,382,NULL),(1471,137,0,382,NULL),(1472,138,0,382,NULL),(1473,139,0,382,NULL),(1474,47,0,383,NULL),(1475,50,0,383,NULL),(1476,51,0,383,NULL),(1477,137,0,383,NULL),(1478,138,0,383,NULL),(1479,139,0,383,NULL),(1480,47,0,385,NULL),(1481,50,0,385,NULL),(1482,51,0,385,NULL),(1483,137,0,385,NULL),(1484,138,0,385,NULL),(1485,139,0,385,NULL),(1486,47,0,386,NULL),(1487,50,0,386,NULL),(1488,51,0,386,NULL),(1489,137,0,386,NULL),(1490,138,0,386,NULL),(1491,139,0,386,NULL),(1492,47,0,387,NULL),(1493,50,0,387,NULL),(1494,51,0,387,NULL),(1495,137,0,387,NULL),(1496,138,0,387,NULL),(1497,139,0,387,NULL),(1498,47,0,445,NULL),(1499,50,0,445,NULL),(1500,51,0,445,NULL),(1501,137,0,445,NULL),(1502,138,0,445,NULL),(1503,139,0,445,NULL),(1504,47,0,308,NULL),(1505,50,0,308,NULL),(1506,51,0,308,NULL),(1507,137,0,308,NULL),(1508,138,0,308,NULL),(1509,139,0,308,NULL),(1510,47,0,309,NULL),(1511,50,0,309,NULL),(1512,51,0,309,NULL),(1513,137,0,309,NULL),(1514,138,0,309,NULL),(1515,139,0,309,NULL),(1516,47,0,310,NULL),(1517,50,0,310,NULL),(1518,51,0,310,NULL),(1519,137,0,310,NULL),(1520,138,0,310,NULL),(1521,139,0,310,NULL),(1522,47,0,311,NULL),(1523,50,0,311,NULL),(1524,51,0,311,NULL),(1525,137,0,311,NULL),(1526,138,0,311,NULL),(1527,139,0,311,NULL),(1528,47,0,312,NULL),(1529,50,0,312,NULL),(1530,51,0,312,NULL),(1531,137,0,312,NULL),(1532,138,0,312,NULL),(1533,139,0,312,NULL),(1534,47,0,313,NULL),(1535,50,0,313,NULL),(1536,51,0,313,NULL),(1537,137,0,313,NULL),(1538,138,0,313,NULL),(1539,139,0,313,NULL),(1540,47,0,314,NULL),(1541,50,0,314,NULL),(1542,51,0,314,NULL),(1543,137,0,314,NULL),(1544,138,0,314,NULL),(1545,139,0,314,NULL),(1546,47,0,315,NULL),(1547,50,0,315,NULL),(1548,51,0,315,NULL),(1549,137,0,315,NULL),(1550,138,0,315,NULL),(1551,139,0,315,NULL),(1552,47,0,322,NULL),(1553,50,0,322,NULL),(1554,51,0,322,NULL),(1555,137,0,322,NULL),(1556,138,0,322,NULL),(1557,139,0,322,NULL),(1558,47,0,324,NULL),(1559,50,0,324,NULL),(1560,51,0,324,NULL),(1561,137,0,324,NULL),(1562,138,0,324,NULL),(1563,139,0,324,NULL),(1564,47,0,325,NULL),(1565,50,0,325,NULL),(1566,51,0,325,NULL),(1567,137,0,325,NULL),(1568,138,0,325,NULL),(1569,139,0,325,NULL),(1570,47,0,326,NULL),(1571,50,0,326,NULL),(1572,51,0,326,NULL),(1573,137,0,326,NULL),(1574,138,0,326,NULL),(1575,139,0,326,NULL),(1576,47,0,328,NULL),(1577,50,0,328,NULL),(1578,51,0,328,NULL),(1579,137,0,328,NULL),(1580,138,0,328,NULL),(1581,139,0,328,NULL),(1582,47,0,327,NULL),(1583,50,0,327,NULL),(1584,51,0,327,NULL),(1585,137,0,327,NULL),(1586,138,0,327,NULL),(1587,139,0,327,NULL),(1588,47,0,329,NULL),(1589,50,0,329,NULL),(1590,51,0,329,NULL),(1591,137,0,329,NULL),(1592,138,0,329,NULL),(1593,139,0,329,NULL),(1594,47,0,330,NULL),(1595,50,0,330,NULL),(1596,51,0,330,NULL),(1597,137,0,330,NULL),(1598,138,0,330,NULL),(1599,139,0,330,NULL),(1600,47,0,331,NULL),(1601,50,0,331,NULL),(1602,51,0,331,NULL),(1603,137,0,331,NULL),(1604,138,0,331,NULL),(1605,139,0,331,NULL),(1606,47,0,336,NULL),(1607,50,0,336,NULL),(1608,51,0,336,NULL),(1609,137,0,336,NULL),(1610,138,0,336,NULL),(1611,139,0,336,NULL),(1612,47,0,345,NULL),(1613,50,0,345,NULL),(1614,51,0,345,NULL),(1615,137,0,345,NULL),(1616,138,0,345,NULL),(1617,139,0,345,NULL),(1618,47,0,346,NULL),(1619,50,0,346,NULL),(1620,51,0,346,NULL),(1621,137,0,346,NULL),(1622,138,0,346,NULL),(1623,139,0,346,NULL),(1624,47,0,338,NULL),(1625,50,0,338,NULL),(1626,51,0,338,NULL),(1627,137,0,338,NULL),(1628,138,0,338,NULL),(1629,139,0,338,NULL),(1630,47,0,339,NULL),(1631,50,0,339,NULL),(1632,51,0,339,NULL),(1633,137,0,339,NULL),(1634,138,0,339,NULL),(1635,139,0,339,NULL),(1636,47,0,340,NULL),(1637,50,0,340,NULL),(1638,51,0,340,NULL),(1639,137,0,340,NULL),(1640,138,0,340,NULL),(1641,139,0,340,NULL),(1642,47,0,341,NULL),(1643,50,0,341,NULL),(1644,51,0,341,NULL),(1645,137,0,341,NULL),(1646,138,0,341,NULL),(1647,139,0,341,NULL),(1648,47,0,342,NULL),(1649,50,0,342,NULL),(1650,51,0,342,NULL),(1651,137,0,342,NULL),(1652,138,0,342,NULL),(1653,139,0,342,NULL),(1654,47,0,359,NULL),(1655,50,0,359,NULL),(1656,51,0,359,NULL),(1657,137,0,359,NULL),(1658,138,0,359,NULL),(1659,139,0,359,NULL),(1660,47,0,360,NULL),(1661,50,0,360,NULL),(1662,51,0,360,NULL),(1663,137,0,360,NULL),(1664,138,0,360,NULL),(1665,139,0,360,NULL),(1666,47,0,361,NULL),(1667,50,0,361,NULL),(1668,51,0,361,NULL),(1669,137,0,361,NULL),(1670,138,0,361,NULL),(1671,139,0,361,NULL),(1672,47,0,362,NULL),(1673,50,0,362,NULL),(1674,51,0,362,NULL),(1675,137,0,362,NULL),(1676,138,0,362,NULL),(1677,139,0,362,NULL),(1678,47,0,351,NULL),(1679,50,0,351,NULL),(1680,51,0,351,NULL),(1681,137,0,351,NULL),(1682,138,0,351,NULL),(1683,139,0,351,NULL),(1684,47,0,352,NULL),(1685,50,0,352,NULL),(1686,51,0,352,NULL),(1687,137,0,352,NULL),(1688,138,0,352,NULL),(1689,139,0,352,NULL),(1690,47,0,353,NULL),(1691,50,0,353,NULL),(1692,51,0,353,NULL),(1693,137,0,353,NULL),(1694,138,0,353,NULL),(1695,139,0,353,NULL),(1696,47,0,354,NULL),(1697,50,0,354,NULL),(1698,51,0,354,NULL),(1699,137,0,354,NULL),(1700,138,0,354,NULL),(1701,139,0,354,NULL),(1702,47,0,355,NULL),(1703,50,0,355,NULL),(1704,51,0,355,NULL),(1705,137,0,355,NULL),(1706,138,0,355,NULL),(1707,139,0,355,NULL),(1708,47,0,198,NULL),(1709,50,0,198,NULL),(1710,51,0,198,NULL),(1711,137,0,198,NULL),(1712,138,0,198,NULL),(1713,139,0,198,NULL),(1714,47,0,200,NULL),(1715,50,0,200,NULL),(1716,51,0,200,NULL),(1717,137,0,200,NULL),(1718,138,0,200,NULL),(1719,139,0,200,NULL),(1720,47,0,205,NULL),(1721,50,0,205,NULL),(1722,51,0,205,NULL),(1723,137,0,205,NULL),(1724,138,0,205,NULL),(1725,139,0,205,NULL),(1726,47,0,365,NULL),(1727,50,0,365,NULL),(1728,51,0,365,NULL),(1729,137,0,365,NULL),(1730,138,0,365,NULL),(1731,139,0,365,NULL),(1732,47,0,349,NULL),(1733,50,0,349,NULL),(1734,51,0,349,NULL),(1735,137,0,349,NULL),(1736,138,0,349,NULL),(1737,139,0,349,NULL),(1738,47,0,210,NULL),(1739,50,0,210,NULL),(1740,51,0,210,NULL),(1741,137,0,210,NULL),(1742,138,0,210,NULL),(1743,139,0,210,NULL),(1744,47,0,211,NULL),(1745,50,0,211,NULL),(1746,51,0,211,NULL),(1747,137,0,211,NULL),(1748,138,0,211,NULL),(1749,139,0,211,NULL),(1750,47,0,212,NULL),(1751,50,0,212,NULL),(1752,51,0,212,NULL),(1753,137,0,212,NULL),(1754,138,0,212,NULL),(1755,139,0,212,NULL),(1756,47,0,213,NULL),(1757,50,0,213,NULL),(1758,51,0,213,NULL),(1759,137,0,213,NULL),(1760,138,0,213,NULL),(1761,139,0,213,NULL),(1762,47,0,214,NULL),(1763,50,0,214,NULL),(1764,51,0,214,NULL),(1765,137,0,214,NULL),(1766,138,0,214,NULL),(1767,139,0,214,NULL),(1768,47,0,215,NULL),(1769,50,0,215,NULL),(1770,51,0,215,NULL),(1771,137,0,215,NULL),(1772,138,0,215,NULL),(1773,139,0,215,NULL),(1774,47,0,216,NULL),(1775,50,0,216,NULL),(1776,51,0,216,NULL),(1777,137,0,216,NULL),(1778,138,0,216,NULL),(1779,139,0,216,NULL),(1780,47,0,221,NULL),(1781,50,0,221,NULL),(1782,51,0,221,NULL),(1783,137,0,221,NULL),(1784,138,0,221,NULL),(1785,139,0,221,NULL),(1786,47,0,222,NULL),(1787,50,0,222,NULL),(1788,51,0,222,NULL),(1789,137,0,222,NULL),(1790,138,0,222,NULL),(1791,139,0,222,NULL),(1792,47,0,208,NULL),(1793,50,0,208,NULL),(1794,51,0,208,NULL),(1795,137,0,208,NULL),(1796,138,0,208,NULL),(1797,139,0,208,NULL),(1798,47,0,227,NULL),(1799,50,0,227,NULL),(1800,51,0,227,NULL),(1801,137,0,227,NULL),(1802,138,0,227,NULL),(1803,139,0,227,NULL),(1804,47,0,229,NULL),(1805,50,0,229,NULL),(1806,51,0,229,NULL),(1807,137,0,229,NULL),(1808,138,0,229,NULL),(1809,139,0,229,NULL),(1810,47,0,231,NULL),(1811,50,0,231,NULL),(1812,51,0,231,NULL),(1813,137,0,231,NULL),(1814,138,0,231,NULL),(1815,139,0,231,NULL),(1816,47,0,232,NULL),(1817,50,0,232,NULL),(1818,51,0,232,NULL),(1819,137,0,232,NULL),(1820,138,0,232,NULL),(1821,139,0,232,NULL),(1822,47,0,233,NULL),(1823,50,0,233,NULL),(1824,51,0,233,NULL),(1825,137,0,233,NULL),(1826,138,0,233,NULL),(1827,139,0,233,NULL),(1828,47,0,234,NULL),(1829,50,0,234,NULL),(1830,51,0,234,NULL),(1831,137,0,234,NULL),(1832,138,0,234,NULL),(1833,139,0,234,NULL),(1834,47,0,235,NULL),(1835,50,0,235,NULL),(1836,51,0,235,NULL),(1837,137,0,235,NULL),(1838,138,0,235,NULL),(1839,139,0,235,NULL),(1840,47,0,236,NULL),(1841,50,0,236,NULL),(1842,51,0,236,NULL),(1843,137,0,236,NULL),(1844,138,0,236,NULL),(1845,139,0,236,NULL),(1846,47,0,237,NULL),(1847,50,0,237,NULL),(1848,51,0,237,NULL),(1849,137,0,237,NULL),(1850,138,0,237,NULL),(1851,139,0,237,NULL),(1852,47,0,238,NULL),(1853,50,0,238,NULL),(1854,51,0,238,NULL),(1855,137,0,238,NULL),(1856,138,0,238,NULL),(1857,139,0,238,NULL),(1858,47,0,239,NULL),(1859,50,0,239,NULL),(1860,51,0,239,NULL),(1861,137,0,239,NULL),(1862,138,0,239,NULL),(1863,139,0,239,NULL),(1864,47,0,241,NULL),(1865,50,0,241,NULL),(1866,51,0,241,NULL),(1867,137,0,241,NULL),(1868,138,0,241,NULL),(1869,139,0,241,NULL),(1870,47,0,242,NULL),(1871,50,0,242,NULL),(1872,51,0,242,NULL),(1873,137,0,242,NULL),(1874,138,0,242,NULL),(1875,139,0,242,NULL),(1876,47,0,243,NULL),(1877,50,0,243,NULL),(1878,51,0,243,NULL),(1879,137,0,243,NULL),(1880,138,0,243,NULL),(1881,139,0,243,NULL),(1882,47,0,244,NULL),(1883,50,0,244,NULL),(1884,51,0,244,NULL),(1885,137,0,244,NULL),(1886,138,0,244,NULL),(1887,139,0,244,NULL),(1888,153,3,2,NULL),(1889,47,0,449,NULL),(1890,50,0,449,NULL),(1891,51,0,449,NULL),(1892,137,0,449,NULL),(1893,138,0,449,NULL),(1894,139,0,449,NULL),(1895,153,0,449,NULL),(1896,153,0,2,NULL),(1897,153,0,219,NULL),(1898,153,0,25,NULL),(1899,153,0,5,NULL),(1900,153,0,3,NULL),(1901,153,0,15,NULL),(1902,153,0,7,NULL),(1903,153,0,12,NULL),(1904,153,0,8,NULL),(1905,153,0,9,NULL),(1906,153,3,15,NULL),(1907,153,4,8,NULL),(1908,153,1,219,NULL),(1909,153,1,165,NULL),(1910,153,1,15,NULL),(1911,153,1,8,NULL),(1912,153,3,8,NULL),(1913,153,3,12,NULL),(1914,153,3,366,NULL),(1915,153,3,367,NULL),(1916,153,3,135,NULL),(1917,153,3,7,NULL),(1918,153,3,318,NULL),(1919,137,1,3,NULL),(1920,138,1,3,NULL),(1921,139,1,3,NULL),(1922,153,1,3,NULL),(1923,153,3,145,NULL),(1924,153,0,318,NULL),(1925,153,0,346,NULL),(1926,153,0,106,NULL),(1927,153,0,307,NULL),(1928,153,2,5,NULL),(1929,153,1,5,NULL),(1930,153,3,5,NULL),(1931,153,4,7,NULL),(1932,153,5,5,NULL),(1933,153,5,318,NULL),(1934,153,5,7,NULL),(1935,153,5,366,NULL),(1936,153,5,219,NULL),(1937,153,1,318,NULL),(1938,153,1,163,NULL),(1939,153,3,163,NULL),(1940,137,3,3,'\r\n'),(1941,138,3,3,'\r\n'),(1942,139,3,3,NULL),(1943,153,3,3,NULL),(1944,153,3,219,NULL),(1945,153,3,4,NULL),(1946,153,3,71,NULL),(1947,153,3,37,NULL),(1948,153,3,25,NULL),(1949,153,3,9,NULL),(1950,137,3,4,NULL),(1951,138,3,4,NULL),(1952,139,3,4,NULL),(1953,153,3,253,NULL),(1954,153,0,71,NULL),(1955,153,1,4,NULL),(1956,153,1,37,NULL),(1957,153,3,343,NULL),(1958,137,3,343,NULL),(1959,138,3,343,NULL),(1960,139,3,343,NULL),(1961,137,1,343,NULL),(1962,138,1,343,NULL),(1963,139,1,343,NULL),(1964,153,1,343,NULL);
/*!40000 ALTER TABLE `catalog_category_entity_text` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_entity_varchar`
--

DROP TABLE IF EXISTS `catalog_category_entity_varchar`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_entity_varchar` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CATALOG_CATEGORY_ENTITY_VARCHAR_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `CATALOG_CATEGORY_ENTITY_VARCHAR_ENTITY_ID` (`entity_id`),
  KEY `CATALOG_CATEGORY_ENTITY_VARCHAR_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_CATEGORY_ENTITY_VARCHAR_STORE_ID` (`store_id`),
  CONSTRAINT `CAT_CTGR_ENTT_VCHR_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_CTGR_ENTT_VCHR_ENTT_ID_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_category_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_CATEGORY_ENTITY_VARCHAR_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=6403 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Varchar Attribute Backend Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_entity_varchar`
--

LOCK TABLES `catalog_category_entity_varchar` WRITE;
/*!40000 ALTER TABLE `catalog_category_entity_varchar` DISABLE KEYS */;
INSERT INTO `catalog_category_entity_varchar` VALUES (1,45,0,1,'Root Catalog'),(2,52,0,2,'PRODUCTS'),(3,45,0,2,'Default Category'),(4,45,0,3,'Bathroom'),(5,52,0,3,'PRODUCTS_AND_PAGE'),(6,63,0,3,'1column'),(7,119,0,3,'bathroom'),(8,120,0,3,'bathroom'),(9,45,0,4,'Shower Enclosures'),(10,52,0,4,'PRODUCTS'),(11,63,0,4,'category-full-width'),(12,119,0,4,'showering'),(13,120,0,4,'bathroom/showering'),(18,45,0,5,'Kitchens'),(19,52,0,5,'PRODUCTS'),(20,63,0,5,'category-full-width'),(21,119,0,5,'kitchen-appliances'),(22,120,0,5,'kitchen-appliances'),(23,45,0,6,'Fireplaces'),(24,52,0,6,'PRODUCTS'),(25,63,0,6,'category-full-width'),(26,119,0,6,'fires'),(27,120,0,6,'heating/fires'),(28,45,0,7,'Heating'),(29,52,0,7,'PRODUCTS'),(30,63,0,7,'category-full-width'),(31,119,0,7,'heating'),(32,120,0,7,'heating'),(33,45,0,8,'Taps'),(34,52,0,8,'PRODUCTS'),(35,63,0,8,'category-full-width'),(36,119,0,8,'taps'),(37,120,0,8,'bathroom/taps'),(38,45,0,9,'Showers'),(39,52,0,9,'PRODUCTS'),(40,63,0,9,'category-full-width'),(41,119,0,9,'shower-valves'),(42,120,0,9,'bathroom/shower-valves'),(43,45,0,10,'Disable - Accessories'),(44,52,0,10,'PRODUCTS'),(45,63,0,10,'category-full-width'),(46,119,0,10,'accessories'),(47,120,0,10,'accessories'),(48,45,0,11,'Disable - Sales'),(49,52,0,11,'PRODUCTS'),(50,63,0,11,'category-full-width'),(51,119,0,11,'sales'),(52,120,0,11,'sales'),(53,45,0,12,'Brands'),(54,52,0,12,'PRODUCTS'),(55,63,0,12,'category-full-width'),(56,119,0,12,'brands'),(57,120,0,12,'brands'),(64,45,0,15,'Toilets'),(65,49,0,15,'Luxury Toilets, High Quality Bathroom Toilets - Super Discounted prices'),(66,52,0,15,'PRODUCTS_AND_PAGE'),(67,63,0,15,'category-full-width'),(68,119,0,15,'toilets'),(69,120,0,15,'bathroom/toilet/toilets'),(71,48,0,15,'straight-bath.png'),(72,60,0,15,NULL),(73,45,0,16,'Close Coupled Toilets'),(74,49,0,16,'Close Coupled toilets UK - Close Coupled toilet | Banyo'),(75,52,0,16,'PRODUCTS'),(76,63,0,16,'category-full-width'),(77,119,0,16,'close-coupled-toilets'),(78,120,0,16,'bathroom/toilet/toilets/close-coupled-toilets'),(79,45,0,17,'Back To Wall Toilets'),(80,49,0,17,'Comfort Height Back to Wall Toilets UK - Back to wall WC Units | Banyo'),(81,52,0,17,'PRODUCTS'),(82,63,0,17,'category-full-width'),(83,119,0,17,'back-to-wall-toilets'),(84,120,0,17,'bathroom/toilet/toilets/back-to-wall-toilets'),(86,48,0,3,'kitchen-sink_2.jpeg'),(87,49,0,3,'Affordable Bathroom Products Online - Furniture, Suite, Bath | Banyo'),(88,60,0,3,NULL),(89,45,0,18,'Wall Hung Toilets'),(90,49,0,18,'wall-hung-toilets'),(91,52,0,18,'PRODUCTS'),(92,63,0,18,'category-full-width'),(93,119,0,18,'wall-hung-toilets'),(94,120,0,18,'bathroom/toilet/toilets/wall-hung-toilets'),(101,45,0,20,'Disable - Corner Toilets'),(102,49,0,20,'Corner Toilets Unit for Cloakrooms, Small Bathrooms | Banyo'),(103,52,0,20,'PRODUCTS'),(104,63,0,20,'category-full-width'),(105,119,0,20,'corner-toilets'),(106,120,0,20,'bathroom/toilet/toilets/corner-toilets'),(107,45,0,21,'Disable - Bidets'),(108,49,0,21,'Bidets - Shop Bathroom Bidets Online | Banyo'),(109,52,0,21,'PRODUCTS'),(110,63,0,21,'category-full-width'),(111,119,0,21,'bidets'),(112,120,0,21,'bathroom/toilet/toilets/bidets'),(113,45,0,22,'Urinals'),(114,49,0,22,'Urinals – Wall Hung Urinals | Banyo'),(115,52,0,22,'PRODUCTS'),(116,63,0,22,'category-full-width'),(117,119,0,22,'urinals'),(118,120,0,22,'bathroom/toilet/toilets/urinals'),(119,45,0,23,'Toilet Seats'),(120,49,0,23,'Bathroom Toilet Seats – Replacement Toilet Seat - Soft Close Toilet Seat | Banyo'),(121,52,0,23,'PRODUCTS'),(122,63,0,23,'category-full-width'),(123,119,0,23,'toilet-seats'),(124,120,0,23,'bathroom/toilet/toilet-accessories/toilet-seats'),(125,45,0,24,'Concealed Cisterns'),(126,49,0,24,'Toilet Cisterns - Concealed Toilet Cisterns | Banyo UK'),(127,52,0,24,'PRODUCTS'),(128,63,0,24,'category-full-width'),(129,119,0,24,'concealed-cisterns'),(130,120,0,24,'bathroom/toilet/toilets/concealed-cisterns'),(131,45,0,25,'Basins'),(132,49,0,25,'Bathroom Basins & Sinks - Bathroom Vanity Units | Banyo'),(133,52,0,25,'PRODUCTS'),(134,63,0,25,'category-full-width'),(135,119,0,25,'basins'),(136,120,0,25,'bathroom/basins'),(137,45,0,26,'Full Pedestal Basins'),(138,49,0,26,'Bathroom Basins - Small and Big Bathroom Basins at banyo'),(139,52,0,26,'PRODUCTS'),(140,63,0,26,'category-full-width'),(141,119,0,26,'pedestal-basins'),(142,120,0,26,'bathroom/basins/basins/pedestal-basins'),(143,45,0,27,'Wall Hung Basins'),(144,49,0,27,'Wall hung basins | Wall Mounted Basins | Banyo'),(145,52,0,27,'PRODUCTS'),(146,63,0,27,'category-full-width'),(147,119,0,27,'wall-hung-basins'),(148,120,0,27,'bathroom/basins/basins/wall-hung-basins'),(149,45,0,28,'Corner Basins'),(150,49,0,28,'Corner basins - Cloakroom Basins - Small Bathroom Suites'),(151,52,0,28,'PRODUCTS'),(152,63,0,28,'category-full-width'),(153,119,0,28,'corner-basins'),(154,120,0,28,'bathroom/basins/basins/corner-basins'),(155,45,0,29,'Disable - Cloakroom Basins'),(156,49,0,29,'Cloakroom Basins, Sinks - Small Bathroom Suites Deals at Banyo'),(157,52,0,29,'PRODUCTS'),(158,63,0,29,'category-full-width'),(159,119,0,29,'cloakroom-basins'),(160,120,0,29,'bathroom/basins/basins/cloakroom-basins'),(161,45,0,30,'Vanity Basins'),(162,49,0,30,'Bathroom Vanity Units - Basins Vanity Units - Banyo'),(163,52,0,30,'PRODUCTS'),(164,63,0,30,'category-full-width'),(165,119,0,30,'vanity-basins'),(166,120,0,30,'bathroom/basins/basins/vanity-basins'),(167,45,0,31,'Semi Recessed Basins'),(168,49,0,31,'Semi Recessed Basins | Designer Bathroom Basins | Banyo'),(169,52,0,31,'PRODUCTS'),(170,63,0,31,'category-full-width'),(171,119,0,31,'semi-recessed-basins'),(172,120,0,31,'bathroom/basins/basins/semi-recessed-basins'),(173,45,0,32,'Under Counter Basins'),(174,49,0,32,'Buy Designer Undercounter Basins For Modern Bathrooms'),(175,52,0,32,'PRODUCTS'),(176,63,0,32,'category-full-width'),(177,119,0,32,'under-counter-basins'),(178,120,0,32,'bathroom/basins/basins/under-counter-basins'),(179,45,0,33,'Counter Top Basins'),(180,49,0,33,'Counter Top Basins | Countertop Sinks | Washbasins UK'),(181,52,0,33,'PRODUCTS'),(182,63,0,33,'category-full-width'),(183,119,0,33,'counter-top-basins'),(184,120,0,33,'bathroom/basins/basins/counter-top-basins'),(185,45,0,34,'Disable - Sit On Basins'),(186,49,0,34,'Sit On Basins - Small Bathroom Basins - Countertop Basins'),(187,52,0,34,'PRODUCTS'),(188,63,0,34,'category-full-width'),(189,119,0,34,'sit-on-basins'),(190,120,0,34,'bathroom/basins/basins/sit-on-basins'),(191,45,0,35,'Bottle Traps'),(192,49,0,35,'Bathroom Basins Bottle Trap Deals in UK - Banyo'),(193,52,0,35,'PRODUCTS'),(194,63,0,35,'category-full-width'),(195,119,0,35,'bottle-traps'),(196,120,0,35,'bathroom/basins/accessories/bottle-traps'),(197,45,0,36,'Basin Wastes'),(198,49,0,36,'Bathroom Basin waste Best Deals in UK - Banyo'),(199,52,0,36,'PRODUCTS'),(200,63,0,36,'category-full-width'),(201,119,0,36,'basin-wastes'),(202,120,0,36,'bathroom/basins/accessories/basin-wastes'),(203,45,0,37,'Baths'),(204,49,0,37,'Bathroom baths & Bathtubs - Traditional & Modern Baths | Banyo'),(205,52,0,37,'PRODUCTS'),(206,63,0,37,'category-full-width'),(207,119,0,37,'baths'),(208,120,0,37,'bathroom/baths'),(209,45,0,38,'Disable - Straight Baths'),(210,49,0,38,'Straight Baths - Stylish And Durable Bath Sales At Banyo'),(211,52,0,38,'PRODUCTS'),(212,63,0,38,'1column'),(213,119,0,38,'straight-baths'),(214,120,0,38,'bathroom/baths/baths/straight-baths'),(215,45,0,39,'Free Standing Baths'),(216,49,0,39,'Free Standing Baths - Luxury Baths at Best Prices in UK'),(217,52,0,39,'PRODUCTS'),(218,63,0,39,'category-full-width'),(219,119,0,39,'free-standing-baths'),(220,120,0,39,'bathroom/baths/baths/free-standing-baths'),(221,45,0,40,'Corner Baths'),(222,49,0,40,'Corner Baths - Space Saving Bathroom Suites | Banyo'),(223,52,0,40,'PRODUCTS'),(224,63,0,40,'category-full-width'),(225,119,0,40,'corner-baths'),(226,120,0,40,'bathroom/baths/baths/corner-baths'),(227,45,0,41,'Oval Baths'),(228,49,0,41,'Oval Baths - Contemporary Freestanding Baths - Banyo'),(229,52,0,41,'PRODUCTS'),(230,63,0,41,'category-full-width'),(231,119,0,41,'oval-baths'),(232,120,0,41,'bathroom/baths/baths/oval-baths'),(233,45,0,42,'Shower Baths'),(234,49,0,42,'Shower Baths - Modern Bathroom Suites Deals at Banyo'),(235,52,0,42,'PRODUCTS'),(236,63,0,42,'category-full-width'),(237,119,0,42,'shower-baths'),(238,120,0,42,'bathroom/baths/baths/shower-baths'),(239,45,0,43,'Traditional Baths'),(240,49,0,43,'Traditional Baths - Best Traditional Bathroom Suites'),(241,52,0,43,'PRODUCTS'),(242,63,0,43,'category-full-width'),(243,119,0,43,'traditional-baths'),(244,120,0,43,'bathroom/baths/baths/traditional-baths'),(245,45,0,44,'Bath Screens'),(246,49,0,44,'Bath Screens - Shower Screens - Luxury bathrooms UK'),(247,52,0,44,'PRODUCTS'),(248,63,0,44,'category-full-width'),(249,119,0,44,'bath-screens'),(250,120,0,44,'bathroom/baths/bathroom-accessories/bath-screens'),(251,45,0,45,'Bath Overflow and Wastes'),(252,49,0,45,'Best Deals On Bath Wastes At Banyo'),(253,52,0,45,'PRODUCTS'),(254,63,0,45,'category-full-width'),(255,119,0,45,'bath-wastes-and-drainer'),(256,120,0,45,'bathroom/baths/bathroom-accessories/bath-wastes-and-drainer'),(257,45,0,46,'Bathroom Furniture'),(258,49,0,46,'Bathroom Cabinets | Bathroom Storage Furniture |Bathroom Ideas'),(259,52,0,46,'PRODUCTS'),(260,63,0,46,'category-full-width'),(261,119,0,46,'bathroom-furniture'),(262,120,0,46,'bathroom/bathroom-furniture'),(263,45,0,47,'Floor Standing Vanity Units'),(264,49,0,47,'Free Standing Bathroom Cabinets | Bathroom Storage Ideas'),(265,52,0,47,'PRODUCTS'),(266,63,0,47,'category-full-width'),(267,119,0,47,'floor-standing-units'),(268,120,0,47,'bathroom/bathroom-furniture/bathroom-furniture/floor-standing-units'),(269,45,0,48,'Wall Hung Vanity Units'),(270,49,0,48,'Bathroom Wall Hung Vanity Units | Bathroom Storage Ideas'),(271,52,0,48,'PRODUCTS'),(272,63,0,48,'category-full-width'),(273,119,0,48,'wall-hung-units'),(274,120,0,48,'bathroom/bathroom-furniture/bathroom-furniture/wall-hung-units'),(275,45,0,49,'Cloakroom Vanity Units'),(276,49,0,49,'Bathroom Furniture Sets | Cloakroom Units | Bathroom Ideas'),(277,52,0,49,'PRODUCTS'),(278,63,0,49,'category-full-width'),(279,119,0,49,'cloakroom-units'),(280,120,0,49,'bathroom/bathroom-furniture/bathroom-furniture/cloakroom-units'),(281,45,0,50,'WC units'),(282,49,0,50,'Back to Wall Toilet Units | WC Units | Banyo Bathrooms'),(283,52,0,50,'PRODUCTS'),(284,63,0,50,'category-full-width'),(285,119,0,50,'wc-units'),(286,120,0,50,'bathroom/bathroom-furniture/bathroom-furniture/wc-units'),(287,45,0,51,'Disable - Bathroom suites'),(288,49,0,51,'Comtemporary Suites, Bathroom Suites, banyo.co.uk'),(289,52,0,51,'PRODUCTS'),(290,63,0,51,'category-full-width'),(291,119,0,51,'bathroom-suites'),(292,120,0,51,'bathroom/bathroom-suites'),(293,45,0,52,'Cloakroom Suites'),(294,49,0,52,'Cloak Room Bathroom Suites - Space Saving Bathroom Suites '),(295,52,0,52,'PRODUCTS'),(296,63,0,52,'category-full-width'),(297,119,0,52,'cloakroom-suites'),(298,120,0,52,'bathroom/bathroom-suites/cloakroom-suites'),(299,45,0,53,'Contemporary Suites'),(300,49,0,53,'Modern Contemporary Bathroom Suites Best Deals in UK - Banyo'),(301,52,0,53,'PRODUCTS'),(302,63,0,53,'category-full-width'),(303,119,0,53,'contemporary-suites'),(304,120,0,53,'bathroom/bathroom-suites/contemporary-suites'),(305,45,0,54,'Bathroom Mirrors'),(306,49,0,54,'Bathroom Mirrors & Cabinets Lowest Prices in UK - Banyo'),(307,52,0,54,'PRODUCTS'),(308,63,0,54,'category-full-width'),(309,119,0,54,'mirrors-cabinets'),(310,120,0,54,'bathroom/mirrors-cabinets'),(311,45,0,55,'Bathroom Mirrors'),(312,49,0,55,'Bathroom Mirrors - Bathroom Mirror Cabinets - Banyo'),(313,52,0,55,'PRODUCTS'),(314,63,0,55,'category-full-width'),(315,119,0,55,'mirrors'),(316,120,0,55,'bathroom/mirrors-cabinets/mirrors'),(317,45,0,56,'Disable - Mirror Cabinets'),(318,49,0,56,'Bathroom Mirror Cabinets - Bathroom Wall Cabinets'),(319,52,0,56,'PRODUCTS'),(320,63,0,56,'category-full-width'),(321,119,0,56,'mirror-cabinets'),(322,120,0,56,'bathroom/mirrors-cabinets/mirror-cabinets'),(323,45,0,57,'Disable - Frames & Plates'),(324,49,0,57,'Bathroom Frames & Plates Lowest Prices in UK - Banyo'),(325,52,0,57,'PRODUCTS'),(326,63,0,57,'category-full-width'),(327,119,0,57,'frames-plates'),(328,120,0,57,'bathroom/frames-plates'),(330,48,0,57,'/media/catalog/category/whirlpool-bath.png'),(331,60,0,57,NULL),(332,45,0,58,'Bidet Frames'),(333,49,0,58,'Bidet Frame UK - Wall Hung Bidet Frame Deals at Banyo'),(334,52,0,58,'PRODUCTS'),(335,63,0,58,'category-full-width'),(336,119,0,58,'bidet-frames'),(337,120,0,58,'bathroom/frames-plates/bidet-frames'),(338,45,0,59,'Toilet Frames'),(339,49,0,59,'Buy Wall Hung Toilet Frame at Lowest Prices in UK at Banyo'),(340,52,0,59,'PRODUCTS'),(341,63,0,59,'category-full-width'),(342,119,0,59,'toilet-frames'),(343,120,0,59,'bathroom/frames-plates/toilet-frames'),(344,45,0,60,'Basin Frames'),(345,49,0,60,'Basin Frames - Wall Hung Bathroom Basin Frames'),(346,52,0,60,'PRODUCTS'),(347,63,0,60,'category-full-width'),(348,119,0,60,'basin-frames'),(349,120,0,60,'bathroom/basins/accessories/basin-frames'),(350,45,0,61,'Plates'),(351,49,0,61,'Flush plates - Dual Flush Plate - Banyo UK'),(352,52,0,61,'PRODUCTS'),(353,63,0,61,'category-full-width'),(354,119,0,61,'plates'),(355,120,0,61,'bathroom/frames-plates/plates'),(356,45,0,62,'Disable - PVC Panels'),(357,49,0,62,'Buy PVC Shower Panels | #1 UK\'s Leading Supplier - Banyo'),(358,52,0,62,'PRODUCTS'),(359,63,0,62,'category-full-width'),(360,119,0,62,'pvc-panels'),(361,120,0,62,'bathroom/pvc-panels'),(362,45,0,63,'Ceiling Panels'),(363,49,0,63,'Waterproof Bathroom Ceiling Panels UK - Banyo'),(364,52,0,63,'PRODUCTS'),(365,63,0,63,'category-full-width'),(366,119,0,63,'ceiling-panels'),(367,120,0,63,'bathroom/pvc-panels/ceiling-panels'),(368,45,0,64,'Wall Splash Panels'),(369,49,0,64,'Bathroom Wall Splash Panels - Banyo  '),(370,52,0,64,'PRODUCTS'),(371,63,0,64,'category-full-width'),(372,119,0,64,'wall-splash-panels'),(373,120,0,64,'bathroom/pvc-panels/wall-splash-panels'),(374,45,0,65,'PVC Trims'),(375,49,0,65,'Shop Now Bathroom PVC Trims - Banyo'),(376,52,0,65,'PRODUCTS'),(377,63,0,65,'category-full-width'),(378,119,0,65,'pvc-trims'),(379,120,0,65,'bathroom/pvc-panels/pvc-trims'),(381,48,0,4,'/media/catalog/category/enclosures.jpeg'),(382,49,0,4,'Shower doors , shower cubicles and shower enclosures- banyo'),(383,60,0,4,NULL),(384,45,0,66,'Shower Doors'),(385,49,0,66,'Shower Door - Sliding Shower Door - Banyo'),(386,52,0,66,'PRODUCTS'),(387,63,0,66,'category-full-width'),(388,119,0,66,'shower-doors'),(389,120,0,66,'bathroom/showering/shower-doors'),(390,45,0,67,'Pivot Doors'),(391,49,0,67,'Pivot Shower Doors - shower doors - Banyo'),(392,52,0,67,'PRODUCTS'),(393,63,0,67,'category-full-width'),(394,119,0,67,'pivot-doors'),(395,120,0,67,'bathroom/showering/shower-doors/pivot-doors'),(396,45,0,68,'Disable - Hinged Doors'),(397,49,0,68,'Hinged Shower Doors | Hinged Shower Enclosures '),(398,52,0,68,'PRODUCTS'),(399,63,0,68,'category-full-width'),(400,119,0,68,'hinged-doors'),(401,120,0,68,'bathroom/showering/shower-doors/hinged-doors'),(402,45,0,69,'Sliding Doors'),(403,49,0,69,'Sliding Shower Doors - Banyo  Shower Enclosures '),(404,52,0,69,'PRODUCTS'),(405,63,0,69,'category-full-width'),(406,119,0,69,'sliding-doors'),(407,120,0,69,'bathroom/showering/shower-doors/sliding-doors'),(408,45,0,70,'Bi-Fold Doors'),(409,49,0,70,'Bifold Shower Doors Deals At Banyo'),(410,52,0,70,'PRODUCTS'),(411,63,0,70,'category-full-width'),(412,119,0,70,'bi-fold-doors'),(413,120,0,70,'bathroom/showering/shower-doors/bi-fold-doors'),(414,45,0,71,'Shower Enclosuress'),(415,49,0,71,'Shower Enclosure - Shower Cubicles & Doors | Shower Units - Banyo'),(416,52,0,71,'PRODUCTS'),(417,63,0,71,'category-full-width'),(418,119,0,71,'shower-enclosures'),(419,120,0,71,'bathroom/showering/shower-enclosures'),(420,45,0,72,'Disable - Pivot Enclosures'),(421,49,0,72,'Pivot Door Shower Enclosures - Banyo Bathrooms'),(422,52,0,72,'PRODUCTS'),(423,63,0,72,'category-full-width'),(424,119,0,72,'pivot-enclosures'),(425,120,0,72,'bathroom/showering/shower-enclosures/pivot-enclosures'),(426,45,0,73,'Disable - Hinged Enclosures'),(427,49,0,73,'Hinged Door Shower Enclosures - Banyo'),(428,52,0,73,'PRODUCTS'),(429,63,0,73,'category-full-width'),(430,119,0,73,'hinged-enclosures'),(431,120,0,73,'bathroom/showering/shower-enclosures/hinged-enclosures'),(432,45,0,74,'Disable - Sliding Enclosures'),(433,49,0,74,'Buy Shower Sliding Doors - Banyo Bathrooms'),(434,52,0,74,'PRODUCTS'),(435,63,0,74,'category-full-width'),(436,119,0,74,'sliding-enclosures'),(437,120,0,74,'bathroom/showering/shower-enclosures/sliding-enclosures'),(448,45,0,75,'Disable - Bi-Fold Enclosures'),(449,49,0,75,'Bi-Fold Enclosures Cheapest Deals at Banyo'),(450,52,0,75,'PRODUCTS'),(451,63,0,75,'category-full-width'),(452,119,0,75,'bi-fold-enclosures'),(453,120,0,75,'bathroom/showering/shower-enclosures/bi-fold-enclosures'),(454,45,0,76,'Disable - D-Shaped Enclosures'),(455,49,0,76,'D Shape Shower Enclosures | Premier D Shape Shower Enclosures UK | Shower Doors'),(456,52,0,76,'PRODUCTS'),(457,63,0,76,'category-full-width'),(458,119,0,76,'d-shaped-enclosures'),(459,120,0,76,'bathroom/showering/shower-enclosures/d-shaped-enclosures'),(460,45,0,77,'Disable - Walk-in Showers'),(461,49,0,77,'Walk In Shower Enclosures| Cheap Walk in Shower'),(462,52,0,77,'PRODUCTS'),(463,63,0,77,'category-full-width'),(464,119,0,77,'walk-in-showers'),(465,120,0,77,'bathroom/showering/shower-enclosures/walk-in-showers'),(466,45,0,78,'Quadrant Enclosures'),(467,49,0,78,'Quadrant Shower Enclosures | Shower Including Quadrant'),(468,52,0,78,'PRODUCTS'),(469,63,0,78,'category-full-width'),(470,119,0,78,'quadrant'),(471,120,0,78,'bathroom/showering/shower-enclosures/quadrant'),(472,45,0,79,'Pentagon Enclosures'),(473,49,0,79,'Pentagon Shower Enclosure | Cheap Shower Enclosure| Banyo'),(474,52,0,79,'PRODUCTS'),(475,63,0,79,'category-full-width'),(476,119,0,79,'pentagons'),(477,120,0,79,'bathroom/showering/shower-enclosures/pentagons'),(478,45,0,80,'Wetrooms'),(479,49,0,80,'Buy Wet Room Panels - Banyo.co.uk'),(480,52,0,80,'PRODUCTS'),(481,63,0,80,'category-full-width'),(482,119,0,80,'wet-rooms'),(483,120,0,80,'bathroom/showering/shower-enclosures/wet-rooms'),(484,45,0,81,'Corner Entry Enclosures'),(485,49,0,81,'Corner Shower Entry Enclosures | Buy Corner Entry Enclosures - Bnayo'),(486,52,0,81,'PRODUCTS'),(487,63,0,81,'category-full-width'),(488,119,0,81,'corner-entry-enclosures'),(489,120,0,81,'bathroom/showering/shower-enclosures/corner-entry-enclosures'),(490,45,0,82,'Shower Trays'),(491,49,0,82,'Bathroom Shower Trays & Floors in the UK -  Banyo'),(492,52,0,82,'PRODUCTS'),(493,63,0,82,'category-full-width'),(494,119,0,82,'shower-trays'),(495,120,0,82,'bathroom/showering/shower-trays'),(496,45,0,83,'Square Shower Tray'),(497,49,0,83,'Square Shower Trays - Bathroom Shower Enclosure Trays'),(498,52,0,83,'PRODUCTS'),(499,63,0,83,'category-full-width'),(500,119,0,83,'square-trays'),(501,120,0,83,'bathroom/showering/shower-trays/square-trays'),(502,45,0,84,'Rectangular Shower Trays'),(503,49,0,84,'Rectangular Shower Trays Best Deals in UK- Banyo'),(504,52,0,84,'PRODUCTS'),(505,63,0,84,'category-full-width'),(506,119,0,84,'rectangular-trays'),(507,120,0,84,'bathroom/showering/shower-trays/rectangular-trays'),(508,45,0,85,'Quadrant Shower Trays'),(509,49,0,85,'Quadrant Shower Trays - Quadrant Shower Enclosures'),(510,52,0,85,'PRODUCTS'),(511,63,0,85,'category-full-width'),(512,119,0,85,'quadrant-trays'),(513,120,0,85,'bathroom/showering/shower-trays/quadrant-trays'),(514,45,0,86,'Pentagon Shower Trays'),(515,49,0,86,'Pentagon Shower Trays - Enclosures Shower Trays Best Prices in UK'),(516,52,0,86,'PRODUCTS'),(517,63,0,86,'category-full-width'),(518,119,0,86,'pentagon-trays'),(519,120,0,86,'bathroom/showering/shower-trays/pentagon-trays'),(521,48,0,5,'kitchen-sink.jpeg'),(522,49,0,5,'Best Deals on Kitchen Appliances: Top Brands, Lowest Prices'),(523,60,0,5,NULL),(524,45,0,87,'Cooking & Baking'),(525,49,0,87,'Cooking & Baking Kitchen Appliances Best Deals in UK'),(526,52,0,87,'PRODUCTS'),(527,63,0,87,'category-full-width'),(528,119,0,87,'cooking-baking'),(529,120,0,87,'kitchen-appliances/appliances/cooking-baking'),(530,45,0,88,'Ovens'),(531,49,0,88,'Ovens - Great Deal on Ovens at Banyo Online Store'),(532,52,0,88,'PRODUCTS'),(533,63,0,88,'category-full-width'),(534,119,0,88,'ovens'),(535,120,0,88,'kitchen-appliances/appliances/cooking-baking/ovens'),(536,45,0,89,'Hobs'),(537,49,0,89,'Kitchen Hobs Best Deal UK – Buy Hobs Online'),(538,52,0,89,'PRODUCTS'),(539,63,0,89,'category-full-width'),(540,119,0,89,'hobs'),(541,120,0,89,'kitchen-appliances/appliances/cooking-baking/hobs'),(542,45,0,90,'Steam Appliances'),(543,49,0,90,'Steam Ovens | Neff Steam Ovens | Bosch Steam Ovens | Steam Oven UK'),(544,52,0,90,'PRODUCTS'),(545,63,0,90,'category-full-width'),(546,119,0,90,'steam-appliances'),(547,120,0,90,'kitchen-appliances/appliances/cooking-baking/steam-appliances'),(548,45,0,91,'Microwaves'),(549,49,0,91,'Microwaves Ovens - Bosch Built in Appliances | Neff Built in Appliances'),(550,52,0,91,'PRODUCTS'),(551,63,0,91,'category-full-width'),(552,119,0,91,'microwaves'),(553,120,0,91,'kitchen-appliances/appliances/cooking-baking/microwaves'),(554,45,0,92,'Coffee Machine'),(555,49,0,92,'Compact Coffee Machine | Neff | Siemens | Bosch'),(556,52,0,92,'PRODUCTS'),(557,63,0,92,'category-full-width'),(558,119,0,92,'coffee-machine'),(559,120,0,92,'kitchen-appliances/appliances/cooking-baking/coffee-machine'),(560,45,0,93,'Cooker Hoods'),(561,49,0,93,'Kitchen Cooker Hoods Best Deals - banyo.co.uk'),(562,52,0,93,'PRODUCTS'),(563,63,0,93,'category-full-width'),(564,119,0,93,'cooker-hoods'),(565,120,0,93,'kitchen-appliances/appliances/cooking-baking/cooker-hoods'),(566,45,0,94,'Warming Drawers'),(567,49,0,94,'Warming Drawers - Cheap Warming Drawer Deals at Banyo'),(568,52,0,94,'PRODUCTS'),(569,63,0,94,'category-full-width'),(570,119,0,94,'warming-drawers'),(571,120,0,94,'kitchen-appliances/appliances/cooking-baking/warming-drawers'),(572,45,0,95,'Cooking Accessories'),(573,49,0,95,'Appliances Accessories'),(574,52,0,95,'PRODUCTS'),(575,63,0,95,'category-full-width'),(576,119,0,95,'cooking-accessories'),(577,120,0,95,'kitchen-appliances/appliances/cooking-baking/cooking-accessories'),(578,45,0,96,'Washers & Dryers'),(579,49,0,96,'Washer Dryers | Neff Washer Dryers  | Bosch Washer Dryers | Banyo'),(580,52,0,96,'PRODUCTS'),(581,63,0,96,'category-full-width'),(582,119,0,96,'washers-dryers'),(583,120,0,96,'kitchen-appliances/appliances/washers-dryers'),(584,45,0,97,'Washing Machines'),(585,49,0,97,'Cheap Washing Machines Deals - Washing machines| Banyo'),(586,52,0,97,'PRODUCTS'),(587,63,0,97,'category-full-width'),(588,119,0,97,'washing-machines'),(589,120,0,97,'kitchen-appliances/appliances/washers-dryers/washing-machines'),(591,48,0,97,NULL),(592,60,0,97,NULL),(593,45,0,98,'Dishwashers'),(594,49,0,98,'Buy Dishwasher Online At Banyo UK'),(595,52,0,98,'PRODUCTS'),(596,63,0,98,'category-full-width'),(597,119,0,98,'dishwashers'),(598,120,0,98,'kitchen-appliances/appliances/dishwashers'),(599,45,0,99,'Built In Dishwashers'),(600,49,0,99,'Built In Dishwashers Online Sale at Banyo'),(601,52,0,99,'PRODUCTS'),(602,63,0,99,'category-full-width'),(603,119,0,99,'built-in-dishwashers'),(604,120,0,99,'kitchen-appliances/appliances/dishwashers/built-in-dishwashers'),(605,45,0,100,'Fridges & Freezers'),(606,49,0,100,'Fridge Freezers UK | Bosch Fridge Freezers | Neff Fridge Freezers'),(607,52,0,100,'PRODUCTS'),(608,63,0,100,'category-full-width'),(609,119,0,100,'fridges-freezers'),(610,120,0,100,'kitchen-appliances/appliances/fridges-freezers'),(611,45,0,101,'Fridges Freezers'),(612,49,0,101,'Buy Top Brands Fridge Freezers In UK'),(613,52,0,101,'PRODUCTS'),(614,63,0,101,'category-full-width'),(615,119,0,101,'fridges-freezers'),(616,120,0,101,'kitchen-appliances/appliances/fridges-freezers/fridges-freezers'),(617,45,0,102,'Fridges'),(618,49,0,102,'Great Deal on High Quality Fridges At Banyo UK'),(619,52,0,102,'PRODUCTS'),(620,63,0,102,'category-full-width'),(621,119,0,102,'fridges'),(622,120,0,102,'kitchen-appliances/appliances/fridges-freezers/fridges'),(623,45,0,103,'Freezers'),(624,49,0,103,'Freezer Deals in UK - Buy Best Freezer at Banyo'),(625,52,0,103,'PRODUCTS'),(626,63,0,103,'category-full-width'),(627,119,0,103,'freezers'),(628,120,0,103,'kitchen-appliances/appliances/fridges-freezers/freezers'),(629,45,0,104,'Wine Coolers'),(630,49,0,104,'Buy Stylish Wine Coolers Uk - Best Deal at Banyo'),(631,52,0,104,'PRODUCTS'),(632,63,0,104,'category-full-width'),(633,119,0,104,'wine-coolers'),(634,120,0,104,'kitchen-appliances/appliances/fridges-freezers/wine-coolers'),(635,45,0,105,'American Style '),(636,49,0,105,'American Style Fridge Freezers Best Deal At Banyo'),(637,52,0,105,'PRODUCTS'),(638,63,0,105,'category-full-width'),(639,119,0,105,'american-style-fridge-freezers'),(640,120,0,105,'kitchen-appliances/appliances/fridges-freezers/american-style-fridge-freezers'),(641,45,0,106,'Sink Type'),(642,49,0,106,NULL),(643,52,0,106,'PRODUCTS'),(644,63,0,106,'category-full-width'),(645,119,0,106,'sink-type'),(646,120,0,106,'kitchen-appliances/kitchen-sinks/sink-type'),(647,45,0,107,'Disable - Full Sinks'),(648,52,0,107,'PRODUCTS'),(649,63,0,107,'category-full-width'),(650,119,0,107,'full-sinks'),(651,120,0,107,'kitchen-appliances/kitchen-sinks/sink-type/full-sinks'),(652,45,0,108,'Stainless Steel Sinks'),(653,49,0,108,'Stainless Steel Sinks: The Perfect Inclusion to Your Home'),(654,52,0,108,'PRODUCTS'),(655,63,0,108,'category-full-width'),(656,119,0,108,'stainless-steel-sinks'),(657,120,0,108,'kitchen-appliances/kitchen-sinks/sink-material/stainless-steel-sinks'),(658,45,0,109,'Disable - Sink tap Packages'),(659,49,0,109,'Upgrade Your Kitchen: Stylish Sink & Tap Packs for Every Home'),(660,52,0,109,'PRODUCTS'),(661,63,0,109,'category-full-width'),(662,119,0,109,'sink-tap-packages'),(663,120,0,109,'kitchen-appliances/kitchen-sinks/sink-type/sink-tap-packages'),(664,45,0,110,'Accessories'),(665,49,0,110,'Find Incomparable Deals on Kitchen Accessories at Banyo'),(666,52,0,110,'PRODUCTS'),(667,63,0,110,'category-full-width'),(668,119,0,110,'kitchen-accessories'),(669,120,0,110,'kitchen-appliances/kitchen-sinks/accessories/kitchen-accessories'),(671,48,0,37,'/media/catalog/category/shower-bath.png'),(672,60,0,37,NULL),(696,48,0,6,'/media/catalog/category/fires.jpg'),(697,49,0,6,'Fires - Electric & Gas | Banyo Fireplaces'),(698,60,0,6,NULL),(699,45,0,111,'Gas Fires'),(700,49,0,111,'Gas Fires | Built in| Lowest Prices | Banyo '),(701,52,0,111,'PRODUCTS'),(702,63,0,111,'category-full-width'),(703,119,0,111,'gas-fires'),(704,120,0,111,'heating/fires/gas-fires'),(705,45,0,112,'Disable - Front View Gas Fires'),(706,49,0,112,' Front View Gas Fires: Contemporary & Traditional Fireplaces | Banyo'),(707,52,0,112,'PRODUCTS'),(708,63,0,112,'category-full-width'),(709,119,0,112,'front-view-gas-fires'),(710,120,0,112,'heating/fires/gas-fires/front-view-gas-fires'),(711,45,0,113,'Corner Gas Fires'),(712,49,0,113,'Dru Global, Lugo, Circo, Paco, Metro Corner Gas Fires – Banyo'),(713,52,0,113,'PRODUCTS'),(714,63,0,113,'category-full-width'),(715,119,0,113,'corner-gas-fires'),(716,120,0,113,'heating/fires/gas-fires/corner-gas-fires'),(717,45,0,114,'3 Sided Gas Fires'),(718,49,0,114,'Three Sided High Efficiency Gas Fires  with Glass Front | Banyo'),(719,52,0,114,'PRODUCTS'),(720,63,0,114,'category-full-width'),(721,119,0,114,'three-sided-gas-fires'),(722,120,0,114,'heating/fires/gas-fires/three-sided-gas-fires'),(723,45,0,115,'Tunnel Gas Fires'),(724,49,0,115,'Double Sided Gas Fires | Tunnel Gas fires | Banyo Fireplaces'),(725,52,0,115,'PRODUCTS'),(726,63,0,115,'category-full-width'),(727,119,0,115,'tunnel-gas-fires'),(728,120,0,115,'heating/fires/gas-fires/tunnel-gas-fires'),(729,45,0,116,'Disable - Gas Heaters'),(730,49,0,116,'Indoor Wall Mounted Gas Heaters for Home & Commercial use in UK'),(731,52,0,116,'PRODUCTS'),(732,63,0,116,'category-full-width'),(733,119,0,116,'heaters'),(734,120,0,116,'heating/fires/gas-fires/heaters'),(735,45,0,117,'Hole In The Wall Gas Fires'),(736,49,0,117,'Hole in the Wall Gas Fires | Modern Gas fires | Lowest online price deals'),(737,52,0,117,'PRODUCTS'),(738,63,0,117,'category-full-width'),(739,119,0,117,'hole-in-the-wall-gas-fires'),(740,120,0,117,'heating/fires/gas-fires/hole-in-the-wall-gas-fires'),(741,45,0,118,'High Efficiency Gas Fires'),(742,49,0,118,'High Efficiency Gas Fires | Price match promise | Banyo Fires'),(743,52,0,118,'PRODUCTS'),(744,63,0,118,'category-full-width'),(745,119,0,118,'high-efficiency-gas-fires'),(746,120,0,118,'heating/fires/gas-fires/high-efficiency-gas-fires'),(747,45,0,119,'Glass Fronted Gas Fires'),(748,49,0,119,'Glass Fronted Gas Fires | Banyo Fireplace'),(749,52,0,119,'PRODUCTS'),(750,63,0,119,'category-full-width'),(751,119,0,119,'glass-fronted-gas-fire'),(752,120,0,119,'heating/fires/gas-fires/glass-fronted-gas-fire'),(753,45,0,120,'Inset Gas Fires'),(754,49,0,120,'Inset Gas Fires | Energy Efficient Fires | Best deals'),(755,52,0,120,'PRODUCTS'),(756,63,0,120,'category-full-width'),(757,119,0,120,'inset-gas-fires'),(758,120,0,120,'heating/fires/gas-fires/inset-gas-fires'),(759,45,0,121,'Wall Mounted Gas Fires'),(760,49,0,121,'Wall Mounted Gas Fires - Wall Hung Gas Fires| Banyo Fireplace'),(761,52,0,121,'PRODUCTS'),(762,63,0,121,'category-full-width'),(763,119,0,121,'wall-mounted-gas-fires'),(764,120,0,121,'heating/fires/gas-fires/wall-mounted-gas-fires'),(765,45,0,122,'Disable - Balanced Flue Gas Fires'),(766,49,0,122,'Balanced Flue Gas Fires | Modern Fires | Built in Gas Fire deals'),(767,52,0,122,'PRODUCTS'),(768,63,0,122,'category-full-width'),(769,119,0,122,'balanced-flue-gas-fires'),(770,120,0,122,'heating/fires/gas-fires/balanced-flue-gas-fires'),(771,45,0,123,'Flueless Gas Fires'),(772,49,0,123,'Flueless Gas Fires - High Efficiency Fireplace | Banyo'),(773,52,0,123,'PRODUCTS'),(774,63,0,123,'category-full-width'),(775,119,0,123,'flueless-gas-fires'),(776,120,0,123,'heating/fires/gas-fires/flueless-gas-fires'),(777,45,0,124,'Stoves'),(778,49,0,124,'Multi Fuel Stoves | Wood Burning Stoves | Solid Fuel Stoves'),(779,52,0,124,'PRODUCTS'),(780,63,0,124,'category-full-width'),(781,119,0,124,'stoves'),(782,120,0,124,'heating/fires/stoves'),(783,45,0,125,'Wood & Multifuel Stoves'),(784,49,0,125,'Best Deals  Aga, Dru, Gazco, Dovre, Flavel wood Burning & multifuel stoves'),(785,52,0,125,'PRODUCTS'),(786,63,0,125,'category-full-width'),(787,119,0,125,'wood-multifuel-stoves'),(788,120,0,125,'heating/fires/stoves/wood-multifuel-stoves'),(789,45,0,126,'Electric Stoves'),(790,49,0,126,'Electric Stoves - Log burner Effect fires | Banyo'),(791,52,0,126,'PRODUCTS'),(792,63,0,126,'category-full-width'),(793,119,0,126,'electric-stoves'),(794,120,0,126,'heating/fires/stoves/electric-stoves'),(795,45,0,127,'Disable - Wood Burning Stoves'),(796,49,0,127,'Wood Burning Stoves - Log burners | Banyo'),(797,52,0,127,'PRODUCTS'),(798,63,0,127,'category-full-width'),(799,119,0,127,'wood-burning-stoves'),(800,120,0,127,'heating/fires/stoves/wood-burning-stoves'),(801,45,0,128,'Gas Stoves'),(802,49,0,128,'Traditional Gas Stoves | Modern Gas Stove | Double sided stove'),(803,52,0,128,'PRODUCTS'),(804,63,0,128,'category-full-width'),(805,119,0,128,'gas-stoves'),(806,120,0,128,'heating/fires/stoves/gas-stoves'),(807,45,0,129,'Electric Fires'),(808,49,0,129,'Electric Fires UK | Price Match Promise - Banyo'),(809,52,0,129,'PRODUCTS'),(810,63,0,129,'category-full-width'),(811,119,0,129,'electric-fires'),(812,120,0,129,'heating/fires/electric-fires'),(813,45,0,130,'Inset Electric Fires'),(814,49,0,130,'Inset Electric Fires | Extensive Range of Sizes & Styles | Banyo'),(815,52,0,130,'PRODUCTS'),(816,63,0,130,'category-full-width'),(817,119,0,130,'inset-electric-fires'),(818,120,0,130,'heating/fires/electric-fires/inset-electric-fires'),(825,45,0,132,'Wall Mounted Electric Fires'),(826,49,0,132,'Wall Mounted Electric Fires - Low Prices - Free delivery | Banyo'),(827,52,0,132,'PRODUCTS'),(828,63,0,132,'category-full-width'),(829,119,0,132,'wall-mounted-electric-fires'),(830,120,0,132,'heating/fires/electric-fires/wall-mounted-electric-fires'),(831,45,0,133,'Disable - Electric Fires and Surrounds'),(832,49,0,133,'Electric Fires & Surrounds - Electric Fire Suites | Low Prices | Banyo'),(833,52,0,133,'PRODUCTS'),(834,63,0,133,'category-full-width'),(835,119,0,133,'electric-fires-and-surrounds'),(836,120,0,133,'heating/fires/electric-fires/electric-fires-and-surrounds'),(837,45,0,134,'Disable - Fires Accessories'),(838,49,0,134,'Fires Accessories - Banyo'),(839,52,0,134,'PRODUCTS'),(840,63,0,134,'category-full-width'),(841,119,0,134,'fires-accessories'),(842,120,0,134,'heating/fires/fires-accessories'),(844,48,0,7,'designer-radiator.jpeg'),(845,49,0,7,'Bathroom Radiators | Heated Towel Rails | Banyo.co.uk'),(846,60,0,7,NULL),(847,45,0,135,'Designer Radiators'),(848,49,0,135,'Designer Radiators - Heated towel rails - Banyo'),(849,52,0,135,'PRODUCTS'),(850,63,0,135,'category-full-width'),(851,119,0,135,'designer-radiators'),(852,120,0,135,'heating/radiators/radiators/designer-radiators'),(853,45,0,136,'Vertical Designer Radiators'),(854,49,0,136,'Vertical Designer Radiators | Towel Heating Radiators | Modern Radiators'),(855,52,0,136,'PRODUCTS'),(856,63,0,136,'category-full-width'),(857,119,0,136,'vertical-designer-radiators'),(858,120,0,136,'heating/radiators/radiators/vertical-designer-radiators'),(859,45,0,137,'Horizontal Designer Radiators'),(860,49,0,137,'Horizontal Radiators | Horizontal Designer Radiators | Chrome Radiators'),(861,52,0,137,'PRODUCTS'),(862,63,0,137,'category-full-width'),(863,119,0,137,'horizontal-designer-radiators'),(864,120,0,137,'heating/radiators/radiators/horizontal-designer-radiators'),(865,45,0,138,'Disable - Traditional Radiators'),(866,49,0,138,'Traditional Radiators UK- Traditional Towel Rails - Banyo'),(867,52,0,138,'PRODUCTS'),(868,63,0,138,'category-full-width'),(869,119,0,138,'traditional-radiators'),(870,120,0,138,'heating/radiators/radiators/traditional-radiators'),(871,45,0,139,'Electric Radiators'),(872,49,0,139,'Electric Radiators | Towel Rail Radiator | Bathroom Radiators'),(873,52,0,139,'PRODUCTS'),(874,63,0,139,'category-full-width'),(875,119,0,139,'electric-radiators'),(876,120,0,139,'heating/radiators/radiators/electric-radiators'),(877,45,0,140,'Disable - Radiator Valves'),(878,49,0,140,'Thermostatic Radiator Valves Best Deals At Banyo'),(879,52,0,140,'PRODUCTS'),(880,63,0,140,'category-full-width'),(881,119,0,140,'radiator-valves'),(882,120,0,140,'heating/radiators/radiators/radiator-valves'),(883,45,0,141,'Disable - Heating Elements'),(884,49,0,141,'Heating Elements - Showe Heating Elements - Banyo'),(885,52,0,141,'PRODUCTS'),(886,63,0,141,'category-full-width'),(887,119,0,141,'heating-elements'),(888,120,0,141,'heating/radiators/radiators/heating-elements'),(889,45,0,142,'Towel Rails'),(890,49,0,142,'Towel Radiators | Designer Towel Rails | Heated Towel Rails'),(891,52,0,142,'PRODUCTS'),(892,63,0,142,'category-full-width'),(893,119,0,142,'towel-rails'),(894,120,0,142,'heating/radiators/towel-rails'),(895,45,0,143,'Heated Towel Rails'),(896,49,0,143,'Heated Towel Rails | Traditional Towel Rails | Electric Towel Rails'),(897,52,0,143,'PRODUCTS'),(898,63,0,143,'category-full-width'),(899,119,0,143,'heated-towel-rails'),(900,120,0,143,'heating/radiators/towel-rails/heated-towel-rails'),(901,45,0,144,'Electric Towel Rails'),(902,49,0,144,'Electric Towel Rails | Chrome Towel Rails | Towel Rail Radiator'),(903,52,0,144,'PRODUCTS'),(904,63,0,144,'category-full-width'),(905,119,0,144,'electric-towel-rails'),(906,120,0,144,'heating/radiators/towel-rails/electric-towel-rails'),(908,48,0,8,'taps.jpeg'),(909,49,0,8,'Discover the Ideal faucet for Your British Home with Taps UK!'),(910,60,0,8,NULL),(911,45,0,145,'Kitchen Taps'),(912,49,0,145,'Browse our wide selection of high-quality kitchen taps'),(913,52,0,145,'PRODUCTS'),(914,63,0,145,'category-full-width'),(915,119,0,145,'kitchen-taps'),(916,120,0,145,'kitchen-appliances/kitchen-taps'),(917,45,0,146,'Disable - Kitchen Sink Taps'),(918,49,0,146,'Stylize Your home with These Kitchen Sink Taps'),(919,52,0,146,'PRODUCTS'),(920,63,0,146,'category-full-width'),(921,119,0,146,'kitchen-sink-taps'),(922,120,0,146,'kitchen-appliances/kitchen-taps/kitchen-sink-taps'),(923,45,0,147,'Boiling Water Taps'),(924,49,0,147,'Save Time and Effort with Instant Hot Water Taps in Kitchen'),(925,52,0,147,'PRODUCTS'),(926,63,0,147,'category-full-width'),(927,119,0,147,'instant-hot-water-taps'),(928,120,0,147,'kitchen-appliances/kitchen-taps/kitchen-tap-type/instant-hot-water-taps'),(929,45,0,148,'Filter Water Taps'),(930,49,0,148,'Filter Tap: Reliable Source of Pure, Healthy Drinking Water'),(931,52,0,148,'PRODUCTS'),(932,63,0,148,'category-full-width'),(933,119,0,148,'filter-flow-taps'),(934,120,0,148,'kitchen-appliances/kitchen-taps/kitchen-tap-type/filter-flow-taps'),(935,45,0,149,'Disable - Sensor Taps'),(936,49,0,149,'Install sensor taps to cut down on water use in your kitchen'),(937,52,0,149,'PRODUCTS'),(938,63,0,149,'category-full-width'),(939,119,0,149,'sensor-taps'),(940,120,0,149,'kitchen-appliances/kitchen-taps/sensor-taps'),(941,45,0,150,'Disable - Bathroom Taps'),(942,49,0,150,'Bathroom Taps'),(943,52,0,150,'PRODUCTS'),(944,63,0,150,'category-full-width'),(945,119,0,150,'bathroom-taps'),(946,120,0,150,'bathroom/taps/bathroom-taps'),(947,45,0,151,'Bidet Taps'),(948,49,0,151,'Bidet Mixer taps Unbeatable Prices in UK'),(949,52,0,151,'PRODUCTS'),(950,63,0,151,'category-full-width'),(951,119,0,151,'bidet-mixers'),(952,120,0,151,'bathroom/taps/basin-taps/bidet-mixers'),(953,45,0,152,'Bath Taps'),(954,49,0,152,'Bathroom - Bath Taps - Mixer Taps Deals in UK'),(955,52,0,152,'PRODUCTS'),(956,63,0,152,'category-full-width'),(957,119,0,152,'bath-taps'),(958,120,0,152,'bathroom/taps/bath-taps'),(959,45,0,153,'Disable - Single Bath Taps'),(960,49,0,153,'Single Bath Taps - Bath Taps - Bathroom Taps - Taps'),(961,52,0,153,'PRODUCTS'),(962,63,0,153,'category-full-width'),(963,119,0,153,'single-bath-taps'),(964,120,0,153,'bathroom/taps/bath-taps/single-bath-taps'),(965,45,0,154,'Bath Mixer Taps'),(966,49,0,154,'Mixer Taps - Bath Taps - Bathroom Taps - Taps'),(967,52,0,154,'PRODUCTS'),(968,63,0,154,'category-full-width'),(969,119,0,154,'mixer-taps'),(970,120,0,154,'bathroom/taps/bath-taps/mixer-taps'),(972,48,0,154,NULL),(973,60,0,154,NULL),(974,45,0,155,'Wall Mounted Taps'),(975,49,0,155,'Wall Mounted Taps - Bath Taps - Bathroom Taps - Taps'),(976,52,0,155,'PRODUCTS'),(977,63,0,155,'category-full-width'),(978,119,0,155,'wall-hung-taps'),(979,120,0,155,'bathroom/taps/bath-taps/wall-hung-taps'),(980,45,0,156,'Disable --Free Standing Taps'),(981,49,0,156,'Free Standing Taps - Bath Taps - Bathroom Taps - Taps'),(982,52,0,156,'PRODUCTS'),(983,63,0,156,'category-full-width'),(984,119,0,156,'free-standing-taps'),(985,120,0,156,'bathroom/taps/bath-taps/free-standing-taps'),(986,45,0,157,'Disable - Bath Spouts'),(987,49,0,157,'Bath Spouts - Bath Taps - Bathroom Taps - Taps'),(988,52,0,157,'PRODUCTS'),(989,63,0,157,'category-full-width'),(990,119,0,157,'bath-spouts'),(991,120,0,157,'bathroom/taps/bath-taps/bath-spouts'),(992,45,0,158,'Bath Fillers'),(993,49,0,158,'Overflow Bath Fillers - Bath Fillers | Banyo'),(994,52,0,158,'PRODUCTS'),(995,63,0,158,'category-full-width'),(996,119,0,158,'bath-filler'),(997,120,0,158,'bathroom/taps/bath-taps/bath-filler'),(998,45,0,159,'Basin Taps'),(999,49,0,159,'Basin Taps - Taps Sales At Banyo'),(1000,52,0,159,'PRODUCTS'),(1001,63,0,159,'category-full-width'),(1002,119,0,159,'basin-taps'),(1003,120,0,159,'bathroom/taps/basin-taps'),(1004,45,0,160,'Basin Mixer Taps'),(1005,49,0,160,'Basin Mixer Taps - Basin Taps - Bathroom Taps - Taps'),(1006,52,0,160,'PRODUCTS'),(1007,63,0,160,'category-full-width'),(1008,119,0,160,'basin-mixer-taps'),(1009,120,0,160,'bathroom/taps/basin-taps/basin-mixer-taps'),(1010,45,0,161,'Wall Mounted Taps'),(1011,49,0,161,'Wall Mounted Taps in UK'),(1012,52,0,161,'PRODUCTS'),(1013,63,0,161,'category-full-width'),(1014,119,0,161,'wall-hung-tap'),(1015,120,0,161,'bathroom/taps/basin-taps/wall-hung-tap'),(1016,45,0,162,'Sensor Taps'),(1017,49,0,162,'Sensor Taps Deals in UK'),(1018,52,0,162,'PRODUCTS'),(1019,63,0,162,'category-full-width'),(1020,119,0,162,'sensor-tap'),(1021,120,0,162,'bathroom/taps/basin-taps/sensor-tap'),(1023,48,0,9,'showers.jpeg'),(1024,49,0,9,'Showers & Taps  Deals at Banyo- Banyo'),(1025,60,0,9,NULL),(1026,45,0,163,'decor product'),(1027,52,0,163,'PRODUCTS'),(1028,63,0,163,'category-full-width'),(1029,119,0,163,'decor-product'),(1030,120,0,163,'decor-product'),(1032,48,0,163,NULL),(1033,49,0,163,NULL),(1034,60,0,163,NULL),(1036,45,0,164,'comfort Product'),(1037,52,0,164,'PRODUCTS'),(1038,63,0,164,'category-full-width'),(1039,119,0,164,'comfort-product'),(1040,120,0,164,'comfort-product'),(1046,48,0,16,NULL),(1047,60,0,16,NULL),(1049,48,0,17,NULL),(1050,60,0,17,NULL),(1052,48,0,18,NULL),(1053,60,0,18,NULL),(1063,48,0,10,'/media/catalog/category/bathroom-accesories.jpeg'),(1064,49,0,10,'Bathroom Light'),(1065,60,0,10,NULL),(1067,48,0,11,'/media/catalog/category/kitchen1_1.png'),(1068,49,0,11,NULL),(1069,60,0,11,NULL),(1071,48,0,12,'kitchen-sink_1.jpeg'),(1072,49,0,12,NULL),(1073,60,0,12,NULL),(1081,48,0,164,NULL),(1082,49,0,164,NULL),(1083,60,0,164,NULL),(1107,48,0,25,'counter-top_1.png'),(1108,60,0,25,NULL),(1111,48,0,46,'/media/catalog/category/straight-bath_1.png'),(1112,60,0,46,NULL),(1114,48,0,51,'/media/catalog/category/counter-top_1_1.png'),(1115,60,0,51,NULL),(1117,48,0,54,'/media/catalog/category/straight-bath_2.png'),(1118,60,0,54,NULL),(1121,48,0,62,'/media/catalog/category/counter-top_1_2.png'),(1122,60,0,62,NULL),(1153,48,0,21,NULL),(1154,60,0,21,NULL),(1157,48,0,22,NULL),(1158,60,0,22,NULL),(1160,48,0,23,NULL),(1161,60,0,23,NULL),(1165,48,0,24,NULL),(1166,60,0,24,NULL),(1178,48,0,26,NULL),(1179,60,0,26,NULL),(1186,48,0,27,NULL),(1187,60,0,27,NULL),(1193,48,0,28,NULL),(1194,60,0,28,NULL),(1198,48,0,29,NULL),(1199,60,0,29,NULL),(1202,48,0,30,NULL),(1203,60,0,30,NULL),(1205,48,0,31,NULL),(1206,60,0,31,NULL),(1208,48,0,2,NULL),(1209,49,0,2,NULL),(1210,60,0,2,NULL),(1211,63,0,2,NULL),(1212,119,0,2,'default-category'),(1213,120,0,2,NULL),(1222,48,0,32,NULL),(1223,60,0,32,NULL),(1229,48,0,33,NULL),(1230,60,0,33,NULL),(1236,48,0,34,NULL),(1237,60,0,34,NULL),(1240,48,0,35,NULL),(1241,60,0,35,NULL),(1245,48,0,36,NULL),(1246,60,0,36,NULL),(1281,48,0,38,'/media/catalog/category/bathroom-menu_1.jpeg'),(1282,60,0,38,NULL),(1304,48,0,39,NULL),(1305,60,0,39,NULL),(1309,48,0,40,NULL),(1310,60,0,40,NULL),(1312,48,0,41,NULL),(1313,60,0,41,NULL),(1315,48,0,42,NULL),(1316,60,0,42,NULL),(1321,48,0,43,NULL),(1322,60,0,43,NULL),(1324,48,0,44,NULL),(1325,60,0,44,NULL),(1330,48,0,45,NULL),(1331,60,0,45,NULL),(1340,48,0,47,NULL),(1341,60,0,47,NULL),(1343,48,0,48,NULL),(1344,60,0,48,NULL),(1348,48,0,49,NULL),(1349,60,0,49,NULL),(1351,48,0,50,NULL),(1352,60,0,50,NULL),(1355,48,0,52,NULL),(1356,60,0,52,NULL),(1358,48,0,53,NULL),(1359,60,0,53,NULL),(1362,48,0,58,NULL),(1363,60,0,58,NULL),(1365,48,0,59,NULL),(1366,60,0,59,NULL),(1368,48,0,60,NULL),(1369,60,0,60,NULL),(1371,48,0,61,NULL),(1372,60,0,61,NULL),(1396,48,0,55,NULL),(1397,60,0,55,NULL),(1405,48,0,56,NULL),(1406,60,0,56,NULL),(1416,48,0,71,NULL),(1417,60,0,71,NULL),(1419,48,0,72,NULL),(1420,60,0,72,NULL),(1422,48,0,73,NULL),(1423,60,0,73,NULL),(1425,48,0,74,NULL),(1426,60,0,74,NULL),(1428,48,0,75,NULL),(1429,60,0,75,NULL),(1431,48,0,76,NULL),(1432,60,0,76,NULL),(1434,48,0,77,NULL),(1435,60,0,77,NULL),(1437,48,0,78,NULL),(1438,60,0,78,NULL),(1441,48,0,79,NULL),(1442,60,0,79,NULL),(1444,48,0,80,NULL),(1445,60,0,80,NULL),(1450,48,0,81,NULL),(1451,60,0,81,NULL),(1454,48,0,83,NULL),(1455,60,0,83,NULL),(1459,48,0,84,NULL),(1460,60,0,84,NULL),(1462,48,0,85,NULL),(1463,60,0,85,NULL),(1465,48,0,86,NULL),(1466,60,0,86,NULL),(1469,48,0,67,NULL),(1470,60,0,67,NULL),(1472,48,0,68,NULL),(1473,60,0,68,NULL),(1476,48,0,69,NULL),(1477,60,0,69,NULL),(1481,48,0,70,NULL),(1482,60,0,70,NULL),(1506,48,0,87,NULL),(1507,60,0,87,NULL),(1510,48,0,88,NULL),(1511,60,0,88,NULL),(1516,48,0,89,NULL),(1517,60,0,89,NULL),(1528,48,0,90,NULL),(1529,60,0,90,NULL),(1531,48,0,91,NULL),(1532,60,0,91,NULL),(1535,48,0,92,NULL),(1536,60,0,92,NULL),(1538,48,0,94,NULL),(1539,60,0,94,NULL),(1542,48,0,95,NULL),(1543,60,0,95,NULL),(1554,48,0,93,NULL),(1555,60,0,93,NULL),(1573,48,0,96,NULL),(1574,60,0,96,NULL),(1578,48,0,98,NULL),(1579,60,0,98,NULL),(1581,48,0,99,NULL),(1582,60,0,99,NULL),(1585,48,0,100,NULL),(1586,60,0,100,NULL),(1591,48,0,101,NULL),(1592,60,0,101,NULL),(1596,48,0,102,NULL),(1597,60,0,102,NULL),(1600,48,0,103,NULL),(1601,60,0,103,NULL),(1603,48,0,104,NULL),(1604,60,0,104,NULL),(1606,48,0,105,NULL),(1607,60,0,105,NULL),(1609,48,0,106,NULL),(1610,60,0,106,NULL),(1617,48,0,110,NULL),(1618,60,0,110,NULL),(1624,48,0,108,NULL),(1625,60,0,108,NULL),(1638,48,0,107,NULL),(1639,49,0,107,NULL),(1640,60,0,107,NULL),(1688,48,0,111,NULL),(1689,60,0,111,NULL),(1710,48,0,112,NULL),(1711,60,0,112,NULL),(1721,48,0,113,NULL),(1722,60,0,113,NULL),(1724,48,0,114,NULL),(1725,60,0,114,NULL),(1728,48,0,115,NULL),(1729,60,0,115,NULL),(1731,48,0,116,NULL),(1732,60,0,116,NULL),(1734,48,0,117,NULL),(1735,60,0,117,NULL),(1743,48,0,118,NULL),(1744,60,0,118,NULL),(1755,48,0,123,NULL),(1756,60,0,123,NULL),(1758,48,0,121,NULL),(1759,60,0,121,NULL),(1762,48,0,122,NULL),(1763,60,0,122,NULL),(1769,48,0,120,NULL),(1770,60,0,120,NULL),(1776,48,0,119,NULL),(1777,60,0,119,NULL),(1793,48,0,124,NULL),(1794,60,0,124,NULL),(1810,48,0,125,NULL),(1811,60,0,125,NULL),(1820,48,0,126,NULL),(1821,60,0,126,NULL),(1825,48,0,127,NULL),(1826,60,0,127,NULL),(1833,48,0,128,NULL),(1834,60,0,128,NULL),(1836,48,0,129,NULL),(1837,60,0,129,NULL),(1852,48,0,130,NULL),(1853,60,0,130,NULL),(1861,48,0,132,NULL),(1862,60,0,132,NULL),(1866,48,0,133,NULL),(1867,60,0,133,NULL),(1869,48,0,134,NULL),(1870,60,0,134,NULL),(1882,48,0,135,NULL),(1883,60,0,135,NULL),(1889,48,0,140,NULL),(1890,60,0,140,NULL),(1892,48,0,141,NULL),(1893,60,0,141,NULL),(1895,48,0,139,NULL),(1896,60,0,139,NULL),(1898,48,0,138,NULL),(1899,60,0,138,NULL),(1901,48,0,137,NULL),(1902,60,0,137,NULL),(1908,48,0,142,NULL),(1909,60,0,142,NULL),(1912,48,0,143,NULL),(1913,60,0,143,NULL),(1925,48,0,144,NULL),(1926,60,0,144,NULL),(1928,48,0,136,NULL),(1929,60,0,136,NULL),(1957,48,0,145,NULL),(1958,60,0,145,NULL),(1967,48,0,146,NULL),(1968,60,0,146,NULL),(1984,48,0,147,NULL),(1985,60,0,147,NULL),(1987,48,0,149,NULL),(1988,60,0,149,NULL),(1991,48,0,151,NULL),(1992,60,0,151,NULL),(1996,48,0,152,NULL),(1997,60,0,152,NULL),(1999,48,0,153,NULL),(2000,60,0,153,NULL),(2010,48,0,155,NULL),(2011,60,0,155,NULL),(2016,48,0,156,NULL),(2017,60,0,156,NULL),(2019,48,0,157,NULL),(2020,60,0,157,NULL),(2023,48,0,158,NULL),(2024,60,0,158,NULL),(2027,48,0,159,NULL),(2028,60,0,159,NULL),(2031,48,0,162,NULL),(2032,60,0,162,NULL),(2034,48,0,161,NULL),(2035,60,0,161,NULL),(2040,48,0,160,NULL),(2041,60,0,160,NULL),(2058,48,0,150,NULL),(2059,60,0,150,NULL),(2060,45,0,165,'Showers'),(2061,49,0,165,'All Showers | Electric Showers | Thermostatic Shower from £90 | Banyo '),(2062,52,0,165,'PRODUCTS'),(2063,63,0,165,'category-full-width'),(2064,119,0,165,'all-showers'),(2065,120,0,165,'bathroom/shower-valves/all-showers'),(2066,45,0,166,'Full Showers'),(2067,49,0,166,'Complete Showers in UK'),(2068,52,0,166,'PRODUCTS'),(2069,63,0,166,'category-full-width'),(2070,119,0,166,'full-showers'),(2071,120,0,166,'bathroom/shower-valves/all-showers/full-showers'),(2073,48,0,166,NULL),(2074,60,0,166,NULL),(2076,45,0,167,'Shower Panels'),(2077,49,0,167,'Shower Panels |Hansgrohe | Premier | Hudson Reed - Banyo'),(2078,52,0,167,'PRODUCTS'),(2079,63,0,167,'category-full-width'),(2080,119,0,167,'shower-panels'),(2081,120,0,167,'bathroom/shower-valves/all-showers/shower-panels'),(2082,45,0,168,'Disable - Electric Showers'),(2083,49,0,168,'Electric Showers - Banyo.co.uk'),(2084,52,0,168,'PRODUCTS'),(2085,63,0,168,'category-full-width'),(2086,119,0,168,'electric-showers'),(2087,120,0,168,'bathroom/shower-valves/all-showers/electric-showers'),(2088,45,0,169,'Accessories'),(2089,49,0,169,NULL),(2090,52,0,169,'PRODUCTS'),(2091,63,0,169,'category-full-width'),(2092,119,0,169,'accessories'),(2093,120,0,169,'bathroom/shower-valves/accessories'),(2094,45,0,170,'Valves'),(2095,49,0,170,'Shower Valves | Shower Mixer Valve - Banyo.co.uk'),(2096,52,0,170,'PRODUCTS'),(2097,63,0,170,'category-full-width'),(2098,119,0,170,'valves'),(2099,120,0,170,'bathroom/shower-valves/valves'),(2102,48,0,165,NULL),(2103,60,0,165,NULL),(2105,45,0,171,'Exposed Valves'),(2106,49,0,171,'Exposed Valves - Valves - Shower Accessories - Showers'),(2107,52,0,171,'PRODUCTS'),(2108,63,0,171,'category-full-width'),(2109,119,0,171,'exposed-valves'),(2110,120,0,171,'bathroom/shower-valves/valves/exposed-valves'),(2111,45,0,172,'Concealed Valves'),(2112,49,0,172,'Concealed Valves - Valves - Shower Accessories - Showers'),(2113,52,0,172,'PRODUCTS'),(2114,63,0,172,'category-full-width'),(2115,119,0,172,'concealed-valves'),(2116,120,0,172,'bathroom/shower-valves/valves/concealed-valves'),(2118,45,0,173,'Disable - Thermostatic Valves'),(2119,49,0,173,'Thermostatic Valves - Valves - Shower Accessories - Showers'),(2120,52,0,173,'PRODUCTS'),(2121,63,0,173,'category-full-width'),(2122,119,0,173,'thermostatic-valves'),(2123,120,0,173,'bathroom/shower-valves/valves/thermostatic-valves'),(2125,45,0,174,'Disable - Traditional Valves'),(2126,49,0,174,'Traditional Valves - Valves - Shower Accessories - Showers'),(2127,52,0,174,'PRODUCTS'),(2128,63,0,174,'category-full-width'),(2129,119,0,174,'traditional-valves'),(2130,120,0,174,'bathroom/shower-valves/valves/traditional-valves'),(2132,48,0,167,NULL),(2133,60,0,167,NULL),(2134,45,0,175,'Disable - Hand Showers'),(2135,49,0,175,'Hand Showers Cheapest Deals At Banyo'),(2136,52,0,175,'PRODUCTS'),(2137,63,0,175,'category-full-width'),(2138,119,0,175,'hand-showers'),(2139,120,0,175,'bathroom/shower-valves/accessories/hand-showers'),(2140,45,0,176,'Slider Kits'),(2141,49,0,176,'Shower Rail Kits | Shower Riser Rail Kits | Banyo'),(2142,52,0,176,'PRODUCTS'),(2143,63,0,176,'category-full-width'),(2144,119,0,176,'slider-kits'),(2145,120,0,176,'bathroom/shower-valves/all-showers/slider-kits'),(2147,48,0,169,NULL),(2148,60,0,169,NULL),(2149,45,0,177,'Shower Heads'),(2150,49,0,177,'Shower Heads | Round, Square Shower Heads - from £29 '),(2151,52,0,177,'PRODUCTS'),(2152,63,0,177,'category-full-width'),(2153,119,0,177,'shower-heads'),(2154,120,0,177,'bathroom/shower-valves/accessories/shower-heads'),(2156,48,0,175,NULL),(2157,60,0,175,NULL),(2158,45,0,178,'Shower Arms'),(2159,49,0,178,'Shower Arms Deals | Chrome Shower Arm from £21'),(2160,52,0,178,'PRODUCTS'),(2161,63,0,178,'category-full-width'),(2162,119,0,178,'shower-arms'),(2163,120,0,178,'bathroom/shower-valves/accessories/shower-arms'),(2165,45,0,179,'Body Jets'),(2166,49,0,179,'Body Jets | Shower Body jets | Best Deals - Banyo'),(2167,52,0,179,'PRODUCTS'),(2168,63,0,179,'category-full-width'),(2169,119,0,179,'body-jets'),(2170,120,0,179,'bathroom/shower-valves/accessories/body-jets'),(2174,48,0,176,NULL),(2175,60,0,176,NULL),(2180,48,0,177,NULL),(2181,60,0,177,NULL),(2182,45,0,180,'Shower Hose'),(2183,49,0,180,'Shower Hose - Accessories'),(2184,52,0,180,'PRODUCTS'),(2185,63,0,180,'category-full-width'),(2186,119,0,180,'shower-hose'),(2187,120,0,180,'bathroom/shower-valves/accessories/shower-hose'),(2189,45,0,181,'Disable - Accessories'),(2190,49,0,181,'Accessories and Wastes - Banyo'),(2191,52,0,181,'PRODUCTS'),(2192,63,0,181,'category-full-width'),(2193,119,0,181,'accessories'),(2194,120,0,181,'bathroom/shower-valves/accessories/accessories'),(2199,48,0,178,NULL),(2200,60,0,178,NULL),(2202,48,0,179,NULL),(2203,60,0,179,NULL),(2205,48,0,180,NULL),(2206,60,0,180,NULL),(2208,48,0,181,NULL),(2209,60,0,181,NULL),(2212,48,0,171,NULL),(2213,60,0,171,NULL),(2216,48,0,172,NULL),(2217,60,0,172,NULL),(2221,48,0,173,NULL),(2222,60,0,173,NULL),(2224,48,0,174,NULL),(2225,60,0,174,NULL),(2232,45,0,182,'Bath Accessories'),(2233,49,0,182,'Bathroom Accessories - Bathroom Suites - Banyo'),(2234,52,0,182,'PRODUCTS'),(2235,63,0,182,'category-full-width'),(2236,119,0,182,'bathroom-accessories'),(2237,120,0,182,'bathroom/baths/bathroom-accessories'),(2238,45,0,183,'Disable - Towel Rings'),(2239,49,0,183,'Towel Rings'),(2240,52,0,183,'PRODUCTS'),(2241,63,0,183,'category-full-width'),(2242,119,0,183,'towel-rings'),(2243,120,0,183,'bathroom/baths/bathroom-accessories/towel-rings'),(2244,45,0,184,'Disable - Bathroom Fans'),(2245,49,0,184,'Bathroom Extractor Fans - Bathroom Fans Best Deals at Banyo '),(2246,52,0,184,'PRODUCTS'),(2247,63,0,184,'category-full-width'),(2248,119,0,184,'bathroom-fans'),(2249,120,0,184,'bathroom/baths/bathroom-accessories/bathroom-fans'),(2250,45,0,185,'Disable - Robe Hooks'),(2251,49,0,185,'Robe Hooks - Bathroom Accessories - Accessories'),(2252,52,0,185,'PRODUCTS'),(2253,63,0,185,'category-full-width'),(2254,119,0,185,'robe-hooks'),(2255,120,0,185,'bathroom/baths/bathroom-accessories/robe-hooks'),(2259,48,0,182,NULL),(2260,60,0,182,NULL),(2262,48,0,183,NULL),(2263,60,0,183,NULL),(2265,48,0,184,NULL),(2266,60,0,184,NULL),(2268,45,0,186,'Disable - Wire Baskets'),(2269,49,0,186,'Wire Baskets - Bathroom Accessories - Accessories'),(2270,52,0,186,'PRODUCTS'),(2271,63,0,186,'category-full-width'),(2272,119,0,186,'wire-baskets'),(2273,120,0,186,'bathroom/baths/bathroom-accessories/wire-baskets'),(2275,48,0,185,NULL),(2276,60,0,185,NULL),(2277,45,0,187,'Toilet Roll Holders'),(2278,49,0,187,'Toilet Roll Holders - Bathroom Accessories - Accessories'),(2279,52,0,187,'PRODUCTS'),(2280,63,0,187,'category-full-width'),(2281,119,0,187,'toilet-roll-holders'),(2282,120,0,187,'bathroom/toilet/toilet-accessories/toilet-roll-holders'),(2284,48,0,186,NULL),(2285,60,0,186,NULL),(2286,45,0,188,'Disable - Shelves'),(2287,49,0,188,'Shelves - Bathroom Accessories - Accessories'),(2288,52,0,188,'PRODUCTS'),(2289,63,0,188,'category-full-width'),(2290,119,0,188,'shelves'),(2291,120,0,188,'bathroom/baths/bathroom-accessories/shelves'),(2292,45,0,189,'Disable - Urinal Accessories'),(2293,49,0,189,'Urinal Accessories - Bathroom Accessories - Accessories'),(2294,52,0,189,'PRODUCTS'),(2295,63,0,189,'category-full-width'),(2296,119,0,189,'urinal-accessories'),(2297,120,0,189,'bathroom/baths/bathroom-accessories/urinal-accessories'),(2298,45,0,190,'Soap Dishes'),(2299,49,0,190,'Soap Dishes - Bathroom Accessories - Accessories'),(2300,52,0,190,'PRODUCTS'),(2301,63,0,190,'category-full-width'),(2302,119,0,190,'soap-dishes'),(2303,120,0,190,'bathroom/basins/accessories/soap-dishes'),(2304,45,0,191,'Lights'),(2305,49,0,191,'LED Lights for Shower & Accessories'),(2306,52,0,191,'PRODUCTS'),(2307,63,0,191,'category-full-width'),(2308,119,0,191,'lights'),(2309,120,0,191,'accessories/lights'),(2310,45,0,192,'Mirror Lights'),(2311,49,0,192,'Bathroom Mirror Lights - Banyo'),(2312,52,0,192,'PRODUCTS'),(2313,63,0,192,'category-full-width'),(2314,119,0,192,'mirror-lights'),(2315,120,0,192,'accessories/lights/mirror-lights'),(2316,45,0,193,' Ceiling Lights'),(2317,49,0,193,'Ceiling Lights - Banyo'),(2318,52,0,193,'PRODUCTS'),(2319,63,0,193,'category-full-width'),(2320,119,0,193,'ceiling-lights'),(2321,120,0,193,'accessories/lights/ceiling-lights'),(2322,45,0,194,'Kitchen Accessories'),(2323,49,0,194,'Kitchen Accessories - Bosch, Neff, Siemens & More | Banyo'),(2324,52,0,194,'PRODUCTS'),(2325,63,0,194,'category-full-width'),(2326,119,0,194,'kitchen-accessories'),(2327,120,0,194,'accessories/kitchen-accessories'),(2328,45,0,195,'Bosch Accessories'),(2329,49,0,195,'Bosch Accessories - Banyo'),(2330,52,0,195,'PRODUCTS'),(2331,63,0,195,'category-full-width'),(2332,119,0,195,'bosch-accessories'),(2333,120,0,195,'accessories/kitchen-accessories/bosch-accessories'),(2334,45,0,196,'Siemens Accessories'),(2335,49,0,196,'Siemens Accessories - Kitchen Accessories'),(2336,52,0,196,'PRODUCTS'),(2337,63,0,196,'category-full-width'),(2338,119,0,196,'siemens-accessories'),(2339,120,0,196,'accessories/kitchen-accessories/siemens-accessories'),(2341,48,0,187,NULL),(2342,60,0,187,NULL),(2343,45,0,197,'Neff Accessories'),(2344,49,0,197,'Neff Accessories - Kitchen Accessories'),(2345,52,0,197,'PRODUCTS'),(2346,63,0,197,'category-full-width'),(2347,119,0,197,'neff-accessories'),(2348,120,0,197,'accessories/kitchen-accessories/neff-accessories'),(2350,48,0,189,NULL),(2351,60,0,189,NULL),(2353,48,0,190,NULL),(2354,60,0,190,NULL),(2356,48,0,188,NULL),(2357,60,0,188,NULL),(2359,48,0,191,NULL),(2360,60,0,191,NULL),(2362,48,0,192,NULL),(2363,60,0,192,NULL),(2365,48,0,193,NULL),(2366,60,0,193,NULL),(2368,48,0,194,NULL),(2369,60,0,194,NULL),(2374,48,0,195,NULL),(2375,60,0,195,NULL),(2377,48,0,196,NULL),(2378,60,0,196,NULL),(2380,48,0,197,NULL),(2381,60,0,197,NULL),(2391,48,0,20,NULL),(2392,60,0,20,NULL),(2397,45,0,198,'Comfort Height Toilets'),(2398,52,0,198,'PRODUCTS'),(2399,63,0,198,'category-full-width'),(2400,119,0,198,'comfort-height-toilets'),(2401,120,0,198,'bathroom/toilet/toilets/comfort-height-toilets'),(2402,45,0,199,'Rimless Toilets'),(2403,52,0,199,'PRODUCTS'),(2404,63,0,199,'category-full-width'),(2405,119,0,199,'rimless-toilets'),(2406,120,0,199,'bathroom/toilet/toilets/rimless-toilets'),(2408,48,0,199,NULL),(2409,49,0,199,NULL),(2410,60,0,199,NULL),(2411,45,0,200,'WC Unit'),(2412,52,0,200,'PRODUCTS'),(2413,63,0,200,'category-full-width'),(2414,119,0,200,'wc-unit'),(2415,120,0,200,'bathroom/toilet/toilets/wc-unit'),(2416,45,0,201,'Smart Toilets'),(2417,52,0,201,'PRODUCTS'),(2418,63,0,201,'category-full-width'),(2419,119,0,201,'smart-toilets'),(2420,120,0,201,'bathroom/toilet/toilets/smart-toilets'),(2421,45,0,202,'Doc M Packs'),(2422,52,0,202,'PRODUCTS'),(2423,63,0,202,'category-full-width'),(2424,119,0,202,'doc-m-packs'),(2425,120,0,202,'bathroom/toilet/toilets/doc-m-packs'),(2426,45,0,203,'Toilet Accessories'),(2427,52,0,203,'PRODUCTS'),(2428,63,0,203,'category-full-width'),(2429,119,0,203,'toilet-accessories'),(2430,120,0,203,'bathroom/toilet/toilet-accessories'),(2433,45,0,204,'Douche / Shattafs'),(2434,52,0,204,'PRODUCTS'),(2435,63,0,204,'category-full-width'),(2436,119,0,204,'douche-shattafs'),(2437,120,0,204,'bathroom/toilet/toilet-accessories/douche-shattafs'),(2438,45,0,205,'Flush Buttons & Plates'),(2439,52,0,205,'PRODUCTS'),(2440,63,0,205,'category-full-width'),(2441,119,0,205,'flush-buttons-plates'),(2442,120,0,205,'bathroom/toilet/toilet-accessories/flush-buttons-plates'),(2458,45,0,208,'Toilet Brush and Holders'),(2459,52,0,208,'PRODUCTS'),(2460,63,0,208,'category-full-width'),(2461,119,0,208,'toilet-brush-and-holders'),(2462,120,0,208,'bathroom/toilet/toilet-accessories/toilet-brush-and-holders'),(2482,45,0,209,'Brands'),(2483,52,0,209,'PRODUCTS'),(2484,63,0,209,'category-full-width'),(2485,119,0,209,'brands'),(2486,120,0,209,'bathroom/toilet/brands'),(2489,45,0,210,'Rak'),(2490,52,0,210,'PRODUCTS'),(2491,63,0,210,'category-full-width'),(2492,119,0,210,'rak'),(2493,120,0,210,'bathroom/toilet/brands/rak'),(2494,45,0,211,'Geberit'),(2495,52,0,211,'PRODUCTS'),(2496,63,0,211,'category-full-width'),(2497,119,0,211,'geberit'),(2498,120,0,211,'bathroom/toilet/brands/geberit'),(2499,45,0,212,'Grohe'),(2500,52,0,212,'PRODUCTS'),(2501,63,0,212,'category-full-width'),(2502,119,0,212,'grohe'),(2503,120,0,212,'bathroom/toilet/brands/grohe'),(2504,45,0,213,'Hudson Reed'),(2505,52,0,213,'PRODUCTS'),(2506,63,0,213,'category-full-width'),(2507,119,0,213,'hudson-reed'),(2508,120,0,213,'bathroom/toilet/brands/hudson-reed'),(2509,45,0,214,'Roca'),(2510,52,0,214,'PRODUCTS'),(2511,63,0,214,'category-full-width'),(2512,119,0,214,'roca'),(2513,120,0,214,'bathroom/toilet/brands/roca'),(2514,45,0,215,'Vitra'),(2515,52,0,215,'PRODUCTS'),(2516,63,0,215,'category-full-width'),(2517,119,0,215,'vitra'),(2518,120,0,215,'bathroom/toilet/brands/vitra'),(2519,45,0,216,'Nuie'),(2520,52,0,216,'PRODUCTS'),(2521,63,0,216,'category-full-width'),(2522,119,0,216,'nuie'),(2523,120,0,216,'bathroom/toilet/brands/nuie'),(2606,45,0,219,'Toilet'),(2607,52,0,219,'PRODUCTS'),(2608,63,0,219,'category-full-width'),(2609,119,0,219,'toilet'),(2610,120,0,219,'bathroom/toilet'),(2740,45,0,221,'Basins'),(2741,52,0,221,'PRODUCTS'),(2742,63,0,221,'category-full-width'),(2743,119,0,221,'basins'),(2744,120,0,221,'bathroom/basins/basins'),(2753,45,0,222,'Semi Pedestal Basins'),(2754,52,0,222,'PRODUCTS'),(2755,63,0,222,'category-full-width'),(2756,119,0,222,'semi-pedestal-basins'),(2757,120,0,222,'bathroom/basins/basins/semi-pedestal-basins'),(2764,45,0,223,'Space Saver Basins'),(2765,52,0,223,'PRODUCTS'),(2766,63,0,223,'category-full-width'),(2767,119,0,223,'space-saver-basins'),(2768,120,0,223,'bathroom/basins/basins/space-saver-basins'),(2777,45,0,224,'Freestanding Basin'),(2778,52,0,224,'PRODUCTS'),(2779,63,0,224,'category-full-width'),(2780,119,0,224,'freestanding-basin'),(2781,120,0,224,'bathroom/basins/basins/freestanding-basin'),(2782,45,0,225,'Washstands'),(2783,52,0,225,'PRODUCTS'),(2784,63,0,225,'category-full-width'),(2785,119,0,225,'washstands'),(2786,120,0,225,'bathroom/basins/basins/washstands'),(2850,45,0,226,'Accessories'),(2851,52,0,226,'PRODUCTS'),(2852,63,0,226,'category-full-width'),(2853,119,0,226,'accessories'),(2854,120,0,226,'bathroom/basins/accessories'),(2880,45,0,227,'Soap Dispenser'),(2881,52,0,227,'PRODUCTS'),(2882,63,0,227,'category-full-width'),(2883,119,0,227,'soap-dispenser'),(2884,120,0,227,'bathroom/basins/accessories/soap-dispenser'),(2892,45,0,229,'Towel Rails'),(2893,52,0,229,'PRODUCTS'),(2894,63,0,229,'category-full-width'),(2895,119,0,229,'towel-rails'),(2896,120,0,229,'bathroom/basins/accessories/towel-rails'),(2897,45,0,230,'Brands'),(2898,52,0,230,'PRODUCTS'),(2899,63,0,230,'category-full-width'),(2900,119,0,230,'brands'),(2901,120,0,230,'bathroom/basins/brands'),(2902,45,0,231,'Rak'),(2903,52,0,231,'PRODUCTS'),(2904,63,0,231,'category-full-width'),(2905,119,0,231,'rak'),(2906,120,0,231,'bathroom/basins/brands/rak'),(2907,45,0,232,'Geberit'),(2908,52,0,232,'PRODUCTS'),(2909,63,0,232,'category-full-width'),(2910,119,0,232,'geberit'),(2911,120,0,232,'bathroom/basins/brands/geberit'),(2912,45,0,233,'Grohe'),(2913,52,0,233,'PRODUCTS'),(2914,63,0,233,'category-full-width'),(2915,119,0,233,'grohe'),(2916,120,0,233,'bathroom/basins/brands/grohe'),(2917,45,0,234,'Hudson Reed'),(2918,52,0,234,'PRODUCTS'),(2919,63,0,234,'category-full-width'),(2920,119,0,234,'hudson-reed'),(2921,120,0,234,'bathroom/basins/brands/hudson-reed'),(2922,45,0,235,'Roca'),(2923,52,0,235,'PRODUCTS'),(2924,63,0,235,'category-full-width'),(2925,119,0,235,'roca'),(2926,120,0,235,'bathroom/basins/brands/roca'),(2927,45,0,236,'Vitra'),(2928,52,0,236,'PRODUCTS'),(2929,63,0,236,'category-full-width'),(2930,119,0,236,'vitra'),(2931,120,0,236,'bathroom/basins/brands/vitra'),(2932,45,0,237,'Nuie'),(2933,52,0,237,'PRODUCTS'),(2934,63,0,237,'category-full-width'),(2935,119,0,237,'nuie'),(2936,120,0,237,'bathroom/basins/brands/nuie'),(2979,48,0,168,NULL),(2980,60,0,168,NULL),(3008,45,0,238,'Shower Head with Arm'),(3009,52,0,238,'PRODUCTS'),(3010,63,0,238,'category-full-width'),(3011,119,0,238,'shower-head-with-arm'),(3012,120,0,238,'bathroom/shower-valves/all-showers/shower-head-with-arm'),(3029,45,0,239,'Bar Valves'),(3030,52,0,239,'PRODUCTS'),(3031,63,0,239,'category-full-width'),(3032,119,0,239,'bar-valves'),(3033,120,0,239,'bathroom/shower-valves/valves/bar-valves'),(3050,45,0,240,'Brands'),(3051,52,0,240,'PRODUCTS'),(3052,63,0,240,'category-full-width'),(3053,119,0,240,'brands'),(3054,120,0,240,'bathroom/shower-valves/brands'),(3055,45,0,241,'Hansgrohe'),(3056,52,0,241,'PRODUCTS'),(3057,63,0,241,'category-full-width'),(3058,119,0,241,'hansgrohe'),(3059,120,0,241,'bathroom/shower-valves/brands/hansgrohe'),(3060,45,0,242,'Grohe'),(3061,52,0,242,'PRODUCTS'),(3062,63,0,242,'category-full-width'),(3063,119,0,242,'grohe'),(3064,120,0,242,'bathroom/shower-valves/brands/grohe'),(3065,45,0,243,'Nuei'),(3066,52,0,243,'PRODUCTS'),(3067,63,0,243,'category-full-width'),(3068,119,0,243,'nuei'),(3069,120,0,243,'bathroom/shower-valves/brands/nuei'),(3070,45,0,244,'Hudson Reed'),(3071,52,0,244,'PRODUCTS'),(3072,63,0,244,'category-full-width'),(3073,119,0,244,'hudson-reed'),(3074,120,0,244,'bathroom/shower-valves/brands/hudson-reed'),(3177,48,0,219,NULL),(3178,49,0,219,'Luxury Toilets, High Quality Bathroom Toilets - Super Discounted prices'),(3179,60,0,219,NULL),(3188,45,0,245,'Curved Enclosures'),(3189,52,0,245,'PRODUCTS'),(3190,63,0,245,'category-full-width'),(3191,119,0,245,'curved-enclosures'),(3192,120,0,245,'bathroom/showering/shower-enclosures/curved-enclosures'),(3193,45,0,246,'3 Sided Enclosures'),(3194,52,0,246,'PRODUCTS'),(3195,63,0,246,'category-full-width'),(3196,119,0,246,'3-sided-enclosures'),(3197,120,0,246,'bathroom/showering/shower-enclosures/3-sided-enclosures'),(3222,48,0,82,NULL),(3223,60,0,82,NULL),(3229,45,0,247,'Brands'),(3230,52,0,247,'PRODUCTS'),(3231,63,0,247,'category-full-width'),(3232,119,0,247,'brands'),(3233,120,0,247,'bathroom/showering/brands'),(3234,45,0,248,'Matki'),(3235,52,0,248,'PRODUCTS'),(3236,63,0,248,'category-full-width'),(3237,119,0,248,'matki'),(3238,120,0,248,'bathroom/showering/brands/matki'),(3239,45,0,249,'Nuei'),(3240,52,0,249,'PRODUCTS'),(3241,63,0,249,'category-full-width'),(3242,119,0,249,'nuei'),(3243,120,0,249,'bathroom/showering/brands/nuei'),(3244,45,0,250,'Ideal Stnadard'),(3245,52,0,250,'PRODUCTS'),(3246,63,0,250,'category-full-width'),(3247,119,0,250,'ideal-stnadard'),(3248,120,0,250,'bathroom/showering/brands/ideal-stnadard'),(3249,45,0,251,'Hudson Reed'),(3250,52,0,251,'PRODUCTS'),(3251,63,0,251,'category-full-width'),(3252,119,0,251,'hudson-reed'),(3253,120,0,251,'bathroom/showering/brands/hudson-reed'),(3254,45,0,252,'Rak'),(3255,52,0,252,'PRODUCTS'),(3256,63,0,252,'category-full-width'),(3257,119,0,252,'rak'),(3258,120,0,252,'bathroom/showering/brands/rak'),(3259,45,0,253,'Baths'),(3260,52,0,253,'PRODUCTS'),(3261,63,0,253,'category-full-width'),(3262,119,0,253,'baths'),(3263,120,0,253,'bathroom/baths/baths'),(3266,45,0,254,'Single Ended Baths'),(3267,52,0,254,'PRODUCTS'),(3268,63,0,254,'category-full-width'),(3269,119,0,254,'single-ended-baths'),(3270,120,0,254,'bathroom/baths/baths/single-ended-baths'),(3271,45,0,255,'Double Ended Baths'),(3272,52,0,255,'PRODUCTS'),(3273,63,0,255,'category-full-width'),(3274,119,0,255,'double-ended-baths'),(3275,120,0,255,'bathroom/baths/baths/double-ended-baths'),(3278,45,0,256,'Rectangular Baths'),(3279,52,0,256,'PRODUCTS'),(3280,63,0,256,'category-full-width'),(3281,119,0,256,'rectangular-baths'),(3282,120,0,256,'bathroom/baths/baths/rectangular-baths'),(3291,45,0,257,'Space Saving Baths'),(3292,52,0,257,'PRODUCTS'),(3293,63,0,257,'category-full-width'),(3294,119,0,257,'space-saving-baths'),(3295,120,0,257,'bathroom/baths/baths/space-saving-baths'),(3321,45,0,258,'Bath Panels'),(3322,52,0,258,'PRODUCTS'),(3323,63,0,258,'category-full-width'),(3324,119,0,258,'bath-panels'),(3325,120,0,258,'bathroom/baths/bathroom-accessories/bath-panels'),(3331,45,0,259,'Bath Legsets'),(3332,52,0,259,'PRODUCTS'),(3333,63,0,259,'category-full-width'),(3334,119,0,259,'bath-legsets'),(3335,120,0,259,'bathroom/baths/bathroom-accessories/bath-legsets'),(3336,45,0,260,'Bath Grips'),(3337,52,0,260,'PRODUCTS'),(3338,63,0,260,'category-full-width'),(3339,119,0,260,'bath-grips'),(3340,120,0,260,'bathroom/baths/bathroom-accessories/bath-grips'),(3341,45,0,261,'Miscellaneous'),(3342,52,0,261,'PRODUCTS'),(3343,63,0,261,'category-full-width'),(3344,119,0,261,'miscellaneous'),(3345,120,0,261,'bathroom/baths/bathroom-accessories/miscellaneous'),(3360,45,0,262,'Brands'),(3361,52,0,262,'PRODUCTS'),(3362,63,0,262,'category-full-width'),(3363,119,0,262,'bette'),(3364,120,0,262,'bathroom/baths/bette'),(3366,48,0,262,NULL),(3367,49,0,262,NULL),(3368,60,0,262,NULL),(3369,45,0,263,'Bette'),(3370,52,0,263,'PRODUCTS'),(3371,63,0,263,'category-full-width'),(3372,119,0,263,'bette'),(3373,120,0,263,'bathroom/baths/bette/bette'),(3374,45,0,264,'Geberit'),(3375,52,0,264,'PRODUCTS'),(3376,63,0,264,'category-full-width'),(3377,119,0,264,'geberit'),(3378,120,0,264,'bathroom/baths/bette/geberit'),(3379,45,0,265,'Grohe'),(3380,52,0,265,'PRODUCTS'),(3381,63,0,265,'category-full-width'),(3382,119,0,265,'grohe'),(3383,120,0,265,'bathroom/baths/bette/grohe'),(3390,45,0,266,'Hasngrohe'),(3391,52,0,266,'PRODUCTS'),(3392,63,0,266,'category-full-width'),(3393,119,0,266,'hasngrohe'),(3394,120,0,266,'bathroom/baths/bette/hasngrohe'),(3395,45,0,267,'Hudson Reed'),(3396,52,0,267,'PRODUCTS'),(3397,63,0,267,'category-full-width'),(3398,119,0,267,'hudson-reed'),(3399,120,0,267,'bathroom/baths/bette/hudson-reed'),(3400,45,0,268,'Ideal Standard'),(3401,52,0,268,'PRODUCTS'),(3402,63,0,268,'category-full-width'),(3403,119,0,268,'ideal-standard'),(3404,120,0,268,'bathroom/baths/bette/ideal-standard'),(3405,45,0,269,'Matki Showers'),(3406,52,0,269,'PRODUCTS'),(3407,63,0,269,'category-full-width'),(3408,119,0,269,'matki-showers'),(3409,120,0,269,'bathroom/baths/bette/matki-showers'),(3410,45,0,270,'Rak Ceramics'),(3411,52,0,270,'PRODUCTS'),(3412,63,0,270,'category-full-width'),(3413,119,0,270,'rak-ceramics'),(3414,120,0,270,'bathroom/baths/bette/rak-ceramics'),(3415,45,0,271,'Roca'),(3416,52,0,271,'PRODUCTS'),(3417,63,0,271,'category-full-width'),(3418,119,0,271,'roca'),(3419,120,0,271,'bathroom/baths/bette/roca'),(3420,45,0,272,'Royce Morgan'),(3421,52,0,272,'PRODUCTS'),(3422,63,0,272,'category-full-width'),(3423,119,0,272,'royce-morgan'),(3424,120,0,272,'bathroom/baths/bette/royce-morgan'),(3425,45,0,273,'Vitra'),(3426,52,0,273,'PRODUCTS'),(3427,63,0,273,'category-full-width'),(3428,119,0,273,'vitra'),(3429,120,0,273,'bathroom/baths/bette/vitra'),(3430,45,0,274,'Nuie'),(3431,52,0,274,'PRODUCTS'),(3432,63,0,274,'category-full-width'),(3433,119,0,274,'nuie'),(3434,120,0,274,'bathroom/baths/bette/nuie'),(3435,45,0,275,'Kaldewei'),(3436,52,0,275,'PRODUCTS'),(3437,63,0,275,'category-full-width'),(3438,119,0,275,'kaldewei'),(3439,120,0,275,'bathroom/baths/bette/kaldewei'),(3513,45,0,276,'High Rise Basin Taps'),(3514,52,0,276,'PRODUCTS'),(3515,63,0,276,'category-full-width'),(3516,119,0,276,'high-rise-basin-taps'),(3517,120,0,276,'bathroom/taps/basin-taps/high-rise-basin-taps'),(3518,45,0,277,'Basin Tap Pairs'),(3519,52,0,277,'PRODUCTS'),(3520,63,0,277,'category-full-width'),(3521,119,0,277,'basin-tap-pairs'),(3522,120,0,277,'bathroom/taps/basin-taps/basin-tap-pairs'),(3523,45,0,278,'Bath & Basin Tap Sets'),(3524,52,0,278,'PRODUCTS'),(3525,63,0,278,'category-full-width'),(3526,119,0,278,'bath-basin-tap-sets'),(3527,120,0,278,'bathroom/taps/basin-taps/bath-basin-tap-sets'),(3533,45,0,279,'Bath Tap Pairs'),(3534,52,0,279,'PRODUCTS'),(3535,63,0,279,'category-full-width'),(3536,119,0,279,'bath-tap-pairs'),(3537,120,0,279,'bathroom/taps/bath-taps/bath-tap-pairs'),(3540,45,0,280,'Deck Mounted Taps'),(3541,52,0,280,'PRODUCTS'),(3542,63,0,280,'category-full-width'),(3543,119,0,280,'deck-mounted-taps'),(3544,120,0,280,'bathroom/taps/bath-taps/deck-mounted-taps'),(3550,45,0,282,'Bath & Basin Tap Sets'),(3551,52,0,282,'PRODUCTS'),(3552,63,0,282,'category-full-width'),(3553,119,0,282,'bath-basin-tap-sets'),(3554,120,0,282,'bathroom/taps/bath-taps/bath-basin-tap-sets'),(3578,45,0,283,'Standard Mirrors'),(3579,52,0,283,'PRODUCTS'),(3580,63,0,283,'category-full-width'),(3581,119,0,283,'standard-mirrors'),(3582,120,0,283,'bathroom/mirrors-cabinets/mirrors/standard-mirrors'),(3583,45,0,284,'LED Mirrors'),(3584,52,0,284,'PRODUCTS'),(3585,63,0,284,'category-full-width'),(3586,119,0,284,'led-mirrors'),(3587,120,0,284,'bathroom/mirrors-cabinets/mirrors/led-mirrors'),(3588,45,0,285,'Backlit Mirrors'),(3589,52,0,285,'PRODUCTS'),(3590,63,0,285,'category-full-width'),(3591,119,0,285,'backlit-mirrors'),(3592,120,0,285,'bathroom/mirrors-cabinets/mirrors/backlit-mirrors'),(3593,45,0,286,'Demister Mirrors'),(3594,52,0,286,'PRODUCTS'),(3595,63,0,286,'category-full-width'),(3596,119,0,286,'demister-mirrors'),(3597,120,0,286,'bathroom/mirrors-cabinets/mirrors/demister-mirrors'),(3598,45,0,287,'Magnifying Mirrors'),(3599,52,0,287,'PRODUCTS'),(3600,63,0,287,'category-full-width'),(3601,119,0,287,'magnifying-mirrors'),(3602,120,0,287,'bathroom/mirrors-cabinets/mirrors/magnifying-mirrors'),(3603,45,0,288,'Smart Mirrors'),(3604,52,0,288,'PRODUCTS'),(3605,63,0,288,'category-full-width'),(3606,119,0,288,'smart-mirrors'),(3607,120,0,288,'bathroom/mirrors-cabinets/mirrors/smart-mirrors'),(3608,45,0,289,'Brands'),(3609,52,0,289,'PRODUCTS'),(3610,63,0,289,'category-full-width'),(3611,119,0,289,'brands'),(3612,120,0,289,'bathroom/mirrors-cabinets/brands'),(3613,45,0,290,'Hib'),(3614,52,0,290,'PRODUCTS'),(3615,63,0,290,'category-full-width'),(3616,119,0,290,'hib'),(3617,120,0,290,'bathroom/mirrors-cabinets/brands/hib'),(3618,45,0,291,'Hudson Reed'),(3619,52,0,291,'PRODUCTS'),(3620,63,0,291,'category-full-width'),(3621,119,0,291,'hudson-reed'),(3622,120,0,291,'bathroom/mirrors-cabinets/brands/hudson-reed'),(3623,45,0,292,'Rak Ceramics'),(3624,52,0,292,'PRODUCTS'),(3625,63,0,292,'category-full-width'),(3626,119,0,292,'rak-ceramics'),(3627,120,0,292,'bathroom/mirrors-cabinets/brands/rak-ceramics'),(3628,45,0,293,'Roca'),(3629,52,0,293,'PRODUCTS'),(3630,63,0,293,'category-full-width'),(3631,119,0,293,'roca'),(3632,120,0,293,'bathroom/mirrors-cabinets/brands/roca'),(3633,45,0,294,'Nuie'),(3634,52,0,294,'PRODUCTS'),(3635,63,0,294,'category-full-width'),(3636,119,0,294,'nuie'),(3637,120,0,294,'bathroom/mirrors-cabinets/brands/nuie'),(3651,45,0,295,'Bathroom Furniture'),(3652,52,0,295,'PRODUCTS'),(3653,63,0,295,'category-full-width'),(3654,119,0,295,'bathroom-furniture'),(3655,120,0,295,'bathroom/bathroom-furniture/bathroom-furniture'),(3675,45,0,296,'Corner Vanity Units'),(3676,52,0,296,'PRODUCTS'),(3677,63,0,296,'category-full-width'),(3678,119,0,296,'corner-vanity-units'),(3679,120,0,296,'bathroom/bathroom-furniture/bathroom-furniture/corner-vanity-units'),(3680,45,0,297,'Double Sink Vanity Units'),(3681,52,0,297,'PRODUCTS'),(3682,63,0,297,'category-full-width'),(3683,119,0,297,'double-sink-vanity-units'),(3684,120,0,297,'bathroom/bathroom-furniture/bathroom-furniture/double-sink-vanity-units'),(3685,45,0,298,'Countertop Vanity Units'),(3686,52,0,298,'PRODUCTS'),(3687,63,0,298,'category-full-width'),(3688,119,0,298,'countertop-vanity-units'),(3689,120,0,298,'bathroom/bathroom-furniture/bathroom-furniture/countertop-vanity-units'),(3692,45,0,299,'Toilet and Sink Units'),(3693,52,0,299,'PRODUCTS'),(3694,63,0,299,'category-full-width'),(3695,119,0,299,'toilet-and-sink-units'),(3696,120,0,299,'bathroom/bathroom-furniture/bathroom-furniture/toilet-and-sink-units'),(3697,45,0,300,'Tall Bathroom Cabinets'),(3698,52,0,300,'PRODUCTS'),(3699,63,0,300,'category-full-width'),(3700,119,0,300,'tall-bathroom-cabinets'),(3701,120,0,300,'bathroom/bathroom-furniture/bathroom-furniture/tall-bathroom-cabinets'),(3702,45,0,301,'Brands'),(3703,52,0,301,'PRODUCTS'),(3704,63,0,301,'category-full-width'),(3705,119,0,301,'brands'),(3706,120,0,301,'bathroom/bathroom-furniture/brands'),(3707,45,0,302,'Hudson Reed'),(3708,52,0,302,'PRODUCTS'),(3709,63,0,302,'category-full-width'),(3710,119,0,302,'hudson-reed'),(3711,120,0,302,'bathroom/bathroom-furniture/brands/hudson-reed'),(3712,45,0,303,'Rak Ceramics'),(3713,52,0,303,'PRODUCTS'),(3714,63,0,303,'category-full-width'),(3715,119,0,303,'rak-ceramics'),(3716,120,0,303,'bathroom/bathroom-furniture/brands/rak-ceramics'),(3717,45,0,304,'Roca'),(3718,52,0,304,'PRODUCTS'),(3719,63,0,304,'category-full-width'),(3720,119,0,304,'roca'),(3721,120,0,304,'bathroom/bathroom-furniture/brands/roca'),(3722,45,0,305,'Vitra'),(3723,52,0,305,'PRODUCTS'),(3724,63,0,305,'category-full-width'),(3725,119,0,305,'vitra'),(3726,120,0,305,'bathroom/bathroom-furniture/brands/vitra'),(3727,45,0,306,'Nuie'),(3728,52,0,306,'PRODUCTS'),(3729,63,0,306,'category-full-width'),(3730,119,0,306,'nuie'),(3731,120,0,306,'bathroom/bathroom-furniture/brands/nuie'),(3733,48,0,290,NULL),(3734,49,0,290,NULL),(3735,60,0,290,NULL),(3801,45,0,307,'Undermount'),(3802,52,0,307,'PRODUCTS'),(3803,63,0,307,'category-full-width'),(3804,119,0,307,'undermount'),(3805,120,0,307,'kitchen-appliances/kitchen-sinks/sink-type/undermount'),(3806,45,0,308,'Inset/Flushmount'),(3807,52,0,308,'PRODUCTS'),(3808,63,0,308,'category-full-width'),(3809,119,0,308,'inset-flushmount'),(3810,120,0,308,'kitchen-appliances/kitchen-sinks/sink-type/inset-flushmount'),(3811,45,0,309,'1.0 Bowl Sinks'),(3812,52,0,309,'PRODUCTS'),(3813,63,0,309,'category-full-width'),(3814,119,0,309,'1-0-bowl-sinks'),(3815,120,0,309,'kitchen-appliances/kitchen-sinks/sink-type/1-0-bowl-sinks'),(3816,45,0,310,'1.5 Bowl Sinks'),(3817,52,0,310,'PRODUCTS'),(3818,63,0,310,'category-full-width'),(3819,119,0,310,'1-5-bowl-sinks'),(3820,120,0,310,'kitchen-appliances/kitchen-sinks/sink-type/1-5-bowl-sinks'),(3821,45,0,311,'2.0 Bowl Sinks'),(3822,52,0,311,'PRODUCTS'),(3823,63,0,311,'category-full-width'),(3824,119,0,311,'2-0-bowl-sinks'),(3825,120,0,311,'kitchen-appliances/kitchen-sinks/sink-type/2-0-bowl-sinks'),(3830,45,0,312,'Belfast Sinks'),(3831,52,0,312,'PRODUCTS'),(3832,63,0,312,'category-full-width'),(3833,119,0,312,'belfast-sinks'),(3834,120,0,312,'kitchen-appliances/kitchen-sinks/sink-type/belfast-sinks'),(3839,48,0,109,NULL),(3840,60,0,109,NULL),(3842,45,0,313,'Sink Material'),(3843,52,0,313,'PRODUCTS'),(3844,63,0,313,'category-full-width'),(3845,119,0,313,'sink-material'),(3846,120,0,313,'kitchen-appliances/kitchen-sinks/sink-material'),(3851,45,0,314,'Ceramic Sinks'),(3852,52,0,314,'PRODUCTS'),(3853,63,0,314,'category-full-width'),(3854,119,0,314,'ceramic-sinks'),(3855,120,0,314,'kitchen-appliances/kitchen-sinks/sink-material/ceramic-sinks'),(3856,45,0,315,'Granite Sinks'),(3857,52,0,315,'PRODUCTS'),(3858,63,0,315,'category-full-width'),(3859,119,0,315,'granite-sinks'),(3860,120,0,315,'kitchen-appliances/kitchen-sinks/sink-material/granite-sinks'),(3861,45,0,316,'Composite Sinks'),(3862,52,0,316,'PRODUCTS'),(3863,63,0,316,'category-full-width'),(3864,119,0,316,'composite-sinks'),(3865,120,0,316,'kitchen-appliances/kitchen-sinks/sink-material/composite-sinks'),(3866,45,0,317,'Coloured Sinks'),(3867,52,0,317,'PRODUCTS'),(3868,63,0,317,'category-full-width'),(3869,119,0,317,'coloured-sinks'),(3870,120,0,317,'kitchen-appliances/kitchen-sinks/sink-material/coloured-sinks'),(3871,45,0,318,'Kitchens Sinks'),(3872,52,0,318,'PRODUCTS'),(3873,63,0,318,'category-full-width'),(3874,119,0,318,'kitchen-sinks'),(3875,120,0,318,'kitchen-appliances/kitchen-sinks'),(3957,48,0,318,NULL),(3958,49,0,318,'Kitchen Sinks: Upgrade Your Kitchen | Unbeatable Deals'),(3959,60,0,318,NULL),(3960,45,0,319,'Accessories'),(3961,52,0,319,'PRODUCTS'),(3962,63,0,319,'category-full-width'),(3963,119,0,319,'accessories'),(3964,120,0,319,'kitchen-appliances/kitchen-sinks/accessories'),(3970,45,0,321,'Waster Sorter'),(3971,52,0,321,'PRODUCTS'),(3972,63,0,321,'category-full-width'),(3973,119,0,321,'waster-sorter'),(3974,120,0,321,'kitchen-appliances/kitchen-sinks/accessories/waster-sorter'),(3975,45,0,322,'Plumbing Kits'),(3976,52,0,322,'PRODUCTS'),(3977,63,0,322,'category-full-width'),(3978,119,0,322,'plumbing-kits'),(3979,120,0,322,'kitchen-appliances/kitchen-sinks/accessories/plumbing-kits'),(3980,45,0,323,'Brands'),(3981,52,0,323,'PRODUCTS'),(3982,63,0,323,'category-full-width'),(3983,119,0,323,'brands'),(3984,120,0,323,'kitchen-appliances/kitchen-sinks/brands'),(3985,45,0,324,'Franke'),(3986,52,0,324,'PRODUCTS'),(3987,63,0,324,'category-full-width'),(3988,119,0,324,'franke'),(3989,120,0,324,'kitchen-appliances/kitchen-sinks/brands/franke'),(3990,45,0,325,'Reginox'),(3991,52,0,325,'PRODUCTS'),(3992,63,0,325,'category-full-width'),(3993,119,0,325,'reginox'),(3994,120,0,325,'kitchen-appliances/kitchen-sinks/brands/reginox'),(3995,45,0,326,'Blanco'),(3996,52,0,326,'PRODUCTS'),(3997,63,0,326,'category-full-width'),(3998,119,0,326,'blanco'),(3999,120,0,326,'kitchen-appliances/kitchen-sinks/brands/blanco'),(4000,45,0,327,'Grohe'),(4001,52,0,327,'PRODUCTS'),(4002,63,0,327,'category-full-width'),(4003,119,0,327,'grohe'),(4004,120,0,327,'kitchen-appliances/kitchen-sinks/brands/grohe'),(4005,45,0,328,'Hansgrohe'),(4006,52,0,328,'PRODUCTS'),(4007,63,0,328,'category-full-width'),(4008,119,0,328,'hansgrohe'),(4009,120,0,328,'kitchen-appliances/kitchen-sinks/brands/hansgrohe'),(4020,45,0,329,'Kitchen Tap Type'),(4021,52,0,329,'PRODUCTS'),(4022,63,0,329,'category-full-width'),(4023,119,0,329,'kitchen-tap-type'),(4024,120,0,329,'kitchen-appliances/kitchen-taps/kitchen-tap-type'),(4032,45,0,330,'Kitchen Mixer Taps'),(4033,52,0,330,'PRODUCTS'),(4034,63,0,330,'category-full-width'),(4035,119,0,330,'kitchen-mixer-taps'),(4036,120,0,330,'kitchen-appliances/kitchen-taps/kitchen-tap-type/kitchen-mixer-taps'),(4037,45,0,331,'Pull Out Kitchen Taps'),(4038,52,0,331,'PRODUCTS'),(4039,63,0,331,'category-full-width'),(4040,119,0,331,'pull-out-kitchen-taps'),(4041,120,0,331,'kitchen-appliances/kitchen-taps/kitchen-tap-type/pull-out-kitchen-taps'),(4042,45,0,332,'Coloured Kitchen Taps'),(4043,52,0,332,'PRODUCTS'),(4044,63,0,332,'category-full-width'),(4045,119,0,332,'coloured-kitchen-taps'),(4046,120,0,332,'kitchen-appliances/kitchen-taps/kitchen-tap-type/coloured-kitchen-taps'),(4057,45,0,335,'Sparkling Water Taps'),(4058,52,0,335,'PRODUCTS'),(4059,63,0,335,'category-full-width'),(4060,119,0,335,'sparkling-water-taps'),(4061,120,0,335,'kitchen-appliances/kitchen-taps/kitchen-tap-type/sparkling-water-taps'),(4062,45,0,336,'Smart Taps'),(4063,52,0,336,'PRODUCTS'),(4064,63,0,336,'category-full-width'),(4065,119,0,336,'smart-taps'),(4066,120,0,336,'kitchen-appliances/kitchen-taps/kitchen-tap-type/smart-taps'),(4070,48,0,148,NULL),(4071,60,0,148,NULL),(4083,45,0,337,'Brands'),(4084,52,0,337,'PRODUCTS'),(4085,63,0,337,'category-full-width'),(4086,119,0,337,'brands'),(4087,120,0,337,'kitchen-appliances/kitchen-taps/brands'),(4090,45,0,338,'Franke'),(4091,52,0,338,'PRODUCTS'),(4092,63,0,338,'category-full-width'),(4093,119,0,338,'franke'),(4094,120,0,338,'kitchen-appliances/kitchen-taps/brands/franke'),(4095,45,0,339,'Blanco'),(4096,52,0,339,'PRODUCTS'),(4097,63,0,339,'category-full-width'),(4098,119,0,339,'blanco'),(4099,120,0,339,'kitchen-appliances/kitchen-taps/brands/blanco'),(4100,45,0,340,'Reginox'),(4101,52,0,340,'PRODUCTS'),(4102,63,0,340,'category-full-width'),(4103,119,0,340,'reginox'),(4104,120,0,340,'kitchen-appliances/kitchen-taps/brands/reginox'),(4105,45,0,341,'Grohe'),(4106,52,0,341,'PRODUCTS'),(4107,63,0,341,'category-full-width'),(4108,119,0,341,'grohe'),(4109,120,0,341,'kitchen-appliances/kitchen-taps/brands/grohe'),(4110,45,0,342,'Hansgrohe'),(4111,52,0,342,'PRODUCTS'),(4112,63,0,342,'category-full-width'),(4113,119,0,342,'hansgrohe'),(4114,120,0,342,'kitchen-appliances/kitchen-taps/brands/hansgrohe'),(4116,45,0,343,'Appliances'),(4117,52,0,343,'PRODUCTS'),(4118,63,0,343,'category-full-width'),(4119,119,0,343,'appliances'),(4120,120,0,343,'kitchen-appliances/appliances'),(4147,45,0,344,'Kitchen Tap Accessories'),(4148,52,0,344,'PRODUCTS'),(4149,63,0,344,'category-full-width'),(4150,119,0,344,'kitchen-tap-accessories'),(4151,120,0,344,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories'),(4154,45,0,345,'Soap Dispensors'),(4155,52,0,345,'PRODUCTS'),(4156,63,0,345,'category-full-width'),(4157,119,0,345,'soap-dispensors'),(4158,120,0,345,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/soap-dispensors'),(4159,45,0,346,'Filters'),(4160,52,0,346,'PRODUCTS'),(4161,63,0,346,'category-full-width'),(4162,119,0,346,'filters'),(4163,120,0,346,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/filters'),(4164,45,0,347,'Hot Water Tanks'),(4165,52,0,347,'PRODUCTS'),(4166,63,0,347,'category-full-width'),(4167,119,0,347,'hot-water-tanks'),(4168,120,0,347,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/hot-water-tanks'),(4231,45,0,348,'Accessories'),(4232,52,0,348,'PRODUCTS'),(4233,63,0,348,'category-full-width'),(4234,119,0,348,'accessories'),(4235,120,0,348,'kitchen-appliances/appliances/accessories'),(4236,45,0,349,'Accessories'),(4237,52,0,349,'PRODUCTS'),(4238,63,0,349,'category-full-width'),(4239,119,0,349,'accessories'),(4240,120,0,349,'kitchen-appliances/appliances/accessories/accessories'),(4241,45,0,350,'Brands'),(4242,52,0,350,'PRODUCTS'),(4243,63,0,350,'category-full-width'),(4244,119,0,350,'brands'),(4245,120,0,350,'kitchen-appliances/appliances/brands'),(4246,45,0,351,'Bosch'),(4247,52,0,351,'PRODUCTS'),(4248,63,0,351,'category-full-width'),(4249,119,0,351,'bosch'),(4250,120,0,351,'kitchen-appliances/appliances/brands/bosch'),(4251,45,0,352,'Neff'),(4252,52,0,352,'PRODUCTS'),(4253,63,0,352,'category-full-width'),(4254,119,0,352,'neff'),(4255,120,0,352,'kitchen-appliances/appliances/brands/neff'),(4256,45,0,353,'Siemens'),(4257,52,0,353,'PRODUCTS'),(4258,63,0,353,'category-full-width'),(4259,119,0,353,'siemens'),(4260,120,0,353,'kitchen-appliances/appliances/brands/siemens'),(4261,45,0,354,'Franke'),(4262,52,0,354,'PRODUCTS'),(4263,63,0,354,'category-full-width'),(4264,119,0,354,'franke'),(4265,120,0,354,'kitchen-appliances/appliances/brands/franke'),(4266,45,0,355,'Elica'),(4267,52,0,355,'PRODUCTS'),(4268,63,0,355,'category-full-width'),(4269,119,0,355,'elica'),(4270,120,0,355,'kitchen-appliances/appliances/brands/elica'),(4271,45,0,356,'Kitchen Accessories'),(4272,52,0,356,'PRODUCTS'),(4273,63,0,356,'category-full-width'),(4274,119,0,356,'kitchen-accessories'),(4275,120,0,356,'kitchen-appliances/kitchen-accessories'),(4281,45,0,358,'Accessories'),(4282,52,0,358,'PRODUCTS'),(4283,63,0,358,'category-full-width'),(4284,119,0,358,'accessories'),(4285,120,0,358,'kitchen-appliances/kitchen-accessories/accessories'),(4286,45,0,359,'Soap Dispensors'),(4287,52,0,359,'PRODUCTS'),(4288,63,0,359,'category-full-width'),(4289,119,0,359,'soap-dispensors'),(4290,120,0,359,'kitchen-appliances/kitchen-accessories/accessories/soap-dispensors'),(4291,45,0,360,'Chopping boards'),(4292,52,0,360,'PRODUCTS'),(4293,63,0,360,'category-full-width'),(4294,119,0,360,'chopping-boards'),(4295,120,0,360,'kitchen-appliances/kitchen-accessories/accessories/chopping-boards'),(4296,45,0,361,'Strainers'),(4297,52,0,361,'PRODUCTS'),(4298,63,0,361,'category-full-width'),(4299,119,0,361,'strainers'),(4300,120,0,361,'kitchen-appliances/kitchen-accessories/accessories/strainers'),(4301,45,0,362,'Colanders'),(4302,52,0,362,'PRODUCTS'),(4303,63,0,362,'category-full-width'),(4304,119,0,362,'colanders'),(4305,120,0,362,'kitchen-appliances/kitchen-accessories/accessories/colanders'),(4306,45,0,363,'Metal Grids'),(4307,52,0,363,'PRODUCTS'),(4308,63,0,363,'category-full-width'),(4309,119,0,363,'metal-grids'),(4310,120,0,363,'kitchen-appliances/kitchen-accessories/accessories/metal-grids'),(4311,45,0,364,'Cleaning Sprays'),(4312,52,0,364,'PRODUCTS'),(4313,63,0,364,'category-full-width'),(4314,119,0,364,'cleaning-sprays'),(4315,120,0,364,'kitchen-appliances/kitchen-accessories/accessories/cleaning-sprays'),(4316,45,0,365,'Waste and Plumbing Kits'),(4317,52,0,365,'PRODUCTS'),(4318,63,0,365,'category-full-width'),(4319,119,0,365,'waste-and-plumbing-kits'),(4320,120,0,365,'kitchen-appliances/kitchen-accessories/accessories/waste-and-plumbing-kits'),(4343,45,0,366,'Radiators'),(4344,52,0,366,'PRODUCTS'),(4345,63,0,366,'category-full-width'),(4346,119,0,366,'radiators'),(4347,120,0,366,'heating/radiators'),(4352,45,0,367,'Radiators'),(4353,52,0,367,'PRODUCTS'),(4354,63,0,367,'category-full-width'),(4355,119,0,367,'radiators'),(4356,120,0,367,'heating/radiators/radiators'),(4387,45,0,368,'Column Radiators'),(4388,52,0,368,'PRODUCTS'),(4389,63,0,368,'category-full-width'),(4390,119,0,368,'column-radiators'),(4391,120,0,368,'heating/radiators/radiators/column-radiators'),(4394,45,0,369,'Convector Radiators'),(4395,52,0,369,'PRODUCTS'),(4396,63,0,369,'category-full-width'),(4397,119,0,369,'convector-radiators'),(4398,120,0,369,'heating/radiators/radiators/convector-radiators'),(4401,45,0,370,'Floor Standing Radiators'),(4402,52,0,370,'PRODUCTS'),(4403,63,0,370,'category-full-width'),(4404,119,0,370,'floor-standing-radiators'),(4405,120,0,370,'heating/radiators/radiators/floor-standing-radiators'),(4409,48,0,370,NULL),(4410,49,0,370,NULL),(4411,60,0,370,NULL),(4416,45,0,371,'Dual Fuel Towel Rails'),(4417,52,0,371,'PRODUCTS'),(4418,63,0,371,'category-full-width'),(4419,119,0,371,'dual-fuel-towel-rails'),(4420,120,0,371,'heating/radiators/towel-rails/dual-fuel-towel-rails'),(4437,45,0,372,'Brands'),(4438,52,0,372,'PRODUCTS'),(4439,63,0,372,'category-full-width'),(4440,119,0,372,'brands'),(4441,120,0,372,'heating/radiators/brands'),(4442,45,0,373,'Nuie'),(4443,52,0,373,'PRODUCTS'),(4444,63,0,373,'category-full-width'),(4445,119,0,373,'nuie'),(4446,120,0,373,'heating/radiators/brands/nuie'),(4447,45,0,374,'Hudson Reed'),(4448,52,0,374,'PRODUCTS'),(4449,63,0,374,'category-full-width'),(4450,119,0,374,'hudson-reed'),(4451,120,0,374,'heating/radiators/brands/hudson-reed'),(4452,45,0,375,'Carisa'),(4453,52,0,375,'PRODUCTS'),(4454,63,0,375,'category-full-width'),(4455,119,0,375,'carisa'),(4456,120,0,375,'heating/radiators/brands/carisa'),(4457,45,0,376,'Zehnder'),(4458,52,0,376,'PRODUCTS'),(4459,63,0,376,'category-full-width'),(4460,119,0,376,'zehnder'),(4461,120,0,376,'heating/radiators/brands/zehnder'),(4462,45,0,377,'Reina'),(4463,52,0,377,'PRODUCTS'),(4464,63,0,377,'category-full-width'),(4465,119,0,377,'reina'),(4466,120,0,377,'heating/radiators/brands/reina'),(4674,45,0,378,'Floor Standing Fires'),(4675,52,0,378,'PRODUCTS'),(4676,63,0,378,'category-full-width'),(4677,119,0,378,'floor-standing-fires'),(4678,120,0,378,'heating/fires/gas-fires/floor-standing-fires'),(4685,45,0,379,'Top Control/Side Control Gas Fires'),(4686,52,0,379,'PRODUCTS'),(4687,63,0,379,'category-full-width'),(4688,119,0,379,'top-control-side-control-gas-fires'),(4689,120,0,379,'heating/fires/gas-fires/top-control-side-control-gas-fires'),(4704,45,0,380,'Outdoor Gas Fires'),(4705,52,0,380,'PRODUCTS'),(4706,63,0,380,'category-full-width'),(4707,119,0,380,'outdoor-gas-fires'),(4708,120,0,380,'heating/fires/gas-fires/outdoor-gas-fires'),(4729,45,0,381,'Floor Standing Electric Fires'),(4730,52,0,381,'PRODUCTS'),(4731,63,0,381,'category-full-width'),(4732,119,0,381,'floor-standing-electric-fires'),(4733,120,0,381,'heating/fires/electric-fires/floor-standing-electric-fires'),(4734,45,0,382,'Hole in the Wall Electric Fires'),(4735,52,0,382,'PRODUCTS'),(4736,63,0,382,'category-full-width'),(4737,119,0,382,'hole-in-the-wall-electric-fires'),(4738,120,0,382,'heating/fires/electric-fires/hole-in-the-wall-electric-fires'),(4746,45,0,383,'Flueless Gas Stoves'),(4747,52,0,383,'PRODUCTS'),(4748,63,0,383,'category-full-width'),(4749,119,0,383,'flueless-gas-stoves'),(4750,120,0,383,'heating/fires/stoves/flueless-gas-stoves'),(4751,45,0,384,'Inset Gas Stoves'),(4752,52,0,384,'PRODUCTS'),(4753,63,0,384,'category-full-width'),(4754,119,0,384,'inset-gas-stoves'),(4755,120,0,384,'heating/fires/stoves/inset-gas-stoves'),(4761,45,0,385,'Fireplase Suite'),(4762,52,0,385,'PRODUCTS'),(4763,63,0,385,'category-full-width'),(4764,119,0,385,'fireplase-suite'),(4765,120,0,385,'heating/fires/fireplase-suite'),(4766,45,0,386,'Gas Fireplaces'),(4767,52,0,386,'PRODUCTS'),(4768,63,0,386,'category-full-width'),(4769,119,0,386,'gas-fireplaces'),(4770,120,0,386,'heating/fires/fireplase-suite/gas-fireplaces'),(4771,45,0,387,'Electric Fireplaces'),(4772,52,0,387,'PRODUCTS'),(4773,63,0,387,'category-full-width'),(4774,119,0,387,'electric-fireplaces'),(4775,120,0,387,'heating/fires/fireplase-suite/electric-fireplaces'),(4776,45,0,388,'Media Wall Electric Fires'),(4777,52,0,388,'PRODUCTS'),(4778,63,0,388,'category-full-width'),(4779,119,0,388,'media-wall-electric-fires'),(4780,120,0,388,'heating/fires/media-wall-electric-fires'),(4781,45,0,389,'Media Wall Electric Fires'),(4782,52,0,389,'PRODUCTS'),(4783,63,0,389,'category-full-width'),(4784,119,0,389,'media-wall-electric-fires'),(4785,120,0,389,'heating/fires/media-wall-electric-fires/media-wall-electric-fires'),(4958,45,0,390,'Brands'),(4959,52,0,390,'PRODUCTS'),(4960,63,0,390,'category-full-width'),(4961,119,0,390,'brands'),(4962,120,0,390,'heating/fires/brands'),(4963,45,0,391,'Ag Stoves'),(4964,52,0,391,'PRODUCTS'),(4965,63,0,391,'category-full-width'),(4966,119,0,391,'ag-stoves'),(4967,120,0,391,'heating/fires/brands/ag-stoves'),(4968,45,0,392,'Dik Guerts'),(4969,52,0,392,'PRODUCTS'),(4970,63,0,392,'category-full-width'),(4971,119,0,392,'dik-guerts'),(4972,120,0,392,'heating/fires/brands/dik-guerts'),(4973,45,0,393,'Dimplex'),(4974,52,0,393,'PRODUCTS'),(4975,63,0,393,'category-full-width'),(4976,119,0,393,'dimplex'),(4977,120,0,393,'heating/fires/brands/dimplex'),(4978,45,0,394,'Dru'),(4979,52,0,394,'PRODUCTS'),(4980,63,0,394,'category-full-width'),(4981,119,0,394,'dru'),(4982,120,0,394,'heating/fires/brands/dru'),(4983,45,0,395,'Ekofires'),(4984,52,0,395,'PRODUCTS'),(4985,63,0,395,'category-full-width'),(4986,119,0,395,'ekofires'),(4987,120,0,395,'heating/fires/brands/ekofires'),(4988,45,0,396,'Element 4'),(4989,52,0,396,'PRODUCTS'),(4990,63,0,396,'category-full-width'),(4991,119,0,396,'element-4'),(4992,120,0,396,'heating/fires/brands/element-4'),(4993,45,0,397,'Esse'),(4994,52,0,397,'PRODUCTS'),(4995,63,0,397,'category-full-width'),(4996,119,0,397,'esse'),(4997,120,0,397,'heating/fires/brands/esse'),(4998,45,0,398,'Evonice Fires'),(4999,52,0,398,'PRODUCTS'),(5000,63,0,398,'category-full-width'),(5001,119,0,398,'evonice-fires'),(5002,120,0,398,'heating/fires/brands/evonice-fires'),(5003,45,0,399,'Carron Fires'),(5004,52,0,399,'PRODUCTS'),(5005,63,0,399,'category-full-width'),(5006,119,0,399,'carron-fires'),(5007,120,0,399,'heating/fires/brands/carron-fires'),(5008,45,0,400,'Flamerite Fires'),(5009,52,0,400,'PRODUCTS'),(5010,63,0,400,'category-full-width'),(5011,119,0,400,'flamerite-fires'),(5012,120,0,400,'heating/fires/brands/flamerite-fires'),(5155,45,0,401,'Flavel'),(5156,52,0,401,'PRODUCTS'),(5157,63,0,401,'category-full-width'),(5158,119,0,401,'flavel'),(5159,120,0,401,'heating/fires/brands/flavel'),(5160,45,0,402,'Valor'),(5161,52,0,402,'PRODUCTS'),(5162,63,0,402,'category-full-width'),(5163,119,0,402,'valor'),(5164,120,0,402,'heating/fires/brands/valor'),(5165,45,0,403,'Gazco'),(5166,52,0,403,'PRODUCTS'),(5167,63,0,403,'category-full-width'),(5168,119,0,403,'gazco'),(5169,120,0,403,'heating/fires/brands/gazco'),(5170,45,0,404,'A-D'),(5171,52,0,404,'PRODUCTS'),(5172,63,0,404,'category-full-width'),(5173,119,0,404,'a-d'),(5174,120,0,404,'brands/a-d'),(5175,45,0,405,'Aga Stoves'),(5176,52,0,405,'PRODUCTS'),(5177,63,0,405,'category-full-width'),(5178,119,0,405,'aga-stoves'),(5179,120,0,405,'brands/a-d/aga-stoves'),(5180,45,0,406,'Bette'),(5181,52,0,406,'PRODUCTS'),(5182,63,0,406,'category-full-width'),(5183,119,0,406,'bette'),(5184,120,0,406,'brands/a-d/bette'),(5185,45,0,407,'Blanco'),(5186,52,0,407,'PRODUCTS'),(5187,63,0,407,'category-full-width'),(5188,119,0,407,'blanco'),(5189,120,0,407,'brands/a-d/blanco'),(5190,45,0,408,'Carisa'),(5191,52,0,408,'PRODUCTS'),(5192,63,0,408,'category-full-width'),(5193,119,0,408,'carisa'),(5194,120,0,408,'brands/a-d/carisa'),(5195,45,0,409,'Dik Guerts'),(5196,52,0,409,'PRODUCTS'),(5197,63,0,409,'category-full-width'),(5198,119,0,409,'dik-guerts'),(5199,120,0,409,'brands/a-d/dik-guerts'),(5200,45,0,410,'Dimplex'),(5201,52,0,410,'PRODUCTS'),(5202,63,0,410,'category-full-width'),(5203,119,0,410,'dimplex'),(5204,120,0,410,'brands/a-d/dimplex'),(5205,45,0,411,'Dru'),(5206,52,0,411,'PRODUCTS'),(5207,63,0,411,'category-full-width'),(5208,119,0,411,'dru'),(5209,120,0,411,'brands/a-d/dru'),(5210,45,0,412,'E-I'),(5211,52,0,412,'PRODUCTS'),(5212,63,0,412,'category-full-width'),(5213,119,0,412,'e-i'),(5214,120,0,412,'brands/e-i'),(5215,45,0,413,'Ekofires'),(5216,52,0,413,'PRODUCTS'),(5217,63,0,413,'category-full-width'),(5218,119,0,413,'ekofires'),(5219,120,0,413,'brands/e-i/ekofires'),(5220,45,0,414,'Element 4'),(5221,52,0,414,'PRODUCTS'),(5222,63,0,414,'category-full-width'),(5223,119,0,414,'element-4'),(5224,120,0,414,'brands/e-i/element-4'),(5225,45,0,415,'Elica'),(5226,52,0,415,'PRODUCTS'),(5227,63,0,415,'category-full-width'),(5228,119,0,415,'elica'),(5229,120,0,415,'brands/e-i/elica'),(5230,45,0,416,'Esse'),(5231,52,0,416,'PRODUCTS'),(5232,63,0,416,'category-full-width'),(5233,119,0,416,'esse'),(5234,120,0,416,'brands/e-i/esse'),(5235,45,0,417,'Evonic FIres'),(5236,52,0,417,'PRODUCTS'),(5237,63,0,417,'category-full-width'),(5238,119,0,417,'evonic-fires'),(5239,120,0,417,'brands/e-i/evonic-fires'),(5240,45,0,418,'Flamerite Fires'),(5241,52,0,418,'PRODUCTS'),(5242,63,0,418,'category-full-width'),(5243,119,0,418,'flamerite-fires'),(5244,120,0,418,'brands/e-i/flamerite-fires'),(5245,45,0,419,'Flavel'),(5246,52,0,419,'PRODUCTS'),(5247,63,0,419,'category-full-width'),(5248,119,0,419,'flavel'),(5249,120,0,419,'brands/e-i/flavel'),(5250,45,0,420,'Franke'),(5251,52,0,420,'PRODUCTS'),(5252,63,0,420,'category-full-width'),(5253,119,0,420,'franke'),(5254,120,0,420,'brands/e-i/franke'),(5255,45,0,421,'Gazco'),(5256,52,0,421,'PRODUCTS'),(5257,63,0,421,'category-full-width'),(5258,119,0,421,'gazco'),(5259,120,0,421,'brands/e-i/gazco'),(5260,45,0,422,'Geberit'),(5261,52,0,422,'PRODUCTS'),(5262,63,0,422,'category-full-width'),(5263,119,0,422,'geberit'),(5264,120,0,422,'brands/e-i/geberit'),(5265,45,0,423,'Grohe'),(5266,52,0,423,'PRODUCTS'),(5267,63,0,423,'category-full-width'),(5268,119,0,423,'grohe'),(5269,120,0,423,'brands/e-i/grohe'),(5270,45,0,424,'Hansgrohe'),(5271,52,0,424,'PRODUCTS'),(5272,63,0,424,'category-full-width'),(5273,119,0,424,'hansgrohe'),(5274,120,0,424,'brands/e-i/hansgrohe'),(5275,45,0,425,'Hib'),(5276,52,0,425,'PRODUCTS'),(5277,63,0,425,'category-full-width'),(5278,119,0,425,'hib'),(5279,120,0,425,'brands/e-i/hib'),(5280,45,0,426,'Hudson Reed'),(5281,52,0,426,'PRODUCTS'),(5282,63,0,426,'category-full-width'),(5283,119,0,426,'hudson-reed'),(5284,120,0,426,'brands/e-i/hudson-reed'),(5285,45,0,427,'Ideal Standard'),(5286,52,0,427,'PRODUCTS'),(5287,63,0,427,'category-full-width'),(5288,119,0,427,'ideal-standard'),(5289,120,0,427,'brands/e-i/ideal-standard'),(5290,45,0,428,'J-R'),(5291,52,0,428,'PRODUCTS'),(5292,63,0,428,'category-full-width'),(5293,119,0,428,'j-r'),(5294,120,0,428,'brands/j-r'),(5295,45,0,429,'Kaldewei'),(5296,52,0,429,'PRODUCTS'),(5297,63,0,429,'category-full-width'),(5298,119,0,429,'kaldewei'),(5299,120,0,429,'brands/j-r/kaldewei'),(5300,45,0,430,'Matki'),(5301,52,0,430,'PRODUCTS'),(5302,63,0,430,'category-full-width'),(5303,119,0,430,'matki'),(5304,120,0,430,'brands/j-r/matki'),(5305,45,0,431,'Neff'),(5306,52,0,431,'PRODUCTS'),(5307,63,0,431,'category-full-width'),(5308,119,0,431,'neff'),(5309,120,0,431,'brands/j-r/neff'),(5310,45,0,432,'Nuie'),(5311,52,0,432,'PRODUCTS'),(5312,63,0,432,'category-full-width'),(5313,119,0,432,'nuie'),(5314,120,0,432,'brands/j-r/nuie'),(5315,45,0,433,'Rak Ceramics'),(5316,52,0,433,'PRODUCTS'),(5317,63,0,433,'category-full-width'),(5318,119,0,433,'rak-ceramics'),(5319,120,0,433,'brands/j-r/rak-ceramics'),(5320,45,0,434,'Reginox'),(5321,52,0,434,'PRODUCTS'),(5322,63,0,434,'category-full-width'),(5323,119,0,434,'reginox'),(5324,120,0,434,'brands/j-r/reginox'),(5325,45,0,435,'Reina'),(5326,52,0,435,'PRODUCTS'),(5327,63,0,435,'category-full-width'),(5328,119,0,435,'reina'),(5329,120,0,435,'brands/j-r/reina'),(5330,45,0,436,'Roca'),(5331,52,0,436,'PRODUCTS'),(5332,63,0,436,'category-full-width'),(5333,119,0,436,'roca'),(5334,120,0,436,'brands/j-r/roca'),(5335,45,0,437,'Royce Morgan'),(5336,52,0,437,'PRODUCTS'),(5337,63,0,437,'category-full-width'),(5338,119,0,437,'royce-morgan'),(5339,120,0,437,'brands/j-r/royce-morgan'),(5340,45,0,438,'S-Z'),(5341,52,0,438,'PRODUCTS'),(5342,63,0,438,'category-full-width'),(5343,119,0,438,'s-z'),(5344,120,0,438,'brands/s-z'),(5345,45,0,439,'Siemens'),(5346,52,0,439,'PRODUCTS'),(5347,63,0,439,'category-full-width'),(5348,119,0,439,'siemens'),(5349,120,0,439,'brands/s-z/siemens'),(5350,45,0,440,'Spartherm'),(5351,52,0,440,'PRODUCTS'),(5352,63,0,440,'category-full-width'),(5353,119,0,440,'spartherm'),(5354,120,0,440,'brands/s-z/spartherm'),(5355,45,0,441,'Valor'),(5356,52,0,441,'PRODUCTS'),(5357,63,0,441,'category-full-width'),(5358,119,0,441,'valor'),(5359,120,0,441,'brands/s-z/valor'),(5360,45,0,442,'Vitra'),(5361,52,0,442,'PRODUCTS'),(5362,63,0,442,'category-full-width'),(5363,119,0,442,'vitra'),(5364,120,0,442,'brands/s-z/vitra'),(5365,45,0,443,'Zehnder'),(5366,52,0,443,'PRODUCTS'),(5367,63,0,443,'category-full-width'),(5368,119,0,443,'zehnder'),(5369,120,0,443,'brands/s-z/zehnder'),(5455,48,0,203,'/media/catalog/category/kitchen-sink_3.jpeg'),(5456,49,0,203,NULL),(5457,60,0,203,NULL),(5459,48,0,405,NULL),(5460,49,0,405,NULL),(5461,60,0,405,NULL),(5464,45,0,444,'Aeon'),(5465,52,0,444,'PRODUCTS'),(5466,63,0,444,'category-full-width'),(5467,119,0,444,'aeon'),(5468,120,0,444,'brands/a-d/aeon'),(5472,48,0,444,NULL),(5473,49,0,444,NULL),(5474,60,0,444,NULL),(5476,48,0,406,NULL),(5477,49,0,406,NULL),(5478,60,0,406,NULL),(5480,48,0,407,NULL),(5481,49,0,407,NULL),(5482,60,0,407,NULL),(5486,48,0,408,NULL),(5487,49,0,408,NULL),(5488,60,0,408,NULL),(5491,48,0,409,NULL),(5492,49,0,409,NULL),(5493,60,0,409,NULL),(5496,48,0,410,NULL),(5497,49,0,410,NULL),(5498,60,0,410,NULL),(5500,48,0,411,NULL),(5501,49,0,411,NULL),(5502,60,0,411,NULL),(5504,48,0,413,NULL),(5505,49,0,413,NULL),(5506,60,0,413,NULL),(5508,48,0,414,NULL),(5509,49,0,414,NULL),(5510,60,0,414,NULL),(5513,48,0,415,NULL),(5514,49,0,415,NULL),(5515,60,0,415,NULL),(5518,48,0,416,NULL),(5519,49,0,416,NULL),(5520,60,0,416,NULL),(5522,48,0,417,NULL),(5523,49,0,417,NULL),(5524,60,0,417,NULL),(5526,48,0,418,NULL),(5527,49,0,418,NULL),(5528,60,0,418,NULL),(5530,48,0,419,NULL),(5531,49,0,419,NULL),(5532,60,0,419,NULL),(5534,48,0,420,NULL),(5535,49,0,420,NULL),(5536,60,0,420,NULL),(5539,48,0,422,NULL),(5540,49,0,422,NULL),(5541,60,0,422,NULL),(5543,48,0,424,NULL),(5544,49,0,424,NULL),(5545,60,0,424,NULL),(5549,48,0,425,NULL),(5550,49,0,425,NULL),(5551,60,0,425,NULL),(5554,48,0,426,NULL),(5555,49,0,426,NULL),(5556,60,0,426,NULL),(5558,48,0,427,NULL),(5559,49,0,427,NULL),(5560,60,0,427,NULL),(5562,48,0,429,NULL),(5563,49,0,429,NULL),(5564,60,0,429,NULL),(5566,48,0,430,NULL),(5567,49,0,430,NULL),(5568,60,0,430,NULL),(5570,48,0,431,NULL),(5571,49,0,431,NULL),(5572,60,0,431,NULL),(5574,48,0,432,NULL),(5575,49,0,432,NULL),(5576,60,0,432,NULL),(5579,48,0,433,NULL),(5580,49,0,433,NULL),(5581,60,0,433,NULL),(5584,48,0,434,NULL),(5585,49,0,434,NULL),(5586,60,0,434,NULL),(5588,48,0,435,NULL),(5589,49,0,435,NULL),(5590,60,0,435,NULL),(5594,48,0,436,NULL),(5595,49,0,436,NULL),(5596,60,0,436,NULL),(5598,48,0,437,NULL),(5599,49,0,437,NULL),(5600,60,0,437,NULL),(5602,48,0,439,NULL),(5603,49,0,439,NULL),(5604,60,0,439,NULL),(5606,48,0,441,NULL),(5607,49,0,441,NULL),(5608,60,0,441,NULL),(5611,48,0,442,NULL),(5612,49,0,442,NULL),(5613,60,0,442,NULL),(5615,48,0,443,NULL),(5616,49,0,443,NULL),(5617,60,0,443,NULL),(5619,48,0,440,NULL),(5620,49,0,440,NULL),(5621,60,0,440,NULL),(5623,48,0,368,NULL),(5624,49,0,368,NULL),(5625,60,0,368,NULL),(5633,48,0,371,NULL),(5634,49,0,371,NULL),(5635,60,0,371,NULL),(5639,48,0,373,NULL),(5640,49,0,373,NULL),(5641,60,0,373,NULL),(5643,48,0,374,NULL),(5644,49,0,374,NULL),(5645,60,0,374,NULL),(5650,48,0,375,NULL),(5651,49,0,375,NULL),(5652,60,0,375,NULL),(5656,48,0,376,NULL),(5657,49,0,376,NULL),(5658,60,0,376,NULL),(5660,48,0,377,NULL),(5661,49,0,377,NULL),(5662,60,0,377,NULL),(5667,48,0,366,NULL),(5668,49,0,366,NULL),(5669,60,0,366,NULL),(5672,48,0,307,NULL),(5673,49,0,307,NULL),(5674,60,0,307,NULL),(5679,48,0,379,NULL),(5680,49,0,379,NULL),(5681,60,0,379,NULL),(5692,48,0,381,NULL),(5693,49,0,381,NULL),(5694,60,0,381,NULL),(5696,48,0,382,NULL),(5697,49,0,382,NULL),(5698,60,0,382,NULL),(5705,48,0,383,NULL),(5706,49,0,383,NULL),(5707,60,0,383,NULL),(5710,48,0,385,NULL),(5711,49,0,385,NULL),(5712,60,0,385,NULL),(5714,48,0,386,NULL),(5715,49,0,386,NULL),(5716,60,0,386,NULL),(5720,48,0,387,NULL),(5721,49,0,387,NULL),(5722,60,0,387,NULL),(5724,45,0,445,'Wood Burning Fireplace'),(5725,52,0,445,'PRODUCTS'),(5726,63,0,445,'category-full-width'),(5727,119,0,445,'wood-burning-fireplace'),(5728,120,0,445,'heating/fires/fireplase-suite/wood-burning-fireplace'),(5730,48,0,445,NULL),(5731,49,0,445,NULL),(5732,60,0,445,NULL),(5734,48,0,308,NULL),(5735,49,0,308,NULL),(5736,60,0,308,NULL),(5744,48,0,309,NULL),(5745,49,0,309,NULL),(5746,60,0,309,NULL),(5748,48,0,310,NULL),(5749,49,0,310,NULL),(5750,60,0,310,NULL),(5752,48,0,311,NULL),(5753,49,0,311,NULL),(5754,60,0,311,NULL),(5758,48,0,312,NULL),(5759,49,0,312,NULL),(5760,60,0,312,NULL),(5763,48,0,313,NULL),(5764,49,0,313,NULL),(5765,60,0,313,NULL),(5769,48,0,314,NULL),(5770,49,0,314,NULL),(5771,60,0,314,NULL),(5774,48,0,315,NULL),(5775,49,0,315,NULL),(5776,60,0,315,NULL),(5778,48,0,322,NULL),(5779,49,0,322,NULL),(5780,60,0,322,NULL),(5782,48,0,324,NULL),(5783,49,0,324,NULL),(5784,60,0,324,NULL),(5789,48,0,325,NULL),(5790,49,0,325,NULL),(5791,60,0,325,NULL),(5793,48,0,326,NULL),(5794,49,0,326,NULL),(5795,60,0,326,NULL),(5797,48,0,328,NULL),(5798,49,0,328,NULL),(5799,60,0,328,NULL),(5801,48,0,327,NULL),(5802,49,0,327,NULL),(5803,60,0,327,NULL),(5808,48,0,329,NULL),(5809,49,0,329,NULL),(5810,60,0,329,NULL),(5816,48,0,330,NULL),(5817,49,0,330,NULL),(5818,60,0,330,NULL),(5823,48,0,331,NULL),(5824,49,0,331,NULL),(5825,60,0,331,NULL),(5828,48,0,336,NULL),(5829,49,0,336,NULL),(5830,60,0,336,NULL),(5832,48,0,345,NULL),(5833,49,0,345,NULL),(5834,60,0,345,NULL),(5836,48,0,346,NULL),(5837,49,0,346,NULL),(5838,60,0,346,NULL),(5840,48,0,338,NULL),(5841,49,0,338,NULL),(5842,60,0,338,NULL),(5851,48,0,339,NULL),(5852,49,0,339,NULL),(5853,60,0,339,NULL),(5858,48,0,340,NULL),(5859,49,0,340,NULL),(5860,60,0,340,NULL),(5867,48,0,341,NULL),(5868,49,0,341,NULL),(5869,60,0,341,NULL),(5874,48,0,342,NULL),(5875,49,0,342,NULL),(5876,60,0,342,NULL),(5878,48,0,359,NULL),(5879,49,0,359,NULL),(5880,60,0,359,NULL),(5882,48,0,360,NULL),(5883,49,0,360,NULL),(5884,60,0,360,NULL),(5886,48,0,361,NULL),(5887,49,0,361,NULL),(5888,60,0,361,NULL),(5890,48,0,362,NULL),(5891,49,0,362,NULL),(5892,60,0,362,NULL),(5920,48,0,351,NULL),(5921,49,0,351,NULL),(5922,60,0,351,NULL),(5925,48,0,352,NULL),(5926,49,0,352,NULL),(5927,60,0,352,NULL),(5929,48,0,353,NULL),(5930,49,0,353,NULL),(5931,60,0,353,NULL),(5933,48,0,354,NULL),(5934,49,0,354,NULL),(5935,60,0,354,NULL),(5937,48,0,355,NULL),(5938,49,0,355,NULL),(5939,60,0,355,NULL),(5946,48,0,198,NULL),(5947,49,0,198,NULL),(5948,60,0,198,NULL),(5955,48,0,200,NULL),(5956,49,0,200,NULL),(5957,60,0,200,NULL),(5961,48,0,205,NULL),(5962,49,0,205,NULL),(5963,60,0,205,NULL),(5965,48,0,365,NULL),(5966,49,0,365,NULL),(5967,60,0,365,NULL),(5969,48,0,349,NULL),(5970,49,0,349,NULL),(5971,60,0,349,NULL),(5975,48,0,210,NULL),(5976,49,0,210,NULL),(5977,60,0,210,NULL),(5983,48,0,211,NULL),(5984,49,0,211,NULL),(5985,60,0,211,NULL),(5987,48,0,212,NULL),(5988,49,0,212,NULL),(5989,60,0,212,NULL),(5992,48,0,213,NULL),(5993,49,0,213,NULL),(5994,60,0,213,NULL),(5996,48,0,214,NULL),(5997,49,0,214,NULL),(5998,60,0,214,NULL),(6001,48,0,215,NULL),(6002,49,0,215,NULL),(6003,60,0,215,NULL),(6006,48,0,216,NULL),(6007,49,0,216,NULL),(6008,60,0,216,NULL),(6015,48,0,221,NULL),(6016,49,0,221,NULL),(6017,60,0,221,NULL),(6019,48,0,222,NULL),(6020,49,0,222,NULL),(6021,60,0,222,NULL),(6033,48,0,208,NULL),(6034,49,0,208,NULL),(6035,60,0,208,NULL),(6040,48,0,227,NULL),(6041,49,0,227,NULL),(6042,60,0,227,NULL),(6045,48,0,229,NULL),(6046,49,0,229,NULL),(6047,60,0,229,NULL),(6049,48,0,231,NULL),(6050,49,0,231,NULL),(6051,60,0,231,NULL),(6057,48,0,232,NULL),(6058,49,0,232,NULL),(6059,60,0,232,NULL),(6061,48,0,233,NULL),(6062,49,0,233,NULL),(6063,60,0,233,NULL),(6065,48,0,234,NULL),(6066,49,0,234,NULL),(6067,60,0,234,NULL),(6070,48,0,235,NULL),(6071,49,0,235,NULL),(6072,60,0,235,NULL),(6074,48,0,236,NULL),(6075,49,0,236,NULL),(6076,60,0,236,NULL),(6078,48,0,237,NULL),(6079,49,0,237,NULL),(6080,60,0,237,NULL),(6083,48,0,238,NULL),(6084,49,0,238,NULL),(6085,60,0,238,NULL),(6091,48,0,239,NULL),(6092,49,0,239,NULL),(6093,60,0,239,NULL),(6099,48,0,241,NULL),(6100,49,0,241,NULL),(6101,60,0,241,NULL),(6105,48,0,242,NULL),(6106,49,0,242,NULL),(6107,60,0,242,NULL),(6110,48,0,243,NULL),(6111,49,0,243,NULL),(6112,60,0,243,NULL),(6115,48,0,244,NULL),(6116,49,0,244,NULL),(6117,60,0,244,NULL),(6119,159,3,2,NULL),(6120,160,3,2,NULL),(6121,45,0,446,'Hyva-Nexus'),(6122,52,0,446,'PRODUCTS'),(6123,63,0,446,'category-full-width'),(6124,119,0,446,'hyva-nexus'),(6125,45,0,447,'Fires'),(6126,52,0,447,'PRODUCTS'),(6127,63,0,447,'category-full-width'),(6128,119,0,447,'fires'),(6129,120,0,447,'fires'),(6135,45,0,449,'Deals'),(6136,52,0,449,'PRODUCTS'),(6137,63,0,449,'category-full-width'),(6138,119,0,449,'deals'),(6139,120,0,449,'deals'),(6141,48,0,449,NULL),(6142,49,0,449,NULL),(6143,60,0,449,NULL),(6144,159,0,449,NULL),(6145,160,0,449,NULL),(6147,159,0,2,NULL),(6148,160,0,2,NULL),(6158,159,0,219,NULL),(6159,160,0,219,NULL),(6162,159,0,25,NULL),(6163,160,0,25,NULL),(6166,159,0,5,NULL),(6167,160,0,5,NULL),(6171,159,0,3,NULL),(6172,160,0,3,NULL),(6179,159,0,15,NULL),(6180,160,0,15,NULL),(6183,159,0,7,NULL),(6184,160,0,7,NULL),(6186,159,0,12,NULL),(6187,160,0,12,NULL),(6191,159,0,8,NULL),(6192,160,0,8,NULL),(6194,159,0,9,NULL),(6195,160,0,9,NULL),(6200,159,3,15,NULL),(6201,160,3,15,NULL),(6203,159,4,8,NULL),(6204,160,4,8,NULL),(6206,159,1,219,NULL),(6207,160,1,219,NULL),(6209,45,1,165,'Showers'),(6210,159,1,165,NULL),(6211,160,1,165,NULL),(6215,159,1,15,NULL),(6216,160,1,15,NULL),(6218,159,1,8,NULL),(6219,160,1,8,NULL),(6221,159,3,8,NULL),(6222,160,3,8,NULL),(6224,159,3,12,NULL),(6225,160,3,12,NULL),(6227,159,3,366,NULL),(6228,160,3,366,NULL),(6230,159,3,367,NULL),(6231,160,3,367,NULL),(6232,159,3,135,NULL),(6233,160,3,135,NULL),(6235,159,3,7,NULL),(6236,160,3,7,NULL),(6242,45,3,367,'Radiators'),(6244,45,3,318,'Kitchens Sinks'),(6245,159,3,318,NULL),(6246,160,3,318,NULL),(6248,159,1,3,NULL),(6249,160,1,3,NULL),(6255,159,3,145,NULL),(6256,160,3,145,NULL),(6258,159,0,318,NULL),(6259,160,0,318,NULL),(6262,159,0,346,NULL),(6263,160,0,346,NULL),(6269,159,0,106,NULL),(6270,160,0,106,NULL),(6272,159,0,307,NULL),(6273,160,0,307,NULL),(6278,159,2,5,NULL),(6279,160,2,5,NULL),(6281,60,2,5,NULL),(6282,63,2,5,'category-full-width'),(6288,159,1,5,NULL),(6289,160,1,5,NULL),(6292,159,3,5,NULL),(6293,160,3,5,NULL),(6296,159,4,7,NULL),(6297,160,4,7,NULL),(6300,159,5,5,NULL),(6301,160,5,5,NULL),(6303,45,5,318,'Kitchens Sinks'),(6304,159,5,318,NULL),(6305,160,5,318,NULL),(6307,45,5,5,'Kitchens'),(6309,45,5,7,'Heating'),(6310,159,5,7,NULL),(6311,160,5,7,NULL),(6313,45,5,366,'Radiators'),(6314,159,5,366,NULL),(6315,160,5,366,NULL),(6317,45,5,219,'Toilet'),(6318,159,5,219,NULL),(6319,160,5,219,NULL),(6322,45,1,318,'Kitchens Sinks'),(6323,159,1,318,NULL),(6324,160,1,318,NULL),(6325,45,1,163,'decor product'),(6326,159,1,163,NULL),(6327,160,1,163,NULL),(6328,159,3,163,NULL),(6329,160,3,163,NULL),(6331,45,3,3,'Bathroom'),(6332,159,3,3,NULL),(6333,160,3,3,NULL),(6335,45,3,219,'Toilet'),(6336,159,3,219,NULL),(6337,160,3,219,NULL),(6340,159,3,4,NULL),(6341,160,3,4,NULL),(6344,45,3,71,'Shower Enclosuress'),(6345,159,3,71,NULL),(6346,160,3,71,NULL),(6348,60,3,37,NULL),(6349,63,3,37,'category-full-width'),(6350,159,3,37,NULL),(6351,160,3,37,NULL),(6353,45,3,25,'Basins'),(6354,159,3,25,NULL),(6355,160,3,25,NULL),(6357,45,3,9,'Showers'),(6358,159,3,9,NULL),(6359,160,3,9,NULL),(6361,45,3,5,'Kitchens'),(6364,45,3,145,'Kitchen Taps'),(6366,60,3,4,NULL),(6367,63,3,4,'category-full-width'),(6370,45,3,253,'Baths'),(6371,159,3,253,NULL),(6372,160,3,253,NULL),(6374,45,3,4,'Shower Enclosures'),(6377,159,0,71,NULL),(6378,160,0,71,NULL),(6383,159,1,4,NULL),(6384,160,1,4,NULL),(6386,159,1,37,NULL),(6387,160,1,37,NULL),(6396,159,3,343,NULL),(6397,160,3,343,NULL),(6400,159,1,343,NULL),(6401,160,1,343,NULL);
/*!40000 ALTER TABLE `catalog_category_entity_varchar` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_product`
--

DROP TABLE IF EXISTS `catalog_category_product`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_product` (
  `entity_id` int NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `category_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Category ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `position` int NOT NULL DEFAULT '0' COMMENT 'Position',
  PRIMARY KEY (`entity_id`,`category_id`,`product_id`),
  UNIQUE KEY `CATALOG_CATEGORY_PRODUCT_CATEGORY_ID_PRODUCT_ID` (`category_id`,`product_id`),
  KEY `CATALOG_CATEGORY_PRODUCT_PRODUCT_ID` (`product_id`),
  CONSTRAINT `CAT_CTGR_PRD_CTGR_ID_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`category_id`) REFERENCES `catalog_category_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_CTGR_PRD_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=26310 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product To Category Linkage Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_product`
--

LOCK TABLES `catalog_category_product` WRITE;
/*!40000 ALTER TABLE `catalog_category_product` DISABLE KEYS */;
INSERT INTO `catalog_category_product` VALUES (26244,2,5760,0),(26245,3,5760,0),(26246,5,5760,0),(26247,6,5760,0),(26248,7,5760,0),(26249,10,5760,0),(26250,11,5760,0),(26251,12,5760,0),(26252,145,5760,0),(26254,164,5760,0),(26256,343,5760,0),(26257,356,5760,0),(26258,366,5760,0),(26259,446,5760,0),(26260,447,5760,0),(26261,449,5760,0),(26262,2,6035,0),(26263,3,6035,0),(26264,5,6035,0),(26265,7,6035,0),(26266,10,6035,0),(26267,11,6035,0),(26268,12,6035,0),(26270,164,6035,0),(26271,446,6035,0),(26272,447,6035,0),(26273,449,6035,0),(26274,318,6326,0),(26275,318,6327,0),(26276,318,6328,0),(26277,318,6329,0),(26278,318,6330,0),(26279,318,6331,0),(26280,318,6332,0),(26281,318,6333,0),(26282,318,6334,0),(26283,318,6335,0),(26284,318,6336,0),(26285,318,6337,0),(26286,318,6338,0),(26287,318,6339,0),(26288,318,6340,0),(26289,318,6341,0),(26290,318,6342,0),(26291,318,6343,0),(26292,318,6344,0),(26293,318,6345,0),(26294,163,6293,0),(26295,163,6299,0),(26296,163,6310,0),(26297,163,6311,0),(26298,163,6332,0),(26299,163,6333,0),(26300,163,6334,0),(26301,163,6335,0),(26302,163,6336,0),(26303,163,6337,0),(26304,163,6035,0),(26305,163,6036,0),(26306,163,6037,0),(26307,163,6038,0),(26308,163,6039,0),(26309,163,6040,0);
/*!40000 ALTER TABLE `catalog_category_product` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_category_product_after_insert` AFTER INSERT ON `catalog_category_product` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`product_id`);
INSERT IGNORE INTO `catalog_product_category_cl` (`entity_id`) VALUES (NEW.`product_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`product_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_category_product_after_update` AFTER UPDATE ON `catalog_category_product` FOR EACH ROW BEGIN
IF (NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`category_id` <=> OLD.`category_id`) OR NOT(NEW.`product_id` <=> OLD.`product_id`) OR NOT(NEW.`position` <=> OLD.`position`)) THEN INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`product_id`); END IF;
IF (NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`category_id` <=> OLD.`category_id`) OR NOT(NEW.`product_id` <=> OLD.`product_id`) OR NOT(NEW.`position` <=> OLD.`position`)) THEN INSERT IGNORE INTO `catalog_product_category_cl` (`entity_id`) VALUES (NEW.`product_id`); END IF;
IF (NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`category_id` <=> OLD.`category_id`) OR NOT(NEW.`product_id` <=> OLD.`product_id`) OR NOT(NEW.`position` <=> OLD.`position`)) THEN INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`product_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_category_product_after_delete` AFTER DELETE ON `catalog_category_product` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (OLD.`product_id`);
INSERT IGNORE INTO `catalog_product_category_cl` (`entity_id`) VALUES (OLD.`product_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (OLD.`product_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `catalog_category_product_cl`
--

DROP TABLE IF EXISTS `catalog_category_product_cl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_product_cl` (
  `version_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Version ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  PRIMARY KEY (`version_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10026 DEFAULT CHARSET=utf8mb3 COMMENT='catalog_category_product_cl';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_product_cl`
--

LOCK TABLES `catalog_category_product_cl` WRITE;
/*!40000 ALTER TABLE `catalog_category_product_cl` DISABLE KEYS */;
INSERT INTO `catalog_category_product_cl` VALUES (1,1),(2,2),(3,3),(4,3),(5,3),(6,3),(7,3),(8,3),(9,3),(10,1),(11,2),(12,3),(13,4),(14,4),(15,4),(16,4),(17,4),(18,4),(19,4),(20,1),(21,2),(22,3),(23,1),(24,2),(25,3),(26,4),(27,1),(28,2),(29,1),(30,2),(31,3),(32,4),(33,3),(34,1),(35,2),(36,5),(37,5),(38,5),(39,5),(40,5),(41,5),(42,5),(43,1),(44,2),(45,6),(46,6),(47,6),(48,6),(49,6),(50,6),(51,6),(52,1),(53,2),(54,7),(55,7),(56,7),(57,7),(58,7),(59,7),(60,7),(61,1),(62,2),(63,8),(64,8),(65,8),(66,8),(67,8),(68,8),(69,8),(70,1),(71,2),(72,9),(73,9),(74,9),(75,9),(76,9),(77,9),(78,9),(79,1),(80,2),(81,10),(82,10),(83,10),(84,10),(85,10),(86,10),(87,10),(88,1),(89,2),(90,11),(91,11),(92,11),(93,11),(94,11),(95,11),(96,11),(97,1),(98,2),(99,12),(100,12),(101,12),(102,12),(103,12),(104,12),(105,12),(106,1),(107,2),(108,13),(109,13),(110,13),(111,13),(112,13),(113,1),(114,2),(115,13),(116,14),(117,14),(118,14),(119,14),(120,14),(121,1),(122,2),(123,3),(124,15),(125,15),(126,15),(127,15),(128,15),(129,15),(130,15),(131,15),(132,1),(133,2),(134,3),(135,15),(136,16),(137,16),(138,16),(139,16),(140,16),(141,16),(142,16),(143,1),(144,2),(145,3),(146,15),(147,17),(148,17),(149,17),(150,17),(151,17),(152,17),(153,17),(154,3),(155,1),(156,2),(157,3),(158,15),(159,18),(160,18),(161,18),(162,18),(163,18),(164,18),(165,18),(166,1),(167,2),(168,3),(169,15),(170,18),(171,19),(172,19),(173,19),(174,19),(175,19),(176,19),(177,19),(178,1),(179,2),(180,3),(181,15),(182,18),(183,19),(184,1),(185,2),(186,3),(187,15),(188,20),(189,20),(190,20),(191,20),(192,20),(193,20),(194,20),(195,1),(196,2),(197,3),(198,15),(199,21),(200,21),(201,21),(202,21),(203,21),(204,21),(205,21),(206,1),(207,2),(208,3),(209,15),(210,22),(211,22),(212,22),(213,22),(214,22),(215,22),(216,22),(217,1),(218,2),(219,3),(220,15),(221,23),(222,23),(223,23),(224,23),(225,23),(226,23),(227,23),(228,1),(229,2),(230,3),(231,15),(232,24),(233,24),(234,24),(235,24),(236,24),(237,24),(238,24),(239,1),(240,2),(241,3),(242,25),(243,25),(244,25),(245,25),(246,25),(247,25),(248,25),(249,1),(250,2),(251,3),(252,25),(253,26),(254,26),(255,26),(256,26),(257,26),(258,26),(259,26),(260,1),(261,2),(262,3),(263,25),(264,27),(265,27),(266,27),(267,27),(268,27),(269,27),(270,27),(271,1),(272,2),(273,3),(274,25),(275,28),(276,28),(277,28),(278,28),(279,28),(280,28),(281,28),(282,1),(283,2),(284,3),(285,25),(286,29),(287,29),(288,29),(289,29),(290,29),(291,29),(292,29),(293,1),(294,2),(295,3),(296,25),(297,30),(298,30),(299,30),(300,30),(301,30),(302,30),(303,30),(304,1),(305,2),(306,3),(307,25),(308,31),(309,31),(310,31),(311,31),(312,31),(313,31),(314,31),(315,1),(316,2),(317,3),(318,25),(319,32),(320,32),(321,32),(322,32),(323,32),(324,32),(325,32),(326,1),(327,2),(328,3),(329,25),(330,33),(331,33),(332,33),(333,33),(334,33),(335,33),(336,33),(337,1),(338,2),(339,3),(340,25),(341,34),(342,34),(343,34),(344,34),(345,34),(346,34),(347,34),(348,1),(349,2),(350,3),(351,25),(352,35),(353,35),(354,35),(355,35),(356,35),(357,35),(358,35),(359,1),(360,2),(361,3),(362,25),(363,36),(364,36),(365,36),(366,36),(367,36),(368,36),(369,36),(370,1),(371,2),(372,3),(373,37),(374,37),(375,37),(376,37),(377,37),(378,37),(379,37),(380,1),(381,2),(382,3),(383,37),(384,38),(385,38),(386,38),(387,38),(388,38),(389,38),(390,38),(391,1),(392,2),(393,3),(394,37),(395,39),(396,39),(397,39),(398,39),(399,39),(400,39),(401,39),(402,1),(403,2),(404,3),(405,37),(406,40),(407,40),(408,40),(409,40),(410,40),(411,40),(412,40),(413,1),(414,2),(415,3),(416,37),(417,41),(418,41),(419,41),(420,41),(421,41),(422,41),(423,41),(424,1),(425,2),(426,3),(427,37),(428,42),(429,42),(430,42),(431,42),(432,42),(433,42),(434,42),(435,1),(436,2),(437,3),(438,37),(439,43),(440,43),(441,43),(442,43),(443,43),(444,43),(445,43),(446,1),(447,2),(448,3),(449,37),(450,44),(451,44),(452,44),(453,44),(454,44),(455,44),(456,44),(457,1),(458,2),(459,3),(460,37),(461,45),(462,45),(463,45),(464,45),(465,45),(466,45),(467,45),(468,1),(469,2),(470,3),(471,46),(472,46),(473,46),(474,46),(475,46),(476,46),(477,46),(478,1),(479,2),(480,3),(481,46),(482,47),(483,47),(484,47),(485,47),(486,47),(487,47),(488,47),(489,1),(490,2),(491,3),(492,46),(493,48),(494,48),(495,48),(496,48),(497,48),(498,48),(499,48),(500,1),(501,2),(502,3),(503,46),(504,49),(505,49),(506,49),(507,49),(508,49),(509,49),(510,49),(511,1),(512,2),(513,3),(514,46),(515,50),(516,50),(517,50),(518,50),(519,50),(520,50),(521,50),(522,1),(523,2),(524,3),(525,51),(526,51),(527,51),(528,51),(529,51),(530,51),(531,51),(532,1),(533,2),(534,3),(535,51),(536,52),(537,52),(538,52),(539,52),(540,52),(541,52),(542,52),(543,1),(544,2),(545,3),(546,51),(547,53),(548,53),(549,53),(550,53),(551,53),(552,53),(553,53),(554,1),(555,2),(556,3),(557,54),(558,54),(559,54),(560,54),(561,54),(562,54),(563,54),(564,1),(565,2),(566,3),(567,54),(568,55),(569,55),(570,55),(571,55),(572,55),(573,55),(574,55),(575,1),(576,2),(577,3),(578,54),(579,56),(580,56),(581,56),(582,56),(583,56),(584,56),(585,56),(586,1),(587,2),(588,3),(589,57),(590,57),(591,57),(592,57),(593,57),(594,57),(595,57),(596,57),(597,1),(598,2),(599,3),(600,57),(601,58),(602,58),(603,58),(604,58),(605,58),(606,58),(607,58),(608,1),(609,2),(610,3),(611,57),(612,59),(613,59),(614,59),(615,59),(616,59),(617,59),(618,59),(619,1),(620,2),(621,3),(622,57),(623,60),(624,60),(625,60),(626,60),(627,60),(628,60),(629,60),(630,1),(631,2),(632,3),(633,57),(634,61),(635,61),(636,61),(637,61),(638,61),(639,61),(640,61),(641,1),(642,2),(643,3),(644,62),(645,62),(646,62),(647,62),(648,62),(649,62),(650,62),(651,1),(652,2),(653,3),(654,62),(655,63),(656,63),(657,63),(658,63),(659,63),(660,63),(661,63),(662,1),(663,2),(664,3),(665,62),(666,64),(667,64),(668,64),(669,64),(670,64),(671,64),(672,64),(673,1),(674,2),(675,3),(676,62),(677,65),(678,65),(679,65),(680,65),(681,65),(682,65),(683,65),(684,4),(685,1),(686,2),(687,4),(688,66),(689,66),(690,66),(691,66),(692,66),(693,66),(694,66),(695,1),(696,2),(697,4),(698,66),(699,67),(700,67),(701,67),(702,67),(703,67),(704,67),(705,67),(706,1),(707,2),(708,4),(709,66),(710,68),(711,68),(712,68),(713,68),(714,68),(715,68),(716,68),(717,1),(718,2),(719,4),(720,66),(721,69),(722,69),(723,69),(724,69),(725,69),(726,69),(727,69),(728,1),(729,2),(730,4),(731,66),(732,70),(733,70),(734,70),(735,70),(736,70),(737,70),(738,70),(739,1),(740,2),(741,4),(742,71),(743,71),(744,71),(745,71),(746,71),(747,71),(748,71),(749,1),(750,2),(751,4),(752,71),(753,72),(754,72),(755,72),(756,72),(757,72),(758,72),(759,72),(760,1),(761,2),(762,4),(763,71),(764,73),(765,73),(766,73),(767,73),(768,73),(769,73),(770,73),(771,1),(772,2),(773,4),(774,71),(775,74),(776,74),(777,74),(778,74),(779,74),(780,74),(781,74),(782,1),(783,2),(784,4),(785,71),(786,75),(787,75),(788,75),(789,75),(790,75),(791,75),(792,75),(793,1),(794,2),(795,4),(796,71),(797,76),(798,76),(799,76),(800,76),(801,76),(802,76),(803,76),(804,1),(805,2),(806,4),(807,71),(808,77),(809,77),(810,77),(811,77),(812,77),(813,77),(814,77),(815,1),(816,2),(817,4),(818,71),(819,78),(820,78),(821,78),(822,78),(823,78),(824,78),(825,78),(826,1),(827,2),(828,4),(829,71),(830,79),(831,79),(832,79),(833,79),(834,79),(835,79),(836,79),(837,1),(838,2),(839,4),(840,71),(841,80),(842,80),(843,80),(844,80),(845,80),(846,80),(847,80),(848,1),(849,2),(850,4),(851,71),(852,81),(853,81),(854,81),(855,81),(856,81),(857,81),(858,81),(859,1),(860,2),(861,4),(862,82),(863,82),(864,82),(865,82),(866,82),(867,82),(868,82),(869,1),(870,2),(871,4),(872,82),(873,83),(874,83),(875,83),(876,83),(877,83),(878,83),(879,83),(880,1),(881,2),(882,4),(883,82),(884,84),(885,84),(886,84),(887,84),(888,84),(889,84),(890,84),(891,1),(892,2),(893,4),(894,82),(895,85),(896,85),(897,85),(898,85),(899,85),(900,85),(901,85),(902,1),(903,2),(904,4),(905,82),(906,86),(907,86),(908,86),(909,86),(910,86),(911,86),(912,86),(913,5),(914,1),(915,2),(916,5),(917,87),(918,87),(919,87),(920,87),(921,87),(922,87),(923,87),(924,1),(925,2),(926,5),(927,87),(928,88),(929,88),(930,88),(931,88),(932,88),(933,88),(934,88),(935,1),(936,2),(937,5),(938,87),(939,89),(940,89),(941,89),(942,89),(943,89),(944,89),(945,89),(946,1),(947,2),(948,5),(949,87),(950,90),(951,90),(952,90),(953,90),(954,90),(955,90),(956,90),(957,1),(958,2),(959,5),(960,87),(961,91),(962,91),(963,91),(964,91),(965,91),(966,91),(967,91),(968,1),(969,2),(970,5),(971,87),(972,92),(973,92),(974,92),(975,92),(976,92),(977,92),(978,92),(979,1),(980,2),(981,5),(982,87),(983,93),(984,93),(985,93),(986,93),(987,93),(988,93),(989,93),(990,1),(991,2),(992,5),(993,87),(994,94),(995,94),(996,94),(997,94),(998,94),(999,94),(1000,94),(1001,1),(1002,2),(1003,5),(1004,87),(1005,95),(1006,95),(1007,95),(1008,95),(1009,95),(1010,95),(1011,95),(1012,1),(1013,2),(1014,5),(1015,96),(1016,96),(1017,96),(1018,96),(1019,96),(1020,96),(1021,96),(1022,1),(1023,2),(1024,5),(1025,96),(1026,97),(1027,97),(1028,97),(1029,97),(1030,97),(1031,97),(1032,97),(1033,97),(1034,1),(1035,2),(1036,5),(1037,98),(1038,98),(1039,98),(1040,98),(1041,98),(1042,98),(1043,98),(1044,1),(1045,2),(1046,5),(1047,98),(1048,99),(1049,99),(1050,99),(1051,99),(1052,99),(1053,99),(1054,99),(1055,1),(1056,2),(1057,5),(1058,100),(1059,100),(1060,100),(1061,100),(1062,100),(1063,100),(1064,100),(1065,1),(1066,2),(1067,5),(1068,100),(1069,101),(1070,101),(1071,101),(1072,101),(1073,101),(1074,101),(1075,101),(1076,1),(1077,2),(1078,5),(1079,100),(1080,102),(1081,102),(1082,102),(1083,102),(1084,102),(1085,102),(1086,102),(1087,1),(1088,2),(1089,5),(1090,100),(1091,103),(1092,103),(1093,103),(1094,103),(1095,103),(1096,103),(1097,103),(1098,1),(1099,2),(1100,5),(1101,100),(1102,104),(1103,104),(1104,104),(1105,104),(1106,104),(1107,104),(1108,104),(1109,1),(1110,2),(1111,5),(1112,100),(1113,105),(1114,105),(1115,105),(1116,105),(1117,105),(1118,105),(1119,105),(1120,1),(1121,2),(1122,5),(1123,106),(1124,106),(1125,106),(1126,106),(1127,106),(1128,106),(1129,106),(1130,1),(1131,2),(1132,5),(1133,106),(1134,107),(1135,107),(1136,107),(1137,107),(1138,107),(1139,107),(1140,107),(1141,1),(1142,2),(1143,5),(1144,106),(1145,108),(1146,108),(1147,108),(1148,108),(1149,108),(1150,108),(1151,108),(1152,1),(1153,2),(1154,5),(1155,106),(1156,109),(1157,109),(1158,109),(1159,109),(1160,109),(1161,109),(1162,109),(1163,1),(1164,2),(1165,5),(1166,106),(1167,110),(1168,110),(1169,110),(1170,110),(1171,110),(1172,110),(1173,110),(1174,37),(1175,6),(1176,1),(1177,2),(1178,6),(1179,111),(1180,111),(1181,111),(1182,111),(1183,111),(1184,111),(1185,111),(1186,1),(1187,2),(1188,6),(1189,111),(1190,112),(1191,112),(1192,112),(1193,112),(1194,112),(1195,112),(1196,112),(1197,1),(1198,2),(1199,6),(1200,111),(1201,113),(1202,113),(1203,113),(1204,113),(1205,113),(1206,113),(1207,113),(1208,1),(1209,2),(1210,6),(1211,111),(1212,114),(1213,114),(1214,114),(1215,114),(1216,114),(1217,114),(1218,114),(1219,1),(1220,2),(1221,6),(1222,111),(1223,115),(1224,115),(1225,115),(1226,115),(1227,115),(1228,115),(1229,115),(1230,1),(1231,2),(1232,6),(1233,111),(1234,116),(1235,116),(1236,116),(1237,116),(1238,116),(1239,116),(1240,116),(1241,1),(1242,2),(1243,6),(1244,111),(1245,117),(1246,117),(1247,117),(1248,117),(1249,117),(1250,117),(1251,117),(1252,1),(1253,2),(1254,6),(1255,111),(1256,118),(1257,118),(1258,118),(1259,118),(1260,118),(1261,118),(1262,118),(1263,1),(1264,2),(1265,6),(1266,111),(1267,119),(1268,119),(1269,119),(1270,119),(1271,119),(1272,119),(1273,119),(1274,1),(1275,2),(1276,6),(1277,111),(1278,120),(1279,120),(1280,120),(1281,120),(1282,120),(1283,120),(1284,120),(1285,1),(1286,2),(1287,6),(1288,111),(1289,121),(1290,121),(1291,121),(1292,121),(1293,121),(1294,121),(1295,121),(1296,1),(1297,2),(1298,6),(1299,111),(1300,122),(1301,122),(1302,122),(1303,122),(1304,122),(1305,122),(1306,122),(1307,1),(1308,2),(1309,6),(1310,111),(1311,123),(1312,123),(1313,123),(1314,123),(1315,123),(1316,123),(1317,123),(1318,1),(1319,2),(1320,6),(1321,124),(1322,124),(1323,124),(1324,124),(1325,124),(1326,124),(1327,124),(1328,1),(1329,2),(1330,6),(1331,124),(1332,125),(1333,125),(1334,125),(1335,125),(1336,125),(1337,125),(1338,125),(1339,1),(1340,2),(1341,6),(1342,124),(1343,126),(1344,126),(1345,126),(1346,126),(1347,126),(1348,126),(1349,126),(1350,1),(1351,2),(1352,6),(1353,124),(1354,127),(1355,127),(1356,127),(1357,127),(1358,127),(1359,127),(1360,127),(1361,1),(1362,2),(1363,6),(1364,124),(1365,128),(1366,128),(1367,128),(1368,128),(1369,128),(1370,128),(1371,128),(1372,1),(1373,2),(1374,6),(1375,129),(1376,129),(1377,129),(1378,129),(1379,129),(1380,129),(1381,129),(1382,1),(1383,2),(1384,6),(1385,129),(1386,130),(1387,130),(1388,130),(1389,130),(1390,130),(1391,130),(1392,130),(1393,1),(1394,2),(1395,6),(1396,129),(1397,131),(1398,131),(1399,131),(1400,131),(1401,131),(1402,131),(1403,131),(1404,1),(1405,2),(1406,6),(1407,129),(1408,132),(1409,132),(1410,132),(1411,132),(1412,132),(1413,132),(1414,132),(1415,1),(1416,2),(1417,6),(1418,129),(1419,133),(1420,133),(1421,133),(1422,133),(1423,133),(1424,133),(1425,133),(1426,1),(1427,2),(1428,6),(1429,134),(1430,134),(1431,134),(1432,134),(1433,134),(1434,134),(1435,134),(1436,7),(1437,1),(1438,2),(1439,7),(1440,135),(1441,135),(1442,135),(1443,135),(1444,135),(1445,135),(1446,135),(1447,1),(1448,2),(1449,7),(1450,135),(1451,136),(1452,136),(1453,136),(1454,136),(1455,136),(1456,136),(1457,136),(1458,1),(1459,2),(1460,7),(1461,135),(1462,137),(1463,137),(1464,137),(1465,137),(1466,137),(1467,137),(1468,137),(1469,1),(1470,2),(1471,7),(1472,135),(1473,138),(1474,138),(1475,138),(1476,138),(1477,138),(1478,138),(1479,138),(1480,1),(1481,2),(1482,7),(1483,135),(1484,139),(1485,139),(1486,139),(1487,139),(1488,139),(1489,139),(1490,139),(1491,1),(1492,2),(1493,7),(1494,135),(1495,140),(1496,140),(1497,140),(1498,140),(1499,140),(1500,140),(1501,140),(1502,1),(1503,2),(1504,7),(1505,135),(1506,141),(1507,141),(1508,141),(1509,141),(1510,141),(1511,141),(1512,141),(1513,1),(1514,2),(1515,7),(1516,142),(1517,142),(1518,142),(1519,142),(1520,142),(1521,142),(1522,142),(1523,1),(1524,2),(1525,7),(1526,142),(1527,143),(1528,143),(1529,143),(1530,143),(1531,143),(1532,143),(1533,143),(1534,1),(1535,2),(1536,7),(1537,142),(1538,144),(1539,144),(1540,144),(1541,144),(1542,144),(1543,144),(1544,144),(1545,8),(1546,1),(1547,2),(1548,8),(1549,145),(1550,145),(1551,145),(1552,145),(1553,145),(1554,145),(1555,145),(1556,1),(1557,2),(1558,8),(1559,145),(1560,146),(1561,146),(1562,146),(1563,146),(1564,146),(1565,146),(1566,146),(1567,1),(1568,2),(1569,8),(1570,145),(1571,147),(1572,147),(1573,147),(1574,147),(1575,147),(1576,147),(1577,147),(1578,1),(1579,2),(1580,8),(1581,145),(1582,148),(1583,148),(1584,148),(1585,148),(1586,148),(1587,148),(1588,148),(1589,1),(1590,2),(1591,8),(1592,145),(1593,149),(1594,149),(1595,149),(1596,149),(1597,149),(1598,149),(1599,149),(1600,1),(1601,2),(1602,8),(1603,150),(1604,150),(1605,150),(1606,150),(1607,150),(1608,150),(1609,150),(1610,1),(1611,2),(1612,8),(1613,150),(1614,151),(1615,151),(1616,151),(1617,151),(1618,151),(1619,151),(1620,151),(1621,1),(1622,2),(1623,8),(1624,150),(1625,152),(1626,152),(1627,152),(1628,152),(1629,152),(1630,152),(1631,152),(1632,1),(1633,2),(1634,8),(1635,150),(1636,152),(1637,153),(1638,153),(1639,153),(1640,153),(1641,153),(1642,153),(1643,153),(1644,1),(1645,2),(1646,8),(1647,150),(1648,152),(1649,154),(1650,154),(1651,154),(1652,154),(1653,154),(1654,154),(1655,154),(1656,154),(1657,1),(1658,2),(1659,8),(1660,150),(1661,152),(1662,155),(1663,155),(1664,155),(1665,155),(1666,155),(1667,155),(1668,155),(1669,1),(1670,2),(1671,8),(1672,150),(1673,152),(1674,156),(1675,156),(1676,156),(1677,156),(1678,156),(1679,156),(1680,156),(1681,1),(1682,2),(1683,8),(1684,150),(1685,152),(1686,157),(1687,157),(1688,157),(1689,157),(1690,157),(1691,157),(1692,157),(1693,1),(1694,2),(1695,8),(1696,150),(1697,152),(1698,158),(1699,158),(1700,158),(1701,158),(1702,158),(1703,158),(1704,158),(1705,1),(1706,2),(1707,8),(1708,150),(1709,159),(1710,159),(1711,159),(1712,159),(1713,159),(1714,159),(1715,159),(1716,1),(1717,2),(1718,8),(1719,150),(1720,159),(1721,160),(1722,160),(1723,160),(1724,160),(1725,160),(1726,160),(1727,160),(1728,1),(1729,2),(1730,8),(1731,150),(1732,159),(1733,161),(1734,161),(1735,161),(1736,161),(1737,161),(1738,161),(1739,161),(1740,1),(1741,2),(1742,8),(1743,150),(1744,159),(1745,162),(1746,162),(1747,162),(1748,162),(1749,162),(1750,162),(1751,162),(1752,9),(1753,1),(1754,2),(1755,163),(1756,163),(1757,163),(1758,163),(1759,163),(1760,163),(1761,163),(1762,163),(1763,1),(1764,2),(1765,164),(1766,164),(1767,164),(1768,164),(1769,164),(1770,164),(1771,164),(1772,16),(1773,17),(1774,18),(1775,10),(1776,11),(1777,12),(1778,13),(1779,13),(1780,13),(1781,164),(1782,164),(1783,163),(1784,1),(1785,2),(1786,1),(1787,2),(1788,13),(1789,14),(1790,13),(1791,25),(1792,46),(1793,51),(1794,54),(1795,62),(1796,21),(1797,22),(1798,23),(1799,24),(1800,26),(1801,27),(1802,28),(1803,29),(1804,30),(1805,31),(1806,2),(1807,2),(1808,2),(1809,2),(1810,32),(1811,33),(1812,34),(1813,35),(1814,36),(1815,38),(1816,37),(1817,37),(1818,3),(1819,39),(1820,40),(1821,41),(1822,42),(1823,43),(1824,44),(1825,45),(1826,47),(1827,48),(1828,49),(1829,50),(1830,52),(1831,53),(1832,58),(1833,59),(1834,60),(1835,61),(1836,55),(1837,56),(1838,71),(1839,72),(1840,73),(1841,74),(1842,75),(1843,76),(1844,77),(1845,78),(1846,79),(1847,80),(1848,81),(1849,83),(1850,84),(1851,85),(1852,86),(1853,67),(1854,68),(1855,69),(1856,70),(1857,87),(1858,88),(1859,89),(1860,90),(1861,91),(1862,92),(1863,94),(1864,95),(1865,93),(1866,96),(1867,98),(1868,99),(1869,100),(1870,101),(1871,102),(1872,103),(1873,104),(1874,105),(1875,106),(1876,110),(1877,108),(1878,107),(1879,111),(1880,112),(1881,113),(1882,114),(1883,115),(1884,116),(1885,117),(1886,118),(1887,123),(1888,121),(1889,122),(1890,120),(1891,119),(1892,124),(1893,125),(1894,126),(1895,127),(1896,128),(1897,129),(1898,130),(1899,131),(1900,132),(1901,133),(1902,134),(1903,135),(1904,140),(1905,141),(1906,139),(1907,138),(1908,137),(1909,142),(1910,143),(1911,144),(1912,136),(1913,145),(1914,146),(1915,147),(1916,149),(1917,151),(1918,152),(1919,153),(1920,155),(1921,156),(1922,157),(1923,158),(1924,159),(1925,162),(1926,161),(1927,160),(1928,150),(1929,1),(1930,2),(1931,9),(1932,165),(1933,165),(1934,165),(1935,165),(1936,165),(1937,165),(1938,165),(1939,1),(1940,2),(1941,9),(1942,165),(1943,166),(1944,166),(1945,166),(1946,166),(1947,166),(1948,166),(1949,166),(1950,166),(1951,1),(1952,2),(1953,9),(1954,165),(1955,167),(1956,167),(1957,167),(1958,167),(1959,167),(1960,167),(1961,167),(1962,1),(1963,2),(1964,9),(1965,165),(1966,168),(1967,168),(1968,168),(1969,168),(1970,168),(1971,168),(1972,168),(1973,1),(1974,2),(1975,9),(1976,169),(1977,169),(1978,169),(1979,169),(1980,169),(1981,169),(1982,169),(1983,1),(1984,2),(1985,9),(1986,169),(1987,170),(1988,170),(1989,170),(1990,170),(1991,170),(1992,170),(1993,170),(1994,9),(1995,165),(1996,1),(1997,2),(1998,9),(1999,169),(2000,170),(2001,171),(2002,171),(2003,171),(2004,171),(2005,171),(2006,171),(2007,171),(2008,1),(2009,2),(2010,9),(2011,169),(2012,170),(2013,172),(2014,172),(2015,172),(2016,172),(2017,172),(2018,172),(2019,172),(2020,1),(2021,2),(2022,9),(2023,169),(2024,170),(2025,173),(2026,173),(2027,173),(2028,173),(2029,173),(2030,173),(2031,173),(2032,1),(2033,2),(2034,9),(2035,169),(2036,170),(2037,174),(2038,174),(2039,174),(2040,174),(2041,174),(2042,174),(2043,174),(2044,167),(2045,1),(2046,2),(2047,9),(2048,169),(2049,175),(2050,175),(2051,175),(2052,175),(2053,175),(2054,175),(2055,175),(2056,1),(2057,2),(2058,9),(2059,169),(2060,176),(2061,176),(2062,176),(2063,176),(2064,176),(2065,176),(2066,176),(2067,169),(2068,1),(2069,2),(2070,9),(2071,169),(2072,177),(2073,177),(2074,177),(2075,177),(2076,177),(2077,177),(2078,177),(2079,175),(2080,1),(2081,2),(2082,9),(2083,169),(2084,178),(2085,178),(2086,178),(2087,178),(2088,178),(2089,178),(2090,178),(2091,1),(2092,2),(2093,9),(2094,169),(2095,179),(2096,179),(2097,179),(2098,179),(2099,179),(2100,179),(2101,179),(2102,176),(2103,177),(2104,1),(2105,2),(2106,9),(2107,169),(2108,180),(2109,180),(2110,180),(2111,180),(2112,180),(2113,180),(2114,180),(2115,1),(2116,2),(2117,9),(2118,169),(2119,181),(2120,181),(2121,181),(2122,181),(2123,181),(2124,181),(2125,181),(2126,178),(2127,179),(2128,180),(2129,181),(2130,171),(2131,172),(2132,173),(2133,174),(2134,1),(2135,2),(2136,10),(2137,182),(2138,182),(2139,182),(2140,182),(2141,182),(2142,182),(2143,182),(2144,1),(2145,2),(2146,10),(2147,182),(2148,183),(2149,183),(2150,183),(2151,183),(2152,183),(2153,183),(2154,183),(2155,1),(2156,2),(2157,10),(2158,182),(2159,184),(2160,184),(2161,184),(2162,184),(2163,184),(2164,184),(2165,184),(2166,1),(2167,2),(2168,10),(2169,182),(2170,185),(2171,185),(2172,185),(2173,185),(2174,185),(2175,185),(2176,185),(2177,182),(2178,183),(2179,184),(2180,1),(2181,2),(2182,10),(2183,182),(2184,186),(2185,186),(2186,186),(2187,186),(2188,186),(2189,186),(2190,186),(2191,185),(2192,1),(2193,2),(2194,10),(2195,182),(2196,187),(2197,187),(2198,187),(2199,187),(2200,187),(2201,187),(2202,187),(2203,186),(2204,1),(2205,2),(2206,10),(2207,182),(2208,188),(2209,188),(2210,188),(2211,188),(2212,188),(2213,188),(2214,188),(2215,1),(2216,2),(2217,10),(2218,182),(2219,189),(2220,189),(2221,189),(2222,189),(2223,189),(2224,189),(2225,189),(2226,1),(2227,2),(2228,10),(2229,182),(2230,190),(2231,190),(2232,190),(2233,190),(2234,190),(2235,190),(2236,190),(2237,1),(2238,2),(2239,10),(2240,191),(2241,191),(2242,191),(2243,191),(2244,191),(2245,191),(2246,191),(2247,1),(2248,2),(2249,10),(2250,191),(2251,192),(2252,192),(2253,192),(2254,192),(2255,192),(2256,192),(2257,192),(2258,1),(2259,2),(2260,10),(2261,191),(2262,193),(2263,193),(2264,193),(2265,193),(2266,193),(2267,193),(2268,193),(2269,1),(2270,2),(2271,10),(2272,194),(2273,194),(2274,194),(2275,194),(2276,194),(2277,194),(2278,194),(2279,1),(2280,2),(2281,10),(2282,194),(2283,195),(2284,195),(2285,195),(2286,195),(2287,195),(2288,195),(2289,195),(2290,1),(2291,2),(2292,10),(2293,194),(2294,196),(2295,196),(2296,196),(2297,196),(2298,196),(2299,196),(2300,196),(2301,187),(2302,1),(2303,2),(2304,10),(2305,194),(2306,197),(2307,197),(2308,197),(2309,197),(2310,197),(2311,197),(2312,197),(2313,189),(2314,190),(2315,188),(2316,191),(2317,192),(2318,193),(2319,194),(2320,195),(2321,196),(2322,197),(2323,130),(2324,130),(2325,130),(2326,3),(2327,20),(2328,20),(2329,20),(2330,20),(2331,21),(2332,21),(2333,21),(2334,23),(2335,23),(2336,23),(2337,1),(2338,2),(2339,3),(2340,15),(2341,198),(2342,198),(2343,198),(2344,198),(2345,198),(2346,198),(2347,198),(2348,198),(2349,1),(2350,2),(2351,3),(2352,15),(2353,199),(2354,199),(2355,199),(2356,199),(2357,199),(2358,199),(2359,199),(2360,199),(2361,199),(2362,1),(2363,2),(2364,3),(2365,15),(2366,200),(2367,200),(2368,200),(2369,200),(2370,200),(2371,200),(2372,200),(2373,200),(2374,1),(2375,2),(2376,3),(2377,15),(2378,201),(2379,201),(2380,201),(2381,201),(2382,201),(2383,201),(2384,201),(2385,201),(2386,1),(2387,2),(2388,3),(2389,15),(2390,202),(2391,202),(2392,202),(2393,202),(2394,202),(2395,202),(2396,202),(2397,202),(2398,1),(2399,2),(2400,3),(2401,203),(2402,203),(2403,203),(2404,203),(2405,203),(2406,203),(2407,203),(2408,203),(2409,1),(2410,2),(2411,3),(2412,1),(2413,2),(2414,3),(2415,25),(2416,37),(2417,46),(2418,51),(2419,54),(2420,57),(2421,62),(2422,203),(2423,203),(2424,1),(2425,2),(2426,3),(2427,203),(2428,204),(2429,204),(2430,204),(2431,204),(2432,204),(2433,204),(2434,204),(2435,204),(2436,1),(2437,2),(2438,3),(2439,203),(2440,205),(2441,205),(2442,205),(2443,205),(2444,205),(2445,205),(2446,205),(2447,205),(2448,1),(2449,2),(2450,3),(2451,203),(2452,206),(2453,206),(2454,206),(2455,206),(2456,206),(2457,206),(2458,206),(2459,206),(2460,1),(2461,2),(2462,3),(2463,203),(2464,207),(2465,207),(2466,207),(2467,207),(2468,207),(2469,207),(2470,207),(2471,207),(2472,207),(2473,1),(2474,2),(2475,3),(2476,203),(2477,208),(2478,208),(2479,208),(2480,208),(2481,208),(2482,208),(2483,208),(2484,208),(2485,1),(2486,2),(2487,3),(2488,15),(2489,1),(2490,2),(2491,3),(2492,15),(2493,18),(2494,20),(2495,21),(2496,22),(2497,23),(2498,24),(2499,198),(2500,199),(2501,200),(2502,201),(2503,202),(2504,16),(2505,17),(2506,18),(2507,20),(2508,21),(2509,22),(2510,23),(2511,24),(2512,198),(2513,199),(2514,200),(2515,201),(2516,202),(2517,17),(2518,1),(2519,2),(2520,3),(2521,15),(2522,1),(2523,2),(2524,3),(2525,15),(2526,199),(2527,200),(2528,201),(2529,202),(2530,18),(2531,20),(2532,21),(2533,22),(2534,23),(2535,24),(2536,198),(2537,199),(2538,200),(2539,201),(2540,202),(2541,198),(2542,1),(2543,2),(2544,3),(2545,15),(2546,1),(2547,2),(2548,3),(2549,15),(2550,200),(2551,201),(2552,202),(2553,18),(2554,20),(2555,21),(2556,22),(2557,23),(2558,24),(2559,199),(2560,200),(2561,201),(2562,202),(2563,199),(2564,1),(2565,2),(2566,3),(2567,15),(2568,1),(2569,2),(2570,3),(2571,15),(2572,20),(2573,21),(2574,22),(2575,23),(2576,24),(2577,200),(2578,201),(2579,202),(2580,18),(2581,20),(2582,21),(2583,22),(2584,23),(2585,24),(2586,199),(2587,200),(2588,201),(2589,202),(2590,18),(2591,1),(2592,2),(2593,3),(2594,15),(2595,1),(2596,2),(2597,3),(2598,15),(2599,201),(2600,202),(2601,20),(2602,21),(2603,22),(2604,23),(2605,24),(2606,200),(2607,201),(2608,202),(2609,200),(2610,1),(2611,2),(2612,3),(2613,15),(2614,1),(2615,2),(2616,3),(2617,15),(2618,202),(2619,20),(2620,21),(2621,22),(2622,23),(2623,24),(2624,201),(2625,202),(2626,201),(2627,1),(2628,2),(2629,3),(2630,15),(2631,1),(2632,2),(2633,3),(2634,15),(2635,20),(2636,21),(2637,22),(2638,23),(2639,24),(2640,202),(2641,202),(2642,1),(2643,2),(2644,3),(2645,15),(2646,1),(2647,2),(2648,3),(2649,15),(2650,23),(2651,24),(2652,20),(2653,21),(2654,22),(2655,23),(2656,24),(2657,22),(2658,1),(2659,2),(2660,3),(2661,15),(2662,1),(2663,2),(2664,3),(2665,15),(2666,20),(2667,21),(2668,23),(2669,24),(2670,24),(2671,1),(2672,2),(2673,3),(2674,209),(2675,209),(2676,209),(2677,209),(2678,209),(2679,209),(2680,209),(2681,209),(2682,1),(2683,2),(2684,3),(2685,1),(2686,2),(2687,3),(2688,25),(2689,37),(2690,46),(2691,51),(2692,54),(2693,57),(2694,62),(2695,209),(2696,209),(2697,1),(2698,2),(2699,3),(2700,209),(2701,210),(2702,210),(2703,210),(2704,210),(2705,210),(2706,210),(2707,210),(2708,210),(2709,1),(2710,2),(2711,3),(2712,209),(2713,211),(2714,211),(2715,211),(2716,211),(2717,211),(2718,211),(2719,211),(2720,211),(2721,1),(2722,2),(2723,3),(2724,209),(2725,212),(2726,212),(2727,212),(2728,212),(2729,212),(2730,212),(2731,212),(2732,212),(2733,1),(2734,2),(2735,3),(2736,209),(2737,213),(2738,213),(2739,213),(2740,213),(2741,213),(2742,213),(2743,213),(2744,213),(2745,1),(2746,2),(2747,3),(2748,209),(2749,214),(2750,214),(2751,214),(2752,214),(2753,214),(2754,214),(2755,214),(2756,214),(2757,1),(2758,2),(2759,3),(2760,209),(2761,215),(2762,215),(2763,215),(2764,215),(2765,215),(2766,215),(2767,215),(2768,215),(2769,1),(2770,2),(2771,3),(2772,209),(2773,216),(2774,216),(2775,216),(2776,216),(2777,216),(2778,216),(2779,216),(2780,216),(2781,1),(2782,2),(2783,3),(2784,1),(2785,2),(2786,3),(2787,15),(2788,25),(2789,37),(2790,46),(2791,51),(2792,54),(2793,57),(2794,62),(2795,209),(2796,16),(2797,17),(2798,18),(2799,20),(2800,21),(2801,22),(2802,23),(2803,24),(2804,198),(2805,199),(2806,200),(2807,201),(2808,202),(2809,204),(2810,205),(2811,206),(2812,207),(2813,208),(2814,203),(2815,1),(2816,2),(2817,3),(2818,1),(2819,2),(2820,3),(2821,15),(2822,25),(2823,37),(2824,46),(2825,51),(2826,54),(2827,57),(2828,62),(2829,16),(2830,17),(2831,18),(2832,20),(2833,21),(2834,22),(2835,23),(2836,24),(2837,198),(2838,199),(2839,200),(2840,201),(2841,202),(2842,210),(2843,211),(2844,212),(2845,213),(2846,214),(2847,215),(2848,216),(2849,209),(2850,1),(2851,2),(2852,3),(2853,15),(2854,217),(2855,217),(2856,217),(2857,217),(2858,217),(2859,217),(2860,217),(2861,217),(2862,1),(2863,2),(2864,3),(2865,15),(2866,1),(2867,2),(2868,3),(2869,15),(2870,16),(2871,17),(2872,18),(2873,20),(2874,21),(2875,22),(2876,23),(2877,24),(2878,198),(2879,199),(2880,200),(2881,201),(2882,202),(2883,203),(2884,209),(2885,217),(2886,217),(2887,1),(2888,2),(2889,3),(2890,15),(2891,217),(2892,1),(2893,2),(2894,3),(2895,15),(2896,1),(2897,2),(2898,16),(2899,17),(2900,18),(2901,20),(2902,21),(2903,22),(2904,23),(2905,24),(2906,198),(2907,199),(2908,200),(2909,201),(2910,202),(2911,209),(2912,4),(2913,5),(2914,6),(2915,7),(2916,8),(2917,9),(2918,10),(2919,11),(2920,12),(2921,163),(2922,164),(2923,204),(2924,205),(2925,206),(2926,207),(2927,208),(2928,203),(2929,1),(2930,2),(2931,3),(2932,15),(2933,1),(2934,2),(2935,3),(2936,15),(2937,16),(2938,18),(2939,20),(2940,21),(2941,22),(2942,23),(2943,24),(2944,198),(2945,199),(2946,200),(2947,201),(2948,202),(2949,16),(2950,17),(2951,18),(2952,20),(2953,21),(2954,22),(2955,23),(2956,24),(2957,198),(2958,199),(2959,200),(2960,201),(2961,202),(2962,209),(2963,17),(2964,1),(2965,2),(2966,1),(2967,2),(2968,3),(2969,4),(2970,5),(2971,6),(2972,7),(2973,8),(2974,9),(2975,10),(2976,11),(2977,12),(2978,163),(2979,164),(2980,15),(2981,25),(2982,37),(2983,46),(2984,51),(2985,54),(2986,57),(2987,62),(2988,204),(2989,205),(2990,206),(2991,207),(2992,208),(2993,203),(2994,1),(2995,2),(2996,3),(2997,15),(2998,1),(2999,2),(3000,3),(3001,16),(3002,18),(3003,20),(3004,21),(3005,22),(3006,23),(3007,24),(3008,198),(3009,199),(3010,200),(3011,201),(3012,202),(3013,15),(3014,25),(3015,37),(3016,46),(3017,51),(3018,54),(3019,57),(3020,62),(3021,210),(3022,211),(3023,212),(3024,213),(3025,214),(3026,215),(3027,216),(3028,209),(3040,1),(3041,2),(3042,3),(3043,219),(3044,219),(3045,219),(3046,219),(3047,219),(3048,219),(3049,219),(3050,219),(3051,1),(3052,2),(3053,3),(3054,1),(3055,2),(3056,3),(3057,15),(3058,25),(3059,37),(3060,46),(3061,51),(3062,54),(3063,57),(3064,62),(3065,203),(3066,209),(3067,219),(3068,219),(3069,1),(3070,2),(3071,3),(3072,1),(3073,2),(3074,3),(3075,219),(3076,15),(3077,25),(3078,37),(3079,46),(3080,51),(3081,54),(3082,57),(3083,62),(3084,209),(3085,204),(3086,205),(3087,206),(3088,207),(3089,208),(3090,203),(3091,1),(3092,2),(3093,3),(3094,1),(3095,2),(3096,3),(3097,219),(3098,15),(3099,25),(3100,37),(3101,46),(3102,51),(3103,54),(3104,57),(3105,62),(3106,203),(3107,210),(3108,211),(3109,212),(3110,213),(3111,214),(3112,215),(3113,216),(3114,209),(3115,1),(3116,2),(3117,3),(3118,15),(3119,1),(3120,2),(3121,3),(3122,219),(3123,18),(3124,20),(3125,21),(3126,22),(3127,23),(3128,24),(3129,199),(3130,200),(3131,201),(3132,202),(3133,203),(3134,209),(3135,198),(3136,1),(3137,2),(3138,3),(3139,219),(3140,1),(3141,2),(3142,3),(3143,203),(3144,15),(3145,25),(3146,37),(3147,46),(3148,51),(3149,54),(3150,57),(3151,62),(3152,219),(3153,210),(3154,211),(3155,212),(3156,213),(3157,214),(3158,215),(3159,216),(3160,209),(3161,1),(3162,2),(3163,3),(3164,219),(3165,1),(3166,2),(3167,3),(3168,15),(3169,25),(3170,37),(3171,46),(3172,51),(3173,54),(3174,57),(3175,62),(3176,219),(3177,204),(3178,205),(3179,206),(3180,207),(3181,208),(3182,203),(3183,1),(3184,2),(3185,3),(3186,1),(3187,2),(3188,3),(3189,15),(3190,25),(3191,37),(3192,46),(3193,51),(3194,54),(3195,57),(3196,62),(3197,15),(3198,25),(3199,37),(3200,46),(3201,51),(3202,54),(3203,57),(3204,62),(3205,203),(3206,209),(3207,219),(3208,219),(3209,1),(3210,2),(3211,3),(3212,1),(3213,2),(3214,3),(3215,219),(3216,25),(3217,37),(3218,46),(3219,51),(3220,54),(3221,57),(3222,62),(3223,198),(3224,16),(3225,17),(3226,18),(3227,199),(3228,20),(3229,200),(3230,201),(3231,202),(3232,21),(3233,22),(3234,23),(3235,24),(3236,15),(3237,1),(3238,2),(3239,3),(3240,1),(3241,2),(3242,3),(3243,219),(3244,25),(3245,37),(3246,46),(3247,51),(3248,54),(3249,57),(3250,62),(3251,203),(3252,198),(3253,210),(3254,211),(3255,212),(3256,213),(3257,214),(3258,215),(3259,216),(3260,209),(3261,1),(3262,2),(3263,3),(3264,1),(3265,2),(3266,3),(3267,219),(3268,25),(3269,37),(3270,46),(3271,51),(3272,54),(3273,57),(3274,62),(3275,198),(3276,209),(3277,204),(3278,205),(3279,206),(3280,207),(3281,208),(3282,203),(3283,1),(3284,2),(3285,3),(3286,219),(3287,1),(3288,2),(3289,3),(3290,15),(3291,219),(3292,16),(3293,17),(3294,18),(3295,20),(3296,21),(3297,22),(3298,23),(3299,24),(3300,199),(3301,200),(3302,201),(3303,202),(3304,198),(3305,1),(3306,2),(3307,3),(3308,15),(3309,219),(3310,1),(3311,2),(3312,3),(3313,15),(3314,219),(3315,16),(3316,17),(3317,18),(3318,20),(3319,21),(3320,22),(3321,23),(3322,24),(3323,199),(3324,200),(3325,201),(3326,202),(3327,18),(3328,20),(3329,21),(3330,22),(3331,23),(3332,24),(3333,199),(3334,200),(3335,201),(3336,202),(3337,198),(3349,25),(3350,26),(3351,1),(3352,2),(3353,3),(3354,25),(3355,221),(3356,221),(3357,221),(3358,221),(3359,221),(3360,221),(3361,221),(3362,221),(3363,1),(3364,2),(3365,3),(3366,25),(3367,1),(3368,2),(3369,3),(3370,25),(3371,26),(3372,27),(3373,28),(3374,29),(3375,30),(3376,31),(3377,32),(3378,33),(3379,34),(3380,35),(3381,36),(3382,221),(3383,221),(3384,1),(3385,2),(3386,3),(3387,25),(3388,1),(3389,2),(3390,3),(3391,25),(3392,221),(3393,27),(3394,28),(3395,29),(3396,30),(3397,31),(3398,32),(3399,33),(3400,34),(3401,35),(3402,36),(3403,26),(3404,1),(3405,2),(3406,3),(3407,25),(3408,1),(3409,2),(3410,3),(3411,25),(3412,221),(3413,28),(3414,29),(3415,30),(3416,31),(3417,32),(3418,33),(3419,34),(3420,35),(3421,36),(3422,26),(3423,27),(3424,1),(3425,2),(3426,3),(3427,25),(3428,221),(3429,1),(3430,2),(3431,3),(3432,25),(3433,221),(3434,26),(3435,27),(3436,26),(3437,1),(3438,2),(3439,3),(3440,25),(3441,221),(3442,222),(3443,222),(3444,222),(3445,222),(3446,222),(3447,222),(3448,222),(3449,222),(3450,1),(3451,2),(3452,3),(3453,25),(3454,221),(3455,1),(3456,2),(3457,3),(3458,25),(3459,221),(3460,27),(3461,222),(3462,222),(3463,1),(3464,2),(3465,3),(3466,25),(3467,1),(3468,2),(3469,3),(3470,25),(3471,221),(3472,34),(3473,35),(3474,36),(3475,33),(3476,1),(3477,2),(3478,3),(3479,25),(3480,1),(3481,2),(3482,3),(3483,25),(3484,221),(3485,34),(3486,35),(3487,36),(3488,32),(3489,1),(3490,2),(3491,3),(3492,25),(3493,221),(3494,223),(3495,223),(3496,223),(3497,223),(3498,223),(3499,223),(3500,223),(3501,223),(3502,1),(3503,2),(3504,3),(3505,25),(3506,1),(3507,2),(3508,3),(3509,25),(3510,221),(3511,29),(3512,30),(3513,31),(3514,34),(3515,35),(3516,36),(3517,28),(3518,1),(3519,2),(3520,3),(3521,25),(3522,221),(3523,1),(3524,2),(3525,3),(3526,25),(3527,221),(3528,28),(3529,28),(3530,1),(3531,2),(3532,3),(3533,25),(3534,1),(3535,2),(3536,3),(3537,25),(3538,221),(3539,31),(3540,34),(3541,35),(3542,36),(3543,30),(3544,1),(3545,2),(3546,3),(3547,25),(3548,1),(3549,2),(3550,3),(3551,25),(3552,221),(3553,34),(3554,35),(3555,36),(3556,31),(3557,1),(3558,2),(3559,3),(3560,25),(3561,221),(3562,224),(3563,224),(3564,224),(3565,224),(3566,224),(3567,224),(3568,224),(3569,224),(3570,1),(3571,2),(3572,3),(3573,25),(3574,221),(3575,225),(3576,225),(3577,225),(3578,225),(3579,225),(3580,225),(3581,225),(3582,225),(3583,29),(3584,29),(3585,29),(3586,34),(3587,34),(3588,34),(3589,35),(3590,35),(3591,35),(3592,36),(3593,36),(3594,36),(3595,1),(3596,2),(3597,3),(3598,25),(3599,1),(3600,2),(3601,3),(3602,25),(3603,221),(3604,34),(3605,35),(3606,36),(3607,26),(3608,27),(3609,28),(3610,30),(3611,31),(3612,32),(3613,33),(3614,222),(3615,223),(3616,224),(3617,225),(3618,29),(3619,1),(3620,2),(3621,3),(3622,25),(3623,1),(3624,2),(3625,3),(3626,25),(3627,221),(3628,35),(3629,36),(3630,26),(3631,27),(3632,28),(3633,29),(3634,30),(3635,31),(3636,32),(3637,33),(3638,222),(3639,223),(3640,224),(3641,225),(3642,34),(3643,1),(3644,2),(3645,3),(3646,25),(3647,1),(3648,2),(3649,3),(3650,25),(3651,221),(3652,36),(3653,26),(3654,27),(3655,28),(3656,29),(3657,30),(3658,31),(3659,32),(3660,33),(3661,34),(3662,222),(3663,223),(3664,224),(3665,225),(3666,35),(3667,1),(3668,2),(3669,3),(3670,25),(3671,1),(3672,2),(3673,3),(3674,25),(3675,221),(3676,26),(3677,27),(3678,28),(3679,29),(3680,30),(3681,31),(3682,32),(3683,33),(3684,34),(3685,35),(3686,222),(3687,223),(3688,224),(3689,225),(3690,36),(3691,1),(3692,2),(3693,3),(3694,25),(3695,221),(3696,1),(3697,2),(3698,3),(3699,25),(3700,26),(3701,27),(3702,28),(3703,29),(3704,30),(3705,31),(3706,32),(3707,33),(3708,34),(3709,35),(3710,222),(3711,223),(3712,224),(3713,225),(3714,221),(3715,36),(3716,1),(3717,2),(3718,3),(3719,25),(3720,221),(3721,1),(3722,2),(3723,3),(3724,25),(3725,26),(3726,27),(3727,28),(3728,29),(3729,30),(3730,31),(3731,32),(3732,33),(3733,34),(3734,222),(3735,223),(3736,224),(3737,225),(3738,221),(3739,35),(3740,1),(3741,2),(3742,3),(3743,25),(3744,221),(3745,1),(3746,2),(3747,3),(3748,25),(3749,26),(3750,27),(3751,28),(3752,29),(3753,30),(3754,31),(3755,32),(3756,33),(3757,222),(3758,223),(3759,224),(3760,225),(3761,221),(3762,34),(3763,1),(3764,2),(3765,3),(3766,25),(3767,221),(3768,1),(3769,2),(3770,3),(3771,25),(3772,26),(3773,27),(3774,28),(3775,30),(3776,31),(3777,32),(3778,33),(3779,222),(3780,223),(3781,224),(3782,225),(3783,221),(3784,29),(3785,1),(3786,2),(3787,3),(3788,25),(3789,1),(3790,2),(3791,3),(3792,25),(3793,29),(3794,34),(3795,35),(3796,36),(3797,221),(3798,221),(3799,1),(3800,2),(3801,3),(3802,25),(3803,1),(3804,2),(3805,3),(3806,25),(3807,221),(3808,29),(3809,34),(3810,35),(3811,26),(3812,27),(3813,28),(3814,30),(3815,31),(3816,32),(3817,33),(3818,222),(3819,223),(3820,224),(3821,225),(3822,36),(3823,1),(3824,2),(3825,3),(3826,25),(3827,1),(3828,2),(3829,3),(3830,25),(3831,221),(3832,29),(3833,34),(3834,26),(3835,27),(3836,28),(3837,30),(3838,31),(3839,32),(3840,33),(3841,36),(3842,222),(3843,223),(3844,224),(3845,225),(3846,35),(3847,1),(3848,2),(3849,3),(3850,25),(3851,1),(3852,2),(3853,3),(3854,25),(3855,221),(3856,29),(3857,26),(3858,27),(3859,28),(3860,30),(3861,31),(3862,32),(3863,33),(3864,35),(3865,36),(3866,222),(3867,223),(3868,224),(3869,225),(3870,34),(3871,1),(3872,2),(3873,3),(3874,25),(3875,1),(3876,2),(3877,3),(3878,25),(3879,221),(3880,26),(3881,27),(3882,28),(3883,30),(3884,31),(3885,32),(3886,33),(3887,34),(3888,35),(3889,36),(3890,222),(3891,223),(3892,224),(3893,225),(3894,29),(3895,1),(3896,2),(3897,3),(3898,25),(3899,221),(3900,1),(3901,2),(3902,3),(3903,25),(3904,221),(3905,26),(3906,27),(3907,28),(3908,30),(3909,31),(3910,32),(3911,33),(3912,222),(3913,223),(3914,224),(3915,225),(3916,36),(3917,1),(3918,2),(3919,3),(3920,25),(3921,221),(3922,1),(3923,2),(3924,3),(3925,25),(3926,221),(3927,26),(3928,27),(3929,28),(3930,30),(3931,31),(3932,32),(3933,33),(3934,36),(3935,222),(3936,223),(3937,224),(3938,225),(3939,35),(3940,1),(3941,2),(3942,3),(3943,25),(3944,221),(3945,1),(3946,2),(3947,3),(3948,25),(3949,221),(3950,26),(3951,27),(3952,28),(3953,30),(3954,31),(3955,32),(3956,33),(3957,35),(3958,36),(3959,222),(3960,223),(3961,224),(3962,225),(3963,34),(3964,1),(3965,2),(3966,3),(3967,25),(3968,221),(3969,1),(3970,2),(3971,3),(3972,25),(3973,221),(3974,26),(3975,27),(3976,28),(3977,30),(3978,31),(3979,32),(3980,33),(3981,34),(3982,35),(3983,36),(3984,222),(3985,223),(3986,224),(3987,225),(3988,29),(3989,1),(3990,2),(3991,3),(3992,25),(3993,226),(3994,226),(3995,226),(3996,226),(3997,226),(3998,226),(3999,226),(4000,226),(4016,1),(4017,2),(4018,3),(4019,203),(4020,219),(4021,207),(4022,1),(4023,2),(4024,10),(4025,182),(4026,1),(4027,2),(4028,3),(4029,203),(4030,219),(4031,188),(4032,189),(4033,190),(4034,187),(4060,1),(4061,2),(4062,3),(4063,203),(4064,219),(4065,206),(4066,1),(4067,2),(4068,3),(4069,15),(4070,219),(4071,1),(4072,2),(4073,3),(4074,203),(4075,219),(4076,187),(4077,23),(4078,1),(4079,2),(4080,3),(4081,203),(4082,219),(4083,1),(4084,2),(4085,3),(4086,203),(4087,219),(4088,187),(4089,23),(4090,187),(4091,208),(4092,23),(4093,1),(4094,2),(4095,3),(4096,25),(4097,221),(4098,1),(4099,2),(4100,3),(4101,25),(4102,226),(4103,29),(4104,34),(4105,35),(4106,1),(4107,2),(4108,3),(4109,25),(4110,226),(4111,1),(4112,2),(4113,3),(4114,25),(4115,226),(4116,35),(4117,1),(4118,2),(4119,3),(4120,25),(4121,221),(4122,1),(4123,2),(4124,3),(4125,25),(4126,226),(4127,29),(4128,34),(4129,35),(4130,36),(4131,36),(4132,1),(4133,2),(4134,3),(4135,25),(4136,221),(4137,1),(4138,2),(4139,3),(4140,25),(4141,226),(4142,27),(4143,28),(4144,29),(4145,30),(4146,31),(4147,32),(4148,33),(4149,34),(4150,222),(4151,223),(4152,224),(4153,225),(4154,35),(4155,36),(4156,1),(4157,2),(4158,3),(4159,57),(4160,1),(4161,2),(4162,3),(4163,25),(4164,226),(4165,61),(4166,60),(4167,1),(4168,2),(4169,3),(4170,25),(4171,226),(4172,227),(4173,227),(4174,227),(4175,227),(4176,227),(4177,227),(4178,227),(4179,227),(4180,1),(4181,2),(4182,3),(4183,25),(4184,226),(4185,228),(4186,228),(4187,228),(4188,228),(4189,228),(4190,228),(4191,228),(4192,228),(4193,1),(4194,2),(4195,3),(4196,25),(4197,226),(4198,228),(4199,1),(4200,2),(4201,10),(4202,182),(4203,1),(4204,2),(4205,3),(4206,25),(4207,226),(4208,190),(4209,1),(4210,2),(4211,3),(4212,25),(4213,226),(4214,229),(4215,229),(4216,229),(4217,229),(4218,229),(4219,229),(4220,229),(4221,229),(4222,1),(4223,2),(4224,3),(4225,25),(4226,230),(4227,230),(4228,230),(4229,230),(4230,230),(4231,230),(4232,230),(4233,230),(4234,1),(4235,2),(4236,3),(4237,25),(4238,230),(4239,231),(4240,231),(4241,231),(4242,231),(4243,231),(4244,231),(4245,231),(4246,231),(4247,1),(4248,2),(4249,3),(4250,25),(4251,230),(4252,232),(4253,232),(4254,232),(4255,232),(4256,232),(4257,232),(4258,232),(4259,232),(4260,1),(4261,2),(4262,3),(4263,25),(4264,230),(4265,233),(4266,233),(4267,233),(4268,233),(4269,233),(4270,233),(4271,233),(4272,233),(4273,1),(4274,2),(4275,3),(4276,25),(4277,230),(4278,234),(4279,234),(4280,234),(4281,234),(4282,234),(4283,234),(4284,234),(4285,234),(4286,1),(4287,2),(4288,3),(4289,25),(4290,230),(4291,235),(4292,235),(4293,235),(4294,235),(4295,235),(4296,235),(4297,235),(4298,235),(4299,1),(4300,2),(4301,3),(4302,25),(4303,230),(4304,236),(4305,236),(4306,236),(4307,236),(4308,236),(4309,236),(4310,236),(4311,236),(4312,1),(4313,2),(4314,3),(4315,25),(4316,230),(4317,237),(4318,237),(4319,237),(4320,237),(4321,237),(4322,237),(4323,237),(4324,237),(4325,1),(4326,2),(4327,1),(4328,2),(4329,3),(4330,10),(4331,11),(4332,12),(4333,163),(4334,164),(4335,37),(4336,46),(4337,51),(4338,54),(4339,57),(4340,62),(4341,165),(4342,166),(4343,167),(4344,168),(4345,169),(4346,170),(4347,171),(4348,172),(4349,173),(4350,174),(4351,175),(4352,176),(4353,177),(4354,178),(4355,179),(4356,180),(4357,181),(4358,9),(4359,165),(4360,166),(4361,168),(4362,168),(4363,1),(4364,2),(4365,3),(4366,9),(4367,165),(4368,1),(4369,2),(4370,3),(4371,9),(4372,165),(4373,168),(4374,166),(4375,167),(4376,168),(4377,167),(4378,1),(4379,2),(4380,3),(4381,9),(4382,169),(4383,1),(4384,2),(4385,3),(4386,9),(4387,165),(4388,179),(4389,180),(4390,181),(4391,178),(4392,1),(4393,2),(4394,3),(4395,9),(4396,165),(4397,1),(4398,2),(4399,3),(4400,9),(4401,165),(4402,166),(4403,168),(4404,178),(4405,167),(4406,1),(4407,2),(4408,3),(4409,9),(4410,169),(4411,1),(4412,2),(4413,3),(4414,9),(4415,165),(4416,179),(4417,180),(4418,181),(4419,177),(4420,1),(4421,2),(4422,3),(4423,9),(4424,169),(4425,1),(4426,2),(4427,3),(4428,9),(4429,165),(4430,179),(4431,180),(4432,181),(4433,177),(4434,176),(4435,1),(4436,2),(4437,3),(4438,9),(4439,165),(4440,1),(4441,2),(4442,3),(4443,9),(4444,165),(4445,176),(4446,177),(4447,166),(4448,167),(4449,168),(4450,176),(4451,177),(4452,178),(4453,167),(4454,1),(4455,2),(4456,3),(4457,9),(4458,165),(4459,1),(4460,2),(4461,3),(4462,9),(4463,165),(4464,176),(4465,177),(4466,178),(4467,168),(4468,1),(4469,2),(4470,3),(4471,9),(4472,165),(4473,1),(4474,2),(4475,3),(4476,9),(4477,165),(4478,168),(4479,176),(4480,177),(4481,178),(4482,168),(4483,166),(4484,1),(4485,2),(4486,3),(4487,9),(4488,165),(4489,1),(4490,2),(4491,3),(4492,9),(4493,165),(4494,166),(4495,168),(4496,166),(4497,168),(4498,176),(4499,177),(4500,177),(4501,1),(4502,2),(4503,3),(4504,9),(4505,165),(4506,1),(4507,2),(4508,3),(4509,9),(4510,165),(4511,166),(4512,168),(4513,176),(4514,166),(4515,168),(4516,176),(4517,177),(4518,178),(4519,177),(4520,1),(4521,2),(4522,3),(4523,9),(4524,165),(4525,1),(4526,2),(4527,3),(4528,9),(4529,165),(4530,168),(4531,166),(4532,167),(4533,168),(4534,176),(4535,177),(4536,178),(4537,166),(4538,1),(4539,2),(4540,3),(4541,9),(4542,165),(4543,1),(4544,2),(4545,3),(4546,9),(4547,169),(4548,168),(4549,176),(4550,178),(4551,175),(4552,179),(4553,180),(4554,181),(4555,177),(4556,1),(4557,2),(4558,3),(4559,9),(4560,165),(4561,1),(4562,2),(4563,3),(4564,9),(4565,169),(4566,168),(4567,176),(4568,175),(4569,179),(4570,180),(4571,181),(4572,178),(4573,1),(4574,2),(4575,3),(4576,9),(4577,165),(4578,238),(4579,238),(4580,238),(4581,238),(4582,238),(4583,238),(4584,238),(4585,238),(4586,1),(4587,2),(4588,3),(4589,9),(4590,165),(4591,1),(4592,2),(4593,3),(4594,9),(4595,165),(4596,167),(4597,168),(4598,176),(4599,238),(4600,238),(4601,1),(4602,2),(4603,3),(4604,9),(4605,165),(4606,1),(4607,2),(4608,3),(4609,9),(4610,165),(4611,168),(4612,167),(4613,168),(4614,176),(4615,176),(4616,1),(4617,2),(4618,3),(4619,9),(4620,169),(4621,1),(4622,2),(4623,3),(4624,9),(4625,175),(4626,177),(4627,178),(4628,179),(4629,180),(4630,181),(4631,169),(4632,171),(4633,172),(4634,173),(4635,174),(4636,170),(4637,173),(4638,173),(4639,173),(4640,174),(4641,174),(4642,174),(4643,1),(4644,2),(4645,3),(4646,9),(4647,170),(4648,239),(4649,239),(4650,239),(4651,239),(4652,239),(4653,239),(4654,239),(4655,239),(4656,1),(4657,2),(4658,3),(4659,9),(4660,170),(4661,1),(4662,2),(4663,3),(4664,9),(4665,170),(4666,173),(4667,174),(4668,239),(4669,239),(4670,1),(4671,2),(4672,3),(4673,9),(4674,169),(4675,1),(4676,2),(4677,3),(4678,9),(4679,169),(4680,181),(4681,175),(4682,178),(4683,179),(4684,180),(4685,181),(4686,180),(4687,1),(4688,2),(4689,3),(4690,9),(4691,169),(4692,1),(4693,2),(4694,3),(4695,9),(4696,169),(4697,181),(4698,175),(4699,179),(4700,181),(4701,179),(4702,169),(4703,175),(4704,175),(4705,175),(4706,181),(4707,1),(4708,2),(4709,3),(4710,9),(4711,240),(4712,240),(4713,240),(4714,240),(4715,240),(4716,240),(4717,240),(4718,240),(4719,1),(4720,2),(4721,3),(4722,9),(4723,240),(4724,241),(4725,241),(4726,241),(4727,241),(4728,241),(4729,241),(4730,241),(4731,241),(4732,1),(4733,2),(4734,3),(4735,9),(4736,240),(4737,242),(4738,242),(4739,242),(4740,242),(4741,242),(4742,242),(4743,242),(4744,242),(4745,1),(4746,2),(4747,3),(4748,9),(4749,240),(4750,243),(4751,243),(4752,243),(4753,243),(4754,243),(4755,243),(4756,243),(4757,243),(4758,1),(4759,2),(4760,3),(4761,9),(4762,240),(4763,244),(4764,244),(4765,244),(4766,244),(4767,244),(4768,244),(4769,244),(4770,244),(4771,1),(4772,2),(4773,1),(4774,2),(4775,3),(4776,5),(4777,6),(4778,7),(4779,8),(4780,10),(4781,11),(4782,12),(4783,163),(4784,164),(4785,37),(4786,46),(4787,51),(4788,54),(4789,57),(4790,62),(4791,66),(4792,67),(4793,68),(4794,69),(4795,70),(4796,71),(4797,72),(4798,73),(4799,74),(4800,75),(4801,76),(4802,77),(4803,78),(4804,79),(4805,80),(4806,81),(4807,82),(4808,83),(4809,84),(4810,85),(4811,86),(4812,4),(4813,1),(4814,2),(4815,3),(4816,4),(4817,1),(4818,2),(4819,3),(4820,4),(4821,82),(4822,66),(4823,71),(4824,82),(4825,71),(4826,1),(4827,2),(4828,3),(4829,4),(4830,71),(4831,1),(4832,2),(4833,3),(4834,4),(4835,71),(4836,73),(4837,74),(4838,75),(4839,76),(4840,77),(4841,78),(4842,79),(4843,80),(4844,81),(4845,81),(4846,1),(4847,2),(4848,3),(4849,4),(4850,71),(4851,1),(4852,2),(4853,3),(4854,4),(4855,71),(4856,79),(4857,80),(4858,72),(4859,73),(4860,74),(4861,75),(4862,76),(4863,77),(4864,78),(4865,79),(4866,80),(4867,81),(4868,78),(4869,1),(4870,2),(4871,3),(4872,4),(4873,1),(4874,2),(4875,3),(4876,4),(4877,66),(4878,82),(4879,66),(4880,71),(4881,82),(4882,71),(4883,78),(4884,1),(4885,2),(4886,3),(4887,4),(4888,71),(4889,1),(4890,2),(4891,3),(4892,4),(4893,71),(4894,80),(4895,72),(4896,73),(4897,74),(4898,75),(4899,76),(4900,77),(4901,79),(4902,80),(4903,81),(4904,79),(4905,79),(4906,219),(4907,4),(4908,1),(4909,2),(4910,3),(4911,4),(4912,71),(4913,245),(4914,245),(4915,245),(4916,245),(4917,245),(4918,245),(4919,245),(4920,245),(4921,1),(4922,2),(4923,3),(4924,4),(4925,71),(4926,246),(4927,246),(4928,246),(4929,246),(4930,246),(4931,246),(4932,246),(4933,246),(4934,1),(4935,2),(4936,3),(4937,4),(4938,71),(4939,1),(4940,2),(4941,3),(4942,4),(4943,71),(4944,246),(4945,72),(4946,73),(4947,74),(4948,75),(4949,76),(4950,77),(4951,80),(4952,81),(4953,245),(4954,246),(4955,245),(4956,1),(4957,2),(4958,3),(4959,4),(4960,71),(4961,1),(4962,2),(4963,3),(4964,4),(4965,71),(4966,72),(4967,73),(4968,74),(4969,75),(4970,76),(4971,77),(4972,80),(4973,81),(4974,246),(4975,246),(4976,1),(4977,2),(4978,3),(4979,4),(4980,71),(4981,1),(4982,2),(4983,3),(4984,4),(4985,71),(4986,72),(4987,73),(4988,74),(4989,75),(4990,76),(4991,77),(4992,80),(4993,81),(4994,80),(4995,80),(4996,1),(4997,2),(4998,3),(4999,4),(5000,71),(5001,1),(5002,2),(5003,3),(5004,4),(5005,71),(5006,73),(5007,74),(5008,75),(5009,76),(5010,77),(5011,72),(5012,73),(5013,74),(5014,75),(5015,76),(5016,77),(5017,81),(5018,81),(5019,72),(5020,73),(5021,73),(5022,73),(5023,72),(5024,72),(5025,74),(5026,74),(5027,74),(5028,75),(5029,75),(5030,75),(5031,76),(5032,76),(5033,76),(5034,77),(5035,77),(5036,77),(5037,67),(5038,1),(5039,2),(5040,3),(5041,4),(5042,66),(5043,1),(5044,2),(5045,3),(5046,4),(5047,66),(5048,69),(5049,70),(5050,68),(5051,68),(5052,82),(5053,82),(5054,83),(5055,84),(5056,85),(5057,86),(5058,1),(5059,2),(5060,3),(5061,4),(5062,247),(5063,247),(5064,247),(5065,247),(5066,247),(5067,247),(5068,247),(5069,247),(5070,1),(5071,2),(5072,3),(5073,4),(5074,247),(5075,248),(5076,248),(5077,248),(5078,248),(5079,248),(5080,248),(5081,248),(5082,248),(5083,1),(5084,2),(5085,3),(5086,4),(5087,247),(5088,249),(5089,249),(5090,249),(5091,249),(5092,249),(5093,249),(5094,249),(5095,249),(5096,1),(5097,2),(5098,3),(5099,4),(5100,247),(5101,250),(5102,250),(5103,250),(5104,250),(5105,250),(5106,250),(5107,250),(5108,250),(5109,1),(5110,2),(5111,3),(5112,4),(5113,247),(5114,251),(5115,251),(5116,251),(5117,251),(5118,251),(5119,251),(5120,251),(5121,251),(5122,1),(5123,2),(5124,3),(5125,4),(5126,247),(5127,252),(5128,252),(5129,252),(5130,252),(5131,252),(5132,252),(5133,252),(5134,252),(5135,1),(5136,2),(5137,3),(5138,37),(5139,253),(5140,253),(5141,253),(5142,253),(5143,253),(5144,253),(5145,253),(5146,253),(5147,1),(5148,2),(5149,3),(5150,37),(5151,1),(5152,2),(5153,3),(5154,37),(5155,38),(5156,39),(5157,40),(5158,41),(5159,42),(5160,43),(5161,44),(5162,45),(5163,253),(5164,253),(5165,1),(5166,2),(5167,3),(5168,37),(5169,253),(5170,254),(5171,254),(5172,254),(5173,254),(5174,254),(5175,254),(5176,254),(5177,254),(5178,1),(5179,2),(5180,3),(5181,37),(5182,253),(5183,255),(5184,255),(5185,255),(5186,255),(5187,255),(5188,255),(5189,255),(5190,255),(5191,1),(5192,2),(5193,3),(5194,37),(5195,1),(5196,2),(5197,3),(5198,37),(5199,253),(5200,40),(5201,41),(5202,42),(5203,43),(5204,44),(5205,45),(5206,39),(5207,1),(5208,2),(5209,3),(5210,37),(5211,253),(5212,256),(5213,256),(5214,256),(5215,256),(5216,256),(5217,256),(5218,256),(5219,256),(5220,1),(5221,2),(5222,3),(5223,37),(5224,1),(5225,2),(5226,3),(5227,37),(5228,253),(5229,43),(5230,44),(5231,45),(5232,42),(5233,1),(5234,2),(5235,3),(5236,37),(5237,1),(5238,2),(5239,3),(5240,37),(5241,253),(5242,41),(5243,43),(5244,44),(5245,45),(5246,40),(5247,1),(5248,2),(5249,3),(5250,37),(5251,1),(5252,2),(5253,3),(5254,37),(5255,43),(5256,44),(5257,45),(5258,38),(5259,41),(5260,43),(5261,44),(5262,45),(5263,41),(5264,1),(5265,2),(5266,3),(5267,37),(5268,1),(5269,2),(5270,3),(5271,37),(5272,253),(5273,38),(5274,43),(5275,44),(5276,45),(5277,41),(5278,1),(5279,2),(5280,3),(5281,37),(5282,253),(5283,257),(5284,257),(5285,257),(5286,257),(5287,257),(5288,257),(5289,257),(5290,257),(5291,1),(5292,2),(5293,3),(5294,37),(5295,1),(5296,2),(5297,3),(5298,37),(5299,44),(5300,45),(5301,38),(5302,43),(5303,44),(5304,45),(5305,43),(5306,1),(5307,2),(5308,3),(5309,37),(5310,1),(5311,2),(5312,3),(5313,37),(5314,253),(5315,38),(5316,44),(5317,45),(5318,43),(5319,38),(5320,38),(5321,38),(5322,1),(5323,2),(5324,3),(5325,37),(5326,1),(5327,2),(5328,3),(5329,37),(5330,253),(5331,44),(5332,45),(5333,39),(5334,40),(5335,41),(5336,42),(5337,43),(5338,254),(5339,255),(5340,256),(5341,257),(5342,38),(5343,1),(5344,2),(5345,10),(5346,1),(5347,2),(5348,3),(5349,37),(5350,191),(5351,194),(5352,44),(5353,45),(5354,183),(5355,184),(5356,185),(5357,186),(5358,188),(5359,189),(5360,182),(5361,1),(5362,2),(5363,3),(5364,37),(5365,1),(5366,2),(5367,3),(5368,37),(5369,182),(5370,45),(5371,183),(5372,184),(5373,185),(5374,186),(5375,188),(5376,189),(5377,44),(5378,182),(5379,1),(5380,2),(5381,3),(5382,37),(5383,182),(5384,258),(5385,258),(5386,258),(5387,258),(5388,258),(5389,258),(5390,258),(5391,258),(5392,1),(5393,2),(5394,3),(5395,37),(5396,182),(5397,1),(5398,2),(5399,3),(5400,37),(5401,182),(5402,183),(5403,184),(5404,185),(5405,186),(5406,188),(5407,189),(5408,258),(5409,258),(5410,1),(5411,2),(5412,3),(5413,37),(5414,1),(5415,2),(5416,3),(5417,37),(5418,182),(5419,183),(5420,184),(5421,185),(5422,186),(5423,188),(5424,189),(5425,45),(5426,45),(5427,1),(5428,2),(5429,3),(5430,37),(5431,182),(5432,259),(5433,259),(5434,259),(5435,259),(5436,259),(5437,259),(5438,259),(5439,259),(5440,1),(5441,2),(5442,3),(5443,37),(5444,182),(5445,260),(5446,260),(5447,260),(5448,260),(5449,260),(5450,260),(5451,260),(5452,260),(5453,1),(5454,2),(5455,3),(5456,37),(5457,182),(5458,261),(5459,261),(5460,261),(5461,261),(5462,261),(5463,261),(5464,261),(5465,261),(5466,1),(5467,2),(5468,3),(5469,37),(5470,182),(5471,1),(5472,2),(5473,3),(5474,37),(5475,182),(5476,260),(5477,261),(5478,183),(5479,184),(5480,185),(5481,186),(5482,188),(5483,189),(5484,259),(5485,260),(5486,261),(5487,259),(5488,1),(5489,2),(5490,3),(5491,37),(5492,182),(5493,1),(5494,2),(5495,3),(5496,37),(5497,182),(5498,261),(5499,183),(5500,184),(5501,185),(5502,186),(5503,188),(5504,189),(5505,260),(5506,261),(5507,260),(5508,1),(5509,2),(5510,3),(5511,37),(5512,182),(5513,1),(5514,2),(5515,3),(5516,37),(5517,182),(5518,183),(5519,184),(5520,185),(5521,186),(5522,188),(5523,189),(5524,261),(5525,261),(5526,183),(5527,183),(5528,183),(5529,183),(5530,183),(5531,183),(5532,183),(5533,184),(5534,184),(5535,184),(5536,185),(5537,185),(5538,185),(5539,186),(5540,186),(5541,186),(5542,188),(5543,188),(5544,188),(5545,189),(5546,189),(5547,189),(5548,1),(5549,2),(5550,3),(5551,37),(5552,262),(5553,262),(5554,262),(5555,262),(5556,262),(5557,262),(5558,262),(5559,262),(5560,262),(5561,1),(5562,2),(5563,3),(5564,37),(5565,262),(5566,263),(5567,263),(5568,263),(5569,263),(5570,263),(5571,263),(5572,263),(5573,263),(5574,1),(5575,2),(5576,3),(5577,37),(5578,262),(5579,263),(5580,264),(5581,264),(5582,264),(5583,264),(5584,264),(5585,264),(5586,264),(5587,264),(5588,1),(5589,2),(5590,3),(5591,37),(5592,262),(5593,263),(5594,265),(5595,265),(5596,265),(5597,265),(5598,265),(5599,265),(5600,265),(5601,265),(5602,1),(5603,2),(5604,3),(5605,37),(5606,262),(5607,263),(5608,1),(5609,2),(5610,3),(5611,37),(5612,262),(5613,265),(5614,263),(5615,264),(5616,1),(5617,2),(5618,3),(5619,37),(5620,262),(5621,263),(5622,1),(5623,2),(5624,3),(5625,37),(5626,262),(5627,263),(5628,265),(5629,1),(5630,2),(5631,3),(5632,37),(5633,262),(5634,1),(5635,2),(5636,3),(5637,37),(5638,262),(5639,263),(5640,264),(5641,265),(5642,263),(5643,1),(5644,2),(5645,3),(5646,37),(5647,262),(5648,266),(5649,266),(5650,266),(5651,266),(5652,266),(5653,266),(5654,266),(5655,266),(5656,1),(5657,2),(5658,3),(5659,37),(5660,262),(5661,267),(5662,267),(5663,267),(5664,267),(5665,267),(5666,267),(5667,267),(5668,267),(5669,1),(5670,2),(5671,3),(5672,37),(5673,262),(5674,268),(5675,268),(5676,268),(5677,268),(5678,268),(5679,268),(5680,268),(5681,268),(5682,1),(5683,2),(5684,3),(5685,37),(5686,262),(5687,269),(5688,269),(5689,269),(5690,269),(5691,269),(5692,269),(5693,269),(5694,269),(5695,1),(5696,2),(5697,3),(5698,37),(5699,262),(5700,270),(5701,270),(5702,270),(5703,270),(5704,270),(5705,270),(5706,270),(5707,270),(5708,1),(5709,2),(5710,3),(5711,37),(5712,262),(5713,271),(5714,271),(5715,271),(5716,271),(5717,271),(5718,271),(5719,271),(5720,271),(5721,1),(5722,2),(5723,3),(5724,37),(5725,262),(5726,272),(5727,272),(5728,272),(5729,272),(5730,272),(5731,272),(5732,272),(5733,272),(5734,1),(5735,2),(5736,3),(5737,37),(5738,262),(5739,273),(5740,273),(5741,273),(5742,273),(5743,273),(5744,273),(5745,273),(5746,273),(5747,1),(5748,2),(5749,3),(5750,37),(5751,262),(5752,274),(5753,274),(5754,274),(5755,274),(5756,274),(5757,274),(5758,274),(5759,274),(5760,1),(5761,2),(5762,3),(5763,37),(5764,262),(5765,275),(5766,275),(5767,275),(5768,275),(5769,275),(5770,275),(5771,275),(5772,275),(5773,1),(5774,2),(5775,1),(5776,2),(5777,3),(5778,10),(5779,11),(5780,12),(5781,163),(5782,164),(5783,46),(5784,51),(5785,54),(5786,57),(5787,62),(5788,145),(5789,146),(5790,147),(5791,148),(5792,149),(5793,150),(5794,151),(5795,152),(5796,153),(5797,154),(5798,155),(5799,156),(5800,157),(5801,158),(5802,159),(5803,160),(5804,161),(5805,162),(5806,8),(5807,1),(5808,2),(5809,3),(5810,8),(5811,1),(5812,2),(5813,150),(5814,5),(5815,6),(5816,7),(5817,10),(5818,11),(5819,12),(5820,163),(5821,164),(5822,146),(5823,147),(5824,148),(5825,149),(5826,145),(5827,1),(5828,2),(5829,3),(5830,8),(5831,150),(5832,1),(5833,2),(5834,3),(5835,8),(5836,150),(5837,160),(5838,161),(5839,162),(5840,159),(5841,1),(5842,2),(5843,3),(5844,8),(5845,150),(5846,1),(5847,2),(5848,3),(5849,8),(5850,150),(5851,153),(5852,154),(5853,155),(5854,156),(5855,157),(5856,158),(5857,152),(5858,1),(5859,2),(5860,3),(5861,8),(5862,150),(5863,1),(5864,2),(5865,3),(5866,8),(5867,159),(5868,151),(5869,151),(5870,1),(5871,2),(5872,3),(5873,8),(5874,159),(5875,276),(5876,276),(5877,276),(5878,276),(5879,276),(5880,276),(5881,276),(5882,276),(5883,1),(5884,2),(5885,3),(5886,8),(5887,159),(5888,277),(5889,277),(5890,277),(5891,277),(5892,277),(5893,277),(5894,277),(5895,277),(5896,1),(5897,2),(5898,3),(5899,8),(5900,159),(5901,278),(5902,278),(5903,278),(5904,278),(5905,278),(5906,278),(5907,278),(5908,278),(5909,1),(5910,2),(5911,3),(5912,8),(5913,152),(5914,1),(5915,2),(5916,3),(5917,8),(5918,152),(5919,155),(5920,156),(5921,157),(5922,158),(5923,153),(5924,154),(5925,155),(5926,156),(5927,157),(5928,158),(5929,154),(5930,1),(5931,2),(5932,3),(5933,8),(5934,152),(5935,1),(5936,2),(5937,3),(5938,8),(5939,152),(5940,156),(5941,157),(5942,158),(5943,153),(5944,155),(5945,156),(5946,157),(5947,158),(5948,155),(5949,154),(5950,1),(5951,2),(5952,3),(5953,8),(5954,152),(5955,279),(5956,279),(5957,279),(5958,279),(5959,279),(5960,279),(5961,279),(5962,279),(5963,1),(5964,2),(5965,3),(5966,8),(5967,152),(5968,1),(5969,2),(5970,3),(5971,8),(5972,152),(5973,153),(5974,156),(5975,157),(5976,158),(5977,279),(5978,279),(5979,1),(5980,2),(5981,3),(5982,8),(5983,152),(5984,280),(5985,280),(5986,280),(5987,280),(5988,280),(5989,280),(5990,280),(5991,280),(5992,1),(5993,2),(5994,3),(5995,8),(5996,152),(5997,281),(5998,281),(5999,281),(6000,281),(6001,281),(6002,281),(6003,281),(6004,281),(6005,1),(6006,2),(6007,3),(6008,8),(6009,152),(6010,282),(6011,282),(6012,282),(6013,282),(6014,282),(6015,282),(6016,282),(6017,282),(6018,1),(6019,2),(6020,3),(6021,8),(6022,152),(6023,1),(6024,2),(6025,3),(6026,8),(6027,152),(6028,281),(6029,282),(6030,153),(6031,156),(6032,157),(6033,158),(6034,280),(6035,281),(6036,282),(6037,280),(6038,1),(6039,2),(6040,3),(6041,8),(6042,152),(6043,1),(6044,2),(6045,3),(6046,8),(6047,152),(6048,282),(6049,153),(6050,156),(6051,157),(6052,158),(6053,281),(6054,282),(6055,281),(6056,1),(6057,2),(6058,3),(6059,8),(6060,152),(6061,1),(6062,2),(6063,3),(6064,8),(6065,152),(6066,153),(6067,156),(6068,157),(6069,158),(6070,282),(6071,282),(6072,1),(6073,2),(6074,3),(6075,8),(6076,152),(6077,281),(6078,1),(6079,2),(6080,3),(6081,8),(6082,152),(6083,1),(6084,2),(6085,3),(6086,8),(6087,152),(6088,153),(6089,156),(6090,157),(6091,158),(6092,282),(6093,158),(6094,153),(6095,153),(6096,153),(6097,156),(6098,157),(6099,157),(6100,157),(6101,156),(6102,156),(6103,150),(6104,150),(6105,150),(6106,1),(6107,2),(6108,3),(6109,1),(6110,2),(6111,3),(6112,57),(6113,62),(6114,46),(6115,51),(6116,54),(6117,57),(6118,62),(6119,54),(6120,54),(6121,55),(6122,1),(6123,2),(6124,3),(6125,54),(6126,1),(6127,2),(6128,3),(6129,46),(6130,51),(6131,57),(6132,62),(6133,56),(6134,1),(6135,2),(6136,3),(6137,54),(6138,55),(6139,283),(6140,283),(6141,283),(6142,283),(6143,283),(6144,283),(6145,283),(6146,283),(6147,1),(6148,2),(6149,3),(6150,54),(6151,55),(6152,284),(6153,284),(6154,284),(6155,284),(6156,284),(6157,284),(6158,284),(6159,284),(6160,1),(6161,2),(6162,3),(6163,54),(6164,55),(6165,285),(6166,285),(6167,285),(6168,285),(6169,285),(6170,285),(6171,285),(6172,285),(6173,1),(6174,2),(6175,3),(6176,54),(6177,55),(6178,286),(6179,286),(6180,286),(6181,286),(6182,286),(6183,286),(6184,286),(6185,286),(6186,1),(6187,2),(6188,3),(6189,54),(6190,55),(6191,287),(6192,287),(6193,287),(6194,287),(6195,287),(6196,287),(6197,287),(6198,287),(6199,1),(6200,2),(6201,3),(6202,54),(6203,55),(6204,288),(6205,288),(6206,288),(6207,288),(6208,288),(6209,288),(6210,288),(6211,288),(6212,1),(6213,2),(6214,3),(6215,54),(6216,289),(6217,289),(6218,289),(6219,289),(6220,289),(6221,289),(6222,289),(6223,289),(6224,1),(6225,2),(6226,3),(6227,54),(6228,289),(6229,290),(6230,290),(6231,290),(6232,290),(6233,290),(6234,290),(6235,290),(6236,290),(6237,1),(6238,2),(6239,3),(6240,54),(6241,289),(6242,291),(6243,291),(6244,291),(6245,291),(6246,291),(6247,291),(6248,291),(6249,291),(6250,1),(6251,2),(6252,3),(6253,54),(6254,289),(6255,292),(6256,292),(6257,292),(6258,292),(6259,292),(6260,292),(6261,292),(6262,292),(6263,1),(6264,2),(6265,3),(6266,54),(6267,289),(6268,293),(6269,293),(6270,293),(6271,293),(6272,293),(6273,293),(6274,293),(6275,293),(6276,1),(6277,2),(6278,3),(6279,54),(6280,289),(6281,294),(6282,294),(6283,294),(6284,294),(6285,294),(6286,294),(6287,294),(6288,294),(6289,1),(6290,2),(6291,3),(6292,1),(6293,2),(6294,3),(6295,51),(6296,57),(6297,62),(6298,46),(6299,51),(6300,56),(6301,57),(6302,62),(6303,46),(6304,1),(6305,2),(6306,3),(6307,1),(6308,2),(6309,3),(6310,54),(6311,51),(6312,57),(6313,62),(6314,55),(6315,289),(6316,56),(6317,56),(6318,1),(6319,2),(6320,3),(6321,46),(6322,295),(6323,295),(6324,295),(6325,295),(6326,295),(6327,295),(6328,295),(6329,295),(6330,1),(6331,2),(6332,3),(6333,46),(6334,1),(6335,2),(6336,3),(6337,46),(6338,47),(6339,48),(6340,49),(6341,50),(6342,295),(6343,295),(6344,1),(6345,2),(6346,3),(6347,46),(6348,1),(6349,2),(6350,3),(6351,46),(6352,295),(6353,48),(6354,49),(6355,50),(6356,47),(6357,1),(6358,2),(6359,3),(6360,46),(6361,1),(6362,2),(6363,3),(6364,46),(6365,295),(6366,49),(6367,50),(6368,47),(6369,48),(6370,1),(6371,2),(6372,3),(6373,46),(6374,1),(6375,2),(6376,3),(6377,46),(6378,295),(6379,50),(6380,47),(6381,48),(6382,49),(6383,1),(6384,2),(6385,3),(6386,46),(6387,1),(6388,2),(6389,3),(6390,46),(6391,295),(6392,47),(6393,48),(6394,49),(6395,50),(6396,1),(6397,2),(6398,3),(6399,46),(6400,295),(6401,1),(6402,2),(6403,3),(6404,46),(6405,295),(6406,47),(6407,48),(6408,49),(6409,50),(6410,1),(6411,2),(6412,3),(6413,46),(6414,295),(6415,1),(6416,2),(6417,3),(6418,46),(6419,295),(6420,50),(6421,47),(6422,48),(6423,49),(6424,50),(6425,47),(6426,47),(6427,1),(6428,2),(6429,3),(6430,46),(6431,295),(6432,1),(6433,2),(6434,3),(6435,46),(6436,295),(6437,50),(6438,48),(6439,49),(6440,50),(6441,48),(6442,48),(6443,49),(6444,1),(6445,2),(6446,3),(6447,46),(6448,295),(6449,296),(6450,296),(6451,296),(6452,296),(6453,296),(6454,296),(6455,296),(6456,296),(6457,1),(6458,2),(6459,3),(6460,46),(6461,295),(6462,297),(6463,297),(6464,297),(6465,297),(6466,297),(6467,297),(6468,297),(6469,297),(6470,1),(6471,2),(6472,3),(6473,46),(6474,295),(6475,298),(6476,298),(6477,298),(6478,298),(6479,298),(6480,298),(6481,298),(6482,298),(6483,1),(6484,2),(6485,3),(6486,46),(6487,295),(6488,1),(6489,2),(6490,3),(6491,46),(6492,295),(6493,296),(6494,297),(6495,298),(6496,50),(6497,1),(6498,2),(6499,3),(6500,46),(6501,295),(6502,299),(6503,299),(6504,299),(6505,299),(6506,299),(6507,299),(6508,299),(6509,299),(6510,1),(6511,2),(6512,3),(6513,46),(6514,295),(6515,300),(6516,300),(6517,300),(6518,300),(6519,300),(6520,300),(6521,300),(6522,300),(6523,1),(6524,2),(6525,3),(6526,46),(6527,301),(6528,301),(6529,301),(6530,301),(6531,301),(6532,301),(6533,301),(6534,301),(6535,1),(6536,2),(6537,3),(6538,46),(6539,301),(6540,302),(6541,302),(6542,302),(6543,302),(6544,302),(6545,302),(6546,302),(6547,302),(6548,1),(6549,2),(6550,3),(6551,46),(6552,301),(6553,303),(6554,303),(6555,303),(6556,303),(6557,303),(6558,303),(6559,303),(6560,303),(6561,1),(6562,2),(6563,3),(6564,46),(6565,301),(6566,304),(6567,304),(6568,304),(6569,304),(6570,304),(6571,304),(6572,304),(6573,304),(6574,1),(6575,2),(6576,3),(6577,46),(6578,301),(6579,305),(6580,305),(6581,305),(6582,305),(6583,305),(6584,305),(6585,305),(6586,305),(6587,1),(6588,2),(6589,3),(6590,46),(6591,301),(6592,306),(6593,306),(6594,306),(6595,306),(6596,306),(6597,306),(6598,306),(6599,306),(6600,290),(6601,62),(6602,62),(6603,62),(6604,57),(6605,57),(6606,57),(6607,51),(6608,51),(6609,51),(6610,56),(6611,56),(6612,1),(6613,2),(6614,1),(6615,2),(6616,6),(6617,7),(6618,10),(6619,11),(6620,12),(6621,163),(6622,164),(6623,5),(6624,6),(6625,7),(6626,10),(6627,11),(6628,12),(6629,145),(6630,163),(6631,164),(6632,5),(6633,1),(6634,2),(6635,5),(6636,1),(6637,2),(6638,5),(6639,87),(6640,96),(6641,98),(6642,100),(6643,106),(6644,106),(6645,5),(6646,1),(6647,2),(6648,5),(6649,106),(6650,307),(6651,307),(6652,307),(6653,307),(6654,307),(6655,307),(6656,307),(6657,307),(6658,1),(6659,2),(6660,5),(6661,106),(6662,308),(6663,308),(6664,308),(6665,308),(6666,308),(6667,308),(6668,308),(6669,308),(6670,1),(6671,2),(6672,5),(6673,106),(6674,309),(6675,309),(6676,309),(6677,309),(6678,309),(6679,309),(6680,309),(6681,309),(6682,1),(6683,2),(6684,5),(6685,106),(6686,310),(6687,310),(6688,310),(6689,310),(6690,310),(6691,310),(6692,310),(6693,310),(6694,1),(6695,2),(6696,5),(6697,106),(6698,310),(6699,311),(6700,311),(6701,311),(6702,311),(6703,311),(6704,311),(6705,311),(6706,311),(6707,1),(6708,2),(6709,5),(6710,106),(6711,310),(6712,1),(6713,2),(6714,5),(6715,106),(6716,310),(6717,311),(6718,1),(6719,2),(6720,5),(6721,106),(6722,1),(6723,2),(6724,5),(6725,106),(6726,310),(6727,311),(6728,310),(6729,1),(6730,2),(6731,5),(6732,106),(6733,312),(6734,312),(6735,312),(6736,312),(6737,312),(6738,312),(6739,312),(6740,312),(6741,107),(6742,107),(6743,107),(6744,1),(6745,2),(6746,5),(6747,106),(6748,1),(6749,2),(6750,5),(6751,106),(6752,110),(6753,307),(6754,308),(6755,309),(6756,310),(6757,311),(6758,312),(6759,109),(6760,109),(6761,109),(6762,109),(6763,109),(6764,106),(6765,1),(6766,2),(6767,5),(6768,313),(6769,313),(6770,313),(6771,313),(6772,313),(6773,313),(6774,313),(6775,313),(6776,1),(6777,2),(6778,5),(6779,1),(6780,2),(6781,5),(6782,87),(6783,96),(6784,98),(6785,100),(6786,313),(6787,313),(6788,1),(6789,2),(6790,5),(6791,106),(6792,1),(6793,2),(6794,5),(6795,313),(6796,109),(6797,110),(6798,307),(6799,308),(6800,309),(6801,310),(6802,311),(6803,312),(6804,108),(6805,1),(6806,2),(6807,5),(6808,313),(6809,314),(6810,314),(6811,314),(6812,314),(6813,314),(6814,314),(6815,314),(6816,314),(6817,1),(6818,2),(6819,5),(6820,313),(6821,315),(6822,315),(6823,315),(6824,315),(6825,315),(6826,315),(6827,315),(6828,315),(6829,1),(6830,2),(6831,5),(6832,313),(6833,316),(6834,316),(6835,316),(6836,316),(6837,316),(6838,316),(6839,316),(6840,316),(6841,1),(6842,2),(6843,5),(6844,313),(6845,317),(6846,317),(6847,317),(6848,317),(6849,317),(6850,317),(6851,317),(6852,317),(6853,1),(6854,2),(6855,5),(6856,318),(6857,318),(6858,318),(6859,318),(6860,318),(6861,318),(6862,318),(6863,318),(6864,1),(6865,2),(6866,5),(6867,1),(6868,2),(6869,5),(6870,87),(6871,96),(6872,98),(6873,100),(6874,106),(6875,313),(6876,318),(6877,318),(6878,1),(6879,2),(6880,5),(6881,1),(6882,2),(6883,5),(6884,318),(6885,87),(6886,96),(6887,98),(6888,100),(6889,313),(6890,107),(6891,109),(6892,110),(6893,307),(6894,308),(6895,309),(6896,310),(6897,311),(6898,312),(6899,106),(6900,1),(6901,2),(6902,5),(6903,1),(6904,2),(6905,5),(6906,318),(6907,87),(6908,96),(6909,98),(6910,100),(6911,106),(6912,108),(6913,314),(6914,315),(6915,316),(6916,317),(6917,313),(6918,1),(6919,2),(6920,5),(6921,318),(6922,1),(6923,2),(6924,5),(6925,318),(6926,106),(6927,313),(6928,106),(6929,318),(6930,1),(6931,2),(6932,5),(6933,318),(6934,319),(6935,319),(6936,319),(6937,319),(6938,319),(6939,319),(6940,319),(6941,319),(6942,1),(6943,2),(6944,5),(6945,318),(6946,319),(6947,320),(6948,320),(6949,320),(6950,320),(6951,320),(6952,320),(6953,320),(6954,320),(6955,1),(6956,2),(6957,5),(6958,318),(6959,319),(6960,321),(6961,321),(6962,321),(6963,321),(6964,321),(6965,321),(6966,321),(6967,321),(6968,1),(6969,2),(6970,5),(6971,318),(6972,319),(6973,322),(6974,322),(6975,322),(6976,322),(6977,322),(6978,322),(6979,322),(6980,322),(6981,1),(6982,2),(6983,5),(6984,318),(6985,323),(6986,323),(6987,323),(6988,323),(6989,323),(6990,323),(6991,323),(6992,323),(6993,1),(6994,2),(6995,5),(6996,318),(6997,323),(6998,324),(6999,324),(7000,324),(7001,324),(7002,324),(7003,324),(7004,324),(7005,324),(7006,1),(7007,2),(7008,5),(7009,318),(7010,323),(7011,325),(7012,325),(7013,325),(7014,325),(7015,325),(7016,325),(7017,325),(7018,325),(7019,1),(7020,2),(7021,5),(7022,318),(7023,323),(7024,326),(7025,326),(7026,326),(7027,326),(7028,326),(7029,326),(7030,326),(7031,326),(7032,1),(7033,2),(7034,5),(7035,318),(7036,323),(7037,327),(7038,327),(7039,327),(7040,327),(7041,327),(7042,327),(7043,327),(7044,327),(7045,1),(7046,2),(7047,5),(7048,318),(7049,323),(7050,328),(7051,328),(7052,328),(7053,328),(7054,328),(7055,328),(7056,328),(7057,328),(7058,1),(7059,2),(7060,1),(7061,2),(7062,5),(7063,6),(7064,7),(7065,10),(7066,11),(7067,12),(7068,163),(7069,164),(7070,87),(7071,96),(7072,98),(7073,100),(7074,146),(7075,147),(7076,148),(7077,149),(7078,145),(7079,1),(7080,2),(7081,5),(7082,145),(7083,329),(7084,329),(7085,329),(7086,329),(7087,329),(7088,329),(7089,329),(7090,329),(7091,1),(7092,2),(7093,5),(7094,145),(7095,1),(7096,2),(7097,5),(7098,145),(7099,146),(7100,147),(7101,148),(7102,149),(7103,329),(7104,329),(7105,1),(7106,2),(7107,5),(7108,106),(7109,318),(7110,1),(7111,2),(7112,5),(7113,318),(7114,319),(7115,109),(7116,307),(7117,308),(7118,309),(7119,310),(7120,311),(7121,312),(7122,320),(7123,321),(7124,322),(7125,110),(7126,1),(7127,2),(7128,5),(7129,106),(7130,318),(7131,1),(7132,2),(7133,5),(7134,106),(7135,318),(7136,109),(7137,307),(7138,308),(7139,309),(7140,310),(7141,311),(7142,312),(7143,107),(7144,1),(7145,2),(7146,5),(7147,318),(7148,319),(7149,320),(7150,110),(7151,1),(7152,2),(7153,5),(7154,145),(7155,329),(7156,330),(7157,330),(7158,330),(7159,330),(7160,330),(7161,330),(7162,330),(7163,330),(7164,1),(7165,2),(7166,5),(7167,145),(7168,329),(7169,331),(7170,331),(7171,331),(7172,331),(7173,331),(7174,331),(7175,331),(7176,331),(7177,1),(7178,2),(7179,5),(7180,145),(7181,329),(7182,332),(7183,332),(7184,332),(7185,332),(7186,332),(7187,332),(7188,332),(7189,332),(7190,1),(7191,2),(7192,5),(7193,145),(7194,329),(7195,333),(7196,333),(7197,333),(7198,333),(7199,333),(7200,333),(7201,333),(7202,333),(7203,1),(7204,2),(7205,5),(7206,145),(7207,329),(7208,334),(7209,334),(7210,334),(7211,334),(7212,334),(7213,334),(7214,334),(7215,334),(7216,1),(7217,2),(7218,5),(7219,145),(7220,329),(7221,335),(7222,335),(7223,335),(7224,335),(7225,335),(7226,335),(7227,335),(7228,335),(7229,1),(7230,2),(7231,5),(7232,145),(7233,329),(7234,336),(7235,336),(7236,336),(7237,336),(7238,336),(7239,336),(7240,336),(7241,336),(7242,146),(7243,146),(7244,146),(7245,147),(7246,147),(7247,147),(7248,148),(7249,148),(7250,148),(7251,148),(7252,149),(7253,149),(7254,149),(7255,1),(7256,2),(7257,5),(7258,145),(7259,1),(7260,2),(7261,5),(7262,145),(7263,329),(7264,149),(7265,335),(7266,336),(7267,148),(7268,1),(7269,2),(7270,5),(7271,145),(7272,1),(7273,2),(7274,5),(7275,145),(7276,329),(7277,149),(7278,148),(7279,333),(7280,334),(7281,335),(7282,336),(7283,147),(7284,1),(7285,2),(7286,5),(7287,145),(7288,329),(7289,334),(7290,148),(7291,148),(7292,1),(7293,2),(7294,5),(7295,145),(7296,329),(7297,333),(7298,147),(7299,147),(7300,87),(7301,87),(7302,87),(7303,96),(7304,96),(7305,96),(7306,96),(7307,96),(7308,87),(7309,87),(7310,1),(7311,2),(7312,5),(7313,337),(7314,337),(7315,337),(7316,337),(7317,337),(7318,337),(7319,337),(7320,337),(7321,1),(7322,2),(7323,5),(7324,1),(7325,2),(7326,5),(7327,87),(7328,96),(7329,98),(7330,100),(7331,337),(7332,337),(7333,1),(7334,2),(7335,5),(7336,337),(7337,338),(7338,338),(7339,338),(7340,338),(7341,338),(7342,338),(7343,338),(7344,338),(7345,1),(7346,2),(7347,5),(7348,337),(7349,339),(7350,339),(7351,339),(7352,339),(7353,339),(7354,339),(7355,339),(7356,339),(7357,1),(7358,2),(7359,5),(7360,337),(7361,340),(7362,340),(7363,340),(7364,340),(7365,340),(7366,340),(7367,340),(7368,340),(7369,1),(7370,2),(7371,5),(7372,337),(7373,341),(7374,341),(7375,341),(7376,341),(7377,341),(7378,341),(7379,341),(7380,341),(7381,1),(7382,2),(7383,5),(7384,337),(7385,342),(7386,342),(7387,342),(7388,342),(7389,342),(7390,342),(7391,342),(7392,342),(7393,1),(7394,2),(7395,5),(7396,343),(7397,343),(7398,343),(7399,343),(7400,343),(7401,343),(7402,343),(7403,343),(7404,1),(7405,2),(7406,5),(7407,1),(7408,2),(7409,5),(7410,87),(7411,96),(7412,98),(7413,100),(7414,337),(7415,343),(7416,343),(7417,1),(7418,2),(7419,5),(7420,1),(7421,2),(7422,5),(7423,87),(7424,96),(7425,98),(7426,100),(7427,87),(7428,96),(7429,98),(7430,100),(7431,337),(7432,343),(7433,337),(7434,1),(7435,2),(7436,5),(7437,1),(7438,2),(7439,5),(7440,145),(7441,87),(7442,96),(7443,98),(7444,100),(7445,343),(7446,146),(7447,149),(7448,338),(7449,339),(7450,340),(7451,341),(7452,342),(7453,337),(7454,1),(7455,2),(7456,5),(7457,145),(7458,344),(7459,344),(7460,344),(7461,344),(7462,344),(7463,344),(7464,344),(7465,344),(7466,1),(7467,2),(7468,5),(7469,145),(7470,1),(7471,2),(7472,5),(7473,145),(7474,146),(7475,149),(7476,337),(7477,344),(7478,344),(7479,1),(7480,2),(7481,5),(7482,145),(7483,344),(7484,345),(7485,345),(7486,345),(7487,345),(7488,345),(7489,345),(7490,345),(7491,345),(7492,1),(7493,2),(7494,5),(7495,145),(7496,344),(7497,346),(7498,346),(7499,346),(7500,346),(7501,346),(7502,346),(7503,346),(7504,346),(7505,1),(7506,2),(7507,5),(7508,145),(7509,344),(7510,347),(7511,347),(7512,347),(7513,347),(7514,347),(7515,347),(7516,347),(7517,347),(7518,1),(7519,2),(7520,5),(7521,1),(7522,2),(7523,5),(7524,343),(7525,96),(7526,98),(7527,100),(7528,88),(7529,89),(7530,90),(7531,91),(7532,92),(7533,93),(7534,94),(7535,95),(7536,87),(7537,1),(7538,2),(7539,5),(7540,1),(7541,2),(7542,5),(7543,343),(7544,98),(7545,100),(7546,87),(7547,97),(7548,96),(7549,1),(7550,2),(7551,5),(7552,1),(7553,2),(7554,5),(7555,343),(7556,100),(7557,87),(7558,96),(7559,99),(7560,98),(7561,1),(7562,2),(7563,5),(7564,1),(7565,2),(7566,5),(7567,343),(7568,87),(7569,96),(7570,98),(7571,101),(7572,102),(7573,103),(7574,104),(7575,105),(7576,100),(7577,1),(7578,2),(7579,5),(7580,343),(7581,1),(7582,2),(7583,5),(7584,343),(7585,87),(7586,96),(7587,98),(7588,100),(7589,87),(7590,1),(7591,2),(7592,5),(7593,343),(7594,1),(7595,2),(7596,5),(7597,343),(7598,96),(7599,98),(7600,96),(7601,1),(7602,2),(7603,5),(7604,100),(7605,343),(7606,1),(7607,2),(7608,5),(7609,100),(7610,343),(7611,102),(7612,103),(7613,104),(7614,105),(7615,104),(7616,105),(7617,101),(7618,1),(7619,2),(7620,5),(7621,343),(7622,348),(7623,348),(7624,348),(7625,348),(7626,348),(7627,348),(7628,348),(7629,348),(7630,1),(7631,2),(7632,5),(7633,343),(7634,348),(7635,349),(7636,349),(7637,349),(7638,349),(7639,349),(7640,349),(7641,349),(7642,349),(7643,1),(7644,2),(7645,5),(7646,343),(7647,350),(7648,350),(7649,350),(7650,350),(7651,350),(7652,350),(7653,350),(7654,350),(7655,1),(7656,2),(7657,5),(7658,343),(7659,350),(7660,351),(7661,351),(7662,351),(7663,351),(7664,351),(7665,351),(7666,351),(7667,351),(7668,1),(7669,2),(7670,5),(7671,343),(7672,350),(7673,352),(7674,352),(7675,352),(7676,352),(7677,352),(7678,352),(7679,352),(7680,352),(7681,1),(7682,2),(7683,5),(7684,343),(7685,350),(7686,353),(7687,353),(7688,353),(7689,353),(7690,353),(7691,353),(7692,353),(7693,353),(7694,1),(7695,2),(7696,5),(7697,343),(7698,350),(7699,354),(7700,354),(7701,354),(7702,354),(7703,354),(7704,354),(7705,354),(7706,354),(7707,1),(7708,2),(7709,5),(7710,343),(7711,350),(7712,355),(7713,355),(7714,355),(7715,355),(7716,355),(7717,355),(7718,355),(7719,355),(7720,1),(7721,2),(7722,5),(7723,356),(7724,356),(7725,356),(7726,356),(7727,356),(7728,356),(7729,356),(7730,356),(7741,1),(7742,2),(7743,5),(7744,356),(7745,358),(7746,358),(7747,358),(7748,358),(7749,358),(7750,358),(7751,358),(7752,358),(7753,1),(7754,2),(7755,5),(7756,356),(7757,358),(7758,359),(7759,359),(7760,359),(7761,359),(7762,359),(7763,359),(7764,359),(7765,359),(7766,1),(7767,2),(7768,5),(7769,356),(7770,358),(7771,360),(7772,360),(7773,360),(7774,360),(7775,360),(7776,360),(7777,360),(7778,360),(7779,1),(7780,2),(7781,5),(7782,356),(7783,358),(7784,361),(7785,361),(7786,361),(7787,361),(7788,361),(7789,361),(7790,361),(7791,361),(7792,1),(7793,2),(7794,5),(7795,356),(7796,358),(7797,362),(7798,362),(7799,362),(7800,362),(7801,362),(7802,362),(7803,362),(7804,362),(7805,1),(7806,2),(7807,5),(7808,356),(7809,358),(7810,363),(7811,363),(7812,363),(7813,363),(7814,363),(7815,363),(7816,363),(7817,363),(7818,1),(7819,2),(7820,5),(7821,356),(7822,358),(7823,364),(7824,364),(7825,364),(7826,364),(7827,364),(7828,364),(7829,364),(7830,364),(7831,1),(7832,2),(7833,5),(7834,356),(7835,358),(7836,365),(7837,365),(7838,365),(7839,365),(7840,365),(7841,365),(7842,365),(7843,365),(7844,1),(7845,2),(7846,1),(7847,2),(7848,10),(7849,11),(7850,12),(7851,163),(7852,164),(7853,6),(7854,7),(7855,10),(7856,11),(7857,12),(7858,163),(7859,164),(7860,7),(7861,1),(7862,2),(7863,7),(7864,366),(7865,366),(7866,366),(7867,366),(7868,366),(7869,366),(7870,366),(7871,366),(7872,1),(7873,2),(7874,7),(7875,1),(7876,2),(7877,6),(7878,10),(7879,11),(7880,12),(7881,163),(7882,164),(7883,366),(7884,1),(7885,2),(7886,1),(7887,2),(7888,7),(7889,6),(7890,10),(7891,11),(7892,12),(7893,163),(7894,164),(7895,135),(7896,142),(7897,366),(7898,1),(7899,2),(7900,7),(7901,366),(7902,367),(7903,367),(7904,367),(7905,367),(7906,367),(7907,367),(7908,367),(7909,367),(7910,1),(7911,2),(7912,7),(7913,1),(7914,2),(7915,7),(7916,366),(7917,367),(7918,142),(7919,136),(7920,137),(7921,138),(7922,139),(7923,140),(7924,141),(7925,135),(7926,1),(7927,2),(7928,7),(7929,135),(7930,366),(7931,367),(7932,1),(7933,2),(7934,7),(7935,366),(7936,367),(7937,137),(7938,138),(7939,139),(7940,140),(7941,141),(7942,135),(7943,136),(7944,1),(7945,2),(7946,7),(7947,135),(7948,366),(7949,367),(7950,1),(7951,2),(7952,7),(7953,366),(7954,367),(7955,138),(7956,139),(7957,140),(7958,141),(7959,135),(7960,137),(7961,1),(7962,2),(7963,7),(7964,135),(7965,366),(7966,367),(7967,1),(7968,2),(7969,7),(7970,366),(7971,367),(7972,139),(7973,140),(7974,141),(7975,135),(7976,138),(7977,1),(7978,2),(7979,7),(7980,135),(7981,366),(7982,367),(7983,1),(7984,2),(7985,7),(7986,366),(7987,367),(7988,140),(7989,141),(7990,135),(7991,139),(7992,1),(7993,2),(7994,7),(7995,135),(7996,366),(7997,367),(7998,1),(7999,2),(8000,7),(8001,366),(8002,367),(8003,141),(8004,135),(8005,140),(8006,1),(8007,2),(8008,7),(8009,135),(8010,366),(8011,367),(8012,1),(8013,2),(8014,7),(8015,366),(8016,367),(8017,135),(8018,141),(8019,1),(8020,2),(8021,7),(8022,366),(8023,367),(8024,1),(8025,2),(8026,7),(8027,366),(8028,367),(8029,135),(8030,136),(8031,137),(8032,138),(8033,139),(8034,140),(8035,141),(8036,135),(8037,1),(8038,2),(8039,7),(8040,366),(8041,367),(8042,1),(8043,2),(8044,7),(8045,366),(8046,367),(8047,140),(8048,141),(8049,138),(8050,139),(8051,140),(8052,141),(8053,139),(8054,1),(8055,2),(8056,7),(8057,366),(8058,367),(8059,368),(8060,368),(8061,368),(8062,368),(8063,368),(8064,368),(8065,368),(8066,368),(8067,1),(8068,2),(8069,7),(8070,366),(8071,367),(8072,1),(8073,2),(8074,7),(8075,366),(8076,367),(8077,138),(8078,139),(8079,140),(8080,141),(8081,368),(8082,368),(8083,1),(8084,2),(8085,7),(8086,366),(8087,367),(8088,369),(8089,369),(8090,369),(8091,369),(8092,369),(8093,369),(8094,369),(8095,369),(8096,1),(8097,2),(8098,7),(8099,366),(8100,367),(8101,1),(8102,2),(8103,7),(8104,366),(8105,367),(8106,138),(8107,140),(8108,141),(8109,369),(8110,369),(8111,1),(8112,2),(8113,7),(8114,366),(8115,367),(8116,370),(8117,370),(8118,370),(8119,370),(8120,370),(8121,370),(8122,370),(8123,370),(8124,1),(8125,2),(8126,7),(8127,366),(8128,367),(8129,1),(8130,2),(8131,7),(8132,366),(8133,367),(8134,138),(8135,140),(8136,141),(8137,370),(8138,370),(8139,370),(8140,141),(8141,141),(8142,141),(8143,140),(8144,140),(8145,140),(8146,138),(8147,138),(8148,138),(8149,142),(8150,1),(8151,2),(8152,7),(8153,142),(8154,371),(8155,371),(8156,371),(8157,371),(8158,371),(8159,371),(8160,371),(8161,371),(8162,1),(8163,2),(8164,7),(8165,1),(8166,2),(8167,7),(8168,366),(8169,367),(8170,143),(8171,144),(8172,371),(8173,142),(8174,1),(8175,2),(8176,7),(8177,366),(8178,1),(8179,2),(8180,7),(8181,366),(8182,367),(8183,142),(8184,1),(8185,2),(8186,7),(8187,366),(8188,372),(8189,372),(8190,372),(8191,372),(8192,372),(8193,372),(8194,372),(8195,372),(8196,1),(8197,2),(8198,7),(8199,366),(8200,372),(8201,373),(8202,373),(8203,373),(8204,373),(8205,373),(8206,373),(8207,373),(8208,373),(8209,1),(8210,2),(8211,7),(8212,366),(8213,372),(8214,374),(8215,374),(8216,374),(8217,374),(8218,374),(8219,374),(8220,374),(8221,374),(8222,1),(8223,2),(8224,7),(8225,366),(8226,372),(8227,375),(8228,375),(8229,375),(8230,375),(8231,375),(8232,375),(8233,375),(8234,375),(8235,1),(8236,2),(8237,7),(8238,366),(8239,372),(8240,376),(8241,376),(8242,376),(8243,376),(8244,376),(8245,376),(8246,376),(8247,376),(8248,1),(8249,2),(8250,7),(8251,366),(8252,372),(8253,377),(8254,377),(8255,377),(8256,377),(8257,377),(8258,377),(8259,377),(8260,377),(8261,1),(8262,2),(8263,1),(8264,2),(8265,7),(8266,10),(8267,11),(8268,12),(8269,163),(8270,164),(8271,366),(8272,111),(8273,112),(8274,113),(8275,114),(8276,115),(8277,116),(8278,117),(8279,118),(8280,119),(8281,120),(8282,121),(8283,122),(8284,123),(8285,124),(8286,125),(8287,126),(8288,127),(8289,128),(8290,129),(8291,130),(8292,131),(8293,132),(8294,133),(8295,134),(8296,6),(8297,1),(8298,2),(8299,7),(8300,1),(8301,2),(8302,7),(8303,366),(8304,6),(8305,6),(8306,6),(8307,1),(8308,2),(8309,1),(8310,2),(8311,7),(8312,10),(8313,11),(8314,12),(8315,163),(8316,164),(8317,11),(8318,12),(8319,163),(8320,164),(8321,6),(8322,1),(8323,2),(8324,1),(8325,2),(8326,7),(8327,11),(8328,12),(8329,163),(8330,164),(8331,366),(8332,6),(8333,1),(8334,2),(8335,7),(8336,1),(8337,2),(8338,7),(8339,366),(8340,6),(8341,1),(8342,2),(8343,6),(8344,7),(8345,111),(8346,1),(8347,2),(8348,6),(8349,7),(8350,111),(8351,122),(8352,123),(8353,112),(8354,113),(8355,114),(8356,115),(8357,116),(8358,117),(8359,118),(8360,119),(8361,120),(8362,121),(8363,122),(8364,123),(8365,121),(8366,1),(8367,2),(8368,6),(8369,7),(8370,111),(8371,1),(8372,2),(8373,6),(8374,7),(8375,111),(8376,122),(8377,123),(8378,112),(8379,113),(8380,114),(8381,115),(8382,116),(8383,117),(8384,118),(8385,119),(8386,120),(8387,122),(8388,123),(8389,120),(8390,1),(8391,2),(8392,6),(8393,7),(8394,111),(8395,378),(8396,378),(8397,378),(8398,378),(8399,378),(8400,378),(8401,378),(8402,378),(8403,1),(8404,2),(8405,6),(8406,7),(8407,111),(8408,1),(8409,2),(8410,6),(8411,7),(8412,111),(8413,112),(8414,113),(8415,114),(8416,115),(8417,116),(8418,117),(8419,118),(8420,119),(8421,122),(8422,123),(8423,378),(8424,378),(8425,1),(8426,2),(8427,6),(8428,7),(8429,111),(8430,1),(8431,2),(8432,6),(8433,7),(8434,111),(8435,112),(8436,113),(8437,114),(8438,115),(8439,116),(8440,117),(8441,118),(8442,119),(8443,122),(8444,123),(8445,123),(8446,1),(8447,2),(8448,6),(8449,7),(8450,111),(8451,1),(8452,2),(8453,6),(8454,7),(8455,111),(8456,119),(8457,122),(8458,112),(8459,113),(8460,114),(8461,115),(8462,116),(8463,117),(8464,118),(8465,119),(8466,122),(8467,118),(8468,1),(8469,2),(8470,6),(8471,7),(8472,111),(8473,379),(8474,379),(8475,379),(8476,379),(8477,379),(8478,379),(8479,379),(8480,379),(8481,1),(8482,2),(8483,6),(8484,7),(8485,111),(8486,1),(8487,2),(8488,6),(8489,7),(8490,111),(8491,112),(8492,113),(8493,114),(8494,115),(8495,116),(8496,117),(8497,119),(8498,122),(8499,379),(8500,379),(8501,1),(8502,2),(8503,6),(8504,7),(8505,111),(8506,1),(8507,2),(8508,6),(8509,7),(8510,111),(8511,119),(8512,122),(8513,112),(8514,113),(8515,114),(8516,115),(8517,116),(8518,117),(8519,119),(8520,122),(8521,117),(8522,1),(8523,2),(8524,6),(8525,7),(8526,111),(8527,1),(8528,2),(8529,6),(8530,7),(8531,111),(8532,122),(8533,112),(8534,113),(8535,114),(8536,115),(8537,116),(8538,119),(8539,122),(8540,119),(8541,119),(8542,1),(8543,2),(8544,6),(8545,7),(8546,111),(8547,1),(8548,2),(8549,6),(8550,7),(8551,111),(8552,114),(8553,115),(8554,116),(8555,122),(8556,112),(8557,113),(8558,114),(8559,115),(8560,116),(8561,122),(8562,113),(8563,1),(8564,2),(8565,6),(8566,7),(8567,111),(8568,1),(8569,2),(8570,6),(8571,7),(8572,111),(8573,115),(8574,116),(8575,122),(8576,112),(8577,114),(8578,115),(8579,116),(8580,122),(8581,114),(8582,114),(8583,1),(8584,2),(8585,6),(8586,7),(8587,111),(8588,1),(8589,2),(8590,6),(8591,7),(8592,111),(8593,116),(8594,122),(8595,112),(8596,115),(8597,116),(8598,122),(8599,115),(8600,1),(8601,2),(8602,6),(8603,7),(8604,111),(8605,380),(8606,380),(8607,380),(8608,380),(8609,380),(8610,380),(8611,380),(8612,380),(8613,1),(8614,2),(8615,6),(8616,7),(8617,111),(8618,1),(8619,2),(8620,6),(8621,7),(8622,111),(8623,112),(8624,116),(8625,122),(8626,380),(8627,380),(8628,112),(8629,112),(8630,112),(8631,116),(8632,116),(8633,116),(8634,122),(8635,122),(8636,122),(8637,1),(8638,2),(8639,6),(8640,7),(8641,1),(8642,2),(8643,6),(8644,7),(8645,134),(8646,124),(8647,129),(8648,134),(8649,129),(8650,1),(8651,2),(8652,6),(8653,7),(8654,129),(8655,1),(8656,2),(8657,6),(8658,7),(8659,129),(8660,133),(8661,130),(8662,131),(8663,132),(8664,133),(8665,132),(8666,1),(8667,2),(8668,6),(8669,7),(8670,129),(8671,1),(8672,2),(8673,6),(8674,7),(8675,124),(8676,133),(8677,125),(8678,126),(8679,127),(8680,128),(8681,131),(8682,133),(8683,133),(8684,133),(8685,1),(8686,2),(8687,6),(8688,7),(8689,129),(8690,381),(8691,381),(8692,381),(8693,381),(8694,381),(8695,381),(8696,381),(8697,381),(8698,1),(8699,2),(8700,6),(8701,7),(8702,129),(8703,382),(8704,382),(8705,382),(8706,382),(8707,382),(8708,382),(8709,382),(8710,382),(8711,1),(8712,2),(8713,6),(8714,7),(8715,129),(8716,1),(8717,2),(8718,6),(8719,7),(8720,129),(8721,381),(8722,382),(8723,133),(8724,1),(8725,2),(8726,6),(8727,7),(8728,124),(8729,1),(8730,2),(8731,6),(8732,7),(8733,124),(8734,125),(8735,126),(8736,127),(8737,128),(8738,131),(8739,128),(8740,1),(8741,2),(8742,6),(8743,7),(8744,124),(8745,1),(8746,2),(8747,6),(8748,7),(8749,124),(8750,126),(8751,127),(8752,125),(8753,126),(8754,127),(8755,131),(8756,125),(8757,127),(8758,127),(8759,127),(8760,1),(8761,2),(8762,6),(8763,7),(8764,124),(8765,131),(8766,1),(8767,2),(8768,6),(8769,7),(8770,124),(8771,383),(8772,383),(8773,383),(8774,383),(8775,383),(8776,383),(8777,383),(8778,383),(8779,1),(8780,2),(8781,6),(8782,7),(8783,124),(8784,384),(8785,384),(8786,384),(8787,384),(8788,384),(8789,384),(8790,384),(8791,384),(8792,1),(8793,2),(8794,6),(8795,7),(8796,124),(8797,1),(8798,2),(8799,6),(8800,7),(8801,124),(8802,127),(8803,383),(8804,384),(8805,126),(8806,1),(8807,2),(8808,6),(8809,7),(8810,124),(8811,1),(8812,2),(8813,6),(8814,7),(8815,124),(8816,126),(8817,383),(8818,384),(8819,127),(8820,134),(8821,134),(8822,134),(8823,1),(8824,2),(8825,6),(8826,7),(8827,385),(8828,385),(8829,385),(8830,385),(8831,385),(8832,385),(8833,385),(8834,385),(8835,1),(8836,2),(8837,6),(8838,7),(8839,385),(8840,386),(8841,386),(8842,386),(8843,386),(8844,386),(8845,386),(8846,386),(8847,386),(8848,1),(8849,2),(8850,6),(8851,7),(8852,385),(8853,387),(8854,387),(8855,387),(8856,387),(8857,387),(8858,387),(8859,387),(8860,387),(8861,1),(8862,2),(8863,6),(8864,7),(8865,388),(8866,388),(8867,388),(8868,388),(8869,388),(8870,388),(8871,388),(8872,388),(8873,1),(8874,2),(8875,6),(8876,7),(8877,388),(8878,389),(8879,389),(8880,389),(8881,389),(8882,389),(8883,389),(8884,389),(8885,389),(8886,1),(8887,2),(8888,1),(8889,2),(8890,10),(8891,11),(8892,12),(8893,163),(8894,164),(8895,5),(8896,7),(8897,10),(8898,11),(8899,12),(8900,163),(8901,164),(8902,5),(8903,1),(8904,2),(8905,6),(8906,7),(8907,1),(8908,2),(8909,6),(8910,7),(8911,385),(8912,388),(8913,134),(8914,1),(8915,2),(8916,6),(8917,7),(8918,390),(8919,390),(8920,390),(8921,390),(8922,390),(8923,390),(8924,390),(8925,390),(8926,1),(8927,2),(8928,6),(8929,7),(8930,390),(8931,391),(8932,391),(8933,391),(8934,391),(8935,391),(8936,391),(8937,391),(8938,391),(8939,1),(8940,2),(8941,6),(8942,7),(8943,390),(8944,392),(8945,392),(8946,392),(8947,392),(8948,392),(8949,392),(8950,392),(8951,392),(8952,1),(8953,2),(8954,6),(8955,7),(8956,390),(8957,393),(8958,393),(8959,393),(8960,393),(8961,393),(8962,393),(8963,393),(8964,393),(8965,1),(8966,2),(8967,6),(8968,7),(8969,390),(8970,394),(8971,394),(8972,394),(8973,394),(8974,394),(8975,394),(8976,394),(8977,394),(8978,1),(8979,2),(8980,6),(8981,7),(8982,390),(8983,395),(8984,395),(8985,395),(8986,395),(8987,395),(8988,395),(8989,395),(8990,395),(8991,1),(8992,2),(8993,6),(8994,7),(8995,390),(8996,396),(8997,396),(8998,396),(8999,396),(9000,396),(9001,396),(9002,396),(9003,396),(9004,1),(9005,2),(9006,6),(9007,7),(9008,390),(9009,397),(9010,397),(9011,397),(9012,397),(9013,397),(9014,397),(9015,397),(9016,397),(9017,1),(9018,2),(9019,6),(9020,7),(9021,390),(9022,398),(9023,398),(9024,398),(9025,398),(9026,398),(9027,398),(9028,398),(9029,398),(9030,1),(9031,2),(9032,6),(9033,7),(9034,390),(9035,399),(9036,399),(9037,399),(9038,399),(9039,399),(9040,399),(9041,399),(9042,399),(9043,1),(9044,2),(9045,6),(9046,7),(9047,390),(9048,400),(9049,400),(9050,400),(9051,400),(9052,400),(9053,400),(9054,400),(9055,400),(9056,1),(9057,2),(9058,1),(9059,2),(9060,11),(9061,12),(9062,163),(9063,164),(9064,7),(9065,10),(9066,11),(9067,12),(9068,163),(9069,164),(9070,7),(9071,1),(9072,2),(9073,6),(9074,7),(9075,390),(9076,1),(9077,2),(9078,6),(9079,7),(9080,390),(9081,400),(9082,392),(9083,393),(9084,394),(9085,395),(9086,396),(9087,397),(9088,398),(9089,399),(9090,400),(9091,399),(9092,1),(9093,2),(9094,6),(9095,7),(9096,390),(9097,401),(9098,401),(9099,401),(9100,401),(9101,401),(9102,401),(9103,401),(9104,401),(9105,1),(9106,2),(9107,6),(9108,7),(9109,390),(9110,402),(9111,402),(9112,402),(9113,402),(9114,402),(9115,402),(9116,402),(9117,402),(9118,1),(9119,2),(9120,6),(9121,7),(9122,390),(9123,403),(9124,403),(9125,403),(9126,403),(9127,403),(9128,403),(9129,403),(9130,403),(9131,1),(9132,2),(9133,12),(9134,404),(9135,404),(9136,404),(9137,404),(9138,404),(9139,404),(9140,404),(9141,404),(9142,1),(9143,2),(9144,12),(9145,404),(9146,405),(9147,405),(9148,405),(9149,405),(9150,405),(9151,405),(9152,405),(9153,405),(9154,1),(9155,2),(9156,12),(9157,404),(9158,406),(9159,406),(9160,406),(9161,406),(9162,406),(9163,406),(9164,406),(9165,406),(9166,1),(9167,2),(9168,12),(9169,404),(9170,407),(9171,407),(9172,407),(9173,407),(9174,407),(9175,407),(9176,407),(9177,407),(9178,1),(9179,2),(9180,12),(9181,404),(9182,408),(9183,408),(9184,408),(9185,408),(9186,408),(9187,408),(9188,408),(9189,408),(9190,1),(9191,2),(9192,12),(9193,404),(9194,409),(9195,409),(9196,409),(9197,409),(9198,409),(9199,409),(9200,409),(9201,409),(9202,1),(9203,2),(9204,12),(9205,404),(9206,410),(9207,410),(9208,410),(9209,410),(9210,410),(9211,410),(9212,410),(9213,410),(9214,1),(9215,2),(9216,12),(9217,404),(9218,411),(9219,411),(9220,411),(9221,411),(9222,411),(9223,411),(9224,411),(9225,411),(9226,1),(9227,2),(9228,12),(9229,412),(9230,412),(9231,412),(9232,412),(9233,412),(9234,412),(9235,412),(9236,412),(9237,1),(9238,2),(9239,12),(9240,412),(9241,413),(9242,413),(9243,413),(9244,413),(9245,413),(9246,413),(9247,413),(9248,413),(9249,1),(9250,2),(9251,12),(9252,412),(9253,414),(9254,414),(9255,414),(9256,414),(9257,414),(9258,414),(9259,414),(9260,414),(9261,1),(9262,2),(9263,12),(9264,412),(9265,415),(9266,415),(9267,415),(9268,415),(9269,415),(9270,415),(9271,415),(9272,415),(9273,1),(9274,2),(9275,12),(9276,412),(9277,416),(9278,416),(9279,416),(9280,416),(9281,416),(9282,416),(9283,416),(9284,416),(9285,1),(9286,2),(9287,12),(9288,412),(9289,417),(9290,417),(9291,417),(9292,417),(9293,417),(9294,417),(9295,417),(9296,417),(9297,1),(9298,2),(9299,12),(9300,412),(9301,418),(9302,418),(9303,418),(9304,418),(9305,418),(9306,418),(9307,418),(9308,418),(9309,1),(9310,2),(9311,12),(9312,412),(9313,419),(9314,419),(9315,419),(9316,419),(9317,419),(9318,419),(9319,419),(9320,419),(9321,1),(9322,2),(9323,12),(9324,412),(9325,420),(9326,420),(9327,420),(9328,420),(9329,420),(9330,420),(9331,420),(9332,420),(9333,1),(9334,2),(9335,12),(9336,412),(9337,421),(9338,421),(9339,421),(9340,421),(9341,421),(9342,421),(9343,421),(9344,421),(9345,1),(9346,2),(9347,12),(9348,412),(9349,422),(9350,422),(9351,422),(9352,422),(9353,422),(9354,422),(9355,422),(9356,422),(9357,1),(9358,2),(9359,12),(9360,412),(9361,423),(9362,423),(9363,423),(9364,423),(9365,423),(9366,423),(9367,423),(9368,423),(9369,1),(9370,2),(9371,12),(9372,412),(9373,424),(9374,424),(9375,424),(9376,424),(9377,424),(9378,424),(9379,424),(9380,424),(9381,1),(9382,2),(9383,12),(9384,412),(9385,425),(9386,425),(9387,425),(9388,425),(9389,425),(9390,425),(9391,425),(9392,425),(9393,1),(9394,2),(9395,12),(9396,412),(9397,426),(9398,426),(9399,426),(9400,426),(9401,426),(9402,426),(9403,426),(9404,426),(9405,1),(9406,2),(9407,12),(9408,412),(9409,427),(9410,427),(9411,427),(9412,427),(9413,427),(9414,427),(9415,427),(9416,427),(9417,1),(9418,2),(9419,12),(9420,428),(9421,428),(9422,428),(9423,428),(9424,428),(9425,428),(9426,428),(9427,428),(9428,1),(9429,2),(9430,12),(9431,428),(9432,429),(9433,429),(9434,429),(9435,429),(9436,429),(9437,429),(9438,429),(9439,429),(9440,1),(9441,2),(9442,12),(9443,428),(9444,430),(9445,430),(9446,430),(9447,430),(9448,430),(9449,430),(9450,430),(9451,430),(9452,1),(9453,2),(9454,12),(9455,428),(9456,431),(9457,431),(9458,431),(9459,431),(9460,431),(9461,431),(9462,431),(9463,431),(9464,1),(9465,2),(9466,12),(9467,428),(9468,432),(9469,432),(9470,432),(9471,432),(9472,432),(9473,432),(9474,432),(9475,432),(9476,1),(9477,2),(9478,12),(9479,428),(9480,433),(9481,433),(9482,433),(9483,433),(9484,433),(9485,433),(9486,433),(9487,433),(9488,1),(9489,2),(9490,12),(9491,428),(9492,434),(9493,434),(9494,434),(9495,434),(9496,434),(9497,434),(9498,434),(9499,434),(9500,1),(9501,2),(9502,12),(9503,428),(9504,435),(9505,435),(9506,435),(9507,435),(9508,435),(9509,435),(9510,435),(9511,435),(9512,1),(9513,2),(9514,12),(9515,428),(9516,436),(9517,436),(9518,436),(9519,436),(9520,436),(9521,436),(9522,436),(9523,436),(9524,1),(9525,2),(9526,12),(9527,428),(9528,437),(9529,437),(9530,437),(9531,437),(9532,437),(9533,437),(9534,437),(9535,437),(9536,1),(9537,2),(9538,12),(9539,438),(9540,438),(9541,438),(9542,438),(9543,438),(9544,438),(9545,438),(9546,438),(9547,1),(9548,2),(9549,12),(9550,438),(9551,439),(9552,439),(9553,439),(9554,439),(9555,439),(9556,439),(9557,439),(9558,439),(9559,1),(9560,2),(9561,12),(9562,438),(9563,440),(9564,440),(9565,440),(9566,440),(9567,440),(9568,440),(9569,440),(9570,440),(9571,1),(9572,2),(9573,12),(9574,438),(9575,441),(9576,441),(9577,441),(9578,441),(9579,441),(9580,441),(9581,441),(9582,441),(9583,1),(9584,2),(9585,12),(9586,438),(9587,442),(9588,442),(9589,442),(9590,442),(9591,442),(9592,442),(9593,442),(9594,442),(9595,1),(9596,2),(9597,12),(9598,438),(9599,443),(9600,443),(9601,443),(9602,443),(9603,443),(9604,443),(9605,443),(9606,443),(9607,1),(9608,2),(9609,1),(9610,2),(9611,163),(9612,164),(9613,10),(9614,11),(9615,12),(9616,163),(9617,164),(9618,12),(9619,10),(9620,10),(9621,10),(9622,11),(9623,11),(9624,11),(9625,203),(9626,405),(9627,1),(9628,2),(9629,12),(9630,404),(9631,444),(9632,444),(9633,444),(9634,444),(9635,444),(9636,444),(9637,444),(9638,444),(9639,1),(9640,2),(9641,12),(9642,404),(9643,1),(9644,2),(9645,12),(9646,404),(9647,405),(9648,406),(9649,407),(9650,408),(9651,409),(9652,410),(9653,411),(9654,444),(9655,444),(9656,444),(9657,406),(9658,407),(9659,408),(9660,409),(9661,410),(9662,411),(9663,413),(9664,414),(9665,415),(9666,416),(9667,417),(9668,418),(9669,419),(9670,420),(9671,422),(9672,424),(9673,425),(9674,426),(9675,427),(9676,429),(9677,430),(9678,431),(9679,432),(9680,433),(9681,434),(9682,435),(9683,436),(9684,437),(9685,439),(9686,441),(9687,442),(9688,443),(9689,440),(9690,368),(9691,143),(9692,371),(9693,373),(9694,374),(9695,375),(9696,376),(9697,377),(9698,366),(9699,307),(9700,121),(9701,123),(9702,118),(9703,379),(9704,113),(9705,132),(9706,381),(9707,382),(9708,124),(9709,128),(9710,125),(9711,383),(9712,126),(9713,385),(9714,386),(9715,387),(9716,1),(9717,2),(9718,6),(9719,7),(9720,385),(9721,445),(9722,445),(9723,445),(9724,445),(9725,445),(9726,445),(9727,445),(9728,445),(9729,445),(9730,308),(9731,309),(9732,310),(9733,311),(9734,312),(9735,313),(9736,108),(9737,314),(9738,315),(9739,322),(9740,324),(9741,325),(9742,326),(9743,328),(9744,327),(9745,145),(9746,329),(9747,330),(9748,331),(9749,336),(9750,345),(9751,346),(9752,338),(9753,339),(9754,340),(9755,341),(9756,342),(9757,359),(9758,360),(9759,361),(9760,362),(9761,88),(9762,89),(9763,90),(9764,91),(9765,93),(9766,94),(9767,95),(9768,100),(9769,102),(9770,103),(9771,101),(9772,104),(9773,105),(9774,97),(9775,98),(9776,99),(9777,351),(9778,352),(9779,353),(9780,354),(9781,355),(9782,17),(9783,16),(9784,198),(9785,18),(9786,200),(9787,24),(9788,205),(9789,365),(9790,349),(9791,210),(9792,211),(9793,212),(9794,213),(9795,214),(9796,215),(9797,216),(9798,15),(9799,221),(9800,222),(9801,27),(9802,33),(9803,32),(9804,30),(9805,208),(9806,60),(9807,227),(9808,190),(9809,229),(9810,231),(9811,232),(9812,233),(9813,234),(9814,235),(9815,236),(9816,237),(9817,238),(9818,176),(9819,167),(9820,172),(9821,239),(9822,177),(9823,180),(9824,178),(9825,241),(9826,242),(9827,243),(9828,244),(9829,1),(9830,446),(9831,446),(9832,446),(9833,446),(9834,446),(9835,446),(9836,446),(9837,446),(9838,1),(9839,446),(9840,447),(9841,447),(9842,447),(9843,447),(9844,447),(9845,447),(9846,447),(9847,447),(9858,1),(9859,2),(9860,449),(9861,449),(9862,449),(9863,449),(9864,449),(9865,449),(9866,449),(9867,449),(9868,449),(9869,2),(9870,2),(9871,449),(9872,1),(9873,2),(9874,450),(9875,450),(9876,450),(9877,450),(9878,450),(9879,450),(9880,450),(9881,450),(9882,450),(9883,219),(9884,1),(9885,2),(9886,450),(9887,25),(9888,5),(9889,3),(9890,3),(9891,219),(9892,15),(9893,5),(9894,7),(9895,7),(9896,12),(9897,12),(9898,12),(9899,219),(9900,8),(9901,8),(9902,9),(9903,9),(9904,9),(9905,15),(9906,15),(9907,15),(9908,8),(9909,219),(9910,165),(9911,219),(9912,15),(9913,8),(9914,8),(9915,12),(9916,366),(9917,367),(9918,135),(9919,7),(9920,7),(9921,366),(9922,367),(9923,367),(9924,318),(9925,318),(9926,318),(9927,318),(9928,318),(9929,145),(9930,318),(9931,318),(9932,346),(9933,8),(9934,8),(9935,318),(9936,106),(9937,307),(9938,318),(9939,106),(9940,307),(9941,5),(9942,5),(9943,5),(9944,5),(9945,5),(9946,5),(9947,5),(9948,5),(9949,5),(9950,5),(9951,5),(9952,5),(9953,7),(9954,346),(9955,5),(9956,318),(9957,318),(9958,318),(9959,5),(9960,5),(9961,7),(9962,7),(9963,7),(9964,366),(9965,366),(9966,366),(9967,219),(9968,219),(9969,219),(9970,318),(9971,318),(9972,318),(9973,318),(9974,163),(9975,3),(9976,3),(9977,3),(9978,219),(9979,219),(9980,219),(9981,4),(9982,4),(9983,4),(9984,71),(9985,71),(9986,71),(9987,37),(9988,25),(9989,25),(9990,25),(9991,9),(9992,9),(9993,9),(9994,5),(9995,5),(9996,5),(9997,4),(9998,145),(9999,145),(10000,4),(10001,4),(10002,4),(10003,4),(10004,253),(10005,253),(10006,253),(10007,4),(10008,71),(10009,71),(10010,71),(10011,4),(10012,4),(10013,4),(10014,37),(10015,37),(10016,4),(10017,4),(10018,318),(10019,4),(10020,4),(10021,318),(10022,343),(10023,343),(10024,4),(10025,4);
/*!40000 ALTER TABLE `catalog_category_product_cl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_product_index`
--

DROP TABLE IF EXISTS `catalog_category_product_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_product_index` (
  `category_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Category ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `position` int DEFAULT NULL COMMENT 'Position',
  `is_parent` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Parent',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `visibility` smallint unsigned NOT NULL COMMENT 'Visibility',
  PRIMARY KEY (`category_id`,`product_id`,`store_id`),
  KEY `CAT_CTGR_PRD_IDX_PRD_ID_STORE_ID_CTGR_ID_VISIBILITY` (`product_id`,`store_id`,`category_id`,`visibility`),
  KEY `CAT_CTGR_PRD_IDX_STORE_ID_CTGR_ID_VISIBILITY_IS_PARENT_POSITION` (`store_id`,`category_id`,`visibility`,`is_parent`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Product Index';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_product_index`
--

LOCK TABLES `catalog_category_product_index` WRITE;
/*!40000 ALTER TABLE `catalog_category_product_index` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_category_product_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_product_index_replica`
--

DROP TABLE IF EXISTS `catalog_category_product_index_replica`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_product_index_replica` (
  `category_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Category ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `position` int DEFAULT NULL COMMENT 'Position',
  `is_parent` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Parent',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `visibility` smallint unsigned NOT NULL COMMENT 'Visibility',
  PRIMARY KEY (`category_id`,`product_id`,`store_id`),
  KEY `CAT_CTGR_PRD_IDX_PRD_ID_STORE_ID_CTGR_ID_VISIBILITY` (`product_id`,`store_id`,`category_id`,`visibility`),
  KEY `CAT_CTGR_PRD_IDX_STORE_ID_CTGR_ID_VISIBILITY_IS_PARENT_POSITION` (`store_id`,`category_id`,`visibility`,`is_parent`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Product Index';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_product_index_replica`
--

LOCK TABLES `catalog_category_product_index_replica` WRITE;
/*!40000 ALTER TABLE `catalog_category_product_index_replica` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_category_product_index_replica` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_product_index_store1`
--

DROP TABLE IF EXISTS `catalog_category_product_index_store1`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_product_index_store1` (
  `category_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Category Id',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product Id',
  `position` int DEFAULT NULL COMMENT 'Position',
  `is_parent` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Parent',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `visibility` smallint unsigned NOT NULL COMMENT 'Visibility',
  PRIMARY KEY (`category_id`,`product_id`,`store_id`),
  KEY `IDX_4B965DC45C352D6E4C9DC0FF50B1FCF5` (`product_id`,`store_id`,`category_id`,`visibility`),
  KEY `IDX_47AB760CD6A893ACEA69A9C2E0112C60` (`store_id`,`category_id`,`visibility`,`is_parent`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Product Index Store1';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_product_index_store1`
--

LOCK TABLES `catalog_category_product_index_store1` WRITE;
/*!40000 ALTER TABLE `catalog_category_product_index_store1` DISABLE KEYS */;
INSERT INTO `catalog_category_product_index_store1` VALUES (2,6219,10000,0,1,2),(2,6257,10000,0,1,2),(2,6353,10000,0,1,2),(2,6547,10000,0,1,2),(2,6548,10000,0,1,2),(2,6549,10000,0,1,2),(2,6551,10000,0,1,2),(2,6552,10000,0,1,2),(2,6553,10000,0,1,2),(2,6554,10000,0,1,2),(2,6555,10000,0,1,2),(2,6556,10000,0,1,2),(2,6559,10000,0,1,2),(2,6560,10000,0,1,2),(2,6561,10000,0,1,2),(2,5760,0,0,1,4),(2,6035,0,0,1,4),(2,6041,10000,0,1,4),(2,6042,10000,0,1,4),(2,6043,10000,0,1,4),(2,6044,10000,0,1,4),(2,6045,10000,0,1,4),(2,6046,10000,0,1,4),(2,6047,10000,0,1,4),(2,6048,10000,0,1,4),(2,6049,10000,0,1,4),(2,6050,10000,0,1,4),(2,6051,10000,0,1,4),(2,6052,10000,0,1,4),(2,6053,10000,0,1,4),(2,6054,10000,0,1,4),(2,6055,10000,0,1,4),(2,6056,10000,0,1,4),(2,6057,10000,0,1,4),(2,6058,10000,0,1,4),(2,6059,10000,0,1,4),(2,6060,10000,0,1,4),(2,6061,10000,0,1,4),(2,6062,10000,0,1,4),(2,6063,10000,0,1,4),(2,6064,10000,0,1,4),(2,6065,10000,0,1,4),(2,6066,10000,0,1,4),(2,6067,10000,0,1,4),(2,6068,10000,0,1,4),(2,6069,10000,0,1,4),(2,6070,10000,0,1,4),(2,6071,10000,0,1,4),(2,6072,10000,0,1,4),(2,6073,10000,0,1,4),(2,6074,10000,0,1,4),(2,6075,10000,0,1,4),(2,6076,10000,0,1,4),(2,6077,10000,0,1,4),(2,6078,10000,0,1,4),(2,6079,10000,0,1,4),(2,6080,10000,0,1,4),(2,6081,10000,0,1,4),(2,6082,10000,0,1,4),(2,6083,10000,0,1,4),(2,6084,10000,0,1,4),(2,6085,10000,0,1,4),(2,6086,10000,0,1,4),(2,6087,10000,0,1,4),(2,6088,10000,0,1,4),(2,6089,10000,0,1,4),(2,6090,10000,0,1,4),(2,6091,10000,0,1,4),(2,6092,10000,0,1,4),(2,6093,10000,0,1,4),(2,6094,10000,0,1,4),(2,6095,10000,0,1,4),(2,6096,10000,0,1,4),(2,6097,10000,0,1,4),(2,6098,10000,0,1,4),(2,6099,10000,0,1,4),(2,6100,10000,0,1,4),(2,6101,10000,0,1,4),(2,6102,10000,0,1,4),(2,6103,10000,0,1,4),(2,6104,10000,0,1,4),(2,6105,10000,0,1,4),(2,6106,10000,0,1,4),(2,6107,10000,0,1,4),(2,6108,10000,0,1,4),(2,6109,10000,0,1,4),(2,6110,10000,0,1,4),(2,6111,10000,0,1,4),(2,6112,10000,0,1,4),(2,6113,10000,0,1,4),(2,6114,10000,0,1,4),(2,6115,10000,0,1,4),(2,6116,10000,0,1,4),(2,6117,10000,0,1,4),(2,6118,10000,0,1,4),(2,6119,10000,0,1,4),(2,6120,10000,0,1,4),(2,6121,10000,0,1,4),(2,6122,10000,0,1,4),(2,6123,10000,0,1,4),(2,6124,10000,0,1,4),(2,6125,10000,0,1,4),(2,6126,10000,0,1,4),(2,6127,10000,0,1,4),(2,6128,10000,0,1,4),(2,6129,10000,0,1,4),(2,6130,10000,0,1,4),(2,6131,10000,0,1,4),(2,6132,10000,0,1,4),(2,6133,10000,0,1,4),(2,6134,10000,0,1,4),(2,6135,10000,0,1,4),(2,6136,10000,0,1,4),(2,6137,10000,0,1,4),(2,6138,10000,0,1,4),(2,6139,10000,0,1,4),(2,6140,10000,0,1,4),(2,6141,10000,0,1,4),(2,6142,10000,0,1,4),(2,6143,10000,0,1,4),(2,6144,10000,0,1,4),(2,6145,10000,0,1,4),(2,6146,10000,0,1,4),(2,6147,10000,0,1,4),(2,6148,10000,0,1,4),(2,6149,10000,0,1,4),(2,6150,10000,0,1,4),(2,6151,10000,0,1,4),(2,6152,10000,0,1,4),(2,6153,10000,0,1,4),(2,6154,10000,0,1,4),(2,6155,10000,0,1,4),(2,6156,10000,0,1,4),(2,6157,10000,0,1,4),(2,6158,10000,0,1,4),(2,6159,10000,0,1,4),(2,6160,10000,0,1,4),(2,6161,10000,0,1,4),(2,6162,10000,0,1,4),(2,6163,10000,0,1,4),(2,6164,10000,0,1,4),(2,6165,10000,0,1,4),(2,6166,10000,0,1,4),(2,6167,10000,0,1,4),(2,6168,10000,0,1,4),(2,6169,10000,0,1,4),(2,6170,10000,0,1,4),(2,6171,10000,0,1,4),(2,6172,10000,0,1,4),(2,6173,10000,0,1,4),(2,6174,10000,0,1,4),(2,6175,10000,0,1,4),(2,6176,10000,0,1,4),(2,6177,10000,0,1,4),(2,6178,10000,0,1,4),(2,6179,10000,0,1,4),(2,6180,10000,0,1,4),(2,6181,10000,0,1,4),(2,6182,10000,0,1,4),(2,6183,10000,0,1,4),(2,6184,10000,0,1,4),(2,6185,10000,0,1,4),(2,6186,10000,0,1,4),(2,6187,10000,0,1,4),(2,6188,10000,0,1,4),(2,6189,10000,0,1,4),(2,6190,10000,0,1,4),(2,6191,10000,0,1,4),(2,6192,10000,0,1,4),(2,6193,10000,0,1,4),(2,6194,10000,0,1,4),(2,6195,10000,0,1,4),(2,6196,10000,0,1,4),(2,6197,10000,0,1,4),(2,6198,10000,0,1,4),(2,6199,10000,0,1,4),(2,6200,10000,0,1,4),(2,6201,10000,0,1,4),(2,6202,10000,0,1,4),(2,6203,10000,0,1,4),(2,6204,10000,0,1,4),(2,6205,10000,0,1,4),(2,6206,10000,0,1,4),(2,6207,10000,0,1,4),(2,6208,10000,0,1,4),(2,6209,10000,0,1,4),(2,6210,10000,0,1,4),(2,6211,10000,0,1,4),(2,6212,10000,0,1,4),(2,6213,10000,0,1,4),(2,6214,10000,0,1,4),(2,6215,10000,0,1,4),(2,6216,10000,0,1,4),(2,6217,10000,0,1,4),(2,6218,10000,0,1,4),(2,6220,10000,0,1,4),(2,6221,10000,0,1,4),(2,6222,10000,0,1,4),(2,6223,10000,0,1,4),(2,6224,10000,0,1,4),(2,6225,10000,0,1,4),(2,6226,10000,0,1,4),(2,6227,10000,0,1,4),(2,6228,10000,0,1,4),(2,6229,10000,0,1,4),(2,6230,10000,0,1,4),(2,6231,10000,0,1,4),(2,6232,10000,0,1,4),(2,6233,10000,0,1,4),(2,6234,10000,0,1,4),(2,6235,10000,0,1,4),(2,6236,10000,0,1,4),(2,6237,10000,0,1,4),(2,6238,10000,0,1,4),(2,6239,10000,0,1,4),(2,6240,10000,0,1,4),(2,6241,10000,0,1,4),(2,6242,10000,0,1,4),(2,6243,10000,0,1,4),(2,6244,10000,0,1,4),(2,6245,10000,0,1,4),(2,6246,10000,0,1,4),(2,6247,10000,0,1,4),(2,6248,10000,0,1,4),(2,6249,10000,0,1,4),(2,6250,10000,0,1,4),(2,6251,10000,0,1,4),(2,6252,10000,0,1,4),(2,6253,10000,0,1,4),(2,6254,10000,0,1,4),(2,6255,10000,0,1,4),(2,6256,10000,0,1,4),(2,6258,10000,0,1,4),(2,6259,10000,0,1,4),(2,6260,10000,0,1,4),(2,6261,10000,0,1,4),(2,6262,10000,0,1,4),(2,6263,10000,0,1,4),(2,6264,10000,0,1,4),(2,6265,10000,0,1,4),(2,6266,10000,0,1,4),(2,6267,10000,0,1,4),(2,6268,10000,0,1,4),(2,6269,10000,0,1,4),(2,6270,10000,0,1,4),(2,6271,10000,0,1,4),(2,6272,10000,0,1,4),(2,6273,10000,0,1,4),(2,6274,10000,0,1,4),(2,6275,10000,0,1,4),(2,6276,10000,0,1,4),(2,6277,10000,0,1,4),(2,6278,10000,0,1,4),(2,6279,10000,0,1,4),(2,6280,10000,0,1,4),(2,6281,10000,0,1,4),(2,6282,10000,0,1,4),(2,6283,10000,0,1,4),(2,6284,10000,0,1,4),(2,6285,10000,0,1,4),(2,6286,10000,0,1,4),(2,6287,10000,0,1,4),(2,6288,10000,0,1,4),(2,6289,10000,0,1,4),(2,6290,10000,0,1,4),(2,6291,10000,0,1,4),(2,6292,10000,0,1,4),(2,6294,10000,0,1,4),(2,6295,10000,0,1,4),(2,6296,10000,0,1,4),(2,6297,10000,0,1,4),(2,6298,10000,0,1,4),(2,6300,10000,0,1,4),(2,6301,10000,0,1,4),(2,6302,10000,0,1,4),(2,6303,10000,0,1,4),(2,6304,10000,0,1,4),(2,6305,10000,0,1,4),(2,6306,10000,0,1,4),(2,6307,10000,0,1,4),(2,6308,10000,0,1,4),(2,6309,10000,0,1,4),(2,6312,10000,0,1,4),(2,6313,10000,0,1,4),(2,6314,10000,0,1,4),(2,6315,10000,0,1,4),(2,6316,10000,0,1,4),(2,6317,10000,0,1,4),(2,6318,10000,0,1,4),(2,6319,10000,0,1,4),(2,6320,10000,0,1,4),(2,6321,10000,0,1,4),(2,6322,10000,0,1,4),(2,6323,10000,0,1,4),(2,6324,10000,0,1,4),(2,6325,10000,0,1,4),(2,6326,10000,0,1,4),(2,6327,10000,0,1,4),(2,6328,10000,0,1,4),(2,6329,10000,0,1,4),(2,6330,10000,0,1,4),(2,6331,10000,0,1,4),(2,6332,10000,0,1,4),(2,6333,10000,0,1,4),(2,6334,10000,0,1,4),(2,6335,10000,0,1,4),(2,6336,10000,0,1,4),(2,6337,10000,0,1,4),(2,6338,10000,0,1,4),(2,6339,10000,0,1,4),(2,6340,10000,0,1,4),(2,6341,10000,0,1,4),(2,6342,10000,0,1,4),(2,6343,10000,0,1,4),(2,6344,10000,0,1,4),(2,6345,10000,0,1,4),(2,6346,10000,0,1,4),(2,6347,10000,0,1,4),(2,6348,10000,0,1,4),(2,6349,10000,0,1,4),(2,6350,10000,0,1,4),(2,6351,10000,0,1,4),(2,6352,10000,0,1,4),(2,6354,10000,0,1,4),(2,6355,10000,0,1,4),(2,6356,10000,0,1,4),(2,6357,10000,0,1,4),(2,6358,10000,0,1,4),(2,6359,10000,0,1,4),(2,6360,10000,0,1,4),(2,6361,10000,0,1,4),(2,6362,10000,0,1,4),(2,6363,10000,0,1,4),(2,6364,10000,0,1,4),(2,6365,10000,0,1,4),(2,6366,10000,0,1,4),(2,6367,10000,0,1,4),(2,6368,10000,0,1,4),(2,6369,10000,0,1,4),(2,6370,10000,0,1,4),(2,6371,10000,0,1,4),(2,6372,10000,0,1,4),(2,6373,10000,0,1,4),(2,6374,10000,0,1,4),(2,6375,10000,0,1,4),(2,6376,10000,0,1,4),(2,6377,10000,0,1,4),(2,6378,10000,0,1,4),(2,6379,10000,0,1,4),(2,6380,10000,0,1,4),(2,6381,10000,0,1,4),(2,6382,10000,0,1,4),(2,6383,10000,0,1,4),(2,6384,10000,0,1,4),(2,6385,10000,0,1,4),(2,6386,10000,0,1,4),(2,6387,10000,0,1,4),(2,6388,10000,0,1,4),(2,6389,10000,0,1,4),(2,6390,10000,0,1,4),(2,6391,10000,0,1,4),(2,6392,10000,0,1,4),(2,6393,10000,0,1,4),(2,6394,10000,0,1,4),(2,6395,10000,0,1,4),(2,6396,10000,0,1,4),(2,6397,10000,0,1,4),(2,6398,10000,0,1,4),(2,6399,10000,0,1,4),(2,6400,10000,0,1,4),(2,6401,10000,0,1,4),(2,6402,10000,0,1,4),(2,6403,10000,0,1,4),(2,6404,10000,0,1,4),(2,6405,10000,0,1,4),(2,6406,10000,0,1,4),(2,6407,10000,0,1,4),(2,6408,10000,0,1,4),(2,6409,10000,0,1,4),(2,6410,10000,0,1,4),(2,6411,10000,0,1,4),(2,6412,10000,0,1,4),(2,6413,10000,0,1,4),(2,6414,10000,0,1,4),(2,6415,10000,0,1,4),(2,6416,10000,0,1,4),(2,6417,10000,0,1,4),(2,6418,10000,0,1,4),(2,6419,10000,0,1,4),(2,6420,10000,0,1,4),(2,6421,10000,0,1,4),(2,6422,10000,0,1,4),(2,6423,10000,0,1,4),(2,6424,10000,0,1,4),(2,6425,10000,0,1,4),(2,6426,10000,0,1,4),(2,6427,10000,0,1,4),(2,6428,10000,0,1,4),(2,6429,10000,0,1,4),(2,6430,10000,0,1,4),(2,6431,10000,0,1,4),(2,6432,10000,0,1,4),(2,6433,10000,0,1,4),(2,6434,10000,0,1,4),(2,6435,10000,0,1,4),(2,6436,10000,0,1,4),(2,6437,10000,0,1,4),(2,6438,10000,0,1,4),(2,6439,10000,0,1,4),(2,6440,10000,0,1,4),(2,6441,10000,0,1,4),(2,6442,10000,0,1,4),(2,6443,10000,0,1,4),(2,6444,10000,0,1,4),(2,6445,10000,0,1,4),(2,6446,10000,0,1,4),(2,6447,10000,0,1,4),(2,6448,10000,0,1,4),(2,6449,10000,0,1,4),(2,6450,10000,0,1,4),(2,6451,10000,0,1,4),(2,6452,10000,0,1,4),(2,6453,10000,0,1,4),(2,6454,10000,0,1,4),(2,6455,10000,0,1,4),(2,6456,10000,0,1,4),(2,6457,10000,0,1,4),(2,6458,10000,0,1,4),(2,6459,10000,0,1,4),(2,6460,10000,0,1,4),(2,6461,10000,0,1,4),(2,6462,10000,0,1,4),(2,6463,10000,0,1,4),(2,6464,10000,0,1,4),(2,6465,10000,0,1,4),(2,6466,10000,0,1,4),(2,6467,10000,0,1,4),(2,6468,10000,0,1,4),(2,6469,10000,0,1,4),(2,6470,10000,0,1,4),(2,6471,10000,0,1,4),(2,6472,10000,0,1,4),(2,6473,10000,0,1,4),(2,6474,10000,0,1,4),(2,6475,10000,0,1,4),(2,6476,10000,0,1,4),(2,6477,10000,0,1,4),(2,6478,10000,0,1,4),(2,6479,10000,0,1,4),(2,6480,10000,0,1,4),(2,6481,10000,0,1,4),(2,6482,10000,0,1,4),(2,6483,10000,0,1,4),(2,6484,10000,0,1,4),(2,6485,10000,0,1,4),(2,6486,10000,0,1,4),(2,6487,10000,0,1,4),(2,6488,10000,0,1,4),(2,6489,10000,0,1,4),(2,6490,10000,0,1,4),(2,6491,10000,0,1,4),(2,6492,10000,0,1,4),(2,6493,10000,0,1,4),(2,6494,10000,0,1,4),(2,6495,10000,0,1,4),(2,6496,10000,0,1,4),(2,6497,10000,0,1,4),(2,6498,10000,0,1,4),(2,6499,10000,0,1,4),(2,6500,10000,0,1,4),(2,6501,10000,0,1,4),(2,6502,10000,0,1,4),(2,6503,10000,0,1,4),(2,6504,10000,0,1,4),(2,6505,10000,0,1,4),(2,6506,10000,0,1,4),(2,6507,10000,0,1,4),(2,6508,10000,0,1,4),(2,6509,10000,0,1,4),(2,6510,10000,0,1,4),(2,6511,10000,0,1,4),(2,6512,10000,0,1,4),(2,6513,10000,0,1,4),(2,6514,10000,0,1,4),(2,6515,10000,0,1,4),(2,6516,10000,0,1,4),(2,6517,10000,0,1,4),(2,6518,10000,0,1,4),(2,6519,10000,0,1,4),(2,6520,10000,0,1,4),(2,6521,10000,0,1,4),(2,6522,10000,0,1,4),(2,6523,10000,0,1,4),(2,6524,10000,0,1,4),(2,6525,10000,0,1,4),(2,6526,10000,0,1,4),(2,6527,10000,0,1,4),(2,6528,10000,0,1,4),(2,6529,10000,0,1,4),(2,6530,10000,0,1,4),(2,6531,10000,0,1,4),(2,6532,10000,0,1,4),(2,6533,10000,0,1,4),(2,6534,10000,0,1,4),(2,6535,10000,0,1,4),(2,6536,10000,0,1,4),(2,6537,10000,0,1,4),(2,6538,10000,0,1,4),(2,6539,10000,0,1,4),(2,6540,10000,0,1,4),(2,6541,10000,0,1,4),(2,6542,10000,0,1,4),(2,6543,10000,0,1,4),(2,6544,10000,0,1,4),(2,6545,10000,0,1,4),(2,6546,10000,0,1,4),(2,6550,10000,0,1,4),(2,6557,10000,0,1,4),(2,6558,10000,0,1,4),(2,6562,10000,0,1,4),(2,6563,10000,0,1,4),(2,6564,10000,0,1,4),(2,6565,10000,0,1,4),(2,6566,10000,0,1,4),(2,6567,10000,0,1,4),(2,6568,10000,0,1,4),(2,6569,10000,0,1,4),(2,6570,10000,0,1,4),(2,6571,10000,0,1,4),(2,6572,10000,0,1,4),(2,6036,0,1,1,4),(2,6037,0,1,1,4),(2,6038,0,1,1,4),(2,6039,0,1,1,4),(2,6040,0,1,1,4),(2,6293,0,1,1,4),(2,6299,0,1,1,4),(2,6310,0,1,1,4),(2,6311,0,1,1,4),(3,5760,0,1,1,4),(3,6035,0,1,1,4),(5,6326,10000,0,1,4),(5,6327,10000,0,1,4),(5,6328,10000,0,1,4),(5,6329,10000,0,1,4),(5,6330,10000,0,1,4),(5,6331,10000,0,1,4),(5,6332,10000,0,1,4),(5,6333,10000,0,1,4),(5,6334,10000,0,1,4),(5,6335,10000,0,1,4),(5,6336,10000,0,1,4),(5,6337,10000,0,1,4),(5,6338,10000,0,1,4),(5,6339,10000,0,1,4),(5,6340,10000,0,1,4),(5,6341,10000,0,1,4),(5,6342,10000,0,1,4),(5,6343,10000,0,1,4),(5,6344,10000,0,1,4),(5,6345,10000,0,1,4),(5,5760,0,1,1,4),(5,6035,0,1,1,4),(6,5760,0,1,1,4),(7,5760,0,1,1,4),(7,6035,0,1,1,4),(10,5760,0,1,1,4),(10,6035,0,1,1,4),(11,5760,0,1,1,4),(11,6035,0,1,1,4),(12,5760,0,1,1,4),(12,6035,0,1,1,4),(145,5760,0,1,1,4),(163,6035,0,1,1,4),(163,6036,0,1,1,4),(163,6037,0,1,1,4),(163,6038,0,1,1,4),(163,6039,0,1,1,4),(163,6040,0,1,1,4),(163,6293,0,1,1,4),(163,6299,0,1,1,4),(163,6310,0,1,1,4),(163,6311,0,1,1,4),(163,6332,0,1,1,4),(163,6333,0,1,1,4),(163,6334,0,1,1,4),(163,6335,0,1,1,4),(163,6336,0,1,1,4),(163,6337,0,1,1,4),(164,5760,0,1,1,4),(164,6035,0,1,1,4),(318,6326,0,1,1,4),(318,6327,0,1,1,4),(318,6328,0,1,1,4),(318,6329,0,1,1,4),(318,6330,0,1,1,4),(318,6331,0,1,1,4),(318,6332,0,1,1,4),(318,6333,0,1,1,4),(318,6334,0,1,1,4),(318,6335,0,1,1,4),(318,6336,0,1,1,4),(318,6337,0,1,1,4),(318,6338,0,1,1,4),(318,6339,0,1,1,4),(318,6340,0,1,1,4),(318,6341,0,1,1,4),(318,6342,0,1,1,4),(318,6343,0,1,1,4),(318,6344,0,1,1,4),(318,6345,0,1,1,4),(343,5760,0,1,1,4),(356,5760,0,1,1,4),(366,5760,0,1,1,4),(449,5760,0,1,1,4),(449,6035,0,1,1,4);
/*!40000 ALTER TABLE `catalog_category_product_index_store1` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_product_index_store1_replica`
--

DROP TABLE IF EXISTS `catalog_category_product_index_store1_replica`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_product_index_store1_replica` (
  `category_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Category Id',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product Id',
  `position` int DEFAULT NULL COMMENT 'Position',
  `is_parent` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Parent',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `visibility` smallint unsigned NOT NULL COMMENT 'Visibility',
  PRIMARY KEY (`category_id`,`product_id`,`store_id`),
  KEY `CAT_CTGR_PRD_IDX_STORE1_PRD_ID_STORE_ID_CTGR_ID_VISIBILITY` (`product_id`,`store_id`,`category_id`,`visibility`),
  KEY `IDX_216E521C8AD125E066D2B0BAB4A08412` (`store_id`,`category_id`,`visibility`,`is_parent`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Product Index Store1 Replica';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_product_index_store1_replica`
--

LOCK TABLES `catalog_category_product_index_store1_replica` WRITE;
/*!40000 ALTER TABLE `catalog_category_product_index_store1_replica` DISABLE KEYS */;
INSERT INTO `catalog_category_product_index_store1_replica` VALUES (2,6219,10000,0,1,2),(2,6257,10000,0,1,2),(2,5760,0,0,1,4),(2,6035,0,0,1,4),(2,6036,10000,0,1,4),(2,6037,10000,0,1,4),(2,6038,10000,0,1,4),(2,6039,10000,0,1,4),(2,6040,10000,0,1,4),(2,6041,10000,0,1,4),(2,6042,10000,0,1,4),(2,6043,10000,0,1,4),(2,6044,10000,0,1,4),(2,6045,10000,0,1,4),(2,6046,10000,0,1,4),(2,6047,10000,0,1,4),(2,6048,10000,0,1,4),(2,6049,10000,0,1,4),(2,6050,10000,0,1,4),(2,6051,10000,0,1,4),(2,6052,10000,0,1,4),(2,6053,10000,0,1,4),(2,6054,10000,0,1,4),(2,6055,10000,0,1,4),(2,6056,10000,0,1,4),(2,6057,10000,0,1,4),(2,6058,10000,0,1,4),(2,6059,10000,0,1,4),(2,6060,10000,0,1,4),(2,6061,10000,0,1,4),(2,6062,10000,0,1,4),(2,6063,10000,0,1,4),(2,6064,10000,0,1,4),(2,6065,10000,0,1,4),(2,6066,10000,0,1,4),(2,6067,10000,0,1,4),(2,6068,10000,0,1,4),(2,6069,10000,0,1,4),(2,6070,10000,0,1,4),(2,6071,10000,0,1,4),(2,6072,10000,0,1,4),(2,6073,10000,0,1,4),(2,6074,10000,0,1,4),(2,6075,10000,0,1,4),(2,6076,10000,0,1,4),(2,6077,10000,0,1,4),(2,6078,10000,0,1,4),(2,6079,10000,0,1,4),(2,6080,10000,0,1,4),(2,6081,10000,0,1,4),(2,6082,10000,0,1,4),(2,6083,10000,0,1,4),(2,6084,10000,0,1,4),(2,6085,10000,0,1,4),(2,6086,10000,0,1,4),(2,6087,10000,0,1,4),(2,6088,10000,0,1,4),(2,6089,10000,0,1,4),(2,6090,10000,0,1,4),(2,6091,10000,0,1,4),(2,6092,10000,0,1,4),(2,6093,10000,0,1,4),(2,6094,10000,0,1,4),(2,6095,10000,0,1,4),(2,6096,10000,0,1,4),(2,6097,10000,0,1,4),(2,6098,10000,0,1,4),(2,6099,10000,0,1,4),(2,6100,10000,0,1,4),(2,6101,10000,0,1,4),(2,6102,10000,0,1,4),(2,6103,10000,0,1,4),(2,6104,10000,0,1,4),(2,6105,10000,0,1,4),(2,6106,10000,0,1,4),(2,6107,10000,0,1,4),(2,6108,10000,0,1,4),(2,6109,10000,0,1,4),(2,6110,10000,0,1,4),(2,6111,10000,0,1,4),(2,6112,10000,0,1,4),(2,6113,10000,0,1,4),(2,6114,10000,0,1,4),(2,6115,10000,0,1,4),(2,6116,10000,0,1,4),(2,6117,10000,0,1,4),(2,6118,10000,0,1,4),(2,6119,10000,0,1,4),(2,6120,10000,0,1,4),(2,6121,10000,0,1,4),(2,6122,10000,0,1,4),(2,6123,10000,0,1,4),(2,6124,10000,0,1,4),(2,6125,10000,0,1,4),(2,6126,10000,0,1,4),(2,6127,10000,0,1,4),(2,6128,10000,0,1,4),(2,6129,10000,0,1,4),(2,6130,10000,0,1,4),(2,6131,10000,0,1,4),(2,6132,10000,0,1,4),(2,6133,10000,0,1,4),(2,6134,10000,0,1,4),(2,6135,10000,0,1,4),(2,6136,10000,0,1,4),(2,6137,10000,0,1,4),(2,6138,10000,0,1,4),(2,6139,10000,0,1,4),(2,6140,10000,0,1,4),(2,6141,10000,0,1,4),(2,6142,10000,0,1,4),(2,6143,10000,0,1,4),(2,6144,10000,0,1,4),(2,6145,10000,0,1,4),(2,6146,10000,0,1,4),(2,6147,10000,0,1,4),(2,6148,10000,0,1,4),(2,6149,10000,0,1,4),(2,6150,10000,0,1,4),(2,6151,10000,0,1,4),(2,6152,10000,0,1,4),(2,6153,10000,0,1,4),(2,6154,10000,0,1,4),(2,6155,10000,0,1,4),(2,6156,10000,0,1,4),(2,6157,10000,0,1,4),(2,6158,10000,0,1,4),(2,6159,10000,0,1,4),(2,6160,10000,0,1,4),(2,6161,10000,0,1,4),(2,6162,10000,0,1,4),(2,6163,10000,0,1,4),(2,6164,10000,0,1,4),(2,6165,10000,0,1,4),(2,6166,10000,0,1,4),(2,6167,10000,0,1,4),(2,6168,10000,0,1,4),(2,6169,10000,0,1,4),(2,6170,10000,0,1,4),(2,6171,10000,0,1,4),(2,6172,10000,0,1,4),(2,6173,10000,0,1,4),(2,6174,10000,0,1,4),(2,6175,10000,0,1,4),(2,6176,10000,0,1,4),(2,6177,10000,0,1,4),(2,6178,10000,0,1,4),(2,6179,10000,0,1,4),(2,6180,10000,0,1,4),(2,6181,10000,0,1,4),(2,6182,10000,0,1,4),(2,6183,10000,0,1,4),(2,6184,10000,0,1,4),(2,6185,10000,0,1,4),(2,6186,10000,0,1,4),(2,6187,10000,0,1,4),(2,6188,10000,0,1,4),(2,6189,10000,0,1,4),(2,6190,10000,0,1,4),(2,6191,10000,0,1,4),(2,6192,10000,0,1,4),(2,6193,10000,0,1,4),(2,6194,10000,0,1,4),(2,6195,10000,0,1,4),(2,6196,10000,0,1,4),(2,6197,10000,0,1,4),(2,6198,10000,0,1,4),(2,6199,10000,0,1,4),(2,6200,10000,0,1,4),(2,6201,10000,0,1,4),(2,6202,10000,0,1,4),(2,6203,10000,0,1,4),(2,6204,10000,0,1,4),(2,6205,10000,0,1,4),(2,6206,10000,0,1,4),(2,6207,10000,0,1,4),(2,6208,10000,0,1,4),(2,6209,10000,0,1,4),(2,6210,10000,0,1,4),(2,6211,10000,0,1,4),(2,6212,10000,0,1,4),(2,6213,10000,0,1,4),(2,6214,10000,0,1,4),(2,6215,10000,0,1,4),(2,6216,10000,0,1,4),(2,6217,10000,0,1,4),(2,6218,10000,0,1,4),(2,6220,10000,0,1,4),(2,6221,10000,0,1,4),(2,6222,10000,0,1,4),(2,6223,10000,0,1,4),(2,6224,10000,0,1,4),(2,6225,10000,0,1,4),(2,6226,10000,0,1,4),(2,6227,10000,0,1,4),(2,6228,10000,0,1,4),(2,6229,10000,0,1,4),(2,6230,10000,0,1,4),(2,6231,10000,0,1,4),(2,6232,10000,0,1,4),(2,6233,10000,0,1,4),(2,6234,10000,0,1,4),(2,6235,10000,0,1,4),(2,6236,10000,0,1,4),(2,6237,10000,0,1,4),(2,6238,10000,0,1,4),(2,6239,10000,0,1,4),(2,6240,10000,0,1,4),(2,6241,10000,0,1,4),(2,6242,10000,0,1,4),(2,6243,10000,0,1,4),(2,6244,10000,0,1,4),(2,6245,10000,0,1,4),(2,6246,10000,0,1,4),(2,6247,10000,0,1,4),(2,6248,10000,0,1,4),(2,6249,10000,0,1,4),(2,6250,10000,0,1,4),(2,6251,10000,0,1,4),(2,6252,10000,0,1,4),(2,6253,10000,0,1,4),(2,6254,10000,0,1,4),(2,6255,10000,0,1,4),(2,6256,10000,0,1,4),(2,6258,10000,0,1,4),(2,6259,10000,0,1,4),(2,6260,10000,0,1,4),(2,6261,10000,0,1,4),(2,6262,10000,0,1,4),(2,6263,10000,0,1,4),(2,6264,10000,0,1,4),(2,6265,10000,0,1,4),(2,6266,10000,0,1,4),(2,6267,10000,0,1,4),(2,6268,10000,0,1,4),(2,6269,10000,0,1,4),(2,6270,10000,0,1,4),(2,6271,10000,0,1,4),(2,6272,10000,0,1,4),(2,6273,10000,0,1,4),(2,6274,10000,0,1,4),(2,6275,10000,0,1,4),(2,6276,10000,0,1,4),(2,6277,10000,0,1,4),(2,6278,10000,0,1,4),(2,6279,10000,0,1,4),(2,6280,10000,0,1,4),(2,6281,10000,0,1,4),(2,6282,10000,0,1,4),(2,6283,10000,0,1,4),(2,6284,10000,0,1,4),(2,6285,10000,0,1,4),(2,6286,10000,0,1,4),(2,6287,10000,0,1,4),(2,6288,10000,0,1,4),(2,6289,10000,0,1,4),(2,6290,10000,0,1,4),(2,6291,10000,0,1,4),(2,6292,10000,0,1,4),(2,6294,10000,0,1,4),(2,6295,10000,0,1,4),(2,6296,10000,0,1,4),(2,6297,10000,0,1,4),(2,6298,10000,0,1,4),(2,6300,10000,0,1,4),(2,6301,10000,0,1,4),(2,6302,10000,0,1,4),(2,6303,10000,0,1,4),(2,6304,10000,0,1,4),(2,6305,10000,0,1,4),(2,6306,10000,0,1,4),(2,6307,10000,0,1,4),(2,6308,10000,0,1,4),(2,6309,10000,0,1,4),(2,6312,10000,0,1,4),(2,6313,10000,0,1,4),(2,6314,10000,0,1,4),(2,6315,10000,0,1,4),(2,6316,10000,0,1,4),(2,6317,10000,0,1,4),(2,6318,10000,0,1,4),(2,6319,10000,0,1,4),(2,6320,10000,0,1,4),(2,6321,10000,0,1,4),(2,6322,10000,0,1,4),(2,6323,10000,0,1,4),(2,6324,10000,0,1,4),(2,6325,10000,0,1,4),(2,6326,10000,0,1,4),(2,6327,10000,0,1,4),(2,6328,10000,0,1,4),(2,6329,10000,0,1,4),(2,6330,10000,0,1,4),(2,6331,10000,0,1,4),(2,6332,10000,0,1,4),(2,6333,10000,0,1,4),(2,6334,10000,0,1,4),(2,6335,10000,0,1,4),(2,6336,10000,0,1,4),(2,6337,10000,0,1,4),(2,6338,10000,0,1,4),(2,6339,10000,0,1,4),(2,6340,10000,0,1,4),(2,6341,10000,0,1,4),(2,6342,10000,0,1,4),(2,6343,10000,0,1,4),(2,6344,10000,0,1,4),(2,6345,10000,0,1,4),(2,6293,0,1,1,4),(2,6299,0,1,1,4),(2,6310,0,1,1,4),(2,6311,0,1,1,4),(3,5760,0,1,1,4),(3,6035,0,1,1,4),(5,6326,10000,0,1,4),(5,6327,10000,0,1,4),(5,6328,10000,0,1,4),(5,6329,10000,0,1,4),(5,6330,10000,0,1,4),(5,6331,10000,0,1,4),(5,6332,10000,0,1,4),(5,6333,10000,0,1,4),(5,6334,10000,0,1,4),(5,6335,10000,0,1,4),(5,6336,10000,0,1,4),(5,6337,10000,0,1,4),(5,6338,10000,0,1,4),(5,6339,10000,0,1,4),(5,6340,10000,0,1,4),(5,6341,10000,0,1,4),(5,6342,10000,0,1,4),(5,6343,10000,0,1,4),(5,6344,10000,0,1,4),(5,6345,10000,0,1,4),(5,5760,0,1,1,4),(5,6035,0,1,1,4),(6,5760,0,1,1,4),(7,5760,0,1,1,4),(7,6035,0,1,1,4),(10,5760,0,1,1,4),(10,6035,0,1,1,4),(11,5760,0,1,1,4),(11,6035,0,1,1,4),(12,5760,0,1,1,4),(12,6035,0,1,1,4),(145,5760,0,1,1,4),(163,6293,0,1,1,4),(163,6299,0,1,1,4),(163,6310,0,1,1,4),(163,6311,0,1,1,4),(163,6332,0,1,1,4),(163,6333,0,1,1,4),(163,6334,0,1,1,4),(163,6335,0,1,1,4),(163,6336,0,1,1,4),(163,6337,0,1,1,4),(164,5760,0,1,1,4),(164,6035,0,1,1,4),(318,6326,0,1,1,4),(318,6327,0,1,1,4),(318,6328,0,1,1,4),(318,6329,0,1,1,4),(318,6330,0,1,1,4),(318,6331,0,1,1,4),(318,6332,0,1,1,4),(318,6333,0,1,1,4),(318,6334,0,1,1,4),(318,6335,0,1,1,4),(318,6336,0,1,1,4),(318,6337,0,1,1,4),(318,6338,0,1,1,4),(318,6339,0,1,1,4),(318,6340,0,1,1,4),(318,6341,0,1,1,4),(318,6342,0,1,1,4),(318,6343,0,1,1,4),(318,6344,0,1,1,4),(318,6345,0,1,1,4),(343,5760,0,1,1,4),(356,5760,0,1,1,4),(366,5760,0,1,1,4),(449,5760,0,1,1,4),(449,6035,0,1,1,4);
/*!40000 ALTER TABLE `catalog_category_product_index_store1_replica` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_product_index_store2`
--

DROP TABLE IF EXISTS `catalog_category_product_index_store2`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_product_index_store2` (
  `category_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Category Id',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product Id',
  `position` int DEFAULT NULL COMMENT 'Position',
  `is_parent` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Parent',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `visibility` smallint unsigned NOT NULL COMMENT 'Visibility',
  PRIMARY KEY (`category_id`,`product_id`,`store_id`),
  KEY `IDX_87FCED52F67C72BB6992C79EB4DCFA8A` (`product_id`,`store_id`,`category_id`,`visibility`),
  KEY `IDX_15B841C92B67D986A980051DF109F9D1` (`store_id`,`category_id`,`visibility`,`is_parent`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Product Index Store2';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_product_index_store2`
--

LOCK TABLES `catalog_category_product_index_store2` WRITE;
/*!40000 ALTER TABLE `catalog_category_product_index_store2` DISABLE KEYS */;
INSERT INTO `catalog_category_product_index_store2` VALUES (2,5760,0,0,2,4),(2,6035,0,0,2,4),(2,6041,10000,0,2,4),(2,6042,10000,0,2,4),(2,6043,10000,0,2,4),(2,6044,10000,0,2,4),(2,6045,10000,0,2,4),(2,6046,10000,0,2,4),(2,6047,10000,0,2,4),(2,6048,10000,0,2,4),(2,6049,10000,0,2,4),(2,6050,10000,0,2,4),(2,6051,10000,0,2,4),(2,6052,10000,0,2,4),(2,6053,10000,0,2,4),(2,6036,0,1,2,4),(2,6037,0,1,2,4),(2,6038,0,1,2,4),(2,6039,0,1,2,4),(2,6040,0,1,2,4),(3,5760,0,1,2,4),(3,6035,0,1,2,4),(5,5760,0,1,2,4),(5,6035,0,1,2,4),(6,5760,0,1,2,4),(7,5760,0,1,2,4),(7,6035,0,1,2,4),(10,5760,0,1,2,4),(10,6035,0,1,2,4),(11,5760,0,1,2,4),(11,6035,0,1,2,4),(12,5760,0,1,2,4),(12,6035,0,1,2,4),(145,5760,0,1,2,4),(163,6035,0,1,2,4),(163,6036,0,1,2,4),(163,6037,0,1,2,4),(163,6038,0,1,2,4),(163,6039,0,1,2,4),(163,6040,0,1,2,4),(164,5760,0,1,2,4),(164,6035,0,1,2,4),(343,5760,0,1,2,4),(356,5760,0,1,2,4),(366,5760,0,1,2,4),(449,5760,0,1,2,4),(449,6035,0,1,2,4);
/*!40000 ALTER TABLE `catalog_category_product_index_store2` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_product_index_store2_replica`
--

DROP TABLE IF EXISTS `catalog_category_product_index_store2_replica`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_product_index_store2_replica` (
  `category_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Category Id',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product Id',
  `position` int DEFAULT NULL COMMENT 'Position',
  `is_parent` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Parent',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `visibility` smallint unsigned NOT NULL COMMENT 'Visibility',
  PRIMARY KEY (`category_id`,`product_id`,`store_id`),
  KEY `CAT_CTGR_PRD_IDX_STORE2_PRD_ID_STORE_ID_CTGR_ID_VISIBILITY` (`product_id`,`store_id`,`category_id`,`visibility`),
  KEY `IDX_2AB6FE58F086547FA7E4590837296849` (`store_id`,`category_id`,`visibility`,`is_parent`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Product Index Store2 Replica';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_product_index_store2_replica`
--

LOCK TABLES `catalog_category_product_index_store2_replica` WRITE;
/*!40000 ALTER TABLE `catalog_category_product_index_store2_replica` DISABLE KEYS */;
INSERT INTO `catalog_category_product_index_store2_replica` VALUES (2,5760,0,0,2,4),(2,6035,0,0,2,4),(2,6036,10000,0,2,4),(2,6037,10000,0,2,4),(2,6038,10000,0,2,4),(2,6039,10000,0,2,4),(2,6040,10000,0,2,4),(2,6041,10000,0,2,4),(2,6042,10000,0,2,4),(2,6043,10000,0,2,4),(2,6044,10000,0,2,4),(2,6045,10000,0,2,4),(2,6046,10000,0,2,4),(2,6047,10000,0,2,4),(2,6048,10000,0,2,4),(2,6049,10000,0,2,4),(2,6050,10000,0,2,4),(2,6051,10000,0,2,4),(2,6052,10000,0,2,4),(2,6053,10000,0,2,4),(3,5760,0,1,2,4),(3,6035,0,1,2,4),(5,5760,0,1,2,4),(5,6035,0,1,2,4),(6,5760,0,1,2,4),(7,5760,0,1,2,4),(7,6035,0,1,2,4),(10,5760,0,1,2,4),(10,6035,0,1,2,4),(11,5760,0,1,2,4),(11,6035,0,1,2,4),(12,5760,0,1,2,4),(12,6035,0,1,2,4),(145,5760,0,1,2,4),(164,5760,0,1,2,4),(164,6035,0,1,2,4),(343,5760,0,1,2,4),(356,5760,0,1,2,4),(366,5760,0,1,2,4),(449,5760,0,1,2,4),(449,6035,0,1,2,4);
/*!40000 ALTER TABLE `catalog_category_product_index_store2_replica` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_product_index_store3`
--

DROP TABLE IF EXISTS `catalog_category_product_index_store3`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_product_index_store3` (
  `category_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Category Id',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product Id',
  `position` int DEFAULT NULL COMMENT 'Position',
  `is_parent` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Parent',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `visibility` smallint unsigned NOT NULL COMMENT 'Visibility',
  PRIMARY KEY (`category_id`,`product_id`,`store_id`),
  KEY `IDX_43726D149468373EB56B59700A89860C` (`product_id`,`store_id`,`category_id`,`visibility`),
  KEY `IDX_3A62575144A54728FACD3A0D6309E61D` (`store_id`,`category_id`,`visibility`,`is_parent`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Product Index Store3';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_product_index_store3`
--

LOCK TABLES `catalog_category_product_index_store3` WRITE;
/*!40000 ALTER TABLE `catalog_category_product_index_store3` DISABLE KEYS */;
INSERT INTO `catalog_category_product_index_store3` VALUES (2,5760,0,0,3,4),(2,6035,0,0,3,4),(2,6041,10000,0,3,4),(2,6042,10000,0,3,4),(2,6043,10000,0,3,4),(2,6044,10000,0,3,4),(2,6045,10000,0,3,4),(2,6046,10000,0,3,4),(2,6047,10000,0,3,4),(2,6048,10000,0,3,4),(2,6049,10000,0,3,4),(2,6050,10000,0,3,4),(2,6051,10000,0,3,4),(2,6052,10000,0,3,4),(2,6053,10000,0,3,4),(2,6036,0,1,3,4),(2,6037,0,1,3,4),(2,6038,0,1,3,4),(2,6039,0,1,3,4),(2,6040,0,1,3,4),(3,5760,0,1,3,4),(3,6035,0,1,3,4),(5,5760,0,1,3,4),(5,6035,0,1,3,4),(6,5760,0,1,3,4),(7,5760,0,1,3,4),(7,6035,0,1,3,4),(10,5760,0,1,3,4),(10,6035,0,1,3,4),(11,5760,0,1,3,4),(11,6035,0,1,3,4),(12,5760,0,1,3,4),(12,6035,0,1,3,4),(145,5760,0,1,3,4),(163,6035,0,1,3,4),(163,6036,0,1,3,4),(163,6037,0,1,3,4),(163,6038,0,1,3,4),(163,6039,0,1,3,4),(163,6040,0,1,3,4),(164,5760,0,1,3,4),(164,6035,0,1,3,4),(343,5760,0,1,3,4),(356,5760,0,1,3,4),(366,5760,0,1,3,4),(449,5760,0,1,3,4),(449,6035,0,1,3,4);
/*!40000 ALTER TABLE `catalog_category_product_index_store3` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_product_index_store3_replica`
--

DROP TABLE IF EXISTS `catalog_category_product_index_store3_replica`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_product_index_store3_replica` (
  `category_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Category Id',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product Id',
  `position` int DEFAULT NULL COMMENT 'Position',
  `is_parent` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Parent',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `visibility` smallint unsigned NOT NULL COMMENT 'Visibility',
  PRIMARY KEY (`category_id`,`product_id`,`store_id`),
  KEY `CAT_CTGR_PRD_IDX_STORE3_PRD_ID_STORE_ID_CTGR_ID_VISIBILITY` (`product_id`,`store_id`,`category_id`,`visibility`),
  KEY `IDX_E9342558FA31C65508E1FE75E6242607` (`store_id`,`category_id`,`visibility`,`is_parent`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Product Index Store3 Replica';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_product_index_store3_replica`
--

LOCK TABLES `catalog_category_product_index_store3_replica` WRITE;
/*!40000 ALTER TABLE `catalog_category_product_index_store3_replica` DISABLE KEYS */;
INSERT INTO `catalog_category_product_index_store3_replica` VALUES (2,5760,0,0,3,4),(2,6035,0,0,3,4),(2,6036,10000,0,3,4),(2,6037,10000,0,3,4),(2,6038,10000,0,3,4),(2,6039,10000,0,3,4),(2,6040,10000,0,3,4),(2,6041,10000,0,3,4),(2,6042,10000,0,3,4),(2,6043,10000,0,3,4),(2,6044,10000,0,3,4),(2,6045,10000,0,3,4),(2,6046,10000,0,3,4),(2,6047,10000,0,3,4),(2,6048,10000,0,3,4),(2,6049,10000,0,3,4),(2,6050,10000,0,3,4),(2,6051,10000,0,3,4),(2,6052,10000,0,3,4),(2,6053,10000,0,3,4),(3,5760,0,1,3,4),(3,6035,0,1,3,4),(5,5760,0,1,3,4),(5,6035,0,1,3,4),(6,5760,0,1,3,4),(7,5760,0,1,3,4),(7,6035,0,1,3,4),(10,5760,0,1,3,4),(10,6035,0,1,3,4),(11,5760,0,1,3,4),(11,6035,0,1,3,4),(12,5760,0,1,3,4),(12,6035,0,1,3,4),(145,5760,0,1,3,4),(164,5760,0,1,3,4),(164,6035,0,1,3,4),(343,5760,0,1,3,4),(356,5760,0,1,3,4),(366,5760,0,1,3,4),(449,5760,0,1,3,4),(449,6035,0,1,3,4);
/*!40000 ALTER TABLE `catalog_category_product_index_store3_replica` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_product_index_store4`
--

DROP TABLE IF EXISTS `catalog_category_product_index_store4`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_product_index_store4` (
  `category_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Category Id',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product Id',
  `position` int DEFAULT NULL COMMENT 'Position',
  `is_parent` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Parent',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `visibility` smallint unsigned NOT NULL COMMENT 'Visibility',
  PRIMARY KEY (`category_id`,`product_id`,`store_id`),
  KEY `IDX_966AADF0F2BFAFFC1235C826759845CC` (`product_id`,`store_id`,`category_id`,`visibility`),
  KEY `IDX_F43ABBF162395BE3A1D5B1AE17C24FE2` (`store_id`,`category_id`,`visibility`,`is_parent`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Product Index Store4';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_product_index_store4`
--

LOCK TABLES `catalog_category_product_index_store4` WRITE;
/*!40000 ALTER TABLE `catalog_category_product_index_store4` DISABLE KEYS */;
INSERT INTO `catalog_category_product_index_store4` VALUES (2,5760,0,0,4,4),(2,6035,0,0,4,4),(2,6041,10000,0,4,4),(2,6042,10000,0,4,4),(2,6043,10000,0,4,4),(2,6044,10000,0,4,4),(2,6045,10000,0,4,4),(2,6046,10000,0,4,4),(2,6047,10000,0,4,4),(2,6048,10000,0,4,4),(2,6049,10000,0,4,4),(2,6050,10000,0,4,4),(2,6051,10000,0,4,4),(2,6052,10000,0,4,4),(2,6053,10000,0,4,4),(2,6036,0,1,4,4),(2,6037,0,1,4,4),(2,6038,0,1,4,4),(2,6039,0,1,4,4),(2,6040,0,1,4,4),(3,5760,0,1,4,4),(3,6035,0,1,4,4),(5,5760,0,1,4,4),(5,6035,0,1,4,4),(6,5760,0,1,4,4),(7,5760,0,1,4,4),(7,6035,0,1,4,4),(10,5760,0,1,4,4),(10,6035,0,1,4,4),(11,5760,0,1,4,4),(11,6035,0,1,4,4),(12,5760,0,1,4,4),(12,6035,0,1,4,4),(145,5760,0,1,4,4),(163,6035,0,1,4,4),(163,6036,0,1,4,4),(163,6037,0,1,4,4),(163,6038,0,1,4,4),(163,6039,0,1,4,4),(163,6040,0,1,4,4),(164,5760,0,1,4,4),(164,6035,0,1,4,4),(343,5760,0,1,4,4),(356,5760,0,1,4,4),(366,5760,0,1,4,4),(449,5760,0,1,4,4),(449,6035,0,1,4,4);
/*!40000 ALTER TABLE `catalog_category_product_index_store4` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_product_index_store4_replica`
--

DROP TABLE IF EXISTS `catalog_category_product_index_store4_replica`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_product_index_store4_replica` (
  `category_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Category Id',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product Id',
  `position` int DEFAULT NULL COMMENT 'Position',
  `is_parent` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Parent',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `visibility` smallint unsigned NOT NULL COMMENT 'Visibility',
  PRIMARY KEY (`category_id`,`product_id`,`store_id`),
  KEY `CAT_CTGR_PRD_IDX_STORE4_PRD_ID_STORE_ID_CTGR_ID_VISIBILITY` (`product_id`,`store_id`,`category_id`,`visibility`),
  KEY `IDX_ABB606D1CB36CD160DB880F39838BC3F` (`store_id`,`category_id`,`visibility`,`is_parent`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Product Index Store4 Replica';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_product_index_store4_replica`
--

LOCK TABLES `catalog_category_product_index_store4_replica` WRITE;
/*!40000 ALTER TABLE `catalog_category_product_index_store4_replica` DISABLE KEYS */;
INSERT INTO `catalog_category_product_index_store4_replica` VALUES (2,5760,0,0,4,4),(2,6035,0,0,4,4),(2,6036,10000,0,4,4),(2,6037,10000,0,4,4),(2,6038,10000,0,4,4),(2,6039,10000,0,4,4),(2,6040,10000,0,4,4),(2,6041,10000,0,4,4),(2,6042,10000,0,4,4),(2,6043,10000,0,4,4),(2,6044,10000,0,4,4),(2,6045,10000,0,4,4),(2,6046,10000,0,4,4),(2,6047,10000,0,4,4),(2,6048,10000,0,4,4),(2,6049,10000,0,4,4),(2,6050,10000,0,4,4),(2,6051,10000,0,4,4),(2,6052,10000,0,4,4),(2,6053,10000,0,4,4),(3,5760,0,1,4,4),(3,6035,0,1,4,4),(5,5760,0,1,4,4),(5,6035,0,1,4,4),(6,5760,0,1,4,4),(7,5760,0,1,4,4),(7,6035,0,1,4,4),(10,5760,0,1,4,4),(10,6035,0,1,4,4),(11,5760,0,1,4,4),(11,6035,0,1,4,4),(12,5760,0,1,4,4),(12,6035,0,1,4,4),(145,5760,0,1,4,4),(164,5760,0,1,4,4),(164,6035,0,1,4,4),(343,5760,0,1,4,4),(356,5760,0,1,4,4),(366,5760,0,1,4,4),(449,5760,0,1,4,4),(449,6035,0,1,4,4);
/*!40000 ALTER TABLE `catalog_category_product_index_store4_replica` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_product_index_store5`
--

DROP TABLE IF EXISTS `catalog_category_product_index_store5`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_product_index_store5` (
  `category_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Category Id',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product Id',
  `position` int DEFAULT NULL COMMENT 'Position',
  `is_parent` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Parent',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `visibility` smallint unsigned NOT NULL COMMENT 'Visibility',
  PRIMARY KEY (`category_id`,`product_id`,`store_id`),
  KEY `CAT_CTGR_PRD_IDX_STORE5_PRD_ID_STORE_ID_CTGR_ID_VISIBILITY` (`product_id`,`store_id`,`category_id`,`visibility`),
  KEY `IDX_D66B6557126C2DE627A049511C72BE10` (`store_id`,`category_id`,`visibility`,`is_parent`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Product Index Store5';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_product_index_store5`
--

LOCK TABLES `catalog_category_product_index_store5` WRITE;
/*!40000 ALTER TABLE `catalog_category_product_index_store5` DISABLE KEYS */;
INSERT INTO `catalog_category_product_index_store5` VALUES (2,6219,10000,0,5,2),(2,6257,10000,0,5,2),(2,6353,10000,0,5,2),(2,6547,10000,0,5,2),(2,6548,10000,0,5,2),(2,6549,10000,0,5,2),(2,6551,10000,0,5,2),(2,6552,10000,0,5,2),(2,6553,10000,0,5,2),(2,6554,10000,0,5,2),(2,6555,10000,0,5,2),(2,6556,10000,0,5,2),(2,6559,10000,0,5,2),(2,6560,10000,0,5,2),(2,6561,10000,0,5,2),(2,5760,0,0,5,4),(2,6035,0,0,5,4),(2,6041,10000,0,5,4),(2,6042,10000,0,5,4),(2,6043,10000,0,5,4),(2,6044,10000,0,5,4),(2,6045,10000,0,5,4),(2,6046,10000,0,5,4),(2,6047,10000,0,5,4),(2,6048,10000,0,5,4),(2,6049,10000,0,5,4),(2,6050,10000,0,5,4),(2,6051,10000,0,5,4),(2,6052,10000,0,5,4),(2,6053,10000,0,5,4),(2,6054,10000,0,5,4),(2,6055,10000,0,5,4),(2,6056,10000,0,5,4),(2,6057,10000,0,5,4),(2,6058,10000,0,5,4),(2,6059,10000,0,5,4),(2,6060,10000,0,5,4),(2,6061,10000,0,5,4),(2,6062,10000,0,5,4),(2,6063,10000,0,5,4),(2,6064,10000,0,5,4),(2,6065,10000,0,5,4),(2,6066,10000,0,5,4),(2,6067,10000,0,5,4),(2,6068,10000,0,5,4),(2,6069,10000,0,5,4),(2,6070,10000,0,5,4),(2,6071,10000,0,5,4),(2,6072,10000,0,5,4),(2,6073,10000,0,5,4),(2,6074,10000,0,5,4),(2,6075,10000,0,5,4),(2,6076,10000,0,5,4),(2,6077,10000,0,5,4),(2,6078,10000,0,5,4),(2,6079,10000,0,5,4),(2,6080,10000,0,5,4),(2,6081,10000,0,5,4),(2,6082,10000,0,5,4),(2,6083,10000,0,5,4),(2,6084,10000,0,5,4),(2,6085,10000,0,5,4),(2,6086,10000,0,5,4),(2,6087,10000,0,5,4),(2,6088,10000,0,5,4),(2,6089,10000,0,5,4),(2,6090,10000,0,5,4),(2,6091,10000,0,5,4),(2,6092,10000,0,5,4),(2,6093,10000,0,5,4),(2,6094,10000,0,5,4),(2,6095,10000,0,5,4),(2,6096,10000,0,5,4),(2,6097,10000,0,5,4),(2,6098,10000,0,5,4),(2,6099,10000,0,5,4),(2,6100,10000,0,5,4),(2,6101,10000,0,5,4),(2,6102,10000,0,5,4),(2,6103,10000,0,5,4),(2,6104,10000,0,5,4),(2,6105,10000,0,5,4),(2,6106,10000,0,5,4),(2,6107,10000,0,5,4),(2,6108,10000,0,5,4),(2,6109,10000,0,5,4),(2,6110,10000,0,5,4),(2,6111,10000,0,5,4),(2,6112,10000,0,5,4),(2,6113,10000,0,5,4),(2,6114,10000,0,5,4),(2,6115,10000,0,5,4),(2,6116,10000,0,5,4),(2,6117,10000,0,5,4),(2,6118,10000,0,5,4),(2,6119,10000,0,5,4),(2,6120,10000,0,5,4),(2,6121,10000,0,5,4),(2,6122,10000,0,5,4),(2,6123,10000,0,5,4),(2,6124,10000,0,5,4),(2,6125,10000,0,5,4),(2,6126,10000,0,5,4),(2,6127,10000,0,5,4),(2,6128,10000,0,5,4),(2,6129,10000,0,5,4),(2,6130,10000,0,5,4),(2,6131,10000,0,5,4),(2,6132,10000,0,5,4),(2,6133,10000,0,5,4),(2,6134,10000,0,5,4),(2,6135,10000,0,5,4),(2,6136,10000,0,5,4),(2,6137,10000,0,5,4),(2,6138,10000,0,5,4),(2,6139,10000,0,5,4),(2,6140,10000,0,5,4),(2,6141,10000,0,5,4),(2,6142,10000,0,5,4),(2,6143,10000,0,5,4),(2,6144,10000,0,5,4),(2,6145,10000,0,5,4),(2,6146,10000,0,5,4),(2,6147,10000,0,5,4),(2,6148,10000,0,5,4),(2,6149,10000,0,5,4),(2,6150,10000,0,5,4),(2,6151,10000,0,5,4),(2,6152,10000,0,5,4),(2,6153,10000,0,5,4),(2,6154,10000,0,5,4),(2,6155,10000,0,5,4),(2,6156,10000,0,5,4),(2,6157,10000,0,5,4),(2,6158,10000,0,5,4),(2,6159,10000,0,5,4),(2,6160,10000,0,5,4),(2,6161,10000,0,5,4),(2,6162,10000,0,5,4),(2,6163,10000,0,5,4),(2,6164,10000,0,5,4),(2,6165,10000,0,5,4),(2,6166,10000,0,5,4),(2,6167,10000,0,5,4),(2,6168,10000,0,5,4),(2,6169,10000,0,5,4),(2,6170,10000,0,5,4),(2,6171,10000,0,5,4),(2,6172,10000,0,5,4),(2,6173,10000,0,5,4),(2,6174,10000,0,5,4),(2,6175,10000,0,5,4),(2,6176,10000,0,5,4),(2,6177,10000,0,5,4),(2,6178,10000,0,5,4),(2,6179,10000,0,5,4),(2,6180,10000,0,5,4),(2,6181,10000,0,5,4),(2,6182,10000,0,5,4),(2,6183,10000,0,5,4),(2,6184,10000,0,5,4),(2,6185,10000,0,5,4),(2,6186,10000,0,5,4),(2,6187,10000,0,5,4),(2,6188,10000,0,5,4),(2,6189,10000,0,5,4),(2,6190,10000,0,5,4),(2,6191,10000,0,5,4),(2,6192,10000,0,5,4),(2,6193,10000,0,5,4),(2,6194,10000,0,5,4),(2,6195,10000,0,5,4),(2,6196,10000,0,5,4),(2,6197,10000,0,5,4),(2,6198,10000,0,5,4),(2,6199,10000,0,5,4),(2,6200,10000,0,5,4),(2,6201,10000,0,5,4),(2,6202,10000,0,5,4),(2,6203,10000,0,5,4),(2,6204,10000,0,5,4),(2,6205,10000,0,5,4),(2,6206,10000,0,5,4),(2,6207,10000,0,5,4),(2,6208,10000,0,5,4),(2,6209,10000,0,5,4),(2,6210,10000,0,5,4),(2,6211,10000,0,5,4),(2,6212,10000,0,5,4),(2,6213,10000,0,5,4),(2,6214,10000,0,5,4),(2,6215,10000,0,5,4),(2,6216,10000,0,5,4),(2,6217,10000,0,5,4),(2,6218,10000,0,5,4),(2,6220,10000,0,5,4),(2,6221,10000,0,5,4),(2,6222,10000,0,5,4),(2,6223,10000,0,5,4),(2,6224,10000,0,5,4),(2,6225,10000,0,5,4),(2,6226,10000,0,5,4),(2,6227,10000,0,5,4),(2,6228,10000,0,5,4),(2,6229,10000,0,5,4),(2,6230,10000,0,5,4),(2,6231,10000,0,5,4),(2,6232,10000,0,5,4),(2,6233,10000,0,5,4),(2,6234,10000,0,5,4),(2,6235,10000,0,5,4),(2,6236,10000,0,5,4),(2,6237,10000,0,5,4),(2,6238,10000,0,5,4),(2,6239,10000,0,5,4),(2,6240,10000,0,5,4),(2,6241,10000,0,5,4),(2,6242,10000,0,5,4),(2,6243,10000,0,5,4),(2,6244,10000,0,5,4),(2,6245,10000,0,5,4),(2,6246,10000,0,5,4),(2,6247,10000,0,5,4),(2,6248,10000,0,5,4),(2,6249,10000,0,5,4),(2,6250,10000,0,5,4),(2,6251,10000,0,5,4),(2,6252,10000,0,5,4),(2,6253,10000,0,5,4),(2,6254,10000,0,5,4),(2,6255,10000,0,5,4),(2,6256,10000,0,5,4),(2,6258,10000,0,5,4),(2,6259,10000,0,5,4),(2,6260,10000,0,5,4),(2,6261,10000,0,5,4),(2,6262,10000,0,5,4),(2,6263,10000,0,5,4),(2,6264,10000,0,5,4),(2,6265,10000,0,5,4),(2,6266,10000,0,5,4),(2,6267,10000,0,5,4),(2,6268,10000,0,5,4),(2,6269,10000,0,5,4),(2,6270,10000,0,5,4),(2,6271,10000,0,5,4),(2,6272,10000,0,5,4),(2,6273,10000,0,5,4),(2,6274,10000,0,5,4),(2,6275,10000,0,5,4),(2,6276,10000,0,5,4),(2,6277,10000,0,5,4),(2,6278,10000,0,5,4),(2,6279,10000,0,5,4),(2,6280,10000,0,5,4),(2,6281,10000,0,5,4),(2,6282,10000,0,5,4),(2,6283,10000,0,5,4),(2,6284,10000,0,5,4),(2,6285,10000,0,5,4),(2,6286,10000,0,5,4),(2,6287,10000,0,5,4),(2,6288,10000,0,5,4),(2,6289,10000,0,5,4),(2,6290,10000,0,5,4),(2,6291,10000,0,5,4),(2,6292,10000,0,5,4),(2,6294,10000,0,5,4),(2,6295,10000,0,5,4),(2,6296,10000,0,5,4),(2,6297,10000,0,5,4),(2,6298,10000,0,5,4),(2,6300,10000,0,5,4),(2,6301,10000,0,5,4),(2,6302,10000,0,5,4),(2,6303,10000,0,5,4),(2,6304,10000,0,5,4),(2,6305,10000,0,5,4),(2,6306,10000,0,5,4),(2,6307,10000,0,5,4),(2,6308,10000,0,5,4),(2,6309,10000,0,5,4),(2,6312,10000,0,5,4),(2,6313,10000,0,5,4),(2,6314,10000,0,5,4),(2,6315,10000,0,5,4),(2,6316,10000,0,5,4),(2,6317,10000,0,5,4),(2,6318,10000,0,5,4),(2,6319,10000,0,5,4),(2,6320,10000,0,5,4),(2,6321,10000,0,5,4),(2,6322,10000,0,5,4),(2,6323,10000,0,5,4),(2,6324,10000,0,5,4),(2,6325,10000,0,5,4),(2,6326,10000,0,5,4),(2,6327,10000,0,5,4),(2,6328,10000,0,5,4),(2,6329,10000,0,5,4),(2,6330,10000,0,5,4),(2,6331,10000,0,5,4),(2,6332,10000,0,5,4),(2,6333,10000,0,5,4),(2,6334,10000,0,5,4),(2,6335,10000,0,5,4),(2,6336,10000,0,5,4),(2,6337,10000,0,5,4),(2,6338,10000,0,5,4),(2,6339,10000,0,5,4),(2,6340,10000,0,5,4),(2,6341,10000,0,5,4),(2,6342,10000,0,5,4),(2,6343,10000,0,5,4),(2,6344,10000,0,5,4),(2,6345,10000,0,5,4),(2,6346,10000,0,5,4),(2,6347,10000,0,5,4),(2,6348,10000,0,5,4),(2,6349,10000,0,5,4),(2,6350,10000,0,5,4),(2,6351,10000,0,5,4),(2,6352,10000,0,5,4),(2,6354,10000,0,5,4),(2,6355,10000,0,5,4),(2,6356,10000,0,5,4),(2,6357,10000,0,5,4),(2,6358,10000,0,5,4),(2,6359,10000,0,5,4),(2,6360,10000,0,5,4),(2,6361,10000,0,5,4),(2,6362,10000,0,5,4),(2,6363,10000,0,5,4),(2,6364,10000,0,5,4),(2,6365,10000,0,5,4),(2,6366,10000,0,5,4),(2,6367,10000,0,5,4),(2,6368,10000,0,5,4),(2,6369,10000,0,5,4),(2,6370,10000,0,5,4),(2,6371,10000,0,5,4),(2,6372,10000,0,5,4),(2,6373,10000,0,5,4),(2,6374,10000,0,5,4),(2,6375,10000,0,5,4),(2,6376,10000,0,5,4),(2,6377,10000,0,5,4),(2,6378,10000,0,5,4),(2,6379,10000,0,5,4),(2,6380,10000,0,5,4),(2,6381,10000,0,5,4),(2,6382,10000,0,5,4),(2,6383,10000,0,5,4),(2,6384,10000,0,5,4),(2,6385,10000,0,5,4),(2,6386,10000,0,5,4),(2,6387,10000,0,5,4),(2,6388,10000,0,5,4),(2,6389,10000,0,5,4),(2,6390,10000,0,5,4),(2,6391,10000,0,5,4),(2,6392,10000,0,5,4),(2,6393,10000,0,5,4),(2,6394,10000,0,5,4),(2,6395,10000,0,5,4),(2,6396,10000,0,5,4),(2,6397,10000,0,5,4),(2,6398,10000,0,5,4),(2,6399,10000,0,5,4),(2,6400,10000,0,5,4),(2,6401,10000,0,5,4),(2,6402,10000,0,5,4),(2,6403,10000,0,5,4),(2,6404,10000,0,5,4),(2,6405,10000,0,5,4),(2,6406,10000,0,5,4),(2,6407,10000,0,5,4),(2,6408,10000,0,5,4),(2,6409,10000,0,5,4),(2,6410,10000,0,5,4),(2,6411,10000,0,5,4),(2,6412,10000,0,5,4),(2,6413,10000,0,5,4),(2,6414,10000,0,5,4),(2,6415,10000,0,5,4),(2,6416,10000,0,5,4),(2,6417,10000,0,5,4),(2,6418,10000,0,5,4),(2,6419,10000,0,5,4),(2,6420,10000,0,5,4),(2,6421,10000,0,5,4),(2,6422,10000,0,5,4),(2,6423,10000,0,5,4),(2,6424,10000,0,5,4),(2,6425,10000,0,5,4),(2,6426,10000,0,5,4),(2,6427,10000,0,5,4),(2,6428,10000,0,5,4),(2,6429,10000,0,5,4),(2,6430,10000,0,5,4),(2,6431,10000,0,5,4),(2,6432,10000,0,5,4),(2,6433,10000,0,5,4),(2,6434,10000,0,5,4),(2,6435,10000,0,5,4),(2,6436,10000,0,5,4),(2,6437,10000,0,5,4),(2,6438,10000,0,5,4),(2,6439,10000,0,5,4),(2,6440,10000,0,5,4),(2,6441,10000,0,5,4),(2,6442,10000,0,5,4),(2,6443,10000,0,5,4),(2,6444,10000,0,5,4),(2,6445,10000,0,5,4),(2,6446,10000,0,5,4),(2,6447,10000,0,5,4),(2,6448,10000,0,5,4),(2,6449,10000,0,5,4),(2,6450,10000,0,5,4),(2,6451,10000,0,5,4),(2,6452,10000,0,5,4),(2,6453,10000,0,5,4),(2,6454,10000,0,5,4),(2,6455,10000,0,5,4),(2,6456,10000,0,5,4),(2,6457,10000,0,5,4),(2,6458,10000,0,5,4),(2,6459,10000,0,5,4),(2,6460,10000,0,5,4),(2,6461,10000,0,5,4),(2,6462,10000,0,5,4),(2,6463,10000,0,5,4),(2,6464,10000,0,5,4),(2,6465,10000,0,5,4),(2,6466,10000,0,5,4),(2,6467,10000,0,5,4),(2,6468,10000,0,5,4),(2,6469,10000,0,5,4),(2,6470,10000,0,5,4),(2,6471,10000,0,5,4),(2,6472,10000,0,5,4),(2,6473,10000,0,5,4),(2,6474,10000,0,5,4),(2,6475,10000,0,5,4),(2,6476,10000,0,5,4),(2,6477,10000,0,5,4),(2,6478,10000,0,5,4),(2,6479,10000,0,5,4),(2,6480,10000,0,5,4),(2,6481,10000,0,5,4),(2,6482,10000,0,5,4),(2,6483,10000,0,5,4),(2,6484,10000,0,5,4),(2,6485,10000,0,5,4),(2,6486,10000,0,5,4),(2,6487,10000,0,5,4),(2,6488,10000,0,5,4),(2,6489,10000,0,5,4),(2,6490,10000,0,5,4),(2,6491,10000,0,5,4),(2,6492,10000,0,5,4),(2,6493,10000,0,5,4),(2,6494,10000,0,5,4),(2,6495,10000,0,5,4),(2,6496,10000,0,5,4),(2,6497,10000,0,5,4),(2,6498,10000,0,5,4),(2,6499,10000,0,5,4),(2,6500,10000,0,5,4),(2,6501,10000,0,5,4),(2,6502,10000,0,5,4),(2,6503,10000,0,5,4),(2,6504,10000,0,5,4),(2,6505,10000,0,5,4),(2,6506,10000,0,5,4),(2,6507,10000,0,5,4),(2,6508,10000,0,5,4),(2,6509,10000,0,5,4),(2,6510,10000,0,5,4),(2,6511,10000,0,5,4),(2,6512,10000,0,5,4),(2,6513,10000,0,5,4),(2,6514,10000,0,5,4),(2,6515,10000,0,5,4),(2,6516,10000,0,5,4),(2,6517,10000,0,5,4),(2,6518,10000,0,5,4),(2,6519,10000,0,5,4),(2,6520,10000,0,5,4),(2,6521,10000,0,5,4),(2,6522,10000,0,5,4),(2,6523,10000,0,5,4),(2,6524,10000,0,5,4),(2,6525,10000,0,5,4),(2,6526,10000,0,5,4),(2,6527,10000,0,5,4),(2,6528,10000,0,5,4),(2,6529,10000,0,5,4),(2,6530,10000,0,5,4),(2,6531,10000,0,5,4),(2,6532,10000,0,5,4),(2,6533,10000,0,5,4),(2,6534,10000,0,5,4),(2,6535,10000,0,5,4),(2,6536,10000,0,5,4),(2,6537,10000,0,5,4),(2,6538,10000,0,5,4),(2,6539,10000,0,5,4),(2,6540,10000,0,5,4),(2,6541,10000,0,5,4),(2,6542,10000,0,5,4),(2,6543,10000,0,5,4),(2,6544,10000,0,5,4),(2,6545,10000,0,5,4),(2,6546,10000,0,5,4),(2,6550,10000,0,5,4),(2,6557,10000,0,5,4),(2,6558,10000,0,5,4),(2,6562,10000,0,5,4),(2,6563,10000,0,5,4),(2,6564,10000,0,5,4),(2,6565,10000,0,5,4),(2,6566,10000,0,5,4),(2,6567,10000,0,5,4),(2,6568,10000,0,5,4),(2,6569,10000,0,5,4),(2,6570,10000,0,5,4),(2,6571,10000,0,5,4),(2,6572,10000,0,5,4),(2,6036,0,1,5,4),(2,6037,0,1,5,4),(2,6038,0,1,5,4),(2,6039,0,1,5,4),(2,6040,0,1,5,4),(2,6293,0,1,5,4),(2,6299,0,1,5,4),(2,6310,0,1,5,4),(2,6311,0,1,5,4),(3,5760,0,1,5,4),(3,6035,0,1,5,4),(5,6326,10000,0,5,4),(5,6327,10000,0,5,4),(5,6328,10000,0,5,4),(5,6329,10000,0,5,4),(5,6330,10000,0,5,4),(5,6331,10000,0,5,4),(5,6332,10000,0,5,4),(5,6333,10000,0,5,4),(5,6334,10000,0,5,4),(5,6335,10000,0,5,4),(5,6336,10000,0,5,4),(5,6337,10000,0,5,4),(5,6338,10000,0,5,4),(5,6339,10000,0,5,4),(5,6340,10000,0,5,4),(5,6341,10000,0,5,4),(5,6342,10000,0,5,4),(5,6343,10000,0,5,4),(5,6344,10000,0,5,4),(5,6345,10000,0,5,4),(5,5760,0,1,5,4),(5,6035,0,1,5,4),(6,5760,0,1,5,4),(7,5760,0,1,5,4),(7,6035,0,1,5,4),(10,5760,0,1,5,4),(10,6035,0,1,5,4),(11,5760,0,1,5,4),(11,6035,0,1,5,4),(12,5760,0,1,5,4),(12,6035,0,1,5,4),(145,5760,0,1,5,4),(163,6035,0,1,5,4),(163,6036,0,1,5,4),(163,6037,0,1,5,4),(163,6038,0,1,5,4),(163,6039,0,1,5,4),(163,6040,0,1,5,4),(163,6293,0,1,5,4),(163,6299,0,1,5,4),(163,6310,0,1,5,4),(163,6311,0,1,5,4),(163,6332,0,1,5,4),(163,6333,0,1,5,4),(163,6334,0,1,5,4),(163,6335,0,1,5,4),(163,6336,0,1,5,4),(163,6337,0,1,5,4),(164,5760,0,1,5,4),(164,6035,0,1,5,4),(318,6326,0,1,5,4),(318,6327,0,1,5,4),(318,6328,0,1,5,4),(318,6329,0,1,5,4),(318,6330,0,1,5,4),(318,6331,0,1,5,4),(318,6332,0,1,5,4),(318,6333,0,1,5,4),(318,6334,0,1,5,4),(318,6335,0,1,5,4),(318,6336,0,1,5,4),(318,6337,0,1,5,4),(318,6338,0,1,5,4),(318,6339,0,1,5,4),(318,6340,0,1,5,4),(318,6341,0,1,5,4),(318,6342,0,1,5,4),(318,6343,0,1,5,4),(318,6344,0,1,5,4),(318,6345,0,1,5,4),(343,5760,0,1,5,4),(356,5760,0,1,5,4),(366,5760,0,1,5,4),(449,5760,0,1,5,4),(449,6035,0,1,5,4);
/*!40000 ALTER TABLE `catalog_category_product_index_store5` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_product_index_store5_replica`
--

DROP TABLE IF EXISTS `catalog_category_product_index_store5_replica`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_product_index_store5_replica` (
  `category_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Category Id',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product Id',
  `position` int DEFAULT NULL COMMENT 'Position',
  `is_parent` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Parent',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `visibility` smallint unsigned NOT NULL COMMENT 'Visibility',
  PRIMARY KEY (`category_id`,`product_id`,`store_id`),
  KEY `IDX_78288F76D618C4C378D1DE1DB362C05F` (`product_id`,`store_id`,`category_id`,`visibility`),
  KEY `IDX_04B1890D19F381013371F9182F62C602` (`store_id`,`category_id`,`visibility`,`is_parent`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Product Index Store5 Replica';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_product_index_store5_replica`
--

LOCK TABLES `catalog_category_product_index_store5_replica` WRITE;
/*!40000 ALTER TABLE `catalog_category_product_index_store5_replica` DISABLE KEYS */;
INSERT INTO `catalog_category_product_index_store5_replica` VALUES (2,6219,10000,0,5,2),(2,6257,10000,0,5,2),(2,5760,0,0,5,4),(2,6035,0,0,5,4),(2,6036,10000,0,5,4),(2,6037,10000,0,5,4),(2,6038,10000,0,5,4),(2,6039,10000,0,5,4),(2,6040,10000,0,5,4),(2,6041,10000,0,5,4),(2,6042,10000,0,5,4),(2,6043,10000,0,5,4),(2,6044,10000,0,5,4),(2,6045,10000,0,5,4),(2,6046,10000,0,5,4),(2,6047,10000,0,5,4),(2,6048,10000,0,5,4),(2,6049,10000,0,5,4),(2,6050,10000,0,5,4),(2,6051,10000,0,5,4),(2,6052,10000,0,5,4),(2,6053,10000,0,5,4),(2,6054,10000,0,5,4),(2,6055,10000,0,5,4),(2,6056,10000,0,5,4),(2,6057,10000,0,5,4),(2,6058,10000,0,5,4),(2,6059,10000,0,5,4),(2,6060,10000,0,5,4),(2,6061,10000,0,5,4),(2,6062,10000,0,5,4),(2,6063,10000,0,5,4),(2,6064,10000,0,5,4),(2,6065,10000,0,5,4),(2,6066,10000,0,5,4),(2,6067,10000,0,5,4),(2,6068,10000,0,5,4),(2,6069,10000,0,5,4),(2,6070,10000,0,5,4),(2,6071,10000,0,5,4),(2,6072,10000,0,5,4),(2,6073,10000,0,5,4),(2,6074,10000,0,5,4),(2,6075,10000,0,5,4),(2,6076,10000,0,5,4),(2,6077,10000,0,5,4),(2,6078,10000,0,5,4),(2,6079,10000,0,5,4),(2,6080,10000,0,5,4),(2,6081,10000,0,5,4),(2,6082,10000,0,5,4),(2,6083,10000,0,5,4),(2,6084,10000,0,5,4),(2,6085,10000,0,5,4),(2,6086,10000,0,5,4),(2,6087,10000,0,5,4),(2,6088,10000,0,5,4),(2,6089,10000,0,5,4),(2,6090,10000,0,5,4),(2,6091,10000,0,5,4),(2,6092,10000,0,5,4),(2,6093,10000,0,5,4),(2,6094,10000,0,5,4),(2,6095,10000,0,5,4),(2,6096,10000,0,5,4),(2,6097,10000,0,5,4),(2,6098,10000,0,5,4),(2,6099,10000,0,5,4),(2,6100,10000,0,5,4),(2,6101,10000,0,5,4),(2,6102,10000,0,5,4),(2,6103,10000,0,5,4),(2,6104,10000,0,5,4),(2,6105,10000,0,5,4),(2,6106,10000,0,5,4),(2,6107,10000,0,5,4),(2,6108,10000,0,5,4),(2,6109,10000,0,5,4),(2,6110,10000,0,5,4),(2,6111,10000,0,5,4),(2,6112,10000,0,5,4),(2,6113,10000,0,5,4),(2,6114,10000,0,5,4),(2,6115,10000,0,5,4),(2,6116,10000,0,5,4),(2,6117,10000,0,5,4),(2,6118,10000,0,5,4),(2,6119,10000,0,5,4),(2,6120,10000,0,5,4),(2,6121,10000,0,5,4),(2,6122,10000,0,5,4),(2,6123,10000,0,5,4),(2,6124,10000,0,5,4),(2,6125,10000,0,5,4),(2,6126,10000,0,5,4),(2,6127,10000,0,5,4),(2,6128,10000,0,5,4),(2,6129,10000,0,5,4),(2,6130,10000,0,5,4),(2,6131,10000,0,5,4),(2,6132,10000,0,5,4),(2,6133,10000,0,5,4),(2,6134,10000,0,5,4),(2,6135,10000,0,5,4),(2,6136,10000,0,5,4),(2,6137,10000,0,5,4),(2,6138,10000,0,5,4),(2,6139,10000,0,5,4),(2,6140,10000,0,5,4),(2,6141,10000,0,5,4),(2,6142,10000,0,5,4),(2,6143,10000,0,5,4),(2,6144,10000,0,5,4),(2,6145,10000,0,5,4),(2,6146,10000,0,5,4),(2,6147,10000,0,5,4),(2,6148,10000,0,5,4),(2,6149,10000,0,5,4),(2,6150,10000,0,5,4),(2,6151,10000,0,5,4),(2,6152,10000,0,5,4),(2,6153,10000,0,5,4),(2,6154,10000,0,5,4),(2,6155,10000,0,5,4),(2,6156,10000,0,5,4),(2,6157,10000,0,5,4),(2,6158,10000,0,5,4),(2,6159,10000,0,5,4),(2,6160,10000,0,5,4),(2,6161,10000,0,5,4),(2,6162,10000,0,5,4),(2,6163,10000,0,5,4),(2,6164,10000,0,5,4),(2,6165,10000,0,5,4),(2,6166,10000,0,5,4),(2,6167,10000,0,5,4),(2,6168,10000,0,5,4),(2,6169,10000,0,5,4),(2,6170,10000,0,5,4),(2,6171,10000,0,5,4),(2,6172,10000,0,5,4),(2,6173,10000,0,5,4),(2,6174,10000,0,5,4),(2,6175,10000,0,5,4),(2,6176,10000,0,5,4),(2,6177,10000,0,5,4),(2,6178,10000,0,5,4),(2,6179,10000,0,5,4),(2,6180,10000,0,5,4),(2,6181,10000,0,5,4),(2,6182,10000,0,5,4),(2,6183,10000,0,5,4),(2,6184,10000,0,5,4),(2,6185,10000,0,5,4),(2,6186,10000,0,5,4),(2,6187,10000,0,5,4),(2,6188,10000,0,5,4),(2,6189,10000,0,5,4),(2,6190,10000,0,5,4),(2,6191,10000,0,5,4),(2,6192,10000,0,5,4),(2,6193,10000,0,5,4),(2,6194,10000,0,5,4),(2,6195,10000,0,5,4),(2,6196,10000,0,5,4),(2,6197,10000,0,5,4),(2,6198,10000,0,5,4),(2,6199,10000,0,5,4),(2,6200,10000,0,5,4),(2,6201,10000,0,5,4),(2,6202,10000,0,5,4),(2,6203,10000,0,5,4),(2,6204,10000,0,5,4),(2,6205,10000,0,5,4),(2,6206,10000,0,5,4),(2,6207,10000,0,5,4),(2,6208,10000,0,5,4),(2,6209,10000,0,5,4),(2,6210,10000,0,5,4),(2,6211,10000,0,5,4),(2,6212,10000,0,5,4),(2,6213,10000,0,5,4),(2,6214,10000,0,5,4),(2,6215,10000,0,5,4),(2,6216,10000,0,5,4),(2,6217,10000,0,5,4),(2,6218,10000,0,5,4),(2,6220,10000,0,5,4),(2,6221,10000,0,5,4),(2,6222,10000,0,5,4),(2,6223,10000,0,5,4),(2,6224,10000,0,5,4),(2,6225,10000,0,5,4),(2,6226,10000,0,5,4),(2,6227,10000,0,5,4),(2,6228,10000,0,5,4),(2,6229,10000,0,5,4),(2,6230,10000,0,5,4),(2,6231,10000,0,5,4),(2,6232,10000,0,5,4),(2,6233,10000,0,5,4),(2,6234,10000,0,5,4),(2,6235,10000,0,5,4),(2,6236,10000,0,5,4),(2,6237,10000,0,5,4),(2,6238,10000,0,5,4),(2,6239,10000,0,5,4),(2,6240,10000,0,5,4),(2,6241,10000,0,5,4),(2,6242,10000,0,5,4),(2,6243,10000,0,5,4),(2,6244,10000,0,5,4),(2,6245,10000,0,5,4),(2,6246,10000,0,5,4),(2,6247,10000,0,5,4),(2,6248,10000,0,5,4),(2,6249,10000,0,5,4),(2,6250,10000,0,5,4),(2,6251,10000,0,5,4),(2,6252,10000,0,5,4),(2,6253,10000,0,5,4),(2,6254,10000,0,5,4),(2,6255,10000,0,5,4),(2,6256,10000,0,5,4),(2,6258,10000,0,5,4),(2,6259,10000,0,5,4),(2,6260,10000,0,5,4),(2,6261,10000,0,5,4),(2,6262,10000,0,5,4),(2,6263,10000,0,5,4),(2,6264,10000,0,5,4),(2,6265,10000,0,5,4),(2,6266,10000,0,5,4),(2,6267,10000,0,5,4),(2,6268,10000,0,5,4),(2,6269,10000,0,5,4),(2,6270,10000,0,5,4),(2,6271,10000,0,5,4),(2,6272,10000,0,5,4),(2,6273,10000,0,5,4),(2,6274,10000,0,5,4),(2,6275,10000,0,5,4),(2,6276,10000,0,5,4),(2,6277,10000,0,5,4),(2,6278,10000,0,5,4),(2,6279,10000,0,5,4),(2,6280,10000,0,5,4),(2,6281,10000,0,5,4),(2,6282,10000,0,5,4),(2,6283,10000,0,5,4),(2,6284,10000,0,5,4),(2,6285,10000,0,5,4),(2,6286,10000,0,5,4),(2,6287,10000,0,5,4),(2,6288,10000,0,5,4),(2,6289,10000,0,5,4),(2,6290,10000,0,5,4),(2,6291,10000,0,5,4),(2,6292,10000,0,5,4),(2,6294,10000,0,5,4),(2,6295,10000,0,5,4),(2,6296,10000,0,5,4),(2,6297,10000,0,5,4),(2,6298,10000,0,5,4),(2,6300,10000,0,5,4),(2,6301,10000,0,5,4),(2,6302,10000,0,5,4),(2,6303,10000,0,5,4),(2,6304,10000,0,5,4),(2,6305,10000,0,5,4),(2,6306,10000,0,5,4),(2,6307,10000,0,5,4),(2,6308,10000,0,5,4),(2,6309,10000,0,5,4),(2,6312,10000,0,5,4),(2,6313,10000,0,5,4),(2,6314,10000,0,5,4),(2,6315,10000,0,5,4),(2,6316,10000,0,5,4),(2,6317,10000,0,5,4),(2,6318,10000,0,5,4),(2,6319,10000,0,5,4),(2,6320,10000,0,5,4),(2,6321,10000,0,5,4),(2,6322,10000,0,5,4),(2,6323,10000,0,5,4),(2,6324,10000,0,5,4),(2,6325,10000,0,5,4),(2,6326,10000,0,5,4),(2,6327,10000,0,5,4),(2,6328,10000,0,5,4),(2,6329,10000,0,5,4),(2,6330,10000,0,5,4),(2,6331,10000,0,5,4),(2,6332,10000,0,5,4),(2,6333,10000,0,5,4),(2,6334,10000,0,5,4),(2,6335,10000,0,5,4),(2,6336,10000,0,5,4),(2,6337,10000,0,5,4),(2,6338,10000,0,5,4),(2,6339,10000,0,5,4),(2,6340,10000,0,5,4),(2,6341,10000,0,5,4),(2,6342,10000,0,5,4),(2,6343,10000,0,5,4),(2,6344,10000,0,5,4),(2,6345,10000,0,5,4),(2,6293,0,1,5,4),(2,6299,0,1,5,4),(2,6310,0,1,5,4),(2,6311,0,1,5,4),(3,5760,0,1,5,4),(3,6035,0,1,5,4),(5,6326,10000,0,5,4),(5,6327,10000,0,5,4),(5,6328,10000,0,5,4),(5,6329,10000,0,5,4),(5,6330,10000,0,5,4),(5,6331,10000,0,5,4),(5,6332,10000,0,5,4),(5,6333,10000,0,5,4),(5,6334,10000,0,5,4),(5,6335,10000,0,5,4),(5,6336,10000,0,5,4),(5,6337,10000,0,5,4),(5,6338,10000,0,5,4),(5,6339,10000,0,5,4),(5,6340,10000,0,5,4),(5,6341,10000,0,5,4),(5,6342,10000,0,5,4),(5,6343,10000,0,5,4),(5,6344,10000,0,5,4),(5,6345,10000,0,5,4),(5,5760,0,1,5,4),(5,6035,0,1,5,4),(6,5760,0,1,5,4),(7,5760,0,1,5,4),(7,6035,0,1,5,4),(10,5760,0,1,5,4),(10,6035,0,1,5,4),(11,5760,0,1,5,4),(11,6035,0,1,5,4),(12,5760,0,1,5,4),(12,6035,0,1,5,4),(145,5760,0,1,5,4),(163,6293,0,1,5,4),(163,6299,0,1,5,4),(163,6310,0,1,5,4),(163,6311,0,1,5,4),(163,6332,0,1,5,4),(163,6333,0,1,5,4),(163,6334,0,1,5,4),(163,6335,0,1,5,4),(163,6336,0,1,5,4),(163,6337,0,1,5,4),(164,5760,0,1,5,4),(164,6035,0,1,5,4),(318,6326,0,1,5,4),(318,6327,0,1,5,4),(318,6328,0,1,5,4),(318,6329,0,1,5,4),(318,6330,0,1,5,4),(318,6331,0,1,5,4),(318,6332,0,1,5,4),(318,6333,0,1,5,4),(318,6334,0,1,5,4),(318,6335,0,1,5,4),(318,6336,0,1,5,4),(318,6337,0,1,5,4),(318,6338,0,1,5,4),(318,6339,0,1,5,4),(318,6340,0,1,5,4),(318,6341,0,1,5,4),(318,6342,0,1,5,4),(318,6343,0,1,5,4),(318,6344,0,1,5,4),(318,6345,0,1,5,4),(343,5760,0,1,5,4),(356,5760,0,1,5,4),(366,5760,0,1,5,4),(449,5760,0,1,5,4),(449,6035,0,1,5,4);
/*!40000 ALTER TABLE `catalog_category_product_index_store5_replica` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_category_product_index_tmp`
--

DROP TABLE IF EXISTS `catalog_category_product_index_tmp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_category_product_index_tmp` (
  `category_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Category ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `position` int NOT NULL DEFAULT '0' COMMENT 'Position',
  `is_parent` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Parent',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `visibility` smallint unsigned NOT NULL COMMENT 'Visibility',
  PRIMARY KEY (`category_id`,`product_id`,`store_id`),
  KEY `CAT_CTGR_PRD_IDX_TMP_PRD_ID_CTGR_ID_STORE_ID` (`product_id`,`category_id`,`store_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Category Product Indexer temporary table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_category_product_index_tmp`
--

LOCK TABLES `catalog_category_product_index_tmp` WRITE;
/*!40000 ALTER TABLE `catalog_category_product_index_tmp` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_category_product_index_tmp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_compare_item`
--

DROP TABLE IF EXISTS `catalog_compare_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_compare_item` (
  `catalog_compare_item_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Compare Item ID',
  `visitor_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Visitor ID',
  `customer_id` int unsigned DEFAULT NULL COMMENT 'Customer ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `list_id` int unsigned DEFAULT NULL COMMENT 'List ID',
  PRIMARY KEY (`catalog_compare_item_id`),
  KEY `CATALOG_COMPARE_ITEM_LIST_ID_CATALOG_COMPARE_LIST_LIST_ID` (`list_id`),
  KEY `CATALOG_COMPARE_ITEM_PRODUCT_ID` (`product_id`),
  KEY `CATALOG_COMPARE_ITEM_VISITOR_ID_PRODUCT_ID` (`visitor_id`,`product_id`),
  KEY `CATALOG_COMPARE_ITEM_CUSTOMER_ID_PRODUCT_ID` (`customer_id`,`product_id`),
  KEY `CATALOG_COMPARE_ITEM_STORE_ID` (`store_id`),
  CONSTRAINT `CATALOG_COMPARE_ITEM_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_COMPARE_ITEM_LIST_ID_CATALOG_COMPARE_LIST_LIST_ID` FOREIGN KEY (`list_id`) REFERENCES `catalog_compare_list` (`list_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_COMPARE_ITEM_PRODUCT_ID_CATALOG_PRODUCT_ENTITY_ENTITY_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_COMPARE_ITEM_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Compare Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_compare_item`
--

LOCK TABLES `catalog_compare_item` WRITE;
/*!40000 ALTER TABLE `catalog_compare_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_compare_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_compare_list`
--

DROP TABLE IF EXISTS `catalog_compare_list`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_compare_list` (
  `list_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Compare List ID',
  `list_id_mask` varchar(32) DEFAULT NULL COMMENT 'Masked ID',
  `customer_id` int unsigned DEFAULT NULL COMMENT 'Customer ID',
  PRIMARY KEY (`list_id`),
  UNIQUE KEY `CATALOG_COMPARE_LIST_CUSTOMER_ID` (`customer_id`),
  KEY `CATALOG_COMPARE_LIST_LIST_ID_MASK` (`list_id_mask`),
  CONSTRAINT `CATALOG_COMPARE_LIST_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Compare List with hash Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_compare_list`
--

LOCK TABLES `catalog_compare_list` WRITE;
/*!40000 ALTER TABLE `catalog_compare_list` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_compare_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_eav_attribute`
--

DROP TABLE IF EXISTS `catalog_eav_attribute`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_eav_attribute` (
  `attribute_id` smallint unsigned NOT NULL COMMENT 'Attribute ID',
  `frontend_input_renderer` varchar(255) DEFAULT NULL COMMENT 'Frontend Input Renderer',
  `is_global` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Is Global',
  `is_visible` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Is Visible',
  `is_searchable` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Searchable',
  `is_filterable` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Filterable',
  `is_comparable` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Comparable',
  `is_visible_on_front` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Visible On Front',
  `is_html_allowed_on_front` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is HTML Allowed On Front',
  `is_used_for_price_rules` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Used For Price Rules',
  `is_filterable_in_search` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Filterable In Search',
  `used_in_product_listing` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Used In Product Listing',
  `used_for_sort_by` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Used For Sorting',
  `apply_to` varchar(255) DEFAULT NULL COMMENT 'Apply To',
  `is_visible_in_advanced_search` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Visible In Advanced Search',
  `position` int NOT NULL DEFAULT '0' COMMENT 'Position',
  `is_wysiwyg_enabled` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is WYSIWYG Enabled',
  `is_used_for_promo_rules` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Used For Promo Rules',
  `is_required_in_admin_store` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Required In Admin Store',
  `is_used_in_grid` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Used in Grid',
  `is_visible_in_grid` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Visible in Grid',
  `is_filterable_in_grid` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Filterable in Grid',
  `search_weight` float NOT NULL DEFAULT '1' COMMENT 'Search Weight',
  `is_pagebuilder_enabled` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Is PageBuilder Enabled',
  `additional_data` text COMMENT 'Additional swatch attributes data',
  PRIMARY KEY (`attribute_id`),
  KEY `CATALOG_EAV_ATTRIBUTE_USED_FOR_SORT_BY` (`used_for_sort_by`),
  KEY `CATALOG_EAV_ATTRIBUTE_USED_IN_PRODUCT_LISTING` (`used_in_product_listing`),
  CONSTRAINT `CATALOG_EAV_ATTRIBUTE_ATTRIBUTE_ID_EAV_ATTRIBUTE_ATTRIBUTE_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog EAV Attribute Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_eav_attribute`
--

LOCK TABLES `catalog_eav_attribute` WRITE;
/*!40000 ALTER TABLE `catalog_eav_attribute` DISABLE KEYS */;
INSERT INTO `catalog_eav_attribute` VALUES (45,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(46,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(47,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,1,0,0,0,0,0,1,0,NULL),(48,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(49,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(50,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(51,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(52,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(53,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(54,NULL,1,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(55,NULL,1,0,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(56,NULL,1,0,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(57,NULL,1,0,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(58,NULL,1,0,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(59,NULL,1,0,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(60,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(61,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(62,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(63,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(64,NULL,0,0,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(65,NULL,1,0,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(66,NULL,1,0,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(67,'Magento\\Catalog\\Block\\Adminhtml\\Category\\Helper\\Sortby\\Available',0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(68,'Magento\\Catalog\\Block\\Adminhtml\\Category\\Helper\\Sortby\\DefaultSortby',0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(69,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(70,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(71,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(72,'Magento\\Catalog\\Block\\Adminhtml\\Category\\Helper\\Pricestep',0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(73,NULL,0,1,1,0,0,0,0,0,0,1,1,NULL,1,0,0,0,0,0,0,0,5,0,NULL),(74,NULL,1,1,1,0,1,0,0,0,0,0,0,NULL,1,0,0,0,0,0,0,0,6,0,NULL),(75,NULL,0,1,1,0,1,0,1,0,0,0,0,NULL,1,0,1,0,0,0,0,0,1,1,NULL),(76,NULL,0,1,1,0,1,0,1,0,0,1,0,NULL,1,0,1,0,0,1,0,0,1,0,NULL),(77,NULL,1,1,1,1,0,0,0,0,0,1,1,'simple,virtual,downloadable,bundle,configurable',1,0,0,0,0,0,0,0,1,0,NULL),(78,NULL,1,1,0,0,0,0,0,0,0,1,0,'simple,virtual,downloadable,bundle,configurable',0,0,0,0,0,1,0,1,1,0,NULL),(79,NULL,2,1,0,0,0,0,0,0,0,1,0,'simple,virtual,downloadable,bundle,configurable',0,0,0,0,0,1,0,0,1,0,NULL),(80,NULL,2,1,0,0,0,0,0,0,0,1,0,'simple,virtual,downloadable,bundle,configurable',0,0,0,0,0,1,0,0,1,0,NULL),(81,NULL,1,1,0,0,0,0,0,0,0,0,0,'simple,virtual,downloadable',0,0,0,0,0,1,0,1,1,0,NULL),(82,'Magento\\Catalog\\Block\\Adminhtml\\Product\\Helper\\Form\\Weight',1,1,0,0,0,0,0,0,0,0,0,'simple,virtual,downloadable,bundle,configurable',0,0,0,0,0,1,0,1,1,0,NULL),(83,NULL,1,1,1,1,1,0,0,0,0,0,0,'simple,configurable',1,0,0,0,0,1,0,1,1,0,NULL),(84,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,1,0,1,1,0,NULL),(85,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,1,0,1,1,0,NULL),(86,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,1,0,1,1,0,NULL),(87,NULL,0,1,0,0,0,0,0,0,0,1,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(88,NULL,0,1,0,0,0,0,0,0,0,1,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(89,NULL,0,1,0,0,0,0,0,0,0,1,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(90,NULL,1,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(91,NULL,1,0,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(92,NULL,2,1,0,0,0,0,0,0,0,0,0,'simple,virtual,downloadable,bundle',0,0,0,0,0,0,0,0,1,0,NULL),(93,NULL,1,1,1,1,1,0,0,0,0,0,0,'simple,virtual,configurable',1,0,0,0,0,1,0,1,1,0,'{\"swatch_input_type\":\"visual\",\"update_product_preview_image\":\"0\",\"use_product_image_for_swatch\":\"0\"}'),(94,NULL,2,1,0,0,0,0,0,0,0,1,0,NULL,0,0,0,0,0,1,0,0,1,0,NULL),(95,NULL,2,1,0,0,0,0,0,0,0,1,0,NULL,0,0,0,0,0,1,0,0,1,0,NULL),(96,NULL,1,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(97,'Magento\\Framework\\Data\\Form\\Element\\Hidden',2,1,1,0,0,0,0,0,0,1,0,NULL,0,0,0,0,1,0,0,0,1,0,NULL),(98,NULL,1,0,0,0,0,0,0,0,0,0,0,'simple,virtual,downloadable,bundle,configurable',0,0,0,0,0,0,0,0,1,0,NULL),(99,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,1,0,0,0,1,0,NULL),(100,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,1,0,1,1,0,NULL),(101,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,1,0,0,1,0,NULL),(102,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,1,0,0,1,0,NULL),(103,NULL,0,0,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(104,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,1,0,0,1,0,NULL),(105,'Magento\\Catalog\\Block\\Adminhtml\\Product\\Helper\\Form\\Category',1,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(106,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(107,NULL,1,0,0,0,0,0,0,0,0,1,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(108,NULL,1,0,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(109,NULL,0,0,0,0,0,0,0,0,0,1,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(110,NULL,0,0,0,0,0,0,0,0,0,1,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(111,NULL,0,0,0,0,0,0,0,0,0,1,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(112,NULL,1,0,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(113,NULL,1,0,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(114,NULL,2,1,0,0,0,0,0,0,0,0,0,'simple,bundle,grouped,configurable',0,0,0,0,0,1,0,1,1,0,NULL),(115,'Magento\\CatalogInventory\\Block\\Adminhtml\\Form\\Field\\Stock',1,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(116,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,1,0,0,1,0,NULL),(117,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(118,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(119,NULL,0,1,1,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(120,NULL,0,0,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(121,NULL,0,1,1,0,0,0,0,0,0,1,0,NULL,0,0,0,0,0,1,0,1,1,0,NULL),(122,NULL,0,0,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(123,'Magento\\Msrp\\Block\\Adminhtml\\Product\\Helper\\Form\\Type',1,1,0,0,0,0,0,0,0,1,0,'simple,virtual,downloadable,bundle,configurable',0,0,0,0,0,1,0,1,1,0,NULL),(124,'Magento\\Msrp\\Block\\Adminhtml\\Product\\Helper\\Form\\Type\\Price',2,1,0,0,0,0,0,0,0,1,0,'simple,virtual,downloadable,bundle,configurable',0,0,0,0,0,0,0,0,1,0,NULL),(125,NULL,1,0,0,0,0,0,0,0,0,1,0,'downloadable',0,0,0,0,0,0,0,0,1,0,NULL),(126,NULL,0,0,0,0,0,0,0,0,0,0,0,'downloadable',0,0,0,0,0,0,0,0,1,0,NULL),(127,NULL,0,0,0,0,0,0,0,0,0,0,0,'downloadable',0,0,0,0,0,0,0,0,1,0,NULL),(128,NULL,1,0,0,0,0,0,0,0,0,1,0,'downloadable',0,0,0,0,0,0,0,0,1,0,NULL),(129,NULL,1,1,0,0,0,0,0,0,0,1,0,'bundle',0,0,0,0,0,0,0,0,1,0,NULL),(130,NULL,1,1,0,0,0,0,0,0,0,0,0,'bundle',0,0,0,0,0,0,0,0,1,0,NULL),(131,NULL,1,1,0,0,0,0,0,0,0,1,0,'bundle',0,0,0,0,0,0,0,0,1,0,NULL),(132,NULL,1,1,0,0,0,0,0,0,0,1,0,'bundle',0,0,0,0,0,0,0,0,1,0,NULL),(133,NULL,1,1,0,0,0,0,0,0,0,1,0,'bundle',0,0,0,0,0,0,0,0,1,0,NULL),(134,'Magento\\GiftMessage\\Block\\Adminhtml\\Product\\Helper\\Form\\Config',1,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,1,0,0,1,0,NULL),(135,NULL,0,1,0,0,0,0,0,0,0,1,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(136,NULL,2,1,1,0,0,0,0,0,0,1,0,'simple,virtual,downloadable,bundle,configurable',0,0,0,0,0,1,0,1,1,0,NULL),(137,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(138,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(139,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(140,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(141,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(142,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(143,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(144,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(145,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,1,0,0,0,0,0,1,0,NULL),(146,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,1,0,0,0,0,0,1,0,NULL),(147,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(148,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(149,NULL,0,1,0,1,0,0,1,0,1,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(150,NULL,0,1,0,0,0,0,0,0,0,0,0,'simple,configurable,bundle',0,0,0,0,0,0,0,0,1,0,NULL),(151,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(152,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(153,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(154,NULL,1,0,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(155,NULL,1,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(156,NULL,1,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(158,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(159,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(160,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(161,NULL,0,1,0,0,0,0,0,0,0,1,0,'simple,configurable,virtual,bundle,downloadable',0,0,0,0,0,0,0,0,1,0,NULL),(162,NULL,1,1,0,0,0,0,0,0,0,1,0,NULL,0,2,0,0,0,0,0,0,1,0,NULL),(163,NULL,0,1,0,0,0,0,0,0,0,0,0,NULL,0,0,0,0,0,0,0,0,1,0,NULL),(164,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(165,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(166,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(167,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(168,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(169,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(170,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(171,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(172,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(173,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(174,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(175,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(176,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(177,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(178,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(179,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(180,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(181,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(182,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(183,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(184,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(185,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(186,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(187,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(188,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(189,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(190,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(191,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(192,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(193,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(194,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(195,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(196,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(197,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(198,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(199,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(200,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(201,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(202,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(203,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(204,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(205,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(206,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL),(207,NULL,0,1,0,0,0,0,1,0,0,0,0,NULL,0,0,0,0,0,1,1,1,1,0,NULL);
/*!40000 ALTER TABLE `catalog_eav_attribute` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_attribute_cl`
--

DROP TABLE IF EXISTS `catalog_product_attribute_cl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_attribute_cl` (
  `version_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Version ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  PRIMARY KEY (`version_id`)
) ENGINE=InnoDB AUTO_INCREMENT=92908 DEFAULT CHARSET=utf8mb3 COMMENT='catalog_product_attribute_cl';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_attribute_cl`
--

LOCK TABLES `catalog_product_attribute_cl` WRITE;
/*!40000 ALTER TABLE `catalog_product_attribute_cl` DISABLE KEYS */;
INSERT INTO `catalog_product_attribute_cl` VALUES (1,1),(2,1),(3,1),(4,1),(5,1),(6,1),(7,2),(8,2),(9,2),(10,2),(11,2),(12,2),(13,3),(14,3),(15,3),(16,3),(17,3),(18,3),(19,4),(20,4),(21,4),(22,4),(23,4),(24,5),(25,5),(26,5),(27,5),(28,5),(29,5),(30,6),(31,6),(32,6),(33,6),(34,6),(35,6),(36,1),(37,1),(38,2),(39,2),(40,3),(41,3),(42,5),(43,5),(44,6),(45,6),(46,1),(47,1),(48,1),(49,1),(50,2),(51,2),(52,2),(53,2),(54,3),(55,3),(56,3),(57,3),(58,4),(59,4),(60,4),(61,5),(62,5),(63,5),(64,5),(65,5),(66,5),(67,5),(68,5),(69,5),(70,6),(71,6),(72,6),(73,6),(74,6),(75,6),(76,6),(77,6),(78,6),(79,4),(80,4),(81,1),(82,1),(83,1),(84,1),(85,1),(86,1),(87,2),(88,2),(89,2),(90,3),(91,3),(92,3),(93,4),(94,4),(95,4),(96,4),(97,4),(98,4),(99,5),(100,5),(101,5),(102,5),(103,5),(104,5),(105,6),(106,6),(107,6),(108,6),(109,6),(110,6),(111,1),(112,1),(113,1),(114,1),(115,1),(116,1),(117,1),(118,1),(119,1),(120,1),(121,1),(122,1),(123,1),(124,1),(125,2),(126,2),(127,2),(128,2),(129,2),(130,2),(131,2),(132,2),(133,6),(134,6),(135,6),(136,6),(137,6),(138,6),(139,6),(140,6),(141,6),(142,6),(143,6),(144,6),(145,6),(146,5),(147,5),(148,5),(149,5),(150,5),(151,5),(152,5),(153,5),(154,5),(155,5),(156,5),(157,5),(158,5),(159,4),(160,4),(161,4),(162,4),(163,4),(164,4),(165,4),(166,4),(167,4),(168,4),(169,4),(170,4),(171,4),(172,4),(173,4),(174,4),(175,4),(176,3),(177,3),(178,3),(179,3),(180,3),(181,3),(182,3),(183,3),(184,7),(185,7),(186,7),(187,7),(188,7),(189,7),(190,7),(191,7),(192,7),(193,7),(194,7),(195,7),(196,7),(197,7),(198,7),(199,7),(200,7),(201,7),(202,7),(203,7),(204,7),(205,8),(206,8),(207,8),(208,8),(209,8),(210,8),(211,8),(212,9),(213,9),(214,9),(215,9),(216,9),(217,9),(218,9),(219,10),(220,10),(221,10),(222,10),(223,10),(224,10),(225,10),(226,11),(227,11),(228,11),(229,11),(230,11),(231,11),(232,11),(233,12),(234,12),(235,12),(236,12),(237,12),(238,12),(239,12),(240,13),(241,13),(242,13),(243,13),(244,13),(245,13),(246,13),(247,14),(248,14),(249,14),(250,14),(251,14),(252,14),(253,14),(254,15),(255,15),(256,15),(257,15),(258,16),(259,16),(260,16),(261,16),(262,16),(263,16),(264,17),(265,17),(266,17),(267,17),(268,18),(269,18),(270,18),(271,18),(272,19),(273,19),(274,19),(275,19),(276,20),(277,20),(278,20),(279,20),(280,21),(281,21),(282,21),(283,21),(284,22),(285,22),(286,22),(287,22),(288,23),(289,23),(290,23),(291,23),(292,23),(293,23),(294,23),(295,24),(296,24),(297,24),(298,24),(299,24),(300,24),(301,24),(302,25),(303,25),(304,25),(305,25),(306,25),(307,25),(308,25),(309,26),(310,26),(311,26),(312,26),(313,27),(314,27),(315,27),(316,27),(317,27),(318,27),(319,27),(320,28),(321,28),(322,28),(323,28),(324,28),(325,28),(326,28),(327,29),(328,29),(329,29),(330,29),(331,29),(332,29),(333,29),(334,30),(335,30),(336,30),(337,30),(338,30),(339,30),(340,30),(341,31),(342,31),(343,31),(344,31),(345,31),(346,31),(347,31),(348,32),(349,32),(350,32),(351,32),(352,32),(353,32),(354,32),(355,33),(356,33),(357,33),(358,33),(359,34),(360,34),(361,34),(362,34),(363,34),(364,34),(365,34),(366,35),(367,35),(368,35),(369,35),(370,35),(371,35),(372,35),(373,36),(374,36),(375,36),(376,36),(377,36),(378,36),(379,36),(380,37),(381,37),(382,37),(383,37),(384,37),(385,37),(386,37),(387,38),(388,38),(389,38),(390,38),(391,38),(392,38),(393,38),(394,39),(395,39),(396,39),(397,39),(398,39),(399,39),(400,40),(401,40),(402,40),(403,40),(404,40),(405,40),(406,40),(407,41),(408,41),(409,41),(410,41),(411,41),(412,41),(413,41),(414,42),(415,42),(416,42),(417,42),(418,42),(419,42),(420,42),(421,43),(422,43),(423,43),(424,43),(425,43),(426,43),(427,43),(428,44),(429,44),(430,44),(431,44),(432,44),(433,44),(434,44),(435,45),(436,45),(437,45),(438,45),(439,45),(440,45),(441,45),(442,46),(443,46),(444,46),(445,46),(446,46),(447,46),(448,46),(449,47),(450,47),(451,47),(452,47),(453,47),(454,47),(455,47),(456,48),(457,48),(458,48),(459,48),(460,48),(461,48),(462,48),(463,49),(464,49),(465,49),(466,49),(467,49),(468,49),(469,49),(470,50),(471,50),(472,50),(473,50),(474,50),(475,50),(476,50),(477,51),(478,51),(479,51),(480,51),(481,51),(482,51),(483,51),(484,52),(485,52),(486,52),(487,52),(488,52),(489,52),(490,52),(491,53),(492,53),(493,53),(494,53),(495,53),(496,53),(497,53),(498,53),(499,53),(500,54),(501,54),(502,54),(503,54),(504,54),(505,54),(506,54),(507,54),(508,54),(509,55),(510,55),(511,55),(512,55),(513,55),(514,55),(515,55),(516,55),(517,55),(518,56),(519,56),(520,56),(521,56),(522,56),(523,56),(524,56),(525,56),(526,56),(527,57),(528,57),(529,57),(530,57),(531,57),(532,57),(533,57),(534,57),(535,57),(536,58),(537,58),(538,58),(539,58),(540,58),(541,58),(542,58),(543,58),(544,58),(545,59),(546,59),(547,59),(548,59),(549,59),(550,59),(551,59),(552,59),(553,59),(554,60),(555,60),(556,60),(557,60),(558,60),(559,60),(560,60),(561,60),(562,60),(563,61),(564,61),(565,61),(566,61),(567,61),(568,61),(569,61),(570,61),(571,61),(572,62),(573,62),(574,62),(575,62),(576,62),(577,62),(578,62),(579,62),(580,62),(581,63),(582,63),(583,63),(584,63),(585,63),(586,63),(587,63),(588,63),(589,63),(590,64),(591,64),(592,64),(593,64),(594,64),(595,64),(596,64),(597,64),(598,64),(599,65),(600,65),(601,65),(602,65),(603,65),(604,65),(605,65),(606,66),(607,66),(608,66),(609,66),(610,66),(611,66),(612,66),(613,67),(614,67),(615,67),(616,67),(617,67),(618,67),(619,67),(620,68),(621,68),(622,68),(623,68),(624,69),(625,69),(626,69),(627,69),(628,70),(629,70),(630,70),(631,70),(632,70),(633,70),(634,70),(635,71),(636,71),(637,71),(638,71),(639,72),(640,72),(641,72),(642,72),(643,73),(644,73),(645,73),(646,73),(647,74),(648,74),(649,74),(650,74),(651,75),(652,75),(653,75),(654,75),(655,76),(656,76),(657,76),(658,76),(659,77),(660,77),(661,77),(662,77),(663,78),(664,78),(665,78),(666,78),(667,78),(668,78),(669,78),(670,79),(671,79),(672,79),(673,79),(674,79),(675,79),(676,79),(677,80),(678,80),(679,80),(680,80),(681,80),(682,80),(683,80),(684,81),(685,81),(686,81),(687,81),(688,81),(689,81),(690,81),(691,82),(692,82),(693,82),(694,82),(695,82),(696,82),(697,82),(698,83),(699,83),(700,83),(701,83),(702,83),(703,83),(704,83),(705,84),(706,84),(707,84),(708,84),(709,84),(710,84),(711,84),(712,85),(713,85),(714,85),(715,85),(716,85),(717,85),(718,85),(719,86),(720,86),(721,86),(722,86),(723,86),(724,86),(725,86),(726,86),(727,86),(728,87),(729,87),(730,87),(731,87),(732,87),(733,87),(734,87),(735,88),(736,88),(737,88),(738,88),(739,88),(740,88),(741,88),(742,89),(743,89),(744,89),(745,89),(746,89),(747,89),(748,89),(749,89),(750,89),(751,90),(752,90),(753,90),(754,90),(755,90),(756,90),(757,90),(758,91),(759,91),(760,91),(761,91),(762,91),(763,91),(764,91),(765,92),(766,92),(767,92),(768,92),(769,92),(770,92),(771,92),(772,93),(773,93),(774,93),(775,93),(776,93),(777,93),(778,93),(779,94),(780,94),(781,94),(782,94),(783,94),(784,94),(785,94),(786,95),(787,95),(788,95),(789,95),(790,95),(791,95),(792,95),(793,96),(794,96),(795,96),(796,96),(797,96),(798,96),(799,96),(800,96),(801,96),(802,97),(803,97),(804,97),(805,97),(806,97),(807,97),(808,97),(809,97),(810,97),(811,98),(812,98),(813,98),(814,98),(815,98),(816,98),(817,98),(818,98),(819,98),(820,99),(821,99),(822,99),(823,99),(824,99),(825,99),(826,99),(827,99),(828,99),(829,100),(830,100),(831,100),(832,100),(833,100),(834,100),(835,100),(836,100),(837,100),(838,101),(839,101),(840,101),(841,101),(842,101),(843,101),(844,101),(845,101),(846,101),(847,102),(848,102),(849,102),(850,102),(851,102),(852,102),(853,102),(854,102),(855,102),(856,103),(857,103),(858,103),(859,103),(860,103),(861,103),(862,103),(863,103),(864,103),(865,104),(866,104),(867,104),(868,104),(869,104),(870,104),(871,104),(872,104),(873,104),(874,105),(875,105),(876,105),(877,105),(878,105),(879,105),(880,105),(881,105),(882,105),(883,106),(884,106),(885,106),(886,106),(887,106),(888,106),(889,106),(890,106),(891,106),(892,7),(893,8),(894,8),(895,8),(896,9),(897,9),(898,9),(899,10),(900,10),(901,10),(902,11),(903,11),(904,11),(905,12),(906,12),(907,12),(908,13),(909,13),(910,13),(911,14),(912,14),(913,14),(914,15),(915,15),(916,15),(917,16),(918,16),(919,16),(920,17),(921,17),(922,17),(923,18),(924,18),(925,18),(926,19),(927,19),(928,19),(929,20),(930,20),(931,20),(932,21),(933,21),(934,21),(935,22),(936,22),(937,22),(938,23),(939,23),(940,23),(941,24),(942,24),(943,24),(944,25),(945,25),(946,25),(947,26),(948,26),(949,26),(950,27),(951,27),(952,27),(953,28),(954,28),(955,28),(956,29),(957,29),(958,29),(959,30),(960,30),(961,30),(962,31),(963,31),(964,31),(965,32),(966,32),(967,32),(968,33),(969,33),(970,33),(971,34),(972,34),(973,34),(974,35),(975,35),(976,35),(977,36),(978,36),(979,36),(980,37),(981,37),(982,37),(983,38),(984,38),(985,38),(986,39),(987,40),(988,40),(989,40),(990,41),(991,41),(992,41),(993,42),(994,42),(995,42),(996,43),(997,43),(998,43),(999,44),(1000,44),(1001,44),(1002,45),(1003,45),(1004,45),(1005,46),(1006,46),(1007,46),(1008,47),(1009,47),(1010,47),(1011,48),(1012,48),(1013,48),(1014,49),(1015,49),(1016,49),(1017,50),(1018,50),(1019,50),(1020,51),(1021,51),(1022,51),(1023,52),(1024,52),(1025,52),(1026,53),(1027,53),(1028,53),(1029,54),(1030,54),(1031,54),(1032,55),(1033,55),(1034,55),(1035,56),(1036,56),(1037,56),(1038,57),(1039,57),(1040,57),(1041,58),(1042,58),(1043,58),(1044,59),(1045,59),(1046,59),(1047,60),(1048,60),(1049,60),(1050,61),(1051,61),(1052,61),(1053,62),(1054,62),(1055,62),(1056,63),(1057,63),(1058,63),(1059,64),(1060,64),(1061,64),(1062,65),(1063,65),(1064,65),(1065,66),(1066,66),(1067,66),(1068,67),(1069,67),(1070,67),(1071,68),(1072,68),(1073,68),(1074,69),(1075,69),(1076,69),(1077,70),(1078,70),(1079,70),(1080,71),(1081,71),(1082,71),(1083,72),(1084,72),(1085,72),(1086,73),(1087,73),(1088,73),(1089,74),(1090,74),(1091,74),(1092,75),(1093,75),(1094,75),(1095,76),(1096,76),(1097,76),(1098,77),(1099,77),(1100,77),(1101,78),(1102,78),(1103,78),(1104,79),(1105,79),(1106,79),(1107,80),(1108,80),(1109,80),(1110,81),(1111,81),(1112,81),(1113,82),(1114,82),(1115,82),(1116,83),(1117,83),(1118,83),(1119,84),(1120,84),(1121,84),(1122,85),(1123,85),(1124,85),(1125,86),(1126,86),(1127,86),(1128,87),(1129,87),(1130,87),(1131,88),(1132,88),(1133,88),(1134,89),(1135,89),(1136,89),(1137,90),(1138,90),(1139,90),(1140,91),(1141,91),(1142,91),(1143,92),(1144,92),(1145,92),(1146,93),(1147,93),(1148,93),(1149,94),(1150,94),(1151,94),(1152,95),(1153,95),(1154,95),(1155,96),(1156,96),(1157,97),(1158,97),(1159,98),(1160,98),(1161,99),(1162,99),(1163,100),(1164,100),(1165,101),(1166,101),(1167,102),(1168,102),(1169,103),(1170,103),(1171,104),(1172,104),(1173,105),(1174,105),(1175,106),(1176,106),(1177,8),(1178,8),(1179,8),(1180,8),(1181,9),(1182,9),(1183,9),(1184,9),(1185,10),(1186,10),(1187,10),(1188,10),(1189,11),(1190,11),(1191,11),(1192,11),(1193,12),(1194,12),(1195,12),(1196,12),(1197,13),(1198,13),(1199,13),(1200,13),(1201,14),(1202,14),(1203,14),(1204,14),(1205,15),(1206,15),(1207,15),(1208,15),(1209,16),(1210,16),(1211,16),(1212,16),(1213,17),(1214,17),(1215,17),(1216,17),(1217,18),(1218,18),(1219,18),(1220,18),(1221,19),(1222,19),(1223,19),(1224,19),(1225,20),(1226,20),(1227,20),(1228,20),(1229,21),(1230,21),(1231,21),(1232,21),(1233,22),(1234,22),(1235,22),(1236,22),(1237,23),(1238,23),(1239,23),(1240,23),(1241,24),(1242,24),(1243,24),(1244,24),(1245,25),(1246,25),(1247,25),(1248,25),(1249,26),(1250,26),(1251,26),(1252,26),(1253,27),(1254,27),(1255,27),(1256,27),(1257,28),(1258,28),(1259,28),(1260,28),(1261,29),(1262,29),(1263,29),(1264,29),(1265,30),(1266,30),(1267,30),(1268,30),(1269,31),(1270,31),(1271,31),(1272,31),(1273,32),(1274,32),(1275,32),(1276,32),(1277,33),(1278,33),(1279,33),(1280,33),(1281,34),(1282,34),(1283,34),(1284,34),(1285,35),(1286,35),(1287,35),(1288,35),(1289,36),(1290,36),(1291,36),(1292,36),(1293,37),(1294,37),(1295,37),(1296,37),(1297,38),(1298,38),(1299,38),(1300,38),(1301,39),(1302,39),(1303,39),(1304,39),(1305,40),(1306,40),(1307,40),(1308,40),(1309,41),(1310,41),(1311,41),(1312,41),(1313,42),(1314,42),(1315,42),(1316,42),(1317,43),(1318,43),(1319,43),(1320,43),(1321,44),(1322,44),(1323,44),(1324,44),(1325,45),(1326,45),(1327,45),(1328,45),(1329,46),(1330,46),(1331,46),(1332,46),(1333,47),(1334,47),(1335,47),(1336,47),(1337,48),(1338,48),(1339,48),(1340,48),(1341,49),(1342,49),(1343,49),(1344,49),(1345,50),(1346,50),(1347,50),(1348,50),(1349,51),(1350,51),(1351,51),(1352,51),(1353,52),(1354,52),(1355,52),(1356,52),(1357,53),(1358,53),(1359,53),(1360,53),(1361,54),(1362,54),(1363,54),(1364,54),(1365,55),(1366,55),(1367,55),(1368,55),(1369,56),(1370,56),(1371,56),(1372,56),(1373,57),(1374,57),(1375,57),(1376,57),(1377,58),(1378,58),(1379,58),(1380,58),(1381,59),(1382,59),(1383,59),(1384,59),(1385,60),(1386,60),(1387,60),(1388,60),(1389,61),(1390,61),(1391,61),(1392,61),(1393,62),(1394,62),(1395,62),(1396,62),(1397,63),(1398,63),(1399,63),(1400,63),(1401,64),(1402,64),(1403,64),(1404,64),(1405,65),(1406,65),(1407,65),(1408,65),(1409,66),(1410,66),(1411,66),(1412,66),(1413,67),(1414,67),(1415,67),(1416,67),(1417,68),(1418,68),(1419,68),(1420,68),(1421,69),(1422,69),(1423,69),(1424,69),(1425,70),(1426,70),(1427,70),(1428,70),(1429,71),(1430,71),(1431,71),(1432,71),(1433,72),(1434,72),(1435,72),(1436,72),(1437,73),(1438,73),(1439,73),(1440,73),(1441,74),(1442,74),(1443,74),(1444,74),(1445,75),(1446,75),(1447,75),(1448,75),(1449,76),(1450,76),(1451,76),(1452,76),(1453,77),(1454,77),(1455,77),(1456,77),(1457,78),(1458,78),(1459,78),(1460,78),(1461,79),(1462,79),(1463,79),(1464,79),(1465,80),(1466,80),(1467,80),(1468,80),(1469,81),(1470,81),(1471,81),(1472,81),(1473,82),(1474,82),(1475,82),(1476,82),(1477,83),(1478,83),(1479,83),(1480,83),(1481,84),(1482,84),(1483,84),(1484,84),(1485,85),(1486,85),(1487,85),(1488,85),(1489,86),(1490,86),(1491,86),(1492,86),(1493,87),(1494,87),(1495,87),(1496,87),(1497,88),(1498,88),(1499,88),(1500,88),(1501,89),(1502,89),(1503,89),(1504,89),(1505,90),(1506,90),(1507,90),(1508,90),(1509,91),(1510,91),(1511,91),(1512,91),(1513,92),(1514,92),(1515,92),(1516,92),(1517,93),(1518,93),(1519,93),(1520,93),(1521,94),(1522,94),(1523,94),(1524,94),(1525,95),(1526,95),(1527,95),(1528,95),(1529,96),(1530,96),(1531,96),(1532,96),(1533,97),(1534,97),(1535,97),(1536,97),(1537,98),(1538,98),(1539,98),(1540,98),(1541,99),(1542,99),(1543,99),(1544,99),(1545,100),(1546,100),(1547,100),(1548,100),(1549,101),(1550,101),(1551,101),(1552,101),(1553,102),(1554,102),(1555,102),(1556,102),(1557,103),(1558,103),(1559,103),(1560,103),(1561,104),(1562,104),(1563,104),(1564,104),(1565,105),(1566,105),(1567,105),(1568,105),(1569,106),(1570,106),(1571,106),(1572,106),(1573,107),(1574,107),(1575,107),(1576,107),(1577,107),(1578,107),(1579,107),(1580,107),(1581,107),(1582,108),(1583,108),(1584,108),(1585,108),(1586,108),(1587,108),(1588,108),(1589,108),(1590,108),(1591,109),(1592,109),(1593,109),(1594,109),(1595,109),(1596,109),(1597,109),(1598,109),(1599,109),(1600,110),(1601,110),(1602,110),(1603,110),(1604,110),(1605,110),(1606,110),(1607,111),(1608,111),(1609,111),(1610,111),(1611,111),(1612,111),(1613,111),(1614,112),(1615,112),(1616,112),(1617,112),(1618,112),(1619,112),(1620,112),(1621,113),(1622,113),(1623,113),(1624,113),(1625,114),(1626,114),(1627,114),(1628,114),(1629,114),(1630,114),(1631,114),(1632,115),(1633,115),(1634,115),(1635,115),(1636,115),(1637,115),(1638,115),(1639,116),(1640,116),(1641,116),(1642,116),(1643,116),(1644,116),(1645,116),(1646,117),(1647,117),(1648,117),(1649,117),(1650,118),(1651,118),(1652,118),(1653,118),(1654,118),(1655,118),(1656,118),(1657,119),(1658,119),(1659,119),(1660,119),(1661,119),(1662,119),(1663,119),(1664,120),(1665,120),(1666,120),(1667,120),(1668,120),(1669,120),(1670,120),(1671,121),(1672,121),(1673,121),(1674,121),(1675,121),(1676,121),(1677,121),(1678,122),(1679,122),(1680,122),(1681,122),(1682,122),(1683,122),(1684,122),(1685,122),(1686,122),(1687,123),(1688,123),(1689,123),(1690,123),(1691,123),(1692,123),(1693,123),(1694,124),(1695,124),(1696,124),(1697,124),(1698,124),(1699,124),(1700,124),(1701,125),(1702,125),(1703,125),(1704,125),(1705,125),(1706,125),(1707,125),(1708,126),(1709,126),(1710,126),(1711,126),(1712,126),(1713,126),(1714,126),(1715,127),(1716,127),(1717,127),(1718,127),(1719,127),(1720,127),(1721,127),(1722,127),(1723,127),(1724,128),(1725,128),(1726,128),(1727,128),(1728,128),(1729,128),(1730,128),(1731,128),(1732,128),(1733,129),(1734,129),(1735,129),(1736,129),(1737,129),(1738,129),(1739,129),(1740,129),(1741,129),(1742,130),(1743,130),(1744,130),(1745,130),(1746,130),(1747,130),(1748,130),(1749,130),(1750,130),(1751,131),(1752,131),(1753,131),(1754,131),(1755,131),(1756,131),(1757,131),(1758,131),(1759,131),(1760,132),(1761,132),(1762,132),(1763,132),(1764,132),(1765,132),(1766,132),(1767,132),(1768,132),(1769,133),(1770,133),(1771,133),(1772,133),(1773,133),(1774,133),(1775,133),(1776,133),(1777,133),(1778,134),(1779,134),(1780,134),(1781,134),(1782,134),(1783,134),(1784,134),(1785,134),(1786,134),(1787,135),(1788,135),(1789,135),(1790,135),(1791,135),(1792,135),(1793,135),(1794,135),(1795,135),(1796,136),(1797,136),(1798,136),(1799,136),(1800,136),(1801,136),(1802,136),(1803,136),(1804,136),(1805,137),(1806,137),(1807,137),(1808,137),(1809,137),(1810,137),(1811,137),(1812,137),(1813,137),(1814,138),(1815,138),(1816,138),(1817,138),(1818,138),(1819,138),(1820,138),(1821,138),(1822,138),(1823,139),(1824,139),(1825,139),(1826,139),(1827,139),(1828,139),(1829,139),(1830,140),(1831,140),(1832,140),(1833,140),(1834,140),(1835,140),(1836,140),(1837,141),(1838,141),(1839,141),(1840,141),(1841,141),(1842,141),(1843,141),(1844,142),(1845,142),(1846,142),(1847,142),(1848,143),(1849,143),(1850,143),(1851,143),(1852,143),(1853,143),(1854,143),(1855,144),(1856,144),(1857,144),(1858,144),(1859,144),(1860,144),(1861,144),(1862,145),(1863,145),(1864,145),(1865,145),(1866,145),(1867,145),(1868,145),(1869,145),(1870,145),(1871,146),(1872,146),(1873,146),(1874,146),(1875,146),(1876,146),(1877,146),(1878,147),(1879,147),(1880,147),(1881,147),(1882,147),(1883,147),(1884,147),(1885,147),(1886,147),(1887,148),(1888,148),(1889,148),(1890,148),(1891,148),(1892,148),(1893,148),(1894,148),(1895,148),(1896,149),(1897,149),(1898,149),(1899,149),(1900,149),(1901,149),(1902,149),(1903,149),(1904,149),(1905,150),(1906,150),(1907,150),(1908,150),(1909,150),(1910,150),(1911,150),(1912,151),(1913,151),(1914,151),(1915,151),(1916,151),(1917,151),(1918,151),(1919,152),(1920,152),(1921,152),(1922,152),(1923,153),(1924,153),(1925,153),(1926,153),(1927,153),(1928,153),(1929,153),(1930,153),(1931,153),(1932,154),(1933,154),(1934,154),(1935,154),(1936,154),(1937,154),(1938,154),(1939,154),(1940,154),(1941,155),(1942,155),(1943,155),(1944,155),(1945,155),(1946,155),(1947,155),(1948,155),(1949,155),(1950,156),(1951,156),(1952,156),(1953,156),(1954,156),(1955,156),(1956,156),(1957,157),(1958,157),(1959,157),(1960,157),(1961,157),(1962,157),(1963,157),(1964,158),(1965,158),(1966,158),(1967,158),(1968,158),(1969,158),(1970,158),(1971,159),(1972,159),(1973,159),(1974,159),(1975,159),(1976,159),(1977,159),(1978,160),(1979,160),(1980,160),(1981,160),(1982,160),(1983,160),(1984,160),(1985,161),(1986,161),(1987,161),(1988,161),(1989,161),(1990,161),(1991,161),(1992,162),(1993,162),(1994,162),(1995,162),(1996,162),(1997,162),(1998,162),(1999,162),(2000,162),(2001,163),(2002,163),(2003,163),(2004,163),(2005,163),(2006,163),(2007,163),(2008,164),(2009,164),(2010,164),(2011,164),(2012,164),(2013,164),(2014,165),(2015,165),(2016,165),(2017,165),(2018,165),(2019,165),(2020,165),(2021,166),(2022,166),(2023,166),(2024,166),(2025,166),(2026,166),(2027,167),(2028,167),(2029,167),(2030,167),(2031,167),(2032,167),(2033,167),(2034,168),(2035,168),(2036,168),(2037,168),(2038,168),(2039,168),(2040,168),(2041,169),(2042,169),(2043,169),(2044,169),(2045,169),(2046,169),(2047,169),(2048,170),(2049,170),(2050,170),(2051,170),(2052,170),(2053,170),(2054,170),(2055,171),(2056,171),(2057,171),(2058,171),(2059,171),(2060,171),(2061,171),(2062,172),(2063,172),(2064,172),(2065,172),(2066,172),(2067,172),(2068,173),(2069,173),(2070,173),(2071,173),(2072,173),(2073,173),(2074,173),(2075,174),(2076,174),(2077,174),(2078,174),(2079,174),(2080,174),(2081,174),(2082,175),(2083,175),(2084,175),(2085,175),(2086,175),(2087,175),(2088,175),(2089,176),(2090,176),(2091,176),(2092,176),(2093,177),(2094,177),(2095,177),(2096,177),(2097,178),(2098,178),(2099,178),(2100,178),(2101,179),(2102,179),(2103,179),(2104,179),(2105,180),(2106,180),(2107,180),(2108,180),(2109,181),(2110,181),(2111,181),(2112,181),(2113,182),(2114,182),(2115,182),(2116,182),(2117,183),(2118,183),(2119,183),(2120,183),(2121,184),(2122,184),(2123,184),(2124,184),(2125,185),(2126,185),(2127,185),(2128,185),(2129,186),(2130,186),(2131,186),(2132,186),(2133,187),(2134,187),(2135,187),(2136,187),(2137,188),(2138,188),(2139,188),(2140,188),(2141,189),(2142,189),(2143,189),(2144,189),(2145,190),(2146,190),(2147,190),(2148,190),(2149,190),(2150,190),(2151,190),(2152,190),(2153,190),(2154,191),(2155,191),(2156,191),(2157,191),(2158,191),(2159,191),(2160,191),(2161,191),(2162,191),(2163,192),(2164,192),(2165,192),(2166,192),(2167,192),(2168,192),(2169,192),(2170,192),(2171,192),(2172,193),(2173,193),(2174,193),(2175,193),(2176,193),(2177,193),(2178,193),(2179,193),(2180,193),(2181,194),(2182,194),(2183,194),(2184,194),(2185,194),(2186,194),(2187,194),(2188,194),(2189,194),(2190,195),(2191,195),(2192,195),(2193,195),(2194,195),(2195,195),(2196,195),(2197,195),(2198,195),(2199,196),(2200,196),(2201,196),(2202,196),(2203,196),(2204,196),(2205,196),(2206,196),(2207,196),(2208,197),(2209,197),(2210,197),(2211,197),(2212,197),(2213,197),(2214,197),(2215,197),(2216,197),(2217,198),(2218,198),(2219,198),(2220,198),(2221,199),(2222,199),(2223,199),(2224,199),(2225,200),(2226,200),(2227,200),(2228,200),(2229,201),(2230,201),(2231,201),(2232,201),(2233,201),(2234,201),(2235,201),(2236,201),(2237,201),(2238,202),(2239,202),(2240,202),(2241,202),(2242,202),(2243,202),(2244,202),(2245,202),(2246,202),(2247,203),(2248,203),(2249,203),(2250,203),(2251,203),(2252,203),(2253,203),(2254,203),(2255,203),(2256,204),(2257,204),(2258,204),(2259,204),(2260,205),(2261,205),(2262,205),(2263,205),(2264,206),(2265,206),(2266,206),(2267,206),(2268,107),(2269,107),(2270,108),(2271,108),(2272,109),(2273,109),(2274,110),(2275,110),(2276,110),(2277,111),(2278,111),(2279,111),(2280,112),(2281,112),(2282,112),(2283,113),(2284,113),(2285,113),(2286,114),(2287,114),(2288,114),(2289,115),(2290,115),(2291,115),(2292,116),(2293,116),(2294,116),(2295,117),(2296,117),(2297,117),(2298,118),(2299,118),(2300,118),(2301,119),(2302,119),(2303,119),(2304,120),(2305,120),(2306,120),(2307,121),(2308,121),(2309,121),(2310,122),(2311,122),(2312,122),(2313,123),(2314,123),(2315,123),(2316,124),(2317,124),(2318,124),(2319,125),(2320,125),(2321,125),(2322,126),(2323,126),(2324,126),(2325,127),(2326,127),(2327,127),(2328,128),(2329,128),(2330,128),(2331,129),(2332,129),(2333,129),(2334,130),(2335,130),(2336,130),(2337,131),(2338,131),(2339,131),(2340,132),(2341,132),(2342,132),(2343,133),(2344,133),(2345,133),(2346,134),(2347,134),(2348,134),(2349,135),(2350,135),(2351,135),(2352,136),(2353,136),(2354,136),(2355,137),(2356,137),(2357,137),(2358,138),(2359,138),(2360,139),(2361,139),(2362,139),(2363,140),(2364,140),(2365,140),(2366,141),(2367,141),(2368,141),(2369,142),(2370,142),(2371,142),(2372,143),(2373,143),(2374,143),(2375,144),(2376,144),(2377,144),(2378,145),(2379,145),(2380,145),(2381,146),(2382,146),(2383,146),(2384,147),(2385,147),(2386,147),(2387,148),(2388,148),(2389,148),(2390,149),(2391,149),(2392,149),(2393,150),(2394,150),(2395,150),(2396,151),(2397,151),(2398,151),(2399,152),(2400,152),(2401,152),(2402,153),(2403,153),(2404,153),(2405,154),(2406,154),(2407,154),(2408,155),(2409,155),(2410,155),(2411,156),(2412,156),(2413,156),(2414,157),(2415,157),(2416,157),(2417,158),(2418,158),(2419,158),(2420,159),(2421,159),(2422,159),(2423,160),(2424,160),(2425,160),(2426,161),(2427,161),(2428,161),(2429,162),(2430,162),(2431,162),(2432,163),(2433,163),(2434,163),(2435,164),(2436,164),(2437,164),(2438,165),(2439,165),(2440,165),(2441,166),(2442,166),(2443,166),(2444,167),(2445,167),(2446,167),(2447,168),(2448,168),(2449,168),(2450,169),(2451,169),(2452,169),(2453,170),(2454,170),(2455,170),(2456,171),(2457,171),(2458,171),(2459,172),(2460,172),(2461,172),(2462,173),(2463,173),(2464,173),(2465,174),(2466,174),(2467,174),(2468,175),(2469,175),(2470,175),(2471,176),(2472,176),(2473,176),(2474,177),(2475,177),(2476,177),(2477,178),(2478,178),(2479,178),(2480,179),(2481,179),(2482,179),(2483,180),(2484,180),(2485,180),(2486,181),(2487,181),(2488,181),(2489,182),(2490,182),(2491,182),(2492,183),(2493,183),(2494,183),(2495,184),(2496,184),(2497,184),(2498,185),(2499,185),(2500,185),(2501,186),(2502,186),(2503,186),(2504,187),(2505,187),(2506,187),(2507,188),(2508,188),(2509,188),(2510,189),(2511,189),(2512,189),(2513,190),(2514,190),(2515,190),(2516,191),(2517,191),(2518,191),(2519,192),(2520,192),(2521,192),(2522,193),(2523,193),(2524,193),(2525,194),(2526,194),(2527,194),(2528,195),(2529,195),(2530,195),(2531,196),(2532,196),(2533,196),(2534,197),(2535,197),(2536,197),(2537,198),(2538,198),(2539,198),(2540,199),(2541,199),(2542,199),(2543,200),(2544,200),(2545,200),(2546,201),(2547,201),(2548,201),(2549,202),(2550,202),(2551,202),(2552,203),(2553,203),(2554,203),(2555,204),(2556,204),(2557,204),(2558,205),(2559,205),(2560,205),(2561,206),(2562,206),(2563,206),(2564,107),(2565,107),(2566,107),(2567,107),(2568,108),(2569,108),(2570,108),(2571,108),(2572,109),(2573,109),(2574,109),(2575,109),(2576,110),(2577,110),(2578,110),(2579,110),(2580,111),(2581,111),(2582,111),(2583,111),(2584,112),(2585,112),(2586,112),(2587,112),(2588,113),(2589,113),(2590,113),(2591,113),(2592,114),(2593,114),(2594,114),(2595,114),(2596,115),(2597,115),(2598,115),(2599,115),(2600,116),(2601,116),(2602,116),(2603,116),(2604,117),(2605,117),(2606,117),(2607,117),(2608,118),(2609,118),(2610,118),(2611,118),(2612,119),(2613,119),(2614,119),(2615,119),(2616,120),(2617,120),(2618,120),(2619,120),(2620,121),(2621,121),(2622,121),(2623,121),(2624,122),(2625,122),(2626,122),(2627,122),(2628,123),(2629,123),(2630,123),(2631,123),(2632,124),(2633,124),(2634,124),(2635,124),(2636,125),(2637,125),(2638,125),(2639,125),(2640,126),(2641,126),(2642,126),(2643,126),(2644,127),(2645,127),(2646,127),(2647,127),(2648,128),(2649,128),(2650,128),(2651,128),(2652,129),(2653,129),(2654,129),(2655,129),(2656,130),(2657,130),(2658,130),(2659,130),(2660,131),(2661,131),(2662,131),(2663,131),(2664,132),(2665,132),(2666,132),(2667,132),(2668,133),(2669,133),(2670,133),(2671,133),(2672,134),(2673,134),(2674,134),(2675,134),(2676,135),(2677,135),(2678,135),(2679,135),(2680,136),(2681,136),(2682,136),(2683,136),(2684,137),(2685,137),(2686,137),(2687,137),(2688,138),(2689,138),(2690,138),(2691,138),(2692,139),(2693,139),(2694,139),(2695,139),(2696,140),(2697,140),(2698,140),(2699,140),(2700,141),(2701,141),(2702,141),(2703,141),(2704,142),(2705,142),(2706,142),(2707,142),(2708,143),(2709,143),(2710,143),(2711,143),(2712,144),(2713,144),(2714,144),(2715,144),(2716,145),(2717,145),(2718,145),(2719,145),(2720,146),(2721,146),(2722,146),(2723,146),(2724,147),(2725,147),(2726,147),(2727,147),(2728,148),(2729,148),(2730,148),(2731,148),(2732,149),(2733,149),(2734,149),(2735,149),(2736,150),(2737,150),(2738,150),(2739,150),(2740,151),(2741,151),(2742,151),(2743,151),(2744,152),(2745,152),(2746,152),(2747,152),(2748,153),(2749,153),(2750,153),(2751,153),(2752,154),(2753,154),(2754,154),(2755,154),(2756,155),(2757,155),(2758,155),(2759,155),(2760,156),(2761,156),(2762,156),(2763,156),(2764,157),(2765,157),(2766,157),(2767,157),(2768,158),(2769,158),(2770,158),(2771,158),(2772,159),(2773,159),(2774,159),(2775,159),(2776,160),(2777,160),(2778,160),(2779,160),(2780,161),(2781,161),(2782,161),(2783,161),(2784,162),(2785,162),(2786,162),(2787,162),(2788,163),(2789,163),(2790,163),(2791,163),(2792,164),(2793,164),(2794,164),(2795,164),(2796,165),(2797,165),(2798,165),(2799,165),(2800,166),(2801,166),(2802,166),(2803,166),(2804,167),(2805,167),(2806,167),(2807,167),(2808,168),(2809,168),(2810,168),(2811,168),(2812,169),(2813,169),(2814,169),(2815,169),(2816,170),(2817,170),(2818,170),(2819,170),(2820,171),(2821,171),(2822,171),(2823,171),(2824,172),(2825,172),(2826,172),(2827,172),(2828,173),(2829,173),(2830,173),(2831,173),(2832,174),(2833,174),(2834,174),(2835,174),(2836,175),(2837,175),(2838,175),(2839,175),(2840,176),(2841,176),(2842,176),(2843,176),(2844,177),(2845,177),(2846,177),(2847,177),(2848,178),(2849,178),(2850,178),(2851,178),(2852,179),(2853,179),(2854,179),(2855,179),(2856,180),(2857,180),(2858,180),(2859,180),(2860,181),(2861,181),(2862,181),(2863,181),(2864,182),(2865,182),(2866,182),(2867,182),(2868,183),(2869,183),(2870,183),(2871,183),(2872,184),(2873,184),(2874,184),(2875,184),(2876,185),(2877,185),(2878,185),(2879,185),(2880,186),(2881,186),(2882,186),(2883,186),(2884,187),(2885,187),(2886,187),(2887,187),(2888,188),(2889,188),(2890,188),(2891,188),(2892,189),(2893,189),(2894,189),(2895,189),(2896,190),(2897,190),(2898,190),(2899,190),(2900,191),(2901,191),(2902,191),(2903,191),(2904,192),(2905,192),(2906,192),(2907,192),(2908,193),(2909,193),(2910,193),(2911,193),(2912,194),(2913,194),(2914,194),(2915,194),(2916,195),(2917,195),(2918,195),(2919,195),(2920,196),(2921,196),(2922,196),(2923,196),(2924,197),(2925,197),(2926,197),(2927,197),(2928,198),(2929,198),(2930,198),(2931,198),(2932,199),(2933,199),(2934,199),(2935,199),(2936,200),(2937,200),(2938,200),(2939,200),(2940,201),(2941,201),(2942,201),(2943,201),(2944,202),(2945,202),(2946,202),(2947,202),(2948,203),(2949,203),(2950,203),(2951,203),(2952,204),(2953,204),(2954,204),(2955,204),(2956,205),(2957,205),(2958,205),(2959,205),(2960,206),(2961,206),(2962,206),(2963,206),(2964,207),(2965,207),(2966,207),(2967,207),(2968,208),(2969,208),(2970,208),(2971,208),(2972,209),(2973,209),(2974,209),(2975,209),(2976,210),(2977,210),(2978,210),(2979,210),(2980,211),(2981,211),(2982,211),(2983,211),(2984,212),(2985,212),(2986,212),(2987,212),(2988,213),(2989,213),(2990,213),(2991,213),(2992,214),(2993,214),(2994,214),(2995,214),(2996,215),(2997,215),(2998,215),(2999,215),(3000,216),(3001,216),(3002,216),(3003,216),(3004,217),(3005,217),(3006,217),(3007,217),(3008,218),(3009,218),(3010,218),(3011,218),(3012,219),(3013,219),(3014,219),(3015,219),(3016,220),(3017,220),(3018,220),(3019,220),(3020,221),(3021,221),(3022,221),(3023,221),(3024,221),(3025,221),(3026,221),(3027,222),(3028,222),(3029,222),(3030,222),(3031,222),(3032,222),(3033,222),(3034,223),(3035,223),(3036,223),(3037,223),(3038,223),(3039,223),(3040,223),(3041,224),(3042,224),(3043,224),(3044,224),(3045,224),(3046,224),(3047,224),(3048,225),(3049,225),(3050,225),(3051,225),(3052,225),(3053,225),(3054,225),(3055,226),(3056,226),(3057,226),(3058,226),(3059,226),(3060,226),(3061,226),(3062,227),(3063,227),(3064,227),(3065,227),(3066,227),(3067,227),(3068,227),(3069,228),(3070,228),(3071,228),(3072,228),(3073,228),(3074,228),(3075,228),(3076,229),(3077,229),(3078,229),(3079,229),(3080,229),(3081,229),(3082,229),(3083,230),(3084,230),(3085,230),(3086,230),(3087,230),(3088,230),(3089,230),(3090,231),(3091,231),(3092,231),(3093,231),(3094,231),(3095,231),(3096,231),(3097,232),(3098,232),(3099,232),(3100,232),(3101,232),(3102,232),(3103,232),(3104,233),(3105,233),(3106,233),(3107,233),(3108,233),(3109,233),(3110,233),(3111,234),(3112,234),(3113,234),(3114,234),(3115,234),(3116,234),(3117,234),(3118,235),(3119,235),(3120,235),(3121,235),(3122,235),(3123,235),(3124,235),(3125,236),(3126,236),(3127,236),(3128,236),(3129,236),(3130,236),(3131,236),(3132,237),(3133,237),(3134,237),(3135,237),(3136,237),(3137,237),(3138,237),(3139,238),(3140,238),(3141,238),(3142,238),(3143,238),(3144,238),(3145,238),(3146,239),(3147,239),(3148,239),(3149,239),(3150,239),(3151,239),(3152,239),(3153,240),(3154,240),(3155,240),(3156,240),(3157,240),(3158,240),(3159,240),(3160,241),(3161,241),(3162,241),(3163,241),(3164,241),(3165,241),(3166,241),(3167,242),(3168,242),(3169,242),(3170,242),(3171,242),(3172,242),(3173,242),(3174,243),(3175,243),(3176,243),(3177,243),(3178,243),(3179,243),(3180,243),(3181,244),(3182,244),(3183,244),(3184,244),(3185,244),(3186,244),(3187,244),(3188,244),(3189,244),(3190,245),(3191,245),(3192,245),(3193,245),(3194,245),(3195,245),(3196,245),(3197,245),(3198,245),(3199,246),(3200,246),(3201,246),(3202,246),(3203,246),(3204,246),(3205,246),(3206,247),(3207,247),(3208,247),(3209,247),(3210,247),(3211,247),(3212,247),(3213,248),(3214,248),(3215,248),(3216,248),(3217,248),(3218,248),(3219,248),(3220,249),(3221,249),(3222,249),(3223,249),(3224,249),(3225,249),(3226,249),(3227,250),(3228,250),(3229,250),(3230,250),(3231,250),(3232,250),(3233,250),(3234,251),(3235,251),(3236,251),(3237,251),(3238,251),(3239,251),(3240,251),(3241,251),(3242,251),(3243,252),(3244,252),(3245,252),(3246,252),(3247,252),(3248,252),(3249,252),(3250,253),(3251,253),(3252,253),(3253,253),(3254,253),(3255,253),(3256,253),(3257,254),(3258,254),(3259,254),(3260,254),(3261,254),(3262,254),(3263,255),(3264,255),(3265,255),(3266,255),(3267,255),(3268,255),(3269,256),(3270,256),(3271,256),(3272,256),(3273,256),(3274,256),(3275,257),(3276,257),(3277,257),(3278,257),(3279,257),(3280,257),(3281,258),(3282,258),(3283,258),(3284,258),(3285,258),(3286,258),(3287,258),(3288,259),(3289,259),(3290,259),(3291,259),(3292,259),(3293,259),(3294,259),(3295,260),(3296,260),(3297,260),(3298,260),(3299,260),(3300,260),(3301,260),(3302,261),(3303,261),(3304,261),(3305,261),(3306,261),(3307,261),(3308,261),(3309,262),(3310,262),(3311,262),(3312,262),(3313,262),(3314,262),(3315,262),(3316,263),(3317,263),(3318,263),(3319,263),(3320,263),(3321,263),(3322,263),(3323,264),(3324,264),(3325,264),(3326,264),(3327,264),(3328,264),(3329,264),(3330,265),(3331,265),(3332,265),(3333,265),(3334,265),(3335,265),(3336,265),(3337,266),(3338,266),(3339,266),(3340,266),(3341,266),(3342,266),(3343,266),(3344,267),(3345,267),(3346,267),(3347,267),(3348,267),(3349,267),(3350,267),(3351,268),(3352,268),(3353,268),(3354,268),(3355,268),(3356,268),(3357,268),(3358,268),(3359,268),(3360,269),(3361,269),(3362,269),(3363,269),(3364,269),(3365,269),(3366,269),(3367,269),(3368,269),(3369,270),(3370,270),(3371,270),(3372,270),(3373,270),(3374,270),(3375,270),(3376,270),(3377,270),(3378,271),(3379,271),(3380,271),(3381,271),(3382,271),(3383,271),(3384,271),(3385,271),(3386,271),(3387,272),(3388,272),(3389,272),(3390,272),(3391,272),(3392,272),(3393,272),(3394,272),(3395,272),(3396,273),(3397,273),(3398,273),(3399,273),(3400,273),(3401,273),(3402,273),(3403,273),(3404,273),(3405,274),(3406,274),(3407,274),(3408,274),(3409,274),(3410,274),(3411,274),(3412,274),(3413,274),(3414,275),(3415,275),(3416,275),(3417,275),(3418,275),(3419,275),(3420,275),(3421,275),(3422,275),(3423,276),(3424,276),(3425,276),(3426,276),(3427,276),(3428,276),(3429,276),(3430,277),(3431,277),(3432,277),(3433,277),(3434,277),(3435,277),(3436,277),(3437,278),(3438,278),(3439,278),(3440,278),(3441,278),(3442,278),(3443,278),(3444,279),(3445,279),(3446,279),(3447,279),(3448,279),(3449,279),(3450,279),(3451,280),(3452,280),(3453,280),(3454,280),(3455,280),(3456,280),(3457,280),(3458,207),(3459,207),(3460,207),(3461,208),(3462,208),(3463,208),(3464,209),(3465,209),(3466,209),(3467,210),(3468,210),(3469,210),(3470,211),(3471,211),(3472,211),(3473,212),(3474,212),(3475,212),(3476,213),(3477,213),(3478,213),(3479,214),(3480,214),(3481,214),(3482,215),(3483,215),(3484,215),(3485,216),(3486,216),(3487,216),(3488,217),(3489,217),(3490,217),(3491,218),(3492,218),(3493,218),(3494,219),(3495,219),(3496,219),(3497,220),(3498,220),(3499,220),(3500,221),(3501,221),(3502,221),(3503,222),(3504,222),(3505,222),(3506,223),(3507,223),(3508,223),(3509,224),(3510,224),(3511,224),(3512,225),(3513,225),(3514,225),(3515,226),(3516,226),(3517,226),(3518,227),(3519,227),(3520,227),(3521,228),(3522,228),(3523,228),(3524,229),(3525,229),(3526,229),(3527,230),(3528,230),(3529,230),(3530,231),(3531,231),(3532,231),(3533,232),(3534,232),(3535,232),(3536,233),(3537,233),(3538,233),(3539,234),(3540,234),(3541,234),(3542,235),(3543,235),(3544,235),(3545,236),(3546,236),(3547,236),(3548,237),(3549,237),(3550,237),(3551,238),(3552,238),(3553,238),(3554,239),(3555,239),(3556,239),(3557,240),(3558,240),(3559,240),(3560,241),(3561,241),(3562,241),(3563,242),(3564,242),(3565,242),(3566,243),(3567,243),(3568,243),(3569,244),(3570,244),(3571,245),(3572,245),(3573,246),(3574,246),(3575,246),(3576,247),(3577,247),(3578,247),(3579,248),(3580,248),(3581,248),(3582,249),(3583,249),(3584,249),(3585,250),(3586,250),(3587,250),(3588,251),(3589,251),(3590,252),(3591,252),(3592,252),(3593,253),(3594,253),(3595,253),(3596,254),(3597,254),(3598,254),(3599,255),(3600,255),(3601,255),(3602,256),(3603,256),(3604,256),(3605,257),(3606,257),(3607,257),(3608,258),(3609,258),(3610,258),(3611,259),(3612,259),(3613,259),(3614,260),(3615,260),(3616,260),(3617,261),(3618,261),(3619,261),(3620,262),(3621,262),(3622,262),(3623,263),(3624,263),(3625,263),(3626,264),(3627,264),(3628,264),(3629,265),(3630,265),(3631,265),(3632,266),(3633,266),(3634,266),(3635,267),(3636,267),(3637,267),(3638,268),(3639,268),(3640,268),(3641,269),(3642,269),(3643,269),(3644,270),(3645,270),(3646,270),(3647,271),(3648,271),(3649,271),(3650,272),(3651,272),(3652,272),(3653,273),(3654,273),(3655,273),(3656,274),(3657,274),(3658,274),(3659,275),(3660,275),(3661,275),(3662,276),(3663,276),(3664,276),(3665,277),(3666,277),(3667,277),(3668,278),(3669,278),(3670,278),(3671,279),(3672,279),(3673,279),(3674,280),(3675,280),(3676,280),(3677,207),(3678,207),(3679,207),(3680,207),(3681,208),(3682,208),(3683,208),(3684,208),(3685,209),(3686,209),(3687,209),(3688,209),(3689,210),(3690,210),(3691,210),(3692,210),(3693,211),(3694,211),(3695,211),(3696,211),(3697,212),(3698,212),(3699,212),(3700,212),(3701,213),(3702,213),(3703,213),(3704,213),(3705,214),(3706,214),(3707,214),(3708,214),(3709,215),(3710,215),(3711,215),(3712,215),(3713,216),(3714,216),(3715,216),(3716,216),(3717,217),(3718,217),(3719,217),(3720,217),(3721,218),(3722,218),(3723,218),(3724,218),(3725,219),(3726,219),(3727,219),(3728,219),(3729,220),(3730,220),(3731,220),(3732,220),(3733,221),(3734,221),(3735,221),(3736,221),(3737,222),(3738,222),(3739,222),(3740,222),(3741,223),(3742,223),(3743,223),(3744,223),(3745,224),(3746,224),(3747,224),(3748,224),(3749,225),(3750,225),(3751,225),(3752,225),(3753,226),(3754,226),(3755,226),(3756,226),(3757,227),(3758,227),(3759,227),(3760,227),(3761,228),(3762,228),(3763,228),(3764,228),(3765,229),(3766,229),(3767,229),(3768,229),(3769,230),(3770,230),(3771,230),(3772,230),(3773,231),(3774,231),(3775,231),(3776,231),(3777,232),(3778,232),(3779,232),(3780,232),(3781,233),(3782,233),(3783,233),(3784,233),(3785,234),(3786,234),(3787,234),(3788,234),(3789,235),(3790,235),(3791,235),(3792,235),(3793,236),(3794,236),(3795,236),(3796,236),(3797,237),(3798,237),(3799,237),(3800,237),(3801,238),(3802,238),(3803,238),(3804,238),(3805,239),(3806,239),(3807,239),(3808,239),(3809,240),(3810,240),(3811,240),(3812,240),(3813,241),(3814,241),(3815,241),(3816,241),(3817,242),(3818,242),(3819,242),(3820,242),(3821,243),(3822,243),(3823,243),(3824,243),(3825,244),(3826,244),(3827,244),(3828,244),(3829,245),(3830,245),(3831,245),(3832,245),(3833,246),(3834,246),(3835,246),(3836,246),(3837,247),(3838,247),(3839,247),(3840,247),(3841,248),(3842,248),(3843,248),(3844,248),(3845,249),(3846,249),(3847,249),(3848,249),(3849,250),(3850,250),(3851,250),(3852,250),(3853,251),(3854,251),(3855,251),(3856,251),(3857,252),(3858,252),(3859,252),(3860,252),(3861,253),(3862,253),(3863,253),(3864,253),(3865,254),(3866,254),(3867,254),(3868,254),(3869,255),(3870,255),(3871,255),(3872,255),(3873,256),(3874,256),(3875,256),(3876,256),(3877,257),(3878,257),(3879,257),(3880,257),(3881,258),(3882,258),(3883,258),(3884,258),(3885,259),(3886,259),(3887,259),(3888,259),(3889,260),(3890,260),(3891,260),(3892,260),(3893,261),(3894,261),(3895,261),(3896,261),(3897,262),(3898,262),(3899,262),(3900,262),(3901,263),(3902,263),(3903,263),(3904,263),(3905,264),(3906,264),(3907,264),(3908,264),(3909,265),(3910,265),(3911,265),(3912,265),(3913,266),(3914,266),(3915,266),(3916,266),(3917,267),(3918,267),(3919,267),(3920,267),(3921,268),(3922,268),(3923,268),(3924,268),(3925,269),(3926,269),(3927,269),(3928,269),(3929,270),(3930,270),(3931,270),(3932,270),(3933,271),(3934,271),(3935,271),(3936,271),(3937,272),(3938,272),(3939,272),(3940,272),(3941,273),(3942,273),(3943,273),(3944,273),(3945,274),(3946,274),(3947,274),(3948,274),(3949,275),(3950,275),(3951,275),(3952,275),(3953,276),(3954,276),(3955,276),(3956,276),(3957,277),(3958,277),(3959,277),(3960,277),(3961,278),(3962,278),(3963,278),(3964,278),(3965,279),(3966,279),(3967,279),(3968,279),(3969,280),(3970,280),(3971,280),(3972,280),(3973,281),(3974,281),(3975,281),(3976,281),(3977,281),(3978,281),(3979,282),(3980,282),(3981,282),(3982,282),(3983,283),(3984,283),(3985,283),(3986,283),(3987,284),(3988,284),(3989,284),(3990,284),(3991,284),(3992,284),(3993,285),(3994,285),(3995,285),(3996,285),(3997,286),(3998,286),(3999,286),(4000,286),(4001,286),(4002,286),(4003,287),(4004,287),(4005,287),(4006,287),(4007,287),(4008,287),(4009,288),(4010,288),(4011,288),(4012,288),(4013,289),(4014,289),(4015,289),(4016,289),(4017,289),(4018,289),(4019,290),(4020,290),(4021,290),(4022,290),(4023,291),(4024,291),(4025,291),(4026,291),(4027,291),(4028,291),(4029,292),(4030,292),(4031,292),(4032,292),(4033,292),(4034,292),(4035,293),(4036,293),(4037,293),(4038,293),(4039,294),(4040,294),(4041,294),(4042,294),(4043,294),(4044,294),(4045,295),(4046,295),(4047,295),(4048,295),(4049,296),(4050,296),(4051,296),(4052,296),(4053,296),(4054,296),(4055,297),(4056,297),(4057,297),(4058,297),(4059,297),(4060,297),(4061,298),(4062,298),(4063,298),(4064,298),(4065,298),(4066,298),(4067,299),(4068,299),(4069,299),(4070,299),(4071,299),(4072,299),(4073,300),(4074,300),(4075,300),(4076,300),(4077,300),(4078,300),(4079,301),(4080,301),(4081,301),(4082,301),(4083,302),(4084,302),(4085,302),(4086,302),(4087,303),(4088,303),(4089,303),(4090,303),(4091,304),(4092,304),(4093,304),(4094,304),(4095,304),(4096,304),(4097,305),(4098,305),(4099,305),(4100,305),(4101,306),(4102,306),(4103,306),(4104,306),(4105,307),(4106,307),(4107,307),(4108,307),(4109,307),(4110,307),(4111,308),(4112,308),(4113,308),(4114,308),(4115,308),(4116,309),(4117,309),(4118,309),(4119,309),(4120,310),(4121,310),(4122,310),(4123,310),(4124,311),(4125,311),(4126,311),(4127,311),(4128,311),(4129,312),(4130,312),(4131,312),(4132,312),(4133,312),(4134,312),(4135,313),(4136,313),(4137,313),(4138,313),(4139,314),(4140,314),(4141,314),(4142,314),(4143,314),(4144,314),(4145,315),(4146,315),(4147,315),(4148,315),(4149,316),(4150,316),(4151,316),(4152,316),(4153,317),(4154,317),(4155,317),(4156,317),(4157,317),(4158,317),(4159,318),(4160,318),(4161,318),(4162,318),(4163,319),(4164,319),(4165,319),(4166,319),(4167,319),(4168,319),(4169,320),(4170,320),(4171,320),(4172,320),(4173,320),(4174,320),(4175,321),(4176,321),(4177,321),(4178,321),(4179,321),(4180,321),(4181,322),(4182,322),(4183,322),(4184,322),(4185,322),(4186,322),(4187,323),(4188,323),(4189,323),(4190,323),(4191,323),(4192,323),(4193,324),(4194,324),(4195,324),(4196,324),(4197,325),(4198,325),(4199,325),(4200,325),(4201,326),(4202,326),(4203,326),(4204,326),(4205,327),(4206,327),(4207,327),(4208,327),(4209,328),(4210,328),(4211,328),(4212,328),(4213,329),(4214,329),(4215,329),(4216,329),(4217,330),(4218,330),(4219,330),(4220,330),(4221,331),(4222,331),(4223,331),(4224,331),(4225,332),(4226,332),(4227,332),(4228,332),(4229,332),(4230,333),(4231,333),(4232,333),(4233,333),(4234,333),(4235,334),(4236,334),(4237,334),(4238,334),(4239,334),(4240,334),(4241,335),(4242,335),(4243,335),(4244,335),(4245,335),(4246,335),(4247,336),(4248,336),(4249,336),(4250,336),(4251,336),(4252,337),(4253,337),(4254,337),(4255,337),(4256,337),(4257,338),(4258,338),(4259,338),(4260,338),(4261,338),(4262,338),(4263,339),(4264,339),(4265,339),(4266,339),(4267,339),(4268,339),(4269,340),(4270,340),(4271,340),(4272,340),(4273,340),(4274,340),(4275,341),(4276,341),(4277,341),(4278,341),(4279,341),(4280,341),(4281,342),(4282,342),(4283,342),(4284,342),(4285,342),(4286,342),(4287,343),(4288,343),(4289,343),(4290,343),(4291,344),(4292,344),(4293,344),(4294,344),(4295,344),(4296,344),(4297,345),(4298,345),(4299,345),(4300,345),(4301,345),(4302,345),(4303,346),(4304,346),(4305,346),(4306,346),(4307,346),(4308,347),(4309,347),(4310,347),(4311,347),(4312,348),(4313,348),(4314,348),(4315,348),(4316,348),(4317,348),(4318,349),(4319,349),(4320,349),(4321,349),(4322,349),(4323,349),(4324,350),(4325,350),(4326,350),(4327,350),(4328,350),(4329,350),(4330,351),(4331,351),(4332,351),(4333,351),(4334,351),(4335,351),(4336,352),(4337,352),(4338,352),(4339,352),(4340,352),(4341,352),(4342,353),(4343,353),(4344,353),(4345,353),(4346,353),(4347,353),(4348,354),(4349,354),(4350,354),(4351,354),(4352,354),(4353,354),(4354,355),(4355,355),(4356,355),(4357,355),(4358,355),(4359,355),(4360,356),(4361,356),(4362,356),(4363,356),(4364,356),(4365,356),(4366,357),(4367,357),(4368,357),(4369,357),(4370,357),(4371,357),(4372,358),(4373,358),(4374,358),(4375,358),(4376,358),(4377,358),(4378,359),(4379,359),(4380,359),(4381,359),(4382,359),(4383,359),(4384,360),(4385,360),(4386,360),(4387,360),(4388,360),(4389,360),(4390,361),(4391,361),(4392,361),(4393,361),(4394,361),(4395,361),(4396,362),(4397,362),(4398,362),(4399,362),(4400,362),(4401,362),(4402,363),(4403,363),(4404,363),(4405,363),(4406,363),(4407,363),(4408,364),(4409,364),(4410,364),(4411,364),(4412,364),(4413,364),(4414,365),(4415,365),(4416,365),(4417,365),(4418,365),(4419,365),(4420,366),(4421,366),(4422,366),(4423,366),(4424,366),(4425,366),(4426,367),(4427,367),(4428,367),(4429,367),(4430,367),(4431,367),(4432,368),(4433,368),(4434,368),(4435,368),(4436,368),(4437,368),(4438,369),(4439,369),(4440,369),(4441,369),(4442,369),(4443,369),(4444,370),(4445,370),(4446,370),(4447,370),(4448,370),(4449,370),(4450,371),(4451,371),(4452,371),(4453,371),(4454,371),(4455,371),(4456,372),(4457,372),(4458,372),(4459,372),(4460,372),(4461,372),(4462,373),(4463,373),(4464,373),(4465,373),(4466,373),(4467,373),(4468,374),(4469,374),(4470,374),(4471,374),(4472,374),(4473,374),(4474,375),(4475,375),(4476,375),(4477,375),(4478,375),(4479,375),(4480,376),(4481,376),(4482,376),(4483,376),(4484,376),(4485,376),(4486,377),(4487,377),(4488,377),(4489,377),(4490,377),(4491,377),(4492,378),(4493,378),(4494,378),(4495,378),(4496,378),(4497,378),(4498,379),(4499,379),(4500,379),(4501,379),(4502,379),(4503,379),(4504,380),(4505,380),(4506,380),(4507,380),(4508,380),(4509,380),(4510,281),(4511,281),(4512,281),(4513,282),(4514,282),(4515,282),(4516,283),(4517,283),(4518,283),(4519,284),(4520,284),(4521,284),(4522,285),(4523,285),(4524,285),(4525,286),(4526,286),(4527,286),(4528,287),(4529,287),(4530,287),(4531,288),(4532,288),(4533,288),(4534,289),(4535,289),(4536,289),(4537,290),(4538,290),(4539,290),(4540,291),(4541,291),(4542,291),(4543,292),(4544,292),(4545,292),(4546,293),(4547,293),(4548,293),(4549,294),(4550,294),(4551,294),(4552,295),(4553,295),(4554,295),(4555,296),(4556,296),(4557,296),(4558,297),(4559,297),(4560,297),(4561,298),(4562,298),(4563,298),(4564,299),(4565,299),(4566,299),(4567,300),(4568,300),(4569,300),(4570,301),(4571,301),(4572,301),(4573,302),(4574,302),(4575,302),(4576,303),(4577,303),(4578,303),(4579,304),(4580,304),(4581,304),(4582,305),(4583,305),(4584,305),(4585,306),(4586,306),(4587,306),(4588,307),(4589,307),(4590,307),(4591,308),(4592,308),(4593,308),(4594,309),(4595,309),(4596,309),(4597,310),(4598,310),(4599,310),(4600,311),(4601,311),(4602,311),(4603,312),(4604,312),(4605,312),(4606,313),(4607,313),(4608,313),(4609,314),(4610,314),(4611,314),(4612,315),(4613,315),(4614,315),(4615,316),(4616,316),(4617,316),(4618,317),(4619,317),(4620,317),(4621,318),(4622,318),(4623,318),(4624,319),(4625,319),(4626,319),(4627,320),(4628,320),(4629,320),(4630,321),(4631,321),(4632,321),(4633,322),(4634,322),(4635,322),(4636,323),(4637,323),(4638,323),(4639,324),(4640,324),(4641,324),(4642,325),(4643,325),(4644,325),(4645,326),(4646,326),(4647,326),(4648,327),(4649,327),(4650,327),(4651,328),(4652,328),(4653,328),(4654,329),(4655,329),(4656,329),(4657,330),(4658,330),(4659,330),(4660,331),(4661,331),(4662,331),(4663,332),(4664,332),(4665,332),(4666,333),(4667,333),(4668,333),(4669,334),(4670,334),(4671,334),(4672,335),(4673,335),(4674,335),(4675,336),(4676,336),(4677,336),(4678,337),(4679,337),(4680,337),(4681,338),(4682,338),(4683,338),(4684,339),(4685,339),(4686,339),(4687,340),(4688,340),(4689,340),(4690,341),(4691,341),(4692,341),(4693,342),(4694,342),(4695,342),(4696,343),(4697,343),(4698,343),(4699,344),(4700,344),(4701,344),(4702,345),(4703,345),(4704,345),(4705,346),(4706,346),(4707,346),(4708,347),(4709,347),(4710,347),(4711,348),(4712,348),(4713,348),(4714,349),(4715,349),(4716,349),(4717,350),(4718,350),(4719,350),(4720,351),(4721,351),(4722,351),(4723,352),(4724,352),(4725,352),(4726,353),(4727,353),(4728,353),(4729,354),(4730,354),(4731,354),(4732,355),(4733,355),(4734,355),(4735,356),(4736,356),(4737,356),(4738,357),(4739,357),(4740,357),(4741,358),(4742,358),(4743,358),(4744,359),(4745,359),(4746,359),(4747,360),(4748,360),(4749,360),(4750,361),(4751,361),(4752,361),(4753,362),(4754,362),(4755,362),(4756,363),(4757,363),(4758,363),(4759,364),(4760,364),(4761,364),(4762,365),(4763,365),(4764,365),(4765,366),(4766,366),(4767,366),(4768,367),(4769,367),(4770,367),(4771,368),(4772,368),(4773,368),(4774,369),(4775,369),(4776,369),(4777,370),(4778,370),(4779,370),(4780,371),(4781,371),(4782,371),(4783,372),(4784,372),(4785,372),(4786,373),(4787,373),(4788,373),(4789,374),(4790,374),(4791,374),(4792,375),(4793,375),(4794,375),(4795,376),(4796,376),(4797,376),(4798,377),(4799,377),(4800,377),(4801,378),(4802,378),(4803,378),(4804,379),(4805,379),(4806,379),(4807,380),(4808,380),(4809,380),(4810,281),(4811,281),(4812,281),(4813,281),(4814,282),(4815,282),(4816,282),(4817,282),(4818,283),(4819,283),(4820,283),(4821,283),(4822,284),(4823,284),(4824,284),(4825,284),(4826,285),(4827,285),(4828,285),(4829,285),(4830,286),(4831,286),(4832,286),(4833,286),(4834,287),(4835,287),(4836,287),(4837,287),(4838,288),(4839,288),(4840,288),(4841,288),(4842,289),(4843,289),(4844,289),(4845,289),(4846,290),(4847,290),(4848,290),(4849,290),(4850,291),(4851,291),(4852,291),(4853,291),(4854,292),(4855,292),(4856,292),(4857,292),(4858,293),(4859,293),(4860,293),(4861,293),(4862,294),(4863,294),(4864,294),(4865,294),(4866,295),(4867,295),(4868,295),(4869,295),(4870,296),(4871,296),(4872,296),(4873,296),(4874,297),(4875,297),(4876,297),(4877,297),(4878,298),(4879,298),(4880,298),(4881,298),(4882,299),(4883,299),(4884,299),(4885,299),(4886,300),(4887,300),(4888,300),(4889,300),(4890,301),(4891,301),(4892,301),(4893,301),(4894,302),(4895,302),(4896,302),(4897,302),(4898,303),(4899,303),(4900,303),(4901,303),(4902,304),(4903,304),(4904,304),(4905,304),(4906,305),(4907,305),(4908,305),(4909,305),(4910,306),(4911,306),(4912,306),(4913,306),(4914,307),(4915,307),(4916,307),(4917,307),(4918,308),(4919,308),(4920,308),(4921,308),(4922,309),(4923,309),(4924,309),(4925,309),(4926,310),(4927,310),(4928,310),(4929,310),(4930,311),(4931,311),(4932,311),(4933,311),(4934,312),(4935,312),(4936,312),(4937,312),(4938,313),(4939,313),(4940,313),(4941,313),(4942,314),(4943,314),(4944,314),(4945,314),(4946,315),(4947,315),(4948,315),(4949,315),(4950,316),(4951,316),(4952,316),(4953,316),(4954,317),(4955,317),(4956,317),(4957,317),(4958,318),(4959,318),(4960,318),(4961,318),(4962,319),(4963,319),(4964,319),(4965,319),(4966,320),(4967,320),(4968,320),(4969,320),(4970,321),(4971,321),(4972,321),(4973,321),(4974,322),(4975,322),(4976,322),(4977,322),(4978,323),(4979,323),(4980,323),(4981,323),(4982,324),(4983,324),(4984,324),(4985,324),(4986,325),(4987,325),(4988,325),(4989,325),(4990,326),(4991,326),(4992,326),(4993,326),(4994,327),(4995,327),(4996,327),(4997,327),(4998,328),(4999,328),(5000,328),(5001,328),(5002,329),(5003,329),(5004,329),(5005,329),(5006,330),(5007,330),(5008,330),(5009,330),(5010,331),(5011,331),(5012,331),(5013,331),(5014,332),(5015,332),(5016,332),(5017,332),(5018,333),(5019,333),(5020,333),(5021,333),(5022,334),(5023,334),(5024,334),(5025,334),(5026,335),(5027,335),(5028,335),(5029,335),(5030,336),(5031,336),(5032,336),(5033,336),(5034,337),(5035,337),(5036,337),(5037,337),(5038,338),(5039,338),(5040,338),(5041,338),(5042,339),(5043,339),(5044,339),(5045,339),(5046,340),(5047,340),(5048,340),(5049,340),(5050,341),(5051,341),(5052,341),(5053,341),(5054,342),(5055,342),(5056,342),(5057,342),(5058,343),(5059,343),(5060,343),(5061,343),(5062,344),(5063,344),(5064,344),(5065,344),(5066,345),(5067,345),(5068,345),(5069,345),(5070,346),(5071,346),(5072,346),(5073,346),(5074,347),(5075,347),(5076,347),(5077,347),(5078,348),(5079,348),(5080,348),(5081,348),(5082,349),(5083,349),(5084,349),(5085,349),(5086,350),(5087,350),(5088,350),(5089,350),(5090,351),(5091,351),(5092,351),(5093,351),(5094,352),(5095,352),(5096,352),(5097,352),(5098,353),(5099,353),(5100,353),(5101,353),(5102,354),(5103,354),(5104,354),(5105,354),(5106,355),(5107,355),(5108,355),(5109,355),(5110,356),(5111,356),(5112,356),(5113,356),(5114,357),(5115,357),(5116,357),(5117,357),(5118,358),(5119,358),(5120,358),(5121,358),(5122,359),(5123,359),(5124,359),(5125,359),(5126,360),(5127,360),(5128,360),(5129,360),(5130,361),(5131,361),(5132,361),(5133,361),(5134,362),(5135,362),(5136,362),(5137,362),(5138,363),(5139,363),(5140,363),(5141,363),(5142,364),(5143,364),(5144,364),(5145,364),(5146,365),(5147,365),(5148,365),(5149,365),(5150,366),(5151,366),(5152,366),(5153,366),(5154,367),(5155,367),(5156,367),(5157,367),(5158,368),(5159,368),(5160,368),(5161,368),(5162,369),(5163,369),(5164,369),(5165,369),(5166,370),(5167,370),(5168,370),(5169,370),(5170,371),(5171,371),(5172,371),(5173,371),(5174,372),(5175,372),(5176,372),(5177,372),(5178,373),(5179,373),(5180,373),(5181,373),(5182,374),(5183,374),(5184,374),(5185,374),(5186,375),(5187,375),(5188,375),(5189,375),(5190,376),(5191,376),(5192,376),(5193,376),(5194,377),(5195,377),(5196,377),(5197,377),(5198,378),(5199,378),(5200,378),(5201,378),(5202,379),(5203,379),(5204,379),(5205,379),(5206,380),(5207,380),(5208,380),(5209,380),(5210,381),(5211,381),(5212,381),(5213,381),(5214,381),(5215,381),(5216,382),(5217,382),(5218,382),(5219,382),(5220,382),(5221,382),(5222,383),(5223,383),(5224,383),(5225,383),(5226,383),(5227,383),(5228,384),(5229,384),(5230,384),(5231,384),(5232,384),(5233,384),(5234,385),(5235,385),(5236,385),(5237,385),(5238,385),(5239,385),(5240,386),(5241,386),(5242,386),(5243,386),(5244,386),(5245,386),(5246,387),(5247,387),(5248,387),(5249,387),(5250,387),(5251,387),(5252,388),(5253,388),(5254,388),(5255,388),(5256,388),(5257,388),(5258,389),(5259,389),(5260,389),(5261,389),(5262,389),(5263,389),(5264,390),(5265,390),(5266,390),(5267,390),(5268,390),(5269,390),(5270,391),(5271,391),(5272,391),(5273,391),(5274,391),(5275,391),(5276,392),(5277,392),(5278,392),(5279,392),(5280,392),(5281,392),(5282,393),(5283,393),(5284,393),(5285,393),(5286,393),(5287,393),(5288,394),(5289,394),(5290,394),(5291,394),(5292,394),(5293,394),(5294,395),(5295,395),(5296,395),(5297,395),(5298,395),(5299,395),(5300,396),(5301,396),(5302,396),(5303,396),(5304,396),(5305,396),(5306,397),(5307,397),(5308,397),(5309,397),(5310,397),(5311,397),(5312,398),(5313,398),(5314,398),(5315,398),(5316,398),(5317,398),(5318,399),(5319,399),(5320,399),(5321,399),(5322,399),(5323,399),(5324,400),(5325,400),(5326,400),(5327,400),(5328,400),(5329,400),(5330,401),(5331,401),(5332,401),(5333,401),(5334,401),(5335,401),(5336,402),(5337,402),(5338,402),(5339,402),(5340,402),(5341,402),(5342,403),(5343,403),(5344,403),(5345,403),(5346,403),(5347,403),(5348,404),(5349,404),(5350,404),(5351,404),(5352,404),(5353,404),(5354,405),(5355,405),(5356,405),(5357,405),(5358,405),(5359,405),(5360,406),(5361,406),(5362,406),(5363,406),(5364,406),(5365,406),(5366,407),(5367,407),(5368,407),(5369,407),(5370,407),(5371,407),(5372,408),(5373,408),(5374,408),(5375,408),(5376,408),(5377,408),(5378,409),(5379,409),(5380,409),(5381,409),(5382,409),(5383,409),(5384,410),(5385,410),(5386,410),(5387,410),(5388,410),(5389,410),(5390,411),(5391,411),(5392,411),(5393,411),(5394,411),(5395,411),(5396,412),(5397,412),(5398,412),(5399,412),(5400,412),(5401,412),(5402,413),(5403,413),(5404,413),(5405,413),(5406,413),(5407,413),(5408,414),(5409,414),(5410,414),(5411,414),(5412,414),(5413,414),(5414,415),(5415,415),(5416,415),(5417,415),(5418,415),(5419,415),(5420,416),(5421,416),(5422,416),(5423,416),(5424,416),(5425,416),(5426,417),(5427,417),(5428,417),(5429,417),(5430,417),(5431,417),(5432,418),(5433,418),(5434,418),(5435,418),(5436,418),(5437,418),(5438,419),(5439,419),(5440,419),(5441,419),(5442,419),(5443,419),(5444,420),(5445,420),(5446,420),(5447,420),(5448,420),(5449,420),(5450,421),(5451,421),(5452,421),(5453,421),(5454,421),(5455,421),(5456,422),(5457,422),(5458,422),(5459,422),(5460,422),(5461,422),(5462,423),(5463,423),(5464,423),(5465,423),(5466,423),(5467,423),(5468,424),(5469,424),(5470,424),(5471,424),(5472,424),(5473,424),(5474,425),(5475,425),(5476,425),(5477,425),(5478,425),(5479,425),(5480,426),(5481,426),(5482,426),(5483,426),(5484,426),(5485,426),(5486,427),(5487,427),(5488,427),(5489,427),(5490,427),(5491,427),(5492,428),(5493,428),(5494,428),(5495,428),(5496,428),(5497,428),(5498,429),(5499,429),(5500,429),(5501,429),(5502,429),(5503,429),(5504,430),(5505,430),(5506,430),(5507,430),(5508,430),(5509,430),(5510,431),(5511,431),(5512,431),(5513,431),(5514,431),(5515,431),(5516,432),(5517,432),(5518,432),(5519,432),(5520,432),(5521,432),(5522,433),(5523,433),(5524,433),(5525,433),(5526,433),(5527,433),(5528,434),(5529,434),(5530,434),(5531,434),(5532,434),(5533,434),(5534,435),(5535,435),(5536,435),(5537,435),(5538,435),(5539,435),(5540,436),(5541,436),(5542,436),(5543,436),(5544,436),(5545,436),(5546,437),(5547,437),(5548,437),(5549,437),(5550,437),(5551,437),(5552,438),(5553,438),(5554,438),(5555,438),(5556,438),(5557,438),(5558,439),(5559,439),(5560,439),(5561,439),(5562,439),(5563,439),(5564,440),(5565,440),(5566,440),(5567,440),(5568,440),(5569,440),(5570,441),(5571,441),(5572,441),(5573,441),(5574,441),(5575,441),(5576,442),(5577,442),(5578,442),(5579,442),(5580,442),(5581,442),(5582,443),(5583,443),(5584,443),(5585,443),(5586,443),(5587,443),(5588,444),(5589,444),(5590,444),(5591,444),(5592,444),(5593,444),(5594,445),(5595,445),(5596,445),(5597,445),(5598,445),(5599,445),(5600,446),(5601,446),(5602,446),(5603,446),(5604,446),(5605,446),(5606,447),(5607,447),(5608,447),(5609,447),(5610,447),(5611,447),(5612,448),(5613,448),(5614,448),(5615,448),(5616,448),(5617,448),(5618,449),(5619,449),(5620,449),(5621,449),(5622,449),(5623,449),(5624,450),(5625,450),(5626,450),(5627,450),(5628,450),(5629,450),(5630,451),(5631,451),(5632,451),(5633,451),(5634,451),(5635,451),(5636,452),(5637,452),(5638,452),(5639,452),(5640,452),(5641,452),(5642,453),(5643,453),(5644,453),(5645,453),(5646,453),(5647,453),(5648,454),(5649,454),(5650,454),(5651,454),(5652,454),(5653,454),(5654,455),(5655,455),(5656,455),(5657,455),(5658,455),(5659,455),(5660,456),(5661,456),(5662,456),(5663,456),(5664,456),(5665,456),(5666,457),(5667,457),(5668,457),(5669,457),(5670,457),(5671,457),(5672,458),(5673,458),(5674,458),(5675,458),(5676,458),(5677,458),(5678,459),(5679,459),(5680,459),(5681,459),(5682,459),(5683,459),(5684,460),(5685,460),(5686,460),(5687,460),(5688,460),(5689,460),(5690,461),(5691,461),(5692,461),(5693,461),(5694,461),(5695,461),(5696,462),(5697,462),(5698,462),(5699,462),(5700,462),(5701,462),(5702,463),(5703,463),(5704,463),(5705,463),(5706,463),(5707,463),(5708,464),(5709,464),(5710,464),(5711,464),(5712,464),(5713,464),(5714,465),(5715,465),(5716,465),(5717,465),(5718,465),(5719,465),(5720,466),(5721,466),(5722,466),(5723,466),(5724,466),(5725,466),(5726,467),(5727,467),(5728,467),(5729,467),(5730,467),(5731,467),(5732,468),(5733,468),(5734,468),(5735,468),(5736,468),(5737,468),(5738,469),(5739,469),(5740,469),(5741,469),(5742,469),(5743,469),(5744,470),(5745,470),(5746,470),(5747,470),(5748,470),(5749,470),(5750,471),(5751,471),(5752,471),(5753,471),(5754,471),(5755,471),(5756,472),(5757,472),(5758,472),(5759,472),(5760,472),(5761,472),(5762,473),(5763,473),(5764,473),(5765,473),(5766,473),(5767,473),(5768,474),(5769,474),(5770,474),(5771,474),(5772,474),(5773,474),(5774,475),(5775,475),(5776,475),(5777,475),(5778,475),(5779,475),(5780,476),(5781,476),(5782,476),(5783,476),(5784,476),(5785,476),(5786,477),(5787,477),(5788,477),(5789,477),(5790,477),(5791,477),(5792,478),(5793,478),(5794,478),(5795,478),(5796,478),(5797,478),(5798,479),(5799,479),(5800,479),(5801,479),(5802,479),(5803,479),(5804,480),(5805,480),(5806,480),(5807,480),(5808,480),(5809,480),(5810,381),(5811,381),(5812,381),(5813,382),(5814,382),(5815,382),(5816,383),(5817,383),(5818,383),(5819,384),(5820,384),(5821,384),(5822,385),(5823,385),(5824,385),(5825,386),(5826,386),(5827,386),(5828,387),(5829,387),(5830,387),(5831,388),(5832,388),(5833,388),(5834,389),(5835,389),(5836,389),(5837,390),(5838,390),(5839,390),(5840,391),(5841,391),(5842,391),(5843,392),(5844,392),(5845,392),(5846,393),(5847,393),(5848,393),(5849,394),(5850,394),(5851,394),(5852,395),(5853,395),(5854,395),(5855,396),(5856,396),(5857,396),(5858,397),(5859,397),(5860,397),(5861,398),(5862,398),(5863,398),(5864,399),(5865,399),(5866,399),(5867,400),(5868,400),(5869,400),(5870,401),(5871,401),(5872,401),(5873,402),(5874,402),(5875,402),(5876,403),(5877,403),(5878,403),(5879,404),(5880,404),(5881,404),(5882,405),(5883,405),(5884,405),(5885,406),(5886,406),(5887,406),(5888,407),(5889,407),(5890,407),(5891,408),(5892,408),(5893,408),(5894,409),(5895,409),(5896,409),(5897,410),(5898,410),(5899,410),(5900,411),(5901,411),(5902,411),(5903,412),(5904,412),(5905,412),(5906,413),(5907,413),(5908,413),(5909,414),(5910,414),(5911,414),(5912,415),(5913,415),(5914,415),(5915,416),(5916,416),(5917,416),(5918,417),(5919,417),(5920,417),(5921,418),(5922,418),(5923,418),(5924,419),(5925,419),(5926,419),(5927,420),(5928,420),(5929,420),(5930,421),(5931,421),(5932,421),(5933,422),(5934,422),(5935,422),(5936,423),(5937,423),(5938,423),(5939,424),(5940,424),(5941,424),(5942,425),(5943,425),(5944,425),(5945,426),(5946,426),(5947,426),(5948,427),(5949,427),(5950,427),(5951,428),(5952,428),(5953,428),(5954,429),(5955,429),(5956,429),(5957,430),(5958,430),(5959,430),(5960,431),(5961,431),(5962,431),(5963,432),(5964,432),(5965,432),(5966,433),(5967,433),(5968,433),(5969,434),(5970,434),(5971,434),(5972,435),(5973,435),(5974,435),(5975,436),(5976,436),(5977,436),(5978,437),(5979,437),(5980,437),(5981,438),(5982,438),(5983,438),(5984,439),(5985,439),(5986,439),(5987,440),(5988,440),(5989,440),(5990,441),(5991,441),(5992,441),(5993,442),(5994,442),(5995,442),(5996,443),(5997,443),(5998,443),(5999,444),(6000,444),(6001,444),(6002,445),(6003,445),(6004,445),(6005,446),(6006,446),(6007,446),(6008,447),(6009,447),(6010,447),(6011,448),(6012,448),(6013,448),(6014,449),(6015,449),(6016,449),(6017,450),(6018,450),(6019,450),(6020,451),(6021,451),(6022,451),(6023,452),(6024,452),(6025,452),(6026,453),(6027,453),(6028,453),(6029,454),(6030,454),(6031,454),(6032,455),(6033,455),(6034,455),(6035,456),(6036,456),(6037,456),(6038,457),(6039,457),(6040,457),(6041,458),(6042,458),(6043,458),(6044,459),(6045,459),(6046,459),(6047,460),(6048,460),(6049,460),(6050,461),(6051,461),(6052,461),(6053,462),(6054,462),(6055,462),(6056,463),(6057,463),(6058,463),(6059,464),(6060,464),(6061,464),(6062,465),(6063,465),(6064,465),(6065,466),(6066,466),(6067,466),(6068,467),(6069,467),(6070,467),(6071,468),(6072,468),(6073,468),(6074,469),(6075,469),(6076,469),(6077,470),(6078,470),(6079,470),(6080,471),(6081,471),(6082,471),(6083,472),(6084,472),(6085,472),(6086,473),(6087,473),(6088,473),(6089,474),(6090,474),(6091,474),(6092,475),(6093,475),(6094,475),(6095,476),(6096,476),(6097,476),(6098,477),(6099,477),(6100,477),(6101,478),(6102,478),(6103,478),(6104,479),(6105,479),(6106,479),(6107,480),(6108,480),(6109,480),(6110,381),(6111,381),(6112,381),(6113,381),(6114,382),(6115,382),(6116,382),(6117,382),(6118,383),(6119,383),(6120,383),(6121,383),(6122,384),(6123,384),(6124,384),(6125,384),(6126,385),(6127,385),(6128,385),(6129,385),(6130,386),(6131,386),(6132,386),(6133,386),(6134,387),(6135,387),(6136,387),(6137,387),(6138,388),(6139,388),(6140,388),(6141,388),(6142,389),(6143,389),(6144,389),(6145,389),(6146,390),(6147,390),(6148,390),(6149,390),(6150,391),(6151,391),(6152,391),(6153,391),(6154,392),(6155,392),(6156,392),(6157,392),(6158,393),(6159,393),(6160,393),(6161,393),(6162,394),(6163,394),(6164,394),(6165,394),(6166,395),(6167,395),(6168,395),(6169,395),(6170,396),(6171,396),(6172,396),(6173,396),(6174,397),(6175,397),(6176,397),(6177,397),(6178,398),(6179,398),(6180,398),(6181,398),(6182,399),(6183,399),(6184,399),(6185,399),(6186,400),(6187,400),(6188,400),(6189,400),(6190,401),(6191,401),(6192,401),(6193,401),(6194,402),(6195,402),(6196,402),(6197,402),(6198,403),(6199,403),(6200,403),(6201,403),(6202,404),(6203,404),(6204,404),(6205,404),(6206,405),(6207,405),(6208,405),(6209,405),(6210,406),(6211,406),(6212,406),(6213,406),(6214,407),(6215,407),(6216,407),(6217,407),(6218,408),(6219,408),(6220,408),(6221,408),(6222,409),(6223,409),(6224,409),(6225,409),(6226,410),(6227,410),(6228,410),(6229,410),(6230,411),(6231,411),(6232,411),(6233,411),(6234,412),(6235,412),(6236,412),(6237,412),(6238,413),(6239,413),(6240,413),(6241,413),(6242,414),(6243,414),(6244,414),(6245,414),(6246,415),(6247,415),(6248,415),(6249,415),(6250,416),(6251,416),(6252,416),(6253,416),(6254,417),(6255,417),(6256,417),(6257,417),(6258,418),(6259,418),(6260,418),(6261,418),(6262,419),(6263,419),(6264,419),(6265,419),(6266,420),(6267,420),(6268,420),(6269,420),(6270,421),(6271,421),(6272,421),(6273,421),(6274,422),(6275,422),(6276,422),(6277,422),(6278,423),(6279,423),(6280,423),(6281,423),(6282,424),(6283,424),(6284,424),(6285,424),(6286,425),(6287,425),(6288,425),(6289,425),(6290,426),(6291,426),(6292,426),(6293,426),(6294,427),(6295,427),(6296,427),(6297,427),(6298,428),(6299,428),(6300,428),(6301,428),(6302,429),(6303,429),(6304,429),(6305,429),(6306,430),(6307,430),(6308,430),(6309,430),(6310,431),(6311,431),(6312,431),(6313,431),(6314,432),(6315,432),(6316,432),(6317,432),(6318,433),(6319,433),(6320,433),(6321,433),(6322,434),(6323,434),(6324,434),(6325,434),(6326,435),(6327,435),(6328,435),(6329,435),(6330,436),(6331,436),(6332,436),(6333,436),(6334,437),(6335,437),(6336,437),(6337,437),(6338,438),(6339,438),(6340,438),(6341,438),(6342,439),(6343,439),(6344,439),(6345,439),(6346,440),(6347,440),(6348,440),(6349,440),(6350,441),(6351,441),(6352,441),(6353,441),(6354,442),(6355,442),(6356,442),(6357,442),(6358,443),(6359,443),(6360,443),(6361,443),(6362,444),(6363,444),(6364,444),(6365,444),(6366,445),(6367,445),(6368,445),(6369,445),(6370,446),(6371,446),(6372,446),(6373,446),(6374,447),(6375,447),(6376,447),(6377,447),(6378,448),(6379,448),(6380,448),(6381,448),(6382,449),(6383,449),(6384,449),(6385,449),(6386,450),(6387,450),(6388,450),(6389,450),(6390,451),(6391,451),(6392,451),(6393,451),(6394,452),(6395,452),(6396,452),(6397,452),(6398,453),(6399,453),(6400,453),(6401,453),(6402,454),(6403,454),(6404,454),(6405,454),(6406,455),(6407,455),(6408,455),(6409,455),(6410,456),(6411,456),(6412,456),(6413,456),(6414,457),(6415,457),(6416,457),(6417,457),(6418,458),(6419,458),(6420,458),(6421,458),(6422,459),(6423,459),(6424,459),(6425,459),(6426,460),(6427,460),(6428,460),(6429,460),(6430,461),(6431,461),(6432,461),(6433,461),(6434,462),(6435,462),(6436,462),(6437,462),(6438,463),(6439,463),(6440,463),(6441,463),(6442,464),(6443,464),(6444,464),(6445,464),(6446,465),(6447,465),(6448,465),(6449,465),(6450,466),(6451,466),(6452,466),(6453,466),(6454,467),(6455,467),(6456,467),(6457,467),(6458,468),(6459,468),(6460,468),(6461,468),(6462,469),(6463,469),(6464,469),(6465,469),(6466,470),(6467,470),(6468,470),(6469,470),(6470,471),(6471,471),(6472,471),(6473,471),(6474,472),(6475,472),(6476,472),(6477,472),(6478,473),(6479,473),(6480,473),(6481,473),(6482,474),(6483,474),(6484,474),(6485,474),(6486,475),(6487,475),(6488,475),(6489,475),(6490,476),(6491,476),(6492,476),(6493,476),(6494,477),(6495,477),(6496,477),(6497,477),(6498,478),(6499,478),(6500,478),(6501,478),(6502,479),(6503,479),(6504,479),(6505,479),(6506,480),(6507,480),(6508,480),(6509,480),(6510,481),(6511,481),(6512,481),(6513,481),(6514,481),(6515,481),(6516,482),(6517,482),(6518,482),(6519,482),(6520,482),(6521,482),(6522,483),(6523,483),(6524,483),(6525,483),(6526,483),(6527,483),(6528,484),(6529,484),(6530,484),(6531,484),(6532,484),(6533,484),(6534,485),(6535,485),(6536,485),(6537,485),(6538,485),(6539,485),(6540,486),(6541,486),(6542,486),(6543,486),(6544,486),(6545,486),(6546,487),(6547,487),(6548,487),(6549,487),(6550,487),(6551,487),(6552,488),(6553,488),(6554,488),(6555,488),(6556,488),(6557,488),(6558,489),(6559,489),(6560,489),(6561,489),(6562,489),(6563,489),(6564,490),(6565,490),(6566,490),(6567,490),(6568,490),(6569,490),(6570,491),(6571,491),(6572,491),(6573,491),(6574,491),(6575,491),(6576,492),(6577,492),(6578,492),(6579,492),(6580,492),(6581,492),(6582,493),(6583,493),(6584,493),(6585,493),(6586,493),(6587,493),(6588,494),(6589,494),(6590,494),(6591,494),(6592,494),(6593,494),(6594,495),(6595,495),(6596,495),(6597,495),(6598,495),(6599,495),(6600,496),(6601,496),(6602,496),(6603,496),(6604,496),(6605,496),(6606,497),(6607,497),(6608,497),(6609,497),(6610,497),(6611,497),(6612,498),(6613,498),(6614,498),(6615,498),(6616,498),(6617,498),(6618,499),(6619,499),(6620,499),(6621,499),(6622,499),(6623,499),(6624,500),(6625,500),(6626,500),(6627,500),(6628,500),(6629,500),(6630,501),(6631,501),(6632,501),(6633,501),(6634,501),(6635,501),(6636,502),(6637,502),(6638,502),(6639,502),(6640,502),(6641,502),(6642,503),(6643,503),(6644,503),(6645,503),(6646,503),(6647,503),(6648,504),(6649,504),(6650,504),(6651,504),(6652,504),(6653,504),(6654,505),(6655,505),(6656,505),(6657,505),(6658,505),(6659,505),(6660,506),(6661,506),(6662,506),(6663,506),(6664,506),(6665,506),(6666,507),(6667,507),(6668,507),(6669,507),(6670,507),(6671,507),(6672,508),(6673,508),(6674,508),(6675,508),(6676,508),(6677,508),(6678,509),(6679,509),(6680,509),(6681,509),(6682,509),(6683,509),(6684,510),(6685,510),(6686,510),(6687,510),(6688,510),(6689,510),(6690,511),(6691,511),(6692,511),(6693,511),(6694,511),(6695,511),(6696,512),(6697,512),(6698,512),(6699,512),(6700,512),(6701,512),(6702,513),(6703,513),(6704,513),(6705,513),(6706,513),(6707,513),(6708,514),(6709,514),(6710,514),(6711,514),(6712,514),(6713,514),(6714,515),(6715,515),(6716,515),(6717,515),(6718,515),(6719,515),(6720,516),(6721,516),(6722,516),(6723,516),(6724,516),(6725,516),(6726,517),(6727,517),(6728,517),(6729,517),(6730,517),(6731,517),(6732,518),(6733,518),(6734,518),(6735,518),(6736,518),(6737,518),(6738,519),(6739,519),(6740,519),(6741,519),(6742,519),(6743,519),(6744,520),(6745,520),(6746,520),(6747,520),(6748,520),(6749,520),(6750,521),(6751,521),(6752,521),(6753,521),(6754,521),(6755,521),(6756,522),(6757,522),(6758,522),(6759,522),(6760,522),(6761,522),(6762,523),(6763,523),(6764,523),(6765,523),(6766,523),(6767,523),(6768,524),(6769,524),(6770,524),(6771,524),(6772,524),(6773,524),(6774,525),(6775,525),(6776,525),(6777,525),(6778,525),(6779,525),(6780,526),(6781,526),(6782,526),(6783,526),(6784,526),(6785,526),(6786,527),(6787,527),(6788,527),(6789,527),(6790,527),(6791,527),(6792,528),(6793,528),(6794,528),(6795,528),(6796,528),(6797,528),(6798,529),(6799,529),(6800,529),(6801,529),(6802,529),(6803,529),(6804,530),(6805,530),(6806,530),(6807,530),(6808,530),(6809,530),(6810,531),(6811,531),(6812,531),(6813,531),(6814,531),(6815,531),(6816,532),(6817,532),(6818,532),(6819,532),(6820,532),(6821,532),(6822,533),(6823,533),(6824,533),(6825,533),(6826,533),(6827,533),(6828,534),(6829,534),(6830,534),(6831,534),(6832,534),(6833,534),(6834,535),(6835,535),(6836,535),(6837,535),(6838,535),(6839,535),(6840,536),(6841,536),(6842,536),(6843,536),(6844,536),(6845,536),(6846,537),(6847,537),(6848,537),(6849,537),(6850,537),(6851,537),(6852,538),(6853,538),(6854,538),(6855,538),(6856,538),(6857,538),(6858,539),(6859,539),(6860,539),(6861,539),(6862,539),(6863,539),(6864,540),(6865,540),(6866,540),(6867,540),(6868,540),(6869,540),(6870,541),(6871,541),(6872,541),(6873,541),(6874,541),(6875,541),(6876,542),(6877,542),(6878,542),(6879,542),(6880,542),(6881,542),(6882,543),(6883,543),(6884,543),(6885,543),(6886,543),(6887,543),(6888,544),(6889,544),(6890,544),(6891,544),(6892,544),(6893,544),(6894,545),(6895,545),(6896,545),(6897,545),(6898,545),(6899,545),(6900,546),(6901,546),(6902,546),(6903,546),(6904,546),(6905,546),(6906,547),(6907,547),(6908,547),(6909,547),(6910,547),(6911,547),(6912,548),(6913,548),(6914,548),(6915,548),(6916,548),(6917,548),(6918,549),(6919,549),(6920,549),(6921,549),(6922,549),(6923,549),(6924,550),(6925,550),(6926,550),(6927,550),(6928,550),(6929,550),(6930,551),(6931,551),(6932,551),(6933,551),(6934,551),(6935,551),(6936,552),(6937,552),(6938,552),(6939,552),(6940,552),(6941,552),(6942,553),(6943,553),(6944,553),(6945,553),(6946,553),(6947,553),(6948,554),(6949,554),(6950,554),(6951,554),(6952,554),(6953,554),(6954,555),(6955,555),(6956,555),(6957,555),(6958,555),(6959,555),(6960,556),(6961,556),(6962,556),(6963,556),(6964,556),(6965,556),(6966,557),(6967,557),(6968,557),(6969,557),(6970,557),(6971,557),(6972,558),(6973,558),(6974,558),(6975,558),(6976,558),(6977,558),(6978,559),(6979,559),(6980,559),(6981,559),(6982,559),(6983,559),(6984,560),(6985,560),(6986,560),(6987,560),(6988,560),(6989,560),(6990,561),(6991,561),(6992,561),(6993,561),(6994,561),(6995,561),(6996,562),(6997,562),(6998,562),(6999,562),(7000,562),(7001,562),(7002,563),(7003,563),(7004,563),(7005,563),(7006,563),(7007,563),(7008,564),(7009,564),(7010,564),(7011,564),(7012,564),(7013,564),(7014,565),(7015,565),(7016,565),(7017,565),(7018,565),(7019,565),(7020,566),(7021,566),(7022,566),(7023,566),(7024,566),(7025,566),(7026,567),(7027,567),(7028,567),(7029,567),(7030,567),(7031,567),(7032,568),(7033,568),(7034,568),(7035,568),(7036,568),(7037,568),(7038,569),(7039,569),(7040,569),(7041,569),(7042,569),(7043,569),(7044,570),(7045,570),(7046,570),(7047,570),(7048,570),(7049,570),(7050,571),(7051,571),(7052,571),(7053,571),(7054,571),(7055,571),(7056,572),(7057,572),(7058,572),(7059,572),(7060,572),(7061,572),(7062,573),(7063,573),(7064,573),(7065,573),(7066,573),(7067,573),(7068,574),(7069,574),(7070,574),(7071,574),(7072,574),(7073,574),(7074,575),(7075,575),(7076,575),(7077,575),(7078,575),(7079,575),(7080,576),(7081,576),(7082,576),(7083,576),(7084,576),(7085,576),(7086,577),(7087,577),(7088,577),(7089,577),(7090,577),(7091,577),(7092,578),(7093,578),(7094,578),(7095,578),(7096,578),(7097,578),(7098,579),(7099,579),(7100,579),(7101,579),(7102,579),(7103,579),(7104,580),(7105,580),(7106,580),(7107,580),(7108,580),(7109,580),(7110,481),(7111,481),(7112,481),(7113,482),(7114,482),(7115,482),(7116,483),(7117,483),(7118,483),(7119,484),(7120,484),(7121,484),(7122,485),(7123,485),(7124,485),(7125,486),(7126,486),(7127,486),(7128,487),(7129,487),(7130,487),(7131,488),(7132,488),(7133,488),(7134,489),(7135,489),(7136,489),(7137,490),(7138,490),(7139,490),(7140,491),(7141,491),(7142,491),(7143,492),(7144,492),(7145,492),(7146,493),(7147,493),(7148,493),(7149,494),(7150,494),(7151,494),(7152,495),(7153,495),(7154,495),(7155,496),(7156,496),(7157,496),(7158,497),(7159,497),(7160,497),(7161,498),(7162,498),(7163,498),(7164,499),(7165,499),(7166,499),(7167,500),(7168,500),(7169,500),(7170,501),(7171,501),(7172,501),(7173,502),(7174,502),(7175,502),(7176,503),(7177,503),(7178,503),(7179,504),(7180,504),(7181,504),(7182,505),(7183,505),(7184,505),(7185,506),(7186,506),(7187,506),(7188,507),(7189,507),(7190,507),(7191,508),(7192,508),(7193,508),(7194,509),(7195,509),(7196,509),(7197,510),(7198,510),(7199,510),(7200,511),(7201,511),(7202,511),(7203,512),(7204,512),(7205,512),(7206,513),(7207,513),(7208,513),(7209,514),(7210,514),(7211,514),(7212,515),(7213,515),(7214,515),(7215,516),(7216,516),(7217,516),(7218,517),(7219,517),(7220,517),(7221,518),(7222,518),(7223,518),(7224,519),(7225,519),(7226,519),(7227,520),(7228,520),(7229,520),(7230,521),(7231,521),(7232,521),(7233,522),(7234,522),(7235,522),(7236,523),(7237,523),(7238,523),(7239,524),(7240,524),(7241,524),(7242,525),(7243,525),(7244,525),(7245,526),(7246,526),(7247,526),(7248,527),(7249,527),(7250,527),(7251,528),(7252,528),(7253,528),(7254,529),(7255,529),(7256,529),(7257,530),(7258,530),(7259,530),(7260,531),(7261,531),(7262,531),(7263,532),(7264,532),(7265,532),(7266,533),(7267,533),(7268,533),(7269,534),(7270,534),(7271,534),(7272,535),(7273,535),(7274,535),(7275,536),(7276,536),(7277,536),(7278,537),(7279,537),(7280,537),(7281,538),(7282,538),(7283,538),(7284,539),(7285,539),(7286,539),(7287,540),(7288,540),(7289,540),(7290,541),(7291,541),(7292,541),(7293,542),(7294,542),(7295,542),(7296,543),(7297,543),(7298,543),(7299,544),(7300,544),(7301,544),(7302,545),(7303,545),(7304,545),(7305,546),(7306,546),(7307,546),(7308,547),(7309,547),(7310,547),(7311,548),(7312,548),(7313,548),(7314,549),(7315,549),(7316,549),(7317,550),(7318,550),(7319,550),(7320,551),(7321,551),(7322,551),(7323,552),(7324,552),(7325,552),(7326,553),(7327,553),(7328,553),(7329,554),(7330,554),(7331,554),(7332,555),(7333,555),(7334,555),(7335,556),(7336,556),(7337,556),(7338,557),(7339,557),(7340,557),(7341,558),(7342,558),(7343,558),(7344,559),(7345,559),(7346,559),(7347,560),(7348,560),(7349,560),(7350,561),(7351,561),(7352,561),(7353,562),(7354,562),(7355,562),(7356,563),(7357,563),(7358,563),(7359,564),(7360,564),(7361,564),(7362,565),(7363,565),(7364,565),(7365,566),(7366,566),(7367,566),(7368,567),(7369,567),(7370,567),(7371,568),(7372,568),(7373,568),(7374,569),(7375,569),(7376,569),(7377,570),(7378,570),(7379,570),(7380,571),(7381,571),(7382,571),(7383,572),(7384,572),(7385,572),(7386,573),(7387,573),(7388,573),(7389,574),(7390,574),(7391,574),(7392,575),(7393,575),(7394,575),(7395,576),(7396,576),(7397,576),(7398,577),(7399,577),(7400,577),(7401,578),(7402,578),(7403,578),(7404,579),(7405,579),(7406,579),(7407,580),(7408,580),(7409,580),(7410,481),(7411,481),(7412,481),(7413,481),(7414,482),(7415,482),(7416,482),(7417,482),(7418,483),(7419,483),(7420,483),(7421,483),(7422,484),(7423,484),(7424,484),(7425,484),(7426,485),(7427,485),(7428,485),(7429,485),(7430,486),(7431,486),(7432,486),(7433,486),(7434,487),(7435,487),(7436,487),(7437,487),(7438,488),(7439,488),(7440,488),(7441,488),(7442,489),(7443,489),(7444,489),(7445,489),(7446,490),(7447,490),(7448,490),(7449,490),(7450,491),(7451,491),(7452,491),(7453,491),(7454,492),(7455,492),(7456,492),(7457,492),(7458,493),(7459,493),(7460,493),(7461,493),(7462,494),(7463,494),(7464,494),(7465,494),(7466,495),(7467,495),(7468,495),(7469,495),(7470,496),(7471,496),(7472,496),(7473,496),(7474,497),(7475,497),(7476,497),(7477,497),(7478,498),(7479,498),(7480,498),(7481,498),(7482,499),(7483,499),(7484,499),(7485,499),(7486,500),(7487,500),(7488,500),(7489,500),(7490,501),(7491,501),(7492,501),(7493,501),(7494,502),(7495,502),(7496,502),(7497,502),(7498,503),(7499,503),(7500,503),(7501,503),(7502,504),(7503,504),(7504,504),(7505,504),(7506,505),(7507,505),(7508,505),(7509,505),(7510,506),(7511,506),(7512,506),(7513,506),(7514,507),(7515,507),(7516,507),(7517,507),(7518,508),(7519,508),(7520,508),(7521,508),(7522,509),(7523,509),(7524,509),(7525,509),(7526,510),(7527,510),(7528,510),(7529,510),(7530,511),(7531,511),(7532,511),(7533,511),(7534,512),(7535,512),(7536,512),(7537,512),(7538,513),(7539,513),(7540,513),(7541,513),(7542,514),(7543,514),(7544,514),(7545,514),(7546,515),(7547,515),(7548,515),(7549,515),(7550,516),(7551,516),(7552,516),(7553,516),(7554,517),(7555,517),(7556,517),(7557,517),(7558,518),(7559,518),(7560,518),(7561,518),(7562,519),(7563,519),(7564,519),(7565,519),(7566,520),(7567,520),(7568,520),(7569,520),(7570,521),(7571,521),(7572,521),(7573,521),(7574,522),(7575,522),(7576,522),(7577,522),(7578,523),(7579,523),(7580,523),(7581,523),(7582,524),(7583,524),(7584,524),(7585,524),(7586,525),(7587,525),(7588,525),(7589,525),(7590,526),(7591,526),(7592,526),(7593,526),(7594,527),(7595,527),(7596,527),(7597,527),(7598,528),(7599,528),(7600,528),(7601,528),(7602,529),(7603,529),(7604,529),(7605,529),(7606,530),(7607,530),(7608,530),(7609,530),(7610,531),(7611,531),(7612,531),(7613,531),(7614,532),(7615,532),(7616,532),(7617,532),(7618,533),(7619,533),(7620,533),(7621,533),(7622,534),(7623,534),(7624,534),(7625,534),(7626,535),(7627,535),(7628,535),(7629,535),(7630,536),(7631,536),(7632,536),(7633,536),(7634,537),(7635,537),(7636,537),(7637,537),(7638,538),(7639,538),(7640,538),(7641,538),(7642,539),(7643,539),(7644,539),(7645,539),(7646,540),(7647,540),(7648,540),(7649,540),(7650,541),(7651,541),(7652,541),(7653,541),(7654,542),(7655,542),(7656,542),(7657,542),(7658,543),(7659,543),(7660,543),(7661,543),(7662,544),(7663,544),(7664,544),(7665,544),(7666,545),(7667,545),(7668,545),(7669,545),(7670,546),(7671,546),(7672,546),(7673,546),(7674,547),(7675,547),(7676,547),(7677,547),(7678,548),(7679,548),(7680,548),(7681,548),(7682,549),(7683,549),(7684,549),(7685,549),(7686,550),(7687,550),(7688,550),(7689,550),(7690,551),(7691,551),(7692,551),(7693,551),(7694,552),(7695,552),(7696,552),(7697,552),(7698,553),(7699,553),(7700,553),(7701,553),(7702,554),(7703,554),(7704,554),(7705,554),(7706,555),(7707,555),(7708,555),(7709,555),(7710,556),(7711,556),(7712,556),(7713,556),(7714,557),(7715,557),(7716,557),(7717,557),(7718,558),(7719,558),(7720,558),(7721,558),(7722,559),(7723,559),(7724,559),(7725,559),(7726,560),(7727,560),(7728,560),(7729,560),(7730,561),(7731,561),(7732,561),(7733,561),(7734,562),(7735,562),(7736,562),(7737,562),(7738,563),(7739,563),(7740,563),(7741,563),(7742,564),(7743,564),(7744,564),(7745,564),(7746,565),(7747,565),(7748,565),(7749,565),(7750,566),(7751,566),(7752,566),(7753,566),(7754,567),(7755,567),(7756,567),(7757,567),(7758,568),(7759,568),(7760,568),(7761,568),(7762,569),(7763,569),(7764,569),(7765,569),(7766,570),(7767,570),(7768,570),(7769,570),(7770,571),(7771,571),(7772,571),(7773,571),(7774,572),(7775,572),(7776,572),(7777,572),(7778,573),(7779,573),(7780,573),(7781,573),(7782,574),(7783,574),(7784,574),(7785,574),(7786,575),(7787,575),(7788,575),(7789,575),(7790,576),(7791,576),(7792,576),(7793,576),(7794,577),(7795,577),(7796,577),(7797,577),(7798,578),(7799,578),(7800,578),(7801,578),(7802,579),(7803,579),(7804,579),(7805,579),(7806,580),(7807,580),(7808,580),(7809,580),(7810,581),(7811,581),(7812,581),(7813,581),(7814,581),(7815,581),(7816,582),(7817,582),(7818,582),(7819,582),(7820,582),(7821,582),(7822,583),(7823,583),(7824,583),(7825,583),(7826,583),(7827,583),(7828,584),(7829,584),(7830,584),(7831,584),(7832,584),(7833,584),(7834,585),(7835,585),(7836,585),(7837,585),(7838,585),(7839,585),(7840,586),(7841,586),(7842,586),(7843,586),(7844,586),(7845,586),(7846,587),(7847,587),(7848,587),(7849,587),(7850,587),(7851,587),(7852,588),(7853,588),(7854,588),(7855,588),(7856,588),(7857,588),(7858,589),(7859,589),(7860,589),(7861,589),(7862,589),(7863,589),(7864,590),(7865,590),(7866,590),(7867,590),(7868,590),(7869,590),(7870,591),(7871,591),(7872,591),(7873,591),(7874,591),(7875,591),(7876,592),(7877,592),(7878,592),(7879,592),(7880,592),(7881,592),(7882,593),(7883,593),(7884,593),(7885,593),(7886,593),(7887,593),(7888,594),(7889,594),(7890,594),(7891,594),(7892,594),(7893,594),(7894,595),(7895,595),(7896,595),(7897,595),(7898,595),(7899,595),(7900,596),(7901,596),(7902,596),(7903,596),(7904,596),(7905,596),(7906,597),(7907,597),(7908,597),(7909,597),(7910,597),(7911,597),(7912,598),(7913,598),(7914,598),(7915,598),(7916,598),(7917,598),(7918,599),(7919,599),(7920,599),(7921,599),(7922,599),(7923,599),(7924,600),(7925,600),(7926,600),(7927,600),(7928,600),(7929,600),(7930,601),(7931,601),(7932,601),(7933,601),(7934,601),(7935,601),(7936,602),(7937,602),(7938,602),(7939,602),(7940,602),(7941,602),(7942,603),(7943,603),(7944,603),(7945,603),(7946,603),(7947,603),(7948,604),(7949,604),(7950,604),(7951,604),(7952,604),(7953,604),(7954,605),(7955,605),(7956,605),(7957,605),(7958,605),(7959,605),(7960,606),(7961,606),(7962,606),(7963,606),(7964,606),(7965,606),(7966,607),(7967,607),(7968,607),(7969,607),(7970,607),(7971,607),(7972,608),(7973,608),(7974,608),(7975,608),(7976,608),(7977,608),(7978,609),(7979,609),(7980,609),(7981,609),(7982,609),(7983,609),(7984,610),(7985,610),(7986,610),(7987,610),(7988,610),(7989,610),(7990,611),(7991,611),(7992,611),(7993,611),(7994,611),(7995,611),(7996,612),(7997,612),(7998,612),(7999,612),(8000,612),(8001,612),(8002,613),(8003,613),(8004,613),(8005,613),(8006,613),(8007,613),(8008,614),(8009,614),(8010,614),(8011,614),(8012,614),(8013,614),(8014,615),(8015,615),(8016,615),(8017,615),(8018,615),(8019,615),(8020,616),(8021,616),(8022,616),(8023,616),(8024,616),(8025,616),(8026,617),(8027,617),(8028,617),(8029,617),(8030,617),(8031,617),(8032,618),(8033,618),(8034,618),(8035,618),(8036,618),(8037,618),(8038,619),(8039,619),(8040,619),(8041,619),(8042,619),(8043,619),(8044,620),(8045,620),(8046,620),(8047,620),(8048,620),(8049,620),(8050,621),(8051,621),(8052,621),(8053,621),(8054,621),(8055,621),(8056,622),(8057,622),(8058,622),(8059,622),(8060,622),(8061,622),(8062,623),(8063,623),(8064,623),(8065,623),(8066,623),(8067,623),(8068,624),(8069,624),(8070,624),(8071,624),(8072,624),(8073,624),(8074,625),(8075,625),(8076,625),(8077,625),(8078,625),(8079,625),(8080,626),(8081,626),(8082,626),(8083,626),(8084,626),(8085,626),(8086,627),(8087,627),(8088,627),(8089,627),(8090,627),(8091,627),(8092,628),(8093,628),(8094,628),(8095,628),(8096,628),(8097,628),(8098,629),(8099,629),(8100,629),(8101,629),(8102,629),(8103,629),(8104,630),(8105,630),(8106,630),(8107,630),(8108,630),(8109,630),(8110,631),(8111,631),(8112,631),(8113,631),(8114,631),(8115,631),(8116,632),(8117,632),(8118,632),(8119,632),(8120,632),(8121,632),(8122,633),(8123,633),(8124,633),(8125,633),(8126,633),(8127,633),(8128,634),(8129,634),(8130,634),(8131,634),(8132,634),(8133,634),(8134,635),(8135,635),(8136,635),(8137,635),(8138,635),(8139,635),(8140,636),(8141,636),(8142,636),(8143,636),(8144,636),(8145,636),(8146,637),(8147,637),(8148,637),(8149,637),(8150,637),(8151,637),(8152,638),(8153,638),(8154,638),(8155,638),(8156,638),(8157,638),(8158,639),(8159,639),(8160,639),(8161,639),(8162,639),(8163,639),(8164,640),(8165,640),(8166,640),(8167,640),(8168,640),(8169,640),(8170,641),(8171,641),(8172,641),(8173,641),(8174,641),(8175,641),(8176,642),(8177,642),(8178,642),(8179,642),(8180,642),(8181,642),(8182,643),(8183,643),(8184,643),(8185,643),(8186,643),(8187,643),(8188,644),(8189,644),(8190,644),(8191,644),(8192,644),(8193,644),(8194,645),(8195,645),(8196,645),(8197,645),(8198,645),(8199,645),(8200,646),(8201,646),(8202,646),(8203,646),(8204,646),(8205,646),(8206,647),(8207,647),(8208,647),(8209,647),(8210,647),(8211,647),(8212,648),(8213,648),(8214,648),(8215,648),(8216,648),(8217,648),(8218,649),(8219,649),(8220,649),(8221,649),(8222,649),(8223,649),(8224,650),(8225,650),(8226,650),(8227,650),(8228,650),(8229,650),(8230,651),(8231,651),(8232,651),(8233,651),(8234,651),(8235,651),(8236,652),(8237,652),(8238,652),(8239,652),(8240,652),(8241,652),(8242,653),(8243,653),(8244,653),(8245,653),(8246,653),(8247,653),(8248,654),(8249,654),(8250,654),(8251,654),(8252,654),(8253,654),(8254,655),(8255,655),(8256,655),(8257,655),(8258,655),(8259,655),(8260,656),(8261,656),(8262,656),(8263,656),(8264,656),(8265,656),(8266,657),(8267,657),(8268,657),(8269,657),(8270,657),(8271,657),(8272,658),(8273,658),(8274,658),(8275,658),(8276,658),(8277,658),(8278,659),(8279,659),(8280,659),(8281,659),(8282,659),(8283,659),(8284,660),(8285,660),(8286,660),(8287,660),(8288,660),(8289,660),(8290,661),(8291,661),(8292,661),(8293,661),(8294,661),(8295,661),(8296,662),(8297,662),(8298,662),(8299,662),(8300,662),(8301,662),(8302,663),(8303,663),(8304,663),(8305,663),(8306,663),(8307,663),(8308,664),(8309,664),(8310,664),(8311,664),(8312,664),(8313,664),(8314,665),(8315,665),(8316,665),(8317,665),(8318,665),(8319,665),(8320,666),(8321,666),(8322,666),(8323,666),(8324,666),(8325,666),(8326,667),(8327,667),(8328,667),(8329,667),(8330,667),(8331,667),(8332,668),(8333,668),(8334,668),(8335,668),(8336,668),(8337,668),(8338,669),(8339,669),(8340,669),(8341,669),(8342,669),(8343,669),(8344,670),(8345,670),(8346,670),(8347,670),(8348,670),(8349,670),(8350,671),(8351,671),(8352,671),(8353,671),(8354,671),(8355,671),(8356,672),(8357,672),(8358,672),(8359,672),(8360,672),(8361,672),(8362,673),(8363,673),(8364,673),(8365,673),(8366,673),(8367,673),(8368,674),(8369,674),(8370,674),(8371,674),(8372,674),(8373,674),(8374,675),(8375,675),(8376,675),(8377,675),(8378,675),(8379,675),(8380,676),(8381,676),(8382,676),(8383,676),(8384,676),(8385,676),(8386,677),(8387,677),(8388,677),(8389,677),(8390,677),(8391,677),(8392,678),(8393,678),(8394,678),(8395,678),(8396,678),(8397,678),(8398,679),(8399,679),(8400,679),(8401,679),(8402,679),(8403,679),(8404,680),(8405,680),(8406,680),(8407,680),(8408,680),(8409,680),(8410,581),(8411,581),(8412,581),(8413,582),(8414,582),(8415,582),(8416,583),(8417,583),(8418,583),(8419,584),(8420,584),(8421,584),(8422,585),(8423,585),(8424,585),(8425,586),(8426,586),(8427,586),(8428,587),(8429,587),(8430,587),(8431,588),(8432,588),(8433,588),(8434,589),(8435,589),(8436,589),(8437,590),(8438,590),(8439,590),(8440,591),(8441,591),(8442,591),(8443,592),(8444,592),(8445,592),(8446,593),(8447,593),(8448,593),(8449,594),(8450,594),(8451,594),(8452,595),(8453,595),(8454,595),(8455,596),(8456,596),(8457,596),(8458,597),(8459,597),(8460,597),(8461,598),(8462,598),(8463,598),(8464,599),(8465,599),(8466,599),(8467,600),(8468,600),(8469,600),(8470,601),(8471,601),(8472,601),(8473,602),(8474,602),(8475,602),(8476,603),(8477,603),(8478,603),(8479,604),(8480,604),(8481,604),(8482,605),(8483,605),(8484,605),(8485,606),(8486,606),(8487,606),(8488,607),(8489,607),(8490,607),(8491,608),(8492,608),(8493,608),(8494,609),(8495,609),(8496,609),(8497,610),(8498,610),(8499,610),(8500,611),(8501,611),(8502,611),(8503,612),(8504,612),(8505,612),(8506,613),(8507,613),(8508,613),(8509,614),(8510,614),(8511,614),(8512,615),(8513,615),(8514,615),(8515,616),(8516,616),(8517,616),(8518,617),(8519,617),(8520,617),(8521,618),(8522,618),(8523,618),(8524,619),(8525,619),(8526,619),(8527,620),(8528,620),(8529,620),(8530,621),(8531,621),(8532,621),(8533,622),(8534,622),(8535,622),(8536,623),(8537,623),(8538,623),(8539,624),(8540,624),(8541,624),(8542,625),(8543,625),(8544,625),(8545,626),(8546,626),(8547,626),(8548,627),(8549,627),(8550,627),(8551,628),(8552,628),(8553,628),(8554,629),(8555,629),(8556,629),(8557,630),(8558,630),(8559,630),(8560,631),(8561,631),(8562,631),(8563,632),(8564,632),(8565,632),(8566,633),(8567,633),(8568,633),(8569,634),(8570,634),(8571,634),(8572,635),(8573,635),(8574,635),(8575,636),(8576,636),(8577,636),(8578,637),(8579,637),(8580,637),(8581,638),(8582,638),(8583,638),(8584,639),(8585,639),(8586,639),(8587,640),(8588,640),(8589,640),(8590,641),(8591,641),(8592,641),(8593,642),(8594,642),(8595,642),(8596,643),(8597,643),(8598,643),(8599,644),(8600,644),(8601,644),(8602,645),(8603,645),(8604,645),(8605,646),(8606,646),(8607,646),(8608,647),(8609,647),(8610,647),(8611,648),(8612,648),(8613,648),(8614,649),(8615,649),(8616,649),(8617,650),(8618,650),(8619,650),(8620,651),(8621,651),(8622,651),(8623,652),(8624,652),(8625,652),(8626,653),(8627,653),(8628,653),(8629,654),(8630,654),(8631,654),(8632,655),(8633,655),(8634,655),(8635,656),(8636,656),(8637,656),(8638,657),(8639,657),(8640,657),(8641,658),(8642,658),(8643,658),(8644,659),(8645,659),(8646,659),(8647,660),(8648,660),(8649,660),(8650,661),(8651,661),(8652,661),(8653,662),(8654,662),(8655,662),(8656,663),(8657,663),(8658,663),(8659,664),(8660,664),(8661,664),(8662,665),(8663,665),(8664,665),(8665,666),(8666,666),(8667,666),(8668,667),(8669,667),(8670,667),(8671,668),(8672,668),(8673,668),(8674,669),(8675,669),(8676,669),(8677,670),(8678,670),(8679,670),(8680,671),(8681,671),(8682,671),(8683,672),(8684,672),(8685,672),(8686,673),(8687,673),(8688,673),(8689,674),(8690,674),(8691,674),(8692,675),(8693,675),(8694,675),(8695,676),(8696,676),(8697,676),(8698,677),(8699,677),(8700,677),(8701,678),(8702,678),(8703,678),(8704,679),(8705,679),(8706,679),(8707,680),(8708,680),(8709,680),(8710,581),(8711,581),(8712,581),(8713,581),(8714,582),(8715,582),(8716,582),(8717,582),(8718,583),(8719,583),(8720,583),(8721,583),(8722,584),(8723,584),(8724,584),(8725,584),(8726,585),(8727,585),(8728,585),(8729,585),(8730,586),(8731,586),(8732,586),(8733,586),(8734,587),(8735,587),(8736,587),(8737,587),(8738,588),(8739,588),(8740,588),(8741,588),(8742,589),(8743,589),(8744,589),(8745,589),(8746,590),(8747,590),(8748,590),(8749,590),(8750,591),(8751,591),(8752,591),(8753,591),(8754,592),(8755,592),(8756,592),(8757,592),(8758,593),(8759,593),(8760,593),(8761,593),(8762,594),(8763,594),(8764,594),(8765,594),(8766,595),(8767,595),(8768,595),(8769,595),(8770,596),(8771,596),(8772,596),(8773,596),(8774,597),(8775,597),(8776,597),(8777,597),(8778,598),(8779,598),(8780,598),(8781,598),(8782,599),(8783,599),(8784,599),(8785,599),(8786,600),(8787,600),(8788,600),(8789,600),(8790,601),(8791,601),(8792,601),(8793,601),(8794,602),(8795,602),(8796,602),(8797,602),(8798,603),(8799,603),(8800,603),(8801,603),(8802,604),(8803,604),(8804,604),(8805,604),(8806,605),(8807,605),(8808,605),(8809,605),(8810,606),(8811,606),(8812,606),(8813,606),(8814,607),(8815,607),(8816,607),(8817,607),(8818,608),(8819,608),(8820,608),(8821,608),(8822,609),(8823,609),(8824,609),(8825,609),(8826,610),(8827,610),(8828,610),(8829,610),(8830,611),(8831,611),(8832,611),(8833,611),(8834,612),(8835,612),(8836,612),(8837,612),(8838,613),(8839,613),(8840,613),(8841,613),(8842,614),(8843,614),(8844,614),(8845,614),(8846,615),(8847,615),(8848,615),(8849,615),(8850,616),(8851,616),(8852,616),(8853,616),(8854,617),(8855,617),(8856,617),(8857,617),(8858,618),(8859,618),(8860,618),(8861,618),(8862,619),(8863,619),(8864,619),(8865,619),(8866,620),(8867,620),(8868,620),(8869,620),(8870,621),(8871,621),(8872,621),(8873,621),(8874,622),(8875,622),(8876,622),(8877,622),(8878,623),(8879,623),(8880,623),(8881,623),(8882,624),(8883,624),(8884,624),(8885,624),(8886,625),(8887,625),(8888,625),(8889,625),(8890,626),(8891,626),(8892,626),(8893,626),(8894,627),(8895,627),(8896,627),(8897,627),(8898,628),(8899,628),(8900,628),(8901,628),(8902,629),(8903,629),(8904,629),(8905,629),(8906,630),(8907,630),(8908,630),(8909,630),(8910,631),(8911,631),(8912,631),(8913,631),(8914,632),(8915,632),(8916,632),(8917,632),(8918,633),(8919,633),(8920,633),(8921,633),(8922,634),(8923,634),(8924,634),(8925,634),(8926,635),(8927,635),(8928,635),(8929,635),(8930,636),(8931,636),(8932,636),(8933,636),(8934,637),(8935,637),(8936,637),(8937,637),(8938,638),(8939,638),(8940,638),(8941,638),(8942,639),(8943,639),(8944,639),(8945,639),(8946,640),(8947,640),(8948,640),(8949,640),(8950,641),(8951,641),(8952,641),(8953,641),(8954,642),(8955,642),(8956,642),(8957,642),(8958,643),(8959,643),(8960,643),(8961,643),(8962,644),(8963,644),(8964,644),(8965,644),(8966,645),(8967,645),(8968,645),(8969,645),(8970,646),(8971,646),(8972,646),(8973,646),(8974,647),(8975,647),(8976,647),(8977,647),(8978,648),(8979,648),(8980,648),(8981,648),(8982,649),(8983,649),(8984,649),(8985,649),(8986,650),(8987,650),(8988,650),(8989,650),(8990,651),(8991,651),(8992,651),(8993,651),(8994,652),(8995,652),(8996,652),(8997,652),(8998,653),(8999,653),(9000,653),(9001,653),(9002,654),(9003,654),(9004,654),(9005,654),(9006,655),(9007,655),(9008,655),(9009,655),(9010,656),(9011,656),(9012,656),(9013,656),(9014,657),(9015,657),(9016,657),(9017,657),(9018,658),(9019,658),(9020,658),(9021,658),(9022,659),(9023,659),(9024,659),(9025,659),(9026,660),(9027,660),(9028,660),(9029,660),(9030,661),(9031,661),(9032,661),(9033,661),(9034,662),(9035,662),(9036,662),(9037,662),(9038,663),(9039,663),(9040,663),(9041,663),(9042,664),(9043,664),(9044,664),(9045,664),(9046,665),(9047,665),(9048,665),(9049,665),(9050,666),(9051,666),(9052,666),(9053,666),(9054,667),(9055,667),(9056,667),(9057,667),(9058,668),(9059,668),(9060,668),(9061,668),(9062,669),(9063,669),(9064,669),(9065,669),(9066,670),(9067,670),(9068,670),(9069,670),(9070,671),(9071,671),(9072,671),(9073,671),(9074,672),(9075,672),(9076,672),(9077,672),(9078,673),(9079,673),(9080,673),(9081,673),(9082,674),(9083,674),(9084,674),(9085,674),(9086,675),(9087,675),(9088,675),(9089,675),(9090,676),(9091,676),(9092,676),(9093,676),(9094,677),(9095,677),(9096,677),(9097,677),(9098,678),(9099,678),(9100,678),(9101,678),(9102,679),(9103,679),(9104,679),(9105,679),(9106,680),(9107,680),(9108,680),(9109,680),(9110,681),(9111,681),(9112,681),(9113,681),(9114,682),(9115,682),(9116,682),(9117,682),(9118,682),(9119,682),(9120,683),(9121,683),(9122,683),(9123,683),(9124,684),(9125,684),(9126,684),(9127,684),(9128,685),(9129,685),(9130,685),(9131,685),(9132,686),(9133,686),(9134,686),(9135,686),(9136,687),(9137,687),(9138,687),(9139,687),(9140,687),(9141,687),(9142,688),(9143,688),(9144,688),(9145,688),(9146,688),(9147,688),(9148,689),(9149,689),(9150,689),(9151,689),(9152,690),(9153,690),(9154,690),(9155,690),(9156,690),(9157,690),(9158,691),(9159,691),(9160,691),(9161,691),(9162,691),(9163,691),(9164,692),(9165,692),(9166,692),(9167,692),(9168,692),(9169,692),(9170,693),(9171,693),(9172,693),(9173,693),(9174,693),(9175,693),(9176,694),(9177,694),(9178,694),(9179,694),(9180,694),(9181,694),(9182,695),(9183,695),(9184,695),(9185,695),(9186,695),(9187,695),(9188,696),(9189,696),(9190,696),(9191,696),(9192,696),(9193,696),(9194,697),(9195,697),(9196,697),(9197,697),(9198,697),(9199,697),(9200,698),(9201,698),(9202,698),(9203,698),(9204,698),(9205,698),(9206,699),(9207,699),(9208,699),(9209,699),(9210,700),(9211,700),(9212,700),(9213,700),(9214,700),(9215,700),(9216,701),(9217,701),(9218,701),(9219,701),(9220,701),(9221,701),(9222,702),(9223,702),(9224,702),(9225,702),(9226,702),(9227,702),(9228,703),(9229,703),(9230,703),(9231,703),(9232,703),(9233,703),(9234,704),(9235,704),(9236,704),(9237,704),(9238,704),(9239,704),(9240,705),(9241,705),(9242,705),(9243,705),(9244,705),(9245,705),(9246,706),(9247,706),(9248,706),(9249,706),(9250,706),(9251,706),(9252,707),(9253,707),(9254,707),(9255,707),(9256,707),(9257,707),(9258,708),(9259,708),(9260,708),(9261,708),(9262,708),(9263,708),(9264,709),(9265,709),(9266,709),(9267,709),(9268,710),(9269,710),(9270,710),(9271,710),(9272,711),(9273,711),(9274,711),(9275,711),(9276,711),(9277,711),(9278,712),(9279,712),(9280,712),(9281,712),(9282,713),(9283,713),(9284,713),(9285,713),(9286,713),(9287,713),(9288,714),(9289,714),(9290,714),(9291,714),(9292,714),(9293,714),(9294,715),(9295,715),(9296,715),(9297,715),(9298,716),(9299,716),(9300,716),(9301,716),(9302,717),(9303,717),(9304,717),(9305,717),(9306,718),(9307,718),(9308,718),(9309,718),(9310,719),(9311,719),(9312,719),(9313,719),(9314,720),(9315,720),(9316,720),(9317,720),(9318,721),(9319,721),(9320,721),(9321,721),(9322,721),(9323,721),(9324,722),(9325,722),(9326,722),(9327,722),(9328,723),(9329,723),(9330,723),(9331,723),(9332,724),(9333,724),(9334,724),(9335,724),(9336,725),(9337,725),(9338,725),(9339,725),(9340,725),(9341,726),(9342,726),(9343,726),(9344,726),(9345,727),(9346,727),(9347,727),(9348,727),(9349,728),(9350,728),(9351,728),(9352,728),(9353,729),(9354,729),(9355,729),(9356,729),(9357,730),(9358,730),(9359,730),(9360,730),(9361,731),(9362,731),(9363,731),(9364,731),(9365,732),(9366,732),(9367,732),(9368,732),(9369,732),(9370,732),(9371,733),(9372,733),(9373,733),(9374,733),(9375,733),(9376,733),(9377,734),(9378,734),(9379,734),(9380,734),(9381,734),(9382,734),(9383,735),(9384,735),(9385,735),(9386,735),(9387,736),(9388,736),(9389,736),(9390,736),(9391,737),(9392,737),(9393,737),(9394,737),(9395,737),(9396,737),(9397,738),(9398,738),(9399,738),(9400,738),(9401,739),(9402,739),(9403,739),(9404,739),(9405,740),(9406,740),(9407,740),(9408,740),(9409,741),(9410,741),(9411,741),(9412,741),(9413,741),(9414,741),(9415,742),(9416,742),(9417,742),(9418,742),(9419,742),(9420,742),(9421,743),(9422,743),(9423,743),(9424,743),(9425,743),(9426,743),(9427,744),(9428,744),(9429,744),(9430,744),(9431,744),(9432,744),(9433,745),(9434,745),(9435,745),(9436,745),(9437,745),(9438,745),(9439,746),(9440,746),(9441,746),(9442,746),(9443,746),(9444,746),(9445,747),(9446,747),(9447,747),(9448,747),(9449,747),(9450,747),(9451,748),(9452,748),(9453,748),(9454,748),(9455,748),(9456,748),(9457,749),(9458,749),(9459,749),(9460,749),(9461,749),(9462,749),(9463,750),(9464,750),(9465,750),(9466,750),(9467,750),(9468,750),(9469,751),(9470,751),(9471,751),(9472,751),(9473,751),(9474,751),(9475,752),(9476,752),(9477,752),(9478,752),(9479,752),(9480,752),(9481,753),(9482,753),(9483,753),(9484,753),(9485,753),(9486,753),(9487,754),(9488,754),(9489,754),(9490,754),(9491,754),(9492,754),(9493,755),(9494,755),(9495,755),(9496,755),(9497,755),(9498,755),(9499,756),(9500,756),(9501,756),(9502,756),(9503,756),(9504,756),(9505,757),(9506,757),(9507,757),(9508,757),(9509,757),(9510,757),(9511,758),(9512,758),(9513,758),(9514,758),(9515,758),(9516,758),(9517,759),(9518,759),(9519,759),(9520,759),(9521,759),(9522,759),(9523,760),(9524,760),(9525,760),(9526,760),(9527,760),(9528,760),(9529,761),(9530,761),(9531,761),(9532,761),(9533,761),(9534,761),(9535,762),(9536,762),(9537,762),(9538,762),(9539,762),(9540,762),(9541,763),(9542,763),(9543,763),(9544,763),(9545,763),(9546,763),(9547,764),(9548,764),(9549,764),(9550,764),(9551,764),(9552,764),(9553,765),(9554,765),(9555,765),(9556,765),(9557,765),(9558,765),(9559,766),(9560,766),(9561,766),(9562,766),(9563,766),(9564,766),(9565,767),(9566,767),(9567,767),(9568,767),(9569,767),(9570,767),(9571,768),(9572,768),(9573,768),(9574,768),(9575,768),(9576,768),(9577,769),(9578,769),(9579,769),(9580,769),(9581,769),(9582,769),(9583,770),(9584,770),(9585,770),(9586,770),(9587,770),(9588,770),(9589,771),(9590,771),(9591,771),(9592,771),(9593,771),(9594,771),(9595,772),(9596,772),(9597,772),(9598,772),(9599,772),(9600,772),(9601,773),(9602,773),(9603,773),(9604,773),(9605,773),(9606,773),(9607,774),(9608,774),(9609,774),(9610,774),(9611,774),(9612,774),(9613,775),(9614,775),(9615,775),(9616,775),(9617,775),(9618,775),(9619,776),(9620,776),(9621,776),(9622,776),(9623,776),(9624,776),(9625,777),(9626,777),(9627,777),(9628,777),(9629,777),(9630,777),(9631,778),(9632,778),(9633,778),(9634,778),(9635,778),(9636,778),(9637,779),(9638,779),(9639,779),(9640,779),(9641,779),(9642,779),(9643,780),(9644,780),(9645,780),(9646,780),(9647,780),(9648,780),(9649,681),(9650,681),(9651,681),(9652,682),(9653,682),(9654,682),(9655,683),(9656,683),(9657,683),(9658,684),(9659,684),(9660,684),(9661,685),(9662,685),(9663,685),(9664,686),(9665,686),(9666,686),(9667,687),(9668,687),(9669,687),(9670,688),(9671,688),(9672,688),(9673,689),(9674,689),(9675,689),(9676,690),(9677,690),(9678,690),(9679,691),(9680,691),(9681,691),(9682,692),(9683,692),(9684,692),(9685,693),(9686,693),(9687,693),(9688,694),(9689,694),(9690,694),(9691,695),(9692,695),(9693,695),(9694,696),(9695,696),(9696,696),(9697,697),(9698,697),(9699,697),(9700,698),(9701,698),(9702,698),(9703,699),(9704,699),(9705,699),(9706,700),(9707,700),(9708,700),(9709,701),(9710,701),(9711,701),(9712,702),(9713,702),(9714,702),(9715,703),(9716,703),(9717,703),(9718,704),(9719,704),(9720,704),(9721,705),(9722,705),(9723,705),(9724,706),(9725,706),(9726,706),(9727,707),(9728,707),(9729,707),(9730,708),(9731,708),(9732,708),(9733,709),(9734,709),(9735,709),(9736,710),(9737,710),(9738,710),(9739,711),(9740,711),(9741,711),(9742,712),(9743,712),(9744,712),(9745,713),(9746,713),(9747,713),(9748,714),(9749,714),(9750,714),(9751,715),(9752,715),(9753,715),(9754,716),(9755,716),(9756,716),(9757,717),(9758,717),(9759,717),(9760,718),(9761,718),(9762,718),(9763,719),(9764,719),(9765,719),(9766,720),(9767,720),(9768,720),(9769,721),(9770,721),(9771,721),(9772,722),(9773,722),(9774,722),(9775,723),(9776,723),(9777,723),(9778,724),(9779,724),(9780,724),(9781,725),(9782,725),(9783,725),(9784,726),(9785,726),(9786,726),(9787,727),(9788,727),(9789,727),(9790,728),(9791,728),(9792,728),(9793,729),(9794,729),(9795,729),(9796,730),(9797,730),(9798,730),(9799,731),(9800,731),(9801,731),(9802,732),(9803,732),(9804,732),(9805,733),(9806,733),(9807,733),(9808,734),(9809,734),(9810,734),(9811,735),(9812,735),(9813,735),(9814,736),(9815,736),(9816,736),(9817,737),(9818,737),(9819,737),(9820,738),(9821,738),(9822,738),(9823,739),(9824,739),(9825,739),(9826,740),(9827,740),(9828,740),(9829,741),(9830,741),(9831,741),(9832,742),(9833,742),(9834,742),(9835,743),(9836,743),(9837,743),(9838,744),(9839,744),(9840,744),(9841,745),(9842,745),(9843,745),(9844,746),(9845,746),(9846,746),(9847,747),(9848,747),(9849,747),(9850,748),(9851,748),(9852,748),(9853,749),(9854,749),(9855,749),(9856,750),(9857,750),(9858,750),(9859,751),(9860,751),(9861,751),(9862,752),(9863,752),(9864,752),(9865,753),(9866,753),(9867,753),(9868,754),(9869,754),(9870,754),(9871,755),(9872,755),(9873,755),(9874,756),(9875,756),(9876,756),(9877,757),(9878,757),(9879,757),(9880,758),(9881,758),(9882,758),(9883,759),(9884,759),(9885,759),(9886,760),(9887,760),(9888,760),(9889,761),(9890,761),(9891,761),(9892,762),(9893,762),(9894,762),(9895,763),(9896,763),(9897,763),(9898,764),(9899,764),(9900,764),(9901,765),(9902,765),(9903,765),(9904,766),(9905,766),(9906,766),(9907,767),(9908,767),(9909,767),(9910,768),(9911,768),(9912,768),(9913,769),(9914,769),(9915,769),(9916,770),(9917,770),(9918,770),(9919,771),(9920,771),(9921,771),(9922,772),(9923,772),(9924,772),(9925,773),(9926,773),(9927,773),(9928,774),(9929,774),(9930,774),(9931,775),(9932,775),(9933,775),(9934,776),(9935,776),(9936,776),(9937,777),(9938,777),(9939,777),(9940,778),(9941,778),(9942,778),(9943,779),(9944,779),(9945,779),(9946,780),(9947,780),(9948,780),(9949,681),(9950,681),(9951,681),(9952,681),(9953,682),(9954,682),(9955,682),(9956,682),(9957,683),(9958,683),(9959,683),(9960,683),(9961,684),(9962,684),(9963,684),(9964,684),(9965,685),(9966,685),(9967,685),(9968,685),(9969,686),(9970,686),(9971,686),(9972,686),(9973,687),(9974,687),(9975,687),(9976,687),(9977,688),(9978,688),(9979,688),(9980,688),(9981,689),(9982,689),(9983,689),(9984,689),(9985,690),(9986,690),(9987,690),(9988,690),(9989,691),(9990,691),(9991,691),(9992,691),(9993,692),(9994,692),(9995,692),(9996,692),(9997,693),(9998,693),(9999,693),(10000,693),(10001,694),(10002,694),(10003,694),(10004,694),(10005,695),(10006,695),(10007,695),(10008,695),(10009,696),(10010,696),(10011,696),(10012,696),(10013,697),(10014,697),(10015,697),(10016,697),(10017,698),(10018,698),(10019,698),(10020,698),(10021,699),(10022,699),(10023,699),(10024,699),(10025,700),(10026,700),(10027,700),(10028,700),(10029,701),(10030,701),(10031,701),(10032,701),(10033,702),(10034,702),(10035,702),(10036,702),(10037,703),(10038,703),(10039,703),(10040,703),(10041,704),(10042,704),(10043,704),(10044,704),(10045,705),(10046,705),(10047,705),(10048,705),(10049,706),(10050,706),(10051,706),(10052,706),(10053,707),(10054,707),(10055,707),(10056,707),(10057,708),(10058,708),(10059,708),(10060,708),(10061,709),(10062,709),(10063,709),(10064,709),(10065,710),(10066,710),(10067,710),(10068,710),(10069,711),(10070,711),(10071,711),(10072,711),(10073,712),(10074,712),(10075,712),(10076,712),(10077,713),(10078,713),(10079,713),(10080,713),(10081,714),(10082,714),(10083,714),(10084,714),(10085,715),(10086,715),(10087,715),(10088,715),(10089,716),(10090,716),(10091,716),(10092,716),(10093,717),(10094,717),(10095,717),(10096,717),(10097,718),(10098,718),(10099,718),(10100,718),(10101,719),(10102,719),(10103,719),(10104,719),(10105,720),(10106,720),(10107,720),(10108,720),(10109,721),(10110,721),(10111,721),(10112,721),(10113,722),(10114,722),(10115,722),(10116,722),(10117,723),(10118,723),(10119,723),(10120,723),(10121,724),(10122,724),(10123,724),(10124,724),(10125,725),(10126,725),(10127,725),(10128,725),(10129,726),(10130,726),(10131,726),(10132,726),(10133,727),(10134,727),(10135,727),(10136,727),(10137,728),(10138,728),(10139,728),(10140,728),(10141,729),(10142,729),(10143,729),(10144,729),(10145,730),(10146,730),(10147,730),(10148,730),(10149,731),(10150,731),(10151,731),(10152,731),(10153,732),(10154,732),(10155,732),(10156,732),(10157,733),(10158,733),(10159,733),(10160,733),(10161,734),(10162,734),(10163,734),(10164,734),(10165,735),(10166,735),(10167,735),(10168,735),(10169,736),(10170,736),(10171,736),(10172,736),(10173,737),(10174,737),(10175,737),(10176,737),(10177,738),(10178,738),(10179,738),(10180,738),(10181,739),(10182,739),(10183,739),(10184,739),(10185,740),(10186,740),(10187,740),(10188,740),(10189,741),(10190,741),(10191,741),(10192,741),(10193,742),(10194,742),(10195,742),(10196,742),(10197,743),(10198,743),(10199,743),(10200,743),(10201,744),(10202,744),(10203,744),(10204,744),(10205,745),(10206,745),(10207,745),(10208,745),(10209,746),(10210,746),(10211,746),(10212,746),(10213,747),(10214,747),(10215,747),(10216,747),(10217,748),(10218,748),(10219,748),(10220,748),(10221,749),(10222,749),(10223,749),(10224,749),(10225,750),(10226,750),(10227,750),(10228,750),(10229,751),(10230,751),(10231,751),(10232,751),(10233,752),(10234,752),(10235,752),(10236,752),(10237,753),(10238,753),(10239,753),(10240,753),(10241,754),(10242,754),(10243,754),(10244,754),(10245,755),(10246,755),(10247,755),(10248,755),(10249,756),(10250,756),(10251,756),(10252,756),(10253,757),(10254,757),(10255,757),(10256,757),(10257,758),(10258,758),(10259,758),(10260,758),(10261,759),(10262,759),(10263,759),(10264,759),(10265,760),(10266,760),(10267,760),(10268,760),(10269,761),(10270,761),(10271,761),(10272,761),(10273,762),(10274,762),(10275,762),(10276,762),(10277,763),(10278,763),(10279,763),(10280,763),(10281,764),(10282,764),(10283,764),(10284,764),(10285,765),(10286,765),(10287,765),(10288,765),(10289,766),(10290,766),(10291,766),(10292,766),(10293,767),(10294,767),(10295,767),(10296,767),(10297,768),(10298,768),(10299,768),(10300,768),(10301,769),(10302,769),(10303,769),(10304,769),(10305,770),(10306,770),(10307,770),(10308,770),(10309,771),(10310,771),(10311,771),(10312,771),(10313,772),(10314,772),(10315,772),(10316,772),(10317,773),(10318,773),(10319,773),(10320,773),(10321,774),(10322,774),(10323,774),(10324,774),(10325,775),(10326,775),(10327,775),(10328,775),(10329,776),(10330,776),(10331,776),(10332,776),(10333,777),(10334,777),(10335,777),(10336,777),(10337,778),(10338,778),(10339,778),(10340,778),(10341,779),(10342,779),(10343,779),(10344,779),(10345,780),(10346,780),(10347,780),(10348,780),(10349,781),(10350,781),(10351,781),(10352,781),(10353,781),(10354,781),(10355,782),(10356,782),(10357,782),(10358,782),(10359,782),(10360,782),(10361,783),(10362,783),(10363,783),(10364,783),(10365,783),(10366,783),(10367,784),(10368,784),(10369,784),(10370,784),(10371,784),(10372,784),(10373,785),(10374,785),(10375,785),(10376,785),(10377,785),(10378,785),(10379,786),(10380,786),(10381,786),(10382,786),(10383,786),(10384,786),(10385,787),(10386,787),(10387,787),(10388,787),(10389,787),(10390,787),(10391,788),(10392,788),(10393,788),(10394,788),(10395,788),(10396,788),(10397,789),(10398,789),(10399,789),(10400,789),(10401,789),(10402,789),(10403,790),(10404,790),(10405,790),(10406,790),(10407,790),(10408,790),(10409,791),(10410,791),(10411,791),(10412,791),(10413,791),(10414,791),(10415,792),(10416,792),(10417,792),(10418,792),(10419,792),(10420,792),(10421,793),(10422,793),(10423,793),(10424,793),(10425,793),(10426,793),(10427,794),(10428,794),(10429,794),(10430,794),(10431,794),(10432,794),(10433,795),(10434,795),(10435,795),(10436,795),(10437,795),(10438,795),(10439,796),(10440,796),(10441,796),(10442,796),(10443,796),(10444,796),(10445,797),(10446,797),(10447,797),(10448,797),(10449,797),(10450,797),(10451,798),(10452,798),(10453,798),(10454,798),(10455,798),(10456,798),(10457,799),(10458,799),(10459,799),(10460,799),(10461,799),(10462,799),(10463,800),(10464,800),(10465,800),(10466,800),(10467,800),(10468,800),(10469,801),(10470,801),(10471,801),(10472,801),(10473,801),(10474,801),(10475,802),(10476,802),(10477,802),(10478,802),(10479,802),(10480,802),(10481,803),(10482,803),(10483,803),(10484,803),(10485,803),(10486,803),(10487,804),(10488,804),(10489,804),(10490,804),(10491,804),(10492,804),(10493,805),(10494,805),(10495,805),(10496,805),(10497,805),(10498,805),(10499,806),(10500,806),(10501,806),(10502,806),(10503,806),(10504,806),(10505,807),(10506,807),(10507,807),(10508,807),(10509,807),(10510,807),(10511,808),(10512,808),(10513,808),(10514,808),(10515,808),(10516,808),(10517,809),(10518,809),(10519,809),(10520,809),(10521,809),(10522,809),(10523,810),(10524,810),(10525,810),(10526,810),(10527,810),(10528,810),(10529,811),(10530,811),(10531,811),(10532,811),(10533,811),(10534,811),(10535,812),(10536,812),(10537,812),(10538,812),(10539,812),(10540,812),(10541,813),(10542,813),(10543,813),(10544,813),(10545,813),(10546,813),(10547,814),(10548,814),(10549,814),(10550,814),(10551,814),(10552,814),(10553,815),(10554,815),(10555,815),(10556,815),(10557,815),(10558,815),(10559,816),(10560,816),(10561,816),(10562,816),(10563,816),(10564,816),(10565,817),(10566,817),(10567,817),(10568,817),(10569,817),(10570,817),(10571,818),(10572,818),(10573,818),(10574,818),(10575,818),(10576,818),(10577,819),(10578,819),(10579,819),(10580,819),(10581,819),(10582,819),(10583,820),(10584,820),(10585,820),(10586,820),(10587,820),(10588,820),(10589,821),(10590,821),(10591,821),(10592,821),(10593,821),(10594,821),(10595,822),(10596,822),(10597,822),(10598,822),(10599,822),(10600,822),(10601,823),(10602,823),(10603,823),(10604,823),(10605,823),(10606,823),(10607,824),(10608,824),(10609,824),(10610,824),(10611,824),(10612,824),(10613,825),(10614,825),(10615,825),(10616,825),(10617,825),(10618,825),(10619,826),(10620,826),(10621,826),(10622,826),(10623,826),(10624,826),(10625,827),(10626,827),(10627,827),(10628,827),(10629,827),(10630,827),(10631,828),(10632,828),(10633,828),(10634,828),(10635,828),(10636,828),(10637,829),(10638,829),(10639,829),(10640,829),(10641,829),(10642,829),(10643,830),(10644,830),(10645,830),(10646,830),(10647,830),(10648,830),(10649,831),(10650,831),(10651,831),(10652,831),(10653,831),(10654,831),(10655,832),(10656,832),(10657,832),(10658,832),(10659,832),(10660,832),(10661,833),(10662,833),(10663,833),(10664,833),(10665,833),(10666,833),(10667,834),(10668,834),(10669,834),(10670,834),(10671,834),(10672,834),(10673,835),(10674,835),(10675,835),(10676,835),(10677,835),(10678,835),(10679,836),(10680,836),(10681,836),(10682,836),(10683,836),(10684,836),(10685,837),(10686,837),(10687,837),(10688,837),(10689,837),(10690,837),(10691,838),(10692,838),(10693,838),(10694,838),(10695,838),(10696,838),(10697,839),(10698,839),(10699,839),(10700,839),(10701,839),(10702,839),(10703,840),(10704,840),(10705,840),(10706,840),(10707,840),(10708,840),(10709,841),(10710,841),(10711,841),(10712,841),(10713,841),(10714,841),(10715,842),(10716,842),(10717,842),(10718,842),(10719,842),(10720,842),(10721,843),(10722,843),(10723,843),(10724,843),(10725,843),(10726,843),(10727,844),(10728,844),(10729,844),(10730,844),(10731,844),(10732,844),(10733,845),(10734,845),(10735,845),(10736,845),(10737,845),(10738,845),(10739,846),(10740,846),(10741,846),(10742,846),(10743,846),(10744,846),(10745,847),(10746,847),(10747,847),(10748,847),(10749,847),(10750,847),(10751,848),(10752,848),(10753,848),(10754,848),(10755,848),(10756,848),(10757,849),(10758,849),(10759,849),(10760,849),(10761,849),(10762,849),(10763,850),(10764,850),(10765,850),(10766,850),(10767,850),(10768,850),(10769,851),(10770,851),(10771,851),(10772,851),(10773,851),(10774,851),(10775,852),(10776,852),(10777,852),(10778,852),(10779,852),(10780,852),(10781,853),(10782,853),(10783,853),(10784,853),(10785,853),(10786,853),(10787,854),(10788,854),(10789,854),(10790,854),(10791,854),(10792,854),(10793,855),(10794,855),(10795,855),(10796,855),(10797,855),(10798,855),(10799,856),(10800,856),(10801,856),(10802,856),(10803,856),(10804,856),(10805,857),(10806,857),(10807,857),(10808,857),(10809,857),(10810,857),(10811,858),(10812,858),(10813,858),(10814,858),(10815,858),(10816,858),(10817,859),(10818,859),(10819,859),(10820,859),(10821,859),(10822,859),(10823,860),(10824,860),(10825,860),(10826,860),(10827,860),(10828,860),(10829,861),(10830,861),(10831,861),(10832,861),(10833,861),(10834,861),(10835,862),(10836,862),(10837,862),(10838,862),(10839,862),(10840,862),(10841,863),(10842,863),(10843,863),(10844,863),(10845,863),(10846,863),(10847,864),(10848,864),(10849,864),(10850,864),(10851,864),(10852,864),(10853,865),(10854,865),(10855,865),(10856,865),(10857,865),(10858,865),(10859,866),(10860,866),(10861,866),(10862,866),(10863,866),(10864,866),(10865,867),(10866,867),(10867,867),(10868,867),(10869,867),(10870,867),(10871,868),(10872,868),(10873,868),(10874,868),(10875,868),(10876,868),(10877,869),(10878,869),(10879,869),(10880,869),(10881,869),(10882,869),(10883,870),(10884,870),(10885,870),(10886,870),(10887,870),(10888,870),(10889,871),(10890,871),(10891,871),(10892,871),(10893,871),(10894,871),(10895,872),(10896,872),(10897,872),(10898,872),(10899,872),(10900,872),(10901,873),(10902,873),(10903,873),(10904,873),(10905,873),(10906,873),(10907,874),(10908,874),(10909,874),(10910,874),(10911,874),(10912,874),(10913,875),(10914,875),(10915,875),(10916,875),(10917,875),(10918,875),(10919,876),(10920,876),(10921,876),(10922,876),(10923,876),(10924,876),(10925,877),(10926,877),(10927,877),(10928,877),(10929,877),(10930,877),(10931,878),(10932,878),(10933,878),(10934,878),(10935,878),(10936,878),(10937,879),(10938,879),(10939,879),(10940,879),(10941,879),(10942,879),(10943,880),(10944,880),(10945,880),(10946,880),(10947,880),(10948,880),(10949,781),(10950,781),(10951,781),(10952,782),(10953,782),(10954,782),(10955,783),(10956,783),(10957,783),(10958,784),(10959,784),(10960,784),(10961,785),(10962,785),(10963,785),(10964,786),(10965,786),(10966,786),(10967,787),(10968,787),(10969,787),(10970,788),(10971,788),(10972,788),(10973,789),(10974,789),(10975,789),(10976,790),(10977,790),(10978,790),(10979,791),(10980,791),(10981,791),(10982,792),(10983,792),(10984,792),(10985,793),(10986,793),(10987,793),(10988,794),(10989,794),(10990,794),(10991,795),(10992,795),(10993,795),(10994,796),(10995,796),(10996,796),(10997,797),(10998,797),(10999,797),(11000,798),(11001,798),(11002,798),(11003,799),(11004,799),(11005,799),(11006,800),(11007,800),(11008,800),(11009,801),(11010,801),(11011,801),(11012,802),(11013,802),(11014,802),(11015,803),(11016,803),(11017,803),(11018,804),(11019,804),(11020,804),(11021,805),(11022,805),(11023,805),(11024,806),(11025,806),(11026,806),(11027,807),(11028,807),(11029,807),(11030,808),(11031,808),(11032,808),(11033,809),(11034,809),(11035,809),(11036,810),(11037,810),(11038,810),(11039,811),(11040,811),(11041,811),(11042,812),(11043,812),(11044,812),(11045,813),(11046,813),(11047,813),(11048,814),(11049,814),(11050,814),(11051,815),(11052,815),(11053,815),(11054,816),(11055,816),(11056,816),(11057,817),(11058,817),(11059,817),(11060,818),(11061,818),(11062,818),(11063,819),(11064,819),(11065,819),(11066,820),(11067,820),(11068,820),(11069,821),(11070,821),(11071,821),(11072,822),(11073,822),(11074,822),(11075,823),(11076,823),(11077,823),(11078,824),(11079,824),(11080,824),(11081,825),(11082,825),(11083,825),(11084,826),(11085,826),(11086,826),(11087,827),(11088,827),(11089,827),(11090,828),(11091,828),(11092,828),(11093,829),(11094,829),(11095,829),(11096,830),(11097,830),(11098,830),(11099,831),(11100,831),(11101,831),(11102,832),(11103,832),(11104,832),(11105,833),(11106,833),(11107,833),(11108,834),(11109,834),(11110,834),(11111,835),(11112,835),(11113,835),(11114,836),(11115,836),(11116,836),(11117,837),(11118,837),(11119,837),(11120,838),(11121,838),(11122,838),(11123,839),(11124,839),(11125,839),(11126,840),(11127,840),(11128,840),(11129,841),(11130,841),(11131,841),(11132,842),(11133,842),(11134,842),(11135,843),(11136,843),(11137,843),(11138,844),(11139,844),(11140,844),(11141,845),(11142,845),(11143,845),(11144,846),(11145,846),(11146,846),(11147,847),(11148,847),(11149,847),(11150,848),(11151,848),(11152,848),(11153,849),(11154,849),(11155,849),(11156,850),(11157,850),(11158,850),(11159,851),(11160,851),(11161,851),(11162,852),(11163,852),(11164,852),(11165,853),(11166,853),(11167,853),(11168,854),(11169,854),(11170,854),(11171,855),(11172,855),(11173,855),(11174,856),(11175,856),(11176,856),(11177,857),(11178,857),(11179,857),(11180,858),(11181,858),(11182,858),(11183,859),(11184,859),(11185,859),(11186,860),(11187,860),(11188,860),(11189,861),(11190,861),(11191,861),(11192,862),(11193,862),(11194,862),(11195,863),(11196,863),(11197,863),(11198,864),(11199,864),(11200,864),(11201,865),(11202,865),(11203,865),(11204,866),(11205,866),(11206,866),(11207,867),(11208,867),(11209,867),(11210,868),(11211,868),(11212,868),(11213,869),(11214,869),(11215,869),(11216,870),(11217,870),(11218,870),(11219,871),(11220,871),(11221,871),(11222,872),(11223,872),(11224,872),(11225,873),(11226,873),(11227,874),(11228,874),(11229,875),(11230,875),(11231,876),(11232,876),(11233,877),(11234,877),(11235,878),(11236,878),(11237,879),(11238,879),(11239,880),(11240,880),(11241,781),(11242,781),(11243,781),(11244,781),(11245,782),(11246,782),(11247,782),(11248,782),(11249,783),(11250,783),(11251,783),(11252,783),(11253,784),(11254,784),(11255,784),(11256,784),(11257,785),(11258,785),(11259,785),(11260,785),(11261,786),(11262,786),(11263,786),(11264,786),(11265,787),(11266,787),(11267,787),(11268,787),(11269,788),(11270,788),(11271,788),(11272,788),(11273,789),(11274,789),(11275,789),(11276,789),(11277,790),(11278,790),(11279,790),(11280,790),(11281,791),(11282,791),(11283,791),(11284,791),(11285,792),(11286,792),(11287,792),(11288,792),(11289,793),(11290,793),(11291,793),(11292,793),(11293,794),(11294,794),(11295,794),(11296,794),(11297,795),(11298,795),(11299,795),(11300,795),(11301,796),(11302,796),(11303,796),(11304,796),(11305,797),(11306,797),(11307,797),(11308,797),(11309,798),(11310,798),(11311,798),(11312,798),(11313,799),(11314,799),(11315,799),(11316,799),(11317,800),(11318,800),(11319,800),(11320,800),(11321,801),(11322,801),(11323,801),(11324,801),(11325,802),(11326,802),(11327,802),(11328,802),(11329,803),(11330,803),(11331,803),(11332,803),(11333,804),(11334,804),(11335,804),(11336,804),(11337,805),(11338,805),(11339,805),(11340,805),(11341,806),(11342,806),(11343,806),(11344,806),(11345,807),(11346,807),(11347,807),(11348,807),(11349,808),(11350,808),(11351,808),(11352,808),(11353,809),(11354,809),(11355,809),(11356,809),(11357,810),(11358,810),(11359,810),(11360,810),(11361,811),(11362,811),(11363,811),(11364,811),(11365,812),(11366,812),(11367,812),(11368,812),(11369,813),(11370,813),(11371,813),(11372,813),(11373,814),(11374,814),(11375,814),(11376,814),(11377,815),(11378,815),(11379,815),(11380,815),(11381,816),(11382,816),(11383,816),(11384,816),(11385,817),(11386,817),(11387,817),(11388,817),(11389,818),(11390,818),(11391,818),(11392,818),(11393,819),(11394,819),(11395,819),(11396,819),(11397,820),(11398,820),(11399,820),(11400,820),(11401,821),(11402,821),(11403,821),(11404,821),(11405,822),(11406,822),(11407,822),(11408,822),(11409,823),(11410,823),(11411,823),(11412,823),(11413,824),(11414,824),(11415,824),(11416,824),(11417,825),(11418,825),(11419,825),(11420,825),(11421,826),(11422,826),(11423,826),(11424,826),(11425,827),(11426,827),(11427,827),(11428,827),(11429,828),(11430,828),(11431,828),(11432,828),(11433,829),(11434,829),(11435,829),(11436,829),(11437,830),(11438,830),(11439,830),(11440,830),(11441,831),(11442,831),(11443,831),(11444,831),(11445,832),(11446,832),(11447,832),(11448,832),(11449,833),(11450,833),(11451,833),(11452,833),(11453,834),(11454,834),(11455,834),(11456,834),(11457,835),(11458,835),(11459,835),(11460,835),(11461,836),(11462,836),(11463,836),(11464,836),(11465,837),(11466,837),(11467,837),(11468,837),(11469,838),(11470,838),(11471,838),(11472,838),(11473,839),(11474,839),(11475,839),(11476,839),(11477,840),(11478,840),(11479,840),(11480,840),(11481,841),(11482,841),(11483,841),(11484,841),(11485,842),(11486,842),(11487,842),(11488,842),(11489,843),(11490,843),(11491,843),(11492,843),(11493,844),(11494,844),(11495,844),(11496,844),(11497,845),(11498,845),(11499,845),(11500,845),(11501,846),(11502,846),(11503,846),(11504,846),(11505,847),(11506,847),(11507,847),(11508,847),(11509,848),(11510,848),(11511,848),(11512,848),(11513,849),(11514,849),(11515,849),(11516,849),(11517,850),(11518,850),(11519,850),(11520,850),(11521,851),(11522,851),(11523,851),(11524,851),(11525,852),(11526,852),(11527,852),(11528,852),(11529,853),(11530,853),(11531,853),(11532,853),(11533,854),(11534,854),(11535,854),(11536,854),(11537,855),(11538,855),(11539,855),(11540,855),(11541,856),(11542,856),(11543,856),(11544,856),(11545,857),(11546,857),(11547,857),(11548,857),(11549,858),(11550,858),(11551,858),(11552,858),(11553,859),(11554,859),(11555,859),(11556,859),(11557,860),(11558,860),(11559,860),(11560,860),(11561,861),(11562,861),(11563,861),(11564,861),(11565,862),(11566,862),(11567,862),(11568,862),(11569,863),(11570,863),(11571,863),(11572,863),(11573,864),(11574,864),(11575,864),(11576,864),(11577,865),(11578,865),(11579,865),(11580,865),(11581,866),(11582,866),(11583,866),(11584,866),(11585,867),(11586,867),(11587,867),(11588,867),(11589,868),(11590,868),(11591,868),(11592,868),(11593,869),(11594,869),(11595,869),(11596,869),(11597,870),(11598,870),(11599,870),(11600,870),(11601,871),(11602,871),(11603,871),(11604,871),(11605,872),(11606,872),(11607,872),(11608,872),(11609,873),(11610,873),(11611,873),(11612,873),(11613,874),(11614,874),(11615,874),(11616,874),(11617,875),(11618,875),(11619,875),(11620,875),(11621,876),(11622,876),(11623,876),(11624,876),(11625,877),(11626,877),(11627,877),(11628,877),(11629,878),(11630,878),(11631,878),(11632,878),(11633,879),(11634,879),(11635,879),(11636,879),(11637,880),(11638,880),(11639,880),(11640,880),(11641,881),(11642,881),(11643,881),(11644,881),(11645,881),(11646,881),(11647,882),(11648,882),(11649,882),(11650,882),(11651,882),(11652,882),(11653,883),(11654,883),(11655,883),(11656,883),(11657,883),(11658,883),(11659,884),(11660,884),(11661,884),(11662,884),(11663,884),(11664,884),(11665,885),(11666,885),(11667,885),(11668,885),(11669,885),(11670,885),(11671,886),(11672,886),(11673,886),(11674,886),(11675,886),(11676,886),(11677,887),(11678,887),(11679,887),(11680,887),(11681,887),(11682,887),(11683,888),(11684,888),(11685,888),(11686,888),(11687,888),(11688,888),(11689,889),(11690,889),(11691,889),(11692,889),(11693,889),(11694,889),(11695,890),(11696,890),(11697,890),(11698,890),(11699,890),(11700,890),(11701,891),(11702,891),(11703,891),(11704,891),(11705,891),(11706,891),(11707,892),(11708,892),(11709,892),(11710,892),(11711,892),(11712,892),(11713,893),(11714,893),(11715,893),(11716,893),(11717,893),(11718,893),(11719,894),(11720,894),(11721,894),(11722,894),(11723,894),(11724,894),(11725,895),(11726,895),(11727,895),(11728,895),(11729,895),(11730,895),(11731,896),(11732,896),(11733,896),(11734,896),(11735,896),(11736,896),(11737,897),(11738,897),(11739,897),(11740,897),(11741,897),(11742,897),(11743,898),(11744,898),(11745,898),(11746,898),(11747,898),(11748,898),(11749,899),(11750,899),(11751,899),(11752,899),(11753,899),(11754,899),(11755,900),(11756,900),(11757,900),(11758,900),(11759,900),(11760,900),(11761,901),(11762,901),(11763,901),(11764,901),(11765,901),(11766,901),(11767,902),(11768,902),(11769,902),(11770,902),(11771,902),(11772,902),(11773,903),(11774,903),(11775,903),(11776,903),(11777,903),(11778,903),(11779,904),(11780,904),(11781,904),(11782,904),(11783,904),(11784,904),(11785,905),(11786,905),(11787,905),(11788,905),(11789,905),(11790,905),(11791,906),(11792,906),(11793,906),(11794,906),(11795,906),(11796,906),(11797,907),(11798,907),(11799,907),(11800,907),(11801,907),(11802,907),(11803,908),(11804,908),(11805,908),(11806,908),(11807,908),(11808,908),(11809,909),(11810,909),(11811,909),(11812,909),(11813,909),(11814,909),(11815,910),(11816,910),(11817,910),(11818,910),(11819,910),(11820,910),(11821,911),(11822,911),(11823,911),(11824,911),(11825,911),(11826,911),(11827,912),(11828,912),(11829,912),(11830,912),(11831,912),(11832,912),(11833,913),(11834,913),(11835,913),(11836,913),(11837,913),(11838,913),(11839,914),(11840,914),(11841,914),(11842,914),(11843,914),(11844,914),(11845,915),(11846,915),(11847,915),(11848,915),(11849,915),(11850,915),(11851,916),(11852,916),(11853,916),(11854,916),(11855,916),(11856,916),(11857,917),(11858,917),(11859,917),(11860,917),(11861,917),(11862,917),(11863,918),(11864,918),(11865,918),(11866,918),(11867,918),(11868,918),(11869,919),(11870,919),(11871,919),(11872,919),(11873,919),(11874,919),(11875,920),(11876,920),(11877,920),(11878,920),(11879,920),(11880,920),(11881,921),(11882,921),(11883,921),(11884,921),(11885,921),(11886,921),(11887,922),(11888,922),(11889,922),(11890,922),(11891,922),(11892,922),(11893,923),(11894,923),(11895,923),(11896,923),(11897,923),(11898,923),(11899,924),(11900,924),(11901,924),(11902,924),(11903,924),(11904,924),(11905,925),(11906,925),(11907,925),(11908,925),(11909,925),(11910,925),(11911,926),(11912,926),(11913,926),(11914,926),(11915,926),(11916,926),(11917,927),(11918,927),(11919,927),(11920,927),(11921,927),(11922,927),(11923,928),(11924,928),(11925,928),(11926,928),(11927,928),(11928,928),(11929,929),(11930,929),(11931,929),(11932,929),(11933,929),(11934,929),(11935,930),(11936,930),(11937,930),(11938,930),(11939,930),(11940,930),(11941,931),(11942,931),(11943,931),(11944,931),(11945,931),(11946,931),(11947,932),(11948,932),(11949,932),(11950,932),(11951,932),(11952,932),(11953,933),(11954,933),(11955,933),(11956,933),(11957,933),(11958,933),(11959,934),(11960,934),(11961,934),(11962,934),(11963,934),(11964,934),(11965,935),(11966,935),(11967,935),(11968,935),(11969,935),(11970,935),(11971,936),(11972,936),(11973,936),(11974,936),(11975,936),(11976,936),(11977,937),(11978,937),(11979,937),(11980,937),(11981,937),(11982,937),(11983,938),(11984,938),(11985,938),(11986,938),(11987,938),(11988,938),(11989,939),(11990,939),(11991,939),(11992,939),(11993,939),(11994,939),(11995,940),(11996,940),(11997,940),(11998,940),(11999,940),(12000,940),(12001,941),(12002,941),(12003,941),(12004,941),(12005,941),(12006,941),(12007,942),(12008,942),(12009,942),(12010,942),(12011,942),(12012,942),(12013,943),(12014,943),(12015,943),(12016,943),(12017,943),(12018,943),(12019,944),(12020,944),(12021,944),(12022,944),(12023,944),(12024,944),(12025,945),(12026,945),(12027,945),(12028,945),(12029,945),(12030,945),(12031,946),(12032,946),(12033,946),(12034,946),(12035,946),(12036,946),(12037,947),(12038,947),(12039,947),(12040,947),(12041,947),(12042,947),(12043,948),(12044,948),(12045,948),(12046,948),(12047,948),(12048,948),(12049,949),(12050,949),(12051,949),(12052,949),(12053,949),(12054,949),(12055,950),(12056,950),(12057,950),(12058,950),(12059,950),(12060,950),(12061,951),(12062,951),(12063,951),(12064,951),(12065,951),(12066,951),(12067,952),(12068,952),(12069,952),(12070,952),(12071,952),(12072,952),(12073,953),(12074,953),(12075,953),(12076,953),(12077,953),(12078,953),(12079,954),(12080,954),(12081,954),(12082,954),(12083,954),(12084,954),(12085,955),(12086,955),(12087,955),(12088,955),(12089,955),(12090,955),(12091,956),(12092,956),(12093,956),(12094,956),(12095,956),(12096,956),(12097,957),(12098,957),(12099,957),(12100,957),(12101,957),(12102,957),(12103,958),(12104,958),(12105,958),(12106,958),(12107,958),(12108,958),(12109,959),(12110,959),(12111,959),(12112,959),(12113,959),(12114,959),(12115,960),(12116,960),(12117,960),(12118,960),(12119,960),(12120,960),(12121,961),(12122,961),(12123,961),(12124,961),(12125,961),(12126,961),(12127,962),(12128,962),(12129,962),(12130,962),(12131,962),(12132,962),(12133,963),(12134,963),(12135,963),(12136,963),(12137,963),(12138,963),(12139,964),(12140,964),(12141,964),(12142,964),(12143,964),(12144,964),(12145,965),(12146,965),(12147,965),(12148,965),(12149,965),(12150,965),(12151,966),(12152,966),(12153,966),(12154,966),(12155,966),(12156,966),(12157,967),(12158,967),(12159,967),(12160,967),(12161,967),(12162,967),(12163,968),(12164,968),(12165,968),(12166,968),(12167,968),(12168,968),(12169,969),(12170,969),(12171,969),(12172,969),(12173,969),(12174,969),(12175,970),(12176,970),(12177,970),(12178,970),(12179,970),(12180,970),(12181,971),(12182,971),(12183,971),(12184,971),(12185,971),(12186,971),(12187,972),(12188,972),(12189,972),(12190,972),(12191,972),(12192,972),(12193,973),(12194,973),(12195,973),(12196,973),(12197,973),(12198,973),(12199,974),(12200,974),(12201,974),(12202,974),(12203,974),(12204,974),(12205,975),(12206,975),(12207,975),(12208,975),(12209,975),(12210,975),(12211,976),(12212,976),(12213,976),(12214,976),(12215,976),(12216,976),(12217,977),(12218,977),(12219,977),(12220,977),(12221,977),(12222,977),(12223,978),(12224,978),(12225,978),(12226,978),(12227,978),(12228,978),(12229,979),(12230,979),(12231,979),(12232,979),(12233,979),(12234,979),(12235,980),(12236,980),(12237,980),(12238,980),(12239,980),(12240,980),(12241,881),(12242,881),(12243,882),(12244,882),(12245,882),(12246,883),(12247,884),(12248,884),(12249,884),(12250,885),(12251,885),(12252,885),(12253,886),(12254,886),(12255,886),(12256,887),(12257,887),(12258,887),(12259,888),(12260,888),(12261,888),(12262,889),(12263,889),(12264,889),(12265,890),(12266,890),(12267,890),(12268,891),(12269,891),(12270,891),(12271,892),(12272,892),(12273,892),(12274,893),(12275,893),(12276,893),(12277,894),(12278,894),(12279,894),(12280,895),(12281,895),(12282,895),(12283,896),(12284,896),(12285,896),(12286,897),(12287,897),(12288,897),(12289,898),(12290,898),(12291,898),(12292,899),(12293,899),(12294,899),(12295,900),(12296,900),(12297,900),(12298,901),(12299,901),(12300,901),(12301,902),(12302,902),(12303,902),(12304,903),(12305,903),(12306,903),(12307,904),(12308,904),(12309,904),(12310,905),(12311,905),(12312,905),(12313,906),(12314,906),(12315,906),(12316,907),(12317,907),(12318,907),(12319,908),(12320,908),(12321,908),(12322,909),(12323,909),(12324,909),(12325,910),(12326,910),(12327,910),(12328,911),(12329,911),(12330,911),(12331,912),(12332,912),(12333,912),(12334,913),(12335,913),(12336,913),(12337,914),(12338,914),(12339,914),(12340,915),(12341,915),(12342,915),(12343,916),(12344,916),(12345,916),(12346,917),(12347,917),(12348,917),(12349,918),(12350,918),(12351,918),(12352,919),(12353,919),(12354,919),(12355,920),(12356,920),(12357,920),(12358,921),(12359,921),(12360,921),(12361,922),(12362,922),(12363,922),(12364,923),(12365,923),(12366,923),(12367,924),(12368,924),(12369,924),(12370,925),(12371,925),(12372,925),(12373,926),(12374,926),(12375,926),(12376,927),(12377,927),(12378,927),(12379,928),(12380,928),(12381,928),(12382,929),(12383,929),(12384,929),(12385,930),(12386,930),(12387,930),(12388,931),(12389,931),(12390,931),(12391,932),(12392,932),(12393,932),(12394,933),(12395,933),(12396,933),(12397,934),(12398,934),(12399,934),(12400,935),(12401,935),(12402,935),(12403,936),(12404,936),(12405,936),(12406,937),(12407,937),(12408,937),(12409,938),(12410,938),(12411,938),(12412,939),(12413,939),(12414,939),(12415,940),(12416,940),(12417,940),(12418,941),(12419,941),(12420,941),(12421,942),(12422,942),(12423,942),(12424,943),(12425,943),(12426,943),(12427,944),(12428,944),(12429,944),(12430,945),(12431,945),(12432,945),(12433,946),(12434,946),(12435,946),(12436,947),(12437,947),(12438,947),(12439,948),(12440,948),(12441,948),(12442,949),(12443,949),(12444,949),(12445,950),(12446,950),(12447,950),(12448,951),(12449,951),(12450,951),(12451,952),(12452,952),(12453,952),(12454,953),(12455,953),(12456,953),(12457,954),(12458,954),(12459,954),(12460,955),(12461,955),(12462,955),(12463,956),(12464,956),(12465,956),(12466,957),(12467,957),(12468,957),(12469,958),(12470,958),(12471,958),(12472,959),(12473,959),(12474,959),(12475,960),(12476,960),(12477,960),(12478,961),(12479,961),(12480,961),(12481,962),(12482,962),(12483,962),(12484,963),(12485,963),(12486,963),(12487,964),(12488,964),(12489,964),(12490,965),(12491,965),(12492,965),(12493,966),(12494,966),(12495,966),(12496,967),(12497,967),(12498,967),(12499,968),(12500,968),(12501,968),(12502,969),(12503,969),(12504,969),(12505,970),(12506,970),(12507,970),(12508,971),(12509,971),(12510,971),(12511,972),(12512,972),(12513,972),(12514,973),(12515,973),(12516,973),(12517,974),(12518,974),(12519,974),(12520,975),(12521,975),(12522,975),(12523,976),(12524,976),(12525,976),(12526,977),(12527,977),(12528,977),(12529,978),(12530,978),(12531,978),(12532,979),(12533,979),(12534,979),(12535,980),(12536,980),(12537,980),(12538,881),(12539,881),(12540,881),(12541,881),(12542,882),(12543,882),(12544,882),(12545,882),(12546,883),(12547,883),(12548,883),(12549,883),(12550,884),(12551,884),(12552,884),(12553,884),(12554,885),(12555,885),(12556,885),(12557,885),(12558,886),(12559,886),(12560,886),(12561,886),(12562,887),(12563,887),(12564,887),(12565,887),(12566,888),(12567,888),(12568,888),(12569,888),(12570,889),(12571,889),(12572,889),(12573,889),(12574,890),(12575,890),(12576,890),(12577,890),(12578,891),(12579,891),(12580,891),(12581,891),(12582,892),(12583,892),(12584,892),(12585,892),(12586,893),(12587,893),(12588,893),(12589,893),(12590,894),(12591,894),(12592,894),(12593,894),(12594,895),(12595,895),(12596,895),(12597,895),(12598,896),(12599,896),(12600,896),(12601,896),(12602,897),(12603,897),(12604,897),(12605,897),(12606,898),(12607,898),(12608,898),(12609,898),(12610,899),(12611,899),(12612,899),(12613,899),(12614,900),(12615,900),(12616,900),(12617,900),(12618,901),(12619,901),(12620,901),(12621,901),(12622,902),(12623,902),(12624,902),(12625,902),(12626,903),(12627,903),(12628,903),(12629,903),(12630,904),(12631,904),(12632,904),(12633,904),(12634,905),(12635,905),(12636,905),(12637,905),(12638,906),(12639,906),(12640,906),(12641,906),(12642,907),(12643,907),(12644,907),(12645,907),(12646,908),(12647,908),(12648,908),(12649,908),(12650,909),(12651,909),(12652,909),(12653,909),(12654,910),(12655,910),(12656,910),(12657,910),(12658,911),(12659,911),(12660,911),(12661,911),(12662,912),(12663,912),(12664,912),(12665,912),(12666,913),(12667,913),(12668,913),(12669,913),(12670,914),(12671,914),(12672,914),(12673,914),(12674,915),(12675,915),(12676,915),(12677,915),(12678,916),(12679,916),(12680,916),(12681,916),(12682,917),(12683,917),(12684,917),(12685,917),(12686,918),(12687,918),(12688,918),(12689,918),(12690,919),(12691,919),(12692,919),(12693,919),(12694,920),(12695,920),(12696,920),(12697,920),(12698,921),(12699,921),(12700,921),(12701,921),(12702,922),(12703,922),(12704,922),(12705,922),(12706,923),(12707,923),(12708,923),(12709,923),(12710,924),(12711,924),(12712,924),(12713,924),(12714,925),(12715,925),(12716,925),(12717,925),(12718,926),(12719,926),(12720,926),(12721,926),(12722,927),(12723,927),(12724,927),(12725,927),(12726,928),(12727,928),(12728,928),(12729,928),(12730,929),(12731,929),(12732,929),(12733,929),(12734,930),(12735,930),(12736,930),(12737,930),(12738,931),(12739,931),(12740,931),(12741,931),(12742,932),(12743,932),(12744,932),(12745,932),(12746,933),(12747,933),(12748,933),(12749,933),(12750,934),(12751,934),(12752,934),(12753,934),(12754,935),(12755,935),(12756,935),(12757,935),(12758,936),(12759,936),(12760,936),(12761,936),(12762,937),(12763,937),(12764,937),(12765,937),(12766,938),(12767,938),(12768,938),(12769,938),(12770,939),(12771,939),(12772,939),(12773,939),(12774,940),(12775,940),(12776,940),(12777,940),(12778,941),(12779,941),(12780,941),(12781,941),(12782,942),(12783,942),(12784,942),(12785,942),(12786,943),(12787,943),(12788,943),(12789,943),(12790,944),(12791,944),(12792,944),(12793,944),(12794,945),(12795,945),(12796,945),(12797,945),(12798,946),(12799,946),(12800,946),(12801,946),(12802,947),(12803,947),(12804,947),(12805,947),(12806,948),(12807,948),(12808,948),(12809,948),(12810,949),(12811,949),(12812,949),(12813,949),(12814,950),(12815,950),(12816,950),(12817,950),(12818,951),(12819,951),(12820,951),(12821,951),(12822,952),(12823,952),(12824,952),(12825,952),(12826,953),(12827,953),(12828,953),(12829,953),(12830,954),(12831,954),(12832,954),(12833,954),(12834,955),(12835,955),(12836,955),(12837,955),(12838,956),(12839,956),(12840,956),(12841,956),(12842,957),(12843,957),(12844,957),(12845,957),(12846,958),(12847,958),(12848,958),(12849,958),(12850,959),(12851,959),(12852,959),(12853,959),(12854,960),(12855,960),(12856,960),(12857,960),(12858,961),(12859,961),(12860,961),(12861,961),(12862,962),(12863,962),(12864,962),(12865,962),(12866,963),(12867,963),(12868,963),(12869,963),(12870,964),(12871,964),(12872,964),(12873,964),(12874,965),(12875,965),(12876,965),(12877,965),(12878,966),(12879,966),(12880,966),(12881,966),(12882,967),(12883,967),(12884,967),(12885,967),(12886,968),(12887,968),(12888,968),(12889,968),(12890,969),(12891,969),(12892,969),(12893,969),(12894,970),(12895,970),(12896,970),(12897,970),(12898,971),(12899,971),(12900,971),(12901,971),(12902,972),(12903,972),(12904,972),(12905,972),(12906,973),(12907,973),(12908,973),(12909,973),(12910,974),(12911,974),(12912,974),(12913,974),(12914,975),(12915,975),(12916,975),(12917,975),(12918,976),(12919,976),(12920,976),(12921,976),(12922,977),(12923,977),(12924,977),(12925,977),(12926,978),(12927,978),(12928,978),(12929,978),(12930,979),(12931,979),(12932,979),(12933,979),(12934,980),(12935,980),(12936,980),(12937,980),(12938,981),(12939,981),(12940,981),(12941,981),(12942,981),(12943,981),(12944,982),(12945,982),(12946,982),(12947,982),(12948,982),(12949,982),(12950,983),(12951,983),(12952,983),(12953,983),(12954,983),(12955,983),(12956,984),(12957,984),(12958,984),(12959,984),(12960,984),(12961,984),(12962,985),(12963,985),(12964,985),(12965,985),(12966,985),(12967,985),(12968,986),(12969,986),(12970,986),(12971,986),(12972,986),(12973,986),(12974,987),(12975,987),(12976,987),(12977,987),(12978,987),(12979,987),(12980,988),(12981,988),(12982,988),(12983,988),(12984,988),(12985,988),(12986,989),(12987,989),(12988,989),(12989,989),(12990,989),(12991,989),(12992,990),(12993,990),(12994,990),(12995,990),(12996,990),(12997,990),(12998,991),(12999,991),(13000,991),(13001,991),(13002,991),(13003,991),(13004,992),(13005,992),(13006,992),(13007,992),(13008,992),(13009,992),(13010,993),(13011,993),(13012,993),(13013,993),(13014,993),(13015,993),(13016,994),(13017,994),(13018,994),(13019,994),(13020,994),(13021,994),(13022,995),(13023,995),(13024,995),(13025,995),(13026,995),(13027,995),(13028,996),(13029,996),(13030,996),(13031,996),(13032,996),(13033,996),(13034,997),(13035,997),(13036,997),(13037,997),(13038,997),(13039,997),(13040,998),(13041,998),(13042,998),(13043,998),(13044,998),(13045,998),(13046,999),(13047,999),(13048,999),(13049,999),(13050,999),(13051,999),(13052,1000),(13053,1000),(13054,1000),(13055,1000),(13056,1000),(13057,1000),(13058,1001),(13059,1001),(13060,1001),(13061,1001),(13062,1001),(13063,1001),(13064,1002),(13065,1002),(13066,1002),(13067,1002),(13068,1002),(13069,1002),(13070,1003),(13071,1003),(13072,1003),(13073,1003),(13074,1004),(13075,1004),(13076,1004),(13077,1004),(13078,1004),(13079,1004),(13080,1005),(13081,1005),(13082,1005),(13083,1005),(13084,1006),(13085,1006),(13086,1006),(13087,1006),(13088,1006),(13089,1006),(13090,1007),(13091,1007),(13092,1007),(13093,1007),(13094,1007),(13095,1007),(13096,1008),(13097,1008),(13098,1008),(13099,1008),(13100,1008),(13101,1008),(13102,1009),(13103,1009),(13104,1009),(13105,1009),(13106,1009),(13107,1009),(13108,1010),(13109,1010),(13110,1010),(13111,1010),(13112,1010),(13113,1010),(13114,1011),(13115,1011),(13116,1011),(13117,1011),(13118,1011),(13119,1011),(13120,1012),(13121,1012),(13122,1012),(13123,1012),(13124,1012),(13125,1012),(13126,1013),(13127,1013),(13128,1013),(13129,1013),(13130,1013),(13131,1013),(13132,1014),(13133,1014),(13134,1014),(13135,1014),(13136,1014),(13137,1014),(13138,1015),(13139,1015),(13140,1015),(13141,1015),(13142,1015),(13143,1015),(13144,1016),(13145,1016),(13146,1016),(13147,1016),(13148,1016),(13149,1016),(13150,1017),(13151,1017),(13152,1017),(13153,1017),(13154,1017),(13155,1017),(13156,1018),(13157,1018),(13158,1018),(13159,1018),(13160,1018),(13161,1018),(13162,1019),(13163,1019),(13164,1019),(13165,1019),(13166,1019),(13167,1019),(13168,1020),(13169,1020),(13170,1020),(13171,1020),(13172,1020),(13173,1020),(13174,1021),(13175,1021),(13176,1021),(13177,1021),(13178,1021),(13179,1021),(13180,1022),(13181,1022),(13182,1022),(13183,1022),(13184,1022),(13185,1022),(13186,1023),(13187,1023),(13188,1023),(13189,1023),(13190,1023),(13191,1023),(13192,1024),(13193,1024),(13194,1024),(13195,1024),(13196,1024),(13197,1024),(13198,1025),(13199,1025),(13200,1025),(13201,1025),(13202,1025),(13203,1025),(13204,1026),(13205,1026),(13206,1026),(13207,1026),(13208,1026),(13209,1026),(13210,1027),(13211,1027),(13212,1027),(13213,1027),(13214,1027),(13215,1027),(13216,1028),(13217,1028),(13218,1028),(13219,1028),(13220,1028),(13221,1028),(13222,1029),(13223,1029),(13224,1029),(13225,1029),(13226,1029),(13227,1029),(13228,1030),(13229,1030),(13230,1030),(13231,1030),(13232,1030),(13233,1030),(13234,1031),(13235,1031),(13236,1031),(13237,1031),(13238,1031),(13239,1031),(13240,1032),(13241,1032),(13242,1032),(13243,1032),(13244,1032),(13245,1032),(13246,1033),(13247,1033),(13248,1033),(13249,1033),(13250,1033),(13251,1033),(13252,1034),(13253,1034),(13254,1034),(13255,1034),(13256,1034),(13257,1034),(13258,1035),(13259,1035),(13260,1035),(13261,1035),(13262,1036),(13263,1036),(13264,1036),(13265,1036),(13266,1036),(13267,1036),(13268,1037),(13269,1037),(13270,1037),(13271,1037),(13272,1037),(13273,1037),(13274,1038),(13275,1038),(13276,1038),(13277,1038),(13278,1038),(13279,1038),(13280,1039),(13281,1039),(13282,1039),(13283,1039),(13284,1039),(13285,1039),(13286,1040),(13287,1040),(13288,1040),(13289,1040),(13290,1040),(13291,1040),(13292,1041),(13293,1041),(13294,1041),(13295,1041),(13296,1041),(13297,1041),(13298,1042),(13299,1042),(13300,1042),(13301,1042),(13302,1042),(13303,1042),(13304,1043),(13305,1043),(13306,1043),(13307,1043),(13308,1043),(13309,1043),(13310,1044),(13311,1044),(13312,1044),(13313,1044),(13314,1044),(13315,1044),(13316,1045),(13317,1045),(13318,1045),(13319,1045),(13320,1045),(13321,1045),(13322,1046),(13323,1046),(13324,1046),(13325,1046),(13326,1046),(13327,1046),(13328,1047),(13329,1047),(13330,1047),(13331,1047),(13332,1047),(13333,1047),(13334,1048),(13335,1048),(13336,1048),(13337,1048),(13338,1048),(13339,1048),(13340,1049),(13341,1049),(13342,1049),(13343,1049),(13344,1049),(13345,1049),(13346,1050),(13347,1050),(13348,1050),(13349,1050),(13350,1050),(13351,1050),(13352,1051),(13353,1051),(13354,1051),(13355,1051),(13356,1051),(13357,1051),(13358,1052),(13359,1052),(13360,1052),(13361,1052),(13362,1052),(13363,1052),(13364,1053),(13365,1053),(13366,1053),(13367,1053),(13368,1053),(13369,1053),(13370,1054),(13371,1054),(13372,1054),(13373,1054),(13374,1054),(13375,1054),(13376,1055),(13377,1055),(13378,1055),(13379,1055),(13380,1055),(13381,1055),(13382,1056),(13383,1056),(13384,1056),(13385,1056),(13386,1056),(13387,1056),(13388,1057),(13389,1057),(13390,1057),(13391,1057),(13392,1057),(13393,1057),(13394,1058),(13395,1058),(13396,1058),(13397,1058),(13398,1058),(13399,1058),(13400,1059),(13401,1059),(13402,1059),(13403,1059),(13404,1059),(13405,1059),(13406,1060),(13407,1060),(13408,1060),(13409,1060),(13410,1060),(13411,1060),(13412,1061),(13413,1061),(13414,1061),(13415,1061),(13416,1061),(13417,1061),(13418,1062),(13419,1062),(13420,1062),(13421,1062),(13422,1062),(13423,1062),(13424,1063),(13425,1063),(13426,1063),(13427,1063),(13428,1063),(13429,1063),(13430,1064),(13431,1064),(13432,1064),(13433,1064),(13434,1064),(13435,1064),(13436,1065),(13437,1065),(13438,1065),(13439,1065),(13440,1065),(13441,1065),(13442,1066),(13443,1066),(13444,1066),(13445,1066),(13446,1066),(13447,1066),(13448,1067),(13449,1067),(13450,1067),(13451,1067),(13452,1067),(13453,1067),(13454,1068),(13455,1068),(13456,1068),(13457,1068),(13458,1068),(13459,1068),(13460,1069),(13461,1069),(13462,1069),(13463,1069),(13464,1069),(13465,1069),(13466,1070),(13467,1070),(13468,1070),(13469,1070),(13470,1070),(13471,1070),(13472,1071),(13473,1071),(13474,1071),(13475,1071),(13476,1071),(13477,1071),(13478,1072),(13479,1072),(13480,1072),(13481,1072),(13482,1072),(13483,1072),(13484,1073),(13485,1073),(13486,1073),(13487,1073),(13488,1073),(13489,1073),(13490,1074),(13491,1074),(13492,1074),(13493,1074),(13494,1074),(13495,1074),(13496,1075),(13497,1075),(13498,1075),(13499,1075),(13500,1075),(13501,1075),(13502,1076),(13503,1076),(13504,1076),(13505,1076),(13506,1076),(13507,1076),(13508,1077),(13509,1077),(13510,1077),(13511,1077),(13512,1077),(13513,1077),(13514,1078),(13515,1078),(13516,1078),(13517,1078),(13518,1078),(13519,1078),(13520,1079),(13521,1079),(13522,1079),(13523,1079),(13524,1079),(13525,1079),(13526,1080),(13527,1080),(13528,1080),(13529,1080),(13530,1080),(13531,1080),(13532,981),(13533,981),(13534,981),(13535,982),(13536,982),(13537,982),(13538,983),(13539,983),(13540,983),(13541,984),(13542,984),(13543,984),(13544,985),(13545,985),(13546,985),(13547,986),(13548,986),(13549,986),(13550,987),(13551,987),(13552,987),(13553,988),(13554,988),(13555,988),(13556,989),(13557,989),(13558,989),(13559,990),(13560,990),(13561,990),(13562,991),(13563,991),(13564,991),(13565,992),(13566,992),(13567,992),(13568,993),(13569,993),(13570,993),(13571,994),(13572,994),(13573,994),(13574,995),(13575,995),(13576,995),(13577,996),(13578,996),(13579,996),(13580,997),(13581,997),(13582,997),(13583,998),(13584,998),(13585,998),(13586,999),(13587,999),(13588,999),(13589,1000),(13590,1000),(13591,1000),(13592,1001),(13593,1001),(13594,1001),(13595,1002),(13596,1002),(13597,1002),(13598,1003),(13599,1003),(13600,1003),(13601,1004),(13602,1004),(13603,1004),(13604,1005),(13605,1005),(13606,1005),(13607,1006),(13608,1006),(13609,1006),(13610,1007),(13611,1007),(13612,1007),(13613,1008),(13614,1008),(13615,1008),(13616,1009),(13617,1009),(13618,1009),(13619,1010),(13620,1010),(13621,1010),(13622,1011),(13623,1011),(13624,1011),(13625,1012),(13626,1012),(13627,1012),(13628,1013),(13629,1013),(13630,1013),(13631,1014),(13632,1014),(13633,1014),(13634,1015),(13635,1015),(13636,1015),(13637,1016),(13638,1016),(13639,1016),(13640,1017),(13641,1017),(13642,1017),(13643,1018),(13644,1018),(13645,1018),(13646,1019),(13647,1019),(13648,1019),(13649,1020),(13650,1020),(13651,1020),(13652,1021),(13653,1021),(13654,1021),(13655,1022),(13656,1022),(13657,1022),(13658,1023),(13659,1023),(13660,1023),(13661,1024),(13662,1024),(13663,1024),(13664,1025),(13665,1025),(13666,1025),(13667,1026),(13668,1026),(13669,1026),(13670,1027),(13671,1027),(13672,1027),(13673,1028),(13674,1028),(13675,1028),(13676,1029),(13677,1029),(13678,1029),(13679,1030),(13680,1030),(13681,1030),(13682,1031),(13683,1031),(13684,1031),(13685,1032),(13686,1032),(13687,1032),(13688,1033),(13689,1033),(13690,1033),(13691,1034),(13692,1034),(13693,1034),(13694,1035),(13695,1035),(13696,1035),(13697,1036),(13698,1036),(13699,1036),(13700,1037),(13701,1037),(13702,1037),(13703,1038),(13704,1038),(13705,1038),(13706,1039),(13707,1039),(13708,1040),(13709,1040),(13710,1040),(13711,1041),(13712,1041),(13713,1041),(13714,1042),(13715,1042),(13716,1042),(13717,1043),(13718,1043),(13719,1043),(13720,1044),(13721,1044),(13722,1044),(13723,1045),(13724,1045),(13725,1045),(13726,1046),(13727,1046),(13728,1046),(13729,1047),(13730,1047),(13731,1047),(13732,1048),(13733,1048),(13734,1048),(13735,1049),(13736,1049),(13737,1049),(13738,1050),(13739,1050),(13740,1050),(13741,1051),(13742,1051),(13743,1051),(13744,1052),(13745,1052),(13746,1052),(13747,1053),(13748,1053),(13749,1053),(13750,1054),(13751,1054),(13752,1054),(13753,1055),(13754,1055),(13755,1055),(13756,1056),(13757,1056),(13758,1056),(13759,1057),(13760,1057),(13761,1057),(13762,1058),(13763,1058),(13764,1058),(13765,1059),(13766,1059),(13767,1059),(13768,1060),(13769,1060),(13770,1060),(13771,1061),(13772,1061),(13773,1061),(13774,1062),(13775,1062),(13776,1062),(13777,1063),(13778,1063),(13779,1063),(13780,1064),(13781,1064),(13782,1064),(13783,1065),(13784,1065),(13785,1065),(13786,1066),(13787,1066),(13788,1066),(13789,1067),(13790,1067),(13791,1067),(13792,1068),(13793,1068),(13794,1068),(13795,1069),(13796,1069),(13797,1069),(13798,1070),(13799,1070),(13800,1070),(13801,1071),(13802,1071),(13803,1071),(13804,1072),(13805,1072),(13806,1072),(13807,1073),(13808,1073),(13809,1073),(13810,1074),(13811,1074),(13812,1074),(13813,1075),(13814,1075),(13815,1075),(13816,1076),(13817,1076),(13818,1076),(13819,1077),(13820,1077),(13821,1077),(13822,1078),(13823,1078),(13824,1078),(13825,1079),(13826,1079),(13827,1079),(13828,1080),(13829,1080),(13830,1080),(13831,981),(13832,981),(13833,981),(13834,981),(13835,982),(13836,982),(13837,982),(13838,982),(13839,983),(13840,983),(13841,983),(13842,983),(13843,984),(13844,984),(13845,984),(13846,984),(13847,985),(13848,985),(13849,985),(13850,985),(13851,986),(13852,986),(13853,986),(13854,986),(13855,987),(13856,987),(13857,987),(13858,987),(13859,988),(13860,988),(13861,988),(13862,988),(13863,989),(13864,989),(13865,989),(13866,989),(13867,990),(13868,990),(13869,990),(13870,990),(13871,991),(13872,991),(13873,991),(13874,991),(13875,992),(13876,992),(13877,992),(13878,992),(13879,993),(13880,993),(13881,993),(13882,993),(13883,994),(13884,994),(13885,994),(13886,994),(13887,995),(13888,995),(13889,995),(13890,995),(13891,996),(13892,996),(13893,996),(13894,996),(13895,997),(13896,997),(13897,997),(13898,997),(13899,998),(13900,998),(13901,998),(13902,998),(13903,999),(13904,999),(13905,999),(13906,999),(13907,1000),(13908,1000),(13909,1000),(13910,1000),(13911,1001),(13912,1001),(13913,1001),(13914,1001),(13915,1002),(13916,1002),(13917,1002),(13918,1002),(13919,1003),(13920,1003),(13921,1003),(13922,1003),(13923,1004),(13924,1004),(13925,1004),(13926,1004),(13927,1005),(13928,1005),(13929,1005),(13930,1005),(13931,1006),(13932,1006),(13933,1006),(13934,1006),(13935,1007),(13936,1007),(13937,1007),(13938,1007),(13939,1008),(13940,1008),(13941,1008),(13942,1008),(13943,1009),(13944,1009),(13945,1009),(13946,1009),(13947,1010),(13948,1010),(13949,1010),(13950,1010),(13951,1011),(13952,1011),(13953,1011),(13954,1011),(13955,1012),(13956,1012),(13957,1012),(13958,1012),(13959,1013),(13960,1013),(13961,1013),(13962,1013),(13963,1014),(13964,1014),(13965,1014),(13966,1014),(13967,1015),(13968,1015),(13969,1015),(13970,1015),(13971,1016),(13972,1016),(13973,1016),(13974,1016),(13975,1017),(13976,1017),(13977,1017),(13978,1017),(13979,1018),(13980,1018),(13981,1018),(13982,1018),(13983,1019),(13984,1019),(13985,1019),(13986,1019),(13987,1020),(13988,1020),(13989,1020),(13990,1020),(13991,1021),(13992,1021),(13993,1021),(13994,1021),(13995,1022),(13996,1022),(13997,1022),(13998,1022),(13999,1023),(14000,1023),(14001,1023),(14002,1023),(14003,1024),(14004,1024),(14005,1024),(14006,1024),(14007,1025),(14008,1025),(14009,1025),(14010,1025),(14011,1026),(14012,1026),(14013,1026),(14014,1026),(14015,1027),(14016,1027),(14017,1027),(14018,1027),(14019,1028),(14020,1028),(14021,1028),(14022,1028),(14023,1029),(14024,1029),(14025,1029),(14026,1029),(14027,1030),(14028,1030),(14029,1030),(14030,1030),(14031,1031),(14032,1031),(14033,1031),(14034,1031),(14035,1032),(14036,1032),(14037,1032),(14038,1032),(14039,1033),(14040,1033),(14041,1033),(14042,1033),(14043,1034),(14044,1034),(14045,1034),(14046,1034),(14047,1035),(14048,1035),(14049,1035),(14050,1035),(14051,1036),(14052,1036),(14053,1036),(14054,1036),(14055,1037),(14056,1037),(14057,1037),(14058,1037),(14059,1038),(14060,1038),(14061,1038),(14062,1038),(14063,1039),(14064,1039),(14065,1039),(14066,1039),(14067,1040),(14068,1040),(14069,1040),(14070,1040),(14071,1041),(14072,1041),(14073,1041),(14074,1041),(14075,1042),(14076,1042),(14077,1042),(14078,1042),(14079,1043),(14080,1043),(14081,1043),(14082,1043),(14083,1044),(14084,1044),(14085,1044),(14086,1044),(14087,1045),(14088,1045),(14089,1045),(14090,1045),(14091,1046),(14092,1046),(14093,1046),(14094,1046),(14095,1047),(14096,1047),(14097,1047),(14098,1047),(14099,1048),(14100,1048),(14101,1048),(14102,1048),(14103,1049),(14104,1049),(14105,1049),(14106,1049),(14107,1050),(14108,1050),(14109,1050),(14110,1050),(14111,1051),(14112,1051),(14113,1051),(14114,1051),(14115,1052),(14116,1052),(14117,1052),(14118,1052),(14119,1053),(14120,1053),(14121,1053),(14122,1053),(14123,1054),(14124,1054),(14125,1054),(14126,1054),(14127,1055),(14128,1055),(14129,1055),(14130,1055),(14131,1056),(14132,1056),(14133,1056),(14134,1056),(14135,1057),(14136,1057),(14137,1057),(14138,1057),(14139,1058),(14140,1058),(14141,1058),(14142,1058),(14143,1059),(14144,1059),(14145,1059),(14146,1059),(14147,1060),(14148,1060),(14149,1060),(14150,1060),(14151,1061),(14152,1061),(14153,1061),(14154,1061),(14155,1062),(14156,1062),(14157,1062),(14158,1062),(14159,1063),(14160,1063),(14161,1063),(14162,1063),(14163,1064),(14164,1064),(14165,1064),(14166,1064),(14167,1065),(14168,1065),(14169,1065),(14170,1065),(14171,1066),(14172,1066),(14173,1066),(14174,1066),(14175,1067),(14176,1067),(14177,1067),(14178,1067),(14179,1068),(14180,1068),(14181,1068),(14182,1068),(14183,1069),(14184,1069),(14185,1069),(14186,1069),(14187,1070),(14188,1070),(14189,1070),(14190,1070),(14191,1071),(14192,1071),(14193,1071),(14194,1071),(14195,1072),(14196,1072),(14197,1072),(14198,1072),(14199,1073),(14200,1073),(14201,1073),(14202,1073),(14203,1074),(14204,1074),(14205,1074),(14206,1074),(14207,1075),(14208,1075),(14209,1075),(14210,1075),(14211,1076),(14212,1076),(14213,1076),(14214,1076),(14215,1077),(14216,1077),(14217,1077),(14218,1077),(14219,1078),(14220,1078),(14221,1078),(14222,1078),(14223,1079),(14224,1079),(14225,1079),(14226,1079),(14227,1080),(14228,1080),(14229,1080),(14230,1080),(14231,1081),(14232,1081),(14233,1081),(14234,1081),(14235,1081),(14236,1081),(14237,1082),(14238,1082),(14239,1082),(14240,1082),(14241,1082),(14242,1082),(14243,1083),(14244,1083),(14245,1083),(14246,1083),(14247,1083),(14248,1083),(14249,1084),(14250,1084),(14251,1084),(14252,1084),(14253,1084),(14254,1084),(14255,1085),(14256,1085),(14257,1085),(14258,1085),(14259,1085),(14260,1085),(14261,1086),(14262,1086),(14263,1086),(14264,1086),(14265,1086),(14266,1086),(14267,1087),(14268,1087),(14269,1087),(14270,1087),(14271,1087),(14272,1087),(14273,1088),(14274,1088),(14275,1088),(14276,1088),(14277,1088),(14278,1088),(14279,1089),(14280,1089),(14281,1089),(14282,1089),(14283,1089),(14284,1089),(14285,1090),(14286,1090),(14287,1090),(14288,1090),(14289,1090),(14290,1090),(14291,1091),(14292,1091),(14293,1091),(14294,1091),(14295,1091),(14296,1091),(14297,1092),(14298,1092),(14299,1092),(14300,1092),(14301,1092),(14302,1092),(14303,1093),(14304,1093),(14305,1093),(14306,1093),(14307,1093),(14308,1093),(14309,1094),(14310,1094),(14311,1094),(14312,1094),(14313,1094),(14314,1094),(14315,1095),(14316,1095),(14317,1095),(14318,1095),(14319,1095),(14320,1095),(14321,1096),(14322,1096),(14323,1096),(14324,1096),(14325,1096),(14326,1096),(14327,1097),(14328,1097),(14329,1097),(14330,1097),(14331,1097),(14332,1097),(14333,1098),(14334,1098),(14335,1098),(14336,1098),(14337,1098),(14338,1098),(14339,1099),(14340,1099),(14341,1099),(14342,1099),(14343,1099),(14344,1099),(14345,1100),(14346,1100),(14347,1100),(14348,1100),(14349,1100),(14350,1100),(14351,1101),(14352,1101),(14353,1101),(14354,1101),(14355,1101),(14356,1101),(14357,1102),(14358,1102),(14359,1102),(14360,1102),(14361,1102),(14362,1102),(14363,1103),(14364,1103),(14365,1103),(14366,1103),(14367,1103),(14368,1103),(14369,1104),(14370,1104),(14371,1104),(14372,1104),(14373,1104),(14374,1104),(14375,1105),(14376,1105),(14377,1105),(14378,1105),(14379,1105),(14380,1105),(14381,1106),(14382,1106),(14383,1106),(14384,1106),(14385,1106),(14386,1106),(14387,1107),(14388,1107),(14389,1107),(14390,1107),(14391,1107),(14392,1107),(14393,1108),(14394,1108),(14395,1108),(14396,1108),(14397,1108),(14398,1108),(14399,1109),(14400,1109),(14401,1109),(14402,1109),(14403,1109),(14404,1109),(14405,1110),(14406,1110),(14407,1110),(14408,1110),(14409,1110),(14410,1110),(14411,1111),(14412,1111),(14413,1111),(14414,1111),(14415,1111),(14416,1111),(14417,1112),(14418,1112),(14419,1112),(14420,1112),(14421,1112),(14422,1112),(14423,1113),(14424,1113),(14425,1113),(14426,1113),(14427,1113),(14428,1113),(14429,1114),(14430,1114),(14431,1114),(14432,1114),(14433,1114),(14434,1114),(14435,1115),(14436,1115),(14437,1115),(14438,1115),(14439,1115),(14440,1115),(14441,1116),(14442,1116),(14443,1116),(14444,1116),(14445,1116),(14446,1116),(14447,1117),(14448,1117),(14449,1117),(14450,1117),(14451,1117),(14452,1117),(14453,1118),(14454,1118),(14455,1118),(14456,1118),(14457,1118),(14458,1118),(14459,1119),(14460,1119),(14461,1119),(14462,1119),(14463,1119),(14464,1119),(14465,1120),(14466,1120),(14467,1120),(14468,1120),(14469,1120),(14470,1120),(14471,1121),(14472,1121),(14473,1121),(14474,1121),(14475,1121),(14476,1121),(14477,1122),(14478,1122),(14479,1122),(14480,1122),(14481,1122),(14482,1122),(14483,1123),(14484,1123),(14485,1123),(14486,1123),(14487,1123),(14488,1123),(14489,1124),(14490,1124),(14491,1124),(14492,1124),(14493,1124),(14494,1124),(14495,1125),(14496,1125),(14497,1125),(14498,1125),(14499,1125),(14500,1125),(14501,1126),(14502,1126),(14503,1126),(14504,1126),(14505,1126),(14506,1126),(14507,1127),(14508,1127),(14509,1127),(14510,1127),(14511,1127),(14512,1127),(14513,1128),(14514,1128),(14515,1128),(14516,1128),(14517,1128),(14518,1128),(14519,1129),(14520,1129),(14521,1129),(14522,1129),(14523,1129),(14524,1129),(14525,1130),(14526,1130),(14527,1130),(14528,1130),(14529,1130),(14530,1130),(14531,1131),(14532,1131),(14533,1131),(14534,1131),(14535,1131),(14536,1131),(14537,1132),(14538,1132),(14539,1132),(14540,1132),(14541,1132),(14542,1132),(14543,1133),(14544,1133),(14545,1133),(14546,1133),(14547,1133),(14548,1133),(14549,1134),(14550,1134),(14551,1134),(14552,1134),(14553,1134),(14554,1134),(14555,1135),(14556,1135),(14557,1135),(14558,1135),(14559,1135),(14560,1135),(14561,1136),(14562,1136),(14563,1136),(14564,1136),(14565,1136),(14566,1136),(14567,1137),(14568,1137),(14569,1137),(14570,1137),(14571,1137),(14572,1137),(14573,1138),(14574,1138),(14575,1138),(14576,1138),(14577,1138),(14578,1138),(14579,1139),(14580,1139),(14581,1139),(14582,1139),(14583,1139),(14584,1139),(14585,1081),(14586,1081),(14587,1081),(14588,1082),(14589,1082),(14590,1082),(14591,1083),(14592,1083),(14593,1083),(14594,1084),(14595,1084),(14596,1084),(14597,1085),(14598,1085),(14599,1085),(14600,1086),(14601,1086),(14602,1086),(14603,1087),(14604,1087),(14605,1087),(14606,1088),(14607,1088),(14608,1088),(14609,1089),(14610,1089),(14611,1089),(14612,1090),(14613,1090),(14614,1090),(14615,1091),(14616,1091),(14617,1091),(14618,1092),(14619,1092),(14620,1092),(14621,1093),(14622,1093),(14623,1093),(14624,1094),(14625,1094),(14626,1094),(14627,1095),(14628,1095),(14629,1095),(14630,1096),(14631,1096),(14632,1096),(14633,1097),(14634,1097),(14635,1097),(14636,1098),(14637,1098),(14638,1098),(14639,1099),(14640,1099),(14641,1100),(14642,1100),(14643,1100),(14644,1101),(14645,1101),(14646,1101),(14647,1102),(14648,1102),(14649,1102),(14650,1103),(14651,1103),(14652,1103),(14653,1104),(14654,1104),(14655,1104),(14656,1105),(14657,1105),(14658,1105),(14659,1106),(14660,1106),(14661,1106),(14662,1107),(14663,1107),(14664,1107),(14665,1108),(14666,1108),(14667,1108),(14668,1109),(14669,1109),(14670,1109),(14671,1110),(14672,1110),(14673,1110),(14674,1111),(14675,1111),(14676,1111),(14677,1112),(14678,1112),(14679,1112),(14680,1113),(14681,1113),(14682,1113),(14683,1114),(14684,1114),(14685,1114),(14686,1115),(14687,1115),(14688,1115),(14689,1116),(14690,1116),(14691,1116),(14692,1117),(14693,1117),(14694,1117),(14695,1118),(14696,1118),(14697,1118),(14698,1119),(14699,1119),(14700,1119),(14701,1120),(14702,1120),(14703,1120),(14704,1121),(14705,1121),(14706,1121),(14707,1122),(14708,1122),(14709,1122),(14710,1123),(14711,1123),(14712,1123),(14713,1124),(14714,1124),(14715,1124),(14716,1125),(14717,1125),(14718,1125),(14719,1126),(14720,1126),(14721,1126),(14722,1127),(14723,1127),(14724,1127),(14725,1128),(14726,1128),(14727,1128),(14728,1129),(14729,1129),(14730,1129),(14731,1130),(14732,1130),(14733,1130),(14734,1131),(14735,1131),(14736,1131),(14737,1132),(14738,1132),(14739,1132),(14740,1133),(14741,1133),(14742,1133),(14743,1134),(14744,1134),(14745,1134),(14746,1135),(14747,1135),(14748,1135),(14749,1136),(14750,1136),(14751,1136),(14752,1137),(14753,1137),(14754,1137),(14755,1138),(14756,1138),(14757,1138),(14758,1139),(14759,1139),(14760,1139),(14761,1081),(14762,1081),(14763,1081),(14764,1081),(14765,1082),(14766,1082),(14767,1082),(14768,1082),(14769,1083),(14770,1083),(14771,1083),(14772,1083),(14773,1084),(14774,1084),(14775,1084),(14776,1084),(14777,1085),(14778,1085),(14779,1085),(14780,1085),(14781,1086),(14782,1086),(14783,1086),(14784,1086),(14785,1087),(14786,1087),(14787,1087),(14788,1087),(14789,1088),(14790,1088),(14791,1088),(14792,1088),(14793,1089),(14794,1089),(14795,1089),(14796,1089),(14797,1090),(14798,1090),(14799,1090),(14800,1090),(14801,1091),(14802,1091),(14803,1091),(14804,1091),(14805,1092),(14806,1092),(14807,1092),(14808,1092),(14809,1093),(14810,1093),(14811,1093),(14812,1093),(14813,1094),(14814,1094),(14815,1094),(14816,1094),(14817,1095),(14818,1095),(14819,1095),(14820,1095),(14821,1096),(14822,1096),(14823,1096),(14824,1096),(14825,1097),(14826,1097),(14827,1097),(14828,1097),(14829,1098),(14830,1098),(14831,1098),(14832,1098),(14833,1099),(14834,1099),(14835,1099),(14836,1099),(14837,1100),(14838,1100),(14839,1100),(14840,1100),(14841,1101),(14842,1101),(14843,1101),(14844,1101),(14845,1102),(14846,1102),(14847,1102),(14848,1102),(14849,1103),(14850,1103),(14851,1103),(14852,1103),(14853,1104),(14854,1104),(14855,1104),(14856,1104),(14857,1105),(14858,1105),(14859,1105),(14860,1105),(14861,1106),(14862,1106),(14863,1106),(14864,1106),(14865,1107),(14866,1107),(14867,1107),(14868,1107),(14869,1108),(14870,1108),(14871,1108),(14872,1108),(14873,1109),(14874,1109),(14875,1109),(14876,1109),(14877,1110),(14878,1110),(14879,1110),(14880,1110),(14881,1111),(14882,1111),(14883,1111),(14884,1111),(14885,1112),(14886,1112),(14887,1112),(14888,1112),(14889,1113),(14890,1113),(14891,1113),(14892,1113),(14893,1114),(14894,1114),(14895,1114),(14896,1114),(14897,1115),(14898,1115),(14899,1115),(14900,1115),(14901,1116),(14902,1116),(14903,1116),(14904,1116),(14905,1117),(14906,1117),(14907,1117),(14908,1117),(14909,1118),(14910,1118),(14911,1118),(14912,1118),(14913,1119),(14914,1119),(14915,1119),(14916,1119),(14917,1120),(14918,1120),(14919,1120),(14920,1120),(14921,1121),(14922,1121),(14923,1121),(14924,1121),(14925,1122),(14926,1122),(14927,1122),(14928,1122),(14929,1123),(14930,1123),(14931,1123),(14932,1123),(14933,1124),(14934,1124),(14935,1124),(14936,1124),(14937,1125),(14938,1125),(14939,1125),(14940,1125),(14941,1126),(14942,1126),(14943,1126),(14944,1126),(14945,1127),(14946,1127),(14947,1127),(14948,1127),(14949,1128),(14950,1128),(14951,1128),(14952,1128),(14953,1129),(14954,1129),(14955,1129),(14956,1129),(14957,1130),(14958,1130),(14959,1130),(14960,1130),(14961,1131),(14962,1131),(14963,1131),(14964,1131),(14965,1132),(14966,1132),(14967,1132),(14968,1132),(14969,1133),(14970,1133),(14971,1133),(14972,1133),(14973,1134),(14974,1134),(14975,1134),(14976,1134),(14977,1135),(14978,1135),(14979,1135),(14980,1135),(14981,1136),(14982,1136),(14983,1136),(14984,1136),(14985,1137),(14986,1137),(14987,1137),(14988,1137),(14989,1138),(14990,1138),(14991,1138),(14992,1138),(14993,1139),(14994,1139),(14995,1139),(14996,1139),(14997,1140),(14998,1140),(14999,1140),(15000,1140),(15001,1140),(15002,1140),(15003,1140),(15004,1140),(15005,1140),(15006,1141),(15007,1141),(15008,1141),(15009,1141),(15010,1141),(15011,1141),(15012,1141),(15013,1141),(15014,1141),(15015,1142),(15016,1142),(15017,1142),(15018,1142),(15019,1142),(15020,1142),(15021,1142),(15022,1142),(15023,1142),(15024,1143),(15025,1143),(15026,1143),(15027,1143),(15028,1143),(15029,1143),(15030,1143),(15031,1143),(15032,1143),(15033,1144),(15034,1144),(15035,1144),(15036,1144),(15037,1144),(15038,1144),(15039,1144),(15040,1144),(15041,1144),(15042,1145),(15043,1145),(15044,1145),(15045,1145),(15046,1145),(15047,1145),(15048,1145),(15049,1145),(15050,1145),(15051,1146),(15052,1146),(15053,1146),(15054,1146),(15055,1146),(15056,1146),(15057,1146),(15058,1147),(15059,1147),(15060,1147),(15061,1147),(15062,1147),(15063,1147),(15064,1147),(15065,1148),(15066,1148),(15067,1148),(15068,1148),(15069,1148),(15070,1148),(15071,1148),(15072,1149),(15073,1149),(15074,1149),(15075,1149),(15076,1149),(15077,1149),(15078,1149),(15079,1149),(15080,1149),(15081,1150),(15082,1150),(15083,1150),(15084,1150),(15085,1150),(15086,1150),(15087,1150),(15088,1150),(15089,1150),(15090,1140),(15091,1140),(15092,1141),(15093,1141),(15094,1142),(15095,1142),(15096,1143),(15097,1143),(15098,1144),(15099,1144),(15100,1144),(15101,1145),(15102,1145),(15103,1145),(15104,1146),(15105,1146),(15106,1146),(15107,1147),(15108,1147),(15109,1147),(15110,1148),(15111,1148),(15112,1148),(15113,1149),(15114,1149),(15115,1150),(15116,1150),(15117,1140),(15118,1140),(15119,1140),(15120,1140),(15121,1141),(15122,1141),(15123,1141),(15124,1141),(15125,1142),(15126,1142),(15127,1142),(15128,1142),(15129,1143),(15130,1143),(15131,1143),(15132,1143),(15133,1144),(15134,1144),(15135,1144),(15136,1144),(15137,1145),(15138,1145),(15139,1145),(15140,1145),(15141,1146),(15142,1146),(15143,1146),(15144,1146),(15145,1147),(15146,1147),(15147,1147),(15148,1147),(15149,1148),(15150,1148),(15151,1148),(15152,1148),(15153,1149),(15154,1149),(15155,1149),(15156,1149),(15157,1150),(15158,1150),(15159,1150),(15160,1150),(15161,1151),(15162,1151),(15163,1151),(15164,1151),(15165,1151),(15166,1151),(15167,1152),(15168,1152),(15169,1152),(15170,1152),(15171,1152),(15172,1152),(15173,1152),(15174,1152),(15175,1152),(15176,1153),(15177,1153),(15178,1153),(15179,1153),(15180,1153),(15181,1153),(15182,1153),(15183,1153),(15184,1153),(15185,1154),(15186,1154),(15187,1154),(15188,1154),(15189,1154),(15190,1154),(15191,1154),(15192,1154),(15193,1154),(15194,1155),(15195,1155),(15196,1155),(15197,1155),(15198,1155),(15199,1155),(15200,1155),(15201,1155),(15202,1155),(15203,1156),(15204,1156),(15205,1156),(15206,1156),(15207,1156),(15208,1156),(15209,1156),(15210,1156),(15211,1156),(15212,1157),(15213,1157),(15214,1157),(15215,1157),(15216,1157),(15217,1157),(15218,1157),(15219,1157),(15220,1157),(15221,1158),(15222,1158),(15223,1158),(15224,1158),(15225,1158),(15226,1158),(15227,1158),(15228,1158),(15229,1158),(15230,1159),(15231,1159),(15232,1159),(15233,1159),(15234,1159),(15235,1159),(15236,1159),(15237,1160),(15238,1160),(15239,1160),(15240,1160),(15241,1160),(15242,1160),(15243,1160),(15244,1161),(15245,1161),(15246,1161),(15247,1161),(15248,1161),(15249,1161),(15250,1161),(15251,1151),(15252,1151),(15253,1151),(15254,1152),(15255,1152),(15256,1152),(15257,1153),(15258,1153),(15259,1153),(15260,1154),(15261,1154),(15262,1154),(15263,1155),(15264,1155),(15265,1155),(15266,1156),(15267,1156),(15268,1156),(15269,1157),(15270,1157),(15271,1157),(15272,1158),(15273,1158),(15274,1158),(15275,1159),(15276,1159),(15277,1159),(15278,1160),(15279,1160),(15280,1160),(15281,1161),(15282,1161),(15283,1161),(15284,1151),(15285,1151),(15286,1151),(15287,1151),(15288,1152),(15289,1152),(15290,1152),(15291,1152),(15292,1153),(15293,1153),(15294,1153),(15295,1153),(15296,1154),(15297,1154),(15298,1154),(15299,1154),(15300,1155),(15301,1155),(15302,1155),(15303,1155),(15304,1156),(15305,1156),(15306,1156),(15307,1156),(15308,1157),(15309,1157),(15310,1157),(15311,1157),(15312,1158),(15313,1158),(15314,1158),(15315,1158),(15316,1159),(15317,1159),(15318,1159),(15319,1159),(15320,1160),(15321,1160),(15322,1160),(15323,1160),(15324,1161),(15325,1161),(15326,1161),(15327,1161),(15328,1162),(15329,1162),(15330,1162),(15331,1162),(15332,1162),(15333,1162),(15334,1162),(15335,1162),(15336,1162),(15337,1162),(15338,1162),(15339,1162),(15340,1163),(15341,1163),(15342,1163),(15343,1163),(15344,1163),(15345,1163),(15346,1163),(15347,1163),(15348,1163),(15349,1163),(15350,1163),(15351,1163),(15352,1163),(15353,1163),(15354,1163),(15355,1163),(15356,1163),(15357,1163),(15358,1163),(15359,1163),(15360,1163),(15361,1164),(15362,1164),(15363,1164),(15364,1164),(15365,1164),(15366,1164),(15367,1164),(15368,1164),(15369,1164),(15370,1164),(15371,1164),(15372,1164),(15373,1164),(15374,1164),(15375,1164),(15376,1164),(15377,1164),(15378,1164),(15379,1164),(15380,1164),(15381,1164),(15382,1165),(15383,1165),(15384,1165),(15385,1165),(15386,1165),(15387,1165),(15388,1165),(15389,1165),(15390,1165),(15391,1165),(15392,1165),(15393,1165),(15394,1165),(15395,1165),(15396,1165),(15397,1165),(15398,1165),(15399,1165),(15400,1165),(15401,1165),(15402,1165),(15403,1166),(15404,1166),(15405,1166),(15406,1166),(15407,1166),(15408,1166),(15409,1166),(15410,1167),(15411,1167),(15412,1167),(15413,1167),(15414,1167),(15415,1167),(15416,1167),(15417,1168),(15418,1168),(15419,1168),(15420,1168),(15421,1168),(15422,1168),(15423,1168),(15424,1169),(15425,1169),(15426,1169),(15427,1169),(15428,1169),(15429,1169),(15430,1169),(15431,1170),(15432,1170),(15433,1170),(15434,1170),(15435,1170),(15436,1170),(15437,1170),(15438,1171),(15439,1171),(15440,1171),(15441,1171),(15442,1171),(15443,1171),(15444,1171),(15445,1172),(15446,1172),(15447,1172),(15448,1172),(15449,1172),(15450,1172),(15451,1172),(15452,1173),(15453,1173),(15454,1173),(15455,1173),(15456,1173),(15457,1173),(15458,1173),(15459,1174),(15460,1174),(15461,1174),(15462,1174),(15463,1174),(15464,1174),(15465,1174),(15466,1175),(15467,1175),(15468,1175),(15469,1175),(15470,1175),(15471,1175),(15472,1175),(15473,1176),(15474,1176),(15475,1176),(15476,1176),(15477,1176),(15478,1176),(15479,1176),(15480,1166),(15481,1166),(15482,1166),(15483,1167),(15484,1167),(15485,1167),(15486,1168),(15487,1168),(15488,1168),(15489,1169),(15490,1169),(15491,1169),(15492,1170),(15493,1170),(15494,1170),(15495,1171),(15496,1171),(15497,1171),(15498,1172),(15499,1172),(15500,1172),(15501,1173),(15502,1173),(15503,1173),(15504,1174),(15505,1174),(15506,1174),(15507,1175),(15508,1175),(15509,1175),(15510,1176),(15511,1176),(15512,1176),(15513,1166),(15514,1166),(15515,1166),(15516,1166),(15517,1167),(15518,1167),(15519,1167),(15520,1167),(15521,1168),(15522,1168),(15523,1168),(15524,1168),(15525,1169),(15526,1169),(15527,1169),(15528,1169),(15529,1170),(15530,1170),(15531,1170),(15532,1170),(15533,1171),(15534,1171),(15535,1171),(15536,1171),(15537,1172),(15538,1172),(15539,1172),(15540,1172),(15541,1173),(15542,1173),(15543,1173),(15544,1173),(15545,1174),(15546,1174),(15547,1174),(15548,1174),(15549,1175),(15550,1175),(15551,1175),(15552,1175),(15553,1176),(15554,1176),(15555,1176),(15556,1176),(15557,1177),(15558,1177),(15559,1177),(15560,1177),(15561,1177),(15562,1177),(15563,1177),(15564,1178),(15565,1178),(15566,1178),(15567,1178),(15568,1178),(15569,1178),(15570,1178),(15571,1179),(15572,1179),(15573,1179),(15574,1179),(15575,1179),(15576,1179),(15577,1179),(15578,1180),(15579,1180),(15580,1180),(15581,1180),(15582,1180),(15583,1180),(15584,1180),(15585,1181),(15586,1181),(15587,1181),(15588,1181),(15589,1181),(15590,1181),(15591,1181),(15592,1182),(15593,1182),(15594,1182),(15595,1182),(15596,1182),(15597,1182),(15598,1183),(15599,1183),(15600,1183),(15601,1183),(15602,1183),(15603,1183),(15604,1184),(15605,1184),(15606,1184),(15607,1184),(15608,1184),(15609,1184),(15610,1184),(15611,1185),(15612,1185),(15613,1185),(15614,1185),(15615,1185),(15616,1185),(15617,1185),(15618,1186),(15619,1186),(15620,1186),(15621,1186),(15622,1186),(15623,1186),(15624,1186),(15625,1187),(15626,1187),(15627,1187),(15628,1187),(15629,1187),(15630,1187),(15631,1187),(15632,1188),(15633,1188),(15634,1188),(15635,1188),(15636,1188),(15637,1188),(15638,1188),(15639,1189),(15640,1189),(15641,1189),(15642,1189),(15643,1189),(15644,1189),(15645,1189),(15646,1190),(15647,1190),(15648,1190),(15649,1190),(15650,1190),(15651,1190),(15652,1190),(15653,1191),(15654,1191),(15655,1191),(15656,1191),(15657,1191),(15658,1191),(15659,1191),(15660,1192),(15661,1192),(15662,1192),(15663,1192),(15664,1192),(15665,1192),(15666,1192),(15667,1193),(15668,1193),(15669,1193),(15670,1193),(15671,1193),(15672,1193),(15673,1193),(15674,1194),(15675,1194),(15676,1194),(15677,1194),(15678,1194),(15679,1194),(15680,1194),(15681,1195),(15682,1195),(15683,1195),(15684,1195),(15685,1195),(15686,1195),(15687,1195),(15688,1196),(15689,1196),(15690,1196),(15691,1196),(15692,1196),(15693,1196),(15694,1196),(15695,1197),(15696,1197),(15697,1197),(15698,1197),(15699,1197),(15700,1197),(15701,1197),(15702,1198),(15703,1198),(15704,1198),(15705,1198),(15706,1198),(15707,1198),(15708,1198),(15709,1199),(15710,1199),(15711,1199),(15712,1199),(15713,1199),(15714,1199),(15715,1199),(15716,1200),(15717,1200),(15718,1200),(15719,1200),(15720,1200),(15721,1200),(15722,1200),(15723,1201),(15724,1201),(15725,1201),(15726,1201),(15727,1201),(15728,1201),(15729,1201),(15730,1202),(15731,1202),(15732,1202),(15733,1202),(15734,1202),(15735,1202),(15736,1202),(15737,1203),(15738,1203),(15739,1203),(15740,1203),(15741,1203),(15742,1203),(15743,1203),(15744,1204),(15745,1204),(15746,1204),(15747,1204),(15748,1204),(15749,1204),(15750,1204),(15751,1205),(15752,1205),(15753,1205),(15754,1205),(15755,1205),(15756,1205),(15757,1205),(15758,1206),(15759,1206),(15760,1206),(15761,1206),(15762,1206),(15763,1206),(15764,1206),(15765,1207),(15766,1207),(15767,1207),(15768,1207),(15769,1207),(15770,1207),(15771,1207),(15772,1208),(15773,1208),(15774,1208),(15775,1208),(15776,1208),(15777,1208),(15778,1208),(15779,1209),(15780,1209),(15781,1209),(15782,1209),(15783,1209),(15784,1209),(15785,1209),(15786,1210),(15787,1210),(15788,1210),(15789,1210),(15790,1210),(15791,1210),(15792,1210),(15793,1210),(15794,1210),(15795,1211),(15796,1211),(15797,1211),(15798,1211),(15799,1211),(15800,1211),(15801,1211),(15802,1212),(15803,1212),(15804,1212),(15805,1212),(15806,1212),(15807,1212),(15808,1212),(15809,1213),(15810,1213),(15811,1213),(15812,1213),(15813,1213),(15814,1213),(15815,1213),(15816,1214),(15817,1214),(15818,1214),(15819,1214),(15820,1214),(15821,1214),(15822,1214),(15823,1215),(15824,1215),(15825,1215),(15826,1215),(15827,1215),(15828,1215),(15829,1215),(15830,1216),(15831,1216),(15832,1216),(15833,1216),(15834,1216),(15835,1216),(15836,1217),(15837,1217),(15838,1217),(15839,1217),(15840,1217),(15841,1217),(15842,1217),(15843,1218),(15844,1218),(15845,1218),(15846,1218),(15847,1218),(15848,1218),(15849,1218),(15850,1219),(15851,1219),(15852,1219),(15853,1219),(15854,1219),(15855,1219),(15856,1219),(15857,1220),(15858,1220),(15859,1220),(15860,1220),(15861,1220),(15862,1220),(15863,1220),(15864,1221),(15865,1221),(15866,1221),(15867,1221),(15868,1221),(15869,1221),(15870,1221),(15871,1222),(15872,1222),(15873,1222),(15874,1222),(15875,1222),(15876,1222),(15877,1222),(15878,1223),(15879,1223),(15880,1223),(15881,1223),(15882,1223),(15883,1223),(15884,1223),(15885,1224),(15886,1224),(15887,1224),(15888,1224),(15889,1224),(15890,1224),(15891,1224),(15892,1225),(15893,1225),(15894,1225),(15895,1225),(15896,1225),(15897,1225),(15898,1225),(15899,1226),(15900,1226),(15901,1226),(15902,1226),(15903,1226),(15904,1226),(15905,1226),(15906,1227),(15907,1227),(15908,1227),(15909,1227),(15910,1227),(15911,1227),(15912,1227),(15913,1228),(15914,1228),(15915,1228),(15916,1228),(15917,1228),(15918,1228),(15919,1228),(15920,1229),(15921,1229),(15922,1229),(15923,1229),(15924,1229),(15925,1229),(15926,1229),(15927,1230),(15928,1230),(15929,1230),(15930,1230),(15931,1230),(15932,1230),(15933,1230),(15934,1231),(15935,1231),(15936,1231),(15937,1231),(15938,1231),(15939,1231),(15940,1231),(15941,1232),(15942,1232),(15943,1232),(15944,1232),(15945,1232),(15946,1232),(15947,1232),(15948,1233),(15949,1233),(15950,1233),(15951,1233),(15952,1233),(15953,1233),(15954,1233),(15955,1234),(15956,1234),(15957,1234),(15958,1234),(15959,1234),(15960,1234),(15961,1234),(15962,1235),(15963,1235),(15964,1235),(15965,1235),(15966,1235),(15967,1235),(15968,1235),(15969,1236),(15970,1236),(15971,1236),(15972,1236),(15973,1236),(15974,1236),(15975,1236),(15976,1237),(15977,1237),(15978,1237),(15979,1237),(15980,1237),(15981,1237),(15982,1237),(15983,1238),(15984,1238),(15985,1238),(15986,1238),(15987,1238),(15988,1238),(15989,1238),(15990,1239),(15991,1239),(15992,1239),(15993,1239),(15994,1239),(15995,1239),(15996,1239),(15997,1240),(15998,1240),(15999,1240),(16000,1240),(16001,1240),(16002,1240),(16003,1240),(16004,1241),(16005,1241),(16006,1241),(16007,1241),(16008,1241),(16009,1241),(16010,1241),(16011,1242),(16012,1242),(16013,1242),(16014,1242),(16015,1242),(16016,1242),(16017,1242),(16018,1243),(16019,1243),(16020,1243),(16021,1243),(16022,1243),(16023,1243),(16024,1243),(16025,1244),(16026,1244),(16027,1244),(16028,1244),(16029,1244),(16030,1244),(16031,1244),(16032,1245),(16033,1245),(16034,1245),(16035,1245),(16036,1245),(16037,1245),(16038,1245),(16039,1246),(16040,1246),(16041,1246),(16042,1246),(16043,1246),(16044,1246),(16045,1246),(16046,1247),(16047,1247),(16048,1247),(16049,1247),(16050,1247),(16051,1247),(16052,1247),(16053,1248),(16054,1248),(16055,1248),(16056,1248),(16057,1248),(16058,1248),(16059,1248),(16060,1249),(16061,1249),(16062,1249),(16063,1249),(16064,1249),(16065,1249),(16066,1249),(16067,1250),(16068,1250),(16069,1250),(16070,1250),(16071,1250),(16072,1250),(16073,1250),(16074,1251),(16075,1251),(16076,1251),(16077,1251),(16078,1251),(16079,1251),(16080,1251),(16081,1252),(16082,1252),(16083,1252),(16084,1252),(16085,1252),(16086,1252),(16087,1252),(16088,1253),(16089,1253),(16090,1253),(16091,1253),(16092,1253),(16093,1253),(16094,1253),(16095,1254),(16096,1254),(16097,1254),(16098,1254),(16099,1254),(16100,1254),(16101,1254),(16102,1255),(16103,1255),(16104,1255),(16105,1255),(16106,1255),(16107,1255),(16108,1255),(16109,1256),(16110,1256),(16111,1256),(16112,1256),(16113,1256),(16114,1256),(16115,1256),(16116,1257),(16117,1257),(16118,1257),(16119,1257),(16120,1257),(16121,1257),(16122,1257),(16123,1258),(16124,1258),(16125,1258),(16126,1258),(16127,1258),(16128,1258),(16129,1258),(16130,1259),(16131,1259),(16132,1259),(16133,1259),(16134,1259),(16135,1259),(16136,1259),(16137,1260),(16138,1260),(16139,1260),(16140,1260),(16141,1260),(16142,1260),(16143,1260),(16144,1261),(16145,1261),(16146,1261),(16147,1261),(16148,1261),(16149,1261),(16150,1261),(16151,1262),(16152,1262),(16153,1262),(16154,1262),(16155,1262),(16156,1262),(16157,1262),(16158,1263),(16159,1263),(16160,1263),(16161,1263),(16162,1263),(16163,1263),(16164,1263),(16165,1264),(16166,1264),(16167,1264),(16168,1264),(16169,1264),(16170,1264),(16171,1264),(16172,1265),(16173,1265),(16174,1265),(16175,1265),(16176,1265),(16177,1265),(16178,1265),(16179,1177),(16180,1177),(16181,1177),(16182,1178),(16183,1178),(16184,1178),(16185,1179),(16186,1179),(16187,1179),(16188,1180),(16189,1180),(16190,1180),(16191,1181),(16192,1181),(16193,1181),(16194,1182),(16195,1182),(16196,1182),(16197,1183),(16198,1183),(16199,1183),(16200,1184),(16201,1184),(16202,1184),(16203,1185),(16204,1185),(16205,1185),(16206,1186),(16207,1186),(16208,1186),(16209,1187),(16210,1187),(16211,1187),(16212,1188),(16213,1188),(16214,1188),(16215,1189),(16216,1189),(16217,1189),(16218,1190),(16219,1190),(16220,1190),(16221,1191),(16222,1191),(16223,1191),(16224,1192),(16225,1192),(16226,1192),(16227,1193),(16228,1193),(16229,1193),(16230,1194),(16231,1194),(16232,1194),(16233,1195),(16234,1195),(16235,1195),(16236,1196),(16237,1196),(16238,1196),(16239,1197),(16240,1197),(16241,1197),(16242,1198),(16243,1198),(16244,1198),(16245,1199),(16246,1199),(16247,1199),(16248,1200),(16249,1200),(16250,1200),(16251,1201),(16252,1201),(16253,1201),(16254,1202),(16255,1202),(16256,1202),(16257,1203),(16258,1203),(16259,1203),(16260,1204),(16261,1204),(16262,1204),(16263,1205),(16264,1205),(16265,1205),(16266,1206),(16267,1206),(16268,1206),(16269,1207),(16270,1207),(16271,1207),(16272,1208),(16273,1208),(16274,1208),(16275,1209),(16276,1209),(16277,1209),(16278,1210),(16279,1210),(16280,1210),(16281,1211),(16282,1211),(16283,1211),(16284,1212),(16285,1212),(16286,1212),(16287,1213),(16288,1213),(16289,1213),(16290,1214),(16291,1214),(16292,1214),(16293,1215),(16294,1215),(16295,1215),(16296,1216),(16297,1216),(16298,1216),(16299,1217),(16300,1217),(16301,1217),(16302,1218),(16303,1218),(16304,1218),(16305,1219),(16306,1219),(16307,1219),(16308,1220),(16309,1220),(16310,1220),(16311,1221),(16312,1221),(16313,1221),(16314,1222),(16315,1222),(16316,1222),(16317,1223),(16318,1223),(16319,1223),(16320,1224),(16321,1224),(16322,1224),(16323,1225),(16324,1225),(16325,1225),(16326,1226),(16327,1226),(16328,1226),(16329,1227),(16330,1227),(16331,1227),(16332,1228),(16333,1228),(16334,1228),(16335,1229),(16336,1229),(16337,1229),(16338,1230),(16339,1230),(16340,1230),(16341,1231),(16342,1231),(16343,1231),(16344,1232),(16345,1232),(16346,1232),(16347,1233),(16348,1233),(16349,1233),(16350,1234),(16351,1234),(16352,1234),(16353,1235),(16354,1235),(16355,1235),(16356,1236),(16357,1236),(16358,1236),(16359,1237),(16360,1237),(16361,1237),(16362,1238),(16363,1238),(16364,1238),(16365,1239),(16366,1239),(16367,1239),(16368,1240),(16369,1240),(16370,1240),(16371,1241),(16372,1241),(16373,1241),(16374,1242),(16375,1242),(16376,1242),(16377,1243),(16378,1243),(16379,1243),(16380,1244),(16381,1244),(16382,1244),(16383,1245),(16384,1245),(16385,1245),(16386,1246),(16387,1246),(16388,1246),(16389,1247),(16390,1247),(16391,1247),(16392,1248),(16393,1248),(16394,1248),(16395,1249),(16396,1249),(16397,1249),(16398,1250),(16399,1250),(16400,1250),(16401,1251),(16402,1251),(16403,1251),(16404,1252),(16405,1252),(16406,1252),(16407,1253),(16408,1253),(16409,1253),(16410,1254),(16411,1254),(16412,1254),(16413,1255),(16414,1255),(16415,1255),(16416,1256),(16417,1256),(16418,1256),(16419,1257),(16420,1257),(16421,1257),(16422,1258),(16423,1258),(16424,1258),(16425,1259),(16426,1259),(16427,1259),(16428,1260),(16429,1260),(16430,1260),(16431,1261),(16432,1261),(16433,1261),(16434,1262),(16435,1262),(16436,1262),(16437,1263),(16438,1263),(16439,1263),(16440,1264),(16441,1264),(16442,1264),(16443,1265),(16444,1265),(16445,1265),(16446,1177),(16447,1177),(16448,1177),(16449,1177),(16450,1178),(16451,1178),(16452,1178),(16453,1178),(16454,1179),(16455,1179),(16456,1179),(16457,1179),(16458,1180),(16459,1180),(16460,1180),(16461,1180),(16462,1181),(16463,1181),(16464,1181),(16465,1181),(16466,1182),(16467,1182),(16468,1182),(16469,1182),(16470,1183),(16471,1183),(16472,1183),(16473,1183),(16474,1184),(16475,1184),(16476,1184),(16477,1184),(16478,1185),(16479,1185),(16480,1185),(16481,1185),(16482,1186),(16483,1186),(16484,1186),(16485,1186),(16486,1187),(16487,1187),(16488,1187),(16489,1187),(16490,1188),(16491,1188),(16492,1188),(16493,1188),(16494,1189),(16495,1189),(16496,1189),(16497,1189),(16498,1190),(16499,1190),(16500,1190),(16501,1190),(16502,1191),(16503,1191),(16504,1191),(16505,1191),(16506,1192),(16507,1192),(16508,1192),(16509,1192),(16510,1193),(16511,1193),(16512,1193),(16513,1193),(16514,1194),(16515,1194),(16516,1194),(16517,1194),(16518,1195),(16519,1195),(16520,1195),(16521,1195),(16522,1196),(16523,1196),(16524,1196),(16525,1196),(16526,1197),(16527,1197),(16528,1197),(16529,1197),(16530,1198),(16531,1198),(16532,1198),(16533,1198),(16534,1199),(16535,1199),(16536,1199),(16537,1199),(16538,1200),(16539,1200),(16540,1200),(16541,1200),(16542,1201),(16543,1201),(16544,1201),(16545,1201),(16546,1202),(16547,1202),(16548,1202),(16549,1202),(16550,1203),(16551,1203),(16552,1203),(16553,1203),(16554,1204),(16555,1204),(16556,1204),(16557,1204),(16558,1205),(16559,1205),(16560,1205),(16561,1205),(16562,1206),(16563,1206),(16564,1206),(16565,1206),(16566,1207),(16567,1207),(16568,1207),(16569,1207),(16570,1208),(16571,1208),(16572,1208),(16573,1208),(16574,1209),(16575,1209),(16576,1209),(16577,1209),(16578,1210),(16579,1210),(16580,1210),(16581,1210),(16582,1211),(16583,1211),(16584,1211),(16585,1211),(16586,1212),(16587,1212),(16588,1212),(16589,1212),(16590,1213),(16591,1213),(16592,1213),(16593,1213),(16594,1214),(16595,1214),(16596,1214),(16597,1214),(16598,1215),(16599,1215),(16600,1215),(16601,1215),(16602,1216),(16603,1216),(16604,1216),(16605,1216),(16606,1217),(16607,1217),(16608,1217),(16609,1217),(16610,1218),(16611,1218),(16612,1218),(16613,1218),(16614,1219),(16615,1219),(16616,1219),(16617,1219),(16618,1220),(16619,1220),(16620,1220),(16621,1220),(16622,1221),(16623,1221),(16624,1221),(16625,1221),(16626,1222),(16627,1222),(16628,1222),(16629,1222),(16630,1223),(16631,1223),(16632,1223),(16633,1223),(16634,1224),(16635,1224),(16636,1224),(16637,1224),(16638,1225),(16639,1225),(16640,1225),(16641,1225),(16642,1226),(16643,1226),(16644,1226),(16645,1226),(16646,1227),(16647,1227),(16648,1227),(16649,1227),(16650,1228),(16651,1228),(16652,1228),(16653,1228),(16654,1229),(16655,1229),(16656,1229),(16657,1229),(16658,1230),(16659,1230),(16660,1230),(16661,1230),(16662,1231),(16663,1231),(16664,1231),(16665,1231),(16666,1232),(16667,1232),(16668,1232),(16669,1232),(16670,1233),(16671,1233),(16672,1233),(16673,1233),(16674,1234),(16675,1234),(16676,1234),(16677,1234),(16678,1235),(16679,1235),(16680,1235),(16681,1235),(16682,1236),(16683,1236),(16684,1236),(16685,1236),(16686,1237),(16687,1237),(16688,1237),(16689,1237),(16690,1238),(16691,1238),(16692,1238),(16693,1238),(16694,1239),(16695,1239),(16696,1239),(16697,1239),(16698,1240),(16699,1240),(16700,1240),(16701,1240),(16702,1241),(16703,1241),(16704,1241),(16705,1241),(16706,1242),(16707,1242),(16708,1242),(16709,1242),(16710,1243),(16711,1243),(16712,1243),(16713,1243),(16714,1244),(16715,1244),(16716,1244),(16717,1244),(16718,1245),(16719,1245),(16720,1245),(16721,1245),(16722,1246),(16723,1246),(16724,1246),(16725,1246),(16726,1247),(16727,1247),(16728,1247),(16729,1247),(16730,1248),(16731,1248),(16732,1248),(16733,1248),(16734,1249),(16735,1249),(16736,1249),(16737,1249),(16738,1250),(16739,1250),(16740,1250),(16741,1250),(16742,1251),(16743,1251),(16744,1251),(16745,1251),(16746,1252),(16747,1252),(16748,1252),(16749,1252),(16750,1253),(16751,1253),(16752,1253),(16753,1253),(16754,1254),(16755,1254),(16756,1254),(16757,1254),(16758,1255),(16759,1255),(16760,1255),(16761,1255),(16762,1256),(16763,1256),(16764,1256),(16765,1256),(16766,1257),(16767,1257),(16768,1257),(16769,1257),(16770,1258),(16771,1258),(16772,1258),(16773,1258),(16774,1259),(16775,1259),(16776,1259),(16777,1259),(16778,1260),(16779,1260),(16780,1260),(16781,1260),(16782,1261),(16783,1261),(16784,1261),(16785,1261),(16786,1262),(16787,1262),(16788,1262),(16789,1262),(16790,1263),(16791,1263),(16792,1263),(16793,1263),(16794,1264),(16795,1264),(16796,1264),(16797,1264),(16798,1265),(16799,1265),(16800,1265),(16801,1265),(16802,1266),(16803,1266),(16804,1266),(16805,1266),(16806,1266),(16807,1266),(16808,1266),(16809,1267),(16810,1267),(16811,1267),(16812,1267),(16813,1267),(16814,1267),(16815,1267),(16816,1268),(16817,1268),(16818,1268),(16819,1268),(16820,1268),(16821,1268),(16822,1268),(16823,1269),(16824,1269),(16825,1269),(16826,1269),(16827,1269),(16828,1269),(16829,1269),(16830,1270),(16831,1270),(16832,1270),(16833,1270),(16834,1270),(16835,1270),(16836,1270),(16837,1271),(16838,1271),(16839,1271),(16840,1271),(16841,1271),(16842,1271),(16843,1271),(16844,1272),(16845,1272),(16846,1272),(16847,1272),(16848,1272),(16849,1272),(16850,1272),(16851,1273),(16852,1273),(16853,1273),(16854,1273),(16855,1273),(16856,1273),(16857,1273),(16858,1274),(16859,1274),(16860,1274),(16861,1274),(16862,1274),(16863,1274),(16864,1274),(16865,1275),(16866,1275),(16867,1275),(16868,1275),(16869,1275),(16870,1275),(16871,1275),(16872,1276),(16873,1276),(16874,1276),(16875,1276),(16876,1276),(16877,1276),(16878,1276),(16879,1277),(16880,1277),(16881,1277),(16882,1277),(16883,1277),(16884,1277),(16885,1277),(16886,1278),(16887,1278),(16888,1278),(16889,1278),(16890,1278),(16891,1278),(16892,1278),(16893,1279),(16894,1279),(16895,1279),(16896,1279),(16897,1279),(16898,1279),(16899,1279),(16900,1280),(16901,1280),(16902,1280),(16903,1280),(16904,1280),(16905,1280),(16906,1280),(16907,1281),(16908,1281),(16909,1281),(16910,1281),(16911,1281),(16912,1281),(16913,1281),(16914,1282),(16915,1282),(16916,1282),(16917,1282),(16918,1282),(16919,1282),(16920,1282),(16921,1283),(16922,1283),(16923,1283),(16924,1283),(16925,1283),(16926,1283),(16927,1283),(16928,1284),(16929,1284),(16930,1284),(16931,1284),(16932,1284),(16933,1284),(16934,1284),(16935,1285),(16936,1285),(16937,1285),(16938,1285),(16939,1285),(16940,1285),(16941,1285),(16942,1286),(16943,1286),(16944,1286),(16945,1286),(16946,1286),(16947,1286),(16948,1286),(16949,1287),(16950,1287),(16951,1287),(16952,1287),(16953,1287),(16954,1287),(16955,1287),(16956,1288),(16957,1288),(16958,1288),(16959,1288),(16960,1288),(16961,1288),(16962,1288),(16963,1289),(16964,1289),(16965,1289),(16966,1289),(16967,1289),(16968,1289),(16969,1289),(16970,1290),(16971,1290),(16972,1290),(16973,1290),(16974,1290),(16975,1290),(16976,1290),(16977,1291),(16978,1291),(16979,1291),(16980,1291),(16981,1291),(16982,1291),(16983,1291),(16984,1292),(16985,1292),(16986,1292),(16987,1292),(16988,1292),(16989,1292),(16990,1292),(16991,1293),(16992,1293),(16993,1293),(16994,1293),(16995,1293),(16996,1293),(16997,1293),(16998,1294),(16999,1294),(17000,1294),(17001,1294),(17002,1294),(17003,1294),(17004,1294),(17005,1295),(17006,1295),(17007,1295),(17008,1295),(17009,1295),(17010,1295),(17011,1295),(17012,1296),(17013,1296),(17014,1296),(17015,1296),(17016,1296),(17017,1296),(17018,1296),(17019,1297),(17020,1297),(17021,1297),(17022,1297),(17023,1297),(17024,1297),(17025,1297),(17026,1298),(17027,1298),(17028,1298),(17029,1298),(17030,1298),(17031,1298),(17032,1298),(17033,1299),(17034,1299),(17035,1299),(17036,1299),(17037,1299),(17038,1299),(17039,1299),(17040,1300),(17041,1300),(17042,1300),(17043,1300),(17044,1300),(17045,1300),(17046,1300),(17047,1301),(17048,1301),(17049,1301),(17050,1301),(17051,1301),(17052,1301),(17053,1301),(17054,1302),(17055,1302),(17056,1302),(17057,1302),(17058,1302),(17059,1302),(17060,1302),(17061,1303),(17062,1303),(17063,1303),(17064,1303),(17065,1303),(17066,1303),(17067,1303),(17068,1304),(17069,1304),(17070,1304),(17071,1304),(17072,1304),(17073,1304),(17074,1304),(17075,1305),(17076,1305),(17077,1305),(17078,1305),(17079,1305),(17080,1305),(17081,1305),(17082,1306),(17083,1306),(17084,1306),(17085,1306),(17086,1306),(17087,1306),(17088,1306),(17089,1307),(17090,1307),(17091,1307),(17092,1307),(17093,1307),(17094,1307),(17095,1307),(17096,1308),(17097,1308),(17098,1308),(17099,1308),(17100,1308),(17101,1308),(17102,1308),(17103,1309),(17104,1309),(17105,1309),(17106,1309),(17107,1309),(17108,1309),(17109,1309),(17110,1310),(17111,1310),(17112,1310),(17113,1310),(17114,1310),(17115,1310),(17116,1310),(17117,1311),(17118,1311),(17119,1311),(17120,1311),(17121,1311),(17122,1311),(17123,1311),(17124,1312),(17125,1312),(17126,1312),(17127,1312),(17128,1312),(17129,1312),(17130,1312),(17131,1313),(17132,1313),(17133,1313),(17134,1313),(17135,1313),(17136,1313),(17137,1313),(17138,1314),(17139,1314),(17140,1314),(17141,1314),(17142,1314),(17143,1314),(17144,1314),(17145,1315),(17146,1315),(17147,1315),(17148,1315),(17149,1315),(17150,1315),(17151,1315),(17152,1316),(17153,1316),(17154,1316),(17155,1316),(17156,1316),(17157,1316),(17158,1316),(17159,1317),(17160,1317),(17161,1317),(17162,1317),(17163,1317),(17164,1317),(17165,1317),(17166,1318),(17167,1318),(17168,1318),(17169,1318),(17170,1318),(17171,1318),(17172,1318),(17173,1319),(17174,1319),(17175,1319),(17176,1319),(17177,1319),(17178,1319),(17179,1319),(17180,1320),(17181,1320),(17182,1320),(17183,1320),(17184,1320),(17185,1320),(17186,1320),(17187,1321),(17188,1321),(17189,1321),(17190,1321),(17191,1321),(17192,1321),(17193,1321),(17194,1322),(17195,1322),(17196,1322),(17197,1322),(17198,1322),(17199,1322),(17200,1322),(17201,1323),(17202,1323),(17203,1323),(17204,1323),(17205,1323),(17206,1323),(17207,1323),(17208,1324),(17209,1324),(17210,1324),(17211,1324),(17212,1324),(17213,1324),(17214,1324),(17215,1325),(17216,1325),(17217,1325),(17218,1325),(17219,1325),(17220,1325),(17221,1325),(17222,1326),(17223,1326),(17224,1326),(17225,1326),(17226,1326),(17227,1326),(17228,1326),(17229,1327),(17230,1327),(17231,1327),(17232,1327),(17233,1327),(17234,1327),(17235,1327),(17236,1328),(17237,1328),(17238,1328),(17239,1328),(17240,1328),(17241,1328),(17242,1328),(17243,1329),(17244,1329),(17245,1329),(17246,1329),(17247,1329),(17248,1329),(17249,1329),(17250,1330),(17251,1330),(17252,1330),(17253,1330),(17254,1330),(17255,1330),(17256,1330),(17257,1331),(17258,1331),(17259,1331),(17260,1331),(17261,1331),(17262,1331),(17263,1331),(17264,1332),(17265,1332),(17266,1332),(17267,1332),(17268,1332),(17269,1332),(17270,1332),(17271,1333),(17272,1333),(17273,1333),(17274,1333),(17275,1333),(17276,1333),(17277,1333),(17278,1334),(17279,1334),(17280,1334),(17281,1334),(17282,1334),(17283,1334),(17284,1334),(17285,1335),(17286,1335),(17287,1335),(17288,1335),(17289,1335),(17290,1335),(17291,1335),(17292,1336),(17293,1336),(17294,1336),(17295,1336),(17296,1336),(17297,1336),(17298,1336),(17299,1337),(17300,1337),(17301,1337),(17302,1337),(17303,1337),(17304,1337),(17305,1337),(17306,1338),(17307,1338),(17308,1338),(17309,1338),(17310,1338),(17311,1338),(17312,1338),(17313,1339),(17314,1339),(17315,1339),(17316,1339),(17317,1339),(17318,1339),(17319,1339),(17320,1340),(17321,1340),(17322,1340),(17323,1340),(17324,1340),(17325,1340),(17326,1340),(17327,1341),(17328,1341),(17329,1341),(17330,1341),(17331,1341),(17332,1341),(17333,1341),(17334,1342),(17335,1342),(17336,1342),(17337,1342),(17338,1342),(17339,1342),(17340,1342),(17341,1343),(17342,1343),(17343,1343),(17344,1343),(17345,1343),(17346,1343),(17347,1343),(17348,1344),(17349,1344),(17350,1344),(17351,1344),(17352,1344),(17353,1344),(17354,1344),(17355,1345),(17356,1345),(17357,1345),(17358,1345),(17359,1345),(17360,1345),(17361,1345),(17362,1346),(17363,1346),(17364,1346),(17365,1346),(17366,1346),(17367,1346),(17368,1346),(17369,1347),(17370,1347),(17371,1347),(17372,1347),(17373,1347),(17374,1347),(17375,1347),(17376,1348),(17377,1348),(17378,1348),(17379,1348),(17380,1348),(17381,1348),(17382,1348),(17383,1349),(17384,1349),(17385,1349),(17386,1349),(17387,1349),(17388,1349),(17389,1349),(17390,1350),(17391,1350),(17392,1350),(17393,1350),(17394,1350),(17395,1350),(17396,1350),(17397,1351),(17398,1351),(17399,1351),(17400,1351),(17401,1351),(17402,1351),(17403,1351),(17404,1352),(17405,1352),(17406,1352),(17407,1352),(17408,1352),(17409,1352),(17410,1352),(17411,1353),(17412,1353),(17413,1353),(17414,1353),(17415,1353),(17416,1353),(17417,1353),(17418,1354),(17419,1354),(17420,1354),(17421,1354),(17422,1354),(17423,1354),(17424,1354),(17425,1355),(17426,1355),(17427,1355),(17428,1355),(17429,1355),(17430,1355),(17431,1355),(17432,1356),(17433,1356),(17434,1356),(17435,1356),(17436,1356),(17437,1356),(17438,1356),(17439,1357),(17440,1357),(17441,1357),(17442,1357),(17443,1357),(17444,1357),(17445,1357),(17446,1358),(17447,1358),(17448,1358),(17449,1358),(17450,1358),(17451,1358),(17452,1358),(17453,1359),(17454,1359),(17455,1359),(17456,1359),(17457,1359),(17458,1359),(17459,1359),(17460,1360),(17461,1360),(17462,1360),(17463,1360),(17464,1360),(17465,1360),(17466,1360),(17467,1361),(17468,1361),(17469,1361),(17470,1361),(17471,1361),(17472,1361),(17473,1361),(17474,1362),(17475,1362),(17476,1362),(17477,1362),(17478,1362),(17479,1362),(17480,1362),(17481,1363),(17482,1363),(17483,1363),(17484,1363),(17485,1363),(17486,1363),(17487,1363),(17488,1364),(17489,1364),(17490,1364),(17491,1364),(17492,1364),(17493,1364),(17494,1364),(17495,1365),(17496,1365),(17497,1365),(17498,1365),(17499,1365),(17500,1365),(17501,1365),(17502,1266),(17503,1266),(17504,1266),(17505,1267),(17506,1267),(17507,1267),(17508,1268),(17509,1268),(17510,1268),(17511,1269),(17512,1269),(17513,1269),(17514,1270),(17515,1270),(17516,1270),(17517,1271),(17518,1271),(17519,1271),(17520,1272),(17521,1272),(17522,1272),(17523,1273),(17524,1273),(17525,1273),(17526,1274),(17527,1274),(17528,1274),(17529,1275),(17530,1275),(17531,1275),(17532,1276),(17533,1276),(17534,1276),(17535,1277),(17536,1277),(17537,1277),(17538,1278),(17539,1278),(17540,1278),(17541,1279),(17542,1279),(17543,1279),(17544,1280),(17545,1280),(17546,1280),(17547,1281),(17548,1281),(17549,1281),(17550,1282),(17551,1282),(17552,1282),(17553,1283),(17554,1283),(17555,1283),(17556,1284),(17557,1284),(17558,1284),(17559,1285),(17560,1285),(17561,1285),(17562,1286),(17563,1286),(17564,1286),(17565,1287),(17566,1287),(17567,1287),(17568,1288),(17569,1288),(17570,1288),(17571,1289),(17572,1289),(17573,1289),(17574,1290),(17575,1290),(17576,1290),(17577,1291),(17578,1291),(17579,1291),(17580,1292),(17581,1292),(17582,1292),(17583,1293),(17584,1293),(17585,1293),(17586,1294),(17587,1294),(17588,1294),(17589,1295),(17590,1295),(17591,1295),(17592,1296),(17593,1296),(17594,1296),(17595,1297),(17596,1297),(17597,1297),(17598,1298),(17599,1298),(17600,1298),(17601,1299),(17602,1299),(17603,1299),(17604,1300),(17605,1300),(17606,1300),(17607,1301),(17608,1301),(17609,1301),(17610,1302),(17611,1302),(17612,1302),(17613,1303),(17614,1303),(17615,1303),(17616,1304),(17617,1304),(17618,1304),(17619,1305),(17620,1305),(17621,1305),(17622,1306),(17623,1306),(17624,1306),(17625,1307),(17626,1307),(17627,1307),(17628,1308),(17629,1308),(17630,1308),(17631,1309),(17632,1309),(17633,1309),(17634,1310),(17635,1310),(17636,1310),(17637,1311),(17638,1311),(17639,1311),(17640,1312),(17641,1312),(17642,1312),(17643,1313),(17644,1313),(17645,1313),(17646,1314),(17647,1314),(17648,1314),(17649,1315),(17650,1315),(17651,1315),(17652,1316),(17653,1316),(17654,1316),(17655,1317),(17656,1317),(17657,1317),(17658,1318),(17659,1318),(17660,1318),(17661,1319),(17662,1319),(17663,1319),(17664,1320),(17665,1320),(17666,1320),(17667,1321),(17668,1321),(17669,1321),(17670,1322),(17671,1322),(17672,1322),(17673,1323),(17674,1323),(17675,1323),(17676,1324),(17677,1324),(17678,1324),(17679,1325),(17680,1325),(17681,1325),(17682,1326),(17683,1326),(17684,1326),(17685,1327),(17686,1327),(17687,1327),(17688,1328),(17689,1328),(17690,1328),(17691,1329),(17692,1329),(17693,1329),(17694,1330),(17695,1330),(17696,1330),(17697,1331),(17698,1331),(17699,1331),(17700,1332),(17701,1332),(17702,1332),(17703,1333),(17704,1333),(17705,1333),(17706,1334),(17707,1334),(17708,1334),(17709,1335),(17710,1335),(17711,1335),(17712,1336),(17713,1336),(17714,1336),(17715,1337),(17716,1337),(17717,1337),(17718,1338),(17719,1338),(17720,1338),(17721,1339),(17722,1339),(17723,1339),(17724,1340),(17725,1340),(17726,1340),(17727,1341),(17728,1341),(17729,1341),(17730,1342),(17731,1342),(17732,1342),(17733,1343),(17734,1343),(17735,1343),(17736,1344),(17737,1344),(17738,1344),(17739,1345),(17740,1345),(17741,1345),(17742,1346),(17743,1346),(17744,1346),(17745,1347),(17746,1347),(17747,1347),(17748,1348),(17749,1348),(17750,1348),(17751,1349),(17752,1349),(17753,1349),(17754,1350),(17755,1350),(17756,1350),(17757,1351),(17758,1351),(17759,1351),(17760,1352),(17761,1352),(17762,1352),(17763,1353),(17764,1353),(17765,1353),(17766,1354),(17767,1354),(17768,1354),(17769,1355),(17770,1355),(17771,1355),(17772,1356),(17773,1356),(17774,1356),(17775,1357),(17776,1357),(17777,1357),(17778,1358),(17779,1358),(17780,1358),(17781,1359),(17782,1359),(17783,1359),(17784,1360),(17785,1360),(17786,1360),(17787,1361),(17788,1361),(17789,1361),(17790,1362),(17791,1362),(17792,1362),(17793,1363),(17794,1363),(17795,1363),(17796,1364),(17797,1364),(17798,1364),(17799,1365),(17800,1365),(17801,1365),(17802,1266),(17803,1266),(17804,1266),(17805,1266),(17806,1267),(17807,1267),(17808,1267),(17809,1267),(17810,1268),(17811,1268),(17812,1268),(17813,1268),(17814,1269),(17815,1269),(17816,1269),(17817,1269),(17818,1270),(17819,1270),(17820,1270),(17821,1270),(17822,1271),(17823,1271),(17824,1271),(17825,1271),(17826,1272),(17827,1272),(17828,1272),(17829,1272),(17830,1273),(17831,1273),(17832,1273),(17833,1273),(17834,1274),(17835,1274),(17836,1274),(17837,1274),(17838,1275),(17839,1275),(17840,1275),(17841,1275),(17842,1276),(17843,1276),(17844,1276),(17845,1276),(17846,1277),(17847,1277),(17848,1277),(17849,1277),(17850,1278),(17851,1278),(17852,1278),(17853,1278),(17854,1279),(17855,1279),(17856,1279),(17857,1279),(17858,1280),(17859,1280),(17860,1280),(17861,1280),(17862,1281),(17863,1281),(17864,1281),(17865,1281),(17866,1282),(17867,1282),(17868,1282),(17869,1282),(17870,1283),(17871,1283),(17872,1283),(17873,1283),(17874,1284),(17875,1284),(17876,1284),(17877,1284),(17878,1285),(17879,1285),(17880,1285),(17881,1285),(17882,1286),(17883,1286),(17884,1286),(17885,1286),(17886,1287),(17887,1287),(17888,1287),(17889,1287),(17890,1288),(17891,1288),(17892,1288),(17893,1288),(17894,1289),(17895,1289),(17896,1289),(17897,1289),(17898,1290),(17899,1290),(17900,1290),(17901,1290),(17902,1291),(17903,1291),(17904,1291),(17905,1291),(17906,1292),(17907,1292),(17908,1292),(17909,1292),(17910,1293),(17911,1293),(17912,1293),(17913,1293),(17914,1294),(17915,1294),(17916,1294),(17917,1294),(17918,1295),(17919,1295),(17920,1295),(17921,1295),(17922,1296),(17923,1296),(17924,1296),(17925,1296),(17926,1297),(17927,1297),(17928,1297),(17929,1297),(17930,1298),(17931,1298),(17932,1298),(17933,1298),(17934,1299),(17935,1299),(17936,1299),(17937,1299),(17938,1300),(17939,1300),(17940,1300),(17941,1300),(17942,1301),(17943,1301),(17944,1301),(17945,1301),(17946,1302),(17947,1302),(17948,1302),(17949,1302),(17950,1303),(17951,1303),(17952,1303),(17953,1303),(17954,1304),(17955,1304),(17956,1304),(17957,1304),(17958,1305),(17959,1305),(17960,1305),(17961,1305),(17962,1306),(17963,1306),(17964,1306),(17965,1306),(17966,1307),(17967,1307),(17968,1307),(17969,1307),(17970,1308),(17971,1308),(17972,1308),(17973,1308),(17974,1309),(17975,1309),(17976,1309),(17977,1309),(17978,1310),(17979,1310),(17980,1310),(17981,1310),(17982,1311),(17983,1311),(17984,1311),(17985,1311),(17986,1312),(17987,1312),(17988,1312),(17989,1312),(17990,1313),(17991,1313),(17992,1313),(17993,1313),(17994,1314),(17995,1314),(17996,1314),(17997,1314),(17998,1315),(17999,1315),(18000,1315),(18001,1315),(18002,1316),(18003,1316),(18004,1316),(18005,1316),(18006,1317),(18007,1317),(18008,1317),(18009,1317),(18010,1318),(18011,1318),(18012,1318),(18013,1318),(18014,1319),(18015,1319),(18016,1319),(18017,1319),(18018,1320),(18019,1320),(18020,1320),(18021,1320),(18022,1321),(18023,1321),(18024,1321),(18025,1321),(18026,1322),(18027,1322),(18028,1322),(18029,1322),(18030,1323),(18031,1323),(18032,1323),(18033,1323),(18034,1324),(18035,1324),(18036,1324),(18037,1324),(18038,1325),(18039,1325),(18040,1325),(18041,1325),(18042,1326),(18043,1326),(18044,1326),(18045,1326),(18046,1327),(18047,1327),(18048,1327),(18049,1327),(18050,1328),(18051,1328),(18052,1328),(18053,1328),(18054,1329),(18055,1329),(18056,1329),(18057,1329),(18058,1330),(18059,1330),(18060,1330),(18061,1330),(18062,1331),(18063,1331),(18064,1331),(18065,1331),(18066,1332),(18067,1332),(18068,1332),(18069,1332),(18070,1333),(18071,1333),(18072,1333),(18073,1333),(18074,1334),(18075,1334),(18076,1334),(18077,1334),(18078,1335),(18079,1335),(18080,1335),(18081,1335),(18082,1336),(18083,1336),(18084,1336),(18085,1336),(18086,1337),(18087,1337),(18088,1337),(18089,1337),(18090,1338),(18091,1338),(18092,1338),(18093,1338),(18094,1339),(18095,1339),(18096,1339),(18097,1339),(18098,1340),(18099,1340),(18100,1340),(18101,1340),(18102,1341),(18103,1341),(18104,1341),(18105,1341),(18106,1342),(18107,1342),(18108,1342),(18109,1342),(18110,1343),(18111,1343),(18112,1343),(18113,1343),(18114,1344),(18115,1344),(18116,1344),(18117,1344),(18118,1345),(18119,1345),(18120,1345),(18121,1345),(18122,1346),(18123,1346),(18124,1346),(18125,1346),(18126,1347),(18127,1347),(18128,1347),(18129,1347),(18130,1348),(18131,1348),(18132,1348),(18133,1348),(18134,1349),(18135,1349),(18136,1349),(18137,1349),(18138,1350),(18139,1350),(18140,1350),(18141,1350),(18142,1351),(18143,1351),(18144,1351),(18145,1351),(18146,1352),(18147,1352),(18148,1352),(18149,1352),(18150,1353),(18151,1353),(18152,1353),(18153,1353),(18154,1354),(18155,1354),(18156,1354),(18157,1354),(18158,1355),(18159,1355),(18160,1355),(18161,1355),(18162,1356),(18163,1356),(18164,1356),(18165,1356),(18166,1357),(18167,1357),(18168,1357),(18169,1357),(18170,1358),(18171,1358),(18172,1358),(18173,1358),(18174,1359),(18175,1359),(18176,1359),(18177,1359),(18178,1360),(18179,1360),(18180,1360),(18181,1360),(18182,1361),(18183,1361),(18184,1361),(18185,1361),(18186,1362),(18187,1362),(18188,1362),(18189,1362),(18190,1363),(18191,1363),(18192,1363),(18193,1363),(18194,1364),(18195,1364),(18196,1364),(18197,1364),(18198,1365),(18199,1365),(18200,1365),(18201,1365),(18202,1366),(18203,1366),(18204,1366),(18205,1366),(18206,1366),(18207,1366),(18208,1366),(18209,1367),(18210,1367),(18211,1367),(18212,1367),(18213,1367),(18214,1367),(18215,1367),(18216,1368),(18217,1368),(18218,1368),(18219,1368),(18220,1368),(18221,1368),(18222,1368),(18223,1369),(18224,1369),(18225,1369),(18226,1369),(18227,1369),(18228,1369),(18229,1369),(18230,1370),(18231,1370),(18232,1370),(18233,1370),(18234,1370),(18235,1370),(18236,1370),(18237,1371),(18238,1371),(18239,1371),(18240,1371),(18241,1371),(18242,1371),(18243,1371),(18244,1372),(18245,1372),(18246,1372),(18247,1372),(18248,1372),(18249,1372),(18250,1372),(18251,1373),(18252,1373),(18253,1373),(18254,1373),(18255,1373),(18256,1373),(18257,1373),(18258,1374),(18259,1374),(18260,1374),(18261,1374),(18262,1374),(18263,1374),(18264,1374),(18265,1375),(18266,1375),(18267,1375),(18268,1375),(18269,1375),(18270,1375),(18271,1375),(18272,1376),(18273,1376),(18274,1376),(18275,1376),(18276,1376),(18277,1376),(18278,1376),(18279,1377),(18280,1377),(18281,1377),(18282,1377),(18283,1377),(18284,1377),(18285,1377),(18286,1378),(18287,1378),(18288,1378),(18289,1378),(18290,1378),(18291,1378),(18292,1378),(18293,1379),(18294,1379),(18295,1379),(18296,1379),(18297,1379),(18298,1379),(18299,1379),(18300,1380),(18301,1380),(18302,1380),(18303,1380),(18304,1380),(18305,1380),(18306,1380),(18307,1381),(18308,1381),(18309,1381),(18310,1381),(18311,1381),(18312,1381),(18313,1381),(18314,1382),(18315,1382),(18316,1382),(18317,1382),(18318,1382),(18319,1382),(18320,1382),(18321,1383),(18322,1383),(18323,1383),(18324,1383),(18325,1383),(18326,1383),(18327,1383),(18328,1384),(18329,1384),(18330,1384),(18331,1384),(18332,1384),(18333,1384),(18334,1384),(18335,1385),(18336,1385),(18337,1385),(18338,1385),(18339,1385),(18340,1385),(18341,1385),(18342,1386),(18343,1386),(18344,1386),(18345,1386),(18346,1386),(18347,1386),(18348,1386),(18349,1387),(18350,1387),(18351,1387),(18352,1387),(18353,1387),(18354,1387),(18355,1387),(18356,1388),(18357,1388),(18358,1388),(18359,1388),(18360,1388),(18361,1388),(18362,1388),(18363,1389),(18364,1389),(18365,1389),(18366,1389),(18367,1389),(18368,1389),(18369,1389),(18370,1390),(18371,1390),(18372,1390),(18373,1390),(18374,1390),(18375,1390),(18376,1390),(18377,1391),(18378,1391),(18379,1391),(18380,1391),(18381,1391),(18382,1391),(18383,1391),(18384,1392),(18385,1392),(18386,1392),(18387,1392),(18388,1392),(18389,1392),(18390,1392),(18391,1393),(18392,1393),(18393,1393),(18394,1393),(18395,1393),(18396,1393),(18397,1393),(18398,1394),(18399,1394),(18400,1394),(18401,1394),(18402,1394),(18403,1394),(18404,1394),(18405,1395),(18406,1395),(18407,1395),(18408,1395),(18409,1395),(18410,1395),(18411,1395),(18412,1396),(18413,1396),(18414,1396),(18415,1396),(18416,1396),(18417,1396),(18418,1396),(18419,1397),(18420,1397),(18421,1397),(18422,1397),(18423,1397),(18424,1397),(18425,1397),(18426,1398),(18427,1398),(18428,1398),(18429,1398),(18430,1398),(18431,1398),(18432,1398),(18433,1399),(18434,1399),(18435,1399),(18436,1399),(18437,1399),(18438,1399),(18439,1399),(18440,1400),(18441,1400),(18442,1400),(18443,1400),(18444,1400),(18445,1400),(18446,1400),(18447,1401),(18448,1401),(18449,1401),(18450,1401),(18451,1401),(18452,1401),(18453,1401),(18454,1402),(18455,1402),(18456,1402),(18457,1402),(18458,1402),(18459,1402),(18460,1402),(18461,1403),(18462,1403),(18463,1403),(18464,1403),(18465,1403),(18466,1403),(18467,1403),(18468,1404),(18469,1404),(18470,1404),(18471,1404),(18472,1404),(18473,1404),(18474,1404),(18475,1405),(18476,1405),(18477,1405),(18478,1405),(18479,1405),(18480,1405),(18481,1405),(18482,1406),(18483,1406),(18484,1406),(18485,1406),(18486,1406),(18487,1406),(18488,1406),(18489,1407),(18490,1407),(18491,1407),(18492,1407),(18493,1407),(18494,1407),(18495,1407),(18496,1408),(18497,1408),(18498,1408),(18499,1408),(18500,1408),(18501,1408),(18502,1408),(18503,1409),(18504,1409),(18505,1409),(18506,1409),(18507,1409),(18508,1409),(18509,1409),(18510,1410),(18511,1410),(18512,1410),(18513,1410),(18514,1410),(18515,1410),(18516,1410),(18517,1411),(18518,1411),(18519,1411),(18520,1411),(18521,1411),(18522,1411),(18523,1411),(18524,1412),(18525,1412),(18526,1412),(18527,1412),(18528,1412),(18529,1412),(18530,1412),(18531,1413),(18532,1413),(18533,1413),(18534,1413),(18535,1413),(18536,1413),(18537,1413),(18538,1414),(18539,1414),(18540,1414),(18541,1414),(18542,1414),(18543,1414),(18544,1414),(18545,1415),(18546,1415),(18547,1415),(18548,1415),(18549,1415),(18550,1415),(18551,1415),(18552,1416),(18553,1416),(18554,1416),(18555,1416),(18556,1416),(18557,1416),(18558,1416),(18559,1417),(18560,1417),(18561,1417),(18562,1417),(18563,1417),(18564,1417),(18565,1417),(18566,1418),(18567,1418),(18568,1418),(18569,1418),(18570,1418),(18571,1418),(18572,1418),(18573,1419),(18574,1419),(18575,1419),(18576,1419),(18577,1419),(18578,1419),(18579,1419),(18580,1420),(18581,1420),(18582,1420),(18583,1420),(18584,1420),(18585,1420),(18586,1420),(18587,1421),(18588,1421),(18589,1421),(18590,1421),(18591,1421),(18592,1421),(18593,1421),(18594,1422),(18595,1422),(18596,1422),(18597,1422),(18598,1422),(18599,1422),(18600,1422),(18601,1423),(18602,1423),(18603,1423),(18604,1423),(18605,1423),(18606,1423),(18607,1423),(18608,1424),(18609,1424),(18610,1424),(18611,1424),(18612,1424),(18613,1424),(18614,1424),(18615,1425),(18616,1425),(18617,1425),(18618,1425),(18619,1425),(18620,1425),(18621,1425),(18622,1426),(18623,1426),(18624,1426),(18625,1426),(18626,1426),(18627,1426),(18628,1426),(18629,1427),(18630,1427),(18631,1427),(18632,1427),(18633,1427),(18634,1427),(18635,1427),(18636,1428),(18637,1428),(18638,1428),(18639,1428),(18640,1428),(18641,1428),(18642,1428),(18643,1429),(18644,1429),(18645,1429),(18646,1429),(18647,1429),(18648,1429),(18649,1429),(18650,1430),(18651,1430),(18652,1430),(18653,1430),(18654,1430),(18655,1430),(18656,1430),(18657,1431),(18658,1431),(18659,1431),(18660,1431),(18661,1431),(18662,1431),(18663,1431),(18664,1432),(18665,1432),(18666,1432),(18667,1432),(18668,1432),(18669,1432),(18670,1432),(18671,1433),(18672,1433),(18673,1433),(18674,1433),(18675,1433),(18676,1433),(18677,1433),(18678,1434),(18679,1434),(18680,1434),(18681,1434),(18682,1434),(18683,1434),(18684,1434),(18685,1435),(18686,1435),(18687,1435),(18688,1435),(18689,1435),(18690,1435),(18691,1435),(18692,1436),(18693,1436),(18694,1436),(18695,1436),(18696,1436),(18697,1436),(18698,1436),(18699,1437),(18700,1437),(18701,1437),(18702,1437),(18703,1437),(18704,1437),(18705,1437),(18706,1438),(18707,1438),(18708,1438),(18709,1438),(18710,1438),(18711,1438),(18712,1438),(18713,1439),(18714,1439),(18715,1439),(18716,1439),(18717,1439),(18718,1439),(18719,1439),(18720,1440),(18721,1440),(18722,1440),(18723,1440),(18724,1440),(18725,1440),(18726,1440),(18727,1441),(18728,1441),(18729,1441),(18730,1441),(18731,1441),(18732,1441),(18733,1441),(18734,1442),(18735,1442),(18736,1442),(18737,1442),(18738,1442),(18739,1442),(18740,1442),(18741,1443),(18742,1443),(18743,1443),(18744,1443),(18745,1443),(18746,1443),(18747,1443),(18748,1444),(18749,1444),(18750,1444),(18751,1444),(18752,1444),(18753,1444),(18754,1444),(18755,1445),(18756,1445),(18757,1445),(18758,1445),(18759,1445),(18760,1445),(18761,1445),(18762,1446),(18763,1446),(18764,1446),(18765,1446),(18766,1446),(18767,1446),(18768,1446),(18769,1447),(18770,1447),(18771,1447),(18772,1447),(18773,1447),(18774,1447),(18775,1447),(18776,1448),(18777,1448),(18778,1448),(18779,1448),(18780,1448),(18781,1448),(18782,1448),(18783,1449),(18784,1449),(18785,1449),(18786,1449),(18787,1449),(18788,1449),(18789,1449),(18790,1450),(18791,1450),(18792,1450),(18793,1450),(18794,1450),(18795,1450),(18796,1450),(18797,1451),(18798,1451),(18799,1451),(18800,1451),(18801,1451),(18802,1451),(18803,1451),(18804,1452),(18805,1452),(18806,1452),(18807,1452),(18808,1452),(18809,1452),(18810,1452),(18811,1453),(18812,1453),(18813,1453),(18814,1453),(18815,1453),(18816,1453),(18817,1453),(18818,1454),(18819,1454),(18820,1454),(18821,1454),(18822,1454),(18823,1454),(18824,1454),(18825,1455),(18826,1455),(18827,1455),(18828,1455),(18829,1455),(18830,1455),(18831,1455),(18832,1456),(18833,1456),(18834,1456),(18835,1456),(18836,1456),(18837,1456),(18838,1456),(18839,1457),(18840,1457),(18841,1457),(18842,1457),(18843,1457),(18844,1457),(18845,1457),(18846,1458),(18847,1458),(18848,1458),(18849,1458),(18850,1458),(18851,1458),(18852,1458),(18853,1459),(18854,1459),(18855,1459),(18856,1459),(18857,1459),(18858,1459),(18859,1459),(18860,1460),(18861,1460),(18862,1460),(18863,1460),(18864,1460),(18865,1460),(18866,1460),(18867,1461),(18868,1461),(18869,1461),(18870,1461),(18871,1461),(18872,1461),(18873,1461),(18874,1462),(18875,1462),(18876,1462),(18877,1462),(18878,1462),(18879,1462),(18880,1462),(18881,1463),(18882,1463),(18883,1463),(18884,1463),(18885,1463),(18886,1463),(18887,1463),(18888,1464),(18889,1464),(18890,1464),(18891,1464),(18892,1464),(18893,1464),(18894,1464),(18895,1465),(18896,1465),(18897,1465),(18898,1465),(18899,1465),(18900,1465),(18901,1465),(18902,1366),(18903,1366),(18904,1366),(18905,1367),(18906,1367),(18907,1367),(18908,1368),(18909,1368),(18910,1368),(18911,1369),(18912,1369),(18913,1369),(18914,1370),(18915,1370),(18916,1370),(18917,1371),(18918,1371),(18919,1371),(18920,1372),(18921,1372),(18922,1372),(18923,1373),(18924,1373),(18925,1373),(18926,1374),(18927,1374),(18928,1374),(18929,1375),(18930,1375),(18931,1375),(18932,1376),(18933,1376),(18934,1376),(18935,1377),(18936,1377),(18937,1377),(18938,1378),(18939,1378),(18940,1378),(18941,1379),(18942,1379),(18943,1379),(18944,1380),(18945,1380),(18946,1380),(18947,1381),(18948,1381),(18949,1381),(18950,1382),(18951,1382),(18952,1382),(18953,1383),(18954,1383),(18955,1383),(18956,1384),(18957,1384),(18958,1384),(18959,1385),(18960,1385),(18961,1385),(18962,1386),(18963,1386),(18964,1386),(18965,1387),(18966,1387),(18967,1387),(18968,1388),(18969,1388),(18970,1388),(18971,1389),(18972,1389),(18973,1389),(18974,1390),(18975,1390),(18976,1390),(18977,1391),(18978,1391),(18979,1391),(18980,1392),(18981,1392),(18982,1392),(18983,1393),(18984,1393),(18985,1393),(18986,1394),(18987,1394),(18988,1394),(18989,1395),(18990,1395),(18991,1395),(18992,1396),(18993,1396),(18994,1396),(18995,1397),(18996,1397),(18997,1397),(18998,1398),(18999,1398),(19000,1398),(19001,1399),(19002,1399),(19003,1399),(19004,1400),(19005,1400),(19006,1400),(19007,1401),(19008,1401),(19009,1401),(19010,1402),(19011,1402),(19012,1402),(19013,1403),(19014,1403),(19015,1403),(19016,1404),(19017,1404),(19018,1404),(19019,1405),(19020,1405),(19021,1405),(19022,1406),(19023,1406),(19024,1406),(19025,1407),(19026,1407),(19027,1407),(19028,1408),(19029,1408),(19030,1408),(19031,1409),(19032,1409),(19033,1409),(19034,1410),(19035,1410),(19036,1410),(19037,1411),(19038,1411),(19039,1411),(19040,1412),(19041,1412),(19042,1412),(19043,1413),(19044,1413),(19045,1413),(19046,1414),(19047,1414),(19048,1414),(19049,1415),(19050,1415),(19051,1415),(19052,1416),(19053,1416),(19054,1416),(19055,1417),(19056,1417),(19057,1417),(19058,1418),(19059,1418),(19060,1418),(19061,1419),(19062,1419),(19063,1419),(19064,1420),(19065,1420),(19066,1420),(19067,1421),(19068,1421),(19069,1421),(19070,1422),(19071,1422),(19072,1422),(19073,1423),(19074,1423),(19075,1423),(19076,1424),(19077,1424),(19078,1424),(19079,1425),(19080,1425),(19081,1425),(19082,1426),(19083,1426),(19084,1426),(19085,1427),(19086,1427),(19087,1427),(19088,1428),(19089,1428),(19090,1428),(19091,1429),(19092,1429),(19093,1429),(19094,1430),(19095,1430),(19096,1430),(19097,1431),(19098,1431),(19099,1431),(19100,1432),(19101,1432),(19102,1432),(19103,1433),(19104,1433),(19105,1433),(19106,1434),(19107,1434),(19108,1434),(19109,1435),(19110,1435),(19111,1435),(19112,1436),(19113,1436),(19114,1436),(19115,1437),(19116,1437),(19117,1437),(19118,1438),(19119,1438),(19120,1438),(19121,1439),(19122,1439),(19123,1439),(19124,1440),(19125,1440),(19126,1440),(19127,1441),(19128,1441),(19129,1441),(19130,1442),(19131,1442),(19132,1442),(19133,1443),(19134,1443),(19135,1443),(19136,1444),(19137,1444),(19138,1444),(19139,1445),(19140,1445),(19141,1445),(19142,1446),(19143,1446),(19144,1446),(19145,1447),(19146,1447),(19147,1447),(19148,1448),(19149,1448),(19150,1448),(19151,1449),(19152,1449),(19153,1449),(19154,1450),(19155,1450),(19156,1450),(19157,1451),(19158,1451),(19159,1451),(19160,1452),(19161,1452),(19162,1452),(19163,1453),(19164,1453),(19165,1453),(19166,1454),(19167,1454),(19168,1454),(19169,1455),(19170,1455),(19171,1455),(19172,1456),(19173,1456),(19174,1456),(19175,1457),(19176,1457),(19177,1457),(19178,1458),(19179,1458),(19180,1458),(19181,1459),(19182,1459),(19183,1459),(19184,1460),(19185,1460),(19186,1460),(19187,1461),(19188,1461),(19189,1461),(19190,1462),(19191,1462),(19192,1462),(19193,1463),(19194,1463),(19195,1463),(19196,1464),(19197,1464),(19198,1464),(19199,1465),(19200,1465),(19201,1465),(19202,1366),(19203,1366),(19204,1366),(19205,1366),(19206,1367),(19207,1367),(19208,1367),(19209,1367),(19210,1368),(19211,1368),(19212,1368),(19213,1368),(19214,1369),(19215,1369),(19216,1369),(19217,1369),(19218,1370),(19219,1370),(19220,1370),(19221,1370),(19222,1371),(19223,1371),(19224,1371),(19225,1371),(19226,1372),(19227,1372),(19228,1372),(19229,1372),(19230,1373),(19231,1373),(19232,1373),(19233,1373),(19234,1374),(19235,1374),(19236,1374),(19237,1374),(19238,1375),(19239,1375),(19240,1375),(19241,1375),(19242,1376),(19243,1376),(19244,1376),(19245,1376),(19246,1377),(19247,1377),(19248,1377),(19249,1377),(19250,1378),(19251,1378),(19252,1378),(19253,1378),(19254,1379),(19255,1379),(19256,1379),(19257,1379),(19258,1380),(19259,1380),(19260,1380),(19261,1380),(19262,1381),(19263,1381),(19264,1381),(19265,1381),(19266,1382),(19267,1382),(19268,1382),(19269,1382),(19270,1383),(19271,1383),(19272,1383),(19273,1383),(19274,1384),(19275,1384),(19276,1384),(19277,1384),(19278,1385),(19279,1385),(19280,1385),(19281,1385),(19282,1386),(19283,1386),(19284,1386),(19285,1386),(19286,1387),(19287,1387),(19288,1387),(19289,1387),(19290,1388),(19291,1388),(19292,1388),(19293,1388),(19294,1389),(19295,1389),(19296,1389),(19297,1389),(19298,1390),(19299,1390),(19300,1390),(19301,1390),(19302,1391),(19303,1391),(19304,1391),(19305,1391),(19306,1392),(19307,1392),(19308,1392),(19309,1392),(19310,1393),(19311,1393),(19312,1393),(19313,1393),(19314,1394),(19315,1394),(19316,1394),(19317,1394),(19318,1395),(19319,1395),(19320,1395),(19321,1395),(19322,1396),(19323,1396),(19324,1396),(19325,1396),(19326,1397),(19327,1397),(19328,1397),(19329,1397),(19330,1398),(19331,1398),(19332,1398),(19333,1398),(19334,1399),(19335,1399),(19336,1399),(19337,1399),(19338,1400),(19339,1400),(19340,1400),(19341,1400),(19342,1401),(19343,1401),(19344,1401),(19345,1401),(19346,1402),(19347,1402),(19348,1402),(19349,1402),(19350,1403),(19351,1403),(19352,1403),(19353,1403),(19354,1404),(19355,1404),(19356,1404),(19357,1404),(19358,1405),(19359,1405),(19360,1405),(19361,1405),(19362,1406),(19363,1406),(19364,1406),(19365,1406),(19366,1407),(19367,1407),(19368,1407),(19369,1407),(19370,1408),(19371,1408),(19372,1408),(19373,1408),(19374,1409),(19375,1409),(19376,1409),(19377,1409),(19378,1410),(19379,1410),(19380,1410),(19381,1410),(19382,1411),(19383,1411),(19384,1411),(19385,1411),(19386,1412),(19387,1412),(19388,1412),(19389,1412),(19390,1413),(19391,1413),(19392,1413),(19393,1413),(19394,1414),(19395,1414),(19396,1414),(19397,1414),(19398,1415),(19399,1415),(19400,1415),(19401,1415),(19402,1416),(19403,1416),(19404,1416),(19405,1416),(19406,1417),(19407,1417),(19408,1417),(19409,1417),(19410,1418),(19411,1418),(19412,1418),(19413,1418),(19414,1419),(19415,1419),(19416,1419),(19417,1419),(19418,1420),(19419,1420),(19420,1420),(19421,1420),(19422,1421),(19423,1421),(19424,1421),(19425,1421),(19426,1422),(19427,1422),(19428,1422),(19429,1422),(19430,1423),(19431,1423),(19432,1423),(19433,1423),(19434,1424),(19435,1424),(19436,1424),(19437,1424),(19438,1425),(19439,1425),(19440,1425),(19441,1425),(19442,1426),(19443,1426),(19444,1426),(19445,1426),(19446,1427),(19447,1427),(19448,1427),(19449,1427),(19450,1428),(19451,1428),(19452,1428),(19453,1428),(19454,1429),(19455,1429),(19456,1429),(19457,1429),(19458,1430),(19459,1430),(19460,1430),(19461,1430),(19462,1431),(19463,1431),(19464,1431),(19465,1431),(19466,1432),(19467,1432),(19468,1432),(19469,1432),(19470,1433),(19471,1433),(19472,1433),(19473,1433),(19474,1434),(19475,1434),(19476,1434),(19477,1434),(19478,1435),(19479,1435),(19480,1435),(19481,1435),(19482,1436),(19483,1436),(19484,1436),(19485,1436),(19486,1437),(19487,1437),(19488,1437),(19489,1437),(19490,1438),(19491,1438),(19492,1438),(19493,1438),(19494,1439),(19495,1439),(19496,1439),(19497,1439),(19498,1440),(19499,1440),(19500,1440),(19501,1440),(19502,1441),(19503,1441),(19504,1441),(19505,1441),(19506,1442),(19507,1442),(19508,1442),(19509,1442),(19510,1443),(19511,1443),(19512,1443),(19513,1443),(19514,1444),(19515,1444),(19516,1444),(19517,1444),(19518,1445),(19519,1445),(19520,1445),(19521,1445),(19522,1446),(19523,1446),(19524,1446),(19525,1446),(19526,1447),(19527,1447),(19528,1447),(19529,1447),(19530,1448),(19531,1448),(19532,1448),(19533,1448),(19534,1449),(19535,1449),(19536,1449),(19537,1449),(19538,1450),(19539,1450),(19540,1450),(19541,1450),(19542,1451),(19543,1451),(19544,1451),(19545,1451),(19546,1452),(19547,1452),(19548,1452),(19549,1452),(19550,1453),(19551,1453),(19552,1453),(19553,1453),(19554,1454),(19555,1454),(19556,1454),(19557,1454),(19558,1455),(19559,1455),(19560,1455),(19561,1455),(19562,1456),(19563,1456),(19564,1456),(19565,1456),(19566,1457),(19567,1457),(19568,1457),(19569,1457),(19570,1458),(19571,1458),(19572,1458),(19573,1458),(19574,1459),(19575,1459),(19576,1459),(19577,1459),(19578,1460),(19579,1460),(19580,1460),(19581,1460),(19582,1461),(19583,1461),(19584,1461),(19585,1461),(19586,1462),(19587,1462),(19588,1462),(19589,1462),(19590,1463),(19591,1463),(19592,1463),(19593,1463),(19594,1464),(19595,1464),(19596,1464),(19597,1464),(19598,1465),(19599,1465),(19600,1465),(19601,1465),(19602,1466),(19603,1466),(19604,1466),(19605,1466),(19606,1466),(19607,1466),(19608,1466),(19609,1467),(19610,1467),(19611,1467),(19612,1467),(19613,1467),(19614,1467),(19615,1467),(19616,1468),(19617,1468),(19618,1468),(19619,1468),(19620,1468),(19621,1468),(19622,1468),(19623,1469),(19624,1469),(19625,1469),(19626,1469),(19627,1469),(19628,1469),(19629,1469),(19630,1470),(19631,1470),(19632,1470),(19633,1470),(19634,1470),(19635,1470),(19636,1470),(19637,1471),(19638,1471),(19639,1471),(19640,1471),(19641,1471),(19642,1471),(19643,1471),(19644,1472),(19645,1472),(19646,1472),(19647,1472),(19648,1472),(19649,1472),(19650,1472),(19651,1473),(19652,1473),(19653,1473),(19654,1473),(19655,1473),(19656,1473),(19657,1473),(19658,1474),(19659,1474),(19660,1474),(19661,1474),(19662,1474),(19663,1474),(19664,1474),(19665,1475),(19666,1475),(19667,1475),(19668,1475),(19669,1475),(19670,1475),(19671,1475),(19672,1476),(19673,1476),(19674,1476),(19675,1476),(19676,1476),(19677,1476),(19678,1476),(19679,1477),(19680,1477),(19681,1477),(19682,1477),(19683,1477),(19684,1477),(19685,1477),(19686,1478),(19687,1478),(19688,1478),(19689,1478),(19690,1478),(19691,1478),(19692,1478),(19693,1479),(19694,1479),(19695,1479),(19696,1479),(19697,1479),(19698,1479),(19699,1479),(19700,1480),(19701,1480),(19702,1480),(19703,1480),(19704,1480),(19705,1480),(19706,1480),(19707,1481),(19708,1481),(19709,1481),(19710,1481),(19711,1481),(19712,1481),(19713,1481),(19714,1482),(19715,1482),(19716,1482),(19717,1482),(19718,1482),(19719,1482),(19720,1482),(19721,1483),(19722,1483),(19723,1483),(19724,1483),(19725,1483),(19726,1483),(19727,1483),(19728,1484),(19729,1484),(19730,1484),(19731,1484),(19732,1484),(19733,1484),(19734,1484),(19735,1485),(19736,1485),(19737,1485),(19738,1485),(19739,1485),(19740,1485),(19741,1485),(19742,1486),(19743,1486),(19744,1486),(19745,1486),(19746,1486),(19747,1486),(19748,1486),(19749,1487),(19750,1487),(19751,1487),(19752,1487),(19753,1487),(19754,1487),(19755,1487),(19756,1488),(19757,1488),(19758,1488),(19759,1488),(19760,1488),(19761,1488),(19762,1488),(19763,1489),(19764,1489),(19765,1489),(19766,1489),(19767,1489),(19768,1489),(19769,1489),(19770,1490),(19771,1490),(19772,1490),(19773,1490),(19774,1490),(19775,1490),(19776,1490),(19777,1491),(19778,1491),(19779,1491),(19780,1491),(19781,1491),(19782,1491),(19783,1491),(19784,1492),(19785,1492),(19786,1492),(19787,1492),(19788,1492),(19789,1492),(19790,1492),(19791,1493),(19792,1493),(19793,1493),(19794,1493),(19795,1493),(19796,1493),(19797,1493),(19798,1494),(19799,1494),(19800,1494),(19801,1494),(19802,1494),(19803,1494),(19804,1494),(19805,1495),(19806,1495),(19807,1495),(19808,1495),(19809,1495),(19810,1495),(19811,1495),(19812,1496),(19813,1496),(19814,1496),(19815,1496),(19816,1496),(19817,1496),(19818,1496),(19819,1496),(19820,1496),(19821,1497),(19822,1497),(19823,1497),(19824,1497),(19825,1497),(19826,1497),(19827,1497),(19828,1497),(19829,1497),(19830,1498),(19831,1498),(19832,1498),(19833,1498),(19834,1498),(19835,1498),(19836,1498),(19837,1498),(19838,1498),(19839,1499),(19840,1499),(19841,1499),(19842,1499),(19843,1499),(19844,1499),(19845,1499),(19846,1499),(19847,1499),(19848,1500),(19849,1500),(19850,1500),(19851,1500),(19852,1500),(19853,1500),(19854,1500),(19855,1501),(19856,1501),(19857,1501),(19858,1501),(19859,1501),(19860,1501),(19861,1501),(19862,1502),(19863,1502),(19864,1502),(19865,1502),(19866,1502),(19867,1502),(19868,1502),(19869,1503),(19870,1503),(19871,1503),(19872,1503),(19873,1503),(19874,1503),(19875,1503),(19876,1503),(19877,1503),(19878,1504),(19879,1504),(19880,1504),(19881,1504),(19882,1504),(19883,1504),(19884,1504),(19885,1505),(19886,1505),(19887,1505),(19888,1505),(19889,1505),(19890,1505),(19891,1505),(19892,1506),(19893,1506),(19894,1506),(19895,1506),(19896,1506),(19897,1506),(19898,1506),(19899,1506),(19900,1506),(19901,1507),(19902,1507),(19903,1507),(19904,1507),(19905,1507),(19906,1507),(19907,1507),(19908,1508),(19909,1508),(19910,1508),(19911,1508),(19912,1508),(19913,1508),(19914,1508),(19915,1509),(19916,1509),(19917,1509),(19918,1509),(19919,1509),(19920,1509),(19921,1509),(19922,1509),(19923,1509),(19924,1510),(19925,1510),(19926,1510),(19927,1510),(19928,1510),(19929,1510),(19930,1510),(19931,1511),(19932,1511),(19933,1511),(19934,1511),(19935,1511),(19936,1511),(19937,1511),(19938,1511),(19939,1511),(19940,1512),(19941,1512),(19942,1512),(19943,1512),(19944,1512),(19945,1512),(19946,1512),(19947,1512),(19948,1512),(19949,1513),(19950,1513),(19951,1513),(19952,1513),(19953,1513),(19954,1513),(19955,1513),(19956,1514),(19957,1514),(19958,1514),(19959,1514),(19960,1514),(19961,1514),(19962,1514),(19963,1514),(19964,1514),(19965,1515),(19966,1515),(19967,1515),(19968,1515),(19969,1515),(19970,1515),(19971,1515),(19972,1516),(19973,1516),(19974,1516),(19975,1516),(19976,1516),(19977,1516),(19978,1516),(19979,1517),(19980,1517),(19981,1517),(19982,1517),(19983,1517),(19984,1517),(19985,1517),(19986,1518),(19987,1518),(19988,1518),(19989,1518),(19990,1518),(19991,1518),(19992,1518),(19993,1519),(19994,1519),(19995,1519),(19996,1519),(19997,1519),(19998,1519),(19999,1519),(20000,1520),(20001,1520),(20002,1520),(20003,1520),(20004,1520),(20005,1520),(20006,1520),(20007,1521),(20008,1521),(20009,1521),(20010,1521),(20011,1521),(20012,1521),(20013,1521),(20014,1522),(20015,1522),(20016,1522),(20017,1522),(20018,1522),(20019,1522),(20020,1522),(20021,1523),(20022,1523),(20023,1523),(20024,1523),(20025,1523),(20026,1523),(20027,1523),(20028,1524),(20029,1524),(20030,1524),(20031,1524),(20032,1524),(20033,1524),(20034,1524),(20035,1525),(20036,1525),(20037,1525),(20038,1525),(20039,1525),(20040,1525),(20041,1525),(20042,1526),(20043,1526),(20044,1526),(20045,1526),(20046,1526),(20047,1526),(20048,1526),(20049,1527),(20050,1527),(20051,1527),(20052,1527),(20053,1527),(20054,1527),(20055,1527),(20056,1528),(20057,1528),(20058,1528),(20059,1528),(20060,1528),(20061,1528),(20062,1528),(20063,1529),(20064,1529),(20065,1529),(20066,1529),(20067,1529),(20068,1529),(20069,1529),(20070,1530),(20071,1530),(20072,1530),(20073,1530),(20074,1530),(20075,1530),(20076,1530),(20077,1531),(20078,1531),(20079,1531),(20080,1531),(20081,1531),(20082,1531),(20083,1531),(20084,1532),(20085,1532),(20086,1532),(20087,1532),(20088,1532),(20089,1532),(20090,1532),(20091,1533),(20092,1533),(20093,1533),(20094,1533),(20095,1533),(20096,1533),(20097,1533),(20098,1533),(20099,1533),(20100,1534),(20101,1534),(20102,1534),(20103,1534),(20104,1534),(20105,1534),(20106,1534),(20107,1535),(20108,1535),(20109,1535),(20110,1535),(20111,1535),(20112,1535),(20113,1535),(20114,1536),(20115,1536),(20116,1536),(20117,1536),(20118,1536),(20119,1536),(20120,1536),(20121,1537),(20122,1537),(20123,1537),(20124,1537),(20125,1537),(20126,1537),(20127,1537),(20128,1538),(20129,1538),(20130,1538),(20131,1538),(20132,1538),(20133,1538),(20134,1538),(20135,1539),(20136,1539),(20137,1539),(20138,1539),(20139,1539),(20140,1539),(20141,1539),(20142,1540),(20143,1540),(20144,1540),(20145,1540),(20146,1540),(20147,1540),(20148,1540),(20149,1541),(20150,1541),(20151,1541),(20152,1541),(20153,1541),(20154,1541),(20155,1541),(20156,1542),(20157,1542),(20158,1542),(20159,1542),(20160,1542),(20161,1542),(20162,1543),(20163,1543),(20164,1543),(20165,1543),(20166,1543),(20167,1543),(20168,1544),(20169,1544),(20170,1544),(20171,1544),(20172,1544),(20173,1544),(20174,1544),(20175,1545),(20176,1545),(20177,1545),(20178,1545),(20179,1545),(20180,1545),(20181,1546),(20182,1546),(20183,1546),(20184,1546),(20185,1546),(20186,1546),(20187,1546),(20188,1547),(20189,1547),(20190,1547),(20191,1547),(20192,1547),(20193,1547),(20194,1547),(20195,1548),(20196,1548),(20197,1548),(20198,1548),(20199,1548),(20200,1548),(20201,1548),(20202,1549),(20203,1549),(20204,1549),(20205,1549),(20206,1549),(20207,1549),(20208,1549),(20209,1550),(20210,1550),(20211,1550),(20212,1550),(20213,1550),(20214,1550),(20215,1550),(20216,1551),(20217,1551),(20218,1551),(20219,1551),(20220,1551),(20221,1551),(20222,1551),(20223,1552),(20224,1552),(20225,1552),(20226,1552),(20227,1552),(20228,1552),(20229,1552),(20230,1553),(20231,1553),(20232,1553),(20233,1553),(20234,1553),(20235,1553),(20236,1553),(20237,1554),(20238,1554),(20239,1554),(20240,1554),(20241,1554),(20242,1554),(20243,1554),(20244,1554),(20245,1554),(20246,1555),(20247,1555),(20248,1555),(20249,1555),(20250,1555),(20251,1555),(20252,1555),(20253,1556),(20254,1556),(20255,1556),(20256,1556),(20257,1556),(20258,1556),(20259,1556),(20260,1557),(20261,1557),(20262,1557),(20263,1557),(20264,1557),(20265,1557),(20266,1557),(20267,1558),(20268,1558),(20269,1558),(20270,1558),(20271,1558),(20272,1558),(20273,1558),(20274,1559),(20275,1559),(20276,1559),(20277,1559),(20278,1559),(20279,1559),(20280,1559),(20281,1560),(20282,1560),(20283,1560),(20284,1560),(20285,1560),(20286,1560),(20287,1560),(20288,1561),(20289,1561),(20290,1561),(20291,1561),(20292,1561),(20293,1561),(20294,1561),(20295,1562),(20296,1562),(20297,1562),(20298,1562),(20299,1562),(20300,1562),(20301,1562),(20302,1563),(20303,1563),(20304,1563),(20305,1563),(20306,1563),(20307,1563),(20308,1563),(20309,1564),(20310,1564),(20311,1564),(20312,1564),(20313,1564),(20314,1564),(20315,1564),(20316,1564),(20317,1564),(20318,1565),(20319,1565),(20320,1565),(20321,1565),(20322,1565),(20323,1565),(20324,1565),(20325,1565),(20326,1565),(20327,1466),(20328,1466),(20329,1466),(20330,1467),(20331,1467),(20332,1467),(20333,1468),(20334,1468),(20335,1468),(20336,1469),(20337,1469),(20338,1469),(20339,1470),(20340,1470),(20341,1470),(20342,1471),(20343,1471),(20344,1471),(20345,1472),(20346,1472),(20347,1472),(20348,1473),(20349,1473),(20350,1473),(20351,1474),(20352,1474),(20353,1474),(20354,1475),(20355,1475),(20356,1475),(20357,1476),(20358,1476),(20359,1476),(20360,1477),(20361,1477),(20362,1477),(20363,1478),(20364,1478),(20365,1478),(20366,1479),(20367,1479),(20368,1479),(20369,1480),(20370,1480),(20371,1480),(20372,1481),(20373,1481),(20374,1481),(20375,1482),(20376,1482),(20377,1482),(20378,1483),(20379,1483),(20380,1483),(20381,1484),(20382,1484),(20383,1484),(20384,1485),(20385,1485),(20386,1485),(20387,1486),(20388,1486),(20389,1486),(20390,1487),(20391,1487),(20392,1487),(20393,1488),(20394,1488),(20395,1488),(20396,1489),(20397,1489),(20398,1489),(20399,1490),(20400,1490),(20401,1490),(20402,1491),(20403,1491),(20404,1491),(20405,1492),(20406,1492),(20407,1492),(20408,1493),(20409,1493),(20410,1493),(20411,1494),(20412,1494),(20413,1494),(20414,1495),(20415,1495),(20416,1496),(20417,1496),(20418,1496),(20419,1497),(20420,1497),(20421,1498),(20422,1498),(20423,1499),(20424,1499),(20425,1500),(20426,1500),(20427,1501),(20428,1501),(20429,1502),(20430,1502),(20431,1503),(20432,1503),(20433,1504),(20434,1504),(20435,1505),(20436,1505),(20437,1506),(20438,1506),(20439,1507),(20440,1507),(20441,1508),(20442,1508),(20443,1509),(20444,1509),(20445,1510),(20446,1510),(20447,1511),(20448,1511),(20449,1512),(20450,1512),(20451,1513),(20452,1513),(20453,1514),(20454,1514),(20455,1515),(20456,1515),(20457,1515),(20458,1516),(20459,1516),(20460,1516),(20461,1517),(20462,1517),(20463,1517),(20464,1518),(20465,1518),(20466,1518),(20467,1519),(20468,1519),(20469,1519),(20470,1520),(20471,1520),(20472,1520),(20473,1521),(20474,1521),(20475,1521),(20476,1522),(20477,1522),(20478,1522),(20479,1523),(20480,1523),(20481,1523),(20482,1524),(20483,1524),(20484,1524),(20485,1525),(20486,1525),(20487,1525),(20488,1526),(20489,1526),(20490,1526),(20491,1527),(20492,1527),(20493,1527),(20494,1528),(20495,1528),(20496,1528),(20497,1529),(20498,1529),(20499,1529),(20500,1530),(20501,1530),(20502,1530),(20503,1531),(20504,1531),(20505,1531),(20506,1532),(20507,1532),(20508,1532),(20509,1533),(20510,1533),(20511,1533),(20512,1534),(20513,1534),(20514,1534),(20515,1535),(20516,1535),(20517,1535),(20518,1536),(20519,1536),(20520,1536),(20521,1537),(20522,1537),(20523,1537),(20524,1538),(20525,1538),(20526,1538),(20527,1539),(20528,1539),(20529,1539),(20530,1540),(20531,1540),(20532,1540),(20533,1541),(20534,1541),(20535,1541),(20536,1542),(20537,1542),(20538,1542),(20539,1543),(20540,1543),(20541,1543),(20542,1544),(20543,1544),(20544,1544),(20545,1545),(20546,1545),(20547,1545),(20548,1546),(20549,1546),(20550,1546),(20551,1547),(20552,1547),(20553,1547),(20554,1548),(20555,1548),(20556,1548),(20557,1549),(20558,1549),(20559,1549),(20560,1550),(20561,1550),(20562,1550),(20563,1551),(20564,1551),(20565,1551),(20566,1552),(20567,1552),(20568,1552),(20569,1553),(20570,1553),(20571,1553),(20572,1554),(20573,1554),(20574,1554),(20575,1555),(20576,1555),(20577,1555),(20578,1556),(20579,1556),(20580,1556),(20581,1557),(20582,1557),(20583,1557),(20584,1558),(20585,1558),(20586,1558),(20587,1559),(20588,1559),(20589,1559),(20590,1560),(20591,1560),(20592,1560),(20593,1561),(20594,1561),(20595,1561),(20596,1562),(20597,1562),(20598,1562),(20599,1563),(20600,1563),(20601,1563),(20602,1564),(20603,1564),(20604,1564),(20605,1565),(20606,1565),(20607,1565),(20608,1466),(20609,1466),(20610,1466),(20611,1466),(20612,1467),(20613,1467),(20614,1467),(20615,1467),(20616,1468),(20617,1468),(20618,1468),(20619,1468),(20620,1469),(20621,1469),(20622,1469),(20623,1469),(20624,1470),(20625,1470),(20626,1470),(20627,1470),(20628,1471),(20629,1471),(20630,1471),(20631,1471),(20632,1472),(20633,1472),(20634,1472),(20635,1472),(20636,1473),(20637,1473),(20638,1473),(20639,1473),(20640,1474),(20641,1474),(20642,1474),(20643,1474),(20644,1475),(20645,1475),(20646,1475),(20647,1475),(20648,1476),(20649,1476),(20650,1476),(20651,1476),(20652,1477),(20653,1477),(20654,1477),(20655,1477),(20656,1478),(20657,1478),(20658,1478),(20659,1478),(20660,1479),(20661,1479),(20662,1479),(20663,1479),(20664,1480),(20665,1480),(20666,1480),(20667,1480),(20668,1481),(20669,1481),(20670,1481),(20671,1481),(20672,1482),(20673,1482),(20674,1482),(20675,1482),(20676,1483),(20677,1483),(20678,1483),(20679,1483),(20680,1484),(20681,1484),(20682,1484),(20683,1484),(20684,1485),(20685,1485),(20686,1485),(20687,1485),(20688,1486),(20689,1486),(20690,1486),(20691,1486),(20692,1487),(20693,1487),(20694,1487),(20695,1487),(20696,1488),(20697,1488),(20698,1488),(20699,1488),(20700,1489),(20701,1489),(20702,1489),(20703,1489),(20704,1490),(20705,1490),(20706,1490),(20707,1490),(20708,1491),(20709,1491),(20710,1491),(20711,1491),(20712,1492),(20713,1492),(20714,1492),(20715,1492),(20716,1493),(20717,1493),(20718,1493),(20719,1493),(20720,1494),(20721,1494),(20722,1494),(20723,1494),(20724,1495),(20725,1495),(20726,1495),(20727,1495),(20728,1496),(20729,1496),(20730,1496),(20731,1496),(20732,1497),(20733,1497),(20734,1497),(20735,1497),(20736,1498),(20737,1498),(20738,1498),(20739,1498),(20740,1499),(20741,1499),(20742,1499),(20743,1499),(20744,1500),(20745,1500),(20746,1500),(20747,1500),(20748,1501),(20749,1501),(20750,1501),(20751,1501),(20752,1502),(20753,1502),(20754,1502),(20755,1502),(20756,1503),(20757,1503),(20758,1503),(20759,1503),(20760,1504),(20761,1504),(20762,1504),(20763,1504),(20764,1505),(20765,1505),(20766,1505),(20767,1505),(20768,1506),(20769,1506),(20770,1506),(20771,1506),(20772,1507),(20773,1507),(20774,1507),(20775,1507),(20776,1508),(20777,1508),(20778,1508),(20779,1508),(20780,1509),(20781,1509),(20782,1509),(20783,1509),(20784,1510),(20785,1510),(20786,1510),(20787,1510),(20788,1511),(20789,1511),(20790,1511),(20791,1511),(20792,1512),(20793,1512),(20794,1512),(20795,1512),(20796,1513),(20797,1513),(20798,1513),(20799,1513),(20800,1514),(20801,1514),(20802,1514),(20803,1514),(20804,1515),(20805,1515),(20806,1515),(20807,1515),(20808,1516),(20809,1516),(20810,1516),(20811,1516),(20812,1517),(20813,1517),(20814,1517),(20815,1517),(20816,1518),(20817,1518),(20818,1518),(20819,1518),(20820,1519),(20821,1519),(20822,1519),(20823,1519),(20824,1520),(20825,1520),(20826,1520),(20827,1520),(20828,1521),(20829,1521),(20830,1521),(20831,1521),(20832,1522),(20833,1522),(20834,1522),(20835,1522),(20836,1523),(20837,1523),(20838,1523),(20839,1523),(20840,1524),(20841,1524),(20842,1524),(20843,1524),(20844,1525),(20845,1525),(20846,1525),(20847,1525),(20848,1526),(20849,1526),(20850,1526),(20851,1526),(20852,1527),(20853,1527),(20854,1527),(20855,1527),(20856,1528),(20857,1528),(20858,1528),(20859,1528),(20860,1529),(20861,1529),(20862,1529),(20863,1529),(20864,1530),(20865,1530),(20866,1530),(20867,1530),(20868,1531),(20869,1531),(20870,1531),(20871,1531),(20872,1532),(20873,1532),(20874,1532),(20875,1532),(20876,1533),(20877,1533),(20878,1533),(20879,1533),(20880,1534),(20881,1534),(20882,1534),(20883,1534),(20884,1535),(20885,1535),(20886,1535),(20887,1535),(20888,1536),(20889,1536),(20890,1536),(20891,1536),(20892,1537),(20893,1537),(20894,1537),(20895,1537),(20896,1538),(20897,1538),(20898,1538),(20899,1538),(20900,1539),(20901,1539),(20902,1539),(20903,1539),(20904,1540),(20905,1540),(20906,1540),(20907,1540),(20908,1541),(20909,1541),(20910,1541),(20911,1541),(20912,1542),(20913,1542),(20914,1542),(20915,1542),(20916,1543),(20917,1543),(20918,1543),(20919,1543),(20920,1544),(20921,1544),(20922,1544),(20923,1544),(20924,1545),(20925,1545),(20926,1545),(20927,1545),(20928,1546),(20929,1546),(20930,1546),(20931,1546),(20932,1547),(20933,1547),(20934,1547),(20935,1547),(20936,1548),(20937,1548),(20938,1548),(20939,1548),(20940,1549),(20941,1549),(20942,1549),(20943,1549),(20944,1550),(20945,1550),(20946,1550),(20947,1550),(20948,1551),(20949,1551),(20950,1551),(20951,1551),(20952,1552),(20953,1552),(20954,1552),(20955,1552),(20956,1553),(20957,1553),(20958,1553),(20959,1553),(20960,1554),(20961,1554),(20962,1554),(20963,1554),(20964,1555),(20965,1555),(20966,1555),(20967,1555),(20968,1556),(20969,1556),(20970,1556),(20971,1556),(20972,1557),(20973,1557),(20974,1557),(20975,1557),(20976,1558),(20977,1558),(20978,1558),(20979,1558),(20980,1559),(20981,1559),(20982,1559),(20983,1559),(20984,1560),(20985,1560),(20986,1560),(20987,1560),(20988,1561),(20989,1561),(20990,1561),(20991,1561),(20992,1562),(20993,1562),(20994,1562),(20995,1562),(20996,1563),(20997,1563),(20998,1563),(20999,1563),(21000,1564),(21001,1564),(21002,1564),(21003,1564),(21004,1565),(21005,1565),(21006,1565),(21007,1565),(21008,1566),(21009,1566),(21010,1566),(21011,1566),(21012,1566),(21013,1566),(21014,1566),(21015,1566),(21016,1566),(21017,1567),(21018,1567),(21019,1567),(21020,1567),(21021,1567),(21022,1567),(21023,1567),(21024,1567),(21025,1568),(21026,1568),(21027,1568),(21028,1568),(21029,1568),(21030,1568),(21031,1568),(21032,1568),(21033,1568),(21034,1569),(21035,1569),(21036,1569),(21037,1569),(21038,1569),(21039,1569),(21040,1569),(21041,1569),(21042,1569),(21043,1570),(21044,1570),(21045,1570),(21046,1570),(21047,1570),(21048,1570),(21049,1570),(21050,1570),(21051,1570),(21052,1571),(21053,1571),(21054,1571),(21055,1571),(21056,1571),(21057,1571),(21058,1571),(21059,1571),(21060,1571),(21061,1572),(21062,1572),(21063,1572),(21064,1572),(21065,1572),(21066,1572),(21067,1572),(21068,1572),(21069,1572),(21070,1573),(21071,1573),(21072,1573),(21073,1573),(21074,1573),(21075,1573),(21076,1573),(21077,1573),(21078,1573),(21079,1574),(21080,1574),(21081,1574),(21082,1574),(21083,1574),(21084,1574),(21085,1574),(21086,1574),(21087,1574),(21088,1575),(21089,1575),(21090,1575),(21091,1575),(21092,1575),(21093,1575),(21094,1575),(21095,1576),(21096,1576),(21097,1576),(21098,1576),(21099,1576),(21100,1576),(21101,1576),(21102,1577),(21103,1577),(21104,1577),(21105,1577),(21106,1577),(21107,1577),(21108,1577),(21109,1578),(21110,1578),(21111,1578),(21112,1578),(21113,1578),(21114,1578),(21115,1578),(21116,1578),(21117,1578),(21118,1579),(21119,1579),(21120,1579),(21121,1579),(21122,1580),(21123,1580),(21124,1580),(21125,1580),(21126,1580),(21127,1580),(21128,1580),(21129,1581),(21130,1581),(21131,1581),(21132,1581),(21133,1581),(21134,1581),(21135,1581),(21136,1582),(21137,1582),(21138,1582),(21139,1582),(21140,1582),(21141,1582),(21142,1582),(21143,1583),(21144,1583),(21145,1583),(21146,1583),(21147,1583),(21148,1583),(21149,1583),(21150,1584),(21151,1584),(21152,1584),(21153,1584),(21154,1584),(21155,1584),(21156,1584),(21157,1584),(21158,1585),(21159,1585),(21160,1585),(21161,1585),(21162,1585),(21163,1585),(21164,1585),(21165,1585),(21166,1586),(21167,1586),(21168,1586),(21169,1586),(21170,1586),(21171,1586),(21172,1586),(21173,1586),(21174,1587),(21175,1587),(21176,1587),(21177,1587),(21178,1587),(21179,1587),(21180,1587),(21181,1588),(21182,1588),(21183,1588),(21184,1588),(21185,1588),(21186,1588),(21187,1588),(21188,1588),(21189,1588),(21190,1589),(21191,1589),(21192,1589),(21193,1589),(21194,1589),(21195,1589),(21196,1589),(21197,1589),(21198,1589),(21199,1590),(21200,1590),(21201,1590),(21202,1590),(21203,1590),(21204,1590),(21205,1590),(21206,1590),(21207,1590),(21208,1591),(21209,1591),(21210,1591),(21211,1591),(21212,1591),(21213,1591),(21214,1591),(21215,1591),(21216,1591),(21217,1592),(21218,1592),(21219,1592),(21220,1592),(21221,1592),(21222,1592),(21223,1592),(21224,1592),(21225,1592),(21226,1593),(21227,1593),(21228,1593),(21229,1593),(21230,1593),(21231,1593),(21232,1593),(21233,1593),(21234,1593),(21235,1594),(21236,1594),(21237,1594),(21238,1594),(21239,1594),(21240,1594),(21241,1594),(21242,1594),(21243,1594),(21244,1595),(21245,1595),(21246,1595),(21247,1595),(21248,1595),(21249,1595),(21250,1595),(21251,1595),(21252,1595),(21253,1596),(21254,1596),(21255,1596),(21256,1596),(21257,1596),(21258,1596),(21259,1596),(21260,1596),(21261,1596),(21262,1597),(21263,1597),(21264,1597),(21265,1597),(21266,1597),(21267,1597),(21268,1597),(21269,1597),(21270,1597),(21271,1598),(21272,1598),(21273,1598),(21274,1598),(21275,1598),(21276,1598),(21277,1598),(21278,1598),(21279,1598),(21280,1599),(21281,1599),(21282,1599),(21283,1599),(21284,1599),(21285,1599),(21286,1599),(21287,1599),(21288,1599),(21289,1600),(21290,1600),(21291,1600),(21292,1600),(21293,1600),(21294,1600),(21295,1600),(21296,1600),(21297,1601),(21298,1601),(21299,1601),(21300,1601),(21301,1601),(21302,1601),(21303,1601),(21304,1601),(21305,1602),(21306,1602),(21307,1602),(21308,1602),(21309,1602),(21310,1602),(21311,1602),(21312,1602),(21313,1603),(21314,1603),(21315,1603),(21316,1603),(21317,1603),(21318,1603),(21319,1603),(21320,1603),(21321,1603),(21322,1604),(21323,1604),(21324,1604),(21325,1604),(21326,1604),(21327,1604),(21328,1604),(21329,1604),(21330,1604),(21331,1605),(21332,1605),(21333,1605),(21334,1605),(21335,1605),(21336,1605),(21337,1605),(21338,1605),(21339,1606),(21340,1606),(21341,1606),(21342,1606),(21343,1606),(21344,1606),(21345,1606),(21346,1606),(21347,1607),(21348,1607),(21349,1607),(21350,1607),(21351,1607),(21352,1607),(21353,1607),(21354,1607),(21355,1607),(21356,1608),(21357,1608),(21358,1608),(21359,1608),(21360,1608),(21361,1608),(21362,1608),(21363,1608),(21364,1609),(21365,1609),(21366,1609),(21367,1609),(21368,1609),(21369,1609),(21370,1609),(21371,1609),(21372,1610),(21373,1610),(21374,1610),(21375,1610),(21376,1610),(21377,1610),(21378,1610),(21379,1610),(21380,1610),(21381,1611),(21382,1611),(21383,1611),(21384,1611),(21385,1611),(21386,1611),(21387,1611),(21388,1612),(21389,1612),(21390,1612),(21391,1612),(21392,1612),(21393,1612),(21394,1613),(21395,1613),(21396,1613),(21397,1613),(21398,1613),(21399,1613),(21400,1613),(21401,1614),(21402,1614),(21403,1614),(21404,1614),(21405,1614),(21406,1614),(21407,1615),(21408,1615),(21409,1615),(21410,1615),(21411,1615),(21412,1615),(21413,1615),(21414,1616),(21415,1616),(21416,1616),(21417,1616),(21418,1616),(21419,1616),(21420,1616),(21421,1617),(21422,1617),(21423,1617),(21424,1617),(21425,1617),(21426,1617),(21427,1617),(21428,1618),(21429,1618),(21430,1618),(21431,1618),(21432,1618),(21433,1618),(21434,1618),(21435,1618),(21436,1618),(21437,1619),(21438,1619),(21439,1619),(21440,1619),(21441,1619),(21442,1619),(21443,1619),(21444,1619),(21445,1619),(21446,1620),(21447,1620),(21448,1620),(21449,1620),(21450,1620),(21451,1620),(21452,1620),(21453,1620),(21454,1620),(21455,1621),(21456,1621),(21457,1621),(21458,1621),(21459,1621),(21460,1621),(21461,1621),(21462,1621),(21463,1621),(21464,1622),(21465,1622),(21466,1622),(21467,1622),(21468,1622),(21469,1622),(21470,1622),(21471,1622),(21472,1623),(21473,1623),(21474,1623),(21475,1623),(21476,1623),(21477,1623),(21478,1623),(21479,1623),(21480,1623),(21481,1624),(21482,1624),(21483,1624),(21484,1624),(21485,1624),(21486,1624),(21487,1624),(21488,1624),(21489,1625),(21490,1625),(21491,1625),(21492,1625),(21493,1625),(21494,1625),(21495,1625),(21496,1625),(21497,1626),(21498,1626),(21499,1626),(21500,1626),(21501,1626),(21502,1626),(21503,1626),(21504,1626),(21505,1626),(21506,1627),(21507,1627),(21508,1627),(21509,1627),(21510,1627),(21511,1627),(21512,1627),(21513,1627),(21514,1627),(21515,1628),(21516,1628),(21517,1628),(21518,1628),(21519,1628),(21520,1628),(21521,1628),(21522,1628),(21523,1629),(21524,1629),(21525,1629),(21526,1629),(21527,1629),(21528,1629),(21529,1629),(21530,1629),(21531,1629),(21532,1630),(21533,1630),(21534,1630),(21535,1630),(21536,1630),(21537,1630),(21538,1631),(21539,1631),(21540,1631),(21541,1631),(21542,1631),(21543,1631),(21544,1631),(21545,1631),(21546,1631),(21547,1632),(21548,1632),(21549,1632),(21550,1632),(21551,1632),(21552,1632),(21553,1632),(21554,1632),(21555,1632),(21556,1633),(21557,1633),(21558,1633),(21559,1633),(21560,1633),(21561,1633),(21562,1634),(21563,1634),(21564,1634),(21565,1634),(21566,1634),(21567,1634),(21568,1634),(21569,1634),(21570,1634),(21571,1635),(21572,1635),(21573,1635),(21574,1635),(21575,1635),(21576,1635),(21577,1635),(21578,1635),(21579,1635),(21580,1636),(21581,1636),(21582,1636),(21583,1636),(21584,1636),(21585,1636),(21586,1636),(21587,1636),(21588,1636),(21589,1637),(21590,1637),(21591,1637),(21592,1637),(21593,1637),(21594,1637),(21595,1637),(21596,1637),(21597,1637),(21598,1638),(21599,1638),(21600,1638),(21601,1638),(21602,1638),(21603,1638),(21604,1638),(21605,1638),(21606,1638),(21607,1639),(21608,1639),(21609,1639),(21610,1639),(21611,1639),(21612,1639),(21613,1639),(21614,1639),(21615,1639),(21616,1640),(21617,1640),(21618,1640),(21619,1640),(21620,1640),(21621,1640),(21622,1640),(21623,1640),(21624,1640),(21625,1641),(21626,1641),(21627,1641),(21628,1641),(21629,1641),(21630,1641),(21631,1642),(21632,1642),(21633,1642),(21634,1642),(21635,1642),(21636,1642),(21637,1643),(21638,1643),(21639,1643),(21640,1643),(21641,1643),(21642,1643),(21643,1643),(21644,1643),(21645,1643),(21646,1644),(21647,1644),(21648,1644),(21649,1644),(21650,1644),(21651,1644),(21652,1644),(21653,1644),(21654,1644),(21655,1645),(21656,1645),(21657,1645),(21658,1645),(21659,1645),(21660,1645),(21661,1645),(21662,1645),(21663,1645),(21664,1646),(21665,1646),(21666,1646),(21667,1646),(21668,1646),(21669,1646),(21670,1646),(21671,1646),(21672,1646),(21673,1647),(21674,1647),(21675,1647),(21676,1647),(21677,1647),(21678,1647),(21679,1647),(21680,1647),(21681,1647),(21682,1648),(21683,1648),(21684,1648),(21685,1648),(21686,1648),(21687,1648),(21688,1648),(21689,1648),(21690,1648),(21691,1649),(21692,1649),(21693,1649),(21694,1649),(21695,1649),(21696,1649),(21697,1649),(21698,1649),(21699,1649),(21700,1650),(21701,1650),(21702,1650),(21703,1650),(21704,1650),(21705,1650),(21706,1650),(21707,1651),(21708,1651),(21709,1651),(21710,1651),(21711,1651),(21712,1651),(21713,1651),(21714,1651),(21715,1651),(21716,1652),(21717,1652),(21718,1652),(21719,1652),(21720,1652),(21721,1652),(21722,1652),(21723,1653),(21724,1653),(21725,1653),(21726,1653),(21727,1653),(21728,1653),(21729,1653),(21730,1653),(21731,1653),(21732,1654),(21733,1654),(21734,1654),(21735,1654),(21736,1654),(21737,1654),(21738,1655),(21739,1655),(21740,1655),(21741,1655),(21742,1655),(21743,1655),(21744,1655),(21745,1656),(21746,1656),(21747,1656),(21748,1656),(21749,1656),(21750,1656),(21751,1656),(21752,1657),(21753,1657),(21754,1657),(21755,1657),(21756,1657),(21757,1657),(21758,1658),(21759,1658),(21760,1658),(21761,1658),(21762,1658),(21763,1658),(21764,1658),(21765,1658),(21766,1658),(21767,1659),(21768,1659),(21769,1659),(21770,1659),(21771,1659),(21772,1659),(21773,1659),(21774,1659),(21775,1659),(21776,1660),(21777,1660),(21778,1660),(21779,1660),(21780,1660),(21781,1660),(21782,1660),(21783,1660),(21784,1660),(21785,1661),(21786,1661),(21787,1661),(21788,1661),(21789,1661),(21790,1661),(21791,1661),(21792,1662),(21793,1662),(21794,1662),(21795,1662),(21796,1662),(21797,1662),(21798,1662),(21799,1663),(21800,1663),(21801,1663),(21802,1663),(21803,1663),(21804,1663),(21805,1663),(21806,1664),(21807,1664),(21808,1664),(21809,1664),(21810,1664),(21811,1664),(21812,1664),(21813,1665),(21814,1665),(21815,1665),(21816,1665),(21817,1665),(21818,1665),(21819,1665),(21820,1566),(21821,1566),(21822,1566),(21823,1567),(21824,1567),(21825,1567),(21826,1568),(21827,1568),(21828,1568),(21829,1569),(21830,1569),(21831,1569),(21832,1570),(21833,1570),(21834,1570),(21835,1571),(21836,1571),(21837,1571),(21838,1572),(21839,1572),(21840,1572),(21841,1573),(21842,1573),(21843,1573),(21844,1574),(21845,1574),(21846,1574),(21847,1575),(21848,1575),(21849,1575),(21850,1576),(21851,1576),(21852,1576),(21853,1577),(21854,1577),(21855,1577),(21856,1578),(21857,1578),(21858,1578),(21859,1579),(21860,1579),(21861,1579),(21862,1580),(21863,1580),(21864,1580),(21865,1581),(21866,1581),(21867,1581),(21868,1582),(21869,1582),(21870,1582),(21871,1583),(21872,1583),(21873,1583),(21874,1584),(21875,1584),(21876,1584),(21877,1585),(21878,1585),(21879,1585),(21880,1586),(21881,1586),(21882,1586),(21883,1587),(21884,1587),(21885,1587),(21886,1588),(21887,1588),(21888,1588),(21889,1589),(21890,1589),(21891,1589),(21892,1590),(21893,1590),(21894,1590),(21895,1591),(21896,1591),(21897,1591),(21898,1592),(21899,1592),(21900,1592),(21901,1593),(21902,1593),(21903,1593),(21904,1594),(21905,1594),(21906,1594),(21907,1595),(21908,1595),(21909,1595),(21910,1596),(21911,1596),(21912,1596),(21913,1597),(21914,1597),(21915,1597),(21916,1598),(21917,1598),(21918,1598),(21919,1599),(21920,1599),(21921,1599),(21922,1600),(21923,1600),(21924,1600),(21925,1601),(21926,1601),(21927,1601),(21928,1602),(21929,1602),(21930,1602),(21931,1603),(21932,1603),(21933,1603),(21934,1604),(21935,1604),(21936,1604),(21937,1605),(21938,1605),(21939,1605),(21940,1606),(21941,1606),(21942,1606),(21943,1607),(21944,1607),(21945,1607),(21946,1608),(21947,1608),(21948,1608),(21949,1609),(21950,1609),(21951,1609),(21952,1610),(21953,1610),(21954,1610),(21955,1611),(21956,1611),(21957,1611),(21958,1612),(21959,1612),(21960,1612),(21961,1613),(21962,1613),(21963,1613),(21964,1614),(21965,1614),(21966,1614),(21967,1615),(21968,1615),(21969,1615),(21970,1616),(21971,1616),(21972,1616),(21973,1617),(21974,1617),(21975,1617),(21976,1618),(21977,1618),(21978,1618),(21979,1619),(21980,1619),(21981,1619),(21982,1620),(21983,1620),(21984,1620),(21985,1621),(21986,1621),(21987,1621),(21988,1622),(21989,1622),(21990,1622),(21991,1623),(21992,1623),(21993,1623),(21994,1624),(21995,1624),(21996,1624),(21997,1625),(21998,1625),(21999,1625),(22000,1626),(22001,1626),(22002,1626),(22003,1627),(22004,1627),(22005,1627),(22006,1628),(22007,1628),(22008,1628),(22009,1629),(22010,1629),(22011,1629),(22012,1629),(22013,1630),(22014,1630),(22015,1630),(22016,1631),(22017,1631),(22018,1631),(22019,1632),(22020,1632),(22021,1632),(22022,1633),(22023,1633),(22024,1633),(22025,1634),(22026,1634),(22027,1634),(22028,1635),(22029,1635),(22030,1635),(22031,1636),(22032,1636),(22033,1636),(22034,1637),(22035,1637),(22036,1637),(22037,1638),(22038,1638),(22039,1638),(22040,1639),(22041,1639),(22042,1639),(22043,1640),(22044,1640),(22045,1640),(22046,1640),(22047,1641),(22048,1641),(22049,1641),(22050,1641),(22051,1642),(22052,1642),(22053,1642),(22054,1642),(22055,1643),(22056,1643),(22057,1643),(22058,1644),(22059,1644),(22060,1644),(22061,1645),(22062,1645),(22063,1645),(22064,1646),(22065,1646),(22066,1646),(22067,1647),(22068,1647),(22069,1647),(22070,1648),(22071,1648),(22072,1648),(22073,1649),(22074,1649),(22075,1649),(22076,1650),(22077,1650),(22078,1650),(22079,1651),(22080,1651),(22081,1651),(22082,1652),(22083,1652),(22084,1652),(22085,1653),(22086,1653),(22087,1653),(22088,1654),(22089,1654),(22090,1654),(22091,1655),(22092,1655),(22093,1655),(22094,1656),(22095,1656),(22096,1656),(22097,1657),(22098,1657),(22099,1657),(22100,1658),(22101,1658),(22102,1658),(22103,1659),(22104,1659),(22105,1659),(22106,1660),(22107,1660),(22108,1660),(22109,1661),(22110,1661),(22111,1661),(22112,1662),(22113,1662),(22114,1662),(22115,1663),(22116,1663),(22117,1663),(22118,1664),(22119,1664),(22120,1664),(22121,1665),(22122,1665),(22123,1665),(22124,1566),(22125,1566),(22126,1566),(22127,1566),(22128,1567),(22129,1567),(22130,1567),(22131,1567),(22132,1568),(22133,1568),(22134,1568),(22135,1568),(22136,1569),(22137,1569),(22138,1569),(22139,1569),(22140,1570),(22141,1570),(22142,1570),(22143,1570),(22144,1571),(22145,1571),(22146,1571),(22147,1571),(22148,1572),(22149,1572),(22150,1572),(22151,1572),(22152,1573),(22153,1573),(22154,1573),(22155,1573),(22156,1574),(22157,1574),(22158,1574),(22159,1574),(22160,1575),(22161,1575),(22162,1575),(22163,1575),(22164,1576),(22165,1576),(22166,1576),(22167,1576),(22168,1577),(22169,1577),(22170,1577),(22171,1577),(22172,1578),(22173,1578),(22174,1578),(22175,1578),(22176,1579),(22177,1579),(22178,1579),(22179,1579),(22180,1580),(22181,1580),(22182,1580),(22183,1580),(22184,1581),(22185,1581),(22186,1581),(22187,1581),(22188,1582),(22189,1582),(22190,1582),(22191,1582),(22192,1583),(22193,1583),(22194,1583),(22195,1583),(22196,1584),(22197,1584),(22198,1584),(22199,1584),(22200,1585),(22201,1585),(22202,1585),(22203,1585),(22204,1586),(22205,1586),(22206,1586),(22207,1586),(22208,1587),(22209,1587),(22210,1587),(22211,1587),(22212,1588),(22213,1588),(22214,1588),(22215,1588),(22216,1589),(22217,1589),(22218,1589),(22219,1589),(22220,1590),(22221,1590),(22222,1590),(22223,1590),(22224,1591),(22225,1591),(22226,1591),(22227,1591),(22228,1592),(22229,1592),(22230,1592),(22231,1592),(22232,1593),(22233,1593),(22234,1593),(22235,1593),(22236,1594),(22237,1594),(22238,1594),(22239,1594),(22240,1595),(22241,1595),(22242,1595),(22243,1595),(22244,1596),(22245,1596),(22246,1596),(22247,1596),(22248,1597),(22249,1597),(22250,1597),(22251,1597),(22252,1598),(22253,1598),(22254,1598),(22255,1598),(22256,1599),(22257,1599),(22258,1599),(22259,1599),(22260,1600),(22261,1600),(22262,1600),(22263,1600),(22264,1601),(22265,1601),(22266,1601),(22267,1601),(22268,1602),(22269,1602),(22270,1602),(22271,1602),(22272,1603),(22273,1603),(22274,1603),(22275,1603),(22276,1604),(22277,1604),(22278,1604),(22279,1604),(22280,1605),(22281,1605),(22282,1605),(22283,1605),(22284,1606),(22285,1606),(22286,1606),(22287,1606),(22288,1607),(22289,1607),(22290,1607),(22291,1607),(22292,1608),(22293,1608),(22294,1608),(22295,1608),(22296,1609),(22297,1609),(22298,1609),(22299,1609),(22300,1610),(22301,1610),(22302,1610),(22303,1610),(22304,1611),(22305,1611),(22306,1611),(22307,1611),(22308,1612),(22309,1612),(22310,1612),(22311,1612),(22312,1613),(22313,1613),(22314,1613),(22315,1613),(22316,1614),(22317,1614),(22318,1614),(22319,1614),(22320,1615),(22321,1615),(22322,1615),(22323,1615),(22324,1616),(22325,1616),(22326,1616),(22327,1616),(22328,1617),(22329,1617),(22330,1617),(22331,1617),(22332,1618),(22333,1618),(22334,1618),(22335,1618),(22336,1619),(22337,1619),(22338,1619),(22339,1619),(22340,1620),(22341,1620),(22342,1620),(22343,1620),(22344,1621),(22345,1621),(22346,1621),(22347,1621),(22348,1622),(22349,1622),(22350,1622),(22351,1622),(22352,1623),(22353,1623),(22354,1623),(22355,1623),(22356,1624),(22357,1624),(22358,1624),(22359,1624),(22360,1625),(22361,1625),(22362,1625),(22363,1625),(22364,1626),(22365,1626),(22366,1626),(22367,1626),(22368,1627),(22369,1627),(22370,1627),(22371,1627),(22372,1628),(22373,1628),(22374,1628),(22375,1628),(22376,1629),(22377,1629),(22378,1629),(22379,1629),(22380,1630),(22381,1630),(22382,1630),(22383,1630),(22384,1631),(22385,1631),(22386,1631),(22387,1631),(22388,1632),(22389,1632),(22390,1632),(22391,1632),(22392,1633),(22393,1633),(22394,1633),(22395,1633),(22396,1634),(22397,1634),(22398,1634),(22399,1634),(22400,1635),(22401,1635),(22402,1635),(22403,1635),(22404,1636),(22405,1636),(22406,1636),(22407,1636),(22408,1637),(22409,1637),(22410,1637),(22411,1637),(22412,1638),(22413,1638),(22414,1638),(22415,1638),(22416,1639),(22417,1639),(22418,1639),(22419,1639),(22420,1640),(22421,1640),(22422,1640),(22423,1640),(22424,1641),(22425,1641),(22426,1641),(22427,1641),(22428,1642),(22429,1642),(22430,1642),(22431,1642),(22432,1643),(22433,1643),(22434,1643),(22435,1643),(22436,1644),(22437,1644),(22438,1644),(22439,1644),(22440,1645),(22441,1645),(22442,1645),(22443,1645),(22444,1646),(22445,1646),(22446,1646),(22447,1646),(22448,1647),(22449,1647),(22450,1647),(22451,1647),(22452,1648),(22453,1648),(22454,1648),(22455,1648),(22456,1649),(22457,1649),(22458,1649),(22459,1649),(22460,1650),(22461,1650),(22462,1650),(22463,1650),(22464,1651),(22465,1651),(22466,1651),(22467,1651),(22468,1652),(22469,1652),(22470,1652),(22471,1652),(22472,1653),(22473,1653),(22474,1653),(22475,1653),(22476,1654),(22477,1654),(22478,1654),(22479,1654),(22480,1655),(22481,1655),(22482,1655),(22483,1655),(22484,1656),(22485,1656),(22486,1656),(22487,1656),(22488,1657),(22489,1657),(22490,1657),(22491,1657),(22492,1658),(22493,1658),(22494,1658),(22495,1658),(22496,1659),(22497,1659),(22498,1659),(22499,1659),(22500,1660),(22501,1660),(22502,1660),(22503,1660),(22504,1661),(22505,1661),(22506,1661),(22507,1661),(22508,1662),(22509,1662),(22510,1662),(22511,1662),(22512,1663),(22513,1663),(22514,1663),(22515,1663),(22516,1664),(22517,1664),(22518,1664),(22519,1664),(22520,1665),(22521,1665),(22522,1665),(22523,1665),(22524,1666),(22525,1666),(22526,1666),(22527,1666),(22528,1666),(22529,1666),(22530,1666),(22531,1667),(22532,1667),(22533,1667),(22534,1667),(22535,1667),(22536,1667),(22537,1667),(22538,1668),(22539,1668),(22540,1668),(22541,1668),(22542,1668),(22543,1668),(22544,1668),(22545,1669),(22546,1669),(22547,1669),(22548,1669),(22549,1669),(22550,1669),(22551,1669),(22552,1670),(22553,1670),(22554,1670),(22555,1670),(22556,1670),(22557,1670),(22558,1670),(22559,1671),(22560,1671),(22561,1671),(22562,1671),(22563,1671),(22564,1671),(22565,1671),(22566,1672),(22567,1672),(22568,1672),(22569,1672),(22570,1672),(22571,1672),(22572,1672),(22573,1673),(22574,1673),(22575,1673),(22576,1673),(22577,1673),(22578,1673),(22579,1673),(22580,1674),(22581,1674),(22582,1674),(22583,1674),(22584,1674),(22585,1674),(22586,1674),(22587,1675),(22588,1675),(22589,1675),(22590,1675),(22591,1675),(22592,1675),(22593,1675),(22594,1676),(22595,1676),(22596,1676),(22597,1676),(22598,1676),(22599,1676),(22600,1676),(22601,1677),(22602,1677),(22603,1677),(22604,1677),(22605,1677),(22606,1677),(22607,1677),(22608,1678),(22609,1678),(22610,1678),(22611,1678),(22612,1678),(22613,1678),(22614,1678),(22615,1679),(22616,1679),(22617,1679),(22618,1679),(22619,1679),(22620,1679),(22621,1679),(22622,1679),(22623,1679),(22624,1680),(22625,1680),(22626,1680),(22627,1680),(22628,1680),(22629,1680),(22630,1680),(22631,1680),(22632,1680),(22633,1681),(22634,1681),(22635,1681),(22636,1681),(22637,1681),(22638,1681),(22639,1681),(22640,1681),(22641,1681),(22642,1682),(22643,1682),(22644,1682),(22645,1682),(22646,1682),(22647,1682),(22648,1682),(22649,1682),(22650,1682),(22651,1683),(22652,1683),(22653,1683),(22654,1683),(22655,1683),(22656,1683),(22657,1684),(22658,1684),(22659,1684),(22660,1684),(22661,1684),(22662,1684),(22663,1685),(22664,1685),(22665,1685),(22666,1685),(22667,1685),(22668,1685),(22669,1685),(22670,1685),(22671,1685),(22672,1686),(22673,1686),(22674,1686),(22675,1686),(22676,1686),(22677,1686),(22678,1687),(22679,1687),(22680,1687),(22681,1687),(22682,1687),(22683,1687),(22684,1687),(22685,1688),(22686,1688),(22687,1688),(22688,1688),(22689,1688),(22690,1688),(22691,1688),(22692,1689),(22693,1689),(22694,1689),(22695,1689),(22696,1689),(22697,1689),(22698,1689),(22699,1689),(22700,1689),(22701,1690),(22702,1690),(22703,1690),(22704,1690),(22705,1690),(22706,1690),(22707,1690),(22708,1691),(22709,1691),(22710,1691),(22711,1691),(22712,1691),(22713,1691),(22714,1691),(22715,1692),(22716,1692),(22717,1692),(22718,1692),(22719,1692),(22720,1692),(22721,1692),(22722,1693),(22723,1693),(22724,1693),(22725,1693),(22726,1693),(22727,1693),(22728,1693),(22729,1694),(22730,1694),(22731,1694),(22732,1694),(22733,1694),(22734,1694),(22735,1694),(22736,1695),(22737,1695),(22738,1695),(22739,1695),(22740,1695),(22741,1695),(22742,1695),(22743,1696),(22744,1696),(22745,1696),(22746,1696),(22747,1696),(22748,1696),(22749,1696),(22750,1697),(22751,1697),(22752,1697),(22753,1697),(22754,1697),(22755,1697),(22756,1697),(22757,1698),(22758,1698),(22759,1698),(22760,1698),(22761,1698),(22762,1698),(22763,1698),(22764,1699),(22765,1699),(22766,1699),(22767,1699),(22768,1699),(22769,1699),(22770,1699),(22771,1700),(22772,1700),(22773,1700),(22774,1700),(22775,1700),(22776,1700),(22777,1700),(22778,1700),(22779,1700),(22780,1701),(22781,1701),(22782,1701),(22783,1701),(22784,1701),(22785,1701),(22786,1701),(22787,1701),(22788,1701),(22789,1702),(22790,1702),(22791,1702),(22792,1702),(22793,1702),(22794,1702),(22795,1702),(22796,1702),(22797,1702),(22798,1703),(22799,1703),(22800,1703),(22801,1703),(22802,1703),(22803,1703),(22804,1703),(22805,1703),(22806,1704),(22807,1704),(22808,1704),(22809,1704),(22810,1704),(22811,1704),(22812,1705),(22813,1705),(22814,1705),(22815,1705),(22816,1705),(22817,1705),(22818,1705),(22819,1706),(22820,1706),(22821,1706),(22822,1706),(22823,1706),(22824,1706),(22825,1706),(22826,1707),(22827,1707),(22828,1707),(22829,1707),(22830,1707),(22831,1707),(22832,1707),(22833,1708),(22834,1708),(22835,1708),(22836,1708),(22837,1708),(22838,1708),(22839,1708),(22840,1709),(22841,1709),(22842,1709),(22843,1709),(22844,1709),(22845,1709),(22846,1709),(22847,1710),(22848,1710),(22849,1710),(22850,1710),(22851,1710),(22852,1710),(22853,1710),(22854,1711),(22855,1711),(22856,1711),(22857,1711),(22858,1711),(22859,1711),(22860,1712),(22861,1712),(22862,1712),(22863,1712),(22864,1712),(22865,1712),(22866,1712),(22867,1713),(22868,1713),(22869,1713),(22870,1713),(22871,1713),(22872,1713),(22873,1714),(22874,1714),(22875,1714),(22876,1714),(22877,1714),(22878,1714),(22879,1714),(22880,1715),(22881,1715),(22882,1715),(22883,1715),(22884,1715),(22885,1715),(22886,1715),(22887,1715),(22888,1716),(22889,1716),(22890,1716),(22891,1716),(22892,1716),(22893,1716),(22894,1716),(22895,1716),(22896,1716),(22897,1717),(22898,1717),(22899,1717),(22900,1717),(22901,1717),(22902,1717),(22903,1717),(22904,1717),(22905,1718),(22906,1718),(22907,1718),(22908,1718),(22909,1718),(22910,1718),(22911,1718),(22912,1718),(22913,1718),(22914,1719),(22915,1719),(22916,1719),(22917,1719),(22918,1719),(22919,1719),(22920,1719),(22921,1719),(22922,1719),(22923,1720),(22924,1720),(22925,1720),(22926,1720),(22927,1720),(22928,1720),(22929,1720),(22930,1720),(22931,1720),(22932,1721),(22933,1721),(22934,1721),(22935,1721),(22936,1721),(22937,1721),(22938,1721),(22939,1721),(22940,1721),(22941,1722),(22942,1722),(22943,1722),(22944,1722),(22945,1722),(22946,1722),(22947,1722),(22948,1722),(22949,1722),(22950,1723),(22951,1723),(22952,1723),(22953,1723),(22954,1723),(22955,1723),(22956,1723),(22957,1723),(22958,1723),(22959,1724),(22960,1724),(22961,1724),(22962,1724),(22963,1724),(22964,1724),(22965,1724),(22966,1724),(22967,1724),(22968,1725),(22969,1725),(22970,1725),(22971,1725),(22972,1725),(22973,1725),(22974,1725),(22975,1725),(22976,1725),(22977,1726),(22978,1726),(22979,1726),(22980,1726),(22981,1726),(22982,1726),(22983,1726),(22984,1726),(22985,1727),(22986,1727),(22987,1727),(22988,1727),(22989,1727),(22990,1727),(22991,1727),(22992,1727),(22993,1728),(22994,1728),(22995,1728),(22996,1728),(22997,1728),(22998,1728),(22999,1728),(23000,1728),(23001,1729),(23002,1729),(23003,1729),(23004,1729),(23005,1729),(23006,1729),(23007,1729),(23008,1729),(23009,1730),(23010,1730),(23011,1730),(23012,1730),(23013,1730),(23014,1730),(23015,1730),(23016,1730),(23017,1731),(23018,1731),(23019,1731),(23020,1731),(23021,1731),(23022,1731),(23023,1731),(23024,1731),(23025,1732),(23026,1732),(23027,1732),(23028,1732),(23029,1732),(23030,1732),(23031,1732),(23032,1732),(23033,1733),(23034,1733),(23035,1733),(23036,1733),(23037,1733),(23038,1733),(23039,1733),(23040,1733),(23041,1733),(23042,1734),(23043,1734),(23044,1734),(23045,1734),(23046,1734),(23047,1734),(23048,1734),(23049,1734),(23050,1734),(23051,1735),(23052,1735),(23053,1735),(23054,1735),(23055,1735),(23056,1735),(23057,1735),(23058,1735),(23059,1735),(23060,1736),(23061,1736),(23062,1736),(23063,1736),(23064,1736),(23065,1736),(23066,1736),(23067,1736),(23068,1737),(23069,1737),(23070,1737),(23071,1737),(23072,1737),(23073,1737),(23074,1737),(23075,1737),(23076,1738),(23077,1738),(23078,1738),(23079,1738),(23080,1738),(23081,1738),(23082,1738),(23083,1738),(23084,1739),(23085,1739),(23086,1739),(23087,1739),(23088,1739),(23089,1739),(23090,1739),(23091,1740),(23092,1740),(23093,1740),(23094,1740),(23095,1740),(23096,1740),(23097,1740),(23098,1741),(23099,1741),(23100,1741),(23101,1741),(23102,1741),(23103,1741),(23104,1741),(23105,1742),(23106,1742),(23107,1742),(23108,1742),(23109,1742),(23110,1742),(23111,1742),(23112,1743),(23113,1743),(23114,1743),(23115,1743),(23116,1743),(23117,1743),(23118,1743),(23119,1744),(23120,1744),(23121,1744),(23122,1744),(23123,1744),(23124,1744),(23125,1744),(23126,1745),(23127,1745),(23128,1745),(23129,1745),(23130,1745),(23131,1745),(23132,1745),(23133,1746),(23134,1746),(23135,1746),(23136,1746),(23137,1746),(23138,1746),(23139,1746),(23140,1747),(23141,1747),(23142,1747),(23143,1747),(23144,1747),(23145,1747),(23146,1747),(23147,1748),(23148,1748),(23149,1748),(23150,1748),(23151,1748),(23152,1748),(23153,1748),(23154,1749),(23155,1749),(23156,1749),(23157,1749),(23158,1749),(23159,1749),(23160,1749),(23161,1750),(23162,1750),(23163,1750),(23164,1750),(23165,1750),(23166,1750),(23167,1750),(23168,1751),(23169,1751),(23170,1751),(23171,1751),(23172,1751),(23173,1751),(23174,1751),(23175,1752),(23176,1752),(23177,1752),(23178,1752),(23179,1752),(23180,1752),(23181,1752),(23182,1753),(23183,1753),(23184,1753),(23185,1753),(23186,1753),(23187,1753),(23188,1753),(23189,1754),(23190,1754),(23191,1754),(23192,1754),(23193,1754),(23194,1754),(23195,1754),(23196,1755),(23197,1755),(23198,1755),(23199,1755),(23200,1755),(23201,1755),(23202,1755),(23203,1756),(23204,1756),(23205,1756),(23206,1756),(23207,1756),(23208,1756),(23209,1756),(23210,1757),(23211,1757),(23212,1757),(23213,1757),(23214,1757),(23215,1757),(23216,1757),(23217,1758),(23218,1758),(23219,1758),(23220,1758),(23221,1758),(23222,1758),(23223,1758),(23224,1759),(23225,1759),(23226,1759),(23227,1759),(23228,1759),(23229,1759),(23230,1759),(23231,1760),(23232,1760),(23233,1760),(23234,1760),(23235,1760),(23236,1760),(23237,1760),(23238,1761),(23239,1761),(23240,1761),(23241,1761),(23242,1761),(23243,1761),(23244,1761),(23245,1762),(23246,1762),(23247,1762),(23248,1762),(23249,1762),(23250,1762),(23251,1762),(23252,1763),(23253,1763),(23254,1763),(23255,1763),(23256,1763),(23257,1763),(23258,1763),(23259,1763),(23260,1763),(23261,1764),(23262,1764),(23263,1764),(23264,1764),(23265,1764),(23266,1764),(23267,1764),(23268,1765),(23269,1765),(23270,1765),(23271,1765),(23272,1765),(23273,1765),(23274,1765),(23275,1666),(23276,1666),(23277,1666),(23278,1667),(23279,1667),(23280,1667),(23281,1668),(23282,1668),(23283,1668),(23284,1669),(23285,1669),(23286,1669),(23287,1670),(23288,1670),(23289,1670),(23290,1671),(23291,1671),(23292,1671),(23293,1672),(23294,1672),(23295,1672),(23296,1673),(23297,1673),(23298,1673),(23299,1674),(23300,1674),(23301,1674),(23302,1675),(23303,1675),(23304,1675),(23305,1676),(23306,1676),(23307,1676),(23308,1677),(23309,1677),(23310,1677),(23311,1678),(23312,1678),(23313,1678),(23314,1679),(23315,1679),(23316,1679),(23317,1680),(23318,1680),(23319,1680),(23320,1681),(23321,1681),(23322,1681),(23323,1682),(23324,1682),(23325,1682),(23326,1683),(23327,1683),(23328,1683),(23329,1684),(23330,1684),(23331,1684),(23332,1685),(23333,1685),(23334,1685),(23335,1686),(23336,1686),(23337,1686),(23338,1687),(23339,1687),(23340,1687),(23341,1688),(23342,1688),(23343,1688),(23344,1689),(23345,1689),(23346,1689),(23347,1690),(23348,1690),(23349,1690),(23350,1691),(23351,1691),(23352,1691),(23353,1692),(23354,1692),(23355,1692),(23356,1693),(23357,1693),(23358,1693),(23359,1694),(23360,1694),(23361,1694),(23362,1695),(23363,1695),(23364,1695),(23365,1696),(23366,1696),(23367,1696),(23368,1697),(23369,1697),(23370,1697),(23371,1698),(23372,1698),(23373,1698),(23374,1699),(23375,1699),(23376,1699),(23377,1700),(23378,1700),(23379,1700),(23380,1701),(23381,1701),(23382,1701),(23383,1702),(23384,1702),(23385,1702),(23386,1703),(23387,1703),(23388,1703),(23389,1704),(23390,1704),(23391,1704),(23392,1705),(23393,1705),(23394,1705),(23395,1706),(23396,1706),(23397,1706),(23398,1707),(23399,1707),(23400,1707),(23401,1708),(23402,1708),(23403,1708),(23404,1709),(23405,1709),(23406,1709),(23407,1710),(23408,1710),(23409,1710),(23410,1711),(23411,1711),(23412,1711),(23413,1711),(23414,1712),(23415,1712),(23416,1712),(23417,1713),(23418,1713),(23419,1713),(23420,1713),(23421,1714),(23422,1714),(23423,1714),(23424,1715),(23425,1715),(23426,1715),(23427,1716),(23428,1716),(23429,1716),(23430,1717),(23431,1717),(23432,1717),(23433,1718),(23434,1718),(23435,1718),(23436,1719),(23437,1719),(23438,1719),(23439,1720),(23440,1720),(23441,1720),(23442,1721),(23443,1721),(23444,1721),(23445,1722),(23446,1722),(23447,1722),(23448,1723),(23449,1723),(23450,1723),(23451,1724),(23452,1724),(23453,1724),(23454,1725),(23455,1725),(23456,1725),(23457,1726),(23458,1726),(23459,1726),(23460,1727),(23461,1727),(23462,1727),(23463,1728),(23464,1728),(23465,1728),(23466,1729),(23467,1729),(23468,1729),(23469,1730),(23470,1730),(23471,1730),(23472,1731),(23473,1731),(23474,1731),(23475,1732),(23476,1732),(23477,1732),(23478,1733),(23479,1733),(23480,1733),(23481,1734),(23482,1734),(23483,1734),(23484,1735),(23485,1735),(23486,1735),(23487,1736),(23488,1736),(23489,1736),(23490,1737),(23491,1737),(23492,1737),(23493,1738),(23494,1738),(23495,1738),(23496,1739),(23497,1739),(23498,1739),(23499,1740),(23500,1740),(23501,1740),(23502,1741),(23503,1741),(23504,1741),(23505,1742),(23506,1742),(23507,1742),(23508,1743),(23509,1743),(23510,1743),(23511,1744),(23512,1744),(23513,1744),(23514,1745),(23515,1745),(23516,1745),(23517,1746),(23518,1746),(23519,1746),(23520,1747),(23521,1747),(23522,1747),(23523,1748),(23524,1748),(23525,1748),(23526,1749),(23527,1749),(23528,1749),(23529,1750),(23530,1750),(23531,1750),(23532,1751),(23533,1751),(23534,1751),(23535,1752),(23536,1752),(23537,1752),(23538,1753),(23539,1753),(23540,1753),(23541,1754),(23542,1754),(23543,1754),(23544,1755),(23545,1755),(23546,1755),(23547,1756),(23548,1756),(23549,1756),(23550,1757),(23551,1757),(23552,1757),(23553,1758),(23554,1758),(23555,1758),(23556,1759),(23557,1759),(23558,1759),(23559,1760),(23560,1760),(23561,1760),(23562,1761),(23563,1761),(23564,1761),(23565,1762),(23566,1762),(23567,1762),(23568,1763),(23569,1763),(23570,1763),(23571,1764),(23572,1764),(23573,1764),(23574,1765),(23575,1765),(23576,1765),(23577,1666),(23578,1666),(23579,1666),(23580,1666),(23581,1667),(23582,1667),(23583,1667),(23584,1667),(23585,1668),(23586,1668),(23587,1668),(23588,1668),(23589,1669),(23590,1669),(23591,1669),(23592,1669),(23593,1670),(23594,1670),(23595,1670),(23596,1670),(23597,1671),(23598,1671),(23599,1671),(23600,1671),(23601,1672),(23602,1672),(23603,1672),(23604,1672),(23605,1673),(23606,1673),(23607,1673),(23608,1673),(23609,1674),(23610,1674),(23611,1674),(23612,1674),(23613,1675),(23614,1675),(23615,1675),(23616,1675),(23617,1676),(23618,1676),(23619,1676),(23620,1676),(23621,1677),(23622,1677),(23623,1677),(23624,1677),(23625,1678),(23626,1678),(23627,1678),(23628,1678),(23629,1679),(23630,1679),(23631,1679),(23632,1679),(23633,1680),(23634,1680),(23635,1680),(23636,1680),(23637,1681),(23638,1681),(23639,1681),(23640,1681),(23641,1682),(23642,1682),(23643,1682),(23644,1682),(23645,1683),(23646,1683),(23647,1683),(23648,1683),(23649,1684),(23650,1684),(23651,1684),(23652,1684),(23653,1685),(23654,1685),(23655,1685),(23656,1685),(23657,1686),(23658,1686),(23659,1686),(23660,1686),(23661,1687),(23662,1687),(23663,1687),(23664,1687),(23665,1688),(23666,1688),(23667,1688),(23668,1688),(23669,1689),(23670,1689),(23671,1689),(23672,1689),(23673,1690),(23674,1690),(23675,1690),(23676,1690),(23677,1691),(23678,1691),(23679,1691),(23680,1691),(23681,1692),(23682,1692),(23683,1692),(23684,1692),(23685,1693),(23686,1693),(23687,1693),(23688,1693),(23689,1694),(23690,1694),(23691,1694),(23692,1694),(23693,1695),(23694,1695),(23695,1695),(23696,1695),(23697,1696),(23698,1696),(23699,1696),(23700,1696),(23701,1697),(23702,1697),(23703,1697),(23704,1697),(23705,1698),(23706,1698),(23707,1698),(23708,1698),(23709,1699),(23710,1699),(23711,1699),(23712,1699),(23713,1700),(23714,1700),(23715,1700),(23716,1700),(23717,1701),(23718,1701),(23719,1701),(23720,1701),(23721,1702),(23722,1702),(23723,1702),(23724,1702),(23725,1703),(23726,1703),(23727,1703),(23728,1703),(23729,1704),(23730,1704),(23731,1704),(23732,1704),(23733,1705),(23734,1705),(23735,1705),(23736,1705),(23737,1706),(23738,1706),(23739,1706),(23740,1706),(23741,1707),(23742,1707),(23743,1707),(23744,1707),(23745,1708),(23746,1708),(23747,1708),(23748,1708),(23749,1709),(23750,1709),(23751,1709),(23752,1709),(23753,1710),(23754,1710),(23755,1710),(23756,1710),(23757,1711),(23758,1711),(23759,1711),(23760,1711),(23761,1712),(23762,1712),(23763,1712),(23764,1712),(23765,1713),(23766,1713),(23767,1713),(23768,1713),(23769,1714),(23770,1714),(23771,1714),(23772,1714),(23773,1715),(23774,1715),(23775,1715),(23776,1715),(23777,1716),(23778,1716),(23779,1716),(23780,1716),(23781,1717),(23782,1717),(23783,1717),(23784,1717),(23785,1718),(23786,1718),(23787,1718),(23788,1718),(23789,1719),(23790,1719),(23791,1719),(23792,1719),(23793,1720),(23794,1720),(23795,1720),(23796,1720),(23797,1721),(23798,1721),(23799,1721),(23800,1721),(23801,1722),(23802,1722),(23803,1722),(23804,1722),(23805,1723),(23806,1723),(23807,1723),(23808,1723),(23809,1724),(23810,1724),(23811,1724),(23812,1724),(23813,1725),(23814,1725),(23815,1725),(23816,1725),(23817,1726),(23818,1726),(23819,1726),(23820,1726),(23821,1727),(23822,1727),(23823,1727),(23824,1727),(23825,1728),(23826,1728),(23827,1728),(23828,1728),(23829,1729),(23830,1729),(23831,1729),(23832,1729),(23833,1730),(23834,1730),(23835,1730),(23836,1730),(23837,1731),(23838,1731),(23839,1731),(23840,1731),(23841,1732),(23842,1732),(23843,1732),(23844,1732),(23845,1733),(23846,1733),(23847,1733),(23848,1733),(23849,1734),(23850,1734),(23851,1734),(23852,1734),(23853,1735),(23854,1735),(23855,1735),(23856,1735),(23857,1736),(23858,1736),(23859,1736),(23860,1736),(23861,1737),(23862,1737),(23863,1737),(23864,1737),(23865,1738),(23866,1738),(23867,1738),(23868,1738),(23869,1739),(23870,1739),(23871,1739),(23872,1739),(23873,1740),(23874,1740),(23875,1740),(23876,1740),(23877,1741),(23878,1741),(23879,1741),(23880,1741),(23881,1742),(23882,1742),(23883,1742),(23884,1742),(23885,1743),(23886,1743),(23887,1743),(23888,1743),(23889,1744),(23890,1744),(23891,1744),(23892,1744),(23893,1745),(23894,1745),(23895,1745),(23896,1745),(23897,1746),(23898,1746),(23899,1746),(23900,1746),(23901,1747),(23902,1747),(23903,1747),(23904,1747),(23905,1748),(23906,1748),(23907,1748),(23908,1748),(23909,1749),(23910,1749),(23911,1749),(23912,1749),(23913,1750),(23914,1750),(23915,1750),(23916,1750),(23917,1751),(23918,1751),(23919,1751),(23920,1751),(23921,1752),(23922,1752),(23923,1752),(23924,1752),(23925,1753),(23926,1753),(23927,1753),(23928,1753),(23929,1754),(23930,1754),(23931,1754),(23932,1754),(23933,1755),(23934,1755),(23935,1755),(23936,1755),(23937,1756),(23938,1756),(23939,1756),(23940,1756),(23941,1757),(23942,1757),(23943,1757),(23944,1757),(23945,1758),(23946,1758),(23947,1758),(23948,1758),(23949,1759),(23950,1759),(23951,1759),(23952,1759),(23953,1760),(23954,1760),(23955,1760),(23956,1760),(23957,1761),(23958,1761),(23959,1761),(23960,1761),(23961,1762),(23962,1762),(23963,1762),(23964,1762),(23965,1763),(23966,1763),(23967,1763),(23968,1763),(23969,1764),(23970,1764),(23971,1764),(23972,1764),(23973,1765),(23974,1765),(23975,1765),(23976,1765),(23977,1766),(23978,1766),(23979,1766),(23980,1766),(23981,1766),(23982,1766),(23983,1767),(23984,1767),(23985,1767),(23986,1767),(23987,1767),(23988,1767),(23989,1768),(23990,1768),(23991,1768),(23992,1768),(23993,1768),(23994,1768),(23995,1769),(23996,1769),(23997,1769),(23998,1769),(23999,1769),(24000,1769),(24001,1769),(24002,1770),(24003,1770),(24004,1770),(24005,1770),(24006,1770),(24007,1770),(24008,1771),(24009,1771),(24010,1771),(24011,1771),(24012,1771),(24013,1771),(24014,1772),(24015,1772),(24016,1772),(24017,1772),(24018,1772),(24019,1772),(24020,1772),(24021,1773),(24022,1773),(24023,1773),(24024,1773),(24025,1773),(24026,1773),(24027,1773),(24028,1773),(24029,1773),(24030,1774),(24031,1774),(24032,1774),(24033,1774),(24034,1774),(24035,1774),(24036,1774),(24037,1775),(24038,1775),(24039,1775),(24040,1775),(24041,1775),(24042,1775),(24043,1775),(24044,1776),(24045,1776),(24046,1776),(24047,1776),(24048,1776),(24049,1776),(24050,1776),(24051,1777),(24052,1777),(24053,1777),(24054,1777),(24055,1777),(24056,1777),(24057,1778),(24058,1778),(24059,1778),(24060,1778),(24061,1778),(24062,1778),(24063,1778),(24064,1779),(24065,1779),(24066,1779),(24067,1779),(24068,1779),(24069,1779),(24070,1779),(24071,1780),(24072,1780),(24073,1780),(24074,1780),(24075,1780),(24076,1780),(24077,1780),(24078,1781),(24079,1781),(24080,1781),(24081,1781),(24082,1781),(24083,1781),(24084,1781),(24085,1782),(24086,1782),(24087,1782),(24088,1782),(24089,1782),(24090,1782),(24091,1782),(24092,1783),(24093,1783),(24094,1783),(24095,1783),(24096,1783),(24097,1783),(24098,1783),(24099,1784),(24100,1784),(24101,1784),(24102,1784),(24103,1784),(24104,1784),(24105,1784),(24106,1785),(24107,1785),(24108,1785),(24109,1785),(24110,1785),(24111,1785),(24112,1786),(24113,1786),(24114,1786),(24115,1786),(24116,1786),(24117,1786),(24118,1786),(24119,1787),(24120,1787),(24121,1787),(24122,1787),(24123,1787),(24124,1787),(24125,1787),(24126,1788),(24127,1788),(24128,1788),(24129,1788),(24130,1788),(24131,1788),(24132,1788),(24133,1789),(24134,1789),(24135,1789),(24136,1789),(24137,1789),(24138,1789),(24139,1789),(24140,1790),(24141,1790),(24142,1790),(24143,1790),(24144,1790),(24145,1790),(24146,1790),(24147,1791),(24148,1791),(24149,1791),(24150,1791),(24151,1791),(24152,1791),(24153,1791),(24154,1791),(24155,1791),(24156,1792),(24157,1792),(24158,1792),(24159,1792),(24160,1792),(24161,1792),(24162,1792),(24163,1792),(24164,1792),(24165,1793),(24166,1793),(24167,1793),(24168,1793),(24169,1793),(24170,1793),(24171,1793),(24172,1794),(24173,1794),(24174,1794),(24175,1794),(24176,1794),(24177,1794),(24178,1794),(24179,1795),(24180,1795),(24181,1795),(24182,1795),(24183,1795),(24184,1795),(24185,1795),(24186,1796),(24187,1796),(24188,1796),(24189,1796),(24190,1796),(24191,1796),(24192,1796),(24193,1796),(24194,1796),(24195,1797),(24196,1797),(24197,1797),(24198,1797),(24199,1797),(24200,1797),(24201,1797),(24202,1797),(24203,1797),(24204,1798),(24205,1798),(24206,1798),(24207,1798),(24208,1798),(24209,1798),(24210,1798),(24211,1798),(24212,1798),(24213,1799),(24214,1799),(24215,1799),(24216,1799),(24217,1799),(24218,1799),(24219,1799),(24220,1800),(24221,1800),(24222,1800),(24223,1800),(24224,1800),(24225,1800),(24226,1800),(24227,1801),(24228,1801),(24229,1801),(24230,1801),(24231,1801),(24232,1801),(24233,1801),(24234,1802),(24235,1802),(24236,1802),(24237,1802),(24238,1802),(24239,1802),(24240,1802),(24241,1803),(24242,1803),(24243,1803),(24244,1803),(24245,1803),(24246,1803),(24247,1803),(24248,1803),(24249,1803),(24250,1804),(24251,1804),(24252,1804),(24253,1804),(24254,1804),(24255,1804),(24256,1804),(24257,1804),(24258,1804),(24259,1805),(24260,1805),(24261,1805),(24262,1805),(24263,1805),(24264,1805),(24265,1805),(24266,1805),(24267,1805),(24268,1806),(24269,1806),(24270,1806),(24271,1806),(24272,1806),(24273,1806),(24274,1806),(24275,1806),(24276,1806),(24277,1807),(24278,1807),(24279,1807),(24280,1807),(24281,1807),(24282,1807),(24283,1807),(24284,1807),(24285,1807),(24286,1808),(24287,1808),(24288,1808),(24289,1808),(24290,1808),(24291,1808),(24292,1808),(24293,1808),(24294,1808),(24295,1809),(24296,1809),(24297,1809),(24298,1809),(24299,1809),(24300,1809),(24301,1809),(24302,1809),(24303,1809),(24304,1810),(24305,1810),(24306,1810),(24307,1810),(24308,1810),(24309,1810),(24310,1810),(24311,1810),(24312,1810),(24313,1811),(24314,1811),(24315,1811),(24316,1811),(24317,1811),(24318,1811),(24319,1811),(24320,1811),(24321,1811),(24322,1812),(24323,1812),(24324,1812),(24325,1812),(24326,1812),(24327,1812),(24328,1766),(24329,1766),(24330,1766),(24331,1767),(24332,1767),(24333,1767),(24334,1768),(24335,1768),(24336,1768),(24337,1769),(24338,1769),(24339,1769),(24340,1770),(24341,1770),(24342,1770),(24343,1771),(24344,1771),(24345,1771),(24346,1772),(24347,1772),(24348,1772),(24349,1773),(24350,1773),(24351,1773),(24352,1774),(24353,1774),(24354,1774),(24355,1775),(24356,1775),(24357,1775),(24358,1776),(24359,1776),(24360,1776),(24361,1777),(24362,1777),(24363,1777),(24364,1778),(24365,1778),(24366,1778),(24367,1779),(24368,1779),(24369,1779),(24370,1780),(24371,1780),(24372,1780),(24373,1781),(24374,1781),(24375,1781),(24376,1782),(24377,1782),(24378,1782),(24379,1783),(24380,1783),(24381,1783),(24382,1784),(24383,1784),(24384,1784),(24385,1785),(24386,1785),(24387,1785),(24388,1786),(24389,1786),(24390,1786),(24391,1787),(24392,1787),(24393,1787),(24394,1788),(24395,1788),(24396,1788),(24397,1789),(24398,1789),(24399,1789),(24400,1790),(24401,1790),(24402,1790),(24403,1791),(24404,1791),(24405,1791),(24406,1792),(24407,1792),(24408,1792),(24409,1793),(24410,1793),(24411,1793),(24412,1794),(24413,1794),(24414,1794),(24415,1795),(24416,1795),(24417,1795),(24418,1796),(24419,1796),(24420,1797),(24421,1797),(24422,1798),(24423,1798),(24424,1798),(24425,1799),(24426,1799),(24427,1799),(24428,1800),(24429,1800),(24430,1800),(24431,1801),(24432,1801),(24433,1801),(24434,1802),(24435,1802),(24436,1802),(24437,1803),(24438,1803),(24439,1803),(24440,1803),(24441,1804),(24442,1804),(24443,1804),(24444,1805),(24445,1805),(24446,1805),(24447,1806),(24448,1806),(24449,1806),(24450,1807),(24451,1807),(24452,1807),(24453,1808),(24454,1808),(24455,1808),(24456,1809),(24457,1809),(24458,1809),(24459,1810),(24460,1810),(24461,1810),(24462,1811),(24463,1811),(24464,1811),(24465,1812),(24466,1812),(24467,1812),(24468,1766),(24469,1766),(24470,1766),(24471,1766),(24472,1767),(24473,1767),(24474,1767),(24475,1767),(24476,1768),(24477,1768),(24478,1768),(24479,1768),(24480,1769),(24481,1769),(24482,1769),(24483,1769),(24484,1770),(24485,1770),(24486,1770),(24487,1770),(24488,1771),(24489,1771),(24490,1771),(24491,1771),(24492,1772),(24493,1772),(24494,1772),(24495,1772),(24496,1773),(24497,1773),(24498,1773),(24499,1773),(24500,1774),(24501,1774),(24502,1774),(24503,1774),(24504,1775),(24505,1775),(24506,1775),(24507,1775),(24508,1776),(24509,1776),(24510,1776),(24511,1776),(24512,1777),(24513,1777),(24514,1777),(24515,1777),(24516,1778),(24517,1778),(24518,1778),(24519,1778),(24520,1779),(24521,1779),(24522,1779),(24523,1779),(24524,1780),(24525,1780),(24526,1780),(24527,1780),(24528,1781),(24529,1781),(24530,1781),(24531,1781),(24532,1782),(24533,1782),(24534,1782),(24535,1782),(24536,1783),(24537,1783),(24538,1783),(24539,1783),(24540,1784),(24541,1784),(24542,1784),(24543,1784),(24544,1785),(24545,1785),(24546,1785),(24547,1785),(24548,1786),(24549,1786),(24550,1786),(24551,1786),(24552,1787),(24553,1787),(24554,1787),(24555,1787),(24556,1788),(24557,1788),(24558,1788),(24559,1788),(24560,1789),(24561,1789),(24562,1789),(24563,1789),(24564,1790),(24565,1790),(24566,1790),(24567,1790),(24568,1791),(24569,1791),(24570,1791),(24571,1791),(24572,1792),(24573,1792),(24574,1792),(24575,1792),(24576,1793),(24577,1793),(24578,1793),(24579,1793),(24580,1794),(24581,1794),(24582,1794),(24583,1794),(24584,1795),(24585,1795),(24586,1795),(24587,1795),(24588,1796),(24589,1796),(24590,1796),(24591,1796),(24592,1797),(24593,1797),(24594,1797),(24595,1797),(24596,1798),(24597,1798),(24598,1798),(24599,1798),(24600,1799),(24601,1799),(24602,1799),(24603,1799),(24604,1800),(24605,1800),(24606,1800),(24607,1800),(24608,1801),(24609,1801),(24610,1801),(24611,1801),(24612,1802),(24613,1802),(24614,1802),(24615,1802),(24616,1803),(24617,1803),(24618,1803),(24619,1803),(24620,1804),(24621,1804),(24622,1804),(24623,1804),(24624,1805),(24625,1805),(24626,1805),(24627,1805),(24628,1806),(24629,1806),(24630,1806),(24631,1806),(24632,1807),(24633,1807),(24634,1807),(24635,1807),(24636,1808),(24637,1808),(24638,1808),(24639,1808),(24640,1809),(24641,1809),(24642,1809),(24643,1809),(24644,1810),(24645,1810),(24646,1810),(24647,1810),(24648,1811),(24649,1811),(24650,1811),(24651,1811),(24652,1812),(24653,1812),(24654,1812),(24655,1812),(24656,1813),(24657,1813),(24658,1813),(24659,1813),(24660,1813),(24661,1813),(24662,1813),(24663,1814),(24664,1814),(24665,1814),(24666,1814),(24667,1814),(24668,1814),(24669,1814),(24670,1815),(24671,1815),(24672,1815),(24673,1815),(24674,1815),(24675,1815),(24676,1815),(24677,1816),(24678,1816),(24679,1816),(24680,1816),(24681,1816),(24682,1816),(24683,1816),(24684,1817),(24685,1817),(24686,1817),(24687,1817),(24688,1817),(24689,1817),(24690,1817),(24691,1818),(24692,1818),(24693,1818),(24694,1818),(24695,1818),(24696,1818),(24697,1818),(24698,1819),(24699,1819),(24700,1819),(24701,1819),(24702,1819),(24703,1819),(24704,1819),(24705,1820),(24706,1820),(24707,1820),(24708,1820),(24709,1820),(24710,1820),(24711,1820),(24712,1821),(24713,1821),(24714,1821),(24715,1821),(24716,1821),(24717,1821),(24718,1821),(24719,1822),(24720,1822),(24721,1822),(24722,1822),(24723,1822),(24724,1822),(24725,1822),(24726,1823),(24727,1823),(24728,1823),(24729,1823),(24730,1823),(24731,1823),(24732,1823),(24733,1813),(24734,1813),(24735,1813),(24736,1814),(24737,1814),(24738,1814),(24739,1815),(24740,1815),(24741,1815),(24742,1816),(24743,1816),(24744,1816),(24745,1817),(24746,1817),(24747,1817),(24748,1818),(24749,1818),(24750,1818),(24751,1819),(24752,1819),(24753,1819),(24754,1820),(24755,1820),(24756,1820),(24757,1821),(24758,1821),(24759,1821),(24760,1822),(24761,1822),(24762,1822),(24763,1823),(24764,1823),(24765,1823),(24766,1813),(24767,1813),(24768,1813),(24769,1813),(24770,1814),(24771,1814),(24772,1814),(24773,1814),(24774,1815),(24775,1815),(24776,1815),(24777,1815),(24778,1816),(24779,1816),(24780,1816),(24781,1816),(24782,1817),(24783,1817),(24784,1817),(24785,1817),(24786,1818),(24787,1818),(24788,1818),(24789,1818),(24790,1819),(24791,1819),(24792,1819),(24793,1819),(24794,1820),(24795,1820),(24796,1820),(24797,1820),(24798,1821),(24799,1821),(24800,1821),(24801,1821),(24802,1822),(24803,1822),(24804,1822),(24805,1822),(24806,1823),(24807,1823),(24808,1823),(24809,1823),(24810,1824),(24811,1824),(24812,1824),(24813,1824),(24814,1824),(24815,1824),(24816,1824),(24817,1824),(24818,1824),(24819,1825),(24820,1825),(24821,1825),(24822,1825),(24823,1825),(24824,1825),(24825,1825),(24826,1826),(24827,1826),(24828,1826),(24829,1826),(24830,1826),(24831,1826),(24832,1826),(24833,1827),(24834,1827),(24835,1827),(24836,1827),(24837,1827),(24838,1827),(24839,1827),(24840,1828),(24841,1828),(24842,1828),(24843,1828),(24844,1828),(24845,1828),(24846,1828),(24847,1829),(24848,1829),(24849,1829),(24850,1829),(24851,1829),(24852,1829),(24853,1829),(24854,1830),(24855,1830),(24856,1830),(24857,1830),(24858,1830),(24859,1830),(24860,1830),(24861,1831),(24862,1831),(24863,1831),(24864,1831),(24865,1831),(24866,1831),(24867,1831),(24868,1832),(24869,1832),(24870,1832),(24871,1832),(24872,1832),(24873,1832),(24874,1832),(24875,1833),(24876,1833),(24877,1833),(24878,1833),(24879,1833),(24880,1833),(24881,1833),(24882,1834),(24883,1834),(24884,1834),(24885,1834),(24886,1834),(24887,1834),(24888,1835),(24889,1835),(24890,1835),(24891,1835),(24892,1836),(24893,1836),(24894,1836),(24895,1836),(24896,1836),(24897,1836),(24898,1836),(24899,1836),(24900,1836),(24901,1837),(24902,1837),(24903,1837),(24904,1837),(24905,1837),(24906,1837),(24907,1837),(24908,1837),(24909,1837),(24910,1838),(24911,1838),(24912,1838),(24913,1838),(24914,1838),(24915,1838),(24916,1838),(24917,1838),(24918,1838),(24919,1839),(24920,1839),(24921,1839),(24922,1839),(24923,1839),(24924,1839),(24925,1839),(24926,1839),(24927,1839),(24928,1840),(24929,1840),(24930,1840),(24931,1840),(24932,1840),(24933,1840),(24934,1840),(24935,1840),(24936,1840),(24937,1841),(24938,1841),(24939,1841),(24940,1841),(24941,1841),(24942,1841),(24943,1841),(24944,1841),(24945,1841),(24946,1842),(24947,1842),(24948,1842),(24949,1842),(24950,1842),(24951,1842),(24952,1842),(24953,1842),(24954,1842),(24955,1843),(24956,1843),(24957,1843),(24958,1843),(24959,1843),(24960,1843),(24961,1843),(24962,1843),(24963,1843),(24964,1844),(24965,1844),(24966,1844),(24967,1844),(24968,1844),(24969,1844),(24970,1844),(24971,1844),(24972,1844),(24973,1845),(24974,1845),(24975,1845),(24976,1845),(24977,1845),(24978,1845),(24979,1845),(24980,1845),(24981,1845),(24982,1846),(24983,1846),(24984,1846),(24985,1846),(24986,1846),(24987,1846),(24988,1846),(24989,1846),(24990,1846),(24991,1847),(24992,1847),(24993,1847),(24994,1847),(24995,1847),(24996,1847),(24997,1847),(24998,1847),(24999,1847),(25000,1848),(25001,1848),(25002,1848),(25003,1848),(25004,1848),(25005,1848),(25006,1848),(25007,1848),(25008,1848),(25009,1849),(25010,1849),(25011,1849),(25012,1849),(25013,1849),(25014,1849),(25015,1849),(25016,1849),(25017,1849),(25018,1850),(25019,1850),(25020,1850),(25021,1850),(25022,1850),(25023,1850),(25024,1850),(25025,1850),(25026,1850),(25027,1851),(25028,1851),(25029,1851),(25030,1851),(25031,1851),(25032,1851),(25033,1851),(25034,1851),(25035,1851),(25036,1852),(25037,1852),(25038,1852),(25039,1852),(25040,1852),(25041,1852),(25042,1852),(25043,1852),(25044,1852),(25045,1853),(25046,1853),(25047,1853),(25048,1853),(25049,1853),(25050,1853),(25051,1853),(25052,1853),(25053,1853),(25054,1854),(25055,1854),(25056,1854),(25057,1854),(25058,1854),(25059,1854),(25060,1854),(25061,1854),(25062,1854),(25063,1855),(25064,1855),(25065,1855),(25066,1855),(25067,1855),(25068,1855),(25069,1855),(25070,1855),(25071,1855),(25072,1856),(25073,1856),(25074,1856),(25075,1856),(25076,1856),(25077,1856),(25078,1856),(25079,1856),(25080,1856),(25081,1857),(25082,1857),(25083,1857),(25084,1857),(25085,1857),(25086,1857),(25087,1857),(25088,1857),(25089,1857),(25090,1858),(25091,1858),(25092,1858),(25093,1858),(25094,1858),(25095,1858),(25096,1858),(25097,1858),(25098,1858),(25099,1859),(25100,1859),(25101,1859),(25102,1859),(25103,1859),(25104,1859),(25105,1859),(25106,1859),(25107,1859),(25108,1860),(25109,1860),(25110,1860),(25111,1860),(25112,1860),(25113,1860),(25114,1860),(25115,1860),(25116,1860),(25117,1861),(25118,1861),(25119,1861),(25120,1861),(25121,1861),(25122,1861),(25123,1861),(25124,1861),(25125,1861),(25126,1862),(25127,1862),(25128,1862),(25129,1862),(25130,1862),(25131,1862),(25132,1862),(25133,1862),(25134,1862),(25135,1863),(25136,1863),(25137,1863),(25138,1863),(25139,1863),(25140,1863),(25141,1863),(25142,1863),(25143,1863),(25144,1864),(25145,1864),(25146,1864),(25147,1864),(25148,1864),(25149,1864),(25150,1864),(25151,1864),(25152,1864),(25153,1865),(25154,1865),(25155,1865),(25156,1865),(25157,1865),(25158,1865),(25159,1865),(25160,1865),(25161,1865),(25162,1866),(25163,1866),(25164,1866),(25165,1866),(25166,1866),(25167,1866),(25168,1866),(25169,1867),(25170,1867),(25171,1867),(25172,1867),(25173,1867),(25174,1867),(25175,1867),(25176,1867),(25177,1867),(25178,1868),(25179,1868),(25180,1868),(25181,1868),(25182,1868),(25183,1868),(25184,1868),(25185,1869),(25186,1869),(25187,1869),(25188,1869),(25189,1869),(25190,1869),(25191,1869),(25192,1869),(25193,1869),(25194,1870),(25195,1870),(25196,1870),(25197,1870),(25198,1870),(25199,1870),(25200,1870),(25201,1870),(25202,1870),(25203,1871),(25204,1871),(25205,1871),(25206,1871),(25207,1871),(25208,1871),(25209,1871),(25210,1871),(25211,1871),(25212,1872),(25213,1872),(25214,1872),(25215,1872),(25216,1872),(25217,1872),(25218,1872),(25219,1872),(25220,1872),(25221,1873),(25222,1873),(25223,1873),(25224,1873),(25225,1873),(25226,1873),(25227,1873),(25228,1873),(25229,1873),(25230,1874),(25231,1874),(25232,1874),(25233,1874),(25234,1874),(25235,1874),(25236,1874),(25237,1874),(25238,1874),(25239,1875),(25240,1875),(25241,1875),(25242,1875),(25243,1875),(25244,1875),(25245,1875),(25246,1875),(25247,1875),(25248,1876),(25249,1876),(25250,1876),(25251,1876),(25252,1876),(25253,1876),(25254,1876),(25255,1876),(25256,1876),(25257,1877),(25258,1877),(25259,1877),(25260,1877),(25261,1877),(25262,1877),(25263,1877),(25264,1878),(25265,1878),(25266,1878),(25267,1878),(25268,1878),(25269,1878),(25270,1878),(25271,1879),(25272,1879),(25273,1879),(25274,1879),(25275,1879),(25276,1879),(25277,1879),(25278,1879),(25279,1879),(25280,1880),(25281,1880),(25282,1880),(25283,1880),(25284,1880),(25285,1880),(25286,1880),(25287,1881),(25288,1881),(25289,1881),(25290,1881),(25291,1881),(25292,1881),(25293,1881),(25294,1882),(25295,1882),(25296,1882),(25297,1882),(25298,1882),(25299,1882),(25300,1882),(25301,1882),(25302,1882),(25303,1883),(25304,1883),(25305,1883),(25306,1883),(25307,1883),(25308,1883),(25309,1883),(25310,1883),(25311,1883),(25312,1884),(25313,1884),(25314,1884),(25315,1884),(25316,1884),(25317,1884),(25318,1884),(25319,1884),(25320,1884),(25321,1885),(25322,1885),(25323,1885),(25324,1885),(25325,1885),(25326,1885),(25327,1885),(25328,1885),(25329,1885),(25330,1886),(25331,1886),(25332,1886),(25333,1886),(25334,1886),(25335,1886),(25336,1886),(25337,1886),(25338,1886),(25339,1887),(25340,1887),(25341,1887),(25342,1887),(25343,1887),(25344,1887),(25345,1887),(25346,1887),(25347,1887),(25348,1888),(25349,1888),(25350,1888),(25351,1888),(25352,1888),(25353,1888),(25354,1888),(25355,1888),(25356,1888),(25357,1889),(25358,1889),(25359,1889),(25360,1889),(25361,1889),(25362,1889),(25363,1889),(25364,1889),(25365,1889),(25366,1890),(25367,1890),(25368,1890),(25369,1890),(25370,1890),(25371,1890),(25372,1890),(25373,1890),(25374,1890),(25375,1891),(25376,1891),(25377,1891),(25378,1891),(25379,1891),(25380,1891),(25381,1891),(25382,1891),(25383,1891),(25384,1892),(25385,1892),(25386,1892),(25387,1892),(25388,1892),(25389,1892),(25390,1892),(25391,1892),(25392,1892),(25393,1893),(25394,1893),(25395,1893),(25396,1893),(25397,1893),(25398,1893),(25399,1893),(25400,1893),(25401,1893),(25402,1894),(25403,1894),(25404,1894),(25405,1894),(25406,1894),(25407,1894),(25408,1894),(25409,1894),(25410,1894),(25411,1895),(25412,1895),(25413,1895),(25414,1895),(25415,1895),(25416,1895),(25417,1895),(25418,1895),(25419,1895),(25420,1896),(25421,1896),(25422,1896),(25423,1896),(25424,1896),(25425,1896),(25426,1896),(25427,1896),(25428,1896),(25429,1897),(25430,1897),(25431,1897),(25432,1897),(25433,1897),(25434,1897),(25435,1897),(25436,1897),(25437,1897),(25438,1898),(25439,1898),(25440,1898),(25441,1898),(25442,1898),(25443,1898),(25444,1898),(25445,1898),(25446,1898),(25447,1899),(25448,1899),(25449,1899),(25450,1899),(25451,1899),(25452,1899),(25453,1899),(25454,1899),(25455,1899),(25456,1900),(25457,1900),(25458,1900),(25459,1900),(25460,1900),(25461,1900),(25462,1900),(25463,1900),(25464,1900),(25465,1901),(25466,1901),(25467,1901),(25468,1901),(25469,1901),(25470,1901),(25471,1901),(25472,1901),(25473,1901),(25474,1902),(25475,1902),(25476,1902),(25477,1902),(25478,1902),(25479,1902),(25480,1902),(25481,1902),(25482,1902),(25483,1903),(25484,1903),(25485,1903),(25486,1903),(25487,1903),(25488,1903),(25489,1903),(25490,1903),(25491,1903),(25492,1904),(25493,1904),(25494,1904),(25495,1904),(25496,1904),(25497,1904),(25498,1904),(25499,1904),(25500,1904),(25501,1905),(25502,1905),(25503,1905),(25504,1905),(25505,1905),(25506,1905),(25507,1905),(25508,1905),(25509,1905),(25510,1906),(25511,1906),(25512,1906),(25513,1906),(25514,1906),(25515,1906),(25516,1906),(25517,1906),(25518,1906),(25519,1907),(25520,1907),(25521,1907),(25522,1907),(25523,1907),(25524,1907),(25525,1907),(25526,1907),(25527,1907),(25528,1908),(25529,1908),(25530,1908),(25531,1908),(25532,1908),(25533,1908),(25534,1908),(25535,1908),(25536,1908),(25537,1909),(25538,1909),(25539,1909),(25540,1909),(25541,1909),(25542,1909),(25543,1909),(25544,1909),(25545,1909),(25546,1910),(25547,1910),(25548,1910),(25549,1910),(25550,1910),(25551,1910),(25552,1910),(25553,1910),(25554,1910),(25555,1911),(25556,1911),(25557,1911),(25558,1911),(25559,1911),(25560,1911),(25561,1911),(25562,1911),(25563,1911),(25564,1912),(25565,1912),(25566,1912),(25567,1912),(25568,1912),(25569,1912),(25570,1912),(25571,1912),(25572,1912),(25573,1824),(25574,1824),(25575,1824),(25576,1825),(25577,1825),(25578,1825),(25579,1826),(25580,1826),(25581,1826),(25582,1827),(25583,1827),(25584,1827),(25585,1828),(25586,1828),(25587,1828),(25588,1829),(25589,1829),(25590,1829),(25591,1830),(25592,1830),(25593,1830),(25594,1831),(25595,1831),(25596,1831),(25597,1832),(25598,1832),(25599,1832),(25600,1833),(25601,1833),(25602,1833),(25603,1834),(25604,1834),(25605,1834),(25606,1835),(25607,1835),(25608,1835),(25609,1836),(25610,1836),(25611,1836),(25612,1837),(25613,1837),(25614,1837),(25615,1838),(25616,1838),(25617,1838),(25618,1839),(25619,1839),(25620,1839),(25621,1840),(25622,1840),(25623,1840),(25624,1841),(25625,1841),(25626,1841),(25627,1842),(25628,1842),(25629,1842),(25630,1843),(25631,1843),(25632,1843),(25633,1844),(25634,1844),(25635,1844),(25636,1845),(25637,1845),(25638,1845),(25639,1846),(25640,1846),(25641,1846),(25642,1847),(25643,1847),(25644,1847),(25645,1848),(25646,1848),(25647,1848),(25648,1849),(25649,1849),(25650,1849),(25651,1850),(25652,1850),(25653,1850),(25654,1851),(25655,1851),(25656,1851),(25657,1852),(25658,1852),(25659,1852),(25660,1853),(25661,1853),(25662,1853),(25663,1854),(25664,1854),(25665,1854),(25666,1855),(25667,1855),(25668,1855),(25669,1856),(25670,1856),(25671,1856),(25672,1857),(25673,1857),(25674,1857),(25675,1858),(25676,1858),(25677,1858),(25678,1859),(25679,1859),(25680,1859),(25681,1860),(25682,1860),(25683,1860),(25684,1861),(25685,1861),(25686,1861),(25687,1862),(25688,1862),(25689,1862),(25690,1863),(25691,1863),(25692,1863),(25693,1864),(25694,1864),(25695,1864),(25696,1865),(25697,1865),(25698,1865),(25699,1866),(25700,1866),(25701,1866),(25702,1867),(25703,1867),(25704,1867),(25705,1868),(25706,1868),(25707,1868),(25708,1869),(25709,1869),(25710,1869),(25711,1870),(25712,1870),(25713,1870),(25714,1871),(25715,1871),(25716,1871),(25717,1872),(25718,1872),(25719,1872),(25720,1873),(25721,1873),(25722,1873),(25723,1874),(25724,1874),(25725,1874),(25726,1875),(25727,1875),(25728,1875),(25729,1876),(25730,1876),(25731,1876),(25732,1877),(25733,1877),(25734,1877),(25735,1878),(25736,1878),(25737,1878),(25738,1879),(25739,1879),(25740,1879),(25741,1880),(25742,1880),(25743,1880),(25744,1881),(25745,1881),(25746,1881),(25747,1882),(25748,1882),(25749,1882),(25750,1883),(25751,1883),(25752,1883),(25753,1884),(25754,1884),(25755,1884),(25756,1885),(25757,1885),(25758,1885),(25759,1886),(25760,1886),(25761,1886),(25762,1887),(25763,1887),(25764,1887),(25765,1888),(25766,1888),(25767,1888),(25768,1889),(25769,1889),(25770,1889),(25771,1890),(25772,1890),(25773,1890),(25774,1891),(25775,1891),(25776,1891),(25777,1892),(25778,1892),(25779,1892),(25780,1893),(25781,1893),(25782,1893),(25783,1894),(25784,1894),(25785,1894),(25786,1895),(25787,1895),(25788,1895),(25789,1896),(25790,1896),(25791,1896),(25792,1897),(25793,1897),(25794,1897),(25795,1898),(25796,1898),(25797,1898),(25798,1899),(25799,1899),(25800,1899),(25801,1900),(25802,1900),(25803,1900),(25804,1901),(25805,1901),(25806,1901),(25807,1902),(25808,1902),(25809,1902),(25810,1903),(25811,1903),(25812,1903),(25813,1904),(25814,1904),(25815,1904),(25816,1905),(25817,1905),(25818,1905),(25819,1906),(25820,1906),(25821,1906),(25822,1907),(25823,1907),(25824,1907),(25825,1908),(25826,1908),(25827,1908),(25828,1909),(25829,1909),(25830,1909),(25831,1910),(25832,1910),(25833,1910),(25834,1911),(25835,1911),(25836,1911),(25837,1912),(25838,1912),(25839,1912),(25840,1824),(25841,1824),(25842,1824),(25843,1824),(25844,1825),(25845,1825),(25846,1825),(25847,1825),(25848,1826),(25849,1826),(25850,1826),(25851,1826),(25852,1827),(25853,1827),(25854,1827),(25855,1827),(25856,1828),(25857,1828),(25858,1828),(25859,1828),(25860,1829),(25861,1829),(25862,1829),(25863,1829),(25864,1830),(25865,1830),(25866,1830),(25867,1830),(25868,1831),(25869,1831),(25870,1831),(25871,1831),(25872,1832),(25873,1832),(25874,1832),(25875,1832),(25876,1833),(25877,1833),(25878,1833),(25879,1833),(25880,1834),(25881,1834),(25882,1834),(25883,1834),(25884,1835),(25885,1835),(25886,1835),(25887,1835),(25888,1836),(25889,1836),(25890,1836),(25891,1836),(25892,1837),(25893,1837),(25894,1837),(25895,1837),(25896,1838),(25897,1838),(25898,1838),(25899,1838),(25900,1839),(25901,1839),(25902,1839),(25903,1839),(25904,1840),(25905,1840),(25906,1840),(25907,1840),(25908,1841),(25909,1841),(25910,1841),(25911,1841),(25912,1842),(25913,1842),(25914,1842),(25915,1842),(25916,1843),(25917,1843),(25918,1843),(25919,1843),(25920,1844),(25921,1844),(25922,1844),(25923,1844),(25924,1845),(25925,1845),(25926,1845),(25927,1845),(25928,1846),(25929,1846),(25930,1846),(25931,1846),(25932,1847),(25933,1847),(25934,1847),(25935,1847),(25936,1848),(25937,1848),(25938,1848),(25939,1848),(25940,1849),(25941,1849),(25942,1849),(25943,1849),(25944,1850),(25945,1850),(25946,1850),(25947,1850),(25948,1851),(25949,1851),(25950,1851),(25951,1851),(25952,1852),(25953,1852),(25954,1852),(25955,1852),(25956,1853),(25957,1853),(25958,1853),(25959,1853),(25960,1854),(25961,1854),(25962,1854),(25963,1854),(25964,1855),(25965,1855),(25966,1855),(25967,1855),(25968,1856),(25969,1856),(25970,1856),(25971,1856),(25972,1857),(25973,1857),(25974,1857),(25975,1857),(25976,1858),(25977,1858),(25978,1858),(25979,1858),(25980,1859),(25981,1859),(25982,1859),(25983,1859),(25984,1860),(25985,1860),(25986,1860),(25987,1860),(25988,1861),(25989,1861),(25990,1861),(25991,1861),(25992,1862),(25993,1862),(25994,1862),(25995,1862),(25996,1863),(25997,1863),(25998,1863),(25999,1863),(26000,1864),(26001,1864),(26002,1864),(26003,1864),(26004,1865),(26005,1865),(26006,1865),(26007,1865),(26008,1866),(26009,1866),(26010,1866),(26011,1866),(26012,1867),(26013,1867),(26014,1867),(26015,1867),(26016,1868),(26017,1868),(26018,1868),(26019,1868),(26020,1869),(26021,1869),(26022,1869),(26023,1869),(26024,1870),(26025,1870),(26026,1870),(26027,1870),(26028,1871),(26029,1871),(26030,1871),(26031,1871),(26032,1872),(26033,1872),(26034,1872),(26035,1872),(26036,1873),(26037,1873),(26038,1873),(26039,1873),(26040,1874),(26041,1874),(26042,1874),(26043,1874),(26044,1875),(26045,1875),(26046,1875),(26047,1875),(26048,1876),(26049,1876),(26050,1876),(26051,1876),(26052,1877),(26053,1877),(26054,1877),(26055,1877),(26056,1878),(26057,1878),(26058,1878),(26059,1878),(26060,1879),(26061,1879),(26062,1879),(26063,1879),(26064,1880),(26065,1880),(26066,1880),(26067,1880),(26068,1881),(26069,1881),(26070,1881),(26071,1881),(26072,1882),(26073,1882),(26074,1882),(26075,1882),(26076,1883),(26077,1883),(26078,1883),(26079,1883),(26080,1884),(26081,1884),(26082,1884),(26083,1884),(26084,1885),(26085,1885),(26086,1885),(26087,1885),(26088,1886),(26089,1886),(26090,1886),(26091,1886),(26092,1887),(26093,1887),(26094,1887),(26095,1887),(26096,1888),(26097,1888),(26098,1888),(26099,1888),(26100,1889),(26101,1889),(26102,1889),(26103,1889),(26104,1890),(26105,1890),(26106,1890),(26107,1890),(26108,1891),(26109,1891),(26110,1891),(26111,1891),(26112,1892),(26113,1892),(26114,1892),(26115,1892),(26116,1893),(26117,1893),(26118,1893),(26119,1893),(26120,1894),(26121,1894),(26122,1894),(26123,1894),(26124,1895),(26125,1895),(26126,1895),(26127,1895),(26128,1896),(26129,1896),(26130,1896),(26131,1896),(26132,1897),(26133,1897),(26134,1897),(26135,1897),(26136,1898),(26137,1898),(26138,1898),(26139,1898),(26140,1899),(26141,1899),(26142,1899),(26143,1899),(26144,1900),(26145,1900),(26146,1900),(26147,1900),(26148,1901),(26149,1901),(26150,1901),(26151,1901),(26152,1902),(26153,1902),(26154,1902),(26155,1902),(26156,1903),(26157,1903),(26158,1903),(26159,1903),(26160,1904),(26161,1904),(26162,1904),(26163,1904),(26164,1905),(26165,1905),(26166,1905),(26167,1905),(26168,1906),(26169,1906),(26170,1906),(26171,1906),(26172,1907),(26173,1907),(26174,1907),(26175,1907),(26176,1908),(26177,1908),(26178,1908),(26179,1908),(26180,1909),(26181,1909),(26182,1909),(26183,1909),(26184,1910),(26185,1910),(26186,1910),(26187,1910),(26188,1911),(26189,1911),(26190,1911),(26191,1911),(26192,1912),(26193,1912),(26194,1912),(26195,1912),(26196,1913),(26197,1913),(26198,1913),(26199,1913),(26200,1913),(26201,1913),(26202,1913),(26203,1913),(26204,1913),(26205,1914),(26206,1914),(26207,1914),(26208,1914),(26209,1914),(26210,1914),(26211,1914),(26212,1914),(26213,1914),(26214,1915),(26215,1915),(26216,1915),(26217,1915),(26218,1915),(26219,1915),(26220,1915),(26221,1915),(26222,1915),(26223,1916),(26224,1916),(26225,1916),(26226,1916),(26227,1916),(26228,1916),(26229,1916),(26230,1916),(26231,1916),(26232,1917),(26233,1917),(26234,1917),(26235,1917),(26236,1917),(26237,1917),(26238,1917),(26239,1917),(26240,1917),(26241,1918),(26242,1918),(26243,1918),(26244,1918),(26245,1918),(26246,1918),(26247,1918),(26248,1918),(26249,1918),(26250,1919),(26251,1919),(26252,1919),(26253,1919),(26254,1919),(26255,1919),(26256,1919),(26257,1919),(26258,1919),(26259,1920),(26260,1920),(26261,1920),(26262,1920),(26263,1920),(26264,1920),(26265,1920),(26266,1920),(26267,1920),(26268,1921),(26269,1921),(26270,1921),(26271,1921),(26272,1921),(26273,1921),(26274,1921),(26275,1921),(26276,1921),(26277,1922),(26278,1922),(26279,1922),(26280,1922),(26281,1922),(26282,1922),(26283,1922),(26284,1922),(26285,1922),(26286,1923),(26287,1923),(26288,1923),(26289,1923),(26290,1923),(26291,1923),(26292,1923),(26293,1923),(26294,1923),(26295,1924),(26296,1924),(26297,1924),(26298,1924),(26299,1924),(26300,1924),(26301,1924),(26302,1924),(26303,1924),(26304,1925),(26305,1925),(26306,1925),(26307,1925),(26308,1925),(26309,1925),(26310,1925),(26311,1925),(26312,1925),(26313,1926),(26314,1926),(26315,1926),(26316,1926),(26317,1926),(26318,1926),(26319,1926),(26320,1926),(26321,1926),(26322,1927),(26323,1927),(26324,1927),(26325,1927),(26326,1927),(26327,1927),(26328,1927),(26329,1927),(26330,1927),(26331,1928),(26332,1928),(26333,1928),(26334,1928),(26335,1928),(26336,1928),(26337,1928),(26338,1928),(26339,1928),(26340,1929),(26341,1929),(26342,1929),(26343,1929),(26344,1929),(26345,1929),(26346,1929),(26347,1929),(26348,1929),(26349,1930),(26350,1930),(26351,1930),(26352,1930),(26353,1930),(26354,1930),(26355,1930),(26356,1930),(26357,1930),(26358,1931),(26359,1931),(26360,1931),(26361,1931),(26362,1931),(26363,1931),(26364,1931),(26365,1931),(26366,1931),(26367,1932),(26368,1932),(26369,1932),(26370,1932),(26371,1932),(26372,1932),(26373,1932),(26374,1932),(26375,1932),(26376,1933),(26377,1933),(26378,1933),(26379,1933),(26380,1933),(26381,1933),(26382,1933),(26383,1933),(26384,1933),(26385,1934),(26386,1934),(26387,1934),(26388,1934),(26389,1934),(26390,1934),(26391,1934),(26392,1934),(26393,1934),(26394,1935),(26395,1935),(26396,1935),(26397,1935),(26398,1935),(26399,1935),(26400,1935),(26401,1935),(26402,1935),(26403,1936),(26404,1936),(26405,1936),(26406,1936),(26407,1936),(26408,1936),(26409,1936),(26410,1936),(26411,1936),(26412,1937),(26413,1937),(26414,1937),(26415,1937),(26416,1937),(26417,1937),(26418,1937),(26419,1938),(26420,1938),(26421,1938),(26422,1938),(26423,1938),(26424,1938),(26425,1938),(26426,1939),(26427,1939),(26428,1939),(26429,1939),(26430,1939),(26431,1939),(26432,1939),(26433,1939),(26434,1939),(26435,1940),(26436,1940),(26437,1940),(26438,1940),(26439,1940),(26440,1940),(26441,1940),(26442,1940),(26443,1940),(26444,1941),(26445,1941),(26446,1941),(26447,1941),(26448,1941),(26449,1941),(26450,1941),(26451,1941),(26452,1941),(26453,1942),(26454,1942),(26455,1942),(26456,1942),(26457,1942),(26458,1942),(26459,1942),(26460,1942),(26461,1942),(26462,1943),(26463,1943),(26464,1943),(26465,1943),(26466,1943),(26467,1943),(26468,1943),(26469,1943),(26470,1943),(26471,1944),(26472,1944),(26473,1944),(26474,1944),(26475,1944),(26476,1944),(26477,1944),(26478,1944),(26479,1944),(26480,1945),(26481,1945),(26482,1945),(26483,1945),(26484,1945),(26485,1945),(26486,1945),(26487,1945),(26488,1945),(26489,1946),(26490,1946),(26491,1946),(26492,1946),(26493,1946),(26494,1946),(26495,1946),(26496,1946),(26497,1946),(26498,1947),(26499,1947),(26500,1947),(26501,1947),(26502,1947),(26503,1947),(26504,1947),(26505,1947),(26506,1947),(26507,1948),(26508,1948),(26509,1948),(26510,1948),(26511,1948),(26512,1948),(26513,1948),(26514,1948),(26515,1948),(26516,1949),(26517,1949),(26518,1949),(26519,1949),(26520,1949),(26521,1949),(26522,1949),(26523,1949),(26524,1949),(26525,1950),(26526,1950),(26527,1950),(26528,1950),(26529,1950),(26530,1950),(26531,1950),(26532,1951),(26533,1951),(26534,1951),(26535,1951),(26536,1951),(26537,1951),(26538,1951),(26539,1952),(26540,1952),(26541,1952),(26542,1952),(26543,1952),(26544,1952),(26545,1952),(26546,1953),(26547,1953),(26548,1953),(26549,1953),(26550,1953),(26551,1953),(26552,1954),(26553,1954),(26554,1954),(26555,1954),(26556,1954),(26557,1954),(26558,1955),(26559,1955),(26560,1955),(26561,1955),(26562,1955),(26563,1955),(26564,1956),(26565,1956),(26566,1956),(26567,1956),(26568,1956),(26569,1956),(26570,1957),(26571,1957),(26572,1957),(26573,1957),(26574,1957),(26575,1957),(26576,1958),(26577,1958),(26578,1958),(26579,1958),(26580,1958),(26581,1958),(26582,1959),(26583,1959),(26584,1959),(26585,1959),(26586,1959),(26587,1959),(26588,1959),(26589,1960),(26590,1960),(26591,1960),(26592,1960),(26593,1960),(26594,1960),(26595,1960),(26596,1961),(26597,1961),(26598,1961),(26599,1961),(26600,1961),(26601,1961),(26602,1961),(26603,1962),(26604,1962),(26605,1962),(26606,1962),(26607,1962),(26608,1962),(26609,1962),(26610,1963),(26611,1963),(26612,1963),(26613,1963),(26614,1963),(26615,1963),(26616,1963),(26617,1964),(26618,1964),(26619,1964),(26620,1964),(26621,1964),(26622,1964),(26623,1964),(26624,1965),(26625,1965),(26626,1965),(26627,1965),(26628,1965),(26629,1965),(26630,1965),(26631,1966),(26632,1966),(26633,1966),(26634,1966),(26635,1966),(26636,1966),(26637,1966),(26638,1967),(26639,1967),(26640,1967),(26641,1967),(26642,1967),(26643,1967),(26644,1967),(26645,1968),(26646,1968),(26647,1968),(26648,1968),(26649,1968),(26650,1968),(26651,1968),(26652,1969),(26653,1969),(26654,1969),(26655,1969),(26656,1969),(26657,1969),(26658,1969),(26659,1970),(26660,1970),(26661,1970),(26662,1970),(26663,1970),(26664,1970),(26665,1970),(26666,1971),(26667,1971),(26668,1971),(26669,1971),(26670,1971),(26671,1971),(26672,1971),(26673,1972),(26674,1972),(26675,1972),(26676,1972),(26677,1972),(26678,1973),(26679,1973),(26680,1973),(26681,1973),(26682,1973),(26683,1973),(26684,1973),(26685,1974),(26686,1974),(26687,1974),(26688,1974),(26689,1974),(26690,1974),(26691,1974),(26692,1975),(26693,1975),(26694,1975),(26695,1975),(26696,1975),(26697,1975),(26698,1975),(26699,1976),(26700,1976),(26701,1976),(26702,1976),(26703,1976),(26704,1976),(26705,1976),(26706,1977),(26707,1977),(26708,1977),(26709,1977),(26710,1977),(26711,1977),(26712,1977),(26713,1978),(26714,1978),(26715,1978),(26716,1978),(26717,1978),(26718,1978),(26719,1978),(26720,1979),(26721,1979),(26722,1979),(26723,1979),(26724,1979),(26725,1979),(26726,1979),(26727,1980),(26728,1980),(26729,1980),(26730,1980),(26731,1980),(26732,1980),(26733,1980),(26734,1981),(26735,1981),(26736,1981),(26737,1981),(26738,1981),(26739,1981),(26740,1981),(26741,1982),(26742,1982),(26743,1982),(26744,1982),(26745,1982),(26746,1982),(26747,1982),(26748,1983),(26749,1983),(26750,1983),(26751,1983),(26752,1983),(26753,1983),(26754,1983),(26755,1984),(26756,1984),(26757,1984),(26758,1984),(26759,1984),(26760,1984),(26761,1984),(26762,1985),(26763,1985),(26764,1985),(26765,1985),(26766,1985),(26767,1985),(26768,1985),(26769,1986),(26770,1986),(26771,1986),(26772,1986),(26773,1986),(26774,1986),(26775,1986),(26776,1987),(26777,1987),(26778,1987),(26779,1987),(26780,1987),(26781,1987),(26782,1987),(26783,1988),(26784,1988),(26785,1988),(26786,1988),(26787,1988),(26788,1988),(26789,1988),(26790,1989),(26791,1989),(26792,1989),(26793,1989),(26794,1989),(26795,1989),(26796,1989),(26797,1990),(26798,1990),(26799,1990),(26800,1990),(26801,1990),(26802,1990),(26803,1990),(26804,1991),(26805,1991),(26806,1991),(26807,1991),(26808,1991),(26809,1991),(26810,1991),(26811,1991),(26812,1991),(26813,1992),(26814,1992),(26815,1992),(26816,1992),(26817,1992),(26818,1992),(26819,1992),(26820,1993),(26821,1993),(26822,1993),(26823,1993),(26824,1993),(26825,1993),(26826,1993),(26827,1994),(26828,1994),(26829,1994),(26830,1994),(26831,1994),(26832,1994),(26833,1994),(26834,1995),(26835,1995),(26836,1995),(26837,1995),(26838,1995),(26839,1995),(26840,1995),(26841,1996),(26842,1996),(26843,1996),(26844,1996),(26845,1996),(26846,1996),(26847,1996),(26848,1997),(26849,1997),(26850,1997),(26851,1997),(26852,1997),(26853,1997),(26854,1997),(26855,1998),(26856,1998),(26857,1998),(26858,1998),(26859,1998),(26860,1998),(26861,1998),(26862,1999),(26863,1999),(26864,1999),(26865,1999),(26866,1999),(26867,1999),(26868,1999),(26869,2000),(26870,2000),(26871,2000),(26872,2000),(26873,2000),(26874,2000),(26875,2000),(26876,2001),(26877,2001),(26878,2001),(26879,2001),(26880,2001),(26881,2001),(26882,2001),(26883,2002),(26884,2002),(26885,2002),(26886,2002),(26887,2002),(26888,2002),(26889,2002),(26890,2003),(26891,2003),(26892,2003),(26893,2003),(26894,2003),(26895,2003),(26896,2003),(26897,2004),(26898,2004),(26899,2004),(26900,2004),(26901,2004),(26902,2004),(26903,2004),(26904,2005),(26905,2005),(26906,2005),(26907,2005),(26908,2005),(26909,2005),(26910,2005),(26911,2006),(26912,2006),(26913,2006),(26914,2006),(26915,2006),(26916,2006),(26917,2006),(26918,2007),(26919,2007),(26920,2007),(26921,2007),(26922,2007),(26923,2007),(26924,2007),(26925,2008),(26926,2008),(26927,2008),(26928,2008),(26929,2008),(26930,2008),(26931,2008),(26932,2009),(26933,2009),(26934,2009),(26935,2009),(26936,2009),(26937,2009),(26938,2009),(26939,2010),(26940,2010),(26941,2010),(26942,2010),(26943,2010),(26944,2010),(26945,2010),(26946,2011),(26947,2011),(26948,2011),(26949,2011),(26950,2011),(26951,2011),(26952,2011),(26953,2012),(26954,2012),(26955,2012),(26956,2012),(26957,2012),(26958,2012),(26959,2012),(26960,1913),(26961,1913),(26962,1913),(26963,1914),(26964,1914),(26965,1914),(26966,1915),(26967,1915),(26968,1915),(26969,1916),(26970,1916),(26971,1916),(26972,1917),(26973,1917),(26974,1917),(26975,1918),(26976,1918),(26977,1918),(26978,1919),(26979,1919),(26980,1919),(26981,1920),(26982,1920),(26983,1920),(26984,1921),(26985,1921),(26986,1921),(26987,1922),(26988,1922),(26989,1922),(26990,1923),(26991,1923),(26992,1923),(26993,1924),(26994,1924),(26995,1924),(26996,1925),(26997,1925),(26998,1925),(26999,1926),(27000,1926),(27001,1926),(27002,1927),(27003,1927),(27004,1927),(27005,1928),(27006,1928),(27007,1928),(27008,1929),(27009,1929),(27010,1929),(27011,1930),(27012,1930),(27013,1930),(27014,1931),(27015,1931),(27016,1931),(27017,1932),(27018,1932),(27019,1932),(27020,1933),(27021,1933),(27022,1933),(27023,1934),(27024,1934),(27025,1934),(27026,1935),(27027,1935),(27028,1935),(27029,1936),(27030,1936),(27031,1936),(27032,1937),(27033,1937),(27034,1937),(27035,1938),(27036,1938),(27037,1938),(27038,1939),(27039,1939),(27040,1939),(27041,1940),(27042,1940),(27043,1940),(27044,1941),(27045,1941),(27046,1941),(27047,1942),(27048,1942),(27049,1942),(27050,1943),(27051,1943),(27052,1943),(27053,1944),(27054,1944),(27055,1944),(27056,1945),(27057,1945),(27058,1945),(27059,1946),(27060,1946),(27061,1946),(27062,1947),(27063,1947),(27064,1947),(27065,1948),(27066,1948),(27067,1948),(27068,1949),(27069,1949),(27070,1949),(27071,1950),(27072,1950),(27073,1950),(27074,1951),(27075,1951),(27076,1951),(27077,1952),(27078,1952),(27079,1952),(27080,1953),(27081,1953),(27082,1953),(27083,1954),(27084,1954),(27085,1954),(27086,1955),(27087,1955),(27088,1955),(27089,1956),(27090,1956),(27091,1956),(27092,1957),(27093,1957),(27094,1957),(27095,1958),(27096,1958),(27097,1958),(27098,1959),(27099,1959),(27100,1959),(27101,1960),(27102,1960),(27103,1960),(27104,1961),(27105,1961),(27106,1961),(27107,1962),(27108,1962),(27109,1962),(27110,1963),(27111,1963),(27112,1963),(27113,1964),(27114,1964),(27115,1964),(27116,1965),(27117,1965),(27118,1965),(27119,1966),(27120,1966),(27121,1966),(27122,1967),(27123,1967),(27124,1967),(27125,1968),(27126,1968),(27127,1968),(27128,1969),(27129,1969),(27130,1969),(27131,1970),(27132,1970),(27133,1970),(27134,1971),(27135,1971),(27136,1971),(27137,1972),(27138,1972),(27139,1972),(27140,1973),(27141,1973),(27142,1973),(27143,1974),(27144,1974),(27145,1974),(27146,1975),(27147,1975),(27148,1975),(27149,1976),(27150,1976),(27151,1976),(27152,1977),(27153,1977),(27154,1977),(27155,1978),(27156,1978),(27157,1978),(27158,1979),(27159,1979),(27160,1979),(27161,1980),(27162,1980),(27163,1980),(27164,1981),(27165,1981),(27166,1981),(27167,1982),(27168,1982),(27169,1982),(27170,1983),(27171,1983),(27172,1983),(27173,1984),(27174,1984),(27175,1984),(27176,1985),(27177,1985),(27178,1985),(27179,1986),(27180,1986),(27181,1986),(27182,1987),(27183,1987),(27184,1987),(27185,1988),(27186,1988),(27187,1988),(27188,1989),(27189,1989),(27190,1989),(27191,1990),(27192,1990),(27193,1990),(27194,1991),(27195,1991),(27196,1991),(27197,1992),(27198,1992),(27199,1992),(27200,1993),(27201,1993),(27202,1993),(27203,1994),(27204,1994),(27205,1994),(27206,1995),(27207,1995),(27208,1995),(27209,1996),(27210,1996),(27211,1996),(27212,1997),(27213,1997),(27214,1997),(27215,1998),(27216,1998),(27217,1998),(27218,1999),(27219,1999),(27220,1999),(27221,2000),(27222,2000),(27223,2000),(27224,2001),(27225,2001),(27226,2001),(27227,2002),(27228,2002),(27229,2002),(27230,2003),(27231,2003),(27232,2003),(27233,2004),(27234,2004),(27235,2004),(27236,2005),(27237,2005),(27238,2005),(27239,2006),(27240,2006),(27241,2006),(27242,2007),(27243,2007),(27244,2007),(27245,2008),(27246,2008),(27247,2008),(27248,2009),(27249,2009),(27250,2009),(27251,2010),(27252,2010),(27253,2010),(27254,2011),(27255,2011),(27256,2011),(27257,2012),(27258,2012),(27259,2012),(27260,1913),(27261,1913),(27262,1913),(27263,1913),(27264,1914),(27265,1914),(27266,1914),(27267,1914),(27268,1915),(27269,1915),(27270,1915),(27271,1915),(27272,1916),(27273,1916),(27274,1916),(27275,1916),(27276,1917),(27277,1917),(27278,1917),(27279,1917),(27280,1918),(27281,1918),(27282,1918),(27283,1918),(27284,1919),(27285,1919),(27286,1919),(27287,1919),(27288,1920),(27289,1920),(27290,1920),(27291,1920),(27292,1921),(27293,1921),(27294,1921),(27295,1921),(27296,1922),(27297,1922),(27298,1922),(27299,1922),(27300,1923),(27301,1923),(27302,1923),(27303,1923),(27304,1924),(27305,1924),(27306,1924),(27307,1924),(27308,1925),(27309,1925),(27310,1925),(27311,1925),(27312,1926),(27313,1926),(27314,1926),(27315,1926),(27316,1927),(27317,1927),(27318,1927),(27319,1927),(27320,1928),(27321,1928),(27322,1928),(27323,1928),(27324,1929),(27325,1929),(27326,1929),(27327,1929),(27328,1930),(27329,1930),(27330,1930),(27331,1930),(27332,1931),(27333,1931),(27334,1931),(27335,1931),(27336,1932),(27337,1932),(27338,1932),(27339,1932),(27340,1933),(27341,1933),(27342,1933),(27343,1933),(27344,1934),(27345,1934),(27346,1934),(27347,1934),(27348,1935),(27349,1935),(27350,1935),(27351,1935),(27352,1936),(27353,1936),(27354,1936),(27355,1936),(27356,1937),(27357,1937),(27358,1937),(27359,1937),(27360,1938),(27361,1938),(27362,1938),(27363,1938),(27364,1939),(27365,1939),(27366,1939),(27367,1939),(27368,1940),(27369,1940),(27370,1940),(27371,1940),(27372,1941),(27373,1941),(27374,1941),(27375,1941),(27376,1942),(27377,1942),(27378,1942),(27379,1942),(27380,1943),(27381,1943),(27382,1943),(27383,1943),(27384,1944),(27385,1944),(27386,1944),(27387,1944),(27388,1945),(27389,1945),(27390,1945),(27391,1945),(27392,1946),(27393,1946),(27394,1946),(27395,1946),(27396,1947),(27397,1947),(27398,1947),(27399,1947),(27400,1948),(27401,1948),(27402,1948),(27403,1948),(27404,1949),(27405,1949),(27406,1949),(27407,1949),(27408,1950),(27409,1950),(27410,1950),(27411,1950),(27412,1951),(27413,1951),(27414,1951),(27415,1951),(27416,1952),(27417,1952),(27418,1952),(27419,1952),(27420,1953),(27421,1953),(27422,1953),(27423,1953),(27424,1954),(27425,1954),(27426,1954),(27427,1954),(27428,1955),(27429,1955),(27430,1955),(27431,1955),(27432,1956),(27433,1956),(27434,1956),(27435,1956),(27436,1957),(27437,1957),(27438,1957),(27439,1957),(27440,1958),(27441,1958),(27442,1958),(27443,1958),(27444,1959),(27445,1959),(27446,1959),(27447,1959),(27448,1960),(27449,1960),(27450,1960),(27451,1960),(27452,1961),(27453,1961),(27454,1961),(27455,1961),(27456,1962),(27457,1962),(27458,1962),(27459,1962),(27460,1963),(27461,1963),(27462,1963),(27463,1963),(27464,1964),(27465,1964),(27466,1964),(27467,1964),(27468,1965),(27469,1965),(27470,1965),(27471,1965),(27472,1966),(27473,1966),(27474,1966),(27475,1966),(27476,1967),(27477,1967),(27478,1967),(27479,1967),(27480,1968),(27481,1968),(27482,1968),(27483,1968),(27484,1969),(27485,1969),(27486,1969),(27487,1969),(27488,1970),(27489,1970),(27490,1970),(27491,1970),(27492,1971),(27493,1971),(27494,1971),(27495,1971),(27496,1972),(27497,1972),(27498,1972),(27499,1972),(27500,1973),(27501,1973),(27502,1973),(27503,1973),(27504,1974),(27505,1974),(27506,1974),(27507,1974),(27508,1975),(27509,1975),(27510,1975),(27511,1975),(27512,1976),(27513,1976),(27514,1976),(27515,1976),(27516,1977),(27517,1977),(27518,1977),(27519,1977),(27520,1978),(27521,1978),(27522,1978),(27523,1978),(27524,1979),(27525,1979),(27526,1979),(27527,1979),(27528,1980),(27529,1980),(27530,1980),(27531,1980),(27532,1981),(27533,1981),(27534,1981),(27535,1981),(27536,1982),(27537,1982),(27538,1982),(27539,1982),(27540,1983),(27541,1983),(27542,1983),(27543,1983),(27544,1984),(27545,1984),(27546,1984),(27547,1984),(27548,1985),(27549,1985),(27550,1985),(27551,1985),(27552,1986),(27553,1986),(27554,1986),(27555,1986),(27556,1987),(27557,1987),(27558,1987),(27559,1987),(27560,1988),(27561,1988),(27562,1988),(27563,1988),(27564,1989),(27565,1989),(27566,1989),(27567,1989),(27568,1990),(27569,1990),(27570,1990),(27571,1990),(27572,1991),(27573,1991),(27574,1991),(27575,1991),(27576,1992),(27577,1992),(27578,1992),(27579,1992),(27580,1993),(27581,1993),(27582,1993),(27583,1993),(27584,1994),(27585,1994),(27586,1994),(27587,1994),(27588,1995),(27589,1995),(27590,1995),(27591,1995),(27592,1996),(27593,1996),(27594,1996),(27595,1996),(27596,1997),(27597,1997),(27598,1997),(27599,1997),(27600,1998),(27601,1998),(27602,1998),(27603,1998),(27604,1999),(27605,1999),(27606,1999),(27607,1999),(27608,2000),(27609,2000),(27610,2000),(27611,2000),(27612,2001),(27613,2001),(27614,2001),(27615,2001),(27616,2002),(27617,2002),(27618,2002),(27619,2002),(27620,2003),(27621,2003),(27622,2003),(27623,2003),(27624,2004),(27625,2004),(27626,2004),(27627,2004),(27628,2005),(27629,2005),(27630,2005),(27631,2005),(27632,2006),(27633,2006),(27634,2006),(27635,2006),(27636,2007),(27637,2007),(27638,2007),(27639,2007),(27640,2008),(27641,2008),(27642,2008),(27643,2008),(27644,2009),(27645,2009),(27646,2009),(27647,2009),(27648,2010),(27649,2010),(27650,2010),(27651,2010),(27652,2011),(27653,2011),(27654,2011),(27655,2011),(27656,2012),(27657,2012),(27658,2012),(27659,2012),(27660,2013),(27661,2013),(27662,2013),(27663,2013),(27664,2013),(27665,2013),(27666,2013),(27667,2014),(27668,2014),(27669,2014),(27670,2014),(27671,2014),(27672,2014),(27673,2014),(27674,2015),(27675,2015),(27676,2015),(27677,2015),(27678,2015),(27679,2015),(27680,2015),(27681,2016),(27682,2016),(27683,2016),(27684,2016),(27685,2016),(27686,2016),(27687,2016),(27688,2017),(27689,2017),(27690,2017),(27691,2017),(27692,2017),(27693,2017),(27694,2017),(27695,2018),(27696,2018),(27697,2018),(27698,2018),(27699,2018),(27700,2018),(27701,2018),(27702,2019),(27703,2019),(27704,2019),(27705,2019),(27706,2019),(27707,2019),(27708,2019),(27709,2020),(27710,2020),(27711,2020),(27712,2020),(27713,2020),(27714,2020),(27715,2020),(27716,2021),(27717,2021),(27718,2021),(27719,2021),(27720,2021),(27721,2021),(27722,2021),(27723,2022),(27724,2022),(27725,2022),(27726,2022),(27727,2022),(27728,2022),(27729,2022),(27730,2023),(27731,2023),(27732,2023),(27733,2023),(27734,2023),(27735,2023),(27736,2023),(27737,2024),(27738,2024),(27739,2024),(27740,2024),(27741,2024),(27742,2024),(27743,2024),(27744,2024),(27745,2024),(27746,2025),(27747,2025),(27748,2025),(27749,2025),(27750,2025),(27751,2025),(27752,2025),(27753,2025),(27754,2025),(27755,2026),(27756,2026),(27757,2026),(27758,2026),(27759,2026),(27760,2026),(27761,2026),(27762,2026),(27763,2026),(27764,2027),(27765,2027),(27766,2027),(27767,2027),(27768,2027),(27769,2027),(27770,2027),(27771,2027),(27772,2027),(27773,2028),(27774,2028),(27775,2028),(27776,2028),(27777,2028),(27778,2028),(27779,2028),(27780,2028),(27781,2028),(27782,2029),(27783,2029),(27784,2029),(27785,2029),(27786,2029),(27787,2029),(27788,2029),(27789,2029),(27790,2029),(27791,2030),(27792,2030),(27793,2030),(27794,2030),(27795,2030),(27796,2030),(27797,2030),(27798,2030),(27799,2030),(27800,2031),(27801,2031),(27802,2031),(27803,2031),(27804,2031),(27805,2031),(27806,2031),(27807,2031),(27808,2031),(27809,2032),(27810,2032),(27811,2032),(27812,2032),(27813,2032),(27814,2032),(27815,2032),(27816,2032),(27817,2032),(27818,2033),(27819,2033),(27820,2033),(27821,2033),(27822,2033),(27823,2033),(27824,2033),(27825,2033),(27826,2033),(27827,2034),(27828,2034),(27829,2034),(27830,2034),(27831,2034),(27832,2034),(27833,2034),(27834,2034),(27835,2034),(27836,2035),(27837,2035),(27838,2035),(27839,2035),(27840,2035),(27841,2035),(27842,2035),(27843,2036),(27844,2036),(27845,2036),(27846,2036),(27847,2036),(27848,2036),(27849,2036),(27850,2037),(27851,2037),(27852,2037),(27853,2037),(27854,2037),(27855,2037),(27856,2037),(27857,2038),(27858,2038),(27859,2038),(27860,2038),(27861,2038),(27862,2038),(27863,2038),(27864,2039),(27865,2039),(27866,2039),(27867,2039),(27868,2039),(27869,2039),(27870,2039),(27871,2039),(27872,2039),(27873,2040),(27874,2040),(27875,2040),(27876,2040),(27877,2040),(27878,2040),(27879,2040),(27880,2040),(27881,2040),(27882,2041),(27883,2041),(27884,2041),(27885,2041),(27886,2041),(27887,2041),(27888,2041),(27889,2042),(27890,2042),(27891,2042),(27892,2042),(27893,2042),(27894,2042),(27895,2042),(27896,2042),(27897,2042),(27898,2043),(27899,2043),(27900,2043),(27901,2043),(27902,2043),(27903,2043),(27904,2043),(27905,2044),(27906,2044),(27907,2044),(27908,2044),(27909,2044),(27910,2044),(27911,2044),(27912,2044),(27913,2044),(27914,2045),(27915,2045),(27916,2045),(27917,2045),(27918,2045),(27919,2045),(27920,2045),(27921,2045),(27922,2045),(27923,2046),(27924,2046),(27925,2046),(27926,2046),(27927,2046),(27928,2046),(27929,2046),(27930,2046),(27931,2046),(27932,2047),(27933,2047),(27934,2047),(27935,2047),(27936,2047),(27937,2047),(27938,2047),(27939,2048),(27940,2048),(27941,2048),(27942,2048),(27943,2048),(27944,2048),(27945,2048),(27946,2049),(27947,2049),(27948,2049),(27949,2049),(27950,2049),(27951,2049),(27952,2049),(27953,2050),(27954,2050),(27955,2050),(27956,2050),(27957,2050),(27958,2050),(27959,2050),(27960,2051),(27961,2051),(27962,2051),(27963,2051),(27964,2051),(27965,2051),(27966,2051),(27967,2052),(27968,2052),(27969,2052),(27970,2052),(27971,2052),(27972,2052),(27973,2052),(27974,2053),(27975,2053),(27976,2053),(27977,2053),(27978,2053),(27979,2053),(27980,2053),(27981,2054),(27982,2054),(27983,2054),(27984,2054),(27985,2054),(27986,2054),(27987,2054),(27988,2055),(27989,2055),(27990,2055),(27991,2055),(27992,2055),(27993,2055),(27994,2055),(27995,2056),(27996,2056),(27997,2056),(27998,2056),(27999,2056),(28000,2056),(28001,2056),(28002,2057),(28003,2057),(28004,2057),(28005,2057),(28006,2057),(28007,2057),(28008,2057),(28009,2058),(28010,2058),(28011,2058),(28012,2058),(28013,2058),(28014,2058),(28015,2058),(28016,2059),(28017,2059),(28018,2059),(28019,2059),(28020,2059),(28021,2059),(28022,2059),(28023,2060),(28024,2060),(28025,2060),(28026,2060),(28027,2060),(28028,2060),(28029,2060),(28030,2061),(28031,2061),(28032,2061),(28033,2061),(28034,2061),(28035,2061),(28036,2061),(28037,2061),(28038,2061),(28039,2062),(28040,2062),(28041,2062),(28042,2062),(28043,2062),(28044,2062),(28045,2062),(28046,2063),(28047,2063),(28048,2063),(28049,2063),(28050,2063),(28051,2063),(28052,2063),(28053,2064),(28054,2064),(28055,2064),(28056,2064),(28057,2064),(28058,2064),(28059,2064),(28060,2065),(28061,2065),(28062,2065),(28063,2065),(28064,2065),(28065,2065),(28066,2065),(28067,2066),(28068,2066),(28069,2066),(28070,2066),(28071,2066),(28072,2066),(28073,2066),(28074,2067),(28075,2067),(28076,2067),(28077,2067),(28078,2067),(28079,2067),(28080,2067),(28081,2068),(28082,2068),(28083,2068),(28084,2068),(28085,2068),(28086,2068),(28087,2068),(28088,2069),(28089,2069),(28090,2069),(28091,2069),(28092,2069),(28093,2069),(28094,2069),(28095,2070),(28096,2070),(28097,2070),(28098,2070),(28099,2070),(28100,2070),(28101,2070),(28102,2071),(28103,2071),(28104,2071),(28105,2071),(28106,2071),(28107,2071),(28108,2071),(28109,2072),(28110,2072),(28111,2072),(28112,2072),(28113,2072),(28114,2072),(28115,2072),(28116,2073),(28117,2073),(28118,2073),(28119,2073),(28120,2073),(28121,2073),(28122,2073),(28123,2074),(28124,2074),(28125,2074),(28126,2074),(28127,2074),(28128,2074),(28129,2074),(28130,2075),(28131,2075),(28132,2075),(28133,2075),(28134,2075),(28135,2075),(28136,2075),(28137,2076),(28138,2076),(28139,2076),(28140,2076),(28141,2076),(28142,2076),(28143,2076),(28144,2077),(28145,2077),(28146,2077),(28147,2077),(28148,2077),(28149,2077),(28150,2077),(28151,2078),(28152,2078),(28153,2078),(28154,2078),(28155,2078),(28156,2078),(28157,2078),(28158,2078),(28159,2078),(28160,2079),(28161,2079),(28162,2079),(28163,2079),(28164,2079),(28165,2079),(28166,2079),(28167,2080),(28168,2080),(28169,2080),(28170,2080),(28171,2080),(28172,2080),(28173,2080),(28174,2081),(28175,2081),(28176,2081),(28177,2081),(28178,2081),(28179,2081),(28180,2081),(28181,2082),(28182,2082),(28183,2082),(28184,2082),(28185,2082),(28186,2082),(28187,2082),(28188,2083),(28189,2083),(28190,2083),(28191,2083),(28192,2083),(28193,2083),(28194,2083),(28195,2084),(28196,2084),(28197,2084),(28198,2084),(28199,2084),(28200,2084),(28201,2084),(28202,2084),(28203,2084),(28204,2085),(28205,2085),(28206,2085),(28207,2085),(28208,2085),(28209,2085),(28210,2085),(28211,2086),(28212,2086),(28213,2086),(28214,2086),(28215,2086),(28216,2086),(28217,2086),(28218,2087),(28219,2087),(28220,2087),(28221,2087),(28222,2087),(28223,2087),(28224,2087),(28225,2088),(28226,2088),(28227,2088),(28228,2088),(28229,2088),(28230,2088),(28231,2088),(28232,2088),(28233,2088),(28234,2089),(28235,2089),(28236,2089),(28237,2089),(28238,2089),(28239,2089),(28240,2089),(28241,2090),(28242,2090),(28243,2090),(28244,2090),(28245,2090),(28246,2090),(28247,2090),(28248,2091),(28249,2091),(28250,2091),(28251,2091),(28252,2091),(28253,2091),(28254,2091),(28255,2092),(28256,2092),(28257,2092),(28258,2092),(28259,2092),(28260,2092),(28261,2092),(28262,2093),(28263,2093),(28264,2093),(28265,2093),(28266,2093),(28267,2093),(28268,2093),(28269,2094),(28270,2094),(28271,2094),(28272,2094),(28273,2094),(28274,2094),(28275,2094),(28276,2095),(28277,2095),(28278,2095),(28279,2095),(28280,2095),(28281,2095),(28282,2095),(28283,2096),(28284,2096),(28285,2096),(28286,2096),(28287,2096),(28288,2096),(28289,2096),(28290,2097),(28291,2097),(28292,2097),(28293,2097),(28294,2097),(28295,2097),(28296,2097),(28297,2097),(28298,2097),(28299,2098),(28300,2098),(28301,2098),(28302,2098),(28303,2098),(28304,2098),(28305,2098),(28306,2099),(28307,2099),(28308,2099),(28309,2099),(28310,2099),(28311,2099),(28312,2099),(28313,2100),(28314,2100),(28315,2100),(28316,2100),(28317,2100),(28318,2100),(28319,2100),(28320,2101),(28321,2101),(28322,2101),(28323,2101),(28324,2101),(28325,2101),(28326,2101),(28327,2101),(28328,2101),(28329,2102),(28330,2102),(28331,2102),(28332,2102),(28333,2102),(28334,2102),(28335,2102),(28336,2103),(28337,2103),(28338,2103),(28339,2103),(28340,2103),(28341,2103),(28342,2103),(28343,2104),(28344,2104),(28345,2104),(28346,2104),(28347,2104),(28348,2104),(28349,2104),(28350,2105),(28351,2105),(28352,2105),(28353,2105),(28354,2105),(28355,2105),(28356,2105),(28357,2105),(28358,2105),(28359,2106),(28360,2106),(28361,2106),(28362,2106),(28363,2106),(28364,2106),(28365,2106),(28366,2107),(28367,2107),(28368,2107),(28369,2107),(28370,2107),(28371,2107),(28372,2107),(28373,2108),(28374,2108),(28375,2108),(28376,2108),(28377,2108),(28378,2108),(28379,2108),(28380,2109),(28381,2109),(28382,2109),(28383,2109),(28384,2109),(28385,2109),(28386,2109),(28387,2110),(28388,2110),(28389,2110),(28390,2110),(28391,2110),(28392,2110),(28393,2110),(28394,2111),(28395,2111),(28396,2111),(28397,2111),(28398,2111),(28399,2111),(28400,2111),(28401,2112),(28402,2112),(28403,2112),(28404,2112),(28405,2112),(28406,2112),(28407,2112),(28408,2013),(28409,2013),(28410,2013),(28411,2014),(28412,2014),(28413,2014),(28414,2015),(28415,2015),(28416,2015),(28417,2016),(28418,2016),(28419,2016),(28420,2017),(28421,2017),(28422,2017),(28423,2018),(28424,2018),(28425,2018),(28426,2019),(28427,2019),(28428,2019),(28429,2020),(28430,2020),(28431,2020),(28432,2021),(28433,2021),(28434,2021),(28435,2022),(28436,2022),(28437,2022),(28438,2023),(28439,2023),(28440,2023),(28441,2024),(28442,2024),(28443,2024),(28444,2025),(28445,2025),(28446,2025),(28447,2026),(28448,2026),(28449,2026),(28450,2027),(28451,2027),(28452,2027),(28453,2028),(28454,2028),(28455,2028),(28456,2029),(28457,2029),(28458,2029),(28459,2030),(28460,2030),(28461,2030),(28462,2031),(28463,2031),(28464,2031),(28465,2032),(28466,2032),(28467,2032),(28468,2033),(28469,2033),(28470,2033),(28471,2034),(28472,2034),(28473,2034),(28474,2035),(28475,2035),(28476,2035),(28477,2036),(28478,2036),(28479,2036),(28480,2037),(28481,2037),(28482,2037),(28483,2038),(28484,2038),(28485,2038),(28486,2039),(28487,2039),(28488,2039),(28489,2040),(28490,2040),(28491,2040),(28492,2041),(28493,2041),(28494,2041),(28495,2042),(28496,2042),(28497,2042),(28498,2043),(28499,2043),(28500,2043),(28501,2044),(28502,2044),(28503,2044),(28504,2045),(28505,2045),(28506,2045),(28507,2046),(28508,2046),(28509,2046),(28510,2047),(28511,2047),(28512,2047),(28513,2048),(28514,2048),(28515,2048),(28516,2049),(28517,2049),(28518,2049),(28519,2050),(28520,2050),(28521,2050),(28522,2051),(28523,2051),(28524,2051),(28525,2052),(28526,2052),(28527,2052),(28528,2053),(28529,2053),(28530,2053),(28531,2054),(28532,2054),(28533,2054),(28534,2055),(28535,2055),(28536,2055),(28537,2056),(28538,2056),(28539,2056),(28540,2057),(28541,2057),(28542,2057),(28543,2058),(28544,2058),(28545,2058),(28546,2059),(28547,2059),(28548,2059),(28549,2060),(28550,2060),(28551,2060),(28552,2061),(28553,2061),(28554,2061),(28555,2062),(28556,2062),(28557,2062),(28558,2063),(28559,2063),(28560,2063),(28561,2064),(28562,2064),(28563,2064),(28564,2065),(28565,2065),(28566,2065),(28567,2066),(28568,2066),(28569,2066),(28570,2067),(28571,2067),(28572,2067),(28573,2068),(28574,2068),(28575,2068),(28576,2069),(28577,2069),(28578,2069),(28579,2070),(28580,2070),(28581,2070),(28582,2071),(28583,2071),(28584,2071),(28585,2072),(28586,2072),(28587,2072),(28588,2073),(28589,2073),(28590,2073),(28591,2074),(28592,2074),(28593,2074),(28594,2075),(28595,2075),(28596,2075),(28597,2076),(28598,2076),(28599,2076),(28600,2077),(28601,2077),(28602,2077),(28603,2078),(28604,2078),(28605,2078),(28606,2079),(28607,2079),(28608,2079),(28609,2080),(28610,2080),(28611,2080),(28612,2081),(28613,2081),(28614,2081),(28615,2082),(28616,2082),(28617,2082),(28618,2083),(28619,2083),(28620,2083),(28621,2084),(28622,2084),(28623,2084),(28624,2085),(28625,2085),(28626,2085),(28627,2086),(28628,2086),(28629,2086),(28630,2087),(28631,2087),(28632,2087),(28633,2088),(28634,2088),(28635,2088),(28636,2089),(28637,2089),(28638,2089),(28639,2090),(28640,2090),(28641,2090),(28642,2091),(28643,2091),(28644,2091),(28645,2092),(28646,2092),(28647,2092),(28648,2093),(28649,2093),(28650,2093),(28651,2094),(28652,2094),(28653,2094),(28654,2095),(28655,2095),(28656,2095),(28657,2096),(28658,2096),(28659,2096),(28660,2097),(28661,2097),(28662,2097),(28663,2098),(28664,2098),(28665,2098),(28666,2099),(28667,2099),(28668,2099),(28669,2100),(28670,2100),(28671,2100),(28672,2101),(28673,2101),(28674,2101),(28675,2102),(28676,2102),(28677,2102),(28678,2103),(28679,2103),(28680,2103),(28681,2104),(28682,2104),(28683,2104),(28684,2105),(28685,2105),(28686,2105),(28687,2106),(28688,2106),(28689,2106),(28690,2107),(28691,2107),(28692,2107),(28693,2108),(28694,2108),(28695,2108),(28696,2109),(28697,2109),(28698,2109),(28699,2110),(28700,2110),(28701,2110),(28702,2111),(28703,2111),(28704,2111),(28705,2112),(28706,2112),(28707,2112),(28708,2013),(28709,2013),(28710,2013),(28711,2013),(28712,2014),(28713,2014),(28714,2014),(28715,2014),(28716,2015),(28717,2015),(28718,2015),(28719,2015),(28720,2016),(28721,2016),(28722,2016),(28723,2016),(28724,2017),(28725,2017),(28726,2017),(28727,2017),(28728,2018),(28729,2018),(28730,2018),(28731,2018),(28732,2019),(28733,2019),(28734,2019),(28735,2019),(28736,2020),(28737,2020),(28738,2020),(28739,2020),(28740,2021),(28741,2021),(28742,2021),(28743,2021),(28744,2022),(28745,2022),(28746,2022),(28747,2022),(28748,2023),(28749,2023),(28750,2023),(28751,2023),(28752,2024),(28753,2024),(28754,2024),(28755,2024),(28756,2025),(28757,2025),(28758,2025),(28759,2025),(28760,2026),(28761,2026),(28762,2026),(28763,2026),(28764,2027),(28765,2027),(28766,2027),(28767,2027),(28768,2028),(28769,2028),(28770,2028),(28771,2028),(28772,2029),(28773,2029),(28774,2029),(28775,2029),(28776,2030),(28777,2030),(28778,2030),(28779,2030),(28780,2031),(28781,2031),(28782,2031),(28783,2031),(28784,2032),(28785,2032),(28786,2032),(28787,2032),(28788,2033),(28789,2033),(28790,2033),(28791,2033),(28792,2034),(28793,2034),(28794,2034),(28795,2034),(28796,2035),(28797,2035),(28798,2035),(28799,2035),(28800,2036),(28801,2036),(28802,2036),(28803,2036),(28804,2037),(28805,2037),(28806,2037),(28807,2037),(28808,2038),(28809,2038),(28810,2038),(28811,2038),(28812,2039),(28813,2039),(28814,2039),(28815,2039),(28816,2040),(28817,2040),(28818,2040),(28819,2040),(28820,2041),(28821,2041),(28822,2041),(28823,2041),(28824,2042),(28825,2042),(28826,2042),(28827,2042),(28828,2043),(28829,2043),(28830,2043),(28831,2043),(28832,2044),(28833,2044),(28834,2044),(28835,2044),(28836,2045),(28837,2045),(28838,2045),(28839,2045),(28840,2046),(28841,2046),(28842,2046),(28843,2046),(28844,2047),(28845,2047),(28846,2047),(28847,2047),(28848,2048),(28849,2048),(28850,2048),(28851,2048),(28852,2049),(28853,2049),(28854,2049),(28855,2049),(28856,2050),(28857,2050),(28858,2050),(28859,2050),(28860,2051),(28861,2051),(28862,2051),(28863,2051),(28864,2052),(28865,2052),(28866,2052),(28867,2052),(28868,2053),(28869,2053),(28870,2053),(28871,2053),(28872,2054),(28873,2054),(28874,2054),(28875,2054),(28876,2055),(28877,2055),(28878,2055),(28879,2055),(28880,2056),(28881,2056),(28882,2056),(28883,2056),(28884,2057),(28885,2057),(28886,2057),(28887,2057),(28888,2058),(28889,2058),(28890,2058),(28891,2058),(28892,2059),(28893,2059),(28894,2059),(28895,2059),(28896,2060),(28897,2060),(28898,2060),(28899,2060),(28900,2061),(28901,2061),(28902,2061),(28903,2061),(28904,2062),(28905,2062),(28906,2062),(28907,2062),(28908,2063),(28909,2063),(28910,2063),(28911,2063),(28912,2064),(28913,2064),(28914,2064),(28915,2064),(28916,2065),(28917,2065),(28918,2065),(28919,2065),(28920,2066),(28921,2066),(28922,2066),(28923,2066),(28924,2067),(28925,2067),(28926,2067),(28927,2067),(28928,2068),(28929,2068),(28930,2068),(28931,2068),(28932,2069),(28933,2069),(28934,2069),(28935,2069),(28936,2070),(28937,2070),(28938,2070),(28939,2070),(28940,2071),(28941,2071),(28942,2071),(28943,2071),(28944,2072),(28945,2072),(28946,2072),(28947,2072),(28948,2073),(28949,2073),(28950,2073),(28951,2073),(28952,2074),(28953,2074),(28954,2074),(28955,2074),(28956,2075),(28957,2075),(28958,2075),(28959,2075),(28960,2076),(28961,2076),(28962,2076),(28963,2076),(28964,2077),(28965,2077),(28966,2077),(28967,2077),(28968,2078),(28969,2078),(28970,2078),(28971,2078),(28972,2079),(28973,2079),(28974,2079),(28975,2079),(28976,2080),(28977,2080),(28978,2080),(28979,2080),(28980,2081),(28981,2081),(28982,2081),(28983,2081),(28984,2082),(28985,2082),(28986,2082),(28987,2082),(28988,2083),(28989,2083),(28990,2083),(28991,2083),(28992,2084),(28993,2084),(28994,2084),(28995,2084),(28996,2085),(28997,2085),(28998,2085),(28999,2085),(29000,2086),(29001,2086),(29002,2086),(29003,2086),(29004,2087),(29005,2087),(29006,2087),(29007,2087),(29008,2088),(29009,2088),(29010,2088),(29011,2088),(29012,2089),(29013,2089),(29014,2089),(29015,2089),(29016,2090),(29017,2090),(29018,2090),(29019,2090),(29020,2091),(29021,2091),(29022,2091),(29023,2091),(29024,2092),(29025,2092),(29026,2092),(29027,2092),(29028,2093),(29029,2093),(29030,2093),(29031,2093),(29032,2094),(29033,2094),(29034,2094),(29035,2094),(29036,2095),(29037,2095),(29038,2095),(29039,2095),(29040,2096),(29041,2096),(29042,2096),(29043,2096),(29044,2097),(29045,2097),(29046,2097),(29047,2097),(29048,2098),(29049,2098),(29050,2098),(29051,2098),(29052,2099),(29053,2099),(29054,2099),(29055,2099),(29056,2100),(29057,2100),(29058,2100),(29059,2100),(29060,2101),(29061,2101),(29062,2101),(29063,2101),(29064,2102),(29065,2102),(29066,2102),(29067,2102),(29068,2103),(29069,2103),(29070,2103),(29071,2103),(29072,2104),(29073,2104),(29074,2104),(29075,2104),(29076,2105),(29077,2105),(29078,2105),(29079,2105),(29080,2106),(29081,2106),(29082,2106),(29083,2106),(29084,2107),(29085,2107),(29086,2107),(29087,2107),(29088,2108),(29089,2108),(29090,2108),(29091,2108),(29092,2109),(29093,2109),(29094,2109),(29095,2109),(29096,2110),(29097,2110),(29098,2110),(29099,2110),(29100,2111),(29101,2111),(29102,2111),(29103,2111),(29104,2112),(29105,2112),(29106,2112),(29107,2112),(29108,2113),(29109,2113),(29110,2113),(29111,2113),(29112,2113),(29113,2113),(29114,2114),(29115,2114),(29116,2114),(29117,2114),(29118,2114),(29119,2114),(29120,2115),(29121,2115),(29122,2115),(29123,2115),(29124,2115),(29125,2115),(29126,2115),(29127,2116),(29128,2116),(29129,2116),(29130,2116),(29131,2116),(29132,2116),(29133,2116),(29134,2117),(29135,2117),(29136,2117),(29137,2117),(29138,2117),(29139,2117),(29140,2117),(29141,2118),(29142,2118),(29143,2118),(29144,2118),(29145,2118),(29146,2118),(29147,2118),(29148,2119),(29149,2119),(29150,2119),(29151,2119),(29152,2119),(29153,2119),(29154,2119),(29155,2120),(29156,2120),(29157,2120),(29158,2120),(29159,2120),(29160,2120),(29161,2120),(29162,2120),(29163,2120),(29164,2121),(29165,2121),(29166,2121),(29167,2121),(29168,2121),(29169,2121),(29170,2121),(29171,2121),(29172,2121),(29173,2122),(29174,2122),(29175,2122),(29176,2122),(29177,2122),(29178,2122),(29179,2122),(29180,2122),(29181,2122),(29182,2123),(29183,2123),(29184,2123),(29185,2123),(29186,2123),(29187,2123),(29188,2123),(29189,2123),(29190,2123),(29191,2124),(29192,2124),(29193,2124),(29194,2124),(29195,2124),(29196,2124),(29197,2124),(29198,2124),(29199,2124),(29200,2125),(29201,2125),(29202,2125),(29203,2125),(29204,2125),(29205,2125),(29206,2125),(29207,2125),(29208,2125),(29209,2126),(29210,2126),(29211,2126),(29212,2126),(29213,2126),(29214,2126),(29215,2126),(29216,2126),(29217,2126),(29218,2127),(29219,2127),(29220,2127),(29221,2127),(29222,2127),(29223,2127),(29224,2127),(29225,2127),(29226,2127),(29227,2128),(29228,2128),(29229,2128),(29230,2128),(29231,2128),(29232,2128),(29233,2128),(29234,2128),(29235,2128),(29236,2129),(29237,2129),(29238,2129),(29239,2129),(29240,2129),(29241,2129),(29242,2129),(29243,2129),(29244,2129),(29245,2130),(29246,2130),(29247,2130),(29248,2130),(29249,2130),(29250,2130),(29251,2130),(29252,2130),(29253,2130),(29254,2131),(29255,2131),(29256,2131),(29257,2131),(29258,2131),(29259,2131),(29260,2131),(29261,2131),(29262,2131),(29263,2132),(29264,2132),(29265,2132),(29266,2132),(29267,2132),(29268,2132),(29269,2132),(29270,2132),(29271,2132),(29272,2133),(29273,2133),(29274,2133),(29275,2133),(29276,2133),(29277,2133),(29278,2133),(29279,2134),(29280,2134),(29281,2134),(29282,2134),(29283,2134),(29284,2134),(29285,2134),(29286,2135),(29287,2135),(29288,2135),(29289,2135),(29290,2135),(29291,2135),(29292,2135),(29293,2135),(29294,2136),(29295,2136),(29296,2136),(29297,2136),(29298,2136),(29299,2136),(29300,2136),(29301,2136),(29302,2136),(29303,2137),(29304,2137),(29305,2137),(29306,2137),(29307,2137),(29308,2137),(29309,2137),(29310,2137),(29311,2137),(29312,2138),(29313,2138),(29314,2138),(29315,2138),(29316,2138),(29317,2138),(29318,2138),(29319,2138),(29320,2138),(29321,2139),(29322,2139),(29323,2139),(29324,2139),(29325,2139),(29326,2139),(29327,2139),(29328,2140),(29329,2140),(29330,2140),(29331,2140),(29332,2140),(29333,2140),(29334,2140),(29335,2141),(29336,2141),(29337,2141),(29338,2141),(29339,2141),(29340,2141),(29341,2141),(29342,2142),(29343,2142),(29344,2142),(29345,2142),(29346,2142),(29347,2142),(29348,2142),(29349,2143),(29350,2143),(29351,2143),(29352,2143),(29353,2143),(29354,2143),(29355,2143),(29356,2144),(29357,2144),(29358,2144),(29359,2144),(29360,2144),(29361,2144),(29362,2144),(29363,2145),(29364,2145),(29365,2145),(29366,2145),(29367,2145),(29368,2145),(29369,2145),(29370,2146),(29371,2146),(29372,2146),(29373,2146),(29374,2146),(29375,2146),(29376,2146),(29377,2147),(29378,2147),(29379,2147),(29380,2147),(29381,2147),(29382,2147),(29383,2147),(29384,2148),(29385,2148),(29386,2148),(29387,2148),(29388,2148),(29389,2148),(29390,2148),(29391,2149),(29392,2149),(29393,2149),(29394,2149),(29395,2149),(29396,2149),(29397,2149),(29398,2150),(29399,2150),(29400,2150),(29401,2150),(29402,2150),(29403,2150),(29404,2150),(29405,2151),(29406,2151),(29407,2151),(29408,2151),(29409,2151),(29410,2151),(29411,2151),(29412,2152),(29413,2152),(29414,2152),(29415,2152),(29416,2152),(29417,2152),(29418,2152),(29419,2153),(29420,2153),(29421,2153),(29422,2153),(29423,2153),(29424,2153),(29425,2153),(29426,2154),(29427,2154),(29428,2154),(29429,2154),(29430,2154),(29431,2154),(29432,2154),(29433,2154),(29434,2154),(29435,2155),(29436,2155),(29437,2155),(29438,2155),(29439,2155),(29440,2155),(29441,2155),(29442,2155),(29443,2155),(29444,2156),(29445,2156),(29446,2156),(29447,2156),(29448,2156),(29449,2156),(29450,2156),(29451,2156),(29452,2156),(29453,2157),(29454,2157),(29455,2157),(29456,2157),(29457,2157),(29458,2157),(29459,2157),(29460,2157),(29461,2157),(29462,2158),(29463,2158),(29464,2158),(29465,2158),(29466,2158),(29467,2158),(29468,2158),(29469,2159),(29470,2159),(29471,2159),(29472,2159),(29473,2159),(29474,2159),(29475,2159),(29476,2159),(29477,2159),(29478,2160),(29479,2160),(29480,2160),(29481,2160),(29482,2160),(29483,2160),(29484,2160),(29485,2161),(29486,2161),(29487,2161),(29488,2161),(29489,2161),(29490,2161),(29491,2161),(29492,2162),(29493,2162),(29494,2162),(29495,2162),(29496,2162),(29497,2162),(29498,2162),(29499,2163),(29500,2163),(29501,2163),(29502,2163),(29503,2163),(29504,2163),(29505,2163),(29506,2163),(29507,2163),(29508,2164),(29509,2164),(29510,2164),(29511,2164),(29512,2164),(29513,2164),(29514,2164),(29515,2165),(29516,2165),(29517,2165),(29518,2165),(29519,2165),(29520,2165),(29521,2165),(29522,2166),(29523,2166),(29524,2166),(29525,2166),(29526,2166),(29527,2166),(29528,2166),(29529,2167),(29530,2167),(29531,2167),(29532,2167),(29533,2167),(29534,2167),(29535,2167),(29536,2168),(29537,2168),(29538,2168),(29539,2168),(29540,2168),(29541,2168),(29542,2168),(29543,2169),(29544,2169),(29545,2169),(29546,2169),(29547,2169),(29548,2169),(29549,2169),(29550,2170),(29551,2170),(29552,2170),(29553,2170),(29554,2170),(29555,2170),(29556,2170),(29557,2171),(29558,2171),(29559,2171),(29560,2171),(29561,2171),(29562,2171),(29563,2171),(29564,2172),(29565,2172),(29566,2172),(29567,2172),(29568,2172),(29569,2172),(29570,2172),(29571,2173),(29572,2173),(29573,2173),(29574,2173),(29575,2173),(29576,2173),(29577,2173),(29578,2174),(29579,2174),(29580,2174),(29581,2174),(29582,2174),(29583,2174),(29584,2174),(29585,2175),(29586,2175),(29587,2175),(29588,2175),(29589,2175),(29590,2175),(29591,2175),(29592,2176),(29593,2176),(29594,2176),(29595,2176),(29596,2176),(29597,2176),(29598,2176),(29599,2177),(29600,2177),(29601,2177),(29602,2177),(29603,2177),(29604,2177),(29605,2177),(29606,2177),(29607,2177),(29608,2178),(29609,2178),(29610,2178),(29611,2178),(29612,2178),(29613,2178),(29614,2178),(29615,2179),(29616,2179),(29617,2179),(29618,2179),(29619,2179),(29620,2179),(29621,2179),(29622,2180),(29623,2180),(29624,2180),(29625,2180),(29626,2180),(29627,2180),(29628,2180),(29629,2181),(29630,2181),(29631,2181),(29632,2181),(29633,2181),(29634,2181),(29635,2181),(29636,2182),(29637,2182),(29638,2182),(29639,2182),(29640,2182),(29641,2182),(29642,2182),(29643,2183),(29644,2183),(29645,2183),(29646,2183),(29647,2183),(29648,2183),(29649,2183),(29650,2184),(29651,2184),(29652,2184),(29653,2184),(29654,2184),(29655,2184),(29656,2184),(29657,2185),(29658,2185),(29659,2185),(29660,2185),(29661,2185),(29662,2185),(29663,2185),(29664,2186),(29665,2186),(29666,2186),(29667,2186),(29668,2186),(29669,2186),(29670,2186),(29671,2187),(29672,2187),(29673,2187),(29674,2187),(29675,2187),(29676,2187),(29677,2187),(29678,2188),(29679,2188),(29680,2188),(29681,2188),(29682,2188),(29683,2188),(29684,2188),(29685,2189),(29686,2189),(29687,2189),(29688,2189),(29689,2189),(29690,2189),(29691,2189),(29692,2190),(29693,2190),(29694,2190),(29695,2190),(29696,2190),(29697,2190),(29698,2190),(29699,2191),(29700,2191),(29701,2191),(29702,2191),(29703,2192),(29704,2192),(29705,2192),(29706,2192),(29707,2192),(29708,2192),(29709,2192),(29710,2193),(29711,2193),(29712,2193),(29713,2193),(29714,2194),(29715,2194),(29716,2194),(29717,2194),(29718,2194),(29719,2194),(29720,2194),(29721,2195),(29722,2195),(29723,2195),(29724,2195),(29725,2196),(29726,2196),(29727,2196),(29728,2196),(29729,2196),(29730,2196),(29731,2197),(29732,2197),(29733,2197),(29734,2197),(29735,2197),(29736,2197),(29737,2197),(29738,2198),(29739,2198),(29740,2198),(29741,2198),(29742,2199),(29743,2199),(29744,2199),(29745,2199),(29746,2199),(29747,2199),(29748,2199),(29749,2200),(29750,2200),(29751,2200),(29752,2200),(29753,2200),(29754,2200),(29755,2200),(29756,2201),(29757,2201),(29758,2201),(29759,2201),(29760,2201),(29761,2201),(29762,2201),(29763,2202),(29764,2202),(29765,2202),(29766,2202),(29767,2202),(29768,2202),(29769,2202),(29770,2203),(29771,2203),(29772,2203),(29773,2203),(29774,2203),(29775,2203),(29776,2203),(29777,2204),(29778,2204),(29779,2204),(29780,2204),(29781,2204),(29782,2204),(29783,2204),(29784,2205),(29785,2205),(29786,2205),(29787,2205),(29788,2205),(29789,2205),(29790,2205),(29791,2206),(29792,2206),(29793,2206),(29794,2206),(29795,2206),(29796,2206),(29797,2206),(29798,2207),(29799,2207),(29800,2207),(29801,2207),(29802,2207),(29803,2207),(29804,2207),(29805,2208),(29806,2208),(29807,2208),(29808,2208),(29809,2208),(29810,2208),(29811,2208),(29812,2209),(29813,2209),(29814,2209),(29815,2209),(29816,2209),(29817,2209),(29818,2209),(29819,2210),(29820,2210),(29821,2210),(29822,2210),(29823,2210),(29824,2210),(29825,2210),(29826,2211),(29827,2211),(29828,2211),(29829,2211),(29830,2211),(29831,2211),(29832,2211),(29833,2211),(29834,2211),(29835,2212),(29836,2212),(29837,2212),(29838,2212),(29839,2212),(29840,2212),(29841,2212),(29842,2113),(29843,2113),(29844,2113),(29845,2114),(29846,2114),(29847,2114),(29848,2115),(29849,2115),(29850,2115),(29851,2116),(29852,2116),(29853,2116),(29854,2117),(29855,2117),(29856,2117),(29857,2118),(29858,2118),(29859,2118),(29860,2119),(29861,2119),(29862,2119),(29863,2120),(29864,2120),(29865,2120),(29866,2121),(29867,2121),(29868,2121),(29869,2122),(29870,2122),(29871,2122),(29872,2123),(29873,2123),(29874,2123),(29875,2124),(29876,2124),(29877,2124),(29878,2125),(29879,2125),(29880,2125),(29881,2126),(29882,2126),(29883,2126),(29884,2127),(29885,2127),(29886,2127),(29887,2128),(29888,2128),(29889,2128),(29890,2129),(29891,2129),(29892,2129),(29893,2130),(29894,2130),(29895,2130),(29896,2131),(29897,2131),(29898,2131),(29899,2132),(29900,2132),(29901,2132),(29902,2133),(29903,2133),(29904,2133),(29905,2134),(29906,2134),(29907,2134),(29908,2135),(29909,2135),(29910,2135),(29911,2136),(29912,2136),(29913,2136),(29914,2137),(29915,2137),(29916,2137),(29917,2138),(29918,2138),(29919,2138),(29920,2139),(29921,2139),(29922,2139),(29923,2140),(29924,2140),(29925,2140),(29926,2141),(29927,2141),(29928,2141),(29929,2142),(29930,2142),(29931,2142),(29932,2143),(29933,2143),(29934,2143),(29935,2144),(29936,2144),(29937,2144),(29938,2145),(29939,2145),(29940,2145),(29941,2146),(29942,2146),(29943,2146),(29944,2147),(29945,2147),(29946,2147),(29947,2148),(29948,2148),(29949,2148),(29950,2149),(29951,2149),(29952,2149),(29953,2150),(29954,2150),(29955,2150),(29956,2151),(29957,2151),(29958,2151),(29959,2152),(29960,2152),(29961,2152),(29962,2153),(29963,2153),(29964,2153),(29965,2154),(29966,2154),(29967,2154),(29968,2155),(29969,2155),(29970,2155),(29971,2156),(29972,2156),(29973,2156),(29974,2157),(29975,2157),(29976,2157),(29977,2158),(29978,2158),(29979,2158),(29980,2159),(29981,2159),(29982,2159),(29983,2160),(29984,2160),(29985,2160),(29986,2161),(29987,2161),(29988,2161),(29989,2162),(29990,2162),(29991,2162),(29992,2163),(29993,2163),(29994,2163),(29995,2164),(29996,2164),(29997,2164),(29998,2165),(29999,2165),(30000,2165),(30001,2166),(30002,2166),(30003,2166),(30004,2167),(30005,2167),(30006,2167),(30007,2168),(30008,2168),(30009,2168),(30010,2169),(30011,2169),(30012,2169),(30013,2169),(30014,2170),(30015,2170),(30016,2170),(30017,2171),(30018,2171),(30019,2171),(30020,2172),(30021,2172),(30022,2172),(30023,2173),(30024,2173),(30025,2173),(30026,2174),(30027,2174),(30028,2174),(30029,2175),(30030,2175),(30031,2175),(30032,2176),(30033,2176),(30034,2176),(30035,2177),(30036,2177),(30037,2177),(30038,2178),(30039,2178),(30040,2178),(30041,2179),(30042,2179),(30043,2179),(30044,2180),(30045,2180),(30046,2180),(30047,2181),(30048,2181),(30049,2181),(30050,2182),(30051,2182),(30052,2182),(30053,2183),(30054,2183),(30055,2183),(30056,2184),(30057,2184),(30058,2184),(30059,2185),(30060,2185),(30061,2185),(30062,2186),(30063,2186),(30064,2186),(30065,2187),(30066,2187),(30067,2187),(30068,2188),(30069,2188),(30070,2188),(30071,2189),(30072,2189),(30073,2189),(30074,2190),(30075,2190),(30076,2190),(30077,2191),(30078,2191),(30079,2191),(30080,2192),(30081,2192),(30082,2192),(30083,2193),(30084,2193),(30085,2193),(30086,2194),(30087,2194),(30088,2194),(30089,2195),(30090,2195),(30091,2195),(30092,2196),(30093,2196),(30094,2196),(30095,2197),(30096,2197),(30097,2197),(30098,2198),(30099,2198),(30100,2198),(30101,2199),(30102,2199),(30103,2199),(30104,2200),(30105,2200),(30106,2200),(30107,2201),(30108,2201),(30109,2201),(30110,2202),(30111,2202),(30112,2202),(30113,2203),(30114,2203),(30115,2203),(30116,2204),(30117,2204),(30118,2204),(30119,2205),(30120,2205),(30121,2205),(30122,2206),(30123,2206),(30124,2206),(30125,2207),(30126,2207),(30127,2207),(30128,2208),(30129,2208),(30130,2208),(30131,2209),(30132,2209),(30133,2209),(30134,2210),(30135,2210),(30136,2210),(30137,2211),(30138,2211),(30139,2211),(30140,2212),(30141,2212),(30142,2212),(30143,2113),(30144,2113),(30145,2113),(30146,2113),(30147,2114),(30148,2114),(30149,2114),(30150,2114),(30151,2115),(30152,2115),(30153,2115),(30154,2115),(30155,2116),(30156,2116),(30157,2116),(30158,2116),(30159,2117),(30160,2117),(30161,2117),(30162,2117),(30163,2118),(30164,2118),(30165,2118),(30166,2118),(30167,2119),(30168,2119),(30169,2119),(30170,2119),(30171,2120),(30172,2120),(30173,2120),(30174,2120),(30175,2121),(30176,2121),(30177,2121),(30178,2121),(30179,2122),(30180,2122),(30181,2122),(30182,2122),(30183,2123),(30184,2123),(30185,2123),(30186,2123),(30187,2124),(30188,2124),(30189,2124),(30190,2124),(30191,2125),(30192,2125),(30193,2125),(30194,2125),(30195,2126),(30196,2126),(30197,2126),(30198,2126),(30199,2127),(30200,2127),(30201,2127),(30202,2127),(30203,2128),(30204,2128),(30205,2128),(30206,2128),(30207,2129),(30208,2129),(30209,2129),(30210,2129),(30211,2130),(30212,2130),(30213,2130),(30214,2130),(30215,2131),(30216,2131),(30217,2131),(30218,2131),(30219,2132),(30220,2132),(30221,2132),(30222,2132),(30223,2133),(30224,2133),(30225,2133),(30226,2133),(30227,2134),(30228,2134),(30229,2134),(30230,2134),(30231,2135),(30232,2135),(30233,2135),(30234,2135),(30235,2136),(30236,2136),(30237,2136),(30238,2136),(30239,2137),(30240,2137),(30241,2137),(30242,2137),(30243,2138),(30244,2138),(30245,2138),(30246,2138),(30247,2139),(30248,2139),(30249,2139),(30250,2139),(30251,2140),(30252,2140),(30253,2140),(30254,2140),(30255,2141),(30256,2141),(30257,2141),(30258,2141),(30259,2142),(30260,2142),(30261,2142),(30262,2142),(30263,2143),(30264,2143),(30265,2143),(30266,2143),(30267,2144),(30268,2144),(30269,2144),(30270,2144),(30271,2145),(30272,2145),(30273,2145),(30274,2145),(30275,2146),(30276,2146),(30277,2146),(30278,2146),(30279,2147),(30280,2147),(30281,2147),(30282,2147),(30283,2148),(30284,2148),(30285,2148),(30286,2148),(30287,2149),(30288,2149),(30289,2149),(30290,2149),(30291,2150),(30292,2150),(30293,2150),(30294,2150),(30295,2151),(30296,2151),(30297,2151),(30298,2151),(30299,2152),(30300,2152),(30301,2152),(30302,2152),(30303,2153),(30304,2153),(30305,2153),(30306,2153),(30307,2154),(30308,2154),(30309,2154),(30310,2154),(30311,2155),(30312,2155),(30313,2155),(30314,2155),(30315,2156),(30316,2156),(30317,2156),(30318,2156),(30319,2157),(30320,2157),(30321,2157),(30322,2157),(30323,2158),(30324,2158),(30325,2158),(30326,2158),(30327,2159),(30328,2159),(30329,2159),(30330,2159),(30331,2160),(30332,2160),(30333,2160),(30334,2160),(30335,2161),(30336,2161),(30337,2161),(30338,2161),(30339,2162),(30340,2162),(30341,2162),(30342,2162),(30343,2163),(30344,2163),(30345,2163),(30346,2163),(30347,2164),(30348,2164),(30349,2164),(30350,2164),(30351,2165),(30352,2165),(30353,2165),(30354,2165),(30355,2166),(30356,2166),(30357,2166),(30358,2166),(30359,2167),(30360,2167),(30361,2167),(30362,2167),(30363,2168),(30364,2168),(30365,2168),(30366,2168),(30367,2169),(30368,2169),(30369,2169),(30370,2169),(30371,2170),(30372,2170),(30373,2170),(30374,2170),(30375,2171),(30376,2171),(30377,2171),(30378,2171),(30379,2172),(30380,2172),(30381,2172),(30382,2172),(30383,2173),(30384,2173),(30385,2173),(30386,2173),(30387,2174),(30388,2174),(30389,2174),(30390,2174),(30391,2175),(30392,2175),(30393,2175),(30394,2175),(30395,2176),(30396,2176),(30397,2176),(30398,2176),(30399,2177),(30400,2177),(30401,2177),(30402,2177),(30403,2178),(30404,2178),(30405,2178),(30406,2178),(30407,2179),(30408,2179),(30409,2179),(30410,2179),(30411,2180),(30412,2180),(30413,2180),(30414,2180),(30415,2181),(30416,2181),(30417,2181),(30418,2181),(30419,2182),(30420,2182),(30421,2182),(30422,2182),(30423,2183),(30424,2183),(30425,2183),(30426,2183),(30427,2184),(30428,2184),(30429,2184),(30430,2184),(30431,2185),(30432,2185),(30433,2185),(30434,2185),(30435,2186),(30436,2186),(30437,2186),(30438,2186),(30439,2187),(30440,2187),(30441,2187),(30442,2187),(30443,2188),(30444,2188),(30445,2188),(30446,2188),(30447,2189),(30448,2189),(30449,2189),(30450,2189),(30451,2190),(30452,2190),(30453,2190),(30454,2190),(30455,2191),(30456,2191),(30457,2191),(30458,2191),(30459,2192),(30460,2192),(30461,2192),(30462,2192),(30463,2193),(30464,2193),(30465,2193),(30466,2193),(30467,2194),(30468,2194),(30469,2194),(30470,2194),(30471,2195),(30472,2195),(30473,2195),(30474,2195),(30475,2196),(30476,2196),(30477,2196),(30478,2196),(30479,2197),(30480,2197),(30481,2197),(30482,2197),(30483,2198),(30484,2198),(30485,2198),(30486,2198),(30487,2199),(30488,2199),(30489,2199),(30490,2199),(30491,2200),(30492,2200),(30493,2200),(30494,2200),(30495,2201),(30496,2201),(30497,2201),(30498,2201),(30499,2202),(30500,2202),(30501,2202),(30502,2202),(30503,2203),(30504,2203),(30505,2203),(30506,2203),(30507,2204),(30508,2204),(30509,2204),(30510,2204),(30511,2205),(30512,2205),(30513,2205),(30514,2205),(30515,2206),(30516,2206),(30517,2206),(30518,2206),(30519,2207),(30520,2207),(30521,2207),(30522,2207),(30523,2208),(30524,2208),(30525,2208),(30526,2208),(30527,2209),(30528,2209),(30529,2209),(30530,2209),(30531,2210),(30532,2210),(30533,2210),(30534,2210),(30535,2211),(30536,2211),(30537,2211),(30538,2211),(30539,2212),(30540,2212),(30541,2212),(30542,2212),(30543,2213),(30544,2213),(30545,2213),(30546,2213),(30547,2213),(30548,2213),(30549,2213),(30550,2214),(30551,2214),(30552,2214),(30553,2214),(30554,2214),(30555,2214),(30556,2214),(30557,2215),(30558,2215),(30559,2215),(30560,2215),(30561,2215),(30562,2215),(30563,2215),(30564,2216),(30565,2216),(30566,2216),(30567,2216),(30568,2216),(30569,2216),(30570,2216),(30571,2217),(30572,2217),(30573,2217),(30574,2217),(30575,2217),(30576,2217),(30577,2217),(30578,2218),(30579,2218),(30580,2218),(30581,2218),(30582,2218),(30583,2218),(30584,2218),(30585,2219),(30586,2219),(30587,2219),(30588,2219),(30589,2219),(30590,2219),(30591,2219),(30592,2220),(30593,2220),(30594,2220),(30595,2220),(30596,2220),(30597,2220),(30598,2220),(30599,2221),(30600,2221),(30601,2221),(30602,2221),(30603,2221),(30604,2221),(30605,2222),(30606,2222),(30607,2222),(30608,2222),(30609,2222),(30610,2222),(30611,2223),(30612,2223),(30613,2223),(30614,2223),(30615,2223),(30616,2223),(30617,2224),(30618,2224),(30619,2224),(30620,2224),(30621,2224),(30622,2224),(30623,2225),(30624,2225),(30625,2225),(30626,2225),(30627,2225),(30628,2225),(30629,2225),(30630,2226),(30631,2226),(30632,2226),(30633,2226),(30634,2226),(30635,2226),(30636,2226),(30637,2226),(30638,2226),(30639,2227),(30640,2227),(30641,2227),(30642,2227),(30643,2227),(30644,2227),(30645,2227),(30646,2228),(30647,2228),(30648,2228),(30649,2228),(30650,2228),(30651,2228),(30652,2228),(30653,2229),(30654,2229),(30655,2229),(30656,2229),(30657,2229),(30658,2229),(30659,2229),(30660,2230),(30661,2230),(30662,2230),(30663,2230),(30664,2230),(30665,2230),(30666,2230),(30667,2230),(30668,2230),(30669,2231),(30670,2231),(30671,2231),(30672,2231),(30673,2231),(30674,2231),(30675,2231),(30676,2232),(30677,2232),(30678,2232),(30679,2232),(30680,2232),(30681,2232),(30682,2232),(30683,2233),(30684,2233),(30685,2233),(30686,2233),(30687,2233),(30688,2233),(30689,2233),(30690,2234),(30691,2234),(30692,2234),(30693,2234),(30694,2234),(30695,2234),(30696,2234),(30697,2235),(30698,2235),(30699,2235),(30700,2235),(30701,2236),(30702,2236),(30703,2236),(30704,2236),(30705,2236),(30706,2236),(30707,2236),(30708,2237),(30709,2237),(30710,2237),(30711,2237),(30712,2237),(30713,2237),(30714,2237),(30715,2238),(30716,2238),(30717,2238),(30718,2238),(30719,2238),(30720,2238),(30721,2238),(30722,2239),(30723,2239),(30724,2239),(30725,2239),(30726,2239),(30727,2239),(30728,2240),(30729,2240),(30730,2240),(30731,2240),(30732,2241),(30733,2241),(30734,2241),(30735,2241),(30736,2241),(30737,2241),(30738,2242),(30739,2242),(30740,2242),(30741,2242),(30742,2242),(30743,2242),(30744,2243),(30745,2243),(30746,2243),(30747,2243),(30748,2243),(30749,2243),(30750,2244),(30751,2244),(30752,2244),(30753,2244),(30754,2244),(30755,2244),(30756,2245),(30757,2245),(30758,2245),(30759,2245),(30760,2245),(30761,2245),(30762,2246),(30763,2246),(30764,2246),(30765,2246),(30766,2246),(30767,2246),(30768,2246),(30769,2246),(30770,2246),(30771,2247),(30772,2247),(30773,2247),(30774,2247),(30775,2247),(30776,2247),(30777,2247),(30778,2248),(30779,2248),(30780,2248),(30781,2248),(30782,2248),(30783,2248),(30784,2248),(30785,2248),(30786,2248),(30787,2249),(30788,2249),(30789,2249),(30790,2249),(30791,2249),(30792,2249),(30793,2249),(30794,2250),(30795,2250),(30796,2250),(30797,2250),(30798,2250),(30799,2250),(30800,2250),(30801,2251),(30802,2251),(30803,2251),(30804,2251),(30805,2251),(30806,2251),(30807,2251),(30808,2252),(30809,2252),(30810,2252),(30811,2252),(30812,2252),(30813,2252),(30814,2252),(30815,2252),(30816,2252),(30817,2253),(30818,2253),(30819,2253),(30820,2253),(30821,2253),(30822,2253),(30823,2253),(30824,2254),(30825,2254),(30826,2254),(30827,2254),(30828,2254),(30829,2254),(30830,2254),(30831,2255),(30832,2255),(30833,2255),(30834,2255),(30835,2255),(30836,2255),(30837,2255),(30838,2256),(30839,2256),(30840,2256),(30841,2256),(30842,2256),(30843,2256),(30844,2256),(30845,2257),(30846,2257),(30847,2257),(30848,2257),(30849,2258),(30850,2258),(30851,2258),(30852,2258),(30853,2259),(30854,2259),(30855,2259),(30856,2259),(30857,2259),(30858,2259),(30859,2259),(30860,2260),(30861,2260),(30862,2260),(30863,2260),(30864,2260),(30865,2260),(30866,2260),(30867,2261),(30868,2261),(30869,2261),(30870,2261),(30871,2261),(30872,2261),(30873,2261),(30874,2262),(30875,2262),(30876,2262),(30877,2262),(30878,2262),(30879,2262),(30880,2262),(30881,2262),(30882,2263),(30883,2263),(30884,2263),(30885,2263),(30886,2263),(30887,2263),(30888,2263),(30889,2264),(30890,2264),(30891,2264),(30892,2264),(30893,2264),(30894,2264),(30895,2264),(30896,2265),(30897,2265),(30898,2265),(30899,2265),(30900,2265),(30901,2265),(30902,2265),(30903,2266),(30904,2266),(30905,2266),(30906,2266),(30907,2266),(30908,2266),(30909,2266),(30910,2267),(30911,2267),(30912,2267),(30913,2267),(30914,2267),(30915,2267),(30916,2267),(30917,2268),(30918,2268),(30919,2268),(30920,2268),(30921,2268),(30922,2268),(30923,2268),(30924,2269),(30925,2269),(30926,2269),(30927,2269),(30928,2269),(30929,2269),(30930,2269),(30931,2270),(30932,2270),(30933,2270),(30934,2270),(30935,2270),(30936,2270),(30937,2270),(30938,2270),(30939,2270),(30940,2271),(30941,2271),(30942,2271),(30943,2271),(30944,2271),(30945,2271),(30946,2271),(30947,2271),(30948,2271),(30949,2272),(30950,2272),(30951,2272),(30952,2272),(30953,2272),(30954,2272),(30955,2272),(30956,2273),(30957,2273),(30958,2273),(30959,2273),(30960,2273),(30961,2273),(30962,2273),(30963,2274),(30964,2274),(30965,2274),(30966,2274),(30967,2274),(30968,2274),(30969,2274),(30970,2275),(30971,2275),(30972,2275),(30973,2275),(30974,2275),(30975,2275),(30976,2276),(30977,2276),(30978,2276),(30979,2276),(30980,2276),(30981,2276),(30982,2276),(30983,2277),(30984,2277),(30985,2277),(30986,2277),(30987,2277),(30988,2277),(30989,2277),(30990,2277),(30991,2277),(30992,2278),(30993,2278),(30994,2278),(30995,2278),(30996,2278),(30997,2278),(30998,2278),(30999,2279),(31000,2279),(31001,2279),(31002,2279),(31003,2279),(31004,2279),(31005,2279),(31006,2280),(31007,2280),(31008,2280),(31009,2280),(31010,2280),(31011,2280),(31012,2280),(31013,2281),(31014,2281),(31015,2281),(31016,2281),(31017,2281),(31018,2281),(31019,2281),(31020,2282),(31021,2282),(31022,2282),(31023,2282),(31024,2282),(31025,2282),(31026,2282),(31027,2283),(31028,2283),(31029,2283),(31030,2283),(31031,2283),(31032,2283),(31033,2283),(31034,2284),(31035,2284),(31036,2284),(31037,2284),(31038,2284),(31039,2284),(31040,2284),(31041,2285),(31042,2285),(31043,2285),(31044,2285),(31045,2285),(31046,2285),(31047,2285),(31048,2286),(31049,2286),(31050,2286),(31051,2286),(31052,2286),(31053,2286),(31054,2286),(31055,2286),(31056,2286),(31057,2287),(31058,2287),(31059,2287),(31060,2287),(31061,2287),(31062,2287),(31063,2287),(31064,2288),(31065,2288),(31066,2288),(31067,2288),(31068,2288),(31069,2288),(31070,2288),(31071,2289),(31072,2289),(31073,2289),(31074,2289),(31075,2289),(31076,2289),(31077,2290),(31078,2290),(31079,2290),(31080,2290),(31081,2290),(31082,2290),(31083,2291),(31084,2291),(31085,2291),(31086,2291),(31087,2291),(31088,2291),(31089,2292),(31090,2292),(31091,2292),(31092,2292),(31093,2292),(31094,2292),(31095,2292),(31096,2293),(31097,2293),(31098,2293),(31099,2293),(31100,2293),(31101,2293),(31102,2294),(31103,2294),(31104,2294),(31105,2294),(31106,2294),(31107,2294),(31108,2294),(31109,2295),(31110,2295),(31111,2295),(31112,2295),(31113,2295),(31114,2295),(31115,2295),(31116,2296),(31117,2296),(31118,2296),(31119,2296),(31120,2296),(31121,2296),(31122,2296),(31123,2297),(31124,2297),(31125,2297),(31126,2297),(31127,2297),(31128,2297),(31129,2297),(31130,2297),(31131,2297),(31132,2298),(31133,2298),(31134,2298),(31135,2298),(31136,2298),(31137,2298),(31138,2298),(31139,2298),(31140,2298),(31141,2299),(31142,2299),(31143,2299),(31144,2299),(31145,2299),(31146,2299),(31147,2299),(31148,2300),(31149,2300),(31150,2300),(31151,2300),(31152,2300),(31153,2300),(31154,2300),(31155,2300),(31156,2301),(31157,2301),(31158,2301),(31159,2301),(31160,2301),(31161,2301),(31162,2301),(31163,2301),(31164,2302),(31165,2302),(31166,2302),(31167,2302),(31168,2303),(31169,2303),(31170,2303),(31171,2303),(31172,2304),(31173,2304),(31174,2304),(31175,2304),(31176,2304),(31177,2304),(31178,2304),(31179,2305),(31180,2305),(31181,2305),(31182,2305),(31183,2305),(31184,2305),(31185,2305),(31186,2306),(31187,2306),(31188,2306),(31189,2306),(31190,2306),(31191,2306),(31192,2306),(31193,2307),(31194,2307),(31195,2307),(31196,2307),(31197,2307),(31198,2307),(31199,2307),(31200,2308),(31201,2308),(31202,2308),(31203,2308),(31204,2308),(31205,2308),(31206,2308),(31207,2309),(31208,2309),(31209,2309),(31210,2309),(31211,2309),(31212,2309),(31213,2309),(31214,2310),(31215,2310),(31216,2310),(31217,2310),(31218,2310),(31219,2310),(31220,2310),(31221,2213),(31222,2213),(31223,2213),(31224,2214),(31225,2214),(31226,2214),(31227,2215),(31228,2215),(31229,2215),(31230,2216),(31231,2216),(31232,2216),(31233,2217),(31234,2217),(31235,2217),(31236,2218),(31237,2218),(31238,2218),(31239,2219),(31240,2219),(31241,2219),(31242,2220),(31243,2220),(31244,2220),(31245,2221),(31246,2221),(31247,2221),(31248,2222),(31249,2222),(31250,2222),(31251,2223),(31252,2223),(31253,2223),(31254,2224),(31255,2224),(31256,2224),(31257,2225),(31258,2225),(31259,2225),(31260,2226),(31261,2226),(31262,2226),(31263,2227),(31264,2227),(31265,2227),(31266,2228),(31267,2228),(31268,2228),(31269,2229),(31270,2229),(31271,2229),(31272,2230),(31273,2230),(31274,2230),(31275,2231),(31276,2231),(31277,2231),(31278,2232),(31279,2232),(31280,2232),(31281,2233),(31282,2233),(31283,2233),(31284,2234),(31285,2234),(31286,2234),(31287,2235),(31288,2235),(31289,2235),(31290,2236),(31291,2236),(31292,2236),(31293,2237),(31294,2237),(31295,2237),(31296,2238),(31297,2238),(31298,2238),(31299,2239),(31300,2239),(31301,2239),(31302,2239),(31303,2240),(31304,2240),(31305,2240),(31306,2241),(31307,2242),(31308,2243),(31309,2244),(31310,2245),(31311,2245),(31312,2245),(31313,2245),(31314,2246),(31315,2246),(31316,2246),(31317,2247),(31318,2247),(31319,2247),(31320,2248),(31321,2248),(31322,2248),(31323,2249),(31324,2249),(31325,2249),(31326,2250),(31327,2250),(31328,2250),(31329,2251),(31330,2251),(31331,2251),(31332,2252),(31333,2252),(31334,2252),(31335,2253),(31336,2253),(31337,2253),(31338,2254),(31339,2254),(31340,2254),(31341,2255),(31342,2255),(31343,2255),(31344,2256),(31345,2256),(31346,2256),(31347,2257),(31348,2257),(31349,2257),(31350,2258),(31351,2258),(31352,2258),(31353,2259),(31354,2259),(31355,2259),(31356,2260),(31357,2260),(31358,2260),(31359,2261),(31360,2261),(31361,2261),(31362,2262),(31363,2262),(31364,2262),(31365,2263),(31366,2263),(31367,2263),(31368,2264),(31369,2264),(31370,2264),(31371,2265),(31372,2265),(31373,2265),(31374,2266),(31375,2266),(31376,2266),(31377,2267),(31378,2267),(31379,2267),(31380,2268),(31381,2268),(31382,2268),(31383,2269),(31384,2269),(31385,2269),(31386,2270),(31387,2270),(31388,2270),(31389,2271),(31390,2271),(31391,2271),(31392,2272),(31393,2272),(31394,2272),(31395,2273),(31396,2273),(31397,2273),(31398,2274),(31399,2274),(31400,2274),(31401,2275),(31402,2275),(31403,2275),(31404,2276),(31405,2276),(31406,2276),(31407,2277),(31408,2277),(31409,2277),(31410,2278),(31411,2278),(31412,2278),(31413,2279),(31414,2279),(31415,2279),(31416,2280),(31417,2280),(31418,2280),(31419,2281),(31420,2281),(31421,2281),(31422,2282),(31423,2282),(31424,2282),(31425,2283),(31426,2283),(31427,2283),(31428,2284),(31429,2284),(31430,2284),(31431,2285),(31432,2285),(31433,2285),(31434,2286),(31435,2286),(31436,2286),(31437,2287),(31438,2287),(31439,2287),(31440,2288),(31441,2288),(31442,2288),(31443,2289),(31444,2289),(31445,2289),(31446,2290),(31447,2290),(31448,2290),(31449,2291),(31450,2291),(31451,2291),(31452,2292),(31453,2292),(31454,2292),(31455,2293),(31456,2293),(31457,2293),(31458,2294),(31459,2294),(31460,2294),(31461,2295),(31462,2295),(31463,2295),(31464,2296),(31465,2296),(31466,2296),(31467,2297),(31468,2297),(31469,2297),(31470,2298),(31471,2298),(31472,2298),(31473,2299),(31474,2299),(31475,2299),(31476,2300),(31477,2300),(31478,2300),(31479,2301),(31480,2301),(31481,2301),(31482,2302),(31483,2302),(31484,2302),(31485,2303),(31486,2303),(31487,2303),(31488,2304),(31489,2304),(31490,2304),(31491,2305),(31492,2305),(31493,2305),(31494,2306),(31495,2306),(31496,2306),(31497,2307),(31498,2307),(31499,2307),(31500,2308),(31501,2308),(31502,2308),(31503,2309),(31504,2309),(31505,2309),(31506,2310),(31507,2310),(31508,2310),(31509,2213),(31510,2213),(31511,2213),(31512,2213),(31513,2214),(31514,2214),(31515,2214),(31516,2214),(31517,2215),(31518,2215),(31519,2215),(31520,2215),(31521,2216),(31522,2216),(31523,2216),(31524,2216),(31525,2217),(31526,2217),(31527,2217),(31528,2217),(31529,2218),(31530,2218),(31531,2218),(31532,2218),(31533,2219),(31534,2219),(31535,2219),(31536,2219),(31537,2220),(31538,2220),(31539,2220),(31540,2220),(31541,2221),(31542,2221),(31543,2221),(31544,2221),(31545,2222),(31546,2222),(31547,2222),(31548,2222),(31549,2223),(31550,2223),(31551,2223),(31552,2223),(31553,2224),(31554,2224),(31555,2224),(31556,2224),(31557,2225),(31558,2225),(31559,2225),(31560,2225),(31561,2226),(31562,2226),(31563,2226),(31564,2226),(31565,2227),(31566,2227),(31567,2227),(31568,2227),(31569,2228),(31570,2228),(31571,2228),(31572,2228),(31573,2229),(31574,2229),(31575,2229),(31576,2229),(31577,2230),(31578,2230),(31579,2230),(31580,2230),(31581,2231),(31582,2231),(31583,2231),(31584,2231),(31585,2232),(31586,2232),(31587,2232),(31588,2232),(31589,2233),(31590,2233),(31591,2233),(31592,2233),(31593,2234),(31594,2234),(31595,2234),(31596,2234),(31597,2235),(31598,2235),(31599,2235),(31600,2235),(31601,2236),(31602,2236),(31603,2236),(31604,2236),(31605,2237),(31606,2237),(31607,2237),(31608,2237),(31609,2238),(31610,2238),(31611,2238),(31612,2238),(31613,2239),(31614,2239),(31615,2239),(31616,2239),(31617,2240),(31618,2240),(31619,2240),(31620,2240),(31621,2241),(31622,2241),(31623,2241),(31624,2241),(31625,2242),(31626,2242),(31627,2242),(31628,2242),(31629,2243),(31630,2243),(31631,2243),(31632,2243),(31633,2244),(31634,2244),(31635,2244),(31636,2244),(31637,2245),(31638,2245),(31639,2245),(31640,2245),(31641,2246),(31642,2246),(31643,2246),(31644,2246),(31645,2247),(31646,2247),(31647,2247),(31648,2247),(31649,2248),(31650,2248),(31651,2248),(31652,2248),(31653,2249),(31654,2249),(31655,2249),(31656,2249),(31657,2250),(31658,2250),(31659,2250),(31660,2250),(31661,2251),(31662,2251),(31663,2251),(31664,2251),(31665,2252),(31666,2252),(31667,2252),(31668,2252),(31669,2253),(31670,2253),(31671,2253),(31672,2253),(31673,2254),(31674,2254),(31675,2254),(31676,2254),(31677,2255),(31678,2255),(31679,2255),(31680,2255),(31681,2256),(31682,2256),(31683,2256),(31684,2256),(31685,2257),(31686,2257),(31687,2257),(31688,2257),(31689,2258),(31690,2258),(31691,2258),(31692,2258),(31693,2259),(31694,2259),(31695,2259),(31696,2259),(31697,2260),(31698,2260),(31699,2260),(31700,2260),(31701,2261),(31702,2261),(31703,2261),(31704,2261),(31705,2262),(31706,2262),(31707,2262),(31708,2262),(31709,2263),(31710,2263),(31711,2263),(31712,2263),(31713,2264),(31714,2264),(31715,2264),(31716,2264),(31717,2265),(31718,2265),(31719,2265),(31720,2265),(31721,2266),(31722,2266),(31723,2266),(31724,2266),(31725,2267),(31726,2267),(31727,2267),(31728,2267),(31729,2268),(31730,2268),(31731,2268),(31732,2268),(31733,2269),(31734,2269),(31735,2269),(31736,2269),(31737,2270),(31738,2270),(31739,2270),(31740,2270),(31741,2271),(31742,2271),(31743,2271),(31744,2271),(31745,2272),(31746,2272),(31747,2272),(31748,2272),(31749,2273),(31750,2273),(31751,2273),(31752,2273),(31753,2274),(31754,2274),(31755,2274),(31756,2274),(31757,2275),(31758,2275),(31759,2275),(31760,2275),(31761,2276),(31762,2276),(31763,2276),(31764,2276),(31765,2277),(31766,2277),(31767,2277),(31768,2277),(31769,2278),(31770,2278),(31771,2278),(31772,2278),(31773,2279),(31774,2279),(31775,2279),(31776,2279),(31777,2280),(31778,2280),(31779,2280),(31780,2280),(31781,2281),(31782,2281),(31783,2281),(31784,2281),(31785,2282),(31786,2282),(31787,2282),(31788,2282),(31789,2283),(31790,2283),(31791,2283),(31792,2283),(31793,2284),(31794,2284),(31795,2284),(31796,2284),(31797,2285),(31798,2285),(31799,2285),(31800,2285),(31801,2286),(31802,2286),(31803,2286),(31804,2286),(31805,2287),(31806,2287),(31807,2287),(31808,2287),(31809,2288),(31810,2288),(31811,2288),(31812,2288),(31813,2289),(31814,2289),(31815,2289),(31816,2289),(31817,2290),(31818,2290),(31819,2290),(31820,2290),(31821,2291),(31822,2291),(31823,2291),(31824,2291),(31825,2292),(31826,2292),(31827,2292),(31828,2292),(31829,2293),(31830,2293),(31831,2293),(31832,2293),(31833,2294),(31834,2294),(31835,2294),(31836,2294),(31837,2295),(31838,2295),(31839,2295),(31840,2295),(31841,2296),(31842,2296),(31843,2296),(31844,2296),(31845,2297),(31846,2297),(31847,2297),(31848,2297),(31849,2298),(31850,2298),(31851,2298),(31852,2298),(31853,2299),(31854,2299),(31855,2299),(31856,2299),(31857,2300),(31858,2300),(31859,2300),(31860,2300),(31861,2301),(31862,2301),(31863,2301),(31864,2301),(31865,2302),(31866,2302),(31867,2302),(31868,2302),(31869,2303),(31870,2303),(31871,2303),(31872,2303),(31873,2304),(31874,2304),(31875,2304),(31876,2304),(31877,2305),(31878,2305),(31879,2305),(31880,2305),(31881,2306),(31882,2306),(31883,2306),(31884,2306),(31885,2307),(31886,2307),(31887,2307),(31888,2307),(31889,2308),(31890,2308),(31891,2308),(31892,2308),(31893,2309),(31894,2309),(31895,2309),(31896,2309),(31897,2310),(31898,2310),(31899,2310),(31900,2310),(31901,2311),(31902,2311),(31903,2311),(31904,2311),(31905,2312),(31906,2312),(31907,2312),(31908,2312),(31909,2312),(31910,2312),(31911,2312),(31912,2313),(31913,2313),(31914,2313),(31915,2313),(31916,2313),(31917,2313),(31918,2313),(31919,2314),(31920,2314),(31921,2314),(31922,2314),(31923,2314),(31924,2314),(31925,2314),(31926,2315),(31927,2315),(31928,2315),(31929,2315),(31930,2316),(31931,2316),(31932,2316),(31933,2316),(31934,2316),(31935,2316),(31936,2316),(31937,2317),(31938,2317),(31939,2317),(31940,2317),(31941,2317),(31942,2317),(31943,2317),(31944,2318),(31945,2318),(31946,2318),(31947,2318),(31948,2318),(31949,2318),(31950,2318),(31951,2319),(31952,2319),(31953,2319),(31954,2319),(31955,2319),(31956,2319),(31957,2319),(31958,2320),(31959,2320),(31960,2320),(31961,2320),(31962,2320),(31963,2320),(31964,2320),(31965,2321),(31966,2321),(31967,2321),(31968,2321),(31969,2321),(31970,2321),(31971,2321),(31972,2311),(31973,2311),(31974,2311),(31975,2312),(31976,2312),(31977,2312),(31978,2313),(31979,2313),(31980,2313),(31981,2314),(31982,2314),(31983,2314),(31984,2315),(31985,2315),(31986,2315),(31987,2316),(31988,2316),(31989,2316),(31990,2317),(31991,2317),(31992,2317),(31993,2318),(31994,2318),(31995,2318),(31996,2319),(31997,2319),(31998,2319),(31999,2320),(32000,2320),(32001,2320),(32002,2321),(32003,2321),(32004,2321),(32005,2311),(32006,2311),(32007,2311),(32008,2311),(32009,2312),(32010,2312),(32011,2312),(32012,2312),(32013,2313),(32014,2313),(32015,2313),(32016,2313),(32017,2314),(32018,2314),(32019,2314),(32020,2314),(32021,2315),(32022,2315),(32023,2315),(32024,2315),(32025,2316),(32026,2316),(32027,2316),(32028,2316),(32029,2317),(32030,2317),(32031,2317),(32032,2317),(32033,2318),(32034,2318),(32035,2318),(32036,2318),(32037,2319),(32038,2319),(32039,2319),(32040,2319),(32041,2320),(32042,2320),(32043,2320),(32044,2320),(32045,2321),(32046,2321),(32047,2321),(32048,2321),(32049,2322),(32050,2322),(32051,2322),(32052,2322),(32053,2322),(32054,2322),(32055,2322),(32056,2323),(32057,2323),(32058,2323),(32059,2323),(32060,2323),(32061,2323),(32062,2323),(32063,2324),(32064,2324),(32065,2324),(32066,2324),(32067,2324),(32068,2324),(32069,2324),(32070,2325),(32071,2325),(32072,2325),(32073,2325),(32074,2325),(32075,2325),(32076,2325),(32077,2326),(32078,2326),(32079,2326),(32080,2326),(32081,2326),(32082,2326),(32083,2326),(32084,2327),(32085,2327),(32086,2327),(32087,2327),(32088,2327),(32089,2327),(32090,2327),(32091,2328),(32092,2328),(32093,2328),(32094,2328),(32095,2328),(32096,2328),(32097,2328),(32098,2329),(32099,2329),(32100,2329),(32101,2329),(32102,2329),(32103,2329),(32104,2329),(32105,2330),(32106,2330),(32107,2330),(32108,2330),(32109,2330),(32110,2330),(32111,2330),(32112,2331),(32113,2331),(32114,2331),(32115,2331),(32116,2331),(32117,2331),(32118,2331),(32119,2332),(32120,2332),(32121,2332),(32122,2332),(32123,2332),(32124,2332),(32125,2332),(32126,2333),(32127,2333),(32128,2333),(32129,2333),(32130,2333),(32131,2333),(32132,2333),(32133,2334),(32134,2334),(32135,2334),(32136,2334),(32137,2334),(32138,2334),(32139,2334),(32140,2335),(32141,2335),(32142,2335),(32143,2335),(32144,2335),(32145,2335),(32146,2335),(32147,2336),(32148,2336),(32149,2336),(32150,2336),(32151,2336),(32152,2336),(32153,2336),(32154,2337),(32155,2337),(32156,2337),(32157,2337),(32158,2337),(32159,2337),(32160,2337),(32161,2338),(32162,2338),(32163,2338),(32164,2338),(32165,2338),(32166,2338),(32167,2338),(32168,2339),(32169,2339),(32170,2339),(32171,2339),(32172,2339),(32173,2339),(32174,2339),(32175,2340),(32176,2340),(32177,2340),(32178,2340),(32179,2340),(32180,2340),(32181,2340),(32182,2341),(32183,2341),(32184,2341),(32185,2341),(32186,2341),(32187,2341),(32188,2341),(32189,2342),(32190,2342),(32191,2342),(32192,2342),(32193,2342),(32194,2342),(32195,2342),(32196,2343),(32197,2343),(32198,2343),(32199,2343),(32200,2343),(32201,2343),(32202,2343),(32203,2344),(32204,2344),(32205,2344),(32206,2344),(32207,2344),(32208,2344),(32209,2344),(32210,2345),(32211,2345),(32212,2345),(32213,2345),(32214,2345),(32215,2345),(32216,2345),(32217,2346),(32218,2346),(32219,2346),(32220,2346),(32221,2346),(32222,2346),(32223,2346),(32224,2347),(32225,2347),(32226,2347),(32227,2347),(32228,2347),(32229,2347),(32230,2347),(32231,2348),(32232,2348),(32233,2348),(32234,2348),(32235,2348),(32236,2348),(32237,2348),(32238,2349),(32239,2349),(32240,2349),(32241,2349),(32242,2349),(32243,2349),(32244,2349),(32245,2350),(32246,2350),(32247,2350),(32248,2350),(32249,2350),(32250,2350),(32251,2350),(32252,2351),(32253,2351),(32254,2351),(32255,2351),(32256,2351),(32257,2351),(32258,2351),(32259,2352),(32260,2352),(32261,2352),(32262,2352),(32263,2352),(32264,2352),(32265,2352),(32266,2353),(32267,2353),(32268,2353),(32269,2353),(32270,2353),(32271,2353),(32272,2353),(32273,2354),(32274,2354),(32275,2354),(32276,2354),(32277,2354),(32278,2354),(32279,2354),(32280,2355),(32281,2355),(32282,2355),(32283,2355),(32284,2355),(32285,2355),(32286,2355),(32287,2356),(32288,2356),(32289,2356),(32290,2356),(32291,2356),(32292,2356),(32293,2356),(32294,2357),(32295,2357),(32296,2357),(32297,2357),(32298,2357),(32299,2357),(32300,2357),(32301,2358),(32302,2358),(32303,2358),(32304,2358),(32305,2358),(32306,2358),(32307,2358),(32308,2359),(32309,2359),(32310,2359),(32311,2359),(32312,2359),(32313,2359),(32314,2359),(32315,2360),(32316,2360),(32317,2360),(32318,2360),(32319,2360),(32320,2360),(32321,2360),(32322,2361),(32323,2361),(32324,2361),(32325,2361),(32326,2361),(32327,2361),(32328,2361),(32329,2362),(32330,2362),(32331,2362),(32332,2362),(32333,2362),(32334,2362),(32335,2362),(32336,2363),(32337,2363),(32338,2363),(32339,2363),(32340,2363),(32341,2363),(32342,2363),(32343,2364),(32344,2364),(32345,2364),(32346,2364),(32347,2364),(32348,2364),(32349,2364),(32350,2365),(32351,2365),(32352,2365),(32353,2365),(32354,2365),(32355,2365),(32356,2365),(32357,2366),(32358,2366),(32359,2366),(32360,2366),(32361,2366),(32362,2366),(32363,2366),(32364,2367),(32365,2367),(32366,2367),(32367,2367),(32368,2367),(32369,2367),(32370,2367),(32371,2368),(32372,2368),(32373,2368),(32374,2368),(32375,2368),(32376,2368),(32377,2368),(32378,2369),(32379,2369),(32380,2369),(32381,2369),(32382,2369),(32383,2369),(32384,2369),(32385,2370),(32386,2370),(32387,2370),(32388,2370),(32389,2370),(32390,2370),(32391,2370),(32392,2371),(32393,2371),(32394,2371),(32395,2371),(32396,2371),(32397,2371),(32398,2371),(32399,2372),(32400,2372),(32401,2372),(32402,2372),(32403,2372),(32404,2372),(32405,2372),(32406,2373),(32407,2373),(32408,2373),(32409,2373),(32410,2373),(32411,2373),(32412,2373),(32413,2374),(32414,2374),(32415,2374),(32416,2374),(32417,2374),(32418,2374),(32419,2374),(32420,2375),(32421,2375),(32422,2375),(32423,2375),(32424,2375),(32425,2375),(32426,2376),(32427,2376),(32428,2376),(32429,2376),(32430,2376),(32431,2376),(32432,2377),(32433,2377),(32434,2377),(32435,2377),(32436,2377),(32437,2377),(32438,2377),(32439,2377),(32440,2377),(32441,2378),(32442,2378),(32443,2378),(32444,2378),(32445,2378),(32446,2378),(32447,2378),(32448,2378),(32449,2378),(32450,2379),(32451,2379),(32452,2379),(32453,2379),(32454,2379),(32455,2379),(32456,2380),(32457,2380),(32458,2380),(32459,2380),(32460,2380),(32461,2380),(32462,2381),(32463,2381),(32464,2381),(32465,2381),(32466,2381),(32467,2381),(32468,2382),(32469,2382),(32470,2382),(32471,2382),(32472,2382),(32473,2382),(32474,2382),(32475,2382),(32476,2382),(32477,2383),(32478,2383),(32479,2383),(32480,2383),(32481,2383),(32482,2383),(32483,2384),(32484,2384),(32485,2384),(32486,2384),(32487,2384),(32488,2384),(32489,2385),(32490,2385),(32491,2385),(32492,2385),(32493,2385),(32494,2385),(32495,2385),(32496,2385),(32497,2385),(32498,2386),(32499,2386),(32500,2386),(32501,2386),(32502,2386),(32503,2386),(32504,2386),(32505,2386),(32506,2386),(32507,2387),(32508,2387),(32509,2387),(32510,2387),(32511,2387),(32512,2387),(32513,2388),(32514,2388),(32515,2388),(32516,2388),(32517,2388),(32518,2388),(32519,2388),(32520,2388),(32521,2388),(32522,2389),(32523,2389),(32524,2389),(32525,2389),(32526,2389),(32527,2389),(32528,2389),(32529,2389),(32530,2389),(32531,2390),(32532,2390),(32533,2390),(32534,2390),(32535,2390),(32536,2390),(32537,2391),(32538,2391),(32539,2391),(32540,2391),(32541,2391),(32542,2391),(32543,2391),(32544,2391),(32545,2391),(32546,2392),(32547,2392),(32548,2392),(32549,2392),(32550,2392),(32551,2392),(32552,2392),(32553,2393),(32554,2393),(32555,2393),(32556,2393),(32557,2393),(32558,2393),(32559,2393),(32560,2394),(32561,2394),(32562,2394),(32563,2394),(32564,2394),(32565,2394),(32566,2394),(32567,2395),(32568,2395),(32569,2395),(32570,2395),(32571,2395),(32572,2395),(32573,2395),(32574,2396),(32575,2396),(32576,2396),(32577,2396),(32578,2396),(32579,2396),(32580,2396),(32581,2397),(32582,2397),(32583,2397),(32584,2397),(32585,2397),(32586,2397),(32587,2397),(32588,2398),(32589,2398),(32590,2398),(32591,2398),(32592,2398),(32593,2398),(32594,2398),(32595,2399),(32596,2399),(32597,2399),(32598,2399),(32599,2399),(32600,2399),(32601,2399),(32602,2400),(32603,2400),(32604,2400),(32605,2400),(32606,2400),(32607,2400),(32608,2400),(32609,2401),(32610,2401),(32611,2401),(32612,2401),(32613,2401),(32614,2401),(32615,2401),(32616,2402),(32617,2402),(32618,2402),(32619,2402),(32620,2402),(32621,2402),(32622,2402),(32623,2403),(32624,2403),(32625,2403),(32626,2403),(32627,2403),(32628,2403),(32629,2403),(32630,2404),(32631,2404),(32632,2404),(32633,2404),(32634,2404),(32635,2404),(32636,2404),(32637,2405),(32638,2405),(32639,2405),(32640,2405),(32641,2405),(32642,2405),(32643,2405),(32644,2406),(32645,2406),(32646,2406),(32647,2406),(32648,2406),(32649,2406),(32650,2406),(32651,2407),(32652,2407),(32653,2407),(32654,2407),(32655,2407),(32656,2407),(32657,2407),(32658,2408),(32659,2408),(32660,2408),(32661,2408),(32662,2408),(32663,2408),(32664,2408),(32665,2409),(32666,2409),(32667,2409),(32668,2409),(32669,2409),(32670,2409),(32671,2409),(32672,2410),(32673,2410),(32674,2410),(32675,2410),(32676,2410),(32677,2410),(32678,2410),(32679,2322),(32680,2322),(32681,2322),(32682,2323),(32683,2323),(32684,2323),(32685,2324),(32686,2324),(32687,2324),(32688,2325),(32689,2325),(32690,2325),(32691,2326),(32692,2326),(32693,2326),(32694,2327),(32695,2327),(32696,2327),(32697,2328),(32698,2328),(32699,2328),(32700,2329),(32701,2329),(32702,2329),(32703,2330),(32704,2330),(32705,2330),(32706,2331),(32707,2331),(32708,2331),(32709,2332),(32710,2332),(32711,2332),(32712,2333),(32713,2333),(32714,2333),(32715,2334),(32716,2334),(32717,2334),(32718,2335),(32719,2335),(32720,2335),(32721,2336),(32722,2336),(32723,2336),(32724,2337),(32725,2337),(32726,2337),(32727,2338),(32728,2338),(32729,2338),(32730,2339),(32731,2339),(32732,2339),(32733,2340),(32734,2340),(32735,2340),(32736,2341),(32737,2341),(32738,2341),(32739,2342),(32740,2342),(32741,2342),(32742,2343),(32743,2343),(32744,2343),(32745,2344),(32746,2344),(32747,2344),(32748,2345),(32749,2345),(32750,2345),(32751,2346),(32752,2346),(32753,2346),(32754,2347),(32755,2347),(32756,2347),(32757,2348),(32758,2348),(32759,2348),(32760,2349),(32761,2349),(32762,2349),(32763,2350),(32764,2350),(32765,2350),(32766,2351),(32767,2351),(32768,2351),(32769,2352),(32770,2352),(32771,2352),(32772,2353),(32773,2353),(32774,2353),(32775,2354),(32776,2354),(32777,2354),(32778,2355),(32779,2355),(32780,2355),(32781,2356),(32782,2356),(32783,2356),(32784,2357),(32785,2357),(32786,2357),(32787,2358),(32788,2358),(32789,2358),(32790,2359),(32791,2359),(32792,2359),(32793,2360),(32794,2360),(32795,2360),(32796,2361),(32797,2361),(32798,2361),(32799,2362),(32800,2362),(32801,2362),(32802,2363),(32803,2363),(32804,2363),(32805,2364),(32806,2364),(32807,2364),(32808,2365),(32809,2365),(32810,2365),(32811,2366),(32812,2366),(32813,2366),(32814,2367),(32815,2367),(32816,2367),(32817,2368),(32818,2368),(32819,2368),(32820,2369),(32821,2369),(32822,2369),(32823,2370),(32824,2370),(32825,2370),(32826,2371),(32827,2371),(32828,2371),(32829,2372),(32830,2372),(32831,2372),(32832,2373),(32833,2373),(32834,2373),(32835,2374),(32836,2374),(32837,2374),(32838,2375),(32839,2375),(32840,2375),(32841,2376),(32842,2376),(32843,2376),(32844,2377),(32845,2377),(32846,2377),(32847,2378),(32848,2378),(32849,2378),(32850,2379),(32851,2379),(32852,2379),(32853,2380),(32854,2380),(32855,2380),(32856,2381),(32857,2381),(32858,2381),(32859,2382),(32860,2382),(32861,2382),(32862,2383),(32863,2383),(32864,2383),(32865,2384),(32866,2384),(32867,2384),(32868,2385),(32869,2385),(32870,2385),(32871,2386),(32872,2386),(32873,2386),(32874,2387),(32875,2387),(32876,2387),(32877,2388),(32878,2388),(32879,2388),(32880,2389),(32881,2389),(32882,2389),(32883,2390),(32884,2390),(32885,2390),(32886,2391),(32887,2391),(32888,2391),(32889,2392),(32890,2392),(32891,2392),(32892,2393),(32893,2393),(32894,2393),(32895,2394),(32896,2394),(32897,2394),(32898,2395),(32899,2395),(32900,2395),(32901,2396),(32902,2396),(32903,2396),(32904,2397),(32905,2397),(32906,2397),(32907,2398),(32908,2398),(32909,2398),(32910,2399),(32911,2399),(32912,2399),(32913,2400),(32914,2400),(32915,2400),(32916,2401),(32917,2401),(32918,2401),(32919,2402),(32920,2402),(32921,2402),(32922,2403),(32923,2403),(32924,2403),(32925,2404),(32926,2404),(32927,2404),(32928,2405),(32929,2405),(32930,2405),(32931,2406),(32932,2406),(32933,2406),(32934,2407),(32935,2407),(32936,2407),(32937,2408),(32938,2408),(32939,2408),(32940,2409),(32941,2409),(32942,2409),(32943,2410),(32944,2410),(32945,2410),(32946,2322),(32947,2322),(32948,2322),(32949,2322),(32950,2323),(32951,2323),(32952,2323),(32953,2323),(32954,2324),(32955,2324),(32956,2324),(32957,2324),(32958,2325),(32959,2325),(32960,2325),(32961,2325),(32962,2326),(32963,2326),(32964,2326),(32965,2326),(32966,2327),(32967,2327),(32968,2327),(32969,2327),(32970,2328),(32971,2328),(32972,2328),(32973,2328),(32974,2329),(32975,2329),(32976,2329),(32977,2329),(32978,2330),(32979,2330),(32980,2330),(32981,2330),(32982,2331),(32983,2331),(32984,2331),(32985,2331),(32986,2332),(32987,2332),(32988,2332),(32989,2332),(32990,2333),(32991,2333),(32992,2333),(32993,2333),(32994,2334),(32995,2334),(32996,2334),(32997,2334),(32998,2335),(32999,2335),(33000,2335),(33001,2335),(33002,2336),(33003,2336),(33004,2336),(33005,2336),(33006,2337),(33007,2337),(33008,2337),(33009,2337),(33010,2338),(33011,2338),(33012,2338),(33013,2338),(33014,2339),(33015,2339),(33016,2339),(33017,2339),(33018,2340),(33019,2340),(33020,2340),(33021,2340),(33022,2341),(33023,2341),(33024,2341),(33025,2341),(33026,2342),(33027,2342),(33028,2342),(33029,2342),(33030,2343),(33031,2343),(33032,2343),(33033,2343),(33034,2344),(33035,2344),(33036,2344),(33037,2344),(33038,2345),(33039,2345),(33040,2345),(33041,2345),(33042,2346),(33043,2346),(33044,2346),(33045,2346),(33046,2347),(33047,2347),(33048,2347),(33049,2347),(33050,2348),(33051,2348),(33052,2348),(33053,2348),(33054,2349),(33055,2349),(33056,2349),(33057,2349),(33058,2350),(33059,2350),(33060,2350),(33061,2350),(33062,2351),(33063,2351),(33064,2351),(33065,2351),(33066,2352),(33067,2352),(33068,2352),(33069,2352),(33070,2353),(33071,2353),(33072,2353),(33073,2353),(33074,2354),(33075,2354),(33076,2354),(33077,2354),(33078,2355),(33079,2355),(33080,2355),(33081,2355),(33082,2356),(33083,2356),(33084,2356),(33085,2356),(33086,2357),(33087,2357),(33088,2357),(33089,2357),(33090,2358),(33091,2358),(33092,2358),(33093,2358),(33094,2359),(33095,2359),(33096,2359),(33097,2359),(33098,2360),(33099,2360),(33100,2360),(33101,2360),(33102,2361),(33103,2361),(33104,2361),(33105,2361),(33106,2362),(33107,2362),(33108,2362),(33109,2362),(33110,2363),(33111,2363),(33112,2363),(33113,2363),(33114,2364),(33115,2364),(33116,2364),(33117,2364),(33118,2365),(33119,2365),(33120,2365),(33121,2365),(33122,2366),(33123,2366),(33124,2366),(33125,2366),(33126,2367),(33127,2367),(33128,2367),(33129,2367),(33130,2368),(33131,2368),(33132,2368),(33133,2368),(33134,2369),(33135,2369),(33136,2369),(33137,2369),(33138,2370),(33139,2370),(33140,2370),(33141,2370),(33142,2371),(33143,2371),(33144,2371),(33145,2371),(33146,2372),(33147,2372),(33148,2372),(33149,2372),(33150,2373),(33151,2373),(33152,2373),(33153,2373),(33154,2374),(33155,2374),(33156,2374),(33157,2374),(33158,2375),(33159,2375),(33160,2375),(33161,2375),(33162,2376),(33163,2376),(33164,2376),(33165,2376),(33166,2377),(33167,2377),(33168,2377),(33169,2377),(33170,2378),(33171,2378),(33172,2378),(33173,2378),(33174,2379),(33175,2379),(33176,2379),(33177,2379),(33178,2380),(33179,2380),(33180,2380),(33181,2380),(33182,2381),(33183,2381),(33184,2381),(33185,2381),(33186,2382),(33187,2382),(33188,2382),(33189,2382),(33190,2383),(33191,2383),(33192,2383),(33193,2383),(33194,2384),(33195,2384),(33196,2384),(33197,2384),(33198,2385),(33199,2385),(33200,2385),(33201,2385),(33202,2386),(33203,2386),(33204,2386),(33205,2386),(33206,2387),(33207,2387),(33208,2387),(33209,2387),(33210,2388),(33211,2388),(33212,2388),(33213,2388),(33214,2389),(33215,2389),(33216,2389),(33217,2389),(33218,2390),(33219,2390),(33220,2390),(33221,2390),(33222,2391),(33223,2391),(33224,2391),(33225,2391),(33226,2392),(33227,2392),(33228,2392),(33229,2392),(33230,2393),(33231,2393),(33232,2393),(33233,2393),(33234,2394),(33235,2394),(33236,2394),(33237,2394),(33238,2395),(33239,2395),(33240,2395),(33241,2395),(33242,2396),(33243,2396),(33244,2396),(33245,2396),(33246,2397),(33247,2397),(33248,2397),(33249,2397),(33250,2398),(33251,2398),(33252,2398),(33253,2398),(33254,2399),(33255,2399),(33256,2399),(33257,2399),(33258,2400),(33259,2400),(33260,2400),(33261,2400),(33262,2401),(33263,2401),(33264,2401),(33265,2401),(33266,2402),(33267,2402),(33268,2402),(33269,2402),(33270,2403),(33271,2403),(33272,2403),(33273,2403),(33274,2404),(33275,2404),(33276,2404),(33277,2404),(33278,2405),(33279,2405),(33280,2405),(33281,2405),(33282,2406),(33283,2406),(33284,2406),(33285,2406),(33286,2407),(33287,2407),(33288,2407),(33289,2407),(33290,2408),(33291,2408),(33292,2408),(33293,2408),(33294,2409),(33295,2409),(33296,2409),(33297,2409),(33298,2410),(33299,2410),(33300,2410),(33301,2410),(33302,2411),(33303,2411),(33304,2411),(33305,2411),(33306,2411),(33307,2411),(33308,2411),(33309,2412),(33310,2412),(33311,2412),(33312,2412),(33313,2412),(33314,2412),(33315,2412),(33316,2413),(33317,2413),(33318,2413),(33319,2413),(33320,2413),(33321,2413),(33322,2413),(33323,2414),(33324,2414),(33325,2414),(33326,2414),(33327,2414),(33328,2414),(33329,2414),(33330,2415),(33331,2415),(33332,2415),(33333,2415),(33334,2415),(33335,2415),(33336,2415),(33337,2416),(33338,2416),(33339,2416),(33340,2416),(33341,2416),(33342,2416),(33343,2416),(33344,2417),(33345,2417),(33346,2417),(33347,2417),(33348,2417),(33349,2417),(33350,2417),(33351,2418),(33352,2418),(33353,2418),(33354,2418),(33355,2418),(33356,2418),(33357,2418),(33358,2419),(33359,2419),(33360,2419),(33361,2419),(33362,2419),(33363,2419),(33364,2419),(33365,2420),(33366,2420),(33367,2420),(33368,2420),(33369,2420),(33370,2420),(33371,2420),(33372,2421),(33373,2421),(33374,2421),(33375,2421),(33376,2421),(33377,2421),(33378,2421),(33379,2422),(33380,2422),(33381,2422),(33382,2422),(33383,2422),(33384,2422),(33385,2422),(33386,2423),(33387,2423),(33388,2423),(33389,2423),(33390,2423),(33391,2423),(33392,2423),(33393,2424),(33394,2424),(33395,2424),(33396,2424),(33397,2424),(33398,2424),(33399,2424),(33400,2425),(33401,2425),(33402,2425),(33403,2425),(33404,2425),(33405,2425),(33406,2425),(33407,2426),(33408,2426),(33409,2426),(33410,2426),(33411,2426),(33412,2426),(33413,2426),(33414,2427),(33415,2427),(33416,2427),(33417,2427),(33418,2427),(33419,2427),(33420,2427),(33421,2428),(33422,2428),(33423,2428),(33424,2428),(33425,2428),(33426,2428),(33427,2428),(33428,2429),(33429,2429),(33430,2429),(33431,2429),(33432,2429),(33433,2429),(33434,2429),(33435,2430),(33436,2430),(33437,2430),(33438,2430),(33439,2430),(33440,2430),(33441,2430),(33442,2431),(33443,2431),(33444,2431),(33445,2431),(33446,2431),(33447,2431),(33448,2431),(33449,2432),(33450,2432),(33451,2432),(33452,2432),(33453,2432),(33454,2432),(33455,2432),(33456,2433),(33457,2433),(33458,2433),(33459,2433),(33460,2433),(33461,2433),(33462,2433),(33463,2434),(33464,2434),(33465,2434),(33466,2434),(33467,2434),(33468,2434),(33469,2434),(33470,2435),(33471,2435),(33472,2435),(33473,2435),(33474,2435),(33475,2435),(33476,2435),(33477,2435),(33478,2436),(33479,2436),(33480,2436),(33481,2436),(33482,2436),(33483,2436),(33484,2436),(33485,2437),(33486,2437),(33487,2437),(33488,2437),(33489,2437),(33490,2437),(33491,2437),(33492,2438),(33493,2438),(33494,2438),(33495,2438),(33496,2438),(33497,2438),(33498,2438),(33499,2439),(33500,2439),(33501,2439),(33502,2439),(33503,2439),(33504,2439),(33505,2439),(33506,2440),(33507,2440),(33508,2440),(33509,2440),(33510,2440),(33511,2440),(33512,2440),(33513,2440),(33514,2440),(33515,2441),(33516,2441),(33517,2441),(33518,2441),(33519,2441),(33520,2441),(33521,2441),(33522,2441),(33523,2441),(33524,2442),(33525,2442),(33526,2442),(33527,2442),(33528,2442),(33529,2442),(33530,2442),(33531,2442),(33532,2442),(33533,2443),(33534,2443),(33535,2443),(33536,2443),(33537,2443),(33538,2443),(33539,2443),(33540,2444),(33541,2444),(33542,2444),(33543,2444),(33544,2444),(33545,2444),(33546,2444),(33547,2445),(33548,2445),(33549,2445),(33550,2445),(33551,2445),(33552,2445),(33553,2445),(33554,2446),(33555,2446),(33556,2446),(33557,2446),(33558,2446),(33559,2446),(33560,2446),(33561,2447),(33562,2447),(33563,2447),(33564,2447),(33565,2447),(33566,2447),(33567,2447),(33568,2448),(33569,2448),(33570,2448),(33571,2448),(33572,2448),(33573,2448),(33574,2448),(33575,2449),(33576,2449),(33577,2449),(33578,2449),(33579,2449),(33580,2449),(33581,2450),(33582,2450),(33583,2450),(33584,2450),(33585,2450),(33586,2450),(33587,2450),(33588,2451),(33589,2451),(33590,2451),(33591,2451),(33592,2451),(33593,2451),(33594,2451),(33595,2452),(33596,2452),(33597,2452),(33598,2452),(33599,2453),(33600,2453),(33601,2453),(33602,2453),(33603,2453),(33604,2453),(33605,2453),(33606,2454),(33607,2454),(33608,2454),(33609,2454),(33610,2454),(33611,2454),(33612,2454),(33613,2454),(33614,2454),(33615,2455),(33616,2455),(33617,2455),(33618,2455),(33619,2455),(33620,2455),(33621,2455),(33622,2455),(33623,2455),(33624,2456),(33625,2456),(33626,2456),(33627,2456),(33628,2456),(33629,2456),(33630,2456),(33631,2456),(33632,2456),(33633,2457),(33634,2457),(33635,2457),(33636,2457),(33637,2457),(33638,2457),(33639,2457),(33640,2457),(33641,2458),(33642,2458),(33643,2458),(33644,2458),(33645,2458),(33646,2458),(33647,2458),(33648,2459),(33649,2459),(33650,2459),(33651,2459),(33652,2459),(33653,2459),(33654,2459),(33655,2460),(33656,2460),(33657,2460),(33658,2460),(33659,2460),(33660,2460),(33661,2460),(33662,2461),(33663,2461),(33664,2461),(33665,2461),(33666,2461),(33667,2461),(33668,2461),(33669,2462),(33670,2462),(33671,2462),(33672,2462),(33673,2462),(33674,2462),(33675,2462),(33676,2463),(33677,2463),(33678,2463),(33679,2463),(33680,2463),(33681,2463),(33682,2463),(33683,2464),(33684,2464),(33685,2464),(33686,2464),(33687,2464),(33688,2464),(33689,2464),(33690,2465),(33691,2465),(33692,2465),(33693,2465),(33694,2465),(33695,2465),(33696,2465),(33697,2466),(33698,2466),(33699,2466),(33700,2466),(33701,2466),(33702,2466),(33703,2466),(33704,2467),(33705,2467),(33706,2467),(33707,2467),(33708,2467),(33709,2467),(33710,2467),(33711,2468),(33712,2468),(33713,2468),(33714,2468),(33715,2468),(33716,2468),(33717,2468),(33718,2469),(33719,2469),(33720,2469),(33721,2469),(33722,2469),(33723,2469),(33724,2469),(33725,2470),(33726,2470),(33727,2470),(33728,2470),(33729,2470),(33730,2470),(33731,2470),(33732,2471),(33733,2471),(33734,2471),(33735,2471),(33736,2471),(33737,2471),(33738,2471),(33739,2472),(33740,2472),(33741,2472),(33742,2472),(33743,2472),(33744,2472),(33745,2472),(33746,2472),(33747,2473),(33748,2473),(33749,2473),(33750,2473),(33751,2473),(33752,2473),(33753,2473),(33754,2473),(33755,2474),(33756,2474),(33757,2474),(33758,2474),(33759,2474),(33760,2474),(33761,2474),(33762,2475),(33763,2475),(33764,2475),(33765,2475),(33766,2475),(33767,2475),(33768,2475),(33769,2475),(33770,2475),(33771,2476),(33772,2476),(33773,2476),(33774,2476),(33775,2476),(33776,2476),(33777,2476),(33778,2476),(33779,2476),(33780,2477),(33781,2477),(33782,2477),(33783,2477),(33784,2477),(33785,2477),(33786,2477),(33787,2478),(33788,2478),(33789,2478),(33790,2478),(33791,2478),(33792,2478),(33793,2478),(33794,2479),(33795,2479),(33796,2479),(33797,2479),(33798,2479),(33799,2479),(33800,2479),(33801,2480),(33802,2480),(33803,2480),(33804,2480),(33805,2480),(33806,2480),(33807,2480),(33808,2481),(33809,2481),(33810,2481),(33811,2481),(33812,2481),(33813,2481),(33814,2481),(33815,2482),(33816,2482),(33817,2482),(33818,2482),(33819,2482),(33820,2482),(33821,2482),(33822,2483),(33823,2483),(33824,2483),(33825,2483),(33826,2483),(33827,2483),(33828,2483),(33829,2483),(33830,2483),(33831,2484),(33832,2484),(33833,2484),(33834,2484),(33835,2484),(33836,2484),(33837,2484),(33838,2485),(33839,2485),(33840,2485),(33841,2485),(33842,2485),(33843,2485),(33844,2485),(33845,2486),(33846,2486),(33847,2486),(33848,2486),(33849,2486),(33850,2486),(33851,2486),(33852,2487),(33853,2487),(33854,2487),(33855,2487),(33856,2487),(33857,2487),(33858,2487),(33859,2487),(33860,2487),(33861,2488),(33862,2488),(33863,2488),(33864,2488),(33865,2488),(33866,2488),(33867,2488),(33868,2489),(33869,2489),(33870,2489),(33871,2489),(33872,2489),(33873,2489),(33874,2489),(33875,2489),(33876,2490),(33877,2490),(33878,2490),(33879,2490),(33880,2490),(33881,2490),(33882,2490),(33883,2490),(33884,2491),(33885,2491),(33886,2491),(33887,2491),(33888,2491),(33889,2491),(33890,2491),(33891,2491),(33892,2492),(33893,2492),(33894,2492),(33895,2492),(33896,2492),(33897,2492),(33898,2493),(33899,2493),(33900,2493),(33901,2493),(33902,2493),(33903,2493),(33904,2494),(33905,2494),(33906,2494),(33907,2494),(33908,2494),(33909,2494),(33910,2495),(33911,2495),(33912,2495),(33913,2495),(33914,2495),(33915,2495),(33916,2496),(33917,2496),(33918,2496),(33919,2496),(33920,2496),(33921,2496),(33922,2497),(33923,2497),(33924,2497),(33925,2497),(33926,2497),(33927,2497),(33928,2498),(33929,2498),(33930,2498),(33931,2498),(33932,2498),(33933,2498),(33934,2498),(33935,2498),(33936,2498),(33937,2499),(33938,2499),(33939,2499),(33940,2499),(33941,2499),(33942,2499),(33943,2499),(33944,2499),(33945,2499),(33946,2500),(33947,2500),(33948,2500),(33949,2500),(33950,2500),(33951,2500),(33952,2500),(33953,2500),(33954,2500),(33955,2501),(33956,2501),(33957,2501),(33958,2501),(33959,2501),(33960,2501),(33961,2501),(33962,2502),(33963,2502),(33964,2502),(33965,2502),(33966,2502),(33967,2502),(33968,2502),(33969,2503),(33970,2503),(33971,2503),(33972,2503),(33973,2503),(33974,2503),(33975,2503),(33976,2504),(33977,2504),(33978,2504),(33979,2504),(33980,2504),(33981,2504),(33982,2504),(33983,2505),(33984,2505),(33985,2505),(33986,2505),(33987,2505),(33988,2505),(33989,2505),(33990,2506),(33991,2506),(33992,2506),(33993,2506),(33994,2506),(33995,2506),(33996,2506),(33997,2506),(33998,2506),(33999,2507),(34000,2507),(34001,2507),(34002,2507),(34003,2507),(34004,2507),(34005,2507),(34006,2507),(34007,2507),(34008,2508),(34009,2508),(34010,2508),(34011,2508),(34012,2508),(34013,2508),(34014,2508),(34015,2508),(34016,2508),(34017,2509),(34018,2509),(34019,2509),(34020,2509),(34021,2509),(34022,2509),(34023,2509),(34024,2509),(34025,2509),(34026,2510),(34027,2510),(34028,2510),(34029,2510),(34030,2510),(34031,2510),(34032,2510),(34033,2411),(34034,2411),(34035,2411),(34036,2412),(34037,2412),(34038,2412),(34039,2413),(34040,2413),(34041,2413),(34042,2414),(34043,2414),(34044,2414),(34045,2415),(34046,2415),(34047,2415),(34048,2416),(34049,2416),(34050,2416),(34051,2417),(34052,2417),(34053,2417),(34054,2418),(34055,2418),(34056,2418),(34057,2419),(34058,2419),(34059,2419),(34060,2420),(34061,2420),(34062,2420),(34063,2421),(34064,2421),(34065,2421),(34066,2422),(34067,2422),(34068,2422),(34069,2423),(34070,2423),(34071,2423),(34072,2424),(34073,2424),(34074,2424),(34075,2425),(34076,2425),(34077,2425),(34078,2426),(34079,2426),(34080,2426),(34081,2426),(34082,2427),(34083,2427),(34084,2427),(34085,2428),(34086,2428),(34087,2428),(34088,2429),(34089,2429),(34090,2429),(34091,2430),(34092,2430),(34093,2430),(34094,2431),(34095,2431),(34096,2431),(34097,2432),(34098,2432),(34099,2432),(34100,2433),(34101,2433),(34102,2433),(34103,2434),(34104,2434),(34105,2434),(34106,2435),(34107,2435),(34108,2435),(34109,2436),(34110,2436),(34111,2436),(34112,2437),(34113,2437),(34114,2437),(34115,2438),(34116,2438),(34117,2438),(34118,2439),(34119,2439),(34120,2439),(34121,2440),(34122,2440),(34123,2440),(34124,2441),(34125,2441),(34126,2441),(34127,2442),(34128,2442),(34129,2442),(34130,2443),(34131,2443),(34132,2443),(34133,2444),(34134,2444),(34135,2444),(34136,2445),(34137,2445),(34138,2445),(34139,2446),(34140,2446),(34141,2446),(34142,2447),(34143,2447),(34144,2447),(34145,2448),(34146,2448),(34147,2448),(34148,2449),(34149,2450),(34150,2450),(34151,2450),(34152,2451),(34153,2451),(34154,2451),(34155,2452),(34156,2452),(34157,2452),(34158,2453),(34159,2453),(34160,2453),(34161,2454),(34162,2454),(34163,2454),(34164,2455),(34165,2455),(34166,2455),(34167,2456),(34168,2456),(34169,2456),(34170,2457),(34171,2457),(34172,2457),(34173,2458),(34174,2458),(34175,2458),(34176,2459),(34177,2459),(34178,2459),(34179,2460),(34180,2460),(34181,2460),(34182,2461),(34183,2461),(34184,2461),(34185,2462),(34186,2462),(34187,2462),(34188,2463),(34189,2463),(34190,2463),(34191,2464),(34192,2464),(34193,2464),(34194,2465),(34195,2465),(34196,2465),(34197,2466),(34198,2466),(34199,2466),(34200,2467),(34201,2467),(34202,2467),(34203,2468),(34204,2468),(34205,2468),(34206,2469),(34207,2469),(34208,2469),(34209,2470),(34210,2470),(34211,2470),(34212,2471),(34213,2471),(34214,2471),(34215,2472),(34216,2472),(34217,2472),(34218,2473),(34219,2473),(34220,2473),(34221,2474),(34222,2474),(34223,2474),(34224,2475),(34225,2475),(34226,2475),(34227,2476),(34228,2476),(34229,2476),(34230,2477),(34231,2477),(34232,2477),(34233,2478),(34234,2478),(34235,2478),(34236,2479),(34237,2479),(34238,2479),(34239,2480),(34240,2480),(34241,2480),(34242,2481),(34243,2481),(34244,2481),(34245,2482),(34246,2482),(34247,2482),(34248,2483),(34249,2483),(34250,2483),(34251,2484),(34252,2484),(34253,2484),(34254,2485),(34255,2485),(34256,2485),(34257,2486),(34258,2486),(34259,2486),(34260,2487),(34261,2487),(34262,2487),(34263,2488),(34264,2488),(34265,2488),(34266,2489),(34267,2489),(34268,2489),(34269,2490),(34270,2490),(34271,2490),(34272,2491),(34273,2491),(34274,2491),(34275,2492),(34276,2492),(34277,2492),(34278,2493),(34279,2493),(34280,2493),(34281,2494),(34282,2494),(34283,2494),(34284,2495),(34285,2495),(34286,2495),(34287,2496),(34288,2496),(34289,2496),(34290,2497),(34291,2497),(34292,2497),(34293,2498),(34294,2498),(34295,2498),(34296,2499),(34297,2499),(34298,2499),(34299,2500),(34300,2500),(34301,2500),(34302,2501),(34303,2501),(34304,2501),(34305,2502),(34306,2502),(34307,2502),(34308,2503),(34309,2503),(34310,2503),(34311,2504),(34312,2504),(34313,2504),(34314,2505),(34315,2505),(34316,2505),(34317,2506),(34318,2506),(34319,2506),(34320,2507),(34321,2507),(34322,2507),(34323,2508),(34324,2508),(34325,2508),(34326,2509),(34327,2509),(34328,2509),(34329,2510),(34330,2510),(34331,2510),(34332,2411),(34333,2411),(34334,2411),(34335,2411),(34336,2412),(34337,2412),(34338,2412),(34339,2412),(34340,2413),(34341,2413),(34342,2413),(34343,2413),(34344,2414),(34345,2414),(34346,2414),(34347,2414),(34348,2415),(34349,2415),(34350,2415),(34351,2415),(34352,2416),(34353,2416),(34354,2416),(34355,2416),(34356,2417),(34357,2417),(34358,2417),(34359,2417),(34360,2418),(34361,2418),(34362,2418),(34363,2418),(34364,2419),(34365,2419),(34366,2419),(34367,2419),(34368,2420),(34369,2420),(34370,2420),(34371,2420),(34372,2421),(34373,2421),(34374,2421),(34375,2421),(34376,2422),(34377,2422),(34378,2422),(34379,2422),(34380,2423),(34381,2423),(34382,2423),(34383,2423),(34384,2424),(34385,2424),(34386,2424),(34387,2424),(34388,2425),(34389,2425),(34390,2425),(34391,2425),(34392,2426),(34393,2426),(34394,2426),(34395,2426),(34396,2427),(34397,2427),(34398,2427),(34399,2427),(34400,2428),(34401,2428),(34402,2428),(34403,2428),(34404,2429),(34405,2429),(34406,2429),(34407,2429),(34408,2430),(34409,2430),(34410,2430),(34411,2430),(34412,2431),(34413,2431),(34414,2431),(34415,2431),(34416,2432),(34417,2432),(34418,2432),(34419,2432),(34420,2433),(34421,2433),(34422,2433),(34423,2433),(34424,2434),(34425,2434),(34426,2434),(34427,2434),(34428,2435),(34429,2435),(34430,2435),(34431,2435),(34432,2436),(34433,2436),(34434,2436),(34435,2436),(34436,2437),(34437,2437),(34438,2437),(34439,2437),(34440,2438),(34441,2438),(34442,2438),(34443,2438),(34444,2439),(34445,2439),(34446,2439),(34447,2439),(34448,2440),(34449,2440),(34450,2440),(34451,2440),(34452,2441),(34453,2441),(34454,2441),(34455,2441),(34456,2442),(34457,2442),(34458,2442),(34459,2442),(34460,2443),(34461,2443),(34462,2443),(34463,2443),(34464,2444),(34465,2444),(34466,2444),(34467,2444),(34468,2445),(34469,2445),(34470,2445),(34471,2445),(34472,2446),(34473,2446),(34474,2446),(34475,2446),(34476,2447),(34477,2447),(34478,2447),(34479,2447),(34480,2448),(34481,2448),(34482,2448),(34483,2448),(34484,2449),(34485,2449),(34486,2449),(34487,2449),(34488,2450),(34489,2450),(34490,2450),(34491,2450),(34492,2451),(34493,2451),(34494,2451),(34495,2451),(34496,2452),(34497,2452),(34498,2452),(34499,2452),(34500,2453),(34501,2453),(34502,2453),(34503,2453),(34504,2454),(34505,2454),(34506,2454),(34507,2454),(34508,2455),(34509,2455),(34510,2455),(34511,2455),(34512,2456),(34513,2456),(34514,2456),(34515,2456),(34516,2457),(34517,2457),(34518,2457),(34519,2457),(34520,2458),(34521,2458),(34522,2458),(34523,2458),(34524,2459),(34525,2459),(34526,2459),(34527,2459),(34528,2460),(34529,2460),(34530,2460),(34531,2460),(34532,2461),(34533,2461),(34534,2461),(34535,2461),(34536,2462),(34537,2462),(34538,2462),(34539,2462),(34540,2463),(34541,2463),(34542,2463),(34543,2463),(34544,2464),(34545,2464),(34546,2464),(34547,2464),(34548,2465),(34549,2465),(34550,2465),(34551,2465),(34552,2466),(34553,2466),(34554,2466),(34555,2466),(34556,2467),(34557,2467),(34558,2467),(34559,2467),(34560,2468),(34561,2468),(34562,2468),(34563,2468),(34564,2469),(34565,2469),(34566,2469),(34567,2469),(34568,2470),(34569,2470),(34570,2470),(34571,2470),(34572,2471),(34573,2471),(34574,2471),(34575,2471),(34576,2472),(34577,2472),(34578,2472),(34579,2472),(34580,2473),(34581,2473),(34582,2473),(34583,2473),(34584,2474),(34585,2474),(34586,2474),(34587,2474),(34588,2475),(34589,2475),(34590,2475),(34591,2475),(34592,2476),(34593,2476),(34594,2476),(34595,2476),(34596,2477),(34597,2477),(34598,2477),(34599,2477),(34600,2478),(34601,2478),(34602,2478),(34603,2478),(34604,2479),(34605,2479),(34606,2479),(34607,2479),(34608,2480),(34609,2480),(34610,2480),(34611,2480),(34612,2481),(34613,2481),(34614,2481),(34615,2481),(34616,2482),(34617,2482),(34618,2482),(34619,2482),(34620,2483),(34621,2483),(34622,2483),(34623,2483),(34624,2484),(34625,2484),(34626,2484),(34627,2484),(34628,2485),(34629,2485),(34630,2485),(34631,2485),(34632,2486),(34633,2486),(34634,2486),(34635,2486),(34636,2487),(34637,2487),(34638,2487),(34639,2487),(34640,2488),(34641,2488),(34642,2488),(34643,2488),(34644,2489),(34645,2489),(34646,2489),(34647,2489),(34648,2490),(34649,2490),(34650,2490),(34651,2490),(34652,2491),(34653,2491),(34654,2491),(34655,2491),(34656,2492),(34657,2492),(34658,2492),(34659,2492),(34660,2493),(34661,2493),(34662,2493),(34663,2493),(34664,2494),(34665,2494),(34666,2494),(34667,2494),(34668,2495),(34669,2495),(34670,2495),(34671,2495),(34672,2496),(34673,2496),(34674,2496),(34675,2496),(34676,2497),(34677,2497),(34678,2497),(34679,2497),(34680,2498),(34681,2498),(34682,2498),(34683,2498),(34684,2499),(34685,2499),(34686,2499),(34687,2499),(34688,2500),(34689,2500),(34690,2500),(34691,2500),(34692,2501),(34693,2501),(34694,2501),(34695,2501),(34696,2502),(34697,2502),(34698,2502),(34699,2502),(34700,2503),(34701,2503),(34702,2503),(34703,2503),(34704,2504),(34705,2504),(34706,2504),(34707,2504),(34708,2505),(34709,2505),(34710,2505),(34711,2505),(34712,2506),(34713,2506),(34714,2506),(34715,2506),(34716,2507),(34717,2507),(34718,2507),(34719,2507),(34720,2508),(34721,2508),(34722,2508),(34723,2508),(34724,2509),(34725,2509),(34726,2509),(34727,2509),(34728,2510),(34729,2510),(34730,2510),(34731,2510),(34732,2511),(34733,2511),(34734,2511),(34735,2511),(34736,2511),(34737,2511),(34738,2511),(34739,2511),(34740,2511),(34741,2512),(34742,2512),(34743,2512),(34744,2512),(34745,2512),(34746,2512),(34747,2512),(34748,2512),(34749,2512),(34750,2513),(34751,2513),(34752,2513),(34753,2513),(34754,2513),(34755,2513),(34756,2513),(34757,2513),(34758,2513),(34759,2514),(34760,2514),(34761,2514),(34762,2514),(34763,2514),(34764,2514),(34765,2514),(34766,2514),(34767,2514),(34768,2515),(34769,2515),(34770,2515),(34771,2515),(34772,2515),(34773,2515),(34774,2515),(34775,2516),(34776,2516),(34777,2516),(34778,2516),(34779,2516),(34780,2516),(34781,2516),(34782,2517),(34783,2517),(34784,2517),(34785,2517),(34786,2517),(34787,2517),(34788,2517),(34789,2518),(34790,2518),(34791,2518),(34792,2518),(34793,2518),(34794,2518),(34795,2518),(34796,2519),(34797,2519),(34798,2519),(34799,2519),(34800,2519),(34801,2519),(34802,2519),(34803,2520),(34804,2520),(34805,2520),(34806,2520),(34807,2520),(34808,2520),(34809,2520),(34810,2521),(34811,2521),(34812,2521),(34813,2521),(34814,2521),(34815,2521),(34816,2521),(34817,2522),(34818,2522),(34819,2522),(34820,2522),(34821,2522),(34822,2522),(34823,2522),(34824,2523),(34825,2523),(34826,2523),(34827,2523),(34828,2523),(34829,2523),(34830,2523),(34831,2524),(34832,2524),(34833,2524),(34834,2524),(34835,2524),(34836,2524),(34837,2524),(34838,2525),(34839,2525),(34840,2525),(34841,2525),(34842,2525),(34843,2525),(34844,2525),(34845,2526),(34846,2526),(34847,2526),(34848,2526),(34849,2526),(34850,2526),(34851,2526),(34852,2527),(34853,2527),(34854,2527),(34855,2527),(34856,2527),(34857,2527),(34858,2527),(34859,2528),(34860,2528),(34861,2528),(34862,2528),(34863,2528),(34864,2528),(34865,2528),(34866,2529),(34867,2529),(34868,2529),(34869,2529),(34870,2529),(34871,2529),(34872,2529),(34873,2530),(34874,2530),(34875,2530),(34876,2530),(34877,2530),(34878,2530),(34879,2530),(34880,2531),(34881,2531),(34882,2531),(34883,2531),(34884,2531),(34885,2531),(34886,2531),(34887,2532),(34888,2532),(34889,2532),(34890,2532),(34891,2532),(34892,2532),(34893,2532),(34894,2533),(34895,2533),(34896,2533),(34897,2533),(34898,2533),(34899,2533),(34900,2533),(34901,2534),(34902,2534),(34903,2534),(34904,2534),(34905,2534),(34906,2534),(34907,2534),(34908,2535),(34909,2535),(34910,2535),(34911,2535),(34912,2535),(34913,2535),(34914,2535),(34915,2536),(34916,2536),(34917,2536),(34918,2536),(34919,2536),(34920,2536),(34921,2536),(34922,2536),(34923,2536),(34924,2537),(34925,2537),(34926,2537),(34927,2537),(34928,2537),(34929,2537),(34930,2537),(34931,2538),(34932,2538),(34933,2538),(34934,2538),(34935,2538),(34936,2538),(34937,2538),(34938,2539),(34939,2539),(34940,2539),(34941,2539),(34942,2539),(34943,2539),(34944,2539),(34945,2539),(34946,2539),(34947,2540),(34948,2540),(34949,2540),(34950,2540),(34951,2540),(34952,2540),(34953,2541),(34954,2541),(34955,2541),(34956,2541),(34957,2541),(34958,2541),(34959,2541),(34960,2541),(34961,2541),(34962,2542),(34963,2542),(34964,2542),(34965,2542),(34966,2542),(34967,2542),(34968,2542),(34969,2542),(34970,2542),(34971,2543),(34972,2543),(34973,2543),(34974,2543),(34975,2543),(34976,2543),(34977,2543),(34978,2544),(34979,2544),(34980,2544),(34981,2544),(34982,2544),(34983,2544),(34984,2544),(34985,2545),(34986,2545),(34987,2545),(34988,2545),(34989,2545),(34990,2545),(34991,2545),(34992,2546),(34993,2546),(34994,2546),(34995,2546),(34996,2546),(34997,2546),(34998,2546),(34999,2547),(35000,2547),(35001,2547),(35002,2547),(35003,2547),(35004,2547),(35005,2547),(35006,2548),(35007,2548),(35008,2548),(35009,2548),(35010,2548),(35011,2548),(35012,2548),(35013,2549),(35014,2549),(35015,2549),(35016,2549),(35017,2549),(35018,2549),(35019,2549),(35020,2550),(35021,2550),(35022,2550),(35023,2550),(35024,2550),(35025,2550),(35026,2550),(35027,2551),(35028,2551),(35029,2551),(35030,2551),(35031,2551),(35032,2551),(35033,2551),(35034,2552),(35035,2552),(35036,2552),(35037,2552),(35038,2552),(35039,2552),(35040,2552),(35041,2553),(35042,2553),(35043,2553),(35044,2553),(35045,2553),(35046,2553),(35047,2553),(35048,2554),(35049,2554),(35050,2554),(35051,2554),(35052,2554),(35053,2554),(35054,2554),(35055,2555),(35056,2555),(35057,2555),(35058,2555),(35059,2555),(35060,2555),(35061,2555),(35062,2556),(35063,2556),(35064,2556),(35065,2556),(35066,2556),(35067,2556),(35068,2556),(35069,2557),(35070,2557),(35071,2557),(35072,2557),(35073,2557),(35074,2557),(35075,2557),(35076,2558),(35077,2558),(35078,2558),(35079,2558),(35080,2558),(35081,2558),(35082,2558),(35083,2559),(35084,2559),(35085,2559),(35086,2559),(35087,2559),(35088,2559),(35089,2560),(35090,2560),(35091,2560),(35092,2560),(35093,2560),(35094,2560),(35095,2560),(35096,2561),(35097,2561),(35098,2561),(35099,2561),(35100,2561),(35101,2561),(35102,2561),(35103,2562),(35104,2562),(35105,2562),(35106,2562),(35107,2562),(35108,2562),(35109,2562),(35110,2563),(35111,2563),(35112,2563),(35113,2563),(35114,2563),(35115,2563),(35116,2563),(35117,2564),(35118,2564),(35119,2564),(35120,2564),(35121,2564),(35122,2564),(35123,2564),(35124,2565),(35125,2565),(35126,2565),(35127,2565),(35128,2565),(35129,2565),(35130,2565),(35131,2566),(35132,2566),(35133,2566),(35134,2566),(35135,2566),(35136,2566),(35137,2566),(35138,2567),(35139,2567),(35140,2567),(35141,2567),(35142,2567),(35143,2567),(35144,2567),(35145,2568),(35146,2568),(35147,2568),(35148,2568),(35149,2568),(35150,2568),(35151,2568),(35152,2569),(35153,2569),(35154,2569),(35155,2569),(35156,2569),(35157,2569),(35158,2569),(35159,2570),(35160,2570),(35161,2570),(35162,2570),(35163,2570),(35164,2570),(35165,2570),(35166,2571),(35167,2571),(35168,2571),(35169,2571),(35170,2571),(35171,2571),(35172,2571),(35173,2572),(35174,2572),(35175,2572),(35176,2572),(35177,2572),(35178,2572),(35179,2572),(35180,2573),(35181,2573),(35182,2573),(35183,2573),(35184,2573),(35185,2573),(35186,2573),(35187,2574),(35188,2574),(35189,2574),(35190,2574),(35191,2574),(35192,2574),(35193,2574),(35194,2575),(35195,2575),(35196,2575),(35197,2575),(35198,2575),(35199,2575),(35200,2575),(35201,2576),(35202,2576),(35203,2576),(35204,2576),(35205,2576),(35206,2576),(35207,2576),(35208,2577),(35209,2577),(35210,2577),(35211,2577),(35212,2577),(35213,2577),(35214,2577),(35215,2578),(35216,2578),(35217,2578),(35218,2578),(35219,2578),(35220,2578),(35221,2578),(35222,2579),(35223,2579),(35224,2579),(35225,2579),(35226,2579),(35227,2579),(35228,2579),(35229,2580),(35230,2580),(35231,2580),(35232,2580),(35233,2580),(35234,2580),(35235,2580),(35236,2581),(35237,2581),(35238,2581),(35239,2581),(35240,2582),(35241,2582),(35242,2582),(35243,2582),(35244,2582),(35245,2582),(35246,2582),(35247,2583),(35248,2583),(35249,2583),(35250,2583),(35251,2583),(35252,2583),(35253,2583),(35254,2584),(35255,2584),(35256,2584),(35257,2584),(35258,2584),(35259,2584),(35260,2584),(35261,2585),(35262,2585),(35263,2585),(35264,2585),(35265,2585),(35266,2585),(35267,2585),(35268,2586),(35269,2586),(35270,2586),(35271,2586),(35272,2586),(35273,2586),(35274,2586),(35275,2587),(35276,2587),(35277,2587),(35278,2587),(35279,2587),(35280,2587),(35281,2587),(35282,2588),(35283,2588),(35284,2588),(35285,2588),(35286,2588),(35287,2588),(35288,2588),(35289,2589),(35290,2589),(35291,2589),(35292,2589),(35293,2589),(35294,2589),(35295,2589),(35296,2590),(35297,2590),(35298,2590),(35299,2590),(35300,2590),(35301,2590),(35302,2590),(35303,2591),(35304,2591),(35305,2591),(35306,2591),(35307,2591),(35308,2591),(35309,2591),(35310,2592),(35311,2592),(35312,2592),(35313,2592),(35314,2592),(35315,2592),(35316,2592),(35317,2593),(35318,2593),(35319,2593),(35320,2593),(35321,2593),(35322,2593),(35323,2593),(35324,2594),(35325,2594),(35326,2594),(35327,2594),(35328,2594),(35329,2594),(35330,2594),(35331,2595),(35332,2595),(35333,2595),(35334,2595),(35335,2595),(35336,2595),(35337,2595),(35338,2596),(35339,2596),(35340,2596),(35341,2596),(35342,2596),(35343,2596),(35344,2596),(35345,2597),(35346,2597),(35347,2597),(35348,2597),(35349,2597),(35350,2597),(35351,2597),(35352,2598),(35353,2598),(35354,2598),(35355,2598),(35356,2598),(35357,2598),(35358,2598),(35359,2599),(35360,2599),(35361,2599),(35362,2599),(35363,2599),(35364,2599),(35365,2599),(35366,2600),(35367,2600),(35368,2600),(35369,2600),(35370,2600),(35371,2600),(35372,2600),(35373,2601),(35374,2601),(35375,2601),(35376,2601),(35377,2601),(35378,2601),(35379,2601),(35380,2602),(35381,2602),(35382,2602),(35383,2602),(35384,2602),(35385,2602),(35386,2602),(35387,2603),(35388,2603),(35389,2603),(35390,2603),(35391,2603),(35392,2603),(35393,2603),(35394,2604),(35395,2604),(35396,2604),(35397,2604),(35398,2604),(35399,2604),(35400,2604),(35401,2605),(35402,2605),(35403,2605),(35404,2605),(35405,2605),(35406,2605),(35407,2605),(35408,2606),(35409,2606),(35410,2606),(35411,2606),(35412,2606),(35413,2606),(35414,2606),(35415,2607),(35416,2607),(35417,2607),(35418,2607),(35419,2607),(35420,2607),(35421,2607),(35422,2608),(35423,2608),(35424,2608),(35425,2608),(35426,2608),(35427,2608),(35428,2608),(35429,2609),(35430,2609),(35431,2609),(35432,2609),(35433,2609),(35434,2609),(35435,2609),(35436,2609),(35437,2609),(35438,2610),(35439,2610),(35440,2610),(35441,2610),(35442,2610),(35443,2610),(35444,2610),(35445,2511),(35446,2511),(35447,2511),(35448,2512),(35449,2512),(35450,2512),(35451,2513),(35452,2513),(35453,2513),(35454,2514),(35455,2514),(35456,2514),(35457,2515),(35458,2515),(35459,2515),(35460,2516),(35461,2516),(35462,2516),(35463,2517),(35464,2517),(35465,2517),(35466,2518),(35467,2518),(35468,2518),(35469,2519),(35470,2519),(35471,2519),(35472,2520),(35473,2520),(35474,2520),(35475,2521),(35476,2521),(35477,2521),(35478,2522),(35479,2522),(35480,2522),(35481,2523),(35482,2523),(35483,2523),(35484,2524),(35485,2524),(35486,2524),(35487,2525),(35488,2525),(35489,2525),(35490,2526),(35491,2526),(35492,2526),(35493,2527),(35494,2527),(35495,2527),(35496,2528),(35497,2528),(35498,2528),(35499,2529),(35500,2529),(35501,2529),(35502,2530),(35503,2530),(35504,2530),(35505,2531),(35506,2531),(35507,2531),(35508,2532),(35509,2532),(35510,2532),(35511,2533),(35512,2533),(35513,2533),(35514,2534),(35515,2534),(35516,2534),(35517,2535),(35518,2535),(35519,2535),(35520,2536),(35521,2536),(35522,2536),(35523,2537),(35524,2537),(35525,2537),(35526,2538),(35527,2538),(35528,2538),(35529,2539),(35530,2539),(35531,2539),(35532,2540),(35533,2540),(35534,2540),(35535,2541),(35536,2541),(35537,2541),(35538,2542),(35539,2542),(35540,2542),(35541,2543),(35542,2543),(35543,2543),(35544,2544),(35545,2544),(35546,2544),(35547,2545),(35548,2545),(35549,2545),(35550,2546),(35551,2546),(35552,2546),(35553,2547),(35554,2547),(35555,2547),(35556,2548),(35557,2548),(35558,2548),(35559,2549),(35560,2549),(35561,2549),(35562,2550),(35563,2550),(35564,2550),(35565,2551),(35566,2551),(35567,2551),(35568,2552),(35569,2552),(35570,2552),(35571,2553),(35572,2553),(35573,2553),(35574,2554),(35575,2554),(35576,2554),(35577,2555),(35578,2555),(35579,2555),(35580,2556),(35581,2556),(35582,2556),(35583,2557),(35584,2557),(35585,2557),(35586,2558),(35587,2558),(35588,2558),(35589,2559),(35590,2559),(35591,2559),(35592,2560),(35593,2560),(35594,2560),(35595,2561),(35596,2561),(35597,2561),(35598,2562),(35599,2562),(35600,2562),(35601,2563),(35602,2563),(35603,2563),(35604,2564),(35605,2564),(35606,2564),(35607,2565),(35608,2565),(35609,2565),(35610,2566),(35611,2566),(35612,2566),(35613,2567),(35614,2567),(35615,2567),(35616,2568),(35617,2568),(35618,2568),(35619,2569),(35620,2569),(35621,2569),(35622,2570),(35623,2570),(35624,2570),(35625,2571),(35626,2571),(35627,2571),(35628,2572),(35629,2572),(35630,2572),(35631,2573),(35632,2573),(35633,2573),(35634,2574),(35635,2574),(35636,2574),(35637,2575),(35638,2575),(35639,2575),(35640,2576),(35641,2576),(35642,2576),(35643,2577),(35644,2577),(35645,2577),(35646,2578),(35647,2578),(35648,2578),(35649,2579),(35650,2579),(35651,2579),(35652,2580),(35653,2580),(35654,2580),(35655,2581),(35656,2581),(35657,2581),(35658,2582),(35659,2582),(35660,2582),(35661,2583),(35662,2583),(35663,2583),(35664,2584),(35665,2584),(35666,2584),(35667,2585),(35668,2585),(35669,2585),(35670,2586),(35671,2586),(35672,2586),(35673,2587),(35674,2587),(35675,2587),(35676,2588),(35677,2588),(35678,2588),(35679,2589),(35680,2589),(35681,2589),(35682,2590),(35683,2590),(35684,2590),(35685,2591),(35686,2591),(35687,2591),(35688,2592),(35689,2592),(35690,2592),(35691,2593),(35692,2593),(35693,2593),(35694,2594),(35695,2594),(35696,2594),(35697,2595),(35698,2595),(35699,2595),(35700,2596),(35701,2596),(35702,2596),(35703,2597),(35704,2597),(35705,2597),(35706,2598),(35707,2598),(35708,2598),(35709,2599),(35710,2599),(35711,2599),(35712,2600),(35713,2600),(35714,2600),(35715,2601),(35716,2601),(35717,2601),(35718,2602),(35719,2602),(35720,2602),(35721,2603),(35722,2603),(35723,2603),(35724,2604),(35725,2604),(35726,2604),(35727,2605),(35728,2605),(35729,2605),(35730,2606),(35731,2606),(35732,2606),(35733,2607),(35734,2607),(35735,2607),(35736,2608),(35737,2608),(35738,2608),(35739,2609),(35740,2609),(35741,2609),(35742,2610),(35743,2610),(35744,2610),(35745,2511),(35746,2511),(35747,2511),(35748,2511),(35749,2512),(35750,2512),(35751,2512),(35752,2512),(35753,2513),(35754,2513),(35755,2513),(35756,2513),(35757,2514),(35758,2514),(35759,2514),(35760,2514),(35761,2515),(35762,2515),(35763,2515),(35764,2515),(35765,2516),(35766,2516),(35767,2516),(35768,2516),(35769,2517),(35770,2517),(35771,2517),(35772,2517),(35773,2518),(35774,2518),(35775,2518),(35776,2518),(35777,2519),(35778,2519),(35779,2519),(35780,2519),(35781,2520),(35782,2520),(35783,2520),(35784,2520),(35785,2521),(35786,2521),(35787,2521),(35788,2521),(35789,2522),(35790,2522),(35791,2522),(35792,2522),(35793,2523),(35794,2523),(35795,2523),(35796,2523),(35797,2524),(35798,2524),(35799,2524),(35800,2524),(35801,2525),(35802,2525),(35803,2525),(35804,2525),(35805,2526),(35806,2526),(35807,2526),(35808,2526),(35809,2527),(35810,2527),(35811,2527),(35812,2527),(35813,2528),(35814,2528),(35815,2528),(35816,2528),(35817,2529),(35818,2529),(35819,2529),(35820,2529),(35821,2530),(35822,2530),(35823,2530),(35824,2530),(35825,2531),(35826,2531),(35827,2531),(35828,2531),(35829,2532),(35830,2532),(35831,2532),(35832,2532),(35833,2533),(35834,2533),(35835,2533),(35836,2533),(35837,2534),(35838,2534),(35839,2534),(35840,2534),(35841,2535),(35842,2535),(35843,2535),(35844,2535),(35845,2536),(35846,2536),(35847,2536),(35848,2536),(35849,2537),(35850,2537),(35851,2537),(35852,2537),(35853,2538),(35854,2538),(35855,2538),(35856,2538),(35857,2539),(35858,2539),(35859,2539),(35860,2539),(35861,2540),(35862,2540),(35863,2540),(35864,2540),(35865,2541),(35866,2541),(35867,2541),(35868,2541),(35869,2542),(35870,2542),(35871,2542),(35872,2542),(35873,2543),(35874,2543),(35875,2543),(35876,2543),(35877,2544),(35878,2544),(35879,2544),(35880,2544),(35881,2545),(35882,2545),(35883,2545),(35884,2545),(35885,2546),(35886,2546),(35887,2546),(35888,2546),(35889,2547),(35890,2547),(35891,2547),(35892,2547),(35893,2548),(35894,2548),(35895,2548),(35896,2548),(35897,2549),(35898,2549),(35899,2549),(35900,2549),(35901,2550),(35902,2550),(35903,2550),(35904,2550),(35905,2551),(35906,2551),(35907,2551),(35908,2551),(35909,2552),(35910,2552),(35911,2552),(35912,2552),(35913,2553),(35914,2553),(35915,2553),(35916,2553),(35917,2554),(35918,2554),(35919,2554),(35920,2554),(35921,2555),(35922,2555),(35923,2555),(35924,2555),(35925,2556),(35926,2556),(35927,2556),(35928,2556),(35929,2557),(35930,2557),(35931,2557),(35932,2557),(35933,2558),(35934,2558),(35935,2558),(35936,2558),(35937,2559),(35938,2559),(35939,2559),(35940,2559),(35941,2560),(35942,2560),(35943,2560),(35944,2560),(35945,2561),(35946,2561),(35947,2561),(35948,2561),(35949,2562),(35950,2562),(35951,2562),(35952,2562),(35953,2563),(35954,2563),(35955,2563),(35956,2563),(35957,2564),(35958,2564),(35959,2564),(35960,2564),(35961,2565),(35962,2565),(35963,2565),(35964,2565),(35965,2566),(35966,2566),(35967,2566),(35968,2566),(35969,2567),(35970,2567),(35971,2567),(35972,2567),(35973,2568),(35974,2568),(35975,2568),(35976,2568),(35977,2569),(35978,2569),(35979,2569),(35980,2569),(35981,2570),(35982,2570),(35983,2570),(35984,2570),(35985,2571),(35986,2571),(35987,2571),(35988,2571),(35989,2572),(35990,2572),(35991,2572),(35992,2572),(35993,2573),(35994,2573),(35995,2573),(35996,2573),(35997,2574),(35998,2574),(35999,2574),(36000,2574),(36001,2575),(36002,2575),(36003,2575),(36004,2575),(36005,2576),(36006,2576),(36007,2576),(36008,2576),(36009,2577),(36010,2577),(36011,2577),(36012,2577),(36013,2578),(36014,2578),(36015,2578),(36016,2578),(36017,2579),(36018,2579),(36019,2579),(36020,2579),(36021,2580),(36022,2580),(36023,2580),(36024,2580),(36025,2581),(36026,2581),(36027,2581),(36028,2581),(36029,2582),(36030,2582),(36031,2582),(36032,2582),(36033,2583),(36034,2583),(36035,2583),(36036,2583),(36037,2584),(36038,2584),(36039,2584),(36040,2584),(36041,2585),(36042,2585),(36043,2585),(36044,2585),(36045,2586),(36046,2586),(36047,2586),(36048,2586),(36049,2587),(36050,2587),(36051,2587),(36052,2587),(36053,2588),(36054,2588),(36055,2588),(36056,2588),(36057,2589),(36058,2589),(36059,2589),(36060,2589),(36061,2590),(36062,2590),(36063,2590),(36064,2590),(36065,2591),(36066,2591),(36067,2591),(36068,2591),(36069,2592),(36070,2592),(36071,2592),(36072,2592),(36073,2593),(36074,2593),(36075,2593),(36076,2593),(36077,2594),(36078,2594),(36079,2594),(36080,2594),(36081,2595),(36082,2595),(36083,2595),(36084,2595),(36085,2596),(36086,2596),(36087,2596),(36088,2596),(36089,2597),(36090,2597),(36091,2597),(36092,2597),(36093,2598),(36094,2598),(36095,2598),(36096,2598),(36097,2599),(36098,2599),(36099,2599),(36100,2599),(36101,2600),(36102,2600),(36103,2600),(36104,2600),(36105,2601),(36106,2601),(36107,2601),(36108,2601),(36109,2602),(36110,2602),(36111,2602),(36112,2602),(36113,2603),(36114,2603),(36115,2603),(36116,2603),(36117,2604),(36118,2604),(36119,2604),(36120,2604),(36121,2605),(36122,2605),(36123,2605),(36124,2605),(36125,2606),(36126,2606),(36127,2606),(36128,2606),(36129,2607),(36130,2607),(36131,2607),(36132,2607),(36133,2608),(36134,2608),(36135,2608),(36136,2608),(36137,2609),(36138,2609),(36139,2609),(36140,2609),(36141,2610),(36142,2610),(36143,2610),(36144,2610),(36145,2611),(36146,2611),(36147,2611),(36148,2611),(36149,2611),(36150,2611),(36151,2611),(36152,2612),(36153,2612),(36154,2612),(36155,2612),(36156,2612),(36157,2612),(36158,2612),(36159,2613),(36160,2613),(36161,2613),(36162,2613),(36163,2613),(36164,2613),(36165,2613),(36166,2614),(36167,2614),(36168,2614),(36169,2614),(36170,2614),(36171,2614),(36172,2614),(36173,2615),(36174,2615),(36175,2615),(36176,2615),(36177,2615),(36178,2615),(36179,2615),(36180,2616),(36181,2616),(36182,2616),(36183,2616),(36184,2616),(36185,2616),(36186,2616),(36187,2617),(36188,2617),(36189,2617),(36190,2617),(36191,2617),(36192,2617),(36193,2617),(36194,2618),(36195,2618),(36196,2618),(36197,2618),(36198,2618),(36199,2618),(36200,2618),(36201,2619),(36202,2619),(36203,2619),(36204,2619),(36205,2619),(36206,2619),(36207,2619),(36208,2620),(36209,2620),(36210,2620),(36211,2620),(36212,2620),(36213,2620),(36214,2620),(36215,2621),(36216,2621),(36217,2621),(36218,2621),(36219,2621),(36220,2621),(36221,2621),(36222,2611),(36223,2611),(36224,2611),(36225,2612),(36226,2612),(36227,2612),(36228,2613),(36229,2613),(36230,2613),(36231,2614),(36232,2614),(36233,2614),(36234,2615),(36235,2615),(36236,2615),(36237,2616),(36238,2616),(36239,2616),(36240,2617),(36241,2617),(36242,2617),(36243,2618),(36244,2618),(36245,2618),(36246,2619),(36247,2619),(36248,2619),(36249,2620),(36250,2620),(36251,2620),(36252,2621),(36253,2621),(36254,2621),(36255,2611),(36256,2611),(36257,2611),(36258,2611),(36259,2612),(36260,2612),(36261,2612),(36262,2612),(36263,2613),(36264,2613),(36265,2613),(36266,2613),(36267,2614),(36268,2614),(36269,2614),(36270,2614),(36271,2615),(36272,2615),(36273,2615),(36274,2615),(36275,2616),(36276,2616),(36277,2616),(36278,2616),(36279,2617),(36280,2617),(36281,2617),(36282,2617),(36283,2618),(36284,2618),(36285,2618),(36286,2618),(36287,2619),(36288,2619),(36289,2619),(36290,2619),(36291,2620),(36292,2620),(36293,2620),(36294,2620),(36295,2621),(36296,2621),(36297,2621),(36298,2621),(36299,2622),(36300,2622),(36301,2622),(36302,2622),(36303,2622),(36304,2622),(36305,2623),(36306,2623),(36307,2623),(36308,2623),(36309,2623),(36310,2623),(36311,2624),(36312,2624),(36313,2624),(36314,2624),(36315,2624),(36316,2624),(36317,2625),(36318,2625),(36319,2625),(36320,2625),(36321,2625),(36322,2625),(36323,2626),(36324,2626),(36325,2626),(36326,2626),(36327,2626),(36328,2626),(36329,2627),(36330,2627),(36331,2627),(36332,2627),(36333,2627),(36334,2627),(36335,2628),(36336,2628),(36337,2628),(36338,2628),(36339,2628),(36340,2628),(36341,2629),(36342,2629),(36343,2629),(36344,2629),(36345,2629),(36346,2629),(36347,2630),(36348,2630),(36349,2630),(36350,2630),(36351,2630),(36352,2630),(36353,2631),(36354,2631),(36355,2631),(36356,2631),(36357,2631),(36358,2631),(36359,2632),(36360,2632),(36361,2632),(36362,2632),(36363,2632),(36364,2632),(36365,2633),(36366,2633),(36367,2633),(36368,2633),(36369,2633),(36370,2633),(36371,2634),(36372,2634),(36373,2634),(36374,2634),(36375,2634),(36376,2634),(36377,2635),(36378,2635),(36379,2635),(36380,2635),(36381,2635),(36382,2635),(36383,2636),(36384,2636),(36385,2636),(36386,2636),(36387,2636),(36388,2636),(36389,2637),(36390,2637),(36391,2637),(36392,2637),(36393,2637),(36394,2637),(36395,2638),(36396,2638),(36397,2638),(36398,2638),(36399,2638),(36400,2638),(36401,2639),(36402,2639),(36403,2639),(36404,2639),(36405,2639),(36406,2639),(36407,2640),(36408,2640),(36409,2640),(36410,2640),(36411,2640),(36412,2640),(36413,2641),(36414,2641),(36415,2641),(36416,2641),(36417,2641),(36418,2641),(36419,2642),(36420,2642),(36421,2642),(36422,2642),(36423,2642),(36424,2642),(36425,2643),(36426,2643),(36427,2643),(36428,2643),(36429,2643),(36430,2643),(36431,2644),(36432,2644),(36433,2644),(36434,2644),(36435,2644),(36436,2644),(36437,2645),(36438,2645),(36439,2645),(36440,2645),(36441,2645),(36442,2645),(36443,2646),(36444,2646),(36445,2646),(36446,2646),(36447,2646),(36448,2646),(36449,2647),(36450,2647),(36451,2647),(36452,2647),(36453,2647),(36454,2647),(36455,2648),(36456,2648),(36457,2648),(36458,2648),(36459,2648),(36460,2648),(36461,2649),(36462,2649),(36463,2649),(36464,2649),(36465,2649),(36466,2649),(36467,2650),(36468,2650),(36469,2650),(36470,2650),(36471,2650),(36472,2650),(36473,2651),(36474,2651),(36475,2651),(36476,2651),(36477,2651),(36478,2651),(36479,2652),(36480,2652),(36481,2652),(36482,2652),(36483,2652),(36484,2652),(36485,2653),(36486,2653),(36487,2653),(36488,2653),(36489,2653),(36490,2653),(36491,2654),(36492,2654),(36493,2654),(36494,2654),(36495,2654),(36496,2654),(36497,2655),(36498,2655),(36499,2655),(36500,2655),(36501,2655),(36502,2655),(36503,2656),(36504,2656),(36505,2656),(36506,2656),(36507,2656),(36508,2656),(36509,2657),(36510,2657),(36511,2657),(36512,2657),(36513,2657),(36514,2657),(36515,2658),(36516,2658),(36517,2658),(36518,2658),(36519,2658),(36520,2658),(36521,2659),(36522,2659),(36523,2659),(36524,2659),(36525,2659),(36526,2659),(36527,2660),(36528,2660),(36529,2660),(36530,2660),(36531,2660),(36532,2660),(36533,2661),(36534,2661),(36535,2661),(36536,2661),(36537,2661),(36538,2661),(36539,2662),(36540,2662),(36541,2662),(36542,2662),(36543,2662),(36544,2662),(36545,2663),(36546,2663),(36547,2663),(36548,2663),(36549,2663),(36550,2663),(36551,2664),(36552,2664),(36553,2664),(36554,2664),(36555,2664),(36556,2664),(36557,2665),(36558,2665),(36559,2665),(36560,2665),(36561,2665),(36562,2665),(36563,2666),(36564,2666),(36565,2666),(36566,2666),(36567,2666),(36568,2666),(36569,2667),(36570,2667),(36571,2667),(36572,2667),(36573,2667),(36574,2667),(36575,2668),(36576,2668),(36577,2668),(36578,2668),(36579,2668),(36580,2668),(36581,2669),(36582,2669),(36583,2669),(36584,2669),(36585,2669),(36586,2669),(36587,2670),(36588,2670),(36589,2670),(36590,2670),(36591,2670),(36592,2670),(36593,2671),(36594,2671),(36595,2671),(36596,2671),(36597,2671),(36598,2671),(36599,2672),(36600,2672),(36601,2672),(36602,2672),(36603,2672),(36604,2672),(36605,2673),(36606,2673),(36607,2673),(36608,2673),(36609,2673),(36610,2673),(36611,2674),(36612,2674),(36613,2674),(36614,2674),(36615,2674),(36616,2674),(36617,2675),(36618,2675),(36619,2675),(36620,2675),(36621,2675),(36622,2675),(36623,2676),(36624,2676),(36625,2676),(36626,2676),(36627,2676),(36628,2676),(36629,2677),(36630,2677),(36631,2677),(36632,2677),(36633,2677),(36634,2677),(36635,2678),(36636,2678),(36637,2678),(36638,2678),(36639,2678),(36640,2678),(36641,2679),(36642,2679),(36643,2679),(36644,2679),(36645,2679),(36646,2679),(36647,2680),(36648,2680),(36649,2680),(36650,2680),(36651,2680),(36652,2680),(36653,2681),(36654,2681),(36655,2681),(36656,2681),(36657,2681),(36658,2681),(36659,2682),(36660,2682),(36661,2682),(36662,2682),(36663,2682),(36664,2682),(36665,2683),(36666,2683),(36667,2683),(36668,2683),(36669,2683),(36670,2683),(36671,2684),(36672,2684),(36673,2684),(36674,2684),(36675,2684),(36676,2684),(36677,2685),(36678,2685),(36679,2685),(36680,2685),(36681,2685),(36682,2685),(36683,2686),(36684,2686),(36685,2686),(36686,2686),(36687,2686),(36688,2686),(36689,2687),(36690,2687),(36691,2687),(36692,2687),(36693,2687),(36694,2687),(36695,2688),(36696,2688),(36697,2688),(36698,2688),(36699,2688),(36700,2688),(36701,2689),(36702,2689),(36703,2689),(36704,2689),(36705,2689),(36706,2689),(36707,2690),(36708,2690),(36709,2690),(36710,2690),(36711,2690),(36712,2690),(36713,2691),(36714,2691),(36715,2691),(36716,2691),(36717,2691),(36718,2691),(36719,2692),(36720,2692),(36721,2692),(36722,2692),(36723,2692),(36724,2692),(36725,2693),(36726,2693),(36727,2693),(36728,2693),(36729,2693),(36730,2693),(36731,2694),(36732,2694),(36733,2694),(36734,2694),(36735,2694),(36736,2694),(36737,2695),(36738,2695),(36739,2695),(36740,2695),(36741,2695),(36742,2695),(36743,2696),(36744,2696),(36745,2696),(36746,2696),(36747,2696),(36748,2696),(36749,2697),(36750,2697),(36751,2697),(36752,2697),(36753,2697),(36754,2697),(36755,2698),(36756,2698),(36757,2698),(36758,2698),(36759,2698),(36760,2698),(36761,2699),(36762,2699),(36763,2699),(36764,2699),(36765,2699),(36766,2699),(36767,2700),(36768,2700),(36769,2700),(36770,2700),(36771,2700),(36772,2700),(36773,2701),(36774,2701),(36775,2701),(36776,2701),(36777,2701),(36778,2701),(36779,2702),(36780,2702),(36781,2702),(36782,2702),(36783,2702),(36784,2702),(36785,2703),(36786,2703),(36787,2703),(36788,2703),(36789,2703),(36790,2703),(36791,2704),(36792,2704),(36793,2704),(36794,2704),(36795,2704),(36796,2704),(36797,2705),(36798,2705),(36799,2705),(36800,2705),(36801,2705),(36802,2705),(36803,2706),(36804,2706),(36805,2706),(36806,2706),(36807,2706),(36808,2706),(36809,2707),(36810,2707),(36811,2707),(36812,2707),(36813,2707),(36814,2707),(36815,2708),(36816,2708),(36817,2708),(36818,2708),(36819,2708),(36820,2708),(36821,2709),(36822,2709),(36823,2709),(36824,2709),(36825,2709),(36826,2709),(36827,2710),(36828,2710),(36829,2710),(36830,2710),(36831,2710),(36832,2710),(36833,2711),(36834,2711),(36835,2711),(36836,2711),(36837,2711),(36838,2711),(36839,2712),(36840,2712),(36841,2712),(36842,2712),(36843,2712),(36844,2712),(36845,2713),(36846,2713),(36847,2713),(36848,2713),(36849,2713),(36850,2713),(36851,2714),(36852,2714),(36853,2714),(36854,2714),(36855,2714),(36856,2714),(36857,2715),(36858,2715),(36859,2715),(36860,2715),(36861,2715),(36862,2715),(36863,2716),(36864,2716),(36865,2716),(36866,2716),(36867,2716),(36868,2716),(36869,2717),(36870,2717),(36871,2717),(36872,2717),(36873,2717),(36874,2717),(36875,2718),(36876,2718),(36877,2718),(36878,2718),(36879,2718),(36880,2718),(36881,2719),(36882,2719),(36883,2719),(36884,2719),(36885,2719),(36886,2719),(36887,2720),(36888,2720),(36889,2720),(36890,2720),(36891,2720),(36892,2720),(36893,2721),(36894,2721),(36895,2721),(36896,2721),(36897,2721),(36898,2721),(36899,2622),(36900,2622),(36901,2622),(36902,2623),(36903,2623),(36904,2623),(36905,2624),(36906,2624),(36907,2624),(36908,2625),(36909,2625),(36910,2625),(36911,2626),(36912,2626),(36913,2626),(36914,2627),(36915,2627),(36916,2627),(36917,2628),(36918,2628),(36919,2628),(36920,2629),(36921,2629),(36922,2629),(36923,2630),(36924,2630),(36925,2630),(36926,2631),(36927,2631),(36928,2631),(36929,2632),(36930,2632),(36931,2632),(36932,2633),(36933,2633),(36934,2633),(36935,2634),(36936,2634),(36937,2634),(36938,2635),(36939,2635),(36940,2635),(36941,2636),(36942,2636),(36943,2636),(36944,2637),(36945,2637),(36946,2637),(36947,2638),(36948,2638),(36949,2638),(36950,2639),(36951,2639),(36952,2639),(36953,2640),(36954,2640),(36955,2640),(36956,2641),(36957,2641),(36958,2641),(36959,2642),(36960,2642),(36961,2642),(36962,2643),(36963,2643),(36964,2643),(36965,2644),(36966,2644),(36967,2644),(36968,2645),(36969,2645),(36970,2645),(36971,2646),(36972,2646),(36973,2646),(36974,2647),(36975,2647),(36976,2647),(36977,2648),(36978,2648),(36979,2648),(36980,2649),(36981,2649),(36982,2649),(36983,2650),(36984,2650),(36985,2650),(36986,2651),(36987,2651),(36988,2651),(36989,2652),(36990,2652),(36991,2652),(36992,2653),(36993,2653),(36994,2653),(36995,2654),(36996,2654),(36997,2654),(36998,2655),(36999,2655),(37000,2655),(37001,2656),(37002,2656),(37003,2656),(37004,2657),(37005,2657),(37006,2657),(37007,2658),(37008,2658),(37009,2658),(37010,2659),(37011,2659),(37012,2659),(37013,2660),(37014,2660),(37015,2660),(37016,2661),(37017,2661),(37018,2661),(37019,2662),(37020,2662),(37021,2662),(37022,2663),(37023,2663),(37024,2663),(37025,2664),(37026,2664),(37027,2664),(37028,2665),(37029,2665),(37030,2665),(37031,2666),(37032,2666),(37033,2666),(37034,2667),(37035,2667),(37036,2667),(37037,2668),(37038,2668),(37039,2668),(37040,2669),(37041,2669),(37042,2669),(37043,2670),(37044,2670),(37045,2670),(37046,2671),(37047,2671),(37048,2671),(37049,2672),(37050,2672),(37051,2672),(37052,2673),(37053,2673),(37054,2673),(37055,2674),(37056,2674),(37057,2674),(37058,2675),(37059,2675),(37060,2675),(37061,2676),(37062,2676),(37063,2676),(37064,2677),(37065,2677),(37066,2677),(37067,2678),(37068,2678),(37069,2678),(37070,2679),(37071,2679),(37072,2679),(37073,2680),(37074,2680),(37075,2680),(37076,2681),(37077,2681),(37078,2681),(37079,2682),(37080,2682),(37081,2682),(37082,2683),(37083,2683),(37084,2683),(37085,2684),(37086,2684),(37087,2684),(37088,2685),(37089,2685),(37090,2685),(37091,2686),(37092,2686),(37093,2686),(37094,2687),(37095,2687),(37096,2687),(37097,2688),(37098,2688),(37099,2688),(37100,2689),(37101,2689),(37102,2689),(37103,2690),(37104,2690),(37105,2690),(37106,2691),(37107,2691),(37108,2691),(37109,2692),(37110,2692),(37111,2692),(37112,2693),(37113,2693),(37114,2693),(37115,2694),(37116,2694),(37117,2694),(37118,2695),(37119,2695),(37120,2695),(37121,2696),(37122,2696),(37123,2696),(37124,2697),(37125,2697),(37126,2697),(37127,2698),(37128,2698),(37129,2698),(37130,2699),(37131,2699),(37132,2699),(37133,2700),(37134,2700),(37135,2700),(37136,2701),(37137,2701),(37138,2701),(37139,2702),(37140,2702),(37141,2702),(37142,2703),(37143,2703),(37144,2703),(37145,2704),(37146,2704),(37147,2704),(37148,2705),(37149,2705),(37150,2705),(37151,2706),(37152,2706),(37153,2706),(37154,2707),(37155,2707),(37156,2708),(37157,2708),(37158,2708),(37159,2709),(37160,2709),(37161,2709),(37162,2710),(37163,2710),(37164,2710),(37165,2711),(37166,2711),(37167,2711),(37168,2712),(37169,2712),(37170,2712),(37171,2713),(37172,2713),(37173,2713),(37174,2714),(37175,2714),(37176,2714),(37177,2715),(37178,2715),(37179,2715),(37180,2716),(37181,2716),(37182,2716),(37183,2717),(37184,2717),(37185,2717),(37186,2718),(37187,2718),(37188,2718),(37189,2719),(37190,2719),(37191,2719),(37192,2720),(37193,2720),(37194,2720),(37195,2721),(37196,2721),(37197,2721),(37198,2622),(37199,2622),(37200,2622),(37201,2622),(37202,2623),(37203,2623),(37204,2623),(37205,2623),(37206,2624),(37207,2624),(37208,2624),(37209,2624),(37210,2625),(37211,2625),(37212,2625),(37213,2625),(37214,2626),(37215,2626),(37216,2626),(37217,2626),(37218,2627),(37219,2627),(37220,2627),(37221,2627),(37222,2628),(37223,2628),(37224,2628),(37225,2628),(37226,2629),(37227,2629),(37228,2629),(37229,2629),(37230,2630),(37231,2630),(37232,2630),(37233,2630),(37234,2631),(37235,2631),(37236,2631),(37237,2631),(37238,2632),(37239,2632),(37240,2632),(37241,2632),(37242,2633),(37243,2633),(37244,2633),(37245,2633),(37246,2634),(37247,2634),(37248,2634),(37249,2634),(37250,2635),(37251,2635),(37252,2635),(37253,2635),(37254,2636),(37255,2636),(37256,2636),(37257,2636),(37258,2637),(37259,2637),(37260,2637),(37261,2637),(37262,2638),(37263,2638),(37264,2638),(37265,2638),(37266,2639),(37267,2639),(37268,2639),(37269,2639),(37270,2640),(37271,2640),(37272,2640),(37273,2640),(37274,2641),(37275,2641),(37276,2641),(37277,2641),(37278,2642),(37279,2642),(37280,2642),(37281,2642),(37282,2643),(37283,2643),(37284,2643),(37285,2643),(37286,2644),(37287,2644),(37288,2644),(37289,2644),(37290,2645),(37291,2645),(37292,2645),(37293,2645),(37294,2646),(37295,2646),(37296,2646),(37297,2646),(37298,2647),(37299,2647),(37300,2647),(37301,2647),(37302,2648),(37303,2648),(37304,2648),(37305,2648),(37306,2649),(37307,2649),(37308,2649),(37309,2649),(37310,2650),(37311,2650),(37312,2650),(37313,2650),(37314,2651),(37315,2651),(37316,2651),(37317,2651),(37318,2652),(37319,2652),(37320,2652),(37321,2652),(37322,2653),(37323,2653),(37324,2653),(37325,2653),(37326,2654),(37327,2654),(37328,2654),(37329,2654),(37330,2655),(37331,2655),(37332,2655),(37333,2655),(37334,2656),(37335,2656),(37336,2656),(37337,2656),(37338,2657),(37339,2657),(37340,2657),(37341,2657),(37342,2658),(37343,2658),(37344,2658),(37345,2658),(37346,2659),(37347,2659),(37348,2659),(37349,2659),(37350,2660),(37351,2660),(37352,2660),(37353,2660),(37354,2661),(37355,2661),(37356,2661),(37357,2661),(37358,2662),(37359,2662),(37360,2662),(37361,2662),(37362,2663),(37363,2663),(37364,2663),(37365,2663),(37366,2664),(37367,2664),(37368,2664),(37369,2664),(37370,2665),(37371,2665),(37372,2665),(37373,2665),(37374,2666),(37375,2666),(37376,2666),(37377,2666),(37378,2667),(37379,2667),(37380,2667),(37381,2667),(37382,2668),(37383,2668),(37384,2668),(37385,2668),(37386,2669),(37387,2669),(37388,2669),(37389,2669),(37390,2670),(37391,2670),(37392,2670),(37393,2670),(37394,2671),(37395,2671),(37396,2671),(37397,2671),(37398,2672),(37399,2672),(37400,2672),(37401,2672),(37402,2673),(37403,2673),(37404,2673),(37405,2673),(37406,2674),(37407,2674),(37408,2674),(37409,2674),(37410,2675),(37411,2675),(37412,2675),(37413,2675),(37414,2676),(37415,2676),(37416,2676),(37417,2676),(37418,2677),(37419,2677),(37420,2677),(37421,2677),(37422,2678),(37423,2678),(37424,2678),(37425,2678),(37426,2679),(37427,2679),(37428,2679),(37429,2679),(37430,2680),(37431,2680),(37432,2680),(37433,2680),(37434,2681),(37435,2681),(37436,2681),(37437,2681),(37438,2682),(37439,2682),(37440,2682),(37441,2682),(37442,2683),(37443,2683),(37444,2683),(37445,2683),(37446,2684),(37447,2684),(37448,2684),(37449,2684),(37450,2685),(37451,2685),(37452,2685),(37453,2685),(37454,2686),(37455,2686),(37456,2686),(37457,2686),(37458,2687),(37459,2687),(37460,2687),(37461,2687),(37462,2688),(37463,2688),(37464,2688),(37465,2688),(37466,2689),(37467,2689),(37468,2689),(37469,2689),(37470,2690),(37471,2690),(37472,2690),(37473,2690),(37474,2691),(37475,2691),(37476,2691),(37477,2691),(37478,2692),(37479,2692),(37480,2692),(37481,2692),(37482,2693),(37483,2693),(37484,2693),(37485,2693),(37486,2694),(37487,2694),(37488,2694),(37489,2694),(37490,2695),(37491,2695),(37492,2695),(37493,2695),(37494,2696),(37495,2696),(37496,2696),(37497,2696),(37498,2697),(37499,2697),(37500,2697),(37501,2697),(37502,2698),(37503,2698),(37504,2698),(37505,2698),(37506,2699),(37507,2699),(37508,2699),(37509,2699),(37510,2700),(37511,2700),(37512,2700),(37513,2700),(37514,2701),(37515,2701),(37516,2701),(37517,2701),(37518,2702),(37519,2702),(37520,2702),(37521,2702),(37522,2703),(37523,2703),(37524,2703),(37525,2703),(37526,2704),(37527,2704),(37528,2704),(37529,2704),(37530,2705),(37531,2705),(37532,2705),(37533,2705),(37534,2706),(37535,2706),(37536,2706),(37537,2706),(37538,2707),(37539,2707),(37540,2707),(37541,2707),(37542,2708),(37543,2708),(37544,2708),(37545,2708),(37546,2709),(37547,2709),(37548,2709),(37549,2709),(37550,2710),(37551,2710),(37552,2710),(37553,2710),(37554,2711),(37555,2711),(37556,2711),(37557,2711),(37558,2712),(37559,2712),(37560,2712),(37561,2712),(37562,2713),(37563,2713),(37564,2713),(37565,2713),(37566,2714),(37567,2714),(37568,2714),(37569,2714),(37570,2715),(37571,2715),(37572,2715),(37573,2715),(37574,2716),(37575,2716),(37576,2716),(37577,2716),(37578,2717),(37579,2717),(37580,2717),(37581,2717),(37582,2718),(37583,2718),(37584,2718),(37585,2718),(37586,2719),(37587,2719),(37588,2719),(37589,2719),(37590,2720),(37591,2720),(37592,2720),(37593,2720),(37594,2721),(37595,2721),(37596,2721),(37597,2721),(37598,2722),(37599,2722),(37600,2722),(37601,2722),(37602,2722),(37603,2722),(37604,2723),(37605,2723),(37606,2723),(37607,2723),(37608,2723),(37609,2723),(37610,2724),(37611,2724),(37612,2724),(37613,2724),(37614,2724),(37615,2724),(37616,2725),(37617,2725),(37618,2725),(37619,2725),(37620,2725),(37621,2725),(37622,2726),(37623,2726),(37624,2726),(37625,2726),(37626,2726),(37627,2726),(37628,2727),(37629,2727),(37630,2727),(37631,2727),(37632,2727),(37633,2727),(37634,2728),(37635,2728),(37636,2728),(37637,2728),(37638,2728),(37639,2728),(37640,2729),(37641,2729),(37642,2729),(37643,2729),(37644,2729),(37645,2729),(37646,2730),(37647,2730),(37648,2730),(37649,2730),(37650,2730),(37651,2730),(37652,2731),(37653,2731),(37654,2731),(37655,2731),(37656,2731),(37657,2731),(37658,2732),(37659,2732),(37660,2732),(37661,2732),(37662,2732),(37663,2732),(37664,2733),(37665,2733),(37666,2733),(37667,2733),(37668,2733),(37669,2733),(37670,2734),(37671,2734),(37672,2734),(37673,2734),(37674,2734),(37675,2734),(37676,2735),(37677,2735),(37678,2735),(37679,2735),(37680,2735),(37681,2735),(37682,2736),(37683,2736),(37684,2736),(37685,2736),(37686,2736),(37687,2736),(37688,2737),(37689,2737),(37690,2737),(37691,2737),(37692,2737),(37693,2737),(37694,2738),(37695,2738),(37696,2738),(37697,2738),(37698,2738),(37699,2738),(37700,2739),(37701,2739),(37702,2739),(37703,2739),(37704,2739),(37705,2739),(37706,2740),(37707,2740),(37708,2740),(37709,2740),(37710,2740),(37711,2740),(37712,2741),(37713,2741),(37714,2741),(37715,2741),(37716,2741),(37717,2741),(37718,2742),(37719,2742),(37720,2742),(37721,2742),(37722,2742),(37723,2742),(37724,2743),(37725,2743),(37726,2743),(37727,2743),(37728,2743),(37729,2743),(37730,2744),(37731,2744),(37732,2744),(37733,2744),(37734,2744),(37735,2744),(37736,2745),(37737,2745),(37738,2745),(37739,2745),(37740,2745),(37741,2745),(37742,2746),(37743,2746),(37744,2746),(37745,2746),(37746,2746),(37747,2746),(37748,2747),(37749,2747),(37750,2747),(37751,2747),(37752,2747),(37753,2747),(37754,2748),(37755,2748),(37756,2748),(37757,2748),(37758,2748),(37759,2748),(37760,2749),(37761,2749),(37762,2749),(37763,2749),(37764,2749),(37765,2749),(37766,2750),(37767,2750),(37768,2750),(37769,2750),(37770,2750),(37771,2750),(37772,2751),(37773,2751),(37774,2751),(37775,2751),(37776,2751),(37777,2751),(37778,2752),(37779,2752),(37780,2752),(37781,2752),(37782,2752),(37783,2752),(37784,2753),(37785,2753),(37786,2753),(37787,2753),(37788,2753),(37789,2753),(37790,2754),(37791,2754),(37792,2754),(37793,2754),(37794,2754),(37795,2754),(37796,2755),(37797,2755),(37798,2755),(37799,2755),(37800,2755),(37801,2755),(37802,2756),(37803,2756),(37804,2756),(37805,2756),(37806,2756),(37807,2756),(37808,2757),(37809,2757),(37810,2757),(37811,2757),(37812,2757),(37813,2757),(37814,2758),(37815,2758),(37816,2758),(37817,2758),(37818,2758),(37819,2758),(37820,2759),(37821,2759),(37822,2759),(37823,2759),(37824,2759),(37825,2759),(37826,2760),(37827,2760),(37828,2760),(37829,2760),(37830,2760),(37831,2760),(37832,2761),(37833,2761),(37834,2761),(37835,2761),(37836,2761),(37837,2761),(37838,2762),(37839,2762),(37840,2762),(37841,2762),(37842,2762),(37843,2762),(37844,2763),(37845,2763),(37846,2763),(37847,2763),(37848,2763),(37849,2763),(37850,2764),(37851,2764),(37852,2764),(37853,2764),(37854,2764),(37855,2764),(37856,2765),(37857,2765),(37858,2765),(37859,2765),(37860,2765),(37861,2765),(37862,2766),(37863,2766),(37864,2766),(37865,2766),(37866,2766),(37867,2766),(37868,2767),(37869,2767),(37870,2767),(37871,2767),(37872,2767),(37873,2767),(37874,2768),(37875,2768),(37876,2768),(37877,2768),(37878,2768),(37879,2768),(37880,2769),(37881,2769),(37882,2769),(37883,2769),(37884,2769),(37885,2769),(37886,2770),(37887,2770),(37888,2770),(37889,2770),(37890,2770),(37891,2770),(37892,2771),(37893,2771),(37894,2771),(37895,2771),(37896,2771),(37897,2771),(37898,2772),(37899,2772),(37900,2772),(37901,2772),(37902,2772),(37903,2772),(37904,2773),(37905,2773),(37906,2773),(37907,2773),(37908,2773),(37909,2773),(37910,2774),(37911,2774),(37912,2774),(37913,2774),(37914,2775),(37915,2775),(37916,2775),(37917,2775),(37918,2776),(37919,2776),(37920,2776),(37921,2776),(37922,2777),(37923,2777),(37924,2777),(37925,2777),(37926,2778),(37927,2778),(37928,2778),(37929,2778),(37930,2779),(37931,2779),(37932,2779),(37933,2779),(37934,2780),(37935,2780),(37936,2780),(37937,2780),(37938,2780),(37939,2780),(37940,2781),(37941,2781),(37942,2781),(37943,2781),(37944,2781),(37945,2781),(37946,2782),(37947,2782),(37948,2782),(37949,2782),(37950,2782),(37951,2782),(37952,2783),(37953,2783),(37954,2783),(37955,2783),(37956,2784),(37957,2784),(37958,2784),(37959,2784),(37960,2785),(37961,2785),(37962,2785),(37963,2785),(37964,2786),(37965,2786),(37966,2786),(37967,2786),(37968,2787),(37969,2787),(37970,2787),(37971,2787),(37972,2788),(37973,2788),(37974,2788),(37975,2788),(37976,2789),(37977,2789),(37978,2789),(37979,2789),(37980,2790),(37981,2790),(37982,2790),(37983,2790),(37984,2791),(37985,2791),(37986,2791),(37987,2791),(37988,2792),(37989,2792),(37990,2792),(37991,2792),(37992,2793),(37993,2793),(37994,2793),(37995,2793),(37996,2793),(37997,2793),(37998,2794),(37999,2794),(38000,2794),(38001,2794),(38002,2794),(38003,2794),(38004,2795),(38005,2795),(38006,2795),(38007,2795),(38008,2795),(38009,2795),(38010,2796),(38011,2796),(38012,2796),(38013,2796),(38014,2796),(38015,2796),(38016,2797),(38017,2797),(38018,2797),(38019,2797),(38020,2797),(38021,2797),(38022,2798),(38023,2798),(38024,2798),(38025,2798),(38026,2798),(38027,2798),(38028,2799),(38029,2799),(38030,2799),(38031,2799),(38032,2799),(38033,2799),(38034,2800),(38035,2800),(38036,2800),(38037,2800),(38038,2800),(38039,2800),(38040,2801),(38041,2801),(38042,2801),(38043,2801),(38044,2801),(38045,2801),(38046,2802),(38047,2802),(38048,2802),(38049,2802),(38050,2802),(38051,2802),(38052,2803),(38053,2803),(38054,2803),(38055,2803),(38056,2803),(38057,2803),(38058,2804),(38059,2804),(38060,2804),(38061,2804),(38062,2804),(38063,2804),(38064,2805),(38065,2805),(38066,2805),(38067,2805),(38068,2805),(38069,2805),(38070,2806),(38071,2806),(38072,2806),(38073,2806),(38074,2806),(38075,2806),(38076,2807),(38077,2807),(38078,2807),(38079,2807),(38080,2807),(38081,2807),(38082,2808),(38083,2808),(38084,2808),(38085,2808),(38086,2808),(38087,2808),(38088,2809),(38089,2809),(38090,2809),(38091,2809),(38092,2809),(38093,2809),(38094,2810),(38095,2810),(38096,2810),(38097,2810),(38098,2810),(38099,2810),(38100,2811),(38101,2811),(38102,2811),(38103,2811),(38104,2811),(38105,2811),(38106,2812),(38107,2812),(38108,2812),(38109,2812),(38110,2812),(38111,2812),(38112,2813),(38113,2813),(38114,2813),(38115,2813),(38116,2813),(38117,2813),(38118,2814),(38119,2814),(38120,2814),(38121,2814),(38122,2814),(38123,2814),(38124,2815),(38125,2815),(38126,2815),(38127,2815),(38128,2815),(38129,2815),(38130,2816),(38131,2816),(38132,2816),(38133,2816),(38134,2816),(38135,2816),(38136,2817),(38137,2817),(38138,2817),(38139,2817),(38140,2817),(38141,2817),(38142,2818),(38143,2818),(38144,2818),(38145,2818),(38146,2818),(38147,2818),(38148,2819),(38149,2819),(38150,2819),(38151,2819),(38152,2819),(38153,2819),(38154,2820),(38155,2820),(38156,2820),(38157,2820),(38158,2820),(38159,2820),(38160,2821),(38161,2821),(38162,2821),(38163,2821),(38164,2821),(38165,2821),(38166,2722),(38167,2722),(38168,2722),(38169,2723),(38170,2723),(38171,2723),(38172,2724),(38173,2724),(38174,2724),(38175,2725),(38176,2725),(38177,2725),(38178,2726),(38179,2726),(38180,2726),(38181,2727),(38182,2727),(38183,2727),(38184,2728),(38185,2728),(38186,2728),(38187,2729),(38188,2729),(38189,2729),(38190,2730),(38191,2730),(38192,2730),(38193,2731),(38194,2731),(38195,2731),(38196,2732),(38197,2732),(38198,2732),(38199,2733),(38200,2733),(38201,2733),(38202,2734),(38203,2734),(38204,2734),(38205,2735),(38206,2735),(38207,2735),(38208,2736),(38209,2736),(38210,2736),(38211,2737),(38212,2737),(38213,2737),(38214,2738),(38215,2738),(38216,2738),(38217,2739),(38218,2739),(38219,2739),(38220,2740),(38221,2740),(38222,2740),(38223,2741),(38224,2741),(38225,2741),(38226,2742),(38227,2742),(38228,2742),(38229,2743),(38230,2743),(38231,2743),(38232,2744),(38233,2744),(38234,2744),(38235,2745),(38236,2745),(38237,2745),(38238,2746),(38239,2746),(38240,2746),(38241,2747),(38242,2747),(38243,2747),(38244,2748),(38245,2748),(38246,2748),(38247,2749),(38248,2749),(38249,2749),(38250,2750),(38251,2750),(38252,2750),(38253,2751),(38254,2751),(38255,2751),(38256,2752),(38257,2752),(38258,2752),(38259,2753),(38260,2753),(38261,2753),(38262,2754),(38263,2754),(38264,2754),(38265,2755),(38266,2755),(38267,2755),(38268,2756),(38269,2756),(38270,2756),(38271,2757),(38272,2757),(38273,2757),(38274,2758),(38275,2758),(38276,2758),(38277,2759),(38278,2759),(38279,2759),(38280,2760),(38281,2760),(38282,2760),(38283,2761),(38284,2761),(38285,2761),(38286,2762),(38287,2762),(38288,2762),(38289,2763),(38290,2763),(38291,2763),(38292,2764),(38293,2764),(38294,2764),(38295,2765),(38296,2765),(38297,2765),(38298,2766),(38299,2766),(38300,2766),(38301,2767),(38302,2767),(38303,2767),(38304,2768),(38305,2768),(38306,2768),(38307,2769),(38308,2769),(38309,2769),(38310,2770),(38311,2770),(38312,2770),(38313,2771),(38314,2771),(38315,2771),(38316,2772),(38317,2772),(38318,2772),(38319,2773),(38320,2773),(38321,2773),(38322,2774),(38323,2774),(38324,2774),(38325,2775),(38326,2775),(38327,2775),(38328,2776),(38329,2776),(38330,2776),(38331,2777),(38332,2777),(38333,2777),(38334,2778),(38335,2778),(38336,2778),(38337,2779),(38338,2779),(38339,2779),(38340,2780),(38341,2780),(38342,2780),(38343,2781),(38344,2781),(38345,2781),(38346,2782),(38347,2782),(38348,2782),(38349,2783),(38350,2783),(38351,2783),(38352,2784),(38353,2784),(38354,2784),(38355,2785),(38356,2785),(38357,2785),(38358,2786),(38359,2786),(38360,2786),(38361,2787),(38362,2787),(38363,2787),(38364,2788),(38365,2788),(38366,2788),(38367,2789),(38368,2789),(38369,2789),(38370,2790),(38371,2790),(38372,2790),(38373,2791),(38374,2791),(38375,2791),(38376,2792),(38377,2792),(38378,2792),(38379,2793),(38380,2793),(38381,2793),(38382,2794),(38383,2794),(38384,2794),(38385,2795),(38386,2795),(38387,2795),(38388,2796),(38389,2796),(38390,2796),(38391,2797),(38392,2797),(38393,2797),(38394,2798),(38395,2798),(38396,2798),(38397,2799),(38398,2799),(38399,2799),(38400,2800),(38401,2800),(38402,2800),(38403,2801),(38404,2801),(38405,2801),(38406,2802),(38407,2802),(38408,2802),(38409,2803),(38410,2803),(38411,2803),(38412,2804),(38413,2804),(38414,2804),(38415,2805),(38416,2805),(38417,2805),(38418,2806),(38419,2806),(38420,2806),(38421,2807),(38422,2807),(38423,2807),(38424,2808),(38425,2808),(38426,2808),(38427,2809),(38428,2809),(38429,2809),(38430,2810),(38431,2810),(38432,2810),(38433,2811),(38434,2811),(38435,2811),(38436,2812),(38437,2812),(38438,2812),(38439,2813),(38440,2813),(38441,2813),(38442,2814),(38443,2814),(38444,2814),(38445,2815),(38446,2815),(38447,2815),(38448,2816),(38449,2816),(38450,2816),(38451,2817),(38452,2817),(38453,2817),(38454,2818),(38455,2818),(38456,2818),(38457,2819),(38458,2819),(38459,2819),(38460,2820),(38461,2820),(38462,2820),(38463,2821),(38464,2821),(38465,2821),(38466,2722),(38467,2722),(38468,2722),(38469,2722),(38470,2723),(38471,2723),(38472,2723),(38473,2723),(38474,2724),(38475,2724),(38476,2724),(38477,2724),(38478,2725),(38479,2725),(38480,2725),(38481,2725),(38482,2726),(38483,2726),(38484,2726),(38485,2726),(38486,2727),(38487,2727),(38488,2727),(38489,2727),(38490,2728),(38491,2728),(38492,2728),(38493,2728),(38494,2729),(38495,2729),(38496,2729),(38497,2729),(38498,2730),(38499,2730),(38500,2730),(38501,2730),(38502,2731),(38503,2731),(38504,2731),(38505,2731),(38506,2732),(38507,2732),(38508,2732),(38509,2732),(38510,2733),(38511,2733),(38512,2733),(38513,2733),(38514,2734),(38515,2734),(38516,2734),(38517,2734),(38518,2735),(38519,2735),(38520,2735),(38521,2735),(38522,2736),(38523,2736),(38524,2736),(38525,2736),(38526,2737),(38527,2737),(38528,2737),(38529,2737),(38530,2738),(38531,2738),(38532,2738),(38533,2738),(38534,2739),(38535,2739),(38536,2739),(38537,2739),(38538,2740),(38539,2740),(38540,2740),(38541,2740),(38542,2741),(38543,2741),(38544,2741),(38545,2741),(38546,2742),(38547,2742),(38548,2742),(38549,2742),(38550,2743),(38551,2743),(38552,2743),(38553,2743),(38554,2744),(38555,2744),(38556,2744),(38557,2744),(38558,2745),(38559,2745),(38560,2745),(38561,2745),(38562,2746),(38563,2746),(38564,2746),(38565,2746),(38566,2747),(38567,2747),(38568,2747),(38569,2747),(38570,2748),(38571,2748),(38572,2748),(38573,2748),(38574,2749),(38575,2749),(38576,2749),(38577,2749),(38578,2750),(38579,2750),(38580,2750),(38581,2750),(38582,2751),(38583,2751),(38584,2751),(38585,2751),(38586,2752),(38587,2752),(38588,2752),(38589,2752),(38590,2753),(38591,2753),(38592,2753),(38593,2753),(38594,2754),(38595,2754),(38596,2754),(38597,2754),(38598,2755),(38599,2755),(38600,2755),(38601,2755),(38602,2756),(38603,2756),(38604,2756),(38605,2756),(38606,2757),(38607,2757),(38608,2757),(38609,2757),(38610,2758),(38611,2758),(38612,2758),(38613,2758),(38614,2759),(38615,2759),(38616,2759),(38617,2759),(38618,2760),(38619,2760),(38620,2760),(38621,2760),(38622,2761),(38623,2761),(38624,2761),(38625,2761),(38626,2762),(38627,2762),(38628,2762),(38629,2762),(38630,2763),(38631,2763),(38632,2763),(38633,2763),(38634,2764),(38635,2764),(38636,2764),(38637,2764),(38638,2765),(38639,2765),(38640,2765),(38641,2765),(38642,2766),(38643,2766),(38644,2766),(38645,2766),(38646,2767),(38647,2767),(38648,2767),(38649,2767),(38650,2768),(38651,2768),(38652,2768),(38653,2768),(38654,2769),(38655,2769),(38656,2769),(38657,2769),(38658,2770),(38659,2770),(38660,2770),(38661,2770),(38662,2771),(38663,2771),(38664,2771),(38665,2771),(38666,2772),(38667,2772),(38668,2772),(38669,2772),(38670,2773),(38671,2773),(38672,2773),(38673,2773),(38674,2774),(38675,2774),(38676,2774),(38677,2774),(38678,2775),(38679,2775),(38680,2775),(38681,2775),(38682,2776),(38683,2776),(38684,2776),(38685,2776),(38686,2777),(38687,2777),(38688,2777),(38689,2777),(38690,2778),(38691,2778),(38692,2778),(38693,2778),(38694,2779),(38695,2779),(38696,2779),(38697,2779),(38698,2780),(38699,2780),(38700,2780),(38701,2780),(38702,2781),(38703,2781),(38704,2781),(38705,2781),(38706,2782),(38707,2782),(38708,2782),(38709,2782),(38710,2783),(38711,2783),(38712,2783),(38713,2783),(38714,2784),(38715,2784),(38716,2784),(38717,2784),(38718,2785),(38719,2785),(38720,2785),(38721,2785),(38722,2786),(38723,2786),(38724,2786),(38725,2786),(38726,2787),(38727,2787),(38728,2787),(38729,2787),(38730,2788),(38731,2788),(38732,2788),(38733,2788),(38734,2789),(38735,2789),(38736,2789),(38737,2789),(38738,2790),(38739,2790),(38740,2790),(38741,2790),(38742,2791),(38743,2791),(38744,2791),(38745,2791),(38746,2792),(38747,2792),(38748,2792),(38749,2792),(38750,2793),(38751,2793),(38752,2793),(38753,2793),(38754,2794),(38755,2794),(38756,2794),(38757,2794),(38758,2795),(38759,2795),(38760,2795),(38761,2795),(38762,2796),(38763,2796),(38764,2796),(38765,2796),(38766,2797),(38767,2797),(38768,2797),(38769,2797),(38770,2798),(38771,2798),(38772,2798),(38773,2798),(38774,2799),(38775,2799),(38776,2799),(38777,2799),(38778,2800),(38779,2800),(38780,2800),(38781,2800),(38782,2801),(38783,2801),(38784,2801),(38785,2801),(38786,2802),(38787,2802),(38788,2802),(38789,2802),(38790,2803),(38791,2803),(38792,2803),(38793,2803),(38794,2804),(38795,2804),(38796,2804),(38797,2804),(38798,2805),(38799,2805),(38800,2805),(38801,2805),(38802,2806),(38803,2806),(38804,2806),(38805,2806),(38806,2807),(38807,2807),(38808,2807),(38809,2807),(38810,2808),(38811,2808),(38812,2808),(38813,2808),(38814,2809),(38815,2809),(38816,2809),(38817,2809),(38818,2810),(38819,2810),(38820,2810),(38821,2810),(38822,2811),(38823,2811),(38824,2811),(38825,2811),(38826,2812),(38827,2812),(38828,2812),(38829,2812),(38830,2813),(38831,2813),(38832,2813),(38833,2813),(38834,2814),(38835,2814),(38836,2814),(38837,2814),(38838,2815),(38839,2815),(38840,2815),(38841,2815),(38842,2816),(38843,2816),(38844,2816),(38845,2816),(38846,2817),(38847,2817),(38848,2817),(38849,2817),(38850,2818),(38851,2818),(38852,2818),(38853,2818),(38854,2819),(38855,2819),(38856,2819),(38857,2819),(38858,2820),(38859,2820),(38860,2820),(38861,2820),(38862,2821),(38863,2821),(38864,2821),(38865,2821),(38866,2822),(38867,2822),(38868,2822),(38869,2822),(38870,2823),(38871,2823),(38872,2823),(38873,2823),(38874,2824),(38875,2824),(38876,2824),(38877,2824),(38878,2825),(38879,2825),(38880,2825),(38881,2825),(38882,2826),(38883,2826),(38884,2826),(38885,2826),(38886,2827),(38887,2827),(38888,2827),(38889,2827),(38890,2828),(38891,2828),(38892,2828),(38893,2828),(38894,2828),(38895,2828),(38896,2829),(38897,2829),(38898,2829),(38899,2829),(38900,2829),(38901,2829),(38902,2830),(38903,2830),(38904,2830),(38905,2830),(38906,2830),(38907,2830),(38908,2831),(38909,2831),(38910,2831),(38911,2831),(38912,2832),(38913,2832),(38914,2832),(38915,2832),(38916,2833),(38917,2833),(38918,2833),(38919,2833),(38920,2833),(38921,2833),(38922,2834),(38923,2834),(38924,2834),(38925,2834),(38926,2834),(38927,2834),(38928,2835),(38929,2835),(38930,2835),(38931,2835),(38932,2835),(38933,2835),(38934,2836),(38935,2836),(38936,2836),(38937,2836),(38938,2836),(38939,2836),(38940,2837),(38941,2837),(38942,2837),(38943,2837),(38944,2837),(38945,2837),(38946,2838),(38947,2838),(38948,2838),(38949,2838),(38950,2838),(38951,2838),(38952,2839),(38953,2839),(38954,2839),(38955,2839),(38956,2839),(38957,2839),(38958,2840),(38959,2840),(38960,2840),(38961,2840),(38962,2840),(38963,2840),(38964,2841),(38965,2841),(38966,2841),(38967,2841),(38968,2841),(38969,2841),(38970,2842),(38971,2842),(38972,2842),(38973,2842),(38974,2842),(38975,2842),(38976,2843),(38977,2843),(38978,2843),(38979,2843),(38980,2843),(38981,2843),(38982,2844),(38983,2844),(38984,2844),(38985,2844),(38986,2845),(38987,2845),(38988,2845),(38989,2845),(38990,2846),(38991,2846),(38992,2846),(38993,2846),(38994,2847),(38995,2847),(38996,2847),(38997,2847),(38998,2848),(38999,2848),(39000,2848),(39001,2848),(39002,2849),(39003,2849),(39004,2849),(39005,2849),(39006,2850),(39007,2850),(39008,2850),(39009,2850),(39010,2851),(39011,2851),(39012,2851),(39013,2851),(39014,2852),(39015,2852),(39016,2852),(39017,2852),(39018,2852),(39019,2852),(39020,2853),(39021,2853),(39022,2853),(39023,2853),(39024,2853),(39025,2853),(39026,2854),(39027,2854),(39028,2854),(39029,2854),(39030,2854),(39031,2854),(39032,2855),(39033,2855),(39034,2855),(39035,2855),(39036,2855),(39037,2855),(39038,2856),(39039,2856),(39040,2856),(39041,2856),(39042,2856),(39043,2856),(39044,2857),(39045,2857),(39046,2857),(39047,2857),(39048,2857),(39049,2857),(39050,2858),(39051,2858),(39052,2858),(39053,2858),(39054,2858),(39055,2858),(39056,2859),(39057,2859),(39058,2859),(39059,2859),(39060,2859),(39061,2859),(39062,2860),(39063,2860),(39064,2860),(39065,2860),(39066,2860),(39067,2860),(39068,2861),(39069,2861),(39070,2861),(39071,2861),(39072,2861),(39073,2861),(39074,2862),(39075,2862),(39076,2862),(39077,2862),(39078,2862),(39079,2862),(39080,2863),(39081,2863),(39082,2863),(39083,2863),(39084,2863),(39085,2863),(39086,2864),(39087,2864),(39088,2864),(39089,2864),(39090,2864),(39091,2864),(39092,2865),(39093,2865),(39094,2865),(39095,2865),(39096,2865),(39097,2865),(39098,2866),(39099,2866),(39100,2866),(39101,2866),(39102,2866),(39103,2866),(39104,2867),(39105,2867),(39106,2867),(39107,2867),(39108,2867),(39109,2867),(39110,2868),(39111,2868),(39112,2868),(39113,2868),(39114,2868),(39115,2868),(39116,2869),(39117,2869),(39118,2869),(39119,2869),(39120,2869),(39121,2869),(39122,2870),(39123,2870),(39124,2870),(39125,2870),(39126,2870),(39127,2870),(39128,2871),(39129,2871),(39130,2871),(39131,2871),(39132,2871),(39133,2871),(39134,2872),(39135,2872),(39136,2872),(39137,2872),(39138,2872),(39139,2872),(39140,2873),(39141,2873),(39142,2873),(39143,2873),(39144,2873),(39145,2873),(39146,2874),(39147,2874),(39148,2874),(39149,2874),(39150,2874),(39151,2874),(39152,2875),(39153,2875),(39154,2875),(39155,2875),(39156,2875),(39157,2875),(39158,2876),(39159,2876),(39160,2876),(39161,2876),(39162,2876),(39163,2876),(39164,2877),(39165,2877),(39166,2877),(39167,2877),(39168,2877),(39169,2877),(39170,2878),(39171,2878),(39172,2878),(39173,2878),(39174,2878),(39175,2878),(39176,2879),(39177,2879),(39178,2879),(39179,2879),(39180,2879),(39181,2879),(39182,2880),(39183,2880),(39184,2880),(39185,2880),(39186,2880),(39187,2880),(39188,2881),(39189,2881),(39190,2881),(39191,2881),(39192,2881),(39193,2881),(39194,2882),(39195,2882),(39196,2882),(39197,2882),(39198,2882),(39199,2882),(39200,2883),(39201,2883),(39202,2883),(39203,2883),(39204,2883),(39205,2883),(39206,2884),(39207,2884),(39208,2884),(39209,2884),(39210,2884),(39211,2884),(39212,2885),(39213,2885),(39214,2885),(39215,2885),(39216,2885),(39217,2885),(39218,2886),(39219,2886),(39220,2886),(39221,2886),(39222,2886),(39223,2886),(39224,2887),(39225,2887),(39226,2887),(39227,2887),(39228,2887),(39229,2887),(39230,2888),(39231,2888),(39232,2888),(39233,2888),(39234,2888),(39235,2888),(39236,2889),(39237,2889),(39238,2889),(39239,2889),(39240,2889),(39241,2889),(39242,2890),(39243,2890),(39244,2890),(39245,2890),(39246,2890),(39247,2890),(39248,2891),(39249,2891),(39250,2891),(39251,2891),(39252,2891),(39253,2891),(39254,2892),(39255,2892),(39256,2892),(39257,2892),(39258,2892),(39259,2892),(39260,2893),(39261,2893),(39262,2893),(39263,2893),(39264,2893),(39265,2893),(39266,2894),(39267,2894),(39268,2894),(39269,2894),(39270,2894),(39271,2894),(39272,2895),(39273,2895),(39274,2895),(39275,2895),(39276,2895),(39277,2895),(39278,2896),(39279,2896),(39280,2896),(39281,2896),(39282,2896),(39283,2896),(39284,2897),(39285,2897),(39286,2897),(39287,2897),(39288,2897),(39289,2897),(39290,2898),(39291,2898),(39292,2898),(39293,2898),(39294,2898),(39295,2898),(39296,2899),(39297,2899),(39298,2899),(39299,2899),(39300,2899),(39301,2899),(39302,2900),(39303,2900),(39304,2900),(39305,2900),(39306,2900),(39307,2900),(39308,2901),(39309,2901),(39310,2901),(39311,2901),(39312,2901),(39313,2901),(39314,2902),(39315,2902),(39316,2902),(39317,2902),(39318,2902),(39319,2902),(39320,2903),(39321,2903),(39322,2903),(39323,2903),(39324,2903),(39325,2903),(39326,2904),(39327,2904),(39328,2904),(39329,2904),(39330,2904),(39331,2904),(39332,2905),(39333,2905),(39334,2905),(39335,2905),(39336,2905),(39337,2905),(39338,2906),(39339,2906),(39340,2906),(39341,2906),(39342,2906),(39343,2906),(39344,2907),(39345,2907),(39346,2907),(39347,2907),(39348,2907),(39349,2907),(39350,2908),(39351,2908),(39352,2908),(39353,2908),(39354,2908),(39355,2908),(39356,2909),(39357,2909),(39358,2909),(39359,2909),(39360,2909),(39361,2909),(39362,2910),(39363,2910),(39364,2910),(39365,2910),(39366,2910),(39367,2910),(39368,2911),(39369,2911),(39370,2911),(39371,2911),(39372,2911),(39373,2911),(39374,2912),(39375,2912),(39376,2912),(39377,2912),(39378,2912),(39379,2912),(39380,2913),(39381,2913),(39382,2913),(39383,2913),(39384,2914),(39385,2914),(39386,2914),(39387,2914),(39388,2915),(39389,2915),(39390,2915),(39391,2915),(39392,2916),(39393,2916),(39394,2916),(39395,2916),(39396,2917),(39397,2917),(39398,2917),(39399,2917),(39400,2917),(39401,2917),(39402,2918),(39403,2918),(39404,2918),(39405,2918),(39406,2918),(39407,2918),(39408,2919),(39409,2919),(39410,2919),(39411,2919),(39412,2919),(39413,2919),(39414,2920),(39415,2920),(39416,2920),(39417,2920),(39418,2920),(39419,2920),(39420,2921),(39421,2921),(39422,2921),(39423,2921),(39424,2921),(39425,2921),(39426,2822),(39427,2822),(39428,2822),(39429,2823),(39430,2823),(39431,2823),(39432,2824),(39433,2824),(39434,2824),(39435,2825),(39436,2825),(39437,2825),(39438,2826),(39439,2826),(39440,2826),(39441,2827),(39442,2827),(39443,2827),(39444,2828),(39445,2828),(39446,2828),(39447,2829),(39448,2829),(39449,2829),(39450,2830),(39451,2830),(39452,2830),(39453,2831),(39454,2831),(39455,2831),(39456,2832),(39457,2832),(39458,2832),(39459,2833),(39460,2833),(39461,2833),(39462,2834),(39463,2834),(39464,2834),(39465,2835),(39466,2835),(39467,2835),(39468,2836),(39469,2836),(39470,2836),(39471,2837),(39472,2837),(39473,2837),(39474,2838),(39475,2838),(39476,2838),(39477,2839),(39478,2839),(39479,2839),(39480,2840),(39481,2840),(39482,2840),(39483,2841),(39484,2841),(39485,2841),(39486,2842),(39487,2842),(39488,2842),(39489,2843),(39490,2843),(39491,2843),(39492,2844),(39493,2844),(39494,2844),(39495,2845),(39496,2845),(39497,2845),(39498,2846),(39499,2846),(39500,2846),(39501,2847),(39502,2847),(39503,2847),(39504,2848),(39505,2848),(39506,2848),(39507,2849),(39508,2849),(39509,2849),(39510,2850),(39511,2850),(39512,2850),(39513,2851),(39514,2851),(39515,2851),(39516,2852),(39517,2852),(39518,2852),(39519,2853),(39520,2853),(39521,2853),(39522,2854),(39523,2854),(39524,2854),(39525,2855),(39526,2855),(39527,2855),(39528,2856),(39529,2856),(39530,2856),(39531,2857),(39532,2857),(39533,2857),(39534,2858),(39535,2858),(39536,2858),(39537,2859),(39538,2859),(39539,2859),(39540,2860),(39541,2860),(39542,2860),(39543,2861),(39544,2861),(39545,2861),(39546,2862),(39547,2862),(39548,2862),(39549,2863),(39550,2863),(39551,2863),(39552,2864),(39553,2864),(39554,2864),(39555,2865),(39556,2865),(39557,2865),(39558,2866),(39559,2866),(39560,2866),(39561,2867),(39562,2867),(39563,2867),(39564,2868),(39565,2868),(39566,2868),(39567,2869),(39568,2869),(39569,2869),(39570,2870),(39571,2870),(39572,2870),(39573,2871),(39574,2871),(39575,2871),(39576,2872),(39577,2872),(39578,2872),(39579,2873),(39580,2873),(39581,2873),(39582,2874),(39583,2874),(39584,2874),(39585,2875),(39586,2875),(39587,2875),(39588,2876),(39589,2876),(39590,2876),(39591,2877),(39592,2877),(39593,2877),(39594,2878),(39595,2878),(39596,2878),(39597,2879),(39598,2879),(39599,2879),(39600,2880),(39601,2880),(39602,2880),(39603,2881),(39604,2881),(39605,2881),(39606,2882),(39607,2882),(39608,2882),(39609,2883),(39610,2883),(39611,2883),(39612,2884),(39613,2884),(39614,2884),(39615,2885),(39616,2885),(39617,2885),(39618,2886),(39619,2886),(39620,2886),(39621,2887),(39622,2887),(39623,2887),(39624,2888),(39625,2888),(39626,2888),(39627,2889),(39628,2889),(39629,2889),(39630,2890),(39631,2890),(39632,2890),(39633,2891),(39634,2891),(39635,2891),(39636,2892),(39637,2892),(39638,2892),(39639,2893),(39640,2893),(39641,2893),(39642,2894),(39643,2894),(39644,2894),(39645,2895),(39646,2895),(39647,2895),(39648,2896),(39649,2896),(39650,2896),(39651,2897),(39652,2897),(39653,2897),(39654,2898),(39655,2898),(39656,2898),(39657,2899),(39658,2899),(39659,2899),(39660,2900),(39661,2900),(39662,2900),(39663,2901),(39664,2901),(39665,2901),(39666,2902),(39667,2902),(39668,2902),(39669,2903),(39670,2903),(39671,2903),(39672,2904),(39673,2904),(39674,2904),(39675,2905),(39676,2905),(39677,2905),(39678,2906),(39679,2906),(39680,2906),(39681,2907),(39682,2907),(39683,2907),(39684,2908),(39685,2908),(39686,2908),(39687,2909),(39688,2909),(39689,2909),(39690,2910),(39691,2910),(39692,2910),(39693,2911),(39694,2911),(39695,2911),(39696,2912),(39697,2912),(39698,2912),(39699,2913),(39700,2913),(39701,2913),(39702,2914),(39703,2914),(39704,2914),(39705,2915),(39706,2915),(39707,2915),(39708,2916),(39709,2916),(39710,2916),(39711,2917),(39712,2917),(39713,2917),(39714,2918),(39715,2918),(39716,2918),(39717,2919),(39718,2919),(39719,2919),(39720,2920),(39721,2920),(39722,2920),(39723,2921),(39724,2921),(39725,2921),(39726,2822),(39727,2822),(39728,2822),(39729,2822),(39730,2823),(39731,2823),(39732,2823),(39733,2823),(39734,2824),(39735,2824),(39736,2824),(39737,2824),(39738,2825),(39739,2825),(39740,2825),(39741,2825),(39742,2826),(39743,2826),(39744,2826),(39745,2826),(39746,2827),(39747,2827),(39748,2827),(39749,2827),(39750,2828),(39751,2828),(39752,2828),(39753,2828),(39754,2829),(39755,2829),(39756,2829),(39757,2829),(39758,2830),(39759,2830),(39760,2830),(39761,2830),(39762,2831),(39763,2831),(39764,2831),(39765,2831),(39766,2832),(39767,2832),(39768,2832),(39769,2832),(39770,2833),(39771,2833),(39772,2833),(39773,2833),(39774,2834),(39775,2834),(39776,2834),(39777,2834),(39778,2835),(39779,2835),(39780,2835),(39781,2835),(39782,2836),(39783,2836),(39784,2836),(39785,2836),(39786,2837),(39787,2837),(39788,2837),(39789,2837),(39790,2838),(39791,2838),(39792,2838),(39793,2838),(39794,2839),(39795,2839),(39796,2839),(39797,2839),(39798,2840),(39799,2840),(39800,2840),(39801,2840),(39802,2841),(39803,2841),(39804,2841),(39805,2841),(39806,2842),(39807,2842),(39808,2842),(39809,2842),(39810,2843),(39811,2843),(39812,2843),(39813,2843),(39814,2844),(39815,2844),(39816,2844),(39817,2844),(39818,2845),(39819,2845),(39820,2845),(39821,2845),(39822,2846),(39823,2846),(39824,2846),(39825,2846),(39826,2847),(39827,2847),(39828,2847),(39829,2847),(39830,2848),(39831,2848),(39832,2848),(39833,2848),(39834,2849),(39835,2849),(39836,2849),(39837,2849),(39838,2850),(39839,2850),(39840,2850),(39841,2850),(39842,2851),(39843,2851),(39844,2851),(39845,2851),(39846,2852),(39847,2852),(39848,2852),(39849,2852),(39850,2853),(39851,2853),(39852,2853),(39853,2853),(39854,2854),(39855,2854),(39856,2854),(39857,2854),(39858,2855),(39859,2855),(39860,2855),(39861,2855),(39862,2856),(39863,2856),(39864,2856),(39865,2856),(39866,2857),(39867,2857),(39868,2857),(39869,2857),(39870,2858),(39871,2858),(39872,2858),(39873,2858),(39874,2859),(39875,2859),(39876,2859),(39877,2859),(39878,2860),(39879,2860),(39880,2860),(39881,2860),(39882,2861),(39883,2861),(39884,2861),(39885,2861),(39886,2862),(39887,2862),(39888,2862),(39889,2862),(39890,2863),(39891,2863),(39892,2863),(39893,2863),(39894,2864),(39895,2864),(39896,2864),(39897,2864),(39898,2865),(39899,2865),(39900,2865),(39901,2865),(39902,2866),(39903,2866),(39904,2866),(39905,2866),(39906,2867),(39907,2867),(39908,2867),(39909,2867),(39910,2868),(39911,2868),(39912,2868),(39913,2868),(39914,2869),(39915,2869),(39916,2869),(39917,2869),(39918,2870),(39919,2870),(39920,2870),(39921,2870),(39922,2871),(39923,2871),(39924,2871),(39925,2871),(39926,2872),(39927,2872),(39928,2872),(39929,2872),(39930,2873),(39931,2873),(39932,2873),(39933,2873),(39934,2874),(39935,2874),(39936,2874),(39937,2874),(39938,2875),(39939,2875),(39940,2875),(39941,2875),(39942,2876),(39943,2876),(39944,2876),(39945,2876),(39946,2877),(39947,2877),(39948,2877),(39949,2877),(39950,2878),(39951,2878),(39952,2878),(39953,2878),(39954,2879),(39955,2879),(39956,2879),(39957,2879),(39958,2880),(39959,2880),(39960,2880),(39961,2880),(39962,2881),(39963,2881),(39964,2881),(39965,2881),(39966,2882),(39967,2882),(39968,2882),(39969,2882),(39970,2883),(39971,2883),(39972,2883),(39973,2883),(39974,2884),(39975,2884),(39976,2884),(39977,2884),(39978,2885),(39979,2885),(39980,2885),(39981,2885),(39982,2886),(39983,2886),(39984,2886),(39985,2886),(39986,2887),(39987,2887),(39988,2887),(39989,2887),(39990,2888),(39991,2888),(39992,2888),(39993,2888),(39994,2889),(39995,2889),(39996,2889),(39997,2889),(39998,2890),(39999,2890),(40000,2890),(40001,2890),(40002,2891),(40003,2891),(40004,2891),(40005,2891),(40006,2892),(40007,2892),(40008,2892),(40009,2892),(40010,2893),(40011,2893),(40012,2893),(40013,2893),(40014,2894),(40015,2894),(40016,2894),(40017,2894),(40018,2895),(40019,2895),(40020,2895),(40021,2895),(40022,2896),(40023,2896),(40024,2896),(40025,2896),(40026,2897),(40027,2897),(40028,2897),(40029,2897),(40030,2898),(40031,2898),(40032,2898),(40033,2898),(40034,2899),(40035,2899),(40036,2899),(40037,2899),(40038,2900),(40039,2900),(40040,2900),(40041,2900),(40042,2901),(40043,2901),(40044,2901),(40045,2901),(40046,2902),(40047,2902),(40048,2902),(40049,2902),(40050,2903),(40051,2903),(40052,2903),(40053,2903),(40054,2904),(40055,2904),(40056,2904),(40057,2904),(40058,2905),(40059,2905),(40060,2905),(40061,2905),(40062,2906),(40063,2906),(40064,2906),(40065,2906),(40066,2907),(40067,2907),(40068,2907),(40069,2907),(40070,2908),(40071,2908),(40072,2908),(40073,2908),(40074,2909),(40075,2909),(40076,2909),(40077,2909),(40078,2910),(40079,2910),(40080,2910),(40081,2910),(40082,2911),(40083,2911),(40084,2911),(40085,2911),(40086,2912),(40087,2912),(40088,2912),(40089,2912),(40090,2913),(40091,2913),(40092,2913),(40093,2913),(40094,2914),(40095,2914),(40096,2914),(40097,2914),(40098,2915),(40099,2915),(40100,2915),(40101,2915),(40102,2916),(40103,2916),(40104,2916),(40105,2916),(40106,2917),(40107,2917),(40108,2917),(40109,2917),(40110,2918),(40111,2918),(40112,2918),(40113,2918),(40114,2919),(40115,2919),(40116,2919),(40117,2919),(40118,2920),(40119,2920),(40120,2920),(40121,2920),(40122,2921),(40123,2921),(40124,2921),(40125,2921),(40126,2922),(40127,2922),(40128,2922),(40129,2922),(40130,2922),(40131,2922),(40132,2923),(40133,2923),(40134,2923),(40135,2923),(40136,2923),(40137,2923),(40138,2924),(40139,2924),(40140,2924),(40141,2924),(40142,2924),(40143,2924),(40144,2925),(40145,2925),(40146,2925),(40147,2925),(40148,2925),(40149,2925),(40150,2926),(40151,2926),(40152,2926),(40153,2926),(40154,2926),(40155,2926),(40156,2927),(40157,2927),(40158,2927),(40159,2927),(40160,2927),(40161,2927),(40162,2928),(40163,2928),(40164,2928),(40165,2928),(40166,2928),(40167,2928),(40168,2929),(40169,2929),(40170,2929),(40171,2929),(40172,2929),(40173,2929),(40174,2930),(40175,2930),(40176,2930),(40177,2930),(40178,2930),(40179,2930),(40180,2931),(40181,2931),(40182,2931),(40183,2931),(40184,2931),(40185,2931),(40186,2932),(40187,2932),(40188,2932),(40189,2932),(40190,2932),(40191,2932),(40192,2933),(40193,2933),(40194,2933),(40195,2933),(40196,2933),(40197,2933),(40198,2934),(40199,2934),(40200,2934),(40201,2934),(40202,2934),(40203,2934),(40204,2935),(40205,2935),(40206,2935),(40207,2935),(40208,2935),(40209,2935),(40210,2936),(40211,2936),(40212,2936),(40213,2936),(40214,2936),(40215,2936),(40216,2937),(40217,2937),(40218,2937),(40219,2937),(40220,2937),(40221,2937),(40222,2938),(40223,2938),(40224,2938),(40225,2938),(40226,2938),(40227,2938),(40228,2939),(40229,2939),(40230,2939),(40231,2939),(40232,2939),(40233,2939),(40234,2940),(40235,2940),(40236,2940),(40237,2940),(40238,2940),(40239,2940),(40240,2941),(40241,2941),(40242,2941),(40243,2941),(40244,2941),(40245,2941),(40246,2942),(40247,2942),(40248,2942),(40249,2942),(40250,2942),(40251,2942),(40252,2943),(40253,2943),(40254,2943),(40255,2943),(40256,2943),(40257,2943),(40258,2944),(40259,2944),(40260,2944),(40261,2944),(40262,2944),(40263,2944),(40264,2945),(40265,2945),(40266,2945),(40267,2945),(40268,2945),(40269,2945),(40270,2946),(40271,2946),(40272,2946),(40273,2946),(40274,2946),(40275,2946),(40276,2947),(40277,2947),(40278,2947),(40279,2947),(40280,2947),(40281,2947),(40282,2948),(40283,2948),(40284,2948),(40285,2948),(40286,2948),(40287,2948),(40288,2949),(40289,2949),(40290,2949),(40291,2949),(40292,2949),(40293,2949),(40294,2950),(40295,2950),(40296,2950),(40297,2950),(40298,2950),(40299,2950),(40300,2951),(40301,2951),(40302,2951),(40303,2951),(40304,2951),(40305,2951),(40306,2952),(40307,2952),(40308,2952),(40309,2952),(40310,2952),(40311,2952),(40312,2953),(40313,2953),(40314,2953),(40315,2953),(40316,2953),(40317,2953),(40318,2954),(40319,2954),(40320,2954),(40321,2954),(40322,2954),(40323,2954),(40324,2955),(40325,2955),(40326,2955),(40327,2955),(40328,2955),(40329,2955),(40330,2956),(40331,2956),(40332,2956),(40333,2956),(40334,2956),(40335,2956),(40336,2957),(40337,2957),(40338,2957),(40339,2957),(40340,2957),(40341,2957),(40342,2958),(40343,2958),(40344,2958),(40345,2958),(40346,2958),(40347,2958),(40348,2959),(40349,2959),(40350,2959),(40351,2959),(40352,2959),(40353,2959),(40354,2960),(40355,2960),(40356,2960),(40357,2960),(40358,2960),(40359,2960),(40360,2961),(40361,2961),(40362,2961),(40363,2961),(40364,2961),(40365,2961),(40366,2962),(40367,2962),(40368,2962),(40369,2962),(40370,2962),(40371,2962),(40372,2963),(40373,2963),(40374,2963),(40375,2963),(40376,2964),(40377,2964),(40378,2964),(40379,2964),(40380,2965),(40381,2965),(40382,2965),(40383,2965),(40384,2966),(40385,2966),(40386,2966),(40387,2966),(40388,2967),(40389,2967),(40390,2967),(40391,2967),(40392,2968),(40393,2968),(40394,2968),(40395,2968),(40396,2969),(40397,2969),(40398,2969),(40399,2969),(40400,2969),(40401,2969),(40402,2970),(40403,2970),(40404,2970),(40405,2970),(40406,2970),(40407,2970),(40408,2971),(40409,2971),(40410,2971),(40411,2971),(40412,2971),(40413,2971),(40414,2972),(40415,2972),(40416,2972),(40417,2972),(40418,2972),(40419,2972),(40420,2973),(40421,2973),(40422,2973),(40423,2973),(40424,2973),(40425,2973),(40426,2974),(40427,2974),(40428,2974),(40429,2974),(40430,2974),(40431,2974),(40432,2975),(40433,2975),(40434,2975),(40435,2975),(40436,2975),(40437,2975),(40438,2976),(40439,2976),(40440,2976),(40441,2976),(40442,2976),(40443,2976),(40444,2977),(40445,2977),(40446,2977),(40447,2977),(40448,2977),(40449,2977),(40450,2978),(40451,2978),(40452,2978),(40453,2978),(40454,2978),(40455,2978),(40456,2979),(40457,2979),(40458,2979),(40459,2979),(40460,2979),(40461,2979),(40462,2980),(40463,2980),(40464,2980),(40465,2980),(40466,2980),(40467,2980),(40468,2981),(40469,2981),(40470,2981),(40471,2981),(40472,2982),(40473,2982),(40474,2982),(40475,2982),(40476,2983),(40477,2983),(40478,2983),(40479,2983),(40480,2984),(40481,2984),(40482,2984),(40483,2984),(40484,2985),(40485,2985),(40486,2985),(40487,2985),(40488,2986),(40489,2986),(40490,2986),(40491,2986),(40492,2987),(40493,2987),(40494,2987),(40495,2987),(40496,2987),(40497,2987),(40498,2988),(40499,2988),(40500,2988),(40501,2988),(40502,2988),(40503,2988),(40504,2989),(40505,2989),(40506,2989),(40507,2989),(40508,2989),(40509,2989),(40510,2990),(40511,2990),(40512,2990),(40513,2990),(40514,2990),(40515,2990),(40516,2991),(40517,2991),(40518,2991),(40519,2991),(40520,2991),(40521,2991),(40522,2992),(40523,2992),(40524,2992),(40525,2992),(40526,2992),(40527,2992),(40528,2993),(40529,2993),(40530,2993),(40531,2993),(40532,2993),(40533,2993),(40534,2994),(40535,2994),(40536,2994),(40537,2994),(40538,2994),(40539,2994),(40540,2995),(40541,2995),(40542,2995),(40543,2995),(40544,2995),(40545,2995),(40546,2996),(40547,2996),(40548,2996),(40549,2996),(40550,2996),(40551,2996),(40552,2997),(40553,2997),(40554,2997),(40555,2997),(40556,2997),(40557,2997),(40558,2998),(40559,2998),(40560,2998),(40561,2998),(40562,2998),(40563,2998),(40564,2999),(40565,2999),(40566,2999),(40567,2999),(40568,2999),(40569,2999),(40570,3000),(40571,3000),(40572,3000),(40573,3000),(40574,3000),(40575,3000),(40576,3001),(40577,3001),(40578,3001),(40579,3001),(40580,3001),(40581,3001),(40582,3002),(40583,3002),(40584,3002),(40585,3002),(40586,3002),(40587,3002),(40588,3003),(40589,3003),(40590,3003),(40591,3003),(40592,3003),(40593,3003),(40594,3004),(40595,3004),(40596,3004),(40597,3004),(40598,3004),(40599,3004),(40600,3005),(40601,3005),(40602,3005),(40603,3005),(40604,3005),(40605,3005),(40606,3006),(40607,3006),(40608,3006),(40609,3006),(40610,3006),(40611,3006),(40612,3007),(40613,3007),(40614,3007),(40615,3007),(40616,3007),(40617,3007),(40618,3008),(40619,3008),(40620,3008),(40621,3008),(40622,3008),(40623,3008),(40624,3009),(40625,3009),(40626,3009),(40627,3009),(40628,3009),(40629,3009),(40630,3010),(40631,3010),(40632,3010),(40633,3010),(40634,3010),(40635,3010),(40636,3011),(40637,3011),(40638,3011),(40639,3011),(40640,3011),(40641,3011),(40642,3012),(40643,3012),(40644,3012),(40645,3012),(40646,3012),(40647,3012),(40648,3013),(40649,3013),(40650,3013),(40651,3013),(40652,3013),(40653,3013),(40654,3014),(40655,3014),(40656,3014),(40657,3014),(40658,3014),(40659,3014),(40660,3015),(40661,3015),(40662,3015),(40663,3015),(40664,3015),(40665,3015),(40666,3016),(40667,3016),(40668,3016),(40669,3016),(40670,3016),(40671,3016),(40672,3017),(40673,3017),(40674,3017),(40675,3017),(40676,3017),(40677,3017),(40678,3018),(40679,3018),(40680,3018),(40681,3018),(40682,3018),(40683,3018),(40684,3019),(40685,3019),(40686,3019),(40687,3019),(40688,3019),(40689,3019),(40690,3020),(40691,3020),(40692,3020),(40693,3020),(40694,3020),(40695,3020),(40696,3021),(40697,3021),(40698,3021),(40699,3021),(40700,3021),(40701,3021),(40702,2922),(40703,2922),(40704,2922),(40705,2923),(40706,2923),(40707,2923),(40708,2924),(40709,2924),(40710,2924),(40711,2925),(40712,2925),(40713,2925),(40714,2926),(40715,2926),(40716,2926),(40717,2927),(40718,2927),(40719,2927),(40720,2928),(40721,2928),(40722,2928),(40723,2929),(40724,2929),(40725,2929),(40726,2930),(40727,2930),(40728,2930),(40729,2931),(40730,2931),(40731,2931),(40732,2932),(40733,2932),(40734,2932),(40735,2933),(40736,2933),(40737,2933),(40738,2934),(40739,2934),(40740,2934),(40741,2935),(40742,2935),(40743,2935),(40744,2936),(40745,2936),(40746,2936),(40747,2937),(40748,2937),(40749,2937),(40750,2938),(40751,2938),(40752,2938),(40753,2939),(40754,2939),(40755,2939),(40756,2940),(40757,2940),(40758,2940),(40759,2941),(40760,2941),(40761,2941),(40762,2942),(40763,2942),(40764,2942),(40765,2943),(40766,2943),(40767,2943),(40768,2944),(40769,2944),(40770,2944),(40771,2945),(40772,2945),(40773,2945),(40774,2946),(40775,2946),(40776,2946),(40777,2947),(40778,2947),(40779,2947),(40780,2948),(40781,2948),(40782,2948),(40783,2949),(40784,2949),(40785,2949),(40786,2950),(40787,2950),(40788,2950),(40789,2951),(40790,2951),(40791,2951),(40792,2952),(40793,2952),(40794,2952),(40795,2953),(40796,2953),(40797,2953),(40798,2954),(40799,2954),(40800,2954),(40801,2955),(40802,2955),(40803,2955),(40804,2956),(40805,2956),(40806,2956),(40807,2957),(40808,2957),(40809,2957),(40810,2958),(40811,2958),(40812,2958),(40813,2959),(40814,2959),(40815,2959),(40816,2960),(40817,2960),(40818,2960),(40819,2961),(40820,2961),(40821,2961),(40822,2962),(40823,2962),(40824,2962),(40825,2963),(40826,2963),(40827,2963),(40828,2964),(40829,2964),(40830,2964),(40831,2965),(40832,2965),(40833,2965),(40834,2966),(40835,2966),(40836,2966),(40837,2967),(40838,2967),(40839,2967),(40840,2968),(40841,2968),(40842,2968),(40843,2969),(40844,2969),(40845,2969),(40846,2970),(40847,2970),(40848,2970),(40849,2971),(40850,2971),(40851,2971),(40852,2972),(40853,2972),(40854,2972),(40855,2973),(40856,2973),(40857,2973),(40858,2974),(40859,2974),(40860,2974),(40861,2975),(40862,2975),(40863,2975),(40864,2976),(40865,2976),(40866,2976),(40867,2977),(40868,2977),(40869,2977),(40870,2978),(40871,2978),(40872,2978),(40873,2979),(40874,2979),(40875,2979),(40876,2980),(40877,2980),(40878,2980),(40879,2981),(40880,2981),(40881,2981),(40882,2982),(40883,2982),(40884,2982),(40885,2983),(40886,2983),(40887,2983),(40888,2984),(40889,2984),(40890,2984),(40891,2985),(40892,2985),(40893,2985),(40894,2986),(40895,2986),(40896,2986),(40897,2987),(40898,2987),(40899,2987),(40900,2988),(40901,2988),(40902,2988),(40903,2989),(40904,2989),(40905,2989),(40906,2990),(40907,2990),(40908,2990),(40909,2991),(40910,2991),(40911,2991),(40912,2992),(40913,2992),(40914,2992),(40915,2993),(40916,2993),(40917,2993),(40918,2994),(40919,2994),(40920,2994),(40921,2995),(40922,2995),(40923,2995),(40924,2996),(40925,2996),(40926,2996),(40927,2997),(40928,2997),(40929,2997),(40930,2998),(40931,2998),(40932,2998),(40933,2999),(40934,2999),(40935,2999),(40936,3000),(40937,3000),(40938,3000),(40939,3001),(40940,3001),(40941,3001),(40942,3002),(40943,3002),(40944,3002),(40945,3003),(40946,3003),(40947,3003),(40948,3004),(40949,3004),(40950,3004),(40951,3005),(40952,3005),(40953,3005),(40954,3006),(40955,3006),(40956,3006),(40957,3007),(40958,3007),(40959,3007),(40960,3008),(40961,3008),(40962,3008),(40963,3009),(40964,3009),(40965,3009),(40966,3010),(40967,3010),(40968,3010),(40969,3011),(40970,3011),(40971,3011),(40972,3012),(40973,3012),(40974,3012),(40975,3013),(40976,3013),(40977,3013),(40978,3014),(40979,3014),(40980,3014),(40981,3015),(40982,3015),(40983,3015),(40984,3016),(40985,3016),(40986,3016),(40987,3017),(40988,3017),(40989,3017),(40990,3018),(40991,3018),(40992,3018),(40993,3019),(40994,3019),(40995,3019),(40996,3020),(40997,3020),(40998,3020),(40999,3021),(41000,3021),(41001,3021),(41002,2922),(41003,2922),(41004,2922),(41005,2922),(41006,2923),(41007,2923),(41008,2923),(41009,2923),(41010,2924),(41011,2924),(41012,2924),(41013,2924),(41014,2925),(41015,2925),(41016,2925),(41017,2925),(41018,2926),(41019,2926),(41020,2926),(41021,2926),(41022,2927),(41023,2927),(41024,2927),(41025,2927),(41026,2928),(41027,2928),(41028,2928),(41029,2928),(41030,2929),(41031,2929),(41032,2929),(41033,2929),(41034,2930),(41035,2930),(41036,2930),(41037,2930),(41038,2931),(41039,2931),(41040,2931),(41041,2931),(41042,2932),(41043,2932),(41044,2932),(41045,2932),(41046,2933),(41047,2933),(41048,2933),(41049,2933),(41050,2934),(41051,2934),(41052,2934),(41053,2934),(41054,2935),(41055,2935),(41056,2935),(41057,2935),(41058,2936),(41059,2936),(41060,2936),(41061,2936),(41062,2937),(41063,2937),(41064,2937),(41065,2937),(41066,2938),(41067,2938),(41068,2938),(41069,2938),(41070,2939),(41071,2939),(41072,2939),(41073,2939),(41074,2940),(41075,2940),(41076,2940),(41077,2940),(41078,2941),(41079,2941),(41080,2941),(41081,2941),(41082,2942),(41083,2942),(41084,2942),(41085,2942),(41086,2943),(41087,2943),(41088,2943),(41089,2943),(41090,2944),(41091,2944),(41092,2944),(41093,2944),(41094,2945),(41095,2945),(41096,2945),(41097,2945),(41098,2946),(41099,2946),(41100,2946),(41101,2946),(41102,2947),(41103,2947),(41104,2947),(41105,2947),(41106,2948),(41107,2948),(41108,2948),(41109,2948),(41110,2949),(41111,2949),(41112,2949),(41113,2949),(41114,2950),(41115,2950),(41116,2950),(41117,2950),(41118,2951),(41119,2951),(41120,2951),(41121,2951),(41122,2952),(41123,2952),(41124,2952),(41125,2952),(41126,2953),(41127,2953),(41128,2953),(41129,2953),(41130,2954),(41131,2954),(41132,2954),(41133,2954),(41134,2955),(41135,2955),(41136,2955),(41137,2955),(41138,2956),(41139,2956),(41140,2956),(41141,2956),(41142,2957),(41143,2957),(41144,2957),(41145,2957),(41146,2958),(41147,2958),(41148,2958),(41149,2958),(41150,2959),(41151,2959),(41152,2959),(41153,2959),(41154,2960),(41155,2960),(41156,2960),(41157,2960),(41158,2961),(41159,2961),(41160,2961),(41161,2961),(41162,2962),(41163,2962),(41164,2962),(41165,2962),(41166,2963),(41167,2963),(41168,2963),(41169,2963),(41170,2964),(41171,2964),(41172,2964),(41173,2964),(41174,2965),(41175,2965),(41176,2965),(41177,2965),(41178,2966),(41179,2966),(41180,2966),(41181,2966),(41182,2967),(41183,2967),(41184,2967),(41185,2967),(41186,2968),(41187,2968),(41188,2968),(41189,2968),(41190,2969),(41191,2969),(41192,2969),(41193,2969),(41194,2970),(41195,2970),(41196,2970),(41197,2970),(41198,2971),(41199,2971),(41200,2971),(41201,2971),(41202,2972),(41203,2972),(41204,2972),(41205,2972),(41206,2973),(41207,2973),(41208,2973),(41209,2973),(41210,2974),(41211,2974),(41212,2974),(41213,2974),(41214,2975),(41215,2975),(41216,2975),(41217,2975),(41218,2976),(41219,2976),(41220,2976),(41221,2976),(41222,2977),(41223,2977),(41224,2977),(41225,2977),(41226,2978),(41227,2978),(41228,2978),(41229,2978),(41230,2979),(41231,2979),(41232,2979),(41233,2979),(41234,2980),(41235,2980),(41236,2980),(41237,2980),(41238,2981),(41239,2981),(41240,2981),(41241,2981),(41242,2982),(41243,2982),(41244,2982),(41245,2982),(41246,2983),(41247,2983),(41248,2983),(41249,2983),(41250,2984),(41251,2984),(41252,2984),(41253,2984),(41254,2985),(41255,2985),(41256,2985),(41257,2985),(41258,2986),(41259,2986),(41260,2986),(41261,2986),(41262,2987),(41263,2987),(41264,2987),(41265,2987),(41266,2988),(41267,2988),(41268,2988),(41269,2988),(41270,2989),(41271,2989),(41272,2989),(41273,2989),(41274,2990),(41275,2990),(41276,2990),(41277,2990),(41278,2991),(41279,2991),(41280,2991),(41281,2991),(41282,2992),(41283,2992),(41284,2992),(41285,2992),(41286,2993),(41287,2993),(41288,2993),(41289,2993),(41290,2994),(41291,2994),(41292,2994),(41293,2994),(41294,2995),(41295,2995),(41296,2995),(41297,2995),(41298,2996),(41299,2996),(41300,2996),(41301,2996),(41302,2997),(41303,2997),(41304,2997),(41305,2997),(41306,2998),(41307,2998),(41308,2998),(41309,2998),(41310,2999),(41311,2999),(41312,2999),(41313,2999),(41314,3000),(41315,3000),(41316,3000),(41317,3000),(41318,3001),(41319,3001),(41320,3001),(41321,3001),(41322,3002),(41323,3002),(41324,3002),(41325,3002),(41326,3003),(41327,3003),(41328,3003),(41329,3003),(41330,3004),(41331,3004),(41332,3004),(41333,3004),(41334,3005),(41335,3005),(41336,3005),(41337,3005),(41338,3006),(41339,3006),(41340,3006),(41341,3006),(41342,3007),(41343,3007),(41344,3007),(41345,3007),(41346,3008),(41347,3008),(41348,3008),(41349,3008),(41350,3009),(41351,3009),(41352,3009),(41353,3009),(41354,3010),(41355,3010),(41356,3010),(41357,3010),(41358,3011),(41359,3011),(41360,3011),(41361,3011),(41362,3012),(41363,3012),(41364,3012),(41365,3012),(41366,3013),(41367,3013),(41368,3013),(41369,3013),(41370,3014),(41371,3014),(41372,3014),(41373,3014),(41374,3015),(41375,3015),(41376,3015),(41377,3015),(41378,3016),(41379,3016),(41380,3016),(41381,3016),(41382,3017),(41383,3017),(41384,3017),(41385,3017),(41386,3018),(41387,3018),(41388,3018),(41389,3018),(41390,3019),(41391,3019),(41392,3019),(41393,3019),(41394,3020),(41395,3020),(41396,3020),(41397,3020),(41398,3021),(41399,3021),(41400,3021),(41401,3021),(41402,3022),(41403,3022),(41404,3022),(41405,3022),(41406,3022),(41407,3022),(41408,3023),(41409,3023),(41410,3023),(41411,3023),(41412,3023),(41413,3023),(41414,3024),(41415,3024),(41416,3024),(41417,3024),(41418,3024),(41419,3024),(41420,3025),(41421,3025),(41422,3025),(41423,3025),(41424,3025),(41425,3025),(41426,3026),(41427,3026),(41428,3026),(41429,3026),(41430,3026),(41431,3026),(41432,3027),(41433,3027),(41434,3027),(41435,3027),(41436,3027),(41437,3027),(41438,3028),(41439,3028),(41440,3028),(41441,3028),(41442,3028),(41443,3028),(41444,3029),(41445,3029),(41446,3029),(41447,3029),(41448,3029),(41449,3029),(41450,3030),(41451,3030),(41452,3030),(41453,3030),(41454,3030),(41455,3030),(41456,3031),(41457,3031),(41458,3031),(41459,3031),(41460,3031),(41461,3031),(41462,3032),(41463,3032),(41464,3032),(41465,3032),(41466,3032),(41467,3032),(41468,3033),(41469,3033),(41470,3033),(41471,3033),(41472,3033),(41473,3033),(41474,3034),(41475,3034),(41476,3034),(41477,3034),(41478,3034),(41479,3034),(41480,3035),(41481,3035),(41482,3035),(41483,3035),(41484,3035),(41485,3035),(41486,3036),(41487,3036),(41488,3036),(41489,3036),(41490,3036),(41491,3036),(41492,3037),(41493,3037),(41494,3037),(41495,3037),(41496,3037),(41497,3037),(41498,3038),(41499,3038),(41500,3038),(41501,3038),(41502,3039),(41503,3039),(41504,3039),(41505,3039),(41506,3040),(41507,3040),(41508,3040),(41509,3040),(41510,3041),(41511,3041),(41512,3041),(41513,3041),(41514,3042),(41515,3042),(41516,3042),(41517,3042),(41518,3042),(41519,3042),(41520,3043),(41521,3043),(41522,3043),(41523,3043),(41524,3043),(41525,3043),(41526,3044),(41527,3044),(41528,3044),(41529,3044),(41530,3045),(41531,3045),(41532,3045),(41533,3045),(41534,3046),(41535,3046),(41536,3046),(41537,3046),(41538,3047),(41539,3047),(41540,3047),(41541,3047),(41542,3048),(41543,3048),(41544,3048),(41545,3048),(41546,3048),(41547,3048),(41548,3049),(41549,3049),(41550,3049),(41551,3049),(41552,3049),(41553,3049),(41554,3050),(41555,3050),(41556,3050),(41557,3050),(41558,3050),(41559,3050),(41560,3051),(41561,3051),(41562,3051),(41563,3051),(41564,3051),(41565,3051),(41566,3052),(41567,3052),(41568,3052),(41569,3052),(41570,3052),(41571,3052),(41572,3053),(41573,3053),(41574,3053),(41575,3053),(41576,3053),(41577,3053),(41578,3054),(41579,3054),(41580,3054),(41581,3054),(41582,3054),(41583,3054),(41584,3055),(41585,3055),(41586,3055),(41587,3055),(41588,3055),(41589,3055),(41590,3056),(41591,3056),(41592,3056),(41593,3056),(41594,3057),(41595,3057),(41596,3057),(41597,3057),(41598,3058),(41599,3058),(41600,3058),(41601,3058),(41602,3059),(41603,3059),(41604,3059),(41605,3059),(41606,3060),(41607,3060),(41608,3060),(41609,3060),(41610,3061),(41611,3061),(41612,3061),(41613,3061),(41614,3062),(41615,3062),(41616,3062),(41617,3062),(41618,3063),(41619,3063),(41620,3063),(41621,3063),(41622,3064),(41623,3064),(41624,3064),(41625,3064),(41626,3065),(41627,3065),(41628,3065),(41629,3065),(41630,3065),(41631,3065),(41632,3066),(41633,3066),(41634,3066),(41635,3066),(41636,3066),(41637,3066),(41638,3067),(41639,3067),(41640,3067),(41641,3067),(41642,3067),(41643,3067),(41644,3068),(41645,3068),(41646,3068),(41647,3068),(41648,3068),(41649,3068),(41650,3069),(41651,3069),(41652,3069),(41653,3069),(41654,3069),(41655,3069),(41656,3070),(41657,3070),(41658,3070),(41659,3070),(41660,3070),(41661,3070),(41662,3071),(41663,3071),(41664,3071),(41665,3071),(41666,3071),(41667,3071),(41668,3072),(41669,3072),(41670,3072),(41671,3072),(41672,3072),(41673,3072),(41674,3073),(41675,3073),(41676,3073),(41677,3073),(41678,3073),(41679,3073),(41680,3074),(41681,3074),(41682,3074),(41683,3074),(41684,3074),(41685,3074),(41686,3075),(41687,3075),(41688,3075),(41689,3075),(41690,3075),(41691,3075),(41692,3076),(41693,3076),(41694,3076),(41695,3076),(41696,3076),(41697,3076),(41698,3077),(41699,3077),(41700,3077),(41701,3077),(41702,3077),(41703,3077),(41704,3078),(41705,3078),(41706,3078),(41707,3078),(41708,3078),(41709,3078),(41710,3079),(41711,3079),(41712,3079),(41713,3079),(41714,3079),(41715,3079),(41716,3080),(41717,3080),(41718,3080),(41719,3080),(41720,3080),(41721,3080),(41722,3081),(41723,3081),(41724,3081),(41725,3081),(41726,3081),(41727,3081),(41728,3082),(41729,3082),(41730,3082),(41731,3082),(41732,3082),(41733,3082),(41734,3083),(41735,3083),(41736,3083),(41737,3083),(41738,3083),(41739,3083),(41740,3084),(41741,3084),(41742,3084),(41743,3084),(41744,3084),(41745,3084),(41746,3085),(41747,3085),(41748,3085),(41749,3085),(41750,3085),(41751,3085),(41752,3086),(41753,3086),(41754,3086),(41755,3086),(41756,3086),(41757,3086),(41758,3087),(41759,3087),(41760,3087),(41761,3087),(41762,3087),(41763,3087),(41764,3088),(41765,3088),(41766,3088),(41767,3088),(41768,3088),(41769,3088),(41770,3089),(41771,3089),(41772,3089),(41773,3089),(41774,3089),(41775,3089),(41776,3090),(41777,3090),(41778,3090),(41779,3090),(41780,3090),(41781,3090),(41782,3091),(41783,3091),(41784,3091),(41785,3091),(41786,3091),(41787,3091),(41788,3092),(41789,3092),(41790,3092),(41791,3092),(41792,3092),(41793,3092),(41794,3093),(41795,3093),(41796,3093),(41797,3093),(41798,3093),(41799,3093),(41800,3094),(41801,3094),(41802,3094),(41803,3094),(41804,3094),(41805,3094),(41806,3095),(41807,3095),(41808,3095),(41809,3095),(41810,3095),(41811,3095),(41812,3096),(41813,3096),(41814,3096),(41815,3096),(41816,3096),(41817,3096),(41818,3097),(41819,3097),(41820,3097),(41821,3097),(41822,3097),(41823,3097),(41824,3098),(41825,3098),(41826,3098),(41827,3098),(41828,3098),(41829,3098),(41830,3099),(41831,3099),(41832,3099),(41833,3099),(41834,3099),(41835,3099),(41836,3100),(41837,3100),(41838,3100),(41839,3100),(41840,3100),(41841,3100),(41842,3101),(41843,3101),(41844,3101),(41845,3101),(41846,3101),(41847,3101),(41848,3102),(41849,3102),(41850,3102),(41851,3102),(41852,3102),(41853,3102),(41854,3103),(41855,3103),(41856,3103),(41857,3103),(41858,3103),(41859,3103),(41860,3104),(41861,3104),(41862,3104),(41863,3104),(41864,3104),(41865,3104),(41866,3105),(41867,3105),(41868,3105),(41869,3105),(41870,3105),(41871,3105),(41872,3106),(41873,3106),(41874,3106),(41875,3106),(41876,3106),(41877,3106),(41878,3107),(41879,3107),(41880,3107),(41881,3107),(41882,3107),(41883,3107),(41884,3108),(41885,3108),(41886,3108),(41887,3108),(41888,3108),(41889,3108),(41890,3109),(41891,3109),(41892,3109),(41893,3109),(41894,3109),(41895,3109),(41896,3110),(41897,3110),(41898,3110),(41899,3110),(41900,3111),(41901,3111),(41902,3111),(41903,3111),(41904,3112),(41905,3112),(41906,3112),(41907,3112),(41908,3113),(41909,3113),(41910,3113),(41911,3113),(41912,3114),(41913,3114),(41914,3114),(41915,3114),(41916,3115),(41917,3115),(41918,3115),(41919,3115),(41920,3116),(41921,3116),(41922,3116),(41923,3116),(41924,3117),(41925,3117),(41926,3117),(41927,3117),(41928,3118),(41929,3118),(41930,3118),(41931,3118),(41932,3118),(41933,3118),(41934,3119),(41935,3119),(41936,3119),(41937,3119),(41938,3120),(41939,3120),(41940,3120),(41941,3120),(41942,3121),(41943,3121),(41944,3121),(41945,3121),(41946,3022),(41947,3022),(41948,3022),(41949,3023),(41950,3023),(41951,3023),(41952,3024),(41953,3024),(41954,3024),(41955,3025),(41956,3025),(41957,3025),(41958,3026),(41959,3026),(41960,3026),(41961,3027),(41962,3027),(41963,3027),(41964,3028),(41965,3028),(41966,3028),(41967,3029),(41968,3029),(41969,3029),(41970,3030),(41971,3030),(41972,3030),(41973,3031),(41974,3031),(41975,3031),(41976,3032),(41977,3032),(41978,3032),(41979,3033),(41980,3033),(41981,3033),(41982,3034),(41983,3034),(41984,3034),(41985,3035),(41986,3035),(41987,3035),(41988,3036),(41989,3036),(41990,3036),(41991,3037),(41992,3037),(41993,3037),(41994,3038),(41995,3038),(41996,3038),(41997,3039),(41998,3039),(41999,3039),(42000,3040),(42001,3040),(42002,3040),(42003,3041),(42004,3041),(42005,3041),(42006,3042),(42007,3042),(42008,3042),(42009,3043),(42010,3043),(42011,3043),(42012,3044),(42013,3044),(42014,3044),(42015,3045),(42016,3045),(42017,3045),(42018,3046),(42019,3046),(42020,3046),(42021,3047),(42022,3047),(42023,3047),(42024,3048),(42025,3048),(42026,3048),(42027,3049),(42028,3049),(42029,3049),(42030,3050),(42031,3050),(42032,3050),(42033,3051),(42034,3051),(42035,3051),(42036,3052),(42037,3052),(42038,3052),(42039,3053),(42040,3053),(42041,3053),(42042,3054),(42043,3054),(42044,3054),(42045,3055),(42046,3055),(42047,3055),(42048,3056),(42049,3056),(42050,3056),(42051,3057),(42052,3057),(42053,3057),(42054,3058),(42055,3058),(42056,3058),(42057,3059),(42058,3059),(42059,3059),(42060,3060),(42061,3060),(42062,3060),(42063,3061),(42064,3061),(42065,3061),(42066,3062),(42067,3062),(42068,3062),(42069,3063),(42070,3063),(42071,3063),(42072,3064),(42073,3064),(42074,3064),(42075,3065),(42076,3065),(42077,3065),(42078,3066),(42079,3066),(42080,3066),(42081,3067),(42082,3067),(42083,3067),(42084,3068),(42085,3068),(42086,3068),(42087,3069),(42088,3069),(42089,3069),(42090,3070),(42091,3070),(42092,3070),(42093,3071),(42094,3071),(42095,3071),(42096,3072),(42097,3072),(42098,3072),(42099,3073),(42100,3073),(42101,3073),(42102,3074),(42103,3074),(42104,3074),(42105,3075),(42106,3075),(42107,3075),(42108,3076),(42109,3076),(42110,3076),(42111,3077),(42112,3077),(42113,3077),(42114,3078),(42115,3078),(42116,3078),(42117,3079),(42118,3079),(42119,3079),(42120,3080),(42121,3080),(42122,3080),(42123,3081),(42124,3081),(42125,3081),(42126,3082),(42127,3082),(42128,3082),(42129,3083),(42130,3083),(42131,3083),(42132,3084),(42133,3084),(42134,3084),(42135,3085),(42136,3085),(42137,3085),(42138,3086),(42139,3086),(42140,3086),(42141,3087),(42142,3087),(42143,3087),(42144,3088),(42145,3088),(42146,3088),(42147,3089),(42148,3089),(42149,3089),(42150,3090),(42151,3090),(42152,3090),(42153,3091),(42154,3091),(42155,3091),(42156,3092),(42157,3092),(42158,3092),(42159,3093),(42160,3093),(42161,3093),(42162,3094),(42163,3094),(42164,3094),(42165,3095),(42166,3095),(42167,3095),(42168,3096),(42169,3096),(42170,3096),(42171,3097),(42172,3097),(42173,3097),(42174,3098),(42175,3098),(42176,3098),(42177,3099),(42178,3099),(42179,3099),(42180,3100),(42181,3100),(42182,3100),(42183,3101),(42184,3101),(42185,3101),(42186,3102),(42187,3102),(42188,3102),(42189,3103),(42190,3103),(42191,3103),(42192,3104),(42193,3104),(42194,3104),(42195,3105),(42196,3105),(42197,3105),(42198,3106),(42199,3106),(42200,3106),(42201,3107),(42202,3107),(42203,3107),(42204,3108),(42205,3108),(42206,3108),(42207,3109),(42208,3109),(42209,3109),(42210,3110),(42211,3110),(42212,3110),(42213,3111),(42214,3111),(42215,3111),(42216,3112),(42217,3112),(42218,3112),(42219,3113),(42220,3113),(42221,3113),(42222,3114),(42223,3114),(42224,3114),(42225,3115),(42226,3115),(42227,3115),(42228,3116),(42229,3116),(42230,3116),(42231,3117),(42232,3117),(42233,3117),(42234,3118),(42235,3118),(42236,3118),(42237,3119),(42238,3119),(42239,3119),(42240,3120),(42241,3120),(42242,3120),(42243,3121),(42244,3121),(42245,3121),(42246,3022),(42247,3022),(42248,3022),(42249,3022),(42250,3023),(42251,3023),(42252,3023),(42253,3023),(42254,3024),(42255,3024),(42256,3024),(42257,3024),(42258,3025),(42259,3025),(42260,3025),(42261,3025),(42262,3026),(42263,3026),(42264,3026),(42265,3026),(42266,3027),(42267,3027),(42268,3027),(42269,3027),(42270,3028),(42271,3028),(42272,3028),(42273,3028),(42274,3029),(42275,3029),(42276,3029),(42277,3029),(42278,3030),(42279,3030),(42280,3030),(42281,3030),(42282,3031),(42283,3031),(42284,3031),(42285,3031),(42286,3032),(42287,3032),(42288,3032),(42289,3032),(42290,3033),(42291,3033),(42292,3033),(42293,3033),(42294,3034),(42295,3034),(42296,3034),(42297,3034),(42298,3035),(42299,3035),(42300,3035),(42301,3035),(42302,3036),(42303,3036),(42304,3036),(42305,3036),(42306,3037),(42307,3037),(42308,3037),(42309,3037),(42310,3038),(42311,3038),(42312,3038),(42313,3038),(42314,3039),(42315,3039),(42316,3039),(42317,3039),(42318,3040),(42319,3040),(42320,3040),(42321,3040),(42322,3041),(42323,3041),(42324,3041),(42325,3041),(42326,3042),(42327,3042),(42328,3042),(42329,3042),(42330,3043),(42331,3043),(42332,3043),(42333,3043),(42334,3044),(42335,3044),(42336,3044),(42337,3044),(42338,3045),(42339,3045),(42340,3045),(42341,3045),(42342,3046),(42343,3046),(42344,3046),(42345,3046),(42346,3047),(42347,3047),(42348,3047),(42349,3047),(42350,3048),(42351,3048),(42352,3048),(42353,3048),(42354,3049),(42355,3049),(42356,3049),(42357,3049),(42358,3050),(42359,3050),(42360,3050),(42361,3050),(42362,3051),(42363,3051),(42364,3051),(42365,3051),(42366,3052),(42367,3052),(42368,3052),(42369,3052),(42370,3053),(42371,3053),(42372,3053),(42373,3053),(42374,3054),(42375,3054),(42376,3054),(42377,3054),(42378,3055),(42379,3055),(42380,3055),(42381,3055),(42382,3056),(42383,3056),(42384,3056),(42385,3056),(42386,3057),(42387,3057),(42388,3057),(42389,3057),(42390,3058),(42391,3058),(42392,3058),(42393,3058),(42394,3059),(42395,3059),(42396,3059),(42397,3059),(42398,3060),(42399,3060),(42400,3060),(42401,3060),(42402,3061),(42403,3061),(42404,3061),(42405,3061),(42406,3062),(42407,3062),(42408,3062),(42409,3062),(42410,3063),(42411,3063),(42412,3063),(42413,3063),(42414,3064),(42415,3064),(42416,3064),(42417,3064),(42418,3065),(42419,3065),(42420,3065),(42421,3065),(42422,3066),(42423,3066),(42424,3066),(42425,3066),(42426,3067),(42427,3067),(42428,3067),(42429,3067),(42430,3068),(42431,3068),(42432,3068),(42433,3068),(42434,3069),(42435,3069),(42436,3069),(42437,3069),(42438,3070),(42439,3070),(42440,3070),(42441,3070),(42442,3071),(42443,3071),(42444,3071),(42445,3071),(42446,3072),(42447,3072),(42448,3072),(42449,3072),(42450,3073),(42451,3073),(42452,3073),(42453,3073),(42454,3074),(42455,3074),(42456,3074),(42457,3074),(42458,3075),(42459,3075),(42460,3075),(42461,3075),(42462,3076),(42463,3076),(42464,3076),(42465,3076),(42466,3077),(42467,3077),(42468,3077),(42469,3077),(42470,3078),(42471,3078),(42472,3078),(42473,3078),(42474,3079),(42475,3079),(42476,3079),(42477,3079),(42478,3080),(42479,3080),(42480,3080),(42481,3080),(42482,3081),(42483,3081),(42484,3081),(42485,3081),(42486,3082),(42487,3082),(42488,3082),(42489,3082),(42490,3083),(42491,3083),(42492,3083),(42493,3083),(42494,3084),(42495,3084),(42496,3084),(42497,3084),(42498,3085),(42499,3085),(42500,3085),(42501,3085),(42502,3086),(42503,3086),(42504,3086),(42505,3086),(42506,3087),(42507,3087),(42508,3087),(42509,3087),(42510,3088),(42511,3088),(42512,3088),(42513,3088),(42514,3089),(42515,3089),(42516,3089),(42517,3089),(42518,3090),(42519,3090),(42520,3090),(42521,3090),(42522,3091),(42523,3091),(42524,3091),(42525,3091),(42526,3092),(42527,3092),(42528,3092),(42529,3092),(42530,3093),(42531,3093),(42532,3093),(42533,3093),(42534,3094),(42535,3094),(42536,3094),(42537,3094),(42538,3095),(42539,3095),(42540,3095),(42541,3095),(42542,3096),(42543,3096),(42544,3096),(42545,3096),(42546,3097),(42547,3097),(42548,3097),(42549,3097),(42550,3098),(42551,3098),(42552,3098),(42553,3098),(42554,3099),(42555,3099),(42556,3099),(42557,3099),(42558,3100),(42559,3100),(42560,3100),(42561,3100),(42562,3101),(42563,3101),(42564,3101),(42565,3101),(42566,3102),(42567,3102),(42568,3102),(42569,3102),(42570,3103),(42571,3103),(42572,3103),(42573,3103),(42574,3104),(42575,3104),(42576,3104),(42577,3104),(42578,3105),(42579,3105),(42580,3105),(42581,3105),(42582,3106),(42583,3106),(42584,3106),(42585,3106),(42586,3107),(42587,3107),(42588,3107),(42589,3107),(42590,3108),(42591,3108),(42592,3108),(42593,3108),(42594,3109),(42595,3109),(42596,3109),(42597,3109),(42598,3110),(42599,3110),(42600,3110),(42601,3110),(42602,3111),(42603,3111),(42604,3111),(42605,3111),(42606,3112),(42607,3112),(42608,3112),(42609,3112),(42610,3113),(42611,3113),(42612,3113),(42613,3113),(42614,3114),(42615,3114),(42616,3114),(42617,3114),(42618,3115),(42619,3115),(42620,3115),(42621,3115),(42622,3116),(42623,3116),(42624,3116),(42625,3116),(42626,3117),(42627,3117),(42628,3117),(42629,3117),(42630,3118),(42631,3118),(42632,3118),(42633,3118),(42634,3119),(42635,3119),(42636,3119),(42637,3119),(42638,3120),(42639,3120),(42640,3120),(42641,3120),(42642,3121),(42643,3121),(42644,3121),(42645,3121),(42646,3122),(42647,3122),(42648,3122),(42649,3122),(42650,3123),(42651,3123),(42652,3123),(42653,3123),(42654,3124),(42655,3124),(42656,3124),(42657,3124),(42658,3125),(42659,3125),(42660,3125),(42661,3125),(42662,3125),(42663,3125),(42664,3126),(42665,3126),(42666,3126),(42667,3126),(42668,3126),(42669,3126),(42670,3127),(42671,3127),(42672,3127),(42673,3127),(42674,3127),(42675,3127),(42676,3128),(42677,3128),(42678,3128),(42679,3128),(42680,3128),(42681,3128),(42682,3129),(42683,3129),(42684,3129),(42685,3129),(42686,3129),(42687,3129),(42688,3130),(42689,3130),(42690,3130),(42691,3130),(42692,3130),(42693,3130),(42694,3131),(42695,3131),(42696,3131),(42697,3131),(42698,3131),(42699,3131),(42700,3132),(42701,3132),(42702,3132),(42703,3132),(42704,3132),(42705,3132),(42706,3133),(42707,3133),(42708,3133),(42709,3133),(42710,3133),(42711,3133),(42712,3134),(42713,3134),(42714,3134),(42715,3134),(42716,3134),(42717,3134),(42718,3135),(42719,3135),(42720,3135),(42721,3135),(42722,3135),(42723,3135),(42724,3136),(42725,3136),(42726,3136),(42727,3136),(42728,3136),(42729,3136),(42730,3137),(42731,3137),(42732,3137),(42733,3137),(42734,3137),(42735,3137),(42736,3138),(42737,3138),(42738,3138),(42739,3138),(42740,3138),(42741,3138),(42742,3139),(42743,3139),(42744,3139),(42745,3139),(42746,3139),(42747,3139),(42748,3140),(42749,3140),(42750,3140),(42751,3140),(42752,3140),(42753,3140),(42754,3141),(42755,3141),(42756,3141),(42757,3141),(42758,3141),(42759,3141),(42760,3142),(42761,3142),(42762,3142),(42763,3142),(42764,3142),(42765,3142),(42766,3143),(42767,3143),(42768,3143),(42769,3143),(42770,3143),(42771,3143),(42772,3144),(42773,3144),(42774,3144),(42775,3144),(42776,3144),(42777,3144),(42778,3145),(42779,3145),(42780,3145),(42781,3145),(42782,3145),(42783,3145),(42784,3146),(42785,3146),(42786,3146),(42787,3146),(42788,3146),(42789,3146),(42790,3147),(42791,3147),(42792,3147),(42793,3147),(42794,3147),(42795,3147),(42796,3148),(42797,3148),(42798,3148),(42799,3148),(42800,3148),(42801,3148),(42802,3149),(42803,3149),(42804,3149),(42805,3149),(42806,3149),(42807,3149),(42808,3150),(42809,3150),(42810,3150),(42811,3150),(42812,3150),(42813,3150),(42814,3151),(42815,3151),(42816,3151),(42817,3151),(42818,3151),(42819,3151),(42820,3152),(42821,3152),(42822,3152),(42823,3152),(42824,3152),(42825,3152),(42826,3153),(42827,3153),(42828,3153),(42829,3153),(42830,3153),(42831,3153),(42832,3154),(42833,3154),(42834,3154),(42835,3154),(42836,3154),(42837,3154),(42838,3155),(42839,3155),(42840,3155),(42841,3155),(42842,3155),(42843,3155),(42844,3156),(42845,3156),(42846,3156),(42847,3156),(42848,3156),(42849,3156),(42850,3157),(42851,3157),(42852,3157),(42853,3157),(42854,3157),(42855,3157),(42856,3158),(42857,3158),(42858,3158),(42859,3158),(42860,3158),(42861,3158),(42862,3159),(42863,3159),(42864,3159),(42865,3159),(42866,3159),(42867,3159),(42868,3160),(42869,3160),(42870,3160),(42871,3160),(42872,3160),(42873,3160),(42874,3161),(42875,3161),(42876,3161),(42877,3161),(42878,3161),(42879,3161),(42880,3162),(42881,3162),(42882,3162),(42883,3162),(42884,3162),(42885,3162),(42886,3163),(42887,3163),(42888,3163),(42889,3163),(42890,3163),(42891,3163),(42892,3164),(42893,3164),(42894,3164),(42895,3164),(42896,3164),(42897,3164),(42898,3165),(42899,3165),(42900,3165),(42901,3165),(42902,3165),(42903,3165),(42904,3166),(42905,3166),(42906,3166),(42907,3166),(42908,3166),(42909,3166),(42910,3167),(42911,3167),(42912,3167),(42913,3167),(42914,3167),(42915,3167),(42916,3168),(42917,3168),(42918,3168),(42919,3168),(42920,3168),(42921,3168),(42922,3122),(42923,3122),(42924,3122),(42925,3123),(42926,3123),(42927,3123),(42928,3124),(42929,3124),(42930,3124),(42931,3125),(42932,3125),(42933,3125),(42934,3126),(42935,3126),(42936,3126),(42937,3127),(42938,3127),(42939,3127),(42940,3128),(42941,3128),(42942,3128),(42943,3129),(42944,3129),(42945,3129),(42946,3130),(42947,3130),(42948,3130),(42949,3131),(42950,3131),(42951,3131),(42952,3132),(42953,3132),(42954,3132),(42955,3133),(42956,3133),(42957,3133),(42958,3134),(42959,3134),(42960,3134),(42961,3135),(42962,3135),(42963,3135),(42964,3136),(42965,3136),(42966,3136),(42967,3137),(42968,3137),(42969,3137),(42970,3138),(42971,3138),(42972,3138),(42973,3139),(42974,3139),(42975,3139),(42976,3140),(42977,3140),(42978,3140),(42979,3141),(42980,3141),(42981,3141),(42982,3142),(42983,3142),(42984,3142),(42985,3143),(42986,3143),(42987,3143),(42988,3144),(42989,3144),(42990,3144),(42991,3145),(42992,3145),(42993,3145),(42994,3146),(42995,3146),(42996,3146),(42997,3147),(42998,3147),(42999,3147),(43000,3148),(43001,3148),(43002,3148),(43003,3149),(43004,3149),(43005,3149),(43006,3150),(43007,3150),(43008,3150),(43009,3151),(43010,3151),(43011,3151),(43012,3152),(43013,3152),(43014,3152),(43015,3153),(43016,3153),(43017,3153),(43018,3154),(43019,3154),(43020,3154),(43021,3155),(43022,3155),(43023,3155),(43024,3156),(43025,3156),(43026,3156),(43027,3157),(43028,3157),(43029,3157),(43030,3158),(43031,3158),(43032,3158),(43033,3159),(43034,3159),(43035,3159),(43036,3160),(43037,3160),(43038,3160),(43039,3161),(43040,3161),(43041,3161),(43042,3162),(43043,3162),(43044,3162),(43045,3163),(43046,3163),(43047,3163),(43048,3164),(43049,3164),(43050,3164),(43051,3165),(43052,3165),(43053,3165),(43054,3166),(43055,3166),(43056,3166),(43057,3167),(43058,3167),(43059,3167),(43060,3168),(43061,3168),(43062,3168),(43063,3122),(43064,3122),(43065,3122),(43066,3122),(43067,3123),(43068,3123),(43069,3123),(43070,3123),(43071,3124),(43072,3124),(43073,3124),(43074,3124),(43075,3125),(43076,3125),(43077,3125),(43078,3125),(43079,3126),(43080,3126),(43081,3126),(43082,3126),(43083,3127),(43084,3127),(43085,3127),(43086,3127),(43087,3128),(43088,3128),(43089,3128),(43090,3128),(43091,3129),(43092,3129),(43093,3129),(43094,3129),(43095,3130),(43096,3130),(43097,3130),(43098,3130),(43099,3131),(43100,3131),(43101,3131),(43102,3131),(43103,3132),(43104,3132),(43105,3132),(43106,3132),(43107,3133),(43108,3133),(43109,3133),(43110,3133),(43111,3134),(43112,3134),(43113,3134),(43114,3134),(43115,3135),(43116,3135),(43117,3135),(43118,3135),(43119,3136),(43120,3136),(43121,3136),(43122,3136),(43123,3137),(43124,3137),(43125,3137),(43126,3137),(43127,3138),(43128,3138),(43129,3138),(43130,3138),(43131,3139),(43132,3139),(43133,3139),(43134,3139),(43135,3140),(43136,3140),(43137,3140),(43138,3140),(43139,3141),(43140,3141),(43141,3141),(43142,3141),(43143,3142),(43144,3142),(43145,3142),(43146,3142),(43147,3143),(43148,3143),(43149,3143),(43150,3143),(43151,3144),(43152,3144),(43153,3144),(43154,3144),(43155,3145),(43156,3145),(43157,3145),(43158,3145),(43159,3146),(43160,3146),(43161,3146),(43162,3146),(43163,3147),(43164,3147),(43165,3147),(43166,3147),(43167,3148),(43168,3148),(43169,3148),(43170,3148),(43171,3149),(43172,3149),(43173,3149),(43174,3149),(43175,3150),(43176,3150),(43177,3150),(43178,3150),(43179,3151),(43180,3151),(43181,3151),(43182,3151),(43183,3152),(43184,3152),(43185,3152),(43186,3152),(43187,3153),(43188,3153),(43189,3153),(43190,3153),(43191,3154),(43192,3154),(43193,3154),(43194,3154),(43195,3155),(43196,3155),(43197,3155),(43198,3155),(43199,3156),(43200,3156),(43201,3156),(43202,3156),(43203,3157),(43204,3157),(43205,3157),(43206,3157),(43207,3158),(43208,3158),(43209,3158),(43210,3158),(43211,3159),(43212,3159),(43213,3159),(43214,3159),(43215,3160),(43216,3160),(43217,3160),(43218,3160),(43219,3161),(43220,3161),(43221,3161),(43222,3161),(43223,3162),(43224,3162),(43225,3162),(43226,3162),(43227,3163),(43228,3163),(43229,3163),(43230,3163),(43231,3164),(43232,3164),(43233,3164),(43234,3164),(43235,3165),(43236,3165),(43237,3165),(43238,3165),(43239,3166),(43240,3166),(43241,3166),(43242,3166),(43243,3167),(43244,3167),(43245,3167),(43246,3167),(43247,3168),(43248,3168),(43249,3168),(43250,3168),(43251,3169),(43252,3169),(43253,3169),(43254,3169),(43255,3169),(43256,3169),(43257,3170),(43258,3170),(43259,3170),(43260,3170),(43261,3170),(43262,3170),(43263,3171),(43264,3171),(43265,3171),(43266,3171),(43267,3171),(43268,3171),(43269,3172),(43270,3172),(43271,3172),(43272,3172),(43273,3172),(43274,3172),(43275,3173),(43276,3173),(43277,3173),(43278,3173),(43279,3173),(43280,3173),(43281,3174),(43282,3174),(43283,3174),(43284,3174),(43285,3174),(43286,3174),(43287,3175),(43288,3175),(43289,3175),(43290,3175),(43291,3175),(43292,3175),(43293,3176),(43294,3176),(43295,3176),(43296,3176),(43297,3176),(43298,3176),(43299,3177),(43300,3177),(43301,3177),(43302,3177),(43303,3177),(43304,3177),(43305,3178),(43306,3178),(43307,3178),(43308,3178),(43309,3178),(43310,3178),(43311,3179),(43312,3179),(43313,3179),(43314,3179),(43315,3179),(43316,3179),(43317,3180),(43318,3180),(43319,3180),(43320,3180),(43321,3180),(43322,3180),(43323,3181),(43324,3181),(43325,3181),(43326,3181),(43327,3181),(43328,3181),(43329,3182),(43330,3182),(43331,3182),(43332,3182),(43333,3182),(43334,3182),(43335,3183),(43336,3183),(43337,3183),(43338,3183),(43339,3183),(43340,3183),(43341,3184),(43342,3184),(43343,3184),(43344,3184),(43345,3184),(43346,3184),(43347,3185),(43348,3185),(43349,3185),(43350,3185),(43351,3185),(43352,3185),(43353,3186),(43354,3186),(43355,3186),(43356,3186),(43357,3186),(43358,3186),(43359,3187),(43360,3187),(43361,3187),(43362,3187),(43363,3187),(43364,3187),(43365,3188),(43366,3188),(43367,3188),(43368,3188),(43369,3188),(43370,3188),(43371,3189),(43372,3189),(43373,3189),(43374,3189),(43375,3189),(43376,3189),(43377,3190),(43378,3190),(43379,3190),(43380,3190),(43381,3190),(43382,3190),(43383,3191),(43384,3191),(43385,3191),(43386,3191),(43387,3191),(43388,3191),(43389,3192),(43390,3192),(43391,3192),(43392,3192),(43393,3192),(43394,3192),(43395,3193),(43396,3193),(43397,3193),(43398,3193),(43399,3193),(43400,3193),(43401,3194),(43402,3194),(43403,3194),(43404,3194),(43405,3194),(43406,3194),(43407,3195),(43408,3195),(43409,3195),(43410,3195),(43411,3195),(43412,3195),(43413,3196),(43414,3196),(43415,3196),(43416,3196),(43417,3196),(43418,3196),(43419,3197),(43420,3197),(43421,3197),(43422,3197),(43423,3197),(43424,3197),(43425,3198),(43426,3198),(43427,3198),(43428,3198),(43429,3198),(43430,3198),(43431,3199),(43432,3199),(43433,3199),(43434,3199),(43435,3199),(43436,3199),(43437,3200),(43438,3200),(43439,3200),(43440,3200),(43441,3200),(43442,3200),(43443,3201),(43444,3201),(43445,3201),(43446,3201),(43447,3201),(43448,3201),(43449,3202),(43450,3202),(43451,3202),(43452,3202),(43453,3202),(43454,3202),(43455,3203),(43456,3203),(43457,3203),(43458,3203),(43459,3203),(43460,3203),(43461,3204),(43462,3204),(43463,3204),(43464,3204),(43465,3204),(43466,3204),(43467,3205),(43468,3205),(43469,3205),(43470,3205),(43471,3205),(43472,3205),(43473,3206),(43474,3206),(43475,3206),(43476,3206),(43477,3206),(43478,3206),(43479,3207),(43480,3207),(43481,3207),(43482,3207),(43483,3207),(43484,3207),(43485,3208),(43486,3208),(43487,3208),(43488,3208),(43489,3208),(43490,3208),(43491,3209),(43492,3209),(43493,3209),(43494,3209),(43495,3209),(43496,3209),(43497,3210),(43498,3210),(43499,3210),(43500,3210),(43501,3210),(43502,3210),(43503,3211),(43504,3211),(43505,3211),(43506,3211),(43507,3211),(43508,3211),(43509,3212),(43510,3212),(43511,3212),(43512,3212),(43513,3212),(43514,3212),(43515,3213),(43516,3213),(43517,3213),(43518,3213),(43519,3213),(43520,3213),(43521,3214),(43522,3214),(43523,3214),(43524,3214),(43525,3214),(43526,3214),(43527,3215),(43528,3215),(43529,3215),(43530,3215),(43531,3215),(43532,3215),(43533,3216),(43534,3216),(43535,3216),(43536,3216),(43537,3216),(43538,3216),(43539,3217),(43540,3217),(43541,3217),(43542,3217),(43543,3217),(43544,3217),(43545,3218),(43546,3218),(43547,3218),(43548,3218),(43549,3218),(43550,3218),(43551,3219),(43552,3219),(43553,3219),(43554,3219),(43555,3219),(43556,3219),(43557,3220),(43558,3220),(43559,3220),(43560,3220),(43561,3220),(43562,3220),(43563,3221),(43564,3221),(43565,3221),(43566,3221),(43567,3221),(43568,3221),(43569,3222),(43570,3222),(43571,3222),(43572,3222),(43573,3222),(43574,3222),(43575,3223),(43576,3223),(43577,3223),(43578,3223),(43579,3223),(43580,3223),(43581,3224),(43582,3224),(43583,3224),(43584,3224),(43585,3224),(43586,3224),(43587,3225),(43588,3225),(43589,3225),(43590,3225),(43591,3225),(43592,3225),(43593,3226),(43594,3226),(43595,3226),(43596,3226),(43597,3226),(43598,3226),(43599,3227),(43600,3227),(43601,3227),(43602,3227),(43603,3227),(43604,3227),(43605,3228),(43606,3228),(43607,3228),(43608,3228),(43609,3228),(43610,3228),(43611,3229),(43612,3229),(43613,3229),(43614,3229),(43615,3229),(43616,3229),(43617,3230),(43618,3230),(43619,3230),(43620,3230),(43621,3230),(43622,3230),(43623,3231),(43624,3231),(43625,3231),(43626,3231),(43627,3231),(43628,3231),(43629,3232),(43630,3232),(43631,3232),(43632,3232),(43633,3232),(43634,3232),(43635,3233),(43636,3233),(43637,3233),(43638,3233),(43639,3233),(43640,3233),(43641,3234),(43642,3234),(43643,3234),(43644,3234),(43645,3234),(43646,3234),(43647,3235),(43648,3235),(43649,3235),(43650,3235),(43651,3235),(43652,3235),(43653,3236),(43654,3236),(43655,3236),(43656,3236),(43657,3236),(43658,3236),(43659,3237),(43660,3237),(43661,3237),(43662,3237),(43663,3237),(43664,3237),(43665,3238),(43666,3238),(43667,3238),(43668,3238),(43669,3238),(43670,3238),(43671,3239),(43672,3239),(43673,3239),(43674,3239),(43675,3239),(43676,3239),(43677,3240),(43678,3240),(43679,3240),(43680,3240),(43681,3240),(43682,3240),(43683,3241),(43684,3241),(43685,3241),(43686,3241),(43687,3241),(43688,3241),(43689,3242),(43690,3242),(43691,3242),(43692,3242),(43693,3242),(43694,3242),(43695,3243),(43696,3243),(43697,3243),(43698,3243),(43699,3243),(43700,3243),(43701,3244),(43702,3244),(43703,3244),(43704,3244),(43705,3244),(43706,3244),(43707,3245),(43708,3245),(43709,3245),(43710,3245),(43711,3245),(43712,3245),(43713,3246),(43714,3246),(43715,3246),(43716,3246),(43717,3246),(43718,3246),(43719,3247),(43720,3247),(43721,3247),(43722,3247),(43723,3247),(43724,3247),(43725,3248),(43726,3248),(43727,3248),(43728,3248),(43729,3248),(43730,3248),(43731,3249),(43732,3249),(43733,3249),(43734,3249),(43735,3249),(43736,3249),(43737,3250),(43738,3250),(43739,3250),(43740,3250),(43741,3250),(43742,3250),(43743,3251),(43744,3251),(43745,3251),(43746,3251),(43747,3251),(43748,3251),(43749,3252),(43750,3252),(43751,3252),(43752,3252),(43753,3252),(43754,3252),(43755,3253),(43756,3253),(43757,3253),(43758,3253),(43759,3253),(43760,3253),(43761,3254),(43762,3254),(43763,3254),(43764,3254),(43765,3254),(43766,3254),(43767,3255),(43768,3255),(43769,3255),(43770,3255),(43771,3255),(43772,3255),(43773,3256),(43774,3256),(43775,3256),(43776,3256),(43777,3256),(43778,3256),(43779,3257),(43780,3257),(43781,3257),(43782,3257),(43783,3257),(43784,3257),(43785,3258),(43786,3258),(43787,3258),(43788,3258),(43789,3258),(43790,3258),(43791,3259),(43792,3259),(43793,3259),(43794,3259),(43795,3259),(43796,3259),(43797,3260),(43798,3260),(43799,3260),(43800,3260),(43801,3260),(43802,3260),(43803,3261),(43804,3261),(43805,3261),(43806,3261),(43807,3261),(43808,3261),(43809,3262),(43810,3262),(43811,3262),(43812,3262),(43813,3262),(43814,3262),(43815,3263),(43816,3263),(43817,3263),(43818,3263),(43819,3263),(43820,3263),(43821,3264),(43822,3264),(43823,3264),(43824,3264),(43825,3264),(43826,3264),(43827,3265),(43828,3265),(43829,3265),(43830,3265),(43831,3265),(43832,3265),(43833,3266),(43834,3266),(43835,3266),(43836,3266),(43837,3266),(43838,3266),(43839,3267),(43840,3267),(43841,3267),(43842,3267),(43843,3267),(43844,3267),(43845,3268),(43846,3268),(43847,3268),(43848,3268),(43849,3268),(43850,3268),(43851,3169),(43852,3169),(43853,3169),(43854,3170),(43855,3170),(43856,3170),(43857,3171),(43858,3171),(43859,3171),(43860,3172),(43861,3172),(43862,3172),(43863,3173),(43864,3173),(43865,3173),(43866,3174),(43867,3174),(43868,3174),(43869,3175),(43870,3175),(43871,3175),(43872,3176),(43873,3176),(43874,3176),(43875,3177),(43876,3177),(43877,3177),(43878,3178),(43879,3178),(43880,3178),(43881,3179),(43882,3179),(43883,3179),(43884,3180),(43885,3180),(43886,3180),(43887,3181),(43888,3181),(43889,3181),(43890,3182),(43891,3182),(43892,3182),(43893,3183),(43894,3183),(43895,3183),(43896,3184),(43897,3184),(43898,3184),(43899,3185),(43900,3185),(43901,3185),(43902,3186),(43903,3186),(43904,3186),(43905,3187),(43906,3187),(43907,3187),(43908,3188),(43909,3188),(43910,3188),(43911,3189),(43912,3189),(43913,3189),(43914,3190),(43915,3190),(43916,3190),(43917,3191),(43918,3191),(43919,3191),(43920,3192),(43921,3192),(43922,3192),(43923,3193),(43924,3193),(43925,3193),(43926,3194),(43927,3194),(43928,3194),(43929,3195),(43930,3195),(43931,3195),(43932,3196),(43933,3196),(43934,3196),(43935,3197),(43936,3197),(43937,3197),(43938,3198),(43939,3198),(43940,3198),(43941,3199),(43942,3199),(43943,3199),(43944,3200),(43945,3200),(43946,3200),(43947,3201),(43948,3201),(43949,3201),(43950,3202),(43951,3202),(43952,3202),(43953,3203),(43954,3203),(43955,3203),(43956,3204),(43957,3204),(43958,3204),(43959,3205),(43960,3205),(43961,3205),(43962,3206),(43963,3206),(43964,3206),(43965,3207),(43966,3207),(43967,3207),(43968,3208),(43969,3208),(43970,3208),(43971,3209),(43972,3209),(43973,3209),(43974,3210),(43975,3210),(43976,3210),(43977,3211),(43978,3211),(43979,3211),(43980,3212),(43981,3212),(43982,3212),(43983,3213),(43984,3213),(43985,3213),(43986,3214),(43987,3214),(43988,3214),(43989,3215),(43990,3215),(43991,3215),(43992,3216),(43993,3216),(43994,3216),(43995,3217),(43996,3217),(43997,3217),(43998,3218),(43999,3218),(44000,3218),(44001,3219),(44002,3219),(44003,3219),(44004,3220),(44005,3220),(44006,3220),(44007,3221),(44008,3221),(44009,3221),(44010,3222),(44011,3222),(44012,3222),(44013,3223),(44014,3223),(44015,3223),(44016,3224),(44017,3224),(44018,3224),(44019,3225),(44020,3225),(44021,3225),(44022,3226),(44023,3226),(44024,3226),(44025,3227),(44026,3227),(44027,3227),(44028,3228),(44029,3228),(44030,3228),(44031,3229),(44032,3229),(44033,3229),(44034,3230),(44035,3230),(44036,3230),(44037,3231),(44038,3231),(44039,3231),(44040,3232),(44041,3232),(44042,3232),(44043,3233),(44044,3233),(44045,3233),(44046,3234),(44047,3234),(44048,3234),(44049,3235),(44050,3235),(44051,3235),(44052,3236),(44053,3236),(44054,3236),(44055,3237),(44056,3237),(44057,3237),(44058,3238),(44059,3238),(44060,3238),(44061,3239),(44062,3239),(44063,3239),(44064,3240),(44065,3240),(44066,3240),(44067,3241),(44068,3241),(44069,3241),(44070,3242),(44071,3242),(44072,3242),(44073,3243),(44074,3243),(44075,3243),(44076,3244),(44077,3244),(44078,3244),(44079,3245),(44080,3245),(44081,3245),(44082,3246),(44083,3246),(44084,3246),(44085,3247),(44086,3247),(44087,3247),(44088,3248),(44089,3248),(44090,3248),(44091,3249),(44092,3249),(44093,3249),(44094,3250),(44095,3250),(44096,3250),(44097,3251),(44098,3251),(44099,3251),(44100,3252),(44101,3252),(44102,3252),(44103,3253),(44104,3253),(44105,3253),(44106,3254),(44107,3254),(44108,3254),(44109,3255),(44110,3255),(44111,3255),(44112,3256),(44113,3256),(44114,3256),(44115,3257),(44116,3257),(44117,3257),(44118,3258),(44119,3258),(44120,3258),(44121,3259),(44122,3259),(44123,3259),(44124,3260),(44125,3260),(44126,3260),(44127,3261),(44128,3261),(44129,3261),(44130,3262),(44131,3262),(44132,3262),(44133,3263),(44134,3263),(44135,3263),(44136,3264),(44137,3264),(44138,3264),(44139,3265),(44140,3265),(44141,3265),(44142,3266),(44143,3266),(44144,3266),(44145,3267),(44146,3267),(44147,3267),(44148,3268),(44149,3268),(44150,3268),(44151,3169),(44152,3169),(44153,3169),(44154,3169),(44155,3170),(44156,3170),(44157,3170),(44158,3170),(44159,3171),(44160,3171),(44161,3171),(44162,3171),(44163,3172),(44164,3172),(44165,3172),(44166,3172),(44167,3173),(44168,3173),(44169,3173),(44170,3173),(44171,3174),(44172,3174),(44173,3174),(44174,3174),(44175,3175),(44176,3175),(44177,3175),(44178,3175),(44179,3176),(44180,3176),(44181,3176),(44182,3176),(44183,3177),(44184,3177),(44185,3177),(44186,3177),(44187,3178),(44188,3178),(44189,3178),(44190,3178),(44191,3179),(44192,3179),(44193,3179),(44194,3179),(44195,3180),(44196,3180),(44197,3180),(44198,3180),(44199,3181),(44200,3181),(44201,3181),(44202,3181),(44203,3182),(44204,3182),(44205,3182),(44206,3182),(44207,3183),(44208,3183),(44209,3183),(44210,3183),(44211,3184),(44212,3184),(44213,3184),(44214,3184),(44215,3185),(44216,3185),(44217,3185),(44218,3185),(44219,3186),(44220,3186),(44221,3186),(44222,3186),(44223,3187),(44224,3187),(44225,3187),(44226,3187),(44227,3188),(44228,3188),(44229,3188),(44230,3188),(44231,3189),(44232,3189),(44233,3189),(44234,3189),(44235,3190),(44236,3190),(44237,3190),(44238,3190),(44239,3191),(44240,3191),(44241,3191),(44242,3191),(44243,3192),(44244,3192),(44245,3192),(44246,3192),(44247,3193),(44248,3193),(44249,3193),(44250,3193),(44251,3194),(44252,3194),(44253,3194),(44254,3194),(44255,3195),(44256,3195),(44257,3195),(44258,3195),(44259,3196),(44260,3196),(44261,3196),(44262,3196),(44263,3197),(44264,3197),(44265,3197),(44266,3197),(44267,3198),(44268,3198),(44269,3198),(44270,3198),(44271,3199),(44272,3199),(44273,3199),(44274,3199),(44275,3200),(44276,3200),(44277,3200),(44278,3200),(44279,3201),(44280,3201),(44281,3201),(44282,3201),(44283,3202),(44284,3202),(44285,3202),(44286,3202),(44287,3203),(44288,3203),(44289,3203),(44290,3203),(44291,3204),(44292,3204),(44293,3204),(44294,3204),(44295,3205),(44296,3205),(44297,3205),(44298,3205),(44299,3206),(44300,3206),(44301,3206),(44302,3206),(44303,3207),(44304,3207),(44305,3207),(44306,3207),(44307,3208),(44308,3208),(44309,3208),(44310,3208),(44311,3209),(44312,3209),(44313,3209),(44314,3209),(44315,3210),(44316,3210),(44317,3210),(44318,3210),(44319,3211),(44320,3211),(44321,3211),(44322,3211),(44323,3212),(44324,3212),(44325,3212),(44326,3212),(44327,3213),(44328,3213),(44329,3213),(44330,3213),(44331,3214),(44332,3214),(44333,3214),(44334,3214),(44335,3215),(44336,3215),(44337,3215),(44338,3215),(44339,3216),(44340,3216),(44341,3216),(44342,3216),(44343,3217),(44344,3217),(44345,3217),(44346,3217),(44347,3218),(44348,3218),(44349,3218),(44350,3218),(44351,3219),(44352,3219),(44353,3219),(44354,3219),(44355,3220),(44356,3220),(44357,3220),(44358,3220),(44359,3221),(44360,3221),(44361,3221),(44362,3221),(44363,3222),(44364,3222),(44365,3222),(44366,3222),(44367,3223),(44368,3223),(44369,3223),(44370,3223),(44371,3224),(44372,3224),(44373,3224),(44374,3224),(44375,3225),(44376,3225),(44377,3225),(44378,3225),(44379,3226),(44380,3226),(44381,3226),(44382,3226),(44383,3227),(44384,3227),(44385,3227),(44386,3227),(44387,3228),(44388,3228),(44389,3228),(44390,3228),(44391,3229),(44392,3229),(44393,3229),(44394,3229),(44395,3230),(44396,3230),(44397,3230),(44398,3230),(44399,3231),(44400,3231),(44401,3231),(44402,3231),(44403,3232),(44404,3232),(44405,3232),(44406,3232),(44407,3233),(44408,3233),(44409,3233),(44410,3233),(44411,3234),(44412,3234),(44413,3234),(44414,3234),(44415,3235),(44416,3235),(44417,3235),(44418,3235),(44419,3236),(44420,3236),(44421,3236),(44422,3236),(44423,3237),(44424,3237),(44425,3237),(44426,3237),(44427,3238),(44428,3238),(44429,3238),(44430,3238),(44431,3239),(44432,3239),(44433,3239),(44434,3239),(44435,3240),(44436,3240),(44437,3240),(44438,3240),(44439,3241),(44440,3241),(44441,3241),(44442,3241),(44443,3242),(44444,3242),(44445,3242),(44446,3242),(44447,3243),(44448,3243),(44449,3243),(44450,3243),(44451,3244),(44452,3244),(44453,3244),(44454,3244),(44455,3245),(44456,3245),(44457,3245),(44458,3245),(44459,3246),(44460,3246),(44461,3246),(44462,3246),(44463,3247),(44464,3247),(44465,3247),(44466,3247),(44467,3248),(44468,3248),(44469,3248),(44470,3248),(44471,3249),(44472,3249),(44473,3249),(44474,3249),(44475,3250),(44476,3250),(44477,3250),(44478,3250),(44479,3251),(44480,3251),(44481,3251),(44482,3251),(44483,3252),(44484,3252),(44485,3252),(44486,3252),(44487,3253),(44488,3253),(44489,3253),(44490,3253),(44491,3254),(44492,3254),(44493,3254),(44494,3254),(44495,3255),(44496,3255),(44497,3255),(44498,3255),(44499,3256),(44500,3256),(44501,3256),(44502,3256),(44503,3257),(44504,3257),(44505,3257),(44506,3257),(44507,3258),(44508,3258),(44509,3258),(44510,3258),(44511,3259),(44512,3259),(44513,3259),(44514,3259),(44515,3260),(44516,3260),(44517,3260),(44518,3260),(44519,3261),(44520,3261),(44521,3261),(44522,3261),(44523,3262),(44524,3262),(44525,3262),(44526,3262),(44527,3263),(44528,3263),(44529,3263),(44530,3263),(44531,3264),(44532,3264),(44533,3264),(44534,3264),(44535,3265),(44536,3265),(44537,3265),(44538,3265),(44539,3266),(44540,3266),(44541,3266),(44542,3266),(44543,3267),(44544,3267),(44545,3267),(44546,3267),(44547,3268),(44548,3268),(44549,3268),(44550,3268),(44551,3269),(44552,3269),(44553,3269),(44554,3269),(44555,3269),(44556,3269),(44557,3270),(44558,3270),(44559,3270),(44560,3270),(44561,3270),(44562,3270),(44563,3271),(44564,3271),(44565,3271),(44566,3271),(44567,3271),(44568,3271),(44569,3272),(44570,3272),(44571,3272),(44572,3272),(44573,3272),(44574,3272),(44575,3273),(44576,3273),(44577,3273),(44578,3273),(44579,3273),(44580,3273),(44581,3274),(44582,3274),(44583,3274),(44584,3274),(44585,3274),(44586,3274),(44587,3275),(44588,3275),(44589,3275),(44590,3275),(44591,3275),(44592,3275),(44593,3276),(44594,3276),(44595,3276),(44596,3276),(44597,3276),(44598,3276),(44599,3277),(44600,3277),(44601,3277),(44602,3277),(44603,3277),(44604,3277),(44605,3278),(44606,3278),(44607,3278),(44608,3278),(44609,3278),(44610,3278),(44611,3279),(44612,3279),(44613,3279),(44614,3279),(44615,3279),(44616,3279),(44617,3280),(44618,3280),(44619,3280),(44620,3280),(44621,3280),(44622,3280),(44623,3281),(44624,3281),(44625,3281),(44626,3281),(44627,3281),(44628,3281),(44629,3282),(44630,3282),(44631,3282),(44632,3282),(44633,3282),(44634,3282),(44635,3283),(44636,3283),(44637,3283),(44638,3283),(44639,3283),(44640,3283),(44641,3284),(44642,3284),(44643,3284),(44644,3284),(44645,3284),(44646,3284),(44647,3285),(44648,3285),(44649,3285),(44650,3285),(44651,3285),(44652,3285),(44653,3286),(44654,3286),(44655,3286),(44656,3286),(44657,3286),(44658,3286),(44659,3287),(44660,3287),(44661,3287),(44662,3287),(44663,3287),(44664,3287),(44665,3288),(44666,3288),(44667,3288),(44668,3288),(44669,3288),(44670,3288),(44671,3289),(44672,3289),(44673,3289),(44674,3289),(44675,3289),(44676,3289),(44677,3290),(44678,3290),(44679,3290),(44680,3290),(44681,3290),(44682,3290),(44683,3291),(44684,3291),(44685,3291),(44686,3291),(44687,3291),(44688,3291),(44689,3292),(44690,3292),(44691,3292),(44692,3292),(44693,3292),(44694,3292),(44695,3293),(44696,3293),(44697,3293),(44698,3293),(44699,3293),(44700,3293),(44701,3294),(44702,3294),(44703,3294),(44704,3294),(44705,3294),(44706,3294),(44707,3295),(44708,3295),(44709,3295),(44710,3295),(44711,3295),(44712,3295),(44713,3296),(44714,3296),(44715,3296),(44716,3296),(44717,3296),(44718,3296),(44719,3297),(44720,3297),(44721,3297),(44722,3297),(44723,3297),(44724,3297),(44725,3298),(44726,3298),(44727,3298),(44728,3298),(44729,3298),(44730,3298),(44731,3299),(44732,3299),(44733,3299),(44734,3299),(44735,3299),(44736,3299),(44737,3300),(44738,3300),(44739,3300),(44740,3300),(44741,3300),(44742,3300),(44743,3301),(44744,3301),(44745,3301),(44746,3301),(44747,3301),(44748,3301),(44749,3302),(44750,3302),(44751,3302),(44752,3302),(44753,3302),(44754,3302),(44755,3303),(44756,3303),(44757,3303),(44758,3303),(44759,3303),(44760,3303),(44761,3304),(44762,3304),(44763,3304),(44764,3304),(44765,3304),(44766,3304),(44767,3305),(44768,3305),(44769,3305),(44770,3305),(44771,3305),(44772,3305),(44773,3306),(44774,3306),(44775,3306),(44776,3306),(44777,3306),(44778,3306),(44779,3307),(44780,3307),(44781,3307),(44782,3307),(44783,3307),(44784,3307),(44785,3308),(44786,3308),(44787,3308),(44788,3308),(44789,3308),(44790,3308),(44791,3309),(44792,3309),(44793,3309),(44794,3309),(44795,3309),(44796,3309),(44797,3310),(44798,3310),(44799,3310),(44800,3310),(44801,3310),(44802,3310),(44803,3311),(44804,3311),(44805,3311),(44806,3311),(44807,3311),(44808,3311),(44809,3312),(44810,3312),(44811,3312),(44812,3312),(44813,3312),(44814,3312),(44815,3313),(44816,3313),(44817,3313),(44818,3313),(44819,3313),(44820,3313),(44821,3314),(44822,3314),(44823,3314),(44824,3314),(44825,3314),(44826,3314),(44827,3315),(44828,3315),(44829,3315),(44830,3315),(44831,3315),(44832,3315),(44833,3316),(44834,3316),(44835,3316),(44836,3316),(44837,3316),(44838,3316),(44839,3317),(44840,3317),(44841,3317),(44842,3317),(44843,3317),(44844,3317),(44845,3318),(44846,3318),(44847,3318),(44848,3318),(44849,3318),(44850,3318),(44851,3319),(44852,3319),(44853,3319),(44854,3319),(44855,3319),(44856,3319),(44857,3320),(44858,3320),(44859,3320),(44860,3320),(44861,3320),(44862,3320),(44863,3321),(44864,3321),(44865,3321),(44866,3321),(44867,3321),(44868,3321),(44869,3322),(44870,3322),(44871,3322),(44872,3322),(44873,3322),(44874,3322),(44875,3323),(44876,3323),(44877,3323),(44878,3323),(44879,3323),(44880,3323),(44881,3324),(44882,3324),(44883,3324),(44884,3324),(44885,3324),(44886,3324),(44887,3325),(44888,3325),(44889,3325),(44890,3325),(44891,3325),(44892,3325),(44893,3326),(44894,3326),(44895,3326),(44896,3326),(44897,3326),(44898,3326),(44899,3327),(44900,3327),(44901,3327),(44902,3327),(44903,3327),(44904,3327),(44905,3328),(44906,3328),(44907,3328),(44908,3328),(44909,3328),(44910,3328),(44911,3329),(44912,3329),(44913,3329),(44914,3329),(44915,3329),(44916,3329),(44917,3330),(44918,3330),(44919,3330),(44920,3330),(44921,3330),(44922,3330),(44923,3331),(44924,3331),(44925,3331),(44926,3331),(44927,3331),(44928,3331),(44929,3332),(44930,3332),(44931,3332),(44932,3332),(44933,3332),(44934,3332),(44935,3333),(44936,3333),(44937,3333),(44938,3333),(44939,3333),(44940,3333),(44941,3334),(44942,3334),(44943,3334),(44944,3334),(44945,3334),(44946,3334),(44947,3335),(44948,3335),(44949,3335),(44950,3335),(44951,3335),(44952,3335),(44953,3336),(44954,3336),(44955,3336),(44956,3336),(44957,3336),(44958,3336),(44959,3337),(44960,3337),(44961,3337),(44962,3337),(44963,3337),(44964,3337),(44965,3338),(44966,3338),(44967,3338),(44968,3338),(44969,3338),(44970,3338),(44971,3339),(44972,3339),(44973,3339),(44974,3339),(44975,3339),(44976,3339),(44977,3340),(44978,3340),(44979,3340),(44980,3340),(44981,3340),(44982,3340),(44983,3341),(44984,3341),(44985,3341),(44986,3341),(44987,3341),(44988,3341),(44989,3342),(44990,3342),(44991,3342),(44992,3342),(44993,3342),(44994,3342),(44995,3343),(44996,3343),(44997,3343),(44998,3343),(44999,3343),(45000,3343),(45001,3344),(45002,3344),(45003,3344),(45004,3344),(45005,3344),(45006,3344),(45007,3345),(45008,3345),(45009,3345),(45010,3345),(45011,3345),(45012,3345),(45013,3346),(45014,3346),(45015,3346),(45016,3346),(45017,3346),(45018,3346),(45019,3347),(45020,3347),(45021,3347),(45022,3347),(45023,3347),(45024,3347),(45025,3348),(45026,3348),(45027,3348),(45028,3348),(45029,3348),(45030,3348),(45031,3349),(45032,3349),(45033,3349),(45034,3349),(45035,3349),(45036,3349),(45037,3350),(45038,3350),(45039,3350),(45040,3350),(45041,3350),(45042,3350),(45043,3351),(45044,3351),(45045,3351),(45046,3351),(45047,3351),(45048,3351),(45049,3352),(45050,3352),(45051,3352),(45052,3352),(45053,3352),(45054,3352),(45055,3353),(45056,3353),(45057,3353),(45058,3353),(45059,3353),(45060,3353),(45061,3354),(45062,3354),(45063,3354),(45064,3354),(45065,3354),(45066,3354),(45067,3355),(45068,3355),(45069,3355),(45070,3355),(45071,3355),(45072,3355),(45073,3356),(45074,3356),(45075,3356),(45076,3356),(45077,3356),(45078,3356),(45079,3357),(45080,3357),(45081,3357),(45082,3357),(45083,3357),(45084,3357),(45085,3358),(45086,3358),(45087,3358),(45088,3358),(45089,3358),(45090,3358),(45091,3359),(45092,3359),(45093,3359),(45094,3359),(45095,3359),(45096,3359),(45097,3360),(45098,3360),(45099,3360),(45100,3360),(45101,3360),(45102,3360),(45103,3361),(45104,3361),(45105,3361),(45106,3361),(45107,3361),(45108,3361),(45109,3362),(45110,3362),(45111,3362),(45112,3362),(45113,3362),(45114,3362),(45115,3363),(45116,3363),(45117,3363),(45118,3363),(45119,3363),(45120,3363),(45121,3364),(45122,3364),(45123,3364),(45124,3364),(45125,3364),(45126,3364),(45127,3365),(45128,3365),(45129,3365),(45130,3365),(45131,3365),(45132,3365),(45133,3366),(45134,3366),(45135,3366),(45136,3366),(45137,3366),(45138,3366),(45139,3367),(45140,3367),(45141,3367),(45142,3367),(45143,3367),(45144,3367),(45145,3368),(45146,3368),(45147,3368),(45148,3368),(45149,3368),(45150,3368),(45151,3269),(45152,3269),(45153,3269),(45154,3270),(45155,3270),(45156,3270),(45157,3271),(45158,3271),(45159,3271),(45160,3272),(45161,3272),(45162,3272),(45163,3273),(45164,3273),(45165,3273),(45166,3274),(45167,3274),(45168,3274),(45169,3275),(45170,3275),(45171,3275),(45172,3276),(45173,3276),(45174,3276),(45175,3277),(45176,3277),(45177,3277),(45178,3278),(45179,3278),(45180,3278),(45181,3279),(45182,3279),(45183,3279),(45184,3280),(45185,3280),(45186,3280),(45187,3281),(45188,3281),(45189,3281),(45190,3282),(45191,3282),(45192,3282),(45193,3283),(45194,3283),(45195,3283),(45196,3284),(45197,3284),(45198,3284),(45199,3285),(45200,3285),(45201,3285),(45202,3286),(45203,3286),(45204,3286),(45205,3287),(45206,3287),(45207,3287),(45208,3288),(45209,3288),(45210,3288),(45211,3289),(45212,3289),(45213,3289),(45214,3290),(45215,3290),(45216,3290),(45217,3291),(45218,3291),(45219,3291),(45220,3292),(45221,3292),(45222,3292),(45223,3293),(45224,3293),(45225,3293),(45226,3294),(45227,3294),(45228,3294),(45229,3295),(45230,3295),(45231,3295),(45232,3296),(45233,3296),(45234,3296),(45235,3297),(45236,3297),(45237,3297),(45238,3298),(45239,3298),(45240,3298),(45241,3299),(45242,3299),(45243,3299),(45244,3300),(45245,3300),(45246,3300),(45247,3301),(45248,3301),(45249,3301),(45250,3302),(45251,3302),(45252,3302),(45253,3303),(45254,3303),(45255,3303),(45256,3304),(45257,3304),(45258,3304),(45259,3305),(45260,3305),(45261,3305),(45262,3306),(45263,3306),(45264,3306),(45265,3307),(45266,3307),(45267,3307),(45268,3308),(45269,3308),(45270,3308),(45271,3309),(45272,3309),(45273,3309),(45274,3310),(45275,3310),(45276,3310),(45277,3311),(45278,3311),(45279,3311),(45280,3312),(45281,3312),(45282,3312),(45283,3313),(45284,3313),(45285,3313),(45286,3314),(45287,3314),(45288,3314),(45289,3315),(45290,3315),(45291,3315),(45292,3316),(45293,3316),(45294,3316),(45295,3317),(45296,3317),(45297,3317),(45298,3318),(45299,3318),(45300,3318),(45301,3319),(45302,3319),(45303,3319),(45304,3320),(45305,3320),(45306,3320),(45307,3321),(45308,3321),(45309,3321),(45310,3322),(45311,3322),(45312,3322),(45313,3323),(45314,3323),(45315,3323),(45316,3324),(45317,3324),(45318,3324),(45319,3325),(45320,3325),(45321,3325),(45322,3326),(45323,3326),(45324,3326),(45325,3327),(45326,3327),(45327,3327),(45328,3328),(45329,3328),(45330,3328),(45331,3329),(45332,3329),(45333,3329),(45334,3330),(45335,3330),(45336,3330),(45337,3331),(45338,3331),(45339,3331),(45340,3332),(45341,3332),(45342,3332),(45343,3333),(45344,3333),(45345,3333),(45346,3334),(45347,3334),(45348,3334),(45349,3335),(45350,3335),(45351,3335),(45352,3336),(45353,3336),(45354,3336),(45355,3337),(45356,3337),(45357,3337),(45358,3338),(45359,3338),(45360,3338),(45361,3339),(45362,3339),(45363,3339),(45364,3340),(45365,3340),(45366,3340),(45367,3341),(45368,3341),(45369,3341),(45370,3342),(45371,3342),(45372,3342),(45373,3343),(45374,3343),(45375,3343),(45376,3344),(45377,3344),(45378,3344),(45379,3345),(45380,3345),(45381,3345),(45382,3346),(45383,3346),(45384,3346),(45385,3347),(45386,3347),(45387,3347),(45388,3348),(45389,3348),(45390,3348),(45391,3349),(45392,3349),(45393,3349),(45394,3350),(45395,3350),(45396,3350),(45397,3351),(45398,3351),(45399,3351),(45400,3352),(45401,3352),(45402,3352),(45403,3353),(45404,3353),(45405,3353),(45406,3354),(45407,3354),(45408,3354),(45409,3355),(45410,3355),(45411,3355),(45412,3356),(45413,3356),(45414,3356),(45415,3357),(45416,3357),(45417,3357),(45418,3358),(45419,3358),(45420,3358),(45421,3359),(45422,3359),(45423,3359),(45424,3360),(45425,3360),(45426,3360),(45427,3361),(45428,3361),(45429,3361),(45430,3362),(45431,3362),(45432,3362),(45433,3363),(45434,3363),(45435,3363),(45436,3364),(45437,3364),(45438,3364),(45439,3365),(45440,3365),(45441,3365),(45442,3366),(45443,3366),(45444,3366),(45445,3367),(45446,3367),(45447,3367),(45448,3368),(45449,3368),(45450,3368),(45451,3269),(45452,3269),(45453,3269),(45454,3269),(45455,3270),(45456,3270),(45457,3270),(45458,3270),(45459,3271),(45460,3271),(45461,3271),(45462,3271),(45463,3272),(45464,3272),(45465,3272),(45466,3272),(45467,3273),(45468,3273),(45469,3273),(45470,3273),(45471,3274),(45472,3274),(45473,3274),(45474,3274),(45475,3275),(45476,3275),(45477,3275),(45478,3275),(45479,3276),(45480,3276),(45481,3276),(45482,3276),(45483,3277),(45484,3277),(45485,3277),(45486,3277),(45487,3278),(45488,3278),(45489,3278),(45490,3278),(45491,3279),(45492,3279),(45493,3279),(45494,3279),(45495,3280),(45496,3280),(45497,3280),(45498,3280),(45499,3281),(45500,3281),(45501,3281),(45502,3281),(45503,3282),(45504,3282),(45505,3282),(45506,3282),(45507,3283),(45508,3283),(45509,3283),(45510,3283),(45511,3284),(45512,3284),(45513,3284),(45514,3284),(45515,3285),(45516,3285),(45517,3285),(45518,3285),(45519,3286),(45520,3286),(45521,3286),(45522,3286),(45523,3287),(45524,3287),(45525,3287),(45526,3287),(45527,3288),(45528,3288),(45529,3288),(45530,3288),(45531,3289),(45532,3289),(45533,3289),(45534,3289),(45535,3290),(45536,3290),(45537,3290),(45538,3290),(45539,3291),(45540,3291),(45541,3291),(45542,3291),(45543,3292),(45544,3292),(45545,3292),(45546,3292),(45547,3293),(45548,3293),(45549,3293),(45550,3293),(45551,3294),(45552,3294),(45553,3294),(45554,3294),(45555,3295),(45556,3295),(45557,3295),(45558,3295),(45559,3296),(45560,3296),(45561,3296),(45562,3296),(45563,3297),(45564,3297),(45565,3297),(45566,3297),(45567,3298),(45568,3298),(45569,3298),(45570,3298),(45571,3299),(45572,3299),(45573,3299),(45574,3299),(45575,3300),(45576,3300),(45577,3300),(45578,3300),(45579,3301),(45580,3301),(45581,3301),(45582,3301),(45583,3302),(45584,3302),(45585,3302),(45586,3302),(45587,3303),(45588,3303),(45589,3303),(45590,3303),(45591,3304),(45592,3304),(45593,3304),(45594,3304),(45595,3305),(45596,3305),(45597,3305),(45598,3305),(45599,3306),(45600,3306),(45601,3306),(45602,3306),(45603,3307),(45604,3307),(45605,3307),(45606,3307),(45607,3308),(45608,3308),(45609,3308),(45610,3308),(45611,3309),(45612,3309),(45613,3309),(45614,3309),(45615,3310),(45616,3310),(45617,3310),(45618,3310),(45619,3311),(45620,3311),(45621,3311),(45622,3311),(45623,3312),(45624,3312),(45625,3312),(45626,3312),(45627,3313),(45628,3313),(45629,3313),(45630,3313),(45631,3314),(45632,3314),(45633,3314),(45634,3314),(45635,3315),(45636,3315),(45637,3315),(45638,3315),(45639,3316),(45640,3316),(45641,3316),(45642,3316),(45643,3317),(45644,3317),(45645,3317),(45646,3317),(45647,3318),(45648,3318),(45649,3318),(45650,3318),(45651,3319),(45652,3319),(45653,3319),(45654,3319),(45655,3320),(45656,3320),(45657,3320),(45658,3320),(45659,3321),(45660,3321),(45661,3321),(45662,3321),(45663,3322),(45664,3322),(45665,3322),(45666,3322),(45667,3323),(45668,3323),(45669,3323),(45670,3323),(45671,3324),(45672,3324),(45673,3324),(45674,3324),(45675,3325),(45676,3325),(45677,3325),(45678,3325),(45679,3326),(45680,3326),(45681,3326),(45682,3326),(45683,3327),(45684,3327),(45685,3327),(45686,3327),(45687,3328),(45688,3328),(45689,3328),(45690,3328),(45691,3329),(45692,3329),(45693,3329),(45694,3329),(45695,3330),(45696,3330),(45697,3330),(45698,3330),(45699,3331),(45700,3331),(45701,3331),(45702,3331),(45703,3332),(45704,3332),(45705,3332),(45706,3332),(45707,3333),(45708,3333),(45709,3333),(45710,3333),(45711,3334),(45712,3334),(45713,3334),(45714,3334),(45715,3335),(45716,3335),(45717,3335),(45718,3335),(45719,3336),(45720,3336),(45721,3336),(45722,3336),(45723,3337),(45724,3337),(45725,3337),(45726,3337),(45727,3338),(45728,3338),(45729,3338),(45730,3338),(45731,3339),(45732,3339),(45733,3339),(45734,3339),(45735,3340),(45736,3340),(45737,3340),(45738,3340),(45739,3341),(45740,3341),(45741,3341),(45742,3341),(45743,3342),(45744,3342),(45745,3342),(45746,3342),(45747,3343),(45748,3343),(45749,3343),(45750,3343),(45751,3344),(45752,3344),(45753,3344),(45754,3344),(45755,3345),(45756,3345),(45757,3345),(45758,3345),(45759,3346),(45760,3346),(45761,3346),(45762,3346),(45763,3347),(45764,3347),(45765,3347),(45766,3347),(45767,3348),(45768,3348),(45769,3348),(45770,3348),(45771,3349),(45772,3349),(45773,3349),(45774,3349),(45775,3350),(45776,3350),(45777,3350),(45778,3350),(45779,3351),(45780,3351),(45781,3351),(45782,3351),(45783,3352),(45784,3352),(45785,3352),(45786,3352),(45787,3353),(45788,3353),(45789,3353),(45790,3353),(45791,3354),(45792,3354),(45793,3354),(45794,3354),(45795,3355),(45796,3355),(45797,3355),(45798,3355),(45799,3356),(45800,3356),(45801,3356),(45802,3356),(45803,3357),(45804,3357),(45805,3357),(45806,3357),(45807,3358),(45808,3358),(45809,3358),(45810,3358),(45811,3359),(45812,3359),(45813,3359),(45814,3359),(45815,3360),(45816,3360),(45817,3360),(45818,3360),(45819,3361),(45820,3361),(45821,3361),(45822,3361),(45823,3362),(45824,3362),(45825,3362),(45826,3362),(45827,3363),(45828,3363),(45829,3363),(45830,3363),(45831,3364),(45832,3364),(45833,3364),(45834,3364),(45835,3365),(45836,3365),(45837,3365),(45838,3365),(45839,3366),(45840,3366),(45841,3366),(45842,3366),(45843,3367),(45844,3367),(45845,3367),(45846,3367),(45847,3368),(45848,3368),(45849,3368),(45850,3368),(45851,3369),(45852,3369),(45853,3369),(45854,3369),(45855,3369),(45856,3369),(45857,3370),(45858,3370),(45859,3370),(45860,3370),(45861,3370),(45862,3370),(45863,3371),(45864,3371),(45865,3371),(45866,3371),(45867,3371),(45868,3371),(45869,3372),(45870,3372),(45871,3372),(45872,3372),(45873,3372),(45874,3372),(45875,3373),(45876,3373),(45877,3373),(45878,3373),(45879,3373),(45880,3373),(45881,3374),(45882,3374),(45883,3374),(45884,3374),(45885,3374),(45886,3374),(45887,3375),(45888,3375),(45889,3375),(45890,3375),(45891,3375),(45892,3375),(45893,3376),(45894,3376),(45895,3376),(45896,3376),(45897,3376),(45898,3376),(45899,3377),(45900,3377),(45901,3377),(45902,3377),(45903,3377),(45904,3377),(45905,3378),(45906,3378),(45907,3378),(45908,3378),(45909,3378),(45910,3378),(45911,3379),(45912,3379),(45913,3379),(45914,3379),(45915,3379),(45916,3379),(45917,3380),(45918,3380),(45919,3380),(45920,3380),(45921,3380),(45922,3380),(45923,3381),(45924,3381),(45925,3381),(45926,3381),(45927,3381),(45928,3381),(45929,3382),(45930,3382),(45931,3382),(45932,3382),(45933,3382),(45934,3382),(45935,3383),(45936,3383),(45937,3383),(45938,3383),(45939,3383),(45940,3383),(45941,3384),(45942,3384),(45943,3384),(45944,3384),(45945,3384),(45946,3384),(45947,3385),(45948,3385),(45949,3385),(45950,3385),(45951,3385),(45952,3385),(45953,3386),(45954,3386),(45955,3386),(45956,3386),(45957,3386),(45958,3386),(45959,3387),(45960,3387),(45961,3387),(45962,3387),(45963,3387),(45964,3387),(45965,3388),(45966,3388),(45967,3388),(45968,3388),(45969,3388),(45970,3388),(45971,3389),(45972,3389),(45973,3389),(45974,3389),(45975,3389),(45976,3389),(45977,3390),(45978,3390),(45979,3390),(45980,3390),(45981,3390),(45982,3390),(45983,3391),(45984,3391),(45985,3391),(45986,3391),(45987,3391),(45988,3391),(45989,3392),(45990,3392),(45991,3392),(45992,3392),(45993,3392),(45994,3392),(45995,3393),(45996,3393),(45997,3393),(45998,3393),(45999,3393),(46000,3393),(46001,3394),(46002,3394),(46003,3394),(46004,3394),(46005,3394),(46006,3394),(46007,3395),(46008,3395),(46009,3395),(46010,3395),(46011,3395),(46012,3395),(46013,3396),(46014,3396),(46015,3396),(46016,3396),(46017,3396),(46018,3396),(46019,3397),(46020,3397),(46021,3397),(46022,3397),(46023,3397),(46024,3397),(46025,3398),(46026,3398),(46027,3398),(46028,3398),(46029,3398),(46030,3398),(46031,3399),(46032,3399),(46033,3399),(46034,3399),(46035,3399),(46036,3399),(46037,3400),(46038,3400),(46039,3400),(46040,3400),(46041,3400),(46042,3400),(46043,3401),(46044,3401),(46045,3401),(46046,3401),(46047,3401),(46048,3401),(46049,3402),(46050,3402),(46051,3402),(46052,3402),(46053,3402),(46054,3402),(46055,3403),(46056,3403),(46057,3403),(46058,3403),(46059,3403),(46060,3403),(46061,3404),(46062,3404),(46063,3404),(46064,3404),(46065,3404),(46066,3404),(46067,3405),(46068,3405),(46069,3405),(46070,3405),(46071,3405),(46072,3405),(46073,3406),(46074,3406),(46075,3406),(46076,3406),(46077,3406),(46078,3406),(46079,3407),(46080,3407),(46081,3407),(46082,3407),(46083,3407),(46084,3407),(46085,3408),(46086,3408),(46087,3408),(46088,3408),(46089,3408),(46090,3408),(46091,3409),(46092,3409),(46093,3409),(46094,3409),(46095,3409),(46096,3409),(46097,3410),(46098,3410),(46099,3410),(46100,3410),(46101,3410),(46102,3410),(46103,3411),(46104,3411),(46105,3411),(46106,3411),(46107,3411),(46108,3411),(46109,3412),(46110,3412),(46111,3412),(46112,3412),(46113,3412),(46114,3412),(46115,3413),(46116,3413),(46117,3413),(46118,3413),(46119,3413),(46120,3413),(46121,3414),(46122,3414),(46123,3414),(46124,3414),(46125,3414),(46126,3414),(46127,3415),(46128,3415),(46129,3415),(46130,3415),(46131,3415),(46132,3415),(46133,3416),(46134,3416),(46135,3416),(46136,3416),(46137,3416),(46138,3416),(46139,3417),(46140,3417),(46141,3417),(46142,3417),(46143,3417),(46144,3417),(46145,3418),(46146,3418),(46147,3418),(46148,3418),(46149,3418),(46150,3418),(46151,3419),(46152,3419),(46153,3419),(46154,3419),(46155,3419),(46156,3419),(46157,3420),(46158,3420),(46159,3420),(46160,3420),(46161,3420),(46162,3420),(46163,3421),(46164,3421),(46165,3421),(46166,3421),(46167,3421),(46168,3421),(46169,3422),(46170,3422),(46171,3422),(46172,3422),(46173,3422),(46174,3422),(46175,3423),(46176,3423),(46177,3423),(46178,3423),(46179,3423),(46180,3423),(46181,3424),(46182,3424),(46183,3424),(46184,3424),(46185,3424),(46186,3424),(46187,3425),(46188,3425),(46189,3425),(46190,3425),(46191,3425),(46192,3425),(46193,3426),(46194,3426),(46195,3426),(46196,3426),(46197,3426),(46198,3426),(46199,3427),(46200,3427),(46201,3427),(46202,3427),(46203,3427),(46204,3427),(46205,3428),(46206,3428),(46207,3428),(46208,3428),(46209,3428),(46210,3428),(46211,3429),(46212,3429),(46213,3429),(46214,3429),(46215,3429),(46216,3429),(46217,3430),(46218,3430),(46219,3430),(46220,3430),(46221,3430),(46222,3430),(46223,3431),(46224,3431),(46225,3431),(46226,3431),(46227,3431),(46228,3431),(46229,3432),(46230,3432),(46231,3432),(46232,3432),(46233,3432),(46234,3432),(46235,3433),(46236,3433),(46237,3433),(46238,3433),(46239,3433),(46240,3433),(46241,3434),(46242,3434),(46243,3434),(46244,3434),(46245,3434),(46246,3434),(46247,3435),(46248,3435),(46249,3435),(46250,3435),(46251,3435),(46252,3435),(46253,3436),(46254,3436),(46255,3436),(46256,3436),(46257,3436),(46258,3436),(46259,3437),(46260,3437),(46261,3437),(46262,3437),(46263,3437),(46264,3437),(46265,3438),(46266,3438),(46267,3438),(46268,3438),(46269,3438),(46270,3438),(46271,3439),(46272,3439),(46273,3439),(46274,3439),(46275,3439),(46276,3439),(46277,3440),(46278,3440),(46279,3440),(46280,3440),(46281,3440),(46282,3440),(46283,3441),(46284,3441),(46285,3441),(46286,3441),(46287,3441),(46288,3441),(46289,3442),(46290,3442),(46291,3442),(46292,3442),(46293,3442),(46294,3442),(46295,3443),(46296,3443),(46297,3443),(46298,3443),(46299,3443),(46300,3443),(46301,3444),(46302,3444),(46303,3444),(46304,3444),(46305,3444),(46306,3444),(46307,3445),(46308,3445),(46309,3445),(46310,3445),(46311,3445),(46312,3445),(46313,3446),(46314,3446),(46315,3446),(46316,3446),(46317,3446),(46318,3446),(46319,3447),(46320,3447),(46321,3447),(46322,3447),(46323,3447),(46324,3447),(46325,3448),(46326,3448),(46327,3448),(46328,3448),(46329,3448),(46330,3448),(46331,3449),(46332,3449),(46333,3449),(46334,3449),(46335,3449),(46336,3449),(46337,3450),(46338,3450),(46339,3450),(46340,3450),(46341,3450),(46342,3450),(46343,3451),(46344,3451),(46345,3451),(46346,3451),(46347,3451),(46348,3451),(46349,3452),(46350,3452),(46351,3452),(46352,3452),(46353,3452),(46354,3452),(46355,3453),(46356,3453),(46357,3453),(46358,3453),(46359,3453),(46360,3453),(46361,3454),(46362,3454),(46363,3454),(46364,3454),(46365,3454),(46366,3454),(46367,3455),(46368,3455),(46369,3455),(46370,3455),(46371,3455),(46372,3455),(46373,3456),(46374,3456),(46375,3456),(46376,3456),(46377,3456),(46378,3456),(46379,3457),(46380,3457),(46381,3457),(46382,3457),(46383,3457),(46384,3457),(46385,3458),(46386,3458),(46387,3458),(46388,3458),(46389,3458),(46390,3458),(46391,3459),(46392,3459),(46393,3459),(46394,3459),(46395,3459),(46396,3459),(46397,3460),(46398,3460),(46399,3460),(46400,3460),(46401,3460),(46402,3460),(46403,3461),(46404,3461),(46405,3461),(46406,3461),(46407,3461),(46408,3461),(46409,3462),(46410,3462),(46411,3462),(46412,3462),(46413,3462),(46414,3462),(46415,3463),(46416,3463),(46417,3463),(46418,3463),(46419,3463),(46420,3463),(46421,3464),(46422,3464),(46423,3464),(46424,3464),(46425,3464),(46426,3464),(46427,3465),(46428,3465),(46429,3465),(46430,3465),(46431,3465),(46432,3465),(46433,3466),(46434,3466),(46435,3466),(46436,3466),(46437,3466),(46438,3466),(46439,3467),(46440,3467),(46441,3467),(46442,3467),(46443,3467),(46444,3467),(46445,3468),(46446,3468),(46447,3468),(46448,3468),(46449,3468),(46450,3468),(46451,3369),(46452,3369),(46453,3369),(46454,3370),(46455,3370),(46456,3370),(46457,3371),(46458,3371),(46459,3371),(46460,3372),(46461,3372),(46462,3372),(46463,3373),(46464,3373),(46465,3373),(46466,3374),(46467,3374),(46468,3374),(46469,3375),(46470,3375),(46471,3375),(46472,3376),(46473,3376),(46474,3376),(46475,3377),(46476,3377),(46477,3377),(46478,3378),(46479,3378),(46480,3378),(46481,3379),(46482,3379),(46483,3379),(46484,3380),(46485,3380),(46486,3380),(46487,3381),(46488,3381),(46489,3381),(46490,3382),(46491,3382),(46492,3382),(46493,3383),(46494,3383),(46495,3383),(46496,3384),(46497,3384),(46498,3384),(46499,3385),(46500,3385),(46501,3385),(46502,3386),(46503,3386),(46504,3386),(46505,3387),(46506,3387),(46507,3387),(46508,3388),(46509,3388),(46510,3388),(46511,3389),(46512,3389),(46513,3389),(46514,3390),(46515,3390),(46516,3390),(46517,3391),(46518,3391),(46519,3391),(46520,3392),(46521,3392),(46522,3392),(46523,3393),(46524,3393),(46525,3393),(46526,3394),(46527,3394),(46528,3394),(46529,3395),(46530,3395),(46531,3395),(46532,3396),(46533,3396),(46534,3396),(46535,3397),(46536,3397),(46537,3397),(46538,3398),(46539,3398),(46540,3398),(46541,3399),(46542,3399),(46543,3399),(46544,3400),(46545,3400),(46546,3400),(46547,3401),(46548,3401),(46549,3401),(46550,3402),(46551,3402),(46552,3402),(46553,3403),(46554,3403),(46555,3403),(46556,3404),(46557,3404),(46558,3404),(46559,3405),(46560,3405),(46561,3405),(46562,3406),(46563,3406),(46564,3406),(46565,3407),(46566,3407),(46567,3407),(46568,3408),(46569,3408),(46570,3408),(46571,3409),(46572,3409),(46573,3409),(46574,3410),(46575,3410),(46576,3410),(46577,3411),(46578,3411),(46579,3411),(46580,3412),(46581,3412),(46582,3412),(46583,3413),(46584,3413),(46585,3413),(46586,3414),(46587,3414),(46588,3414),(46589,3415),(46590,3415),(46591,3415),(46592,3416),(46593,3416),(46594,3416),(46595,3417),(46596,3417),(46597,3417),(46598,3418),(46599,3418),(46600,3418),(46601,3419),(46602,3419),(46603,3419),(46604,3420),(46605,3420),(46606,3420),(46607,3421),(46608,3421),(46609,3421),(46610,3422),(46611,3422),(46612,3422),(46613,3423),(46614,3423),(46615,3423),(46616,3424),(46617,3424),(46618,3424),(46619,3425),(46620,3425),(46621,3425),(46622,3426),(46623,3426),(46624,3426),(46625,3427),(46626,3427),(46627,3427),(46628,3428),(46629,3428),(46630,3428),(46631,3429),(46632,3429),(46633,3429),(46634,3430),(46635,3430),(46636,3430),(46637,3431),(46638,3431),(46639,3431),(46640,3432),(46641,3432),(46642,3432),(46643,3433),(46644,3433),(46645,3433),(46646,3434),(46647,3434),(46648,3434),(46649,3435),(46650,3435),(46651,3435),(46652,3436),(46653,3436),(46654,3436),(46655,3437),(46656,3437),(46657,3437),(46658,3438),(46659,3438),(46660,3438),(46661,3439),(46662,3439),(46663,3439),(46664,3440),(46665,3440),(46666,3440),(46667,3441),(46668,3441),(46669,3441),(46670,3442),(46671,3442),(46672,3442),(46673,3443),(46674,3443),(46675,3443),(46676,3444),(46677,3444),(46678,3444),(46679,3445),(46680,3445),(46681,3445),(46682,3446),(46683,3446),(46684,3446),(46685,3447),(46686,3447),(46687,3447),(46688,3448),(46689,3448),(46690,3448),(46691,3449),(46692,3449),(46693,3449),(46694,3450),(46695,3450),(46696,3450),(46697,3451),(46698,3451),(46699,3451),(46700,3452),(46701,3452),(46702,3452),(46703,3453),(46704,3453),(46705,3453),(46706,3454),(46707,3454),(46708,3454),(46709,3455),(46710,3455),(46711,3455),(46712,3456),(46713,3456),(46714,3456),(46715,3457),(46716,3457),(46717,3457),(46718,3458),(46719,3458),(46720,3458),(46721,3459),(46722,3459),(46723,3459),(46724,3460),(46725,3460),(46726,3460),(46727,3461),(46728,3461),(46729,3461),(46730,3462),(46731,3462),(46732,3462),(46733,3463),(46734,3463),(46735,3463),(46736,3464),(46737,3464),(46738,3464),(46739,3465),(46740,3465),(46741,3465),(46742,3466),(46743,3466),(46744,3466),(46745,3467),(46746,3467),(46747,3467),(46748,3468),(46749,3468),(46750,3468),(46751,3369),(46752,3369),(46753,3369),(46754,3369),(46755,3370),(46756,3370),(46757,3370),(46758,3370),(46759,3371),(46760,3371),(46761,3371),(46762,3371),(46763,3372),(46764,3372),(46765,3372),(46766,3372),(46767,3373),(46768,3373),(46769,3373),(46770,3373),(46771,3374),(46772,3374),(46773,3374),(46774,3374),(46775,3375),(46776,3375),(46777,3375),(46778,3375),(46779,3376),(46780,3376),(46781,3376),(46782,3376),(46783,3377),(46784,3377),(46785,3377),(46786,3377),(46787,3378),(46788,3378),(46789,3378),(46790,3378),(46791,3379),(46792,3379),(46793,3379),(46794,3379),(46795,3380),(46796,3380),(46797,3380),(46798,3380),(46799,3381),(46800,3381),(46801,3381),(46802,3381),(46803,3382),(46804,3382),(46805,3382),(46806,3382),(46807,3383),(46808,3383),(46809,3383),(46810,3383),(46811,3384),(46812,3384),(46813,3384),(46814,3384),(46815,3385),(46816,3385),(46817,3385),(46818,3385),(46819,3386),(46820,3386),(46821,3386),(46822,3386),(46823,3387),(46824,3387),(46825,3387),(46826,3387),(46827,3388),(46828,3388),(46829,3388),(46830,3388),(46831,3389),(46832,3389),(46833,3389),(46834,3389),(46835,3390),(46836,3390),(46837,3390),(46838,3390),(46839,3391),(46840,3391),(46841,3391),(46842,3391),(46843,3392),(46844,3392),(46845,3392),(46846,3392),(46847,3393),(46848,3393),(46849,3393),(46850,3393),(46851,3394),(46852,3394),(46853,3394),(46854,3394),(46855,3395),(46856,3395),(46857,3395),(46858,3395),(46859,3396),(46860,3396),(46861,3396),(46862,3396),(46863,3397),(46864,3397),(46865,3397),(46866,3397),(46867,3398),(46868,3398),(46869,3398),(46870,3398),(46871,3399),(46872,3399),(46873,3399),(46874,3399),(46875,3400),(46876,3400),(46877,3400),(46878,3400),(46879,3401),(46880,3401),(46881,3401),(46882,3401),(46883,3402),(46884,3402),(46885,3402),(46886,3402),(46887,3403),(46888,3403),(46889,3403),(46890,3403),(46891,3404),(46892,3404),(46893,3404),(46894,3404),(46895,3405),(46896,3405),(46897,3405),(46898,3405),(46899,3406),(46900,3406),(46901,3406),(46902,3406),(46903,3407),(46904,3407),(46905,3407),(46906,3407),(46907,3408),(46908,3408),(46909,3408),(46910,3408),(46911,3409),(46912,3409),(46913,3409),(46914,3409),(46915,3410),(46916,3410),(46917,3410),(46918,3410),(46919,3411),(46920,3411),(46921,3411),(46922,3411),(46923,3412),(46924,3412),(46925,3412),(46926,3412),(46927,3413),(46928,3413),(46929,3413),(46930,3413),(46931,3414),(46932,3414),(46933,3414),(46934,3414),(46935,3415),(46936,3415),(46937,3415),(46938,3415),(46939,3416),(46940,3416),(46941,3416),(46942,3416),(46943,3417),(46944,3417),(46945,3417),(46946,3417),(46947,3418),(46948,3418),(46949,3418),(46950,3418),(46951,3419),(46952,3419),(46953,3419),(46954,3419),(46955,3420),(46956,3420),(46957,3420),(46958,3420),(46959,3421),(46960,3421),(46961,3421),(46962,3421),(46963,3422),(46964,3422),(46965,3422),(46966,3422),(46967,3423),(46968,3423),(46969,3423),(46970,3423),(46971,3424),(46972,3424),(46973,3424),(46974,3424),(46975,3425),(46976,3425),(46977,3425),(46978,3425),(46979,3426),(46980,3426),(46981,3426),(46982,3426),(46983,3427),(46984,3427),(46985,3427),(46986,3427),(46987,3428),(46988,3428),(46989,3428),(46990,3428),(46991,3429),(46992,3429),(46993,3429),(46994,3429),(46995,3430),(46996,3430),(46997,3430),(46998,3430),(46999,3431),(47000,3431),(47001,3431),(47002,3431),(47003,3432),(47004,3432),(47005,3432),(47006,3432),(47007,3433),(47008,3433),(47009,3433),(47010,3433),(47011,3434),(47012,3434),(47013,3434),(47014,3434),(47015,3435),(47016,3435),(47017,3435),(47018,3435),(47019,3436),(47020,3436),(47021,3436),(47022,3436),(47023,3437),(47024,3437),(47025,3437),(47026,3437),(47027,3438),(47028,3438),(47029,3438),(47030,3438),(47031,3439),(47032,3439),(47033,3439),(47034,3439),(47035,3440),(47036,3440),(47037,3440),(47038,3440),(47039,3441),(47040,3441),(47041,3441),(47042,3441),(47043,3442),(47044,3442),(47045,3442),(47046,3442),(47047,3443),(47048,3443),(47049,3443),(47050,3443),(47051,3444),(47052,3444),(47053,3444),(47054,3444),(47055,3445),(47056,3445),(47057,3445),(47058,3445),(47059,3446),(47060,3446),(47061,3446),(47062,3446),(47063,3447),(47064,3447),(47065,3447),(47066,3447),(47067,3448),(47068,3448),(47069,3448),(47070,3448),(47071,3449),(47072,3449),(47073,3449),(47074,3449),(47075,3450),(47076,3450),(47077,3450),(47078,3450),(47079,3451),(47080,3451),(47081,3451),(47082,3451),(47083,3452),(47084,3452),(47085,3452),(47086,3452),(47087,3453),(47088,3453),(47089,3453),(47090,3453),(47091,3454),(47092,3454),(47093,3454),(47094,3454),(47095,3455),(47096,3455),(47097,3455),(47098,3455),(47099,3456),(47100,3456),(47101,3456),(47102,3456),(47103,3457),(47104,3457),(47105,3457),(47106,3457),(47107,3458),(47108,3458),(47109,3458),(47110,3458),(47111,3459),(47112,3459),(47113,3459),(47114,3459),(47115,3460),(47116,3460),(47117,3460),(47118,3460),(47119,3461),(47120,3461),(47121,3461),(47122,3461),(47123,3462),(47124,3462),(47125,3462),(47126,3462),(47127,3463),(47128,3463),(47129,3463),(47130,3463),(47131,3464),(47132,3464),(47133,3464),(47134,3464),(47135,3465),(47136,3465),(47137,3465),(47138,3465),(47139,3466),(47140,3466),(47141,3466),(47142,3466),(47143,3467),(47144,3467),(47145,3467),(47146,3467),(47147,3468),(47148,3468),(47149,3468),(47150,3468),(47151,3469),(47152,3469),(47153,3469),(47154,3469),(47155,3469),(47156,3469),(47157,3470),(47158,3470),(47159,3470),(47160,3470),(47161,3470),(47162,3470),(47163,3471),(47164,3471),(47165,3471),(47166,3471),(47167,3471),(47168,3471),(47169,3472),(47170,3472),(47171,3472),(47172,3472),(47173,3472),(47174,3472),(47175,3473),(47176,3473),(47177,3473),(47178,3473),(47179,3473),(47180,3473),(47181,3474),(47182,3474),(47183,3474),(47184,3474),(47185,3474),(47186,3474),(47187,3475),(47188,3475),(47189,3475),(47190,3475),(47191,3475),(47192,3475),(47193,3476),(47194,3476),(47195,3476),(47196,3476),(47197,3476),(47198,3476),(47199,3477),(47200,3477),(47201,3477),(47202,3477),(47203,3477),(47204,3477),(47205,3478),(47206,3478),(47207,3478),(47208,3478),(47209,3478),(47210,3478),(47211,3479),(47212,3479),(47213,3479),(47214,3479),(47215,3479),(47216,3479),(47217,3480),(47218,3480),(47219,3480),(47220,3480),(47221,3480),(47222,3480),(47223,3481),(47224,3481),(47225,3481),(47226,3481),(47227,3481),(47228,3481),(47229,3482),(47230,3482),(47231,3482),(47232,3482),(47233,3482),(47234,3482),(47235,3483),(47236,3483),(47237,3483),(47238,3483),(47239,3483),(47240,3483),(47241,3484),(47242,3484),(47243,3484),(47244,3484),(47245,3484),(47246,3484),(47247,3485),(47248,3485),(47249,3485),(47250,3485),(47251,3485),(47252,3485),(47253,3486),(47254,3486),(47255,3486),(47256,3486),(47257,3486),(47258,3486),(47259,3487),(47260,3487),(47261,3487),(47262,3487),(47263,3487),(47264,3487),(47265,3488),(47266,3488),(47267,3488),(47268,3488),(47269,3488),(47270,3488),(47271,3489),(47272,3489),(47273,3489),(47274,3489),(47275,3489),(47276,3489),(47277,3490),(47278,3490),(47279,3490),(47280,3490),(47281,3490),(47282,3490),(47283,3491),(47284,3491),(47285,3491),(47286,3491),(47287,3491),(47288,3491),(47289,3492),(47290,3492),(47291,3492),(47292,3492),(47293,3492),(47294,3492),(47295,3493),(47296,3493),(47297,3493),(47298,3493),(47299,3493),(47300,3493),(47301,3494),(47302,3494),(47303,3494),(47304,3494),(47305,3494),(47306,3494),(47307,3495),(47308,3495),(47309,3495),(47310,3495),(47311,3495),(47312,3495),(47313,3496),(47314,3496),(47315,3496),(47316,3496),(47317,3496),(47318,3496),(47319,3497),(47320,3497),(47321,3497),(47322,3497),(47323,3497),(47324,3497),(47325,3498),(47326,3498),(47327,3498),(47328,3498),(47329,3498),(47330,3498),(47331,3499),(47332,3499),(47333,3499),(47334,3499),(47335,3499),(47336,3499),(47337,3500),(47338,3500),(47339,3500),(47340,3500),(47341,3500),(47342,3500),(47343,3501),(47344,3501),(47345,3501),(47346,3501),(47347,3501),(47348,3501),(47349,3502),(47350,3502),(47351,3502),(47352,3502),(47353,3502),(47354,3502),(47355,3503),(47356,3503),(47357,3503),(47358,3503),(47359,3503),(47360,3503),(47361,3504),(47362,3504),(47363,3504),(47364,3504),(47365,3504),(47366,3504),(47367,3505),(47368,3505),(47369,3505),(47370,3505),(47371,3505),(47372,3505),(47373,3506),(47374,3506),(47375,3506),(47376,3506),(47377,3506),(47378,3506),(47379,3507),(47380,3507),(47381,3507),(47382,3507),(47383,3507),(47384,3507),(47385,3508),(47386,3508),(47387,3508),(47388,3508),(47389,3508),(47390,3508),(47391,3509),(47392,3509),(47393,3509),(47394,3509),(47395,3509),(47396,3509),(47397,3510),(47398,3510),(47399,3510),(47400,3510),(47401,3510),(47402,3510),(47403,3511),(47404,3511),(47405,3511),(47406,3511),(47407,3511),(47408,3511),(47409,3512),(47410,3512),(47411,3512),(47412,3512),(47413,3512),(47414,3512),(47415,3513),(47416,3513),(47417,3513),(47418,3513),(47419,3513),(47420,3513),(47421,3514),(47422,3514),(47423,3514),(47424,3514),(47425,3514),(47426,3514),(47427,3515),(47428,3515),(47429,3515),(47430,3515),(47431,3515),(47432,3515),(47433,3516),(47434,3516),(47435,3516),(47436,3516),(47437,3516),(47438,3516),(47439,3517),(47440,3517),(47441,3517),(47442,3517),(47443,3517),(47444,3517),(47445,3518),(47446,3518),(47447,3518),(47448,3518),(47449,3518),(47450,3518),(47451,3519),(47452,3519),(47453,3519),(47454,3519),(47455,3519),(47456,3519),(47457,3520),(47458,3520),(47459,3520),(47460,3520),(47461,3520),(47462,3520),(47463,3521),(47464,3521),(47465,3521),(47466,3521),(47467,3521),(47468,3521),(47469,3522),(47470,3522),(47471,3522),(47472,3522),(47473,3522),(47474,3522),(47475,3523),(47476,3523),(47477,3523),(47478,3523),(47479,3523),(47480,3523),(47481,3524),(47482,3524),(47483,3524),(47484,3524),(47485,3524),(47486,3524),(47487,3525),(47488,3525),(47489,3525),(47490,3525),(47491,3525),(47492,3525),(47493,3526),(47494,3526),(47495,3526),(47496,3526),(47497,3526),(47498,3526),(47499,3527),(47500,3527),(47501,3527),(47502,3527),(47503,3527),(47504,3527),(47505,3528),(47506,3528),(47507,3528),(47508,3528),(47509,3529),(47510,3529),(47511,3529),(47512,3529),(47513,3530),(47514,3530),(47515,3530),(47516,3530),(47517,3531),(47518,3531),(47519,3531),(47520,3531),(47521,3532),(47522,3532),(47523,3532),(47524,3532),(47525,3533),(47526,3533),(47527,3533),(47528,3533),(47529,3534),(47530,3534),(47531,3534),(47532,3534),(47533,3534),(47534,3534),(47535,3535),(47536,3535),(47537,3535),(47538,3535),(47539,3535),(47540,3535),(47541,3536),(47542,3536),(47543,3536),(47544,3536),(47545,3536),(47546,3536),(47547,3537),(47548,3537),(47549,3537),(47550,3537),(47551,3537),(47552,3537),(47553,3538),(47554,3538),(47555,3538),(47556,3538),(47557,3538),(47558,3538),(47559,3539),(47560,3539),(47561,3539),(47562,3539),(47563,3539),(47564,3539),(47565,3540),(47566,3540),(47567,3540),(47568,3540),(47569,3540),(47570,3540),(47571,3541),(47572,3541),(47573,3541),(47574,3541),(47575,3541),(47576,3541),(47577,3542),(47578,3542),(47579,3542),(47580,3542),(47581,3542),(47582,3542),(47583,3543),(47584,3543),(47585,3543),(47586,3543),(47587,3543),(47588,3543),(47589,3544),(47590,3544),(47591,3544),(47592,3544),(47593,3544),(47594,3544),(47595,3545),(47596,3545),(47597,3545),(47598,3545),(47599,3545),(47600,3545),(47601,3546),(47602,3546),(47603,3546),(47604,3546),(47605,3546),(47606,3546),(47607,3547),(47608,3547),(47609,3547),(47610,3547),(47611,3547),(47612,3547),(47613,3548),(47614,3548),(47615,3548),(47616,3548),(47617,3548),(47618,3548),(47619,3549),(47620,3549),(47621,3549),(47622,3549),(47623,3550),(47624,3550),(47625,3550),(47626,3550),(47627,3551),(47628,3551),(47629,3551),(47630,3551),(47631,3551),(47632,3551),(47633,3552),(47634,3552),(47635,3552),(47636,3552),(47637,3552),(47638,3552),(47639,3553),(47640,3553),(47641,3553),(47642,3553),(47643,3553),(47644,3553),(47645,3554),(47646,3554),(47647,3554),(47648,3554),(47649,3554),(47650,3554),(47651,3555),(47652,3555),(47653,3555),(47654,3555),(47655,3555),(47656,3555),(47657,3556),(47658,3556),(47659,3556),(47660,3556),(47661,3556),(47662,3556),(47663,3557),(47664,3557),(47665,3557),(47666,3557),(47667,3557),(47668,3557),(47669,3558),(47670,3558),(47671,3558),(47672,3558),(47673,3558),(47674,3558),(47675,3559),(47676,3559),(47677,3559),(47678,3559),(47679,3559),(47680,3559),(47681,3560),(47682,3560),(47683,3560),(47684,3560),(47685,3560),(47686,3560),(47687,3561),(47688,3561),(47689,3561),(47690,3561),(47691,3561),(47692,3561),(47693,3562),(47694,3562),(47695,3562),(47696,3562),(47697,3562),(47698,3562),(47699,3563),(47700,3563),(47701,3563),(47702,3563),(47703,3563),(47704,3563),(47705,3564),(47706,3564),(47707,3564),(47708,3564),(47709,3564),(47710,3564),(47711,3565),(47712,3565),(47713,3565),(47714,3565),(47715,3565),(47716,3565),(47717,3566),(47718,3566),(47719,3566),(47720,3566),(47721,3566),(47722,3566),(47723,3567),(47724,3567),(47725,3567),(47726,3567),(47727,3567),(47728,3567),(47729,3568),(47730,3568),(47731,3568),(47732,3568),(47733,3568),(47734,3568),(47735,3469),(47736,3469),(47737,3469),(47738,3470),(47739,3470),(47740,3470),(47741,3471),(47742,3471),(47743,3471),(47744,3472),(47745,3472),(47746,3472),(47747,3473),(47748,3473),(47749,3473),(47750,3474),(47751,3474),(47752,3474),(47753,3475),(47754,3475),(47755,3475),(47756,3476),(47757,3476),(47758,3476),(47759,3477),(47760,3477),(47761,3477),(47762,3478),(47763,3478),(47764,3478),(47765,3479),(47766,3479),(47767,3479),(47768,3480),(47769,3480),(47770,3480),(47771,3481),(47772,3481),(47773,3481),(47774,3482),(47775,3482),(47776,3482),(47777,3483),(47778,3483),(47779,3483),(47780,3484),(47781,3484),(47782,3484),(47783,3485),(47784,3485),(47785,3485),(47786,3486),(47787,3486),(47788,3486),(47789,3487),(47790,3487),(47791,3487),(47792,3488),(47793,3488),(47794,3488),(47795,3489),(47796,3489),(47797,3489),(47798,3490),(47799,3490),(47800,3490),(47801,3491),(47802,3491),(47803,3491),(47804,3492),(47805,3492),(47806,3492),(47807,3493),(47808,3493),(47809,3493),(47810,3494),(47811,3494),(47812,3494),(47813,3495),(47814,3495),(47815,3495),(47816,3496),(47817,3496),(47818,3496),(47819,3497),(47820,3497),(47821,3497),(47822,3498),(47823,3498),(47824,3498),(47825,3499),(47826,3499),(47827,3499),(47828,3500),(47829,3500),(47830,3500),(47831,3501),(47832,3501),(47833,3501),(47834,3502),(47835,3502),(47836,3502),(47837,3503),(47838,3503),(47839,3503),(47840,3504),(47841,3504),(47842,3504),(47843,3505),(47844,3505),(47845,3505),(47846,3506),(47847,3506),(47848,3506),(47849,3507),(47850,3507),(47851,3507),(47852,3508),(47853,3508),(47854,3508),(47855,3509),(47856,3509),(47857,3509),(47858,3510),(47859,3510),(47860,3510),(47861,3511),(47862,3511),(47863,3511),(47864,3512),(47865,3512),(47866,3512),(47867,3513),(47868,3513),(47869,3513),(47870,3514),(47871,3514),(47872,3514),(47873,3515),(47874,3515),(47875,3515),(47876,3516),(47877,3516),(47878,3516),(47879,3517),(47880,3517),(47881,3517),(47882,3518),(47883,3518),(47884,3518),(47885,3519),(47886,3519),(47887,3519),(47888,3520),(47889,3520),(47890,3520),(47891,3521),(47892,3521),(47893,3521),(47894,3522),(47895,3522),(47896,3522),(47897,3523),(47898,3523),(47899,3523),(47900,3524),(47901,3524),(47902,3524),(47903,3525),(47904,3525),(47905,3525),(47906,3526),(47907,3526),(47908,3526),(47909,3527),(47910,3527),(47911,3527),(47912,3528),(47913,3528),(47914,3528),(47915,3529),(47916,3529),(47917,3529),(47918,3530),(47919,3530),(47920,3530),(47921,3531),(47922,3531),(47923,3531),(47924,3532),(47925,3532),(47926,3532),(47927,3533),(47928,3533),(47929,3533),(47930,3534),(47931,3534),(47932,3534),(47933,3535),(47934,3535),(47935,3535),(47936,3536),(47937,3536),(47938,3536),(47939,3537),(47940,3537),(47941,3537),(47942,3538),(47943,3538),(47944,3538),(47945,3539),(47946,3539),(47947,3539),(47948,3540),(47949,3540),(47950,3540),(47951,3541),(47952,3541),(47953,3541),(47954,3542),(47955,3542),(47956,3542),(47957,3543),(47958,3543),(47959,3543),(47960,3544),(47961,3544),(47962,3544),(47963,3545),(47964,3545),(47965,3545),(47966,3546),(47967,3546),(47968,3546),(47969,3547),(47970,3547),(47971,3547),(47972,3548),(47973,3548),(47974,3548),(47975,3549),(47976,3549),(47977,3549),(47978,3550),(47979,3550),(47980,3550),(47981,3551),(47982,3551),(47983,3551),(47984,3552),(47985,3552),(47986,3552),(47987,3553),(47988,3553),(47989,3553),(47990,3554),(47991,3554),(47992,3554),(47993,3555),(47994,3555),(47995,3555),(47996,3556),(47997,3556),(47998,3556),(47999,3557),(48000,3557),(48001,3557),(48002,3558),(48003,3558),(48004,3558),(48005,3559),(48006,3559),(48007,3559),(48008,3560),(48009,3560),(48010,3560),(48011,3561),(48012,3561),(48013,3561),(48014,3562),(48015,3562),(48016,3562),(48017,3563),(48018,3563),(48019,3563),(48020,3564),(48021,3564),(48022,3564),(48023,3565),(48024,3565),(48025,3565),(48026,3566),(48027,3566),(48028,3566),(48029,3567),(48030,3567),(48031,3567),(48032,3568),(48033,3568),(48034,3568),(48035,3469),(48036,3469),(48037,3469),(48038,3469),(48039,3470),(48040,3470),(48041,3470),(48042,3470),(48043,3471),(48044,3471),(48045,3471),(48046,3471),(48047,3472),(48048,3472),(48049,3472),(48050,3472),(48051,3473),(48052,3473),(48053,3473),(48054,3473),(48055,3474),(48056,3474),(48057,3474),(48058,3474),(48059,3475),(48060,3475),(48061,3475),(48062,3475),(48063,3476),(48064,3476),(48065,3476),(48066,3476),(48067,3477),(48068,3477),(48069,3477),(48070,3477),(48071,3478),(48072,3478),(48073,3478),(48074,3478),(48075,3479),(48076,3479),(48077,3479),(48078,3479),(48079,3480),(48080,3480),(48081,3480),(48082,3480),(48083,3481),(48084,3481),(48085,3481),(48086,3481),(48087,3482),(48088,3482),(48089,3482),(48090,3482),(48091,3483),(48092,3483),(48093,3483),(48094,3483),(48095,3484),(48096,3484),(48097,3484),(48098,3484),(48099,3485),(48100,3485),(48101,3485),(48102,3485),(48103,3486),(48104,3486),(48105,3486),(48106,3486),(48107,3487),(48108,3487),(48109,3487),(48110,3487),(48111,3488),(48112,3488),(48113,3488),(48114,3488),(48115,3489),(48116,3489),(48117,3489),(48118,3489),(48119,3490),(48120,3490),(48121,3490),(48122,3490),(48123,3491),(48124,3491),(48125,3491),(48126,3491),(48127,3492),(48128,3492),(48129,3492),(48130,3492),(48131,3493),(48132,3493),(48133,3493),(48134,3493),(48135,3494),(48136,3494),(48137,3494),(48138,3494),(48139,3495),(48140,3495),(48141,3495),(48142,3495),(48143,3496),(48144,3496),(48145,3496),(48146,3496),(48147,3497),(48148,3497),(48149,3497),(48150,3497),(48151,3498),(48152,3498),(48153,3498),(48154,3498),(48155,3499),(48156,3499),(48157,3499),(48158,3499),(48159,3500),(48160,3500),(48161,3500),(48162,3500),(48163,3501),(48164,3501),(48165,3501),(48166,3501),(48167,3502),(48168,3502),(48169,3502),(48170,3502),(48171,3503),(48172,3503),(48173,3503),(48174,3503),(48175,3504),(48176,3504),(48177,3504),(48178,3504),(48179,3505),(48180,3505),(48181,3505),(48182,3505),(48183,3506),(48184,3506),(48185,3506),(48186,3506),(48187,3507),(48188,3507),(48189,3507),(48190,3507),(48191,3508),(48192,3508),(48193,3508),(48194,3508),(48195,3509),(48196,3509),(48197,3509),(48198,3509),(48199,3510),(48200,3510),(48201,3510),(48202,3510),(48203,3511),(48204,3511),(48205,3511),(48206,3511),(48207,3512),(48208,3512),(48209,3512),(48210,3512),(48211,3513),(48212,3513),(48213,3513),(48214,3513),(48215,3514),(48216,3514),(48217,3514),(48218,3514),(48219,3515),(48220,3515),(48221,3515),(48222,3515),(48223,3516),(48224,3516),(48225,3516),(48226,3516),(48227,3517),(48228,3517),(48229,3517),(48230,3517),(48231,3518),(48232,3518),(48233,3518),(48234,3518),(48235,3519),(48236,3519),(48237,3519),(48238,3519),(48239,3520),(48240,3520),(48241,3520),(48242,3520),(48243,3521),(48244,3521),(48245,3521),(48246,3521),(48247,3522),(48248,3522),(48249,3522),(48250,3522),(48251,3523),(48252,3523),(48253,3523),(48254,3523),(48255,3524),(48256,3524),(48257,3524),(48258,3524),(48259,3525),(48260,3525),(48261,3525),(48262,3525),(48263,3526),(48264,3526),(48265,3526),(48266,3526),(48267,3527),(48268,3527),(48269,3527),(48270,3527),(48271,3528),(48272,3528),(48273,3528),(48274,3528),(48275,3529),(48276,3529),(48277,3529),(48278,3529),(48279,3530),(48280,3530),(48281,3530),(48282,3530),(48283,3531),(48284,3531),(48285,3531),(48286,3531),(48287,3532),(48288,3532),(48289,3532),(48290,3532),(48291,3533),(48292,3533),(48293,3533),(48294,3533),(48295,3534),(48296,3534),(48297,3534),(48298,3534),(48299,3535),(48300,3535),(48301,3535),(48302,3535),(48303,3536),(48304,3536),(48305,3536),(48306,3536),(48307,3537),(48308,3537),(48309,3537),(48310,3537),(48311,3538),(48312,3538),(48313,3538),(48314,3538),(48315,3539),(48316,3539),(48317,3539),(48318,3539),(48319,3540),(48320,3540),(48321,3540),(48322,3540),(48323,3541),(48324,3541),(48325,3541),(48326,3541),(48327,3542),(48328,3542),(48329,3542),(48330,3542),(48331,3543),(48332,3543),(48333,3543),(48334,3543),(48335,3544),(48336,3544),(48337,3544),(48338,3544),(48339,3545),(48340,3545),(48341,3545),(48342,3545),(48343,3546),(48344,3546),(48345,3546),(48346,3546),(48347,3547),(48348,3547),(48349,3547),(48350,3547),(48351,3548),(48352,3548),(48353,3548),(48354,3548),(48355,3549),(48356,3549),(48357,3549),(48358,3549),(48359,3550),(48360,3550),(48361,3550),(48362,3550),(48363,3551),(48364,3551),(48365,3551),(48366,3551),(48367,3552),(48368,3552),(48369,3552),(48370,3552),(48371,3553),(48372,3553),(48373,3553),(48374,3553),(48375,3554),(48376,3554),(48377,3554),(48378,3554),(48379,3555),(48380,3555),(48381,3555),(48382,3555),(48383,3556),(48384,3556),(48385,3556),(48386,3556),(48387,3557),(48388,3557),(48389,3557),(48390,3557),(48391,3558),(48392,3558),(48393,3558),(48394,3558),(48395,3559),(48396,3559),(48397,3559),(48398,3559),(48399,3560),(48400,3560),(48401,3560),(48402,3560),(48403,3561),(48404,3561),(48405,3561),(48406,3561),(48407,3562),(48408,3562),(48409,3562),(48410,3562),(48411,3563),(48412,3563),(48413,3563),(48414,3563),(48415,3564),(48416,3564),(48417,3564),(48418,3564),(48419,3565),(48420,3565),(48421,3565),(48422,3565),(48423,3566),(48424,3566),(48425,3566),(48426,3566),(48427,3567),(48428,3567),(48429,3567),(48430,3567),(48431,3568),(48432,3568),(48433,3568),(48434,3568),(48435,3569),(48436,3569),(48437,3569),(48438,3569),(48439,3569),(48440,3569),(48441,3570),(48442,3570),(48443,3570),(48444,3570),(48445,3570),(48446,3570),(48447,3571),(48448,3571),(48449,3571),(48450,3571),(48451,3571),(48452,3571),(48453,3572),(48454,3572),(48455,3572),(48456,3572),(48457,3572),(48458,3572),(48459,3573),(48460,3573),(48461,3573),(48462,3573),(48463,3573),(48464,3573),(48465,3574),(48466,3574),(48467,3574),(48468,3574),(48469,3574),(48470,3574),(48471,3575),(48472,3575),(48473,3575),(48474,3575),(48475,3575),(48476,3575),(48477,3576),(48478,3576),(48479,3576),(48480,3576),(48481,3576),(48482,3576),(48483,3577),(48484,3577),(48485,3577),(48486,3577),(48487,3577),(48488,3577),(48489,3578),(48490,3578),(48491,3578),(48492,3578),(48493,3578),(48494,3578),(48495,3579),(48496,3579),(48497,3579),(48498,3579),(48499,3579),(48500,3579),(48501,3580),(48502,3580),(48503,3580),(48504,3580),(48505,3580),(48506,3580),(48507,3581),(48508,3581),(48509,3581),(48510,3581),(48511,3581),(48512,3581),(48513,3582),(48514,3582),(48515,3582),(48516,3582),(48517,3582),(48518,3582),(48519,3583),(48520,3583),(48521,3583),(48522,3583),(48523,3583),(48524,3583),(48525,3584),(48526,3584),(48527,3584),(48528,3584),(48529,3584),(48530,3584),(48531,3585),(48532,3585),(48533,3585),(48534,3585),(48535,3585),(48536,3585),(48537,3586),(48538,3586),(48539,3586),(48540,3586),(48541,3586),(48542,3586),(48543,3587),(48544,3587),(48545,3587),(48546,3587),(48547,3587),(48548,3587),(48549,3588),(48550,3588),(48551,3588),(48552,3588),(48553,3588),(48554,3588),(48555,3589),(48556,3589),(48557,3589),(48558,3589),(48559,3589),(48560,3589),(48561,3590),(48562,3590),(48563,3590),(48564,3590),(48565,3590),(48566,3590),(48567,3591),(48568,3591),(48569,3591),(48570,3591),(48571,3591),(48572,3591),(48573,3592),(48574,3592),(48575,3592),(48576,3592),(48577,3592),(48578,3592),(48579,3593),(48580,3593),(48581,3593),(48582,3593),(48583,3593),(48584,3593),(48585,3594),(48586,3594),(48587,3594),(48588,3594),(48589,3594),(48590,3594),(48591,3595),(48592,3595),(48593,3595),(48594,3595),(48595,3595),(48596,3595),(48597,3596),(48598,3596),(48599,3596),(48600,3596),(48601,3596),(48602,3596),(48603,3597),(48604,3597),(48605,3597),(48606,3597),(48607,3597),(48608,3597),(48609,3598),(48610,3598),(48611,3598),(48612,3598),(48613,3598),(48614,3598),(48615,3599),(48616,3599),(48617,3599),(48618,3599),(48619,3599),(48620,3599),(48621,3600),(48622,3600),(48623,3600),(48624,3600),(48625,3600),(48626,3600),(48627,3601),(48628,3601),(48629,3601),(48630,3601),(48631,3601),(48632,3601),(48633,3602),(48634,3602),(48635,3602),(48636,3602),(48637,3602),(48638,3602),(48639,3603),(48640,3603),(48641,3603),(48642,3603),(48643,3603),(48644,3603),(48645,3604),(48646,3604),(48647,3604),(48648,3604),(48649,3604),(48650,3604),(48651,3605),(48652,3605),(48653,3605),(48654,3605),(48655,3605),(48656,3605),(48657,3606),(48658,3606),(48659,3606),(48660,3606),(48661,3606),(48662,3606),(48663,3607),(48664,3607),(48665,3607),(48666,3607),(48667,3607),(48668,3607),(48669,3608),(48670,3608),(48671,3608),(48672,3608),(48673,3608),(48674,3608),(48675,3609),(48676,3609),(48677,3609),(48678,3609),(48679,3609),(48680,3609),(48681,3610),(48682,3610),(48683,3610),(48684,3610),(48685,3611),(48686,3611),(48687,3611),(48688,3611),(48689,3612),(48690,3612),(48691,3612),(48692,3612),(48693,3613),(48694,3613),(48695,3613),(48696,3613),(48697,3614),(48698,3614),(48699,3614),(48700,3614),(48701,3614),(48702,3614),(48703,3615),(48704,3615),(48705,3615),(48706,3615),(48707,3615),(48708,3615),(48709,3616),(48710,3616),(48711,3616),(48712,3616),(48713,3616),(48714,3616),(48715,3617),(48716,3617),(48717,3617),(48718,3617),(48719,3617),(48720,3617),(48721,3618),(48722,3618),(48723,3618),(48724,3618),(48725,3618),(48726,3618),(48727,3619),(48728,3619),(48729,3619),(48730,3619),(48731,3619),(48732,3619),(48733,3620),(48734,3620),(48735,3620),(48736,3620),(48737,3620),(48738,3620),(48739,3621),(48740,3621),(48741,3621),(48742,3621),(48743,3621),(48744,3621),(48745,3622),(48746,3622),(48747,3622),(48748,3622),(48749,3622),(48750,3622),(48751,3623),(48752,3623),(48753,3623),(48754,3623),(48755,3623),(48756,3623),(48757,3624),(48758,3624),(48759,3624),(48760,3624),(48761,3624),(48762,3624),(48763,3625),(48764,3625),(48765,3625),(48766,3625),(48767,3625),(48768,3625),(48769,3626),(48770,3626),(48771,3626),(48772,3626),(48773,3626),(48774,3626),(48775,3627),(48776,3627),(48777,3627),(48778,3627),(48779,3627),(48780,3627),(48781,3628),(48782,3628),(48783,3628),(48784,3628),(48785,3628),(48786,3628),(48787,3629),(48788,3629),(48789,3629),(48790,3629),(48791,3629),(48792,3629),(48793,3630),(48794,3630),(48795,3630),(48796,3630),(48797,3630),(48798,3630),(48799,3631),(48800,3631),(48801,3631),(48802,3631),(48803,3631),(48804,3631),(48805,3632),(48806,3632),(48807,3632),(48808,3632),(48809,3632),(48810,3632),(48811,3633),(48812,3633),(48813,3633),(48814,3633),(48815,3633),(48816,3633),(48817,3634),(48818,3634),(48819,3634),(48820,3634),(48821,3634),(48822,3634),(48823,3635),(48824,3635),(48825,3635),(48826,3635),(48827,3635),(48828,3635),(48829,3636),(48830,3636),(48831,3636),(48832,3636),(48833,3636),(48834,3636),(48835,3637),(48836,3637),(48837,3637),(48838,3637),(48839,3637),(48840,3637),(48841,3638),(48842,3638),(48843,3638),(48844,3638),(48845,3638),(48846,3638),(48847,3639),(48848,3639),(48849,3639),(48850,3639),(48851,3639),(48852,3639),(48853,3640),(48854,3640),(48855,3640),(48856,3640),(48857,3640),(48858,3640),(48859,3641),(48860,3641),(48861,3641),(48862,3641),(48863,3641),(48864,3641),(48865,3642),(48866,3642),(48867,3642),(48868,3642),(48869,3642),(48870,3642),(48871,3643),(48872,3643),(48873,3643),(48874,3643),(48875,3643),(48876,3643),(48877,3644),(48878,3644),(48879,3644),(48880,3644),(48881,3645),(48882,3645),(48883,3645),(48884,3645),(48885,3646),(48886,3646),(48887,3646),(48888,3646),(48889,3647),(48890,3647),(48891,3647),(48892,3647),(48893,3648),(48894,3648),(48895,3648),(48896,3648),(48897,3648),(48898,3648),(48899,3649),(48900,3649),(48901,3649),(48902,3649),(48903,3650),(48904,3650),(48905,3650),(48906,3650),(48907,3651),(48908,3651),(48909,3651),(48910,3651),(48911,3652),(48912,3652),(48913,3652),(48914,3652),(48915,3653),(48916,3653),(48917,3653),(48918,3653),(48919,3654),(48920,3654),(48921,3654),(48922,3654),(48923,3655),(48924,3655),(48925,3655),(48926,3655),(48927,3656),(48928,3656),(48929,3656),(48930,3656),(48931,3657),(48932,3657),(48933,3657),(48934,3657),(48935,3658),(48936,3658),(48937,3658),(48938,3658),(48939,3659),(48940,3659),(48941,3659),(48942,3659),(48943,3659),(48944,3659),(48945,3660),(48946,3660),(48947,3660),(48948,3660),(48949,3660),(48950,3660),(48951,3661),(48952,3661),(48953,3661),(48954,3661),(48955,3661),(48956,3661),(48957,3662),(48958,3662),(48959,3662),(48960,3662),(48961,3662),(48962,3662),(48963,3663),(48964,3663),(48965,3663),(48966,3663),(48967,3663),(48968,3663),(48969,3664),(48970,3664),(48971,3664),(48972,3664),(48973,3664),(48974,3664),(48975,3665),(48976,3665),(48977,3665),(48978,3665),(48979,3665),(48980,3665),(48981,3666),(48982,3666),(48983,3666),(48984,3666),(48985,3666),(48986,3666),(48987,3667),(48988,3667),(48989,3667),(48990,3667),(48991,3667),(48992,3667),(48993,3668),(48994,3668),(48995,3668),(48996,3668),(48997,3668),(48998,3668),(48999,3569),(49000,3569),(49001,3569),(49002,3570),(49003,3570),(49004,3570),(49005,3571),(49006,3571),(49007,3571),(49008,3572),(49009,3572),(49010,3572),(49011,3573),(49012,3573),(49013,3573),(49014,3574),(49015,3574),(49016,3574),(49017,3575),(49018,3575),(49019,3575),(49020,3576),(49021,3576),(49022,3576),(49023,3577),(49024,3577),(49025,3577),(49026,3578),(49027,3578),(49028,3578),(49029,3579),(49030,3579),(49031,3579),(49032,3580),(49033,3580),(49034,3580),(49035,3581),(49036,3581),(49037,3581),(49038,3582),(49039,3582),(49040,3582),(49041,3583),(49042,3583),(49043,3583),(49044,3584),(49045,3584),(49046,3584),(49047,3585),(49048,3585),(49049,3585),(49050,3586),(49051,3586),(49052,3586),(49053,3587),(49054,3587),(49055,3587),(49056,3588),(49057,3588),(49058,3588),(49059,3589),(49060,3589),(49061,3589),(49062,3590),(49063,3590),(49064,3590),(49065,3591),(49066,3591),(49067,3591),(49068,3592),(49069,3592),(49070,3592),(49071,3593),(49072,3593),(49073,3593),(49074,3594),(49075,3594),(49076,3594),(49077,3595),(49078,3595),(49079,3595),(49080,3596),(49081,3596),(49082,3596),(49083,3597),(49084,3597),(49085,3597),(49086,3598),(49087,3598),(49088,3598),(49089,3599),(49090,3599),(49091,3599),(49092,3600),(49093,3600),(49094,3600),(49095,3601),(49096,3601),(49097,3601),(49098,3602),(49099,3602),(49100,3602),(49101,3603),(49102,3603),(49103,3603),(49104,3604),(49105,3604),(49106,3604),(49107,3605),(49108,3605),(49109,3605),(49110,3606),(49111,3606),(49112,3606),(49113,3607),(49114,3607),(49115,3607),(49116,3608),(49117,3608),(49118,3608),(49119,3609),(49120,3609),(49121,3609),(49122,3610),(49123,3610),(49124,3610),(49125,3611),(49126,3611),(49127,3611),(49128,3612),(49129,3612),(49130,3612),(49131,3613),(49132,3613),(49133,3613),(49134,3614),(49135,3614),(49136,3614),(49137,3615),(49138,3615),(49139,3615),(49140,3616),(49141,3616),(49142,3616),(49143,3617),(49144,3617),(49145,3617),(49146,3618),(49147,3618),(49148,3618),(49149,3619),(49150,3619),(49151,3619),(49152,3620),(49153,3620),(49154,3620),(49155,3621),(49156,3621),(49157,3621),(49158,3622),(49159,3622),(49160,3622),(49161,3623),(49162,3623),(49163,3623),(49164,3624),(49165,3624),(49166,3624),(49167,3625),(49168,3625),(49169,3625),(49170,3626),(49171,3626),(49172,3626),(49173,3627),(49174,3627),(49175,3627),(49176,3628),(49177,3628),(49178,3628),(49179,3629),(49180,3629),(49181,3629),(49182,3630),(49183,3630),(49184,3630),(49185,3631),(49186,3631),(49187,3631),(49188,3632),(49189,3632),(49190,3632),(49191,3633),(49192,3633),(49193,3633),(49194,3634),(49195,3634),(49196,3634),(49197,3635),(49198,3635),(49199,3635),(49200,3636),(49201,3636),(49202,3636),(49203,3637),(49204,3637),(49205,3637),(49206,3638),(49207,3638),(49208,3638),(49209,3639),(49210,3639),(49211,3639),(49212,3640),(49213,3640),(49214,3640),(49215,3641),(49216,3641),(49217,3641),(49218,3642),(49219,3642),(49220,3642),(49221,3643),(49222,3643),(49223,3643),(49224,3644),(49225,3644),(49226,3644),(49227,3645),(49228,3645),(49229,3645),(49230,3646),(49231,3646),(49232,3646),(49233,3647),(49234,3647),(49235,3647),(49236,3648),(49237,3648),(49238,3648),(49239,3649),(49240,3649),(49241,3649),(49242,3650),(49243,3650),(49244,3650),(49245,3651),(49246,3651),(49247,3651),(49248,3652),(49249,3652),(49250,3652),(49251,3653),(49252,3653),(49253,3653),(49254,3654),(49255,3654),(49256,3654),(49257,3655),(49258,3655),(49259,3655),(49260,3656),(49261,3656),(49262,3656),(49263,3657),(49264,3657),(49265,3657),(49266,3658),(49267,3658),(49268,3658),(49269,3659),(49270,3659),(49271,3659),(49272,3660),(49273,3660),(49274,3660),(49275,3661),(49276,3661),(49277,3661),(49278,3662),(49279,3662),(49280,3662),(49281,3663),(49282,3663),(49283,3663),(49284,3664),(49285,3664),(49286,3664),(49287,3665),(49288,3665),(49289,3665),(49290,3666),(49291,3666),(49292,3666),(49293,3667),(49294,3667),(49295,3667),(49296,3668),(49297,3668),(49298,3668),(49299,3569),(49300,3569),(49301,3569),(49302,3569),(49303,3570),(49304,3570),(49305,3570),(49306,3570),(49307,3571),(49308,3571),(49309,3571),(49310,3571),(49311,3572),(49312,3572),(49313,3572),(49314,3572),(49315,3573),(49316,3573),(49317,3573),(49318,3573),(49319,3574),(49320,3574),(49321,3574),(49322,3574),(49323,3575),(49324,3575),(49325,3575),(49326,3575),(49327,3576),(49328,3576),(49329,3576),(49330,3576),(49331,3577),(49332,3577),(49333,3577),(49334,3577),(49335,3578),(49336,3578),(49337,3578),(49338,3578),(49339,3579),(49340,3579),(49341,3579),(49342,3579),(49343,3580),(49344,3580),(49345,3580),(49346,3580),(49347,3581),(49348,3581),(49349,3581),(49350,3581),(49351,3582),(49352,3582),(49353,3582),(49354,3582),(49355,3583),(49356,3583),(49357,3583),(49358,3583),(49359,3584),(49360,3584),(49361,3584),(49362,3584),(49363,3585),(49364,3585),(49365,3585),(49366,3585),(49367,3586),(49368,3586),(49369,3586),(49370,3586),(49371,3587),(49372,3587),(49373,3587),(49374,3587),(49375,3588),(49376,3588),(49377,3588),(49378,3588),(49379,3589),(49380,3589),(49381,3589),(49382,3589),(49383,3590),(49384,3590),(49385,3590),(49386,3590),(49387,3591),(49388,3591),(49389,3591),(49390,3591),(49391,3592),(49392,3592),(49393,3592),(49394,3592),(49395,3593),(49396,3593),(49397,3593),(49398,3593),(49399,3594),(49400,3594),(49401,3594),(49402,3594),(49403,3595),(49404,3595),(49405,3595),(49406,3595),(49407,3596),(49408,3596),(49409,3596),(49410,3596),(49411,3597),(49412,3597),(49413,3597),(49414,3597),(49415,3598),(49416,3598),(49417,3598),(49418,3598),(49419,3599),(49420,3599),(49421,3599),(49422,3599),(49423,3600),(49424,3600),(49425,3600),(49426,3600),(49427,3601),(49428,3601),(49429,3601),(49430,3601),(49431,3602),(49432,3602),(49433,3602),(49434,3602),(49435,3603),(49436,3603),(49437,3603),(49438,3603),(49439,3604),(49440,3604),(49441,3604),(49442,3604),(49443,3605),(49444,3605),(49445,3605),(49446,3605),(49447,3606),(49448,3606),(49449,3606),(49450,3606),(49451,3607),(49452,3607),(49453,3607),(49454,3607),(49455,3608),(49456,3608),(49457,3608),(49458,3608),(49459,3609),(49460,3609),(49461,3609),(49462,3609),(49463,3610),(49464,3610),(49465,3610),(49466,3610),(49467,3611),(49468,3611),(49469,3611),(49470,3611),(49471,3612),(49472,3612),(49473,3612),(49474,3612),(49475,3613),(49476,3613),(49477,3613),(49478,3613),(49479,3614),(49480,3614),(49481,3614),(49482,3614),(49483,3615),(49484,3615),(49485,3615),(49486,3615),(49487,3616),(49488,3616),(49489,3616),(49490,3616),(49491,3617),(49492,3617),(49493,3617),(49494,3617),(49495,3618),(49496,3618),(49497,3618),(49498,3618),(49499,3619),(49500,3619),(49501,3619),(49502,3619),(49503,3620),(49504,3620),(49505,3620),(49506,3620),(49507,3621),(49508,3621),(49509,3621),(49510,3621),(49511,3622),(49512,3622),(49513,3622),(49514,3622),(49515,3623),(49516,3623),(49517,3623),(49518,3623),(49519,3624),(49520,3624),(49521,3624),(49522,3624),(49523,3625),(49524,3625),(49525,3625),(49526,3625),(49527,3626),(49528,3626),(49529,3626),(49530,3626),(49531,3627),(49532,3627),(49533,3627),(49534,3627),(49535,3628),(49536,3628),(49537,3628),(49538,3628),(49539,3629),(49540,3629),(49541,3629),(49542,3629),(49543,3630),(49544,3630),(49545,3630),(49546,3630),(49547,3631),(49548,3631),(49549,3631),(49550,3631),(49551,3632),(49552,3632),(49553,3632),(49554,3632),(49555,3633),(49556,3633),(49557,3633),(49558,3633),(49559,3634),(49560,3634),(49561,3634),(49562,3634),(49563,3635),(49564,3635),(49565,3635),(49566,3635),(49567,3636),(49568,3636),(49569,3636),(49570,3636),(49571,3637),(49572,3637),(49573,3637),(49574,3637),(49575,3638),(49576,3638),(49577,3638),(49578,3638),(49579,3639),(49580,3639),(49581,3639),(49582,3639),(49583,3640),(49584,3640),(49585,3640),(49586,3640),(49587,3641),(49588,3641),(49589,3641),(49590,3641),(49591,3642),(49592,3642),(49593,3642),(49594,3642),(49595,3643),(49596,3643),(49597,3643),(49598,3643),(49599,3644),(49600,3644),(49601,3644),(49602,3644),(49603,3645),(49604,3645),(49605,3645),(49606,3645),(49607,3646),(49608,3646),(49609,3646),(49610,3646),(49611,3647),(49612,3647),(49613,3647),(49614,3647),(49615,3648),(49616,3648),(49617,3648),(49618,3648),(49619,3649),(49620,3649),(49621,3649),(49622,3649),(49623,3650),(49624,3650),(49625,3650),(49626,3650),(49627,3651),(49628,3651),(49629,3651),(49630,3651),(49631,3652),(49632,3652),(49633,3652),(49634,3652),(49635,3653),(49636,3653),(49637,3653),(49638,3653),(49639,3654),(49640,3654),(49641,3654),(49642,3654),(49643,3655),(49644,3655),(49645,3655),(49646,3655),(49647,3656),(49648,3656),(49649,3656),(49650,3656),(49651,3657),(49652,3657),(49653,3657),(49654,3657),(49655,3658),(49656,3658),(49657,3658),(49658,3658),(49659,3659),(49660,3659),(49661,3659),(49662,3659),(49663,3660),(49664,3660),(49665,3660),(49666,3660),(49667,3661),(49668,3661),(49669,3661),(49670,3661),(49671,3662),(49672,3662),(49673,3662),(49674,3662),(49675,3663),(49676,3663),(49677,3663),(49678,3663),(49679,3664),(49680,3664),(49681,3664),(49682,3664),(49683,3665),(49684,3665),(49685,3665),(49686,3665),(49687,3666),(49688,3666),(49689,3666),(49690,3666),(49691,3667),(49692,3667),(49693,3667),(49694,3667),(49695,3668),(49696,3668),(49697,3668),(49698,3668),(49699,3669),(49700,3669),(49701,3669),(49702,3669),(49703,3669),(49704,3669),(49705,3670),(49706,3670),(49707,3670),(49708,3670),(49709,3670),(49710,3670),(49711,3671),(49712,3671),(49713,3671),(49714,3671),(49715,3671),(49716,3671),(49717,3672),(49718,3672),(49719,3672),(49720,3672),(49721,3672),(49722,3672),(49723,3673),(49724,3673),(49725,3673),(49726,3673),(49727,3673),(49728,3673),(49729,3674),(49730,3674),(49731,3674),(49732,3674),(49733,3674),(49734,3674),(49735,3675),(49736,3675),(49737,3675),(49738,3675),(49739,3675),(49740,3675),(49741,3676),(49742,3676),(49743,3676),(49744,3676),(49745,3676),(49746,3676),(49747,3677),(49748,3677),(49749,3677),(49750,3677),(49751,3677),(49752,3677),(49753,3678),(49754,3678),(49755,3678),(49756,3678),(49757,3678),(49758,3678),(49759,3679),(49760,3679),(49761,3679),(49762,3679),(49763,3679),(49764,3679),(49765,3680),(49766,3680),(49767,3680),(49768,3680),(49769,3680),(49770,3680),(49771,3681),(49772,3681),(49773,3681),(49774,3681),(49775,3681),(49776,3681),(49777,3682),(49778,3682),(49779,3682),(49780,3682),(49781,3682),(49782,3682),(49783,3683),(49784,3683),(49785,3683),(49786,3683),(49787,3683),(49788,3683),(49789,3684),(49790,3684),(49791,3684),(49792,3684),(49793,3685),(49794,3685),(49795,3685),(49796,3685),(49797,3686),(49798,3686),(49799,3686),(49800,3686),(49801,3686),(49802,3686),(49803,3687),(49804,3687),(49805,3687),(49806,3687),(49807,3687),(49808,3687),(49809,3688),(49810,3688),(49811,3688),(49812,3688),(49813,3688),(49814,3688),(49815,3689),(49816,3689),(49817,3689),(49818,3689),(49819,3689),(49820,3689),(49821,3690),(49822,3690),(49823,3690),(49824,3690),(49825,3690),(49826,3690),(49827,3691),(49828,3691),(49829,3691),(49830,3691),(49831,3691),(49832,3691),(49833,3692),(49834,3692),(49835,3692),(49836,3692),(49837,3692),(49838,3692),(49839,3693),(49840,3693),(49841,3693),(49842,3693),(49843,3693),(49844,3693),(49845,3694),(49846,3694),(49847,3694),(49848,3694),(49849,3694),(49850,3694),(49851,3695),(49852,3695),(49853,3695),(49854,3695),(49855,3695),(49856,3695),(49857,3696),(49858,3696),(49859,3696),(49860,3696),(49861,3696),(49862,3696),(49863,3697),(49864,3697),(49865,3697),(49866,3697),(49867,3697),(49868,3697),(49869,3698),(49870,3698),(49871,3698),(49872,3698),(49873,3698),(49874,3698),(49875,3699),(49876,3699),(49877,3699),(49878,3699),(49879,3699),(49880,3699),(49881,3700),(49882,3700),(49883,3700),(49884,3700),(49885,3700),(49886,3700),(49887,3701),(49888,3701),(49889,3701),(49890,3701),(49891,3701),(49892,3701),(49893,3702),(49894,3702),(49895,3702),(49896,3702),(49897,3702),(49898,3702),(49899,3703),(49900,3703),(49901,3703),(49902,3703),(49903,3703),(49904,3703),(49905,3704),(49906,3704),(49907,3704),(49908,3704),(49909,3704),(49910,3704),(49911,3705),(49912,3705),(49913,3705),(49914,3705),(49915,3705),(49916,3705),(49917,3706),(49918,3706),(49919,3706),(49920,3706),(49921,3706),(49922,3706),(49923,3707),(49924,3707),(49925,3707),(49926,3707),(49927,3707),(49928,3707),(49929,3708),(49930,3708),(49931,3708),(49932,3708),(49933,3708),(49934,3708),(49935,3709),(49936,3709),(49937,3709),(49938,3709),(49939,3709),(49940,3709),(49941,3710),(49942,3710),(49943,3710),(49944,3710),(49945,3710),(49946,3710),(49947,3711),(49948,3711),(49949,3711),(49950,3711),(49951,3711),(49952,3711),(49953,3712),(49954,3712),(49955,3712),(49956,3712),(49957,3712),(49958,3712),(49959,3713),(49960,3713),(49961,3713),(49962,3713),(49963,3713),(49964,3713),(49965,3714),(49966,3714),(49967,3714),(49968,3714),(49969,3714),(49970,3714),(49971,3669),(49972,3669),(49973,3669),(49974,3670),(49975,3670),(49976,3670),(49977,3671),(49978,3671),(49979,3671),(49980,3672),(49981,3672),(49982,3672),(49983,3673),(49984,3673),(49985,3673),(49986,3674),(49987,3674),(49988,3674),(49989,3675),(49990,3675),(49991,3675),(49992,3676),(49993,3676),(49994,3676),(49995,3677),(49996,3677),(49997,3677),(49998,3678),(49999,3678),(50000,3678),(50001,3679),(50002,3679),(50003,3679),(50004,3680),(50005,3680),(50006,3680),(50007,3681),(50008,3681),(50009,3681),(50010,3682),(50011,3682),(50012,3682),(50013,3683),(50014,3683),(50015,3683),(50016,3684),(50017,3684),(50018,3684),(50019,3685),(50020,3685),(50021,3685),(50022,3686),(50023,3686),(50024,3686),(50025,3687),(50026,3687),(50027,3687),(50028,3688),(50029,3688),(50030,3688),(50031,3689),(50032,3689),(50033,3689),(50034,3690),(50035,3690),(50036,3690),(50037,3691),(50038,3691),(50039,3691),(50040,3692),(50041,3692),(50042,3692),(50043,3693),(50044,3693),(50045,3693),(50046,3694),(50047,3694),(50048,3694),(50049,3695),(50050,3695),(50051,3695),(50052,3696),(50053,3696),(50054,3696),(50055,3697),(50056,3697),(50057,3697),(50058,3698),(50059,3698),(50060,3698),(50061,3699),(50062,3699),(50063,3699),(50064,3700),(50065,3700),(50066,3700),(50067,3701),(50068,3701),(50069,3701),(50070,3702),(50071,3702),(50072,3702),(50073,3703),(50074,3703),(50075,3703),(50076,3704),(50077,3704),(50078,3704),(50079,3705),(50080,3705),(50081,3705),(50082,3706),(50083,3706),(50084,3706),(50085,3707),(50086,3707),(50087,3707),(50088,3708),(50089,3708),(50090,3708),(50091,3709),(50092,3709),(50093,3709),(50094,3710),(50095,3710),(50096,3710),(50097,3711),(50098,3711),(50099,3711),(50100,3712),(50101,3712),(50102,3712),(50103,3713),(50104,3713),(50105,3713),(50106,3714),(50107,3714),(50108,3714),(50109,3669),(50110,3669),(50111,3669),(50112,3669),(50113,3670),(50114,3670),(50115,3670),(50116,3670),(50117,3671),(50118,3671),(50119,3671),(50120,3671),(50121,3672),(50122,3672),(50123,3672),(50124,3672),(50125,3673),(50126,3673),(50127,3673),(50128,3673),(50129,3674),(50130,3674),(50131,3674),(50132,3674),(50133,3675),(50134,3675),(50135,3675),(50136,3675),(50137,3676),(50138,3676),(50139,3676),(50140,3676),(50141,3677),(50142,3677),(50143,3677),(50144,3677),(50145,3678),(50146,3678),(50147,3678),(50148,3678),(50149,3679),(50150,3679),(50151,3679),(50152,3679),(50153,3680),(50154,3680),(50155,3680),(50156,3680),(50157,3681),(50158,3681),(50159,3681),(50160,3681),(50161,3682),(50162,3682),(50163,3682),(50164,3682),(50165,3683),(50166,3683),(50167,3683),(50168,3683),(50169,3684),(50170,3684),(50171,3684),(50172,3684),(50173,3685),(50174,3685),(50175,3685),(50176,3685),(50177,3686),(50178,3686),(50179,3686),(50180,3686),(50181,3687),(50182,3687),(50183,3687),(50184,3687),(50185,3688),(50186,3688),(50187,3688),(50188,3688),(50189,3689),(50190,3689),(50191,3689),(50192,3689),(50193,3690),(50194,3690),(50195,3690),(50196,3690),(50197,3691),(50198,3691),(50199,3691),(50200,3691),(50201,3692),(50202,3692),(50203,3692),(50204,3692),(50205,3693),(50206,3693),(50207,3693),(50208,3693),(50209,3694),(50210,3694),(50211,3694),(50212,3694),(50213,3695),(50214,3695),(50215,3695),(50216,3695),(50217,3696),(50218,3696),(50219,3696),(50220,3696),(50221,3697),(50222,3697),(50223,3697),(50224,3697),(50225,3698),(50226,3698),(50227,3698),(50228,3698),(50229,3699),(50230,3699),(50231,3699),(50232,3699),(50233,3700),(50234,3700),(50235,3700),(50236,3700),(50237,3701),(50238,3701),(50239,3701),(50240,3701),(50241,3702),(50242,3702),(50243,3702),(50244,3702),(50245,3703),(50246,3703),(50247,3703),(50248,3703),(50249,3704),(50250,3704),(50251,3704),(50252,3704),(50253,3705),(50254,3705),(50255,3705),(50256,3705),(50257,3706),(50258,3706),(50259,3706),(50260,3706),(50261,3707),(50262,3707),(50263,3707),(50264,3707),(50265,3708),(50266,3708),(50267,3708),(50268,3708),(50269,3709),(50270,3709),(50271,3709),(50272,3709),(50273,3710),(50274,3710),(50275,3710),(50276,3710),(50277,3711),(50278,3711),(50279,3711),(50280,3711),(50281,3712),(50282,3712),(50283,3712),(50284,3712),(50285,3713),(50286,3713),(50287,3713),(50288,3713),(50289,3714),(50290,3714),(50291,3714),(50292,3714),(50293,3715),(50294,3715),(50295,3715),(50296,3715),(50297,3715),(50298,3715),(50299,3716),(50300,3716),(50301,3716),(50302,3716),(50303,3716),(50304,3716),(50305,3717),(50306,3717),(50307,3717),(50308,3717),(50309,3717),(50310,3717),(50311,3718),(50312,3718),(50313,3718),(50314,3718),(50315,3718),(50316,3718),(50317,3719),(50318,3719),(50319,3719),(50320,3719),(50321,3719),(50322,3719),(50323,3720),(50324,3720),(50325,3720),(50326,3720),(50327,3720),(50328,3720),(50329,3721),(50330,3721),(50331,3721),(50332,3721),(50333,3721),(50334,3721),(50335,3722),(50336,3722),(50337,3722),(50338,3722),(50339,3722),(50340,3722),(50341,3723),(50342,3723),(50343,3723),(50344,3723),(50345,3723),(50346,3723),(50347,3724),(50348,3724),(50349,3724),(50350,3724),(50351,3724),(50352,3724),(50353,3725),(50354,3725),(50355,3725),(50356,3725),(50357,3725),(50358,3725),(50359,3726),(50360,3726),(50361,3726),(50362,3726),(50363,3726),(50364,3726),(50365,3727),(50366,3727),(50367,3727),(50368,3727),(50369,3727),(50370,3727),(50371,3728),(50372,3728),(50373,3728),(50374,3728),(50375,3728),(50376,3728),(50377,3729),(50378,3729),(50379,3729),(50380,3729),(50381,3729),(50382,3729),(50383,3730),(50384,3730),(50385,3730),(50386,3730),(50387,3730),(50388,3730),(50389,3731),(50390,3731),(50391,3731),(50392,3731),(50393,3731),(50394,3731),(50395,3732),(50396,3732),(50397,3732),(50398,3732),(50399,3732),(50400,3732),(50401,3733),(50402,3733),(50403,3733),(50404,3733),(50405,3733),(50406,3733),(50407,3734),(50408,3734),(50409,3734),(50410,3734),(50411,3734),(50412,3734),(50413,3735),(50414,3735),(50415,3735),(50416,3735),(50417,3735),(50418,3735),(50419,3736),(50420,3736),(50421,3736),(50422,3736),(50423,3736),(50424,3736),(50425,3737),(50426,3737),(50427,3737),(50428,3737),(50429,3737),(50430,3737),(50431,3738),(50432,3738),(50433,3738),(50434,3738),(50435,3738),(50436,3738),(50437,3739),(50438,3739),(50439,3739),(50440,3739),(50441,3739),(50442,3739),(50443,3740),(50444,3740),(50445,3740),(50446,3740),(50447,3740),(50448,3740),(50449,3741),(50450,3741),(50451,3741),(50452,3741),(50453,3741),(50454,3741),(50455,3742),(50456,3742),(50457,3742),(50458,3742),(50459,3742),(50460,3742),(50461,3743),(50462,3743),(50463,3743),(50464,3743),(50465,3743),(50466,3743),(50467,3744),(50468,3744),(50469,3744),(50470,3744),(50471,3744),(50472,3744),(50473,3745),(50474,3745),(50475,3745),(50476,3745),(50477,3745),(50478,3745),(50479,3746),(50480,3746),(50481,3746),(50482,3746),(50483,3746),(50484,3746),(50485,3747),(50486,3747),(50487,3747),(50488,3747),(50489,3747),(50490,3747),(50491,3748),(50492,3748),(50493,3748),(50494,3748),(50495,3748),(50496,3748),(50497,3749),(50498,3749),(50499,3749),(50500,3749),(50501,3749),(50502,3749),(50503,3750),(50504,3750),(50505,3750),(50506,3750),(50507,3750),(50508,3750),(50509,3751),(50510,3751),(50511,3751),(50512,3751),(50513,3751),(50514,3751),(50515,3752),(50516,3752),(50517,3752),(50518,3752),(50519,3752),(50520,3752),(50521,3753),(50522,3753),(50523,3753),(50524,3753),(50525,3753),(50526,3753),(50527,3754),(50528,3754),(50529,3754),(50530,3754),(50531,3754),(50532,3754),(50533,3755),(50534,3755),(50535,3755),(50536,3755),(50537,3755),(50538,3755),(50539,3756),(50540,3756),(50541,3756),(50542,3756),(50543,3756),(50544,3756),(50545,3757),(50546,3757),(50547,3757),(50548,3757),(50549,3757),(50550,3757),(50551,3758),(50552,3758),(50553,3758),(50554,3758),(50555,3758),(50556,3758),(50557,3759),(50558,3759),(50559,3759),(50560,3759),(50561,3759),(50562,3759),(50563,3760),(50564,3760),(50565,3760),(50566,3760),(50567,3760),(50568,3760),(50569,3761),(50570,3761),(50571,3761),(50572,3761),(50573,3761),(50574,3761),(50575,3762),(50576,3762),(50577,3762),(50578,3762),(50579,3762),(50580,3762),(50581,3763),(50582,3763),(50583,3763),(50584,3763),(50585,3763),(50586,3763),(50587,3764),(50588,3764),(50589,3764),(50590,3764),(50591,3764),(50592,3764),(50593,3765),(50594,3765),(50595,3765),(50596,3765),(50597,3765),(50598,3765),(50599,3766),(50600,3766),(50601,3766),(50602,3766),(50603,3766),(50604,3766),(50605,3767),(50606,3767),(50607,3767),(50608,3767),(50609,3767),(50610,3767),(50611,3768),(50612,3768),(50613,3768),(50614,3768),(50615,3768),(50616,3768),(50617,3769),(50618,3769),(50619,3769),(50620,3769),(50621,3769),(50622,3769),(50623,3770),(50624,3770),(50625,3770),(50626,3770),(50627,3770),(50628,3770),(50629,3771),(50630,3771),(50631,3771),(50632,3771),(50633,3771),(50634,3771),(50635,3772),(50636,3772),(50637,3772),(50638,3772),(50639,3772),(50640,3772),(50641,3773),(50642,3773),(50643,3773),(50644,3773),(50645,3773),(50646,3773),(50647,3774),(50648,3774),(50649,3774),(50650,3774),(50651,3774),(50652,3774),(50653,3775),(50654,3775),(50655,3775),(50656,3775),(50657,3775),(50658,3775),(50659,3776),(50660,3776),(50661,3776),(50662,3776),(50663,3776),(50664,3776),(50665,3777),(50666,3777),(50667,3777),(50668,3777),(50669,3777),(50670,3777),(50671,3778),(50672,3778),(50673,3778),(50674,3778),(50675,3778),(50676,3778),(50677,3779),(50678,3779),(50679,3779),(50680,3779),(50681,3779),(50682,3779),(50683,3780),(50684,3780),(50685,3780),(50686,3780),(50687,3780),(50688,3780),(50689,3781),(50690,3781),(50691,3781),(50692,3781),(50693,3781),(50694,3781),(50695,3782),(50696,3782),(50697,3782),(50698,3782),(50699,3782),(50700,3782),(50701,3783),(50702,3783),(50703,3783),(50704,3783),(50705,3783),(50706,3783),(50707,3784),(50708,3784),(50709,3784),(50710,3784),(50711,3784),(50712,3784),(50713,3785),(50714,3785),(50715,3785),(50716,3785),(50717,3785),(50718,3785),(50719,3786),(50720,3786),(50721,3786),(50722,3786),(50723,3786),(50724,3786),(50725,3787),(50726,3787),(50727,3787),(50728,3787),(50729,3787),(50730,3787),(50731,3788),(50732,3788),(50733,3788),(50734,3788),(50735,3788),(50736,3788),(50737,3789),(50738,3789),(50739,3789),(50740,3789),(50741,3789),(50742,3789),(50743,3790),(50744,3790),(50745,3790),(50746,3790),(50747,3790),(50748,3790),(50749,3791),(50750,3791),(50751,3791),(50752,3791),(50753,3791),(50754,3791),(50755,3792),(50756,3792),(50757,3792),(50758,3792),(50759,3792),(50760,3792),(50761,3793),(50762,3793),(50763,3793),(50764,3793),(50765,3793),(50766,3793),(50767,3794),(50768,3794),(50769,3794),(50770,3794),(50771,3794),(50772,3794),(50773,3795),(50774,3795),(50775,3795),(50776,3795),(50777,3795),(50778,3795),(50779,3796),(50780,3796),(50781,3796),(50782,3796),(50783,3796),(50784,3796),(50785,3797),(50786,3797),(50787,3797),(50788,3797),(50789,3797),(50790,3797),(50791,3798),(50792,3798),(50793,3798),(50794,3798),(50795,3798),(50796,3798),(50797,3799),(50798,3799),(50799,3799),(50800,3799),(50801,3799),(50802,3799),(50803,3800),(50804,3800),(50805,3800),(50806,3800),(50807,3800),(50808,3800),(50809,3801),(50810,3801),(50811,3801),(50812,3801),(50813,3801),(50814,3801),(50815,3802),(50816,3802),(50817,3802),(50818,3802),(50819,3802),(50820,3802),(50821,3803),(50822,3803),(50823,3803),(50824,3803),(50825,3803),(50826,3803),(50827,3804),(50828,3804),(50829,3804),(50830,3804),(50831,3804),(50832,3804),(50833,3805),(50834,3805),(50835,3805),(50836,3805),(50837,3805),(50838,3805),(50839,3806),(50840,3806),(50841,3806),(50842,3806),(50843,3806),(50844,3806),(50845,3807),(50846,3807),(50847,3807),(50848,3807),(50849,3807),(50850,3807),(50851,3808),(50852,3808),(50853,3808),(50854,3808),(50855,3808),(50856,3808),(50857,3809),(50858,3809),(50859,3809),(50860,3809),(50861,3809),(50862,3809),(50863,3810),(50864,3810),(50865,3810),(50866,3810),(50867,3810),(50868,3810),(50869,3811),(50870,3811),(50871,3811),(50872,3811),(50873,3811),(50874,3811),(50875,3812),(50876,3812),(50877,3812),(50878,3812),(50879,3812),(50880,3812),(50881,3813),(50882,3813),(50883,3813),(50884,3813),(50885,3813),(50886,3813),(50887,3814),(50888,3814),(50889,3814),(50890,3814),(50891,3814),(50892,3814),(50893,3715),(50894,3715),(50895,3715),(50896,3716),(50897,3716),(50898,3716),(50899,3717),(50900,3717),(50901,3717),(50902,3718),(50903,3718),(50904,3718),(50905,3719),(50906,3719),(50907,3719),(50908,3720),(50909,3720),(50910,3720),(50911,3721),(50912,3721),(50913,3721),(50914,3722),(50915,3722),(50916,3722),(50917,3723),(50918,3723),(50919,3723),(50920,3724),(50921,3724),(50922,3724),(50923,3725),(50924,3725),(50925,3725),(50926,3726),(50927,3726),(50928,3726),(50929,3727),(50930,3727),(50931,3727),(50932,3728),(50933,3728),(50934,3728),(50935,3729),(50936,3729),(50937,3729),(50938,3730),(50939,3730),(50940,3730),(50941,3731),(50942,3731),(50943,3731),(50944,3732),(50945,3732),(50946,3732),(50947,3733),(50948,3733),(50949,3733),(50950,3734),(50951,3734),(50952,3734),(50953,3735),(50954,3735),(50955,3735),(50956,3736),(50957,3736),(50958,3736),(50959,3737),(50960,3737),(50961,3737),(50962,3738),(50963,3738),(50964,3738),(50965,3739),(50966,3739),(50967,3739),(50968,3740),(50969,3740),(50970,3740),(50971,3741),(50972,3741),(50973,3741),(50974,3742),(50975,3742),(50976,3742),(50977,3743),(50978,3743),(50979,3743),(50980,3744),(50981,3744),(50982,3744),(50983,3745),(50984,3745),(50985,3745),(50986,3746),(50987,3746),(50988,3746),(50989,3747),(50990,3747),(50991,3747),(50992,3748),(50993,3748),(50994,3748),(50995,3749),(50996,3749),(50997,3749),(50998,3750),(50999,3750),(51000,3750),(51001,3751),(51002,3751),(51003,3751),(51004,3752),(51005,3752),(51006,3752),(51007,3753),(51008,3753),(51009,3753),(51010,3754),(51011,3754),(51012,3754),(51013,3755),(51014,3755),(51015,3755),(51016,3756),(51017,3756),(51018,3756),(51019,3757),(51020,3757),(51021,3757),(51022,3758),(51023,3758),(51024,3758),(51025,3759),(51026,3759),(51027,3759),(51028,3760),(51029,3760),(51030,3760),(51031,3761),(51032,3761),(51033,3761),(51034,3762),(51035,3762),(51036,3762),(51037,3763),(51038,3763),(51039,3763),(51040,3764),(51041,3764),(51042,3764),(51043,3765),(51044,3765),(51045,3765),(51046,3766),(51047,3766),(51048,3766),(51049,3767),(51050,3767),(51051,3767),(51052,3768),(51053,3768),(51054,3768),(51055,3769),(51056,3769),(51057,3769),(51058,3770),(51059,3770),(51060,3770),(51061,3771),(51062,3771),(51063,3771),(51064,3772),(51065,3772),(51066,3772),(51067,3773),(51068,3773),(51069,3773),(51070,3774),(51071,3774),(51072,3774),(51073,3775),(51074,3775),(51075,3775),(51076,3776),(51077,3776),(51078,3776),(51079,3777),(51080,3777),(51081,3777),(51082,3778),(51083,3778),(51084,3778),(51085,3779),(51086,3779),(51087,3779),(51088,3780),(51089,3780),(51090,3780),(51091,3781),(51092,3781),(51093,3781),(51094,3782),(51095,3782),(51096,3782),(51097,3783),(51098,3783),(51099,3783),(51100,3784),(51101,3784),(51102,3784),(51103,3785),(51104,3785),(51105,3785),(51106,3786),(51107,3786),(51108,3786),(51109,3787),(51110,3787),(51111,3787),(51112,3788),(51113,3788),(51114,3788),(51115,3789),(51116,3789),(51117,3789),(51118,3790),(51119,3790),(51120,3790),(51121,3791),(51122,3791),(51123,3791),(51124,3792),(51125,3792),(51126,3792),(51127,3793),(51128,3793),(51129,3793),(51130,3794),(51131,3794),(51132,3794),(51133,3795),(51134,3795),(51135,3795),(51136,3796),(51137,3796),(51138,3796),(51139,3797),(51140,3797),(51141,3797),(51142,3798),(51143,3798),(51144,3798),(51145,3799),(51146,3799),(51147,3799),(51148,3800),(51149,3800),(51150,3800),(51151,3801),(51152,3801),(51153,3801),(51154,3802),(51155,3802),(51156,3802),(51157,3803),(51158,3803),(51159,3803),(51160,3804),(51161,3804),(51162,3804),(51163,3805),(51164,3805),(51165,3805),(51166,3806),(51167,3806),(51168,3806),(51169,3807),(51170,3807),(51171,3807),(51172,3808),(51173,3808),(51174,3808),(51175,3809),(51176,3809),(51177,3809),(51178,3810),(51179,3810),(51180,3810),(51181,3811),(51182,3811),(51183,3811),(51184,3812),(51185,3812),(51186,3812),(51187,3813),(51188,3813),(51189,3813),(51190,3814),(51191,3814),(51192,3814),(51193,3715),(51194,3715),(51195,3715),(51196,3715),(51197,3716),(51198,3716),(51199,3716),(51200,3716),(51201,3717),(51202,3717),(51203,3717),(51204,3717),(51205,3718),(51206,3718),(51207,3718),(51208,3718),(51209,3719),(51210,3719),(51211,3719),(51212,3719),(51213,3720),(51214,3720),(51215,3720),(51216,3720),(51217,3721),(51218,3721),(51219,3721),(51220,3721),(51221,3722),(51222,3722),(51223,3722),(51224,3722),(51225,3723),(51226,3723),(51227,3723),(51228,3723),(51229,3724),(51230,3724),(51231,3724),(51232,3724),(51233,3725),(51234,3725),(51235,3725),(51236,3725),(51237,3726),(51238,3726),(51239,3726),(51240,3726),(51241,3727),(51242,3727),(51243,3727),(51244,3727),(51245,3728),(51246,3728),(51247,3728),(51248,3728),(51249,3729),(51250,3729),(51251,3729),(51252,3729),(51253,3730),(51254,3730),(51255,3730),(51256,3730),(51257,3731),(51258,3731),(51259,3731),(51260,3731),(51261,3732),(51262,3732),(51263,3732),(51264,3732),(51265,3733),(51266,3733),(51267,3733),(51268,3733),(51269,3734),(51270,3734),(51271,3734),(51272,3734),(51273,3735),(51274,3735),(51275,3735),(51276,3735),(51277,3736),(51278,3736),(51279,3736),(51280,3736),(51281,3737),(51282,3737),(51283,3737),(51284,3737),(51285,3738),(51286,3738),(51287,3738),(51288,3738),(51289,3739),(51290,3739),(51291,3739),(51292,3739),(51293,3740),(51294,3740),(51295,3740),(51296,3740),(51297,3741),(51298,3741),(51299,3741),(51300,3741),(51301,3742),(51302,3742),(51303,3742),(51304,3742),(51305,3743),(51306,3743),(51307,3743),(51308,3743),(51309,3744),(51310,3744),(51311,3744),(51312,3744),(51313,3745),(51314,3745),(51315,3745),(51316,3745),(51317,3746),(51318,3746),(51319,3746),(51320,3746),(51321,3747),(51322,3747),(51323,3747),(51324,3747),(51325,3748),(51326,3748),(51327,3748),(51328,3748),(51329,3749),(51330,3749),(51331,3749),(51332,3749),(51333,3750),(51334,3750),(51335,3750),(51336,3750),(51337,3751),(51338,3751),(51339,3751),(51340,3751),(51341,3752),(51342,3752),(51343,3752),(51344,3752),(51345,3753),(51346,3753),(51347,3753),(51348,3753),(51349,3754),(51350,3754),(51351,3754),(51352,3754),(51353,3755),(51354,3755),(51355,3755),(51356,3755),(51357,3756),(51358,3756),(51359,3756),(51360,3756),(51361,3757),(51362,3757),(51363,3757),(51364,3757),(51365,3758),(51366,3758),(51367,3758),(51368,3758),(51369,3759),(51370,3759),(51371,3759),(51372,3759),(51373,3760),(51374,3760),(51375,3760),(51376,3760),(51377,3761),(51378,3761),(51379,3761),(51380,3761),(51381,3762),(51382,3762),(51383,3762),(51384,3762),(51385,3763),(51386,3763),(51387,3763),(51388,3763),(51389,3764),(51390,3764),(51391,3764),(51392,3764),(51393,3765),(51394,3765),(51395,3765),(51396,3765),(51397,3766),(51398,3766),(51399,3766),(51400,3766),(51401,3767),(51402,3767),(51403,3767),(51404,3767),(51405,3768),(51406,3768),(51407,3768),(51408,3768),(51409,3769),(51410,3769),(51411,3769),(51412,3769),(51413,3770),(51414,3770),(51415,3770),(51416,3770),(51417,3771),(51418,3771),(51419,3771),(51420,3771),(51421,3772),(51422,3772),(51423,3772),(51424,3772),(51425,3773),(51426,3773),(51427,3773),(51428,3773),(51429,3774),(51430,3774),(51431,3774),(51432,3774),(51433,3775),(51434,3775),(51435,3775),(51436,3775),(51437,3776),(51438,3776),(51439,3776),(51440,3776),(51441,3777),(51442,3777),(51443,3777),(51444,3777),(51445,3778),(51446,3778),(51447,3778),(51448,3778),(51449,3779),(51450,3779),(51451,3779),(51452,3779),(51453,3780),(51454,3780),(51455,3780),(51456,3780),(51457,3781),(51458,3781),(51459,3781),(51460,3781),(51461,3782),(51462,3782),(51463,3782),(51464,3782),(51465,3783),(51466,3783),(51467,3783),(51468,3783),(51469,3784),(51470,3784),(51471,3784),(51472,3784),(51473,3785),(51474,3785),(51475,3785),(51476,3785),(51477,3786),(51478,3786),(51479,3786),(51480,3786),(51481,3787),(51482,3787),(51483,3787),(51484,3787),(51485,3788),(51486,3788),(51487,3788),(51488,3788),(51489,3789),(51490,3789),(51491,3789),(51492,3789),(51493,3790),(51494,3790),(51495,3790),(51496,3790),(51497,3791),(51498,3791),(51499,3791),(51500,3791),(51501,3792),(51502,3792),(51503,3792),(51504,3792),(51505,3793),(51506,3793),(51507,3793),(51508,3793),(51509,3794),(51510,3794),(51511,3794),(51512,3794),(51513,3795),(51514,3795),(51515,3795),(51516,3795),(51517,3796),(51518,3796),(51519,3796),(51520,3796),(51521,3797),(51522,3797),(51523,3797),(51524,3797),(51525,3798),(51526,3798),(51527,3798),(51528,3798),(51529,3799),(51530,3799),(51531,3799),(51532,3799),(51533,3800),(51534,3800),(51535,3800),(51536,3800),(51537,3801),(51538,3801),(51539,3801),(51540,3801),(51541,3802),(51542,3802),(51543,3802),(51544,3802),(51545,3803),(51546,3803),(51547,3803),(51548,3803),(51549,3804),(51550,3804),(51551,3804),(51552,3804),(51553,3805),(51554,3805),(51555,3805),(51556,3805),(51557,3806),(51558,3806),(51559,3806),(51560,3806),(51561,3807),(51562,3807),(51563,3807),(51564,3807),(51565,3808),(51566,3808),(51567,3808),(51568,3808),(51569,3809),(51570,3809),(51571,3809),(51572,3809),(51573,3810),(51574,3810),(51575,3810),(51576,3810),(51577,3811),(51578,3811),(51579,3811),(51580,3811),(51581,3812),(51582,3812),(51583,3812),(51584,3812),(51585,3813),(51586,3813),(51587,3813),(51588,3813),(51589,3814),(51590,3814),(51591,3814),(51592,3814),(51593,3815),(51594,3815),(51595,3815),(51596,3815),(51597,3815),(51598,3815),(51599,3816),(51600,3816),(51601,3816),(51602,3816),(51603,3816),(51604,3816),(51605,3817),(51606,3817),(51607,3817),(51608,3817),(51609,3817),(51610,3817),(51611,3818),(51612,3818),(51613,3818),(51614,3818),(51615,3818),(51616,3818),(51617,3819),(51618,3819),(51619,3819),(51620,3819),(51621,3820),(51622,3820),(51623,3820),(51624,3820),(51625,3820),(51626,3820),(51627,3821),(51628,3821),(51629,3821),(51630,3821),(51631,3821),(51632,3821),(51633,3822),(51634,3822),(51635,3822),(51636,3822),(51637,3822),(51638,3822),(51639,3823),(51640,3823),(51641,3823),(51642,3823),(51643,3823),(51644,3823),(51645,3824),(51646,3824),(51647,3824),(51648,3824),(51649,3824),(51650,3824),(51651,3825),(51652,3825),(51653,3825),(51654,3825),(51655,3825),(51656,3825),(51657,3826),(51658,3826),(51659,3826),(51660,3826),(51661,3826),(51662,3826),(51663,3827),(51664,3827),(51665,3827),(51666,3827),(51667,3827),(51668,3827),(51669,3828),(51670,3828),(51671,3828),(51672,3828),(51673,3828),(51674,3828),(51675,3829),(51676,3829),(51677,3829),(51678,3829),(51679,3829),(51680,3829),(51681,3830),(51682,3830),(51683,3830),(51684,3830),(51685,3830),(51686,3830),(51687,3831),(51688,3831),(51689,3831),(51690,3831),(51691,3831),(51692,3831),(51693,3832),(51694,3832),(51695,3832),(51696,3832),(51697,3832),(51698,3832),(51699,3833),(51700,3833),(51701,3833),(51702,3833),(51703,3833),(51704,3833),(51705,3834),(51706,3834),(51707,3834),(51708,3834),(51709,3834),(51710,3834),(51711,3835),(51712,3835),(51713,3835),(51714,3835),(51715,3835),(51716,3835),(51717,3836),(51718,3836),(51719,3836),(51720,3836),(51721,3836),(51722,3836),(51723,3837),(51724,3837),(51725,3837),(51726,3837),(51727,3837),(51728,3837),(51729,3838),(51730,3838),(51731,3838),(51732,3838),(51733,3838),(51734,3838),(51735,3839),(51736,3839),(51737,3839),(51738,3839),(51739,3839),(51740,3839),(51741,3840),(51742,3840),(51743,3840),(51744,3840),(51745,3840),(51746,3840),(51747,3841),(51748,3841),(51749,3841),(51750,3841),(51751,3841),(51752,3841),(51753,3842),(51754,3842),(51755,3842),(51756,3842),(51757,3842),(51758,3842),(51759,3843),(51760,3843),(51761,3843),(51762,3843),(51763,3843),(51764,3843),(51765,3844),(51766,3844),(51767,3844),(51768,3844),(51769,3844),(51770,3844),(51771,3845),(51772,3845),(51773,3845),(51774,3845),(51775,3845),(51776,3845),(51777,3846),(51778,3846),(51779,3846),(51780,3846),(51781,3846),(51782,3846),(51783,3847),(51784,3847),(51785,3847),(51786,3847),(51787,3847),(51788,3847),(51789,3848),(51790,3848),(51791,3848),(51792,3848),(51793,3848),(51794,3848),(51795,3849),(51796,3849),(51797,3849),(51798,3849),(51799,3849),(51800,3849),(51801,3850),(51802,3850),(51803,3850),(51804,3850),(51805,3850),(51806,3850),(51807,3851),(51808,3851),(51809,3851),(51810,3851),(51811,3851),(51812,3851),(51813,3852),(51814,3852),(51815,3852),(51816,3852),(51817,3852),(51818,3852),(51819,3853),(51820,3853),(51821,3853),(51822,3853),(51823,3853),(51824,3853),(51825,3854),(51826,3854),(51827,3854),(51828,3854),(51829,3854),(51830,3854),(51831,3855),(51832,3855),(51833,3855),(51834,3855),(51835,3855),(51836,3855),(51837,3856),(51838,3856),(51839,3856),(51840,3856),(51841,3856),(51842,3856),(51843,3857),(51844,3857),(51845,3857),(51846,3857),(51847,3857),(51848,3857),(51849,3858),(51850,3858),(51851,3858),(51852,3858),(51853,3858),(51854,3858),(51855,3859),(51856,3859),(51857,3859),(51858,3859),(51859,3859),(51860,3859),(51861,3860),(51862,3860),(51863,3860),(51864,3860),(51865,3860),(51866,3860),(51867,3861),(51868,3861),(51869,3861),(51870,3861),(51871,3861),(51872,3861),(51873,3862),(51874,3862),(51875,3862),(51876,3862),(51877,3862),(51878,3862),(51879,3863),(51880,3863),(51881,3863),(51882,3863),(51883,3863),(51884,3863),(51885,3864),(51886,3864),(51887,3864),(51888,3864),(51889,3864),(51890,3864),(51891,3865),(51892,3865),(51893,3865),(51894,3865),(51895,3865),(51896,3865),(51897,3866),(51898,3866),(51899,3866),(51900,3866),(51901,3866),(51902,3866),(51903,3867),(51904,3867),(51905,3867),(51906,3867),(51907,3867),(51908,3867),(51909,3868),(51910,3868),(51911,3868),(51912,3868),(51913,3868),(51914,3868),(51915,3869),(51916,3869),(51917,3869),(51918,3869),(51919,3869),(51920,3869),(51921,3870),(51922,3870),(51923,3870),(51924,3870),(51925,3870),(51926,3870),(51927,3871),(51928,3871),(51929,3871),(51930,3871),(51931,3871),(51932,3871),(51933,3872),(51934,3872),(51935,3872),(51936,3872),(51937,3872),(51938,3872),(51939,3873),(51940,3873),(51941,3873),(51942,3873),(51943,3873),(51944,3873),(51945,3874),(51946,3874),(51947,3874),(51948,3874),(51949,3874),(51950,3874),(51951,3875),(51952,3875),(51953,3875),(51954,3875),(51955,3875),(51956,3875),(51957,3876),(51958,3876),(51959,3876),(51960,3876),(51961,3876),(51962,3876),(51963,3877),(51964,3877),(51965,3877),(51966,3877),(51967,3877),(51968,3877),(51969,3878),(51970,3878),(51971,3878),(51972,3878),(51973,3878),(51974,3878),(51975,3879),(51976,3879),(51977,3879),(51978,3879),(51979,3879),(51980,3879),(51981,3880),(51982,3880),(51983,3880),(51984,3880),(51985,3880),(51986,3880),(51987,3881),(51988,3881),(51989,3881),(51990,3881),(51991,3881),(51992,3881),(51993,3882),(51994,3882),(51995,3882),(51996,3882),(51997,3882),(51998,3882),(51999,3883),(52000,3883),(52001,3883),(52002,3883),(52003,3883),(52004,3883),(52005,3884),(52006,3884),(52007,3884),(52008,3884),(52009,3884),(52010,3884),(52011,3885),(52012,3885),(52013,3885),(52014,3885),(52015,3885),(52016,3885),(52017,3886),(52018,3886),(52019,3886),(52020,3886),(52021,3886),(52022,3886),(52023,3887),(52024,3887),(52025,3887),(52026,3887),(52027,3887),(52028,3887),(52029,3888),(52030,3888),(52031,3888),(52032,3888),(52033,3888),(52034,3888),(52035,3889),(52036,3889),(52037,3889),(52038,3889),(52039,3889),(52040,3889),(52041,3890),(52042,3890),(52043,3890),(52044,3890),(52045,3890),(52046,3890),(52047,3891),(52048,3891),(52049,3891),(52050,3891),(52051,3891),(52052,3891),(52053,3892),(52054,3892),(52055,3892),(52056,3892),(52057,3892),(52058,3892),(52059,3893),(52060,3893),(52061,3893),(52062,3893),(52063,3893),(52064,3893),(52065,3894),(52066,3894),(52067,3894),(52068,3894),(52069,3894),(52070,3894),(52071,3895),(52072,3895),(52073,3895),(52074,3895),(52075,3895),(52076,3895),(52077,3896),(52078,3896),(52079,3896),(52080,3896),(52081,3896),(52082,3897),(52083,3897),(52084,3897),(52085,3897),(52086,3897),(52087,3898),(52088,3898),(52089,3898),(52090,3898),(52091,3898),(52092,3898),(52093,3899),(52094,3899),(52095,3899),(52096,3899),(52097,3899),(52098,3899),(52099,3900),(52100,3900),(52101,3900),(52102,3900),(52103,3900),(52104,3900),(52105,3901),(52106,3901),(52107,3901),(52108,3901),(52109,3901),(52110,3901),(52111,3902),(52112,3902),(52113,3902),(52114,3902),(52115,3902),(52116,3902),(52117,3903),(52118,3903),(52119,3903),(52120,3903),(52121,3903),(52122,3903),(52123,3904),(52124,3904),(52125,3904),(52126,3904),(52127,3904),(52128,3904),(52129,3905),(52130,3905),(52131,3905),(52132,3905),(52133,3905),(52134,3905),(52135,3906),(52136,3906),(52137,3906),(52138,3906),(52139,3906),(52140,3906),(52141,3907),(52142,3907),(52143,3907),(52144,3907),(52145,3907),(52146,3907),(52147,3908),(52148,3908),(52149,3908),(52150,3908),(52151,3908),(52152,3908),(52153,3909),(52154,3909),(52155,3909),(52156,3909),(52157,3909),(52158,3909),(52159,3910),(52160,3910),(52161,3910),(52162,3910),(52163,3910),(52164,3910),(52165,3911),(52166,3911),(52167,3911),(52168,3911),(52169,3911),(52170,3911),(52171,3912),(52172,3912),(52173,3912),(52174,3912),(52175,3912),(52176,3912),(52177,3913),(52178,3913),(52179,3913),(52180,3913),(52181,3913),(52182,3913),(52183,3914),(52184,3914),(52185,3914),(52186,3914),(52187,3914),(52188,3914),(52189,3815),(52190,3815),(52191,3815),(52192,3816),(52193,3816),(52194,3816),(52195,3817),(52196,3817),(52197,3817),(52198,3818),(52199,3818),(52200,3818),(52201,3819),(52202,3819),(52203,3819),(52204,3820),(52205,3820),(52206,3820),(52207,3821),(52208,3821),(52209,3821),(52210,3822),(52211,3822),(52212,3822),(52213,3823),(52214,3823),(52215,3823),(52216,3824),(52217,3824),(52218,3824),(52219,3825),(52220,3825),(52221,3825),(52222,3826),(52223,3826),(52224,3826),(52225,3827),(52226,3827),(52227,3827),(52228,3828),(52229,3828),(52230,3828),(52231,3829),(52232,3829),(52233,3829),(52234,3830),(52235,3830),(52236,3830),(52237,3831),(52238,3831),(52239,3831),(52240,3832),(52241,3832),(52242,3832),(52243,3833),(52244,3833),(52245,3833),(52246,3834),(52247,3834),(52248,3834),(52249,3835),(52250,3835),(52251,3835),(52252,3836),(52253,3836),(52254,3836),(52255,3837),(52256,3837),(52257,3837),(52258,3838),(52259,3838),(52260,3838),(52261,3839),(52262,3839),(52263,3839),(52264,3840),(52265,3840),(52266,3840),(52267,3841),(52268,3841),(52269,3841),(52270,3842),(52271,3842),(52272,3842),(52273,3843),(52274,3843),(52275,3843),(52276,3844),(52277,3844),(52278,3844),(52279,3845),(52280,3845),(52281,3845),(52282,3846),(52283,3846),(52284,3846),(52285,3847),(52286,3847),(52287,3847),(52288,3848),(52289,3848),(52290,3848),(52291,3849),(52292,3849),(52293,3849),(52294,3850),(52295,3850),(52296,3850),(52297,3851),(52298,3851),(52299,3851),(52300,3852),(52301,3852),(52302,3852),(52303,3853),(52304,3853),(52305,3853),(52306,3854),(52307,3854),(52308,3854),(52309,3855),(52310,3855),(52311,3855),(52312,3856),(52313,3856),(52314,3856),(52315,3857),(52316,3857),(52317,3857),(52318,3858),(52319,3858),(52320,3858),(52321,3859),(52322,3859),(52323,3859),(52324,3860),(52325,3860),(52326,3860),(52327,3861),(52328,3861),(52329,3861),(52330,3862),(52331,3862),(52332,3862),(52333,3863),(52334,3863),(52335,3863),(52336,3864),(52337,3864),(52338,3864),(52339,3865),(52340,3865),(52341,3865),(52342,3866),(52343,3866),(52344,3866),(52345,3867),(52346,3867),(52347,3867),(52348,3868),(52349,3868),(52350,3868),(52351,3869),(52352,3869),(52353,3869),(52354,3870),(52355,3870),(52356,3870),(52357,3871),(52358,3871),(52359,3871),(52360,3872),(52361,3872),(52362,3873),(52363,3873),(52364,3874),(52365,3874),(52366,3874),(52367,3875),(52368,3875),(52369,3875),(52370,3876),(52371,3876),(52372,3876),(52373,3877),(52374,3877),(52375,3877),(52376,3878),(52377,3878),(52378,3878),(52379,3879),(52380,3879),(52381,3879),(52382,3880),(52383,3880),(52384,3880),(52385,3881),(52386,3881),(52387,3881),(52388,3882),(52389,3882),(52390,3882),(52391,3883),(52392,3883),(52393,3883),(52394,3884),(52395,3884),(52396,3884),(52397,3885),(52398,3885),(52399,3886),(52400,3886),(52401,3886),(52402,3887),(52403,3887),(52404,3887),(52405,3888),(52406,3888),(52407,3888),(52408,3889),(52409,3889),(52410,3889),(52411,3890),(52412,3890),(52413,3890),(52414,3891),(52415,3891),(52416,3891),(52417,3892),(52418,3892),(52419,3892),(52420,3893),(52421,3893),(52422,3893),(52423,3894),(52424,3894),(52425,3894),(52426,3895),(52427,3895),(52428,3895),(52429,3896),(52430,3896),(52431,3896),(52432,3897),(52433,3897),(52434,3897),(52435,3898),(52436,3898),(52437,3898),(52438,3899),(52439,3899),(52440,3899),(52441,3900),(52442,3900),(52443,3900),(52444,3901),(52445,3901),(52446,3901),(52447,3902),(52448,3902),(52449,3902),(52450,3903),(52451,3903),(52452,3903),(52453,3904),(52454,3904),(52455,3904),(52456,3905),(52457,3905),(52458,3905),(52459,3906),(52460,3906),(52461,3906),(52462,3907),(52463,3907),(52464,3907),(52465,3908),(52466,3908),(52467,3908),(52468,3909),(52469,3909),(52470,3909),(52471,3910),(52472,3910),(52473,3910),(52474,3911),(52475,3911),(52476,3911),(52477,3912),(52478,3912),(52479,3912),(52480,3913),(52481,3913),(52482,3913),(52483,3914),(52484,3914),(52485,3914),(52486,3815),(52487,3815),(52488,3815),(52489,3815),(52490,3816),(52491,3816),(52492,3816),(52493,3816),(52494,3817),(52495,3817),(52496,3817),(52497,3817),(52498,3818),(52499,3818),(52500,3818),(52501,3818),(52502,3819),(52503,3819),(52504,3819),(52505,3819),(52506,3820),(52507,3820),(52508,3820),(52509,3820),(52510,3821),(52511,3821),(52512,3821),(52513,3821),(52514,3822),(52515,3822),(52516,3822),(52517,3822),(52518,3823),(52519,3823),(52520,3823),(52521,3823),(52522,3824),(52523,3824),(52524,3824),(52525,3824),(52526,3825),(52527,3825),(52528,3825),(52529,3825),(52530,3826),(52531,3826),(52532,3826),(52533,3826),(52534,3827),(52535,3827),(52536,3827),(52537,3827),(52538,3828),(52539,3828),(52540,3828),(52541,3828),(52542,3829),(52543,3829),(52544,3829),(52545,3829),(52546,3830),(52547,3830),(52548,3830),(52549,3830),(52550,3831),(52551,3831),(52552,3831),(52553,3831),(52554,3832),(52555,3832),(52556,3832),(52557,3832),(52558,3833),(52559,3833),(52560,3833),(52561,3833),(52562,3834),(52563,3834),(52564,3834),(52565,3834),(52566,3835),(52567,3835),(52568,3835),(52569,3835),(52570,3836),(52571,3836),(52572,3836),(52573,3836),(52574,3837),(52575,3837),(52576,3837),(52577,3837),(52578,3838),(52579,3838),(52580,3838),(52581,3838),(52582,3839),(52583,3839),(52584,3839),(52585,3839),(52586,3840),(52587,3840),(52588,3840),(52589,3840),(52590,3841),(52591,3841),(52592,3841),(52593,3841),(52594,3842),(52595,3842),(52596,3842),(52597,3842),(52598,3843),(52599,3843),(52600,3843),(52601,3843),(52602,3844),(52603,3844),(52604,3844),(52605,3844),(52606,3845),(52607,3845),(52608,3845),(52609,3845),(52610,3846),(52611,3846),(52612,3846),(52613,3846),(52614,3847),(52615,3847),(52616,3847),(52617,3847),(52618,3848),(52619,3848),(52620,3848),(52621,3848),(52622,3849),(52623,3849),(52624,3849),(52625,3849),(52626,3850),(52627,3850),(52628,3850),(52629,3850),(52630,3851),(52631,3851),(52632,3851),(52633,3851),(52634,3852),(52635,3852),(52636,3852),(52637,3852),(52638,3853),(52639,3853),(52640,3853),(52641,3853),(52642,3854),(52643,3854),(52644,3854),(52645,3854),(52646,3855),(52647,3855),(52648,3855),(52649,3855),(52650,3856),(52651,3856),(52652,3856),(52653,3856),(52654,3857),(52655,3857),(52656,3857),(52657,3857),(52658,3858),(52659,3858),(52660,3858),(52661,3858),(52662,3859),(52663,3859),(52664,3859),(52665,3859),(52666,3860),(52667,3860),(52668,3860),(52669,3860),(52670,3861),(52671,3861),(52672,3861),(52673,3861),(52674,3862),(52675,3862),(52676,3862),(52677,3862),(52678,3863),(52679,3863),(52680,3863),(52681,3863),(52682,3864),(52683,3864),(52684,3864),(52685,3864),(52686,3865),(52687,3865),(52688,3865),(52689,3865),(52690,3866),(52691,3866),(52692,3866),(52693,3866),(52694,3867),(52695,3867),(52696,3867),(52697,3867),(52698,3868),(52699,3868),(52700,3868),(52701,3868),(52702,3869),(52703,3869),(52704,3869),(52705,3869),(52706,3870),(52707,3870),(52708,3870),(52709,3870),(52710,3871),(52711,3871),(52712,3871),(52713,3871),(52714,3872),(52715,3872),(52716,3872),(52717,3872),(52718,3873),(52719,3873),(52720,3873),(52721,3873),(52722,3874),(52723,3874),(52724,3874),(52725,3874),(52726,3875),(52727,3875),(52728,3875),(52729,3875),(52730,3876),(52731,3876),(52732,3876),(52733,3876),(52734,3877),(52735,3877),(52736,3877),(52737,3877),(52738,3878),(52739,3878),(52740,3878),(52741,3878),(52742,3879),(52743,3879),(52744,3879),(52745,3879),(52746,3880),(52747,3880),(52748,3880),(52749,3880),(52750,3881),(52751,3881),(52752,3881),(52753,3881),(52754,3882),(52755,3882),(52756,3882),(52757,3882),(52758,3883),(52759,3883),(52760,3883),(52761,3883),(52762,3884),(52763,3884),(52764,3884),(52765,3884),(52766,3885),(52767,3885),(52768,3885),(52769,3885),(52770,3886),(52771,3886),(52772,3886),(52773,3886),(52774,3887),(52775,3887),(52776,3887),(52777,3887),(52778,3888),(52779,3888),(52780,3888),(52781,3888),(52782,3889),(52783,3889),(52784,3889),(52785,3889),(52786,3890),(52787,3890),(52788,3890),(52789,3890),(52790,3891),(52791,3891),(52792,3891),(52793,3891),(52794,3892),(52795,3892),(52796,3892),(52797,3892),(52798,3893),(52799,3893),(52800,3893),(52801,3893),(52802,3894),(52803,3894),(52804,3894),(52805,3894),(52806,3895),(52807,3895),(52808,3895),(52809,3895),(52810,3896),(52811,3896),(52812,3896),(52813,3896),(52814,3897),(52815,3897),(52816,3897),(52817,3897),(52818,3898),(52819,3898),(52820,3898),(52821,3898),(52822,3899),(52823,3899),(52824,3899),(52825,3899),(52826,3900),(52827,3900),(52828,3900),(52829,3900),(52830,3901),(52831,3901),(52832,3901),(52833,3901),(52834,3902),(52835,3902),(52836,3902),(52837,3902),(52838,3903),(52839,3903),(52840,3903),(52841,3903),(52842,3904),(52843,3904),(52844,3904),(52845,3904),(52846,3905),(52847,3905),(52848,3905),(52849,3905),(52850,3906),(52851,3906),(52852,3906),(52853,3906),(52854,3907),(52855,3907),(52856,3907),(52857,3907),(52858,3908),(52859,3908),(52860,3908),(52861,3908),(52862,3909),(52863,3909),(52864,3909),(52865,3909),(52866,3910),(52867,3910),(52868,3910),(52869,3910),(52870,3911),(52871,3911),(52872,3911),(52873,3911),(52874,3912),(52875,3912),(52876,3912),(52877,3912),(52878,3913),(52879,3913),(52880,3913),(52881,3913),(52882,3914),(52883,3914),(52884,3914),(52885,3914),(52886,3915),(52887,3915),(52888,3915),(52889,3915),(52890,3915),(52891,3915),(52892,3916),(52893,3916),(52894,3916),(52895,3916),(52896,3916),(52897,3916),(52898,3917),(52899,3917),(52900,3917),(52901,3917),(52902,3917),(52903,3917),(52904,3918),(52905,3918),(52906,3918),(52907,3918),(52908,3918),(52909,3918),(52910,3919),(52911,3919),(52912,3919),(52913,3919),(52914,3919),(52915,3919),(52916,3920),(52917,3920),(52918,3920),(52919,3920),(52920,3920),(52921,3920),(52922,3921),(52923,3921),(52924,3921),(52925,3921),(52926,3921),(52927,3921),(52928,3922),(52929,3922),(52930,3922),(52931,3922),(52932,3922),(52933,3922),(52934,3923),(52935,3923),(52936,3923),(52937,3923),(52938,3923),(52939,3923),(52940,3924),(52941,3924),(52942,3924),(52943,3924),(52944,3924),(52945,3924),(52946,3925),(52947,3925),(52948,3925),(52949,3925),(52950,3925),(52951,3925),(52952,3926),(52953,3926),(52954,3926),(52955,3926),(52956,3926),(52957,3926),(52958,3927),(52959,3927),(52960,3927),(52961,3927),(52962,3927),(52963,3927),(52964,3928),(52965,3928),(52966,3928),(52967,3928),(52968,3928),(52969,3928),(52970,3929),(52971,3929),(52972,3929),(52973,3929),(52974,3929),(52975,3929),(52976,3930),(52977,3930),(52978,3930),(52979,3930),(52980,3930),(52981,3930),(52982,3931),(52983,3931),(52984,3931),(52985,3931),(52986,3931),(52987,3931),(52988,3932),(52989,3932),(52990,3932),(52991,3932),(52992,3932),(52993,3932),(52994,3933),(52995,3933),(52996,3933),(52997,3933),(52998,3933),(52999,3933),(53000,3934),(53001,3934),(53002,3934),(53003,3934),(53004,3934),(53005,3934),(53006,3935),(53007,3935),(53008,3935),(53009,3935),(53010,3935),(53011,3935),(53012,3936),(53013,3936),(53014,3936),(53015,3936),(53016,3936),(53017,3936),(53018,3937),(53019,3937),(53020,3937),(53021,3937),(53022,3937),(53023,3937),(53024,3938),(53025,3938),(53026,3938),(53027,3938),(53028,3938),(53029,3938),(53030,3939),(53031,3939),(53032,3939),(53033,3939),(53034,3939),(53035,3939),(53036,3940),(53037,3940),(53038,3940),(53039,3940),(53040,3940),(53041,3940),(53042,3941),(53043,3941),(53044,3941),(53045,3941),(53046,3941),(53047,3941),(53048,3942),(53049,3942),(53050,3942),(53051,3942),(53052,3942),(53053,3942),(53054,3943),(53055,3943),(53056,3943),(53057,3943),(53058,3943),(53059,3943),(53060,3944),(53061,3944),(53062,3944),(53063,3944),(53064,3944),(53065,3944),(53066,3945),(53067,3945),(53068,3945),(53069,3945),(53070,3945),(53071,3945),(53072,3946),(53073,3946),(53074,3946),(53075,3946),(53076,3946),(53077,3946),(53078,3947),(53079,3947),(53080,3947),(53081,3947),(53082,3947),(53083,3947),(53084,3948),(53085,3948),(53086,3948),(53087,3948),(53088,3948),(53089,3948),(53090,3949),(53091,3949),(53092,3949),(53093,3949),(53094,3949),(53095,3949),(53096,3950),(53097,3950),(53098,3950),(53099,3950),(53100,3950),(53101,3950),(53102,3951),(53103,3951),(53104,3951),(53105,3951),(53106,3951),(53107,3951),(53108,3952),(53109,3952),(53110,3952),(53111,3952),(53112,3952),(53113,3952),(53114,3953),(53115,3953),(53116,3953),(53117,3953),(53118,3953),(53119,3953),(53120,3954),(53121,3954),(53122,3954),(53123,3954),(53124,3954),(53125,3954),(53126,3955),(53127,3955),(53128,3955),(53129,3955),(53130,3955),(53131,3955),(53132,3956),(53133,3956),(53134,3956),(53135,3956),(53136,3956),(53137,3956),(53138,3957),(53139,3957),(53140,3957),(53141,3957),(53142,3957),(53143,3957),(53144,3958),(53145,3958),(53146,3958),(53147,3958),(53148,3958),(53149,3958),(53150,3959),(53151,3959),(53152,3959),(53153,3959),(53154,3959),(53155,3959),(53156,3960),(53157,3960),(53158,3960),(53159,3960),(53160,3960),(53161,3960),(53162,3961),(53163,3961),(53164,3961),(53165,3961),(53166,3961),(53167,3961),(53168,3962),(53169,3962),(53170,3962),(53171,3962),(53172,3962),(53173,3962),(53174,3963),(53175,3963),(53176,3963),(53177,3963),(53178,3963),(53179,3963),(53180,3964),(53181,3964),(53182,3964),(53183,3964),(53184,3964),(53185,3964),(53186,3965),(53187,3965),(53188,3965),(53189,3965),(53190,3965),(53191,3965),(53192,3966),(53193,3966),(53194,3966),(53195,3966),(53196,3966),(53197,3966),(53198,3967),(53199,3967),(53200,3967),(53201,3967),(53202,3967),(53203,3967),(53204,3968),(53205,3968),(53206,3968),(53207,3968),(53208,3968),(53209,3968),(53210,3969),(53211,3969),(53212,3969),(53213,3969),(53214,3969),(53215,3969),(53216,3970),(53217,3970),(53218,3970),(53219,3970),(53220,3970),(53221,3970),(53222,3971),(53223,3971),(53224,3971),(53225,3971),(53226,3971),(53227,3971),(53228,3972),(53229,3972),(53230,3972),(53231,3972),(53232,3972),(53233,3972),(53234,3973),(53235,3973),(53236,3973),(53237,3973),(53238,3973),(53239,3973),(53240,3974),(53241,3974),(53242,3974),(53243,3974),(53244,3974),(53245,3974),(53246,3975),(53247,3975),(53248,3975),(53249,3975),(53250,3975),(53251,3975),(53252,3976),(53253,3976),(53254,3976),(53255,3976),(53256,3976),(53257,3976),(53258,3977),(53259,3977),(53260,3977),(53261,3977),(53262,3977),(53263,3977),(53264,3978),(53265,3978),(53266,3978),(53267,3978),(53268,3978),(53269,3978),(53270,3979),(53271,3979),(53272,3979),(53273,3979),(53274,3979),(53275,3979),(53276,3980),(53277,3980),(53278,3980),(53279,3980),(53280,3980),(53281,3980),(53282,3981),(53283,3981),(53284,3981),(53285,3981),(53286,3981),(53287,3981),(53288,3982),(53289,3982),(53290,3982),(53291,3982),(53292,3983),(53293,3983),(53294,3983),(53295,3983),(53296,3984),(53297,3984),(53298,3984),(53299,3984),(53300,3985),(53301,3985),(53302,3985),(53303,3985),(53304,3986),(53305,3986),(53306,3986),(53307,3986),(53308,3987),(53309,3987),(53310,3987),(53311,3987),(53312,3988),(53313,3988),(53314,3988),(53315,3988),(53316,3989),(53317,3989),(53318,3989),(53319,3989),(53320,3989),(53321,3989),(53322,3990),(53323,3990),(53324,3990),(53325,3990),(53326,3990),(53327,3990),(53328,3991),(53329,3991),(53330,3991),(53331,3991),(53332,3991),(53333,3991),(53334,3992),(53335,3992),(53336,3992),(53337,3992),(53338,3992),(53339,3992),(53340,3993),(53341,3993),(53342,3993),(53343,3993),(53344,3993),(53345,3993),(53346,3994),(53347,3994),(53348,3994),(53349,3994),(53350,3994),(53351,3994),(53352,3995),(53353,3995),(53354,3995),(53355,3995),(53356,3995),(53357,3995),(53358,3996),(53359,3996),(53360,3996),(53361,3996),(53362,3996),(53363,3996),(53364,3997),(53365,3997),(53366,3997),(53367,3997),(53368,3997),(53369,3997),(53370,3998),(53371,3998),(53372,3998),(53373,3998),(53374,3998),(53375,3998),(53376,3999),(53377,3999),(53378,3999),(53379,3999),(53380,3999),(53381,3999),(53382,4000),(53383,4000),(53384,4000),(53385,4000),(53386,4000),(53387,4000),(53388,4001),(53389,4001),(53390,4001),(53391,4001),(53392,4001),(53393,4001),(53394,4002),(53395,4002),(53396,4002),(53397,4002),(53398,4002),(53399,4002),(53400,4003),(53401,4003),(53402,4003),(53403,4003),(53404,4003),(53405,4003),(53406,4004),(53407,4004),(53408,4004),(53409,4004),(53410,4004),(53411,4004),(53412,4005),(53413,4005),(53414,4005),(53415,4005),(53416,4005),(53417,4005),(53418,4006),(53419,4006),(53420,4006),(53421,4006),(53422,4006),(53423,4006),(53424,4007),(53425,4007),(53426,4007),(53427,4007),(53428,4007),(53429,4007),(53430,4008),(53431,4008),(53432,4008),(53433,4008),(53434,4008),(53435,4008),(53436,4009),(53437,4009),(53438,4009),(53439,4009),(53440,4009),(53441,4009),(53442,4010),(53443,4010),(53444,4010),(53445,4010),(53446,4010),(53447,4010),(53448,4011),(53449,4011),(53450,4011),(53451,4011),(53452,4011),(53453,4011),(53454,4012),(53455,4012),(53456,4012),(53457,4012),(53458,4012),(53459,4012),(53460,4013),(53461,4013),(53462,4013),(53463,4013),(53464,4013),(53465,4013),(53466,4014),(53467,4014),(53468,4014),(53469,4014),(53470,4014),(53471,4014),(53472,3915),(53473,3915),(53474,3915),(53475,3916),(53476,3916),(53477,3916),(53478,3917),(53479,3917),(53480,3917),(53481,3918),(53482,3918),(53483,3918),(53484,3919),(53485,3919),(53486,3920),(53487,3920),(53488,3921),(53489,3921),(53490,3922),(53491,3922),(53492,3923),(53493,3923),(53494,3923),(53495,3924),(53496,3924),(53497,3924),(53498,3925),(53499,3925),(53500,3925),(53501,3926),(53502,3926),(53503,3926),(53504,3927),(53505,3927),(53506,3927),(53507,3928),(53508,3928),(53509,3928),(53510,3929),(53511,3929),(53512,3929),(53513,3930),(53514,3930),(53515,3930),(53516,3931),(53517,3931),(53518,3931),(53519,3932),(53520,3932),(53521,3932),(53522,3933),(53523,3933),(53524,3933),(53525,3934),(53526,3934),(53527,3934),(53528,3935),(53529,3935),(53530,3935),(53531,3936),(53532,3936),(53533,3936),(53534,3937),(53535,3937),(53536,3937),(53537,3938),(53538,3938),(53539,3938),(53540,3939),(53541,3939),(53542,3939),(53543,3940),(53544,3940),(53545,3940),(53546,3941),(53547,3941),(53548,3941),(53549,3942),(53550,3942),(53551,3942),(53552,3943),(53553,3943),(53554,3943),(53555,3944),(53556,3944),(53557,3944),(53558,3945),(53559,3945),(53560,3945),(53561,3946),(53562,3946),(53563,3946),(53564,3947),(53565,3947),(53566,3947),(53567,3948),(53568,3948),(53569,3948),(53570,3949),(53571,3949),(53572,3949),(53573,3950),(53574,3950),(53575,3950),(53576,3951),(53577,3951),(53578,3951),(53579,3952),(53580,3952),(53581,3952),(53582,3953),(53583,3953),(53584,3953),(53585,3954),(53586,3954),(53587,3954),(53588,3955),(53589,3955),(53590,3955),(53591,3956),(53592,3956),(53593,3956),(53594,3957),(53595,3957),(53596,3957),(53597,3958),(53598,3958),(53599,3958),(53600,3959),(53601,3959),(53602,3959),(53603,3960),(53604,3960),(53605,3960),(53606,3961),(53607,3961),(53608,3961),(53609,3962),(53610,3962),(53611,3962),(53612,3963),(53613,3963),(53614,3963),(53615,3964),(53616,3964),(53617,3964),(53618,3965),(53619,3965),(53620,3965),(53621,3966),(53622,3966),(53623,3966),(53624,3967),(53625,3967),(53626,3967),(53627,3968),(53628,3968),(53629,3968),(53630,3969),(53631,3969),(53632,3969),(53633,3970),(53634,3970),(53635,3970),(53636,3971),(53637,3971),(53638,3971),(53639,3972),(53640,3972),(53641,3972),(53642,3973),(53643,3973),(53644,3973),(53645,3974),(53646,3974),(53647,3974),(53648,3975),(53649,3975),(53650,3975),(53651,3976),(53652,3976),(53653,3976),(53654,3977),(53655,3977),(53656,3977),(53657,3978),(53658,3978),(53659,3978),(53660,3979),(53661,3979),(53662,3979),(53663,3980),(53664,3980),(53665,3980),(53666,3981),(53667,3981),(53668,3981),(53669,3982),(53670,3982),(53671,3982),(53672,3983),(53673,3983),(53674,3983),(53675,3984),(53676,3984),(53677,3984),(53678,3985),(53679,3985),(53680,3985),(53681,3986),(53682,3986),(53683,3986),(53684,3987),(53685,3987),(53686,3987),(53687,3988),(53688,3988),(53689,3988),(53690,3989),(53691,3989),(53692,3989),(53693,3990),(53694,3990),(53695,3990),(53696,3991),(53697,3991),(53698,3991),(53699,3992),(53700,3992),(53701,3992),(53702,3993),(53703,3993),(53704,3993),(53705,3994),(53706,3994),(53707,3994),(53708,3995),(53709,3995),(53710,3995),(53711,3996),(53712,3996),(53713,3996),(53714,3997),(53715,3997),(53716,3997),(53717,3998),(53718,3998),(53719,3998),(53720,3999),(53721,3999),(53722,3999),(53723,4000),(53724,4000),(53725,4000),(53726,4001),(53727,4001),(53728,4001),(53729,4002),(53730,4002),(53731,4002),(53732,4003),(53733,4003),(53734,4003),(53735,4004),(53736,4004),(53737,4004),(53738,4005),(53739,4005),(53740,4005),(53741,4006),(53742,4006),(53743,4006),(53744,4007),(53745,4007),(53746,4007),(53747,4008),(53748,4008),(53749,4008),(53750,4009),(53751,4009),(53752,4009),(53753,4010),(53754,4010),(53755,4010),(53756,4011),(53757,4011),(53758,4011),(53759,4012),(53760,4012),(53761,4012),(53762,4013),(53763,4013),(53764,4013),(53765,4014),(53766,4014),(53767,4014),(53768,3915),(53769,3915),(53770,3915),(53771,3915),(53772,3916),(53773,3916),(53774,3916),(53775,3916),(53776,3917),(53777,3917),(53778,3917),(53779,3917),(53780,3918),(53781,3918),(53782,3918),(53783,3918),(53784,3919),(53785,3919),(53786,3919),(53787,3919),(53788,3920),(53789,3920),(53790,3920),(53791,3920),(53792,3921),(53793,3921),(53794,3921),(53795,3921),(53796,3922),(53797,3922),(53798,3922),(53799,3922),(53800,3923),(53801,3923),(53802,3923),(53803,3923),(53804,3924),(53805,3924),(53806,3924),(53807,3924),(53808,3925),(53809,3925),(53810,3925),(53811,3925),(53812,3926),(53813,3926),(53814,3926),(53815,3926),(53816,3927),(53817,3927),(53818,3927),(53819,3927),(53820,3928),(53821,3928),(53822,3928),(53823,3928),(53824,3929),(53825,3929),(53826,3929),(53827,3929),(53828,3930),(53829,3930),(53830,3930),(53831,3930),(53832,3931),(53833,3931),(53834,3931),(53835,3931),(53836,3932),(53837,3932),(53838,3932),(53839,3932),(53840,3933),(53841,3933),(53842,3933),(53843,3933),(53844,3934),(53845,3934),(53846,3934),(53847,3934),(53848,3935),(53849,3935),(53850,3935),(53851,3935),(53852,3936),(53853,3936),(53854,3936),(53855,3936),(53856,3937),(53857,3937),(53858,3937),(53859,3937),(53860,3938),(53861,3938),(53862,3938),(53863,3938),(53864,3939),(53865,3939),(53866,3939),(53867,3939),(53868,3940),(53869,3940),(53870,3940),(53871,3940),(53872,3941),(53873,3941),(53874,3941),(53875,3941),(53876,3942),(53877,3942),(53878,3942),(53879,3942),(53880,3943),(53881,3943),(53882,3943),(53883,3943),(53884,3944),(53885,3944),(53886,3944),(53887,3944),(53888,3945),(53889,3945),(53890,3945),(53891,3945),(53892,3946),(53893,3946),(53894,3946),(53895,3946),(53896,3947),(53897,3947),(53898,3947),(53899,3947),(53900,3948),(53901,3948),(53902,3948),(53903,3948),(53904,3949),(53905,3949),(53906,3949),(53907,3949),(53908,3950),(53909,3950),(53910,3950),(53911,3950),(53912,3951),(53913,3951),(53914,3951),(53915,3951),(53916,3952),(53917,3952),(53918,3952),(53919,3952),(53920,3953),(53921,3953),(53922,3953),(53923,3953),(53924,3954),(53925,3954),(53926,3954),(53927,3954),(53928,3955),(53929,3955),(53930,3955),(53931,3955),(53932,3956),(53933,3956),(53934,3956),(53935,3956),(53936,3957),(53937,3957),(53938,3957),(53939,3957),(53940,3958),(53941,3958),(53942,3958),(53943,3958),(53944,3959),(53945,3959),(53946,3959),(53947,3959),(53948,3960),(53949,3960),(53950,3960),(53951,3960),(53952,3961),(53953,3961),(53954,3961),(53955,3961),(53956,3962),(53957,3962),(53958,3962),(53959,3962),(53960,3963),(53961,3963),(53962,3963),(53963,3963),(53964,3964),(53965,3964),(53966,3964),(53967,3964),(53968,3965),(53969,3965),(53970,3965),(53971,3965),(53972,3966),(53973,3966),(53974,3966),(53975,3966),(53976,3967),(53977,3967),(53978,3967),(53979,3967),(53980,3968),(53981,3968),(53982,3968),(53983,3968),(53984,3969),(53985,3969),(53986,3969),(53987,3969),(53988,3970),(53989,3970),(53990,3970),(53991,3970),(53992,3971),(53993,3971),(53994,3971),(53995,3971),(53996,3972),(53997,3972),(53998,3972),(53999,3972),(54000,3973),(54001,3973),(54002,3973),(54003,3973),(54004,3974),(54005,3974),(54006,3974),(54007,3974),(54008,3975),(54009,3975),(54010,3975),(54011,3975),(54012,3976),(54013,3976),(54014,3976),(54015,3976),(54016,3977),(54017,3977),(54018,3977),(54019,3977),(54020,3978),(54021,3978),(54022,3978),(54023,3978),(54024,3979),(54025,3979),(54026,3979),(54027,3979),(54028,3980),(54029,3980),(54030,3980),(54031,3980),(54032,3981),(54033,3981),(54034,3981),(54035,3981),(54036,3982),(54037,3982),(54038,3982),(54039,3982),(54040,3983),(54041,3983),(54042,3983),(54043,3983),(54044,3984),(54045,3984),(54046,3984),(54047,3984),(54048,3985),(54049,3985),(54050,3985),(54051,3985),(54052,3986),(54053,3986),(54054,3986),(54055,3986),(54056,3987),(54057,3987),(54058,3987),(54059,3987),(54060,3988),(54061,3988),(54062,3988),(54063,3988),(54064,3989),(54065,3989),(54066,3989),(54067,3989),(54068,3990),(54069,3990),(54070,3990),(54071,3990),(54072,3991),(54073,3991),(54074,3991),(54075,3991),(54076,3992),(54077,3992),(54078,3992),(54079,3992),(54080,3993),(54081,3993),(54082,3993),(54083,3993),(54084,3994),(54085,3994),(54086,3994),(54087,3994),(54088,3995),(54089,3995),(54090,3995),(54091,3995),(54092,3996),(54093,3996),(54094,3996),(54095,3996),(54096,3997),(54097,3997),(54098,3997),(54099,3997),(54100,3998),(54101,3998),(54102,3998),(54103,3998),(54104,3999),(54105,3999),(54106,3999),(54107,3999),(54108,4000),(54109,4000),(54110,4000),(54111,4000),(54112,4001),(54113,4001),(54114,4001),(54115,4001),(54116,4002),(54117,4002),(54118,4002),(54119,4002),(54120,4003),(54121,4003),(54122,4003),(54123,4003),(54124,4004),(54125,4004),(54126,4004),(54127,4004),(54128,4005),(54129,4005),(54130,4005),(54131,4005),(54132,4006),(54133,4006),(54134,4006),(54135,4006),(54136,4007),(54137,4007),(54138,4007),(54139,4007),(54140,4008),(54141,4008),(54142,4008),(54143,4008),(54144,4009),(54145,4009),(54146,4009),(54147,4009),(54148,4010),(54149,4010),(54150,4010),(54151,4010),(54152,4011),(54153,4011),(54154,4011),(54155,4011),(54156,4012),(54157,4012),(54158,4012),(54159,4012),(54160,4013),(54161,4013),(54162,4013),(54163,4013),(54164,4014),(54165,4014),(54166,4014),(54167,4014),(54168,4015),(54169,4015),(54170,4015),(54171,4015),(54172,4015),(54173,4015),(54174,4016),(54175,4016),(54176,4016),(54177,4016),(54178,4016),(54179,4016),(54180,4017),(54181,4017),(54182,4017),(54183,4017),(54184,4017),(54185,4017),(54186,4018),(54187,4018),(54188,4018),(54189,4018),(54190,4018),(54191,4018),(54192,4019),(54193,4019),(54194,4019),(54195,4019),(54196,4019),(54197,4019),(54198,4020),(54199,4020),(54200,4020),(54201,4020),(54202,4020),(54203,4020),(54204,4021),(54205,4021),(54206,4021),(54207,4021),(54208,4021),(54209,4021),(54210,4022),(54211,4022),(54212,4022),(54213,4022),(54214,4022),(54215,4022),(54216,4023),(54217,4023),(54218,4023),(54219,4023),(54220,4023),(54221,4023),(54222,4024),(54223,4024),(54224,4024),(54225,4024),(54226,4024),(54227,4024),(54228,4025),(54229,4025),(54230,4025),(54231,4025),(54232,4025),(54233,4025),(54234,4026),(54235,4026),(54236,4026),(54237,4026),(54238,4026),(54239,4026),(54240,4027),(54241,4027),(54242,4027),(54243,4027),(54244,4027),(54245,4027),(54246,4028),(54247,4028),(54248,4028),(54249,4028),(54250,4028),(54251,4028),(54252,4029),(54253,4029),(54254,4029),(54255,4029),(54256,4029),(54257,4029),(54258,4030),(54259,4030),(54260,4030),(54261,4030),(54262,4030),(54263,4030),(54264,4031),(54265,4031),(54266,4031),(54267,4031),(54268,4031),(54269,4031),(54270,4032),(54271,4032),(54272,4032),(54273,4032),(54274,4032),(54275,4032),(54276,4033),(54277,4033),(54278,4033),(54279,4033),(54280,4033),(54281,4033),(54282,4034),(54283,4034),(54284,4034),(54285,4034),(54286,4034),(54287,4034),(54288,4035),(54289,4035),(54290,4035),(54291,4035),(54292,4035),(54293,4035),(54294,4036),(54295,4036),(54296,4036),(54297,4036),(54298,4036),(54299,4036),(54300,4037),(54301,4037),(54302,4037),(54303,4037),(54304,4037),(54305,4037),(54306,4038),(54307,4038),(54308,4038),(54309,4038),(54310,4038),(54311,4038),(54312,4039),(54313,4039),(54314,4039),(54315,4039),(54316,4039),(54317,4039),(54318,4040),(54319,4040),(54320,4040),(54321,4040),(54322,4040),(54323,4040),(54324,4041),(54325,4041),(54326,4041),(54327,4041),(54328,4041),(54329,4041),(54330,4042),(54331,4042),(54332,4042),(54333,4042),(54334,4042),(54335,4042),(54336,4043),(54337,4043),(54338,4043),(54339,4043),(54340,4043),(54341,4043),(54342,4044),(54343,4044),(54344,4044),(54345,4044),(54346,4044),(54347,4044),(54348,4045),(54349,4045),(54350,4045),(54351,4045),(54352,4045),(54353,4045),(54354,4046),(54355,4046),(54356,4046),(54357,4046),(54358,4046),(54359,4046),(54360,4047),(54361,4047),(54362,4047),(54363,4047),(54364,4047),(54365,4047),(54366,4048),(54367,4048),(54368,4048),(54369,4048),(54370,4048),(54371,4048),(54372,4049),(54373,4049),(54374,4049),(54375,4049),(54376,4049),(54377,4049),(54378,4050),(54379,4050),(54380,4050),(54381,4050),(54382,4050),(54383,4050),(54384,4051),(54385,4051),(54386,4051),(54387,4051),(54388,4051),(54389,4051),(54390,4052),(54391,4052),(54392,4052),(54393,4052),(54394,4052),(54395,4052),(54396,4053),(54397,4053),(54398,4053),(54399,4053),(54400,4053),(54401,4053),(54402,4054),(54403,4054),(54404,4054),(54405,4054),(54406,4054),(54407,4054),(54408,4055),(54409,4055),(54410,4055),(54411,4055),(54412,4055),(54413,4055),(54414,4056),(54415,4056),(54416,4056),(54417,4056),(54418,4056),(54419,4056),(54420,4057),(54421,4057),(54422,4057),(54423,4057),(54424,4057),(54425,4057),(54426,4058),(54427,4058),(54428,4058),(54429,4058),(54430,4058),(54431,4058),(54432,4059),(54433,4059),(54434,4059),(54435,4059),(54436,4059),(54437,4059),(54438,4060),(54439,4060),(54440,4060),(54441,4060),(54442,4060),(54443,4060),(54444,4061),(54445,4061),(54446,4061),(54447,4061),(54448,4061),(54449,4061),(54450,4062),(54451,4062),(54452,4062),(54453,4062),(54454,4062),(54455,4062),(54456,4063),(54457,4063),(54458,4063),(54459,4063),(54460,4063),(54461,4063),(54462,4064),(54463,4064),(54464,4064),(54465,4064),(54466,4064),(54467,4064),(54468,4065),(54469,4065),(54470,4065),(54471,4065),(54472,4065),(54473,4065),(54474,4066),(54475,4066),(54476,4066),(54477,4066),(54478,4066),(54479,4066),(54480,4067),(54481,4067),(54482,4067),(54483,4067),(54484,4067),(54485,4067),(54486,4068),(54487,4068),(54488,4068),(54489,4068),(54490,4068),(54491,4068),(54492,4069),(54493,4069),(54494,4069),(54495,4069),(54496,4069),(54497,4069),(54498,4070),(54499,4070),(54500,4070),(54501,4070),(54502,4070),(54503,4070),(54504,4071),(54505,4071),(54506,4071),(54507,4071),(54508,4071),(54509,4071),(54510,4072),(54511,4072),(54512,4072),(54513,4072),(54514,4072),(54515,4072),(54516,4073),(54517,4073),(54518,4073),(54519,4073),(54520,4073),(54521,4073),(54522,4074),(54523,4074),(54524,4074),(54525,4074),(54526,4074),(54527,4074),(54528,4075),(54529,4075),(54530,4075),(54531,4075),(54532,4075),(54533,4075),(54534,4076),(54535,4076),(54536,4076),(54537,4076),(54538,4076),(54539,4076),(54540,4077),(54541,4077),(54542,4077),(54543,4077),(54544,4077),(54545,4077),(54546,4078),(54547,4078),(54548,4078),(54549,4078),(54550,4078),(54551,4078),(54552,4079),(54553,4079),(54554,4079),(54555,4079),(54556,4079),(54557,4079),(54558,4080),(54559,4080),(54560,4080),(54561,4080),(54562,4080),(54563,4080),(54564,4081),(54565,4081),(54566,4081),(54567,4081),(54568,4081),(54569,4081),(54570,4082),(54571,4082),(54572,4082),(54573,4082),(54574,4082),(54575,4082),(54576,4083),(54577,4083),(54578,4083),(54579,4083),(54580,4083),(54581,4083),(54582,4084),(54583,4084),(54584,4084),(54585,4084),(54586,4084),(54587,4084),(54588,4085),(54589,4085),(54590,4085),(54591,4085),(54592,4085),(54593,4085),(54594,4086),(54595,4086),(54596,4086),(54597,4086),(54598,4086),(54599,4086),(54600,4087),(54601,4087),(54602,4087),(54603,4087),(54604,4087),(54605,4087),(54606,4088),(54607,4088),(54608,4088),(54609,4088),(54610,4088),(54611,4088),(54612,4089),(54613,4089),(54614,4089),(54615,4089),(54616,4089),(54617,4089),(54618,4090),(54619,4090),(54620,4090),(54621,4090),(54622,4090),(54623,4090),(54624,4091),(54625,4091),(54626,4091),(54627,4091),(54628,4091),(54629,4091),(54630,4092),(54631,4092),(54632,4092),(54633,4092),(54634,4092),(54635,4092),(54636,4093),(54637,4093),(54638,4093),(54639,4093),(54640,4093),(54641,4093),(54642,4094),(54643,4094),(54644,4094),(54645,4094),(54646,4094),(54647,4094),(54648,4095),(54649,4095),(54650,4095),(54651,4095),(54652,4095),(54653,4095),(54654,4096),(54655,4096),(54656,4096),(54657,4096),(54658,4096),(54659,4096),(54660,4097),(54661,4097),(54662,4097),(54663,4097),(54664,4097),(54665,4097),(54666,4098),(54667,4098),(54668,4098),(54669,4098),(54670,4098),(54671,4098),(54672,4099),(54673,4099),(54674,4099),(54675,4099),(54676,4099),(54677,4099),(54678,4100),(54679,4100),(54680,4100),(54681,4100),(54682,4100),(54683,4100),(54684,4101),(54685,4101),(54686,4101),(54687,4101),(54688,4101),(54689,4101),(54690,4102),(54691,4102),(54692,4102),(54693,4102),(54694,4102),(54695,4102),(54696,4103),(54697,4103),(54698,4103),(54699,4103),(54700,4103),(54701,4103),(54702,4104),(54703,4104),(54704,4104),(54705,4104),(54706,4104),(54707,4104),(54708,4105),(54709,4105),(54710,4105),(54711,4105),(54712,4105),(54713,4105),(54714,4106),(54715,4106),(54716,4106),(54717,4106),(54718,4106),(54719,4106),(54720,4107),(54721,4107),(54722,4107),(54723,4107),(54724,4107),(54725,4107),(54726,4108),(54727,4108),(54728,4108),(54729,4108),(54730,4108),(54731,4108),(54732,4109),(54733,4109),(54734,4109),(54735,4109),(54736,4109),(54737,4109),(54738,4110),(54739,4110),(54740,4110),(54741,4110),(54742,4110),(54743,4110),(54744,4111),(54745,4111),(54746,4111),(54747,4111),(54748,4111),(54749,4111),(54750,4112),(54751,4112),(54752,4112),(54753,4112),(54754,4112),(54755,4112),(54756,4113),(54757,4113),(54758,4113),(54759,4113),(54760,4113),(54761,4113),(54762,4114),(54763,4114),(54764,4114),(54765,4114),(54766,4114),(54767,4114),(54768,4015),(54769,4015),(54770,4015),(54771,4016),(54772,4016),(54773,4016),(54774,4017),(54775,4017),(54776,4017),(54777,4018),(54778,4018),(54779,4018),(54780,4019),(54781,4019),(54782,4019),(54783,4020),(54784,4020),(54785,4020),(54786,4021),(54787,4021),(54788,4021),(54789,4022),(54790,4022),(54791,4022),(54792,4023),(54793,4023),(54794,4023),(54795,4024),(54796,4024),(54797,4024),(54798,4025),(54799,4025),(54800,4025),(54801,4026),(54802,4026),(54803,4026),(54804,4027),(54805,4027),(54806,4027),(54807,4028),(54808,4028),(54809,4028),(54810,4029),(54811,4029),(54812,4029),(54813,4030),(54814,4030),(54815,4030),(54816,4031),(54817,4031),(54818,4031),(54819,4032),(54820,4032),(54821,4032),(54822,4033),(54823,4033),(54824,4033),(54825,4034),(54826,4034),(54827,4034),(54828,4035),(54829,4035),(54830,4035),(54831,4036),(54832,4036),(54833,4036),(54834,4037),(54835,4037),(54836,4037),(54837,4038),(54838,4038),(54839,4038),(54840,4039),(54841,4039),(54842,4039),(54843,4040),(54844,4040),(54845,4040),(54846,4041),(54847,4041),(54848,4041),(54849,4042),(54850,4042),(54851,4042),(54852,4043),(54853,4043),(54854,4044),(54855,4044),(54856,4044),(54857,4045),(54858,4045),(54859,4045),(54860,4046),(54861,4046),(54862,4046),(54863,4047),(54864,4047),(54865,4047),(54866,4048),(54867,4048),(54868,4048),(54869,4049),(54870,4049),(54871,4049),(54872,4050),(54873,4050),(54874,4050),(54875,4051),(54876,4051),(54877,4051),(54878,4052),(54879,4052),(54880,4052),(54881,4053),(54882,4053),(54883,4053),(54884,4054),(54885,4054),(54886,4055),(54887,4055),(54888,4056),(54889,4056),(54890,4056),(54891,4057),(54892,4057),(54893,4057),(54894,4058),(54895,4058),(54896,4058),(54897,4059),(54898,4059),(54899,4059),(54900,4060),(54901,4060),(54902,4060),(54903,4061),(54904,4061),(54905,4061),(54906,4062),(54907,4062),(54908,4062),(54909,4063),(54910,4063),(54911,4063),(54912,4064),(54913,4064),(54914,4064),(54915,4065),(54916,4065),(54917,4065),(54918,4066),(54919,4066),(54920,4066),(54921,4067),(54922,4067),(54923,4067),(54924,4068),(54925,4068),(54926,4068),(54927,4069),(54928,4069),(54929,4069),(54930,4070),(54931,4070),(54932,4070),(54933,4071),(54934,4071),(54935,4071),(54936,4072),(54937,4072),(54938,4072),(54939,4073),(54940,4073),(54941,4073),(54942,4074),(54943,4074),(54944,4074),(54945,4075),(54946,4075),(54947,4076),(54948,4076),(54949,4077),(54950,4077),(54951,4078),(54952,4078),(54953,4079),(54954,4079),(54955,4079),(54956,4080),(54957,4080),(54958,4080),(54959,4081),(54960,4081),(54961,4081),(54962,4082),(54963,4082),(54964,4082),(54965,4083),(54966,4083),(54967,4083),(54968,4084),(54969,4084),(54970,4084),(54971,4085),(54972,4085),(54973,4085),(54974,4086),(54975,4086),(54976,4086),(54977,4087),(54978,4087),(54979,4087),(54980,4088),(54981,4088),(54982,4088),(54983,4089),(54984,4089),(54985,4089),(54986,4090),(54987,4090),(54988,4090),(54989,4091),(54990,4091),(54991,4091),(54992,4092),(54993,4092),(54994,4093),(54995,4093),(54996,4094),(54997,4094),(54998,4095),(54999,4095),(55000,4096),(55001,4096),(55002,4097),(55003,4097),(55004,4098),(55005,4098),(55006,4098),(55007,4099),(55008,4099),(55009,4099),(55010,4100),(55011,4100),(55012,4100),(55013,4101),(55014,4101),(55015,4101),(55016,4102),(55017,4102),(55018,4102),(55019,4103),(55020,4103),(55021,4103),(55022,4104),(55023,4104),(55024,4104),(55025,4105),(55026,4105),(55027,4105),(55028,4106),(55029,4106),(55030,4106),(55031,4107),(55032,4107),(55033,4107),(55034,4108),(55035,4108),(55036,4108),(55037,4109),(55038,4109),(55039,4109),(55040,4110),(55041,4110),(55042,4110),(55043,4111),(55044,4111),(55045,4111),(55046,4112),(55047,4112),(55048,4112),(55049,4113),(55050,4113),(55051,4113),(55052,4114),(55053,4114),(55054,4114),(55055,4015),(55056,4015),(55057,4015),(55058,4015),(55059,4016),(55060,4016),(55061,4016),(55062,4016),(55063,4017),(55064,4017),(55065,4017),(55066,4017),(55067,4018),(55068,4018),(55069,4018),(55070,4018),(55071,4019),(55072,4019),(55073,4019),(55074,4019),(55075,4020),(55076,4020),(55077,4020),(55078,4020),(55079,4021),(55080,4021),(55081,4021),(55082,4021),(55083,4022),(55084,4022),(55085,4022),(55086,4022),(55087,4023),(55088,4023),(55089,4023),(55090,4023),(55091,4024),(55092,4024),(55093,4024),(55094,4024),(55095,4025),(55096,4025),(55097,4025),(55098,4025),(55099,4026),(55100,4026),(55101,4026),(55102,4026),(55103,4027),(55104,4027),(55105,4027),(55106,4027),(55107,4028),(55108,4028),(55109,4028),(55110,4028),(55111,4029),(55112,4029),(55113,4029),(55114,4029),(55115,4030),(55116,4030),(55117,4030),(55118,4030),(55119,4031),(55120,4031),(55121,4031),(55122,4031),(55123,4032),(55124,4032),(55125,4032),(55126,4032),(55127,4033),(55128,4033),(55129,4033),(55130,4033),(55131,4034),(55132,4034),(55133,4034),(55134,4034),(55135,4035),(55136,4035),(55137,4035),(55138,4035),(55139,4036),(55140,4036),(55141,4036),(55142,4036),(55143,4037),(55144,4037),(55145,4037),(55146,4037),(55147,4038),(55148,4038),(55149,4038),(55150,4038),(55151,4039),(55152,4039),(55153,4039),(55154,4039),(55155,4040),(55156,4040),(55157,4040),(55158,4040),(55159,4041),(55160,4041),(55161,4041),(55162,4041),(55163,4042),(55164,4042),(55165,4042),(55166,4042),(55167,4043),(55168,4043),(55169,4043),(55170,4043),(55171,4044),(55172,4044),(55173,4044),(55174,4044),(55175,4045),(55176,4045),(55177,4045),(55178,4045),(55179,4046),(55180,4046),(55181,4046),(55182,4046),(55183,4047),(55184,4047),(55185,4047),(55186,4047),(55187,4048),(55188,4048),(55189,4048),(55190,4048),(55191,4049),(55192,4049),(55193,4049),(55194,4049),(55195,4050),(55196,4050),(55197,4050),(55198,4050),(55199,4051),(55200,4051),(55201,4051),(55202,4051),(55203,4052),(55204,4052),(55205,4052),(55206,4052),(55207,4053),(55208,4053),(55209,4053),(55210,4053),(55211,4054),(55212,4054),(55213,4054),(55214,4054),(55215,4055),(55216,4055),(55217,4055),(55218,4055),(55219,4056),(55220,4056),(55221,4056),(55222,4056),(55223,4057),(55224,4057),(55225,4057),(55226,4057),(55227,4058),(55228,4058),(55229,4058),(55230,4058),(55231,4059),(55232,4059),(55233,4059),(55234,4059),(55235,4060),(55236,4060),(55237,4060),(55238,4060),(55239,4061),(55240,4061),(55241,4061),(55242,4061),(55243,4062),(55244,4062),(55245,4062),(55246,4062),(55247,4063),(55248,4063),(55249,4063),(55250,4063),(55251,4064),(55252,4064),(55253,4064),(55254,4064),(55255,4065),(55256,4065),(55257,4065),(55258,4065),(55259,4066),(55260,4066),(55261,4066),(55262,4066),(55263,4067),(55264,4067),(55265,4067),(55266,4067),(55267,4068),(55268,4068),(55269,4068),(55270,4068),(55271,4069),(55272,4069),(55273,4069),(55274,4069),(55275,4070),(55276,4070),(55277,4070),(55278,4070),(55279,4071),(55280,4071),(55281,4071),(55282,4071),(55283,4072),(55284,4072),(55285,4072),(55286,4072),(55287,4073),(55288,4073),(55289,4073),(55290,4073),(55291,4074),(55292,4074),(55293,4074),(55294,4074),(55295,4075),(55296,4075),(55297,4075),(55298,4075),(55299,4076),(55300,4076),(55301,4076),(55302,4076),(55303,4077),(55304,4077),(55305,4077),(55306,4077),(55307,4078),(55308,4078),(55309,4078),(55310,4078),(55311,4079),(55312,4079),(55313,4079),(55314,4079),(55315,4080),(55316,4080),(55317,4080),(55318,4080),(55319,4081),(55320,4081),(55321,4081),(55322,4081),(55323,4082),(55324,4082),(55325,4082),(55326,4082),(55327,4083),(55328,4083),(55329,4083),(55330,4083),(55331,4084),(55332,4084),(55333,4084),(55334,4084),(55335,4085),(55336,4085),(55337,4085),(55338,4085),(55339,4086),(55340,4086),(55341,4086),(55342,4086),(55343,4087),(55344,4087),(55345,4087),(55346,4087),(55347,4088),(55348,4088),(55349,4088),(55350,4088),(55351,4089),(55352,4089),(55353,4089),(55354,4089),(55355,4090),(55356,4090),(55357,4090),(55358,4090),(55359,4091),(55360,4091),(55361,4091),(55362,4091),(55363,4092),(55364,4092),(55365,4092),(55366,4092),(55367,4093),(55368,4093),(55369,4093),(55370,4093),(55371,4094),(55372,4094),(55373,4094),(55374,4094),(55375,4095),(55376,4095),(55377,4095),(55378,4095),(55379,4096),(55380,4096),(55381,4096),(55382,4096),(55383,4097),(55384,4097),(55385,4097),(55386,4097),(55387,4098),(55388,4098),(55389,4098),(55390,4098),(55391,4099),(55392,4099),(55393,4099),(55394,4099),(55395,4100),(55396,4100),(55397,4100),(55398,4100),(55399,4101),(55400,4101),(55401,4101),(55402,4101),(55403,4102),(55404,4102),(55405,4102),(55406,4102),(55407,4103),(55408,4103),(55409,4103),(55410,4103),(55411,4104),(55412,4104),(55413,4104),(55414,4104),(55415,4105),(55416,4105),(55417,4105),(55418,4105),(55419,4106),(55420,4106),(55421,4106),(55422,4106),(55423,4107),(55424,4107),(55425,4107),(55426,4107),(55427,4108),(55428,4108),(55429,4108),(55430,4108),(55431,4109),(55432,4109),(55433,4109),(55434,4109),(55435,4110),(55436,4110),(55437,4110),(55438,4110),(55439,4111),(55440,4111),(55441,4111),(55442,4111),(55443,4112),(55444,4112),(55445,4112),(55446,4112),(55447,4113),(55448,4113),(55449,4113),(55450,4113),(55451,4114),(55452,4114),(55453,4114),(55454,4114),(55455,4115),(55456,4115),(55457,4115),(55458,4115),(55459,4115),(55460,4115),(55461,4116),(55462,4116),(55463,4116),(55464,4116),(55465,4116),(55466,4116),(55467,4117),(55468,4117),(55469,4117),(55470,4117),(55471,4117),(55472,4117),(55473,4118),(55474,4118),(55475,4118),(55476,4118),(55477,4118),(55478,4118),(55479,4119),(55480,4119),(55481,4119),(55482,4119),(55483,4119),(55484,4119),(55485,4120),(55486,4120),(55487,4120),(55488,4120),(55489,4120),(55490,4120),(55491,4121),(55492,4121),(55493,4121),(55494,4121),(55495,4121),(55496,4121),(55497,4122),(55498,4122),(55499,4122),(55500,4122),(55501,4122),(55502,4122),(55503,4123),(55504,4123),(55505,4123),(55506,4123),(55507,4123),(55508,4123),(55509,4124),(55510,4124),(55511,4124),(55512,4124),(55513,4124),(55514,4124),(55515,4125),(55516,4125),(55517,4125),(55518,4125),(55519,4125),(55520,4125),(55521,4126),(55522,4126),(55523,4126),(55524,4126),(55525,4126),(55526,4126),(55527,4127),(55528,4127),(55529,4127),(55530,4127),(55531,4127),(55532,4127),(55533,4128),(55534,4128),(55535,4128),(55536,4128),(55537,4128),(55538,4128),(55539,4129),(55540,4129),(55541,4129),(55542,4129),(55543,4129),(55544,4129),(55545,4130),(55546,4130),(55547,4130),(55548,4130),(55549,4130),(55550,4130),(55551,4131),(55552,4131),(55553,4131),(55554,4131),(55555,4131),(55556,4131),(55557,4132),(55558,4132),(55559,4132),(55560,4132),(55561,4132),(55562,4132),(55563,4133),(55564,4133),(55565,4133),(55566,4133),(55567,4133),(55568,4133),(55569,4134),(55570,4134),(55571,4134),(55572,4134),(55573,4134),(55574,4134),(55575,4135),(55576,4135),(55577,4135),(55578,4135),(55579,4135),(55580,4135),(55581,4136),(55582,4136),(55583,4136),(55584,4136),(55585,4136),(55586,4136),(55587,4137),(55588,4137),(55589,4137),(55590,4137),(55591,4137),(55592,4137),(55593,4138),(55594,4138),(55595,4138),(55596,4138),(55597,4138),(55598,4138),(55599,4139),(55600,4139),(55601,4139),(55602,4139),(55603,4139),(55604,4139),(55605,4140),(55606,4140),(55607,4140),(55608,4140),(55609,4140),(55610,4140),(55611,4141),(55612,4141),(55613,4141),(55614,4141),(55615,4141),(55616,4141),(55617,4142),(55618,4142),(55619,4142),(55620,4142),(55621,4142),(55622,4142),(55623,4143),(55624,4143),(55625,4143),(55626,4143),(55627,4143),(55628,4143),(55629,4144),(55630,4144),(55631,4144),(55632,4144),(55633,4144),(55634,4144),(55635,4145),(55636,4145),(55637,4145),(55638,4145),(55639,4145),(55640,4145),(55641,4146),(55642,4146),(55643,4146),(55644,4146),(55645,4146),(55646,4146),(55647,4147),(55648,4147),(55649,4147),(55650,4147),(55651,4147),(55652,4147),(55653,4148),(55654,4148),(55655,4148),(55656,4148),(55657,4148),(55658,4148),(55659,4149),(55660,4149),(55661,4149),(55662,4149),(55663,4149),(55664,4149),(55665,4150),(55666,4150),(55667,4150),(55668,4150),(55669,4150),(55670,4150),(55671,4151),(55672,4151),(55673,4151),(55674,4151),(55675,4151),(55676,4151),(55677,4152),(55678,4152),(55679,4152),(55680,4152),(55681,4152),(55682,4152),(55683,4153),(55684,4153),(55685,4153),(55686,4153),(55687,4153),(55688,4153),(55689,4154),(55690,4154),(55691,4154),(55692,4154),(55693,4154),(55694,4154),(55695,4155),(55696,4155),(55697,4155),(55698,4155),(55699,4155),(55700,4155),(55701,4156),(55702,4156),(55703,4156),(55704,4156),(55705,4156),(55706,4156),(55707,4157),(55708,4157),(55709,4157),(55710,4157),(55711,4157),(55712,4157),(55713,4158),(55714,4158),(55715,4158),(55716,4158),(55717,4158),(55718,4158),(55719,4159),(55720,4159),(55721,4159),(55722,4159),(55723,4159),(55724,4159),(55725,4160),(55726,4160),(55727,4160),(55728,4160),(55729,4160),(55730,4160),(55731,4161),(55732,4161),(55733,4161),(55734,4161),(55735,4161),(55736,4161),(55737,4162),(55738,4162),(55739,4162),(55740,4162),(55741,4162),(55742,4162),(55743,4163),(55744,4163),(55745,4163),(55746,4163),(55747,4163),(55748,4163),(55749,4164),(55750,4164),(55751,4164),(55752,4164),(55753,4164),(55754,4164),(55755,4165),(55756,4165),(55757,4165),(55758,4165),(55759,4165),(55760,4165),(55761,4166),(55762,4166),(55763,4166),(55764,4166),(55765,4166),(55766,4166),(55767,4167),(55768,4167),(55769,4167),(55770,4167),(55771,4167),(55772,4167),(55773,4168),(55774,4168),(55775,4168),(55776,4168),(55777,4168),(55778,4168),(55779,4169),(55780,4169),(55781,4169),(55782,4169),(55783,4169),(55784,4169),(55785,4170),(55786,4170),(55787,4170),(55788,4170),(55789,4170),(55790,4170),(55791,4171),(55792,4171),(55793,4171),(55794,4171),(55795,4171),(55796,4171),(55797,4172),(55798,4172),(55799,4172),(55800,4172),(55801,4172),(55802,4172),(55803,4173),(55804,4173),(55805,4173),(55806,4173),(55807,4173),(55808,4173),(55809,4174),(55810,4174),(55811,4174),(55812,4174),(55813,4174),(55814,4174),(55815,4175),(55816,4175),(55817,4175),(55818,4175),(55819,4175),(55820,4175),(55821,4176),(55822,4176),(55823,4176),(55824,4176),(55825,4176),(55826,4176),(55827,4177),(55828,4177),(55829,4177),(55830,4177),(55831,4177),(55832,4177),(55833,4178),(55834,4178),(55835,4178),(55836,4178),(55837,4178),(55838,4178),(55839,4179),(55840,4179),(55841,4179),(55842,4179),(55843,4179),(55844,4179),(55845,4180),(55846,4180),(55847,4180),(55848,4180),(55849,4180),(55850,4180),(55851,4181),(55852,4181),(55853,4181),(55854,4181),(55855,4181),(55856,4181),(55857,4182),(55858,4182),(55859,4182),(55860,4182),(55861,4182),(55862,4182),(55863,4183),(55864,4183),(55865,4183),(55866,4183),(55867,4183),(55868,4183),(55869,4184),(55870,4184),(55871,4184),(55872,4184),(55873,4184),(55874,4184),(55875,4185),(55876,4185),(55877,4185),(55878,4185),(55879,4185),(55880,4185),(55881,4186),(55882,4186),(55883,4186),(55884,4186),(55885,4186),(55886,4186),(55887,4187),(55888,4187),(55889,4187),(55890,4187),(55891,4187),(55892,4187),(55893,4188),(55894,4188),(55895,4188),(55896,4188),(55897,4188),(55898,4188),(55899,4189),(55900,4189),(55901,4189),(55902,4189),(55903,4189),(55904,4189),(55905,4190),(55906,4190),(55907,4190),(55908,4190),(55909,4190),(55910,4190),(55911,4191),(55912,4191),(55913,4191),(55914,4191),(55915,4191),(55916,4191),(55917,4192),(55918,4192),(55919,4192),(55920,4192),(55921,4192),(55922,4192),(55923,4193),(55924,4193),(55925,4193),(55926,4193),(55927,4193),(55928,4193),(55929,4194),(55930,4194),(55931,4194),(55932,4194),(55933,4194),(55934,4194),(55935,4195),(55936,4195),(55937,4195),(55938,4195),(55939,4195),(55940,4195),(55941,4196),(55942,4196),(55943,4196),(55944,4196),(55945,4196),(55946,4196),(55947,4197),(55948,4197),(55949,4197),(55950,4197),(55951,4197),(55952,4197),(55953,4198),(55954,4198),(55955,4198),(55956,4198),(55957,4198),(55958,4198),(55959,4199),(55960,4199),(55961,4199),(55962,4199),(55963,4199),(55964,4199),(55965,4200),(55966,4200),(55967,4200),(55968,4200),(55969,4200),(55970,4200),(55971,4201),(55972,4201),(55973,4201),(55974,4201),(55975,4201),(55976,4201),(55977,4202),(55978,4202),(55979,4202),(55980,4202),(55981,4202),(55982,4202),(55983,4203),(55984,4203),(55985,4203),(55986,4203),(55987,4203),(55988,4203),(55989,4204),(55990,4204),(55991,4204),(55992,4204),(55993,4204),(55994,4204),(55995,4205),(55996,4205),(55997,4205),(55998,4205),(55999,4205),(56000,4205),(56001,4206),(56002,4206),(56003,4206),(56004,4206),(56005,4206),(56006,4206),(56007,4207),(56008,4207),(56009,4207),(56010,4207),(56011,4207),(56012,4207),(56013,4208),(56014,4208),(56015,4208),(56016,4208),(56017,4208),(56018,4208),(56019,4209),(56020,4209),(56021,4209),(56022,4209),(56023,4209),(56024,4209),(56025,4210),(56026,4210),(56027,4210),(56028,4210),(56029,4210),(56030,4210),(56031,4211),(56032,4211),(56033,4211),(56034,4211),(56035,4211),(56036,4211),(56037,4212),(56038,4212),(56039,4212),(56040,4212),(56041,4212),(56042,4212),(56043,4213),(56044,4213),(56045,4213),(56046,4213),(56047,4213),(56048,4213),(56049,4115),(56050,4115),(56051,4115),(56052,4116),(56053,4116),(56054,4116),(56055,4117),(56056,4117),(56057,4117),(56058,4118),(56059,4118),(56060,4118),(56061,4119),(56062,4119),(56063,4119),(56064,4120),(56065,4120),(56066,4121),(56067,4121),(56068,4121),(56069,4122),(56070,4122),(56071,4122),(56072,4123),(56073,4123),(56074,4123),(56075,4124),(56076,4124),(56077,4124),(56078,4125),(56079,4125),(56080,4125),(56081,4126),(56082,4126),(56083,4126),(56084,4127),(56085,4127),(56086,4127),(56087,4128),(56088,4128),(56089,4128),(56090,4129),(56091,4129),(56092,4129),(56093,4130),(56094,4130),(56095,4130),(56096,4131),(56097,4131),(56098,4131),(56099,4132),(56100,4132),(56101,4132),(56102,4133),(56103,4133),(56104,4133),(56105,4134),(56106,4134),(56107,4134),(56108,4135),(56109,4135),(56110,4135),(56111,4136),(56112,4136),(56113,4136),(56114,4137),(56115,4137),(56116,4137),(56117,4138),(56118,4138),(56119,4138),(56120,4139),(56121,4139),(56122,4139),(56123,4140),(56124,4140),(56125,4140),(56126,4141),(56127,4141),(56128,4141),(56129,4142),(56130,4142),(56131,4143),(56132,4143),(56133,4144),(56134,4144),(56135,4144),(56136,4145),(56137,4145),(56138,4145),(56139,4146),(56140,4146),(56141,4146),(56142,4147),(56143,4147),(56144,4147),(56145,4148),(56146,4148),(56147,4148),(56148,4149),(56149,4149),(56150,4149),(56151,4150),(56152,4150),(56153,4151),(56154,4151),(56155,4152),(56156,4152),(56157,4152),(56158,4153),(56159,4153),(56160,4153),(56161,4154),(56162,4154),(56163,4154),(56164,4155),(56165,4155),(56166,4155),(56167,4156),(56168,4156),(56169,4156),(56170,4157),(56171,4157),(56172,4157),(56173,4158),(56174,4158),(56175,4158),(56176,4159),(56177,4159),(56178,4159),(56179,4160),(56180,4160),(56181,4160),(56182,4161),(56183,4161),(56184,4161),(56185,4162),(56186,4162),(56187,4163),(56188,4163),(56189,4163),(56190,4164),(56191,4164),(56192,4164),(56193,4165),(56194,4165),(56195,4165),(56196,4166),(56197,4166),(56198,4166),(56199,4167),(56200,4167),(56201,4167),(56202,4168),(56203,4168),(56204,4168),(56205,4169),(56206,4169),(56207,4169),(56208,4170),(56209,4170),(56210,4170),(56211,4171),(56212,4171),(56213,4171),(56214,4172),(56215,4172),(56216,4172),(56217,4173),(56218,4173),(56219,4173),(56220,4174),(56221,4174),(56222,4174),(56223,4175),(56224,4175),(56225,4175),(56226,4176),(56227,4176),(56228,4176),(56229,4177),(56230,4177),(56231,4177),(56232,4178),(56233,4178),(56234,4178),(56235,4179),(56236,4179),(56237,4179),(56238,4180),(56239,4180),(56240,4180),(56241,4181),(56242,4181),(56243,4181),(56244,4182),(56245,4182),(56246,4182),(56247,4183),(56248,4183),(56249,4183),(56250,4184),(56251,4184),(56252,4184),(56253,4185),(56254,4185),(56255,4185),(56256,4186),(56257,4186),(56258,4186),(56259,4187),(56260,4187),(56261,4187),(56262,4188),(56263,4188),(56264,4188),(56265,4189),(56266,4189),(56267,4189),(56268,4190),(56269,4190),(56270,4190),(56271,4191),(56272,4191),(56273,4191),(56274,4192),(56275,4192),(56276,4192),(56277,4193),(56278,4193),(56279,4193),(56280,4194),(56281,4194),(56282,4194),(56283,4195),(56284,4195),(56285,4195),(56286,4196),(56287,4196),(56288,4196),(56289,4197),(56290,4197),(56291,4197),(56292,4198),(56293,4198),(56294,4198),(56295,4199),(56296,4199),(56297,4200),(56298,4200),(56299,4201),(56300,4201),(56301,4202),(56302,4202),(56303,4202),(56304,4203),(56305,4203),(56306,4203),(56307,4204),(56308,4204),(56309,4204),(56310,4205),(56311,4205),(56312,4205),(56313,4206),(56314,4206),(56315,4206),(56316,4207),(56317,4207),(56318,4207),(56319,4208),(56320,4208),(56321,4208),(56322,4209),(56323,4209),(56324,4209),(56325,4210),(56326,4210),(56327,4210),(56328,4211),(56329,4211),(56330,4211),(56331,4212),(56332,4212),(56333,4212),(56334,4213),(56335,4213),(56336,4213),(56337,4115),(56338,4115),(56339,4115),(56340,4115),(56341,4116),(56342,4116),(56343,4116),(56344,4116),(56345,4117),(56346,4117),(56347,4117),(56348,4117),(56349,4118),(56350,4118),(56351,4118),(56352,4118),(56353,4119),(56354,4119),(56355,4119),(56356,4119),(56357,4120),(56358,4120),(56359,4120),(56360,4120),(56361,4121),(56362,4121),(56363,4121),(56364,4121),(56365,4122),(56366,4122),(56367,4122),(56368,4122),(56369,4123),(56370,4123),(56371,4123),(56372,4123),(56373,4124),(56374,4124),(56375,4124),(56376,4124),(56377,4125),(56378,4125),(56379,4125),(56380,4125),(56381,4126),(56382,4126),(56383,4126),(56384,4126),(56385,4127),(56386,4127),(56387,4127),(56388,4127),(56389,4128),(56390,4128),(56391,4128),(56392,4128),(56393,4129),(56394,4129),(56395,4129),(56396,4129),(56397,4130),(56398,4130),(56399,4130),(56400,4130),(56401,4131),(56402,4131),(56403,4131),(56404,4131),(56405,4132),(56406,4132),(56407,4132),(56408,4132),(56409,4133),(56410,4133),(56411,4133),(56412,4133),(56413,4134),(56414,4134),(56415,4134),(56416,4134),(56417,4135),(56418,4135),(56419,4135),(56420,4135),(56421,4136),(56422,4136),(56423,4136),(56424,4136),(56425,4137),(56426,4137),(56427,4137),(56428,4137),(56429,4138),(56430,4138),(56431,4138),(56432,4138),(56433,4139),(56434,4139),(56435,4139),(56436,4139),(56437,4140),(56438,4140),(56439,4140),(56440,4140),(56441,4141),(56442,4141),(56443,4141),(56444,4141),(56445,4142),(56446,4142),(56447,4142),(56448,4142),(56449,4143),(56450,4143),(56451,4143),(56452,4143),(56453,4144),(56454,4144),(56455,4144),(56456,4144),(56457,4145),(56458,4145),(56459,4145),(56460,4145),(56461,4146),(56462,4146),(56463,4146),(56464,4146),(56465,4147),(56466,4147),(56467,4147),(56468,4147),(56469,4148),(56470,4148),(56471,4148),(56472,4148),(56473,4149),(56474,4149),(56475,4149),(56476,4149),(56477,4150),(56478,4150),(56479,4150),(56480,4150),(56481,4151),(56482,4151),(56483,4151),(56484,4151),(56485,4152),(56486,4152),(56487,4152),(56488,4152),(56489,4153),(56490,4153),(56491,4153),(56492,4153),(56493,4154),(56494,4154),(56495,4154),(56496,4154),(56497,4155),(56498,4155),(56499,4155),(56500,4155),(56501,4156),(56502,4156),(56503,4156),(56504,4156),(56505,4157),(56506,4157),(56507,4157),(56508,4157),(56509,4158),(56510,4158),(56511,4158),(56512,4158),(56513,4159),(56514,4159),(56515,4159),(56516,4159),(56517,4160),(56518,4160),(56519,4160),(56520,4160),(56521,4161),(56522,4161),(56523,4161),(56524,4161),(56525,4162),(56526,4162),(56527,4162),(56528,4162),(56529,4163),(56530,4163),(56531,4163),(56532,4163),(56533,4164),(56534,4164),(56535,4164),(56536,4164),(56537,4165),(56538,4165),(56539,4165),(56540,4165),(56541,4166),(56542,4166),(56543,4166),(56544,4166),(56545,4167),(56546,4167),(56547,4167),(56548,4167),(56549,4168),(56550,4168),(56551,4168),(56552,4168),(56553,4169),(56554,4169),(56555,4169),(56556,4169),(56557,4170),(56558,4170),(56559,4170),(56560,4170),(56561,4171),(56562,4171),(56563,4171),(56564,4171),(56565,4172),(56566,4172),(56567,4172),(56568,4172),(56569,4173),(56570,4173),(56571,4173),(56572,4173),(56573,4174),(56574,4174),(56575,4174),(56576,4174),(56577,4175),(56578,4175),(56579,4175),(56580,4175),(56581,4176),(56582,4176),(56583,4176),(56584,4176),(56585,4177),(56586,4177),(56587,4177),(56588,4177),(56589,4178),(56590,4178),(56591,4178),(56592,4178),(56593,4179),(56594,4179),(56595,4179),(56596,4179),(56597,4180),(56598,4180),(56599,4180),(56600,4180),(56601,4181),(56602,4181),(56603,4181),(56604,4181),(56605,4182),(56606,4182),(56607,4182),(56608,4182),(56609,4183),(56610,4183),(56611,4183),(56612,4183),(56613,4184),(56614,4184),(56615,4184),(56616,4184),(56617,4185),(56618,4185),(56619,4185),(56620,4185),(56621,4186),(56622,4186),(56623,4186),(56624,4186),(56625,4187),(56626,4187),(56627,4187),(56628,4187),(56629,4188),(56630,4188),(56631,4188),(56632,4188),(56633,4189),(56634,4189),(56635,4189),(56636,4189),(56637,4190),(56638,4190),(56639,4190),(56640,4190),(56641,4191),(56642,4191),(56643,4191),(56644,4191),(56645,4192),(56646,4192),(56647,4192),(56648,4192),(56649,4193),(56650,4193),(56651,4193),(56652,4193),(56653,4194),(56654,4194),(56655,4194),(56656,4194),(56657,4195),(56658,4195),(56659,4195),(56660,4195),(56661,4196),(56662,4196),(56663,4196),(56664,4196),(56665,4197),(56666,4197),(56667,4197),(56668,4197),(56669,4198),(56670,4198),(56671,4198),(56672,4198),(56673,4199),(56674,4199),(56675,4199),(56676,4199),(56677,4200),(56678,4200),(56679,4200),(56680,4200),(56681,4201),(56682,4201),(56683,4201),(56684,4201),(56685,4202),(56686,4202),(56687,4202),(56688,4202),(56689,4203),(56690,4203),(56691,4203),(56692,4203),(56693,4204),(56694,4204),(56695,4204),(56696,4204),(56697,4205),(56698,4205),(56699,4205),(56700,4205),(56701,4206),(56702,4206),(56703,4206),(56704,4206),(56705,4207),(56706,4207),(56707,4207),(56708,4207),(56709,4208),(56710,4208),(56711,4208),(56712,4208),(56713,4209),(56714,4209),(56715,4209),(56716,4209),(56717,4210),(56718,4210),(56719,4210),(56720,4210),(56721,4211),(56722,4211),(56723,4211),(56724,4211),(56725,4212),(56726,4212),(56727,4212),(56728,4212),(56729,4213),(56730,4213),(56731,4213),(56732,4213),(56733,4214),(56734,4214),(56735,4214),(56736,4214),(56737,4214),(56738,4214),(56739,4215),(56740,4215),(56741,4215),(56742,4215),(56743,4215),(56744,4215),(56745,4216),(56746,4216),(56747,4216),(56748,4216),(56749,4216),(56750,4216),(56751,4217),(56752,4217),(56753,4217),(56754,4217),(56755,4217),(56756,4217),(56757,4218),(56758,4218),(56759,4218),(56760,4218),(56761,4218),(56762,4218),(56763,4219),(56764,4219),(56765,4219),(56766,4219),(56767,4219),(56768,4219),(56769,4220),(56770,4220),(56771,4220),(56772,4220),(56773,4220),(56774,4220),(56775,4221),(56776,4221),(56777,4221),(56778,4221),(56779,4221),(56780,4221),(56781,4222),(56782,4222),(56783,4222),(56784,4222),(56785,4222),(56786,4222),(56787,4223),(56788,4223),(56789,4223),(56790,4223),(56791,4223),(56792,4223),(56793,4224),(56794,4224),(56795,4224),(56796,4224),(56797,4224),(56798,4224),(56799,4225),(56800,4225),(56801,4225),(56802,4225),(56803,4225),(56804,4225),(56805,4226),(56806,4226),(56807,4226),(56808,4226),(56809,4226),(56810,4226),(56811,4227),(56812,4227),(56813,4227),(56814,4227),(56815,4227),(56816,4227),(56817,4228),(56818,4228),(56819,4228),(56820,4228),(56821,4228),(56822,4228),(56823,4229),(56824,4229),(56825,4229),(56826,4229),(56827,4229),(56828,4229),(56829,4230),(56830,4230),(56831,4230),(56832,4230),(56833,4230),(56834,4230),(56835,4231),(56836,4231),(56837,4231),(56838,4231),(56839,4231),(56840,4231),(56841,4232),(56842,4232),(56843,4232),(56844,4232),(56845,4232),(56846,4232),(56847,4233),(56848,4233),(56849,4233),(56850,4233),(56851,4233),(56852,4233),(56853,4234),(56854,4234),(56855,4234),(56856,4234),(56857,4234),(56858,4234),(56859,4235),(56860,4235),(56861,4235),(56862,4235),(56863,4235),(56864,4235),(56865,4236),(56866,4236),(56867,4236),(56868,4236),(56869,4236),(56870,4236),(56871,4237),(56872,4237),(56873,4237),(56874,4237),(56875,4237),(56876,4237),(56877,4238),(56878,4238),(56879,4238),(56880,4238),(56881,4238),(56882,4238),(56883,4239),(56884,4239),(56885,4239),(56886,4239),(56887,4239),(56888,4239),(56889,4240),(56890,4240),(56891,4240),(56892,4240),(56893,4240),(56894,4240),(56895,4241),(56896,4241),(56897,4241),(56898,4241),(56899,4241),(56900,4241),(56901,4242),(56902,4242),(56903,4242),(56904,4242),(56905,4242),(56906,4242),(56907,4243),(56908,4243),(56909,4243),(56910,4243),(56911,4243),(56912,4243),(56913,4244),(56914,4244),(56915,4244),(56916,4244),(56917,4244),(56918,4244),(56919,4245),(56920,4245),(56921,4245),(56922,4245),(56923,4245),(56924,4245),(56925,4246),(56926,4246),(56927,4246),(56928,4246),(56929,4246),(56930,4246),(56931,4247),(56932,4247),(56933,4247),(56934,4247),(56935,4247),(56936,4247),(56937,4248),(56938,4248),(56939,4248),(56940,4248),(56941,4248),(56942,4248),(56943,4249),(56944,4249),(56945,4249),(56946,4249),(56947,4249),(56948,4249),(56949,4250),(56950,4250),(56951,4250),(56952,4250),(56953,4250),(56954,4250),(56955,4251),(56956,4251),(56957,4251),(56958,4251),(56959,4251),(56960,4251),(56961,4252),(56962,4252),(56963,4252),(56964,4252),(56965,4252),(56966,4252),(56967,4253),(56968,4253),(56969,4253),(56970,4253),(56971,4253),(56972,4253),(56973,4254),(56974,4254),(56975,4254),(56976,4254),(56977,4254),(56978,4254),(56979,4255),(56980,4255),(56981,4255),(56982,4255),(56983,4255),(56984,4255),(56985,4256),(56986,4256),(56987,4256),(56988,4256),(56989,4256),(56990,4256),(56991,4257),(56992,4257),(56993,4257),(56994,4257),(56995,4257),(56996,4257),(56997,4258),(56998,4258),(56999,4258),(57000,4258),(57001,4258),(57002,4258),(57003,4259),(57004,4259),(57005,4259),(57006,4259),(57007,4259),(57008,4259),(57009,4260),(57010,4260),(57011,4260),(57012,4260),(57013,4260),(57014,4260),(57015,4261),(57016,4261),(57017,4261),(57018,4261),(57019,4261),(57020,4261),(57021,4262),(57022,4262),(57023,4262),(57024,4262),(57025,4262),(57026,4262),(57027,4263),(57028,4263),(57029,4263),(57030,4263),(57031,4263),(57032,4263),(57033,4264),(57034,4264),(57035,4264),(57036,4264),(57037,4264),(57038,4264),(57039,4265),(57040,4265),(57041,4265),(57042,4265),(57043,4265),(57044,4265),(57045,4266),(57046,4266),(57047,4266),(57048,4266),(57049,4266),(57050,4266),(57051,4267),(57052,4267),(57053,4267),(57054,4267),(57055,4267),(57056,4267),(57057,4268),(57058,4268),(57059,4268),(57060,4268),(57061,4268),(57062,4268),(57063,4269),(57064,4269),(57065,4269),(57066,4269),(57067,4269),(57068,4269),(57069,4270),(57070,4270),(57071,4270),(57072,4270),(57073,4270),(57074,4270),(57075,4271),(57076,4271),(57077,4271),(57078,4271),(57079,4271),(57080,4271),(57081,4272),(57082,4272),(57083,4272),(57084,4272),(57085,4272),(57086,4272),(57087,4273),(57088,4273),(57089,4273),(57090,4273),(57091,4273),(57092,4273),(57093,4274),(57094,4274),(57095,4274),(57096,4274),(57097,4274),(57098,4274),(57099,4275),(57100,4275),(57101,4275),(57102,4275),(57103,4275),(57104,4275),(57105,4276),(57106,4276),(57107,4276),(57108,4276),(57109,4276),(57110,4276),(57111,4277),(57112,4277),(57113,4277),(57114,4277),(57115,4277),(57116,4277),(57117,4278),(57118,4278),(57119,4278),(57120,4278),(57121,4278),(57122,4278),(57123,4279),(57124,4279),(57125,4279),(57126,4279),(57127,4279),(57128,4279),(57129,4280),(57130,4280),(57131,4280),(57132,4280),(57133,4280),(57134,4280),(57135,4281),(57136,4281),(57137,4281),(57138,4281),(57139,4281),(57140,4281),(57141,4282),(57142,4282),(57143,4282),(57144,4282),(57145,4282),(57146,4282),(57147,4283),(57148,4283),(57149,4283),(57150,4283),(57151,4283),(57152,4283),(57153,4284),(57154,4284),(57155,4284),(57156,4284),(57157,4284),(57158,4284),(57159,4285),(57160,4285),(57161,4285),(57162,4285),(57163,4285),(57164,4285),(57165,4286),(57166,4286),(57167,4286),(57168,4286),(57169,4286),(57170,4286),(57171,4287),(57172,4287),(57173,4287),(57174,4287),(57175,4287),(57176,4287),(57177,4288),(57178,4288),(57179,4288),(57180,4288),(57181,4288),(57182,4288),(57183,4289),(57184,4289),(57185,4289),(57186,4289),(57187,4289),(57188,4289),(57189,4290),(57190,4290),(57191,4290),(57192,4290),(57193,4290),(57194,4290),(57195,4291),(57196,4291),(57197,4291),(57198,4291),(57199,4291),(57200,4291),(57201,4292),(57202,4292),(57203,4292),(57204,4292),(57205,4292),(57206,4292),(57207,4293),(57208,4293),(57209,4293),(57210,4293),(57211,4293),(57212,4293),(57213,4294),(57214,4294),(57215,4294),(57216,4294),(57217,4294),(57218,4294),(57219,4295),(57220,4295),(57221,4295),(57222,4295),(57223,4295),(57224,4295),(57225,4296),(57226,4296),(57227,4296),(57228,4296),(57229,4296),(57230,4296),(57231,4297),(57232,4297),(57233,4297),(57234,4297),(57235,4297),(57236,4297),(57237,4298),(57238,4298),(57239,4298),(57240,4298),(57241,4298),(57242,4298),(57243,4299),(57244,4299),(57245,4299),(57246,4299),(57247,4299),(57248,4299),(57249,4300),(57250,4300),(57251,4300),(57252,4300),(57253,4300),(57254,4300),(57255,4301),(57256,4301),(57257,4301),(57258,4301),(57259,4301),(57260,4301),(57261,4302),(57262,4302),(57263,4302),(57264,4302),(57265,4302),(57266,4302),(57267,4303),(57268,4303),(57269,4303),(57270,4303),(57271,4303),(57272,4303),(57273,4304),(57274,4304),(57275,4304),(57276,4304),(57277,4304),(57278,4304),(57279,4305),(57280,4305),(57281,4305),(57282,4305),(57283,4305),(57284,4305),(57285,4306),(57286,4306),(57287,4306),(57288,4306),(57289,4306),(57290,4306),(57291,4307),(57292,4307),(57293,4307),(57294,4307),(57295,4307),(57296,4307),(57297,4308),(57298,4308),(57299,4308),(57300,4308),(57301,4308),(57302,4308),(57303,4309),(57304,4309),(57305,4309),(57306,4309),(57307,4309),(57308,4309),(57309,4310),(57310,4310),(57311,4310),(57312,4310),(57313,4310),(57314,4310),(57315,4311),(57316,4311),(57317,4311),(57318,4311),(57319,4311),(57320,4311),(57321,4312),(57322,4312),(57323,4312),(57324,4312),(57325,4312),(57326,4312),(57327,4313),(57328,4313),(57329,4313),(57330,4313),(57331,4313),(57332,4313),(57333,4214),(57334,4214),(57335,4215),(57336,4215),(57337,4215),(57338,4216),(57339,4216),(57340,4216),(57341,4217),(57342,4217),(57343,4217),(57344,4218),(57345,4218),(57346,4218),(57347,4219),(57348,4219),(57349,4219),(57350,4220),(57351,4220),(57352,4220),(57353,4221),(57354,4221),(57355,4221),(57356,4222),(57357,4222),(57358,4222),(57359,4223),(57360,4223),(57361,4223),(57362,4224),(57363,4224),(57364,4224),(57365,4225),(57366,4225),(57367,4225),(57368,4226),(57369,4226),(57370,4226),(57371,4227),(57372,4227),(57373,4227),(57374,4228),(57375,4228),(57376,4228),(57377,4229),(57378,4229),(57379,4229),(57380,4230),(57381,4230),(57382,4230),(57383,4231),(57384,4231),(57385,4231),(57386,4232),(57387,4232),(57388,4232),(57389,4233),(57390,4233),(57391,4233),(57392,4234),(57393,4234),(57394,4234),(57395,4235),(57396,4235),(57397,4235),(57398,4236),(57399,4236),(57400,4236),(57401,4237),(57402,4237),(57403,4237),(57404,4238),(57405,4238),(57406,4238),(57407,4239),(57408,4239),(57409,4239),(57410,4240),(57411,4240),(57412,4240),(57413,4241),(57414,4241),(57415,4241),(57416,4242),(57417,4242),(57418,4242),(57419,4243),(57420,4243),(57421,4243),(57422,4244),(57423,4244),(57424,4244),(57425,4245),(57426,4245),(57427,4245),(57428,4246),(57429,4246),(57430,4246),(57431,4247),(57432,4247),(57433,4247),(57434,4248),(57435,4248),(57436,4248),(57437,4249),(57438,4249),(57439,4249),(57440,4250),(57441,4250),(57442,4250),(57443,4251),(57444,4251),(57445,4251),(57446,4252),(57447,4252),(57448,4252),(57449,4253),(57450,4253),(57451,4253),(57452,4254),(57453,4254),(57454,4254),(57455,4255),(57456,4255),(57457,4255),(57458,4256),(57459,4256),(57460,4256),(57461,4257),(57462,4257),(57463,4257),(57464,4258),(57465,4258),(57466,4258),(57467,4259),(57468,4259),(57469,4259),(57470,4260),(57471,4260),(57472,4260),(57473,4261),(57474,4261),(57475,4261),(57476,4262),(57477,4262),(57478,4262),(57479,4263),(57480,4263),(57481,4263),(57482,4264),(57483,4264),(57484,4264),(57485,4265),(57486,4265),(57487,4265),(57488,4266),(57489,4266),(57490,4266),(57491,4267),(57492,4267),(57493,4267),(57494,4268),(57495,4268),(57496,4268),(57497,4269),(57498,4269),(57499,4269),(57500,4270),(57501,4270),(57502,4270),(57503,4271),(57504,4271),(57505,4272),(57506,4272),(57507,4273),(57508,4273),(57509,4274),(57510,4274),(57511,4274),(57512,4275),(57513,4275),(57514,4275),(57515,4276),(57516,4276),(57517,4276),(57518,4277),(57519,4277),(57520,4277),(57521,4278),(57522,4278),(57523,4278),(57524,4279),(57525,4279),(57526,4279),(57527,4280),(57528,4280),(57529,4280),(57530,4281),(57531,4281),(57532,4281),(57533,4282),(57534,4282),(57535,4282),(57536,4283),(57537,4283),(57538,4283),(57539,4284),(57540,4284),(57541,4284),(57542,4285),(57543,4285),(57544,4285),(57545,4286),(57546,4286),(57547,4286),(57548,4287),(57549,4287),(57550,4287),(57551,4288),(57552,4288),(57553,4288),(57554,4289),(57555,4289),(57556,4289),(57557,4290),(57558,4290),(57559,4290),(57560,4291),(57561,4291),(57562,4291),(57563,4292),(57564,4292),(57565,4292),(57566,4293),(57567,4293),(57568,4293),(57569,4294),(57570,4294),(57571,4294),(57572,4295),(57573,4295),(57574,4295),(57575,4296),(57576,4296),(57577,4296),(57578,4297),(57579,4297),(57580,4297),(57581,4298),(57582,4298),(57583,4298),(57584,4299),(57585,4299),(57586,4299),(57587,4300),(57588,4300),(57589,4300),(57590,4301),(57591,4301),(57592,4301),(57593,4302),(57594,4302),(57595,4302),(57596,4303),(57597,4303),(57598,4303),(57599,4304),(57600,4304),(57601,4304),(57602,4305),(57603,4305),(57604,4305),(57605,4306),(57606,4306),(57607,4307),(57608,4307),(57609,4307),(57610,4308),(57611,4308),(57612,4308),(57613,4309),(57614,4309),(57615,4309),(57616,4310),(57617,4310),(57618,4310),(57619,4311),(57620,4311),(57621,4311),(57622,4312),(57623,4312),(57624,4312),(57625,4313),(57626,4313),(57627,4214),(57628,4214),(57629,4214),(57630,4214),(57631,4215),(57632,4215),(57633,4215),(57634,4215),(57635,4216),(57636,4216),(57637,4216),(57638,4216),(57639,4217),(57640,4217),(57641,4217),(57642,4217),(57643,4218),(57644,4218),(57645,4218),(57646,4218),(57647,4219),(57648,4219),(57649,4219),(57650,4219),(57651,4220),(57652,4220),(57653,4220),(57654,4220),(57655,4221),(57656,4221),(57657,4221),(57658,4221),(57659,4222),(57660,4222),(57661,4222),(57662,4222),(57663,4223),(57664,4223),(57665,4223),(57666,4223),(57667,4224),(57668,4224),(57669,4224),(57670,4224),(57671,4225),(57672,4225),(57673,4225),(57674,4225),(57675,4226),(57676,4226),(57677,4226),(57678,4226),(57679,4227),(57680,4227),(57681,4227),(57682,4227),(57683,4228),(57684,4228),(57685,4228),(57686,4228),(57687,4229),(57688,4229),(57689,4229),(57690,4229),(57691,4230),(57692,4230),(57693,4230),(57694,4230),(57695,4231),(57696,4231),(57697,4231),(57698,4231),(57699,4232),(57700,4232),(57701,4232),(57702,4232),(57703,4233),(57704,4233),(57705,4233),(57706,4233),(57707,4234),(57708,4234),(57709,4234),(57710,4234),(57711,4235),(57712,4235),(57713,4235),(57714,4235),(57715,4236),(57716,4236),(57717,4236),(57718,4236),(57719,4237),(57720,4237),(57721,4237),(57722,4237),(57723,4238),(57724,4238),(57725,4238),(57726,4238),(57727,4239),(57728,4239),(57729,4239),(57730,4239),(57731,4240),(57732,4240),(57733,4240),(57734,4240),(57735,4241),(57736,4241),(57737,4241),(57738,4241),(57739,4242),(57740,4242),(57741,4242),(57742,4242),(57743,4243),(57744,4243),(57745,4243),(57746,4243),(57747,4244),(57748,4244),(57749,4244),(57750,4244),(57751,4245),(57752,4245),(57753,4245),(57754,4245),(57755,4246),(57756,4246),(57757,4246),(57758,4246),(57759,4247),(57760,4247),(57761,4247),(57762,4247),(57763,4248),(57764,4248),(57765,4248),(57766,4248),(57767,4249),(57768,4249),(57769,4249),(57770,4249),(57771,4250),(57772,4250),(57773,4250),(57774,4250),(57775,4251),(57776,4251),(57777,4251),(57778,4251),(57779,4252),(57780,4252),(57781,4252),(57782,4252),(57783,4253),(57784,4253),(57785,4253),(57786,4253),(57787,4254),(57788,4254),(57789,4254),(57790,4254),(57791,4255),(57792,4255),(57793,4255),(57794,4255),(57795,4256),(57796,4256),(57797,4256),(57798,4256),(57799,4257),(57800,4257),(57801,4257),(57802,4257),(57803,4258),(57804,4258),(57805,4258),(57806,4258),(57807,4259),(57808,4259),(57809,4259),(57810,4259),(57811,4260),(57812,4260),(57813,4260),(57814,4260),(57815,4261),(57816,4261),(57817,4261),(57818,4261),(57819,4262),(57820,4262),(57821,4262),(57822,4262),(57823,4263),(57824,4263),(57825,4263),(57826,4263),(57827,4264),(57828,4264),(57829,4264),(57830,4264),(57831,4265),(57832,4265),(57833,4265),(57834,4265),(57835,4266),(57836,4266),(57837,4266),(57838,4266),(57839,4267),(57840,4267),(57841,4267),(57842,4267),(57843,4268),(57844,4268),(57845,4268),(57846,4268),(57847,4269),(57848,4269),(57849,4269),(57850,4269),(57851,4270),(57852,4270),(57853,4270),(57854,4270),(57855,4271),(57856,4271),(57857,4271),(57858,4271),(57859,4272),(57860,4272),(57861,4272),(57862,4272),(57863,4273),(57864,4273),(57865,4273),(57866,4273),(57867,4274),(57868,4274),(57869,4274),(57870,4274),(57871,4275),(57872,4275),(57873,4275),(57874,4275),(57875,4276),(57876,4276),(57877,4276),(57878,4276),(57879,4277),(57880,4277),(57881,4277),(57882,4277),(57883,4278),(57884,4278),(57885,4278),(57886,4278),(57887,4279),(57888,4279),(57889,4279),(57890,4279),(57891,4280),(57892,4280),(57893,4280),(57894,4280),(57895,4281),(57896,4281),(57897,4281),(57898,4281),(57899,4282),(57900,4282),(57901,4282),(57902,4282),(57903,4283),(57904,4283),(57905,4283),(57906,4283),(57907,4284),(57908,4284),(57909,4284),(57910,4284),(57911,4285),(57912,4285),(57913,4285),(57914,4285),(57915,4286),(57916,4286),(57917,4286),(57918,4286),(57919,4287),(57920,4287),(57921,4287),(57922,4287),(57923,4288),(57924,4288),(57925,4288),(57926,4288),(57927,4289),(57928,4289),(57929,4289),(57930,4289),(57931,4290),(57932,4290),(57933,4290),(57934,4290),(57935,4291),(57936,4291),(57937,4291),(57938,4291),(57939,4292),(57940,4292),(57941,4292),(57942,4292),(57943,4293),(57944,4293),(57945,4293),(57946,4293),(57947,4294),(57948,4294),(57949,4294),(57950,4294),(57951,4295),(57952,4295),(57953,4295),(57954,4295),(57955,4296),(57956,4296),(57957,4296),(57958,4296),(57959,4297),(57960,4297),(57961,4297),(57962,4297),(57963,4298),(57964,4298),(57965,4298),(57966,4298),(57967,4299),(57968,4299),(57969,4299),(57970,4299),(57971,4300),(57972,4300),(57973,4300),(57974,4300),(57975,4301),(57976,4301),(57977,4301),(57978,4301),(57979,4302),(57980,4302),(57981,4302),(57982,4302),(57983,4303),(57984,4303),(57985,4303),(57986,4303),(57987,4304),(57988,4304),(57989,4304),(57990,4304),(57991,4305),(57992,4305),(57993,4305),(57994,4305),(57995,4306),(57996,4306),(57997,4306),(57998,4306),(57999,4307),(58000,4307),(58001,4307),(58002,4307),(58003,4308),(58004,4308),(58005,4308),(58006,4308),(58007,4309),(58008,4309),(58009,4309),(58010,4309),(58011,4310),(58012,4310),(58013,4310),(58014,4310),(58015,4311),(58016,4311),(58017,4311),(58018,4311),(58019,4312),(58020,4312),(58021,4312),(58022,4312),(58023,4313),(58024,4313),(58025,4313),(58026,4313),(58027,4314),(58028,4314),(58029,4314),(58030,4314),(58031,4314),(58032,4314),(58033,4315),(58034,4315),(58035,4315),(58036,4315),(58037,4315),(58038,4315),(58039,4316),(58040,4316),(58041,4316),(58042,4316),(58043,4316),(58044,4316),(58045,4317),(58046,4317),(58047,4317),(58048,4317),(58049,4317),(58050,4317),(58051,4318),(58052,4318),(58053,4318),(58054,4318),(58055,4318),(58056,4318),(58057,4319),(58058,4319),(58059,4319),(58060,4319),(58061,4319),(58062,4319),(58063,4320),(58064,4320),(58065,4320),(58066,4320),(58067,4320),(58068,4320),(58069,4321),(58070,4321),(58071,4321),(58072,4321),(58073,4321),(58074,4321),(58075,4322),(58076,4322),(58077,4322),(58078,4322),(58079,4322),(58080,4322),(58081,4323),(58082,4323),(58083,4323),(58084,4323),(58085,4323),(58086,4323),(58087,4324),(58088,4324),(58089,4324),(58090,4324),(58091,4324),(58092,4324),(58093,4325),(58094,4325),(58095,4325),(58096,4325),(58097,4325),(58098,4325),(58099,4326),(58100,4326),(58101,4326),(58102,4326),(58103,4326),(58104,4326),(58105,4327),(58106,4327),(58107,4327),(58108,4327),(58109,4327),(58110,4327),(58111,4328),(58112,4328),(58113,4328),(58114,4328),(58115,4328),(58116,4328),(58117,4329),(58118,4329),(58119,4329),(58120,4329),(58121,4329),(58122,4329),(58123,4330),(58124,4330),(58125,4330),(58126,4330),(58127,4330),(58128,4330),(58129,4331),(58130,4331),(58131,4331),(58132,4331),(58133,4331),(58134,4331),(58135,4332),(58136,4332),(58137,4332),(58138,4332),(58139,4332),(58140,4332),(58141,4333),(58142,4333),(58143,4333),(58144,4333),(58145,4333),(58146,4333),(58147,4334),(58148,4334),(58149,4334),(58150,4334),(58151,4334),(58152,4334),(58153,4335),(58154,4335),(58155,4335),(58156,4335),(58157,4335),(58158,4335),(58159,4336),(58160,4336),(58161,4336),(58162,4336),(58163,4336),(58164,4336),(58165,4337),(58166,4337),(58167,4337),(58168,4337),(58169,4337),(58170,4337),(58171,4338),(58172,4338),(58173,4338),(58174,4338),(58175,4338),(58176,4338),(58177,4339),(58178,4339),(58179,4339),(58180,4339),(58181,4339),(58182,4339),(58183,4340),(58184,4340),(58185,4340),(58186,4340),(58187,4340),(58188,4340),(58189,4341),(58190,4341),(58191,4341),(58192,4341),(58193,4341),(58194,4341),(58195,4342),(58196,4342),(58197,4342),(58198,4342),(58199,4342),(58200,4342),(58201,4343),(58202,4343),(58203,4343),(58204,4343),(58205,4343),(58206,4343),(58207,4344),(58208,4344),(58209,4344),(58210,4344),(58211,4344),(58212,4344),(58213,4345),(58214,4345),(58215,4345),(58216,4345),(58217,4345),(58218,4345),(58219,4346),(58220,4346),(58221,4346),(58222,4346),(58223,4346),(58224,4346),(58225,4347),(58226,4347),(58227,4347),(58228,4347),(58229,4347),(58230,4347),(58231,4348),(58232,4348),(58233,4348),(58234,4348),(58235,4348),(58236,4348),(58237,4349),(58238,4349),(58239,4349),(58240,4349),(58241,4349),(58242,4349),(58243,4350),(58244,4350),(58245,4350),(58246,4350),(58247,4350),(58248,4350),(58249,4351),(58250,4351),(58251,4351),(58252,4351),(58253,4351),(58254,4351),(58255,4352),(58256,4352),(58257,4352),(58258,4352),(58259,4352),(58260,4352),(58261,4353),(58262,4353),(58263,4353),(58264,4353),(58265,4353),(58266,4353),(58267,4354),(58268,4354),(58269,4354),(58270,4354),(58271,4354),(58272,4354),(58273,4355),(58274,4355),(58275,4355),(58276,4355),(58277,4355),(58278,4355),(58279,4356),(58280,4356),(58281,4356),(58282,4356),(58283,4356),(58284,4356),(58285,4357),(58286,4357),(58287,4357),(58288,4357),(58289,4357),(58290,4357),(58291,4358),(58292,4358),(58293,4358),(58294,4358),(58295,4358),(58296,4358),(58297,4359),(58298,4359),(58299,4359),(58300,4359),(58301,4359),(58302,4359),(58303,4360),(58304,4360),(58305,4360),(58306,4360),(58307,4360),(58308,4360),(58309,4361),(58310,4361),(58311,4361),(58312,4361),(58313,4361),(58314,4361),(58315,4362),(58316,4362),(58317,4362),(58318,4362),(58319,4362),(58320,4362),(58321,4363),(58322,4363),(58323,4363),(58324,4363),(58325,4363),(58326,4363),(58327,4364),(58328,4364),(58329,4364),(58330,4364),(58331,4364),(58332,4364),(58333,4365),(58334,4365),(58335,4365),(58336,4365),(58337,4365),(58338,4365),(58339,4366),(58340,4366),(58341,4366),(58342,4366),(58343,4366),(58344,4366),(58345,4367),(58346,4367),(58347,4367),(58348,4367),(58349,4367),(58350,4367),(58351,4368),(58352,4368),(58353,4368),(58354,4368),(58355,4368),(58356,4368),(58357,4369),(58358,4369),(58359,4369),(58360,4369),(58361,4369),(58362,4369),(58363,4370),(58364,4370),(58365,4370),(58366,4370),(58367,4370),(58368,4370),(58369,4371),(58370,4371),(58371,4371),(58372,4371),(58373,4371),(58374,4371),(58375,4372),(58376,4372),(58377,4372),(58378,4372),(58379,4372),(58380,4372),(58381,4373),(58382,4373),(58383,4373),(58384,4373),(58385,4373),(58386,4373),(58387,4374),(58388,4374),(58389,4374),(58390,4374),(58391,4374),(58392,4374),(58393,4375),(58394,4375),(58395,4375),(58396,4375),(58397,4375),(58398,4375),(58399,4376),(58400,4376),(58401,4376),(58402,4376),(58403,4376),(58404,4376),(58405,4377),(58406,4377),(58407,4377),(58408,4377),(58409,4377),(58410,4377),(58411,4378),(58412,4378),(58413,4378),(58414,4378),(58415,4378),(58416,4378),(58417,4379),(58418,4379),(58419,4379),(58420,4379),(58421,4379),(58422,4379),(58423,4380),(58424,4380),(58425,4380),(58426,4380),(58427,4380),(58428,4380),(58429,4381),(58430,4381),(58431,4381),(58432,4381),(58433,4381),(58434,4381),(58435,4382),(58436,4382),(58437,4382),(58438,4382),(58439,4382),(58440,4382),(58441,4383),(58442,4383),(58443,4383),(58444,4383),(58445,4383),(58446,4383),(58447,4384),(58448,4384),(58449,4384),(58450,4384),(58451,4384),(58452,4384),(58453,4385),(58454,4385),(58455,4385),(58456,4385),(58457,4385),(58458,4385),(58459,4386),(58460,4386),(58461,4386),(58462,4386),(58463,4386),(58464,4386),(58465,4387),(58466,4387),(58467,4387),(58468,4387),(58469,4387),(58470,4387),(58471,4388),(58472,4388),(58473,4388),(58474,4388),(58475,4388),(58476,4388),(58477,4389),(58478,4389),(58479,4389),(58480,4389),(58481,4389),(58482,4389),(58483,4390),(58484,4390),(58485,4390),(58486,4390),(58487,4390),(58488,4390),(58489,4391),(58490,4391),(58491,4391),(58492,4391),(58493,4391),(58494,4391),(58495,4392),(58496,4392),(58497,4392),(58498,4392),(58499,4392),(58500,4392),(58501,4393),(58502,4393),(58503,4393),(58504,4393),(58505,4393),(58506,4393),(58507,4394),(58508,4394),(58509,4394),(58510,4394),(58511,4394),(58512,4394),(58513,4395),(58514,4395),(58515,4395),(58516,4395),(58517,4395),(58518,4395),(58519,4396),(58520,4396),(58521,4396),(58522,4396),(58523,4396),(58524,4396),(58525,4397),(58526,4397),(58527,4397),(58528,4397),(58529,4397),(58530,4397),(58531,4398),(58532,4398),(58533,4398),(58534,4398),(58535,4398),(58536,4398),(58537,4399),(58538,4399),(58539,4399),(58540,4399),(58541,4399),(58542,4399),(58543,4400),(58544,4400),(58545,4400),(58546,4400),(58547,4400),(58548,4400),(58549,4401),(58550,4401),(58551,4401),(58552,4401),(58553,4401),(58554,4401),(58555,4402),(58556,4402),(58557,4402),(58558,4402),(58559,4402),(58560,4402),(58561,4403),(58562,4403),(58563,4403),(58564,4403),(58565,4403),(58566,4403),(58567,4404),(58568,4404),(58569,4404),(58570,4404),(58571,4404),(58572,4404),(58573,4405),(58574,4405),(58575,4405),(58576,4405),(58577,4405),(58578,4405),(58579,4406),(58580,4406),(58581,4406),(58582,4406),(58583,4406),(58584,4406),(58585,4407),(58586,4407),(58587,4407),(58588,4407),(58589,4407),(58590,4407),(58591,4408),(58592,4408),(58593,4408),(58594,4408),(58595,4408),(58596,4408),(58597,4409),(58598,4409),(58599,4409),(58600,4409),(58601,4409),(58602,4409),(58603,4410),(58604,4410),(58605,4410),(58606,4410),(58607,4410),(58608,4410),(58609,4411),(58610,4411),(58611,4411),(58612,4411),(58613,4411),(58614,4411),(58615,4412),(58616,4412),(58617,4412),(58618,4412),(58619,4412),(58620,4412),(58621,4413),(58622,4413),(58623,4413),(58624,4413),(58625,4413),(58626,4413),(58627,4314),(58628,4314),(58629,4315),(58630,4315),(58631,4315),(58632,4316),(58633,4316),(58634,4316),(58635,4317),(58636,4317),(58637,4317),(58638,4318),(58639,4318),(58640,4318),(58641,4319),(58642,4319),(58643,4319),(58644,4320),(58645,4320),(58646,4320),(58647,4321),(58648,4321),(58649,4321),(58650,4322),(58651,4322),(58652,4322),(58653,4323),(58654,4323),(58655,4323),(58656,4324),(58657,4324),(58658,4324),(58659,4325),(58660,4325),(58661,4325),(58662,4326),(58663,4326),(58664,4326),(58665,4327),(58666,4327),(58667,4327),(58668,4328),(58669,4328),(58670,4328),(58671,4329),(58672,4329),(58673,4329),(58674,4330),(58675,4330),(58676,4330),(58677,4331),(58678,4331),(58679,4331),(58680,4332),(58681,4332),(58682,4332),(58683,4333),(58684,4333),(58685,4333),(58686,4334),(58687,4334),(58688,4334),(58689,4335),(58690,4335),(58691,4335),(58692,4336),(58693,4336),(58694,4336),(58695,4337),(58696,4337),(58697,4337),(58698,4338),(58699,4338),(58700,4338),(58701,4339),(58702,4339),(58703,4339),(58704,4340),(58705,4340),(58706,4340),(58707,4341),(58708,4341),(58709,4342),(58710,4342),(58711,4342),(58712,4343),(58713,4343),(58714,4343),(58715,4344),(58716,4344),(58717,4344),(58718,4345),(58719,4345),(58720,4345),(58721,4346),(58722,4346),(58723,4346),(58724,4347),(58725,4347),(58726,4347),(58727,4348),(58728,4348),(58729,4348),(58730,4349),(58731,4349),(58732,4349),(58733,4350),(58734,4350),(58735,4350),(58736,4351),(58737,4351),(58738,4351),(58739,4352),(58740,4352),(58741,4352),(58742,4353),(58743,4353),(58744,4353),(58745,4354),(58746,4354),(58747,4354),(58748,4355),(58749,4355),(58750,4355),(58751,4356),(58752,4356),(58753,4356),(58754,4357),(58755,4357),(58756,4357),(58757,4358),(58758,4358),(58759,4359),(58760,4359),(58761,4359),(58762,4360),(58763,4360),(58764,4360),(58765,4361),(58766,4361),(58767,4361),(58768,4362),(58769,4362),(58770,4362),(58771,4363),(58772,4363),(58773,4363),(58774,4364),(58775,4364),(58776,4364),(58777,4365),(58778,4365),(58779,4365),(58780,4366),(58781,4366),(58782,4366),(58783,4367),(58784,4367),(58785,4367),(58786,4368),(58787,4368),(58788,4368),(58789,4369),(58790,4369),(58791,4369),(58792,4370),(58793,4370),(58794,4370),(58795,4371),(58796,4371),(58797,4371),(58798,4372),(58799,4372),(58800,4372),(58801,4373),(58802,4373),(58803,4373),(58804,4374),(58805,4374),(58806,4374),(58807,4375),(58808,4375),(58809,4375),(58810,4376),(58811,4376),(58812,4376),(58813,4377),(58814,4377),(58815,4377),(58816,4378),(58817,4378),(58818,4378),(58819,4379),(58820,4379),(58821,4379),(58822,4380),(58823,4380),(58824,4380),(58825,4381),(58826,4381),(58827,4381),(58828,4382),(58829,4382),(58830,4382),(58831,4383),(58832,4383),(58833,4383),(58834,4384),(58835,4384),(58836,4384),(58837,4385),(58838,4385),(58839,4385),(58840,4386),(58841,4386),(58842,4386),(58843,4387),(58844,4387),(58845,4387),(58846,4388),(58847,4388),(58848,4388),(58849,4389),(58850,4389),(58851,4389),(58852,4390),(58853,4390),(58854,4390),(58855,4391),(58856,4391),(58857,4391),(58858,4392),(58859,4392),(58860,4392),(58861,4393),(58862,4393),(58863,4393),(58864,4394),(58865,4394),(58866,4394),(58867,4395),(58868,4395),(58869,4395),(58870,4396),(58871,4396),(58872,4396),(58873,4397),(58874,4397),(58875,4397),(58876,4398),(58877,4398),(58878,4398),(58879,4399),(58880,4399),(58881,4399),(58882,4400),(58883,4400),(58884,4400),(58885,4401),(58886,4401),(58887,4401),(58888,4402),(58889,4402),(58890,4402),(58891,4403),(58892,4403),(58893,4403),(58894,4404),(58895,4404),(58896,4404),(58897,4405),(58898,4405),(58899,4405),(58900,4406),(58901,4406),(58902,4406),(58903,4407),(58904,4407),(58905,4407),(58906,4408),(58907,4408),(58908,4408),(58909,4409),(58910,4409),(58911,4409),(58912,4410),(58913,4410),(58914,4410),(58915,4411),(58916,4411),(58917,4411),(58918,4412),(58919,4412),(58920,4412),(58921,4413),(58922,4413),(58923,4413),(58924,4314),(58925,4314),(58926,4314),(58927,4314),(58928,4315),(58929,4315),(58930,4315),(58931,4315),(58932,4316),(58933,4316),(58934,4316),(58935,4316),(58936,4317),(58937,4317),(58938,4317),(58939,4317),(58940,4318),(58941,4318),(58942,4318),(58943,4318),(58944,4319),(58945,4319),(58946,4319),(58947,4319),(58948,4320),(58949,4320),(58950,4320),(58951,4320),(58952,4321),(58953,4321),(58954,4321),(58955,4321),(58956,4322),(58957,4322),(58958,4322),(58959,4322),(58960,4323),(58961,4323),(58962,4323),(58963,4323),(58964,4324),(58965,4324),(58966,4324),(58967,4324),(58968,4325),(58969,4325),(58970,4325),(58971,4325),(58972,4326),(58973,4326),(58974,4326),(58975,4326),(58976,4327),(58977,4327),(58978,4327),(58979,4327),(58980,4328),(58981,4328),(58982,4328),(58983,4328),(58984,4329),(58985,4329),(58986,4329),(58987,4329),(58988,4330),(58989,4330),(58990,4330),(58991,4330),(58992,4331),(58993,4331),(58994,4331),(58995,4331),(58996,4332),(58997,4332),(58998,4332),(58999,4332),(59000,4333),(59001,4333),(59002,4333),(59003,4333),(59004,4334),(59005,4334),(59006,4334),(59007,4334),(59008,4335),(59009,4335),(59010,4335),(59011,4335),(59012,4336),(59013,4336),(59014,4336),(59015,4336),(59016,4337),(59017,4337),(59018,4337),(59019,4337),(59020,4338),(59021,4338),(59022,4338),(59023,4338),(59024,4339),(59025,4339),(59026,4339),(59027,4339),(59028,4340),(59029,4340),(59030,4340),(59031,4340),(59032,4341),(59033,4341),(59034,4341),(59035,4341),(59036,4342),(59037,4342),(59038,4342),(59039,4342),(59040,4343),(59041,4343),(59042,4343),(59043,4343),(59044,4344),(59045,4344),(59046,4344),(59047,4344),(59048,4345),(59049,4345),(59050,4345),(59051,4345),(59052,4346),(59053,4346),(59054,4346),(59055,4346),(59056,4347),(59057,4347),(59058,4347),(59059,4347),(59060,4348),(59061,4348),(59062,4348),(59063,4348),(59064,4349),(59065,4349),(59066,4349),(59067,4349),(59068,4350),(59069,4350),(59070,4350),(59071,4350),(59072,4351),(59073,4351),(59074,4351),(59075,4351),(59076,4352),(59077,4352),(59078,4352),(59079,4352),(59080,4353),(59081,4353),(59082,4353),(59083,4353),(59084,4354),(59085,4354),(59086,4354),(59087,4354),(59088,4355),(59089,4355),(59090,4355),(59091,4355),(59092,4356),(59093,4356),(59094,4356),(59095,4356),(59096,4357),(59097,4357),(59098,4357),(59099,4357),(59100,4358),(59101,4358),(59102,4358),(59103,4358),(59104,4359),(59105,4359),(59106,4359),(59107,4359),(59108,4360),(59109,4360),(59110,4360),(59111,4360),(59112,4361),(59113,4361),(59114,4361),(59115,4361),(59116,4362),(59117,4362),(59118,4362),(59119,4362),(59120,4363),(59121,4363),(59122,4363),(59123,4363),(59124,4364),(59125,4364),(59126,4364),(59127,4364),(59128,4365),(59129,4365),(59130,4365),(59131,4365),(59132,4366),(59133,4366),(59134,4366),(59135,4366),(59136,4367),(59137,4367),(59138,4367),(59139,4367),(59140,4368),(59141,4368),(59142,4368),(59143,4368),(59144,4369),(59145,4369),(59146,4369),(59147,4369),(59148,4370),(59149,4370),(59150,4370),(59151,4370),(59152,4371),(59153,4371),(59154,4371),(59155,4371),(59156,4372),(59157,4372),(59158,4372),(59159,4372),(59160,4373),(59161,4373),(59162,4373),(59163,4373),(59164,4374),(59165,4374),(59166,4374),(59167,4374),(59168,4375),(59169,4375),(59170,4375),(59171,4375),(59172,4376),(59173,4376),(59174,4376),(59175,4376),(59176,4377),(59177,4377),(59178,4377),(59179,4377),(59180,4378),(59181,4378),(59182,4378),(59183,4378),(59184,4379),(59185,4379),(59186,4379),(59187,4379),(59188,4380),(59189,4380),(59190,4380),(59191,4380),(59192,4381),(59193,4381),(59194,4381),(59195,4381),(59196,4382),(59197,4382),(59198,4382),(59199,4382),(59200,4383),(59201,4383),(59202,4383),(59203,4383),(59204,4384),(59205,4384),(59206,4384),(59207,4384),(59208,4385),(59209,4385),(59210,4385),(59211,4385),(59212,4386),(59213,4386),(59214,4386),(59215,4386),(59216,4387),(59217,4387),(59218,4387),(59219,4387),(59220,4388),(59221,4388),(59222,4388),(59223,4388),(59224,4389),(59225,4389),(59226,4389),(59227,4389),(59228,4390),(59229,4390),(59230,4390),(59231,4390),(59232,4391),(59233,4391),(59234,4391),(59235,4391),(59236,4392),(59237,4392),(59238,4392),(59239,4392),(59240,4393),(59241,4393),(59242,4393),(59243,4393),(59244,4394),(59245,4394),(59246,4394),(59247,4394),(59248,4395),(59249,4395),(59250,4395),(59251,4395),(59252,4396),(59253,4396),(59254,4396),(59255,4396),(59256,4397),(59257,4397),(59258,4397),(59259,4397),(59260,4398),(59261,4398),(59262,4398),(59263,4398),(59264,4399),(59265,4399),(59266,4399),(59267,4399),(59268,4400),(59269,4400),(59270,4400),(59271,4400),(59272,4401),(59273,4401),(59274,4401),(59275,4401),(59276,4402),(59277,4402),(59278,4402),(59279,4402),(59280,4403),(59281,4403),(59282,4403),(59283,4403),(59284,4404),(59285,4404),(59286,4404),(59287,4404),(59288,4405),(59289,4405),(59290,4405),(59291,4405),(59292,4406),(59293,4406),(59294,4406),(59295,4406),(59296,4407),(59297,4407),(59298,4407),(59299,4407),(59300,4408),(59301,4408),(59302,4408),(59303,4408),(59304,4409),(59305,4409),(59306,4409),(59307,4409),(59308,4410),(59309,4410),(59310,4410),(59311,4410),(59312,4411),(59313,4411),(59314,4411),(59315,4411),(59316,4412),(59317,4412),(59318,4412),(59319,4412),(59320,4413),(59321,4413),(59322,4413),(59323,4413),(59324,4414),(59325,4414),(59326,4414),(59327,4414),(59328,4414),(59329,4414),(59330,4415),(59331,4415),(59332,4415),(59333,4415),(59334,4415),(59335,4415),(59336,4416),(59337,4416),(59338,4416),(59339,4416),(59340,4416),(59341,4416),(59342,4417),(59343,4417),(59344,4417),(59345,4417),(59346,4417),(59347,4417),(59348,4418),(59349,4418),(59350,4418),(59351,4418),(59352,4418),(59353,4418),(59354,4419),(59355,4419),(59356,4419),(59357,4419),(59358,4419),(59359,4419),(59360,4420),(59361,4420),(59362,4420),(59363,4420),(59364,4420),(59365,4420),(59366,4421),(59367,4421),(59368,4421),(59369,4421),(59370,4421),(59371,4421),(59372,4422),(59373,4422),(59374,4422),(59375,4422),(59376,4422),(59377,4422),(59378,4423),(59379,4423),(59380,4423),(59381,4423),(59382,4423),(59383,4423),(59384,4424),(59385,4424),(59386,4424),(59387,4424),(59388,4424),(59389,4424),(59390,4425),(59391,4425),(59392,4425),(59393,4425),(59394,4425),(59395,4425),(59396,4426),(59397,4426),(59398,4426),(59399,4426),(59400,4426),(59401,4426),(59402,4427),(59403,4427),(59404,4427),(59405,4427),(59406,4427),(59407,4427),(59408,4428),(59409,4428),(59410,4428),(59411,4428),(59412,4428),(59413,4428),(59414,4429),(59415,4429),(59416,4429),(59417,4429),(59418,4429),(59419,4429),(59420,4430),(59421,4430),(59422,4430),(59423,4430),(59424,4430),(59425,4430),(59426,4431),(59427,4431),(59428,4431),(59429,4431),(59430,4431),(59431,4431),(59432,4432),(59433,4432),(59434,4432),(59435,4432),(59436,4433),(59437,4433),(59438,4433),(59439,4433),(59440,4434),(59441,4434),(59442,4434),(59443,4434),(59444,4434),(59445,4434),(59446,4435),(59447,4435),(59448,4435),(59449,4435),(59450,4435),(59451,4435),(59452,4436),(59453,4436),(59454,4436),(59455,4436),(59456,4436),(59457,4436),(59458,4437),(59459,4437),(59460,4437),(59461,4437),(59462,4437),(59463,4437),(59464,4438),(59465,4438),(59466,4438),(59467,4438),(59468,4438),(59469,4438),(59470,4439),(59471,4439),(59472,4439),(59473,4439),(59474,4439),(59475,4439),(59476,4440),(59477,4440),(59478,4440),(59479,4440),(59480,4440),(59481,4440),(59482,4441),(59483,4441),(59484,4441),(59485,4441),(59486,4441),(59487,4441),(59488,4442),(59489,4442),(59490,4442),(59491,4442),(59492,4442),(59493,4442),(59494,4443),(59495,4443),(59496,4443),(59497,4443),(59498,4443),(59499,4443),(59500,4444),(59501,4444),(59502,4444),(59503,4444),(59504,4444),(59505,4444),(59506,4445),(59507,4445),(59508,4445),(59509,4445),(59510,4445),(59511,4445),(59512,4446),(59513,4446),(59514,4446),(59515,4446),(59516,4446),(59517,4446),(59518,4447),(59519,4447),(59520,4447),(59521,4447),(59522,4447),(59523,4447),(59524,4448),(59525,4448),(59526,4448),(59527,4448),(59528,4448),(59529,4448),(59530,4449),(59531,4449),(59532,4449),(59533,4449),(59534,4449),(59535,4449),(59536,4450),(59537,4450),(59538,4450),(59539,4450),(59540,4450),(59541,4450),(59542,4451),(59543,4451),(59544,4451),(59545,4451),(59546,4451),(59547,4451),(59548,4452),(59549,4452),(59550,4452),(59551,4452),(59552,4452),(59553,4452),(59554,4453),(59555,4453),(59556,4453),(59557,4453),(59558,4453),(59559,4453),(59560,4454),(59561,4454),(59562,4454),(59563,4454),(59564,4454),(59565,4454),(59566,4455),(59567,4455),(59568,4455),(59569,4455),(59570,4455),(59571,4455),(59572,4456),(59573,4456),(59574,4456),(59575,4456),(59576,4456),(59577,4456),(59578,4457),(59579,4457),(59580,4457),(59581,4457),(59582,4457),(59583,4457),(59584,4458),(59585,4458),(59586,4458),(59587,4458),(59588,4458),(59589,4458),(59590,4459),(59591,4459),(59592,4459),(59593,4459),(59594,4459),(59595,4459),(59596,4460),(59597,4460),(59598,4460),(59599,4460),(59600,4460),(59601,4460),(59602,4461),(59603,4461),(59604,4461),(59605,4461),(59606,4461),(59607,4461),(59608,4462),(59609,4462),(59610,4462),(59611,4462),(59612,4462),(59613,4462),(59614,4463),(59615,4463),(59616,4463),(59617,4463),(59618,4463),(59619,4463),(59620,4464),(59621,4464),(59622,4464),(59623,4464),(59624,4464),(59625,4464),(59626,4465),(59627,4465),(59628,4465),(59629,4465),(59630,4465),(59631,4465),(59632,4466),(59633,4466),(59634,4466),(59635,4466),(59636,4466),(59637,4466),(59638,4467),(59639,4467),(59640,4467),(59641,4467),(59642,4467),(59643,4467),(59644,4468),(59645,4468),(59646,4468),(59647,4468),(59648,4468),(59649,4468),(59650,4469),(59651,4469),(59652,4469),(59653,4469),(59654,4469),(59655,4469),(59656,4470),(59657,4470),(59658,4470),(59659,4470),(59660,4470),(59661,4470),(59662,4471),(59663,4471),(59664,4471),(59665,4471),(59666,4471),(59667,4471),(59668,4472),(59669,4472),(59670,4472),(59671,4472),(59672,4472),(59673,4472),(59674,4473),(59675,4473),(59676,4473),(59677,4473),(59678,4473),(59679,4473),(59680,4474),(59681,4474),(59682,4474),(59683,4474),(59684,4474),(59685,4474),(59686,4475),(59687,4475),(59688,4475),(59689,4475),(59690,4475),(59691,4475),(59692,4476),(59693,4476),(59694,4476),(59695,4476),(59696,4476),(59697,4476),(59698,4477),(59699,4477),(59700,4477),(59701,4477),(59702,4477),(59703,4477),(59704,4478),(59705,4478),(59706,4478),(59707,4478),(59708,4478),(59709,4478),(59710,4479),(59711,4479),(59712,4479),(59713,4479),(59714,4479),(59715,4479),(59716,4480),(59717,4480),(59718,4480),(59719,4480),(59720,4480),(59721,4481),(59722,4481),(59723,4481),(59724,4481),(59725,4481),(59726,4481),(59727,4482),(59728,4482),(59729,4482),(59730,4482),(59731,4482),(59732,4482),(59733,4483),(59734,4483),(59735,4483),(59736,4483),(59737,4483),(59738,4483),(59739,4484),(59740,4484),(59741,4484),(59742,4484),(59743,4484),(59744,4484),(59745,4485),(59746,4485),(59747,4485),(59748,4485),(59749,4485),(59750,4485),(59751,4486),(59752,4486),(59753,4486),(59754,4486),(59755,4486),(59756,4486),(59757,4487),(59758,4487),(59759,4487),(59760,4487),(59761,4487),(59762,4487),(59763,4488),(59764,4488),(59765,4488),(59766,4488),(59767,4488),(59768,4488),(59769,4489),(59770,4489),(59771,4489),(59772,4489),(59773,4489),(59774,4489),(59775,4490),(59776,4490),(59777,4490),(59778,4490),(59779,4490),(59780,4490),(59781,4414),(59782,4414),(59783,4414),(59784,4415),(59785,4415),(59786,4415),(59787,4416),(59788,4416),(59789,4417),(59790,4417),(59791,4417),(59792,4418),(59793,4418),(59794,4418),(59795,4419),(59796,4419),(59797,4419),(59798,4420),(59799,4420),(59800,4420),(59801,4421),(59802,4421),(59803,4421),(59804,4422),(59805,4422),(59806,4422),(59807,4423),(59808,4423),(59809,4423),(59810,4424),(59811,4424),(59812,4424),(59813,4425),(59814,4425),(59815,4425),(59816,4426),(59817,4426),(59818,4426),(59819,4427),(59820,4427),(59821,4427),(59822,4428),(59823,4428),(59824,4428),(59825,4429),(59826,4429),(59827,4429),(59828,4430),(59829,4430),(59830,4431),(59831,4431),(59832,4432),(59833,4432),(59834,4432),(59835,4433),(59836,4433),(59837,4433),(59838,4434),(59839,4434),(59840,4434),(59841,4435),(59842,4435),(59843,4435),(59844,4436),(59845,4436),(59846,4436),(59847,4437),(59848,4437),(59849,4437),(59850,4438),(59851,4438),(59852,4438),(59853,4439),(59854,4439),(59855,4439),(59856,4440),(59857,4440),(59858,4440),(59859,4441),(59860,4441),(59861,4441),(59862,4442),(59863,4442),(59864,4442),(59865,4443),(59866,4443),(59867,4443),(59868,4444),(59869,4444),(59870,4444),(59871,4445),(59872,4445),(59873,4445),(59874,4446),(59875,4446),(59876,4446),(59877,4447),(59878,4447),(59879,4447),(59880,4448),(59881,4448),(59882,4448),(59883,4449),(59884,4449),(59885,4449),(59886,4450),(59887,4450),(59888,4450),(59889,4451),(59890,4451),(59891,4451),(59892,4452),(59893,4452),(59894,4452),(59895,4453),(59896,4453),(59897,4453),(59898,4454),(59899,4454),(59900,4454),(59901,4455),(59902,4455),(59903,4455),(59904,4456),(59905,4456),(59906,4456),(59907,4457),(59908,4457),(59909,4458),(59910,4458),(59911,4458),(59912,4459),(59913,4459),(59914,4459),(59915,4460),(59916,4460),(59917,4460),(59918,4461),(59919,4461),(59920,4461),(59921,4462),(59922,4462),(59923,4462),(59924,4463),(59925,4463),(59926,4463),(59927,4464),(59928,4464),(59929,4464),(59930,4465),(59931,4465),(59932,4465),(59933,4466),(59934,4466),(59935,4466),(59936,4467),(59937,4467),(59938,4467),(59939,4468),(59940,4468),(59941,4468),(59942,4469),(59943,4469),(59944,4469),(59945,4470),(59946,4470),(59947,4470),(59948,4471),(59949,4471),(59950,4471),(59951,4472),(59952,4472),(59953,4472),(59954,4473),(59955,4473),(59956,4473),(59957,4474),(59958,4474),(59959,4474),(59960,4475),(59961,4475),(59962,4475),(59963,4476),(59964,4476),(59965,4476),(59966,4477),(59967,4477),(59968,4477),(59969,4478),(59970,4478),(59971,4478),(59972,4479),(59973,4479),(59974,4479),(59975,4480),(59976,4480),(59977,4480),(59978,4481),(59979,4481),(59980,4481),(59981,4482),(59982,4482),(59983,4482),(59984,4483),(59985,4483),(59986,4483),(59987,4484),(59988,4484),(59989,4484),(59990,4485),(59991,4485),(59992,4485),(59993,4486),(59994,4486),(59995,4486),(59996,4487),(59997,4487),(59998,4487),(59999,4488),(60000,4488),(60001,4488),(60002,4489),(60003,4489),(60004,4489),(60005,4490),(60006,4490),(60007,4490),(60008,4414),(60009,4414),(60010,4414),(60011,4414),(60012,4415),(60013,4415),(60014,4415),(60015,4415),(60016,4416),(60017,4416),(60018,4416),(60019,4416),(60020,4417),(60021,4417),(60022,4417),(60023,4417),(60024,4418),(60025,4418),(60026,4418),(60027,4418),(60028,4419),(60029,4419),(60030,4419),(60031,4419),(60032,4420),(60033,4420),(60034,4420),(60035,4420),(60036,4421),(60037,4421),(60038,4421),(60039,4421),(60040,4422),(60041,4422),(60042,4422),(60043,4422),(60044,4423),(60045,4423),(60046,4423),(60047,4423),(60048,4424),(60049,4424),(60050,4424),(60051,4424),(60052,4425),(60053,4425),(60054,4425),(60055,4425),(60056,4426),(60057,4426),(60058,4426),(60059,4426),(60060,4427),(60061,4427),(60062,4427),(60063,4427),(60064,4428),(60065,4428),(60066,4428),(60067,4428),(60068,4429),(60069,4429),(60070,4429),(60071,4429),(60072,4430),(60073,4430),(60074,4430),(60075,4430),(60076,4431),(60077,4431),(60078,4431),(60079,4431),(60080,4432),(60081,4432),(60082,4432),(60083,4432),(60084,4433),(60085,4433),(60086,4433),(60087,4433),(60088,4434),(60089,4434),(60090,4434),(60091,4434),(60092,4435),(60093,4435),(60094,4435),(60095,4435),(60096,4436),(60097,4436),(60098,4436),(60099,4436),(60100,4437),(60101,4437),(60102,4437),(60103,4437),(60104,4438),(60105,4438),(60106,4438),(60107,4438),(60108,4439),(60109,4439),(60110,4439),(60111,4439),(60112,4440),(60113,4440),(60114,4440),(60115,4440),(60116,4441),(60117,4441),(60118,4441),(60119,4441),(60120,4442),(60121,4442),(60122,4442),(60123,4442),(60124,4443),(60125,4443),(60126,4443),(60127,4443),(60128,4444),(60129,4444),(60130,4444),(60131,4444),(60132,4445),(60133,4445),(60134,4445),(60135,4445),(60136,4446),(60137,4446),(60138,4446),(60139,4446),(60140,4447),(60141,4447),(60142,4447),(60143,4447),(60144,4448),(60145,4448),(60146,4448),(60147,4448),(60148,4449),(60149,4449),(60150,4449),(60151,4449),(60152,4450),(60153,4450),(60154,4450),(60155,4450),(60156,4451),(60157,4451),(60158,4451),(60159,4451),(60160,4452),(60161,4452),(60162,4452),(60163,4452),(60164,4453),(60165,4453),(60166,4453),(60167,4453),(60168,4454),(60169,4454),(60170,4454),(60171,4454),(60172,4455),(60173,4455),(60174,4455),(60175,4455),(60176,4456),(60177,4456),(60178,4456),(60179,4456),(60180,4457),(60181,4457),(60182,4457),(60183,4457),(60184,4458),(60185,4458),(60186,4458),(60187,4458),(60188,4459),(60189,4459),(60190,4459),(60191,4459),(60192,4460),(60193,4460),(60194,4460),(60195,4460),(60196,4461),(60197,4461),(60198,4461),(60199,4461),(60200,4462),(60201,4462),(60202,4462),(60203,4462),(60204,4463),(60205,4463),(60206,4463),(60207,4463),(60208,4464),(60209,4464),(60210,4464),(60211,4464),(60212,4465),(60213,4465),(60214,4465),(60215,4465),(60216,4466),(60217,4466),(60218,4466),(60219,4466),(60220,4467),(60221,4467),(60222,4467),(60223,4467),(60224,4468),(60225,4468),(60226,4468),(60227,4468),(60228,4469),(60229,4469),(60230,4469),(60231,4469),(60232,4470),(60233,4470),(60234,4470),(60235,4470),(60236,4471),(60237,4471),(60238,4471),(60239,4471),(60240,4472),(60241,4472),(60242,4472),(60243,4472),(60244,4473),(60245,4473),(60246,4473),(60247,4473),(60248,4474),(60249,4474),(60250,4474),(60251,4474),(60252,4475),(60253,4475),(60254,4475),(60255,4475),(60256,4476),(60257,4476),(60258,4476),(60259,4476),(60260,4477),(60261,4477),(60262,4477),(60263,4477),(60264,4478),(60265,4478),(60266,4478),(60267,4478),(60268,4479),(60269,4479),(60270,4479),(60271,4479),(60272,4480),(60273,4480),(60274,4480),(60275,4480),(60276,4481),(60277,4481),(60278,4481),(60279,4481),(60280,4482),(60281,4482),(60282,4482),(60283,4482),(60284,4483),(60285,4483),(60286,4483),(60287,4483),(60288,4484),(60289,4484),(60290,4484),(60291,4484),(60292,4485),(60293,4485),(60294,4485),(60295,4485),(60296,4486),(60297,4486),(60298,4486),(60299,4486),(60300,4487),(60301,4487),(60302,4487),(60303,4487),(60304,4488),(60305,4488),(60306,4488),(60307,4488),(60308,4489),(60309,4489),(60310,4489),(60311,4489),(60312,4490),(60313,4490),(60314,4490),(60315,4490),(60316,4491),(60317,4491),(60318,4491),(60319,4491),(60320,4491),(60321,4491),(60322,4492),(60323,4492),(60324,4492),(60325,4492),(60326,4492),(60327,4492),(60328,4493),(60329,4493),(60330,4493),(60331,4493),(60332,4493),(60333,4493),(60334,4494),(60335,4494),(60336,4494),(60337,4494),(60338,4494),(60339,4494),(60340,4495),(60341,4495),(60342,4495),(60343,4495),(60344,4495),(60345,4495),(60346,4496),(60347,4496),(60348,4496),(60349,4496),(60350,4496),(60351,4496),(60352,4497),(60353,4497),(60354,4497),(60355,4497),(60356,4497),(60357,4497),(60358,4498),(60359,4498),(60360,4498),(60361,4498),(60362,4498),(60363,4498),(60364,4499),(60365,4499),(60366,4499),(60367,4499),(60368,4499),(60369,4499),(60370,4500),(60371,4500),(60372,4500),(60373,4500),(60374,4500),(60375,4500),(60376,4501),(60377,4501),(60378,4501),(60379,4501),(60380,4501),(60381,4501),(60382,4502),(60383,4502),(60384,4502),(60385,4502),(60386,4502),(60387,4502),(60388,4503),(60389,4503),(60390,4503),(60391,4503),(60392,4503),(60393,4503),(60394,4504),(60395,4504),(60396,4504),(60397,4504),(60398,4504),(60399,4504),(60400,4505),(60401,4505),(60402,4505),(60403,4505),(60404,4505),(60405,4505),(60406,4506),(60407,4506),(60408,4506),(60409,4506),(60410,4506),(60411,4506),(60412,4507),(60413,4507),(60414,4507),(60415,4507),(60416,4507),(60417,4507),(60418,4508),(60419,4508),(60420,4508),(60421,4508),(60422,4508),(60423,4508),(60424,4509),(60425,4509),(60426,4509),(60427,4509),(60428,4509),(60429,4509),(60430,4510),(60431,4510),(60432,4510),(60433,4510),(60434,4510),(60435,4510),(60436,4511),(60437,4511),(60438,4511),(60439,4511),(60440,4511),(60441,4511),(60442,4512),(60443,4512),(60444,4512),(60445,4512),(60446,4512),(60447,4512),(60448,4513),(60449,4513),(60450,4513),(60451,4513),(60452,4513),(60453,4513),(60454,4514),(60455,4514),(60456,4514),(60457,4514),(60458,4514),(60459,4514),(60460,4515),(60461,4515),(60462,4515),(60463,4515),(60464,4515),(60465,4515),(60466,4516),(60467,4516),(60468,4516),(60469,4516),(60470,4516),(60471,4516),(60472,4517),(60473,4517),(60474,4517),(60475,4517),(60476,4517),(60477,4517),(60478,4518),(60479,4518),(60480,4518),(60481,4518),(60482,4518),(60483,4518),(60484,4519),(60485,4519),(60486,4519),(60487,4519),(60488,4519),(60489,4519),(60490,4520),(60491,4520),(60492,4520),(60493,4520),(60494,4520),(60495,4520),(60496,4521),(60497,4521),(60498,4521),(60499,4521),(60500,4521),(60501,4521),(60502,4522),(60503,4522),(60504,4522),(60505,4522),(60506,4522),(60507,4522),(60508,4523),(60509,4523),(60510,4523),(60511,4523),(60512,4523),(60513,4523),(60514,4524),(60515,4524),(60516,4524),(60517,4524),(60518,4524),(60519,4524),(60520,4525),(60521,4525),(60522,4525),(60523,4525),(60524,4525),(60525,4525),(60526,4526),(60527,4526),(60528,4526),(60529,4526),(60530,4526),(60531,4526),(60532,4527),(60533,4527),(60534,4527),(60535,4527),(60536,4527),(60537,4527),(60538,4528),(60539,4528),(60540,4528),(60541,4528),(60542,4528),(60543,4528),(60544,4529),(60545,4529),(60546,4529),(60547,4529),(60548,4529),(60549,4529),(60550,4530),(60551,4530),(60552,4530),(60553,4530),(60554,4530),(60555,4530),(60556,4531),(60557,4531),(60558,4531),(60559,4531),(60560,4531),(60561,4531),(60562,4532),(60563,4532),(60564,4532),(60565,4532),(60566,4532),(60567,4532),(60568,4533),(60569,4533),(60570,4533),(60571,4533),(60572,4533),(60573,4533),(60574,4534),(60575,4534),(60576,4534),(60577,4534),(60578,4534),(60579,4534),(60580,4535),(60581,4535),(60582,4535),(60583,4535),(60584,4535),(60585,4535),(60586,4536),(60587,4536),(60588,4536),(60589,4536),(60590,4536),(60591,4536),(60592,4537),(60593,4537),(60594,4537),(60595,4537),(60596,4537),(60597,4537),(60598,4538),(60599,4538),(60600,4538),(60601,4538),(60602,4538),(60603,4538),(60604,4539),(60605,4539),(60606,4539),(60607,4539),(60608,4539),(60609,4539),(60610,4540),(60611,4540),(60612,4540),(60613,4540),(60614,4540),(60615,4540),(60616,4541),(60617,4541),(60618,4541),(60619,4541),(60620,4541),(60621,4541),(60622,4542),(60623,4542),(60624,4542),(60625,4542),(60626,4542),(60627,4542),(60628,4543),(60629,4543),(60630,4543),(60631,4543),(60632,4543),(60633,4543),(60634,4544),(60635,4544),(60636,4544),(60637,4544),(60638,4544),(60639,4544),(60640,4545),(60641,4545),(60642,4545),(60643,4545),(60644,4545),(60645,4545),(60646,4546),(60647,4546),(60648,4546),(60649,4546),(60650,4546),(60651,4546),(60652,4547),(60653,4547),(60654,4547),(60655,4547),(60656,4547),(60657,4547),(60658,4548),(60659,4548),(60660,4548),(60661,4548),(60662,4548),(60663,4548),(60664,4549),(60665,4549),(60666,4549),(60667,4549),(60668,4549),(60669,4549),(60670,4550),(60671,4550),(60672,4550),(60673,4550),(60674,4550),(60675,4550),(60676,4551),(60677,4551),(60678,4551),(60679,4551),(60680,4551),(60681,4551),(60682,4552),(60683,4552),(60684,4552),(60685,4552),(60686,4552),(60687,4552),(60688,4553),(60689,4553),(60690,4553),(60691,4553),(60692,4553),(60693,4553),(60694,4554),(60695,4554),(60696,4554),(60697,4554),(60698,4554),(60699,4554),(60700,4555),(60701,4555),(60702,4555),(60703,4555),(60704,4555),(60705,4555),(60706,4556),(60707,4556),(60708,4556),(60709,4556),(60710,4556),(60711,4556),(60712,4557),(60713,4557),(60714,4557),(60715,4557),(60716,4557),(60717,4557),(60718,4558),(60719,4558),(60720,4558),(60721,4558),(60722,4558),(60723,4558),(60724,4559),(60725,4559),(60726,4559),(60727,4559),(60728,4559),(60729,4559),(60730,4560),(60731,4560),(60732,4560),(60733,4560),(60734,4560),(60735,4560),(60736,4561),(60737,4561),(60738,4561),(60739,4561),(60740,4561),(60741,4561),(60742,4562),(60743,4562),(60744,4562),(60745,4562),(60746,4562),(60747,4562),(60748,4563),(60749,4563),(60750,4563),(60751,4563),(60752,4563),(60753,4563),(60754,4564),(60755,4564),(60756,4564),(60757,4564),(60758,4564),(60759,4564),(60760,4565),(60761,4565),(60762,4565),(60763,4565),(60764,4565),(60765,4565),(60766,4566),(60767,4566),(60768,4566),(60769,4566),(60770,4566),(60771,4566),(60772,4567),(60773,4567),(60774,4567),(60775,4567),(60776,4567),(60777,4567),(60778,4568),(60779,4568),(60780,4568),(60781,4568),(60782,4569),(60783,4569),(60784,4569),(60785,4569),(60786,4570),(60787,4570),(60788,4570),(60789,4570),(60790,4571),(60791,4571),(60792,4571),(60793,4571),(60794,4572),(60795,4572),(60796,4572),(60797,4572),(60798,4572),(60799,4572),(60800,4573),(60801,4573),(60802,4573),(60803,4573),(60804,4573),(60805,4573),(60806,4574),(60807,4574),(60808,4574),(60809,4574),(60810,4574),(60811,4574),(60812,4575),(60813,4575),(60814,4575),(60815,4575),(60816,4576),(60817,4576),(60818,4576),(60819,4576),(60820,4577),(60821,4577),(60822,4577),(60823,4577),(60824,4577),(60825,4577),(60826,4578),(60827,4578),(60828,4578),(60829,4578),(60830,4578),(60831,4579),(60832,4579),(60833,4579),(60834,4579),(60835,4579),(60836,4491),(60837,4491),(60838,4491),(60839,4492),(60840,4492),(60841,4492),(60842,4493),(60843,4493),(60844,4493),(60845,4494),(60846,4494),(60847,4494),(60848,4495),(60849,4495),(60850,4495),(60851,4496),(60852,4496),(60853,4496),(60854,4497),(60855,4497),(60856,4497),(60857,4498),(60858,4498),(60859,4498),(60860,4499),(60861,4499),(60862,4499),(60863,4500),(60864,4500),(60865,4500),(60866,4501),(60867,4501),(60868,4501),(60869,4502),(60870,4502),(60871,4502),(60872,4503),(60873,4503),(60874,4503),(60875,4504),(60876,4504),(60877,4504),(60878,4505),(60879,4505),(60880,4505),(60881,4506),(60882,4506),(60883,4506),(60884,4507),(60885,4507),(60886,4507),(60887,4508),(60888,4508),(60889,4508),(60890,4509),(60891,4509),(60892,4509),(60893,4510),(60894,4510),(60895,4510),(60896,4511),(60897,4511),(60898,4511),(60899,4512),(60900,4512),(60901,4512),(60902,4513),(60903,4513),(60904,4513),(60905,4514),(60906,4514),(60907,4514),(60908,4515),(60909,4515),(60910,4515),(60911,4516),(60912,4516),(60913,4516),(60914,4517),(60915,4517),(60916,4517),(60917,4518),(60918,4518),(60919,4518),(60920,4519),(60921,4519),(60922,4519),(60923,4520),(60924,4520),(60925,4520),(60926,4521),(60927,4521),(60928,4521),(60929,4522),(60930,4522),(60931,4522),(60932,4523),(60933,4523),(60934,4523),(60935,4524),(60936,4524),(60937,4524),(60938,4525),(60939,4525),(60940,4525),(60941,4526),(60942,4526),(60943,4526),(60944,4527),(60945,4527),(60946,4527),(60947,4528),(60948,4528),(60949,4528),(60950,4529),(60951,4529),(60952,4529),(60953,4530),(60954,4530),(60955,4530),(60956,4531),(60957,4531),(60958,4531),(60959,4532),(60960,4532),(60961,4532),(60962,4533),(60963,4533),(60964,4533),(60965,4534),(60966,4534),(60967,4534),(60968,4535),(60969,4535),(60970,4535),(60971,4536),(60972,4536),(60973,4536),(60974,4537),(60975,4537),(60976,4537),(60977,4538),(60978,4538),(60979,4539),(60980,4539),(60981,4539),(60982,4540),(60983,4540),(60984,4540),(60985,4541),(60986,4541),(60987,4541),(60988,4542),(60989,4542),(60990,4542),(60991,4543),(60992,4543),(60993,4543),(60994,4544),(60995,4544),(60996,4544),(60997,4545),(60998,4545),(60999,4545),(61000,4546),(61001,4546),(61002,4546),(61003,4547),(61004,4547),(61005,4547),(61006,4548),(61007,4548),(61008,4548),(61009,4549),(61010,4549),(61011,4549),(61012,4550),(61013,4550),(61014,4550),(61015,4551),(61016,4551),(61017,4551),(61018,4552),(61019,4552),(61020,4552),(61021,4553),(61022,4553),(61023,4553),(61024,4554),(61025,4554),(61026,4554),(61027,4555),(61028,4555),(61029,4555),(61030,4556),(61031,4556),(61032,4556),(61033,4557),(61034,4557),(61035,4557),(61036,4558),(61037,4558),(61038,4558),(61039,4559),(61040,4559),(61041,4559),(61042,4560),(61043,4560),(61044,4560),(61045,4561),(61046,4561),(61047,4561),(61048,4562),(61049,4562),(61050,4562),(61051,4563),(61052,4563),(61053,4563),(61054,4564),(61055,4564),(61056,4564),(61057,4565),(61058,4565),(61059,4565),(61060,4566),(61061,4566),(61062,4566),(61063,4567),(61064,4567),(61065,4567),(61066,4568),(61067,4568),(61068,4568),(61069,4569),(61070,4569),(61071,4569),(61072,4570),(61073,4570),(61074,4570),(61075,4571),(61076,4571),(61077,4571),(61078,4572),(61079,4572),(61080,4572),(61081,4573),(61082,4573),(61083,4573),(61084,4574),(61085,4574),(61086,4574),(61087,4575),(61088,4575),(61089,4575),(61090,4576),(61091,4576),(61092,4576),(61093,4577),(61094,4577),(61095,4577),(61096,4578),(61097,4578),(61098,4578),(61099,4579),(61100,4579),(61101,4579),(61102,4491),(61103,4491),(61104,4491),(61105,4491),(61106,4492),(61107,4492),(61108,4492),(61109,4492),(61110,4493),(61111,4493),(61112,4493),(61113,4493),(61114,4494),(61115,4494),(61116,4494),(61117,4494),(61118,4495),(61119,4495),(61120,4495),(61121,4495),(61122,4496),(61123,4496),(61124,4496),(61125,4496),(61126,4497),(61127,4497),(61128,4497),(61129,4497),(61130,4498),(61131,4498),(61132,4498),(61133,4498),(61134,4499),(61135,4499),(61136,4499),(61137,4499),(61138,4500),(61139,4500),(61140,4500),(61141,4500),(61142,4501),(61143,4501),(61144,4501),(61145,4501),(61146,4502),(61147,4502),(61148,4502),(61149,4502),(61150,4503),(61151,4503),(61152,4503),(61153,4503),(61154,4504),(61155,4504),(61156,4504),(61157,4504),(61158,4505),(61159,4505),(61160,4505),(61161,4505),(61162,4506),(61163,4506),(61164,4506),(61165,4506),(61166,4507),(61167,4507),(61168,4507),(61169,4507),(61170,4508),(61171,4508),(61172,4508),(61173,4508),(61174,4509),(61175,4509),(61176,4509),(61177,4509),(61178,4510),(61179,4510),(61180,4510),(61181,4510),(61182,4511),(61183,4511),(61184,4511),(61185,4511),(61186,4512),(61187,4512),(61188,4512),(61189,4512),(61190,4513),(61191,4513),(61192,4513),(61193,4513),(61194,4514),(61195,4514),(61196,4514),(61197,4514),(61198,4515),(61199,4515),(61200,4515),(61201,4515),(61202,4516),(61203,4516),(61204,4516),(61205,4516),(61206,4517),(61207,4517),(61208,4517),(61209,4517),(61210,4518),(61211,4518),(61212,4518),(61213,4518),(61214,4519),(61215,4519),(61216,4519),(61217,4519),(61218,4520),(61219,4520),(61220,4520),(61221,4520),(61222,4521),(61223,4521),(61224,4521),(61225,4521),(61226,4522),(61227,4522),(61228,4522),(61229,4522),(61230,4523),(61231,4523),(61232,4523),(61233,4523),(61234,4524),(61235,4524),(61236,4524),(61237,4524),(61238,4525),(61239,4525),(61240,4525),(61241,4525),(61242,4526),(61243,4526),(61244,4526),(61245,4526),(61246,4527),(61247,4527),(61248,4527),(61249,4527),(61250,4528),(61251,4528),(61252,4528),(61253,4528),(61254,4529),(61255,4529),(61256,4529),(61257,4529),(61258,4530),(61259,4530),(61260,4530),(61261,4530),(61262,4531),(61263,4531),(61264,4531),(61265,4531),(61266,4532),(61267,4532),(61268,4532),(61269,4532),(61270,4533),(61271,4533),(61272,4533),(61273,4533),(61274,4534),(61275,4534),(61276,4534),(61277,4534),(61278,4535),(61279,4535),(61280,4535),(61281,4535),(61282,4536),(61283,4536),(61284,4536),(61285,4536),(61286,4537),(61287,4537),(61288,4537),(61289,4537),(61290,4538),(61291,4538),(61292,4538),(61293,4538),(61294,4539),(61295,4539),(61296,4539),(61297,4539),(61298,4540),(61299,4540),(61300,4540),(61301,4540),(61302,4541),(61303,4541),(61304,4541),(61305,4541),(61306,4542),(61307,4542),(61308,4542),(61309,4542),(61310,4543),(61311,4543),(61312,4543),(61313,4543),(61314,4544),(61315,4544),(61316,4544),(61317,4544),(61318,4545),(61319,4545),(61320,4545),(61321,4545),(61322,4546),(61323,4546),(61324,4546),(61325,4546),(61326,4547),(61327,4547),(61328,4547),(61329,4547),(61330,4548),(61331,4548),(61332,4548),(61333,4548),(61334,4549),(61335,4549),(61336,4549),(61337,4549),(61338,4550),(61339,4550),(61340,4550),(61341,4550),(61342,4551),(61343,4551),(61344,4551),(61345,4551),(61346,4552),(61347,4552),(61348,4552),(61349,4552),(61350,4553),(61351,4553),(61352,4553),(61353,4553),(61354,4554),(61355,4554),(61356,4554),(61357,4554),(61358,4555),(61359,4555),(61360,4555),(61361,4555),(61362,4556),(61363,4556),(61364,4556),(61365,4556),(61366,4557),(61367,4557),(61368,4557),(61369,4557),(61370,4558),(61371,4558),(61372,4558),(61373,4558),(61374,4559),(61375,4559),(61376,4559),(61377,4559),(61378,4560),(61379,4560),(61380,4560),(61381,4560),(61382,4561),(61383,4561),(61384,4561),(61385,4561),(61386,4562),(61387,4562),(61388,4562),(61389,4562),(61390,4563),(61391,4563),(61392,4563),(61393,4563),(61394,4564),(61395,4564),(61396,4564),(61397,4564),(61398,4565),(61399,4565),(61400,4565),(61401,4565),(61402,4566),(61403,4566),(61404,4566),(61405,4566),(61406,4567),(61407,4567),(61408,4567),(61409,4567),(61410,4568),(61411,4568),(61412,4568),(61413,4568),(61414,4569),(61415,4569),(61416,4569),(61417,4569),(61418,4570),(61419,4570),(61420,4570),(61421,4570),(61422,4571),(61423,4571),(61424,4571),(61425,4571),(61426,4572),(61427,4572),(61428,4572),(61429,4572),(61430,4573),(61431,4573),(61432,4573),(61433,4573),(61434,4574),(61435,4574),(61436,4574),(61437,4574),(61438,4575),(61439,4575),(61440,4575),(61441,4575),(61442,4576),(61443,4576),(61444,4576),(61445,4576),(61446,4577),(61447,4577),(61448,4577),(61449,4577),(61450,4578),(61451,4578),(61452,4578),(61453,4578),(61454,4579),(61455,4579),(61456,4579),(61457,4579),(61458,4580),(61459,4580),(61460,4580),(61461,4580),(61462,4580),(61463,4581),(61464,4581),(61465,4581),(61466,4581),(61467,4581),(61468,4582),(61469,4582),(61470,4582),(61471,4582),(61472,4582),(61473,4582),(61474,4583),(61475,4583),(61476,4583),(61477,4583),(61478,4583),(61479,4583),(61480,4584),(61481,4584),(61482,4584),(61483,4584),(61484,4584),(61485,4584),(61486,4585),(61487,4585),(61488,4585),(61489,4585),(61490,4585),(61491,4585),(61492,4586),(61493,4586),(61494,4586),(61495,4586),(61496,4586),(61497,4586),(61498,4587),(61499,4587),(61500,4587),(61501,4587),(61502,4587),(61503,4587),(61504,4588),(61505,4588),(61506,4588),(61507,4588),(61508,4588),(61509,4588),(61510,4589),(61511,4589),(61512,4589),(61513,4589),(61514,4589),(61515,4589),(61516,4590),(61517,4590),(61518,4590),(61519,4590),(61520,4590),(61521,4590),(61522,4591),(61523,4591),(61524,4591),(61525,4591),(61526,4591),(61527,4591),(61528,4592),(61529,4592),(61530,4592),(61531,4592),(61532,4592),(61533,4592),(61534,4593),(61535,4593),(61536,4593),(61537,4593),(61538,4593),(61539,4593),(61540,4594),(61541,4594),(61542,4594),(61543,4594),(61544,4594),(61545,4594),(61546,4595),(61547,4595),(61548,4595),(61549,4595),(61550,4595),(61551,4595),(61552,4596),(61553,4596),(61554,4596),(61555,4596),(61556,4596),(61557,4596),(61558,4597),(61559,4597),(61560,4597),(61561,4597),(61562,4597),(61563,4597),(61564,4598),(61565,4598),(61566,4598),(61567,4598),(61568,4598),(61569,4598),(61570,4599),(61571,4599),(61572,4599),(61573,4599),(61574,4599),(61575,4599),(61576,4600),(61577,4600),(61578,4600),(61579,4600),(61580,4600),(61581,4600),(61582,4601),(61583,4601),(61584,4601),(61585,4601),(61586,4601),(61587,4601),(61588,4602),(61589,4602),(61590,4602),(61591,4602),(61592,4602),(61593,4602),(61594,4603),(61595,4603),(61596,4603),(61597,4603),(61598,4603),(61599,4603),(61600,4604),(61601,4604),(61602,4604),(61603,4604),(61604,4604),(61605,4604),(61606,4605),(61607,4605),(61608,4605),(61609,4605),(61610,4605),(61611,4606),(61612,4606),(61613,4606),(61614,4606),(61615,4606),(61616,4607),(61617,4607),(61618,4607),(61619,4607),(61620,4607),(61621,4608),(61622,4608),(61623,4608),(61624,4608),(61625,4608),(61626,4608),(61627,4609),(61628,4609),(61629,4609),(61630,4609),(61631,4610),(61632,4610),(61633,4610),(61634,4610),(61635,4611),(61636,4611),(61637,4611),(61638,4611),(61639,4612),(61640,4612),(61641,4612),(61642,4612),(61643,4612),(61644,4612),(61645,4613),(61646,4613),(61647,4613),(61648,4613),(61649,4613),(61650,4613),(61651,4614),(61652,4614),(61653,4614),(61654,4614),(61655,4614),(61656,4614),(61657,4615),(61658,4615),(61659,4615),(61660,4615),(61661,4616),(61662,4616),(61663,4616),(61664,4616),(61665,4617),(61666,4617),(61667,4617),(61668,4617),(61669,4618),(61670,4618),(61671,4618),(61672,4618),(61673,4619),(61674,4619),(61675,4619),(61676,4619),(61677,4620),(61678,4620),(61679,4620),(61680,4620),(61681,4621),(61682,4621),(61683,4621),(61684,4621),(61685,4621),(61686,4621),(61687,4622),(61688,4622),(61689,4622),(61690,4622),(61691,4622),(61692,4622),(61693,4623),(61694,4623),(61695,4623),(61696,4623),(61697,4623),(61698,4623),(61699,4624),(61700,4624),(61701,4624),(61702,4624),(61703,4624),(61704,4624),(61705,4625),(61706,4625),(61707,4625),(61708,4625),(61709,4625),(61710,4626),(61711,4626),(61712,4626),(61713,4626),(61714,4626),(61715,4627),(61716,4627),(61717,4627),(61718,4627),(61719,4627),(61720,4627),(61721,4628),(61722,4628),(61723,4628),(61724,4628),(61725,4628),(61726,4628),(61727,4629),(61728,4629),(61729,4629),(61730,4629),(61731,4629),(61732,4629),(61733,4630),(61734,4630),(61735,4630),(61736,4630),(61737,4630),(61738,4630),(61739,4631),(61740,4631),(61741,4631),(61742,4631),(61743,4631),(61744,4631),(61745,4632),(61746,4632),(61747,4632),(61748,4632),(61749,4632),(61750,4632),(61751,4633),(61752,4633),(61753,4633),(61754,4633),(61755,4633),(61756,4633),(61757,4634),(61758,4634),(61759,4634),(61760,4634),(61761,4634),(61762,4634),(61763,4635),(61764,4635),(61765,4635),(61766,4635),(61767,4635),(61768,4635),(61769,4636),(61770,4636),(61771,4636),(61772,4636),(61773,4636),(61774,4636),(61775,4637),(61776,4637),(61777,4637),(61778,4637),(61779,4637),(61780,4637),(61781,4638),(61782,4638),(61783,4638),(61784,4638),(61785,4638),(61786,4638),(61787,4639),(61788,4639),(61789,4639),(61790,4639),(61791,4639),(61792,4639),(61793,4640),(61794,4640),(61795,4640),(61796,4640),(61797,4640),(61798,4640),(61799,4641),(61800,4641),(61801,4641),(61802,4641),(61803,4641),(61804,4641),(61805,4642),(61806,4642),(61807,4642),(61808,4642),(61809,4642),(61810,4642),(61811,4643),(61812,4643),(61813,4643),(61814,4643),(61815,4643),(61816,4643),(61817,4644),(61818,4644),(61819,4644),(61820,4644),(61821,4644),(61822,4644),(61823,4645),(61824,4645),(61825,4645),(61826,4645),(61827,4645),(61828,4645),(61829,4646),(61830,4646),(61831,4646),(61832,4646),(61833,4646),(61834,4646),(61835,4647),(61836,4647),(61837,4647),(61838,4647),(61839,4647),(61840,4647),(61841,4648),(61842,4648),(61843,4648),(61844,4648),(61845,4648),(61846,4648),(61847,4649),(61848,4649),(61849,4649),(61850,4649),(61851,4649),(61852,4649),(61853,4650),(61854,4650),(61855,4650),(61856,4650),(61857,4650),(61858,4650),(61859,4651),(61860,4651),(61861,4651),(61862,4651),(61863,4651),(61864,4651),(61865,4652),(61866,4652),(61867,4652),(61868,4652),(61869,4652),(61870,4652),(61871,4653),(61872,4653),(61873,4653),(61874,4653),(61875,4653),(61876,4653),(61877,4654),(61878,4654),(61879,4654),(61880,4654),(61881,4654),(61882,4654),(61883,4655),(61884,4655),(61885,4655),(61886,4655),(61887,4655),(61888,4655),(61889,4656),(61890,4656),(61891,4656),(61892,4656),(61893,4656),(61894,4656),(61895,4657),(61896,4657),(61897,4657),(61898,4657),(61899,4657),(61900,4657),(61901,4658),(61902,4658),(61903,4658),(61904,4658),(61905,4658),(61906,4658),(61907,4659),(61908,4659),(61909,4659),(61910,4659),(61911,4659),(61912,4659),(61913,4660),(61914,4660),(61915,4660),(61916,4660),(61917,4660),(61918,4660),(61919,4661),(61920,4661),(61921,4661),(61922,4661),(61923,4661),(61924,4661),(61925,4662),(61926,4662),(61927,4662),(61928,4662),(61929,4662),(61930,4662),(61931,4663),(61932,4663),(61933,4663),(61934,4663),(61935,4663),(61936,4663),(61937,4664),(61938,4664),(61939,4664),(61940,4664),(61941,4664),(61942,4664),(61943,4665),(61944,4665),(61945,4665),(61946,4665),(61947,4665),(61948,4665),(61949,4666),(61950,4666),(61951,4666),(61952,4666),(61953,4666),(61954,4666),(61955,4667),(61956,4667),(61957,4667),(61958,4667),(61959,4667),(61960,4667),(61961,4668),(61962,4668),(61963,4668),(61964,4668),(61965,4668),(61966,4668),(61967,4669),(61968,4669),(61969,4669),(61970,4669),(61971,4669),(61972,4669),(61973,4670),(61974,4670),(61975,4670),(61976,4670),(61977,4671),(61978,4671),(61979,4671),(61980,4671),(61981,4671),(61982,4671),(61983,4672),(61984,4672),(61985,4672),(61986,4672),(61987,4673),(61988,4673),(61989,4673),(61990,4673),(61991,4673),(61992,4673),(61993,4674),(61994,4674),(61995,4674),(61996,4674),(61997,4674),(61998,4674),(61999,4675),(62000,4675),(62001,4675),(62002,4675),(62003,4675),(62004,4675),(62005,4676),(62006,4676),(62007,4676),(62008,4676),(62009,4676),(62010,4676),(62011,4677),(62012,4677),(62013,4677),(62014,4677),(62015,4678),(62016,4678),(62017,4678),(62018,4678),(62019,4679),(62020,4679),(62021,4679),(62022,4679),(62023,4580),(62024,4580),(62025,4580),(62026,4581),(62027,4581),(62028,4581),(62029,4582),(62030,4582),(62031,4582),(62032,4583),(62033,4583),(62034,4583),(62035,4584),(62036,4584),(62037,4584),(62038,4585),(62039,4585),(62040,4585),(62041,4586),(62042,4586),(62043,4586),(62044,4587),(62045,4587),(62046,4587),(62047,4588),(62048,4588),(62049,4588),(62050,4589),(62051,4589),(62052,4589),(62053,4590),(62054,4590),(62055,4590),(62056,4591),(62057,4591),(62058,4591),(62059,4592),(62060,4592),(62061,4592),(62062,4593),(62063,4593),(62064,4593),(62065,4594),(62066,4594),(62067,4594),(62068,4595),(62069,4595),(62070,4595),(62071,4596),(62072,4596),(62073,4596),(62074,4597),(62075,4597),(62076,4597),(62077,4598),(62078,4598),(62079,4598),(62080,4599),(62081,4599),(62082,4599),(62083,4600),(62084,4600),(62085,4600),(62086,4601),(62087,4601),(62088,4601),(62089,4602),(62090,4602),(62091,4602),(62092,4603),(62093,4603),(62094,4603),(62095,4604),(62096,4604),(62097,4604),(62098,4605),(62099,4605),(62100,4605),(62101,4606),(62102,4606),(62103,4606),(62104,4607),(62105,4607),(62106,4607),(62107,4608),(62108,4608),(62109,4608),(62110,4609),(62111,4609),(62112,4609),(62113,4610),(62114,4610),(62115,4610),(62116,4611),(62117,4611),(62118,4611),(62119,4612),(62120,4612),(62121,4612),(62122,4613),(62123,4613),(62124,4613),(62125,4614),(62126,4614),(62127,4614),(62128,4615),(62129,4615),(62130,4615),(62131,4616),(62132,4616),(62133,4616),(62134,4617),(62135,4617),(62136,4617),(62137,4618),(62138,4618),(62139,4618),(62140,4619),(62141,4619),(62142,4619),(62143,4620),(62144,4620),(62145,4620),(62146,4621),(62147,4621),(62148,4621),(62149,4622),(62150,4622),(62151,4622),(62152,4623),(62153,4623),(62154,4623),(62155,4624),(62156,4624),(62157,4624),(62158,4625),(62159,4625),(62160,4625),(62161,4626),(62162,4626),(62163,4626),(62164,4627),(62165,4627),(62166,4627),(62167,4628),(62168,4628),(62169,4628),(62170,4629),(62171,4629),(62172,4629),(62173,4630),(62174,4630),(62175,4630),(62176,4631),(62177,4631),(62178,4631),(62179,4632),(62180,4632),(62181,4632),(62182,4633),(62183,4633),(62184,4633),(62185,4634),(62186,4634),(62187,4634),(62188,4635),(62189,4635),(62190,4635),(62191,4636),(62192,4636),(62193,4636),(62194,4637),(62195,4637),(62196,4637),(62197,4638),(62198,4638),(62199,4638),(62200,4639),(62201,4639),(62202,4639),(62203,4640),(62204,4640),(62205,4640),(62206,4641),(62207,4641),(62208,4641),(62209,4642),(62210,4642),(62211,4642),(62212,4643),(62213,4643),(62214,4643),(62215,4644),(62216,4644),(62217,4644),(62218,4645),(62219,4645),(62220,4645),(62221,4646),(62222,4646),(62223,4646),(62224,4647),(62225,4647),(62226,4647),(62227,4648),(62228,4648),(62229,4648),(62230,4649),(62231,4649),(62232,4649),(62233,4650),(62234,4650),(62235,4650),(62236,4651),(62237,4651),(62238,4651),(62239,4652),(62240,4652),(62241,4652),(62242,4653),(62243,4653),(62244,4653),(62245,4654),(62246,4654),(62247,4654),(62248,4655),(62249,4655),(62250,4655),(62251,4656),(62252,4656),(62253,4656),(62254,4657),(62255,4657),(62256,4657),(62257,4658),(62258,4658),(62259,4658),(62260,4659),(62261,4659),(62262,4659),(62263,4660),(62264,4660),(62265,4660),(62266,4661),(62267,4661),(62268,4661),(62269,4662),(62270,4662),(62271,4662),(62272,4663),(62273,4663),(62274,4663),(62275,4664),(62276,4664),(62277,4664),(62278,4665),(62279,4665),(62280,4665),(62281,4666),(62282,4666),(62283,4666),(62284,4667),(62285,4667),(62286,4667),(62287,4668),(62288,4668),(62289,4668),(62290,4669),(62291,4669),(62292,4669),(62293,4670),(62294,4670),(62295,4670),(62296,4671),(62297,4671),(62298,4671),(62299,4672),(62300,4672),(62301,4672),(62302,4673),(62303,4673),(62304,4673),(62305,4674),(62306,4674),(62307,4674),(62308,4675),(62309,4675),(62310,4675),(62311,4676),(62312,4676),(62313,4676),(62314,4677),(62315,4677),(62316,4677),(62317,4678),(62318,4678),(62319,4678),(62320,4679),(62321,4679),(62322,4679),(62323,4580),(62324,4580),(62325,4580),(62326,4580),(62327,4581),(62328,4581),(62329,4581),(62330,4581),(62331,4582),(62332,4582),(62333,4582),(62334,4582),(62335,4583),(62336,4583),(62337,4583),(62338,4583),(62339,4584),(62340,4584),(62341,4584),(62342,4584),(62343,4585),(62344,4585),(62345,4585),(62346,4585),(62347,4586),(62348,4586),(62349,4586),(62350,4586),(62351,4587),(62352,4587),(62353,4587),(62354,4587),(62355,4588),(62356,4588),(62357,4588),(62358,4588),(62359,4589),(62360,4589),(62361,4589),(62362,4589),(62363,4590),(62364,4590),(62365,4590),(62366,4590),(62367,4591),(62368,4591),(62369,4591),(62370,4591),(62371,4592),(62372,4592),(62373,4592),(62374,4592),(62375,4593),(62376,4593),(62377,4593),(62378,4593),(62379,4594),(62380,4594),(62381,4594),(62382,4594),(62383,4595),(62384,4595),(62385,4595),(62386,4595),(62387,4596),(62388,4596),(62389,4596),(62390,4596),(62391,4597),(62392,4597),(62393,4597),(62394,4597),(62395,4598),(62396,4598),(62397,4598),(62398,4598),(62399,4599),(62400,4599),(62401,4599),(62402,4599),(62403,4600),(62404,4600),(62405,4600),(62406,4600),(62407,4601),(62408,4601),(62409,4601),(62410,4601),(62411,4602),(62412,4602),(62413,4602),(62414,4602),(62415,4603),(62416,4603),(62417,4603),(62418,4603),(62419,4604),(62420,4604),(62421,4604),(62422,4604),(62423,4605),(62424,4605),(62425,4605),(62426,4605),(62427,4606),(62428,4606),(62429,4606),(62430,4606),(62431,4607),(62432,4607),(62433,4607),(62434,4607),(62435,4608),(62436,4608),(62437,4608),(62438,4608),(62439,4609),(62440,4609),(62441,4609),(62442,4609),(62443,4610),(62444,4610),(62445,4610),(62446,4610),(62447,4611),(62448,4611),(62449,4611),(62450,4611),(62451,4612),(62452,4612),(62453,4612),(62454,4612),(62455,4613),(62456,4613),(62457,4613),(62458,4613),(62459,4614),(62460,4614),(62461,4614),(62462,4614),(62463,4615),(62464,4615),(62465,4615),(62466,4615),(62467,4616),(62468,4616),(62469,4616),(62470,4616),(62471,4617),(62472,4617),(62473,4617),(62474,4617),(62475,4618),(62476,4618),(62477,4618),(62478,4618),(62479,4619),(62480,4619),(62481,4619),(62482,4619),(62483,4620),(62484,4620),(62485,4620),(62486,4620),(62487,4621),(62488,4621),(62489,4621),(62490,4621),(62491,4622),(62492,4622),(62493,4622),(62494,4622),(62495,4623),(62496,4623),(62497,4623),(62498,4623),(62499,4624),(62500,4624),(62501,4624),(62502,4624),(62503,4625),(62504,4625),(62505,4625),(62506,4625),(62507,4626),(62508,4626),(62509,4626),(62510,4626),(62511,4627),(62512,4627),(62513,4627),(62514,4627),(62515,4628),(62516,4628),(62517,4628),(62518,4628),(62519,4629),(62520,4629),(62521,4629),(62522,4629),(62523,4630),(62524,4630),(62525,4630),(62526,4630),(62527,4631),(62528,4631),(62529,4631),(62530,4631),(62531,4632),(62532,4632),(62533,4632),(62534,4632),(62535,4633),(62536,4633),(62537,4633),(62538,4633),(62539,4634),(62540,4634),(62541,4634),(62542,4634),(62543,4635),(62544,4635),(62545,4635),(62546,4635),(62547,4636),(62548,4636),(62549,4636),(62550,4636),(62551,4637),(62552,4637),(62553,4637),(62554,4637),(62555,4638),(62556,4638),(62557,4638),(62558,4638),(62559,4639),(62560,4639),(62561,4639),(62562,4639),(62563,4640),(62564,4640),(62565,4640),(62566,4640),(62567,4641),(62568,4641),(62569,4641),(62570,4641),(62571,4642),(62572,4642),(62573,4642),(62574,4642),(62575,4643),(62576,4643),(62577,4643),(62578,4643),(62579,4644),(62580,4644),(62581,4644),(62582,4644),(62583,4645),(62584,4645),(62585,4645),(62586,4645),(62587,4646),(62588,4646),(62589,4646),(62590,4646),(62591,4647),(62592,4647),(62593,4647),(62594,4647),(62595,4648),(62596,4648),(62597,4648),(62598,4648),(62599,4649),(62600,4649),(62601,4649),(62602,4649),(62603,4650),(62604,4650),(62605,4650),(62606,4650),(62607,4651),(62608,4651),(62609,4651),(62610,4651),(62611,4652),(62612,4652),(62613,4652),(62614,4652),(62615,4653),(62616,4653),(62617,4653),(62618,4653),(62619,4654),(62620,4654),(62621,4654),(62622,4654),(62623,4655),(62624,4655),(62625,4655),(62626,4655),(62627,4656),(62628,4656),(62629,4656),(62630,4656),(62631,4657),(62632,4657),(62633,4657),(62634,4657),(62635,4658),(62636,4658),(62637,4658),(62638,4658),(62639,4659),(62640,4659),(62641,4659),(62642,4659),(62643,4660),(62644,4660),(62645,4660),(62646,4660),(62647,4661),(62648,4661),(62649,4661),(62650,4661),(62651,4662),(62652,4662),(62653,4662),(62654,4662),(62655,4663),(62656,4663),(62657,4663),(62658,4663),(62659,4664),(62660,4664),(62661,4664),(62662,4664),(62663,4665),(62664,4665),(62665,4665),(62666,4665),(62667,4666),(62668,4666),(62669,4666),(62670,4666),(62671,4667),(62672,4667),(62673,4667),(62674,4667),(62675,4668),(62676,4668),(62677,4668),(62678,4668),(62679,4669),(62680,4669),(62681,4669),(62682,4669),(62683,4670),(62684,4670),(62685,4670),(62686,4670),(62687,4671),(62688,4671),(62689,4671),(62690,4671),(62691,4672),(62692,4672),(62693,4672),(62694,4672),(62695,4673),(62696,4673),(62697,4673),(62698,4673),(62699,4674),(62700,4674),(62701,4674),(62702,4674),(62703,4675),(62704,4675),(62705,4675),(62706,4675),(62707,4676),(62708,4676),(62709,4676),(62710,4676),(62711,4677),(62712,4677),(62713,4677),(62714,4677),(62715,4678),(62716,4678),(62717,4678),(62718,4678),(62719,4679),(62720,4679),(62721,4679),(62722,4679),(62723,4680),(62724,4680),(62725,4680),(62726,4680),(62727,4680),(62728,4680),(62729,4681),(62730,4681),(62731,4681),(62732,4681),(62733,4681),(62734,4681),(62735,4682),(62736,4682),(62737,4682),(62738,4682),(62739,4682),(62740,4682),(62741,4683),(62742,4683),(62743,4683),(62744,4683),(62745,4683),(62746,4683),(62747,4684),(62748,4684),(62749,4684),(62750,4684),(62751,4684),(62752,4684),(62753,4685),(62754,4685),(62755,4685),(62756,4685),(62757,4685),(62758,4685),(62759,4686),(62760,4686),(62761,4686),(62762,4686),(62763,4686),(62764,4686),(62765,4687),(62766,4687),(62767,4687),(62768,4687),(62769,4687),(62770,4687),(62771,4688),(62772,4688),(62773,4688),(62774,4688),(62775,4688),(62776,4688),(62777,4689),(62778,4689),(62779,4689),(62780,4689),(62781,4689),(62782,4689),(62783,4690),(62784,4690),(62785,4690),(62786,4690),(62787,4690),(62788,4690),(62789,4691),(62790,4691),(62791,4691),(62792,4691),(62793,4691),(62794,4691),(62795,4692),(62796,4692),(62797,4692),(62798,4692),(62799,4692),(62800,4692),(62801,4693),(62802,4693),(62803,4693),(62804,4693),(62805,4693),(62806,4693),(62807,4694),(62808,4694),(62809,4694),(62810,4694),(62811,4694),(62812,4694),(62813,4695),(62814,4695),(62815,4695),(62816,4695),(62817,4695),(62818,4695),(62819,4696),(62820,4696),(62821,4696),(62822,4696),(62823,4696),(62824,4696),(62825,4697),(62826,4697),(62827,4697),(62828,4697),(62829,4697),(62830,4697),(62831,4698),(62832,4698),(62833,4698),(62834,4698),(62835,4698),(62836,4698),(62837,4699),(62838,4699),(62839,4699),(62840,4699),(62841,4699),(62842,4699),(62843,4700),(62844,4700),(62845,4700),(62846,4700),(62847,4700),(62848,4700),(62849,4701),(62850,4701),(62851,4701),(62852,4701),(62853,4701),(62854,4701),(62855,4702),(62856,4702),(62857,4702),(62858,4702),(62859,4702),(62860,4702),(62861,4703),(62862,4703),(62863,4703),(62864,4703),(62865,4703),(62866,4703),(62867,4704),(62868,4704),(62869,4704),(62870,4704),(62871,4704),(62872,4704),(62873,4705),(62874,4705),(62875,4705),(62876,4705),(62877,4705),(62878,4705),(62879,4706),(62880,4706),(62881,4706),(62882,4706),(62883,4706),(62884,4706),(62885,4707),(62886,4707),(62887,4707),(62888,4707),(62889,4707),(62890,4707),(62891,4708),(62892,4708),(62893,4708),(62894,4708),(62895,4708),(62896,4708),(62897,4709),(62898,4709),(62899,4709),(62900,4709),(62901,4709),(62902,4709),(62903,4710),(62904,4710),(62905,4710),(62906,4710),(62907,4710),(62908,4710),(62909,4711),(62910,4711),(62911,4711),(62912,4711),(62913,4711),(62914,4711),(62915,4712),(62916,4712),(62917,4712),(62918,4712),(62919,4712),(62920,4712),(62921,4713),(62922,4713),(62923,4713),(62924,4713),(62925,4713),(62926,4713),(62927,4714),(62928,4714),(62929,4714),(62930,4714),(62931,4714),(62932,4714),(62933,4715),(62934,4715),(62935,4715),(62936,4715),(62937,4715),(62938,4715),(62939,4716),(62940,4716),(62941,4716),(62942,4716),(62943,4716),(62944,4716),(62945,4717),(62946,4717),(62947,4717),(62948,4717),(62949,4717),(62950,4717),(62951,4718),(62952,4718),(62953,4718),(62954,4718),(62955,4718),(62956,4718),(62957,4719),(62958,4719),(62959,4719),(62960,4719),(62961,4719),(62962,4719),(62963,4720),(62964,4720),(62965,4720),(62966,4720),(62967,4720),(62968,4720),(62969,4721),(62970,4721),(62971,4721),(62972,4721),(62973,4722),(62974,4722),(62975,4722),(62976,4722),(62977,4722),(62978,4722),(62979,4723),(62980,4723),(62981,4723),(62982,4723),(62983,4723),(62984,4723),(62985,4724),(62986,4724),(62987,4724),(62988,4724),(62989,4724),(62990,4724),(62991,4725),(62992,4725),(62993,4725),(62994,4725),(62995,4726),(62996,4726),(62997,4726),(62998,4726),(62999,4727),(63000,4727),(63001,4727),(63002,4727),(63003,4728),(63004,4728),(63005,4728),(63006,4728),(63007,4729),(63008,4729),(63009,4729),(63010,4729),(63011,4730),(63012,4730),(63013,4730),(63014,4730),(63015,4730),(63016,4730),(63017,4731),(63018,4731),(63019,4731),(63020,4731),(63021,4731),(63022,4731),(63023,4732),(63024,4732),(63025,4732),(63026,4732),(63027,4732),(63028,4732),(63029,4733),(63030,4733),(63031,4733),(63032,4733),(63033,4733),(63034,4733),(63035,4734),(63036,4734),(63037,4734),(63038,4734),(63039,4734),(63040,4734),(63041,4735),(63042,4735),(63043,4735),(63044,4735),(63045,4735),(63046,4735),(63047,4736),(63048,4736),(63049,4736),(63050,4736),(63051,4736),(63052,4736),(63053,4737),(63054,4737),(63055,4737),(63056,4737),(63057,4737),(63058,4737),(63059,4738),(63060,4738),(63061,4738),(63062,4738),(63063,4738),(63064,4738),(63065,4739),(63066,4739),(63067,4739),(63068,4739),(63069,4739),(63070,4739),(63071,4740),(63072,4740),(63073,4740),(63074,4740),(63075,4740),(63076,4740),(63077,4741),(63078,4741),(63079,4741),(63080,4741),(63081,4741),(63082,4741),(63083,4742),(63084,4742),(63085,4742),(63086,4742),(63087,4742),(63088,4742),(63089,4743),(63090,4743),(63091,4743),(63092,4743),(63093,4743),(63094,4743),(63095,4744),(63096,4744),(63097,4744),(63098,4744),(63099,4744),(63100,4744),(63101,4745),(63102,4745),(63103,4745),(63104,4745),(63105,4746),(63106,4746),(63107,4746),(63108,4746),(63109,4746),(63110,4746),(63111,4747),(63112,4747),(63113,4747),(63114,4747),(63115,4747),(63116,4747),(63117,4748),(63118,4748),(63119,4748),(63120,4748),(63121,4748),(63122,4748),(63123,4749),(63124,4749),(63125,4749),(63126,4749),(63127,4749),(63128,4749),(63129,4750),(63130,4750),(63131,4750),(63132,4750),(63133,4750),(63134,4750),(63135,4751),(63136,4751),(63137,4751),(63138,4751),(63139,4751),(63140,4751),(63141,4752),(63142,4752),(63143,4752),(63144,4752),(63145,4752),(63146,4752),(63147,4753),(63148,4753),(63149,4753),(63150,4753),(63151,4753),(63152,4753),(63153,4754),(63154,4754),(63155,4754),(63156,4754),(63157,4754),(63158,4754),(63159,4755),(63160,4755),(63161,4755),(63162,4755),(63163,4755),(63164,4755),(63165,4756),(63166,4756),(63167,4756),(63168,4756),(63169,4756),(63170,4756),(63171,4757),(63172,4757),(63173,4757),(63174,4757),(63175,4757),(63176,4757),(63177,4758),(63178,4758),(63179,4758),(63180,4758),(63181,4758),(63182,4758),(63183,4759),(63184,4759),(63185,4759),(63186,4759),(63187,4759),(63188,4759),(63189,4760),(63190,4760),(63191,4760),(63192,4760),(63193,4760),(63194,4760),(63195,4761),(63196,4761),(63197,4761),(63198,4761),(63199,4761),(63200,4761),(63201,4762),(63202,4762),(63203,4762),(63204,4762),(63205,4762),(63206,4762),(63207,4763),(63208,4763),(63209,4763),(63210,4763),(63211,4763),(63212,4763),(63213,4764),(63214,4764),(63215,4764),(63216,4764),(63217,4764),(63218,4764),(63219,4765),(63220,4765),(63221,4765),(63222,4765),(63223,4766),(63224,4766),(63225,4766),(63226,4766),(63227,4766),(63228,4766),(63229,4767),(63230,4767),(63231,4767),(63232,4767),(63233,4767),(63234,4767),(63235,4768),(63236,4768),(63237,4768),(63238,4768),(63239,4768),(63240,4768),(63241,4769),(63242,4769),(63243,4769),(63244,4769),(63245,4769),(63246,4769),(63247,4770),(63248,4770),(63249,4770),(63250,4770),(63251,4770),(63252,4770),(63253,4771),(63254,4771),(63255,4771),(63256,4771),(63257,4771),(63258,4771),(63259,4772),(63260,4772),(63261,4772),(63262,4772),(63263,4772),(63264,4772),(63265,4773),(63266,4773),(63267,4773),(63268,4773),(63269,4773),(63270,4773),(63271,4774),(63272,4774),(63273,4774),(63274,4774),(63275,4774),(63276,4774),(63277,4775),(63278,4775),(63279,4775),(63280,4775),(63281,4775),(63282,4775),(63283,4776),(63284,4776),(63285,4776),(63286,4776),(63287,4776),(63288,4776),(63289,4777),(63290,4777),(63291,4777),(63292,4777),(63293,4777),(63294,4777),(63295,4778),(63296,4778),(63297,4778),(63298,4778),(63299,4778),(63300,4778),(63301,4779),(63302,4779),(63303,4779),(63304,4779),(63305,4779),(63306,4779),(63307,4680),(63308,4680),(63309,4680),(63310,4681),(63311,4681),(63312,4681),(63313,4682),(63314,4682),(63315,4682),(63316,4683),(63317,4683),(63318,4683),(63319,4684),(63320,4684),(63321,4684),(63322,4685),(63323,4685),(63324,4685),(63325,4686),(63326,4686),(63327,4686),(63328,4687),(63329,4687),(63330,4687),(63331,4688),(63332,4688),(63333,4688),(63334,4689),(63335,4689),(63336,4689),(63337,4690),(63338,4690),(63339,4690),(63340,4691),(63341,4691),(63342,4691),(63343,4692),(63344,4692),(63345,4692),(63346,4693),(63347,4693),(63348,4693),(63349,4694),(63350,4694),(63351,4694),(63352,4695),(63353,4695),(63354,4695),(63355,4696),(63356,4696),(63357,4696),(63358,4697),(63359,4697),(63360,4697),(63361,4698),(63362,4698),(63363,4698),(63364,4699),(63365,4699),(63366,4699),(63367,4700),(63368,4700),(63369,4700),(63370,4701),(63371,4701),(63372,4701),(63373,4702),(63374,4702),(63375,4702),(63376,4703),(63377,4703),(63378,4703),(63379,4704),(63380,4704),(63381,4704),(63382,4705),(63383,4705),(63384,4705),(63385,4706),(63386,4706),(63387,4706),(63388,4707),(63389,4707),(63390,4707),(63391,4708),(63392,4708),(63393,4708),(63394,4709),(63395,4709),(63396,4709),(63397,4710),(63398,4710),(63399,4710),(63400,4711),(63401,4711),(63402,4711),(63403,4712),(63404,4712),(63405,4712),(63406,4713),(63407,4713),(63408,4713),(63409,4714),(63410,4714),(63411,4714),(63412,4715),(63413,4715),(63414,4715),(63415,4716),(63416,4716),(63417,4716),(63418,4717),(63419,4717),(63420,4717),(63421,4718),(63422,4718),(63423,4718),(63424,4719),(63425,4719),(63426,4719),(63427,4720),(63428,4720),(63429,4720),(63430,4721),(63431,4721),(63432,4721),(63433,4722),(63434,4722),(63435,4722),(63436,4723),(63437,4723),(63438,4723),(63439,4724),(63440,4724),(63441,4724),(63442,4725),(63443,4725),(63444,4725),(63445,4726),(63446,4726),(63447,4726),(63448,4727),(63449,4727),(63450,4727),(63451,4728),(63452,4728),(63453,4728),(63454,4729),(63455,4729),(63456,4729),(63457,4730),(63458,4730),(63459,4730),(63460,4731),(63461,4731),(63462,4731),(63463,4732),(63464,4732),(63465,4732),(63466,4733),(63467,4733),(63468,4733),(63469,4734),(63470,4734),(63471,4734),(63472,4735),(63473,4735),(63474,4735),(63475,4736),(63476,4736),(63477,4736),(63478,4737),(63479,4737),(63480,4737),(63481,4738),(63482,4738),(63483,4738),(63484,4739),(63485,4739),(63486,4739),(63487,4740),(63488,4740),(63489,4740),(63490,4741),(63491,4741),(63492,4741),(63493,4742),(63494,4742),(63495,4742),(63496,4743),(63497,4743),(63498,4743),(63499,4744),(63500,4744),(63501,4744),(63502,4745),(63503,4745),(63504,4745),(63505,4746),(63506,4746),(63507,4746),(63508,4747),(63509,4747),(63510,4747),(63511,4748),(63512,4748),(63513,4748),(63514,4749),(63515,4749),(63516,4749),(63517,4750),(63518,4750),(63519,4750),(63520,4751),(63521,4751),(63522,4751),(63523,4752),(63524,4752),(63525,4752),(63526,4753),(63527,4753),(63528,4753),(63529,4754),(63530,4754),(63531,4754),(63532,4755),(63533,4755),(63534,4755),(63535,4756),(63536,4756),(63537,4756),(63538,4757),(63539,4757),(63540,4757),(63541,4758),(63542,4758),(63543,4758),(63544,4759),(63545,4759),(63546,4759),(63547,4760),(63548,4760),(63549,4760),(63550,4761),(63551,4761),(63552,4761),(63553,4762),(63554,4762),(63555,4762),(63556,4763),(63557,4763),(63558,4763),(63559,4764),(63560,4764),(63561,4764),(63562,4765),(63563,4765),(63564,4765),(63565,4766),(63566,4766),(63567,4766),(63568,4767),(63569,4767),(63570,4767),(63571,4768),(63572,4768),(63573,4768),(63574,4769),(63575,4769),(63576,4769),(63577,4770),(63578,4770),(63579,4770),(63580,4771),(63581,4771),(63582,4771),(63583,4772),(63584,4772),(63585,4772),(63586,4773),(63587,4773),(63588,4773),(63589,4774),(63590,4774),(63591,4774),(63592,4775),(63593,4775),(63594,4775),(63595,4776),(63596,4776),(63597,4776),(63598,4777),(63599,4777),(63600,4777),(63601,4778),(63602,4778),(63603,4778),(63604,4779),(63605,4779),(63606,4779),(63607,4680),(63608,4680),(63609,4680),(63610,4680),(63611,4681),(63612,4681),(63613,4681),(63614,4681),(63615,4682),(63616,4682),(63617,4682),(63618,4682),(63619,4683),(63620,4683),(63621,4683),(63622,4683),(63623,4684),(63624,4684),(63625,4684),(63626,4684),(63627,4685),(63628,4685),(63629,4685),(63630,4685),(63631,4686),(63632,4686),(63633,4686),(63634,4686),(63635,4687),(63636,4687),(63637,4687),(63638,4687),(63639,4688),(63640,4688),(63641,4688),(63642,4688),(63643,4689),(63644,4689),(63645,4689),(63646,4689),(63647,4690),(63648,4690),(63649,4690),(63650,4690),(63651,4691),(63652,4691),(63653,4691),(63654,4691),(63655,4692),(63656,4692),(63657,4692),(63658,4692),(63659,4693),(63660,4693),(63661,4693),(63662,4693),(63663,4694),(63664,4694),(63665,4694),(63666,4694),(63667,4695),(63668,4695),(63669,4695),(63670,4695),(63671,4696),(63672,4696),(63673,4696),(63674,4696),(63675,4697),(63676,4697),(63677,4697),(63678,4697),(63679,4698),(63680,4698),(63681,4698),(63682,4698),(63683,4699),(63684,4699),(63685,4699),(63686,4699),(63687,4700),(63688,4700),(63689,4700),(63690,4700),(63691,4701),(63692,4701),(63693,4701),(63694,4701),(63695,4702),(63696,4702),(63697,4702),(63698,4702),(63699,4703),(63700,4703),(63701,4703),(63702,4703),(63703,4704),(63704,4704),(63705,4704),(63706,4704),(63707,4705),(63708,4705),(63709,4705),(63710,4705),(63711,4706),(63712,4706),(63713,4706),(63714,4706),(63715,4707),(63716,4707),(63717,4707),(63718,4707),(63719,4708),(63720,4708),(63721,4708),(63722,4708),(63723,4709),(63724,4709),(63725,4709),(63726,4709),(63727,4710),(63728,4710),(63729,4710),(63730,4710),(63731,4711),(63732,4711),(63733,4711),(63734,4711),(63735,4712),(63736,4712),(63737,4712),(63738,4712),(63739,4713),(63740,4713),(63741,4713),(63742,4713),(63743,4714),(63744,4714),(63745,4714),(63746,4714),(63747,4715),(63748,4715),(63749,4715),(63750,4715),(63751,4716),(63752,4716),(63753,4716),(63754,4716),(63755,4717),(63756,4717),(63757,4717),(63758,4717),(63759,4718),(63760,4718),(63761,4718),(63762,4718),(63763,4719),(63764,4719),(63765,4719),(63766,4719),(63767,4720),(63768,4720),(63769,4720),(63770,4720),(63771,4721),(63772,4721),(63773,4721),(63774,4721),(63775,4722),(63776,4722),(63777,4722),(63778,4722),(63779,4723),(63780,4723),(63781,4723),(63782,4723),(63783,4724),(63784,4724),(63785,4724),(63786,4724),(63787,4725),(63788,4725),(63789,4725),(63790,4725),(63791,4726),(63792,4726),(63793,4726),(63794,4726),(63795,4727),(63796,4727),(63797,4727),(63798,4727),(63799,4728),(63800,4728),(63801,4728),(63802,4728),(63803,4729),(63804,4729),(63805,4729),(63806,4729),(63807,4730),(63808,4730),(63809,4730),(63810,4730),(63811,4731),(63812,4731),(63813,4731),(63814,4731),(63815,4732),(63816,4732),(63817,4732),(63818,4732),(63819,4733),(63820,4733),(63821,4733),(63822,4733),(63823,4734),(63824,4734),(63825,4734),(63826,4734),(63827,4735),(63828,4735),(63829,4735),(63830,4735),(63831,4736),(63832,4736),(63833,4736),(63834,4736),(63835,4737),(63836,4737),(63837,4737),(63838,4737),(63839,4738),(63840,4738),(63841,4738),(63842,4738),(63843,4739),(63844,4739),(63845,4739),(63846,4739),(63847,4740),(63848,4740),(63849,4740),(63850,4740),(63851,4741),(63852,4741),(63853,4741),(63854,4741),(63855,4742),(63856,4742),(63857,4742),(63858,4742),(63859,4743),(63860,4743),(63861,4743),(63862,4743),(63863,4744),(63864,4744),(63865,4744),(63866,4744),(63867,4745),(63868,4745),(63869,4745),(63870,4745),(63871,4746),(63872,4746),(63873,4746),(63874,4746),(63875,4747),(63876,4747),(63877,4747),(63878,4747),(63879,4748),(63880,4748),(63881,4748),(63882,4748),(63883,4749),(63884,4749),(63885,4749),(63886,4749),(63887,4750),(63888,4750),(63889,4750),(63890,4750),(63891,4751),(63892,4751),(63893,4751),(63894,4751),(63895,4752),(63896,4752),(63897,4752),(63898,4752),(63899,4753),(63900,4753),(63901,4753),(63902,4753),(63903,4754),(63904,4754),(63905,4754),(63906,4754),(63907,4755),(63908,4755),(63909,4755),(63910,4755),(63911,4756),(63912,4756),(63913,4756),(63914,4756),(63915,4757),(63916,4757),(63917,4757),(63918,4757),(63919,4758),(63920,4758),(63921,4758),(63922,4758),(63923,4759),(63924,4759),(63925,4759),(63926,4759),(63927,4760),(63928,4760),(63929,4760),(63930,4760),(63931,4761),(63932,4761),(63933,4761),(63934,4761),(63935,4762),(63936,4762),(63937,4762),(63938,4762),(63939,4763),(63940,4763),(63941,4763),(63942,4763),(63943,4764),(63944,4764),(63945,4764),(63946,4764),(63947,4765),(63948,4765),(63949,4765),(63950,4765),(63951,4766),(63952,4766),(63953,4766),(63954,4766),(63955,4767),(63956,4767),(63957,4767),(63958,4767),(63959,4768),(63960,4768),(63961,4768),(63962,4768),(63963,4769),(63964,4769),(63965,4769),(63966,4769),(63967,4770),(63968,4770),(63969,4770),(63970,4770),(63971,4771),(63972,4771),(63973,4771),(63974,4771),(63975,4772),(63976,4772),(63977,4772),(63978,4772),(63979,4773),(63980,4773),(63981,4773),(63982,4773),(63983,4774),(63984,4774),(63985,4774),(63986,4774),(63987,4775),(63988,4775),(63989,4775),(63990,4775),(63991,4776),(63992,4776),(63993,4776),(63994,4776),(63995,4777),(63996,4777),(63997,4777),(63998,4777),(63999,4778),(64000,4778),(64001,4778),(64002,4778),(64003,4779),(64004,4779),(64005,4779),(64006,4779),(64007,4780),(64008,4780),(64009,4780),(64010,4780),(64011,4780),(64012,4780),(64013,4781),(64014,4781),(64015,4781),(64016,4781),(64017,4781),(64018,4781),(64019,4782),(64020,4782),(64021,4782),(64022,4782),(64023,4782),(64024,4782),(64025,4783),(64026,4783),(64027,4783),(64028,4783),(64029,4783),(64030,4783),(64031,4784),(64032,4784),(64033,4784),(64034,4784),(64035,4784),(64036,4784),(64037,4785),(64038,4785),(64039,4785),(64040,4785),(64041,4785),(64042,4785),(64043,4786),(64044,4786),(64045,4786),(64046,4786),(64047,4786),(64048,4786),(64049,4787),(64050,4787),(64051,4787),(64052,4787),(64053,4787),(64054,4787),(64055,4788),(64056,4788),(64057,4788),(64058,4788),(64059,4788),(64060,4788),(64061,4789),(64062,4789),(64063,4789),(64064,4789),(64065,4789),(64066,4789),(64067,4790),(64068,4790),(64069,4790),(64070,4790),(64071,4790),(64072,4790),(64073,4791),(64074,4791),(64075,4791),(64076,4791),(64077,4791),(64078,4791),(64079,4792),(64080,4792),(64081,4792),(64082,4792),(64083,4792),(64084,4792),(64085,4793),(64086,4793),(64087,4793),(64088,4793),(64089,4793),(64090,4793),(64091,4794),(64092,4794),(64093,4794),(64094,4794),(64095,4794),(64096,4794),(64097,4795),(64098,4795),(64099,4795),(64100,4795),(64101,4795),(64102,4795),(64103,4796),(64104,4796),(64105,4796),(64106,4796),(64107,4796),(64108,4796),(64109,4797),(64110,4797),(64111,4797),(64112,4797),(64113,4797),(64114,4797),(64115,4798),(64116,4798),(64117,4798),(64118,4798),(64119,4798),(64120,4798),(64121,4799),(64122,4799),(64123,4799),(64124,4799),(64125,4799),(64126,4799),(64127,4800),(64128,4800),(64129,4800),(64130,4800),(64131,4800),(64132,4800),(64133,4801),(64134,4801),(64135,4801),(64136,4801),(64137,4801),(64138,4801),(64139,4802),(64140,4802),(64141,4802),(64142,4802),(64143,4802),(64144,4802),(64145,4803),(64146,4803),(64147,4803),(64148,4803),(64149,4803),(64150,4803),(64151,4804),(64152,4804),(64153,4804),(64154,4804),(64155,4804),(64156,4804),(64157,4805),(64158,4805),(64159,4805),(64160,4805),(64161,4806),(64162,4806),(64163,4806),(64164,4806),(64165,4807),(64166,4807),(64167,4807),(64168,4807),(64169,4808),(64170,4808),(64171,4808),(64172,4808),(64173,4809),(64174,4809),(64175,4809),(64176,4809),(64177,4809),(64178,4809),(64179,4810),(64180,4810),(64181,4810),(64182,4810),(64183,4810),(64184,4810),(64185,4811),(64186,4811),(64187,4811),(64188,4811),(64189,4811),(64190,4811),(64191,4812),(64192,4812),(64193,4812),(64194,4812),(64195,4812),(64196,4812),(64197,4813),(64198,4813),(64199,4813),(64200,4813),(64201,4813),(64202,4813),(64203,4814),(64204,4814),(64205,4814),(64206,4814),(64207,4814),(64208,4814),(64209,4815),(64210,4815),(64211,4815),(64212,4815),(64213,4815),(64214,4815),(64215,4816),(64216,4816),(64217,4816),(64218,4816),(64219,4816),(64220,4816),(64221,4817),(64222,4817),(64223,4817),(64224,4817),(64225,4817),(64226,4817),(64227,4818),(64228,4818),(64229,4818),(64230,4818),(64231,4818),(64232,4818),(64233,4819),(64234,4819),(64235,4819),(64236,4819),(64237,4819),(64238,4819),(64239,4820),(64240,4820),(64241,4820),(64242,4820),(64243,4820),(64244,4820),(64245,4821),(64246,4821),(64247,4821),(64248,4821),(64249,4821),(64250,4821),(64251,4822),(64252,4822),(64253,4822),(64254,4822),(64255,4822),(64256,4822),(64257,4823),(64258,4823),(64259,4823),(64260,4823),(64261,4823),(64262,4823),(64263,4824),(64264,4824),(64265,4824),(64266,4824),(64267,4825),(64268,4825),(64269,4825),(64270,4825),(64271,4826),(64272,4826),(64273,4826),(64274,4826),(64275,4827),(64276,4827),(64277,4827),(64278,4827),(64279,4828),(64280,4828),(64281,4828),(64282,4828),(64283,4829),(64284,4829),(64285,4829),(64286,4829),(64287,4830),(64288,4830),(64289,4830),(64290,4830),(64291,4831),(64292,4831),(64293,4831),(64294,4831),(64295,4832),(64296,4832),(64297,4832),(64298,4832),(64299,4833),(64300,4833),(64301,4833),(64302,4833),(64303,4834),(64304,4834),(64305,4834),(64306,4834),(64307,4834),(64308,4834),(64309,4835),(64310,4835),(64311,4835),(64312,4835),(64313,4835),(64314,4835),(64315,4836),(64316,4836),(64317,4836),(64318,4836),(64319,4836),(64320,4836),(64321,4837),(64322,4837),(64323,4837),(64324,4837),(64325,4837),(64326,4837),(64327,4838),(64328,4838),(64329,4838),(64330,4838),(64331,4838),(64332,4838),(64333,4839),(64334,4839),(64335,4839),(64336,4839),(64337,4839),(64338,4839),(64339,4840),(64340,4840),(64341,4840),(64342,4840),(64343,4840),(64344,4840),(64345,4841),(64346,4841),(64347,4841),(64348,4841),(64349,4841),(64350,4841),(64351,4842),(64352,4842),(64353,4842),(64354,4842),(64355,4842),(64356,4842),(64357,4843),(64358,4843),(64359,4843),(64360,4843),(64361,4843),(64362,4843),(64363,4844),(64364,4844),(64365,4844),(64366,4844),(64367,4845),(64368,4845),(64369,4845),(64370,4845),(64371,4845),(64372,4845),(64373,4846),(64374,4846),(64375,4846),(64376,4846),(64377,4846),(64378,4846),(64379,4847),(64380,4847),(64381,4847),(64382,4847),(64383,4847),(64384,4847),(64385,4848),(64386,4848),(64387,4848),(64388,4848),(64389,4848),(64390,4848),(64391,4849),(64392,4849),(64393,4849),(64394,4849),(64395,4849),(64396,4849),(64397,4850),(64398,4850),(64399,4850),(64400,4850),(64401,4850),(64402,4850),(64403,4851),(64404,4851),(64405,4851),(64406,4851),(64407,4851),(64408,4851),(64409,4852),(64410,4852),(64411,4852),(64412,4852),(64413,4852),(64414,4852),(64415,4853),(64416,4853),(64417,4853),(64418,4853),(64419,4853),(64420,4853),(64421,4854),(64422,4854),(64423,4854),(64424,4854),(64425,4854),(64426,4854),(64427,4855),(64428,4855),(64429,4855),(64430,4855),(64431,4855),(64432,4855),(64433,4856),(64434,4856),(64435,4856),(64436,4856),(64437,4856),(64438,4856),(64439,4857),(64440,4857),(64441,4857),(64442,4857),(64443,4857),(64444,4857),(64445,4858),(64446,4858),(64447,4858),(64448,4858),(64449,4858),(64450,4858),(64451,4859),(64452,4859),(64453,4859),(64454,4859),(64455,4859),(64456,4859),(64457,4860),(64458,4860),(64459,4860),(64460,4860),(64461,4860),(64462,4860),(64463,4861),(64464,4861),(64465,4861),(64466,4861),(64467,4861),(64468,4861),(64469,4862),(64470,4862),(64471,4862),(64472,4862),(64473,4862),(64474,4862),(64475,4863),(64476,4863),(64477,4863),(64478,4863),(64479,4863),(64480,4863),(64481,4864),(64482,4864),(64483,4864),(64484,4864),(64485,4864),(64486,4864),(64487,4865),(64488,4865),(64489,4865),(64490,4865),(64491,4865),(64492,4865),(64493,4866),(64494,4866),(64495,4866),(64496,4866),(64497,4866),(64498,4866),(64499,4867),(64500,4867),(64501,4867),(64502,4867),(64503,4867),(64504,4867),(64505,4868),(64506,4868),(64507,4868),(64508,4868),(64509,4868),(64510,4868),(64511,4869),(64512,4869),(64513,4869),(64514,4869),(64515,4869),(64516,4869),(64517,4870),(64518,4870),(64519,4870),(64520,4870),(64521,4870),(64522,4870),(64523,4871),(64524,4871),(64525,4871),(64526,4871),(64527,4871),(64528,4871),(64529,4872),(64530,4872),(64531,4872),(64532,4872),(64533,4872),(64534,4872),(64535,4873),(64536,4873),(64537,4873),(64538,4873),(64539,4873),(64540,4873),(64541,4874),(64542,4874),(64543,4874),(64544,4874),(64545,4874),(64546,4874),(64547,4875),(64548,4875),(64549,4875),(64550,4875),(64551,4875),(64552,4875),(64553,4876),(64554,4876),(64555,4876),(64556,4876),(64557,4876),(64558,4876),(64559,4877),(64560,4877),(64561,4877),(64562,4877),(64563,4877),(64564,4877),(64565,4878),(64566,4878),(64567,4878),(64568,4878),(64569,4878),(64570,4878),(64571,4879),(64572,4879),(64573,4879),(64574,4879),(64575,4879),(64576,4879),(64577,4780),(64578,4780),(64579,4780),(64580,4781),(64581,4781),(64582,4781),(64583,4782),(64584,4782),(64585,4782),(64586,4783),(64587,4783),(64588,4783),(64589,4784),(64590,4784),(64591,4784),(64592,4785),(64593,4785),(64594,4785),(64595,4786),(64596,4786),(64597,4786),(64598,4787),(64599,4787),(64600,4787),(64601,4788),(64602,4788),(64603,4788),(64604,4789),(64605,4789),(64606,4789),(64607,4790),(64608,4790),(64609,4790),(64610,4791),(64611,4791),(64612,4791),(64613,4792),(64614,4792),(64615,4792),(64616,4793),(64617,4793),(64618,4793),(64619,4794),(64620,4794),(64621,4794),(64622,4795),(64623,4795),(64624,4795),(64625,4796),(64626,4796),(64627,4796),(64628,4797),(64629,4797),(64630,4797),(64631,4798),(64632,4798),(64633,4798),(64634,4799),(64635,4799),(64636,4799),(64637,4800),(64638,4800),(64639,4800),(64640,4801),(64641,4801),(64642,4801),(64643,4802),(64644,4802),(64645,4802),(64646,4803),(64647,4803),(64648,4803),(64649,4804),(64650,4804),(64651,4804),(64652,4805),(64653,4805),(64654,4805),(64655,4806),(64656,4806),(64657,4806),(64658,4807),(64659,4807),(64660,4807),(64661,4808),(64662,4808),(64663,4808),(64664,4809),(64665,4809),(64666,4809),(64667,4810),(64668,4810),(64669,4810),(64670,4811),(64671,4811),(64672,4811),(64673,4812),(64674,4812),(64675,4812),(64676,4813),(64677,4813),(64678,4813),(64679,4814),(64680,4814),(64681,4814),(64682,4815),(64683,4815),(64684,4815),(64685,4816),(64686,4816),(64687,4816),(64688,4817),(64689,4817),(64690,4817),(64691,4818),(64692,4818),(64693,4818),(64694,4819),(64695,4819),(64696,4819),(64697,4820),(64698,4820),(64699,4820),(64700,4821),(64701,4821),(64702,4821),(64703,4822),(64704,4822),(64705,4822),(64706,4823),(64707,4823),(64708,4823),(64709,4824),(64710,4824),(64711,4824),(64712,4825),(64713,4825),(64714,4825),(64715,4826),(64716,4826),(64717,4826),(64718,4827),(64719,4827),(64720,4827),(64721,4828),(64722,4828),(64723,4828),(64724,4829),(64725,4829),(64726,4829),(64727,4830),(64728,4830),(64729,4830),(64730,4831),(64731,4831),(64732,4831),(64733,4832),(64734,4832),(64735,4832),(64736,4833),(64737,4833),(64738,4833),(64739,4834),(64740,4834),(64741,4834),(64742,4835),(64743,4835),(64744,4835),(64745,4836),(64746,4836),(64747,4836),(64748,4837),(64749,4837),(64750,4837),(64751,4838),(64752,4838),(64753,4838),(64754,4839),(64755,4839),(64756,4839),(64757,4840),(64758,4840),(64759,4840),(64760,4841),(64761,4841),(64762,4841),(64763,4842),(64764,4842),(64765,4842),(64766,4843),(64767,4843),(64768,4843),(64769,4844),(64770,4844),(64771,4844),(64772,4845),(64773,4845),(64774,4845),(64775,4846),(64776,4846),(64777,4846),(64778,4847),(64779,4847),(64780,4847),(64781,4848),(64782,4848),(64783,4848),(64784,4849),(64785,4849),(64786,4849),(64787,4850),(64788,4850),(64789,4850),(64790,4851),(64791,4851),(64792,4851),(64793,4852),(64794,4852),(64795,4852),(64796,4853),(64797,4853),(64798,4853),(64799,4854),(64800,4854),(64801,4854),(64802,4855),(64803,4855),(64804,4855),(64805,4856),(64806,4856),(64807,4856),(64808,4857),(64809,4857),(64810,4857),(64811,4858),(64812,4858),(64813,4858),(64814,4859),(64815,4859),(64816,4859),(64817,4860),(64818,4860),(64819,4860),(64820,4861),(64821,4861),(64822,4861),(64823,4862),(64824,4862),(64825,4862),(64826,4863),(64827,4863),(64828,4863),(64829,4864),(64830,4864),(64831,4864),(64832,4865),(64833,4865),(64834,4865),(64835,4866),(64836,4866),(64837,4866),(64838,4867),(64839,4867),(64840,4867),(64841,4868),(64842,4868),(64843,4868),(64844,4869),(64845,4869),(64846,4869),(64847,4870),(64848,4870),(64849,4870),(64850,4871),(64851,4871),(64852,4871),(64853,4872),(64854,4872),(64855,4872),(64856,4873),(64857,4873),(64858,4873),(64859,4874),(64860,4874),(64861,4874),(64862,4875),(64863,4875),(64864,4875),(64865,4876),(64866,4876),(64867,4876),(64868,4877),(64869,4877),(64870,4877),(64871,4878),(64872,4878),(64873,4878),(64874,4879),(64875,4879),(64876,4879),(64877,4780),(64878,4780),(64879,4780),(64880,4780),(64881,4781),(64882,4781),(64883,4781),(64884,4781),(64885,4782),(64886,4782),(64887,4782),(64888,4782),(64889,4783),(64890,4783),(64891,4783),(64892,4783),(64893,4784),(64894,4784),(64895,4784),(64896,4784),(64897,4785),(64898,4785),(64899,4785),(64900,4785),(64901,4786),(64902,4786),(64903,4786),(64904,4786),(64905,4787),(64906,4787),(64907,4787),(64908,4787),(64909,4788),(64910,4788),(64911,4788),(64912,4788),(64913,4789),(64914,4789),(64915,4789),(64916,4789),(64917,4790),(64918,4790),(64919,4790),(64920,4790),(64921,4791),(64922,4791),(64923,4791),(64924,4791),(64925,4792),(64926,4792),(64927,4792),(64928,4792),(64929,4793),(64930,4793),(64931,4793),(64932,4793),(64933,4794),(64934,4794),(64935,4794),(64936,4794),(64937,4795),(64938,4795),(64939,4795),(64940,4795),(64941,4796),(64942,4796),(64943,4796),(64944,4796),(64945,4797),(64946,4797),(64947,4797),(64948,4797),(64949,4798),(64950,4798),(64951,4798),(64952,4798),(64953,4799),(64954,4799),(64955,4799),(64956,4799),(64957,4800),(64958,4800),(64959,4800),(64960,4800),(64961,4801),(64962,4801),(64963,4801),(64964,4801),(64965,4802),(64966,4802),(64967,4802),(64968,4802),(64969,4803),(64970,4803),(64971,4803),(64972,4803),(64973,4804),(64974,4804),(64975,4804),(64976,4804),(64977,4805),(64978,4805),(64979,4805),(64980,4805),(64981,4806),(64982,4806),(64983,4806),(64984,4806),(64985,4807),(64986,4807),(64987,4807),(64988,4807),(64989,4808),(64990,4808),(64991,4808),(64992,4808),(64993,4809),(64994,4809),(64995,4809),(64996,4809),(64997,4810),(64998,4810),(64999,4810),(65000,4810),(65001,4811),(65002,4811),(65003,4811),(65004,4811),(65005,4812),(65006,4812),(65007,4812),(65008,4812),(65009,4813),(65010,4813),(65011,4813),(65012,4813),(65013,4814),(65014,4814),(65015,4814),(65016,4814),(65017,4815),(65018,4815),(65019,4815),(65020,4815),(65021,4816),(65022,4816),(65023,4816),(65024,4816),(65025,4817),(65026,4817),(65027,4817),(65028,4817),(65029,4818),(65030,4818),(65031,4818),(65032,4818),(65033,4819),(65034,4819),(65035,4819),(65036,4819),(65037,4820),(65038,4820),(65039,4820),(65040,4820),(65041,4821),(65042,4821),(65043,4821),(65044,4821),(65045,4822),(65046,4822),(65047,4822),(65048,4822),(65049,4823),(65050,4823),(65051,4823),(65052,4823),(65053,4824),(65054,4824),(65055,4824),(65056,4824),(65057,4825),(65058,4825),(65059,4825),(65060,4825),(65061,4826),(65062,4826),(65063,4826),(65064,4826),(65065,4827),(65066,4827),(65067,4827),(65068,4827),(65069,4828),(65070,4828),(65071,4828),(65072,4828),(65073,4829),(65074,4829),(65075,4829),(65076,4829),(65077,4830),(65078,4830),(65079,4830),(65080,4830),(65081,4831),(65082,4831),(65083,4831),(65084,4831),(65085,4832),(65086,4832),(65087,4832),(65088,4832),(65089,4833),(65090,4833),(65091,4833),(65092,4833),(65093,4834),(65094,4834),(65095,4834),(65096,4834),(65097,4835),(65098,4835),(65099,4835),(65100,4835),(65101,4836),(65102,4836),(65103,4836),(65104,4836),(65105,4837),(65106,4837),(65107,4837),(65108,4837),(65109,4838),(65110,4838),(65111,4838),(65112,4838),(65113,4839),(65114,4839),(65115,4839),(65116,4839),(65117,4840),(65118,4840),(65119,4840),(65120,4840),(65121,4841),(65122,4841),(65123,4841),(65124,4841),(65125,4842),(65126,4842),(65127,4842),(65128,4842),(65129,4843),(65130,4843),(65131,4843),(65132,4843),(65133,4844),(65134,4844),(65135,4844),(65136,4844),(65137,4845),(65138,4845),(65139,4845),(65140,4845),(65141,4846),(65142,4846),(65143,4846),(65144,4846),(65145,4847),(65146,4847),(65147,4847),(65148,4847),(65149,4848),(65150,4848),(65151,4848),(65152,4848),(65153,4849),(65154,4849),(65155,4849),(65156,4849),(65157,4850),(65158,4850),(65159,4850),(65160,4850),(65161,4851),(65162,4851),(65163,4851),(65164,4851),(65165,4852),(65166,4852),(65167,4852),(65168,4852),(65169,4853),(65170,4853),(65171,4853),(65172,4853),(65173,4854),(65174,4854),(65175,4854),(65176,4854),(65177,4855),(65178,4855),(65179,4855),(65180,4855),(65181,4856),(65182,4856),(65183,4856),(65184,4856),(65185,4857),(65186,4857),(65187,4857),(65188,4857),(65189,4858),(65190,4858),(65191,4858),(65192,4858),(65193,4859),(65194,4859),(65195,4859),(65196,4859),(65197,4860),(65198,4860),(65199,4860),(65200,4860),(65201,4861),(65202,4861),(65203,4861),(65204,4861),(65205,4862),(65206,4862),(65207,4862),(65208,4862),(65209,4863),(65210,4863),(65211,4863),(65212,4863),(65213,4864),(65214,4864),(65215,4864),(65216,4864),(65217,4865),(65218,4865),(65219,4865),(65220,4865),(65221,4866),(65222,4866),(65223,4866),(65224,4866),(65225,4867),(65226,4867),(65227,4867),(65228,4867),(65229,4868),(65230,4868),(65231,4868),(65232,4868),(65233,4869),(65234,4869),(65235,4869),(65236,4869),(65237,4870),(65238,4870),(65239,4870),(65240,4870),(65241,4871),(65242,4871),(65243,4871),(65244,4871),(65245,4872),(65246,4872),(65247,4872),(65248,4872),(65249,4873),(65250,4873),(65251,4873),(65252,4873),(65253,4874),(65254,4874),(65255,4874),(65256,4874),(65257,4875),(65258,4875),(65259,4875),(65260,4875),(65261,4876),(65262,4876),(65263,4876),(65264,4876),(65265,4877),(65266,4877),(65267,4877),(65268,4877),(65269,4878),(65270,4878),(65271,4878),(65272,4878),(65273,4879),(65274,4879),(65275,4879),(65276,4879),(65277,4880),(65278,4880),(65279,4880),(65280,4880),(65281,4880),(65282,4880),(65283,4881),(65284,4881),(65285,4881),(65286,4881),(65287,4881),(65288,4881),(65289,4882),(65290,4882),(65291,4882),(65292,4882),(65293,4882),(65294,4882),(65295,4883),(65296,4883),(65297,4883),(65298,4883),(65299,4883),(65300,4883),(65301,4884),(65302,4884),(65303,4884),(65304,4884),(65305,4884),(65306,4884),(65307,4885),(65308,4885),(65309,4885),(65310,4885),(65311,4885),(65312,4885),(65313,4886),(65314,4886),(65315,4886),(65316,4886),(65317,4886),(65318,4886),(65319,4887),(65320,4887),(65321,4887),(65322,4887),(65323,4887),(65324,4887),(65325,4888),(65326,4888),(65327,4888),(65328,4888),(65329,4888),(65330,4888),(65331,4889),(65332,4889),(65333,4889),(65334,4889),(65335,4889),(65336,4889),(65337,4890),(65338,4890),(65339,4890),(65340,4890),(65341,4890),(65342,4890),(65343,4891),(65344,4891),(65345,4891),(65346,4891),(65347,4891),(65348,4891),(65349,4892),(65350,4892),(65351,4892),(65352,4892),(65353,4892),(65354,4892),(65355,4893),(65356,4893),(65357,4893),(65358,4893),(65359,4893),(65360,4893),(65361,4894),(65362,4894),(65363,4894),(65364,4894),(65365,4894),(65366,4894),(65367,4895),(65368,4895),(65369,4895),(65370,4895),(65371,4895),(65372,4895),(65373,4896),(65374,4896),(65375,4896),(65376,4896),(65377,4896),(65378,4896),(65379,4897),(65380,4897),(65381,4897),(65382,4897),(65383,4897),(65384,4897),(65385,4898),(65386,4898),(65387,4898),(65388,4898),(65389,4898),(65390,4898),(65391,4899),(65392,4899),(65393,4899),(65394,4899),(65395,4899),(65396,4899),(65397,4900),(65398,4900),(65399,4900),(65400,4900),(65401,4900),(65402,4900),(65403,4901),(65404,4901),(65405,4901),(65406,4901),(65407,4901),(65408,4901),(65409,4902),(65410,4902),(65411,4902),(65412,4902),(65413,4902),(65414,4902),(65415,4903),(65416,4903),(65417,4903),(65418,4903),(65419,4903),(65420,4903),(65421,4904),(65422,4904),(65423,4904),(65424,4904),(65425,4904),(65426,4904),(65427,4905),(65428,4905),(65429,4905),(65430,4905),(65431,4905),(65432,4905),(65433,4906),(65434,4906),(65435,4906),(65436,4906),(65437,4906),(65438,4906),(65439,4907),(65440,4907),(65441,4907),(65442,4907),(65443,4907),(65444,4907),(65445,4908),(65446,4908),(65447,4908),(65448,4908),(65449,4908),(65450,4908),(65451,4909),(65452,4909),(65453,4909),(65454,4909),(65455,4909),(65456,4909),(65457,4910),(65458,4910),(65459,4910),(65460,4910),(65461,4910),(65462,4910),(65463,4911),(65464,4911),(65465,4911),(65466,4911),(65467,4911),(65468,4911),(65469,4912),(65470,4912),(65471,4912),(65472,4912),(65473,4912),(65474,4912),(65475,4913),(65476,4913),(65477,4913),(65478,4913),(65479,4913),(65480,4913),(65481,4914),(65482,4914),(65483,4914),(65484,4914),(65485,4914),(65486,4914),(65487,4915),(65488,4915),(65489,4915),(65490,4915),(65491,4915),(65492,4915),(65493,4916),(65494,4916),(65495,4916),(65496,4916),(65497,4916),(65498,4916),(65499,4917),(65500,4917),(65501,4917),(65502,4917),(65503,4917),(65504,4917),(65505,4918),(65506,4918),(65507,4918),(65508,4918),(65509,4918),(65510,4918),(65511,4919),(65512,4919),(65513,4919),(65514,4919),(65515,4919),(65516,4919),(65517,4920),(65518,4920),(65519,4920),(65520,4920),(65521,4920),(65522,4920),(65523,4921),(65524,4921),(65525,4921),(65526,4921),(65527,4921),(65528,4921),(65529,4922),(65530,4922),(65531,4922),(65532,4922),(65533,4922),(65534,4922),(65535,4923),(65536,4923),(65537,4923),(65538,4923),(65539,4923),(65540,4923),(65541,4924),(65542,4924),(65543,4924),(65544,4924),(65545,4925),(65546,4925),(65547,4925),(65548,4925),(65549,4926),(65550,4926),(65551,4926),(65552,4926),(65553,4927),(65554,4927),(65555,4927),(65556,4927),(65557,4928),(65558,4928),(65559,4928),(65560,4928),(65561,4929),(65562,4929),(65563,4929),(65564,4929),(65565,4930),(65566,4930),(65567,4930),(65568,4930),(65569,4931),(65570,4931),(65571,4931),(65572,4931),(65573,4932),(65574,4932),(65575,4932),(65576,4932),(65577,4933),(65578,4933),(65579,4933),(65580,4933),(65581,4933),(65582,4933),(65583,4934),(65584,4934),(65585,4934),(65586,4934),(65587,4935),(65588,4935),(65589,4935),(65590,4935),(65591,4936),(65592,4936),(65593,4936),(65594,4936),(65595,4937),(65596,4937),(65597,4937),(65598,4937),(65599,4938),(65600,4938),(65601,4938),(65602,4938),(65603,4939),(65604,4939),(65605,4939),(65606,4939),(65607,4940),(65608,4940),(65609,4940),(65610,4940),(65611,4941),(65612,4941),(65613,4941),(65614,4941),(65615,4942),(65616,4942),(65617,4942),(65618,4942),(65619,4942),(65620,4942),(65621,4943),(65622,4943),(65623,4943),(65624,4943),(65625,4943),(65626,4943),(65627,4944),(65628,4944),(65629,4944),(65630,4944),(65631,4944),(65632,4944),(65633,4945),(65634,4945),(65635,4945),(65636,4945),(65637,4945),(65638,4945),(65639,4946),(65640,4946),(65641,4946),(65642,4946),(65643,4946),(65644,4946),(65645,4947),(65646,4947),(65647,4947),(65648,4947),(65649,4947),(65650,4947),(65651,4948),(65652,4948),(65653,4948),(65654,4948),(65655,4948),(65656,4948),(65657,4949),(65658,4949),(65659,4949),(65660,4949),(65661,4949),(65662,4949),(65663,4950),(65664,4950),(65665,4950),(65666,4950),(65667,4950),(65668,4950),(65669,4951),(65670,4951),(65671,4951),(65672,4951),(65673,4951),(65674,4951),(65675,4952),(65676,4952),(65677,4952),(65678,4952),(65679,4952),(65680,4952),(65681,4953),(65682,4953),(65683,4953),(65684,4953),(65685,4953),(65686,4953),(65687,4954),(65688,4954),(65689,4954),(65690,4954),(65691,4954),(65692,4955),(65693,4955),(65694,4955),(65695,4955),(65696,4955),(65697,4955),(65698,4956),(65699,4956),(65700,4956),(65701,4956),(65702,4956),(65703,4956),(65704,4957),(65705,4957),(65706,4957),(65707,4957),(65708,4957),(65709,4957),(65710,4958),(65711,4958),(65712,4958),(65713,4958),(65714,4958),(65715,4958),(65716,4959),(65717,4959),(65718,4959),(65719,4959),(65720,4959),(65721,4959),(65722,4960),(65723,4960),(65724,4960),(65725,4960),(65726,4960),(65727,4960),(65728,4961),(65729,4961),(65730,4961),(65731,4961),(65732,4961),(65733,4961),(65734,4962),(65735,4962),(65736,4962),(65737,4962),(65738,4962),(65739,4962),(65740,4963),(65741,4963),(65742,4963),(65743,4963),(65744,4964),(65745,4964),(65746,4964),(65747,4964),(65748,4965),(65749,4965),(65750,4965),(65751,4965),(65752,4965),(65753,4965),(65754,4966),(65755,4966),(65756,4966),(65757,4966),(65758,4966),(65759,4966),(65760,4967),(65761,4967),(65762,4967),(65763,4967),(65764,4967),(65765,4967),(65766,4968),(65767,4968),(65768,4968),(65769,4968),(65770,4968),(65771,4968),(65772,4969),(65773,4969),(65774,4969),(65775,4969),(65776,4969),(65777,4969),(65778,4970),(65779,4970),(65780,4970),(65781,4970),(65782,4970),(65783,4970),(65784,4971),(65785,4971),(65786,4971),(65787,4971),(65788,4971),(65789,4971),(65790,4972),(65791,4972),(65792,4972),(65793,4972),(65794,4972),(65795,4972),(65796,4973),(65797,4973),(65798,4973),(65799,4973),(65800,4973),(65801,4973),(65802,4974),(65803,4974),(65804,4974),(65805,4974),(65806,4974),(65807,4974),(65808,4975),(65809,4975),(65810,4975),(65811,4975),(65812,4975),(65813,4975),(65814,4976),(65815,4976),(65816,4976),(65817,4976),(65818,4976),(65819,4976),(65820,4977),(65821,4977),(65822,4977),(65823,4977),(65824,4977),(65825,4977),(65826,4978),(65827,4978),(65828,4978),(65829,4978),(65830,4978),(65831,4978),(65832,4979),(65833,4979),(65834,4979),(65835,4979),(65836,4979),(65837,4979),(65838,4880),(65839,4880),(65840,4880),(65841,4881),(65842,4881),(65843,4881),(65844,4882),(65845,4882),(65846,4882),(65847,4883),(65848,4883),(65849,4883),(65850,4884),(65851,4884),(65852,4884),(65853,4885),(65854,4885),(65855,4885),(65856,4886),(65857,4886),(65858,4886),(65859,4887),(65860,4887),(65861,4887),(65862,4888),(65863,4888),(65864,4888),(65865,4889),(65866,4889),(65867,4889),(65868,4890),(65869,4890),(65870,4890),(65871,4891),(65872,4891),(65873,4891),(65874,4892),(65875,4892),(65876,4892),(65877,4893),(65878,4893),(65879,4893),(65880,4894),(65881,4894),(65882,4894),(65883,4895),(65884,4895),(65885,4895),(65886,4896),(65887,4896),(65888,4896),(65889,4897),(65890,4897),(65891,4897),(65892,4898),(65893,4898),(65894,4898),(65895,4899),(65896,4899),(65897,4899),(65898,4900),(65899,4900),(65900,4900),(65901,4901),(65902,4901),(65903,4901),(65904,4902),(65905,4902),(65906,4902),(65907,4903),(65908,4903),(65909,4903),(65910,4904),(65911,4904),(65912,4904),(65913,4905),(65914,4905),(65915,4905),(65916,4906),(65917,4906),(65918,4906),(65919,4907),(65920,4907),(65921,4907),(65922,4908),(65923,4908),(65924,4908),(65925,4909),(65926,4909),(65927,4909),(65928,4910),(65929,4910),(65930,4910),(65931,4911),(65932,4911),(65933,4911),(65934,4912),(65935,4912),(65936,4912),(65937,4913),(65938,4913),(65939,4913),(65940,4914),(65941,4914),(65942,4914),(65943,4915),(65944,4915),(65945,4915),(65946,4916),(65947,4916),(65948,4916),(65949,4917),(65950,4917),(65951,4917),(65952,4918),(65953,4918),(65954,4918),(65955,4919),(65956,4919),(65957,4919),(65958,4920),(65959,4920),(65960,4920),(65961,4921),(65962,4921),(65963,4921),(65964,4922),(65965,4922),(65966,4922),(65967,4923),(65968,4923),(65969,4923),(65970,4924),(65971,4924),(65972,4924),(65973,4925),(65974,4925),(65975,4925),(65976,4926),(65977,4926),(65978,4926),(65979,4927),(65980,4927),(65981,4927),(65982,4928),(65983,4928),(65984,4928),(65985,4929),(65986,4929),(65987,4929),(65988,4930),(65989,4930),(65990,4930),(65991,4931),(65992,4931),(65993,4931),(65994,4932),(65995,4932),(65996,4932),(65997,4933),(65998,4933),(65999,4933),(66000,4934),(66001,4934),(66002,4934),(66003,4935),(66004,4935),(66005,4935),(66006,4936),(66007,4936),(66008,4936),(66009,4937),(66010,4937),(66011,4937),(66012,4938),(66013,4938),(66014,4938),(66015,4939),(66016,4939),(66017,4939),(66018,4940),(66019,4940),(66020,4940),(66021,4941),(66022,4941),(66023,4941),(66024,4942),(66025,4942),(66026,4942),(66027,4943),(66028,4943),(66029,4943),(66030,4944),(66031,4944),(66032,4944),(66033,4945),(66034,4945),(66035,4945),(66036,4946),(66037,4946),(66038,4946),(66039,4947),(66040,4947),(66041,4947),(66042,4948),(66043,4948),(66044,4948),(66045,4949),(66046,4949),(66047,4949),(66048,4950),(66049,4950),(66050,4950),(66051,4951),(66052,4951),(66053,4951),(66054,4952),(66055,4952),(66056,4952),(66057,4953),(66058,4953),(66059,4953),(66060,4954),(66061,4954),(66062,4954),(66063,4955),(66064,4955),(66065,4955),(66066,4956),(66067,4956),(66068,4956),(66069,4957),(66070,4957),(66071,4957),(66072,4958),(66073,4958),(66074,4958),(66075,4959),(66076,4959),(66077,4959),(66078,4960),(66079,4960),(66080,4960),(66081,4961),(66082,4961),(66083,4961),(66084,4962),(66085,4962),(66086,4962),(66087,4963),(66088,4963),(66089,4963),(66090,4964),(66091,4964),(66092,4964),(66093,4965),(66094,4965),(66095,4965),(66096,4966),(66097,4966),(66098,4966),(66099,4967),(66100,4967),(66101,4967),(66102,4968),(66103,4968),(66104,4968),(66105,4969),(66106,4969),(66107,4969),(66108,4970),(66109,4970),(66110,4970),(66111,4971),(66112,4971),(66113,4971),(66114,4972),(66115,4972),(66116,4972),(66117,4973),(66118,4973),(66119,4973),(66120,4974),(66121,4974),(66122,4974),(66123,4975),(66124,4975),(66125,4975),(66126,4976),(66127,4976),(66128,4976),(66129,4977),(66130,4977),(66131,4977),(66132,4978),(66133,4978),(66134,4978),(66135,4979),(66136,4979),(66137,4979),(66138,4880),(66139,4880),(66140,4880),(66141,4880),(66142,4881),(66143,4881),(66144,4881),(66145,4881),(66146,4882),(66147,4882),(66148,4882),(66149,4882),(66150,4883),(66151,4883),(66152,4883),(66153,4883),(66154,4884),(66155,4884),(66156,4884),(66157,4884),(66158,4885),(66159,4885),(66160,4885),(66161,4885),(66162,4886),(66163,4886),(66164,4886),(66165,4886),(66166,4887),(66167,4887),(66168,4887),(66169,4887),(66170,4888),(66171,4888),(66172,4888),(66173,4888),(66174,4889),(66175,4889),(66176,4889),(66177,4889),(66178,4890),(66179,4890),(66180,4890),(66181,4890),(66182,4891),(66183,4891),(66184,4891),(66185,4891),(66186,4892),(66187,4892),(66188,4892),(66189,4892),(66190,4893),(66191,4893),(66192,4893),(66193,4893),(66194,4894),(66195,4894),(66196,4894),(66197,4894),(66198,4895),(66199,4895),(66200,4895),(66201,4895),(66202,4896),(66203,4896),(66204,4896),(66205,4896),(66206,4897),(66207,4897),(66208,4897),(66209,4897),(66210,4898),(66211,4898),(66212,4898),(66213,4898),(66214,4899),(66215,4899),(66216,4899),(66217,4899),(66218,4900),(66219,4900),(66220,4900),(66221,4900),(66222,4901),(66223,4901),(66224,4901),(66225,4901),(66226,4902),(66227,4902),(66228,4902),(66229,4902),(66230,4903),(66231,4903),(66232,4903),(66233,4903),(66234,4904),(66235,4904),(66236,4904),(66237,4904),(66238,4905),(66239,4905),(66240,4905),(66241,4905),(66242,4906),(66243,4906),(66244,4906),(66245,4906),(66246,4907),(66247,4907),(66248,4907),(66249,4907),(66250,4908),(66251,4908),(66252,4908),(66253,4908),(66254,4909),(66255,4909),(66256,4909),(66257,4909),(66258,4910),(66259,4910),(66260,4910),(66261,4910),(66262,4911),(66263,4911),(66264,4911),(66265,4911),(66266,4912),(66267,4912),(66268,4912),(66269,4912),(66270,4913),(66271,4913),(66272,4913),(66273,4913),(66274,4914),(66275,4914),(66276,4914),(66277,4914),(66278,4915),(66279,4915),(66280,4915),(66281,4915),(66282,4916),(66283,4916),(66284,4916),(66285,4916),(66286,4917),(66287,4917),(66288,4917),(66289,4917),(66290,4918),(66291,4918),(66292,4918),(66293,4918),(66294,4919),(66295,4919),(66296,4919),(66297,4919),(66298,4920),(66299,4920),(66300,4920),(66301,4920),(66302,4921),(66303,4921),(66304,4921),(66305,4921),(66306,4922),(66307,4922),(66308,4922),(66309,4922),(66310,4923),(66311,4923),(66312,4923),(66313,4923),(66314,4924),(66315,4924),(66316,4924),(66317,4924),(66318,4925),(66319,4925),(66320,4925),(66321,4925),(66322,4926),(66323,4926),(66324,4926),(66325,4926),(66326,4927),(66327,4927),(66328,4927),(66329,4927),(66330,4928),(66331,4928),(66332,4928),(66333,4928),(66334,4929),(66335,4929),(66336,4929),(66337,4929),(66338,4930),(66339,4930),(66340,4930),(66341,4930),(66342,4931),(66343,4931),(66344,4931),(66345,4931),(66346,4932),(66347,4932),(66348,4932),(66349,4932),(66350,4933),(66351,4933),(66352,4933),(66353,4933),(66354,4934),(66355,4934),(66356,4934),(66357,4934),(66358,4935),(66359,4935),(66360,4935),(66361,4935),(66362,4936),(66363,4936),(66364,4936),(66365,4936),(66366,4937),(66367,4937),(66368,4937),(66369,4937),(66370,4938),(66371,4938),(66372,4938),(66373,4938),(66374,4939),(66375,4939),(66376,4939),(66377,4939),(66378,4940),(66379,4940),(66380,4940),(66381,4940),(66382,4941),(66383,4941),(66384,4941),(66385,4941),(66386,4942),(66387,4942),(66388,4942),(66389,4942),(66390,4943),(66391,4943),(66392,4943),(66393,4943),(66394,4944),(66395,4944),(66396,4944),(66397,4944),(66398,4945),(66399,4945),(66400,4945),(66401,4945),(66402,4946),(66403,4946),(66404,4946),(66405,4946),(66406,4947),(66407,4947),(66408,4947),(66409,4947),(66410,4948),(66411,4948),(66412,4948),(66413,4948),(66414,4949),(66415,4949),(66416,4949),(66417,4949),(66418,4950),(66419,4950),(66420,4950),(66421,4950),(66422,4951),(66423,4951),(66424,4951),(66425,4951),(66426,4952),(66427,4952),(66428,4952),(66429,4952),(66430,4953),(66431,4953),(66432,4953),(66433,4953),(66434,4954),(66435,4954),(66436,4954),(66437,4954),(66438,4955),(66439,4955),(66440,4955),(66441,4955),(66442,4956),(66443,4956),(66444,4956),(66445,4956),(66446,4957),(66447,4957),(66448,4957),(66449,4957),(66450,4958),(66451,4958),(66452,4958),(66453,4958),(66454,4959),(66455,4959),(66456,4959),(66457,4959),(66458,4960),(66459,4960),(66460,4960),(66461,4960),(66462,4961),(66463,4961),(66464,4961),(66465,4961),(66466,4962),(66467,4962),(66468,4962),(66469,4962),(66470,4963),(66471,4963),(66472,4963),(66473,4963),(66474,4964),(66475,4964),(66476,4964),(66477,4964),(66478,4965),(66479,4965),(66480,4965),(66481,4965),(66482,4966),(66483,4966),(66484,4966),(66485,4966),(66486,4967),(66487,4967),(66488,4967),(66489,4967),(66490,4968),(66491,4968),(66492,4968),(66493,4968),(66494,4969),(66495,4969),(66496,4969),(66497,4969),(66498,4970),(66499,4970),(66500,4970),(66501,4970),(66502,4971),(66503,4971),(66504,4971),(66505,4971),(66506,4972),(66507,4972),(66508,4972),(66509,4972),(66510,4973),(66511,4973),(66512,4973),(66513,4973),(66514,4974),(66515,4974),(66516,4974),(66517,4974),(66518,4975),(66519,4975),(66520,4975),(66521,4975),(66522,4976),(66523,4976),(66524,4976),(66525,4976),(66526,4977),(66527,4977),(66528,4977),(66529,4977),(66530,4978),(66531,4978),(66532,4978),(66533,4978),(66534,4979),(66535,4979),(66536,4979),(66537,4979),(66538,4980),(66539,4980),(66540,4980),(66541,4980),(66542,4980),(66543,4980),(66544,4981),(66545,4981),(66546,4981),(66547,4981),(66548,4981),(66549,4981),(66550,4982),(66551,4982),(66552,4982),(66553,4982),(66554,4982),(66555,4982),(66556,4983),(66557,4983),(66558,4983),(66559,4983),(66560,4983),(66561,4983),(66562,4984),(66563,4984),(66564,4984),(66565,4984),(66566,4984),(66567,4984),(66568,4985),(66569,4985),(66570,4985),(66571,4985),(66572,4985),(66573,4985),(66574,4986),(66575,4986),(66576,4986),(66577,4986),(66578,4986),(66579,4986),(66580,4987),(66581,4987),(66582,4987),(66583,4987),(66584,4987),(66585,4987),(66586,4988),(66587,4988),(66588,4988),(66589,4988),(66590,4988),(66591,4988),(66592,4989),(66593,4989),(66594,4989),(66595,4989),(66596,4989),(66597,4989),(66598,4990),(66599,4990),(66600,4990),(66601,4990),(66602,4990),(66603,4990),(66604,4991),(66605,4991),(66606,4991),(66607,4991),(66608,4991),(66609,4991),(66610,4992),(66611,4992),(66612,4992),(66613,4992),(66614,4992),(66615,4992),(66616,4993),(66617,4993),(66618,4993),(66619,4993),(66620,4993),(66621,4993),(66622,4994),(66623,4994),(66624,4994),(66625,4994),(66626,4994),(66627,4994),(66628,4995),(66629,4995),(66630,4995),(66631,4995),(66632,4995),(66633,4995),(66634,4996),(66635,4996),(66636,4996),(66637,4996),(66638,4996),(66639,4996),(66640,4997),(66641,4997),(66642,4997),(66643,4997),(66644,4997),(66645,4997),(66646,4998),(66647,4998),(66648,4998),(66649,4998),(66650,4998),(66651,4998),(66652,4999),(66653,4999),(66654,4999),(66655,4999),(66656,4999),(66657,4999),(66658,5000),(66659,5000),(66660,5000),(66661,5000),(66662,5000),(66663,5000),(66664,5001),(66665,5001),(66666,5001),(66667,5001),(66668,5001),(66669,5001),(66670,5002),(66671,5002),(66672,5002),(66673,5002),(66674,5002),(66675,5002),(66676,5003),(66677,5003),(66678,5003),(66679,5003),(66680,5003),(66681,5003),(66682,5004),(66683,5004),(66684,5004),(66685,5004),(66686,5004),(66687,5004),(66688,5005),(66689,5005),(66690,5005),(66691,5005),(66692,5005),(66693,5005),(66694,5006),(66695,5006),(66696,5006),(66697,5006),(66698,5006),(66699,5006),(66700,5007),(66701,5007),(66702,5007),(66703,5007),(66704,5007),(66705,5007),(66706,5008),(66707,5008),(66708,5008),(66709,5008),(66710,5008),(66711,5008),(66712,5009),(66713,5009),(66714,5009),(66715,5009),(66716,5009),(66717,5009),(66718,5010),(66719,5010),(66720,5010),(66721,5010),(66722,5010),(66723,5010),(66724,5011),(66725,5011),(66726,5011),(66727,5011),(66728,5011),(66729,5011),(66730,5012),(66731,5012),(66732,5012),(66733,5012),(66734,5012),(66735,5012),(66736,5013),(66737,5013),(66738,5013),(66739,5013),(66740,5013),(66741,5013),(66742,5014),(66743,5014),(66744,5014),(66745,5014),(66746,5014),(66747,5014),(66748,5015),(66749,5015),(66750,5015),(66751,5015),(66752,5015),(66753,5015),(66754,5016),(66755,5016),(66756,5016),(66757,5016),(66758,5016),(66759,5016),(66760,5017),(66761,5017),(66762,5017),(66763,5017),(66764,5017),(66765,5017),(66766,5018),(66767,5018),(66768,5018),(66769,5018),(66770,5018),(66771,5018),(66772,5019),(66773,5019),(66774,5019),(66775,5019),(66776,5019),(66777,5019),(66778,5020),(66779,5020),(66780,5020),(66781,5020),(66782,5020),(66783,5020),(66784,5021),(66785,5021),(66786,5021),(66787,5021),(66788,5021),(66789,5021),(66790,5022),(66791,5022),(66792,5022),(66793,5022),(66794,5022),(66795,5022),(66796,5023),(66797,5023),(66798,5023),(66799,5023),(66800,5023),(66801,5023),(66802,5024),(66803,5024),(66804,5024),(66805,5024),(66806,5024),(66807,5024),(66808,5025),(66809,5025),(66810,5025),(66811,5025),(66812,5025),(66813,5025),(66814,5026),(66815,5026),(66816,5026),(66817,5026),(66818,5026),(66819,5026),(66820,5027),(66821,5027),(66822,5027),(66823,5027),(66824,5027),(66825,5027),(66826,5028),(66827,5028),(66828,5028),(66829,5028),(66830,5028),(66831,5028),(66832,5029),(66833,5029),(66834,5029),(66835,5029),(66836,5029),(66837,5029),(66838,5030),(66839,5030),(66840,5030),(66841,5030),(66842,5030),(66843,5030),(66844,5031),(66845,5031),(66846,5031),(66847,5031),(66848,5031),(66849,5031),(66850,5032),(66851,5032),(66852,5032),(66853,5032),(66854,5032),(66855,5032),(66856,5033),(66857,5033),(66858,5033),(66859,5033),(66860,5033),(66861,5033),(66862,5034),(66863,5034),(66864,5034),(66865,5034),(66866,5034),(66867,5034),(66868,5035),(66869,5035),(66870,5035),(66871,5035),(66872,5035),(66873,5035),(66874,5036),(66875,5036),(66876,5036),(66877,5036),(66878,5036),(66879,5036),(66880,5037),(66881,5037),(66882,5037),(66883,5037),(66884,5038),(66885,5038),(66886,5038),(66887,5038),(66888,5039),(66889,5039),(66890,5039),(66891,5039),(66892,5039),(66893,5039),(66894,5040),(66895,5040),(66896,5040),(66897,5040),(66898,5040),(66899,5040),(66900,5041),(66901,5041),(66902,5041),(66903,5041),(66904,5041),(66905,5041),(66906,5042),(66907,5042),(66908,5042),(66909,5042),(66910,5042),(66911,5042),(66912,5043),(66913,5043),(66914,5043),(66915,5043),(66916,5043),(66917,5043),(66918,5044),(66919,5044),(66920,5044),(66921,5044),(66922,5044),(66923,5044),(66924,5045),(66925,5045),(66926,5045),(66927,5045),(66928,5045),(66929,5045),(66930,5046),(66931,5046),(66932,5046),(66933,5046),(66934,5046),(66935,5046),(66936,5047),(66937,5047),(66938,5047),(66939,5047),(66940,5047),(66941,5047),(66942,5048),(66943,5048),(66944,5048),(66945,5048),(66946,5048),(66947,5048),(66948,5049),(66949,5049),(66950,5049),(66951,5049),(66952,5049),(66953,5049),(66954,5050),(66955,5050),(66956,5050),(66957,5050),(66958,5050),(66959,5050),(66960,5051),(66961,5051),(66962,5051),(66963,5051),(66964,5051),(66965,5051),(66966,5052),(66967,5052),(66968,5052),(66969,5052),(66970,5052),(66971,5052),(66972,5053),(66973,5053),(66974,5053),(66975,5053),(66976,5053),(66977,5053),(66978,5054),(66979,5054),(66980,5054),(66981,5054),(66982,5054),(66983,5054),(66984,5055),(66985,5055),(66986,5055),(66987,5055),(66988,5055),(66989,5055),(66990,5056),(66991,5056),(66992,5056),(66993,5056),(66994,5056),(66995,5056),(66996,5057),(66997,5057),(66998,5057),(66999,5057),(67000,5057),(67001,5057),(67002,5058),(67003,5058),(67004,5058),(67005,5058),(67006,5058),(67007,5058),(67008,5059),(67009,5059),(67010,5059),(67011,5059),(67012,5059),(67013,5059),(67014,5060),(67015,5060),(67016,5060),(67017,5060),(67018,5060),(67019,5060),(67020,5061),(67021,5061),(67022,5061),(67023,5061),(67024,5061),(67025,5061),(67026,5062),(67027,5062),(67028,5062),(67029,5062),(67030,5063),(67031,5063),(67032,5063),(67033,5063),(67034,5064),(67035,5064),(67036,5064),(67037,5064),(67038,5065),(67039,5065),(67040,5065),(67041,5065),(67042,5065),(67043,5065),(67044,5066),(67045,5066),(67046,5066),(67047,5066),(67048,5066),(67049,5066),(67050,5067),(67051,5067),(67052,5067),(67053,5067),(67054,5068),(67055,5068),(67056,5068),(67057,5068),(67058,5069),(67059,5069),(67060,5069),(67061,5069),(67062,5070),(67063,5070),(67064,5070),(67065,5070),(67066,5070),(67067,5070),(67068,5071),(67069,5071),(67070,5071),(67071,5071),(67072,5071),(67073,5071),(67074,5072),(67075,5072),(67076,5072),(67077,5072),(67078,5072),(67079,5072),(67080,5073),(67081,5073),(67082,5073),(67083,5073),(67084,5074),(67085,5074),(67086,5074),(67087,5074),(67088,5075),(67089,5075),(67090,5075),(67091,5075),(67092,5076),(67093,5076),(67094,5076),(67095,5076),(67096,5077),(67097,5077),(67098,5077),(67099,5077),(67100,5077),(67101,5077),(67102,5078),(67103,5078),(67104,5078),(67105,5078),(67106,5078),(67107,5078),(67108,5079),(67109,5079),(67110,5079),(67111,5079),(67112,5079),(67113,5079),(67114,4980),(67115,4980),(67116,4980),(67117,4981),(67118,4981),(67119,4981),(67120,4982),(67121,4982),(67122,4982),(67123,4983),(67124,4983),(67125,4983),(67126,4984),(67127,4984),(67128,4984),(67129,4985),(67130,4985),(67131,4985),(67132,4986),(67133,4986),(67134,4986),(67135,4987),(67136,4987),(67137,4987),(67138,4988),(67139,4988),(67140,4988),(67141,4989),(67142,4989),(67143,4989),(67144,4990),(67145,4990),(67146,4990),(67147,4991),(67148,4991),(67149,4991),(67150,4992),(67151,4992),(67152,4992),(67153,4993),(67154,4993),(67155,4993),(67156,4994),(67157,4994),(67158,4994),(67159,4995),(67160,4995),(67161,4995),(67162,4996),(67163,4996),(67164,4996),(67165,4997),(67166,4997),(67167,4997),(67168,4998),(67169,4998),(67170,4998),(67171,4999),(67172,4999),(67173,4999),(67174,5000),(67175,5000),(67176,5000),(67177,5001),(67178,5001),(67179,5001),(67180,5002),(67181,5002),(67182,5002),(67183,5003),(67184,5003),(67185,5003),(67186,5004),(67187,5004),(67188,5004),(67189,5005),(67190,5005),(67191,5005),(67192,5006),(67193,5006),(67194,5006),(67195,5007),(67196,5007),(67197,5007),(67198,5008),(67199,5008),(67200,5008),(67201,5009),(67202,5009),(67203,5009),(67204,5010),(67205,5010),(67206,5010),(67207,5011),(67208,5011),(67209,5011),(67210,5012),(67211,5012),(67212,5012),(67213,5013),(67214,5013),(67215,5013),(67216,5014),(67217,5014),(67218,5014),(67219,5015),(67220,5015),(67221,5015),(67222,5016),(67223,5016),(67224,5016),(67225,5017),(67226,5017),(67227,5017),(67228,5018),(67229,5018),(67230,5018),(67231,5019),(67232,5019),(67233,5019),(67234,5020),(67235,5020),(67236,5020),(67237,5021),(67238,5021),(67239,5021),(67240,5022),(67241,5022),(67242,5023),(67243,5023),(67244,5023),(67245,5024),(67246,5024),(67247,5024),(67248,5025),(67249,5025),(67250,5025),(67251,5026),(67252,5026),(67253,5026),(67254,5027),(67255,5027),(67256,5027),(67257,5028),(67258,5028),(67259,5028),(67260,5029),(67261,5029),(67262,5029),(67263,5030),(67264,5030),(67265,5030),(67266,5031),(67267,5031),(67268,5031),(67269,5032),(67270,5032),(67271,5032),(67272,5033),(67273,5033),(67274,5033),(67275,5034),(67276,5034),(67277,5034),(67278,5035),(67279,5035),(67280,5035),(67281,5036),(67282,5036),(67283,5036),(67284,5037),(67285,5037),(67286,5037),(67287,5038),(67288,5038),(67289,5038),(67290,5039),(67291,5039),(67292,5039),(67293,5040),(67294,5040),(67295,5040),(67296,5041),(67297,5041),(67298,5041),(67299,5042),(67300,5042),(67301,5042),(67302,5043),(67303,5043),(67304,5043),(67305,5044),(67306,5044),(67307,5044),(67308,5045),(67309,5045),(67310,5045),(67311,5046),(67312,5046),(67313,5046),(67314,5047),(67315,5047),(67316,5047),(67317,5048),(67318,5048),(67319,5048),(67320,5049),(67321,5049),(67322,5049),(67323,5050),(67324,5050),(67325,5050),(67326,5051),(67327,5051),(67328,5051),(67329,5052),(67330,5052),(67331,5052),(67332,5053),(67333,5053),(67334,5053),(67335,5054),(67336,5054),(67337,5054),(67338,5055),(67339,5055),(67340,5055),(67341,5056),(67342,5056),(67343,5056),(67344,5057),(67345,5057),(67346,5057),(67347,5058),(67348,5058),(67349,5058),(67350,5059),(67351,5059),(67352,5059),(67353,5060),(67354,5060),(67355,5060),(67356,5061),(67357,5061),(67358,5061),(67359,5062),(67360,5062),(67361,5062),(67362,5063),(67363,5063),(67364,5063),(67365,5064),(67366,5064),(67367,5064),(67368,5065),(67369,5065),(67370,5065),(67371,5066),(67372,5066),(67373,5066),(67374,5067),(67375,5067),(67376,5067),(67377,5068),(67378,5068),(67379,5068),(67380,5069),(67381,5069),(67382,5069),(67383,5070),(67384,5070),(67385,5070),(67386,5071),(67387,5071),(67388,5071),(67389,5072),(67390,5072),(67391,5072),(67392,5073),(67393,5073),(67394,5073),(67395,5074),(67396,5074),(67397,5074),(67398,5075),(67399,5075),(67400,5075),(67401,5076),(67402,5076),(67403,5076),(67404,5077),(67405,5077),(67406,5077),(67407,5078),(67408,5078),(67409,5078),(67410,5079),(67411,5079),(67412,5079),(67413,4980),(67414,4980),(67415,4980),(67416,4980),(67417,4981),(67418,4981),(67419,4981),(67420,4981),(67421,4982),(67422,4982),(67423,4982),(67424,4982),(67425,4983),(67426,4983),(67427,4983),(67428,4983),(67429,4984),(67430,4984),(67431,4984),(67432,4984),(67433,4985),(67434,4985),(67435,4985),(67436,4985),(67437,4986),(67438,4986),(67439,4986),(67440,4986),(67441,4987),(67442,4987),(67443,4987),(67444,4987),(67445,4988),(67446,4988),(67447,4988),(67448,4988),(67449,4989),(67450,4989),(67451,4989),(67452,4989),(67453,4990),(67454,4990),(67455,4990),(67456,4990),(67457,4991),(67458,4991),(67459,4991),(67460,4991),(67461,4992),(67462,4992),(67463,4992),(67464,4992),(67465,4993),(67466,4993),(67467,4993),(67468,4993),(67469,4994),(67470,4994),(67471,4994),(67472,4994),(67473,4995),(67474,4995),(67475,4995),(67476,4995),(67477,4996),(67478,4996),(67479,4996),(67480,4996),(67481,4997),(67482,4997),(67483,4997),(67484,4997),(67485,4998),(67486,4998),(67487,4998),(67488,4998),(67489,4999),(67490,4999),(67491,4999),(67492,4999),(67493,5000),(67494,5000),(67495,5000),(67496,5000),(67497,5001),(67498,5001),(67499,5001),(67500,5001),(67501,5002),(67502,5002),(67503,5002),(67504,5002),(67505,5003),(67506,5003),(67507,5003),(67508,5003),(67509,5004),(67510,5004),(67511,5004),(67512,5004),(67513,5005),(67514,5005),(67515,5005),(67516,5005),(67517,5006),(67518,5006),(67519,5006),(67520,5006),(67521,5007),(67522,5007),(67523,5007),(67524,5007),(67525,5008),(67526,5008),(67527,5008),(67528,5008),(67529,5009),(67530,5009),(67531,5009),(67532,5009),(67533,5010),(67534,5010),(67535,5010),(67536,5010),(67537,5011),(67538,5011),(67539,5011),(67540,5011),(67541,5012),(67542,5012),(67543,5012),(67544,5012),(67545,5013),(67546,5013),(67547,5013),(67548,5013),(67549,5014),(67550,5014),(67551,5014),(67552,5014),(67553,5015),(67554,5015),(67555,5015),(67556,5015),(67557,5016),(67558,5016),(67559,5016),(67560,5016),(67561,5017),(67562,5017),(67563,5017),(67564,5017),(67565,5018),(67566,5018),(67567,5018),(67568,5018),(67569,5019),(67570,5019),(67571,5019),(67572,5019),(67573,5020),(67574,5020),(67575,5020),(67576,5020),(67577,5021),(67578,5021),(67579,5021),(67580,5021),(67581,5022),(67582,5022),(67583,5022),(67584,5022),(67585,5023),(67586,5023),(67587,5023),(67588,5023),(67589,5024),(67590,5024),(67591,5024),(67592,5024),(67593,5025),(67594,5025),(67595,5025),(67596,5025),(67597,5026),(67598,5026),(67599,5026),(67600,5026),(67601,5027),(67602,5027),(67603,5027),(67604,5027),(67605,5028),(67606,5028),(67607,5028),(67608,5028),(67609,5029),(67610,5029),(67611,5029),(67612,5029),(67613,5030),(67614,5030),(67615,5030),(67616,5030),(67617,5031),(67618,5031),(67619,5031),(67620,5031),(67621,5032),(67622,5032),(67623,5032),(67624,5032),(67625,5033),(67626,5033),(67627,5033),(67628,5033),(67629,5034),(67630,5034),(67631,5034),(67632,5034),(67633,5035),(67634,5035),(67635,5035),(67636,5035),(67637,5036),(67638,5036),(67639,5036),(67640,5036),(67641,5037),(67642,5037),(67643,5037),(67644,5037),(67645,5038),(67646,5038),(67647,5038),(67648,5038),(67649,5039),(67650,5039),(67651,5039),(67652,5039),(67653,5040),(67654,5040),(67655,5040),(67656,5040),(67657,5041),(67658,5041),(67659,5041),(67660,5041),(67661,5042),(67662,5042),(67663,5042),(67664,5042),(67665,5043),(67666,5043),(67667,5043),(67668,5043),(67669,5044),(67670,5044),(67671,5044),(67672,5044),(67673,5045),(67674,5045),(67675,5045),(67676,5045),(67677,5046),(67678,5046),(67679,5046),(67680,5046),(67681,5047),(67682,5047),(67683,5047),(67684,5047),(67685,5048),(67686,5048),(67687,5048),(67688,5048),(67689,5049),(67690,5049),(67691,5049),(67692,5049),(67693,5050),(67694,5050),(67695,5050),(67696,5050),(67697,5051),(67698,5051),(67699,5051),(67700,5051),(67701,5052),(67702,5052),(67703,5052),(67704,5052),(67705,5053),(67706,5053),(67707,5053),(67708,5053),(67709,5054),(67710,5054),(67711,5054),(67712,5054),(67713,5055),(67714,5055),(67715,5055),(67716,5055),(67717,5056),(67718,5056),(67719,5056),(67720,5056),(67721,5057),(67722,5057),(67723,5057),(67724,5057),(67725,5058),(67726,5058),(67727,5058),(67728,5058),(67729,5059),(67730,5059),(67731,5059),(67732,5059),(67733,5060),(67734,5060),(67735,5060),(67736,5060),(67737,5061),(67738,5061),(67739,5061),(67740,5061),(67741,5062),(67742,5062),(67743,5062),(67744,5062),(67745,5063),(67746,5063),(67747,5063),(67748,5063),(67749,5064),(67750,5064),(67751,5064),(67752,5064),(67753,5065),(67754,5065),(67755,5065),(67756,5065),(67757,5066),(67758,5066),(67759,5066),(67760,5066),(67761,5067),(67762,5067),(67763,5067),(67764,5067),(67765,5068),(67766,5068),(67767,5068),(67768,5068),(67769,5069),(67770,5069),(67771,5069),(67772,5069),(67773,5070),(67774,5070),(67775,5070),(67776,5070),(67777,5071),(67778,5071),(67779,5071),(67780,5071),(67781,5072),(67782,5072),(67783,5072),(67784,5072),(67785,5073),(67786,5073),(67787,5073),(67788,5073),(67789,5074),(67790,5074),(67791,5074),(67792,5074),(67793,5075),(67794,5075),(67795,5075),(67796,5075),(67797,5076),(67798,5076),(67799,5076),(67800,5076),(67801,5077),(67802,5077),(67803,5077),(67804,5077),(67805,5078),(67806,5078),(67807,5078),(67808,5078),(67809,5079),(67810,5079),(67811,5079),(67812,5079),(67813,5080),(67814,5080),(67815,5080),(67816,5080),(67817,5080),(67818,5080),(67819,5081),(67820,5081),(67821,5081),(67822,5081),(67823,5081),(67824,5081),(67825,5082),(67826,5082),(67827,5082),(67828,5082),(67829,5082),(67830,5082),(67831,5083),(67832,5083),(67833,5083),(67834,5083),(67835,5083),(67836,5083),(67837,5084),(67838,5084),(67839,5084),(67840,5084),(67841,5084),(67842,5084),(67843,5085),(67844,5085),(67845,5085),(67846,5085),(67847,5085),(67848,5085),(67849,5086),(67850,5086),(67851,5086),(67852,5086),(67853,5086),(67854,5086),(67855,5087),(67856,5087),(67857,5087),(67858,5087),(67859,5087),(67860,5087),(67861,5088),(67862,5088),(67863,5088),(67864,5088),(67865,5089),(67866,5089),(67867,5089),(67868,5089),(67869,5090),(67870,5090),(67871,5090),(67872,5090),(67873,5090),(67874,5090),(67875,5091),(67876,5091),(67877,5091),(67878,5091),(67879,5091),(67880,5091),(67881,5092),(67882,5092),(67883,5092),(67884,5092),(67885,5092),(67886,5092),(67887,5093),(67888,5093),(67889,5093),(67890,5093),(67891,5093),(67892,5093),(67893,5094),(67894,5094),(67895,5094),(67896,5094),(67897,5094),(67898,5094),(67899,5095),(67900,5095),(67901,5095),(67902,5095),(67903,5095),(67904,5095),(67905,5096),(67906,5096),(67907,5096),(67908,5096),(67909,5096),(67910,5096),(67911,5097),(67912,5097),(67913,5097),(67914,5097),(67915,5097),(67916,5097),(67917,5098),(67918,5098),(67919,5098),(67920,5098),(67921,5098),(67922,5098),(67923,5099),(67924,5099),(67925,5099),(67926,5099),(67927,5099),(67928,5099),(67929,5100),(67930,5100),(67931,5100),(67932,5100),(67933,5100),(67934,5100),(67935,5101),(67936,5101),(67937,5101),(67938,5101),(67939,5101),(67940,5101),(67941,5102),(67942,5102),(67943,5102),(67944,5102),(67945,5102),(67946,5102),(67947,5103),(67948,5103),(67949,5103),(67950,5103),(67951,5103),(67952,5103),(67953,5104),(67954,5104),(67955,5104),(67956,5104),(67957,5104),(67958,5104),(67959,5105),(67960,5105),(67961,5105),(67962,5105),(67963,5105),(67964,5105),(67965,5106),(67966,5106),(67967,5106),(67968,5106),(67969,5107),(67970,5107),(67971,5107),(67972,5107),(67973,5108),(67974,5108),(67975,5108),(67976,5108),(67977,5109),(67978,5109),(67979,5109),(67980,5109),(67981,5110),(67982,5110),(67983,5110),(67984,5110),(67985,5110),(67986,5110),(67987,5111),(67988,5111),(67989,5111),(67990,5111),(67991,5111),(67992,5111),(67993,5112),(67994,5112),(67995,5112),(67996,5112),(67997,5112),(67998,5112),(67999,5113),(68000,5113),(68001,5113),(68002,5113),(68003,5113),(68004,5113),(68005,5114),(68006,5114),(68007,5114),(68008,5114),(68009,5114),(68010,5114),(68011,5115),(68012,5115),(68013,5115),(68014,5115),(68015,5115),(68016,5115),(68017,5116),(68018,5116),(68019,5116),(68020,5116),(68021,5116),(68022,5116),(68023,5117),(68024,5117),(68025,5117),(68026,5117),(68027,5117),(68028,5117),(68029,5118),(68030,5118),(68031,5118),(68032,5118),(68033,5118),(68034,5118),(68035,5119),(68036,5119),(68037,5119),(68038,5119),(68039,5119),(68040,5119),(68041,5120),(68042,5120),(68043,5120),(68044,5120),(68045,5120),(68046,5120),(68047,5121),(68048,5121),(68049,5121),(68050,5121),(68051,5121),(68052,5121),(68053,5122),(68054,5122),(68055,5122),(68056,5122),(68057,5122),(68058,5122),(68059,5123),(68060,5123),(68061,5123),(68062,5123),(68063,5123),(68064,5123),(68065,5124),(68066,5124),(68067,5124),(68068,5124),(68069,5124),(68070,5124),(68071,5125),(68072,5125),(68073,5125),(68074,5125),(68075,5125),(68076,5125),(68077,5126),(68078,5126),(68079,5126),(68080,5126),(68081,5126),(68082,5126),(68083,5127),(68084,5127),(68085,5127),(68086,5127),(68087,5127),(68088,5127),(68089,5128),(68090,5128),(68091,5128),(68092,5128),(68093,5128),(68094,5128),(68095,5129),(68096,5129),(68097,5129),(68098,5129),(68099,5129),(68100,5129),(68101,5130),(68102,5130),(68103,5130),(68104,5130),(68105,5130),(68106,5130),(68107,5131),(68108,5131),(68109,5131),(68110,5131),(68111,5131),(68112,5131),(68113,5132),(68114,5132),(68115,5132),(68116,5132),(68117,5133),(68118,5133),(68119,5133),(68120,5133),(68121,5134),(68122,5134),(68123,5134),(68124,5134),(68125,5135),(68126,5135),(68127,5135),(68128,5135),(68129,5136),(68130,5136),(68131,5136),(68132,5136),(68133,5136),(68134,5136),(68135,5137),(68136,5137),(68137,5137),(68138,5137),(68139,5137),(68140,5137),(68141,5138),(68142,5138),(68143,5138),(68144,5138),(68145,5138),(68146,5138),(68147,5139),(68148,5139),(68149,5139),(68150,5139),(68151,5139),(68152,5139),(68153,5140),(68154,5140),(68155,5140),(68156,5140),(68157,5141),(68158,5141),(68159,5141),(68160,5141),(68161,5142),(68162,5142),(68163,5142),(68164,5142),(68165,5142),(68166,5142),(68167,5143),(68168,5143),(68169,5143),(68170,5143),(68171,5144),(68172,5144),(68173,5144),(68174,5144),(68175,5145),(68176,5145),(68177,5145),(68178,5145),(68179,5146),(68180,5146),(68181,5146),(68182,5146),(68183,5147),(68184,5147),(68185,5147),(68186,5147),(68187,5147),(68188,5147),(68189,5148),(68190,5148),(68191,5148),(68192,5148),(68193,5148),(68194,5148),(68195,5149),(68196,5149),(68197,5149),(68198,5149),(68199,5149),(68200,5149),(68201,5150),(68202,5150),(68203,5150),(68204,5150),(68205,5150),(68206,5150),(68207,5151),(68208,5151),(68209,5151),(68210,5151),(68211,5151),(68212,5151),(68213,5152),(68214,5152),(68215,5152),(68216,5152),(68217,5152),(68218,5152),(68219,5153),(68220,5153),(68221,5153),(68222,5153),(68223,5153),(68224,5153),(68225,5154),(68226,5154),(68227,5154),(68228,5154),(68229,5154),(68230,5154),(68231,5155),(68232,5155),(68233,5155),(68234,5155),(68235,5155),(68236,5155),(68237,5156),(68238,5156),(68239,5156),(68240,5156),(68241,5156),(68242,5156),(68243,5157),(68244,5157),(68245,5157),(68246,5157),(68247,5157),(68248,5157),(68249,5158),(68250,5158),(68251,5158),(68252,5158),(68253,5158),(68254,5158),(68255,5159),(68256,5159),(68257,5159),(68258,5159),(68259,5159),(68260,5159),(68261,5160),(68262,5160),(68263,5160),(68264,5160),(68265,5160),(68266,5160),(68267,5161),(68268,5161),(68269,5161),(68270,5161),(68271,5161),(68272,5161),(68273,5162),(68274,5162),(68275,5162),(68276,5162),(68277,5163),(68278,5163),(68279,5163),(68280,5163),(68281,5163),(68282,5163),(68283,5164),(68284,5164),(68285,5164),(68286,5164),(68287,5164),(68288,5164),(68289,5165),(68290,5165),(68291,5165),(68292,5165),(68293,5166),(68294,5166),(68295,5166),(68296,5166),(68297,5166),(68298,5166),(68299,5167),(68300,5167),(68301,5167),(68302,5167),(68303,5167),(68304,5167),(68305,5168),(68306,5168),(68307,5168),(68308,5168),(68309,5168),(68310,5168),(68311,5169),(68312,5169),(68313,5169),(68314,5169),(68315,5170),(68316,5170),(68317,5170),(68318,5170),(68319,5171),(68320,5171),(68321,5171),(68322,5171),(68323,5171),(68324,5171),(68325,5172),(68326,5172),(68327,5172),(68328,5172),(68329,5172),(68330,5172),(68331,5173),(68332,5173),(68333,5173),(68334,5173),(68335,5173),(68336,5173),(68337,5174),(68338,5174),(68339,5174),(68340,5174),(68341,5174),(68342,5174),(68343,5175),(68344,5175),(68345,5175),(68346,5175),(68347,5175),(68348,5175),(68349,5176),(68350,5176),(68351,5176),(68352,5176),(68353,5176),(68354,5176),(68355,5177),(68356,5177),(68357,5177),(68358,5177),(68359,5177),(68360,5177),(68361,5178),(68362,5178),(68363,5178),(68364,5178),(68365,5178),(68366,5178),(68367,5179),(68368,5179),(68369,5179),(68370,5179),(68371,5179),(68372,5179),(68373,5080),(68374,5080),(68375,5080),(68376,5081),(68377,5081),(68378,5081),(68379,5082),(68380,5082),(68381,5082),(68382,5083),(68383,5083),(68384,5083),(68385,5084),(68386,5084),(68387,5084),(68388,5085),(68389,5085),(68390,5085),(68391,5086),(68392,5086),(68393,5086),(68394,5087),(68395,5087),(68396,5087),(68397,5088),(68398,5088),(68399,5088),(68400,5089),(68401,5089),(68402,5089),(68403,5090),(68404,5090),(68405,5090),(68406,5091),(68407,5091),(68408,5091),(68409,5092),(68410,5092),(68411,5092),(68412,5093),(68413,5093),(68414,5093),(68415,5094),(68416,5094),(68417,5094),(68418,5095),(68419,5095),(68420,5095),(68421,5096),(68422,5096),(68423,5096),(68424,5097),(68425,5097),(68426,5097),(68427,5098),(68428,5098),(68429,5098),(68430,5099),(68431,5099),(68432,5099),(68433,5100),(68434,5100),(68435,5100),(68436,5101),(68437,5101),(68438,5101),(68439,5102),(68440,5102),(68441,5102),(68442,5103),(68443,5103),(68444,5103),(68445,5104),(68446,5104),(68447,5104),(68448,5105),(68449,5105),(68450,5105),(68451,5106),(68452,5106),(68453,5106),(68454,5107),(68455,5107),(68456,5107),(68457,5108),(68458,5108),(68459,5108),(68460,5109),(68461,5109),(68462,5109),(68463,5110),(68464,5110),(68465,5110),(68466,5111),(68467,5111),(68468,5111),(68469,5112),(68470,5112),(68471,5112),(68472,5113),(68473,5113),(68474,5113),(68475,5114),(68476,5114),(68477,5114),(68478,5115),(68479,5115),(68480,5115),(68481,5116),(68482,5116),(68483,5116),(68484,5117),(68485,5117),(68486,5117),(68487,5118),(68488,5118),(68489,5118),(68490,5119),(68491,5119),(68492,5119),(68493,5120),(68494,5120),(68495,5120),(68496,5121),(68497,5121),(68498,5121),(68499,5122),(68500,5122),(68501,5122),(68502,5123),(68503,5123),(68504,5123),(68505,5124),(68506,5124),(68507,5124),(68508,5125),(68509,5125),(68510,5125),(68511,5126),(68512,5126),(68513,5126),(68514,5127),(68515,5127),(68516,5127),(68517,5128),(68518,5128),(68519,5128),(68520,5129),(68521,5129),(68522,5129),(68523,5130),(68524,5130),(68525,5130),(68526,5131),(68527,5131),(68528,5131),(68529,5132),(68530,5132),(68531,5132),(68532,5133),(68533,5133),(68534,5133),(68535,5134),(68536,5134),(68537,5134),(68538,5135),(68539,5135),(68540,5135),(68541,5136),(68542,5136),(68543,5136),(68544,5137),(68545,5137),(68546,5137),(68547,5138),(68548,5138),(68549,5138),(68550,5139),(68551,5139),(68552,5139),(68553,5140),(68554,5140),(68555,5140),(68556,5141),(68557,5141),(68558,5141),(68559,5142),(68560,5142),(68561,5142),(68562,5143),(68563,5143),(68564,5143),(68565,5144),(68566,5144),(68567,5144),(68568,5145),(68569,5145),(68570,5145),(68571,5146),(68572,5146),(68573,5146),(68574,5147),(68575,5147),(68576,5147),(68577,5148),(68578,5148),(68579,5148),(68580,5149),(68581,5149),(68582,5149),(68583,5150),(68584,5150),(68585,5150),(68586,5151),(68587,5151),(68588,5151),(68589,5152),(68590,5152),(68591,5152),(68592,5153),(68593,5153),(68594,5153),(68595,5154),(68596,5154),(68597,5154),(68598,5155),(68599,5155),(68600,5155),(68601,5156),(68602,5156),(68603,5156),(68604,5157),(68605,5157),(68606,5157),(68607,5158),(68608,5158),(68609,5158),(68610,5159),(68611,5159),(68612,5159),(68613,5160),(68614,5160),(68615,5160),(68616,5161),(68617,5161),(68618,5161),(68619,5162),(68620,5162),(68621,5162),(68622,5163),(68623,5163),(68624,5163),(68625,5164),(68626,5164),(68627,5164),(68628,5165),(68629,5165),(68630,5165),(68631,5166),(68632,5166),(68633,5166),(68634,5167),(68635,5167),(68636,5167),(68637,5168),(68638,5168),(68639,5168),(68640,5169),(68641,5169),(68642,5169),(68643,5170),(68644,5170),(68645,5170),(68646,5171),(68647,5171),(68648,5172),(68649,5172),(68650,5172),(68651,5173),(68652,5173),(68653,5173),(68654,5174),(68655,5174),(68656,5174),(68657,5175),(68658,5175),(68659,5175),(68660,5176),(68661,5176),(68662,5176),(68663,5177),(68664,5177),(68665,5177),(68666,5178),(68667,5178),(68668,5178),(68669,5179),(68670,5179),(68671,5179),(68672,5080),(68673,5080),(68674,5080),(68675,5080),(68676,5081),(68677,5081),(68678,5081),(68679,5081),(68680,5082),(68681,5082),(68682,5082),(68683,5082),(68684,5083),(68685,5083),(68686,5083),(68687,5083),(68688,5084),(68689,5084),(68690,5084),(68691,5084),(68692,5085),(68693,5085),(68694,5085),(68695,5085),(68696,5086),(68697,5086),(68698,5086),(68699,5086),(68700,5087),(68701,5087),(68702,5087),(68703,5087),(68704,5088),(68705,5088),(68706,5088),(68707,5088),(68708,5089),(68709,5089),(68710,5089),(68711,5089),(68712,5090),(68713,5090),(68714,5090),(68715,5090),(68716,5091),(68717,5091),(68718,5091),(68719,5091),(68720,5092),(68721,5092),(68722,5092),(68723,5092),(68724,5093),(68725,5093),(68726,5093),(68727,5093),(68728,5094),(68729,5094),(68730,5094),(68731,5094),(68732,5095),(68733,5095),(68734,5095),(68735,5095),(68736,5096),(68737,5096),(68738,5096),(68739,5096),(68740,5097),(68741,5097),(68742,5097),(68743,5097),(68744,5098),(68745,5098),(68746,5098),(68747,5098),(68748,5099),(68749,5099),(68750,5099),(68751,5099),(68752,5100),(68753,5100),(68754,5100),(68755,5100),(68756,5101),(68757,5101),(68758,5101),(68759,5101),(68760,5102),(68761,5102),(68762,5102),(68763,5102),(68764,5103),(68765,5103),(68766,5103),(68767,5103),(68768,5104),(68769,5104),(68770,5104),(68771,5104),(68772,5105),(68773,5105),(68774,5105),(68775,5105),(68776,5106),(68777,5106),(68778,5106),(68779,5106),(68780,5107),(68781,5107),(68782,5107),(68783,5107),(68784,5108),(68785,5108),(68786,5108),(68787,5108),(68788,5109),(68789,5109),(68790,5109),(68791,5109),(68792,5110),(68793,5110),(68794,5110),(68795,5110),(68796,5111),(68797,5111),(68798,5111),(68799,5111),(68800,5112),(68801,5112),(68802,5112),(68803,5112),(68804,5113),(68805,5113),(68806,5113),(68807,5113),(68808,5114),(68809,5114),(68810,5114),(68811,5114),(68812,5115),(68813,5115),(68814,5115),(68815,5115),(68816,5116),(68817,5116),(68818,5116),(68819,5116),(68820,5117),(68821,5117),(68822,5117),(68823,5117),(68824,5118),(68825,5118),(68826,5118),(68827,5118),(68828,5119),(68829,5119),(68830,5119),(68831,5119),(68832,5120),(68833,5120),(68834,5120),(68835,5120),(68836,5121),(68837,5121),(68838,5121),(68839,5121),(68840,5122),(68841,5122),(68842,5122),(68843,5122),(68844,5123),(68845,5123),(68846,5123),(68847,5123),(68848,5124),(68849,5124),(68850,5124),(68851,5124),(68852,5125),(68853,5125),(68854,5125),(68855,5125),(68856,5126),(68857,5126),(68858,5126),(68859,5126),(68860,5127),(68861,5127),(68862,5127),(68863,5127),(68864,5128),(68865,5128),(68866,5128),(68867,5128),(68868,5129),(68869,5129),(68870,5129),(68871,5129),(68872,5130),(68873,5130),(68874,5130),(68875,5130),(68876,5131),(68877,5131),(68878,5131),(68879,5131),(68880,5132),(68881,5132),(68882,5132),(68883,5132),(68884,5133),(68885,5133),(68886,5133),(68887,5133),(68888,5134),(68889,5134),(68890,5134),(68891,5134),(68892,5135),(68893,5135),(68894,5135),(68895,5135),(68896,5136),(68897,5136),(68898,5136),(68899,5136),(68900,5137),(68901,5137),(68902,5137),(68903,5137),(68904,5138),(68905,5138),(68906,5138),(68907,5138),(68908,5139),(68909,5139),(68910,5139),(68911,5139),(68912,5140),(68913,5140),(68914,5140),(68915,5140),(68916,5141),(68917,5141),(68918,5141),(68919,5141),(68920,5142),(68921,5142),(68922,5142),(68923,5142),(68924,5143),(68925,5143),(68926,5143),(68927,5143),(68928,5144),(68929,5144),(68930,5144),(68931,5144),(68932,5145),(68933,5145),(68934,5145),(68935,5145),(68936,5146),(68937,5146),(68938,5146),(68939,5146),(68940,5147),(68941,5147),(68942,5147),(68943,5147),(68944,5148),(68945,5148),(68946,5148),(68947,5148),(68948,5149),(68949,5149),(68950,5149),(68951,5149),(68952,5150),(68953,5150),(68954,5150),(68955,5150),(68956,5151),(68957,5151),(68958,5151),(68959,5151),(68960,5152),(68961,5152),(68962,5152),(68963,5152),(68964,5153),(68965,5153),(68966,5153),(68967,5153),(68968,5154),(68969,5154),(68970,5154),(68971,5154),(68972,5155),(68973,5155),(68974,5155),(68975,5155),(68976,5156),(68977,5156),(68978,5156),(68979,5156),(68980,5157),(68981,5157),(68982,5157),(68983,5157),(68984,5158),(68985,5158),(68986,5158),(68987,5158),(68988,5159),(68989,5159),(68990,5159),(68991,5159),(68992,5160),(68993,5160),(68994,5160),(68995,5160),(68996,5161),(68997,5161),(68998,5161),(68999,5161),(69000,5162),(69001,5162),(69002,5162),(69003,5162),(69004,5163),(69005,5163),(69006,5163),(69007,5163),(69008,5164),(69009,5164),(69010,5164),(69011,5164),(69012,5165),(69013,5165),(69014,5165),(69015,5165),(69016,5166),(69017,5166),(69018,5166),(69019,5166),(69020,5167),(69021,5167),(69022,5167),(69023,5167),(69024,5168),(69025,5168),(69026,5168),(69027,5168),(69028,5169),(69029,5169),(69030,5169),(69031,5169),(69032,5170),(69033,5170),(69034,5170),(69035,5170),(69036,5171),(69037,5171),(69038,5171),(69039,5171),(69040,5172),(69041,5172),(69042,5172),(69043,5172),(69044,5173),(69045,5173),(69046,5173),(69047,5173),(69048,5174),(69049,5174),(69050,5174),(69051,5174),(69052,5175),(69053,5175),(69054,5175),(69055,5175),(69056,5176),(69057,5176),(69058,5176),(69059,5176),(69060,5177),(69061,5177),(69062,5177),(69063,5177),(69064,5178),(69065,5178),(69066,5178),(69067,5178),(69068,5179),(69069,5179),(69070,5179),(69071,5179),(69072,5180),(69073,5180),(69074,5180),(69075,5180),(69076,5180),(69077,5180),(69078,5181),(69079,5181),(69080,5181),(69081,5181),(69082,5182),(69083,5182),(69084,5182),(69085,5182),(69086,5182),(69087,5182),(69088,5183),(69089,5183),(69090,5183),(69091,5183),(69092,5183),(69093,5183),(69094,5184),(69095,5184),(69096,5184),(69097,5184),(69098,5185),(69099,5185),(69100,5185),(69101,5185),(69102,5186),(69103,5186),(69104,5186),(69105,5186),(69106,5186),(69107,5186),(69108,5187),(69109,5187),(69110,5187),(69111,5187),(69112,5187),(69113,5187),(69114,5188),(69115,5188),(69116,5188),(69117,5188),(69118,5188),(69119,5188),(69120,5189),(69121,5189),(69122,5189),(69123,5189),(69124,5189),(69125,5189),(69126,5190),(69127,5190),(69128,5190),(69129,5190),(69130,5190),(69131,5190),(69132,5191),(69133,5191),(69134,5191),(69135,5191),(69136,5191),(69137,5191),(69138,5192),(69139,5192),(69140,5192),(69141,5192),(69142,5192),(69143,5192),(69144,5193),(69145,5193),(69146,5193),(69147,5193),(69148,5193),(69149,5193),(69150,5194),(69151,5194),(69152,5194),(69153,5194),(69154,5194),(69155,5194),(69156,5195),(69157,5195),(69158,5195),(69159,5195),(69160,5195),(69161,5195),(69162,5196),(69163,5196),(69164,5196),(69165,5196),(69166,5196),(69167,5196),(69168,5197),(69169,5197),(69170,5197),(69171,5197),(69172,5197),(69173,5197),(69174,5198),(69175,5198),(69176,5198),(69177,5198),(69178,5198),(69179,5198),(69180,5199),(69181,5199),(69182,5199),(69183,5199),(69184,5199),(69185,5199),(69186,5200),(69187,5200),(69188,5200),(69189,5200),(69190,5201),(69191,5201),(69192,5201),(69193,5201),(69194,5202),(69195,5202),(69196,5202),(69197,5202),(69198,5202),(69199,5202),(69200,5203),(69201,5203),(69202,5203),(69203,5203),(69204,5203),(69205,5203),(69206,5204),(69207,5204),(69208,5204),(69209,5204),(69210,5204),(69211,5204),(69212,5205),(69213,5205),(69214,5205),(69215,5205),(69216,5205),(69217,5205),(69218,5206),(69219,5206),(69220,5206),(69221,5206),(69222,5206),(69223,5206),(69224,5207),(69225,5207),(69226,5207),(69227,5207),(69228,5207),(69229,5207),(69230,5208),(69231,5208),(69232,5208),(69233,5208),(69234,5208),(69235,5208),(69236,5209),(69237,5209),(69238,5209),(69239,5209),(69240,5209),(69241,5209),(69242,5210),(69243,5210),(69244,5210),(69245,5210),(69246,5210),(69247,5210),(69248,5211),(69249,5211),(69250,5211),(69251,5211),(69252,5211),(69253,5211),(69254,5212),(69255,5212),(69256,5212),(69257,5212),(69258,5212),(69259,5212),(69260,5213),(69261,5213),(69262,5213),(69263,5213),(69264,5213),(69265,5213),(69266,5214),(69267,5214),(69268,5214),(69269,5214),(69270,5214),(69271,5214),(69272,5215),(69273,5215),(69274,5215),(69275,5215),(69276,5215),(69277,5215),(69278,5216),(69279,5216),(69280,5216),(69281,5216),(69282,5216),(69283,5216),(69284,5217),(69285,5217),(69286,5217),(69287,5217),(69288,5217),(69289,5217),(69290,5218),(69291,5218),(69292,5218),(69293,5218),(69294,5218),(69295,5218),(69296,5219),(69297,5219),(69298,5219),(69299,5219),(69300,5219),(69301,5219),(69302,5220),(69303,5220),(69304,5220),(69305,5220),(69306,5220),(69307,5220),(69308,5221),(69309,5221),(69310,5221),(69311,5221),(69312,5221),(69313,5221),(69314,5222),(69315,5222),(69316,5222),(69317,5222),(69318,5222),(69319,5222),(69320,5223),(69321,5223),(69322,5223),(69323,5223),(69324,5223),(69325,5223),(69326,5224),(69327,5224),(69328,5224),(69329,5224),(69330,5224),(69331,5224),(69332,5225),(69333,5225),(69334,5225),(69335,5225),(69336,5225),(69337,5225),(69338,5226),(69339,5226),(69340,5226),(69341,5226),(69342,5226),(69343,5226),(69344,5227),(69345,5227),(69346,5227),(69347,5227),(69348,5227),(69349,5227),(69350,5228),(69351,5228),(69352,5228),(69353,5228),(69354,5228),(69355,5228),(69356,5229),(69357,5229),(69358,5229),(69359,5229),(69360,5229),(69361,5229),(69362,5230),(69363,5230),(69364,5230),(69365,5230),(69366,5230),(69367,5230),(69368,5231),(69369,5231),(69370,5231),(69371,5231),(69372,5231),(69373,5231),(69374,5232),(69375,5232),(69376,5232),(69377,5232),(69378,5232),(69379,5232),(69380,5233),(69381,5233),(69382,5233),(69383,5233),(69384,5233),(69385,5233),(69386,5234),(69387,5234),(69388,5234),(69389,5234),(69390,5234),(69391,5234),(69392,5235),(69393,5235),(69394,5235),(69395,5235),(69396,5235),(69397,5235),(69398,5236),(69399,5236),(69400,5236),(69401,5236),(69402,5236),(69403,5236),(69404,5237),(69405,5237),(69406,5237),(69407,5237),(69408,5237),(69409,5237),(69410,5238),(69411,5238),(69412,5238),(69413,5238),(69414,5239),(69415,5239),(69416,5239),(69417,5239),(69418,5240),(69419,5240),(69420,5240),(69421,5240),(69422,5241),(69423,5241),(69424,5241),(69425,5241),(69426,5242),(69427,5242),(69428,5242),(69429,5242),(69430,5243),(69431,5243),(69432,5243),(69433,5243),(69434,5244),(69435,5244),(69436,5244),(69437,5244),(69438,5245),(69439,5245),(69440,5245),(69441,5245),(69442,5246),(69443,5246),(69444,5246),(69445,5246),(69446,5247),(69447,5247),(69448,5247),(69449,5247),(69450,5248),(69451,5248),(69452,5248),(69453,5248),(69454,5248),(69455,5248),(69456,5249),(69457,5249),(69458,5249),(69459,5249),(69460,5249),(69461,5249),(69462,5250),(69463,5250),(69464,5250),(69465,5250),(69466,5250),(69467,5250),(69468,5251),(69469,5251),(69470,5251),(69471,5251),(69472,5251),(69473,5251),(69474,5252),(69475,5252),(69476,5252),(69477,5252),(69478,5252),(69479,5252),(69480,5253),(69481,5253),(69482,5253),(69483,5253),(69484,5253),(69485,5253),(69486,5254),(69487,5254),(69488,5254),(69489,5254),(69490,5254),(69491,5254),(69492,5255),(69493,5255),(69494,5255),(69495,5255),(69496,5255),(69497,5255),(69498,5256),(69499,5256),(69500,5256),(69501,5256),(69502,5256),(69503,5256),(69504,5257),(69505,5257),(69506,5257),(69507,5257),(69508,5257),(69509,5257),(69510,5258),(69511,5258),(69512,5258),(69513,5258),(69514,5258),(69515,5259),(69516,5259),(69517,5259),(69518,5259),(69519,5259),(69520,5260),(69521,5260),(69522,5260),(69523,5260),(69524,5260),(69525,5261),(69526,5261),(69527,5261),(69528,5261),(69529,5261),(69530,5262),(69531,5262),(69532,5262),(69533,5262),(69534,5262),(69535,5263),(69536,5263),(69537,5263),(69538,5263),(69539,5264),(69540,5264),(69541,5264),(69542,5264),(69543,5265),(69544,5265),(69545,5265),(69546,5265),(69547,5266),(69548,5266),(69549,5266),(69550,5266),(69551,5266),(69552,5267),(69553,5267),(69554,5267),(69555,5267),(69556,5267),(69557,5268),(69558,5268),(69559,5268),(69560,5268),(69561,5268),(69562,5269),(69563,5269),(69564,5269),(69565,5269),(69566,5270),(69567,5270),(69568,5270),(69569,5270),(69570,5180),(69571,5180),(69572,5180),(69573,5181),(69574,5181),(69575,5181),(69576,5182),(69577,5182),(69578,5182),(69579,5183),(69580,5183),(69581,5183),(69582,5184),(69583,5184),(69584,5184),(69585,5185),(69586,5185),(69587,5185),(69588,5186),(69589,5186),(69590,5186),(69591,5187),(69592,5187),(69593,5187),(69594,5188),(69595,5188),(69596,5188),(69597,5189),(69598,5189),(69599,5189),(69600,5190),(69601,5190),(69602,5190),(69603,5191),(69604,5191),(69605,5191),(69606,5192),(69607,5192),(69608,5192),(69609,5193),(69610,5193),(69611,5193),(69612,5194),(69613,5194),(69614,5194),(69615,5195),(69616,5195),(69617,5195),(69618,5196),(69619,5196),(69620,5196),(69621,5197),(69622,5197),(69623,5197),(69624,5198),(69625,5198),(69626,5198),(69627,5199),(69628,5199),(69629,5200),(69630,5200),(69631,5200),(69632,5201),(69633,5201),(69634,5201),(69635,5202),(69636,5202),(69637,5202),(69638,5203),(69639,5203),(69640,5203),(69641,5204),(69642,5204),(69643,5204),(69644,5205),(69645,5205),(69646,5205),(69647,5206),(69648,5206),(69649,5206),(69650,5207),(69651,5207),(69652,5207),(69653,5208),(69654,5208),(69655,5208),(69656,5209),(69657,5209),(69658,5209),(69659,5210),(69660,5210),(69661,5210),(69662,5211),(69663,5211),(69664,5211),(69665,5212),(69666,5212),(69667,5212),(69668,5213),(69669,5213),(69670,5213),(69671,5214),(69672,5214),(69673,5214),(69674,5215),(69675,5215),(69676,5215),(69677,5216),(69678,5216),(69679,5216),(69680,5217),(69681,5217),(69682,5217),(69683,5218),(69684,5218),(69685,5218),(69686,5219),(69687,5219),(69688,5219),(69689,5220),(69690,5220),(69691,5220),(69692,5221),(69693,5221),(69694,5221),(69695,5222),(69696,5222),(69697,5222),(69698,5223),(69699,5223),(69700,5223),(69701,5224),(69702,5224),(69703,5224),(69704,5225),(69705,5225),(69706,5225),(69707,5226),(69708,5226),(69709,5226),(69710,5227),(69711,5227),(69712,5227),(69713,5228),(69714,5228),(69715,5228),(69716,5229),(69717,5229),(69718,5229),(69719,5230),(69720,5230),(69721,5230),(69722,5231),(69723,5231),(69724,5231),(69725,5232),(69726,5232),(69727,5232),(69728,5233),(69729,5233),(69730,5233),(69731,5234),(69732,5234),(69733,5234),(69734,5235),(69735,5235),(69736,5235),(69737,5236),(69738,5236),(69739,5236),(69740,5237),(69741,5237),(69742,5237),(69743,5238),(69744,5238),(69745,5238),(69746,5239),(69747,5239),(69748,5239),(69749,5240),(69750,5240),(69751,5240),(69752,5241),(69753,5241),(69754,5241),(69755,5242),(69756,5242),(69757,5242),(69758,5243),(69759,5243),(69760,5243),(69761,5244),(69762,5244),(69763,5244),(69764,5245),(69765,5245),(69766,5245),(69767,5246),(69768,5246),(69769,5246),(69770,5247),(69771,5247),(69772,5247),(69773,5248),(69774,5248),(69775,5248),(69776,5249),(69777,5249),(69778,5249),(69779,5250),(69780,5250),(69781,5250),(69782,5251),(69783,5251),(69784,5251),(69785,5252),(69786,5252),(69787,5252),(69788,5253),(69789,5253),(69790,5253),(69791,5254),(69792,5254),(69793,5254),(69794,5255),(69795,5255),(69796,5255),(69797,5256),(69798,5256),(69799,5256),(69800,5257),(69801,5257),(69802,5257),(69803,5258),(69804,5258),(69805,5258),(69806,5259),(69807,5259),(69808,5259),(69809,5260),(69810,5260),(69811,5260),(69812,5261),(69813,5261),(69814,5261),(69815,5262),(69816,5262),(69817,5262),(69818,5263),(69819,5263),(69820,5263),(69821,5264),(69822,5264),(69823,5264),(69824,5265),(69825,5265),(69826,5265),(69827,5266),(69828,5266),(69829,5266),(69830,5267),(69831,5267),(69832,5267),(69833,5268),(69834,5268),(69835,5268),(69836,5269),(69837,5269),(69838,5269),(69839,5270),(69840,5270),(69841,5270),(69842,5180),(69843,5180),(69844,5180),(69845,5180),(69846,5181),(69847,5181),(69848,5181),(69849,5181),(69850,5182),(69851,5182),(69852,5182),(69853,5182),(69854,5183),(69855,5183),(69856,5183),(69857,5183),(69858,5184),(69859,5184),(69860,5184),(69861,5184),(69862,5185),(69863,5185),(69864,5185),(69865,5185),(69866,5186),(69867,5186),(69868,5186),(69869,5186),(69870,5187),(69871,5187),(69872,5187),(69873,5187),(69874,5188),(69875,5188),(69876,5188),(69877,5188),(69878,5189),(69879,5189),(69880,5189),(69881,5189),(69882,5190),(69883,5190),(69884,5190),(69885,5190),(69886,5191),(69887,5191),(69888,5191),(69889,5191),(69890,5192),(69891,5192),(69892,5192),(69893,5192),(69894,5193),(69895,5193),(69896,5193),(69897,5193),(69898,5194),(69899,5194),(69900,5194),(69901,5194),(69902,5195),(69903,5195),(69904,5195),(69905,5195),(69906,5196),(69907,5196),(69908,5196),(69909,5196),(69910,5197),(69911,5197),(69912,5197),(69913,5197),(69914,5198),(69915,5198),(69916,5198),(69917,5198),(69918,5199),(69919,5199),(69920,5199),(69921,5199),(69922,5200),(69923,5200),(69924,5200),(69925,5200),(69926,5201),(69927,5201),(69928,5201),(69929,5201),(69930,5202),(69931,5202),(69932,5202),(69933,5202),(69934,5203),(69935,5203),(69936,5203),(69937,5203),(69938,5204),(69939,5204),(69940,5204),(69941,5204),(69942,5205),(69943,5205),(69944,5205),(69945,5205),(69946,5206),(69947,5206),(69948,5206),(69949,5206),(69950,5207),(69951,5207),(69952,5207),(69953,5207),(69954,5208),(69955,5208),(69956,5208),(69957,5208),(69958,5209),(69959,5209),(69960,5209),(69961,5209),(69962,5210),(69963,5210),(69964,5210),(69965,5210),(69966,5211),(69967,5211),(69968,5211),(69969,5211),(69970,5212),(69971,5212),(69972,5212),(69973,5212),(69974,5213),(69975,5213),(69976,5213),(69977,5213),(69978,5214),(69979,5214),(69980,5214),(69981,5214),(69982,5215),(69983,5215),(69984,5215),(69985,5215),(69986,5216),(69987,5216),(69988,5216),(69989,5216),(69990,5217),(69991,5217),(69992,5217),(69993,5217),(69994,5218),(69995,5218),(69996,5218),(69997,5218),(69998,5219),(69999,5219),(70000,5219),(70001,5219),(70002,5220),(70003,5220),(70004,5220),(70005,5220),(70006,5221),(70007,5221),(70008,5221),(70009,5221),(70010,5222),(70011,5222),(70012,5222),(70013,5222),(70014,5223),(70015,5223),(70016,5223),(70017,5223),(70018,5224),(70019,5224),(70020,5224),(70021,5224),(70022,5225),(70023,5225),(70024,5225),(70025,5225),(70026,5226),(70027,5226),(70028,5226),(70029,5226),(70030,5227),(70031,5227),(70032,5227),(70033,5227),(70034,5228),(70035,5228),(70036,5228),(70037,5228),(70038,5229),(70039,5229),(70040,5229),(70041,5229),(70042,5230),(70043,5230),(70044,5230),(70045,5230),(70046,5231),(70047,5231),(70048,5231),(70049,5231),(70050,5232),(70051,5232),(70052,5232),(70053,5232),(70054,5233),(70055,5233),(70056,5233),(70057,5233),(70058,5234),(70059,5234),(70060,5234),(70061,5234),(70062,5235),(70063,5235),(70064,5235),(70065,5235),(70066,5236),(70067,5236),(70068,5236),(70069,5236),(70070,5237),(70071,5237),(70072,5237),(70073,5237),(70074,5238),(70075,5238),(70076,5238),(70077,5238),(70078,5239),(70079,5239),(70080,5239),(70081,5239),(70082,5240),(70083,5240),(70084,5240),(70085,5240),(70086,5241),(70087,5241),(70088,5241),(70089,5241),(70090,5242),(70091,5242),(70092,5242),(70093,5242),(70094,5243),(70095,5243),(70096,5243),(70097,5243),(70098,5244),(70099,5244),(70100,5244),(70101,5244),(70102,5245),(70103,5245),(70104,5245),(70105,5245),(70106,5246),(70107,5246),(70108,5246),(70109,5246),(70110,5247),(70111,5247),(70112,5247),(70113,5247),(70114,5248),(70115,5248),(70116,5248),(70117,5248),(70118,5249),(70119,5249),(70120,5249),(70121,5249),(70122,5250),(70123,5250),(70124,5250),(70125,5250),(70126,5251),(70127,5251),(70128,5251),(70129,5251),(70130,5252),(70131,5252),(70132,5252),(70133,5252),(70134,5253),(70135,5253),(70136,5253),(70137,5253),(70138,5254),(70139,5254),(70140,5254),(70141,5254),(70142,5255),(70143,5255),(70144,5255),(70145,5255),(70146,5256),(70147,5256),(70148,5256),(70149,5256),(70150,5257),(70151,5257),(70152,5257),(70153,5257),(70154,5258),(70155,5258),(70156,5258),(70157,5258),(70158,5259),(70159,5259),(70160,5259),(70161,5259),(70162,5260),(70163,5260),(70164,5260),(70165,5260),(70166,5261),(70167,5261),(70168,5261),(70169,5261),(70170,5262),(70171,5262),(70172,5262),(70173,5262),(70174,5263),(70175,5263),(70176,5263),(70177,5263),(70178,5264),(70179,5264),(70180,5264),(70181,5264),(70182,5265),(70183,5265),(70184,5265),(70185,5265),(70186,5266),(70187,5266),(70188,5266),(70189,5266),(70190,5267),(70191,5267),(70192,5267),(70193,5267),(70194,5268),(70195,5268),(70196,5268),(70197,5268),(70198,5269),(70199,5269),(70200,5269),(70201,5269),(70202,5270),(70203,5270),(70204,5270),(70205,5270),(70206,5271),(70207,5271),(70208,5271),(70209,5271),(70210,5271),(70211,5271),(70212,5272),(70213,5272),(70214,5272),(70215,5272),(70216,5272),(70217,5272),(70218,5273),(70219,5273),(70220,5273),(70221,5273),(70222,5273),(70223,5273),(70224,5274),(70225,5274),(70226,5274),(70227,5274),(70228,5274),(70229,5274),(70230,5275),(70231,5275),(70232,5275),(70233,5275),(70234,5275),(70235,5275),(70236,5276),(70237,5276),(70238,5276),(70239,5276),(70240,5276),(70241,5276),(70242,5277),(70243,5277),(70244,5277),(70245,5277),(70246,5277),(70247,5277),(70248,5278),(70249,5278),(70250,5278),(70251,5278),(70252,5278),(70253,5278),(70254,5279),(70255,5279),(70256,5279),(70257,5279),(70258,5279),(70259,5279),(70260,5280),(70261,5280),(70262,5280),(70263,5280),(70264,5280),(70265,5280),(70266,5281),(70267,5281),(70268,5281),(70269,5281),(70270,5281),(70271,5281),(70272,5282),(70273,5282),(70274,5282),(70275,5282),(70276,5282),(70277,5282),(70278,5283),(70279,5283),(70280,5283),(70281,5283),(70282,5283),(70283,5283),(70284,5284),(70285,5284),(70286,5284),(70287,5284),(70288,5284),(70289,5284),(70290,5285),(70291,5285),(70292,5285),(70293,5285),(70294,5285),(70295,5285),(70296,5286),(70297,5286),(70298,5286),(70299,5286),(70300,5286),(70301,5286),(70302,5287),(70303,5287),(70304,5287),(70305,5287),(70306,5287),(70307,5287),(70308,5288),(70309,5288),(70310,5288),(70311,5288),(70312,5288),(70313,5288),(70314,5289),(70315,5289),(70316,5289),(70317,5289),(70318,5289),(70319,5289),(70320,5290),(70321,5290),(70322,5290),(70323,5290),(70324,5290),(70325,5290),(70326,5291),(70327,5291),(70328,5291),(70329,5291),(70330,5291),(70331,5291),(70332,5292),(70333,5292),(70334,5292),(70335,5292),(70336,5292),(70337,5292),(70338,5293),(70339,5293),(70340,5293),(70341,5293),(70342,5293),(70343,5293),(70344,5294),(70345,5294),(70346,5294),(70347,5294),(70348,5294),(70349,5294),(70350,5295),(70351,5295),(70352,5295),(70353,5295),(70354,5295),(70355,5295),(70356,5296),(70357,5296),(70358,5296),(70359,5296),(70360,5296),(70361,5296),(70362,5297),(70363,5297),(70364,5297),(70365,5297),(70366,5297),(70367,5297),(70368,5298),(70369,5298),(70370,5298),(70371,5298),(70372,5298),(70373,5298),(70374,5299),(70375,5299),(70376,5299),(70377,5299),(70378,5299),(70379,5299),(70380,5300),(70381,5300),(70382,5300),(70383,5300),(70384,5300),(70385,5300),(70386,5301),(70387,5301),(70388,5301),(70389,5301),(70390,5301),(70391,5301),(70392,5302),(70393,5302),(70394,5302),(70395,5302),(70396,5302),(70397,5302),(70398,5303),(70399,5303),(70400,5303),(70401,5303),(70402,5303),(70403,5303),(70404,5304),(70405,5304),(70406,5304),(70407,5304),(70408,5304),(70409,5304),(70410,5305),(70411,5305),(70412,5305),(70413,5305),(70414,5305),(70415,5305),(70416,5306),(70417,5306),(70418,5306),(70419,5306),(70420,5306),(70421,5306),(70422,5307),(70423,5307),(70424,5307),(70425,5307),(70426,5307),(70427,5307),(70428,5308),(70429,5308),(70430,5308),(70431,5308),(70432,5308),(70433,5308),(70434,5309),(70435,5309),(70436,5309),(70437,5309),(70438,5309),(70439,5309),(70440,5310),(70441,5310),(70442,5310),(70443,5310),(70444,5310),(70445,5310),(70446,5311),(70447,5311),(70448,5311),(70449,5311),(70450,5311),(70451,5311),(70452,5312),(70453,5312),(70454,5312),(70455,5312),(70456,5312),(70457,5312),(70458,5313),(70459,5313),(70460,5313),(70461,5313),(70462,5313),(70463,5313),(70464,5314),(70465,5314),(70466,5314),(70467,5314),(70468,5314),(70469,5314),(70470,5315),(70471,5315),(70472,5315),(70473,5315),(70474,5315),(70475,5315),(70476,5316),(70477,5316),(70478,5316),(70479,5316),(70480,5316),(70481,5316),(70482,5317),(70483,5317),(70484,5317),(70485,5317),(70486,5317),(70487,5317),(70488,5318),(70489,5318),(70490,5318),(70491,5318),(70492,5318),(70493,5318),(70494,5319),(70495,5319),(70496,5319),(70497,5319),(70498,5319),(70499,5319),(70500,5320),(70501,5320),(70502,5320),(70503,5320),(70504,5320),(70505,5320),(70506,5321),(70507,5321),(70508,5321),(70509,5321),(70510,5321),(70511,5321),(70512,5322),(70513,5322),(70514,5322),(70515,5322),(70516,5322),(70517,5322),(70518,5323),(70519,5323),(70520,5323),(70521,5323),(70522,5323),(70523,5323),(70524,5324),(70525,5324),(70526,5324),(70527,5324),(70528,5324),(70529,5324),(70530,5325),(70531,5325),(70532,5325),(70533,5325),(70534,5325),(70535,5325),(70536,5326),(70537,5326),(70538,5326),(70539,5326),(70540,5326),(70541,5326),(70542,5327),(70543,5327),(70544,5327),(70545,5327),(70546,5327),(70547,5327),(70548,5328),(70549,5328),(70550,5328),(70551,5328),(70552,5328),(70553,5328),(70554,5329),(70555,5329),(70556,5329),(70557,5329),(70558,5329),(70559,5329),(70560,5330),(70561,5330),(70562,5330),(70563,5330),(70564,5330),(70565,5330),(70566,5331),(70567,5331),(70568,5331),(70569,5331),(70570,5331),(70571,5331),(70572,5332),(70573,5332),(70574,5332),(70575,5332),(70576,5332),(70577,5332),(70578,5333),(70579,5333),(70580,5333),(70581,5333),(70582,5333),(70583,5333),(70584,5334),(70585,5334),(70586,5334),(70587,5334),(70588,5334),(70589,5335),(70590,5335),(70591,5335),(70592,5335),(70593,5335),(70594,5335),(70595,5336),(70596,5336),(70597,5336),(70598,5336),(70599,5336),(70600,5336),(70601,5337),(70602,5337),(70603,5337),(70604,5337),(70605,5337),(70606,5337),(70607,5338),(70608,5338),(70609,5338),(70610,5338),(70611,5338),(70612,5338),(70613,5339),(70614,5339),(70615,5339),(70616,5339),(70617,5339),(70618,5339),(70619,5340),(70620,5340),(70621,5340),(70622,5340),(70623,5340),(70624,5340),(70625,5341),(70626,5341),(70627,5341),(70628,5341),(70629,5341),(70630,5341),(70631,5342),(70632,5342),(70633,5342),(70634,5342),(70635,5342),(70636,5342),(70637,5343),(70638,5343),(70639,5343),(70640,5343),(70641,5343),(70642,5343),(70643,5344),(70644,5344),(70645,5344),(70646,5344),(70647,5344),(70648,5344),(70649,5345),(70650,5345),(70651,5345),(70652,5345),(70653,5345),(70654,5345),(70655,5346),(70656,5346),(70657,5346),(70658,5346),(70659,5346),(70660,5346),(70661,5347),(70662,5347),(70663,5347),(70664,5347),(70665,5347),(70666,5347),(70667,5348),(70668,5348),(70669,5348),(70670,5348),(70671,5348),(70672,5348),(70673,5349),(70674,5349),(70675,5349),(70676,5349),(70677,5349),(70678,5349),(70679,5350),(70680,5350),(70681,5350),(70682,5350),(70683,5350),(70684,5350),(70685,5351),(70686,5351),(70687,5351),(70688,5351),(70689,5351),(70690,5351),(70691,5352),(70692,5352),(70693,5352),(70694,5352),(70695,5352),(70696,5352),(70697,5353),(70698,5353),(70699,5353),(70700,5353),(70701,5353),(70702,5353),(70703,5354),(70704,5354),(70705,5354),(70706,5354),(70707,5354),(70708,5354),(70709,5355),(70710,5355),(70711,5355),(70712,5355),(70713,5355),(70714,5355),(70715,5356),(70716,5356),(70717,5356),(70718,5356),(70719,5356),(70720,5356),(70721,5357),(70722,5357),(70723,5357),(70724,5357),(70725,5357),(70726,5357),(70727,5358),(70728,5358),(70729,5358),(70730,5358),(70731,5358),(70732,5358),(70733,5359),(70734,5359),(70735,5359),(70736,5359),(70737,5359),(70738,5359),(70739,5271),(70740,5271),(70741,5271),(70742,5272),(70743,5272),(70744,5272),(70745,5273),(70746,5273),(70747,5273),(70748,5274),(70749,5274),(70750,5274),(70751,5275),(70752,5275),(70753,5275),(70754,5276),(70755,5276),(70756,5276),(70757,5277),(70758,5277),(70759,5277),(70760,5278),(70761,5278),(70762,5278),(70763,5279),(70764,5279),(70765,5279),(70766,5280),(70767,5280),(70768,5280),(70769,5281),(70770,5281),(70771,5281),(70772,5282),(70773,5282),(70774,5282),(70775,5283),(70776,5283),(70777,5283),(70778,5284),(70779,5284),(70780,5284),(70781,5285),(70782,5285),(70783,5286),(70784,5286),(70785,5286),(70786,5287),(70787,5287),(70788,5288),(70789,5288),(70790,5289),(70791,5289),(70792,5290),(70793,5290),(70794,5291),(70795,5291),(70796,5292),(70797,5292),(70798,5293),(70799,5293),(70800,5294),(70801,5294),(70802,5295),(70803,5295),(70804,5296),(70805,5296),(70806,5297),(70807,5297),(70808,5298),(70809,5298),(70810,5299),(70811,5299),(70812,5300),(70813,5300),(70814,5301),(70815,5301),(70816,5301),(70817,5302),(70818,5302),(70819,5303),(70820,5303),(70821,5304),(70822,5304),(70823,5305),(70824,5305),(70825,5306),(70826,5306),(70827,5307),(70828,5307),(70829,5308),(70830,5308),(70831,5309),(70832,5309),(70833,5309),(70834,5310),(70835,5310),(70836,5310),(70837,5311),(70838,5311),(70839,5311),(70840,5312),(70841,5312),(70842,5312),(70843,5313),(70844,5313),(70845,5313),(70846,5314),(70847,5314),(70848,5314),(70849,5315),(70850,5315),(70851,5315),(70852,5316),(70853,5316),(70854,5316),(70855,5317),(70856,5317),(70857,5317),(70858,5318),(70859,5318),(70860,5318),(70861,5319),(70862,5319),(70863,5319),(70864,5320),(70865,5320),(70866,5320),(70867,5321),(70868,5321),(70869,5322),(70870,5322),(70871,5323),(70872,5323),(70873,5323),(70874,5324),(70875,5324),(70876,5324),(70877,5325),(70878,5325),(70879,5325),(70880,5326),(70881,5326),(70882,5326),(70883,5327),(70884,5327),(70885,5327),(70886,5328),(70887,5328),(70888,5328),(70889,5329),(70890,5329),(70891,5329),(70892,5330),(70893,5330),(70894,5330),(70895,5331),(70896,5331),(70897,5331),(70898,5332),(70899,5332),(70900,5332),(70901,5333),(70902,5333),(70903,5333),(70904,5334),(70905,5334),(70906,5334),(70907,5335),(70908,5335),(70909,5335),(70910,5336),(70911,5336),(70912,5336),(70913,5337),(70914,5337),(70915,5337),(70916,5338),(70917,5338),(70918,5338),(70919,5339),(70920,5339),(70921,5339),(70922,5340),(70923,5340),(70924,5340),(70925,5341),(70926,5341),(70927,5341),(70928,5342),(70929,5342),(70930,5342),(70931,5343),(70932,5343),(70933,5343),(70934,5344),(70935,5344),(70936,5344),(70937,5345),(70938,5345),(70939,5345),(70940,5346),(70941,5346),(70942,5346),(70943,5347),(70944,5347),(70945,5347),(70946,5348),(70947,5348),(70948,5348),(70949,5349),(70950,5349),(70951,5349),(70952,5350),(70953,5350),(70954,5350),(70955,5351),(70956,5351),(70957,5351),(70958,5352),(70959,5352),(70960,5352),(70961,5353),(70962,5353),(70963,5353),(70964,5354),(70965,5354),(70966,5354),(70967,5355),(70968,5355),(70969,5355),(70970,5356),(70971,5356),(70972,5356),(70973,5357),(70974,5357),(70975,5357),(70976,5358),(70977,5358),(70978,5358),(70979,5359),(70980,5359),(70981,5359),(70982,5271),(70983,5271),(70984,5271),(70985,5271),(70986,5272),(70987,5272),(70988,5272),(70989,5272),(70990,5273),(70991,5273),(70992,5273),(70993,5273),(70994,5274),(70995,5274),(70996,5274),(70997,5274),(70998,5275),(70999,5275),(71000,5275),(71001,5275),(71002,5276),(71003,5276),(71004,5276),(71005,5276),(71006,5277),(71007,5277),(71008,5277),(71009,5277),(71010,5278),(71011,5278),(71012,5278),(71013,5278),(71014,5279),(71015,5279),(71016,5279),(71017,5279),(71018,5280),(71019,5280),(71020,5280),(71021,5280),(71022,5281),(71023,5281),(71024,5281),(71025,5281),(71026,5282),(71027,5282),(71028,5282),(71029,5282),(71030,5283),(71031,5283),(71032,5283),(71033,5283),(71034,5284),(71035,5284),(71036,5284),(71037,5284),(71038,5285),(71039,5285),(71040,5285),(71041,5285),(71042,5286),(71043,5286),(71044,5286),(71045,5286),(71046,5287),(71047,5287),(71048,5287),(71049,5287),(71050,5288),(71051,5288),(71052,5288),(71053,5288),(71054,5289),(71055,5289),(71056,5289),(71057,5289),(71058,5290),(71059,5290),(71060,5290),(71061,5290),(71062,5291),(71063,5291),(71064,5291),(71065,5291),(71066,5292),(71067,5292),(71068,5292),(71069,5292),(71070,5293),(71071,5293),(71072,5293),(71073,5293),(71074,5294),(71075,5294),(71076,5294),(71077,5294),(71078,5295),(71079,5295),(71080,5295),(71081,5295),(71082,5296),(71083,5296),(71084,5296),(71085,5296),(71086,5297),(71087,5297),(71088,5297),(71089,5297),(71090,5298),(71091,5298),(71092,5298),(71093,5298),(71094,5299),(71095,5299),(71096,5299),(71097,5299),(71098,5300),(71099,5300),(71100,5300),(71101,5300),(71102,5301),(71103,5301),(71104,5301),(71105,5301),(71106,5302),(71107,5302),(71108,5302),(71109,5302),(71110,5303),(71111,5303),(71112,5303),(71113,5303),(71114,5304),(71115,5304),(71116,5304),(71117,5304),(71118,5305),(71119,5305),(71120,5305),(71121,5305),(71122,5306),(71123,5306),(71124,5306),(71125,5306),(71126,5307),(71127,5307),(71128,5307),(71129,5307),(71130,5308),(71131,5308),(71132,5308),(71133,5308),(71134,5309),(71135,5309),(71136,5309),(71137,5309),(71138,5310),(71139,5310),(71140,5310),(71141,5310),(71142,5311),(71143,5311),(71144,5311),(71145,5311),(71146,5312),(71147,5312),(71148,5312),(71149,5312),(71150,5313),(71151,5313),(71152,5313),(71153,5313),(71154,5314),(71155,5314),(71156,5314),(71157,5314),(71158,5315),(71159,5315),(71160,5315),(71161,5315),(71162,5316),(71163,5316),(71164,5316),(71165,5316),(71166,5317),(71167,5317),(71168,5317),(71169,5317),(71170,5318),(71171,5318),(71172,5318),(71173,5318),(71174,5319),(71175,5319),(71176,5319),(71177,5319),(71178,5320),(71179,5320),(71180,5320),(71181,5320),(71182,5321),(71183,5321),(71184,5321),(71185,5321),(71186,5322),(71187,5322),(71188,5322),(71189,5322),(71190,5323),(71191,5323),(71192,5323),(71193,5323),(71194,5324),(71195,5324),(71196,5324),(71197,5324),(71198,5325),(71199,5325),(71200,5325),(71201,5325),(71202,5326),(71203,5326),(71204,5326),(71205,5326),(71206,5327),(71207,5327),(71208,5327),(71209,5327),(71210,5328),(71211,5328),(71212,5328),(71213,5328),(71214,5329),(71215,5329),(71216,5329),(71217,5329),(71218,5330),(71219,5330),(71220,5330),(71221,5330),(71222,5331),(71223,5331),(71224,5331),(71225,5331),(71226,5332),(71227,5332),(71228,5332),(71229,5332),(71230,5333),(71231,5333),(71232,5333),(71233,5333),(71234,5334),(71235,5334),(71236,5334),(71237,5334),(71238,5335),(71239,5335),(71240,5335),(71241,5335),(71242,5336),(71243,5336),(71244,5336),(71245,5336),(71246,5337),(71247,5337),(71248,5337),(71249,5337),(71250,5338),(71251,5338),(71252,5338),(71253,5338),(71254,5339),(71255,5339),(71256,5339),(71257,5339),(71258,5340),(71259,5340),(71260,5340),(71261,5340),(71262,5341),(71263,5341),(71264,5341),(71265,5341),(71266,5342),(71267,5342),(71268,5342),(71269,5342),(71270,5343),(71271,5343),(71272,5343),(71273,5343),(71274,5344),(71275,5344),(71276,5344),(71277,5344),(71278,5345),(71279,5345),(71280,5345),(71281,5345),(71282,5346),(71283,5346),(71284,5346),(71285,5346),(71286,5347),(71287,5347),(71288,5347),(71289,5347),(71290,5348),(71291,5348),(71292,5348),(71293,5348),(71294,5349),(71295,5349),(71296,5349),(71297,5349),(71298,5350),(71299,5350),(71300,5350),(71301,5350),(71302,5351),(71303,5351),(71304,5351),(71305,5351),(71306,5352),(71307,5352),(71308,5352),(71309,5352),(71310,5353),(71311,5353),(71312,5353),(71313,5353),(71314,5354),(71315,5354),(71316,5354),(71317,5354),(71318,5355),(71319,5355),(71320,5355),(71321,5355),(71322,5356),(71323,5356),(71324,5356),(71325,5356),(71326,5357),(71327,5357),(71328,5357),(71329,5357),(71330,5358),(71331,5358),(71332,5358),(71333,5358),(71334,5359),(71335,5359),(71336,5359),(71337,5359),(71338,5360),(71339,5360),(71340,5360),(71341,5360),(71342,5360),(71343,5360),(71344,5361),(71345,5361),(71346,5361),(71347,5361),(71348,5361),(71349,5361),(71350,5362),(71351,5362),(71352,5362),(71353,5362),(71354,5362),(71355,5362),(71356,5363),(71357,5363),(71358,5363),(71359,5363),(71360,5363),(71361,5363),(71362,5364),(71363,5364),(71364,5364),(71365,5364),(71366,5364),(71367,5364),(71368,5365),(71369,5365),(71370,5365),(71371,5365),(71372,5365),(71373,5365),(71374,5366),(71375,5366),(71376,5366),(71377,5366),(71378,5366),(71379,5366),(71380,5367),(71381,5367),(71382,5367),(71383,5367),(71384,5367),(71385,5367),(71386,5368),(71387,5368),(71388,5368),(71389,5368),(71390,5368),(71391,5368),(71392,5369),(71393,5369),(71394,5369),(71395,5369),(71396,5369),(71397,5369),(71398,5370),(71399,5370),(71400,5370),(71401,5370),(71402,5370),(71403,5370),(71404,5371),(71405,5371),(71406,5371),(71407,5371),(71408,5371),(71409,5371),(71410,5372),(71411,5372),(71412,5372),(71413,5372),(71414,5372),(71415,5372),(71416,5373),(71417,5373),(71418,5373),(71419,5373),(71420,5373),(71421,5373),(71422,5374),(71423,5374),(71424,5374),(71425,5374),(71426,5374),(71427,5374),(71428,5375),(71429,5375),(71430,5375),(71431,5375),(71432,5375),(71433,5375),(71434,5376),(71435,5376),(71436,5376),(71437,5376),(71438,5376),(71439,5376),(71440,5377),(71441,5377),(71442,5377),(71443,5377),(71444,5377),(71445,5377),(71446,5378),(71447,5378),(71448,5378),(71449,5378),(71450,5378),(71451,5378),(71452,5379),(71453,5379),(71454,5379),(71455,5379),(71456,5379),(71457,5379),(71458,5380),(71459,5380),(71460,5380),(71461,5380),(71462,5380),(71463,5380),(71464,5381),(71465,5381),(71466,5381),(71467,5381),(71468,5381),(71469,5381),(71470,5382),(71471,5382),(71472,5382),(71473,5382),(71474,5382),(71475,5382),(71476,5383),(71477,5383),(71478,5383),(71479,5383),(71480,5384),(71481,5384),(71482,5384),(71483,5384),(71484,5385),(71485,5385),(71486,5385),(71487,5385),(71488,5385),(71489,5385),(71490,5386),(71491,5386),(71492,5386),(71493,5386),(71494,5386),(71495,5386),(71496,5387),(71497,5387),(71498,5387),(71499,5387),(71500,5387),(71501,5387),(71502,5388),(71503,5388),(71504,5388),(71505,5388),(71506,5388),(71507,5388),(71508,5389),(71509,5389),(71510,5389),(71511,5389),(71512,5389),(71513,5389),(71514,5390),(71515,5390),(71516,5390),(71517,5390),(71518,5390),(71519,5390),(71520,5391),(71521,5391),(71522,5391),(71523,5391),(71524,5391),(71525,5391),(71526,5392),(71527,5392),(71528,5392),(71529,5392),(71530,5392),(71531,5392),(71532,5393),(71533,5393),(71534,5393),(71535,5393),(71536,5394),(71537,5394),(71538,5394),(71539,5394),(71540,5395),(71541,5395),(71542,5395),(71543,5395),(71544,5396),(71545,5396),(71546,5396),(71547,5396),(71548,5397),(71549,5397),(71550,5397),(71551,5397),(71552,5398),(71553,5398),(71554,5398),(71555,5398),(71556,5399),(71557,5399),(71558,5399),(71559,5399),(71560,5400),(71561,5400),(71562,5400),(71563,5400),(71564,5401),(71565,5401),(71566,5401),(71567,5401),(71568,5401),(71569,5401),(71570,5402),(71571,5402),(71572,5402),(71573,5402),(71574,5402),(71575,5402),(71576,5403),(71577,5403),(71578,5403),(71579,5403),(71580,5403),(71581,5403),(71582,5404),(71583,5404),(71584,5404),(71585,5404),(71586,5404),(71587,5404),(71588,5405),(71589,5405),(71590,5405),(71591,5405),(71592,5405),(71593,5405),(71594,5406),(71595,5406),(71596,5406),(71597,5406),(71598,5406),(71599,5406),(71600,5407),(71601,5407),(71602,5407),(71603,5407),(71604,5407),(71605,5407),(71606,5408),(71607,5408),(71608,5408),(71609,5408),(71610,5408),(71611,5408),(71612,5409),(71613,5409),(71614,5409),(71615,5409),(71616,5409),(71617,5409),(71618,5410),(71619,5410),(71620,5410),(71621,5410),(71622,5410),(71623,5410),(71624,5411),(71625,5411),(71626,5411),(71627,5411),(71628,5411),(71629,5411),(71630,5412),(71631,5412),(71632,5412),(71633,5412),(71634,5412),(71635,5412),(71636,5413),(71637,5413),(71638,5413),(71639,5413),(71640,5413),(71641,5413),(71642,5414),(71643,5414),(71644,5414),(71645,5414),(71646,5414),(71647,5414),(71648,5415),(71649,5415),(71650,5415),(71651,5415),(71652,5415),(71653,5415),(71654,5416),(71655,5416),(71656,5416),(71657,5416),(71658,5416),(71659,5416),(71660,5417),(71661,5417),(71662,5417),(71663,5417),(71664,5417),(71665,5417),(71666,5418),(71667,5418),(71668,5418),(71669,5418),(71670,5418),(71671,5418),(71672,5419),(71673,5419),(71674,5419),(71675,5419),(71676,5419),(71677,5419),(71678,5420),(71679,5420),(71680,5420),(71681,5420),(71682,5420),(71683,5420),(71684,5421),(71685,5421),(71686,5421),(71687,5421),(71688,5421),(71689,5421),(71690,5422),(71691,5422),(71692,5422),(71693,5422),(71694,5422),(71695,5422),(71696,5423),(71697,5423),(71698,5423),(71699,5423),(71700,5423),(71701,5423),(71702,5424),(71703,5424),(71704,5424),(71705,5424),(71706,5424),(71707,5424),(71708,5425),(71709,5425),(71710,5425),(71711,5425),(71712,5425),(71713,5425),(71714,5426),(71715,5426),(71716,5426),(71717,5426),(71718,5426),(71719,5426),(71720,5427),(71721,5427),(71722,5427),(71723,5427),(71724,5427),(71725,5427),(71726,5428),(71727,5428),(71728,5428),(71729,5428),(71730,5428),(71731,5428),(71732,5429),(71733,5429),(71734,5429),(71735,5429),(71736,5429),(71737,5429),(71738,5430),(71739,5430),(71740,5430),(71741,5430),(71742,5430),(71743,5431),(71744,5431),(71745,5431),(71746,5431),(71747,5431),(71748,5431),(71749,5432),(71750,5432),(71751,5432),(71752,5432),(71753,5432),(71754,5433),(71755,5433),(71756,5433),(71757,5433),(71758,5433),(71759,5433),(71760,5434),(71761,5434),(71762,5434),(71763,5434),(71764,5434),(71765,5435),(71766,5435),(71767,5435),(71768,5435),(71769,5435),(71770,5435),(71771,5436),(71772,5436),(71773,5436),(71774,5436),(71775,5436),(71776,5436),(71777,5437),(71778,5437),(71779,5437),(71780,5437),(71781,5437),(71782,5437),(71783,5438),(71784,5438),(71785,5438),(71786,5438),(71787,5438),(71788,5438),(71789,5439),(71790,5439),(71791,5439),(71792,5439),(71793,5439),(71794,5439),(71795,5440),(71796,5440),(71797,5440),(71798,5440),(71799,5440),(71800,5440),(71801,5441),(71802,5441),(71803,5441),(71804,5441),(71805,5441),(71806,5441),(71807,5442),(71808,5442),(71809,5442),(71810,5442),(71811,5442),(71812,5442),(71813,5443),(71814,5443),(71815,5443),(71816,5443),(71817,5443),(71818,5443),(71819,5444),(71820,5444),(71821,5444),(71822,5444),(71823,5444),(71824,5444),(71825,5445),(71826,5445),(71827,5445),(71828,5445),(71829,5445),(71830,5445),(71831,5446),(71832,5446),(71833,5446),(71834,5446),(71835,5446),(71836,5446),(71837,5447),(71838,5447),(71839,5447),(71840,5447),(71841,5447),(71842,5447),(71843,5448),(71844,5448),(71845,5448),(71846,5448),(71847,5448),(71848,5448),(71849,5449),(71850,5449),(71851,5449),(71852,5449),(71853,5449),(71854,5449),(71855,5450),(71856,5450),(71857,5450),(71858,5450),(71859,5450),(71860,5450),(71861,5451),(71862,5451),(71863,5451),(71864,5451),(71865,5451),(71866,5451),(71867,5452),(71868,5452),(71869,5452),(71870,5452),(71871,5452),(71872,5452),(71873,5453),(71874,5453),(71875,5453),(71876,5453),(71877,5453),(71878,5453),(71879,5454),(71880,5454),(71881,5454),(71882,5454),(71883,5454),(71884,5454),(71885,5455),(71886,5455),(71887,5455),(71888,5455),(71889,5455),(71890,5455),(71891,5456),(71892,5456),(71893,5456),(71894,5456),(71895,5456),(71896,5456),(71897,5457),(71898,5457),(71899,5457),(71900,5457),(71901,5457),(71902,5457),(71903,5458),(71904,5458),(71905,5458),(71906,5458),(71907,5458),(71908,5458),(71909,5459),(71910,5459),(71911,5459),(71912,5459),(71913,5459),(71914,5459),(71915,5360),(71916,5360),(71917,5360),(71918,5361),(71919,5361),(71920,5361),(71921,5362),(71922,5362),(71923,5362),(71924,5363),(71925,5363),(71926,5363),(71927,5364),(71928,5364),(71929,5364),(71930,5365),(71931,5365),(71932,5365),(71933,5366),(71934,5366),(71935,5366),(71936,5367),(71937,5367),(71938,5367),(71939,5368),(71940,5368),(71941,5368),(71942,5369),(71943,5369),(71944,5369),(71945,5370),(71946,5370),(71947,5370),(71948,5371),(71949,5371),(71950,5371),(71951,5372),(71952,5372),(71953,5372),(71954,5373),(71955,5373),(71956,5373),(71957,5374),(71958,5374),(71959,5374),(71960,5375),(71961,5375),(71962,5375),(71963,5376),(71964,5376),(71965,5376),(71966,5377),(71967,5377),(71968,5377),(71969,5378),(71970,5378),(71971,5378),(71972,5379),(71973,5379),(71974,5379),(71975,5380),(71976,5380),(71977,5380),(71978,5381),(71979,5381),(71980,5381),(71981,5382),(71982,5382),(71983,5382),(71984,5383),(71985,5383),(71986,5383),(71987,5384),(71988,5384),(71989,5384),(71990,5385),(71991,5385),(71992,5385),(71993,5386),(71994,5386),(71995,5386),(71996,5387),(71997,5387),(71998,5387),(71999,5388),(72000,5388),(72001,5388),(72002,5389),(72003,5389),(72004,5389),(72005,5390),(72006,5390),(72007,5390),(72008,5391),(72009,5391),(72010,5391),(72011,5392),(72012,5392),(72013,5392),(72014,5393),(72015,5393),(72016,5393),(72017,5394),(72018,5394),(72019,5394),(72020,5395),(72021,5395),(72022,5395),(72023,5396),(72024,5396),(72025,5396),(72026,5397),(72027,5397),(72028,5397),(72029,5398),(72030,5398),(72031,5398),(72032,5399),(72033,5399),(72034,5399),(72035,5400),(72036,5400),(72037,5400),(72038,5401),(72039,5401),(72040,5401),(72041,5402),(72042,5402),(72043,5402),(72044,5403),(72045,5403),(72046,5403),(72047,5404),(72048,5404),(72049,5404),(72050,5405),(72051,5405),(72052,5405),(72053,5406),(72054,5406),(72055,5406),(72056,5407),(72057,5407),(72058,5407),(72059,5408),(72060,5408),(72061,5408),(72062,5409),(72063,5409),(72064,5409),(72065,5410),(72066,5410),(72067,5410),(72068,5411),(72069,5411),(72070,5411),(72071,5411),(72072,5412),(72073,5412),(72074,5412),(72075,5413),(72076,5413),(72077,5413),(72078,5414),(72079,5414),(72080,5414),(72081,5415),(72082,5415),(72083,5415),(72084,5416),(72085,5416),(72086,5416),(72087,5417),(72088,5417),(72089,5417),(72090,5418),(72091,5418),(72092,5418),(72093,5419),(72094,5419),(72095,5419),(72096,5420),(72097,5420),(72098,5420),(72099,5421),(72100,5421),(72101,5421),(72102,5422),(72103,5422),(72104,5422),(72105,5423),(72106,5423),(72107,5423),(72108,5424),(72109,5424),(72110,5424),(72111,5425),(72112,5425),(72113,5425),(72114,5426),(72115,5426),(72116,5426),(72117,5427),(72118,5427),(72119,5427),(72120,5428),(72121,5428),(72122,5428),(72123,5429),(72124,5429),(72125,5429),(72126,5430),(72127,5430),(72128,5430),(72129,5431),(72130,5431),(72131,5431),(72132,5432),(72133,5432),(72134,5432),(72135,5433),(72136,5433),(72137,5433),(72138,5434),(72139,5434),(72140,5434),(72141,5435),(72142,5435),(72143,5435),(72144,5436),(72145,5436),(72146,5436),(72147,5437),(72148,5437),(72149,5437),(72150,5438),(72151,5438),(72152,5438),(72153,5439),(72154,5439),(72155,5439),(72156,5440),(72157,5440),(72158,5440),(72159,5441),(72160,5441),(72161,5441),(72162,5442),(72163,5442),(72164,5442),(72165,5443),(72166,5443),(72167,5443),(72168,5444),(72169,5444),(72170,5444),(72171,5445),(72172,5445),(72173,5445),(72174,5446),(72175,5446),(72176,5446),(72177,5447),(72178,5447),(72179,5447),(72180,5448),(72181,5448),(72182,5448),(72183,5449),(72184,5449),(72185,5449),(72186,5450),(72187,5450),(72188,5450),(72189,5451),(72190,5451),(72191,5451),(72192,5452),(72193,5452),(72194,5452),(72195,5453),(72196,5453),(72197,5453),(72198,5454),(72199,5454),(72200,5454),(72201,5455),(72202,5455),(72203,5455),(72204,5456),(72205,5456),(72206,5456),(72207,5457),(72208,5457),(72209,5457),(72210,5458),(72211,5458),(72212,5458),(72213,5459),(72214,5459),(72215,5459),(72216,5360),(72217,5360),(72218,5360),(72219,5360),(72220,5361),(72221,5361),(72222,5361),(72223,5361),(72224,5362),(72225,5362),(72226,5362),(72227,5362),(72228,5363),(72229,5363),(72230,5363),(72231,5363),(72232,5364),(72233,5364),(72234,5364),(72235,5364),(72236,5365),(72237,5365),(72238,5365),(72239,5365),(72240,5366),(72241,5366),(72242,5366),(72243,5366),(72244,5367),(72245,5367),(72246,5367),(72247,5367),(72248,5368),(72249,5368),(72250,5368),(72251,5368),(72252,5369),(72253,5369),(72254,5369),(72255,5369),(72256,5370),(72257,5370),(72258,5370),(72259,5370),(72260,5371),(72261,5371),(72262,5371),(72263,5371),(72264,5372),(72265,5372),(72266,5372),(72267,5372),(72268,5373),(72269,5373),(72270,5373),(72271,5373),(72272,5374),(72273,5374),(72274,5374),(72275,5374),(72276,5375),(72277,5375),(72278,5375),(72279,5375),(72280,5376),(72281,5376),(72282,5376),(72283,5376),(72284,5377),(72285,5377),(72286,5377),(72287,5377),(72288,5378),(72289,5378),(72290,5378),(72291,5378),(72292,5379),(72293,5379),(72294,5379),(72295,5379),(72296,5380),(72297,5380),(72298,5380),(72299,5380),(72300,5381),(72301,5381),(72302,5381),(72303,5381),(72304,5382),(72305,5382),(72306,5382),(72307,5382),(72308,5383),(72309,5383),(72310,5383),(72311,5383),(72312,5384),(72313,5384),(72314,5384),(72315,5384),(72316,5385),(72317,5385),(72318,5385),(72319,5385),(72320,5386),(72321,5386),(72322,5386),(72323,5386),(72324,5387),(72325,5387),(72326,5387),(72327,5387),(72328,5388),(72329,5388),(72330,5388),(72331,5388),(72332,5389),(72333,5389),(72334,5389),(72335,5389),(72336,5390),(72337,5390),(72338,5390),(72339,5390),(72340,5391),(72341,5391),(72342,5391),(72343,5391),(72344,5392),(72345,5392),(72346,5392),(72347,5392),(72348,5393),(72349,5393),(72350,5393),(72351,5393),(72352,5394),(72353,5394),(72354,5394),(72355,5394),(72356,5395),(72357,5395),(72358,5395),(72359,5395),(72360,5396),(72361,5396),(72362,5396),(72363,5396),(72364,5397),(72365,5397),(72366,5397),(72367,5397),(72368,5398),(72369,5398),(72370,5398),(72371,5398),(72372,5399),(72373,5399),(72374,5399),(72375,5399),(72376,5400),(72377,5400),(72378,5400),(72379,5400),(72380,5401),(72381,5401),(72382,5401),(72383,5401),(72384,5402),(72385,5402),(72386,5402),(72387,5402),(72388,5403),(72389,5403),(72390,5403),(72391,5403),(72392,5404),(72393,5404),(72394,5404),(72395,5404),(72396,5405),(72397,5405),(72398,5405),(72399,5405),(72400,5406),(72401,5406),(72402,5406),(72403,5406),(72404,5407),(72405,5407),(72406,5407),(72407,5407),(72408,5408),(72409,5408),(72410,5408),(72411,5408),(72412,5409),(72413,5409),(72414,5409),(72415,5409),(72416,5410),(72417,5410),(72418,5410),(72419,5410),(72420,5411),(72421,5411),(72422,5411),(72423,5411),(72424,5412),(72425,5412),(72426,5412),(72427,5412),(72428,5413),(72429,5413),(72430,5413),(72431,5413),(72432,5414),(72433,5414),(72434,5414),(72435,5414),(72436,5415),(72437,5415),(72438,5415),(72439,5415),(72440,5416),(72441,5416),(72442,5416),(72443,5416),(72444,5417),(72445,5417),(72446,5417),(72447,5417),(72448,5418),(72449,5418),(72450,5418),(72451,5418),(72452,5419),(72453,5419),(72454,5419),(72455,5419),(72456,5420),(72457,5420),(72458,5420),(72459,5420),(72460,5421),(72461,5421),(72462,5421),(72463,5421),(72464,5422),(72465,5422),(72466,5422),(72467,5422),(72468,5423),(72469,5423),(72470,5423),(72471,5423),(72472,5424),(72473,5424),(72474,5424),(72475,5424),(72476,5425),(72477,5425),(72478,5425),(72479,5425),(72480,5426),(72481,5426),(72482,5426),(72483,5426),(72484,5427),(72485,5427),(72486,5427),(72487,5427),(72488,5428),(72489,5428),(72490,5428),(72491,5428),(72492,5429),(72493,5429),(72494,5429),(72495,5429),(72496,5430),(72497,5430),(72498,5430),(72499,5430),(72500,5431),(72501,5431),(72502,5431),(72503,5431),(72504,5432),(72505,5432),(72506,5432),(72507,5432),(72508,5433),(72509,5433),(72510,5433),(72511,5433),(72512,5434),(72513,5434),(72514,5434),(72515,5434),(72516,5435),(72517,5435),(72518,5435),(72519,5435),(72520,5436),(72521,5436),(72522,5436),(72523,5436),(72524,5437),(72525,5437),(72526,5437),(72527,5437),(72528,5438),(72529,5438),(72530,5438),(72531,5438),(72532,5439),(72533,5439),(72534,5439),(72535,5439),(72536,5440),(72537,5440),(72538,5440),(72539,5440),(72540,5441),(72541,5441),(72542,5441),(72543,5441),(72544,5442),(72545,5442),(72546,5442),(72547,5442),(72548,5443),(72549,5443),(72550,5443),(72551,5443),(72552,5444),(72553,5444),(72554,5444),(72555,5444),(72556,5445),(72557,5445),(72558,5445),(72559,5445),(72560,5446),(72561,5446),(72562,5446),(72563,5446),(72564,5447),(72565,5447),(72566,5447),(72567,5447),(72568,5448),(72569,5448),(72570,5448),(72571,5448),(72572,5449),(72573,5449),(72574,5449),(72575,5449),(72576,5450),(72577,5450),(72578,5450),(72579,5450),(72580,5451),(72581,5451),(72582,5451),(72583,5451),(72584,5452),(72585,5452),(72586,5452),(72587,5452),(72588,5453),(72589,5453),(72590,5453),(72591,5453),(72592,5454),(72593,5454),(72594,5454),(72595,5454),(72596,5455),(72597,5455),(72598,5455),(72599,5455),(72600,5456),(72601,5456),(72602,5456),(72603,5456),(72604,5457),(72605,5457),(72606,5457),(72607,5457),(72608,5458),(72609,5458),(72610,5458),(72611,5458),(72612,5459),(72613,5459),(72614,5459),(72615,5459),(72616,5460),(72617,5460),(72618,5460),(72619,5460),(72620,5460),(72621,5460),(72622,5461),(72623,5461),(72624,5461),(72625,5461),(72626,5461),(72627,5461),(72628,5462),(72629,5462),(72630,5462),(72631,5462),(72632,5462),(72633,5462),(72634,5463),(72635,5463),(72636,5463),(72637,5463),(72638,5463),(72639,5463),(72640,5464),(72641,5464),(72642,5464),(72643,5464),(72644,5464),(72645,5464),(72646,5465),(72647,5465),(72648,5465),(72649,5465),(72650,5465),(72651,5465),(72652,5466),(72653,5466),(72654,5466),(72655,5466),(72656,5466),(72657,5466),(72658,5467),(72659,5467),(72660,5467),(72661,5467),(72662,5467),(72663,5467),(72664,5468),(72665,5468),(72666,5468),(72667,5468),(72668,5468),(72669,5468),(72670,5469),(72671,5469),(72672,5469),(72673,5469),(72674,5469),(72675,5469),(72676,5470),(72677,5470),(72678,5470),(72679,5470),(72680,5470),(72681,5470),(72682,5471),(72683,5471),(72684,5471),(72685,5471),(72686,5471),(72687,5471),(72688,5472),(72689,5472),(72690,5472),(72691,5472),(72692,5472),(72693,5472),(72694,5473),(72695,5473),(72696,5473),(72697,5473),(72698,5473),(72699,5473),(72700,5474),(72701,5474),(72702,5474),(72703,5474),(72704,5474),(72705,5474),(72706,5475),(72707,5475),(72708,5475),(72709,5475),(72710,5475),(72711,5475),(72712,5476),(72713,5476),(72714,5476),(72715,5476),(72716,5476),(72717,5476),(72718,5477),(72719,5477),(72720,5477),(72721,5477),(72722,5477),(72723,5477),(72724,5478),(72725,5478),(72726,5478),(72727,5478),(72728,5478),(72729,5478),(72730,5479),(72731,5479),(72732,5479),(72733,5479),(72734,5479),(72735,5479),(72736,5480),(72737,5480),(72738,5480),(72739,5480),(72740,5480),(72741,5480),(72742,5481),(72743,5481),(72744,5481),(72745,5481),(72746,5481),(72747,5481),(72748,5482),(72749,5482),(72750,5482),(72751,5482),(72752,5482),(72753,5482),(72754,5483),(72755,5483),(72756,5483),(72757,5483),(72758,5483),(72759,5483),(72760,5484),(72761,5484),(72762,5484),(72763,5484),(72764,5484),(72765,5484),(72766,5485),(72767,5485),(72768,5485),(72769,5485),(72770,5485),(72771,5485),(72772,5486),(72773,5486),(72774,5486),(72775,5486),(72776,5486),(72777,5486),(72778,5487),(72779,5487),(72780,5487),(72781,5487),(72782,5487),(72783,5487),(72784,5488),(72785,5488),(72786,5488),(72787,5488),(72788,5488),(72789,5488),(72790,5489),(72791,5489),(72792,5489),(72793,5489),(72794,5489),(72795,5489),(72796,5490),(72797,5490),(72798,5490),(72799,5490),(72800,5490),(72801,5490),(72802,5491),(72803,5491),(72804,5491),(72805,5491),(72806,5491),(72807,5491),(72808,5492),(72809,5492),(72810,5492),(72811,5492),(72812,5492),(72813,5492),(72814,5493),(72815,5493),(72816,5493),(72817,5493),(72818,5493),(72819,5493),(72820,5494),(72821,5494),(72822,5494),(72823,5494),(72824,5494),(72825,5494),(72826,5495),(72827,5495),(72828,5495),(72829,5495),(72830,5495),(72831,5495),(72832,5496),(72833,5496),(72834,5496),(72835,5496),(72836,5496),(72837,5496),(72838,5497),(72839,5497),(72840,5497),(72841,5497),(72842,5497),(72843,5497),(72844,5498),(72845,5498),(72846,5498),(72847,5498),(72848,5498),(72849,5498),(72850,5499),(72851,5499),(72852,5499),(72853,5499),(72854,5499),(72855,5499),(72856,5500),(72857,5500),(72858,5500),(72859,5500),(72860,5500),(72861,5500),(72862,5501),(72863,5501),(72864,5501),(72865,5501),(72866,5501),(72867,5501),(72868,5502),(72869,5502),(72870,5502),(72871,5502),(72872,5502),(72873,5502),(72874,5503),(72875,5503),(72876,5503),(72877,5503),(72878,5503),(72879,5503),(72880,5504),(72881,5504),(72882,5504),(72883,5504),(72884,5504),(72885,5504),(72886,5505),(72887,5505),(72888,5505),(72889,5505),(72890,5505),(72891,5505),(72892,5506),(72893,5506),(72894,5506),(72895,5506),(72896,5506),(72897,5506),(72898,5507),(72899,5507),(72900,5507),(72901,5507),(72902,5507),(72903,5507),(72904,5508),(72905,5508),(72906,5508),(72907,5508),(72908,5508),(72909,5508),(72910,5509),(72911,5509),(72912,5509),(72913,5509),(72914,5509),(72915,5509),(72916,5510),(72917,5510),(72918,5510),(72919,5510),(72920,5510),(72921,5510),(72922,5511),(72923,5511),(72924,5511),(72925,5511),(72926,5511),(72927,5511),(72928,5512),(72929,5512),(72930,5512),(72931,5512),(72932,5512),(72933,5512),(72934,5513),(72935,5513),(72936,5513),(72937,5513),(72938,5513),(72939,5513),(72940,5514),(72941,5514),(72942,5514),(72943,5514),(72944,5514),(72945,5514),(72946,5515),(72947,5515),(72948,5515),(72949,5515),(72950,5515),(72951,5515),(72952,5516),(72953,5516),(72954,5516),(72955,5516),(72956,5516),(72957,5516),(72958,5517),(72959,5517),(72960,5517),(72961,5517),(72962,5517),(72963,5517),(72964,5518),(72965,5518),(72966,5518),(72967,5518),(72968,5518),(72969,5518),(72970,5519),(72971,5519),(72972,5519),(72973,5519),(72974,5519),(72975,5519),(72976,5520),(72977,5520),(72978,5520),(72979,5520),(72980,5520),(72981,5520),(72982,5521),(72983,5521),(72984,5521),(72985,5521),(72986,5521),(72987,5521),(72988,5522),(72989,5522),(72990,5522),(72991,5522),(72992,5522),(72993,5522),(72994,5523),(72995,5523),(72996,5523),(72997,5523),(72998,5523),(72999,5523),(73000,5524),(73001,5524),(73002,5524),(73003,5524),(73004,5524),(73005,5525),(73006,5525),(73007,5525),(73008,5525),(73009,5525),(73010,5525),(73011,5526),(73012,5526),(73013,5526),(73014,5526),(73015,5526),(73016,5526),(73017,5527),(73018,5527),(73019,5527),(73020,5527),(73021,5527),(73022,5527),(73023,5528),(73024,5528),(73025,5528),(73026,5528),(73027,5528),(73028,5528),(73029,5529),(73030,5529),(73031,5529),(73032,5529),(73033,5529),(73034,5529),(73035,5530),(73036,5530),(73037,5530),(73038,5530),(73039,5530),(73040,5530),(73041,5531),(73042,5531),(73043,5531),(73044,5531),(73045,5531),(73046,5531),(73047,5532),(73048,5532),(73049,5532),(73050,5532),(73051,5532),(73052,5532),(73053,5533),(73054,5533),(73055,5533),(73056,5533),(73057,5533),(73058,5533),(73059,5534),(73060,5534),(73061,5534),(73062,5534),(73063,5534),(73064,5534),(73065,5535),(73066,5535),(73067,5535),(73068,5535),(73069,5535),(73070,5535),(73071,5536),(73072,5536),(73073,5536),(73074,5536),(73075,5536),(73076,5536),(73077,5537),(73078,5537),(73079,5537),(73080,5537),(73081,5537),(73082,5537),(73083,5538),(73084,5538),(73085,5538),(73086,5538),(73087,5538),(73088,5538),(73089,5539),(73090,5539),(73091,5539),(73092,5539),(73093,5539),(73094,5539),(73095,5540),(73096,5540),(73097,5540),(73098,5540),(73099,5540),(73100,5540),(73101,5541),(73102,5541),(73103,5541),(73104,5541),(73105,5541),(73106,5541),(73107,5542),(73108,5542),(73109,5542),(73110,5542),(73111,5542),(73112,5542),(73113,5543),(73114,5543),(73115,5543),(73116,5543),(73117,5543),(73118,5543),(73119,5544),(73120,5544),(73121,5544),(73122,5544),(73123,5544),(73124,5544),(73125,5545),(73126,5545),(73127,5545),(73128,5545),(73129,5545),(73130,5545),(73131,5546),(73132,5546),(73133,5546),(73134,5546),(73135,5546),(73136,5546),(73137,5547),(73138,5547),(73139,5547),(73140,5547),(73141,5547),(73142,5547),(73143,5548),(73144,5548),(73145,5548),(73146,5548),(73147,5548),(73148,5548),(73149,5549),(73150,5549),(73151,5549),(73152,5549),(73153,5549),(73154,5549),(73155,5550),(73156,5550),(73157,5550),(73158,5550),(73159,5550),(73160,5550),(73161,5551),(73162,5551),(73163,5551),(73164,5551),(73165,5551),(73166,5551),(73167,5552),(73168,5552),(73169,5552),(73170,5552),(73171,5552),(73172,5552),(73173,5553),(73174,5553),(73175,5553),(73176,5553),(73177,5553),(73178,5553),(73179,5554),(73180,5554),(73181,5554),(73182,5554),(73183,5554),(73184,5554),(73185,5555),(73186,5555),(73187,5555),(73188,5555),(73189,5555),(73190,5555),(73191,5556),(73192,5556),(73193,5556),(73194,5556),(73195,5556),(73196,5556),(73197,5557),(73198,5557),(73199,5557),(73200,5557),(73201,5557),(73202,5557),(73203,5558),(73204,5558),(73205,5558),(73206,5558),(73207,5558),(73208,5558),(73209,5559),(73210,5559),(73211,5559),(73212,5559),(73213,5559),(73214,5559),(73215,5460),(73216,5460),(73217,5460),(73218,5461),(73219,5461),(73220,5461),(73221,5462),(73222,5462),(73223,5462),(73224,5463),(73225,5463),(73226,5463),(73227,5464),(73228,5464),(73229,5464),(73230,5465),(73231,5465),(73232,5465),(73233,5466),(73234,5466),(73235,5466),(73236,5467),(73237,5467),(73238,5467),(73239,5468),(73240,5468),(73241,5468),(73242,5469),(73243,5469),(73244,5469),(73245,5470),(73246,5470),(73247,5470),(73248,5471),(73249,5471),(73250,5471),(73251,5471),(73252,5472),(73253,5472),(73254,5472),(73255,5472),(73256,5473),(73257,5473),(73258,5473),(73259,5474),(73260,5474),(73261,5474),(73262,5475),(73263,5475),(73264,5475),(73265,5476),(73266,5476),(73267,5476),(73268,5477),(73269,5477),(73270,5477),(73271,5478),(73272,5478),(73273,5478),(73274,5479),(73275,5479),(73276,5479),(73277,5480),(73278,5480),(73279,5480),(73280,5481),(73281,5481),(73282,5481),(73283,5482),(73284,5482),(73285,5482),(73286,5483),(73287,5483),(73288,5483),(73289,5484),(73290,5484),(73291,5484),(73292,5485),(73293,5485),(73294,5485),(73295,5486),(73296,5486),(73297,5486),(73298,5487),(73299,5487),(73300,5487),(73301,5488),(73302,5488),(73303,5488),(73304,5489),(73305,5489),(73306,5489),(73307,5490),(73308,5490),(73309,5490),(73310,5491),(73311,5491),(73312,5491),(73313,5492),(73314,5492),(73315,5492),(73316,5493),(73317,5493),(73318,5493),(73319,5494),(73320,5494),(73321,5494),(73322,5495),(73323,5495),(73324,5495),(73325,5496),(73326,5496),(73327,5496),(73328,5497),(73329,5497),(73330,5497),(73331,5498),(73332,5498),(73333,5498),(73334,5499),(73335,5499),(73336,5499),(73337,5500),(73338,5500),(73339,5500),(73340,5501),(73341,5501),(73342,5501),(73343,5502),(73344,5502),(73345,5502),(73346,5503),(73347,5503),(73348,5503),(73349,5504),(73350,5504),(73351,5504),(73352,5505),(73353,5505),(73354,5505),(73355,5506),(73356,5506),(73357,5506),(73358,5507),(73359,5507),(73360,5507),(73361,5508),(73362,5508),(73363,5508),(73364,5509),(73365,5509),(73366,5509),(73367,5510),(73368,5510),(73369,5510),(73370,5511),(73371,5511),(73372,5511),(73373,5512),(73374,5512),(73375,5512),(73376,5513),(73377,5513),(73378,5513),(73379,5514),(73380,5514),(73381,5514),(73382,5515),(73383,5515),(73384,5515),(73385,5516),(73386,5516),(73387,5516),(73388,5517),(73389,5517),(73390,5517),(73391,5518),(73392,5518),(73393,5518),(73394,5519),(73395,5519),(73396,5519),(73397,5520),(73398,5520),(73399,5520),(73400,5521),(73401,5521),(73402,5521),(73403,5522),(73404,5522),(73405,5522),(73406,5523),(73407,5523),(73408,5523),(73409,5524),(73410,5524),(73411,5524),(73412,5525),(73413,5525),(73414,5525),(73415,5526),(73416,5526),(73417,5526),(73418,5527),(73419,5527),(73420,5527),(73421,5528),(73422,5528),(73423,5528),(73424,5529),(73425,5529),(73426,5529),(73427,5530),(73428,5530),(73429,5530),(73430,5531),(73431,5531),(73432,5531),(73433,5532),(73434,5532),(73435,5532),(73436,5533),(73437,5533),(73438,5533),(73439,5534),(73440,5534),(73441,5534),(73442,5535),(73443,5535),(73444,5535),(73445,5536),(73446,5536),(73447,5537),(73448,5537),(73449,5538),(73450,5538),(73451,5538),(73452,5539),(73453,5539),(73454,5539),(73455,5540),(73456,5540),(73457,5540),(73458,5540),(73459,5541),(73460,5541),(73461,5541),(73462,5541),(73463,5542),(73464,5542),(73465,5542),(73466,5542),(73467,5543),(73468,5543),(73469,5543),(73470,5543),(73471,5544),(73472,5544),(73473,5544),(73474,5544),(73475,5545),(73476,5545),(73477,5545),(73478,5545),(73479,5546),(73480,5546),(73481,5546),(73482,5547),(73483,5547),(73484,5547),(73485,5548),(73486,5548),(73487,5548),(73488,5549),(73489,5549),(73490,5549),(73491,5550),(73492,5550),(73493,5550),(73494,5551),(73495,5551),(73496,5551),(73497,5552),(73498,5552),(73499,5552),(73500,5553),(73501,5553),(73502,5553),(73503,5554),(73504,5554),(73505,5554),(73506,5555),(73507,5555),(73508,5555),(73509,5556),(73510,5556),(73511,5556),(73512,5557),(73513,5557),(73514,5557),(73515,5558),(73516,5558),(73517,5558),(73518,5559),(73519,5559),(73520,5559),(73521,5460),(73522,5460),(73523,5460),(73524,5460),(73525,5461),(73526,5461),(73527,5461),(73528,5461),(73529,5462),(73530,5462),(73531,5462),(73532,5462),(73533,5463),(73534,5463),(73535,5463),(73536,5463),(73537,5464),(73538,5464),(73539,5464),(73540,5464),(73541,5465),(73542,5465),(73543,5465),(73544,5465),(73545,5466),(73546,5466),(73547,5466),(73548,5466),(73549,5467),(73550,5467),(73551,5467),(73552,5467),(73553,5468),(73554,5468),(73555,5468),(73556,5468),(73557,5469),(73558,5469),(73559,5469),(73560,5469),(73561,5470),(73562,5470),(73563,5470),(73564,5470),(73565,5471),(73566,5471),(73567,5471),(73568,5471),(73569,5472),(73570,5472),(73571,5472),(73572,5472),(73573,5473),(73574,5473),(73575,5473),(73576,5473),(73577,5474),(73578,5474),(73579,5474),(73580,5474),(73581,5475),(73582,5475),(73583,5475),(73584,5475),(73585,5476),(73586,5476),(73587,5476),(73588,5476),(73589,5477),(73590,5477),(73591,5477),(73592,5477),(73593,5478),(73594,5478),(73595,5478),(73596,5478),(73597,5479),(73598,5479),(73599,5479),(73600,5479),(73601,5480),(73602,5480),(73603,5480),(73604,5480),(73605,5481),(73606,5481),(73607,5481),(73608,5481),(73609,5482),(73610,5482),(73611,5482),(73612,5482),(73613,5483),(73614,5483),(73615,5483),(73616,5483),(73617,5484),(73618,5484),(73619,5484),(73620,5484),(73621,5485),(73622,5485),(73623,5485),(73624,5485),(73625,5486),(73626,5486),(73627,5486),(73628,5486),(73629,5487),(73630,5487),(73631,5487),(73632,5487),(73633,5488),(73634,5488),(73635,5488),(73636,5488),(73637,5489),(73638,5489),(73639,5489),(73640,5489),(73641,5490),(73642,5490),(73643,5490),(73644,5490),(73645,5491),(73646,5491),(73647,5491),(73648,5491),(73649,5492),(73650,5492),(73651,5492),(73652,5492),(73653,5493),(73654,5493),(73655,5493),(73656,5493),(73657,5494),(73658,5494),(73659,5494),(73660,5494),(73661,5495),(73662,5495),(73663,5495),(73664,5495),(73665,5496),(73666,5496),(73667,5496),(73668,5496),(73669,5497),(73670,5497),(73671,5497),(73672,5497),(73673,5498),(73674,5498),(73675,5498),(73676,5498),(73677,5499),(73678,5499),(73679,5499),(73680,5499),(73681,5500),(73682,5500),(73683,5500),(73684,5500),(73685,5501),(73686,5501),(73687,5501),(73688,5501),(73689,5502),(73690,5502),(73691,5502),(73692,5502),(73693,5503),(73694,5503),(73695,5503),(73696,5503),(73697,5504),(73698,5504),(73699,5504),(73700,5504),(73701,5505),(73702,5505),(73703,5505),(73704,5505),(73705,5506),(73706,5506),(73707,5506),(73708,5506),(73709,5507),(73710,5507),(73711,5507),(73712,5507),(73713,5508),(73714,5508),(73715,5508),(73716,5508),(73717,5509),(73718,5509),(73719,5509),(73720,5509),(73721,5510),(73722,5510),(73723,5510),(73724,5510),(73725,5511),(73726,5511),(73727,5511),(73728,5511),(73729,5512),(73730,5512),(73731,5512),(73732,5512),(73733,5513),(73734,5513),(73735,5513),(73736,5513),(73737,5514),(73738,5514),(73739,5514),(73740,5514),(73741,5515),(73742,5515),(73743,5515),(73744,5515),(73745,5516),(73746,5516),(73747,5516),(73748,5516),(73749,5517),(73750,5517),(73751,5517),(73752,5517),(73753,5518),(73754,5518),(73755,5518),(73756,5518),(73757,5519),(73758,5519),(73759,5519),(73760,5519),(73761,5520),(73762,5520),(73763,5520),(73764,5520),(73765,5521),(73766,5521),(73767,5521),(73768,5521),(73769,5522),(73770,5522),(73771,5522),(73772,5522),(73773,5523),(73774,5523),(73775,5523),(73776,5523),(73777,5524),(73778,5524),(73779,5524),(73780,5524),(73781,5525),(73782,5525),(73783,5525),(73784,5525),(73785,5526),(73786,5526),(73787,5526),(73788,5526),(73789,5527),(73790,5527),(73791,5527),(73792,5527),(73793,5528),(73794,5528),(73795,5528),(73796,5528),(73797,5529),(73798,5529),(73799,5529),(73800,5529),(73801,5530),(73802,5530),(73803,5530),(73804,5530),(73805,5531),(73806,5531),(73807,5531),(73808,5531),(73809,5532),(73810,5532),(73811,5532),(73812,5532),(73813,5533),(73814,5533),(73815,5533),(73816,5533),(73817,5534),(73818,5534),(73819,5534),(73820,5534),(73821,5535),(73822,5535),(73823,5535),(73824,5535),(73825,5536),(73826,5536),(73827,5536),(73828,5536),(73829,5537),(73830,5537),(73831,5537),(73832,5537),(73833,5538),(73834,5538),(73835,5538),(73836,5538),(73837,5539),(73838,5539),(73839,5539),(73840,5539),(73841,5540),(73842,5540),(73843,5540),(73844,5540),(73845,5541),(73846,5541),(73847,5541),(73848,5541),(73849,5542),(73850,5542),(73851,5542),(73852,5542),(73853,5543),(73854,5543),(73855,5543),(73856,5543),(73857,5544),(73858,5544),(73859,5544),(73860,5544),(73861,5545),(73862,5545),(73863,5545),(73864,5545),(73865,5546),(73866,5546),(73867,5546),(73868,5546),(73869,5547),(73870,5547),(73871,5547),(73872,5547),(73873,5548),(73874,5548),(73875,5548),(73876,5548),(73877,5549),(73878,5549),(73879,5549),(73880,5549),(73881,5550),(73882,5550),(73883,5550),(73884,5550),(73885,5551),(73886,5551),(73887,5551),(73888,5551),(73889,5552),(73890,5552),(73891,5552),(73892,5552),(73893,5553),(73894,5553),(73895,5553),(73896,5553),(73897,5554),(73898,5554),(73899,5554),(73900,5554),(73901,5555),(73902,5555),(73903,5555),(73904,5555),(73905,5556),(73906,5556),(73907,5556),(73908,5556),(73909,5557),(73910,5557),(73911,5557),(73912,5557),(73913,5558),(73914,5558),(73915,5558),(73916,5558),(73917,5559),(73918,5559),(73919,5559),(73920,5559),(73921,5560),(73922,5560),(73923,5560),(73924,5560),(73925,5560),(73926,5560),(73927,5561),(73928,5561),(73929,5561),(73930,5561),(73931,5561),(73932,5561),(73933,5562),(73934,5562),(73935,5562),(73936,5562),(73937,5562),(73938,5562),(73939,5563),(73940,5563),(73941,5563),(73942,5563),(73943,5563),(73944,5563),(73945,5564),(73946,5564),(73947,5564),(73948,5564),(73949,5564),(73950,5564),(73951,5565),(73952,5565),(73953,5565),(73954,5565),(73955,5565),(73956,5565),(73957,5566),(73958,5566),(73959,5566),(73960,5566),(73961,5566),(73962,5566),(73963,5567),(73964,5567),(73965,5567),(73966,5567),(73967,5567),(73968,5567),(73969,5568),(73970,5568),(73971,5568),(73972,5568),(73973,5568),(73974,5568),(73975,5569),(73976,5569),(73977,5569),(73978,5569),(73979,5569),(73980,5569),(73981,5570),(73982,5570),(73983,5570),(73984,5570),(73985,5570),(73986,5571),(73987,5571),(73988,5571),(73989,5571),(73990,5571),(73991,5571),(73992,5572),(73993,5572),(73994,5572),(73995,5572),(73996,5572),(73997,5572),(73998,5573),(73999,5573),(74000,5573),(74001,5573),(74002,5573),(74003,5573),(74004,5574),(74005,5574),(74006,5574),(74007,5574),(74008,5574),(74009,5574),(74010,5575),(74011,5575),(74012,5575),(74013,5575),(74014,5575),(74015,5575),(74016,5576),(74017,5576),(74018,5576),(74019,5576),(74020,5576),(74021,5576),(74022,5577),(74023,5577),(74024,5577),(74025,5577),(74026,5578),(74027,5578),(74028,5578),(74029,5578),(74030,5578),(74031,5578),(74032,5579),(74033,5579),(74034,5579),(74035,5579),(74036,5579),(74037,5579),(74038,5580),(74039,5580),(74040,5580),(74041,5580),(74042,5581),(74043,5581),(74044,5581),(74045,5581),(74046,5582),(74047,5582),(74048,5582),(74049,5582),(74050,5582),(74051,5582),(74052,5583),(74053,5583),(74054,5583),(74055,5583),(74056,5583),(74057,5583),(74058,5584),(74059,5584),(74060,5584),(74061,5584),(74062,5584),(74063,5584),(74064,5585),(74065,5585),(74066,5585),(74067,5585),(74068,5585),(74069,5585),(74070,5586),(74071,5586),(74072,5586),(74073,5586),(74074,5586),(74075,5587),(74076,5587),(74077,5587),(74078,5587),(74079,5587),(74080,5588),(74081,5588),(74082,5588),(74083,5588),(74084,5588),(74085,5589),(74086,5589),(74087,5589),(74088,5589),(74089,5589),(74090,5590),(74091,5590),(74092,5590),(74093,5590),(74094,5590),(74095,5590),(74096,5591),(74097,5591),(74098,5591),(74099,5591),(74100,5591),(74101,5591),(74102,5592),(74103,5592),(74104,5592),(74105,5592),(74106,5592),(74107,5592),(74108,5593),(74109,5593),(74110,5593),(74111,5593),(74112,5593),(74113,5593),(74114,5594),(74115,5594),(74116,5594),(74117,5594),(74118,5594),(74119,5594),(74120,5595),(74121,5595),(74122,5595),(74123,5595),(74124,5595),(74125,5595),(74126,5596),(74127,5596),(74128,5596),(74129,5596),(74130,5596),(74131,5596),(74132,5597),(74133,5597),(74134,5597),(74135,5597),(74136,5597),(74137,5597),(74138,5598),(74139,5598),(74140,5598),(74141,5598),(74142,5598),(74143,5598),(74144,5599),(74145,5599),(74146,5599),(74147,5599),(74148,5599),(74149,5599),(74150,5600),(74151,5600),(74152,5600),(74153,5600),(74154,5600),(74155,5600),(74156,5601),(74157,5601),(74158,5601),(74159,5601),(74160,5601),(74161,5601),(74162,5602),(74163,5602),(74164,5602),(74165,5602),(74166,5602),(74167,5602),(74168,5603),(74169,5603),(74170,5603),(74171,5603),(74172,5603),(74173,5603),(74174,5604),(74175,5604),(74176,5604),(74177,5604),(74178,5604),(74179,5604),(74180,5605),(74181,5605),(74182,5605),(74183,5605),(74184,5605),(74185,5605),(74186,5606),(74187,5606),(74188,5606),(74189,5606),(74190,5606),(74191,5606),(74192,5607),(74193,5607),(74194,5607),(74195,5607),(74196,5607),(74197,5607),(74198,5608),(74199,5608),(74200,5608),(74201,5608),(74202,5608),(74203,5608),(74204,5609),(74205,5609),(74206,5609),(74207,5609),(74208,5609),(74209,5609),(74210,5610),(74211,5610),(74212,5610),(74213,5610),(74214,5610),(74215,5610),(74216,5611),(74217,5611),(74218,5611),(74219,5611),(74220,5611),(74221,5611),(74222,5612),(74223,5612),(74224,5612),(74225,5612),(74226,5612),(74227,5612),(74228,5613),(74229,5613),(74230,5613),(74231,5613),(74232,5613),(74233,5613),(74234,5614),(74235,5614),(74236,5614),(74237,5614),(74238,5614),(74239,5614),(74240,5615),(74241,5615),(74242,5615),(74243,5615),(74244,5615),(74245,5615),(74246,5616),(74247,5616),(74248,5616),(74249,5616),(74250,5616),(74251,5616),(74252,5617),(74253,5617),(74254,5617),(74255,5617),(74256,5617),(74257,5617),(74258,5618),(74259,5618),(74260,5618),(74261,5618),(74262,5618),(74263,5618),(74264,5619),(74265,5619),(74266,5619),(74267,5619),(74268,5619),(74269,5619),(74270,5620),(74271,5620),(74272,5620),(74273,5620),(74274,5620),(74275,5620),(74276,5621),(74277,5621),(74278,5621),(74279,5621),(74280,5621),(74281,5621),(74282,5622),(74283,5622),(74284,5622),(74285,5622),(74286,5622),(74287,5622),(74288,5623),(74289,5623),(74290,5623),(74291,5623),(74292,5623),(74293,5623),(74294,5624),(74295,5624),(74296,5624),(74297,5624),(74298,5624),(74299,5624),(74300,5625),(74301,5625),(74302,5625),(74303,5625),(74304,5625),(74305,5625),(74306,5626),(74307,5626),(74308,5626),(74309,5626),(74310,5626),(74311,5626),(74312,5627),(74313,5627),(74314,5627),(74315,5627),(74316,5627),(74317,5627),(74318,5628),(74319,5628),(74320,5628),(74321,5628),(74322,5628),(74323,5628),(74324,5629),(74325,5629),(74326,5629),(74327,5629),(74328,5629),(74329,5629),(74330,5630),(74331,5630),(74332,5630),(74333,5630),(74334,5630),(74335,5630),(74336,5631),(74337,5631),(74338,5631),(74339,5631),(74340,5631),(74341,5631),(74342,5632),(74343,5632),(74344,5632),(74345,5632),(74346,5632),(74347,5632),(74348,5633),(74349,5633),(74350,5633),(74351,5633),(74352,5633),(74353,5633),(74354,5634),(74355,5634),(74356,5634),(74357,5634),(74358,5634),(74359,5634),(74360,5635),(74361,5635),(74362,5635),(74363,5635),(74364,5635),(74365,5635),(74366,5636),(74367,5636),(74368,5636),(74369,5636),(74370,5636),(74371,5636),(74372,5637),(74373,5637),(74374,5637),(74375,5637),(74376,5637),(74377,5637),(74378,5638),(74379,5638),(74380,5638),(74381,5638),(74382,5638),(74383,5638),(74384,5639),(74385,5639),(74386,5639),(74387,5639),(74388,5639),(74389,5639),(74390,5640),(74391,5640),(74392,5640),(74393,5640),(74394,5640),(74395,5640),(74396,5641),(74397,5641),(74398,5641),(74399,5641),(74400,5641),(74401,5641),(74402,5642),(74403,5642),(74404,5642),(74405,5642),(74406,5642),(74407,5642),(74408,5643),(74409,5643),(74410,5643),(74411,5643),(74412,5643),(74413,5643),(74414,5644),(74415,5644),(74416,5644),(74417,5644),(74418,5644),(74419,5644),(74420,5645),(74421,5645),(74422,5645),(74423,5645),(74424,5645),(74425,5645),(74426,5646),(74427,5646),(74428,5646),(74429,5646),(74430,5646),(74431,5646),(74432,5647),(74433,5647),(74434,5647),(74435,5647),(74436,5647),(74437,5647),(74438,5648),(74439,5648),(74440,5648),(74441,5648),(74442,5648),(74443,5648),(74444,5649),(74445,5649),(74446,5649),(74447,5649),(74448,5649),(74449,5649),(74450,5650),(74451,5650),(74452,5650),(74453,5650),(74454,5650),(74455,5650),(74456,5651),(74457,5651),(74458,5651),(74459,5651),(74460,5651),(74461,5651),(74462,5652),(74463,5652),(74464,5652),(74465,5652),(74466,5652),(74467,5652),(74468,5653),(74469,5653),(74470,5653),(74471,5653),(74472,5653),(74473,5653),(74474,5654),(74475,5654),(74476,5654),(74477,5654),(74478,5654),(74479,5654),(74480,5655),(74481,5655),(74482,5655),(74483,5655),(74484,5655),(74485,5655),(74486,5656),(74487,5656),(74488,5656),(74489,5656),(74490,5656),(74491,5656),(74492,5657),(74493,5657),(74494,5657),(74495,5657),(74496,5657),(74497,5657),(74498,5658),(74499,5658),(74500,5658),(74501,5658),(74502,5658),(74503,5658),(74504,5659),(74505,5659),(74506,5659),(74507,5659),(74508,5659),(74509,5659),(74510,5560),(74511,5560),(74512,5560),(74513,5561),(74514,5561),(74515,5561),(74516,5562),(74517,5562),(74518,5562),(74519,5563),(74520,5563),(74521,5563),(74522,5564),(74523,5564),(74524,5564),(74525,5565),(74526,5565),(74527,5565),(74528,5566),(74529,5566),(74530,5566),(74531,5567),(74532,5567),(74533,5567),(74534,5568),(74535,5568),(74536,5568),(74537,5569),(74538,5569),(74539,5569),(74540,5570),(74541,5570),(74542,5570),(74543,5571),(74544,5571),(74545,5571),(74546,5572),(74547,5572),(74548,5572),(74549,5573),(74550,5573),(74551,5573),(74552,5574),(74553,5574),(74554,5574),(74555,5575),(74556,5575),(74557,5575),(74558,5576),(74559,5576),(74560,5576),(74561,5577),(74562,5577),(74563,5577),(74564,5578),(74565,5578),(74566,5578),(74567,5579),(74568,5579),(74569,5579),(74570,5580),(74571,5580),(74572,5580),(74573,5581),(74574,5581),(74575,5581),(74576,5582),(74577,5582),(74578,5582),(74579,5583),(74580,5583),(74581,5583),(74582,5584),(74583,5584),(74584,5584),(74585,5585),(74586,5585),(74587,5585),(74588,5586),(74589,5586),(74590,5586),(74591,5587),(74592,5587),(74593,5587),(74594,5588),(74595,5588),(74596,5588),(74597,5589),(74598,5589),(74599,5589),(74600,5590),(74601,5590),(74602,5590),(74603,5591),(74604,5591),(74605,5591),(74606,5592),(74607,5592),(74608,5592),(74609,5592),(74610,5593),(74611,5593),(74612,5593),(74613,5594),(74614,5594),(74615,5594),(74616,5595),(74617,5595),(74618,5595),(74619,5596),(74620,5596),(74621,5596),(74622,5597),(74623,5597),(74624,5597),(74625,5598),(74626,5598),(74627,5598),(74628,5599),(74629,5599),(74630,5599),(74631,5600),(74632,5600),(74633,5600),(74634,5601),(74635,5601),(74636,5601),(74637,5602),(74638,5602),(74639,5602),(74640,5602),(74641,5603),(74642,5603),(74643,5603),(74644,5603),(74645,5604),(74646,5604),(74647,5604),(74648,5605),(74649,5605),(74650,5605),(74651,5605),(74652,5606),(74653,5606),(74654,5606),(74655,5607),(74656,5607),(74657,5607),(74658,5608),(74659,5608),(74660,5608),(74661,5608),(74662,5609),(74663,5609),(74664,5609),(74665,5609),(74666,5610),(74667,5610),(74668,5610),(74669,5610),(74670,5611),(74671,5611),(74672,5611),(74673,5611),(74674,5612),(74675,5612),(74676,5612),(74677,5612),(74678,5613),(74679,5613),(74680,5613),(74681,5613),(74682,5614),(74683,5614),(74684,5614),(74685,5614),(74686,5615),(74687,5615),(74688,5615),(74689,5616),(74690,5616),(74691,5616),(74692,5617),(74693,5617),(74694,5617),(74695,5618),(74696,5618),(74697,5618),(74698,5619),(74699,5619),(74700,5619),(74701,5620),(74702,5620),(74703,5620),(74704,5620),(74705,5621),(74706,5621),(74707,5621),(74708,5622),(74709,5622),(74710,5622),(74711,5623),(74712,5623),(74713,5623),(74714,5624),(74715,5624),(74716,5624),(74717,5625),(74718,5625),(74719,5625),(74720,5626),(74721,5626),(74722,5626),(74723,5627),(74724,5627),(74725,5627),(74726,5628),(74727,5628),(74728,5628),(74729,5629),(74730,5629),(74731,5629),(74732,5630),(74733,5630),(74734,5630),(74735,5631),(74736,5631),(74737,5631),(74738,5632),(74739,5632),(74740,5632),(74741,5633),(74742,5633),(74743,5633),(74744,5634),(74745,5634),(74746,5634),(74747,5635),(74748,5635),(74749,5635),(74750,5636),(74751,5636),(74752,5636),(74753,5637),(74754,5637),(74755,5637),(74756,5638),(74757,5638),(74758,5638),(74759,5639),(74760,5639),(74761,5639),(74762,5640),(74763,5640),(74764,5640),(74765,5641),(74766,5641),(74767,5641),(74768,5642),(74769,5642),(74770,5642),(74771,5643),(74772,5643),(74773,5643),(74774,5644),(74775,5644),(74776,5644),(74777,5645),(74778,5645),(74779,5645),(74780,5646),(74781,5646),(74782,5646),(74783,5647),(74784,5647),(74785,5647),(74786,5648),(74787,5648),(74788,5648),(74789,5649),(74790,5649),(74791,5649),(74792,5650),(74793,5650),(74794,5650),(74795,5651),(74796,5651),(74797,5651),(74798,5652),(74799,5652),(74800,5652),(74801,5653),(74802,5653),(74803,5653),(74804,5654),(74805,5654),(74806,5654),(74807,5655),(74808,5655),(74809,5655),(74810,5656),(74811,5656),(74812,5656),(74813,5657),(74814,5657),(74815,5657),(74816,5658),(74817,5658),(74818,5658),(74819,5659),(74820,5659),(74821,5659),(74822,5560),(74823,5560),(74824,5560),(74825,5560),(74826,5561),(74827,5561),(74828,5561),(74829,5561),(74830,5562),(74831,5562),(74832,5562),(74833,5562),(74834,5563),(74835,5563),(74836,5563),(74837,5563),(74838,5564),(74839,5564),(74840,5564),(74841,5564),(74842,5565),(74843,5565),(74844,5565),(74845,5565),(74846,5566),(74847,5566),(74848,5566),(74849,5566),(74850,5567),(74851,5567),(74852,5567),(74853,5567),(74854,5568),(74855,5568),(74856,5568),(74857,5568),(74858,5569),(74859,5569),(74860,5569),(74861,5569),(74862,5570),(74863,5570),(74864,5570),(74865,5570),(74866,5571),(74867,5571),(74868,5571),(74869,5571),(74870,5572),(74871,5572),(74872,5572),(74873,5572),(74874,5573),(74875,5573),(74876,5573),(74877,5573),(74878,5574),(74879,5574),(74880,5574),(74881,5574),(74882,5575),(74883,5575),(74884,5575),(74885,5575),(74886,5576),(74887,5576),(74888,5576),(74889,5576),(74890,5577),(74891,5577),(74892,5577),(74893,5577),(74894,5578),(74895,5578),(74896,5578),(74897,5578),(74898,5579),(74899,5579),(74900,5579),(74901,5579),(74902,5580),(74903,5580),(74904,5580),(74905,5580),(74906,5581),(74907,5581),(74908,5581),(74909,5581),(74910,5582),(74911,5582),(74912,5582),(74913,5582),(74914,5583),(74915,5583),(74916,5583),(74917,5583),(74918,5584),(74919,5584),(74920,5584),(74921,5584),(74922,5585),(74923,5585),(74924,5585),(74925,5585),(74926,5586),(74927,5586),(74928,5586),(74929,5586),(74930,5587),(74931,5587),(74932,5587),(74933,5587),(74934,5588),(74935,5588),(74936,5588),(74937,5588),(74938,5589),(74939,5589),(74940,5589),(74941,5589),(74942,5590),(74943,5590),(74944,5590),(74945,5590),(74946,5591),(74947,5591),(74948,5591),(74949,5591),(74950,5592),(74951,5592),(74952,5592),(74953,5592),(74954,5593),(74955,5593),(74956,5593),(74957,5593),(74958,5594),(74959,5594),(74960,5594),(74961,5594),(74962,5595),(74963,5595),(74964,5595),(74965,5595),(74966,5596),(74967,5596),(74968,5596),(74969,5596),(74970,5597),(74971,5597),(74972,5597),(74973,5597),(74974,5598),(74975,5598),(74976,5598),(74977,5598),(74978,5599),(74979,5599),(74980,5599),(74981,5599),(74982,5600),(74983,5600),(74984,5600),(74985,5600),(74986,5601),(74987,5601),(74988,5601),(74989,5601),(74990,5602),(74991,5602),(74992,5602),(74993,5602),(74994,5603),(74995,5603),(74996,5603),(74997,5603),(74998,5604),(74999,5604),(75000,5604),(75001,5604),(75002,5605),(75003,5605),(75004,5605),(75005,5605),(75006,5606),(75007,5606),(75008,5606),(75009,5606),(75010,5607),(75011,5607),(75012,5607),(75013,5607),(75014,5608),(75015,5608),(75016,5608),(75017,5608),(75018,5609),(75019,5609),(75020,5609),(75021,5609),(75022,5610),(75023,5610),(75024,5610),(75025,5610),(75026,5611),(75027,5611),(75028,5611),(75029,5611),(75030,5612),(75031,5612),(75032,5612),(75033,5612),(75034,5613),(75035,5613),(75036,5613),(75037,5613),(75038,5614),(75039,5614),(75040,5614),(75041,5614),(75042,5615),(75043,5615),(75044,5615),(75045,5615),(75046,5616),(75047,5616),(75048,5616),(75049,5616),(75050,5617),(75051,5617),(75052,5617),(75053,5617),(75054,5618),(75055,5618),(75056,5618),(75057,5618),(75058,5619),(75059,5619),(75060,5619),(75061,5619),(75062,5620),(75063,5620),(75064,5620),(75065,5620),(75066,5621),(75067,5621),(75068,5621),(75069,5621),(75070,5622),(75071,5622),(75072,5622),(75073,5622),(75074,5623),(75075,5623),(75076,5623),(75077,5623),(75078,5624),(75079,5624),(75080,5624),(75081,5624),(75082,5625),(75083,5625),(75084,5625),(75085,5625),(75086,5626),(75087,5626),(75088,5626),(75089,5626),(75090,5627),(75091,5627),(75092,5627),(75093,5627),(75094,5628),(75095,5628),(75096,5628),(75097,5628),(75098,5629),(75099,5629),(75100,5629),(75101,5629),(75102,5630),(75103,5630),(75104,5630),(75105,5630),(75106,5631),(75107,5631),(75108,5631),(75109,5631),(75110,5632),(75111,5632),(75112,5632),(75113,5632),(75114,5633),(75115,5633),(75116,5633),(75117,5633),(75118,5634),(75119,5634),(75120,5634),(75121,5634),(75122,5635),(75123,5635),(75124,5635),(75125,5635),(75126,5636),(75127,5636),(75128,5636),(75129,5636),(75130,5637),(75131,5637),(75132,5637),(75133,5637),(75134,5638),(75135,5638),(75136,5638),(75137,5638),(75138,5639),(75139,5639),(75140,5639),(75141,5639),(75142,5640),(75143,5640),(75144,5640),(75145,5640),(75146,5641),(75147,5641),(75148,5641),(75149,5641),(75150,5642),(75151,5642),(75152,5642),(75153,5642),(75154,5643),(75155,5643),(75156,5643),(75157,5643),(75158,5644),(75159,5644),(75160,5644),(75161,5644),(75162,5645),(75163,5645),(75164,5645),(75165,5645),(75166,5646),(75167,5646),(75168,5646),(75169,5646),(75170,5647),(75171,5647),(75172,5647),(75173,5647),(75174,5648),(75175,5648),(75176,5648),(75177,5648),(75178,5649),(75179,5649),(75180,5649),(75181,5649),(75182,5650),(75183,5650),(75184,5650),(75185,5650),(75186,5651),(75187,5651),(75188,5651),(75189,5651),(75190,5652),(75191,5652),(75192,5652),(75193,5652),(75194,5653),(75195,5653),(75196,5653),(75197,5653),(75198,5654),(75199,5654),(75200,5654),(75201,5654),(75202,5655),(75203,5655),(75204,5655),(75205,5655),(75206,5656),(75207,5656),(75208,5656),(75209,5656),(75210,5657),(75211,5657),(75212,5657),(75213,5657),(75214,5658),(75215,5658),(75216,5658),(75217,5658),(75218,5659),(75219,5659),(75220,5659),(75221,5659),(75222,5660),(75223,5660),(75224,5660),(75225,5660),(75226,5660),(75227,5660),(75228,5661),(75229,5661),(75230,5661),(75231,5661),(75232,5661),(75233,5661),(75234,5662),(75235,5662),(75236,5662),(75237,5662),(75238,5662),(75239,5662),(75240,5663),(75241,5663),(75242,5663),(75243,5663),(75244,5663),(75245,5663),(75246,5664),(75247,5664),(75248,5664),(75249,5664),(75250,5664),(75251,5664),(75252,5665),(75253,5665),(75254,5665),(75255,5665),(75256,5665),(75257,5665),(75258,5666),(75259,5666),(75260,5666),(75261,5666),(75262,5666),(75263,5666),(75264,5667),(75265,5667),(75266,5667),(75267,5667),(75268,5667),(75269,5667),(75270,5668),(75271,5668),(75272,5668),(75273,5668),(75274,5668),(75275,5668),(75276,5669),(75277,5669),(75278,5669),(75279,5669),(75280,5669),(75281,5669),(75282,5670),(75283,5670),(75284,5670),(75285,5670),(75286,5670),(75287,5670),(75288,5671),(75289,5671),(75290,5671),(75291,5671),(75292,5671),(75293,5671),(75294,5672),(75295,5672),(75296,5672),(75297,5672),(75298,5672),(75299,5672),(75300,5673),(75301,5673),(75302,5673),(75303,5673),(75304,5673),(75305,5673),(75306,5674),(75307,5674),(75308,5674),(75309,5674),(75310,5674),(75311,5674),(75312,5675),(75313,5675),(75314,5675),(75315,5675),(75316,5675),(75317,5675),(75318,5676),(75319,5676),(75320,5676),(75321,5676),(75322,5676),(75323,5676),(75324,5677),(75325,5677),(75326,5677),(75327,5677),(75328,5677),(75329,5677),(75330,5678),(75331,5678),(75332,5678),(75333,5678),(75334,5678),(75335,5678),(75336,5679),(75337,5679),(75338,5679),(75339,5679),(75340,5679),(75341,5679),(75342,5680),(75343,5680),(75344,5680),(75345,5680),(75346,5680),(75347,5680),(75348,5681),(75349,5681),(75350,5681),(75351,5681),(75352,5681),(75353,5681),(75354,5682),(75355,5682),(75356,5682),(75357,5682),(75358,5682),(75359,5682),(75360,5683),(75361,5683),(75362,5683),(75363,5683),(75364,5683),(75365,5683),(75366,5684),(75367,5684),(75368,5684),(75369,5684),(75370,5684),(75371,5684),(75372,5685),(75373,5685),(75374,5685),(75375,5685),(75376,5685),(75377,5685),(75378,5686),(75379,5686),(75380,5686),(75381,5686),(75382,5686),(75383,5686),(75384,5687),(75385,5687),(75386,5687),(75387,5687),(75388,5687),(75389,5687),(75390,5688),(75391,5688),(75392,5688),(75393,5688),(75394,5688),(75395,5688),(75396,5689),(75397,5689),(75398,5689),(75399,5689),(75400,5689),(75401,5689),(75402,5690),(75403,5690),(75404,5690),(75405,5690),(75406,5690),(75407,5690),(75408,5691),(75409,5691),(75410,5691),(75411,5691),(75412,5691),(75413,5691),(75414,5692),(75415,5692),(75416,5692),(75417,5692),(75418,5692),(75419,5692),(75420,5693),(75421,5693),(75422,5693),(75423,5693),(75424,5693),(75425,5693),(75426,5694),(75427,5694),(75428,5694),(75429,5694),(75430,5694),(75431,5694),(75432,5695),(75433,5695),(75434,5695),(75435,5695),(75436,5695),(75437,5695),(75438,5696),(75439,5696),(75440,5696),(75441,5696),(75442,5696),(75443,5696),(75444,5697),(75445,5697),(75446,5697),(75447,5697),(75448,5697),(75449,5697),(75450,5698),(75451,5698),(75452,5698),(75453,5698),(75454,5698),(75455,5698),(75456,5699),(75457,5699),(75458,5699),(75459,5699),(75460,5699),(75461,5699),(75462,5700),(75463,5700),(75464,5700),(75465,5700),(75466,5700),(75467,5700),(75468,5701),(75469,5701),(75470,5701),(75471,5701),(75472,5701),(75473,5701),(75474,5702),(75475,5702),(75476,5702),(75477,5702),(75478,5702),(75479,5702),(75480,5703),(75481,5703),(75482,5703),(75483,5703),(75484,5703),(75485,5703),(75486,5704),(75487,5704),(75488,5704),(75489,5704),(75490,5704),(75491,5704),(75492,5705),(75493,5705),(75494,5705),(75495,5705),(75496,5705),(75497,5705),(75498,5706),(75499,5706),(75500,5706),(75501,5706),(75502,5706),(75503,5706),(75504,5707),(75505,5707),(75506,5707),(75507,5707),(75508,5707),(75509,5707),(75510,5708),(75511,5708),(75512,5708),(75513,5708),(75514,5708),(75515,5708),(75516,5709),(75517,5709),(75518,5709),(75519,5709),(75520,5709),(75521,5709),(75522,5710),(75523,5710),(75524,5710),(75525,5710),(75526,5710),(75527,5710),(75528,5711),(75529,5711),(75530,5711),(75531,5711),(75532,5711),(75533,5711),(75534,5712),(75535,5712),(75536,5712),(75537,5712),(75538,5712),(75539,5712),(75540,5713),(75541,5713),(75542,5713),(75543,5713),(75544,5713),(75545,5713),(75546,5714),(75547,5714),(75548,5714),(75549,5714),(75550,5714),(75551,5714),(75552,5715),(75553,5715),(75554,5715),(75555,5715),(75556,5715),(75557,5715),(75558,5716),(75559,5716),(75560,5716),(75561,5716),(75562,5716),(75563,5716),(75564,5717),(75565,5717),(75566,5717),(75567,5717),(75568,5717),(75569,5717),(75570,5718),(75571,5718),(75572,5718),(75573,5718),(75574,5718),(75575,5718),(75576,5719),(75577,5719),(75578,5719),(75579,5719),(75580,5719),(75581,5719),(75582,5720),(75583,5720),(75584,5720),(75585,5720),(75586,5720),(75587,5720),(75588,5721),(75589,5721),(75590,5721),(75591,5721),(75592,5721),(75593,5721),(75594,5722),(75595,5722),(75596,5722),(75597,5722),(75598,5722),(75599,5722),(75600,5723),(75601,5723),(75602,5723),(75603,5723),(75604,5723),(75605,5723),(75606,5724),(75607,5724),(75608,5724),(75609,5724),(75610,5724),(75611,5724),(75612,5725),(75613,5725),(75614,5725),(75615,5725),(75616,5725),(75617,5725),(75618,5726),(75619,5726),(75620,5726),(75621,5726),(75622,5726),(75623,5726),(75624,5727),(75625,5727),(75626,5727),(75627,5727),(75628,5727),(75629,5727),(75630,5728),(75631,5728),(75632,5728),(75633,5728),(75634,5728),(75635,5728),(75636,5729),(75637,5729),(75638,5729),(75639,5729),(75640,5729),(75641,5729),(75642,5730),(75643,5730),(75644,5730),(75645,5730),(75646,5730),(75647,5730),(75648,5731),(75649,5731),(75650,5731),(75651,5731),(75652,5731),(75653,5731),(75654,5732),(75655,5732),(75656,5732),(75657,5732),(75658,5732),(75659,5732),(75660,5733),(75661,5733),(75662,5733),(75663,5733),(75664,5733),(75665,5733),(75666,5734),(75667,5734),(75668,5734),(75669,5734),(75670,5734),(75671,5734),(75672,5735),(75673,5735),(75674,5735),(75675,5735),(75676,5735),(75677,5735),(75678,5736),(75679,5736),(75680,5736),(75681,5736),(75682,5736),(75683,5736),(75684,5737),(75685,5737),(75686,5737),(75687,5737),(75688,5737),(75689,5737),(75690,5738),(75691,5738),(75692,5738),(75693,5738),(75694,5738),(75695,5738),(75696,5739),(75697,5739),(75698,5739),(75699,5739),(75700,5739),(75701,5739),(75702,5740),(75703,5740),(75704,5740),(75705,5740),(75706,5740),(75707,5740),(75708,5741),(75709,5741),(75710,5741),(75711,5741),(75712,5741),(75713,5741),(75714,5742),(75715,5742),(75716,5742),(75717,5742),(75718,5742),(75719,5742),(75720,5743),(75721,5743),(75722,5743),(75723,5743),(75724,5743),(75725,5743),(75726,5744),(75727,5744),(75728,5744),(75729,5744),(75730,5744),(75731,5744),(75732,5745),(75733,5745),(75734,5745),(75735,5745),(75736,5745),(75737,5745),(75738,5746),(75739,5746),(75740,5746),(75741,5746),(75742,5746),(75743,5746),(75744,5747),(75745,5747),(75746,5747),(75747,5747),(75748,5747),(75749,5747),(75750,5748),(75751,5748),(75752,5748),(75753,5748),(75754,5748),(75755,5748),(75756,5749),(75757,5749),(75758,5749),(75759,5749),(75760,5749),(75761,5749),(75762,5750),(75763,5750),(75764,5750),(75765,5750),(75766,5751),(75767,5751),(75768,5751),(75769,5751),(75770,5751),(75771,5751),(75772,5752),(75773,5752),(75774,5752),(75775,5752),(75776,5752),(75777,5752),(75778,5660),(75779,5660),(75780,5660),(75781,5661),(75782,5661),(75783,5661),(75784,5662),(75785,5662),(75786,5662),(75787,5663),(75788,5663),(75789,5663),(75790,5664),(75791,5664),(75792,5664),(75793,5665),(75794,5665),(75795,5665),(75796,5666),(75797,5666),(75798,5666),(75799,5667),(75800,5667),(75801,5667),(75802,5668),(75803,5668),(75804,5668),(75805,5669),(75806,5669),(75807,5669),(75808,5670),(75809,5670),(75810,5670),(75811,5671),(75812,5671),(75813,5671),(75814,5672),(75815,5672),(75816,5672),(75817,5673),(75818,5673),(75819,5673),(75820,5674),(75821,5674),(75822,5674),(75823,5675),(75824,5675),(75825,5675),(75826,5676),(75827,5676),(75828,5676),(75829,5677),(75830,5677),(75831,5677),(75832,5678),(75833,5678),(75834,5678),(75835,5679),(75836,5679),(75837,5679),(75838,5680),(75839,5680),(75840,5680),(75841,5681),(75842,5681),(75843,5681),(75844,5682),(75845,5682),(75846,5682),(75847,5682),(75848,5683),(75849,5683),(75850,5683),(75851,5683),(75852,5684),(75853,5684),(75854,5684),(75855,5684),(75856,5685),(75857,5685),(75858,5685),(75859,5685),(75860,5686),(75861,5686),(75862,5686),(75863,5686),(75864,5687),(75865,5687),(75866,5687),(75867,5688),(75868,5688),(75869,5688),(75870,5688),(75871,5689),(75872,5689),(75873,5690),(75874,5690),(75875,5690),(75876,5691),(75877,5691),(75878,5691),(75879,5692),(75880,5692),(75881,5692),(75882,5693),(75883,5693),(75884,5693),(75885,5694),(75886,5694),(75887,5694),(75888,5695),(75889,5695),(75890,5695),(75891,5696),(75892,5696),(75893,5697),(75894,5697),(75895,5697),(75896,5698),(75897,5698),(75898,5698),(75899,5699),(75900,5699),(75901,5699),(75902,5700),(75903,5700),(75904,5700),(75905,5701),(75906,5701),(75907,5701),(75908,5702),(75909,5702),(75910,5702),(75911,5703),(75912,5703),(75913,5703),(75914,5704),(75915,5704),(75916,5704),(75917,5705),(75918,5705),(75919,5705),(75920,5706),(75921,5706),(75922,5706),(75923,5707),(75924,5707),(75925,5707),(75926,5708),(75927,5708),(75928,5708),(75929,5709),(75930,5709),(75931,5709),(75932,5709),(75933,5710),(75934,5710),(75935,5710),(75936,5711),(75937,5711),(75938,5711),(75939,5711),(75940,5712),(75941,5712),(75942,5712),(75943,5713),(75944,5713),(75945,5713),(75946,5714),(75947,5714),(75948,5714),(75949,5715),(75950,5715),(75951,5715),(75952,5716),(75953,5716),(75954,5716),(75955,5717),(75956,5717),(75957,5717),(75958,5718),(75959,5718),(75960,5718),(75961,5719),(75962,5719),(75963,5719),(75964,5720),(75965,5720),(75966,5720),(75967,5721),(75968,5721),(75969,5721),(75970,5722),(75971,5722),(75972,5722),(75973,5723),(75974,5723),(75975,5723),(75976,5724),(75977,5724),(75978,5724),(75979,5725),(75980,5725),(75981,5725),(75982,5726),(75983,5726),(75984,5726),(75985,5727),(75986,5727),(75987,5727),(75988,5728),(75989,5728),(75990,5728),(75991,5729),(75992,5729),(75993,5729),(75994,5730),(75995,5730),(75996,5730),(75997,5731),(75998,5731),(75999,5731),(76000,5732),(76001,5732),(76002,5732),(76003,5733),(76004,5733),(76005,5733),(76006,5734),(76007,5734),(76008,5734),(76009,5735),(76010,5735),(76011,5735),(76012,5736),(76013,5736),(76014,5736),(76015,5737),(76016,5737),(76017,5737),(76018,5738),(76019,5738),(76020,5738),(76021,5739),(76022,5739),(76023,5739),(76024,5740),(76025,5740),(76026,5740),(76027,5741),(76028,5741),(76029,5741),(76030,5742),(76031,5742),(76032,5742),(76033,5743),(76034,5743),(76035,5743),(76036,5744),(76037,5744),(76038,5744),(76039,5745),(76040,5745),(76041,5745),(76042,5745),(76043,5746),(76044,5746),(76045,5746),(76046,5746),(76047,5747),(76048,5747),(76049,5747),(76050,5747),(76051,5748),(76052,5748),(76053,5748),(76054,5749),(76055,5749),(76056,5749),(76057,5749),(76058,5750),(76059,5750),(76060,5750),(76061,5751),(76062,5751),(76063,5751),(76064,5752),(76065,5752),(76066,5660),(76067,5660),(76068,5660),(76069,5660),(76070,5661),(76071,5661),(76072,5661),(76073,5661),(76074,5662),(76075,5662),(76076,5662),(76077,5662),(76078,5663),(76079,5663),(76080,5663),(76081,5663),(76082,5664),(76083,5664),(76084,5664),(76085,5664),(76086,5665),(76087,5665),(76088,5665),(76089,5665),(76090,5666),(76091,5666),(76092,5666),(76093,5666),(76094,5667),(76095,5667),(76096,5667),(76097,5667),(76098,5668),(76099,5668),(76100,5668),(76101,5668),(76102,5669),(76103,5669),(76104,5669),(76105,5669),(76106,5670),(76107,5670),(76108,5670),(76109,5670),(76110,5671),(76111,5671),(76112,5671),(76113,5671),(76114,5672),(76115,5672),(76116,5672),(76117,5672),(76118,5673),(76119,5673),(76120,5673),(76121,5673),(76122,5674),(76123,5674),(76124,5674),(76125,5674),(76126,5675),(76127,5675),(76128,5675),(76129,5675),(76130,5676),(76131,5676),(76132,5676),(76133,5676),(76134,5677),(76135,5677),(76136,5677),(76137,5677),(76138,5678),(76139,5678),(76140,5678),(76141,5678),(76142,5679),(76143,5679),(76144,5679),(76145,5679),(76146,5680),(76147,5680),(76148,5680),(76149,5680),(76150,5681),(76151,5681),(76152,5681),(76153,5681),(76154,5682),(76155,5682),(76156,5682),(76157,5682),(76158,5683),(76159,5683),(76160,5683),(76161,5683),(76162,5684),(76163,5684),(76164,5684),(76165,5684),(76166,5685),(76167,5685),(76168,5685),(76169,5685),(76170,5686),(76171,5686),(76172,5686),(76173,5686),(76174,5687),(76175,5687),(76176,5687),(76177,5687),(76178,5688),(76179,5688),(76180,5688),(76181,5688),(76182,5689),(76183,5689),(76184,5689),(76185,5689),(76186,5690),(76187,5690),(76188,5690),(76189,5690),(76190,5691),(76191,5691),(76192,5691),(76193,5691),(76194,5692),(76195,5692),(76196,5692),(76197,5692),(76198,5693),(76199,5693),(76200,5693),(76201,5693),(76202,5694),(76203,5694),(76204,5694),(76205,5694),(76206,5695),(76207,5695),(76208,5695),(76209,5695),(76210,5696),(76211,5696),(76212,5696),(76213,5696),(76214,5697),(76215,5697),(76216,5697),(76217,5697),(76218,5698),(76219,5698),(76220,5698),(76221,5698),(76222,5699),(76223,5699),(76224,5699),(76225,5699),(76226,5700),(76227,5700),(76228,5700),(76229,5700),(76230,5701),(76231,5701),(76232,5701),(76233,5701),(76234,5702),(76235,5702),(76236,5702),(76237,5702),(76238,5703),(76239,5703),(76240,5703),(76241,5703),(76242,5704),(76243,5704),(76244,5704),(76245,5704),(76246,5705),(76247,5705),(76248,5705),(76249,5705),(76250,5706),(76251,5706),(76252,5706),(76253,5706),(76254,5707),(76255,5707),(76256,5707),(76257,5707),(76258,5708),(76259,5708),(76260,5708),(76261,5708),(76262,5709),(76263,5709),(76264,5709),(76265,5709),(76266,5710),(76267,5710),(76268,5710),(76269,5710),(76270,5711),(76271,5711),(76272,5711),(76273,5711),(76274,5712),(76275,5712),(76276,5712),(76277,5712),(76278,5713),(76279,5713),(76280,5713),(76281,5713),(76282,5714),(76283,5714),(76284,5714),(76285,5714),(76286,5715),(76287,5715),(76288,5715),(76289,5715),(76290,5716),(76291,5716),(76292,5716),(76293,5716),(76294,5717),(76295,5717),(76296,5717),(76297,5717),(76298,5718),(76299,5718),(76300,5718),(76301,5718),(76302,5719),(76303,5719),(76304,5719),(76305,5719),(76306,5720),(76307,5720),(76308,5720),(76309,5720),(76310,5721),(76311,5721),(76312,5721),(76313,5721),(76314,5722),(76315,5722),(76316,5722),(76317,5722),(76318,5723),(76319,5723),(76320,5723),(76321,5723),(76322,5724),(76323,5724),(76324,5724),(76325,5724),(76326,5725),(76327,5725),(76328,5725),(76329,5725),(76330,5726),(76331,5726),(76332,5726),(76333,5726),(76334,5727),(76335,5727),(76336,5727),(76337,5727),(76338,5728),(76339,5728),(76340,5728),(76341,5728),(76342,5729),(76343,5729),(76344,5729),(76345,5729),(76346,5730),(76347,5730),(76348,5730),(76349,5730),(76350,5731),(76351,5731),(76352,5731),(76353,5731),(76354,5732),(76355,5732),(76356,5732),(76357,5732),(76358,5733),(76359,5733),(76360,5733),(76361,5733),(76362,5734),(76363,5734),(76364,5734),(76365,5734),(76366,5735),(76367,5735),(76368,5735),(76369,5735),(76370,5736),(76371,5736),(76372,5736),(76373,5736),(76374,5737),(76375,5737),(76376,5737),(76377,5737),(76378,5738),(76379,5738),(76380,5738),(76381,5738),(76382,5739),(76383,5739),(76384,5739),(76385,5739),(76386,5740),(76387,5740),(76388,5740),(76389,5740),(76390,5741),(76391,5741),(76392,5741),(76393,5741),(76394,5742),(76395,5742),(76396,5742),(76397,5742),(76398,5743),(76399,5743),(76400,5743),(76401,5743),(76402,5744),(76403,5744),(76404,5744),(76405,5744),(76406,5745),(76407,5745),(76408,5745),(76409,5745),(76410,5746),(76411,5746),(76412,5746),(76413,5746),(76414,5747),(76415,5747),(76416,5747),(76417,5747),(76418,5748),(76419,5748),(76420,5748),(76421,5748),(76422,5749),(76423,5749),(76424,5749),(76425,5749),(76426,5750),(76427,5750),(76428,5750),(76429,5750),(76430,5751),(76431,5751),(76432,5751),(76433,5751),(76434,5752),(76435,5752),(76436,5752),(76437,5752),(76438,1160),(76439,1160),(76440,1160),(76441,1160),(76442,1160),(76443,1160),(76444,1160),(76445,1160),(76446,1160),(76447,1161),(76448,1161),(76449,1161),(76450,1161),(76451,1161),(76452,1161),(76453,1161),(76454,1161),(76455,1161),(76456,1161),(76457,1162),(76458,1162),(76459,1162),(76460,1162),(76461,1162),(76462,1162),(76463,1162),(76464,1162),(76465,1162),(76466,1119),(76467,1119),(76468,5752),(76469,5752),(76470,5752),(76471,5752),(76472,5752),(76473,5752),(76474,5752),(76475,5752),(76476,5752),(76477,5738),(76478,5738),(76479,5738),(76480,5738),(76481,5738),(76482,5738),(76483,5738),(76484,5738),(76485,5738),(76486,5738),(76487,5738),(76488,4713),(76489,4713),(76490,4713),(76491,4713),(76492,4713),(76493,4713),(76494,4713),(76495,4713),(76496,4713),(76497,5197),(76498,5197),(76499,5197),(76500,5197),(76501,5197),(76502,5197),(76503,5197),(76504,5197),(76505,5197),(76506,5194),(76507,5194),(76508,5194),(76509,5194),(76510,5194),(76511,5194),(76512,5194),(76513,5194),(76514,5194),(76515,5193),(76516,5193),(76517,5193),(76518,5193),(76519,5193),(76520,5193),(76521,5193),(76522,5193),(76523,5193),(76524,5192),(76525,5192),(76526,5192),(76527,5192),(76528,5192),(76529,5192),(76530,5192),(76531,5192),(76532,5192),(76533,5191),(76534,5191),(76535,5191),(76536,5191),(76537,5191),(76538,5191),(76539,5191),(76540,5191),(76541,5191),(76542,5190),(76543,5190),(76544,5190),(76545,5190),(76546,5190),(76547,5190),(76548,5190),(76549,5190),(76550,5190),(76551,4875),(76552,4876),(76553,4876),(76554,4876),(76555,4876),(76556,4876),(76557,4876),(76558,4876),(76559,4876),(76560,4876),(76561,4891),(76562,4892),(76563,4893),(76564,4893),(76565,4893),(76566,4893),(76567,4893),(76568,4893),(76569,4893),(76570,4893),(76571,4893),(76572,4894),(76573,4894),(76574,4894),(76575,4894),(76576,4894),(76577,4894),(76578,4894),(76579,4894),(76580,4894),(76581,4892),(76582,4892),(76583,4892),(76584,4892),(76585,4892),(76586,4892),(76587,4892),(76588,4892),(76589,4875),(76590,4875),(76591,4875),(76592,4875),(76593,4875),(76594,4875),(76595,4875),(76596,4875),(76597,4892),(76598,4892),(76599,4892),(76600,4892),(76601,4892),(76602,4892),(76603,4892),(76604,4892);
INSERT INTO `catalog_product_attribute_cl` VALUES (76605,4891),(76606,4891),(76607,4891),(76608,4891),(76609,4891),(76610,4891),(76611,4891),(76612,4891),(76613,1162),(76614,1162),(76615,1162),(76616,1165),(76617,1165),(76618,1165),(76619,2163),(76620,2163),(76621,2163),(76622,2163),(76623,2163),(76624,2163),(76625,2163),(76626,2176),(76627,2176),(76628,2176),(76629,2176),(76630,2176),(76631,2176),(76632,2176),(76633,1164),(76634,1164),(76635,1164),(76636,4894),(76637,4894),(76638,4894),(76639,4894),(76640,2163),(76641,1),(76642,1),(76643,1),(76644,1),(76645,1),(76646,1),(76647,1),(76648,1),(76649,1),(76650,1),(76651,1),(76652,1),(76653,1),(76654,1),(76655,1),(76656,1),(76657,1),(76658,1),(76659,1),(76660,1),(76661,1),(76662,1),(76663,1),(76664,1),(76665,1),(76666,1),(76667,1),(76668,1),(76669,1),(76670,1),(76671,5753),(76672,5753),(76673,5753),(76674,5753),(76675,5753),(76676,5753),(76677,5753),(76678,5753),(76679,5753),(76680,5753),(76681,5753),(76682,5753),(76683,5753),(76684,5753),(76685,5753),(76686,5753),(76687,5754),(76688,5754),(76689,5754),(76690,5754),(76691,5754),(76692,5754),(76693,5754),(76694,5754),(76695,5754),(76696,5754),(76697,5754),(76698,5754),(76699,5754),(76700,5754),(76701,5754),(76702,5754),(76703,5754),(76704,5755),(76705,5755),(76706,5755),(76707,5755),(76708,5755),(76709,5755),(76710,5755),(76711,5755),(76712,5755),(76713,5755),(76714,5755),(76715,5755),(76716,5755),(76717,5755),(76718,5755),(76719,5755),(76720,5755),(76721,5756),(76722,5756),(76723,5756),(76724,5756),(76725,5756),(76726,5756),(76727,5756),(76728,5756),(76729,5756),(76730,5756),(76731,5756),(76732,5756),(76733,5756),(76734,5756),(76735,5756),(76736,5756),(76737,5756),(76738,5753),(76739,5753),(76740,5754),(76741,5755),(76742,5756),(76743,1162),(76744,1162),(76745,1162),(76746,4894),(76747,4894),(76748,4894),(76749,1164),(76750,1164),(76751,1164),(76752,2176),(76753,2176),(76754,2176),(76755,5753),(76756,5753),(76757,5753),(76758,5753),(76759,5753),(76760,5753),(76761,5753),(76762,5753),(76763,5753),(76764,5753),(76765,5753),(76766,5753),(76767,5753),(76768,1165),(76769,1165),(76770,1165),(76771,1165),(76772,1165),(76773,1165),(76774,5193),(76775,5193),(76776,5193),(76777,5193),(76778,5193),(76779,5193),(76780,5193),(76781,5192),(76782,5192),(76783,5192),(76784,5192),(76785,5192),(76786,5192),(76787,5192),(76788,5190),(76789,5190),(76790,5190),(76791,5190),(76792,5190),(76793,5190),(76794,5190),(76795,5753),(76796,5753),(76797,5753),(76798,5753),(76799,5753),(76800,5753),(76801,5753),(76802,5753),(76803,5753),(76804,5753),(76805,5753),(76806,5753),(76807,5753),(76808,5753),(76809,5753),(76810,5753),(76811,5753),(76812,5753),(76813,5753),(76814,5753),(76815,5753),(76816,5753),(76817,5753),(76818,5753),(76819,5753),(76820,5753),(76821,5753),(76822,5753),(76823,5753),(76824,5753),(76825,5753),(76826,5753),(76827,5753),(76828,5753),(76829,5753),(76830,5753),(76831,5753),(76832,5753),(76833,5753),(76834,5753),(76835,5753),(76836,5753),(76837,5753),(76838,5753),(76839,5753),(76840,5753),(76841,5753),(76842,5753),(76843,5753),(76844,5753),(76845,5753),(76846,5753),(76847,5753),(76848,5753),(76849,5753),(76850,5753),(76851,5753),(76852,5753),(76853,5753),(76854,5753),(76855,5753),(76856,5753),(76857,5753),(76858,5753),(76859,5753),(76860,5753),(76861,5753),(76862,5753),(76863,5753),(76864,5753),(76865,5753),(76866,5753),(76867,5753),(76868,5753),(76869,5753),(76870,5753),(76871,5753),(76872,5753),(76873,5753),(76874,5753),(76875,5753),(76876,5753),(76877,5753),(76878,5753),(76879,5753),(76880,5753),(76881,5753),(76882,5753),(76883,5753),(76884,5753),(76885,5753),(76886,5753),(76887,5753),(76888,5753),(76889,48),(76890,48),(76891,48),(76892,48),(76893,48),(76894,48),(76895,48),(76896,48),(76897,48),(76898,48),(76899,48),(76900,48),(76901,48),(76902,48),(76903,48),(76904,48),(76905,48),(76906,48),(76907,48),(76908,48),(76909,48),(76910,4894),(76911,4894),(76912,4894),(76913,5753),(76914,5753),(76915,5753),(76916,5753),(76917,5753),(76918,5753),(76919,5753),(76920,5753),(76921,5753),(76922,5753),(76923,5753),(76924,5753),(76925,5753),(76926,2176),(76927,2176),(76928,2176),(76929,5753),(76930,5753),(76931,5753),(76932,5753),(76933,5753),(76934,5753),(76935,5753),(76936,5753),(76937,5753),(76938,5753),(76939,5753),(76940,7),(76941,7),(76942,7),(76943,7),(76944,7),(76945,7),(76946,7),(76947,7),(76948,7),(76949,7),(76950,7),(76951,7),(76952,7),(76953,7),(76954,7),(76955,7),(76956,7),(76957,7),(76958,7),(76959,7),(76960,7),(76961,5757),(76962,5757),(76963,5757),(76964,5757),(76965,5757),(76966,5757),(76967,5757),(76968,5757),(76969,5757),(76970,5757),(76971,5757),(76972,5757),(76973,5757),(76974,5757),(76975,5757),(76976,5757),(76977,5757),(76978,5757),(76979,5757),(76980,5758),(76981,5758),(76982,5758),(76983,5758),(76984,5758),(76985,5758),(76986,5758),(76987,5758),(76988,5758),(76989,5758),(76990,5758),(76991,5758),(76992,5758),(76993,5758),(76994,5758),(76995,5758),(76996,5758),(76997,5758),(76998,5758),(76999,5759),(77000,5759),(77001,5759),(77002,5759),(77003,5759),(77004,5759),(77005,5759),(77006,5759),(77007,5759),(77008,5759),(77009,5759),(77010,5759),(77011,5759),(77012,5759),(77013,5759),(77014,5759),(77015,5759),(77016,5759),(77017,5759),(77018,1165),(77019,1165),(77020,1165),(77021,1165),(77022,1165),(77023,1165),(77024,7),(77025,7),(77026,7),(77027,7),(77028,7),(77029,7),(77030,7),(77031,7),(77032,7),(77033,7),(77034,7),(77035,7),(77036,7),(77037,7),(77038,7),(77039,7),(77040,7),(77041,7),(77042,7),(77043,7),(77044,7),(77045,7),(77046,7),(77047,7),(77048,7),(77049,7),(77050,7),(77051,7),(77052,7),(77053,7),(77054,7),(77055,7),(77056,7),(77057,7),(77058,7),(77059,7),(77060,7),(77061,7),(77062,7),(77063,7),(77064,7),(77065,7),(77066,7),(77067,7),(77068,7),(77069,7),(77070,7),(77071,7),(77072,7),(77073,7),(77074,7),(77075,7),(77076,7),(77077,7),(77078,7),(77079,7),(77080,7),(77081,7),(77082,7),(77083,7),(77084,7),(77085,7),(77086,7),(77087,7),(77088,7),(77089,7),(77090,7),(77091,7),(77092,7),(77093,7),(77094,7),(77095,7),(77096,7),(77097,7),(77098,7),(77099,7),(77100,7),(77101,7),(77102,7),(77103,7),(77104,7),(77105,7),(77106,7),(77107,7),(77108,51),(77109,51),(77110,51),(77111,51),(77112,51),(77113,51),(77114,51),(77115,51),(77116,51),(77117,51),(77118,51),(77119,51),(77120,51),(77121,51),(77122,51),(77123,51),(77124,51),(77125,51),(77126,221),(77127,221),(77128,221),(77129,221),(77130,221),(77131,221),(77132,221),(77133,221),(77134,221),(77135,221),(77136,221),(77137,221),(77138,112),(77139,112),(77140,112),(77141,112),(77142,112),(77143,112),(77144,112),(77145,112),(77146,112),(77147,112),(77148,112),(77149,18),(77150,18),(77151,18),(77152,18),(77153,18),(77154,18),(77155,18),(77156,18),(77157,18),(77158,18),(77159,18),(77160,1623),(77161,1623),(77162,1623),(77163,1623),(77164,1623),(77165,1623),(77166,1623),(77167,1623),(77168,1623),(77169,1623),(77170,1623),(77171,1623),(77172,2289),(77173,2289),(77174,2289),(77175,2289),(77176,2289),(77177,2289),(77178,2289),(77179,2289),(77180,2289),(77181,2289),(77182,2289),(77183,2289),(77184,2289),(77185,2289),(77186,2289),(77187,2289),(77188,1165),(77189,1164),(77190,1164),(77191,1164),(77192,1162),(77193,1162),(77194,1162),(77195,1165),(77196,51),(77197,51),(77198,51),(77199,51),(77200,51),(77201,51),(77202,51),(77203,51),(77204,5726),(77205,5726),(77206,5726),(77207,5726),(77208,5718),(77209,5718),(77210,5718),(77211,5718),(77212,5718),(77213,5718),(77214,5718),(77215,5718),(77216,5718),(77217,5718),(77218,5718),(77219,5718),(77220,5718),(77221,5760),(77222,5760),(77223,5760),(77224,5760),(77225,5760),(77226,5760),(77227,5760),(77228,5760),(77229,5760),(77230,5760),(77231,5760),(77232,5760),(77233,5760),(77234,5760),(77235,5760),(77236,5760),(77237,5760),(77238,5760),(77239,5760),(77240,5760),(77241,5760),(77242,5761),(77243,5761),(77244,5761),(77245,5761),(77246,5761),(77247,5761),(77248,5761),(77249,5762),(77250,5762),(77251,5762),(77252,5762),(77253,5762),(77254,5762),(77255,5762),(77256,5763),(77257,5763),(77258,5763),(77259,5763),(77260,5763),(77261,5763),(77262,5763),(77263,5764),(77264,5764),(77265,5764),(77266,5764),(77267,5764),(77268,5764),(77269,5764),(77270,5765),(77271,5765),(77272,5765),(77273,5765),(77274,5765),(77275,5765),(77276,5765),(77277,5766),(77278,5766),(77279,5766),(77280,5766),(77281,5766),(77282,5766),(77283,5766),(77284,5767),(77285,5767),(77286,5767),(77287,5767),(77288,5767),(77289,5767),(77290,5767),(77291,5768),(77292,5768),(77293,5768),(77294,5768),(77295,5768),(77296,5768),(77297,5768),(77298,5769),(77299,5769),(77300,5769),(77301,5769),(77302,5770),(77303,5770),(77304,5770),(77305,5770),(77306,5770),(77307,5770),(77308,5771),(77309,5771),(77310,5771),(77311,5771),(77312,5772),(77313,5772),(77314,5772),(77315,5772),(77316,5773),(77317,5773),(77318,5773),(77319,5773),(77320,5774),(77321,5774),(77322,5774),(77323,5774),(77324,5775),(77325,5775),(77326,5775),(77327,5775),(77328,5776),(77329,5776),(77330,5776),(77331,5776),(77332,5777),(77333,5777),(77334,5777),(77335,5777),(77336,5777),(77337,5777),(77338,5777),(77339,5778),(77340,5778),(77341,5778),(77342,5778),(77343,5778),(77344,5778),(77345,5778),(77346,5779),(77347,5779),(77348,5779),(77349,5779),(77350,5779),(77351,5779),(77352,5779),(77353,5780),(77354,5780),(77355,5780),(77356,5780),(77357,5781),(77358,5781),(77359,5781),(77360,5781),(77361,5781),(77362,5781),(77363,5781),(77364,5782),(77365,5782),(77366,5782),(77367,5782),(77368,5782),(77369,5782),(77370,5782),(77371,5783),(77372,5783),(77373,5783),(77374,5783),(77375,5783),(77376,5783),(77377,5783),(77378,5784),(77379,5784),(77380,5784),(77381,5784),(77382,5784),(77383,5784),(77384,5784),(77385,5785),(77386,5785),(77387,5785),(77388,5785),(77389,5785),(77390,5785),(77391,5785),(77392,5786),(77393,5786),(77394,5786),(77395,5786),(77396,5786),(77397,5786),(77398,5786),(77399,5787),(77400,5787),(77401,5787),(77402,5787),(77403,5788),(77404,5788),(77405,5788),(77406,5788),(77407,5788),(77408,5788),(77409,5788),(77410,5789),(77411,5789),(77412,5789),(77413,5789),(77414,5789),(77415,5789),(77416,5789),(77417,5790),(77418,5790),(77419,5790),(77420,5790),(77421,5790),(77422,5790),(77423,5790),(77424,5791),(77425,5791),(77426,5791),(77427,5791),(77428,5791),(77429,5791),(77430,5791),(77431,5792),(77432,5792),(77433,5792),(77434,5792),(77435,5792),(77436,5792),(77437,5792),(77438,5793),(77439,5793),(77440,5793),(77441,5793),(77442,5793),(77443,5793),(77444,5794),(77445,5794),(77446,5794),(77447,5794),(77448,5794),(77449,5794),(77450,5794),(77451,5795),(77452,5795),(77453,5795),(77454,5795),(77455,5795),(77456,5795),(77457,5795),(77458,5796),(77459,5796),(77460,5796),(77461,5796),(77462,5796),(77463,5796),(77464,5796),(77465,5797),(77466,5797),(77467,5797),(77468,5797),(77469,5797),(77470,5797),(77471,5797),(77472,5798),(77473,5798),(77474,5798),(77475,5798),(77476,5798),(77477,5798),(77478,5798),(77479,5799),(77480,5799),(77481,5799),(77482,5799),(77483,5799),(77484,5799),(77485,5799),(77486,5800),(77487,5800),(77488,5800),(77489,5800),(77490,5800),(77491,5800),(77492,5800),(77493,5801),(77494,5801),(77495,5801),(77496,5801),(77497,5801),(77498,5801),(77499,5801),(77500,5802),(77501,5802),(77502,5802),(77503,5802),(77504,5802),(77505,5802),(77506,5802),(77507,5803),(77508,5803),(77509,5803),(77510,5803),(77511,5803),(77512,5803),(77513,5803),(77514,5804),(77515,5804),(77516,5804),(77517,5804),(77518,5804),(77519,5804),(77520,5804),(77521,5805),(77522,5805),(77523,5805),(77524,5805),(77525,5805),(77526,5805),(77527,5805),(77528,5806),(77529,5806),(77530,5806),(77531,5806),(77532,5806),(77533,5806),(77534,5806),(77535,5807),(77536,5807),(77537,5807),(77538,5807),(77539,5807),(77540,5807),(77541,5807),(77542,5807),(77543,5807),(77544,5808),(77545,5808),(77546,5808),(77547,5808),(77548,5808),(77549,5808),(77550,5808),(77551,5808),(77552,5808),(77553,5809),(77554,5809),(77555,5809),(77556,5809),(77557,5809),(77558,5809),(77559,5809),(77560,5809),(77561,5809),(77562,5810),(77563,5810),(77564,5810),(77565,5810),(77566,5810),(77567,5810),(77568,5810),(77569,5810),(77570,5810),(77571,5811),(77572,5811),(77573,5811),(77574,5811),(77575,5811),(77576,5811),(77577,5811),(77578,5811),(77579,5811),(77580,5812),(77581,5812),(77582,5812),(77583,5812),(77584,5812),(77585,5812),(77586,5812),(77587,5812),(77588,5812),(77589,5813),(77590,5813),(77591,5813),(77592,5813),(77593,5813),(77594,5813),(77595,5813),(77596,5813),(77597,5813),(77598,5814),(77599,5814),(77600,5814),(77601,5814),(77602,5814),(77603,5814),(77604,5814),(77605,5814),(77606,5814),(77607,5815),(77608,5815),(77609,5815),(77610,5815),(77611,5815),(77612,5815),(77613,5815),(77614,5815),(77615,5815),(77616,5816),(77617,5816),(77618,5816),(77619,5816),(77620,5816),(77621,5816),(77622,5816),(77623,5816),(77624,5816),(77625,5817),(77626,5817),(77627,5817),(77628,5817),(77629,5817),(77630,5817),(77631,5817),(77632,5817),(77633,5817),(77634,5818),(77635,5818),(77636,5818),(77637,5818),(77638,5818),(77639,5818),(77640,5818),(77641,5818),(77642,5818),(77643,5819),(77644,5819),(77645,5819),(77646,5819),(77647,5819),(77648,5819),(77649,5819),(77650,5820),(77651,5820),(77652,5820),(77653,5820),(77654,5820),(77655,5820),(77656,5820),(77657,5821),(77658,5821),(77659,5821),(77660,5821),(77661,5821),(77662,5821),(77663,5821),(77664,5822),(77665,5822),(77666,5822),(77667,5822),(77668,5823),(77669,5823),(77670,5823),(77671,5823),(77672,5824),(77673,5824),(77674,5824),(77675,5824),(77676,5824),(77677,5824),(77678,5824),(77679,5825),(77680,5825),(77681,5825),(77682,5825),(77683,5826),(77684,5826),(77685,5826),(77686,5826),(77687,5827),(77688,5827),(77689,5827),(77690,5827),(77691,5828),(77692,5828),(77693,5828),(77694,5828),(77695,5829),(77696,5829),(77697,5829),(77698,5829),(77699,5830),(77700,5830),(77701,5830),(77702,5830),(77703,5831),(77704,5831),(77705,5831),(77706,5831),(77707,5832),(77708,5832),(77709,5832),(77710,5832),(77711,5832),(77712,5832),(77713,5832),(77714,5833),(77715,5833),(77716,5833),(77717,5833),(77718,5833),(77719,5833),(77720,5833),(77721,5834),(77722,5834),(77723,5834),(77724,5834),(77725,5834),(77726,5834),(77727,5834),(77728,5835),(77729,5835),(77730,5835),(77731,5835),(77732,5835),(77733,5835),(77734,5835),(77735,5836),(77736,5836),(77737,5836),(77738,5836),(77739,5836),(77740,5836),(77741,5836),(77742,5837),(77743,5837),(77744,5837),(77745,5837),(77746,5837),(77747,5837),(77748,5837),(77749,5838),(77750,5838),(77751,5838),(77752,5838),(77753,5838),(77754,5838),(77755,5838),(77756,5839),(77757,5839),(77758,5839),(77759,5839),(77760,5839),(77761,5839),(77762,5839),(77763,5840),(77764,5840),(77765,5840),(77766,5840),(77767,5840),(77768,5840),(77769,5840),(77770,5840),(77771,5840),(77772,5841),(77773,5841),(77774,5841),(77775,5841),(77776,5841),(77777,5841),(77778,5841),(77779,5842),(77780,5842),(77781,5842),(77782,5842),(77783,5842),(77784,5842),(77785,5842),(77786,5843),(77787,5843),(77788,5843),(77789,5843),(77790,5843),(77791,5843),(77792,5843),(77793,5843),(77794,5843),(77795,5844),(77796,5844),(77797,5844),(77798,5844),(77799,5844),(77800,5844),(77801,5844),(77802,5845),(77803,5845),(77804,5845),(77805,5845),(77806,5845),(77807,5845),(77808,5845),(77809,5846),(77810,5846),(77811,5846),(77812,5846),(77813,5846),(77814,5846),(77815,5846),(77816,5847),(77817,5847),(77818,5847),(77819,5847),(77820,5847),(77821,5847),(77822,5847),(77823,5848),(77824,5848),(77825,5848),(77826,5848),(77827,5848),(77828,5848),(77829,5848),(77830,5849),(77831,5849),(77832,5849),(77833,5849),(77834,5849),(77835,5849),(77836,5849),(77837,5850),(77838,5850),(77839,5850),(77840,5850),(77841,5850),(77842,5850),(77843,5850),(77844,5850),(77845,5850),(77846,5851),(77847,5851),(77848,5851),(77849,5851),(77850,5851),(77851,5851),(77852,5851),(77853,5851),(77854,5851),(77855,5852),(77856,5852),(77857,5852),(77858,5852),(77859,5852),(77860,5852),(77861,5852),(77862,5852),(77863,5852),(77864,5853),(77865,5853),(77866,5853),(77867,5853),(77868,5853),(77869,5853),(77870,5853),(77871,5853),(77872,5853),(77873,5854),(77874,5854),(77875,5854),(77876,5854),(77877,5854),(77878,5854),(77879,5854),(77880,5854),(77881,5854),(77882,5855),(77883,5855),(77884,5855),(77885,5855),(77886,5855),(77887,5855),(77888,5855),(77889,5855),(77890,5855),(77891,5856),(77892,5856),(77893,5856),(77894,5856),(77895,5856),(77896,5856),(77897,5856),(77898,5856),(77899,5856),(77900,5857),(77901,5857),(77902,5857),(77903,5857),(77904,5857),(77905,5857),(77906,5857),(77907,5857),(77908,5857),(77909,5858),(77910,5858),(77911,5858),(77912,5858),(77913,5858),(77914,5858),(77915,5858),(77916,5858),(77917,5858),(77918,5859),(77919,5859),(77920,5859),(77921,5859),(77922,5859),(77923,5859),(77924,5859),(77925,5859),(77926,5859),(77927,5860),(77928,5860),(77929,5860),(77930,5860),(77931,5860),(77932,5860),(77933,5860),(77934,5860),(77935,5860),(77936,5761),(77937,5761),(77938,5761),(77939,5762),(77940,5762),(77941,5762),(77942,5763),(77943,5763),(77944,5763),(77945,5764),(77946,5764),(77947,5764),(77948,5765),(77949,5765),(77950,5765),(77951,5766),(77952,5766),(77953,5766),(77954,5767),(77955,5767),(77956,5767),(77957,5768),(77958,5768),(77959,5768),(77960,5769),(77961,5769),(77962,5769),(77963,5770),(77964,5770),(77965,5770),(77966,5771),(77967,5771),(77968,5771),(77969,5772),(77970,5772),(77971,5772),(77972,5773),(77973,5773),(77974,5773),(77975,5774),(77976,5774),(77977,5774),(77978,5775),(77979,5775),(77980,5775),(77981,5776),(77982,5776),(77983,5776),(77984,5777),(77985,5777),(77986,5777),(77987,5778),(77988,5778),(77989,5778),(77990,5779),(77991,5779),(77992,5779),(77993,5780),(77994,5780),(77995,5780),(77996,5781),(77997,5781),(77998,5781),(77999,5782),(78000,5782),(78001,5782),(78002,5783),(78003,5783),(78004,5783),(78005,5784),(78006,5784),(78007,5784),(78008,5785),(78009,5785),(78010,5785),(78011,5786),(78012,5786),(78013,5786),(78014,5787),(78015,5787),(78016,5787),(78017,5788),(78018,5788),(78019,5788),(78020,5789),(78021,5789),(78022,5789),(78023,5790),(78024,5790),(78025,5790),(78026,5791),(78027,5791),(78028,5791),(78029,5792),(78030,5792),(78031,5792),(78032,5793),(78033,5794),(78034,5794),(78035,5794),(78036,5795),(78037,5795),(78038,5795),(78039,5796),(78040,5796),(78041,5796),(78042,5797),(78043,5797),(78044,5797),(78045,5798),(78046,5798),(78047,5798),(78048,5799),(78049,5799),(78050,5799),(78051,5800),(78052,5800),(78053,5800),(78054,5801),(78055,5801),(78056,5801),(78057,5802),(78058,5802),(78059,5802),(78060,5803),(78061,5803),(78062,5803),(78063,5804),(78064,5804),(78065,5804),(78066,5805),(78067,5805),(78068,5805),(78069,5806),(78070,5806),(78071,5806),(78072,5807),(78073,5807),(78074,5807),(78075,5808),(78076,5808),(78077,5808),(78078,5809),(78079,5809),(78080,5809),(78081,5810),(78082,5810),(78083,5810),(78084,5811),(78085,5811),(78086,5811),(78087,5812),(78088,5812),(78089,5812),(78090,5813),(78091,5813),(78092,5813),(78093,5814),(78094,5814),(78095,5814),(78096,5815),(78097,5815),(78098,5815),(78099,5816),(78100,5816),(78101,5816),(78102,5817),(78103,5817),(78104,5817),(78105,5818),(78106,5818),(78107,5818),(78108,5819),(78109,5819),(78110,5819),(78111,5820),(78112,5820),(78113,5820),(78114,5821),(78115,5821),(78116,5821),(78117,5822),(78118,5822),(78119,5822),(78120,5823),(78121,5823),(78122,5823),(78123,5824),(78124,5824),(78125,5824),(78126,5825),(78127,5825),(78128,5825),(78129,5826),(78130,5826),(78131,5826),(78132,5827),(78133,5827),(78134,5827),(78135,5828),(78136,5828),(78137,5828),(78138,5829),(78139,5829),(78140,5829),(78141,5830),(78142,5830),(78143,5830),(78144,5831),(78145,5831),(78146,5831),(78147,5832),(78148,5832),(78149,5832),(78150,5833),(78151,5833),(78152,5833),(78153,5834),(78154,5834),(78155,5834),(78156,5835),(78157,5835),(78158,5835),(78159,5836),(78160,5836),(78161,5836),(78162,5837),(78163,5837),(78164,5837),(78165,5838),(78166,5838),(78167,5838),(78168,5839),(78169,5839),(78170,5839),(78171,5840),(78172,5840),(78173,5840),(78174,5841),(78175,5841),(78176,5841),(78177,5842),(78178,5842),(78179,5842),(78180,5843),(78181,5843),(78182,5843),(78183,5844),(78184,5844),(78185,5844),(78186,5845),(78187,5845),(78188,5845),(78189,5846),(78190,5846),(78191,5846),(78192,5847),(78193,5847),(78194,5847),(78195,5848),(78196,5848),(78197,5848),(78198,5849),(78199,5849),(78200,5849),(78201,5850),(78202,5850),(78203,5851),(78204,5851),(78205,5852),(78206,5852),(78207,5853),(78208,5853),(78209,5854),(78210,5854),(78211,5855),(78212,5855),(78213,5856),(78214,5856),(78215,5857),(78216,5857),(78217,5858),(78218,5858),(78219,5859),(78220,5859),(78221,5860),(78222,5860),(78223,5761),(78224,5761),(78225,5761),(78226,5761),(78227,5761),(78228,5761),(78229,5761),(78230,5761),(78231,5761),(78232,5761),(78233,5761),(78234,5762),(78235,5762),(78236,5762),(78237,5762),(78238,5762),(78239,5762),(78240,5762),(78241,5762),(78242,5762),(78243,5762),(78244,5762),(78245,5763),(78246,5763),(78247,5763),(78248,5763),(78249,5763),(78250,5763),(78251,5763),(78252,5763),(78253,5763),(78254,5763),(78255,5763),(78256,5764),(78257,5764),(78258,5764),(78259,5764),(78260,5764),(78261,5764),(78262,5764),(78263,5764),(78264,5764),(78265,5764),(78266,5764),(78267,5765),(78268,5765),(78269,5765),(78270,5765),(78271,5765),(78272,5765),(78273,5765),(78274,5765),(78275,5765),(78276,5765),(78277,5765),(78278,5766),(78279,5766),(78280,5766),(78281,5766),(78282,5766),(78283,5766),(78284,5766),(78285,5766),(78286,5766),(78287,5766),(78288,5766),(78289,5767),(78290,5767),(78291,5767),(78292,5767),(78293,5767),(78294,5767),(78295,5767),(78296,5767),(78297,5767),(78298,5767),(78299,5767),(78300,5768),(78301,5768),(78302,5768),(78303,5768),(78304,5768),(78305,5768),(78306,5768),(78307,5768),(78308,5768),(78309,5768),(78310,5768),(78311,5769),(78312,5769),(78313,5769),(78314,5769),(78315,5769),(78316,5769),(78317,5769),(78318,5769),(78319,5769),(78320,5769),(78321,5769),(78322,5770),(78323,5770),(78324,5770),(78325,5770),(78326,5770),(78327,5770),(78328,5770),(78329,5770),(78330,5770),(78331,5770),(78332,5770),(78333,5771),(78334,5771),(78335,5771),(78336,5771),(78337,5771),(78338,5771),(78339,5771),(78340,5771),(78341,5771),(78342,5771),(78343,5771),(78344,5772),(78345,5772),(78346,5772),(78347,5772),(78348,5772),(78349,5772),(78350,5772),(78351,5772),(78352,5772),(78353,5772),(78354,5772),(78355,5773),(78356,5773),(78357,5773),(78358,5773),(78359,5773),(78360,5773),(78361,5773),(78362,5773),(78363,5773),(78364,5773),(78365,5773),(78366,5774),(78367,5774),(78368,5774),(78369,5774),(78370,5774),(78371,5774),(78372,5774),(78373,5774),(78374,5774),(78375,5774),(78376,5774),(78377,5775),(78378,5775),(78379,5775),(78380,5775),(78381,5775),(78382,5775),(78383,5775),(78384,5775),(78385,5775),(78386,5775),(78387,5775),(78388,5776),(78389,5776),(78390,5776),(78391,5776),(78392,5776),(78393,5776),(78394,5776),(78395,5776),(78396,5776),(78397,5776),(78398,5776),(78399,5777),(78400,5777),(78401,5777),(78402,5777),(78403,5777),(78404,5777),(78405,5777),(78406,5777),(78407,5777),(78408,5777),(78409,5777),(78410,5778),(78411,5778),(78412,5778),(78413,5778),(78414,5778),(78415,5778),(78416,5778),(78417,5778),(78418,5778),(78419,5778),(78420,5778),(78421,5779),(78422,5779),(78423,5779),(78424,5779),(78425,5779),(78426,5779),(78427,5779),(78428,5779),(78429,5779),(78430,5779),(78431,5779),(78432,5780),(78433,5780),(78434,5780),(78435,5780),(78436,5780),(78437,5780),(78438,5780),(78439,5780),(78440,5780),(78441,5780),(78442,5780),(78443,5781),(78444,5781),(78445,5781),(78446,5781),(78447,5781),(78448,5781),(78449,5781),(78450,5781),(78451,5781),(78452,5781),(78453,5781),(78454,5782),(78455,5782),(78456,5782),(78457,5782),(78458,5782),(78459,5782),(78460,5782),(78461,5782),(78462,5782),(78463,5782),(78464,5782),(78465,5783),(78466,5783),(78467,5783),(78468,5783),(78469,5783),(78470,5783),(78471,5783),(78472,5783),(78473,5783),(78474,5783),(78475,5783),(78476,5784),(78477,5784),(78478,5784),(78479,5784),(78480,5784),(78481,5784),(78482,5784),(78483,5784),(78484,5784),(78485,5784),(78486,5784),(78487,5785),(78488,5785),(78489,5785),(78490,5785),(78491,5785),(78492,5785),(78493,5785),(78494,5785),(78495,5785),(78496,5785),(78497,5785),(78498,5786),(78499,5786),(78500,5786),(78501,5786),(78502,5786),(78503,5786),(78504,5786),(78505,5786),(78506,5786),(78507,5786),(78508,5786),(78509,5787),(78510,5787),(78511,5787),(78512,5787),(78513,5787),(78514,5787),(78515,5787),(78516,5787),(78517,5787),(78518,5787),(78519,5787),(78520,5788),(78521,5788),(78522,5788),(78523,5788),(78524,5788),(78525,5788),(78526,5788),(78527,5788),(78528,5788),(78529,5788),(78530,5788),(78531,5789),(78532,5789),(78533,5789),(78534,5789),(78535,5789),(78536,5789),(78537,5789),(78538,5789),(78539,5789),(78540,5789),(78541,5789),(78542,5790),(78543,5790),(78544,5790),(78545,5790),(78546,5790),(78547,5790),(78548,5790),(78549,5790),(78550,5790),(78551,5790),(78552,5790),(78553,5791),(78554,5791),(78555,5791),(78556,5791),(78557,5791),(78558,5791),(78559,5791),(78560,5791),(78561,5791),(78562,5791),(78563,5791),(78564,5792),(78565,5792),(78566,5792),(78567,5792),(78568,5792),(78569,5792),(78570,5792),(78571,5792),(78572,5792),(78573,5792),(78574,5792),(78575,5793),(78576,5793),(78577,5793),(78578,5793),(78579,5793),(78580,5793),(78581,5793),(78582,5793),(78583,5793),(78584,5793),(78585,5793),(78586,5794),(78587,5794),(78588,5794),(78589,5794),(78590,5794),(78591,5794),(78592,5794),(78593,5794),(78594,5794),(78595,5794),(78596,5794),(78597,5795),(78598,5795),(78599,5795),(78600,5795),(78601,5795),(78602,5795),(78603,5795),(78604,5795),(78605,5795),(78606,5795),(78607,5795),(78608,5796),(78609,5796),(78610,5796),(78611,5796),(78612,5796),(78613,5796),(78614,5796),(78615,5796),(78616,5796),(78617,5796),(78618,5796),(78619,5797),(78620,5797),(78621,5797),(78622,5797),(78623,5797),(78624,5797),(78625,5797),(78626,5797),(78627,5797),(78628,5797),(78629,5797),(78630,5798),(78631,5798),(78632,5798),(78633,5798),(78634,5798),(78635,5798),(78636,5798),(78637,5798),(78638,5798),(78639,5798),(78640,5798),(78641,5799),(78642,5799),(78643,5799),(78644,5799),(78645,5799),(78646,5799),(78647,5799),(78648,5799),(78649,5799),(78650,5799),(78651,5799),(78652,5800),(78653,5800),(78654,5800),(78655,5800),(78656,5800),(78657,5800),(78658,5800),(78659,5800),(78660,5800),(78661,5800),(78662,5800),(78663,5801),(78664,5801),(78665,5801),(78666,5801),(78667,5801),(78668,5801),(78669,5801),(78670,5801),(78671,5801),(78672,5801),(78673,5801),(78674,5802),(78675,5802),(78676,5802),(78677,5802),(78678,5802),(78679,5802),(78680,5802),(78681,5802),(78682,5802),(78683,5802),(78684,5802),(78685,5803),(78686,5803),(78687,5803),(78688,5803),(78689,5803),(78690,5803),(78691,5803),(78692,5803),(78693,5803),(78694,5803),(78695,5803),(78696,5804),(78697,5804),(78698,5804),(78699,5804),(78700,5804),(78701,5804),(78702,5804),(78703,5804),(78704,5804),(78705,5804),(78706,5804),(78707,5805),(78708,5805),(78709,5805),(78710,5805),(78711,5805),(78712,5805),(78713,5805),(78714,5805),(78715,5805),(78716,5805),(78717,5805),(78718,5806),(78719,5806),(78720,5806),(78721,5806),(78722,5806),(78723,5806),(78724,5806),(78725,5806),(78726,5806),(78727,5806),(78728,5806),(78729,5807),(78730,5807),(78731,5807),(78732,5807),(78733,5807),(78734,5807),(78735,5807),(78736,5807),(78737,5807),(78738,5807),(78739,5807),(78740,5808),(78741,5808),(78742,5808),(78743,5808),(78744,5808),(78745,5808),(78746,5808),(78747,5808),(78748,5808),(78749,5808),(78750,5808),(78751,5809),(78752,5809),(78753,5809),(78754,5809),(78755,5809),(78756,5809),(78757,5809),(78758,5809),(78759,5809),(78760,5809),(78761,5809),(78762,5810),(78763,5810),(78764,5810),(78765,5810),(78766,5810),(78767,5810),(78768,5810),(78769,5810),(78770,5810),(78771,5810),(78772,5810),(78773,5811),(78774,5811),(78775,5811),(78776,5811),(78777,5811),(78778,5811),(78779,5811),(78780,5811),(78781,5811),(78782,5811),(78783,5811),(78784,5812),(78785,5812),(78786,5812),(78787,5812),(78788,5812),(78789,5812),(78790,5812),(78791,5812),(78792,5812),(78793,5812),(78794,5812),(78795,5813),(78796,5813),(78797,5813),(78798,5813),(78799,5813),(78800,5813),(78801,5813),(78802,5813),(78803,5813),(78804,5813),(78805,5813),(78806,5814),(78807,5814),(78808,5814),(78809,5814),(78810,5814),(78811,5814),(78812,5814),(78813,5814),(78814,5814),(78815,5814),(78816,5814),(78817,5815),(78818,5815),(78819,5815),(78820,5815),(78821,5815),(78822,5815),(78823,5815),(78824,5815),(78825,5815),(78826,5815),(78827,5815),(78828,5816),(78829,5816),(78830,5816),(78831,5816),(78832,5816),(78833,5816),(78834,5816),(78835,5816),(78836,5816),(78837,5816),(78838,5816),(78839,5817),(78840,5817),(78841,5817),(78842,5817),(78843,5817),(78844,5817),(78845,5817),(78846,5817),(78847,5817),(78848,5817),(78849,5817),(78850,5818),(78851,5818),(78852,5818),(78853,5818),(78854,5818),(78855,5818),(78856,5818),(78857,5818),(78858,5818),(78859,5818),(78860,5818),(78861,5819),(78862,5819),(78863,5819),(78864,5819),(78865,5819),(78866,5819),(78867,5819),(78868,5819),(78869,5819),(78870,5819),(78871,5819),(78872,5820),(78873,5820),(78874,5820),(78875,5820),(78876,5820),(78877,5820),(78878,5820),(78879,5820),(78880,5820),(78881,5820),(78882,5820),(78883,5821),(78884,5821),(78885,5821),(78886,5821),(78887,5821),(78888,5821),(78889,5821),(78890,5821),(78891,5821),(78892,5821),(78893,5821),(78894,5822),(78895,5822),(78896,5822),(78897,5822),(78898,5822),(78899,5822),(78900,5822),(78901,5822),(78902,5822),(78903,5822),(78904,5822),(78905,5823),(78906,5823),(78907,5823),(78908,5823),(78909,5823),(78910,5823),(78911,5823),(78912,5823),(78913,5823),(78914,5823),(78915,5823),(78916,5824),(78917,5824),(78918,5824),(78919,5824),(78920,5824),(78921,5824),(78922,5824),(78923,5824),(78924,5824),(78925,5824),(78926,5824),(78927,5825),(78928,5825),(78929,5825),(78930,5825),(78931,5825),(78932,5825),(78933,5825),(78934,5825),(78935,5825),(78936,5825),(78937,5825),(78938,5826),(78939,5826),(78940,5826),(78941,5826),(78942,5826),(78943,5826),(78944,5826),(78945,5826),(78946,5826),(78947,5826),(78948,5826),(78949,5827),(78950,5827),(78951,5827),(78952,5827),(78953,5827),(78954,5827),(78955,5827),(78956,5827),(78957,5827),(78958,5827),(78959,5827),(78960,5828),(78961,5828),(78962,5828),(78963,5828),(78964,5828),(78965,5828),(78966,5828),(78967,5828),(78968,5828),(78969,5828),(78970,5828),(78971,5829),(78972,5829),(78973,5829),(78974,5829),(78975,5829),(78976,5829),(78977,5829),(78978,5829),(78979,5829),(78980,5829),(78981,5829),(78982,5830),(78983,5830),(78984,5830),(78985,5830),(78986,5830),(78987,5830),(78988,5830),(78989,5830),(78990,5830),(78991,5830),(78992,5830),(78993,5831),(78994,5831),(78995,5831),(78996,5831),(78997,5831),(78998,5831),(78999,5831),(79000,5831),(79001,5831),(79002,5831),(79003,5831),(79004,5832),(79005,5832),(79006,5832),(79007,5832),(79008,5832),(79009,5832),(79010,5832),(79011,5832),(79012,5832),(79013,5832),(79014,5832),(79015,5833),(79016,5833),(79017,5833),(79018,5833),(79019,5833),(79020,5833),(79021,5833),(79022,5833),(79023,5833),(79024,5833),(79025,5833),(79026,5834),(79027,5834),(79028,5834),(79029,5834),(79030,5834),(79031,5834),(79032,5834),(79033,5834),(79034,5834),(79035,5834),(79036,5834),(79037,5835),(79038,5835),(79039,5835),(79040,5835),(79041,5835),(79042,5835),(79043,5835),(79044,5835),(79045,5835),(79046,5835),(79047,5835),(79048,5836),(79049,5836),(79050,5836),(79051,5836),(79052,5836),(79053,5836),(79054,5836),(79055,5836),(79056,5836),(79057,5836),(79058,5836),(79059,5837),(79060,5837),(79061,5837),(79062,5837),(79063,5837),(79064,5837),(79065,5837),(79066,5837),(79067,5837),(79068,5837),(79069,5837),(79070,5838),(79071,5838),(79072,5838),(79073,5838),(79074,5838),(79075,5838),(79076,5838),(79077,5838),(79078,5838),(79079,5838),(79080,5838),(79081,5839),(79082,5839),(79083,5839),(79084,5839),(79085,5839),(79086,5839),(79087,5839),(79088,5839),(79089,5839),(79090,5839),(79091,5839),(79092,5840),(79093,5840),(79094,5840),(79095,5840),(79096,5840),(79097,5840),(79098,5840),(79099,5840),(79100,5840),(79101,5840),(79102,5840),(79103,5841),(79104,5841),(79105,5841),(79106,5841),(79107,5841),(79108,5841),(79109,5841),(79110,5841),(79111,5841),(79112,5841),(79113,5841),(79114,5842),(79115,5842),(79116,5842),(79117,5842),(79118,5842),(79119,5842),(79120,5842),(79121,5842),(79122,5842),(79123,5842),(79124,5842),(79125,5843),(79126,5843),(79127,5843),(79128,5843),(79129,5843),(79130,5843),(79131,5843),(79132,5843),(79133,5843),(79134,5843),(79135,5843),(79136,5844),(79137,5844),(79138,5844),(79139,5844),(79140,5844),(79141,5844),(79142,5844),(79143,5844),(79144,5844),(79145,5844),(79146,5844),(79147,5845),(79148,5845),(79149,5845),(79150,5845),(79151,5845),(79152,5845),(79153,5845),(79154,5845),(79155,5845),(79156,5845),(79157,5845),(79158,5846),(79159,5846),(79160,5846),(79161,5846),(79162,5846),(79163,5846),(79164,5846),(79165,5846),(79166,5846),(79167,5846),(79168,5846),(79169,5847),(79170,5847),(79171,5847),(79172,5847),(79173,5847),(79174,5847),(79175,5847),(79176,5847),(79177,5847),(79178,5847),(79179,5847),(79180,5848),(79181,5848),(79182,5848),(79183,5848),(79184,5848),(79185,5848),(79186,5848),(79187,5848),(79188,5848),(79189,5848),(79190,5848),(79191,5849),(79192,5849),(79193,5849),(79194,5849),(79195,5849),(79196,5849),(79197,5849),(79198,5849),(79199,5849),(79200,5849),(79201,5849),(79202,5850),(79203,5850),(79204,5850),(79205,5850),(79206,5850),(79207,5850),(79208,5850),(79209,5850),(79210,5850),(79211,5850),(79212,5850),(79213,5851),(79214,5851),(79215,5851),(79216,5851),(79217,5851),(79218,5851),(79219,5851),(79220,5851),(79221,5851),(79222,5851),(79223,5851),(79224,5852),(79225,5852),(79226,5852),(79227,5852),(79228,5852),(79229,5852),(79230,5852),(79231,5852),(79232,5852),(79233,5852),(79234,5852),(79235,5853),(79236,5853),(79237,5853),(79238,5853),(79239,5853),(79240,5853),(79241,5853),(79242,5853),(79243,5853),(79244,5853),(79245,5853),(79246,5854),(79247,5854),(79248,5854),(79249,5854),(79250,5854),(79251,5854),(79252,5854),(79253,5854),(79254,5854),(79255,5854),(79256,5854),(79257,5855),(79258,5855),(79259,5855),(79260,5855),(79261,5855),(79262,5855),(79263,5855),(79264,5855),(79265,5855),(79266,5855),(79267,5855),(79268,5856),(79269,5856),(79270,5856),(79271,5856),(79272,5856),(79273,5856),(79274,5856),(79275,5856),(79276,5856),(79277,5856),(79278,5856),(79279,5857),(79280,5857),(79281,5857),(79282,5857),(79283,5857),(79284,5857),(79285,5857),(79286,5857),(79287,5857),(79288,5857),(79289,5857),(79290,5858),(79291,5858),(79292,5858),(79293,5858),(79294,5858),(79295,5858),(79296,5858),(79297,5858),(79298,5858),(79299,5858),(79300,5858),(79301,5859),(79302,5859),(79303,5859),(79304,5859),(79305,5859),(79306,5859),(79307,5859),(79308,5859),(79309,5859),(79310,5859),(79311,5859),(79312,5860),(79313,5860),(79314,5860),(79315,5860),(79316,5860),(79317,5860),(79318,5860),(79319,5860),(79320,5860),(79321,5860),(79322,5860),(79323,5861),(79324,5861),(79325,5861),(79326,5861),(79327,5861),(79328,5861),(79329,5861),(79330,5861),(79331,5861),(79332,5862),(79333,5862),(79334,5862),(79335,5862),(79336,5862),(79337,5862),(79338,5862),(79339,5862),(79340,5862),(79341,5863),(79342,5863),(79343,5863),(79344,5863),(79345,5863),(79346,5863),(79347,5863),(79348,5863),(79349,5863),(79350,5864),(79351,5864),(79352,5864),(79353,5864),(79354,5864),(79355,5864),(79356,5864),(79357,5865),(79358,5865),(79359,5865),(79360,5865),(79361,5865),(79362,5865),(79363,5865),(79364,5866),(79365,5866),(79366,5866),(79367,5866),(79368,5866),(79369,5866),(79370,5866),(79371,5867),(79372,5867),(79373,5867),(79374,5867),(79375,5868),(79376,5868),(79377,5868),(79378,5868),(79379,5868),(79380,5868),(79381,5868),(79382,5869),(79383,5869),(79384,5869),(79385,5869),(79386,5869),(79387,5869),(79388,5869),(79389,5870),(79390,5870),(79391,5870),(79392,5870),(79393,5870),(79394,5870),(79395,5870),(79396,5871),(79397,5871),(79398,5871),(79399,5871),(79400,5872),(79401,5872),(79402,5872),(79403,5872),(79404,5872),(79405,5872),(79406,5872),(79407,5873),(79408,5873),(79409,5873),(79410,5873),(79411,5873),(79412,5873),(79413,5873),(79414,5874),(79415,5874),(79416,5874),(79417,5874),(79418,5874),(79419,5874),(79420,5874),(79421,5875),(79422,5875),(79423,5875),(79424,5875),(79425,5875),(79426,5875),(79427,5875),(79428,5876),(79429,5876),(79430,5876),(79431,5876),(79432,5876),(79433,5876),(79434,5876),(79435,5876),(79436,5876),(79437,5877),(79438,5877),(79439,5877),(79440,5877),(79441,5877),(79442,5877),(79443,5877),(79444,5878),(79445,5878),(79446,5878),(79447,5878),(79448,5878),(79449,5878),(79450,5878),(79451,5879),(79452,5879),(79453,5879),(79454,5879),(79455,5879),(79456,5879),(79457,5879),(79458,5880),(79459,5880),(79460,5880),(79461,5880),(79462,5880),(79463,5880),(79464,5880),(79465,5881),(79466,5881),(79467,5881),(79468,5881),(79469,5881),(79470,5881),(79471,5881),(79472,5881),(79473,5881),(79474,5882),(79475,5882),(79476,5882),(79477,5882),(79478,5882),(79479,5882),(79480,5882),(79481,5882),(79482,5882),(79483,5883),(79484,5883),(79485,5883),(79486,5883),(79487,5883),(79488,5883),(79489,5883),(79490,5883),(79491,5883),(79492,5884),(79493,5884),(79494,5884),(79495,5884),(79496,5884),(79497,5884),(79498,5884),(79499,5884),(79500,5884),(79501,5885),(79502,5885),(79503,5885),(79504,5885),(79505,5885),(79506,5885),(79507,5885),(79508,5885),(79509,5885),(79510,5886),(79511,5886),(79512,5886),(79513,5886),(79514,5886),(79515,5886),(79516,5886),(79517,5886),(79518,5886),(79519,5887),(79520,5887),(79521,5887),(79522,5887),(79523,5887),(79524,5887),(79525,5887),(79526,5887),(79527,5887),(79528,5888),(79529,5888),(79530,5888),(79531,5888),(79532,5888),(79533,5888),(79534,5888),(79535,5888),(79536,5888),(79537,5889),(79538,5889),(79539,5889),(79540,5889),(79541,5889),(79542,5889),(79543,5889),(79544,5889),(79545,5889),(79546,5890),(79547,5890),(79548,5890),(79549,5890),(79550,5890),(79551,5890),(79552,5890),(79553,5890),(79554,5890),(79555,5891),(79556,5891),(79557,5891),(79558,5891),(79559,5891),(79560,5891),(79561,5891),(79562,5891),(79563,5891),(79564,5892),(79565,5892),(79566,5892),(79567,5892),(79568,5892),(79569,5892),(79570,5892),(79571,5892),(79572,5892),(79573,5893),(79574,5893),(79575,5893),(79576,5893),(79577,5893),(79578,5893),(79579,5893),(79580,5894),(79581,5894),(79582,5894),(79583,5894),(79584,5894),(79585,5894),(79586,5894),(79587,5895),(79588,5895),(79589,5895),(79590,5895),(79591,5895),(79592,5895),(79593,5895),(79594,5896),(79595,5896),(79596,5896),(79597,5896),(79598,5897),(79599,5897),(79600,5897),(79601,5897),(79602,5897),(79603,5897),(79604,5897),(79605,5898),(79606,5898),(79607,5898),(79608,5898),(79609,5898),(79610,5898),(79611,5898),(79612,5899),(79613,5899),(79614,5899),(79615,5899),(79616,5899),(79617,5899),(79618,5899),(79619,5899),(79620,5899),(79621,5900),(79622,5900),(79623,5900),(79624,5900),(79625,5900),(79626,5900),(79627,5900),(79628,5901),(79629,5901),(79630,5901),(79631,5901),(79632,5901),(79633,5901),(79634,5901),(79635,5901),(79636,5901),(79637,5902),(79638,5902),(79639,5902),(79640,5902),(79641,5902),(79642,5902),(79643,5902),(79644,5902),(79645,5902),(79646,5903),(79647,5903),(79648,5903),(79649,5903),(79650,5903),(79651,5903),(79652,5903),(79653,5903),(79654,5903),(79655,5904),(79656,5904),(79657,5904),(79658,5904),(79659,5904),(79660,5904),(79661,5904),(79662,5905),(79663,5905),(79664,5905),(79665,5905),(79666,5905),(79667,5905),(79668,5905),(79669,5906),(79670,5906),(79671,5906),(79672,5906),(79673,5907),(79674,5907),(79675,5907),(79676,5907),(79677,5907),(79678,5907),(79679,5907),(79680,5907),(79681,5907),(79682,5908),(79683,5908),(79684,5908),(79685,5908),(79686,5908),(79687,5908),(79688,5908),(79689,5908),(79690,5908),(79691,5909),(79692,5909),(79693,5909),(79694,5909),(79695,5909),(79696,5909),(79697,5909),(79698,5909),(79699,5909),(79700,5910),(79701,5910),(79702,5910),(79703,5910),(79704,5910),(79705,5910),(79706,5910),(79707,5911),(79708,5911),(79709,5911),(79710,5911),(79711,5911),(79712,5911),(79713,5911),(79714,5912),(79715,5912),(79716,5912),(79717,5912),(79718,5912),(79719,5912),(79720,5912),(79721,5913),(79722,5913),(79723,5913),(79724,5913),(79725,5913),(79726,5913),(79727,5913),(79728,5914),(79729,5914),(79730,5914),(79731,5914),(79732,5914),(79733,5914),(79734,5914),(79735,5915),(79736,5915),(79737,5915),(79738,5915),(79739,5915),(79740,5915),(79741,5915),(79742,5916),(79743,5916),(79744,5916),(79745,5916),(79746,5916),(79747,5916),(79748,5916),(79749,5916),(79750,5916),(79751,5917),(79752,5917),(79753,5917),(79754,5917),(79755,5917),(79756,5917),(79757,5917),(79758,5918),(79759,5918),(79760,5918),(79761,5918),(79762,5918),(79763,5918),(79764,5919),(79765,5919),(79766,5919),(79767,5919),(79768,5919),(79769,5919),(79770,5919),(79771,5920),(79772,5920),(79773,5920),(79774,5920),(79775,5920),(79776,5920),(79777,5921),(79778,5921),(79779,5921),(79780,5921),(79781,5921),(79782,5921),(79783,5921),(79784,5922),(79785,5922),(79786,5922),(79787,5922),(79788,5922),(79789,5922),(79790,5922),(79791,5923),(79792,5923),(79793,5923),(79794,5923),(79795,5923),(79796,5923),(79797,5923),(79798,5924),(79799,5924),(79800,5924),(79801,5924),(79802,5924),(79803,5924),(79804,5924),(79805,5925),(79806,5925),(79807,5925),(79808,5925),(79809,5925),(79810,5925),(79811,5925),(79812,5926),(79813,5926),(79814,5926),(79815,5926),(79816,5926),(79817,5926),(79818,5927),(79819,5927),(79820,5927),(79821,5927),(79822,5927),(79823,5927),(79824,5927),(79825,5928),(79826,5928),(79827,5928),(79828,5928),(79829,5928),(79830,5928),(79831,5928),(79832,5929),(79833,5929),(79834,5929),(79835,5929),(79836,5929),(79837,5929),(79838,5929),(79839,5930),(79840,5930),(79841,5930),(79842,5930),(79843,5931),(79844,5931),(79845,5931),(79846,5931),(79847,5932),(79848,5932),(79849,5932),(79850,5932),(79851,5933),(79852,5933),(79853,5933),(79854,5933),(79855,5934),(79856,5934),(79857,5934),(79858,5934),(79859,5935),(79860,5935),(79861,5935),(79862,5935),(79863,5936),(79864,5936),(79865,5936),(79866,5936),(79867,5937),(79868,5937),(79869,5937),(79870,5937),(79871,5938),(79872,5938),(79873,5938),(79874,5938),(79875,5939),(79876,5939),(79877,5939),(79878,5939),(79879,5940),(79880,5940),(79881,5940),(79882,5940),(79883,5941),(79884,5941),(79885,5941),(79886,5941),(79887,5942),(79888,5942),(79889,5942),(79890,5942),(79891,5943),(79892,5943),(79893,5943),(79894,5943),(79895,5944),(79896,5944),(79897,5944),(79898,5944),(79899,5944),(79900,5944),(79901,5944),(79902,5944),(79903,5944),(79904,5945),(79905,5945),(79906,5945),(79907,5945),(79908,5945),(79909,5945),(79910,5945),(79911,5945),(79912,5945),(79913,5946),(79914,5946),(79915,5946),(79916,5946),(79917,5946),(79918,5946),(79919,5946),(79920,5946),(79921,5946),(79922,5947),(79923,5947),(79924,5947),(79925,5947),(79926,5947),(79927,5947),(79928,5947),(79929,5947),(79930,5947),(79931,5948),(79932,5948),(79933,5948),(79934,5948),(79935,5948),(79936,5948),(79937,5948),(79938,5948),(79939,5948),(79940,5949),(79941,5949),(79942,5949),(79943,5949),(79944,5949),(79945,5949),(79946,5949),(79947,5949),(79948,5949),(79949,5950),(79950,5950),(79951,5950),(79952,5950),(79953,5950),(79954,5950),(79955,5950),(79956,5950),(79957,5950),(79958,5951),(79959,5951),(79960,5951),(79961,5951),(79962,5951),(79963,5951),(79964,5951),(79965,5951),(79966,5951),(79967,5952),(79968,5952),(79969,5952),(79970,5952),(79971,5953),(79972,5953),(79973,5953),(79974,5953),(79975,5954),(79976,5954),(79977,5954),(79978,5954),(79979,5955),(79980,5955),(79981,5955),(79982,5955),(79983,5955),(79984,5955),(79985,5955),(79986,5955),(79987,5955),(79988,5956),(79989,5956),(79990,5956),(79991,5956),(79992,5956),(79993,5956),(79994,5956),(79995,5956),(79996,5956),(79997,5957),(79998,5957),(79999,5957),(80000,5957),(80001,5957),(80002,5957),(80003,5957),(80004,5957),(80005,5957),(80006,5958),(80007,5958),(80008,5958),(80009,5958),(80010,5959),(80011,5959),(80012,5959),(80013,5959),(80014,5960),(80015,5960),(80016,5960),(80017,5960),(80018,5861),(80019,5861),(80020,5862),(80021,5862),(80022,5863),(80023,5863),(80024,5864),(80025,5864),(80026,5864),(80027,5865),(80028,5865),(80029,5865),(80030,5866),(80031,5866),(80032,5866),(80033,5867),(80034,5867),(80035,5867),(80036,5868),(80037,5868),(80038,5868),(80039,5869),(80040,5869),(80041,5869),(80042,5870),(80043,5870),(80044,5870),(80045,5871),(80046,5871),(80047,5871),(80048,5872),(80049,5872),(80050,5872),(80051,5873),(80052,5873),(80053,5873),(80054,5874),(80055,5874),(80056,5874),(80057,5875),(80058,5875),(80059,5875),(80060,5876),(80061,5876),(80062,5876),(80063,5877),(80064,5877),(80065,5877),(80066,5878),(80067,5878),(80068,5878),(80069,5879),(80070,5879),(80071,5879),(80072,5880),(80073,5880),(80074,5880),(80075,5881),(80076,5881),(80077,5881),(80078,5882),(80079,5882),(80080,5882),(80081,5883),(80082,5883),(80083,5883),(80084,5884),(80085,5884),(80086,5884),(80087,5885),(80088,5885),(80089,5885),(80090,5886),(80091,5886),(80092,5886),(80093,5887),(80094,5887),(80095,5887),(80096,5888),(80097,5888),(80098,5888),(80099,5889),(80100,5889),(80101,5889),(80102,5890),(80103,5890),(80104,5890),(80105,5891),(80106,5891),(80107,5891),(80108,5892),(80109,5892),(80110,5893),(80111,5893),(80112,5893),(80113,5894),(80114,5894),(80115,5894),(80116,5895),(80117,5895),(80118,5895),(80119,5896),(80120,5896),(80121,5896),(80122,5897),(80123,5897),(80124,5897),(80125,5898),(80126,5898),(80127,5898),(80128,5899),(80129,5899),(80130,5899),(80131,5900),(80132,5900),(80133,5900),(80134,5901),(80135,5901),(80136,5901),(80137,5902),(80138,5902),(80139,5902),(80140,5903),(80141,5903),(80142,5903),(80143,5904),(80144,5904),(80145,5904),(80146,5905),(80147,5905),(80148,5905),(80149,5906),(80150,5906),(80151,5906),(80152,5907),(80153,5907),(80154,5907),(80155,5908),(80156,5908),(80157,5908),(80158,5909),(80159,5909),(80160,5909),(80161,5910),(80162,5910),(80163,5910),(80164,5911),(80165,5911),(80166,5911),(80167,5912),(80168,5912),(80169,5912),(80170,5913),(80171,5913),(80172,5913),(80173,5914),(80174,5914),(80175,5914),(80176,5915),(80177,5915),(80178,5915),(80179,5916),(80180,5916),(80181,5916),(80182,5917),(80183,5917),(80184,5917),(80185,5918),(80186,5918),(80187,5918),(80188,5919),(80189,5919),(80190,5919),(80191,5920),(80192,5920),(80193,5920),(80194,5921),(80195,5921),(80196,5921),(80197,5922),(80198,5922),(80199,5922),(80200,5923),(80201,5923),(80202,5923),(80203,5924),(80204,5924),(80205,5924),(80206,5925),(80207,5925),(80208,5925),(80209,5926),(80210,5926),(80211,5926),(80212,5927),(80213,5927),(80214,5927),(80215,5928),(80216,5928),(80217,5928),(80218,5929),(80219,5929),(80220,5929),(80221,5930),(80222,5930),(80223,5930),(80224,5931),(80225,5931),(80226,5931),(80227,5932),(80228,5932),(80229,5932),(80230,5933),(80231,5933),(80232,5933),(80233,5934),(80234,5934),(80235,5934),(80236,5935),(80237,5935),(80238,5935),(80239,5936),(80240,5936),(80241,5936),(80242,5937),(80243,5937),(80244,5937),(80245,5938),(80246,5938),(80247,5938),(80248,5939),(80249,5939),(80250,5939),(80251,5940),(80252,5940),(80253,5940),(80254,5941),(80255,5941),(80256,5941),(80257,5942),(80258,5942),(80259,5942),(80260,5943),(80261,5943),(80262,5943),(80263,5944),(80264,5944),(80265,5944),(80266,5945),(80267,5945),(80268,5945),(80269,5946),(80270,5946),(80271,5946),(80272,5947),(80273,5947),(80274,5947),(80275,5948),(80276,5948),(80277,5948),(80278,5949),(80279,5949),(80280,5949),(80281,5950),(80282,5950),(80283,5950),(80284,5951),(80285,5951),(80286,5951),(80287,5952),(80288,5952),(80289,5952),(80290,5953),(80291,5953),(80292,5953),(80293,5954),(80294,5954),(80295,5954),(80296,5955),(80297,5955),(80298,5955),(80299,5956),(80300,5956),(80301,5956),(80302,5957),(80303,5957),(80304,5957),(80305,5958),(80306,5958),(80307,5958),(80308,5959),(80309,5959),(80310,5959),(80311,5960),(80312,5960),(80313,5960),(80314,5861),(80315,5861),(80316,5861),(80317,5861),(80318,5861),(80319,5861),(80320,5861),(80321,5861),(80322,5861),(80323,5861),(80324,5861),(80325,5862),(80326,5862),(80327,5862),(80328,5862),(80329,5862),(80330,5862),(80331,5862),(80332,5862),(80333,5862),(80334,5862),(80335,5862),(80336,5863),(80337,5863),(80338,5863),(80339,5863),(80340,5863),(80341,5863),(80342,5863),(80343,5863),(80344,5863),(80345,5863),(80346,5863),(80347,5864),(80348,5864),(80349,5864),(80350,5864),(80351,5864),(80352,5864),(80353,5864),(80354,5864),(80355,5864),(80356,5864),(80357,5864),(80358,5865),(80359,5865),(80360,5865),(80361,5865),(80362,5865),(80363,5865),(80364,5865),(80365,5865),(80366,5865),(80367,5865),(80368,5865),(80369,5866),(80370,5866),(80371,5866),(80372,5866),(80373,5866),(80374,5866),(80375,5866),(80376,5866),(80377,5866),(80378,5866),(80379,5866),(80380,5867),(80381,5867),(80382,5867),(80383,5867),(80384,5867),(80385,5867),(80386,5867),(80387,5867),(80388,5867),(80389,5867),(80390,5867),(80391,5868),(80392,5868),(80393,5868),(80394,5868),(80395,5868),(80396,5868),(80397,5868),(80398,5868),(80399,5868),(80400,5868),(80401,5868),(80402,5869),(80403,5869),(80404,5869),(80405,5869),(80406,5869),(80407,5869),(80408,5869),(80409,5869),(80410,5869),(80411,5869),(80412,5869),(80413,5870),(80414,5870),(80415,5870),(80416,5870),(80417,5870),(80418,5870),(80419,5870),(80420,5870),(80421,5870),(80422,5870),(80423,5870),(80424,5871),(80425,5871),(80426,5871),(80427,5871),(80428,5871),(80429,5871),(80430,5871),(80431,5871),(80432,5871),(80433,5871),(80434,5871),(80435,5872),(80436,5872),(80437,5872),(80438,5872),(80439,5872),(80440,5872),(80441,5872),(80442,5872),(80443,5872),(80444,5872),(80445,5872),(80446,5873),(80447,5873),(80448,5873),(80449,5873),(80450,5873),(80451,5873),(80452,5873),(80453,5873),(80454,5873),(80455,5873),(80456,5873),(80457,5874),(80458,5874),(80459,5874),(80460,5874),(80461,5874),(80462,5874),(80463,5874),(80464,5874),(80465,5874),(80466,5874),(80467,5874),(80468,5875),(80469,5875),(80470,5875),(80471,5875),(80472,5875),(80473,5875),(80474,5875),(80475,5875),(80476,5875),(80477,5875),(80478,5875),(80479,5876),(80480,5876),(80481,5876),(80482,5876),(80483,5876),(80484,5876),(80485,5876),(80486,5876),(80487,5876),(80488,5876),(80489,5876),(80490,5877),(80491,5877),(80492,5877),(80493,5877),(80494,5877),(80495,5877),(80496,5877),(80497,5877),(80498,5877),(80499,5877),(80500,5877),(80501,5878),(80502,5878),(80503,5878),(80504,5878),(80505,5878),(80506,5878),(80507,5878),(80508,5878),(80509,5878),(80510,5878),(80511,5878),(80512,5879),(80513,5879),(80514,5879),(80515,5879),(80516,5879),(80517,5879),(80518,5879),(80519,5879),(80520,5879),(80521,5879),(80522,5879),(80523,5880),(80524,5880),(80525,5880),(80526,5880),(80527,5880),(80528,5880),(80529,5880),(80530,5880),(80531,5880),(80532,5880),(80533,5880),(80534,5881),(80535,5881),(80536,5881),(80537,5881),(80538,5881),(80539,5881),(80540,5881),(80541,5881),(80542,5881),(80543,5881),(80544,5881),(80545,5882),(80546,5882),(80547,5882),(80548,5882),(80549,5882),(80550,5882),(80551,5882),(80552,5882),(80553,5882),(80554,5882),(80555,5882),(80556,5883),(80557,5883),(80558,5883),(80559,5883),(80560,5883),(80561,5883),(80562,5883),(80563,5883),(80564,5883),(80565,5883),(80566,5883),(80567,5884),(80568,5884),(80569,5884),(80570,5884),(80571,5884),(80572,5884),(80573,5884),(80574,5884),(80575,5884),(80576,5884),(80577,5884),(80578,5885),(80579,5885),(80580,5885),(80581,5885),(80582,5885),(80583,5885),(80584,5885),(80585,5885),(80586,5885),(80587,5885),(80588,5885),(80589,5886),(80590,5886),(80591,5886),(80592,5886),(80593,5886),(80594,5886),(80595,5886),(80596,5886),(80597,5886),(80598,5886),(80599,5886),(80600,5887),(80601,5887),(80602,5887),(80603,5887),(80604,5887),(80605,5887),(80606,5887),(80607,5887),(80608,5887),(80609,5887),(80610,5887),(80611,5888),(80612,5888),(80613,5888),(80614,5888),(80615,5888),(80616,5888),(80617,5888),(80618,5888),(80619,5888),(80620,5888),(80621,5888),(80622,5889),(80623,5889),(80624,5889),(80625,5889),(80626,5889),(80627,5889),(80628,5889),(80629,5889),(80630,5889),(80631,5889),(80632,5889),(80633,5890),(80634,5890),(80635,5890),(80636,5890),(80637,5890),(80638,5890),(80639,5890),(80640,5890),(80641,5890),(80642,5890),(80643,5890),(80644,5891),(80645,5891),(80646,5891),(80647,5891),(80648,5891),(80649,5891),(80650,5891),(80651,5891),(80652,5891),(80653,5891),(80654,5891),(80655,5892),(80656,5892),(80657,5892),(80658,5892),(80659,5892),(80660,5892),(80661,5892),(80662,5892),(80663,5892),(80664,5892),(80665,5892),(80666,5893),(80667,5893),(80668,5893),(80669,5893),(80670,5893),(80671,5893),(80672,5893),(80673,5893),(80674,5893),(80675,5893),(80676,5893),(80677,5894),(80678,5894),(80679,5894),(80680,5894),(80681,5894),(80682,5894),(80683,5894),(80684,5894),(80685,5894),(80686,5894),(80687,5894),(80688,5895),(80689,5895),(80690,5895),(80691,5895),(80692,5895),(80693,5895),(80694,5895),(80695,5895),(80696,5895),(80697,5895),(80698,5895),(80699,5896),(80700,5896),(80701,5896),(80702,5896),(80703,5896),(80704,5896),(80705,5896),(80706,5896),(80707,5896),(80708,5896),(80709,5896),(80710,5897),(80711,5897),(80712,5897),(80713,5897),(80714,5897),(80715,5897),(80716,5897),(80717,5897),(80718,5897),(80719,5897),(80720,5897),(80721,5898),(80722,5898),(80723,5898),(80724,5898),(80725,5898),(80726,5898),(80727,5898),(80728,5898),(80729,5898),(80730,5898),(80731,5898),(80732,5899),(80733,5899),(80734,5899),(80735,5899),(80736,5899),(80737,5899),(80738,5899),(80739,5899),(80740,5899),(80741,5899),(80742,5899),(80743,5900),(80744,5900),(80745,5900),(80746,5900),(80747,5900),(80748,5900),(80749,5900),(80750,5900),(80751,5900),(80752,5900),(80753,5900),(80754,5901),(80755,5901),(80756,5901),(80757,5901),(80758,5901),(80759,5901),(80760,5901),(80761,5901),(80762,5901),(80763,5901),(80764,5901),(80765,5902),(80766,5902),(80767,5902),(80768,5902),(80769,5902),(80770,5902),(80771,5902),(80772,5902),(80773,5902),(80774,5902),(80775,5902),(80776,5903),(80777,5903),(80778,5903),(80779,5903),(80780,5903),(80781,5903),(80782,5903),(80783,5903),(80784,5903),(80785,5903),(80786,5903),(80787,5904),(80788,5904),(80789,5904),(80790,5904),(80791,5904),(80792,5904),(80793,5904),(80794,5904),(80795,5904),(80796,5904),(80797,5904),(80798,5905),(80799,5905),(80800,5905),(80801,5905),(80802,5905),(80803,5905),(80804,5905),(80805,5905),(80806,5905),(80807,5905),(80808,5905),(80809,5906),(80810,5906),(80811,5906),(80812,5906),(80813,5906),(80814,5906),(80815,5906),(80816,5906),(80817,5906),(80818,5906),(80819,5906),(80820,5907),(80821,5907),(80822,5907),(80823,5907),(80824,5907),(80825,5907),(80826,5907),(80827,5907),(80828,5907),(80829,5907),(80830,5907),(80831,5908),(80832,5908),(80833,5908),(80834,5908),(80835,5908),(80836,5908),(80837,5908),(80838,5908),(80839,5908),(80840,5908),(80841,5908),(80842,5909),(80843,5909),(80844,5909),(80845,5909),(80846,5909),(80847,5909),(80848,5909),(80849,5909),(80850,5909),(80851,5909),(80852,5909),(80853,5910),(80854,5910),(80855,5910),(80856,5910),(80857,5910),(80858,5910),(80859,5910),(80860,5910),(80861,5910),(80862,5910),(80863,5910),(80864,5911),(80865,5911),(80866,5911),(80867,5911),(80868,5911),(80869,5911),(80870,5911),(80871,5911),(80872,5911),(80873,5911),(80874,5911),(80875,5912),(80876,5912),(80877,5912),(80878,5912),(80879,5912),(80880,5912),(80881,5912),(80882,5912),(80883,5912),(80884,5912),(80885,5912),(80886,5913),(80887,5913),(80888,5913),(80889,5913),(80890,5913),(80891,5913),(80892,5913),(80893,5913),(80894,5913),(80895,5913),(80896,5913),(80897,5914),(80898,5914),(80899,5914),(80900,5914),(80901,5914),(80902,5914),(80903,5914),(80904,5914),(80905,5914),(80906,5914),(80907,5914),(80908,5915),(80909,5915),(80910,5915),(80911,5915),(80912,5915),(80913,5915),(80914,5915),(80915,5915),(80916,5915),(80917,5915),(80918,5915),(80919,5916),(80920,5916),(80921,5916),(80922,5916),(80923,5916),(80924,5916),(80925,5916),(80926,5916),(80927,5916),(80928,5916),(80929,5916),(80930,5917),(80931,5917),(80932,5917),(80933,5917),(80934,5917),(80935,5917),(80936,5917),(80937,5917),(80938,5917),(80939,5917),(80940,5917),(80941,5918),(80942,5918),(80943,5918),(80944,5918),(80945,5918),(80946,5918),(80947,5918),(80948,5918),(80949,5918),(80950,5918),(80951,5918),(80952,5919),(80953,5919),(80954,5919),(80955,5919),(80956,5919),(80957,5919),(80958,5919),(80959,5919),(80960,5919),(80961,5919),(80962,5919),(80963,5920),(80964,5920),(80965,5920),(80966,5920),(80967,5920),(80968,5920),(80969,5920),(80970,5920),(80971,5920),(80972,5920),(80973,5920),(80974,5921),(80975,5921),(80976,5921),(80977,5921),(80978,5921),(80979,5921),(80980,5921),(80981,5921),(80982,5921),(80983,5921),(80984,5921),(80985,5922),(80986,5922),(80987,5922),(80988,5922),(80989,5922),(80990,5922),(80991,5922),(80992,5922),(80993,5922),(80994,5922),(80995,5922),(80996,5923),(80997,5923),(80998,5923),(80999,5923),(81000,5923),(81001,5923),(81002,5923),(81003,5923),(81004,5923),(81005,5923),(81006,5923),(81007,5924),(81008,5924),(81009,5924),(81010,5924),(81011,5924),(81012,5924),(81013,5924),(81014,5924),(81015,5924),(81016,5924),(81017,5924),(81018,5925),(81019,5925),(81020,5925),(81021,5925),(81022,5925),(81023,5925),(81024,5925),(81025,5925),(81026,5925),(81027,5925),(81028,5925),(81029,5926),(81030,5926),(81031,5926),(81032,5926),(81033,5926),(81034,5926),(81035,5926),(81036,5926),(81037,5926),(81038,5926),(81039,5926),(81040,5927),(81041,5927),(81042,5927),(81043,5927),(81044,5927),(81045,5927),(81046,5927),(81047,5927),(81048,5927),(81049,5927),(81050,5927),(81051,5928),(81052,5928),(81053,5928),(81054,5928),(81055,5928),(81056,5928),(81057,5928),(81058,5928),(81059,5928),(81060,5928),(81061,5928),(81062,5929),(81063,5929),(81064,5929),(81065,5929),(81066,5929),(81067,5929),(81068,5929),(81069,5929),(81070,5929),(81071,5929),(81072,5929),(81073,5930),(81074,5930),(81075,5930),(81076,5930),(81077,5930),(81078,5930),(81079,5930),(81080,5930),(81081,5930),(81082,5930),(81083,5930),(81084,5931),(81085,5931),(81086,5931),(81087,5931),(81088,5931),(81089,5931),(81090,5931),(81091,5931),(81092,5931),(81093,5931),(81094,5931),(81095,5932),(81096,5932),(81097,5932),(81098,5932),(81099,5932),(81100,5932),(81101,5932),(81102,5932),(81103,5932),(81104,5932),(81105,5932),(81106,5933),(81107,5933),(81108,5933),(81109,5933),(81110,5933),(81111,5933),(81112,5933),(81113,5933),(81114,5933),(81115,5933),(81116,5933),(81117,5934),(81118,5934),(81119,5934),(81120,5934),(81121,5934),(81122,5934),(81123,5934),(81124,5934),(81125,5934),(81126,5934),(81127,5934),(81128,5935),(81129,5935),(81130,5935),(81131,5935),(81132,5935),(81133,5935),(81134,5935),(81135,5935),(81136,5935),(81137,5935),(81138,5935),(81139,5936),(81140,5936),(81141,5936),(81142,5936),(81143,5936),(81144,5936),(81145,5936),(81146,5936),(81147,5936),(81148,5936),(81149,5936),(81150,5937),(81151,5937),(81152,5937),(81153,5937),(81154,5937),(81155,5937),(81156,5937),(81157,5937),(81158,5937),(81159,5937),(81160,5937),(81161,5938),(81162,5938),(81163,5938),(81164,5938),(81165,5938),(81166,5938),(81167,5938),(81168,5938),(81169,5938),(81170,5938),(81171,5938),(81172,5939),(81173,5939),(81174,5939),(81175,5939),(81176,5939),(81177,5939),(81178,5939),(81179,5939),(81180,5939),(81181,5939),(81182,5939),(81183,5940),(81184,5940),(81185,5940),(81186,5940),(81187,5940),(81188,5940),(81189,5940),(81190,5940),(81191,5940),(81192,5940),(81193,5940),(81194,5941),(81195,5941),(81196,5941),(81197,5941),(81198,5941),(81199,5941),(81200,5941),(81201,5941),(81202,5941),(81203,5941),(81204,5941),(81205,5942),(81206,5942),(81207,5942),(81208,5942),(81209,5942),(81210,5942),(81211,5942),(81212,5942),(81213,5942),(81214,5942),(81215,5942),(81216,5943),(81217,5943),(81218,5943),(81219,5943),(81220,5943),(81221,5943),(81222,5943),(81223,5943),(81224,5943),(81225,5943),(81226,5943),(81227,5944),(81228,5944),(81229,5944),(81230,5944),(81231,5944),(81232,5944),(81233,5944),(81234,5944),(81235,5944),(81236,5944),(81237,5944),(81238,5945),(81239,5945),(81240,5945),(81241,5945),(81242,5945),(81243,5945),(81244,5945),(81245,5945),(81246,5945),(81247,5945),(81248,5945),(81249,5946),(81250,5946),(81251,5946),(81252,5946),(81253,5946),(81254,5946),(81255,5946),(81256,5946),(81257,5946),(81258,5946),(81259,5946),(81260,5947),(81261,5947),(81262,5947),(81263,5947),(81264,5947),(81265,5947),(81266,5947),(81267,5947),(81268,5947),(81269,5947),(81270,5947),(81271,5948),(81272,5948),(81273,5948),(81274,5948),(81275,5948),(81276,5948),(81277,5948),(81278,5948),(81279,5948),(81280,5948),(81281,5948),(81282,5949),(81283,5949),(81284,5949),(81285,5949),(81286,5949),(81287,5949),(81288,5949),(81289,5949),(81290,5949),(81291,5949),(81292,5949),(81293,5950),(81294,5950),(81295,5950),(81296,5950),(81297,5950),(81298,5950),(81299,5950),(81300,5950),(81301,5950),(81302,5950),(81303,5950),(81304,5951),(81305,5951),(81306,5951),(81307,5951),(81308,5951),(81309,5951),(81310,5951),(81311,5951),(81312,5951),(81313,5951),(81314,5951),(81315,5952),(81316,5952),(81317,5952),(81318,5952),(81319,5952),(81320,5952),(81321,5952),(81322,5952),(81323,5952),(81324,5952),(81325,5952),(81326,5953),(81327,5953),(81328,5953),(81329,5953),(81330,5953),(81331,5953),(81332,5953),(81333,5953),(81334,5953),(81335,5953),(81336,5953),(81337,5954),(81338,5954),(81339,5954),(81340,5954),(81341,5954),(81342,5954),(81343,5954),(81344,5954),(81345,5954),(81346,5954),(81347,5954),(81348,5955),(81349,5955),(81350,5955),(81351,5955),(81352,5955),(81353,5955),(81354,5955),(81355,5955),(81356,5955),(81357,5955),(81358,5955),(81359,5956),(81360,5956),(81361,5956),(81362,5956),(81363,5956),(81364,5956),(81365,5956),(81366,5956),(81367,5956),(81368,5956),(81369,5956),(81370,5957),(81371,5957),(81372,5957),(81373,5957),(81374,5957),(81375,5957),(81376,5957),(81377,5957),(81378,5957),(81379,5957),(81380,5957),(81381,5958),(81382,5958),(81383,5958),(81384,5958),(81385,5958),(81386,5958),(81387,5958),(81388,5958),(81389,5958),(81390,5958),(81391,5958),(81392,5959),(81393,5959),(81394,5959),(81395,5959),(81396,5959),(81397,5959),(81398,5959),(81399,5959),(81400,5959),(81401,5959),(81402,5959),(81403,5960),(81404,5960),(81405,5960),(81406,5960),(81407,5960),(81408,5960),(81409,5960),(81410,5960),(81411,5960),(81412,5960),(81413,5960),(81414,5961),(81415,5961),(81416,5961),(81417,5961),(81418,5962),(81419,5962),(81420,5962),(81421,5962),(81422,5963),(81423,5963),(81424,5963),(81425,5963),(81426,5964),(81427,5964),(81428,5964),(81429,5964),(81430,5965),(81431,5965),(81432,5965),(81433,5965),(81434,5966),(81435,5966),(81436,5966),(81437,5966),(81438,5967),(81439,5967),(81440,5967),(81441,5967),(81442,5968),(81443,5968),(81444,5968),(81445,5968),(81446,5969),(81447,5969),(81448,5969),(81449,5969),(81450,5970),(81451,5970),(81452,5970),(81453,5970),(81454,5971),(81455,5971),(81456,5971),(81457,5971),(81458,5972),(81459,5972),(81460,5972),(81461,5972),(81462,5973),(81463,5973),(81464,5973),(81465,5973),(81466,5974),(81467,5974),(81468,5974),(81469,5974),(81470,5975),(81471,5975),(81472,5975),(81473,5975),(81474,5975),(81475,5975),(81476,5975),(81477,5976),(81478,5976),(81479,5976),(81480,5976),(81481,5976),(81482,5976),(81483,5976),(81484,5977),(81485,5977),(81486,5977),(81487,5977),(81488,5977),(81489,5977),(81490,5977),(81491,5978),(81492,5978),(81493,5978),(81494,5978),(81495,5978),(81496,5978),(81497,5978),(81498,5979),(81499,5979),(81500,5979),(81501,5979),(81502,5979),(81503,5979),(81504,5979),(81505,5980),(81506,5980),(81507,5980),(81508,5980),(81509,5980),(81510,5980),(81511,5980),(81512,5981),(81513,5981),(81514,5981),(81515,5981),(81516,5981),(81517,5981),(81518,5981),(81519,5982),(81520,5982),(81521,5982),(81522,5982),(81523,5982),(81524,5982),(81525,5982),(81526,5983),(81527,5983),(81528,5983),(81529,5983),(81530,5983),(81531,5983),(81532,5983),(81533,5984),(81534,5984),(81535,5984),(81536,5984),(81537,5984),(81538,5984),(81539,5984),(81540,5985),(81541,5985),(81542,5985),(81543,5985),(81544,5985),(81545,5985),(81546,5985),(81547,5986),(81548,5986),(81549,5986),(81550,5986),(81551,5986),(81552,5986),(81553,5986),(81554,5987),(81555,5987),(81556,5987),(81557,5987),(81558,5987),(81559,5987),(81560,5987),(81561,5988),(81562,5988),(81563,5988),(81564,5988),(81565,5988),(81566,5988),(81567,5988),(81568,5989),(81569,5989),(81570,5989),(81571,5989),(81572,5989),(81573,5989),(81574,5989),(81575,5990),(81576,5990),(81577,5990),(81578,5990),(81579,5990),(81580,5990),(81581,5990),(81582,5991),(81583,5991),(81584,5991),(81585,5991),(81586,5991),(81587,5991),(81588,5991),(81589,5992),(81590,5992),(81591,5992),(81592,5992),(81593,5992),(81594,5992),(81595,5992),(81596,5993),(81597,5993),(81598,5993),(81599,5993),(81600,5993),(81601,5993),(81602,5993),(81603,5994),(81604,5994),(81605,5994),(81606,5994),(81607,5994),(81608,5994),(81609,5994),(81610,5995),(81611,5995),(81612,5995),(81613,5995),(81614,5995),(81615,5995),(81616,5995),(81617,5996),(81618,5996),(81619,5996),(81620,5996),(81621,5996),(81622,5996),(81623,5996),(81624,5997),(81625,5997),(81626,5997),(81627,5997),(81628,5997),(81629,5997),(81630,5997),(81631,5998),(81632,5998),(81633,5998),(81634,5998),(81635,5998),(81636,5998),(81637,5998),(81638,5998),(81639,5998),(81640,5999),(81641,5999),(81642,5999),(81643,5999),(81644,5999),(81645,5999),(81646,5999),(81647,5999),(81648,5999),(81649,6000),(81650,6000),(81651,6000),(81652,6000),(81653,6000),(81654,6000),(81655,6000),(81656,6001),(81657,6001),(81658,6001),(81659,6001),(81660,6001),(81661,6001),(81662,6001),(81663,6002),(81664,6002),(81665,6002),(81666,6002),(81667,6002),(81668,6002),(81669,6002),(81670,6003),(81671,6003),(81672,6003),(81673,6003),(81674,6003),(81675,6003),(81676,6003),(81677,6004),(81678,6004),(81679,6004),(81680,6004),(81681,6004),(81682,6004),(81683,6004),(81684,6005),(81685,6005),(81686,6005),(81687,6005),(81688,6005),(81689,6005),(81690,6005),(81691,6005),(81692,6005),(81693,6006),(81694,6006),(81695,6006),(81696,6006),(81697,6006),(81698,6006),(81699,6006),(81700,6007),(81701,6007),(81702,6007),(81703,6007),(81704,6007),(81705,6007),(81706,6007),(81707,6008),(81708,6008),(81709,6008),(81710,6008),(81711,6008),(81712,6008),(81713,6009),(81714,6009),(81715,6009),(81716,6009),(81717,6009),(81718,6009),(81719,6010),(81720,6010),(81721,6010),(81722,6010),(81723,6010),(81724,6010),(81725,6011),(81726,6011),(81727,6011),(81728,6011),(81729,6011),(81730,6011),(81731,6012),(81732,6012),(81733,6012),(81734,6012),(81735,6012),(81736,6012),(81737,6012),(81738,6013),(81739,6013),(81740,6013),(81741,6013),(81742,6013),(81743,6013),(81744,6013),(81745,6014),(81746,6014),(81747,6014),(81748,6014),(81749,6014),(81750,6014),(81751,6014),(81752,6015),(81753,6015),(81754,6015),(81755,6015),(81756,6015),(81757,6015),(81758,6015),(81759,6016),(81760,6016),(81761,6016),(81762,6016),(81763,6016),(81764,6016),(81765,6016),(81766,6017),(81767,6017),(81768,6017),(81769,6017),(81770,6017),(81771,6017),(81772,6017),(81773,6018),(81774,6018),(81775,6018),(81776,6018),(81777,6018),(81778,6018),(81779,6018),(81780,6019),(81781,6019),(81782,6019),(81783,6019),(81784,6019),(81785,6019),(81786,6019),(81787,6020),(81788,6020),(81789,6020),(81790,6020),(81791,6020),(81792,6020),(81793,6020),(81794,6021),(81795,6021),(81796,6021),(81797,6021),(81798,6021),(81799,6021),(81800,6021),(81801,6022),(81802,6022),(81803,6022),(81804,6022),(81805,6022),(81806,6022),(81807,6022),(81808,6022),(81809,6022),(81810,6023),(81811,6023),(81812,6023),(81813,6023),(81814,6023),(81815,6023),(81816,6023),(81817,6023),(81818,6023),(81819,6024),(81820,6024),(81821,6024),(81822,6024),(81823,6024),(81824,6024),(81825,6024),(81826,6024),(81827,6024),(81828,6025),(81829,6025),(81830,6025),(81831,6025),(81832,6025),(81833,6025),(81834,6025),(81835,6025),(81836,6025),(81837,6026),(81838,6026),(81839,6026),(81840,6026),(81841,6026),(81842,6026),(81843,6026),(81844,6026),(81845,6026),(81846,6027),(81847,6027),(81848,6027),(81849,6027),(81850,6027),(81851,6027),(81852,6027),(81853,6027),(81854,6027),(81855,6028),(81856,6028),(81857,6028),(81858,6028),(81859,6028),(81860,6028),(81861,6028),(81862,6028),(81863,6028),(81864,6029),(81865,6029),(81866,6029),(81867,6029),(81868,6029),(81869,6029),(81870,6029),(81871,6029),(81872,6029),(81873,6030),(81874,6030),(81875,6030),(81876,6030),(81877,6030),(81878,6030),(81879,6030),(81880,6031),(81881,6031),(81882,6031),(81883,6031),(81884,6031),(81885,6031),(81886,6031),(81887,6032),(81888,6032),(81889,6032),(81890,6032),(81891,6032),(81892,6032),(81893,6032),(81894,6033),(81895,6033),(81896,6033),(81897,6033),(81898,6033),(81899,6033),(81900,6033),(81901,6034),(81902,6034),(81903,6034),(81904,6034),(81905,6034),(81906,6034),(81907,6034),(81908,5961),(81909,5961),(81910,5961),(81911,5962),(81912,5962),(81913,5962),(81914,5963),(81915,5963),(81916,5963),(81917,5964),(81918,5964),(81919,5964),(81920,5965),(81921,5965),(81922,5965),(81923,5966),(81924,5966),(81925,5966),(81926,5967),(81927,5967),(81928,5967),(81929,5968),(81930,5968),(81931,5968),(81932,5969),(81933,5969),(81934,5969),(81935,5970),(81936,5970),(81937,5970),(81938,5971),(81939,5971),(81940,5971),(81941,5972),(81942,5972),(81943,5972),(81944,5973),(81945,5973),(81946,5973),(81947,5974),(81948,5974),(81949,5974),(81950,5975),(81951,5975),(81952,5975),(81953,5976),(81954,5976),(81955,5976),(81956,5977),(81957,5977),(81958,5977),(81959,5978),(81960,5978),(81961,5978),(81962,5979),(81963,5979),(81964,5979),(81965,5980),(81966,5980),(81967,5980),(81968,5981),(81969,5981),(81970,5981),(81971,5982),(81972,5982),(81973,5982),(81974,5983),(81975,5983),(81976,5983),(81977,5984),(81978,5984),(81979,5984),(81980,5985),(81981,5985),(81982,5985),(81983,5986),(81984,5986),(81985,5986),(81986,5987),(81987,5987),(81988,5987),(81989,5988),(81990,5988),(81991,5988),(81992,5989),(81993,5989),(81994,5989),(81995,5990),(81996,5990),(81997,5990),(81998,5991),(81999,5991),(82000,5991),(82001,5992),(82002,5992),(82003,5992),(82004,5993),(82005,5993),(82006,5993),(82007,5994),(82008,5994),(82009,5994),(82010,5995),(82011,5995),(82012,5995),(82013,5996),(82014,5996),(82015,5996),(82016,5997),(82017,5997),(82018,5997),(82019,5998),(82020,5998),(82021,5999),(82022,5999),(82023,6000),(82024,6000),(82025,6000),(82026,6001),(82027,6001),(82028,6001),(82029,6002),(82030,6002),(82031,6002),(82032,6003),(82033,6003),(82034,6003),(82035,6004),(82036,6004),(82037,6004),(82038,6005),(82039,6005),(82040,6006),(82041,6006),(82042,6006),(82043,6007),(82044,6007),(82045,6007),(82046,6008),(82047,6008),(82048,6008),(82049,6009),(82050,6009),(82051,6009),(82052,6010),(82053,6010),(82054,6010),(82055,6011),(82056,6011),(82057,6011),(82058,6012),(82059,6012),(82060,6012),(82061,6013),(82062,6013),(82063,6013),(82064,6014),(82065,6014),(82066,6014),(82067,6015),(82068,6015),(82069,6015),(82070,6016),(82071,6016),(82072,6016),(82073,6017),(82074,6017),(82075,6017),(82076,6018),(82077,6018),(82078,6018),(82079,6019),(82080,6019),(82081,6019),(82082,6020),(82083,6020),(82084,6020),(82085,6021),(82086,6021),(82087,6021),(82088,6022),(82089,6022),(82090,6022),(82091,6023),(82092,6023),(82093,6023),(82094,6024),(82095,6024),(82096,6024),(82097,6025),(82098,6025),(82099,6025),(82100,6026),(82101,6026),(82102,6026),(82103,6027),(82104,6027),(82105,6027),(82106,6028),(82107,6028),(82108,6028),(82109,6029),(82110,6029),(82111,6029),(82112,6030),(82113,6030),(82114,6030),(82115,6031),(82116,6031),(82117,6031),(82118,6032),(82119,6032),(82120,6032),(82121,6033),(82122,6033),(82123,6033),(82124,6034),(82125,6034),(82126,6034),(82127,5961),(82128,5961),(82129,5961),(82130,5961),(82131,5961),(82132,5961),(82133,5961),(82134,5961),(82135,5961),(82136,5961),(82137,5961),(82138,5962),(82139,5962),(82140,5962),(82141,5962),(82142,5962),(82143,5962),(82144,5962),(82145,5962),(82146,5962),(82147,5962),(82148,5962),(82149,5963),(82150,5963),(82151,5963),(82152,5963),(82153,5963),(82154,5963),(82155,5963),(82156,5963),(82157,5963),(82158,5963),(82159,5963),(82160,5964),(82161,5964),(82162,5964),(82163,5964),(82164,5964),(82165,5964),(82166,5964),(82167,5964),(82168,5964),(82169,5964),(82170,5964),(82171,5965),(82172,5965),(82173,5965),(82174,5965),(82175,5965),(82176,5965),(82177,5965),(82178,5965),(82179,5965),(82180,5965),(82181,5965),(82182,5966),(82183,5966),(82184,5966),(82185,5966),(82186,5966),(82187,5966),(82188,5966),(82189,5966),(82190,5966),(82191,5966),(82192,5966),(82193,5967),(82194,5967),(82195,5967),(82196,5967),(82197,5967),(82198,5967),(82199,5967),(82200,5967),(82201,5967),(82202,5967),(82203,5967),(82204,5968),(82205,5968),(82206,5968),(82207,5968),(82208,5968),(82209,5968),(82210,5968),(82211,5968),(82212,5968),(82213,5968),(82214,5968),(82215,5969),(82216,5969),(82217,5969),(82218,5969),(82219,5969),(82220,5969),(82221,5969),(82222,5969),(82223,5969),(82224,5969),(82225,5969),(82226,5970),(82227,5970),(82228,5970),(82229,5970),(82230,5970),(82231,5970),(82232,5970),(82233,5970),(82234,5970),(82235,5970),(82236,5970),(82237,5971),(82238,5971),(82239,5971),(82240,5971),(82241,5971),(82242,5971),(82243,5971),(82244,5971),(82245,5971),(82246,5971),(82247,5971),(82248,5972),(82249,5972),(82250,5972),(82251,5972),(82252,5972),(82253,5972),(82254,5972),(82255,5972),(82256,5972),(82257,5972),(82258,5972),(82259,5973),(82260,5973),(82261,5973),(82262,5973),(82263,5973),(82264,5973),(82265,5973),(82266,5973),(82267,5973),(82268,5973),(82269,5973),(82270,5974),(82271,5974),(82272,5974),(82273,5974),(82274,5974),(82275,5974),(82276,5974),(82277,5974),(82278,5974),(82279,5974),(82280,5974),(82281,5975),(82282,5975),(82283,5975),(82284,5975),(82285,5975),(82286,5975),(82287,5975),(82288,5975),(82289,5975),(82290,5975),(82291,5975),(82292,5976),(82293,5976),(82294,5976),(82295,5976),(82296,5976),(82297,5976),(82298,5976),(82299,5976),(82300,5976),(82301,5976),(82302,5976),(82303,5977),(82304,5977),(82305,5977),(82306,5977),(82307,5977),(82308,5977),(82309,5977),(82310,5977),(82311,5977),(82312,5977),(82313,5977),(82314,5978),(82315,5978),(82316,5978),(82317,5978),(82318,5978),(82319,5978),(82320,5978),(82321,5978),(82322,5978),(82323,5978),(82324,5978),(82325,5979),(82326,5979),(82327,5979),(82328,5979),(82329,5979),(82330,5979),(82331,5979),(82332,5979),(82333,5979),(82334,5979),(82335,5979),(82336,5980),(82337,5980),(82338,5980),(82339,5980),(82340,5980),(82341,5980),(82342,5980),(82343,5980),(82344,5980),(82345,5980),(82346,5980),(82347,5981),(82348,5981),(82349,5981),(82350,5981),(82351,5981),(82352,5981),(82353,5981),(82354,5981),(82355,5981),(82356,5981),(82357,5981),(82358,5982),(82359,5982),(82360,5982),(82361,5982),(82362,5982),(82363,5982),(82364,5982),(82365,5982),(82366,5982),(82367,5982),(82368,5982),(82369,5983),(82370,5983),(82371,5983),(82372,5983),(82373,5983),(82374,5983),(82375,5983),(82376,5983),(82377,5983),(82378,5983),(82379,5983),(82380,5984),(82381,5984),(82382,5984),(82383,5984),(82384,5984),(82385,5984),(82386,5984),(82387,5984),(82388,5984),(82389,5984),(82390,5984),(82391,5985),(82392,5985),(82393,5985),(82394,5985),(82395,5985),(82396,5985),(82397,5985),(82398,5985),(82399,5985),(82400,5985),(82401,5985),(82402,5986),(82403,5986),(82404,5986),(82405,5986),(82406,5986),(82407,5986),(82408,5986),(82409,5986),(82410,5986),(82411,5986),(82412,5986),(82413,5987),(82414,5987),(82415,5987),(82416,5987),(82417,5987),(82418,5987),(82419,5987),(82420,5987),(82421,5987),(82422,5987),(82423,5987),(82424,5988),(82425,5988),(82426,5988),(82427,5988),(82428,5988),(82429,5988),(82430,5988),(82431,5988),(82432,5988),(82433,5988),(82434,5988),(82435,5989),(82436,5989),(82437,5989),(82438,5989),(82439,5989),(82440,5989),(82441,5989),(82442,5989),(82443,5989),(82444,5989),(82445,5989),(82446,5990),(82447,5990),(82448,5990),(82449,5990),(82450,5990),(82451,5990),(82452,5990),(82453,5990),(82454,5990),(82455,5990),(82456,5990),(82457,5991),(82458,5991),(82459,5991),(82460,5991),(82461,5991),(82462,5991),(82463,5991),(82464,5991),(82465,5991),(82466,5991),(82467,5991),(82468,5992),(82469,5992),(82470,5992),(82471,5992),(82472,5992),(82473,5992),(82474,5992),(82475,5992),(82476,5992),(82477,5992),(82478,5992),(82479,5993),(82480,5993),(82481,5993),(82482,5993),(82483,5993),(82484,5993),(82485,5993),(82486,5993),(82487,5993),(82488,5993),(82489,5993),(82490,5994),(82491,5994),(82492,5994),(82493,5994),(82494,5994),(82495,5994),(82496,5994),(82497,5994),(82498,5994),(82499,5994),(82500,5994),(82501,5995),(82502,5995),(82503,5995),(82504,5995),(82505,5995),(82506,5995),(82507,5995),(82508,5995),(82509,5995),(82510,5995),(82511,5995),(82512,5996),(82513,5996),(82514,5996),(82515,5996),(82516,5996),(82517,5996),(82518,5996),(82519,5996),(82520,5996),(82521,5996),(82522,5996),(82523,5997),(82524,5997),(82525,5997),(82526,5997),(82527,5997),(82528,5997),(82529,5997),(82530,5997),(82531,5997),(82532,5997),(82533,5997),(82534,5998),(82535,5998),(82536,5998),(82537,5998),(82538,5998),(82539,5998),(82540,5998),(82541,5998),(82542,5998),(82543,5998),(82544,5998),(82545,5999),(82546,5999),(82547,5999),(82548,5999),(82549,5999),(82550,5999),(82551,5999),(82552,5999),(82553,5999),(82554,5999),(82555,5999),(82556,6000),(82557,6000),(82558,6000),(82559,6000),(82560,6000),(82561,6000),(82562,6000),(82563,6000),(82564,6000),(82565,6000),(82566,6000),(82567,6001),(82568,6001),(82569,6001),(82570,6001),(82571,6001),(82572,6001),(82573,6001),(82574,6001),(82575,6001),(82576,6001),(82577,6001),(82578,6002),(82579,6002),(82580,6002),(82581,6002),(82582,6002),(82583,6002),(82584,6002),(82585,6002),(82586,6002),(82587,6002),(82588,6002),(82589,6003),(82590,6003),(82591,6003),(82592,6003),(82593,6003),(82594,6003),(82595,6003),(82596,6003),(82597,6003),(82598,6003),(82599,6003),(82600,6004),(82601,6004),(82602,6004),(82603,6004),(82604,6004),(82605,6004),(82606,6004),(82607,6004),(82608,6004),(82609,6004),(82610,6004),(82611,6005),(82612,6005),(82613,6005),(82614,6005),(82615,6005),(82616,6005),(82617,6005),(82618,6005),(82619,6005),(82620,6005),(82621,6005),(82622,6006),(82623,6006),(82624,6006),(82625,6006),(82626,6006),(82627,6006),(82628,6006),(82629,6006),(82630,6006),(82631,6006),(82632,6006),(82633,6007),(82634,6007),(82635,6007),(82636,6007),(82637,6007),(82638,6007),(82639,6007),(82640,6007),(82641,6007),(82642,6007),(82643,6007),(82644,6008),(82645,6008),(82646,6008),(82647,6008),(82648,6008),(82649,6008),(82650,6008),(82651,6008),(82652,6008),(82653,6008),(82654,6008),(82655,6009),(82656,6009),(82657,6009),(82658,6009),(82659,6009),(82660,6009),(82661,6009),(82662,6009),(82663,6009),(82664,6009),(82665,6009),(82666,6010),(82667,6010),(82668,6010),(82669,6010),(82670,6010),(82671,6010),(82672,6010),(82673,6010),(82674,6010),(82675,6010),(82676,6010),(82677,6011),(82678,6011),(82679,6011),(82680,6011),(82681,6011),(82682,6011),(82683,6011),(82684,6011),(82685,6011),(82686,6011),(82687,6011),(82688,6012),(82689,6012),(82690,6012),(82691,6012),(82692,6012),(82693,6012),(82694,6012),(82695,6012),(82696,6012),(82697,6012),(82698,6012),(82699,6013),(82700,6013),(82701,6013),(82702,6013),(82703,6013),(82704,6013),(82705,6013),(82706,6013),(82707,6013),(82708,6013),(82709,6013),(82710,6014),(82711,6014),(82712,6014),(82713,6014),(82714,6014),(82715,6014),(82716,6014),(82717,6014),(82718,6014),(82719,6014),(82720,6014),(82721,6015),(82722,6015),(82723,6015),(82724,6015),(82725,6015),(82726,6015),(82727,6015),(82728,6015),(82729,6015),(82730,6015),(82731,6015),(82732,6016),(82733,6016),(82734,6016),(82735,6016),(82736,6016),(82737,6016),(82738,6016),(82739,6016),(82740,6016),(82741,6016),(82742,6016),(82743,6017),(82744,6017),(82745,6017),(82746,6017),(82747,6017),(82748,6017),(82749,6017),(82750,6017),(82751,6017),(82752,6017),(82753,6017),(82754,6018),(82755,6018),(82756,6018),(82757,6018),(82758,6018),(82759,6018),(82760,6018),(82761,6018),(82762,6018),(82763,6018),(82764,6018),(82765,6019),(82766,6019),(82767,6019),(82768,6019),(82769,6019),(82770,6019),(82771,6019),(82772,6019),(82773,6019),(82774,6019),(82775,6019),(82776,6020),(82777,6020),(82778,6020),(82779,6020),(82780,6020),(82781,6020),(82782,6020),(82783,6020),(82784,6020),(82785,6020),(82786,6020),(82787,6021),(82788,6021),(82789,6021),(82790,6021),(82791,6021),(82792,6021),(82793,6021),(82794,6021),(82795,6021),(82796,6021),(82797,6021),(82798,6022),(82799,6022),(82800,6022),(82801,6022),(82802,6022),(82803,6022),(82804,6022),(82805,6022),(82806,6022),(82807,6022),(82808,6022),(82809,6023),(82810,6023),(82811,6023),(82812,6023),(82813,6023),(82814,6023),(82815,6023),(82816,6023),(82817,6023),(82818,6023),(82819,6023),(82820,6024),(82821,6024),(82822,6024),(82823,6024),(82824,6024),(82825,6024),(82826,6024),(82827,6024),(82828,6024),(82829,6024),(82830,6024),(82831,6025),(82832,6025),(82833,6025),(82834,6025),(82835,6025),(82836,6025),(82837,6025),(82838,6025),(82839,6025),(82840,6025),(82841,6025),(82842,6026),(82843,6026),(82844,6026),(82845,6026),(82846,6026),(82847,6026),(82848,6026),(82849,6026),(82850,6026),(82851,6026),(82852,6026),(82853,6027),(82854,6027),(82855,6027),(82856,6027),(82857,6027),(82858,6027),(82859,6027),(82860,6027),(82861,6027),(82862,6027),(82863,6027),(82864,6028),(82865,6028),(82866,6028),(82867,6028),(82868,6028),(82869,6028),(82870,6028),(82871,6028),(82872,6028),(82873,6028),(82874,6028),(82875,6029),(82876,6029),(82877,6029),(82878,6029),(82879,6029),(82880,6029),(82881,6029),(82882,6029),(82883,6029),(82884,6029),(82885,6029),(82886,6030),(82887,6030),(82888,6030),(82889,6030),(82890,6030),(82891,6030),(82892,6030),(82893,6030),(82894,6030),(82895,6030),(82896,6030),(82897,6031),(82898,6031),(82899,6031),(82900,6031),(82901,6031),(82902,6031),(82903,6031),(82904,6031),(82905,6031),(82906,6031),(82907,6031),(82908,6032),(82909,6032),(82910,6032),(82911,6032),(82912,6032),(82913,6032),(82914,6032),(82915,6032),(82916,6032),(82917,6032),(82918,6032),(82919,6033),(82920,6033),(82921,6033),(82922,6033),(82923,6033),(82924,6033),(82925,6033),(82926,6033),(82927,6033),(82928,6033),(82929,6033),(82930,6034),(82931,6034),(82932,6034),(82933,6034),(82934,6034),(82935,6034),(82936,6034),(82937,6034),(82938,6034),(82939,6034),(82940,6034),(82941,6035),(82942,6035),(82943,6035),(82944,6036),(82945,6036),(82946,6036),(82947,6037),(82948,6037),(82949,6037),(82950,6038),(82951,6038),(82952,6038),(82953,6039),(82954,6039),(82955,6039),(82956,6040),(82957,6040),(82958,6040),(82959,6041),(82960,6041),(82961,6041),(82962,6042),(82963,6042),(82964,6042),(82965,6043),(82966,6043),(82967,6043),(82968,6044),(82969,6044),(82970,6044),(82971,6045),(82972,6045),(82973,6045),(82974,6046),(82975,6046),(82976,6046),(82977,6047),(82978,6047),(82979,6047),(82980,6048),(82981,6048),(82982,6048),(82983,6049),(82984,6049),(82985,6049),(82986,6050),(82987,6050),(82988,6050),(82989,6051),(82990,6051),(82991,6051),(82992,6052),(82993,6052),(82994,6052),(82995,6053),(82996,6053),(82997,6053),(82998,6054),(82999,6054),(83000,6054),(83001,6055),(83002,6055),(83003,6055),(83004,6056),(83005,6056),(83006,6056),(83007,6057),(83008,6057),(83009,6057),(83010,6058),(83011,6058),(83012,6058),(83013,6059),(83014,6059),(83015,6059),(83016,6060),(83017,6060),(83018,6060),(83019,6061),(83020,6061),(83021,6061),(83022,6062),(83023,6062),(83024,6062),(83025,6063),(83026,6063),(83027,6063),(83028,6064),(83029,6064),(83030,6064),(83031,6065),(83032,6065),(83033,6065),(83034,6066),(83035,6066),(83036,6066),(83037,6067),(83038,6067),(83039,6067),(83040,6068),(83041,6068),(83042,6068),(83043,6069),(83044,6069),(83045,6069),(83046,6070),(83047,6070),(83048,6070),(83049,6071),(83050,6071),(83051,6071),(83052,6072),(83053,6072),(83054,6072),(83055,6073),(83056,6073),(83057,6073),(83058,6074),(83059,6074),(83060,6074),(83061,6075),(83062,6075),(83063,6075),(83064,6076),(83065,6076),(83066,6076),(83067,6077),(83068,6077),(83069,6077),(83070,6078),(83071,6078),(83072,6078),(83073,6079),(83074,6079),(83075,6079),(83076,6080),(83077,6080),(83078,6080),(83079,6081),(83080,6081),(83081,6081),(83082,6082),(83083,6082),(83084,6082),(83085,6083),(83086,6083),(83087,6083),(83088,6084),(83089,6084),(83090,6084),(83091,6085),(83092,6085),(83093,6085),(83094,6086),(83095,6086),(83096,6086),(83097,6087),(83098,6087),(83099,6087),(83100,6088),(83101,6088),(83102,6088),(83103,6089),(83104,6089),(83105,6089),(83106,6090),(83107,6090),(83108,6090),(83109,6091),(83110,6091),(83111,6091),(83112,6092),(83113,6092),(83114,6092),(83115,6093),(83116,6093),(83117,6093),(83118,6094),(83119,6094),(83120,6094),(83121,6095),(83122,6095),(83123,6095),(83124,6096),(83125,6096),(83126,6096),(83127,6097),(83128,6097),(83129,6097),(83130,6098),(83131,6098),(83132,6098),(83133,6099),(83134,6099),(83135,6099),(83136,6100),(83137,6100),(83138,6100),(83139,6101),(83140,6101),(83141,6101),(83142,6102),(83143,6102),(83144,6102),(83145,6103),(83146,6103),(83147,6103),(83148,6104),(83149,6104),(83150,6104),(83151,6105),(83152,6105),(83153,6105),(83154,6106),(83155,6106),(83156,6106),(83157,6107),(83158,6107),(83159,6107),(83160,6108),(83161,6108),(83162,6108),(83163,6109),(83164,6109),(83165,6109),(83166,6110),(83167,6110),(83168,6110),(83169,6111),(83170,6111),(83171,6111),(83172,6112),(83173,6112),(83174,6112),(83175,6113),(83176,6113),(83177,6113),(83178,6114),(83179,6114),(83180,6114),(83181,6115),(83182,6115),(83183,6115),(83184,6116),(83185,6116),(83186,6116),(83187,6117),(83188,6117),(83189,6117),(83190,6118),(83191,6118),(83192,6118),(83193,6119),(83194,6119),(83195,6119),(83196,6120),(83197,6120),(83198,6120),(83199,6121),(83200,6121),(83201,6121),(83202,6122),(83203,6122),(83204,6122),(83205,6123),(83206,6123),(83207,6123),(83208,6124),(83209,6124),(83210,6124),(83211,6125),(83212,6125),(83213,6125),(83214,6126),(83215,6126),(83216,6126),(83217,6127),(83218,6127),(83219,6127),(83220,6128),(83221,6128),(83222,6128),(83223,6129),(83224,6129),(83225,6129),(83226,6130),(83227,6130),(83228,6130),(83229,6131),(83230,6131),(83231,6131),(83232,6132),(83233,6132),(83234,6132),(83235,6133),(83236,6133),(83237,6133),(83238,6134),(83239,6134),(83240,6134),(83241,6035),(83242,6035),(83243,6035),(83244,6035),(83245,6035),(83246,6035),(83247,6035),(83248,6035),(83249,6036),(83250,6036),(83251,6036),(83252,6036),(83253,6036),(83254,6036),(83255,6036),(83256,6036),(83257,6037),(83258,6037),(83259,6037),(83260,6037),(83261,6037),(83262,6037),(83263,6037),(83264,6037),(83265,6038),(83266,6038),(83267,6038),(83268,6038),(83269,6038),(83270,6038),(83271,6038),(83272,6038),(83273,6039),(83274,6039),(83275,6039),(83276,6039),(83277,6039),(83278,6039),(83279,6039),(83280,6039),(83281,6040),(83282,6040),(83283,6040),(83284,6040),(83285,6040),(83286,6040),(83287,6040),(83288,6040),(83289,6041),(83290,6041),(83291,6041),(83292,6041),(83293,6041),(83294,6041),(83295,6041),(83296,6041),(83297,6041),(83298,6041),(83299,6042),(83300,6042),(83301,6042),(83302,6042),(83303,6042),(83304,6042),(83305,6042),(83306,6042),(83307,6042),(83308,6042),(83309,6043),(83310,6043),(83311,6043),(83312,6043),(83313,6043),(83314,6043),(83315,6043),(83316,6043),(83317,6043),(83318,6043),(83319,6044),(83320,6044),(83321,6044),(83322,6044),(83323,6044),(83324,6044),(83325,6044),(83326,6044),(83327,6044),(83328,6044),(83329,6045),(83330,6045),(83331,6045),(83332,6045),(83333,6045),(83334,6045),(83335,6045),(83336,6045),(83337,6045),(83338,6045),(83339,6046),(83340,6046),(83341,6046),(83342,6046),(83343,6046),(83344,6046),(83345,6046),(83346,6046),(83347,6046),(83348,6046),(83349,6047),(83350,6047),(83351,6047),(83352,6047),(83353,6047),(83354,6047),(83355,6047),(83356,6047),(83357,6047),(83358,6047),(83359,6048),(83360,6048),(83361,6048),(83362,6048),(83363,6048),(83364,6048),(83365,6048),(83366,6048),(83367,6048),(83368,6048),(83369,6049),(83370,6049),(83371,6049),(83372,6049),(83373,6049),(83374,6049),(83375,6049),(83376,6049),(83377,6049),(83378,6049),(83379,6050),(83380,6050),(83381,6050),(83382,6050),(83383,6050),(83384,6050),(83385,6050),(83386,6050),(83387,6050),(83388,6050),(83389,6051),(83390,6051),(83391,6051),(83392,6051),(83393,6051),(83394,6051),(83395,6051),(83396,6051),(83397,6051),(83398,6051),(83399,6052),(83400,6052),(83401,6052),(83402,6052),(83403,6052),(83404,6052),(83405,6052),(83406,6052),(83407,6052),(83408,6052),(83409,6053),(83410,6053),(83411,6053),(83412,6053),(83413,6053),(83414,6053),(83415,6053),(83416,6053),(83417,6053),(83418,6053),(83419,6053),(83420,6053),(83421,6053),(83422,6053),(83423,6054),(83424,6054),(83425,6054),(83426,6054),(83427,6054),(83428,6054),(83429,6054),(83430,6054),(83431,6054),(83432,6054),(83433,6054),(83434,6054),(83435,6054),(83436,6054),(83437,6055),(83438,6055),(83439,6055),(83440,6055),(83441,6055),(83442,6055),(83443,6055),(83444,6055),(83445,6055),(83446,6055),(83447,6056),(83448,6056),(83449,6056),(83450,6056),(83451,6056),(83452,6056),(83453,6056),(83454,6056),(83455,6056),(83456,6056),(83457,6057),(83458,6057),(83459,6057),(83460,6057),(83461,6057),(83462,6057),(83463,6057),(83464,6057),(83465,6057),(83466,6057),(83467,6058),(83468,6058),(83469,6058),(83470,6058),(83471,6058),(83472,6058),(83473,6058),(83474,6058),(83475,6058),(83476,6058),(83477,6059),(83478,6059),(83479,6059),(83480,6059),(83481,6059),(83482,6059),(83483,6059),(83484,6059),(83485,6059),(83486,6059),(83487,6060),(83488,6060),(83489,6060),(83490,6060),(83491,6060),(83492,6060),(83493,6060),(83494,6060),(83495,6060),(83496,6060),(83497,6061),(83498,6061),(83499,6061),(83500,6061),(83501,6061),(83502,6061),(83503,6061),(83504,6061),(83505,6061),(83506,6061),(83507,6062),(83508,6062),(83509,6062),(83510,6062),(83511,6062),(83512,6062),(83513,6062),(83514,6062),(83515,6062),(83516,6062),(83517,6063),(83518,6063),(83519,6063),(83520,6063),(83521,6063),(83522,6063),(83523,6063),(83524,6063),(83525,6063),(83526,6063),(83527,6064),(83528,6064),(83529,6064),(83530,6064),(83531,6064),(83532,6064),(83533,6064),(83534,6064),(83535,6064),(83536,6064),(83537,6065),(83538,6065),(83539,6065),(83540,6065),(83541,6065),(83542,6065),(83543,6065),(83544,6065),(83545,6065),(83546,6065),(83547,6066),(83548,6066),(83549,6066),(83550,6066),(83551,6066),(83552,6066),(83553,6066),(83554,6066),(83555,6066),(83556,6066),(83557,6067),(83558,6067),(83559,6067),(83560,6067),(83561,6067),(83562,6067),(83563,6067),(83564,6067),(83565,6067),(83566,6067),(83567,6068),(83568,6068),(83569,6068),(83570,6068),(83571,6068),(83572,6068),(83573,6068),(83574,6068),(83575,6068),(83576,6068),(83577,6069),(83578,6069),(83579,6069),(83580,6069),(83581,6069),(83582,6069),(83583,6069),(83584,6069),(83585,6069),(83586,6069),(83587,6070),(83588,6070),(83589,6070),(83590,6070),(83591,6070),(83592,6070),(83593,6070),(83594,6070),(83595,6070),(83596,6070),(83597,6071),(83598,6071),(83599,6071),(83600,6071),(83601,6071),(83602,6071),(83603,6071),(83604,6071),(83605,6071),(83606,6071),(83607,6071),(83608,6071),(83609,6071),(83610,6071),(83611,6072),(83612,6072),(83613,6072),(83614,6072),(83615,6072),(83616,6072),(83617,6072),(83618,6072),(83619,6072),(83620,6072),(83621,6073),(83622,6073),(83623,6073),(83624,6073),(83625,6073),(83626,6073),(83627,6073),(83628,6073),(83629,6073),(83630,6073),(83631,6074),(83632,6074),(83633,6074),(83634,6074),(83635,6074),(83636,6074),(83637,6074),(83638,6074),(83639,6074),(83640,6074),(83641,6075),(83642,6075),(83643,6075),(83644,6075),(83645,6075),(83646,6075),(83647,6075),(83648,6075),(83649,6075),(83650,6075),(83651,6076),(83652,6076),(83653,6076),(83654,6076),(83655,6076),(83656,6076),(83657,6076),(83658,6076),(83659,6076),(83660,6076),(83661,6077),(83662,6077),(83663,6077),(83664,6077),(83665,6077),(83666,6077),(83667,6077),(83668,6077),(83669,6077),(83670,6077),(83671,6078),(83672,6078),(83673,6078),(83674,6078),(83675,6078),(83676,6078),(83677,6078),(83678,6078),(83679,6078),(83680,6078),(83681,6079),(83682,6079),(83683,6079),(83684,6079),(83685,6079),(83686,6079),(83687,6079),(83688,6079),(83689,6079),(83690,6079),(83691,6080),(83692,6080),(83693,6080),(83694,6080),(83695,6080),(83696,6080),(83697,6080),(83698,6080),(83699,6080),(83700,6080),(83701,6081),(83702,6081),(83703,6081),(83704,6081),(83705,6081),(83706,6081),(83707,6081),(83708,6081),(83709,6081),(83710,6081),(83711,6082),(83712,6082),(83713,6082),(83714,6082),(83715,6082),(83716,6082),(83717,6082),(83718,6082),(83719,6082),(83720,6082),(83721,6083),(83722,6083),(83723,6083),(83724,6083),(83725,6083),(83726,6083),(83727,6083),(83728,6083),(83729,6083),(83730,6083),(83731,6084),(83732,6084),(83733,6084),(83734,6084),(83735,6084),(83736,6084),(83737,6084),(83738,6084),(83739,6084),(83740,6084),(83741,6085),(83742,6085),(83743,6085),(83744,6085),(83745,6085),(83746,6085),(83747,6085),(83748,6085),(83749,6085),(83750,6085),(83751,6086),(83752,6086),(83753,6086),(83754,6086),(83755,6086),(83756,6086),(83757,6086),(83758,6086),(83759,6086),(83760,6086),(83761,6087),(83762,6087),(83763,6087),(83764,6087),(83765,6087),(83766,6087),(83767,6087),(83768,6087),(83769,6087),(83770,6087),(83771,6088),(83772,6088),(83773,6088),(83774,6088),(83775,6088),(83776,6088),(83777,6088),(83778,6088),(83779,6088),(83780,6088),(83781,6088),(83782,6088),(83783,6088),(83784,6088),(83785,6089),(83786,6089),(83787,6089),(83788,6089),(83789,6089),(83790,6089),(83791,6089),(83792,6089),(83793,6089),(83794,6089),(83795,6090),(83796,6090),(83797,6090),(83798,6090),(83799,6090),(83800,6090),(83801,6090),(83802,6090),(83803,6090),(83804,6090),(83805,6091),(83806,6091),(83807,6091),(83808,6091),(83809,6091),(83810,6091),(83811,6091),(83812,6091),(83813,6091),(83814,6091),(83815,6092),(83816,6092),(83817,6092),(83818,6092),(83819,6092),(83820,6092),(83821,6092),(83822,6092),(83823,6092),(83824,6092),(83825,6092),(83826,6092),(83827,6092),(83828,6092),(83829,6093),(83830,6093),(83831,6093),(83832,6093),(83833,6093),(83834,6093),(83835,6093),(83836,6093),(83837,6093),(83838,6093),(83839,6094),(83840,6094),(83841,6094),(83842,6094),(83843,6094),(83844,6094),(83845,6094),(83846,6094),(83847,6094),(83848,6094),(83849,6095),(83850,6095),(83851,6095),(83852,6095),(83853,6095),(83854,6095),(83855,6095),(83856,6095),(83857,6095),(83858,6095),(83859,6096),(83860,6096),(83861,6096),(83862,6096),(83863,6096),(83864,6096),(83865,6096),(83866,6096),(83867,6096),(83868,6096),(83869,6096),(83870,6096),(83871,6096),(83872,6096),(83873,6097),(83874,6097),(83875,6097),(83876,6097),(83877,6097),(83878,6097),(83879,6097),(83880,6097),(83881,6097),(83882,6097),(83883,6098),(83884,6098),(83885,6098),(83886,6098),(83887,6098),(83888,6098),(83889,6098),(83890,6098),(83891,6098),(83892,6098),(83893,6099),(83894,6099),(83895,6099),(83896,6099),(83897,6099),(83898,6099),(83899,6099),(83900,6099),(83901,6099),(83902,6099),(83903,6100),(83904,6100),(83905,6100),(83906,6100),(83907,6100),(83908,6100),(83909,6100),(83910,6100),(83911,6100),(83912,6100),(83913,6101),(83914,6101),(83915,6101),(83916,6101),(83917,6101),(83918,6101),(83919,6101),(83920,6101),(83921,6101),(83922,6101),(83923,6102),(83924,6102),(83925,6102),(83926,6102),(83927,6102),(83928,6102),(83929,6102),(83930,6102),(83931,6102),(83932,6102),(83933,6103),(83934,6103),(83935,6103),(83936,6103),(83937,6103),(83938,6103),(83939,6103),(83940,6103),(83941,6103),(83942,6103),(83943,6104),(83944,6104),(83945,6104),(83946,6104),(83947,6104),(83948,6104),(83949,6104),(83950,6104),(83951,6104),(83952,6104),(83953,6105),(83954,6105),(83955,6105),(83956,6105),(83957,6105),(83958,6105),(83959,6105),(83960,6105),(83961,6105),(83962,6105),(83963,6105),(83964,6105),(83965,6105),(83966,6105),(83967,6106),(83968,6106),(83969,6106),(83970,6106),(83971,6106),(83972,6106),(83973,6106),(83974,6106),(83975,6106),(83976,6106),(83977,6107),(83978,6107),(83979,6107),(83980,6107),(83981,6107),(83982,6107),(83983,6107),(83984,6107),(83985,6107),(83986,6107),(83987,6108),(83988,6108),(83989,6108),(83990,6108),(83991,6108),(83992,6108),(83993,6108),(83994,6108),(83995,6108),(83996,6108),(83997,6109),(83998,6109),(83999,6109),(84000,6109),(84001,6109),(84002,6109),(84003,6109),(84004,6109),(84005,6109),(84006,6109),(84007,6109),(84008,6109),(84009,6109),(84010,6109),(84011,6110),(84012,6110),(84013,6110),(84014,6110),(84015,6110),(84016,6110),(84017,6110),(84018,6110),(84019,6110),(84020,6110),(84021,6111),(84022,6111),(84023,6111),(84024,6111),(84025,6111),(84026,6111),(84027,6111),(84028,6111),(84029,6111),(84030,6111),(84031,6112),(84032,6112),(84033,6112),(84034,6112),(84035,6112),(84036,6112),(84037,6112),(84038,6112),(84039,6112),(84040,6112),(84041,6113),(84042,6113),(84043,6113),(84044,6113),(84045,6113),(84046,6113),(84047,6113),(84048,6113),(84049,6113),(84050,6113),(84051,6113),(84052,6113),(84053,6113),(84054,6113),(84055,6114),(84056,6114),(84057,6114),(84058,6114),(84059,6114),(84060,6114),(84061,6114),(84062,6114),(84063,6114),(84064,6114),(84065,6115),(84066,6115),(84067,6115),(84068,6115),(84069,6115),(84070,6115),(84071,6115),(84072,6115),(84073,6115),(84074,6115),(84075,6116),(84076,6116),(84077,6116),(84078,6116),(84079,6116),(84080,6116),(84081,6116),(84082,6116),(84083,6116),(84084,6116),(84085,6117),(84086,6117),(84087,6117),(84088,6117),(84089,6117),(84090,6117),(84091,6117),(84092,6117),(84093,6117),(84094,6117),(84095,6118),(84096,6118),(84097,6118),(84098,6118),(84099,6118),(84100,6118),(84101,6118),(84102,6118),(84103,6118),(84104,6118),(84105,6119),(84106,6119),(84107,6119),(84108,6119),(84109,6119),(84110,6119),(84111,6119),(84112,6119),(84113,6119),(84114,6119),(84115,6120),(84116,6120),(84117,6120),(84118,6120),(84119,6120),(84120,6120),(84121,6120),(84122,6120),(84123,6120),(84124,6120),(84125,6121),(84126,6121),(84127,6121),(84128,6121),(84129,6121),(84130,6121),(84131,6121),(84132,6121),(84133,6121),(84134,6121),(84135,6122),(84136,6122),(84137,6122),(84138,6122),(84139,6122),(84140,6122),(84141,6122),(84142,6122),(84143,6122),(84144,6122),(84145,6123),(84146,6123),(84147,6123),(84148,6123),(84149,6123),(84150,6123),(84151,6123),(84152,6123),(84153,6123),(84154,6123),(84155,6124),(84156,6124),(84157,6124),(84158,6124),(84159,6124),(84160,6124),(84161,6124),(84162,6124),(84163,6124),(84164,6124),(84165,6125),(84166,6125),(84167,6125),(84168,6125),(84169,6125),(84170,6125),(84171,6125),(84172,6125),(84173,6125),(84174,6125),(84175,6125),(84176,6125),(84177,6125),(84178,6125),(84179,6126),(84180,6126),(84181,6126),(84182,6126),(84183,6126),(84184,6126),(84185,6126),(84186,6126),(84187,6126),(84188,6126),(84189,6126),(84190,6126),(84191,6126),(84192,6126),(84193,6127),(84194,6127),(84195,6127),(84196,6127),(84197,6127),(84198,6127),(84199,6127),(84200,6127),(84201,6127),(84202,6127),(84203,6127),(84204,6127),(84205,6127),(84206,6127),(84207,6128),(84208,6128),(84209,6128),(84210,6128),(84211,6128),(84212,6128),(84213,6128),(84214,6128),(84215,6128),(84216,6128),(84217,6128),(84218,6128),(84219,6128),(84220,6128),(84221,6129),(84222,6129),(84223,6129),(84224,6129),(84225,6129),(84226,6129),(84227,6129),(84228,6129),(84229,6129),(84230,6129),(84231,6129),(84232,6129),(84233,6129),(84234,6129),(84235,6130),(84236,6130),(84237,6130),(84238,6130),(84239,6130),(84240,6130),(84241,6130),(84242,6130),(84243,6130),(84244,6130),(84245,6131),(84246,6131),(84247,6131),(84248,6131),(84249,6131),(84250,6131),(84251,6131),(84252,6131),(84253,6131),(84254,6131),(84255,6131),(84256,6131),(84257,6131),(84258,6131),(84259,6132),(84260,6132),(84261,6132),(84262,6132),(84263,6132),(84264,6132),(84265,6132),(84266,6132),(84267,6132),(84268,6132),(84269,6133),(84270,6133),(84271,6133),(84272,6133),(84273,6133),(84274,6133),(84275,6133),(84276,6133),(84277,6133),(84278,6133),(84279,6134),(84280,6134),(84281,6134),(84282,6134),(84283,6134),(84284,6134),(84285,6134),(84286,6134),(84287,6134),(84288,6134),(84289,6035),(84290,6035),(84291,6035),(84292,6035),(84293,6035),(84294,6036),(84295,6036),(84296,6036),(84297,6036),(84298,6036),(84299,6037),(84300,6037),(84301,6037),(84302,6037),(84303,6037),(84304,6038),(84305,6038),(84306,6038),(84307,6038),(84308,6038),(84309,6039),(84310,6039),(84311,6039),(84312,6039),(84313,6039),(84314,6040),(84315,6040),(84316,6040),(84317,6040),(84318,6040),(84319,6041),(84320,6041),(84321,6041),(84322,6041),(84323,6041),(84324,6042),(84325,6042),(84326,6042),(84327,6042),(84328,6042),(84329,6043),(84330,6043),(84331,6043),(84332,6043),(84333,6043),(84334,6044),(84335,6044),(84336,6044),(84337,6044),(84338,6044),(84339,6045),(84340,6045),(84341,6045),(84342,6045),(84343,6045),(84344,6046),(84345,6046),(84346,6046),(84347,6046),(84348,6046),(84349,6047),(84350,6047),(84351,6047),(84352,6047),(84353,6047),(84354,6048),(84355,6048),(84356,6048),(84357,6048),(84358,6048),(84359,6049),(84360,6049),(84361,6049),(84362,6049),(84363,6049),(84364,6050),(84365,6050),(84366,6050),(84367,6050),(84368,6050),(84369,6051),(84370,6051),(84371,6051),(84372,6051),(84373,6051),(84374,6052),(84375,6052),(84376,6052),(84377,6052),(84378,6052),(84379,6053),(84380,6053),(84381,6053),(84382,6053),(84383,6053),(84384,6054),(84385,6054),(84386,6054),(84387,6054),(84388,6054),(84389,6055),(84390,6055),(84391,6055),(84392,6055),(84393,6055),(84394,6056),(84395,6056),(84396,6056),(84397,6056),(84398,6056),(84399,6057),(84400,6057),(84401,6057),(84402,6057),(84403,6057),(84404,6058),(84405,6058),(84406,6058),(84407,6058),(84408,6058),(84409,6059),(84410,6059),(84411,6059),(84412,6059),(84413,6059),(84414,6060),(84415,6060),(84416,6060),(84417,6060),(84418,6060),(84419,6061),(84420,6061),(84421,6061),(84422,6061),(84423,6061),(84424,6062),(84425,6062),(84426,6062),(84427,6062),(84428,6062),(84429,6063),(84430,6063),(84431,6063),(84432,6063),(84433,6063),(84434,6064),(84435,6064),(84436,6064),(84437,6064),(84438,6064),(84439,6065),(84440,6065),(84441,6065),(84442,6065),(84443,6065),(84444,6066),(84445,6066),(84446,6066),(84447,6066),(84448,6066),(84449,6067),(84450,6067),(84451,6067),(84452,6067),(84453,6067),(84454,6068),(84455,6068),(84456,6068),(84457,6068),(84458,6068),(84459,6069),(84460,6069),(84461,6069),(84462,6069),(84463,6069),(84464,6070),(84465,6070),(84466,6070),(84467,6070),(84468,6070),(84469,6071),(84470,6071),(84471,6071),(84472,6071),(84473,6071),(84474,6072),(84475,6072),(84476,6072),(84477,6072),(84478,6072),(84479,6073),(84480,6073),(84481,6073),(84482,6073),(84483,6073),(84484,6074),(84485,6074),(84486,6074),(84487,6074),(84488,6074),(84489,6075),(84490,6075),(84491,6075),(84492,6075),(84493,6075),(84494,6076),(84495,6076),(84496,6076),(84497,6076),(84498,6076),(84499,6077),(84500,6077),(84501,6077),(84502,6077),(84503,6077),(84504,6078),(84505,6078),(84506,6078),(84507,6078),(84508,6078),(84509,6079),(84510,6079),(84511,6079),(84512,6079),(84513,6079),(84514,6080),(84515,6080),(84516,6080),(84517,6080),(84518,6080),(84519,6081),(84520,6081),(84521,6081),(84522,6081),(84523,6081),(84524,6082),(84525,6082),(84526,6082),(84527,6082),(84528,6082),(84529,6083),(84530,6083),(84531,6083),(84532,6083),(84533,6083),(84534,6084),(84535,6084),(84536,6084),(84537,6084),(84538,6084),(84539,6085),(84540,6085),(84541,6085),(84542,6085),(84543,6085),(84544,6086),(84545,6086),(84546,6086),(84547,6086),(84548,6086),(84549,6087),(84550,6087),(84551,6087),(84552,6087),(84553,6087),(84554,6088),(84555,6088),(84556,6088),(84557,6088),(84558,6088),(84559,6089),(84560,6089),(84561,6089),(84562,6089),(84563,6089),(84564,6090),(84565,6090),(84566,6090),(84567,6090),(84568,6090),(84569,6091),(84570,6091),(84571,6091),(84572,6091),(84573,6091),(84574,6092),(84575,6092),(84576,6092),(84577,6092),(84578,6092),(84579,6093),(84580,6093),(84581,6093),(84582,6093),(84583,6093),(84584,6094),(84585,6094),(84586,6094),(84587,6094),(84588,6094),(84589,6095),(84590,6095),(84591,6095),(84592,6095),(84593,6095),(84594,6096),(84595,6096),(84596,6096),(84597,6096),(84598,6096),(84599,6097),(84600,6097),(84601,6097),(84602,6097),(84603,6097),(84604,6098),(84605,6098),(84606,6098),(84607,6098),(84608,6098),(84609,6099),(84610,6099),(84611,6099),(84612,6099),(84613,6099),(84614,6100),(84615,6100),(84616,6100),(84617,6100),(84618,6100),(84619,6101),(84620,6101),(84621,6101),(84622,6101),(84623,6101),(84624,6102),(84625,6102),(84626,6102),(84627,6102),(84628,6102),(84629,6103),(84630,6103),(84631,6103),(84632,6103),(84633,6103),(84634,6104),(84635,6104),(84636,6104),(84637,6104),(84638,6104),(84639,6105),(84640,6105),(84641,6105),(84642,6105),(84643,6105),(84644,6106),(84645,6106),(84646,6106),(84647,6106),(84648,6106),(84649,6107),(84650,6107),(84651,6107),(84652,6107),(84653,6107),(84654,6108),(84655,6108),(84656,6108),(84657,6108),(84658,6108),(84659,6109),(84660,6109),(84661,6109),(84662,6109),(84663,6109),(84664,6110),(84665,6110),(84666,6110),(84667,6110),(84668,6110),(84669,6111),(84670,6111),(84671,6111),(84672,6111),(84673,6111),(84674,6112),(84675,6112),(84676,6112),(84677,6112),(84678,6112),(84679,6113),(84680,6113),(84681,6113),(84682,6113),(84683,6113),(84684,6114),(84685,6114),(84686,6114),(84687,6114),(84688,6114),(84689,6115),(84690,6115),(84691,6115),(84692,6115),(84693,6115),(84694,6116),(84695,6116),(84696,6116),(84697,6116),(84698,6116),(84699,6117),(84700,6117),(84701,6117),(84702,6117),(84703,6117),(84704,6118),(84705,6118),(84706,6118),(84707,6118),(84708,6118),(84709,6119),(84710,6119),(84711,6119),(84712,6119),(84713,6119),(84714,6120),(84715,6120),(84716,6120),(84717,6120),(84718,6120),(84719,6121),(84720,6121),(84721,6121),(84722,6121),(84723,6121),(84724,6122),(84725,6122),(84726,6122),(84727,6122),(84728,6122),(84729,6123),(84730,6123),(84731,6123),(84732,6123),(84733,6123),(84734,6124),(84735,6124),(84736,6124),(84737,6124),(84738,6124),(84739,6125),(84740,6125),(84741,6125),(84742,6125),(84743,6125),(84744,6126),(84745,6126),(84746,6126),(84747,6126),(84748,6126),(84749,6127),(84750,6127),(84751,6127),(84752,6127),(84753,6127),(84754,6128),(84755,6128),(84756,6128),(84757,6128),(84758,6128),(84759,6129),(84760,6129),(84761,6129),(84762,6129),(84763,6129),(84764,6130),(84765,6130),(84766,6130),(84767,6130),(84768,6130),(84769,6131),(84770,6131),(84771,6131),(84772,6131),(84773,6131),(84774,6132),(84775,6132),(84776,6132),(84777,6132),(84778,6132),(84779,6133),(84780,6133),(84781,6133),(84782,6133),(84783,6133),(84784,6134),(84785,6134),(84786,6134),(84787,6134),(84788,6134),(84789,6135),(84790,6135),(84791,6135),(84792,6136),(84793,6136),(84794,6136),(84795,6137),(84796,6137),(84797,6137),(84798,6138),(84799,6138),(84800,6138),(84801,6139),(84802,6139),(84803,6139),(84804,6140),(84805,6140),(84806,6140),(84807,6141),(84808,6141),(84809,6141),(84810,6142),(84811,6142),(84812,6142),(84813,6143),(84814,6143),(84815,6143),(84816,6144),(84817,6144),(84818,6144),(84819,6145),(84820,6145),(84821,6145),(84822,6146),(84823,6146),(84824,6146),(84825,6147),(84826,6147),(84827,6147),(84828,6148),(84829,6148),(84830,6148),(84831,6149),(84832,6149),(84833,6149),(84834,6150),(84835,6150),(84836,6150),(84837,6151),(84838,6151),(84839,6151),(84840,6152),(84841,6152),(84842,6152),(84843,6153),(84844,6153),(84845,6153),(84846,6154),(84847,6154),(84848,6154),(84849,6155),(84850,6155),(84851,6155),(84852,6156),(84853,6156),(84854,6156),(84855,6157),(84856,6157),(84857,6157),(84858,6158),(84859,6158),(84860,6158),(84861,6159),(84862,6159),(84863,6159),(84864,6160),(84865,6160),(84866,6160),(84867,6161),(84868,6161),(84869,6161),(84870,6162),(84871,6162),(84872,6162),(84873,6163),(84874,6163),(84875,6163),(84876,6164),(84877,6164),(84878,6164),(84879,6165),(84880,6165),(84881,6165),(84882,6166),(84883,6166),(84884,6166),(84885,6167),(84886,6167),(84887,6167),(84888,6168),(84889,6168),(84890,6168),(84891,6169),(84892,6169),(84893,6169),(84894,6170),(84895,6170),(84896,6170),(84897,6171),(84898,6171),(84899,6171),(84900,6172),(84901,6172),(84902,6172),(84903,6173),(84904,6173),(84905,6173),(84906,6174),(84907,6174),(84908,6174),(84909,6175),(84910,6175),(84911,6175),(84912,6176),(84913,6176),(84914,6176),(84915,6177),(84916,6177),(84917,6177),(84918,6178),(84919,6178),(84920,6178),(84921,6179),(84922,6179),(84923,6179),(84924,6180),(84925,6180),(84926,6180),(84927,6181),(84928,6181),(84929,6181),(84930,6182),(84931,6182),(84932,6182),(84933,6183),(84934,6183),(84935,6183),(84936,6184),(84937,6184),(84938,6184),(84939,6185),(84940,6185),(84941,6185),(84942,6186),(84943,6186),(84944,6186),(84945,6187),(84946,6187),(84947,6187),(84948,6188),(84949,6188),(84950,6188),(84951,6189),(84952,6189),(84953,6189),(84954,6190),(84955,6190),(84956,6190),(84957,6191),(84958,6191),(84959,6191),(84960,6192),(84961,6192),(84962,6192),(84963,6193),(84964,6193),(84965,6193),(84966,6194),(84967,6194),(84968,6194),(84969,6195),(84970,6195),(84971,6195),(84972,6196),(84973,6196),(84974,6196),(84975,6197),(84976,6197),(84977,6197),(84978,6198),(84979,6198),(84980,6198),(84981,6199),(84982,6199),(84983,6199),(84984,6200),(84985,6200),(84986,6200),(84987,6201),(84988,6201),(84989,6201),(84990,6202),(84991,6202),(84992,6202),(84993,6203),(84994,6203),(84995,6203),(84996,6204),(84997,6204),(84998,6204),(84999,6205),(85000,6205),(85001,6205),(85002,6206),(85003,6206),(85004,6206),(85005,6207),(85006,6207),(85007,6207),(85008,6208),(85009,6208),(85010,6208),(85011,6209),(85012,6209),(85013,6209),(85014,6210),(85015,6210),(85016,6210),(85017,6211),(85018,6211),(85019,6211),(85020,6212),(85021,6212),(85022,6212),(85023,6213),(85024,6213),(85025,6213),(85026,6214),(85027,6214),(85028,6214),(85029,6215),(85030,6215),(85031,6215),(85032,6216),(85033,6216),(85034,6216),(85035,6217),(85036,6217),(85037,6217),(85038,6218),(85039,6218),(85040,6218),(85041,6219),(85042,6219),(85043,6219),(85044,6220),(85045,6220),(85046,6220),(85047,6221),(85048,6221),(85049,6221),(85050,6222),(85051,6222),(85052,6222),(85053,6223),(85054,6223),(85055,6223),(85056,6224),(85057,6224),(85058,6224),(85059,6225),(85060,6225),(85061,6225),(85062,6226),(85063,6226),(85064,6226),(85065,6227),(85066,6227),(85067,6227),(85068,6228),(85069,6228),(85070,6228),(85071,6229),(85072,6229),(85073,6229),(85074,6230),(85075,6230),(85076,6230),(85077,6231),(85078,6231),(85079,6231),(85080,6232),(85081,6232),(85082,6232),(85083,6233),(85084,6233),(85085,6233),(85086,6234),(85087,6234),(85088,6234),(85089,6135),(85090,6135),(85091,6135),(85092,6135),(85093,6135),(85094,6135),(85095,6135),(85096,6135),(85097,6135),(85098,6135),(85099,6135),(85100,6135),(85101,6135),(85102,6135),(85103,6136),(85104,6136),(85105,6136),(85106,6136),(85107,6136),(85108,6136),(85109,6136),(85110,6136),(85111,6136),(85112,6136),(85113,6137),(85114,6137),(85115,6137),(85116,6137),(85117,6137),(85118,6137),(85119,6137),(85120,6137),(85121,6137),(85122,6137),(85123,6138),(85124,6138),(85125,6138),(85126,6138),(85127,6138),(85128,6138),(85129,6138),(85130,6138),(85131,6138),(85132,6138),(85133,6139),(85134,6139),(85135,6139),(85136,6139),(85137,6139),(85138,6139),(85139,6139),(85140,6139),(85141,6139),(85142,6139),(85143,6140),(85144,6140),(85145,6140),(85146,6140),(85147,6140),(85148,6140),(85149,6140),(85150,6140),(85151,6140),(85152,6140),(85153,6141),(85154,6141),(85155,6141),(85156,6141),(85157,6141),(85158,6141),(85159,6141),(85160,6141),(85161,6141),(85162,6141),(85163,6142),(85164,6142),(85165,6142),(85166,6142),(85167,6142),(85168,6142),(85169,6142),(85170,6142),(85171,6142),(85172,6142),(85173,6143),(85174,6143),(85175,6143),(85176,6143),(85177,6143),(85178,6143),(85179,6143),(85180,6143),(85181,6143),(85182,6143),(85183,6144),(85184,6144),(85185,6144),(85186,6144),(85187,6144),(85188,6144),(85189,6144),(85190,6144),(85191,6144),(85192,6144),(85193,6145),(85194,6145),(85195,6145),(85196,6145),(85197,6145),(85198,6145),(85199,6145),(85200,6145),(85201,6145),(85202,6145),(85203,6146),(85204,6146),(85205,6146),(85206,6146),(85207,6146),(85208,6146),(85209,6146),(85210,6146),(85211,6146),(85212,6146),(85213,6147),(85214,6147),(85215,6147),(85216,6147),(85217,6147),(85218,6147),(85219,6147),(85220,6147),(85221,6147),(85222,6147),(85223,6148),(85224,6148),(85225,6148),(85226,6148),(85227,6148),(85228,6148),(85229,6148),(85230,6148),(85231,6148),(85232,6148),(85233,6149),(85234,6149),(85235,6149),(85236,6149),(85237,6149),(85238,6149),(85239,6149),(85240,6149),(85241,6149),(85242,6149),(85243,6150),(85244,6150),(85245,6150),(85246,6150),(85247,6150),(85248,6150),(85249,6150),(85250,6150),(85251,6150),(85252,6150),(85253,6151),(85254,6151),(85255,6151),(85256,6151),(85257,6151),(85258,6151),(85259,6151),(85260,6151),(85261,6151),(85262,6151),(85263,6152),(85264,6152),(85265,6152),(85266,6152),(85267,6152),(85268,6152),(85269,6152),(85270,6152),(85271,6152),(85272,6152),(85273,6153),(85274,6153),(85275,6153),(85276,6153),(85277,6153),(85278,6153),(85279,6153),(85280,6153),(85281,6153),(85282,6153),(85283,6154),(85284,6154),(85285,6154),(85286,6154),(85287,6154),(85288,6154),(85289,6154),(85290,6154),(85291,6154),(85292,6154),(85293,6155),(85294,6155),(85295,6155),(85296,6155),(85297,6155),(85298,6155),(85299,6155),(85300,6155),(85301,6155),(85302,6155),(85303,6156),(85304,6156),(85305,6156),(85306,6156),(85307,6156),(85308,6156),(85309,6156),(85310,6156),(85311,6156),(85312,6156),(85313,6157),(85314,6157),(85315,6157),(85316,6157),(85317,6157),(85318,6157),(85319,6157),(85320,6157),(85321,6157),(85322,6157),(85323,6158),(85324,6158),(85325,6158),(85326,6158),(85327,6158),(85328,6158),(85329,6158),(85330,6158),(85331,6158),(85332,6158),(85333,6159),(85334,6159),(85335,6159),(85336,6159),(85337,6159),(85338,6159),(85339,6159),(85340,6159),(85341,6159),(85342,6159),(85343,6160),(85344,6160),(85345,6160),(85346,6160),(85347,6160),(85348,6160),(85349,6160),(85350,6160),(85351,6160),(85352,6160),(85353,6161),(85354,6161),(85355,6161),(85356,6161),(85357,6161),(85358,6161),(85359,6161),(85360,6161),(85361,6161),(85362,6161),(85363,6162),(85364,6162),(85365,6162),(85366,6162),(85367,6162),(85368,6162),(85369,6162),(85370,6162),(85371,6162),(85372,6162),(85373,6163),(85374,6163),(85375,6163),(85376,6163),(85377,6163),(85378,6163),(85379,6163),(85380,6163),(85381,6163),(85382,6163),(85383,6164),(85384,6164),(85385,6164),(85386,6164),(85387,6164),(85388,6164),(85389,6164),(85390,6164),(85391,6164),(85392,6164),(85393,6164),(85394,6164),(85395,6164),(85396,6164),(85397,6165),(85398,6165),(85399,6165),(85400,6165),(85401,6165),(85402,6165),(85403,6165),(85404,6165),(85405,6165),(85406,6165),(85407,6166),(85408,6166),(85409,6166),(85410,6166),(85411,6166),(85412,6166),(85413,6166),(85414,6166),(85415,6166),(85416,6166),(85417,6167),(85418,6167),(85419,6167),(85420,6167),(85421,6167),(85422,6167),(85423,6167),(85424,6167),(85425,6168),(85426,6168),(85427,6168),(85428,6168),(85429,6168),(85430,6168),(85431,6168),(85432,6168),(85433,6169),(85434,6169),(85435,6169),(85436,6169),(85437,6169),(85438,6169),(85439,6169),(85440,6169),(85441,6169),(85442,6169),(85443,6170),(85444,6170),(85445,6170),(85446,6170),(85447,6170),(85448,6170),(85449,6170),(85450,6170),(85451,6170),(85452,6170),(85453,6170),(85454,6170),(85455,6170),(85456,6170),(85457,6171),(85458,6171),(85459,6171),(85460,6171),(85461,6171),(85462,6171),(85463,6171),(85464,6171),(85465,6171),(85466,6171),(85467,6172),(85468,6172),(85469,6172),(85470,6172),(85471,6172),(85472,6172),(85473,6172),(85474,6172),(85475,6172),(85476,6172),(85477,6173),(85478,6173),(85479,6173),(85480,6173),(85481,6173),(85482,6173),(85483,6173),(85484,6173),(85485,6173),(85486,6173),(85487,6174),(85488,6174),(85489,6174),(85490,6174),(85491,6174),(85492,6174),(85493,6174),(85494,6174),(85495,6174),(85496,6174),(85497,6174),(85498,6174),(85499,6174),(85500,6174),(85501,6175),(85502,6175),(85503,6175),(85504,6175),(85505,6175),(85506,6175),(85507,6175),(85508,6175),(85509,6175),(85510,6175),(85511,6176),(85512,6176),(85513,6176),(85514,6176),(85515,6176),(85516,6176),(85517,6176),(85518,6176),(85519,6176),(85520,6176),(85521,6177),(85522,6177),(85523,6177),(85524,6177),(85525,6177),(85526,6177),(85527,6177),(85528,6177),(85529,6177),(85530,6177),(85531,6177),(85532,6177),(85533,6177),(85534,6177),(85535,6178),(85536,6178),(85537,6178),(85538,6178),(85539,6178),(85540,6178),(85541,6178),(85542,6178),(85543,6178),(85544,6178),(85545,6179),(85546,6179),(85547,6179),(85548,6179),(85549,6179),(85550,6179),(85551,6179),(85552,6179),(85553,6179),(85554,6179),(85555,6180),(85556,6180),(85557,6180),(85558,6180),(85559,6180),(85560,6180),(85561,6180),(85562,6180),(85563,6180),(85564,6180),(85565,6180),(85566,6180),(85567,6180),(85568,6180),(85569,6181),(85570,6181),(85571,6181),(85572,6181),(85573,6181),(85574,6181),(85575,6181),(85576,6181),(85577,6181),(85578,6181),(85579,6182),(85580,6182),(85581,6182),(85582,6182),(85583,6182),(85584,6182),(85585,6182),(85586,6182),(85587,6182),(85588,6182),(85589,6183),(85590,6183),(85591,6183),(85592,6183),(85593,6183),(85594,6183),(85595,6183),(85596,6183),(85597,6183),(85598,6183),(85599,6184),(85600,6184),(85601,6184),(85602,6184),(85603,6184),(85604,6184),(85605,6184),(85606,6184),(85607,6184),(85608,6184),(85609,6185),(85610,6185),(85611,6185),(85612,6185),(85613,6185),(85614,6185),(85615,6185),(85616,6185),(85617,6185),(85618,6185),(85619,6186),(85620,6186),(85621,6186),(85622,6186),(85623,6186),(85624,6186),(85625,6186),(85626,6186),(85627,6186),(85628,6186),(85629,6187),(85630,6187),(85631,6187),(85632,6187),(85633,6187),(85634,6187),(85635,6187),(85636,6187),(85637,6187),(85638,6187),(85639,6187),(85640,6187),(85641,6187),(85642,6187),(85643,6188),(85644,6188),(85645,6188),(85646,6188),(85647,6188),(85648,6188),(85649,6188),(85650,6188),(85651,6188),(85652,6188),(85653,6188),(85654,6188),(85655,6188),(85656,6188),(85657,6189),(85658,6189),(85659,6189),(85660,6189),(85661,6189),(85662,6189),(85663,6189),(85664,6189),(85665,6189),(85666,6189),(85667,6190),(85668,6190),(85669,6190),(85670,6190),(85671,6190),(85672,6190),(85673,6190),(85674,6190),(85675,6190),(85676,6190),(85677,6191),(85678,6191),(85679,6191),(85680,6191),(85681,6191),(85682,6191),(85683,6191),(85684,6191),(85685,6191),(85686,6191),(85687,6192),(85688,6192),(85689,6192),(85690,6192),(85691,6192),(85692,6192),(85693,6192),(85694,6192),(85695,6192),(85696,6192),(85697,6193),(85698,6193),(85699,6193),(85700,6193),(85701,6193),(85702,6193),(85703,6193),(85704,6193),(85705,6193),(85706,6193),(85707,6194),(85708,6194),(85709,6194),(85710,6194),(85711,6194),(85712,6194),(85713,6194),(85714,6194),(85715,6194),(85716,6194),(85717,6195),(85718,6195),(85719,6195),(85720,6195),(85721,6195),(85722,6195),(85723,6195),(85724,6195),(85725,6195),(85726,6195),(85727,6196),(85728,6196),(85729,6196),(85730,6196),(85731,6196),(85732,6196),(85733,6196),(85734,6196),(85735,6196),(85736,6196),(85737,6197),(85738,6197),(85739,6197),(85740,6197),(85741,6197),(85742,6197),(85743,6197),(85744,6197),(85745,6197),(85746,6197),(85747,6198),(85748,6198),(85749,6198),(85750,6198),(85751,6198),(85752,6198),(85753,6198),(85754,6198),(85755,6198),(85756,6198),(85757,6199),(85758,6199),(85759,6199),(85760,6199),(85761,6199),(85762,6199),(85763,6199),(85764,6199),(85765,6199),(85766,6199),(85767,6199),(85768,6199),(85769,6199),(85770,6199),(85771,6200),(85772,6200),(85773,6200),(85774,6200),(85775,6200),(85776,6200),(85777,6200),(85778,6200),(85779,6200),(85780,6200),(85781,6201),(85782,6201),(85783,6201),(85784,6201),(85785,6201),(85786,6201),(85787,6201),(85788,6201),(85789,6201),(85790,6201),(85791,6202),(85792,6202),(85793,6202),(85794,6202),(85795,6202),(85796,6202),(85797,6202),(85798,6202),(85799,6202),(85800,6202),(85801,6203),(85802,6203),(85803,6203),(85804,6203),(85805,6203),(85806,6203),(85807,6203),(85808,6203),(85809,6203),(85810,6203),(85811,6204),(85812,6204),(85813,6204),(85814,6204),(85815,6204),(85816,6204),(85817,6204),(85818,6204),(85819,6204),(85820,6204),(85821,6205),(85822,6205),(85823,6205),(85824,6205),(85825,6205),(85826,6205),(85827,6205),(85828,6205),(85829,6205),(85830,6205),(85831,6206),(85832,6206),(85833,6206),(85834,6206),(85835,6206),(85836,6206),(85837,6206),(85838,6206),(85839,6206),(85840,6206),(85841,6206),(85842,6206),(85843,6206),(85844,6206),(85845,6207),(85846,6207),(85847,6207),(85848,6207),(85849,6207),(85850,6207),(85851,6207),(85852,6207),(85853,6207),(85854,6207),(85855,6207),(85856,6207),(85857,6207),(85858,6207),(85859,6208),(85860,6208),(85861,6208),(85862,6208),(85863,6208),(85864,6208),(85865,6208),(85866,6208),(85867,6208),(85868,6208),(85869,6208),(85870,6208),(85871,6209),(85872,6209),(85873,6209),(85874,6209),(85875,6209),(85876,6209),(85877,6209),(85878,6209),(85879,6209),(85880,6209),(85881,6209),(85882,6209),(85883,6210),(85884,6210),(85885,6210),(85886,6210),(85887,6210),(85888,6210),(85889,6210),(85890,6210),(85891,6210),(85892,6210),(85893,6211),(85894,6211),(85895,6211),(85896,6211),(85897,6211),(85898,6211),(85899,6211),(85900,6211),(85901,6211),(85902,6211),(85903,6212),(85904,6212),(85905,6212),(85906,6212),(85907,6212),(85908,6212),(85909,6212),(85910,6212),(85911,6212),(85912,6212),(85913,6213),(85914,6213),(85915,6213),(85916,6213),(85917,6213),(85918,6213),(85919,6213),(85920,6213),(85921,6213),(85922,6213),(85923,6214),(85924,6214),(85925,6214),(85926,6214),(85927,6214),(85928,6214),(85929,6214),(85930,6214),(85931,6214),(85932,6214),(85933,6215),(85934,6215),(85935,6215),(85936,6215),(85937,6215),(85938,6215),(85939,6215),(85940,6215),(85941,6215),(85942,6215),(85943,6216),(85944,6216),(85945,6216),(85946,6216),(85947,6216),(85948,6216),(85949,6216),(85950,6216),(85951,6216),(85952,6216),(85953,6217),(85954,6217),(85955,6217),(85956,6217),(85957,6217),(85958,6217),(85959,6217),(85960,6217),(85961,6217),(85962,6217),(85963,6218),(85964,6218),(85965,6218),(85966,6218),(85967,6218),(85968,6218),(85969,6218),(85970,6218),(85971,6218),(85972,6218),(85973,6219),(85974,6219),(85975,6219),(85976,6219),(85977,6219),(85978,6219),(85979,6219),(85980,6219),(85981,6219),(85982,6219),(85983,6220),(85984,6220),(85985,6220),(85986,6220),(85987,6220),(85988,6220),(85989,6220),(85990,6220),(85991,6220),(85992,6220),(85993,6220),(85994,6220),(85995,6220),(85996,6220),(85997,6221),(85998,6221),(85999,6221),(86000,6221),(86001,6221),(86002,6221),(86003,6221),(86004,6221),(86005,6221),(86006,6221),(86007,6221),(86008,6221),(86009,6221),(86010,6221),(86011,6222),(86012,6222),(86013,6222),(86014,6222),(86015,6222),(86016,6222),(86017,6222),(86018,6222),(86019,6222),(86020,6222),(86021,6222),(86022,6222),(86023,6222),(86024,6222),(86025,6223),(86026,6223),(86027,6223),(86028,6223),(86029,6223),(86030,6223),(86031,6223),(86032,6223),(86033,6223),(86034,6223),(86035,6224),(86036,6224),(86037,6224),(86038,6224),(86039,6224),(86040,6224),(86041,6224),(86042,6224),(86043,6224),(86044,6224),(86045,6225),(86046,6225),(86047,6225),(86048,6225),(86049,6225),(86050,6225),(86051,6225),(86052,6225),(86053,6225),(86054,6225),(86055,6226),(86056,6226),(86057,6226),(86058,6226),(86059,6226),(86060,6226),(86061,6226),(86062,6226),(86063,6226),(86064,6226),(86065,6227),(86066,6227),(86067,6227),(86068,6227),(86069,6227),(86070,6227),(86071,6227),(86072,6227),(86073,6227),(86074,6227),(86075,6228),(86076,6228),(86077,6228),(86078,6228),(86079,6228),(86080,6228),(86081,6228),(86082,6228),(86083,6228),(86084,6228),(86085,6229),(86086,6229),(86087,6229),(86088,6229),(86089,6229),(86090,6229),(86091,6229),(86092,6229),(86093,6229),(86094,6229),(86095,6230),(86096,6230),(86097,6230),(86098,6230),(86099,6230),(86100,6230),(86101,6230),(86102,6230),(86103,6230),(86104,6230),(86105,6231),(86106,6231),(86107,6231),(86108,6231),(86109,6232),(86110,6232),(86111,6232),(86112,6232),(86113,6232),(86114,6232),(86115,6232),(86116,6232),(86117,6232),(86118,6232),(86119,6233),(86120,6233),(86121,6233),(86122,6233),(86123,6233),(86124,6233),(86125,6233),(86126,6233),(86127,6233),(86128,6233),(86129,6233),(86130,6233),(86131,6234),(86132,6234),(86133,6234),(86134,6234),(86135,6234),(86136,6234),(86137,6234),(86138,6234),(86139,6234),(86140,6234),(86141,6135),(86142,6135),(86143,6135),(86144,6135),(86145,6135),(86146,6136),(86147,6136),(86148,6136),(86149,6136),(86150,6136),(86151,6137),(86152,6137),(86153,6137),(86154,6137),(86155,6137),(86156,6138),(86157,6138),(86158,6138),(86159,6138),(86160,6138),(86161,6139),(86162,6139),(86163,6139),(86164,6139),(86165,6139),(86166,6140),(86167,6140),(86168,6140),(86169,6140),(86170,6140),(86171,6141),(86172,6141),(86173,6141),(86174,6141),(86175,6141),(86176,6142),(86177,6142),(86178,6142),(86179,6142),(86180,6142),(86181,6143),(86182,6143),(86183,6143),(86184,6143),(86185,6143),(86186,6144),(86187,6144),(86188,6144),(86189,6144),(86190,6144),(86191,6145),(86192,6145),(86193,6145),(86194,6145),(86195,6145),(86196,6146),(86197,6146),(86198,6146),(86199,6146),(86200,6146),(86201,6147),(86202,6147),(86203,6147),(86204,6147),(86205,6147),(86206,6148),(86207,6148),(86208,6148),(86209,6148),(86210,6148),(86211,6149),(86212,6149),(86213,6149),(86214,6149),(86215,6149),(86216,6150),(86217,6150),(86218,6150),(86219,6150),(86220,6150),(86221,6151),(86222,6151),(86223,6151),(86224,6151),(86225,6151),(86226,6152),(86227,6152),(86228,6152),(86229,6152),(86230,6152),(86231,6153),(86232,6153),(86233,6153),(86234,6153),(86235,6153),(86236,6154),(86237,6154),(86238,6154),(86239,6154),(86240,6154),(86241,6155),(86242,6155),(86243,6155),(86244,6155),(86245,6155),(86246,6156),(86247,6156),(86248,6156),(86249,6156),(86250,6156),(86251,6157),(86252,6157),(86253,6157),(86254,6157),(86255,6157),(86256,6158),(86257,6158),(86258,6158),(86259,6158),(86260,6158),(86261,6159),(86262,6159),(86263,6159),(86264,6159),(86265,6159),(86266,6160),(86267,6160),(86268,6160),(86269,6160),(86270,6160),(86271,6161),(86272,6161),(86273,6161),(86274,6161),(86275,6161),(86276,6162),(86277,6162),(86278,6162),(86279,6162),(86280,6162),(86281,6163),(86282,6163),(86283,6163),(86284,6163),(86285,6163),(86286,6164),(86287,6164),(86288,6164),(86289,6164),(86290,6164),(86291,6165),(86292,6165),(86293,6165),(86294,6165),(86295,6165),(86296,6166),(86297,6166),(86298,6166),(86299,6166),(86300,6166),(86301,6167),(86302,6167),(86303,6167),(86304,6167),(86305,6167),(86306,6168),(86307,6168),(86308,6168),(86309,6168),(86310,6168),(86311,6169),(86312,6169),(86313,6169),(86314,6169),(86315,6169),(86316,6170),(86317,6170),(86318,6170),(86319,6170),(86320,6170),(86321,6171),(86322,6171),(86323,6171),(86324,6171),(86325,6171),(86326,6172),(86327,6172),(86328,6172),(86329,6172),(86330,6172),(86331,6173),(86332,6173),(86333,6173),(86334,6173),(86335,6173),(86336,6174),(86337,6174),(86338,6174),(86339,6174),(86340,6174),(86341,6175),(86342,6175),(86343,6175),(86344,6175),(86345,6175),(86346,6176),(86347,6176),(86348,6176),(86349,6176),(86350,6176),(86351,6177),(86352,6177),(86353,6177),(86354,6177),(86355,6177),(86356,6178),(86357,6178),(86358,6178),(86359,6178),(86360,6178),(86361,6179),(86362,6179),(86363,6179),(86364,6179),(86365,6179),(86366,6180),(86367,6180),(86368,6180),(86369,6180),(86370,6180),(86371,6181),(86372,6181),(86373,6181),(86374,6181),(86375,6181),(86376,6182),(86377,6182),(86378,6182),(86379,6182),(86380,6182),(86381,6183),(86382,6183),(86383,6183),(86384,6183),(86385,6183),(86386,6184),(86387,6184),(86388,6184),(86389,6184),(86390,6184),(86391,6185),(86392,6185),(86393,6185),(86394,6185),(86395,6185),(86396,6186),(86397,6186),(86398,6186),(86399,6186),(86400,6186),(86401,6187),(86402,6187),(86403,6187),(86404,6187),(86405,6187),(86406,6188),(86407,6188),(86408,6188),(86409,6188),(86410,6188),(86411,6189),(86412,6189),(86413,6189),(86414,6189),(86415,6189),(86416,6190),(86417,6190),(86418,6190),(86419,6190),(86420,6190),(86421,6191),(86422,6191),(86423,6191),(86424,6191),(86425,6191),(86426,6192),(86427,6192),(86428,6192),(86429,6192),(86430,6192),(86431,6193),(86432,6193),(86433,6193),(86434,6193),(86435,6193),(86436,6194),(86437,6194),(86438,6194),(86439,6194),(86440,6194),(86441,6195),(86442,6195),(86443,6195),(86444,6195),(86445,6195),(86446,6196),(86447,6196),(86448,6196),(86449,6196),(86450,6196),(86451,6197),(86452,6197),(86453,6197),(86454,6197),(86455,6197),(86456,6198),(86457,6198),(86458,6198),(86459,6198),(86460,6198),(86461,6199),(86462,6199),(86463,6199),(86464,6199),(86465,6199),(86466,6200),(86467,6200),(86468,6200),(86469,6200),(86470,6200),(86471,6201),(86472,6201),(86473,6201),(86474,6201),(86475,6201),(86476,6202),(86477,6202),(86478,6202),(86479,6202),(86480,6202),(86481,6203),(86482,6203),(86483,6203),(86484,6203),(86485,6203),(86486,6204),(86487,6204),(86488,6204),(86489,6204),(86490,6204),(86491,6205),(86492,6205),(86493,6205),(86494,6205),(86495,6205),(86496,6206),(86497,6206),(86498,6206),(86499,6206),(86500,6206),(86501,6207),(86502,6207),(86503,6207),(86504,6207),(86505,6207),(86506,6208),(86507,6208),(86508,6208),(86509,6208),(86510,6208),(86511,6209),(86512,6209),(86513,6209),(86514,6209),(86515,6209),(86516,6210),(86517,6210),(86518,6210),(86519,6210),(86520,6210),(86521,6211),(86522,6211),(86523,6211),(86524,6211),(86525,6211),(86526,6212),(86527,6212),(86528,6212),(86529,6212),(86530,6212),(86531,6213),(86532,6213),(86533,6213),(86534,6213),(86535,6213),(86536,6214),(86537,6214),(86538,6214),(86539,6214),(86540,6214),(86541,6215),(86542,6215),(86543,6215),(86544,6215),(86545,6215),(86546,6216),(86547,6216),(86548,6216),(86549,6216),(86550,6216),(86551,6217),(86552,6217),(86553,6217),(86554,6217),(86555,6217),(86556,6218),(86557,6218),(86558,6218),(86559,6218),(86560,6218),(86561,6219),(86562,6219),(86563,6219),(86564,6219),(86565,6219),(86566,6220),(86567,6220),(86568,6220),(86569,6220),(86570,6220),(86571,6221),(86572,6221),(86573,6221),(86574,6221),(86575,6221),(86576,6222),(86577,6222),(86578,6222),(86579,6222),(86580,6222),(86581,6223),(86582,6223),(86583,6223),(86584,6223),(86585,6223),(86586,6224),(86587,6224),(86588,6224),(86589,6224),(86590,6224),(86591,6225),(86592,6225),(86593,6225),(86594,6225),(86595,6225),(86596,6226),(86597,6226),(86598,6226),(86599,6226),(86600,6226),(86601,6227),(86602,6227),(86603,6227),(86604,6227),(86605,6227),(86606,6228),(86607,6228),(86608,6228),(86609,6228),(86610,6228),(86611,6229),(86612,6229),(86613,6229),(86614,6229),(86615,6229),(86616,6230),(86617,6230),(86618,6230),(86619,6230),(86620,6230),(86621,6231),(86622,6231),(86623,6231),(86624,6231),(86625,6231),(86626,6232),(86627,6232),(86628,6232),(86629,6232),(86630,6232),(86631,6233),(86632,6233),(86633,6233),(86634,6233),(86635,6233),(86636,6234),(86637,6234),(86638,6234),(86639,6234),(86640,6234),(86641,6235),(86642,6235),(86643,6235),(86644,6236),(86645,6236),(86646,6236),(86647,6237),(86648,6237),(86649,6237),(86650,6238),(86651,6238),(86652,6238),(86653,6239),(86654,6239),(86655,6239),(86656,6240),(86657,6240),(86658,6240),(86659,6241),(86660,6241),(86661,6241),(86662,6242),(86663,6242),(86664,6242),(86665,6243),(86666,6243),(86667,6243),(86668,6244),(86669,6244),(86670,6244),(86671,6245),(86672,6245),(86673,6245),(86674,6246),(86675,6246),(86676,6246),(86677,6247),(86678,6247),(86679,6247),(86680,6248),(86681,6248),(86682,6248),(86683,6249),(86684,6249),(86685,6249),(86686,6250),(86687,6250),(86688,6250),(86689,6251),(86690,6251),(86691,6251),(86692,6252),(86693,6252),(86694,6252),(86695,6253),(86696,6253),(86697,6253),(86698,6254),(86699,6254),(86700,6254),(86701,6255),(86702,6255),(86703,6255),(86704,6256),(86705,6256),(86706,6256),(86707,6257),(86708,6257),(86709,6257),(86710,6258),(86711,6258),(86712,6258),(86713,6259),(86714,6259),(86715,6259),(86716,6260),(86717,6260),(86718,6260),(86719,6261),(86720,6261),(86721,6261),(86722,6262),(86723,6262),(86724,6262),(86725,6263),(86726,6263),(86727,6263),(86728,6264),(86729,6264),(86730,6264),(86731,6265),(86732,6265),(86733,6265),(86734,6266),(86735,6266),(86736,6266),(86737,6267),(86738,6267),(86739,6267),(86740,6268),(86741,6268),(86742,6268),(86743,6269),(86744,6269),(86745,6269),(86746,6270),(86747,6270),(86748,6270),(86749,6271),(86750,6271),(86751,6271),(86752,6272),(86753,6272),(86754,6272),(86755,6273),(86756,6273),(86757,6273),(86758,6274),(86759,6274),(86760,6274),(86761,6275),(86762,6275),(86763,6275),(86764,6276),(86765,6276),(86766,6276),(86767,6277),(86768,6277),(86769,6277),(86770,6278),(86771,6278),(86772,6278),(86773,6279),(86774,6279),(86775,6279),(86776,6280),(86777,6280),(86778,6280),(86779,6281),(86780,6281),(86781,6281),(86782,6282),(86783,6282),(86784,6282),(86785,6283),(86786,6283),(86787,6283),(86788,6284),(86789,6284),(86790,6284),(86791,6285),(86792,6285),(86793,6285),(86794,6286),(86795,6286),(86796,6286),(86797,6287),(86798,6287),(86799,6287),(86800,6288),(86801,6288),(86802,6288),(86803,6289),(86804,6289),(86805,6289),(86806,6290),(86807,6290),(86808,6290),(86809,6291),(86810,6291),(86811,6291),(86812,6292),(86813,6292),(86814,6292),(86815,6293),(86816,6293),(86817,6293),(86818,6294),(86819,6294),(86820,6294),(86821,6295),(86822,6295),(86823,6295),(86824,6296),(86825,6296),(86826,6296),(86827,6297),(86828,6297),(86829,6297),(86830,6298),(86831,6298),(86832,6298),(86833,6299),(86834,6299),(86835,6299),(86836,6300),(86837,6300),(86838,6300),(86839,6301),(86840,6301),(86841,6301),(86842,6302),(86843,6302),(86844,6302),(86845,6303),(86846,6303),(86847,6303),(86848,6304),(86849,6304),(86850,6304),(86851,6305),(86852,6305),(86853,6305),(86854,6306),(86855,6306),(86856,6306),(86857,6307),(86858,6307),(86859,6307),(86860,6308),(86861,6308),(86862,6308),(86863,6309),(86864,6309),(86865,6309),(86866,6310),(86867,6310),(86868,6310),(86869,6311),(86870,6311),(86871,6311),(86872,6312),(86873,6312),(86874,6312),(86875,6313),(86876,6313),(86877,6313),(86878,6314),(86879,6314),(86880,6314),(86881,6315),(86882,6315),(86883,6315),(86884,6316),(86885,6316),(86886,6316),(86887,6317),(86888,6317),(86889,6317),(86890,6318),(86891,6318),(86892,6318),(86893,6319),(86894,6319),(86895,6319),(86896,6320),(86897,6320),(86898,6320),(86899,6321),(86900,6321),(86901,6321),(86902,6322),(86903,6322),(86904,6322),(86905,6323),(86906,6323),(86907,6323),(86908,6324),(86909,6324),(86910,6324),(86911,6325),(86912,6325),(86913,6325),(86914,6326),(86915,6326),(86916,6326),(86917,6327),(86918,6327),(86919,6327),(86920,6328),(86921,6328),(86922,6328),(86923,6329),(86924,6329),(86925,6329),(86926,6330),(86927,6330),(86928,6330),(86929,6331),(86930,6331),(86931,6331),(86932,6332),(86933,6332),(86934,6332),(86935,6333),(86936,6333),(86937,6333),(86938,6334),(86939,6334),(86940,6334),(86941,6235),(86942,6235),(86943,6235),(86944,6235),(86945,6235),(86946,6235),(86947,6235),(86948,6235),(86949,6235),(86950,6235),(86951,6236),(86952,6236),(86953,6236),(86954,6236),(86955,6236),(86956,6236),(86957,6236),(86958,6236),(86959,6236),(86960,6236),(86961,6237),(86962,6237),(86963,6237),(86964,6237),(86965,6237),(86966,6237),(86967,6237),(86968,6237),(86969,6237),(86970,6237),(86971,6238),(86972,6238),(86973,6238),(86974,6238),(86975,6238),(86976,6238),(86977,6238),(86978,6238),(86979,6238),(86980,6238),(86981,6239),(86982,6239),(86983,6239),(86984,6239),(86985,6239),(86986,6239),(86987,6239),(86988,6239),(86989,6239),(86990,6239),(86991,6240),(86992,6240),(86993,6240),(86994,6240),(86995,6240),(86996,6240),(86997,6240),(86998,6240),(86999,6240),(87000,6240),(87001,6240),(87002,6240),(87003,6241),(87004,6241),(87005,6241),(87006,6241),(87007,6241),(87008,6241),(87009,6241),(87010,6241),(87011,6241),(87012,6241),(87013,6241),(87014,6241),(87015,6242),(87016,6242),(87017,6242),(87018,6242),(87019,6242),(87020,6242),(87021,6242),(87022,6242),(87023,6242),(87024,6242),(87025,6243),(87026,6243),(87027,6243),(87028,6243),(87029,6243),(87030,6243),(87031,6243),(87032,6243),(87033,6243),(87034,6243),(87035,6243),(87036,6243),(87037,6243),(87038,6243),(87039,6244),(87040,6244),(87041,6244),(87042,6244),(87043,6244),(87044,6244),(87045,6244),(87046,6244),(87047,6244),(87048,6244),(87049,6244),(87050,6244),(87051,6244),(87052,6244),(87053,6245),(87054,6245),(87055,6245),(87056,6245),(87057,6245),(87058,6245),(87059,6245),(87060,6245),(87061,6245),(87062,6245),(87063,6246),(87064,6246),(87065,6246),(87066,6246),(87067,6246),(87068,6246),(87069,6246),(87070,6246),(87071,6246),(87072,6246),(87073,6247),(87074,6247),(87075,6247),(87076,6247),(87077,6247),(87078,6247),(87079,6247),(87080,6247),(87081,6247),(87082,6247),(87083,6248),(87084,6248),(87085,6248),(87086,6248),(87087,6248),(87088,6248),(87089,6248),(87090,6248),(87091,6248),(87092,6248),(87093,6249),(87094,6249),(87095,6249),(87096,6249),(87097,6249),(87098,6249),(87099,6249),(87100,6249),(87101,6249),(87102,6249),(87103,6250),(87104,6250),(87105,6250),(87106,6250),(87107,6250),(87108,6250),(87109,6250),(87110,6250),(87111,6250),(87112,6250),(87113,6251),(87114,6251),(87115,6251),(87116,6251),(87117,6251),(87118,6251),(87119,6251),(87120,6251),(87121,6251),(87122,6251),(87123,6251),(87124,6251),(87125,6251),(87126,6251),(87127,6252),(87128,6252),(87129,6252),(87130,6252),(87131,6252),(87132,6252),(87133,6252),(87134,6252),(87135,6252),(87136,6252),(87137,6253),(87138,6253),(87139,6253),(87140,6253),(87141,6253),(87142,6253),(87143,6253),(87144,6253),(87145,6253),(87146,6253),(87147,6254),(87148,6254),(87149,6254),(87150,6254),(87151,6254),(87152,6254),(87153,6254),(87154,6254),(87155,6254),(87156,6254),(87157,6255),(87158,6255),(87159,6255),(87160,6255),(87161,6255),(87162,6255),(87163,6255),(87164,6255),(87165,6255),(87166,6255),(87167,6255),(87168,6255),(87169,6255),(87170,6255),(87171,6256),(87172,6256),(87173,6256),(87174,6256),(87175,6256),(87176,6256),(87177,6256),(87178,6256),(87179,6256),(87180,6256),(87181,6257),(87182,6257),(87183,6257),(87184,6257),(87185,6257),(87186,6257),(87187,6257),(87188,6257),(87189,6257),(87190,6257),(87191,6258),(87192,6258),(87193,6258),(87194,6258),(87195,6258),(87196,6258),(87197,6258),(87198,6258),(87199,6258),(87200,6258),(87201,6258),(87202,6258),(87203,6259),(87204,6259),(87205,6259),(87206,6259),(87207,6259),(87208,6259),(87209,6259),(87210,6259),(87211,6259),(87212,6259),(87213,6259),(87214,6259),(87215,6260),(87216,6260),(87217,6260),(87218,6260),(87219,6260),(87220,6260),(87221,6260),(87222,6260),(87223,6260),(87224,6260),(87225,6260),(87226,6260),(87227,6261),(87228,6261),(87229,6261),(87230,6261),(87231,6261),(87232,6261),(87233,6261),(87234,6261),(87235,6262),(87236,6262),(87237,6262),(87238,6262),(87239,6262),(87240,6262),(87241,6262),(87242,6262),(87243,6263),(87244,6263),(87245,6263),(87246,6263),(87247,6263),(87248,6263),(87249,6263),(87250,6263),(87251,6264),(87252,6264),(87253,6264),(87254,6264),(87255,6264),(87256,6264),(87257,6264),(87258,6264),(87259,6265),(87260,6265),(87261,6265),(87262,6265),(87263,6265),(87264,6265),(87265,6265),(87266,6265),(87267,6266),(87268,6266),(87269,6266),(87270,6266),(87271,6266),(87272,6266),(87273,6266),(87274,6266),(87275,6267),(87276,6267),(87277,6267),(87278,6267),(87279,6267),(87280,6267),(87281,6267),(87282,6267),(87283,6267),(87284,6267),(87285,6267),(87286,6267),(87287,6267),(87288,6267),(87289,6268),(87290,6268),(87291,6268),(87292,6268),(87293,6268),(87294,6268),(87295,6268),(87296,6268),(87297,6268),(87298,6268),(87299,6268),(87300,6268),(87301,6268),(87302,6268),(87303,6269),(87304,6269),(87305,6269),(87306,6269),(87307,6269),(87308,6269),(87309,6269),(87310,6269),(87311,6269),(87312,6269),(87313,6270),(87314,6270),(87315,6270),(87316,6270),(87317,6270),(87318,6270),(87319,6270),(87320,6270),(87321,6270),(87322,6270),(87323,6271),(87324,6271),(87325,6271),(87326,6271),(87327,6271),(87328,6271),(87329,6271),(87330,6271),(87331,6271),(87332,6271),(87333,6271),(87334,6271),(87335,6271),(87336,6271),(87337,6272),(87338,6272),(87339,6272),(87340,6272),(87341,6272),(87342,6272),(87343,6272),(87344,6272),(87345,6272),(87346,6272),(87347,6272),(87348,6272),(87349,6272),(87350,6272),(87351,6273),(87352,6273),(87353,6273),(87354,6273),(87355,6273),(87356,6273),(87357,6273),(87358,6273),(87359,6273),(87360,6273),(87361,6273),(87362,6273),(87363,6273),(87364,6273),(87365,6274),(87366,6274),(87367,6274),(87368,6274),(87369,6274),(87370,6274),(87371,6274),(87372,6274),(87373,6274),(87374,6274),(87375,6274),(87376,6274),(87377,6274),(87378,6274),(87379,6275),(87380,6275),(87381,6275),(87382,6275),(87383,6275),(87384,6275),(87385,6275),(87386,6275),(87387,6275),(87388,6275),(87389,6276),(87390,6276),(87391,6276),(87392,6276),(87393,6276),(87394,6276),(87395,6276),(87396,6276),(87397,6276),(87398,6276),(87399,6276),(87400,6276),(87401,6276),(87402,6276),(87403,6277),(87404,6277),(87405,6277),(87406,6277),(87407,6277),(87408,6277),(87409,6277),(87410,6277),(87411,6277),(87412,6277),(87413,6277),(87414,6277),(87415,6277),(87416,6277),(87417,6278),(87418,6278),(87419,6278),(87420,6278),(87421,6278),(87422,6278),(87423,6278),(87424,6278),(87425,6278),(87426,6278),(87427,6278),(87428,6278),(87429,6278),(87430,6278),(87431,6279),(87432,6279),(87433,6279),(87434,6279),(87435,6279),(87436,6279),(87437,6279),(87438,6279),(87439,6279),(87440,6279),(87441,6279),(87442,6279),(87443,6279),(87444,6279),(87445,6280),(87446,6280),(87447,6280),(87448,6280),(87449,6280),(87450,6280),(87451,6280),(87452,6280),(87453,6280),(87454,6280),(87455,6281),(87456,6281),(87457,6281),(87458,6281),(87459,6281),(87460,6281),(87461,6281),(87462,6281),(87463,6281),(87464,6281),(87465,6282),(87466,6282),(87467,6282),(87468,6282),(87469,6282),(87470,6282),(87471,6282),(87472,6282),(87473,6282),(87474,6282),(87475,6283),(87476,6283),(87477,6283),(87478,6283),(87479,6283),(87480,6283),(87481,6283),(87482,6283),(87483,6283),(87484,6283),(87485,6284),(87486,6284),(87487,6284),(87488,6284),(87489,6284),(87490,6284),(87491,6284),(87492,6284),(87493,6284),(87494,6284),(87495,6285),(87496,6285),(87497,6285),(87498,6285),(87499,6285),(87500,6285),(87501,6285),(87502,6285),(87503,6285),(87504,6285),(87505,6286),(87506,6286),(87507,6286),(87508,6286),(87509,6286),(87510,6286),(87511,6286),(87512,6286),(87513,6286),(87514,6286),(87515,6287),(87516,6287),(87517,6287),(87518,6287),(87519,6287),(87520,6287),(87521,6287),(87522,6287),(87523,6287),(87524,6287),(87525,6288),(87526,6288),(87527,6288),(87528,6288),(87529,6288),(87530,6288),(87531,6288),(87532,6288),(87533,6288),(87534,6288),(87535,6289),(87536,6289),(87537,6289),(87538,6289),(87539,6289),(87540,6289),(87541,6289),(87542,6289),(87543,6289),(87544,6289),(87545,6290),(87546,6290),(87547,6290),(87548,6290),(87549,6290),(87550,6290),(87551,6290),(87552,6290),(87553,6290),(87554,6290),(87555,6291),(87556,6291),(87557,6291),(87558,6291),(87559,6291),(87560,6291),(87561,6291),(87562,6291),(87563,6291),(87564,6291),(87565,6292),(87566,6292),(87567,6292),(87568,6292),(87569,6292),(87570,6292),(87571,6292),(87572,6292),(87573,6292),(87574,6292),(87575,6293),(87576,6293),(87577,6293),(87578,6293),(87579,6293),(87580,6293),(87581,6293),(87582,6293),(87583,6293),(87584,6293),(87585,6294),(87586,6294),(87587,6294),(87588,6294),(87589,6294),(87590,6294),(87591,6294),(87592,6294),(87593,6294),(87594,6294),(87595,6295),(87596,6295),(87597,6295),(87598,6295),(87599,6295),(87600,6295),(87601,6295),(87602,6295),(87603,6295),(87604,6295),(87605,6296),(87606,6296),(87607,6296),(87608,6296),(87609,6296),(87610,6296),(87611,6296),(87612,6296),(87613,6296),(87614,6296),(87615,6297),(87616,6297),(87617,6297),(87618,6297),(87619,6297),(87620,6297),(87621,6297),(87622,6297),(87623,6297),(87624,6297),(87625,6298),(87626,6298),(87627,6298),(87628,6298),(87629,6298),(87630,6298),(87631,6298),(87632,6298),(87633,6298),(87634,6298),(87635,6298),(87636,6298),(87637,6298),(87638,6298),(87639,6299),(87640,6299),(87641,6299),(87642,6299),(87643,6299),(87644,6299),(87645,6299),(87646,6299),(87647,6299),(87648,6299),(87649,6299),(87650,6299),(87651,6299),(87652,6299),(87653,6300),(87654,6300),(87655,6300),(87656,6300),(87657,6300),(87658,6300),(87659,6300),(87660,6300),(87661,6300),(87662,6300),(87663,6301),(87664,6301),(87665,6301),(87666,6301),(87667,6301),(87668,6301),(87669,6301),(87670,6301),(87671,6301),(87672,6301),(87673,6302),(87674,6302),(87675,6302),(87676,6302),(87677,6302),(87678,6302),(87679,6302),(87680,6302),(87681,6302),(87682,6302),(87683,6303),(87684,6303),(87685,6303),(87686,6303),(87687,6303),(87688,6303),(87689,6303),(87690,6303),(87691,6303),(87692,6303),(87693,6304),(87694,6304),(87695,6304),(87696,6304),(87697,6304),(87698,6304),(87699,6304),(87700,6304),(87701,6304),(87702,6304),(87703,6305),(87704,6305),(87705,6305),(87706,6305),(87707,6305),(87708,6305),(87709,6305),(87710,6305),(87711,6305),(87712,6305),(87713,6306),(87714,6306),(87715,6306),(87716,6306),(87717,6306),(87718,6306),(87719,6306),(87720,6306),(87721,6306),(87722,6306),(87723,6307),(87724,6307),(87725,6307),(87726,6307),(87727,6307),(87728,6307),(87729,6307),(87730,6307),(87731,6307),(87732,6307),(87733,6308),(87734,6308),(87735,6308),(87736,6308),(87737,6308),(87738,6308),(87739,6308),(87740,6308),(87741,6308),(87742,6308),(87743,6309),(87744,6309),(87745,6309),(87746,6309),(87747,6309),(87748,6309),(87749,6309),(87750,6309),(87751,6309),(87752,6309),(87753,6310),(87754,6310),(87755,6310),(87756,6310),(87757,6310),(87758,6310),(87759,6310),(87760,6310),(87761,6310),(87762,6310),(87763,6311),(87764,6311),(87765,6311),(87766,6311),(87767,6311),(87768,6311),(87769,6311),(87770,6311),(87771,6311),(87772,6311),(87773,6312),(87774,6312),(87775,6312),(87776,6312),(87777,6312),(87778,6312),(87779,6312),(87780,6312),(87781,6312),(87782,6312),(87783,6313),(87784,6313),(87785,6313),(87786,6313),(87787,6313),(87788,6313),(87789,6313),(87790,6313),(87791,6313),(87792,6313),(87793,6314),(87794,6314),(87795,6314),(87796,6314),(87797,6314),(87798,6314),(87799,6314),(87800,6314),(87801,6314),(87802,6314),(87803,6315),(87804,6315),(87805,6315),(87806,6315),(87807,6315),(87808,6315),(87809,6315),(87810,6315),(87811,6315),(87812,6315),(87813,6316),(87814,6316),(87815,6316),(87816,6316),(87817,6316),(87818,6316),(87819,6316),(87820,6316),(87821,6316),(87822,6316),(87823,6317),(87824,6317),(87825,6317),(87826,6317),(87827,6317),(87828,6317),(87829,6317),(87830,6317),(87831,6317),(87832,6317),(87833,6318),(87834,6318),(87835,6318),(87836,6318),(87837,6318),(87838,6318),(87839,6318),(87840,6318),(87841,6318),(87842,6318),(87843,6319),(87844,6319),(87845,6319),(87846,6319),(87847,6319),(87848,6319),(87849,6319),(87850,6319),(87851,6319),(87852,6319),(87853,6320),(87854,6320),(87855,6320),(87856,6320),(87857,6320),(87858,6320),(87859,6320),(87860,6320),(87861,6320),(87862,6320),(87863,6321),(87864,6321),(87865,6321),(87866,6321),(87867,6321),(87868,6321),(87869,6321),(87870,6321),(87871,6321),(87872,6321),(87873,6322),(87874,6322),(87875,6322),(87876,6322),(87877,6322),(87878,6322),(87879,6322),(87880,6322),(87881,6322),(87882,6322),(87883,6323),(87884,6323),(87885,6323),(87886,6323),(87887,6323),(87888,6323),(87889,6323),(87890,6323),(87891,6323),(87892,6323),(87893,6324),(87894,6324),(87895,6324),(87896,6324),(87897,6324),(87898,6324),(87899,6324),(87900,6324),(87901,6324),(87902,6324),(87903,6325),(87904,6325),(87905,6325),(87906,6325),(87907,6325),(87908,6325),(87909,6325),(87910,6325),(87911,6325),(87912,6325),(87913,6326),(87914,6326),(87915,6326),(87916,6326),(87917,6326),(87918,6326),(87919,6326),(87920,6326),(87921,6326),(87922,6326),(87923,6327),(87924,6327),(87925,6327),(87926,6327),(87927,6327),(87928,6327),(87929,6327),(87930,6327),(87931,6327),(87932,6327),(87933,6328),(87934,6328),(87935,6328),(87936,6328),(87937,6328),(87938,6328),(87939,6328),(87940,6328),(87941,6328),(87942,6328),(87943,6329),(87944,6329),(87945,6329),(87946,6329),(87947,6329),(87948,6329),(87949,6329),(87950,6329),(87951,6329),(87952,6329),(87953,6330),(87954,6330),(87955,6330),(87956,6330),(87957,6330),(87958,6330),(87959,6330),(87960,6330),(87961,6330),(87962,6330),(87963,6331),(87964,6331),(87965,6331),(87966,6331),(87967,6331),(87968,6331),(87969,6331),(87970,6331),(87971,6331),(87972,6331),(87973,6332),(87974,6332),(87975,6332),(87976,6332),(87977,6332),(87978,6332),(87979,6332),(87980,6332),(87981,6332),(87982,6332),(87983,6333),(87984,6333),(87985,6333),(87986,6333),(87987,6333),(87988,6333),(87989,6333),(87990,6333),(87991,6333),(87992,6333),(87993,6334),(87994,6334),(87995,6334),(87996,6334),(87997,6334),(87998,6334),(87999,6334),(88000,6334),(88001,6334),(88002,6334),(88003,6235),(88004,6235),(88005,6235),(88006,6235),(88007,6235),(88008,6236),(88009,6236),(88010,6236),(88011,6236),(88012,6236),(88013,6237),(88014,6237),(88015,6237),(88016,6237),(88017,6237),(88018,6238),(88019,6238),(88020,6238),(88021,6238),(88022,6238),(88023,6239),(88024,6239),(88025,6239),(88026,6239),(88027,6239),(88028,6240),(88029,6240),(88030,6240),(88031,6240),(88032,6240),(88033,6241),(88034,6241),(88035,6241),(88036,6241),(88037,6241),(88038,6242),(88039,6242),(88040,6242),(88041,6242),(88042,6242),(88043,6243),(88044,6243),(88045,6243),(88046,6243),(88047,6243),(88048,6244),(88049,6244),(88050,6244),(88051,6244),(88052,6244),(88053,6245),(88054,6245),(88055,6245),(88056,6245),(88057,6245),(88058,6246),(88059,6246),(88060,6246),(88061,6246),(88062,6246),(88063,6247),(88064,6247),(88065,6247),(88066,6247),(88067,6247),(88068,6248),(88069,6248),(88070,6248),(88071,6248),(88072,6248),(88073,6249),(88074,6249),(88075,6249),(88076,6249),(88077,6249),(88078,6250),(88079,6250),(88080,6250),(88081,6250),(88082,6250),(88083,6251),(88084,6251),(88085,6251),(88086,6251),(88087,6251),(88088,6252),(88089,6252),(88090,6252),(88091,6252),(88092,6252),(88093,6253),(88094,6253),(88095,6253),(88096,6253),(88097,6253),(88098,6254),(88099,6254),(88100,6254),(88101,6254),(88102,6254),(88103,6255),(88104,6255),(88105,6255),(88106,6255),(88107,6255),(88108,6256),(88109,6256),(88110,6256),(88111,6256),(88112,6256),(88113,6257),(88114,6257),(88115,6257),(88116,6257),(88117,6257),(88118,6258),(88119,6258),(88120,6258),(88121,6258),(88122,6258),(88123,6259),(88124,6259),(88125,6259),(88126,6259),(88127,6259),(88128,6260),(88129,6260),(88130,6260),(88131,6260),(88132,6260),(88133,6261),(88134,6261),(88135,6261),(88136,6261),(88137,6261),(88138,6262),(88139,6262),(88140,6262),(88141,6262),(88142,6262),(88143,6263),(88144,6263),(88145,6263),(88146,6263),(88147,6263),(88148,6264),(88149,6264),(88150,6264),(88151,6264),(88152,6264),(88153,6265),(88154,6265),(88155,6265),(88156,6265),(88157,6265),(88158,6266),(88159,6266),(88160,6266),(88161,6266),(88162,6266),(88163,6267),(88164,6267),(88165,6267),(88166,6267),(88167,6267),(88168,6268),(88169,6268),(88170,6268),(88171,6268),(88172,6268),(88173,6269),(88174,6269),(88175,6269),(88176,6269),(88177,6269),(88178,6270),(88179,6270),(88180,6270),(88181,6270),(88182,6270),(88183,6271),(88184,6271),(88185,6271),(88186,6271),(88187,6271),(88188,6272),(88189,6272),(88190,6272),(88191,6272),(88192,6272),(88193,6273),(88194,6273),(88195,6273),(88196,6273),(88197,6273),(88198,6274),(88199,6274),(88200,6274),(88201,6274),(88202,6274),(88203,6275),(88204,6275),(88205,6275),(88206,6275),(88207,6275),(88208,6276),(88209,6276),(88210,6276),(88211,6276),(88212,6276),(88213,6277),(88214,6277),(88215,6277),(88216,6277),(88217,6277),(88218,6278),(88219,6278),(88220,6278),(88221,6278),(88222,6278),(88223,6279),(88224,6279),(88225,6279),(88226,6279),(88227,6279),(88228,6280),(88229,6280),(88230,6280),(88231,6280),(88232,6280),(88233,6281),(88234,6281),(88235,6281),(88236,6281),(88237,6281),(88238,6282),(88239,6282),(88240,6282),(88241,6282),(88242,6282),(88243,6283),(88244,6283),(88245,6283),(88246,6283),(88247,6283),(88248,6284),(88249,6284),(88250,6284),(88251,6284),(88252,6284),(88253,6285),(88254,6285),(88255,6285),(88256,6285),(88257,6285),(88258,6286),(88259,6286),(88260,6286),(88261,6286),(88262,6286),(88263,6287),(88264,6287),(88265,6287),(88266,6287),(88267,6287),(88268,6288),(88269,6288),(88270,6288),(88271,6288),(88272,6288),(88273,6289),(88274,6289),(88275,6289),(88276,6289),(88277,6289),(88278,6290),(88279,6290),(88280,6290),(88281,6290),(88282,6290),(88283,6291),(88284,6291),(88285,6291),(88286,6291),(88287,6291),(88288,6292),(88289,6292),(88290,6292),(88291,6292),(88292,6292),(88293,6293),(88294,6293),(88295,6293),(88296,6293),(88297,6293),(88298,6294),(88299,6294),(88300,6294),(88301,6294),(88302,6294),(88303,6295),(88304,6295),(88305,6295),(88306,6295),(88307,6295),(88308,6296),(88309,6296),(88310,6296),(88311,6296),(88312,6296),(88313,6297),(88314,6297),(88315,6297),(88316,6297),(88317,6297),(88318,6298),(88319,6298),(88320,6298),(88321,6298),(88322,6298),(88323,6299),(88324,6299),(88325,6299),(88326,6299),(88327,6299),(88328,6300),(88329,6300),(88330,6300),(88331,6300),(88332,6300),(88333,6301),(88334,6301),(88335,6301),(88336,6301),(88337,6301),(88338,6302),(88339,6302),(88340,6302),(88341,6302),(88342,6302),(88343,6303),(88344,6303),(88345,6303),(88346,6303),(88347,6303),(88348,6304),(88349,6304),(88350,6304),(88351,6304),(88352,6304),(88353,6305),(88354,6305),(88355,6305),(88356,6305),(88357,6305),(88358,6306),(88359,6306),(88360,6306),(88361,6306),(88362,6306),(88363,6307),(88364,6307),(88365,6307),(88366,6307),(88367,6307),(88368,6308),(88369,6308),(88370,6308),(88371,6308),(88372,6308),(88373,6309),(88374,6309),(88375,6309),(88376,6309),(88377,6309),(88378,6310),(88379,6310),(88380,6310),(88381,6310),(88382,6310),(88383,6311),(88384,6311),(88385,6311),(88386,6311),(88387,6311),(88388,6312),(88389,6312),(88390,6312),(88391,6312),(88392,6312),(88393,6313),(88394,6313),(88395,6313),(88396,6313),(88397,6313),(88398,6314),(88399,6314),(88400,6314),(88401,6314),(88402,6314),(88403,6315),(88404,6315),(88405,6315),(88406,6315),(88407,6315),(88408,6316),(88409,6316),(88410,6316),(88411,6316),(88412,6316),(88413,6317),(88414,6317),(88415,6317),(88416,6317),(88417,6317),(88418,6318),(88419,6318),(88420,6318),(88421,6318),(88422,6318),(88423,6319),(88424,6319),(88425,6319),(88426,6319),(88427,6319),(88428,6320),(88429,6320),(88430,6320),(88431,6320),(88432,6320),(88433,6321),(88434,6321),(88435,6321),(88436,6321),(88437,6321),(88438,6322),(88439,6322),(88440,6322),(88441,6322),(88442,6322),(88443,6323),(88444,6323),(88445,6323),(88446,6323),(88447,6323),(88448,6324),(88449,6324),(88450,6324),(88451,6324),(88452,6324),(88453,6325),(88454,6325),(88455,6325),(88456,6325),(88457,6325),(88458,6326),(88459,6326),(88460,6326),(88461,6326),(88462,6326),(88463,6327),(88464,6327),(88465,6327),(88466,6327),(88467,6327),(88468,6328),(88469,6328),(88470,6328),(88471,6328),(88472,6328),(88473,6329),(88474,6329),(88475,6329),(88476,6329),(88477,6329),(88478,6330),(88479,6330),(88480,6330),(88481,6330),(88482,6330),(88483,6331),(88484,6331),(88485,6331),(88486,6331),(88487,6331),(88488,6332),(88489,6332),(88490,6332),(88491,6332),(88492,6332),(88493,6333),(88494,6333),(88495,6333),(88496,6333),(88497,6333),(88498,6334),(88499,6334),(88500,6334),(88501,6334),(88502,6334),(88503,6335),(88504,6335),(88505,6335),(88506,6336),(88507,6336),(88508,6336),(88509,6337),(88510,6337),(88511,6337),(88512,6338),(88513,6338),(88514,6338),(88515,6339),(88516,6339),(88517,6339),(88518,6340),(88519,6340),(88520,6340),(88521,6341),(88522,6341),(88523,6341),(88524,6342),(88525,6342),(88526,6342),(88527,6343),(88528,6343),(88529,6343),(88530,6344),(88531,6344),(88532,6344),(88533,6345),(88534,6345),(88535,6345),(88536,6335),(88537,6335),(88538,6335),(88539,6335),(88540,6335),(88541,6335),(88542,6335),(88543,6335),(88544,6335),(88545,6335),(88546,6336),(88547,6336),(88548,6336),(88549,6336),(88550,6336),(88551,6336),(88552,6336),(88553,6336),(88554,6336),(88555,6336),(88556,6337),(88557,6337),(88558,6337),(88559,6337),(88560,6337),(88561,6337),(88562,6337),(88563,6337),(88564,6337),(88565,6337),(88566,6338),(88567,6338),(88568,6338),(88569,6338),(88570,6338),(88571,6338),(88572,6338),(88573,6338),(88574,6338),(88575,6338),(88576,6339),(88577,6339),(88578,6339),(88579,6339),(88580,6339),(88581,6339),(88582,6339),(88583,6339),(88584,6339),(88585,6339),(88586,6340),(88587,6340),(88588,6340),(88589,6340),(88590,6340),(88591,6340),(88592,6340),(88593,6340),(88594,6340),(88595,6340),(88596,6341),(88597,6341),(88598,6341),(88599,6341),(88600,6341),(88601,6341),(88602,6341),(88603,6341),(88604,6341),(88605,6341),(88606,6342),(88607,6342),(88608,6342),(88609,6342),(88610,6342),(88611,6342),(88612,6342),(88613,6342),(88614,6342),(88615,6342),(88616,6343),(88617,6343),(88618,6343),(88619,6343),(88620,6343),(88621,6343),(88622,6343),(88623,6343),(88624,6343),(88625,6343),(88626,6344),(88627,6344),(88628,6344),(88629,6344),(88630,6344),(88631,6344),(88632,6344),(88633,6344),(88634,6344),(88635,6344),(88636,6345),(88637,6345),(88638,6345),(88639,6345),(88640,6345),(88641,6345),(88642,6345),(88643,6345),(88644,6345),(88645,6345),(88646,6335),(88647,6335),(88648,6335),(88649,6335),(88650,6335),(88651,6336),(88652,6336),(88653,6336),(88654,6336),(88655,6336),(88656,6337),(88657,6337),(88658,6337),(88659,6337),(88660,6337),(88661,6338),(88662,6338),(88663,6338),(88664,6338),(88665,6338),(88666,6339),(88667,6339),(88668,6339),(88669,6339),(88670,6339),(88671,6340),(88672,6340),(88673,6340),(88674,6340),(88675,6340),(88676,6341),(88677,6341),(88678,6341),(88679,6341),(88680,6341),(88681,6342),(88682,6342),(88683,6342),(88684,6342),(88685,6342),(88686,6343),(88687,6343),(88688,6343),(88689,6343),(88690,6343),(88691,6344),(88692,6344),(88693,6344),(88694,6344),(88695,6344),(88696,6345),(88697,6345),(88698,6345),(88699,6345),(88700,6345),(88701,6035),(88702,6035),(88703,6035),(88704,6035),(88705,6035),(88706,6035),(88707,6035),(88708,6035),(88709,6035),(88710,6035),(88711,6035),(88712,6035),(88713,6035),(88714,6035),(88715,6035),(88716,6035),(88717,6035),(88718,6035),(88719,6035),(88720,6035),(88721,6035),(88722,6035),(88723,6035),(88724,6035),(88725,6035),(88726,6036),(88727,6036),(88728,6036),(88729,6036),(88730,6036),(88731,6036),(88732,6036),(88733,6036),(88734,6036),(88735,6036),(88736,6036),(88737,6036),(88738,6036),(88739,6036),(88740,6036),(88741,6036),(88742,6036),(88743,6036),(88744,6036),(88745,6036),(88746,6036),(88747,6036),(88748,6036),(88749,6036),(88750,6036),(88751,6035),(88752,6035),(88753,6035),(88754,6035),(88755,6035),(88756,6346),(88757,6346),(88758,6346),(88759,6347),(88760,6347),(88761,6347),(88762,6348),(88763,6348),(88764,6348),(88765,6349),(88766,6349),(88767,6349),(88768,6350),(88769,6350),(88770,6350),(88771,6351),(88772,6351),(88773,6351),(88774,6352),(88775,6352),(88776,6352),(88777,6353),(88778,6353),(88779,6353),(88780,6354),(88781,6354),(88782,6354),(88783,6355),(88784,6355),(88785,6355),(88786,6356),(88787,6356),(88788,6356),(88789,6346),(88790,6346),(88791,6346),(88792,6346),(88793,6346),(88794,6346),(88795,6346),(88796,6346),(88797,6346),(88798,6346),(88799,6347),(88800,6347),(88801,6347),(88802,6347),(88803,6347),(88804,6347),(88805,6347),(88806,6347),(88807,6347),(88808,6347),(88809,6348),(88810,6348),(88811,6348),(88812,6348),(88813,6348),(88814,6348),(88815,6348),(88816,6348),(88817,6348),(88818,6348),(88819,6349),(88820,6349),(88821,6349),(88822,6349),(88823,6349),(88824,6349),(88825,6349),(88826,6349),(88827,6349),(88828,6349),(88829,6350),(88830,6350),(88831,6350),(88832,6350),(88833,6350),(88834,6350),(88835,6350),(88836,6350),(88837,6350),(88838,6350),(88839,6351),(88840,6351),(88841,6351),(88842,6351),(88843,6351),(88844,6351),(88845,6351),(88846,6351),(88847,6351),(88848,6351),(88849,6352),(88850,6352),(88851,6352),(88852,6352),(88853,6352),(88854,6352),(88855,6352),(88856,6352),(88857,6352),(88858,6352),(88859,6353),(88860,6353),(88861,6353),(88862,6353),(88863,6353),(88864,6353),(88865,6353),(88866,6353),(88867,6353),(88868,6353),(88869,6354),(88870,6354),(88871,6354),(88872,6354),(88873,6354),(88874,6354),(88875,6354),(88876,6354),(88877,6354),(88878,6354),(88879,6355),(88880,6355),(88881,6355),(88882,6355),(88883,6355),(88884,6355),(88885,6355),(88886,6355),(88887,6355),(88888,6355),(88889,6356),(88890,6356),(88891,6356),(88892,6356),(88893,6356),(88894,6356),(88895,6356),(88896,6356),(88897,6356),(88898,6356),(88899,6346),(88900,6346),(88901,6346),(88902,6346),(88903,6346),(88904,6347),(88905,6347),(88906,6347),(88907,6347),(88908,6347),(88909,6348),(88910,6348),(88911,6348),(88912,6348),(88913,6348),(88914,6349),(88915,6349),(88916,6349),(88917,6349),(88918,6349),(88919,6350),(88920,6350),(88921,6350),(88922,6350),(88923,6350),(88924,6351),(88925,6351),(88926,6351),(88927,6351),(88928,6351),(88929,6352),(88930,6352),(88931,6352),(88932,6352),(88933,6352),(88934,6353),(88935,6353),(88936,6353),(88937,6353),(88938,6353),(88939,6354),(88940,6354),(88941,6354),(88942,6354),(88943,6354),(88944,6355),(88945,6355),(88946,6355),(88947,6355),(88948,6355),(88949,6356),(88950,6356),(88951,6356),(88952,6356),(88953,6356),(88954,6357),(88955,6357),(88956,6357),(88957,6358),(88958,6358),(88959,6358),(88960,6359),(88961,6359),(88962,6359),(88963,6360),(88964,6360),(88965,6360),(88966,6361),(88967,6361),(88968,6361),(88969,6362),(88970,6362),(88971,6362),(88972,6363),(88973,6363),(88974,6363),(88975,6364),(88976,6364),(88977,6364),(88978,6365),(88979,6365),(88980,6365),(88981,6366),(88982,6366),(88983,6366),(88984,6367),(88985,6367),(88986,6367),(88987,6368),(88988,6368),(88989,6368),(88990,6369),(88991,6369),(88992,6369),(88993,6370),(88994,6370),(88995,6370),(88996,6371),(88997,6371),(88998,6371),(88999,6372),(89000,6372),(89001,6372),(89002,6373),(89003,6373),(89004,6373),(89005,6374),(89006,6374),(89007,6374),(89008,6375),(89009,6375),(89010,6375),(89011,6376),(89012,6376),(89013,6376),(89014,6377),(89015,6377),(89016,6377),(89017,6378),(89018,6378),(89019,6378),(89020,6379),(89021,6379),(89022,6379),(89023,6380),(89024,6380),(89025,6380),(89026,6381),(89027,6381),(89028,6381),(89029,6382),(89030,6382),(89031,6382),(89032,6383),(89033,6383),(89034,6383),(89035,6384),(89036,6384),(89037,6384),(89038,6385),(89039,6385),(89040,6385),(89041,6386),(89042,6386),(89043,6386),(89044,6387),(89045,6387),(89046,6387),(89047,6388),(89048,6388),(89049,6388),(89050,6389),(89051,6389),(89052,6389),(89053,6390),(89054,6390),(89055,6390),(89056,6391),(89057,6391),(89058,6391),(89059,6392),(89060,6392),(89061,6392),(89062,6393),(89063,6393),(89064,6393),(89065,6394),(89066,6394),(89067,6394),(89068,6395),(89069,6395),(89070,6395),(89071,6396),(89072,6396),(89073,6396),(89074,6397),(89075,6397),(89076,6397),(89077,6398),(89078,6398),(89079,6398),(89080,6399),(89081,6399),(89082,6399),(89083,6400),(89084,6400),(89085,6400),(89086,6401),(89087,6401),(89088,6401),(89089,6402),(89090,6402),(89091,6402),(89092,6403),(89093,6404),(89094,6404),(89095,6404),(89096,6405),(89097,6405),(89098,6405),(89099,6406),(89100,6406),(89101,6406),(89102,6407),(89103,6407),(89104,6407),(89105,6408),(89106,6408),(89107,6408),(89108,6409),(89109,6409),(89110,6409),(89111,6410),(89112,6410),(89113,6410),(89114,6411),(89115,6411),(89116,6411),(89117,6412),(89118,6412),(89119,6412),(89120,6413),(89121,6413),(89122,6413),(89123,6414),(89124,6414),(89125,6414),(89126,6415),(89127,6415),(89128,6415),(89129,6416),(89130,6416),(89131,6416),(89132,6417),(89133,6417),(89134,6417),(89135,6418),(89136,6418),(89137,6418),(89138,6419),(89139,6419),(89140,6419),(89141,6420),(89142,6420),(89143,6420),(89144,6421),(89145,6421),(89146,6421),(89147,6422),(89148,6422),(89149,6422),(89150,6423),(89151,6423),(89152,6423),(89153,6424),(89154,6424),(89155,6424),(89156,6425),(89157,6425),(89158,6425),(89159,6426),(89160,6426),(89161,6426),(89162,6427),(89163,6427),(89164,6427),(89165,6428),(89166,6428),(89167,6428),(89168,6429),(89169,6429),(89170,6429),(89171,6430),(89172,6430),(89173,6430),(89174,6431),(89175,6431),(89176,6431),(89177,6432),(89178,6432),(89179,6432),(89180,6433),(89181,6433),(89182,6433),(89183,6434),(89184,6434),(89185,6434),(89186,6435),(89187,6435),(89188,6435),(89189,6436),(89190,6436),(89191,6436),(89192,6437),(89193,6437),(89194,6437),(89195,6438),(89196,6438),(89197,6438),(89198,6439),(89199,6439),(89200,6439),(89201,6440),(89202,6440),(89203,6440),(89204,6441),(89205,6441),(89206,6441),(89207,6442),(89208,6442),(89209,6442),(89210,6443),(89211,6443),(89212,6443),(89213,6444),(89214,6444),(89215,6444),(89216,6445),(89217,6445),(89218,6445),(89219,6357),(89220,6357),(89221,6357),(89222,6357),(89223,6357),(89224,6357),(89225,6357),(89226,6357),(89227,6357),(89228,6357),(89229,6358),(89230,6358),(89231,6358),(89232,6358),(89233,6358),(89234,6358),(89235,6358),(89236,6358),(89237,6358),(89238,6358),(89239,6359),(89240,6359),(89241,6359),(89242,6359),(89243,6359),(89244,6359),(89245,6359),(89246,6359),(89247,6359),(89248,6359),(89249,6360),(89250,6360),(89251,6360),(89252,6360),(89253,6360),(89254,6360),(89255,6360),(89256,6360),(89257,6360),(89258,6360),(89259,6361),(89260,6361),(89261,6361),(89262,6361),(89263,6361),(89264,6361),(89265,6361),(89266,6361),(89267,6361),(89268,6361),(89269,6362),(89270,6362),(89271,6362),(89272,6362),(89273,6362),(89274,6362),(89275,6362),(89276,6362),(89277,6362),(89278,6362),(89279,6363),(89280,6363),(89281,6363),(89282,6363),(89283,6363),(89284,6363),(89285,6363),(89286,6363),(89287,6363),(89288,6363),(89289,6364),(89290,6364),(89291,6364),(89292,6364),(89293,6364),(89294,6364),(89295,6364),(89296,6364),(89297,6364),(89298,6364),(89299,6365),(89300,6365),(89301,6365),(89302,6365),(89303,6365),(89304,6365),(89305,6365),(89306,6365),(89307,6365),(89308,6365),(89309,6366),(89310,6366),(89311,6366),(89312,6366),(89313,6366),(89314,6366),(89315,6366),(89316,6366),(89317,6366),(89318,6366),(89319,6367),(89320,6367),(89321,6367),(89322,6367),(89323,6367),(89324,6367),(89325,6367),(89326,6367),(89327,6367),(89328,6367),(89329,6368),(89330,6368),(89331,6368),(89332,6368),(89333,6368),(89334,6368),(89335,6368),(89336,6368),(89337,6368),(89338,6368),(89339,6369),(89340,6369),(89341,6369),(89342,6369),(89343,6369),(89344,6369),(89345,6369),(89346,6369),(89347,6369),(89348,6369),(89349,6370),(89350,6370),(89351,6370),(89352,6370),(89353,6370),(89354,6370),(89355,6370),(89356,6370),(89357,6370),(89358,6370),(89359,6371),(89360,6371),(89361,6371),(89362,6371),(89363,6371),(89364,6371),(89365,6371),(89366,6371),(89367,6371),(89368,6371),(89369,6372),(89370,6372),(89371,6372),(89372,6372),(89373,6372),(89374,6372),(89375,6372),(89376,6372),(89377,6372),(89378,6372),(89379,6373),(89380,6373),(89381,6373),(89382,6373),(89383,6373),(89384,6373),(89385,6373),(89386,6373),(89387,6373),(89388,6373),(89389,6374),(89390,6374),(89391,6374),(89392,6374),(89393,6374),(89394,6374),(89395,6374),(89396,6374),(89397,6374),(89398,6374),(89399,6375),(89400,6375),(89401,6375),(89402,6375),(89403,6375),(89404,6375),(89405,6375),(89406,6375),(89407,6375),(89408,6375),(89409,6376),(89410,6376),(89411,6376),(89412,6376),(89413,6376),(89414,6376),(89415,6376),(89416,6376),(89417,6376),(89418,6376),(89419,6377),(89420,6377),(89421,6377),(89422,6377),(89423,6377),(89424,6377),(89425,6377),(89426,6377),(89427,6377),(89428,6377),(89429,6378),(89430,6378),(89431,6378),(89432,6378),(89433,6378),(89434,6378),(89435,6378),(89436,6378),(89437,6378),(89438,6378),(89439,6379),(89440,6379),(89441,6379),(89442,6379),(89443,6379),(89444,6379),(89445,6379),(89446,6379),(89447,6379),(89448,6379),(89449,6380),(89450,6380),(89451,6380),(89452,6380),(89453,6380),(89454,6380),(89455,6380),(89456,6380),(89457,6380),(89458,6380),(89459,6381),(89460,6381),(89461,6381),(89462,6381),(89463,6381),(89464,6381),(89465,6381),(89466,6381),(89467,6381),(89468,6381),(89469,6382),(89470,6382),(89471,6382),(89472,6382),(89473,6382),(89474,6382),(89475,6382),(89476,6382),(89477,6382),(89478,6382),(89479,6383),(89480,6383),(89481,6383),(89482,6383),(89483,6383),(89484,6383),(89485,6383),(89486,6383),(89487,6383),(89488,6383),(89489,6384),(89490,6384),(89491,6384),(89492,6384),(89493,6384),(89494,6384),(89495,6384),(89496,6384),(89497,6384),(89498,6384),(89499,6385),(89500,6385),(89501,6385),(89502,6385),(89503,6385),(89504,6385),(89505,6385),(89506,6385),(89507,6385),(89508,6385),(89509,6386),(89510,6386),(89511,6386),(89512,6386),(89513,6386),(89514,6386),(89515,6386),(89516,6386),(89517,6386),(89518,6386),(89519,6387),(89520,6387),(89521,6387),(89522,6387),(89523,6387),(89524,6387),(89525,6387),(89526,6387),(89527,6387),(89528,6387),(89529,6388),(89530,6388),(89531,6388),(89532,6388),(89533,6388),(89534,6388),(89535,6388),(89536,6388),(89537,6388),(89538,6388),(89539,6389),(89540,6389),(89541,6389),(89542,6389),(89543,6389),(89544,6389),(89545,6389),(89546,6389),(89547,6389),(89548,6389),(89549,6390),(89550,6390),(89551,6390),(89552,6390),(89553,6390),(89554,6390),(89555,6390),(89556,6390),(89557,6390),(89558,6390),(89559,6391),(89560,6391),(89561,6391),(89562,6391),(89563,6391),(89564,6391),(89565,6391),(89566,6391),(89567,6391),(89568,6391),(89569,6392),(89570,6392),(89571,6392),(89572,6392),(89573,6392),(89574,6392),(89575,6392),(89576,6392),(89577,6392),(89578,6392),(89579,6393),(89580,6393),(89581,6393),(89582,6393),(89583,6393),(89584,6393),(89585,6393),(89586,6393),(89587,6393),(89588,6393),(89589,6394),(89590,6394),(89591,6394),(89592,6394),(89593,6394),(89594,6394),(89595,6394),(89596,6394),(89597,6394),(89598,6394),(89599,6395),(89600,6395),(89601,6395),(89602,6395),(89603,6395),(89604,6395),(89605,6395),(89606,6395),(89607,6395),(89608,6395),(89609,6396),(89610,6396),(89611,6396),(89612,6396),(89613,6396),(89614,6396),(89615,6396),(89616,6396),(89617,6396),(89618,6396),(89619,6396),(89620,6396),(89621,6396),(89622,6396),(89623,6397),(89624,6397),(89625,6397),(89626,6397),(89627,6397),(89628,6397),(89629,6397),(89630,6397),(89631,6397),(89632,6397),(89633,6398),(89634,6398),(89635,6398),(89636,6398),(89637,6398),(89638,6398),(89639,6398),(89640,6398),(89641,6398),(89642,6398),(89643,6399),(89644,6399),(89645,6399),(89646,6399),(89647,6399),(89648,6399),(89649,6399),(89650,6399),(89651,6399),(89652,6399),(89653,6400),(89654,6400),(89655,6400),(89656,6400),(89657,6400),(89658,6400),(89659,6400),(89660,6400),(89661,6400),(89662,6400),(89663,6401),(89664,6401),(89665,6401),(89666,6401),(89667,6401),(89668,6401),(89669,6401),(89670,6401),(89671,6401),(89672,6401),(89673,6402),(89674,6402),(89675,6402),(89676,6402),(89677,6402),(89678,6402),(89679,6402),(89680,6402),(89681,6402),(89682,6402),(89683,6403),(89684,6403),(89685,6403),(89686,6403),(89687,6403),(89688,6403),(89689,6403),(89690,6403),(89691,6404),(89692,6404),(89693,6404),(89694,6404),(89695,6404),(89696,6404),(89697,6404),(89698,6404),(89699,6404),(89700,6404),(89701,6405),(89702,6405),(89703,6405),(89704,6405),(89705,6405),(89706,6405),(89707,6405),(89708,6405),(89709,6405),(89710,6405),(89711,6406),(89712,6406),(89713,6406),(89714,6406),(89715,6406),(89716,6406),(89717,6406),(89718,6406),(89719,6406),(89720,6406),(89721,6407),(89722,6407),(89723,6407),(89724,6407),(89725,6407),(89726,6407),(89727,6407),(89728,6407),(89729,6407),(89730,6407),(89731,6408),(89732,6408),(89733,6408),(89734,6408),(89735,6408),(89736,6408),(89737,6408),(89738,6408),(89739,6408),(89740,6408),(89741,6409),(89742,6409),(89743,6409),(89744,6409),(89745,6409),(89746,6409),(89747,6409),(89748,6409),(89749,6409),(89750,6409),(89751,6410),(89752,6410),(89753,6410),(89754,6410),(89755,6410),(89756,6410),(89757,6410),(89758,6410),(89759,6410),(89760,6410),(89761,6411),(89762,6411),(89763,6411),(89764,6411),(89765,6411),(89766,6411),(89767,6411),(89768,6411),(89769,6411),(89770,6411),(89771,6412),(89772,6412),(89773,6412),(89774,6412),(89775,6412),(89776,6412),(89777,6412),(89778,6412),(89779,6412),(89780,6412),(89781,6413),(89782,6413),(89783,6413),(89784,6413),(89785,6413),(89786,6413),(89787,6413),(89788,6413),(89789,6413),(89790,6413),(89791,6414),(89792,6414),(89793,6414),(89794,6414),(89795,6414),(89796,6414),(89797,6414),(89798,6414),(89799,6414),(89800,6414),(89801,6415),(89802,6415),(89803,6415),(89804,6415),(89805,6415),(89806,6415),(89807,6415),(89808,6415),(89809,6415),(89810,6415),(89811,6416),(89812,6416),(89813,6416),(89814,6416),(89815,6416),(89816,6416),(89817,6416),(89818,6416),(89819,6416),(89820,6416),(89821,6417),(89822,6417),(89823,6417),(89824,6417),(89825,6417),(89826,6417),(89827,6417),(89828,6417),(89829,6417),(89830,6417),(89831,6418),(89832,6418),(89833,6418),(89834,6418),(89835,6418),(89836,6418),(89837,6418),(89838,6418),(89839,6418),(89840,6418),(89841,6419),(89842,6419),(89843,6419),(89844,6419),(89845,6419),(89846,6419),(89847,6419),(89848,6419),(89849,6419),(89850,6419),(89851,6420),(89852,6420),(89853,6420),(89854,6420),(89855,6420),(89856,6420),(89857,6420),(89858,6420),(89859,6420),(89860,6420),(89861,6421),(89862,6421),(89863,6421),(89864,6421),(89865,6421),(89866,6421),(89867,6421),(89868,6421),(89869,6421),(89870,6421),(89871,6422),(89872,6422),(89873,6422),(89874,6422),(89875,6422),(89876,6422),(89877,6422),(89878,6422),(89879,6422),(89880,6422),(89881,6423),(89882,6423),(89883,6423),(89884,6423),(89885,6423),(89886,6423),(89887,6423),(89888,6423),(89889,6423),(89890,6423),(89891,6424),(89892,6424),(89893,6424),(89894,6424),(89895,6424),(89896,6424),(89897,6424),(89898,6424),(89899,6424),(89900,6424),(89901,6425),(89902,6425),(89903,6425),(89904,6425),(89905,6425),(89906,6425),(89907,6425),(89908,6425),(89909,6425),(89910,6425),(89911,6426),(89912,6426),(89913,6426),(89914,6426),(89915,6426),(89916,6426),(89917,6426),(89918,6426),(89919,6426),(89920,6426),(89921,6427),(89922,6427),(89923,6427),(89924,6427),(89925,6427),(89926,6427),(89927,6427),(89928,6427),(89929,6427),(89930,6427),(89931,6428),(89932,6428),(89933,6428),(89934,6428),(89935,6428),(89936,6428),(89937,6428),(89938,6428),(89939,6428),(89940,6428),(89941,6429),(89942,6429),(89943,6429),(89944,6429),(89945,6429),(89946,6429),(89947,6429),(89948,6429),(89949,6429),(89950,6429),(89951,6430),(89952,6430),(89953,6430),(89954,6430),(89955,6430),(89956,6430),(89957,6430),(89958,6430),(89959,6430),(89960,6430),(89961,6431),(89962,6431),(89963,6431),(89964,6431),(89965,6431),(89966,6431),(89967,6431),(89968,6431),(89969,6431),(89970,6431),(89971,6431),(89972,6431),(89973,6431),(89974,6431),(89975,6432),(89976,6432),(89977,6432),(89978,6432),(89979,6432),(89980,6432),(89981,6432),(89982,6432),(89983,6432),(89984,6432),(89985,6433),(89986,6433),(89987,6433),(89988,6433),(89989,6433),(89990,6433),(89991,6433),(89992,6433),(89993,6433),(89994,6433),(89995,6434),(89996,6434),(89997,6434),(89998,6434),(89999,6434),(90000,6434),(90001,6434),(90002,6434),(90003,6434),(90004,6434),(90005,6435),(90006,6435),(90007,6435),(90008,6435),(90009,6435),(90010,6435),(90011,6435),(90012,6435),(90013,6435),(90014,6435),(90015,6436),(90016,6436),(90017,6436),(90018,6436),(90019,6436),(90020,6436),(90021,6436),(90022,6436),(90023,6436),(90024,6436),(90025,6437),(90026,6437),(90027,6437),(90028,6437),(90029,6437),(90030,6437),(90031,6437),(90032,6437),(90033,6437),(90034,6437),(90035,6437),(90036,6437),(90037,6437),(90038,6437),(90039,6438),(90040,6438),(90041,6438),(90042,6438),(90043,6438),(90044,6438),(90045,6438),(90046,6438),(90047,6438),(90048,6438),(90049,6439),(90050,6439),(90051,6439),(90052,6439),(90053,6439),(90054,6439),(90055,6439),(90056,6439),(90057,6439),(90058,6439),(90059,6440),(90060,6440),(90061,6440),(90062,6440),(90063,6440),(90064,6440),(90065,6440),(90066,6440),(90067,6440),(90068,6440),(90069,6440),(90070,6440),(90071,6440),(90072,6440),(90073,6441),(90074,6441),(90075,6441),(90076,6441),(90077,6441),(90078,6441),(90079,6441),(90080,6441),(90081,6441),(90082,6441),(90083,6441),(90084,6441),(90085,6441),(90086,6441),(90087,6442),(90088,6442),(90089,6442),(90090,6442),(90091,6442),(90092,6442),(90093,6442),(90094,6442),(90095,6442),(90096,6442),(90097,6442),(90098,6442),(90099,6442),(90100,6442),(90101,6443),(90102,6443),(90103,6443),(90104,6443),(90105,6443),(90106,6443),(90107,6443),(90108,6443),(90109,6443),(90110,6443),(90111,6444),(90112,6444),(90113,6444),(90114,6444),(90115,6444),(90116,6444),(90117,6444),(90118,6444),(90119,6444),(90120,6444),(90121,6444),(90122,6444),(90123,6444),(90124,6444),(90125,6445),(90126,6445),(90127,6445),(90128,6445),(90129,6445),(90130,6445),(90131,6445),(90132,6445),(90133,6445),(90134,6445),(90135,6445),(90136,6445),(90137,6445),(90138,6445),(90139,6357),(90140,6357),(90141,6357),(90142,6357),(90143,6357),(90144,6358),(90145,6358),(90146,6358),(90147,6358),(90148,6358),(90149,6359),(90150,6359),(90151,6359),(90152,6359),(90153,6359),(90154,6360),(90155,6360),(90156,6360),(90157,6360),(90158,6360),(90159,6361),(90160,6361),(90161,6361),(90162,6361),(90163,6361),(90164,6362),(90165,6362),(90166,6362),(90167,6362),(90168,6362),(90169,6363),(90170,6363),(90171,6363),(90172,6363),(90173,6363),(90174,6364),(90175,6364),(90176,6364),(90177,6364),(90178,6364),(90179,6365),(90180,6365),(90181,6365),(90182,6365),(90183,6365),(90184,6366),(90185,6366),(90186,6366),(90187,6366),(90188,6366),(90189,6367),(90190,6367),(90191,6367),(90192,6367),(90193,6367),(90194,6368),(90195,6368),(90196,6368),(90197,6368),(90198,6368),(90199,6369),(90200,6369),(90201,6369),(90202,6369),(90203,6369),(90204,6370),(90205,6370),(90206,6370),(90207,6370),(90208,6370),(90209,6371),(90210,6371),(90211,6371),(90212,6371),(90213,6371),(90214,6372),(90215,6372),(90216,6372),(90217,6372),(90218,6372),(90219,6373),(90220,6373),(90221,6373),(90222,6373),(90223,6373),(90224,6374),(90225,6374),(90226,6374),(90227,6374),(90228,6374),(90229,6375),(90230,6375),(90231,6375),(90232,6375),(90233,6375),(90234,6376),(90235,6376),(90236,6376),(90237,6376),(90238,6376),(90239,6377),(90240,6377),(90241,6377),(90242,6377),(90243,6377),(90244,6378),(90245,6378),(90246,6378),(90247,6378),(90248,6378),(90249,6379),(90250,6379),(90251,6379),(90252,6379),(90253,6379),(90254,6380),(90255,6380),(90256,6380),(90257,6380),(90258,6380),(90259,6381),(90260,6381),(90261,6381),(90262,6381),(90263,6381),(90264,6382),(90265,6382),(90266,6382),(90267,6382),(90268,6382),(90269,6383),(90270,6383),(90271,6383),(90272,6383),(90273,6383),(90274,6384),(90275,6384),(90276,6384),(90277,6384),(90278,6384),(90279,6385),(90280,6385),(90281,6385),(90282,6385),(90283,6385),(90284,6386),(90285,6386),(90286,6386),(90287,6386),(90288,6386),(90289,6387),(90290,6387),(90291,6387),(90292,6387),(90293,6387),(90294,6388),(90295,6388),(90296,6388),(90297,6388),(90298,6388),(90299,6389),(90300,6389),(90301,6389),(90302,6389),(90303,6389),(90304,6390),(90305,6390),(90306,6390),(90307,6390),(90308,6390),(90309,6391),(90310,6391),(90311,6391),(90312,6391),(90313,6391),(90314,6392),(90315,6392),(90316,6392),(90317,6392),(90318,6392),(90319,6393),(90320,6393),(90321,6393),(90322,6393),(90323,6393),(90324,6394),(90325,6394),(90326,6394),(90327,6394),(90328,6394),(90329,6395),(90330,6395),(90331,6395),(90332,6395),(90333,6395),(90334,6396),(90335,6396),(90336,6396),(90337,6396),(90338,6396),(90339,6397),(90340,6397),(90341,6397),(90342,6397),(90343,6397),(90344,6398),(90345,6398),(90346,6398),(90347,6398),(90348,6398),(90349,6399),(90350,6399),(90351,6399),(90352,6399),(90353,6399),(90354,6400),(90355,6400),(90356,6400),(90357,6400),(90358,6400),(90359,6401),(90360,6401),(90361,6401),(90362,6401),(90363,6401),(90364,6402),(90365,6402),(90366,6402),(90367,6402),(90368,6402),(90369,6403),(90370,6403),(90371,6403),(90372,6403),(90373,6403),(90374,6404),(90375,6404),(90376,6404),(90377,6404),(90378,6404),(90379,6405),(90380,6405),(90381,6405),(90382,6405),(90383,6405),(90384,6406),(90385,6406),(90386,6406),(90387,6406),(90388,6406),(90389,6407),(90390,6407),(90391,6407),(90392,6407),(90393,6407),(90394,6408),(90395,6408),(90396,6408),(90397,6408),(90398,6408),(90399,6409),(90400,6409),(90401,6409),(90402,6409),(90403,6409),(90404,6410),(90405,6410),(90406,6410),(90407,6410),(90408,6410),(90409,6411),(90410,6411),(90411,6411),(90412,6411),(90413,6411),(90414,6412),(90415,6412),(90416,6412),(90417,6412),(90418,6412),(90419,6413),(90420,6413),(90421,6413),(90422,6413),(90423,6413),(90424,6414),(90425,6414),(90426,6414),(90427,6414),(90428,6414),(90429,6415),(90430,6415),(90431,6415),(90432,6415),(90433,6415),(90434,6416),(90435,6416),(90436,6416),(90437,6416),(90438,6416),(90439,6417),(90440,6417),(90441,6417),(90442,6417),(90443,6417),(90444,6418),(90445,6418),(90446,6418),(90447,6418),(90448,6418),(90449,6419),(90450,6419),(90451,6419),(90452,6419),(90453,6419),(90454,6420),(90455,6420),(90456,6420),(90457,6420),(90458,6420),(90459,6421),(90460,6421),(90461,6421),(90462,6421),(90463,6421),(90464,6422),(90465,6422),(90466,6422),(90467,6422),(90468,6422),(90469,6423),(90470,6423),(90471,6423),(90472,6423),(90473,6423),(90474,6424),(90475,6424),(90476,6424),(90477,6424),(90478,6424),(90479,6425),(90480,6425),(90481,6425),(90482,6425),(90483,6425),(90484,6426),(90485,6426),(90486,6426),(90487,6426),(90488,6426),(90489,6427),(90490,6427),(90491,6427),(90492,6427),(90493,6427),(90494,6428),(90495,6428),(90496,6428),(90497,6428),(90498,6428),(90499,6429),(90500,6429),(90501,6429),(90502,6429),(90503,6429),(90504,6430),(90505,6430),(90506,6430),(90507,6430),(90508,6430),(90509,6431),(90510,6431),(90511,6431),(90512,6431),(90513,6431),(90514,6432),(90515,6432),(90516,6432),(90517,6432),(90518,6432),(90519,6433),(90520,6433),(90521,6433),(90522,6433),(90523,6433),(90524,6434),(90525,6434),(90526,6434),(90527,6434),(90528,6434),(90529,6435),(90530,6435),(90531,6435),(90532,6435),(90533,6435),(90534,6436),(90535,6436),(90536,6436),(90537,6436),(90538,6436),(90539,6437),(90540,6437),(90541,6437),(90542,6437),(90543,6437),(90544,6438),(90545,6438),(90546,6438),(90547,6438),(90548,6438),(90549,6439),(90550,6439),(90551,6439),(90552,6439),(90553,6439),(90554,6440),(90555,6440),(90556,6440),(90557,6440),(90558,6440),(90559,6441),(90560,6441),(90561,6441),(90562,6441),(90563,6441),(90564,6442),(90565,6442),(90566,6442),(90567,6442),(90568,6442),(90569,6443),(90570,6443),(90571,6443),(90572,6443),(90573,6443),(90574,6444),(90575,6444),(90576,6444),(90577,6444),(90578,6444),(90579,6445),(90580,6445),(90581,6445),(90582,6445),(90583,6445),(90584,6446),(90585,6446),(90586,6446),(90587,6447),(90588,6447),(90589,6447),(90590,6448),(90591,6448),(90592,6448),(90593,6449),(90594,6449),(90595,6449),(90596,6450),(90597,6450),(90598,6450),(90599,6451),(90600,6451),(90601,6451),(90602,6452),(90603,6452),(90604,6452),(90605,6453),(90606,6453),(90607,6453),(90608,6454),(90609,6454),(90610,6454),(90611,6455),(90612,6455),(90613,6455),(90614,6456),(90615,6456),(90616,6456),(90617,6457),(90618,6457),(90619,6457),(90620,6458),(90621,6458),(90622,6458),(90623,6459),(90624,6459),(90625,6459),(90626,6460),(90627,6460),(90628,6460),(90629,6461),(90630,6461),(90631,6461),(90632,6462),(90633,6462),(90634,6462),(90635,6463),(90636,6463),(90637,6463),(90638,6464),(90639,6464),(90640,6464),(90641,6465),(90642,6465),(90643,6465),(90644,6466),(90645,6466),(90646,6466),(90647,6467),(90648,6467),(90649,6467),(90650,6468),(90651,6468),(90652,6468),(90653,6469),(90654,6469),(90655,6469),(90656,6470),(90657,6470),(90658,6470),(90659,6471),(90660,6471),(90661,6471),(90662,6472),(90663,6472),(90664,6472),(90665,6473),(90666,6473),(90667,6473),(90668,6474),(90669,6474),(90670,6474),(90671,6475),(90672,6475),(90673,6475),(90674,6476),(90675,6476),(90676,6476),(90677,6477),(90678,6477),(90679,6477),(90680,6478),(90681,6478),(90682,6478),(90683,6479),(90684,6479),(90685,6479),(90686,6480),(90687,6480),(90688,6480),(90689,6481),(90690,6481),(90691,6481),(90692,6482),(90693,6482),(90694,6482),(90695,6483),(90696,6483),(90697,6483),(90698,6484),(90699,6484),(90700,6484),(90701,6485),(90702,6485),(90703,6485),(90704,6486),(90705,6486),(90706,6486),(90707,6487),(90708,6487),(90709,6487),(90710,6488),(90711,6488),(90712,6488),(90713,6489),(90714,6489),(90715,6489),(90716,6490),(90717,6490),(90718,6490),(90719,6491),(90720,6491),(90721,6491),(90722,6492),(90723,6492),(90724,6492),(90725,6493),(90726,6493),(90727,6493),(90728,6494),(90729,6494),(90730,6494),(90731,6495),(90732,6495),(90733,6495),(90734,6496),(90735,6496),(90736,6496),(90737,6497),(90738,6497),(90739,6497),(90740,6498),(90741,6498),(90742,6498),(90743,6499),(90744,6499),(90745,6499),(90746,6500),(90747,6500),(90748,6500),(90749,6501),(90750,6501),(90751,6501),(90752,6502),(90753,6502),(90754,6502),(90755,6503),(90756,6503),(90757,6503),(90758,6504),(90759,6504),(90760,6504),(90761,6505),(90762,6505),(90763,6505),(90764,6506),(90765,6506),(90766,6506),(90767,6507),(90768,6507),(90769,6507),(90770,6508),(90771,6508),(90772,6508),(90773,6509),(90774,6509),(90775,6509),(90776,6510),(90777,6510),(90778,6510),(90779,6511),(90780,6511),(90781,6511),(90782,6512),(90783,6512),(90784,6512),(90785,6513),(90786,6513),(90787,6513),(90788,6514),(90789,6514),(90790,6514),(90791,6515),(90792,6515),(90793,6515),(90794,6516),(90795,6516),(90796,6516),(90797,6517),(90798,6517),(90799,6517),(90800,6518),(90801,6518),(90802,6518),(90803,6519),(90804,6519),(90805,6519),(90806,6520),(90807,6520),(90808,6520),(90809,6521),(90810,6521),(90811,6521),(90812,6522),(90813,6522),(90814,6522),(90815,6523),(90816,6523),(90817,6523),(90818,6524),(90819,6524),(90820,6524),(90821,6525),(90822,6525),(90823,6525),(90824,6526),(90825,6526),(90826,6526),(90827,6527),(90828,6527),(90829,6527),(90830,6528),(90831,6528),(90832,6528),(90833,6529),(90834,6529),(90835,6529),(90836,6530),(90837,6530),(90838,6530),(90839,6531),(90840,6531),(90841,6531),(90842,6532),(90843,6532),(90844,6532),(90845,6533),(90846,6533),(90847,6533),(90848,6534),(90849,6534),(90850,6534),(90851,6535),(90852,6535),(90853,6535),(90854,6536),(90855,6536),(90856,6536),(90857,6537),(90858,6537),(90859,6537),(90860,6538),(90861,6538),(90862,6538),(90863,6539),(90864,6539),(90865,6539),(90866,6540),(90867,6540),(90868,6540),(90869,6541),(90870,6541),(90871,6541),(90872,6542),(90873,6542),(90874,6542),(90875,6543),(90876,6543),(90877,6543),(90878,6544),(90879,6544),(90880,6544),(90881,6545),(90882,6545),(90883,6545),(90884,6446),(90885,6446),(90886,6446),(90887,6446),(90888,6446),(90889,6446),(90890,6446),(90891,6446),(90892,6446),(90893,6446),(90894,6446),(90895,6446),(90896,6446),(90897,6446),(90898,6447),(90899,6447),(90900,6447),(90901,6447),(90902,6447),(90903,6447),(90904,6447),(90905,6447),(90906,6447),(90907,6447),(90908,6448),(90909,6448),(90910,6448),(90911,6448),(90912,6448),(90913,6448),(90914,6448),(90915,6448),(90916,6448),(90917,6448),(90918,6449),(90919,6449),(90920,6449),(90921,6449),(90922,6449),(90923,6449),(90924,6449),(90925,6449),(90926,6449),(90927,6449),(90928,6449),(90929,6449),(90930,6449),(90931,6449),(90932,6450),(90933,6450),(90934,6450),(90935,6450),(90936,6450),(90937,6450),(90938,6450),(90939,6450),(90940,6450),(90941,6450),(90942,6450),(90943,6450),(90944,6450),(90945,6450),(90946,6451),(90947,6451),(90948,6451),(90949,6451),(90950,6451),(90951,6451),(90952,6451),(90953,6451),(90954,6451),(90955,6451),(90956,6452),(90957,6452),(90958,6452),(90959,6452),(90960,6452),(90961,6452),(90962,6452),(90963,6452),(90964,6452),(90965,6452),(90966,6452),(90967,6452),(90968,6452),(90969,6452),(90970,6453),(90971,6453),(90972,6453),(90973,6453),(90974,6453),(90975,6453),(90976,6453),(90977,6453),(90978,6453),(90979,6453),(90980,6454),(90981,6454),(90982,6454),(90983,6454),(90984,6454),(90985,6454),(90986,6454),(90987,6454),(90988,6454),(90989,6454),(90990,6455),(90991,6455),(90992,6455),(90993,6455),(90994,6455),(90995,6455),(90996,6455),(90997,6455),(90998,6455),(90999,6455),(91000,6456),(91001,6456),(91002,6456),(91003,6456),(91004,6456),(91005,6456),(91006,6456),(91007,6456),(91008,6456),(91009,6456),(91010,6457),(91011,6457),(91012,6457),(91013,6457),(91014,6457),(91015,6457),(91016,6457),(91017,6457),(91018,6457),(91019,6457),(91020,6458),(91021,6458),(91022,6458),(91023,6458),(91024,6458),(91025,6458),(91026,6458),(91027,6458),(91028,6458),(91029,6458),(91030,6459),(91031,6459),(91032,6459),(91033,6459),(91034,6459),(91035,6459),(91036,6459),(91037,6459),(91038,6459),(91039,6459),(91040,6460),(91041,6460),(91042,6460),(91043,6460),(91044,6460),(91045,6460),(91046,6460),(91047,6460),(91048,6460),(91049,6460),(91050,6461),(91051,6461),(91052,6461),(91053,6461),(91054,6461),(91055,6461),(91056,6461),(91057,6461),(91058,6461),(91059,6461),(91060,6462),(91061,6462),(91062,6462),(91063,6462),(91064,6462),(91065,6462),(91066,6462),(91067,6462),(91068,6462),(91069,6462),(91070,6463),(91071,6463),(91072,6463),(91073,6463),(91074,6463),(91075,6463),(91076,6463),(91077,6463),(91078,6463),(91079,6463),(91080,6463),(91081,6463),(91082,6463),(91083,6463),(91084,6464),(91085,6464),(91086,6464),(91087,6464),(91088,6464),(91089,6464),(91090,6464),(91091,6464),(91092,6464),(91093,6464),(91094,6464),(91095,6464),(91096,6464),(91097,6464),(91098,6465),(91099,6465),(91100,6465),(91101,6465),(91102,6465),(91103,6465),(91104,6465),(91105,6465),(91106,6465),(91107,6465),(91108,6466),(91109,6466),(91110,6466),(91111,6466),(91112,6466),(91113,6466),(91114,6466),(91115,6466),(91116,6466),(91117,6466),(91118,6467),(91119,6467),(91120,6467),(91121,6467),(91122,6467),(91123,6467),(91124,6467),(91125,6467),(91126,6467),(91127,6467),(91128,6468),(91129,6468),(91130,6468),(91131,6468),(91132,6468),(91133,6468),(91134,6468),(91135,6468),(91136,6468),(91137,6468),(91138,6469),(91139,6469),(91140,6469),(91141,6469),(91142,6469),(91143,6469),(91144,6469),(91145,6469),(91146,6469),(91147,6469),(91148,6470),(91149,6470),(91150,6470),(91151,6470),(91152,6470),(91153,6470),(91154,6470),(91155,6470),(91156,6470),(91157,6470),(91158,6471),(91159,6471),(91160,6471),(91161,6471),(91162,6471),(91163,6471),(91164,6471),(91165,6471),(91166,6471),(91167,6471),(91168,6471),(91169,6471),(91170,6471),(91171,6471),(91172,6472),(91173,6472),(91174,6472),(91175,6472),(91176,6472),(91177,6472),(91178,6472),(91179,6472),(91180,6472),(91181,6472),(91182,6472),(91183,6472),(91184,6472),(91185,6472),(91186,6473),(91187,6473),(91188,6473),(91189,6473),(91190,6473),(91191,6473),(91192,6473),(91193,6473),(91194,6473),(91195,6473),(91196,6473),(91197,6473),(91198,6473),(91199,6473),(91200,6474),(91201,6474),(91202,6474),(91203,6474),(91204,6474),(91205,6474),(91206,6474),(91207,6474),(91208,6474),(91209,6474),(91210,6474),(91211,6474),(91212,6474),(91213,6474),(91214,6475),(91215,6475),(91216,6475),(91217,6475),(91218,6475),(91219,6475),(91220,6475),(91221,6475),(91222,6475),(91223,6475),(91224,6475),(91225,6475),(91226,6475),(91227,6475),(91228,6476),(91229,6476),(91230,6476),(91231,6476),(91232,6476),(91233,6476),(91234,6476),(91235,6476),(91236,6476),(91237,6476),(91238,6476),(91239,6476),(91240,6476),(91241,6476),(91242,6477),(91243,6477),(91244,6477),(91245,6477),(91246,6477),(91247,6477),(91248,6477),(91249,6477),(91250,6477),(91251,6477),(91252,6477),(91253,6477),(91254,6477),(91255,6477),(91256,6478),(91257,6478),(91258,6478),(91259,6478),(91260,6478),(91261,6478),(91262,6478),(91263,6478),(91264,6478),(91265,6478),(91266,6478),(91267,6478),(91268,6478),(91269,6478),(91270,6479),(91271,6479),(91272,6479),(91273,6479),(91274,6479),(91275,6479),(91276,6479),(91277,6479),(91278,6479),(91279,6479),(91280,6479),(91281,6479),(91282,6479),(91283,6479),(91284,6480),(91285,6480),(91286,6480),(91287,6480),(91288,6480),(91289,6480),(91290,6480),(91291,6480),(91292,6480),(91293,6480),(91294,6480),(91295,6480),(91296,6480),(91297,6480),(91298,6481),(91299,6481),(91300,6481),(91301,6481),(91302,6481),(91303,6481),(91304,6481),(91305,6481),(91306,6481),(91307,6481),(91308,6481),(91309,6481),(91310,6481),(91311,6481),(91312,6482),(91313,6482),(91314,6482),(91315,6482),(91316,6482),(91317,6482),(91318,6482),(91319,6482),(91320,6482),(91321,6482),(91322,6482),(91323,6482),(91324,6482),(91325,6482),(91326,6483),(91327,6483),(91328,6483),(91329,6483),(91330,6483),(91331,6483),(91332,6483),(91333,6483),(91334,6483),(91335,6483),(91336,6484),(91337,6484),(91338,6484),(91339,6484),(91340,6484),(91341,6484),(91342,6484),(91343,6484),(91344,6484),(91345,6484),(91346,6485),(91347,6485),(91348,6485),(91349,6485),(91350,6485),(91351,6485),(91352,6485),(91353,6485),(91354,6486),(91355,6486),(91356,6486),(91357,6486),(91358,6486),(91359,6486),(91360,6486),(91361,6486),(91362,6487),(91363,6487),(91364,6487),(91365,6487),(91366,6487),(91367,6487),(91368,6487),(91369,6487),(91370,6488),(91371,6488),(91372,6488),(91373,6488),(91374,6488),(91375,6488),(91376,6488),(91377,6488),(91378,6489),(91379,6489),(91380,6489),(91381,6489),(91382,6489),(91383,6489),(91384,6489),(91385,6489),(91386,6490),(91387,6490),(91388,6490),(91389,6490),(91390,6490),(91391,6490),(91392,6490),(91393,6490),(91394,6491),(91395,6491),(91396,6491),(91397,6491),(91398,6491),(91399,6491),(91400,6491),(91401,6491),(91402,6492),(91403,6492),(91404,6492),(91405,6492),(91406,6492),(91407,6492),(91408,6492),(91409,6492),(91410,6492),(91411,6492),(91412,6493),(91413,6493),(91414,6493),(91415,6493),(91416,6493),(91417,6493),(91418,6493),(91419,6493),(91420,6493),(91421,6493),(91422,6494),(91423,6494),(91424,6494),(91425,6494),(91426,6494),(91427,6494),(91428,6494),(91429,6494),(91430,6494),(91431,6494),(91432,6495),(91433,6495),(91434,6495),(91435,6495),(91436,6495),(91437,6495),(91438,6495),(91439,6495),(91440,6495),(91441,6495),(91442,6496),(91443,6496),(91444,6496),(91445,6496),(91446,6496),(91447,6496),(91448,6496),(91449,6496),(91450,6496),(91451,6496),(91452,6497),(91453,6497),(91454,6497),(91455,6497),(91456,6497),(91457,6497),(91458,6497),(91459,6497),(91460,6497),(91461,6497),(91462,6498),(91463,6498),(91464,6498),(91465,6498),(91466,6498),(91467,6498),(91468,6498),(91469,6498),(91470,6498),(91471,6498),(91472,6499),(91473,6499),(91474,6499),(91475,6499),(91476,6499),(91477,6499),(91478,6499),(91479,6499),(91480,6499),(91481,6499),(91482,6500),(91483,6500),(91484,6500),(91485,6500),(91486,6500),(91487,6500),(91488,6500),(91489,6500),(91490,6500),(91491,6500),(91492,6501),(91493,6501),(91494,6501),(91495,6501),(91496,6501),(91497,6501),(91498,6501),(91499,6501),(91500,6501),(91501,6501),(91502,6502),(91503,6502),(91504,6502),(91505,6502),(91506,6502),(91507,6502),(91508,6502),(91509,6502),(91510,6502),(91511,6502),(91512,6503),(91513,6503),(91514,6503),(91515,6503),(91516,6503),(91517,6503),(91518,6503),(91519,6503),(91520,6503),(91521,6503),(91522,6504),(91523,6504),(91524,6504),(91525,6504),(91526,6504),(91527,6504),(91528,6504),(91529,6504),(91530,6504),(91531,6504),(91532,6505),(91533,6505),(91534,6505),(91535,6505),(91536,6505),(91537,6505),(91538,6505),(91539,6505),(91540,6505),(91541,6505),(91542,6506),(91543,6506),(91544,6506),(91545,6506),(91546,6506),(91547,6506),(91548,6506),(91549,6506),(91550,6506),(91551,6506),(91552,6507),(91553,6507),(91554,6507),(91555,6507),(91556,6507),(91557,6507),(91558,6507),(91559,6507),(91560,6508),(91561,6508),(91562,6508),(91563,6508),(91564,6508),(91565,6508),(91566,6508),(91567,6508),(91568,6508),(91569,6508),(91570,6508),(91571,6508),(91572,6508),(91573,6508),(91574,6509),(91575,6509),(91576,6509),(91577,6509),(91578,6509),(91579,6509),(91580,6509),(91581,6509),(91582,6509),(91583,6509),(91584,6509),(91585,6509),(91586,6509),(91587,6509),(91588,6510),(91589,6510),(91590,6510),(91591,6510),(91592,6510),(91593,6510),(91594,6510),(91595,6510),(91596,6510),(91597,6510),(91598,6510),(91599,6510),(91600,6510),(91601,6510),(91602,6511),(91603,6511),(91604,6511),(91605,6511),(91606,6511),(91607,6511),(91608,6511),(91609,6511),(91610,6511),(91611,6511),(91612,6511),(91613,6511),(91614,6511),(91615,6511),(91616,6512),(91617,6512),(91618,6512),(91619,6512),(91620,6512),(91621,6512),(91622,6512),(91623,6512),(91624,6512),(91625,6512),(91626,6512),(91627,6512),(91628,6512),(91629,6512),(91630,6513),(91631,6513),(91632,6513),(91633,6513),(91634,6513),(91635,6513),(91636,6513),(91637,6513),(91638,6513),(91639,6513),(91640,6513),(91641,6513),(91642,6513),(91643,6513),(91644,6514),(91645,6514),(91646,6514),(91647,6514),(91648,6515),(91649,6515),(91650,6515),(91651,6515),(91652,6516),(91653,6516),(91654,6516),(91655,6516),(91656,6517),(91657,6517),(91658,6517),(91659,6517),(91660,6518),(91661,6518),(91662,6518),(91663,6518),(91664,6519),(91665,6519),(91666,6519),(91667,6519),(91668,6520),(91669,6520),(91670,6520),(91671,6520),(91672,6521),(91673,6521),(91674,6521),(91675,6521),(91676,6521),(91677,6521),(91678,6521),(91679,6521),(91680,6521),(91681,6521),(91682,6522),(91683,6522),(91684,6522),(91685,6522),(91686,6522),(91687,6522),(91688,6522),(91689,6522),(91690,6522),(91691,6522),(91692,6523),(91693,6523),(91694,6523),(91695,6523),(91696,6523),(91697,6523),(91698,6523),(91699,6523),(91700,6523),(91701,6523),(91702,6524),(91703,6524),(91704,6524),(91705,6524),(91706,6524),(91707,6524),(91708,6524),(91709,6524),(91710,6524),(91711,6524),(91712,6525),(91713,6525),(91714,6525),(91715,6525),(91716,6526),(91717,6526),(91718,6526),(91719,6526),(91720,6527),(91721,6527),(91722,6527),(91723,6527),(91724,6528),(91725,6528),(91726,6528),(91727,6528),(91728,6529),(91729,6529),(91730,6529),(91731,6529),(91732,6530),(91733,6530),(91734,6530),(91735,6530),(91736,6531),(91737,6531),(91738,6531),(91739,6531),(91740,6532),(91741,6532),(91742,6532),(91743,6532),(91744,6533),(91745,6533),(91746,6533),(91747,6533),(91748,6534),(91749,6534),(91750,6534),(91751,6534),(91752,6535),(91753,6535),(91754,6535),(91755,6535),(91756,6536),(91757,6536),(91758,6536),(91759,6536),(91760,6537),(91761,6537),(91762,6537),(91763,6537),(91764,6538),(91765,6538),(91766,6538),(91767,6538),(91768,6539),(91769,6539),(91770,6539),(91771,6539),(91772,6540),(91773,6540),(91774,6540),(91775,6540),(91776,6540),(91777,6540),(91778,6540),(91779,6540),(91780,6540),(91781,6540),(91782,6541),(91783,6541),(91784,6541),(91785,6541),(91786,6541),(91787,6541),(91788,6541),(91789,6541),(91790,6541),(91791,6541),(91792,6542),(91793,6542),(91794,6542),(91795,6542),(91796,6542),(91797,6542),(91798,6542),(91799,6542),(91800,6542),(91801,6542),(91802,6543),(91803,6543),(91804,6543),(91805,6543),(91806,6543),(91807,6543),(91808,6543),(91809,6543),(91810,6543),(91811,6543),(91812,6544),(91813,6544),(91814,6544),(91815,6544),(91816,6544),(91817,6544),(91818,6544),(91819,6544),(91820,6544),(91821,6544),(91822,6545),(91823,6545),(91824,6545),(91825,6545),(91826,6545),(91827,6545),(91828,6545),(91829,6545),(91830,6545),(91831,6545),(91832,6446),(91833,6446),(91834,6446),(91835,6446),(91836,6446),(91837,6447),(91838,6447),(91839,6447),(91840,6447),(91841,6447),(91842,6448),(91843,6448),(91844,6448),(91845,6448),(91846,6448),(91847,6449),(91848,6449),(91849,6449),(91850,6449),(91851,6449),(91852,6450),(91853,6450),(91854,6450),(91855,6450),(91856,6450),(91857,6451),(91858,6451),(91859,6451),(91860,6451),(91861,6451),(91862,6452),(91863,6452),(91864,6452),(91865,6452),(91866,6452),(91867,6453),(91868,6453),(91869,6453),(91870,6453),(91871,6453),(91872,6454),(91873,6454),(91874,6454),(91875,6454),(91876,6454),(91877,6455),(91878,6455),(91879,6455),(91880,6455),(91881,6455),(91882,6456),(91883,6456),(91884,6456),(91885,6456),(91886,6456),(91887,6457),(91888,6457),(91889,6457),(91890,6457),(91891,6457),(91892,6458),(91893,6458),(91894,6458),(91895,6458),(91896,6458),(91897,6459),(91898,6459),(91899,6459),(91900,6459),(91901,6459),(91902,6460),(91903,6460),(91904,6460),(91905,6460),(91906,6460),(91907,6461),(91908,6461),(91909,6461),(91910,6461),(91911,6461),(91912,6462),(91913,6462),(91914,6462),(91915,6462),(91916,6462),(91917,6463),(91918,6463),(91919,6463),(91920,6463),(91921,6463),(91922,6464),(91923,6464),(91924,6464),(91925,6464),(91926,6464),(91927,6465),(91928,6465),(91929,6465),(91930,6465),(91931,6465),(91932,6466),(91933,6466),(91934,6466),(91935,6466),(91936,6466),(91937,6467),(91938,6467),(91939,6467),(91940,6467),(91941,6467),(91942,6468),(91943,6468),(91944,6468),(91945,6468),(91946,6468),(91947,6469),(91948,6469),(91949,6469),(91950,6469),(91951,6469),(91952,6470),(91953,6470),(91954,6470),(91955,6470),(91956,6470),(91957,6471),(91958,6471),(91959,6471),(91960,6471),(91961,6471),(91962,6472),(91963,6472),(91964,6472),(91965,6472),(91966,6472),(91967,6473),(91968,6473),(91969,6473),(91970,6473),(91971,6473),(91972,6474),(91973,6474),(91974,6474),(91975,6474),(91976,6474),(91977,6475),(91978,6475),(91979,6475),(91980,6475),(91981,6475),(91982,6476),(91983,6476),(91984,6476),(91985,6476),(91986,6476),(91987,6477),(91988,6477),(91989,6477),(91990,6477),(91991,6477),(91992,6478),(91993,6478),(91994,6478),(91995,6478),(91996,6478),(91997,6479),(91998,6479),(91999,6479),(92000,6479),(92001,6479),(92002,6480),(92003,6480),(92004,6480),(92005,6480),(92006,6480),(92007,6481),(92008,6481),(92009,6481),(92010,6481),(92011,6481),(92012,6482),(92013,6482),(92014,6482),(92015,6482),(92016,6482),(92017,6483),(92018,6483),(92019,6483),(92020,6483),(92021,6483),(92022,6484),(92023,6484),(92024,6484),(92025,6484),(92026,6484),(92027,6485),(92028,6485),(92029,6485),(92030,6485),(92031,6485),(92032,6486),(92033,6486),(92034,6486),(92035,6486),(92036,6486),(92037,6487),(92038,6487),(92039,6487),(92040,6487),(92041,6487),(92042,6488),(92043,6488),(92044,6488),(92045,6488),(92046,6488),(92047,6489),(92048,6489),(92049,6489),(92050,6489),(92051,6489),(92052,6490),(92053,6490),(92054,6490),(92055,6490),(92056,6490),(92057,6491),(92058,6491),(92059,6491),(92060,6491),(92061,6491),(92062,6492),(92063,6492),(92064,6492),(92065,6492),(92066,6492),(92067,6493),(92068,6493),(92069,6493),(92070,6493),(92071,6493),(92072,6494),(92073,6494),(92074,6494),(92075,6494),(92076,6494),(92077,6495),(92078,6495),(92079,6495),(92080,6495),(92081,6495),(92082,6496),(92083,6496),(92084,6496),(92085,6496),(92086,6496),(92087,6497),(92088,6497),(92089,6497),(92090,6497),(92091,6497),(92092,6498),(92093,6498),(92094,6498),(92095,6498),(92096,6498),(92097,6499),(92098,6499),(92099,6499),(92100,6499),(92101,6499),(92102,6500),(92103,6500),(92104,6500),(92105,6500),(92106,6500),(92107,6501),(92108,6501),(92109,6501),(92110,6501),(92111,6501),(92112,6502),(92113,6502),(92114,6502),(92115,6502),(92116,6502),(92117,6503),(92118,6503),(92119,6503),(92120,6503),(92121,6503),(92122,6504),(92123,6504),(92124,6504),(92125,6504),(92126,6504),(92127,6505),(92128,6505),(92129,6505),(92130,6505),(92131,6505),(92132,6506),(92133,6506),(92134,6506),(92135,6506),(92136,6506),(92137,6507),(92138,6507),(92139,6507),(92140,6507),(92141,6507),(92142,6508),(92143,6508),(92144,6508),(92145,6508),(92146,6508),(92147,6509),(92148,6509),(92149,6509),(92150,6509),(92151,6509),(92152,6510),(92153,6510),(92154,6510),(92155,6510),(92156,6510),(92157,6511),(92158,6511),(92159,6511),(92160,6511),(92161,6511),(92162,6512),(92163,6512),(92164,6512),(92165,6512),(92166,6512),(92167,6513),(92168,6513),(92169,6513),(92170,6513),(92171,6513),(92172,6514),(92173,6514),(92174,6514),(92175,6514),(92176,6514),(92177,6515),(92178,6515),(92179,6515),(92180,6515),(92181,6515),(92182,6516),(92183,6516),(92184,6516),(92185,6516),(92186,6516),(92187,6517),(92188,6517),(92189,6517),(92190,6517),(92191,6517),(92192,6518),(92193,6518),(92194,6518),(92195,6518),(92196,6518),(92197,6519),(92198,6519),(92199,6519),(92200,6519),(92201,6519),(92202,6520),(92203,6520),(92204,6520),(92205,6520),(92206,6520),(92207,6521),(92208,6521),(92209,6521),(92210,6521),(92211,6521),(92212,6522),(92213,6522),(92214,6522),(92215,6522),(92216,6522),(92217,6523),(92218,6523),(92219,6523),(92220,6523),(92221,6523),(92222,6524),(92223,6524),(92224,6524),(92225,6524),(92226,6524),(92227,6525),(92228,6525),(92229,6525),(92230,6525),(92231,6525),(92232,6526),(92233,6526),(92234,6526),(92235,6526),(92236,6526),(92237,6527),(92238,6527),(92239,6527),(92240,6527),(92241,6527),(92242,6528),(92243,6528),(92244,6528),(92245,6528),(92246,6528),(92247,6529),(92248,6529),(92249,6529),(92250,6529),(92251,6529),(92252,6530),(92253,6530),(92254,6530),(92255,6530),(92256,6530),(92257,6531),(92258,6531),(92259,6531),(92260,6531),(92261,6531),(92262,6532),(92263,6532),(92264,6532),(92265,6532),(92266,6532),(92267,6533),(92268,6533),(92269,6533),(92270,6533),(92271,6533),(92272,6534),(92273,6534),(92274,6534),(92275,6534),(92276,6534),(92277,6535),(92278,6535),(92279,6535),(92280,6535),(92281,6535),(92282,6536),(92283,6536),(92284,6536),(92285,6536),(92286,6536),(92287,6537),(92288,6537),(92289,6537),(92290,6537),(92291,6537),(92292,6538),(92293,6538),(92294,6538),(92295,6538),(92296,6538),(92297,6539),(92298,6539),(92299,6539),(92300,6539),(92301,6539),(92302,6540),(92303,6540),(92304,6540),(92305,6540),(92306,6540),(92307,6541),(92308,6541),(92309,6541),(92310,6541),(92311,6541),(92312,6542),(92313,6542),(92314,6542),(92315,6542),(92316,6542),(92317,6543),(92318,6543),(92319,6543),(92320,6543),(92321,6543),(92322,6544),(92323,6544),(92324,6544),(92325,6544),(92326,6544),(92327,6545),(92328,6545),(92329,6545),(92330,6545),(92331,6545),(92332,6546),(92333,6546),(92334,6547),(92335,6547),(92336,6548),(92337,6548),(92338,6549),(92339,6549),(92340,6550),(92341,6550),(92342,6551),(92343,6551),(92344,6552),(92345,6552),(92346,6553),(92347,6553),(92348,6554),(92349,6554),(92350,6555),(92351,6555),(92352,6556),(92353,6556),(92354,6557),(92355,6557),(92356,6558),(92357,6558),(92358,6559),(92359,6559),(92360,6560),(92361,6560),(92362,6561),(92363,6561),(92364,6562),(92365,6562),(92366,6563),(92367,6563),(92368,6564),(92369,6564),(92370,6564),(92371,6565),(92372,6565),(92373,6565),(92374,6566),(92375,6566),(92376,6566),(92377,6567),(92378,6567),(92379,6567),(92380,6568),(92381,6568),(92382,6568),(92383,6569),(92384,6569),(92385,6569),(92386,6570),(92387,6570),(92388,6570),(92389,6571),(92390,6571),(92391,6571),(92392,6572),(92393,6572),(92394,6572),(92395,6546),(92396,6546),(92397,6546),(92398,6546),(92399,6546),(92400,6546),(92401,6546),(92402,6546),(92403,6546),(92404,6546),(92405,6546),(92406,6546),(92407,6546),(92408,6546),(92409,6547),(92410,6547),(92411,6547),(92412,6547),(92413,6547),(92414,6547),(92415,6547),(92416,6547),(92417,6547),(92418,6547),(92419,6547),(92420,6547),(92421,6547),(92422,6547),(92423,6548),(92424,6548),(92425,6548),(92426,6548),(92427,6548),(92428,6548),(92429,6548),(92430,6548),(92431,6548),(92432,6548),(92433,6548),(92434,6548),(92435,6548),(92436,6548),(92437,6549),(92438,6549),(92439,6549),(92440,6549),(92441,6549),(92442,6549),(92443,6549),(92444,6549),(92445,6549),(92446,6549),(92447,6549),(92448,6549),(92449,6549),(92450,6549),(92451,6550),(92452,6550),(92453,6550),(92454,6550),(92455,6550),(92456,6550),(92457,6550),(92458,6550),(92459,6550),(92460,6550),(92461,6550),(92462,6550),(92463,6550),(92464,6550),(92465,6551),(92466,6551),(92467,6551),(92468,6551),(92469,6551),(92470,6551),(92471,6551),(92472,6551),(92473,6551),(92474,6551),(92475,6551),(92476,6551),(92477,6551),(92478,6551),(92479,6552),(92480,6552),(92481,6552),(92482,6552),(92483,6552),(92484,6552),(92485,6552),(92486,6552),(92487,6552),(92488,6552),(92489,6552),(92490,6552),(92491,6552),(92492,6552),(92493,6553),(92494,6553),(92495,6553),(92496,6553),(92497,6553),(92498,6553),(92499,6553),(92500,6553),(92501,6553),(92502,6553),(92503,6553),(92504,6553),(92505,6553),(92506,6553),(92507,6554),(92508,6554),(92509,6554),(92510,6554),(92511,6554),(92512,6554),(92513,6554),(92514,6554),(92515,6554),(92516,6554),(92517,6554),(92518,6554),(92519,6554),(92520,6554),(92521,6555),(92522,6555),(92523,6555),(92524,6555),(92525,6555),(92526,6555),(92527,6555),(92528,6555),(92529,6555),(92530,6555),(92531,6555),(92532,6555),(92533,6555),(92534,6555),(92535,6556),(92536,6556),(92537,6556),(92538,6556),(92539,6556),(92540,6556),(92541,6556),(92542,6556),(92543,6556),(92544,6556),(92545,6556),(92546,6556),(92547,6556),(92548,6556),(92549,6557),(92550,6557),(92551,6557),(92552,6557),(92553,6557),(92554,6557),(92555,6557),(92556,6557),(92557,6557),(92558,6557),(92559,6557),(92560,6557),(92561,6557),(92562,6557),(92563,6558),(92564,6558),(92565,6558),(92566,6558),(92567,6558),(92568,6558),(92569,6558),(92570,6558),(92571,6558),(92572,6558),(92573,6558),(92574,6558),(92575,6558),(92576,6558),(92577,6559),(92578,6559),(92579,6559),(92580,6559),(92581,6559),(92582,6559),(92583,6559),(92584,6559),(92585,6559),(92586,6559),(92587,6559),(92588,6559),(92589,6559),(92590,6559),(92591,6560),(92592,6560),(92593,6560),(92594,6560),(92595,6560),(92596,6560),(92597,6560),(92598,6560),(92599,6560),(92600,6560),(92601,6560),(92602,6560),(92603,6560),(92604,6560),(92605,6561),(92606,6561),(92607,6561),(92608,6561),(92609,6561),(92610,6561),(92611,6561),(92612,6561),(92613,6561),(92614,6561),(92615,6561),(92616,6561),(92617,6561),(92618,6561),(92619,6562),(92620,6562),(92621,6562),(92622,6562),(92623,6562),(92624,6562),(92625,6562),(92626,6562),(92627,6562),(92628,6562),(92629,6562),(92630,6562),(92631,6562),(92632,6562),(92633,6563),(92634,6563),(92635,6563),(92636,6563),(92637,6563),(92638,6563),(92639,6563),(92640,6563),(92641,6563),(92642,6563),(92643,6563),(92644,6563),(92645,6563),(92646,6563),(92647,6564),(92648,6564),(92649,6564),(92650,6564),(92651,6564),(92652,6564),(92653,6564),(92654,6564),(92655,6564),(92656,6564),(92657,6564),(92658,6564),(92659,6564),(92660,6564),(92661,6565),(92662,6565),(92663,6565),(92664,6565),(92665,6565),(92666,6565),(92667,6565),(92668,6565),(92669,6565),(92670,6565),(92671,6565),(92672,6565),(92673,6565),(92674,6565),(92675,6566),(92676,6566),(92677,6566),(92678,6566),(92679,6566),(92680,6566),(92681,6566),(92682,6566),(92683,6566),(92684,6566),(92685,6566),(92686,6566),(92687,6566),(92688,6566),(92689,6567),(92690,6567),(92691,6567),(92692,6567),(92693,6567),(92694,6567),(92695,6567),(92696,6567),(92697,6567),(92698,6567),(92699,6567),(92700,6567),(92701,6567),(92702,6567),(92703,6568),(92704,6568),(92705,6568),(92706,6568),(92707,6568),(92708,6568),(92709,6568),(92710,6568),(92711,6568),(92712,6568),(92713,6568),(92714,6568),(92715,6568),(92716,6568),(92717,6569),(92718,6569),(92719,6569),(92720,6569),(92721,6569),(92722,6569),(92723,6569),(92724,6569),(92725,6569),(92726,6569),(92727,6569),(92728,6569),(92729,6569),(92730,6569),(92731,6570),(92732,6570),(92733,6570),(92734,6570),(92735,6570),(92736,6570),(92737,6570),(92738,6570),(92739,6570),(92740,6570),(92741,6570),(92742,6570),(92743,6570),(92744,6570),(92745,6571),(92746,6571),(92747,6571),(92748,6571),(92749,6571),(92750,6571),(92751,6571),(92752,6571),(92753,6571),(92754,6571),(92755,6571),(92756,6571),(92757,6571),(92758,6571),(92759,6572),(92760,6572),(92761,6572),(92762,6572),(92763,6572),(92764,6572),(92765,6572),(92766,6572),(92767,6572),(92768,6572),(92769,6572),(92770,6572),(92771,6572),(92772,6572),(92773,6546),(92774,6546),(92775,6546),(92776,6546),(92777,6546),(92778,6547),(92779,6547),(92780,6547),(92781,6547),(92782,6547),(92783,6548),(92784,6548),(92785,6548),(92786,6548),(92787,6548),(92788,6549),(92789,6549),(92790,6549),(92791,6549),(92792,6549),(92793,6550),(92794,6550),(92795,6550),(92796,6550),(92797,6550),(92798,6551),(92799,6551),(92800,6551),(92801,6551),(92802,6551),(92803,6552),(92804,6552),(92805,6552),(92806,6552),(92807,6552),(92808,6553),(92809,6553),(92810,6553),(92811,6553),(92812,6553),(92813,6554),(92814,6554),(92815,6554),(92816,6554),(92817,6554),(92818,6555),(92819,6555),(92820,6555),(92821,6555),(92822,6555),(92823,6556),(92824,6556),(92825,6556),(92826,6556),(92827,6556),(92828,6557),(92829,6557),(92830,6557),(92831,6557),(92832,6557),(92833,6558),(92834,6558),(92835,6558),(92836,6558),(92837,6558),(92838,6559),(92839,6559),(92840,6559),(92841,6559),(92842,6559),(92843,6560),(92844,6560),(92845,6560),(92846,6560),(92847,6560),(92848,6561),(92849,6561),(92850,6561),(92851,6561),(92852,6561),(92853,6562),(92854,6562),(92855,6562),(92856,6562),(92857,6562),(92858,6563),(92859,6563),(92860,6563),(92861,6563),(92862,6563),(92863,6564),(92864,6564),(92865,6564),(92866,6564),(92867,6564),(92868,6565),(92869,6565),(92870,6565),(92871,6565),(92872,6565),(92873,6566),(92874,6566),(92875,6566),(92876,6566),(92877,6566),(92878,6567),(92879,6567),(92880,6567),(92881,6567),(92882,6567),(92883,6568),(92884,6568),(92885,6568),(92886,6568),(92887,6568),(92888,6569),(92889,6569),(92890,6569),(92891,6569),(92892,6569),(92893,6570),(92894,6570),(92895,6570),(92896,6570),(92897,6570),(92898,6571),(92899,6571),(92900,6571),(92901,6571),(92902,6571),(92903,6572),(92904,6572),(92905,6572),(92906,6572),(92907,6572);
/*!40000 ALTER TABLE `catalog_product_attribute_cl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_bundle_option`
--

DROP TABLE IF EXISTS `catalog_product_bundle_option`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_bundle_option` (
  `option_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option ID',
  `parent_id` int unsigned NOT NULL COMMENT 'Parent ID',
  `required` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Required',
  `position` int unsigned NOT NULL DEFAULT '0' COMMENT 'Position',
  `type` varchar(255) DEFAULT NULL COMMENT 'Type',
  PRIMARY KEY (`option_id`),
  KEY `CATALOG_PRODUCT_BUNDLE_OPTION_PARENT_ID` (`parent_id`),
  CONSTRAINT `CAT_PRD_BNDL_OPT_PARENT_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`parent_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Bundle Option';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_bundle_option`
--

LOCK TABLES `catalog_product_bundle_option` WRITE;
/*!40000 ALTER TABLE `catalog_product_bundle_option` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_bundle_option` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_bundle_option_value`
--

DROP TABLE IF EXISTS `catalog_product_bundle_option_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_bundle_option_value` (
  `value_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `option_id` int unsigned NOT NULL COMMENT 'Option ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title',
  `parent_product_id` int unsigned NOT NULL COMMENT 'Parent Product ID',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CAT_PRD_BNDL_OPT_VAL_OPT_ID_PARENT_PRD_ID_STORE_ID` (`option_id`,`parent_product_id`,`store_id`),
  CONSTRAINT `CAT_PRD_BNDL_OPT_VAL_OPT_ID_CAT_PRD_BNDL_OPT_OPT_ID` FOREIGN KEY (`option_id`) REFERENCES `catalog_product_bundle_option` (`option_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Bundle Option Value';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_bundle_option_value`
--

LOCK TABLES `catalog_product_bundle_option_value` WRITE;
/*!40000 ALTER TABLE `catalog_product_bundle_option_value` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_bundle_option_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_bundle_price_index`
--

DROP TABLE IF EXISTS `catalog_product_bundle_price_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_bundle_price_index` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `customer_group_id` int unsigned NOT NULL COMMENT 'Customer Group ID',
  `min_price` decimal(20,6) NOT NULL COMMENT 'Min Price',
  `max_price` decimal(20,6) NOT NULL COMMENT 'Max Price',
  PRIMARY KEY (`entity_id`,`website_id`,`customer_group_id`),
  KEY `CATALOG_PRODUCT_BUNDLE_PRICE_INDEX_WEBSITE_ID` (`website_id`),
  KEY `CATALOG_PRODUCT_BUNDLE_PRICE_INDEX_CUSTOMER_GROUP_ID` (`customer_group_id`),
  CONSTRAINT `CAT_PRD_BNDL_PRICE_IDX_CSTR_GROUP_ID_CSTR_GROUP_CSTR_GROUP_ID` FOREIGN KEY (`customer_group_id`) REFERENCES `customer_group` (`customer_group_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_BNDL_PRICE_IDX_ENTT_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_BNDL_PRICE_IDX_WS_ID_STORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Bundle Price Index';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_bundle_price_index`
--

LOCK TABLES `catalog_product_bundle_price_index` WRITE;
/*!40000 ALTER TABLE `catalog_product_bundle_price_index` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_bundle_price_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_bundle_selection`
--

DROP TABLE IF EXISTS `catalog_product_bundle_selection`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_bundle_selection` (
  `selection_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Selection ID',
  `option_id` int unsigned NOT NULL COMMENT 'Option ID',
  `parent_product_id` int unsigned NOT NULL COMMENT 'Parent Product ID',
  `product_id` int unsigned NOT NULL COMMENT 'Product ID',
  `position` int unsigned NOT NULL DEFAULT '0' COMMENT 'Position',
  `is_default` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Default',
  `selection_price_type` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Selection Price Type',
  `selection_price_value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Selection Price Value',
  `selection_qty` decimal(12,4) DEFAULT NULL COMMENT 'Selection Qty',
  `selection_can_change_qty` smallint NOT NULL DEFAULT '0' COMMENT 'Selection Can Change Qty',
  PRIMARY KEY (`selection_id`),
  KEY `CATALOG_PRODUCT_BUNDLE_SELECTION_OPTION_ID` (`option_id`),
  KEY `CATALOG_PRODUCT_BUNDLE_SELECTION_PRODUCT_ID` (`product_id`),
  CONSTRAINT `CAT_PRD_BNDL_SELECTION_OPT_ID_CAT_PRD_BNDL_OPT_OPT_ID` FOREIGN KEY (`option_id`) REFERENCES `catalog_product_bundle_option` (`option_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_BNDL_SELECTION_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Bundle Selection';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_bundle_selection`
--

LOCK TABLES `catalog_product_bundle_selection` WRITE;
/*!40000 ALTER TABLE `catalog_product_bundle_selection` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_bundle_selection` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_bundle_selection_after_insert` AFTER INSERT ON `catalog_product_bundle_selection` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`parent_product_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_bundle_selection_after_update` AFTER UPDATE ON `catalog_product_bundle_selection` FOR EACH ROW BEGIN
IF (NOT(NEW.`selection_id` <=> OLD.`selection_id`) OR NOT(NEW.`option_id` <=> OLD.`option_id`) OR NOT(NEW.`parent_product_id` <=> OLD.`parent_product_id`) OR NOT(NEW.`product_id` <=> OLD.`product_id`) OR NOT(NEW.`position` <=> OLD.`position`) OR NOT(NEW.`is_default` <=> OLD.`is_default`) OR NOT(NEW.`selection_price_type` <=> OLD.`selection_price_type`) OR NOT(NEW.`selection_price_value` <=> OLD.`selection_price_value`) OR NOT(NEW.`selection_qty` <=> OLD.`selection_qty`) OR NOT(NEW.`selection_can_change_qty` <=> OLD.`selection_can_change_qty`)) THEN INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`parent_product_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_bundle_selection_after_delete` AFTER DELETE ON `catalog_product_bundle_selection` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (OLD.`parent_product_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `catalog_product_bundle_selection_price`
--

DROP TABLE IF EXISTS `catalog_product_bundle_selection_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_bundle_selection_price` (
  `selection_id` int unsigned NOT NULL COMMENT 'Selection ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `selection_price_type` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Selection Price Type',
  `selection_price_value` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Selection Price Value',
  `parent_product_id` int unsigned NOT NULL COMMENT 'Parent Product ID',
  PRIMARY KEY (`selection_id`,`parent_product_id`,`website_id`),
  KEY `CATALOG_PRODUCT_BUNDLE_SELECTION_PRICE_WEBSITE_ID` (`website_id`),
  CONSTRAINT `CAT_PRD_BNDL_SELECTION_PRICE_WS_ID_STORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_DCF37523AA05D770A70AA4ED7C2616E4` FOREIGN KEY (`selection_id`) REFERENCES `catalog_product_bundle_selection` (`selection_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Bundle Selection Price';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_bundle_selection_price`
--

LOCK TABLES `catalog_product_bundle_selection_price` WRITE;
/*!40000 ALTER TABLE `catalog_product_bundle_selection_price` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_bundle_selection_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_bundle_stock_index`
--

DROP TABLE IF EXISTS `catalog_product_bundle_stock_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_bundle_stock_index` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `stock_id` smallint unsigned NOT NULL COMMENT 'Stock ID',
  `option_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `stock_status` smallint DEFAULT '0' COMMENT 'Stock Status',
  PRIMARY KEY (`entity_id`,`website_id`,`stock_id`,`option_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Bundle Stock Index';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_bundle_stock_index`
--

LOCK TABLES `catalog_product_bundle_stock_index` WRITE;
/*!40000 ALTER TABLE `catalog_product_bundle_stock_index` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_bundle_stock_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_category_cl`
--

DROP TABLE IF EXISTS `catalog_product_category_cl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_category_cl` (
  `version_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Version ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  PRIMARY KEY (`version_id`)
) ENGINE=InnoDB AUTO_INCREMENT=64896 DEFAULT CHARSET=utf8mb3 COMMENT='catalog_product_category_cl';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_category_cl`
--

LOCK TABLES `catalog_product_category_cl` WRITE;
/*!40000 ALTER TABLE `catalog_product_category_cl` DISABLE KEYS */;
INSERT INTO `catalog_product_category_cl` VALUES (1,1),(2,2),(3,3),(4,4),(5,5),(6,6),(7,1),(8,1),(9,2),(10,2),(11,3),(12,3),(13,4),(14,4),(15,5),(16,5),(17,6),(18,6),(19,1),(20,1),(21,1),(22,1),(23,2),(24,2),(25,2),(26,2),(27,3),(28,3),(29,3),(30,3),(31,4),(32,4),(33,4),(34,5),(35,5),(36,5),(37,5),(38,5),(39,5),(40,5),(41,5),(42,5),(43,6),(44,6),(45,6),(46,6),(47,6),(48,6),(49,6),(50,6),(51,6),(52,1),(53,1),(54,1),(55,1),(56,1),(57,1),(58,1),(59,1),(60,2),(61,2),(62,2),(63,2),(64,2),(65,2),(66,6),(67,6),(68,6),(69,6),(70,6),(71,6),(72,5),(73,5),(74,5),(75,5),(76,4),(77,4),(78,4),(79,4),(80,4),(81,3),(82,3),(83,7),(84,7),(85,7),(86,7),(87,7),(88,7),(89,7),(90,8),(91,9),(92,10),(93,11),(94,12),(95,13),(96,14),(97,15),(98,16),(99,17),(100,18),(101,19),(102,20),(103,21),(104,22),(105,23),(106,24),(107,25),(108,26),(109,27),(110,28),(111,29),(112,30),(113,31),(114,32),(115,33),(116,34),(117,35),(118,36),(119,37),(120,38),(121,39),(122,40),(123,41),(124,42),(125,43),(126,44),(127,45),(128,46),(129,47),(130,48),(131,49),(132,50),(133,51),(134,52),(135,53),(136,54),(137,55),(138,56),(139,57),(140,58),(141,59),(142,60),(143,61),(144,62),(145,63),(146,64),(147,65),(148,66),(149,67),(150,68),(151,69),(152,70),(153,71),(154,72),(155,73),(156,74),(157,75),(158,76),(159,77),(160,78),(161,79),(162,80),(163,81),(164,82),(165,83),(166,84),(167,85),(168,86),(169,87),(170,88),(171,89),(172,90),(173,91),(174,92),(175,93),(176,94),(177,95),(178,96),(179,97),(180,98),(181,99),(182,100),(183,101),(184,102),(185,103),(186,104),(187,105),(188,106),(189,8),(190,8),(191,8),(192,8),(193,9),(194,9),(195,9),(196,9),(197,10),(198,10),(199,10),(200,10),(201,11),(202,11),(203,11),(204,11),(205,12),(206,12),(207,12),(208,12),(209,13),(210,13),(211,13),(212,13),(213,14),(214,14),(215,14),(216,14),(217,15),(218,15),(219,15),(220,15),(221,16),(222,16),(223,16),(224,16),(225,17),(226,17),(227,17),(228,17),(229,18),(230,18),(231,18),(232,18),(233,19),(234,19),(235,19),(236,19),(237,20),(238,20),(239,20),(240,20),(241,21),(242,21),(243,21),(244,21),(245,22),(246,22),(247,22),(248,22),(249,23),(250,23),(251,23),(252,23),(253,24),(254,24),(255,24),(256,24),(257,25),(258,25),(259,25),(260,25),(261,26),(262,26),(263,26),(264,26),(265,27),(266,27),(267,27),(268,27),(269,28),(270,28),(271,28),(272,28),(273,29),(274,29),(275,29),(276,29),(277,30),(278,30),(279,30),(280,30),(281,31),(282,31),(283,31),(284,31),(285,32),(286,32),(287,32),(288,32),(289,33),(290,33),(291,33),(292,33),(293,34),(294,34),(295,34),(296,34),(297,35),(298,35),(299,35),(300,35),(301,36),(302,36),(303,36),(304,36),(305,37),(306,37),(307,37),(308,37),(309,38),(310,38),(311,38),(312,38),(313,39),(314,39),(315,39),(316,39),(317,40),(318,40),(319,40),(320,40),(321,41),(322,41),(323,41),(324,41),(325,42),(326,42),(327,42),(328,42),(329,43),(330,43),(331,43),(332,43),(333,44),(334,44),(335,44),(336,44),(337,45),(338,45),(339,45),(340,45),(341,46),(342,46),(343,46),(344,46),(345,47),(346,47),(347,47),(348,47),(349,48),(350,48),(351,48),(352,48),(353,49),(354,49),(355,49),(356,49),(357,50),(358,50),(359,50),(360,50),(361,51),(362,51),(363,51),(364,51),(365,52),(366,52),(367,52),(368,52),(369,53),(370,53),(371,53),(372,53),(373,54),(374,54),(375,54),(376,54),(377,55),(378,55),(379,55),(380,55),(381,56),(382,56),(383,56),(384,56),(385,57),(386,57),(387,57),(388,57),(389,58),(390,58),(391,58),(392,58),(393,59),(394,59),(395,59),(396,59),(397,60),(398,60),(399,60),(400,60),(401,61),(402,61),(403,61),(404,61),(405,62),(406,62),(407,62),(408,62),(409,63),(410,63),(411,63),(412,63),(413,64),(414,64),(415,64),(416,64),(417,65),(418,65),(419,65),(420,65),(421,66),(422,66),(423,66),(424,66),(425,67),(426,67),(427,67),(428,67),(429,68),(430,68),(431,68),(432,68),(433,69),(434,69),(435,69),(436,69),(437,70),(438,70),(439,70),(440,70),(441,71),(442,71),(443,71),(444,71),(445,72),(446,72),(447,72),(448,72),(449,73),(450,73),(451,73),(452,73),(453,74),(454,74),(455,74),(456,74),(457,75),(458,75),(459,75),(460,75),(461,76),(462,76),(463,76),(464,76),(465,77),(466,77),(467,77),(468,77),(469,78),(470,78),(471,78),(472,78),(473,79),(474,79),(475,79),(476,79),(477,80),(478,80),(479,80),(480,80),(481,81),(482,81),(483,81),(484,81),(485,82),(486,82),(487,82),(488,82),(489,83),(490,83),(491,83),(492,83),(493,84),(494,84),(495,84),(496,84),(497,85),(498,85),(499,85),(500,85),(501,86),(502,86),(503,86),(504,86),(505,87),(506,87),(507,87),(508,87),(509,88),(510,88),(511,88),(512,88),(513,89),(514,89),(515,89),(516,89),(517,90),(518,90),(519,90),(520,90),(521,91),(522,91),(523,91),(524,91),(525,92),(526,92),(527,92),(528,92),(529,93),(530,93),(531,93),(532,93),(533,94),(534,94),(535,94),(536,94),(537,95),(538,95),(539,95),(540,95),(541,96),(542,96),(543,96),(544,96),(545,97),(546,97),(547,97),(548,97),(549,98),(550,98),(551,98),(552,98),(553,99),(554,99),(555,99),(556,99),(557,100),(558,100),(559,100),(560,100),(561,101),(562,101),(563,101),(564,101),(565,102),(566,102),(567,102),(568,102),(569,103),(570,103),(571,103),(572,103),(573,104),(574,104),(575,104),(576,104),(577,105),(578,105),(579,105),(580,105),(581,106),(582,106),(583,106),(584,106),(585,107),(586,108),(587,109),(588,110),(589,111),(590,112),(591,113),(592,114),(593,115),(594,116),(595,117),(596,118),(597,119),(598,120),(599,121),(600,122),(601,123),(602,124),(603,125),(604,126),(605,127),(606,128),(607,129),(608,130),(609,131),(610,132),(611,133),(612,134),(613,135),(614,136),(615,137),(616,138),(617,139),(618,140),(619,141),(620,142),(621,143),(622,144),(623,145),(624,146),(625,147),(626,148),(627,149),(628,150),(629,151),(630,152),(631,153),(632,154),(633,155),(634,156),(635,157),(636,158),(637,159),(638,160),(639,161),(640,162),(641,163),(642,164),(643,165),(644,166),(645,167),(646,168),(647,169),(648,170),(649,171),(650,172),(651,173),(652,174),(653,175),(654,176),(655,177),(656,178),(657,179),(658,180),(659,181),(660,182),(661,183),(662,184),(663,185),(664,186),(665,187),(666,188),(667,189),(668,190),(669,191),(670,192),(671,193),(672,194),(673,195),(674,196),(675,197),(676,198),(677,199),(678,200),(679,201),(680,202),(681,203),(682,204),(683,205),(684,206),(685,107),(686,107),(687,107),(688,107),(689,108),(690,108),(691,108),(692,108),(693,109),(694,109),(695,109),(696,109),(697,110),(698,110),(699,110),(700,110),(701,111),(702,111),(703,111),(704,111),(705,112),(706,112),(707,112),(708,112),(709,113),(710,113),(711,113),(712,113),(713,114),(714,114),(715,114),(716,114),(717,115),(718,115),(719,115),(720,115),(721,116),(722,116),(723,116),(724,116),(725,117),(726,117),(727,117),(728,117),(729,118),(730,118),(731,118),(732,118),(733,119),(734,119),(735,119),(736,119),(737,120),(738,120),(739,120),(740,120),(741,121),(742,121),(743,121),(744,121),(745,122),(746,122),(747,122),(748,122),(749,123),(750,123),(751,123),(752,123),(753,124),(754,124),(755,124),(756,124),(757,125),(758,125),(759,125),(760,125),(761,126),(762,126),(763,126),(764,126),(765,127),(766,127),(767,127),(768,127),(769,128),(770,128),(771,128),(772,128),(773,129),(774,129),(775,129),(776,129),(777,130),(778,130),(779,130),(780,130),(781,131),(782,131),(783,131),(784,131),(785,132),(786,132),(787,132),(788,132),(789,133),(790,133),(791,133),(792,133),(793,134),(794,134),(795,134),(796,134),(797,135),(798,135),(799,135),(800,135),(801,136),(802,136),(803,136),(804,136),(805,137),(806,137),(807,137),(808,137),(809,138),(810,138),(811,138),(812,138),(813,139),(814,139),(815,139),(816,139),(817,140),(818,140),(819,140),(820,140),(821,141),(822,141),(823,141),(824,141),(825,142),(826,142),(827,142),(828,142),(829,143),(830,143),(831,143),(832,143),(833,144),(834,144),(835,144),(836,144),(837,145),(838,145),(839,145),(840,145),(841,146),(842,146),(843,146),(844,146),(845,147),(846,147),(847,147),(848,147),(849,148),(850,148),(851,148),(852,148),(853,149),(854,149),(855,149),(856,149),(857,150),(858,150),(859,150),(860,150),(861,151),(862,151),(863,151),(864,151),(865,152),(866,152),(867,152),(868,152),(869,153),(870,153),(871,153),(872,153),(873,154),(874,154),(875,154),(876,154),(877,155),(878,155),(879,155),(880,155),(881,156),(882,156),(883,156),(884,156),(885,157),(886,157),(887,157),(888,157),(889,158),(890,158),(891,158),(892,158),(893,159),(894,159),(895,159),(896,159),(897,160),(898,160),(899,160),(900,160),(901,161),(902,161),(903,161),(904,161),(905,162),(906,162),(907,162),(908,162),(909,163),(910,163),(911,163),(912,163),(913,164),(914,164),(915,164),(916,164),(917,165),(918,165),(919,165),(920,165),(921,166),(922,166),(923,166),(924,166),(925,167),(926,167),(927,167),(928,167),(929,168),(930,168),(931,168),(932,168),(933,169),(934,169),(935,169),(936,169),(937,170),(938,170),(939,170),(940,170),(941,171),(942,171),(943,171),(944,171),(945,172),(946,172),(947,172),(948,172),(949,173),(950,173),(951,173),(952,173),(953,174),(954,174),(955,174),(956,174),(957,175),(958,175),(959,175),(960,175),(961,176),(962,176),(963,176),(964,176),(965,177),(966,177),(967,177),(968,177),(969,178),(970,178),(971,178),(972,178),(973,179),(974,179),(975,179),(976,179),(977,180),(978,180),(979,180),(980,180),(981,181),(982,181),(983,181),(984,181),(985,182),(986,182),(987,182),(988,182),(989,183),(990,183),(991,183),(992,183),(993,184),(994,184),(995,184),(996,184),(997,185),(998,185),(999,185),(1000,185),(1001,186),(1002,186),(1003,186),(1004,186),(1005,187),(1006,187),(1007,187),(1008,187),(1009,188),(1010,188),(1011,188),(1012,188),(1013,189),(1014,189),(1015,189),(1016,189),(1017,190),(1018,190),(1019,190),(1020,190),(1021,191),(1022,191),(1023,191),(1024,191),(1025,192),(1026,192),(1027,192),(1028,192),(1029,193),(1030,193),(1031,193),(1032,193),(1033,194),(1034,194),(1035,194),(1036,194),(1037,195),(1038,195),(1039,195),(1040,195),(1041,196),(1042,196),(1043,196),(1044,196),(1045,197),(1046,197),(1047,197),(1048,197),(1049,198),(1050,198),(1051,198),(1052,198),(1053,199),(1054,199),(1055,199),(1056,199),(1057,200),(1058,200),(1059,200),(1060,200),(1061,201),(1062,201),(1063,201),(1064,201),(1065,202),(1066,202),(1067,202),(1068,202),(1069,203),(1070,203),(1071,203),(1072,203),(1073,204),(1074,204),(1075,204),(1076,204),(1077,205),(1078,205),(1079,205),(1080,205),(1081,206),(1082,206),(1083,206),(1084,206),(1085,207),(1086,208),(1087,209),(1088,210),(1089,211),(1090,212),(1091,213),(1092,214),(1093,215),(1094,216),(1095,217),(1096,218),(1097,219),(1098,220),(1099,221),(1100,222),(1101,223),(1102,224),(1103,225),(1104,226),(1105,227),(1106,228),(1107,229),(1108,230),(1109,231),(1110,232),(1111,233),(1112,234),(1113,235),(1114,236),(1115,237),(1116,238),(1117,239),(1118,240),(1119,241),(1120,242),(1121,243),(1122,244),(1123,245),(1124,246),(1125,247),(1126,248),(1127,249),(1128,250),(1129,251),(1130,252),(1131,253),(1132,254),(1133,255),(1134,256),(1135,257),(1136,258),(1137,259),(1138,260),(1139,261),(1140,262),(1141,263),(1142,264),(1143,265),(1144,266),(1145,267),(1146,268),(1147,269),(1148,270),(1149,271),(1150,272),(1151,273),(1152,274),(1153,275),(1154,276),(1155,277),(1156,278),(1157,279),(1158,280),(1159,207),(1160,207),(1161,207),(1162,207),(1163,208),(1164,208),(1165,208),(1166,208),(1167,209),(1168,209),(1169,209),(1170,209),(1171,210),(1172,210),(1173,210),(1174,210),(1175,211),(1176,211),(1177,211),(1178,211),(1179,212),(1180,212),(1181,212),(1182,212),(1183,213),(1184,213),(1185,213),(1186,213),(1187,214),(1188,214),(1189,214),(1190,214),(1191,215),(1192,215),(1193,215),(1194,215),(1195,216),(1196,216),(1197,216),(1198,216),(1199,217),(1200,217),(1201,217),(1202,217),(1203,218),(1204,218),(1205,218),(1206,218),(1207,219),(1208,219),(1209,219),(1210,219),(1211,220),(1212,220),(1213,220),(1214,220),(1215,221),(1216,221),(1217,221),(1218,221),(1219,222),(1220,222),(1221,222),(1222,222),(1223,223),(1224,223),(1225,223),(1226,223),(1227,224),(1228,224),(1229,224),(1230,224),(1231,225),(1232,225),(1233,225),(1234,225),(1235,226),(1236,226),(1237,226),(1238,226),(1239,227),(1240,227),(1241,227),(1242,227),(1243,228),(1244,228),(1245,228),(1246,228),(1247,229),(1248,229),(1249,229),(1250,229),(1251,230),(1252,230),(1253,230),(1254,230),(1255,231),(1256,231),(1257,231),(1258,231),(1259,232),(1260,232),(1261,232),(1262,232),(1263,233),(1264,233),(1265,233),(1266,233),(1267,234),(1268,234),(1269,234),(1270,234),(1271,235),(1272,235),(1273,235),(1274,235),(1275,236),(1276,236),(1277,236),(1278,236),(1279,237),(1280,237),(1281,237),(1282,237),(1283,238),(1284,238),(1285,238),(1286,238),(1287,239),(1288,239),(1289,239),(1290,239),(1291,240),(1292,240),(1293,240),(1294,240),(1295,241),(1296,241),(1297,241),(1298,241),(1299,242),(1300,242),(1301,242),(1302,242),(1303,243),(1304,243),(1305,243),(1306,243),(1307,244),(1308,244),(1309,244),(1310,244),(1311,245),(1312,245),(1313,245),(1314,245),(1315,246),(1316,246),(1317,246),(1318,246),(1319,247),(1320,247),(1321,247),(1322,247),(1323,248),(1324,248),(1325,248),(1326,248),(1327,249),(1328,249),(1329,249),(1330,249),(1331,250),(1332,250),(1333,250),(1334,250),(1335,251),(1336,251),(1337,251),(1338,251),(1339,252),(1340,252),(1341,252),(1342,252),(1343,253),(1344,253),(1345,253),(1346,253),(1347,254),(1348,254),(1349,254),(1350,254),(1351,255),(1352,255),(1353,255),(1354,255),(1355,256),(1356,256),(1357,256),(1358,256),(1359,257),(1360,257),(1361,257),(1362,257),(1363,258),(1364,258),(1365,258),(1366,258),(1367,259),(1368,259),(1369,259),(1370,259),(1371,260),(1372,260),(1373,260),(1374,260),(1375,261),(1376,261),(1377,261),(1378,261),(1379,262),(1380,262),(1381,262),(1382,262),(1383,263),(1384,263),(1385,263),(1386,263),(1387,264),(1388,264),(1389,264),(1390,264),(1391,265),(1392,265),(1393,265),(1394,265),(1395,266),(1396,266),(1397,266),(1398,266),(1399,267),(1400,267),(1401,267),(1402,267),(1403,268),(1404,268),(1405,268),(1406,268),(1407,269),(1408,269),(1409,269),(1410,269),(1411,270),(1412,270),(1413,270),(1414,270),(1415,271),(1416,271),(1417,271),(1418,271),(1419,272),(1420,272),(1421,272),(1422,272),(1423,273),(1424,273),(1425,273),(1426,273),(1427,274),(1428,274),(1429,274),(1430,274),(1431,275),(1432,275),(1433,275),(1434,275),(1435,276),(1436,276),(1437,276),(1438,276),(1439,277),(1440,277),(1441,277),(1442,277),(1443,278),(1444,278),(1445,278),(1446,278),(1447,279),(1448,279),(1449,279),(1450,279),(1451,280),(1452,280),(1453,280),(1454,280),(1455,7),(1456,8),(1457,9),(1458,10),(1459,11),(1460,12),(1461,13),(1462,14),(1463,15),(1464,16),(1465,17),(1466,18),(1467,19),(1468,20),(1469,21),(1470,22),(1471,23),(1472,24),(1473,25),(1474,26),(1475,27),(1476,28),(1477,29),(1478,30),(1479,31),(1480,32),(1481,33),(1482,34),(1483,35),(1484,36),(1485,37),(1486,38),(1487,39),(1488,40),(1489,41),(1490,42),(1491,43),(1492,44),(1493,45),(1494,46),(1495,47),(1496,48),(1497,49),(1498,50),(1499,51),(1500,52),(1501,53),(1502,54),(1503,55),(1504,56),(1505,57),(1506,58),(1507,59),(1508,60),(1509,61),(1510,62),(1511,63),(1512,64),(1513,65),(1514,66),(1515,67),(1516,68),(1517,69),(1518,70),(1519,71),(1520,72),(1521,73),(1522,74),(1523,75),(1524,76),(1525,77),(1526,78),(1527,79),(1528,80),(1529,81),(1530,82),(1531,83),(1532,84),(1533,85),(1534,86),(1535,87),(1536,88),(1537,89),(1538,90),(1539,91),(1540,92),(1541,93),(1542,94),(1543,95),(1544,96),(1545,97),(1546,98),(1547,99),(1548,100),(1549,101),(1550,102),(1551,103),(1552,104),(1553,105),(1554,106),(1555,107),(1556,108),(1557,109),(1558,110),(1559,111),(1560,112),(1561,113),(1562,114),(1563,115),(1564,116),(1565,117),(1566,118),(1567,119),(1568,120),(1569,121),(1570,122),(1571,123),(1572,124),(1573,125),(1574,126),(1575,127),(1576,128),(1577,129),(1578,130),(1579,131),(1580,132),(1581,133),(1582,134),(1583,135),(1584,136),(1585,137),(1586,138),(1587,139),(1588,140),(1589,141),(1590,142),(1591,143),(1592,144),(1593,145),(1594,146),(1595,147),(1596,148),(1597,149),(1598,150),(1599,151),(1600,152),(1601,153),(1602,154),(1603,155),(1604,156),(1605,157),(1606,158),(1607,159),(1608,160),(1609,161),(1610,162),(1611,163),(1612,164),(1613,165),(1614,166),(1615,167),(1616,168),(1617,169),(1618,170),(1619,171),(1620,172),(1621,173),(1622,174),(1623,175),(1624,176),(1625,177),(1626,178),(1627,179),(1628,180),(1629,181),(1630,182),(1631,183),(1632,184),(1633,185),(1634,186),(1635,187),(1636,188),(1637,189),(1638,190),(1639,191),(1640,192),(1641,193),(1642,194),(1643,195),(1644,196),(1645,197),(1646,198),(1647,199),(1648,200),(1649,201),(1650,202),(1651,203),(1652,204),(1653,205),(1654,206),(1655,207),(1656,208),(1657,209),(1658,210),(1659,211),(1660,212),(1661,213),(1662,214),(1663,215),(1664,216),(1665,217),(1666,218),(1667,219),(1668,220),(1669,221),(1670,222),(1671,223),(1672,224),(1673,225),(1674,226),(1675,227),(1676,228),(1677,229),(1678,230),(1679,231),(1680,232),(1681,233),(1682,234),(1683,235),(1684,236),(1685,237),(1686,238),(1687,239),(1688,240),(1689,241),(1690,242),(1691,243),(1692,244),(1693,245),(1694,246),(1695,247),(1696,248),(1697,249),(1698,251),(1699,252),(1700,253),(1701,254),(1702,255),(1703,256),(1704,257),(1705,258),(1706,259),(1707,260),(1708,261),(1709,262),(1710,263),(1711,264),(1712,265),(1713,266),(1714,267),(1715,268),(1716,269),(1717,270),(1718,271),(1719,272),(1720,273),(1721,274),(1722,275),(1723,276),(1724,277),(1725,278),(1726,279),(1727,280),(1728,250),(1729,281),(1730,282),(1731,283),(1732,284),(1733,285),(1734,286),(1735,287),(1736,288),(1737,289),(1738,290),(1739,291),(1740,292),(1741,293),(1742,294),(1743,295),(1744,296),(1745,297),(1746,298),(1747,299),(1748,300),(1749,301),(1750,302),(1751,303),(1752,304),(1753,305),(1754,306),(1755,307),(1756,308),(1757,309),(1758,310),(1759,311),(1760,312),(1761,313),(1762,314),(1763,315),(1764,316),(1765,317),(1766,318),(1767,319),(1768,320),(1769,321),(1770,322),(1771,323),(1772,324),(1773,325),(1774,326),(1775,327),(1776,328),(1777,329),(1778,330),(1779,331),(1780,332),(1781,333),(1782,334),(1783,335),(1784,336),(1785,337),(1786,338),(1787,339),(1788,340),(1789,341),(1790,342),(1791,343),(1792,344),(1793,345),(1794,346),(1795,347),(1796,348),(1797,349),(1798,350),(1799,351),(1800,352),(1801,353),(1802,354),(1803,355),(1804,356),(1805,357),(1806,358),(1807,359),(1808,360),(1809,361),(1810,362),(1811,363),(1812,364),(1813,365),(1814,366),(1815,367),(1816,368),(1817,369),(1818,370),(1819,371),(1820,372),(1821,373),(1822,374),(1823,375),(1824,376),(1825,377),(1826,378),(1827,379),(1828,380),(1829,281),(1830,281),(1831,282),(1832,282),(1833,283),(1834,283),(1835,284),(1836,284),(1837,285),(1838,285),(1839,286),(1840,286),(1841,287),(1842,287),(1843,288),(1844,288),(1845,289),(1846,289),(1847,290),(1848,290),(1849,291),(1850,291),(1851,292),(1852,292),(1853,293),(1854,293),(1855,294),(1856,294),(1857,295),(1858,295),(1859,296),(1860,296),(1861,297),(1862,297),(1863,298),(1864,298),(1865,299),(1866,299),(1867,300),(1868,300),(1869,301),(1870,301),(1871,302),(1872,302),(1873,303),(1874,303),(1875,304),(1876,304),(1877,305),(1878,305),(1879,306),(1880,306),(1881,307),(1882,307),(1883,308),(1884,308),(1885,309),(1886,309),(1887,310),(1888,310),(1889,311),(1890,311),(1891,312),(1892,312),(1893,313),(1894,313),(1895,314),(1896,314),(1897,315),(1898,315),(1899,316),(1900,316),(1901,317),(1902,317),(1903,318),(1904,318),(1905,319),(1906,319),(1907,320),(1908,320),(1909,321),(1910,321),(1911,322),(1912,322),(1913,323),(1914,323),(1915,324),(1916,324),(1917,325),(1918,325),(1919,326),(1920,326),(1921,327),(1922,327),(1923,328),(1924,328),(1925,329),(1926,329),(1927,330),(1928,330),(1929,331),(1930,331),(1931,332),(1932,332),(1933,333),(1934,333),(1935,334),(1936,334),(1937,335),(1938,335),(1939,336),(1940,336),(1941,337),(1942,337),(1943,338),(1944,338),(1945,339),(1946,339),(1947,340),(1948,340),(1949,341),(1950,341),(1951,342),(1952,342),(1953,343),(1954,343),(1955,344),(1956,344),(1957,345),(1958,345),(1959,346),(1960,346),(1961,347),(1962,347),(1963,348),(1964,348),(1965,349),(1966,349),(1967,350),(1968,350),(1969,351),(1970,351),(1971,352),(1972,352),(1973,353),(1974,353),(1975,354),(1976,354),(1977,355),(1978,355),(1979,356),(1980,356),(1981,357),(1982,357),(1983,358),(1984,358),(1985,359),(1986,359),(1987,360),(1988,360),(1989,361),(1990,361),(1991,362),(1992,362),(1993,363),(1994,363),(1995,364),(1996,364),(1997,365),(1998,365),(1999,366),(2000,366),(2001,367),(2002,367),(2003,368),(2004,368),(2005,369),(2006,369),(2007,370),(2008,370),(2009,371),(2010,371),(2011,372),(2012,372),(2013,373),(2014,373),(2015,374),(2016,374),(2017,375),(2018,375),(2019,376),(2020,376),(2021,377),(2022,377),(2023,378),(2024,378),(2025,379),(2026,379),(2027,380),(2028,380),(2029,281),(2030,281),(2031,281),(2032,281),(2033,282),(2034,282),(2035,282),(2036,282),(2037,283),(2038,283),(2039,283),(2040,283),(2041,284),(2042,284),(2043,284),(2044,284),(2045,285),(2046,285),(2047,285),(2048,285),(2049,286),(2050,286),(2051,286),(2052,286),(2053,287),(2054,287),(2055,287),(2056,287),(2057,288),(2058,288),(2059,288),(2060,288),(2061,289),(2062,289),(2063,289),(2064,289),(2065,290),(2066,290),(2067,290),(2068,290),(2069,291),(2070,291),(2071,291),(2072,291),(2073,292),(2074,292),(2075,292),(2076,292),(2077,293),(2078,293),(2079,293),(2080,293),(2081,294),(2082,294),(2083,294),(2084,294),(2085,295),(2086,295),(2087,295),(2088,295),(2089,296),(2090,296),(2091,296),(2092,296),(2093,297),(2094,297),(2095,297),(2096,297),(2097,298),(2098,298),(2099,298),(2100,298),(2101,299),(2102,299),(2103,299),(2104,299),(2105,300),(2106,300),(2107,300),(2108,300),(2109,301),(2110,301),(2111,301),(2112,301),(2113,302),(2114,302),(2115,302),(2116,302),(2117,303),(2118,303),(2119,303),(2120,303),(2121,304),(2122,304),(2123,304),(2124,304),(2125,305),(2126,305),(2127,305),(2128,305),(2129,306),(2130,306),(2131,306),(2132,306),(2133,307),(2134,307),(2135,307),(2136,307),(2137,308),(2138,308),(2139,308),(2140,308),(2141,309),(2142,309),(2143,309),(2144,309),(2145,310),(2146,310),(2147,310),(2148,310),(2149,311),(2150,311),(2151,311),(2152,311),(2153,312),(2154,312),(2155,312),(2156,312),(2157,313),(2158,313),(2159,313),(2160,313),(2161,314),(2162,314),(2163,314),(2164,314),(2165,315),(2166,315),(2167,315),(2168,315),(2169,316),(2170,316),(2171,316),(2172,316),(2173,317),(2174,317),(2175,317),(2176,317),(2177,318),(2178,318),(2179,318),(2180,318),(2181,319),(2182,319),(2183,319),(2184,319),(2185,320),(2186,320),(2187,320),(2188,320),(2189,321),(2190,321),(2191,321),(2192,321),(2193,322),(2194,322),(2195,322),(2196,322),(2197,323),(2198,323),(2199,323),(2200,323),(2201,324),(2202,324),(2203,324),(2204,324),(2205,325),(2206,325),(2207,325),(2208,325),(2209,326),(2210,326),(2211,326),(2212,326),(2213,327),(2214,327),(2215,327),(2216,327),(2217,328),(2218,328),(2219,328),(2220,328),(2221,329),(2222,329),(2223,329),(2224,329),(2225,330),(2226,330),(2227,330),(2228,330),(2229,331),(2230,331),(2231,331),(2232,331),(2233,332),(2234,332),(2235,332),(2236,332),(2237,333),(2238,333),(2239,333),(2240,333),(2241,334),(2242,334),(2243,334),(2244,334),(2245,335),(2246,335),(2247,335),(2248,335),(2249,336),(2250,336),(2251,336),(2252,336),(2253,337),(2254,337),(2255,337),(2256,337),(2257,338),(2258,338),(2259,338),(2260,338),(2261,339),(2262,339),(2263,339),(2264,339),(2265,340),(2266,340),(2267,340),(2268,340),(2269,341),(2270,341),(2271,341),(2272,341),(2273,342),(2274,342),(2275,342),(2276,342),(2277,343),(2278,343),(2279,343),(2280,343),(2281,344),(2282,344),(2283,344),(2284,344),(2285,345),(2286,345),(2287,345),(2288,345),(2289,346),(2290,346),(2291,346),(2292,346),(2293,347),(2294,347),(2295,347),(2296,347),(2297,348),(2298,348),(2299,348),(2300,348),(2301,349),(2302,349),(2303,349),(2304,349),(2305,350),(2306,350),(2307,350),(2308,350),(2309,351),(2310,351),(2311,351),(2312,351),(2313,352),(2314,352),(2315,352),(2316,352),(2317,353),(2318,353),(2319,353),(2320,353),(2321,354),(2322,354),(2323,354),(2324,354),(2325,355),(2326,355),(2327,355),(2328,355),(2329,356),(2330,356),(2331,356),(2332,356),(2333,357),(2334,357),(2335,357),(2336,357),(2337,358),(2338,358),(2339,358),(2340,358),(2341,359),(2342,359),(2343,359),(2344,359),(2345,360),(2346,360),(2347,360),(2348,360),(2349,361),(2350,361),(2351,361),(2352,361),(2353,362),(2354,362),(2355,362),(2356,362),(2357,363),(2358,363),(2359,363),(2360,363),(2361,364),(2362,364),(2363,364),(2364,364),(2365,365),(2366,365),(2367,365),(2368,365),(2369,366),(2370,366),(2371,366),(2372,366),(2373,367),(2374,367),(2375,367),(2376,367),(2377,368),(2378,368),(2379,368),(2380,368),(2381,369),(2382,369),(2383,369),(2384,369),(2385,370),(2386,370),(2387,370),(2388,370),(2389,371),(2390,371),(2391,371),(2392,371),(2393,372),(2394,372),(2395,372),(2396,372),(2397,373),(2398,373),(2399,373),(2400,373),(2401,374),(2402,374),(2403,374),(2404,374),(2405,375),(2406,375),(2407,375),(2408,375),(2409,376),(2410,376),(2411,376),(2412,376),(2413,377),(2414,377),(2415,377),(2416,377),(2417,378),(2418,378),(2419,378),(2420,378),(2421,379),(2422,379),(2423,379),(2424,379),(2425,380),(2426,380),(2427,380),(2428,380),(2429,381),(2430,382),(2431,383),(2432,384),(2433,385),(2434,386),(2435,387),(2436,388),(2437,389),(2438,390),(2439,391),(2440,392),(2441,393),(2442,394),(2443,395),(2444,396),(2445,397),(2446,398),(2447,399),(2448,400),(2449,401),(2450,402),(2451,403),(2452,404),(2453,405),(2454,406),(2455,407),(2456,408),(2457,409),(2458,410),(2459,411),(2460,412),(2461,413),(2462,414),(2463,415),(2464,416),(2465,417),(2466,418),(2467,419),(2468,420),(2469,421),(2470,422),(2471,423),(2472,424),(2473,425),(2474,426),(2475,427),(2476,428),(2477,429),(2478,430),(2479,431),(2480,432),(2481,433),(2482,434),(2483,435),(2484,436),(2485,437),(2486,438),(2487,439),(2488,440),(2489,441),(2490,442),(2491,443),(2492,444),(2493,445),(2494,446),(2495,447),(2496,448),(2497,449),(2498,450),(2499,451),(2500,452),(2501,453),(2502,454),(2503,455),(2504,456),(2505,457),(2506,458),(2507,459),(2508,460),(2509,461),(2510,462),(2511,463),(2512,464),(2513,465),(2514,466),(2515,467),(2516,468),(2517,469),(2518,470),(2519,471),(2520,472),(2521,473),(2522,474),(2523,475),(2524,476),(2525,477),(2526,478),(2527,479),(2528,480),(2529,381),(2530,381),(2531,382),(2532,382),(2533,383),(2534,383),(2535,384),(2536,384),(2537,385),(2538,385),(2539,386),(2540,386),(2541,387),(2542,387),(2543,388),(2544,388),(2545,389),(2546,389),(2547,390),(2548,390),(2549,391),(2550,391),(2551,392),(2552,392),(2553,393),(2554,393),(2555,394),(2556,394),(2557,395),(2558,395),(2559,396),(2560,396),(2561,397),(2562,397),(2563,398),(2564,398),(2565,399),(2566,399),(2567,400),(2568,400),(2569,401),(2570,401),(2571,402),(2572,402),(2573,403),(2574,403),(2575,404),(2576,404),(2577,405),(2578,405),(2579,406),(2580,406),(2581,407),(2582,407),(2583,408),(2584,408),(2585,409),(2586,409),(2587,410),(2588,410),(2589,411),(2590,411),(2591,412),(2592,412),(2593,413),(2594,413),(2595,414),(2596,414),(2597,415),(2598,415),(2599,416),(2600,416),(2601,417),(2602,417),(2603,418),(2604,418),(2605,419),(2606,419),(2607,420),(2608,420),(2609,421),(2610,421),(2611,422),(2612,422),(2613,423),(2614,423),(2615,424),(2616,424),(2617,425),(2618,425),(2619,426),(2620,426),(2621,427),(2622,427),(2623,428),(2624,428),(2625,429),(2626,429),(2627,430),(2628,430),(2629,431),(2630,431),(2631,432),(2632,432),(2633,433),(2634,433),(2635,434),(2636,434),(2637,435),(2638,435),(2639,436),(2640,436),(2641,437),(2642,437),(2643,438),(2644,438),(2645,439),(2646,439),(2647,440),(2648,440),(2649,441),(2650,441),(2651,442),(2652,442),(2653,443),(2654,443),(2655,444),(2656,444),(2657,445),(2658,445),(2659,446),(2660,446),(2661,447),(2662,447),(2663,448),(2664,448),(2665,449),(2666,449),(2667,450),(2668,450),(2669,451),(2670,451),(2671,452),(2672,452),(2673,453),(2674,453),(2675,454),(2676,454),(2677,455),(2678,455),(2679,456),(2680,456),(2681,457),(2682,457),(2683,458),(2684,458),(2685,459),(2686,459),(2687,460),(2688,460),(2689,461),(2690,461),(2691,462),(2692,462),(2693,463),(2694,463),(2695,464),(2696,464),(2697,465),(2698,465),(2699,466),(2700,466),(2701,467),(2702,467),(2703,468),(2704,468),(2705,469),(2706,469),(2707,470),(2708,470),(2709,471),(2710,471),(2711,472),(2712,472),(2713,473),(2714,473),(2715,474),(2716,474),(2717,475),(2718,475),(2719,476),(2720,476),(2721,477),(2722,477),(2723,478),(2724,478),(2725,479),(2726,479),(2727,480),(2728,480),(2729,381),(2730,381),(2731,381),(2732,381),(2733,382),(2734,382),(2735,382),(2736,382),(2737,383),(2738,383),(2739,383),(2740,383),(2741,384),(2742,384),(2743,384),(2744,384),(2745,385),(2746,385),(2747,385),(2748,385),(2749,386),(2750,386),(2751,386),(2752,386),(2753,387),(2754,387),(2755,387),(2756,387),(2757,388),(2758,388),(2759,388),(2760,388),(2761,389),(2762,389),(2763,389),(2764,389),(2765,390),(2766,390),(2767,390),(2768,390),(2769,391),(2770,391),(2771,391),(2772,391),(2773,392),(2774,392),(2775,392),(2776,392),(2777,393),(2778,393),(2779,393),(2780,393),(2781,394),(2782,394),(2783,394),(2784,394),(2785,395),(2786,395),(2787,395),(2788,395),(2789,396),(2790,396),(2791,396),(2792,396),(2793,397),(2794,397),(2795,397),(2796,397),(2797,398),(2798,398),(2799,398),(2800,398),(2801,399),(2802,399),(2803,399),(2804,399),(2805,400),(2806,400),(2807,400),(2808,400),(2809,401),(2810,401),(2811,401),(2812,401),(2813,402),(2814,402),(2815,402),(2816,402),(2817,403),(2818,403),(2819,403),(2820,403),(2821,404),(2822,404),(2823,404),(2824,404),(2825,405),(2826,405),(2827,405),(2828,405),(2829,406),(2830,406),(2831,406),(2832,406),(2833,407),(2834,407),(2835,407),(2836,407),(2837,408),(2838,408),(2839,408),(2840,408),(2841,409),(2842,409),(2843,409),(2844,409),(2845,410),(2846,410),(2847,410),(2848,410),(2849,411),(2850,411),(2851,411),(2852,411),(2853,412),(2854,412),(2855,412),(2856,412),(2857,413),(2858,413),(2859,413),(2860,413),(2861,414),(2862,414),(2863,414),(2864,414),(2865,415),(2866,415),(2867,415),(2868,415),(2869,416),(2870,416),(2871,416),(2872,416),(2873,417),(2874,417),(2875,417),(2876,417),(2877,418),(2878,418),(2879,418),(2880,418),(2881,419),(2882,419),(2883,419),(2884,419),(2885,420),(2886,420),(2887,420),(2888,420),(2889,421),(2890,421),(2891,421),(2892,421),(2893,422),(2894,422),(2895,422),(2896,422),(2897,423),(2898,423),(2899,423),(2900,423),(2901,424),(2902,424),(2903,424),(2904,424),(2905,425),(2906,425),(2907,425),(2908,425),(2909,426),(2910,426),(2911,426),(2912,426),(2913,427),(2914,427),(2915,427),(2916,427),(2917,428),(2918,428),(2919,428),(2920,428),(2921,429),(2922,429),(2923,429),(2924,429),(2925,430),(2926,430),(2927,430),(2928,430),(2929,431),(2930,431),(2931,431),(2932,431),(2933,432),(2934,432),(2935,432),(2936,432),(2937,433),(2938,433),(2939,433),(2940,433),(2941,434),(2942,434),(2943,434),(2944,434),(2945,435),(2946,435),(2947,435),(2948,435),(2949,436),(2950,436),(2951,436),(2952,436),(2953,437),(2954,437),(2955,437),(2956,437),(2957,438),(2958,438),(2959,438),(2960,438),(2961,439),(2962,439),(2963,439),(2964,439),(2965,440),(2966,440),(2967,440),(2968,440),(2969,441),(2970,441),(2971,441),(2972,441),(2973,442),(2974,442),(2975,442),(2976,442),(2977,443),(2978,443),(2979,443),(2980,443),(2981,444),(2982,444),(2983,444),(2984,444),(2985,445),(2986,445),(2987,445),(2988,445),(2989,446),(2990,446),(2991,446),(2992,446),(2993,447),(2994,447),(2995,447),(2996,447),(2997,448),(2998,448),(2999,448),(3000,448),(3001,449),(3002,449),(3003,449),(3004,449),(3005,450),(3006,450),(3007,450),(3008,450),(3009,451),(3010,451),(3011,451),(3012,451),(3013,452),(3014,452),(3015,452),(3016,452),(3017,453),(3018,453),(3019,453),(3020,453),(3021,454),(3022,454),(3023,454),(3024,454),(3025,455),(3026,455),(3027,455),(3028,455),(3029,456),(3030,456),(3031,456),(3032,456),(3033,457),(3034,457),(3035,457),(3036,457),(3037,458),(3038,458),(3039,458),(3040,458),(3041,459),(3042,459),(3043,459),(3044,459),(3045,460),(3046,460),(3047,460),(3048,460),(3049,461),(3050,461),(3051,461),(3052,461),(3053,462),(3054,462),(3055,462),(3056,462),(3057,463),(3058,463),(3059,463),(3060,463),(3061,464),(3062,464),(3063,464),(3064,464),(3065,465),(3066,465),(3067,465),(3068,465),(3069,466),(3070,466),(3071,466),(3072,466),(3073,467),(3074,467),(3075,467),(3076,467),(3077,468),(3078,468),(3079,468),(3080,468),(3081,469),(3082,469),(3083,469),(3084,469),(3085,470),(3086,470),(3087,470),(3088,470),(3089,471),(3090,471),(3091,471),(3092,471),(3093,472),(3094,472),(3095,472),(3096,472),(3097,473),(3098,473),(3099,473),(3100,473),(3101,474),(3102,474),(3103,474),(3104,474),(3105,475),(3106,475),(3107,475),(3108,475),(3109,476),(3110,476),(3111,476),(3112,476),(3113,477),(3114,477),(3115,477),(3116,477),(3117,478),(3118,478),(3119,478),(3120,478),(3121,479),(3122,479),(3123,479),(3124,479),(3125,480),(3126,480),(3127,480),(3128,480),(3129,481),(3130,482),(3131,483),(3132,484),(3133,485),(3134,486),(3135,487),(3136,488),(3137,489),(3138,490),(3139,491),(3140,492),(3141,493),(3142,494),(3143,495),(3144,496),(3145,497),(3146,498),(3147,499),(3148,500),(3149,501),(3150,502),(3151,503),(3152,504),(3153,505),(3154,506),(3155,507),(3156,508),(3157,509),(3158,510),(3159,511),(3160,512),(3161,513),(3162,514),(3163,515),(3164,516),(3165,517),(3166,518),(3167,519),(3168,520),(3169,521),(3170,522),(3171,523),(3172,524),(3173,525),(3174,526),(3175,527),(3176,528),(3177,529),(3178,530),(3179,531),(3180,532),(3181,533),(3182,534),(3183,535),(3184,536),(3185,537),(3186,538),(3187,539),(3188,540),(3189,541),(3190,542),(3191,543),(3192,544),(3193,545),(3194,546),(3195,547),(3196,548),(3197,549),(3198,550),(3199,551),(3200,552),(3201,553),(3202,554),(3203,555),(3204,556),(3205,557),(3206,558),(3207,559),(3208,560),(3209,561),(3210,562),(3211,563),(3212,564),(3213,565),(3214,566),(3215,567),(3216,568),(3217,569),(3218,570),(3219,571),(3220,572),(3221,573),(3222,574),(3223,575),(3224,576),(3225,577),(3226,578),(3227,579),(3228,580),(3229,481),(3230,481),(3231,482),(3232,482),(3233,483),(3234,483),(3235,484),(3236,484),(3237,485),(3238,485),(3239,486),(3240,486),(3241,487),(3242,487),(3243,488),(3244,488),(3245,489),(3246,489),(3247,490),(3248,490),(3249,491),(3250,491),(3251,492),(3252,492),(3253,493),(3254,493),(3255,494),(3256,494),(3257,495),(3258,495),(3259,496),(3260,496),(3261,497),(3262,497),(3263,498),(3264,498),(3265,499),(3266,499),(3267,500),(3268,500),(3269,501),(3270,501),(3271,502),(3272,502),(3273,503),(3274,503),(3275,504),(3276,504),(3277,505),(3278,505),(3279,506),(3280,506),(3281,507),(3282,507),(3283,508),(3284,508),(3285,509),(3286,509),(3287,510),(3288,510),(3289,511),(3290,511),(3291,512),(3292,512),(3293,513),(3294,513),(3295,514),(3296,514),(3297,515),(3298,515),(3299,516),(3300,516),(3301,517),(3302,517),(3303,518),(3304,518),(3305,519),(3306,519),(3307,520),(3308,520),(3309,521),(3310,521),(3311,522),(3312,522),(3313,523),(3314,523),(3315,524),(3316,524),(3317,525),(3318,525),(3319,526),(3320,526),(3321,527),(3322,527),(3323,528),(3324,528),(3325,529),(3326,529),(3327,530),(3328,530),(3329,531),(3330,531),(3331,532),(3332,532),(3333,533),(3334,533),(3335,534),(3336,534),(3337,535),(3338,535),(3339,536),(3340,536),(3341,537),(3342,537),(3343,538),(3344,538),(3345,539),(3346,539),(3347,540),(3348,540),(3349,541),(3350,541),(3351,542),(3352,542),(3353,543),(3354,543),(3355,544),(3356,544),(3357,545),(3358,545),(3359,546),(3360,546),(3361,547),(3362,547),(3363,548),(3364,548),(3365,549),(3366,549),(3367,550),(3368,550),(3369,551),(3370,551),(3371,552),(3372,552),(3373,553),(3374,553),(3375,554),(3376,554),(3377,555),(3378,555),(3379,556),(3380,556),(3381,557),(3382,557),(3383,558),(3384,558),(3385,559),(3386,559),(3387,560),(3388,560),(3389,561),(3390,561),(3391,562),(3392,562),(3393,563),(3394,563),(3395,564),(3396,564),(3397,565),(3398,565),(3399,566),(3400,566),(3401,567),(3402,567),(3403,568),(3404,568),(3405,569),(3406,569),(3407,570),(3408,570),(3409,571),(3410,571),(3411,572),(3412,572),(3413,573),(3414,573),(3415,574),(3416,574),(3417,575),(3418,575),(3419,576),(3420,576),(3421,577),(3422,577),(3423,578),(3424,578),(3425,579),(3426,579),(3427,580),(3428,580),(3429,481),(3430,481),(3431,481),(3432,481),(3433,482),(3434,482),(3435,482),(3436,482),(3437,483),(3438,483),(3439,483),(3440,483),(3441,484),(3442,484),(3443,484),(3444,484),(3445,485),(3446,485),(3447,485),(3448,485),(3449,486),(3450,486),(3451,486),(3452,486),(3453,487),(3454,487),(3455,487),(3456,487),(3457,488),(3458,488),(3459,488),(3460,488),(3461,489),(3462,489),(3463,489),(3464,489),(3465,490),(3466,490),(3467,490),(3468,490),(3469,491),(3470,491),(3471,491),(3472,491),(3473,492),(3474,492),(3475,492),(3476,492),(3477,493),(3478,493),(3479,493),(3480,493),(3481,494),(3482,494),(3483,494),(3484,494),(3485,495),(3486,495),(3487,495),(3488,495),(3489,496),(3490,496),(3491,496),(3492,496),(3493,497),(3494,497),(3495,497),(3496,497),(3497,498),(3498,498),(3499,498),(3500,498),(3501,499),(3502,499),(3503,499),(3504,499),(3505,500),(3506,500),(3507,500),(3508,500),(3509,501),(3510,501),(3511,501),(3512,501),(3513,502),(3514,502),(3515,502),(3516,502),(3517,503),(3518,503),(3519,503),(3520,503),(3521,504),(3522,504),(3523,504),(3524,504),(3525,505),(3526,505),(3527,505),(3528,505),(3529,506),(3530,506),(3531,506),(3532,506),(3533,507),(3534,507),(3535,507),(3536,507),(3537,508),(3538,508),(3539,508),(3540,508),(3541,509),(3542,509),(3543,509),(3544,509),(3545,510),(3546,510),(3547,510),(3548,510),(3549,511),(3550,511),(3551,511),(3552,511),(3553,512),(3554,512),(3555,512),(3556,512),(3557,513),(3558,513),(3559,513),(3560,513),(3561,514),(3562,514),(3563,514),(3564,514),(3565,515),(3566,515),(3567,515),(3568,515),(3569,516),(3570,516),(3571,516),(3572,516),(3573,517),(3574,517),(3575,517),(3576,517),(3577,518),(3578,518),(3579,518),(3580,518),(3581,519),(3582,519),(3583,519),(3584,519),(3585,520),(3586,520),(3587,520),(3588,520),(3589,521),(3590,521),(3591,521),(3592,521),(3593,522),(3594,522),(3595,522),(3596,522),(3597,523),(3598,523),(3599,523),(3600,523),(3601,524),(3602,524),(3603,524),(3604,524),(3605,525),(3606,525),(3607,525),(3608,525),(3609,526),(3610,526),(3611,526),(3612,526),(3613,527),(3614,527),(3615,527),(3616,527),(3617,528),(3618,528),(3619,528),(3620,528),(3621,529),(3622,529),(3623,529),(3624,529),(3625,530),(3626,530),(3627,530),(3628,530),(3629,531),(3630,531),(3631,531),(3632,531),(3633,532),(3634,532),(3635,532),(3636,532),(3637,533),(3638,533),(3639,533),(3640,533),(3641,534),(3642,534),(3643,534),(3644,534),(3645,535),(3646,535),(3647,535),(3648,535),(3649,536),(3650,536),(3651,536),(3652,536),(3653,537),(3654,537),(3655,537),(3656,537),(3657,538),(3658,538),(3659,538),(3660,538),(3661,539),(3662,539),(3663,539),(3664,539),(3665,540),(3666,540),(3667,540),(3668,540),(3669,541),(3670,541),(3671,541),(3672,541),(3673,542),(3674,542),(3675,542),(3676,542),(3677,543),(3678,543),(3679,543),(3680,543),(3681,544),(3682,544),(3683,544),(3684,544),(3685,545),(3686,545),(3687,545),(3688,545),(3689,546),(3690,546),(3691,546),(3692,546),(3693,547),(3694,547),(3695,547),(3696,547),(3697,548),(3698,548),(3699,548),(3700,548),(3701,549),(3702,549),(3703,549),(3704,549),(3705,550),(3706,550),(3707,550),(3708,550),(3709,551),(3710,551),(3711,551),(3712,551),(3713,552),(3714,552),(3715,552),(3716,552),(3717,553),(3718,553),(3719,553),(3720,553),(3721,554),(3722,554),(3723,554),(3724,554),(3725,555),(3726,555),(3727,555),(3728,555),(3729,556),(3730,556),(3731,556),(3732,556),(3733,557),(3734,557),(3735,557),(3736,557),(3737,558),(3738,558),(3739,558),(3740,558),(3741,559),(3742,559),(3743,559),(3744,559),(3745,560),(3746,560),(3747,560),(3748,560),(3749,561),(3750,561),(3751,561),(3752,561),(3753,562),(3754,562),(3755,562),(3756,562),(3757,563),(3758,563),(3759,563),(3760,563),(3761,564),(3762,564),(3763,564),(3764,564),(3765,565),(3766,565),(3767,565),(3768,565),(3769,566),(3770,566),(3771,566),(3772,566),(3773,567),(3774,567),(3775,567),(3776,567),(3777,568),(3778,568),(3779,568),(3780,568),(3781,569),(3782,569),(3783,569),(3784,569),(3785,570),(3786,570),(3787,570),(3788,570),(3789,571),(3790,571),(3791,571),(3792,571),(3793,572),(3794,572),(3795,572),(3796,572),(3797,573),(3798,573),(3799,573),(3800,573),(3801,574),(3802,574),(3803,574),(3804,574),(3805,575),(3806,575),(3807,575),(3808,575),(3809,576),(3810,576),(3811,576),(3812,576),(3813,577),(3814,577),(3815,577),(3816,577),(3817,578),(3818,578),(3819,578),(3820,578),(3821,579),(3822,579),(3823,579),(3824,579),(3825,580),(3826,580),(3827,580),(3828,580),(3829,581),(3830,582),(3831,583),(3832,584),(3833,585),(3834,586),(3835,587),(3836,588),(3837,589),(3838,590),(3839,591),(3840,592),(3841,593),(3842,594),(3843,595),(3844,596),(3845,597),(3846,598),(3847,599),(3848,600),(3849,601),(3850,602),(3851,603),(3852,604),(3853,605),(3854,606),(3855,607),(3856,608),(3857,609),(3858,610),(3859,611),(3860,612),(3861,613),(3862,614),(3863,615),(3864,616),(3865,617),(3866,618),(3867,619),(3868,620),(3869,621),(3870,622),(3871,623),(3872,624),(3873,625),(3874,626),(3875,627),(3876,628),(3877,629),(3878,630),(3879,631),(3880,632),(3881,633),(3882,634),(3883,635),(3884,636),(3885,637),(3886,638),(3887,639),(3888,640),(3889,641),(3890,642),(3891,643),(3892,644),(3893,645),(3894,646),(3895,647),(3896,648),(3897,649),(3898,650),(3899,651),(3900,652),(3901,653),(3902,654),(3903,655),(3904,656),(3905,657),(3906,658),(3907,659),(3908,660),(3909,661),(3910,662),(3911,663),(3912,664),(3913,665),(3914,666),(3915,667),(3916,668),(3917,669),(3918,670),(3919,671),(3920,672),(3921,673),(3922,674),(3923,675),(3924,676),(3925,677),(3926,678),(3927,679),(3928,680),(3929,581),(3930,581),(3931,582),(3932,582),(3933,583),(3934,583),(3935,584),(3936,584),(3937,585),(3938,585),(3939,586),(3940,586),(3941,587),(3942,587),(3943,588),(3944,588),(3945,589),(3946,589),(3947,590),(3948,590),(3949,591),(3950,591),(3951,592),(3952,592),(3953,593),(3954,593),(3955,594),(3956,594),(3957,595),(3958,595),(3959,596),(3960,596),(3961,597),(3962,597),(3963,598),(3964,598),(3965,599),(3966,599),(3967,600),(3968,600),(3969,601),(3970,601),(3971,602),(3972,602),(3973,603),(3974,603),(3975,604),(3976,604),(3977,605),(3978,605),(3979,606),(3980,606),(3981,607),(3982,607),(3983,608),(3984,608),(3985,609),(3986,609),(3987,610),(3988,610),(3989,611),(3990,611),(3991,612),(3992,612),(3993,613),(3994,613),(3995,614),(3996,614),(3997,615),(3998,615),(3999,616),(4000,616),(4001,617),(4002,617),(4003,618),(4004,618),(4005,619),(4006,619),(4007,620),(4008,620),(4009,621),(4010,621),(4011,622),(4012,622),(4013,623),(4014,623),(4015,624),(4016,624),(4017,625),(4018,625),(4019,626),(4020,626),(4021,627),(4022,627),(4023,628),(4024,628),(4025,629),(4026,629),(4027,630),(4028,630),(4029,631),(4030,631),(4031,632),(4032,632),(4033,633),(4034,633),(4035,634),(4036,634),(4037,635),(4038,635),(4039,636),(4040,636),(4041,637),(4042,637),(4043,638),(4044,638),(4045,639),(4046,639),(4047,640),(4048,640),(4049,641),(4050,641),(4051,642),(4052,642),(4053,643),(4054,643),(4055,644),(4056,644),(4057,645),(4058,645),(4059,646),(4060,646),(4061,647),(4062,647),(4063,648),(4064,648),(4065,649),(4066,649),(4067,650),(4068,650),(4069,651),(4070,651),(4071,652),(4072,652),(4073,653),(4074,653),(4075,654),(4076,654),(4077,655),(4078,655),(4079,656),(4080,656),(4081,657),(4082,657),(4083,658),(4084,658),(4085,659),(4086,659),(4087,660),(4088,660),(4089,661),(4090,661),(4091,662),(4092,662),(4093,663),(4094,663),(4095,664),(4096,664),(4097,665),(4098,665),(4099,666),(4100,666),(4101,667),(4102,667),(4103,668),(4104,668),(4105,669),(4106,669),(4107,670),(4108,670),(4109,671),(4110,671),(4111,672),(4112,672),(4113,673),(4114,673),(4115,674),(4116,674),(4117,675),(4118,675),(4119,676),(4120,676),(4121,677),(4122,677),(4123,678),(4124,678),(4125,679),(4126,679),(4127,680),(4128,680),(4129,581),(4130,581),(4131,581),(4132,581),(4133,582),(4134,582),(4135,582),(4136,582),(4137,583),(4138,583),(4139,583),(4140,583),(4141,584),(4142,584),(4143,584),(4144,584),(4145,585),(4146,585),(4147,585),(4148,585),(4149,586),(4150,586),(4151,586),(4152,586),(4153,587),(4154,587),(4155,587),(4156,587),(4157,588),(4158,588),(4159,588),(4160,588),(4161,589),(4162,589),(4163,589),(4164,589),(4165,590),(4166,590),(4167,590),(4168,590),(4169,591),(4170,591),(4171,591),(4172,591),(4173,592),(4174,592),(4175,592),(4176,592),(4177,593),(4178,593),(4179,593),(4180,593),(4181,594),(4182,594),(4183,594),(4184,594),(4185,595),(4186,595),(4187,595),(4188,595),(4189,596),(4190,596),(4191,596),(4192,596),(4193,597),(4194,597),(4195,597),(4196,597),(4197,598),(4198,598),(4199,598),(4200,598),(4201,599),(4202,599),(4203,599),(4204,599),(4205,600),(4206,600),(4207,600),(4208,600),(4209,601),(4210,601),(4211,601),(4212,601),(4213,602),(4214,602),(4215,602),(4216,602),(4217,603),(4218,603),(4219,603),(4220,603),(4221,604),(4222,604),(4223,604),(4224,604),(4225,605),(4226,605),(4227,605),(4228,605),(4229,606),(4230,606),(4231,606),(4232,606),(4233,607),(4234,607),(4235,607),(4236,607),(4237,608),(4238,608),(4239,608),(4240,608),(4241,609),(4242,609),(4243,609),(4244,609),(4245,610),(4246,610),(4247,610),(4248,610),(4249,611),(4250,611),(4251,611),(4252,611),(4253,612),(4254,612),(4255,612),(4256,612),(4257,613),(4258,613),(4259,613),(4260,613),(4261,614),(4262,614),(4263,614),(4264,614),(4265,615),(4266,615),(4267,615),(4268,615),(4269,616),(4270,616),(4271,616),(4272,616),(4273,617),(4274,617),(4275,617),(4276,617),(4277,618),(4278,618),(4279,618),(4280,618),(4281,619),(4282,619),(4283,619),(4284,619),(4285,620),(4286,620),(4287,620),(4288,620),(4289,621),(4290,621),(4291,621),(4292,621),(4293,622),(4294,622),(4295,622),(4296,622),(4297,623),(4298,623),(4299,623),(4300,623),(4301,624),(4302,624),(4303,624),(4304,624),(4305,625),(4306,625),(4307,625),(4308,625),(4309,626),(4310,626),(4311,626),(4312,626),(4313,627),(4314,627),(4315,627),(4316,627),(4317,628),(4318,628),(4319,628),(4320,628),(4321,629),(4322,629),(4323,629),(4324,629),(4325,630),(4326,630),(4327,630),(4328,630),(4329,631),(4330,631),(4331,631),(4332,631),(4333,632),(4334,632),(4335,632),(4336,632),(4337,633),(4338,633),(4339,633),(4340,633),(4341,634),(4342,634),(4343,634),(4344,634),(4345,635),(4346,635),(4347,635),(4348,635),(4349,636),(4350,636),(4351,636),(4352,636),(4353,637),(4354,637),(4355,637),(4356,637),(4357,638),(4358,638),(4359,638),(4360,638),(4361,639),(4362,639),(4363,639),(4364,639),(4365,640),(4366,640),(4367,640),(4368,640),(4369,641),(4370,641),(4371,641),(4372,641),(4373,642),(4374,642),(4375,642),(4376,642),(4377,643),(4378,643),(4379,643),(4380,643),(4381,644),(4382,644),(4383,644),(4384,644),(4385,645),(4386,645),(4387,645),(4388,645),(4389,646),(4390,646),(4391,646),(4392,646),(4393,647),(4394,647),(4395,647),(4396,647),(4397,648),(4398,648),(4399,648),(4400,648),(4401,649),(4402,649),(4403,649),(4404,649),(4405,650),(4406,650),(4407,650),(4408,650),(4409,651),(4410,651),(4411,651),(4412,651),(4413,652),(4414,652),(4415,652),(4416,652),(4417,653),(4418,653),(4419,653),(4420,653),(4421,654),(4422,654),(4423,654),(4424,654),(4425,655),(4426,655),(4427,655),(4428,655),(4429,656),(4430,656),(4431,656),(4432,656),(4433,657),(4434,657),(4435,657),(4436,657),(4437,658),(4438,658),(4439,658),(4440,658),(4441,659),(4442,659),(4443,659),(4444,659),(4445,660),(4446,660),(4447,660),(4448,660),(4449,661),(4450,661),(4451,661),(4452,661),(4453,662),(4454,662),(4455,662),(4456,662),(4457,663),(4458,663),(4459,663),(4460,663),(4461,664),(4462,664),(4463,664),(4464,664),(4465,665),(4466,665),(4467,665),(4468,665),(4469,666),(4470,666),(4471,666),(4472,666),(4473,667),(4474,667),(4475,667),(4476,667),(4477,668),(4478,668),(4479,668),(4480,668),(4481,669),(4482,669),(4483,669),(4484,669),(4485,670),(4486,670),(4487,670),(4488,670),(4489,671),(4490,671),(4491,671),(4492,671),(4493,672),(4494,672),(4495,672),(4496,672),(4497,673),(4498,673),(4499,673),(4500,673),(4501,674),(4502,674),(4503,674),(4504,674),(4505,675),(4506,675),(4507,675),(4508,675),(4509,676),(4510,676),(4511,676),(4512,676),(4513,677),(4514,677),(4515,677),(4516,677),(4517,678),(4518,678),(4519,678),(4520,678),(4521,679),(4522,679),(4523,679),(4524,679),(4525,680),(4526,680),(4527,680),(4528,680),(4529,681),(4530,682),(4531,683),(4532,684),(4533,685),(4534,686),(4535,687),(4536,688),(4537,689),(4538,690),(4539,691),(4540,692),(4541,693),(4542,694),(4543,695),(4544,696),(4545,697),(4546,698),(4547,699),(4548,700),(4549,701),(4550,702),(4551,703),(4552,704),(4553,705),(4554,706),(4555,707),(4556,708),(4557,709),(4558,710),(4559,711),(4560,712),(4561,713),(4562,714),(4563,715),(4564,716),(4565,717),(4566,718),(4567,719),(4568,720),(4569,721),(4570,722),(4571,723),(4572,724),(4573,725),(4574,726),(4575,727),(4576,728),(4577,729),(4578,730),(4579,731),(4580,732),(4581,733),(4582,734),(4583,735),(4584,736),(4585,737),(4586,738),(4587,739),(4588,740),(4589,741),(4590,742),(4591,743),(4592,744),(4593,745),(4594,746),(4595,747),(4596,748),(4597,749),(4598,750),(4599,751),(4600,752),(4601,753),(4602,754),(4603,755),(4604,756),(4605,757),(4606,758),(4607,759),(4608,760),(4609,761),(4610,762),(4611,763),(4612,764),(4613,765),(4614,766),(4615,767),(4616,768),(4617,769),(4618,770),(4619,771),(4620,772),(4621,773),(4622,774),(4623,775),(4624,776),(4625,777),(4626,778),(4627,779),(4628,780),(4629,681),(4630,681),(4631,682),(4632,682),(4633,683),(4634,683),(4635,684),(4636,684),(4637,685),(4638,685),(4639,686),(4640,686),(4641,687),(4642,687),(4643,688),(4644,688),(4645,689),(4646,689),(4647,690),(4648,690),(4649,691),(4650,691),(4651,692),(4652,692),(4653,693),(4654,693),(4655,694),(4656,694),(4657,695),(4658,695),(4659,696),(4660,696),(4661,697),(4662,697),(4663,698),(4664,698),(4665,699),(4666,699),(4667,700),(4668,700),(4669,701),(4670,701),(4671,702),(4672,702),(4673,703),(4674,703),(4675,704),(4676,704),(4677,705),(4678,705),(4679,706),(4680,706),(4681,707),(4682,707),(4683,708),(4684,708),(4685,709),(4686,709),(4687,710),(4688,710),(4689,711),(4690,711),(4691,712),(4692,712),(4693,713),(4694,713),(4695,714),(4696,714),(4697,715),(4698,715),(4699,716),(4700,716),(4701,717),(4702,717),(4703,718),(4704,718),(4705,719),(4706,719),(4707,720),(4708,720),(4709,721),(4710,721),(4711,722),(4712,722),(4713,723),(4714,723),(4715,724),(4716,724),(4717,725),(4718,725),(4719,726),(4720,726),(4721,727),(4722,727),(4723,728),(4724,728),(4725,729),(4726,729),(4727,730),(4728,730),(4729,731),(4730,731),(4731,732),(4732,732),(4733,733),(4734,733),(4735,734),(4736,734),(4737,735),(4738,735),(4739,736),(4740,736),(4741,737),(4742,737),(4743,738),(4744,738),(4745,739),(4746,739),(4747,740),(4748,740),(4749,741),(4750,741),(4751,742),(4752,742),(4753,743),(4754,743),(4755,744),(4756,744),(4757,745),(4758,745),(4759,746),(4760,746),(4761,747),(4762,747),(4763,748),(4764,748),(4765,749),(4766,749),(4767,750),(4768,750),(4769,751),(4770,751),(4771,752),(4772,752),(4773,753),(4774,753),(4775,754),(4776,754),(4777,755),(4778,755),(4779,756),(4780,756),(4781,757),(4782,757),(4783,758),(4784,758),(4785,759),(4786,759),(4787,760),(4788,760),(4789,761),(4790,761),(4791,762),(4792,762),(4793,763),(4794,763),(4795,764),(4796,764),(4797,765),(4798,765),(4799,766),(4800,766),(4801,767),(4802,767),(4803,768),(4804,768),(4805,769),(4806,769),(4807,770),(4808,770),(4809,771),(4810,771),(4811,772),(4812,772),(4813,773),(4814,773),(4815,774),(4816,774),(4817,775),(4818,775),(4819,776),(4820,776),(4821,777),(4822,777),(4823,778),(4824,778),(4825,779),(4826,779),(4827,780),(4828,780),(4829,681),(4830,681),(4831,681),(4832,681),(4833,682),(4834,682),(4835,682),(4836,682),(4837,683),(4838,683),(4839,683),(4840,683),(4841,684),(4842,684),(4843,684),(4844,684),(4845,685),(4846,685),(4847,685),(4848,685),(4849,686),(4850,686),(4851,686),(4852,686),(4853,687),(4854,687),(4855,687),(4856,687),(4857,688),(4858,688),(4859,688),(4860,688),(4861,689),(4862,689),(4863,689),(4864,689),(4865,690),(4866,690),(4867,690),(4868,690),(4869,691),(4870,691),(4871,691),(4872,691),(4873,692),(4874,692),(4875,692),(4876,692),(4877,693),(4878,693),(4879,693),(4880,693),(4881,694),(4882,694),(4883,694),(4884,694),(4885,695),(4886,695),(4887,695),(4888,695),(4889,696),(4890,696),(4891,696),(4892,696),(4893,697),(4894,697),(4895,697),(4896,697),(4897,698),(4898,698),(4899,698),(4900,698),(4901,699),(4902,699),(4903,699),(4904,699),(4905,700),(4906,700),(4907,700),(4908,700),(4909,701),(4910,701),(4911,701),(4912,701),(4913,702),(4914,702),(4915,702),(4916,702),(4917,703),(4918,703),(4919,703),(4920,703),(4921,704),(4922,704),(4923,704),(4924,704),(4925,705),(4926,705),(4927,705),(4928,705),(4929,706),(4930,706),(4931,706),(4932,706),(4933,707),(4934,707),(4935,707),(4936,707),(4937,708),(4938,708),(4939,708),(4940,708),(4941,709),(4942,709),(4943,709),(4944,709),(4945,710),(4946,710),(4947,710),(4948,710),(4949,711),(4950,711),(4951,711),(4952,711),(4953,712),(4954,712),(4955,712),(4956,712),(4957,713),(4958,713),(4959,713),(4960,713),(4961,714),(4962,714),(4963,714),(4964,714),(4965,715),(4966,715),(4967,715),(4968,715),(4969,716),(4970,716),(4971,716),(4972,716),(4973,717),(4974,717),(4975,717),(4976,717),(4977,718),(4978,718),(4979,718),(4980,718),(4981,719),(4982,719),(4983,719),(4984,719),(4985,720),(4986,720),(4987,720),(4988,720),(4989,721),(4990,721),(4991,721),(4992,721),(4993,722),(4994,722),(4995,722),(4996,722),(4997,723),(4998,723),(4999,723),(5000,723),(5001,724),(5002,724),(5003,724),(5004,724),(5005,725),(5006,725),(5007,725),(5008,725),(5009,726),(5010,726),(5011,726),(5012,726),(5013,727),(5014,727),(5015,727),(5016,727),(5017,728),(5018,728),(5019,728),(5020,728),(5021,729),(5022,729),(5023,729),(5024,729),(5025,730),(5026,730),(5027,730),(5028,730),(5029,731),(5030,731),(5031,731),(5032,731),(5033,732),(5034,732),(5035,732),(5036,732),(5037,733),(5038,733),(5039,733),(5040,733),(5041,734),(5042,734),(5043,734),(5044,734),(5045,735),(5046,735),(5047,735),(5048,735),(5049,736),(5050,736),(5051,736),(5052,736),(5053,737),(5054,737),(5055,737),(5056,737),(5057,738),(5058,738),(5059,738),(5060,738),(5061,739),(5062,739),(5063,739),(5064,739),(5065,740),(5066,740),(5067,740),(5068,740),(5069,741),(5070,741),(5071,741),(5072,741),(5073,742),(5074,742),(5075,742),(5076,742),(5077,743),(5078,743),(5079,743),(5080,743),(5081,744),(5082,744),(5083,744),(5084,744),(5085,745),(5086,745),(5087,745),(5088,745),(5089,746),(5090,746),(5091,746),(5092,746),(5093,747),(5094,747),(5095,747),(5096,747),(5097,748),(5098,748),(5099,748),(5100,748),(5101,749),(5102,749),(5103,749),(5104,749),(5105,750),(5106,750),(5107,750),(5108,750),(5109,751),(5110,751),(5111,751),(5112,751),(5113,752),(5114,752),(5115,752),(5116,752),(5117,753),(5118,753),(5119,753),(5120,753),(5121,754),(5122,754),(5123,754),(5124,754),(5125,755),(5126,755),(5127,755),(5128,755),(5129,756),(5130,756),(5131,756),(5132,756),(5133,757),(5134,757),(5135,757),(5136,757),(5137,758),(5138,758),(5139,758),(5140,758),(5141,759),(5142,759),(5143,759),(5144,759),(5145,760),(5146,760),(5147,760),(5148,760),(5149,761),(5150,761),(5151,761),(5152,761),(5153,762),(5154,762),(5155,762),(5156,762),(5157,763),(5158,763),(5159,763),(5160,763),(5161,764),(5162,764),(5163,764),(5164,764),(5165,765),(5166,765),(5167,765),(5168,765),(5169,766),(5170,766),(5171,766),(5172,766),(5173,767),(5174,767),(5175,767),(5176,767),(5177,768),(5178,768),(5179,768),(5180,768),(5181,769),(5182,769),(5183,769),(5184,769),(5185,770),(5186,770),(5187,770),(5188,770),(5189,771),(5190,771),(5191,771),(5192,771),(5193,772),(5194,772),(5195,772),(5196,772),(5197,773),(5198,773),(5199,773),(5200,773),(5201,774),(5202,774),(5203,774),(5204,774),(5205,775),(5206,775),(5207,775),(5208,775),(5209,776),(5210,776),(5211,776),(5212,776),(5213,777),(5214,777),(5215,777),(5216,777),(5217,778),(5218,778),(5219,778),(5220,778),(5221,779),(5222,779),(5223,779),(5224,779),(5225,780),(5226,780),(5227,780),(5228,780),(5229,781),(5230,782),(5231,783),(5232,784),(5233,785),(5234,786),(5235,787),(5236,788),(5237,789),(5238,790),(5239,791),(5240,792),(5241,793),(5242,794),(5243,795),(5244,796),(5245,797),(5246,798),(5247,799),(5248,800),(5249,801),(5250,802),(5251,803),(5252,804),(5253,805),(5254,806),(5255,807),(5256,808),(5257,809),(5258,810),(5259,811),(5260,812),(5261,813),(5262,814),(5263,815),(5264,816),(5265,817),(5266,818),(5267,819),(5268,820),(5269,821),(5270,822),(5271,823),(5272,824),(5273,825),(5274,826),(5275,827),(5276,828),(5277,829),(5278,830),(5279,831),(5280,832),(5281,833),(5282,834),(5283,835),(5284,836),(5285,837),(5286,838),(5287,839),(5288,840),(5289,841),(5290,842),(5291,843),(5292,844),(5293,845),(5294,846),(5295,847),(5296,848),(5297,849),(5298,850),(5299,851),(5300,852),(5301,853),(5302,854),(5303,855),(5304,856),(5305,857),(5306,858),(5307,859),(5308,860),(5309,861),(5310,862),(5311,863),(5312,864),(5313,865),(5314,866),(5315,867),(5316,868),(5317,869),(5318,870),(5319,871),(5320,872),(5321,873),(5322,874),(5323,875),(5324,876),(5325,877),(5326,878),(5327,879),(5328,880),(5329,781),(5330,781),(5331,782),(5332,782),(5333,783),(5334,783),(5335,784),(5336,784),(5337,785),(5338,785),(5339,786),(5340,786),(5341,787),(5342,787),(5343,788),(5344,788),(5345,789),(5346,789),(5347,790),(5348,790),(5349,791),(5350,791),(5351,792),(5352,792),(5353,793),(5354,793),(5355,794),(5356,794),(5357,795),(5358,795),(5359,796),(5360,796),(5361,797),(5362,797),(5363,798),(5364,798),(5365,799),(5366,799),(5367,800),(5368,800),(5369,801),(5370,801),(5371,802),(5372,802),(5373,803),(5374,803),(5375,804),(5376,804),(5377,805),(5378,805),(5379,806),(5380,806),(5381,807),(5382,807),(5383,808),(5384,808),(5385,809),(5386,809),(5387,810),(5388,810),(5389,811),(5390,811),(5391,812),(5392,812),(5393,813),(5394,813),(5395,814),(5396,814),(5397,815),(5398,815),(5399,816),(5400,816),(5401,817),(5402,817),(5403,818),(5404,818),(5405,819),(5406,819),(5407,820),(5408,820),(5409,821),(5410,821),(5411,822),(5412,822),(5413,823),(5414,823),(5415,824),(5416,824),(5417,825),(5418,825),(5419,826),(5420,826),(5421,827),(5422,827),(5423,828),(5424,828),(5425,829),(5426,829),(5427,830),(5428,830),(5429,831),(5430,831),(5431,832),(5432,832),(5433,833),(5434,833),(5435,834),(5436,834),(5437,835),(5438,835),(5439,836),(5440,836),(5441,837),(5442,837),(5443,838),(5444,838),(5445,839),(5446,839),(5447,840),(5448,840),(5449,841),(5450,841),(5451,842),(5452,842),(5453,843),(5454,843),(5455,844),(5456,844),(5457,845),(5458,845),(5459,846),(5460,846),(5461,847),(5462,847),(5463,848),(5464,848),(5465,849),(5466,849),(5467,850),(5468,850),(5469,851),(5470,851),(5471,852),(5472,852),(5473,853),(5474,853),(5475,854),(5476,854),(5477,855),(5478,855),(5479,856),(5480,856),(5481,857),(5482,857),(5483,858),(5484,858),(5485,859),(5486,859),(5487,860),(5488,860),(5489,861),(5490,861),(5491,862),(5492,862),(5493,863),(5494,863),(5495,864),(5496,864),(5497,865),(5498,865),(5499,866),(5500,866),(5501,867),(5502,867),(5503,868),(5504,868),(5505,869),(5506,869),(5507,870),(5508,870),(5509,871),(5510,871),(5511,872),(5512,872),(5513,873),(5514,873),(5515,874),(5516,874),(5517,875),(5518,875),(5519,876),(5520,876),(5521,877),(5522,877),(5523,878),(5524,878),(5525,879),(5526,879),(5527,880),(5528,880),(5529,781),(5530,781),(5531,781),(5532,781),(5533,782),(5534,782),(5535,782),(5536,782),(5537,783),(5538,783),(5539,783),(5540,783),(5541,784),(5542,784),(5543,784),(5544,784),(5545,785),(5546,785),(5547,785),(5548,785),(5549,786),(5550,786),(5551,786),(5552,786),(5553,787),(5554,787),(5555,787),(5556,787),(5557,788),(5558,788),(5559,788),(5560,788),(5561,789),(5562,789),(5563,789),(5564,789),(5565,790),(5566,790),(5567,790),(5568,790),(5569,791),(5570,791),(5571,791),(5572,791),(5573,792),(5574,792),(5575,792),(5576,792),(5577,793),(5578,793),(5579,793),(5580,793),(5581,794),(5582,794),(5583,794),(5584,794),(5585,795),(5586,795),(5587,795),(5588,795),(5589,796),(5590,796),(5591,796),(5592,796),(5593,797),(5594,797),(5595,797),(5596,797),(5597,798),(5598,798),(5599,798),(5600,798),(5601,799),(5602,799),(5603,799),(5604,799),(5605,800),(5606,800),(5607,800),(5608,800),(5609,801),(5610,801),(5611,801),(5612,801),(5613,802),(5614,802),(5615,802),(5616,802),(5617,803),(5618,803),(5619,803),(5620,803),(5621,804),(5622,804),(5623,804),(5624,804),(5625,805),(5626,805),(5627,805),(5628,805),(5629,806),(5630,806),(5631,806),(5632,806),(5633,807),(5634,807),(5635,807),(5636,807),(5637,808),(5638,808),(5639,808),(5640,808),(5641,809),(5642,809),(5643,809),(5644,809),(5645,810),(5646,810),(5647,810),(5648,810),(5649,811),(5650,811),(5651,811),(5652,811),(5653,812),(5654,812),(5655,812),(5656,812),(5657,813),(5658,813),(5659,813),(5660,813),(5661,814),(5662,814),(5663,814),(5664,814),(5665,815),(5666,815),(5667,815),(5668,815),(5669,816),(5670,816),(5671,816),(5672,816),(5673,817),(5674,817),(5675,817),(5676,817),(5677,818),(5678,818),(5679,818),(5680,818),(5681,819),(5682,819),(5683,819),(5684,819),(5685,820),(5686,820),(5687,820),(5688,820),(5689,821),(5690,821),(5691,821),(5692,821),(5693,822),(5694,822),(5695,822),(5696,822),(5697,823),(5698,823),(5699,823),(5700,823),(5701,824),(5702,824),(5703,824),(5704,824),(5705,825),(5706,825),(5707,825),(5708,825),(5709,826),(5710,826),(5711,826),(5712,826),(5713,827),(5714,827),(5715,827),(5716,827),(5717,828),(5718,828),(5719,828),(5720,828),(5721,829),(5722,829),(5723,829),(5724,829),(5725,830),(5726,830),(5727,830),(5728,830),(5729,831),(5730,831),(5731,831),(5732,831),(5733,832),(5734,832),(5735,832),(5736,832),(5737,833),(5738,833),(5739,833),(5740,833),(5741,834),(5742,834),(5743,834),(5744,834),(5745,835),(5746,835),(5747,835),(5748,835),(5749,836),(5750,836),(5751,836),(5752,836),(5753,837),(5754,837),(5755,837),(5756,837),(5757,838),(5758,838),(5759,838),(5760,838),(5761,839),(5762,839),(5763,839),(5764,839),(5765,840),(5766,840),(5767,840),(5768,840),(5769,841),(5770,841),(5771,841),(5772,841),(5773,842),(5774,842),(5775,842),(5776,842),(5777,843),(5778,843),(5779,843),(5780,843),(5781,844),(5782,844),(5783,844),(5784,844),(5785,845),(5786,845),(5787,845),(5788,845),(5789,846),(5790,846),(5791,846),(5792,846),(5793,847),(5794,847),(5795,847),(5796,847),(5797,848),(5798,848),(5799,848),(5800,848),(5801,849),(5802,849),(5803,849),(5804,849),(5805,850),(5806,850),(5807,850),(5808,850),(5809,851),(5810,851),(5811,851),(5812,851),(5813,852),(5814,852),(5815,852),(5816,852),(5817,853),(5818,853),(5819,853),(5820,853),(5821,854),(5822,854),(5823,854),(5824,854),(5825,855),(5826,855),(5827,855),(5828,855),(5829,856),(5830,856),(5831,856),(5832,856),(5833,857),(5834,857),(5835,857),(5836,857),(5837,858),(5838,858),(5839,858),(5840,858),(5841,859),(5842,859),(5843,859),(5844,859),(5845,860),(5846,860),(5847,860),(5848,860),(5849,861),(5850,861),(5851,861),(5852,861),(5853,862),(5854,862),(5855,862),(5856,862),(5857,863),(5858,863),(5859,863),(5860,863),(5861,864),(5862,864),(5863,864),(5864,864),(5865,865),(5866,865),(5867,865),(5868,865),(5869,866),(5870,866),(5871,866),(5872,866),(5873,867),(5874,867),(5875,867),(5876,867),(5877,868),(5878,868),(5879,868),(5880,868),(5881,869),(5882,869),(5883,869),(5884,869),(5885,870),(5886,870),(5887,870),(5888,870),(5889,871),(5890,871),(5891,871),(5892,871),(5893,872),(5894,872),(5895,872),(5896,872),(5897,873),(5898,873),(5899,873),(5900,873),(5901,874),(5902,874),(5903,874),(5904,874),(5905,875),(5906,875),(5907,875),(5908,875),(5909,876),(5910,876),(5911,876),(5912,876),(5913,877),(5914,877),(5915,877),(5916,877),(5917,878),(5918,878),(5919,878),(5920,878),(5921,879),(5922,879),(5923,879),(5924,879),(5925,880),(5926,880),(5927,880),(5928,880),(5929,881),(5930,882),(5931,883),(5932,884),(5933,885),(5934,886),(5935,887),(5936,888),(5937,889),(5938,890),(5939,891),(5940,892),(5941,893),(5942,894),(5943,895),(5944,896),(5945,897),(5946,898),(5947,899),(5948,900),(5949,901),(5950,902),(5951,903),(5952,904),(5953,905),(5954,906),(5955,907),(5956,908),(5957,909),(5958,910),(5959,911),(5960,912),(5961,913),(5962,914),(5963,915),(5964,916),(5965,917),(5966,918),(5967,919),(5968,920),(5969,921),(5970,922),(5971,923),(5972,924),(5973,925),(5974,926),(5975,927),(5976,928),(5977,929),(5978,930),(5979,931),(5980,932),(5981,933),(5982,934),(5983,935),(5984,936),(5985,937),(5986,938),(5987,939),(5988,940),(5989,941),(5990,942),(5991,943),(5992,944),(5993,945),(5994,946),(5995,947),(5996,948),(5997,949),(5998,950),(5999,951),(6000,952),(6001,953),(6002,954),(6003,955),(6004,956),(6005,957),(6006,958),(6007,959),(6008,960),(6009,961),(6010,962),(6011,963),(6012,964),(6013,965),(6014,966),(6015,967),(6016,968),(6017,969),(6018,970),(6019,971),(6020,972),(6021,973),(6022,974),(6023,975),(6024,976),(6025,977),(6026,978),(6027,979),(6028,980),(6029,881),(6030,881),(6031,882),(6032,882),(6033,883),(6034,883),(6035,884),(6036,884),(6037,885),(6038,885),(6039,886),(6040,886),(6041,887),(6042,887),(6043,888),(6044,888),(6045,889),(6046,889),(6047,890),(6048,890),(6049,891),(6050,891),(6051,892),(6052,892),(6053,893),(6054,893),(6055,894),(6056,894),(6057,895),(6058,895),(6059,896),(6060,896),(6061,897),(6062,897),(6063,898),(6064,898),(6065,899),(6066,899),(6067,900),(6068,900),(6069,901),(6070,901),(6071,902),(6072,902),(6073,903),(6074,903),(6075,904),(6076,904),(6077,905),(6078,905),(6079,906),(6080,906),(6081,907),(6082,907),(6083,908),(6084,908),(6085,909),(6086,909),(6087,910),(6088,910),(6089,911),(6090,911),(6091,912),(6092,912),(6093,913),(6094,913),(6095,914),(6096,914),(6097,915),(6098,915),(6099,916),(6100,916),(6101,917),(6102,917),(6103,918),(6104,918),(6105,919),(6106,919),(6107,920),(6108,920),(6109,921),(6110,921),(6111,922),(6112,922),(6113,923),(6114,923),(6115,924),(6116,924),(6117,925),(6118,925),(6119,926),(6120,926),(6121,927),(6122,927),(6123,928),(6124,928),(6125,929),(6126,929),(6127,930),(6128,930),(6129,931),(6130,931),(6131,932),(6132,932),(6133,933),(6134,933),(6135,934),(6136,934),(6137,935),(6138,935),(6139,936),(6140,936),(6141,937),(6142,937),(6143,938),(6144,938),(6145,939),(6146,939),(6147,940),(6148,940),(6149,941),(6150,941),(6151,942),(6152,942),(6153,943),(6154,943),(6155,944),(6156,944),(6157,945),(6158,945),(6159,946),(6160,946),(6161,947),(6162,947),(6163,948),(6164,948),(6165,949),(6166,949),(6167,950),(6168,950),(6169,951),(6170,951),(6171,952),(6172,952),(6173,953),(6174,953),(6175,954),(6176,954),(6177,955),(6178,955),(6179,956),(6180,956),(6181,957),(6182,957),(6183,958),(6184,958),(6185,959),(6186,959),(6187,960),(6188,960),(6189,961),(6190,961),(6191,962),(6192,962),(6193,963),(6194,963),(6195,964),(6196,964),(6197,965),(6198,965),(6199,966),(6200,966),(6201,967),(6202,967),(6203,968),(6204,968),(6205,969),(6206,969),(6207,970),(6208,970),(6209,971),(6210,971),(6211,972),(6212,972),(6213,973),(6214,973),(6215,974),(6216,974),(6217,975),(6218,975),(6219,976),(6220,976),(6221,977),(6222,977),(6223,978),(6224,978),(6225,979),(6226,979),(6227,980),(6228,980),(6229,881),(6230,881),(6231,881),(6232,881),(6233,882),(6234,882),(6235,882),(6236,882),(6237,883),(6238,883),(6239,883),(6240,883),(6241,884),(6242,884),(6243,884),(6244,884),(6245,885),(6246,885),(6247,885),(6248,885),(6249,886),(6250,886),(6251,886),(6252,886),(6253,887),(6254,887),(6255,887),(6256,887),(6257,888),(6258,888),(6259,888),(6260,888),(6261,889),(6262,889),(6263,889),(6264,889),(6265,890),(6266,890),(6267,890),(6268,890),(6269,891),(6270,891),(6271,891),(6272,891),(6273,892),(6274,892),(6275,892),(6276,892),(6277,893),(6278,893),(6279,893),(6280,893),(6281,894),(6282,894),(6283,894),(6284,894),(6285,895),(6286,895),(6287,895),(6288,895),(6289,896),(6290,896),(6291,896),(6292,896),(6293,897),(6294,897),(6295,897),(6296,897),(6297,898),(6298,898),(6299,898),(6300,898),(6301,899),(6302,899),(6303,899),(6304,899),(6305,900),(6306,900),(6307,900),(6308,900),(6309,901),(6310,901),(6311,901),(6312,901),(6313,902),(6314,902),(6315,902),(6316,902),(6317,903),(6318,903),(6319,903),(6320,903),(6321,904),(6322,904),(6323,904),(6324,904),(6325,905),(6326,905),(6327,905),(6328,905),(6329,906),(6330,906),(6331,906),(6332,906),(6333,907),(6334,907),(6335,907),(6336,907),(6337,908),(6338,908),(6339,908),(6340,908),(6341,909),(6342,909),(6343,909),(6344,909),(6345,910),(6346,910),(6347,910),(6348,910),(6349,911),(6350,911),(6351,911),(6352,911),(6353,912),(6354,912),(6355,912),(6356,912),(6357,913),(6358,913),(6359,913),(6360,913),(6361,914),(6362,914),(6363,914),(6364,914),(6365,915),(6366,915),(6367,915),(6368,915),(6369,916),(6370,916),(6371,916),(6372,916),(6373,917),(6374,917),(6375,917),(6376,917),(6377,918),(6378,918),(6379,918),(6380,918),(6381,919),(6382,919),(6383,919),(6384,919),(6385,920),(6386,920),(6387,920),(6388,920),(6389,921),(6390,921),(6391,921),(6392,921),(6393,922),(6394,922),(6395,922),(6396,922),(6397,923),(6398,923),(6399,923),(6400,923),(6401,924),(6402,924),(6403,924),(6404,924),(6405,925),(6406,925),(6407,925),(6408,925),(6409,926),(6410,926),(6411,926),(6412,926),(6413,927),(6414,927),(6415,927),(6416,927),(6417,928),(6418,928),(6419,928),(6420,928),(6421,929),(6422,929),(6423,929),(6424,929),(6425,930),(6426,930),(6427,930),(6428,930),(6429,931),(6430,931),(6431,931),(6432,931),(6433,932),(6434,932),(6435,932),(6436,932),(6437,933),(6438,933),(6439,933),(6440,933),(6441,934),(6442,934),(6443,934),(6444,934),(6445,935),(6446,935),(6447,935),(6448,935),(6449,936),(6450,936),(6451,936),(6452,936),(6453,937),(6454,937),(6455,937),(6456,937),(6457,938),(6458,938),(6459,938),(6460,938),(6461,939),(6462,939),(6463,939),(6464,939),(6465,940),(6466,940),(6467,940),(6468,940),(6469,941),(6470,941),(6471,941),(6472,941),(6473,942),(6474,942),(6475,942),(6476,942),(6477,943),(6478,943),(6479,943),(6480,943),(6481,944),(6482,944),(6483,944),(6484,944),(6485,945),(6486,945),(6487,945),(6488,945),(6489,946),(6490,946),(6491,946),(6492,946),(6493,947),(6494,947),(6495,947),(6496,947),(6497,948),(6498,948),(6499,948),(6500,948),(6501,949),(6502,949),(6503,949),(6504,949),(6505,950),(6506,950),(6507,950),(6508,950),(6509,951),(6510,951),(6511,951),(6512,951),(6513,952),(6514,952),(6515,952),(6516,952),(6517,953),(6518,953),(6519,953),(6520,953),(6521,954),(6522,954),(6523,954),(6524,954),(6525,955),(6526,955),(6527,955),(6528,955),(6529,956),(6530,956),(6531,956),(6532,956),(6533,957),(6534,957),(6535,957),(6536,957),(6537,958),(6538,958),(6539,958),(6540,958),(6541,959),(6542,959),(6543,959),(6544,959),(6545,960),(6546,960),(6547,960),(6548,960),(6549,961),(6550,961),(6551,961),(6552,961),(6553,962),(6554,962),(6555,962),(6556,962),(6557,963),(6558,963),(6559,963),(6560,963),(6561,964),(6562,964),(6563,964),(6564,964),(6565,965),(6566,965),(6567,965),(6568,965),(6569,966),(6570,966),(6571,966),(6572,966),(6573,967),(6574,967),(6575,967),(6576,967),(6577,968),(6578,968),(6579,968),(6580,968),(6581,969),(6582,969),(6583,969),(6584,969),(6585,970),(6586,970),(6587,970),(6588,970),(6589,971),(6590,971),(6591,971),(6592,971),(6593,972),(6594,972),(6595,972),(6596,972),(6597,973),(6598,973),(6599,973),(6600,973),(6601,974),(6602,974),(6603,974),(6604,974),(6605,975),(6606,975),(6607,975),(6608,975),(6609,976),(6610,976),(6611,976),(6612,976),(6613,977),(6614,977),(6615,977),(6616,977),(6617,978),(6618,978),(6619,978),(6620,978),(6621,979),(6622,979),(6623,979),(6624,979),(6625,980),(6626,980),(6627,980),(6628,980),(6629,981),(6630,982),(6631,983),(6632,984),(6633,985),(6634,986),(6635,987),(6636,988),(6637,989),(6638,990),(6639,991),(6640,992),(6641,993),(6642,994),(6643,995),(6644,996),(6645,997),(6646,998),(6647,999),(6648,1000),(6649,1001),(6650,1002),(6651,1003),(6652,1004),(6653,1005),(6654,1006),(6655,1007),(6656,1008),(6657,1009),(6658,1010),(6659,1011),(6660,1012),(6661,1013),(6662,1014),(6663,1015),(6664,1016),(6665,1017),(6666,1018),(6667,1019),(6668,1020),(6669,1021),(6670,1022),(6671,1023),(6672,1024),(6673,1025),(6674,1026),(6675,1027),(6676,1028),(6677,1029),(6678,1030),(6679,1031),(6680,1032),(6681,1033),(6682,1034),(6683,1035),(6684,1036),(6685,1037),(6686,1038),(6687,1039),(6688,1040),(6689,1041),(6690,1042),(6691,1043),(6692,1044),(6693,1045),(6694,1046),(6695,1047),(6696,1048),(6697,1049),(6698,1050),(6699,1051),(6700,1052),(6701,1053),(6702,1054),(6703,1055),(6704,1056),(6705,1057),(6706,1058),(6707,1059),(6708,1060),(6709,1061),(6710,1062),(6711,1063),(6712,1064),(6713,1065),(6714,1066),(6715,1067),(6716,1068),(6717,1069),(6718,1070),(6719,1071),(6720,1072),(6721,1073),(6722,1074),(6723,1075),(6724,1076),(6725,1077),(6726,1078),(6727,1079),(6728,1080),(6729,981),(6730,981),(6731,982),(6732,982),(6733,983),(6734,983),(6735,984),(6736,984),(6737,985),(6738,985),(6739,986),(6740,986),(6741,987),(6742,987),(6743,988),(6744,988),(6745,989),(6746,989),(6747,990),(6748,990),(6749,991),(6750,991),(6751,992),(6752,992),(6753,993),(6754,993),(6755,994),(6756,994),(6757,995),(6758,995),(6759,996),(6760,996),(6761,997),(6762,997),(6763,998),(6764,998),(6765,999),(6766,999),(6767,1000),(6768,1000),(6769,1001),(6770,1001),(6771,1002),(6772,1002),(6773,1003),(6774,1003),(6775,1004),(6776,1004),(6777,1005),(6778,1005),(6779,1006),(6780,1006),(6781,1007),(6782,1007),(6783,1008),(6784,1008),(6785,1009),(6786,1009),(6787,1010),(6788,1010),(6789,1011),(6790,1011),(6791,1012),(6792,1012),(6793,1013),(6794,1013),(6795,1014),(6796,1014),(6797,1015),(6798,1015),(6799,1016),(6800,1016),(6801,1017),(6802,1017),(6803,1018),(6804,1018),(6805,1019),(6806,1019),(6807,1020),(6808,1020),(6809,1021),(6810,1021),(6811,1022),(6812,1022),(6813,1023),(6814,1023),(6815,1024),(6816,1024),(6817,1025),(6818,1025),(6819,1026),(6820,1026),(6821,1027),(6822,1027),(6823,1028),(6824,1028),(6825,1029),(6826,1029),(6827,1030),(6828,1030),(6829,1031),(6830,1031),(6831,1032),(6832,1032),(6833,1033),(6834,1033),(6835,1034),(6836,1034),(6837,1035),(6838,1035),(6839,1036),(6840,1036),(6841,1037),(6842,1037),(6843,1038),(6844,1038),(6845,1039),(6846,1039),(6847,1040),(6848,1040),(6849,1041),(6850,1041),(6851,1042),(6852,1042),(6853,1043),(6854,1043),(6855,1044),(6856,1044),(6857,1045),(6858,1045),(6859,1046),(6860,1046),(6861,1047),(6862,1047),(6863,1048),(6864,1048),(6865,1049),(6866,1049),(6867,1050),(6868,1050),(6869,1051),(6870,1051),(6871,1052),(6872,1052),(6873,1053),(6874,1053),(6875,1054),(6876,1054),(6877,1055),(6878,1055),(6879,1056),(6880,1056),(6881,1057),(6882,1057),(6883,1058),(6884,1058),(6885,1059),(6886,1059),(6887,1060),(6888,1060),(6889,1061),(6890,1061),(6891,1062),(6892,1062),(6893,1063),(6894,1063),(6895,1064),(6896,1064),(6897,1065),(6898,1065),(6899,1066),(6900,1066),(6901,1067),(6902,1067),(6903,1068),(6904,1068),(6905,1069),(6906,1069),(6907,1070),(6908,1070),(6909,1071),(6910,1071),(6911,1072),(6912,1072),(6913,1073),(6914,1073),(6915,1074),(6916,1074),(6917,1075),(6918,1075),(6919,1076),(6920,1076),(6921,1077),(6922,1077),(6923,1078),(6924,1078),(6925,1079),(6926,1079),(6927,1080),(6928,1080),(6929,981),(6930,981),(6931,981),(6932,981),(6933,982),(6934,982),(6935,982),(6936,982),(6937,983),(6938,983),(6939,983),(6940,983),(6941,984),(6942,984),(6943,984),(6944,984),(6945,985),(6946,985),(6947,985),(6948,985),(6949,986),(6950,986),(6951,986),(6952,986),(6953,987),(6954,987),(6955,987),(6956,987),(6957,988),(6958,988),(6959,988),(6960,988),(6961,989),(6962,989),(6963,989),(6964,989),(6965,990),(6966,990),(6967,990),(6968,990),(6969,991),(6970,991),(6971,991),(6972,991),(6973,992),(6974,992),(6975,992),(6976,992),(6977,993),(6978,993),(6979,993),(6980,993),(6981,994),(6982,994),(6983,994),(6984,994),(6985,995),(6986,995),(6987,995),(6988,995),(6989,996),(6990,996),(6991,996),(6992,996),(6993,997),(6994,997),(6995,997),(6996,997),(6997,998),(6998,998),(6999,998),(7000,998),(7001,999),(7002,999),(7003,999),(7004,999),(7005,1000),(7006,1000),(7007,1000),(7008,1000),(7009,1001),(7010,1001),(7011,1001),(7012,1001),(7013,1002),(7014,1002),(7015,1002),(7016,1002),(7017,1003),(7018,1003),(7019,1003),(7020,1003),(7021,1004),(7022,1004),(7023,1004),(7024,1004),(7025,1005),(7026,1005),(7027,1005),(7028,1005),(7029,1006),(7030,1006),(7031,1006),(7032,1006),(7033,1007),(7034,1007),(7035,1007),(7036,1007),(7037,1008),(7038,1008),(7039,1008),(7040,1008),(7041,1009),(7042,1009),(7043,1009),(7044,1009),(7045,1010),(7046,1010),(7047,1010),(7048,1010),(7049,1011),(7050,1011),(7051,1011),(7052,1011),(7053,1012),(7054,1012),(7055,1012),(7056,1012),(7057,1013),(7058,1013),(7059,1013),(7060,1013),(7061,1014),(7062,1014),(7063,1014),(7064,1014),(7065,1015),(7066,1015),(7067,1015),(7068,1015),(7069,1016),(7070,1016),(7071,1016),(7072,1016),(7073,1017),(7074,1017),(7075,1017),(7076,1017),(7077,1018),(7078,1018),(7079,1018),(7080,1018),(7081,1019),(7082,1019),(7083,1019),(7084,1019),(7085,1020),(7086,1020),(7087,1020),(7088,1020),(7089,1021),(7090,1021),(7091,1021),(7092,1021),(7093,1022),(7094,1022),(7095,1022),(7096,1022),(7097,1023),(7098,1023),(7099,1023),(7100,1023),(7101,1024),(7102,1024),(7103,1024),(7104,1024),(7105,1025),(7106,1025),(7107,1025),(7108,1025),(7109,1026),(7110,1026),(7111,1026),(7112,1026),(7113,1027),(7114,1027),(7115,1027),(7116,1027),(7117,1028),(7118,1028),(7119,1028),(7120,1028),(7121,1029),(7122,1029),(7123,1029),(7124,1029),(7125,1030),(7126,1030),(7127,1030),(7128,1030),(7129,1031),(7130,1031),(7131,1031),(7132,1031),(7133,1032),(7134,1032),(7135,1032),(7136,1032),(7137,1033),(7138,1033),(7139,1033),(7140,1033),(7141,1034),(7142,1034),(7143,1034),(7144,1034),(7145,1035),(7146,1035),(7147,1035),(7148,1035),(7149,1036),(7150,1036),(7151,1036),(7152,1036),(7153,1037),(7154,1037),(7155,1037),(7156,1037),(7157,1038),(7158,1038),(7159,1038),(7160,1038),(7161,1039),(7162,1039),(7163,1039),(7164,1039),(7165,1040),(7166,1040),(7167,1040),(7168,1040),(7169,1041),(7170,1041),(7171,1041),(7172,1041),(7173,1042),(7174,1042),(7175,1042),(7176,1042),(7177,1043),(7178,1043),(7179,1043),(7180,1043),(7181,1044),(7182,1044),(7183,1044),(7184,1044),(7185,1045),(7186,1045),(7187,1045),(7188,1045),(7189,1046),(7190,1046),(7191,1046),(7192,1046),(7193,1047),(7194,1047),(7195,1047),(7196,1047),(7197,1048),(7198,1048),(7199,1048),(7200,1048),(7201,1049),(7202,1049),(7203,1049),(7204,1049),(7205,1050),(7206,1050),(7207,1050),(7208,1050),(7209,1051),(7210,1051),(7211,1051),(7212,1051),(7213,1052),(7214,1052),(7215,1052),(7216,1052),(7217,1053),(7218,1053),(7219,1053),(7220,1053),(7221,1054),(7222,1054),(7223,1054),(7224,1054),(7225,1055),(7226,1055),(7227,1055),(7228,1055),(7229,1056),(7230,1056),(7231,1056),(7232,1056),(7233,1057),(7234,1057),(7235,1057),(7236,1057),(7237,1058),(7238,1058),(7239,1058),(7240,1058),(7241,1059),(7242,1059),(7243,1059),(7244,1059),(7245,1060),(7246,1060),(7247,1060),(7248,1060),(7249,1061),(7250,1061),(7251,1061),(7252,1061),(7253,1062),(7254,1062),(7255,1062),(7256,1062),(7257,1063),(7258,1063),(7259,1063),(7260,1063),(7261,1064),(7262,1064),(7263,1064),(7264,1064),(7265,1065),(7266,1065),(7267,1065),(7268,1065),(7269,1066),(7270,1066),(7271,1066),(7272,1066),(7273,1067),(7274,1067),(7275,1067),(7276,1067),(7277,1068),(7278,1068),(7279,1068),(7280,1068),(7281,1069),(7282,1069),(7283,1069),(7284,1069),(7285,1070),(7286,1070),(7287,1070),(7288,1070),(7289,1071),(7290,1071),(7291,1071),(7292,1071),(7293,1072),(7294,1072),(7295,1072),(7296,1072),(7297,1073),(7298,1073),(7299,1073),(7300,1073),(7301,1074),(7302,1074),(7303,1074),(7304,1074),(7305,1075),(7306,1075),(7307,1075),(7308,1075),(7309,1076),(7310,1076),(7311,1076),(7312,1076),(7313,1077),(7314,1077),(7315,1077),(7316,1077),(7317,1078),(7318,1078),(7319,1078),(7320,1078),(7321,1079),(7322,1079),(7323,1079),(7324,1079),(7325,1080),(7326,1080),(7327,1080),(7328,1080),(7329,1081),(7330,1082),(7331,1083),(7332,1084),(7333,1085),(7334,1086),(7335,1087),(7336,1088),(7337,1089),(7338,1090),(7339,1091),(7340,1092),(7341,1093),(7342,1094),(7343,1095),(7344,1096),(7345,1097),(7346,1098),(7347,1099),(7348,1100),(7349,1101),(7350,1102),(7351,1103),(7352,1104),(7353,1105),(7354,1106),(7355,1107),(7356,1108),(7357,1109),(7358,1110),(7359,1111),(7360,1112),(7361,1113),(7362,1114),(7363,1115),(7364,1116),(7365,1117),(7366,1118),(7367,1119),(7368,1120),(7369,1121),(7370,1122),(7371,1123),(7372,1124),(7373,1125),(7374,1126),(7375,1127),(7376,1128),(7377,1129),(7378,1130),(7379,1131),(7380,1132),(7381,1133),(7382,1134),(7383,1135),(7384,1136),(7385,1137),(7386,1138),(7387,1139),(7388,1081),(7389,1081),(7390,1082),(7391,1082),(7392,1083),(7393,1083),(7394,1084),(7395,1084),(7396,1085),(7397,1085),(7398,1086),(7399,1086),(7400,1087),(7401,1087),(7402,1088),(7403,1088),(7404,1089),(7405,1089),(7406,1090),(7407,1090),(7408,1091),(7409,1091),(7410,1092),(7411,1092),(7412,1093),(7413,1093),(7414,1094),(7415,1094),(7416,1095),(7417,1095),(7418,1096),(7419,1096),(7420,1097),(7421,1097),(7422,1098),(7423,1098),(7424,1099),(7425,1099),(7426,1100),(7427,1100),(7428,1101),(7429,1101),(7430,1102),(7431,1102),(7432,1103),(7433,1103),(7434,1104),(7435,1104),(7436,1105),(7437,1105),(7438,1106),(7439,1106),(7440,1107),(7441,1107),(7442,1108),(7443,1108),(7444,1109),(7445,1109),(7446,1110),(7447,1110),(7448,1111),(7449,1111),(7450,1112),(7451,1112),(7452,1113),(7453,1113),(7454,1114),(7455,1114),(7456,1115),(7457,1115),(7458,1116),(7459,1116),(7460,1117),(7461,1117),(7462,1118),(7463,1118),(7464,1119),(7465,1119),(7466,1120),(7467,1120),(7468,1121),(7469,1121),(7470,1122),(7471,1122),(7472,1123),(7473,1123),(7474,1124),(7475,1124),(7476,1125),(7477,1125),(7478,1126),(7479,1126),(7480,1127),(7481,1127),(7482,1128),(7483,1128),(7484,1129),(7485,1129),(7486,1130),(7487,1130),(7488,1131),(7489,1131),(7490,1132),(7491,1132),(7492,1133),(7493,1133),(7494,1134),(7495,1134),(7496,1135),(7497,1135),(7498,1136),(7499,1136),(7500,1137),(7501,1137),(7502,1138),(7503,1138),(7504,1139),(7505,1139),(7506,1081),(7507,1081),(7508,1081),(7509,1081),(7510,1082),(7511,1082),(7512,1082),(7513,1082),(7514,1083),(7515,1083),(7516,1083),(7517,1083),(7518,1084),(7519,1084),(7520,1084),(7521,1084),(7522,1085),(7523,1085),(7524,1085),(7525,1085),(7526,1086),(7527,1086),(7528,1086),(7529,1086),(7530,1087),(7531,1087),(7532,1087),(7533,1087),(7534,1088),(7535,1088),(7536,1088),(7537,1088),(7538,1089),(7539,1089),(7540,1089),(7541,1089),(7542,1090),(7543,1090),(7544,1090),(7545,1090),(7546,1091),(7547,1091),(7548,1091),(7549,1091),(7550,1092),(7551,1092),(7552,1092),(7553,1092),(7554,1093),(7555,1093),(7556,1093),(7557,1093),(7558,1094),(7559,1094),(7560,1094),(7561,1094),(7562,1095),(7563,1095),(7564,1095),(7565,1095),(7566,1096),(7567,1096),(7568,1096),(7569,1096),(7570,1097),(7571,1097),(7572,1097),(7573,1097),(7574,1098),(7575,1098),(7576,1098),(7577,1098),(7578,1099),(7579,1099),(7580,1099),(7581,1099),(7582,1100),(7583,1100),(7584,1100),(7585,1100),(7586,1101),(7587,1101),(7588,1101),(7589,1101),(7590,1102),(7591,1102),(7592,1102),(7593,1102),(7594,1103),(7595,1103),(7596,1103),(7597,1103),(7598,1104),(7599,1104),(7600,1104),(7601,1104),(7602,1105),(7603,1105),(7604,1105),(7605,1105),(7606,1106),(7607,1106),(7608,1106),(7609,1106),(7610,1107),(7611,1107),(7612,1107),(7613,1107),(7614,1108),(7615,1108),(7616,1108),(7617,1108),(7618,1109),(7619,1109),(7620,1109),(7621,1109),(7622,1110),(7623,1110),(7624,1110),(7625,1110),(7626,1111),(7627,1111),(7628,1111),(7629,1111),(7630,1112),(7631,1112),(7632,1112),(7633,1112),(7634,1113),(7635,1113),(7636,1113),(7637,1113),(7638,1114),(7639,1114),(7640,1114),(7641,1114),(7642,1115),(7643,1115),(7644,1115),(7645,1115),(7646,1116),(7647,1116),(7648,1116),(7649,1116),(7650,1117),(7651,1117),(7652,1117),(7653,1117),(7654,1118),(7655,1118),(7656,1118),(7657,1118),(7658,1119),(7659,1119),(7660,1119),(7661,1119),(7662,1120),(7663,1120),(7664,1120),(7665,1120),(7666,1121),(7667,1121),(7668,1121),(7669,1121),(7670,1122),(7671,1122),(7672,1122),(7673,1122),(7674,1123),(7675,1123),(7676,1123),(7677,1123),(7678,1124),(7679,1124),(7680,1124),(7681,1124),(7682,1125),(7683,1125),(7684,1125),(7685,1125),(7686,1126),(7687,1126),(7688,1126),(7689,1126),(7690,1127),(7691,1127),(7692,1127),(7693,1127),(7694,1128),(7695,1128),(7696,1128),(7697,1128),(7698,1129),(7699,1129),(7700,1129),(7701,1129),(7702,1130),(7703,1130),(7704,1130),(7705,1130),(7706,1131),(7707,1131),(7708,1131),(7709,1131),(7710,1132),(7711,1132),(7712,1132),(7713,1132),(7714,1133),(7715,1133),(7716,1133),(7717,1133),(7718,1134),(7719,1134),(7720,1134),(7721,1134),(7722,1135),(7723,1135),(7724,1135),(7725,1135),(7726,1136),(7727,1136),(7728,1136),(7729,1136),(7730,1137),(7731,1137),(7732,1137),(7733,1137),(7734,1138),(7735,1138),(7736,1138),(7737,1138),(7738,1139),(7739,1139),(7740,1139),(7741,1139),(7742,1140),(7743,1141),(7744,1142),(7745,1143),(7746,1144),(7747,1145),(7748,1146),(7749,1147),(7750,1148),(7751,1149),(7752,1150),(7753,1140),(7754,1140),(7755,1141),(7756,1141),(7757,1142),(7758,1142),(7759,1143),(7760,1143),(7761,1144),(7762,1144),(7763,1145),(7764,1145),(7765,1146),(7766,1146),(7767,1147),(7768,1147),(7769,1148),(7770,1148),(7771,1149),(7772,1149),(7773,1150),(7774,1150),(7775,1140),(7776,1140),(7777,1140),(7778,1140),(7779,1141),(7780,1141),(7781,1141),(7782,1141),(7783,1142),(7784,1142),(7785,1142),(7786,1142),(7787,1143),(7788,1143),(7789,1143),(7790,1143),(7791,1144),(7792,1144),(7793,1144),(7794,1144),(7795,1145),(7796,1145),(7797,1145),(7798,1145),(7799,1146),(7800,1146),(7801,1146),(7802,1146),(7803,1147),(7804,1147),(7805,1147),(7806,1147),(7807,1148),(7808,1148),(7809,1148),(7810,1148),(7811,1149),(7812,1149),(7813,1149),(7814,1149),(7815,1150),(7816,1150),(7817,1150),(7818,1150),(7819,1151),(7820,1152),(7821,1153),(7822,1154),(7823,1155),(7824,1156),(7825,1157),(7826,1158),(7827,1159),(7828,1160),(7829,1161),(7830,1151),(7831,1151),(7832,1151),(7833,1151),(7834,1152),(7835,1152),(7836,1152),(7837,1152),(7838,1153),(7839,1153),(7840,1153),(7841,1153),(7842,1154),(7843,1154),(7844,1154),(7845,1154),(7846,1155),(7847,1155),(7848,1155),(7849,1155),(7850,1156),(7851,1156),(7852,1156),(7853,1156),(7854,1157),(7855,1157),(7856,1157),(7857,1157),(7858,1158),(7859,1158),(7860,1158),(7861,1158),(7862,1159),(7863,1159),(7864,1159),(7865,1159),(7866,1160),(7867,1160),(7868,1160),(7869,1160),(7870,1161),(7871,1161),(7872,1161),(7873,1161),(7874,1142),(7875,1143),(7876,1144),(7877,1145),(7878,1146),(7879,1147),(7880,1148),(7881,1149),(7882,1150),(7883,1151),(7884,1152),(7885,1153),(7886,1154),(7887,1155),(7888,1156),(7889,1157),(7890,1158),(7891,1159),(7892,1160),(7893,1161),(7894,1162),(7895,1162),(7896,1162),(7897,1162),(7898,1162),(7899,1162),(7900,1162),(7901,1162),(7902,1162),(7903,1162),(7904,1162),(7905,1162),(7906,1162),(7907,1162),(7908,1162),(7909,1162),(7910,1163),(7911,1163),(7912,1163),(7913,1163),(7914,1163),(7915,1163),(7916,1163),(7917,1163),(7918,1163),(7919,1163),(7920,1163),(7921,1163),(7922,1163),(7923,1163),(7924,1163),(7925,1163),(7926,1163),(7927,1163),(7928,1164),(7929,1164),(7930,1164),(7931,1164),(7932,1164),(7933,1164),(7934,1164),(7935,1164),(7936,1164),(7937,1164),(7938,1164),(7939,1164),(7940,1164),(7941,1164),(7942,1164),(7943,1164),(7944,1164),(7945,1164),(7946,1165),(7947,1165),(7948,1165),(7949,1165),(7950,1165),(7951,1165),(7952,1165),(7953,1165),(7954,1165),(7955,1165),(7956,1165),(7957,1165),(7958,1165),(7959,1165),(7960,1165),(7961,1165),(7962,1165),(7963,1165),(7964,1154),(7965,1155),(7966,1156),(7967,1157),(7968,1142),(7969,1143),(7970,1144),(7971,1145),(7972,1146),(7973,1147),(7974,1148),(7975,1149),(7976,1150),(7977,1151),(7978,1152),(7979,1153),(7980,1158),(7981,1159),(7982,1159),(7983,1160),(7984,1161),(7985,1162),(7986,1163),(7987,1164),(7988,1165),(7989,1166),(7990,1167),(7991,1168),(7992,1169),(7993,1170),(7994,1171),(7995,1172),(7996,1173),(7997,1174),(7998,1175),(7999,1176),(8000,1166),(8001,1166),(8002,1166),(8003,1166),(8004,1167),(8005,1167),(8006,1167),(8007,1167),(8008,1168),(8009,1168),(8010,1168),(8011,1168),(8012,1169),(8013,1169),(8014,1169),(8015,1169),(8016,1170),(8017,1170),(8018,1170),(8019,1170),(8020,1171),(8021,1171),(8022,1171),(8023,1171),(8024,1172),(8025,1172),(8026,1172),(8027,1172),(8028,1173),(8029,1173),(8030,1173),(8031,1173),(8032,1174),(8033,1174),(8034,1174),(8035,1174),(8036,1175),(8037,1175),(8038,1175),(8039,1175),(8040,1176),(8041,1176),(8042,1176),(8043,1176),(8044,1177),(8045,1178),(8046,1179),(8047,1180),(8048,1181),(8049,1182),(8050,1183),(8051,1184),(8052,1185),(8053,1186),(8054,1187),(8055,1188),(8056,1189),(8057,1190),(8058,1191),(8059,1192),(8060,1193),(8061,1194),(8062,1195),(8063,1196),(8064,1197),(8065,1198),(8066,1199),(8067,1200),(8068,1201),(8069,1202),(8070,1203),(8071,1204),(8072,1205),(8073,1206),(8074,1207),(8075,1208),(8076,1209),(8077,1210),(8078,1211),(8079,1212),(8080,1213),(8081,1214),(8082,1215),(8083,1216),(8084,1217),(8085,1218),(8086,1219),(8087,1220),(8088,1221),(8089,1222),(8090,1223),(8091,1224),(8092,1225),(8093,1226),(8094,1227),(8095,1228),(8096,1229),(8097,1230),(8098,1231),(8099,1232),(8100,1233),(8101,1234),(8102,1235),(8103,1236),(8104,1237),(8105,1238),(8106,1239),(8107,1240),(8108,1241),(8109,1242),(8110,1243),(8111,1244),(8112,1245),(8113,1246),(8114,1247),(8115,1248),(8116,1249),(8117,1250),(8118,1251),(8119,1252),(8120,1253),(8121,1254),(8122,1255),(8123,1256),(8124,1257),(8125,1258),(8126,1259),(8127,1260),(8128,1261),(8129,1262),(8130,1263),(8131,1264),(8132,1265),(8133,1177),(8134,1177),(8135,1177),(8136,1177),(8137,1178),(8138,1178),(8139,1178),(8140,1178),(8141,1179),(8142,1179),(8143,1179),(8144,1179),(8145,1180),(8146,1180),(8147,1180),(8148,1180),(8149,1181),(8150,1181),(8151,1181),(8152,1181),(8153,1182),(8154,1182),(8155,1182),(8156,1182),(8157,1183),(8158,1183),(8159,1183),(8160,1183),(8161,1184),(8162,1184),(8163,1184),(8164,1184),(8165,1185),(8166,1185),(8167,1185),(8168,1185),(8169,1186),(8170,1186),(8171,1186),(8172,1186),(8173,1187),(8174,1187),(8175,1187),(8176,1187),(8177,1188),(8178,1188),(8179,1188),(8180,1188),(8181,1189),(8182,1189),(8183,1189),(8184,1189),(8185,1190),(8186,1190),(8187,1190),(8188,1190),(8189,1191),(8190,1191),(8191,1191),(8192,1191),(8193,1192),(8194,1192),(8195,1192),(8196,1192),(8197,1193),(8198,1193),(8199,1193),(8200,1193),(8201,1194),(8202,1194),(8203,1194),(8204,1194),(8205,1195),(8206,1195),(8207,1195),(8208,1195),(8209,1196),(8210,1196),(8211,1196),(8212,1196),(8213,1197),(8214,1197),(8215,1197),(8216,1197),(8217,1198),(8218,1198),(8219,1198),(8220,1198),(8221,1199),(8222,1199),(8223,1199),(8224,1199),(8225,1200),(8226,1200),(8227,1200),(8228,1200),(8229,1201),(8230,1201),(8231,1201),(8232,1201),(8233,1202),(8234,1202),(8235,1202),(8236,1202),(8237,1203),(8238,1203),(8239,1203),(8240,1203),(8241,1204),(8242,1204),(8243,1204),(8244,1204),(8245,1205),(8246,1205),(8247,1205),(8248,1205),(8249,1206),(8250,1206),(8251,1206),(8252,1206),(8253,1207),(8254,1207),(8255,1207),(8256,1207),(8257,1208),(8258,1208),(8259,1208),(8260,1208),(8261,1209),(8262,1209),(8263,1209),(8264,1209),(8265,1210),(8266,1210),(8267,1210),(8268,1210),(8269,1211),(8270,1211),(8271,1211),(8272,1211),(8273,1212),(8274,1212),(8275,1212),(8276,1212),(8277,1213),(8278,1213),(8279,1213),(8280,1213),(8281,1214),(8282,1214),(8283,1214),(8284,1214),(8285,1215),(8286,1215),(8287,1215),(8288,1215),(8289,1216),(8290,1216),(8291,1216),(8292,1216),(8293,1217),(8294,1217),(8295,1217),(8296,1217),(8297,1218),(8298,1218),(8299,1218),(8300,1218),(8301,1219),(8302,1219),(8303,1219),(8304,1219),(8305,1220),(8306,1220),(8307,1220),(8308,1220),(8309,1221),(8310,1221),(8311,1221),(8312,1221),(8313,1222),(8314,1222),(8315,1222),(8316,1222),(8317,1223),(8318,1223),(8319,1223),(8320,1223),(8321,1224),(8322,1224),(8323,1224),(8324,1224),(8325,1225),(8326,1225),(8327,1225),(8328,1225),(8329,1226),(8330,1226),(8331,1226),(8332,1226),(8333,1227),(8334,1227),(8335,1227),(8336,1227),(8337,1228),(8338,1228),(8339,1228),(8340,1228),(8341,1229),(8342,1229),(8343,1229),(8344,1229),(8345,1230),(8346,1230),(8347,1230),(8348,1230),(8349,1231),(8350,1231),(8351,1231),(8352,1231),(8353,1232),(8354,1232),(8355,1232),(8356,1232),(8357,1233),(8358,1233),(8359,1233),(8360,1233),(8361,1234),(8362,1234),(8363,1234),(8364,1234),(8365,1235),(8366,1235),(8367,1235),(8368,1235),(8369,1236),(8370,1236),(8371,1236),(8372,1236),(8373,1237),(8374,1237),(8375,1237),(8376,1237),(8377,1238),(8378,1238),(8379,1238),(8380,1238),(8381,1239),(8382,1239),(8383,1239),(8384,1239),(8385,1240),(8386,1240),(8387,1240),(8388,1240),(8389,1241),(8390,1241),(8391,1241),(8392,1241),(8393,1242),(8394,1242),(8395,1242),(8396,1242),(8397,1243),(8398,1243),(8399,1243),(8400,1243),(8401,1244),(8402,1244),(8403,1244),(8404,1244),(8405,1245),(8406,1245),(8407,1245),(8408,1245),(8409,1246),(8410,1246),(8411,1246),(8412,1246),(8413,1247),(8414,1247),(8415,1247),(8416,1247),(8417,1248),(8418,1248),(8419,1248),(8420,1248),(8421,1249),(8422,1249),(8423,1249),(8424,1249),(8425,1250),(8426,1250),(8427,1250),(8428,1250),(8429,1251),(8430,1251),(8431,1251),(8432,1251),(8433,1252),(8434,1252),(8435,1252),(8436,1252),(8437,1253),(8438,1253),(8439,1253),(8440,1253),(8441,1254),(8442,1254),(8443,1254),(8444,1254),(8445,1255),(8446,1255),(8447,1255),(8448,1255),(8449,1256),(8450,1256),(8451,1256),(8452,1256),(8453,1257),(8454,1257),(8455,1257),(8456,1257),(8457,1258),(8458,1258),(8459,1258),(8460,1258),(8461,1259),(8462,1259),(8463,1259),(8464,1259),(8465,1260),(8466,1260),(8467,1260),(8468,1260),(8469,1261),(8470,1261),(8471,1261),(8472,1261),(8473,1262),(8474,1262),(8475,1262),(8476,1262),(8477,1263),(8478,1263),(8479,1263),(8480,1263),(8481,1264),(8482,1264),(8483,1264),(8484,1264),(8485,1265),(8486,1265),(8487,1265),(8488,1265),(8489,1266),(8490,1267),(8491,1268),(8492,1269),(8493,1270),(8494,1271),(8495,1272),(8496,1273),(8497,1274),(8498,1275),(8499,1276),(8500,1277),(8501,1278),(8502,1279),(8503,1280),(8504,1281),(8505,1282),(8506,1283),(8507,1284),(8508,1285),(8509,1286),(8510,1287),(8511,1288),(8512,1289),(8513,1290),(8514,1291),(8515,1292),(8516,1293),(8517,1294),(8518,1295),(8519,1296),(8520,1297),(8521,1298),(8522,1299),(8523,1300),(8524,1301),(8525,1302),(8526,1303),(8527,1304),(8528,1305),(8529,1306),(8530,1307),(8531,1308),(8532,1309),(8533,1310),(8534,1311),(8535,1312),(8536,1313),(8537,1314),(8538,1315),(8539,1316),(8540,1317),(8541,1318),(8542,1319),(8543,1320),(8544,1321),(8545,1322),(8546,1323),(8547,1324),(8548,1325),(8549,1326),(8550,1327),(8551,1328),(8552,1329),(8553,1330),(8554,1331),(8555,1332),(8556,1333),(8557,1334),(8558,1335),(8559,1336),(8560,1337),(8561,1338),(8562,1339),(8563,1340),(8564,1341),(8565,1342),(8566,1343),(8567,1344),(8568,1345),(8569,1346),(8570,1347),(8571,1348),(8572,1349),(8573,1350),(8574,1351),(8575,1352),(8576,1353),(8577,1354),(8578,1355),(8579,1356),(8580,1357),(8581,1358),(8582,1359),(8583,1360),(8584,1361),(8585,1362),(8586,1363),(8587,1364),(8588,1365),(8589,1266),(8590,1266),(8591,1266),(8592,1266),(8593,1267),(8594,1267),(8595,1267),(8596,1267),(8597,1268),(8598,1268),(8599,1268),(8600,1268),(8601,1269),(8602,1269),(8603,1269),(8604,1269),(8605,1270),(8606,1270),(8607,1270),(8608,1270),(8609,1271),(8610,1271),(8611,1271),(8612,1271),(8613,1272),(8614,1272),(8615,1272),(8616,1272),(8617,1273),(8618,1273),(8619,1273),(8620,1273),(8621,1274),(8622,1274),(8623,1274),(8624,1274),(8625,1275),(8626,1275),(8627,1275),(8628,1275),(8629,1276),(8630,1276),(8631,1276),(8632,1276),(8633,1277),(8634,1277),(8635,1277),(8636,1277),(8637,1278),(8638,1278),(8639,1278),(8640,1278),(8641,1279),(8642,1279),(8643,1279),(8644,1279),(8645,1280),(8646,1280),(8647,1280),(8648,1280),(8649,1281),(8650,1281),(8651,1281),(8652,1281),(8653,1282),(8654,1282),(8655,1282),(8656,1282),(8657,1283),(8658,1283),(8659,1283),(8660,1283),(8661,1284),(8662,1284),(8663,1284),(8664,1284),(8665,1285),(8666,1285),(8667,1285),(8668,1285),(8669,1286),(8670,1286),(8671,1286),(8672,1286),(8673,1287),(8674,1287),(8675,1287),(8676,1287),(8677,1288),(8678,1288),(8679,1288),(8680,1288),(8681,1289),(8682,1289),(8683,1289),(8684,1289),(8685,1290),(8686,1290),(8687,1290),(8688,1290),(8689,1291),(8690,1291),(8691,1291),(8692,1291),(8693,1292),(8694,1292),(8695,1292),(8696,1292),(8697,1293),(8698,1293),(8699,1293),(8700,1293),(8701,1294),(8702,1294),(8703,1294),(8704,1294),(8705,1295),(8706,1295),(8707,1295),(8708,1295),(8709,1296),(8710,1296),(8711,1296),(8712,1296),(8713,1297),(8714,1297),(8715,1297),(8716,1297),(8717,1298),(8718,1298),(8719,1298),(8720,1298),(8721,1299),(8722,1299),(8723,1299),(8724,1299),(8725,1300),(8726,1300),(8727,1300),(8728,1300),(8729,1301),(8730,1301),(8731,1301),(8732,1301),(8733,1302),(8734,1302),(8735,1302),(8736,1302),(8737,1303),(8738,1303),(8739,1303),(8740,1303),(8741,1304),(8742,1304),(8743,1304),(8744,1304),(8745,1305),(8746,1305),(8747,1305),(8748,1305),(8749,1306),(8750,1306),(8751,1306),(8752,1306),(8753,1307),(8754,1307),(8755,1307),(8756,1307),(8757,1308),(8758,1308),(8759,1308),(8760,1308),(8761,1309),(8762,1309),(8763,1309),(8764,1309),(8765,1310),(8766,1310),(8767,1310),(8768,1310),(8769,1311),(8770,1311),(8771,1311),(8772,1311),(8773,1312),(8774,1312),(8775,1312),(8776,1312),(8777,1313),(8778,1313),(8779,1313),(8780,1313),(8781,1314),(8782,1314),(8783,1314),(8784,1314),(8785,1315),(8786,1315),(8787,1315),(8788,1315),(8789,1316),(8790,1316),(8791,1316),(8792,1316),(8793,1317),(8794,1317),(8795,1317),(8796,1317),(8797,1318),(8798,1318),(8799,1318),(8800,1318),(8801,1319),(8802,1319),(8803,1319),(8804,1319),(8805,1320),(8806,1320),(8807,1320),(8808,1320),(8809,1321),(8810,1321),(8811,1321),(8812,1321),(8813,1322),(8814,1322),(8815,1322),(8816,1322),(8817,1323),(8818,1323),(8819,1323),(8820,1323),(8821,1324),(8822,1324),(8823,1324),(8824,1324),(8825,1325),(8826,1325),(8827,1325),(8828,1325),(8829,1326),(8830,1326),(8831,1326),(8832,1326),(8833,1327),(8834,1327),(8835,1327),(8836,1327),(8837,1328),(8838,1328),(8839,1328),(8840,1328),(8841,1329),(8842,1329),(8843,1329),(8844,1329),(8845,1330),(8846,1330),(8847,1330),(8848,1330),(8849,1331),(8850,1331),(8851,1331),(8852,1331),(8853,1332),(8854,1332),(8855,1332),(8856,1332),(8857,1333),(8858,1333),(8859,1333),(8860,1333),(8861,1334),(8862,1334),(8863,1334),(8864,1334),(8865,1335),(8866,1335),(8867,1335),(8868,1335),(8869,1336),(8870,1336),(8871,1336),(8872,1336),(8873,1337),(8874,1337),(8875,1337),(8876,1337),(8877,1338),(8878,1338),(8879,1338),(8880,1338),(8881,1339),(8882,1339),(8883,1339),(8884,1339),(8885,1340),(8886,1340),(8887,1340),(8888,1340),(8889,1341),(8890,1341),(8891,1341),(8892,1341),(8893,1342),(8894,1342),(8895,1342),(8896,1342),(8897,1343),(8898,1343),(8899,1343),(8900,1343),(8901,1344),(8902,1344),(8903,1344),(8904,1344),(8905,1345),(8906,1345),(8907,1345),(8908,1345),(8909,1346),(8910,1346),(8911,1346),(8912,1346),(8913,1347),(8914,1347),(8915,1347),(8916,1347),(8917,1348),(8918,1348),(8919,1348),(8920,1348),(8921,1349),(8922,1349),(8923,1349),(8924,1349),(8925,1350),(8926,1350),(8927,1350),(8928,1350),(8929,1351),(8930,1351),(8931,1351),(8932,1351),(8933,1352),(8934,1352),(8935,1352),(8936,1352),(8937,1353),(8938,1353),(8939,1353),(8940,1353),(8941,1354),(8942,1354),(8943,1354),(8944,1354),(8945,1355),(8946,1355),(8947,1355),(8948,1355),(8949,1356),(8950,1356),(8951,1356),(8952,1356),(8953,1357),(8954,1357),(8955,1357),(8956,1357),(8957,1358),(8958,1358),(8959,1358),(8960,1358),(8961,1359),(8962,1359),(8963,1359),(8964,1359),(8965,1360),(8966,1360),(8967,1360),(8968,1360),(8969,1361),(8970,1361),(8971,1361),(8972,1361),(8973,1362),(8974,1362),(8975,1362),(8976,1362),(8977,1363),(8978,1363),(8979,1363),(8980,1363),(8981,1364),(8982,1364),(8983,1364),(8984,1364),(8985,1365),(8986,1365),(8987,1365),(8988,1365),(8989,1366),(8990,1367),(8991,1368),(8992,1369),(8993,1370),(8994,1371),(8995,1372),(8996,1373),(8997,1374),(8998,1375),(8999,1376),(9000,1377),(9001,1378),(9002,1379),(9003,1380),(9004,1381),(9005,1382),(9006,1383),(9007,1384),(9008,1385),(9009,1386),(9010,1387),(9011,1388),(9012,1389),(9013,1390),(9014,1391),(9015,1392),(9016,1393),(9017,1394),(9018,1395),(9019,1396),(9020,1397),(9021,1398),(9022,1399),(9023,1400),(9024,1401),(9025,1402),(9026,1403),(9027,1404),(9028,1405),(9029,1406),(9030,1407),(9031,1408),(9032,1409),(9033,1410),(9034,1411),(9035,1412),(9036,1413),(9037,1414),(9038,1415),(9039,1416),(9040,1417),(9041,1418),(9042,1419),(9043,1420),(9044,1421),(9045,1422),(9046,1423),(9047,1424),(9048,1425),(9049,1426),(9050,1427),(9051,1428),(9052,1429),(9053,1430),(9054,1431),(9055,1432),(9056,1433),(9057,1434),(9058,1435),(9059,1436),(9060,1437),(9061,1438),(9062,1439),(9063,1440),(9064,1441),(9065,1442),(9066,1443),(9067,1444),(9068,1445),(9069,1446),(9070,1447),(9071,1448),(9072,1449),(9073,1450),(9074,1451),(9075,1452),(9076,1453),(9077,1454),(9078,1455),(9079,1456),(9080,1457),(9081,1458),(9082,1459),(9083,1460),(9084,1461),(9085,1462),(9086,1463),(9087,1464),(9088,1465),(9089,1366),(9090,1366),(9091,1366),(9092,1366),(9093,1367),(9094,1367),(9095,1367),(9096,1367),(9097,1368),(9098,1368),(9099,1368),(9100,1368),(9101,1369),(9102,1369),(9103,1369),(9104,1369),(9105,1370),(9106,1370),(9107,1370),(9108,1370),(9109,1371),(9110,1371),(9111,1371),(9112,1371),(9113,1372),(9114,1372),(9115,1372),(9116,1372),(9117,1373),(9118,1373),(9119,1373),(9120,1373),(9121,1374),(9122,1374),(9123,1374),(9124,1374),(9125,1375),(9126,1375),(9127,1375),(9128,1375),(9129,1376),(9130,1376),(9131,1376),(9132,1376),(9133,1377),(9134,1377),(9135,1377),(9136,1377),(9137,1378),(9138,1378),(9139,1378),(9140,1378),(9141,1379),(9142,1379),(9143,1379),(9144,1379),(9145,1380),(9146,1380),(9147,1380),(9148,1380),(9149,1381),(9150,1381),(9151,1381),(9152,1381),(9153,1382),(9154,1382),(9155,1382),(9156,1382),(9157,1383),(9158,1383),(9159,1383),(9160,1383),(9161,1384),(9162,1384),(9163,1384),(9164,1384),(9165,1385),(9166,1385),(9167,1385),(9168,1385),(9169,1386),(9170,1386),(9171,1386),(9172,1386),(9173,1387),(9174,1387),(9175,1387),(9176,1387),(9177,1388),(9178,1388),(9179,1388),(9180,1388),(9181,1389),(9182,1389),(9183,1389),(9184,1389),(9185,1390),(9186,1390),(9187,1390),(9188,1390),(9189,1391),(9190,1391),(9191,1391),(9192,1391),(9193,1392),(9194,1392),(9195,1392),(9196,1392),(9197,1393),(9198,1393),(9199,1393),(9200,1393),(9201,1394),(9202,1394),(9203,1394),(9204,1394),(9205,1395),(9206,1395),(9207,1395),(9208,1395),(9209,1396),(9210,1396),(9211,1396),(9212,1396),(9213,1397),(9214,1397),(9215,1397),(9216,1397),(9217,1398),(9218,1398),(9219,1398),(9220,1398),(9221,1399),(9222,1399),(9223,1399),(9224,1399),(9225,1400),(9226,1400),(9227,1400),(9228,1400),(9229,1401),(9230,1401),(9231,1401),(9232,1401),(9233,1402),(9234,1402),(9235,1402),(9236,1402),(9237,1403),(9238,1403),(9239,1403),(9240,1403),(9241,1404),(9242,1404),(9243,1404),(9244,1404),(9245,1405),(9246,1405),(9247,1405),(9248,1405),(9249,1406),(9250,1406),(9251,1406),(9252,1406),(9253,1407),(9254,1407),(9255,1407),(9256,1407),(9257,1408),(9258,1408),(9259,1408),(9260,1408),(9261,1409),(9262,1409),(9263,1409),(9264,1409),(9265,1410),(9266,1410),(9267,1410),(9268,1410),(9269,1411),(9270,1411),(9271,1411),(9272,1411),(9273,1412),(9274,1412),(9275,1412),(9276,1412),(9277,1413),(9278,1413),(9279,1413),(9280,1413),(9281,1414),(9282,1414),(9283,1414),(9284,1414),(9285,1415),(9286,1415),(9287,1415),(9288,1415),(9289,1416),(9290,1416),(9291,1416),(9292,1416),(9293,1417),(9294,1417),(9295,1417),(9296,1417),(9297,1418),(9298,1418),(9299,1418),(9300,1418),(9301,1419),(9302,1419),(9303,1419),(9304,1419),(9305,1420),(9306,1420),(9307,1420),(9308,1420),(9309,1421),(9310,1421),(9311,1421),(9312,1421),(9313,1422),(9314,1422),(9315,1422),(9316,1422),(9317,1423),(9318,1423),(9319,1423),(9320,1423),(9321,1424),(9322,1424),(9323,1424),(9324,1424),(9325,1425),(9326,1425),(9327,1425),(9328,1425),(9329,1426),(9330,1426),(9331,1426),(9332,1426),(9333,1427),(9334,1427),(9335,1427),(9336,1427),(9337,1428),(9338,1428),(9339,1428),(9340,1428),(9341,1429),(9342,1429),(9343,1429),(9344,1429),(9345,1430),(9346,1430),(9347,1430),(9348,1430),(9349,1431),(9350,1431),(9351,1431),(9352,1431),(9353,1432),(9354,1432),(9355,1432),(9356,1432),(9357,1433),(9358,1433),(9359,1433),(9360,1433),(9361,1434),(9362,1434),(9363,1434),(9364,1434),(9365,1435),(9366,1435),(9367,1435),(9368,1435),(9369,1436),(9370,1436),(9371,1436),(9372,1436),(9373,1437),(9374,1437),(9375,1437),(9376,1437),(9377,1438),(9378,1438),(9379,1438),(9380,1438),(9381,1439),(9382,1439),(9383,1439),(9384,1439),(9385,1440),(9386,1440),(9387,1440),(9388,1440),(9389,1441),(9390,1441),(9391,1441),(9392,1441),(9393,1442),(9394,1442),(9395,1442),(9396,1442),(9397,1443),(9398,1443),(9399,1443),(9400,1443),(9401,1444),(9402,1444),(9403,1444),(9404,1444),(9405,1445),(9406,1445),(9407,1445),(9408,1445),(9409,1446),(9410,1446),(9411,1446),(9412,1446),(9413,1447),(9414,1447),(9415,1447),(9416,1447),(9417,1448),(9418,1448),(9419,1448),(9420,1448),(9421,1449),(9422,1449),(9423,1449),(9424,1449),(9425,1450),(9426,1450),(9427,1450),(9428,1450),(9429,1451),(9430,1451),(9431,1451),(9432,1451),(9433,1452),(9434,1452),(9435,1452),(9436,1452),(9437,1453),(9438,1453),(9439,1453),(9440,1453),(9441,1454),(9442,1454),(9443,1454),(9444,1454),(9445,1455),(9446,1455),(9447,1455),(9448,1455),(9449,1456),(9450,1456),(9451,1456),(9452,1456),(9453,1457),(9454,1457),(9455,1457),(9456,1457),(9457,1458),(9458,1458),(9459,1458),(9460,1458),(9461,1459),(9462,1459),(9463,1459),(9464,1459),(9465,1460),(9466,1460),(9467,1460),(9468,1460),(9469,1461),(9470,1461),(9471,1461),(9472,1461),(9473,1462),(9474,1462),(9475,1462),(9476,1462),(9477,1463),(9478,1463),(9479,1463),(9480,1463),(9481,1464),(9482,1464),(9483,1464),(9484,1464),(9485,1465),(9486,1465),(9487,1465),(9488,1465),(9489,1466),(9490,1467),(9491,1468),(9492,1469),(9493,1470),(9494,1471),(9495,1472),(9496,1473),(9497,1474),(9498,1475),(9499,1476),(9500,1477),(9501,1478),(9502,1479),(9503,1480),(9504,1481),(9505,1482),(9506,1483),(9507,1484),(9508,1485),(9509,1486),(9510,1487),(9511,1488),(9512,1489),(9513,1490),(9514,1491),(9515,1492),(9516,1493),(9517,1494),(9518,1495),(9519,1496),(9520,1497),(9521,1498),(9522,1499),(9523,1500),(9524,1501),(9525,1502),(9526,1503),(9527,1504),(9528,1505),(9529,1506),(9530,1507),(9531,1508),(9532,1509),(9533,1510),(9534,1511),(9535,1512),(9536,1513),(9537,1514),(9538,1515),(9539,1516),(9540,1517),(9541,1518),(9542,1519),(9543,1520),(9544,1521),(9545,1522),(9546,1523),(9547,1524),(9548,1525),(9549,1526),(9550,1527),(9551,1528),(9552,1529),(9553,1530),(9554,1531),(9555,1532),(9556,1533),(9557,1534),(9558,1535),(9559,1536),(9560,1537),(9561,1538),(9562,1539),(9563,1540),(9564,1541),(9565,1542),(9566,1543),(9567,1544),(9568,1545),(9569,1546),(9570,1547),(9571,1548),(9572,1549),(9573,1550),(9574,1551),(9575,1552),(9576,1553),(9577,1554),(9578,1555),(9579,1556),(9580,1557),(9581,1558),(9582,1559),(9583,1560),(9584,1561),(9585,1562),(9586,1563),(9587,1564),(9588,1565),(9589,1466),(9590,1466),(9591,1466),(9592,1466),(9593,1467),(9594,1467),(9595,1467),(9596,1467),(9597,1468),(9598,1468),(9599,1468),(9600,1468),(9601,1469),(9602,1469),(9603,1469),(9604,1469),(9605,1470),(9606,1470),(9607,1470),(9608,1470),(9609,1471),(9610,1471),(9611,1471),(9612,1471),(9613,1472),(9614,1472),(9615,1472),(9616,1472),(9617,1473),(9618,1473),(9619,1473),(9620,1473),(9621,1474),(9622,1474),(9623,1474),(9624,1474),(9625,1475),(9626,1475),(9627,1475),(9628,1475),(9629,1476),(9630,1476),(9631,1476),(9632,1476),(9633,1477),(9634,1477),(9635,1477),(9636,1477),(9637,1478),(9638,1478),(9639,1478),(9640,1478),(9641,1479),(9642,1479),(9643,1479),(9644,1479),(9645,1480),(9646,1480),(9647,1480),(9648,1480),(9649,1481),(9650,1481),(9651,1481),(9652,1481),(9653,1482),(9654,1482),(9655,1482),(9656,1482),(9657,1483),(9658,1483),(9659,1483),(9660,1483),(9661,1484),(9662,1484),(9663,1484),(9664,1484),(9665,1485),(9666,1485),(9667,1485),(9668,1485),(9669,1486),(9670,1486),(9671,1486),(9672,1486),(9673,1487),(9674,1487),(9675,1487),(9676,1487),(9677,1488),(9678,1488),(9679,1488),(9680,1488),(9681,1489),(9682,1489),(9683,1489),(9684,1489),(9685,1490),(9686,1490),(9687,1490),(9688,1490),(9689,1491),(9690,1491),(9691,1491),(9692,1491),(9693,1492),(9694,1492),(9695,1492),(9696,1492),(9697,1493),(9698,1493),(9699,1493),(9700,1493),(9701,1494),(9702,1494),(9703,1494),(9704,1494),(9705,1495),(9706,1495),(9707,1495),(9708,1495),(9709,1496),(9710,1496),(9711,1496),(9712,1496),(9713,1497),(9714,1497),(9715,1497),(9716,1497),(9717,1498),(9718,1498),(9719,1498),(9720,1498),(9721,1499),(9722,1499),(9723,1499),(9724,1499),(9725,1500),(9726,1500),(9727,1500),(9728,1500),(9729,1501),(9730,1501),(9731,1501),(9732,1501),(9733,1502),(9734,1502),(9735,1502),(9736,1502),(9737,1503),(9738,1503),(9739,1503),(9740,1503),(9741,1504),(9742,1504),(9743,1504),(9744,1504),(9745,1505),(9746,1505),(9747,1505),(9748,1505),(9749,1506),(9750,1506),(9751,1506),(9752,1506),(9753,1507),(9754,1507),(9755,1507),(9756,1507),(9757,1508),(9758,1508),(9759,1508),(9760,1508),(9761,1509),(9762,1509),(9763,1509),(9764,1509),(9765,1510),(9766,1510),(9767,1510),(9768,1510),(9769,1511),(9770,1511),(9771,1511),(9772,1511),(9773,1512),(9774,1512),(9775,1512),(9776,1512),(9777,1513),(9778,1513),(9779,1513),(9780,1513),(9781,1514),(9782,1514),(9783,1514),(9784,1514),(9785,1515),(9786,1515),(9787,1515),(9788,1515),(9789,1516),(9790,1516),(9791,1516),(9792,1516),(9793,1517),(9794,1517),(9795,1517),(9796,1517),(9797,1518),(9798,1518),(9799,1518),(9800,1518),(9801,1519),(9802,1519),(9803,1519),(9804,1519),(9805,1520),(9806,1520),(9807,1520),(9808,1520),(9809,1521),(9810,1521),(9811,1521),(9812,1521),(9813,1522),(9814,1522),(9815,1522),(9816,1522),(9817,1523),(9818,1523),(9819,1523),(9820,1523),(9821,1524),(9822,1524),(9823,1524),(9824,1524),(9825,1525),(9826,1525),(9827,1525),(9828,1525),(9829,1526),(9830,1526),(9831,1526),(9832,1526),(9833,1527),(9834,1527),(9835,1527),(9836,1527),(9837,1528),(9838,1528),(9839,1528),(9840,1528),(9841,1529),(9842,1529),(9843,1529),(9844,1529),(9845,1530),(9846,1530),(9847,1530),(9848,1530),(9849,1531),(9850,1531),(9851,1531),(9852,1531),(9853,1532),(9854,1532),(9855,1532),(9856,1532),(9857,1533),(9858,1533),(9859,1533),(9860,1533),(9861,1534),(9862,1534),(9863,1534),(9864,1534),(9865,1535),(9866,1535),(9867,1535),(9868,1535),(9869,1536),(9870,1536),(9871,1536),(9872,1536),(9873,1537),(9874,1537),(9875,1537),(9876,1537),(9877,1538),(9878,1538),(9879,1538),(9880,1538),(9881,1539),(9882,1539),(9883,1539),(9884,1539),(9885,1540),(9886,1540),(9887,1540),(9888,1540),(9889,1541),(9890,1541),(9891,1541),(9892,1541),(9893,1542),(9894,1542),(9895,1542),(9896,1542),(9897,1543),(9898,1543),(9899,1543),(9900,1543),(9901,1544),(9902,1544),(9903,1544),(9904,1544),(9905,1545),(9906,1545),(9907,1545),(9908,1545),(9909,1546),(9910,1546),(9911,1546),(9912,1546),(9913,1547),(9914,1547),(9915,1547),(9916,1547),(9917,1548),(9918,1548),(9919,1548),(9920,1548),(9921,1549),(9922,1549),(9923,1549),(9924,1549),(9925,1550),(9926,1550),(9927,1550),(9928,1550),(9929,1551),(9930,1551),(9931,1551),(9932,1551),(9933,1552),(9934,1552),(9935,1552),(9936,1552),(9937,1553),(9938,1553),(9939,1553),(9940,1553),(9941,1554),(9942,1554),(9943,1554),(9944,1554),(9945,1555),(9946,1555),(9947,1555),(9948,1555),(9949,1556),(9950,1556),(9951,1556),(9952,1556),(9953,1557),(9954,1557),(9955,1557),(9956,1557),(9957,1558),(9958,1558),(9959,1558),(9960,1558),(9961,1559),(9962,1559),(9963,1559),(9964,1559),(9965,1560),(9966,1560),(9967,1560),(9968,1560),(9969,1561),(9970,1561),(9971,1561),(9972,1561),(9973,1562),(9974,1562),(9975,1562),(9976,1562),(9977,1563),(9978,1563),(9979,1563),(9980,1563),(9981,1564),(9982,1564),(9983,1564),(9984,1564),(9985,1565),(9986,1565),(9987,1565),(9988,1565),(9989,1566),(9990,1567),(9991,1568),(9992,1569),(9993,1570),(9994,1571),(9995,1572),(9996,1573),(9997,1574),(9998,1575),(9999,1576),(10000,1577),(10001,1578),(10002,1579),(10003,1580),(10004,1581),(10005,1582),(10006,1583),(10007,1584),(10008,1585),(10009,1586),(10010,1587),(10011,1588),(10012,1589),(10013,1590),(10014,1591),(10015,1592),(10016,1593),(10017,1594),(10018,1595),(10019,1596),(10020,1597),(10021,1598),(10022,1599),(10023,1600),(10024,1601),(10025,1602),(10026,1603),(10027,1604),(10028,1605),(10029,1606),(10030,1607),(10031,1608),(10032,1609),(10033,1610),(10034,1611),(10035,1612),(10036,1613),(10037,1614),(10038,1615),(10039,1616),(10040,1617),(10041,1618),(10042,1619),(10043,1620),(10044,1621),(10045,1622),(10046,1623),(10047,1624),(10048,1625),(10049,1626),(10050,1627),(10051,1628),(10052,1629),(10053,1630),(10054,1631),(10055,1632),(10056,1633),(10057,1634),(10058,1635),(10059,1636),(10060,1637),(10061,1638),(10062,1639),(10063,1640),(10064,1641),(10065,1642),(10066,1643),(10067,1644),(10068,1645),(10069,1646),(10070,1647),(10071,1648),(10072,1649),(10073,1650),(10074,1651),(10075,1652),(10076,1653),(10077,1654),(10078,1655),(10079,1656),(10080,1657),(10081,1658),(10082,1659),(10083,1660),(10084,1661),(10085,1662),(10086,1663),(10087,1664),(10088,1665),(10089,1566),(10090,1566),(10091,1566),(10092,1566),(10093,1567),(10094,1567),(10095,1567),(10096,1567),(10097,1568),(10098,1568),(10099,1568),(10100,1568),(10101,1569),(10102,1569),(10103,1569),(10104,1569),(10105,1570),(10106,1570),(10107,1570),(10108,1570),(10109,1571),(10110,1571),(10111,1571),(10112,1571),(10113,1572),(10114,1572),(10115,1572),(10116,1572),(10117,1573),(10118,1573),(10119,1573),(10120,1573),(10121,1574),(10122,1574),(10123,1574),(10124,1574),(10125,1575),(10126,1575),(10127,1575),(10128,1575),(10129,1576),(10130,1576),(10131,1576),(10132,1576),(10133,1577),(10134,1577),(10135,1577),(10136,1577),(10137,1578),(10138,1578),(10139,1578),(10140,1578),(10141,1579),(10142,1579),(10143,1579),(10144,1579),(10145,1580),(10146,1580),(10147,1580),(10148,1580),(10149,1581),(10150,1581),(10151,1581),(10152,1581),(10153,1582),(10154,1582),(10155,1582),(10156,1582),(10157,1583),(10158,1583),(10159,1583),(10160,1583),(10161,1584),(10162,1584),(10163,1584),(10164,1584),(10165,1585),(10166,1585),(10167,1585),(10168,1585),(10169,1586),(10170,1586),(10171,1586),(10172,1586),(10173,1587),(10174,1587),(10175,1587),(10176,1587),(10177,1588),(10178,1588),(10179,1588),(10180,1588),(10181,1589),(10182,1589),(10183,1589),(10184,1589),(10185,1590),(10186,1590),(10187,1590),(10188,1590),(10189,1591),(10190,1591),(10191,1591),(10192,1591),(10193,1592),(10194,1592),(10195,1592),(10196,1592),(10197,1593),(10198,1593),(10199,1593),(10200,1593),(10201,1594),(10202,1594),(10203,1594),(10204,1594),(10205,1595),(10206,1595),(10207,1595),(10208,1595),(10209,1596),(10210,1596),(10211,1596),(10212,1596),(10213,1597),(10214,1597),(10215,1597),(10216,1597),(10217,1598),(10218,1598),(10219,1598),(10220,1598),(10221,1599),(10222,1599),(10223,1599),(10224,1599),(10225,1600),(10226,1600),(10227,1600),(10228,1600),(10229,1601),(10230,1601),(10231,1601),(10232,1601),(10233,1602),(10234,1602),(10235,1602),(10236,1602),(10237,1603),(10238,1603),(10239,1603),(10240,1603),(10241,1604),(10242,1604),(10243,1604),(10244,1604),(10245,1605),(10246,1605),(10247,1605),(10248,1605),(10249,1606),(10250,1606),(10251,1606),(10252,1606),(10253,1607),(10254,1607),(10255,1607),(10256,1607),(10257,1608),(10258,1608),(10259,1608),(10260,1608),(10261,1609),(10262,1609),(10263,1609),(10264,1609),(10265,1610),(10266,1610),(10267,1610),(10268,1610),(10269,1611),(10270,1611),(10271,1611),(10272,1611),(10273,1612),(10274,1612),(10275,1612),(10276,1612),(10277,1613),(10278,1613),(10279,1613),(10280,1613),(10281,1614),(10282,1614),(10283,1614),(10284,1614),(10285,1615),(10286,1615),(10287,1615),(10288,1615),(10289,1616),(10290,1616),(10291,1616),(10292,1616),(10293,1617),(10294,1617),(10295,1617),(10296,1617),(10297,1618),(10298,1618),(10299,1618),(10300,1618),(10301,1619),(10302,1619),(10303,1619),(10304,1619),(10305,1620),(10306,1620),(10307,1620),(10308,1620),(10309,1621),(10310,1621),(10311,1621),(10312,1621),(10313,1622),(10314,1622),(10315,1622),(10316,1622),(10317,1623),(10318,1623),(10319,1623),(10320,1623),(10321,1624),(10322,1624),(10323,1624),(10324,1624),(10325,1625),(10326,1625),(10327,1625),(10328,1625),(10329,1626),(10330,1626),(10331,1626),(10332,1626),(10333,1627),(10334,1627),(10335,1627),(10336,1627),(10337,1628),(10338,1628),(10339,1628),(10340,1628),(10341,1629),(10342,1629),(10343,1629),(10344,1629),(10345,1630),(10346,1630),(10347,1630),(10348,1630),(10349,1631),(10350,1631),(10351,1631),(10352,1631),(10353,1632),(10354,1632),(10355,1632),(10356,1632),(10357,1633),(10358,1633),(10359,1633),(10360,1633),(10361,1634),(10362,1634),(10363,1634),(10364,1634),(10365,1635),(10366,1635),(10367,1635),(10368,1635),(10369,1636),(10370,1636),(10371,1636),(10372,1636),(10373,1637),(10374,1637),(10375,1637),(10376,1637),(10377,1638),(10378,1638),(10379,1638),(10380,1638),(10381,1639),(10382,1639),(10383,1639),(10384,1639),(10385,1640),(10386,1640),(10387,1640),(10388,1640),(10389,1641),(10390,1641),(10391,1641),(10392,1641),(10393,1642),(10394,1642),(10395,1642),(10396,1642),(10397,1643),(10398,1643),(10399,1643),(10400,1643),(10401,1644),(10402,1644),(10403,1644),(10404,1644),(10405,1645),(10406,1645),(10407,1645),(10408,1645),(10409,1646),(10410,1646),(10411,1646),(10412,1646),(10413,1647),(10414,1647),(10415,1647),(10416,1647),(10417,1648),(10418,1648),(10419,1648),(10420,1648),(10421,1649),(10422,1649),(10423,1649),(10424,1649),(10425,1650),(10426,1650),(10427,1650),(10428,1650),(10429,1651),(10430,1651),(10431,1651),(10432,1651),(10433,1652),(10434,1652),(10435,1652),(10436,1652),(10437,1653),(10438,1653),(10439,1653),(10440,1653),(10441,1654),(10442,1654),(10443,1654),(10444,1654),(10445,1655),(10446,1655),(10447,1655),(10448,1655),(10449,1656),(10450,1656),(10451,1656),(10452,1656),(10453,1657),(10454,1657),(10455,1657),(10456,1657),(10457,1658),(10458,1658),(10459,1658),(10460,1658),(10461,1659),(10462,1659),(10463,1659),(10464,1659),(10465,1660),(10466,1660),(10467,1660),(10468,1660),(10469,1661),(10470,1661),(10471,1661),(10472,1661),(10473,1662),(10474,1662),(10475,1662),(10476,1662),(10477,1663),(10478,1663),(10479,1663),(10480,1663),(10481,1664),(10482,1664),(10483,1664),(10484,1664),(10485,1665),(10486,1665),(10487,1665),(10488,1665),(10489,1666),(10490,1667),(10491,1668),(10492,1669),(10493,1670),(10494,1671),(10495,1672),(10496,1673),(10497,1674),(10498,1675),(10499,1676),(10500,1677),(10501,1678),(10502,1679),(10503,1680),(10504,1681),(10505,1682),(10506,1683),(10507,1684),(10508,1685),(10509,1686),(10510,1687),(10511,1688),(10512,1689),(10513,1690),(10514,1691),(10515,1692),(10516,1693),(10517,1694),(10518,1695),(10519,1696),(10520,1697),(10521,1698),(10522,1699),(10523,1700),(10524,1701),(10525,1702),(10526,1703),(10527,1704),(10528,1705),(10529,1706),(10530,1707),(10531,1708),(10532,1709),(10533,1710),(10534,1711),(10535,1712),(10536,1713),(10537,1714),(10538,1715),(10539,1716),(10540,1717),(10541,1718),(10542,1719),(10543,1720),(10544,1721),(10545,1722),(10546,1723),(10547,1724),(10548,1725),(10549,1726),(10550,1727),(10551,1728),(10552,1729),(10553,1730),(10554,1731),(10555,1732),(10556,1733),(10557,1734),(10558,1735),(10559,1736),(10560,1737),(10561,1738),(10562,1739),(10563,1740),(10564,1741),(10565,1742),(10566,1743),(10567,1744),(10568,1745),(10569,1746),(10570,1747),(10571,1748),(10572,1749),(10573,1750),(10574,1751),(10575,1752),(10576,1753),(10577,1754),(10578,1755),(10579,1756),(10580,1757),(10581,1758),(10582,1759),(10583,1760),(10584,1761),(10585,1762),(10586,1763),(10587,1764),(10588,1765),(10589,1666),(10590,1666),(10591,1666),(10592,1666),(10593,1667),(10594,1667),(10595,1667),(10596,1667),(10597,1668),(10598,1668),(10599,1668),(10600,1668),(10601,1669),(10602,1669),(10603,1669),(10604,1669),(10605,1670),(10606,1670),(10607,1670),(10608,1670),(10609,1671),(10610,1671),(10611,1671),(10612,1671),(10613,1672),(10614,1672),(10615,1672),(10616,1672),(10617,1673),(10618,1673),(10619,1673),(10620,1673),(10621,1674),(10622,1674),(10623,1674),(10624,1674),(10625,1675),(10626,1675),(10627,1675),(10628,1675),(10629,1676),(10630,1676),(10631,1676),(10632,1676),(10633,1677),(10634,1677),(10635,1677),(10636,1677),(10637,1678),(10638,1678),(10639,1678),(10640,1678),(10641,1679),(10642,1679),(10643,1679),(10644,1679),(10645,1680),(10646,1680),(10647,1680),(10648,1680),(10649,1681),(10650,1681),(10651,1681),(10652,1681),(10653,1682),(10654,1682),(10655,1682),(10656,1682),(10657,1683),(10658,1683),(10659,1683),(10660,1683),(10661,1684),(10662,1684),(10663,1684),(10664,1684),(10665,1685),(10666,1685),(10667,1685),(10668,1685),(10669,1686),(10670,1686),(10671,1686),(10672,1686),(10673,1687),(10674,1687),(10675,1687),(10676,1687),(10677,1688),(10678,1688),(10679,1688),(10680,1688),(10681,1689),(10682,1689),(10683,1689),(10684,1689),(10685,1690),(10686,1690),(10687,1690),(10688,1690),(10689,1691),(10690,1691),(10691,1691),(10692,1691),(10693,1692),(10694,1692),(10695,1692),(10696,1692),(10697,1693),(10698,1693),(10699,1693),(10700,1693),(10701,1694),(10702,1694),(10703,1694),(10704,1694),(10705,1695),(10706,1695),(10707,1695),(10708,1695),(10709,1696),(10710,1696),(10711,1696),(10712,1696),(10713,1697),(10714,1697),(10715,1697),(10716,1697),(10717,1698),(10718,1698),(10719,1698),(10720,1698),(10721,1699),(10722,1699),(10723,1699),(10724,1699),(10725,1700),(10726,1700),(10727,1700),(10728,1700),(10729,1701),(10730,1701),(10731,1701),(10732,1701),(10733,1702),(10734,1702),(10735,1702),(10736,1702),(10737,1703),(10738,1703),(10739,1703),(10740,1703),(10741,1704),(10742,1704),(10743,1704),(10744,1704),(10745,1705),(10746,1705),(10747,1705),(10748,1705),(10749,1706),(10750,1706),(10751,1706),(10752,1706),(10753,1707),(10754,1707),(10755,1707),(10756,1707),(10757,1708),(10758,1708),(10759,1708),(10760,1708),(10761,1709),(10762,1709),(10763,1709),(10764,1709),(10765,1710),(10766,1710),(10767,1710),(10768,1710),(10769,1711),(10770,1711),(10771,1711),(10772,1711),(10773,1712),(10774,1712),(10775,1712),(10776,1712),(10777,1713),(10778,1713),(10779,1713),(10780,1713),(10781,1714),(10782,1714),(10783,1714),(10784,1714),(10785,1715),(10786,1715),(10787,1715),(10788,1715),(10789,1716),(10790,1716),(10791,1716),(10792,1716),(10793,1717),(10794,1717),(10795,1717),(10796,1717),(10797,1718),(10798,1718),(10799,1718),(10800,1718),(10801,1719),(10802,1719),(10803,1719),(10804,1719),(10805,1720),(10806,1720),(10807,1720),(10808,1720),(10809,1721),(10810,1721),(10811,1721),(10812,1721),(10813,1722),(10814,1722),(10815,1722),(10816,1722),(10817,1723),(10818,1723),(10819,1723),(10820,1723),(10821,1724),(10822,1724),(10823,1724),(10824,1724),(10825,1725),(10826,1725),(10827,1725),(10828,1725),(10829,1726),(10830,1726),(10831,1726),(10832,1726),(10833,1727),(10834,1727),(10835,1727),(10836,1727),(10837,1728),(10838,1728),(10839,1728),(10840,1728),(10841,1729),(10842,1729),(10843,1729),(10844,1729),(10845,1730),(10846,1730),(10847,1730),(10848,1730),(10849,1731),(10850,1731),(10851,1731),(10852,1731),(10853,1732),(10854,1732),(10855,1732),(10856,1732),(10857,1733),(10858,1733),(10859,1733),(10860,1733),(10861,1734),(10862,1734),(10863,1734),(10864,1734),(10865,1735),(10866,1735),(10867,1735),(10868,1735),(10869,1736),(10870,1736),(10871,1736),(10872,1736),(10873,1737),(10874,1737),(10875,1737),(10876,1737),(10877,1738),(10878,1738),(10879,1738),(10880,1738),(10881,1739),(10882,1739),(10883,1739),(10884,1739),(10885,1740),(10886,1740),(10887,1740),(10888,1740),(10889,1741),(10890,1741),(10891,1741),(10892,1741),(10893,1742),(10894,1742),(10895,1742),(10896,1742),(10897,1743),(10898,1743),(10899,1743),(10900,1743),(10901,1744),(10902,1744),(10903,1744),(10904,1744),(10905,1745),(10906,1745),(10907,1745),(10908,1745),(10909,1746),(10910,1746),(10911,1746),(10912,1746),(10913,1747),(10914,1747),(10915,1747),(10916,1747),(10917,1748),(10918,1748),(10919,1748),(10920,1748),(10921,1749),(10922,1749),(10923,1749),(10924,1749),(10925,1750),(10926,1750),(10927,1750),(10928,1750),(10929,1751),(10930,1751),(10931,1751),(10932,1751),(10933,1752),(10934,1752),(10935,1752),(10936,1752),(10937,1753),(10938,1753),(10939,1753),(10940,1753),(10941,1754),(10942,1754),(10943,1754),(10944,1754),(10945,1755),(10946,1755),(10947,1755),(10948,1755),(10949,1756),(10950,1756),(10951,1756),(10952,1756),(10953,1757),(10954,1757),(10955,1757),(10956,1757),(10957,1758),(10958,1758),(10959,1758),(10960,1758),(10961,1759),(10962,1759),(10963,1759),(10964,1759),(10965,1760),(10966,1760),(10967,1760),(10968,1760),(10969,1761),(10970,1761),(10971,1761),(10972,1761),(10973,1762),(10974,1762),(10975,1762),(10976,1762),(10977,1763),(10978,1763),(10979,1763),(10980,1763),(10981,1764),(10982,1764),(10983,1764),(10984,1764),(10985,1765),(10986,1765),(10987,1765),(10988,1765),(10989,1766),(10990,1767),(10991,1768),(10992,1769),(10993,1770),(10994,1771),(10995,1772),(10996,1773),(10997,1774),(10998,1775),(10999,1776),(11000,1777),(11001,1778),(11002,1779),(11003,1780),(11004,1781),(11005,1782),(11006,1783),(11007,1784),(11008,1785),(11009,1786),(11010,1787),(11011,1788),(11012,1789),(11013,1790),(11014,1791),(11015,1792),(11016,1793),(11017,1794),(11018,1795),(11019,1796),(11020,1797),(11021,1798),(11022,1799),(11023,1800),(11024,1801),(11025,1802),(11026,1803),(11027,1804),(11028,1805),(11029,1806),(11030,1807),(11031,1808),(11032,1809),(11033,1810),(11034,1811),(11035,1812),(11036,1766),(11037,1766),(11038,1766),(11039,1766),(11040,1767),(11041,1767),(11042,1767),(11043,1767),(11044,1768),(11045,1768),(11046,1768),(11047,1768),(11048,1769),(11049,1769),(11050,1769),(11051,1769),(11052,1770),(11053,1770),(11054,1770),(11055,1770),(11056,1771),(11057,1771),(11058,1771),(11059,1771),(11060,1772),(11061,1772),(11062,1772),(11063,1772),(11064,1773),(11065,1773),(11066,1773),(11067,1773),(11068,1774),(11069,1774),(11070,1774),(11071,1774),(11072,1775),(11073,1775),(11074,1775),(11075,1775),(11076,1776),(11077,1776),(11078,1776),(11079,1776),(11080,1777),(11081,1777),(11082,1777),(11083,1777),(11084,1778),(11085,1778),(11086,1778),(11087,1778),(11088,1779),(11089,1779),(11090,1779),(11091,1779),(11092,1780),(11093,1780),(11094,1780),(11095,1780),(11096,1781),(11097,1781),(11098,1781),(11099,1781),(11100,1782),(11101,1782),(11102,1782),(11103,1782),(11104,1783),(11105,1783),(11106,1783),(11107,1783),(11108,1784),(11109,1784),(11110,1784),(11111,1784),(11112,1785),(11113,1785),(11114,1785),(11115,1785),(11116,1786),(11117,1786),(11118,1786),(11119,1786),(11120,1787),(11121,1787),(11122,1787),(11123,1787),(11124,1788),(11125,1788),(11126,1788),(11127,1788),(11128,1789),(11129,1789),(11130,1789),(11131,1789),(11132,1790),(11133,1790),(11134,1790),(11135,1790),(11136,1791),(11137,1791),(11138,1791),(11139,1791),(11140,1792),(11141,1792),(11142,1792),(11143,1792),(11144,1793),(11145,1793),(11146,1793),(11147,1793),(11148,1794),(11149,1794),(11150,1794),(11151,1794),(11152,1795),(11153,1795),(11154,1795),(11155,1795),(11156,1796),(11157,1796),(11158,1796),(11159,1796),(11160,1797),(11161,1797),(11162,1797),(11163,1797),(11164,1798),(11165,1798),(11166,1798),(11167,1798),(11168,1799),(11169,1799),(11170,1799),(11171,1799),(11172,1800),(11173,1800),(11174,1800),(11175,1800),(11176,1801),(11177,1801),(11178,1801),(11179,1801),(11180,1802),(11181,1802),(11182,1802),(11183,1802),(11184,1803),(11185,1803),(11186,1803),(11187,1803),(11188,1804),(11189,1804),(11190,1804),(11191,1804),(11192,1805),(11193,1805),(11194,1805),(11195,1805),(11196,1806),(11197,1806),(11198,1806),(11199,1806),(11200,1807),(11201,1807),(11202,1807),(11203,1807),(11204,1808),(11205,1808),(11206,1808),(11207,1808),(11208,1809),(11209,1809),(11210,1809),(11211,1809),(11212,1810),(11213,1810),(11214,1810),(11215,1810),(11216,1811),(11217,1811),(11218,1811),(11219,1811),(11220,1812),(11221,1812),(11222,1812),(11223,1812),(11224,1813),(11225,1814),(11226,1815),(11227,1816),(11228,1817),(11229,1818),(11230,1819),(11231,1820),(11232,1821),(11233,1822),(11234,1823),(11235,1813),(11236,1813),(11237,1813),(11238,1813),(11239,1814),(11240,1814),(11241,1814),(11242,1814),(11243,1815),(11244,1815),(11245,1815),(11246,1815),(11247,1816),(11248,1816),(11249,1816),(11250,1816),(11251,1817),(11252,1817),(11253,1817),(11254,1817),(11255,1818),(11256,1818),(11257,1818),(11258,1818),(11259,1819),(11260,1819),(11261,1819),(11262,1819),(11263,1820),(11264,1820),(11265,1820),(11266,1820),(11267,1821),(11268,1821),(11269,1821),(11270,1821),(11271,1822),(11272,1822),(11273,1822),(11274,1822),(11275,1823),(11276,1823),(11277,1823),(11278,1823),(11279,1824),(11280,1825),(11281,1826),(11282,1827),(11283,1828),(11284,1829),(11285,1830),(11286,1831),(11287,1832),(11288,1833),(11289,1834),(11290,1835),(11291,1836),(11292,1837),(11293,1838),(11294,1839),(11295,1840),(11296,1841),(11297,1842),(11298,1843),(11299,1844),(11300,1845),(11301,1846),(11302,1847),(11303,1848),(11304,1849),(11305,1850),(11306,1851),(11307,1852),(11308,1853),(11309,1854),(11310,1855),(11311,1856),(11312,1857),(11313,1858),(11314,1859),(11315,1860),(11316,1861),(11317,1862),(11318,1863),(11319,1864),(11320,1865),(11321,1866),(11322,1867),(11323,1868),(11324,1869),(11325,1870),(11326,1871),(11327,1872),(11328,1873),(11329,1874),(11330,1875),(11331,1876),(11332,1877),(11333,1878),(11334,1879),(11335,1880),(11336,1881),(11337,1882),(11338,1883),(11339,1884),(11340,1885),(11341,1886),(11342,1887),(11343,1888),(11344,1889),(11345,1890),(11346,1891),(11347,1892),(11348,1893),(11349,1894),(11350,1895),(11351,1896),(11352,1897),(11353,1898),(11354,1899),(11355,1900),(11356,1901),(11357,1902),(11358,1903),(11359,1904),(11360,1905),(11361,1906),(11362,1907),(11363,1908),(11364,1909),(11365,1910),(11366,1911),(11367,1912),(11368,1824),(11369,1824),(11370,1824),(11371,1824),(11372,1825),(11373,1825),(11374,1825),(11375,1825),(11376,1826),(11377,1826),(11378,1826),(11379,1826),(11380,1827),(11381,1827),(11382,1827),(11383,1827),(11384,1828),(11385,1828),(11386,1828),(11387,1828),(11388,1829),(11389,1829),(11390,1829),(11391,1829),(11392,1830),(11393,1830),(11394,1830),(11395,1830),(11396,1831),(11397,1831),(11398,1831),(11399,1831),(11400,1832),(11401,1832),(11402,1832),(11403,1832),(11404,1833),(11405,1833),(11406,1833),(11407,1833),(11408,1834),(11409,1834),(11410,1834),(11411,1834),(11412,1835),(11413,1835),(11414,1835),(11415,1835),(11416,1836),(11417,1836),(11418,1836),(11419,1836),(11420,1837),(11421,1837),(11422,1837),(11423,1837),(11424,1838),(11425,1838),(11426,1838),(11427,1838),(11428,1839),(11429,1839),(11430,1839),(11431,1839),(11432,1840),(11433,1840),(11434,1840),(11435,1840),(11436,1841),(11437,1841),(11438,1841),(11439,1841),(11440,1842),(11441,1842),(11442,1842),(11443,1842),(11444,1843),(11445,1843),(11446,1843),(11447,1843),(11448,1844),(11449,1844),(11450,1844),(11451,1844),(11452,1845),(11453,1845),(11454,1845),(11455,1845),(11456,1846),(11457,1846),(11458,1846),(11459,1846),(11460,1847),(11461,1847),(11462,1847),(11463,1847),(11464,1848),(11465,1848),(11466,1848),(11467,1848),(11468,1849),(11469,1849),(11470,1849),(11471,1849),(11472,1850),(11473,1850),(11474,1850),(11475,1850),(11476,1851),(11477,1851),(11478,1851),(11479,1851),(11480,1852),(11481,1852),(11482,1852),(11483,1852),(11484,1853),(11485,1853),(11486,1853),(11487,1853),(11488,1854),(11489,1854),(11490,1854),(11491,1854),(11492,1855),(11493,1855),(11494,1855),(11495,1855),(11496,1856),(11497,1856),(11498,1856),(11499,1856),(11500,1857),(11501,1857),(11502,1857),(11503,1857),(11504,1858),(11505,1858),(11506,1858),(11507,1858),(11508,1859),(11509,1859),(11510,1859),(11511,1859),(11512,1860),(11513,1860),(11514,1860),(11515,1860),(11516,1861),(11517,1861),(11518,1861),(11519,1861),(11520,1862),(11521,1862),(11522,1862),(11523,1862),(11524,1863),(11525,1863),(11526,1863),(11527,1863),(11528,1864),(11529,1864),(11530,1864),(11531,1864),(11532,1865),(11533,1865),(11534,1865),(11535,1865),(11536,1866),(11537,1866),(11538,1866),(11539,1866),(11540,1867),(11541,1867),(11542,1867),(11543,1867),(11544,1868),(11545,1868),(11546,1868),(11547,1868),(11548,1869),(11549,1869),(11550,1869),(11551,1869),(11552,1870),(11553,1870),(11554,1870),(11555,1870),(11556,1871),(11557,1871),(11558,1871),(11559,1871),(11560,1872),(11561,1872),(11562,1872),(11563,1872),(11564,1873),(11565,1873),(11566,1873),(11567,1873),(11568,1874),(11569,1874),(11570,1874),(11571,1874),(11572,1875),(11573,1875),(11574,1875),(11575,1875),(11576,1876),(11577,1876),(11578,1876),(11579,1876),(11580,1877),(11581,1877),(11582,1877),(11583,1877),(11584,1878),(11585,1878),(11586,1878),(11587,1878),(11588,1879),(11589,1879),(11590,1879),(11591,1879),(11592,1880),(11593,1880),(11594,1880),(11595,1880),(11596,1881),(11597,1881),(11598,1881),(11599,1881),(11600,1882),(11601,1882),(11602,1882),(11603,1882),(11604,1883),(11605,1883),(11606,1883),(11607,1883),(11608,1884),(11609,1884),(11610,1884),(11611,1884),(11612,1885),(11613,1885),(11614,1885),(11615,1885),(11616,1886),(11617,1886),(11618,1886),(11619,1886),(11620,1887),(11621,1887),(11622,1887),(11623,1887),(11624,1888),(11625,1888),(11626,1888),(11627,1888),(11628,1889),(11629,1889),(11630,1889),(11631,1889),(11632,1890),(11633,1890),(11634,1890),(11635,1890),(11636,1891),(11637,1891),(11638,1891),(11639,1891),(11640,1892),(11641,1892),(11642,1892),(11643,1892),(11644,1893),(11645,1893),(11646,1893),(11647,1893),(11648,1894),(11649,1894),(11650,1894),(11651,1894),(11652,1895),(11653,1895),(11654,1895),(11655,1895),(11656,1896),(11657,1896),(11658,1896),(11659,1896),(11660,1897),(11661,1897),(11662,1897),(11663,1897),(11664,1898),(11665,1898),(11666,1898),(11667,1898),(11668,1899),(11669,1899),(11670,1899),(11671,1899),(11672,1900),(11673,1900),(11674,1900),(11675,1900),(11676,1901),(11677,1901),(11678,1901),(11679,1901),(11680,1902),(11681,1902),(11682,1902),(11683,1902),(11684,1903),(11685,1903),(11686,1903),(11687,1903),(11688,1904),(11689,1904),(11690,1904),(11691,1904),(11692,1905),(11693,1905),(11694,1905),(11695,1905),(11696,1906),(11697,1906),(11698,1906),(11699,1906),(11700,1907),(11701,1907),(11702,1907),(11703,1907),(11704,1908),(11705,1908),(11706,1908),(11707,1908),(11708,1909),(11709,1909),(11710,1909),(11711,1909),(11712,1910),(11713,1910),(11714,1910),(11715,1910),(11716,1911),(11717,1911),(11718,1911),(11719,1911),(11720,1912),(11721,1912),(11722,1912),(11723,1912),(11724,1913),(11725,1914),(11726,1915),(11727,1916),(11728,1917),(11729,1918),(11730,1919),(11731,1920),(11732,1921),(11733,1922),(11734,1923),(11735,1924),(11736,1925),(11737,1926),(11738,1927),(11739,1928),(11740,1929),(11741,1930),(11742,1931),(11743,1932),(11744,1933),(11745,1934),(11746,1935),(11747,1936),(11748,1937),(11749,1938),(11750,1939),(11751,1940),(11752,1941),(11753,1942),(11754,1943),(11755,1944),(11756,1945),(11757,1946),(11758,1947),(11759,1948),(11760,1949),(11761,1950),(11762,1951),(11763,1952),(11764,1953),(11765,1954),(11766,1955),(11767,1956),(11768,1957),(11769,1958),(11770,1959),(11771,1960),(11772,1961),(11773,1962),(11774,1963),(11775,1964),(11776,1965),(11777,1966),(11778,1967),(11779,1968),(11780,1969),(11781,1970),(11782,1971),(11783,1972),(11784,1973),(11785,1974),(11786,1975),(11787,1976),(11788,1977),(11789,1978),(11790,1979),(11791,1980),(11792,1981),(11793,1982),(11794,1983),(11795,1984),(11796,1985),(11797,1986),(11798,1987),(11799,1988),(11800,1989),(11801,1990),(11802,1991),(11803,1992),(11804,1993),(11805,1994),(11806,1995),(11807,1996),(11808,1997),(11809,1998),(11810,1999),(11811,2000),(11812,2001),(11813,2002),(11814,2003),(11815,2004),(11816,2005),(11817,2006),(11818,2007),(11819,2008),(11820,2009),(11821,2010),(11822,2011),(11823,2012),(11824,1913),(11825,1913),(11826,1913),(11827,1913),(11828,1914),(11829,1914),(11830,1914),(11831,1914),(11832,1915),(11833,1915),(11834,1915),(11835,1915),(11836,1916),(11837,1916),(11838,1916),(11839,1916),(11840,1917),(11841,1917),(11842,1917),(11843,1917),(11844,1918),(11845,1918),(11846,1918),(11847,1918),(11848,1919),(11849,1919),(11850,1919),(11851,1919),(11852,1920),(11853,1920),(11854,1920),(11855,1920),(11856,1921),(11857,1921),(11858,1921),(11859,1921),(11860,1922),(11861,1922),(11862,1922),(11863,1922),(11864,1923),(11865,1923),(11866,1923),(11867,1923),(11868,1924),(11869,1924),(11870,1924),(11871,1924),(11872,1925),(11873,1925),(11874,1925),(11875,1925),(11876,1926),(11877,1926),(11878,1926),(11879,1926),(11880,1927),(11881,1927),(11882,1927),(11883,1927),(11884,1928),(11885,1928),(11886,1928),(11887,1928),(11888,1929),(11889,1929),(11890,1929),(11891,1929),(11892,1930),(11893,1930),(11894,1930),(11895,1930),(11896,1931),(11897,1931),(11898,1931),(11899,1931),(11900,1932),(11901,1932),(11902,1932),(11903,1932),(11904,1933),(11905,1933),(11906,1933),(11907,1933),(11908,1934),(11909,1934),(11910,1934),(11911,1934),(11912,1935),(11913,1935),(11914,1935),(11915,1935),(11916,1936),(11917,1936),(11918,1936),(11919,1936),(11920,1937),(11921,1937),(11922,1937),(11923,1937),(11924,1938),(11925,1938),(11926,1938),(11927,1938),(11928,1939),(11929,1939),(11930,1939),(11931,1939),(11932,1940),(11933,1940),(11934,1940),(11935,1940),(11936,1941),(11937,1941),(11938,1941),(11939,1941),(11940,1942),(11941,1942),(11942,1942),(11943,1942),(11944,1943),(11945,1943),(11946,1943),(11947,1943),(11948,1944),(11949,1944),(11950,1944),(11951,1944),(11952,1945),(11953,1945),(11954,1945),(11955,1945),(11956,1946),(11957,1946),(11958,1946),(11959,1946),(11960,1947),(11961,1947),(11962,1947),(11963,1947),(11964,1948),(11965,1948),(11966,1948),(11967,1948),(11968,1949),(11969,1949),(11970,1949),(11971,1949),(11972,1950),(11973,1950),(11974,1950),(11975,1950),(11976,1951),(11977,1951),(11978,1951),(11979,1951),(11980,1952),(11981,1952),(11982,1952),(11983,1952),(11984,1953),(11985,1953),(11986,1953),(11987,1953),(11988,1954),(11989,1954),(11990,1954),(11991,1954),(11992,1955),(11993,1955),(11994,1955),(11995,1955),(11996,1956),(11997,1956),(11998,1956),(11999,1956),(12000,1957),(12001,1957),(12002,1957),(12003,1957),(12004,1958),(12005,1958),(12006,1958),(12007,1958),(12008,1959),(12009,1959),(12010,1959),(12011,1959),(12012,1960),(12013,1960),(12014,1960),(12015,1960),(12016,1961),(12017,1961),(12018,1961),(12019,1961),(12020,1962),(12021,1962),(12022,1962),(12023,1962),(12024,1963),(12025,1963),(12026,1963),(12027,1963),(12028,1964),(12029,1964),(12030,1964),(12031,1964),(12032,1965),(12033,1965),(12034,1965),(12035,1965),(12036,1966),(12037,1966),(12038,1966),(12039,1966),(12040,1967),(12041,1967),(12042,1967),(12043,1967),(12044,1968),(12045,1968),(12046,1968),(12047,1968),(12048,1969),(12049,1969),(12050,1969),(12051,1969),(12052,1970),(12053,1970),(12054,1970),(12055,1970),(12056,1971),(12057,1971),(12058,1971),(12059,1971),(12060,1972),(12061,1972),(12062,1972),(12063,1972),(12064,1973),(12065,1973),(12066,1973),(12067,1973),(12068,1974),(12069,1974),(12070,1974),(12071,1974),(12072,1975),(12073,1975),(12074,1975),(12075,1975),(12076,1976),(12077,1976),(12078,1976),(12079,1976),(12080,1977),(12081,1977),(12082,1977),(12083,1977),(12084,1978),(12085,1978),(12086,1978),(12087,1978),(12088,1979),(12089,1979),(12090,1979),(12091,1979),(12092,1980),(12093,1980),(12094,1980),(12095,1980),(12096,1981),(12097,1981),(12098,1981),(12099,1981),(12100,1982),(12101,1982),(12102,1982),(12103,1982),(12104,1983),(12105,1983),(12106,1983),(12107,1983),(12108,1984),(12109,1984),(12110,1984),(12111,1984),(12112,1985),(12113,1985),(12114,1985),(12115,1985),(12116,1986),(12117,1986),(12118,1986),(12119,1986),(12120,1987),(12121,1987),(12122,1987),(12123,1987),(12124,1988),(12125,1988),(12126,1988),(12127,1988),(12128,1989),(12129,1989),(12130,1989),(12131,1989),(12132,1990),(12133,1990),(12134,1990),(12135,1990),(12136,1991),(12137,1991),(12138,1991),(12139,1991),(12140,1992),(12141,1992),(12142,1992),(12143,1992),(12144,1993),(12145,1993),(12146,1993),(12147,1993),(12148,1994),(12149,1994),(12150,1994),(12151,1994),(12152,1995),(12153,1995),(12154,1995),(12155,1995),(12156,1996),(12157,1996),(12158,1996),(12159,1996),(12160,1997),(12161,1997),(12162,1997),(12163,1997),(12164,1998),(12165,1998),(12166,1998),(12167,1998),(12168,1999),(12169,1999),(12170,1999),(12171,1999),(12172,2000),(12173,2000),(12174,2000),(12175,2000),(12176,2001),(12177,2001),(12178,2001),(12179,2001),(12180,2002),(12181,2002),(12182,2002),(12183,2002),(12184,2003),(12185,2003),(12186,2003),(12187,2003),(12188,2004),(12189,2004),(12190,2004),(12191,2004),(12192,2005),(12193,2005),(12194,2005),(12195,2005),(12196,2006),(12197,2006),(12198,2006),(12199,2006),(12200,2007),(12201,2007),(12202,2007),(12203,2007),(12204,2008),(12205,2008),(12206,2008),(12207,2008),(12208,2009),(12209,2009),(12210,2009),(12211,2009),(12212,2010),(12213,2010),(12214,2010),(12215,2010),(12216,2011),(12217,2011),(12218,2011),(12219,2011),(12220,2012),(12221,2012),(12222,2012),(12223,2012),(12224,2013),(12225,2014),(12226,2015),(12227,2016),(12228,2017),(12229,2018),(12230,2019),(12231,2020),(12232,2021),(12233,2022),(12234,2023),(12235,2024),(12236,2025),(12237,2026),(12238,2027),(12239,2028),(12240,2029),(12241,2030),(12242,2031),(12243,2032),(12244,2033),(12245,2034),(12246,2035),(12247,2036),(12248,2037),(12249,2038),(12250,2039),(12251,2040),(12252,2041),(12253,2042),(12254,2043),(12255,2044),(12256,2045),(12257,2046),(12258,2047),(12259,2048),(12260,2049),(12261,2050),(12262,2051),(12263,2052),(12264,2053),(12265,2054),(12266,2055),(12267,2056),(12268,2057),(12269,2058),(12270,2059),(12271,2060),(12272,2061),(12273,2062),(12274,2063),(12275,2064),(12276,2065),(12277,2066),(12278,2067),(12279,2068),(12280,2069),(12281,2070),(12282,2071),(12283,2072),(12284,2073),(12285,2074),(12286,2075),(12287,2076),(12288,2077),(12289,2078),(12290,2079),(12291,2080),(12292,2081),(12293,2082),(12294,2083),(12295,2084),(12296,2085),(12297,2086),(12298,2087),(12299,2088),(12300,2089),(12301,2090),(12302,2091),(12303,2092),(12304,2093),(12305,2094),(12306,2095),(12307,2096),(12308,2097),(12309,2098),(12310,2099),(12311,2100),(12312,2101),(12313,2102),(12314,2103),(12315,2104),(12316,2105),(12317,2106),(12318,2107),(12319,2108),(12320,2109),(12321,2110),(12322,2111),(12323,2112),(12324,2013),(12325,2013),(12326,2013),(12327,2013),(12328,2014),(12329,2014),(12330,2014),(12331,2014),(12332,2015),(12333,2015),(12334,2015),(12335,2015),(12336,2016),(12337,2016),(12338,2016),(12339,2016),(12340,2017),(12341,2017),(12342,2017),(12343,2017),(12344,2018),(12345,2018),(12346,2018),(12347,2018),(12348,2019),(12349,2019),(12350,2019),(12351,2019),(12352,2020),(12353,2020),(12354,2020),(12355,2020),(12356,2021),(12357,2021),(12358,2021),(12359,2021),(12360,2022),(12361,2022),(12362,2022),(12363,2022),(12364,2023),(12365,2023),(12366,2023),(12367,2023),(12368,2024),(12369,2024),(12370,2024),(12371,2024),(12372,2025),(12373,2025),(12374,2025),(12375,2025),(12376,2026),(12377,2026),(12378,2026),(12379,2026),(12380,2027),(12381,2027),(12382,2027),(12383,2027),(12384,2028),(12385,2028),(12386,2028),(12387,2028),(12388,2029),(12389,2029),(12390,2029),(12391,2029),(12392,2030),(12393,2030),(12394,2030),(12395,2030),(12396,2031),(12397,2031),(12398,2031),(12399,2031),(12400,2032),(12401,2032),(12402,2032),(12403,2032),(12404,2033),(12405,2033),(12406,2033),(12407,2033),(12408,2034),(12409,2034),(12410,2034),(12411,2034),(12412,2035),(12413,2035),(12414,2035),(12415,2035),(12416,2036),(12417,2036),(12418,2036),(12419,2036),(12420,2037),(12421,2037),(12422,2037),(12423,2037),(12424,2038),(12425,2038),(12426,2038),(12427,2038),(12428,2039),(12429,2039),(12430,2039),(12431,2039),(12432,2040),(12433,2040),(12434,2040),(12435,2040),(12436,2041),(12437,2041),(12438,2041),(12439,2041),(12440,2042),(12441,2042),(12442,2042),(12443,2042),(12444,2043),(12445,2043),(12446,2043),(12447,2043),(12448,2044),(12449,2044),(12450,2044),(12451,2044),(12452,2045),(12453,2045),(12454,2045),(12455,2045),(12456,2046),(12457,2046),(12458,2046),(12459,2046),(12460,2047),(12461,2047),(12462,2047),(12463,2047),(12464,2048),(12465,2048),(12466,2048),(12467,2048),(12468,2049),(12469,2049),(12470,2049),(12471,2049),(12472,2050),(12473,2050),(12474,2050),(12475,2050),(12476,2051),(12477,2051),(12478,2051),(12479,2051),(12480,2052),(12481,2052),(12482,2052),(12483,2052),(12484,2053),(12485,2053),(12486,2053),(12487,2053),(12488,2054),(12489,2054),(12490,2054),(12491,2054),(12492,2055),(12493,2055),(12494,2055),(12495,2055),(12496,2056),(12497,2056),(12498,2056),(12499,2056),(12500,2057),(12501,2057),(12502,2057),(12503,2057),(12504,2058),(12505,2058),(12506,2058),(12507,2058),(12508,2059),(12509,2059),(12510,2059),(12511,2059),(12512,2060),(12513,2060),(12514,2060),(12515,2060),(12516,2061),(12517,2061),(12518,2061),(12519,2061),(12520,2062),(12521,2062),(12522,2062),(12523,2062),(12524,2063),(12525,2063),(12526,2063),(12527,2063),(12528,2064),(12529,2064),(12530,2064),(12531,2064),(12532,2065),(12533,2065),(12534,2065),(12535,2065),(12536,2066),(12537,2066),(12538,2066),(12539,2066),(12540,2067),(12541,2067),(12542,2067),(12543,2067),(12544,2068),(12545,2068),(12546,2068),(12547,2068),(12548,2069),(12549,2069),(12550,2069),(12551,2069),(12552,2070),(12553,2070),(12554,2070),(12555,2070),(12556,2071),(12557,2071),(12558,2071),(12559,2071),(12560,2072),(12561,2072),(12562,2072),(12563,2072),(12564,2073),(12565,2073),(12566,2073),(12567,2073),(12568,2074),(12569,2074),(12570,2074),(12571,2074),(12572,2075),(12573,2075),(12574,2075),(12575,2075),(12576,2076),(12577,2076),(12578,2076),(12579,2076),(12580,2077),(12581,2077),(12582,2077),(12583,2077),(12584,2078),(12585,2078),(12586,2078),(12587,2078),(12588,2079),(12589,2079),(12590,2079),(12591,2079),(12592,2080),(12593,2080),(12594,2080),(12595,2080),(12596,2081),(12597,2081),(12598,2081),(12599,2081),(12600,2082),(12601,2082),(12602,2082),(12603,2082),(12604,2083),(12605,2083),(12606,2083),(12607,2083),(12608,2084),(12609,2084),(12610,2084),(12611,2084),(12612,2085),(12613,2085),(12614,2085),(12615,2085),(12616,2086),(12617,2086),(12618,2086),(12619,2086),(12620,2087),(12621,2087),(12622,2087),(12623,2087),(12624,2088),(12625,2088),(12626,2088),(12627,2088),(12628,2089),(12629,2089),(12630,2089),(12631,2089),(12632,2090),(12633,2090),(12634,2090),(12635,2090),(12636,2091),(12637,2091),(12638,2091),(12639,2091),(12640,2092),(12641,2092),(12642,2092),(12643,2092),(12644,2093),(12645,2093),(12646,2093),(12647,2093),(12648,2094),(12649,2094),(12650,2094),(12651,2094),(12652,2095),(12653,2095),(12654,2095),(12655,2095),(12656,2096),(12657,2096),(12658,2096),(12659,2096),(12660,2097),(12661,2097),(12662,2097),(12663,2097),(12664,2098),(12665,2098),(12666,2098),(12667,2098),(12668,2099),(12669,2099),(12670,2099),(12671,2099),(12672,2100),(12673,2100),(12674,2100),(12675,2100),(12676,2101),(12677,2101),(12678,2101),(12679,2101),(12680,2102),(12681,2102),(12682,2102),(12683,2102),(12684,2103),(12685,2103),(12686,2103),(12687,2103),(12688,2104),(12689,2104),(12690,2104),(12691,2104),(12692,2105),(12693,2105),(12694,2105),(12695,2105),(12696,2106),(12697,2106),(12698,2106),(12699,2106),(12700,2107),(12701,2107),(12702,2107),(12703,2107),(12704,2108),(12705,2108),(12706,2108),(12707,2108),(12708,2109),(12709,2109),(12710,2109),(12711,2109),(12712,2110),(12713,2110),(12714,2110),(12715,2110),(12716,2111),(12717,2111),(12718,2111),(12719,2111),(12720,2112),(12721,2112),(12722,2112),(12723,2112),(12724,2113),(12725,2114),(12726,2115),(12727,2116),(12728,2117),(12729,2118),(12730,2119),(12731,2120),(12732,2121),(12733,2122),(12734,2123),(12735,2124),(12736,2125),(12737,2126),(12738,2127),(12739,2128),(12740,2129),(12741,2130),(12742,2131),(12743,2132),(12744,2133),(12745,2134),(12746,2135),(12747,2136),(12748,2137),(12749,2138),(12750,2139),(12751,2140),(12752,2141),(12753,2142),(12754,2143),(12755,2144),(12756,2145),(12757,2146),(12758,2147),(12759,2148),(12760,2149),(12761,2150),(12762,2151),(12763,2152),(12764,2153),(12765,2154),(12766,2155),(12767,2156),(12768,2157),(12769,2158),(12770,2159),(12771,2160),(12772,2161),(12773,2162),(12774,2163),(12775,2164),(12776,2165),(12777,2166),(12778,2167),(12779,2168),(12780,2169),(12781,2170),(12782,2171),(12783,2172),(12784,2173),(12785,2174),(12786,2175),(12787,2176),(12788,2177),(12789,2178),(12790,2179),(12791,2180),(12792,2181),(12793,2182),(12794,2183),(12795,2184),(12796,2185),(12797,2186),(12798,2187),(12799,2188),(12800,2189),(12801,2190),(12802,2191),(12803,2192),(12804,2193),(12805,2194),(12806,2195),(12807,2196),(12808,2197),(12809,2198),(12810,2199),(12811,2200),(12812,2201),(12813,2202),(12814,2203),(12815,2204),(12816,2205),(12817,2206),(12818,2207),(12819,2208),(12820,2209),(12821,2210),(12822,2211),(12823,2212),(12824,2113),(12825,2113),(12826,2113),(12827,2113),(12828,2114),(12829,2114),(12830,2114),(12831,2114),(12832,2115),(12833,2115),(12834,2115),(12835,2115),(12836,2116),(12837,2116),(12838,2116),(12839,2116),(12840,2117),(12841,2117),(12842,2117),(12843,2117),(12844,2118),(12845,2118),(12846,2118),(12847,2118),(12848,2119),(12849,2119),(12850,2119),(12851,2119),(12852,2120),(12853,2120),(12854,2120),(12855,2120),(12856,2121),(12857,2121),(12858,2121),(12859,2121),(12860,2122),(12861,2122),(12862,2122),(12863,2122),(12864,2123),(12865,2123),(12866,2123),(12867,2123),(12868,2124),(12869,2124),(12870,2124),(12871,2124),(12872,2125),(12873,2125),(12874,2125),(12875,2125),(12876,2126),(12877,2126),(12878,2126),(12879,2126),(12880,2127),(12881,2127),(12882,2127),(12883,2127),(12884,2128),(12885,2128),(12886,2128),(12887,2128),(12888,2129),(12889,2129),(12890,2129),(12891,2129),(12892,2130),(12893,2130),(12894,2130),(12895,2130),(12896,2131),(12897,2131),(12898,2131),(12899,2131),(12900,2132),(12901,2132),(12902,2132),(12903,2132),(12904,2133),(12905,2133),(12906,2133),(12907,2133),(12908,2134),(12909,2134),(12910,2134),(12911,2134),(12912,2135),(12913,2135),(12914,2135),(12915,2135),(12916,2136),(12917,2136),(12918,2136),(12919,2136),(12920,2137),(12921,2137),(12922,2137),(12923,2137),(12924,2138),(12925,2138),(12926,2138),(12927,2138),(12928,2139),(12929,2139),(12930,2139),(12931,2139),(12932,2140),(12933,2140),(12934,2140),(12935,2140),(12936,2141),(12937,2141),(12938,2141),(12939,2141),(12940,2142),(12941,2142),(12942,2142),(12943,2142),(12944,2143),(12945,2143),(12946,2143),(12947,2143),(12948,2144),(12949,2144),(12950,2144),(12951,2144),(12952,2145),(12953,2145),(12954,2145),(12955,2145),(12956,2146),(12957,2146),(12958,2146),(12959,2146),(12960,2147),(12961,2147),(12962,2147),(12963,2147),(12964,2148),(12965,2148),(12966,2148),(12967,2148),(12968,2149),(12969,2149),(12970,2149),(12971,2149),(12972,2150),(12973,2150),(12974,2150),(12975,2150),(12976,2151),(12977,2151),(12978,2151),(12979,2151),(12980,2152),(12981,2152),(12982,2152),(12983,2152),(12984,2153),(12985,2153),(12986,2153),(12987,2153),(12988,2154),(12989,2154),(12990,2154),(12991,2154),(12992,2155),(12993,2155),(12994,2155),(12995,2155),(12996,2156),(12997,2156),(12998,2156),(12999,2156),(13000,2157),(13001,2157),(13002,2157),(13003,2157),(13004,2158),(13005,2158),(13006,2158),(13007,2158),(13008,2159),(13009,2159),(13010,2159),(13011,2159),(13012,2160),(13013,2160),(13014,2160),(13015,2160),(13016,2161),(13017,2161),(13018,2161),(13019,2161),(13020,2162),(13021,2162),(13022,2162),(13023,2162),(13024,2163),(13025,2163),(13026,2163),(13027,2163),(13028,2164),(13029,2164),(13030,2164),(13031,2164),(13032,2165),(13033,2165),(13034,2165),(13035,2165),(13036,2166),(13037,2166),(13038,2166),(13039,2166),(13040,2167),(13041,2167),(13042,2167),(13043,2167),(13044,2168),(13045,2168),(13046,2168),(13047,2168),(13048,2169),(13049,2169),(13050,2169),(13051,2169),(13052,2170),(13053,2170),(13054,2170),(13055,2170),(13056,2171),(13057,2171),(13058,2171),(13059,2171),(13060,2172),(13061,2172),(13062,2172),(13063,2172),(13064,2173),(13065,2173),(13066,2173),(13067,2173),(13068,2174),(13069,2174),(13070,2174),(13071,2174),(13072,2175),(13073,2175),(13074,2175),(13075,2175),(13076,2176),(13077,2176),(13078,2176),(13079,2176),(13080,2177),(13081,2177),(13082,2177),(13083,2177),(13084,2178),(13085,2178),(13086,2178),(13087,2178),(13088,2179),(13089,2179),(13090,2179),(13091,2179),(13092,2180),(13093,2180),(13094,2180),(13095,2180),(13096,2181),(13097,2181),(13098,2181),(13099,2181),(13100,2182),(13101,2182),(13102,2182),(13103,2182),(13104,2183),(13105,2183),(13106,2183),(13107,2183),(13108,2184),(13109,2184),(13110,2184),(13111,2184),(13112,2185),(13113,2185),(13114,2185),(13115,2185),(13116,2186),(13117,2186),(13118,2186),(13119,2186),(13120,2187),(13121,2187),(13122,2187),(13123,2187),(13124,2188),(13125,2188),(13126,2188),(13127,2188),(13128,2189),(13129,2189),(13130,2189),(13131,2189),(13132,2190),(13133,2190),(13134,2190),(13135,2190),(13136,2191),(13137,2191),(13138,2191),(13139,2191),(13140,2192),(13141,2192),(13142,2192),(13143,2192),(13144,2193),(13145,2193),(13146,2193),(13147,2193),(13148,2194),(13149,2194),(13150,2194),(13151,2194),(13152,2195),(13153,2195),(13154,2195),(13155,2195),(13156,2196),(13157,2196),(13158,2196),(13159,2196),(13160,2197),(13161,2197),(13162,2197),(13163,2197),(13164,2198),(13165,2198),(13166,2198),(13167,2198),(13168,2199),(13169,2199),(13170,2199),(13171,2199),(13172,2200),(13173,2200),(13174,2200),(13175,2200),(13176,2201),(13177,2201),(13178,2201),(13179,2201),(13180,2202),(13181,2202),(13182,2202),(13183,2202),(13184,2203),(13185,2203),(13186,2203),(13187,2203),(13188,2204),(13189,2204),(13190,2204),(13191,2204),(13192,2205),(13193,2205),(13194,2205),(13195,2205),(13196,2206),(13197,2206),(13198,2206),(13199,2206),(13200,2207),(13201,2207),(13202,2207),(13203,2207),(13204,2208),(13205,2208),(13206,2208),(13207,2208),(13208,2209),(13209,2209),(13210,2209),(13211,2209),(13212,2210),(13213,2210),(13214,2210),(13215,2210),(13216,2211),(13217,2211),(13218,2211),(13219,2211),(13220,2212),(13221,2212),(13222,2212),(13223,2212),(13224,2213),(13225,2214),(13226,2215),(13227,2216),(13228,2217),(13229,2218),(13230,2219),(13231,2220),(13232,2221),(13233,2222),(13234,2223),(13235,2224),(13236,2225),(13237,2226),(13238,2227),(13239,2228),(13240,2229),(13241,2230),(13242,2231),(13243,2232),(13244,2233),(13245,2234),(13246,2235),(13247,2236),(13248,2237),(13249,2238),(13250,2239),(13251,2240),(13252,2241),(13253,2242),(13254,2243),(13255,2244),(13256,2245),(13257,2246),(13258,2247),(13259,2248),(13260,2249),(13261,2250),(13262,2251),(13263,2252),(13264,2253),(13265,2254),(13266,2255),(13267,2256),(13268,2257),(13269,2258),(13270,2259),(13271,2260),(13272,2261),(13273,2262),(13274,2263),(13275,2264),(13276,2265),(13277,2266),(13278,2267),(13279,2268),(13280,2269),(13281,2270),(13282,2271),(13283,2272),(13284,2273),(13285,2274),(13286,2275),(13287,2276),(13288,2277),(13289,2278),(13290,2279),(13291,2280),(13292,2281),(13293,2282),(13294,2283),(13295,2284),(13296,2285),(13297,2286),(13298,2287),(13299,2288),(13300,2289),(13301,2290),(13302,2291),(13303,2292),(13304,2293),(13305,2294),(13306,2295),(13307,2296),(13308,2297),(13309,2298),(13310,2299),(13311,2300),(13312,2301),(13313,2302),(13314,2303),(13315,2304),(13316,2305),(13317,2306),(13318,2307),(13319,2308),(13320,2309),(13321,2310),(13322,2213),(13323,2213),(13324,2213),(13325,2213),(13326,2214),(13327,2214),(13328,2214),(13329,2214),(13330,2215),(13331,2215),(13332,2215),(13333,2215),(13334,2216),(13335,2216),(13336,2216),(13337,2216),(13338,2217),(13339,2217),(13340,2217),(13341,2217),(13342,2218),(13343,2218),(13344,2218),(13345,2218),(13346,2219),(13347,2219),(13348,2219),(13349,2219),(13350,2220),(13351,2220),(13352,2220),(13353,2220),(13354,2221),(13355,2221),(13356,2221),(13357,2221),(13358,2222),(13359,2222),(13360,2222),(13361,2222),(13362,2223),(13363,2223),(13364,2223),(13365,2223),(13366,2224),(13367,2224),(13368,2224),(13369,2224),(13370,2225),(13371,2225),(13372,2225),(13373,2225),(13374,2226),(13375,2226),(13376,2226),(13377,2226),(13378,2227),(13379,2227),(13380,2227),(13381,2227),(13382,2228),(13383,2228),(13384,2228),(13385,2228),(13386,2229),(13387,2229),(13388,2229),(13389,2229),(13390,2230),(13391,2230),(13392,2230),(13393,2230),(13394,2231),(13395,2231),(13396,2231),(13397,2231),(13398,2232),(13399,2232),(13400,2232),(13401,2232),(13402,2233),(13403,2233),(13404,2233),(13405,2233),(13406,2234),(13407,2234),(13408,2234),(13409,2234),(13410,2235),(13411,2235),(13412,2235),(13413,2235),(13414,2236),(13415,2236),(13416,2236),(13417,2236),(13418,2237),(13419,2237),(13420,2237),(13421,2237),(13422,2238),(13423,2238),(13424,2238),(13425,2238),(13426,2239),(13427,2239),(13428,2239),(13429,2239),(13430,2240),(13431,2240),(13432,2240),(13433,2240),(13434,2241),(13435,2241),(13436,2241),(13437,2241),(13438,2242),(13439,2242),(13440,2242),(13441,2242),(13442,2243),(13443,2243),(13444,2243),(13445,2243),(13446,2244),(13447,2244),(13448,2244),(13449,2244),(13450,2245),(13451,2245),(13452,2245),(13453,2245),(13454,2246),(13455,2246),(13456,2246),(13457,2246),(13458,2247),(13459,2247),(13460,2247),(13461,2247),(13462,2248),(13463,2248),(13464,2248),(13465,2248),(13466,2249),(13467,2249),(13468,2249),(13469,2249),(13470,2250),(13471,2250),(13472,2250),(13473,2250),(13474,2251),(13475,2251),(13476,2251),(13477,2251),(13478,2252),(13479,2252),(13480,2252),(13481,2252),(13482,2253),(13483,2253),(13484,2253),(13485,2253),(13486,2254),(13487,2254),(13488,2254),(13489,2254),(13490,2255),(13491,2255),(13492,2255),(13493,2255),(13494,2256),(13495,2256),(13496,2256),(13497,2256),(13498,2257),(13499,2257),(13500,2257),(13501,2257),(13502,2258),(13503,2258),(13504,2258),(13505,2258),(13506,2259),(13507,2259),(13508,2259),(13509,2259),(13510,2260),(13511,2260),(13512,2260),(13513,2260),(13514,2261),(13515,2261),(13516,2261),(13517,2261),(13518,2262),(13519,2262),(13520,2262),(13521,2262),(13522,2263),(13523,2263),(13524,2263),(13525,2263),(13526,2264),(13527,2264),(13528,2264),(13529,2264),(13530,2265),(13531,2265),(13532,2265),(13533,2265),(13534,2266),(13535,2266),(13536,2266),(13537,2266),(13538,2267),(13539,2267),(13540,2267),(13541,2267),(13542,2268),(13543,2268),(13544,2268),(13545,2268),(13546,2269),(13547,2269),(13548,2269),(13549,2269),(13550,2270),(13551,2270),(13552,2270),(13553,2270),(13554,2271),(13555,2271),(13556,2271),(13557,2271),(13558,2272),(13559,2272),(13560,2272),(13561,2272),(13562,2273),(13563,2273),(13564,2273),(13565,2273),(13566,2274),(13567,2274),(13568,2274),(13569,2274),(13570,2275),(13571,2275),(13572,2275),(13573,2275),(13574,2276),(13575,2276),(13576,2276),(13577,2276),(13578,2277),(13579,2277),(13580,2277),(13581,2277),(13582,2278),(13583,2278),(13584,2278),(13585,2278),(13586,2279),(13587,2279),(13588,2279),(13589,2279),(13590,2280),(13591,2280),(13592,2280),(13593,2280),(13594,2281),(13595,2281),(13596,2281),(13597,2281),(13598,2282),(13599,2282),(13600,2282),(13601,2282),(13602,2283),(13603,2283),(13604,2283),(13605,2283),(13606,2284),(13607,2284),(13608,2284),(13609,2284),(13610,2285),(13611,2285),(13612,2285),(13613,2285),(13614,2286),(13615,2286),(13616,2286),(13617,2286),(13618,2287),(13619,2287),(13620,2287),(13621,2287),(13622,2288),(13623,2288),(13624,2288),(13625,2288),(13626,2289),(13627,2289),(13628,2289),(13629,2289),(13630,2290),(13631,2290),(13632,2290),(13633,2290),(13634,2291),(13635,2291),(13636,2291),(13637,2291),(13638,2292),(13639,2292),(13640,2292),(13641,2292),(13642,2293),(13643,2293),(13644,2293),(13645,2293),(13646,2294),(13647,2294),(13648,2294),(13649,2294),(13650,2295),(13651,2295),(13652,2295),(13653,2295),(13654,2296),(13655,2296),(13656,2296),(13657,2296),(13658,2297),(13659,2297),(13660,2297),(13661,2297),(13662,2298),(13663,2298),(13664,2298),(13665,2298),(13666,2299),(13667,2299),(13668,2299),(13669,2299),(13670,2300),(13671,2300),(13672,2300),(13673,2300),(13674,2301),(13675,2301),(13676,2301),(13677,2301),(13678,2302),(13679,2302),(13680,2302),(13681,2302),(13682,2303),(13683,2303),(13684,2303),(13685,2303),(13686,2304),(13687,2304),(13688,2304),(13689,2304),(13690,2305),(13691,2305),(13692,2305),(13693,2305),(13694,2306),(13695,2306),(13696,2306),(13697,2306),(13698,2307),(13699,2307),(13700,2307),(13701,2307),(13702,2308),(13703,2308),(13704,2308),(13705,2308),(13706,2309),(13707,2309),(13708,2309),(13709,2309),(13710,2310),(13711,2310),(13712,2310),(13713,2310),(13714,2311),(13715,2312),(13716,2313),(13717,2314),(13718,2315),(13719,2316),(13720,2317),(13721,2318),(13722,2319),(13723,2320),(13724,2321),(13725,2311),(13726,2311),(13727,2311),(13728,2311),(13729,2312),(13730,2312),(13731,2312),(13732,2312),(13733,2313),(13734,2313),(13735,2313),(13736,2313),(13737,2314),(13738,2314),(13739,2314),(13740,2314),(13741,2315),(13742,2315),(13743,2315),(13744,2315),(13745,2316),(13746,2316),(13747,2316),(13748,2316),(13749,2317),(13750,2317),(13751,2317),(13752,2317),(13753,2318),(13754,2318),(13755,2318),(13756,2318),(13757,2319),(13758,2319),(13759,2319),(13760,2319),(13761,2320),(13762,2320),(13763,2320),(13764,2320),(13765,2321),(13766,2321),(13767,2321),(13768,2321),(13769,2322),(13770,2323),(13771,2324),(13772,2325),(13773,2326),(13774,2327),(13775,2328),(13776,2329),(13777,2330),(13778,2331),(13779,2332),(13780,2333),(13781,2334),(13782,2335),(13783,2336),(13784,2337),(13785,2338),(13786,2339),(13787,2340),(13788,2341),(13789,2342),(13790,2343),(13791,2344),(13792,2345),(13793,2346),(13794,2347),(13795,2348),(13796,2349),(13797,2350),(13798,2351),(13799,2352),(13800,2353),(13801,2354),(13802,2355),(13803,2356),(13804,2357),(13805,2358),(13806,2359),(13807,2360),(13808,2361),(13809,2362),(13810,2363),(13811,2364),(13812,2365),(13813,2366),(13814,2367),(13815,2368),(13816,2369),(13817,2370),(13818,2371),(13819,2372),(13820,2373),(13821,2374),(13822,2375),(13823,2376),(13824,2377),(13825,2378),(13826,2379),(13827,2380),(13828,2381),(13829,2382),(13830,2383),(13831,2384),(13832,2385),(13833,2386),(13834,2387),(13835,2388),(13836,2389),(13837,2390),(13838,2391),(13839,2392),(13840,2393),(13841,2394),(13842,2395),(13843,2396),(13844,2397),(13845,2398),(13846,2399),(13847,2400),(13848,2401),(13849,2402),(13850,2403),(13851,2404),(13852,2405),(13853,2406),(13854,2407),(13855,2408),(13856,2409),(13857,2410),(13858,2322),(13859,2322),(13860,2322),(13861,2322),(13862,2323),(13863,2323),(13864,2323),(13865,2323),(13866,2324),(13867,2324),(13868,2324),(13869,2324),(13870,2325),(13871,2325),(13872,2325),(13873,2325),(13874,2326),(13875,2326),(13876,2326),(13877,2326),(13878,2327),(13879,2327),(13880,2327),(13881,2327),(13882,2328),(13883,2328),(13884,2328),(13885,2328),(13886,2329),(13887,2329),(13888,2329),(13889,2329),(13890,2330),(13891,2330),(13892,2330),(13893,2330),(13894,2331),(13895,2331),(13896,2331),(13897,2331),(13898,2332),(13899,2332),(13900,2332),(13901,2332),(13902,2333),(13903,2333),(13904,2333),(13905,2333),(13906,2334),(13907,2334),(13908,2334),(13909,2334),(13910,2335),(13911,2335),(13912,2335),(13913,2335),(13914,2336),(13915,2336),(13916,2336),(13917,2336),(13918,2337),(13919,2337),(13920,2337),(13921,2337),(13922,2338),(13923,2338),(13924,2338),(13925,2338),(13926,2339),(13927,2339),(13928,2339),(13929,2339),(13930,2340),(13931,2340),(13932,2340),(13933,2340),(13934,2341),(13935,2341),(13936,2341),(13937,2341),(13938,2342),(13939,2342),(13940,2342),(13941,2342),(13942,2343),(13943,2343),(13944,2343),(13945,2343),(13946,2344),(13947,2344),(13948,2344),(13949,2344),(13950,2345),(13951,2345),(13952,2345),(13953,2345),(13954,2346),(13955,2346),(13956,2346),(13957,2346),(13958,2347),(13959,2347),(13960,2347),(13961,2347),(13962,2348),(13963,2348),(13964,2348),(13965,2348),(13966,2349),(13967,2349),(13968,2349),(13969,2349),(13970,2350),(13971,2350),(13972,2350),(13973,2350),(13974,2351),(13975,2351),(13976,2351),(13977,2351),(13978,2352),(13979,2352),(13980,2352),(13981,2352),(13982,2353),(13983,2353),(13984,2353),(13985,2353),(13986,2354),(13987,2354),(13988,2354),(13989,2354),(13990,2355),(13991,2355),(13992,2355),(13993,2355),(13994,2356),(13995,2356),(13996,2356),(13997,2356),(13998,2357),(13999,2357),(14000,2357),(14001,2357),(14002,2358),(14003,2358),(14004,2358),(14005,2358),(14006,2359),(14007,2359),(14008,2359),(14009,2359),(14010,2360),(14011,2360),(14012,2360),(14013,2360),(14014,2361),(14015,2361),(14016,2361),(14017,2361),(14018,2362),(14019,2362),(14020,2362),(14021,2362),(14022,2363),(14023,2363),(14024,2363),(14025,2363),(14026,2364),(14027,2364),(14028,2364),(14029,2364),(14030,2365),(14031,2365),(14032,2365),(14033,2365),(14034,2366),(14035,2366),(14036,2366),(14037,2366),(14038,2367),(14039,2367),(14040,2367),(14041,2367),(14042,2368),(14043,2368),(14044,2368),(14045,2368),(14046,2369),(14047,2369),(14048,2369),(14049,2369),(14050,2370),(14051,2370),(14052,2370),(14053,2370),(14054,2371),(14055,2371),(14056,2371),(14057,2371),(14058,2372),(14059,2372),(14060,2372),(14061,2372),(14062,2373),(14063,2373),(14064,2373),(14065,2373),(14066,2374),(14067,2374),(14068,2374),(14069,2374),(14070,2375),(14071,2375),(14072,2375),(14073,2375),(14074,2376),(14075,2376),(14076,2376),(14077,2376),(14078,2377),(14079,2377),(14080,2377),(14081,2377),(14082,2378),(14083,2378),(14084,2378),(14085,2378),(14086,2379),(14087,2379),(14088,2379),(14089,2379),(14090,2380),(14091,2380),(14092,2380),(14093,2380),(14094,2381),(14095,2381),(14096,2381),(14097,2381),(14098,2382),(14099,2382),(14100,2382),(14101,2382),(14102,2383),(14103,2383),(14104,2383),(14105,2383),(14106,2384),(14107,2384),(14108,2384),(14109,2384),(14110,2385),(14111,2385),(14112,2385),(14113,2385),(14114,2386),(14115,2386),(14116,2386),(14117,2386),(14118,2387),(14119,2387),(14120,2387),(14121,2387),(14122,2388),(14123,2388),(14124,2388),(14125,2388),(14126,2389),(14127,2389),(14128,2389),(14129,2389),(14130,2390),(14131,2390),(14132,2390),(14133,2390),(14134,2391),(14135,2391),(14136,2391),(14137,2391),(14138,2392),(14139,2392),(14140,2392),(14141,2392),(14142,2393),(14143,2393),(14144,2393),(14145,2393),(14146,2394),(14147,2394),(14148,2394),(14149,2394),(14150,2395),(14151,2395),(14152,2395),(14153,2395),(14154,2396),(14155,2396),(14156,2396),(14157,2396),(14158,2397),(14159,2397),(14160,2397),(14161,2397),(14162,2398),(14163,2398),(14164,2398),(14165,2398),(14166,2399),(14167,2399),(14168,2399),(14169,2399),(14170,2400),(14171,2400),(14172,2400),(14173,2400),(14174,2401),(14175,2401),(14176,2401),(14177,2401),(14178,2402),(14179,2402),(14180,2402),(14181,2402),(14182,2403),(14183,2403),(14184,2403),(14185,2403),(14186,2404),(14187,2404),(14188,2404),(14189,2404),(14190,2405),(14191,2405),(14192,2405),(14193,2405),(14194,2406),(14195,2406),(14196,2406),(14197,2406),(14198,2407),(14199,2407),(14200,2407),(14201,2407),(14202,2408),(14203,2408),(14204,2408),(14205,2408),(14206,2409),(14207,2409),(14208,2409),(14209,2409),(14210,2410),(14211,2410),(14212,2410),(14213,2410),(14214,2411),(14215,2412),(14216,2413),(14217,2414),(14218,2415),(14219,2416),(14220,2417),(14221,2418),(14222,2419),(14223,2420),(14224,2421),(14225,2422),(14226,2423),(14227,2424),(14228,2425),(14229,2426),(14230,2427),(14231,2428),(14232,2429),(14233,2430),(14234,2431),(14235,2432),(14236,2433),(14237,2434),(14238,2435),(14239,2436),(14240,2437),(14241,2438),(14242,2439),(14243,2440),(14244,2441),(14245,2442),(14246,2443),(14247,2444),(14248,2445),(14249,2446),(14250,2447),(14251,2448),(14252,2449),(14253,2450),(14254,2451),(14255,2452),(14256,2453),(14257,2454),(14258,2455),(14259,2456),(14260,2457),(14261,2458),(14262,2459),(14263,2460),(14264,2461),(14265,2462),(14266,2463),(14267,2464),(14268,2465),(14269,2466),(14270,2467),(14271,2468),(14272,2469),(14273,2470),(14274,2471),(14275,2472),(14276,2473),(14277,2474),(14278,2475),(14279,2476),(14280,2477),(14281,2478),(14282,2479),(14283,2480),(14284,2481),(14285,2482),(14286,2483),(14287,2484),(14288,2485),(14289,2486),(14290,2487),(14291,2488),(14292,2489),(14293,2490),(14294,2491),(14295,2492),(14296,2493),(14297,2494),(14298,2495),(14299,2496),(14300,2497),(14301,2498),(14302,2499),(14303,2500),(14304,2501),(14305,2502),(14306,2503),(14307,2504),(14308,2505),(14309,2506),(14310,2507),(14311,2508),(14312,2509),(14313,2510),(14314,2411),(14315,2411),(14316,2411),(14317,2411),(14318,2412),(14319,2412),(14320,2412),(14321,2412),(14322,2413),(14323,2413),(14324,2413),(14325,2413),(14326,2414),(14327,2414),(14328,2414),(14329,2414),(14330,2415),(14331,2415),(14332,2415),(14333,2415),(14334,2416),(14335,2416),(14336,2416),(14337,2416),(14338,2417),(14339,2417),(14340,2417),(14341,2417),(14342,2418),(14343,2418),(14344,2418),(14345,2418),(14346,2419),(14347,2419),(14348,2419),(14349,2419),(14350,2420),(14351,2420),(14352,2420),(14353,2420),(14354,2421),(14355,2421),(14356,2421),(14357,2421),(14358,2422),(14359,2422),(14360,2422),(14361,2422),(14362,2423),(14363,2423),(14364,2423),(14365,2423),(14366,2424),(14367,2424),(14368,2424),(14369,2424),(14370,2425),(14371,2425),(14372,2425),(14373,2425),(14374,2426),(14375,2426),(14376,2426),(14377,2426),(14378,2427),(14379,2427),(14380,2427),(14381,2427),(14382,2428),(14383,2428),(14384,2428),(14385,2428),(14386,2429),(14387,2429),(14388,2429),(14389,2429),(14390,2430),(14391,2430),(14392,2430),(14393,2430),(14394,2431),(14395,2431),(14396,2431),(14397,2431),(14398,2432),(14399,2432),(14400,2432),(14401,2432),(14402,2433),(14403,2433),(14404,2433),(14405,2433),(14406,2434),(14407,2434),(14408,2434),(14409,2434),(14410,2435),(14411,2435),(14412,2435),(14413,2435),(14414,2436),(14415,2436),(14416,2436),(14417,2436),(14418,2437),(14419,2437),(14420,2437),(14421,2437),(14422,2438),(14423,2438),(14424,2438),(14425,2438),(14426,2439),(14427,2439),(14428,2439),(14429,2439),(14430,2440),(14431,2440),(14432,2440),(14433,2440),(14434,2441),(14435,2441),(14436,2441),(14437,2441),(14438,2442),(14439,2442),(14440,2442),(14441,2442),(14442,2443),(14443,2443),(14444,2443),(14445,2443),(14446,2444),(14447,2444),(14448,2444),(14449,2444),(14450,2445),(14451,2445),(14452,2445),(14453,2445),(14454,2446),(14455,2446),(14456,2446),(14457,2446),(14458,2447),(14459,2447),(14460,2447),(14461,2447),(14462,2448),(14463,2448),(14464,2448),(14465,2448),(14466,2449),(14467,2449),(14468,2449),(14469,2449),(14470,2450),(14471,2450),(14472,2450),(14473,2450),(14474,2451),(14475,2451),(14476,2451),(14477,2451),(14478,2452),(14479,2452),(14480,2452),(14481,2452),(14482,2453),(14483,2453),(14484,2453),(14485,2453),(14486,2454),(14487,2454),(14488,2454),(14489,2454),(14490,2455),(14491,2455),(14492,2455),(14493,2455),(14494,2456),(14495,2456),(14496,2456),(14497,2456),(14498,2457),(14499,2457),(14500,2457),(14501,2457),(14502,2458),(14503,2458),(14504,2458),(14505,2458),(14506,2459),(14507,2459),(14508,2459),(14509,2459),(14510,2460),(14511,2460),(14512,2460),(14513,2460),(14514,2461),(14515,2461),(14516,2461),(14517,2461),(14518,2462),(14519,2462),(14520,2462),(14521,2462),(14522,2463),(14523,2463),(14524,2463),(14525,2463),(14526,2464),(14527,2464),(14528,2464),(14529,2464),(14530,2465),(14531,2465),(14532,2465),(14533,2465),(14534,2466),(14535,2466),(14536,2466),(14537,2466),(14538,2467),(14539,2467),(14540,2467),(14541,2467),(14542,2468),(14543,2468),(14544,2468),(14545,2468),(14546,2469),(14547,2469),(14548,2469),(14549,2469),(14550,2470),(14551,2470),(14552,2470),(14553,2470),(14554,2471),(14555,2471),(14556,2471),(14557,2471),(14558,2472),(14559,2472),(14560,2472),(14561,2472),(14562,2473),(14563,2473),(14564,2473),(14565,2473),(14566,2474),(14567,2474),(14568,2474),(14569,2474),(14570,2475),(14571,2475),(14572,2475),(14573,2475),(14574,2476),(14575,2476),(14576,2476),(14577,2476),(14578,2477),(14579,2477),(14580,2477),(14581,2477),(14582,2478),(14583,2478),(14584,2478),(14585,2478),(14586,2479),(14587,2479),(14588,2479),(14589,2479),(14590,2480),(14591,2480),(14592,2480),(14593,2480),(14594,2481),(14595,2481),(14596,2481),(14597,2481),(14598,2482),(14599,2482),(14600,2482),(14601,2482),(14602,2483),(14603,2483),(14604,2483),(14605,2483),(14606,2484),(14607,2484),(14608,2484),(14609,2484),(14610,2485),(14611,2485),(14612,2485),(14613,2485),(14614,2486),(14615,2486),(14616,2486),(14617,2486),(14618,2487),(14619,2487),(14620,2487),(14621,2487),(14622,2488),(14623,2488),(14624,2488),(14625,2488),(14626,2489),(14627,2489),(14628,2489),(14629,2489),(14630,2490),(14631,2490),(14632,2490),(14633,2490),(14634,2491),(14635,2491),(14636,2491),(14637,2491),(14638,2492),(14639,2492),(14640,2492),(14641,2492),(14642,2493),(14643,2493),(14644,2493),(14645,2493),(14646,2494),(14647,2494),(14648,2494),(14649,2494),(14650,2495),(14651,2495),(14652,2495),(14653,2495),(14654,2496),(14655,2496),(14656,2496),(14657,2496),(14658,2497),(14659,2497),(14660,2497),(14661,2497),(14662,2498),(14663,2498),(14664,2498),(14665,2498),(14666,2499),(14667,2499),(14668,2499),(14669,2499),(14670,2500),(14671,2500),(14672,2500),(14673,2500),(14674,2501),(14675,2501),(14676,2501),(14677,2501),(14678,2502),(14679,2502),(14680,2502),(14681,2502),(14682,2503),(14683,2503),(14684,2503),(14685,2503),(14686,2504),(14687,2504),(14688,2504),(14689,2504),(14690,2505),(14691,2505),(14692,2505),(14693,2505),(14694,2506),(14695,2506),(14696,2506),(14697,2506),(14698,2507),(14699,2507),(14700,2507),(14701,2507),(14702,2508),(14703,2508),(14704,2508),(14705,2508),(14706,2509),(14707,2509),(14708,2509),(14709,2509),(14710,2510),(14711,2510),(14712,2510),(14713,2510),(14714,2511),(14715,2512),(14716,2513),(14717,2514),(14718,2515),(14719,2516),(14720,2517),(14721,2518),(14722,2519),(14723,2520),(14724,2521),(14725,2522),(14726,2523),(14727,2524),(14728,2525),(14729,2526),(14730,2527),(14731,2528),(14732,2529),(14733,2530),(14734,2531),(14735,2532),(14736,2533),(14737,2534),(14738,2535),(14739,2536),(14740,2537),(14741,2538),(14742,2539),(14743,2540),(14744,2541),(14745,2542),(14746,2543),(14747,2544),(14748,2545),(14749,2546),(14750,2547),(14751,2548),(14752,2549),(14753,2550),(14754,2551),(14755,2552),(14756,2553),(14757,2554),(14758,2555),(14759,2556),(14760,2557),(14761,2558),(14762,2559),(14763,2560),(14764,2561),(14765,2562),(14766,2563),(14767,2564),(14768,2565),(14769,2566),(14770,2567),(14771,2568),(14772,2569),(14773,2570),(14774,2571),(14775,2572),(14776,2573),(14777,2574),(14778,2575),(14779,2576),(14780,2577),(14781,2578),(14782,2579),(14783,2580),(14784,2581),(14785,2582),(14786,2583),(14787,2584),(14788,2585),(14789,2586),(14790,2587),(14791,2588),(14792,2589),(14793,2590),(14794,2591),(14795,2592),(14796,2593),(14797,2594),(14798,2595),(14799,2596),(14800,2597),(14801,2598),(14802,2599),(14803,2600),(14804,2601),(14805,2602),(14806,2603),(14807,2604),(14808,2605),(14809,2606),(14810,2607),(14811,2608),(14812,2609),(14813,2610),(14814,2511),(14815,2511),(14816,2511),(14817,2511),(14818,2512),(14819,2512),(14820,2512),(14821,2512),(14822,2513),(14823,2513),(14824,2513),(14825,2513),(14826,2514),(14827,2514),(14828,2514),(14829,2514),(14830,2515),(14831,2515),(14832,2515),(14833,2515),(14834,2516),(14835,2516),(14836,2516),(14837,2516),(14838,2517),(14839,2517),(14840,2517),(14841,2517),(14842,2518),(14843,2518),(14844,2518),(14845,2518),(14846,2519),(14847,2519),(14848,2519),(14849,2519),(14850,2520),(14851,2520),(14852,2520),(14853,2520),(14854,2521),(14855,2521),(14856,2521),(14857,2521),(14858,2522),(14859,2522),(14860,2522),(14861,2522),(14862,2523),(14863,2523),(14864,2523),(14865,2523),(14866,2524),(14867,2524),(14868,2524),(14869,2524),(14870,2525),(14871,2525),(14872,2525),(14873,2525),(14874,2526),(14875,2526),(14876,2526),(14877,2526),(14878,2527),(14879,2527),(14880,2527),(14881,2527),(14882,2528),(14883,2528),(14884,2528),(14885,2528),(14886,2529),(14887,2529),(14888,2529),(14889,2529),(14890,2530),(14891,2530),(14892,2530),(14893,2530),(14894,2531),(14895,2531),(14896,2531),(14897,2531),(14898,2532),(14899,2532),(14900,2532),(14901,2532),(14902,2533),(14903,2533),(14904,2533),(14905,2533),(14906,2534),(14907,2534),(14908,2534),(14909,2534),(14910,2535),(14911,2535),(14912,2535),(14913,2535),(14914,2536),(14915,2536),(14916,2536),(14917,2536),(14918,2537),(14919,2537),(14920,2537),(14921,2537),(14922,2538),(14923,2538),(14924,2538),(14925,2538),(14926,2539),(14927,2539),(14928,2539),(14929,2539),(14930,2540),(14931,2540),(14932,2540),(14933,2540),(14934,2541),(14935,2541),(14936,2541),(14937,2541),(14938,2542),(14939,2542),(14940,2542),(14941,2542),(14942,2543),(14943,2543),(14944,2543),(14945,2543),(14946,2544),(14947,2544),(14948,2544),(14949,2544),(14950,2545),(14951,2545),(14952,2545),(14953,2545),(14954,2546),(14955,2546),(14956,2546),(14957,2546),(14958,2547),(14959,2547),(14960,2547),(14961,2547),(14962,2548),(14963,2548),(14964,2548),(14965,2548),(14966,2549),(14967,2549),(14968,2549),(14969,2549),(14970,2550),(14971,2550),(14972,2550),(14973,2550),(14974,2551),(14975,2551),(14976,2551),(14977,2551),(14978,2552),(14979,2552),(14980,2552),(14981,2552),(14982,2553),(14983,2553),(14984,2553),(14985,2553),(14986,2554),(14987,2554),(14988,2554),(14989,2554),(14990,2555),(14991,2555),(14992,2555),(14993,2555),(14994,2556),(14995,2556),(14996,2556),(14997,2556),(14998,2557),(14999,2557),(15000,2557),(15001,2557),(15002,2558),(15003,2558),(15004,2558),(15005,2558),(15006,2559),(15007,2559),(15008,2559),(15009,2559),(15010,2560),(15011,2560),(15012,2560),(15013,2560),(15014,2561),(15015,2561),(15016,2561),(15017,2561),(15018,2562),(15019,2562),(15020,2562),(15021,2562),(15022,2563),(15023,2563),(15024,2563),(15025,2563),(15026,2564),(15027,2564),(15028,2564),(15029,2564),(15030,2565),(15031,2565),(15032,2565),(15033,2565),(15034,2566),(15035,2566),(15036,2566),(15037,2566),(15038,2567),(15039,2567),(15040,2567),(15041,2567),(15042,2568),(15043,2568),(15044,2568),(15045,2568),(15046,2569),(15047,2569),(15048,2569),(15049,2569),(15050,2570),(15051,2570),(15052,2570),(15053,2570),(15054,2571),(15055,2571),(15056,2571),(15057,2571),(15058,2572),(15059,2572),(15060,2572),(15061,2572),(15062,2573),(15063,2573),(15064,2573),(15065,2573),(15066,2574),(15067,2574),(15068,2574),(15069,2574),(15070,2575),(15071,2575),(15072,2575),(15073,2575),(15074,2576),(15075,2576),(15076,2576),(15077,2576),(15078,2577),(15079,2577),(15080,2577),(15081,2577),(15082,2578),(15083,2578),(15084,2578),(15085,2578),(15086,2579),(15087,2579),(15088,2579),(15089,2579),(15090,2580),(15091,2580),(15092,2580),(15093,2580),(15094,2581),(15095,2581),(15096,2581),(15097,2581),(15098,2582),(15099,2582),(15100,2582),(15101,2582),(15102,2583),(15103,2583),(15104,2583),(15105,2583),(15106,2584),(15107,2584),(15108,2584),(15109,2584),(15110,2585),(15111,2585),(15112,2585),(15113,2585),(15114,2586),(15115,2586),(15116,2586),(15117,2586),(15118,2587),(15119,2587),(15120,2587),(15121,2587),(15122,2588),(15123,2588),(15124,2588),(15125,2588),(15126,2589),(15127,2589),(15128,2589),(15129,2589),(15130,2590),(15131,2590),(15132,2590),(15133,2590),(15134,2591),(15135,2591),(15136,2591),(15137,2591),(15138,2592),(15139,2592),(15140,2592),(15141,2592),(15142,2593),(15143,2593),(15144,2593),(15145,2593),(15146,2594),(15147,2594),(15148,2594),(15149,2594),(15150,2595),(15151,2595),(15152,2595),(15153,2595),(15154,2596),(15155,2596),(15156,2596),(15157,2596),(15158,2597),(15159,2597),(15160,2597),(15161,2597),(15162,2598),(15163,2598),(15164,2598),(15165,2598),(15166,2599),(15167,2599),(15168,2599),(15169,2599),(15170,2600),(15171,2600),(15172,2600),(15173,2600),(15174,2601),(15175,2601),(15176,2601),(15177,2601),(15178,2602),(15179,2602),(15180,2602),(15181,2602),(15182,2603),(15183,2603),(15184,2603),(15185,2603),(15186,2604),(15187,2604),(15188,2604),(15189,2604),(15190,2605),(15191,2605),(15192,2605),(15193,2605),(15194,2606),(15195,2606),(15196,2606),(15197,2606),(15198,2607),(15199,2607),(15200,2607),(15201,2607),(15202,2608),(15203,2608),(15204,2608),(15205,2608),(15206,2609),(15207,2609),(15208,2609),(15209,2609),(15210,2610),(15211,2610),(15212,2610),(15213,2610),(15214,2611),(15215,2612),(15216,2613),(15217,2614),(15218,2615),(15219,2616),(15220,2617),(15221,2618),(15222,2619),(15223,2620),(15224,2621),(15225,2611),(15226,2611),(15227,2611),(15228,2611),(15229,2612),(15230,2612),(15231,2612),(15232,2612),(15233,2613),(15234,2613),(15235,2613),(15236,2613),(15237,2614),(15238,2614),(15239,2614),(15240,2614),(15241,2615),(15242,2615),(15243,2615),(15244,2615),(15245,2616),(15246,2616),(15247,2616),(15248,2616),(15249,2617),(15250,2617),(15251,2617),(15252,2617),(15253,2618),(15254,2618),(15255,2618),(15256,2618),(15257,2619),(15258,2619),(15259,2619),(15260,2619),(15261,2620),(15262,2620),(15263,2620),(15264,2620),(15265,2621),(15266,2621),(15267,2621),(15268,2621),(15269,2622),(15270,2623),(15271,2624),(15272,2625),(15273,2626),(15274,2627),(15275,2628),(15276,2629),(15277,2630),(15278,2631),(15279,2632),(15280,2633),(15281,2634),(15282,2635),(15283,2636),(15284,2637),(15285,2638),(15286,2639),(15287,2640),(15288,2641),(15289,2642),(15290,2643),(15291,2644),(15292,2645),(15293,2646),(15294,2647),(15295,2648),(15296,2649),(15297,2650),(15298,2651),(15299,2652),(15300,2653),(15301,2654),(15302,2655),(15303,2656),(15304,2657),(15305,2658),(15306,2659),(15307,2660),(15308,2661),(15309,2662),(15310,2663),(15311,2664),(15312,2665),(15313,2666),(15314,2667),(15315,2668),(15316,2669),(15317,2670),(15318,2671),(15319,2672),(15320,2673),(15321,2674),(15322,2675),(15323,2676),(15324,2677),(15325,2678),(15326,2679),(15327,2680),(15328,2681),(15329,2682),(15330,2683),(15331,2684),(15332,2685),(15333,2686),(15334,2687),(15335,2688),(15336,2689),(15337,2690),(15338,2691),(15339,2692),(15340,2693),(15341,2694),(15342,2695),(15343,2696),(15344,2697),(15345,2698),(15346,2699),(15347,2700),(15348,2701),(15349,2702),(15350,2703),(15351,2704),(15352,2705),(15353,2706),(15354,2707),(15355,2708),(15356,2709),(15357,2710),(15358,2711),(15359,2712),(15360,2713),(15361,2714),(15362,2715),(15363,2716),(15364,2717),(15365,2718),(15366,2719),(15367,2720),(15368,2721),(15369,2622),(15370,2622),(15371,2622),(15372,2622),(15373,2623),(15374,2623),(15375,2623),(15376,2623),(15377,2624),(15378,2624),(15379,2624),(15380,2624),(15381,2625),(15382,2625),(15383,2625),(15384,2625),(15385,2626),(15386,2626),(15387,2626),(15388,2626),(15389,2627),(15390,2627),(15391,2627),(15392,2627),(15393,2628),(15394,2628),(15395,2628),(15396,2628),(15397,2629),(15398,2629),(15399,2629),(15400,2629),(15401,2630),(15402,2630),(15403,2630),(15404,2630),(15405,2631),(15406,2631),(15407,2631),(15408,2631),(15409,2632),(15410,2632),(15411,2632),(15412,2632),(15413,2633),(15414,2633),(15415,2633),(15416,2633),(15417,2634),(15418,2634),(15419,2634),(15420,2634),(15421,2635),(15422,2635),(15423,2635),(15424,2635),(15425,2636),(15426,2636),(15427,2636),(15428,2636),(15429,2637),(15430,2637),(15431,2637),(15432,2637),(15433,2638),(15434,2638),(15435,2638),(15436,2638),(15437,2639),(15438,2639),(15439,2639),(15440,2639),(15441,2640),(15442,2640),(15443,2640),(15444,2640),(15445,2641),(15446,2641),(15447,2641),(15448,2641),(15449,2642),(15450,2642),(15451,2642),(15452,2642),(15453,2643),(15454,2643),(15455,2643),(15456,2643),(15457,2644),(15458,2644),(15459,2644),(15460,2644),(15461,2645),(15462,2645),(15463,2645),(15464,2645),(15465,2646),(15466,2646),(15467,2646),(15468,2646),(15469,2647),(15470,2647),(15471,2647),(15472,2647),(15473,2648),(15474,2648),(15475,2648),(15476,2648),(15477,2649),(15478,2649),(15479,2649),(15480,2649),(15481,2650),(15482,2650),(15483,2650),(15484,2650),(15485,2651),(15486,2651),(15487,2651),(15488,2651),(15489,2652),(15490,2652),(15491,2652),(15492,2652),(15493,2653),(15494,2653),(15495,2653),(15496,2653),(15497,2654),(15498,2654),(15499,2654),(15500,2654),(15501,2655),(15502,2655),(15503,2655),(15504,2655),(15505,2656),(15506,2656),(15507,2656),(15508,2656),(15509,2657),(15510,2657),(15511,2657),(15512,2657),(15513,2658),(15514,2658),(15515,2658),(15516,2658),(15517,2659),(15518,2659),(15519,2659),(15520,2659),(15521,2660),(15522,2660),(15523,2660),(15524,2660),(15525,2661),(15526,2661),(15527,2661),(15528,2661),(15529,2662),(15530,2662),(15531,2662),(15532,2662),(15533,2663),(15534,2663),(15535,2663),(15536,2663),(15537,2664),(15538,2664),(15539,2664),(15540,2664),(15541,2665),(15542,2665),(15543,2665),(15544,2665),(15545,2666),(15546,2666),(15547,2666),(15548,2666),(15549,2667),(15550,2667),(15551,2667),(15552,2667),(15553,2668),(15554,2668),(15555,2668),(15556,2668),(15557,2669),(15558,2669),(15559,2669),(15560,2669),(15561,2670),(15562,2670),(15563,2670),(15564,2670),(15565,2671),(15566,2671),(15567,2671),(15568,2671),(15569,2672),(15570,2672),(15571,2672),(15572,2672),(15573,2673),(15574,2673),(15575,2673),(15576,2673),(15577,2674),(15578,2674),(15579,2674),(15580,2674),(15581,2675),(15582,2675),(15583,2675),(15584,2675),(15585,2676),(15586,2676),(15587,2676),(15588,2676),(15589,2677),(15590,2677),(15591,2677),(15592,2677),(15593,2678),(15594,2678),(15595,2678),(15596,2678),(15597,2679),(15598,2679),(15599,2679),(15600,2679),(15601,2680),(15602,2680),(15603,2680),(15604,2680),(15605,2681),(15606,2681),(15607,2681),(15608,2681),(15609,2682),(15610,2682),(15611,2682),(15612,2682),(15613,2683),(15614,2683),(15615,2683),(15616,2683),(15617,2684),(15618,2684),(15619,2684),(15620,2684),(15621,2685),(15622,2685),(15623,2685),(15624,2685),(15625,2686),(15626,2686),(15627,2686),(15628,2686),(15629,2687),(15630,2687),(15631,2687),(15632,2687),(15633,2688),(15634,2688),(15635,2688),(15636,2688),(15637,2689),(15638,2689),(15639,2689),(15640,2689),(15641,2690),(15642,2690),(15643,2690),(15644,2690),(15645,2691),(15646,2691),(15647,2691),(15648,2691),(15649,2692),(15650,2692),(15651,2692),(15652,2692),(15653,2693),(15654,2693),(15655,2693),(15656,2693),(15657,2694),(15658,2694),(15659,2694),(15660,2694),(15661,2695),(15662,2695),(15663,2695),(15664,2695),(15665,2696),(15666,2696),(15667,2696),(15668,2696),(15669,2697),(15670,2697),(15671,2697),(15672,2697),(15673,2698),(15674,2698),(15675,2698),(15676,2698),(15677,2699),(15678,2699),(15679,2699),(15680,2699),(15681,2700),(15682,2700),(15683,2700),(15684,2700),(15685,2701),(15686,2701),(15687,2701),(15688,2701),(15689,2702),(15690,2702),(15691,2702),(15692,2702),(15693,2703),(15694,2703),(15695,2703),(15696,2703),(15697,2704),(15698,2704),(15699,2704),(15700,2704),(15701,2705),(15702,2705),(15703,2705),(15704,2705),(15705,2706),(15706,2706),(15707,2706),(15708,2706),(15709,2707),(15710,2707),(15711,2707),(15712,2707),(15713,2708),(15714,2708),(15715,2708),(15716,2708),(15717,2709),(15718,2709),(15719,2709),(15720,2709),(15721,2710),(15722,2710),(15723,2710),(15724,2710),(15725,2711),(15726,2711),(15727,2711),(15728,2711),(15729,2712),(15730,2712),(15731,2712),(15732,2712),(15733,2713),(15734,2713),(15735,2713),(15736,2713),(15737,2714),(15738,2714),(15739,2714),(15740,2714),(15741,2715),(15742,2715),(15743,2715),(15744,2715),(15745,2716),(15746,2716),(15747,2716),(15748,2716),(15749,2717),(15750,2717),(15751,2717),(15752,2717),(15753,2718),(15754,2718),(15755,2718),(15756,2718),(15757,2719),(15758,2719),(15759,2719),(15760,2719),(15761,2720),(15762,2720),(15763,2720),(15764,2720),(15765,2721),(15766,2721),(15767,2721),(15768,2721),(15769,2722),(15770,2723),(15771,2724),(15772,2725),(15773,2726),(15774,2727),(15775,2728),(15776,2729),(15777,2730),(15778,2731),(15779,2732),(15780,2733),(15781,2734),(15782,2735),(15783,2736),(15784,2737),(15785,2738),(15786,2739),(15787,2740),(15788,2741),(15789,2742),(15790,2743),(15791,2744),(15792,2745),(15793,2746),(15794,2747),(15795,2748),(15796,2749),(15797,2750),(15798,2751),(15799,2752),(15800,2753),(15801,2754),(15802,2755),(15803,2756),(15804,2757),(15805,2758),(15806,2759),(15807,2760),(15808,2761),(15809,2762),(15810,2763),(15811,2764),(15812,2765),(15813,2766),(15814,2767),(15815,2768),(15816,2769),(15817,2770),(15818,2771),(15819,2772),(15820,2773),(15821,2774),(15822,2775),(15823,2776),(15824,2777),(15825,2778),(15826,2779),(15827,2780),(15828,2781),(15829,2782),(15830,2783),(15831,2784),(15832,2785),(15833,2786),(15834,2787),(15835,2788),(15836,2789),(15837,2790),(15838,2791),(15839,2792),(15840,2793),(15841,2794),(15842,2795),(15843,2796),(15844,2797),(15845,2798),(15846,2799),(15847,2800),(15848,2801),(15849,2802),(15850,2803),(15851,2804),(15852,2805),(15853,2806),(15854,2807),(15855,2808),(15856,2809),(15857,2810),(15858,2811),(15859,2812),(15860,2813),(15861,2814),(15862,2815),(15863,2816),(15864,2817),(15865,2818),(15866,2819),(15867,2820),(15868,2821),(15869,2722),(15870,2722),(15871,2722),(15872,2722),(15873,2723),(15874,2723),(15875,2723),(15876,2723),(15877,2724),(15878,2724),(15879,2724),(15880,2724),(15881,2725),(15882,2725),(15883,2725),(15884,2725),(15885,2726),(15886,2726),(15887,2726),(15888,2726),(15889,2727),(15890,2727),(15891,2727),(15892,2727),(15893,2728),(15894,2728),(15895,2728),(15896,2728),(15897,2729),(15898,2729),(15899,2729),(15900,2729),(15901,2730),(15902,2730),(15903,2730),(15904,2730),(15905,2731),(15906,2731),(15907,2731),(15908,2731),(15909,2732),(15910,2732),(15911,2732),(15912,2732),(15913,2733),(15914,2733),(15915,2733),(15916,2733),(15917,2734),(15918,2734),(15919,2734),(15920,2734),(15921,2735),(15922,2735),(15923,2735),(15924,2735),(15925,2736),(15926,2736),(15927,2736),(15928,2736),(15929,2737),(15930,2737),(15931,2737),(15932,2737),(15933,2738),(15934,2738),(15935,2738),(15936,2738),(15937,2739),(15938,2739),(15939,2739),(15940,2739),(15941,2740),(15942,2740),(15943,2740),(15944,2740),(15945,2741),(15946,2741),(15947,2741),(15948,2741),(15949,2742),(15950,2742),(15951,2742),(15952,2742),(15953,2743),(15954,2743),(15955,2743),(15956,2743),(15957,2744),(15958,2744),(15959,2744),(15960,2744),(15961,2745),(15962,2745),(15963,2745),(15964,2745),(15965,2746),(15966,2746),(15967,2746),(15968,2746),(15969,2747),(15970,2747),(15971,2747),(15972,2747),(15973,2748),(15974,2748),(15975,2748),(15976,2748),(15977,2749),(15978,2749),(15979,2749),(15980,2749),(15981,2750),(15982,2750),(15983,2750),(15984,2750),(15985,2751),(15986,2751),(15987,2751),(15988,2751),(15989,2752),(15990,2752),(15991,2752),(15992,2752),(15993,2753),(15994,2753),(15995,2753),(15996,2753),(15997,2754),(15998,2754),(15999,2754),(16000,2754),(16001,2755),(16002,2755),(16003,2755),(16004,2755),(16005,2756),(16006,2756),(16007,2756),(16008,2756),(16009,2757),(16010,2757),(16011,2757),(16012,2757),(16013,2758),(16014,2758),(16015,2758),(16016,2758),(16017,2759),(16018,2759),(16019,2759),(16020,2759),(16021,2760),(16022,2760),(16023,2760),(16024,2760),(16025,2761),(16026,2761),(16027,2761),(16028,2761),(16029,2762),(16030,2762),(16031,2762),(16032,2762),(16033,2763),(16034,2763),(16035,2763),(16036,2763),(16037,2764),(16038,2764),(16039,2764),(16040,2764),(16041,2765),(16042,2765),(16043,2765),(16044,2765),(16045,2766),(16046,2766),(16047,2766),(16048,2766),(16049,2767),(16050,2767),(16051,2767),(16052,2767),(16053,2768),(16054,2768),(16055,2768),(16056,2768),(16057,2769),(16058,2769),(16059,2769),(16060,2769),(16061,2770),(16062,2770),(16063,2770),(16064,2770),(16065,2771),(16066,2771),(16067,2771),(16068,2771),(16069,2772),(16070,2772),(16071,2772),(16072,2772),(16073,2773),(16074,2773),(16075,2773),(16076,2773),(16077,2774),(16078,2774),(16079,2774),(16080,2774),(16081,2775),(16082,2775),(16083,2775),(16084,2775),(16085,2776),(16086,2776),(16087,2776),(16088,2776),(16089,2777),(16090,2777),(16091,2777),(16092,2777),(16093,2778),(16094,2778),(16095,2778),(16096,2778),(16097,2779),(16098,2779),(16099,2779),(16100,2779),(16101,2780),(16102,2780),(16103,2780),(16104,2780),(16105,2781),(16106,2781),(16107,2781),(16108,2781),(16109,2782),(16110,2782),(16111,2782),(16112,2782),(16113,2783),(16114,2783),(16115,2783),(16116,2783),(16117,2784),(16118,2784),(16119,2784),(16120,2784),(16121,2785),(16122,2785),(16123,2785),(16124,2785),(16125,2786),(16126,2786),(16127,2786),(16128,2786),(16129,2787),(16130,2787),(16131,2787),(16132,2787),(16133,2788),(16134,2788),(16135,2788),(16136,2788),(16137,2789),(16138,2789),(16139,2789),(16140,2789),(16141,2790),(16142,2790),(16143,2790),(16144,2790),(16145,2791),(16146,2791),(16147,2791),(16148,2791),(16149,2792),(16150,2792),(16151,2792),(16152,2792),(16153,2793),(16154,2793),(16155,2793),(16156,2793),(16157,2794),(16158,2794),(16159,2794),(16160,2794),(16161,2795),(16162,2795),(16163,2795),(16164,2795),(16165,2796),(16166,2796),(16167,2796),(16168,2796),(16169,2797),(16170,2797),(16171,2797),(16172,2797),(16173,2798),(16174,2798),(16175,2798),(16176,2798),(16177,2799),(16178,2799),(16179,2799),(16180,2799),(16181,2800),(16182,2800),(16183,2800),(16184,2800),(16185,2801),(16186,2801),(16187,2801),(16188,2801),(16189,2802),(16190,2802),(16191,2802),(16192,2802),(16193,2803),(16194,2803),(16195,2803),(16196,2803),(16197,2804),(16198,2804),(16199,2804),(16200,2804),(16201,2805),(16202,2805),(16203,2805),(16204,2805),(16205,2806),(16206,2806),(16207,2806),(16208,2806),(16209,2807),(16210,2807),(16211,2807),(16212,2807),(16213,2808),(16214,2808),(16215,2808),(16216,2808),(16217,2809),(16218,2809),(16219,2809),(16220,2809),(16221,2810),(16222,2810),(16223,2810),(16224,2810),(16225,2811),(16226,2811),(16227,2811),(16228,2811),(16229,2812),(16230,2812),(16231,2812),(16232,2812),(16233,2813),(16234,2813),(16235,2813),(16236,2813),(16237,2814),(16238,2814),(16239,2814),(16240,2814),(16241,2815),(16242,2815),(16243,2815),(16244,2815),(16245,2816),(16246,2816),(16247,2816),(16248,2816),(16249,2817),(16250,2817),(16251,2817),(16252,2817),(16253,2818),(16254,2818),(16255,2818),(16256,2818),(16257,2819),(16258,2819),(16259,2819),(16260,2819),(16261,2820),(16262,2820),(16263,2820),(16264,2820),(16265,2821),(16266,2821),(16267,2821),(16268,2821),(16269,2822),(16270,2823),(16271,2824),(16272,2825),(16273,2826),(16274,2827),(16275,2828),(16276,2829),(16277,2830),(16278,2831),(16279,2832),(16280,2833),(16281,2834),(16282,2835),(16283,2836),(16284,2837),(16285,2838),(16286,2839),(16287,2840),(16288,2841),(16289,2842),(16290,2843),(16291,2844),(16292,2845),(16293,2846),(16294,2847),(16295,2848),(16296,2849),(16297,2850),(16298,2851),(16299,2852),(16300,2853),(16301,2854),(16302,2855),(16303,2856),(16304,2857),(16305,2858),(16306,2859),(16307,2860),(16308,2861),(16309,2862),(16310,2863),(16311,2864),(16312,2865),(16313,2866),(16314,2867),(16315,2868),(16316,2869),(16317,2870),(16318,2871),(16319,2872),(16320,2873),(16321,2874),(16322,2875),(16323,2876),(16324,2877),(16325,2878),(16326,2879),(16327,2880),(16328,2881),(16329,2882),(16330,2883),(16331,2884),(16332,2885),(16333,2886),(16334,2887),(16335,2888),(16336,2889),(16337,2890),(16338,2891),(16339,2892),(16340,2893),(16341,2894),(16342,2895),(16343,2896),(16344,2897),(16345,2898),(16346,2899),(16347,2900),(16348,2901),(16349,2902),(16350,2903),(16351,2904),(16352,2905),(16353,2906),(16354,2907),(16355,2908),(16356,2909),(16357,2910),(16358,2911),(16359,2912),(16360,2913),(16361,2914),(16362,2915),(16363,2916),(16364,2917),(16365,2918),(16366,2919),(16367,2920),(16368,2921),(16369,2822),(16370,2822),(16371,2822),(16372,2822),(16373,2823),(16374,2823),(16375,2823),(16376,2823),(16377,2824),(16378,2824),(16379,2824),(16380,2824),(16381,2825),(16382,2825),(16383,2825),(16384,2825),(16385,2826),(16386,2826),(16387,2826),(16388,2826),(16389,2827),(16390,2827),(16391,2827),(16392,2827),(16393,2828),(16394,2828),(16395,2828),(16396,2828),(16397,2829),(16398,2829),(16399,2829),(16400,2829),(16401,2830),(16402,2830),(16403,2830),(16404,2830),(16405,2831),(16406,2831),(16407,2831),(16408,2831),(16409,2832),(16410,2832),(16411,2832),(16412,2832),(16413,2833),(16414,2833),(16415,2833),(16416,2833),(16417,2834),(16418,2834),(16419,2834),(16420,2834),(16421,2835),(16422,2835),(16423,2835),(16424,2835),(16425,2836),(16426,2836),(16427,2836),(16428,2836),(16429,2837),(16430,2837),(16431,2837),(16432,2837),(16433,2838),(16434,2838),(16435,2838),(16436,2838),(16437,2839),(16438,2839),(16439,2839),(16440,2839),(16441,2840),(16442,2840),(16443,2840),(16444,2840),(16445,2841),(16446,2841),(16447,2841),(16448,2841),(16449,2842),(16450,2842),(16451,2842),(16452,2842),(16453,2843),(16454,2843),(16455,2843),(16456,2843),(16457,2844),(16458,2844),(16459,2844),(16460,2844),(16461,2845),(16462,2845),(16463,2845),(16464,2845),(16465,2846),(16466,2846),(16467,2846),(16468,2846),(16469,2847),(16470,2847),(16471,2847),(16472,2847),(16473,2848),(16474,2848),(16475,2848),(16476,2848),(16477,2849),(16478,2849),(16479,2849),(16480,2849),(16481,2850),(16482,2850),(16483,2850),(16484,2850),(16485,2851),(16486,2851),(16487,2851),(16488,2851),(16489,2852),(16490,2852),(16491,2852),(16492,2852),(16493,2853),(16494,2853),(16495,2853),(16496,2853),(16497,2854),(16498,2854),(16499,2854),(16500,2854),(16501,2855),(16502,2855),(16503,2855),(16504,2855),(16505,2856),(16506,2856),(16507,2856),(16508,2856),(16509,2857),(16510,2857),(16511,2857),(16512,2857),(16513,2858),(16514,2858),(16515,2858),(16516,2858),(16517,2859),(16518,2859),(16519,2859),(16520,2859),(16521,2860),(16522,2860),(16523,2860),(16524,2860),(16525,2861),(16526,2861),(16527,2861),(16528,2861),(16529,2862),(16530,2862),(16531,2862),(16532,2862),(16533,2863),(16534,2863),(16535,2863),(16536,2863),(16537,2864),(16538,2864),(16539,2864),(16540,2864),(16541,2865),(16542,2865),(16543,2865),(16544,2865),(16545,2866),(16546,2866),(16547,2866),(16548,2866),(16549,2867),(16550,2867),(16551,2867),(16552,2867),(16553,2868),(16554,2868),(16555,2868),(16556,2868),(16557,2869),(16558,2869),(16559,2869),(16560,2869),(16561,2870),(16562,2870),(16563,2870),(16564,2870),(16565,2871),(16566,2871),(16567,2871),(16568,2871),(16569,2872),(16570,2872),(16571,2872),(16572,2872),(16573,2873),(16574,2873),(16575,2873),(16576,2873),(16577,2874),(16578,2874),(16579,2874),(16580,2874),(16581,2875),(16582,2875),(16583,2875),(16584,2875),(16585,2876),(16586,2876),(16587,2876),(16588,2876),(16589,2877),(16590,2877),(16591,2877),(16592,2877),(16593,2878),(16594,2878),(16595,2878),(16596,2878),(16597,2879),(16598,2879),(16599,2879),(16600,2879),(16601,2880),(16602,2880),(16603,2880),(16604,2880),(16605,2881),(16606,2881),(16607,2881),(16608,2881),(16609,2882),(16610,2882),(16611,2882),(16612,2882),(16613,2883),(16614,2883),(16615,2883),(16616,2883),(16617,2884),(16618,2884),(16619,2884),(16620,2884),(16621,2885),(16622,2885),(16623,2885),(16624,2885),(16625,2886),(16626,2886),(16627,2886),(16628,2886),(16629,2887),(16630,2887),(16631,2887),(16632,2887),(16633,2888),(16634,2888),(16635,2888),(16636,2888),(16637,2889),(16638,2889),(16639,2889),(16640,2889),(16641,2890),(16642,2890),(16643,2890),(16644,2890),(16645,2891),(16646,2891),(16647,2891),(16648,2891),(16649,2892),(16650,2892),(16651,2892),(16652,2892),(16653,2893),(16654,2893),(16655,2893),(16656,2893),(16657,2894),(16658,2894),(16659,2894),(16660,2894),(16661,2895),(16662,2895),(16663,2895),(16664,2895),(16665,2896),(16666,2896),(16667,2896),(16668,2896),(16669,2897),(16670,2897),(16671,2897),(16672,2897),(16673,2898),(16674,2898),(16675,2898),(16676,2898),(16677,2899),(16678,2899),(16679,2899),(16680,2899),(16681,2900),(16682,2900),(16683,2900),(16684,2900),(16685,2901),(16686,2901),(16687,2901),(16688,2901),(16689,2902),(16690,2902),(16691,2902),(16692,2902),(16693,2903),(16694,2903),(16695,2903),(16696,2903),(16697,2904),(16698,2904),(16699,2904),(16700,2904),(16701,2905),(16702,2905),(16703,2905),(16704,2905),(16705,2906),(16706,2906),(16707,2906),(16708,2906),(16709,2907),(16710,2907),(16711,2907),(16712,2907),(16713,2908),(16714,2908),(16715,2908),(16716,2908),(16717,2909),(16718,2909),(16719,2909),(16720,2909),(16721,2910),(16722,2910),(16723,2910),(16724,2910),(16725,2911),(16726,2911),(16727,2911),(16728,2911),(16729,2912),(16730,2912),(16731,2912),(16732,2912),(16733,2913),(16734,2913),(16735,2913),(16736,2913),(16737,2914),(16738,2914),(16739,2914),(16740,2914),(16741,2915),(16742,2915),(16743,2915),(16744,2915),(16745,2916),(16746,2916),(16747,2916),(16748,2916),(16749,2917),(16750,2917),(16751,2917),(16752,2917),(16753,2918),(16754,2918),(16755,2918),(16756,2918),(16757,2919),(16758,2919),(16759,2919),(16760,2919),(16761,2920),(16762,2920),(16763,2920),(16764,2920),(16765,2921),(16766,2921),(16767,2921),(16768,2921),(16769,2922),(16770,2923),(16771,2924),(16772,2925),(16773,2926),(16774,2927),(16775,2928),(16776,2929),(16777,2930),(16778,2931),(16779,2932),(16780,2933),(16781,2934),(16782,2935),(16783,2936),(16784,2937),(16785,2938),(16786,2939),(16787,2940),(16788,2941),(16789,2942),(16790,2943),(16791,2944),(16792,2945),(16793,2946),(16794,2947),(16795,2948),(16796,2949),(16797,2950),(16798,2951),(16799,2952),(16800,2953),(16801,2954),(16802,2955),(16803,2956),(16804,2957),(16805,2958),(16806,2959),(16807,2960),(16808,2961),(16809,2962),(16810,2963),(16811,2964),(16812,2965),(16813,2966),(16814,2967),(16815,2968),(16816,2969),(16817,2970),(16818,2971),(16819,2972),(16820,2973),(16821,2974),(16822,2975),(16823,2976),(16824,2977),(16825,2978),(16826,2979),(16827,2980),(16828,2981),(16829,2982),(16830,2983),(16831,2984),(16832,2985),(16833,2986),(16834,2987),(16835,2988),(16836,2989),(16837,2990),(16838,2991),(16839,2992),(16840,2993),(16841,2994),(16842,2995),(16843,2996),(16844,2997),(16845,2998),(16846,2999),(16847,3000),(16848,3001),(16849,3002),(16850,3003),(16851,3004),(16852,3005),(16853,3006),(16854,3007),(16855,3008),(16856,3009),(16857,3010),(16858,3011),(16859,3012),(16860,3013),(16861,3014),(16862,3015),(16863,3016),(16864,3017),(16865,3018),(16866,3019),(16867,3020),(16868,3021),(16869,2922),(16870,2922),(16871,2922),(16872,2922),(16873,2923),(16874,2923),(16875,2923),(16876,2923),(16877,2924),(16878,2924),(16879,2924),(16880,2924),(16881,2925),(16882,2925),(16883,2925),(16884,2925),(16885,2926),(16886,2926),(16887,2926),(16888,2926),(16889,2927),(16890,2927),(16891,2927),(16892,2927),(16893,2928),(16894,2928),(16895,2928),(16896,2928),(16897,2929),(16898,2929),(16899,2929),(16900,2929),(16901,2930),(16902,2930),(16903,2930),(16904,2930),(16905,2931),(16906,2931),(16907,2931),(16908,2931),(16909,2932),(16910,2932),(16911,2932),(16912,2932),(16913,2933),(16914,2933),(16915,2933),(16916,2933),(16917,2934),(16918,2934),(16919,2934),(16920,2934),(16921,2935),(16922,2935),(16923,2935),(16924,2935),(16925,2936),(16926,2936),(16927,2936),(16928,2936),(16929,2937),(16930,2937),(16931,2937),(16932,2937),(16933,2938),(16934,2938),(16935,2938),(16936,2938),(16937,2939),(16938,2939),(16939,2939),(16940,2939),(16941,2940),(16942,2940),(16943,2940),(16944,2940),(16945,2941),(16946,2941),(16947,2941),(16948,2941),(16949,2942),(16950,2942),(16951,2942),(16952,2942),(16953,2943),(16954,2943),(16955,2943),(16956,2943),(16957,2944),(16958,2944),(16959,2944),(16960,2944),(16961,2945),(16962,2945),(16963,2945),(16964,2945),(16965,2946),(16966,2946),(16967,2946),(16968,2946),(16969,2947),(16970,2947),(16971,2947),(16972,2947),(16973,2948),(16974,2948),(16975,2948),(16976,2948),(16977,2949),(16978,2949),(16979,2949),(16980,2949),(16981,2950),(16982,2950),(16983,2950),(16984,2950),(16985,2951),(16986,2951),(16987,2951),(16988,2951),(16989,2952),(16990,2952),(16991,2952),(16992,2952),(16993,2953),(16994,2953),(16995,2953),(16996,2953),(16997,2954),(16998,2954),(16999,2954),(17000,2954),(17001,2955),(17002,2955),(17003,2955),(17004,2955),(17005,2956),(17006,2956),(17007,2956),(17008,2956),(17009,2957),(17010,2957),(17011,2957),(17012,2957),(17013,2958),(17014,2958),(17015,2958),(17016,2958),(17017,2959),(17018,2959),(17019,2959),(17020,2959),(17021,2960),(17022,2960),(17023,2960),(17024,2960),(17025,2961),(17026,2961),(17027,2961),(17028,2961),(17029,2962),(17030,2962),(17031,2962),(17032,2962),(17033,2963),(17034,2963),(17035,2963),(17036,2963),(17037,2964),(17038,2964),(17039,2964),(17040,2964),(17041,2965),(17042,2965),(17043,2965),(17044,2965),(17045,2966),(17046,2966),(17047,2966),(17048,2966),(17049,2967),(17050,2967),(17051,2967),(17052,2967),(17053,2968),(17054,2968),(17055,2968),(17056,2968),(17057,2969),(17058,2969),(17059,2969),(17060,2969),(17061,2970),(17062,2970),(17063,2970),(17064,2970),(17065,2971),(17066,2971),(17067,2971),(17068,2971),(17069,2972),(17070,2972),(17071,2972),(17072,2972),(17073,2973),(17074,2973),(17075,2973),(17076,2973),(17077,2974),(17078,2974),(17079,2974),(17080,2974),(17081,2975),(17082,2975),(17083,2975),(17084,2975),(17085,2976),(17086,2976),(17087,2976),(17088,2976),(17089,2977),(17090,2977),(17091,2977),(17092,2977),(17093,2978),(17094,2978),(17095,2978),(17096,2978),(17097,2979),(17098,2979),(17099,2979),(17100,2979),(17101,2980),(17102,2980),(17103,2980),(17104,2980),(17105,2981),(17106,2981),(17107,2981),(17108,2981),(17109,2982),(17110,2982),(17111,2982),(17112,2982),(17113,2983),(17114,2983),(17115,2983),(17116,2983),(17117,2984),(17118,2984),(17119,2984),(17120,2984),(17121,2985),(17122,2985),(17123,2985),(17124,2985),(17125,2986),(17126,2986),(17127,2986),(17128,2986),(17129,2987),(17130,2987),(17131,2987),(17132,2987),(17133,2988),(17134,2988),(17135,2988),(17136,2988),(17137,2989),(17138,2989),(17139,2989),(17140,2989),(17141,2990),(17142,2990),(17143,2990),(17144,2990),(17145,2991),(17146,2991),(17147,2991),(17148,2991),(17149,2992),(17150,2992),(17151,2992),(17152,2992),(17153,2993),(17154,2993),(17155,2993),(17156,2993),(17157,2994),(17158,2994),(17159,2994),(17160,2994),(17161,2995),(17162,2995),(17163,2995),(17164,2995),(17165,2996),(17166,2996),(17167,2996),(17168,2996),(17169,2997),(17170,2997),(17171,2997),(17172,2997),(17173,2998),(17174,2998),(17175,2998),(17176,2998),(17177,2999),(17178,2999),(17179,2999),(17180,2999),(17181,3000),(17182,3000),(17183,3000),(17184,3000),(17185,3001),(17186,3001),(17187,3001),(17188,3001),(17189,3002),(17190,3002),(17191,3002),(17192,3002),(17193,3003),(17194,3003),(17195,3003),(17196,3003),(17197,3004),(17198,3004),(17199,3004),(17200,3004),(17201,3005),(17202,3005),(17203,3005),(17204,3005),(17205,3006),(17206,3006),(17207,3006),(17208,3006),(17209,3007),(17210,3007),(17211,3007),(17212,3007),(17213,3008),(17214,3008),(17215,3008),(17216,3008),(17217,3009),(17218,3009),(17219,3009),(17220,3009),(17221,3010),(17222,3010),(17223,3010),(17224,3010),(17225,3011),(17226,3011),(17227,3011),(17228,3011),(17229,3012),(17230,3012),(17231,3012),(17232,3012),(17233,3013),(17234,3013),(17235,3013),(17236,3013),(17237,3014),(17238,3014),(17239,3014),(17240,3014),(17241,3015),(17242,3015),(17243,3015),(17244,3015),(17245,3016),(17246,3016),(17247,3016),(17248,3016),(17249,3017),(17250,3017),(17251,3017),(17252,3017),(17253,3018),(17254,3018),(17255,3018),(17256,3018),(17257,3019),(17258,3019),(17259,3019),(17260,3019),(17261,3020),(17262,3020),(17263,3020),(17264,3020),(17265,3021),(17266,3021),(17267,3021),(17268,3021),(17269,3022),(17270,3023),(17271,3024),(17272,3025),(17273,3026),(17274,3027),(17275,3028),(17276,3029),(17277,3030),(17278,3031),(17279,3032),(17280,3033),(17281,3034),(17282,3035),(17283,3036),(17284,3037),(17285,3038),(17286,3039),(17287,3040),(17288,3041),(17289,3042),(17290,3043),(17291,3044),(17292,3045),(17293,3046),(17294,3047),(17295,3048),(17296,3049),(17297,3050),(17298,3051),(17299,3052),(17300,3053),(17301,3054),(17302,3055),(17303,3056),(17304,3057),(17305,3058),(17306,3059),(17307,3060),(17308,3061),(17309,3062),(17310,3063),(17311,3064),(17312,3065),(17313,3066),(17314,3067),(17315,3068),(17316,3069),(17317,3070),(17318,3071),(17319,3072),(17320,3073),(17321,3074),(17322,3075),(17323,3076),(17324,3077),(17325,3078),(17326,3079),(17327,3080),(17328,3081),(17329,3082),(17330,3083),(17331,3084),(17332,3085),(17333,3086),(17334,3087),(17335,3088),(17336,3089),(17337,3090),(17338,3091),(17339,3092),(17340,3093),(17341,3094),(17342,3095),(17343,3096),(17344,3097),(17345,3098),(17346,3099),(17347,3100),(17348,3101),(17349,3102),(17350,3103),(17351,3104),(17352,3105),(17353,3106),(17354,3107),(17355,3108),(17356,3109),(17357,3110),(17358,3111),(17359,3112),(17360,3113),(17361,3114),(17362,3115),(17363,3116),(17364,3117),(17365,3118),(17366,3119),(17367,3120),(17368,3121),(17369,3022),(17370,3022),(17371,3022),(17372,3022),(17373,3023),(17374,3023),(17375,3023),(17376,3023),(17377,3024),(17378,3024),(17379,3024),(17380,3024),(17381,3025),(17382,3025),(17383,3025),(17384,3025),(17385,3026),(17386,3026),(17387,3026),(17388,3026),(17389,3027),(17390,3027),(17391,3027),(17392,3027),(17393,3028),(17394,3028),(17395,3028),(17396,3028),(17397,3029),(17398,3029),(17399,3029),(17400,3029),(17401,3030),(17402,3030),(17403,3030),(17404,3030),(17405,3031),(17406,3031),(17407,3031),(17408,3031),(17409,3032),(17410,3032),(17411,3032),(17412,3032),(17413,3033),(17414,3033),(17415,3033),(17416,3033),(17417,3034),(17418,3034),(17419,3034),(17420,3034),(17421,3035),(17422,3035),(17423,3035),(17424,3035),(17425,3036),(17426,3036),(17427,3036),(17428,3036),(17429,3037),(17430,3037),(17431,3037),(17432,3037),(17433,3038),(17434,3038),(17435,3038),(17436,3038),(17437,3039),(17438,3039),(17439,3039),(17440,3039),(17441,3040),(17442,3040),(17443,3040),(17444,3040),(17445,3041),(17446,3041),(17447,3041),(17448,3041),(17449,3042),(17450,3042),(17451,3042),(17452,3042),(17453,3043),(17454,3043),(17455,3043),(17456,3043),(17457,3044),(17458,3044),(17459,3044),(17460,3044),(17461,3045),(17462,3045),(17463,3045),(17464,3045),(17465,3046),(17466,3046),(17467,3046),(17468,3046),(17469,3047),(17470,3047),(17471,3047),(17472,3047),(17473,3048),(17474,3048),(17475,3048),(17476,3048),(17477,3049),(17478,3049),(17479,3049),(17480,3049),(17481,3050),(17482,3050),(17483,3050),(17484,3050),(17485,3051),(17486,3051),(17487,3051),(17488,3051),(17489,3052),(17490,3052),(17491,3052),(17492,3052),(17493,3053),(17494,3053),(17495,3053),(17496,3053),(17497,3054),(17498,3054),(17499,3054),(17500,3054),(17501,3055),(17502,3055),(17503,3055),(17504,3055),(17505,3056),(17506,3056),(17507,3056),(17508,3056),(17509,3057),(17510,3057),(17511,3057),(17512,3057),(17513,3058),(17514,3058),(17515,3058),(17516,3058),(17517,3059),(17518,3059),(17519,3059),(17520,3059),(17521,3060),(17522,3060),(17523,3060),(17524,3060),(17525,3061),(17526,3061),(17527,3061),(17528,3061),(17529,3062),(17530,3062),(17531,3062),(17532,3062),(17533,3063),(17534,3063),(17535,3063),(17536,3063),(17537,3064),(17538,3064),(17539,3064),(17540,3064),(17541,3065),(17542,3065),(17543,3065),(17544,3065),(17545,3066),(17546,3066),(17547,3066),(17548,3066),(17549,3067),(17550,3067),(17551,3067),(17552,3067),(17553,3068),(17554,3068),(17555,3068),(17556,3068),(17557,3069),(17558,3069),(17559,3069),(17560,3069),(17561,3070),(17562,3070),(17563,3070),(17564,3070),(17565,3071),(17566,3071),(17567,3071),(17568,3071),(17569,3072),(17570,3072),(17571,3072),(17572,3072),(17573,3073),(17574,3073),(17575,3073),(17576,3073),(17577,3074),(17578,3074),(17579,3074),(17580,3074),(17581,3075),(17582,3075),(17583,3075),(17584,3075),(17585,3076),(17586,3076),(17587,3076),(17588,3076),(17589,3077),(17590,3077),(17591,3077),(17592,3077),(17593,3078),(17594,3078),(17595,3078),(17596,3078),(17597,3079),(17598,3079),(17599,3079),(17600,3079),(17601,3080),(17602,3080),(17603,3080),(17604,3080),(17605,3081),(17606,3081),(17607,3081),(17608,3081),(17609,3082),(17610,3082),(17611,3082),(17612,3082),(17613,3083),(17614,3083),(17615,3083),(17616,3083),(17617,3084),(17618,3084),(17619,3084),(17620,3084),(17621,3085),(17622,3085),(17623,3085),(17624,3085),(17625,3086),(17626,3086),(17627,3086),(17628,3086),(17629,3087),(17630,3087),(17631,3087),(17632,3087),(17633,3088),(17634,3088),(17635,3088),(17636,3088),(17637,3089),(17638,3089),(17639,3089),(17640,3089),(17641,3090),(17642,3090),(17643,3090),(17644,3090),(17645,3091),(17646,3091),(17647,3091),(17648,3091),(17649,3092),(17650,3092),(17651,3092),(17652,3092),(17653,3093),(17654,3093),(17655,3093),(17656,3093),(17657,3094),(17658,3094),(17659,3094),(17660,3094),(17661,3095),(17662,3095),(17663,3095),(17664,3095),(17665,3096),(17666,3096),(17667,3096),(17668,3096),(17669,3097),(17670,3097),(17671,3097),(17672,3097),(17673,3098),(17674,3098),(17675,3098),(17676,3098),(17677,3099),(17678,3099),(17679,3099),(17680,3099),(17681,3100),(17682,3100),(17683,3100),(17684,3100),(17685,3101),(17686,3101),(17687,3101),(17688,3101),(17689,3102),(17690,3102),(17691,3102),(17692,3102),(17693,3103),(17694,3103),(17695,3103),(17696,3103),(17697,3104),(17698,3104),(17699,3104),(17700,3104),(17701,3105),(17702,3105),(17703,3105),(17704,3105),(17705,3106),(17706,3106),(17707,3106),(17708,3106),(17709,3107),(17710,3107),(17711,3107),(17712,3107),(17713,3108),(17714,3108),(17715,3108),(17716,3108),(17717,3109),(17718,3109),(17719,3109),(17720,3109),(17721,3110),(17722,3110),(17723,3110),(17724,3110),(17725,3111),(17726,3111),(17727,3111),(17728,3111),(17729,3112),(17730,3112),(17731,3112),(17732,3112),(17733,3113),(17734,3113),(17735,3113),(17736,3113),(17737,3114),(17738,3114),(17739,3114),(17740,3114),(17741,3115),(17742,3115),(17743,3115),(17744,3115),(17745,3116),(17746,3116),(17747,3116),(17748,3116),(17749,3117),(17750,3117),(17751,3117),(17752,3117),(17753,3118),(17754,3118),(17755,3118),(17756,3118),(17757,3119),(17758,3119),(17759,3119),(17760,3119),(17761,3120),(17762,3120),(17763,3120),(17764,3120),(17765,3121),(17766,3121),(17767,3121),(17768,3121),(17769,3122),(17770,3123),(17771,3124),(17772,3125),(17773,3126),(17774,3127),(17775,3128),(17776,3129),(17777,3130),(17778,3131),(17779,3132),(17780,3133),(17781,3134),(17782,3135),(17783,3136),(17784,3137),(17785,3138),(17786,3139),(17787,3140),(17788,3141),(17789,3142),(17790,3143),(17791,3144),(17792,3145),(17793,3146),(17794,3147),(17795,3148),(17796,3149),(17797,3150),(17798,3151),(17799,3152),(17800,3153),(17801,3154),(17802,3155),(17803,3156),(17804,3157),(17805,3158),(17806,3159),(17807,3160),(17808,3161),(17809,3162),(17810,3163),(17811,3164),(17812,3165),(17813,3166),(17814,3167),(17815,3168),(17816,3122),(17817,3122),(17818,3122),(17819,3122),(17820,3123),(17821,3123),(17822,3123),(17823,3123),(17824,3124),(17825,3124),(17826,3124),(17827,3124),(17828,3125),(17829,3125),(17830,3125),(17831,3125),(17832,3126),(17833,3126),(17834,3126),(17835,3126),(17836,3127),(17837,3127),(17838,3127),(17839,3127),(17840,3128),(17841,3128),(17842,3128),(17843,3128),(17844,3129),(17845,3129),(17846,3129),(17847,3129),(17848,3130),(17849,3130),(17850,3130),(17851,3130),(17852,3131),(17853,3131),(17854,3131),(17855,3131),(17856,3132),(17857,3132),(17858,3132),(17859,3132),(17860,3133),(17861,3133),(17862,3133),(17863,3133),(17864,3134),(17865,3134),(17866,3134),(17867,3134),(17868,3135),(17869,3135),(17870,3135),(17871,3135),(17872,3136),(17873,3136),(17874,3136),(17875,3136),(17876,3137),(17877,3137),(17878,3137),(17879,3137),(17880,3138),(17881,3138),(17882,3138),(17883,3138),(17884,3139),(17885,3139),(17886,3139),(17887,3139),(17888,3140),(17889,3140),(17890,3140),(17891,3140),(17892,3141),(17893,3141),(17894,3141),(17895,3141),(17896,3142),(17897,3142),(17898,3142),(17899,3142),(17900,3143),(17901,3143),(17902,3143),(17903,3143),(17904,3144),(17905,3144),(17906,3144),(17907,3144),(17908,3145),(17909,3145),(17910,3145),(17911,3145),(17912,3146),(17913,3146),(17914,3146),(17915,3146),(17916,3147),(17917,3147),(17918,3147),(17919,3147),(17920,3148),(17921,3148),(17922,3148),(17923,3148),(17924,3149),(17925,3149),(17926,3149),(17927,3149),(17928,3150),(17929,3150),(17930,3150),(17931,3150),(17932,3151),(17933,3151),(17934,3151),(17935,3151),(17936,3152),(17937,3152),(17938,3152),(17939,3152),(17940,3153),(17941,3153),(17942,3153),(17943,3153),(17944,3154),(17945,3154),(17946,3154),(17947,3154),(17948,3155),(17949,3155),(17950,3155),(17951,3155),(17952,3156),(17953,3156),(17954,3156),(17955,3156),(17956,3157),(17957,3157),(17958,3157),(17959,3157),(17960,3158),(17961,3158),(17962,3158),(17963,3158),(17964,3159),(17965,3159),(17966,3159),(17967,3159),(17968,3160),(17969,3160),(17970,3160),(17971,3160),(17972,3161),(17973,3161),(17974,3161),(17975,3161),(17976,3162),(17977,3162),(17978,3162),(17979,3162),(17980,3163),(17981,3163),(17982,3163),(17983,3163),(17984,3164),(17985,3164),(17986,3164),(17987,3164),(17988,3165),(17989,3165),(17990,3165),(17991,3165),(17992,3166),(17993,3166),(17994,3166),(17995,3166),(17996,3167),(17997,3167),(17998,3167),(17999,3167),(18000,3168),(18001,3168),(18002,3168),(18003,3168),(18004,3169),(18005,3170),(18006,3171),(18007,3172),(18008,3173),(18009,3174),(18010,3175),(18011,3176),(18012,3177),(18013,3178),(18014,3179),(18015,3180),(18016,3181),(18017,3182),(18018,3183),(18019,3184),(18020,3185),(18021,3186),(18022,3187),(18023,3188),(18024,3189),(18025,3190),(18026,3191),(18027,3192),(18028,3193),(18029,3194),(18030,3195),(18031,3196),(18032,3197),(18033,3198),(18034,3199),(18035,3200),(18036,3201),(18037,3202),(18038,3203),(18039,3204),(18040,3205),(18041,3206),(18042,3207),(18043,3208),(18044,3209),(18045,3210),(18046,3211),(18047,3212),(18048,3213),(18049,3214),(18050,3215),(18051,3216),(18052,3217),(18053,3218),(18054,3219),(18055,3220),(18056,3221),(18057,3222),(18058,3223),(18059,3224),(18060,3225),(18061,3226),(18062,3227),(18063,3228),(18064,3229),(18065,3230),(18066,3231),(18067,3232),(18068,3233),(18069,3234),(18070,3235),(18071,3236),(18072,3237),(18073,3238),(18074,3239),(18075,3240),(18076,3241),(18077,3242),(18078,3243),(18079,3244),(18080,3245),(18081,3246),(18082,3247),(18083,3248),(18084,3249),(18085,3250),(18086,3251),(18087,3252),(18088,3253),(18089,3254),(18090,3255),(18091,3256),(18092,3257),(18093,3258),(18094,3259),(18095,3260),(18096,3261),(18097,3262),(18098,3263),(18099,3264),(18100,3265),(18101,3266),(18102,3267),(18103,3268),(18104,3169),(18105,3169),(18106,3169),(18107,3169),(18108,3170),(18109,3170),(18110,3170),(18111,3170),(18112,3171),(18113,3171),(18114,3171),(18115,3171),(18116,3172),(18117,3172),(18118,3172),(18119,3172),(18120,3173),(18121,3173),(18122,3173),(18123,3173),(18124,3174),(18125,3174),(18126,3174),(18127,3174),(18128,3175),(18129,3175),(18130,3175),(18131,3175),(18132,3176),(18133,3176),(18134,3176),(18135,3176),(18136,3177),(18137,3177),(18138,3177),(18139,3177),(18140,3178),(18141,3178),(18142,3178),(18143,3178),(18144,3179),(18145,3179),(18146,3179),(18147,3179),(18148,3180),(18149,3180),(18150,3180),(18151,3180),(18152,3181),(18153,3181),(18154,3181),(18155,3181),(18156,3182),(18157,3182),(18158,3182),(18159,3182),(18160,3183),(18161,3183),(18162,3183),(18163,3183),(18164,3184),(18165,3184),(18166,3184),(18167,3184),(18168,3185),(18169,3185),(18170,3185),(18171,3185),(18172,3186),(18173,3186),(18174,3186),(18175,3186),(18176,3187),(18177,3187),(18178,3187),(18179,3187),(18180,3188),(18181,3188),(18182,3188),(18183,3188),(18184,3189),(18185,3189),(18186,3189),(18187,3189),(18188,3190),(18189,3190),(18190,3190),(18191,3190),(18192,3191),(18193,3191),(18194,3191),(18195,3191),(18196,3192),(18197,3192),(18198,3192),(18199,3192),(18200,3193),(18201,3193),(18202,3193),(18203,3193),(18204,3194),(18205,3194),(18206,3194),(18207,3194),(18208,3195),(18209,3195),(18210,3195),(18211,3195),(18212,3196),(18213,3196),(18214,3196),(18215,3196),(18216,3197),(18217,3197),(18218,3197),(18219,3197),(18220,3198),(18221,3198),(18222,3198),(18223,3198),(18224,3199),(18225,3199),(18226,3199),(18227,3199),(18228,3200),(18229,3200),(18230,3200),(18231,3200),(18232,3201),(18233,3201),(18234,3201),(18235,3201),(18236,3202),(18237,3202),(18238,3202),(18239,3202),(18240,3203),(18241,3203),(18242,3203),(18243,3203),(18244,3204),(18245,3204),(18246,3204),(18247,3204),(18248,3205),(18249,3205),(18250,3205),(18251,3205),(18252,3206),(18253,3206),(18254,3206),(18255,3206),(18256,3207),(18257,3207),(18258,3207),(18259,3207),(18260,3208),(18261,3208),(18262,3208),(18263,3208),(18264,3209),(18265,3209),(18266,3209),(18267,3209),(18268,3210),(18269,3210),(18270,3210),(18271,3210),(18272,3211),(18273,3211),(18274,3211),(18275,3211),(18276,3212),(18277,3212),(18278,3212),(18279,3212),(18280,3213),(18281,3213),(18282,3213),(18283,3213),(18284,3214),(18285,3214),(18286,3214),(18287,3214),(18288,3215),(18289,3215),(18290,3215),(18291,3215),(18292,3216),(18293,3216),(18294,3216),(18295,3216),(18296,3217),(18297,3217),(18298,3217),(18299,3217),(18300,3218),(18301,3218),(18302,3218),(18303,3218),(18304,3219),(18305,3219),(18306,3219),(18307,3219),(18308,3220),(18309,3220),(18310,3220),(18311,3220),(18312,3221),(18313,3221),(18314,3221),(18315,3221),(18316,3222),(18317,3222),(18318,3222),(18319,3222),(18320,3223),(18321,3223),(18322,3223),(18323,3223),(18324,3224),(18325,3224),(18326,3224),(18327,3224),(18328,3225),(18329,3225),(18330,3225),(18331,3225),(18332,3226),(18333,3226),(18334,3226),(18335,3226),(18336,3227),(18337,3227),(18338,3227),(18339,3227),(18340,3228),(18341,3228),(18342,3228),(18343,3228),(18344,3229),(18345,3229),(18346,3229),(18347,3229),(18348,3230),(18349,3230),(18350,3230),(18351,3230),(18352,3231),(18353,3231),(18354,3231),(18355,3231),(18356,3232),(18357,3232),(18358,3232),(18359,3232),(18360,3233),(18361,3233),(18362,3233),(18363,3233),(18364,3234),(18365,3234),(18366,3234),(18367,3234),(18368,3235),(18369,3235),(18370,3235),(18371,3235),(18372,3236),(18373,3236),(18374,3236),(18375,3236),(18376,3237),(18377,3237),(18378,3237),(18379,3237),(18380,3238),(18381,3238),(18382,3238),(18383,3238),(18384,3239),(18385,3239),(18386,3239),(18387,3239),(18388,3240),(18389,3240),(18390,3240),(18391,3240),(18392,3241),(18393,3241),(18394,3241),(18395,3241),(18396,3242),(18397,3242),(18398,3242),(18399,3242),(18400,3243),(18401,3243),(18402,3243),(18403,3243),(18404,3244),(18405,3244),(18406,3244),(18407,3244),(18408,3245),(18409,3245),(18410,3245),(18411,3245),(18412,3246),(18413,3246),(18414,3246),(18415,3246),(18416,3247),(18417,3247),(18418,3247),(18419,3247),(18420,3248),(18421,3248),(18422,3248),(18423,3248),(18424,3249),(18425,3249),(18426,3249),(18427,3249),(18428,3250),(18429,3250),(18430,3250),(18431,3250),(18432,3251),(18433,3251),(18434,3251),(18435,3251),(18436,3252),(18437,3252),(18438,3252),(18439,3252),(18440,3253),(18441,3253),(18442,3253),(18443,3253),(18444,3254),(18445,3254),(18446,3254),(18447,3254),(18448,3255),(18449,3255),(18450,3255),(18451,3255),(18452,3256),(18453,3256),(18454,3256),(18455,3256),(18456,3257),(18457,3257),(18458,3257),(18459,3257),(18460,3258),(18461,3258),(18462,3258),(18463,3258),(18464,3259),(18465,3259),(18466,3259),(18467,3259),(18468,3260),(18469,3260),(18470,3260),(18471,3260),(18472,3261),(18473,3261),(18474,3261),(18475,3261),(18476,3262),(18477,3262),(18478,3262),(18479,3262),(18480,3263),(18481,3263),(18482,3263),(18483,3263),(18484,3264),(18485,3264),(18486,3264),(18487,3264),(18488,3265),(18489,3265),(18490,3265),(18491,3265),(18492,3266),(18493,3266),(18494,3266),(18495,3266),(18496,3267),(18497,3267),(18498,3267),(18499,3267),(18500,3268),(18501,3268),(18502,3268),(18503,3268),(18504,3269),(18505,3270),(18506,3271),(18507,3272),(18508,3273),(18509,3274),(18510,3275),(18511,3276),(18512,3277),(18513,3278),(18514,3279),(18515,3280),(18516,3281),(18517,3282),(18518,3283),(18519,3284),(18520,3285),(18521,3286),(18522,3287),(18523,3288),(18524,3289),(18525,3290),(18526,3291),(18527,3292),(18528,3293),(18529,3294),(18530,3295),(18531,3296),(18532,3297),(18533,3298),(18534,3299),(18535,3300),(18536,3301),(18537,3302),(18538,3303),(18539,3304),(18540,3305),(18541,3306),(18542,3307),(18543,3308),(18544,3309),(18545,3310),(18546,3311),(18547,3312),(18548,3313),(18549,3314),(18550,3315),(18551,3316),(18552,3317),(18553,3318),(18554,3319),(18555,3320),(18556,3321),(18557,3322),(18558,3323),(18559,3324),(18560,3325),(18561,3326),(18562,3327),(18563,3328),(18564,3329),(18565,3330),(18566,3331),(18567,3332),(18568,3333),(18569,3334),(18570,3335),(18571,3336),(18572,3337),(18573,3338),(18574,3339),(18575,3340),(18576,3341),(18577,3342),(18578,3343),(18579,3344),(18580,3345),(18581,3346),(18582,3347),(18583,3348),(18584,3349),(18585,3350),(18586,3351),(18587,3352),(18588,3353),(18589,3354),(18590,3355),(18591,3356),(18592,3357),(18593,3358),(18594,3359),(18595,3360),(18596,3361),(18597,3362),(18598,3363),(18599,3364),(18600,3365),(18601,3366),(18602,3367),(18603,3368),(18604,3269),(18605,3269),(18606,3269),(18607,3269),(18608,3270),(18609,3270),(18610,3270),(18611,3270),(18612,3271),(18613,3271),(18614,3271),(18615,3271),(18616,3272),(18617,3272),(18618,3272),(18619,3272),(18620,3273),(18621,3273),(18622,3273),(18623,3273),(18624,3274),(18625,3274),(18626,3274),(18627,3274),(18628,3275),(18629,3275),(18630,3275),(18631,3275),(18632,3276),(18633,3276),(18634,3276),(18635,3276),(18636,3277),(18637,3277),(18638,3277),(18639,3277),(18640,3278),(18641,3278),(18642,3278),(18643,3278),(18644,3279),(18645,3279),(18646,3279),(18647,3279),(18648,3280),(18649,3280),(18650,3280),(18651,3280),(18652,3281),(18653,3281),(18654,3281),(18655,3281),(18656,3282),(18657,3282),(18658,3282),(18659,3282),(18660,3283),(18661,3283),(18662,3283),(18663,3283),(18664,3284),(18665,3284),(18666,3284),(18667,3284),(18668,3285),(18669,3285),(18670,3285),(18671,3285),(18672,3286),(18673,3286),(18674,3286),(18675,3286),(18676,3287),(18677,3287),(18678,3287),(18679,3287),(18680,3288),(18681,3288),(18682,3288),(18683,3288),(18684,3289),(18685,3289),(18686,3289),(18687,3289),(18688,3290),(18689,3290),(18690,3290),(18691,3290),(18692,3291),(18693,3291),(18694,3291),(18695,3291),(18696,3292),(18697,3292),(18698,3292),(18699,3292),(18700,3293),(18701,3293),(18702,3293),(18703,3293),(18704,3294),(18705,3294),(18706,3294),(18707,3294),(18708,3295),(18709,3295),(18710,3295),(18711,3295),(18712,3296),(18713,3296),(18714,3296),(18715,3296),(18716,3297),(18717,3297),(18718,3297),(18719,3297),(18720,3298),(18721,3298),(18722,3298),(18723,3298),(18724,3299),(18725,3299),(18726,3299),(18727,3299),(18728,3300),(18729,3300),(18730,3300),(18731,3300),(18732,3301),(18733,3301),(18734,3301),(18735,3301),(18736,3302),(18737,3302),(18738,3302),(18739,3302),(18740,3303),(18741,3303),(18742,3303),(18743,3303),(18744,3304),(18745,3304),(18746,3304),(18747,3304),(18748,3305),(18749,3305),(18750,3305),(18751,3305),(18752,3306),(18753,3306),(18754,3306),(18755,3306),(18756,3307),(18757,3307),(18758,3307),(18759,3307),(18760,3308),(18761,3308),(18762,3308),(18763,3308),(18764,3309),(18765,3309),(18766,3309),(18767,3309),(18768,3310),(18769,3310),(18770,3310),(18771,3310),(18772,3311),(18773,3311),(18774,3311),(18775,3311),(18776,3312),(18777,3312),(18778,3312),(18779,3312),(18780,3313),(18781,3313),(18782,3313),(18783,3313),(18784,3314),(18785,3314),(18786,3314),(18787,3314),(18788,3315),(18789,3315),(18790,3315),(18791,3315),(18792,3316),(18793,3316),(18794,3316),(18795,3316),(18796,3317),(18797,3317),(18798,3317),(18799,3317),(18800,3318),(18801,3318),(18802,3318),(18803,3318),(18804,3319),(18805,3319),(18806,3319),(18807,3319),(18808,3320),(18809,3320),(18810,3320),(18811,3320),(18812,3321),(18813,3321),(18814,3321),(18815,3321),(18816,3322),(18817,3322),(18818,3322),(18819,3322),(18820,3323),(18821,3323),(18822,3323),(18823,3323),(18824,3324),(18825,3324),(18826,3324),(18827,3324),(18828,3325),(18829,3325),(18830,3325),(18831,3325),(18832,3326),(18833,3326),(18834,3326),(18835,3326),(18836,3327),(18837,3327),(18838,3327),(18839,3327),(18840,3328),(18841,3328),(18842,3328),(18843,3328),(18844,3329),(18845,3329),(18846,3329),(18847,3329),(18848,3330),(18849,3330),(18850,3330),(18851,3330),(18852,3331),(18853,3331),(18854,3331),(18855,3331),(18856,3332),(18857,3332),(18858,3332),(18859,3332),(18860,3333),(18861,3333),(18862,3333),(18863,3333),(18864,3334),(18865,3334),(18866,3334),(18867,3334),(18868,3335),(18869,3335),(18870,3335),(18871,3335),(18872,3336),(18873,3336),(18874,3336),(18875,3336),(18876,3337),(18877,3337),(18878,3337),(18879,3337),(18880,3338),(18881,3338),(18882,3338),(18883,3338),(18884,3339),(18885,3339),(18886,3339),(18887,3339),(18888,3340),(18889,3340),(18890,3340),(18891,3340),(18892,3341),(18893,3341),(18894,3341),(18895,3341),(18896,3342),(18897,3342),(18898,3342),(18899,3342),(18900,3343),(18901,3343),(18902,3343),(18903,3343),(18904,3344),(18905,3344),(18906,3344),(18907,3344),(18908,3345),(18909,3345),(18910,3345),(18911,3345),(18912,3346),(18913,3346),(18914,3346),(18915,3346),(18916,3347),(18917,3347),(18918,3347),(18919,3347),(18920,3348),(18921,3348),(18922,3348),(18923,3348),(18924,3349),(18925,3349),(18926,3349),(18927,3349),(18928,3350),(18929,3350),(18930,3350),(18931,3350),(18932,3351),(18933,3351),(18934,3351),(18935,3351),(18936,3352),(18937,3352),(18938,3352),(18939,3352),(18940,3353),(18941,3353),(18942,3353),(18943,3353),(18944,3354),(18945,3354),(18946,3354),(18947,3354),(18948,3355),(18949,3355),(18950,3355),(18951,3355),(18952,3356),(18953,3356),(18954,3356),(18955,3356),(18956,3357),(18957,3357),(18958,3357),(18959,3357),(18960,3358),(18961,3358),(18962,3358),(18963,3358),(18964,3359),(18965,3359),(18966,3359),(18967,3359),(18968,3360),(18969,3360),(18970,3360),(18971,3360),(18972,3361),(18973,3361),(18974,3361),(18975,3361),(18976,3362),(18977,3362),(18978,3362),(18979,3362),(18980,3363),(18981,3363),(18982,3363),(18983,3363),(18984,3364),(18985,3364),(18986,3364),(18987,3364),(18988,3365),(18989,3365),(18990,3365),(18991,3365),(18992,3366),(18993,3366),(18994,3366),(18995,3366),(18996,3367),(18997,3367),(18998,3367),(18999,3367),(19000,3368),(19001,3368),(19002,3368),(19003,3368),(19004,3369),(19005,3370),(19006,3371),(19007,3372),(19008,3373),(19009,3374),(19010,3375),(19011,3376),(19012,3377),(19013,3378),(19014,3379),(19015,3380),(19016,3381),(19017,3382),(19018,3383),(19019,3384),(19020,3385),(19021,3386),(19022,3387),(19023,3388),(19024,3389),(19025,3390),(19026,3391),(19027,3392),(19028,3393),(19029,3394),(19030,3395),(19031,3396),(19032,3397),(19033,3398),(19034,3399),(19035,3400),(19036,3401),(19037,3402),(19038,3403),(19039,3404),(19040,3405),(19041,3406),(19042,3407),(19043,3408),(19044,3409),(19045,3410),(19046,3411),(19047,3412),(19048,3413),(19049,3414),(19050,3415),(19051,3416),(19052,3417),(19053,3418),(19054,3419),(19055,3420),(19056,3421),(19057,3422),(19058,3423),(19059,3424),(19060,3425),(19061,3426),(19062,3427),(19063,3428),(19064,3429),(19065,3430),(19066,3431),(19067,3432),(19068,3433),(19069,3434),(19070,3435),(19071,3436),(19072,3437),(19073,3438),(19074,3439),(19075,3440),(19076,3441),(19077,3442),(19078,3443),(19079,3444),(19080,3445),(19081,3446),(19082,3447),(19083,3448),(19084,3449),(19085,3450),(19086,3451),(19087,3452),(19088,3453),(19089,3454),(19090,3455),(19091,3456),(19092,3457),(19093,3458),(19094,3459),(19095,3460),(19096,3461),(19097,3462),(19098,3463),(19099,3464),(19100,3465),(19101,3466),(19102,3467),(19103,3468),(19104,3369),(19105,3369),(19106,3369),(19107,3369),(19108,3370),(19109,3370),(19110,3370),(19111,3370),(19112,3371),(19113,3371),(19114,3371),(19115,3371),(19116,3372),(19117,3372),(19118,3372),(19119,3372),(19120,3373),(19121,3373),(19122,3373),(19123,3373),(19124,3374),(19125,3374),(19126,3374),(19127,3374),(19128,3375),(19129,3375),(19130,3375),(19131,3375),(19132,3376),(19133,3376),(19134,3376),(19135,3376),(19136,3377),(19137,3377),(19138,3377),(19139,3377),(19140,3378),(19141,3378),(19142,3378),(19143,3378),(19144,3379),(19145,3379),(19146,3379),(19147,3379),(19148,3380),(19149,3380),(19150,3380),(19151,3380),(19152,3381),(19153,3381),(19154,3381),(19155,3381),(19156,3382),(19157,3382),(19158,3382),(19159,3382),(19160,3383),(19161,3383),(19162,3383),(19163,3383),(19164,3384),(19165,3384),(19166,3384),(19167,3384),(19168,3385),(19169,3385),(19170,3385),(19171,3385),(19172,3386),(19173,3386),(19174,3386),(19175,3386),(19176,3387),(19177,3387),(19178,3387),(19179,3387),(19180,3388),(19181,3388),(19182,3388),(19183,3388),(19184,3389),(19185,3389),(19186,3389),(19187,3389),(19188,3390),(19189,3390),(19190,3390),(19191,3390),(19192,3391),(19193,3391),(19194,3391),(19195,3391),(19196,3392),(19197,3392),(19198,3392),(19199,3392),(19200,3393),(19201,3393),(19202,3393),(19203,3393),(19204,3394),(19205,3394),(19206,3394),(19207,3394),(19208,3395),(19209,3395),(19210,3395),(19211,3395),(19212,3396),(19213,3396),(19214,3396),(19215,3396),(19216,3397),(19217,3397),(19218,3397),(19219,3397),(19220,3398),(19221,3398),(19222,3398),(19223,3398),(19224,3399),(19225,3399),(19226,3399),(19227,3399),(19228,3400),(19229,3400),(19230,3400),(19231,3400),(19232,3401),(19233,3401),(19234,3401),(19235,3401),(19236,3402),(19237,3402),(19238,3402),(19239,3402),(19240,3403),(19241,3403),(19242,3403),(19243,3403),(19244,3404),(19245,3404),(19246,3404),(19247,3404),(19248,3405),(19249,3405),(19250,3405),(19251,3405),(19252,3406),(19253,3406),(19254,3406),(19255,3406),(19256,3407),(19257,3407),(19258,3407),(19259,3407),(19260,3408),(19261,3408),(19262,3408),(19263,3408),(19264,3409),(19265,3409),(19266,3409),(19267,3409),(19268,3410),(19269,3410),(19270,3410),(19271,3410),(19272,3411),(19273,3411),(19274,3411),(19275,3411),(19276,3412),(19277,3412),(19278,3412),(19279,3412),(19280,3413),(19281,3413),(19282,3413),(19283,3413),(19284,3414),(19285,3414),(19286,3414),(19287,3414),(19288,3415),(19289,3415),(19290,3415),(19291,3415),(19292,3416),(19293,3416),(19294,3416),(19295,3416),(19296,3417),(19297,3417),(19298,3417),(19299,3417),(19300,3418),(19301,3418),(19302,3418),(19303,3418),(19304,3419),(19305,3419),(19306,3419),(19307,3419),(19308,3420),(19309,3420),(19310,3420),(19311,3420),(19312,3421),(19313,3421),(19314,3421),(19315,3421),(19316,3422),(19317,3422),(19318,3422),(19319,3422),(19320,3423),(19321,3423),(19322,3423),(19323,3423),(19324,3424),(19325,3424),(19326,3424),(19327,3424),(19328,3425),(19329,3425),(19330,3425),(19331,3425),(19332,3426),(19333,3426),(19334,3426),(19335,3426),(19336,3427),(19337,3427),(19338,3427),(19339,3427),(19340,3428),(19341,3428),(19342,3428),(19343,3428),(19344,3429),(19345,3429),(19346,3429),(19347,3429),(19348,3430),(19349,3430),(19350,3430),(19351,3430),(19352,3431),(19353,3431),(19354,3431),(19355,3431),(19356,3432),(19357,3432),(19358,3432),(19359,3432),(19360,3433),(19361,3433),(19362,3433),(19363,3433),(19364,3434),(19365,3434),(19366,3434),(19367,3434),(19368,3435),(19369,3435),(19370,3435),(19371,3435),(19372,3436),(19373,3436),(19374,3436),(19375,3436),(19376,3437),(19377,3437),(19378,3437),(19379,3437),(19380,3438),(19381,3438),(19382,3438),(19383,3438),(19384,3439),(19385,3439),(19386,3439),(19387,3439),(19388,3440),(19389,3440),(19390,3440),(19391,3440),(19392,3441),(19393,3441),(19394,3441),(19395,3441),(19396,3442),(19397,3442),(19398,3442),(19399,3442),(19400,3443),(19401,3443),(19402,3443),(19403,3443),(19404,3444),(19405,3444),(19406,3444),(19407,3444),(19408,3445),(19409,3445),(19410,3445),(19411,3445),(19412,3446),(19413,3446),(19414,3446),(19415,3446),(19416,3447),(19417,3447),(19418,3447),(19419,3447),(19420,3448),(19421,3448),(19422,3448),(19423,3448),(19424,3449),(19425,3449),(19426,3449),(19427,3449),(19428,3450),(19429,3450),(19430,3450),(19431,3450),(19432,3451),(19433,3451),(19434,3451),(19435,3451),(19436,3452),(19437,3452),(19438,3452),(19439,3452),(19440,3453),(19441,3453),(19442,3453),(19443,3453),(19444,3454),(19445,3454),(19446,3454),(19447,3454),(19448,3455),(19449,3455),(19450,3455),(19451,3455),(19452,3456),(19453,3456),(19454,3456),(19455,3456),(19456,3457),(19457,3457),(19458,3457),(19459,3457),(19460,3458),(19461,3458),(19462,3458),(19463,3458),(19464,3459),(19465,3459),(19466,3459),(19467,3459),(19468,3460),(19469,3460),(19470,3460),(19471,3460),(19472,3461),(19473,3461),(19474,3461),(19475,3461),(19476,3462),(19477,3462),(19478,3462),(19479,3462),(19480,3463),(19481,3463),(19482,3463),(19483,3463),(19484,3464),(19485,3464),(19486,3464),(19487,3464),(19488,3465),(19489,3465),(19490,3465),(19491,3465),(19492,3466),(19493,3466),(19494,3466),(19495,3466),(19496,3467),(19497,3467),(19498,3467),(19499,3467),(19500,3468),(19501,3468),(19502,3468),(19503,3468),(19504,3469),(19505,3470),(19506,3471),(19507,3472),(19508,3473),(19509,3474),(19510,3475),(19511,3476),(19512,3477),(19513,3478),(19514,3479),(19515,3480),(19516,3481),(19517,3482),(19518,3483),(19519,3484),(19520,3485),(19521,3486),(19522,3487),(19523,3488),(19524,3489),(19525,3490),(19526,3491),(19527,3492),(19528,3493),(19529,3494),(19530,3495),(19531,3496),(19532,3497),(19533,3498),(19534,3499),(19535,3500),(19536,3501),(19537,3502),(19538,3503),(19539,3504),(19540,3505),(19541,3506),(19542,3507),(19543,3508),(19544,3509),(19545,3510),(19546,3511),(19547,3512),(19548,3513),(19549,3514),(19550,3515),(19551,3516),(19552,3517),(19553,3518),(19554,3519),(19555,3520),(19556,3521),(19557,3522),(19558,3523),(19559,3524),(19560,3525),(19561,3526),(19562,3527),(19563,3528),(19564,3529),(19565,3530),(19566,3531),(19567,3532),(19568,3533),(19569,3534),(19570,3535),(19571,3536),(19572,3537),(19573,3538),(19574,3539),(19575,3540),(19576,3541),(19577,3542),(19578,3543),(19579,3544),(19580,3545),(19581,3546),(19582,3547),(19583,3548),(19584,3549),(19585,3550),(19586,3551),(19587,3552),(19588,3553),(19589,3554),(19590,3555),(19591,3556),(19592,3557),(19593,3558),(19594,3559),(19595,3560),(19596,3561),(19597,3562),(19598,3563),(19599,3564),(19600,3565),(19601,3566),(19602,3567),(19603,3568),(19604,3469),(19605,3469),(19606,3469),(19607,3469),(19608,3470),(19609,3470),(19610,3470),(19611,3470),(19612,3471),(19613,3471),(19614,3471),(19615,3471),(19616,3472),(19617,3472),(19618,3472),(19619,3472),(19620,3473),(19621,3473),(19622,3473),(19623,3473),(19624,3474),(19625,3474),(19626,3474),(19627,3474),(19628,3475),(19629,3475),(19630,3475),(19631,3475),(19632,3476),(19633,3476),(19634,3476),(19635,3476),(19636,3477),(19637,3477),(19638,3477),(19639,3477),(19640,3478),(19641,3478),(19642,3478),(19643,3478),(19644,3479),(19645,3479),(19646,3479),(19647,3479),(19648,3480),(19649,3480),(19650,3480),(19651,3480),(19652,3481),(19653,3481),(19654,3481),(19655,3481),(19656,3482),(19657,3482),(19658,3482),(19659,3482),(19660,3483),(19661,3483),(19662,3483),(19663,3483),(19664,3484),(19665,3484),(19666,3484),(19667,3484),(19668,3485),(19669,3485),(19670,3485),(19671,3485),(19672,3486),(19673,3486),(19674,3486),(19675,3486),(19676,3487),(19677,3487),(19678,3487),(19679,3487),(19680,3488),(19681,3488),(19682,3488),(19683,3488),(19684,3489),(19685,3489),(19686,3489),(19687,3489),(19688,3490),(19689,3490),(19690,3490),(19691,3490),(19692,3491),(19693,3491),(19694,3491),(19695,3491),(19696,3492),(19697,3492),(19698,3492),(19699,3492),(19700,3493),(19701,3493),(19702,3493),(19703,3493),(19704,3494),(19705,3494),(19706,3494),(19707,3494),(19708,3495),(19709,3495),(19710,3495),(19711,3495),(19712,3496),(19713,3496),(19714,3496),(19715,3496),(19716,3497),(19717,3497),(19718,3497),(19719,3497),(19720,3498),(19721,3498),(19722,3498),(19723,3498),(19724,3499),(19725,3499),(19726,3499),(19727,3499),(19728,3500),(19729,3500),(19730,3500),(19731,3500),(19732,3501),(19733,3501),(19734,3501),(19735,3501),(19736,3502),(19737,3502),(19738,3502),(19739,3502),(19740,3503),(19741,3503),(19742,3503),(19743,3503),(19744,3504),(19745,3504),(19746,3504),(19747,3504),(19748,3505),(19749,3505),(19750,3505),(19751,3505),(19752,3506),(19753,3506),(19754,3506),(19755,3506),(19756,3507),(19757,3507),(19758,3507),(19759,3507),(19760,3508),(19761,3508),(19762,3508),(19763,3508),(19764,3509),(19765,3509),(19766,3509),(19767,3509),(19768,3510),(19769,3510),(19770,3510),(19771,3510),(19772,3511),(19773,3511),(19774,3511),(19775,3511),(19776,3512),(19777,3512),(19778,3512),(19779,3512),(19780,3513),(19781,3513),(19782,3513),(19783,3513),(19784,3514),(19785,3514),(19786,3514),(19787,3514),(19788,3515),(19789,3515),(19790,3515),(19791,3515),(19792,3516),(19793,3516),(19794,3516),(19795,3516),(19796,3517),(19797,3517),(19798,3517),(19799,3517),(19800,3518),(19801,3518),(19802,3518),(19803,3518),(19804,3519),(19805,3519),(19806,3519),(19807,3519),(19808,3520),(19809,3520),(19810,3520),(19811,3520),(19812,3521),(19813,3521),(19814,3521),(19815,3521),(19816,3522),(19817,3522),(19818,3522),(19819,3522),(19820,3523),(19821,3523),(19822,3523),(19823,3523),(19824,3524),(19825,3524),(19826,3524),(19827,3524),(19828,3525),(19829,3525),(19830,3525),(19831,3525),(19832,3526),(19833,3526),(19834,3526),(19835,3526),(19836,3527),(19837,3527),(19838,3527),(19839,3527),(19840,3528),(19841,3528),(19842,3528),(19843,3528),(19844,3529),(19845,3529),(19846,3529),(19847,3529),(19848,3530),(19849,3530),(19850,3530),(19851,3530),(19852,3531),(19853,3531),(19854,3531),(19855,3531),(19856,3532),(19857,3532),(19858,3532),(19859,3532),(19860,3533),(19861,3533),(19862,3533),(19863,3533),(19864,3534),(19865,3534),(19866,3534),(19867,3534),(19868,3535),(19869,3535),(19870,3535),(19871,3535),(19872,3536),(19873,3536),(19874,3536),(19875,3536),(19876,3537),(19877,3537),(19878,3537),(19879,3537),(19880,3538),(19881,3538),(19882,3538),(19883,3538),(19884,3539),(19885,3539),(19886,3539),(19887,3539),(19888,3540),(19889,3540),(19890,3540),(19891,3540),(19892,3541),(19893,3541),(19894,3541),(19895,3541),(19896,3542),(19897,3542),(19898,3542),(19899,3542),(19900,3543),(19901,3543),(19902,3543),(19903,3543),(19904,3544),(19905,3544),(19906,3544),(19907,3544),(19908,3545),(19909,3545),(19910,3545),(19911,3545),(19912,3546),(19913,3546),(19914,3546),(19915,3546),(19916,3547),(19917,3547),(19918,3547),(19919,3547),(19920,3548),(19921,3548),(19922,3548),(19923,3548),(19924,3549),(19925,3549),(19926,3549),(19927,3549),(19928,3550),(19929,3550),(19930,3550),(19931,3550),(19932,3551),(19933,3551),(19934,3551),(19935,3551),(19936,3552),(19937,3552),(19938,3552),(19939,3552),(19940,3553),(19941,3553),(19942,3553),(19943,3553),(19944,3554),(19945,3554),(19946,3554),(19947,3554),(19948,3555),(19949,3555),(19950,3555),(19951,3555),(19952,3556),(19953,3556),(19954,3556),(19955,3556),(19956,3557),(19957,3557),(19958,3557),(19959,3557),(19960,3558),(19961,3558),(19962,3558),(19963,3558),(19964,3559),(19965,3559),(19966,3559),(19967,3559),(19968,3560),(19969,3560),(19970,3560),(19971,3560),(19972,3561),(19973,3561),(19974,3561),(19975,3561),(19976,3562),(19977,3562),(19978,3562),(19979,3562),(19980,3563),(19981,3563),(19982,3563),(19983,3563),(19984,3564),(19985,3564),(19986,3564),(19987,3564),(19988,3565),(19989,3565),(19990,3565),(19991,3565),(19992,3566),(19993,3566),(19994,3566),(19995,3566),(19996,3567),(19997,3567),(19998,3567),(19999,3567),(20000,3568),(20001,3568),(20002,3568),(20003,3568),(20004,3569),(20005,3570),(20006,3571),(20007,3572),(20008,3573),(20009,3574),(20010,3575),(20011,3576),(20012,3577),(20013,3578),(20014,3579),(20015,3580),(20016,3581),(20017,3582),(20018,3583),(20019,3584),(20020,3585),(20021,3586),(20022,3587),(20023,3588),(20024,3589),(20025,3590),(20026,3591),(20027,3592),(20028,3593),(20029,3594),(20030,3595),(20031,3596),(20032,3597),(20033,3598),(20034,3599),(20035,3600),(20036,3601),(20037,3602),(20038,3603),(20039,3604),(20040,3605),(20041,3606),(20042,3607),(20043,3608),(20044,3609),(20045,3610),(20046,3611),(20047,3612),(20048,3613),(20049,3614),(20050,3615),(20051,3616),(20052,3617),(20053,3618),(20054,3619),(20055,3620),(20056,3621),(20057,3622),(20058,3623),(20059,3624),(20060,3625),(20061,3626),(20062,3627),(20063,3628),(20064,3629),(20065,3630),(20066,3631),(20067,3632),(20068,3633),(20069,3634),(20070,3635),(20071,3636),(20072,3637),(20073,3638),(20074,3639),(20075,3640),(20076,3641),(20077,3642),(20078,3643),(20079,3644),(20080,3645),(20081,3646),(20082,3647),(20083,3648),(20084,3649),(20085,3650),(20086,3651),(20087,3652),(20088,3653),(20089,3654),(20090,3655),(20091,3656),(20092,3657),(20093,3658),(20094,3659),(20095,3660),(20096,3661),(20097,3662),(20098,3663),(20099,3664),(20100,3665),(20101,3666),(20102,3667),(20103,3668),(20104,3569),(20105,3569),(20106,3569),(20107,3569),(20108,3570),(20109,3570),(20110,3570),(20111,3570),(20112,3571),(20113,3571),(20114,3571),(20115,3571),(20116,3572),(20117,3572),(20118,3572),(20119,3572),(20120,3573),(20121,3573),(20122,3573),(20123,3573),(20124,3574),(20125,3574),(20126,3574),(20127,3574),(20128,3575),(20129,3575),(20130,3575),(20131,3575),(20132,3576),(20133,3576),(20134,3576),(20135,3576),(20136,3577),(20137,3577),(20138,3577),(20139,3577),(20140,3578),(20141,3578),(20142,3578),(20143,3578),(20144,3579),(20145,3579),(20146,3579),(20147,3579),(20148,3580),(20149,3580),(20150,3580),(20151,3580),(20152,3581),(20153,3581),(20154,3581),(20155,3581),(20156,3582),(20157,3582),(20158,3582),(20159,3582),(20160,3583),(20161,3583),(20162,3583),(20163,3583),(20164,3584),(20165,3584),(20166,3584),(20167,3584),(20168,3585),(20169,3585),(20170,3585),(20171,3585),(20172,3586),(20173,3586),(20174,3586),(20175,3586),(20176,3587),(20177,3587),(20178,3587),(20179,3587),(20180,3588),(20181,3588),(20182,3588),(20183,3588),(20184,3589),(20185,3589),(20186,3589),(20187,3589),(20188,3590),(20189,3590),(20190,3590),(20191,3590),(20192,3591),(20193,3591),(20194,3591),(20195,3591),(20196,3592),(20197,3592),(20198,3592),(20199,3592),(20200,3593),(20201,3593),(20202,3593),(20203,3593),(20204,3594),(20205,3594),(20206,3594),(20207,3594),(20208,3595),(20209,3595),(20210,3595),(20211,3595),(20212,3596),(20213,3596),(20214,3596),(20215,3596),(20216,3597),(20217,3597),(20218,3597),(20219,3597),(20220,3598),(20221,3598),(20222,3598),(20223,3598),(20224,3599),(20225,3599),(20226,3599),(20227,3599),(20228,3600),(20229,3600),(20230,3600),(20231,3600),(20232,3601),(20233,3601),(20234,3601),(20235,3601),(20236,3602),(20237,3602),(20238,3602),(20239,3602),(20240,3603),(20241,3603),(20242,3603),(20243,3603),(20244,3604),(20245,3604),(20246,3604),(20247,3604),(20248,3605),(20249,3605),(20250,3605),(20251,3605),(20252,3606),(20253,3606),(20254,3606),(20255,3606),(20256,3607),(20257,3607),(20258,3607),(20259,3607),(20260,3608),(20261,3608),(20262,3608),(20263,3608),(20264,3609),(20265,3609),(20266,3609),(20267,3609),(20268,3610),(20269,3610),(20270,3610),(20271,3610),(20272,3611),(20273,3611),(20274,3611),(20275,3611),(20276,3612),(20277,3612),(20278,3612),(20279,3612),(20280,3613),(20281,3613),(20282,3613),(20283,3613),(20284,3614),(20285,3614),(20286,3614),(20287,3614),(20288,3615),(20289,3615),(20290,3615),(20291,3615),(20292,3616),(20293,3616),(20294,3616),(20295,3616),(20296,3617),(20297,3617),(20298,3617),(20299,3617),(20300,3618),(20301,3618),(20302,3618),(20303,3618),(20304,3619),(20305,3619),(20306,3619),(20307,3619),(20308,3620),(20309,3620),(20310,3620),(20311,3620),(20312,3621),(20313,3621),(20314,3621),(20315,3621),(20316,3622),(20317,3622),(20318,3622),(20319,3622),(20320,3623),(20321,3623),(20322,3623),(20323,3623),(20324,3624),(20325,3624),(20326,3624),(20327,3624),(20328,3625),(20329,3625),(20330,3625),(20331,3625),(20332,3626),(20333,3626),(20334,3626),(20335,3626),(20336,3627),(20337,3627),(20338,3627),(20339,3627),(20340,3628),(20341,3628),(20342,3628),(20343,3628),(20344,3629),(20345,3629),(20346,3629),(20347,3629),(20348,3630),(20349,3630),(20350,3630),(20351,3630),(20352,3631),(20353,3631),(20354,3631),(20355,3631),(20356,3632),(20357,3632),(20358,3632),(20359,3632),(20360,3633),(20361,3633),(20362,3633),(20363,3633),(20364,3634),(20365,3634),(20366,3634),(20367,3634),(20368,3635),(20369,3635),(20370,3635),(20371,3635),(20372,3636),(20373,3636),(20374,3636),(20375,3636),(20376,3637),(20377,3637),(20378,3637),(20379,3637),(20380,3638),(20381,3638),(20382,3638),(20383,3638),(20384,3639),(20385,3639),(20386,3639),(20387,3639),(20388,3640),(20389,3640),(20390,3640),(20391,3640),(20392,3641),(20393,3641),(20394,3641),(20395,3641),(20396,3642),(20397,3642),(20398,3642),(20399,3642),(20400,3643),(20401,3643),(20402,3643),(20403,3643),(20404,3644),(20405,3644),(20406,3644),(20407,3644),(20408,3645),(20409,3645),(20410,3645),(20411,3645),(20412,3646),(20413,3646),(20414,3646),(20415,3646),(20416,3647),(20417,3647),(20418,3647),(20419,3647),(20420,3648),(20421,3648),(20422,3648),(20423,3648),(20424,3649),(20425,3649),(20426,3649),(20427,3649),(20428,3650),(20429,3650),(20430,3650),(20431,3650),(20432,3651),(20433,3651),(20434,3651),(20435,3651),(20436,3652),(20437,3652),(20438,3652),(20439,3652),(20440,3653),(20441,3653),(20442,3653),(20443,3653),(20444,3654),(20445,3654),(20446,3654),(20447,3654),(20448,3655),(20449,3655),(20450,3655),(20451,3655),(20452,3656),(20453,3656),(20454,3656),(20455,3656),(20456,3657),(20457,3657),(20458,3657),(20459,3657),(20460,3658),(20461,3658),(20462,3658),(20463,3658),(20464,3659),(20465,3659),(20466,3659),(20467,3659),(20468,3660),(20469,3660),(20470,3660),(20471,3660),(20472,3661),(20473,3661),(20474,3661),(20475,3661),(20476,3662),(20477,3662),(20478,3662),(20479,3662),(20480,3663),(20481,3663),(20482,3663),(20483,3663),(20484,3664),(20485,3664),(20486,3664),(20487,3664),(20488,3665),(20489,3665),(20490,3665),(20491,3665),(20492,3666),(20493,3666),(20494,3666),(20495,3666),(20496,3667),(20497,3667),(20498,3667),(20499,3667),(20500,3668),(20501,3668),(20502,3668),(20503,3668),(20504,3669),(20505,3670),(20506,3671),(20507,3672),(20508,3673),(20509,3674),(20510,3675),(20511,3676),(20512,3677),(20513,3678),(20514,3679),(20515,3680),(20516,3681),(20517,3682),(20518,3683),(20519,3684),(20520,3685),(20521,3686),(20522,3687),(20523,3688),(20524,3689),(20525,3690),(20526,3691),(20527,3692),(20528,3693),(20529,3694),(20530,3695),(20531,3696),(20532,3697),(20533,3698),(20534,3699),(20535,3700),(20536,3701),(20537,3702),(20538,3703),(20539,3704),(20540,3705),(20541,3706),(20542,3707),(20543,3708),(20544,3709),(20545,3710),(20546,3711),(20547,3712),(20548,3713),(20549,3714),(20550,3669),(20551,3669),(20552,3669),(20553,3669),(20554,3670),(20555,3670),(20556,3670),(20557,3670),(20558,3671),(20559,3671),(20560,3671),(20561,3671),(20562,3672),(20563,3672),(20564,3672),(20565,3672),(20566,3673),(20567,3673),(20568,3673),(20569,3673),(20570,3674),(20571,3674),(20572,3674),(20573,3674),(20574,3675),(20575,3675),(20576,3675),(20577,3675),(20578,3676),(20579,3676),(20580,3676),(20581,3676),(20582,3677),(20583,3677),(20584,3677),(20585,3677),(20586,3678),(20587,3678),(20588,3678),(20589,3678),(20590,3679),(20591,3679),(20592,3679),(20593,3679),(20594,3680),(20595,3680),(20596,3680),(20597,3680),(20598,3681),(20599,3681),(20600,3681),(20601,3681),(20602,3682),(20603,3682),(20604,3682),(20605,3682),(20606,3683),(20607,3683),(20608,3683),(20609,3683),(20610,3684),(20611,3684),(20612,3684),(20613,3684),(20614,3685),(20615,3685),(20616,3685),(20617,3685),(20618,3686),(20619,3686),(20620,3686),(20621,3686),(20622,3687),(20623,3687),(20624,3687),(20625,3687),(20626,3688),(20627,3688),(20628,3688),(20629,3688),(20630,3689),(20631,3689),(20632,3689),(20633,3689),(20634,3690),(20635,3690),(20636,3690),(20637,3690),(20638,3691),(20639,3691),(20640,3691),(20641,3691),(20642,3692),(20643,3692),(20644,3692),(20645,3692),(20646,3693),(20647,3693),(20648,3693),(20649,3693),(20650,3694),(20651,3694),(20652,3694),(20653,3694),(20654,3695),(20655,3695),(20656,3695),(20657,3695),(20658,3696),(20659,3696),(20660,3696),(20661,3696),(20662,3697),(20663,3697),(20664,3697),(20665,3697),(20666,3698),(20667,3698),(20668,3698),(20669,3698),(20670,3699),(20671,3699),(20672,3699),(20673,3699),(20674,3700),(20675,3700),(20676,3700),(20677,3700),(20678,3701),(20679,3701),(20680,3701),(20681,3701),(20682,3702),(20683,3702),(20684,3702),(20685,3702),(20686,3703),(20687,3703),(20688,3703),(20689,3703),(20690,3704),(20691,3704),(20692,3704),(20693,3704),(20694,3705),(20695,3705),(20696,3705),(20697,3705),(20698,3706),(20699,3706),(20700,3706),(20701,3706),(20702,3707),(20703,3707),(20704,3707),(20705,3707),(20706,3708),(20707,3708),(20708,3708),(20709,3708),(20710,3709),(20711,3709),(20712,3709),(20713,3709),(20714,3710),(20715,3710),(20716,3710),(20717,3710),(20718,3711),(20719,3711),(20720,3711),(20721,3711),(20722,3712),(20723,3712),(20724,3712),(20725,3712),(20726,3713),(20727,3713),(20728,3713),(20729,3713),(20730,3714),(20731,3714),(20732,3714),(20733,3714),(20734,3715),(20735,3716),(20736,3717),(20737,3718),(20738,3719),(20739,3720),(20740,3721),(20741,3722),(20742,3723),(20743,3724),(20744,3725),(20745,3726),(20746,3727),(20747,3728),(20748,3729),(20749,3730),(20750,3731),(20751,3732),(20752,3733),(20753,3734),(20754,3735),(20755,3736),(20756,3737),(20757,3738),(20758,3739),(20759,3740),(20760,3741),(20761,3742),(20762,3743),(20763,3744),(20764,3745),(20765,3746),(20766,3747),(20767,3748),(20768,3749),(20769,3750),(20770,3751),(20771,3752),(20772,3753),(20773,3754),(20774,3755),(20775,3756),(20776,3757),(20777,3758),(20778,3759),(20779,3760),(20780,3761),(20781,3762),(20782,3763),(20783,3764),(20784,3765),(20785,3766),(20786,3767),(20787,3768),(20788,3769),(20789,3770),(20790,3771),(20791,3772),(20792,3773),(20793,3774),(20794,3775),(20795,3776),(20796,3777),(20797,3778),(20798,3779),(20799,3780),(20800,3781),(20801,3782),(20802,3783),(20803,3784),(20804,3785),(20805,3786),(20806,3787),(20807,3788),(20808,3789),(20809,3790),(20810,3791),(20811,3792),(20812,3793),(20813,3794),(20814,3795),(20815,3796),(20816,3797),(20817,3798),(20818,3799),(20819,3800),(20820,3801),(20821,3802),(20822,3803),(20823,3804),(20824,3805),(20825,3806),(20826,3807),(20827,3808),(20828,3809),(20829,3810),(20830,3811),(20831,3812),(20832,3813),(20833,3814),(20834,3715),(20835,3715),(20836,3715),(20837,3715),(20838,3716),(20839,3716),(20840,3716),(20841,3716),(20842,3717),(20843,3717),(20844,3717),(20845,3717),(20846,3718),(20847,3718),(20848,3718),(20849,3718),(20850,3719),(20851,3719),(20852,3719),(20853,3719),(20854,3720),(20855,3720),(20856,3720),(20857,3720),(20858,3721),(20859,3721),(20860,3721),(20861,3721),(20862,3722),(20863,3722),(20864,3722),(20865,3722),(20866,3723),(20867,3723),(20868,3723),(20869,3723),(20870,3724),(20871,3724),(20872,3724),(20873,3724),(20874,3725),(20875,3725),(20876,3725),(20877,3725),(20878,3726),(20879,3726),(20880,3726),(20881,3726),(20882,3727),(20883,3727),(20884,3727),(20885,3727),(20886,3728),(20887,3728),(20888,3728),(20889,3728),(20890,3729),(20891,3729),(20892,3729),(20893,3729),(20894,3730),(20895,3730),(20896,3730),(20897,3730),(20898,3731),(20899,3731),(20900,3731),(20901,3731),(20902,3732),(20903,3732),(20904,3732),(20905,3732),(20906,3733),(20907,3733),(20908,3733),(20909,3733),(20910,3734),(20911,3734),(20912,3734),(20913,3734),(20914,3735),(20915,3735),(20916,3735),(20917,3735),(20918,3736),(20919,3736),(20920,3736),(20921,3736),(20922,3737),(20923,3737),(20924,3737),(20925,3737),(20926,3738),(20927,3738),(20928,3738),(20929,3738),(20930,3739),(20931,3739),(20932,3739),(20933,3739),(20934,3740),(20935,3740),(20936,3740),(20937,3740),(20938,3741),(20939,3741),(20940,3741),(20941,3741),(20942,3742),(20943,3742),(20944,3742),(20945,3742),(20946,3743),(20947,3743),(20948,3743),(20949,3743),(20950,3744),(20951,3744),(20952,3744),(20953,3744),(20954,3745),(20955,3745),(20956,3745),(20957,3745),(20958,3746),(20959,3746),(20960,3746),(20961,3746),(20962,3747),(20963,3747),(20964,3747),(20965,3747),(20966,3748),(20967,3748),(20968,3748),(20969,3748),(20970,3749),(20971,3749),(20972,3749),(20973,3749),(20974,3750),(20975,3750),(20976,3750),(20977,3750),(20978,3751),(20979,3751),(20980,3751),(20981,3751),(20982,3752),(20983,3752),(20984,3752),(20985,3752),(20986,3753),(20987,3753),(20988,3753),(20989,3753),(20990,3754),(20991,3754),(20992,3754),(20993,3754),(20994,3755),(20995,3755),(20996,3755),(20997,3755),(20998,3756),(20999,3756),(21000,3756),(21001,3756),(21002,3757),(21003,3757),(21004,3757),(21005,3757),(21006,3758),(21007,3758),(21008,3758),(21009,3758),(21010,3759),(21011,3759),(21012,3759),(21013,3759),(21014,3760),(21015,3760),(21016,3760),(21017,3760),(21018,3761),(21019,3761),(21020,3761),(21021,3761),(21022,3762),(21023,3762),(21024,3762),(21025,3762),(21026,3763),(21027,3763),(21028,3763),(21029,3763),(21030,3764),(21031,3764),(21032,3764),(21033,3764),(21034,3765),(21035,3765),(21036,3765),(21037,3765),(21038,3766),(21039,3766),(21040,3766),(21041,3766),(21042,3767),(21043,3767),(21044,3767),(21045,3767),(21046,3768),(21047,3768),(21048,3768),(21049,3768),(21050,3769),(21051,3769),(21052,3769),(21053,3769),(21054,3770),(21055,3770),(21056,3770),(21057,3770),(21058,3771),(21059,3771),(21060,3771),(21061,3771),(21062,3772),(21063,3772),(21064,3772),(21065,3772),(21066,3773),(21067,3773),(21068,3773),(21069,3773),(21070,3774),(21071,3774),(21072,3774),(21073,3774),(21074,3775),(21075,3775),(21076,3775),(21077,3775),(21078,3776),(21079,3776),(21080,3776),(21081,3776),(21082,3777),(21083,3777),(21084,3777),(21085,3777),(21086,3778),(21087,3778),(21088,3778),(21089,3778),(21090,3779),(21091,3779),(21092,3779),(21093,3779),(21094,3780),(21095,3780),(21096,3780),(21097,3780),(21098,3781),(21099,3781),(21100,3781),(21101,3781),(21102,3782),(21103,3782),(21104,3782),(21105,3782),(21106,3783),(21107,3783),(21108,3783),(21109,3783),(21110,3784),(21111,3784),(21112,3784),(21113,3784),(21114,3785),(21115,3785),(21116,3785),(21117,3785),(21118,3786),(21119,3786),(21120,3786),(21121,3786),(21122,3787),(21123,3787),(21124,3787),(21125,3787),(21126,3788),(21127,3788),(21128,3788),(21129,3788),(21130,3789),(21131,3789),(21132,3789),(21133,3789),(21134,3790),(21135,3790),(21136,3790),(21137,3790),(21138,3791),(21139,3791),(21140,3791),(21141,3791),(21142,3792),(21143,3792),(21144,3792),(21145,3792),(21146,3793),(21147,3793),(21148,3793),(21149,3793),(21150,3794),(21151,3794),(21152,3794),(21153,3794),(21154,3795),(21155,3795),(21156,3795),(21157,3795),(21158,3796),(21159,3796),(21160,3796),(21161,3796),(21162,3797),(21163,3797),(21164,3797),(21165,3797),(21166,3798),(21167,3798),(21168,3798),(21169,3798),(21170,3799),(21171,3799),(21172,3799),(21173,3799),(21174,3800),(21175,3800),(21176,3800),(21177,3800),(21178,3801),(21179,3801),(21180,3801),(21181,3801),(21182,3802),(21183,3802),(21184,3802),(21185,3802),(21186,3803),(21187,3803),(21188,3803),(21189,3803),(21190,3804),(21191,3804),(21192,3804),(21193,3804),(21194,3805),(21195,3805),(21196,3805),(21197,3805),(21198,3806),(21199,3806),(21200,3806),(21201,3806),(21202,3807),(21203,3807),(21204,3807),(21205,3807),(21206,3808),(21207,3808),(21208,3808),(21209,3808),(21210,3809),(21211,3809),(21212,3809),(21213,3809),(21214,3810),(21215,3810),(21216,3810),(21217,3810),(21218,3811),(21219,3811),(21220,3811),(21221,3811),(21222,3812),(21223,3812),(21224,3812),(21225,3812),(21226,3813),(21227,3813),(21228,3813),(21229,3813),(21230,3814),(21231,3814),(21232,3814),(21233,3814),(21234,3815),(21235,3816),(21236,3817),(21237,3818),(21238,3819),(21239,3820),(21240,3821),(21241,3822),(21242,3823),(21243,3824),(21244,3825),(21245,3826),(21246,3827),(21247,3828),(21248,3829),(21249,3830),(21250,3831),(21251,3832),(21252,3833),(21253,3834),(21254,3835),(21255,3836),(21256,3837),(21257,3838),(21258,3839),(21259,3840),(21260,3841),(21261,3842),(21262,3843),(21263,3844),(21264,3845),(21265,3846),(21266,3847),(21267,3848),(21268,3849),(21269,3850),(21270,3851),(21271,3852),(21272,3853),(21273,3854),(21274,3855),(21275,3856),(21276,3857),(21277,3858),(21278,3859),(21279,3860),(21280,3861),(21281,3862),(21282,3863),(21283,3864),(21284,3865),(21285,3866),(21286,3867),(21287,3868),(21288,3869),(21289,3870),(21290,3871),(21291,3872),(21292,3873),(21293,3874),(21294,3875),(21295,3876),(21296,3877),(21297,3878),(21298,3879),(21299,3880),(21300,3881),(21301,3882),(21302,3883),(21303,3884),(21304,3885),(21305,3886),(21306,3887),(21307,3888),(21308,3889),(21309,3890),(21310,3891),(21311,3892),(21312,3893),(21313,3894),(21314,3895),(21315,3896),(21316,3897),(21317,3898),(21318,3899),(21319,3900),(21320,3901),(21321,3902),(21322,3903),(21323,3904),(21324,3905),(21325,3906),(21326,3907),(21327,3908),(21328,3909),(21329,3910),(21330,3911),(21331,3912),(21332,3913),(21333,3914),(21334,3815),(21335,3815),(21336,3815),(21337,3815),(21338,3816),(21339,3816),(21340,3816),(21341,3816),(21342,3817),(21343,3817),(21344,3817),(21345,3817),(21346,3818),(21347,3818),(21348,3818),(21349,3818),(21350,3819),(21351,3819),(21352,3819),(21353,3819),(21354,3820),(21355,3820),(21356,3820),(21357,3820),(21358,3821),(21359,3821),(21360,3821),(21361,3821),(21362,3822),(21363,3822),(21364,3822),(21365,3822),(21366,3823),(21367,3823),(21368,3823),(21369,3823),(21370,3824),(21371,3824),(21372,3824),(21373,3824),(21374,3825),(21375,3825),(21376,3825),(21377,3825),(21378,3826),(21379,3826),(21380,3826),(21381,3826),(21382,3827),(21383,3827),(21384,3827),(21385,3827),(21386,3828),(21387,3828),(21388,3828),(21389,3828),(21390,3829),(21391,3829),(21392,3829),(21393,3829),(21394,3830),(21395,3830),(21396,3830),(21397,3830),(21398,3831),(21399,3831),(21400,3831),(21401,3831),(21402,3832),(21403,3832),(21404,3832),(21405,3832),(21406,3833),(21407,3833),(21408,3833),(21409,3833),(21410,3834),(21411,3834),(21412,3834),(21413,3834),(21414,3835),(21415,3835),(21416,3835),(21417,3835),(21418,3836),(21419,3836),(21420,3836),(21421,3836),(21422,3837),(21423,3837),(21424,3837),(21425,3837),(21426,3838),(21427,3838),(21428,3838),(21429,3838),(21430,3839),(21431,3839),(21432,3839),(21433,3839),(21434,3840),(21435,3840),(21436,3840),(21437,3840),(21438,3841),(21439,3841),(21440,3841),(21441,3841),(21442,3842),(21443,3842),(21444,3842),(21445,3842),(21446,3843),(21447,3843),(21448,3843),(21449,3843),(21450,3844),(21451,3844),(21452,3844),(21453,3844),(21454,3845),(21455,3845),(21456,3845),(21457,3845),(21458,3846),(21459,3846),(21460,3846),(21461,3846),(21462,3847),(21463,3847),(21464,3847),(21465,3847),(21466,3848),(21467,3848),(21468,3848),(21469,3848),(21470,3849),(21471,3849),(21472,3849),(21473,3849),(21474,3850),(21475,3850),(21476,3850),(21477,3850),(21478,3851),(21479,3851),(21480,3851),(21481,3851),(21482,3852),(21483,3852),(21484,3852),(21485,3852),(21486,3853),(21487,3853),(21488,3853),(21489,3853),(21490,3854),(21491,3854),(21492,3854),(21493,3854),(21494,3855),(21495,3855),(21496,3855),(21497,3855),(21498,3856),(21499,3856),(21500,3856),(21501,3856),(21502,3857),(21503,3857),(21504,3857),(21505,3857),(21506,3858),(21507,3858),(21508,3858),(21509,3858),(21510,3859),(21511,3859),(21512,3859),(21513,3859),(21514,3860),(21515,3860),(21516,3860),(21517,3860),(21518,3861),(21519,3861),(21520,3861),(21521,3861),(21522,3862),(21523,3862),(21524,3862),(21525,3862),(21526,3863),(21527,3863),(21528,3863),(21529,3863),(21530,3864),(21531,3864),(21532,3864),(21533,3864),(21534,3865),(21535,3865),(21536,3865),(21537,3865),(21538,3866),(21539,3866),(21540,3866),(21541,3866),(21542,3867),(21543,3867),(21544,3867),(21545,3867),(21546,3868),(21547,3868),(21548,3868),(21549,3868),(21550,3869),(21551,3869),(21552,3869),(21553,3869),(21554,3870),(21555,3870),(21556,3870),(21557,3870),(21558,3871),(21559,3871),(21560,3871),(21561,3871),(21562,3872),(21563,3872),(21564,3872),(21565,3872),(21566,3873),(21567,3873),(21568,3873),(21569,3873),(21570,3874),(21571,3874),(21572,3874),(21573,3874),(21574,3875),(21575,3875),(21576,3875),(21577,3875),(21578,3876),(21579,3876),(21580,3876),(21581,3876),(21582,3877),(21583,3877),(21584,3877),(21585,3877),(21586,3878),(21587,3878),(21588,3878),(21589,3878),(21590,3879),(21591,3879),(21592,3879),(21593,3879),(21594,3880),(21595,3880),(21596,3880),(21597,3880),(21598,3881),(21599,3881),(21600,3881),(21601,3881),(21602,3882),(21603,3882),(21604,3882),(21605,3882),(21606,3883),(21607,3883),(21608,3883),(21609,3883),(21610,3884),(21611,3884),(21612,3884),(21613,3884),(21614,3885),(21615,3885),(21616,3885),(21617,3885),(21618,3886),(21619,3886),(21620,3886),(21621,3886),(21622,3887),(21623,3887),(21624,3887),(21625,3887),(21626,3888),(21627,3888),(21628,3888),(21629,3888),(21630,3889),(21631,3889),(21632,3889),(21633,3889),(21634,3890),(21635,3890),(21636,3890),(21637,3890),(21638,3891),(21639,3891),(21640,3891),(21641,3891),(21642,3892),(21643,3892),(21644,3892),(21645,3892),(21646,3893),(21647,3893),(21648,3893),(21649,3893),(21650,3894),(21651,3894),(21652,3894),(21653,3894),(21654,3895),(21655,3895),(21656,3895),(21657,3895),(21658,3896),(21659,3896),(21660,3896),(21661,3896),(21662,3897),(21663,3897),(21664,3897),(21665,3897),(21666,3898),(21667,3898),(21668,3898),(21669,3898),(21670,3899),(21671,3899),(21672,3899),(21673,3899),(21674,3900),(21675,3900),(21676,3900),(21677,3900),(21678,3901),(21679,3901),(21680,3901),(21681,3901),(21682,3902),(21683,3902),(21684,3902),(21685,3902),(21686,3903),(21687,3903),(21688,3903),(21689,3903),(21690,3904),(21691,3904),(21692,3904),(21693,3904),(21694,3905),(21695,3905),(21696,3905),(21697,3905),(21698,3906),(21699,3906),(21700,3906),(21701,3906),(21702,3907),(21703,3907),(21704,3907),(21705,3907),(21706,3908),(21707,3908),(21708,3908),(21709,3908),(21710,3909),(21711,3909),(21712,3909),(21713,3909),(21714,3910),(21715,3910),(21716,3910),(21717,3910),(21718,3911),(21719,3911),(21720,3911),(21721,3911),(21722,3912),(21723,3912),(21724,3912),(21725,3912),(21726,3913),(21727,3913),(21728,3913),(21729,3913),(21730,3914),(21731,3914),(21732,3914),(21733,3914),(21734,3915),(21735,3916),(21736,3917),(21737,3918),(21738,3919),(21739,3920),(21740,3921),(21741,3922),(21742,3923),(21743,3924),(21744,3925),(21745,3926),(21746,3927),(21747,3928),(21748,3929),(21749,3930),(21750,3931),(21751,3932),(21752,3933),(21753,3934),(21754,3935),(21755,3936),(21756,3937),(21757,3938),(21758,3939),(21759,3940),(21760,3941),(21761,3942),(21762,3943),(21763,3944),(21764,3945),(21765,3946),(21766,3947),(21767,3948),(21768,3949),(21769,3950),(21770,3951),(21771,3952),(21772,3953),(21773,3954),(21774,3955),(21775,3956),(21776,3957),(21777,3958),(21778,3959),(21779,3960),(21780,3961),(21781,3962),(21782,3963),(21783,3964),(21784,3965),(21785,3966),(21786,3967),(21787,3968),(21788,3969),(21789,3970),(21790,3971),(21791,3972),(21792,3973),(21793,3974),(21794,3975),(21795,3976),(21796,3977),(21797,3978),(21798,3979),(21799,3980),(21800,3981),(21801,3982),(21802,3983),(21803,3984),(21804,3985),(21805,3986),(21806,3987),(21807,3988),(21808,3989),(21809,3990),(21810,3991),(21811,3992),(21812,3993),(21813,3994),(21814,3995),(21815,3996),(21816,3997),(21817,3998),(21818,3999),(21819,4000),(21820,4001),(21821,4002),(21822,4003),(21823,4004),(21824,4005),(21825,4006),(21826,4007),(21827,4008),(21828,4009),(21829,4010),(21830,4011),(21831,4012),(21832,4013),(21833,4014),(21834,3915),(21835,3915),(21836,3915),(21837,3915),(21838,3916),(21839,3916),(21840,3916),(21841,3916),(21842,3917),(21843,3917),(21844,3917),(21845,3917),(21846,3918),(21847,3918),(21848,3918),(21849,3918),(21850,3919),(21851,3919),(21852,3919),(21853,3919),(21854,3920),(21855,3920),(21856,3920),(21857,3920),(21858,3921),(21859,3921),(21860,3921),(21861,3921),(21862,3922),(21863,3922),(21864,3922),(21865,3922),(21866,3923),(21867,3923),(21868,3923),(21869,3923),(21870,3924),(21871,3924),(21872,3924),(21873,3924),(21874,3925),(21875,3925),(21876,3925),(21877,3925),(21878,3926),(21879,3926),(21880,3926),(21881,3926),(21882,3927),(21883,3927),(21884,3927),(21885,3927),(21886,3928),(21887,3928),(21888,3928),(21889,3928),(21890,3929),(21891,3929),(21892,3929),(21893,3929),(21894,3930),(21895,3930),(21896,3930),(21897,3930),(21898,3931),(21899,3931),(21900,3931),(21901,3931),(21902,3932),(21903,3932),(21904,3932),(21905,3932),(21906,3933),(21907,3933),(21908,3933),(21909,3933),(21910,3934),(21911,3934),(21912,3934),(21913,3934),(21914,3935),(21915,3935),(21916,3935),(21917,3935),(21918,3936),(21919,3936),(21920,3936),(21921,3936),(21922,3937),(21923,3937),(21924,3937),(21925,3937),(21926,3938),(21927,3938),(21928,3938),(21929,3938),(21930,3939),(21931,3939),(21932,3939),(21933,3939),(21934,3940),(21935,3940),(21936,3940),(21937,3940),(21938,3941),(21939,3941),(21940,3941),(21941,3941),(21942,3942),(21943,3942),(21944,3942),(21945,3942),(21946,3943),(21947,3943),(21948,3943),(21949,3943),(21950,3944),(21951,3944),(21952,3944),(21953,3944),(21954,3945),(21955,3945),(21956,3945),(21957,3945),(21958,3946),(21959,3946),(21960,3946),(21961,3946),(21962,3947),(21963,3947),(21964,3947),(21965,3947),(21966,3948),(21967,3948),(21968,3948),(21969,3948),(21970,3949),(21971,3949),(21972,3949),(21973,3949),(21974,3950),(21975,3950),(21976,3950),(21977,3950),(21978,3951),(21979,3951),(21980,3951),(21981,3951),(21982,3952),(21983,3952),(21984,3952),(21985,3952),(21986,3953),(21987,3953),(21988,3953),(21989,3953),(21990,3954),(21991,3954),(21992,3954),(21993,3954),(21994,3955),(21995,3955),(21996,3955),(21997,3955),(21998,3956),(21999,3956),(22000,3956),(22001,3956),(22002,3957),(22003,3957),(22004,3957),(22005,3957),(22006,3958),(22007,3958),(22008,3958),(22009,3958),(22010,3959),(22011,3959),(22012,3959),(22013,3959),(22014,3960),(22015,3960),(22016,3960),(22017,3960),(22018,3961),(22019,3961),(22020,3961),(22021,3961),(22022,3962),(22023,3962),(22024,3962),(22025,3962),(22026,3963),(22027,3963),(22028,3963),(22029,3963),(22030,3964),(22031,3964),(22032,3964),(22033,3964),(22034,3965),(22035,3965),(22036,3965),(22037,3965),(22038,3966),(22039,3966),(22040,3966),(22041,3966),(22042,3967),(22043,3967),(22044,3967),(22045,3967),(22046,3968),(22047,3968),(22048,3968),(22049,3968),(22050,3969),(22051,3969),(22052,3969),(22053,3969),(22054,3970),(22055,3970),(22056,3970),(22057,3970),(22058,3971),(22059,3971),(22060,3971),(22061,3971),(22062,3972),(22063,3972),(22064,3972),(22065,3972),(22066,3973),(22067,3973),(22068,3973),(22069,3973),(22070,3974),(22071,3974),(22072,3974),(22073,3974),(22074,3975),(22075,3975),(22076,3975),(22077,3975),(22078,3976),(22079,3976),(22080,3976),(22081,3976),(22082,3977),(22083,3977),(22084,3977),(22085,3977),(22086,3978),(22087,3978),(22088,3978),(22089,3978),(22090,3979),(22091,3979),(22092,3979),(22093,3979),(22094,3980),(22095,3980),(22096,3980),(22097,3980),(22098,3981),(22099,3981),(22100,3981),(22101,3981),(22102,3982),(22103,3982),(22104,3982),(22105,3982),(22106,3983),(22107,3983),(22108,3983),(22109,3983),(22110,3984),(22111,3984),(22112,3984),(22113,3984),(22114,3985),(22115,3985),(22116,3985),(22117,3985),(22118,3986),(22119,3986),(22120,3986),(22121,3986),(22122,3987),(22123,3987),(22124,3987),(22125,3987),(22126,3988),(22127,3988),(22128,3988),(22129,3988),(22130,3989),(22131,3989),(22132,3989),(22133,3989),(22134,3990),(22135,3990),(22136,3990),(22137,3990),(22138,3991),(22139,3991),(22140,3991),(22141,3991),(22142,3992),(22143,3992),(22144,3992),(22145,3992),(22146,3993),(22147,3993),(22148,3993),(22149,3993),(22150,3994),(22151,3994),(22152,3994),(22153,3994),(22154,3995),(22155,3995),(22156,3995),(22157,3995),(22158,3996),(22159,3996),(22160,3996),(22161,3996),(22162,3997),(22163,3997),(22164,3997),(22165,3997),(22166,3998),(22167,3998),(22168,3998),(22169,3998),(22170,3999),(22171,3999),(22172,3999),(22173,3999),(22174,4000),(22175,4000),(22176,4000),(22177,4000),(22178,4001),(22179,4001),(22180,4001),(22181,4001),(22182,4002),(22183,4002),(22184,4002),(22185,4002),(22186,4003),(22187,4003),(22188,4003),(22189,4003),(22190,4004),(22191,4004),(22192,4004),(22193,4004),(22194,4005),(22195,4005),(22196,4005),(22197,4005),(22198,4006),(22199,4006),(22200,4006),(22201,4006),(22202,4007),(22203,4007),(22204,4007),(22205,4007),(22206,4008),(22207,4008),(22208,4008),(22209,4008),(22210,4009),(22211,4009),(22212,4009),(22213,4009),(22214,4010),(22215,4010),(22216,4010),(22217,4010),(22218,4011),(22219,4011),(22220,4011),(22221,4011),(22222,4012),(22223,4012),(22224,4012),(22225,4012),(22226,4013),(22227,4013),(22228,4013),(22229,4013),(22230,4014),(22231,4014),(22232,4014),(22233,4014),(22234,4015),(22235,4016),(22236,4017),(22237,4018),(22238,4019),(22239,4020),(22240,4021),(22241,4022),(22242,4023),(22243,4024),(22244,4025),(22245,4026),(22246,4027),(22247,4028),(22248,4029),(22249,4030),(22250,4031),(22251,4032),(22252,4033),(22253,4034),(22254,4035),(22255,4036),(22256,4037),(22257,4038),(22258,4039),(22259,4040),(22260,4041),(22261,4042),(22262,4043),(22263,4044),(22264,4045),(22265,4046),(22266,4047),(22267,4048),(22268,4049),(22269,4050),(22270,4051),(22271,4052),(22272,4053),(22273,4054),(22274,4055),(22275,4056),(22276,4057),(22277,4058),(22278,4059),(22279,4060),(22280,4061),(22281,4062),(22282,4063),(22283,4064),(22284,4065),(22285,4066),(22286,4067),(22287,4068),(22288,4069),(22289,4070),(22290,4071),(22291,4072),(22292,4073),(22293,4074),(22294,4075),(22295,4076),(22296,4077),(22297,4078),(22298,4079),(22299,4080),(22300,4081),(22301,4082),(22302,4083),(22303,4084),(22304,4085),(22305,4086),(22306,4087),(22307,4088),(22308,4089),(22309,4090),(22310,4091),(22311,4092),(22312,4093),(22313,4094),(22314,4095),(22315,4096),(22316,4097),(22317,4098),(22318,4099),(22319,4100),(22320,4101),(22321,4102),(22322,4103),(22323,4104),(22324,4105),(22325,4106),(22326,4107),(22327,4108),(22328,4109),(22329,4110),(22330,4111),(22331,4112),(22332,4113),(22333,4114),(22334,4015),(22335,4015),(22336,4015),(22337,4015),(22338,4016),(22339,4016),(22340,4016),(22341,4016),(22342,4017),(22343,4017),(22344,4017),(22345,4017),(22346,4018),(22347,4018),(22348,4018),(22349,4018),(22350,4019),(22351,4019),(22352,4019),(22353,4019),(22354,4020),(22355,4020),(22356,4020),(22357,4020),(22358,4021),(22359,4021),(22360,4021),(22361,4021),(22362,4022),(22363,4022),(22364,4022),(22365,4022),(22366,4023),(22367,4023),(22368,4023),(22369,4023),(22370,4024),(22371,4024),(22372,4024),(22373,4024),(22374,4025),(22375,4025),(22376,4025),(22377,4025),(22378,4026),(22379,4026),(22380,4026),(22381,4026),(22382,4027),(22383,4027),(22384,4027),(22385,4027),(22386,4028),(22387,4028),(22388,4028),(22389,4028),(22390,4029),(22391,4029),(22392,4029),(22393,4029),(22394,4030),(22395,4030),(22396,4030),(22397,4030),(22398,4031),(22399,4031),(22400,4031),(22401,4031),(22402,4032),(22403,4032),(22404,4032),(22405,4032),(22406,4033),(22407,4033),(22408,4033),(22409,4033),(22410,4034),(22411,4034),(22412,4034),(22413,4034),(22414,4035),(22415,4035),(22416,4035),(22417,4035),(22418,4036),(22419,4036),(22420,4036),(22421,4036),(22422,4037),(22423,4037),(22424,4037),(22425,4037),(22426,4038),(22427,4038),(22428,4038),(22429,4038),(22430,4039),(22431,4039),(22432,4039),(22433,4039),(22434,4040),(22435,4040),(22436,4040),(22437,4040),(22438,4041),(22439,4041),(22440,4041),(22441,4041),(22442,4042),(22443,4042),(22444,4042),(22445,4042),(22446,4043),(22447,4043),(22448,4043),(22449,4043),(22450,4044),(22451,4044),(22452,4044),(22453,4044),(22454,4045),(22455,4045),(22456,4045),(22457,4045),(22458,4046),(22459,4046),(22460,4046),(22461,4046),(22462,4047),(22463,4047),(22464,4047),(22465,4047),(22466,4048),(22467,4048),(22468,4048),(22469,4048),(22470,4049),(22471,4049),(22472,4049),(22473,4049),(22474,4050),(22475,4050),(22476,4050),(22477,4050),(22478,4051),(22479,4051),(22480,4051),(22481,4051),(22482,4052),(22483,4052),(22484,4052),(22485,4052),(22486,4053),(22487,4053),(22488,4053),(22489,4053),(22490,4054),(22491,4054),(22492,4054),(22493,4054),(22494,4055),(22495,4055),(22496,4055),(22497,4055),(22498,4056),(22499,4056),(22500,4056),(22501,4056),(22502,4057),(22503,4057),(22504,4057),(22505,4057),(22506,4058),(22507,4058),(22508,4058),(22509,4058),(22510,4059),(22511,4059),(22512,4059),(22513,4059),(22514,4060),(22515,4060),(22516,4060),(22517,4060),(22518,4061),(22519,4061),(22520,4061),(22521,4061),(22522,4062),(22523,4062),(22524,4062),(22525,4062),(22526,4063),(22527,4063),(22528,4063),(22529,4063),(22530,4064),(22531,4064),(22532,4064),(22533,4064),(22534,4065),(22535,4065),(22536,4065),(22537,4065),(22538,4066),(22539,4066),(22540,4066),(22541,4066),(22542,4067),(22543,4067),(22544,4067),(22545,4067),(22546,4068),(22547,4068),(22548,4068),(22549,4068),(22550,4069),(22551,4069),(22552,4069),(22553,4069),(22554,4070),(22555,4070),(22556,4070),(22557,4070),(22558,4071),(22559,4071),(22560,4071),(22561,4071),(22562,4072),(22563,4072),(22564,4072),(22565,4072),(22566,4073),(22567,4073),(22568,4073),(22569,4073),(22570,4074),(22571,4074),(22572,4074),(22573,4074),(22574,4075),(22575,4075),(22576,4075),(22577,4075),(22578,4076),(22579,4076),(22580,4076),(22581,4076),(22582,4077),(22583,4077),(22584,4077),(22585,4077),(22586,4078),(22587,4078),(22588,4078),(22589,4078),(22590,4079),(22591,4079),(22592,4079),(22593,4079),(22594,4080),(22595,4080),(22596,4080),(22597,4080),(22598,4081),(22599,4081),(22600,4081),(22601,4081),(22602,4082),(22603,4082),(22604,4082),(22605,4082),(22606,4083),(22607,4083),(22608,4083),(22609,4083),(22610,4084),(22611,4084),(22612,4084),(22613,4084),(22614,4085),(22615,4085),(22616,4085),(22617,4085),(22618,4086),(22619,4086),(22620,4086),(22621,4086),(22622,4087),(22623,4087),(22624,4087),(22625,4087),(22626,4088),(22627,4088),(22628,4088),(22629,4088),(22630,4089),(22631,4089),(22632,4089),(22633,4089),(22634,4090),(22635,4090),(22636,4090),(22637,4090),(22638,4091),(22639,4091),(22640,4091),(22641,4091),(22642,4092),(22643,4092),(22644,4092),(22645,4092),(22646,4093),(22647,4093),(22648,4093),(22649,4093),(22650,4094),(22651,4094),(22652,4094),(22653,4094),(22654,4095),(22655,4095),(22656,4095),(22657,4095),(22658,4096),(22659,4096),(22660,4096),(22661,4096),(22662,4097),(22663,4097),(22664,4097),(22665,4097),(22666,4098),(22667,4098),(22668,4098),(22669,4098),(22670,4099),(22671,4099),(22672,4099),(22673,4099),(22674,4100),(22675,4100),(22676,4100),(22677,4100),(22678,4101),(22679,4101),(22680,4101),(22681,4101),(22682,4102),(22683,4102),(22684,4102),(22685,4102),(22686,4103),(22687,4103),(22688,4103),(22689,4103),(22690,4104),(22691,4104),(22692,4104),(22693,4104),(22694,4105),(22695,4105),(22696,4105),(22697,4105),(22698,4106),(22699,4106),(22700,4106),(22701,4106),(22702,4107),(22703,4107),(22704,4107),(22705,4107),(22706,4108),(22707,4108),(22708,4108),(22709,4108),(22710,4109),(22711,4109),(22712,4109),(22713,4109),(22714,4110),(22715,4110),(22716,4110),(22717,4110),(22718,4111),(22719,4111),(22720,4111),(22721,4111),(22722,4112),(22723,4112),(22724,4112),(22725,4112),(22726,4113),(22727,4113),(22728,4113),(22729,4113),(22730,4114),(22731,4114),(22732,4114),(22733,4114),(22734,4115),(22735,4116),(22736,4117),(22737,4118),(22738,4119),(22739,4120),(22740,4121),(22741,4122),(22742,4123),(22743,4124),(22744,4125),(22745,4126),(22746,4127),(22747,4128),(22748,4129),(22749,4130),(22750,4131),(22751,4132),(22752,4133),(22753,4134),(22754,4135),(22755,4136),(22756,4137),(22757,4138),(22758,4139),(22759,4140),(22760,4141),(22761,4142),(22762,4143),(22763,4144),(22764,4145),(22765,4146),(22766,4147),(22767,4148),(22768,4149),(22769,4150),(22770,4151),(22771,4152),(22772,4153),(22773,4154),(22774,4155),(22775,4156),(22776,4157),(22777,4158),(22778,4159),(22779,4160),(22780,4161),(22781,4162),(22782,4163),(22783,4164),(22784,4165),(22785,4166),(22786,4167),(22787,4168),(22788,4169),(22789,4170),(22790,4171),(22791,4172),(22792,4173),(22793,4174),(22794,4175),(22795,4176),(22796,4177),(22797,4178),(22798,4179),(22799,4180),(22800,4181),(22801,4182),(22802,4183),(22803,4184),(22804,4185),(22805,4186),(22806,4187),(22807,4188),(22808,4189),(22809,4190),(22810,4191),(22811,4192),(22812,4193),(22813,4194),(22814,4195),(22815,4196),(22816,4197),(22817,4198),(22818,4199),(22819,4200),(22820,4201),(22821,4202),(22822,4203),(22823,4204),(22824,4205),(22825,4206),(22826,4207),(22827,4208),(22828,4209),(22829,4210),(22830,4211),(22831,4212),(22832,4213),(22833,4115),(22834,4115),(22835,4115),(22836,4115),(22837,4116),(22838,4116),(22839,4116),(22840,4116),(22841,4117),(22842,4117),(22843,4117),(22844,4117),(22845,4118),(22846,4118),(22847,4118),(22848,4118),(22849,4119),(22850,4119),(22851,4119),(22852,4119),(22853,4120),(22854,4120),(22855,4120),(22856,4120),(22857,4121),(22858,4121),(22859,4121),(22860,4121),(22861,4122),(22862,4122),(22863,4122),(22864,4122),(22865,4123),(22866,4123),(22867,4123),(22868,4123),(22869,4124),(22870,4124),(22871,4124),(22872,4124),(22873,4125),(22874,4125),(22875,4125),(22876,4125),(22877,4126),(22878,4126),(22879,4126),(22880,4126),(22881,4127),(22882,4127),(22883,4127),(22884,4127),(22885,4128),(22886,4128),(22887,4128),(22888,4128),(22889,4129),(22890,4129),(22891,4129),(22892,4129),(22893,4130),(22894,4130),(22895,4130),(22896,4130),(22897,4131),(22898,4131),(22899,4131),(22900,4131),(22901,4132),(22902,4132),(22903,4132),(22904,4132),(22905,4133),(22906,4133),(22907,4133),(22908,4133),(22909,4134),(22910,4134),(22911,4134),(22912,4134),(22913,4135),(22914,4135),(22915,4135),(22916,4135),(22917,4136),(22918,4136),(22919,4136),(22920,4136),(22921,4137),(22922,4137),(22923,4137),(22924,4137),(22925,4138),(22926,4138),(22927,4138),(22928,4138),(22929,4139),(22930,4139),(22931,4139),(22932,4139),(22933,4140),(22934,4140),(22935,4140),(22936,4140),(22937,4141),(22938,4141),(22939,4141),(22940,4141),(22941,4142),(22942,4142),(22943,4142),(22944,4142),(22945,4143),(22946,4143),(22947,4143),(22948,4143),(22949,4144),(22950,4144),(22951,4144),(22952,4144),(22953,4145),(22954,4145),(22955,4145),(22956,4145),(22957,4146),(22958,4146),(22959,4146),(22960,4146),(22961,4147),(22962,4147),(22963,4147),(22964,4147),(22965,4148),(22966,4148),(22967,4148),(22968,4148),(22969,4149),(22970,4149),(22971,4149),(22972,4149),(22973,4150),(22974,4150),(22975,4150),(22976,4150),(22977,4151),(22978,4151),(22979,4151),(22980,4151),(22981,4152),(22982,4152),(22983,4152),(22984,4152),(22985,4153),(22986,4153),(22987,4153),(22988,4153),(22989,4154),(22990,4154),(22991,4154),(22992,4154),(22993,4155),(22994,4155),(22995,4155),(22996,4155),(22997,4156),(22998,4156),(22999,4156),(23000,4156),(23001,4157),(23002,4157),(23003,4157),(23004,4157),(23005,4158),(23006,4158),(23007,4158),(23008,4158),(23009,4159),(23010,4159),(23011,4159),(23012,4159),(23013,4160),(23014,4160),(23015,4160),(23016,4160),(23017,4161),(23018,4161),(23019,4161),(23020,4161),(23021,4162),(23022,4162),(23023,4162),(23024,4162),(23025,4163),(23026,4163),(23027,4163),(23028,4163),(23029,4164),(23030,4164),(23031,4164),(23032,4164),(23033,4165),(23034,4165),(23035,4165),(23036,4165),(23037,4166),(23038,4166),(23039,4166),(23040,4166),(23041,4167),(23042,4167),(23043,4167),(23044,4167),(23045,4168),(23046,4168),(23047,4168),(23048,4168),(23049,4169),(23050,4169),(23051,4169),(23052,4169),(23053,4170),(23054,4170),(23055,4170),(23056,4170),(23057,4171),(23058,4171),(23059,4171),(23060,4171),(23061,4172),(23062,4172),(23063,4172),(23064,4172),(23065,4173),(23066,4173),(23067,4173),(23068,4173),(23069,4174),(23070,4174),(23071,4174),(23072,4174),(23073,4175),(23074,4175),(23075,4175),(23076,4175),(23077,4176),(23078,4176),(23079,4176),(23080,4176),(23081,4177),(23082,4177),(23083,4177),(23084,4177),(23085,4178),(23086,4178),(23087,4178),(23088,4178),(23089,4179),(23090,4179),(23091,4179),(23092,4179),(23093,4180),(23094,4180),(23095,4180),(23096,4180),(23097,4181),(23098,4181),(23099,4181),(23100,4181),(23101,4182),(23102,4182),(23103,4182),(23104,4182),(23105,4183),(23106,4183),(23107,4183),(23108,4183),(23109,4184),(23110,4184),(23111,4184),(23112,4184),(23113,4185),(23114,4185),(23115,4185),(23116,4185),(23117,4186),(23118,4186),(23119,4186),(23120,4186),(23121,4187),(23122,4187),(23123,4187),(23124,4187),(23125,4188),(23126,4188),(23127,4188),(23128,4188),(23129,4189),(23130,4189),(23131,4189),(23132,4189),(23133,4190),(23134,4190),(23135,4190),(23136,4190),(23137,4191),(23138,4191),(23139,4191),(23140,4191),(23141,4192),(23142,4192),(23143,4192),(23144,4192),(23145,4193),(23146,4193),(23147,4193),(23148,4193),(23149,4194),(23150,4194),(23151,4194),(23152,4194),(23153,4195),(23154,4195),(23155,4195),(23156,4195),(23157,4196),(23158,4196),(23159,4196),(23160,4196),(23161,4197),(23162,4197),(23163,4197),(23164,4197),(23165,4198),(23166,4198),(23167,4198),(23168,4198),(23169,4199),(23170,4199),(23171,4199),(23172,4199),(23173,4200),(23174,4200),(23175,4200),(23176,4200),(23177,4201),(23178,4201),(23179,4201),(23180,4201),(23181,4202),(23182,4202),(23183,4202),(23184,4202),(23185,4203),(23186,4203),(23187,4203),(23188,4203),(23189,4204),(23190,4204),(23191,4204),(23192,4204),(23193,4205),(23194,4205),(23195,4205),(23196,4205),(23197,4206),(23198,4206),(23199,4206),(23200,4206),(23201,4207),(23202,4207),(23203,4207),(23204,4207),(23205,4208),(23206,4208),(23207,4208),(23208,4208),(23209,4209),(23210,4209),(23211,4209),(23212,4209),(23213,4210),(23214,4210),(23215,4210),(23216,4210),(23217,4211),(23218,4211),(23219,4211),(23220,4211),(23221,4212),(23222,4212),(23223,4212),(23224,4212),(23225,4213),(23226,4213),(23227,4213),(23228,4213),(23229,4214),(23230,4215),(23231,4216),(23232,4217),(23233,4218),(23234,4219),(23235,4220),(23236,4221),(23237,4222),(23238,4223),(23239,4224),(23240,4225),(23241,4226),(23242,4227),(23243,4228),(23244,4229),(23245,4230),(23246,4231),(23247,4232),(23248,4233),(23249,4234),(23250,4235),(23251,4236),(23252,4237),(23253,4238),(23254,4239),(23255,4240),(23256,4241),(23257,4242),(23258,4243),(23259,4244),(23260,4245),(23261,4246),(23262,4247),(23263,4248),(23264,4249),(23265,4250),(23266,4251),(23267,4252),(23268,4253),(23269,4254),(23270,4255),(23271,4256),(23272,4257),(23273,4258),(23274,4259),(23275,4260),(23276,4261),(23277,4262),(23278,4263),(23279,4264),(23280,4265),(23281,4266),(23282,4267),(23283,4268),(23284,4269),(23285,4270),(23286,4271),(23287,4272),(23288,4273),(23289,4274),(23290,4275),(23291,4276),(23292,4277),(23293,4278),(23294,4279),(23295,4280),(23296,4281),(23297,4282),(23298,4283),(23299,4284),(23300,4285),(23301,4286),(23302,4287),(23303,4288),(23304,4289),(23305,4290),(23306,4291),(23307,4292),(23308,4293),(23309,4294),(23310,4295),(23311,4296),(23312,4297),(23313,4298),(23314,4299),(23315,4300),(23316,4301),(23317,4302),(23318,4303),(23319,4304),(23320,4305),(23321,4306),(23322,4307),(23323,4308),(23324,4309),(23325,4310),(23326,4311),(23327,4312),(23328,4313),(23329,4214),(23330,4214),(23331,4214),(23332,4214),(23333,4215),(23334,4215),(23335,4215),(23336,4215),(23337,4216),(23338,4216),(23339,4216),(23340,4216),(23341,4217),(23342,4217),(23343,4217),(23344,4217),(23345,4218),(23346,4218),(23347,4218),(23348,4218),(23349,4219),(23350,4219),(23351,4219),(23352,4219),(23353,4220),(23354,4220),(23355,4220),(23356,4220),(23357,4221),(23358,4221),(23359,4221),(23360,4221),(23361,4222),(23362,4222),(23363,4222),(23364,4222),(23365,4223),(23366,4223),(23367,4223),(23368,4223),(23369,4224),(23370,4224),(23371,4224),(23372,4224),(23373,4225),(23374,4225),(23375,4225),(23376,4225),(23377,4226),(23378,4226),(23379,4226),(23380,4226),(23381,4227),(23382,4227),(23383,4227),(23384,4227),(23385,4228),(23386,4228),(23387,4228),(23388,4228),(23389,4229),(23390,4229),(23391,4229),(23392,4229),(23393,4230),(23394,4230),(23395,4230),(23396,4230),(23397,4231),(23398,4231),(23399,4231),(23400,4231),(23401,4232),(23402,4232),(23403,4232),(23404,4232),(23405,4233),(23406,4233),(23407,4233),(23408,4233),(23409,4234),(23410,4234),(23411,4234),(23412,4234),(23413,4235),(23414,4235),(23415,4235),(23416,4235),(23417,4236),(23418,4236),(23419,4236),(23420,4236),(23421,4237),(23422,4237),(23423,4237),(23424,4237),(23425,4238),(23426,4238),(23427,4238),(23428,4238),(23429,4239),(23430,4239),(23431,4239),(23432,4239),(23433,4240),(23434,4240),(23435,4240),(23436,4240),(23437,4241),(23438,4241),(23439,4241),(23440,4241),(23441,4242),(23442,4242),(23443,4242),(23444,4242),(23445,4243),(23446,4243),(23447,4243),(23448,4243),(23449,4244),(23450,4244),(23451,4244),(23452,4244),(23453,4245),(23454,4245),(23455,4245),(23456,4245),(23457,4246),(23458,4246),(23459,4246),(23460,4246),(23461,4247),(23462,4247),(23463,4247),(23464,4247),(23465,4248),(23466,4248),(23467,4248),(23468,4248),(23469,4249),(23470,4249),(23471,4249),(23472,4249),(23473,4250),(23474,4250),(23475,4250),(23476,4250),(23477,4251),(23478,4251),(23479,4251),(23480,4251),(23481,4252),(23482,4252),(23483,4252),(23484,4252),(23485,4253),(23486,4253),(23487,4253),(23488,4253),(23489,4254),(23490,4254),(23491,4254),(23492,4254),(23493,4255),(23494,4255),(23495,4255),(23496,4255),(23497,4256),(23498,4256),(23499,4256),(23500,4256),(23501,4257),(23502,4257),(23503,4257),(23504,4257),(23505,4258),(23506,4258),(23507,4258),(23508,4258),(23509,4259),(23510,4259),(23511,4259),(23512,4259),(23513,4260),(23514,4260),(23515,4260),(23516,4260),(23517,4261),(23518,4261),(23519,4261),(23520,4261),(23521,4262),(23522,4262),(23523,4262),(23524,4262),(23525,4263),(23526,4263),(23527,4263),(23528,4263),(23529,4264),(23530,4264),(23531,4264),(23532,4264),(23533,4265),(23534,4265),(23535,4265),(23536,4265),(23537,4266),(23538,4266),(23539,4266),(23540,4266),(23541,4267),(23542,4267),(23543,4267),(23544,4267),(23545,4268),(23546,4268),(23547,4268),(23548,4268),(23549,4269),(23550,4269),(23551,4269),(23552,4269),(23553,4270),(23554,4270),(23555,4270),(23556,4270),(23557,4271),(23558,4271),(23559,4271),(23560,4271),(23561,4272),(23562,4272),(23563,4272),(23564,4272),(23565,4273),(23566,4273),(23567,4273),(23568,4273),(23569,4274),(23570,4274),(23571,4274),(23572,4274),(23573,4275),(23574,4275),(23575,4275),(23576,4275),(23577,4276),(23578,4276),(23579,4276),(23580,4276),(23581,4277),(23582,4277),(23583,4277),(23584,4277),(23585,4278),(23586,4278),(23587,4278),(23588,4278),(23589,4279),(23590,4279),(23591,4279),(23592,4279),(23593,4280),(23594,4280),(23595,4280),(23596,4280),(23597,4281),(23598,4281),(23599,4281),(23600,4281),(23601,4282),(23602,4282),(23603,4282),(23604,4282),(23605,4283),(23606,4283),(23607,4283),(23608,4283),(23609,4284),(23610,4284),(23611,4284),(23612,4284),(23613,4285),(23614,4285),(23615,4285),(23616,4285),(23617,4286),(23618,4286),(23619,4286),(23620,4286),(23621,4287),(23622,4287),(23623,4287),(23624,4287),(23625,4288),(23626,4288),(23627,4288),(23628,4288),(23629,4289),(23630,4289),(23631,4289),(23632,4289),(23633,4290),(23634,4290),(23635,4290),(23636,4290),(23637,4291),(23638,4291),(23639,4291),(23640,4291),(23641,4292),(23642,4292),(23643,4292),(23644,4292),(23645,4293),(23646,4293),(23647,4293),(23648,4293),(23649,4294),(23650,4294),(23651,4294),(23652,4294),(23653,4295),(23654,4295),(23655,4295),(23656,4295),(23657,4296),(23658,4296),(23659,4296),(23660,4296),(23661,4297),(23662,4297),(23663,4297),(23664,4297),(23665,4298),(23666,4298),(23667,4298),(23668,4298),(23669,4299),(23670,4299),(23671,4299),(23672,4299),(23673,4300),(23674,4300),(23675,4300),(23676,4300),(23677,4301),(23678,4301),(23679,4301),(23680,4301),(23681,4302),(23682,4302),(23683,4302),(23684,4302),(23685,4303),(23686,4303),(23687,4303),(23688,4303),(23689,4304),(23690,4304),(23691,4304),(23692,4304),(23693,4305),(23694,4305),(23695,4305),(23696,4305),(23697,4306),(23698,4306),(23699,4306),(23700,4306),(23701,4307),(23702,4307),(23703,4307),(23704,4307),(23705,4308),(23706,4308),(23707,4308),(23708,4308),(23709,4309),(23710,4309),(23711,4309),(23712,4309),(23713,4310),(23714,4310),(23715,4310),(23716,4310),(23717,4311),(23718,4311),(23719,4311),(23720,4311),(23721,4312),(23722,4312),(23723,4312),(23724,4312),(23725,4313),(23726,4313),(23727,4313),(23728,4313),(23729,4314),(23730,4315),(23731,4316),(23732,4317),(23733,4318),(23734,4319),(23735,4320),(23736,4321),(23737,4322),(23738,4323),(23739,4324),(23740,4325),(23741,4326),(23742,4327),(23743,4328),(23744,4329),(23745,4330),(23746,4331),(23747,4332),(23748,4333),(23749,4334),(23750,4335),(23751,4336),(23752,4337),(23753,4338),(23754,4339),(23755,4340),(23756,4341),(23757,4342),(23758,4343),(23759,4344),(23760,4345),(23761,4346),(23762,4347),(23763,4348),(23764,4349),(23765,4350),(23766,4351),(23767,4352),(23768,4353),(23769,4354),(23770,4355),(23771,4356),(23772,4357),(23773,4358),(23774,4359),(23775,4360),(23776,4361),(23777,4362),(23778,4363),(23779,4364),(23780,4365),(23781,4366),(23782,4367),(23783,4368),(23784,4369),(23785,4370),(23786,4371),(23787,4372),(23788,4373),(23789,4374),(23790,4375),(23791,4376),(23792,4377),(23793,4378),(23794,4379),(23795,4380),(23796,4381),(23797,4382),(23798,4383),(23799,4384),(23800,4385),(23801,4386),(23802,4387),(23803,4388),(23804,4389),(23805,4390),(23806,4391),(23807,4392),(23808,4393),(23809,4394),(23810,4395),(23811,4396),(23812,4397),(23813,4398),(23814,4399),(23815,4400),(23816,4401),(23817,4402),(23818,4403),(23819,4404),(23820,4405),(23821,4406),(23822,4407),(23823,4408),(23824,4409),(23825,4410),(23826,4411),(23827,4412),(23828,4413),(23829,4314),(23830,4314),(23831,4314),(23832,4314),(23833,4315),(23834,4315),(23835,4315),(23836,4315),(23837,4316),(23838,4316),(23839,4316),(23840,4316),(23841,4317),(23842,4317),(23843,4317),(23844,4317),(23845,4318),(23846,4318),(23847,4318),(23848,4318),(23849,4319),(23850,4319),(23851,4319),(23852,4319),(23853,4320),(23854,4320),(23855,4320),(23856,4320),(23857,4321),(23858,4321),(23859,4321),(23860,4321),(23861,4322),(23862,4322),(23863,4322),(23864,4322),(23865,4323),(23866,4323),(23867,4323),(23868,4323),(23869,4324),(23870,4324),(23871,4324),(23872,4324),(23873,4325),(23874,4325),(23875,4325),(23876,4325),(23877,4326),(23878,4326),(23879,4326),(23880,4326),(23881,4327),(23882,4327),(23883,4327),(23884,4327),(23885,4328),(23886,4328),(23887,4328),(23888,4328),(23889,4329),(23890,4329),(23891,4329),(23892,4329),(23893,4330),(23894,4330),(23895,4330),(23896,4330),(23897,4331),(23898,4331),(23899,4331),(23900,4331),(23901,4332),(23902,4332),(23903,4332),(23904,4332),(23905,4333),(23906,4333),(23907,4333),(23908,4333),(23909,4334),(23910,4334),(23911,4334),(23912,4334),(23913,4335),(23914,4335),(23915,4335),(23916,4335),(23917,4336),(23918,4336),(23919,4336),(23920,4336),(23921,4337),(23922,4337),(23923,4337),(23924,4337),(23925,4338),(23926,4338),(23927,4338),(23928,4338),(23929,4339),(23930,4339),(23931,4339),(23932,4339),(23933,4340),(23934,4340),(23935,4340),(23936,4340),(23937,4341),(23938,4341),(23939,4341),(23940,4341),(23941,4342),(23942,4342),(23943,4342),(23944,4342),(23945,4343),(23946,4343),(23947,4343),(23948,4343),(23949,4344),(23950,4344),(23951,4344),(23952,4344),(23953,4345),(23954,4345),(23955,4345),(23956,4345),(23957,4346),(23958,4346),(23959,4346),(23960,4346),(23961,4347),(23962,4347),(23963,4347),(23964,4347),(23965,4348),(23966,4348),(23967,4348),(23968,4348),(23969,4349),(23970,4349),(23971,4349),(23972,4349),(23973,4350),(23974,4350),(23975,4350),(23976,4350),(23977,4351),(23978,4351),(23979,4351),(23980,4351),(23981,4352),(23982,4352),(23983,4352),(23984,4352),(23985,4353),(23986,4353),(23987,4353),(23988,4353),(23989,4354),(23990,4354),(23991,4354),(23992,4354),(23993,4355),(23994,4355),(23995,4355),(23996,4355),(23997,4356),(23998,4356),(23999,4356),(24000,4356),(24001,4357),(24002,4357),(24003,4357),(24004,4357),(24005,4358),(24006,4358),(24007,4358),(24008,4358),(24009,4359),(24010,4359),(24011,4359),(24012,4359),(24013,4360),(24014,4360),(24015,4360),(24016,4360),(24017,4361),(24018,4361),(24019,4361),(24020,4361),(24021,4362),(24022,4362),(24023,4362),(24024,4362),(24025,4363),(24026,4363),(24027,4363),(24028,4363),(24029,4364),(24030,4364),(24031,4364),(24032,4364),(24033,4365),(24034,4365),(24035,4365),(24036,4365),(24037,4366),(24038,4366),(24039,4366),(24040,4366),(24041,4367),(24042,4367),(24043,4367),(24044,4367),(24045,4368),(24046,4368),(24047,4368),(24048,4368),(24049,4369),(24050,4369),(24051,4369),(24052,4369),(24053,4370),(24054,4370),(24055,4370),(24056,4370),(24057,4371),(24058,4371),(24059,4371),(24060,4371),(24061,4372),(24062,4372),(24063,4372),(24064,4372),(24065,4373),(24066,4373),(24067,4373),(24068,4373),(24069,4374),(24070,4374),(24071,4374),(24072,4374),(24073,4375),(24074,4375),(24075,4375),(24076,4375),(24077,4376),(24078,4376),(24079,4376),(24080,4376),(24081,4377),(24082,4377),(24083,4377),(24084,4377),(24085,4378),(24086,4378),(24087,4378),(24088,4378),(24089,4379),(24090,4379),(24091,4379),(24092,4379),(24093,4380),(24094,4380),(24095,4380),(24096,4380),(24097,4381),(24098,4381),(24099,4381),(24100,4381),(24101,4382),(24102,4382),(24103,4382),(24104,4382),(24105,4383),(24106,4383),(24107,4383),(24108,4383),(24109,4384),(24110,4384),(24111,4384),(24112,4384),(24113,4385),(24114,4385),(24115,4385),(24116,4385),(24117,4386),(24118,4386),(24119,4386),(24120,4386),(24121,4387),(24122,4387),(24123,4387),(24124,4387),(24125,4388),(24126,4388),(24127,4388),(24128,4388),(24129,4389),(24130,4389),(24131,4389),(24132,4389),(24133,4390),(24134,4390),(24135,4390),(24136,4390),(24137,4391),(24138,4391),(24139,4391),(24140,4391),(24141,4392),(24142,4392),(24143,4392),(24144,4392),(24145,4393),(24146,4393),(24147,4393),(24148,4393),(24149,4394),(24150,4394),(24151,4394),(24152,4394),(24153,4395),(24154,4395),(24155,4395),(24156,4395),(24157,4396),(24158,4396),(24159,4396),(24160,4396),(24161,4397),(24162,4397),(24163,4397),(24164,4397),(24165,4398),(24166,4398),(24167,4398),(24168,4398),(24169,4399),(24170,4399),(24171,4399),(24172,4399),(24173,4400),(24174,4400),(24175,4400),(24176,4400),(24177,4401),(24178,4401),(24179,4401),(24180,4401),(24181,4402),(24182,4402),(24183,4402),(24184,4402),(24185,4403),(24186,4403),(24187,4403),(24188,4403),(24189,4404),(24190,4404),(24191,4404),(24192,4404),(24193,4405),(24194,4405),(24195,4405),(24196,4405),(24197,4406),(24198,4406),(24199,4406),(24200,4406),(24201,4407),(24202,4407),(24203,4407),(24204,4407),(24205,4408),(24206,4408),(24207,4408),(24208,4408),(24209,4409),(24210,4409),(24211,4409),(24212,4409),(24213,4410),(24214,4410),(24215,4410),(24216,4410),(24217,4411),(24218,4411),(24219,4411),(24220,4411),(24221,4412),(24222,4412),(24223,4412),(24224,4412),(24225,4413),(24226,4413),(24227,4413),(24228,4413),(24229,4414),(24230,4415),(24231,4416),(24232,4417),(24233,4418),(24234,4419),(24235,4420),(24236,4421),(24237,4422),(24238,4423),(24239,4424),(24240,4425),(24241,4426),(24242,4427),(24243,4428),(24244,4429),(24245,4430),(24246,4431),(24247,4432),(24248,4433),(24249,4434),(24250,4435),(24251,4436),(24252,4437),(24253,4438),(24254,4439),(24255,4440),(24256,4441),(24257,4442),(24258,4443),(24259,4444),(24260,4445),(24261,4446),(24262,4447),(24263,4448),(24264,4449),(24265,4450),(24266,4451),(24267,4452),(24268,4453),(24269,4454),(24270,4455),(24271,4456),(24272,4457),(24273,4458),(24274,4459),(24275,4460),(24276,4461),(24277,4462),(24278,4463),(24279,4464),(24280,4465),(24281,4466),(24282,4467),(24283,4468),(24284,4469),(24285,4470),(24286,4471),(24287,4472),(24288,4473),(24289,4474),(24290,4475),(24291,4476),(24292,4477),(24293,4478),(24294,4479),(24295,4480),(24296,4481),(24297,4482),(24298,4483),(24299,4484),(24300,4485),(24301,4486),(24302,4487),(24303,4488),(24304,4489),(24305,4490),(24306,4414),(24307,4414),(24308,4414),(24309,4414),(24310,4415),(24311,4415),(24312,4415),(24313,4415),(24314,4416),(24315,4416),(24316,4416),(24317,4416),(24318,4417),(24319,4417),(24320,4417),(24321,4417),(24322,4418),(24323,4418),(24324,4418),(24325,4418),(24326,4419),(24327,4419),(24328,4419),(24329,4419),(24330,4420),(24331,4420),(24332,4420),(24333,4420),(24334,4421),(24335,4421),(24336,4421),(24337,4421),(24338,4422),(24339,4422),(24340,4422),(24341,4422),(24342,4423),(24343,4423),(24344,4423),(24345,4423),(24346,4424),(24347,4424),(24348,4424),(24349,4424),(24350,4425),(24351,4425),(24352,4425),(24353,4425),(24354,4426),(24355,4426),(24356,4426),(24357,4426),(24358,4427),(24359,4427),(24360,4427),(24361,4427),(24362,4428),(24363,4428),(24364,4428),(24365,4428),(24366,4429),(24367,4429),(24368,4429),(24369,4429),(24370,4430),(24371,4430),(24372,4430),(24373,4430),(24374,4431),(24375,4431),(24376,4431),(24377,4431),(24378,4432),(24379,4432),(24380,4432),(24381,4432),(24382,4433),(24383,4433),(24384,4433),(24385,4433),(24386,4434),(24387,4434),(24388,4434),(24389,4434),(24390,4435),(24391,4435),(24392,4435),(24393,4435),(24394,4436),(24395,4436),(24396,4436),(24397,4436),(24398,4437),(24399,4437),(24400,4437),(24401,4437),(24402,4438),(24403,4438),(24404,4438),(24405,4438),(24406,4439),(24407,4439),(24408,4439),(24409,4439),(24410,4440),(24411,4440),(24412,4440),(24413,4440),(24414,4441),(24415,4441),(24416,4441),(24417,4441),(24418,4442),(24419,4442),(24420,4442),(24421,4442),(24422,4443),(24423,4443),(24424,4443),(24425,4443),(24426,4444),(24427,4444),(24428,4444),(24429,4444),(24430,4445),(24431,4445),(24432,4445),(24433,4445),(24434,4446),(24435,4446),(24436,4446),(24437,4446),(24438,4447),(24439,4447),(24440,4447),(24441,4447),(24442,4448),(24443,4448),(24444,4448),(24445,4448),(24446,4449),(24447,4449),(24448,4449),(24449,4449),(24450,4450),(24451,4450),(24452,4450),(24453,4450),(24454,4451),(24455,4451),(24456,4451),(24457,4451),(24458,4452),(24459,4452),(24460,4452),(24461,4452),(24462,4453),(24463,4453),(24464,4453),(24465,4453),(24466,4454),(24467,4454),(24468,4454),(24469,4454),(24470,4455),(24471,4455),(24472,4455),(24473,4455),(24474,4456),(24475,4456),(24476,4456),(24477,4456),(24478,4457),(24479,4457),(24480,4457),(24481,4457),(24482,4458),(24483,4458),(24484,4458),(24485,4458),(24486,4459),(24487,4459),(24488,4459),(24489,4459),(24490,4460),(24491,4460),(24492,4460),(24493,4460),(24494,4461),(24495,4461),(24496,4461),(24497,4461),(24498,4462),(24499,4462),(24500,4462),(24501,4462),(24502,4463),(24503,4463),(24504,4463),(24505,4463),(24506,4464),(24507,4464),(24508,4464),(24509,4464),(24510,4465),(24511,4465),(24512,4465),(24513,4465),(24514,4466),(24515,4466),(24516,4466),(24517,4466),(24518,4467),(24519,4467),(24520,4467),(24521,4467),(24522,4468),(24523,4468),(24524,4468),(24525,4468),(24526,4469),(24527,4469),(24528,4469),(24529,4469),(24530,4470),(24531,4470),(24532,4470),(24533,4470),(24534,4471),(24535,4471),(24536,4471),(24537,4471),(24538,4472),(24539,4472),(24540,4472),(24541,4472),(24542,4473),(24543,4473),(24544,4473),(24545,4473),(24546,4474),(24547,4474),(24548,4474),(24549,4474),(24550,4475),(24551,4475),(24552,4475),(24553,4475),(24554,4476),(24555,4476),(24556,4476),(24557,4476),(24558,4477),(24559,4477),(24560,4477),(24561,4477),(24562,4478),(24563,4478),(24564,4478),(24565,4478),(24566,4479),(24567,4479),(24568,4479),(24569,4479),(24570,4480),(24571,4480),(24572,4480),(24573,4480),(24574,4481),(24575,4481),(24576,4481),(24577,4481),(24578,4482),(24579,4482),(24580,4482),(24581,4482),(24582,4483),(24583,4483),(24584,4483),(24585,4483),(24586,4484),(24587,4484),(24588,4484),(24589,4484),(24590,4485),(24591,4485),(24592,4485),(24593,4485),(24594,4486),(24595,4486),(24596,4486),(24597,4486),(24598,4487),(24599,4487),(24600,4487),(24601,4487),(24602,4488),(24603,4488),(24604,4488),(24605,4488),(24606,4489),(24607,4489),(24608,4489),(24609,4489),(24610,4490),(24611,4490),(24612,4490),(24613,4490),(24614,4491),(24615,4492),(24616,4493),(24617,4494),(24618,4495),(24619,4496),(24620,4497),(24621,4498),(24622,4499),(24623,4500),(24624,4501),(24625,4502),(24626,4503),(24627,4504),(24628,4505),(24629,4506),(24630,4507),(24631,4508),(24632,4509),(24633,4510),(24634,4511),(24635,4512),(24636,4513),(24637,4514),(24638,4515),(24639,4516),(24640,4517),(24641,4518),(24642,4519),(24643,4520),(24644,4521),(24645,4522),(24646,4523),(24647,4524),(24648,4525),(24649,4526),(24650,4527),(24651,4528),(24652,4529),(24653,4530),(24654,4531),(24655,4532),(24656,4533),(24657,4534),(24658,4535),(24659,4536),(24660,4537),(24661,4538),(24662,4539),(24663,4540),(24664,4541),(24665,4542),(24666,4543),(24667,4544),(24668,4545),(24669,4546),(24670,4547),(24671,4548),(24672,4549),(24673,4550),(24674,4551),(24675,4552),(24676,4553),(24677,4554),(24678,4555),(24679,4556),(24680,4557),(24681,4558),(24682,4559),(24683,4560),(24684,4561),(24685,4562),(24686,4563),(24687,4564),(24688,4565),(24689,4566),(24690,4567),(24691,4568),(24692,4569),(24693,4570),(24694,4571),(24695,4572),(24696,4573),(24697,4574),(24698,4575),(24699,4576),(24700,4577),(24701,4578),(24702,4579),(24703,4491),(24704,4491),(24705,4491),(24706,4491),(24707,4492),(24708,4492),(24709,4492),(24710,4492),(24711,4493),(24712,4493),(24713,4493),(24714,4493),(24715,4494),(24716,4494),(24717,4494),(24718,4494),(24719,4495),(24720,4495),(24721,4495),(24722,4495),(24723,4496),(24724,4496),(24725,4496),(24726,4496),(24727,4497),(24728,4497),(24729,4497),(24730,4497),(24731,4498),(24732,4498),(24733,4498),(24734,4498),(24735,4499),(24736,4499),(24737,4499),(24738,4499),(24739,4500),(24740,4500),(24741,4500),(24742,4500),(24743,4501),(24744,4501),(24745,4501),(24746,4501),(24747,4502),(24748,4502),(24749,4502),(24750,4502),(24751,4503),(24752,4503),(24753,4503),(24754,4503),(24755,4504),(24756,4504),(24757,4504),(24758,4504),(24759,4505),(24760,4505),(24761,4505),(24762,4505),(24763,4506),(24764,4506),(24765,4506),(24766,4506),(24767,4507),(24768,4507),(24769,4507),(24770,4507),(24771,4508),(24772,4508),(24773,4508),(24774,4508),(24775,4509),(24776,4509),(24777,4509),(24778,4509),(24779,4510),(24780,4510),(24781,4510),(24782,4510),(24783,4511),(24784,4511),(24785,4511),(24786,4511),(24787,4512),(24788,4512),(24789,4512),(24790,4512),(24791,4513),(24792,4513),(24793,4513),(24794,4513),(24795,4514),(24796,4514),(24797,4514),(24798,4514),(24799,4515),(24800,4515),(24801,4515),(24802,4515),(24803,4516),(24804,4516),(24805,4516),(24806,4516),(24807,4517),(24808,4517),(24809,4517),(24810,4517),(24811,4518),(24812,4518),(24813,4518),(24814,4518),(24815,4519),(24816,4519),(24817,4519),(24818,4519),(24819,4520),(24820,4520),(24821,4520),(24822,4520),(24823,4521),(24824,4521),(24825,4521),(24826,4521),(24827,4522),(24828,4522),(24829,4522),(24830,4522),(24831,4523),(24832,4523),(24833,4523),(24834,4523),(24835,4524),(24836,4524),(24837,4524),(24838,4524),(24839,4525),(24840,4525),(24841,4525),(24842,4525),(24843,4526),(24844,4526),(24845,4526),(24846,4526),(24847,4527),(24848,4527),(24849,4527),(24850,4527),(24851,4528),(24852,4528),(24853,4528),(24854,4528),(24855,4529),(24856,4529),(24857,4529),(24858,4529),(24859,4530),(24860,4530),(24861,4530),(24862,4530),(24863,4531),(24864,4531),(24865,4531),(24866,4531),(24867,4532),(24868,4532),(24869,4532),(24870,4532),(24871,4533),(24872,4533),(24873,4533),(24874,4533),(24875,4534),(24876,4534),(24877,4534),(24878,4534),(24879,4535),(24880,4535),(24881,4535),(24882,4535),(24883,4536),(24884,4536),(24885,4536),(24886,4536),(24887,4537),(24888,4537),(24889,4537),(24890,4537),(24891,4538),(24892,4538),(24893,4538),(24894,4538),(24895,4539),(24896,4539),(24897,4539),(24898,4539),(24899,4540),(24900,4540),(24901,4540),(24902,4540),(24903,4541),(24904,4541),(24905,4541),(24906,4541),(24907,4542),(24908,4542),(24909,4542),(24910,4542),(24911,4543),(24912,4543),(24913,4543),(24914,4543),(24915,4544),(24916,4544),(24917,4544),(24918,4544),(24919,4545),(24920,4545),(24921,4545),(24922,4545),(24923,4546),(24924,4546),(24925,4546),(24926,4546),(24927,4547),(24928,4547),(24929,4547),(24930,4547),(24931,4548),(24932,4548),(24933,4548),(24934,4548),(24935,4549),(24936,4549),(24937,4549),(24938,4549),(24939,4550),(24940,4550),(24941,4550),(24942,4550),(24943,4551),(24944,4551),(24945,4551),(24946,4551),(24947,4552),(24948,4552),(24949,4552),(24950,4552),(24951,4553),(24952,4553),(24953,4553),(24954,4553),(24955,4554),(24956,4554),(24957,4554),(24958,4554),(24959,4555),(24960,4555),(24961,4555),(24962,4555),(24963,4556),(24964,4556),(24965,4556),(24966,4556),(24967,4557),(24968,4557),(24969,4557),(24970,4557),(24971,4558),(24972,4558),(24973,4558),(24974,4558),(24975,4559),(24976,4559),(24977,4559),(24978,4559),(24979,4560),(24980,4560),(24981,4560),(24982,4560),(24983,4561),(24984,4561),(24985,4561),(24986,4561),(24987,4562),(24988,4562),(24989,4562),(24990,4562),(24991,4563),(24992,4563),(24993,4563),(24994,4563),(24995,4564),(24996,4564),(24997,4564),(24998,4564),(24999,4565),(25000,4565),(25001,4565),(25002,4565),(25003,4566),(25004,4566),(25005,4566),(25006,4566),(25007,4567),(25008,4567),(25009,4567),(25010,4567),(25011,4568),(25012,4568),(25013,4568),(25014,4568),(25015,4569),(25016,4569),(25017,4569),(25018,4569),(25019,4570),(25020,4570),(25021,4570),(25022,4570),(25023,4571),(25024,4571),(25025,4571),(25026,4571),(25027,4572),(25028,4572),(25029,4572),(25030,4572),(25031,4573),(25032,4573),(25033,4573),(25034,4573),(25035,4574),(25036,4574),(25037,4574),(25038,4574),(25039,4575),(25040,4575),(25041,4575),(25042,4575),(25043,4576),(25044,4576),(25045,4576),(25046,4576),(25047,4577),(25048,4577),(25049,4577),(25050,4577),(25051,4578),(25052,4578),(25053,4578),(25054,4578),(25055,4579),(25056,4579),(25057,4579),(25058,4579),(25059,4580),(25060,4581),(25061,4582),(25062,4583),(25063,4584),(25064,4585),(25065,4586),(25066,4587),(25067,4588),(25068,4589),(25069,4590),(25070,4591),(25071,4592),(25072,4593),(25073,4594),(25074,4595),(25075,4596),(25076,4597),(25077,4598),(25078,4599),(25079,4600),(25080,4601),(25081,4602),(25082,4603),(25083,4604),(25084,4605),(25085,4606),(25086,4607),(25087,4608),(25088,4609),(25089,4610),(25090,4611),(25091,4612),(25092,4613),(25093,4614),(25094,4615),(25095,4616),(25096,4617),(25097,4618),(25098,4619),(25099,4620),(25100,4621),(25101,4622),(25102,4623),(25103,4624),(25104,4625),(25105,4626),(25106,4627),(25107,4628),(25108,4629),(25109,4630),(25110,4631),(25111,4632),(25112,4633),(25113,4634),(25114,4635),(25115,4636),(25116,4637),(25117,4638),(25118,4639),(25119,4640),(25120,4641),(25121,4642),(25122,4643),(25123,4644),(25124,4645),(25125,4646),(25126,4647),(25127,4648),(25128,4649),(25129,4650),(25130,4651),(25131,4652),(25132,4653),(25133,4654),(25134,4655),(25135,4656),(25136,4657),(25137,4658),(25138,4659),(25139,4660),(25140,4661),(25141,4662),(25142,4663),(25143,4664),(25144,4665),(25145,4666),(25146,4667),(25147,4668),(25148,4669),(25149,4670),(25150,4671),(25151,4672),(25152,4673),(25153,4674),(25154,4675),(25155,4676),(25156,4677),(25157,4678),(25158,4679),(25159,4580),(25160,4580),(25161,4580),(25162,4580),(25163,4581),(25164,4581),(25165,4581),(25166,4581),(25167,4582),(25168,4582),(25169,4582),(25170,4582),(25171,4583),(25172,4583),(25173,4583),(25174,4583),(25175,4584),(25176,4584),(25177,4584),(25178,4584),(25179,4585),(25180,4585),(25181,4585),(25182,4585),(25183,4586),(25184,4586),(25185,4586),(25186,4586),(25187,4587),(25188,4587),(25189,4587),(25190,4587),(25191,4588),(25192,4588),(25193,4588),(25194,4588),(25195,4589),(25196,4589),(25197,4589),(25198,4589),(25199,4590),(25200,4590),(25201,4590),(25202,4590),(25203,4591),(25204,4591),(25205,4591),(25206,4591),(25207,4592),(25208,4592),(25209,4592),(25210,4592),(25211,4593),(25212,4593),(25213,4593),(25214,4593),(25215,4594),(25216,4594),(25217,4594),(25218,4594),(25219,4595),(25220,4595),(25221,4595),(25222,4595),(25223,4596),(25224,4596),(25225,4596),(25226,4596),(25227,4597),(25228,4597),(25229,4597),(25230,4597),(25231,4598),(25232,4598),(25233,4598),(25234,4598),(25235,4599),(25236,4599),(25237,4599),(25238,4599),(25239,4600),(25240,4600),(25241,4600),(25242,4600),(25243,4601),(25244,4601),(25245,4601),(25246,4601),(25247,4602),(25248,4602),(25249,4602),(25250,4602),(25251,4603),(25252,4603),(25253,4603),(25254,4603),(25255,4604),(25256,4604),(25257,4604),(25258,4604),(25259,4605),(25260,4605),(25261,4605),(25262,4605),(25263,4606),(25264,4606),(25265,4606),(25266,4606),(25267,4607),(25268,4607),(25269,4607),(25270,4607),(25271,4608),(25272,4608),(25273,4608),(25274,4608),(25275,4609),(25276,4609),(25277,4609),(25278,4609),(25279,4610),(25280,4610),(25281,4610),(25282,4610),(25283,4611),(25284,4611),(25285,4611),(25286,4611),(25287,4612),(25288,4612),(25289,4612),(25290,4612),(25291,4613),(25292,4613),(25293,4613),(25294,4613),(25295,4614),(25296,4614),(25297,4614),(25298,4614),(25299,4615),(25300,4615),(25301,4615),(25302,4615),(25303,4616),(25304,4616),(25305,4616),(25306,4616),(25307,4617),(25308,4617),(25309,4617),(25310,4617),(25311,4618),(25312,4618),(25313,4618),(25314,4618),(25315,4619),(25316,4619),(25317,4619),(25318,4619),(25319,4620),(25320,4620),(25321,4620),(25322,4620),(25323,4621),(25324,4621),(25325,4621),(25326,4621),(25327,4622),(25328,4622),(25329,4622),(25330,4622),(25331,4623),(25332,4623),(25333,4623),(25334,4623),(25335,4624),(25336,4624),(25337,4624),(25338,4624),(25339,4625),(25340,4625),(25341,4625),(25342,4625),(25343,4626),(25344,4626),(25345,4626),(25346,4626),(25347,4627),(25348,4627),(25349,4627),(25350,4627),(25351,4628),(25352,4628),(25353,4628),(25354,4628),(25355,4629),(25356,4629),(25357,4629),(25358,4629),(25359,4630),(25360,4630),(25361,4630),(25362,4630),(25363,4631),(25364,4631),(25365,4631),(25366,4631),(25367,4632),(25368,4632),(25369,4632),(25370,4632),(25371,4633),(25372,4633),(25373,4633),(25374,4633),(25375,4634),(25376,4634),(25377,4634),(25378,4634),(25379,4635),(25380,4635),(25381,4635),(25382,4635),(25383,4636),(25384,4636),(25385,4636),(25386,4636),(25387,4637),(25388,4637),(25389,4637),(25390,4637),(25391,4638),(25392,4638),(25393,4638),(25394,4638),(25395,4639),(25396,4639),(25397,4639),(25398,4639),(25399,4640),(25400,4640),(25401,4640),(25402,4640),(25403,4641),(25404,4641),(25405,4641),(25406,4641),(25407,4642),(25408,4642),(25409,4642),(25410,4642),(25411,4643),(25412,4643),(25413,4643),(25414,4643),(25415,4644),(25416,4644),(25417,4644),(25418,4644),(25419,4645),(25420,4645),(25421,4645),(25422,4645),(25423,4646),(25424,4646),(25425,4646),(25426,4646),(25427,4647),(25428,4647),(25429,4647),(25430,4647),(25431,4648),(25432,4648),(25433,4648),(25434,4648),(25435,4649),(25436,4649),(25437,4649),(25438,4649),(25439,4650),(25440,4650),(25441,4650),(25442,4650),(25443,4651),(25444,4651),(25445,4651),(25446,4651),(25447,4652),(25448,4652),(25449,4652),(25450,4652),(25451,4653),(25452,4653),(25453,4653),(25454,4653),(25455,4654),(25456,4654),(25457,4654),(25458,4654),(25459,4655),(25460,4655),(25461,4655),(25462,4655),(25463,4656),(25464,4656),(25465,4656),(25466,4656),(25467,4657),(25468,4657),(25469,4657),(25470,4657),(25471,4658),(25472,4658),(25473,4658),(25474,4658),(25475,4659),(25476,4659),(25477,4659),(25478,4659),(25479,4660),(25480,4660),(25481,4660),(25482,4660),(25483,4661),(25484,4661),(25485,4661),(25486,4661),(25487,4662),(25488,4662),(25489,4662),(25490,4662),(25491,4663),(25492,4663),(25493,4663),(25494,4663),(25495,4664),(25496,4664),(25497,4664),(25498,4664),(25499,4665),(25500,4665),(25501,4665),(25502,4665),(25503,4666),(25504,4666),(25505,4666),(25506,4666),(25507,4667),(25508,4667),(25509,4667),(25510,4667),(25511,4668),(25512,4668),(25513,4668),(25514,4668),(25515,4669),(25516,4669),(25517,4669),(25518,4669),(25519,4670),(25520,4670),(25521,4670),(25522,4670),(25523,4671),(25524,4671),(25525,4671),(25526,4671),(25527,4672),(25528,4672),(25529,4672),(25530,4672),(25531,4673),(25532,4673),(25533,4673),(25534,4673),(25535,4674),(25536,4674),(25537,4674),(25538,4674),(25539,4675),(25540,4675),(25541,4675),(25542,4675),(25543,4676),(25544,4676),(25545,4676),(25546,4676),(25547,4677),(25548,4677),(25549,4677),(25550,4677),(25551,4678),(25552,4678),(25553,4678),(25554,4678),(25555,4679),(25556,4679),(25557,4679),(25558,4679),(25559,4680),(25560,4681),(25561,4682),(25562,4683),(25563,4684),(25564,4685),(25565,4686),(25566,4687),(25567,4688),(25568,4689),(25569,4690),(25570,4691),(25571,4692),(25572,4693),(25573,4694),(25574,4695),(25575,4696),(25576,4697),(25577,4698),(25578,4699),(25579,4700),(25580,4701),(25581,4702),(25582,4703),(25583,4704),(25584,4705),(25585,4706),(25586,4707),(25587,4708),(25588,4709),(25589,4710),(25590,4711),(25591,4712),(25592,4713),(25593,4714),(25594,4715),(25595,4716),(25596,4717),(25597,4718),(25598,4719),(25599,4720),(25600,4721),(25601,4722),(25602,4723),(25603,4724),(25604,4725),(25605,4726),(25606,4727),(25607,4728),(25608,4729),(25609,4730),(25610,4731),(25611,4732),(25612,4733),(25613,4734),(25614,4735),(25615,4736),(25616,4737),(25617,4738),(25618,4739),(25619,4740),(25620,4741),(25621,4742),(25622,4743),(25623,4744),(25624,4745),(25625,4746),(25626,4747),(25627,4748),(25628,4749),(25629,4750),(25630,4751),(25631,4752),(25632,4753),(25633,4754),(25634,4755),(25635,4756),(25636,4757),(25637,4758),(25638,4759),(25639,4760),(25640,4761),(25641,4762),(25642,4763),(25643,4764),(25644,4765),(25645,4766),(25646,4767),(25647,4768),(25648,4769),(25649,4770),(25650,4771),(25651,4772),(25652,4773),(25653,4774),(25654,4775),(25655,4776),(25656,4777),(25657,4778),(25658,4779),(25659,4680),(25660,4680),(25661,4680),(25662,4680),(25663,4681),(25664,4681),(25665,4681),(25666,4681),(25667,4682),(25668,4682),(25669,4682),(25670,4682),(25671,4683),(25672,4683),(25673,4683),(25674,4683),(25675,4684),(25676,4684),(25677,4684),(25678,4684),(25679,4685),(25680,4685),(25681,4685),(25682,4685),(25683,4686),(25684,4686),(25685,4686),(25686,4686),(25687,4687),(25688,4687),(25689,4687),(25690,4687),(25691,4688),(25692,4688),(25693,4688),(25694,4688),(25695,4689),(25696,4689),(25697,4689),(25698,4689),(25699,4690),(25700,4690),(25701,4690),(25702,4690),(25703,4691),(25704,4691),(25705,4691),(25706,4691),(25707,4692),(25708,4692),(25709,4692),(25710,4692),(25711,4693),(25712,4693),(25713,4693),(25714,4693),(25715,4694),(25716,4694),(25717,4694),(25718,4694),(25719,4695),(25720,4695),(25721,4695),(25722,4695),(25723,4696),(25724,4696),(25725,4696),(25726,4696),(25727,4697),(25728,4697),(25729,4697),(25730,4697),(25731,4698),(25732,4698),(25733,4698),(25734,4698),(25735,4699),(25736,4699),(25737,4699),(25738,4699),(25739,4700),(25740,4700),(25741,4700),(25742,4700),(25743,4701),(25744,4701),(25745,4701),(25746,4701),(25747,4702),(25748,4702),(25749,4702),(25750,4702),(25751,4703),(25752,4703),(25753,4703),(25754,4703),(25755,4704),(25756,4704),(25757,4704),(25758,4704),(25759,4705),(25760,4705),(25761,4705),(25762,4705),(25763,4706),(25764,4706),(25765,4706),(25766,4706),(25767,4707),(25768,4707),(25769,4707),(25770,4707),(25771,4708),(25772,4708),(25773,4708),(25774,4708),(25775,4709),(25776,4709),(25777,4709),(25778,4709),(25779,4710),(25780,4710),(25781,4710),(25782,4710),(25783,4711),(25784,4711),(25785,4711),(25786,4711),(25787,4712),(25788,4712),(25789,4712),(25790,4712),(25791,4713),(25792,4713),(25793,4713),(25794,4713),(25795,4714),(25796,4714),(25797,4714),(25798,4714),(25799,4715),(25800,4715),(25801,4715),(25802,4715),(25803,4716),(25804,4716),(25805,4716),(25806,4716),(25807,4717),(25808,4717),(25809,4717),(25810,4717),(25811,4718),(25812,4718),(25813,4718),(25814,4718),(25815,4719),(25816,4719),(25817,4719),(25818,4719),(25819,4720),(25820,4720),(25821,4720),(25822,4720),(25823,4721),(25824,4721),(25825,4721),(25826,4721),(25827,4722),(25828,4722),(25829,4722),(25830,4722),(25831,4723),(25832,4723),(25833,4723),(25834,4723),(25835,4724),(25836,4724),(25837,4724),(25838,4724),(25839,4725),(25840,4725),(25841,4725),(25842,4725),(25843,4726),(25844,4726),(25845,4726),(25846,4726),(25847,4727),(25848,4727),(25849,4727),(25850,4727),(25851,4728),(25852,4728),(25853,4728),(25854,4728),(25855,4729),(25856,4729),(25857,4729),(25858,4729),(25859,4730),(25860,4730),(25861,4730),(25862,4730),(25863,4731),(25864,4731),(25865,4731),(25866,4731),(25867,4732),(25868,4732),(25869,4732),(25870,4732),(25871,4733),(25872,4733),(25873,4733),(25874,4733),(25875,4734),(25876,4734),(25877,4734),(25878,4734),(25879,4735),(25880,4735),(25881,4735),(25882,4735),(25883,4736),(25884,4736),(25885,4736),(25886,4736),(25887,4737),(25888,4737),(25889,4737),(25890,4737),(25891,4738),(25892,4738),(25893,4738),(25894,4738),(25895,4739),(25896,4739),(25897,4739),(25898,4739),(25899,4740),(25900,4740),(25901,4740),(25902,4740),(25903,4741),(25904,4741),(25905,4741),(25906,4741),(25907,4742),(25908,4742),(25909,4742),(25910,4742),(25911,4743),(25912,4743),(25913,4743),(25914,4743),(25915,4744),(25916,4744),(25917,4744),(25918,4744),(25919,4745),(25920,4745),(25921,4745),(25922,4745),(25923,4746),(25924,4746),(25925,4746),(25926,4746),(25927,4747),(25928,4747),(25929,4747),(25930,4747),(25931,4748),(25932,4748),(25933,4748),(25934,4748),(25935,4749),(25936,4749),(25937,4749),(25938,4749),(25939,4750),(25940,4750),(25941,4750),(25942,4750),(25943,4751),(25944,4751),(25945,4751),(25946,4751),(25947,4752),(25948,4752),(25949,4752),(25950,4752),(25951,4753),(25952,4753),(25953,4753),(25954,4753),(25955,4754),(25956,4754),(25957,4754),(25958,4754),(25959,4755),(25960,4755),(25961,4755),(25962,4755),(25963,4756),(25964,4756),(25965,4756),(25966,4756),(25967,4757),(25968,4757),(25969,4757),(25970,4757),(25971,4758),(25972,4758),(25973,4758),(25974,4758),(25975,4759),(25976,4759),(25977,4759),(25978,4759),(25979,4760),(25980,4760),(25981,4760),(25982,4760),(25983,4761),(25984,4761),(25985,4761),(25986,4761),(25987,4762),(25988,4762),(25989,4762),(25990,4762),(25991,4763),(25992,4763),(25993,4763),(25994,4763),(25995,4764),(25996,4764),(25997,4764),(25998,4764),(25999,4765),(26000,4765),(26001,4765),(26002,4765),(26003,4766),(26004,4766),(26005,4766),(26006,4766),(26007,4767),(26008,4767),(26009,4767),(26010,4767),(26011,4768),(26012,4768),(26013,4768),(26014,4768),(26015,4769),(26016,4769),(26017,4769),(26018,4769),(26019,4770),(26020,4770),(26021,4770),(26022,4770),(26023,4771),(26024,4771),(26025,4771),(26026,4771),(26027,4772),(26028,4772),(26029,4772),(26030,4772),(26031,4773),(26032,4773),(26033,4773),(26034,4773),(26035,4774),(26036,4774),(26037,4774),(26038,4774),(26039,4775),(26040,4775),(26041,4775),(26042,4775),(26043,4776),(26044,4776),(26045,4776),(26046,4776),(26047,4777),(26048,4777),(26049,4777),(26050,4777),(26051,4778),(26052,4778),(26053,4778),(26054,4778),(26055,4779),(26056,4779),(26057,4779),(26058,4779),(26059,4780),(26060,4781),(26061,4782),(26062,4783),(26063,4784),(26064,4785),(26065,4786),(26066,4787),(26067,4788),(26068,4789),(26069,4790),(26070,4791),(26071,4792),(26072,4793),(26073,4794),(26074,4795),(26075,4796),(26076,4797),(26077,4798),(26078,4799),(26079,4800),(26080,4801),(26081,4802),(26082,4803),(26083,4804),(26084,4805),(26085,4806),(26086,4807),(26087,4808),(26088,4809),(26089,4810),(26090,4811),(26091,4812),(26092,4813),(26093,4814),(26094,4815),(26095,4816),(26096,4817),(26097,4818),(26098,4819),(26099,4820),(26100,4821),(26101,4822),(26102,4823),(26103,4824),(26104,4825),(26105,4826),(26106,4827),(26107,4828),(26108,4829),(26109,4830),(26110,4831),(26111,4832),(26112,4833),(26113,4834),(26114,4835),(26115,4836),(26116,4837),(26117,4838),(26118,4839),(26119,4840),(26120,4841),(26121,4842),(26122,4843),(26123,4844),(26124,4845),(26125,4846),(26126,4847),(26127,4848),(26128,4849),(26129,4850),(26130,4851),(26131,4852),(26132,4853),(26133,4854),(26134,4855),(26135,4856),(26136,4857),(26137,4858),(26138,4859),(26139,4860),(26140,4861),(26141,4862),(26142,4863),(26143,4864),(26144,4865),(26145,4866),(26146,4867),(26147,4868),(26148,4869),(26149,4870),(26150,4871),(26151,4872),(26152,4873),(26153,4874),(26154,4875),(26155,4876),(26156,4877),(26157,4878),(26158,4879),(26159,4780),(26160,4780),(26161,4780),(26162,4780),(26163,4781),(26164,4781),(26165,4781),(26166,4781),(26167,4782),(26168,4782),(26169,4782),(26170,4782),(26171,4783),(26172,4783),(26173,4783),(26174,4783),(26175,4784),(26176,4784),(26177,4784),(26178,4784),(26179,4785),(26180,4785),(26181,4785),(26182,4785),(26183,4786),(26184,4786),(26185,4786),(26186,4786),(26187,4787),(26188,4787),(26189,4787),(26190,4787),(26191,4788),(26192,4788),(26193,4788),(26194,4788),(26195,4789),(26196,4789),(26197,4789),(26198,4789),(26199,4790),(26200,4790),(26201,4790),(26202,4790),(26203,4791),(26204,4791),(26205,4791),(26206,4791),(26207,4792),(26208,4792),(26209,4792),(26210,4792),(26211,4793),(26212,4793),(26213,4793),(26214,4793),(26215,4794),(26216,4794),(26217,4794),(26218,4794),(26219,4795),(26220,4795),(26221,4795),(26222,4795),(26223,4796),(26224,4796),(26225,4796),(26226,4796),(26227,4797),(26228,4797),(26229,4797),(26230,4797),(26231,4798),(26232,4798),(26233,4798),(26234,4798),(26235,4799),(26236,4799),(26237,4799),(26238,4799),(26239,4800),(26240,4800),(26241,4800),(26242,4800),(26243,4801),(26244,4801),(26245,4801),(26246,4801),(26247,4802),(26248,4802),(26249,4802),(26250,4802),(26251,4803),(26252,4803),(26253,4803),(26254,4803),(26255,4804),(26256,4804),(26257,4804),(26258,4804),(26259,4805),(26260,4805),(26261,4805),(26262,4805),(26263,4806),(26264,4806),(26265,4806),(26266,4806),(26267,4807),(26268,4807),(26269,4807),(26270,4807),(26271,4808),(26272,4808),(26273,4808),(26274,4808),(26275,4809),(26276,4809),(26277,4809),(26278,4809),(26279,4810),(26280,4810),(26281,4810),(26282,4810),(26283,4811),(26284,4811),(26285,4811),(26286,4811),(26287,4812),(26288,4812),(26289,4812),(26290,4812),(26291,4813),(26292,4813),(26293,4813),(26294,4813),(26295,4814),(26296,4814),(26297,4814),(26298,4814),(26299,4815),(26300,4815),(26301,4815),(26302,4815),(26303,4816),(26304,4816),(26305,4816),(26306,4816),(26307,4817),(26308,4817),(26309,4817),(26310,4817),(26311,4818),(26312,4818),(26313,4818),(26314,4818),(26315,4819),(26316,4819),(26317,4819),(26318,4819),(26319,4820),(26320,4820),(26321,4820),(26322,4820),(26323,4821),(26324,4821),(26325,4821),(26326,4821),(26327,4822),(26328,4822),(26329,4822),(26330,4822),(26331,4823),(26332,4823),(26333,4823),(26334,4823),(26335,4824),(26336,4824),(26337,4824),(26338,4824),(26339,4825),(26340,4825),(26341,4825),(26342,4825),(26343,4826),(26344,4826),(26345,4826),(26346,4826),(26347,4827),(26348,4827),(26349,4827),(26350,4827),(26351,4828),(26352,4828),(26353,4828),(26354,4828),(26355,4829),(26356,4829),(26357,4829),(26358,4829),(26359,4830),(26360,4830),(26361,4830),(26362,4830),(26363,4831),(26364,4831),(26365,4831),(26366,4831),(26367,4832),(26368,4832),(26369,4832),(26370,4832),(26371,4833),(26372,4833),(26373,4833),(26374,4833),(26375,4834),(26376,4834),(26377,4834),(26378,4834),(26379,4835),(26380,4835),(26381,4835),(26382,4835),(26383,4836),(26384,4836),(26385,4836),(26386,4836),(26387,4837),(26388,4837),(26389,4837),(26390,4837),(26391,4838),(26392,4838),(26393,4838),(26394,4838),(26395,4839),(26396,4839),(26397,4839),(26398,4839),(26399,4840),(26400,4840),(26401,4840),(26402,4840),(26403,4841),(26404,4841),(26405,4841),(26406,4841),(26407,4842),(26408,4842),(26409,4842),(26410,4842),(26411,4843),(26412,4843),(26413,4843),(26414,4843),(26415,4844),(26416,4844),(26417,4844),(26418,4844),(26419,4845),(26420,4845),(26421,4845),(26422,4845),(26423,4846),(26424,4846),(26425,4846),(26426,4846),(26427,4847),(26428,4847),(26429,4847),(26430,4847),(26431,4848),(26432,4848),(26433,4848),(26434,4848),(26435,4849),(26436,4849),(26437,4849),(26438,4849),(26439,4850),(26440,4850),(26441,4850),(26442,4850),(26443,4851),(26444,4851),(26445,4851),(26446,4851),(26447,4852),(26448,4852),(26449,4852),(26450,4852),(26451,4853),(26452,4853),(26453,4853),(26454,4853),(26455,4854),(26456,4854),(26457,4854),(26458,4854),(26459,4855),(26460,4855),(26461,4855),(26462,4855),(26463,4856),(26464,4856),(26465,4856),(26466,4856),(26467,4857),(26468,4857),(26469,4857),(26470,4857),(26471,4858),(26472,4858),(26473,4858),(26474,4858),(26475,4859),(26476,4859),(26477,4859),(26478,4859),(26479,4860),(26480,4860),(26481,4860),(26482,4860),(26483,4861),(26484,4861),(26485,4861),(26486,4861),(26487,4862),(26488,4862),(26489,4862),(26490,4862),(26491,4863),(26492,4863),(26493,4863),(26494,4863),(26495,4864),(26496,4864),(26497,4864),(26498,4864),(26499,4865),(26500,4865),(26501,4865),(26502,4865),(26503,4866),(26504,4866),(26505,4866),(26506,4866),(26507,4867),(26508,4867),(26509,4867),(26510,4867),(26511,4868),(26512,4868),(26513,4868),(26514,4868),(26515,4869),(26516,4869),(26517,4869),(26518,4869),(26519,4870),(26520,4870),(26521,4870),(26522,4870),(26523,4871),(26524,4871),(26525,4871),(26526,4871),(26527,4872),(26528,4872),(26529,4872),(26530,4872),(26531,4873),(26532,4873),(26533,4873),(26534,4873),(26535,4874),(26536,4874),(26537,4874),(26538,4874),(26539,4875),(26540,4875),(26541,4875),(26542,4875),(26543,4876),(26544,4876),(26545,4876),(26546,4876),(26547,4877),(26548,4877),(26549,4877),(26550,4877),(26551,4878),(26552,4878),(26553,4878),(26554,4878),(26555,4879),(26556,4879),(26557,4879),(26558,4879),(26559,4880),(26560,4881),(26561,4882),(26562,4883),(26563,4884),(26564,4885),(26565,4886),(26566,4887),(26567,4888),(26568,4889),(26569,4890),(26570,4891),(26571,4892),(26572,4893),(26573,4894),(26574,4895),(26575,4896),(26576,4897),(26577,4898),(26578,4899),(26579,4900),(26580,4901),(26581,4902),(26582,4903),(26583,4904),(26584,4905),(26585,4906),(26586,4907),(26587,4908),(26588,4909),(26589,4910),(26590,4911),(26591,4912),(26592,4913),(26593,4914),(26594,4915),(26595,4916),(26596,4917),(26597,4918),(26598,4919),(26599,4920),(26600,4921),(26601,4922),(26602,4923),(26603,4924),(26604,4925),(26605,4926),(26606,4927),(26607,4928),(26608,4929),(26609,4930),(26610,4931),(26611,4932),(26612,4933),(26613,4934),(26614,4935),(26615,4936),(26616,4937),(26617,4938),(26618,4939),(26619,4940),(26620,4941),(26621,4942),(26622,4943),(26623,4944),(26624,4945),(26625,4946),(26626,4947),(26627,4948),(26628,4949),(26629,4950),(26630,4951),(26631,4952),(26632,4953),(26633,4954),(26634,4955),(26635,4956),(26636,4957),(26637,4958),(26638,4959),(26639,4960),(26640,4961),(26641,4962),(26642,4963),(26643,4964),(26644,4965),(26645,4966),(26646,4967),(26647,4968),(26648,4969),(26649,4970),(26650,4971),(26651,4972),(26652,4973),(26653,4974),(26654,4975),(26655,4976),(26656,4977),(26657,4978),(26658,4979),(26659,4880),(26660,4880),(26661,4880),(26662,4880),(26663,4881),(26664,4881),(26665,4881),(26666,4881),(26667,4882),(26668,4882),(26669,4882),(26670,4882),(26671,4883),(26672,4883),(26673,4883),(26674,4883),(26675,4884),(26676,4884),(26677,4884),(26678,4884),(26679,4885),(26680,4885),(26681,4885),(26682,4885),(26683,4886),(26684,4886),(26685,4886),(26686,4886),(26687,4887),(26688,4887),(26689,4887),(26690,4887),(26691,4888),(26692,4888),(26693,4888),(26694,4888),(26695,4889),(26696,4889),(26697,4889),(26698,4889),(26699,4890),(26700,4890),(26701,4890),(26702,4890),(26703,4891),(26704,4891),(26705,4891),(26706,4891),(26707,4892),(26708,4892),(26709,4892),(26710,4892),(26711,4893),(26712,4893),(26713,4893),(26714,4893),(26715,4894),(26716,4894),(26717,4894),(26718,4894),(26719,4895),(26720,4895),(26721,4895),(26722,4895),(26723,4896),(26724,4896),(26725,4896),(26726,4896),(26727,4897),(26728,4897),(26729,4897),(26730,4897),(26731,4898),(26732,4898),(26733,4898),(26734,4898),(26735,4899),(26736,4899),(26737,4899),(26738,4899),(26739,4900),(26740,4900),(26741,4900),(26742,4900),(26743,4901),(26744,4901),(26745,4901),(26746,4901),(26747,4902),(26748,4902),(26749,4902),(26750,4902),(26751,4903),(26752,4903),(26753,4903),(26754,4903),(26755,4904),(26756,4904),(26757,4904),(26758,4904),(26759,4905),(26760,4905),(26761,4905),(26762,4905),(26763,4906),(26764,4906),(26765,4906),(26766,4906),(26767,4907),(26768,4907),(26769,4907),(26770,4907),(26771,4908),(26772,4908),(26773,4908),(26774,4908),(26775,4909),(26776,4909),(26777,4909),(26778,4909),(26779,4910),(26780,4910),(26781,4910),(26782,4910),(26783,4911),(26784,4911),(26785,4911),(26786,4911),(26787,4912),(26788,4912),(26789,4912),(26790,4912),(26791,4913),(26792,4913),(26793,4913),(26794,4913),(26795,4914),(26796,4914),(26797,4914),(26798,4914),(26799,4915),(26800,4915),(26801,4915),(26802,4915),(26803,4916),(26804,4916),(26805,4916),(26806,4916),(26807,4917),(26808,4917),(26809,4917),(26810,4917),(26811,4918),(26812,4918),(26813,4918),(26814,4918),(26815,4919),(26816,4919),(26817,4919),(26818,4919),(26819,4920),(26820,4920),(26821,4920),(26822,4920),(26823,4921),(26824,4921),(26825,4921),(26826,4921),(26827,4922),(26828,4922),(26829,4922),(26830,4922),(26831,4923),(26832,4923),(26833,4923),(26834,4923),(26835,4924),(26836,4924),(26837,4924),(26838,4924),(26839,4925),(26840,4925),(26841,4925),(26842,4925),(26843,4926),(26844,4926),(26845,4926),(26846,4926),(26847,4927),(26848,4927),(26849,4927),(26850,4927),(26851,4928),(26852,4928),(26853,4928),(26854,4928),(26855,4929),(26856,4929),(26857,4929),(26858,4929),(26859,4930),(26860,4930),(26861,4930),(26862,4930),(26863,4931),(26864,4931),(26865,4931),(26866,4931),(26867,4932),(26868,4932),(26869,4932),(26870,4932),(26871,4933),(26872,4933),(26873,4933),(26874,4933),(26875,4934),(26876,4934),(26877,4934),(26878,4934),(26879,4935),(26880,4935),(26881,4935),(26882,4935),(26883,4936),(26884,4936),(26885,4936),(26886,4936),(26887,4937),(26888,4937),(26889,4937),(26890,4937),(26891,4938),(26892,4938),(26893,4938),(26894,4938),(26895,4939),(26896,4939),(26897,4939),(26898,4939),(26899,4940),(26900,4940),(26901,4940),(26902,4940),(26903,4941),(26904,4941),(26905,4941),(26906,4941),(26907,4942),(26908,4942),(26909,4942),(26910,4942),(26911,4943),(26912,4943),(26913,4943),(26914,4943),(26915,4944),(26916,4944),(26917,4944),(26918,4944),(26919,4945),(26920,4945),(26921,4945),(26922,4945),(26923,4946),(26924,4946),(26925,4946),(26926,4946),(26927,4947),(26928,4947),(26929,4947),(26930,4947),(26931,4948),(26932,4948),(26933,4948),(26934,4948),(26935,4949),(26936,4949),(26937,4949),(26938,4949),(26939,4950),(26940,4950),(26941,4950),(26942,4950),(26943,4951),(26944,4951),(26945,4951),(26946,4951),(26947,4952),(26948,4952),(26949,4952),(26950,4952),(26951,4953),(26952,4953),(26953,4953),(26954,4953),(26955,4954),(26956,4954),(26957,4954),(26958,4954),(26959,4955),(26960,4955),(26961,4955),(26962,4955),(26963,4956),(26964,4956),(26965,4956),(26966,4956),(26967,4957),(26968,4957),(26969,4957),(26970,4957),(26971,4958),(26972,4958),(26973,4958),(26974,4958),(26975,4959),(26976,4959),(26977,4959),(26978,4959),(26979,4960),(26980,4960),(26981,4960),(26982,4960),(26983,4961),(26984,4961),(26985,4961),(26986,4961),(26987,4962),(26988,4962),(26989,4962),(26990,4962),(26991,4963),(26992,4963),(26993,4963),(26994,4963),(26995,4964),(26996,4964),(26997,4964),(26998,4964),(26999,4965),(27000,4965),(27001,4965),(27002,4965),(27003,4966),(27004,4966),(27005,4966),(27006,4966),(27007,4967),(27008,4967),(27009,4967),(27010,4967),(27011,4968),(27012,4968),(27013,4968),(27014,4968),(27015,4969),(27016,4969),(27017,4969),(27018,4969),(27019,4970),(27020,4970),(27021,4970),(27022,4970),(27023,4971),(27024,4971),(27025,4971),(27026,4971),(27027,4972),(27028,4972),(27029,4972),(27030,4972),(27031,4973),(27032,4973),(27033,4973),(27034,4973),(27035,4974),(27036,4974),(27037,4974),(27038,4974),(27039,4975),(27040,4975),(27041,4975),(27042,4975),(27043,4976),(27044,4976),(27045,4976),(27046,4976),(27047,4977),(27048,4977),(27049,4977),(27050,4977),(27051,4978),(27052,4978),(27053,4978),(27054,4978),(27055,4979),(27056,4979),(27057,4979),(27058,4979),(27059,4980),(27060,4981),(27061,4982),(27062,4983),(27063,4984),(27064,4985),(27065,4986),(27066,4987),(27067,4988),(27068,4989),(27069,4990),(27070,4991),(27071,4992),(27072,4993),(27073,4994),(27074,4995),(27075,4996),(27076,4997),(27077,4998),(27078,4999),(27079,5000),(27080,5001),(27081,5002),(27082,5003),(27083,5004),(27084,5005),(27085,5006),(27086,5007),(27087,5008),(27088,5009),(27089,5010),(27090,5011),(27091,5012),(27092,5013),(27093,5014),(27094,5015),(27095,5016),(27096,5017),(27097,5018),(27098,5019),(27099,5020),(27100,5021),(27101,5022),(27102,5023),(27103,5024),(27104,5025),(27105,5026),(27106,5027),(27107,5028),(27108,5029),(27109,5030),(27110,5031),(27111,5032),(27112,5033),(27113,5034),(27114,5035),(27115,5036),(27116,5037),(27117,5038),(27118,5039),(27119,5040),(27120,5041),(27121,5042),(27122,5043),(27123,5044),(27124,5045),(27125,5046),(27126,5047),(27127,5048),(27128,5049),(27129,5050),(27130,5051),(27131,5052),(27132,5053),(27133,5054),(27134,5055),(27135,5056),(27136,5057),(27137,5058),(27138,5059),(27139,5060),(27140,5061),(27141,5062),(27142,5063),(27143,5064),(27144,5065),(27145,5066),(27146,5067),(27147,5068),(27148,5069),(27149,5070),(27150,5071),(27151,5072),(27152,5073),(27153,5074),(27154,5075),(27155,5076),(27156,5077),(27157,5078),(27158,5079),(27159,4980),(27160,4980),(27161,4980),(27162,4980),(27163,4981),(27164,4981),(27165,4981),(27166,4981),(27167,4982),(27168,4982),(27169,4982),(27170,4982),(27171,4983),(27172,4983),(27173,4983),(27174,4983),(27175,4984),(27176,4984),(27177,4984),(27178,4984),(27179,4985),(27180,4985),(27181,4985),(27182,4985),(27183,4986),(27184,4986),(27185,4986),(27186,4986),(27187,4987),(27188,4987),(27189,4987),(27190,4987),(27191,4988),(27192,4988),(27193,4988),(27194,4988),(27195,4989),(27196,4989),(27197,4989),(27198,4989),(27199,4990),(27200,4990),(27201,4990),(27202,4990),(27203,4991),(27204,4991),(27205,4991),(27206,4991),(27207,4992),(27208,4992),(27209,4992),(27210,4992),(27211,4993),(27212,4993),(27213,4993),(27214,4993),(27215,4994),(27216,4994),(27217,4994),(27218,4994),(27219,4995),(27220,4995),(27221,4995),(27222,4995),(27223,4996),(27224,4996),(27225,4996),(27226,4996),(27227,4997),(27228,4997),(27229,4997),(27230,4997),(27231,4998),(27232,4998),(27233,4998),(27234,4998),(27235,4999),(27236,4999),(27237,4999),(27238,4999),(27239,5000),(27240,5000),(27241,5000),(27242,5000),(27243,5001),(27244,5001),(27245,5001),(27246,5001),(27247,5002),(27248,5002),(27249,5002),(27250,5002),(27251,5003),(27252,5003),(27253,5003),(27254,5003),(27255,5004),(27256,5004),(27257,5004),(27258,5004),(27259,5005),(27260,5005),(27261,5005),(27262,5005),(27263,5006),(27264,5006),(27265,5006),(27266,5006),(27267,5007),(27268,5007),(27269,5007),(27270,5007),(27271,5008),(27272,5008),(27273,5008),(27274,5008),(27275,5009),(27276,5009),(27277,5009),(27278,5009),(27279,5010),(27280,5010),(27281,5010),(27282,5010),(27283,5011),(27284,5011),(27285,5011),(27286,5011),(27287,5012),(27288,5012),(27289,5012),(27290,5012),(27291,5013),(27292,5013),(27293,5013),(27294,5013),(27295,5014),(27296,5014),(27297,5014),(27298,5014),(27299,5015),(27300,5015),(27301,5015),(27302,5015),(27303,5016),(27304,5016),(27305,5016),(27306,5016),(27307,5017),(27308,5017),(27309,5017),(27310,5017),(27311,5018),(27312,5018),(27313,5018),(27314,5018),(27315,5019),(27316,5019),(27317,5019),(27318,5019),(27319,5020),(27320,5020),(27321,5020),(27322,5020),(27323,5021),(27324,5021),(27325,5021),(27326,5021),(27327,5022),(27328,5022),(27329,5022),(27330,5022),(27331,5023),(27332,5023),(27333,5023),(27334,5023),(27335,5024),(27336,5024),(27337,5024),(27338,5024),(27339,5025),(27340,5025),(27341,5025),(27342,5025),(27343,5026),(27344,5026),(27345,5026),(27346,5026),(27347,5027),(27348,5027),(27349,5027),(27350,5027),(27351,5028),(27352,5028),(27353,5028),(27354,5028),(27355,5029),(27356,5029),(27357,5029),(27358,5029),(27359,5030),(27360,5030),(27361,5030),(27362,5030),(27363,5031),(27364,5031),(27365,5031),(27366,5031),(27367,5032),(27368,5032),(27369,5032),(27370,5032),(27371,5033),(27372,5033),(27373,5033),(27374,5033),(27375,5034),(27376,5034),(27377,5034),(27378,5034),(27379,5035),(27380,5035),(27381,5035),(27382,5035),(27383,5036),(27384,5036),(27385,5036),(27386,5036),(27387,5037),(27388,5037),(27389,5037),(27390,5037),(27391,5038),(27392,5038),(27393,5038),(27394,5038),(27395,5039),(27396,5039),(27397,5039),(27398,5039),(27399,5040),(27400,5040),(27401,5040),(27402,5040),(27403,5041),(27404,5041),(27405,5041),(27406,5041),(27407,5042),(27408,5042),(27409,5042),(27410,5042),(27411,5043),(27412,5043),(27413,5043),(27414,5043),(27415,5044),(27416,5044),(27417,5044),(27418,5044),(27419,5045),(27420,5045),(27421,5045),(27422,5045),(27423,5046),(27424,5046),(27425,5046),(27426,5046),(27427,5047),(27428,5047),(27429,5047),(27430,5047),(27431,5048),(27432,5048),(27433,5048),(27434,5048),(27435,5049),(27436,5049),(27437,5049),(27438,5049),(27439,5050),(27440,5050),(27441,5050),(27442,5050),(27443,5051),(27444,5051),(27445,5051),(27446,5051),(27447,5052),(27448,5052),(27449,5052),(27450,5052),(27451,5053),(27452,5053),(27453,5053),(27454,5053),(27455,5054),(27456,5054),(27457,5054),(27458,5054),(27459,5055),(27460,5055),(27461,5055),(27462,5055),(27463,5056),(27464,5056),(27465,5056),(27466,5056),(27467,5057),(27468,5057),(27469,5057),(27470,5057),(27471,5058),(27472,5058),(27473,5058),(27474,5058),(27475,5059),(27476,5059),(27477,5059),(27478,5059),(27479,5060),(27480,5060),(27481,5060),(27482,5060),(27483,5061),(27484,5061),(27485,5061),(27486,5061),(27487,5062),(27488,5062),(27489,5062),(27490,5062),(27491,5063),(27492,5063),(27493,5063),(27494,5063),(27495,5064),(27496,5064),(27497,5064),(27498,5064),(27499,5065),(27500,5065),(27501,5065),(27502,5065),(27503,5066),(27504,5066),(27505,5066),(27506,5066),(27507,5067),(27508,5067),(27509,5067),(27510,5067),(27511,5068),(27512,5068),(27513,5068),(27514,5068),(27515,5069),(27516,5069),(27517,5069),(27518,5069),(27519,5070),(27520,5070),(27521,5070),(27522,5070),(27523,5071),(27524,5071),(27525,5071),(27526,5071),(27527,5072),(27528,5072),(27529,5072),(27530,5072),(27531,5073),(27532,5073),(27533,5073),(27534,5073),(27535,5074),(27536,5074),(27537,5074),(27538,5074),(27539,5075),(27540,5075),(27541,5075),(27542,5075),(27543,5076),(27544,5076),(27545,5076),(27546,5076),(27547,5077),(27548,5077),(27549,5077),(27550,5077),(27551,5078),(27552,5078),(27553,5078),(27554,5078),(27555,5079),(27556,5079),(27557,5079),(27558,5079),(27559,5080),(27560,5081),(27561,5082),(27562,5083),(27563,5084),(27564,5085),(27565,5086),(27566,5087),(27567,5088),(27568,5089),(27569,5090),(27570,5091),(27571,5092),(27572,5093),(27573,5094),(27574,5095),(27575,5096),(27576,5097),(27577,5098),(27578,5099),(27579,5100),(27580,5101),(27581,5102),(27582,5103),(27583,5104),(27584,5105),(27585,5106),(27586,5107),(27587,5108),(27588,5109),(27589,5110),(27590,5111),(27591,5112),(27592,5113),(27593,5114),(27594,5115),(27595,5116),(27596,5117),(27597,5118),(27598,5119),(27599,5120),(27600,5121),(27601,5122),(27602,5123),(27603,5124),(27604,5125),(27605,5126),(27606,5127),(27607,5128),(27608,5129),(27609,5130),(27610,5131),(27611,5132),(27612,5133),(27613,5134),(27614,5135),(27615,5136),(27616,5137),(27617,5138),(27618,5139),(27619,5140),(27620,5141),(27621,5142),(27622,5143),(27623,5144),(27624,5145),(27625,5146),(27626,5147),(27627,5148),(27628,5149),(27629,5150),(27630,5151),(27631,5152),(27632,5153),(27633,5154),(27634,5155),(27635,5156),(27636,5157),(27637,5158),(27638,5159),(27639,5160),(27640,5161),(27641,5162),(27642,5163),(27643,5164),(27644,5165),(27645,5166),(27646,5167),(27647,5168),(27648,5169),(27649,5170),(27650,5171),(27651,5172),(27652,5173),(27653,5174),(27654,5175),(27655,5176),(27656,5177),(27657,5178),(27658,5179),(27659,5080),(27660,5080),(27661,5080),(27662,5080),(27663,5081),(27664,5081),(27665,5081),(27666,5081),(27667,5082),(27668,5082),(27669,5082),(27670,5082),(27671,5083),(27672,5083),(27673,5083),(27674,5083),(27675,5084),(27676,5084),(27677,5084),(27678,5084),(27679,5085),(27680,5085),(27681,5085),(27682,5085),(27683,5086),(27684,5086),(27685,5086),(27686,5086),(27687,5087),(27688,5087),(27689,5087),(27690,5087),(27691,5088),(27692,5088),(27693,5088),(27694,5088),(27695,5089),(27696,5089),(27697,5089),(27698,5089),(27699,5090),(27700,5090),(27701,5090),(27702,5090),(27703,5091),(27704,5091),(27705,5091),(27706,5091),(27707,5092),(27708,5092),(27709,5092),(27710,5092),(27711,5093),(27712,5093),(27713,5093),(27714,5093),(27715,5094),(27716,5094),(27717,5094),(27718,5094),(27719,5095),(27720,5095),(27721,5095),(27722,5095),(27723,5096),(27724,5096),(27725,5096),(27726,5096),(27727,5097),(27728,5097),(27729,5097),(27730,5097),(27731,5098),(27732,5098),(27733,5098),(27734,5098),(27735,5099),(27736,5099),(27737,5099),(27738,5099),(27739,5100),(27740,5100),(27741,5100),(27742,5100),(27743,5101),(27744,5101),(27745,5101),(27746,5101),(27747,5102),(27748,5102),(27749,5102),(27750,5102),(27751,5103),(27752,5103),(27753,5103),(27754,5103),(27755,5104),(27756,5104),(27757,5104),(27758,5104),(27759,5105),(27760,5105),(27761,5105),(27762,5105),(27763,5106),(27764,5106),(27765,5106),(27766,5106),(27767,5107),(27768,5107),(27769,5107),(27770,5107),(27771,5108),(27772,5108),(27773,5108),(27774,5108),(27775,5109),(27776,5109),(27777,5109),(27778,5109),(27779,5110),(27780,5110),(27781,5110),(27782,5110),(27783,5111),(27784,5111),(27785,5111),(27786,5111),(27787,5112),(27788,5112),(27789,5112),(27790,5112),(27791,5113),(27792,5113),(27793,5113),(27794,5113),(27795,5114),(27796,5114),(27797,5114),(27798,5114),(27799,5115),(27800,5115),(27801,5115),(27802,5115),(27803,5116),(27804,5116),(27805,5116),(27806,5116),(27807,5117),(27808,5117),(27809,5117),(27810,5117),(27811,5118),(27812,5118),(27813,5118),(27814,5118),(27815,5119),(27816,5119),(27817,5119),(27818,5119),(27819,5120),(27820,5120),(27821,5120),(27822,5120),(27823,5121),(27824,5121),(27825,5121),(27826,5121),(27827,5122),(27828,5122),(27829,5122),(27830,5122),(27831,5123),(27832,5123),(27833,5123),(27834,5123),(27835,5124),(27836,5124),(27837,5124),(27838,5124),(27839,5125),(27840,5125),(27841,5125),(27842,5125),(27843,5126),(27844,5126),(27845,5126),(27846,5126),(27847,5127),(27848,5127),(27849,5127),(27850,5127),(27851,5128),(27852,5128),(27853,5128),(27854,5128),(27855,5129),(27856,5129),(27857,5129),(27858,5129),(27859,5130),(27860,5130),(27861,5130),(27862,5130),(27863,5131),(27864,5131),(27865,5131),(27866,5131),(27867,5132),(27868,5132),(27869,5132),(27870,5132),(27871,5133),(27872,5133),(27873,5133),(27874,5133),(27875,5134),(27876,5134),(27877,5134),(27878,5134),(27879,5135),(27880,5135),(27881,5135),(27882,5135),(27883,5136),(27884,5136),(27885,5136),(27886,5136),(27887,5137),(27888,5137),(27889,5137),(27890,5137),(27891,5138),(27892,5138),(27893,5138),(27894,5138),(27895,5139),(27896,5139),(27897,5139),(27898,5139),(27899,5140),(27900,5140),(27901,5140),(27902,5140),(27903,5141),(27904,5141),(27905,5141),(27906,5141),(27907,5142),(27908,5142),(27909,5142),(27910,5142),(27911,5143),(27912,5143),(27913,5143),(27914,5143),(27915,5144),(27916,5144),(27917,5144),(27918,5144),(27919,5145),(27920,5145),(27921,5145),(27922,5145),(27923,5146),(27924,5146),(27925,5146),(27926,5146),(27927,5147),(27928,5147),(27929,5147),(27930,5147),(27931,5148),(27932,5148),(27933,5148),(27934,5148),(27935,5149),(27936,5149),(27937,5149),(27938,5149),(27939,5150),(27940,5150),(27941,5150),(27942,5150),(27943,5151),(27944,5151),(27945,5151),(27946,5151),(27947,5152),(27948,5152),(27949,5152),(27950,5152),(27951,5153),(27952,5153),(27953,5153),(27954,5153),(27955,5154),(27956,5154),(27957,5154),(27958,5154),(27959,5155),(27960,5155),(27961,5155),(27962,5155),(27963,5156),(27964,5156),(27965,5156),(27966,5156),(27967,5157),(27968,5157),(27969,5157),(27970,5157),(27971,5158),(27972,5158),(27973,5158),(27974,5158),(27975,5159),(27976,5159),(27977,5159),(27978,5159),(27979,5160),(27980,5160),(27981,5160),(27982,5160),(27983,5161),(27984,5161),(27985,5161),(27986,5161),(27987,5162),(27988,5162),(27989,5162),(27990,5162),(27991,5163),(27992,5163),(27993,5163),(27994,5163),(27995,5164),(27996,5164),(27997,5164),(27998,5164),(27999,5165),(28000,5165),(28001,5165),(28002,5165),(28003,5166),(28004,5166),(28005,5166),(28006,5166),(28007,5167),(28008,5167),(28009,5167),(28010,5167),(28011,5168),(28012,5168),(28013,5168),(28014,5168),(28015,5169),(28016,5169),(28017,5169),(28018,5169),(28019,5170),(28020,5170),(28021,5170),(28022,5170),(28023,5171),(28024,5171),(28025,5171),(28026,5171),(28027,5172),(28028,5172),(28029,5172),(28030,5172),(28031,5173),(28032,5173),(28033,5173),(28034,5173),(28035,5174),(28036,5174),(28037,5174),(28038,5174),(28039,5175),(28040,5175),(28041,5175),(28042,5175),(28043,5176),(28044,5176),(28045,5176),(28046,5176),(28047,5177),(28048,5177),(28049,5177),(28050,5177),(28051,5178),(28052,5178),(28053,5178),(28054,5178),(28055,5179),(28056,5179),(28057,5179),(28058,5179),(28059,5180),(28060,5181),(28061,5182),(28062,5183),(28063,5184),(28064,5185),(28065,5186),(28066,5187),(28067,5188),(28068,5189),(28069,5190),(28070,5191),(28071,5192),(28072,5193),(28073,5194),(28074,5195),(28075,5196),(28076,5197),(28077,5198),(28078,5199),(28079,5200),(28080,5201),(28081,5202),(28082,5203),(28083,5204),(28084,5205),(28085,5206),(28086,5207),(28087,5208),(28088,5209),(28089,5210),(28090,5211),(28091,5212),(28092,5213),(28093,5214),(28094,5215),(28095,5216),(28096,5217),(28097,5218),(28098,5219),(28099,5220),(28100,5221),(28101,5222),(28102,5223),(28103,5224),(28104,5225),(28105,5226),(28106,5227),(28107,5228),(28108,5229),(28109,5230),(28110,5231),(28111,5232),(28112,5233),(28113,5234),(28114,5235),(28115,5236),(28116,5237),(28117,5238),(28118,5239),(28119,5240),(28120,5241),(28121,5242),(28122,5243),(28123,5244),(28124,5245),(28125,5246),(28126,5247),(28127,5248),(28128,5249),(28129,5250),(28130,5251),(28131,5252),(28132,5253),(28133,5254),(28134,5255),(28135,5256),(28136,5257),(28137,5258),(28138,5259),(28139,5260),(28140,5261),(28141,5262),(28142,5263),(28143,5264),(28144,5265),(28145,5266),(28146,5267),(28147,5268),(28148,5269),(28149,5270),(28150,5180),(28151,5180),(28152,5180),(28153,5180),(28154,5181),(28155,5181),(28156,5181),(28157,5181),(28158,5182),(28159,5182),(28160,5182),(28161,5182),(28162,5183),(28163,5183),(28164,5183),(28165,5183),(28166,5184),(28167,5184),(28168,5184),(28169,5184),(28170,5185),(28171,5185),(28172,5185),(28173,5185),(28174,5186),(28175,5186),(28176,5186),(28177,5186),(28178,5187),(28179,5187),(28180,5187),(28181,5187),(28182,5188),(28183,5188),(28184,5188),(28185,5188),(28186,5189),(28187,5189),(28188,5189),(28189,5189),(28190,5190),(28191,5190),(28192,5190),(28193,5190),(28194,5191),(28195,5191),(28196,5191),(28197,5191),(28198,5192),(28199,5192),(28200,5192),(28201,5192),(28202,5193),(28203,5193),(28204,5193),(28205,5193),(28206,5194),(28207,5194),(28208,5194),(28209,5194),(28210,5195),(28211,5195),(28212,5195),(28213,5195),(28214,5196),(28215,5196),(28216,5196),(28217,5196),(28218,5197),(28219,5197),(28220,5197),(28221,5197),(28222,5198),(28223,5198),(28224,5198),(28225,5198),(28226,5199),(28227,5199),(28228,5199),(28229,5199),(28230,5200),(28231,5200),(28232,5200),(28233,5200),(28234,5201),(28235,5201),(28236,5201),(28237,5201),(28238,5202),(28239,5202),(28240,5202),(28241,5202),(28242,5203),(28243,5203),(28244,5203),(28245,5203),(28246,5204),(28247,5204),(28248,5204),(28249,5204),(28250,5205),(28251,5205),(28252,5205),(28253,5205),(28254,5206),(28255,5206),(28256,5206),(28257,5206),(28258,5207),(28259,5207),(28260,5207),(28261,5207),(28262,5208),(28263,5208),(28264,5208),(28265,5208),(28266,5209),(28267,5209),(28268,5209),(28269,5209),(28270,5210),(28271,5210),(28272,5210),(28273,5210),(28274,5211),(28275,5211),(28276,5211),(28277,5211),(28278,5212),(28279,5212),(28280,5212),(28281,5212),(28282,5213),(28283,5213),(28284,5213),(28285,5213),(28286,5214),(28287,5214),(28288,5214),(28289,5214),(28290,5215),(28291,5215),(28292,5215),(28293,5215),(28294,5216),(28295,5216),(28296,5216),(28297,5216),(28298,5217),(28299,5217),(28300,5217),(28301,5217),(28302,5218),(28303,5218),(28304,5218),(28305,5218),(28306,5219),(28307,5219),(28308,5219),(28309,5219),(28310,5220),(28311,5220),(28312,5220),(28313,5220),(28314,5221),(28315,5221),(28316,5221),(28317,5221),(28318,5222),(28319,5222),(28320,5222),(28321,5222),(28322,5223),(28323,5223),(28324,5223),(28325,5223),(28326,5224),(28327,5224),(28328,5224),(28329,5224),(28330,5225),(28331,5225),(28332,5225),(28333,5225),(28334,5226),(28335,5226),(28336,5226),(28337,5226),(28338,5227),(28339,5227),(28340,5227),(28341,5227),(28342,5228),(28343,5228),(28344,5228),(28345,5228),(28346,5229),(28347,5229),(28348,5229),(28349,5229),(28350,5230),(28351,5230),(28352,5230),(28353,5230),(28354,5231),(28355,5231),(28356,5231),(28357,5231),(28358,5232),(28359,5232),(28360,5232),(28361,5232),(28362,5233),(28363,5233),(28364,5233),(28365,5233),(28366,5234),(28367,5234),(28368,5234),(28369,5234),(28370,5235),(28371,5235),(28372,5235),(28373,5235),(28374,5236),(28375,5236),(28376,5236),(28377,5236),(28378,5237),(28379,5237),(28380,5237),(28381,5237),(28382,5238),(28383,5238),(28384,5238),(28385,5238),(28386,5239),(28387,5239),(28388,5239),(28389,5239),(28390,5240),(28391,5240),(28392,5240),(28393,5240),(28394,5241),(28395,5241),(28396,5241),(28397,5241),(28398,5242),(28399,5242),(28400,5242),(28401,5242),(28402,5243),(28403,5243),(28404,5243),(28405,5243),(28406,5244),(28407,5244),(28408,5244),(28409,5244),(28410,5245),(28411,5245),(28412,5245),(28413,5245),(28414,5246),(28415,5246),(28416,5246),(28417,5246),(28418,5247),(28419,5247),(28420,5247),(28421,5247),(28422,5248),(28423,5248),(28424,5248),(28425,5248),(28426,5249),(28427,5249),(28428,5249),(28429,5249),(28430,5250),(28431,5250),(28432,5250),(28433,5250),(28434,5251),(28435,5251),(28436,5251),(28437,5251),(28438,5252),(28439,5252),(28440,5252),(28441,5252),(28442,5253),(28443,5253),(28444,5253),(28445,5253),(28446,5254),(28447,5254),(28448,5254),(28449,5254),(28450,5255),(28451,5255),(28452,5255),(28453,5255),(28454,5256),(28455,5256),(28456,5256),(28457,5256),(28458,5257),(28459,5257),(28460,5257),(28461,5257),(28462,5258),(28463,5258),(28464,5258),(28465,5258),(28466,5259),(28467,5259),(28468,5259),(28469,5259),(28470,5260),(28471,5260),(28472,5260),(28473,5260),(28474,5261),(28475,5261),(28476,5261),(28477,5261),(28478,5262),(28479,5262),(28480,5262),(28481,5262),(28482,5263),(28483,5263),(28484,5263),(28485,5263),(28486,5264),(28487,5264),(28488,5264),(28489,5264),(28490,5265),(28491,5265),(28492,5265),(28493,5265),(28494,5266),(28495,5266),(28496,5266),(28497,5266),(28498,5267),(28499,5267),(28500,5267),(28501,5267),(28502,5268),(28503,5268),(28504,5268),(28505,5268),(28506,5269),(28507,5269),(28508,5269),(28509,5269),(28510,5270),(28511,5270),(28512,5270),(28513,5270),(28514,5271),(28515,5272),(28516,5273),(28517,5274),(28518,5275),(28519,5276),(28520,5277),(28521,5278),(28522,5279),(28523,5280),(28524,5281),(28525,5282),(28526,5283),(28527,5284),(28528,5285),(28529,5286),(28530,5287),(28531,5288),(28532,5289),(28533,5290),(28534,5291),(28535,5292),(28536,5293),(28537,5294),(28538,5295),(28539,5296),(28540,5297),(28541,5298),(28542,5299),(28543,5300),(28544,5301),(28545,5302),(28546,5303),(28547,5304),(28548,5305),(28549,5306),(28550,5307),(28551,5308),(28552,5309),(28553,5310),(28554,5311),(28555,5312),(28556,5313),(28557,5314),(28558,5315),(28559,5316),(28560,5317),(28561,5318),(28562,5319),(28563,5320),(28564,5321),(28565,5322),(28566,5323),(28567,5324),(28568,5325),(28569,5326),(28570,5327),(28571,5328),(28572,5329),(28573,5330),(28574,5331),(28575,5332),(28576,5333),(28577,5334),(28578,5335),(28579,5336),(28580,5337),(28581,5338),(28582,5339),(28583,5340),(28584,5341),(28585,5342),(28586,5343),(28587,5344),(28588,5345),(28589,5346),(28590,5347),(28591,5348),(28592,5349),(28593,5350),(28594,5351),(28595,5352),(28596,5353),(28597,5354),(28598,5355),(28599,5356),(28600,5357),(28601,5358),(28602,5359),(28603,5271),(28604,5271),(28605,5271),(28606,5271),(28607,5272),(28608,5272),(28609,5272),(28610,5272),(28611,5273),(28612,5273),(28613,5273),(28614,5273),(28615,5274),(28616,5274),(28617,5274),(28618,5274),(28619,5275),(28620,5275),(28621,5275),(28622,5275),(28623,5276),(28624,5276),(28625,5276),(28626,5276),(28627,5277),(28628,5277),(28629,5277),(28630,5277),(28631,5278),(28632,5278),(28633,5278),(28634,5278),(28635,5279),(28636,5279),(28637,5279),(28638,5279),(28639,5280),(28640,5280),(28641,5280),(28642,5280),(28643,5281),(28644,5281),(28645,5281),(28646,5281),(28647,5282),(28648,5282),(28649,5282),(28650,5282),(28651,5283),(28652,5283),(28653,5283),(28654,5283),(28655,5284),(28656,5284),(28657,5284),(28658,5284),(28659,5285),(28660,5285),(28661,5285),(28662,5285),(28663,5286),(28664,5286),(28665,5286),(28666,5286),(28667,5287),(28668,5287),(28669,5287),(28670,5287),(28671,5288),(28672,5288),(28673,5288),(28674,5288),(28675,5289),(28676,5289),(28677,5289),(28678,5289),(28679,5290),(28680,5290),(28681,5290),(28682,5290),(28683,5291),(28684,5291),(28685,5291),(28686,5291),(28687,5292),(28688,5292),(28689,5292),(28690,5292),(28691,5293),(28692,5293),(28693,5293),(28694,5293),(28695,5294),(28696,5294),(28697,5294),(28698,5294),(28699,5295),(28700,5295),(28701,5295),(28702,5295),(28703,5296),(28704,5296),(28705,5296),(28706,5296),(28707,5297),(28708,5297),(28709,5297),(28710,5297),(28711,5298),(28712,5298),(28713,5298),(28714,5298),(28715,5299),(28716,5299),(28717,5299),(28718,5299),(28719,5300),(28720,5300),(28721,5300),(28722,5300),(28723,5301),(28724,5301),(28725,5301),(28726,5301),(28727,5302),(28728,5302),(28729,5302),(28730,5302),(28731,5303),(28732,5303),(28733,5303),(28734,5303),(28735,5304),(28736,5304),(28737,5304),(28738,5304),(28739,5305),(28740,5305),(28741,5305),(28742,5305),(28743,5306),(28744,5306),(28745,5306),(28746,5306),(28747,5307),(28748,5307),(28749,5307),(28750,5307),(28751,5308),(28752,5308),(28753,5308),(28754,5308),(28755,5309),(28756,5309),(28757,5309),(28758,5309),(28759,5310),(28760,5310),(28761,5310),(28762,5310),(28763,5311),(28764,5311),(28765,5311),(28766,5311),(28767,5312),(28768,5312),(28769,5312),(28770,5312),(28771,5313),(28772,5313),(28773,5313),(28774,5313),(28775,5314),(28776,5314),(28777,5314),(28778,5314),(28779,5315),(28780,5315),(28781,5315),(28782,5315),(28783,5316),(28784,5316),(28785,5316),(28786,5316),(28787,5317),(28788,5317),(28789,5317),(28790,5317),(28791,5318),(28792,5318),(28793,5318),(28794,5318),(28795,5319),(28796,5319),(28797,5319),(28798,5319),(28799,5320),(28800,5320),(28801,5320),(28802,5320),(28803,5321),(28804,5321),(28805,5321),(28806,5321),(28807,5322),(28808,5322),(28809,5322),(28810,5322),(28811,5323),(28812,5323),(28813,5323),(28814,5323),(28815,5324),(28816,5324),(28817,5324),(28818,5324),(28819,5325),(28820,5325),(28821,5325),(28822,5325),(28823,5326),(28824,5326),(28825,5326),(28826,5326),(28827,5327),(28828,5327),(28829,5327),(28830,5327),(28831,5328),(28832,5328),(28833,5328),(28834,5328),(28835,5329),(28836,5329),(28837,5329),(28838,5329),(28839,5330),(28840,5330),(28841,5330),(28842,5330),(28843,5331),(28844,5331),(28845,5331),(28846,5331),(28847,5332),(28848,5332),(28849,5332),(28850,5332),(28851,5333),(28852,5333),(28853,5333),(28854,5333),(28855,5334),(28856,5334),(28857,5334),(28858,5334),(28859,5335),(28860,5335),(28861,5335),(28862,5335),(28863,5336),(28864,5336),(28865,5336),(28866,5336),(28867,5337),(28868,5337),(28869,5337),(28870,5337),(28871,5338),(28872,5338),(28873,5338),(28874,5338),(28875,5339),(28876,5339),(28877,5339),(28878,5339),(28879,5340),(28880,5340),(28881,5340),(28882,5340),(28883,5341),(28884,5341),(28885,5341),(28886,5341),(28887,5342),(28888,5342),(28889,5342),(28890,5342),(28891,5343),(28892,5343),(28893,5343),(28894,5343),(28895,5344),(28896,5344),(28897,5344),(28898,5344),(28899,5345),(28900,5345),(28901,5345),(28902,5345),(28903,5346),(28904,5346),(28905,5346),(28906,5346),(28907,5347),(28908,5347),(28909,5347),(28910,5347),(28911,5348),(28912,5348),(28913,5348),(28914,5348),(28915,5349),(28916,5349),(28917,5349),(28918,5349),(28919,5350),(28920,5350),(28921,5350),(28922,5350),(28923,5351),(28924,5351),(28925,5351),(28926,5351),(28927,5352),(28928,5352),(28929,5352),(28930,5352),(28931,5353),(28932,5353),(28933,5353),(28934,5353),(28935,5354),(28936,5354),(28937,5354),(28938,5354),(28939,5355),(28940,5355),(28941,5355),(28942,5355),(28943,5356),(28944,5356),(28945,5356),(28946,5356),(28947,5357),(28948,5357),(28949,5357),(28950,5357),(28951,5358),(28952,5358),(28953,5358),(28954,5358),(28955,5359),(28956,5359),(28957,5359),(28958,5359),(28959,5360),(28960,5361),(28961,5362),(28962,5363),(28963,5364),(28964,5365),(28965,5366),(28966,5367),(28967,5368),(28968,5369),(28969,5370),(28970,5371),(28971,5372),(28972,5373),(28973,5374),(28974,5375),(28975,5376),(28976,5377),(28977,5378),(28978,5379),(28979,5380),(28980,5381),(28981,5382),(28982,5383),(28983,5384),(28984,5385),(28985,5386),(28986,5387),(28987,5388),(28988,5389),(28989,5390),(28990,5391),(28991,5392),(28992,5393),(28993,5394),(28994,5395),(28995,5396),(28996,5397),(28997,5398),(28998,5399),(28999,5400),(29000,5401),(29001,5402),(29002,5403),(29003,5404),(29004,5405),(29005,5406),(29006,5407),(29007,5408),(29008,5409),(29009,5410),(29010,5411),(29011,5412),(29012,5413),(29013,5414),(29014,5415),(29015,5416),(29016,5417),(29017,5418),(29018,5419),(29019,5420),(29020,5421),(29021,5422),(29022,5423),(29023,5424),(29024,5425),(29025,5426),(29026,5427),(29027,5428),(29028,5429),(29029,5430),(29030,5431),(29031,5432),(29032,5433),(29033,5434),(29034,5435),(29035,5436),(29036,5437),(29037,5438),(29038,5439),(29039,5440),(29040,5441),(29041,5442),(29042,5443),(29043,5444),(29044,5445),(29045,5446),(29046,5447),(29047,5448),(29048,5449),(29049,5450),(29050,5451),(29051,5452),(29052,5453),(29053,5454),(29054,5455),(29055,5456),(29056,5457),(29057,5458),(29058,5459),(29059,5360),(29060,5360),(29061,5360),(29062,5360),(29063,5361),(29064,5361),(29065,5361),(29066,5361),(29067,5362),(29068,5362),(29069,5362),(29070,5362),(29071,5363),(29072,5363),(29073,5363),(29074,5363),(29075,5364),(29076,5364),(29077,5364),(29078,5364),(29079,5365),(29080,5365),(29081,5365),(29082,5365),(29083,5366),(29084,5366),(29085,5366),(29086,5366),(29087,5367),(29088,5367),(29089,5367),(29090,5367),(29091,5368),(29092,5368),(29093,5368),(29094,5368),(29095,5369),(29096,5369),(29097,5369),(29098,5369),(29099,5370),(29100,5370),(29101,5370),(29102,5370),(29103,5371),(29104,5371),(29105,5371),(29106,5371),(29107,5372),(29108,5372),(29109,5372),(29110,5372),(29111,5373),(29112,5373),(29113,5373),(29114,5373),(29115,5374),(29116,5374),(29117,5374),(29118,5374),(29119,5375),(29120,5375),(29121,5375),(29122,5375),(29123,5376),(29124,5376),(29125,5376),(29126,5376),(29127,5377),(29128,5377),(29129,5377),(29130,5377),(29131,5378),(29132,5378),(29133,5378),(29134,5378),(29135,5379),(29136,5379),(29137,5379),(29138,5379),(29139,5380),(29140,5380),(29141,5380),(29142,5380),(29143,5381),(29144,5381),(29145,5381),(29146,5381),(29147,5382),(29148,5382),(29149,5382),(29150,5382),(29151,5383),(29152,5383),(29153,5383),(29154,5383),(29155,5384),(29156,5384),(29157,5384),(29158,5384),(29159,5385),(29160,5385),(29161,5385),(29162,5385),(29163,5386),(29164,5386),(29165,5386),(29166,5386),(29167,5387),(29168,5387),(29169,5387),(29170,5387),(29171,5388),(29172,5388),(29173,5388),(29174,5388),(29175,5389),(29176,5389),(29177,5389),(29178,5389),(29179,5390),(29180,5390),(29181,5390),(29182,5390),(29183,5391),(29184,5391),(29185,5391),(29186,5391),(29187,5392),(29188,5392),(29189,5392),(29190,5392),(29191,5393),(29192,5393),(29193,5393),(29194,5393),(29195,5394),(29196,5394),(29197,5394),(29198,5394),(29199,5395),(29200,5395),(29201,5395),(29202,5395),(29203,5396),(29204,5396),(29205,5396),(29206,5396),(29207,5397),(29208,5397),(29209,5397),(29210,5397),(29211,5398),(29212,5398),(29213,5398),(29214,5398),(29215,5399),(29216,5399),(29217,5399),(29218,5399),(29219,5400),(29220,5400),(29221,5400),(29222,5400),(29223,5401),(29224,5401),(29225,5401),(29226,5401),(29227,5402),(29228,5402),(29229,5402),(29230,5402),(29231,5403),(29232,5403),(29233,5403),(29234,5403),(29235,5404),(29236,5404),(29237,5404),(29238,5404),(29239,5405),(29240,5405),(29241,5405),(29242,5405),(29243,5406),(29244,5406),(29245,5406),(29246,5406),(29247,5407),(29248,5407),(29249,5407),(29250,5407),(29251,5408),(29252,5408),(29253,5408),(29254,5408),(29255,5409),(29256,5409),(29257,5409),(29258,5409),(29259,5410),(29260,5410),(29261,5410),(29262,5410),(29263,5411),(29264,5411),(29265,5411),(29266,5411),(29267,5412),(29268,5412),(29269,5412),(29270,5412),(29271,5413),(29272,5413),(29273,5413),(29274,5413),(29275,5414),(29276,5414),(29277,5414),(29278,5414),(29279,5415),(29280,5415),(29281,5415),(29282,5415),(29283,5416),(29284,5416),(29285,5416),(29286,5416),(29287,5417),(29288,5417),(29289,5417),(29290,5417),(29291,5418),(29292,5418),(29293,5418),(29294,5418),(29295,5419),(29296,5419),(29297,5419),(29298,5419),(29299,5420),(29300,5420),(29301,5420),(29302,5420),(29303,5421),(29304,5421),(29305,5421),(29306,5421),(29307,5422),(29308,5422),(29309,5422),(29310,5422),(29311,5423),(29312,5423),(29313,5423),(29314,5423),(29315,5424),(29316,5424),(29317,5424),(29318,5424),(29319,5425),(29320,5425),(29321,5425),(29322,5425),(29323,5426),(29324,5426),(29325,5426),(29326,5426),(29327,5427),(29328,5427),(29329,5427),(29330,5427),(29331,5428),(29332,5428),(29333,5428),(29334,5428),(29335,5429),(29336,5429),(29337,5429),(29338,5429),(29339,5430),(29340,5430),(29341,5430),(29342,5430),(29343,5431),(29344,5431),(29345,5431),(29346,5431),(29347,5432),(29348,5432),(29349,5432),(29350,5432),(29351,5433),(29352,5433),(29353,5433),(29354,5433),(29355,5434),(29356,5434),(29357,5434),(29358,5434),(29359,5435),(29360,5435),(29361,5435),(29362,5435),(29363,5436),(29364,5436),(29365,5436),(29366,5436),(29367,5437),(29368,5437),(29369,5437),(29370,5437),(29371,5438),(29372,5438),(29373,5438),(29374,5438),(29375,5439),(29376,5439),(29377,5439),(29378,5439),(29379,5440),(29380,5440),(29381,5440),(29382,5440),(29383,5441),(29384,5441),(29385,5441),(29386,5441),(29387,5442),(29388,5442),(29389,5442),(29390,5442),(29391,5443),(29392,5443),(29393,5443),(29394,5443),(29395,5444),(29396,5444),(29397,5444),(29398,5444),(29399,5445),(29400,5445),(29401,5445),(29402,5445),(29403,5446),(29404,5446),(29405,5446),(29406,5446),(29407,5447),(29408,5447),(29409,5447),(29410,5447),(29411,5448),(29412,5448),(29413,5448),(29414,5448),(29415,5449),(29416,5449),(29417,5449),(29418,5449),(29419,5450),(29420,5450),(29421,5450),(29422,5450),(29423,5451),(29424,5451),(29425,5451),(29426,5451),(29427,5452),(29428,5452),(29429,5452),(29430,5452),(29431,5453),(29432,5453),(29433,5453),(29434,5453),(29435,5454),(29436,5454),(29437,5454),(29438,5454),(29439,5455),(29440,5455),(29441,5455),(29442,5455),(29443,5456),(29444,5456),(29445,5456),(29446,5456),(29447,5457),(29448,5457),(29449,5457),(29450,5457),(29451,5458),(29452,5458),(29453,5458),(29454,5458),(29455,5459),(29456,5459),(29457,5459),(29458,5459),(29459,5460),(29460,5461),(29461,5462),(29462,5463),(29463,5464),(29464,5465),(29465,5466),(29466,5467),(29467,5468),(29468,5469),(29469,5470),(29470,5471),(29471,5472),(29472,5473),(29473,5474),(29474,5475),(29475,5476),(29476,5477),(29477,5478),(29478,5479),(29479,5480),(29480,5481),(29481,5482),(29482,5483),(29483,5484),(29484,5485),(29485,5486),(29486,5487),(29487,5488),(29488,5489),(29489,5490),(29490,5491),(29491,5492),(29492,5493),(29493,5494),(29494,5495),(29495,5496),(29496,5497),(29497,5498),(29498,5499),(29499,5500),(29500,5501),(29501,5502),(29502,5503),(29503,5504),(29504,5505),(29505,5506),(29506,5507),(29507,5508),(29508,5509),(29509,5510),(29510,5511),(29511,5512),(29512,5513),(29513,5514),(29514,5515),(29515,5516),(29516,5517),(29517,5518),(29518,5519),(29519,5520),(29520,5521),(29521,5522),(29522,5523),(29523,5524),(29524,5525),(29525,5526),(29526,5527),(29527,5528),(29528,5529),(29529,5530),(29530,5531),(29531,5532),(29532,5533),(29533,5534),(29534,5535),(29535,5536),(29536,5537),(29537,5538),(29538,5539),(29539,5540),(29540,5541),(29541,5542),(29542,5543),(29543,5544),(29544,5545),(29545,5546),(29546,5547),(29547,5548),(29548,5549),(29549,5550),(29550,5551),(29551,5552),(29552,5553),(29553,5554),(29554,5555),(29555,5556),(29556,5557),(29557,5558),(29558,5559),(29559,5460),(29560,5460),(29561,5460),(29562,5460),(29563,5461),(29564,5461),(29565,5461),(29566,5461),(29567,5462),(29568,5462),(29569,5462),(29570,5462),(29571,5463),(29572,5463),(29573,5463),(29574,5463),(29575,5464),(29576,5464),(29577,5464),(29578,5464),(29579,5465),(29580,5465),(29581,5465),(29582,5465),(29583,5466),(29584,5466),(29585,5466),(29586,5466),(29587,5467),(29588,5467),(29589,5467),(29590,5467),(29591,5468),(29592,5468),(29593,5468),(29594,5468),(29595,5469),(29596,5469),(29597,5469),(29598,5469),(29599,5470),(29600,5470),(29601,5470),(29602,5470),(29603,5471),(29604,5471),(29605,5471),(29606,5471),(29607,5472),(29608,5472),(29609,5472),(29610,5472),(29611,5473),(29612,5473),(29613,5473),(29614,5473),(29615,5474),(29616,5474),(29617,5474),(29618,5474),(29619,5475),(29620,5475),(29621,5475),(29622,5475),(29623,5476),(29624,5476),(29625,5476),(29626,5476),(29627,5477),(29628,5477),(29629,5477),(29630,5477),(29631,5478),(29632,5478),(29633,5478),(29634,5478),(29635,5479),(29636,5479),(29637,5479),(29638,5479),(29639,5480),(29640,5480),(29641,5480),(29642,5480),(29643,5481),(29644,5481),(29645,5481),(29646,5481),(29647,5482),(29648,5482),(29649,5482),(29650,5482),(29651,5483),(29652,5483),(29653,5483),(29654,5483),(29655,5484),(29656,5484),(29657,5484),(29658,5484),(29659,5485),(29660,5485),(29661,5485),(29662,5485),(29663,5486),(29664,5486),(29665,5486),(29666,5486),(29667,5487),(29668,5487),(29669,5487),(29670,5487),(29671,5488),(29672,5488),(29673,5488),(29674,5488),(29675,5489),(29676,5489),(29677,5489),(29678,5489),(29679,5490),(29680,5490),(29681,5490),(29682,5490),(29683,5491),(29684,5491),(29685,5491),(29686,5491),(29687,5492),(29688,5492),(29689,5492),(29690,5492),(29691,5493),(29692,5493),(29693,5493),(29694,5493),(29695,5494),(29696,5494),(29697,5494),(29698,5494),(29699,5495),(29700,5495),(29701,5495),(29702,5495),(29703,5496),(29704,5496),(29705,5496),(29706,5496),(29707,5497),(29708,5497),(29709,5497),(29710,5497),(29711,5498),(29712,5498),(29713,5498),(29714,5498),(29715,5499),(29716,5499),(29717,5499),(29718,5499),(29719,5500),(29720,5500),(29721,5500),(29722,5500),(29723,5501),(29724,5501),(29725,5501),(29726,5501),(29727,5502),(29728,5502),(29729,5502),(29730,5502),(29731,5503),(29732,5503),(29733,5503),(29734,5503),(29735,5504),(29736,5504),(29737,5504),(29738,5504),(29739,5505),(29740,5505),(29741,5505),(29742,5505),(29743,5506),(29744,5506),(29745,5506),(29746,5506),(29747,5507),(29748,5507),(29749,5507),(29750,5507),(29751,5508),(29752,5508),(29753,5508),(29754,5508),(29755,5509),(29756,5509),(29757,5509),(29758,5509),(29759,5510),(29760,5510),(29761,5510),(29762,5510),(29763,5511),(29764,5511),(29765,5511),(29766,5511),(29767,5512),(29768,5512),(29769,5512),(29770,5512),(29771,5513),(29772,5513),(29773,5513),(29774,5513),(29775,5514),(29776,5514),(29777,5514),(29778,5514),(29779,5515),(29780,5515),(29781,5515),(29782,5515),(29783,5516),(29784,5516),(29785,5516),(29786,5516),(29787,5517),(29788,5517),(29789,5517),(29790,5517),(29791,5518),(29792,5518),(29793,5518),(29794,5518),(29795,5519),(29796,5519),(29797,5519),(29798,5519),(29799,5520),(29800,5520),(29801,5520),(29802,5520),(29803,5521),(29804,5521),(29805,5521),(29806,5521),(29807,5522),(29808,5522),(29809,5522),(29810,5522),(29811,5523),(29812,5523),(29813,5523),(29814,5523),(29815,5524),(29816,5524),(29817,5524),(29818,5524),(29819,5525),(29820,5525),(29821,5525),(29822,5525),(29823,5526),(29824,5526),(29825,5526),(29826,5526),(29827,5527),(29828,5527),(29829,5527),(29830,5527),(29831,5528),(29832,5528),(29833,5528),(29834,5528),(29835,5529),(29836,5529),(29837,5529),(29838,5529),(29839,5530),(29840,5530),(29841,5530),(29842,5530),(29843,5531),(29844,5531),(29845,5531),(29846,5531),(29847,5532),(29848,5532),(29849,5532),(29850,5532),(29851,5533),(29852,5533),(29853,5533),(29854,5533),(29855,5534),(29856,5534),(29857,5534),(29858,5534),(29859,5535),(29860,5535),(29861,5535),(29862,5535),(29863,5536),(29864,5536),(29865,5536),(29866,5536),(29867,5537),(29868,5537),(29869,5537),(29870,5537),(29871,5538),(29872,5538),(29873,5538),(29874,5538),(29875,5539),(29876,5539),(29877,5539),(29878,5539),(29879,5540),(29880,5540),(29881,5540),(29882,5540),(29883,5541),(29884,5541),(29885,5541),(29886,5541),(29887,5542),(29888,5542),(29889,5542),(29890,5542),(29891,5543),(29892,5543),(29893,5543),(29894,5543),(29895,5544),(29896,5544),(29897,5544),(29898,5544),(29899,5545),(29900,5545),(29901,5545),(29902,5545),(29903,5546),(29904,5546),(29905,5546),(29906,5546),(29907,5547),(29908,5547),(29909,5547),(29910,5547),(29911,5548),(29912,5548),(29913,5548),(29914,5548),(29915,5549),(29916,5549),(29917,5549),(29918,5549),(29919,5550),(29920,5550),(29921,5550),(29922,5550),(29923,5551),(29924,5551),(29925,5551),(29926,5551),(29927,5552),(29928,5552),(29929,5552),(29930,5552),(29931,5553),(29932,5553),(29933,5553),(29934,5553),(29935,5554),(29936,5554),(29937,5554),(29938,5554),(29939,5555),(29940,5555),(29941,5555),(29942,5555),(29943,5556),(29944,5556),(29945,5556),(29946,5556),(29947,5557),(29948,5557),(29949,5557),(29950,5557),(29951,5558),(29952,5558),(29953,5558),(29954,5558),(29955,5559),(29956,5559),(29957,5559),(29958,5559),(29959,5560),(29960,5561),(29961,5562),(29962,5563),(29963,5564),(29964,5565),(29965,5566),(29966,5567),(29967,5568),(29968,5569),(29969,5570),(29970,5571),(29971,5572),(29972,5573),(29973,5574),(29974,5575),(29975,5576),(29976,5577),(29977,5578),(29978,5579),(29979,5580),(29980,5581),(29981,5582),(29982,5583),(29983,5584),(29984,5585),(29985,5586),(29986,5587),(29987,5588),(29988,5589),(29989,5590),(29990,5591),(29991,5592),(29992,5593),(29993,5594),(29994,5595),(29995,5596),(29996,5597),(29997,5598),(29998,5599),(29999,5600),(30000,5601),(30001,5602),(30002,5603),(30003,5604),(30004,5605),(30005,5606),(30006,5607),(30007,5608),(30008,5609),(30009,5610),(30010,5611),(30011,5612),(30012,5613),(30013,5614),(30014,5615),(30015,5616),(30016,5617),(30017,5618),(30018,5619),(30019,5620),(30020,5621),(30021,5622),(30022,5623),(30023,5624),(30024,5625),(30025,5626),(30026,5627),(30027,5628),(30028,5629),(30029,5630),(30030,5631),(30031,5632),(30032,5633),(30033,5634),(30034,5635),(30035,5636),(30036,5637),(30037,5638),(30038,5639),(30039,5640),(30040,5641),(30041,5642),(30042,5643),(30043,5644),(30044,5645),(30045,5646),(30046,5647),(30047,5648),(30048,5649),(30049,5650),(30050,5651),(30051,5652),(30052,5653),(30053,5654),(30054,5655),(30055,5656),(30056,5657),(30057,5658),(30058,5659),(30059,5560),(30060,5560),(30061,5560),(30062,5560),(30063,5561),(30064,5561),(30065,5561),(30066,5561),(30067,5562),(30068,5562),(30069,5562),(30070,5562),(30071,5563),(30072,5563),(30073,5563),(30074,5563),(30075,5564),(30076,5564),(30077,5564),(30078,5564),(30079,5565),(30080,5565),(30081,5565),(30082,5565),(30083,5566),(30084,5566),(30085,5566),(30086,5566),(30087,5567),(30088,5567),(30089,5567),(30090,5567),(30091,5568),(30092,5568),(30093,5568),(30094,5568),(30095,5569),(30096,5569),(30097,5569),(30098,5569),(30099,5570),(30100,5570),(30101,5570),(30102,5570),(30103,5571),(30104,5571),(30105,5571),(30106,5571),(30107,5572),(30108,5572),(30109,5572),(30110,5572),(30111,5573),(30112,5573),(30113,5573),(30114,5573),(30115,5574),(30116,5574),(30117,5574),(30118,5574),(30119,5575),(30120,5575),(30121,5575),(30122,5575),(30123,5576),(30124,5576),(30125,5576),(30126,5576),(30127,5577),(30128,5577),(30129,5577),(30130,5577),(30131,5578),(30132,5578),(30133,5578),(30134,5578),(30135,5579),(30136,5579),(30137,5579),(30138,5579),(30139,5580),(30140,5580),(30141,5580),(30142,5580),(30143,5581),(30144,5581),(30145,5581),(30146,5581),(30147,5582),(30148,5582),(30149,5582),(30150,5582),(30151,5583),(30152,5583),(30153,5583),(30154,5583),(30155,5584),(30156,5584),(30157,5584),(30158,5584),(30159,5585),(30160,5585),(30161,5585),(30162,5585),(30163,5586),(30164,5586),(30165,5586),(30166,5586),(30167,5587),(30168,5587),(30169,5587),(30170,5587),(30171,5588),(30172,5588),(30173,5588),(30174,5588),(30175,5589),(30176,5589),(30177,5589),(30178,5589),(30179,5590),(30180,5590),(30181,5590),(30182,5590),(30183,5591),(30184,5591),(30185,5591),(30186,5591),(30187,5592),(30188,5592),(30189,5592),(30190,5592),(30191,5593),(30192,5593),(30193,5593),(30194,5593),(30195,5594),(30196,5594),(30197,5594),(30198,5594),(30199,5595),(30200,5595),(30201,5595),(30202,5595),(30203,5596),(30204,5596),(30205,5596),(30206,5596),(30207,5597),(30208,5597),(30209,5597),(30210,5597),(30211,5598),(30212,5598),(30213,5598),(30214,5598),(30215,5599),(30216,5599),(30217,5599),(30218,5599),(30219,5600),(30220,5600),(30221,5600),(30222,5600),(30223,5601),(30224,5601),(30225,5601),(30226,5601),(30227,5602),(30228,5602),(30229,5602),(30230,5602),(30231,5603),(30232,5603),(30233,5603),(30234,5603),(30235,5604),(30236,5604),(30237,5604),(30238,5604),(30239,5605),(30240,5605),(30241,5605),(30242,5605),(30243,5606),(30244,5606),(30245,5606),(30246,5606),(30247,5607),(30248,5607),(30249,5607),(30250,5607),(30251,5608),(30252,5608),(30253,5608),(30254,5608),(30255,5609),(30256,5609),(30257,5609),(30258,5609),(30259,5610),(30260,5610),(30261,5610),(30262,5610),(30263,5611),(30264,5611),(30265,5611),(30266,5611),(30267,5612),(30268,5612),(30269,5612),(30270,5612),(30271,5613),(30272,5613),(30273,5613),(30274,5613),(30275,5614),(30276,5614),(30277,5614),(30278,5614),(30279,5615),(30280,5615),(30281,5615),(30282,5615),(30283,5616),(30284,5616),(30285,5616),(30286,5616),(30287,5617),(30288,5617),(30289,5617),(30290,5617),(30291,5618),(30292,5618),(30293,5618),(30294,5618),(30295,5619),(30296,5619),(30297,5619),(30298,5619),(30299,5620),(30300,5620),(30301,5620),(30302,5620),(30303,5621),(30304,5621),(30305,5621),(30306,5621),(30307,5622),(30308,5622),(30309,5622),(30310,5622),(30311,5623),(30312,5623),(30313,5623),(30314,5623),(30315,5624),(30316,5624),(30317,5624),(30318,5624),(30319,5625),(30320,5625),(30321,5625),(30322,5625),(30323,5626),(30324,5626),(30325,5626),(30326,5626),(30327,5627),(30328,5627),(30329,5627),(30330,5627),(30331,5628),(30332,5628),(30333,5628),(30334,5628),(30335,5629),(30336,5629),(30337,5629),(30338,5629),(30339,5630),(30340,5630),(30341,5630),(30342,5630),(30343,5631),(30344,5631),(30345,5631),(30346,5631),(30347,5632),(30348,5632),(30349,5632),(30350,5632),(30351,5633),(30352,5633),(30353,5633),(30354,5633),(30355,5634),(30356,5634),(30357,5634),(30358,5634),(30359,5635),(30360,5635),(30361,5635),(30362,5635),(30363,5636),(30364,5636),(30365,5636),(30366,5636),(30367,5637),(30368,5637),(30369,5637),(30370,5637),(30371,5638),(30372,5638),(30373,5638),(30374,5638),(30375,5639),(30376,5639),(30377,5639),(30378,5639),(30379,5640),(30380,5640),(30381,5640),(30382,5640),(30383,5641),(30384,5641),(30385,5641),(30386,5641),(30387,5642),(30388,5642),(30389,5642),(30390,5642),(30391,5643),(30392,5643),(30393,5643),(30394,5643),(30395,5644),(30396,5644),(30397,5644),(30398,5644),(30399,5645),(30400,5645),(30401,5645),(30402,5645),(30403,5646),(30404,5646),(30405,5646),(30406,5646),(30407,5647),(30408,5647),(30409,5647),(30410,5647),(30411,5648),(30412,5648),(30413,5648),(30414,5648),(30415,5649),(30416,5649),(30417,5649),(30418,5649),(30419,5650),(30420,5650),(30421,5650),(30422,5650),(30423,5651),(30424,5651),(30425,5651),(30426,5651),(30427,5652),(30428,5652),(30429,5652),(30430,5652),(30431,5653),(30432,5653),(30433,5653),(30434,5653),(30435,5654),(30436,5654),(30437,5654),(30438,5654),(30439,5655),(30440,5655),(30441,5655),(30442,5655),(30443,5656),(30444,5656),(30445,5656),(30446,5656),(30447,5657),(30448,5657),(30449,5657),(30450,5657),(30451,5658),(30452,5658),(30453,5658),(30454,5658),(30455,5659),(30456,5659),(30457,5659),(30458,5659),(30459,5660),(30460,5661),(30461,5662),(30462,5663),(30463,5664),(30464,5665),(30465,5666),(30466,5667),(30467,5668),(30468,5669),(30469,5670),(30470,5671),(30471,5672),(30472,5673),(30473,5674),(30474,5675),(30475,5676),(30476,5677),(30477,5678),(30478,5679),(30479,5680),(30480,5681),(30481,5682),(30482,5683),(30483,5684),(30484,5685),(30485,5686),(30486,5687),(30487,5688),(30488,5689),(30489,5690),(30490,5691),(30491,5692),(30492,5693),(30493,5694),(30494,5695),(30495,5696),(30496,5697),(30497,5698),(30498,5699),(30499,5700),(30500,5701),(30501,5702),(30502,5703),(30503,5704),(30504,5705),(30505,5706),(30506,5707),(30507,5708),(30508,5709),(30509,5710),(30510,5711),(30511,5712),(30512,5713),(30513,5714),(30514,5715),(30515,5716),(30516,5717),(30517,5718),(30518,5719),(30519,5720),(30520,5721),(30521,5722),(30522,5723),(30523,5724),(30524,5725),(30525,5726),(30526,5727),(30527,5728),(30528,5729),(30529,5730),(30530,5731),(30531,5732),(30532,5733),(30533,5734),(30534,5735),(30535,5736),(30536,5737),(30537,5738),(30538,5739),(30539,5740),(30540,5741),(30541,5742),(30542,5743),(30543,5744),(30544,5745),(30545,5746),(30546,5747),(30547,5748),(30548,5749),(30549,5750),(30550,5751),(30551,5752),(30552,5660),(30553,5660),(30554,5660),(30555,5660),(30556,5661),(30557,5661),(30558,5661),(30559,5661),(30560,5662),(30561,5662),(30562,5662),(30563,5662),(30564,5663),(30565,5663),(30566,5663),(30567,5663),(30568,5664),(30569,5664),(30570,5664),(30571,5664),(30572,5665),(30573,5665),(30574,5665),(30575,5665),(30576,5666),(30577,5666),(30578,5666),(30579,5666),(30580,5667),(30581,5667),(30582,5667),(30583,5667),(30584,5668),(30585,5668),(30586,5668),(30587,5668),(30588,5669),(30589,5669),(30590,5669),(30591,5669),(30592,5670),(30593,5670),(30594,5670),(30595,5670),(30596,5671),(30597,5671),(30598,5671),(30599,5671),(30600,5672),(30601,5672),(30602,5672),(30603,5672),(30604,5673),(30605,5673),(30606,5673),(30607,5673),(30608,5674),(30609,5674),(30610,5674),(30611,5674),(30612,5675),(30613,5675),(30614,5675),(30615,5675),(30616,5676),(30617,5676),(30618,5676),(30619,5676),(30620,5677),(30621,5677),(30622,5677),(30623,5677),(30624,5678),(30625,5678),(30626,5678),(30627,5678),(30628,5679),(30629,5679),(30630,5679),(30631,5679),(30632,5680),(30633,5680),(30634,5680),(30635,5680),(30636,5681),(30637,5681),(30638,5681),(30639,5681),(30640,5682),(30641,5682),(30642,5682),(30643,5682),(30644,5683),(30645,5683),(30646,5683),(30647,5683),(30648,5684),(30649,5684),(30650,5684),(30651,5684),(30652,5685),(30653,5685),(30654,5685),(30655,5685),(30656,5686),(30657,5686),(30658,5686),(30659,5686),(30660,5687),(30661,5687),(30662,5687),(30663,5687),(30664,5688),(30665,5688),(30666,5688),(30667,5688),(30668,5689),(30669,5689),(30670,5689),(30671,5689),(30672,5690),(30673,5690),(30674,5690),(30675,5690),(30676,5691),(30677,5691),(30678,5691),(30679,5691),(30680,5692),(30681,5692),(30682,5692),(30683,5692),(30684,5693),(30685,5693),(30686,5693),(30687,5693),(30688,5694),(30689,5694),(30690,5694),(30691,5694),(30692,5695),(30693,5695),(30694,5695),(30695,5695),(30696,5696),(30697,5696),(30698,5696),(30699,5696),(30700,5697),(30701,5697),(30702,5697),(30703,5697),(30704,5698),(30705,5698),(30706,5698),(30707,5698),(30708,5699),(30709,5699),(30710,5699),(30711,5699),(30712,5700),(30713,5700),(30714,5700),(30715,5700),(30716,5701),(30717,5701),(30718,5701),(30719,5701),(30720,5702),(30721,5702),(30722,5702),(30723,5702),(30724,5703),(30725,5703),(30726,5703),(30727,5703),(30728,5704),(30729,5704),(30730,5704),(30731,5704),(30732,5705),(30733,5705),(30734,5705),(30735,5705),(30736,5706),(30737,5706),(30738,5706),(30739,5706),(30740,5707),(30741,5707),(30742,5707),(30743,5707),(30744,5708),(30745,5708),(30746,5708),(30747,5708),(30748,5709),(30749,5709),(30750,5709),(30751,5709),(30752,5710),(30753,5710),(30754,5710),(30755,5710),(30756,5711),(30757,5711),(30758,5711),(30759,5711),(30760,5712),(30761,5712),(30762,5712),(30763,5712),(30764,5713),(30765,5713),(30766,5713),(30767,5713),(30768,5714),(30769,5714),(30770,5714),(30771,5714),(30772,5715),(30773,5715),(30774,5715),(30775,5715),(30776,5716),(30777,5716),(30778,5716),(30779,5716),(30780,5717),(30781,5717),(30782,5717),(30783,5717),(30784,5718),(30785,5718),(30786,5718),(30787,5718),(30788,5719),(30789,5719),(30790,5719),(30791,5719),(30792,5720),(30793,5720),(30794,5720),(30795,5720),(30796,5721),(30797,5721),(30798,5721),(30799,5721),(30800,5722),(30801,5722),(30802,5722),(30803,5722),(30804,5723),(30805,5723),(30806,5723),(30807,5723),(30808,5724),(30809,5724),(30810,5724),(30811,5724),(30812,5725),(30813,5725),(30814,5725),(30815,5725),(30816,5726),(30817,5726),(30818,5726),(30819,5726),(30820,5727),(30821,5727),(30822,5727),(30823,5727),(30824,5728),(30825,5728),(30826,5728),(30827,5728),(30828,5729),(30829,5729),(30830,5729),(30831,5729),(30832,5730),(30833,5730),(30834,5730),(30835,5730),(30836,5731),(30837,5731),(30838,5731),(30839,5731),(30840,5732),(30841,5732),(30842,5732),(30843,5732),(30844,5733),(30845,5733),(30846,5733),(30847,5733),(30848,5734),(30849,5734),(30850,5734),(30851,5734),(30852,5735),(30853,5735),(30854,5735),(30855,5735),(30856,5736),(30857,5736),(30858,5736),(30859,5736),(30860,5737),(30861,5737),(30862,5737),(30863,5737),(30864,5738),(30865,5738),(30866,5738),(30867,5738),(30868,5739),(30869,5739),(30870,5739),(30871,5739),(30872,5740),(30873,5740),(30874,5740),(30875,5740),(30876,5741),(30877,5741),(30878,5741),(30879,5741),(30880,5742),(30881,5742),(30882,5742),(30883,5742),(30884,5743),(30885,5743),(30886,5743),(30887,5743),(30888,5744),(30889,5744),(30890,5744),(30891,5744),(30892,5745),(30893,5745),(30894,5745),(30895,5745),(30896,5746),(30897,5746),(30898,5746),(30899,5746),(30900,5747),(30901,5747),(30902,5747),(30903,5747),(30904,5748),(30905,5748),(30906,5748),(30907,5748),(30908,5749),(30909,5749),(30910,5749),(30911,5749),(30912,5750),(30913,5750),(30914,5750),(30915,5750),(30916,5751),(30917,5751),(30918,5751),(30919,5751),(30920,5752),(30921,5752),(30922,5752),(30923,5752),(30924,1475),(30925,1476),(30926,1497),(30927,1498),(30928,1501),(30929,1503),(30930,1504),(30931,1506),(30932,1507),(30933,1508),(30934,1509),(30935,1510),(30936,1511),(30937,1512),(30938,1513),(30939,1514),(30940,1515),(30941,1545),(30942,1588),(30943,1589),(30944,1590),(30945,1591),(30946,1592),(30947,1593),(30948,1594),(30949,1595),(30950,1596),(30951,1597),(30952,1598),(30953,1599),(30954,1600),(30955,1601),(30956,1602),(30957,1603),(30958,1604),(30959,1605),(30960,1606),(30961,1607),(30962,1608),(30963,1609),(30964,1610),(30965,1613),(30966,1615),(30967,1618),(30968,1619),(30969,1620),(30970,1621),(30971,1622),(30972,1623),(30973,1624),(30974,1625),(30975,1626),(30976,1627),(30977,1628),(30978,1654),(30979,1657),(30980,1715),(30981,1717),(30982,1718),(30983,1719),(30984,1720),(30985,1721),(30986,1722),(30987,1723),(30988,1724),(30989,1725),(30990,1727),(30991,1728),(30992,1729),(30993,1732),(30994,1733),(30995,1734),(30996,1735),(30997,1766),(30998,1767),(30999,1768),(31000,1770),(31001,1771),(31002,1774),(31003,1775),(31004,1784),(31005,1785),(31006,1797),(31007,1812),(31008,2289),(31009,4881),(31010,4889),(31011,5363),(31012,5366),(31013,5623),(31014,5629),(31015,5636),(31016,5642),(31017,5651),(31018,5662),(31019,5668),(31020,1497),(31021,1503),(31022,1504),(31023,1507),(31024,1508),(31025,1510),(31026,1512),(31027,1592),(31028,1595),(31029,1600),(31030,1601),(31031,1602),(31032,1603),(31033,1605),(31034,1606),(31035,1608),(31036,1609),(31037,1622),(31038,1624),(31039,1625),(31040,1626),(31041,1627),(31042,1628),(31043,1717),(31044,1720),(31045,1723),(31046,1724),(31047,1725),(31048,1727),(31049,1728),(31050,1729),(31051,1732),(31052,1797),(31053,1498),(31054,1503),(31055,1513),(31056,1588),(31057,1589),(31058,1590),(31059,1604),(31060,1613),(31061,1615),(31062,1619),(31063,1715),(31064,1718),(31065,1721),(31066,1723),(31067,1724),(31068,1733),(31069,1734),(31070,1770),(31071,1771),(31072,1774),(31073,1775),(31074,1784),(31075,1785),(31076,4889),(31077,1501),(31078,1506),(31079,1509),(31080,1511),(31081,1514),(31082,1607),(31083,1615),(31084,1618),(31085,1620),(31086,1654),(31087,1657),(31088,1719),(31089,1722),(31090,1735),(31091,1766),(31092,1767),(31093,1768),(31094,1812),(31095,4881),(31096,1159),(31097,1164),(31098,1165),(31099,1164),(31100,1165),(31101,4711),(31102,4713),(31103,5738),(31104,5752),(31105,1162),(31106,1163),(31107,1164),(31108,1165),(31109,4875),(31110,4876),(31111,4891),(31112,4892),(31113,4893),(31114,4894),(31115,1160),(31116,1161),(31117,1162),(31118,1163),(31119,1164),(31120,1165),(31121,4711),(31122,4713),(31123,5738),(31124,5752),(31125,5191),(31126,5192),(31127,5193),(31128,5194),(31129,5197),(31130,1160),(31131,1161),(31132,5190),(31133,5190),(31134,4713),(31135,4713),(31136,5190),(31137,4891),(31138,4891),(31139,1162),(31140,1162),(31141,1162),(31142,1165),(31143,1165),(31144,1165),(31145,2163),(31146,2163),(31147,2163),(31148,2176),(31149,2176),(31150,2176),(31151,1164),(31152,1164),(31153,1164),(31154,4894),(31155,4894),(31156,4894),(31157,4894),(31158,2163),(31159,1),(31160,1),(31161,1),(31162,1),(31163,1),(31164,1),(31165,42),(31166,141),(31167,143),(31168,163),(31169,165),(31170,145),(31171,148),(31172,180),(31173,186),(31174,1509),(31175,1775),(31176,1785),(31177,2375),(31178,2390),(31179,176),(31180,177),(31181,178),(31182,179),(31183,183),(31184,184),(31185,185),(31186,187),(31187,162),(31188,181),(31189,188),(31190,189),(31191,190),(31192,191),(31193,201),(31194,203),(31195,206),(31196,207),(31197,208),(31198,209),(31199,210),(31200,192),(31201,193),(31202,194),(31203,196),(31204,1480),(31205,1483),(31206,1486),(31207,1487),(31208,1495),(31209,1502),(31210,1611),(31211,1705),(31212,1707),(31213,1769),(31214,1505),(31215,1616),(31216,1617),(31217,1655),(31218,1656),(31219,1706),(31220,1742),(31221,1776),(31222,1539),(31223,1540),(31224,1541),(31225,1548),(31226,1549),(31227,1560),(31228,1561),(31229,1741),(31230,1764),(31231,1765),(31232,1783),(31233,1477),(31234,1537),(31235,1538),(31236,1544),(31237,1546),(31238,1547),(31239,1550),(31240,1551),(31241,1552),(31242,1554),(31243,1555),(31244,1556),(31245,1496),(31246,1553),(31247,1612),(31248,1614),(31249,1777),(31250,1473),(31251,1474),(31252,1475),(31253,1476),(31254,1477),(31255,1500),(31256,1537),(31257,1538),(31258,1539),(31259,1540),(31260,1541),(31261,1542),(31262,1543),(31263,1544),(31264,1545),(31265,1561),(31266,1591),(31267,1593),(31268,1594),(31269,1596),(31270,1597),(31271,1610),(31272,1598),(31273,1599),(31274,1621),(31275,1623),(31276,4538),(31277,1485),(31278,1611),(31279,1707),(31280,1769),(31281,1486),(31282,1487),(31283,1495),(31284,1505),(31285,1517),(31286,1776),(31287,1546),(31288,1553),(31289,1554),(31290,1555),(31291,1556),(31292,1612),(31293,1655),(31294,1656),(31295,1764),(31296,1777),(31297,1584),(31298,1585),(31299,1586),(31300,1730),(31301,1731),(31302,1796),(31303,1478),(31304,1481),(31305,1482),(31306,1484),(31307,1516),(31308,1705),(31309,5753),(31310,5753),(31311,5753),(31312,5753),(31313,5753),(31314,5753),(31315,5753),(31316,5753),(31317,5754),(31318,5754),(31319,5754),(31320,5754),(31321,5754),(31322,5754),(31323,5754),(31324,5754),(31325,5754),(31326,5755),(31327,5755),(31328,5755),(31329,5755),(31330,5755),(31331,5755),(31332,5755),(31333,5755),(31334,5755),(31335,5756),(31336,5756),(31337,5756),(31338,5756),(31339,5756),(31340,5756),(31341,5756),(31342,5756),(31343,5756),(31344,5753),(31345,1479),(31346,1480),(31347,1483),(31348,1502),(31349,1515),(31350,1616),(31351,1617),(31352,1548),(31353,1549),(31354,1551),(31355,1552),(31356,1560),(31357,1706),(31358,1741),(31359,1765),(31360,1783),(31361,1496),(31362,1547),(31363,1550),(31364,1614),(31365,1716),(31366,1726),(31367,1736),(31368,5278),(31369,5279),(31370,5280),(31371,5281),(31372,5295),(31373,5470),(31374,5473),(31375,5538),(31376,5539),(31377,5549),(31378,5550),(31379,5607),(31380,5701),(31381,5353),(31382,5469),(31383,5687),(31384,5712),(31385,5748),(31386,1739),(31387,1772),(31388,5310),(31389,5311),(31390,5312),(31391,5315),(31392,5318),(31393,5321),(31394,5322),(31395,5309),(31396,5313),(31397,5314),(31398,5316),(31399,5317),(31400,5319),(31401,1140),(31402,5689),(31403,5696),(31404,1154),(31405,4530),(31406,4535),(31407,4536),(31408,5256),(31409,5257),(31410,5284),(31411,5320),(31412,4622),(31413,4623),(31414,4624),(31415,4853),(31416,4854),(31417,4855),(31418,4881),(31419,4889),(31420,5282),(31421,5283),(31422,4526),(31423,4527),(31424,4531),(31425,4533),(31426,4534),(31427,4877),(31428,4878),(31429,4879),(31430,4886),(31431,4887),(31432,4888),(31433,5259),(31434,5260),(31435,5261),(31436,5262),(31437,5263),(31438,4882),(31439,4883),(31440,5264),(31441,5265),(31442,5266),(31443,5267),(31444,5268),(31445,5269),(31446,5270),(31447,1151),(31448,1152),(31449,1153),(31450,1155),(31451,1156),(31452,4890),(31453,4897),(31454,5171),(31455,5258),(31456,5435),(31457,5436),(31458,5437),(31459,5438),(31460,5439),(31461,5440),(31462,5441),(31463,5443),(31464,5444),(31465,5285),(31466,5296),(31467,5297),(31468,5338),(31469,5339),(31470,5340),(31471,5431),(31472,5442),(31473,5341),(31474,5342),(31475,5345),(31476,5346),(31477,5347),(31478,5348),(31479,5349),(31480,5350),(31481,5535),(31482,5674),(31483,5675),(31484,5676),(31485,5677),(31486,5679),(31487,5369),(31488,5402),(31489,5531),(31490,5532),(31491,5537),(31492,5615),(31493,5752),(31494,5403),(31495,5412),(31496,5423),(31497,5445),(31498,5446),(31499,5447),(31500,5448),(31501,5450),(31502,5546),(31503,5547),(31504,5606),(31505,5690),(31506,5288),(31507,5290),(31508,5292),(31509,5293),(31510,5680),(31511,5681),(31512,5697),(31513,5698),(31514,5710),(31515,5294),(31516,5411),(31517,5611),(31518,5614),(31519,5620),(31520,5683),(31521,5709),(31522,5747),(31523,5749),(31524,5471),(31525,5472),(31526,5533),(31527,5534),(31528,5535),(31529,5609),(31530,5682),(31531,5685),(31532,5745),(31533,5746),(31534,5674),(31535,5675),(31536,5676),(31537,5677),(31538,5678),(31539,5679),(31540,5369),(31541,5402),(31542,5531),(31543,5532),(31544,5537),(31545,5752),(31546,5277),(31547,5415),(31548,5416),(31549,5417),(31550,5547),(31551,5567),(31552,5680),(31553,5681),(31554,5691),(31555,5699),(31556,5275),(31557,5276),(31558,5542),(31559,5543),(31560,5608),(31561,5610),(31562,5612),(31563,5684),(31564,5686),(31565,5338),(31566,5339),(31567,5340),(31568,5341),(31569,5342),(31570,5410),(31571,5544),(31572,5545),(31573,5688),(31574,5345),(31575,5346),(31576,5347),(31577,5348),(31578,5349),(31579,5350),(31580,5369),(31581,5531),(31582,5532),(31583,5535),(31584,5738),(31585,5417),(31586,5567),(31587,1615),(31588,5563),(31589,5688),(31590,5608),(31591,5291),(31592,5558),(31593,5564),(31594,5566),(31595,5605),(31596,5608),(31597,5612),(31598,5684),(31599,5686),(31600,5688),(31601,5691),(31602,5290),(31603,5345),(31604,5346),(31605,5347),(31606,5348),(31607,5349),(31608,5350),(31609,5594),(31610,5599),(31611,5600),(31612,5601),(31613,5604),(31614,5693),(31615,5285),(31616,5413),(31617,5414),(31618,5418),(31619,5419),(31620,5548),(31621,5593),(31622,5692),(31623,5694),(31624,5700),(31625,5286),(31626,5296),(31627,5297),(31628,5298),(31629,5541),(31630,5711),(31631,5443),(31632,5289),(31633,5302),(31634,5442),(31635,5591),(31636,5595),(31637,5602),(31638,5603),(31639,5613),(31640,5618),(31641,5733),(31642,5431),(31643,5435),(31644,5436),(31645,5437),(31646,5438),(31647,5439),(31648,5440),(31649,5441),(31650,5444),(31651,5408),(31652,5420),(31653,5553),(31654,5554),(31655,5555),(31656,5556),(31657,5557),(31658,5599),(31659,5600),(31660,5601),(31661,5615),(31662,5618),(31663,5540),(31664,5553),(31665,5554),(31666,5555),(31667,5556),(31668,5557),(31669,5571),(31670,5592),(31671,5596),(31672,5597),(31673,1148),(31674,5452),(31675,5659),(31676,5661),(31677,2540),(31678,2541),(31679,2542),(31680,5357),(31681,5630),(31682,5631),(31683,5632),(31684,5633),(31685,5634),(31686,1162),(31687,1162),(31688,1162),(31689,4894),(31690,4894),(31691,4894),(31692,1164),(31693,1164),(31694,1164),(31695,2176),(31696,2176),(31697,2176),(31698,224),(31699,225),(31700,226),(31701,227),(31702,228),(31703,235),(31704,236),(31705,237),(31706,238),(31707,239),(31708,163),(31709,165),(31710,167),(31711,168),(31712,229),(31713,230),(31714,231),(31715,232),(31716,233),(31717,234),(31718,7),(31719,39),(31720,40),(31721,41),(31722,42),(31723,43),(31724,44),(31725,141),(31726,143),(31727,144),(31728,146),(31729,150),(31730,151),(31731,8),(31732,9),(31733,10),(31734,11),(31735,12),(31736,13),(31737,14),(31738,23),(31739,24),(31740,25),(31741,27),(31742,28),(31743,29),(31744,30),(31745,32),(31746,37),(31747,38),(31748,45),(31749,46),(31750,47),(31751,53),(31752,66),(31753,70),(31754,78),(31755,79),(31756,80),(31757,81),(31758,54),(31759,55),(31760,61),(31761,62),(31762,82),(31763,83),(31764,84),(31765,85),(31766,86),(31767,87),(31768,88),(31769,90),(31770,56),(31771,57),(31772,59),(31773,60),(31774,91),(31775,92),(31776,58),(31777,93),(31778,95),(31779,122),(31780,133),(31781,134),(31782,135),(31783,136),(31784,137),(31785,16),(31786,94),(31787,145),(31788,147),(31789,148),(31790,153),(31791,164),(31792,166),(31793,172),(31794,256),(31795,257),(31796,100),(31797,104),(31798,138),(31799,154),(31800,155),(31801,244),(31802,251),(31803,139),(31804,160),(31805,161),(31806,169),(31807,171),(31808,173),(31809,175),(31810,221),(31811,222),(31812,223),(31813,276),(31814,277),(31815,278),(31816,279),(31817,240),(31818,241),(31819,242),(31820,243),(31821,254),(31822,255),(31823,258),(31824,259),(31825,260),(31826,261),(31827,280),(31828,106),(31829,162),(31830,262),(31831,263),(31832,264),(31833,265),(31834,110),(31835,111),(31836,112),(31837,114),(31838,115),(31839,116),(31840,157),(31841,159),(31842,188),(31843,189),(31844,48),(31845,49),(31846,50),(31847,51),(31848,52),(31849,106),(31850,123),(31851,124),(31852,125),(31853,126),(31854,140),(31855,156),(31856,158),(31857,255),(31858,245),(31859,268),(31860,269),(31861,270),(31862,271),(31863,272),(31864,273),(31865,274),(31866,275),(31867,4524),(31868,176),(31869,177),(31870,178),(31871,180),(31872,183),(31873,184),(31874,185),(31875,186),(31876,179),(31877,181),(31878,187),(31879,188),(31880,189),(31881,206),(31882,207),(31883,208),(31884,162),(31885,190),(31886,193),(31887,194),(31888,195),(31889,196),(31890,197),(31891,202),(31892,209),(31893,210),(31894,139),(31895,169),(31896,173),(31897,175),(31898,221),(31899,222),(31900,223),(31901,5465),(31902,5466),(31903,5467),(31904,5525),(31905,5551),(31906,5552),(31907,5561),(31908,5562),(31909,5565),(31910,5572),(31911,5573),(31912,5574),(31913,5575),(31914,5576),(31915,5578),(31916,5579),(31917,5582),(31918,5583),(31919,5584),(31920,5456),(31921,5459),(31922,5460),(31923,5462),(31924,5577),(31925,5580),(31926,5581),(31927,5585),(31928,5702),(31929,5703),(31930,5707),(31931,5708),(31932,1145),(31933,1146),(31934,1147),(31935,5271),(31936,5272),(31937,5273),(31938,5655),(31939,5656),(31940,5657),(31941,5385),(31942,5433),(31943,5451),(31944,5453),(31945,5454),(31946,5455),(31947,5468),(31948,5301),(31949,2276),(31950,4552),(31951,4561),(31952,4564),(31953,4565),(31954,5155),(31955,5248),(31956,5249),(31957,5154),(31958,4545),(31959,4562),(31960,5151),(31961,5152),(31962,4539),(31963,4543),(31964,4544),(31965,4546),(31966,4970),(31967,5153),(31968,5157),(31969,5158),(31970,5183),(31971,2389),(31972,4540),(31973,4541),(31974,4542),(31975,4547),(31976,4548),(31977,4549),(31978,4550),(31979,4551),(31980,4553),(31981,4554),(31982,4555),(31983,4556),(31984,4557),(31985,4558),(31986,4559),(31987,4560),(31988,4539),(31989,4545),(31990,4547),(31991,4548),(31992,4549),(31993,4552),(31994,4553),(31995,4563),(31996,5151),(31997,5152),(31998,5153),(31999,5156),(32000,5157),(32001,5158),(32002,5248),(32003,4539),(32004,4545),(32005,4552),(32006,4561),(32007,4562),(32008,4564),(32009,4565),(32010,4970),(32011,5249),(32012,4543),(32013,4544),(32014,4546),(32015,4547),(32016,4548),(32017,4549),(32018,4550),(32019,4551),(32020,4553),(32021,4554),(32022,4555),(32023,4540),(32024,4541),(32025,4542),(32026,4556),(32027,4557),(32028,4558),(32029,4559),(32030,4560),(32031,5183),(32032,5154),(32033,5155),(32034,1615),(32035,1775),(32036,1615),(32037,1775),(32038,1615),(32039,1775),(32040,2289),(32041,4492),(32042,4493),(32043,4494),(32044,4529),(32045,4884),(32046,4885),(32047,1158),(32048,1159),(32049,4495),(32050,4496),(32051,4497),(32052,4498),(32053,4499),(32054,4532),(32055,4537),(32056,4877),(32057,4878),(32058,4879),(32059,4880),(32060,5257),(32061,1160),(32062,1161),(32063,4491),(32064,4528),(32065,1866),(32066,1867),(32067,1868),(32068,1875),(32069,1876),(32070,1877),(32071,1878),(32072,1879),(32073,1880),(32074,1881),(32075,1882),(32076,1883),(32077,1884),(32078,1936),(32079,1937),(32080,1938),(32081,1992),(32082,1993),(32083,1493),(32084,1994),(32085,1995),(32086,1996),(32087,1997),(32088,1998),(32089,1999),(32090,2000),(32091,2001),(32092,2002),(32093,2289),(32094,2290),(32095,1836),(32096,1843),(32097,1848),(32098,1856),(32099,1860),(32100,1862),(32101,1869),(32102,1885),(32103,2291),(32104,2293),(32105,1886),(32106,1898),(32107,1913),(32108,1930),(32109,1939),(32110,1940),(32111,1945),(32112,5524),(32113,2330),(32114,2331),(32115,2332),(32116,2333),(32117,2334),(32118,2335),(32119,2336),(32120,2341),(32121,2342),(32122,2343),(32123,2133),(32124,2134),(32125,2139),(32126,2140),(32127,2141),(32128,2142),(32129,2337),(32130,2338),(32131,2339),(32132,2340),(32133,3515),(32134,4552),(32135,2143),(32136,2144),(32137,2145),(32138,2146),(32139,2147),(32140,2148),(32141,2149),(32142,2150),(32143,2151),(32144,2152),(32145,2153),(32146,2325),(32147,2326),(32148,2327),(32149,2328),(32150,2329),(32151,2344),(32152,2345),(32153,2346),(32154,2347),(32155,2348),(32156,2349),(32157,2350),(32158,2351),(32159,2352),(32160,2353),(32161,2354),(32162,2355),(32163,2356),(32164,2357),(32165,2358),(32166,2359),(32167,2360),(32168,2361),(32169,2362),(32170,2363),(32171,2364),(32172,2365),(32173,2366),(32174,2367),(32175,2368),(32176,2369),(32177,2370),(32178,2371),(32179,2372),(32180,2373),(32181,2374),(32182,2515),(32183,2516),(32184,1959),(32185,1960),(32186,1961),(32187,1963),(32188,1964),(32189,2413),(32190,2414),(32191,2415),(32192,2416),(32193,2417),(32194,2418),(32195,2419),(32196,2420),(32197,2421),(32198,2422),(32199,2423),(32200,2424),(32201,2425),(32202,2426),(32203,2537),(32204,2538),(32205,2816),(32206,2818),(32207,4550),(32208,4551),(32209,4553),(32210,4554),(32211,4555),(32212,4558),(32213,2002),(32214,2275),(32215,2379),(32216,2383),(32217,2384),(32218,2390),(32219,2559),(32220,4559),(32221,2375),(32222,2376),(32223,2380),(32224,2381),(32225,2387),(32226,2454),(32227,2455),(32228,2456),(32229,2135),(32230,2136),(32231,2137),(32232,2138),(32233,2382),(32234,3549),(32235,3550),(32236,3581),(32237,3582),(32238,2026),(32239,2027),(32240,2028),(32241,2029),(32242,2034),(32243,2039),(32244,2040),(32245,2030),(32246,2031),(32247,2032),(32248,2042),(32249,2044),(32250,2045),(32251,2046),(32252,2122),(32253,2123),(32254,2124),(32255,2125),(32256,2377),(32257,2378),(32258,2385),(32259,2386),(32260,2388),(32261,2389),(32262,2391),(32263,2133),(32264,2134),(32265,2139),(32266,2140),(32267,2141),(32268,2142),(32269,2143),(32270,2144),(32271,2145),(32272,2146),(32273,2147),(32274,2148),(32275,2149),(32276,2150),(32277,2151),(32278,2152),(32279,2153),(32280,2325),(32281,2326),(32282,2327),(32283,2328),(32284,2329),(32285,2355),(32286,2356),(32287,2357),(32288,2358),(32289,2359),(32290,2360),(32291,2361),(32292,2362),(32293,2363),(32294,2364),(32295,2365),(32296,2366),(32297,2367),(32298,2368),(32299,2369),(32300,2370),(32301,2371),(32302,2372),(32303,2275),(32304,2373),(32305,2374),(32306,2417),(32307,2418),(32308,2419),(32309,2420),(32310,2421),(32311,2422),(32312,2423),(32313,2424),(32314,2425),(32315,2426),(32316,2537),(32317,2538),(32318,2135),(32319,2375),(32320,2376),(32321,2379),(32322,2380),(32323,2381),(32324,2383),(32325,2384),(32326,2387),(32327,2390),(32328,2456),(32329,2559),(32330,2136),(32331,2137),(32332,2138),(32333,2377),(32334,2378),(32335,2385),(32336,2386),(32337,2388),(32338,2391),(32339,2330),(32340,2331),(32341,2332),(32342,2333),(32343,2334),(32344,2335),(32345,2336),(32346,2340),(32347,2341),(32348,2342),(32349,2343),(32350,2337),(32351,2338),(32352,2339),(32353,2344),(32354,2345),(32355,2346),(32356,2347),(32357,2348),(32358,2349),(32359,1959),(32360,1960),(32361,1961),(32362,1963),(32363,1964),(32364,2350),(32365,2351),(32366,2352),(32367,2353),(32368,2354),(32369,2413),(32370,2414),(32371,2515),(32372,2516),(32373,2026),(32374,2027),(32375,2028),(32376,2029),(32377,2034),(32378,2039),(32379,2382),(32380,2415),(32381,2416),(32382,2454),(32383,2455),(32384,2030),(32385,2031),(32386,2040),(32387,2042),(32388,2044),(32389,2045),(32390,2046),(32391,2032),(32392,2122),(32393,2123),(32394,2124),(32395,2125),(32396,2389),(32397,4608),(32398,4837),(32399,4942),(32400,5029),(32401,5030),(32402,5031),(32403,5032),(32404,5033),(32405,4955),(32406,4956),(32407,4967),(32408,5097),(32409,5100),(32410,5111),(32411,5116),(32412,5117),(32413,5119),(32414,5120),(32415,5121),(32416,1658),(32417,1659),(32418,1660),(32419,4818),(32420,4820),(32421,5118),(32422,4718),(32423,4838),(32424,5028),(32425,4730),(32426,4812),(32427,4813),(32428,4815),(32429,4822),(32430,4845),(32431,4942),(32432,4589),(32433,4590),(32434,4591),(32435,4592),(32436,4593),(32437,4594),(32438,4595),(32439,4596),(32440,4597),(32441,4598),(32442,4599),(32443,4818),(32444,4820),(32445,4841),(32446,4842),(32447,5101),(32448,5113),(32449,4582),(32450,4583),(32451,4584),(32452,4585),(32453,4586),(32454,4587),(32455,4834),(32456,4835),(32457,4836),(32458,4608),(32459,5116),(32460,5117),(32461,5118),(32462,5119),(32463,5120),(32464,4588),(32465,4600),(32466,4601),(32467,4602),(32468,4603),(32469,5029),(32470,5030),(32471,5031),(32472,5032),(32473,5033),(32474,4604),(32475,4608),(32476,4718),(32477,4839),(32478,4840),(32479,5097),(32480,5110),(32481,5111),(32482,4816),(32483,4967),(32484,5100),(32485,5250),(32486,5739),(32487,5740),(32488,5741),(32489,5742),(32490,5743),(32491,5744),(32492,1651),(32493,1652),(32494,1653),(32495,5103),(32496,5104),(32497,5251),(32498,5252),(32499,5253),(32500,5255),(32501,1650),(32502,1703),(32503,1704),(32504,1737),(32505,1738),(32506,4612),(32507,5254),(32508,4813),(32509,4837),(32510,4955),(32511,4956),(32512,5097),(32513,5098),(32514,5101),(32515,5110),(32516,5111),(32517,5116),(32518,4730),(32519,4812),(32520,4818),(32521,4822),(32522,4845),(32523,5117),(32524,5118),(32525,1687),(32526,1780),(32527,1660),(32528,1689),(32529,1692),(32530,1695),(32531,5090),(32532,1691),(32533,1687),(32534,1689),(32535,1691),(32536,1692),(32537,1695),(32538,1696),(32539,1750),(32540,1759),(32541,1760),(32542,5090),(32543,1659),(32544,1688),(32545,1740),(32546,1743),(32547,1690),(32548,4838),(32549,5028),(32550,5098),(32551,5099),(32552,5121),(32553,4812),(32554,4813),(32555,4814),(32556,4815),(32557,4817),(32558,4942),(32559,4969),(32560,5461),(32561,4821),(32562,4822),(32563,5093),(32564,5094),(32565,5095),(32566,5096),(32567,4589),(32568,4590),(32569,4591),(32570,4592),(32571,4593),(32572,4594),(32573,5034),(32574,5035),(32575,5036),(32576,4595),(32577,4596),(32578,4597),(32579,4598),(32580,4599),(32581,4718),(32582,4841),(32583,4842),(32584,5101),(32585,4819),(32586,5078),(32587,5080),(32588,5081),(32589,5084),(32590,5102),(32591,5112),(32592,4582),(32593,4583),(32594,4584),(32595,4585),(32596,4586),(32597,4587),(32598,4834),(32599,4835),(32600,4836),(32601,2219),(32602,2220),(32603,2261),(32604,2307),(32605,2308),(32606,2310),(32607,2251),(32608,2260),(32609,2309),(32610,2312),(32611,2313),(32612,2314),(32613,2316),(32614,2461),(32615,2259),(32616,2460),(32617,2462),(32618,2463),(32619,2504),(32620,2505),(32621,2201),(32622,2202),(32623,2214),(32624,2215),(32625,2216),(32626,2217),(32627,2218),(32628,2187),(32629,2188),(32630,2190),(32631,2192),(32632,2194),(32633,2197),(32634,2232),(32635,2233),(32636,2234),(32637,2237),(32638,2238),(32639,2236),(32640,2392),(32641,2393),(32642,2394),(32643,2395),(32644,2411),(32645,2412),(32646,2577),(32647,2578),(32648,2579),(32649,2580),(32650,5123),(32651,5124),(32652,5125),(32653,5126),(32654,5127),(32655,5129),(32656,5130),(32657,5131),(32658,5148),(32659,5149),(32660,5150),(32661,2256),(32662,2305),(32663,5128),(32664,5136),(32665,5167),(32666,2208),(32667,2209),(32668,2304),(32669,2458),(32670,2459),(32671,2503),(32672,4860),(32673,5203),(32674,5204),(32675,5205),(32676,5230),(32677,5105),(32678,5207),(32679,5208),(32680,5209),(32681,5210),(32682,5212),(32683,5213),(32684,5214),(32685,5215),(32686,5216),(32687,5217),(32688,5218),(32689,5229),(32690,5234),(32691,5235),(32692,5236),(32693,4714),(32694,4715),(32695,4716),(32696,4717),(32697,4724),(32698,4809),(32699,4810),(32700,4811),(32701,4843),(32702,4851),(32703,5237),(32704,4668),(32705,4669),(32706,4688),(32707,4689),(32708,4691),(32709,4693),(32710,4696),(32711,4698),(32712,4699),(32713,4700),(32714,4705),(32715,4706),(32716,4707),(32717,4708),(32718,4709),(32719,4636),(32720,4638),(32721,4641),(32722,4642),(32723,4643),(32724,4644),(32725,4674),(32726,4675),(32727,4690),(32728,4692),(32729,4694),(32730,4697),(32731,4710),(32732,4712),(32733,4645),(32734,4646),(32735,4647),(32736,4648),(32737,4649),(32738,4652),(32739,4654),(32740,4656),(32741,4657),(32742,4658),(32743,4659),(32744,4660),(32745,4661),(32746,4662),(32747,4663),(32748,4665),(32749,4667),(32750,5045),(32751,5046),(32752,5055),(32753,5056),(32754,5060),(32755,5061),(32756,5041),(32757,5043),(32758,5047),(32759,5048),(32760,5049),(32761,5050),(32762,5051),(32763,5052),(32764,5054),(32765,5057),(32766,5058),(32767,5059),(32768,2399),(32769,2400),(32770,2401),(32771,2403),(32772,2591),(32773,2592),(32774,2605),(32775,4628),(32776,4731),(32777,4734),(32778,4739),(32779,4744),(32780,4747),(32781,4748),(32782,4757),(32783,4766),(32784,4767),(32785,4768),(32786,4773),(32787,4774),(32788,4775),(32789,4776),(32790,4781),(32791,2204),(32792,2205),(32793,2206),(32794,2318),(32795,2321),(32796,2322),(32797,4613),(32798,4614),(32799,4769),(32800,4782),(32801,4783),(32802,4784),(32803,4790),(32804,4792),(32805,4794),(32806,4796),(32807,4802),(32808,4873),(32809,2200),(32810,2210),(32811,2614),(32812,4639),(32813,4664),(32814,4680),(32815,4719),(32816,4952),(32817,5202),(32818,5211),(32819,5220),(32820,5224),(32821,5225),(32822,2163),(32823,2248),(32824,2270),(32825,2271),(32826,2300),(32827,2301),(32828,2311),(32829,2440),(32830,2441),(32831,2442),(32832,2489),(32833,2497),(32834,2506),(32835,2507),(32836,2508),(32837,2509),(32838,2511),(32839,2512),(32840,2609),(32841,4722),(32842,4740),(32843,4770),(32844,5044),(32845,5053),(32846,5065),(32847,5066),(32848,5072),(32849,2024),(32850,2226),(32851,2472),(32852,2473),(32853,2475),(32854,2476),(32855,2490),(32856,2491),(32857,4764),(32858,4872),(32859,4957),(32860,4958),(32861,4959),(32862,4960),(32863,4961),(32864,4962),(32865,1711),(32866,4777),(32867,4778),(32868,4779),(32869,4780),(32870,2311),(32871,4764),(32872,4957),(32873,4958),(32874,4959),(32875,4960),(32876,4961),(32877,4962),(32878,5106),(32879,5107),(32880,5108),(32881,5109),(32882,2251),(32883,2260),(32884,2307),(32885,2308),(32886,2309),(32887,2310),(32888,2312),(32889,2313),(32890,2314),(32891,2316),(32892,2188),(32893,2190),(32894,2192),(32895,2194),(32896,2197),(32897,2460),(32898,2461),(32899,2462),(32900,2463),(32901,2504),(32902,2505),(32903,2187),(32904,2245),(32905,2256),(32906,2304),(32907,2305),(32908,2306),(32909,2315),(32910,2396),(32911,2411),(32912,2412),(32913,2458),(32914,2459),(32915,2503),(32916,2577),(32917,2578),(32918,2579),(32919,2580),(32920,2191),(32921,2193),(32922,2195),(32923,2198),(32924,2235),(32925,2240),(32926,2246),(32927,2257),(32928,2302),(32929,2303),(32930,2311),(32931,2581),(32932,5123),(32933,5124),(32934,5130),(32935,5131),(32936,5148),(32937,5149),(32938,5150),(32939,5125),(32940,5126),(32941,5127),(32942,5128),(32943,5129),(32944,5136),(32945,5167),(32946,5203),(32947,5204),(32948,5205),(32949,5217),(32950,5229),(32951,5230),(32952,5105),(32953,5207),(32954,5208),(32955,5209),(32956,5210),(32957,5212),(32958,5213),(32959,5214),(32960,5215),(32961,5216),(32962,5218),(32963,5234),(32964,5235),(32965,4714),(32966,4715),(32967,4716),(32968,4717),(32969,4724),(32970,4809),(32971,4810),(32972,4811),(32973,5236),(32974,5237),(32975,4719),(32976,4722),(32977,4843),(32978,4851),(32979,4873),(32980,5166),(32981,5202),(32982,5211),(32983,5220),(32984,5224),(32985,5225),(32986,5122),(32987,5137),(32988,5138),(32989,5139),(32990,5142),(32991,5147),(32992,5159),(32993,5160),(32994,5161),(32995,5163),(32996,5164),(32997,5168),(32998,5222),(32999,5231),(33000,5232),(33001,5233),(33002,4720),(33003,4723),(33004,4846),(33005,4847),(33006,4848),(33007,4849),(33008,4850),(33009,4852),(33010,4856),(33011,5141),(33012,5206),(33013,5219),(33014,5221),(33015,5223),(33016,5226),(33017,5227),(33018,5228),(33019,4721),(33020,4725),(33021,4726),(33022,4727),(33023,4728),(33024,4729),(33025,4777),(33026,4844),(33027,5140),(33028,5162),(33029,5165),(33030,4778),(33031,4779),(33032,4780),(33033,4823),(33034,4872),(33035,5106),(33036,5107),(33037,5108),(33038,5109),(33039,2245),(33040,2201),(33041,2202),(33042,2214),(33043,2215),(33044,2216),(33045,2217),(33046,2218),(33047,2219),(33048,2220),(33049,2232),(33050,2233),(33051,2234),(33052,2236),(33053,2237),(33054,2238),(33055,2251),(33056,2259),(33057,2260),(33058,2261),(33059,2200),(33060,2208),(33061,2209),(33062,2210),(33063,2246),(33064,2256),(33065,2258),(33066,2392),(33067,2393),(33068,2394),(33069,2395),(33070,2396),(33071,2459),(33072,4621),(33073,4627),(33074,4628),(33075,1575),(33076,1576),(33077,1577),(33078,1580),(33079,1581),(33080,1582),(33081,1583),(33082,1708),(33083,1709),(33084,1710),(33085,1711),(33086,1712),(33087,1714),(33088,1578),(33089,1579),(33090,1713),(33091,2265),(33092,2266),(33093,2267),(33094,2268),(33095,2269),(33096,2276),(33097,2320),(33098,2397),(33099,2398),(33100,2400),(33101,2401),(33102,2403),(33103,2405),(33104,2406),(33105,2407),(33106,2408),(33107,2409),(33108,2410),(33109,2589),(33110,2590),(33111,2591),(33112,2592),(33113,2593),(33114,2594),(33115,2595),(33116,2598),(33117,2599),(33118,2600),(33119,2601),(33120,2602),(33121,2603),(33122,2604),(33123,2605),(33124,2606),(33125,2607),(33126,2318),(33127,2319),(33128,2321),(33129,2322),(33130,2608),(33131,2610),(33132,2611),(33133,2612),(33134,2613),(33135,2317),(33136,2596),(33137,2597),(33138,2609),(33139,2614),(33140,2399),(33141,4860),(33142,4668),(33143,4688),(33144,4689),(33145,4691),(33146,4693),(33147,4696),(33148,4698),(33149,4699),(33150,4700),(33151,4705),(33152,4706),(33153,4669),(33154,4690),(33155,4694),(33156,4697),(33157,4707),(33158,4708),(33159,4709),(33160,4710),(33161,4712),(33162,4636),(33163,4638),(33164,4641),(33165,4642),(33166,4643),(33167,4644),(33168,4645),(33169,4646),(33170,4647),(33171,4648),(33172,4674),(33173,4675),(33174,4692),(33175,4649),(33176,4652),(33177,4654),(33178,4656),(33179,4657),(33180,4658),(33181,4659),(33182,4660),(33183,4661),(33184,4662),(33185,4663),(33186,4665),(33187,4667),(33188,5045),(33189,5046),(33190,5047),(33191,5048),(33192,5049),(33193,5051),(33194,5052),(33195,5055),(33196,5056),(33197,5057),(33198,5058),(33199,5060),(33200,5061),(33201,2605),(33202,4731),(33203,4734),(33204,4739),(33205,4744),(33206,4747),(33207,4748),(33208,4757),(33209,5041),(33210,5043),(33211,5050),(33212,5054),(33213,5059),(33214,4613),(33215,4614),(33216,4639),(33217,4664),(33218,4680),(33219,4766),(33220,4767),(33221,4768),(33222,4769),(33223,4773),(33224,4774),(33225,4775),(33226,4776),(33227,4781),(33228,4782),(33229,4783),(33230,4784),(33231,4790),(33232,4792),(33233,4794),(33234,4796),(33235,4802),(33236,4804),(33237,4952),(33238,4676),(33239,4687),(33240,4695),(33241,4701),(33242,4702),(33243,4703),(33244,4704),(33245,4740),(33246,5044),(33247,5053),(33248,5065),(33249,5066),(33250,5072),(33251,4673),(33252,4711),(33253,4713),(33254,4944),(33255,4949),(33256,4953),(33257,4637),(33258,4640),(33259,4650),(33260,4651),(33261,4655),(33262,4666),(33263,4943),(33264,4945),(33265,4946),(33266,4947),(33267,4948),(33268,4950),(33269,4951),(33270,4635),(33271,4653),(33272,4671),(33273,4735),(33274,4741),(33275,4742),(33276,4754),(33277,4759),(33278,4762),(33279,4763),(33280,4771),(33281,4786),(33282,4795),(33283,4857),(33284,4858),(33285,4859),(33286,4861),(33287,4867),(33288,4868),(33289,5039),(33290,5040),(33291,5042),(33292,5070),(33293,5071),(33294,4629),(33295,4630),(33296,4631),(33297,4632),(33298,4633),(33299,4634),(33300,4670),(33301,4672),(33302,4770),(33303,4862),(33304,4863),(33305,4864),(33306,4865),(33307,4866),(33308,4876),(33309,5069),(33310,4732),(33311,4736),(33312,4746),(33313,4758),(33314,4760),(33315,4787),(33316,4789),(33317,4797),(33318,4799),(33319,5067),(33320,5068),(33321,4743),(33322,4749),(33323,4750),(33324,4751),(33325,4752),(33326,4753),(33327,4761),(33328,4772),(33329,4785),(33330,4788),(33331,4798),(33332,4800),(33333,4801),(33334,4803),(33335,4733),(33336,4737),(33337,4738),(33338,4745),(33339,4755),(33340,4764),(33341,4765),(33342,4791),(33343,4793),(33344,4954),(33345,4957),(33346,4958),(33347,4959),(33348,4960),(33349,4961),(33350,4962),(33351,4756),(33352,4869),(33353,4870),(33354,4871),(33355,4874),(33356,4875),(33357,4891),(33358,4892),(33359,4893),(33360,4894),(33361,4895),(33362,1791),(33363,1792),(33364,1798),(33365,1803),(33366,1805),(33367,1806),(33368,1807),(33369,1808),(33370,1809),(33371,1810),(33372,1811),(33373,1748),(33374,1791),(33375,1792),(33376,1798),(33377,1803),(33378,1804),(33379,1805),(33380,1809),(33381,1806),(33382,1807),(33383,1808),(33384,1810),(33385,1811),(33386,5178),(33387,5180),(33388,5181),(33389,5191),(33390,5192),(33391,5193),(33392,5178),(33393,5179),(33394,5180),(33395,5182),(33396,5190),(33397,5192),(33398,5194),(33399,5197),(33400,5181),(33401,5191),(33402,5193),(33403,5195),(33404,5196),(33405,5199),(33406,4971),(33407,4973),(33408,4974),(33409,4976),(33410,4977),(33411,4982),(33412,4992),(33413,4993),(33414,4994),(33415,5009),(33416,5025),(33417,4972),(33418,4979),(33419,4980),(33420,4981),(33421,4983),(33422,4984),(33423,4985),(33424,4986),(33425,4987),(33426,4988),(33427,4989),(33428,4990),(33429,4991),(33430,5001),(33431,5002),(33432,4995),(33433,4996),(33434,4997),(33435,4998),(33436,4999),(33437,5000),(33438,5005),(33439,5008),(33440,5011),(33441,5012),(33442,5019),(33443,4975),(33444,4978),(33445,5003),(33446,5004),(33447,5006),(33448,5007),(33449,5010),(33450,5013),(33451,5014),(33452,5015),(33453,5016),(33454,5022),(33455,5024),(33456,4972),(33457,4973),(33458,4976),(33459,4977),(33460,4983),(33461,4984),(33462,4985),(33463,4986),(33464,4987),(33465,4988),(33466,4989),(33467,4990),(33468,4991),(33469,4996),(33470,4998),(33471,5002),(33472,4997),(33473,4999),(33474,5000),(33475,5005),(33476,5008),(33477,5011),(33478,5012),(33479,5013),(33480,5014),(33481,5015),(33482,5016),(33483,4971),(33484,4981),(33485,4982),(33486,4992),(33487,4993),(33488,4994),(33489,5001),(33490,5009),(33491,5025),(33492,4979),(33493,4980),(33494,4995),(33495,5003),(33496,5004),(33497,5006),(33498,5007),(33499,5010),(33500,5019),(33501,5022),(33502,5024),(33503,4896),(33504,4898),(33505,4899),(33506,4900),(33507,4901),(33508,4902),(33509,4903),(33510,4904),(33511,4905),(33512,4906),(33513,4907),(33514,4908),(33515,4909),(33516,4910),(33517,4911),(33518,4972),(33519,1679),(33520,1680),(33521,5021),(33522,5023),(33523,5026),(33524,5027),(33525,4973),(33526,4975),(33527,4976),(33528,4977),(33529,4978),(33530,2036),(33531,2086),(33532,2088),(33533,2174),(33534,2204),(33535,2252),(33536,2087),(33537,2094),(33538,2095),(33539,2096),(33540,2205),(33541,2206),(33542,2296),(33543,2510),(33544,2543),(33545,1953),(33546,1954),(33547,1955),(33548,2064),(33549,2089),(33550,2159),(33551,2494),(33552,2495),(33553,2497),(33554,2059),(33555,2103),(33556,2106),(33557,2107),(33558,2108),(33559,2109),(33560,2110),(33561,2111),(33562,2112),(33563,2452),(33564,2555),(33565,2621),(33566,2104),(33567,2163),(33568,2248),(33569,2270),(33570,2271),(33571,2441),(33572,2442),(33573,2477),(33574,2478),(33575,2479),(33576,2507),(33577,2508),(33578,2509),(33579,2025),(33580,2226),(33581,2230),(33582,2300),(33583,2301),(33584,2472),(33585,2473),(33586,2475),(33587,2476),(33588,2489),(33589,2490),(33590,2491),(33591,2511),(33592,2512),(33593,1816),(33594,1818),(33595,1822),(33596,1827),(33597,1965),(33598,1966),(33599,2008),(33600,2013),(33601,2014),(33602,1972),(33603,1973),(33604,1974),(33605,1977),(33606,1978),(33607,1983),(33608,1984),(33609,1986),(33610,1988),(33611,2035),(33612,2037),(33613,2041),(33614,1975),(33615,1976),(33616,1979),(33617,1980),(33618,1982),(33619,1985),(33620,1987),(33621,1989),(33622,1990),(33623,1813),(33624,1814),(33625,1815),(33626,1820),(33627,1821),(33628,1824),(33629,1825),(33630,1826),(33631,1817),(33632,1819),(33633,1823),(33634,1828),(33635,1981),(33636,2021),(33637,2022),(33638,2154),(33639,2177),(33640,2221),(33641,2222),(33642,2299),(33643,2435),(33644,2531),(33645,2540),(33646,2541),(33647,2542),(33648,2066),(33649,2067),(33650,2068),(33651,2069),(33652,2078),(33653,2100),(33654,2165),(33655,2166),(33656,2169),(33657,2070),(33658,2071),(33659,2072),(33660,2073),(33661,2074),(33662,2075),(33663,2076),(33664,2077),(33665,2079),(33666,2097),(33667,2098),(33668,2099),(33669,2101),(33670,2167),(33671,2049),(33672,2050),(33673,2051),(33674,2052),(33675,2053),(33676,2054),(33677,2055),(33678,2056),(33679,2060),(33680,2085),(33681,2168),(33682,2252),(33683,2253),(33684,2254),(33685,2255),(33686,2003),(33687,2004),(33688,2005),(33689,2006),(33690,2012),(33691,2015),(33692,2016),(33693,2038),(33694,2272),(33695,2273),(33696,2274),(33697,2009),(33698,2010),(33699,2011),(33700,2057),(33701,2058),(33702,2170),(33703,2171),(33704,2172),(33705,2173),(33706,2174),(33707,2175),(33708,2297),(33709,2298),(33710,2444),(33711,2445),(33712,2446),(33713,2447),(33714,2448),(33715,2485),(33716,2487),(33717,2615),(33718,2247),(33719,2429),(33720,2430),(33721,2431),(33722,2513),(33723,2514),(33724,2521),(33725,2522),(33726,2523),(33727,2524),(33728,2525),(33729,2526),(33730,2527),(33731,2528),(33732,2539),(33733,2573),(33734,2574),(33735,2575),(33736,2576),(33737,2017),(33738,2018),(33739,2019),(33740,2020),(33741,2062),(33742,2063),(33743,2080),(33744,2158),(33745,2160),(33746,2161),(33747,2164),(33748,2176),(33749,2180),(33750,2207),(33751,2249),(33752,2250),(33753,2474),(33754,2482),(33755,2484),(33756,2486),(33757,2543),(33758,2544),(33759,2545),(33760,2546),(33761,2047),(33762,2048),(33763,2116),(33764,2117),(33765,2118),(33766,2119),(33767,2184),(33768,2185),(33769,2186),(33770,2225),(33771,2227),(33772,2228),(33773,2229),(33774,2231),(33775,2483),(33776,2488),(33777,2553),(33778,2554),(33779,1955),(33780,2007),(33781,2065),(33782,2081),(33783,2082),(33784,2083),(33785,2090),(33786,2091),(33787,2159),(33788,2223),(33789,2296),(33790,2494),(33791,2495),(33792,2496),(33793,2497),(33794,2510),(33795,1953),(33796,1954),(33797,1956),(33798,1957),(33799,2059),(33800,2064),(33801,2089),(33802,2103),(33803,2106),(33804,2107),(33805,2108),(33806,2109),(33807,2110),(33808,2111),(33809,2112),(33810,2492),(33811,2493),(33812,2498),(33813,2499),(33814,2555),(33815,1991),(33816,2024),(33817,2025),(33818,2033),(33819,2061),(33820,2084),(33821,2102),(33822,2104),(33823,2105),(33824,2120),(33825,2121),(33826,2163),(33827,2226),(33828,2248),(33829,2270),(33830,2271),(33831,2441),(33832,2472),(33833,2473),(33834,2506),(33835,2507),(33836,2508),(33837,2509),(33838,2511),(33839,2536),(33840,2512),(33841,2066),(33842,2067),(33843,2068),(33844,2069),(33845,2070),(33846,2078),(33847,2079),(33848,2100),(33849,2101),(33850,2165),(33851,2166),(33852,2169),(33853,2616),(33854,2617),(33855,2618),(33856,2049),(33857,2050),(33858,2051),(33859,2052),(33860,2053),(33861,2056),(33862,2071),(33863,2072),(33864,2073),(33865,2074),(33866,2075),(33867,2076),(33868,2077),(33869,2097),(33870,2098),(33871,2099),(33872,2167),(33873,2168),(33874,2253),(33875,2254),(33876,2005),(33877,2006),(33878,2012),(33879,2015),(33880,2016),(33881,2054),(33882,2055),(33883,2060),(33884,2085),(33885,2255),(33886,2264),(33887,2272),(33888,2273),(33889,2274),(33890,2283),(33891,2284),(33892,2465),(33893,2003),(33894,2004),(33895,2009),(33896,2010),(33897,2011),(33898,2057),(33899,2058),(33900,2170),(33901,2171),(33902,2172),(33903,2173),(33904,2175),(33905,2199),(33906,2281),(33907,2294),(33908,2297),(33909,2298),(33910,2444),(33911,2445),(33912,2466),(33913,2467),(33914,2468),(33915,2469),(33916,2470),(33917,2471),(33918,2552),(33919,2556),(33920,2557),(33921,2558),(33922,2562),(33923,2563),(33924,2566),(33925,2567),(33926,2568),(33927,2569),(33928,2570),(33929,2571),(33930,2615),(33931,2247),(33932,2429),(33933,2446),(33934,2447),(33935,2448),(33936,2485),(33937,2487),(33938,2513),(33939,2514),(33940,2521),(33941,2523),(33942,2529),(33943,2530),(33944,2539),(33945,2584),(33946,2586),(33947,2587),(33948,2522),(33949,2524),(33950,2525),(33951,2526),(33952,2527),(33953,2528),(33954,2573),(33955,2574),(33956,2575),(33957,2576),(33958,2164),(33959,2176),(33960,2203),(33961,2205),(33962,2206),(33963,2207),(33964,2249),(33965,2250),(33966,2277),(33967,2278),(33968,2279),(33969,2280),(33970,2430),(33971,2431),(33972,2532),(33973,2533),(33974,2534),(33975,2535),(33976,2547),(33977,2548),(33978,2549),(33979,2550),(33980,2551),(33981,2158),(33982,2160),(33983,2161),(33984,2162),(33985,2181),(33986,2183),(33987,2292),(33988,2295),(33989,2432),(33990,2474),(33991,2543),(33992,2544),(33993,2545),(33994,2546),(33995,2017),(33996,2062),(33997,2063),(33998,2080),(33999,2178),(34000,2179),(34001,2180),(34002,2263),(34003,2285),(34004,2433),(34005,2434),(34006,2436),(34007,2437),(34008,2438),(34009,2450),(34010,2482),(34011,2484),(34012,2486),(34013,2018),(34014,2019),(34015,2020),(34016,2047),(34017,2048),(34018,2116),(34019,2117),(34020,2118),(34021,2119),(34022,2451),(34023,2453),(34024,2501),(34025,2502),(34026,2560),(34027,2561),(34028,2565),(34029,2184),(34030,2185),(34031,2186),(34032,2212),(34033,2225),(34034,2227),(34035,2228),(34036,2229),(34037,2231),(34038,2282),(34039,2483),(34040,2517),(34041,2518),(34042,2519),(34043,2520),(34044,2619),(34045,2620),(34046,2296),(34047,2488),(34048,2553),(34049,2554),(34050,2582),(34051,2583),(34052,2585),(34053,1955),(34054,2007),(34055,2065),(34056,2081),(34057,2082),(34058,2083),(34059,2090),(34060,2091),(34061,2092),(34062,2093),(34063,2286),(34064,2287),(34065,2288),(34066,2496),(34067,2497),(34068,2510),(34069,2564),(34070,2572),(34071,1953),(34072,1954),(34073,1956),(34074,1957),(34075,1958),(34076,2059),(34077,2064),(34078,2089),(34079,2110),(34080,2111),(34081,2112),(34082,2159),(34083,2223),(34084,2492),(34085,2493),(34086,2494),(34087,2495),(34088,2498),(34089,2499),(34090,2555),(34091,2102),(34092,2103),(34093,2104),(34094,2106),(34095,2107),(34096,2108),(34097,2109),(34098,2163),(34099,2270),(34100,2271),(34101,2441),(34102,2452),(34103,2478),(34104,2480),(34105,2621),(34106,2248),(34107,2457),(34108,2506),(34109,2507),(34110,2508),(34111,2509),(34112,2511),(34113,2512),(34114,2536),(34115,2038),(34116,1),(34117,4),(34118,5),(34119,6),(34120,1162),(34121,1163),(34122,1164),(34123,1165),(34124,3835),(34125,4013),(34126,4014),(34127,4015),(34128,4016),(34129,4017),(34130,4018),(34131,4019),(34132,4020),(34133,4021),(34134,4022),(34135,4023),(34136,4024),(34137,4025),(34138,4026),(34139,4027),(34140,4028),(34141,4029),(34142,4030),(34143,4031),(34144,4032),(34145,4033),(34146,4034),(34147,4035),(34148,4036),(34149,4037),(34150,4127),(34151,4128),(34152,4129),(34153,4130),(34154,4132),(34155,4133),(34156,4211),(34157,3724),(34158,3733),(34159,3734),(34160,3735),(34161,3736),(34162,3737),(34163,3740),(34164,3746),(34165,4135),(34166,4156),(34167,4297),(34168,4298),(34169,4300),(34170,4301),(34171,4302),(34172,4303),(34173,4304),(34174,4458),(34175,4459),(34176,3719),(34177,3720),(34178,3723),(34179,3725),(34180,3726),(34181,3728),(34182,3731),(34183,3748),(34184,3751),(34185,3752),(34186,3753),(34187,3754),(34188,3755),(34189,3757),(34190,3758),(34191,3759),(34192,3760),(34193,3909),(34194,3721),(34195,3727),(34196,3732),(34197,3741),(34198,3743),(34199,3744),(34200,3749),(34201,3761),(34202,3762),(34203,3765),(34204,3942),(34205,3972),(34206,3978),(34207,3980),(34208,4080),(34209,4081),(34210,4082),(34211,4083),(34212,4084),(34213,4085),(34214,4088),(34215,4089),(34216,4196),(34217,4197),(34218,4198),(34219,4204),(34220,4205),(34221,4206),(34222,4207),(34223,3884),(34224,3889),(34225,3905),(34226,3917),(34227,3974),(34228,4208),(34229,4209),(34230,4210),(34231,4222),(34232,4226),(34233,4227),(34234,4228),(34235,4230),(34236,4231),(34237,4232),(34238,4233),(34239,4235),(34240,4237),(34241,4238),(34242,4247),(34243,4259),(34244,4275),(34245,4292),(34246,4425),(34247,3885),(34248,3894),(34249,3919),(34250,3920),(34251,3921),(34252,3922),(34253,3966),(34254,3968),(34255,4062),(34256,4121),(34257,4122),(34258,4249),(34259,4250),(34260,4252),(34261,4253),(34262,4255),(34263,4270),(34264,4336),(34265,4360),(34266,4418),(34267,4427),(34268,4063),(34269,4123),(34270,4124),(34271,4179),(34272,4180),(34273,4181),(34274,4182),(34275,4183),(34276,4184),(34277,4185),(34278,4187),(34279,4188),(34280,4189),(34281,4190),(34282,4191),(34283,3785),(34284,3786),(34285,4192),(34286,4215),(34287,4305),(34288,4309),(34289,4310),(34290,4316),(34291,4317),(34292,4070),(34293,4318),(34294,4319),(34295,4364),(34296,4366),(34297,4390),(34298,4391),(34299,4393),(34300,4394),(34301,4395),(34302,4396),(34303,4397),(34304,4398),(34305,4399),(34306,3715),(34307,3716),(34308,3750),(34309,3827),(34310,3828),(34311,3829),(34312,3830),(34313,3832),(34314,3833),(34315,3834),(34316,4092),(34317,4093),(34318,4096),(34319,4097),(34320,4400),(34321,4401),(34322,4460),(34323,4461),(34324,4462),(34325,4467),(34326,4469),(34327,4470),(34328,4474),(34329,4475),(34330,4120),(34331,4151),(34332,4162),(34333,4199),(34334,4200),(34335,4201),(34336,4271),(34337,4272),(34338,4273),(34339,4313),(34340,4430),(34341,4431),(34342,4457),(34343,3874),(34344,3918),(34345,3941),(34346,3963),(34347,4012),(34348,4043),(34349,4087),(34350,4090),(34351,4091),(34352,4095),(34353,4195),(34354,4214),(34355,4224),(34356,4225),(34357,4234),(34358,4236),(34359,4291),(34360,4306),(34361,4358),(34362,1641),(34363,1642),(34364,3722),(34365,3875),(34366,3876),(34367,3877),(34368,3878),(34369,3880),(34370,3892),(34371,4243),(34372,4244),(34373,4245),(34374,4294),(34375,4295),(34376,4436),(34377,4444),(34378,4446),(34379,4447),(34380,4448),(34381,4449),(34382,4450),(34383,4451),(34384,4452),(34385,4454),(34386,4455),(34387,4456),(34388,3729),(34389,3893),(34390,3895),(34391,3924),(34392,3925),(34393,3926),(34394,3927),(34395,3928),(34396,3931),(34397,3933),(34398,3934),(34399,3935),(34400,4086),(34401,4194),(34402,4229),(34403,4251),(34404,4254),(34405,4402),(34406,4403),(34407,4404),(34408,4413),(34409,4414),(34410,4415),(34411,3730),(34412,3738),(34413,3739),(34414,3742),(34415,3747),(34416,3763),(34417,3764),(34418,3831),(34419,3861),(34420,3964),(34421,3965),(34422,3975),(34423,3976),(34424,4052),(34425,4053),(34426,4219),(34427,4276),(34428,4417),(34429,4419),(34430,4065),(34431,4066),(34432,4069),(34433,4170),(34434,4171),(34435,4172),(34436,4173),(34437,4174),(34438,4175),(34439,4186),(34440,4202),(34441,4203),(34442,4212),(34443,5753),(34444,5753),(34445,4216),(34446,4217),(34447,4218),(34448,4220),(34449,4257),(34450,4277),(34451,4278),(34452,4279),(34453,4280),(34454,4282),(34455,4283),(34456,4287),(34457,4288),(34458,4289),(34459,4290),(34460,4315),(34461,4340),(34462,4342),(34463,4343),(34464,4392),(34465,3981),(34466,4054),(34467,4075),(34468,4077),(34469,4142),(34470,4150),(34471,4223),(34472,4434),(34473,4435),(34474,4437),(34475,4438),(34476,4439),(34477,4441),(34478,4442),(34479,4443),(34480,4445),(34481,3756),(34482,3982),(34483,3983),(34484,3984),(34485,3985),(34486,3986),(34487,3987),(34488,3988),(34489,4067),(34490,4068),(34491,4078),(34492,4261),(34493,4262),(34494,4308),(34495,4311),(34496,4312),(34497,4480),(34498,3923),(34499,3929),(34500,3936),(34501,3967),(34502,3969),(34503,4239),(34504,4240),(34505,4241),(34506,4256),(34507,4307),(34508,4346),(34509,4405),(34510,4407),(34511,4408),(34512,4410),(34513,4426),(34514,4473),(34515,4476),(34516,1630),(34517,1631),(34518,1632),(34519,1633),(34520,1634),(34521,1635),(34522,1682),(34523,1683),(34524,1686),(34525,4347),(34526,4349),(34527,4351),(34528,4353),(34529,4355),(34530,1681),(34531,1684),(34532,1685),(34533,3767),(34534,3882),(34535,3903),(34536,3973),(34537,4055),(34538,4059),(34539,4060),(34540,4094),(34541,4143),(34542,4152),(34543,4154),(34544,4168),(34545,3747),(34546,3718),(34547,3745),(34548,3769),(34549,3770),(34550,3772),(34551,3773),(34552,3774),(34553,3904),(34554,3989),(34555,4039),(34556,4041),(34557,4079),(34558,4293),(34559,4370),(34560,4373),(34561,4375),(34562,4378),(34563,4381),(34564,4383),(34565,4384),(34566,4385),(34567,4424),(34568,3787),(34569,3930),(34570,4368),(34571,4369),(34572,4371),(34573,4372),(34574,4374),(34575,4376),(34576,4377),(34577,4379),(34578,4380),(34579,4382),(34580,4386),(34581,4387),(34582,4388),(34583,4389),(34584,3932),(34585,3937),(34586,3938),(34587,3943),(34588,3944),(34589,3945),(34590,3946),(34591,3947),(34592,3948),(34593,3949),(34594,3950),(34595,3951),(34596,3952),(34597,3953),(34598,3954),(34599,3955),(34600,3956),(34601,3957),(34602,3958),(34603,3959),(34604,3960),(34605,3961),(34606,4108),(34607,4140),(34608,4411),(34609,4412),(34610,4131),(34611,4134),(34612,4136),(34613,4138),(34614,4139),(34615,4145),(34616,4146),(34617,4148),(34618,4149),(34619,4248),(34620,4359),(34621,3747),(34622,4021),(34623,4022),(34624,4023),(34625,4024),(34626,4025),(34627,4026),(34628,4027),(34629,4028),(34630,4029),(34631,4030),(34632,4031),(34633,4032),(34634,4033),(34635,4034),(34636,3724),(34637,3733),(34638,3734),(34639,3735),(34640,3736),(34641,3737),(34642,3740),(34643,4035),(34644,4036),(34645,4037),(34646,4211),(34647,3719),(34648,3720),(34649,3723),(34650,3725),(34651,3726),(34652,3728),(34653,3731),(34654,3746),(34655,3751),(34656,3752),(34657,3753),(34658,3754),(34659,3755),(34660,3757),(34661,3758),(34662,3759),(34663,3760),(34664,3909),(34665,3721),(34666,3727),(34667,3732),(34668,3741),(34669,3743),(34670,3744),(34671,3748),(34672,3749),(34673,3761),(34674,3762),(34675,3765),(34676,3942),(34677,3972),(34678,4080),(34679,4081),(34680,4082),(34681,4083),(34682,4084),(34683,4085),(34684,4089),(34685,4196),(34686,4197),(34687,4198),(34688,4204),(34689,4205),(34690,4206),(34691,4207),(34692,4208),(34693,4209),(34694,4210),(34695,4222),(34696,3894),(34697,3966),(34698,3968),(34699,4187),(34700,4188),(34701,4226),(34702,4227),(34703,4228),(34704,4230),(34705,4231),(34706,4232),(34707,4233),(34708,4235),(34709,4237),(34710,4238),(34711,4250),(34712,4252),(34713,4253),(34714,4275),(34715,4292),(34716,4418),(34717,4425),(34718,4427),(34719,4179),(34720,4180),(34721,4181),(34722,4182),(34723,4183),(34724,4184),(34725,4185),(34726,4189),(34727,4309),(34728,4310),(34729,4316),(34730,4317),(34731,4318),(34732,4319),(34733,4390),(34734,4391),(34735,4393),(34736,4394),(34737,4395),(34738,4396),(34739,4397),(34740,4398),(34741,4399),(34742,4400),(34743,4401),(34744,3715),(34745,3716),(34746,3750),(34747,3827),(34748,3828),(34749,3829),(34750,3830),(34751,3832),(34752,3833),(34753,3834),(34754,3918),(34755,3941),(34756,4087),(34757,4090),(34758,4091),(34759,4195),(34760,4224),(34761,4225),(34762,4236),(34763,3722),(34764,3729),(34765,3893),(34766,3895),(34767,3924),(34768,3925),(34769,3926),(34770,3927),(34771,3928),(34772,3931),(34773,3933),(34774,3934),(34775,3935),(34776,4194),(34777,4251),(34778,4254),(34779,4402),(34780,4403),(34781,4404),(34782,3730),(34783,3738),(34784,3739),(34785,3742),(34786,3747),(34787,3763),(34788,3764),(34789,3831),(34790,3975),(34791,3976),(34792,4052),(34793,4053),(34794,4065),(34795,4086),(34796,4219),(34797,4229),(34798,4276),(34799,4413),(34800,4414),(34801,4415),(34802,4417),(34803,4419),(34804,3981),(34805,3982),(34806,3983),(34807,3984),(34808,3985),(34809,4066),(34810,4069),(34811,4186),(34812,4212),(34813,4218),(34814,4220),(34815,4223),(34816,4282),(34817,4283),(34818,4392),(34819,4437),(34820,4438),(34821,4439),(34822,3756),(34823,4067),(34824,4068),(34825,4307),(34826,4308),(34827,4311),(34828,4312),(34829,3745),(34830,3903),(34831,3967),(34832,3969),(34833,4059),(34834,4060),(34835,4346),(34836,4347),(34837,4349),(34838,4351),(34839,4353),(34840,4355),(34841,4405),(34842,4407),(34843,4408),(34844,4410),(34845,4426),(34846,3718),(34847,3871),(34848,4041),(34849,4167),(34850,4274),(34851,4348),(34852,4350),(34853,4352),(34854,4354),(34855,4356),(34856,4406),(34857,4409),(34858,4411),(34859,4412),(34860,4021),(34861,4022),(34862,4023),(34863,4024),(34864,4025),(34865,4026),(34866,4027),(34867,4028),(34868,4029),(34869,4030),(34870,4031),(34871,4032),(34872,4033),(34873,4034),(34874,4035),(34875,3724),(34876,3733),(34877,3735),(34878,3736),(34879,3740),(34880,3746),(34881,3751),(34882,3755),(34883,3757),(34884,3758),(34885,3759),(34886,3760),(34887,3909),(34888,4036),(34889,4037),(34890,3719),(34891,3720),(34892,3723),(34893,3725),(34894,3726),(34895,3727),(34896,3728),(34897,3731),(34898,3748),(34899,3752),(34900,3753),(34901,3754),(34902,3721),(34903,3732),(34904,3741),(34905,3743),(34906,3744),(34907,3749),(34908,3761),(34909,3762),(34910,3765),(34911,3966),(34912,3968),(34913,4083),(34914,4088),(34915,4204),(34916,4207),(34917,4235),(34918,4237),(34919,4249),(34920,4179),(34921,4180),(34922,4181),(34923,4182),(34924,4183),(34925,4184),(34926,4185),(34927,4187),(34928,4188),(34929,4189),(34930,4250),(34931,4252),(34932,4253),(34933,4255),(34934,4309),(34935,4310),(34936,4316),(34937,4317),(34938,3827),(34939,3828),(34940,3829),(34941,4318),(34942,4390),(34943,4391),(34944,4393),(34945,4394),(34946,4396),(34947,4397),(34948,4398),(34949,4399),(34950,4400),(34951,4401),(34952,3715),(34953,3716),(34954,3722),(34955,3729),(34956,3750),(34957,3830),(34958,3833),(34959,3834),(34960,3925),(34961,3926),(34962,3927),(34963,3928),(34964,3941),(34965,4087),(34966,4090),(34967,4091),(34968,3730),(34969,3738),(34970,3739),(34971,3742),(34972,3747),(34973,3763),(34974,3764),(34975,3831),(34976,3931),(34977,3933),(34978,3934),(34979,3935),(34980,3975),(34981,3976),(34982,4086),(34983,4219),(34984,4229),(34985,4251),(34986,4254),(34987,4404),(34988,4415),(34989,4052),(34990,4053),(34991,4065),(34992,4066),(34993,4069),(34994,4186),(34995,4218),(34996,4220),(34997,4282),(34998,4283),(34999,4392),(35000,4437),(35001,4438),(35002,4439),(35003,3787),(35004,3893),(35005,3894),(35006,3895),(35007,3903),(35008,3925),(35009,3932),(35010,3981),(35011,4081),(35012,4084),(35013,4089),(35014,4195),(35015,4197),(35016,4205),(35017,4210),(35018,4224),(35019,4225),(35020,4230),(35021,4275),(35022,4403),(35023,4407),(35024,4411),(35025,4414),(35026,3972),(35027,4082),(35028,4085),(35029,4196),(35030,4198),(35031,4206),(35032,4209),(35033,4211),(35034,4226),(35035,4227),(35036,4231),(35037,4232),(35038,3918),(35039,3924),(35040,4193),(35041,4194),(35042,4225),(35043,4276),(35044,4292),(35045,4312),(35046,4402),(35047,4405),(35048,4425),(35049,4426),(35050,4427),(35051,3927),(35052,3942),(35053,3985),(35054,4141),(35055,4208),(35056,4222),(35057,4228),(35058,4234),(35059,4236),(35060,4238),(35061,4347),(35062,4348),(35063,4351),(35064,4352),(35065,4355),(35066,4356),(35067,4395),(35068,4410),(35069,4417),(35070,4418),(35071,4419),(35072,4481),(35073,4482),(35074,4483),(35075,4484),(35076,4485),(35077,4486),(35078,4487),(35079,4488),(35080,4489),(35081,4490),(35082,3721),(35083,3723),(35084,3732),(35085,3733),(35086,3746),(35087,3765),(35088,3889),(35089,3966),(35090,3968),(35091,4020),(35092,4080),(35093,4083),(35094,4204),(35095,4207),(35096,4233),(35097,4235),(35098,4237),(35099,4249),(35100,4250),(35101,4252),(35102,4253),(35103,4275),(35104,3785),(35105,3786),(35106,4181),(35107,4255),(35108,4305),(35109,4309),(35110,4310),(35111,4316),(35112,4317),(35113,4318),(35114,4319),(35115,4393),(35116,4394),(35117,4398),(35118,4399),(35119,4400),(35120,4401),(35121,3924),(35122,3941),(35123,4087),(35124,4090),(35125,4091),(35126,4092),(35127,4093),(35128,4095),(35129,4096),(35130,4097),(35131,4162),(35132,4271),(35133,4272),(35134,3739),(35135,3747),(35136,3764),(35137,3861),(35138,3925),(35139,3926),(35140,4065),(35141,4066),(35142,4069),(35143,4086),(35144,4229),(35145,4251),(35146,4254),(35147,4404),(35148,4414),(35149,4415),(35150,4067),(35151,4068),(35152,4075),(35153,4150),(35154,4170),(35155,4171),(35156,4174),(35157,4175),(35158,4203),(35159,4223),(35160,4340),(35161,4392),(35162,4434),(35163,3718),(35164,3967),(35165,3969),(35166,4094),(35167,4256),(35168,4346),(35169,4349),(35170,4353),(35171,4375),(35172,4377),(35173,4385),(35174,4386),(35175,4408),(35176,3930),(35177,4354),(35178,4368),(35179,4369),(35180,4372),(35181,4376),(35182,4379),(35183,4380),(35184,4382),(35185,4387),(35186,4388),(35187,4389),(35188,3719),(35189,3723),(35190,3735),(35191,3736),(35192,3740),(35193,3744),(35194,3746),(35195,3942),(35196,3972),(35197,4035),(35198,4037),(35199,4081),(35200,4082),(35201,4083),(35202,4084),(35203,4085),(35204,4089),(35205,4196),(35206,4197),(35207,4198),(35208,4204),(35209,4205),(35210,4206),(35211,4207),(35212,4208),(35213,4209),(35214,4210),(35215,4222),(35216,4226),(35217,4227),(35218,4228),(35219,4231),(35220,4232),(35221,4233),(35222,4235),(35223,4237),(35224,4238),(35225,4275),(35226,3894),(35227,3966),(35228,3968),(35229,4249),(35230,4250),(35231,4252),(35232,4253),(35233,4255),(35234,4292),(35235,4425),(35236,4179),(35237,4180),(35238,4181),(35239,4182),(35240,4183),(35241,4184),(35242,4309),(35243,4316),(35244,4318),(35245,4390),(35246,4391),(35247,4394),(35248,4418),(35249,4427),(35250,3715),(35251,3750),(35252,3828),(35253,3829),(35254,3830),(35255,3918),(35256,3941),(35257,4090),(35258,4395),(35259,4396),(35260,4398),(35261,4399),(35262,4400),(35263,4401),(35264,3722),(35265,3729),(35266,3893),(35267,3895),(35268,3924),(35269,3925),(35270,3926),(35271,3927),(35272,3928),(35273,3931),(35274,3933),(35275,3934),(35276,3935),(35277,4194),(35278,4195),(35279,4224),(35280,4225),(35281,4234),(35282,4236),(35283,4251),(35284,4254),(35285,3742),(35286,3747),(35287,3831),(35288,3975),(35289,4052),(35290,4053),(35291,4086),(35292,4193),(35293,4229),(35294,4276),(35295,4402),(35296,4403),(35297,4404),(35298,4415),(35299,4417),(35300,4419),(35301,3756),(35302,3981),(35303,4065),(35304,4218),(35305,4220),(35306,4223),(35307,4346),(35308,4347),(35309,4349),(35310,4351),(35311,4353),(35312,4355),(35313,4405),(35314,4407),(35315,4408),(35316,4410),(35317,4438),(35318,4439),(35319,4230),(35320,4021),(35321,4022),(35322,4023),(35323,4024),(35324,4025),(35325,4026),(35326,4027),(35327,4028),(35328,4029),(35329,4030),(35330,4031),(35331,4032),(35332,4033),(35333,4034),(35334,4035),(35335,4036),(35336,4037),(35337,3721),(35338,3723),(35339,3732),(35340,3733),(35341,3746),(35342,3765),(35343,3942),(35344,3972),(35345,4034),(35346,4035),(35347,4036),(35348,4080),(35349,4081),(35350,4083),(35351,4084),(35352,4089),(35353,4181),(35354,4237),(35355,4275),(35356,4292),(35357,4316),(35358,3718),(35359,3739),(35360,3747),(35361,3764),(35362,3871),(35363,3976),(35364,4065),(35365,4066),(35366,4069),(35367,4186),(35368,4282),(35369,4283),(35370,4317),(35371,4350),(35372,4354),(35373,4392),(35374,4393),(35375,4394),(35376,4398),(35377,4399),(35378,4400),(35379,4401),(35380,4406),(35381,4412),(35382,3733),(35383,3746),(35384,3942),(35385,3972),(35386,4080),(35387,4081),(35388,4082),(35389,4083),(35390,4084),(35391,4085),(35392,4089),(35393,4196),(35394,4197),(35395,4198),(35396,4204),(35397,4205),(35398,4206),(35399,4207),(35400,4208),(35401,4209),(35402,4210),(35403,4211),(35404,4222),(35405,3894),(35406,3966),(35407,4226),(35408,4227),(35409,4228),(35410,4230),(35411,4231),(35412,4232),(35413,4233),(35414,4235),(35415,4237),(35416,4238),(35417,4275),(35418,4292),(35419,4425),(35420,3750),(35421,3918),(35422,3941),(35423,3968),(35424,4087),(35425,4090),(35426,4179),(35427,4181),(35428,4183),(35429,4249),(35430,4250),(35431,4252),(35432,4253),(35433,4255),(35434,4309),(35435,4316),(35436,4317),(35437,4318),(35438,4390),(35439,4394),(35440,4395),(35441,4396),(35442,4398),(35443,4400),(35444,4401),(35445,4418),(35446,4427),(35447,3722),(35448,3729),(35449,3831),(35450,3895),(35451,4065),(35452,4066),(35453,4069),(35454,4086),(35455,4193),(35456,4195),(35457,4223),(35458,4224),(35459,4225),(35460,4229),(35461,4234),(35462,4236),(35463,4254),(35464,4276),(35465,4311),(35466,4392),(35467,4402),(35468,4312),(35469,3734),(35470,3735),(35471,3736),(35472,3740),(35473,3751),(35474,3758),(35475,4021),(35476,4022),(35477,4023),(35478,4024),(35479,4025),(35480,4026),(35481,4027),(35482,4028),(35483,4029),(35484,4030),(35485,4031),(35486,4032),(35487,4033),(35488,4037),(35489,3728),(35490,3731),(35491,3741),(35492,3743),(35493,3744),(35494,3752),(35495,3753),(35496,3754),(35497,3755),(35498,3757),(35499,3759),(35500,3760),(35501,3761),(35502,3762),(35503,3909),(35504,3750),(35505,3827),(35506,3828),(35507,3829),(35508,3830),(35509,4179),(35510,4180),(35511,4182),(35512,4183),(35513,4184),(35514,4185),(35515,4187),(35516,4188),(35517,4189),(35518,3715),(35519,3722),(35520,3729),(35521,3730),(35522,3738),(35523,3742),(35524,3763),(35525,3764),(35526,3831),(35527,3832),(35528,3833),(35529,3834),(35530,3975),(35531,3976),(35532,4052),(35533,4053),(35534,4186),(35535,4212),(35536,4219),(35537,4220),(35538,3745),(35539,3756),(35540,4218),(35541,4282),(35542,4283),(35543,4437),(35544,4438),(35545,4439),(35546,3765),(35547,3942),(35548,3972),(35549,4032),(35550,4033),(35551,4035),(35552,4036),(35553,4037),(35554,4081),(35555,4082),(35556,4083),(35557,4084),(35558,4211),(35559,4085),(35560,4089),(35561,4196),(35562,4197),(35563,4198),(35564,4204),(35565,4205),(35566,4206),(35567,4207),(35568,4208),(35569,4209),(35570,4210),(35571,4222),(35572,4226),(35573,4227),(35574,4228),(35575,4230),(35576,4231),(35577,4232),(35578,4233),(35579,4235),(35580,4237),(35581,4238),(35582,4275),(35583,4179),(35584,4180),(35585,4181),(35586,4182),(35587,4187),(35588,4188),(35589,4189),(35590,4292),(35591,4425),(35592,4183),(35593,4184),(35594,4185),(35595,4316),(35596,4317),(35597,4390),(35598,4391),(35599,4393),(35600,4394),(35601,4395),(35602,4396),(35603,4397),(35604,4398),(35605,4399),(35606,4400),(35607,4401),(35608,3918),(35609,3941),(35610,4086),(35611,4087),(35612,4090),(35613,4091),(35614,4195),(35615,4224),(35616,4225),(35617,4229),(35618,4234),(35619,4236),(35620,4065),(35621,3967),(35622,3981),(35623,4066),(35624,4069),(35625,4186),(35626,4392),(35627,4408),(35628,4410),(35629,4426),(35630,4438),(35631,3718),(35632,3969),(35633,4256),(35634,4346),(35635,4347),(35636,4351),(35637,4353),(35638,4355),(35639,4356),(35640,1165),(35641,1165),(35642,1165),(35643,1165),(35644,1165),(35645,1165),(35646,5193),(35647,5193),(35648,5193),(35649,5193),(35650,5193),(35651,5193),(35652,5193),(35653,5192),(35654,5192),(35655,5192),(35656,5192),(35657,5192),(35658,5192),(35659,5192),(35660,5190),(35661,5190),(35662,5190),(35663,5190),(35664,5190),(35665,5190),(35666,5190),(35667,5753),(35668,5753),(35669,4127),(35670,4128),(35671,4129),(35672,4130),(35673,4132),(35674,4133),(35675,4135),(35676,4137),(35677,4156),(35678,4297),(35679,4298),(35680,4299),(35681,4300),(35682,4301),(35683,4302),(35684,4303),(35685,4304),(35686,4458),(35687,4459),(35688,1629),(35689,3884),(35690,3905),(35691,3970),(35692,3980),(35693,4062),(35694,4121),(35695,4122),(35696,4123),(35697,4259),(35698,4270),(35699,4063),(35700,4070),(35701,4124),(35702,4215),(35703,4364),(35704,4366),(35705,4460),(35706,4461),(35707,4462),(35708,4467),(35709,4470),(35710,1640),(35711,1641),(35712,1642),(35713,3875),(35714,3876),(35715,3877),(35716,3878),(35717,3880),(35718,3977),(35719,4469),(35720,4474),(35721,4475),(35722,4243),(35723,4244),(35724,4245),(35725,4294),(35726,4295),(35727,4296),(35728,4436),(35729,4444),(35730,4446),(35731,4447),(35732,4448),(35733,4449),(35734,4450),(35735,3870),(35736,3892),(35737,3964),(35738,3965),(35739,3979),(35740,4172),(35741,4173),(35742,4451),(35743,4452),(35744,4453),(35745,4454),(35746,4455),(35747,4456),(35748,4202),(35749,4216),(35750,4217),(35751,4257),(35752,4277),(35753,4278),(35754,4279),(35755,4280),(35756,4281),(35757,4287),(35758,4288),(35759,4289),(35760,4290),(35761,4315),(35762,4342),(35763,4343),(35764,4441),(35765,1632),(35766,4239),(35767,4240),(35768,4241),(35769,4442),(35770,4443),(35771,4445),(35772,4473),(35773,4476),(35774,4480),(35775,1630),(35776,1631),(35777,1633),(35778,1634),(35779,1635),(35780,1681),(35781,1682),(35782,1683),(35783,1684),(35784,1685),(35785,1686),(35786,3903),(35787,1638),(35788,1639),(35789,1645),(35790,3768),(35791,3771),(35792,3882),(35793,3973),(35794,4152),(35795,4153),(35796,4154),(35797,4168),(35798,4337),(35799,4338),(35800,4339),(35801,1568),(35802,1569),(35803,1570),(35804,1571),(35805,1572),(35806,1573),(35807,1636),(35808,1637),(35809,1643),(35810,1644),(35811,1574),(35812,1646),(35813,1647),(35814,1648),(35815,1649),(35816,4145),(35817,4146),(35818,4148),(35819,4149),(35820,4248),(35821,4359),(35822,4127),(35823,4128),(35824,4129),(35825,4130),(35826,4132),(35827,4133),(35828,4135),(35829,4137),(35830,4156),(35831,4297),(35832,4298),(35833,4299),(35834,4300),(35835,4301),(35836,1640),(35837,1641),(35838,3977),(35839,3978),(35840,4302),(35841,4303),(35842,4304),(35843,4458),(35844,4459),(35845,1642),(35846,3875),(35847,3876),(35848,3877),(35849,3878),(35850,3879),(35851,3880),(35852,4243),(35853,4244),(35854,4245),(35855,4294),(35856,4295),(35857,4296),(35858,4436),(35859,4444),(35860,4446),(35861,4447),(35862,3892),(35863,4448),(35864,4449),(35865,4450),(35866,4451),(35867,4452),(35868,4453),(35869,4454),(35870,4455),(35871,4456),(35872,3870),(35873,3964),(35874,3965),(35875,4172),(35876,4173),(35877,4202),(35878,4257),(35879,4277),(35880,4278),(35881,4279),(35882,4280),(35883,4281),(35884,4287),(35885,1632),(35886,1635),(35887,1683),(35888,1686),(35889,4288),(35890,4289),(35891,4290),(35892,4342),(35893,4343),(35894,4441),(35895,4442),(35896,4443),(35897,4445),(35898,1568),(35899,1569),(35900,1570),(35901,1571),(35902,1572),(35903,3882),(35904,3903),(35905,3973),(35906,4152),(35907,1573),(35908,1574),(35909,4145),(35910,4146),(35911,4148),(35912,4149),(35913,3884),(35914,3905),(35915,3970),(35916,4062),(35917,4121),(35918,4259),(35919,4270),(35920,4422),(35921,1630),(35922,1633),(35923,4063),(35924,4070),(35925,4215),(35926,4239),(35927,4241),(35928,4460),(35929,4473),(35930,4476),(35931,4480),(35932,1681),(35933,1684),(35934,3768),(35935,3771),(35936,4127),(35937,4128),(35938,4129),(35939,4130),(35940,4132),(35941,4133),(35942,4135),(35943,4137),(35944,4156),(35945,4297),(35946,4298),(35947,4299),(35948,4300),(35949,4301),(35950,1640),(35951,1641),(35952,1642),(35953,3875),(35954,3876),(35955,3877),(35956,3878),(35957,3879),(35958,3880),(35959,3978),(35960,4243),(35961,4244),(35962,4245),(35963,4294),(35964,4295),(35965,4296),(35966,4302),(35967,4303),(35968,4304),(35969,4436),(35970,4444),(35971,4446),(35972,4458),(35973,4459),(35974,3870),(35975,3892),(35976,3964),(35977,3965),(35978,4170),(35979,4171),(35980,4447),(35981,4448),(35982,4449),(35983,4450),(35984,4451),(35985,4452),(35986,4453),(35987,4454),(35988,4455),(35989,4456),(35990,4172),(35991,4173),(35992,4174),(35993,4202),(35994,4257),(35995,4277),(35996,4278),(35997,4279),(35998,4280),(35999,4281),(36000,4287),(36001,4288),(36002,4289),(36003,4290),(36004,4342),(36005,4343),(36006,1568),(36007,1569),(36008,1570),(36009,1636),(36010,1637),(36011,1638),(36012,1639),(36013,1643),(36014,1644),(36015,1645),(36016,3903),(36017,3973),(36018,4153),(36019,4154),(36020,4168),(36021,4337),(36022,4338),(36023,4339),(36024,4441),(36025,4442),(36026,4443),(36027,4445),(36028,1571),(36029,1572),(36030,1573),(36031,1574),(36032,1646),(36033,1647),(36034,1648),(36035,1649),(36036,4141),(36037,4146),(36038,4148),(36039,4149),(36040,1631),(36041,1634),(36042,1682),(36043,1685),(36044,4122),(36045,4123),(36046,4124),(36047,4216),(36048,4217),(36049,4315),(36050,4364),(36051,4366),(36052,4461),(36053,4462),(36054,4467),(36055,4469),(36056,4470),(36057,4474),(36058,4475),(36059,3889),(36060,4013),(36061,4014),(36062,4015),(36063,4016),(36064,4017),(36065,4018),(36066,4019),(36067,4020),(36068,3917),(36069,3974),(36070,4247),(36071,4336),(36072,3885),(36073,3919),(36074,4360),(36075,3785),(36076,3786),(36077,3920),(36078,3921),(36079,3922),(36080,4062),(36081,4092),(36082,4093),(36083,4096),(36084,4097),(36085,4120),(36086,4151),(36087,4305),(36088,4460),(36089,4043),(36090,4095),(36091,4162),(36092,4199),(36093,4200),(36094,4271),(36095,4272),(36096,4273),(36097,4313),(36098,4314),(36099,4430),(36100,4431),(36101,4457),(36102,4214),(36103,4306),(36104,4358),(36105,3874),(36106,3963),(36107,3986),(36108,3987),(36109,3988),(36110,4012),(36111,4291),(36112,3767),(36113,3773),(36114,3774),(36115,3868),(36116,3904),(36117,3923),(36118,3929),(36119,3936),(36120,4039),(36121,4094),(36122,4143),(36123,4293),(36124,4385),(36125,4468),(36126,3908),(36127,3930),(36128,3932),(36129,3937),(36130,3938),(36131,4040),(36132,4044),(36133,4125),(36134,4178),(36135,4213),(36136,4320),(36137,4322),(36138,4323),(36139,4324),(36140,4325),(36141,4345),(36142,4368),(36143,4372),(36144,4375),(36145,4376),(36146,4379),(36147,4382),(36148,4383),(36149,4384),(36150,4386),(36151,3872),(36152,3873),(36153,3944),(36154,3946),(36155,3948),(36156,3949),(36157,3951),(36158,3952),(36159,3953),(36160,3954),(36161,3960),(36162,4076),(36163,4341),(36164,4416),(36165,3943),(36166,3945),(36167,3947),(36168,3950),(36169,3955),(36170,3956),(36171,3957),(36172,3958),(36173,3959),(36174,3961),(36175,4108),(36176,3885),(36177,3919),(36178,3920),(36179,3921),(36180,3922),(36181,3974),(36182,4013),(36183,4014),(36184,4015),(36185,4016),(36186,4191),(36187,4192),(36188,4215),(36189,4336),(36190,3767),(36191,3923),(36192,3936),(36193,4043),(36194,4094),(36195,4120),(36196,4162),(36197,4271),(36198,4272),(36199,4291),(36200,4305),(36201,4306),(36202,4313),(36203,4314),(36204,4358),(36205,4430),(36206,4431),(36207,3773),(36208,3774),(36209,3872),(36210,3873),(36211,3904),(36212,3930),(36213,3989),(36214,4039),(36215,4079),(36216,4293),(36217,4341),(36218,4416),(36219,4424),(36220,4468),(36221,3943),(36222,3944),(36223,3946),(36224,3947),(36225,3948),(36226,3949),(36227,3950),(36228,3951),(36229,3952),(36230,3953),(36231,3954),(36232,3955),(36233,3956),(36234,3957),(36235,3958),(36236,3959),(36237,3960),(36238,4108),(36239,3768),(36240,3771),(36241,3884),(36242,3905),(36243,3970),(36244,4062),(36245,4063),(36246,4070),(36247,4121),(36248,4215),(36249,4239),(36250,4241),(36251,4259),(36252,4270),(36253,4422),(36254,4460),(36255,4473),(36256,4476),(36257,3769),(36258,3874),(36259,4012),(36260,4054),(36261,4055),(36262,4075),(36263,4077),(36264,4078),(36265,4094),(36266,4097),(36267,4142),(36268,4143),(36269,4150),(36270,4151),(36271,4199),(36272,4200),(36273,4201),(36274,3770),(36275,3787),(36276,3932),(36277,3944),(36278,3946),(36279,3948),(36280,3949),(36281,3951),(36282,3952),(36283,3953),(36284,3954),(36285,3960),(36286,4076),(36287,4341),(36288,4375),(36289,4385),(36290,4386),(36291,4388),(36292,4468),(36293,3943),(36294,3945),(36295,3947),(36296,3950),(36297,3955),(36298,3958),(36299,3961),(36300,4108),(36301,3986),(36302,3987),(36303,3988),(36304,4012),(36305,4013),(36306,4014),(36307,4015),(36308,4016),(36309,4017),(36310,4018),(36311,4019),(36312,4020),(36313,4097),(36314,4341),(36315,4416),(36316,3776),(36317,3777),(36318,3778),(36319,3779),(36320,3780),(36321,3781),(36322,3782),(36323,3783),(36324,3788),(36325,3789),(36326,3790),(36327,3791),(36328,3792),(36329,3793),(36330,3794),(36331,3795),(36332,3796),(36333,3797),(36334,3798),(36335,3799),(36336,3800),(36337,3801),(36338,3802),(36339,3803),(36340,3804),(36341,3805),(36342,3806),(36343,3807),(36344,3808),(36345,3809),(36346,3810),(36347,3811),(36348,3812),(36349,3813),(36350,3814),(36351,3815),(36352,3816),(36353,3817),(36354,3818),(36355,3820),(36356,3821),(36357,3822),(36358,3823),(36359,3824),(36360,3825),(36361,3826),(36362,3836),(36363,3837),(36364,3838),(36365,3839),(36366,3840),(36367,3841),(36368,3847),(36369,3852),(36370,3853),(36371,3854),(36372,3857),(36373,3890),(36374,3849),(36375,3855),(36376,3856),(36377,3858),(36378,3859),(36379,4326),(36380,4327),(36381,4328),(36382,4330),(36383,4331),(36384,4332),(36385,4333),(36386,4335),(36387,3842),(36388,3846),(36389,3848),(36390,3850),(36391,3851),(36392,3887),(36393,3910),(36394,3911),(36395,3912),(36396,4057),(36397,4064),(36398,4329),(36399,4334),(36400,1),(36401,2),(36402,5),(36403,6),(36404,1162),(36405,1163),(36406,1164),(36407,1165),(36408,3128),(36409,3130),(36410,3133),(36411,3172),(36412,3134),(36413,3136),(36414,3137),(36415,3138),(36416,3139),(36417,3145),(36418,3150),(36419,3151),(36420,3155),(36421,3407),(36422,2704),(36423,2705),(36424,2731),(36425,3153),(36426,3160),(36427,3161),(36428,3162),(36429,3163),(36430,3713),(36431,2924),(36432,2927),(36433,2928),(36434,2931),(36435,2932),(36436,2933),(36437,2934),(36438,2935),(36439,2936),(36440,2937),(36441,2988),(36442,3164),(36443,3165),(36444,2938),(36445,2939),(36446,2940),(36447,2941),(36448,3102),(36449,3133),(36450,3134),(36451,3136),(36452,3137),(36453,3138),(36454,3139),(36455,3145),(36456,3150),(36457,3151),(36458,3157),(36459,3166),(36460,2704),(36461,2705),(36462,2731),(36463,2732),(36464,2733),(36465,2734),(36466,2735),(36467,2736),(36468,2737),(36469,2738),(36470,2739),(36471,3160),(36472,3161),(36473,3162),(36474,3163),(36475,2740),(36476,2741),(36477,2742),(36478,2743),(36479,2744),(36480,2745),(36481,2746),(36482,2747),(36483,2748),(36484,2749),(36485,2750),(36486,2751),(36487,2752),(36488,2753),(36489,2754),(36490,2755),(36491,2756),(36492,2757),(36493,2758),(36494,2759),(36495,3118),(36496,3131),(36497,3153),(36498,3623),(36499,3713),(36500,2942),(36501,2944),(36502,3153),(36503,3534),(36504,3535),(36505,3536),(36506,3675),(36507,3676),(36508,3677),(36509,3678),(36510,3679),(36511,3680),(36512,3681),(36513,3682),(36514,3683),(36515,2700),(36516,2866),(36517,2867),(36518,2919),(36519,2920),(36520,2655),(36521,2656),(36522,2657),(36523,2759),(36524,2766),(36525,2767),(36526,2768),(36527,2769),(36528,2770),(36529,2771),(36530,2970),(36531,3131),(36532,2796),(36533,3042),(36534,3169),(36535,3336),(36536,3391),(36537,2864),(36538,2887),(36539,2888),(36540,2911),(36541,3036),(36542,3048),(36543,3078),(36544,3108),(36545,3537),(36546,3543),(36547,3561),(36548,3621),(36549,3671),(36550,2655),(36551,2656),(36552,2657),(36553,2767),(36554,2768),(36555,2781),(36556,2794),(36557,2833),(36558,2835),(36559,2837),(36560,2838),(36561,2894),(36562,2895),(36563,2896),(36564,2978),(36565,2991),(36566,3052),(36567,3167),(36568,3168),(36569,2771),(36570,2971),(36571,2972),(36572,2973),(36573,2974),(36574,2975),(36575,2993),(36576,2994),(36577,2995),(36578,2996),(36579,3504),(36580,3505),(36581,3507),(36582,3508),(36583,2932),(36584,2939),(36585,2947),(36586,2948),(36587,2949),(36588,2950),(36589,3407),(36590,3509),(36591,3510),(36592,3511),(36593,3512),(36594,3513),(36595,3514),(36596,3711),(36597,2724),(36598,2748),(36599,2755),(36600,2782),(36601,2793),(36602,2807),(36603,2809),(36604,2811),(36605,2813),(36606,2817),(36607,2819),(36608,3136),(36609,3137),(36610,3150),(36611,3151),(36612,3156),(36613,3160),(36614,3161),(36615,3184),(36616,3214),(36617,3488),(36618,3623),(36619,2699),(36620,2925),(36621,2926),(36622,2929),(36623,2930),(36624,2943),(36625,2945),(36626,2979),(36627,2980),(36628,3042),(36629,3128),(36630,3172),(36631,2740),(36632,2741),(36633,2742),(36634,2743),(36635,2749),(36636,2750),(36637,2751),(36638,2753),(36639,2754),(36640,2757),(36641,2758),(36642,2800),(36643,2812),(36644,3118),(36645,3130),(36646,3131),(36647,3157),(36648,3407),(36649,3623),(36650,3714),(36651,2765),(36652,2798),(36653,2821),(36654,2856),(36655,2886),(36656,2893),(36657,2900),(36658,2904),(36659,2955),(36660,3543),(36661,3548),(36662,3620),(36663,3673),(36664,3674),(36665,2828),(36666,2829),(36667,2843),(36668,2858),(36669,2863),(36670,2891),(36671,2978),(36672,2987),(36673,2989),(36674,2990),(36675,2998),(36676,3539),(36677,3540),(36678,2999),(36679,3000),(36680,3001),(36681,3002),(36682,3003),(36683,3004),(36684,3005),(36685,3006),(36686,3007),(36687,3490),(36688,3491),(36689,3492),(36690,3493),(36691,3494),(36692,3495),(36693,3496),(36694,3497),(36695,3498),(36696,3499),(36697,3500),(36698,3501),(36699,3502),(36700,3503),(36701,3573),(36702,3574),(36703,3575),(36704,3576),(36705,3577),(36706,3578),(36707,3579),(36708,3580),(36709,3583),(36710,3592),(36711,3593),(36712,3594),(36713,3595),(36714,3596),(36715,3597),(36716,3598),(36717,3599),(36718,3600),(36719,3601),(36720,3602),(36721,3603),(36722,3604),(36723,3605),(36724,3606),(36725,3607),(36726,3608),(36727,3609),(36728,3686),(36729,3687),(36730,3688),(36731,3689),(36732,3690),(36733,3691),(36734,3692),(36735,3693),(36736,3694),(36737,3695),(36738,3696),(36739,3697),(36740,3698),(36741,3699),(36742,3700),(36743,3701),(36744,3702),(36745,3703),(36746,2699),(36747,2923),(36748,2925),(36749,2926),(36750,2929),(36751,2930),(36752,2943),(36753,2945),(36754,2979),(36755,3704),(36756,3705),(36757,3706),(36758,3707),(36759,3708),(36760,3709),(36761,3710),(36762,2703),(36763,2980),(36764,3042),(36765,2890),(36766,2899),(36767,2917),(36768,2976),(36769,3012),(36770,3128),(36771,3130),(36772,3142),(36773,3146),(36774,3149),(36775,3152),(36776,3154),(36777,3155),(36778,3156),(36779,3172),(36780,3184),(36781,3214),(36782,3407),(36783,3479),(36784,3480),(36785,3488),(36786,2708),(36787,2711),(36788,2712),(36789,2713),(36790,2714),(36791,2717),(36792,2721),(36793,2722),(36794,2723),(36795,2730),(36796,2799),(36797,2800),(36798,2801),(36799,2802),(36800,2918),(36801,3043),(36802,3489),(36803,2677),(36804,2803),(36805,2804),(36806,2810),(36807,2812),(36808,2815),(36809,3126),(36810,3132),(36811,3135),(36812,3140),(36813,3143),(36814,3144),(36815,3147),(36816,3148),(36817,3159),(36818,3421),(36819,3714),(36820,2828),(36821,2842),(36822,2843),(36823,2987),(36824,3479),(36825,3539),(36826,2856),(36827,2893),(36828,2912),(36829,2955),(36830,3037),(36831,3049),(36832,3077),(36833,3079),(36834,3109),(36835,3538),(36836,3543),(36837,3548),(36838,3571),(36839,3620),(36840,3674),(36841,2765),(36842,2796),(36843,2797),(36844,2798),(36845,2857),(36846,2865),(36847,2886),(36848,2889),(36849,2894),(36850,2900),(36851,2988),(36852,2992),(36853,3019),(36854,3562),(36855,3622),(36856,3672),(36857,3673),(36858,2828),(36859,2829),(36860,2834),(36861,2836),(36862,2839),(36863,2843),(36864,2858),(36865,2863),(36866,2897),(36867,2898),(36868,2978),(36869,2987),(36870,2989),(36871,2990),(36872,2997),(36873,3008),(36874,3053),(36875,3054),(36876,3539),(36877,3540),(36878,3541),(36879,3542),(36880,3648),(36881,3009),(36882,3010),(36883,3011),(36884,3490),(36885,3491),(36886,3492),(36887,3493),(36888,3494),(36889,3495),(36890,3496),(36891,3497),(36892,3498),(36893,3499),(36894,3500),(36895,3501),(36896,3502),(36897,3503),(36898,3515),(36899,3516),(36900,3517),(36901,3518),(36902,3519),(36903,3520),(36904,3521),(36905,3522),(36906,3523),(36907,3524),(36908,3525),(36909,3526),(36910,3527),(36911,3573),(36912,2924),(36913,2927),(36914,2928),(36915,2931),(36916,2933),(36917,2934),(36918,2935),(36919,2936),(36920,3164),(36921,3165),(36922,3574),(36923,3575),(36924,3576),(36925,3577),(36926,3578),(36927,3579),(36928,3580),(36929,3583),(36930,3701),(36931,3712),(36932,2703),(36933,2937),(36934,2938),(36935,2940),(36936,2941),(36937,2948),(36938,2949),(36939,2951),(36940,2952),(36941,2953),(36942,2954),(36943,3166),(36944,2795),(36945,2830),(36946,2890),(36947,2899),(36948,2917),(36949,2976),(36950,3012),(36951,3102),(36952,3127),(36953,3128),(36954,3130),(36955,3133),(36956,3134),(36957,3138),(36958,3139),(36959,3141),(36960,3142),(36961,3145),(36962,3146),(36963,3172),(36964,3149),(36965,3152),(36966,3154),(36967,3155),(36968,3156),(36969,3157),(36970,3162),(36971,3163),(36972,3169),(36973,3214),(36974,3336),(36975,3342),(36976,3388),(36977,3488),(36978,2704),(36979,2705),(36980,2706),(36981,2707),(36982,2708),(36983,2709),(36984,2710),(36985,2711),(36986,2712),(36987,2713),(36988,2714),(36989,2715),(36990,2716),(36991,2717),(36992,2718),(36993,2719),(36994,2720),(36995,2721),(36996,2722),(36997,2723),(36998,2725),(36999,3158),(37000,3277),(37001,3479),(37002,3480),(37003,2726),(37004,2727),(37005,2728),(37006,2729),(37007,2730),(37008,2731),(37009,2732),(37010,2733),(37011,2734),(37012,2735),(37013,2736),(37014,2737),(37015,2738),(37016,2739),(37017,2744),(37018,2745),(37019,2746),(37020,2747),(37021,2740),(37022,2750),(37023,2752),(37024,2753),(37025,2754),(37026,2756),(37027,2757),(37028,2758),(37029,2759),(37030,2799),(37031,2800),(37032,2801),(37033,2802),(37034,2803),(37035,2804),(37036,2805),(37037,2806),(37038,2807),(37039,2808),(37040,2809),(37041,2810),(37042,2812),(37043,2814),(37044,2815),(37045,2816),(37046,2818),(37047,2820),(37048,2970),(37049,2977),(37050,3050),(37051,3051),(37052,3055),(37053,3125),(37054,3140),(37055,3144),(37056,3147),(37057,3148),(37058,3713),(37059,3714),(37060,2),(37061,4),(37062,1162),(37063,1163),(37064,1164),(37065,1165),(37066,400),(37067,480),(37068,482),(37069,515),(37070,48),(37071,48),(37072,48),(37073,48),(37074,48),(37075,48),(37076,48),(37077,499),(37078,659),(37079,687),(37080,695),(37081,697),(37082,906),(37083,913),(37084,914),(37085,1004),(37086,1019),(37087,1038),(37088,1092),(37089,1119),(37090,882),(37091,884),(37092,885),(37093,886),(37094,887),(37095,888),(37096,889),(37097,890),(37098,891),(37099,892),(37100,893),(37101,894),(37102,895),(37103,896),(37104,897),(37105,898),(37106,899),(37107,900),(37108,901),(37109,915),(37110,1166),(37111,1167),(37112,321),(37113,342),(37114,418),(37115,436),(37116,542),(37117,543),(37118,553),(37119,766),(37120,809),(37121,843),(37122,1169),(37123,312),(37124,314),(37125,317),(37126,319),(37127,320),(37128,322),(37129,323),(37130,701),(37131,707),(37132,708),(37133,907),(37134,911),(37135,916),(37136,996),(37137,1002),(37138,1034),(37139,917),(37140,918),(37141,919),(37142,920),(37143,921),(37144,922),(37145,923),(37146,928),(37147,929),(37148,931),(37149,934),(37150,936),(37151,937),(37152,938),(37153,939),(37154,942),(37155,948),(37156,949),(37157,950),(37158,951),(37159,952),(37160,953),(37161,954),(37162,955),(37163,956),(37164,957),(37165,958),(37166,959),(37167,960),(37168,961),(37169,962),(37170,963),(37171,964),(37172,965),(37173,966),(37174,967),(37175,973),(37176,974),(37177,975),(37178,976),(37179,977),(37180,978),(37181,979),(37182,980),(37183,981),(37184,982),(37185,983),(37186,984),(37187,985),(37188,986),(37189,987),(37190,992),(37191,993),(37192,994),(37193,995),(37194,1007),(37195,1109),(37196,1115),(37197,1122),(37198,1123),(37199,1136),(37200,1137),(37201,1138),(37202,308),(37203,346),(37204,699),(37205,718),(37206,719),(37207,720),(37208,722),(37209,723),(37210,724),(37211,738),(37212,739),(37213,740),(37214,1003),(37215,1005),(37216,1035),(37217,1039),(37218,1139),(37219,5752),(37220,301),(37221,311),(37222,324),(37223,326),(37224,328),(37225,330),(37226,332),(37227,333),(37228,336),(37229,337),(37230,636),(37231,743),(37232,744),(37233,745),(37234,746),(37235,869),(37236,875),(37237,878),(37238,879),(37239,883),(37240,334),(37241,335),(37242,338),(37243,344),(37244,692),(37245,702),(37246,703),(37247,704),(37248,706),(37249,711),(37250,713),(37251,714),(37252,732),(37253,733),(37254,734),(37255,737),(37256,741),(37257,742),(37258,748),(37259,749),(37260,747),(37261,1021),(37262,1037),(37263,294),(37264,659),(37265,1004),(37266,319),(37267,320),(37268,687),(37269,707),(37270,1012),(37271,1019),(37272,1092),(37273,312),(37274,314),(37275,322),(37276,323),(37277,618),(37278,907),(37279,308),(37280,346),(37281,632),(37282,699),(37283,718),(37284,719),(37285,720),(37286,722),(37287,723),(37288,724),(37289,738),(37290,739),(37291,740),(37292,1003),(37293,1005),(37294,1035),(37295,301),(37296,311),(37297,332),(37298,333),(37299,336),(37300,337),(37301,347),(37302,636),(37303,743),(37304,334),(37305,335),(37306,338),(37307,339),(37308,340),(37309,344),(37310,345),(37311,744),(37312,745),(37313,746),(37314,903),(37315,904),(37316,905),(37317,692),(37318,702),(37319,703),(37320,704),(37321,706),(37322,711),(37323,713),(37324,714),(37325,732),(37326,733),(37327,734),(37328,737),(37329,741),(37330,742),(37331,748),(37332,749),(37333,721),(37334,725),(37335,747),(37336,1037),(37337,296),(37338,374),(37339,375),(37340,376),(37341,527),(37342,528),(37343,529),(37344,531),(37345,557),(37346,560),(37347,587),(37348,646),(37349,588),(37350,589),(37351,590),(37352,591),(37353,592),(37354,611),(37355,613),(37356,617),(37357,619),(37358,624),(37359,637),(37360,639),(37361,639),(37362,648),(37363,652),(37364,670),(37365,672),(37366,778),(37367,779),(37368,834),(37369,835),(37370,836),(37371,837),(37372,838),(37373,839),(37374,639),(37375,648),(37376,652),(37377,670),(37378,672),(37379,778),(37380,779),(37381,834),(37382,835),(37383,836),(37384,837),(37385,838),(37386,839),(37387,281),(37388,284),(37389,648),(37390,652),(37391,670),(37392,672),(37393,778),(37394,779),(37395,834),(37396,835),(37397,836),(37398,837),(37399,838),(37400,839),(37401,840),(37402,286),(37403,287),(37404,289),(37405,291),(37406,292),(37407,294),(37408,297),(37409,530),(37410,532),(37411,625),(37412,660),(37413,691),(37414,693),(37415,694),(37416,906),(37417,997),(37418,998),(37419,999),(37420,1001),(37421,1036),(37422,299),(37423,304),(37424,307),(37425,682),(37426,688),(37427,690),(37428,696),(37429,1000),(37430,1067),(37431,1068),(37432,1069),(37433,1070),(37434,1072),(37435,1073),(37436,1074),(37437,1075),(37438,1133),(37439,298),(37440,300),(37441,321),(37442,342),(37443,687),(37444,695),(37445,697),(37446,698),(37447,700),(37448,705),(37449,1004),(37450,1012),(37451,1019),(37452,1038),(37453,1092),(37454,1119),(37455,317),(37456,319),(37457,320),(37458,322),(37459,323),(37460,701),(37461,707),(37462,708),(37463,907),(37464,996),(37465,1034),(37466,308),(37467,312),(37468,314),(37469,346),(37470,618),(37471,632),(37472,699),(37473,718),(37474,722),(37475,724),(37476,738),(37477,739),(37478,301),(37479,332),(37480,336),(37481,347),(37482,636),(37483,719),(37484,720),(37485,723),(37486,740),(37487,1003),(37488,1005),(37489,1035),(37490,311),(37491,333),(37492,334),(37493,335),(37494,337),(37495,338),(37496,339),(37497,340),(37498,743),(37499,744),(37500,745),(37501,746),(37502,903),(37503,904),(37504,905),(37505,344),(37506,345),(37507,702),(37508,704),(37509,706),(37510,711),(37511,732),(37512,733),(37513,734),(37514,737),(37515,741),(37516,742),(37517,748),(37518,749),(37519,692),(37520,703),(37521,713),(37522,714),(37523,725),(37524,747),(37525,1037),(37526,718),(37527,721),(37528,725),(37529,747),(37530,319),(37531,1060),(37532,1062),(37533,1064),(37534,1061),(37535,469),(37536,558),(37537,559),(37538,596),(37539,597),(37540,600),(37541,601),(37542,614),(37543,615),(37544,645),(37545,650),(37546,651),(37547,656),(37548,664),(37549,771),(37550,772),(37551,780),(37552,815),(37553,855),(37554,856),(37555,470),(37556,518),(37557,599),(37558,753),(37559,814),(37560,875),(37561,902),(37562,936),(37563,937),(37564,938),(37565,939),(37566,980),(37567,981),(37568,982),(37569,983),(37570,1028),(37571,1050),(37572,878),(37573,879),(37574,1021),(37575,553),(37576,913),(37577,914),(37578,915),(37579,957),(37580,958),(37581,959),(37582,1021),(37583,1089),(37584,399),(37585,400),(37586,402),(37587,403),(37588,421),(37589,460),(37590,461),(37591,462),(37592,480),(37593,481),(37594,482),(37595,499),(37596,514),(37597,515),(37598,521),(37599,526),(37600,662),(37601,665),(37602,668),(37603,669),(37604,407),(37605,411),(37606,412),(37607,413),(37608,414),(37609,422),(37610,423),(37611,425),(37612,430),(37613,472),(37614,473),(37615,500),(37616,501),(37617,502),(37618,517),(37619,524),(37620,661),(37621,663),(37622,666),(37623,667),(37624,348),(37625,349),(37626,350),(37627,353),(37628,354),(37629,355),(37630,359),(37631,522),(37632,602),(37633,603),(37634,604),(37635,605),(37636,606),(37637,607),(37638,608),(37639,609),(37640,776),(37641,777),(37642,781),(37643,785),(37644,788),(37645,791),(37646,561),(37647,564),(37648,569),(37649,584),(37650,782),(37651,783),(37652,784),(37653,786),(37654,787),(37655,789),(37656,790),(37657,794),(37658,798),(37659,799),(37660,800),(37661,801),(37662,802),(37663,803),(37664,804),(37665,360),(37666,389),(37667,390),(37668,396),(37669,397),(37670,562),(37671,563),(37672,565),(37673,566),(37674,567),(37675,568),(37676,583),(37677,816),(37678,817),(37679,821),(37680,822),(37681,823),(37682,824),(37683,830),(37684,831),(37685,832),(37686,833),(37687,858),(37688,859),(37689,860),(37690,863),(37691,864),(37692,865),(37693,867),(37694,857),(37695,862),(37696,866),(37697,868),(37698,924),(37699,926),(37700,930),(37701,1006),(37702,1015),(37703,1025),(37704,1026),(37705,1053),(37706,1057),(37707,1112),(37708,1118),(37709,1127),(37710,418),(37711,436),(37712,553),(37713,928),(37714,929),(37715,931),(37716,946),(37717,957),(37718,958),(37719,959),(37720,960),(37721,961),(37722,962),(37723,963),(37724,964),(37725,965),(37726,966),(37727,967),(37728,1059),(37729,1079),(37730,1081),(37731,1083),(37732,1084),(37733,1087),(37734,1089),(37735,311),(37736,332),(37737,333),(37738,336),(37739,337),(37740,878),(37741,879),(37742,970),(37743,971),(37744,973),(37745,974),(37746,975),(37747,988),(37748,1008),(37749,1021),(37750,1094),(37751,1101),(37752,1109),(37753,1115),(37754,1122),(37755,1135),(37756,435),(37757,437),(37758,447),(37759,460),(37760,461),(37761,472),(37762,502),(37763,504),(37764,507),(37765,537),(37766,538),(37767,598),(37768,616),(37769,643),(37770,644),(37771,661),(37772,662),(37773,665),(37774,667),(37775,668),(37776,669),(37777,774),(37778,775),(37779,1040),(37780,351),(37781,352),(37782,356),(37783,357),(37784,361),(37785,471),(37786,473),(37787,605),(37788,609),(37789,635),(37790,671),(37791,675),(37792,676),(37793,678),(37794,679),(37795,776),(37796,777),(37797,788),(37798,358),(37799,565),(37800,566),(37801,750),(37802,787),(37803,794),(37804,798),(37805,799),(37806,803),(37807,804),(37808,821),(37809,822),(37810,830),(37811,857),(37812,858),(37813,866),(37814,1041),(37815,751),(37816,917),(37817,919),(37818,921),(37819,923),(37820,925),(37821,927),(37822,929),(37823,931),(37824,969),(37825,971),(37826,973),(37827,975),(37828,1043),(37829,474),(37830,475),(37831,514),(37832,564),(37833,862),(37834,1044),(37835,1045),(37836,362),(37837,363),(37838,364),(37839,365),(37840,366),(37841,367),(37842,368),(37843,369),(37844,370),(37845,371),(37846,372),(37847,373),(37848,570),(37849,793),(37850,861),(37851,944),(37852,945),(37853,947),(37854,1112),(37855,1118),(37856,626),(37857,629),(37858,630),(37859,946),(37860,988),(37861,989),(37862,990),(37863,991),(37864,519),(37865,520),(37866,523),(37867,525),(37868,916),(37869,1014),(37870,1032),(37871,1040),(37872,1043),(37873,1052),(37874,1056),(37875,1058),(37876,1078),(37877,1080),(37878,1086),(37879,1111),(37880,1117),(37881,1126),(37882,917),(37883,918),(37884,919),(37885,920),(37886,921),(37887,922),(37888,923),(37889,960),(37890,961),(37891,962),(37892,963),(37893,964),(37894,965),(37895,966),(37896,967),(37897,1007),(37898,1093),(37899,1100),(37900,1124),(37901,1134),(37902,400),(37903,480),(37904,482),(37905,499),(37906,515),(37907,882),(37908,884),(37909,885),(37910,886),(37911,887),(37912,890),(37913,892),(37914,894),(37915,895),(37916,898),(37917,899),(37918,1022),(37919,1023),(37920,1106),(37921,458),(37922,883),(37923,888),(37924,889),(37925,891),(37926,893),(37927,896),(37928,897),(37929,900),(37930,901),(37931,1039),(37932,1099),(37933,544),(37934,545),(37935,546),(37936,547),(37937,1060),(37938,1061),(37939,401),(37940,405),(37941,408),(37942,409),(37943,410),(37944,415),(37945,416),(37946,417),(37947,419),(37948,426),(37949,428),(37950,432),(37951,433),(37952,437),(37953,444),(37954,447),(37955,504),(37956,507),(37957,537),(37958,538),(37959,556),(37960,594),(37961,427),(37962,429),(37963,434),(37964,435),(37965,448),(37966,449),(37967,598),(37968,752),(37969,774),(37970,775),(37971,818),(37972,820),(37973,852),(37974,853),(37975,892),(37976,893),(37977,900),(37978,948),(37979,949),(37980,950),(37981,951),(37982,992),(37983,993),(37984,1040),(37985,1047),(37986,1060),(37987,1108),(37988,1114),(37989,994),(37990,995),(37991,1010),(37992,1096),(37993,1103),(37994,1121),(37995,1137),(37996,400),(37997,401),(37998,405),(37999,408),(38000,409),(38001,410),(38002,415),(38003,416),(38004,417),(38005,419),(38006,426),(38007,428),(38008,432),(38009,433),(38010,437),(38011,438),(38012,439),(38013,440),(38014,559),(38015,600),(38016,780),(38017,856),(38018,441),(38019,442),(38020,443),(38021,444),(38022,445),(38023,446),(38024,447),(38025,450),(38026,452),(38027,453),(38028,454),(38029,455),(38030,456),(38031,457),(38032,459),(38033,463),(38034,464),(38035,465),(38036,467),(38037,476),(38038,477),(38039,478),(38040,479),(38041,480),(38042,482),(38043,485),(38044,495),(38045,496),(38046,497),(38047,498),(38048,503),(38049,504),(38050,505),(38051,506),(38052,507),(38053,508),(38054,509),(38055,510),(38056,511),(38057,512),(38058,513),(38059,515),(38060,516),(38061,534),(38062,535),(38063,536),(38064,537),(38065,538),(38066,539),(38067,540),(38068,541),(38069,544),(38070,545),(38071,546),(38072,547),(38073,548),(38074,549),(38075,550),(38076,551),(38077,552),(38078,554),(38079,555),(38080,556),(38081,571),(38082,572),(38083,573),(38084,574),(38085,575),(38086,576),(38087,577),(38088,578),(38089,579),(38090,580),(38091,581),(38092,582),(38093,586),(38094,594),(38095,595),(38096,598),(38097,610),(38098,612),(38099,621),(38100,633),(38101,634),(38102,638),(38103,647),(38104,649),(38105,653),(38106,654),(38107,657),(38108,674),(38109,755),(38110,757),(38111,758),(38112,760),(38113,763),(38114,764),(38115,765),(38116,768),(38117,769),(38118,427),(38119,429),(38120,434),(38121,435),(38122,448),(38123,449),(38124,451),(38125,770),(38126,774),(38127,775),(38128,805),(38129,808),(38130,810),(38131,813),(38132,818),(38133,819),(38134,820),(38135,826),(38136,827),(38137,828),(38138,841),(38139,850),(38140,852),(38141,853),(38142,466),(38143,468),(38144,483),(38145,484),(38146,486),(38147,487),(38148,488),(38149,489),(38150,490),(38151,491),(38152,492),(38153,493),(38154,494),(38155,499),(38156,533),(38157,585),(38158,593),(38159,620),(38160,622),(38161,623),(38162,640),(38163,641),(38164,642),(38165,655),(38166,658),(38167,752),(38168,754),(38169,1020),(38170,756),(38171,759),(38172,761),(38173,762),(38174,767),(38175,773),(38176,806),(38177,807),(38178,811),(38179,812),(38180,829),(38181,842),(38182,844),(38183,845),(38184,846),(38185,847),(38186,848),(38187,849),(38188,851),(38189,854),(38190,909),(38191,910),(38192,912),(38193,932),(38194,933),(38195,935),(38196,940),(38197,941),(38198,943),(38199,1023),(38200,1106),(38201,1013),(38202,1016),(38203,1017),(38204,1027),(38205,1029),(38206,1030),(38207,1031),(38208,1033),(38209,1042),(38210,1046),(38211,1047),(38212,1048),(38213,1107),(38214,1108),(38215,1110),(38216,1113),(38217,1114),(38218,1116),(38219,1128),(38220,882),(38221,884),(38222,885),(38223,886),(38224,887),(38225,890),(38226,892),(38227,894),(38228,895),(38229,897),(38230,898),(38231,899),(38232,900),(38233,1018),(38234,1049),(38235,1051),(38236,1054),(38237,1055),(38238,1065),(38239,1076),(38240,1077),(38241,1082),(38242,1085),(38243,1088),(38244,1090),(38245,1091),(38246,1129),(38247,1130),(38248,1131),(38249,1132),(38250,542),(38251,543),(38252,766),(38253,809),(38254,843),(38255,888),(38256,889),(38257,891),(38258,893),(38259,896),(38260,901),(38261,934),(38262,942),(38263,948),(38264,949),(38265,950),(38266,951),(38267,952),(38268,953),(38269,954),(38270,955),(38271,956),(38272,976),(38273,977),(38274,978),(38275,979),(38276,984),(38277,985),(38278,986),(38279,987),(38280,992),(38281,993),(38282,994),(38283,995),(38284,1009),(38285,1010),(38286,1011),(38287,1095),(38288,1096),(38289,1097),(38290,1098),(38291,1102),(38292,458),(38293,869),(38294,883),(38295,1039),(38296,1099),(38297,1103),(38298,1104),(38299,1105),(38300,1120),(38301,1121),(38302,1123),(38303,1136),(38304,1137),(38305,1138),(38306,1139),(38307,1021),(38308,1022),(38309,2),(38310,1162),(38311,1163),(38312,1164),(38313,1165),(38314,1761),(38315,1762),(38316,1779),(38317,4524),(38318,4524),(38319,1673),(38320,1674),(38321,1790),(38322,4506),(38323,4507),(38324,4508),(38325,4511),(38326,4512),(38327,4513),(38328,4514),(38329,4566),(38330,4567),(38331,4577),(38332,5336),(38333,1332),(38334,4500),(38335,4501),(38336,4502),(38337,4503),(38338,4504),(38339,4505),(38340,4509),(38341,4510),(38342,4515),(38343,4516),(38344,4521),(38345,4522),(38346,4523),(38347,4525),(38348,1210),(38349,4517),(38350,4518),(38351,4519),(38352,4520),(38353,4568),(38354,4569),(38355,4570),(38356,4571),(38357,1749),(38358,1396),(38359,1406),(38360,1427),(38361,5323),(38362,5487),(38363,1208),(38364,1217),(38365,1218),(38366,1219),(38367,1220),(38368,1221),(38369,1222),(38370,1223),(38371,1224),(38372,1225),(38373,1226),(38374,1227),(38375,5330),(38376,5335),(38377,5355),(38378,5520),(38379,5521),(38380,5522),(38381,5523),(38382,1228),(38383,1240),(38384,1241),(38385,1246),(38386,1247),(38387,1310),(38388,1311),(38389,1312),(38390,1313),(38391,1314),(38392,1315),(38393,1316),(38394,1317),(38395,1318),(38396,1319),(38397,1320),(38398,1321),(38399,1322),(38400,1323),(38401,1330),(38402,1331),(38403,1336),(38404,1340),(38405,1344),(38406,1345),(38407,1348),(38408,1352),(38409,1375),(38410,1376),(38411,1377),(38412,1380),(38413,1209),(38414,1239),(38415,1248),(38416,1257),(38417,1258),(38418,1302),(38419,1303),(38420,1381),(38421,1382),(38422,1384),(38423,1385),(38424,1402),(38425,1403),(38426,1404),(38427,1419),(38428,1436),(38429,1450),(38430,1451),(38431,1452),(38432,1454),(38433,1455),(38434,1456),(38435,1457),(38436,1467),(38437,1249),(38438,1250),(38439,1251),(38440,1523),(38441,1533),(38442,1536),(38443,1664),(38444,1667),(38445,1781),(38446,1782),(38447,4572),(38448,5325),(38449,5326),(38450,5327),(38451,5331),(38452,5333),(38453,1252),(38454,1253),(38455,1254),(38456,1255),(38457,1256),(38458,1259),(38459,1260),(38460,1261),(38461,1262),(38462,1263),(38463,1264),(38464,1265),(38465,1266),(38466,1267),(38467,1268),(38468,1269),(38469,1270),(38470,1271),(38471,1272),(38472,1273),(38473,1274),(38474,1275),(38475,1276),(38476,1277),(38477,1278),(38478,1279),(38479,1280),(38480,1281),(38481,1282),(38482,1283),(38483,1284),(38484,1285),(38485,1286),(38486,1287),(38487,1329),(38488,1333),(38489,1334),(38490,1335),(38491,1337),(38492,1339),(38493,1369),(38494,1213),(38495,1214),(38496,1215),(38497,1216),(38498,1293),(38499,1294),(38500,1295),(38501,1296),(38502,1297),(38503,1298),(38504,1299),(38505,1300),(38506,1301),(38507,1370),(38508,1372),(38509,1373),(38510,1374),(38511,1379),(38512,1383),(38513,1389),(38514,1390),(38515,1391),(38516,1392),(38517,1393),(38518,1394),(38519,1395),(38520,1397),(38521,1398),(38522,1399),(38523,1400),(38524,1405),(38525,1465),(38526,5323),(38527,5324),(38528,5328),(38529,5329),(38530,5390),(38531,5474),(38532,5475),(38533,5476),(38534,5477),(38535,5478),(38536,5479),(38537,5480),(38538,5481),(38539,5482),(38540,5483),(38541,5484),(38542,5485),(38543,5486),(38544,5704),(38545,5705),(38546,5706),(38547,1195),(38548,1196),(38549,1197),(38550,1198),(38551,1199),(38552,1200),(38553,1201),(38554,1202),(38555,1203),(38556,1204),(38557,1205),(38558,1206),(38559,1207),(38560,1211),(38561,1212),(38562,1229),(38563,1230),(38564,1233),(38565,1236),(38566,5487),(38567,5488),(38568,1237),(38569,1288),(38570,1289),(38571,1290),(38572,1291),(38573,1292),(38574,1304),(38575,1305),(38576,1306),(38577,1307),(38578,1308),(38579,1309),(38580,1325),(38581,1328),(38582,1338),(38583,1341),(38584,1346),(38585,1347),(38586,1350),(38587,1351),(38588,1359),(38589,1360),(38590,1361),(38591,1362),(38592,1363),(38593,1364),(38594,1365),(38595,1366),(38596,1367),(38597,1368),(38598,1387),(38599,1401),(38600,1410),(38601,1426),(38602,1438),(38603,1439),(38604,1443),(38605,1444),(38606,1445),(38607,1231),(38608,1232),(38609,1234),(38610,1242),(38611,1243),(38612,1244),(38613,1245),(38614,1342),(38615,1349),(38616,1411),(38617,1446),(38618,1448),(38619,1466),(38620,1353),(38621,1354),(38622,1355),(38623,1356),(38624,1357),(38625,1358),(38626,1412),(38627,1413),(38628,1414),(38629,1415),(38630,1416),(38631,1437),(38632,1440),(38633,1449),(38634,1453),(38635,1464),(38636,1468),(38637,5327),(38638,5334),(38639,5370),(38640,5371),(38641,5372),(38642,5373),(38643,5374),(38644,5375),(38645,5376),(38646,5377),(38647,1447),(38648,5351),(38649,5352),(38650,5356),(38651,5390),(38652,1420),(38653,1421),(38654,1422),(38655,1423),(38656,1424),(38657,1425),(38658,1427),(38659,1428),(38660,1429),(38661,1430),(38662,1431),(38663,1432),(38664,1433),(38665,1434),(38666,1558),(38667,1559),(38668,5332),(38669,1168),(38670,1170),(38671,1171),(38672,1172),(38673,1173),(38674,1182),(38675,1183),(38676,1235),(38677,1324),(38678,1326),(38679,1327),(38680,1329),(38681,1343),(38682,1371),(38683,1532),(38684,5332),(38685,5337),(38686,5343),(38687,5344),(38688,5351),(38689,5352),(38690,5354),(38691,5474),(38692,5476),(38693,5526),(38694,1386),(38695,1388),(38696,1407),(38697,1408),(38698,1409),(38699,1417),(38700,1418),(38701,1435),(38702,1441),(38703,1442),(38704,1458),(38705,1459),(38706,1461),(38707,1469),(38708,1488),(38709,1489),(38710,1491),(38711,1492),(38712,1494),(38713,5489),(38714,1188),(38715,1524),(38716,1526),(38717,1528),(38718,1666),(38719,1529),(38720,1534),(38721,1535),(38722,1557),(38723,1799),(38724,1800),(38725,1175),(38726,1176),(38727,1177),(38728,1178),(38729,1179),(38730,1180),(38731,1181),(38732,1185),(38733,1186),(38734,1187),(38735,1190),(38736,1192),(38737,1193),(38738,1518),(38739,1519),(38740,1520),(38741,1521),(38742,1563),(38743,1564),(38744,1565),(38745,1665),(38746,1675),(38747,1676),(38748,1677),(38749,1678),(38750,1751),(38751,1752),(38752,1753),(38753,1761),(38754,1762),(38755,1778),(38756,1779),(38757,377),(38758,378),(38759,379),(38760,380),(38761,381),(38762,382),(38763,383),(38764,384),(38765,385),(38766,386),(38767,387),(38768,388),(38769,391),(38770,392),(38771,394),(38772,395),(38773,1527),(38774,1522),(38775,1525),(38776,1530),(38777,1534),(38778,1535),(38779,1661),(38780,1662),(38781,1663),(38782,1668),(38783,1669),(38784,1670),(38785,1671),(38786,1745),(38787,1747),(38788,1794),(38789,1801),(38790,1802),(38791,1191),(38792,1522),(38793,1524),(38794,1525),(38795,1526),(38796,1528),(38797,1529),(38798,1530),(38799,1531),(38800,1535),(38801,1661),(38802,1662),(38803,1663),(38804,1177),(38805,1178),(38806,1179),(38807,1180),(38808,1181),(38809,1563),(38810,1564),(38811,1565),(38812,1566),(38813,1675),(38814,1676),(38815,1677),(38816,1678),(38817,1761),(38818,1762),(38819,1778),(38820,1779),(38821,356),(38822,607),(38823,608),(38824,1518),(38825,1519),(38826,1520),(38827,1521),(38828,1665),(38829,1666),(38830,1751),(38831,1752),(38832,1753),(38833,1754),(38834,1755),(38835,1756),(38836,1757),(38837,1758),(38838,1786),(38839,1787),(38840,1788),(38841,1789),(38842,1790),(38843,389),(38844,390),(38845,396),(38846,397),(38847,563),(38848,606),(38849,777),(38850,789),(38851,795),(38852,798),(38853,799),(38854,800),(38855,801),(38856,802),(38857,803),(38858,804),(38859,823),(38860,832),(38861,833),(38862,830),(38863,831),(38864,859),(38865,860),(38866,866),(38867,867),(38868,868),(38869,1189),(38870,1522),(38871,1524),(38872,1525),(38873,1526),(38874,1527),(38875,1528),(38876,1669),(38877,1671),(38878,1745),(38879,1422),(38880,1529),(38881,1530),(38882,1531),(38883,1534),(38884,1535),(38885,1587),(38886,1661),(38887,1662),(38888,1663),(38889,1668),(38890,1670),(38891,1672),(38892,1744),(38893,1746),(38894,1793),(38895,1794),(38896,1795),(38897,1799),(38898,1800),(38899,1801),(38900,1802),(38901,2),(38902,4),(38903,1162),(38904,1163),(38905,1164),(38906,1165),(38907,2449),(38908,5394),(38909,5489),(38910,1471),(38911,1567),(38912,5282),(38913,5283),(38914,5284),(38915,5301),(38916,5389),(38917,5393),(38918,5394),(38919,5395),(38920,5468),(38921,5489),(38922,5598),(38923,5650),(38924,5673),(38925,1700),(38926,2699),(38927,5365),(38928,5527),(38929,5528),(38930,5621),(38931,5627),(38932,5637),(38933,5644),(38934,5645),(38935,5646),(38936,5652),(38937,5654),(38938,5663),(38939,5670),(38940,5671),(38941,5672),(38942,5490),(38943,5491),(38944,5492),(38945,5493),(38946,5494),(38947,5495),(38948,5496),(38949,5497),(38950,5498),(38951,5499),(38952,5500),(38953,5501),(38954,5502),(38955,5503),(38956,5504),(38957,5505),(38958,5506),(38959,5507),(38960,5508),(38961,5509),(38962,5510),(38963,5511),(38964,5512),(38965,5513),(38966,5514),(38967,5515),(38968,5516),(38969,5517),(38970,2921),(38971,5359),(38972,5360),(38973,5367),(38974,5529),(38975,5530),(38976,5363),(38977,5366),(38978,5636),(38979,5651),(38980,5662),(38981,4622),(38982,4623),(38983,4624),(38984,4853),(38985,4854),(38986,4855),(38987,4888),(38988,5598),(38989,5660),(38990,5695),(38991,1184),(38992,1238),(38993,1378),(38994,1462),(38995,5361),(38996,5362),(38997,5364),(38998,5626),(38999,5639),(39000,5640),(39001,5648),(39002,5665),(39003,5666),(39004,5628),(39005,5646),(39006,5672),(39007,2126),(39008,2127),(39009,2128),(39010,2129),(39011,2130),(39012,2131),(39013,2132),(39014,2323),(39015,2324),(39016,2449),(39017,2427),(39018,2126),(39019,2127),(39020,2128),(39021,2129),(39022,2130),(39023,2131),(39024,2132),(39025,2323),(39026,2324),(39027,2449),(39028,1816),(39029,1818),(39030,1822),(39031,1827),(39032,1965),(39033,1966),(39034,1972),(39035,1983),(39036,1984),(39037,1986),(39038,2008),(39039,2013),(39040,2014),(39041,2035),(39042,2037),(39043,2041),(39044,1813),(39045,1815),(39046,1820),(39047,1973),(39048,1974),(39049,1975),(39050,1976),(39051,1977),(39052,1978),(39053,1979),(39054,1980),(39055,1982),(39056,1985),(39057,1987),(39058,1988),(39059,1989),(39060,1990),(39061,1814),(39062,1817),(39063,1819),(39064,1821),(39065,1823),(39066,1824),(39067,1825),(39068,1826),(39069,1967),(39070,1968),(39071,1971),(39072,1981),(39073,2299),(39074,2404),(39075,2531),(39076,5622),(39077,5641),(39078,5667),(39079,1828),(39080,1829),(39081,1830),(39082,1831),(39083,1832),(39084,1833),(39085,1950),(39086,1952),(39087,1969),(39088,1970),(39089,2021),(39090,2022),(39091,2154),(39092,2177),(39093,2221),(39094,2222),(39095,2435),(39096,2540),(39097,2541),(39098,2542),(39099,2265),(39100,2266),(39101,2267),(39102,2268),(39103,2269),(39104,2276),(39105,2317),(39106,2318),(39107,2319),(39108,2320),(39109,2321),(39110,2322),(39111,2397),(39112,2398),(39113,2399),(39114,2400),(39115,2401),(39116,2403),(39117,2405),(39118,2406),(39119,2407),(39120,2408),(39121,2409),(39122,2410),(39123,2589),(39124,2590),(39125,2591),(39126,2592),(39127,2593),(39128,2594),(39129,2595),(39130,2598),(39131,2599),(39132,2600),(39133,2601),(39134,2602),(39135,2603),(39136,2604),(39137,2605),(39138,2606),(39139,2607),(39140,2596),(39141,2597),(39142,2608),(39143,2609),(39144,2610),(39145,2611),(39146,2612),(39147,2613),(39148,2614),(39149,4894),(39150,4894),(39151,4894),(39152,5753),(39153,5753),(39154,2176),(39155,2176),(39156,2176),(39157,5753),(39158,7),(39159,7),(39160,7),(39161,7),(39162,7),(39163,7),(39164,7),(39165,7),(39166,5757),(39167,5757),(39168,5757),(39169,5757),(39170,5757),(39171,5757),(39172,5757),(39173,5757),(39174,5757),(39175,5757),(39176,5757),(39177,5757),(39178,5757),(39179,5757),(39180,5757),(39181,5757),(39182,5757),(39183,5758),(39184,5758),(39185,5758),(39186,5758),(39187,5758),(39188,5758),(39189,5758),(39190,5758),(39191,5758),(39192,5758),(39193,5758),(39194,5758),(39195,5758),(39196,5758),(39197,5758),(39198,5758),(39199,5758),(39200,5759),(39201,5759),(39202,5759),(39203,5759),(39204,5759),(39205,5759),(39206,5759),(39207,5759),(39208,5759),(39209,5759),(39210,5759),(39211,5759),(39212,5759),(39213,5759),(39214,5759),(39215,5759),(39216,5759),(39217,1165),(39218,1165),(39219,2026),(39220,2027),(39221,2028),(39222,2029),(39223,2030),(39224,2031),(39225,2032),(39226,2034),(39227,2039),(39228,2040),(39229,2042),(39230,2044),(39231,2045),(39232,2046),(39233,2122),(39234,2123),(39235,2124),(39236,2125),(39237,2133),(39238,2134),(39239,2135),(39240,2136),(39241,2137),(39242,2138),(39243,2139),(39244,2140),(39245,2141),(39246,2142),(39247,2143),(39248,2144),(39249,2145),(39250,2146),(39251,2147),(39252,2148),(39253,2149),(39254,2150),(39255,2151),(39256,2152),(39257,2153),(39258,2275),(39259,2325),(39260,2326),(39261,2327),(39262,2328),(39263,2329),(39264,2330),(39265,2331),(39266,2332),(39267,2333),(39268,2334),(39269,2335),(39270,2336),(39271,2337),(39272,2338),(39273,2339),(39274,2340),(39275,2341),(39276,2342),(39277,2343),(39278,2344),(39279,2345),(39280,2346),(39281,2347),(39282,2348),(39283,2349),(39284,2350),(39285,2351),(39286,2352),(39287,2353),(39288,2354),(39289,2355),(39290,2356),(39291,2357),(39292,2358),(39293,2359),(39294,2360),(39295,2361),(39296,2362),(39297,2363),(39298,2364),(39299,2365),(39300,2366),(39301,2367),(39302,2368),(39303,2369),(39304,2370),(39305,2371),(39306,2372),(39307,2373),(39308,2374),(39309,2375),(39310,2376),(39311,2377),(39312,2378),(39313,2379),(39314,2380),(39315,2381),(39316,2382),(39317,2383),(39318,2384),(39319,2385),(39320,2386),(39321,2387),(39322,2388),(39323,2389),(39324,2390),(39325,2391),(39326,2559),(39327,51),(39328,51),(39329,51),(39330,51),(39331,51),(39332,51),(39333,51),(39334,51),(39335,221),(39336,221),(39337,221),(39338,221),(39339,221),(39340,221),(39341,221),(39342,221),(39343,112),(39344,112),(39345,112),(39346,112),(39347,112),(39348,112),(39349,112),(39350,112),(39351,18),(39352,18),(39353,18),(39354,18),(39355,18),(39356,18),(39357,18),(39358,18),(39359,1623),(39360,1623),(39361,1623),(39362,1623),(39363,1623),(39364,1623),(39365,1623),(39366,1623),(39367,2289),(39368,2289),(39369,2289),(39370,2289),(39371,2289),(39372,2289),(39373,2289),(39374,2289),(39375,2289),(39376,2289),(39377,2289),(39378,2289),(39379,2289),(39380,2289),(39381,1164),(39382,1164),(39383,1162),(39384,1162),(39385,4370),(39386,4371),(39387,4372),(39388,4373),(39389,4374),(39390,4375),(39391,4376),(39392,4377),(39393,4378),(39394,4379),(39395,4380),(39396,4381),(39397,4382),(39398,4383),(39399,4384),(39400,4385),(39401,4386),(39402,4387),(39403,4388),(39404,4389),(39405,1629),(39406,1630),(39407,1631),(39408,1632),(39409,1633),(39410,1634),(39411,1635),(39412,1681),(39413,1682),(39414,1683),(39415,1684),(39416,1685),(39417,1686),(39418,4368),(39419,4369),(39420,2704),(39421,2705),(39422,2706),(39423,2707),(39424,2708),(39425,2709),(39426,2710),(39427,2711),(39428,2712),(39429,2713),(39430,2714),(39431,2715),(39432,2716),(39433,2717),(39434,2718),(39435,2719),(39436,2720),(39437,2721),(39438,2722),(39439,2723),(39440,2724),(39441,2725),(39442,2726),(39443,2727),(39444,2728),(39445,2729),(39446,2730),(39447,2731),(39448,2732),(39449,2733),(39450,2734),(39451,2735),(39452,2736),(39453,2737),(39454,2738),(39455,2739),(39456,2740),(39457,2741),(39458,2742),(39459,2743),(39460,2744),(39461,2745),(39462,2746),(39463,2747),(39464,2748),(39465,2749),(39466,2750),(39467,2751),(39468,2752),(39469,2753),(39470,2754),(39471,2755),(39472,2756),(39473,2757),(39474,2758),(39475,2759),(39476,2797),(39477,2857),(39478,2894),(39479,2904),(39480,2977),(39481,2988),(39482,3118),(39483,3623),(39484,7),(39485,8),(39486,9),(39487,10),(39488,11),(39489,12),(39490,13),(39491,14),(39492,15),(39493,16),(39494,17),(39495,18),(39496,19),(39497,20),(39498,21),(39499,22),(39500,23),(39501,24),(39502,25),(39503,26),(39504,27),(39505,28),(39506,29),(39507,30),(39508,31),(39509,32),(39510,33),(39511,34),(39512,35),(39513,36),(39514,37),(39515,38),(39516,45),(39517,46),(39518,47),(39519,48),(39520,49),(39521,50),(39522,51),(39523,52),(39524,53),(39525,54),(39526,55),(39527,56),(39528,57),(39529,58),(39530,59),(39531,60),(39532,61),(39533,62),(39534,63),(39535,64),(39536,65),(39537,66),(39538,67),(39539,68),(39540,69),(39541,70),(39542,71),(39543,72),(39544,73),(39545,74),(39546,75),(39547,76),(39548,77),(39549,78),(39550,79),(39551,80),(39552,81),(39553,82),(39554,83),(39555,84),(39556,85),(39557,86),(39558,87),(39559,88),(39560,89),(39561,90),(39562,91),(39563,92),(39564,93),(39565,94),(39566,95),(39567,110),(39568,111),(39569,112),(39570,113),(39571,114),(39572,115),(39573,116),(39574,117),(39575,118),(39576,119),(39577,120),(39578,121),(39579,122),(39580,123),(39581,124),(39582,125),(39583,126),(39584,127),(39585,128),(39586,129),(39587,130),(39588,131),(39589,132),(39590,133),(39591,134),(39592,135),(39593,136),(39594,137),(39595,140),(39596,141),(39597,142),(39598,143),(39599,144),(39600,145),(39601,146),(39602,147),(39603,148),(39604,149),(39605,150),(39606,151),(39607,152),(39608,153),(39609,154),(39610,155),(39611,156),(39612,157),(39613,158),(39614,159),(39615,1567),(39616,5378),(39617,5379),(39618,5380),(39619,5381),(39620,5382),(39621,5383),(39622,5384),(39623,5385),(39624,5386),(39625,5387),(39626,5388),(39627,5389),(39628,5391),(39629,5392),(39630,5673),(39631,5750),(39632,5751),(39633,1002),(39634,1003),(39635,1005),(39636,1034),(39637,1035),(39638,1036),(39639,1038),(39640,1133),(39641,1972),(39642,1973),(39643,1974),(39644,1975),(39645,1976),(39646,1977),(39647,1978),(39648,1979),(39649,1980),(39650,1981),(39651,1982),(39652,1983),(39653,1984),(39654,1985),(39655,1986),(39656,1987),(39657,1988),(39658,1989),(39659,1990),(39660,1991),(39661,2003),(39662,2004),(39663,2005),(39664,2006),(39665,2007),(39666,2008),(39667,2009),(39668,2010),(39669,2011),(39670,2012),(39671,2013),(39672,2014),(39673,2015),(39674,2016),(39675,2017),(39676,2018),(39677,2019),(39678,2020),(39679,2021),(39680,2022),(39681,2023),(39682,2024),(39683,2025),(39684,2033),(39685,2035),(39686,2036),(39687,2037),(39688,2038),(39689,2041),(39690,2043),(39691,2047),(39692,2048),(39693,2049),(39694,2050),(39695,2051),(39696,2052),(39697,2053),(39698,2054),(39699,2055),(39700,2056),(39701,2057),(39702,2058),(39703,2059),(39704,2060),(39705,2061),(39706,2062),(39707,2063),(39708,2064),(39709,2065),(39710,2066),(39711,2067),(39712,2068),(39713,2069),(39714,2070),(39715,2071),(39716,2072),(39717,2073),(39718,2074),(39719,2075),(39720,2076),(39721,2077),(39722,2078),(39723,2079),(39724,2080),(39725,2081),(39726,2082),(39727,2083),(39728,2084),(39729,2085),(39730,2086),(39731,2087),(39732,2088),(39733,2089),(39734,2090),(39735,2091),(39736,2092),(39737,2093),(39738,2094),(39739,2095),(39740,2096),(39741,2097),(39742,2098),(39743,2099),(39744,2100),(39745,2101),(39746,2102),(39747,2103),(39748,2104),(39749,2105),(39750,2106),(39751,2107),(39752,2108),(39753,2109),(39754,2110),(39755,2111),(39756,2112),(39757,2113),(39758,2114),(39759,2115),(39760,2116),(39761,2117),(39762,2118),(39763,2119),(39764,2120),(39765,2121),(39766,2155),(39767,2156),(39768,2157),(39769,2165),(39770,2166),(39771,2167),(39772,2168),(39773,2169),(39774,2178),(39775,2179),(39776,2180),(39777,2221),(39778,2222),(39779,2252),(39780,2253),(39781,2254),(39782,2255),(39783,2263),(39784,2264),(39785,2272),(39786,2273),(39787,2274),(39788,2283),(39789,2284),(39790,2285),(39791,2286),(39792,2287),(39793,2288),(39794,2450),(39795,2451),(39796,2452),(39797,2453),(39798,2465),(39799,2466),(39800,2467),(39801,2468),(39802,2469),(39803,2470),(39804,2471),(39805,2501),(39806,2502),(39807,2552),(39808,2555),(39809,2556),(39810,2557),(39811,2558),(39812,2560),(39813,2561),(39814,2562),(39815,2563),(39816,2564),(39817,2565),(39818,2566),(39819,2567),(39820,2568),(39821,2569),(39822,2570),(39823,2571),(39824,2572),(39825,2588),(39826,2615),(39827,2616),(39828,2617),(39829,2618),(39830,2619),(39831,2620),(39832,2621),(39833,681),(39834,682),(39835,687),(39836,688),(39837,690),(39838,691),(39839,692),(39840,693),(39841,694),(39842,695),(39843,696),(39844,697),(39845,698),(39846,699),(39847,700),(39848,701),(39849,702),(39850,703),(39851,704),(39852,705),(39853,706),(39854,707),(39855,708),(39856,711),(39857,713),(39858,714),(39859,718),(39860,719),(39861,720),(39862,721),(39863,722),(39864,723),(39865,724),(39866,725),(39867,732),(39868,733),(39869,734),(39870,737),(39871,738),(39872,739),(39873,740),(39874,741),(39875,742),(39876,743),(39877,744),(39878,745),(39879,746),(39880,747),(39881,748),(39882,749),(39883,996),(39884,997),(39885,998),(39886,999),(39887,1000),(39888,1001),(39889,683),(39890,684),(39891,685),(39892,686),(39893,689),(39894,709),(39895,710),(39896,712),(39897,715),(39898,716),(39899,717),(39900,726),(39901,727),(39902,728),(39903,729),(39904,730),(39905,731),(39906,735),(39907,736),(39908,3028),(39909,3029),(39910,3030),(39911,3031),(39912,3032),(39913,3033),(39914,3034),(39915,3035),(39916,3036),(39917,3037),(39918,3038),(39919,3039),(39920,3040),(39921,3041),(39922,3044),(39923,3045),(39924,3046),(39925,3047),(39926,3048),(39927,3049),(39928,3056),(39929,3057),(39930,3058),(39931,3059),(39932,3060),(39933,3061),(39934,3062),(39935,3063),(39936,3064),(39937,3065),(39938,3066),(39939,3067),(39940,3068),(39941,3069),(39942,3070),(39943,3071),(39944,3072),(39945,3073),(39946,3074),(39947,3075),(39948,3076),(39949,3077),(39950,3078),(39951,3079),(39952,3080),(39953,3081),(39954,3082),(39955,3083),(39956,3084),(39957,3085),(39958,3086),(39959,3087),(39960,3088),(39961,3089),(39962,3090),(39963,3091),(39964,3092),(39965,3093),(39966,3094),(39967,3095),(39968,3096),(39969,3097),(39970,3098),(39971,3099),(39972,3100),(39973,3101),(39974,3103),(39975,3104),(39976,3105),(39977,3106),(39978,3107),(39979,3108),(39980,3109),(39981,3110),(39982,3111),(39983,3112),(39984,3113),(39985,3114),(39986,3115),(39987,3116),(39988,3117),(39989,3119),(39990,3120),(39991,3121),(39992,3122),(39993,3123),(39994,3124),(39995,3528),(39996,3529),(39997,3530),(39998,3531),(39999,3532),(40000,3533),(40001,3537),(40002,3538),(40003,3543),(40004,3544),(40005,3545),(40006,3546),(40007,3547),(40008,3548),(40009,3549),(40010,3550),(40011,3551),(40012,3552),(40013,3553),(40014,3554),(40015,3555),(40016,3556),(40017,3557),(40018,3558),(40019,3559),(40020,3560),(40021,3561),(40022,3562),(40023,3563),(40024,3564),(40025,3565),(40026,3566),(40027,3567),(40028,3568),(40029,3569),(40030,3570),(40031,3571),(40032,3572),(40033,3581),(40034,3582),(40035,3584),(40036,3585),(40037,3586),(40038,3587),(40039,3588),(40040,3589),(40041,3590),(40042,3591),(40043,3610),(40044,3611),(40045,3612),(40046,3613),(40047,3614),(40048,3615),(40049,3616),(40050,3617),(40051,3618),(40052,3619),(40053,3620),(40054,3621),(40055,3622),(40056,3624),(40057,3625),(40058,3626),(40059,3627),(40060,3628),(40061,3629),(40062,3630),(40063,3631),(40064,3632),(40065,3633),(40066,3634),(40067,3635),(40068,3636),(40069,3637),(40070,3638),(40071,3639),(40072,3640),(40073,3641),(40074,3642),(40075,3643),(40076,3644),(40077,3645),(40078,3646),(40079,3647),(40080,3649),(40081,3650),(40082,3651),(40083,3652),(40084,3653),(40085,3654),(40086,3655),(40087,3656),(40088,3657),(40089,3658),(40090,3659),(40091,3660),(40092,3661),(40093,3662),(40094,3663),(40095,3664),(40096,3665),(40097,3666),(40098,3667),(40099,3668),(40100,3669),(40101,3670),(40102,3671),(40103,3672),(40104,3673),(40105,3674),(40106,3684),(40107,3685),(40108,2701),(40109,2702),(40110,2760),(40111,2761),(40112,2762),(40113,2763),(40114,2764),(40115,2765),(40116,2772),(40117,2774),(40118,2775),(40119,2776),(40120,2777),(40121,2778),(40122,2779),(40123,2780),(40124,2783),(40125,2784),(40126,2785),(40127,2786),(40128,2787),(40129,2788),(40130,2789),(40131,2790),(40132,2791),(40133,2792),(40134,2799),(40135,2800),(40136,2801),(40137,2802),(40138,2803),(40139,2804),(40140,2805),(40141,2806),(40142,2807),(40143,2808),(40144,2809),(40145,2810),(40146,2811),(40147,2812),(40148,2813),(40149,2814),(40150,2815),(40151,2816),(40152,2817),(40153,2818),(40154,2819),(40155,2820),(40156,2822),(40157,2823),(40158,2824),(40159,2825),(40160,2826),(40161,2827),(40162,2831),(40163,2832),(40164,2844),(40165,2845),(40166,2846),(40167,2847),(40168,2848),(40169,2849),(40170,2850),(40171,2851),(40172,2852),(40173,2853),(40174,2854),(40175,2855),(40176,2856),(40177,2859),(40178,2860),(40179,2861),(40180,2862),(40181,2864),(40182,2865),(40183,2868),(40184,2869),(40185,2870),(40186,2871),(40187,2872),(40188,2873),(40189,2874),(40190,2875),(40191,2876),(40192,2877),(40193,2878),(40194,2879),(40195,2880),(40196,2881),(40197,2882),(40198,2883),(40199,2884),(40200,2885),(40201,2886),(40202,2887),(40203,2888),(40204,2889),(40205,2892),(40206,2893),(40207,2900),(40208,2901),(40209,2902),(40210,2903),(40211,2905),(40212,2906),(40213,2907),(40214,2908),(40215,2909),(40216,2910),(40217,2911),(40218,2912),(40219,2913),(40220,2914),(40221,2915),(40222,2916),(40223,2955),(40224,2956),(40225,2957),(40226,2958),(40227,2959),(40228,2960),(40229,2961),(40230,2962),(40231,2963),(40232,2964),(40233,2965),(40234,2966),(40235,2967),(40236,2968),(40237,2981),(40238,2982),(40239,2983),(40240,2984),(40241,2985),(40242,2986),(40243,2991),(40244,2992),(40245,3013),(40246,3014),(40247,3015),(40248,3016),(40249,3017),(40250,3018),(40251,3019),(40252,3020),(40253,3021),(40254,3022),(40255,3023),(40256,3024),(40257,3025),(40258,3026),(40259,3027),(40260,4147),(40261,4148),(40262,4149),(40263,4152),(40264,4153),(40265,4154),(40266,4156),(40267,4168),(40268,4248),(40269,4297),(40270,4298),(40271,4299),(40272,4300),(40273,4301),(40274,4302),(40275,4303),(40276,4304),(40277,4359),(40278,4458),(40279,4459),(40280,3842),(40281,3846),(40282,3882),(40283,3903),(40284,3973),(40285,4057),(40286,4127),(40287,4128),(40288,4129),(40289,4130),(40290,4131),(40291,4132),(40292,4133),(40293,4134),(40294,4135),(40295,4136),(40296,4137),(40297,4138),(40298,4139),(40299,4140),(40300,4141),(40301,4145),(40302,4146),(40303,3767),(40304,3768),(40305,3769),(40306,3770),(40307,3771),(40308,3772),(40309,3773),(40310,3775),(40311,3868),(40312,3874),(40313,3884),(40314,3889),(40315,3904),(40316,3905),(40317,3913),(40318,3914),(40319,3915),(40320,3916),(40321,3917),(40322,3963),(40323,3970),(40324,3974),(40325,3989),(40326,4039),(40327,4079),(40328,4119),(40329,4247),(40330,4259),(40331,4261),(40332,4262),(40333,4270),(40334,4284),(40335,4285),(40336,4291),(40337,4293),(40338,4336),(40339,4357),(40340,4360),(40341,4422),(40342,4424),(40343,4468),(40344,4480),(40345,3776),(40346,3777),(40347,3778),(40348,3779),(40349,3780),(40350,3781),(40351,3782),(40352,3783),(40353,3788),(40354,3789),(40355,3790),(40356,3791),(40357,3792),(40358,3793),(40359,3794),(40360,3795),(40361,3796),(40362,3797),(40363,3798),(40364,3799),(40365,3800),(40366,3801),(40367,3802),(40368,3803),(40369,3804),(40370,3805),(40371,3806),(40372,3807),(40373,3808),(40374,3809),(40375,3810),(40376,3811),(40377,3812),(40378,3813),(40379,3814),(40380,3815),(40381,3816),(40382,3817),(40383,3818),(40384,3819),(40385,3820),(40386,3821),(40387,3822),(40388,3823),(40389,3824),(40390,3825),(40391,3826),(40392,3836),(40393,3837),(40394,3838),(40395,3839),(40396,3840),(40397,3841),(40398,3918),(40399,3941),(40400,3942),(40401,3972),(40402,3977),(40403,3978),(40404,3979),(40405,3980),(40406,3981),(40407,3982),(40408,3983),(40409,3984),(40410,3985),(40411,3986),(40412,3987),(40413,3988),(40414,4080),(40415,4081),(40416,4082),(40417,4083),(40418,4084),(40419,4085),(40420,4086),(40421,4087),(40422,4088),(40423,4089),(40424,4090),(40425,4091),(40426,4195),(40427,4196),(40428,4197),(40429,4198),(40430,4204),(40431,4205),(40432,4206),(40433,4207),(40434,4208),(40435,4209),(40436,4210),(40437,4211),(40438,4222),(40439,4223),(40440,4224),(40441,4225),(40442,4226),(40443,4227),(40444,4228),(40445,4229),(40446,4230),(40447,4231),(40448,4232),(40449,4233),(40450,4234),(40451,4235),(40452,4236),(40453,4237),(40454,4238),(40455,4275),(40456,4276),(40457,4292),(40458,4425),(40459,4432),(40460,4433),(40461,4481),(40462,4482),(40463,4483),(40464,4484),(40465,4485),(40466,4486),(40467,4487),(40468,4488),(40469,4489),(40470,4490),(40471,3835),(40472,4012),(40473,4013),(40474,4014),(40475,4015),(40476,4016),(40477,4017),(40478,4018),(40479,4019),(40480,4020),(40481,4021),(40482,4022),(40483,4023),(40484,4024),(40485,4025),(40486,4026),(40487,4027),(40488,4028),(40489,4029),(40490,4030),(40491,4031),(40492,4032),(40493,4033),(40494,4034),(40495,4035),(40496,4036),(40497,4037),(40498,4356),(40499,4402),(40500,4403),(40501,4404),(40502,4405),(40503,4406),(40504,4407),(40505,4408),(40506,4409),(40507,4410),(40508,4411),(40509,4412),(40510,4413),(40511,4414),(40512,4415),(40513,4417),(40514,4418),(40515,4419),(40516,4426),(40517,4427),(40518,3787),(40519,3871),(40520,3893),(40521,3894),(40522,3895),(40523,3923),(40524,3924),(40525,3925),(40526,3926),(40527,3927),(40528,3928),(40529,3929),(40530,3930),(40531,3931),(40532,3932),(40533,3933),(40534,3934),(40535,3935),(40536,3936),(40537,3937),(40538,3938),(40539,3966),(40540,3967),(40541,3968),(40542,3969),(40543,4167),(40544,4193),(40545,4194),(40546,4249),(40547,4250),(40548,4251),(40549,4252),(40550,4253),(40551,4254),(40552,4255),(40553,4256),(40554,4274),(40555,4346),(40556,4347),(40557,4348),(40558,4349),(40559,4350),(40560,4351),(40561,4352),(40562,4353),(40563,4354),(40564,4355),(40565,4611),(40566,4615),(40567,4616),(40568,4617),(40569,4618),(40570,4619),(40571,4620),(40572,4625),(40573,4626),(40574,4677),(40575,4678),(40576,4679),(40577,4681),(40578,4682),(40579,4683),(40580,4684),(40581,4685),(40582,4686),(40583,4731),(40584,4732),(40585,4733),(40586,4734),(40587,4735),(40588,4736),(40589,4737),(40590,4738),(40591,4739),(40592,4740),(40593,4741),(40594,4742),(40595,4743),(40596,4744),(40597,4745),(40598,4746),(40599,4747),(40600,4748),(40601,4749),(40602,4750),(40603,4751),(40604,4752),(40605,4753),(40606,4754),(40607,4755),(40608,4756),(40609,4757),(40610,4758),(40611,4759),(40612,4760),(40613,4761),(40614,4762),(40615,4763),(40616,4764),(40617,4765),(40618,4766),(40619,4767),(40620,4768),(40621,4769),(40622,4770),(40623,4771),(40624,4772),(40625,4773),(40626,4774),(40627,4775),(40628,4776),(40629,4777),(40630,4778),(40631,4779),(40632,4780),(40633,4781),(40634,4782),(40635,4783),(40636,4784),(40637,4785),(40638,4786),(40639,4787),(40640,4788),(40641,4789),(40642,4790),(40643,4791),(40644,4792),(40645,4793),(40646,4794),(40647,4795),(40648,4796),(40649,4797),(40650,4798),(40651,4799),(40652,4800),(40653,4801),(40654,4802),(40655,4803),(40656,4804),(40657,4805),(40658,4806),(40659,4807),(40660,4808),(40661,4824),(40662,4825),(40663,4826),(40664,4827),(40665,4828),(40666,4829),(40667,4830),(40668,4831),(40669,4832),(40670,4833),(40671,4912),(40672,4913),(40673,4914),(40674,4915),(40675,4916),(40676,4917),(40677,4918),(40678,4919),(40679,4920),(40680,4921),(40681,4922),(40682,4923),(40683,4924),(40684,4925),(40685,4926),(40686,4927),(40687,4928),(40688,4929),(40689,4930),(40690,4931),(40691,4932),(40692,4934),(40693,4935),(40694,4936),(40695,4937),(40696,4938),(40697,4939),(40698,4940),(40699,4941),(40700,4957),(40701,4958),(40702,4959),(40703,4960),(40704,4961),(40705,4962),(40706,4963),(40707,4964),(40708,4965),(40709,4966),(40710,5017),(40711,5018),(40712,5037),(40713,5038),(40714,5062),(40715,5063),(40716,5064),(40717,5073),(40718,5074),(40719,5075),(40720,5076),(40721,5088),(40722,5089),(40723,5091),(40724,5092),(40725,5106),(40726,5107),(40727,5108),(40728,5109),(40729,5114),(40730,5115),(40731,5132),(40732,5133),(40733,5134),(40734,5135),(40735,5143),(40736,5144),(40737,5145),(40738,5146),(40739,5169),(40740,5170),(40741,5172),(40742,5173),(40743,5174),(40744,5175),(40745,5176),(40746,5177),(40747,5184),(40748,5185),(40749,5186),(40750,5187),(40751,5188),(40752,5189),(40753,5200),(40754,5201),(40755,5238),(40756,5239),(40757,5240),(40758,5241),(40759,5242),(40760,5243),(40761,5244),(40762,5245),(40763,5246),(40764,5247),(40765,2435),(40766,4573),(40767,4574),(40768,4575),(40769,4576),(40770,4578),(40771,4579),(40772,4580),(40773,4581),(40774,4605),(40775,4606),(40776,4607),(40777,4609),(40778,4610),(40779,398),(40780,399),(40781,410),(40782,418),(40783,432),(40784,436),(40785,441),(40786,442),(40787,485),(40788,512),(40789,513),(40790,514),(40791,516),(40792,529),(40793,530),(40794,531),(40795,532),(40796,647),(40797,651),(40798,668),(40799,669),(40800,674),(40801,1636),(40802,1637),(40803,1638),(40804,1639),(40805,1640),(40806,1641),(40807,1642),(40808,1643),(40809,1644),(40810,1645),(40811,1646),(40812,1647),(40813,1648),(40814,1649),(40815,2017),(40816,2351),(40817,3732),(40818,4816),(40819,4967),(40820,5100),(40821,5285),(40822,5286),(40823,5296),(40824,5297),(40825,5298),(40826,5413),(40827,5414),(40828,5418),(40829,5419),(40830,5541),(40831,5548),(40832,5593),(40833,5692),(40834,5694),(40835,5700),(40836,5711),(40837,5738),(40838,3860),(40839,3862),(40840,3863),(40841,3864),(40842,3865),(40843,3866),(40844,3867),(40845,3869),(40846,3881),(40847,3883),(40848,3886),(40849,3888),(40850,3891),(40851,3900),(40852,3901),(40853,3902),(40854,3906),(40855,3907),(40856,3908),(40857,3939),(40858,3940),(40859,3943),(40860,3944),(40861,3945),(40862,3946),(40863,3947),(40864,3948),(40865,3949),(40866,3950),(40867,3951),(40868,3952),(40869,3953),(40870,3954),(40871,3955),(40872,3956),(40873,3957),(40874,3958),(40875,3959),(40876,3960),(40877,3961),(40878,3962),(40879,3971),(40880,3990),(40881,3991),(40882,3992),(40883,3993),(40884,3994),(40885,3995),(40886,3996),(40887,3997),(40888,3998),(40889,3999),(40890,4000),(40891,4001),(40892,4002),(40893,4003),(40894,4004),(40895,4005),(40896,4006),(40897,4007),(40898,4008),(40899,4009),(40900,4010),(40901,4011),(40902,4038),(40903,4040),(40904,4042),(40905,4044),(40906,4045),(40907,4046),(40908,4047),(40909,4048),(40910,4049),(40911,4050),(40912,4051),(40913,4056),(40914,4061),(40915,4071),(40916,4072),(40917,4073),(40918,4074),(40919,4098),(40920,4099),(40921,4100),(40922,4101),(40923,4102),(40924,4103),(40925,4104),(40926,4105),(40927,4106),(40928,4107),(40929,4108),(40930,4109),(40931,4110),(40932,4111),(40933,4112),(40934,4113),(40935,4114),(40936,4115),(40937,4116),(40938,4117),(40939,4118),(40940,4125),(40941,4126),(40942,4144),(40943,4155),(40944,4157),(40945,4158),(40946,4159),(40947,4160),(40948,4161),(40949,4163),(40950,4164),(40951,4165),(40952,4166),(40953,4169),(40954,4176),(40955,4177),(40956,4178),(40957,4213),(40958,4221),(40959,4242),(40960,4246),(40961,4258),(40962,4260),(40963,4263),(40964,4264),(40965,4265),(40966,4266),(40967,4267),(40968,4268),(40969,4269),(40970,4286),(40971,4320),(40972,4321),(40973,4322),(40974,4323),(40975,4324),(40976,4325),(40977,4344),(40978,4345),(40979,4361),(40980,4367),(40981,4421),(40982,4423),(40983,4428),(40984,4429),(40985,4440),(40986,4479),(40987,3872),(40988,3873),(40989,3885),(40990,3919),(40991,3920),(40992,3921),(40993,3922),(40994,4043),(40995,4054),(40996,4055),(40997,4075),(40998,4076),(40999,4077),(41000,4078),(41001,4092),(41002,4093),(41003,4094),(41004,4095),(41005,4096),(41006,4097),(41007,4120),(41008,4142),(41009,4143),(41010,4150),(41011,4151),(41012,4162),(41013,4199),(41014,4200),(41015,4201),(41016,4214),(41017,4271),(41018,4272),(41019,4273),(41020,4306),(41021,4313),(41022,4314),(41023,4341),(41024,4358),(41025,4416),(41026,4430),(41027,4431),(41028,4457),(41029,3719),(41030,3720),(41031,3721),(41032,3722),(41033,3723),(41034,3724),(41035,3725),(41036,3726),(41037,3727),(41038,3728),(41039,3729),(41040,3730),(41041,3731),(41042,3732),(41043,3733),(41044,3734),(41045,3735),(41046,3736),(41047,3737),(41048,3738),(41049,3739),(41050,3740),(41051,3741),(41052,3742),(41053,3743),(41054,3744),(41055,3745),(41056,3746),(41057,3747),(41058,3748),(41059,3749),(41060,3751),(41061,3752),(41062,3753),(41063,3754),(41064,3755),(41065,3756),(41066,3757),(41067,3758),(41068,3759),(41069,3760),(41070,3761),(41071,3762),(41072,3763),(41073,3764),(41074,3765),(41075,3909),(41076,4041),(41077,305),(41078,306),(41079,307),(41080,308),(41081,309),(41082,310),(41083,311),(41084,312),(41085,313),(41086,314),(41087,315),(41088,316),(41089,317),(41090,318),(41091,319),(41092,320),(41093,321),(41094,322),(41095,323),(41096,324),(41097,325),(41098,326),(41099,327),(41100,328),(41101,329),(41102,330),(41103,331),(41104,332),(41105,333),(41106,334),(41107,335),(41108,336),(41109,337),(41110,338),(41111,339),(41112,340),(41113,341),(41114,342),(41115,343),(41116,344),(41117,345),(41118,346),(41119,347),(41120,903),(41121,904),(41122,905),(41123,907),(41124,1813),(41125,1814),(41126,1815),(41127,1816),(41128,1817),(41129,1818),(41130,1819),(41131,1820),(41132,1821),(41133,1822),(41134,1823),(41135,1824),(41136,1825),(41137,1826),(41138,1827),(41139,1828),(41140,1829),(41141,1830),(41142,1831),(41143,1832),(41144,1833),(41145,1834),(41146,1835),(41147,1950),(41148,1951),(41149,1952),(41150,1953),(41151,1954),(41152,1955),(41153,1956),(41154,1957),(41155,1958),(41156,1965),(41157,1966),(41158,1967),(41159,1968),(41160,1969),(41161,1970),(41162,1971),(41163,2154),(41164,2158),(41165,2159),(41166,2160),(41167,2161),(41168,2162),(41169,2170),(41170,2171),(41171,2172),(41172,2173),(41173,2174),(41174,2175),(41175,2177),(41176,2181),(41177,2182),(41178,2183),(41179,2184),(41180,2185),(41181,2186),(41182,2199),(41183,2211),(41184,2212),(41185,2213),(41186,2223),(41187,2224),(41188,2225),(41189,2226),(41190,2227),(41191,2228),(41192,2229),(41193,2230),(41194,2231),(41195,2281),(41196,2282),(41197,2292),(41198,2294),(41199,2295),(41200,2297),(41201,2298),(41202,2432),(41203,2433),(41204,2434),(41205,2436),(41206,2437),(41207,2438),(41208,2439),(41209,2443),(41210,2444),(41211,2445),(41212,2446),(41213,2447),(41214,2448),(41215,2475),(41216,2476),(41217,2477),(41218,2478),(41219,2479),(41220,2480),(41221,2481),(41222,2482),(41223,2483),(41224,2484),(41225,2485),(41226,2486),(41227,2487),(41228,2488),(41229,2492),(41230,2493),(41231,2494),(41232,2495),(41233,2496),(41234,2497),(41235,2498),(41236,2499),(41237,2500),(41238,2513),(41239,2514),(41240,2529),(41241,2530),(41242,2539),(41243,2553),(41244,2554),(41245,2582),(41246,2583),(41247,2584),(41248,2585),(41249,2586),(41250,2587),(41251,4613),(41252,4614),(41253,4857),(41254,4858),(41255,4859),(41256,4860),(41257,4861),(41258,4862),(41259,4863),(41260,4864),(41261,4865),(41262,4866),(41263,4867),(41264,4868),(41265,4869),(41266,4870),(41267,4871),(41268,4872),(41269,4873),(41270,4874),(41271,4875),(41272,4876),(41273,4891),(41274,4892),(41275,4893),(41276,4894),(41277,281),(41278,282),(41279,283),(41280,284),(41281,285),(41282,286),(41283,287),(41284,288),(41285,289),(41286,290),(41287,291),(41288,292),(41289,293),(41290,294),(41291,295),(41292,296),(41293,297),(41294,298),(41295,299),(41296,300),(41297,301),(41298,302),(41299,303),(41300,304),(41301,1144),(41302,1145),(41303,1146),(41304,1147),(41305,1148),(41306,1151),(41307,1152),(41308,1153),(41309,1154),(41310,1155),(41311,1156),(41312,1157),(41313,1158),(41314,1159),(41315,1160),(41316,1161),(41317,1496),(41318,1836),(41319,1837),(41320,1838),(41321,1839),(41322,1840),(41323,1841),(41324,1842),(41325,1843),(41326,1844),(41327,1845),(41328,1846),(41329,1847),(41330,1848),(41331,1849),(41332,1850),(41333,1851),(41334,1852),(41335,1853),(41336,1854),(41337,1855),(41338,1856),(41339,1857),(41340,1858),(41341,1859),(41342,1860),(41343,1861),(41344,1862),(41345,1863),(41346,1864),(41347,1865),(41348,1866),(41349,1867),(41350,1868),(41351,1869),(41352,1870),(41353,1871),(41354,1872),(41355,1873),(41356,1874),(41357,1875),(41358,1876),(41359,1877),(41360,1878),(41361,1879),(41362,1880),(41363,1881),(41364,1882),(41365,1883),(41366,1884),(41367,1885),(41368,1886),(41369,1887),(41370,1888),(41371,1889),(41372,1890),(41373,1891),(41374,1892),(41375,1893),(41376,1894),(41377,1895),(41378,1896),(41379,1897),(41380,1898),(41381,1899),(41382,1900),(41383,1901),(41384,1902),(41385,1903),(41386,1904),(41387,1905),(41388,1906),(41389,1907),(41390,1908),(41391,1909),(41392,1910),(41393,1911),(41394,1912),(41395,1913),(41396,1914),(41397,1915),(41398,1916),(41399,1917),(41400,1918),(41401,1919),(41402,1920),(41403,1921),(41404,1922),(41405,1923),(41406,1924),(41407,1925),(41408,1926),(41409,1927),(41410,1928),(41411,1929),(41412,1930),(41413,1931),(41414,1932),(41415,1933),(41416,1934),(41417,1935),(41418,1936),(41419,1937),(41420,1938),(41421,1939),(41422,1940),(41423,1941),(41424,1942),(41425,1943),(41426,1944),(41427,1945),(41428,1946),(41429,1947),(41430,1948),(41431,1949),(41432,4491),(41433,4492),(41434,4493),(41435,4494),(41436,4495),(41437,4496),(41438,4497),(41439,4498),(41440,4499),(41441,4537),(41442,4897),(41443,5286),(41444,1219),(41445,1220),(41446,1221),(41447,1222),(41448,1223),(41449,1224),(41450,1225),(41451,1226),(41452,1227),(41453,1228),(41454,1229),(41455,1230),(41456,1231),(41457,1232),(41458,1233),(41459,1234),(41460,1235),(41461,1236),(41462,1237),(41463,1238),(41464,1239),(41465,1240),(41466,1241),(41467,1242),(41468,1243),(41469,1244),(41470,1245),(41471,1246),(41472,1247),(41473,1248),(41474,1249),(41475,1250),(41476,1251),(41477,1252),(41478,1253),(41479,1254),(41480,1255),(41481,1256),(41482,1257),(41483,1258),(41484,1259),(41485,1260),(41486,1261),(41487,1262),(41488,1263),(41489,1264),(41490,1265),(41491,1266),(41492,1267),(41493,1268),(41494,1269),(41495,1270),(41496,1271),(41497,1272),(41498,1273),(41499,1274),(41500,1275),(41501,1276),(41502,1277),(41503,1278),(41504,1279),(41505,1280),(41506,1281),(41507,1282),(41508,1283),(41509,1284),(41510,1285),(41511,1286),(41512,1287),(41513,1288),(41514,1289),(41515,1290),(41516,1291),(41517,1292),(41518,1293),(41519,1294),(41520,1295),(41521,1296),(41522,1297),(41523,1298),(41524,1299),(41525,1300),(41526,1301),(41527,1302),(41528,1303),(41529,1304),(41530,1305),(41531,1306),(41532,1307),(41533,1308),(41534,1309),(41535,1310),(41536,1311),(41537,1312),(41538,1313),(41539,1314),(41540,1315),(41541,1316),(41542,1317),(41543,1318),(41544,1319),(41545,1320),(41546,1321),(41547,1322),(41548,1323),(41549,1332),(41550,1342),(41551,1346),(41552,1347),(41553,1349),(41554,1350),(41555,1351),(41556,1353),(41557,1354),(41558,1355),(41559,1356),(41560,1357),(41561,1358),(41562,1359),(41563,1360),(41564,1361),(41565,1362),(41566,1363),(41567,1364),(41568,1366),(41569,1367),(41570,1368),(41571,1371),(41572,1375),(41573,1376),(41574,1377),(41575,1379),(41576,1389),(41577,1390),(41578,1391),(41579,1392),(41580,1393),(41581,1394),(41582,1395),(41583,1397),(41584,1398),(41585,1400),(41586,1420),(41587,1421),(41588,1422),(41589,1423),(41590,1424),(41591,1425),(41592,1427),(41593,1428),(41594,1429),(41595,1430),(41596,1431),(41597,1432),(41598,1433),(41599,1434),(41600,1435),(41601,1442),(41602,1443),(41603,1444),(41604,1445),(41605,1446),(41606,1447),(41607,1448),(41608,1450),(41609,1451),(41610,1452),(41611,1454),(41612,1455),(41613,1456),(41614,1457),(41615,1462),(41616,1469),(41617,1749),(41618,4500),(41619,4501),(41620,4502),(41621,4503),(41622,4504),(41623,4505),(41624,4506),(41625,4507),(41626,4508),(41627,4509),(41628,4510),(41629,4511),(41630,4512),(41631,4513),(41632,4514),(41633,4515),(41634,4516),(41635,4517),(41636,4518),(41637,4519),(41638,4520),(41639,4522),(41640,4523),(41641,5301),(41642,5468),(41643,5489),(41644,582),(41645,583),(41646,584),(41647,585),(41648,586),(41649,587),(41650,588),(41651,589),(41652,590),(41653,591),(41654,592),(41655,593),(41656,594),(41657,595),(41658,596),(41659,597),(41660,598),(41661,599),(41662,600),(41663,601),(41664,602),(41665,603),(41666,604),(41667,605),(41668,606),(41669,607),(41670,608),(41671,609),(41672,610),(41673,612),(41674,626),(41675,627),(41676,628),(41677,629),(41678,630),(41679,631),(41680,754),(41681,755),(41682,756),(41683,757),(41684,758),(41685,759),(41686,760),(41687,761),(41688,762),(41689,763),(41690,764),(41691,765),(41692,766),(41693,767),(41694,768),(41695,769),(41696,770),(41697,771),(41698,772),(41699,773),(41700,774),(41701,775),(41702,776),(41703,777),(41704,778),(41705,779),(41706,780),(41707,781),(41708,782),(41709,783),(41710,784),(41711,785),(41712,786),(41713,787),(41714,788),(41715,789),(41716,790),(41717,791),(41718,792),(41719,793),(41720,794),(41721,795),(41722,796),(41723,797),(41724,798),(41725,799),(41726,800),(41727,801),(41728,802),(41729,803),(41730,804),(41731,805),(41732,806),(41733,807),(41734,808),(41735,809),(41736,810),(41737,811),(41738,812),(41739,813),(41740,814),(41741,815),(41742,816),(41743,817),(41744,818),(41745,819),(41746,820),(41747,821),(41748,822),(41749,823),(41750,824),(41751,825),(41752,826),(41753,827),(41754,828),(41755,829),(41756,830),(41757,831),(41758,832),(41759,833),(41760,834),(41761,835),(41762,836),(41763,837),(41764,838),(41765,839),(41766,840),(41767,841),(41768,842),(41769,843),(41770,844),(41771,845),(41772,846),(41773,847),(41774,848),(41775,849),(41776,850),(41777,851),(41778,852),(41779,853),(41780,854),(41781,855),(41782,856),(41783,857),(41784,858),(41785,859),(41786,860),(41787,861),(41788,862),(41789,863),(41790,864),(41791,865),(41792,866),(41793,867),(41794,868),(41795,869),(41796,870),(41797,871),(41798,872),(41799,1020),(41800,1021),(41801,1022),(41802,1023),(41803,1106),(41804,1166),(41805,1167),(41806,1168),(41807,1169),(41808,1170),(41809,1171),(41810,1172),(41811,1173),(41812,1174),(41813,1175),(41814,1176),(41815,1177),(41816,1178),(41817,1179),(41818,1180),(41819,1181),(41820,1182),(41821,1183),(41822,1195),(41823,1196),(41824,1197),(41825,1198),(41826,1199),(41827,1200),(41828,1201),(41829,1202),(41830,1203),(41831,1204),(41832,1205),(41833,1206),(41834,1207),(41835,1210),(41836,1211),(41837,1212),(41838,1213),(41839,1214),(41840,1215),(41841,1216),(41842,1217),(41843,1218),(41844,348),(41845,349),(41846,350),(41847,351),(41848,352),(41849,353),(41850,354),(41851,355),(41852,356),(41853,357),(41854,358),(41855,359),(41856,360),(41857,361),(41858,370),(41859,371),(41860,372),(41861,373),(41862,374),(41863,375),(41864,376),(41865,377),(41866,378),(41867,379),(41868,380),(41869,381),(41870,382),(41871,383),(41872,384),(41873,385),(41874,386),(41875,387),(41876,388),(41877,389),(41878,390),(41879,391),(41880,392),(41881,393),(41882,394),(41883,395),(41884,396),(41885,397),(41886,533),(41887,534),(41888,535),(41889,536),(41890,537),(41891,538),(41892,539),(41893,540),(41894,541),(41895,542),(41896,543),(41897,544),(41898,545),(41899,546),(41900,547),(41901,548),(41902,549),(41903,550),(41904,551),(41905,552),(41906,553),(41907,554),(41908,555),(41909,556),(41910,558),(41911,559),(41912,561),(41913,562),(41914,563),(41915,564),(41916,565),(41917,566),(41918,567),(41919,568),(41920,569),(41921,570),(41922,571),(41923,572),(41924,573),(41925,574),(41926,575),(41927,576),(41928,577),(41929,578),(41930,579),(41931,580),(41932,581),(41933,5500),(41934,5501),(41935,5502),(41936,5503),(41937,5504),(41938,5505),(41939,5506),(41940,5507),(41941,5508),(41942,5509),(41943,5510),(41944,5511),(41945,5512),(41946,5513),(41947,5514),(41948,5515),(41949,5516),(41950,5517),(41951,5518),(41952,5519),(41953,1024),(41954,2026),(41955,2027),(41956,2028),(41957,2029),(41958,2030),(41959,2031),(41960,2032),(41961,2034),(41962,2039),(41963,2040),(41964,2042),(41965,2044),(41966,2045),(41967,2046),(41968,2122),(41969,2123),(41970,2124),(41971,2125),(41972,2126),(41973,2127),(41974,2128),(41975,2129),(41976,2130),(41977,2131),(41978,2132),(41979,2133),(41980,2134),(41981,2135),(41982,2136),(41983,2137),(41984,2138),(41985,2139),(41986,2140),(41987,2141),(41988,2142),(41989,2143),(41990,2144),(41991,2145),(41992,2146),(41993,2147),(41994,2148),(41995,2149),(41996,2150),(41997,2151),(41998,2152),(41999,2153),(42000,2275),(42001,2323),(42002,2324),(42003,2325),(42004,2326),(42005,2327),(42006,2328),(42007,2329),(42008,2330),(42009,2331),(42010,2332),(42011,2333),(42012,2334),(42013,2335),(42014,2336),(42015,2337),(42016,2338),(42017,2339),(42018,2340),(42019,2341),(42020,2342),(42021,2343),(42022,2344),(42023,2345),(42024,2346),(42025,2347),(42026,2348),(42027,2349),(42028,2350),(42029,2351),(42030,2352),(42031,2353),(42032,2354),(42033,2355),(42034,2356),(42035,2357),(42036,2358),(42037,2359),(42038,2360),(42039,2361),(42040,2362),(42041,2363),(42042,2364),(42043,2365),(42044,2366),(42045,2367),(42046,2368),(42047,2369),(42048,2370),(42049,2371),(42050,2372),(42051,2373),(42052,2374),(42053,2375),(42054,2376),(42055,2377),(42056,2378),(42057,2379),(42058,2380),(42059,2381),(42060,2382),(42061,2383),(42062,2384),(42063,2385),(42064,2386),(42065,2387),(42066,2388),(42067,2389),(42068,2390),(42069,2391),(42070,2559),(42071,4933),(42072,5490),(42073,5491),(42074,5492),(42075,5493),(42076,5494),(42077,5495),(42078,5496),(42079,5497),(42080,5498),(42081,5499),(42082,240),(42083,241),(42084,242),(42085,243),(42086,246),(42087,247),(42088,248),(42089,258),(42090,259),(42091,260),(42092,261),(42093,262),(42094,263),(42095,264),(42096,265),(42097,909),(42098,910),(42099,911),(42100,912),(42101,913),(42102,914),(42103,915),(42104,916),(42105,917),(42106,918),(42107,919),(42108,920),(42109,921),(42110,922),(42111,923),(42112,924),(42113,925),(42114,926),(42115,927),(42116,928),(42117,929),(42118,930),(42119,931),(42120,932),(42121,933),(42122,934),(42123,935),(42124,936),(42125,937),(42126,938),(42127,939),(42128,940),(42129,941),(42130,942),(42131,943),(42132,944),(42133,945),(42134,946),(42135,947),(42136,948),(42137,949),(42138,950),(42139,951),(42140,952),(42141,953),(42142,954),(42143,955),(42144,956),(42145,957),(42146,958),(42147,959),(42148,960),(42149,961),(42150,962),(42151,963),(42152,964),(42153,965),(42154,966),(42155,967),(42156,968),(42157,969),(42158,970),(42159,971),(42160,972),(42161,973),(42162,974),(42163,975),(42164,976),(42165,977),(42166,978),(42167,979),(42168,980),(42169,981),(42170,982),(42171,983),(42172,984),(42173,985),(42174,986),(42175,987),(42176,988),(42177,989),(42178,990),(42179,991),(42180,992),(42181,993),(42182,994),(42183,995),(42184,1007),(42185,1008),(42186,1009),(42187,1010),(42188,1011),(42189,1040),(42190,1041),(42191,1042),(42192,1043),(42193,1044),(42194,1045),(42195,1046),(42196,1047),(42197,1048),(42198,1093),(42199,1094),(42200,1095),(42201,1096),(42202,1097),(42203,1098),(42204,1100),(42205,1101),(42206,1102),(42207,1103),(42208,1104),(42209,1105),(42210,1107),(42211,1108),(42212,1109),(42213,1110),(42214,1111),(42215,1112),(42216,1113),(42217,1114),(42218,1115),(42219,1116),(42220,1117),(42221,1118),(42222,1120),(42223,1121),(42224,1122),(42225,1123),(42226,1124),(42227,1125),(42228,1134),(42229,1135),(42230,1136),(42231,1137),(42232,1138),(42233,1139),(42234,1518),(42235,1519),(42236,1520),(42237,1521),(42238,1533),(42239,1563),(42240,1564),(42241,1565),(42242,1566),(42243,1588),(42244,1589),(42245,1590),(42246,1591),(42247,1592),(42248,1593),(42249,1594),(42250,1595),(42251,1596),(42252,1597),(42253,1598),(42254,1599),(42255,1604),(42256,1607),(42257,1610),(42258,1618),(42259,1619),(42260,1620),(42261,1621),(42262,1623),(42263,1626),(42264,1658),(42265,1659),(42266,1660),(42267,1665),(42268,1666),(42269,1675),(42270,1676),(42271,1677),(42272,1678),(42273,1733),(42274,1734),(42275,1735),(42276,1751),(42277,1752),(42278,1753),(42279,1754),(42280,1755),(42281,1756),(42282,1757),(42283,1758),(42284,1761),(42285,1762),(42286,1778),(42287,1779),(42288,1786),(42289,1787),(42290,1788),(42291,1789),(42292,1790),(42293,2454),(42294,2455),(42295,2456),(42296,2699),(42297,2919),(42298,2920),(42299,2921),(42300,2922),(42301,2923),(42302,2924),(42303,2925),(42304,2926),(42305,2927),(42306,2928),(42307,2929),(42308,2930),(42309,2931),(42310,2932),(42311,2933),(42312,2934),(42313,2935),(42314,2936),(42315,2937),(42316,2938),(42317,2939),(42318,2940),(42319,2941),(42320,2942),(42321,2943),(42322,2944),(42323,2945),(42324,2946),(42325,2947),(42326,2948),(42327,2949),(42328,2950),(42329,2951),(42330,2952),(42331,2953),(42332,2954),(42333,2979),(42334,2980),(42335,3042),(42336,3164),(42337,3165),(42338,3166),(42339,3534),(42340,3535),(42341,3536),(42342,4566),(42343,4567),(42344,4568),(42345,4569),(42346,4570),(42347,4571),(42348,4572),(42349,4577),(42350,5077),(42351,5078),(42352,5079),(42353,5080),(42354,5081),(42355,5082),(42356,5083),(42357,5084),(42358,5085),(42359,5086),(42360,5087),(42361,5093),(42362,5094),(42363,5095),(42364,5096),(42365,5250),(42366,5251),(42367,5252),(42368,5253),(42369,5254),(42370,5255),(42371,5258),(42372,5259),(42373,5260),(42374,5261),(42375,5262),(42376,5263),(42377,5264),(42378,5265),(42379,5266),(42380,5267),(42381,5268),(42382,5269),(42383,5270),(42384,5323),(42385,5324),(42386,5325),(42387,5326),(42388,5327),(42389,5328),(42390,5329),(42391,5330),(42392,5331),(42393,5332),(42394,5333),(42395,5334),(42396,5335),(42397,5336),(42398,5337),(42399,5343),(42400,5344),(42401,5351),(42402,5352),(42403,5354),(42404,5356),(42405,5367),(42406,5369),(42407,5372),(42408,5373),(42409,5374),(42410,5375),(42411,5376),(42412,5377),(42413,5390),(42414,5402),(42415,5433),(42416,5434),(42417,5451),(42418,5452),(42419,5453),(42420,5454),(42421,5455),(42422,5474),(42423,5475),(42424,5476),(42425,5477),(42426,5478),(42427,5479),(42428,5480),(42429,5481),(42430,5484),(42431,5485),(42432,5486),(42433,5487),(42434,5488),(42435,5524),(42436,5526),(42437,5527),(42438,5528),(42439,5529),(42440,5530),(42441,5531),(42442,5532),(42443,5533),(42444,5534),(42445,5535),(42446,5558),(42447,5563),(42448,5564),(42449,5566),(42450,5570),(42451,5577),(42452,5578),(42453,5580),(42454,5581),(42455,5588),(42456,5674),(42457,5675),(42458,5676),(42459,5677),(42460,5678),(42461,5679),(42462,5738),(42463,5028),(42464,5029),(42465,5030),(42466,5031),(42467,5032),(42468,5033),(42469,5034),(42470,5035),(42471,5036),(42472,5359),(42473,5360),(42474,5361),(42475,5362),(42476,5363),(42477,5364),(42478,5365),(42479,5366),(42480,5420),(42481,5431),(42482,5435),(42483,5436),(42484,5437),(42485,5438),(42486,5439),(42487,5440),(42488,5441),(42489,5442),(42490,5443),(42491,5444),(42492,5445),(42493,5446),(42494,5447),(42495,5448),(42496,5449),(42497,5450),(42498,5525),(42499,5707),(42500,5708),(42501,162),(42502,176),(42503,177),(42504,178),(42505,179),(42506,180),(42507,181),(42508,182),(42509,183),(42510,184),(42511,185),(42512,186),(42513,187),(42514,188),(42515,189),(42516,190),(42517,191),(42518,192),(42519,193),(42520,194),(42521,195),(42522,196),(42523,197),(42524,198),(42525,199),(42526,200),(42527,201),(42528,202),(42529,203),(42530,204),(42531,205),(42532,206),(42533,207),(42534,208),(42535,209),(42536,210),(42537,211),(42538,212),(42539,213),(42540,214),(42541,215),(42542,216),(42543,217),(42544,218),(42545,219),(42546,220),(42547,5393),(42548,5394),(42549,5395),(42550,5396),(42551,5397),(42552,5398),(42553,5399),(42554,5400),(42555,1650),(42556,1651),(42557,1652),(42558,1653),(42559,1687),(42560,1688),(42561,1689),(42562,1690),(42563,1691),(42564,1692),(42565,1693),(42566,1694),(42567,1695),(42568,1696),(42569,1697),(42570,1698),(42571,1699),(42572,1700),(42573,1701),(42574,1702),(42575,1703),(42576,1704),(42577,1737),(42578,1738),(42579,1773),(42580,4612),(42581,4718),(42582,4730),(42583,4812),(42584,4813),(42585,4814),(42586,4815),(42587,4816),(42588,4817),(42589,4818),(42590,4819),(42591,4820),(42592,4821),(42593,4822),(42594,4845),(42595,4955),(42596,4956),(42597,4967),(42598,4968),(42599,4969),(42600,5090),(42601,5097),(42602,5098),(42603,5099),(42604,5100),(42605,5101),(42606,5102),(42607,5103),(42608,5104),(42609,5110),(42610,5111),(42611,5112),(42612,5113),(42613,5116),(42614,5117),(42615,5118),(42616,5119),(42617,5120),(42618,5456),(42619,5457),(42620,5459),(42621,5460),(42622,5461),(42623,5462),(42624,5702),(42625,5703),(42626,1679),(42627,1680),(42628,1708),(42629,1709),(42630,1710),(42631,1711),(42632,1712),(42633,1713),(42634,1714),(42635,1748),(42636,1791),(42637,1792),(42638,1798),(42639,2187),(42640,2188),(42641,2189),(42642,2190),(42643,2191),(42644,2192),(42645,2193),(42646,2194),(42647,2195),(42648,2196),(42649,2197),(42650,2198),(42651,2232),(42652,2233),(42653,2234),(42654,2235),(42655,2236),(42656,2237),(42657,2238),(42658,2239),(42659,2240),(42660,2392),(42661,2393),(42662,2394),(42663,2395),(42664,2411),(42665,2412),(42666,2577),(42667,2578),(42668,2579),(42669,2580),(42670,2581),(42671,2589),(42672,2590),(42673,2591),(42674,2592),(42675,2593),(42676,2594),(42677,2595),(42678,2596),(42679,2597),(42680,2598),(42681,2599),(42682,2600),(42683,2601),(42684,2602),(42685,2603),(42686,2604),(42687,2605),(42688,2606),(42689,2607),(42690,2608),(42691,2609),(42692,2610),(42693,2611),(42694,2612),(42695,2613),(42696,2614),(42697,4621),(42698,4629),(42699,4630),(42700,4631),(42701,4632),(42702,4633),(42703,4634),(42704,4635),(42705,4636),(42706,4637),(42707,4638),(42708,4639),(42709,4640),(42710,4641),(42711,4642),(42712,4643),(42713,4644),(42714,4645),(42715,4646),(42716,4647),(42717,4648),(42718,4649),(42719,4650),(42720,4651),(42721,4652),(42722,4653),(42723,4654),(42724,4655),(42725,4656),(42726,4657),(42727,4658),(42728,4659),(42729,4660),(42730,4661),(42731,4662),(42732,4663),(42733,4664),(42734,4665),(42735,4666),(42736,4667),(42737,4896),(42738,4898),(42739,4900),(42740,4902),(42741,4903),(42742,4904),(42743,4943),(42744,4944),(42745,4945),(42746,4946),(42747,4947),(42748,4948),(42749,4949),(42750,4950),(42751,4951),(42752,4952),(42753,4953),(42754,4954),(42755,4971),(42756,4972),(42757,4973),(42758,4979),(42759,4980),(42760,4981),(42761,4982),(42762,4983),(42763,4984),(42764,4985),(42765,4986),(42766,4987),(42767,4988),(42768,4989),(42769,4990),(42770,4991),(42771,5001),(42772,5002),(42773,5105),(42774,5178),(42775,5179),(42776,5180),(42777,5181),(42778,5182),(42779,5202),(42780,5203),(42781,5204),(42782,5205),(42783,5206),(42784,5207),(42785,5208),(42786,5209),(42787,5210),(42788,5211),(42789,5212),(42790,5213),(42791,5214),(42792,5215),(42793,5216),(42794,5217),(42795,5218),(42796,5219),(42797,5220),(42798,5221),(42799,5222),(42800,5223),(42801,5224),(42802,5225),(42803,5226),(42804,5227),(42805,5228),(42806,5229),(42807,5230),(42808,5231),(42809,5232),(42810,5233),(42811,5234),(42812,5235),(42813,5236),(42814,5237),(42815,1527),(42816,1528),(42817,1529),(42818,1530),(42819,1531),(42820,1532),(42821,1534),(42822,1535),(42823,1536),(42824,1557),(42825,1558),(42826,1559),(42827,1562),(42828,1584),(42829,1585),(42830,1586),(42831,1587),(42832,1600),(42833,1601),(42834,1602),(42835,1603),(42836,1605),(42837,1606),(42838,1608),(42839,1609),(42840,1622),(42841,1624),(42842,1625),(42843,1627),(42844,1628),(42845,1661),(42846,1662),(42847,1663),(42848,1664),(42849,1667),(42850,1668),(42851,1669),(42852,1670),(42853,1671),(42854,1672),(42855,1673),(42856,1674),(42857,1715),(42858,1716),(42859,1717),(42860,1718),(42861,1719),(42862,1720),(42863,1721),(42864,1722),(42865,1723),(42866,1724),(42867,1725),(42868,1726),(42869,1727),(42870,1728),(42871,1729),(42872,1730),(42873,1731),(42874,1732),(42875,1736),(42876,1740),(42877,1743),(42878,1744),(42879,1745),(42880,1746),(42881,1747),(42882,1750),(42883,1780),(42884,1781),(42885,1782),(42886,1793),(42887,1794),(42888,1795),(42889,1799),(42890,1800),(42891,1801),(42892,1802),(42893,2515),(42894,2516),(42895,2918),(42896,3043),(42897,4582),(42898,4583),(42899,4584),(42900,4585),(42901,4586),(42902,4587),(42903,4588),(42904,4589),(42905,4590),(42906,4591),(42907,4592),(42908,4593),(42909,4594),(42910,4595),(42911,4596),(42912,4597),(42913,4598),(42914,4599),(42915,4600),(42916,4601),(42917,4602),(42918,4603),(42919,4604),(42920,4608),(42921,4834),(42922,4835),(42923,4836),(42924,4837),(42925,4838),(42926,4839),(42927,4840),(42928,4841),(42929,4842),(42930,4942),(42931,5121),(42932,5151),(42933,5152),(42934,5153),(42935,5154),(42936,5155),(42937,5156),(42938,5157),(42939,5158),(42940,5183),(42941,5248),(42942,5249),(42943,5256),(42944,5257),(42945,5355),(42946,5370),(42947,5371),(42948,5401),(42949,5403),(42950,5404),(42951,5405),(42952,5406),(42953,5407),(42954,5409),(42955,5421),(42956,5422),(42957,5423),(42958,5424),(42959,5425),(42960,5426),(42961,5427),(42962,5429),(42963,5430),(42964,5432),(42965,5458),(42966,5463),(42967,5464),(42968,5465),(42969,5466),(42970,5467),(42971,5482),(42972,5483),(42973,5520),(42974,5521),(42975,5522),(42976,5523),(42977,5551),(42978,5552),(42979,5553),(42980,5554),(42981,5555),(42982,5556),(42983,5557),(42984,5559),(42985,5560),(42986,5561),(42987,5562),(42988,5565),(42989,5567),(42990,5568),(42991,5569),(42992,5572),(42993,5573),(42994,5574),(42995,5575),(42996,5576),(42997,5579),(42998,5582),(42999,5583),(43000,5584),(43001,5585),(43002,5586),(43003,5587),(43004,5589),(43005,5590),(43006,5704),(43007,5705),(43008,5706),(43009,5739),(43010,5740),(43011,5741),(43012,5742),(43013,5743),(43014,5744),(43015,224),(43016,225),(43017,226),(43018,227),(43019,228),(43020,229),(43021,230),(43022,231),(43023,232),(43024,233),(43025,234),(43026,235),(43027,236),(43028,237),(43029,238),(43030,239),(43031,268),(43032,269),(43033,270),(43034,271),(43035,272),(43036,273),(43037,274),(43038,275),(43039,1006),(43040,1013),(43041,1014),(43042,1015),(43043,1016),(43044,1017),(43045,1018),(43046,1025),(43047,1026),(43048,1027),(43049,1028),(43050,1029),(43051,1030),(43052,1031),(43053,1032),(43054,1033),(43055,1126),(43056,1127),(43057,1128),(43058,1129),(43059,1130),(43060,1131),(43061,1132),(43062,1522),(43063,1523),(43064,1524),(43065,1525),(43066,1526),(43067,2422),(43068,2423),(43069,2424),(43070,2425),(43071,2426),(43072,2427),(43073,2428),(43074,2517),(43075,2518),(43076,2519),(43077,2520),(43078,2537),(43079,2538),(43080,4622),(43081,4623),(43082,4624),(43083,4853),(43084,4854),(43085,4855),(43086,4877),(43087,4878),(43088,4879),(43089,4880),(43090,4881),(43091,4882),(43092,4883),(43093,4884),(43094,4885),(43095,4886),(43096,4887),(43097,4888),(43098,4889),(43099,4890),(43100,4970),(43101,5368),(43102,5408),(43103,5410),(43104,5411),(43105,5412),(43106,5413),(43107,5414),(43108,5415),(43109,5416),(43110,5417),(43111,5418),(43112,5419),(43113,5428),(43114,5469),(43115,5470),(43116,5471),(43117,5472),(43118,5473),(43119,5538),(43120,5539),(43121,5540),(43122,5541),(43123,5542),(43124,5543),(43125,5544),(43126,5545),(43127,5546),(43128,5547),(43129,5548),(43130,5549),(43131,5550),(43132,5571),(43133,5591),(43134,5592),(43135,5593),(43136,5594),(43137,5595),(43138,5596),(43139,5597),(43140,5598),(43141,5599),(43142,5600),(43143,5601),(43144,5602),(43145,5603),(43146,5604),(43147,5605),(43148,5606),(43149,5607),(43150,5608),(43151,5609),(43152,5610),(43153,5611),(43154,5612),(43155,5613),(43156,5614),(43157,5615),(43158,5616),(43159,5617),(43160,5618),(43161,5619),(43162,5620),(43163,5621),(43164,5622),(43165,5623),(43166,5624),(43167,5625),(43168,5626),(43169,5627),(43170,5628),(43171,5629),(43172,5630),(43173,5631),(43174,5632),(43175,5633),(43176,5634),(43177,5635),(43178,5636),(43179,5637),(43180,5638),(43181,5639),(43182,5640),(43183,5641),(43184,5642),(43185,5643),(43186,5644),(43187,5645),(43188,5646),(43189,5647),(43190,5648),(43191,5649),(43192,5650),(43193,5651),(43194,5652),(43195,5653),(43196,5654),(43197,5655),(43198,5656),(43199,5657),(43200,5658),(43201,5659),(43202,5660),(43203,5661),(43204,5662),(43205,5663),(43206,5664),(43207,5665),(43208,5666),(43209,5667),(43210,5668),(43211,5669),(43212,5670),(43213,5671),(43214,5672),(43215,5682),(43216,5683),(43217,5684),(43218,5685),(43219,5686),(43220,5687),(43221,5688),(43222,5690),(43223,5691),(43224,5692),(43225,5693),(43226,5694),(43227,5695),(43228,5697),(43229,5698),(43230,5699),(43231,5700),(43232,5701),(43233,5709),(43234,5710),(43235,5711),(43236,5712),(43237,5713),(43238,5714),(43239,5715),(43240,5716),(43241,5717),(43242,5718),(43243,5719),(43244,5720),(43245,5721),(43246,5722),(43247,5723),(43248,5724),(43249,5725),(43250,5726),(43251,5727),(43252,5728),(43253,5729),(43254,5730),(43255,5731),(43256,5732),(43257,5733),(43258,5734),(43259,5735),(43260,5736),(43261,5737),(43262,5745),(43263,5746),(43264,5747),(43265,5748),(43266,5749),(43267,163),(43268,164),(43269,165),(43270,166),(43271,167),(43272,168),(43273,172),(43274,254),(43275,255),(43276,256),(43277,257),(43278,1049),(43279,1050),(43280,1051),(43281,1052),(43282,1053),(43283,1054),(43284,1055),(43285,1056),(43286,1057),(43287,1058),(43288,1059),(43289,1060),(43290,1061),(43291,1062),(43292,1063),(43293,1064),(43294,1065),(43295,1066),(43296,1067),(43297,1068),(43298,1069),(43299,1070),(43300,1071),(43301,1072),(43302,1073),(43303,1074),(43304,1075),(43305,1076),(43306,1077),(43307,1078),(43308,1079),(43309,1080),(43310,1081),(43311,1082),(43312,1083),(43313,1084),(43314,1085),(43315,1086),(43316,1087),(43317,1088),(43318,1089),(43319,1090),(43320,1091),(43321,1611),(43322,1612),(43323,1613),(43324,1614),(43325,1615),(43326,1616),(43327,1617),(43328,1654),(43329,1655),(43330,1656),(43331,1657),(43332,1705),(43333,1706),(43334,1707),(43335,1739),(43336,1741),(43337,1742),(43338,1759),(43339,1760),(43340,1764),(43341,1765),(43342,1766),(43343,1767),(43344,1768),(43345,1769),(43346,1770),(43347,1771),(43348,1772),(43349,1774),(43350,1775),(43351,1776),(43352,1777),(43353,1783),(43354,1784),(43355,1785),(43356,1812),(43357,1959),(43358,1960),(43359,1961),(43360,1962),(43361,1963),(43362,1964),(43363,2289),(43364,2290),(43365,2291),(43366,2293),(43367,2413),(43368,2414),(43369,2415),(43370,2416),(43371,2417),(43372,2418),(43373,2419),(43374,2420),(43375,2421),(43376,906),(43377,908),(43378,1004),(43379,1012),(43380,1019),(43381,1037),(43382,1092),(43383,1119),(43384,1162),(43385,1163),(43386,1164),(43387,1165),(43388,2163),(43389,2164),(43390,2176),(43391,2203),(43392,2204),(43393,2205),(43394,2206),(43395,2207),(43396,2247),(43397,2248),(43398,2249),(43399,2250),(43400,2270),(43401,2271),(43402,2277),(43403,2278),(43404,2279),(43405,2280),(43406,2296),(43407,2299),(43408,2300),(43409,2301),(43410,2429),(43411,2430),(43412,2431),(43413,2440),(43414,2441),(43415,2442),(43416,2457),(43417,2472),(43418,2473),(43419,2474),(43420,2489),(43421,2490),(43422,2491),(43423,2506),(43424,2507),(43425,2508),(43426,2509),(43427,2510),(43428,2511),(43429,2512),(43430,2521),(43431,2522),(43432,2523),(43433,2524),(43434,2525),(43435,2526),(43436,2527),(43437,2528),(43438,2531),(43439,2532),(43440,2533),(43441,2534),(43442,2535),(43443,2536),(43444,2540),(43445,2541),(43446,2542),(43447,2543),(43448,2544),(43449,2545),(43450,2546),(43451,2547),(43452,2548),(43453,2549),(43454,2550),(43455,2551),(43456,2573),(43457,2574),(43458,2575),(43459,2576),(43460,5757),(43461,5758),(43462,5759),(43463,3304),(43464,3305),(43465,3306),(43466,3307),(43467,3308),(43468,3309),(43469,3310),(43470,3311),(43471,3312),(43472,3313),(43473,3314),(43474,3315),(43475,3316),(43476,3317),(43477,3318),(43478,3319),(43479,3320),(43480,3321),(43481,3322),(43482,3323),(43483,3324),(43484,3325),(43485,3326),(43486,3327),(43487,3328),(43488,3329),(43489,3330),(43490,3331),(43491,3332),(43492,3333),(43493,3334),(43494,3335),(43495,3336),(43496,3337),(43497,3338),(43498,3339),(43499,3340),(43500,3341),(43501,3342),(43502,3343),(43503,3344),(43504,3345),(43505,3346),(43506,3347),(43507,3348),(43508,3349),(43509,3350),(43510,3351),(43511,3352),(43512,3353),(43513,3354),(43514,3355),(43515,3356),(43516,3357),(43517,3358),(43518,3359),(43519,3360),(43520,3361),(43521,3362),(43522,3363),(43523,3364),(43524,3365),(43525,3366),(43526,3367),(43527,3368),(43528,3369),(43529,3370),(43530,3371),(43531,3372),(43532,3373),(43533,3374),(43534,3375),(43535,3376),(43536,3377),(43537,3378),(43538,3379),(43539,3380),(43540,3381),(43541,3382),(43542,3383),(43543,3384),(43544,3385),(43545,3386),(43546,3387),(43547,3388),(43548,3389),(43549,3390),(43550,3391),(43551,3392),(43552,3393),(43553,3394),(43554,3395),(43555,3396),(43556,3397),(43557,3398),(43558,3399),(43559,3400),(43560,3401),(43561,3402),(43562,3403),(43563,3404),(43564,3405),(43565,3406),(43566,3407),(43567,3408),(43568,3409),(43569,3410),(43570,3411),(43571,3412),(43572,3413),(43573,3414),(43574,3415),(43575,3416),(43576,3417),(43577,3418),(43578,3419),(43579,3420),(43580,3421),(43581,3422),(43582,3423),(43583,3424),(43584,3425),(43585,3426),(43586,3427),(43587,3428),(43588,3429),(43589,3430),(43590,3431),(43591,3432),(43592,3433),(43593,3434),(43594,3435),(43595,3436),(43596,3437),(43597,3438),(43598,3439),(43599,3440),(43600,3441),(43601,3442),(43602,3443),(43603,3444),(43604,3445),(43605,3446),(43606,3447),(43607,3448),(43608,3449),(43609,3450),(43610,3451),(43611,3452),(43612,3453),(43613,3454),(43614,3455),(43615,3456),(43616,3457),(43617,3458),(43618,3459),(43619,3460),(43620,3461),(43621,3462),(43622,3463),(43623,3464),(43624,3465),(43625,3466),(43626,3467),(43627,3468),(43628,3469),(43629,3470),(43630,3471),(43631,3472),(43632,3473),(43633,3474),(43634,3475),(43635,3476),(43636,3477),(43637,3478),(43638,3479),(43639,3480),(43640,3481),(43641,3482),(43642,3483),(43643,3484),(43644,3485),(43645,3486),(43646,3487),(43647,3488),(43648,3489),(43649,3539),(43650,3540),(43651,3541),(43652,3542),(43653,3648),(43654,3675),(43655,3676),(43656,3677),(43657,3678),(43658,3679),(43659,3680),(43660,3681),(43661,3682),(43662,3683),(43663,2858),(43664,2863),(43665,2866),(43666,2867),(43667,2890),(43668,2891),(43669,2895),(43670,2896),(43671,2897),(43672,2898),(43673,2899),(43674,2917),(43675,2976),(43676,2978),(43677,2987),(43678,2989),(43679,2990),(43680,3012),(43681,3050),(43682,3051),(43683,3052),(43684,3053),(43685,3054),(43686,3055),(43687,3102),(43688,3126),(43689,3127),(43690,3128),(43691,3129),(43692,3130),(43693,3131),(43694,3132),(43695,3133),(43696,3134),(43697,3135),(43698,3136),(43699,3137),(43700,3138),(43701,3139),(43702,3140),(43703,3141),(43704,3142),(43705,3143),(43706,3144),(43707,3145),(43708,3146),(43709,3147),(43710,3148),(43711,3149),(43712,3150),(43713,3151),(43714,3152),(43715,3153),(43716,3154),(43717,3155),(43718,3156),(43719,3157),(43720,3158),(43721,3159),(43722,3160),(43723,3161),(43724,3162),(43725,3163),(43726,3167),(43727,3168),(43728,3169),(43729,3170),(43730,3171),(43731,3172),(43732,3173),(43733,3174),(43734,3175),(43735,3176),(43736,3177),(43737,3178),(43738,3179),(43739,3180),(43740,3181),(43741,3182),(43742,3183),(43743,3184),(43744,3185),(43745,3186),(43746,3187),(43747,3188),(43748,3189),(43749,3190),(43750,3191),(43751,3192),(43752,3193),(43753,3194),(43754,3195),(43755,3196),(43756,3197),(43757,3198),(43758,3199),(43759,3200),(43760,3201),(43761,3202),(43762,3203),(43763,3204),(43764,3205),(43765,3206),(43766,3207),(43767,3208),(43768,3209),(43769,3210),(43770,3211),(43771,3212),(43772,3213),(43773,3214),(43774,3215),(43775,3216),(43776,3217),(43777,3218),(43778,3219),(43779,3220),(43780,3221),(43781,3222),(43782,3223),(43783,3224),(43784,3225),(43785,3226),(43786,3227),(43787,3228),(43788,3229),(43789,3230),(43790,3231),(43791,3232),(43792,3233),(43793,3234),(43794,3235),(43795,3236),(43796,3237),(43797,3238),(43798,3239),(43799,3240),(43800,3241),(43801,3242),(43802,3243),(43803,3244),(43804,3245),(43805,3246),(43806,3247),(43807,3248),(43808,3249),(43809,3250),(43810,3251),(43811,3252),(43812,3253),(43813,3254),(43814,3255),(43815,3256),(43816,3257),(43817,3258),(43818,3259),(43819,3260),(43820,3261),(43821,3262),(43822,3263),(43823,3264),(43824,3265),(43825,3266),(43826,3267),(43827,3268),(43828,3269),(43829,3270),(43830,3271),(43831,3272),(43832,3273),(43833,3274),(43834,3275),(43835,3276),(43836,3277),(43837,3278),(43838,3279),(43839,3280),(43840,3281),(43841,3282),(43842,3283),(43843,3284),(43844,3285),(43845,3286),(43846,3287),(43847,3288),(43848,3289),(43849,3290),(43850,3291),(43851,3292),(43852,3293),(43853,3294),(43854,3295),(43855,3296),(43856,3297),(43857,3298),(43858,3299),(43859,3300),(43860,3301),(43861,3302),(43862,3303),(43863,2622),(43864,2623),(43865,2624),(43866,2625),(43867,2626),(43868,2627),(43869,2628),(43870,2629),(43871,2630),(43872,2631),(43873,2632),(43874,2633),(43875,2634),(43876,2635),(43877,2636),(43878,2637),(43879,2638),(43880,2639),(43881,2640),(43882,2641),(43883,2642),(43884,2643),(43885,2644),(43886,2645),(43887,2646),(43888,2647),(43889,2648),(43890,2649),(43891,2650),(43892,2651),(43893,2652),(43894,2653),(43895,2654),(43896,2658),(43897,2659),(43898,2660),(43899,2661),(43900,2662),(43901,2663),(43902,2664),(43903,2665),(43904,2666),(43905,2667),(43906,2668),(43907,2669),(43908,2670),(43909,2671),(43910,2672),(43911,2673),(43912,2674),(43913,2675),(43914,2676),(43915,2677),(43916,2678),(43917,2679),(43918,2680),(43919,2681),(43920,2682),(43921,2683),(43922,2684),(43923,2685),(43924,2686),(43925,2687),(43926,2688),(43927,2689),(43928,2690),(43929,2691),(43930,2692),(43931,2693),(43932,2694),(43933,2695),(43934,2696),(43935,2697),(43936,2698),(43937,2700),(43938,2703),(43939,2781),(43940,2794),(43941,2795),(43942,2796),(43943,2798),(43944,2821),(43945,2828),(43946,2829),(43947,2830),(43948,2833),(43949,2834),(43950,2835),(43951,2836),(43952,2837),(43953,2838),(43954,2839),(43955,2840),(43956,2841),(43957,2842),(43958,2843),(43959,39),(43960,40),(43961,41),(43962,42),(43963,43),(43964,44),(43965,750),(43966,751),(43967,752),(43968,753),(43969,882),(43970,883),(43971,884),(43972,885),(43973,886),(43974,887),(43975,888),(43976,889),(43977,890),(43978,891),(43979,892),(43980,893),(43981,894),(43982,895),(43983,896),(43984,897),(43985,898),(43986,899),(43987,900),(43988,901),(43989,902),(43990,1473),(43991,1474),(43992,1475),(43993,1476),(43994,1477),(43995,1478),(43996,1479),(43997,1480),(43998,1481),(43999,1482),(44000,1483),(44001,1484),(44002,1485),(44003,1486),(44004,1487),(44005,1515),(44006,1516),(44007,1517),(44008,1537),(44009,1538),(44010,1539),(44011,1540),(44012,1541),(44013,1542),(44014,1543),(44015,1544),(44016,1545),(44017,1546),(44018,1547),(44019,1548),(44020,1549),(44021,1550),(44022,1551),(44023,1552),(44024,1553),(44025,1554),(44026,1555),(44027,1556),(44028,1560),(44029,1561),(44030,1763),(44031,4539),(44032,4540),(44033,4541),(44034,4542),(44035,4543),(44036,4544),(44037,4545),(44038,4546),(44039,4547),(44040,4548),(44041,4549),(44042,4550),(44043,4551),(44044,4552),(44045,4553),(44046,4554),(44047,4555),(44048,4556),(44049,4557),(44050,4558),(44051,4559),(44052,4560),(44053,4561),(44054,4562),(44055,4563),(44056,4564),(44057,4565),(44058,5275),(44059,5276),(44060,5277),(44061,5278),(44062,5279),(44063,5280),(44064,5281),(44065,5309),(44066,5310),(44067,5311),(44068,5312),(44069,5313),(44070,5314),(44071,5315),(44072,5316),(44073,5317),(44074,5318),(44075,5319),(44076,5320),(44077,5338),(44078,5339),(44079,5340),(44080,5341),(44081,5342),(44082,5345),(44083,5346),(44084,5347),(44085,5348),(44086,5349),(44087,5350),(44088,5353),(44089,5357),(44090,5358),(44091,5680),(44092,5681),(44093,139),(44094,160),(44095,161),(44096,169),(44097,170),(44098,171),(44099,173),(44100,174),(44101,175),(44102,221),(44103,222),(44104,223),(44105,249),(44106,250),(44107,252),(44108,253),(44109,266),(44110,267),(44111,276),(44112,277),(44113,278),(44114,279),(44115,280),(44116,1575),(44117,1576),(44118,1577),(44119,1578),(44120,1805),(44121,1806),(44122,2200),(44123,2208),(44124,2209),(44125,2210),(44126,2245),(44127,2246),(44128,2256),(44129,2257),(44130,2302),(44131,2303),(44132,2304),(44133,2305),(44134,2306),(44135,2396),(44136,2397),(44137,2398),(44138,2399),(44139,2400),(44140,2401),(44141,2402),(44142,2403),(44143,2404),(44144,2405),(44145,2406),(44146,2407),(44147,2408),(44148,2409),(44149,2410),(44150,2458),(44151,2459),(44152,2503),(44153,4627),(44154,4714),(44155,4715),(44156,4716),(44157,4717),(44158,4719),(44159,4720),(44160,4721),(44161,4722),(44162,4723),(44163,4724),(44164,4725),(44165,4726),(44166,4727),(44167,4728),(44168,4729),(44169,4809),(44170,4810),(44171,4811),(44172,4823),(44173,4843),(44174,4844),(44175,4846),(44176,4847),(44177,4848),(44178,4849),(44179,4850),(44180,4851),(44181,4852),(44182,4856),(44183,4899),(44184,4901),(44185,4905),(44186,4906),(44187,4910),(44188,4992),(44189,4993),(44190,4994),(44191,4995),(44192,4996),(44193,4997),(44194,4998),(44195,4999),(44196,5000),(44197,5019),(44198,5020),(44199,5021),(44200,5022),(44201,5023),(44202,5039),(44203,5040),(44204,5041),(44205,5042),(44206,5043),(44207,5044),(44208,5045),(44209,5046),(44210,5047),(44211,5048),(44212,5049),(44213,5050),(44214,5051),(44215,5052),(44216,5053),(44217,5054),(44218,5055),(44219,5056),(44220,5057),(44221,5058),(44222,5059),(44223,5060),(44224,5061),(44225,5065),(44226,5066),(44227,5067),(44228,5068),(44229,5069),(44230,5070),(44231,5071),(44232,5072),(44233,5195),(44234,5196),(44235,5198),(44236,5199),(44237,3829),(44238,3830),(44239,3831),(44240,3832),(44241,3833),(44242,3834),(44243,3975),(44244,3976),(44245,4052),(44246,4053),(44247,4212),(44248,4218),(44249,4219),(44250,4220),(44251,4282),(44252,4283),(44253,4315),(44254,4437),(44255,4438),(44256,4439),(44257,3715),(44258,3716),(44259,3718),(44260,3750),(44261,3774),(44262,3827),(44263,3828),(44264,96),(44265,97),(44266,98),(44267,99),(44268,100),(44269,101),(44270,102),(44271,103),(44272,104),(44273,105),(44274,106),(44275,107),(44276,108),(44277,109),(44278,138),(44279,244),(44280,245),(44281,251),(44282,873),(44283,874),(44284,875),(44285,876),(44286,877),(44287,878),(44288,879),(44289,880),(44290,881),(44291,1039),(44292,1099),(44293,1140),(44294,1141),(44295,1142),(44296,1143),(44297,1149),(44298,1150),(44299,1495),(44300,1497),(44301,1498),(44302,1499),(44303,1500),(44304,1501),(44305,1502),(44306,1503),(44307,1504),(44308,1505),(44309,1506),(44310,1507),(44311,1508),(44312,1509),(44313,1510),(44314,1511),(44315,1512),(44316,1513),(44317,1514),(44318,1796),(44319,1797),(44320,4538),(44321,5171),(44322,5285),(44323,5287),(44324,5288),(44325,5289),(44326,5290),(44327,5291),(44328,5292),(44329,5293),(44330,5294),(44331,5295),(44332,5296),(44333,5297),(44334,5298),(44335,5299),(44336,5300),(44337,5302),(44338,5303),(44339,5304),(44340,5305),(44341,5306),(44342,5307),(44343,5308),(44344,5321),(44345,5322),(44346,5536),(44347,5537),(44348,5689),(44349,5696),(44350,5752),(44351,2655),(44352,2656),(44353,2657),(44354,2766),(44355,2767),(44356,2768),(44357,2769),(44358,2770),(44359,2771),(44360,2773),(44361,2782),(44362,2793),(44363,2969),(44364,2970),(44365,2971),(44366,2972),(44367,2973),(44368,2974),(44369,2975),(44370,2993),(44371,2994),(44372,2995),(44373,2996),(44374,2997),(44375,2998),(44376,2999),(44377,3000),(44378,3001),(44379,3002),(44380,3003),(44381,3004),(44382,3005),(44383,3006),(44384,3007),(44385,3008),(44386,3009),(44387,3010),(44388,3011),(44389,3125),(44390,3490),(44391,3491),(44392,3492),(44393,3493),(44394,3494),(44395,3495),(44396,3496),(44397,3497),(44398,3498),(44399,3499),(44400,3500),(44401,3501),(44402,3502),(44403,3503),(44404,3504),(44405,3505),(44406,3506),(44407,3507),(44408,3508),(44409,3509),(44410,3510),(44411,3511),(44412,3512),(44413,3513),(44414,3514),(44415,3515),(44416,3516),(44417,3517),(44418,3518),(44419,3519),(44420,3520),(44421,3521),(44422,3522),(44423,3523),(44424,3524),(44425,3525),(44426,3526),(44427,3527),(44428,3573),(44429,3574),(44430,3575),(44431,3576),(44432,3577),(44433,3578),(44434,3579),(44435,3580),(44436,3583),(44437,3592),(44438,3593),(44439,3594),(44440,3595),(44441,3596),(44442,3597),(44443,3598),(44444,3599),(44445,3600),(44446,3601),(44447,3602),(44448,3603),(44449,3604),(44450,3605),(44451,3606),(44452,3607),(44453,3608),(44454,3609),(44455,3686),(44456,3687),(44457,3688),(44458,3689),(44459,3690),(44460,3691),(44461,3692),(44462,3693),(44463,3694),(44464,3695),(44465,3696),(44466,3697),(44467,3698),(44468,3699),(44469,3700),(44470,3701),(44471,3702),(44472,3703),(44473,3704),(44474,3705),(44475,3706),(44476,3707),(44477,3708),(44478,3709),(44479,3710),(44480,3711),(44481,3712),(44482,3713),(44483,3714),(44484,3861),(44485,3870),(44486,3875),(44487,3876),(44488,3877),(44489,3878),(44490,3879),(44491,3880),(44492,3892),(44493,3964),(44494,3965),(44495,4059),(44496,4060),(44497,4170),(44498,4171),(44499,4172),(44500,4173),(44501,4174),(44502,4175),(44503,4202),(44504,4203),(44505,4243),(44506,4244),(44507,4245),(44508,4257),(44509,4277),(44510,4278),(44511,4279),(44512,4280),(44513,4281),(44514,4287),(44515,4288),(44516,4289),(44517,4290),(44518,4294),(44519,4295),(44520,4296),(44521,4337),(44522,4338),(44523,4339),(44524,4340),(44525,4342),(44526,4343),(44527,4434),(44528,4435),(44529,4436),(44530,4441),(44531,4442),(44532,4443),(44533,4444),(44534,4445),(44535,4446),(44536,4447),(44537,4448),(44538,4449),(44539,4450),(44540,4451),(44541,4452),(44542,4453),(44543,4454),(44544,4455),(44545,4456),(44546,2667),(44547,2668),(44548,2669),(44549,2670),(44550,2833),(44551,2834),(44552,2835),(44553,2836),(44554,2837),(44555,2861),(44556,2862),(44557,2887),(44558,2699),(44559,2703),(44560,2708),(44561,2711),(44562,2712),(44563,2713),(44564,2714),(44565,2717),(44566,2721),(44567,2722),(44568,2723),(44569,2730),(44570,2765),(44571,2798),(44572,2799),(44573,2800),(44574,2801),(44575,2802),(44576,2803),(44577,2804),(44578,2810),(44579,2812),(44580,2815),(44581,2821),(44582,2828),(44583,2829),(44584,2843),(44585,2856),(44586,2858),(44587,2863),(44588,2886),(44589,2890),(44590,2891),(44591,2893),(44592,2899),(44593,2900),(44594,2904),(44595,2917),(44596,2918),(44597,2923),(44598,2925),(44599,2926),(44600,2929),(44601,2930),(44602,2943),(44603,2945),(44604,2955),(44605,2976),(44606,2978),(44607,2979),(44608,2980),(44609,2987),(44610,2989),(44611,2990),(44612,2998),(44613,2999),(44614,3000),(44615,3001),(44616,3002),(44617,3003),(44618,3004),(44619,3005),(44620,3006),(44621,3007),(44622,3012),(44623,3042),(44624,3043),(44625,3126),(44626,3128),(44627,3130),(44628,3132),(44629,3135),(44630,3140),(44631,3142),(44632,3143),(44633,3146),(44634,3147),(44635,3148),(44636,3149),(44637,3152),(44638,3154),(44639,3155),(44640,3156),(44641,3159),(44642,3172),(44643,3184),(44644,3214),(44645,3407),(44646,3421),(44647,3479),(44648,3480),(44649,3488),(44650,3489),(44651,3490),(44652,3491),(44653,3492),(44654,3493),(44655,3494),(44656,3495),(44657,3496),(44658,3497),(44659,3498),(44660,3499),(44661,3500),(44662,3501),(44663,3502),(44664,3503),(44665,3539),(44666,3540),(44667,3543),(44668,3548),(44669,3573),(44670,3574),(44671,3575),(44672,3576),(44673,3577),(44674,3578),(44675,3579),(44676,3580),(44677,3583),(44678,3592),(44679,3593),(44680,3594),(44681,3595),(44682,3596),(44683,3597),(44684,3598),(44685,3599),(44686,3600),(44687,3601),(44688,3602),(44689,3603),(44690,3604),(44691,3605),(44692,3606),(44693,3607),(44694,3608),(44695,3609),(44696,3620),(44697,3673),(44698,3674),(44699,3686),(44700,3687),(44701,3688),(44702,3689),(44703,3690),(44704,3691),(44705,3692),(44706,3693),(44707,3694),(44708,3695),(44709,3696),(44710,3697),(44711,3698),(44712,3699),(44713,3700),(44714,3701),(44715,3702),(44716,3703),(44717,3704),(44718,3705),(44719,3706),(44720,3707),(44721,3708),(44722,3709),(44723,3710),(44724,3714),(44725,1700),(44726,2696),(44727,2697),(44728,2698),(44729,2699),(44730,2821),(44731,2840),(44732,2841),(44733,2842),(44734,2891),(44735,2904),(44736,2918),(44737,2922),(44738,2923),(44739,2925),(44740,2926),(44741,2929),(44742,2930),(44743,2943),(44744,2945),(44745,2979),(44746,2980),(44747,2998),(44748,2999),(44749,3000),(44750,3001),(44751,3002),(44752,3003),(44753,3004),(44754,3005),(44755,3006),(44756,3007),(44757,3042),(44758,3043),(44759,3118),(44760,3126),(44761,3132),(44762,3135),(44763,3143),(44764,3147),(44765,3148),(44766,3159),(44767,3170),(44768,3171),(44769,3173),(44770,3174),(44771,3175),(44772,3176),(44773,3177),(44774,3178),(44775,3179),(44776,3180),(44777,3181),(44778,3185),(44779,3186),(44780,3187),(44781,3188),(44782,3189),(44783,3190),(44784,3191),(44785,3192),(44786,3193),(44787,3194),(44788,3195),(44789,3204),(44790,3205),(44791,3206),(44792,3207),(44793,3208),(44794,3212),(44795,3213),(44796,3245),(44797,3246),(44798,3247),(44799,3248),(44800,3249),(44801,3250),(44802,3251),(44803,3252),(44804,3253),(44805,3254),(44806,3255),(44807,3256),(44808,3278),(44809,3279),(44810,3280),(44811,3281),(44812,3282),(44813,3283),(44814,3284),(44815,3285),(44816,3286),(44817,3287),(44818,3288),(44819,3289),(44820,3290),(44821,3291),(44822,3292),(44823,3381),(44824,3382),(44825,3383),(44826,3384),(44827,3385),(44828,3386),(44829,3387),(44830,3389),(44831,3390),(44832,3392),(44833,3393),(44834,3394),(44835,3395),(44836,3396),(44837,3397),(44838,3398),(44839,3399),(44840,3400),(44841,3401),(44842,3404),(44843,3405),(44844,3406),(44845,3408),(44846,3409),(44847,3410),(44848,3411),(44849,3412),(44850,3413),(44851,3414),(44852,3415),(44853,3416),(44854,3417),(44855,3418),(44856,3419),(44857,3420),(44858,3421),(44859,3422),(44860,3423),(44861,3424),(44862,3425),(44863,3426),(44864,3427),(44865,3428),(44866,3429),(44867,3430),(44868,3431),(44869,3432),(44870,3433),(44871,3434),(44872,3435),(44873,3436),(44874,3437),(44875,3438),(44876,3439),(44877,3440),(44878,3441),(44879,3442),(44880,3443),(44881,3444),(44882,3445),(44883,3446),(44884,3447),(44885,3448),(44886,3449),(44887,3450),(44888,3451),(44889,3452),(44890,3453),(44891,3454),(44892,3455),(44893,3456),(44894,3457),(44895,3458),(44896,3481),(44897,3482),(44898,3483),(44899,3484),(44900,3485),(44901,3486),(44902,3487),(44903,3489),(44904,3592),(44905,3595),(44906,3596),(44907,3597),(44908,3598),(44909,3599),(44910,3600),(44911,3601),(44912,3602),(44913,3603),(44914,3604),(44915,3605),(44916,3606),(44917,3607),(44918,3608),(44919,3609),(44920,3623),(44921,3686),(44922,3687),(44923,3688),(44924,3689),(44925,3690),(44926,3691),(44927,3692),(44928,3693),(44929,3694),(44930,3695),(44931,3696),(44932,3697),(44933,3698),(44934,3699),(44935,3700),(44936,3701),(44937,3702),(44938,3703),(44939,3704),(44940,3705),(44941,3706),(44942,3707),(44943,3708),(44944,3709),(44945,3710),(44946,3714),(44947,4563),(44948,4563),(44949,3714),(44950,326),(44951,327),(44952,330),(44953,331),(44954,904),(44955,1153),(44956,1154),(44957,1473),(44958,1475),(44959,1486),(44960,1487),(44961,1529),(44962,1530),(44963,1542),(44964,1543),(44965,1545),(44966,1665),(44967,1666),(44968,1836),(44969,1837),(44970,1838),(44971,1839),(44972,1840),(44973,1841),(44974,1842),(44975,1843),(44976,1844),(44977,1845),(44978,1846),(44979,1847),(44980,1848),(44981,1849),(44982,1850),(44983,1851),(44984,1852),(44985,1853),(44986,1854),(44987,1855),(44988,1856),(44989,1857),(44990,1858),(44991,1859),(44992,1860),(44993,1861),(44994,1862),(44995,1863),(44996,1864),(44997,1865),(44998,1866),(44999,1867),(45000,1868),(45001,1869),(45002,1870),(45003,1871),(45004,1872),(45005,1873),(45006,1874),(45007,1875),(45008,1876),(45009,1880),(45010,1881),(45011,1882),(45012,1883),(45013,1884),(45014,1886),(45015,1887),(45016,1888),(45017,1889),(45018,1890),(45019,1891),(45020,1892),(45021,1893),(45022,1894),(45023,1895),(45024,1896),(45025,1897),(45026,1898),(45027,1899),(45028,1900),(45029,1901),(45030,1902),(45031,1903),(45032,1904),(45033,1905),(45034,1906),(45035,1907),(45036,1908),(45037,1909),(45038,1910),(45039,1911),(45040,1912),(45041,1913),(45042,1914),(45043,1915),(45044,1916),(45045,1917),(45046,1918),(45047,1919),(45048,1920),(45049,1921),(45050,1922),(45051,1923),(45052,1924),(45053,1925),(45054,1926),(45055,1927),(45056,1928),(45057,1929),(45058,1930),(45059,1936),(45060,1937),(45061,1938),(45062,2221),(45063,2290),(45064,2291),(45065,2293),(45066,2700),(45067,4530),(45068,4536),(45069,4897),(45070,5171),(45071,5524),(45072,326),(45073,327),(45074,330),(45075,331),(45076,904),(45077,1153),(45078,1154),(45079,1473),(45080,1475),(45081,1486),(45082,1487),(45083,1529),(45084,1530),(45085,1542),(45086,1543),(45087,1545),(45088,1665),(45089,1666),(45090,1836),(45091,1837),(45092,1838),(45093,1839),(45094,1840),(45095,1841),(45096,1842),(45097,1843),(45098,1844),(45099,1845),(45100,1846),(45101,1847),(45102,1848),(45103,1849),(45104,1850),(45105,1851),(45106,1852),(45107,1853),(45108,1854),(45109,1855),(45110,1856),(45111,1857),(45112,1858),(45113,1859),(45114,1860),(45115,1861),(45116,1862),(45117,1863),(45118,1864),(45119,1865),(45120,1866),(45121,1867),(45122,1868),(45123,1869),(45124,1870),(45125,1871),(45126,1872),(45127,1873),(45128,1874),(45129,1875),(45130,1876),(45131,1880),(45132,1881),(45133,1882),(45134,1883),(45135,1884),(45136,1886),(45137,1887),(45138,1888),(45139,1889),(45140,1890),(45141,1891),(45142,1892),(45143,1893),(45144,1894),(45145,1895),(45146,1896),(45147,1897),(45148,1898),(45149,1899),(45150,1900),(45151,1901),(45152,1902),(45153,1903),(45154,1904),(45155,1905),(45156,1906),(45157,1907),(45158,1908),(45159,1909),(45160,1910),(45161,1911),(45162,1912),(45163,1913),(45164,1914),(45165,1915),(45166,1916),(45167,1917),(45168,1918),(45169,1919),(45170,1920),(45171,1921),(45172,1922),(45173,1923),(45174,1924),(45175,1925),(45176,1926),(45177,1927),(45178,1928),(45179,1929),(45180,1930),(45181,1936),(45182,1937),(45183,1938),(45184,2221),(45185,2290),(45186,2291),(45187,2293),(45188,4530),(45189,4536),(45190,4897),(45191,5171),(45192,5524),(45193,2700),(45194,2918),(45195,3043),(45196,5584),(45197,5585),(45198,2921),(45199,2922),(45200,2924),(45201,2927),(45202,2928),(45203,2929),(45204,2930),(45205,2931),(45206,2932),(45207,2933),(45208,2934),(45209,2935),(45210,2936),(45211,2937),(45212,2938),(45213,2939),(45214,2940),(45215,2941),(45216,2942),(45217,2944),(45218,2945),(45219,2946),(45220,2947),(45221,2948),(45222,2949),(45223,2950),(45224,2951),(45225,2952),(45226,2953),(45227,2954),(45228,3164),(45229,3165),(45230,3166),(45231,3534),(45232,3535),(45233,3536),(45234,2699),(45235,2923),(45236,2925),(45237,2926),(45238,2943),(45239,2979),(45240,2980),(45241,3042),(45242,2701),(45243,2702),(45244,2760),(45245,2761),(45246,2762),(45247,2763),(45248,2764),(45249,2765),(45250,2772),(45251,2774),(45252,2775),(45253,2776),(45254,2777),(45255,2778),(45256,2779),(45257,2780),(45258,2783),(45259,2784),(45260,2785),(45261,2786),(45262,2787),(45263,2788),(45264,2789),(45265,2790),(45266,2791),(45267,2792),(45268,2799),(45269,2800),(45270,2801),(45271,2802),(45272,2803),(45273,2804),(45274,2805),(45275,2806),(45276,2807),(45277,2808),(45278,2809),(45279,2810),(45280,2811),(45281,2812),(45282,2813),(45283,2814),(45284,2815),(45285,2816),(45286,2817),(45287,2818),(45288,2819),(45289,2820),(45290,2822),(45291,2823),(45292,2824),(45293,2825),(45294,2826),(45295,2827),(45296,2831),(45297,2832),(45298,2844),(45299,2845),(45300,2846),(45301,2847),(45302,2848),(45303,2849),(45304,2850),(45305,2851),(45306,2852),(45307,2853),(45308,2854),(45309,2855),(45310,2856),(45311,2859),(45312,2860),(45313,2861),(45314,2862),(45315,2864),(45316,2865),(45317,2868),(45318,2869),(45319,2870),(45320,2871),(45321,2872),(45322,2873),(45323,2874),(45324,2875),(45325,2876),(45326,2877),(45327,2878),(45328,2879),(45329,2880),(45330,2881),(45331,2882),(45332,2883),(45333,2884),(45334,2885),(45335,2886),(45336,2887),(45337,2888),(45338,2889),(45339,2892),(45340,2893),(45341,2900),(45342,2901),(45343,2902),(45344,2903),(45345,2905),(45346,2906),(45347,2907),(45348,2908),(45349,2909),(45350,2910),(45351,2911),(45352,2912),(45353,2913),(45354,2914),(45355,2915),(45356,2916),(45357,2955),(45358,2956),(45359,2957),(45360,2958),(45361,2959),(45362,2960),(45363,2961),(45364,2962),(45365,2963),(45366,2964),(45367,2965),(45368,2966),(45369,2967),(45370,2968),(45371,2981),(45372,2982),(45373,2983),(45374,2984),(45375,2985),(45376,2986),(45377,2991),(45378,2992),(45379,3013),(45380,3014),(45381,3015),(45382,3016),(45383,3017),(45384,3018),(45385,3019),(45386,3020),(45387,3021),(45388,3022),(45389,3023),(45390,3024),(45391,3025),(45392,3026),(45393,3027),(45394,3028),(45395,3029),(45396,3030),(45397,3031),(45398,3032),(45399,3033),(45400,3034),(45401,3035),(45402,3036),(45403,3037),(45404,3038),(45405,3039),(45406,3040),(45407,3041),(45408,3044),(45409,3045),(45410,3046),(45411,3047),(45412,3048),(45413,3049),(45414,3056),(45415,3057),(45416,3058),(45417,3059),(45418,3060),(45419,3061),(45420,3062),(45421,3063),(45422,3064),(45423,3065),(45424,3066),(45425,3067),(45426,3068),(45427,3069),(45428,3070),(45429,3071),(45430,3072),(45431,3073),(45432,3074),(45433,3075),(45434,3076),(45435,3077),(45436,3078),(45437,3079),(45438,3080),(45439,3081),(45440,3082),(45441,3083),(45442,3084),(45443,3085),(45444,3086),(45445,3087),(45446,3088),(45447,3089),(45448,3090),(45449,3091),(45450,3092),(45451,3093),(45452,3094),(45453,3095),(45454,3096),(45455,3097),(45456,3098),(45457,3099),(45458,3100),(45459,3101),(45460,3103),(45461,3104),(45462,3105),(45463,3106),(45464,3107),(45465,3108),(45466,3109),(45467,3110),(45468,3111),(45469,3112),(45470,3113),(45471,3114),(45472,3115),(45473,3116),(45474,3117),(45475,3119),(45476,3120),(45477,3121),(45478,3122),(45479,3123),(45480,3124),(45481,3528),(45482,3529),(45483,3530),(45484,3531),(45485,3532),(45486,3533),(45487,3537),(45488,3538),(45489,3543),(45490,3544),(45491,3545),(45492,3546),(45493,3547),(45494,3548),(45495,3549),(45496,3550),(45497,3551),(45498,3552),(45499,3553),(45500,3554),(45501,3555),(45502,3556),(45503,3557),(45504,3558),(45505,3559),(45506,3560),(45507,3561),(45508,3562),(45509,3563),(45510,3564),(45511,3565),(45512,3566),(45513,3567),(45514,3568),(45515,3569),(45516,3570),(45517,3571),(45518,3572),(45519,3581),(45520,3582),(45521,3584),(45522,3585),(45523,3586),(45524,3587),(45525,3588),(45526,3589),(45527,3590),(45528,3591),(45529,3610),(45530,3611),(45531,3612),(45532,3613),(45533,3614),(45534,3615),(45535,3616),(45536,3617),(45537,3618),(45538,3619),(45539,3620),(45540,3621),(45541,3622),(45542,3624),(45543,3625),(45544,3626),(45545,3627),(45546,3628),(45547,3629),(45548,3630),(45549,3631),(45550,3632),(45551,3633),(45552,3634),(45553,3635),(45554,3636),(45555,3637),(45556,3638),(45557,3639),(45558,3640),(45559,3641),(45560,3642),(45561,3643),(45562,3644),(45563,3645),(45564,3646),(45565,3647),(45566,3649),(45567,3650),(45568,3651),(45569,3652),(45570,3653),(45571,3654),(45572,3655),(45573,3656),(45574,3657),(45575,3658),(45576,3659),(45577,3661),(45578,3662),(45579,3663),(45580,3664),(45581,3665),(45582,3666),(45583,3667),(45584,3668),(45585,3669),(45586,3670),(45587,3671),(45588,3672),(45589,3673),(45590,3674),(45591,3684),(45592,3685),(45593,3660),(45594,2655),(45595,2656),(45596,2657),(45597,2766),(45598,2767),(45599,2768),(45600,2769),(45601,2770),(45602,2771),(45603,2773),(45604,2782),(45605,2793),(45606,2969),(45607,2970),(45608,2971),(45609,2972),(45610,2973),(45611,2974),(45612,2975),(45613,2993),(45614,2994),(45615,2995),(45616,2996),(45617,2997),(45618,2998),(45619,2999),(45620,3000),(45621,3001),(45622,3002),(45623,3003),(45624,3004),(45625,3005),(45626,3006),(45627,3007),(45628,3008),(45629,3009),(45630,3010),(45631,3011),(45632,3125),(45633,3490),(45634,3491),(45635,3492),(45636,3493),(45637,3494),(45638,3495),(45639,3496),(45640,3497),(45641,3498),(45642,3499),(45643,3500),(45644,3501),(45645,3502),(45646,3503),(45647,3504),(45648,3505),(45649,3506),(45650,3507),(45651,3508),(45652,3509),(45653,3510),(45654,3511),(45655,3512),(45656,3513),(45657,3514),(45658,3515),(45659,3516),(45660,3517),(45661,3518),(45662,3519),(45663,3520),(45664,3521),(45665,3522),(45666,3523),(45667,3524),(45668,3525),(45669,3526),(45670,3527),(45671,3573),(45672,3574),(45673,3575),(45674,3576),(45675,3577),(45676,3578),(45677,3579),(45678,3580),(45679,3583),(45680,3592),(45681,3593),(45682,3594),(45683,3595),(45684,3596),(45685,3597),(45686,3598),(45687,3599),(45688,3600),(45689,3601),(45690,3602),(45691,3603),(45692,3604),(45693,3605),(45694,3606),(45695,3607),(45696,3608),(45697,3609),(45698,3686),(45699,3687),(45700,3688),(45701,3689),(45702,3690),(45703,3691),(45704,3692),(45705,3693),(45706,3694),(45707,3695),(45708,3696),(45709,3697),(45710,3698),(45711,3699),(45712,3700),(45713,3701),(45714,3702),(45715,3703),(45716,3704),(45717,3705),(45718,3706),(45719,3707),(45720,3708),(45721,3709),(45722,3710),(45723,3711),(45724,3712),(45725,3713),(45726,3714),(45727,2622),(45728,2623),(45729,2624),(45730,2625),(45731,2626),(45732,2627),(45733,2628),(45734,2629),(45735,2630),(45736,2631),(45737,2632),(45738,2633),(45739,2634),(45740,2635),(45741,2636),(45742,2637),(45743,2638),(45744,2639),(45745,2640),(45746,2641),(45747,2642),(45748,2643),(45749,2644),(45750,2645),(45751,2646),(45752,2647),(45753,2648),(45754,2649),(45755,2650),(45756,2651),(45757,2652),(45758,2653),(45759,2654),(45760,2658),(45761,2659),(45762,2660),(45763,2661),(45764,2662),(45765,2663),(45766,2664),(45767,2665),(45768,2666),(45769,2667),(45770,2668),(45771,2669),(45772,2670),(45773,2671),(45774,2672),(45775,2673),(45776,2674),(45777,2675),(45778,2676),(45779,2677),(45780,2678),(45781,2679),(45782,2680),(45783,2681),(45784,2682),(45785,2683),(45786,2684),(45787,2685),(45788,2686),(45789,2687),(45790,2688),(45791,2689),(45792,2690),(45793,2691),(45794,2692),(45795,2693),(45796,2694),(45797,2695),(45798,2696),(45799,2697),(45800,2698),(45801,2700),(45802,2703),(45803,2781),(45804,2794),(45805,2795),(45806,2796),(45807,2798),(45808,2821),(45809,2828),(45810,2829),(45811,2830),(45812,2833),(45813,2834),(45814,2835),(45815,2836),(45816,2837),(45817,2838),(45818,2839),(45819,2840),(45820,2841),(45821,2842),(45822,2843),(45823,2858),(45824,2863),(45825,2866),(45826,2867),(45827,2890),(45828,2891),(45829,2895),(45830,2896),(45831,2897),(45832,2898),(45833,2899),(45834,2917),(45835,2976),(45836,2978),(45837,2987),(45838,2989),(45839,2990),(45840,3012),(45841,3050),(45842,3051),(45843,3052),(45844,3053),(45845,3054),(45846,3055),(45847,3102),(45848,3126),(45849,3127),(45850,3128),(45851,3129),(45852,3130),(45853,3131),(45854,3132),(45855,3133),(45856,3134),(45857,3135),(45858,3136),(45859,3137),(45860,3138),(45861,3139),(45862,3140),(45863,3141),(45864,3142),(45865,3143),(45866,3144),(45867,3145),(45868,3146),(45869,3147),(45870,3148),(45871,3149),(45872,3150),(45873,3151),(45874,3152),(45875,3153),(45876,3154),(45877,3155),(45878,3156),(45879,3157),(45880,3158),(45881,3159),(45882,3160),(45883,3161),(45884,3162),(45885,3163),(45886,3167),(45887,3168),(45888,3169),(45889,3170),(45890,3171),(45891,3172),(45892,3173),(45893,3174),(45894,3175),(45895,3176),(45896,3177),(45897,3178),(45898,3179),(45899,3180),(45900,3181),(45901,3182),(45902,3183),(45903,3184),(45904,3185),(45905,3186),(45906,3187),(45907,3188),(45908,3189),(45909,3190),(45910,3191),(45911,3192),(45912,3193),(45913,3194),(45914,3195),(45915,3196),(45916,3197),(45917,3198),(45918,3199),(45919,3200),(45920,3201),(45921,3202),(45922,3203),(45923,3204),(45924,3205),(45925,3206),(45926,3207),(45927,3208),(45928,3209),(45929,3210),(45930,3211),(45931,3212),(45932,3213),(45933,3214),(45934,3215),(45935,3216),(45936,3217),(45937,3218),(45938,3219),(45939,3220),(45940,3221),(45941,3222),(45942,3223),(45943,3224),(45944,3225),(45945,3226),(45946,3227),(45947,3228),(45948,3229),(45949,3230),(45950,3231),(45951,3232),(45952,3233),(45953,3234),(45954,3235),(45955,3236),(45956,3237),(45957,3238),(45958,3239),(45959,3240),(45960,3241),(45961,3242),(45962,3243),(45963,3244),(45964,3245),(45965,3246),(45966,3247),(45967,3248),(45968,3249),(45969,3250),(45970,3251),(45971,3252),(45972,3253),(45973,3254),(45974,3255),(45975,3256),(45976,3257),(45977,3258),(45978,3259),(45979,3260),(45980,3261),(45981,3262),(45982,3263),(45983,3264),(45984,3265),(45985,3266),(45986,3267),(45987,3268),(45988,3269),(45989,3270),(45990,3271),(45991,3272),(45992,3273),(45993,3274),(45994,3275),(45995,3276),(45996,3277),(45997,3278),(45998,3279),(45999,3280),(46000,3281),(46001,3282),(46002,3283),(46003,3284),(46004,3285),(46005,3286),(46006,3287),(46007,3288),(46008,3289),(46009,3290),(46010,3291),(46011,3292),(46012,3293),(46013,3294),(46014,3295),(46015,3296),(46016,3297),(46017,3298),(46018,3299),(46019,3300),(46020,3301),(46021,3302),(46022,3303),(46023,3304),(46024,3305),(46025,3306),(46026,3307),(46027,3308),(46028,3309),(46029,3310),(46030,3311),(46031,3312),(46032,3313),(46033,3314),(46034,3315),(46035,3316),(46036,3317),(46037,3318),(46038,3319),(46039,3320),(46040,3321),(46041,3322),(46042,3323),(46043,3324),(46044,3325),(46045,3326),(46046,3327),(46047,3328),(46048,3329),(46049,3330),(46050,3331),(46051,3332),(46052,3333),(46053,3334),(46054,3335),(46055,3336),(46056,3337),(46057,3338),(46058,3339),(46059,3340),(46060,3341),(46061,3342),(46062,3343),(46063,3344),(46064,3345),(46065,3346),(46066,3347),(46067,3348),(46068,3349),(46069,3350),(46070,3351),(46071,3352),(46072,3353),(46073,3354),(46074,3355),(46075,3356),(46076,3357),(46077,3358),(46078,3359),(46079,3360),(46080,3361),(46081,3362),(46082,3363),(46083,3364),(46084,3365),(46085,3366),(46086,3367),(46087,3368),(46088,3369),(46089,3370),(46090,3371),(46091,3372),(46092,3373),(46093,3374),(46094,3375),(46095,3376),(46096,3377),(46097,3378),(46098,3379),(46099,3380),(46100,3381),(46101,3382),(46102,3383),(46103,3384),(46104,3385),(46105,3386),(46106,3387),(46107,3388),(46108,3389),(46109,3390),(46110,3391),(46111,3392),(46112,3393),(46113,3394),(46114,3395),(46115,3396),(46116,3397),(46117,3398),(46118,3399),(46119,3400),(46120,3401),(46121,3402),(46122,3403),(46123,3404),(46124,3405),(46125,3406),(46126,3407),(46127,3408),(46128,3409),(46129,3410),(46130,3411),(46131,3412),(46132,3413),(46133,3414),(46134,3415),(46135,3416),(46136,3417),(46137,3418),(46138,3419),(46139,3420),(46140,3421),(46141,3422),(46142,3423),(46143,3424),(46144,3425),(46145,3426),(46146,3427),(46147,3428),(46148,3429),(46149,3430),(46150,3431),(46151,3432),(46152,3433),(46153,3434),(46154,3435),(46155,3436),(46156,3437),(46157,3438),(46158,3439),(46159,3440),(46160,3441),(46161,3442),(46162,3443),(46163,3444),(46164,3445),(46165,3446),(46166,3447),(46167,3448),(46168,3449),(46169,3450),(46170,3451),(46171,3452),(46172,3453),(46173,3454),(46174,3455),(46175,3456),(46176,3457),(46177,3458),(46178,3459),(46179,3460),(46180,3461),(46181,3462),(46182,3463),(46183,3464),(46184,3465),(46185,3466),(46186,3467),(46187,3468),(46188,3469),(46189,3470),(46190,3471),(46191,3472),(46192,3473),(46193,3474),(46194,3475),(46195,3476),(46196,3477),(46197,3478),(46198,3479),(46199,3480),(46200,3481),(46201,3482),(46202,3483),(46203,3484),(46204,3485),(46205,3486),(46206,3487),(46207,3488),(46208,3489),(46209,3539),(46210,3540),(46211,3541),(46212,3542),(46213,3648),(46214,3675),(46215,3676),(46216,3677),(46217,3678),(46218,3679),(46219,3680),(46220,3681),(46221,3682),(46222,3683),(46223,2700),(46224,2866),(46225,2867),(46226,3153),(46227,3675),(46228,3676),(46229,3677),(46230,3678),(46231,3679),(46232,3680),(46233,3681),(46234,3682),(46235,3683),(46236,2821),(46237,2842),(46238,2891),(46239,2918),(46240,2922),(46241,3043),(46242,3143),(46243,3170),(46244,3173),(46245,3175),(46246,3176),(46247,3178),(46248,3181),(46249,3185),(46250,3187),(46251,3204),(46252,3206),(46253,3208),(46254,3246),(46255,3251),(46256,3253),(46257,3254),(46258,3256),(46259,3278),(46260,3279),(46261,3284),(46262,3286),(46263,3382),(46264,3415),(46265,3425),(46266,3429),(46267,3439),(46268,3440),(46269,3443),(46270,3447),(46271,3686),(46272,3687),(46273,3701),(46274,5621),(46275,1700),(46276,2677),(46277,2696),(46278,2697),(46279,2698),(46280,2702),(46281,2703),(46282,2708),(46283,2711),(46284,2712),(46285,2713),(46286,2714),(46287,2717),(46288,2721),(46289,2722),(46290,2723),(46291,2730),(46292,2760),(46293,2761),(46294,2762),(46295,2763),(46296,2764),(46297,2765),(46298,2772),(46299,2774),(46300,2775),(46301,2776),(46302,2777),(46303,2778),(46304,2779),(46305,2780),(46306,2783),(46307,2784),(46308,2785),(46309,2786),(46310,2787),(46311,2788),(46312,2789),(46313,2790),(46314,2791),(46315,2792),(46316,2799),(46317,2801),(46318,2802),(46319,2803),(46320,2804),(46321,2810),(46322,2815),(46323,2822),(46324,2823),(46325,2824),(46326,2825),(46327,2826),(46328,2827),(46329,2831),(46330,2832),(46331,2840),(46332,2841),(46333,2844),(46334,2845),(46335,2852),(46336,2853),(46337,2854),(46338,2855),(46339,2856),(46340,2859),(46341,2860),(46342,2863),(46343,2886),(46344,2890),(46345,2892),(46346,2893),(46347,2899),(46348,2900),(46349,2901),(46350,2902),(46351,2903),(46352,2904),(46353,2917),(46354,2923),(46355,2955),(46356,2956),(46357,2957),(46358,2958),(46359,2959),(46360,2960),(46361,2961),(46362,2962),(46363,2976),(46364,2978),(46365,2989),(46366,2990),(46367,2998),(46368,2999),(46369,3000),(46370,3001),(46371,3002),(46372,3003),(46373,3004),(46374,3005),(46375,3006),(46376,3007),(46377,3012),(46378,3126),(46379,3129),(46380,3132),(46381,3135),(46382,3140),(46383,3142),(46384,3144),(46385,3146),(46386,3147),(46387,3148),(46388,3149),(46389,3152),(46390,3154),(46391,3155),(46392,3156),(46393,3159),(46394,3171),(46395,3174),(46396,3177),(46397,3179),(46398,3180),(46399,3184),(46400,3186),(46401,3188),(46402,3189),(46403,3190),(46404,3191),(46405,3192),(46406,3193),(46407,3194),(46408,3195),(46409,3205),(46410,3207),(46411,3212),(46412,3213),(46413,3214),(46414,3245),(46415,3247),(46416,3248),(46417,3249),(46418,3250),(46419,3252),(46420,3255),(46421,3280),(46422,3281),(46423,3282),(46424,3283),(46425,3285),(46426,3287),(46427,3288),(46428,3289),(46429,3290),(46430,3291),(46431,3292),(46432,3376),(46433,3377),(46434,3378),(46435,3379),(46436,3380),(46437,3381),(46438,3383),(46439,3384),(46440,3385),(46441,3386),(46442,3387),(46443,3389),(46444,3390),(46445,3392),(46446,3393),(46447,3394),(46448,3395),(46449,3396),(46450,3397),(46451,3398),(46452,3399),(46453,3400),(46454,3401),(46455,3404),(46456,3405),(46457,3406),(46458,3408),(46459,3409),(46460,3410),(46461,3411),(46462,3412),(46463,3413),(46464,3414),(46465,3416),(46466,3417),(46467,3418),(46468,3419),(46469,3420),(46470,3421),(46471,3422),(46472,3423),(46473,3424),(46474,3426),(46475,3427),(46476,3428),(46477,3430),(46478,3431),(46479,3432),(46480,3433),(46481,3434),(46482,3435),(46483,3436),(46484,3437),(46485,3438),(46486,3441),(46487,3442),(46488,3444),(46489,3445),(46490,3446),(46491,3448),(46492,3449),(46493,3450),(46494,3451),(46495,3452),(46496,3453),(46497,3454),(46498,3455),(46499,3456),(46500,3457),(46501,3458),(46502,3480),(46503,3481),(46504,3482),(46505,3483),(46506,3484),(46507,3485),(46508,3486),(46509,3487),(46510,3488),(46511,3489),(46512,3490),(46513,3491),(46514,3492),(46515,3493),(46516,3494),(46517,3495),(46518,3496),(46519,3497),(46520,3498),(46521,3499),(46522,3500),(46523,3501),(46524,3502),(46525,3503),(46526,3540),(46527,3543),(46528,3544),(46529,3545),(46530,3546),(46531,3547),(46532,3548),(46533,3573),(46534,3574),(46535,3575),(46536,3576),(46537,3577),(46538,3578),(46539,3579),(46540,3580),(46541,3583),(46542,3592),(46543,3593),(46544,3594),(46545,3595),(46546,3596),(46547,3597),(46548,3598),(46549,3599),(46550,3600),(46551,3601),(46552,3602),(46553,3603),(46554,3604),(46555,3605),(46556,3606),(46557,3607),(46558,3608),(46559,3609),(46560,3614),(46561,3615),(46562,3616),(46563,3617),(46564,3618),(46565,3619),(46566,3620),(46567,3649),(46568,3650),(46569,3673),(46570,3674),(46571,3684),(46572,3685),(46573,3688),(46574,3689),(46575,3690),(46576,3691),(46577,3692),(46578,3693),(46579,3694),(46580,3695),(46581,3696),(46582,3697),(46583,3698),(46584,3699),(46585,3700),(46586,3702),(46587,3703),(46588,3704),(46589,3705),(46590,3706),(46591,3707),(46592,3708),(46593,3709),(46594,3710),(46595,4563),(46596,5365),(46597,5527),(46598,5584),(46599,5585),(46600,5627),(46601,5637),(46602,5644),(46603,5645),(46604,5646),(46605,5652),(46606,5654),(46607,5663),(46608,5670),(46609,5671),(46610,5672),(46611,2622),(46612,2623),(46613,2624),(46614,2625),(46615,2626),(46616,2627),(46617,2628),(46618,2629),(46619,2630),(46620,2631),(46621,2632),(46622,2633),(46623,2634),(46624,2635),(46625,2636),(46626,2637),(46627,2638),(46628,2639),(46629,2640),(46630,2641),(46631,2642),(46632,2643),(46633,2644),(46634,2645),(46635,2646),(46636,2647),(46637,2648),(46638,2649),(46639,2650),(46640,2651),(46641,2652),(46642,2653),(46643,2654),(46644,2655),(46645,2656),(46646,2657),(46647,2658),(46648,2659),(46649,2660),(46650,2661),(46651,2662),(46652,2663),(46653,2664),(46654,2665),(46655,2666),(46656,2667),(46657,2668),(46658,2669),(46659,2670),(46660,2671),(46661,2672),(46662,2673),(46663,2674),(46664,2675),(46665,2676),(46666,2678),(46667,2679),(46668,2680),(46669,2681),(46670,2682),(46671,2683),(46672,2684),(46673,2685),(46674,2686),(46675,2687),(46676,2688),(46677,2689),(46678,2690),(46679,2691),(46680,2692),(46681,2693),(46682,2694),(46683,2695),(46684,2701),(46685,2702),(46686,2703),(46687,2704),(46688,2705),(46689,2706),(46690,2707),(46691,2708),(46692,2709),(46693,2710),(46694,2711),(46695,2712),(46696,2713),(46697,2714),(46698,2715),(46699,2716),(46700,2717),(46701,2718),(46702,2719),(46703,2720),(46704,2721),(46705,2722),(46706,2723),(46707,2724),(46708,2725),(46709,2726),(46710,2727),(46711,2728),(46712,2729),(46713,2730),(46714,2731),(46715,2732),(46716,2733),(46717,2734),(46718,2735),(46719,2736),(46720,2737),(46721,2738),(46722,2739),(46723,2740),(46724,2741),(46725,2742),(46726,2743),(46727,2744),(46728,2745),(46729,2746),(46730,2747),(46731,2748),(46732,2749),(46733,2750),(46734,2751),(46735,2752),(46736,2753),(46737,2754),(46738,2755),(46739,2756),(46740,2757),(46741,2758),(46742,2759),(46743,2760),(46744,2761),(46745,2762),(46746,2763),(46747,2764),(46748,2765),(46749,2766),(46750,2767),(46751,2768),(46752,2769),(46753,2770),(46754,2771),(46755,2772),(46756,2773),(46757,2774),(46758,2775),(46759,2776),(46760,2777),(46761,2778),(46762,2779),(46763,2780),(46764,2781),(46765,2782),(46766,2783),(46767,2784),(46768,2785),(46769,2786),(46770,2787),(46771,2788),(46772,2789),(46773,2790),(46774,2791),(46775,2792),(46776,2793),(46777,2794),(46778,2795),(46779,2796),(46780,2797),(46781,2798),(46782,2799),(46783,2800),(46784,2801),(46785,2802),(46786,2803),(46787,2804),(46788,2805),(46789,2806),(46790,2807),(46791,2808),(46792,2809),(46793,2810),(46794,2811),(46795,2812),(46796,2813),(46797,2814),(46798,2815),(46799,2816),(46800,2817),(46801,2818),(46802,2819),(46803,2820),(46804,2822),(46805,2823),(46806,2824),(46807,2825),(46808,2826),(46809,2827),(46810,2828),(46811,2829),(46812,2830),(46813,2831),(46814,2832),(46815,2833),(46816,2834),(46817,2835),(46818,2836),(46819,2837),(46820,2838),(46821,2839),(46822,2843),(46823,2844),(46824,2845),(46825,2846),(46826,2847),(46827,2848),(46828,2849),(46829,2850),(46830,2851),(46831,2852),(46832,2853),(46833,2854),(46834,2855),(46835,2856),(46836,2857),(46837,2858),(46838,2859),(46839,2860),(46840,2861),(46841,2862),(46842,2863),(46843,2864),(46844,2865),(46845,2868),(46846,2869),(46847,2870),(46848,2871),(46849,2872),(46850,2873),(46851,2874),(46852,2875),(46853,2876),(46854,2877),(46855,2878),(46856,2879),(46857,2880),(46858,2881),(46859,2882),(46860,2883),(46861,2884),(46862,2885),(46863,2886),(46864,2887),(46865,2888),(46866,2889),(46867,2890),(46868,2892),(46869,2893),(46870,2894),(46871,2895),(46872,2896),(46873,2897),(46874,2898),(46875,2899),(46876,2900),(46877,2901),(46878,2902),(46879,2903),(46880,2905),(46881,2906),(46882,2907),(46883,2908),(46884,2909),(46885,2910),(46886,2911),(46887,2912),(46888,2913),(46889,2914),(46890,2915),(46891,2916),(46892,2917),(46893,2921),(46894,2922),(46895,2924),(46896,2927),(46897,2928),(46898,2931),(46899,2932),(46900,2933),(46901,2934),(46902,2935),(46903,2936),(46904,2937),(46905,2938),(46906,2939),(46907,2940),(46908,2941),(46909,2942),(46910,2944),(46911,2946),(46912,2947),(46913,2948),(46914,2949),(46915,2950),(46916,2951),(46917,2952),(46918,2953),(46919,2954),(46920,2955),(46921,2956),(46922,2957),(46923,2958),(46924,2959),(46925,2960),(46926,2961),(46927,2962),(46928,2963),(46929,2964),(46930,2965),(46931,2966),(46932,2967),(46933,2968),(46934,2969),(46935,2970),(46936,2971),(46937,2972),(46938,2973),(46939,2974),(46940,2975),(46941,2976),(46942,2977),(46943,2978),(46944,2981),(46945,2982),(46946,2983),(46947,2984),(46948,2985),(46949,2986),(46950,2987),(46951,2988),(46952,2989),(46953,2990),(46954,2991),(46955,2992),(46956,2993),(46957,2994),(46958,2995),(46959,2996),(46960,2997),(46961,3008),(46962,3009),(46963,3010),(46964,3011),(46965,3012),(46966,3013),(46967,3014),(46968,3015),(46969,3016),(46970,3017),(46971,3018),(46972,3019),(46973,3020),(46974,3021),(46975,3022),(46976,3023),(46977,3024),(46978,3025),(46979,3026),(46980,3027),(46981,3028),(46982,3029),(46983,3030),(46984,3031),(46985,3032),(46986,3033),(46987,3034),(46988,3035),(46989,3036),(46990,3037),(46991,3038),(46992,3039),(46993,3040),(46994,3041),(46995,3044),(46996,3045),(46997,3046),(46998,3047),(46999,3048),(47000,3049),(47001,3050),(47002,3051),(47003,3052),(47004,3053),(47005,3054),(47006,3055),(47007,3056),(47008,3057),(47009,3058),(47010,3059),(47011,3060),(47012,3061),(47013,3062),(47014,3063),(47015,3064),(47016,3065),(47017,3066),(47018,3067),(47019,3068),(47020,3069),(47021,3070),(47022,3071),(47023,3072),(47024,3073),(47025,3074),(47026,3075),(47027,3076),(47028,3077),(47029,3078),(47030,3079),(47031,3080),(47032,3081),(47033,3082),(47034,3083),(47035,3084),(47036,3085),(47037,3086),(47038,3087),(47039,3088),(47040,3089),(47041,3090),(47042,3091),(47043,3092),(47044,3093),(47045,3094),(47046,3095),(47047,3096),(47048,3097),(47049,3098),(47050,3099),(47051,3100),(47052,3101),(47053,3102),(47054,3103),(47055,3104),(47056,3105),(47057,3106),(47058,3107),(47059,3108),(47060,3109),(47061,3110),(47062,3111),(47063,3112),(47064,3113),(47065,3114),(47066,3115),(47067,3116),(47068,3117),(47069,3119),(47070,3120),(47071,3121),(47072,3122),(47073,3123),(47074,3124),(47075,3125),(47076,3127),(47077,3128),(47078,3129),(47079,3130),(47080,3131),(47081,3133),(47082,3134),(47083,3136),(47084,3137),(47085,3138),(47086,3139),(47087,3140),(47088,3141),(47089,3142),(47090,3144),(47091,3145),(47092,3146),(47093,3147),(47094,3148),(47095,3149),(47096,3150),(47097,3151),(47098,3152),(47099,3153),(47100,3154),(47101,3155),(47102,3156),(47103,3157),(47104,3158),(47105,3160),(47106,3161),(47107,3162),(47108,3163),(47109,3164),(47110,3165),(47111,3166),(47112,3167),(47113,3168),(47114,3169),(47115,3172),(47116,3182),(47117,3183),(47118,3184),(47119,3196),(47120,3197),(47121,3198),(47122,3199),(47123,3200),(47124,3201),(47125,3202),(47126,3203),(47127,3209),(47128,3210),(47129,3211),(47130,3214),(47131,3215),(47132,3216),(47133,3217),(47134,3218),(47135,3219),(47136,3220),(47137,3221),(47138,3222),(47139,3223),(47140,3224),(47141,3225),(47142,3226),(47143,3227),(47144,3228),(47145,3229),(47146,3230),(47147,3231),(47148,3232),(47149,3233),(47150,3234),(47151,3235),(47152,3236),(47153,3237),(47154,3238),(47155,3239),(47156,3240),(47157,3241),(47158,3242),(47159,3243),(47160,3244),(47161,3257),(47162,3258),(47163,3259),(47164,3260),(47165,3261),(47166,3262),(47167,3263),(47168,3264),(47169,3265),(47170,3266),(47171,3267),(47172,3268),(47173,3269),(47174,3270),(47175,3271),(47176,3272),(47177,3273),(47178,3274),(47179,3275),(47180,3276),(47181,3277),(47182,3293),(47183,3294),(47184,3295),(47185,3296),(47186,3297),(47187,3298),(47188,3299),(47189,3300),(47190,3301),(47191,3302),(47192,3303),(47193,3304),(47194,3305),(47195,3306),(47196,3307),(47197,3308),(47198,3309),(47199,3310),(47200,3311),(47201,3312),(47202,3313),(47203,3314),(47204,3315),(47205,3316),(47206,3317),(47207,3318),(47208,3319),(47209,3320),(47210,3321),(47211,3322),(47212,3323),(47213,3324),(47214,3325),(47215,3326),(47216,3327),(47217,3328),(47218,3329),(47219,3330),(47220,3331),(47221,3332),(47222,3333),(47223,3334),(47224,3335),(47225,3336),(47226,3337),(47227,3338),(47228,3339),(47229,3340),(47230,3341),(47231,3342),(47232,3343),(47233,3344),(47234,3345),(47235,3346),(47236,3347),(47237,3348),(47238,3349),(47239,3350),(47240,3351),(47241,3352),(47242,3353),(47243,3354),(47244,3355),(47245,3356),(47246,3357),(47247,3358),(47248,3359),(47249,3360),(47250,3361),(47251,3362),(47252,3363),(47253,3364),(47254,3365),(47255,3366),(47256,3367),(47257,3368),(47258,3369),(47259,3370),(47260,3371),(47261,3372),(47262,3373),(47263,3374),(47264,3375),(47265,3376),(47266,3377),(47267,3378),(47268,3379),(47269,3380),(47270,3388),(47271,3391),(47272,3402),(47273,3403),(47274,3407),(47275,3459),(47276,3460),(47277,3461),(47278,3462),(47279,3463),(47280,3464),(47281,3465),(47282,3466),(47283,3467),(47284,3468),(47285,3469),(47286,3470),(47287,3471),(47288,3472),(47289,3473),(47290,3474),(47291,3475),(47292,3476),(47293,3477),(47294,3478),(47295,3479),(47296,3480),(47297,3488),(47298,3490),(47299,3491),(47300,3492),(47301,3493),(47302,3494),(47303,3495),(47304,3496),(47305,3497),(47306,3498),(47307,3499),(47308,3500),(47309,3501),(47310,3502),(47311,3503),(47312,3504),(47313,3505),(47314,3506),(47315,3507),(47316,3508),(47317,3509),(47318,3510),(47319,3511),(47320,3512),(47321,3513),(47322,3514),(47323,3515),(47324,3516),(47325,3517),(47326,3518),(47327,3519),(47328,3520),(47329,3521),(47330,3522),(47331,3523),(47332,3524),(47333,3525),(47334,3526),(47335,3527),(47336,3528),(47337,3529),(47338,3530),(47339,3531),(47340,3532),(47341,3533),(47342,3534),(47343,3535),(47344,3536),(47345,3537),(47346,3538),(47347,3539),(47348,3540),(47349,3541),(47350,3542),(47351,3543),(47352,3544),(47353,3545),(47354,3546),(47355,3547),(47356,3548),(47357,3549),(47358,3550),(47359,3551),(47360,3552),(47361,3553),(47362,3554),(47363,3555),(47364,3556),(47365,3557),(47366,3558),(47367,3559),(47368,3560),(47369,3561),(47370,3562),(47371,3563),(47372,3564),(47373,3565),(47374,3566),(47375,3567),(47376,3568),(47377,3569),(47378,3570),(47379,3571),(47380,3572),(47381,3573),(47382,3574),(47383,3575),(47384,3576),(47385,3577),(47386,3578),(47387,3579),(47388,3580),(47389,3581),(47390,3582),(47391,3583),(47392,3584),(47393,3585),(47394,3586),(47395,3587),(47396,3588),(47397,3589),(47398,3590),(47399,3591),(47400,3593),(47401,3594),(47402,3610),(47403,3611),(47404,3612),(47405,3613),(47406,3614),(47407,3615),(47408,3616),(47409,3617),(47410,3618),(47411,3619),(47412,3620),(47413,3621),(47414,3622),(47415,3624),(47416,3625),(47417,3626),(47418,3627),(47419,3628),(47420,3629),(47421,3630),(47422,3631),(47423,3632),(47424,3633),(47425,3634),(47426,3635),(47427,3636),(47428,3637),(47429,3638),(47430,3639),(47431,3640),(47432,3641),(47433,3642),(47434,3643),(47435,3644),(47436,3645),(47437,3646),(47438,3647),(47439,3648),(47440,3649),(47441,3650),(47442,3651),(47443,3652),(47444,3653),(47445,3654),(47446,3655),(47447,3656),(47448,3657),(47449,3658),(47450,3659),(47451,3660),(47452,3661),(47453,3662),(47454,3663),(47455,3664),(47456,3665),(47457,3666),(47458,3667),(47459,3668),(47460,3669),(47461,3670),(47462,3671),(47463,3672),(47464,3673),(47465,3674),(47466,3675),(47467,3676),(47468,3677),(47469,3678),(47470,3679),(47471,3680),(47472,3681),(47473,3682),(47474,3683),(47475,3684),(47476,3685),(47477,3701),(47478,3711),(47479,3712),(47480,3713),(47481,3714),(47482,2921),(47483,2922),(47484,2942),(47485,2944),(47486,3153),(47487,3675),(47488,3676),(47489,3677),(47490,3678),(47491,3679),(47492,3680),(47493,3681),(47494,3682),(47495,3683),(47496,1953),(47497,1954),(47498,1955),(47499,1956),(47500,1957),(47501,2003),(47502,2004),(47503,2009),(47504,2010),(47505,2011),(47506,2017),(47507,2043),(47508,2047),(47509,2048),(47510,2049),(47511,2050),(47512,2051),(47513,2052),(47514,2054),(47515,2056),(47516,2057),(47517,2058),(47518,2059),(47519,2060),(47520,2061),(47521,2064),(47522,2067),(47523,2069),(47524,2071),(47525,2073),(47526,2075),(47527,2077),(47528,2078),(47529,2080),(47530,2083),(47531,2084),(47532,2086),(47533,2087),(47534,2088),(47535,2089),(47536,2092),(47537,2105),(47538,2106),(47539,2107),(47540,2108),(47541,2109),(47542,2110),(47543,2111),(47544,2112),(47545,2120),(47546,2121),(47547,2166),(47548,2167),(47549,2170),(47550,2171),(47551,2172),(47552,2173),(47553,2174),(47554,2175),(47555,2227),(47556,2228),(47557,2229),(47558,2230),(47559,2231),(47560,2253),(47561,2254),(47562,2285),(47563,2287),(47564,2292),(47565,2432),(47566,2433),(47567,2434),(47568,2436),(47569,2437),(47570,2438),(47571,2439),(47572,2443),(47573,2444),(47574,2445),(47575,2446),(47576,2447),(47577,2448),(47578,2457),(47579,2475),(47580,2476),(47581,2492),(47582,2493),(47583,2532),(47584,2533),(47585,2534),(47586,2535),(47587,2555),(47588,2560),(47589,2561),(47590,2562),(47591,2563),(47592,2564),(47593,2565),(47594,2566),(47595,2569),(47596,2570),(47597,2571),(47598,2572),(47599,2582),(47600,2583),(47601,2585),(47602,2588),(47603,2615),(47604,3737),(47605,3832),(47606,4021),(47607,4022),(47608,4023),(47609,4024),(47610,4025),(47611,4026),(47612,4027),(47613,4028),(47614,4029),(47615,4030),(47616,4031),(47617,4032),(47618,4033),(47619,4032),(47620,4033),(47621,3731),(47622,3735),(47623,3736),(47624,3744),(47625,3753),(47626,3755),(47627,3760),(47628,4022),(47629,4024),(47630,4026),(47631,4029),(47632,4031),(47633,4033),(47634,4183),(47635,4184),(47636,4189),(47637,3719),(47638,3724),(47639,4138),(47640,4139),(47641,4409),(47642,4413),(47643,3940),(47644,3962),(47645,3992),(47646,3999),(47647,4006),(47648,4008),(47649,4038),(47650,4044),(47651,4092),(47652,4093),(47653,4095),(47654,4125),(47655,4126),(47656,4178),(47657,4246),(47658,4271),(47659,4272),(47660,4273),(47661,4284),(47662,4285),(47663,4320),(47664,4321),(47665,4322),(47666,4323),(47667,4324),(47668,4360),(47669,4457),(47670,3889),(47671,3908),(47672,4094),(47673,4162),(47674,4271),(47675,4272),(47676,4341),(47677,4416),(47678,3971),(47679,3990),(47680,3991),(47681,4000),(47682,4001),(47683,4004),(47684,4005),(47685,4045),(47686,4046),(47687,4047),(47688,4048),(47689,4050),(47690,4051),(47691,4097),(47692,4100),(47693,4101),(47694,4103),(47695,4104),(47696,4105),(47697,4106),(47698,4107),(47699,4109),(47700,4110),(47701,4111),(47702,4112),(47703,4113),(47704,4114),(47705,4115),(47706,4116),(47707,4117),(47708,4144),(47709,4160),(47710,4163),(47711,4166),(47712,4176),(47713,4221),(47714,4284),(47715,4285),(47716,4286),(47717,4361),(47718,4368),(47719,4369),(47720,4372),(47721,4375),(47722,4376),(47723,4377),(47724,4380),(47725,4385),(47726,4386),(47727,4387),(47728,4388),(47729,4389),(47730,4423),(47731,4429),(47732,4440),(47733,3869),(47734,3907),(47735,4096),(47736,4162),(47737,3723),(47738,3732),(47739,3739),(47740,3746),(47741,3835),(47742,3896),(47743,3897),(47744,3898),(47745,3899),(47746,4362),(47747,4363),(47748,4365),(47749,4463),(47750,4464),(47751,4465),(47752,4466),(47753,4471),(47754,4472),(47755,4477),(47756,4478),(47757,3835),(47758,3896),(47759,3897),(47760,3898),(47761,3899),(47762,4240),(47763,4362),(47764,4363),(47765,4365),(47766,4463),(47767,4464),(47768,4465),(47769,4466),(47770,4471),(47771,4472),(47772,4477),(47773,4478),(47774,3843),(47775,3844),(47776,3845),(47777,3879),(47778,3888),(47779,3978),(47780,4049),(47781,4098),(47782,4099),(47783,4141),(47784,4147),(47785,4329),(47786,4357),(47787,4422),(47788,4428),(47789,1629),(47790,1636),(47791,1637),(47792,1638),(47793,1639),(47794,1643),(47795,1644),(47796,1645),(47797,1646),(47798,1647),(47799,1648),(47800,1649),(47801,3979),(47802,3980),(47803,4141),(47804,4147),(47805,4153),(47806,4154),(47807,4168),(47808,4248),(47809,4337),(47810,4338),(47811,4339),(47812,4359),(47813,3835),(47814,3843),(47815,3844),(47816,3845),(47817,3888),(47818,4098),(47819,4099),(47820,4357),(47821,4428),(47822,3772),(47823,3773),(47824,3775),(47825,3860),(47826,3868),(47827,3891),(47828,3900),(47829,3901),(47830,3902),(47831,3906),(47832,3917),(47833,3939),(47834,3940),(47835,4042),(47836,4061),(47837,4071),(47838,4072),(47839,4073),(47840,4074),(47841,4096),(47842,4150),(47843,4157),(47844,4158),(47845,4159),(47846,4164),(47847,4165),(47848,4199),(47849,4200),(47850,4201),(47851,4242),(47852,4247),(47853,4261),(47854,4262),(47855,4263),(47856,4268),(47857,4341),(47858,4368),(47859,4369),(47860,4370),(47861,4371),(47862,4372),(47863,4373),(47864,4374),(47865,4375),(47866,4384),(47867,4387),(47868,4389),(47869,4416),(47870,4479),(47871,3772),(47872,3773),(47873,3775),(47874,3860),(47875,3868),(47876,3891),(47877,3900),(47878,3901),(47879,3902),(47880,3906),(47881,3917),(47882,3939),(47883,3940),(47884,4042),(47885,4061),(47886,4071),(47887,4072),(47888,4073),(47889,4074),(47890,4096),(47891,4150),(47892,4157),(47893,4158),(47894,4159),(47895,4164),(47896,4165),(47897,4199),(47898,4200),(47899,4201),(47900,4242),(47901,4247),(47902,4261),(47903,4262),(47904,4263),(47905,4268),(47906,4341),(47907,4368),(47908,4369),(47909,4370),(47910,4371),(47911,4372),(47912,4373),(47913,4374),(47914,4375),(47915,4384),(47916,4387),(47917,4389),(47918,4416),(47919,4479),(47920,3772),(47921,3773),(47922,3775),(47923,3860),(47924,3868),(47925,3891),(47926,3900),(47927,3901),(47928,3902),(47929,3906),(47930,3917),(47931,3939),(47932,3940),(47933,4042),(47934,4061),(47935,4071),(47936,4072),(47937,4073),(47938,4074),(47939,4096),(47940,4150),(47941,4157),(47942,4158),(47943,4159),(47944,4164),(47945,4165),(47946,4199),(47947,4200),(47948,4201),(47949,4242),(47950,4247),(47951,4261),(47952,4262),(47953,4263),(47954,4268),(47955,4341),(47956,4368),(47957,4369),(47958,4370),(47959,4371),(47960,4372),(47961,4373),(47962,4374),(47963,4375),(47964,4384),(47965,4387),(47966,4389),(47967,4479),(47968,3861),(47969,4170),(47970,4171),(47971,4174),(47972,4175),(47973,4203),(47974,4340),(47975,4434),(47976,4435),(47977,4416),(47978,3772),(47979,3773),(47980,3775),(47981,3860),(47982,3868),(47983,3891),(47984,3900),(47985,3901),(47986,3902),(47987,3906),(47988,3917),(47989,3939),(47990,3940),(47991,4042),(47992,4061),(47993,4071),(47994,4072),(47995,4073),(47996,4074),(47997,4096),(47998,4150),(47999,4157),(48000,4158),(48001,4159),(48002,4164),(48003,4165),(48004,4199),(48005,4200),(48006,4201),(48007,4242),(48008,4247),(48009,4261),(48010,4262),(48011,4263),(48012,4268),(48013,4341),(48014,4368),(48015,4369),(48016,4370),(48017,4371),(48018,4372),(48019,4373),(48020,4374),(48021,4375),(48022,4384),(48023,4387),(48024,4389),(48025,4416),(48026,4479),(48027,3861),(48028,4170),(48029,4171),(48030,4174),(48031,4175),(48032,4203),(48033,4340),(48034,4434),(48035,4435),(48036,2181),(48037,2182),(48038,2183),(48039,2184),(48040,2185),(48041,2186),(48042,2203),(48043,2204),(48044,2205),(48045,2206),(48046,2207),(48047,2212),(48048,2213),(48049,2223),(48050,2224),(48051,2225),(48052,2252),(48053,2255),(48054,2263),(48055,2264),(48056,2272),(48057,2273),(48058,2274),(48059,2277),(48060,2278),(48061,2279),(48062,2280),(48063,2281),(48064,2282),(48065,2283),(48066,2284),(48067,2286),(48068,2288),(48069,2294),(48070,2297),(48071,2298),(48072,2300),(48073,2301),(48074,2429),(48075,2450),(48076,2451),(48077,2452),(48078,2453),(48079,2465),(48080,2466),(48081,2467),(48082,2468),(48083,2469),(48084,2470),(48085,2471),(48086,2474),(48087,2481),(48088,2482),(48089,2483),(48090,2484),(48091,2485),(48092,2487),(48093,2488),(48094,2489),(48095,2490),(48096,2491),(48097,2494),(48098,2495),(48099,2496),(48100,2497),(48101,2501),(48102,2502),(48103,2513),(48104,2514),(48105,2529),(48106,2536),(48107,2543),(48108,2544),(48109,2547),(48110,2548),(48111,2549),(48112,2550),(48113,2551),(48114,2552),(48115,2553),(48116,2554),(48117,2556),(48118,2557),(48119,2558),(48120,2616),(48121,2617),(48122,2618),(48123,2619),(48124,2620),(48125,2621),(48126,1958),(48127,2005),(48128,2006),(48129,2007),(48130,2012),(48131,2015),(48132,2016),(48133,2018),(48134,2019),(48135,2020),(48136,2024),(48137,2025),(48138,2033),(48139,2036),(48140,2038),(48141,2053),(48142,2055),(48143,2062),(48144,2063),(48145,2065),(48146,2066),(48147,2068),(48148,2070),(48149,2072),(48150,2074),(48151,2076),(48152,2079),(48153,2081),(48154,2082),(48155,2085),(48156,2090),(48157,2091),(48158,2093),(48159,2094),(48160,2095),(48161,2096),(48162,2097),(48163,2098),(48164,2099),(48165,2100),(48166,2101),(48167,2102),(48168,2103),(48169,2104),(48170,2116),(48171,2117),(48172,2118),(48173,2119),(48174,2158),(48175,2159),(48176,2160),(48177,2161),(48178,2164),(48179,2165),(48180,2168),(48181,2169),(48182,2178),(48183,2179),(48184,2180),(48185,281),(48186,284),(48187,286),(48188,287),(48189,289),(48190,291),(48191,292),(48192,294),(48193,296),(48194,297),(48195,301),(48196,304),(48197,305),(48198,307),(48199,316),(48200,332),(48201,333),(48202,337),(48203,527),(48204,528),(48205,529),(48206,557),(48207,588),(48208,590),(48209,592),(48210,611),(48211,613),(48212,617),(48213,618),(48214,619),(48215,624),(48216,625),(48217,636),(48218,637),(48219,639),(48220,646),(48221,648),(48222,659),(48223,660),(48224,670),(48225,690),(48226,691),(48227,693),(48228,695),(48229,697),(48230,698),(48231,700),(48232,702),(48233,706),(48234,728),(48235,778),(48236,779),(48237,834),(48238,835),(48239,836),(48240,837),(48241,838),(48242,839),(48243,840),(48244,906),(48245,997),(48246,1001),(48247,1037),(48248,1038),(48249,1064),(48250,1066),(48251,1067),(48252,1068),(48253,1069),(48254,1070),(48255,1071),(48256,1072),(48257,1073),(48258,1074),(48259,1075),(48260,1133),(48261,1165),(48262,1813),(48263,1815),(48264,1816),(48265,1818),(48266,1820),(48267,1821),(48268,1822),(48269,1827),(48270,2003),(48271,2004),(48272,2005),(48273,2006),(48274,2007),(48275,2008),(48276,2009),(48277,2010),(48278,2011),(48279,2012),(48280,2014),(48281,2016),(48282,2017),(48283,2020),(48284,2024),(48285,2033),(48286,2038),(48287,2043),(48288,2067),(48289,2105),(48290,2116),(48291,2117),(48292,2158),(48293,2160),(48294,2161),(48295,2164),(48296,2170),(48297,2171),(48298,2172),(48299,2173),(48300,2176),(48301,2181),(48302,2184),(48303,2185),(48304,2186),(48305,2199),(48306,2203),(48307,2207),(48308,2227),(48309,2247),(48310,2249),(48311,2250),(48312,2277),(48313,2278),(48314,2279),(48315,2280),(48316,2297),(48317,2429),(48318,2430),(48319,2431),(48320,2440),(48321,2443),(48322,2444),(48323,2457),(48324,2474),(48325,2481),(48326,2482),(48327,2483),(48328,2485),(48329,2506),(48330,2517),(48331,2518),(48332,2520),(48333,2521),(48334,2523),(48335,2524),(48336,2525),(48337,2526),(48338,2528),(48339,2529),(48340,2530),(48341,2532),(48342,2533),(48343,2534),(48344,2535),(48345,2536),(48346,2539),(48347,2544),(48348,2545),(48349,2546),(48350,2547),(48351,2548),(48352,2549),(48353,2550),(48354,2551),(48355,2553),(48356,2554),(48357,2560),(48358,2573),(48359,2574),(48360,2575),(48361,2576),(48362,2182),(48363,2183),(48364,2211),(48365,2212),(48366,2213),(48367,2223),(48368,2224),(48369,2225),(48370,2228),(48371,2229),(48372,2231),(48373,2253),(48374,2254),(48375,2255),(48376,2263),(48377,2264),(48378,2272),(48379,2273),(48380,2274),(48381,2281),(48382,2282),(48383,2283),(48384,2284),(48385,2285),(48386,2286),(48387,2287),(48388,2288),(48389,2292),(48390,2294),(48391,2295),(48392,2298),(48393,2432),(48394,2433),(48395,2434),(48396,2436),(48397,2437),(48398,2438),(48399,2439),(48400,2445),(48401,2446),(48402,2447),(48403,2448),(48404,2450),(48405,2451),(48406,2453),(48407,2465),(48408,2466),(48409,2467),(48410,2468),(48411,2469),(48412,2470),(48413,2471),(48414,2480),(48415,2484),(48416,2486),(48417,2487),(48418,2488),(48419,2492),(48420,2493),(48421,2496),(48422,2498),(48423,2499),(48424,2500),(48425,2501),(48426,2502),(48427,2513),(48428,2514),(48429,2519),(48430,2522),(48431,2527),(48432,2552),(48433,2556),(48434,2557),(48435,2558),(48436,2561),(48437,2562),(48438,2563),(48439,2564),(48440,2565),(48441,2566),(48442,2567),(48443,2568),(48444,2569),(48445,2570),(48446,2571),(48447,2572),(48448,2582),(48449,2583),(48450,2584),(48451,2585),(48452,2586),(48453,2587),(48454,2588),(48455,2615),(48456,2616),(48457,2617),(48458,2618),(48459,2619),(48460,2620),(48461,5757),(48462,5758),(48463,5759),(48464,298),(48465,299),(48466,300),(48467,302),(48468,303),(48469,306),(48470,341),(48471,342),(48472,343),(48473,374),(48474,375),(48475,376),(48476,530),(48477,531),(48478,532),(48479,560),(48480,587),(48481,589),(48482,591),(48483,632),(48484,652),(48485,682),(48486,683),(48487,684),(48488,685),(48489,686),(48490,687),(48491,688),(48492,689),(48493,694),(48494,696),(48495,705),(48496,711),(48497,712),(48498,715),(48499,716),(48500,717),(48501,735),(48502,736),(48503,742),(48504,998),(48505,999),(48506,1000),(48507,1036),(48508,1162),(48509,1163),(48510,1164),(48511,1956),(48512,1957),(48513,1958),(48514,2015),(48515,2018),(48516,2019),(48517,2047),(48518,2048),(48519,2049),(48520,2050),(48521,2051),(48522,2052),(48523,2053),(48524,2054),(48525,2055),(48526,2056),(48527,2057),(48528,2058),(48529,2060),(48530,2061),(48531,2062),(48532,2063),(48533,2065),(48534,2066),(48535,2068),(48536,2069),(48537,2070),(48538,2071),(48539,2072),(48540,2073),(48541,2074),(48542,2075),(48543,2076),(48544,2077),(48545,2078),(48546,2079),(48547,2080),(48548,2081),(48549,2082),(48550,2083),(48551,2084),(48552,2085),(48553,2090),(48554,2091),(48555,2092),(48556,2093),(48557,2097),(48558,2098),(48559,2099),(48560,2100),(48561,2101),(48562,2102),(48563,2118),(48564,2119),(48565,2120),(48566,2121),(48567,2155),(48568,2156),(48569,2157),(48570,2162),(48571,2165),(48572,2166),(48573,2167),(48574,2168),(48575,2169),(48576,2175),(48577,2178),(48578,2179),(48579,2180),(48580,1162),(48581,1163),(48582,1164),(48583,1165),(48584,1818),(48585,1953),(48586,1954),(48587,1955),(48588,1956),(48589,2013),(48590,2159),(48591,2164),(48592,2176),(48593,2184),(48594,2185),(48595,2203),(48596,2206),(48597,2212),(48598,2227),(48599,2228),(48600,2229),(48601,2230),(48602,2248),(48603,2271),(48604,2278),(48605,2280),(48606,2300),(48607,2429),(48608,2430),(48609,2431),(48610,2440),(48611,2441),(48612,2472),(48613,2473),(48614,2474),(48615,2475),(48616,2476),(48617,2483),(48618,2489),(48619,2490),(48620,2491),(48621,2494),(48622,2495),(48623,2496),(48624,2497),(48625,2506),(48626,2508),(48627,2511),(48628,2517),(48629,2518),(48630,2519),(48631,2520),(48632,2523),(48633,2524),(48634,2525),(48635,2526),(48636,2528),(48637,2532),(48638,2533),(48639,2534),(48640,2536),(48641,2543),(48642,2544),(48643,2545),(48644,2546),(48645,2548),(48646,2551),(48647,2553),(48648,2574),(48649,2575),(48650,2576),(48651,2583),(48652,5757),(48653,5758),(48654,5759),(48655,1816),(48656,1958),(48657,2014),(48658,2096),(48659,2161),(48660,2163),(48661,2174),(48662,2175),(48663,2183),(48664,2186),(48665,2205),(48666,2213),(48667,2223),(48668,2224),(48669,2225),(48670,2231),(48671,2247),(48672,2270),(48673,2277),(48674,2279),(48675,2282),(48676,2295),(48677,2298),(48678,2301),(48679,2434),(48680,2439),(48681,2448),(48682,2487),(48683,2488),(48684,2492),(48685,2493),(48686,2507),(48687,2509),(48688,2512),(48689,2514),(48690,2522),(48691,2527),(48692,2530),(48693,2547),(48694,2549),(48695,2550),(48696,2554),(48697,2585),(48698,2008),(48699,2182),(48700,2204),(48701,2207),(48702,2249),(48703,2250),(48704,2446),(48705,2587),(48706,1957),(48707,2486),(48708,2043),(48709,2199),(48710,2203),(48711,2586),(48712,2587),(48713,2181),(48714,2182),(48715,2183),(48716,2184),(48717,2185),(48718,2186),(48719,2199),(48720,2203),(48721,2204),(48722,2205),(48723,2206),(48724,2207),(48725,2211),(48726,2212),(48727,2213),(48728,2223),(48729,2224),(48730,2225),(48731,2226),(48732,2227),(48733,2228),(48734,2229),(48735,2230),(48736,2231),(48737,2247),(48738,2248),(48739,2249),(48740,2250),(48741,2252),(48742,2253),(48743,2254),(48744,2255),(48745,2263),(48746,2264),(48747,2270),(48748,2271),(48749,2272),(48750,2273),(48751,2274),(48752,2277),(48753,2278),(48754,2279),(48755,2280),(48756,2281),(48757,2282),(48758,2283),(48759,2284),(48760,2285),(48761,2286),(48762,2287),(48763,2288),(48764,2292),(48765,2294),(48766,2295),(48767,2296),(48768,2297),(48769,2298),(48770,2300),(48771,2301),(48772,2429),(48773,2430),(48774,2431),(48775,2432),(48776,2433),(48777,2434),(48778,2436),(48779,2437),(48780,2438),(48781,2439),(48782,2440),(48783,2441),(48784,2442),(48785,2443),(48786,2444),(48787,2445),(48788,2446),(48789,2447),(48790,2448),(48791,2450),(48792,2451),(48793,2452),(48794,2453),(48795,2457),(48796,2465),(48797,2466),(48798,2467),(48799,2468),(48800,2469),(48801,2470),(48802,2471),(48803,2472),(48804,2473),(48805,2474),(48806,2475),(48807,2476),(48808,2477),(48809,2478),(48810,2479),(48811,2480),(48812,2481),(48813,2482),(48814,2483),(48815,2484),(48816,2485),(48817,2486),(48818,2487),(48819,2488),(48820,2489),(48821,2490),(48822,2491),(48823,2492),(48824,2493),(48825,2494),(48826,2495),(48827,2496),(48828,2497),(48829,2498),(48830,2499),(48831,2500),(48832,2501),(48833,2502),(48834,2506),(48835,2507),(48836,2508),(48837,2509),(48838,2510),(48839,2511),(48840,2512),(48841,2513),(48842,2514),(48843,2517),(48844,2518),(48845,2519),(48846,2520),(48847,2521),(48848,2522),(48849,2523),(48850,2524),(48851,2525),(48852,2526),(48853,2527),(48854,2528),(48855,2529),(48856,2530),(48857,2532),(48858,2533),(48859,2534),(48860,2535),(48861,2536),(48862,2539),(48863,2543),(48864,2544),(48865,2545),(48866,2546),(48867,2547),(48868,2548),(48869,2549),(48870,2550),(48871,2551),(48872,2552),(48873,2553),(48874,2554),(48875,2555),(48876,2556),(48877,2557),(48878,2558),(48879,2560),(48880,2561),(48881,2562),(48882,2563),(48883,2564),(48884,2565),(48885,2566),(48886,2567),(48887,2568),(48888,2569),(48889,2570),(48890,2571),(48891,2572),(48892,2573),(48893,2574),(48894,2575),(48895,2576),(48896,2582),(48897,2583),(48898,2584),(48899,2585),(48900,2586),(48901,2587),(48902,2588),(48903,2615),(48904,2616),(48905,2617),(48906,2618),(48907,2619),(48908,2620),(48909,2621),(48910,5757),(48911,5758),(48912,5759),(48913,281),(48914,284),(48915,286),(48916,287),(48917,289),(48918,291),(48919,292),(48920,294),(48921,296),(48922,297),(48923,298),(48924,299),(48925,300),(48926,301),(48927,302),(48928,303),(48929,304),(48930,305),(48931,306),(48932,307),(48933,316),(48934,332),(48935,333),(48936,337),(48937,341),(48938,342),(48939,343),(48940,374),(48941,375),(48942,376),(48943,527),(48944,528),(48945,529),(48946,530),(48947,531),(48948,532),(48949,557),(48950,560),(48951,587),(48952,588),(48953,589),(48954,590),(48955,591),(48956,592),(48957,611),(48958,613),(48959,617),(48960,618),(48961,619),(48962,624),(48963,625),(48964,632),(48965,636),(48966,637),(48967,639),(48968,646),(48969,648),(48970,652),(48971,659),(48972,660),(48973,670),(48974,682),(48975,683),(48976,684),(48977,685),(48978,686),(48979,687),(48980,688),(48981,689),(48982,690),(48983,691),(48984,693),(48985,694),(48986,695),(48987,696),(48988,697),(48989,698),(48990,700),(48991,702),(48992,705),(48993,706),(48994,711),(48995,712),(48996,715),(48997,716),(48998,717),(48999,728),(49000,735),(49001,736),(49002,742),(49003,778),(49004,779),(49005,834),(49006,835),(49007,836),(49008,837),(49009,838),(49010,839),(49011,840),(49012,906),(49013,997),(49014,998),(49015,999),(49016,1000),(49017,1001),(49018,1036),(49019,1037),(49020,1038),(49021,1064),(49022,1066),(49023,1067),(49024,1068),(49025,1069),(49026,1070),(49027,1071),(49028,1072),(49029,1073),(49030,1074),(49031,1075),(49032,1133),(49033,1162),(49034,1163),(49035,1164),(49036,1165),(49037,1813),(49038,1815),(49039,1816),(49040,1818),(49041,1820),(49042,1821),(49043,1822),(49044,1827),(49045,1953),(49046,1954),(49047,1955),(49048,1956),(49049,1957),(49050,1958),(49051,2003),(49052,2004),(49053,2005),(49054,2006),(49055,2007),(49056,2008),(49057,2009),(49058,2010),(49059,2011),(49060,2012),(49061,2014),(49062,2015),(49063,2016),(49064,2017),(49065,2018),(49066,2019),(49067,2020),(49068,2024),(49069,2025),(49070,2033),(49071,2036),(49072,2038),(49073,2043),(49074,2047),(49075,2048),(49076,2049),(49077,2050),(49078,2051),(49079,2052),(49080,2053),(49081,2054),(49082,2055),(49083,2056),(49084,2057),(49085,2058),(49086,2059),(49087,2060),(49088,2061),(49089,2062),(49090,2063),(49091,2064),(49092,2065),(49093,2066),(49094,2067),(49095,2068),(49096,2069),(49097,2070),(49098,2071),(49099,2072),(49100,2073),(49101,2074),(49102,2075),(49103,2076),(49104,2077),(49105,2078),(49106,2079),(49107,2080),(49108,2081),(49109,2082),(49110,2083),(49111,2084),(49112,2085),(49113,2086),(49114,2087),(49115,2088),(49116,2089),(49117,2090),(49118,2091),(49119,2092),(49120,2093),(49121,2094),(49122,2095),(49123,2096),(49124,2097),(49125,2098),(49126,2099),(49127,2100),(49128,2101),(49129,2102),(49130,2103),(49131,2104),(49132,2105),(49133,2106),(49134,2107),(49135,2108),(49136,2109),(49137,2110),(49138,2111),(49139,2112),(49140,2116),(49141,2117),(49142,2118),(49143,2119),(49144,2120),(49145,2121),(49146,2155),(49147,2156),(49148,2157),(49149,2158),(49150,2159),(49151,2160),(49152,2161),(49153,2162),(49154,2163),(49155,2164),(49156,2165),(49157,2166),(49158,2167),(49159,2168),(49160,2169),(49161,2170),(49162,2171),(49163,2172),(49164,2173),(49165,2174),(49166,2175),(49167,2176),(49168,2178),(49169,2179),(49170,2180),(49171,716),(49172,717),(49173,2199),(49174,2203),(49175,2281),(49176,2282),(49177,2294),(49178,2295),(49179,2457),(49180,2517),(49181,2518),(49182,2519),(49183,2520),(49184,2547),(49185,2548),(49186,2549),(49187,2550),(49188,2551),(49189,2582),(49190,2583),(49191,2584),(49192,2585),(49193,2586),(49194,2587),(49195,1070),(49196,1958),(49197,2036),(49198,2043),(49199,2086),(49200,2087),(49201,2088),(49202,2092),(49203,2093),(49204,2094),(49205,2095),(49206,2096),(49207,2162),(49208,2204),(49209,2205),(49210,2206),(49211,2212),(49212,2213),(49213,2277),(49214,2278),(49215,2279),(49216,2280),(49217,2300),(49218,2301),(49219,2489),(49220,2490),(49221,2491),(49222,2532),(49223,2533),(49224,2534),(49225,2535),(49226,1816),(49227,1818),(49228,1822),(49229,2013),(49230,4861),(49231,4862),(49232,4863),(49233,4864),(49234,4865),(49235,4866),(49236,4867),(49237,4868),(49238,4869),(49239,4870),(49240,4871),(49241,4872),(49242,4873),(49243,4874),(49244,4875),(49245,4876),(49246,4891),(49247,4892),(49248,4893),(49249,4894),(49250,281),(49251,282),(49252,283),(49253,284),(49254,285),(49255,286),(49256,287),(49257,288),(49258,289),(49259,290),(49260,291),(49261,292),(49262,293),(49263,294),(49264,295),(49265,296),(49266,297),(49267,298),(49268,299),(49269,300),(49270,301),(49271,302),(49272,303),(49273,304),(49274,305),(49275,306),(49276,307),(49277,308),(49278,309),(49279,310),(49280,311),(49281,312),(49282,313),(49283,314),(49284,315),(49285,316),(49286,317),(49287,318),(49288,319),(49289,320),(49290,321),(49291,322),(49292,323),(49293,324),(49294,325),(49295,326),(49296,327),(49297,328),(49298,329),(49299,330),(49300,331),(49301,332),(49302,333),(49303,334),(49304,335),(49305,336),(49306,337),(49307,338),(49308,339),(49309,340),(49310,341),(49311,342),(49312,343),(49313,344),(49314,345),(49315,346),(49316,347),(49317,903),(49318,904),(49319,905),(49320,907),(49321,1813),(49322,1814),(49323,1815),(49324,1816),(49325,1817),(49326,1818),(49327,1819),(49328,1820),(49329,1821),(49330,1822),(49331,1823),(49332,1824),(49333,1825),(49334,1826),(49335,1827),(49336,1828),(49337,1829),(49338,1830),(49339,1831),(49340,1832),(49341,1833),(49342,1834),(49343,1835),(49344,1950),(49345,1951),(49346,1952),(49347,1953),(49348,1954),(49349,1955),(49350,1956),(49351,1957),(49352,1958),(49353,1965),(49354,1966),(49355,1967),(49356,1968),(49357,1969),(49358,1970),(49359,1971),(49360,2154),(49361,2158),(49362,2159),(49363,2160),(49364,2161),(49365,2162),(49366,2170),(49367,2171),(49368,2172),(49369,2173),(49370,2174),(49371,2175),(49372,2177),(49373,2181),(49374,2182),(49375,2183),(49376,2184),(49377,2185),(49378,2186),(49379,2199),(49380,2211),(49381,2212),(49382,2213),(49383,2223),(49384,2224),(49385,2225),(49386,2226),(49387,2227),(49388,2228),(49389,2229),(49390,2230),(49391,2231),(49392,2281),(49393,2282),(49394,2292),(49395,2294),(49396,2295),(49397,2297),(49398,2298),(49399,2432),(49400,2433),(49401,2434),(49402,2436),(49403,2437),(49404,2438),(49405,2439),(49406,2443),(49407,2444),(49408,2445),(49409,2446),(49410,2447),(49411,2448),(49412,2475),(49413,2476),(49414,2477),(49415,2478),(49416,2479),(49417,2480),(49418,2481),(49419,2482),(49420,2483),(49421,2484),(49422,2485),(49423,2486),(49424,2487),(49425,2488),(49426,2492),(49427,2493),(49428,2494),(49429,2495),(49430,2496),(49431,2497),(49432,2498),(49433,2499),(49434,2500),(49435,2513),(49436,2514),(49437,2529),(49438,2530),(49439,2539),(49440,2553),(49441,2554),(49442,2582),(49443,2583),(49444,2584),(49445,2585),(49446,2586),(49447,2587),(49448,4613),(49449,4614),(49450,4857),(49451,4858),(49452,4859),(49453,4860),(49454,906),(49455,908),(49456,1004),(49457,1012),(49458,1019),(49459,1037),(49460,1092),(49461,1119),(49462,1162),(49463,1163),(49464,1164),(49465,1165),(49466,2163),(49467,2164),(49468,2176),(49469,2203),(49470,2204),(49471,2205),(49472,2206),(49473,2207),(49474,2247),(49475,2248),(49476,2249),(49477,2250),(49478,2270),(49479,2271),(49480,2277),(49481,2278),(49482,2279),(49483,2280),(49484,2296),(49485,2299),(49486,2300),(49487,2301),(49488,2429),(49489,2430),(49490,2431),(49491,2440),(49492,2441),(49493,2442),(49494,2457),(49495,2472),(49496,2473),(49497,2474),(49498,2489),(49499,2490),(49500,2491),(49501,2506),(49502,2507),(49503,2508),(49504,2509),(49505,2510),(49506,2511),(49507,2512),(49508,2521),(49509,2522),(49510,2523),(49511,2524),(49512,2525),(49513,2526),(49514,2527),(49515,2528),(49516,2531),(49517,2532),(49518,2533),(49519,2534),(49520,2535),(49521,2536),(49522,2540),(49523,2541),(49524,2542),(49525,2543),(49526,2544),(49527,2545),(49528,2546),(49529,2547),(49530,2548),(49531,2549),(49532,2550),(49533,2551),(49534,2573),(49535,2574),(49536,2575),(49537,2576),(49538,5757),(49539,5758),(49540,5759),(49541,681),(49542,682),(49543,683),(49544,684),(49545,685),(49546,686),(49547,687),(49548,688),(49549,689),(49550,690),(49551,691),(49552,692),(49553,693),(49554,694),(49555,695),(49556,696),(49557,697),(49558,698),(49559,699),(49560,700),(49561,701),(49562,702),(49563,703),(49564,704),(49565,705),(49566,706),(49567,707),(49568,708),(49569,709),(49570,710),(49571,711),(49572,712),(49573,713),(49574,714),(49575,715),(49576,716),(49577,717),(49578,718),(49579,719),(49580,720),(49581,721),(49582,722),(49583,723),(49584,724),(49585,725),(49586,726),(49587,727),(49588,728),(49589,729),(49590,730),(49591,731),(49592,732),(49593,733),(49594,734),(49595,735),(49596,736),(49597,737),(49598,738),(49599,739),(49600,740),(49601,741),(49602,742),(49603,743),(49604,744),(49605,745),(49606,746),(49607,747),(49608,748),(49609,749),(49610,996),(49611,997),(49612,998),(49613,999),(49614,1000),(49615,1001),(49616,1002),(49617,1003),(49618,1005),(49619,1034),(49620,1035),(49621,1036),(49622,1038),(49623,1133),(49624,1972),(49625,1973),(49626,1974),(49627,1975),(49628,1976),(49629,1977),(49630,1978),(49631,1979),(49632,1980),(49633,1981),(49634,1982),(49635,1983),(49636,1984),(49637,1985),(49638,1986),(49639,1987),(49640,1988),(49641,1989),(49642,1990),(49643,1991),(49644,2003),(49645,2004),(49646,2005),(49647,2006),(49648,2007),(49649,2008),(49650,2009),(49651,2010),(49652,2011),(49653,2012),(49654,2013),(49655,2014),(49656,2015),(49657,2016),(49658,2017),(49659,2018),(49660,2019),(49661,2020),(49662,2021),(49663,2022),(49664,2023),(49665,2024),(49666,2025),(49667,2033),(49668,2035),(49669,2036),(49670,2037),(49671,2038),(49672,2041),(49673,2043),(49674,2047),(49675,2048),(49676,2049),(49677,2050),(49678,2051),(49679,2052),(49680,2053),(49681,2054),(49682,2055),(49683,2056),(49684,2057),(49685,2058),(49686,2059),(49687,2060),(49688,2061),(49689,2062),(49690,2063),(49691,2064),(49692,2065),(49693,2066),(49694,2067),(49695,2068),(49696,2069),(49697,2070),(49698,2071),(49699,2072),(49700,2073),(49701,2074),(49702,2075),(49703,2076),(49704,2077),(49705,2078),(49706,2079),(49707,2080),(49708,2081),(49709,2082),(49710,2083),(49711,2084),(49712,2085),(49713,2086),(49714,2087),(49715,2088),(49716,2089),(49717,2090),(49718,2091),(49719,2092),(49720,2093),(49721,2094),(49722,2095),(49723,2096),(49724,2097),(49725,2098),(49726,2099),(49727,2100),(49728,2101),(49729,2102),(49730,2103),(49731,2104),(49732,2105),(49733,2106),(49734,2107),(49735,2108),(49736,2109),(49737,2110),(49738,2111),(49739,2112),(49740,2113),(49741,2114),(49742,2115),(49743,2116),(49744,2117),(49745,2118),(49746,2119),(49747,2120),(49748,2121),(49749,2155),(49750,2156),(49751,2157),(49752,2165),(49753,2166),(49754,2167),(49755,2168),(49756,2169),(49757,2178),(49758,2179),(49759,2180),(49760,2221),(49761,2222),(49762,2252),(49763,2253),(49764,2254),(49765,2255),(49766,2263),(49767,2264),(49768,2272),(49769,2273),(49770,2274),(49771,2283),(49772,2284),(49773,2285),(49774,2286),(49775,2287),(49776,2288),(49777,2450),(49778,2451),(49779,2452),(49780,2453),(49781,2465),(49782,2466),(49783,2467),(49784,2468),(49785,2469),(49786,2470),(49787,2471),(49788,2501),(49789,2502),(49790,2552),(49791,2555),(49792,2556),(49793,2557),(49794,2558),(49795,2560),(49796,2561),(49797,2562),(49798,2563),(49799,2564),(49800,2565),(49801,2566),(49802,2567),(49803,2568),(49804,2569),(49805,2570),(49806,2571),(49807,2572),(49808,2588),(49809,2615),(49810,2616),(49811,2617),(49812,2618),(49813,2619),(49814,2620),(49815,2621),(49816,348),(49817,349),(49818,350),(49819,351),(49820,352),(49821,353),(49822,354),(49823,355),(49824,356),(49825,357),(49826,358),(49827,359),(49828,360),(49829,361),(49830,370),(49831,371),(49832,372),(49833,373),(49834,374),(49835,375),(49836,376),(49837,377),(49838,378),(49839,379),(49840,380),(49841,381),(49842,382),(49843,383),(49844,384),(49845,385),(49846,386),(49847,387),(49848,388),(49849,389),(49850,390),(49851,391),(49852,392),(49853,393),(49854,394),(49855,395),(49856,396),(49857,397),(49858,533),(49859,534),(49860,535),(49861,536),(49862,537),(49863,538),(49864,539),(49865,540),(49866,541),(49867,542),(49868,543),(49869,544),(49870,545),(49871,546),(49872,547),(49873,548),(49874,549),(49875,550),(49876,551),(49877,552),(49878,553),(49879,554),(49880,555),(49881,556),(49882,558),(49883,559),(49884,561),(49885,562),(49886,563),(49887,564),(49888,565),(49889,566),(49890,567),(49891,568),(49892,569),(49893,570),(49894,571),(49895,572),(49896,573),(49897,574),(49898,575),(49899,576),(49900,577),(49901,578),(49902,579),(49903,580),(49904,581),(49905,582),(49906,583),(49907,584),(49908,585),(49909,586),(49910,587),(49911,588),(49912,589),(49913,590),(49914,591),(49915,592),(49916,593),(49917,594),(49918,595),(49919,596),(49920,597),(49921,598),(49922,599),(49923,600),(49924,601),(49925,602),(49926,603),(49927,604),(49928,605),(49929,606),(49930,607),(49931,608),(49932,609),(49933,610),(49934,612),(49935,626),(49936,627),(49937,628),(49938,629),(49939,630),(49940,631),(49941,754),(49942,755),(49943,756),(49944,757),(49945,758),(49946,759),(49947,760),(49948,761),(49949,762),(49950,763),(49951,764),(49952,765),(49953,766),(49954,767),(49955,768),(49956,769),(49957,770),(49958,771),(49959,772),(49960,773),(49961,774),(49962,775),(49963,776),(49964,777),(49965,778),(49966,779),(49967,780),(49968,781),(49969,782),(49970,783),(49971,784),(49972,785),(49973,786),(49974,787),(49975,788),(49976,789),(49977,790),(49978,791),(49979,792),(49980,793),(49981,794),(49982,795),(49983,796),(49984,797),(49985,798),(49986,799),(49987,800),(49988,801),(49989,802),(49990,803),(49991,804),(49992,805),(49993,806),(49994,807),(49995,808),(49996,809),(49997,810),(49998,811),(49999,812),(50000,813),(50001,814),(50002,815),(50003,816),(50004,817),(50005,818),(50006,819),(50007,820),(50008,821),(50009,822),(50010,823),(50011,824),(50012,825),(50013,826),(50014,827),(50015,828),(50016,829),(50017,830),(50018,831),(50019,832),(50020,833),(50021,834),(50022,835),(50023,836),(50024,837),(50025,838),(50026,839),(50027,840),(50028,841),(50029,842),(50030,843),(50031,844),(50032,845),(50033,846),(50034,847),(50035,848),(50036,849),(50037,850),(50038,851),(50039,852),(50040,853),(50041,854),(50042,855),(50043,856),(50044,857),(50045,858),(50046,859),(50047,860),(50048,861),(50049,862),(50050,863),(50051,864),(50052,865),(50053,866),(50054,867),(50055,868),(50056,869),(50057,870),(50058,871),(50059,872),(50060,1020),(50061,1021),(50062,1022),(50063,1023),(50064,1106),(50065,1166),(50066,1167),(50067,1168),(50068,1169),(50069,1170),(50070,1171),(50071,1172),(50072,1173),(50073,1174),(50074,1175),(50075,1176),(50076,1177),(50077,1178),(50078,1179),(50079,1180),(50080,1181),(50081,1182),(50082,1183),(50083,1195),(50084,1196),(50085,1197),(50086,1198),(50087,1199),(50088,1200),(50089,1201),(50090,1202),(50091,1203),(50092,1204),(50093,1205),(50094,1206),(50095,1207),(50096,1210),(50097,1211),(50098,1212),(50099,1213),(50100,1214),(50101,1215),(50102,1216),(50103,1217),(50104,1218),(50105,1219),(50106,1220),(50107,1221),(50108,1222),(50109,1223),(50110,1224),(50111,1225),(50112,1226),(50113,1227),(50114,1228),(50115,1229),(50116,1230),(50117,1231),(50118,1232),(50119,1233),(50120,1234),(50121,1235),(50122,1236),(50123,1237),(50124,1238),(50125,1239),(50126,1240),(50127,1241),(50128,1242),(50129,1243),(50130,1244),(50131,1245),(50132,1246),(50133,1247),(50134,1248),(50135,1249),(50136,1250),(50137,1251),(50138,1252),(50139,1253),(50140,1254),(50141,1255),(50142,1256),(50143,1257),(50144,1258),(50145,1259),(50146,1260),(50147,1261),(50148,1262),(50149,1263),(50150,1264),(50151,1265),(50152,1266),(50153,1267),(50154,1268),(50155,1269),(50156,1270),(50157,1271),(50158,1272),(50159,1273),(50160,1274),(50161,1275),(50162,1276),(50163,1277),(50164,1278),(50165,1279),(50166,1280),(50167,1281),(50168,1282),(50169,1283),(50170,1284),(50171,1285),(50172,1286),(50173,1287),(50174,1288),(50175,1289),(50176,1290),(50177,1291),(50178,1292),(50179,1293),(50180,1294),(50181,1295),(50182,1296),(50183,1297),(50184,1298),(50185,1299),(50186,1300),(50187,1301),(50188,1302),(50189,1303),(50190,1304),(50191,1305),(50192,1306),(50193,1307),(50194,1308),(50195,1309),(50196,1310),(50197,1311),(50198,1312),(50199,1313),(50200,1314),(50201,1315),(50202,1316),(50203,1317),(50204,1318),(50205,1319),(50206,1320),(50207,1321),(50208,1322),(50209,1323),(50210,1332),(50211,1342),(50212,1346),(50213,1347),(50214,1349),(50215,1350),(50216,1351),(50217,1353),(50218,1354),(50219,1355),(50220,1356),(50221,1357),(50222,1358),(50223,1359),(50224,1360),(50225,1361),(50226,1362),(50227,1363),(50228,1364),(50229,1366),(50230,1367),(50231,1368),(50232,1371),(50233,1375),(50234,1376),(50235,1377),(50236,1379),(50237,1389),(50238,1390),(50239,1391),(50240,1392),(50241,1393),(50242,1394),(50243,1395),(50244,1397),(50245,1398),(50246,1400),(50247,1420),(50248,1421),(50249,1422),(50250,1423),(50251,1424),(50252,1425),(50253,1427),(50254,1428),(50255,1429),(50256,1430),(50257,1431),(50258,1432),(50259,1433),(50260,1434),(50261,1435),(50262,1442),(50263,1443),(50264,1444),(50265,1445),(50266,1446),(50267,1447),(50268,1448),(50269,1450),(50270,1451),(50271,1452),(50272,1454),(50273,1455),(50274,1456),(50275,1457),(50276,1462),(50277,1469),(50278,1749),(50279,4500),(50280,4501),(50281,4502),(50282,4503),(50283,4504),(50284,4505),(50285,4506),(50286,4507),(50287,4508),(50288,4509),(50289,4510),(50290,4511),(50291,4512),(50292,4513),(50293,4514),(50294,4515),(50295,4516),(50296,4517),(50297,4518),(50298,4519),(50299,4520),(50300,4522),(50301,4523),(50302,5301),(50303,5468),(50304,5489),(50305,348),(50306,349),(50307,350),(50308,351),(50309,352),(50310,353),(50311,354),(50312,355),(50313,356),(50314,357),(50315,358),(50316,359),(50317,360),(50318,361),(50319,362),(50320,363),(50321,364),(50322,365),(50323,366),(50324,367),(50325,368),(50326,369),(50327,370),(50328,371),(50329,372),(50330,373),(50331,374),(50332,375),(50333,376),(50334,377),(50335,378),(50336,379),(50337,380),(50338,381),(50339,382),(50340,383),(50341,384),(50342,385),(50343,386),(50344,387),(50345,388),(50346,389),(50347,390),(50348,391),(50349,392),(50350,393),(50351,394),(50352,395),(50353,396),(50354,397),(50355,398),(50356,399),(50357,400),(50358,401),(50359,402),(50360,403),(50361,404),(50362,405),(50363,406),(50364,407),(50365,408),(50366,409),(50367,410),(50368,411),(50369,412),(50370,413),(50371,414),(50372,415),(50373,416),(50374,417),(50375,418),(50376,419),(50377,420),(50378,421),(50379,422),(50380,423),(50381,424),(50382,425),(50383,426),(50384,427),(50385,428),(50386,429),(50387,430),(50388,431),(50389,432),(50390,433),(50391,434),(50392,435),(50393,436),(50394,437),(50395,438),(50396,439),(50397,440),(50398,441),(50399,442),(50400,443),(50401,444),(50402,445),(50403,446),(50404,447),(50405,448),(50406,449),(50407,450),(50408,451),(50409,452),(50410,453),(50411,454),(50412,455),(50413,456),(50414,457),(50415,458),(50416,459),(50417,460),(50418,461),(50419,462),(50420,463),(50421,464),(50422,465),(50423,466),(50424,467),(50425,468),(50426,469),(50427,470),(50428,471),(50429,472),(50430,473),(50431,474),(50432,475),(50433,476),(50434,477),(50435,478),(50436,479),(50437,480),(50438,481),(50439,482),(50440,483),(50441,484),(50442,485),(50443,486),(50444,487),(50445,488),(50446,489),(50447,490),(50448,491),(50449,492),(50450,493),(50451,494),(50452,495),(50453,496),(50454,497),(50455,498),(50456,499),(50457,500),(50458,501),(50459,502),(50460,503),(50461,504),(50462,505),(50463,506),(50464,507),(50465,508),(50466,509),(50467,510),(50468,511),(50469,512),(50470,513),(50471,514),(50472,515),(50473,516),(50474,517),(50475,518),(50476,519),(50477,520),(50478,521),(50479,522),(50480,523),(50481,524),(50482,525),(50483,526),(50484,527),(50485,528),(50486,529),(50487,530),(50488,531),(50489,532),(50490,533),(50491,534),(50492,535),(50493,536),(50494,537),(50495,538),(50496,539),(50497,540),(50498,541),(50499,542),(50500,543),(50501,544),(50502,545),(50503,546),(50504,547),(50505,548),(50506,549),(50507,550),(50508,551),(50509,552),(50510,553),(50511,554),(50512,555),(50513,556),(50514,557),(50515,558),(50516,559),(50517,560),(50518,561),(50519,562),(50520,563),(50521,564),(50522,565),(50523,566),(50524,567),(50525,568),(50526,569),(50527,570),(50528,571),(50529,572),(50530,573),(50531,574),(50532,575),(50533,576),(50534,577),(50535,578),(50536,579),(50537,580),(50538,581),(50539,582),(50540,583),(50541,584),(50542,585),(50543,586),(50544,587),(50545,588),(50546,589),(50547,590),(50548,591),(50549,592),(50550,593),(50551,594),(50552,595),(50553,596),(50554,597),(50555,598),(50556,599),(50557,600),(50558,601),(50559,602),(50560,603),(50561,604),(50562,605),(50563,606),(50564,607),(50565,608),(50566,609),(50567,610),(50568,611),(50569,612),(50570,613),(50571,614),(50572,615),(50573,616),(50574,617),(50575,618),(50576,619),(50577,620),(50578,621),(50579,622),(50580,623),(50581,624),(50582,625),(50583,626),(50584,627),(50585,628),(50586,629),(50587,630),(50588,631),(50589,632),(50590,633),(50591,634),(50592,635),(50593,636),(50594,637),(50595,638),(50596,639),(50597,640),(50598,641),(50599,642),(50600,643),(50601,644),(50602,645),(50603,646),(50604,647),(50605,648),(50606,649),(50607,650),(50608,651),(50609,652),(50610,653),(50611,654),(50612,655),(50613,656),(50614,657),(50615,658),(50616,659),(50617,660),(50618,661),(50619,662),(50620,663),(50621,664),(50622,665),(50623,666),(50624,667),(50625,668),(50626,669),(50627,670),(50628,671),(50629,672),(50630,673),(50631,674),(50632,675),(50633,676),(50634,677),(50635,678),(50636,679),(50637,680),(50638,754),(50639,755),(50640,756),(50641,757),(50642,758),(50643,759),(50644,760),(50645,761),(50646,762),(50647,763),(50648,764),(50649,765),(50650,766),(50651,767),(50652,768),(50653,769),(50654,770),(50655,771),(50656,772),(50657,773),(50658,774),(50659,775),(50660,776),(50661,777),(50662,778),(50663,779),(50664,780),(50665,781),(50666,782),(50667,783),(50668,784),(50669,785),(50670,786),(50671,787),(50672,788),(50673,789),(50674,790),(50675,791),(50676,792),(50677,793),(50678,794),(50679,795),(50680,796),(50681,797),(50682,798),(50683,799),(50684,800),(50685,801),(50686,802),(50687,803),(50688,804),(50689,805),(50690,806),(50691,807),(50692,808),(50693,809),(50694,810),(50695,811),(50696,812),(50697,813),(50698,814),(50699,815),(50700,816),(50701,817),(50702,818),(50703,819),(50704,820),(50705,821),(50706,822),(50707,823),(50708,824),(50709,825),(50710,826),(50711,827),(50712,828),(50713,829),(50714,830),(50715,831),(50716,832),(50717,833),(50718,834),(50719,835),(50720,836),(50721,837),(50722,838),(50723,839),(50724,840),(50725,841),(50726,842),(50727,843),(50728,844),(50729,845),(50730,846),(50731,847),(50732,848),(50733,849),(50734,850),(50735,851),(50736,852),(50737,853),(50738,854),(50739,855),(50740,856),(50741,857),(50742,858),(50743,859),(50744,860),(50745,861),(50746,862),(50747,863),(50748,864),(50749,865),(50750,866),(50751,867),(50752,868),(50753,869),(50754,870),(50755,871),(50756,872),(50757,1020),(50758,1021),(50759,1022),(50760,1023),(50761,1106),(50762,1166),(50763,1167),(50764,1168),(50765,1169),(50766,1170),(50767,1171),(50768,1172),(50769,1173),(50770,1174),(50771,1175),(50772,1176),(50773,1177),(50774,1178),(50775,1179),(50776,1180),(50777,1181),(50778,1182),(50779,1183),(50780,1184),(50781,1185),(50782,1186),(50783,1187),(50784,1188),(50785,1189),(50786,1190),(50787,1191),(50788,1192),(50789,1193),(50790,1194),(50791,1195),(50792,1196),(50793,1197),(50794,1198),(50795,1199),(50796,1200),(50797,1201),(50798,1202),(50799,1203),(50800,1204),(50801,1205),(50802,1206),(50803,1207),(50804,1208),(50805,1209),(50806,1210),(50807,1211),(50808,1212),(50809,1213),(50810,1214),(50811,1215),(50812,1216),(50813,1217),(50814,1218),(50815,1219),(50816,1220),(50817,1221),(50818,1222),(50819,1223),(50820,1224),(50821,1225),(50822,1226),(50823,1227),(50824,1228),(50825,1229),(50826,1230),(50827,1231),(50828,1232),(50829,1233),(50830,1234),(50831,1235),(50832,1236),(50833,1237),(50834,1238),(50835,1239),(50836,1240),(50837,1241),(50838,1242),(50839,1243),(50840,1244),(50841,1245),(50842,1246),(50843,1247),(50844,1248),(50845,1249),(50846,1250),(50847,1251),(50848,1252),(50849,1253),(50850,1254),(50851,1255),(50852,1256),(50853,1257),(50854,1258),(50855,1259),(50856,1260),(50857,1261),(50858,1262),(50859,1263),(50860,1264),(50861,1265),(50862,1266),(50863,1267),(50864,1268),(50865,1269),(50866,1270),(50867,1271),(50868,1272),(50869,1273),(50870,1274),(50871,1275),(50872,1276),(50873,1277),(50874,1278),(50875,1279),(50876,1280),(50877,1281),(50878,1282),(50879,1283),(50880,1284),(50881,1285),(50882,1286),(50883,1287),(50884,1288),(50885,1289),(50886,1290),(50887,1291),(50888,1292),(50889,1293),(50890,1294),(50891,1295),(50892,1296),(50893,1297),(50894,1298),(50895,1299),(50896,1300),(50897,1301),(50898,1302),(50899,1303),(50900,1304),(50901,1305),(50902,1306),(50903,1307),(50904,1308),(50905,1309),(50906,1310),(50907,1311),(50908,1312),(50909,1313),(50910,1314),(50911,1315),(50912,1316),(50913,1317),(50914,1318),(50915,1319),(50916,1320),(50917,1321),(50918,1322),(50919,1323),(50920,1324),(50921,1325),(50922,1326),(50923,1327),(50924,1328),(50925,1329),(50926,1330),(50927,1331),(50928,1332),(50929,1333),(50930,1334),(50931,1335),(50932,1336),(50933,1337),(50934,1338),(50935,1339),(50936,1340),(50937,1341),(50938,1342),(50939,1343),(50940,1344),(50941,1345),(50942,1346),(50943,1347),(50944,1348),(50945,1349),(50946,1350),(50947,1351),(50948,1352),(50949,1353),(50950,1354),(50951,1355),(50952,1356),(50953,1357),(50954,1358),(50955,1359),(50956,1360),(50957,1361),(50958,1362),(50959,1363),(50960,1364),(50961,1365),(50962,1366),(50963,1367),(50964,1368),(50965,1369),(50966,1370),(50967,1371),(50968,1372),(50969,1373),(50970,1374),(50971,1375),(50972,1376),(50973,1377),(50974,1378),(50975,1379),(50976,1380),(50977,1381),(50978,1382),(50979,1383),(50980,1384),(50981,1385),(50982,1386),(50983,1387),(50984,1388),(50985,1389),(50986,1390),(50987,1391),(50988,1392),(50989,1393),(50990,1394),(50991,1395),(50992,1396),(50993,1397),(50994,1398),(50995,1399),(50996,1400),(50997,1401),(50998,1402),(50999,1403),(51000,1404),(51001,1405),(51002,1406),(51003,1407),(51004,1408),(51005,1409),(51006,1410),(51007,1411),(51008,1412),(51009,1413),(51010,1414),(51011,1415),(51012,1416),(51013,1417),(51014,1418),(51015,1419),(51016,1420),(51017,1421),(51018,1422),(51019,1423),(51020,1424),(51021,1425),(51022,1426),(51023,1427),(51024,1428),(51025,1429),(51026,1430),(51027,1431),(51028,1432),(51029,1433),(51030,1434),(51031,1435),(51032,1436),(51033,1437),(51034,1438),(51035,1439),(51036,1440),(51037,1441),(51038,1442),(51039,1443),(51040,1444),(51041,1445),(51042,1446),(51043,1447),(51044,1448),(51045,1449),(51046,1450),(51047,1451),(51048,1452),(51049,1453),(51050,1454),(51051,1455),(51052,1456),(51053,1457),(51054,1458),(51055,1459),(51056,1460),(51057,1461),(51058,1462),(51059,1463),(51060,1464),(51061,1465),(51062,1466),(51063,1467),(51064,1468),(51065,1469),(51066,1470),(51067,1471),(51068,1472),(51069,1488),(51070,1489),(51071,1490),(51072,1491),(51073,1492),(51074,1493),(51075,1494),(51076,1749),(51077,1992),(51078,1993),(51079,1994),(51080,1995),(51081,1996),(51082,1997),(51083,1998),(51084,1999),(51085,2000),(51086,2001),(51087,2002),(51088,4500),(51089,4501),(51090,4502),(51091,4503),(51092,4504),(51093,4505),(51094,4506),(51095,4507),(51096,4508),(51097,4509),(51098,4510),(51099,4511),(51100,4512),(51101,4513),(51102,4514),(51103,4515),(51104,4516),(51105,4517),(51106,4518),(51107,4519),(51108,4520),(51109,4521),(51110,4522),(51111,4523),(51112,4524),(51113,4525),(51114,4526),(51115,4527),(51116,4528),(51117,4529),(51118,4530),(51119,4531),(51120,4532),(51121,4533),(51122,4534),(51123,4535),(51124,4536),(51125,5271),(51126,5272),(51127,5273),(51128,5274),(51129,5282),(51130,5283),(51131,5284),(51132,5301),(51133,5468),(51134,5489),(51135,348),(51136,349),(51137,350),(51138,351),(51139,352),(51140,353),(51141,354),(51142,355),(51143,356),(51144,357),(51145,358),(51146,359),(51147,360),(51148,361),(51149,370),(51150,371),(51151,372),(51152,373),(51153,374),(51154,375),(51155,376),(51156,377),(51157,378),(51158,379),(51159,380),(51160,381),(51161,382),(51162,383),(51163,384),(51164,385),(51165,386),(51166,387),(51167,388),(51168,389),(51169,390),(51170,391),(51171,392),(51172,393),(51173,394),(51174,395),(51175,396),(51176,397),(51177,533),(51178,534),(51179,535),(51180,536),(51181,537),(51182,538),(51183,539),(51184,540),(51185,541),(51186,542),(51187,543),(51188,544),(51189,545),(51190,546),(51191,547),(51192,548),(51193,549),(51194,550),(51195,551),(51196,552),(51197,553),(51198,554),(51199,555),(51200,556),(51201,558),(51202,559),(51203,561),(51204,562),(51205,563),(51206,564),(51207,565),(51208,566),(51209,567),(51210,568),(51211,569),(51212,570),(51213,571),(51214,572),(51215,573),(51216,574),(51217,575),(51218,576),(51219,577),(51220,578),(51221,579),(51222,580),(51223,581),(51224,582),(51225,583),(51226,584),(51227,585),(51228,586),(51229,587),(51230,588),(51231,589),(51232,590),(51233,591),(51234,592),(51235,593),(51236,594),(51237,595),(51238,596),(51239,597),(51240,598),(51241,599),(51242,600),(51243,601),(51244,602),(51245,603),(51246,604),(51247,605),(51248,606),(51249,607),(51250,608),(51251,609),(51252,610),(51253,612),(51254,626),(51255,627),(51256,628),(51257,629),(51258,630),(51259,631),(51260,754),(51261,755),(51262,756),(51263,757),(51264,758),(51265,759),(51266,760),(51267,761),(51268,762),(51269,763),(51270,764),(51271,765),(51272,766),(51273,767),(51274,768),(51275,769),(51276,770),(51277,771),(51278,772),(51279,773),(51280,774),(51281,775),(51282,776),(51283,777),(51284,778),(51285,779),(51286,780),(51287,781),(51288,782),(51289,783),(51290,784),(51291,785),(51292,786),(51293,787),(51294,788),(51295,789),(51296,790),(51297,791),(51298,792),(51299,793),(51300,794),(51301,795),(51302,796),(51303,797),(51304,798),(51305,799),(51306,800),(51307,801),(51308,802),(51309,803),(51310,804),(51311,805),(51312,806),(51313,807),(51314,808),(51315,809),(51316,810),(51317,811),(51318,812),(51319,813),(51320,814),(51321,815),(51322,816),(51323,817),(51324,818),(51325,819),(51326,820),(51327,821),(51328,822),(51329,823),(51330,824),(51331,825),(51332,826),(51333,827),(51334,828),(51335,829),(51336,830),(51337,831),(51338,832),(51339,833),(51340,834),(51341,835),(51342,836),(51343,837),(51344,838),(51345,839),(51346,840),(51347,841),(51348,842),(51349,843),(51350,844),(51351,845),(51352,846),(51353,847),(51354,848),(51355,849),(51356,850),(51357,851),(51358,852),(51359,853),(51360,854),(51361,855),(51362,856),(51363,857),(51364,858),(51365,859),(51366,860),(51367,861),(51368,862),(51369,863),(51370,864),(51371,865),(51372,866),(51373,867),(51374,868),(51375,869),(51376,870),(51377,871),(51378,872),(51379,1020),(51380,1021),(51381,1022),(51382,1023),(51383,1106),(51384,1166),(51385,1167),(51386,1168),(51387,1169),(51388,1170),(51389,1171),(51390,1172),(51391,1173),(51392,1174),(51393,1175),(51394,1176),(51395,1177),(51396,1178),(51397,1179),(51398,1180),(51399,1181),(51400,1182),(51401,1183),(51402,1195),(51403,1196),(51404,1197),(51405,1198),(51406,1199),(51407,1200),(51408,1201),(51409,1202),(51410,1203),(51411,1204),(51412,1205),(51413,1206),(51414,1207),(51415,1210),(51416,1211),(51417,1212),(51418,1213),(51419,1214),(51420,1215),(51421,1216),(51422,1217),(51423,1218),(51424,1219),(51425,1220),(51426,1221),(51427,1222),(51428,1223),(51429,1224),(51430,1225),(51431,1226),(51432,1227),(51433,1228),(51434,1229),(51435,1230),(51436,1231),(51437,1232),(51438,1233),(51439,1234),(51440,1235),(51441,1236),(51442,1237),(51443,1238),(51444,1239),(51445,1240),(51446,1241),(51447,1242),(51448,1243),(51449,1244),(51450,1245),(51451,1246),(51452,1247),(51453,1248),(51454,1249),(51455,1250),(51456,1251),(51457,1252),(51458,1253),(51459,1254),(51460,1255),(51461,1256),(51462,1257),(51463,1258),(51464,1259),(51465,1260),(51466,1261),(51467,1262),(51468,1263),(51469,1264),(51470,1265),(51471,1266),(51472,1267),(51473,1268),(51474,1269),(51475,1270),(51476,1271),(51477,1272),(51478,1273),(51479,1274),(51480,1275),(51481,1276),(51482,1277),(51483,1278),(51484,1279),(51485,1280),(51486,1281),(51487,1282),(51488,1283),(51489,1284),(51490,1285),(51491,1286),(51492,1287),(51493,1288),(51494,1289),(51495,1290),(51496,1291),(51497,1292),(51498,1293),(51499,1294),(51500,1295),(51501,1296),(51502,1297),(51503,1298),(51504,1299),(51505,1300),(51506,1301),(51507,1302),(51508,1303),(51509,1304),(51510,1305),(51511,1306),(51512,1307),(51513,1308),(51514,1309),(51515,1310),(51516,1311),(51517,1312),(51518,1313),(51519,1314),(51520,1315),(51521,1316),(51522,1317),(51523,1318),(51524,1319),(51525,1320),(51526,1321),(51527,1322),(51528,1323),(51529,1332),(51530,1342),(51531,1346),(51532,1347),(51533,1349),(51534,1350),(51535,1351),(51536,1353),(51537,1354),(51538,1355),(51539,1356),(51540,1357),(51541,1358),(51542,1359),(51543,1360),(51544,1361),(51545,1362),(51546,1363),(51547,1364),(51548,1366),(51549,1367),(51550,1368),(51551,1371),(51552,1375),(51553,1376),(51554,1377),(51555,1379),(51556,1389),(51557,1390),(51558,1391),(51559,1392),(51560,1393),(51561,1394),(51562,1395),(51563,1397),(51564,1398),(51565,1400),(51566,1420),(51567,1421),(51568,1422),(51569,1423),(51570,1424),(51571,1425),(51572,1427),(51573,1428),(51574,1429),(51575,1430),(51576,1431),(51577,1432),(51578,1433),(51579,1434),(51580,1435),(51581,1442),(51582,1443),(51583,1444),(51584,1445),(51585,1446),(51586,1447),(51587,1448),(51588,1450),(51589,1451),(51590,1452),(51591,1454),(51592,1455),(51593,1456),(51594,1457),(51595,1462),(51596,1469),(51597,1749),(51598,4500),(51599,4501),(51600,4502),(51601,4503),(51602,4504),(51603,4505),(51604,4506),(51605,4507),(51606,4508),(51607,4509),(51608,4510),(51609,4511),(51610,4512),(51611,4513),(51612,4514),(51613,4515),(51614,4516),(51615,4517),(51616,4518),(51617,4519),(51618,4520),(51619,4522),(51620,4523),(51621,5301),(51622,5468),(51623,5489),(51624,283),(51625,285),(51626,288),(51627,290),(51628,293),(51629,295),(51630,315),(51631,321),(51632,672),(51633,681),(51634,709),(51635,710),(51636,726),(51637,727),(51638,729),(51639,908),(51640,1002),(51641,1119),(51642,636),(51643,281),(51644,282),(51645,284),(51646,286),(51647,287),(51648,289),(51649,291),(51650,292),(51651,296),(51652,297),(51653,298),(51654,299),(51655,300),(51656,302),(51657,303),(51658,304),(51659,305),(51660,306),(51661,307),(51662,309),(51663,310),(51664,313),(51665,316),(51666,317),(51667,318),(51668,341),(51669,342),(51670,343),(51671,374),(51672,375),(51673,376),(51674,527),(51675,529),(51676,530),(51677,531),(51678,532),(51679,557),(51680,560),(51681,587),(51682,588),(51683,589),(51684,590),(51685,591),(51686,592),(51687,611),(51688,613),(51689,617),(51690,619),(51691,624),(51692,625),(51693,637),(51694,639),(51695,648),(51696,652),(51697,660),(51698,670),(51699,682),(51700,683),(51701,684),(51702,685),(51703,686),(51704,688),(51705,689),(51706,690),(51707,691),(51708,693),(51709,694),(51710,695),(51711,696),(51712,697),(51713,698),(51714,700),(51715,701),(51716,705),(51717,708),(51718,712),(51719,715),(51720,716),(51721,717),(51722,728),(51723,730),(51724,731),(51725,735),(51726,736),(51727,778),(51728,779),(51729,834),(51730,835),(51731,836),(51732,837),(51733,838),(51734,839),(51735,840),(51736,906),(51737,996),(51738,997),(51739,998),(51740,999),(51741,1000),(51742,1034),(51743,1036),(51744,1038),(51745,1062),(51746,1063),(51747,1064),(51748,1066),(51749,1067),(51750,1068),(51751,1069),(51752,1070),(51753,1071),(51754,1072),(51755,1073),(51756,1074),(51757,1075),(51758,1133),(51759,2524),(51760,2526),(51761,281),(51762,284),(51763,286),(51764,287),(51765,289),(51766,291),(51767,292),(51768,294),(51769,296),(51770,297),(51771,298),(51772,299),(51773,300),(51774,301),(51775,302),(51776,303),(51777,304),(51778,305),(51779,306),(51780,307),(51781,316),(51782,332),(51783,333),(51784,337),(51785,341),(51786,342),(51787,343),(51788,374),(51789,375),(51790,376),(51791,527),(51792,528),(51793,529),(51794,530),(51795,531),(51796,532),(51797,557),(51798,560),(51799,587),(51800,588),(51801,589),(51802,590),(51803,591),(51804,592),(51805,611),(51806,613),(51807,617),(51808,618),(51809,619),(51810,624),(51811,625),(51812,632),(51813,636),(51814,637),(51815,639),(51816,646),(51817,648),(51818,652),(51819,659),(51820,660),(51821,670),(51822,682),(51823,683),(51824,684),(51825,685),(51826,686),(51827,687),(51828,688),(51829,689),(51830,690),(51831,691),(51832,693),(51833,694),(51834,695),(51835,696),(51836,697),(51837,698),(51838,700),(51839,702),(51840,705),(51841,706),(51842,711),(51843,712),(51844,715),(51845,716),(51846,717),(51847,728),(51848,735),(51849,736),(51850,742),(51851,778),(51852,779),(51853,834),(51854,835),(51855,836),(51856,837),(51857,838),(51858,839),(51859,840),(51860,906),(51861,997),(51862,998),(51863,999),(51864,1000),(51865,1001),(51866,1036),(51867,1037),(51868,1038),(51869,1064),(51870,1066),(51871,1067),(51872,1068),(51873,1069),(51874,1070),(51875,1071),(51876,1072),(51877,1073),(51878,1074),(51879,1075),(51880,1133),(51881,2524),(51882,2526),(51883,282),(51884,283),(51885,285),(51886,288),(51887,290),(51888,293),(51889,295),(51890,308),(51891,309),(51892,310),(51893,311),(51894,312),(51895,313),(51896,314),(51897,315),(51898,317),(51899,318),(51900,319),(51901,320),(51902,321),(51903,322),(51904,323),(51905,334),(51906,335),(51907,336),(51908,338),(51909,339),(51910,345),(51911,672),(51912,681),(51913,692),(51914,699),(51915,701),(51916,703),(51917,704),(51918,707),(51919,708),(51920,709),(51921,710),(51922,713),(51923,718),(51924,719),(51925,720),(51926,721),(51927,722),(51928,723),(51929,724),(51930,725),(51931,726),(51932,727),(51933,729),(51934,730),(51935,731),(51936,737),(51937,738),(51938,739),(51939,740),(51940,741),(51941,743),(51942,744),(51943,745),(51944,746),(51945,748),(51946,749),(51947,903),(51948,907),(51949,908),(51950,996),(51951,1002),(51952,1003),(51953,1004),(51954,1005),(51955,1012),(51956,1019),(51957,1034),(51958,1035),(51959,1062),(51960,1063),(51961,1092),(51962,1119),(51963,528),(51964,636),(51965,646),(51966,1001),(51967,340),(51968,344),(51969,346),(51970,347),(51971,714),(51972,732),(51973,733),(51974,734),(51975,747),(51976,904),(51977,905),(51978,281),(51979,282),(51980,284),(51981,286),(51982,287),(51983,289),(51984,291),(51985,292),(51986,294),(51987,296),(51988,297),(51989,298),(51990,299),(51991,300),(51992,301),(51993,302),(51994,303),(51995,304),(51996,305),(51997,306),(51998,307),(51999,308),(52000,309),(52001,310),(52002,311),(52003,312),(52004,313),(52005,316),(52006,317),(52007,318),(52008,332),(52009,333),(52010,334),(52011,335),(52012,336),(52013,337),(52014,338),(52015,339),(52016,341),(52017,342),(52018,343),(52019,374),(52020,375),(52021,376),(52022,527),(52023,529),(52024,530),(52025,531),(52026,532),(52027,557),(52028,560),(52029,587),(52030,588),(52031,589),(52032,590),(52033,591),(52034,592),(52035,611),(52036,613),(52037,617),(52038,619),(52039,624),(52040,625),(52041,637),(52042,639),(52043,648),(52044,652),(52045,659),(52046,660),(52047,670),(52048,682),(52049,683),(52050,684),(52051,685),(52052,686),(52053,687),(52054,688),(52055,689),(52056,690),(52057,691),(52058,693),(52059,694),(52060,695),(52061,696),(52062,697),(52063,698),(52064,700),(52065,701),(52066,702),(52067,703),(52068,705),(52069,706),(52070,707),(52071,708),(52072,711),(52073,712),(52074,713),(52075,715),(52076,716),(52077,717),(52078,728),(52079,730),(52080,731),(52081,735),(52082,736),(52083,742),(52084,778),(52085,779),(52086,834),(52087,835),(52088,836),(52089,837),(52090,838),(52091,839),(52092,840),(52093,903),(52094,996),(52095,997),(52096,998),(52097,999),(52098,1000),(52099,1001),(52100,1034),(52101,1035),(52102,1036),(52103,1038),(52104,1062),(52105,1063),(52106,1064),(52107,1066),(52108,1067),(52109,1068),(52110,1069),(52111,1070),(52112,1071),(52113,1072),(52114,1073),(52115,1074),(52116,1075),(52117,1133),(52118,659),(52119,683),(52120,684),(52121,685),(52122,686),(52123,689),(52124,709),(52125,710),(52126,712),(52127,715),(52128,716),(52129,717),(52130,726),(52131,727),(52132,728),(52133,729),(52134,730),(52135,731),(52136,735),(52137,736),(52138,659),(52139,683),(52140,684),(52141,685),(52142,686),(52143,689),(52144,709),(52145,710),(52146,712),(52147,715),(52148,716),(52149,717),(52150,726),(52151,727),(52152,728),(52153,729),(52154,730),(52155,731),(52156,735),(52157,736),(52158,659),(52159,683),(52160,684),(52161,685),(52162,686),(52163,689),(52164,712),(52165,715),(52166,716),(52167,717),(52168,728),(52169,730),(52170,731),(52171,735),(52172,736),(52173,292),(52174,293),(52175,302),(52176,303),(52177,314),(52178,315),(52179,320),(52180,321),(52181,326),(52182,327),(52183,335),(52184,338),(52185,346),(52186,347),(52187,699),(52188,722),(52189,729),(52190,730),(52191,903),(52192,1035),(52193,1073),(52194,1074),(52195,1075),(52196,297),(52197,438),(52198,476),(52199,477),(52200,478),(52201,479),(52202,484),(52203,493),(52204,494),(52205,515),(52206,523),(52207,524),(52208,528),(52209,620),(52210,640),(52211,641),(52212,642),(52213,646),(52214,649),(52215,654),(52216,657),(52217,658),(52218,659),(52219,660),(52220,1184),(52221,1238),(52222,1268),(52223,1294),(52224,1378),(52225,1389),(52226,1462),(52227,2154),(52228,2177),(52229,2221),(52230,2222),(52231,2299),(52232,5361),(52233,5362),(52234,5364),(52235,5622),(52236,5626),(52237,5639),(52238,5640),(52239,5641),(52240,5648),(52241,5665),(52242,5666),(52243,5667),(52244,2265),(52245,2269),(52246,281),(52247,282),(52248,283),(52249,284),(52250,285),(52251,286),(52252,287),(52253,288),(52254,289),(52255,290),(52256,291),(52257,292),(52258,293),(52259,294),(52260,295),(52261,296),(52262,297),(52263,298),(52264,299),(52265,300),(52266,301),(52267,302),(52268,303),(52269,304),(52270,305),(52271,306),(52272,307),(52273,308),(52274,309),(52275,310),(52276,311),(52277,312),(52278,313),(52279,314),(52280,315),(52281,316),(52282,317),(52283,318),(52284,319),(52285,320),(52286,321),(52287,322),(52288,323),(52289,324),(52290,325),(52291,326),(52292,327),(52293,328),(52294,329),(52295,330),(52296,331),(52297,332),(52298,333),(52299,334),(52300,335),(52301,336),(52302,337),(52303,338),(52304,339),(52305,340),(52306,341),(52307,342),(52308,343),(52309,344),(52310,345),(52311,346),(52312,347),(52313,903),(52314,904),(52315,905),(52316,907),(52317,1965),(52318,2439),(52319,2494),(52320,2495),(52321,2496),(52322,2497),(52323,2498),(52324,2499),(52325,2500),(52326,2513),(52327,2514),(52328,2529),(52329,2530),(52330,2539),(52331,2553),(52332,2554),(52333,2582),(52334,2583),(52335,2584),(52336,2585),(52337,2586),(52338,2587),(52339,4859),(52340,4860),(52341,4861),(52342,4862),(52343,4863),(52344,4864),(52345,4865),(52346,4866),(52347,4867),(52348,4868),(52349,4869),(52350,4870),(52351,4871),(52352,4874),(52353,4875),(52354,4876),(52355,4891),(52356,4892),(52357,4893),(52358,4894),(52359,281),(52360,282),(52361,283),(52362,284),(52363,285),(52364,286),(52365,287),(52366,288),(52367,289),(52368,290),(52369,291),(52370,292),(52371,293),(52372,294),(52373,295),(52374,296),(52375,297),(52376,298),(52377,299),(52378,300),(52379,301),(52380,302),(52381,303),(52382,304),(52383,305),(52384,306),(52385,307),(52386,308),(52387,309),(52388,310),(52389,311),(52390,312),(52391,313),(52392,314),(52393,315),(52394,316),(52395,317),(52396,318),(52397,319),(52398,320),(52399,321),(52400,322),(52401,323),(52402,324),(52403,325),(52404,326),(52405,327),(52406,328),(52407,329),(52408,330),(52409,331),(52410,332),(52411,333),(52412,334),(52413,335),(52414,336),(52415,337),(52416,338),(52417,339),(52418,340),(52419,341),(52420,342),(52421,343),(52422,344),(52423,345),(52424,346),(52425,347),(52426,903),(52427,904),(52428,905),(52429,907),(52430,1965),(52431,4613),(52432,4614),(52433,4857),(52434,4858),(52435,4872),(52436,4873),(52437,906),(52438,908),(52439,1004),(52440,1012),(52441,1019),(52442,1037),(52443,1092),(52444,1119),(52445,2524),(52446,2526),(52447,681),(52448,682),(52449,683),(52450,684),(52451,685),(52452,686),(52453,687),(52454,688),(52455,689),(52456,690),(52457,691),(52458,692),(52459,693),(52460,694),(52461,695),(52462,696),(52463,697),(52464,698),(52465,699),(52466,700),(52467,701),(52468,702),(52469,703),(52470,704),(52471,705),(52472,706),(52473,707),(52474,708),(52475,709),(52476,710),(52477,711),(52478,712),(52479,713),(52480,714),(52481,715),(52482,716),(52483,717),(52484,718),(52485,719),(52486,720),(52487,721),(52488,722),(52489,723),(52490,724),(52491,725),(52492,726),(52493,727),(52494,728),(52495,729),(52496,730),(52497,731),(52498,732),(52499,733),(52500,734),(52501,735),(52502,736),(52503,737),(52504,738),(52505,739),(52506,740),(52507,741),(52508,742),(52509,743),(52510,744),(52511,745),(52512,746),(52513,747),(52514,748),(52515,749),(52516,996),(52517,997),(52518,998),(52519,999),(52520,1000),(52521,1001),(52522,1002),(52523,1003),(52524,1005),(52525,1034),(52526,1035),(52527,1036),(52528,1038),(52529,1133),(52530,2221),(52531,2222),(52532,362),(52533,363),(52534,364),(52535,365),(52536,366),(52537,367),(52538,368),(52539,369),(52540,398),(52541,399),(52542,400),(52543,401),(52544,402),(52545,403),(52546,404),(52547,405),(52548,406),(52549,407),(52550,408),(52551,409),(52552,410),(52553,411),(52554,412),(52555,413),(52556,414),(52557,415),(52558,416),(52559,417),(52560,418),(52561,419),(52562,420),(52563,421),(52564,422),(52565,423),(52566,424),(52567,425),(52568,426),(52569,427),(52570,428),(52571,429),(52572,430),(52573,431),(52574,432),(52575,433),(52576,434),(52577,435),(52578,436),(52579,437),(52580,438),(52581,439),(52582,440),(52583,441),(52584,442),(52585,443),(52586,444),(52587,445),(52588,446),(52589,447),(52590,448),(52591,449),(52592,450),(52593,451),(52594,452),(52595,453),(52596,454),(52597,455),(52598,456),(52599,457),(52600,458),(52601,459),(52602,460),(52603,461),(52604,462),(52605,463),(52606,464),(52607,465),(52608,466),(52609,467),(52610,468),(52611,469),(52612,470),(52613,471),(52614,472),(52615,473),(52616,474),(52617,475),(52618,476),(52619,477),(52620,478),(52621,479),(52622,480),(52623,481),(52624,482),(52625,483),(52626,484),(52627,485),(52628,486),(52629,487),(52630,488),(52631,489),(52632,490),(52633,491),(52634,492),(52635,493),(52636,494),(52637,495),(52638,496),(52639,497),(52640,498),(52641,499),(52642,500),(52643,501),(52644,502),(52645,503),(52646,504),(52647,505),(52648,506),(52649,507),(52650,508),(52651,509),(52652,510),(52653,511),(52654,512),(52655,513),(52656,514),(52657,515),(52658,516),(52659,517),(52660,518),(52661,519),(52662,520),(52663,521),(52664,522),(52665,523),(52666,524),(52667,525),(52668,526),(52669,527),(52670,528),(52671,529),(52672,530),(52673,531),(52674,532),(52675,557),(52676,560),(52677,611),(52678,613),(52679,614),(52680,615),(52681,616),(52682,617),(52683,619),(52684,620),(52685,621),(52686,622),(52687,623),(52688,624),(52689,625),(52690,633),(52691,634),(52692,635),(52693,636),(52694,637),(52695,638),(52696,639),(52697,640),(52698,641),(52699,642),(52700,643),(52701,644),(52702,645),(52703,646),(52704,647),(52705,648),(52706,649),(52707,650),(52708,651),(52709,652),(52710,653),(52711,654),(52712,655),(52713,656),(52714,657),(52715,658),(52716,659),(52717,660),(52718,661),(52719,662),(52720,663),(52721,664),(52722,665),(52723,666),(52724,667),(52725,668),(52726,669),(52727,670),(52728,671),(52729,672),(52730,673),(52731,674),(52732,675),(52733,676),(52734,677),(52735,678),(52736,679),(52737,680),(52738,1184),(52739,1185),(52740,1186),(52741,1187),(52742,1188),(52743,1189),(52744,1190),(52745,1191),(52746,1192),(52747,1193),(52748,1194),(52749,1208),(52750,1209),(52751,1324),(52752,1325),(52753,1326),(52754,1327),(52755,1328),(52756,1329),(52757,1330),(52758,1331),(52759,1333),(52760,1334),(52761,1335),(52762,1336),(52763,1337),(52764,1338),(52765,1339),(52766,1340),(52767,1341),(52768,1343),(52769,1344),(52770,1345),(52771,1348),(52772,1352),(52773,1365),(52774,1369),(52775,1370),(52776,1372),(52777,1373),(52778,1374),(52779,1378),(52780,1380),(52781,1381),(52782,1382),(52783,1383),(52784,1384),(52785,1385),(52786,1386),(52787,1387),(52788,1388),(52789,1396),(52790,1399),(52791,1401),(52792,1402),(52793,1403),(52794,1404),(52795,1405),(52796,1406),(52797,1407),(52798,1408),(52799,1409),(52800,1410),(52801,1411),(52802,1412),(52803,1413),(52804,1414),(52805,1415),(52806,1416),(52807,1417),(52808,1418),(52809,1419),(52810,1426),(52811,1436),(52812,1437),(52813,1438),(52814,1439),(52815,1440),(52816,1441),(52817,1449),(52818,1453),(52819,1458),(52820,1459),(52821,1460),(52822,1461),(52823,1463),(52824,1464),(52825,1465),(52826,1466),(52827,1467),(52828,1468),(52829,1470),(52830,1471),(52831,1472),(52832,1488),(52833,1489),(52834,1490),(52835,1491),(52836,1492),(52837,1493),(52838,1494),(52839,1992),(52840,1993),(52841,1994),(52842,1995),(52843,1996),(52844,1997),(52845,1998),(52846,1999),(52847,2000),(52848,2001),(52849,2002),(52850,4521),(52851,4524),(52852,4525),(52853,4526),(52854,4527),(52855,4528),(52856,4529),(52857,4530),(52858,4531),(52859,4532),(52860,4533),(52861,4534),(52862,4535),(52863,4536),(52864,5271),(52865,5272),(52866,5273),(52867,5274),(52868,5282),(52869,5283),(52870,5284),(52871,348),(52872,349),(52873,350),(52874,351),(52875,352),(52876,353),(52877,354),(52878,355),(52879,356),(52880,357),(52881,358),(52882,359),(52883,360),(52884,361),(52885,370),(52886,371),(52887,372),(52888,373),(52889,374),(52890,375),(52891,376),(52892,377),(52893,378),(52894,379),(52895,380),(52896,381),(52897,382),(52898,383),(52899,384),(52900,385),(52901,386),(52902,387),(52903,388),(52904,389),(52905,390),(52906,391),(52907,392),(52908,393),(52909,394),(52910,395),(52911,396),(52912,397),(52913,533),(52914,534),(52915,535),(52916,536),(52917,537),(52918,538),(52919,539),(52920,540),(52921,541),(52922,542),(52923,543),(52924,544),(52925,545),(52926,546),(52927,547),(52928,548),(52929,549),(52930,550),(52931,551),(52932,552),(52933,553),(52934,554),(52935,555),(52936,556),(52937,558),(52938,559),(52939,561),(52940,562),(52941,563),(52942,564),(52943,565),(52944,566),(52945,567),(52946,568),(52947,569),(52948,570),(52949,571),(52950,572),(52951,573),(52952,574),(52953,575),(52954,576),(52955,577),(52956,578),(52957,579),(52958,580),(52959,581),(52960,582),(52961,583),(52962,584),(52963,585),(52964,586),(52965,587),(52966,588),(52967,589),(52968,590),(52969,591),(52970,592),(52971,593),(52972,594),(52973,595),(52974,596),(52975,597),(52976,598),(52977,599),(52978,600),(52979,601),(52980,602),(52981,603),(52982,604),(52983,605),(52984,606),(52985,607),(52986,608),(52987,609),(52988,610),(52989,612),(52990,626),(52991,627),(52992,628),(52993,629),(52994,630),(52995,631),(52996,754),(52997,755),(52998,756),(52999,757),(53000,758),(53001,759),(53002,760),(53003,761),(53004,762),(53005,763),(53006,764),(53007,765),(53008,766),(53009,767),(53010,768),(53011,769),(53012,770),(53013,771),(53014,772),(53015,773),(53016,774),(53017,775),(53018,776),(53019,777),(53020,778),(53021,779),(53022,780),(53023,781),(53024,782),(53025,783),(53026,784),(53027,785),(53028,786),(53029,787),(53030,788),(53031,789),(53032,790),(53033,791),(53034,792),(53035,793),(53036,794),(53037,795),(53038,796),(53039,797),(53040,798),(53041,799),(53042,800),(53043,801),(53044,802),(53045,803),(53046,804),(53047,805),(53048,806),(53049,807),(53050,808),(53051,809),(53052,810),(53053,811),(53054,812),(53055,813),(53056,814),(53057,815),(53058,816),(53059,817),(53060,818),(53061,819),(53062,820),(53063,821),(53064,822),(53065,823),(53066,824),(53067,825),(53068,826),(53069,827),(53070,828),(53071,829),(53072,830),(53073,831),(53074,832),(53075,833),(53076,834),(53077,835),(53078,836),(53079,837),(53080,838),(53081,839),(53082,840),(53083,841),(53084,842),(53085,843),(53086,844),(53087,845),(53088,846),(53089,847),(53090,848),(53091,849),(53092,850),(53093,851),(53094,852),(53095,853),(53096,854),(53097,855),(53098,856),(53099,857),(53100,858),(53101,859),(53102,860),(53103,861),(53104,862),(53105,863),(53106,864),(53107,865),(53108,866),(53109,867),(53110,868),(53111,869),(53112,870),(53113,871),(53114,872),(53115,1020),(53116,1021),(53117,1022),(53118,1023),(53119,1106),(53120,1166),(53121,1167),(53122,1168),(53123,1169),(53124,1170),(53125,1171),(53126,1172),(53127,1173),(53128,1174),(53129,1175),(53130,1176),(53131,1177),(53132,1178),(53133,1179),(53134,1180),(53135,1181),(53136,1182),(53137,1183),(53138,1195),(53139,1196),(53140,1197),(53141,1198),(53142,1199),(53143,1200),(53144,1201),(53145,1202),(53146,1203),(53147,1204),(53148,1205),(53149,1206),(53150,1207),(53151,1210),(53152,1211),(53153,1212),(53154,1213),(53155,1214),(53156,1215),(53157,1216),(53158,1217),(53159,1218),(53160,1219),(53161,1220),(53162,1221),(53163,1222),(53164,1223),(53165,1224),(53166,1225),(53167,1226),(53168,1227),(53169,1228),(53170,1229),(53171,1230),(53172,1231),(53173,1232),(53174,1233),(53175,1234),(53176,1235),(53177,1236),(53178,1237),(53179,1238),(53180,1239),(53181,1240),(53182,1241),(53183,1242),(53184,1243),(53185,1244),(53186,1245),(53187,1246),(53188,1247),(53189,1248),(53190,1249),(53191,1250),(53192,1251),(53193,1252),(53194,1253),(53195,1254),(53196,1255),(53197,1256),(53198,1257),(53199,1258),(53200,1259),(53201,1260),(53202,1261),(53203,1262),(53204,1263),(53205,1264),(53206,1265),(53207,1266),(53208,1267),(53209,1268),(53210,1269),(53211,1270),(53212,1271),(53213,1272),(53214,1273),(53215,1274),(53216,1275),(53217,1276),(53218,1277),(53219,1278),(53220,1279),(53221,1280),(53222,1281),(53223,1282),(53224,1283),(53225,1284),(53226,1285),(53227,1286),(53228,1287),(53229,1288),(53230,1289),(53231,1290),(53232,1291),(53233,1292),(53234,1293),(53235,1294),(53236,1295),(53237,1296),(53238,1297),(53239,1298),(53240,1299),(53241,1300),(53242,1301),(53243,1302),(53244,1303),(53245,1304),(53246,1305),(53247,1306),(53248,1307),(53249,1308),(53250,1309),(53251,1310),(53252,1311),(53253,1312),(53254,1313),(53255,1314),(53256,1315),(53257,1316),(53258,1317),(53259,1318),(53260,1319),(53261,1320),(53262,1321),(53263,1322),(53264,1323),(53265,1332),(53266,1342),(53267,1346),(53268,1347),(53269,1349),(53270,1350),(53271,1351),(53272,1353),(53273,1354),(53274,1355),(53275,1356),(53276,1357),(53277,1358),(53278,1359),(53279,1360),(53280,1361),(53281,1362),(53282,1363),(53283,1364),(53284,1366),(53285,1367),(53286,1368),(53287,1371),(53288,1375),(53289,1376),(53290,1377),(53291,1379),(53292,1389),(53293,1390),(53294,1391),(53295,1392),(53296,1393),(53297,1394),(53298,1395),(53299,1397),(53300,1398),(53301,1400),(53302,1420),(53303,1421),(53304,1422),(53305,1423),(53306,1424),(53307,1425),(53308,1427),(53309,1428),(53310,1429),(53311,1430),(53312,1431),(53313,1432),(53314,1433),(53315,1434),(53316,1435),(53317,1442),(53318,1443),(53319,1444),(53320,1445),(53321,1446),(53322,1447),(53323,1448),(53324,1450),(53325,1451),(53326,1452),(53327,1454),(53328,1455),(53329,1456),(53330,1457),(53331,1462),(53332,1469),(53333,1749),(53334,4500),(53335,4501),(53336,4502),(53337,4503),(53338,4504),(53339,4505),(53340,4506),(53341,4507),(53342,4508),(53343,4509),(53344,4510),(53345,4511),(53346,4512),(53347,4513),(53348,4514),(53349,4515),(53350,4516),(53351,4517),(53352,4518),(53353,4519),(53354,4520),(53355,4522),(53356,4523),(53357,5301),(53358,5468),(53359,5489),(53360,2154),(53361,2177),(53362,681),(53363,682),(53364,683),(53365,684),(53366,685),(53367,686),(53368,687),(53369,688),(53370,689),(53371,690),(53372,691),(53373,692),(53374,693),(53375,694),(53376,695),(53377,696),(53378,697),(53379,698),(53380,699),(53381,700),(53382,701),(53383,702),(53384,703),(53385,704),(53386,705),(53387,706),(53388,707),(53389,708),(53390,709),(53391,710),(53392,711),(53393,712),(53394,713),(53395,714),(53396,715),(53397,716),(53398,717),(53399,718),(53400,719),(53401,720),(53402,721),(53403,722),(53404,723),(53405,724),(53406,725),(53407,726),(53408,727),(53409,728),(53410,729),(53411,730),(53412,731),(53413,732),(53414,733),(53415,734),(53416,735),(53417,736),(53418,737),(53419,738),(53420,739),(53421,740),(53422,741),(53423,742),(53424,743),(53425,744),(53426,745),(53427,746),(53428,747),(53429,748),(53430,749),(53431,996),(53432,997),(53433,998),(53434,999),(53435,1000),(53436,1001),(53437,1002),(53438,1003),(53439,1005),(53440,1034),(53441,1035),(53442,1036),(53443,1038),(53444,1133),(53445,683),(53446,684),(53447,685),(53448,686),(53449,689),(53450,709),(53451,710),(53452,712),(53453,715),(53454,716),(53455,717),(53456,726),(53457,727),(53458,728),(53459,729),(53460,730),(53461,731),(53462,735),(53463,736),(53464,2221),(53465,2222),(53466,2221),(53467,2222),(53468,2221),(53469,2222),(53470,906),(53471,908),(53472,1004),(53473,1012),(53474,1019),(53475,1037),(53476,1092),(53477,1119),(53478,2524),(53479,2526),(53480,2299),(53481,2299),(53482,5757),(53483,5758),(53484,5759),(53485,362),(53486,363),(53487,364),(53488,365),(53489,366),(53490,367),(53491,368),(53492,369),(53493,398),(53494,399),(53495,400),(53496,401),(53497,402),(53498,403),(53499,404),(53500,405),(53501,406),(53502,407),(53503,408),(53504,409),(53505,410),(53506,411),(53507,412),(53508,413),(53509,414),(53510,415),(53511,416),(53512,417),(53513,418),(53514,419),(53515,420),(53516,421),(53517,422),(53518,423),(53519,424),(53520,425),(53521,426),(53522,427),(53523,428),(53524,429),(53525,430),(53526,431),(53527,432),(53528,433),(53529,434),(53530,435),(53531,436),(53532,437),(53533,438),(53534,439),(53535,440),(53536,441),(53537,442),(53538,443),(53539,444),(53540,445),(53541,446),(53542,447),(53543,448),(53544,449),(53545,450),(53546,451),(53547,452),(53548,453),(53549,454),(53550,455),(53551,456),(53552,457),(53553,458),(53554,459),(53555,460),(53556,461),(53557,462),(53558,463),(53559,464),(53560,465),(53561,466),(53562,467),(53563,468),(53564,469),(53565,470),(53566,471),(53567,472),(53568,473),(53569,474),(53570,475),(53571,476),(53572,477),(53573,478),(53574,479),(53575,480),(53576,481),(53577,482),(53578,483),(53579,484),(53580,485),(53581,486),(53582,487),(53583,488),(53584,489),(53585,490),(53586,491),(53587,492),(53588,493),(53589,494),(53590,495),(53591,496),(53592,497),(53593,498),(53594,499),(53595,500),(53596,501),(53597,502),(53598,503),(53599,504),(53600,505),(53601,506),(53602,507),(53603,508),(53604,509),(53605,510),(53606,511),(53607,512),(53608,513),(53609,514),(53610,515),(53611,516),(53612,517),(53613,518),(53614,519),(53615,520),(53616,521),(53617,522),(53618,523),(53619,524),(53620,525),(53621,526),(53622,527),(53623,528),(53624,529),(53625,530),(53626,531),(53627,532),(53628,560),(53629,611),(53630,613),(53631,614),(53632,615),(53633,616),(53634,617),(53635,618),(53636,619),(53637,620),(53638,621),(53639,622),(53640,623),(53641,624),(53642,625),(53643,632),(53644,633),(53645,634),(53646,635),(53647,636),(53648,637),(53649,638),(53650,639),(53651,640),(53652,641),(53653,642),(53654,643),(53655,644),(53656,645),(53657,646),(53658,647),(53659,648),(53660,649),(53661,650),(53662,651),(53663,652),(53664,653),(53665,655),(53666,656),(53667,657),(53668,658),(53669,659),(53670,660),(53671,661),(53672,662),(53673,663),(53674,664),(53675,665),(53676,666),(53677,667),(53678,669),(53679,670),(53680,671),(53681,672),(53682,673),(53683,674),(53684,675),(53685,676),(53686,677),(53687,678),(53688,679),(53689,680),(53690,1184),(53691,1185),(53692,1186),(53693,1187),(53694,1188),(53695,1189),(53696,1190),(53697,1191),(53698,1192),(53699,1193),(53700,1194),(53701,1208),(53702,1209),(53703,1324),(53704,1325),(53705,1326),(53706,1327),(53707,1328),(53708,1329),(53709,1330),(53710,1331),(53711,1333),(53712,1334),(53713,1335),(53714,1336),(53715,1337),(53716,1338),(53717,1339),(53718,1340),(53719,1341),(53720,1343),(53721,1344),(53722,1345),(53723,1348),(53724,1352),(53725,1365),(53726,1369),(53727,1370),(53728,1372),(53729,1373),(53730,1374),(53731,1378),(53732,1379),(53733,1380),(53734,1381),(53735,1382),(53736,1383),(53737,1384),(53738,1385),(53739,1386),(53740,1387),(53741,1388),(53742,1396),(53743,1399),(53744,1401),(53745,1402),(53746,1403),(53747,1404),(53748,1405),(53749,1406),(53750,1407),(53751,1408),(53752,1409),(53753,1410),(53754,1411),(53755,1412),(53756,1413),(53757,1414),(53758,1415),(53759,1416),(53760,1417),(53761,1418),(53762,1419),(53763,1426),(53764,1436),(53765,1437),(53766,1438),(53767,1439),(53768,1440),(53769,1441),(53770,1449),(53771,1453),(53772,1458),(53773,1459),(53774,1460),(53775,1461),(53776,1463),(53777,1464),(53778,1465),(53779,1466),(53780,1467),(53781,1468),(53782,1470),(53783,1471),(53784,1472),(53785,1488),(53786,1489),(53787,1490),(53788,1491),(53789,1492),(53790,1493),(53791,1494),(53792,1992),(53793,1993),(53794,1994),(53795,1995),(53796,1996),(53797,1997),(53798,1998),(53799,1999),(53800,2000),(53801,2001),(53802,2002),(53803,4521),(53804,4524),(53805,4525),(53806,4526),(53807,4527),(53808,4528),(53809,4529),(53810,4530),(53811,4531),(53812,4532),(53813,4533),(53814,4534),(53815,4535),(53816,4536),(53817,5271),(53818,5272),(53819,5273),(53820,5274),(53821,5282),(53822,5283),(53823,5284),(53824,527),(53825,528),(53826,529),(53827,530),(53828,531),(53829,532),(53830,560),(53831,611),(53832,613),(53833,617),(53834,618),(53835,619),(53836,624),(53837,625),(53838,632),(53839,636),(53840,637),(53841,639),(53842,646),(53843,648),(53844,652),(53845,659),(53846,660),(53847,670),(53848,362),(53849,363),(53850,364),(53851,365),(53852,366),(53853,367),(53854,368),(53855,369),(53856,398),(53857,399),(53858,403),(53859,404),(53860,405),(53861,406),(53862,407),(53863,411),(53864,412),(53865,413),(53866,414),(53867,420),(53868,421),(53869,424),(53870,425),(53871,431),(53872,458),(53873,462),(53874,469),(53875,470),(53876,471),(53877,475),(53878,481),(53879,500),(53880,517),(53881,519),(53882,520),(53883,614),(53884,616),(53885,635),(53886,643),(53887,644),(53888,645),(53889,650),(53890,656),(53891,661),(53892,663),(53893,665),(53894,666),(53895,669),(53896,671),(53897,673),(53898,675),(53899,676),(53900,677),(53901,678),(53902,679),(53903,680),(53904,1184),(53905,1185),(53906,1186),(53907,1187),(53908,1188),(53909,1189),(53910,1190),(53911,1191),(53912,1192),(53913,1193),(53914,1194),(53915,1208),(53916,1209),(53917,1324),(53918,1325),(53919,1326),(53920,1327),(53921,1328),(53922,1329),(53923,1330),(53924,1331),(53925,1333),(53926,1334),(53927,1335),(53928,1336),(53929,1337),(53930,1338),(53931,1339),(53932,1340),(53933,1341),(53934,1343),(53935,1344),(53936,1345),(53937,1348),(53938,1352),(53939,1365),(53940,1369),(53941,1370),(53942,1372),(53943,1373),(53944,1374),(53945,1378),(53946,1379),(53947,1380),(53948,1381),(53949,1382),(53950,1383),(53951,1384),(53952,1385),(53953,1386),(53954,1387),(53955,1388),(53956,1396),(53957,1399),(53958,1401),(53959,1402),(53960,1403),(53961,1404),(53962,1405),(53963,1406),(53964,1407),(53965,1408),(53966,1409),(53967,1410),(53968,1411),(53969,1412),(53970,1413),(53971,1414),(53972,1415),(53973,1416),(53974,1417),(53975,1418),(53976,1419),(53977,1426),(53978,1436),(53979,1437),(53980,1438),(53981,1439),(53982,1440),(53983,1441),(53984,1449),(53985,1453),(53986,1458),(53987,1459),(53988,1460),(53989,1461),(53990,1463),(53991,1464),(53992,1465),(53993,1466),(53994,1467),(53995,1468),(53996,1470),(53997,1471),(53998,1472),(53999,1488),(54000,1489),(54001,1490),(54002,1491),(54003,1492),(54004,1493),(54005,1494),(54006,1992),(54007,1993),(54008,1994),(54009,1995),(54010,1996),(54011,1997),(54012,1998),(54013,1999),(54014,2000),(54015,2001),(54016,2002),(54017,4521),(54018,4524),(54019,4525),(54020,4526),(54021,4527),(54022,4528),(54023,4529),(54024,4530),(54025,4531),(54026,4532),(54027,4533),(54028,4534),(54029,4535),(54030,4536),(54031,5271),(54032,5272),(54033,5273),(54034,5274),(54035,5282),(54036,5283),(54037,5284),(54038,374),(54039,375),(54040,376),(54041,533),(54042,534),(54043,535),(54044,536),(54045,537),(54046,538),(54047,539),(54048,540),(54049,541),(54050,542),(54051,543),(54052,544),(54053,545),(54054,546),(54055,547),(54056,548),(54057,549),(54058,550),(54059,551),(54060,552),(54061,553),(54062,554),(54063,555),(54064,558),(54065,559),(54066,561),(54067,562),(54068,564),(54069,566),(54070,571),(54071,572),(54072,573),(54073,574),(54074,575),(54075,576),(54076,577),(54077,578),(54078,579),(54079,580),(54080,581),(54081,582),(54082,585),(54083,586),(54084,587),(54085,588),(54086,589),(54087,590),(54088,591),(54089,592),(54090,593),(54091,594),(54092,595),(54093,596),(54094,598),(54095,600),(54096,601),(54097,602),(54098,603),(54099,604),(54100,605),(54101,609),(54102,610),(54103,612),(54104,754),(54105,755),(54106,756),(54107,757),(54108,758),(54109,759),(54110,760),(54111,761),(54112,762),(54113,763),(54114,764),(54115,765),(54116,766),(54117,767),(54118,768),(54119,769),(54120,770),(54121,771),(54122,772),(54123,773),(54124,774),(54125,775),(54126,776),(54127,778),(54128,779),(54129,780),(54130,781),(54131,782),(54132,783),(54133,784),(54134,785),(54135,786),(54136,787),(54137,788),(54138,790),(54139,791),(54140,794),(54141,796),(54142,797),(54143,805),(54144,806),(54145,807),(54146,808),(54147,809),(54148,810),(54149,811),(54150,812),(54151,813),(54152,814),(54153,816),(54154,817),(54155,818),(54156,819),(54157,820),(54158,821),(54159,822),(54160,824),(54161,826),(54162,827),(54163,828),(54164,829),(54165,834),(54166,835),(54167,836),(54168,837),(54169,838),(54170,839),(54171,840),(54172,841),(54173,842),(54174,843),(54175,844),(54176,845),(54177,846),(54178,847),(54179,848),(54180,849),(54181,850),(54182,851),(54183,852),(54184,853),(54185,854),(54186,855),(54187,856),(54188,857),(54189,858),(54190,862),(54191,864),(54192,865),(54193,1020),(54194,1021),(54195,1022),(54196,1023),(54197,1106),(54198,1166),(54199,1167),(54200,1169),(54201,1184),(54202,1238),(54203,1268),(54204,1294),(54205,1378),(54206,1389),(54207,1462),(54208,2154),(54209,2177),(54210,2221),(54211,2222),(54212,2299),(54213,5361),(54214,5362),(54215,5364),(54216,5622),(54217,5626),(54218,5639),(54219,5640),(54220,5641),(54221,5648),(54222,5665),(54223,5666),(54224,5667),(54225,1972),(54226,1973),(54227,1978),(54228,1981),(54229,1982),(54230,1983),(54231,1988),(54232,2037),(54233,1814),(54234,1817),(54235,1819),(54236,1823),(54237,1826),(54238,1830),(54239,1832),(54240,1835),(54241,1975),(54242,1977),(54243,1979),(54244,1980),(54245,1985),(54246,1987),(54247,1991),(54248,2189),(54249,2196),(54250,2201),(54251,2202),(54252,2208),(54253,2209),(54254,2214),(54255,2215),(54256,2216),(54257,2217),(54258,2218),(54259,2219),(54260,2220),(54261,2232),(54262,2233),(54263,2234),(54264,2236),(54265,2237),(54266,2238),(54267,2239),(54268,2258),(54269,2259),(54270,2261),(54271,2262),(54272,2321),(54273,2322),(54274,2392),(54275,2393),(54276,2394),(54277,2395),(54278,2464),(54279,2589),(54280,2591),(54281,2592),(54282,2318),(54283,2399),(54284,2400),(54285,2401),(54286,2614),(54287,2060),(54288,2139),(54289,2140),(54290,2141),(54291,2142),(54292,2143),(54293,2317),(54294,2398),(54295,2409),(54296,2611),(54297,4613),(54298,4614),(54299,2460),(54300,2461),(54301,2462),(54302,2463),(54303,2464),(54304,2504),(54305,2505),(54306,4573),(54307,4574),(54308,4575),(54309,4576),(54310,4605),(54311,4606),(54312,4607),(54313,4609),(54314,4610),(54315,4611),(54316,4625),(54317,4626),(54318,4805),(54319,4806),(54320,4807),(54321,4808),(54322,4824),(54323,4825),(54324,4826),(54325,4827),(54326,4828),(54327,4829),(54328,4830),(54329,4831),(54330,4832),(54331,4833),(54332,4912),(54333,4913),(54334,4914),(54335,4915),(54336,4916),(54337,4917),(54338,4918),(54339,4919),(54340,4920),(54341,4921),(54342,4922),(54343,4923),(54344,4924),(54345,4925),(54346,4926),(54347,4927),(54348,4928),(54349,4929),(54350,4930),(54351,4931),(54352,4932),(54353,4963),(54354,4964),(54355,4965),(54356,4966),(54357,5017),(54358,5018),(54359,5073),(54360,5074),(54361,5075),(54362,5076),(54363,5091),(54364,5092),(54365,5132),(54366,5133),(54367,5134),(54368,5135),(54369,5143),(54370,5144),(54371,5145),(54372,5146),(54373,5169),(54374,5170),(54375,5172),(54376,5173),(54377,5174),(54378,5175),(54379,5176),(54380,5177),(54381,5184),(54382,5185),(54383,5200),(54384,5201),(54385,5238),(54386,5239),(54387,5240),(54388,5241),(54389,5242),(54390,5243),(54391,5244),(54392,5245),(54393,5246),(54394,5247),(54395,4573),(54396,4574),(54397,4575),(54398,4576),(54399,4605),(54400,4606),(54401,4607),(54402,4609),(54403,4610),(54404,4611),(54405,4625),(54406,4626),(54407,4805),(54408,4806),(54409,4807),(54410,4808),(54411,4824),(54412,4825),(54413,4826),(54414,4827),(54415,4828),(54416,4829),(54417,4830),(54418,4831),(54419,4832),(54420,4833),(54421,4912),(54422,4913),(54423,4914),(54424,4915),(54425,4916),(54426,4917),(54427,4918),(54428,4919),(54429,4920),(54430,4921),(54431,4922),(54432,4923),(54433,4924),(54434,4925),(54435,4926),(54436,4927),(54437,4928),(54438,4929),(54439,4930),(54440,4931),(54441,4932),(54442,4959),(54443,4963),(54444,4964),(54445,4965),(54446,4966),(54447,5017),(54448,5018),(54449,5073),(54450,5074),(54451,5075),(54452,5076),(54453,5091),(54454,5092),(54455,5132),(54456,5133),(54457,5134),(54458,5135),(54459,5143),(54460,5144),(54461,5145),(54462,5146),(54463,5169),(54464,5170),(54465,5172),(54466,5173),(54467,5174),(54468,5175),(54469,5176),(54470,5177),(54471,5184),(54472,5185),(54473,5200),(54474,5201),(54475,5238),(54476,5239),(54477,5240),(54478,5241),(54479,5242),(54480,5243),(54481,5244),(54482,5245),(54483,5246),(54484,5247),(54485,4721),(54486,4725),(54487,4728),(54488,5140),(54489,5141),(54490,2591),(54491,2592),(54492,1828),(54493,1829),(54494,1831),(54495,1950),(54496,1951),(54497,1952),(54498,4896),(54499,4898),(54500,4899),(54501,4900),(54502,4901),(54503,4902),(54504,4903),(54505,4904),(54506,4905),(54507,4906),(54508,4907),(54509,4908),(54510,4909),(54511,4910),(54512,4911),(54513,5020),(54514,1679),(54515,1680),(54516,5021),(54517,5023),(54518,5026),(54519,5027),(54520,4972),(54521,4973),(54522,4974),(54523,4975),(54524,4976),(54525,4977),(54526,4978),(54527,4983),(54528,4984),(54529,4985),(54530,4986),(54531,4987),(54532,4988),(54533,4989),(54534,4990),(54535,4991),(54536,4996),(54537,4997),(54538,4998),(54539,4999),(54540,5000),(54541,5002),(54542,5005),(54543,5008),(54544,5011),(54545,5012),(54546,5013),(54547,5014),(54548,5015),(54549,5016),(54550,5020),(54551,4972),(54552,4973),(54553,4974),(54554,4975),(54555,4976),(54556,4977),(54557,4978),(54558,4983),(54559,4984),(54560,4985),(54561,4986),(54562,4987),(54563,4988),(54564,4989),(54565,4990),(54566,4991),(54567,4996),(54568,4997),(54569,4998),(54570,5000),(54571,5002),(54572,5004),(54573,5005),(54574,5008),(54575,5011),(54576,5012),(54577,5013),(54578,5014),(54579,5015),(54580,5016),(54581,4973),(54582,4974),(54583,4975),(54584,4976),(54585,4977),(54586,4978),(54587,4983),(54588,4984),(54589,4985),(54590,4986),(54591,4987),(54592,4988),(54593,4989),(54594,4990),(54595,4991),(54596,4996),(54597,4997),(54598,4998),(54599,4999),(54600,5000),(54601,5002),(54602,5004),(54603,5005),(54604,5008),(54605,5011),(54606,5012),(54607,5013),(54608,5014),(54609,5015),(54610,5016),(54611,4972),(54612,4973),(54613,4974),(54614,4975),(54615,4976),(54616,4977),(54617,4978),(54618,4983),(54619,4984),(54620,4985),(54621,4986),(54622,4987),(54623,4988),(54624,4989),(54625,4990),(54626,4991),(54627,4996),(54628,4997),(54629,4998),(54630,4999),(54631,5000),(54632,5002),(54633,5004),(54634,5005),(54635,5008),(54636,5011),(54637,5012),(54638,5013),(54639,5014),(54640,5015),(54641,5016),(54642,4896),(54643,4898),(54644,4899),(54645,4900),(54646,4901),(54647,4902),(54648,4903),(54649,4904),(54650,4905),(54651,4906),(54652,4907),(54653,4908),(54654,4909),(54655,4910),(54656,4911),(54657,4971),(54658,4974),(54659,4975),(54660,4978),(54661,4979),(54662,4980),(54663,4981),(54664,4982),(54665,4992),(54666,4993),(54667,4994),(54668,4995),(54669,5001),(54670,5003),(54671,5004),(54672,5006),(54673,5007),(54674,5009),(54675,5010),(54676,5019),(54677,5020),(54678,5022),(54679,5024),(54680,5025),(54681,4974),(54682,1748),(54683,255),(54684,256),(54685,257),(54686,1812),(54687,5620),(54688,5745),(54689,5746),(54690,5747),(54691,5748),(54692,5749),(54693,5179),(54694,5182),(54695,5190),(54696,5194),(54697,5195),(54698,5196),(54699,5197),(54700,5198),(54701,5199),(54702,5198),(54703,1579),(54704,1580),(54705,1581),(54706,1582),(54707,1583),(54708,1803),(54709,1804),(54710,1807),(54711,1808),(54712,1809),(54713,1810),(54714,1811),(54715,2201),(54716,2202),(54717,2214),(54718,2215),(54719,2216),(54720,2217),(54721,2218),(54722,2219),(54723,2220),(54724,2251),(54725,2258),(54726,2259),(54727,2260),(54728,2261),(54729,2262),(54730,2265),(54731,2266),(54732,2267),(54733,2268),(54734,2269),(54735,2276),(54736,2307),(54737,2308),(54738,2309),(54739,2310),(54740,2311),(54741,2312),(54742,2313),(54743,2314),(54744,2315),(54745,2316),(54746,2317),(54747,2318),(54748,2319),(54749,2320),(54750,2321),(54751,2322),(54752,2460),(54753,2461),(54754,2462),(54755,2463),(54756,2464),(54757,2504),(54758,2505),(54759,4628),(54760,4668),(54761,4669),(54762,4670),(54763,4671),(54764,4672),(54765,4673),(54766,4674),(54767,4675),(54768,4676),(54769,4680),(54770,4687),(54771,4688),(54772,4689),(54773,4690),(54774,4691),(54775,4692),(54776,4693),(54777,4694),(54778,4695),(54779,4696),(54780,4697),(54781,4698),(54782,4699),(54783,4700),(54784,4701),(54785,4702),(54786,4703),(54787,4704),(54788,4705),(54789,4706),(54790,4707),(54791,4708),(54792,4709),(54793,4710),(54794,4711),(54795,4712),(54796,4713),(54797,4907),(54798,4908),(54799,4909),(54800,4911),(54801,4974),(54802,4975),(54803,4976),(54804,4977),(54805,4978),(54806,5003),(54807,5004),(54808,5005),(54809,5006),(54810,5007),(54811,5008),(54812,5009),(54813,5010),(54814,5011),(54815,5012),(54816,5013),(54817,5014),(54818,5015),(54819,5016),(54820,5024),(54821,5025),(54822,5026),(54823,5027),(54824,5122),(54825,5123),(54826,5124),(54827,5125),(54828,5126),(54829,5127),(54830,5128),(54831,5129),(54832,5130),(54833,5131),(54834,5136),(54835,5137),(54836,5138),(54837,5139),(54838,5140),(54839,5141),(54840,5142),(54841,5147),(54842,5148),(54843,5149),(54844,5150),(54845,5159),(54846,5160),(54847,5161),(54848,5162),(54849,5163),(54850,5164),(54851,5165),(54852,5166),(54853,5167),(54854,5168),(54855,5190),(54856,5191),(54857,5192),(54858,5193),(54859,5194),(54860,5197),(54861,4974),(54862,5026),(54863,5166),(54864,1679),(54865,1680),(54866,1708),(54867,1709),(54868,1710),(54869,1711),(54870,1712),(54871,1713),(54872,1714),(54873,1748),(54874,1791),(54875,1792),(54876,1798),(54877,2187),(54878,2188),(54879,2189),(54880,2190),(54881,2191),(54882,2192),(54883,2193),(54884,2194),(54885,2195),(54886,2196),(54887,2197),(54888,2198),(54889,2232),(54890,2233),(54891,2234),(54892,2235),(54893,2236),(54894,2237),(54895,2238),(54896,2239),(54897,2240),(54898,2392),(54899,2393),(54900,2394),(54901,2395),(54902,2411),(54903,2412),(54904,2577),(54905,2578),(54906,2579),(54907,2580),(54908,2581),(54909,2589),(54910,2590),(54911,2591),(54912,2592),(54913,2593),(54914,2594),(54915,2595),(54916,2596),(54917,2597),(54918,2598),(54919,2599),(54920,2600),(54921,2601),(54922,2602),(54923,2603),(54924,2604),(54925,2605),(54926,2606),(54927,2607),(54928,2608),(54929,2609),(54930,2610),(54931,2611),(54932,2612),(54933,2613),(54934,2614),(54935,4621),(54936,4629),(54937,4630),(54938,4631),(54939,4632),(54940,4633),(54941,4634),(54942,4635),(54943,4636),(54944,4637),(54945,4638),(54946,4639),(54947,4640),(54948,4641),(54949,4642),(54950,4643),(54951,4644),(54952,4645),(54953,4646),(54954,4647),(54955,4648),(54956,4649),(54957,4650),(54958,4651),(54959,4652),(54960,4653),(54961,4654),(54962,4655),(54963,4656),(54964,4657),(54965,4658),(54966,4659),(54967,4660),(54968,4661),(54969,4662),(54970,4663),(54971,4664),(54972,4665),(54973,4666),(54974,4667),(54975,4896),(54976,4898),(54977,4900),(54978,4902),(54979,4903),(54980,4904),(54981,4943),(54982,4944),(54983,4945),(54984,4946),(54985,4947),(54986,4948),(54987,4949),(54988,4950),(54989,4951),(54990,4952),(54991,4953),(54992,4954),(54993,4971),(54994,4972),(54995,4973),(54996,4979),(54997,4980),(54998,4981),(54999,4982),(55000,4983),(55001,4984),(55002,4985),(55003,4986),(55004,4987),(55005,4988),(55006,4989),(55007,4990),(55008,4991),(55009,5001),(55010,5002),(55011,5105),(55012,5178),(55013,5179),(55014,5180),(55015,5181),(55016,5182),(55017,5202),(55018,5203),(55019,5204),(55020,5205),(55021,5206),(55022,5207),(55023,5208),(55024,5209),(55025,5210),(55026,5211),(55027,5212),(55028,5213),(55029,5214),(55030,5215),(55031,5216),(55032,5217),(55033,5218),(55034,5219),(55035,5220),(55036,5221),(55037,5222),(55038,5223),(55039,5224),(55040,5225),(55041,5226),(55042,5227),(55043,5228),(55044,5229),(55045,5230),(55046,5231),(55047,5232),(55048,5233),(55049,5234),(55050,5235),(55051,5236),(55052,5237),(55053,1575),(55054,1576),(55055,1577),(55056,1578),(55057,1805),(55058,1806),(55059,2200),(55060,2208),(55061,2209),(55062,2210),(55063,2245),(55064,2246),(55065,2256),(55066,2257),(55067,2302),(55068,2303),(55069,2304),(55070,2305),(55071,2306),(55072,2396),(55073,2397),(55074,2398),(55075,2399),(55076,2400),(55077,2401),(55078,2402),(55079,2403),(55080,2404),(55081,2405),(55082,2406),(55083,2407),(55084,2408),(55085,2409),(55086,2410),(55087,2458),(55088,2459),(55089,2503),(55090,4627),(55091,4714),(55092,4715),(55093,4716),(55094,4717),(55095,4719),(55096,4720),(55097,4721),(55098,4722),(55099,4723),(55100,4724),(55101,4725),(55102,4726),(55103,4727),(55104,4728),(55105,4729),(55106,4809),(55107,4810),(55108,4811),(55109,4823),(55110,4843),(55111,4844),(55112,4846),(55113,4847),(55114,4848),(55115,4849),(55116,4850),(55117,4851),(55118,4852),(55119,4856),(55120,4899),(55121,4901),(55122,4905),(55123,4906),(55124,4910),(55125,4992),(55126,4993),(55127,4994),(55128,4995),(55129,4996),(55130,4997),(55131,4998),(55132,4999),(55133,5000),(55134,5019),(55135,5020),(55136,5021),(55137,5022),(55138,5023),(55139,5039),(55140,5040),(55141,5041),(55142,5042),(55143,5043),(55144,5044),(55145,5045),(55146,5046),(55147,5047),(55148,5048),(55149,5049),(55150,5050),(55151,5051),(55152,5052),(55153,5053),(55154,5054),(55155,5055),(55156,5056),(55157,5057),(55158,5058),(55159,5059),(55160,5060),(55161,5061),(55162,5065),(55163,5066),(55164,5067),(55165,5068),(55166,5069),(55167,5070),(55168,5071),(55169,5072),(55170,5195),(55171,5196),(55172,5198),(55173,5199),(55174,4613),(55175,4614),(55176,4857),(55177,4858),(55178,4859),(55179,4860),(55180,4861),(55181,4862),(55182,4863),(55183,4864),(55184,4865),(55185,4866),(55186,4867),(55187,4868),(55188,4869),(55189,4870),(55190,4871),(55191,4874),(55192,4875),(55193,4876),(55194,4891),(55195,4892),(55196,4893),(55197,4894),(55198,2435),(55199,4731),(55200,4732),(55201,4733),(55202,4734),(55203,4735),(55204,4736),(55205,4737),(55206,4738),(55207,4739),(55208,4740),(55209,4741),(55210,4742),(55211,4743),(55212,4744),(55213,4745),(55214,4746),(55215,4747),(55216,4748),(55217,4749),(55218,4750),(55219,4751),(55220,4752),(55221,4753),(55222,4754),(55223,4755),(55224,4756),(55225,4757),(55226,4758),(55227,4759),(55228,4760),(55229,4761),(55230,4762),(55231,4763),(55232,4764),(55233,4765),(55234,4766),(55235,4767),(55236,4768),(55237,4769),(55238,4770),(55239,4771),(55240,4772),(55241,4773),(55242,4774),(55243,4775),(55244,4776),(55245,4777),(55246,4778),(55247,4779),(55248,4780),(55249,4781),(55250,4782),(55251,4783),(55252,4784),(55253,4785),(55254,4786),(55255,4787),(55256,4788),(55257,4789),(55258,4790),(55259,4791),(55260,4792),(55261,4793),(55262,4794),(55263,4795),(55264,4796),(55265,4797),(55266,4798),(55267,4799),(55268,4800),(55269,4801),(55270,4802),(55271,4803),(55272,4804),(55273,4957),(55274,4958),(55275,4960),(55276,4961),(55277,4962),(55278,5106),(55279,5107),(55280,5108),(55281,5109),(55282,2435),(55283,1538),(55284,1539),(55285,1543),(55286,1544),(55287,1561),(55288,5154),(55289,5155),(55290,1763),(55291,1497),(55292,1512),(55293,1590),(55294,1595),(55295,1596),(55296,1597),(55297,1599),(55298,1729),(55299,1732),(55300,1734),(55301,1149),(55302,1150),(55303,1475),(55304,1476),(55305,1480),(55306,1481),(55307,1482),(55308,1483),(55309,1510),(55310,1537),(55311,1538),(55312,1539),(55313,1540),(55314,1542),(55315,1543),(55316,1545),(55317,1546),(55318,1547),(55319,1548),(55320,1549),(55321,1550),(55322,1551),(55323,1552),(55324,1553),(55325,1554),(55326,1555),(55327,1560),(55328,1613),(55329,1616),(55330,1617),(55331,1655),(55332,1657),(55333,1706),(55334,1715),(55335,1716),(55336,1717),(55337,1718),(55338,1719),(55339,1720),(55340,1722),(55341,1723),(55342,1724),(55343,1725),(55344,1735),(55345,1765),(55346,1766),(55347,1767),(55348,1768),(55349,1770),(55350,1771),(55351,1776),(55352,1777),(55353,1783),(55354,1812),(55355,1149),(55356,1150),(55357,1477),(55358,1480),(55359,1483),(55360,1486),(55361,1487),(55362,1495),(55363,1496),(55364,1499),(55365,1500),(55366,1502),(55367,1505),(55368,1509),(55369,1537),(55370,1538),(55371,1539),(55372,1540),(55373,1541),(55374,1544),(55375,1546),(55376,1547),(55377,1548),(55378,1549),(55379,1550),(55380,1551),(55381,1552),(55382,1553),(55383,1554),(55384,1555),(55385,1556),(55386,1560),(55387,1561),(55388,1612),(55389,1614),(55390,1705),(55391,1776),(55392,1777),(55393,1796),(55394,5154),(55395,5155),(55396,377),(55397,378),(55398,380),(55399,382),(55400,385),(55401,386),(55402,387),(55403,389),(55404,391),(55405,397),(55406,569),(55407,584),(55408,607),(55409,608),(55410,774),(55411,791),(55412,792),(55413,795),(55414,800),(55415,801),(55416,818),(55417,823),(55418,831),(55419,860),(55420,867),(55421,868),(55422,893),(55423,1174),(55424,1175),(55425,1176),(55426,1177),(55427,1178),(55428,1179),(55429,1180),(55430,1185),(55431,1186),(55432,1187),(55433,1190),(55434,1192),(55435,1193),(55436,1194),(55437,1470),(55438,1471),(55439,1472),(55440,1494),(55441,1518),(55442,1519),(55443,1520),(55444,1521),(55445,1563),(55446,1564),(55447,1565),(55448,1665),(55449,1675),(55450,1676),(55451,1677),(55452,1678),(55453,1747),(55454,1751),(55455,1752),(55456,1753),(55457,1761),(55458,1762),(55459,1772),(55460,1778),(55461,1779),(55462,4880),(55463,4884),(55464,4885),(55465,5274),(55466,5336),(55467,5524),(55468,4536),(55469,904),(55470,905),(55471,1816),(55472,1818),(55473,1822),(55474,1966),(55475,1967),(55476,1968),(55477,1969),(55478,1970),(55479,1971),(55480,2013),(55481,2265),(55482,2266),(55483,2267),(55484,2268),(55485,2269),(55486,2276),(55487,2319),(55488,2320),(55489,2397),(55490,2400),(55491,2401),(55492,2409),(55493,2410),(55494,2589),(55495,2590),(55496,2591),(55497,2593),(55498,2597),(55499,2599),(55500,2601),(55501,2602),(55502,2603),(55503,2604),(55504,2605),(55505,2606),(55506,2607),(55507,2608),(55508,2609),(55509,2610),(55510,2612),(55511,1813),(55512,1814),(55513,1815),(55514,1816),(55515,1817),(55516,1818),(55517,1819),(55518,1820),(55519,1821),(55520,1822),(55521,1823),(55522,1824),(55523,1825),(55524,1826),(55525,1950),(55526,1951),(55527,1952),(55528,2435),(55529,4539),(55530,4540),(55531,4541),(55532,4542),(55533,4543),(55534,4544),(55535,4545),(55536,4546),(55537,4547),(55538,4548),(55539,4549),(55540,4550),(55541,4551),(55542,4552),(55543,4553),(55544,4554),(55545,4555),(55546,4556),(55547,4557),(55548,4558),(55549,4559),(55550,4560),(55551,4561),(55552,4562),(55553,4563),(55554,4564),(55555,4565),(55556,4933),(55557,4970),(55558,5151),(55559,5152),(55560,5153),(55561,5154),(55562,5155),(55563,5156),(55564,5157),(55565,5158),(55566,5183),(55567,5248),(55568,5249),(55569,4559),(55570,4560),(55571,4561),(55572,4562),(55573,4563),(55574,4564),(55575,4565),(55576,4933),(55577,5151),(55578,5152),(55579,5153),(55580,5154),(55581,5155),(55582,5156),(55583,5157),(55584,5158),(55585,5183),(55586,5248),(55587,5249),(55588,163),(55589,164),(55590,165),(55591,166),(55592,167),(55593,168),(55594,172),(55595,254),(55596,255),(55597,256),(55598,257),(55599,1049),(55600,1050),(55601,1051),(55602,1052),(55603,1053),(55604,1054),(55605,1055),(55606,1056),(55607,1057),(55608,1058),(55609,1059),(55610,1060),(55611,1061),(55612,1062),(55613,1063),(55614,1064),(55615,1065),(55616,1066),(55617,1067),(55618,1068),(55619,1069),(55620,1070),(55621,1071),(55622,1072),(55623,1073),(55624,1074),(55625,1075),(55626,1076),(55627,1077),(55628,1078),(55629,1079),(55630,1080),(55631,1081),(55632,1082),(55633,1083),(55634,1084),(55635,1085),(55636,1086),(55637,1087),(55638,1088),(55639,1089),(55640,1090),(55641,1091),(55642,1611),(55643,1612),(55644,1613),(55645,1614),(55646,1615),(55647,1616),(55648,1617),(55649,1654),(55650,1655),(55651,1656),(55652,1657),(55653,1705),(55654,1706),(55655,1707),(55656,1739),(55657,1741),(55658,1742),(55659,1759),(55660,1760),(55661,1764),(55662,1765),(55663,1766),(55664,1767),(55665,1768),(55666,1769),(55667,1770),(55668,1771),(55669,1772),(55670,1774),(55671,1775),(55672,1776),(55673,1777),(55674,1783),(55675,1784),(55676,1785),(55677,1812),(55678,1959),(55679,1960),(55680,1961),(55681,1962),(55682,1963),(55683,1964),(55684,2289),(55685,2290),(55686,2291),(55687,2293),(55688,2413),(55689,2414),(55690,2415),(55691,2416),(55692,2417),(55693,2418),(55694,2419),(55695,2420),(55696,2421),(55697,2422),(55698,2423),(55699,2424),(55700,2425),(55701,2426),(55702,2427),(55703,2428),(55704,2517),(55705,2518),(55706,2519),(55707,2520),(55708,2537),(55709,2538),(55710,4622),(55711,4623),(55712,4624),(55713,4853),(55714,4854),(55715,4855),(55716,4877),(55717,4878),(55718,4879),(55719,4880),(55720,4881),(55721,4882),(55722,4883),(55723,4884),(55724,4885),(55725,4886),(55726,4887),(55727,4888),(55728,4889),(55729,4890),(55730,5368),(55731,5408),(55732,5410),(55733,5411),(55734,5412),(55735,5413),(55736,5414),(55737,5415),(55738,5416),(55739,5417),(55740,5418),(55741,5419),(55742,5428),(55743,5469),(55744,5470),(55745,5471),(55746,5472),(55747,5473),(55748,5538),(55749,5539),(55750,5540),(55751,5541),(55752,5542),(55753,5543),(55754,5544),(55755,5545),(55756,5546),(55757,5547),(55758,5548),(55759,5549),(55760,5550),(55761,5571),(55762,5591),(55763,5592),(55764,5593),(55765,5594),(55766,5595),(55767,5596),(55768,5597),(55769,5598),(55770,5599),(55771,5600),(55772,5601),(55773,5602),(55774,5603),(55775,5604),(55776,5605),(55777,5606),(55778,5607),(55779,5608),(55780,5609),(55781,5610),(55782,5611),(55783,5612),(55784,5613),(55785,5614),(55786,5615),(55787,5616),(55788,5617),(55789,5618),(55790,5619),(55791,5620),(55792,5621),(55793,5622),(55794,5623),(55795,5624),(55796,5625),(55797,5626),(55798,5627),(55799,5628),(55800,5629),(55801,5630),(55802,5631),(55803,5632),(55804,5633),(55805,5634),(55806,5635),(55807,5636),(55808,5637),(55809,5638),(55810,5639),(55811,5640),(55812,5641),(55813,5642),(55814,5643),(55815,5644),(55816,5645),(55817,5646),(55818,5647),(55819,5648),(55820,5649),(55821,5650),(55822,5651),(55823,5652),(55824,5653),(55825,5654),(55826,5655),(55827,5656),(55828,5657),(55829,5658),(55830,5659),(55831,5660),(55832,5661),(55833,5662),(55834,5663),(55835,5664),(55836,5665),(55837,5666),(55838,5667),(55839,5668),(55840,5669),(55841,5670),(55842,5671),(55843,5672),(55844,5682),(55845,5683),(55846,5684),(55847,5685),(55848,5686),(55849,5687),(55850,5688),(55851,5690),(55852,5691),(55853,5692),(55854,5693),(55855,5694),(55856,5695),(55857,5697),(55858,5698),(55859,5699),(55860,5700),(55861,5701),(55862,5709),(55863,5710),(55864,5711),(55865,5712),(55866,5713),(55867,5714),(55868,5715),(55869,5716),(55870,5717),(55871,5718),(55872,5719),(55873,5720),(55874,5721),(55875,5722),(55876,5723),(55877,5724),(55878,5725),(55879,5726),(55880,5727),(55881,5728),(55882,5729),(55883,5730),(55884,5731),(55885,5732),(55886,5733),(55887,5734),(55888,5735),(55889,5736),(55890,5737),(55891,5745),(55892,5746),(55893,5747),(55894,5748),(55895,5749),(55896,163),(55897,164),(55898,165),(55899,166),(55900,167),(55901,168),(55902,172),(55903,254),(55904,255),(55905,256),(55906,257),(55907,1049),(55908,1050),(55909,1051),(55910,1052),(55911,1053),(55912,1054),(55913,1055),(55914,1056),(55915,1057),(55916,1058),(55917,1059),(55918,1060),(55919,1061),(55920,1062),(55921,1063),(55922,1064),(55923,1065),(55924,1066),(55925,1067),(55926,1068),(55927,1069),(55928,1070),(55929,1071),(55930,1072),(55931,1073),(55932,1074),(55933,1075),(55934,1076),(55935,1077),(55936,1078),(55937,1079),(55938,1080),(55939,1081),(55940,1082),(55941,1083),(55942,1084),(55943,1085),(55944,1086),(55945,1087),(55946,1088),(55947,1089),(55948,1090),(55949,1091),(55950,1611),(55951,1612),(55952,1614),(55953,1616),(55954,1617),(55955,1655),(55956,1656),(55957,1705),(55958,1706),(55959,1707),(55960,1739),(55961,1741),(55962,1742),(55963,1759),(55964,1760),(55965,1764),(55966,1765),(55967,1769),(55968,1772),(55969,1776),(55970,1777),(55971,1783),(55972,1959),(55973,1960),(55974,1961),(55975,1962),(55976,1963),(55977,1964),(55978,2290),(55979,2291),(55980,2293),(55981,2413),(55982,2414),(55983,2415),(55984,2416),(55985,2417),(55986,2418),(55987,2419),(55988,2420),(55989,2421),(55990,2422),(55991,2423),(55992,2424),(55993,2425),(55994,2426),(55995,2427),(55996,2428),(55997,2517),(55998,2518),(55999,2519),(56000,2520),(56001,2537),(56002,2538),(56003,4539),(56004,4540),(56005,4541),(56006,4542),(56007,4543),(56008,4544),(56009,4545),(56010,4546),(56011,4547),(56012,4548),(56013,4549),(56014,4550),(56015,4551),(56016,4552),(56017,4553),(56018,4554),(56019,4555),(56020,4556),(56021,4557),(56022,4558),(56023,4622),(56024,4623),(56025,4624),(56026,4853),(56027,4854),(56028,4855),(56029,4877),(56030,4878),(56031,4879),(56032,4880),(56033,4882),(56034,4883),(56035,4884),(56036,4885),(56037,4886),(56038,4887),(56039,4888),(56040,4890),(56041,4970),(56042,5368),(56043,5408),(56044,5410),(56045,5411),(56046,5412),(56047,5413),(56048,5414),(56049,5415),(56050,5416),(56051,5417),(56052,5418),(56053,5419),(56054,5428),(56055,5469),(56056,5470),(56057,5471),(56058,5472),(56059,5473),(56060,5538),(56061,5539),(56062,5540),(56063,5541),(56064,5542),(56065,5543),(56066,5544),(56067,5545),(56068,5546),(56069,5547),(56070,5548),(56071,5549),(56072,5550),(56073,5571),(56074,5591),(56075,5592),(56076,5593),(56077,5594),(56078,5595),(56079,5596),(56080,5597),(56081,5598),(56082,5599),(56083,5600),(56084,5601),(56085,5602),(56086,5603),(56087,5604),(56088,5605),(56089,5606),(56090,5607),(56091,5608),(56092,5609),(56093,5610),(56094,5611),(56095,5612),(56096,5613),(56097,5614),(56098,5615),(56099,5616),(56100,5617),(56101,5618),(56102,5619),(56103,5620),(56104,5621),(56105,5622),(56106,5624),(56107,5625),(56108,5626),(56109,5627),(56110,5628),(56111,5630),(56112,5631),(56113,5632),(56114,5633),(56115,5634),(56116,5635),(56117,5637),(56118,5638),(56119,5639),(56120,5640),(56121,5641),(56122,5643),(56123,5644),(56124,5645),(56125,5646),(56126,5647),(56127,5648),(56128,5649),(56129,5650),(56130,5652),(56131,5653),(56132,5654),(56133,5655),(56134,5656),(56135,5657),(56136,5658),(56137,5659),(56138,5660),(56139,5661),(56140,5663),(56141,5664),(56142,5665),(56143,5666),(56144,5667),(56145,5669),(56146,5670),(56147,5671),(56148,5672),(56149,5682),(56150,5683),(56151,5684),(56152,5685),(56153,5686),(56154,5687),(56155,5688),(56156,5690),(56157,5691),(56158,5692),(56159,5693),(56160,5694),(56161,5695),(56162,5697),(56163,5698),(56164,5699),(56165,5700),(56166,5701),(56167,5709),(56168,5710),(56169,5711),(56170,5712),(56171,5713),(56172,5714),(56173,5715),(56174,5716),(56175,5717),(56176,5718),(56177,5719),(56178,5720),(56179,5721),(56180,5722),(56181,5723),(56182,5724),(56183,5725),(56184,5726),(56185,5727),(56186,5728),(56187,5729),(56188,5730),(56189,5731),(56190,5732),(56191,5733),(56192,5734),(56193,5735),(56194,5736),(56195,5737),(56196,5745),(56197,5746),(56198,5747),(56199,5748),(56200,5749),(56201,1081),(56202,1611),(56203,1612),(56204,1614),(56205,1616),(56206,1617),(56207,1655),(56208,1656),(56209,1705),(56210,1706),(56211,1707),(56212,1739),(56213,1741),(56214,1742),(56215,1764),(56216,1765),(56217,1769),(56218,1772),(56219,1776),(56220,1777),(56221,1783),(56222,2290),(56223,2291),(56224,2293),(56225,4622),(56226,4623),(56227,4624),(56228,4853),(56229,4854),(56230,4855),(56231,4877),(56232,4878),(56233,4879),(56234,4880),(56235,4882),(56236,4883),(56237,4884),(56238,4885),(56239,4886),(56240,4887),(56241,4888),(56242,5598),(56243,5622),(56244,5625),(56245,5626),(56246,5627),(56247,5638),(56248,5641),(56249,5650),(56250,5660),(56251,5664),(56252,5667),(56253,5695),(56254,1081),(56255,1496),(56256,1992),(56257,1993),(56258,1994),(56259,1995),(56260,1997),(56261,1998),(56262,1999),(56263,2000),(56264,2001),(56265,2002),(56266,4526),(56267,4527),(56268,4530),(56269,4531),(56270,4532),(56271,4533),(56272,4534),(56273,4536),(56274,5274),(56275,5282),(56276,5283),(56277,5284),(56278,1996),(56279,4535),(56280,1588),(56281,1589),(56282,1590),(56283,1591),(56284,1592),(56285,1593),(56286,1594),(56287,1595),(56288,1596),(56289,1597),(56290,1598),(56291,1599),(56292,1604),(56293,1607),(56294,1610),(56295,1618),(56296,1619),(56297,1620),(56298,1621),(56299,1623),(56300,1626),(56301,1733),(56302,1734),(56303,1735),(56304,5258),(56305,5259),(56306,5260),(56307,5261),(56308,5262),(56309,5263),(56310,5264),(56311,5265),(56312,5266),(56313,5267),(56314,5268),(56315,5269),(56316,5270),(56317,5524),(56318,5526),(56319,5570),(56320,5588),(56321,1473),(56322,1474),(56323,1475),(56324,1476),(56325,1477),(56326,1478),(56327,1479),(56328,1480),(56329,1483),(56330,1484),(56331,1485),(56332,1486),(56333,1487),(56334,1515),(56335,1516),(56336,1517),(56337,1537),(56338,1538),(56339,1539),(56340,1540),(56341,1541),(56342,1544),(56343,1545),(56344,1546),(56345,1547),(56346,1548),(56347,1549),(56348,1550),(56349,1551),(56350,1552),(56351,1553),(56352,1554),(56353,1555),(56354,1556),(56355,1560),(56356,1561),(56357,1763),(56358,5309),(56359,5310),(56360,5311),(56361,5312),(56362,5313),(56363,5314),(56364,5315),(56365,5316),(56366,5317),(56367,5318),(56368,5319),(56369,5320),(56370,1481),(56371,1482),(56372,1542),(56373,1543),(56374,1140),(56375,1141),(56376,1142),(56377,1143),(56378,1149),(56379,1150),(56380,1497),(56381,1498),(56382,1501),(56383,1502),(56384,1503),(56385,1504),(56386,1506),(56387,1507),(56388,1508),(56389,1509),(56390,1510),(56391,1511),(56392,1512),(56393,1513),(56394,1514),(56395,1797),(56396,5171),(56397,5307),(56398,5308),(56399,5321),(56400,5322),(56401,5536),(56402,5689),(56403,5696),(56404,1141),(56405,1142),(56406,1143),(56407,1149),(56408,1150),(56409,1497),(56410,1498),(56411,1512),(56412,5307),(56413,5308),(56414,1495),(56415,1500),(56416,1796),(56417,1584),(56418,1585),(56419,1586),(56420,1600),(56421,1601),(56422,1602),(56423,1603),(56424,1605),(56425,1606),(56426,1608),(56427,1609),(56428,1622),(56429,1624),(56430,1625),(56431,1627),(56432,1628),(56433,1715),(56434,1716),(56435,1717),(56436,1718),(56437,1719),(56438,1720),(56439,1721),(56440,1722),(56441,1723),(56442,1724),(56443,1725),(56444,1726),(56445,1727),(56446,1728),(56447,1729),(56448,1730),(56449,1731),(56450,1732),(56451,5256),(56452,5257),(56453,5586),(56454,5587),(56455,5589),(56456,4532),(56457,5282),(56458,5283),(56459,5284),(56460,1497),(56461,1498),(56462,1512),(56463,1498),(56464,1499),(56465,5282),(56466,5283),(56467,5284),(56468,400),(56469,401),(56470,405),(56471,408),(56472,409),(56473,410),(56474,415),(56475,416),(56476,417),(56477,419),(56478,426),(56479,427),(56480,428),(56481,429),(56482,432),(56483,433),(56484,434),(56485,435),(56486,437),(56487,438),(56488,439),(56489,440),(56490,441),(56491,442),(56492,443),(56493,444),(56494,445),(56495,446),(56496,447),(56497,448),(56498,449),(56499,450),(56500,451),(56501,452),(56502,453),(56503,454),(56504,455),(56505,456),(56506,457),(56507,458),(56508,459),(56509,463),(56510,464),(56511,465),(56512,466),(56513,467),(56514,468),(56515,476),(56516,477),(56517,478),(56518,479),(56519,480),(56520,482),(56521,483),(56522,484),(56523,485),(56524,486),(56525,487),(56526,488),(56527,489),(56528,490),(56529,491),(56530,492),(56531,493),(56532,494),(56533,495),(56534,496),(56535,497),(56536,498),(56537,499),(56538,503),(56539,504),(56540,505),(56541,506),(56542,507),(56543,508),(56544,509),(56545,510),(56546,511),(56547,512),(56548,513),(56549,515),(56550,516),(56551,533),(56552,534),(56553,535),(56554,536),(56555,537),(56556,538),(56557,539),(56558,540),(56559,541),(56560,544),(56561,545),(56562,546),(56563,547),(56564,548),(56565,549),(56566,550),(56567,551),(56568,552),(56569,554),(56570,555),(56571,556),(56572,559),(56573,571),(56574,572),(56575,573),(56576,574),(56577,575),(56578,576),(56579,577),(56580,578),(56581,579),(56582,580),(56583,581),(56584,582),(56585,585),(56586,586),(56587,593),(56588,594),(56589,595),(56590,598),(56591,600),(56592,610),(56593,612),(56594,620),(56595,621),(56596,622),(56597,623),(56598,633),(56599,634),(56600,638),(56601,640),(56602,641),(56603,642),(56604,647),(56605,649),(56606,653),(56607,654),(56608,655),(56609,657),(56610,658),(56611,674),(56612,752),(56613,754),(56614,755),(56615,756),(56616,757),(56617,758),(56618,759),(56619,760),(56620,761),(56621,762),(56622,763),(56623,764),(56624,765),(56625,766),(56626,767),(56627,768),(56628,769),(56629,770),(56630,773),(56631,774),(56632,775),(56633,780),(56634,796),(56635,797),(56636,805),(56637,806),(56638,807),(56639,808),(56640,809),(56641,810),(56642,811),(56643,812),(56644,813),(56645,818),(56646,819),(56647,820),(56648,826),(56649,827),(56650,828),(56651,829),(56652,841),(56653,842),(56654,843),(56655,844),(56656,845),(56657,846),(56658,847),(56659,848),(56660,849),(56661,850),(56662,851),(56663,852),(56664,853),(56665,854),(56666,856),(56667,869),(56668,873),(56669,874),(56670,876),(56671,877),(56672,880),(56673,881),(56674,882),(56675,883),(56676,884),(56677,885),(56678,886),(56679,887),(56680,888),(56681,889),(56682,890),(56683,891),(56684,892),(56685,893),(56686,894),(56687,895),(56688,896),(56689,897),(56690,898),(56691,899),(56692,900),(56693,901),(56694,909),(56695,910),(56696,911),(56697,912),(56698,932),(56699,933),(56700,934),(56701,935),(56702,940),(56703,941),(56704,942),(56705,943),(56706,948),(56707,949),(56708,950),(56709,951),(56710,952),(56711,953),(56712,954),(56713,955),(56714,956),(56715,976),(56716,977),(56717,978),(56718,979),(56719,984),(56720,985),(56721,986),(56722,987),(56723,992),(56724,993),(56725,994),(56726,995),(56727,1009),(56728,1010),(56729,1011),(56730,1013),(56731,1016),(56732,1017),(56733,1018),(56734,1020),(56735,1022),(56736,1023),(56737,1024),(56738,1027),(56739,1029),(56740,1030),(56741,1031),(56742,1033),(56743,1039),(56744,1040),(56745,1042),(56746,1046),(56747,1047),(56748,1048),(56749,1049),(56750,1051),(56751,1054),(56752,1055),(56753,1065),(56754,1076),(56755,1077),(56756,1082),(56757,1085),(56758,1088),(56759,1090),(56760,1091),(56761,1095),(56762,1096),(56763,1097),(56764,1098),(56765,1099),(56766,1102),(56767,1103),(56768,1104),(56769,1105),(56770,1106),(56771,1107),(56772,1108),(56773,1110),(56774,1113),(56775,1114),(56776,1116),(56777,1120),(56778,1121),(56779,1123),(56780,1128),(56781,1129),(56782,1130),(56783,1131),(56784,1132),(56785,1136),(56786,1137),(56787,1138),(56788,1139),(56789,1148),(56790,1160),(56791,1161),(56792,1174),(56793,1471),(56794,1615),(56795,1775),(56796,1785),(56797,4491),(56798,4528),(56799,4539),(56800,4540),(56801,4541),(56802,4542),(56803,4543),(56804,4544),(56805,4545),(56806,4546),(56807,4547),(56808,4548),(56809,4549),(56810,4550),(56811,4551),(56812,4552),(56813,4553),(56814,4554),(56815,4555),(56816,4556),(56817,4557),(56818,4558),(56819,4559),(56820,4560),(56821,4563),(56822,4564),(56823,4565),(56824,5248),(56825,5249),(56826,5275),(56827,5276),(56828,5277),(56829,5285),(56830,5286),(56831,5287),(56832,5288),(56833,5289),(56834,5290),(56835,5291),(56836,5292),(56837,5293),(56838,5294),(56839,5296),(56840,5297),(56841,5298),(56842,5299),(56843,5300),(56844,5302),(56845,5303),(56846,5304),(56847,5305),(56848,5306),(56849,5338),(56850,5339),(56851,5340),(56852,5341),(56853,5342),(56854,5345),(56855,5346),(56856,5347),(56857,5348),(56858,5349),(56859,5350),(56860,5357),(56861,5358),(56862,5368),(56863,5369),(56864,5401),(56865,5402),(56866,5403),(56867,5404),(56868,5405),(56869,5406),(56870,5407),(56871,5408),(56872,5409),(56873,5410),(56874,5411),(56875,5412),(56876,5413),(56877,5414),(56878,5415),(56879,5416),(56880,5417),(56881,5418),(56882,5419),(56883,5420),(56884,5421),(56885,5422),(56886,5423),(56887,5424),(56888,5425),(56889,5426),(56890,5427),(56891,5428),(56892,5429),(56893,5431),(56894,5434),(56895,5435),(56896,5436),(56897,5437),(56898,5438),(56899,5439),(56900,5440),(56901,5441),(56902,5442),(56903,5443),(56904,5444),(56905,5445),(56906,5446),(56907,5447),(56908,5448),(56909,5449),(56910,5450),(56911,5458),(56912,5463),(56913,5464),(56914,5471),(56915,5472),(56916,5518),(56917,5519),(56918,5531),(56919,5532),(56920,5533),(56921,5534),(56922,5535),(56923,5537),(56924,5541),(56925,5542),(56926,5543),(56927,5544),(56928,5545),(56929,5546),(56930,5547),(56931,5548),(56932,5553),(56933,5554),(56934,5555),(56935,5556),(56936,5557),(56937,5558),(56938,5559),(56939,5560),(56940,5563),(56941,5564),(56942,5566),(56943,5567),(56944,5568),(56945,5569),(56946,5571),(56947,5590),(56948,5591),(56949,5592),(56950,5593),(56951,5595),(56952,5596),(56953,5597),(56954,5602),(56955,5603),(56956,5605),(56957,5606),(56958,5608),(56959,5609),(56960,5610),(56961,5611),(56962,5612),(56963,5613),(56964,5614),(56965,5615),(56966,5616),(56967,5617),(56968,5618),(56969,5619),(56970,5620),(56971,5630),(56972,5631),(56973,5632),(56974,5633),(56975,5634),(56976,5674),(56977,5675),(56978,5676),(56979,5677),(56980,5678),(56981,5679),(56982,5680),(56983,5681),(56984,5682),(56985,5683),(56986,5684),(56987,5685),(56988,5686),(56989,5688),(56990,5690),(56991,5691),(56992,5692),(56993,5693),(56994,5694),(56995,5697),(56996,5698),(56997,5699),(56998,5700),(56999,5709),(57000,5710),(57001,5711),(57002,5713),(57003,5714),(57004,5715),(57005,5716),(57006,5717),(57007,5718),(57008,5719),(57009,5720),(57010,5721),(57011,5722),(57012,5723),(57013,5724),(57014,5725),(57015,5726),(57016,5727),(57017,5728),(57018,5729),(57019,5730),(57020,5731),(57021,5732),(57022,5733),(57023,5734),(57024,5735),(57025,5736),(57026,5737),(57027,5738),(57028,5745),(57029,5746),(57030,5747),(57031,5749),(57032,5752),(57033,5404),(57034,5425),(57035,5427),(57036,5406),(57037,5407),(57038,5426),(57039,5559),(57040,5560),(57041,5401),(57042,1615),(57043,4539),(57044,4540),(57045,4541),(57046,4542),(57047,4543),(57048,4544),(57049,4546),(57050,4547),(57051,4548),(57052,4549),(57053,4556),(57054,4557),(57055,4558),(57056,4559),(57057,4560),(57058,5249),(57059,5568),(57060,5569),(57061,5443),(57062,5540),(57063,5592),(57064,5594),(57065,5604),(57066,5693),(57067,5596),(57068,5597),(57069,5734),(57070,5735),(57071,5736),(57072,5737),(57073,400),(57074,480),(57075,482),(57076,499),(57077,515),(57078,873),(57079,874),(57080,876),(57081,877),(57082,880),(57083,881),(57084,1024),(57085,5299),(57086,5300),(57087,5303),(57088,5304),(57089,5305),(57090,5306),(57091,5449),(57092,5518),(57093,5519),(57094,5713),(57095,5714),(57096,5715),(57097,5716),(57098,5717),(57099,5718),(57100,5719),(57101,5720),(57102,5721),(57103,5722),(57104,5723),(57105,5724),(57106,5725),(57107,5726),(57108,5727),(57109,5728),(57110,5729),(57111,5730),(57112,5731),(57113,5732),(57114,5733),(57115,5734),(57116,5735),(57117,5736),(57118,5737),(57119,5733),(57120,5734),(57121,5735),(57122,5736),(57123,5737),(57124,4540),(57125,4541),(57126,4542),(57127,5248),(57128,5249),(57129,5629),(57130,5642),(57131,5668),(57132,2540),(57133,2541),(57134,2542),(57135,5357),(57136,5429),(57137,5434),(57138,5458),(57139,5463),(57140,5464),(57141,5518),(57142,2154),(57143,2177),(57144,2221),(57145,2222),(57146,2299),(57147,5622),(57148,5641),(57149,5667),(57150,1184),(57151,5527),(57152,5621),(57153,5644),(57154,5645),(57155,5654),(57156,5670),(57157,5671),(57158,1054),(57159,1055),(57160,1066),(57161,2289),(57162,2290),(57163,2291),(57164,2293),(57165,2428),(57166,5621),(57167,5622),(57168,5623),(57169,5624),(57170,5625),(57171,5626),(57172,5627),(57173,5629),(57174,5630),(57175,5631),(57176,5632),(57177,5633),(57178,5634),(57179,5636),(57180,5637),(57181,5638),(57182,5639),(57183,5640),(57184,5641),(57185,5642),(57186,5643),(57187,5644),(57188,5645),(57189,5647),(57190,5648),(57191,5649),(57192,5650),(57193,5651),(57194,5652),(57195,5653),(57196,5655),(57197,5656),(57198,5658),(57199,5659),(57200,5660),(57201,5662),(57202,5663),(57203,5664),(57204,5665),(57205,5666),(57206,5667),(57207,5668),(57208,5669),(57209,5670),(57210,5671),(57211,5731),(57212,5732),(57213,5733),(57214,5734),(57215,5735),(57216,5736),(57217,5737),(57218,5745),(57219,5746),(57220,5747),(57221,5749),(57222,1054),(57223,1055),(57224,1066),(57225,2289),(57226,2290),(57227,2291),(57228,2293),(57229,2428),(57230,5655),(57231,5656),(57232,5732),(57233,5745),(57234,5746),(57235,5747),(57236,5749),(57237,165),(57238,1082),(57239,1088),(57240,1611),(57241,1612),(57242,1614),(57243,1616),(57244,1617),(57245,1655),(57246,1656),(57247,1705),(57248,1706),(57249,1707),(57250,1739),(57251,1741),(57252,1742),(57253,1764),(57254,1765),(57255,1769),(57256,1776),(57257,1777),(57258,1783),(57259,1962),(57260,2517),(57261,2518),(57262,2519),(57263,2520),(57264,4853),(57265,4854),(57266,4855),(57267,4883),(57268,4970),(57269,5368),(57270,5408),(57271,5410),(57272,5411),(57273,5412),(57274,5413),(57275,5415),(57276,5416),(57277,5417),(57278,5428),(57279,5540),(57280,5546),(57281,5547),(57282,5548),(57283,5571),(57284,5591),(57285,5592),(57286,5593),(57287,5594),(57288,5595),(57289,5596),(57290,5597),(57291,5598),(57292,5599),(57293,5600),(57294,5601),(57295,5602),(57296,5603),(57297,5604),(57298,5613),(57299,5615),(57300,5616),(57301,5617),(57302,5618),(57303,5619),(57304,5628),(57305,5646),(57306,5654),(57307,5661),(57308,5672),(57309,5690),(57310,5691),(57311,5692),(57312,5693),(57313,5694),(57314,5695),(57315,5713),(57316,5715),(57317,5717),(57318,5719),(57319,5721),(57320,5723),(57321,5725),(57322,5727),(57323,5729),(57324,165),(57325,1082),(57326,1088),(57327,1611),(57328,1612),(57329,1614),(57330,1616),(57331,1617),(57332,1655),(57333,1656),(57334,1705),(57335,1706),(57336,1707),(57337,1739),(57338,1741),(57339,1742),(57340,1764),(57341,1765),(57342,1769),(57343,1776),(57344,1777),(57345,1783),(57346,1962),(57347,2517),(57348,2518),(57349,2519),(57350,2520),(57351,4853),(57352,4854),(57353,4855),(57354,4883),(57355,4970),(57356,5598),(57357,5624),(57358,5628),(57359,5643),(57360,5653),(57361,5660),(57362,5669),(57363,5695),(57364,1615),(57365,1775),(57366,1785),(57367,5414),(57368,5418),(57369,5419),(57370,5471),(57371,5472),(57372,5541),(57373,5542),(57374,5543),(57375,5544),(57376,5545),(57377,5605),(57378,5606),(57379,5608),(57380,5609),(57381,5610),(57382,5611),(57383,5614),(57384,5620),(57385,5682),(57386,5683),(57387,5684),(57388,5685),(57389,5686),(57390,5688),(57391,5697),(57392,5698),(57393,5699),(57394,5700),(57395,5709),(57396,5710),(57397,5711),(57398,5714),(57399,5716),(57400,5718),(57401,5720),(57402,5722),(57403,5724),(57404,5726),(57405,5728),(57406,5730),(57407,5732),(57408,5745),(57409,5746),(57410,5747),(57411,5749),(57412,5612),(57413,1148),(57414,5286),(57415,5274),(57416,5282),(57417,5283),(57418,5284),(57419,5369),(57420,5402),(57421,5531),(57422,5532),(57423,5533),(57424,5534),(57425,5535),(57426,5558),(57427,5563),(57428,5564),(57429,5566),(57430,5674),(57431,5675),(57432,5676),(57433,5677),(57434,5678),(57435,5679),(57436,5738),(57437,5434),(57438,5275),(57439,5276),(57440,5277),(57441,5338),(57442,5339),(57443,5340),(57444,5341),(57445,5342),(57446,5345),(57447,5346),(57448,5347),(57449,5348),(57450,5349),(57451,5350),(57452,5357),(57453,5358),(57454,5680),(57455,5681),(57456,5285),(57457,5287),(57458,5288),(57459,5289),(57460,5290),(57461,5291),(57462,5292),(57463,5293),(57464,5294),(57465,5296),(57466,5297),(57467,5298),(57468,5299),(57469,5300),(57470,5302),(57471,5303),(57472,5304),(57473,5305),(57474,5306),(57475,5537),(57476,5752),(57477,5401),(57478,5403),(57479,5404),(57480,5405),(57481,5406),(57482,5407),(57483,5409),(57484,5421),(57485,5422),(57486,5423),(57487,5424),(57488,5425),(57489,5426),(57490,5427),(57491,5429),(57492,5458),(57493,5463),(57494,5464),(57495,5553),(57496,5554),(57497,5555),(57498,5556),(57499,5557),(57500,5559),(57501,5560),(57502,5567),(57503,5568),(57504,5569),(57505,5590),(57506,4524),(57507,4572),(57508,1081),(57509,1196),(57510,1197),(57511,1198),(57512,1199),(57513,1201),(57514,1202),(57515,1203),(57516,1204),(57517,1205),(57518,1206),(57519,1207),(57520,1232),(57521,1243),(57522,1245),(57523,1289),(57524,1332),(57525,1346),(57526,1347),(57527,1349),(57528,1353),(57529,1354),(57530,1355),(57531,1356),(57532,1357),(57533,1358),(57534,1359),(57535,1360),(57536,1361),(57537,1362),(57538,1363),(57539,1364),(57540,1366),(57541,1367),(57542,1368),(57543,1387),(57544,1410),(57545,1411),(57546,1412),(57547,1413),(57548,1414),(57549,1415),(57550,1416),(57551,1437),(57552,1440),(57553,1443),(57554,1444),(57555,1453),(57556,1464),(57557,1468),(57558,5324),(57559,5328),(57560,5329),(57561,5370),(57562,5371),(57563,5372),(57564,5373),(57565,5374),(57566,5375),(57567,5477),(57568,5478),(57569,5479),(57570,5480),(57571,5481),(57572,5484),(57573,5485),(57574,5486),(57575,5487),(57576,5488),(57577,5704),(57578,5705),(57579,5706),(57580,1329),(57581,1333),(57582,1334),(57583,1335),(57584,1337),(57585,1339),(57586,1369),(57587,1370),(57588,1372),(57589,1373),(57590,1374),(57591,5103),(57592,5104),(57593,5274),(57594,1524),(57595,1672),(57596,1673),(57597,1674),(57598,1793),(57599,1794),(57600,1795),(57601,1081),(57602,5370),(57603,5332),(57604,1197),(57605,1332),(57606,1362),(57607,1367),(57608,583),(57609,584),(57610,600),(57611,602),(57612,605),(57613,606),(57614,608),(57615,777),(57616,778),(57617,779),(57618,780),(57619,783),(57620,787),(57621,789),(57622,798),(57623,799),(57624,800),(57625,801),(57626,802),(57627,803),(57628,804),(57629,821),(57630,822),(57631,823),(57632,830),(57633,831),(57634,832),(57635,833),(57636,856),(57637,866),(57638,867),(57639,868),(57640,1173),(57641,1175),(57642,1176),(57643,1177),(57644,1178),(57645,1179),(57646,1180),(57647,1181),(57648,1182),(57649,1183),(57650,1195),(57651,1196),(57652,1197),(57653,1198),(57654,1199),(57655,1200),(57656,1201),(57657,1202),(57658,1203),(57659,1204),(57660,1205),(57661,1206),(57662,1207),(57663,1210),(57664,1211),(57665,1212),(57666,1213),(57667,1214),(57668,1215),(57669,1216),(57670,1217),(57671,1218),(57672,1219),(57673,1220),(57674,1221),(57675,1222),(57676,1223),(57677,1224),(57678,1225),(57679,1226),(57680,1227),(57681,1228),(57682,1229),(57683,1230),(57684,1231),(57685,1232),(57686,1233),(57687,1234),(57688,1235),(57689,1236),(57690,1237),(57691,1238),(57692,1239),(57693,1240),(57694,1241),(57695,1242),(57696,1243),(57697,1244),(57698,1245),(57699,1246),(57700,1247),(57701,1248),(57702,1249),(57703,1250),(57704,1251),(57705,1252),(57706,1253),(57707,1254),(57708,1255),(57709,1256),(57710,1257),(57711,1258),(57712,1259),(57713,1260),(57714,1261),(57715,1262),(57716,1263),(57717,1264),(57718,1265),(57719,1266),(57720,1267),(57721,1268),(57722,1269),(57723,1270),(57724,1271),(57725,1272),(57726,1273),(57727,1274),(57728,1275),(57729,1276),(57730,1277),(57731,1278),(57732,1279),(57733,1280),(57734,1281),(57735,1282),(57736,1283),(57737,1284),(57738,1285),(57739,1286),(57740,1287),(57741,1288),(57742,1289),(57743,1290),(57744,1291),(57745,1292),(57746,1293),(57747,1294),(57748,1295),(57749,1296),(57750,1297),(57751,1298),(57752,1299),(57753,1300),(57754,1301),(57755,1302),(57756,1303),(57757,1304),(57758,1305),(57759,1306),(57760,1307),(57761,1308),(57762,1309),(57763,1310),(57764,1311),(57765,1312),(57766,1313),(57767,1314),(57768,1315),(57769,1316),(57770,1317),(57771,1318),(57772,1319),(57773,1320),(57774,1321),(57775,1322),(57776,1323),(57777,1332),(57778,1342),(57779,1346),(57780,1347),(57781,1349),(57782,1350),(57783,1351),(57784,1353),(57785,1354),(57786,1355),(57787,1356),(57788,1357),(57789,1358),(57790,1359),(57791,1360),(57792,1361),(57793,1362),(57794,1363),(57795,1364),(57796,1366),(57797,1367),(57798,1368),(57799,1371),(57800,1375),(57801,1376),(57802,1377),(57803,1379),(57804,1389),(57805,1390),(57806,1391),(57807,1392),(57808,1393),(57809,1394),(57810,1395),(57811,1397),(57812,1398),(57813,1400),(57814,1420),(57815,1421),(57816,1422),(57817,1423),(57818,1424),(57819,1425),(57820,1427),(57821,1428),(57822,1429),(57823,1430),(57824,1431),(57825,1432),(57826,1433),(57827,1434),(57828,1435),(57829,1442),(57830,1443),(57831,1444),(57832,1445),(57833,1446),(57834,1447),(57835,1448),(57836,1450),(57837,1451),(57838,1452),(57839,1454),(57840,1455),(57841,1456),(57842,1457),(57843,1462),(57844,1469),(57845,1749),(57846,4500),(57847,4501),(57848,4502),(57849,4503),(57850,4504),(57851,4505),(57852,4506),(57853,4507),(57854,4508),(57855,4509),(57856,4510),(57857,4511),(57858,4512),(57859,4513),(57860,4514),(57861,4515),(57862,4516),(57863,4517),(57864,4518),(57865,4519),(57866,4520),(57867,4522),(57868,4523),(57869,583),(57870,602),(57871,605),(57872,778),(57873,779),(57874,780),(57875,783),(57876,787),(57877,821),(57878,822),(57879,856),(57880,1166),(57881,1171),(57882,1172),(57883,1174),(57884,600),(57885,1166),(57886,1184),(57887,1185),(57888,1186),(57889,1187),(57890,1188),(57891,1189),(57892,1190),(57893,1191),(57894,1192),(57895,1193),(57896,1194),(57897,1208),(57898,1209),(57899,1324),(57900,1325),(57901,1326),(57902,1327),(57903,1328),(57904,1329),(57905,1330),(57906,1331),(57907,1333),(57908,1334),(57909,1335),(57910,4521),(57911,4524),(57912,4525),(57913,1185),(57914,1186),(57915,1187),(57916,1188),(57917,1189),(57918,1190),(57919,1192),(57920,1193),(57921,1194),(57922,398),(57923,399),(57924,403),(57925,404),(57926,406),(57927,407),(57928,411),(57929,412),(57930,413),(57931,414),(57932,420),(57933,421),(57934,424),(57935,425),(57936,431),(57937,462),(57938,471),(57939,481),(57940,500),(57941,501),(57942,517),(57943,616),(57944,635),(57945,643),(57946,644),(57947,661),(57948,663),(57949,665),(57950,666),(57951,669),(57952,671),(57953,673),(57954,675),(57955,676),(57956,677),(57957,678),(57958,679),(57959,680),(57960,1336),(57961,1337),(57962,1338),(57963,1339),(57964,1340),(57965,1341),(57966,1344),(57967,1345),(57968,1348),(57969,1352),(57970,1365),(57971,1369),(57972,1370),(57973,1372),(57974,1373),(57975,1374),(57976,1378),(57977,1380),(57978,1381),(57979,1382),(57980,1383),(57981,1384),(57982,1385),(57983,1386),(57984,1387),(57985,1388),(57986,1396),(57987,1399),(57988,1401),(57989,1402),(57990,1403),(57991,1404),(57992,1405),(57993,1406),(57994,1407),(57995,1408),(57996,1409),(57997,1410),(57998,1411),(57999,1412),(58000,1413),(58001,1414),(58002,1415),(58003,1416),(58004,1426),(58005,1436),(58006,1437),(58007,1438),(58008,1439),(58009,1440),(58010,1449),(58011,1453),(58012,1458),(58013,1459),(58014,1460),(58015,1461),(58016,1463),(58017,1464),(58018,1465),(58019,1466),(58020,1467),(58021,1468),(58022,1522),(58023,1523),(58024,1524),(58025,1525),(58026,1526),(58027,1527),(58028,1528),(58029,1529),(58030,1530),(58031,1531),(58032,1532),(58033,1534),(58034,1535),(58035,1536),(58036,1557),(58037,1558),(58038,1559),(58039,1562),(58040,1587),(58041,1661),(58042,1662),(58043,1663),(58044,1664),(58045,1667),(58046,1668),(58047,1669),(58048,1670),(58049,1671),(58050,1672),(58051,1673),(58052,1674),(58053,1740),(58054,1743),(58055,1744),(58056,1745),(58057,1746),(58058,1747),(58059,1750),(58060,1780),(58061,1781),(58062,1782),(58063,1793),(58064,1794),(58065,1795),(58066,1799),(58067,1800),(58068,1801),(58069,1802),(58070,5355),(58071,5370),(58072,5371),(58073,5482),(58074,5483),(58075,5520),(58076,5521),(58077,5522),(58078,5523),(58079,5704),(58080,5705),(58081,5706),(58082,1518),(58083,1519),(58084,1520),(58085,1521),(58086,1533),(58087,1563),(58088,1564),(58089,1565),(58090,1566),(58091,1658),(58092,1659),(58093,1660),(58094,1665),(58095,1666),(58096,1675),(58097,1676),(58098,1677),(58099,1678),(58100,1751),(58101,1752),(58102,1753),(58103,1754),(58104,1756),(58105,1757),(58106,1758),(58107,1761),(58108,1762),(58109,1778),(58110,1779),(58111,1786),(58112,1787),(58113,1788),(58114,1789),(58115,1790),(58116,5323),(58117,5324),(58118,5325),(58119,5326),(58120,5327),(58121,5328),(58122,5329),(58123,5330),(58124,5331),(58125,5332),(58126,5333),(58127,5334),(58128,5335),(58129,5336),(58130,5337),(58131,5351),(58132,5352),(58133,5354),(58134,5356),(58135,5372),(58136,5373),(58137,5374),(58138,5375),(58139,5376),(58140,5377),(58141,5390),(58142,5474),(58143,5475),(58144,5476),(58145,5477),(58146,5478),(58147,5479),(58148,5480),(58149,5481),(58150,5484),(58151,5485),(58152,5486),(58153,5487),(58154,5488),(58155,5718),(58156,5718),(58157,5718),(58158,5718),(58159,5718),(58160,5718),(58161,5718),(58162,5718),(58163,5718),(58164,5760),(58165,5760),(58166,5760),(58167,5760),(58168,5760),(58169,5760),(58170,5760),(58171,5760),(58172,5760),(58173,5760),(58174,5760),(58175,5760),(58176,5760),(58177,5760),(58178,5760),(58179,5760),(58180,5760),(58181,5760),(58182,5760),(58183,5760),(58184,5760),(58185,5760),(58186,5760),(58187,5760),(58188,5760),(58189,5760),(58190,5760),(58191,5760),(58192,5760),(58193,5760),(58194,5761),(58195,5762),(58196,5763),(58197,5764),(58198,5765),(58199,5766),(58200,5767),(58201,5768),(58202,5769),(58203,5770),(58204,5771),(58205,5772),(58206,5773),(58207,5774),(58208,5775),(58209,5776),(58210,5777),(58211,5778),(58212,5779),(58213,5780),(58214,5781),(58215,5782),(58216,5783),(58217,5784),(58218,5785),(58219,5786),(58220,5787),(58221,5788),(58222,5789),(58223,5790),(58224,5791),(58225,5792),(58226,5793),(58227,5794),(58228,5795),(58229,5796),(58230,5797),(58231,5798),(58232,5799),(58233,5800),(58234,5801),(58235,5802),(58236,5803),(58237,5804),(58238,5805),(58239,5806),(58240,5807),(58241,5808),(58242,5809),(58243,5810),(58244,5811),(58245,5812),(58246,5813),(58247,5814),(58248,5815),(58249,5816),(58250,5817),(58251,5818),(58252,5819),(58253,5820),(58254,5821),(58255,5822),(58256,5823),(58257,5824),(58258,5825),(58259,5826),(58260,5827),(58261,5828),(58262,5829),(58263,5830),(58264,5831),(58265,5832),(58266,5833),(58267,5834),(58268,5835),(58269,5836),(58270,5837),(58271,5838),(58272,5839),(58273,5840),(58274,5841),(58275,5842),(58276,5843),(58277,5844),(58278,5845),(58279,5846),(58280,5847),(58281,5848),(58282,5849),(58283,5850),(58284,5851),(58285,5852),(58286,5853),(58287,5854),(58288,5855),(58289,5856),(58290,5857),(58291,5858),(58292,5859),(58293,5860),(58294,5761),(58295,5761),(58296,5761),(58297,5761),(58298,5761),(58299,5761),(58300,5761),(58301,5761),(58302,5761),(58303,5761),(58304,5761),(58305,5762),(58306,5762),(58307,5762),(58308,5762),(58309,5762),(58310,5762),(58311,5762),(58312,5762),(58313,5762),(58314,5762),(58315,5762),(58316,5763),(58317,5763),(58318,5763),(58319,5763),(58320,5763),(58321,5763),(58322,5763),(58323,5763),(58324,5763),(58325,5763),(58326,5763),(58327,5764),(58328,5764),(58329,5764),(58330,5764),(58331,5764),(58332,5764),(58333,5764),(58334,5764),(58335,5764),(58336,5764),(58337,5764),(58338,5765),(58339,5765),(58340,5765),(58341,5765),(58342,5765),(58343,5765),(58344,5765),(58345,5765),(58346,5765),(58347,5765),(58348,5765),(58349,5766),(58350,5766),(58351,5766),(58352,5766),(58353,5766),(58354,5766),(58355,5766),(58356,5766),(58357,5766),(58358,5766),(58359,5766),(58360,5767),(58361,5767),(58362,5767),(58363,5767),(58364,5767),(58365,5767),(58366,5767),(58367,5767),(58368,5767),(58369,5767),(58370,5767),(58371,5768),(58372,5768),(58373,5768),(58374,5768),(58375,5768),(58376,5768),(58377,5768),(58378,5768),(58379,5768),(58380,5768),(58381,5768),(58382,5769),(58383,5769),(58384,5769),(58385,5769),(58386,5769),(58387,5769),(58388,5769),(58389,5769),(58390,5769),(58391,5769),(58392,5769),(58393,5770),(58394,5770),(58395,5770),(58396,5770),(58397,5770),(58398,5770),(58399,5770),(58400,5770),(58401,5770),(58402,5770),(58403,5770),(58404,5771),(58405,5771),(58406,5771),(58407,5771),(58408,5771),(58409,5771),(58410,5771),(58411,5771),(58412,5771),(58413,5771),(58414,5771),(58415,5772),(58416,5772),(58417,5772),(58418,5772),(58419,5772),(58420,5772),(58421,5772),(58422,5772),(58423,5772),(58424,5772),(58425,5772),(58426,5773),(58427,5773),(58428,5773),(58429,5773),(58430,5773),(58431,5773),(58432,5773),(58433,5773),(58434,5773),(58435,5773),(58436,5773),(58437,5774),(58438,5774),(58439,5774),(58440,5774),(58441,5774),(58442,5774),(58443,5774),(58444,5774),(58445,5774),(58446,5774),(58447,5774),(58448,5775),(58449,5775),(58450,5775),(58451,5775),(58452,5775),(58453,5775),(58454,5775),(58455,5775),(58456,5775),(58457,5775),(58458,5775),(58459,5776),(58460,5776),(58461,5776),(58462,5776),(58463,5776),(58464,5776),(58465,5776),(58466,5776),(58467,5776),(58468,5776),(58469,5776),(58470,5777),(58471,5777),(58472,5777),(58473,5777),(58474,5777),(58475,5777),(58476,5777),(58477,5777),(58478,5777),(58479,5777),(58480,5777),(58481,5778),(58482,5778),(58483,5778),(58484,5778),(58485,5778),(58486,5778),(58487,5778),(58488,5778),(58489,5778),(58490,5778),(58491,5778),(58492,5779),(58493,5779),(58494,5779),(58495,5779),(58496,5779),(58497,5779),(58498,5779),(58499,5779),(58500,5779),(58501,5779),(58502,5779),(58503,5780),(58504,5780),(58505,5780),(58506,5780),(58507,5780),(58508,5780),(58509,5780),(58510,5780),(58511,5780),(58512,5780),(58513,5780),(58514,5781),(58515,5781),(58516,5781),(58517,5781),(58518,5781),(58519,5781),(58520,5781),(58521,5781),(58522,5781),(58523,5781),(58524,5781),(58525,5782),(58526,5782),(58527,5782),(58528,5782),(58529,5782),(58530,5782),(58531,5782),(58532,5782),(58533,5782),(58534,5782),(58535,5782),(58536,5783),(58537,5783),(58538,5783),(58539,5783),(58540,5783),(58541,5783),(58542,5783),(58543,5783),(58544,5783),(58545,5783),(58546,5783),(58547,5784),(58548,5784),(58549,5784),(58550,5784),(58551,5784),(58552,5784),(58553,5784),(58554,5784),(58555,5784),(58556,5784),(58557,5784),(58558,5785),(58559,5785),(58560,5785),(58561,5785),(58562,5785),(58563,5785),(58564,5785),(58565,5785),(58566,5785),(58567,5785),(58568,5785),(58569,5786),(58570,5786),(58571,5786),(58572,5786),(58573,5786),(58574,5786),(58575,5786),(58576,5786),(58577,5786),(58578,5786),(58579,5786),(58580,5787),(58581,5787),(58582,5787),(58583,5787),(58584,5787),(58585,5787),(58586,5787),(58587,5787),(58588,5787),(58589,5787),(58590,5787),(58591,5788),(58592,5788),(58593,5788),(58594,5788),(58595,5788),(58596,5788),(58597,5788),(58598,5788),(58599,5788),(58600,5788),(58601,5788),(58602,5789),(58603,5789),(58604,5789),(58605,5789),(58606,5789),(58607,5789),(58608,5789),(58609,5789),(58610,5789),(58611,5789),(58612,5789),(58613,5790),(58614,5790),(58615,5790),(58616,5790),(58617,5790),(58618,5790),(58619,5790),(58620,5790),(58621,5790),(58622,5790),(58623,5790),(58624,5791),(58625,5791),(58626,5791),(58627,5791),(58628,5791),(58629,5791),(58630,5791),(58631,5791),(58632,5791),(58633,5791),(58634,5791),(58635,5792),(58636,5792),(58637,5792),(58638,5792),(58639,5792),(58640,5792),(58641,5792),(58642,5792),(58643,5792),(58644,5792),(58645,5792),(58646,5793),(58647,5793),(58648,5793),(58649,5793),(58650,5793),(58651,5793),(58652,5793),(58653,5793),(58654,5793),(58655,5793),(58656,5793),(58657,5794),(58658,5794),(58659,5794),(58660,5794),(58661,5794),(58662,5794),(58663,5794),(58664,5794),(58665,5794),(58666,5794),(58667,5794),(58668,5795),(58669,5795),(58670,5795),(58671,5795),(58672,5795),(58673,5795),(58674,5795),(58675,5795),(58676,5795),(58677,5795),(58678,5795),(58679,5796),(58680,5796),(58681,5796),(58682,5796),(58683,5796),(58684,5796),(58685,5796),(58686,5796),(58687,5796),(58688,5796),(58689,5796),(58690,5797),(58691,5797),(58692,5797),(58693,5797),(58694,5797),(58695,5797),(58696,5797),(58697,5797),(58698,5797),(58699,5797),(58700,5797),(58701,5798),(58702,5798),(58703,5798),(58704,5798),(58705,5798),(58706,5798),(58707,5798),(58708,5798),(58709,5798),(58710,5798),(58711,5798),(58712,5799),(58713,5799),(58714,5799),(58715,5799),(58716,5799),(58717,5799),(58718,5799),(58719,5799),(58720,5799),(58721,5799),(58722,5799),(58723,5800),(58724,5800),(58725,5800),(58726,5800),(58727,5800),(58728,5800),(58729,5800),(58730,5800),(58731,5800),(58732,5800),(58733,5800),(58734,5801),(58735,5801),(58736,5801),(58737,5801),(58738,5801),(58739,5801),(58740,5801),(58741,5801),(58742,5801),(58743,5801),(58744,5801),(58745,5802),(58746,5802),(58747,5802),(58748,5802),(58749,5802),(58750,5802),(58751,5802),(58752,5802),(58753,5802),(58754,5802),(58755,5802),(58756,5803),(58757,5803),(58758,5803),(58759,5803),(58760,5803),(58761,5803),(58762,5803),(58763,5803),(58764,5803),(58765,5803),(58766,5803),(58767,5804),(58768,5804),(58769,5804),(58770,5804),(58771,5804),(58772,5804),(58773,5804),(58774,5804),(58775,5804),(58776,5804),(58777,5804),(58778,5805),(58779,5805),(58780,5805),(58781,5805),(58782,5805),(58783,5805),(58784,5805),(58785,5805),(58786,5805),(58787,5805),(58788,5805),(58789,5806),(58790,5806),(58791,5806),(58792,5806),(58793,5806),(58794,5806),(58795,5806),(58796,5806),(58797,5806),(58798,5806),(58799,5806),(58800,5807),(58801,5807),(58802,5807),(58803,5807),(58804,5807),(58805,5807),(58806,5807),(58807,5807),(58808,5807),(58809,5807),(58810,5807),(58811,5808),(58812,5808),(58813,5808),(58814,5808),(58815,5808),(58816,5808),(58817,5808),(58818,5808),(58819,5808),(58820,5808),(58821,5808),(58822,5809),(58823,5809),(58824,5809),(58825,5809),(58826,5809),(58827,5809),(58828,5809),(58829,5809),(58830,5809),(58831,5809),(58832,5809),(58833,5810),(58834,5810),(58835,5810),(58836,5810),(58837,5810),(58838,5810),(58839,5810),(58840,5810),(58841,5810),(58842,5810),(58843,5810),(58844,5811),(58845,5811),(58846,5811),(58847,5811),(58848,5811),(58849,5811),(58850,5811),(58851,5811),(58852,5811),(58853,5811),(58854,5811),(58855,5812),(58856,5812),(58857,5812),(58858,5812),(58859,5812),(58860,5812),(58861,5812),(58862,5812),(58863,5812),(58864,5812),(58865,5812),(58866,5813),(58867,5813),(58868,5813),(58869,5813),(58870,5813),(58871,5813),(58872,5813),(58873,5813),(58874,5813),(58875,5813),(58876,5813),(58877,5814),(58878,5814),(58879,5814),(58880,5814),(58881,5814),(58882,5814),(58883,5814),(58884,5814),(58885,5814),(58886,5814),(58887,5814),(58888,5815),(58889,5815),(58890,5815),(58891,5815),(58892,5815),(58893,5815),(58894,5815),(58895,5815),(58896,5815),(58897,5815),(58898,5815),(58899,5816),(58900,5816),(58901,5816),(58902,5816),(58903,5816),(58904,5816),(58905,5816),(58906,5816),(58907,5816),(58908,5816),(58909,5816),(58910,5817),(58911,5817),(58912,5817),(58913,5817),(58914,5817),(58915,5817),(58916,5817),(58917,5817),(58918,5817),(58919,5817),(58920,5817),(58921,5818),(58922,5818),(58923,5818),(58924,5818),(58925,5818),(58926,5818),(58927,5818),(58928,5818),(58929,5818),(58930,5818),(58931,5818),(58932,5819),(58933,5819),(58934,5819),(58935,5819),(58936,5819),(58937,5819),(58938,5819),(58939,5819),(58940,5819),(58941,5819),(58942,5819),(58943,5820),(58944,5820),(58945,5820),(58946,5820),(58947,5820),(58948,5820),(58949,5820),(58950,5820),(58951,5820),(58952,5820),(58953,5820),(58954,5821),(58955,5821),(58956,5821),(58957,5821),(58958,5821),(58959,5821),(58960,5821),(58961,5821),(58962,5821),(58963,5821),(58964,5821),(58965,5822),(58966,5822),(58967,5822),(58968,5822),(58969,5822),(58970,5822),(58971,5822),(58972,5822),(58973,5822),(58974,5822),(58975,5822),(58976,5823),(58977,5823),(58978,5823),(58979,5823),(58980,5823),(58981,5823),(58982,5823),(58983,5823),(58984,5823),(58985,5823),(58986,5823),(58987,5824),(58988,5824),(58989,5824),(58990,5824),(58991,5824),(58992,5824),(58993,5824),(58994,5824),(58995,5824),(58996,5824),(58997,5824),(58998,5825),(58999,5825),(59000,5825),(59001,5825),(59002,5825),(59003,5825),(59004,5825),(59005,5825),(59006,5825),(59007,5825),(59008,5825),(59009,5826),(59010,5826),(59011,5826),(59012,5826),(59013,5826),(59014,5826),(59015,5826),(59016,5826),(59017,5826),(59018,5826),(59019,5826),(59020,5827),(59021,5827),(59022,5827),(59023,5827),(59024,5827),(59025,5827),(59026,5827),(59027,5827),(59028,5827),(59029,5827),(59030,5827),(59031,5828),(59032,5828),(59033,5828),(59034,5828),(59035,5828),(59036,5828),(59037,5828),(59038,5828),(59039,5828),(59040,5828),(59041,5828),(59042,5829),(59043,5829),(59044,5829),(59045,5829),(59046,5829),(59047,5829),(59048,5829),(59049,5829),(59050,5829),(59051,5829),(59052,5829),(59053,5830),(59054,5830),(59055,5830),(59056,5830),(59057,5830),(59058,5830),(59059,5830),(59060,5830),(59061,5830),(59062,5830),(59063,5830),(59064,5831),(59065,5831),(59066,5831),(59067,5831),(59068,5831),(59069,5831),(59070,5831),(59071,5831),(59072,5831),(59073,5831),(59074,5831),(59075,5832),(59076,5832),(59077,5832),(59078,5832),(59079,5832),(59080,5832),(59081,5832),(59082,5832),(59083,5832),(59084,5832),(59085,5832),(59086,5833),(59087,5833),(59088,5833),(59089,5833),(59090,5833),(59091,5833),(59092,5833),(59093,5833),(59094,5833),(59095,5833),(59096,5833),(59097,5834),(59098,5834),(59099,5834),(59100,5834),(59101,5834),(59102,5834),(59103,5834),(59104,5834),(59105,5834),(59106,5834),(59107,5834),(59108,5835),(59109,5835),(59110,5835),(59111,5835),(59112,5835),(59113,5835),(59114,5835),(59115,5835),(59116,5835),(59117,5835),(59118,5835),(59119,5836),(59120,5836),(59121,5836),(59122,5836),(59123,5836),(59124,5836),(59125,5836),(59126,5836),(59127,5836),(59128,5836),(59129,5836),(59130,5837),(59131,5837),(59132,5837),(59133,5837),(59134,5837),(59135,5837),(59136,5837),(59137,5837),(59138,5837),(59139,5837),(59140,5837),(59141,5838),(59142,5838),(59143,5838),(59144,5838),(59145,5838),(59146,5838),(59147,5838),(59148,5838),(59149,5838),(59150,5838),(59151,5838),(59152,5839),(59153,5839),(59154,5839),(59155,5839),(59156,5839),(59157,5839),(59158,5839),(59159,5839),(59160,5839),(59161,5839),(59162,5839),(59163,5840),(59164,5840),(59165,5840),(59166,5840),(59167,5840),(59168,5840),(59169,5840),(59170,5840),(59171,5840),(59172,5840),(59173,5840),(59174,5841),(59175,5841),(59176,5841),(59177,5841),(59178,5841),(59179,5841),(59180,5841),(59181,5841),(59182,5841),(59183,5841),(59184,5841),(59185,5842),(59186,5842),(59187,5842),(59188,5842),(59189,5842),(59190,5842),(59191,5842),(59192,5842),(59193,5842),(59194,5842),(59195,5842),(59196,5843),(59197,5843),(59198,5843),(59199,5843),(59200,5843),(59201,5843),(59202,5843),(59203,5843),(59204,5843),(59205,5843),(59206,5843),(59207,5844),(59208,5844),(59209,5844),(59210,5844),(59211,5844),(59212,5844),(59213,5844),(59214,5844),(59215,5844),(59216,5844),(59217,5844),(59218,5845),(59219,5845),(59220,5845),(59221,5845),(59222,5845),(59223,5845),(59224,5845),(59225,5845),(59226,5845),(59227,5845),(59228,5845),(59229,5846),(59230,5846),(59231,5846),(59232,5846),(59233,5846),(59234,5846),(59235,5846),(59236,5846),(59237,5846),(59238,5846),(59239,5846),(59240,5847),(59241,5847),(59242,5847),(59243,5847),(59244,5847),(59245,5847),(59246,5847),(59247,5847),(59248,5847),(59249,5847),(59250,5847),(59251,5848),(59252,5848),(59253,5848),(59254,5848),(59255,5848),(59256,5848),(59257,5848),(59258,5848),(59259,5848),(59260,5848),(59261,5848),(59262,5849),(59263,5849),(59264,5849),(59265,5849),(59266,5849),(59267,5849),(59268,5849),(59269,5849),(59270,5849),(59271,5849),(59272,5849),(59273,5850),(59274,5850),(59275,5850),(59276,5850),(59277,5850),(59278,5850),(59279,5850),(59280,5850),(59281,5850),(59282,5850),(59283,5850),(59284,5851),(59285,5851),(59286,5851),(59287,5851),(59288,5851),(59289,5851),(59290,5851),(59291,5851),(59292,5851),(59293,5851),(59294,5851),(59295,5852),(59296,5852),(59297,5852),(59298,5852),(59299,5852),(59300,5852),(59301,5852),(59302,5852),(59303,5852),(59304,5852),(59305,5852),(59306,5853),(59307,5853),(59308,5853),(59309,5853),(59310,5853),(59311,5853),(59312,5853),(59313,5853),(59314,5853),(59315,5853),(59316,5853),(59317,5854),(59318,5854),(59319,5854),(59320,5854),(59321,5854),(59322,5854),(59323,5854),(59324,5854),(59325,5854),(59326,5854),(59327,5854),(59328,5855),(59329,5855),(59330,5855),(59331,5855),(59332,5855),(59333,5855),(59334,5855),(59335,5855),(59336,5855),(59337,5855),(59338,5855),(59339,5856),(59340,5856),(59341,5856),(59342,5856),(59343,5856),(59344,5856),(59345,5856),(59346,5856),(59347,5856),(59348,5856),(59349,5856),(59350,5857),(59351,5857),(59352,5857),(59353,5857),(59354,5857),(59355,5857),(59356,5857),(59357,5857),(59358,5857),(59359,5857),(59360,5857),(59361,5858),(59362,5858),(59363,5858),(59364,5858),(59365,5858),(59366,5858),(59367,5858),(59368,5858),(59369,5858),(59370,5858),(59371,5858),(59372,5859),(59373,5859),(59374,5859),(59375,5859),(59376,5859),(59377,5859),(59378,5859),(59379,5859),(59380,5859),(59381,5859),(59382,5859),(59383,5860),(59384,5860),(59385,5860),(59386,5860),(59387,5860),(59388,5860),(59389,5860),(59390,5860),(59391,5860),(59392,5860),(59393,5860),(59394,5861),(59395,5862),(59396,5863),(59397,5864),(59398,5865),(59399,5866),(59400,5867),(59401,5868),(59402,5869),(59403,5870),(59404,5871),(59405,5872),(59406,5873),(59407,5874),(59408,5875),(59409,5876),(59410,5877),(59411,5878),(59412,5879),(59413,5880),(59414,5881),(59415,5882),(59416,5883),(59417,5884),(59418,5885),(59419,5886),(59420,5887),(59421,5888),(59422,5889),(59423,5890),(59424,5891),(59425,5892),(59426,5893),(59427,5894),(59428,5895),(59429,5896),(59430,5897),(59431,5898),(59432,5899),(59433,5900),(59434,5901),(59435,5902),(59436,5903),(59437,5904),(59438,5905),(59439,5906),(59440,5907),(59441,5908),(59442,5909),(59443,5910),(59444,5911),(59445,5912),(59446,5913),(59447,5914),(59448,5915),(59449,5916),(59450,5917),(59451,5918),(59452,5919),(59453,5920),(59454,5921),(59455,5922),(59456,5923),(59457,5924),(59458,5925),(59459,5926),(59460,5927),(59461,5928),(59462,5929),(59463,5930),(59464,5931),(59465,5932),(59466,5933),(59467,5934),(59468,5935),(59469,5936),(59470,5937),(59471,5938),(59472,5939),(59473,5940),(59474,5941),(59475,5942),(59476,5943),(59477,5944),(59478,5945),(59479,5946),(59480,5947),(59481,5948),(59482,5949),(59483,5950),(59484,5951),(59485,5952),(59486,5953),(59487,5954),(59488,5955),(59489,5956),(59490,5957),(59491,5958),(59492,5959),(59493,5960),(59494,5861),(59495,5861),(59496,5861),(59497,5861),(59498,5861),(59499,5861),(59500,5861),(59501,5861),(59502,5861),(59503,5861),(59504,5861),(59505,5862),(59506,5862),(59507,5862),(59508,5862),(59509,5862),(59510,5862),(59511,5862),(59512,5862),(59513,5862),(59514,5862),(59515,5862),(59516,5863),(59517,5863),(59518,5863),(59519,5863),(59520,5863),(59521,5863),(59522,5863),(59523,5863),(59524,5863),(59525,5863),(59526,5863),(59527,5864),(59528,5864),(59529,5864),(59530,5864),(59531,5864),(59532,5864),(59533,5864),(59534,5864),(59535,5864),(59536,5864),(59537,5864),(59538,5865),(59539,5865),(59540,5865),(59541,5865),(59542,5865),(59543,5865),(59544,5865),(59545,5865),(59546,5865),(59547,5865),(59548,5865),(59549,5866),(59550,5866),(59551,5866),(59552,5866),(59553,5866),(59554,5866),(59555,5866),(59556,5866),(59557,5866),(59558,5866),(59559,5866),(59560,5867),(59561,5867),(59562,5867),(59563,5867),(59564,5867),(59565,5867),(59566,5867),(59567,5867),(59568,5867),(59569,5867),(59570,5867),(59571,5868),(59572,5868),(59573,5868),(59574,5868),(59575,5868),(59576,5868),(59577,5868),(59578,5868),(59579,5868),(59580,5868),(59581,5868),(59582,5869),(59583,5869),(59584,5869),(59585,5869),(59586,5869),(59587,5869),(59588,5869),(59589,5869),(59590,5869),(59591,5869),(59592,5869),(59593,5870),(59594,5870),(59595,5870),(59596,5870),(59597,5870),(59598,5870),(59599,5870),(59600,5870),(59601,5870),(59602,5870),(59603,5870),(59604,5871),(59605,5871),(59606,5871),(59607,5871),(59608,5871),(59609,5871),(59610,5871),(59611,5871),(59612,5871),(59613,5871),(59614,5871),(59615,5872),(59616,5872),(59617,5872),(59618,5872),(59619,5872),(59620,5872),(59621,5872),(59622,5872),(59623,5872),(59624,5872),(59625,5872),(59626,5873),(59627,5873),(59628,5873),(59629,5873),(59630,5873),(59631,5873),(59632,5873),(59633,5873),(59634,5873),(59635,5873),(59636,5873),(59637,5874),(59638,5874),(59639,5874),(59640,5874),(59641,5874),(59642,5874),(59643,5874),(59644,5874),(59645,5874),(59646,5874),(59647,5874),(59648,5875),(59649,5875),(59650,5875),(59651,5875),(59652,5875),(59653,5875),(59654,5875),(59655,5875),(59656,5875),(59657,5875),(59658,5875),(59659,5876),(59660,5876),(59661,5876),(59662,5876),(59663,5876),(59664,5876),(59665,5876),(59666,5876),(59667,5876),(59668,5876),(59669,5876),(59670,5877),(59671,5877),(59672,5877),(59673,5877),(59674,5877),(59675,5877),(59676,5877),(59677,5877),(59678,5877),(59679,5877),(59680,5877),(59681,5878),(59682,5878),(59683,5878),(59684,5878),(59685,5878),(59686,5878),(59687,5878),(59688,5878),(59689,5878),(59690,5878),(59691,5878),(59692,5879),(59693,5879),(59694,5879),(59695,5879),(59696,5879),(59697,5879),(59698,5879),(59699,5879),(59700,5879),(59701,5879),(59702,5879),(59703,5880),(59704,5880),(59705,5880),(59706,5880),(59707,5880),(59708,5880),(59709,5880),(59710,5880),(59711,5880),(59712,5880),(59713,5880),(59714,5881),(59715,5881),(59716,5881),(59717,5881),(59718,5881),(59719,5881),(59720,5881),(59721,5881),(59722,5881),(59723,5881),(59724,5881),(59725,5882),(59726,5882),(59727,5882),(59728,5882),(59729,5882),(59730,5882),(59731,5882),(59732,5882),(59733,5882),(59734,5882),(59735,5882),(59736,5883),(59737,5883),(59738,5883),(59739,5883),(59740,5883),(59741,5883),(59742,5883),(59743,5883),(59744,5883),(59745,5883),(59746,5883),(59747,5884),(59748,5884),(59749,5884),(59750,5884),(59751,5884),(59752,5884),(59753,5884),(59754,5884),(59755,5884),(59756,5884),(59757,5884),(59758,5885),(59759,5885),(59760,5885),(59761,5885),(59762,5885),(59763,5885),(59764,5885),(59765,5885),(59766,5885),(59767,5885),(59768,5885),(59769,5886),(59770,5886),(59771,5886),(59772,5886),(59773,5886),(59774,5886),(59775,5886),(59776,5886),(59777,5886),(59778,5886),(59779,5886),(59780,5887),(59781,5887),(59782,5887),(59783,5887),(59784,5887),(59785,5887),(59786,5887),(59787,5887),(59788,5887),(59789,5887),(59790,5887),(59791,5888),(59792,5888),(59793,5888),(59794,5888),(59795,5888),(59796,5888),(59797,5888),(59798,5888),(59799,5888),(59800,5888),(59801,5888),(59802,5889),(59803,5889),(59804,5889),(59805,5889),(59806,5889),(59807,5889),(59808,5889),(59809,5889),(59810,5889),(59811,5889),(59812,5889),(59813,5890),(59814,5890),(59815,5890),(59816,5890),(59817,5890),(59818,5890),(59819,5890),(59820,5890),(59821,5890),(59822,5890),(59823,5890),(59824,5891),(59825,5891),(59826,5891),(59827,5891),(59828,5891),(59829,5891),(59830,5891),(59831,5891),(59832,5891),(59833,5891),(59834,5891),(59835,5892),(59836,5892),(59837,5892),(59838,5892),(59839,5892),(59840,5892),(59841,5892),(59842,5892),(59843,5892),(59844,5892),(59845,5892),(59846,5893),(59847,5893),(59848,5893),(59849,5893),(59850,5893),(59851,5893),(59852,5893),(59853,5893),(59854,5893),(59855,5893),(59856,5893),(59857,5894),(59858,5894),(59859,5894),(59860,5894),(59861,5894),(59862,5894),(59863,5894),(59864,5894),(59865,5894),(59866,5894),(59867,5894),(59868,5895),(59869,5895),(59870,5895),(59871,5895),(59872,5895),(59873,5895),(59874,5895),(59875,5895),(59876,5895),(59877,5895),(59878,5895),(59879,5896),(59880,5896),(59881,5896),(59882,5896),(59883,5896),(59884,5896),(59885,5896),(59886,5896),(59887,5896),(59888,5896),(59889,5896),(59890,5897),(59891,5897),(59892,5897),(59893,5897),(59894,5897),(59895,5897),(59896,5897),(59897,5897),(59898,5897),(59899,5897),(59900,5897),(59901,5898),(59902,5898),(59903,5898),(59904,5898),(59905,5898),(59906,5898),(59907,5898),(59908,5898),(59909,5898),(59910,5898),(59911,5898),(59912,5899),(59913,5899),(59914,5899),(59915,5899),(59916,5899),(59917,5899),(59918,5899),(59919,5899),(59920,5899),(59921,5899),(59922,5899),(59923,5900),(59924,5900),(59925,5900),(59926,5900),(59927,5900),(59928,5900),(59929,5900),(59930,5900),(59931,5900),(59932,5900),(59933,5900),(59934,5901),(59935,5901),(59936,5901),(59937,5901),(59938,5901),(59939,5901),(59940,5901),(59941,5901),(59942,5901),(59943,5901),(59944,5901),(59945,5902),(59946,5902),(59947,5902),(59948,5902),(59949,5902),(59950,5902),(59951,5902),(59952,5902),(59953,5902),(59954,5902),(59955,5902),(59956,5903),(59957,5903),(59958,5903),(59959,5903),(59960,5903),(59961,5903),(59962,5903),(59963,5903),(59964,5903),(59965,5903),(59966,5903),(59967,5904),(59968,5904),(59969,5904),(59970,5904),(59971,5904),(59972,5904),(59973,5904),(59974,5904),(59975,5904),(59976,5904),(59977,5904),(59978,5905),(59979,5905),(59980,5905),(59981,5905),(59982,5905),(59983,5905),(59984,5905),(59985,5905),(59986,5905),(59987,5905),(59988,5905),(59989,5906),(59990,5906),(59991,5906),(59992,5906),(59993,5906),(59994,5906),(59995,5906),(59996,5906),(59997,5906),(59998,5906),(59999,5906),(60000,5907),(60001,5907),(60002,5907),(60003,5907),(60004,5907),(60005,5907),(60006,5907),(60007,5907),(60008,5907),(60009,5907),(60010,5907),(60011,5908),(60012,5908),(60013,5908),(60014,5908),(60015,5908),(60016,5908),(60017,5908),(60018,5908),(60019,5908),(60020,5908),(60021,5908),(60022,5909),(60023,5909),(60024,5909),(60025,5909),(60026,5909),(60027,5909),(60028,5909),(60029,5909),(60030,5909),(60031,5909),(60032,5909),(60033,5910),(60034,5910),(60035,5910),(60036,5910),(60037,5910),(60038,5910),(60039,5910),(60040,5910),(60041,5910),(60042,5910),(60043,5910),(60044,5911),(60045,5911),(60046,5911),(60047,5911),(60048,5911),(60049,5911),(60050,5911),(60051,5911),(60052,5911),(60053,5911),(60054,5911),(60055,5912),(60056,5912),(60057,5912),(60058,5912),(60059,5912),(60060,5912),(60061,5912),(60062,5912),(60063,5912),(60064,5912),(60065,5912),(60066,5913),(60067,5913),(60068,5913),(60069,5913),(60070,5913),(60071,5913),(60072,5913),(60073,5913),(60074,5913),(60075,5913),(60076,5913),(60077,5914),(60078,5914),(60079,5914),(60080,5914),(60081,5914),(60082,5914),(60083,5914),(60084,5914),(60085,5914),(60086,5914),(60087,5914),(60088,5915),(60089,5915),(60090,5915),(60091,5915),(60092,5915),(60093,5915),(60094,5915),(60095,5915),(60096,5915),(60097,5915),(60098,5915),(60099,5916),(60100,5916),(60101,5916),(60102,5916),(60103,5916),(60104,5916),(60105,5916),(60106,5916),(60107,5916),(60108,5916),(60109,5916),(60110,5917),(60111,5917),(60112,5917),(60113,5917),(60114,5917),(60115,5917),(60116,5917),(60117,5917),(60118,5917),(60119,5917),(60120,5917),(60121,5918),(60122,5918),(60123,5918),(60124,5918),(60125,5918),(60126,5918),(60127,5918),(60128,5918),(60129,5918),(60130,5918),(60131,5918),(60132,5919),(60133,5919),(60134,5919),(60135,5919),(60136,5919),(60137,5919),(60138,5919),(60139,5919),(60140,5919),(60141,5919),(60142,5919),(60143,5920),(60144,5920),(60145,5920),(60146,5920),(60147,5920),(60148,5920),(60149,5920),(60150,5920),(60151,5920),(60152,5920),(60153,5920),(60154,5921),(60155,5921),(60156,5921),(60157,5921),(60158,5921),(60159,5921),(60160,5921),(60161,5921),(60162,5921),(60163,5921),(60164,5921),(60165,5922),(60166,5922),(60167,5922),(60168,5922),(60169,5922),(60170,5922),(60171,5922),(60172,5922),(60173,5922),(60174,5922),(60175,5922),(60176,5923),(60177,5923),(60178,5923),(60179,5923),(60180,5923),(60181,5923),(60182,5923),(60183,5923),(60184,5923),(60185,5923),(60186,5923),(60187,5924),(60188,5924),(60189,5924),(60190,5924),(60191,5924),(60192,5924),(60193,5924),(60194,5924),(60195,5924),(60196,5924),(60197,5924),(60198,5925),(60199,5925),(60200,5925),(60201,5925),(60202,5925),(60203,5925),(60204,5925),(60205,5925),(60206,5925),(60207,5925),(60208,5925),(60209,5926),(60210,5926),(60211,5926),(60212,5926),(60213,5926),(60214,5926),(60215,5926),(60216,5926),(60217,5926),(60218,5926),(60219,5926),(60220,5927),(60221,5927),(60222,5927),(60223,5927),(60224,5927),(60225,5927),(60226,5927),(60227,5927),(60228,5927),(60229,5927),(60230,5927),(60231,5928),(60232,5928),(60233,5928),(60234,5928),(60235,5928),(60236,5928),(60237,5928),(60238,5928),(60239,5928),(60240,5928),(60241,5928),(60242,5929),(60243,5929),(60244,5929),(60245,5929),(60246,5929),(60247,5929),(60248,5929),(60249,5929),(60250,5929),(60251,5929),(60252,5929),(60253,5930),(60254,5930),(60255,5930),(60256,5930),(60257,5930),(60258,5930),(60259,5930),(60260,5930),(60261,5930),(60262,5930),(60263,5930),(60264,5931),(60265,5931),(60266,5931),(60267,5931),(60268,5931),(60269,5931),(60270,5931),(60271,5931),(60272,5931),(60273,5931),(60274,5931),(60275,5932),(60276,5932),(60277,5932),(60278,5932),(60279,5932),(60280,5932),(60281,5932),(60282,5932),(60283,5932),(60284,5932),(60285,5932),(60286,5933),(60287,5933),(60288,5933),(60289,5933),(60290,5933),(60291,5933),(60292,5933),(60293,5933),(60294,5933),(60295,5933),(60296,5933),(60297,5934),(60298,5934),(60299,5934),(60300,5934),(60301,5934),(60302,5934),(60303,5934),(60304,5934),(60305,5934),(60306,5934),(60307,5934),(60308,5935),(60309,5935),(60310,5935),(60311,5935),(60312,5935),(60313,5935),(60314,5935),(60315,5935),(60316,5935),(60317,5935),(60318,5935),(60319,5936),(60320,5936),(60321,5936),(60322,5936),(60323,5936),(60324,5936),(60325,5936),(60326,5936),(60327,5936),(60328,5936),(60329,5936),(60330,5937),(60331,5937),(60332,5937),(60333,5937),(60334,5937),(60335,5937),(60336,5937),(60337,5937),(60338,5937),(60339,5937),(60340,5937),(60341,5938),(60342,5938),(60343,5938),(60344,5938),(60345,5938),(60346,5938),(60347,5938),(60348,5938),(60349,5938),(60350,5938),(60351,5938),(60352,5939),(60353,5939),(60354,5939),(60355,5939),(60356,5939),(60357,5939),(60358,5939),(60359,5939),(60360,5939),(60361,5939),(60362,5939),(60363,5940),(60364,5940),(60365,5940),(60366,5940),(60367,5940),(60368,5940),(60369,5940),(60370,5940),(60371,5940),(60372,5940),(60373,5940),(60374,5941),(60375,5941),(60376,5941),(60377,5941),(60378,5941),(60379,5941),(60380,5941),(60381,5941),(60382,5941),(60383,5941),(60384,5941),(60385,5942),(60386,5942),(60387,5942),(60388,5942),(60389,5942),(60390,5942),(60391,5942),(60392,5942),(60393,5942),(60394,5942),(60395,5942),(60396,5943),(60397,5943),(60398,5943),(60399,5943),(60400,5943),(60401,5943),(60402,5943),(60403,5943),(60404,5943),(60405,5943),(60406,5943),(60407,5944),(60408,5944),(60409,5944),(60410,5944),(60411,5944),(60412,5944),(60413,5944),(60414,5944),(60415,5944),(60416,5944),(60417,5944),(60418,5945),(60419,5945),(60420,5945),(60421,5945),(60422,5945),(60423,5945),(60424,5945),(60425,5945),(60426,5945),(60427,5945),(60428,5945),(60429,5946),(60430,5946),(60431,5946),(60432,5946),(60433,5946),(60434,5946),(60435,5946),(60436,5946),(60437,5946),(60438,5946),(60439,5946),(60440,5947),(60441,5947),(60442,5947),(60443,5947),(60444,5947),(60445,5947),(60446,5947),(60447,5947),(60448,5947),(60449,5947),(60450,5947),(60451,5948),(60452,5948),(60453,5948),(60454,5948),(60455,5948),(60456,5948),(60457,5948),(60458,5948),(60459,5948),(60460,5948),(60461,5948),(60462,5949),(60463,5949),(60464,5949),(60465,5949),(60466,5949),(60467,5949),(60468,5949),(60469,5949),(60470,5949),(60471,5949),(60472,5949),(60473,5950),(60474,5950),(60475,5950),(60476,5950),(60477,5950),(60478,5950),(60479,5950),(60480,5950),(60481,5950),(60482,5950),(60483,5950),(60484,5951),(60485,5951),(60486,5951),(60487,5951),(60488,5951),(60489,5951),(60490,5951),(60491,5951),(60492,5951),(60493,5951),(60494,5951),(60495,5952),(60496,5952),(60497,5952),(60498,5952),(60499,5952),(60500,5952),(60501,5952),(60502,5952),(60503,5952),(60504,5952),(60505,5952),(60506,5953),(60507,5953),(60508,5953),(60509,5953),(60510,5953),(60511,5953),(60512,5953),(60513,5953),(60514,5953),(60515,5953),(60516,5953),(60517,5954),(60518,5954),(60519,5954),(60520,5954),(60521,5954),(60522,5954),(60523,5954),(60524,5954),(60525,5954),(60526,5954),(60527,5954),(60528,5955),(60529,5955),(60530,5955),(60531,5955),(60532,5955),(60533,5955),(60534,5955),(60535,5955),(60536,5955),(60537,5955),(60538,5955),(60539,5956),(60540,5956),(60541,5956),(60542,5956),(60543,5956),(60544,5956),(60545,5956),(60546,5956),(60547,5956),(60548,5956),(60549,5956),(60550,5957),(60551,5957),(60552,5957),(60553,5957),(60554,5957),(60555,5957),(60556,5957),(60557,5957),(60558,5957),(60559,5957),(60560,5957),(60561,5958),(60562,5958),(60563,5958),(60564,5958),(60565,5958),(60566,5958),(60567,5958),(60568,5958),(60569,5958),(60570,5958),(60571,5958),(60572,5959),(60573,5959),(60574,5959),(60575,5959),(60576,5959),(60577,5959),(60578,5959),(60579,5959),(60580,5959),(60581,5959),(60582,5959),(60583,5960),(60584,5960),(60585,5960),(60586,5960),(60587,5960),(60588,5960),(60589,5960),(60590,5960),(60591,5960),(60592,5960),(60593,5960),(60594,5961),(60595,5962),(60596,5963),(60597,5964),(60598,5965),(60599,5966),(60600,5967),(60601,5968),(60602,5969),(60603,5970),(60604,5971),(60605,5972),(60606,5973),(60607,5974),(60608,5975),(60609,5976),(60610,5977),(60611,5978),(60612,5979),(60613,5980),(60614,5981),(60615,5982),(60616,5983),(60617,5984),(60618,5985),(60619,5986),(60620,5987),(60621,5988),(60622,5989),(60623,5990),(60624,5991),(60625,5992),(60626,5993),(60627,5994),(60628,5995),(60629,5996),(60630,5997),(60631,5998),(60632,5999),(60633,6000),(60634,6001),(60635,6002),(60636,6003),(60637,6004),(60638,6005),(60639,6006),(60640,6007),(60641,6008),(60642,6009),(60643,6010),(60644,6011),(60645,6012),(60646,6013),(60647,6014),(60648,6015),(60649,6016),(60650,6017),(60651,6018),(60652,6019),(60653,6020),(60654,6021),(60655,6022),(60656,6023),(60657,6024),(60658,6025),(60659,6026),(60660,6027),(60661,6028),(60662,6029),(60663,6030),(60664,6031),(60665,6032),(60666,6033),(60667,6034),(60668,5961),(60669,5961),(60670,5961),(60671,5961),(60672,5961),(60673,5961),(60674,5961),(60675,5961),(60676,5961),(60677,5961),(60678,5961),(60679,5962),(60680,5962),(60681,5962),(60682,5962),(60683,5962),(60684,5962),(60685,5962),(60686,5962),(60687,5962),(60688,5962),(60689,5962),(60690,5963),(60691,5963),(60692,5963),(60693,5963),(60694,5963),(60695,5963),(60696,5963),(60697,5963),(60698,5963),(60699,5963),(60700,5963),(60701,5964),(60702,5964),(60703,5964),(60704,5964),(60705,5964),(60706,5964),(60707,5964),(60708,5964),(60709,5964),(60710,5964),(60711,5964),(60712,5965),(60713,5965),(60714,5965),(60715,5965),(60716,5965),(60717,5965),(60718,5965),(60719,5965),(60720,5965),(60721,5965),(60722,5965),(60723,5966),(60724,5966),(60725,5966),(60726,5966),(60727,5966),(60728,5966),(60729,5966),(60730,5966),(60731,5966),(60732,5966),(60733,5966),(60734,5967),(60735,5967),(60736,5967),(60737,5967),(60738,5967),(60739,5967),(60740,5967),(60741,5967),(60742,5967),(60743,5967),(60744,5967),(60745,5968),(60746,5968),(60747,5968),(60748,5968),(60749,5968),(60750,5968),(60751,5968),(60752,5968),(60753,5968),(60754,5968),(60755,5968),(60756,5969),(60757,5969),(60758,5969),(60759,5969),(60760,5969),(60761,5969),(60762,5969),(60763,5969),(60764,5969),(60765,5969),(60766,5969),(60767,5970),(60768,5970),(60769,5970),(60770,5970),(60771,5970),(60772,5970),(60773,5970),(60774,5970),(60775,5970),(60776,5970),(60777,5970),(60778,5971),(60779,5971),(60780,5971),(60781,5971),(60782,5971),(60783,5971),(60784,5971),(60785,5971),(60786,5971),(60787,5971),(60788,5971),(60789,5972),(60790,5972),(60791,5972),(60792,5972),(60793,5972),(60794,5972),(60795,5972),(60796,5972),(60797,5972),(60798,5972),(60799,5972),(60800,5973),(60801,5973),(60802,5973),(60803,5973),(60804,5973),(60805,5973),(60806,5973),(60807,5973),(60808,5973),(60809,5973),(60810,5973),(60811,5974),(60812,5974),(60813,5974),(60814,5974),(60815,5974),(60816,5974),(60817,5974),(60818,5974),(60819,5974),(60820,5974),(60821,5974),(60822,5975),(60823,5975),(60824,5975),(60825,5975),(60826,5975),(60827,5975),(60828,5975),(60829,5975),(60830,5975),(60831,5975),(60832,5975),(60833,5976),(60834,5976),(60835,5976),(60836,5976),(60837,5976),(60838,5976),(60839,5976),(60840,5976),(60841,5976),(60842,5976),(60843,5976),(60844,5977),(60845,5977),(60846,5977),(60847,5977),(60848,5977),(60849,5977),(60850,5977),(60851,5977),(60852,5977),(60853,5977),(60854,5977),(60855,5978),(60856,5978),(60857,5978),(60858,5978),(60859,5978),(60860,5978),(60861,5978),(60862,5978),(60863,5978),(60864,5978),(60865,5978),(60866,5979),(60867,5979),(60868,5979),(60869,5979),(60870,5979),(60871,5979),(60872,5979),(60873,5979),(60874,5979),(60875,5979),(60876,5979),(60877,5980),(60878,5980),(60879,5980),(60880,5980),(60881,5980),(60882,5980),(60883,5980),(60884,5980),(60885,5980),(60886,5980),(60887,5980),(60888,5981),(60889,5981),(60890,5981),(60891,5981),(60892,5981),(60893,5981),(60894,5981),(60895,5981),(60896,5981),(60897,5981),(60898,5981),(60899,5982),(60900,5982),(60901,5982),(60902,5982),(60903,5982),(60904,5982),(60905,5982),(60906,5982),(60907,5982),(60908,5982),(60909,5982),(60910,5983),(60911,5983),(60912,5983),(60913,5983),(60914,5983),(60915,5983),(60916,5983),(60917,5983),(60918,5983),(60919,5983),(60920,5983),(60921,5984),(60922,5984),(60923,5984),(60924,5984),(60925,5984),(60926,5984),(60927,5984),(60928,5984),(60929,5984),(60930,5984),(60931,5984),(60932,5985),(60933,5985),(60934,5985),(60935,5985),(60936,5985),(60937,5985),(60938,5985),(60939,5985),(60940,5985),(60941,5985),(60942,5985),(60943,5986),(60944,5986),(60945,5986),(60946,5986),(60947,5986),(60948,5986),(60949,5986),(60950,5986),(60951,5986),(60952,5986),(60953,5986),(60954,5987),(60955,5987),(60956,5987),(60957,5987),(60958,5987),(60959,5987),(60960,5987),(60961,5987),(60962,5987),(60963,5987),(60964,5987),(60965,5988),(60966,5988),(60967,5988),(60968,5988),(60969,5988),(60970,5988),(60971,5988),(60972,5988),(60973,5988),(60974,5988),(60975,5988),(60976,5989),(60977,5989),(60978,5989),(60979,5989),(60980,5989),(60981,5989),(60982,5989),(60983,5989),(60984,5989),(60985,5989),(60986,5989),(60987,5990),(60988,5990),(60989,5990),(60990,5990),(60991,5990),(60992,5990),(60993,5990),(60994,5990),(60995,5990),(60996,5990),(60997,5990),(60998,5991),(60999,5991),(61000,5991),(61001,5991),(61002,5991),(61003,5991),(61004,5991),(61005,5991),(61006,5991),(61007,5991),(61008,5991),(61009,5992),(61010,5992),(61011,5992),(61012,5992),(61013,5992),(61014,5992),(61015,5992),(61016,5992),(61017,5992),(61018,5992),(61019,5992),(61020,5993),(61021,5993),(61022,5993),(61023,5993),(61024,5993),(61025,5993),(61026,5993),(61027,5993),(61028,5993),(61029,5993),(61030,5993),(61031,5994),(61032,5994),(61033,5994),(61034,5994),(61035,5994),(61036,5994),(61037,5994),(61038,5994),(61039,5994),(61040,5994),(61041,5994),(61042,5995),(61043,5995),(61044,5995),(61045,5995),(61046,5995),(61047,5995),(61048,5995),(61049,5995),(61050,5995),(61051,5995),(61052,5995),(61053,5996),(61054,5996),(61055,5996),(61056,5996),(61057,5996),(61058,5996),(61059,5996),(61060,5996),(61061,5996),(61062,5996),(61063,5996),(61064,5997),(61065,5997),(61066,5997),(61067,5997),(61068,5997),(61069,5997),(61070,5997),(61071,5997),(61072,5997),(61073,5997),(61074,5997),(61075,5998),(61076,5998),(61077,5998),(61078,5998),(61079,5998),(61080,5998),(61081,5998),(61082,5998),(61083,5998),(61084,5998),(61085,5998),(61086,5999),(61087,5999),(61088,5999),(61089,5999),(61090,5999),(61091,5999),(61092,5999),(61093,5999),(61094,5999),(61095,5999),(61096,5999),(61097,6000),(61098,6000),(61099,6000),(61100,6000),(61101,6000),(61102,6000),(61103,6000),(61104,6000),(61105,6000),(61106,6000),(61107,6000),(61108,6001),(61109,6001),(61110,6001),(61111,6001),(61112,6001),(61113,6001),(61114,6001),(61115,6001),(61116,6001),(61117,6001),(61118,6001),(61119,6002),(61120,6002),(61121,6002),(61122,6002),(61123,6002),(61124,6002),(61125,6002),(61126,6002),(61127,6002),(61128,6002),(61129,6002),(61130,6003),(61131,6003),(61132,6003),(61133,6003),(61134,6003),(61135,6003),(61136,6003),(61137,6003),(61138,6003),(61139,6003),(61140,6003),(61141,6004),(61142,6004),(61143,6004),(61144,6004),(61145,6004),(61146,6004),(61147,6004),(61148,6004),(61149,6004),(61150,6004),(61151,6004),(61152,6005),(61153,6005),(61154,6005),(61155,6005),(61156,6005),(61157,6005),(61158,6005),(61159,6005),(61160,6005),(61161,6005),(61162,6005),(61163,6006),(61164,6006),(61165,6006),(61166,6006),(61167,6006),(61168,6006),(61169,6006),(61170,6006),(61171,6006),(61172,6006),(61173,6006),(61174,6007),(61175,6007),(61176,6007),(61177,6007),(61178,6007),(61179,6007),(61180,6007),(61181,6007),(61182,6007),(61183,6007),(61184,6007),(61185,6008),(61186,6008),(61187,6008),(61188,6008),(61189,6008),(61190,6008),(61191,6008),(61192,6008),(61193,6008),(61194,6008),(61195,6008),(61196,6009),(61197,6009),(61198,6009),(61199,6009),(61200,6009),(61201,6009),(61202,6009),(61203,6009),(61204,6009),(61205,6009),(61206,6009),(61207,6010),(61208,6010),(61209,6010),(61210,6010),(61211,6010),(61212,6010),(61213,6010),(61214,6010),(61215,6010),(61216,6010),(61217,6010),(61218,6011),(61219,6011),(61220,6011),(61221,6011),(61222,6011),(61223,6011),(61224,6011),(61225,6011),(61226,6011),(61227,6011),(61228,6011),(61229,6012),(61230,6012),(61231,6012),(61232,6012),(61233,6012),(61234,6012),(61235,6012),(61236,6012),(61237,6012),(61238,6012),(61239,6012),(61240,6013),(61241,6013),(61242,6013),(61243,6013),(61244,6013),(61245,6013),(61246,6013),(61247,6013),(61248,6013),(61249,6013),(61250,6013),(61251,6014),(61252,6014),(61253,6014),(61254,6014),(61255,6014),(61256,6014),(61257,6014),(61258,6014),(61259,6014),(61260,6014),(61261,6014),(61262,6015),(61263,6015),(61264,6015),(61265,6015),(61266,6015),(61267,6015),(61268,6015),(61269,6015),(61270,6015),(61271,6015),(61272,6015),(61273,6016),(61274,6016),(61275,6016),(61276,6016),(61277,6016),(61278,6016),(61279,6016),(61280,6016),(61281,6016),(61282,6016),(61283,6016),(61284,6017),(61285,6017),(61286,6017),(61287,6017),(61288,6017),(61289,6017),(61290,6017),(61291,6017),(61292,6017),(61293,6017),(61294,6017),(61295,6018),(61296,6018),(61297,6018),(61298,6018),(61299,6018),(61300,6018),(61301,6018),(61302,6018),(61303,6018),(61304,6018),(61305,6018),(61306,6019),(61307,6019),(61308,6019),(61309,6019),(61310,6019),(61311,6019),(61312,6019),(61313,6019),(61314,6019),(61315,6019),(61316,6019),(61317,6020),(61318,6020),(61319,6020),(61320,6020),(61321,6020),(61322,6020),(61323,6020),(61324,6020),(61325,6020),(61326,6020),(61327,6020),(61328,6021),(61329,6021),(61330,6021),(61331,6021),(61332,6021),(61333,6021),(61334,6021),(61335,6021),(61336,6021),(61337,6021),(61338,6021),(61339,6022),(61340,6022),(61341,6022),(61342,6022),(61343,6022),(61344,6022),(61345,6022),(61346,6022),(61347,6022),(61348,6022),(61349,6022),(61350,6023),(61351,6023),(61352,6023),(61353,6023),(61354,6023),(61355,6023),(61356,6023),(61357,6023),(61358,6023),(61359,6023),(61360,6023),(61361,6024),(61362,6024),(61363,6024),(61364,6024),(61365,6024),(61366,6024),(61367,6024),(61368,6024),(61369,6024),(61370,6024),(61371,6024),(61372,6025),(61373,6025),(61374,6025),(61375,6025),(61376,6025),(61377,6025),(61378,6025),(61379,6025),(61380,6025),(61381,6025),(61382,6025),(61383,6026),(61384,6026),(61385,6026),(61386,6026),(61387,6026),(61388,6026),(61389,6026),(61390,6026),(61391,6026),(61392,6026),(61393,6026),(61394,6027),(61395,6027),(61396,6027),(61397,6027),(61398,6027),(61399,6027),(61400,6027),(61401,6027),(61402,6027),(61403,6027),(61404,6027),(61405,6028),(61406,6028),(61407,6028),(61408,6028),(61409,6028),(61410,6028),(61411,6028),(61412,6028),(61413,6028),(61414,6028),(61415,6028),(61416,6029),(61417,6029),(61418,6029),(61419,6029),(61420,6029),(61421,6029),(61422,6029),(61423,6029),(61424,6029),(61425,6029),(61426,6029),(61427,6030),(61428,6030),(61429,6030),(61430,6030),(61431,6030),(61432,6030),(61433,6030),(61434,6030),(61435,6030),(61436,6030),(61437,6030),(61438,6031),(61439,6031),(61440,6031),(61441,6031),(61442,6031),(61443,6031),(61444,6031),(61445,6031),(61446,6031),(61447,6031),(61448,6031),(61449,6032),(61450,6032),(61451,6032),(61452,6032),(61453,6032),(61454,6032),(61455,6032),(61456,6032),(61457,6032),(61458,6032),(61459,6032),(61460,6033),(61461,6033),(61462,6033),(61463,6033),(61464,6033),(61465,6033),(61466,6033),(61467,6033),(61468,6033),(61469,6033),(61470,6033),(61471,6034),(61472,6034),(61473,6034),(61474,6034),(61475,6034),(61476,6034),(61477,6034),(61478,6034),(61479,6034),(61480,6034),(61481,6034),(61482,6035),(61483,6036),(61484,6037),(61485,6038),(61486,6039),(61487,6040),(61488,6041),(61489,6042),(61490,6043),(61491,6044),(61492,6045),(61493,6046),(61494,6047),(61495,6048),(61496,6049),(61497,6050),(61498,6051),(61499,6052),(61500,6053),(61501,6054),(61502,6055),(61503,6056),(61504,6057),(61505,6058),(61506,6059),(61507,6060),(61508,6061),(61509,6062),(61510,6063),(61511,6064),(61512,6065),(61513,6066),(61514,6067),(61515,6068),(61516,6069),(61517,6070),(61518,6071),(61519,6072),(61520,6073),(61521,6074),(61522,6075),(61523,6076),(61524,6077),(61525,6078),(61526,6079),(61527,6080),(61528,6081),(61529,6082),(61530,6083),(61531,6084),(61532,6085),(61533,6086),(61534,6087),(61535,6088),(61536,6089),(61537,6090),(61538,6091),(61539,6092),(61540,6093),(61541,6094),(61542,6095),(61543,6096),(61544,6097),(61545,6098),(61546,6099),(61547,6100),(61548,6101),(61549,6102),(61550,6103),(61551,6104),(61552,6105),(61553,6106),(61554,6107),(61555,6108),(61556,6109),(61557,6110),(61558,6111),(61559,6112),(61560,6113),(61561,6114),(61562,6115),(61563,6116),(61564,6117),(61565,6118),(61566,6119),(61567,6120),(61568,6121),(61569,6122),(61570,6123),(61571,6124),(61572,6125),(61573,6126),(61574,6127),(61575,6128),(61576,6129),(61577,6130),(61578,6131),(61579,6132),(61580,6133),(61581,6134),(61582,6035),(61583,6035),(61584,6035),(61585,6035),(61586,6035),(61587,6036),(61588,6036),(61589,6036),(61590,6036),(61591,6036),(61592,6037),(61593,6037),(61594,6037),(61595,6037),(61596,6037),(61597,6038),(61598,6038),(61599,6038),(61600,6038),(61601,6038),(61602,6039),(61603,6039),(61604,6039),(61605,6039),(61606,6039),(61607,6040),(61608,6040),(61609,6040),(61610,6040),(61611,6040),(61612,6041),(61613,6041),(61614,6041),(61615,6041),(61616,6041),(61617,6042),(61618,6042),(61619,6042),(61620,6042),(61621,6042),(61622,6043),(61623,6043),(61624,6043),(61625,6043),(61626,6043),(61627,6044),(61628,6044),(61629,6044),(61630,6044),(61631,6044),(61632,6045),(61633,6045),(61634,6045),(61635,6045),(61636,6045),(61637,6046),(61638,6046),(61639,6046),(61640,6046),(61641,6046),(61642,6047),(61643,6047),(61644,6047),(61645,6047),(61646,6047),(61647,6048),(61648,6048),(61649,6048),(61650,6048),(61651,6048),(61652,6049),(61653,6049),(61654,6049),(61655,6049),(61656,6049),(61657,6050),(61658,6050),(61659,6050),(61660,6050),(61661,6050),(61662,6051),(61663,6051),(61664,6051),(61665,6051),(61666,6051),(61667,6052),(61668,6052),(61669,6052),(61670,6052),(61671,6052),(61672,6053),(61673,6053),(61674,6053),(61675,6053),(61676,6053),(61677,6054),(61678,6054),(61679,6054),(61680,6054),(61681,6054),(61682,6055),(61683,6055),(61684,6055),(61685,6055),(61686,6055),(61687,6056),(61688,6056),(61689,6056),(61690,6056),(61691,6056),(61692,6057),(61693,6057),(61694,6057),(61695,6057),(61696,6057),(61697,6058),(61698,6058),(61699,6058),(61700,6058),(61701,6058),(61702,6059),(61703,6059),(61704,6059),(61705,6059),(61706,6059),(61707,6060),(61708,6060),(61709,6060),(61710,6060),(61711,6060),(61712,6061),(61713,6061),(61714,6061),(61715,6061),(61716,6061),(61717,6062),(61718,6062),(61719,6062),(61720,6062),(61721,6062),(61722,6063),(61723,6063),(61724,6063),(61725,6063),(61726,6063),(61727,6064),(61728,6064),(61729,6064),(61730,6064),(61731,6064),(61732,6065),(61733,6065),(61734,6065),(61735,6065),(61736,6065),(61737,6066),(61738,6066),(61739,6066),(61740,6066),(61741,6066),(61742,6067),(61743,6067),(61744,6067),(61745,6067),(61746,6067),(61747,6068),(61748,6068),(61749,6068),(61750,6068),(61751,6068),(61752,6069),(61753,6069),(61754,6069),(61755,6069),(61756,6069),(61757,6070),(61758,6070),(61759,6070),(61760,6070),(61761,6070),(61762,6071),(61763,6071),(61764,6071),(61765,6071),(61766,6071),(61767,6072),(61768,6072),(61769,6072),(61770,6072),(61771,6072),(61772,6073),(61773,6073),(61774,6073),(61775,6073),(61776,6073),(61777,6074),(61778,6074),(61779,6074),(61780,6074),(61781,6074),(61782,6075),(61783,6075),(61784,6075),(61785,6075),(61786,6075),(61787,6076),(61788,6076),(61789,6076),(61790,6076),(61791,6076),(61792,6077),(61793,6077),(61794,6077),(61795,6077),(61796,6077),(61797,6078),(61798,6078),(61799,6078),(61800,6078),(61801,6078),(61802,6079),(61803,6079),(61804,6079),(61805,6079),(61806,6079),(61807,6080),(61808,6080),(61809,6080),(61810,6080),(61811,6080),(61812,6081),(61813,6081),(61814,6081),(61815,6081),(61816,6081),(61817,6082),(61818,6082),(61819,6082),(61820,6082),(61821,6082),(61822,6083),(61823,6083),(61824,6083),(61825,6083),(61826,6083),(61827,6084),(61828,6084),(61829,6084),(61830,6084),(61831,6084),(61832,6085),(61833,6085),(61834,6085),(61835,6085),(61836,6085),(61837,6086),(61838,6086),(61839,6086),(61840,6086),(61841,6086),(61842,6087),(61843,6087),(61844,6087),(61845,6087),(61846,6087),(61847,6088),(61848,6088),(61849,6088),(61850,6088),(61851,6088),(61852,6089),(61853,6089),(61854,6089),(61855,6089),(61856,6089),(61857,6090),(61858,6090),(61859,6090),(61860,6090),(61861,6090),(61862,6091),(61863,6091),(61864,6091),(61865,6091),(61866,6091),(61867,6092),(61868,6092),(61869,6092),(61870,6092),(61871,6092),(61872,6093),(61873,6093),(61874,6093),(61875,6093),(61876,6093),(61877,6094),(61878,6094),(61879,6094),(61880,6094),(61881,6094),(61882,6095),(61883,6095),(61884,6095),(61885,6095),(61886,6095),(61887,6096),(61888,6096),(61889,6096),(61890,6096),(61891,6096),(61892,6097),(61893,6097),(61894,6097),(61895,6097),(61896,6097),(61897,6098),(61898,6098),(61899,6098),(61900,6098),(61901,6098),(61902,6099),(61903,6099),(61904,6099),(61905,6099),(61906,6099),(61907,6100),(61908,6100),(61909,6100),(61910,6100),(61911,6100),(61912,6101),(61913,6101),(61914,6101),(61915,6101),(61916,6101),(61917,6102),(61918,6102),(61919,6102),(61920,6102),(61921,6102),(61922,6103),(61923,6103),(61924,6103),(61925,6103),(61926,6103),(61927,6104),(61928,6104),(61929,6104),(61930,6104),(61931,6104),(61932,6105),(61933,6105),(61934,6105),(61935,6105),(61936,6105),(61937,6106),(61938,6106),(61939,6106),(61940,6106),(61941,6106),(61942,6107),(61943,6107),(61944,6107),(61945,6107),(61946,6107),(61947,6108),(61948,6108),(61949,6108),(61950,6108),(61951,6108),(61952,6109),(61953,6109),(61954,6109),(61955,6109),(61956,6109),(61957,6110),(61958,6110),(61959,6110),(61960,6110),(61961,6110),(61962,6111),(61963,6111),(61964,6111),(61965,6111),(61966,6111),(61967,6112),(61968,6112),(61969,6112),(61970,6112),(61971,6112),(61972,6113),(61973,6113),(61974,6113),(61975,6113),(61976,6113),(61977,6114),(61978,6114),(61979,6114),(61980,6114),(61981,6114),(61982,6115),(61983,6115),(61984,6115),(61985,6115),(61986,6115),(61987,6116),(61988,6116),(61989,6116),(61990,6116),(61991,6116),(61992,6117),(61993,6117),(61994,6117),(61995,6117),(61996,6117),(61997,6118),(61998,6118),(61999,6118),(62000,6118),(62001,6118),(62002,6119),(62003,6119),(62004,6119),(62005,6119),(62006,6119),(62007,6120),(62008,6120),(62009,6120),(62010,6120),(62011,6120),(62012,6121),(62013,6121),(62014,6121),(62015,6121),(62016,6121),(62017,6122),(62018,6122),(62019,6122),(62020,6122),(62021,6122),(62022,6123),(62023,6123),(62024,6123),(62025,6123),(62026,6123),(62027,6124),(62028,6124),(62029,6124),(62030,6124),(62031,6124),(62032,6125),(62033,6125),(62034,6125),(62035,6125),(62036,6125),(62037,6126),(62038,6126),(62039,6126),(62040,6126),(62041,6126),(62042,6127),(62043,6127),(62044,6127),(62045,6127),(62046,6127),(62047,6128),(62048,6128),(62049,6128),(62050,6128),(62051,6128),(62052,6129),(62053,6129),(62054,6129),(62055,6129),(62056,6129),(62057,6130),(62058,6130),(62059,6130),(62060,6130),(62061,6130),(62062,6131),(62063,6131),(62064,6131),(62065,6131),(62066,6131),(62067,6132),(62068,6132),(62069,6132),(62070,6132),(62071,6132),(62072,6133),(62073,6133),(62074,6133),(62075,6133),(62076,6133),(62077,6134),(62078,6134),(62079,6134),(62080,6134),(62081,6134),(62082,6135),(62083,6136),(62084,6137),(62085,6138),(62086,6139),(62087,6140),(62088,6141),(62089,6142),(62090,6143),(62091,6144),(62092,6145),(62093,6146),(62094,6147),(62095,6148),(62096,6149),(62097,6150),(62098,6151),(62099,6152),(62100,6153),(62101,6154),(62102,6155),(62103,6156),(62104,6157),(62105,6158),(62106,6159),(62107,6160),(62108,6161),(62109,6162),(62110,6163),(62111,6164),(62112,6165),(62113,6166),(62114,6167),(62115,6168),(62116,6169),(62117,6170),(62118,6171),(62119,6172),(62120,6173),(62121,6174),(62122,6175),(62123,6176),(62124,6177),(62125,6178),(62126,6179),(62127,6180),(62128,6181),(62129,6182),(62130,6183),(62131,6184),(62132,6185),(62133,6186),(62134,6187),(62135,6188),(62136,6189),(62137,6190),(62138,6191),(62139,6192),(62140,6193),(62141,6194),(62142,6195),(62143,6196),(62144,6197),(62145,6198),(62146,6199),(62147,6200),(62148,6201),(62149,6202),(62150,6203),(62151,6204),(62152,6205),(62153,6206),(62154,6207),(62155,6208),(62156,6209),(62157,6210),(62158,6211),(62159,6212),(62160,6213),(62161,6214),(62162,6215),(62163,6216),(62164,6217),(62165,6218),(62166,6219),(62167,6220),(62168,6221),(62169,6222),(62170,6223),(62171,6224),(62172,6225),(62173,6226),(62174,6227),(62175,6228),(62176,6229),(62177,6230),(62178,6231),(62179,6232),(62180,6233),(62181,6234),(62182,6135),(62183,6135),(62184,6135),(62185,6135),(62186,6135),(62187,6136),(62188,6136),(62189,6136),(62190,6136),(62191,6136),(62192,6137),(62193,6137),(62194,6137),(62195,6137),(62196,6137),(62197,6138),(62198,6138),(62199,6138),(62200,6138),(62201,6138),(62202,6139),(62203,6139),(62204,6139),(62205,6139),(62206,6139),(62207,6140),(62208,6140),(62209,6140),(62210,6140),(62211,6140),(62212,6141),(62213,6141),(62214,6141),(62215,6141),(62216,6141),(62217,6142),(62218,6142),(62219,6142),(62220,6142),(62221,6142),(62222,6143),(62223,6143),(62224,6143),(62225,6143),(62226,6143),(62227,6144),(62228,6144),(62229,6144),(62230,6144),(62231,6144),(62232,6145),(62233,6145),(62234,6145),(62235,6145),(62236,6145),(62237,6146),(62238,6146),(62239,6146),(62240,6146),(62241,6146),(62242,6147),(62243,6147),(62244,6147),(62245,6147),(62246,6147),(62247,6148),(62248,6148),(62249,6148),(62250,6148),(62251,6148),(62252,6149),(62253,6149),(62254,6149),(62255,6149),(62256,6149),(62257,6150),(62258,6150),(62259,6150),(62260,6150),(62261,6150),(62262,6151),(62263,6151),(62264,6151),(62265,6151),(62266,6151),(62267,6152),(62268,6152),(62269,6152),(62270,6152),(62271,6152),(62272,6153),(62273,6153),(62274,6153),(62275,6153),(62276,6153),(62277,6154),(62278,6154),(62279,6154),(62280,6154),(62281,6154),(62282,6155),(62283,6155),(62284,6155),(62285,6155),(62286,6155),(62287,6156),(62288,6156),(62289,6156),(62290,6156),(62291,6156),(62292,6157),(62293,6157),(62294,6157),(62295,6157),(62296,6157),(62297,6158),(62298,6158),(62299,6158),(62300,6158),(62301,6158),(62302,6159),(62303,6159),(62304,6159),(62305,6159),(62306,6159),(62307,6160),(62308,6160),(62309,6160),(62310,6160),(62311,6160),(62312,6161),(62313,6161),(62314,6161),(62315,6161),(62316,6161),(62317,6162),(62318,6162),(62319,6162),(62320,6162),(62321,6162),(62322,6163),(62323,6163),(62324,6163),(62325,6163),(62326,6163),(62327,6164),(62328,6164),(62329,6164),(62330,6164),(62331,6164),(62332,6165),(62333,6165),(62334,6165),(62335,6165),(62336,6165),(62337,6166),(62338,6166),(62339,6166),(62340,6166),(62341,6166),(62342,6167),(62343,6167),(62344,6167),(62345,6167),(62346,6167),(62347,6168),(62348,6168),(62349,6168),(62350,6168),(62351,6168),(62352,6169),(62353,6169),(62354,6169),(62355,6169),(62356,6169),(62357,6170),(62358,6170),(62359,6170),(62360,6170),(62361,6170),(62362,6171),(62363,6171),(62364,6171),(62365,6171),(62366,6171),(62367,6172),(62368,6172),(62369,6172),(62370,6172),(62371,6172),(62372,6173),(62373,6173),(62374,6173),(62375,6173),(62376,6173),(62377,6174),(62378,6174),(62379,6174),(62380,6174),(62381,6174),(62382,6175),(62383,6175),(62384,6175),(62385,6175),(62386,6175),(62387,6176),(62388,6176),(62389,6176),(62390,6176),(62391,6176),(62392,6177),(62393,6177),(62394,6177),(62395,6177),(62396,6177),(62397,6178),(62398,6178),(62399,6178),(62400,6178),(62401,6178),(62402,6179),(62403,6179),(62404,6179),(62405,6179),(62406,6179),(62407,6180),(62408,6180),(62409,6180),(62410,6180),(62411,6180),(62412,6181),(62413,6181),(62414,6181),(62415,6181),(62416,6181),(62417,6182),(62418,6182),(62419,6182),(62420,6182),(62421,6182),(62422,6183),(62423,6183),(62424,6183),(62425,6183),(62426,6183),(62427,6184),(62428,6184),(62429,6184),(62430,6184),(62431,6184),(62432,6185),(62433,6185),(62434,6185),(62435,6185),(62436,6185),(62437,6186),(62438,6186),(62439,6186),(62440,6186),(62441,6186),(62442,6187),(62443,6187),(62444,6187),(62445,6187),(62446,6187),(62447,6188),(62448,6188),(62449,6188),(62450,6188),(62451,6188),(62452,6189),(62453,6189),(62454,6189),(62455,6189),(62456,6189),(62457,6190),(62458,6190),(62459,6190),(62460,6190),(62461,6190),(62462,6191),(62463,6191),(62464,6191),(62465,6191),(62466,6191),(62467,6192),(62468,6192),(62469,6192),(62470,6192),(62471,6192),(62472,6193),(62473,6193),(62474,6193),(62475,6193),(62476,6193),(62477,6194),(62478,6194),(62479,6194),(62480,6194),(62481,6194),(62482,6195),(62483,6195),(62484,6195),(62485,6195),(62486,6195),(62487,6196),(62488,6196),(62489,6196),(62490,6196),(62491,6196),(62492,6197),(62493,6197),(62494,6197),(62495,6197),(62496,6197),(62497,6198),(62498,6198),(62499,6198),(62500,6198),(62501,6198),(62502,6199),(62503,6199),(62504,6199),(62505,6199),(62506,6199),(62507,6200),(62508,6200),(62509,6200),(62510,6200),(62511,6200),(62512,6201),(62513,6201),(62514,6201),(62515,6201),(62516,6201),(62517,6202),(62518,6202),(62519,6202),(62520,6202),(62521,6202),(62522,6203),(62523,6203),(62524,6203),(62525,6203),(62526,6203),(62527,6204),(62528,6204),(62529,6204),(62530,6204),(62531,6204),(62532,6205),(62533,6205),(62534,6205),(62535,6205),(62536,6205),(62537,6206),(62538,6206),(62539,6206),(62540,6206),(62541,6206),(62542,6207),(62543,6207),(62544,6207),(62545,6207),(62546,6207),(62547,6208),(62548,6208),(62549,6208),(62550,6208),(62551,6208),(62552,6209),(62553,6209),(62554,6209),(62555,6209),(62556,6209),(62557,6210),(62558,6210),(62559,6210),(62560,6210),(62561,6210),(62562,6211),(62563,6211),(62564,6211),(62565,6211),(62566,6211),(62567,6212),(62568,6212),(62569,6212),(62570,6212),(62571,6212),(62572,6213),(62573,6213),(62574,6213),(62575,6213),(62576,6213),(62577,6214),(62578,6214),(62579,6214),(62580,6214),(62581,6214),(62582,6215),(62583,6215),(62584,6215),(62585,6215),(62586,6215),(62587,6216),(62588,6216),(62589,6216),(62590,6216),(62591,6216),(62592,6217),(62593,6217),(62594,6217),(62595,6217),(62596,6217),(62597,6218),(62598,6218),(62599,6218),(62600,6218),(62601,6218),(62602,6219),(62603,6219),(62604,6219),(62605,6219),(62606,6219),(62607,6220),(62608,6220),(62609,6220),(62610,6220),(62611,6220),(62612,6221),(62613,6221),(62614,6221),(62615,6221),(62616,6221),(62617,6222),(62618,6222),(62619,6222),(62620,6222),(62621,6222),(62622,6223),(62623,6223),(62624,6223),(62625,6223),(62626,6223),(62627,6224),(62628,6224),(62629,6224),(62630,6224),(62631,6224),(62632,6225),(62633,6225),(62634,6225),(62635,6225),(62636,6225),(62637,6226),(62638,6226),(62639,6226),(62640,6226),(62641,6226),(62642,6227),(62643,6227),(62644,6227),(62645,6227),(62646,6227),(62647,6228),(62648,6228),(62649,6228),(62650,6228),(62651,6228),(62652,6229),(62653,6229),(62654,6229),(62655,6229),(62656,6229),(62657,6230),(62658,6230),(62659,6230),(62660,6230),(62661,6230),(62662,6231),(62663,6231),(62664,6231),(62665,6231),(62666,6231),(62667,6232),(62668,6232),(62669,6232),(62670,6232),(62671,6232),(62672,6233),(62673,6233),(62674,6233),(62675,6233),(62676,6233),(62677,6234),(62678,6234),(62679,6234),(62680,6234),(62681,6234),(62682,6235),(62683,6236),(62684,6237),(62685,6238),(62686,6239),(62687,6240),(62688,6241),(62689,6242),(62690,6243),(62691,6244),(62692,6245),(62693,6246),(62694,6247),(62695,6248),(62696,6249),(62697,6250),(62698,6251),(62699,6252),(62700,6253),(62701,6254),(62702,6255),(62703,6256),(62704,6257),(62705,6258),(62706,6259),(62707,6260),(62708,6261),(62709,6262),(62710,6263),(62711,6264),(62712,6265),(62713,6266),(62714,6267),(62715,6268),(62716,6269),(62717,6270),(62718,6271),(62719,6272),(62720,6273),(62721,6274),(62722,6275),(62723,6276),(62724,6277),(62725,6278),(62726,6279),(62727,6280),(62728,6281),(62729,6282),(62730,6283),(62731,6284),(62732,6285),(62733,6286),(62734,6287),(62735,6288),(62736,6289),(62737,6290),(62738,6291),(62739,6292),(62740,6293),(62741,6294),(62742,6295),(62743,6296),(62744,6297),(62745,6298),(62746,6299),(62747,6300),(62748,6301),(62749,6302),(62750,6303),(62751,6304),(62752,6305),(62753,6306),(62754,6307),(62755,6308),(62756,6309),(62757,6310),(62758,6311),(62759,6312),(62760,6313),(62761,6314),(62762,6315),(62763,6316),(62764,6317),(62765,6318),(62766,6319),(62767,6320),(62768,6321),(62769,6322),(62770,6323),(62771,6324),(62772,6325),(62773,6326),(62774,6327),(62775,6328),(62776,6329),(62777,6330),(62778,6331),(62779,6332),(62780,6333),(62781,6334),(62782,6235),(62783,6235),(62784,6235),(62785,6235),(62786,6235),(62787,6236),(62788,6236),(62789,6236),(62790,6236),(62791,6236),(62792,6237),(62793,6237),(62794,6237),(62795,6237),(62796,6237),(62797,6238),(62798,6238),(62799,6238),(62800,6238),(62801,6238),(62802,6239),(62803,6239),(62804,6239),(62805,6239),(62806,6239),(62807,6240),(62808,6240),(62809,6240),(62810,6240),(62811,6240),(62812,6241),(62813,6241),(62814,6241),(62815,6241),(62816,6241),(62817,6242),(62818,6242),(62819,6242),(62820,6242),(62821,6242),(62822,6243),(62823,6243),(62824,6243),(62825,6243),(62826,6243),(62827,6244),(62828,6244),(62829,6244),(62830,6244),(62831,6244),(62832,6245),(62833,6245),(62834,6245),(62835,6245),(62836,6245),(62837,6246),(62838,6246),(62839,6246),(62840,6246),(62841,6246),(62842,6247),(62843,6247),(62844,6247),(62845,6247),(62846,6247),(62847,6248),(62848,6248),(62849,6248),(62850,6248),(62851,6248),(62852,6249),(62853,6249),(62854,6249),(62855,6249),(62856,6249),(62857,6250),(62858,6250),(62859,6250),(62860,6250),(62861,6250),(62862,6251),(62863,6251),(62864,6251),(62865,6251),(62866,6251),(62867,6252),(62868,6252),(62869,6252),(62870,6252),(62871,6252),(62872,6253),(62873,6253),(62874,6253),(62875,6253),(62876,6253),(62877,6254),(62878,6254),(62879,6254),(62880,6254),(62881,6254),(62882,6255),(62883,6255),(62884,6255),(62885,6255),(62886,6255),(62887,6256),(62888,6256),(62889,6256),(62890,6256),(62891,6256),(62892,6257),(62893,6257),(62894,6257),(62895,6257),(62896,6257),(62897,6258),(62898,6258),(62899,6258),(62900,6258),(62901,6258),(62902,6259),(62903,6259),(62904,6259),(62905,6259),(62906,6259),(62907,6260),(62908,6260),(62909,6260),(62910,6260),(62911,6260),(62912,6261),(62913,6261),(62914,6261),(62915,6261),(62916,6261),(62917,6262),(62918,6262),(62919,6262),(62920,6262),(62921,6262),(62922,6263),(62923,6263),(62924,6263),(62925,6263),(62926,6263),(62927,6264),(62928,6264),(62929,6264),(62930,6264),(62931,6264),(62932,6265),(62933,6265),(62934,6265),(62935,6265),(62936,6265),(62937,6266),(62938,6266),(62939,6266),(62940,6266),(62941,6266),(62942,6267),(62943,6267),(62944,6267),(62945,6267),(62946,6267),(62947,6268),(62948,6268),(62949,6268),(62950,6268),(62951,6268),(62952,6269),(62953,6269),(62954,6269),(62955,6269),(62956,6269),(62957,6270),(62958,6270),(62959,6270),(62960,6270),(62961,6270),(62962,6271),(62963,6271),(62964,6271),(62965,6271),(62966,6271),(62967,6272),(62968,6272),(62969,6272),(62970,6272),(62971,6272),(62972,6273),(62973,6273),(62974,6273),(62975,6273),(62976,6273),(62977,6274),(62978,6274),(62979,6274),(62980,6274),(62981,6274),(62982,6275),(62983,6275),(62984,6275),(62985,6275),(62986,6275),(62987,6276),(62988,6276),(62989,6276),(62990,6276),(62991,6276),(62992,6277),(62993,6277),(62994,6277),(62995,6277),(62996,6277),(62997,6278),(62998,6278),(62999,6278),(63000,6278),(63001,6278),(63002,6279),(63003,6279),(63004,6279),(63005,6279),(63006,6279),(63007,6280),(63008,6280),(63009,6280),(63010,6280),(63011,6280),(63012,6281),(63013,6281),(63014,6281),(63015,6281),(63016,6281),(63017,6282),(63018,6282),(63019,6282),(63020,6282),(63021,6282),(63022,6283),(63023,6283),(63024,6283),(63025,6283),(63026,6283),(63027,6284),(63028,6284),(63029,6284),(63030,6284),(63031,6284),(63032,6285),(63033,6285),(63034,6285),(63035,6285),(63036,6285),(63037,6286),(63038,6286),(63039,6286),(63040,6286),(63041,6286),(63042,6287),(63043,6287),(63044,6287),(63045,6287),(63046,6287),(63047,6288),(63048,6288),(63049,6288),(63050,6288),(63051,6288),(63052,6289),(63053,6289),(63054,6289),(63055,6289),(63056,6289),(63057,6290),(63058,6290),(63059,6290),(63060,6290),(63061,6290),(63062,6291),(63063,6291),(63064,6291),(63065,6291),(63066,6291),(63067,6292),(63068,6292),(63069,6292),(63070,6292),(63071,6292),(63072,6293),(63073,6293),(63074,6293),(63075,6293),(63076,6293),(63077,6294),(63078,6294),(63079,6294),(63080,6294),(63081,6294),(63082,6295),(63083,6295),(63084,6295),(63085,6295),(63086,6295),(63087,6296),(63088,6296),(63089,6296),(63090,6296),(63091,6296),(63092,6297),(63093,6297),(63094,6297),(63095,6297),(63096,6297),(63097,6298),(63098,6298),(63099,6298),(63100,6298),(63101,6298),(63102,6299),(63103,6299),(63104,6299),(63105,6299),(63106,6299),(63107,6300),(63108,6300),(63109,6300),(63110,6300),(63111,6300),(63112,6301),(63113,6301),(63114,6301),(63115,6301),(63116,6301),(63117,6302),(63118,6302),(63119,6302),(63120,6302),(63121,6302),(63122,6303),(63123,6303),(63124,6303),(63125,6303),(63126,6303),(63127,6304),(63128,6304),(63129,6304),(63130,6304),(63131,6304),(63132,6305),(63133,6305),(63134,6305),(63135,6305),(63136,6305),(63137,6306),(63138,6306),(63139,6306),(63140,6306),(63141,6306),(63142,6307),(63143,6307),(63144,6307),(63145,6307),(63146,6307),(63147,6308),(63148,6308),(63149,6308),(63150,6308),(63151,6308),(63152,6309),(63153,6309),(63154,6309),(63155,6309),(63156,6309),(63157,6310),(63158,6310),(63159,6310),(63160,6310),(63161,6310),(63162,6311),(63163,6311),(63164,6311),(63165,6311),(63166,6311),(63167,6312),(63168,6312),(63169,6312),(63170,6312),(63171,6312),(63172,6313),(63173,6313),(63174,6313),(63175,6313),(63176,6313),(63177,6314),(63178,6314),(63179,6314),(63180,6314),(63181,6314),(63182,6315),(63183,6315),(63184,6315),(63185,6315),(63186,6315),(63187,6316),(63188,6316),(63189,6316),(63190,6316),(63191,6316),(63192,6317),(63193,6317),(63194,6317),(63195,6317),(63196,6317),(63197,6318),(63198,6318),(63199,6318),(63200,6318),(63201,6318),(63202,6319),(63203,6319),(63204,6319),(63205,6319),(63206,6319),(63207,6320),(63208,6320),(63209,6320),(63210,6320),(63211,6320),(63212,6321),(63213,6321),(63214,6321),(63215,6321),(63216,6321),(63217,6322),(63218,6322),(63219,6322),(63220,6322),(63221,6322),(63222,6323),(63223,6323),(63224,6323),(63225,6323),(63226,6323),(63227,6324),(63228,6324),(63229,6324),(63230,6324),(63231,6324),(63232,6325),(63233,6325),(63234,6325),(63235,6325),(63236,6325),(63237,6326),(63238,6326),(63239,6326),(63240,6326),(63241,6326),(63242,6327),(63243,6327),(63244,6327),(63245,6327),(63246,6327),(63247,6328),(63248,6328),(63249,6328),(63250,6328),(63251,6328),(63252,6329),(63253,6329),(63254,6329),(63255,6329),(63256,6329),(63257,6330),(63258,6330),(63259,6330),(63260,6330),(63261,6330),(63262,6331),(63263,6331),(63264,6331),(63265,6331),(63266,6331),(63267,6332),(63268,6332),(63269,6332),(63270,6332),(63271,6332),(63272,6333),(63273,6333),(63274,6333),(63275,6333),(63276,6333),(63277,6334),(63278,6334),(63279,6334),(63280,6334),(63281,6334),(63282,6335),(63283,6336),(63284,6337),(63285,6338),(63286,6339),(63287,6340),(63288,6341),(63289,6342),(63290,6343),(63291,6344),(63292,6345),(63293,6335),(63294,6335),(63295,6335),(63296,6335),(63297,6335),(63298,6336),(63299,6336),(63300,6336),(63301,6336),(63302,6336),(63303,6337),(63304,6337),(63305,6337),(63306,6337),(63307,6337),(63308,6338),(63309,6338),(63310,6338),(63311,6338),(63312,6338),(63313,6339),(63314,6339),(63315,6339),(63316,6339),(63317,6339),(63318,6340),(63319,6340),(63320,6340),(63321,6340),(63322,6340),(63323,6341),(63324,6341),(63325,6341),(63326,6341),(63327,6341),(63328,6342),(63329,6342),(63330,6342),(63331,6342),(63332,6342),(63333,6343),(63334,6343),(63335,6343),(63336,6343),(63337,6343),(63338,6344),(63339,6344),(63340,6344),(63341,6344),(63342,6344),(63343,6345),(63344,6345),(63345,6345),(63346,6345),(63347,6345),(63348,6035),(63349,6035),(63350,6035),(63351,6035),(63352,6035),(63353,6035),(63354,6035),(63355,6035),(63356,6035),(63357,6035),(63358,6035),(63359,6035),(63360,6035),(63361,6035),(63362,6035),(63363,6035),(63364,6035),(63365,6035),(63366,6035),(63367,6035),(63368,6035),(63369,6035),(63370,6035),(63371,6035),(63372,6035),(63373,6035),(63374,6035),(63375,6035),(63376,5760),(63377,6326),(63378,6327),(63379,6328),(63380,6329),(63381,6330),(63382,6331),(63383,6332),(63384,6333),(63385,6334),(63386,6335),(63387,6336),(63388,6337),(63389,6338),(63390,6339),(63391,6340),(63392,6341),(63393,6342),(63394,6343),(63395,6344),(63396,6345),(63397,6036),(63398,6036),(63399,6036),(63400,6036),(63401,6036),(63402,6036),(63403,6036),(63404,6036),(63405,6036),(63406,6036),(63407,6036),(63408,6036),(63409,6036),(63410,6036),(63411,6036),(63412,6036),(63413,5760),(63414,6035),(63415,6293),(63416,6299),(63417,6310),(63418,6311),(63419,6332),(63420,6333),(63421,6334),(63422,6335),(63423,6336),(63424,6337),(63425,5760),(63426,6035),(63427,6036),(63428,6037),(63429,6038),(63430,6039),(63431,6040),(63432,6041),(63433,6042),(63434,6043),(63435,6044),(63436,6045),(63437,6046),(63438,6047),(63439,6048),(63440,6049),(63441,6050),(63442,6051),(63443,6052),(63444,6053),(63445,5760),(63446,6035),(63447,6036),(63448,6037),(63449,6038),(63450,6039),(63451,6040),(63452,6041),(63453,6042),(63454,6043),(63455,6044),(63456,6045),(63457,6046),(63458,6047),(63459,6048),(63460,6049),(63461,6050),(63462,6051),(63463,6052),(63464,6053),(63465,5760),(63466,6035),(63467,6036),(63468,6037),(63469,6038),(63470,6039),(63471,6040),(63472,6041),(63473,6042),(63474,6043),(63475,6044),(63476,6045),(63477,6046),(63478,6047),(63479,6048),(63480,6049),(63481,6050),(63482,6051),(63483,6052),(63484,6053),(63485,5760),(63486,6035),(63487,6036),(63488,6037),(63489,6038),(63490,6039),(63491,6040),(63492,6041),(63493,6042),(63494,6043),(63495,6044),(63496,6045),(63497,6046),(63498,6047),(63499,6048),(63500,6049),(63501,6050),(63502,6051),(63503,6052),(63504,6053),(63505,5760),(63506,6035),(63507,6036),(63508,6037),(63509,6038),(63510,6039),(63511,6040),(63512,6041),(63513,6042),(63514,6043),(63515,6044),(63516,6045),(63517,6046),(63518,6047),(63519,6048),(63520,6049),(63521,6050),(63522,6051),(63523,6052),(63524,6053),(63525,6035),(63526,6035),(63527,6035),(63528,6035),(63529,6036),(63530,6037),(63531,6038),(63532,6039),(63533,6040),(63534,6346),(63535,6347),(63536,6348),(63537,6349),(63538,6350),(63539,6351),(63540,6352),(63541,6353),(63542,6354),(63543,6355),(63544,6356),(63545,6346),(63546,6346),(63547,6346),(63548,6346),(63549,6346),(63550,6347),(63551,6347),(63552,6347),(63553,6347),(63554,6347),(63555,6348),(63556,6348),(63557,6348),(63558,6348),(63559,6348),(63560,6349),(63561,6349),(63562,6349),(63563,6349),(63564,6349),(63565,6350),(63566,6350),(63567,6350),(63568,6350),(63569,6350),(63570,6351),(63571,6351),(63572,6351),(63573,6351),(63574,6351),(63575,6352),(63576,6352),(63577,6352),(63578,6352),(63579,6352),(63580,6353),(63581,6353),(63582,6353),(63583,6353),(63584,6353),(63585,6354),(63586,6354),(63587,6354),(63588,6354),(63589,6354),(63590,6355),(63591,6355),(63592,6355),(63593,6355),(63594,6355),(63595,6356),(63596,6356),(63597,6356),(63598,6356),(63599,6356),(63600,6357),(63601,6358),(63602,6359),(63603,6360),(63604,6361),(63605,6362),(63606,6363),(63607,6364),(63608,6365),(63609,6366),(63610,6367),(63611,6368),(63612,6369),(63613,6370),(63614,6371),(63615,6372),(63616,6373),(63617,6374),(63618,6375),(63619,6376),(63620,6377),(63621,6378),(63622,6379),(63623,6380),(63624,6381),(63625,6382),(63626,6383),(63627,6384),(63628,6385),(63629,6386),(63630,6387),(63631,6388),(63632,6389),(63633,6390),(63634,6391),(63635,6392),(63636,6393),(63637,6394),(63638,6395),(63639,6396),(63640,6397),(63641,6398),(63642,6399),(63643,6400),(63644,6401),(63645,6402),(63646,6403),(63647,6404),(63648,6405),(63649,6406),(63650,6407),(63651,6408),(63652,6409),(63653,6410),(63654,6411),(63655,6412),(63656,6413),(63657,6414),(63658,6415),(63659,6416),(63660,6417),(63661,6418),(63662,6419),(63663,6420),(63664,6421),(63665,6422),(63666,6423),(63667,6424),(63668,6425),(63669,6426),(63670,6427),(63671,6428),(63672,6429),(63673,6430),(63674,6431),(63675,6432),(63676,6433),(63677,6434),(63678,6435),(63679,6436),(63680,6437),(63681,6438),(63682,6439),(63683,6440),(63684,6441),(63685,6442),(63686,6443),(63687,6444),(63688,6445),(63689,6357),(63690,6357),(63691,6357),(63692,6357),(63693,6357),(63694,6358),(63695,6358),(63696,6358),(63697,6358),(63698,6358),(63699,6359),(63700,6359),(63701,6359),(63702,6359),(63703,6359),(63704,6360),(63705,6360),(63706,6360),(63707,6360),(63708,6360),(63709,6361),(63710,6361),(63711,6361),(63712,6361),(63713,6361),(63714,6362),(63715,6362),(63716,6362),(63717,6362),(63718,6362),(63719,6363),(63720,6363),(63721,6363),(63722,6363),(63723,6363),(63724,6364),(63725,6364),(63726,6364),(63727,6364),(63728,6364),(63729,6365),(63730,6365),(63731,6365),(63732,6365),(63733,6365),(63734,6366),(63735,6366),(63736,6366),(63737,6366),(63738,6366),(63739,6367),(63740,6367),(63741,6367),(63742,6367),(63743,6367),(63744,6368),(63745,6368),(63746,6368),(63747,6368),(63748,6368),(63749,6369),(63750,6369),(63751,6369),(63752,6369),(63753,6369),(63754,6370),(63755,6370),(63756,6370),(63757,6370),(63758,6370),(63759,6371),(63760,6371),(63761,6371),(63762,6371),(63763,6371),(63764,6372),(63765,6372),(63766,6372),(63767,6372),(63768,6372),(63769,6373),(63770,6373),(63771,6373),(63772,6373),(63773,6373),(63774,6374),(63775,6374),(63776,6374),(63777,6374),(63778,6374),(63779,6375),(63780,6375),(63781,6375),(63782,6375),(63783,6375),(63784,6376),(63785,6376),(63786,6376),(63787,6376),(63788,6376),(63789,6377),(63790,6377),(63791,6377),(63792,6377),(63793,6377),(63794,6378),(63795,6378),(63796,6378),(63797,6378),(63798,6378),(63799,6379),(63800,6379),(63801,6379),(63802,6379),(63803,6379),(63804,6380),(63805,6380),(63806,6380),(63807,6380),(63808,6380),(63809,6381),(63810,6381),(63811,6381),(63812,6381),(63813,6381),(63814,6382),(63815,6382),(63816,6382),(63817,6382),(63818,6382),(63819,6383),(63820,6383),(63821,6383),(63822,6383),(63823,6383),(63824,6384),(63825,6384),(63826,6384),(63827,6384),(63828,6384),(63829,6385),(63830,6385),(63831,6385),(63832,6385),(63833,6385),(63834,6386),(63835,6386),(63836,6386),(63837,6386),(63838,6386),(63839,6387),(63840,6387),(63841,6387),(63842,6387),(63843,6387),(63844,6388),(63845,6388),(63846,6388),(63847,6388),(63848,6388),(63849,6389),(63850,6389),(63851,6389),(63852,6389),(63853,6389),(63854,6390),(63855,6390),(63856,6390),(63857,6390),(63858,6390),(63859,6391),(63860,6391),(63861,6391),(63862,6391),(63863,6391),(63864,6392),(63865,6392),(63866,6392),(63867,6392),(63868,6392),(63869,6393),(63870,6393),(63871,6393),(63872,6393),(63873,6393),(63874,6394),(63875,6394),(63876,6394),(63877,6394),(63878,6394),(63879,6395),(63880,6395),(63881,6395),(63882,6395),(63883,6395),(63884,6396),(63885,6396),(63886,6396),(63887,6396),(63888,6396),(63889,6397),(63890,6397),(63891,6397),(63892,6397),(63893,6397),(63894,6398),(63895,6398),(63896,6398),(63897,6398),(63898,6398),(63899,6399),(63900,6399),(63901,6399),(63902,6399),(63903,6399),(63904,6400),(63905,6400),(63906,6400),(63907,6400),(63908,6400),(63909,6401),(63910,6401),(63911,6401),(63912,6401),(63913,6401),(63914,6402),(63915,6402),(63916,6402),(63917,6402),(63918,6402),(63919,6403),(63920,6403),(63921,6403),(63922,6403),(63923,6403),(63924,6404),(63925,6404),(63926,6404),(63927,6404),(63928,6404),(63929,6405),(63930,6405),(63931,6405),(63932,6405),(63933,6405),(63934,6406),(63935,6406),(63936,6406),(63937,6406),(63938,6406),(63939,6407),(63940,6407),(63941,6407),(63942,6407),(63943,6407),(63944,6408),(63945,6408),(63946,6408),(63947,6408),(63948,6408),(63949,6409),(63950,6409),(63951,6409),(63952,6409),(63953,6409),(63954,6410),(63955,6410),(63956,6410),(63957,6410),(63958,6410),(63959,6411),(63960,6411),(63961,6411),(63962,6411),(63963,6411),(63964,6412),(63965,6412),(63966,6412),(63967,6412),(63968,6412),(63969,6413),(63970,6413),(63971,6413),(63972,6413),(63973,6413),(63974,6414),(63975,6414),(63976,6414),(63977,6414),(63978,6414),(63979,6415),(63980,6415),(63981,6415),(63982,6415),(63983,6415),(63984,6416),(63985,6416),(63986,6416),(63987,6416),(63988,6416),(63989,6417),(63990,6417),(63991,6417),(63992,6417),(63993,6417),(63994,6418),(63995,6418),(63996,6418),(63997,6418),(63998,6418),(63999,6419),(64000,6419),(64001,6419),(64002,6419),(64003,6419),(64004,6420),(64005,6420),(64006,6420),(64007,6420),(64008,6420),(64009,6421),(64010,6421),(64011,6421),(64012,6421),(64013,6421),(64014,6422),(64015,6422),(64016,6422),(64017,6422),(64018,6422),(64019,6423),(64020,6423),(64021,6423),(64022,6423),(64023,6423),(64024,6424),(64025,6424),(64026,6424),(64027,6424),(64028,6424),(64029,6425),(64030,6425),(64031,6425),(64032,6425),(64033,6425),(64034,6426),(64035,6426),(64036,6426),(64037,6426),(64038,6426),(64039,6427),(64040,6427),(64041,6427),(64042,6427),(64043,6427),(64044,6428),(64045,6428),(64046,6428),(64047,6428),(64048,6428),(64049,6429),(64050,6429),(64051,6429),(64052,6429),(64053,6429),(64054,6430),(64055,6430),(64056,6430),(64057,6430),(64058,6430),(64059,6431),(64060,6431),(64061,6431),(64062,6431),(64063,6431),(64064,6432),(64065,6432),(64066,6432),(64067,6432),(64068,6432),(64069,6433),(64070,6433),(64071,6433),(64072,6433),(64073,6433),(64074,6434),(64075,6434),(64076,6434),(64077,6434),(64078,6434),(64079,6435),(64080,6435),(64081,6435),(64082,6435),(64083,6435),(64084,6436),(64085,6436),(64086,6436),(64087,6436),(64088,6436),(64089,6437),(64090,6437),(64091,6437),(64092,6437),(64093,6437),(64094,6438),(64095,6438),(64096,6438),(64097,6438),(64098,6438),(64099,6439),(64100,6439),(64101,6439),(64102,6439),(64103,6439),(64104,6440),(64105,6440),(64106,6440),(64107,6440),(64108,6440),(64109,6441),(64110,6441),(64111,6441),(64112,6441),(64113,6441),(64114,6442),(64115,6442),(64116,6442),(64117,6442),(64118,6442),(64119,6443),(64120,6443),(64121,6443),(64122,6443),(64123,6443),(64124,6444),(64125,6444),(64126,6444),(64127,6444),(64128,6444),(64129,6445),(64130,6445),(64131,6445),(64132,6445),(64133,6445),(64134,6446),(64135,6447),(64136,6448),(64137,6449),(64138,6450),(64139,6451),(64140,6452),(64141,6453),(64142,6454),(64143,6455),(64144,6456),(64145,6457),(64146,6458),(64147,6459),(64148,6460),(64149,6461),(64150,6462),(64151,6463),(64152,6464),(64153,6465),(64154,6466),(64155,6467),(64156,6468),(64157,6469),(64158,6470),(64159,6471),(64160,6472),(64161,6473),(64162,6474),(64163,6475),(64164,6476),(64165,6477),(64166,6478),(64167,6479),(64168,6480),(64169,6481),(64170,6482),(64171,6483),(64172,6484),(64173,6485),(64174,6486),(64175,6487),(64176,6488),(64177,6489),(64178,6490),(64179,6491),(64180,6492),(64181,6493),(64182,6494),(64183,6495),(64184,6496),(64185,6497),(64186,6498),(64187,6499),(64188,6500),(64189,6501),(64190,6502),(64191,6503),(64192,6504),(64193,6505),(64194,6506),(64195,6507),(64196,6508),(64197,6509),(64198,6510),(64199,6511),(64200,6512),(64201,6513),(64202,6514),(64203,6515),(64204,6516),(64205,6517),(64206,6518),(64207,6519),(64208,6520),(64209,6521),(64210,6522),(64211,6523),(64212,6524),(64213,6525),(64214,6526),(64215,6527),(64216,6528),(64217,6529),(64218,6530),(64219,6531),(64220,6532),(64221,6533),(64222,6534),(64223,6535),(64224,6536),(64225,6537),(64226,6538),(64227,6539),(64228,6540),(64229,6541),(64230,6542),(64231,6543),(64232,6544),(64233,6545),(64234,6446),(64235,6446),(64236,6446),(64237,6446),(64238,6446),(64239,6447),(64240,6447),(64241,6447),(64242,6447),(64243,6447),(64244,6448),(64245,6448),(64246,6448),(64247,6448),(64248,6448),(64249,6449),(64250,6449),(64251,6449),(64252,6449),(64253,6449),(64254,6450),(64255,6450),(64256,6450),(64257,6450),(64258,6450),(64259,6451),(64260,6451),(64261,6451),(64262,6451),(64263,6451),(64264,6452),(64265,6452),(64266,6452),(64267,6452),(64268,6452),(64269,6453),(64270,6453),(64271,6453),(64272,6453),(64273,6453),(64274,6454),(64275,6454),(64276,6454),(64277,6454),(64278,6454),(64279,6455),(64280,6455),(64281,6455),(64282,6455),(64283,6455),(64284,6456),(64285,6456),(64286,6456),(64287,6456),(64288,6456),(64289,6457),(64290,6457),(64291,6457),(64292,6457),(64293,6457),(64294,6458),(64295,6458),(64296,6458),(64297,6458),(64298,6458),(64299,6459),(64300,6459),(64301,6459),(64302,6459),(64303,6459),(64304,6460),(64305,6460),(64306,6460),(64307,6460),(64308,6460),(64309,6461),(64310,6461),(64311,6461),(64312,6461),(64313,6461),(64314,6462),(64315,6462),(64316,6462),(64317,6462),(64318,6462),(64319,6463),(64320,6463),(64321,6463),(64322,6463),(64323,6463),(64324,6464),(64325,6464),(64326,6464),(64327,6464),(64328,6464),(64329,6465),(64330,6465),(64331,6465),(64332,6465),(64333,6465),(64334,6466),(64335,6466),(64336,6466),(64337,6466),(64338,6466),(64339,6467),(64340,6467),(64341,6467),(64342,6467),(64343,6467),(64344,6468),(64345,6468),(64346,6468),(64347,6468),(64348,6468),(64349,6469),(64350,6469),(64351,6469),(64352,6469),(64353,6469),(64354,6470),(64355,6470),(64356,6470),(64357,6470),(64358,6470),(64359,6471),(64360,6471),(64361,6471),(64362,6471),(64363,6471),(64364,6472),(64365,6472),(64366,6472),(64367,6472),(64368,6472),(64369,6473),(64370,6473),(64371,6473),(64372,6473),(64373,6473),(64374,6474),(64375,6474),(64376,6474),(64377,6474),(64378,6474),(64379,6475),(64380,6475),(64381,6475),(64382,6475),(64383,6475),(64384,6476),(64385,6476),(64386,6476),(64387,6476),(64388,6476),(64389,6477),(64390,6477),(64391,6477),(64392,6477),(64393,6477),(64394,6478),(64395,6478),(64396,6478),(64397,6478),(64398,6478),(64399,6479),(64400,6479),(64401,6479),(64402,6479),(64403,6479),(64404,6480),(64405,6480),(64406,6480),(64407,6480),(64408,6480),(64409,6481),(64410,6481),(64411,6481),(64412,6481),(64413,6481),(64414,6482),(64415,6482),(64416,6482),(64417,6482),(64418,6482),(64419,6483),(64420,6483),(64421,6483),(64422,6483),(64423,6483),(64424,6484),(64425,6484),(64426,6484),(64427,6484),(64428,6484),(64429,6485),(64430,6485),(64431,6485),(64432,6485),(64433,6485),(64434,6486),(64435,6486),(64436,6486),(64437,6486),(64438,6486),(64439,6487),(64440,6487),(64441,6487),(64442,6487),(64443,6487),(64444,6488),(64445,6488),(64446,6488),(64447,6488),(64448,6488),(64449,6489),(64450,6489),(64451,6489),(64452,6489),(64453,6489),(64454,6490),(64455,6490),(64456,6490),(64457,6490),(64458,6490),(64459,6491),(64460,6491),(64461,6491),(64462,6491),(64463,6491),(64464,6492),(64465,6492),(64466,6492),(64467,6492),(64468,6492),(64469,6493),(64470,6493),(64471,6493),(64472,6493),(64473,6493),(64474,6494),(64475,6494),(64476,6494),(64477,6494),(64478,6494),(64479,6495),(64480,6495),(64481,6495),(64482,6495),(64483,6495),(64484,6496),(64485,6496),(64486,6496),(64487,6496),(64488,6496),(64489,6497),(64490,6497),(64491,6497),(64492,6497),(64493,6497),(64494,6498),(64495,6498),(64496,6498),(64497,6498),(64498,6498),(64499,6499),(64500,6499),(64501,6499),(64502,6499),(64503,6499),(64504,6500),(64505,6500),(64506,6500),(64507,6500),(64508,6500),(64509,6501),(64510,6501),(64511,6501),(64512,6501),(64513,6501),(64514,6502),(64515,6502),(64516,6502),(64517,6502),(64518,6502),(64519,6503),(64520,6503),(64521,6503),(64522,6503),(64523,6503),(64524,6504),(64525,6504),(64526,6504),(64527,6504),(64528,6504),(64529,6505),(64530,6505),(64531,6505),(64532,6505),(64533,6505),(64534,6506),(64535,6506),(64536,6506),(64537,6506),(64538,6506),(64539,6507),(64540,6507),(64541,6507),(64542,6507),(64543,6507),(64544,6508),(64545,6508),(64546,6508),(64547,6508),(64548,6508),(64549,6509),(64550,6509),(64551,6509),(64552,6509),(64553,6509),(64554,6510),(64555,6510),(64556,6510),(64557,6510),(64558,6510),(64559,6511),(64560,6511),(64561,6511),(64562,6511),(64563,6511),(64564,6512),(64565,6512),(64566,6512),(64567,6512),(64568,6512),(64569,6513),(64570,6513),(64571,6513),(64572,6513),(64573,6513),(64574,6514),(64575,6514),(64576,6514),(64577,6514),(64578,6514),(64579,6515),(64580,6515),(64581,6515),(64582,6515),(64583,6515),(64584,6516),(64585,6516),(64586,6516),(64587,6516),(64588,6516),(64589,6517),(64590,6517),(64591,6517),(64592,6517),(64593,6517),(64594,6518),(64595,6518),(64596,6518),(64597,6518),(64598,6518),(64599,6519),(64600,6519),(64601,6519),(64602,6519),(64603,6519),(64604,6520),(64605,6520),(64606,6520),(64607,6520),(64608,6520),(64609,6521),(64610,6521),(64611,6521),(64612,6521),(64613,6521),(64614,6522),(64615,6522),(64616,6522),(64617,6522),(64618,6522),(64619,6523),(64620,6523),(64621,6523),(64622,6523),(64623,6523),(64624,6524),(64625,6524),(64626,6524),(64627,6524),(64628,6524),(64629,6525),(64630,6525),(64631,6525),(64632,6525),(64633,6525),(64634,6526),(64635,6526),(64636,6526),(64637,6526),(64638,6526),(64639,6527),(64640,6527),(64641,6527),(64642,6527),(64643,6527),(64644,6528),(64645,6528),(64646,6528),(64647,6528),(64648,6528),(64649,6529),(64650,6529),(64651,6529),(64652,6529),(64653,6529),(64654,6530),(64655,6530),(64656,6530),(64657,6530),(64658,6530),(64659,6531),(64660,6531),(64661,6531),(64662,6531),(64663,6531),(64664,6532),(64665,6532),(64666,6532),(64667,6532),(64668,6532),(64669,6533),(64670,6533),(64671,6533),(64672,6533),(64673,6533),(64674,6534),(64675,6534),(64676,6534),(64677,6534),(64678,6534),(64679,6535),(64680,6535),(64681,6535),(64682,6535),(64683,6535),(64684,6536),(64685,6536),(64686,6536),(64687,6536),(64688,6536),(64689,6537),(64690,6537),(64691,6537),(64692,6537),(64693,6537),(64694,6538),(64695,6538),(64696,6538),(64697,6538),(64698,6538),(64699,6539),(64700,6539),(64701,6539),(64702,6539),(64703,6539),(64704,6540),(64705,6540),(64706,6540),(64707,6540),(64708,6540),(64709,6541),(64710,6541),(64711,6541),(64712,6541),(64713,6541),(64714,6542),(64715,6542),(64716,6542),(64717,6542),(64718,6542),(64719,6543),(64720,6543),(64721,6543),(64722,6543),(64723,6543),(64724,6544),(64725,6544),(64726,6544),(64727,6544),(64728,6544),(64729,6545),(64730,6545),(64731,6545),(64732,6545),(64733,6545),(64734,6546),(64735,6547),(64736,6548),(64737,6549),(64738,6550),(64739,6551),(64740,6552),(64741,6553),(64742,6554),(64743,6555),(64744,6556),(64745,6557),(64746,6558),(64747,6559),(64748,6560),(64749,6561),(64750,6562),(64751,6563),(64752,6564),(64753,6565),(64754,6566),(64755,6567),(64756,6568),(64757,6569),(64758,6570),(64759,6571),(64760,6572),(64761,6546),(64762,6546),(64763,6546),(64764,6546),(64765,6546),(64766,6547),(64767,6547),(64768,6547),(64769,6547),(64770,6547),(64771,6548),(64772,6548),(64773,6548),(64774,6548),(64775,6548),(64776,6549),(64777,6549),(64778,6549),(64779,6549),(64780,6549),(64781,6550),(64782,6550),(64783,6550),(64784,6550),(64785,6550),(64786,6551),(64787,6551),(64788,6551),(64789,6551),(64790,6551),(64791,6552),(64792,6552),(64793,6552),(64794,6552),(64795,6552),(64796,6553),(64797,6553),(64798,6553),(64799,6553),(64800,6553),(64801,6554),(64802,6554),(64803,6554),(64804,6554),(64805,6554),(64806,6555),(64807,6555),(64808,6555),(64809,6555),(64810,6555),(64811,6556),(64812,6556),(64813,6556),(64814,6556),(64815,6556),(64816,6557),(64817,6557),(64818,6557),(64819,6557),(64820,6557),(64821,6558),(64822,6558),(64823,6558),(64824,6558),(64825,6558),(64826,6559),(64827,6559),(64828,6559),(64829,6559),(64830,6559),(64831,6560),(64832,6560),(64833,6560),(64834,6560),(64835,6560),(64836,6561),(64837,6561),(64838,6561),(64839,6561),(64840,6561),(64841,6562),(64842,6562),(64843,6562),(64844,6562),(64845,6562),(64846,6563),(64847,6563),(64848,6563),(64849,6563),(64850,6563),(64851,6564),(64852,6564),(64853,6564),(64854,6564),(64855,6564),(64856,6565),(64857,6565),(64858,6565),(64859,6565),(64860,6565),(64861,6566),(64862,6566),(64863,6566),(64864,6566),(64865,6566),(64866,6567),(64867,6567),(64868,6567),(64869,6567),(64870,6567),(64871,6568),(64872,6568),(64873,6568),(64874,6568),(64875,6568),(64876,6569),(64877,6569),(64878,6569),(64879,6569),(64880,6569),(64881,6570),(64882,6570),(64883,6570),(64884,6570),(64885,6570),(64886,6571),(64887,6571),(64888,6571),(64889,6571),(64890,6571),(64891,6572),(64892,6572),(64893,6572),(64894,6572),(64895,6572);
/*!40000 ALTER TABLE `catalog_product_category_cl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_entity`
--

DROP TABLE IF EXISTS `catalog_product_entity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_entity` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `attribute_set_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Set ID',
  `type_id` varchar(32) NOT NULL DEFAULT 'simple' COMMENT 'Type ID',
  `sku` varchar(64) NOT NULL COMMENT 'SKU',
  `has_options` smallint NOT NULL DEFAULT '0' COMMENT 'Has Options',
  `required_options` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Required Options',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Creation Time',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Update Time',
  `mageworx_is_require` smallint NOT NULL DEFAULT '0' COMMENT 'MageWorx Is Required',
  PRIMARY KEY (`entity_id`),
  KEY `CATALOG_PRODUCT_ENTITY_ATTRIBUTE_SET_ID` (`attribute_set_id`),
  KEY `CATALOG_PRODUCT_ENTITY_SKU` (`sku`)
) ENGINE=InnoDB AUTO_INCREMENT=6573 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_entity`
--

LOCK TABLES `catalog_product_entity` WRITE;
/*!40000 ALTER TABLE `catalog_product_entity` DISABLE KEYS */;
INSERT INTO `catalog_product_entity` VALUES (5760,4,'simple','test-product',0,0,'2025-02-01 05:33:16','2025-02-01 05:33:16',0),(6035,11,'simple','122.0606.948',0,0,'2025-02-03 08:26:54','2025-02-04 10:20:48',0),(6036,11,'simple','122.0606.949',0,0,'2025-02-03 08:26:54','2025-02-03 17:22:11',0),(6037,11,'simple','122.0606.969',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6038,11,'simple','122.0607.061',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6039,11,'simple','122.0607.085',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6040,11,'simple','124.0532.229',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6041,11,'simple','450748',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6042,11,'simple','450762',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6043,11,'simple','450835',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6044,11,'simple','450836',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6045,11,'simple','452613',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6046,11,'simple','452614',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6047,11,'simple','452615',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6048,11,'simple','453364',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6049,11,'simple','453665',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6050,11,'simple','454729',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6051,11,'simple','454730',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6052,11,'simple','454795',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6053,11,'simple','456449',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6054,11,'simple','513306',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6055,11,'simple','514486',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6056,11,'simple','514647',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6057,11,'simple','518497',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6058,11,'simple','521559',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6059,11,'simple','521560',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6060,11,'simple','521565',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6061,11,'simple','521571',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6062,11,'simple','521573',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6063,11,'simple','521575',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6064,11,'simple','521576',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6065,11,'simple','521577',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6066,11,'simple','521580',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6067,11,'simple','521581',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6068,11,'simple','521589',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6069,11,'simple','521591',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6070,11,'simple','521593',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6071,11,'simple','521618',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6072,11,'simple','521748',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6073,11,'simple','521840',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6074,11,'simple','521841',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6075,11,'simple','522103',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6076,11,'simple','522951',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6077,11,'simple','522952',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6078,11,'simple','522953',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6079,11,'simple','522955',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6080,11,'simple','522957',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6081,11,'simple','522959',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6082,11,'simple','522961',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6083,11,'simple','522963',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6084,11,'simple','522965',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6085,11,'simple','522967',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6086,11,'simple','522969',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6087,11,'simple','522971',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6088,11,'simple','522983',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6089,11,'simple','522985',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6090,11,'simple','522987',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6091,11,'simple','523386',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6092,11,'simple','523387',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6093,11,'simple','523667',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6094,11,'simple','523726',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6095,11,'simple','523733',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6096,11,'simple','523741',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6097,11,'simple','524270',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6098,11,'simple','524272',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6099,11,'simple','524274',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6100,11,'simple','525149',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6101,11,'simple','525156',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6102,11,'simple','525163',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6103,11,'simple','525164',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6104,11,'simple','525165',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6105,11,'simple','525244',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6106,11,'simple','525245',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6107,11,'simple','525246',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6108,11,'simple','525247',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6109,11,'simple','525249',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6110,11,'simple','525327',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6111,11,'simple','525328',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6112,11,'simple','525330',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6113,11,'simple','526113',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6114,11,'simple','526115',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6115,11,'simple','526117',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6116,11,'simple','526120',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6117,11,'simple','526122',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6118,11,'simple','526125',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6119,11,'simple','526243',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6120,11,'simple','526244',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6121,11,'simple','526350',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6122,11,'simple','526351',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6123,11,'simple','526352',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6124,11,'simple','526354',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6125,11,'simple','527834',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6126,11,'simple','527835',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6127,11,'simple','ADIRA 45 S',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6128,11,'simple','ADIRA 6S',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6129,11,'simple','ADIRA XL 6S',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6130,11,'simple','AGX 611-100',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6131,11,'simple','AGX 611-78',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6132,11,'simple','AGX 611-860',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6133,11,'simple','AGX 651',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6134,11,'simple','AHK 611',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6135,11,'simple','ALASKA MBR',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6136,11,'simple','ALPHA 10',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6137,11,'simple','Andano 340/180-IF',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6138,11,'simple','Andano 340/180-U',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6139,11,'simple','Andano 500/180-U',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6140,11,'simple','Andano XL 6 S-IF',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6141,11,'simple','Andano XL 6 S-IF Compact',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6142,11,'simple','ARX 110 17',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6143,11,'simple','ARX 110 17-D',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6144,11,'simple','ARX 110 33',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6145,11,'simple','ARX 110 35',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6146,11,'simple','ARX 160',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6147,11,'simple','ARX 160-D',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6148,11,'simple','Atlantis Sp H Nof',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6149,11,'simple','AXIA III 6 S',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6150,11,'simple','AXIA III XL 6 S',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6151,11,'simple','AXIS III 6 S-IF',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6152,11,'simple','AZG 611 78',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6153,11,'simple','AZG 621',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6154,11,'simple','AZG 651',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6155,11,'simple','AZN 611-100',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6156,11,'simple','AZN 611-86',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6157,11,'simple','AZN 651',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6158,11,'simple','BAK 710',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6159,11,'simple','BELFAST 90MM',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6160,11,'simple','BEST 450',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6161,11,'simple','BEST 475',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6162,11,'simple','BEST 480',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6163,11,'simple','Beta 20 Bap Kg H Nof',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6164,11,'simple','BFG 611-78',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6165,11,'simple','BFG 611-970',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6166,11,'simple','BFG 651',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6167,11,'simple','Box Center BWX 120-41-27',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6168,11,'simple','BWX 220 41-27',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6169,11,'simple','BWX 220 54-27',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6170,11,'simple','BXX 110 16',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6171,11,'simple','BXX 110 40',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6172,11,'simple','BXX 110 50',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6173,11,'simple','BXX 110 54',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6174,11,'simple','BXX 110 68',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6175,11,'simple','BXX 160-34-16',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6176,11,'simple','CENTURIO L 1.5',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6177,11,'simple','CENTURIO L 10',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6178,11,'simple','Centurio L 20',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6179,11,'simple','Centurio L 30',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6180,11,'simple','Claron 340/180-IF',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6181,11,'simple','Claron 340/180-U',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6182,11,'simple','Claron 550-U',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6183,11,'simple','Classic 40 S',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6184,11,'simple','COLLECTIS 6 S',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6185,11,'simple','Colorado Comfort',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6186,11,'simple','Delta II',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6187,11,'simple','DIPLOMAT 1.5 ECO',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6188,11,'simple','DIPLOMAT 10 ECO',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6189,11,'simple','Divon II 5 S-IF',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6190,11,'simple','Divon II 6 S-IF',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6191,11,'simple','Divon II 8 S-IF',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6192,11,'simple','EGO 400',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6193,11,'simple','EGO 475',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6194,11,'simple','EGO 480',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6195,11,'simple','ELK 611',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6196,11,'simple','ELON 45 S',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6197,11,'simple','ELON XL 6 S',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6198,11,'simple','ETAGON 500-U',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6199,11,'simple','Etagon 6',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6200,11,'simple','Etagon 700-U Silgranit',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6201,11,'simple','Etagon 8',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6202,11,'simple','FSG 111',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6203,11,'simple','GAK 611',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6204,11,'simple','GAK 651',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6205,11,'simple','GALICIA',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6206,11,'simple','GAX 611',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6207,11,'simple','GAX 621',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6208,11,'simple','HARLEM 10',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6209,11,'simple','HARLEM 15',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6210,11,'simple','Jumbo',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6211,11,'simple','KANSAS 40X40 L',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6212,11,'simple','KANSAS 50X40 L',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6213,11,'simple','KBK 110 40',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6214,11,'simple','KBK 110 50',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6215,11,'simple','KBK 160',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6216,11,'simple','KNG 110 37',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6217,11,'simple','KNG 110 52',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6218,11,'simple','KNG 110 62',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6219,11,'simple','KNG 120',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6220,11,'simple','L18 3016 OKG',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6221,11,'simple','L18 3440 OKG',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6222,11,'simple','L18 390 OKG',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6223,11,'simple','LAX 110 45',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6224,11,'simple','LAX 110 50',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6225,11,'simple','LAX 110 50-41',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6226,11,'simple','LAX 120 36-36',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6227,11,'simple','LAX 120 45-30',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6228,11,'simple','LAX 160 36-16',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6229,11,'simple','LEGRA 45 S',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6230,11,'simple','LEGRA 6',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6231,11,'simple','LEGRA 6 S',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6232,11,'simple','LEGRA XL 6 S',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6233,11,'simple','MATARO2',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6234,11,'simple','Metra 45 S',0,0,'2025-02-03 08:26:54','2025-02-03 08:26:54',0),(6235,11,'simple','Metra 5 S',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6236,11,'simple','Metra 6',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6237,11,'simple','Metra 6 S',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6238,11,'simple','Metra 8 S',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6239,11,'simple','Metra XL 6 S',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6240,11,'simple','MIAMI 40X40',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6241,11,'simple','MIAMI 50X40',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6242,11,'simple','Minister Reversible',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6243,11,'simple','MQX 110 50',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6244,11,'simple','MQX 110 82',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6245,11,'simple','MRG 110-37',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6246,11,'simple','MRG 110-52',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6247,11,'simple','MRG 110-72',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6248,11,'simple','MRG 160-34-15',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6249,11,'simple','MRX 210-19',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6250,11,'simple','MRX 210-34',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6251,11,'simple','MRX 210-45',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6252,11,'simple','MRX 210-70',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6253,11,'simple','MRX 211',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6254,11,'simple','MRX 220 34-34',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6255,11,'simple','MRX 251',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6256,11,'simple','MRX 260 34-19',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6257,11,'simple','MTG 651-100',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6258,11,'simple','MULTA 102',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6259,11,'simple','MULTA 105',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6260,11,'simple','MULTA 130',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6261,11,'simple','Mythos MYX 160 34-16',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6262,11,'simple','Mythos MYX 160 50-16',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6263,11,'simple','Mythos MYX 210-34',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6264,11,'simple','Mythos MYX 210-45',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6265,11,'simple','Mythos MYX 210-55',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6266,11,'simple','Mythos MYX 210-70',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6267,11,'simple','MYX 211',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6268,11,'simple','MYX 251',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6269,11,'simple','NAYA 6',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6270,11,'simple','NAYA XL 9',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6271,11,'simple','NEW YORK 18X40 L',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6272,11,'simple','NEW YORK 18X40+34X40',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6273,11,'simple','NEW YORK 34X40 L',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6274,11,'simple','NEW YORK 34X40+18X40',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6275,11,'simple','NEW YORK 40X40 L',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6276,11,'simple','NEW YORK 50X40 L',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6277,11,'simple','NEW YORK 50X40+18X40',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6278,11,'simple','NEX 211',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6279,11,'simple','NEX 251',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6280,11,'simple','OC162AWHA',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6281,11,'simple','OC163AWHA',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6282,11,'simple','OC164AWHA',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6283,11,'simple','OC165AWHA',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6284,11,'simple','OHIO 18X40 L',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6285,11,'simple','OHIO 18X40+50X40 L',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6286,11,'simple','OHIO 40X40 L',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6287,11,'simple','OHIO 40X40 TW',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6288,11,'simple','OHIO 50X40 L',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6289,11,'simple','OHIO 50X40 TW',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6290,11,'simple','OHIO 50X40+18X40 L',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6291,11,'simple','OHIO 80X42 L',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6292,11,'simple','OID 611-94',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6293,11,'simple','OID 651',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6294,11,'simple','QUADRA 100',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6295,11,'simple','QUADRA 105',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6296,11,'simple','QUADRA 130',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6297,11,'simple','QUADRA 50',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6298,11,'simple','R18 2330',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6299,11,'simple','RBX 610',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6300,11,'simple','REGENT 10 LUXA',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6301,11,'simple','REGIDRAIN R',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6302,11,'simple','RIO',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6303,11,'simple','RIO SP H NOF',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6304,11,'simple','RL 301 CW',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6305,11,'simple','RL 304 CW',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6306,11,'simple','RL 401 CB',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6307,11,'simple','RL 501 CW',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6308,11,'simple','RL 504 CW',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6309,11,'simple','Rondo',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6310,11,'simple','SKX 611-86',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6311,11,'simple','SKX 651',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6312,11,'simple','SOLIS 340/180-U',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6313,11,'simple','Sona 5 S',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6314,11,'simple','Sona 6 S',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6315,11,'simple','Sona XL 6 S',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6316,11,'simple','SUBLINE 160-U',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6317,11,'simple','Subline 320-U',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6318,11,'simple','Subline 340/160-U',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6319,11,'simple','Subline 350/350-U',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6320,11,'simple','Subline 400-U',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6321,11,'simple','SUBLINE 430/270-U',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6322,11,'simple','Subline 480/320-U',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6323,11,'simple','Subline 500-IF',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6324,11,'simple','Subline 500-U',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6325,11,'simple','Subline 700-U',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6326,11,'simple','Subline 700-U PuraDur',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6327,11,'simple','Subline 800-U',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6328,11,'simple','TEXAS 18X40 L',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6329,11,'simple','TEXAS 30X40 L',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6330,11,'simple','TEXAS 40X40 L',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6331,11,'simple','TEXAS 50X40 L',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6332,11,'simple','VBK 110 21',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6333,11,'simple','VBK 110 33',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6334,11,'simple','VBK 110 50',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6335,11,'simple','VBK 160',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6336,11,'simple','VBK 710',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6337,11,'simple','VBK 720',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6338,11,'simple','VINTERA XL 9',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6339,11,'simple','Zerox 340/180-U',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6340,11,'simple','Zia 45 S',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6341,11,'simple','Zia 5 S',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6342,11,'simple','Zia 6 S',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6343,11,'simple','ZIA 9 E',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6344,11,'simple','ZIA XL 6 S',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6345,11,'simple','ZIA XL 6 S Compact',0,0,'2025-02-03 08:26:55','2025-02-03 08:26:55',0),(6346,19,'simple','Balmoral',0,0,'2025-02-04 12:43:26','2025-02-04 13:46:25',0),(6347,19,'simple','Bolton 1690',0,0,'2025-02-04 12:43:26','2025-02-04 13:46:25',0),(6348,19,'simple','Bolton 1805',0,0,'2025-02-04 12:43:26','2025-02-04 13:46:25',0),(6349,19,'simple','Chatsworth',0,0,'2025-02-04 12:43:26','2025-02-04 13:46:25',0),(6350,19,'simple','Ebony',0,0,'2025-02-04 12:43:26','2025-02-04 13:46:25',0),(6351,19,'simple','Hexham',0,0,'2025-02-04 12:43:26','2025-02-04 13:46:25',0),(6352,19,'simple','Kensington 1495',0,0,'2025-02-04 12:43:26','2025-02-04 13:46:25',0),(6353,19,'simple','Kensington 1695',0,0,'2025-02-04 12:43:26','2025-02-04 13:46:25',0),(6354,19,'simple','Lambeth',0,0,'2025-02-04 12:43:26','2025-02-04 13:46:25',0),(6355,19,'simple','Melrose',0,0,'2025-02-04 12:43:26','2025-02-04 13:46:25',0),(6356,19,'simple','Melrose FA',0,0,'2025-02-04 12:43:26','2025-02-04 13:46:25',0),(6357,19,'simple','Onyx',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6358,19,'simple','Opal',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6359,19,'simple','Orlando 1380',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6360,19,'simple','Quartz',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6361,19,'simple','Ruby',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6362,19,'simple','Sunstone',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6363,19,'simple','Westminster 1490',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6364,19,'simple','Westminster 1860',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6365,19,'simple','Woburn 1490',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6366,19,'simple','Woburn 1675',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6367,19,'simple','Woburn 1765',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6368,19,'simple','NBA209',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6369,19,'simple','NBA210',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6370,19,'simple','NBA214',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6371,19,'simple','NBA605',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6372,19,'simple','NBA607',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6373,19,'simple','NBA609',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6374,19,'simple','NBA610',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6375,19,'simple','NBA614',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6376,19,'simple','NBA405',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6377,19,'simple','NBA407',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6378,19,'simple','NBA409',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6379,19,'simple','NBA410',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6380,19,'simple','NBA414',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6381,19,'simple','NBA509',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6382,19,'simple','NBA510',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6383,19,'simple','NBA514',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6384,19,'simple','BT58AWHA',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6385,19,'simple','BT55AAWHA',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6386,19,'simple','BT57AWHA',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6387,19,'simple','BT01AAWHA',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6388,19,'simple','2370J 2370K',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6389,19,'simple','24717000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6390,19,'simple','24719000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6391,19,'simple','24718000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6392,19,'simple','Bette Classic',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6393,19,'simple','Bette Comodo with Side Overflow',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6394,19,'simple','Bette Duett',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6395,19,'simple','Bette Free',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6396,19,'simple','Bette Ocean Lowline',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6397,19,'simple','Bette One',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6398,19,'simple','Bette One Relax',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6399,19,'simple','Bette Starlet Flair Oval',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6400,19,'simple','Bette Starlet IV Silhouette',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6401,19,'simple','Bette Starlet Oval',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6402,19,'simple','Bette Starlet V',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6403,19,'simple','2.21E+03',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6404,19,'simple','2375L3000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6405,19,'simple','1080-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6406,19,'simple','1180-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6407,19,'simple','1200-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6408,19,'simple','1210-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6409,19,'simple','1220-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6410,19,'simple','1230-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6411,19,'simple','1240-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6412,19,'simple','1250-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6413,19,'simple','1270-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6414,19,'simple','1271-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6415,19,'simple','1272-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6416,19,'simple','1300-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6417,19,'simple','1380-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6418,19,'simple','1430-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6419,19,'simple','1450-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6420,19,'simple','1630-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6421,19,'simple','1730-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6422,19,'simple','1830-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6423,19,'simple','2540-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6424,19,'simple','2560-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6425,19,'simple','2590-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6426,19,'simple','3060-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6427,19,'simple','3110-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6428,19,'simple','3323-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6429,19,'simple','3324-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6430,19,'simple','3325-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6431,19,'simple','2940-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6432,19,'simple','3410-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6433,19,'simple','3411-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6434,19,'simple','3412-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6435,19,'simple','3413-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6436,19,'simple','3420-000T',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6437,19,'simple','3431-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6438,19,'simple','3432-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6439,19,'simple','3433-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6440,19,'simple','2949-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6441,19,'simple','2948-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6442,19,'simple','2941-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6443,19,'simple','3560-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6444,19,'simple','2942-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6445,19,'simple','2943-000',0,0,'2025-02-04 13:46:25','2025-02-04 13:46:25',0),(6446,19,'simple','2944-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6447,19,'simple','3650-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6448,19,'simple','3660-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6449,19,'simple','2946-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6450,19,'simple','2947-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6451,19,'simple','3760-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6452,19,'simple','2950-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6453,19,'simple','3860-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6454,19,'simple','8772-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6455,19,'simple','8773-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6456,19,'simple','8774-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6457,19,'simple','8775-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6458,19,'simple','2700-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6459,19,'simple','2720-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6460,19,'simple','2680-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6461,19,'simple','2740-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6462,19,'simple','2745-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6463,19,'simple','2951-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6464,19,'simple','2945-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6465,19,'simple','6650-000CERVK',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6466,19,'simple','6660-000CERVK',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6467,19,'simple','6670-000CERVK',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6468,19,'simple','6680-000CELVK',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6469,19,'simple','6690-000CELVK',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6470,19,'simple','6700-000CELVK',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6471,19,'simple','8856-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6472,19,'simple','8842-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6473,19,'simple','8859-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6474,19,'simple','8850-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6475,19,'simple','8765-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6476,19,'simple','8852-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6477,19,'simple','8854-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6478,19,'simple','8831-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6479,19,'simple','8836-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6480,19,'simple','8833-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6481,19,'simple','8835-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6482,19,'simple','8839-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6483,19,'simple','3480-000CFXXK',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6484,19,'simple','3820-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6485,19,'simple','RAK-Cloud Bath',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6486,19,'simple','BT54AWHA',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6487,19,'simple','KABATH/WL',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6488,19,'simple','BT56AWHA',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6489,19,'simple','RAKWTNBAT1770/WL',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6490,19,'simple','RAKWTNBAT1775/WL',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6491,19,'simple','RAK-Washington',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6492,19,'simple','NBB001',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6493,19,'simple','NBB002',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6494,19,'simple','NBB003',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6495,19,'simple','NBB004',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6496,19,'simple','NLB109',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6497,19,'simple','NLB110',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6498,19,'simple','NLB114',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6499,19,'simple','RE1701C2',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6500,19,'simple','RL1490C2',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6501,19,'simple','RL1501C2',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6502,19,'simple','RL1690C2',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6503,19,'simple','RL1705C2',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6504,19,'simple','RL1707T',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6505,19,'simple','RLF1500C2',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6506,19,'simple','RLF1700C2',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6507,19,'simple','1252-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6508,19,'simple','Bette Select Overflow',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6509,19,'simple','Bette Form Steel Bath',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6510,19,'simple','Bette Labette',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6511,19,'simple','Bette Ocean',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6512,19,'simple','Bette Set',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6513,19,'simple','Bette Starlet',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6514,19,'simple','3310-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6515,19,'simple','3311-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6516,19,'simple','3312-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6517,19,'simple','3313-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6518,19,'simple','3314-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6519,19,'simple','6677-000CERVK',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6520,19,'simple','6720-000CELVK',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6521,19,'simple','1620-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6522,19,'simple','1643-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6523,19,'simple','1641-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6524,19,'simple','1642-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6525,19,'simple','1266-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6526,19,'simple','1268-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6527,19,'simple','1267-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6528,19,'simple','1269-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6529,19,'simple','1265-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6530,19,'simple','3108-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6531,19,'simple','3109-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6532,19,'simple','3111-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6533,19,'simple','3112-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6534,19,'simple','1273-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6535,19,'simple','1631-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6536,19,'simple','Bette Select',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6537,19,'simple','Bette Comodo',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6538,19,'simple','1253-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6539,19,'simple','1251-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6540,19,'simple','3020-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6541,19,'simple','3100-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6542,19,'simple','6829-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6543,19,'simple','6830-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6544,19,'simple','6831-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6545,19,'simple','6832-000',0,0,'2025-02-04 13:46:26','2025-02-04 13:46:26',0),(6546,19,'simple','Balance Bath',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6547,19,'simple','55230001000',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6548,19,'simple','55210001000',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6549,19,'simple','55180001000',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6550,19,'simple','Neon Rectangular Bath',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6551,19,'simple','52510001000',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6552,19,'simple','52520001000',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6553,19,'simple','52660001000',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6554,19,'simple','52530001000',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6555,19,'simple','52280001000',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6556,19,'simple','Neon Shower Bath',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6557,19,'simple','52540001000',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6558,19,'simple','Optima Bath',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6559,19,'simple','50800001000',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6560,19,'simple','50810001000',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6561,19,'simple','50820001000',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6562,19,'simple','52430001000',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6563,19,'simple','54300001000',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6564,19,'simple','WBS1585',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6565,19,'simple','WBS1685',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6566,19,'simple','WBS1785',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6567,19,'simple','WBB1585',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6568,19,'simple','WBB1785',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6569,19,'simple','WBP1585',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6570,19,'simple','WBP1685',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6571,19,'simple','WBP1785',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0),(6572,19,'simple','3473-000',0,0,'2025-02-04 13:46:27','2025-02-04 13:46:27',0);
/*!40000 ALTER TABLE `catalog_product_entity` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_after_insert` AFTER INSERT ON `catalog_product_entity` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`entity_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`entity_id`);
INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (NEW.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_after_update` AFTER UPDATE ON `catalog_product_entity` FOR EACH ROW BEGIN
IF (NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`attribute_set_id` <=> OLD.`attribute_set_id`) OR NOT(NEW.`type_id` <=> OLD.`type_id`) OR NOT(NEW.`sku` <=> OLD.`sku`) OR NOT(NEW.`has_options` <=> OLD.`has_options`) OR NOT(NEW.`required_options` <=> OLD.`required_options`) OR NOT(NEW.`created_at` <=> OLD.`created_at`) OR NOT(NEW.`mageworx_is_require` <=> OLD.`mageworx_is_require`)) THEN INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
IF (NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`attribute_set_id` <=> OLD.`attribute_set_id`) OR NOT(NEW.`type_id` <=> OLD.`type_id`) OR NOT(NEW.`sku` <=> OLD.`sku`) OR NOT(NEW.`has_options` <=> OLD.`has_options`) OR NOT(NEW.`required_options` <=> OLD.`required_options`) OR NOT(NEW.`created_at` <=> OLD.`created_at`) OR NOT(NEW.`mageworx_is_require` <=> OLD.`mageworx_is_require`)) THEN INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
IF (NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`attribute_set_id` <=> OLD.`attribute_set_id`) OR NOT(NEW.`type_id` <=> OLD.`type_id`) OR NOT(NEW.`sku` <=> OLD.`sku`) OR NOT(NEW.`has_options` <=> OLD.`has_options`) OR NOT(NEW.`required_options` <=> OLD.`required_options`) OR NOT(NEW.`created_at` <=> OLD.`created_at`) OR NOT(NEW.`mageworx_is_require` <=> OLD.`mageworx_is_require`)) THEN INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_after_delete` AFTER DELETE ON `catalog_product_entity` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (OLD.`entity_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (OLD.`entity_id`);
INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (OLD.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `catalog_product_entity_datetime`
--

DROP TABLE IF EXISTS `catalog_product_entity_datetime`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_entity_datetime` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` datetime DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CATALOG_PRODUCT_ENTITY_DATETIME_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `CATALOG_PRODUCT_ENTITY_DATETIME_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_PRODUCT_ENTITY_DATETIME_STORE_ID` (`store_id`),
  CONSTRAINT `CAT_PRD_ENTT_DTIME_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_ENTT_DTIME_ENTT_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_PRODUCT_ENTITY_DATETIME_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=31 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Datetime Attribute Backend Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_entity_datetime`
--

LOCK TABLES `catalog_product_entity_datetime` WRITE;
/*!40000 ALTER TABLE `catalog_product_entity_datetime` DISABLE KEYS */;
INSERT INTO `catalog_product_entity_datetime` VALUES (29,79,0,6035,'2025-02-03 00:00:00'),(30,79,0,6036,'2025-02-03 00:00:00');
/*!40000 ALTER TABLE `catalog_product_entity_datetime` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_datetime_after_insert` AFTER INSERT ON `catalog_product_entity_datetime` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`entity_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`entity_id`);
INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (NEW.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_datetime_after_update` AFTER UPDATE ON `catalog_product_entity_datetime` FOR EACH ROW BEGIN
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_datetime_after_delete` AFTER DELETE ON `catalog_product_entity_datetime` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (OLD.`entity_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (OLD.`entity_id`);
INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (OLD.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `catalog_product_entity_decimal`
--

DROP TABLE IF EXISTS `catalog_product_entity_decimal`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_entity_decimal` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` decimal(20,6) DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CATALOG_PRODUCT_ENTITY_DECIMAL_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `CATALOG_PRODUCT_ENTITY_DECIMAL_STORE_ID` (`store_id`),
  KEY `CATALOG_PRODUCT_ENTITY_DECIMAL_ATTRIBUTE_ID` (`attribute_id`),
  CONSTRAINT `CAT_PRD_ENTT_DEC_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_ENTT_DEC_ENTT_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_PRODUCT_ENTITY_DECIMAL_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=21397 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Decimal Attribute Backend Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_entity_decimal`
--

LOCK TABLES `catalog_product_entity_decimal` WRITE;
/*!40000 ALTER TABLE `catalog_product_entity_decimal` DISABLE KEYS */;
INSERT INTO `catalog_product_entity_decimal` VALUES (18966,77,0,5760,0.010000),(18967,82,0,5760,0.400000),(19770,78,0,6035,278.400000),(19771,81,0,6035,312.940000),(19772,77,0,6035,348.000000),(19773,78,0,6036,326.400000),(19774,81,0,6036,366.760000),(19775,77,0,6036,408.000000),(19776,78,0,6037,391.200000),(19777,81,0,6037,439.690000),(19778,77,0,6037,489.000000),(19779,78,0,6038,440.000000),(19780,81,0,6038,494.630000),(19781,77,0,6038,550.000000),(19782,78,0,6039,531.200000),(19783,81,0,6039,597.260000),(19784,77,0,6039,664.000000),(19785,78,0,6040,371.333333),(19786,81,0,6040,417.750000),(19787,77,0,6040,464.166667),(19788,78,0,6041,90.466667),(19789,81,0,6041,92.160000),(19790,77,0,6041,128.000000),(19791,78,0,6042,98.380000),(19792,81,0,6042,99.360000),(19793,77,0,6042,138.000000),(19794,78,0,6043,154.666667),(19795,81,0,6043,164.160000),(19796,77,0,6043,228.000000),(19797,78,0,6044,167.875000),(19798,81,0,6044,178.560000),(19799,77,0,6044,248.000000),(19800,78,0,6045,104.991667),(19801,81,0,6045,106.560000),(19802,77,0,6045,148.000000),(19803,78,0,6046,117.600000),(19804,81,0,6046,120.960000),(19805,77,0,6046,168.000000),(19806,78,0,6047,134.166667),(19807,81,0,6047,135.360000),(19808,77,0,6047,188.000000),(19809,78,0,6048,183.875000),(19810,81,0,6048,200.160000),(19811,77,0,6048,278.000000),(19812,78,0,6049,221.666667),(19813,81,0,6049,236.160000),(19814,77,0,6049,328.000000),(19815,78,0,6050,260.133333),(19816,81,0,6050,286.560000),(19817,77,0,6050,398.000000),(19818,78,0,6051,234.800000),(19819,81,0,6051,257.760000),(19820,77,0,6051,358.000000),(19821,78,0,6052,196.658333),(19822,81,0,6052,214.560000),(19823,77,0,6052,298.000000),(19824,78,0,6053,226.780000),(19825,81,0,6053,243.360000),(19826,77,0,6053,338.000000),(19827,78,0,6054,152.540000),(19828,81,0,6054,142.560000),(19829,77,0,6054,198.000000),(19830,78,0,6055,309.291667),(19831,81,0,6055,322.560000),(19832,77,0,6055,448.000000),(19833,78,0,6056,138.600000),(19834,81,0,6056,142.560000),(19835,77,0,6056,198.000000),(19836,78,0,6057,215.833333),(19837,81,0,6057,221.760000),(19838,77,0,6057,308.000000),(19839,78,0,6058,443.000000),(19840,81,0,6058,502.560000),(19841,77,0,6058,698.000000),(19842,78,0,6059,530.825000),(19843,81,0,6059,610.560000),(19844,77,0,6059,848.000000),(19845,78,0,6060,352.500000),(19846,81,0,6060,387.360000),(19847,77,0,6060,538.000000),(19848,78,0,6061,385.000000),(19849,81,0,6061,430.560000),(19850,77,0,6061,598.000000),(19851,78,0,6062,398.491667),(19852,81,0,6062,452.160000),(19853,77,0,6062,628.000000),(19854,78,0,6063,413.333333),(19855,81,0,6063,459.360000),(19856,77,0,6063,638.000000),(19857,78,0,6064,516.600000),(19858,81,0,6064,531.360000),(19859,77,0,6064,738.000000),(19860,78,0,6065,417.741667),(19861,81,0,6065,466.560000),(19862,77,0,6065,648.000000),(19863,78,0,6066,518.333333),(19864,81,0,6066,574.560000),(19865,77,0,6066,798.000000),(19866,78,0,6067,476.666667),(19867,81,0,6067,531.360000),(19868,77,0,6067,738.000000),(19869,78,0,6068,397.600000),(19870,81,0,6068,408.960000),(19871,77,0,6068,568.000000),(19872,78,0,6069,389.241667),(19873,81,0,6069,430.560000),(19874,77,0,6069,598.000000),(19875,78,0,6070,451.666667),(19876,81,0,6070,488.160000),(19877,77,0,6070,678.000000),(19878,78,0,6071,802.630000),(19879,81,0,6071,862.560000),(19880,77,0,6071,1198.000000),(19881,78,0,6072,461.800000),(19882,81,0,6072,502.560000),(19883,77,0,6072,698.000000),(19884,78,0,6073,405.833333),(19885,81,0,6073,430.560000),(19886,77,0,6073,598.000000),(19887,78,0,6074,404.166667),(19888,81,0,6074,430.560000),(19889,77,0,6074,598.000000),(19890,78,0,6075,412.325000),(19891,81,0,6075,416.160000),(19892,77,0,6075,578.000000),(19893,78,0,6076,251.666667),(19894,81,0,6076,264.960000),(19895,77,0,6076,368.000000),(19896,78,0,6077,226.666667),(19897,81,0,6077,236.160000),(19898,77,0,6077,328.000000),(19899,78,0,6078,296.666667),(19900,81,0,6078,329.760000),(19901,77,0,6078,458.000000),(19902,78,0,6079,276.666667),(19903,81,0,6079,293.760000),(19904,77,0,6079,408.000000),(19905,78,0,6080,318.333333),(19906,81,0,6080,344.160000),(19907,77,0,6080,478.000000),(19908,78,0,6081,288.333333),(19909,81,0,6081,308.160000),(19910,77,0,6081,428.000000),(19911,78,0,6082,312.908333),(19912,81,0,6082,351.360000),(19913,77,0,6082,488.000000),(19914,78,0,6083,301.666667),(19915,81,0,6083,322.560000),(19916,77,0,6083,448.000000),(19917,78,0,6084,321.666667),(19918,81,0,6084,358.560000),(19919,77,0,6084,498.000000),(19920,78,0,6085,320.600000),(19921,81,0,6085,329.760000),(19922,77,0,6085,458.000000),(19923,78,0,6086,388.333333),(19924,81,0,6086,430.560000),(19925,77,0,6086,598.000000),(19926,78,0,6087,374.991667),(19927,81,0,6087,394.560000),(19928,77,0,6087,548.000000),(19929,78,0,6088,460.960000),(19930,81,0,6088,495.360000),(19931,77,0,6088,688.000000),(19932,78,0,6089,605.000000),(19933,81,0,6089,689.760000),(19934,77,0,6089,958.000000),(19935,78,0,6090,568.160000),(19936,81,0,6090,610.560000),(19937,77,0,6090,848.000000),(19938,78,0,6091,558.600000),(19939,81,0,6091,574.560000),(19940,77,0,6091,798.000000),(19941,78,0,6092,619.960000),(19942,81,0,6092,646.560000),(19943,77,0,6092,898.000000),(19944,78,0,6093,555.000000),(19945,81,0,6093,596.160000),(19946,77,0,6093,828.000000),(19947,78,0,6094,320.158333),(19948,81,0,6094,358.560000),(19949,77,0,6094,498.000000),(19950,78,0,6095,368.333333),(19951,81,0,6095,394.560000),(19952,77,0,6095,548.000000),(19953,78,0,6096,403.141667),(19954,81,0,6096,430.560000),(19955,77,0,6096,598.000000),(19956,78,0,6097,473.541667),(19957,81,0,6097,495.360000),(19958,77,0,6097,688.000000),(19959,78,0,6098,435.833333),(19960,81,0,6098,488.160000),(19961,77,0,6098,678.000000),(19962,78,0,6099,509.275000),(19963,81,0,6099,552.960000),(19964,77,0,6099,768.000000),(19965,78,0,6100,409.990000),(19966,81,0,6100,430.560000),(19967,77,0,6100,598.000000),(19968,78,0,6101,423.333333),(19969,81,0,6101,466.560000),(19970,77,0,6101,648.000000),(19971,78,0,6102,380.833333),(19972,81,0,6102,401.760000),(19973,77,0,6102,558.000000),(19974,78,0,6103,368.333333),(19975,81,0,6103,401.760000),(19976,77,0,6103,558.000000),(19977,78,0,6104,318.333333),(19978,81,0,6104,344.160000),(19979,77,0,6104,478.000000),(19980,78,0,6105,396.666667),(19981,81,0,6105,430.560000),(19982,77,0,6105,598.000000),(19983,78,0,6106,413.333333),(19984,81,0,6106,459.360000),(19985,77,0,6106,638.000000),(19986,78,0,6107,443.333333),(19987,81,0,6107,495.360000),(19988,77,0,6107,688.000000),(19989,78,0,6108,635.000000),(19990,81,0,6108,704.160000),(19991,77,0,6108,978.000000),(19992,78,0,6109,647.420000),(19993,81,0,6109,718.560000),(19994,77,0,6109,998.000000),(19995,78,0,6110,271.666667),(19996,81,0,6110,286.560000),(19997,77,0,6110,398.000000),(19998,78,0,6111,292.600000),(19999,81,0,6111,300.960000),(20000,77,0,6111,418.000000),(20001,78,0,6112,249.166667),(20002,81,0,6112,250.560000),(20003,77,0,6112,348.000000),(20004,78,0,6113,153.910000),(20005,81,0,6113,164.160000),(20006,77,0,6113,228.000000),(20007,78,0,6114,211.650000),(20008,81,0,6114,214.560000),(20009,77,0,6114,298.000000),(20010,78,0,6115,225.000000),(20011,81,0,6115,243.360000),(20012,77,0,6115,338.000000),(20013,78,0,6116,250.600000),(20014,81,0,6116,257.760000),(20015,77,0,6116,358.000000),(20016,78,0,6117,246.666667),(20017,81,0,6117,264.960000),(20018,77,0,6117,368.000000),(20019,78,0,6118,321.666667),(20020,81,0,6118,344.160000),(20021,77,0,6118,478.000000),(20022,78,0,6119,561.666667),(20023,81,0,6119,596.160000),(20024,77,0,6119,828.000000),(20025,78,0,6120,659.166667),(20026,81,0,6120,704.160000),(20027,77,0,6120,978.000000),(20028,78,0,6121,185.970000),(20029,81,0,6121,200.160000),(20030,77,0,6121,278.000000),(20031,78,0,6122,233.875000),(20032,81,0,6122,236.160000),(20033,77,0,6122,328.000000),(20034,78,0,6123,243.600000),(20035,81,0,6123,250.560000),(20036,77,0,6123,348.000000),(20037,78,0,6124,277.316667),(20038,81,0,6124,286.560000),(20039,77,0,6124,398.000000),(20040,78,0,6125,673.330000),(20041,81,0,6125,718.560000),(20042,77,0,6125,998.000000),(20043,78,0,6126,869.340000),(20044,81,0,6126,934.560000),(20045,77,0,6126,1298.000000),(20046,78,0,6127,315.633333),(20047,81,0,6127,344.160000),(20048,77,0,6127,478.000000),(20049,78,0,6128,383.466667),(20050,81,0,6128,394.560000),(20051,77,0,6128,548.000000),(20052,78,0,6129,365.830000),(20053,81,0,6129,372.960000),(20054,77,0,6129,518.000000),(20055,78,0,6130,216.000000),(20056,81,0,6130,242.880000),(20057,77,0,6130,270.000000),(20058,78,0,6131,146.400000),(20059,81,0,6131,163.870000),(20060,77,0,6131,183.000000),(20061,78,0,6132,158.400000),(20062,81,0,6132,177.590000),(20063,77,0,6132,198.000000),(20064,78,0,6133,236.800000),(20065,81,0,6133,265.790000),(20066,77,0,6133,296.000000),(20067,78,0,6134,337.346667),(20068,81,0,6134,379.520000),(20069,77,0,6134,421.683333),(20070,78,0,6135,200.833334),(20071,81,0,6135,183.072000),(20072,77,0,6135,220.916667),(20073,78,0,6136,86.666667),(20074,81,0,6136,51.120000),(20075,77,0,6136,95.333333),(20076,78,0,6137,501.666667),(20077,81,0,6137,560.160000),(20078,77,0,6137,778.000000),(20079,78,0,6138,405.000000),(20080,81,0,6138,430.560000),(20081,77,0,6138,598.000000),(20082,78,0,6139,496.758333),(20083,81,0,6139,516.960000),(20084,77,0,6139,718.000000),(20085,78,0,6140,444.983333),(20086,81,0,6140,430.560000),(20087,77,0,6140,598.000000),(20088,78,0,6141,363.333333),(20089,81,0,6141,408.960000),(20090,77,0,6141,568.000000),(20091,78,0,6142,153.646667),(20092,81,0,6142,172.860000),(20093,77,0,6142,192.058333),(20094,78,0,6143,205.326667),(20095,81,0,6143,231.000000),(20096,77,0,6143,256.658333),(20097,78,0,6144,164.000000),(20098,81,0,6144,184.500000),(20099,77,0,6144,205.000000),(20100,78,0,6145,205.600000),(20101,81,0,6145,231.300000),(20102,77,0,6145,257.000000),(20103,78,0,6146,308.513333),(20104,81,0,6146,347.080000),(20105,77,0,6146,385.641667),(20106,78,0,6147,360.066667),(20107,81,0,6147,405.070000),(20108,77,0,6147,450.083333),(20109,78,0,6148,131.666667),(20110,81,0,6148,106.152000),(20111,77,0,6148,144.833333),(20112,78,0,6149,578.291667),(20113,81,0,6149,574.560000),(20114,77,0,6149,798.000000),(20115,78,0,6150,508.333333),(20116,81,0,6150,552.960000),(20117,77,0,6150,768.000000),(20118,78,0,6151,450.833333),(20119,81,0,6151,452.160000),(20120,77,0,6151,628.000000),(20121,78,0,6152,261.333333),(20122,81,0,6152,294.000000),(20123,77,0,6152,326.666667),(20124,78,0,6153,348.240000),(20125,81,0,6153,391.780000),(20126,77,0,6153,435.300000),(20127,78,0,6154,304.800000),(20128,81,0,6154,342.900000),(20129,77,0,6154,381.000000),(20130,78,0,6155,117.600000),(20131,81,0,6155,132.310000),(20132,77,0,6155,147.000000),(20133,78,0,6156,94.666667),(20134,81,0,6156,106.380000),(20135,77,0,6156,118.333333),(20136,78,0,6157,124.000000),(20137,81,0,6157,139.320000),(20138,77,0,6157,155.000000),(20139,78,0,6158,244.000000),(20140,81,0,6158,274.500000),(20141,77,0,6158,305.000000),(20142,78,0,6159,165.796667),(20143,81,0,6159,132.744000),(20144,77,0,6159,182.376333),(20145,78,0,6160,230.840000),(20146,81,0,6160,212.100000),(20147,77,0,6160,253.920000),(20148,78,0,6161,225.840000),(20149,81,0,6161,212.100000),(20150,77,0,6161,248.420000),(20151,78,0,6162,225.840000),(20152,81,0,6162,212.100000),(20153,77,0,6162,248.420000),(20154,78,0,6163,110.833334),(20155,81,0,6163,88.620000),(20156,77,0,6163,121.916667),(20157,78,0,6164,301.333333),(20158,81,0,6164,339.000000),(20159,77,0,6164,376.666667),(20160,78,0,6165,308.320000),(20161,81,0,6165,346.860000),(20162,77,0,6165,385.400000),(20163,78,0,6166,328.926667),(20164,81,0,6166,370.040000),(20165,77,0,6166,411.158333),(20166,78,0,6167,1098.400000),(20167,81,0,6167,1235.290000),(20168,77,0,6167,1373.000000),(20169,78,0,6168,1264.800000),(20170,81,0,6168,1422.100000),(20171,77,0,6168,1581.000000),(20172,78,0,6169,1198.400000),(20173,81,0,6169,1348.980000),(20174,77,0,6169,1498.000000),(20175,78,0,6170,241.966667),(20176,81,0,6170,272.220000),(20177,77,0,6170,302.458333),(20178,78,0,6171,273.826667),(20179,81,0,6171,308.050000),(20180,77,0,6171,342.283333),(20181,78,0,6172,290.960000),(20182,81,0,6172,327.340000),(20183,77,0,6172,363.700000),(20184,78,0,6173,299.506667),(20185,81,0,6173,336.950000),(20186,77,0,6173,374.383333),(20187,78,0,6174,330.706667),(20188,81,0,6174,372.050000),(20189,77,0,6174,413.383333),(20190,78,0,6175,389.373333),(20191,81,0,6175,438.050000),(20192,77,0,6175,486.716667),(20193,78,0,6176,251.666667),(20194,81,0,6176,239.568000),(20195,77,0,6176,276.833333),(20196,78,0,6177,166.666667),(20197,81,0,6177,154.836000),(20198,77,0,6177,183.333333),(20199,78,0,6178,181.666667),(20200,81,0,6178,165.540000),(20201,77,0,6178,199.833333),(20202,78,0,6179,204.166667),(20203,81,0,6179,194.268000),(20204,77,0,6179,224.583333),(20205,78,0,6180,769.980000),(20206,81,0,6180,790.560000),(20207,77,0,6180,1098.000000),(20208,78,0,6181,638.383333),(20209,81,0,6181,718.560000),(20210,77,0,6181,998.000000),(20211,78,0,6182,450.133333),(20212,81,0,6182,480.960000),(20213,77,0,6182,668.000000),(20214,78,0,6183,254.166667),(20215,81,0,6183,250.560000),(20216,77,0,6183,348.000000),(20217,78,0,6184,444.975000),(20218,81,0,6184,430.560000),(20219,77,0,6184,598.000000),(20220,78,0,6185,109.916667),(20221,81,0,6185,77.892000),(20222,77,0,6185,120.908333),(20223,78,0,6186,503.425000),(20224,81,0,6186,524.160000),(20225,77,0,6186,728.000000),(20226,78,0,6187,178.333334),(20227,81,0,6187,128.040000),(20228,77,0,6187,196.166667),(20229,78,0,6188,126.666667),(20230,81,0,6188,84.720000),(20231,77,0,6188,139.333333),(20232,78,0,6189,614.600000),(20233,81,0,6189,632.160000),(20234,77,0,6189,878.000000),(20235,78,0,6190,768.600000),(20236,81,0,6190,790.560000),(20237,77,0,6190,1098.000000),(20238,78,0,6191,802.660000),(20239,81,0,6191,862.560000),(20240,77,0,6191,1198.000000),(20241,78,0,6192,189.416667),(20242,81,0,6192,168.264000),(20243,77,0,6192,208.358333),(20244,78,0,6193,189.416667),(20245,81,0,6193,168.264000),(20246,77,0,6193,208.358333),(20247,78,0,6194,181.666667),(20248,81,0,6194,168.264000),(20249,77,0,6194,199.833333),(20250,78,0,6195,399.200000),(20251,81,0,6195,449.100000),(20252,77,0,6195,499.000000),(20253,78,0,6196,299.600000),(20254,81,0,6196,308.160000),(20255,77,0,6196,428.000000),(20256,78,0,6197,367.980000),(20257,81,0,6197,358.560000),(20258,77,0,6197,498.000000),(20259,78,0,6198,421.166667),(20260,81,0,6198,480.960000),(20261,77,0,6198,668.000000),(20262,78,0,6199,423.333333),(20263,81,0,6199,473.760000),(20264,77,0,6199,658.000000),(20265,78,0,6200,470.833333),(20266,81,0,6200,538.560000),(20267,77,0,6200,748.000000),(20268,78,0,6201,482.600000),(20269,81,0,6201,509.760000),(20270,77,0,6201,708.000000),(20271,78,0,6202,411.873333),(20272,81,0,6202,436.360000),(20273,77,0,6202,514.841667),(20274,78,0,6203,443.628000),(20275,81,0,6203,443.628000),(20276,77,0,6203,492.920000),(20277,78,0,6204,468.369000),(20278,81,0,6204,468.369000),(20279,77,0,6204,520.410000),(20280,78,0,6205,105.833334),(20281,81,0,6205,75.468000),(20282,77,0,6205,116.416667),(20283,78,0,6206,201.333333),(20284,81,0,6206,225.820000),(20285,77,0,6206,251.666667),(20286,78,0,6207,287.373333),(20287,81,0,6207,323.300000),(20288,77,0,6207,359.216667),(20289,78,0,6208,142.500000),(20290,81,0,6208,123.320000),(20291,77,0,6208,156.750000),(20292,78,0,6209,143.170000),(20293,81,0,6209,126.950000),(20294,77,0,6209,157.480000),(20295,78,0,6210,207.500000),(20296,81,0,6210,204.384000),(20297,77,0,6210,228.250000),(20298,78,0,6211,258.333334),(20299,81,0,6211,240.060000),(20300,77,0,6211,284.166667),(20301,78,0,6212,279.166667),(20302,81,0,6212,266.340000),(20303,77,0,6212,307.083333),(20304,78,0,6213,397.346667),(20305,81,0,6213,447.020000),(20306,77,0,6213,496.683333),(20307,78,0,6214,473.346667),(20308,81,0,6214,532.520000),(20309,77,0,6214,591.683333),(20310,78,0,6215,532.673333),(20311,81,0,6215,599.260000),(20312,77,0,6215,665.841667),(20313,78,0,6216,353.266667),(20314,81,0,6216,397.430000),(20315,77,0,6216,441.583333),(20316,78,0,6217,401.153333),(20317,81,0,6217,451.300000),(20318,77,0,6217,501.441667),(20319,78,0,6218,436.640000),(20320,81,0,6218,491.220000),(20321,77,0,6218,545.800000),(20322,78,0,6219,464.686667),(20323,81,0,6219,522.780000),(20324,77,0,6219,580.858333),(20325,78,0,6220,71.333334),(20326,81,0,6220,38.940000),(20327,77,0,6220,78.466667),(20328,78,0,6221,78.500000),(20329,81,0,6221,47.700000),(20330,77,0,6221,86.350000),(20331,78,0,6222,104.166667),(20332,81,0,6222,77.890000),(20333,77,0,6222,114.583333),(20334,78,0,6223,209.006667),(20335,81,0,6223,235.140000),(20336,77,0,6223,261.258333),(20337,78,0,6224,266.653333),(20338,81,0,6224,299.990000),(20339,77,0,6224,333.316667),(20340,78,0,6225,277.406667),(20341,81,0,6225,312.080000),(20342,77,0,6225,346.758333),(20343,78,0,6226,350.626667),(20344,81,0,6226,394.450000),(20345,77,0,6226,438.283333),(20346,78,0,6227,338.800000),(20347,81,0,6227,381.160000),(20348,77,0,6227,423.500000),(20349,78,0,6228,348.366667),(20350,81,0,6228,391.920000),(20351,77,0,6228,435.458333),(20352,78,0,6229,259.158333),(20353,81,0,6229,257.760000),(20354,77,0,6229,358.000000),(20355,78,0,6230,306.708333),(20356,81,0,6230,286.560000),(20357,77,0,6230,398.000000),(20358,78,0,6231,291.650000),(20359,81,0,6231,308.160000),(20360,77,0,6231,428.000000),(20361,78,0,6232,282.166667),(20362,81,0,6232,286.560000),(20363,77,0,6232,398.000000),(20364,78,0,6233,173.830000),(20365,81,0,6233,163.220000),(20366,77,0,6233,191.220000),(20367,78,0,6234,313.450000),(20368,81,0,6234,322.560000),(20369,77,0,6234,448.000000),(20370,78,0,6235,332.741667),(20371,81,0,6235,344.160000),(20372,77,0,6235,478.000000),(20373,78,0,6236,348.075000),(20374,81,0,6236,387.360000),(20375,77,0,6236,538.000000),(20376,78,0,6237,348.330000),(20377,81,0,6237,372.960000),(20378,77,0,6237,518.000000),(20379,78,0,6238,385.966667),(20380,81,0,6238,430.560000),(20381,77,0,6238,598.000000),(20382,78,0,6239,367.710000),(20383,81,0,6239,351.360000),(20384,77,0,6239,488.000000),(20385,78,0,6240,325.000000),(20386,81,0,6240,324.770000),(20387,77,0,6240,357.500000),(20388,78,0,6241,348.250000),(20389,81,0,6241,350.580000),(20390,77,0,6241,383.070000),(20391,78,0,6242,160.833334),(20392,81,0,6242,113.832000),(20393,77,0,6242,176.916667),(20394,78,0,6243,293.333333),(20395,81,0,6243,275.000000),(20396,77,0,6243,366.666667),(20397,78,0,6244,352.000000),(20398,81,0,6244,330.000000),(20399,77,0,6244,440.000000),(20400,78,0,6245,318.733333),(20401,81,0,6245,358.580000),(20402,77,0,6245,398.416667),(20403,78,0,6246,360.733333),(20404,81,0,6246,405.830000),(20405,77,0,6246,450.916667),(20406,78,0,6247,426.553333),(20407,81,0,6247,479.540000),(20408,77,0,6247,533.191667),(20409,78,0,6248,420.306667),(20410,81,0,6248,472.850000),(20411,77,0,6248,525.383333),(20412,78,0,6249,174.400000),(20413,81,0,6249,195.340000),(20414,77,0,6249,216.666667),(20415,78,0,6250,235.200000),(20416,81,0,6250,264.520000),(20417,77,0,6250,294.000000),(20418,78,0,6251,240.800000),(20419,81,0,6251,270.110000),(20420,77,0,6251,301.000000),(20421,78,0,6252,395.200000),(20422,81,0,6252,443.990000),(20423,77,0,6252,494.000000),(20424,78,0,6253,273.553333),(20425,81,0,6253,307.750000),(20426,77,0,6253,341.941667),(20427,78,0,6254,430.400000),(20428,81,0,6254,484.190000),(20429,77,0,6254,538.000000),(20430,78,0,6255,314.666667),(20431,81,0,6255,354.000000),(20432,77,0,6255,393.333333),(20433,78,0,6256,430.400000),(20434,81,0,6256,484.190000),(20435,77,0,6256,538.000000),(20436,78,0,6257,311.120000),(20437,81,0,6257,314.680000),(20438,77,0,6257,444.460000),(20439,78,0,6258,204.170000),(20440,81,0,6258,192.830000),(20441,77,0,6258,224.580000),(20442,78,0,6259,218.330000),(20443,81,0,6259,209.960000),(20444,77,0,6259,240.170000),(20445,78,0,6260,225.830000),(20446,81,0,6260,224.960000),(20447,77,0,6260,248.420000),(20448,78,0,6261,456.800000),(20449,81,0,6261,513.130000),(20450,77,0,6261,571.000000),(20451,78,0,6262,456.800000),(20452,81,0,6262,513.130000),(20453,77,0,6262,571.000000),(20454,78,0,6263,311.200000),(20455,81,0,6263,349.560000),(20456,77,0,6263,389.000000),(20457,78,0,6264,363.200000),(20458,81,0,6264,408.390000),(20459,77,0,6264,454.000000),(20460,78,0,6265,436.800000),(20461,81,0,6265,491.140000),(20462,77,0,6265,546.000000),(20463,78,0,6266,492.000000),(20464,81,0,6266,552.640000),(20465,77,0,6266,615.000000),(20466,78,0,6267,513.600000),(20467,81,0,6267,577.800000),(20468,77,0,6267,642.000000),(20469,78,0,6268,566.600000),(20470,81,0,6268,637.430000),(20471,77,0,6268,708.250000),(20472,78,0,6269,325.850000),(20473,81,0,6269,329.760000),(20474,77,0,6269,458.000000),(20475,78,0,6270,343.333333),(20476,81,0,6270,365.760000),(20477,77,0,6270,508.000000),(20478,78,0,6271,163.333334),(20479,81,0,6271,130.476000),(20480,77,0,6271,179.666667),(20481,78,0,6272,373.333334),(20482,81,0,6272,387.096000),(20483,77,0,6272,410.666667),(20484,78,0,6273,170.666667),(20485,81,0,6273,150.240000),(20486,77,0,6273,187.733333),(20487,78,0,6274,373.333334),(20488,81,0,6274,376.728000),(20489,77,0,6274,410.666667),(20490,78,0,6275,172.500000),(20491,81,0,6275,150.240000),(20492,77,0,6275,189.750000),(20493,78,0,6276,196.666667),(20494,81,0,6276,170.328000),(20495,77,0,6276,216.333333),(20496,78,0,6277,395.000000),(20497,81,0,6277,409.788000),(20498,77,0,6277,434.500000),(20499,78,0,6278,292.173333),(20500,81,0,6278,328.700000),(20501,77,0,6278,365.216667),(20502,78,0,6279,345.840000),(20503,81,0,6279,389.080000),(20504,77,0,6279,432.300000),(20505,78,0,6280,144.830000),(20506,81,0,6280,126.400000),(20507,77,0,6280,263.330000),(20508,78,0,6281,155.380000),(20509,81,0,6281,135.600000),(20510,77,0,6281,282.500000),(20511,78,0,6282,221.380000),(20512,81,0,6282,193.200000),(20513,77,0,6282,402.500000),(20514,78,0,6283,189.750000),(20515,81,0,6283,165.600000),(20516,77,0,6283,345.000000),(20517,78,0,6284,156.666667),(20518,81,0,6284,140.220000),(20519,77,0,6284,172.333333),(20520,78,0,6285,443.333334),(20521,81,0,6285,431.400000),(20522,77,0,6285,487.666667),(20523,78,0,6286,200.833334),(20524,81,0,6286,180.660000),(20525,77,0,6286,220.916667),(20526,78,0,6287,238.333334),(20527,81,0,6287,223.020000),(20528,77,0,6287,262.166667),(20529,78,0,6288,209.166667),(20530,81,0,6288,200.604000),(20531,77,0,6288,230.083333),(20532,78,0,6289,256.583334),(20533,81,0,6289,244.932000),(20534,77,0,6289,282.241667),(20535,78,0,6290,396.666667),(20536,81,0,6290,431.400000),(20537,77,0,6290,436.333333),(20538,78,0,6291,267.500000),(20539,81,0,6291,261.000000),(20540,77,0,6291,294.250000),(20541,78,0,6292,214.573333),(20542,81,0,6292,241.400000),(20543,77,0,6292,268.216667),(20544,78,0,6293,255.333333),(20545,81,0,6293,286.330000),(20546,77,0,6293,319.166667),(20547,78,0,6294,209.166667),(20548,81,0,6294,188.520000),(20549,77,0,6294,230.083333),(20550,78,0,6295,205.000000),(20551,81,0,6295,188.520000),(20552,77,0,6295,225.500000),(20553,78,0,6296,204.166667),(20554,81,0,6296,188.520000),(20555,77,0,6296,224.583333),(20556,78,0,6297,130.000000),(20557,81,0,6297,94.272000),(20558,77,0,6297,143.000000),(20559,78,0,6298,112.596667),(20560,81,0,6298,70.120000),(20561,77,0,6298,123.856333),(20562,78,0,6299,234.766667),(20563,81,0,6299,264.120000),(20564,77,0,6299,293.458333),(20565,78,0,6300,110.840000),(20566,81,0,6300,84.720000),(20567,77,0,6300,121.920000),(20568,78,0,6301,97.500000),(20569,81,0,6301,67.188000),(20570,77,0,6301,107.250000),(20571,78,0,6302,104.166667),(20572,81,0,6302,72.060000),(20573,77,0,6302,114.583333),(20574,78,0,6303,105.000000),(20575,81,0,6303,77.892000),(20576,77,0,6303,115.500000),(20577,78,0,6304,184.666667),(20578,81,0,6304,158.736000),(20579,77,0,6304,203.133333),(20580,78,0,6305,160.496667),(20581,81,0,6305,145.180000),(20582,77,0,6305,176.546333),(20583,78,0,6306,200.496667),(20584,81,0,6306,196.320000),(20585,77,0,6306,220.546333),(20586,78,0,6307,198.946667),(20587,81,0,6307,179.736000),(20588,77,0,6307,218.841333),(20589,78,0,6308,199.816667),(20590,81,0,6308,180.780000),(20591,77,0,6308,219.798333),(20592,78,0,6309,243.600000),(20593,81,0,6309,250.560000),(20594,77,0,6309,348.000000),(20595,78,0,6310,118.720000),(20596,81,0,6310,134.110000),(20597,77,0,6310,148.400000),(20598,78,0,6311,159.453333),(20599,81,0,6311,179.740000),(20600,77,0,6311,199.316667),(20601,78,0,6312,342.450000),(20602,81,0,6312,380.160000),(20603,77,0,6312,528.000000),(20604,78,0,6313,256.770000),(20605,81,0,6313,286.560000),(20606,77,0,6313,398.000000),(20607,78,0,6314,301.666667),(20608,81,0,6314,315.360000),(20609,77,0,6314,438.000000),(20610,78,0,6315,285.600000),(20611,81,0,6315,293.760000),(20612,77,0,6315,408.000000),(20613,78,0,6316,231.708333),(20614,81,0,6316,243.360000),(20615,77,0,6316,338.000000),(20616,78,0,6317,363.491667),(20617,81,0,6317,408.960000),(20618,77,0,6317,568.000000),(20619,78,0,6318,470.833333),(20620,81,0,6318,538.560000),(20621,77,0,6318,748.000000),(20622,78,0,6319,515.000000),(20623,81,0,6319,588.960000),(20624,77,0,6319,818.000000),(20625,78,0,6320,382.650000),(20626,81,0,6320,430.560000),(20627,77,0,6320,598.000000),(20628,78,0,6321,534.366667),(20629,81,0,6321,603.360000),(20630,77,0,6321,838.000000),(20631,78,0,6322,541.733333),(20632,81,0,6322,610.560000),(20633,77,0,6322,848.000000),(20634,78,0,6323,465.541667),(20635,81,0,6323,488.160000),(20636,77,0,6323,678.000000),(20637,78,0,6324,426.666667),(20638,81,0,6324,466.560000),(20639,77,0,6324,648.000000),(20640,78,0,6325,514.560000),(20641,81,0,6325,552.960000),(20642,77,0,6325,768.000000),(20643,78,0,6326,460.833333),(20644,81,0,6326,516.960000),(20645,77,0,6326,718.000000),(20646,78,0,6327,505.816667),(20647,81,0,6327,531.360000),(20648,77,0,6327,738.000000),(20649,78,0,6328,175.000000),(20650,81,0,6328,160.692000),(20651,77,0,6328,192.500000),(20652,78,0,6329,200.000000),(20653,81,0,6329,180.660000),(20654,77,0,6329,220.000000),(20655,78,0,6330,211.666667),(20656,81,0,6330,200.604000),(20657,77,0,6330,232.833333),(20658,78,0,6331,229.166667),(20659,81,0,6331,220.572000),(20660,77,0,6331,252.083333),(20661,78,0,6332,317.693333),(20662,81,0,6332,326.120000),(20663,77,0,6332,397.116667),(20664,78,0,6333,374.686667),(20665,81,0,6333,421.540000),(20666,77,0,6333,468.358333),(20667,78,0,6334,422.466667),(20668,81,0,6334,475.280000),(20669,77,0,6334,528.083333),(20670,78,0,6335,500.753333),(20671,81,0,6335,563.360000),(20672,77,0,6335,625.941667),(20673,78,0,6336,346.673333),(20674,81,0,6336,390.020000),(20675,77,0,6336,433.341667),(20676,78,0,6337,408.000000),(20677,81,0,6337,455.180000),(20678,77,0,6337,510.000000),(20679,78,0,6338,665.830000),(20680,81,0,6338,682.560000),(20681,77,0,6338,948.000000),(20682,78,0,6339,519.208333),(20683,81,0,6339,538.560000),(20684,77,0,6339,748.000000),(20685,78,0,6340,276.666667),(20686,81,0,6340,293.760000),(20687,77,0,6340,408.000000),(20688,78,0,6341,293.333333),(20689,81,0,6341,315.360000),(20690,77,0,6341,438.000000),(20691,78,0,6342,305.000000),(20692,81,0,6342,344.160000),(20693,77,0,6342,478.000000),(20694,78,0,6343,383.600000),(20695,81,0,6343,394.560000),(20696,77,0,6343,548.000000),(20697,78,0,6344,299.991667),(20698,81,0,6344,322.560000),(20699,77,0,6344,448.000000),(20700,78,0,6345,260.000000),(20701,81,0,6345,272.160000),(20702,77,0,6345,378.000000),(20703,78,0,6346,532.730000),(20704,81,0,6346,515.250000),(20705,77,0,6346,954.170000),(20706,78,0,6347,758.210000),(20707,81,0,6347,733.500000),(20708,77,0,6347,1358.330000),(20709,78,0,6348,733.210000),(20710,81,0,6348,733.500000),(20711,77,0,6348,1358.330000),(20712,78,0,6349,539.880000),(20713,81,0,6349,447.750000),(20714,77,0,6349,829.170000),(20715,78,0,6350,950.160000),(20716,81,0,6350,920.250000),(20717,77,0,6350,1704.170000),(20718,78,0,6351,515.370000),(20719,81,0,6351,447.750000),(20720,77,0,6351,829.170000),(20721,78,0,6352,542.730000),(20722,81,0,6352,488.250000),(20723,77,0,6352,904.170000),(20724,78,0,6353,559.640000),(20725,81,0,6353,443.250000),(20726,77,0,6353,820.830000),(20727,78,0,6354,482.500000),(20728,81,0,6354,447.750000),(20729,77,0,6354,829.170000),(20730,78,0,6355,645.960000),(20731,81,0,6355,612.000000),(20732,77,0,6355,1133.330000),(20733,78,0,6356,563.800000),(20734,81,0,6356,569.250000),(20735,77,0,6356,1054.166667),(20736,78,0,6357,926.900000),(20737,81,0,6357,922.500000),(20738,77,0,6357,1708.330000),(20739,78,0,6358,1107.500000),(20740,81,0,6358,974.250000),(20741,77,0,6358,1804.170000),(20742,78,0,6359,616.580000),(20743,81,0,6359,569.250000),(20744,77,0,6359,1054.170000),(20745,78,0,6360,1045.830000),(20746,81,0,6360,920.250000),(20747,77,0,6360,1704.170000),(20748,78,0,6361,956.820000),(20749,81,0,6361,949.500000),(20750,77,0,6361,1758.330000),(20751,78,0,6362,956.810000),(20752,81,0,6362,949.500000),(20753,77,0,6362,1758.330000),(20754,78,0,6363,808.180000),(20755,81,0,6363,731.250000),(20756,77,0,6363,1354.170000),(20757,78,0,6364,732.630000),(20758,81,0,6364,731.250000),(20759,77,0,6364,1354.170000),(20760,78,0,6365,683.330000),(20761,81,0,6365,612.000000),(20762,77,0,6365,1133.330000),(20763,78,0,6366,683.330000),(20764,81,0,6366,612.000000),(20765,77,0,6366,1133.330000),(20766,78,0,6367,683.330000),(20767,81,0,6367,612.000000),(20768,77,0,6367,1133.330000),(20769,78,0,6368,188.500000),(20770,81,0,6368,143.260000),(20771,77,0,6368,314.170000),(20772,78,0,6369,213.000000),(20773,81,0,6369,161.880000),(20774,77,0,6369,355.000000),(20775,78,0,6370,230.000000),(20776,81,0,6370,174.800000),(20777,77,0,6370,383.330000),(20778,78,0,6371,170.000000),(20779,81,0,6371,129.200000),(20780,77,0,6371,283.330000),(20781,78,0,6372,176.000000),(20782,81,0,6372,133.760000),(20783,77,0,6372,293.330000),(20784,78,0,6373,181.500000),(20785,81,0,6373,137.940000),(20786,77,0,6373,302.500000),(20787,78,0,6374,211.500000),(20788,81,0,6374,160.740000),(20789,77,0,6374,352.500000),(20790,78,0,6375,222.500000),(20791,81,0,6375,169.100000),(20792,77,0,6375,370.830000),(20793,78,0,6376,178.500000),(20794,81,0,6376,135.660000),(20795,77,0,6376,297.500000),(20796,78,0,6377,183.500000),(20797,81,0,6377,139.460000),(20798,77,0,6377,305.830000),(20799,78,0,6378,188.500000),(20800,81,0,6378,143.260000),(20801,77,0,6378,314.170000),(20802,78,0,6379,213.000000),(20803,81,0,6379,161.880000),(20804,77,0,6379,355.000000),(20805,78,0,6380,230.000000),(20806,81,0,6380,174.800000),(20807,77,0,6380,383.330000),(20808,78,0,6381,187.500000),(20809,81,0,6381,142.500000),(20810,77,0,6381,312.500000),(20811,78,0,6382,211.500000),(20812,81,0,6382,160.740000),(20813,77,0,6382,352.500000),(20814,78,0,6383,226.000000),(20815,81,0,6383,171.760000),(20816,77,0,6383,376.670000),(20817,78,0,6384,375.830000),(20818,81,0,6384,328.000000),(20819,77,0,6384,683.330000),(20820,78,0,6385,275.000000),(20821,81,0,6385,240.000000),(20822,77,0,6385,500.000000),(20823,78,0,6386,216.790000),(20824,81,0,6386,189.200000),(20825,77,0,6386,394.170000),(20826,78,0,6387,251.630000),(20827,81,0,6387,219.600000),(20828,77,0,6387,457.500000),(20829,78,0,6388,167.939600),(20830,81,0,6388,148.182000),(20831,77,0,6388,246.970000),(20832,78,0,6389,279.670400),(20833,81,0,6389,246.768000),(20834,77,0,6389,411.280000),(20835,78,0,6390,377.960000),(20836,81,0,6390,333.490000),(20837,77,0,6390,555.820000),(20838,78,0,6391,377.960000),(20839,81,0,6391,333.490000),(20840,77,0,6391,555.820000),(20841,78,0,6392,544.040000),(20842,81,0,6392,535.920000),(20843,77,0,6392,812.000000),(20844,78,0,6393,533.990000),(20845,81,0,6393,526.020000),(20846,77,0,6393,797.000000),(20847,78,0,6394,618.410000),(20848,81,0,6394,609.180000),(20849,77,0,6394,923.000000),(20850,78,0,6395,812.040000),(20851,81,0,6395,799.920000),(20852,77,0,6395,1212.000000),(20853,78,0,6396,615.060000),(20854,81,0,6396,605.880000),(20855,77,0,6396,918.000000),(20856,78,0,6397,649.900000),(20857,81,0,6397,640.200000),(20858,77,0,6397,970.000000),(20859,78,0,6398,857.600000),(20860,81,0,6398,844.800000),(20861,77,0,6398,1280.000000),(20862,78,0,6399,994.280000),(20863,81,0,6399,979.440000),(20864,77,0,6399,1484.000000),(20865,78,0,6400,2517.190000),(20866,81,0,6400,2479.620000),(20867,77,0,6400,3757.000000),(20868,78,0,6401,927.950000),(20869,81,0,6401,914.100000),(20870,77,0,6401,1385.000000),(20871,78,0,6402,2517.190000),(20872,81,0,6402,2479.620000),(20873,77,0,6402,3757.000000),(20874,77,0,6403,693.440000),(20875,78,0,6404,187.270000),(20876,81,0,6404,165.240000),(20877,77,0,6404,275.400000),(20878,78,0,6405,509.200000),(20879,81,0,6405,501.600000),(20880,77,0,6405,760.000000),(20881,78,0,6406,509.200000),(20882,81,0,6406,501.600000),(20883,77,0,6406,760.000000),(20884,78,0,6407,509.200000),(20885,81,0,6407,501.600000),(20886,77,0,6407,760.000000),(20887,78,0,6408,519.960000),(20888,81,0,6408,505.560000),(20889,77,0,6408,766.000000),(20890,78,0,6409,525.950000),(20891,81,0,6409,518.100000),(20892,77,0,6409,785.000000),(20893,78,0,6410,525.950000),(20894,81,0,6410,518.100000),(20895,77,0,6410,785.000000),(20896,78,0,6411,485.080000),(20897,81,0,6411,477.840000),(20898,77,0,6411,724.000000),(20899,78,0,6412,528.370000),(20900,81,0,6412,512.820000),(20901,77,0,6412,777.000000),(20902,78,0,6413,598.980000),(20903,81,0,6413,590.040000),(20904,77,0,6413,894.000000),(20905,78,0,6414,571.510000),(20906,81,0,6414,562.980000),(20907,77,0,6414,853.000000),(20908,78,0,6415,571.510000),(20909,81,0,6415,562.980000),(20910,77,0,6415,853.000000),(20911,78,0,6416,509.200000),(20912,81,0,6416,501.600000),(20913,77,0,6416,760.000000),(20914,78,0,6417,525.950000),(20915,81,0,6417,518.100000),(20916,77,0,6417,785.000000),(20917,78,0,6418,584.910000),(20918,81,0,6418,576.180000),(20919,77,0,6418,873.000000),(20920,78,0,6419,552.080000),(20921,81,0,6419,543.840000),(20922,77,0,6419,824.000000),(20923,78,0,6420,612.380000),(20924,81,0,6420,603.240000),(20925,77,0,6420,914.000000),(20926,78,0,6421,525.950000),(20927,81,0,6421,518.100000),(20928,77,0,6421,785.000000),(20929,78,0,6422,769.160000),(20930,81,0,6422,757.680000),(20931,77,0,6422,1148.000000),(20932,78,0,6423,525.950000),(20933,81,0,6423,518.100000),(20934,77,0,6423,785.000000),(20935,78,0,6424,473.580000),(20936,81,0,6424,460.020000),(20937,77,0,6424,697.000000),(20938,78,0,6425,525.950000),(20939,81,0,6425,518.100000),(20940,77,0,6425,785.000000),(20941,78,0,6426,479.050000),(20942,81,0,6426,471.900000),(20943,77,0,6426,715.000000),(20944,78,0,6427,544.040000),(20945,81,0,6427,535.920000),(20946,77,0,6427,812.000000),(20947,78,0,6428,849.200000),(20948,81,0,6428,824.340000),(20949,77,0,6428,1249.000000),(20950,78,0,6429,968.820000),(20951,81,0,6429,954.360000),(20952,77,0,6429,1446.000000),(20953,78,0,6430,1086.070000),(20954,81,0,6430,1069.860000),(20955,77,0,6430,1621.000000),(20956,78,0,6431,375.200000),(20957,81,0,6431,369.600000),(20958,77,0,6431,560.000000),(20959,78,0,6432,415.583333),(20960,81,0,6432,438.240000),(20961,77,0,6432,664.000000),(20962,78,0,6433,456.270000),(20963,81,0,6433,449.460000),(20964,77,0,6433,681.000000),(20965,78,0,6434,456.270000),(20966,81,0,6434,449.460000),(20967,77,0,6434,681.000000),(20968,78,0,6435,501.830000),(20969,81,0,6435,494.340000),(20970,77,0,6435,749.000000),(20971,78,0,6436,456.270000),(20972,81,0,6436,449.460000),(20973,77,0,6436,681.000000),(20974,78,0,6437,456.270000),(20975,81,0,6437,449.460000),(20976,77,0,6437,681.000000),(20977,78,0,6438,456.270000),(20978,81,0,6438,449.460000),(20979,77,0,6438,681.000000),(20980,78,0,6439,501.830000),(20981,81,0,6439,494.340000),(20982,77,0,6439,749.000000),(20983,78,0,6440,414.730000),(20984,81,0,6440,408.540000),(20985,77,0,6440,619.000000),(20986,78,0,6441,395.300000),(20987,81,0,6441,389.400000),(20988,77,0,6441,590.000000),(20989,78,0,6442,375.200000),(20990,81,0,6442,369.600000),(20991,77,0,6442,560.000000),(20992,78,0,6443,479.050000),(20993,81,0,6443,471.900000),(20994,77,0,6443,715.000000),(20995,78,0,6444,330.866667),(20996,81,0,6444,322.740000),(20997,77,0,6444,489.000000),(20998,78,0,6445,335.670000),(20999,81,0,6445,330.660000),(21000,77,0,6445,501.000000),(21034,78,0,6446,375.200000),(21035,81,0,6446,369.600000),(21036,77,0,6446,560.000000),(21037,78,0,6447,479.050000),(21038,81,0,6447,471.900000),(21039,77,0,6447,715.000000),(21040,78,0,6448,479.050000),(21041,81,0,6448,471.900000),(21042,77,0,6448,715.000000),(21043,78,0,6449,375.200000),(21044,81,0,6449,369.600000),(21045,77,0,6449,560.000000),(21046,78,0,6450,335.670000),(21047,81,0,6450,330.660000),(21048,77,0,6450,501.000000),(21049,78,0,6451,479.050000),(21050,81,0,6451,471.900000),(21051,77,0,6451,715.000000),(21052,78,0,6452,412.720000),(21053,81,0,6452,406.560000),(21054,77,0,6452,616.000000),(21055,78,0,6453,526.620000),(21056,81,0,6453,518.760000),(21057,77,0,6453,786.000000),(21058,78,0,6454,994.280000),(21059,81,0,6454,979.440000),(21060,77,0,6454,1484.000000),(21061,78,0,6455,994.280000),(21062,81,0,6455,979.440000),(21063,77,0,6455,1484.000000),(21064,78,0,6456,1043.860000),(21065,81,0,6456,1028.280000),(21066,77,0,6456,1558.000000),(21067,78,0,6457,1094.110000),(21068,81,0,6457,1077.780000),(21069,77,0,6457,1633.000000),(21070,78,0,6458,927.950000),(21071,81,0,6458,914.100000),(21072,77,0,6458,1385.000000),(21073,78,0,6459,927.950000),(21074,81,0,6459,914.100000),(21075,77,0,6459,1385.000000),(21076,78,0,6460,974.180000),(21077,81,0,6460,959.640000),(21078,77,0,6460,1454.000000),(21079,78,0,6461,1021.080000),(21080,81,0,6461,1005.840000),(21081,77,0,6461,1524.000000),(21082,78,0,6462,1193.270000),(21083,81,0,6462,1175.460000),(21084,77,0,6462,1781.000000),(21085,78,0,6463,491.110000),(21086,81,0,6463,483.780000),(21087,77,0,6463,733.000000),(21088,78,0,6464,335.670000),(21089,81,0,6464,330.660000),(21090,77,0,6464,501.000000),(21091,78,0,6465,2451.690000),(21092,81,0,6465,2419.560000),(21093,77,0,6465,3666.000000),(21094,78,0,6466,2643.150000),(21095,81,0,6466,2603.700000),(21096,77,0,6466,3945.000000),(21097,78,0,6467,2769.110000),(21098,81,0,6467,2727.780000),(21099,77,0,6467,4133.000000),(21100,78,0,6468,2451.690000),(21101,81,0,6468,2419.560000),(21102,77,0,6468,3666.000000),(21103,78,0,6469,2643.150000),(21104,81,0,6469,2603.700000),(21105,77,0,6469,3945.000000),(21106,78,0,6470,2769.110000),(21107,81,0,6470,2727.780000),(21108,77,0,6470,4133.000000),(21109,78,0,6471,751.740000),(21110,81,0,6471,740.520000),(21111,77,0,6471,1122.000000),(21112,78,0,6472,615.060000),(21113,81,0,6472,605.880000),(21114,77,0,6472,918.000000),(21115,78,0,6473,615.060000),(21116,81,0,6473,605.880000),(21117,77,0,6473,918.000000),(21118,78,0,6474,615.060000),(21119,81,0,6474,605.880000),(21120,77,0,6474,918.000000),(21121,78,0,6475,615.060000),(21122,81,0,6475,605.880000),(21123,77,0,6475,918.000000),(21124,78,0,6476,615.060000),(21125,81,0,6476,605.880000),(21126,77,0,6476,918.000000),(21127,78,0,6477,615.060000),(21128,81,0,6477,605.880000),(21129,77,0,6477,918.000000),(21130,78,0,6478,615.060000),(21131,81,0,6478,605.880000),(21132,77,0,6478,918.000000),(21133,78,0,6479,615.060000),(21134,81,0,6479,605.880000),(21135,77,0,6479,918.000000),(21136,78,0,6480,615.060000),(21137,81,0,6480,605.880000),(21138,77,0,6480,918.000000),(21139,78,0,6481,615.060000),(21140,81,0,6481,605.880000),(21141,77,0,6481,918.000000),(21142,78,0,6482,751.740000),(21143,81,0,6482,740.520000),(21144,77,0,6482,1122.000000),(21145,78,0,6483,3946.300000),(21146,81,0,6483,3887.400000),(21147,77,0,6483,5890.000000),(21148,78,0,6484,680.720000),(21149,81,0,6484,670.560000),(21150,77,0,6484,1016.000000),(21151,78,0,6485,2468.000000),(21152,81,0,6485,1974.400000),(21153,77,0,6485,4113.330000),(21154,78,0,6486,305.250000),(21155,81,0,6486,266.400000),(21156,77,0,6486,555.000000),(21157,78,0,6487,176.000000),(21158,81,0,6487,153.600000),(21159,77,0,6487,320.000000),(21160,78,0,6488,275.000000),(21161,81,0,6488,240.000000),(21162,77,0,6488,500.000000),(21163,78,0,6489,274.500000),(21164,81,0,6489,219.600000),(21165,77,0,6489,457.500000),(21166,78,0,6490,303.800000),(21167,81,0,6490,248.000000),(21168,77,0,6490,516.670000),(21169,78,0,6491,2230.002000),(21170,81,0,6491,1784.001600),(21171,77,0,6491,3716.670000),(21172,78,0,6492,1511.668000),(21173,81,0,6492,1315.151160),(21174,77,0,6492,3779.170000),(21175,78,0,6493,1511.668000),(21176,81,0,6493,1315.151160),(21177,77,0,6493,3779.170000),(21178,78,0,6494,1511.668000),(21179,81,0,6494,1315.151160),(21180,77,0,6494,3779.170000),(21181,78,0,6495,1653.332000),(21182,81,0,6495,1438.398840),(21183,77,0,6495,4133.330000),(21184,78,0,6496,149.332000),(21185,81,0,6496,129.918840),(21186,77,0,6496,373.330000),(21187,78,0,6497,158.332000),(21188,81,0,6497,137.748840),(21189,77,0,6497,395.830000),(21190,78,0,6498,169.332000),(21191,81,0,6498,147.318840),(21192,77,0,6498,423.330000),(21193,78,0,6499,614.332000),(21194,81,0,6499,534.468840),(21195,77,0,6499,1535.830000),(21196,78,0,6500,489.000000),(21197,81,0,6500,425.430000),(21198,77,0,6500,1222.500000),(21199,78,0,6501,489.000000),(21200,81,0,6501,425.430000),(21201,77,0,6501,1222.500000),(21202,78,0,6502,489.000000),(21203,81,0,6502,425.430000),(21204,77,0,6502,1222.500000),(21205,78,0,6503,489.000000),(21206,81,0,6503,425.430000),(21207,77,0,6503,1222.500000),(21208,78,0,6504,489.000000),(21209,81,0,6504,425.430000),(21210,77,0,6504,1222.500000),(21211,78,0,6505,591.668000),(21212,81,0,6505,514.751160),(21213,77,0,6505,1479.170000),(21214,78,0,6506,591.668000),(21215,81,0,6506,514.751160),(21216,77,0,6506,1479.170000),(21217,78,0,6507,737.000000),(21218,81,0,6507,726.000000),(21219,77,0,6507,1100.000000),(21220,78,0,6508,456.270000),(21221,81,0,6508,449.460000),(21222,77,0,6508,681.000000),(21223,78,0,6509,335.670000),(21224,81,0,6509,330.660000),(21225,77,0,6509,501.000000),(21226,78,0,6510,509.200000),(21227,81,0,6510,501.600000),(21228,77,0,6510,760.000000),(21229,78,0,6511,104.520000),(21230,81,0,6511,102.960000),(21231,77,0,6511,156.000000),(21232,78,0,6512,479.050000),(21233,81,0,6512,471.900000),(21234,77,0,6512,715.000000),(21235,78,0,6513,525.950000),(21236,81,0,6513,518.100000),(21237,77,0,6513,785.000000),(21238,78,0,6514,642.533333),(21239,81,0,6514,624.360000),(21240,77,0,6514,946.000000),(21241,78,0,6515,649.900000),(21242,81,0,6515,640.200000),(21243,77,0,6515,970.000000),(21244,78,0,6516,649.900000),(21245,81,0,6516,640.200000),(21246,77,0,6516,970.000000),(21247,78,0,6517,714.890000),(21248,81,0,6517,704.220000),(21249,77,0,6517,1067.000000),(21250,78,0,6518,807.350000),(21251,81,0,6518,795.300000),(21252,77,0,6518,1205.000000),(21253,78,0,6519,3215.330000),(21254,81,0,6519,3167.340000),(21255,77,0,6519,4799.000000),(21256,78,0,6520,3215.330000),(21257,81,0,6520,3167.340000),(21258,77,0,6520,4799.000000),(21259,78,0,6521,533.990000),(21260,81,0,6521,526.020000),(21261,77,0,6521,797.000000),(21262,78,0,6522,533.990000),(21263,81,0,6522,526.020000),(21264,77,0,6522,797.000000),(21265,78,0,6523,586.920000),(21266,81,0,6523,578.160000),(21267,77,0,6523,876.000000),(21268,78,0,6524,737.000000),(21269,81,0,6524,726.000000),(21270,77,0,6524,1100.000000),(21271,78,0,6525,592.533333),(21272,81,0,6525,523.380000),(21273,77,0,6525,793.000000),(21274,78,0,6526,544.040000),(21275,81,0,6526,535.920000),(21276,77,0,6526,812.000000),(21277,78,0,6527,544.040000),(21278,81,0,6527,535.920000),(21279,77,0,6527,812.000000),(21280,78,0,6528,544.040000),(21281,81,0,6528,535.920000),(21282,77,0,6528,812.000000),(21283,78,0,6529,544.040000),(21284,81,0,6529,535.920000),(21285,77,0,6529,812.000000),(21286,78,0,6530,544.040000),(21287,81,0,6530,535.920000),(21288,77,0,6530,812.000000),(21289,78,0,6531,544.040000),(21290,81,0,6531,535.920000),(21291,77,0,6531,812.000000),(21292,78,0,6532,544.040000),(21293,81,0,6532,535.920000),(21294,77,0,6532,812.000000),(21295,78,0,6533,571.510000),(21296,81,0,6533,562.980000),(21297,77,0,6533,853.000000),(21298,78,0,6534,676.700000),(21299,81,0,6534,666.600000),(21300,77,0,6534,1010.000000),(21301,78,0,6535,680.720000),(21302,81,0,6535,670.560000),(21303,77,0,6535,1016.000000),(21304,78,0,6536,456.270000),(21305,81,0,6536,449.460000),(21306,77,0,6536,681.000000),(21307,78,0,6537,533.990000),(21308,81,0,6537,526.020000),(21309,77,0,6537,797.000000),(21310,78,0,6538,533.990000),(21311,81,0,6538,526.020000),(21312,77,0,6538,797.000000),(21313,78,0,6539,586.920000),(21314,81,0,6539,578.160000),(21315,77,0,6539,876.000000),(21316,78,0,6540,611.700000),(21317,81,0,6540,594.660000),(21318,77,0,6540,901.000000),(21319,78,0,6541,618.410000),(21320,81,0,6541,609.180000),(21321,77,0,6541,923.000000),(21322,78,0,6542,804.200000),(21323,81,0,6542,780.120000),(21324,77,0,6542,1182.000000),(21325,78,0,6543,893.110000),(21326,81,0,6543,879.780000),(21327,77,0,6543,1333.000000),(21328,78,0,6544,1009.020000),(21329,81,0,6544,993.960000),(21330,77,0,6544,1506.000000),(21331,78,0,6545,1218.060000),(21332,81,0,6545,1199.880000),(21333,77,0,6545,1818.000000),(21334,81,0,6546,131.200000),(21335,77,0,6546,273.330000),(21336,81,0,6547,131.200000),(21337,77,0,6547,273.330000),(21338,81,0,6548,131.200000),(21339,77,0,6548,273.330000),(21340,81,0,6549,131.200000),(21341,77,0,6549,273.330000),(21342,81,0,6550,160.000000),(21343,77,0,6550,333.330000),(21344,81,0,6551,160.000000),(21345,77,0,6551,333.330000),(21346,81,0,6552,160.070000),(21347,77,0,6552,333.480000),(21348,81,0,6553,191.600000),(21349,77,0,6553,399.170000),(21350,81,0,6554,160.000000),(21351,77,0,6554,333.330000),(21352,81,0,6555,191.600000),(21353,77,0,6555,399.170000),(21354,81,0,6556,204.000000),(21355,77,0,6556,425.000000),(21356,81,0,6557,303.600000),(21357,77,0,6557,632.500000),(21358,81,0,6558,108.400000),(21359,77,0,6558,225.830000),(21360,81,0,6559,108.400000),(21361,77,0,6559,225.830000),(21362,81,0,6560,108.400000),(21363,77,0,6560,225.830000),(21364,81,0,6561,108.400000),(21365,77,0,6561,225.830000),(21366,81,0,6562,148.400000),(21367,77,0,6562,309.170000),(21368,81,0,6563,1732.000000),(21369,77,0,6563,3608.330000),(21370,78,0,6564,266.500000),(21371,81,0,6564,202.540000),(21372,77,0,6564,444.170000),(21373,78,0,6565,266.500000),(21374,81,0,6565,202.540000),(21375,77,0,6565,444.170000),(21376,78,0,6566,266.500000),(21377,81,0,6566,202.540000),(21378,77,0,6566,444.170000),(21379,78,0,6567,253.000000),(21380,81,0,6567,192.280000),(21381,77,0,6567,421.670000),(21382,78,0,6568,253.000000),(21383,81,0,6568,192.280000),(21384,77,0,6568,421.670000),(21385,78,0,6569,253.000000),(21386,81,0,6569,192.280000),(21387,77,0,6569,421.670000),(21388,78,0,6570,253.000000),(21389,81,0,6570,192.280000),(21390,77,0,6570,421.670000),(21391,78,0,6571,253.000000),(21392,81,0,6571,192.280000),(21393,77,0,6571,421.670000),(21394,78,0,6572,524.610000),(21395,81,0,6572,516.780000),(21396,77,0,6572,783.000000);
/*!40000 ALTER TABLE `catalog_product_entity_decimal` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_decimal_after_insert` AFTER INSERT ON `catalog_product_entity_decimal` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`entity_id`);
INSERT IGNORE INTO `catalog_product_attribute_cl` (`entity_id`) VALUES (NEW.`entity_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`entity_id`);
INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (NEW.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_decimal_after_update` AFTER UPDATE ON `catalog_product_entity_decimal` FOR EACH ROW BEGIN
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalog_product_attribute_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_decimal_after_delete` AFTER DELETE ON `catalog_product_entity_decimal` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (OLD.`entity_id`);
INSERT IGNORE INTO `catalog_product_attribute_cl` (`entity_id`) VALUES (OLD.`entity_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (OLD.`entity_id`);
INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (OLD.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `catalog_product_entity_gallery`
--

DROP TABLE IF EXISTS `catalog_product_entity_gallery`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_entity_gallery` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `position` int NOT NULL DEFAULT '0' COMMENT 'Position',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CATALOG_PRODUCT_ENTITY_GALLERY_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `CATALOG_PRODUCT_ENTITY_GALLERY_ENTITY_ID` (`entity_id`),
  KEY `CATALOG_PRODUCT_ENTITY_GALLERY_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_PRODUCT_ENTITY_GALLERY_STORE_ID` (`store_id`),
  CONSTRAINT `CAT_PRD_ENTT_GLR_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_ENTT_GLR_ENTT_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_PRODUCT_ENTITY_GALLERY_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Gallery Attribute Backend Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_entity_gallery`
--

LOCK TABLES `catalog_product_entity_gallery` WRITE;
/*!40000 ALTER TABLE `catalog_product_entity_gallery` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_entity_gallery` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_entity_int`
--

DROP TABLE IF EXISTS `catalog_product_entity_int`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_entity_int` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` int DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CATALOG_PRODUCT_ENTITY_INT_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `CATALOG_PRODUCT_ENTITY_INT_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_PRODUCT_ENTITY_INT_STORE_ID` (`store_id`),
  KEY `CATALOG_PRODUCT_ENTITY_INT_ATTRIBUTE_ID_STORE_ID_VALUE` (`attribute_id`,`store_id`,`value`),
  CONSTRAINT `CAT_PRD_ENTT_INT_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_ENTT_INT_ENTT_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_PRODUCT_ENTITY_INT_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=31717 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Integer Attribute Backend Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_entity_int`
--

LOCK TABLES `catalog_product_entity_int` WRITE;
/*!40000 ALTER TABLE `catalog_product_entity_int` DISABLE KEYS */;
INSERT INTO `catalog_product_entity_int` VALUES (25625,142,0,5760,0),(25626,141,0,5760,1),(25627,161,0,5760,0),(25628,150,0,5760,0),(25629,140,0,5760,1),(25630,144,0,5760,0),(25631,97,0,5760,1),(25632,136,0,5760,0),(25633,147,0,5760,0),(25634,99,0,5760,4),(25635,143,0,5760,0),(28650,97,5,6035,1),(28651,97,1,6035,1),(28652,97,0,6035,1),(28653,99,5,6035,4),(28654,99,0,6035,4),(28655,97,5,6036,1),(28656,97,1,6036,1),(28657,97,0,6036,1),(28658,99,5,6036,4),(28659,99,0,6036,4),(28660,97,5,6037,1),(28661,97,1,6037,1),(28662,97,0,6037,1),(28663,99,5,6037,4),(28664,99,0,6037,4),(28665,97,5,6038,1),(28666,97,1,6038,1),(28667,97,0,6038,1),(28668,99,5,6038,4),(28669,99,0,6038,4),(28670,97,5,6039,1),(28671,97,1,6039,1),(28672,97,0,6039,1),(28673,99,5,6039,4),(28674,99,0,6039,4),(28675,97,5,6040,1),(28676,97,1,6040,1),(28677,97,0,6040,1),(28678,99,5,6040,4),(28679,99,0,6040,4),(28680,97,5,6041,1),(28681,97,1,6041,1),(28682,97,0,6041,1),(28683,99,5,6041,4),(28684,99,0,6041,4),(28685,97,5,6042,1),(28686,97,1,6042,1),(28687,97,0,6042,1),(28688,99,5,6042,4),(28689,99,0,6042,4),(28690,97,5,6043,1),(28691,97,1,6043,1),(28692,97,0,6043,1),(28693,99,5,6043,4),(28694,99,0,6043,4),(28695,97,5,6044,1),(28696,97,1,6044,1),(28697,97,0,6044,1),(28698,99,5,6044,4),(28699,99,0,6044,4),(28700,97,5,6045,1),(28701,97,1,6045,1),(28702,97,0,6045,1),(28703,99,5,6045,4),(28704,99,0,6045,4),(28705,97,5,6046,1),(28706,97,1,6046,1),(28707,97,0,6046,1),(28708,99,5,6046,4),(28709,99,0,6046,4),(28710,97,5,6047,1),(28711,97,1,6047,1),(28712,97,0,6047,1),(28713,99,5,6047,4),(28714,99,0,6047,4),(28715,97,5,6048,1),(28716,97,1,6048,1),(28717,97,0,6048,1),(28718,99,5,6048,4),(28719,99,0,6048,4),(28720,97,5,6049,1),(28721,97,1,6049,1),(28722,97,0,6049,1),(28723,99,5,6049,4),(28724,99,0,6049,4),(28725,97,5,6050,1),(28726,97,1,6050,1),(28727,97,0,6050,1),(28728,99,5,6050,4),(28729,99,0,6050,4),(28730,97,5,6051,1),(28731,97,1,6051,1),(28732,97,0,6051,1),(28733,99,5,6051,4),(28734,99,0,6051,4),(28735,97,5,6052,1),(28736,97,1,6052,1),(28737,97,0,6052,1),(28738,99,5,6052,4),(28739,99,0,6052,4),(28740,97,5,6053,1),(28741,97,1,6053,1),(28742,97,0,6053,1),(28743,99,5,6053,4),(28744,99,0,6053,4),(28745,97,5,6054,1),(28746,97,1,6054,1),(28747,97,0,6054,1),(28748,99,5,6054,4),(28749,99,0,6054,4),(28750,97,5,6055,1),(28751,97,1,6055,1),(28752,97,0,6055,1),(28753,99,5,6055,4),(28754,99,0,6055,4),(28755,97,5,6056,1),(28756,97,1,6056,1),(28757,97,0,6056,1),(28758,99,5,6056,4),(28759,99,0,6056,4),(28760,97,5,6057,1),(28761,97,1,6057,1),(28762,97,0,6057,1),(28763,99,5,6057,4),(28764,99,0,6057,4),(28765,97,5,6058,1),(28766,97,1,6058,1),(28767,97,0,6058,1),(28768,99,5,6058,4),(28769,99,0,6058,4),(28770,97,5,6059,1),(28771,97,1,6059,1),(28772,97,0,6059,1),(28773,99,5,6059,4),(28774,99,0,6059,4),(28775,97,5,6060,1),(28776,97,1,6060,1),(28777,97,0,6060,1),(28778,99,5,6060,4),(28779,99,0,6060,4),(28780,97,5,6061,1),(28781,97,1,6061,1),(28782,97,0,6061,1),(28783,99,5,6061,4),(28784,99,0,6061,4),(28785,97,5,6062,1),(28786,97,1,6062,1),(28787,97,0,6062,1),(28788,99,5,6062,4),(28789,99,0,6062,4),(28790,97,5,6063,1),(28791,97,1,6063,1),(28792,97,0,6063,1),(28793,99,5,6063,4),(28794,99,0,6063,4),(28795,97,5,6064,1),(28796,97,1,6064,1),(28797,97,0,6064,1),(28798,99,5,6064,4),(28799,99,0,6064,4),(28800,97,5,6065,1),(28801,97,1,6065,1),(28802,97,0,6065,1),(28803,99,5,6065,4),(28804,99,0,6065,4),(28805,97,5,6066,1),(28806,97,1,6066,1),(28807,97,0,6066,1),(28808,99,5,6066,4),(28809,99,0,6066,4),(28810,97,5,6067,1),(28811,97,1,6067,1),(28812,97,0,6067,1),(28813,99,5,6067,4),(28814,99,0,6067,4),(28815,97,5,6068,1),(28816,97,1,6068,1),(28817,97,0,6068,1),(28818,99,5,6068,4),(28819,99,0,6068,4),(28820,97,5,6069,1),(28821,97,1,6069,1),(28822,97,0,6069,1),(28823,99,5,6069,4),(28824,99,0,6069,4),(28825,97,5,6070,1),(28826,97,1,6070,1),(28827,97,0,6070,1),(28828,99,5,6070,4),(28829,99,0,6070,4),(28830,97,5,6071,1),(28831,97,1,6071,1),(28832,97,0,6071,1),(28833,99,5,6071,4),(28834,99,0,6071,4),(28835,97,5,6072,1),(28836,97,1,6072,1),(28837,97,0,6072,1),(28838,99,5,6072,4),(28839,99,0,6072,4),(28840,97,5,6073,1),(28841,97,1,6073,1),(28842,97,0,6073,1),(28843,99,5,6073,4),(28844,99,0,6073,4),(28845,97,5,6074,1),(28846,97,1,6074,1),(28847,97,0,6074,1),(28848,99,5,6074,4),(28849,99,0,6074,4),(28850,97,5,6075,1),(28851,97,1,6075,1),(28852,97,0,6075,1),(28853,99,5,6075,4),(28854,99,0,6075,4),(28855,97,5,6076,1),(28856,97,1,6076,1),(28857,97,0,6076,1),(28858,99,5,6076,4),(28859,99,0,6076,4),(28860,97,5,6077,1),(28861,97,1,6077,1),(28862,97,0,6077,1),(28863,99,5,6077,4),(28864,99,0,6077,4),(28865,97,5,6078,1),(28866,97,1,6078,1),(28867,97,0,6078,1),(28868,99,5,6078,4),(28869,99,0,6078,4),(28870,97,5,6079,1),(28871,97,1,6079,1),(28872,97,0,6079,1),(28873,99,5,6079,4),(28874,99,0,6079,4),(28875,97,5,6080,1),(28876,97,1,6080,1),(28877,97,0,6080,1),(28878,99,5,6080,4),(28879,99,0,6080,4),(28880,97,5,6081,1),(28881,97,1,6081,1),(28882,97,0,6081,1),(28883,99,5,6081,4),(28884,99,0,6081,4),(28885,97,5,6082,1),(28886,97,1,6082,1),(28887,97,0,6082,1),(28888,99,5,6082,4),(28889,99,0,6082,4),(28890,97,5,6083,1),(28891,97,1,6083,1),(28892,97,0,6083,1),(28893,99,5,6083,4),(28894,99,0,6083,4),(28895,97,5,6084,1),(28896,97,1,6084,1),(28897,97,0,6084,1),(28898,99,5,6084,4),(28899,99,0,6084,4),(28900,97,5,6085,1),(28901,97,1,6085,1),(28902,97,0,6085,1),(28903,99,5,6085,4),(28904,99,0,6085,4),(28905,97,5,6086,1),(28906,97,1,6086,1),(28907,97,0,6086,1),(28908,99,5,6086,4),(28909,99,0,6086,4),(28910,97,5,6087,1),(28911,97,1,6087,1),(28912,97,0,6087,1),(28913,99,5,6087,4),(28914,99,0,6087,4),(28915,97,5,6088,1),(28916,97,1,6088,1),(28917,97,0,6088,1),(28918,99,5,6088,4),(28919,99,0,6088,4),(28920,97,5,6089,1),(28921,97,1,6089,1),(28922,97,0,6089,1),(28923,99,5,6089,4),(28924,99,0,6089,4),(28925,97,5,6090,1),(28926,97,1,6090,1),(28927,97,0,6090,1),(28928,99,5,6090,4),(28929,99,0,6090,4),(28930,97,5,6091,1),(28931,97,1,6091,1),(28932,97,0,6091,1),(28933,99,5,6091,4),(28934,99,0,6091,4),(28935,97,5,6092,1),(28936,97,1,6092,1),(28937,97,0,6092,1),(28938,99,5,6092,4),(28939,99,0,6092,4),(28940,97,5,6093,1),(28941,97,1,6093,1),(28942,97,0,6093,1),(28943,99,5,6093,4),(28944,99,0,6093,4),(28945,97,5,6094,1),(28946,97,1,6094,1),(28947,97,0,6094,1),(28948,99,5,6094,4),(28949,99,0,6094,4),(28950,97,5,6095,1),(28951,97,1,6095,1),(28952,97,0,6095,1),(28953,99,5,6095,4),(28954,99,0,6095,4),(28955,97,5,6096,1),(28956,97,1,6096,1),(28957,97,0,6096,1),(28958,99,5,6096,4),(28959,99,0,6096,4),(28960,97,5,6097,1),(28961,97,1,6097,1),(28962,97,0,6097,1),(28963,99,5,6097,4),(28964,99,0,6097,4),(28965,97,5,6098,1),(28966,97,1,6098,1),(28967,97,0,6098,1),(28968,99,5,6098,4),(28969,99,0,6098,4),(28970,97,5,6099,1),(28971,97,1,6099,1),(28972,97,0,6099,1),(28973,99,5,6099,4),(28974,99,0,6099,4),(28975,97,5,6100,1),(28976,97,1,6100,1),(28977,97,0,6100,1),(28978,99,5,6100,4),(28979,99,0,6100,4),(28980,97,5,6101,1),(28981,97,1,6101,1),(28982,97,0,6101,1),(28983,99,5,6101,4),(28984,99,0,6101,4),(28985,97,5,6102,1),(28986,97,1,6102,1),(28987,97,0,6102,1),(28988,99,5,6102,4),(28989,99,0,6102,4),(28990,97,5,6103,1),(28991,97,1,6103,1),(28992,97,0,6103,1),(28993,99,5,6103,4),(28994,99,0,6103,4),(28995,97,5,6104,1),(28996,97,1,6104,1),(28997,97,0,6104,1),(28998,99,5,6104,4),(28999,99,0,6104,4),(29000,97,5,6105,1),(29001,97,1,6105,1),(29002,97,0,6105,1),(29003,99,5,6105,4),(29004,99,0,6105,4),(29005,97,5,6106,1),(29006,97,1,6106,1),(29007,97,0,6106,1),(29008,99,5,6106,4),(29009,99,0,6106,4),(29010,97,5,6107,1),(29011,97,1,6107,1),(29012,97,0,6107,1),(29013,99,5,6107,4),(29014,99,0,6107,4),(29015,97,5,6108,1),(29016,97,1,6108,1),(29017,97,0,6108,1),(29018,99,5,6108,4),(29019,99,0,6108,4),(29020,97,5,6109,1),(29021,97,1,6109,1),(29022,97,0,6109,1),(29023,99,5,6109,4),(29024,99,0,6109,4),(29025,97,5,6110,1),(29026,97,1,6110,1),(29027,97,0,6110,1),(29028,99,5,6110,4),(29029,99,0,6110,4),(29030,97,5,6111,1),(29031,97,1,6111,1),(29032,97,0,6111,1),(29033,99,5,6111,4),(29034,99,0,6111,4),(29035,97,5,6112,1),(29036,97,1,6112,1),(29037,97,0,6112,1),(29038,99,5,6112,4),(29039,99,0,6112,4),(29040,97,5,6113,1),(29041,97,1,6113,1),(29042,97,0,6113,1),(29043,99,5,6113,4),(29044,99,0,6113,4),(29045,97,5,6114,1),(29046,97,1,6114,1),(29047,97,0,6114,1),(29048,99,5,6114,4),(29049,99,0,6114,4),(29050,97,5,6115,1),(29051,97,1,6115,1),(29052,97,0,6115,1),(29053,99,5,6115,4),(29054,99,0,6115,4),(29055,97,5,6116,1),(29056,97,1,6116,1),(29057,97,0,6116,1),(29058,99,5,6116,4),(29059,99,0,6116,4),(29060,97,5,6117,1),(29061,97,1,6117,1),(29062,97,0,6117,1),(29063,99,5,6117,4),(29064,99,0,6117,4),(29065,97,5,6118,1),(29066,97,1,6118,1),(29067,97,0,6118,1),(29068,99,5,6118,4),(29069,99,0,6118,4),(29070,97,5,6119,1),(29071,97,1,6119,1),(29072,97,0,6119,1),(29073,99,5,6119,4),(29074,99,0,6119,4),(29075,97,5,6120,1),(29076,97,1,6120,1),(29077,97,0,6120,1),(29078,99,5,6120,4),(29079,99,0,6120,4),(29080,97,5,6121,1),(29081,97,1,6121,1),(29082,97,0,6121,1),(29083,99,5,6121,4),(29084,99,0,6121,4),(29085,97,5,6122,1),(29086,97,1,6122,1),(29087,97,0,6122,1),(29088,99,5,6122,4),(29089,99,0,6122,4),(29090,97,5,6123,1),(29091,97,1,6123,1),(29092,97,0,6123,1),(29093,99,5,6123,4),(29094,99,0,6123,4),(29095,97,5,6124,1),(29096,97,1,6124,1),(29097,97,0,6124,1),(29098,99,5,6124,4),(29099,99,0,6124,4),(29100,97,5,6125,1),(29101,97,1,6125,1),(29102,97,0,6125,1),(29103,99,5,6125,4),(29104,99,0,6125,4),(29105,97,5,6126,1),(29106,97,1,6126,1),(29107,97,0,6126,1),(29108,99,5,6126,4),(29109,99,0,6126,4),(29110,97,5,6127,1),(29111,97,1,6127,1),(29112,97,0,6127,1),(29113,99,5,6127,4),(29114,99,0,6127,4),(29115,97,5,6128,1),(29116,97,1,6128,1),(29117,97,0,6128,1),(29118,99,5,6128,4),(29119,99,0,6128,4),(29120,97,5,6129,1),(29121,97,1,6129,1),(29122,97,0,6129,1),(29123,99,5,6129,4),(29124,99,0,6129,4),(29125,97,5,6130,1),(29126,97,1,6130,1),(29127,97,0,6130,1),(29128,99,5,6130,4),(29129,99,0,6130,4),(29130,97,5,6131,1),(29131,97,1,6131,1),(29132,97,0,6131,1),(29133,99,5,6131,4),(29134,99,0,6131,4),(29135,97,5,6132,1),(29136,97,1,6132,1),(29137,97,0,6132,1),(29138,99,5,6132,4),(29139,99,0,6132,4),(29140,97,5,6133,1),(29141,97,1,6133,1),(29142,97,0,6133,1),(29143,99,5,6133,4),(29144,99,0,6133,4),(29145,97,5,6134,1),(29146,97,1,6134,1),(29147,97,0,6134,1),(29148,99,5,6134,4),(29149,99,0,6134,4),(29150,97,5,6135,1),(29151,97,1,6135,1),(29152,97,0,6135,1),(29153,99,5,6135,4),(29154,99,0,6135,4),(29155,97,5,6136,1),(29156,97,1,6136,1),(29157,97,0,6136,1),(29158,99,5,6136,4),(29159,99,0,6136,4),(29160,97,5,6137,1),(29161,97,1,6137,1),(29162,97,0,6137,1),(29163,99,5,6137,4),(29164,99,0,6137,4),(29165,97,5,6138,1),(29166,97,1,6138,1),(29167,97,0,6138,1),(29168,99,5,6138,4),(29169,99,0,6138,4),(29170,97,5,6139,1),(29171,97,1,6139,1),(29172,97,0,6139,1),(29173,99,5,6139,4),(29174,99,0,6139,4),(29175,97,5,6140,1),(29176,97,1,6140,1),(29177,97,0,6140,1),(29178,99,5,6140,4),(29179,99,0,6140,4),(29180,97,5,6141,1),(29181,97,1,6141,1),(29182,97,0,6141,1),(29183,99,5,6141,4),(29184,99,0,6141,4),(29185,97,5,6142,1),(29186,97,1,6142,1),(29187,97,0,6142,1),(29188,99,5,6142,4),(29189,99,0,6142,4),(29190,97,5,6143,1),(29191,97,1,6143,1),(29192,97,0,6143,1),(29193,99,5,6143,4),(29194,99,0,6143,4),(29195,97,5,6144,1),(29196,97,1,6144,1),(29197,97,0,6144,1),(29198,99,5,6144,4),(29199,99,0,6144,4),(29200,97,5,6145,1),(29201,97,1,6145,1),(29202,97,0,6145,1),(29203,99,5,6145,4),(29204,99,0,6145,4),(29205,97,5,6146,1),(29206,97,1,6146,1),(29207,97,0,6146,1),(29208,99,5,6146,4),(29209,99,0,6146,4),(29210,97,5,6147,1),(29211,97,1,6147,1),(29212,97,0,6147,1),(29213,99,5,6147,4),(29214,99,0,6147,4),(29215,97,5,6148,1),(29216,97,1,6148,1),(29217,97,0,6148,1),(29218,99,5,6148,4),(29219,99,0,6148,4),(29220,97,5,6149,1),(29221,97,1,6149,1),(29222,97,0,6149,1),(29223,99,5,6149,4),(29224,99,0,6149,4),(29225,97,5,6150,1),(29226,97,1,6150,1),(29227,97,0,6150,1),(29228,99,5,6150,4),(29229,99,0,6150,4),(29230,97,5,6151,1),(29231,97,1,6151,1),(29232,97,0,6151,1),(29233,99,5,6151,4),(29234,99,0,6151,4),(29235,97,5,6152,1),(29236,97,1,6152,1),(29237,97,0,6152,1),(29238,99,5,6152,4),(29239,99,0,6152,4),(29240,97,5,6153,1),(29241,97,1,6153,1),(29242,97,0,6153,1),(29243,99,5,6153,4),(29244,99,0,6153,4),(29245,97,5,6154,1),(29246,97,1,6154,1),(29247,97,0,6154,1),(29248,99,5,6154,4),(29249,99,0,6154,4),(29250,97,5,6155,1),(29251,97,1,6155,1),(29252,97,0,6155,1),(29253,99,5,6155,4),(29254,99,0,6155,4),(29255,97,5,6156,1),(29256,97,1,6156,1),(29257,97,0,6156,1),(29258,99,5,6156,4),(29259,99,0,6156,4),(29260,97,5,6157,1),(29261,97,1,6157,1),(29262,97,0,6157,1),(29263,99,5,6157,4),(29264,99,0,6157,4),(29265,97,5,6158,1),(29266,97,1,6158,1),(29267,97,0,6158,1),(29268,99,5,6158,4),(29269,99,0,6158,4),(29270,97,5,6159,1),(29271,97,1,6159,1),(29272,97,0,6159,1),(29273,99,5,6159,4),(29274,99,0,6159,4),(29275,97,5,6160,1),(29276,97,1,6160,1),(29277,97,0,6160,1),(29278,99,5,6160,4),(29279,99,0,6160,4),(29280,97,5,6161,1),(29281,97,1,6161,1),(29282,97,0,6161,1),(29283,99,5,6161,4),(29284,99,0,6161,4),(29285,97,5,6162,1),(29286,97,1,6162,1),(29287,97,0,6162,1),(29288,99,5,6162,4),(29289,99,0,6162,4),(29290,97,5,6163,1),(29291,97,1,6163,1),(29292,97,0,6163,1),(29293,99,5,6163,4),(29294,99,0,6163,4),(29295,97,5,6164,1),(29296,97,1,6164,1),(29297,97,0,6164,1),(29298,99,5,6164,4),(29299,99,0,6164,4),(29300,97,5,6165,1),(29301,97,1,6165,1),(29302,97,0,6165,1),(29303,99,5,6165,4),(29304,99,0,6165,4),(29305,97,5,6166,1),(29306,97,1,6166,1),(29307,97,0,6166,1),(29308,99,5,6166,4),(29309,99,0,6166,4),(29310,97,5,6167,1),(29311,97,1,6167,1),(29312,97,0,6167,1),(29313,99,5,6167,4),(29314,99,0,6167,4),(29315,97,5,6168,1),(29316,97,1,6168,1),(29317,97,0,6168,1),(29318,99,5,6168,4),(29319,99,0,6168,4),(29320,97,5,6169,1),(29321,97,1,6169,1),(29322,97,0,6169,1),(29323,99,5,6169,4),(29324,99,0,6169,4),(29325,97,5,6170,1),(29326,97,1,6170,1),(29327,97,0,6170,1),(29328,99,5,6170,4),(29329,99,0,6170,4),(29330,97,5,6171,1),(29331,97,1,6171,1),(29332,97,0,6171,1),(29333,99,5,6171,4),(29334,99,0,6171,4),(29335,97,5,6172,1),(29336,97,1,6172,1),(29337,97,0,6172,1),(29338,99,5,6172,4),(29339,99,0,6172,4),(29340,97,5,6173,1),(29341,97,1,6173,1),(29342,97,0,6173,1),(29343,99,5,6173,4),(29344,99,0,6173,4),(29345,97,5,6174,1),(29346,97,1,6174,1),(29347,97,0,6174,1),(29348,99,5,6174,4),(29349,99,0,6174,4),(29350,97,5,6175,1),(29351,97,1,6175,1),(29352,97,0,6175,1),(29353,99,5,6175,4),(29354,99,0,6175,4),(29355,97,5,6176,1),(29356,97,1,6176,1),(29357,97,0,6176,1),(29358,99,5,6176,4),(29359,99,0,6176,4),(29360,97,5,6177,1),(29361,97,1,6177,1),(29362,97,0,6177,1),(29363,99,5,6177,4),(29364,99,0,6177,4),(29365,97,5,6178,1),(29366,97,1,6178,1),(29367,97,0,6178,1),(29368,99,5,6178,4),(29369,99,0,6178,4),(29370,97,5,6179,1),(29371,97,1,6179,1),(29372,97,0,6179,1),(29373,99,5,6179,4),(29374,99,0,6179,4),(29375,97,5,6180,1),(29376,97,1,6180,1),(29377,97,0,6180,1),(29378,99,5,6180,4),(29379,99,0,6180,4),(29380,97,5,6181,1),(29381,97,1,6181,1),(29382,97,0,6181,1),(29383,99,5,6181,4),(29384,99,0,6181,4),(29385,97,5,6182,1),(29386,97,1,6182,1),(29387,97,0,6182,1),(29388,99,5,6182,4),(29389,99,0,6182,4),(29390,97,5,6183,1),(29391,97,1,6183,1),(29392,97,0,6183,1),(29393,99,5,6183,4),(29394,99,0,6183,4),(29395,97,5,6184,1),(29396,97,1,6184,1),(29397,97,0,6184,1),(29398,99,5,6184,4),(29399,99,0,6184,4),(29400,97,5,6185,1),(29401,97,1,6185,1),(29402,97,0,6185,1),(29403,99,5,6185,4),(29404,99,0,6185,4),(29405,97,5,6186,1),(29406,97,1,6186,1),(29407,97,0,6186,1),(29408,99,5,6186,4),(29409,99,0,6186,4),(29410,97,5,6187,1),(29411,97,1,6187,1),(29412,97,0,6187,1),(29413,99,5,6187,4),(29414,99,0,6187,4),(29415,97,5,6188,1),(29416,97,1,6188,1),(29417,97,0,6188,1),(29418,99,5,6188,4),(29419,99,0,6188,4),(29420,97,5,6189,1),(29421,97,1,6189,1),(29422,97,0,6189,1),(29423,99,5,6189,4),(29424,99,0,6189,4),(29425,97,5,6190,1),(29426,97,1,6190,1),(29427,97,0,6190,1),(29428,99,5,6190,4),(29429,99,0,6190,4),(29430,97,5,6191,1),(29431,97,1,6191,1),(29432,97,0,6191,1),(29433,99,5,6191,4),(29434,99,0,6191,4),(29435,97,5,6192,1),(29436,97,1,6192,1),(29437,97,0,6192,1),(29438,99,5,6192,4),(29439,99,0,6192,4),(29440,97,5,6193,1),(29441,97,1,6193,1),(29442,97,0,6193,1),(29443,99,5,6193,4),(29444,99,0,6193,4),(29445,97,5,6194,1),(29446,97,1,6194,1),(29447,97,0,6194,1),(29448,99,5,6194,4),(29449,99,0,6194,4),(29450,97,5,6195,1),(29451,97,1,6195,1),(29452,97,0,6195,1),(29453,99,5,6195,4),(29454,99,0,6195,4),(29455,97,5,6196,1),(29456,97,1,6196,1),(29457,97,0,6196,1),(29458,99,5,6196,4),(29459,99,0,6196,4),(29460,97,5,6197,1),(29461,97,1,6197,1),(29462,97,0,6197,1),(29463,99,5,6197,4),(29464,99,0,6197,4),(29465,97,5,6198,1),(29466,97,1,6198,1),(29467,97,0,6198,1),(29468,99,5,6198,4),(29469,99,0,6198,4),(29470,97,5,6199,1),(29471,97,1,6199,1),(29472,97,0,6199,1),(29473,99,5,6199,4),(29474,99,0,6199,4),(29475,97,5,6200,1),(29476,97,1,6200,1),(29477,97,0,6200,1),(29478,99,5,6200,4),(29479,99,0,6200,4),(29480,97,5,6201,1),(29481,97,1,6201,1),(29482,97,0,6201,1),(29483,99,5,6201,4),(29484,99,0,6201,4),(29485,97,5,6202,1),(29486,97,1,6202,1),(29487,97,0,6202,1),(29488,99,5,6202,4),(29489,99,0,6202,4),(29490,97,5,6203,1),(29491,97,1,6203,1),(29492,97,0,6203,1),(29493,99,5,6203,4),(29494,99,0,6203,4),(29495,97,5,6204,1),(29496,97,1,6204,1),(29497,97,0,6204,1),(29498,99,5,6204,4),(29499,99,0,6204,4),(29500,97,5,6205,1),(29501,97,1,6205,1),(29502,97,0,6205,1),(29503,99,5,6205,4),(29504,99,0,6205,4),(29505,97,5,6206,1),(29506,97,1,6206,1),(29507,97,0,6206,1),(29508,99,5,6206,4),(29509,99,0,6206,4),(29510,97,5,6207,1),(29511,97,1,6207,1),(29512,97,0,6207,1),(29513,99,5,6207,4),(29514,99,0,6207,4),(29515,97,5,6208,1),(29516,97,1,6208,1),(29517,97,0,6208,1),(29518,99,5,6208,4),(29519,99,0,6208,4),(29520,97,5,6209,1),(29521,97,1,6209,1),(29522,97,0,6209,1),(29523,99,5,6209,4),(29524,99,0,6209,4),(29525,97,5,6210,1),(29526,97,1,6210,1),(29527,97,0,6210,1),(29528,99,5,6210,4),(29529,99,0,6210,4),(29530,97,5,6211,1),(29531,97,1,6211,1),(29532,97,0,6211,1),(29533,99,5,6211,4),(29534,99,0,6211,4),(29535,97,5,6212,1),(29536,97,1,6212,1),(29537,97,0,6212,1),(29538,99,5,6212,4),(29539,99,0,6212,4),(29540,97,5,6213,1),(29541,97,1,6213,1),(29542,97,0,6213,1),(29543,99,5,6213,4),(29544,99,0,6213,4),(29545,97,5,6214,1),(29546,97,1,6214,1),(29547,97,0,6214,1),(29548,99,5,6214,4),(29549,99,0,6214,4),(29550,97,5,6215,1),(29551,97,1,6215,1),(29552,97,0,6215,1),(29553,99,5,6215,4),(29554,99,0,6215,4),(29555,97,5,6216,1),(29556,97,1,6216,1),(29557,97,0,6216,1),(29558,99,5,6216,4),(29559,99,0,6216,4),(29560,97,5,6217,1),(29561,97,1,6217,1),(29562,97,0,6217,1),(29563,99,5,6217,4),(29564,99,0,6217,4),(29565,97,5,6218,1),(29566,97,1,6218,1),(29567,97,0,6218,1),(29568,99,5,6218,4),(29569,99,0,6218,4),(29570,97,5,6219,1),(29571,97,1,6219,1),(29572,97,0,6219,1),(29573,99,5,6219,2),(29574,99,0,6219,2),(29575,97,5,6220,1),(29576,97,1,6220,1),(29577,97,0,6220,1),(29578,99,5,6220,4),(29579,99,0,6220,4),(29580,97,5,6221,1),(29581,97,1,6221,1),(29582,97,0,6221,1),(29583,99,5,6221,4),(29584,99,0,6221,4),(29585,97,5,6222,1),(29586,97,1,6222,1),(29587,97,0,6222,1),(29588,99,5,6222,4),(29589,99,0,6222,4),(29590,97,5,6223,1),(29591,97,1,6223,1),(29592,97,0,6223,1),(29593,99,5,6223,4),(29594,99,0,6223,4),(29595,97,5,6224,1),(29596,97,1,6224,1),(29597,97,0,6224,1),(29598,99,5,6224,4),(29599,99,0,6224,4),(29600,97,5,6225,1),(29601,97,1,6225,1),(29602,97,0,6225,1),(29603,99,5,6225,4),(29604,99,0,6225,4),(29605,97,5,6226,1),(29606,97,1,6226,1),(29607,97,0,6226,1),(29608,99,5,6226,4),(29609,99,0,6226,4),(29610,97,5,6227,1),(29611,97,1,6227,1),(29612,97,0,6227,1),(29613,99,5,6227,4),(29614,99,0,6227,4),(29615,97,5,6228,1),(29616,97,1,6228,1),(29617,97,0,6228,1),(29618,99,5,6228,4),(29619,99,0,6228,4),(29620,97,5,6229,1),(29621,97,1,6229,1),(29622,97,0,6229,1),(29623,99,5,6229,4),(29624,99,0,6229,4),(29625,97,5,6230,1),(29626,97,1,6230,1),(29627,97,0,6230,1),(29628,99,5,6230,4),(29629,99,0,6230,4),(29630,97,5,6231,1),(29631,97,1,6231,1),(29632,97,0,6231,1),(29633,99,5,6231,4),(29634,99,0,6231,4),(29635,97,5,6232,1),(29636,97,1,6232,1),(29637,97,0,6232,1),(29638,99,5,6232,4),(29639,99,0,6232,4),(29640,97,5,6233,1),(29641,97,1,6233,1),(29642,97,0,6233,1),(29643,99,5,6233,4),(29644,99,0,6233,4),(29645,97,5,6234,1),(29646,97,1,6234,1),(29647,97,0,6234,1),(29648,99,5,6234,4),(29649,99,0,6234,4),(29650,97,5,6235,1),(29651,97,1,6235,1),(29652,97,0,6235,1),(29653,99,5,6235,4),(29654,99,0,6235,4),(29655,97,5,6236,1),(29656,97,1,6236,1),(29657,97,0,6236,1),(29658,99,5,6236,4),(29659,99,0,6236,4),(29660,97,5,6237,1),(29661,97,1,6237,1),(29662,97,0,6237,1),(29663,99,5,6237,4),(29664,99,0,6237,4),(29665,97,5,6238,1),(29666,97,1,6238,1),(29667,97,0,6238,1),(29668,99,5,6238,4),(29669,99,0,6238,4),(29670,97,5,6239,1),(29671,97,1,6239,1),(29672,97,0,6239,1),(29673,99,5,6239,4),(29674,99,0,6239,4),(29675,97,5,6240,1),(29676,97,1,6240,1),(29677,97,0,6240,1),(29678,99,5,6240,4),(29679,99,0,6240,4),(29680,97,5,6241,1),(29681,97,1,6241,1),(29682,97,0,6241,1),(29683,99,5,6241,4),(29684,99,0,6241,4),(29685,97,5,6242,1),(29686,97,1,6242,1),(29687,97,0,6242,1),(29688,99,5,6242,4),(29689,99,0,6242,4),(29690,97,5,6243,1),(29691,97,1,6243,1),(29692,97,0,6243,1),(29693,99,5,6243,4),(29694,99,0,6243,4),(29695,97,5,6244,1),(29696,97,1,6244,1),(29697,97,0,6244,1),(29698,99,5,6244,4),(29699,99,0,6244,4),(29700,97,5,6245,1),(29701,97,1,6245,1),(29702,97,0,6245,1),(29703,99,5,6245,4),(29704,99,0,6245,4),(29705,97,5,6246,1),(29706,97,1,6246,1),(29707,97,0,6246,1),(29708,99,5,6246,4),(29709,99,0,6246,4),(29710,97,5,6247,1),(29711,97,1,6247,1),(29712,97,0,6247,1),(29713,99,5,6247,4),(29714,99,0,6247,4),(29715,97,5,6248,1),(29716,97,1,6248,1),(29717,97,0,6248,1),(29718,99,5,6248,4),(29719,99,0,6248,4),(29720,97,5,6249,1),(29721,97,1,6249,1),(29722,97,0,6249,1),(29723,99,5,6249,4),(29724,99,0,6249,4),(29725,97,5,6250,1),(29726,97,1,6250,1),(29727,97,0,6250,1),(29728,99,5,6250,4),(29729,99,0,6250,4),(29730,97,5,6251,1),(29731,97,1,6251,1),(29732,97,0,6251,1),(29733,99,5,6251,4),(29734,99,0,6251,4),(29735,97,5,6252,1),(29736,97,1,6252,1),(29737,97,0,6252,1),(29738,99,5,6252,4),(29739,99,0,6252,4),(29740,97,5,6253,1),(29741,97,1,6253,1),(29742,97,0,6253,1),(29743,99,5,6253,4),(29744,99,0,6253,4),(29745,97,5,6254,1),(29746,97,1,6254,1),(29747,97,0,6254,1),(29748,99,5,6254,4),(29749,99,0,6254,4),(29750,97,5,6255,1),(29751,97,1,6255,1),(29752,97,0,6255,1),(29753,99,5,6255,4),(29754,99,0,6255,4),(29755,97,5,6256,1),(29756,97,1,6256,1),(29757,97,0,6256,1),(29758,99,5,6256,4),(29759,99,0,6256,4),(29760,97,5,6257,1),(29761,97,1,6257,1),(29762,97,0,6257,1),(29763,99,5,6257,2),(29764,99,0,6257,2),(29765,97,5,6258,1),(29766,97,1,6258,1),(29767,97,0,6258,1),(29768,99,5,6258,4),(29769,99,0,6258,4),(29770,97,5,6259,1),(29771,97,1,6259,1),(29772,97,0,6259,1),(29773,99,5,6259,4),(29774,99,0,6259,4),(29775,97,5,6260,1),(29776,97,1,6260,1),(29777,97,0,6260,1),(29778,99,5,6260,4),(29779,99,0,6260,4),(29780,97,5,6261,1),(29781,97,1,6261,1),(29782,97,0,6261,1),(29783,99,5,6261,4),(29784,99,0,6261,4),(29785,97,5,6262,1),(29786,97,1,6262,1),(29787,97,0,6262,1),(29788,99,5,6262,4),(29789,99,0,6262,4),(29790,97,5,6263,1),(29791,97,1,6263,1),(29792,97,0,6263,1),(29793,99,5,6263,4),(29794,99,0,6263,4),(29795,97,5,6264,1),(29796,97,1,6264,1),(29797,97,0,6264,1),(29798,99,5,6264,4),(29799,99,0,6264,4),(29800,97,5,6265,1),(29801,97,1,6265,1),(29802,97,0,6265,1),(29803,99,5,6265,4),(29804,99,0,6265,4),(29805,97,5,6266,1),(29806,97,1,6266,1),(29807,97,0,6266,1),(29808,99,5,6266,4),(29809,99,0,6266,4),(29810,97,5,6267,1),(29811,97,1,6267,1),(29812,97,0,6267,1),(29813,99,5,6267,4),(29814,99,0,6267,4),(29815,97,5,6268,1),(29816,97,1,6268,1),(29817,97,0,6268,1),(29818,99,5,6268,4),(29819,99,0,6268,4),(29820,97,5,6269,1),(29821,97,1,6269,1),(29822,97,0,6269,1),(29823,99,5,6269,4),(29824,99,0,6269,4),(29825,97,5,6270,1),(29826,97,1,6270,1),(29827,97,0,6270,1),(29828,99,5,6270,4),(29829,99,0,6270,4),(29830,97,5,6271,1),(29831,97,1,6271,1),(29832,97,0,6271,1),(29833,99,5,6271,4),(29834,99,0,6271,4),(29835,97,5,6272,1),(29836,97,1,6272,1),(29837,97,0,6272,1),(29838,99,5,6272,4),(29839,99,0,6272,4),(29840,97,5,6273,1),(29841,97,1,6273,1),(29842,97,0,6273,1),(29843,99,5,6273,4),(29844,99,0,6273,4),(29845,97,5,6274,1),(29846,97,1,6274,1),(29847,97,0,6274,1),(29848,99,5,6274,4),(29849,99,0,6274,4),(29850,97,5,6275,1),(29851,97,1,6275,1),(29852,97,0,6275,1),(29853,99,5,6275,4),(29854,99,0,6275,4),(29855,97,5,6276,1),(29856,97,1,6276,1),(29857,97,0,6276,1),(29858,99,5,6276,4),(29859,99,0,6276,4),(29860,97,5,6277,1),(29861,97,1,6277,1),(29862,97,0,6277,1),(29863,99,5,6277,4),(29864,99,0,6277,4),(29865,97,5,6278,1),(29866,97,1,6278,1),(29867,97,0,6278,1),(29868,99,5,6278,4),(29869,99,0,6278,4),(29870,97,5,6279,1),(29871,97,1,6279,1),(29872,97,0,6279,1),(29873,99,5,6279,4),(29874,99,0,6279,4),(29875,97,5,6280,1),(29876,97,1,6280,1),(29877,97,0,6280,1),(29878,99,5,6280,4),(29879,99,0,6280,4),(29880,97,5,6281,1),(29881,97,1,6281,1),(29882,97,0,6281,1),(29883,99,5,6281,4),(29884,99,0,6281,4),(29885,97,5,6282,1),(29886,97,1,6282,1),(29887,97,0,6282,1),(29888,99,5,6282,4),(29889,99,0,6282,4),(29890,97,5,6283,1),(29891,97,1,6283,1),(29892,97,0,6283,1),(29893,99,5,6283,4),(29894,99,0,6283,4),(29895,97,5,6284,1),(29896,97,1,6284,1),(29897,97,0,6284,1),(29898,99,5,6284,4),(29899,99,0,6284,4),(29900,97,5,6285,1),(29901,97,1,6285,1),(29902,97,0,6285,1),(29903,99,5,6285,4),(29904,99,0,6285,4),(29905,97,5,6286,1),(29906,97,1,6286,1),(29907,97,0,6286,1),(29908,99,5,6286,4),(29909,99,0,6286,4),(29910,97,5,6287,1),(29911,97,1,6287,1),(29912,97,0,6287,1),(29913,99,5,6287,4),(29914,99,0,6287,4),(29915,97,5,6288,1),(29916,97,1,6288,1),(29917,97,0,6288,1),(29918,99,5,6288,4),(29919,99,0,6288,4),(29920,97,5,6289,1),(29921,97,1,6289,1),(29922,97,0,6289,1),(29923,99,5,6289,4),(29924,99,0,6289,4),(29925,97,5,6290,1),(29926,97,1,6290,1),(29927,97,0,6290,1),(29928,99,5,6290,4),(29929,99,0,6290,4),(29930,97,5,6291,1),(29931,97,1,6291,1),(29932,97,0,6291,1),(29933,99,5,6291,4),(29934,99,0,6291,4),(29935,97,5,6292,1),(29936,97,1,6292,1),(29937,97,0,6292,1),(29938,99,5,6292,4),(29939,99,0,6292,4),(29940,97,5,6293,1),(29941,97,1,6293,1),(29942,97,0,6293,1),(29943,99,5,6293,4),(29944,99,0,6293,4),(29945,97,5,6294,1),(29946,97,1,6294,1),(29947,97,0,6294,1),(29948,99,5,6294,4),(29949,99,0,6294,4),(29950,97,5,6295,1),(29951,97,1,6295,1),(29952,97,0,6295,1),(29953,99,5,6295,4),(29954,99,0,6295,4),(29955,97,5,6296,1),(29956,97,1,6296,1),(29957,97,0,6296,1),(29958,99,5,6296,4),(29959,99,0,6296,4),(29960,97,5,6297,1),(29961,97,1,6297,1),(29962,97,0,6297,1),(29963,99,5,6297,4),(29964,99,0,6297,4),(29965,97,5,6298,1),(29966,97,1,6298,1),(29967,97,0,6298,1),(29968,99,5,6298,4),(29969,99,0,6298,4),(29970,97,5,6299,1),(29971,97,1,6299,1),(29972,97,0,6299,1),(29973,99,5,6299,4),(29974,99,0,6299,4),(29975,97,5,6300,1),(29976,97,1,6300,1),(29977,97,0,6300,1),(29978,99,5,6300,4),(29979,99,0,6300,4),(29980,97,5,6301,1),(29981,97,1,6301,1),(29982,97,0,6301,1),(29983,99,5,6301,4),(29984,99,0,6301,4),(29985,97,5,6302,1),(29986,97,1,6302,1),(29987,97,0,6302,1),(29988,99,5,6302,4),(29989,99,0,6302,4),(29990,97,5,6303,1),(29991,97,1,6303,1),(29992,97,0,6303,1),(29993,99,5,6303,4),(29994,99,0,6303,4),(29995,97,5,6304,1),(29996,97,1,6304,1),(29997,97,0,6304,1),(29998,99,5,6304,4),(29999,99,0,6304,4),(30000,97,5,6305,1),(30001,97,1,6305,1),(30002,97,0,6305,1),(30003,99,5,6305,4),(30004,99,0,6305,4),(30005,97,5,6306,1),(30006,97,1,6306,1),(30007,97,0,6306,1),(30008,99,5,6306,4),(30009,99,0,6306,4),(30010,97,5,6307,1),(30011,97,1,6307,1),(30012,97,0,6307,1),(30013,99,5,6307,4),(30014,99,0,6307,4),(30015,97,5,6308,1),(30016,97,1,6308,1),(30017,97,0,6308,1),(30018,99,5,6308,4),(30019,99,0,6308,4),(30020,97,5,6309,1),(30021,97,1,6309,1),(30022,97,0,6309,1),(30023,99,5,6309,4),(30024,99,0,6309,4),(30025,97,5,6310,1),(30026,97,1,6310,1),(30027,97,0,6310,1),(30028,99,5,6310,4),(30029,99,0,6310,4),(30030,97,5,6311,1),(30031,97,1,6311,1),(30032,97,0,6311,1),(30033,99,5,6311,4),(30034,99,0,6311,4),(30035,97,5,6312,1),(30036,97,1,6312,1),(30037,97,0,6312,1),(30038,99,5,6312,4),(30039,99,0,6312,4),(30040,97,5,6313,1),(30041,97,1,6313,1),(30042,97,0,6313,1),(30043,99,5,6313,4),(30044,99,0,6313,4),(30045,97,5,6314,1),(30046,97,1,6314,1),(30047,97,0,6314,1),(30048,99,5,6314,4),(30049,99,0,6314,4),(30050,97,5,6315,1),(30051,97,1,6315,1),(30052,97,0,6315,1),(30053,99,5,6315,4),(30054,99,0,6315,4),(30055,97,5,6316,1),(30056,97,1,6316,1),(30057,97,0,6316,1),(30058,99,5,6316,4),(30059,99,0,6316,4),(30060,97,5,6317,1),(30061,97,1,6317,1),(30062,97,0,6317,1),(30063,99,5,6317,4),(30064,99,0,6317,4),(30065,97,5,6318,1),(30066,97,1,6318,1),(30067,97,0,6318,1),(30068,99,5,6318,4),(30069,99,0,6318,4),(30070,97,5,6319,1),(30071,97,1,6319,1),(30072,97,0,6319,1),(30073,99,5,6319,4),(30074,99,0,6319,4),(30075,97,5,6320,1),(30076,97,1,6320,1),(30077,97,0,6320,1),(30078,99,5,6320,4),(30079,99,0,6320,4),(30080,97,5,6321,1),(30081,97,1,6321,1),(30082,97,0,6321,1),(30083,99,5,6321,4),(30084,99,0,6321,4),(30085,97,5,6322,1),(30086,97,1,6322,1),(30087,97,0,6322,1),(30088,99,5,6322,4),(30089,99,0,6322,4),(30090,97,5,6323,1),(30091,97,1,6323,1),(30092,97,0,6323,1),(30093,99,5,6323,4),(30094,99,0,6323,4),(30095,97,5,6324,1),(30096,97,1,6324,1),(30097,97,0,6324,1),(30098,99,5,6324,4),(30099,99,0,6324,4),(30100,97,5,6325,1),(30101,97,1,6325,1),(30102,97,0,6325,1),(30103,99,5,6325,4),(30104,99,0,6325,4),(30105,97,5,6326,1),(30106,97,1,6326,1),(30107,97,0,6326,1),(30108,99,5,6326,4),(30109,99,0,6326,4),(30110,97,5,6327,1),(30111,97,1,6327,1),(30112,97,0,6327,1),(30113,99,5,6327,4),(30114,99,0,6327,4),(30115,97,5,6328,1),(30116,97,1,6328,1),(30117,97,0,6328,1),(30118,99,5,6328,4),(30119,99,0,6328,4),(30120,97,5,6329,1),(30121,97,1,6329,1),(30122,97,0,6329,1),(30123,99,5,6329,4),(30124,99,0,6329,4),(30125,97,5,6330,1),(30126,97,1,6330,1),(30127,97,0,6330,1),(30128,99,5,6330,4),(30129,99,0,6330,4),(30130,97,5,6331,1),(30131,97,1,6331,1),(30132,97,0,6331,1),(30133,99,5,6331,4),(30134,99,0,6331,4),(30135,97,5,6332,1),(30136,97,1,6332,1),(30137,97,0,6332,1),(30138,99,5,6332,4),(30139,99,0,6332,4),(30140,97,5,6333,1),(30141,97,1,6333,1),(30142,97,0,6333,1),(30143,99,5,6333,4),(30144,99,0,6333,4),(30145,97,5,6334,1),(30146,97,1,6334,1),(30147,97,0,6334,1),(30148,99,5,6334,4),(30149,99,0,6334,4),(30150,97,5,6335,1),(30151,97,1,6335,1),(30152,97,0,6335,1),(30153,99,5,6335,4),(30154,99,0,6335,4),(30155,97,5,6336,1),(30156,97,1,6336,1),(30157,97,0,6336,1),(30158,99,5,6336,4),(30159,99,0,6336,4),(30160,97,5,6337,1),(30161,97,1,6337,1),(30162,97,0,6337,1),(30163,99,5,6337,4),(30164,99,0,6337,4),(30165,97,5,6338,1),(30166,97,1,6338,1),(30167,97,0,6338,1),(30168,99,5,6338,4),(30169,99,0,6338,4),(30170,97,5,6339,1),(30171,97,1,6339,1),(30172,97,0,6339,1),(30173,99,5,6339,4),(30174,99,0,6339,4),(30175,97,5,6340,1),(30176,97,1,6340,1),(30177,97,0,6340,1),(30178,99,5,6340,4),(30179,99,0,6340,4),(30180,97,5,6341,1),(30181,97,1,6341,1),(30182,97,0,6341,1),(30183,99,5,6341,4),(30184,99,0,6341,4),(30185,97,5,6342,1),(30186,97,1,6342,1),(30187,97,0,6342,1),(30188,99,5,6342,4),(30189,99,0,6342,4),(30190,97,5,6343,1),(30191,97,1,6343,1),(30192,97,0,6343,1),(30193,99,5,6343,4),(30194,99,0,6343,4),(30195,97,5,6344,1),(30196,97,1,6344,1),(30197,97,0,6344,1),(30198,99,5,6344,4),(30199,99,0,6344,4),(30200,97,5,6345,1),(30201,97,1,6345,1),(30202,97,0,6345,1),(30203,99,5,6345,4),(30204,99,0,6345,4),(30206,93,0,6035,NULL),(30208,141,5,6035,1),(30209,140,5,6035,1),(30210,142,0,6035,1),(30211,141,0,6035,1),(30212,161,0,6035,0),(30213,150,0,6035,0),(30214,140,0,6035,1),(30215,144,0,6035,1),(30216,136,0,6035,0),(30217,147,0,6035,0),(30218,143,0,6035,1),(30219,142,5,6036,1),(30220,141,5,6036,1),(30221,93,0,6036,NULL),(30222,140,5,6036,1),(30223,144,5,6036,1),(30224,147,5,6036,1),(30225,143,5,6036,1),(30226,142,0,6036,1),(30227,141,0,6036,1),(30228,161,0,6036,0),(30229,150,0,6036,0),(30230,140,0,6036,1),(30231,144,0,6036,1),(30232,136,0,6036,0),(30233,147,0,6036,1),(30234,143,0,6036,1),(30546,141,3,6035,0),(30547,144,3,6035,0),(30548,143,3,6035,0),(30549,97,5,6346,1),(30550,97,1,6346,1),(30551,97,0,6346,1),(30552,99,5,6346,4),(30553,99,0,6346,4),(30554,97,5,6347,1),(30555,97,1,6347,1),(30556,97,0,6347,1),(30557,99,5,6347,4),(30558,99,0,6347,4),(30559,97,5,6348,1),(30560,97,1,6348,1),(30561,97,0,6348,1),(30562,99,5,6348,4),(30563,99,0,6348,4),(30564,97,5,6349,1),(30565,97,1,6349,1),(30566,97,0,6349,1),(30567,99,5,6349,4),(30568,99,0,6349,4),(30569,97,5,6350,1),(30570,97,1,6350,1),(30571,97,0,6350,1),(30572,99,5,6350,4),(30573,99,0,6350,4),(30574,97,5,6351,1),(30575,97,1,6351,1),(30576,97,0,6351,1),(30577,99,5,6351,4),(30578,99,0,6351,4),(30579,97,5,6352,1),(30580,97,1,6352,1),(30581,97,0,6352,1),(30582,99,5,6352,4),(30583,99,0,6352,4),(30584,97,5,6353,1),(30585,97,1,6353,1),(30586,97,0,6353,1),(30587,99,5,6353,2),(30588,99,0,6353,2),(30589,97,5,6354,1),(30590,97,1,6354,1),(30591,97,0,6354,1),(30592,99,5,6354,4),(30593,99,0,6354,4),(30594,97,5,6355,1),(30595,97,1,6355,1),(30596,97,0,6355,1),(30597,99,5,6355,4),(30598,99,0,6355,4),(30599,97,5,6356,1),(30600,97,1,6356,1),(30601,97,0,6356,1),(30602,99,5,6356,4),(30603,99,0,6356,4),(30604,97,5,6357,1),(30605,97,1,6357,1),(30606,97,0,6357,1),(30607,99,5,6357,4),(30608,99,0,6357,4),(30609,97,5,6358,1),(30610,97,1,6358,1),(30611,97,0,6358,1),(30612,99,5,6358,4),(30613,99,0,6358,4),(30614,97,5,6359,1),(30615,97,1,6359,1),(30616,97,0,6359,1),(30617,99,5,6359,4),(30618,99,0,6359,4),(30619,97,5,6360,1),(30620,97,1,6360,1),(30621,97,0,6360,1),(30622,99,5,6360,4),(30623,99,0,6360,4),(30624,97,5,6361,1),(30625,97,1,6361,1),(30626,97,0,6361,1),(30627,99,5,6361,4),(30628,99,0,6361,4),(30629,97,5,6362,1),(30630,97,1,6362,1),(30631,97,0,6362,1),(30632,99,5,6362,4),(30633,99,0,6362,4),(30634,97,5,6363,1),(30635,97,1,6363,1),(30636,97,0,6363,1),(30637,99,5,6363,4),(30638,99,0,6363,4),(30639,97,5,6364,1),(30640,97,1,6364,1),(30641,97,0,6364,1),(30642,99,5,6364,4),(30643,99,0,6364,4),(30644,97,5,6365,1),(30645,97,1,6365,1),(30646,97,0,6365,1),(30647,99,5,6365,4),(30648,99,0,6365,4),(30649,97,5,6366,1),(30650,97,1,6366,1),(30651,97,0,6366,1),(30652,99,5,6366,4),(30653,99,0,6366,4),(30654,97,5,6367,1),(30655,97,1,6367,1),(30656,97,0,6367,1),(30657,99,5,6367,4),(30658,99,0,6367,4),(30659,97,5,6368,1),(30660,97,1,6368,1),(30661,97,0,6368,1),(30662,99,5,6368,4),(30663,99,0,6368,4),(30664,97,5,6369,1),(30665,97,1,6369,1),(30666,97,0,6369,1),(30667,99,5,6369,4),(30668,99,0,6369,4),(30669,97,5,6370,1),(30670,97,1,6370,1),(30671,97,0,6370,1),(30672,99,5,6370,4),(30673,99,0,6370,4),(30674,97,5,6371,1),(30675,97,1,6371,1),(30676,97,0,6371,1),(30677,99,5,6371,4),(30678,99,0,6371,4),(30679,97,5,6372,1),(30680,97,1,6372,1),(30681,97,0,6372,1),(30682,99,5,6372,4),(30683,99,0,6372,4),(30684,97,5,6373,1),(30685,97,1,6373,1),(30686,97,0,6373,1),(30687,99,5,6373,4),(30688,99,0,6373,4),(30689,97,5,6374,1),(30690,97,1,6374,1),(30691,97,0,6374,1),(30692,99,5,6374,4),(30693,99,0,6374,4),(30694,97,5,6375,1),(30695,97,1,6375,1),(30696,97,0,6375,1),(30697,99,5,6375,4),(30698,99,0,6375,4),(30699,97,5,6376,1),(30700,97,1,6376,1),(30701,97,0,6376,1),(30702,99,5,6376,4),(30703,99,0,6376,4),(30704,97,5,6377,1),(30705,97,1,6377,1),(30706,97,0,6377,1),(30707,99,5,6377,4),(30708,99,0,6377,4),(30709,97,5,6378,1),(30710,97,1,6378,1),(30711,97,0,6378,1),(30712,99,5,6378,4),(30713,99,0,6378,4),(30714,97,5,6379,1),(30715,97,1,6379,1),(30716,97,0,6379,1),(30717,99,5,6379,4),(30718,99,0,6379,4),(30719,97,5,6380,1),(30720,97,1,6380,1),(30721,97,0,6380,1),(30722,99,5,6380,4),(30723,99,0,6380,4),(30724,97,5,6381,1),(30725,97,1,6381,1),(30726,97,0,6381,1),(30727,99,5,6381,4),(30728,99,0,6381,4),(30729,97,5,6382,1),(30730,97,1,6382,1),(30731,97,0,6382,1),(30732,99,5,6382,4),(30733,99,0,6382,4),(30734,97,5,6383,1),(30735,97,1,6383,1),(30736,97,0,6383,1),(30737,99,5,6383,4),(30738,99,0,6383,4),(30739,97,5,6384,1),(30740,97,1,6384,1),(30741,97,0,6384,1),(30742,99,5,6384,4),(30743,99,0,6384,4),(30744,97,5,6385,1),(30745,97,1,6385,1),(30746,97,0,6385,1),(30747,99,5,6385,4),(30748,99,0,6385,4),(30749,97,5,6386,1),(30750,97,1,6386,1),(30751,97,0,6386,1),(30752,99,5,6386,4),(30753,99,0,6386,4),(30754,97,5,6387,1),(30755,97,1,6387,1),(30756,97,0,6387,1),(30757,99,5,6387,4),(30758,99,0,6387,4),(30759,97,5,6388,1),(30760,97,1,6388,1),(30761,97,0,6388,1),(30762,99,5,6388,4),(30763,99,0,6388,4),(30764,97,5,6389,1),(30765,97,1,6389,1),(30766,97,0,6389,1),(30767,99,5,6389,4),(30768,99,0,6389,4),(30769,97,5,6390,1),(30770,97,1,6390,1),(30771,97,0,6390,1),(30772,99,5,6390,4),(30773,99,0,6390,4),(30774,97,5,6391,1),(30775,97,1,6391,1),(30776,97,0,6391,1),(30777,99,5,6391,4),(30778,99,0,6391,4),(30779,97,5,6392,1),(30780,97,1,6392,1),(30781,97,0,6392,1),(30782,99,5,6392,4),(30783,99,0,6392,4),(30784,97,5,6393,1),(30785,97,1,6393,1),(30786,97,0,6393,1),(30787,99,5,6393,4),(30788,99,0,6393,4),(30789,97,5,6394,1),(30790,97,1,6394,1),(30791,97,0,6394,1),(30792,99,5,6394,4),(30793,99,0,6394,4),(30794,97,5,6395,1),(30795,97,1,6395,1),(30796,97,0,6395,1),(30797,99,5,6395,4),(30798,99,0,6395,4),(30799,97,5,6396,1),(30800,97,1,6396,1),(30801,97,0,6396,1),(30802,99,5,6396,4),(30803,99,0,6396,4),(30804,97,5,6397,1),(30805,97,1,6397,1),(30806,97,0,6397,1),(30807,99,5,6397,4),(30808,99,0,6397,4),(30809,97,5,6398,1),(30810,97,1,6398,1),(30811,97,0,6398,1),(30812,99,5,6398,4),(30813,99,0,6398,4),(30814,97,5,6399,1),(30815,97,1,6399,1),(30816,97,0,6399,1),(30817,99,5,6399,4),(30818,99,0,6399,4),(30819,97,5,6400,1),(30820,97,1,6400,1),(30821,97,0,6400,1),(30822,99,5,6400,4),(30823,99,0,6400,4),(30824,97,5,6401,1),(30825,97,1,6401,1),(30826,97,0,6401,1),(30827,99,5,6401,4),(30828,99,0,6401,4),(30829,97,5,6402,1),(30830,97,1,6402,1),(30831,97,0,6402,1),(30832,99,5,6402,4),(30833,99,0,6402,4),(30834,97,5,6403,1),(30835,97,1,6403,1),(30836,97,0,6403,1),(30837,99,5,6403,4),(30838,99,0,6403,4),(30839,97,5,6404,1),(30840,97,1,6404,1),(30841,97,0,6404,1),(30842,99,5,6404,4),(30843,99,0,6404,4),(30844,97,5,6405,1),(30845,97,1,6405,1),(30846,97,0,6405,1),(30847,99,5,6405,4),(30848,99,0,6405,4),(30849,97,5,6406,1),(30850,97,1,6406,1),(30851,97,0,6406,1),(30852,99,5,6406,4),(30853,99,0,6406,4),(30854,97,5,6407,1),(30855,97,1,6407,1),(30856,97,0,6407,1),(30857,99,5,6407,4),(30858,99,0,6407,4),(30859,97,5,6408,1),(30860,97,1,6408,1),(30861,97,0,6408,1),(30862,99,5,6408,4),(30863,99,0,6408,4),(30864,97,5,6409,1),(30865,97,1,6409,1),(30866,97,0,6409,1),(30867,99,5,6409,4),(30868,99,0,6409,4),(30869,97,5,6410,1),(30870,97,1,6410,1),(30871,97,0,6410,1),(30872,99,5,6410,4),(30873,99,0,6410,4),(30874,97,5,6411,1),(30875,97,1,6411,1),(30876,97,0,6411,1),(30877,99,5,6411,4),(30878,99,0,6411,4),(30879,97,5,6412,1),(30880,97,1,6412,1),(30881,97,0,6412,1),(30882,99,5,6412,4),(30883,99,0,6412,4),(30884,97,5,6413,1),(30885,97,1,6413,1),(30886,97,0,6413,1),(30887,99,5,6413,4),(30888,99,0,6413,4),(30889,97,5,6414,1),(30890,97,1,6414,1),(30891,97,0,6414,1),(30892,99,5,6414,4),(30893,99,0,6414,4),(30894,97,5,6415,1),(30895,97,1,6415,1),(30896,97,0,6415,1),(30897,99,5,6415,4),(30898,99,0,6415,4),(30899,97,5,6416,1),(30900,97,1,6416,1),(30901,97,0,6416,1),(30902,99,5,6416,4),(30903,99,0,6416,4),(30904,97,5,6417,1),(30905,97,1,6417,1),(30906,97,0,6417,1),(30907,99,5,6417,4),(30908,99,0,6417,4),(30909,97,5,6418,1),(30910,97,1,6418,1),(30911,97,0,6418,1),(30912,99,5,6418,4),(30913,99,0,6418,4),(30914,97,5,6419,1),(30915,97,1,6419,1),(30916,97,0,6419,1),(30917,99,5,6419,4),(30918,99,0,6419,4),(30919,97,5,6420,1),(30920,97,1,6420,1),(30921,97,0,6420,1),(30922,99,5,6420,4),(30923,99,0,6420,4),(30924,97,5,6421,1),(30925,97,1,6421,1),(30926,97,0,6421,1),(30927,99,5,6421,4),(30928,99,0,6421,4),(30929,97,5,6422,1),(30930,97,1,6422,1),(30931,97,0,6422,1),(30932,99,5,6422,4),(30933,99,0,6422,4),(30934,97,5,6423,1),(30935,97,1,6423,1),(30936,97,0,6423,1),(30937,99,5,6423,4),(30938,99,0,6423,4),(30939,97,5,6424,1),(30940,97,1,6424,1),(30941,97,0,6424,1),(30942,99,5,6424,4),(30943,99,0,6424,4),(30944,97,5,6425,1),(30945,97,1,6425,1),(30946,97,0,6425,1),(30947,99,5,6425,4),(30948,99,0,6425,4),(30949,97,5,6426,1),(30950,97,1,6426,1),(30951,97,0,6426,1),(30952,99,5,6426,4),(30953,99,0,6426,4),(30954,97,5,6427,1),(30955,97,1,6427,1),(30956,97,0,6427,1),(30957,99,5,6427,4),(30958,99,0,6427,4),(30959,97,5,6428,1),(30960,97,1,6428,1),(30961,97,0,6428,1),(30962,99,5,6428,4),(30963,99,0,6428,4),(30964,97,5,6429,1),(30965,97,1,6429,1),(30966,97,0,6429,1),(30967,99,5,6429,4),(30968,99,0,6429,4),(30969,97,5,6430,1),(30970,97,1,6430,1),(30971,97,0,6430,1),(30972,99,5,6430,4),(30973,99,0,6430,4),(30974,97,5,6431,1),(30975,97,1,6431,1),(30976,97,0,6431,1),(30977,99,5,6431,4),(30978,99,0,6431,4),(30979,97,5,6432,1),(30980,97,1,6432,1),(30981,97,0,6432,1),(30982,99,5,6432,4),(30983,99,0,6432,4),(30984,97,5,6433,1),(30985,97,1,6433,1),(30986,97,0,6433,1),(30987,99,5,6433,4),(30988,99,0,6433,4),(30989,97,5,6434,1),(30990,97,1,6434,1),(30991,97,0,6434,1),(30992,99,5,6434,4),(30993,99,0,6434,4),(30994,97,5,6435,1),(30995,97,1,6435,1),(30996,97,0,6435,1),(30997,99,5,6435,4),(30998,99,0,6435,4),(30999,97,5,6436,1),(31000,97,1,6436,1),(31001,97,0,6436,1),(31002,99,5,6436,4),(31003,99,0,6436,4),(31004,97,5,6437,1),(31005,97,1,6437,1),(31006,97,0,6437,1),(31007,99,5,6437,4),(31008,99,0,6437,4),(31009,97,5,6438,1),(31010,97,1,6438,1),(31011,97,0,6438,1),(31012,99,5,6438,4),(31013,99,0,6438,4),(31014,97,5,6439,1),(31015,97,1,6439,1),(31016,97,0,6439,1),(31017,99,5,6439,4),(31018,99,0,6439,4),(31019,97,5,6440,1),(31020,97,1,6440,1),(31021,97,0,6440,1),(31022,99,5,6440,4),(31023,99,0,6440,4),(31024,97,5,6441,1),(31025,97,1,6441,1),(31026,97,0,6441,1),(31027,99,5,6441,4),(31028,99,0,6441,4),(31029,97,5,6442,1),(31030,97,1,6442,1),(31031,97,0,6442,1),(31032,99,5,6442,4),(31033,99,0,6442,4),(31034,97,5,6443,1),(31035,97,1,6443,1),(31036,97,0,6443,1),(31037,99,5,6443,4),(31038,99,0,6443,4),(31039,97,5,6444,1),(31040,97,1,6444,1),(31041,97,0,6444,1),(31042,99,5,6444,4),(31043,99,0,6444,4),(31044,97,5,6445,1),(31045,97,1,6445,1),(31046,97,0,6445,1),(31047,99,5,6445,4),(31048,99,0,6445,4),(31082,97,5,6446,1),(31083,97,1,6446,1),(31084,97,0,6446,1),(31085,99,5,6446,4),(31086,99,0,6446,4),(31087,97,5,6447,1),(31088,97,1,6447,1),(31089,97,0,6447,1),(31090,99,5,6447,4),(31091,99,0,6447,4),(31092,97,5,6448,1),(31093,97,1,6448,1),(31094,97,0,6448,1),(31095,99,5,6448,4),(31096,99,0,6448,4),(31097,97,5,6449,1),(31098,97,1,6449,1),(31099,97,0,6449,1),(31100,99,5,6449,4),(31101,99,0,6449,4),(31102,97,5,6450,1),(31103,97,1,6450,1),(31104,97,0,6450,1),(31105,99,5,6450,4),(31106,99,0,6450,4),(31107,97,5,6451,1),(31108,97,1,6451,1),(31109,97,0,6451,1),(31110,99,5,6451,4),(31111,99,0,6451,4),(31112,97,5,6452,1),(31113,97,1,6452,1),(31114,97,0,6452,1),(31115,99,5,6452,4),(31116,99,0,6452,4),(31117,97,5,6453,1),(31118,97,1,6453,1),(31119,97,0,6453,1),(31120,99,5,6453,4),(31121,99,0,6453,4),(31122,97,5,6454,1),(31123,97,1,6454,1),(31124,97,0,6454,1),(31125,99,5,6454,4),(31126,99,0,6454,4),(31127,97,5,6455,1),(31128,97,1,6455,1),(31129,97,0,6455,1),(31130,99,5,6455,4),(31131,99,0,6455,4),(31132,97,5,6456,1),(31133,97,1,6456,1),(31134,97,0,6456,1),(31135,99,5,6456,4),(31136,99,0,6456,4),(31137,97,5,6457,1),(31138,97,1,6457,1),(31139,97,0,6457,1),(31140,99,5,6457,4),(31141,99,0,6457,4),(31142,97,5,6458,1),(31143,97,1,6458,1),(31144,97,0,6458,1),(31145,99,5,6458,4),(31146,99,0,6458,4),(31147,97,5,6459,1),(31148,97,1,6459,1),(31149,97,0,6459,1),(31150,99,5,6459,4),(31151,99,0,6459,4),(31152,97,5,6460,1),(31153,97,1,6460,1),(31154,97,0,6460,1),(31155,99,5,6460,4),(31156,99,0,6460,4),(31157,97,5,6461,1),(31158,97,1,6461,1),(31159,97,0,6461,1),(31160,99,5,6461,4),(31161,99,0,6461,4),(31162,97,5,6462,1),(31163,97,1,6462,1),(31164,97,0,6462,1),(31165,99,5,6462,4),(31166,99,0,6462,4),(31167,97,5,6463,1),(31168,97,1,6463,1),(31169,97,0,6463,1),(31170,99,5,6463,4),(31171,99,0,6463,4),(31172,97,5,6464,1),(31173,97,1,6464,1),(31174,97,0,6464,1),(31175,99,5,6464,4),(31176,99,0,6464,4),(31177,97,5,6465,1),(31178,97,1,6465,1),(31179,97,0,6465,1),(31180,99,5,6465,4),(31181,99,0,6465,4),(31182,97,5,6466,1),(31183,97,1,6466,1),(31184,97,0,6466,1),(31185,99,5,6466,4),(31186,99,0,6466,4),(31187,97,5,6467,1),(31188,97,1,6467,1),(31189,97,0,6467,1),(31190,99,5,6467,4),(31191,99,0,6467,4),(31192,97,5,6468,1),(31193,97,1,6468,1),(31194,97,0,6468,1),(31195,99,5,6468,4),(31196,99,0,6468,4),(31197,97,5,6469,1),(31198,97,1,6469,1),(31199,97,0,6469,1),(31200,99,5,6469,4),(31201,99,0,6469,4),(31202,97,5,6470,1),(31203,97,1,6470,1),(31204,97,0,6470,1),(31205,99,5,6470,4),(31206,99,0,6470,4),(31207,97,5,6471,1),(31208,97,1,6471,1),(31209,97,0,6471,1),(31210,99,5,6471,4),(31211,99,0,6471,4),(31212,97,5,6472,1),(31213,97,1,6472,1),(31214,97,0,6472,1),(31215,99,5,6472,4),(31216,99,0,6472,4),(31217,97,5,6473,1),(31218,97,1,6473,1),(31219,97,0,6473,1),(31220,99,5,6473,4),(31221,99,0,6473,4),(31222,97,5,6474,1),(31223,97,1,6474,1),(31224,97,0,6474,1),(31225,99,5,6474,4),(31226,99,0,6474,4),(31227,97,5,6475,1),(31228,97,1,6475,1),(31229,97,0,6475,1),(31230,99,5,6475,4),(31231,99,0,6475,4),(31232,97,5,6476,1),(31233,97,1,6476,1),(31234,97,0,6476,1),(31235,99,5,6476,4),(31236,99,0,6476,4),(31237,97,5,6477,1),(31238,97,1,6477,1),(31239,97,0,6477,1),(31240,99,5,6477,4),(31241,99,0,6477,4),(31242,97,5,6478,1),(31243,97,1,6478,1),(31244,97,0,6478,1),(31245,99,5,6478,4),(31246,99,0,6478,4),(31247,97,5,6479,1),(31248,97,1,6479,1),(31249,97,0,6479,1),(31250,99,5,6479,4),(31251,99,0,6479,4),(31252,97,5,6480,1),(31253,97,1,6480,1),(31254,97,0,6480,1),(31255,99,5,6480,4),(31256,99,0,6480,4),(31257,97,5,6481,1),(31258,97,1,6481,1),(31259,97,0,6481,1),(31260,99,5,6481,4),(31261,99,0,6481,4),(31262,97,5,6482,1),(31263,97,1,6482,1),(31264,97,0,6482,1),(31265,99,5,6482,4),(31266,99,0,6482,4),(31267,97,5,6483,1),(31268,97,1,6483,1),(31269,97,0,6483,1),(31270,99,5,6483,4),(31271,99,0,6483,4),(31272,97,5,6484,1),(31273,97,1,6484,1),(31274,97,0,6484,1),(31275,99,5,6484,4),(31276,99,0,6484,4),(31277,97,5,6485,1),(31278,97,1,6485,1),(31279,97,0,6485,1),(31280,99,5,6485,4),(31281,99,0,6485,4),(31282,97,5,6486,1),(31283,97,1,6486,1),(31284,97,0,6486,1),(31285,99,5,6486,4),(31286,99,0,6486,4),(31287,97,5,6487,1),(31288,97,1,6487,1),(31289,97,0,6487,1),(31290,99,5,6487,4),(31291,99,0,6487,4),(31292,97,5,6488,1),(31293,97,1,6488,1),(31294,97,0,6488,1),(31295,99,5,6488,4),(31296,99,0,6488,4),(31297,97,5,6489,1),(31298,97,1,6489,1),(31299,97,0,6489,1),(31300,99,5,6489,4),(31301,99,0,6489,4),(31302,97,5,6490,1),(31303,97,1,6490,1),(31304,97,0,6490,1),(31305,99,5,6490,4),(31306,99,0,6490,4),(31307,97,5,6491,1),(31308,97,1,6491,1),(31309,97,0,6491,1),(31310,99,5,6491,4),(31311,99,0,6491,4),(31312,97,5,6492,1),(31313,97,1,6492,1),(31314,97,0,6492,1),(31315,99,5,6492,4),(31316,99,0,6492,4),(31317,97,5,6493,1),(31318,97,1,6493,1),(31319,97,0,6493,1),(31320,99,5,6493,4),(31321,99,0,6493,4),(31322,97,5,6494,1),(31323,97,1,6494,1),(31324,97,0,6494,1),(31325,99,5,6494,4),(31326,99,0,6494,4),(31327,97,5,6495,1),(31328,97,1,6495,1),(31329,97,0,6495,1),(31330,99,5,6495,4),(31331,99,0,6495,4),(31332,97,5,6496,1),(31333,97,1,6496,1),(31334,97,0,6496,1),(31335,99,5,6496,4),(31336,99,0,6496,4),(31337,97,5,6497,1),(31338,97,1,6497,1),(31339,97,0,6497,1),(31340,99,5,6497,4),(31341,99,0,6497,4),(31342,97,5,6498,1),(31343,97,1,6498,1),(31344,97,0,6498,1),(31345,99,5,6498,4),(31346,99,0,6498,4),(31347,97,5,6499,1),(31348,97,1,6499,1),(31349,97,0,6499,1),(31350,99,5,6499,4),(31351,99,0,6499,4),(31352,97,5,6500,1),(31353,97,1,6500,1),(31354,97,0,6500,1),(31355,99,5,6500,4),(31356,99,0,6500,4),(31357,97,5,6501,1),(31358,97,1,6501,1),(31359,97,0,6501,1),(31360,99,5,6501,4),(31361,99,0,6501,4),(31362,97,5,6502,1),(31363,97,1,6502,1),(31364,97,0,6502,1),(31365,99,5,6502,4),(31366,99,0,6502,4),(31367,97,5,6503,1),(31368,97,1,6503,1),(31369,97,0,6503,1),(31370,99,5,6503,4),(31371,99,0,6503,4),(31372,97,5,6504,1),(31373,97,1,6504,1),(31374,97,0,6504,1),(31375,99,5,6504,4),(31376,99,0,6504,4),(31377,97,5,6505,1),(31378,97,1,6505,1),(31379,97,0,6505,1),(31380,99,5,6505,4),(31381,99,0,6505,4),(31382,97,5,6506,1),(31383,97,1,6506,1),(31384,97,0,6506,1),(31385,99,5,6506,4),(31386,99,0,6506,4),(31387,97,5,6507,1),(31388,97,1,6507,1),(31389,97,0,6507,1),(31390,99,5,6507,4),(31391,99,0,6507,4),(31392,97,5,6508,1),(31393,97,1,6508,1),(31394,97,0,6508,1),(31395,99,5,6508,4),(31396,99,0,6508,4),(31397,97,5,6509,1),(31398,97,1,6509,1),(31399,97,0,6509,1),(31400,99,5,6509,4),(31401,99,0,6509,4),(31402,97,5,6510,1),(31403,97,1,6510,1),(31404,97,0,6510,1),(31405,99,5,6510,4),(31406,99,0,6510,4),(31407,97,5,6511,1),(31408,97,1,6511,1),(31409,97,0,6511,1),(31410,99,5,6511,4),(31411,99,0,6511,4),(31412,97,5,6512,1),(31413,97,1,6512,1),(31414,97,0,6512,1),(31415,99,5,6512,4),(31416,99,0,6512,4),(31417,97,5,6513,1),(31418,97,1,6513,1),(31419,97,0,6513,1),(31420,99,5,6513,4),(31421,99,0,6513,4),(31422,97,5,6514,1),(31423,97,1,6514,1),(31424,97,0,6514,1),(31425,99,5,6514,4),(31426,99,0,6514,4),(31427,97,5,6515,1),(31428,97,1,6515,1),(31429,97,0,6515,1),(31430,99,5,6515,4),(31431,99,0,6515,4),(31432,97,5,6516,1),(31433,97,1,6516,1),(31434,97,0,6516,1),(31435,99,5,6516,4),(31436,99,0,6516,4),(31437,97,5,6517,1),(31438,97,1,6517,1),(31439,97,0,6517,1),(31440,99,5,6517,4),(31441,99,0,6517,4),(31442,97,5,6518,1),(31443,97,1,6518,1),(31444,97,0,6518,1),(31445,99,5,6518,4),(31446,99,0,6518,4),(31447,97,5,6519,1),(31448,97,1,6519,1),(31449,97,0,6519,1),(31450,99,5,6519,4),(31451,99,0,6519,4),(31452,97,5,6520,1),(31453,97,1,6520,1),(31454,97,0,6520,1),(31455,99,5,6520,4),(31456,99,0,6520,4),(31457,97,5,6521,1),(31458,97,1,6521,1),(31459,97,0,6521,1),(31460,99,5,6521,4),(31461,99,0,6521,4),(31462,97,5,6522,1),(31463,97,1,6522,1),(31464,97,0,6522,1),(31465,99,5,6522,4),(31466,99,0,6522,4),(31467,97,5,6523,1),(31468,97,1,6523,1),(31469,97,0,6523,1),(31470,99,5,6523,4),(31471,99,0,6523,4),(31472,97,5,6524,1),(31473,97,1,6524,1),(31474,97,0,6524,1),(31475,99,5,6524,4),(31476,99,0,6524,4),(31477,97,5,6525,1),(31478,97,1,6525,1),(31479,97,0,6525,1),(31480,99,5,6525,4),(31481,99,0,6525,4),(31482,97,5,6526,1),(31483,97,1,6526,1),(31484,97,0,6526,1),(31485,99,5,6526,4),(31486,99,0,6526,4),(31487,97,5,6527,1),(31488,97,1,6527,1),(31489,97,0,6527,1),(31490,99,5,6527,4),(31491,99,0,6527,4),(31492,97,5,6528,1),(31493,97,1,6528,1),(31494,97,0,6528,1),(31495,99,5,6528,4),(31496,99,0,6528,4),(31497,97,5,6529,1),(31498,97,1,6529,1),(31499,97,0,6529,1),(31500,99,5,6529,4),(31501,99,0,6529,4),(31502,97,5,6530,1),(31503,97,1,6530,1),(31504,97,0,6530,1),(31505,99,5,6530,4),(31506,99,0,6530,4),(31507,97,5,6531,1),(31508,97,1,6531,1),(31509,97,0,6531,1),(31510,99,5,6531,4),(31511,99,0,6531,4),(31512,97,5,6532,1),(31513,97,1,6532,1),(31514,97,0,6532,1),(31515,99,5,6532,4),(31516,99,0,6532,4),(31517,97,5,6533,1),(31518,97,1,6533,1),(31519,97,0,6533,1),(31520,99,5,6533,4),(31521,99,0,6533,4),(31522,97,5,6534,1),(31523,97,1,6534,1),(31524,97,0,6534,1),(31525,99,5,6534,4),(31526,99,0,6534,4),(31527,97,5,6535,1),(31528,97,1,6535,1),(31529,97,0,6535,1),(31530,99,5,6535,4),(31531,99,0,6535,4),(31532,97,5,6536,1),(31533,97,1,6536,1),(31534,97,0,6536,1),(31535,99,5,6536,4),(31536,99,0,6536,4),(31537,97,5,6537,1),(31538,97,1,6537,1),(31539,97,0,6537,1),(31540,99,5,6537,4),(31541,99,0,6537,4),(31542,97,5,6538,1),(31543,97,1,6538,1),(31544,97,0,6538,1),(31545,99,5,6538,4),(31546,99,0,6538,4),(31547,97,5,6539,1),(31548,97,1,6539,1),(31549,97,0,6539,1),(31550,99,5,6539,4),(31551,99,0,6539,4),(31552,97,5,6540,1),(31553,97,1,6540,1),(31554,97,0,6540,1),(31555,99,5,6540,4),(31556,99,0,6540,4),(31557,97,5,6541,1),(31558,97,1,6541,1),(31559,97,0,6541,1),(31560,99,5,6541,4),(31561,99,0,6541,4),(31562,97,5,6542,1),(31563,97,1,6542,1),(31564,97,0,6542,1),(31565,99,5,6542,4),(31566,99,0,6542,4),(31567,97,5,6543,1),(31568,97,1,6543,1),(31569,97,0,6543,1),(31570,99,5,6543,4),(31571,99,0,6543,4),(31572,97,5,6544,1),(31573,97,1,6544,1),(31574,97,0,6544,1),(31575,99,5,6544,4),(31576,99,0,6544,4),(31577,97,5,6545,1),(31578,97,1,6545,1),(31579,97,0,6545,1),(31580,99,5,6545,4),(31581,99,0,6545,4),(31582,97,5,6546,1),(31583,97,1,6546,1),(31584,97,0,6546,1),(31585,99,5,6546,4),(31586,99,0,6546,4),(31587,97,5,6547,1),(31588,97,1,6547,1),(31589,97,0,6547,1),(31590,99,5,6547,2),(31591,99,0,6547,2),(31592,97,5,6548,1),(31593,97,1,6548,1),(31594,97,0,6548,1),(31595,99,5,6548,2),(31596,99,0,6548,2),(31597,97,5,6549,1),(31598,97,1,6549,1),(31599,97,0,6549,1),(31600,99,5,6549,2),(31601,99,0,6549,2),(31602,97,5,6550,1),(31603,97,1,6550,1),(31604,97,0,6550,1),(31605,99,5,6550,4),(31606,99,0,6550,4),(31607,97,5,6551,1),(31608,97,1,6551,1),(31609,97,0,6551,1),(31610,99,5,6551,2),(31611,99,0,6551,2),(31612,97,5,6552,1),(31613,97,1,6552,1),(31614,97,0,6552,1),(31615,99,5,6552,2),(31616,99,0,6552,2),(31617,97,5,6553,1),(31618,97,1,6553,1),(31619,97,0,6553,1),(31620,99,5,6553,2),(31621,99,0,6553,2),(31622,97,5,6554,1),(31623,97,1,6554,1),(31624,97,0,6554,1),(31625,99,5,6554,2),(31626,99,0,6554,2),(31627,97,5,6555,1),(31628,97,1,6555,1),(31629,97,0,6555,1),(31630,99,5,6555,2),(31631,99,0,6555,2),(31632,97,5,6556,1),(31633,97,1,6556,1),(31634,97,0,6556,1),(31635,99,5,6556,2),(31636,99,0,6556,2),(31637,97,5,6557,1),(31638,97,1,6557,1),(31639,97,0,6557,1),(31640,99,5,6557,4),(31641,99,0,6557,4),(31642,97,5,6558,1),(31643,97,1,6558,1),(31644,97,0,6558,1),(31645,99,5,6558,4),(31646,99,0,6558,4),(31647,97,5,6559,1),(31648,97,1,6559,1),(31649,97,0,6559,1),(31650,99,5,6559,2),(31651,99,0,6559,2),(31652,97,5,6560,1),(31653,97,1,6560,1),(31654,97,0,6560,1),(31655,99,5,6560,2),(31656,99,0,6560,2),(31657,97,5,6561,1),(31658,97,1,6561,1),(31659,97,0,6561,1),(31660,99,5,6561,2),(31661,99,0,6561,2),(31662,97,5,6562,1),(31663,97,1,6562,1),(31664,97,0,6562,1),(31665,99,5,6562,4),(31666,99,0,6562,4),(31667,97,5,6563,1),(31668,97,1,6563,1),(31669,97,0,6563,1),(31670,99,5,6563,4),(31671,99,0,6563,4),(31672,97,5,6564,1),(31673,97,1,6564,1),(31674,97,0,6564,1),(31675,99,5,6564,4),(31676,99,0,6564,4),(31677,97,5,6565,1),(31678,97,1,6565,1),(31679,97,0,6565,1),(31680,99,5,6565,4),(31681,99,0,6565,4),(31682,97,5,6566,1),(31683,97,1,6566,1),(31684,97,0,6566,1),(31685,99,5,6566,4),(31686,99,0,6566,4),(31687,97,5,6567,1),(31688,97,1,6567,1),(31689,97,0,6567,1),(31690,99,5,6567,4),(31691,99,0,6567,4),(31692,97,5,6568,1),(31693,97,1,6568,1),(31694,97,0,6568,1),(31695,99,5,6568,4),(31696,99,0,6568,4),(31697,97,5,6569,1),(31698,97,1,6569,1),(31699,97,0,6569,1),(31700,99,5,6569,4),(31701,99,0,6569,4),(31702,97,5,6570,1),(31703,97,1,6570,1),(31704,97,0,6570,1),(31705,99,5,6570,4),(31706,99,0,6570,4),(31707,97,5,6571,1),(31708,97,1,6571,1),(31709,97,0,6571,1),(31710,99,5,6571,4),(31711,99,0,6571,4),(31712,97,5,6572,1),(31713,97,1,6572,1),(31714,97,0,6572,1),(31715,99,5,6572,4),(31716,99,0,6572,4);
/*!40000 ALTER TABLE `catalog_product_entity_int` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_int_after_insert` AFTER INSERT ON `catalog_product_entity_int` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`entity_id`);
INSERT IGNORE INTO `catalog_product_category_cl` (`entity_id`) VALUES (NEW.`entity_id`);
INSERT IGNORE INTO `catalog_product_attribute_cl` (`entity_id`) VALUES (NEW.`entity_id`);
INSERT IGNORE INTO `cataloginventory_stock_cl` (`entity_id`) VALUES (NEW.`entity_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`entity_id`);
INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (NEW.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_int_after_update` AFTER UPDATE ON `catalog_product_entity_int` FOR EACH ROW BEGIN
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalog_product_category_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalog_product_attribute_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `cataloginventory_stock_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_int_after_delete` AFTER DELETE ON `catalog_product_entity_int` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (OLD.`entity_id`);
INSERT IGNORE INTO `catalog_product_category_cl` (`entity_id`) VALUES (OLD.`entity_id`);
INSERT IGNORE INTO `catalog_product_attribute_cl` (`entity_id`) VALUES (OLD.`entity_id`);
INSERT IGNORE INTO `cataloginventory_stock_cl` (`entity_id`) VALUES (OLD.`entity_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (OLD.`entity_id`);
INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (OLD.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `catalog_product_entity_media_gallery`
--

DROP TABLE IF EXISTS `catalog_product_entity_media_gallery`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_entity_media_gallery` (
  `value_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value',
  `media_type` varchar(32) NOT NULL DEFAULT 'image' COMMENT 'Media entry type',
  `disabled` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Visibility status',
  PRIMARY KEY (`value_id`),
  KEY `CATALOG_PRODUCT_ENTITY_MEDIA_GALLERY_ATTRIBUTE_ID` (`attribute_id`),
  CONSTRAINT `CAT_PRD_ENTT_MDA_GLR_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=34 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Media Gallery Attribute Backend Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_entity_media_gallery`
--

LOCK TABLES `catalog_product_entity_media_gallery` WRITE;
/*!40000 ALTER TABLE `catalog_product_entity_media_gallery` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_entity_media_gallery` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_entity_media_gallery_value`
--

DROP TABLE IF EXISTS `catalog_product_entity_media_gallery_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_entity_media_gallery_value` (
  `value_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Value ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `label` varchar(255) DEFAULT NULL COMMENT 'Label',
  `position` int unsigned DEFAULT NULL COMMENT 'Position',
  `disabled` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Disabled',
  `record_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Record ID',
  PRIMARY KEY (`record_id`),
  KEY `CATALOG_PRODUCT_ENTITY_MEDIA_GALLERY_VALUE_STORE_ID` (`store_id`),
  KEY `CATALOG_PRODUCT_ENTITY_MEDIA_GALLERY_VALUE_ENTITY_ID` (`entity_id`),
  KEY `CATALOG_PRODUCT_ENTITY_MEDIA_GALLERY_VALUE_VALUE_ID` (`value_id`),
  KEY `CAT_PRD_ENTT_MDA_GLR_VAL_ENTT_ID_VAL_ID_STORE_ID` (`entity_id`,`value_id`,`store_id`),
  CONSTRAINT `CAT_PRD_ENTT_MDA_GLR_VAL_ENTT_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_ENTT_MDA_GLR_VAL_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_ENTT_MDA_GLR_VAL_VAL_ID_CAT_PRD_ENTT_MDA_GLR_VAL_ID` FOREIGN KEY (`value_id`) REFERENCES `catalog_product_entity_media_gallery` (`value_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=149 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Media Gallery Attribute Value Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_entity_media_gallery_value`
--

LOCK TABLES `catalog_product_entity_media_gallery_value` WRITE;
/*!40000 ALTER TABLE `catalog_product_entity_media_gallery_value` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_entity_media_gallery_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_entity_media_gallery_value_to_entity`
--

DROP TABLE IF EXISTS `catalog_product_entity_media_gallery_value_to_entity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_entity_media_gallery_value_to_entity` (
  `value_id` int unsigned NOT NULL COMMENT 'Value media Entry ID',
  `entity_id` int unsigned NOT NULL COMMENT 'Product Entity ID',
  PRIMARY KEY (`value_id`,`entity_id`),
  KEY `CAT_PRD_ENTT_MDA_GLR_VAL_TO_ENTT_ENTT_ID_CAT_PRD_ENTT_ENTT_ID` (`entity_id`),
  CONSTRAINT `CAT_PRD_ENTT_MDA_GLR_VAL_TO_ENTT_ENTT_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_A6C6C8FAA386736921D3A7C4B50B1185` FOREIGN KEY (`value_id`) REFERENCES `catalog_product_entity_media_gallery` (`value_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Link Media value to Product entity table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_entity_media_gallery_value_to_entity`
--

LOCK TABLES `catalog_product_entity_media_gallery_value_to_entity` WRITE;
/*!40000 ALTER TABLE `catalog_product_entity_media_gallery_value_to_entity` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_entity_media_gallery_value_to_entity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_entity_media_gallery_value_video`
--

DROP TABLE IF EXISTS `catalog_product_entity_media_gallery_value_video`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_entity_media_gallery_value_video` (
  `value_id` int unsigned NOT NULL COMMENT 'Media Entity ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `provider` varchar(32) DEFAULT NULL COMMENT 'Video provider ID',
  `url` text COMMENT 'Video URL',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title',
  `description` text COMMENT 'Page Meta Description',
  `metadata` text COMMENT 'Video meta data',
  PRIMARY KEY (`value_id`,`store_id`),
  KEY `CAT_PRD_ENTT_MDA_GLR_VAL_VIDEO_STORE_ID_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `CAT_PRD_ENTT_MDA_GLR_VAL_VIDEO_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_6FDF205946906B0E653E60AA769899F8` FOREIGN KEY (`value_id`) REFERENCES `catalog_product_entity_media_gallery` (`value_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Video Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_entity_media_gallery_value_video`
--

LOCK TABLES `catalog_product_entity_media_gallery_value_video` WRITE;
/*!40000 ALTER TABLE `catalog_product_entity_media_gallery_value_video` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_entity_media_gallery_value_video` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_entity_text`
--

DROP TABLE IF EXISTS `catalog_product_entity_text`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_entity_text` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` mediumtext COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CATALOG_PRODUCT_ENTITY_TEXT_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `CATALOG_PRODUCT_ENTITY_TEXT_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_PRODUCT_ENTITY_TEXT_STORE_ID` (`store_id`),
  CONSTRAINT `CAT_PRD_ENTT_TEXT_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_ENTT_TEXT_ENTT_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_PRODUCT_ENTITY_TEXT_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=18155 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Text Attribute Backend Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_entity_text`
--

LOCK TABLES `catalog_product_entity_text` WRITE;
/*!40000 ALTER TABLE `catalog_product_entity_text` DISABLE KEYS */;
INSERT INTO `catalog_product_entity_text` VALUES (14234,85,0,5760,'test-product'),(14235,156,0,5760,'0'),(15249,85,5,6035,'Franke Mythos MYX 110-34 Undermount Single Bowl Sink -Stainless Steel'),(15250,85,0,6035,'Franke Mythos MYX 110-34 Undermount Single Bowl Sink -Stainless Steel'),(15251,75,5,6035,'<style>#html-body [data-pb-style=IYB5ARY]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"IYB5ARY\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 110-34 Undermount Single Bowl Sink -Stainless Steel</strong></span></p>\r\n<p>The Franke Mythos MYX 110-34 Undermount Single Bowl Sink -Stainless Steel is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 450mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Round flush cover plate</li>\r\n</ul></div></div></div>'),(15252,75,0,6035,'<style>#html-body [data-pb-style=J2C758Q]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"J2C758Q\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 110-34 Undermount Single Bowl Sink -Stainless Steel</strong></span></p>\r\n<p>The Franke Mythos MYX 110-34 Undermount Single Bowl Sink -Stainless Steel is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 450mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Round flush cover plate</li>\r\n</ul></div></div></div>'),(15254,85,5,6036,'Franke Mythos MYX 110-45 Undermount Single Bowl Sink -Stainless Steel'),(15255,85,0,6036,'Franke Mythos MYX 110-45 Undermount Single Bowl Sink -Stainless Steel'),(15256,75,5,6036,'<style>#html-body [data-pb-style=THSK7OW]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"THSK7OW\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 110-45 Undermount Single Bowl Sink -Stainless Steel</strong></span></p>\r\n<p>The Franke Mythos MYX 110-45 Undermount Single Bowl Sink -Stainless Steel is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 550mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Round flush cover plate</li>\r\n</ul></div></div></div>'),(15257,75,0,6036,'<style>#html-body [data-pb-style=THSK7OW]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"THSK7OW\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 110-45 Undermount Single Bowl Sink -Stainless Steel</strong></span></p>\r\n<p>The Franke Mythos MYX 110-45 Undermount Single Bowl Sink -Stainless Steel is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 550mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Round flush cover plate</li>\r\n</ul></div></div></div>'),(15258,155,0,6036,'Exclude'),(15259,85,5,6037,'Franke Mythos MYX 110-55 1.0 Bowl Undermount Sink, Franke Undermount Sink, Franke Mythos, Franke Mythos MYX 110-55, Franke 1.0 Bowl Sink, Franke Undermount Kitchen Sink'),(15260,85,0,6037,'Franke Mythos MYX 110-55 1.0 Bowl Undermount Sink, Franke Undermount Sink, Franke Mythos, Franke Mythos MYX 110-55, Franke 1.0 Bowl Sink, Franke Undermount Kitchen Sink'),(15261,75,5,6037,'<style>#html-body [data-pb-style=IKMACTW]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"IKMACTW\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 110-55 Undermount Single Bowl Sink -Stainless Steel</strong></span></p>\r\n<p id=\"TK7HR4H\">The Franke Mythos MYX 110-55 Undermount Single Bowl Sink -Stainless Steel &nbsp;is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts. The Franke Mythos sinks range is one of complete cleanness. The sensitive design of the Maris range is matchless and will therefore give any kitchen a newer, stunning look. A complete new range of Franke Mythos MYX 110-55 single Bowls, available in Undermount models.&nbsp;</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 800mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Round flush cover plate</li>\r\n</ul></div></div></div>'),(15262,75,0,6037,'<style>#html-body [data-pb-style=IKMACTW]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"IKMACTW\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 110-55 Undermount Single Bowl Sink -Stainless Steel</strong></span></p>\r\n<p id=\"TK7HR4H\">The Franke Mythos MYX 110-55 Undermount Single Bowl Sink -Stainless Steel &nbsp;is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts. The Franke Mythos sinks range is one of complete cleanness. The sensitive design of the Maris range is matchless and will therefore give any kitchen a newer, stunning look. A complete new range of Franke Mythos MYX 110-55 single Bowls, available in Undermount models.&nbsp;</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 800mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Round flush cover plate</li>\r\n</ul></div></div></div>'),(15263,155,0,6037,'Exclude'),(15264,85,5,6038,'Franke Mythos MYX 110-70 Undermount Single Bowl Sink -Stainless Steel'),(15265,85,0,6038,'Franke Mythos MYX 110-70 Undermount Single Bowl Sink -Stainless Steel'),(15266,75,5,6038,'<style>#html-body [data-pb-style=ED2HR4G]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"ED2HR4G\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 110-70 Kitchen Sink -Stainless Steel</strong></span></p>\r\n<p>The Franke Mythos MYX 110-70 Undermount Single Bowl Sink -Stainless Steel is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Round flush cover plate</li>\r\n</ul></div></div></div>'),(15267,75,0,6038,'<style>#html-body [data-pb-style=ED2HR4G]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"ED2HR4G\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 110-70 Kitchen Sink -Stainless Steel</strong></span></p>\r\n<p>The Franke Mythos MYX 110-70 Undermount Single Bowl Sink -Stainless Steel is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Round flush cover plate</li>\r\n</ul></div></div></div>'),(15268,155,0,6038,'Exclude'),(15269,85,5,6039,'Franke Mythos MYX 120 34-34 Undermount Double Bowl Sink -Stainless Steel'),(15270,85,0,6039,'Franke Mythos MYX 120 34-34 Undermount Double Bowl Sink -Stainless Steel'),(15271,75,5,6039,'<style>#html-body [data-pb-style=CFMAYHP]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"CFMAYHP\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 120 34-34 Undermount Double Bowl Sink -Stainless Steel</strong></span></p>\r\n<p>The Franke Mythos MYX 120 34-34 Undermount Double Bowl Sink -Stainless Steel is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double bowls sink</li>\r\n<li>Cabinet size: 900mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Round flush cover plates&gt;/li&gt;</li>\r\n</ul></div></div></div>'),(15272,75,0,6039,'<style>#html-body [data-pb-style=CFMAYHP]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"CFMAYHP\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 120 34-34 Undermount Double Bowl Sink -Stainless Steel</strong></span></p>\r\n<p>The Franke Mythos MYX 120 34-34 Undermount Double Bowl Sink -Stainless Steel is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double bowls sink</li>\r\n<li>Cabinet size: 900mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Round flush cover plates&gt;/li&gt;</li>\r\n</ul></div></div></div>'),(15273,155,0,6039,'Exclude'),(15274,85,5,6040,'Franke Arcana AHK 651 Ceramic Inset 1.5 Bowl Sink'),(15275,85,0,6040,'Franke Arcana AHK 651 Ceramic Inset 1.5 Bowl Sink'),(15276,75,5,6040,'<p><span style=\"font-size: medium;\"><strong>Franke Arcana AHK 651 Ceramic Inset 1.5 Bowl Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>       \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Position of Drainer: Reversible</li>\r\n<li>Colour: White</li>\r\n<li>Sink: Ceramic</li>\r\n</ul>\r\n'),(15277,75,0,6040,'<p><span style=\"font-size: medium;\"><strong>Franke Arcana AHK 651 Ceramic Inset 1.5 Bowl Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>       \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Position of Drainer: Reversible</li>\r\n<li>Colour: White</li>\r\n<li>Sink: Ceramic</li>\r\n</ul>\r\n'),(15278,155,0,6040,'Exclude'),(15279,85,5,6041,'BL 450 748 Sink, Blanco Metra XL Silgranit  Sink, Stainless Steel Sink, Blanco Best Sink ,Blanco BL 450 748 Sink'),(15280,85,0,6041,'BL 450 748 Sink, Blanco Metra XL Silgranit  Sink, Stainless Steel Sink, Blanco Best Sink ,Blanco BL 450 748 Sink'),(15281,75,5,6041,'<p><span style=\"font-size: medium;\"><strong>Blanco Supra 160-U Undermount Stainless Steel Kitchen Sink - 450748</strong></span></p>\r\n<p> Blanco Supra 160-U belongs to the Supra <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> range by Blanco. This undermount sink is perfectly manufactured, and you can also use it as a side bowl for your main kitchen sink. This sink can be fixed into a bar area if you have one, or someplace in the kitchen where you think it can be useful to you as a small sink. Blanco Supra 160-U being an undermount sink comes with a 3 &frac12;&rdquo; basket strainer waste and overflow. It also includes a Topper waste cover and fixing kit 212 330. This stainless steel sink has 30cm cabinet width; the bowl depth is 130mm and has 60mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 130mm</li>\r\n<li>Cabinet width: 300mm</li>\r\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Timelessly elegant, contoured bowl design</li>\n<li>Undermount bowl for discerning demands on design</li>\n<li>High-quality features with covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\r\n<li>Overflow and waste</li>\r\n<li>Fixing kit included</li>\r\n\r</ul>\r\n'),(15282,75,0,6041,'<p><span style=\"font-size: medium;\"><strong>Blanco Supra 160-U Undermount Stainless Steel Kitchen Sink - 450748</strong></span></p>\r\n<p> Blanco Supra 160-U belongs to the Supra <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> range by Blanco. This undermount sink is perfectly manufactured, and you can also use it as a side bowl for your main kitchen sink. This sink can be fixed into a bar area if you have one, or someplace in the kitchen where you think it can be useful to you as a small sink. Blanco Supra 160-U being an undermount sink comes with a 3 &frac12;&rdquo; basket strainer waste and overflow. It also includes a Topper waste cover and fixing kit 212 330. This stainless steel sink has 30cm cabinet width; the bowl depth is 130mm and has 60mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 130mm</li>\r\n<li>Cabinet width: 300mm</li>\r\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Timelessly elegant, contoured bowl design</li>\n<li>Undermount bowl for discerning demands on design</li>\n<li>High-quality features with covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\r\n<li>Overflow and waste</li>\r\n<li>Fixing kit included</li>\r\n\r</ul>\r\n'),(15283,155,0,6041,'Exclude'),(15284,85,5,6042,'Blanco  Sink,buy Blanco BL 450 762 Sink , Blanco Sink, Blanco  classic Sink,Blanco Stylish  Sink'),(15285,85,0,6042,'Blanco  Sink,buy Blanco BL 450 762 Sink , Blanco Sink, Blanco  classic Sink,Blanco Stylish  Sink'),(15286,75,5,6042,'<p><span style=\"font-size: medium;\"><strong>Blanco Supra 340-U Undermount Stainless Steel Kitchen Sink - 450762</strong></span></p>\r\n<p> Blanco Supra 340-U comes under the Supra range of stainless steel sinks by Blanco. Blanco Supra kitchen sinks offer different sizes of undermount sinks from small to large. Blanco Supra 340-U is a medium sized <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sink</span></a>. Like the small sinks of Supra range, it can also be used as a side bowl with the main kitchen sink i.e. large sized sinks of the same range. Blanco Supra 340-U as an undermount sink comes with a 3 &frac12;&rdquo; basket strainer waste and overflow. It also includes a Topper waste cover and fixing kit 212 330. This stainless steel sink has 45cm cabinet width; the bowl depth is 175mm and has 60mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Bowl depth: 175mm</li>\r\n<li>Cabinet width: 400mm</li>\r\n<li>Material: Stainless steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\r\n<li>Overflow and waste</li>\r\n<li>Fixing kit included</li>\r\n</ul>\r\n\r\n\r\n'),(15287,75,0,6042,'<p><span style=\"font-size: medium;\"><strong>Blanco Supra 340-U Undermount Stainless Steel Kitchen Sink - 450762</strong></span></p>\r\n<p> Blanco Supra 340-U comes under the Supra range of stainless steel sinks by Blanco. Blanco Supra kitchen sinks offer different sizes of undermount sinks from small to large. Blanco Supra 340-U is a medium sized <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sink</span></a>. Like the small sinks of Supra range, it can also be used as a side bowl with the main kitchen sink i.e. large sized sinks of the same range. Blanco Supra 340-U as an undermount sink comes with a 3 &frac12;&rdquo; basket strainer waste and overflow. It also includes a Topper waste cover and fixing kit 212 330. This stainless steel sink has 45cm cabinet width; the bowl depth is 175mm and has 60mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Bowl depth: 175mm</li>\r\n<li>Cabinet width: 400mm</li>\r\n<li>Material: Stainless steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\r\n<li>Overflow and waste</li>\r\n<li>Fixing kit included</li>\r\n</ul>\r\n\r\n\r\n'),(15288,155,0,6042,'Exclude'),(15289,85,5,6043,'Blanco Livit 45 S Salto Stainless Steel Inset Sink, Blanco Livit 45s Salto Sink, Blanco Livit 45s Sink, Blanco stainless Sink'),(15290,85,0,6043,'Blanco Livit 45 S Salto Stainless Steel Inset Sink, Blanco Livit 45s Salto Sink, Blanco Livit 45s Sink, Blanco stainless Sink'),(15291,75,5,6043,'<style>#html-body [data-pb-style=A738C4M]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"A738C4M\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Livit 45 S Salto Stainless Steel Inset Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Bowl depth: 170mm</li>\n<li>Cabinet width: 450mm</li>\n<li>Handing options: Reversible</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Spacious drainer with linear runners</li>\n<li>Optimum functionality and maximum bowl capacity</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting</li>\n<li>3 1/2\" basket strainer</li>\n</ul>\n\n</div></div></div>'),(15292,75,0,6043,'<style>#html-body [data-pb-style=A738C4M]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"A738C4M\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Livit 45 S Salto Stainless Steel Inset Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Bowl depth: 170mm</li>\n<li>Cabinet width: 450mm</li>\n<li>Handing options: Reversible</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Spacious drainer with linear runners</li>\n<li>Optimum functionality and maximum bowl capacity</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting</li>\n<li>3 1/2\" basket strainer</li>\n</ul>\n\n</div></div></div>'),(15293,155,0,6043,'Exclude'),(15294,85,5,6044,'Livit XL 5 S S/ST Sink,buy Blanco Sink , Blanco Livit XL 5 S S/ST Sink, Cheap Livit XL 5 S S/ST  Sink'),(15295,85,0,6044,'Livit XL 5 S S/ST Sink,buy Blanco Sink , Blanco Livit XL 5 S S/ST Sink, Cheap Livit XL 5 S S/ST  Sink'),(15296,75,5,6044,'<p><span style=\"font-size: medium;\"><strong>Blanco Livit XL 5 S Inset Stainless Steel Kitchen Sink -450836</strong></span></p>\n<p>Blanco is an eminent name in assembling the surpassing stainless steel kitchen sinks for more than 90 years. It has now engineered the Blanco Livit XL 5 S having an outstanding design. This stainless steel kitchen sink has a fine and firm design, with reversible installation with either left-handed or right-handed drainer. Blanco Livit XL 5 with its optimal design is a perfect choice for large kitchen areas, providing maximum work space. This stainless steel kitchen sink has an excellent and unyielding design, with reversible installation with either left-handed or right-handed bowl. This inset kitchen sink provides a fine adjusting space between its bowl and drainer. It also two pre-drilled tap ledge holes to fix a compatible kitchen mixer tap providing ease of left or right hand drainer installation. Blanco Livit XL 5 as an inset sink comes with a 3 &frac12;&rdquo; basket strainer and a stainless steel insert. This stainless steel sink needs a 50cm cabinet width for its fitting while the depth of the bowl is 165mm.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Bowl depth: 160mm</li>\n<li>Cabinet width: 500mm</li>\n<li>Handing options: Reversible</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Spacious drainer with linear runners</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n\n</ul>\n\n'),(15297,75,0,6044,'<p><span style=\"font-size: medium;\"><strong>Blanco Livit XL 5 S Inset Stainless Steel Kitchen Sink -450836</strong></span></p>\n<p>Blanco is an eminent name in assembling the surpassing stainless steel kitchen sinks for more than 90 years. It has now engineered the Blanco Livit XL 5 S having an outstanding design. This stainless steel kitchen sink has a fine and firm design, with reversible installation with either left-handed or right-handed drainer. Blanco Livit XL 5 with its optimal design is a perfect choice for large kitchen areas, providing maximum work space. This stainless steel kitchen sink has an excellent and unyielding design, with reversible installation with either left-handed or right-handed bowl. This inset kitchen sink provides a fine adjusting space between its bowl and drainer. It also two pre-drilled tap ledge holes to fix a compatible kitchen mixer tap providing ease of left or right hand drainer installation. Blanco Livit XL 5 as an inset sink comes with a 3 &frac12;&rdquo; basket strainer and a stainless steel insert. This stainless steel sink needs a 50cm cabinet width for its fitting while the depth of the bowl is 165mm.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Bowl depth: 160mm</li>\n<li>Cabinet width: 500mm</li>\n<li>Handing options: Reversible</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Spacious drainer with linear runners</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n\n</ul>\n\n'),(15298,155,0,6044,'Exclude'),(15299,85,5,6045,'Blanco BL 452 613 Sink, Blanco Silgranit Sink, Blanco Sink Deals,Blanco Silgranit Sink, Blanco BL 452 613'),(15300,85,0,6045,'Blanco BL 452 613 Sink, Blanco Silgranit Sink, Blanco Sink Deals,Blanco Silgranit Sink, Blanco BL 452 613'),(15301,75,5,6045,'<p><span style=\"font-size: medium;\"><strong>Blanco Supra 400-U Undermount Stainless Steel Kitchen Sink - 452613</strong></span></p>\r\n<p> Blanco Supra 400-U comes under the Supra range of stainless steel sinks by Blanco. Blanco Supra kitchen sinks offer different sizes of <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> undermount sinks</span></a> from small to large. Blanco Supra 400-U is a medium sized stainless steel sink, but due its squared shapes it is larger than Supra 160-U, 180-U and 340-U.This stainless steel sink can be used as the main kitchen sink, or it could be coupled with same sized another sink of Supra range. Blanco Supra 400-U as an undermount sink comes with a 3 &frac12;&rdquo; basket strainer waste and overflow. It also includes a Topper waste cover and fixing kit 212 330. This stainless steel sink has 45cm cabinet width; the bowl depth is 175mm and has 60mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Bowl depth: 175mm</li>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Material: Stainless steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\r\n<li>Overflow and waste</li>\r\n<li>Fixing kit included</li>\r\n</ul>\r\n\r\n'),(15302,75,0,6045,'<p><span style=\"font-size: medium;\"><strong>Blanco Supra 400-U Undermount Stainless Steel Kitchen Sink - 452613</strong></span></p>\r\n<p> Blanco Supra 400-U comes under the Supra range of stainless steel sinks by Blanco. Blanco Supra kitchen sinks offer different sizes of <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> undermount sinks</span></a> from small to large. Blanco Supra 400-U is a medium sized stainless steel sink, but due its squared shapes it is larger than Supra 160-U, 180-U and 340-U.This stainless steel sink can be used as the main kitchen sink, or it could be coupled with same sized another sink of Supra range. Blanco Supra 400-U as an undermount sink comes with a 3 &frac12;&rdquo; basket strainer waste and overflow. It also includes a Topper waste cover and fixing kit 212 330. This stainless steel sink has 45cm cabinet width; the bowl depth is 175mm and has 60mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Bowl depth: 175mm</li>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Material: Stainless steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\r\n<li>Overflow and waste</li>\r\n<li>Fixing kit included</li>\r\n</ul>\r\n\r\n'),(15303,155,0,6045,'Exclude'),(15304,85,5,6046,'Blanco Sink, Blanco BL 452 614 Sink,Blanco classic Sink,  Sink Deals,Blanco BL 452 614 Sink sale'),(15305,85,0,6046,'Blanco Sink, Blanco BL 452 614 Sink,Blanco classic Sink,  Sink Deals,Blanco BL 452 614 Sink sale'),(15306,75,5,6046,'<p><span style=\"font-size: medium;\"><strong>Blanco Supra 450-U Undermount Stainless Steel Kitchen Sink - 452614</strong></span></p>\r\n<p> Blanco Supra 450-U comes under the Supra range of stainless steel sinks by Blanco. Blanco Supra kitchen sinks offer different sizes of undermount sinks from small to large. Blanco Supra 450-U is a medium sized <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sink</span></a>, but it is slightly larger than Supra 400-U. This stainless steel sink can be used as the main kitchen sink, or it could be coupled with same sized another sink of Supra range. Blanco Supra 450-U as an undermount sink comes with a 3 &frac12;&rdquo; basket strainer waste and overflow. It also includes a Topper waste cover and fixing kit 212 330. This stainless steel sink has 60cm cabinet width; the bowl depth is 175mm and has 60mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Bowl depth: 175mm</li>\r\n<li>Cabinet width: 500mm</li>\r\n<li>Material: Stainless steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\r\n<li>Overflow and waste</li>\r\n<li>Fixing kit included</li>\r\n</ul>\r\n'),(15307,75,0,6046,'<p><span style=\"font-size: medium;\"><strong>Blanco Supra 450-U Undermount Stainless Steel Kitchen Sink - 452614</strong></span></p>\r\n<p> Blanco Supra 450-U comes under the Supra range of stainless steel sinks by Blanco. Blanco Supra kitchen sinks offer different sizes of undermount sinks from small to large. Blanco Supra 450-U is a medium sized <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sink</span></a>, but it is slightly larger than Supra 400-U. This stainless steel sink can be used as the main kitchen sink, or it could be coupled with same sized another sink of Supra range. Blanco Supra 450-U as an undermount sink comes with a 3 &frac12;&rdquo; basket strainer waste and overflow. It also includes a Topper waste cover and fixing kit 212 330. This stainless steel sink has 60cm cabinet width; the bowl depth is 175mm and has 60mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Bowl depth: 175mm</li>\r\n<li>Cabinet width: 500mm</li>\r\n<li>Material: Stainless steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\r\n<li>Overflow and waste</li>\r\n<li>Fixing kit included</li>\r\n</ul>\r\n'),(15308,155,0,6046,'Exclude'),(15309,85,5,6047,'Blanco Sink, Silgranit Kitchen Sink, Buy BL 452 615 Sink, Blanco Silgranit Kitchen Sink Sinks,Silgranit Kitchen Sink, Blanco Supra'),(15310,85,0,6047,'Blanco Sink, Silgranit Kitchen Sink, Buy BL 452 615 Sink, Blanco Silgranit Kitchen Sink Sinks,Silgranit Kitchen Sink, Blanco Supra'),(15311,75,5,6047,'<style>#html-body [data-pb-style=EQPP3AU]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"EQPP3AU\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Supra 500-U Undermount Stainless Steel Kitchen Sink - 452615</strong></span></p>\r\n<p>Discover the supreme functionality of the <strong>SUPRA 500-U</strong> Undermount Sink! With a generous bowl depth of 175mm, it′s perfect for any kitchen task. Designed to fit in a 600mm wide cabinet, this stainless steel sink seamlessly integrates with your countertop. Elevate your kitchen with this elegant and durable single‐bowl solution</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Bowl depth: 175mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Undermount bowl with 3 1/2\" basket strainer waste</li>\r\n<li>Overflow and waste</li>\r\n<li>Fixing kit included</li>\r\n</ul></div></div></div>'),(15312,75,0,6047,'<style>#html-body [data-pb-style=EQPP3AU]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"EQPP3AU\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Supra 500-U Undermount Stainless Steel Kitchen Sink - 452615</strong></span></p>\r\n<p>Discover the supreme functionality of the <strong>SUPRA 500-U</strong> Undermount Sink! With a generous bowl depth of 175mm, it′s perfect for any kitchen task. Designed to fit in a 600mm wide cabinet, this stainless steel sink seamlessly integrates with your countertop. Elevate your kitchen with this elegant and durable single‐bowl solution</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Bowl depth: 175mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Undermount bowl with 3 1/2\" basket strainer waste</li>\r\n<li>Overflow and waste</li>\r\n<li>Fixing kit included</li>\r\n</ul></div></div></div>'),(15313,155,0,6047,'Exclude'),(15314,85,5,6048,'Buy Blanco Livit XL 6 S Sink, Blanco Sink, Livit XL 6 S Sink, Lantos Sink, Livit XL 6 S Deals'),(15315,85,0,6048,'Buy Blanco Livit XL 6 S Sink, Blanco Sink, Livit XL 6 S Sink, Lantos Sink, Livit XL 6 S Deals'),(15316,75,5,6048,'<p><span style=\"font-size: medium;\"><strong>Blanco Livit XL 6 S Inset Kitchen Sink -453364</strong></span></p>\n<p>Blanco an expert in manufacturing the best stainless steel kitchen sinks now brings to you the Blanco Livit XL 6 S. This inset kitchen sink with its long-lasting and durable design features a large single bowl and a large draining area. This stainless steel kitchen sink has an excellent and robust design, with reversible installation with either left-handed or right-handed drainer. Blanco Livit XL 6 S with its optimal design is a perfect choice for large kitchen areas, providing maximum work space. This inset kitchen sink provides a fine adjusting space between its bowl and drainer. It also has two pre-drilled tap ledge holes to fix a compatible kitchen mixer tap providing ease of left or right hand drainer installation. Blanco Livit XL 6 S as an inset sink comes with a 3 &frac12;&rdquo; basket strainer waste. This stainless steel sink requires a 60cm cabinet width to fit in while the depth of the bowl is 160mm.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Bowl depth: 160mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless Steel</li>\n<li>Handing options: Reversible</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Extra large and practical bowl size</li>\n<li>Spacious drainer with linear runners</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n\n</ul>\n\n'),(15317,75,0,6048,'<p><span style=\"font-size: medium;\"><strong>Blanco Livit XL 6 S Inset Kitchen Sink -453364</strong></span></p>\n<p>Blanco an expert in manufacturing the best stainless steel kitchen sinks now brings to you the Blanco Livit XL 6 S. This inset kitchen sink with its long-lasting and durable design features a large single bowl and a large draining area. This stainless steel kitchen sink has an excellent and robust design, with reversible installation with either left-handed or right-handed drainer. Blanco Livit XL 6 S with its optimal design is a perfect choice for large kitchen areas, providing maximum work space. This inset kitchen sink provides a fine adjusting space between its bowl and drainer. It also has two pre-drilled tap ledge holes to fix a compatible kitchen mixer tap providing ease of left or right hand drainer installation. Blanco Livit XL 6 S as an inset sink comes with a 3 &frac12;&rdquo; basket strainer waste. This stainless steel sink requires a 60cm cabinet width to fit in while the depth of the bowl is 160mm.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Bowl depth: 160mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless Steel</li>\n<li>Handing options: Reversible</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Extra large and practical bowl size</li>\n<li>Spacious drainer with linear runners</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n\n</ul>\n\n'),(15318,155,0,6048,'Exclude'),(15319,85,5,6049,'Blanco Essential 530-U Stainless Steel Undermount Sink'),(15320,85,0,6049,'Blanco Essential 530-U Stainless Steel Undermount Sink'),(15321,75,5,6049,'<p><span style=\"font-size: medium;\"><strong>Blanco Essential 530-U Stainless Steel Undermount Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n\n<li>Cabinet width: 600mm</li>\n<li>Overall size: 582 x 450mm</li>\n<li>Small bowl size: 162 x 300 x 130mm</li>\n<li>Large bowl size: 340 x 400 x 180mm</li>\n<li>Material: Stainless Steel</li>\n<li>Handing options: Reversible</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>High quality 18/10 stainless steel</li>\n<li>Universal handing for greater flexibility</li>\n<li>Unique essential shape allows for compact installation</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<li>With 3 1&sol;2&quot; waste kits and overflow</li>\n</ul>\n'),(15322,75,0,6049,'<p><span style=\"font-size: medium;\"><strong>Blanco Essential 530-U Stainless Steel Undermount Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n\n<li>Cabinet width: 600mm</li>\n<li>Overall size: 582 x 450mm</li>\n<li>Small bowl size: 162 x 300 x 130mm</li>\n<li>Large bowl size: 340 x 400 x 180mm</li>\n<li>Material: Stainless Steel</li>\n<li>Handing options: Reversible</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>High quality 18/10 stainless steel</li>\n<li>Universal handing for greater flexibility</li>\n<li>Unique essential shape allows for compact installation</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<li>With 3 1&sol;2&quot; waste kits and overflow</li>\n</ul>\n'),(15323,155,0,6049,'Exclude'),(15324,85,5,6050,'Blanco LEMIS 6 S-IF Stainless Steel Inset Kitchen Sink'),(15325,85,0,6050,'Blanco LEMIS 6 S-IF Stainless Steel Inset Kitchen Sink'),(15326,75,5,6050,'<p><span style=\"font-size: medium;\"><strong>Blanco LEMIS 6 S-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\n\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Cabinet width: 600mm</li>\n<li>Overall size: 1000 x 500mm</li>\n<li>Small bowl size: 180 x 290 x 145mm</li>\n<li>Large bowl size: 335 x 424 x 205mm</li>\n<li>Material: Stainless Steel</li>\n<li>Handing options: Reversible</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>Installation: Inset / Flushmount</li>\n<li>Modern linear shape</li>\n<li>Can be installed reversibly</li>\n<li>Spacious tap ledge and drainer area</li>\n<li>Maximized bowl capacity for more functionality</li>\n<li>Also with the attractive IF flat rim: Flexible for flush mount installation or inserted from above for a flush mount effect</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li> 3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(15327,75,0,6050,'<p><span style=\"font-size: medium;\"><strong>Blanco LEMIS 6 S-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\n\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Cabinet width: 600mm</li>\n<li>Overall size: 1000 x 500mm</li>\n<li>Small bowl size: 180 x 290 x 145mm</li>\n<li>Large bowl size: 335 x 424 x 205mm</li>\n<li>Material: Stainless Steel</li>\n<li>Handing options: Reversible</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>Installation: Inset / Flushmount</li>\n<li>Modern linear shape</li>\n<li>Can be installed reversibly</li>\n<li>Spacious tap ledge and drainer area</li>\n<li>Maximized bowl capacity for more functionality</li>\n<li>Also with the attractive IF flat rim: Flexible for flush mount installation or inserted from above for a flush mount effect</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li> 3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(15328,155,0,6050,'Exclude'),(15329,85,5,6051,'Blanco LEMIS XL 6 S-IF Stainless Steel Inset Kitchen Sink'),(15330,85,0,6051,'Blanco LEMIS XL 6 S-IF Stainless Steel Inset Kitchen Sink'),(15331,75,5,6051,'<p><span style=\"font-size: medium;\"><strong>Blanco LEMIS XL 6 S-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\n\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 205mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Installation: Inset / Flushmount</li>\n<li>Modern linear shape</li>\n<li>Handing options: Reversible</li>\n<li>Can be installed reversibly</li>\n<li>Spacious tap ledge and drainer area</li>\n<li>Maximized bowl capacity for more functionality</li>\n<li>Also with the attractive IF flat rim: Flexible for flush mount installation or inserted from above for a flush mount effect</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(15332,75,0,6051,'<p><span style=\"font-size: medium;\"><strong>Blanco LEMIS XL 6 S-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\n\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 205mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Installation: Inset / Flushmount</li>\n<li>Modern linear shape</li>\n<li>Handing options: Reversible</li>\n<li>Can be installed reversibly</li>\n<li>Spacious tap ledge and drainer area</li>\n<li>Maximized bowl capacity for more functionality</li>\n<li>Also with the attractive IF flat rim: Flexible for flush mount installation or inserted from above for a flush mount effect</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(15333,155,0,6051,'Exclude'),(15334,85,5,6052,'Blanco LEMIS 45 S-IF Stainless Steel Inset Kitchen Sink'),(15335,85,0,6052,'Blanco LEMIS 45 S-IF Stainless Steel Inset Kitchen Sink'),(15336,75,5,6052,'<p><span style=\"font-size: medium;\"><strong>Blanco LEMIS 45 S-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\n\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation : Inset</li>\n<li>Bowl depth: 205mm </li>\n\n<li>Cabinet width: 450mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Modern linear shape</li>\n<li>Handing options: Reversible</li>\n<li>Can be installed reversibly</li>\n<li>Spacious tap ledge and drainer area</li>\n<li>Maximized bowl capacity for more functionality</li>\n<li>Also with the attractive IF flat rim: Flexible for flushmount installation or inserted from above for a flushmount effect</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li> 3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(15337,75,0,6052,'<p><span style=\"font-size: medium;\"><strong>Blanco LEMIS 45 S-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\n\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation : Inset</li>\n<li>Bowl depth: 205mm </li>\n\n<li>Cabinet width: 450mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Modern linear shape</li>\n<li>Handing options: Reversible</li>\n<li>Can be installed reversibly</li>\n<li>Spacious tap ledge and drainer area</li>\n<li>Maximized bowl capacity for more functionality</li>\n<li>Also with the attractive IF flat rim: Flexible for flushmount installation or inserted from above for a flushmount effect</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li> 3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(15338,155,0,6052,'Exclude'),(15339,85,5,6053,'Blanco LIVIT II 6 S Stainless Steel Inset Kitchen Sink'),(15340,85,0,6053,'Blanco LIVIT II 6 S Stainless Steel Inset Kitchen Sink'),(15341,75,5,6053,'<p><span style=\"font-size: medium;\"><strong>Blanco LIVIT II 6 S Stainless Steel Inset Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: Yes</li>\n<li>Installation: Inset</li>\n<li>No Pop-up control</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless Steel</li>\n<li>Brushed finish surface</li>\n<li>Can be installed reversibly</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Overall size: 1000 x 500mm</li>\n<li>Handing options: Reversible</li>\n<li>Small bowl depth: 95mm</li>\n<li>Large bowl depth: 165mm</li>\n<li>Small bowl size: 290 x 182mm</li>\n<li>Large bowl size: 420 x 330mm</li>\n<li>Spacious drainer with linear runners</li>\n<li>With additional bowl for added convenience</li>\n<li>Classic design with large sweeping bowl shape</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting kit</li>\n<li>Cut out size: 982 x 482 x R15</li>\n<li>With 3 1&sol;2&quot; stainless steel basket strainers</li>\n</ul>'),(15342,75,0,6053,'<p><span style=\"font-size: medium;\"><strong>Blanco LIVIT II 6 S Stainless Steel Inset Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: Yes</li>\n<li>Installation: Inset</li>\n<li>No Pop-up control</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless Steel</li>\n<li>Brushed finish surface</li>\n<li>Can be installed reversibly</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Overall size: 1000 x 500mm</li>\n<li>Handing options: Reversible</li>\n<li>Small bowl depth: 95mm</li>\n<li>Large bowl depth: 165mm</li>\n<li>Small bowl size: 290 x 182mm</li>\n<li>Large bowl size: 420 x 330mm</li>\n<li>Spacious drainer with linear runners</li>\n<li>With additional bowl for added convenience</li>\n<li>Classic design with large sweeping bowl shape</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting kit</li>\n<li>Cut out size: 982 x 482 x R15</li>\n<li>With 3 1&sol;2&quot; stainless steel basket strainers</li>\n</ul>'),(15343,155,0,6053,'Exclude'),(15344,85,5,6054,'Blanco RONDOSOL Stainless Steel Inset Kitchen Sink'),(15345,85,0,6054,'Blanco RONDOSOL Stainless Steel Inset Kitchen Sink'),(15346,75,5,6054,'<p><span style=\"font-size: medium;\"><strong>Blanco RONDOSOL Stainless Steel Inset Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: No</li>\n<li>No drainboard</li>\n<li>Installation: Inset</li>\n<li>No Pop-up control</li>\n<li>Timeless sink design</li>\n<li>Cabinet width: 450mm</li>\n<li>Brushed finish surface</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Overall size: 390 x 460mm</li>\n<li>Bowl depth: 165mm</li>\n<li>Version: Without Pop-up Waste</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting kit with space-saving pipe</li>\n<li>Inset cut out size: Diameter 444mm</li>\n<li>With 3 1&sol;2&quot; basket strainers</li>\n</ul>'),(15347,75,0,6054,'<p><span style=\"font-size: medium;\"><strong>Blanco RONDOSOL Stainless Steel Inset Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: No</li>\n<li>No drainboard</li>\n<li>Installation: Inset</li>\n<li>No Pop-up control</li>\n<li>Timeless sink design</li>\n<li>Cabinet width: 450mm</li>\n<li>Brushed finish surface</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Overall size: 390 x 460mm</li>\n<li>Bowl depth: 165mm</li>\n<li>Version: Without Pop-up Waste</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting kit with space-saving pipe</li>\n<li>Inset cut out size: Diameter 444mm</li>\n<li>With 3 1&sol;2&quot; basket strainers</li>\n</ul>'),(15348,155,0,6054,'Exclude'),(15349,85,5,6055,'Blanco kitchen faucets , kitchen mixer taps ,Mini Mixer Tap,kitchen taps Uk,Blanco BM 3095 CH Tap , Blanco BL467542 Sink'),(15350,85,0,6055,'Blanco kitchen faucets , kitchen mixer taps ,Mini Mixer Tap,kitchen taps Uk,Blanco BM 3095 CH Tap , Blanco BL467542 Sink'),(15351,75,5,6055,'<p><span style=\"font-size: medium;\"><strong>Blanco Panor 60-9 PuraPlus Inset Ceramic Kitchen Sink Crystal White -514486</strong></span></p>\r\n<p>Blanco being an expert in manufacturing the finest <a href=\"/brands/blanco/blanco-ceramic-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> ceramic sinks</span></a> for a long time period has now produced the Blanco Panor 60-9, an inset sink. This inset kitchen sink offers a unique style in inset sinks. Blanco Panor 60-9 is a finely designed and a compact ceramic sink. It is perfectly used as the main kitchen sink providing convenient working space. It can be positioned reversibly. This sink with its crystal white glossy finishing will become the focal point of your kitchen. Blanco Panor 60-9, as an inset sink comes with a 3 &frac12;\" basket strainer waste and an overflow kit. This ceramic sink has 60cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Finish: Crystal White</li>\n<li>Bowl depth: 190mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Ceramic</li>\n<li>Style: Single Bowl Sink</li>\n<li>Attractive solution for traditional and modern country home styles</li>\r\n<li>Elegant combination of radii</li>\r\n<li>Particularly voluminous bowl</li>\r\n<li>Elegant in crystal white</li>\r\n<li>Suitable for 60 cm sink cabinets</li>\r\n</ul>\r\n<p><span style=\"font-size: small;\"><strong>Consist of</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1/2\'\' basket strainer</li>\r\n\r\n</ul>\r\n\r\n'),(15352,75,0,6055,'<p><span style=\"font-size: medium;\"><strong>Blanco Panor 60-9 PuraPlus Inset Ceramic Kitchen Sink Crystal White -514486</strong></span></p>\r\n<p>Blanco being an expert in manufacturing the finest <a href=\"/brands/blanco/blanco-ceramic-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> ceramic sinks</span></a> for a long time period has now produced the Blanco Panor 60-9, an inset sink. This inset kitchen sink offers a unique style in inset sinks. Blanco Panor 60-9 is a finely designed and a compact ceramic sink. It is perfectly used as the main kitchen sink providing convenient working space. It can be positioned reversibly. This sink with its crystal white glossy finishing will become the focal point of your kitchen. Blanco Panor 60-9, as an inset sink comes with a 3 &frac12;\" basket strainer waste and an overflow kit. This ceramic sink has 60cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Finish: Crystal White</li>\n<li>Bowl depth: 190mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Ceramic</li>\n<li>Style: Single Bowl Sink</li>\n<li>Attractive solution for traditional and modern country home styles</li>\r\n<li>Elegant combination of radii</li>\r\n<li>Particularly voluminous bowl</li>\r\n<li>Elegant in crystal white</li>\r\n<li>Suitable for 60 cm sink cabinets</li>\r\n</ul>\r\n<p><span style=\"font-size: small;\"><strong>Consist of</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1/2\'\' basket strainer</li>\r\n\r\n</ul>\r\n\r\n'),(15353,155,0,6055,'Exclude'),(15354,85,5,6056,'Rondo Sol-IF S/ST Sink, ceramic Sink, Blanco Median Rondo Sol-IF S/ST, Blanco Sinks, kitchen Sinks, best Silgranit Sink'),(15355,85,0,6056,'Rondo Sol-IF S/ST Sink, ceramic Sink, Blanco Median Rondo Sol-IF S/ST, Blanco Sinks, kitchen Sinks, best Silgranit Sink'),(15356,75,5,6056,'<p><span style=\"font-size: medium;\"><strong>Blanco Rondo Sol-IF Inset Stainless Steel Kitchen Sink - 514647</strong></span></p>\r\n<p> Blanco Rondo Sol-IF belongs to the Rondo range of stainless steel sinks by Blanco. Blanco Rondo kitchen sinks offer a unique style in inset sinks. Blanco Rondo Sol-IF is a finely designed and a compact stainless steel sink. This stainless steel sink is perfectly used as the main kitchen sink. Yet it could be coupled with the similar sink of Rondo range providing extra working space. This sink especially used with a wooden work surface will become the focal point of your kitchen. Blanco Rondo Sol-IF as an <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> inset sink</span></a> comes with a 3 &frac12;&rdquo; basket strainer waste and waste fitting with space-saving pipe. This stainless steel sink has 45cm cabinet width; the bowl depth is 165mm and the cut out size of this sink is of 434mm diameter.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 165mm</li>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Perfect compact solution for corner sinks and utility rooms</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n\r</ul>\r\n\r'),(15357,75,0,6056,'<p><span style=\"font-size: medium;\"><strong>Blanco Rondo Sol-IF Inset Stainless Steel Kitchen Sink - 514647</strong></span></p>\r\n<p> Blanco Rondo Sol-IF belongs to the Rondo range of stainless steel sinks by Blanco. Blanco Rondo kitchen sinks offer a unique style in inset sinks. Blanco Rondo Sol-IF is a finely designed and a compact stainless steel sink. This stainless steel sink is perfectly used as the main kitchen sink. Yet it could be coupled with the similar sink of Rondo range providing extra working space. This sink especially used with a wooden work surface will become the focal point of your kitchen. Blanco Rondo Sol-IF as an <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> inset sink</span></a> comes with a 3 &frac12;&rdquo; basket strainer waste and waste fitting with space-saving pipe. This stainless steel sink has 45cm cabinet width; the bowl depth is 165mm and the cut out size of this sink is of 434mm diameter.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 165mm</li>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Perfect compact solution for corner sinks and utility rooms</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n\r</ul>\r\n\r'),(15358,155,0,6056,'Exclude'),(15359,85,5,6057,'Blanco Belfast Undermount Ceramic Kitchen Sink - BL468008'),(15360,85,0,6057,'Blanco Belfast Undermount Ceramic Kitchen Sink - BL468008'),(15361,75,5,6057,'<style>#html-body [data-pb-style=G4VNT0I]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"G4VNT0I\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Belfast Undermount Ceramic Kitchen Sink - 518497</strong></span></p>\n<p>Blanco Belfast is an undermount ceramic kitchen sinkby Blanco sink products. This undermount sink has a profoundly broad and functional bowl, providing an ease of use for your large pots and pans. This high quality ceramic sink is perfectly designed to give your kitchen a modern country style outlook. Blanco Belfast as an undermount sink comes with basket strainer waste and an integral overflow. This <a title=\"Blanco Ceramic Sinks\" href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\">ceramic sink</span></a> has 60cm cabinet width; the bowl depth is 235mm and an overmount cut out size. It also comes in an eye-catching crystal white glossy colour finishing, thus enhancing the beauty of your kitchen.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n<li>Bowl depth: 275mm</li>\n<li>Bowl depth: 275mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Finish: Crystal white</li>\n<li>Material: Ceramic</li>\n<li>Style: Single Bowl Sink</li>\n<li>Handing options: Reversible</li>\n<li>High quality ceramic and glaze</li>\n<li>Perfect for creating a modern country style kitchens</li>\n<li>Deep and practical bowl for your largest pots and pans</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>With 1 1/2\" basket strainer waste and integral overflow</li>\n</ul></div></div></div>'),(15362,75,0,6057,'<style>#html-body [data-pb-style=G4VNT0I]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"G4VNT0I\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Belfast Undermount Ceramic Kitchen Sink - 518497</strong></span></p>\n<p>Blanco Belfast is an undermount ceramic kitchen sinkby Blanco sink products. This undermount sink has a profoundly broad and functional bowl, providing an ease of use for your large pots and pans. This high quality ceramic sink is perfectly designed to give your kitchen a modern country style outlook. Blanco Belfast as an undermount sink comes with basket strainer waste and an integral overflow. This <a title=\"Blanco Ceramic Sinks\" href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\">ceramic sink</span></a> has 60cm cabinet width; the bowl depth is 235mm and an overmount cut out size. It also comes in an eye-catching crystal white glossy colour finishing, thus enhancing the beauty of your kitchen.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n<li>Bowl depth: 275mm</li>\n<li>Bowl depth: 275mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Finish: Crystal white</li>\n<li>Material: Ceramic</li>\n<li>Style: Single Bowl Sink</li>\n<li>Handing options: Reversible</li>\n<li>High quality ceramic and glaze</li>\n<li>Perfect for creating a modern country style kitchens</li>\n<li>Deep and practical bowl for your largest pots and pans</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>With 1 1/2\" basket strainer waste and integral overflow</li>\n</ul></div></div></div>'),(15363,155,0,6057,'Exclude'),(15364,85,5,6058,'Blanco ZEROX 500-U Durinox Stainless Steel Undermount Sink'),(15365,85,0,6058,'Blanco ZEROX 500-U Durinox Stainless Steel Undermount Sink'),(15366,75,5,6058,'<p><span style=\"font-size: medium;\"><strong>Blanco ZEROX 500-U Durinox Stainless Steel Undermount Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n\r<li>Bowl depth: 175mm</li>\r\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Highly resistant to scratches</li>\n<li>With the covered c-overflow in durinox</li>\n<li>Infino drain system - elegantly integrated and easy-care</li>\n<li>Zero radius design with the striking rectangular bowl geometry</li>\r\n<li>Matt velvet looks with a homogeneous surface structure and pleasantly warm to the touch</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\n<li>Overflow and waste</li>\n<li>Fixing kit included</li>\n</ul>'),(15367,75,0,6058,'<p><span style=\"font-size: medium;\"><strong>Blanco ZEROX 500-U Durinox Stainless Steel Undermount Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n\r<li>Bowl depth: 175mm</li>\r\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Highly resistant to scratches</li>\n<li>With the covered c-overflow in durinox</li>\n<li>Infino drain system - elegantly integrated and easy-care</li>\n<li>Zero radius design with the striking rectangular bowl geometry</li>\r\n<li>Matt velvet looks with a homogeneous surface structure and pleasantly warm to the touch</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\n<li>Overflow and waste</li>\n<li>Fixing kit included</li>\n</ul>'),(15368,155,0,6058,'Exclude'),(15369,85,5,6059,'Blanco ZEROX 700-U Durinox® Stainless Steel Undermount Sink'),(15370,85,0,6059,'Blanco ZEROX 700-U Durinox® Stainless Steel Undermount Sink'),(15371,75,5,6059,'<p><span style=\"font-size: medium;\"><strong>Blanco ZEROX 700-U Durinox Stainless Steel Undermount Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 185mm</li>\n\r<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Highly resistant to scratches</li>\r\n<li>With the covered C-overflow in Durinox</li>\r\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Zero radius design with the striking rectangular bowl geometry</li>\r\n<li>Matt velvet looks with a homogeneous surface structure and pleasantly warm to the touch</li>\r\n\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\n<li>Overflow and waste</li>\n<li>Fixing kit included</li>\n</ul>'),(15372,75,0,6059,'<p><span style=\"font-size: medium;\"><strong>Blanco ZEROX 700-U Durinox Stainless Steel Undermount Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 185mm</li>\n\r<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Highly resistant to scratches</li>\r\n<li>With the covered C-overflow in Durinox</li>\r\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Zero radius design with the striking rectangular bowl geometry</li>\r\n<li>Matt velvet looks with a homogeneous surface structure and pleasantly warm to the touch</li>\r\n\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\n<li>Overflow and waste</li>\n<li>Fixing kit included</li>\n</ul>'),(15373,155,0,6059,'Exclude'),(15374,85,5,6060,'Blanco BL467689 Claron Sink,Claron Sink, Blanco Claron Sinks,Blanco BL467689 Sink, Blanco Undermount Sink'),(15375,85,0,6060,'Blanco BL467689 Claron Sink,Claron Sink, Blanco Claron Sinks,Blanco BL467689 Sink, Blanco Undermount Sink'),(15376,75,5,6060,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 180-U Undermount Sink</strong></span></p>\r\n<p> Blanco Claron 180-U is an undermount sink from the Claron family of Blanco STEELART <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a>. The rectangular design of this undermount sink and its compact size is very handful to be used in small kitchens. Due to its size and shape Blanco Claron 180-U can also be used as a side bowl, pairing it with other medium and large sized sinks of Claron range. Blanco Claron 180-U in addition, features an overflow and waste fitting with a space-saving pipe. This undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This stainless steel sink has 30cm cabinet width and the depth of the bowl is 130mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 130mm</li>\n<li>Cabinet width: 300mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Half Bowl SS Sink</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino straineri</li>\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit included</li>\r\n</ul>\r\n'),(15377,75,0,6060,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 180-U Undermount Sink</strong></span></p>\r\n<p> Blanco Claron 180-U is an undermount sink from the Claron family of Blanco STEELART <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a>. The rectangular design of this undermount sink and its compact size is very handful to be used in small kitchens. Due to its size and shape Blanco Claron 180-U can also be used as a side bowl, pairing it with other medium and large sized sinks of Claron range. Blanco Claron 180-U in addition, features an overflow and waste fitting with a space-saving pipe. This undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This stainless steel sink has 30cm cabinet width and the depth of the bowl is 130mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 130mm</li>\n<li>Cabinet width: 300mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Half Bowl SS Sink</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino straineri</li>\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit included</li>\r\n</ul>\r\n'),(15378,155,0,6060,'Exclude'),(15379,85,5,6061,'Claron Sink, Ceramic Sink, Blanco BL467690  Claron Sink, Claron cooker Sinks, BL467690 Kitchen Sinks'),(15380,85,0,6061,'Claron Sink, Ceramic Sink, Blanco BL467690  Claron Sink, Claron cooker Sinks, BL467690 Kitchen Sinks'),(15381,75,5,6061,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 340-U Undermount Sink - 521571</strong></span></p>\r\n<p>Blanco with its long-time period experience in manufacturing stainless steel sinks now brings to you the Blanco Claron 340-U, an undermount sink. Blanco Claron 340-U with its finest design is idyllic to give your kitchen an outlook with geometrical designing. This undermount sink is perfectly built to be used as an individual main kitchen sink. Blanco Claron 340-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This stainless steel sink has 40cm cabinet width and the depth of the bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 400mm</li>\r\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n\r</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing element set (sealing not included)</li>\r\n</ul>\r\n'),(15382,75,0,6061,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 340-U Undermount Sink - 521571</strong></span></p>\r\n<p>Blanco with its long-time period experience in manufacturing stainless steel sinks now brings to you the Blanco Claron 340-U, an undermount sink. Blanco Claron 340-U with its finest design is idyllic to give your kitchen an outlook with geometrical designing. This undermount sink is perfectly built to be used as an individual main kitchen sink. Blanco Claron 340-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This stainless steel sink has 40cm cabinet width and the depth of the bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 400mm</li>\r\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n\r</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing element set (sealing not included)</li>\r\n</ul>\r\n'),(15383,155,0,6061,'Exclude'),(15384,85,5,6062,'Blanco BL467691,Blanco ceramic Sink, Blanco Silgranit Sink, Blanco BL467691  Sink,Blanco Claron Sink'),(15385,85,0,6062,'Blanco BL467691,Blanco ceramic Sink, Blanco Silgranit Sink, Blanco BL467691  Sink,Blanco Claron Sink'),(15386,75,5,6062,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 400-U Undermount Sink - 521573</strong></span></p>\r\n<p>Blanco being a renowned expert in producing the stainless steel sinks now brings forth the Blanco Claron 400-U, an undermount sink. Blanco Claron 400-U with its finest design is perfect to give your kitchen an outlook with geometrical designing. This <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> undermount sink</span></a> is flawlessly built to be used as an individual main kitchen sink. Blanco Claron 400-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This stainless steel sink has 45cm cabinet width and the depth of the bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Material: Stainless steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n<li>InFino drain system – elegantly integrated and easy-care</li>\r\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste and overflow fittin  with space saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing element set (sealing not included)</li>\r\n</ul>\r\n'),(15387,75,0,6062,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 400-U Undermount Sink - 521573</strong></span></p>\r\n<p>Blanco being a renowned expert in producing the stainless steel sinks now brings forth the Blanco Claron 400-U, an undermount sink. Blanco Claron 400-U with its finest design is perfect to give your kitchen an outlook with geometrical designing. This <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> undermount sink</span></a> is flawlessly built to be used as an individual main kitchen sink. Blanco Claron 400-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This stainless steel sink has 45cm cabinet width and the depth of the bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Material: Stainless steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n<li>InFino drain system – elegantly integrated and easy-care</li>\r\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste and overflow fittin  with space saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing element set (sealing not included)</li>\r\n</ul>\r\n'),(15388,155,0,6062,'Exclude'),(15389,85,5,6063,'Buy BL467692 Sink, Blanco Sink sale, cheap Blanco Claron Sinks, best Blanco Claron Sinks,Blanco BL467692 Sink'),(15390,85,0,6063,'Buy BL467692 Sink, Blanco Sink sale, cheap Blanco Claron Sinks, best Blanco Claron Sinks,Blanco BL467692 Sink'),(15391,75,5,6063,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 450-U Undermount Sink - 521575</strong></span></p>\r\n<p>Blanco being a well-known professional in producing the stainless steel sinks now brings forth the Blanco Claron 450-U, an undermount sink. Blanco Claron 450-U with its finest design is perfect to give your kitchen an outlook with geometrical designing. This <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> undermount sink</span></a> is flawlessly built to be used as an individual main kitchen sink. Blanco Claron 450-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This stainless steel sink has 50cm cabinet width and the depth of the bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 500mm</li>\r\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing element set (sealing not included)</li>\r\n</ul>\r\n\r'),(15392,75,0,6063,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 450-U Undermount Sink - 521575</strong></span></p>\r\n<p>Blanco being a well-known professional in producing the stainless steel sinks now brings forth the Blanco Claron 450-U, an undermount sink. Blanco Claron 450-U with its finest design is perfect to give your kitchen an outlook with geometrical designing. This <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> undermount sink</span></a> is flawlessly built to be used as an individual main kitchen sink. Blanco Claron 450-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This stainless steel sink has 50cm cabinet width and the depth of the bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 500mm</li>\r\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing element set (sealing not included)</li>\r\n</ul>\r\n\r'),(15393,155,0,6063,'Exclude'),(15394,85,5,6064,'Blanco BL467656  Sink, Blanco ceramic Sink, Blanco Silgranit Sink, Blanco Claron Sink, buy Blanco Sink'),(15395,85,0,6064,'Blanco BL467656  Sink, Blanco ceramic Sink, Blanco Silgranit Sink, Blanco Claron Sink, buy Blanco Sink'),(15396,75,5,6064,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 500-IF Insert Kitchen Sink - 521576</strong></span></p>\r\n<p> Blanco Claron 500-IF is an inset sink from the Claron family of Blanco STEELART <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a>. Blanco Claron 500-IF with its finest design is idyllic to give your kitchen an outlook with geometrical designing. This inset sink is perfectly built to be used as an individual main kitchen sink. Blanco Claron 500-IF, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This stainless steel sink has 60cm cabinet width and the depth of the bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Blanco Claron in elegant-pure design with no visible base pattern</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing element set (sealing not included)</li>\r\n</ul>\r\n'),(15397,75,0,6064,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 500-IF Insert Kitchen Sink - 521576</strong></span></p>\r\n<p> Blanco Claron 500-IF is an inset sink from the Claron family of Blanco STEELART <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a>. Blanco Claron 500-IF with its finest design is idyllic to give your kitchen an outlook with geometrical designing. This inset sink is perfectly built to be used as an individual main kitchen sink. Blanco Claron 500-IF, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This stainless steel sink has 60cm cabinet width and the depth of the bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Blanco Claron in elegant-pure design with no visible base pattern</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing element set (sealing not included)</li>\r\n</ul>\r\n'),(15398,155,0,6064,'Exclude'),(15399,85,5,6065,'Blanco Sink, Blanco BL467693 Sink, Blanco stainless steel Sink, Blanco Kitchen Sink, Blanco Claron Sink, Blanco Claron 500 u sink, Blanco Undermount Sink'),(15400,85,0,6065,'Blanco Sink, Blanco BL467693 Sink, Blanco stainless steel Sink, Blanco Kitchen Sink, Blanco Claron Sink, Blanco Claron 500 u sink, Blanco Undermount Sink'),(15401,75,5,6065,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 500-U Undermount Sink - 521577</strong></span></p>\r\n<p> Blanco Claron 500-U is an  undermount sink from the Claron family of Blanco STEELART <a href=\"/brands/blanco/blanco-stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a>.  Blanco Claron 500-U with its finest design is idyllic to give your kitchen an outlook with geometrical designing. This  undermount sink is perfectly built to be used as an individual main kitchen sink.  Blanco Claron 500 U sink, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This  undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This  stainless steel sink has 60cm cabinet width and the depth of the bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n\r</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing element set (sealing not included)</li>\r\n</ul>\r\n'),(15402,75,0,6065,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 500-U Undermount Sink - 521577</strong></span></p>\r\n<p> Blanco Claron 500-U is an  undermount sink from the Claron family of Blanco STEELART <a href=\"/brands/blanco/blanco-stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a>.  Blanco Claron 500-U with its finest design is idyllic to give your kitchen an outlook with geometrical designing. This  undermount sink is perfectly built to be used as an individual main kitchen sink.  Blanco Claron 500 U sink, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This  undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This  stainless steel sink has 60cm cabinet width and the depth of the bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n\r</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing element set (sealing not included)</li>\r\n</ul>\r\n'),(15403,155,0,6065,'Exclude'),(15404,85,5,6066,'BlancoBL467659 Sink, Buy Blanco Sink, Stylish Claron Sink, Cheap  BL467659 Sink, Blanco Stainless steel Sink'),(15405,85,0,6066,'BlancoBL467659 Sink, Buy Blanco Sink, Stylish Claron Sink, Cheap  BL467659 Sink, Blanco Stainless steel Sink'),(15406,75,5,6066,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 700-IF Insert Kitchen Sink - 521580</strong></span></p>\r\n<p>Blanco being a well-known professional in producing the stainless steel sinks now brings forth the Blanco Claron 700-IF, an inset sink. Blanco Claron 700-IF with its finest design is perfect to give your kitchen an outlook with geometrical designing. This inset sink is flawlessly built to be used as an individual main kitchen sink. Blanco Claron 700-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sink</span></a> has 80cm cabinet width and the depth of the bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 400mm</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Blanco Claron in elegant-pure design with no visible base pattern</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit included</li>\r\n</ul>\r\n\r'),(15407,75,0,6066,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 700-IF Insert Kitchen Sink - 521580</strong></span></p>\r\n<p>Blanco being a well-known professional in producing the stainless steel sinks now brings forth the Blanco Claron 700-IF, an inset sink. Blanco Claron 700-IF with its finest design is perfect to give your kitchen an outlook with geometrical designing. This inset sink is flawlessly built to be used as an individual main kitchen sink. Blanco Claron 700-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sink</span></a> has 80cm cabinet width and the depth of the bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 400mm</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Blanco Claron in elegant-pure design with no visible base pattern</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit included</li>\r\n</ul>\r\n\r'),(15408,155,0,6066,'Exclude'),(15409,85,5,6067,'Blanco BL467695 Sink, Blanco Sink, Blanco BL467695 Sink, Blanco Claron Sink, Blanco Sink Deals'),(15410,85,0,6067,'Blanco BL467695 Sink, Blanco Sink, Blanco BL467695 Sink, Blanco Claron Sink, Blanco Sink Deals'),(15411,75,5,6067,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 700-U Undermount Sink - 521581</strong></span></p>\r\n<p>Blanco having almost a century\'s experience in manufacturing stainless steel sinks, now produces the Blanco Claron 700-U, an undermount sink. Blanco Claron 700-U with its finest design is perfect to give your kitchen an outlook with geometrical designing. This undermount sink is flawlessly built to be used as an individual main kitchen sink. Blanco Claron 700-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sink</span></a> has 80cm cabinet width and the depth of the bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 800mm</li>\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\r\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing element set (sealing not included)</li>\r\n</ul>\r\n'),(15412,75,0,6067,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 700-U Undermount Sink - 521581</strong></span></p>\r\n<p>Blanco having almost a century\'s experience in manufacturing stainless steel sinks, now produces the Blanco Claron 700-U, an undermount sink. Blanco Claron 700-U with its finest design is perfect to give your kitchen an outlook with geometrical designing. This undermount sink is flawlessly built to be used as an individual main kitchen sink. Blanco Claron 700-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sink</span></a> has 80cm cabinet width and the depth of the bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 800mm</li>\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\r\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing element set (sealing not included)</li>\r\n</ul>\r\n'),(15413,155,0,6067,'Exclude'),(15414,85,5,6068,'Blanco BL467707 Sink, Buy Blanco Sink, Stylish Steam Sink, Cheap  Sink, Blanco Stainless steel Sink'),(15415,85,0,6068,'Blanco BL467707 Sink, Buy Blanco Sink, Stylish Steam Sink, Cheap  Sink, Blanco Stainless steel Sink'),(15416,75,5,6068,'<p><span style=\"font-size: medium;\"><strong>Blanco Zerox 500-U Undermount Sink - 521589</strong></span></p>\r\n<p>Blanco as the manufacturer of high-quality stainless steel sinks now gives you the Blanco Zerox 500-U, an undermount sink. This undermount sink with its geometrical design will become the focal point of your modern kitchen. Blanco Zerox 500-U, in addition, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sink</span></a> has 60cm cabinet width and the bowl depth is of 175mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 175mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Zero-radius design with striking, right-angled bowl geometry</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\n<li>Overflow and waste</li>\n<li>Fixing kit included</li>\n</ul>\n\n'),(15417,75,0,6068,'<p><span style=\"font-size: medium;\"><strong>Blanco Zerox 500-U Undermount Sink - 521589</strong></span></p>\r\n<p>Blanco as the manufacturer of high-quality stainless steel sinks now gives you the Blanco Zerox 500-U, an undermount sink. This undermount sink with its geometrical design will become the focal point of your modern kitchen. Blanco Zerox 500-U, in addition, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sink</span></a> has 60cm cabinet width and the bowl depth is of 175mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 175mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Zero-radius design with striking, right-angled bowl geometry</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\n<li>Overflow and waste</li>\n<li>Fixing kit included</li>\n</ul>\n\n'),(15418,155,0,6068,'Exclude'),(15419,85,5,6069,'Blanco BL467708 Sink, Blanco Best Sink, Stylish Single Sink, Cheap Blanco Sink, BL467708 Sink'),(15420,85,0,6069,'Blanco BL467708 Sink, Blanco Best Sink, Stylish Single Sink, Cheap Blanco Sink, BL467708 Sink'),(15421,75,5,6069,'<p><span style=\"font-size: medium;\"><strong>Blanco Zerox 550-U Undermount Sink - 521591</strong></span></p>\r\n<p>Blanco well-known for its long-time expertise in manufacturing high-quality stainless steel sinks now brings to you the Blanco Zerox 550-U, an undermount sink. This undermount sink with its geometrical design will certainly provide a focal point for your modern kitchen. Blanco Zerox 550-U, in addition, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This stainless steel sink has 60cm cabinet width and the bowl depth is of 175mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 175mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Zero-radius design with striking, right-angled bowl geometry</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\n<li>Overflow and waste</li>\n<li>Fixing kit included</li>\n</ul>\n'),(15422,75,0,6069,'<p><span style=\"font-size: medium;\"><strong>Blanco Zerox 550-U Undermount Sink - 521591</strong></span></p>\r\n<p>Blanco well-known for its long-time expertise in manufacturing high-quality stainless steel sinks now brings to you the Blanco Zerox 550-U, an undermount sink. This undermount sink with its geometrical design will certainly provide a focal point for your modern kitchen. Blanco Zerox 550-U, in addition, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This stainless steel sink has 60cm cabinet width and the bowl depth is of 175mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 175mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Zero-radius design with striking, right-angled bowl geometry</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\n<li>Overflow and waste</li>\n<li>Fixing kit included</li>\n</ul>\n'),(15423,155,0,6069,'Exclude'),(15424,75,5,6070,'<p><span style=\"font-size: medium;\"><strong>Blanco Zerox 700-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Finish: Satin polish</li>\r\n<li>Bowl depth: 185mm</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n<li>Zero-radius design with striking, right-angled bowl geometry</li>\r\n<li>InFino drain system – elegantly integrated and easy-care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Fixing kit</li>\r\n<li>Waste kit with space saving pipe</li>\r\n<li>3 1&sol;2&quot; InFino basket strainer</li>\r\n</ul>'),(15425,75,0,6070,'<p><span style=\"font-size: medium;\"><strong>Blanco Zerox 700-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Finish: Satin polish</li>\r\n<li>Bowl depth: 185mm</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n<li>Zero-radius design with striking, right-angled bowl geometry</li>\r\n<li>InFino drain system – elegantly integrated and easy-care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Fixing kit</li>\r\n<li>Waste kit with space saving pipe</li>\r\n<li>3 1&sol;2&quot; InFino basket strainer</li>\r\n</ul>'),(15426,155,0,6070,'Exclude'),(15427,85,5,6071,'Blanco CLARON 400/400-U Stainless Steel Undermount Kitchen Sink'),(15428,85,0,6071,'Blanco CLARON 400/400-U Stainless Steel Undermount Kitchen Sink'),(15429,75,5,6071,'<p><span style=\"font-size: medium;\"><strong>Blanco CLARON 400/400-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: No</li>\n<li>No drainboard</li>\n<li>No Pop-up control</li>\n<li>Cabinet width: 900mm</li>\n<li>Satin polish surface</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Double Bowl SS Sink</li>\n<li>Installation: Undermount</li>\n<li>Overall size: 865 x 440mm</li>\n<li>Main bowl size: 400 x 400mm</li>\n<li>Version: Without Pop-up Waste</li>\n<li>Bowl Position: Universal Handing</li>\n<li>Elegant-pure bowl design</li>\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Concise 10mm radius for a more refined design, without doing away with practical benefits</li>\n<li>Optimum utilisation of the bowl capacity thanks to extra-deep bowls and distinctively small radii</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit included</li>\n<li>Cut out: Template provided</li>\n<li>With 3 1&sol;2&quot; basket strainer</li>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>Technical note: The undermount bowl edge is not closed at the corners</li>\n</ul>'),(15430,75,0,6071,'<p><span style=\"font-size: medium;\"><strong>Blanco CLARON 400/400-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: No</li>\n<li>No drainboard</li>\n<li>No Pop-up control</li>\n<li>Cabinet width: 900mm</li>\n<li>Satin polish surface</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Double Bowl SS Sink</li>\n<li>Installation: Undermount</li>\n<li>Overall size: 865 x 440mm</li>\n<li>Main bowl size: 400 x 400mm</li>\n<li>Version: Without Pop-up Waste</li>\n<li>Bowl Position: Universal Handing</li>\n<li>Elegant-pure bowl design</li>\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Concise 10mm radius for a more refined design, without doing away with practical benefits</li>\n<li>Optimum utilisation of the bowl capacity thanks to extra-deep bowls and distinctively small radii</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit included</li>\n<li>Cut out: Template provided</li>\n<li>With 3 1&sol;2&quot; basket strainer</li>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>Technical note: The undermount bowl edge is not closed at the corners</li>\n</ul>'),(15431,155,0,6071,'Exclude'),(15432,85,5,6072,'Blanco ETAGON 500 IF/A Stainless Steel Inset Sink'),(15433,85,0,6072,'Blanco ETAGON 500 IF/A Stainless Steel Inset Sink'),(15434,75,5,6072,'<style>#html-body [data-pb-style=JF3O8OM]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"JF3O8OM\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco ETAGON 500 IF/A Stainless Steel Inset Sink</strong></span></p>\r\n<p>Blanco ETAGON 500-U Silgranit® PuraDur II® Stainless Steel Inset Sink is a stylish and Multifunctional stainless steel kitchen sink.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\r\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n<li>Generous staggered bowl with the functionality of a sink centre</li>\r\n<li>Integrated step creates an additional functions level combined with the innovative andversatile ETAGON rails</li>\r\n<li>High-quality features with the covered C-overflow and drain system elegantly integrated and extremely hygienic</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>With Etagon rails in stainless steel</li>\r\n<li>3 1/2\" basket strainer</li>\r\n<li>Waste fitting with space-saving pipe</li>\r\n</ul></div></div></div>'),(15435,75,0,6072,'<style>#html-body [data-pb-style=JF3O8OM]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"JF3O8OM\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco ETAGON 500 IF/A Stainless Steel Inset Sink</strong></span></p>\r\n<p>Blanco ETAGON 500-U Silgranit® PuraDur II® Stainless Steel Inset Sink is a stylish and Multifunctional stainless steel kitchen sink.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\r\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n<li>Generous staggered bowl with the functionality of a sink centre</li>\r\n<li>Integrated step creates an additional functions level combined with the innovative andversatile ETAGON rails</li>\r\n<li>High-quality features with the covered C-overflow and drain system elegantly integrated and extremely hygienic</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>With Etagon rails in stainless steel</li>\r\n<li>3 1/2\" basket strainer</li>\r\n<li>Waste fitting with space-saving pipe</li>\r\n</ul></div></div></div>'),(15436,155,0,6072,'Exclude'),(15437,85,5,6073,'Blanco ETAGON 500-IF Stainless Steel Inset Sink'),(15438,85,0,6073,'Blanco ETAGON 500-IF Stainless Steel Inset Sink'),(15439,75,5,6073,'<p><span style=\"font-size: medium;\"><strong>Blanco ETAGON 500-IF Stainless Steel Inset Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n\r<li>Installation: Inset</li>\n<li>Bowl depth: 190 mm</li>\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Integrated step creates an additional functions level</li>\r\n<li>Innovative system concept with versatile ETAGON rails</li>\r\n<li>Generous staggered bowl with the functionality of a sink centre</li>\n<li>High-quality features with the covered C-overflow and InFino drain system elegantly integrated and extremely hygienic</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>With Etagon rails in stainless steel</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Waste fitting with space-saving pipe</li>\n</ul>\n\n'),(15440,75,0,6073,'<p><span style=\"font-size: medium;\"><strong>Blanco ETAGON 500-IF Stainless Steel Inset Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n\r<li>Installation: Inset</li>\n<li>Bowl depth: 190 mm</li>\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Integrated step creates an additional functions level</li>\r\n<li>Innovative system concept with versatile ETAGON rails</li>\r\n<li>Generous staggered bowl with the functionality of a sink centre</li>\n<li>High-quality features with the covered C-overflow and InFino drain system elegantly integrated and extremely hygienic</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>With Etagon rails in stainless steel</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Waste fitting with space-saving pipe</li>\n</ul>\n\n'),(15441,155,0,6073,'Exclude'),(15442,75,5,6074,'<p><span style=\"font-size: medium;\"><strong>Blanco Etagon 500-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation : Undermount</li>\n<li>Bowl depth: 190mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Integrated step creates an additional functions level</li>\n<li>Innovative system concept with versatile ETAGON rails</li>\n<li>Generous staggered bowl with the functionality of a sink centre</li>\n<li>For undermount installation, ideal in combination with high quality worktops</li>\n<li>High-quality features with the covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space-saving pipe</li>\n<li>2 x ETAGON rails in stainless steel</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15443,75,0,6074,'<p><span style=\"font-size: medium;\"><strong>Blanco Etagon 500-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation : Undermount</li>\n<li>Bowl depth: 190mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Integrated step creates an additional functions level</li>\n<li>Innovative system concept with versatile ETAGON rails</li>\n<li>Generous staggered bowl with the functionality of a sink centre</li>\n<li>For undermount installation, ideal in combination with high quality worktops</li>\n<li>High-quality features with the covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space-saving pipe</li>\n<li>2 x ETAGON rails in stainless steel</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15444,155,0,6074,'Exclude'),(15445,85,5,6075,'Blanco Axis III 5 S-IF Stainless Steel Inset Sink'),(15446,85,0,6075,'Blanco Axis III 5 S-IF Stainless Steel Inset Sink'),(15447,75,5,6075,'<p><span style=\"font-size: medium;\"><strong>Blanco Axis III 5 S-IF Stainless Steel Inset Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Bowl depth: 190/60mm</li>\n<li>Cabinet width: 500mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Handing options: Reversible</li>\n<li>Flowing ergonomic work processes along two axis</li>\n<li>Practical additional draining bowl With stainless steel insert</li>\n<li>Accentuated base contours create an aesthetically pleasing contoured bowl with large base area</li>\n<li>High-quality features with the covered C-overflow&trade; and InFino&trade; drain system &ndash; elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Pop-up waste for main bowl</li>\n<li>Perforated insert stainless steel</li>\n<li>Waste fitting with space-saving pipe</li>\n<li>Movable chopping board made of safety glass</li>\n<li>3 1&sol;2&quot; basket strainer and 1 1&sol;2&quot;\'\' ; non sealing basket strainer</li>\n</ul>\n\n'),(15448,75,0,6075,'<p><span style=\"font-size: medium;\"><strong>Blanco Axis III 5 S-IF Stainless Steel Inset Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Bowl depth: 190/60mm</li>\n<li>Cabinet width: 500mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Handing options: Reversible</li>\n<li>Flowing ergonomic work processes along two axis</li>\n<li>Practical additional draining bowl With stainless steel insert</li>\n<li>Accentuated base contours create an aesthetically pleasing contoured bowl with large base area</li>\n<li>High-quality features with the covered C-overflow&trade; and InFino&trade; drain system &ndash; elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Pop-up waste for main bowl</li>\n<li>Perforated insert stainless steel</li>\n<li>Waste fitting with space-saving pipe</li>\n<li>Movable chopping board made of safety glass</li>\n<li>3 1&sol;2&quot; basket strainer and 1 1&sol;2&quot;\'\' ; non sealing basket strainer</li>\n</ul>\n\n'),(15449,155,0,6075,'Exclude'),(15450,85,5,6076,'Blanco Stainless Steel  Sink, Blanco ceramic Sink, Blanco BL 518 303 Sink, Blanco Anadano Sink, buy Blanco BL 518 303 Sink'),(15451,85,0,6076,'Blanco Stainless Steel  Sink, Blanco ceramic Sink, Blanco BL 518 303 Sink, Blanco Anadano Sink, buy Blanco BL 518 303 Sink'),(15452,75,5,6076,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 180-IF Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with more than 90 years&rsquo; experience in manufacturing the <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks </span></a>has now introduced the new Blanco Andano 180-IF, an inset kitchen sink from the Andano family of Blanco STEELART. The rectangular design of this inset kitchen sink and its compact size is very handful to be used in small kitchens. Due to its size and shape Blanco Andano 180-IF can also be used as a side bowl, pairing it with other medium and large sized sinks of Andano range. Blanco Andano 180-IF in addition features an overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 30cm cabinet width and the depth of the bowl is 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 130mm</li>\r\n<li>Cabinet width: 300mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Half Bowl SS Sink</li>\n<li>Large bowl capacity and fully usable base</li>\n<li>For installation from above or undermount installation</li>\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow and modern basket strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15453,75,0,6076,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 180-IF Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with more than 90 years&rsquo; experience in manufacturing the <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks </span></a>has now introduced the new Blanco Andano 180-IF, an inset kitchen sink from the Andano family of Blanco STEELART. The rectangular design of this inset kitchen sink and its compact size is very handful to be used in small kitchens. Due to its size and shape Blanco Andano 180-IF can also be used as a side bowl, pairing it with other medium and large sized sinks of Andano range. Blanco Andano 180-IF in addition features an overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 30cm cabinet width and the depth of the bowl is 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 130mm</li>\r\n<li>Cabinet width: 300mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Half Bowl SS Sink</li>\n<li>Large bowl capacity and fully usable base</li>\n<li>For installation from above or undermount installation</li>\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow and modern basket strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15454,155,0,6076,'Exclude'),(15455,85,5,6077,'Blanco BL 518 301 Anadano Sink,Anadano Sink, Blanco Anadano Sinks,Blanco BL 518 301 Sink,Blanco Silgranit Sink'),(15456,85,0,6077,'Blanco BL 518 301 Anadano Sink,Anadano Sink, Blanco Anadano Sinks,Blanco BL 518 301 Sink,Blanco Silgranit Sink'),(15457,75,5,6077,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 180-U Undermount Stainless Steel Kitchen Sink</strong></span></p>\r\n<p> Blanco Andano 180-U is an <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> undermount kitchen sink</span></a> from the Andano family of Blanco STEELART <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a>. The rectangular design of this undermount kitchen sink and its compact size is very handful to be used in small kitchens. Due to its size and shape Blanco Andano 180-U can also be used as a side bowl, pairing it with other medium and large sized sinks of Andano range. Blanco Andano 180-U in addition features an overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 30cm cabinet width and the depth of the bowl is 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 130mm</li>\n<li>Cabinet width: 300mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Half Bowl SS Sink</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow and modern basket strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15458,75,0,6077,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 180-U Undermount Stainless Steel Kitchen Sink</strong></span></p>\r\n<p> Blanco Andano 180-U is an <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> undermount kitchen sink</span></a> from the Andano family of Blanco STEELART <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a>. The rectangular design of this undermount kitchen sink and its compact size is very handful to be used in small kitchens. Due to its size and shape Blanco Andano 180-U can also be used as a side bowl, pairing it with other medium and large sized sinks of Andano range. Blanco Andano 180-U in addition features an overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 30cm cabinet width and the depth of the bowl is 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 130mm</li>\n<li>Cabinet width: 300mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Half Bowl SS Sink</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow and modern basket strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15459,155,0,6077,'Exclude'),(15460,85,5,6078,'BlancoBL 518 307 Sink,Blanco Anadano Sink, Blanco Stainless Steel Sinks,Buy BL 518 307 Sink deals'),(15461,85,0,6078,'BlancoBL 518 307 Sink,Blanco Anadano Sink, Blanco Stainless Steel Sinks,Buy BL 518 307 Sink deals'),(15462,75,5,6078,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 340-IF Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with more than 90 years&rsquo; experience in manufacturing the <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks </span></a>has now introduced the new Blanco Andano 340-IF, an inset kitchen sink from the Andano family of Blanco STEELART. Blanco Andano 340-IF with its finest design is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is perfectly built to be used as an individual main kitchen sink. Blanco Andano 340-IF, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 40cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 400mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully usable base</li>\n<li>For installation from above or undermount installation</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow and modern basket strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15463,75,0,6078,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 340-IF Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with more than 90 years&rsquo; experience in manufacturing the <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks </span></a>has now introduced the new Blanco Andano 340-IF, an inset kitchen sink from the Andano family of Blanco STEELART. Blanco Andano 340-IF with its finest design is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is perfectly built to be used as an individual main kitchen sink. Blanco Andano 340-IF, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 40cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 400mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully usable base</li>\n<li>For installation from above or undermount installation</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow and modern basket strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15464,155,0,6078,'Exclude'),(15465,85,5,6079,'Blanco Anadano Sinks,Blanco Silgranit Sink, Blanco ceramic Sink, Blanco BL 518 305 Sink, Blanco Sink sale'),(15466,85,0,6079,'Blanco Anadano Sinks,Blanco Silgranit Sink, Blanco ceramic Sink, Blanco BL 518 305 Sink, Blanco Sink sale'),(15467,75,5,6079,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 340-U Undermount Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with its long-time period experience in manufacturing <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings to you the Blanco Andano 340-U, an undermount kitchen sink. Blanco Andano 340-U with its finest design is idyllic to give your kitchen an outlook with geometrical designing. This undermount kitchen sink is perfectly built to be used as an individual main kitchen sink. Blanco Andano 340-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 40cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 400mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully usable base</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow and InFino drain system – gracefully integrated and easy-care</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15468,75,0,6079,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 340-U Undermount Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with its long-time period experience in manufacturing <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings to you the Blanco Andano 340-U, an undermount kitchen sink. Blanco Andano 340-U with its finest design is idyllic to give your kitchen an outlook with geometrical designing. This undermount kitchen sink is perfectly built to be used as an individual main kitchen sink. Blanco Andano 340-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 40cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 400mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully usable base</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow and InFino drain system – gracefully integrated and easy-care</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15469,155,0,6079,'Exclude'),(15470,85,5,6080,'Blanco Andano 400-IF Undermount Stainless Steel Kitchen Sink '),(15471,85,0,6080,'Blanco Andano 400-IF Undermount Stainless Steel Kitchen Sink '),(15472,75,5,6080,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 400-IF Inset Stainless Steel Kitchen Sink </strong></span></p>\r\n<p>Blanco with more than 90 years&rsquo; experience as a renowned manufacturer in engineering the high-quality <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings forth the Blanco Andano 400-IF, an inset kitchen sink. Blanco Andano 400-IF with its finest design is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano 400-IF, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 45cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\n<li>Cabinet width: 450mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>Large bowl capacity and fully usable base</li>\r\n<li>For installation from above or undermount installation</li>\r\n<li>High quality features consisting of a covered c-overflow&reg; and modern basket strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Fixing kit (sealing not included)</li>\n</ul>\n\r'),(15473,75,0,6080,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 400-IF Inset Stainless Steel Kitchen Sink </strong></span></p>\r\n<p>Blanco with more than 90 years&rsquo; experience as a renowned manufacturer in engineering the high-quality <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings forth the Blanco Andano 400-IF, an inset kitchen sink. Blanco Andano 400-IF with its finest design is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano 400-IF, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 45cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\n<li>Cabinet width: 450mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>Large bowl capacity and fully usable base</li>\r\n<li>For installation from above or undermount installation</li>\r\n<li>High quality features consisting of a covered c-overflow&reg; and modern basket strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Fixing kit (sealing not included)</li>\n</ul>\n\r'),(15474,155,0,6080,'Exclude'),(15475,85,5,6081,'Undermount Anadano Sink, Anadano Sink, ceramic Sink, Blanco BL 518 309 Anadano Sink, Blanco kitchen Sinks'),(15476,85,0,6081,'Undermount Anadano Sink, Anadano Sink, ceramic Sink, Blanco BL 518 309 Anadano Sink, Blanco kitchen Sinks'),(15477,75,5,6081,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 400-U Undermount Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco being a renowned expert in crafting the <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings forth the Blanco Andano 400-U, an undermount kitchen sink. Blanco Andano 400-U with its finest design is perfect to give your kitchen an outlook with geometrical designing. This undermount kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano 400-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 45cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n<li>High quality features consisting of a covered C-overflow and InFino drain system – gracefully integrated and easy-care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Fixing kit (sealing not included)</li>\n</ul>\n\n\r'),(15478,75,0,6081,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 400-U Undermount Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco being a renowned expert in crafting the <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings forth the Blanco Andano 400-U, an undermount kitchen sink. Blanco Andano 400-U with its finest design is perfect to give your kitchen an outlook with geometrical designing. This undermount kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano 400-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 45cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n<li>High quality features consisting of a covered C-overflow and InFino drain system – gracefully integrated and easy-care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Fixing kit (sealing not included)</li>\n</ul>\n\n\r'),(15479,155,0,6081,'Exclude'),(15480,85,5,6082,'BL 519 375 Sink, ,Blanco Anadano Sinks,Blanco BL 519 375 Sink, Blanco Silgranit Sink, Blanco steel Sinks'),(15481,85,0,6082,'BL 519 375 Sink, ,Blanco Anadano Sinks,Blanco BL 519 375 Sink, Blanco Silgranit Sink, Blanco steel Sinks'),(15482,75,5,6082,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 450-IF Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with its long-time period experience in manufacturing <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings to you the new Blanco Andano 450-IF, an inset kitchen sink. Blanco Andano 450-IF with its finest design is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano 450-IF, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 50cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 500mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>For installation from above or undermount installation</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n<li>High quality features consisting of a covered c-overflow&trade; and modern basket strainer</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15483,75,0,6082,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 450-IF Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with its long-time period experience in manufacturing <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings to you the new Blanco Andano 450-IF, an inset kitchen sink. Blanco Andano 450-IF with its finest design is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano 450-IF, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 50cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 500mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>For installation from above or undermount installation</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n<li>High quality features consisting of a covered c-overflow&trade; and modern basket strainer</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15484,155,0,6082,'Exclude'),(15485,85,5,6083,'Blanco BL 519 373 Silgranit Sink,Blanco ceramic Sink, Blanco Silgranit Sink, Blanco BL 519 373  Sink,Blanco Anadano Sink'),(15486,85,0,6083,'Blanco BL 519 373 Silgranit Sink,Blanco ceramic Sink, Blanco Silgranit Sink, Blanco BL 519 373  Sink,Blanco Anadano Sink'),(15487,75,5,6083,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 450-U Undermount Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco has been producing the <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel kitchen sinks</span></a> for more than 90 years. Now Blanco has manufactured the new Blanco Andano 450-U, an undermount kitchen sink. Blanco Andano 450-U with its finest design is perfect to give your kitchen an outlook with geometrical designing. This undermount kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano 450-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 50cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n<li>High quality features consisting of a covered C-overflow and InFino drain system – gracefully integrated and easy-care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n\r<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15488,75,0,6083,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 450-U Undermount Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco has been producing the <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel kitchen sinks</span></a> for more than 90 years. Now Blanco has manufactured the new Blanco Andano 450-U, an undermount kitchen sink. Blanco Andano 450-U with its finest design is perfect to give your kitchen an outlook with geometrical designing. This undermount kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano 450-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 50cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n<li>High quality features consisting of a covered C-overflow and InFino drain system – gracefully integrated and easy-care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n\r<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15489,155,0,6083,'Exclude'),(15490,85,5,6084,'Blanco BL 518 315 Sink, Blanco ceramic Sink, Blanco Silgranit Sink, Blanco Anadano Sink, buy Blanco  Anadano Sink'),(15491,85,0,6084,'Blanco BL 518 315 Sink, Blanco ceramic Sink, Blanco Silgranit Sink, Blanco Anadano Sink, buy Blanco  Anadano Sink'),(15492,75,5,6084,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 500-IF Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with over 90 years&rsquo; experience as a kitchen appliances manufacturer has been assembling exceeding <a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel kitchen sinks</span></a>. Now it has engineered the Blanco Andano 500-IF, an inset kitchen sink. Blanco Andano 500-IF with its finest design is just the right one sink to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano 500-IF, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 60cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>For installation from above or undermount installation</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n<li>High quality features consisting of a covered C-overflow&trade; and modern basket strainer</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15493,75,0,6084,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 500-IF Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with over 90 years&rsquo; experience as a kitchen appliances manufacturer has been assembling exceeding <a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel kitchen sinks</span></a>. Now it has engineered the Blanco Andano 500-IF, an inset kitchen sink. Blanco Andano 500-IF with its finest design is just the right one sink to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano 500-IF, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 60cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>For installation from above or undermount installation</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n<li>High quality features consisting of a covered C-overflow&trade; and modern basket strainer</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15494,155,0,6084,'Exclude'),(15495,85,5,6085,'Buy Blanco BL 518 313 Sink, Blanco Sink sale, cheap Blanco Anadano Sinks, best Blanco Anadano Sinks,Blanco BL 518 313 Sink'),(15496,85,0,6085,'Buy Blanco BL 518 313 Sink, Blanco Sink sale, cheap Blanco Anadano Sinks, best Blanco Anadano Sinks,Blanco BL 518 313 Sink'),(15497,75,5,6085,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 500-U Undermount Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with its more than 90 years&rsquo; experience in crafting the <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel kitchen sinks </span></a>has now introduced the Blanco Andano 500-U, an undermount kitchen sink. Blanco Andano 500-U with its finest design is just the right one sink to give your kitchen an outlook with geometrical designing. This undermount kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano 500-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 60cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n<li>High quality features consisting of a covered c-overflow&trade; and modern basket strainer</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n\r'),(15498,75,0,6085,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 500-U Undermount Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with its more than 90 years&rsquo; experience in crafting the <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel kitchen sinks </span></a>has now introduced the Blanco Andano 500-U, an undermount kitchen sink. Blanco Andano 500-U with its finest design is just the right one sink to give your kitchen an outlook with geometrical designing. This undermount kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano 500-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 60cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n<li>High quality features consisting of a covered c-overflow&trade; and modern basket strainer</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n\r'),(15499,155,0,6085,'Exclude'),(15500,85,5,6086,'Andano 700-IF S/ST, best Sink, Blanco Andano 700-IF S/ST Sink, Anadano Sink deals, Blanco stylish Sinks'),(15501,85,0,6086,'Andano 700-IF S/ST, best Sink, Blanco Andano 700-IF S/ST Sink, Anadano Sink deals, Blanco stylish Sinks'),(15502,75,5,6086,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 700-IF Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco being a renowned expert in producing the <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings forth the Blanco Andano 700-IF, an inset sink. Blanco Andano 700-IF with its finest design is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano 700-IF, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This stainless steel sink has 80cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>For installation from above or undermount installation</li>\n<li>Unique composition of optical and functional elements</li>\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\n<li>High quality features consisting of a covered C-overflow&trade; and modern basket strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15503,75,0,6086,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 700-IF Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco being a renowned expert in producing the <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings forth the Blanco Andano 700-IF, an inset sink. Blanco Andano 700-IF with its finest design is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano 700-IF, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This stainless steel sink has 80cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>For installation from above or undermount installation</li>\n<li>Unique composition of optical and functional elements</li>\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\n<li>High quality features consisting of a covered C-overflow&trade; and modern basket strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15504,155,0,6086,'Exclude'),(15505,85,5,6087,'Blanco BL 518 614 Sink, Blanco ceramic Sink, Blanco Silgranit Sink, Blanco Anadano Sink, buy Blanco Sink'),(15506,85,0,6087,'Blanco BL 518 614 Sink, Blanco ceramic Sink, Blanco Silgranit Sink, Blanco Anadano Sink, buy Blanco Sink'),(15507,75,5,6087,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 700-U Undermount Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with more than 90 years&rsquo; experience as a renowned manufacturer in engineering the high-quality <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings forth the Blanco Andano 700-U, an undermount kitchen sink.Blanco Andano 700-U with its finest design is perfect to give your kitchen an outlook with geometrical designing. This undermount kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano 700-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This stainless steel sink has 80cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n<li>High quality features consisting of a covered C-overflow and InFino drain system – gracefully integrated and easy-care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n\r\n'),(15508,75,0,6087,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 700-U Undermount Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with more than 90 years&rsquo; experience as a renowned manufacturer in engineering the high-quality <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings forth the Blanco Andano 700-U, an undermount kitchen sink.Blanco Andano 700-U with its finest design is perfect to give your kitchen an outlook with geometrical designing. This undermount kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano 700-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This stainless steel sink has 80cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n<li>High quality features consisting of a covered C-overflow and InFino drain system – gracefully integrated and easy-care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n\r\n'),(15509,155,0,6087,'Exclude'),(15510,85,5,6088,'Blanco BL467789 Sink, Blanco Sink, Stainless Steel Sink, Blanco Best Sinks , Blanco BL467789 Sink'),(15511,85,0,6088,'Blanco BL467789 Sink, Blanco Sink, Stainless Steel Sink, Blanco Best Sinks , Blanco BL467789 Sink'),(15512,75,5,6088,'<style>#html-body [data-pb-style=XXE3WUH]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"XXE3WUH\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Andano 340/340-U Undermount Stainless Steel Kitchen Sink </strong></span></p>\r\n<p>Blanco famous for its many years\' expertise in manufacturing high-quality <a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings to you the Blanco Andano 340/340-U, an undermount kitchen sink. Blanco Andano 340/340-U comes with equal sized twin bowls to provide an adequate work space. This undermount kitchen sink with its geometrical design will certainly provide a focal point for your modern kitchen. Blanco Andano 340/340-U, in addition, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1/2\" basket strainer waste and a fixing kit. This stainless steel sink has 80cm cabinet width and the depth of both bowls is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\r\n<li>Bowl(s) depth: 175mm</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Style: Double Bowl SS Sink</li>\r\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow® and modern basket strainer</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1/2\" basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n\r\n</div></div></div>'),(15513,75,0,6088,'<style>#html-body [data-pb-style=XXE3WUH]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"XXE3WUH\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Andano 340/340-U Undermount Stainless Steel Kitchen Sink </strong></span></p>\r\n<p>Blanco famous for its many years\' expertise in manufacturing high-quality <a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings to you the Blanco Andano 340/340-U, an undermount kitchen sink. Blanco Andano 340/340-U comes with equal sized twin bowls to provide an adequate work space. This undermount kitchen sink with its geometrical design will certainly provide a focal point for your modern kitchen. Blanco Andano 340/340-U, in addition, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1/2\" basket strainer waste and a fixing kit. This stainless steel sink has 80cm cabinet width and the depth of both bowls is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\r\n<li>Bowl(s) depth: 175mm</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Style: Double Bowl SS Sink</li>\r\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow® and modern basket strainer</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1/2\" basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n\r\n</div></div></div>'),(15514,155,0,6088,'Exclude'),(15515,85,5,6089,'Cheap Blanco Anadano Sinks, best Blanco Anadano Sinks,Blanco Andano 400/400-IF S/ST , Andano 400/400-IF S/ST Sink'),(15516,85,0,6089,'Cheap Blanco Anadano Sinks, best Blanco Anadano Sinks,Blanco Andano 400/400-IF S/ST , Andano 400/400-IF S/ST Sink'),(15517,75,5,6089,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 400/400-IF Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p><a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"><strong>Blanco</strong></span></a> has been producing the high-quality <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel kitchen sinks</span></a> for more than 90 years. Now Blanco has manufactured the Blanco Andano 400/400-IF, an inset kitchen sink. Blanco Andano 400/400-IF comes with equal sized twin bowls to provide an adequate work space. This inset kitchen sink with its geometrical design will certainly provide a focal point for your modern kitchen. Blanco Andano 400/400-IF, in addition, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 90cm cabinet width and the depth of both bowls is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Inset</li>\n<li>Bowl(s) depth: 190mm</li>\r\n<li>Cabinet width: 900mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Double Bowl SS Sink</li>\n<li>Large bowl capacity and fully usable base</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>Elegant IF flat-rim for flushmount and for installation from above</li>\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow and InFino drain system – gracefully integrated and easy-care</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15518,75,0,6089,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 400/400-IF Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p><a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"><strong>Blanco</strong></span></a> has been producing the high-quality <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel kitchen sinks</span></a> for more than 90 years. Now Blanco has manufactured the Blanco Andano 400/400-IF, an inset kitchen sink. Blanco Andano 400/400-IF comes with equal sized twin bowls to provide an adequate work space. This inset kitchen sink with its geometrical design will certainly provide a focal point for your modern kitchen. Blanco Andano 400/400-IF, in addition, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. This stainless steel sink has 90cm cabinet width and the depth of both bowls is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Inset</li>\n<li>Bowl(s) depth: 190mm</li>\r\n<li>Cabinet width: 900mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Double Bowl SS Sink</li>\n<li>Large bowl capacity and fully usable base</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>Elegant IF flat-rim for flushmount and for installation from above</li>\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow and InFino drain system – gracefully integrated and easy-care</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15519,155,0,6089,'Exclude'),(15520,85,5,6090,'Blanco ANDANO 400/400-U Stainless Steel Undermount Sink'),(15521,85,0,6090,'Blanco ANDANO 400/400-U Stainless Steel Undermount Sink'),(15522,75,5,6090,'<style>#html-body [data-pb-style=F5J51V9]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"F5J51V9\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Andano 400/400-U Stainless Steel Undermount Sink</strong></span></p>\r\n<p id=\"CJ6EF8H\" style=\"text-align: justify;\">Blanco Andano 400/400-U Stainless Steel Undermount sinks bring sophistication to your kitchen with their timeless design and durable stainless steel construction. Blanco Andano 400 is a compact yet stylish sink that fits seamlessly into smaller kitchen spaces, offering both practicality and aesthetic appeal. Whether you choose the spacious Blanco Andano or the more compact Blanco Andano 400, you can trust in the quality and elegance that define the entire Andano series.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\r\n<li>Bowl(s) depth: 195mm</li>\r\n<li>Cabinet width: 900mm</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Style: Double Bowl SS Sink</li>\r\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow® and modern basket strainer</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1/2\" basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul></div></div></div>'),(15523,75,0,6090,'<style>#html-body [data-pb-style=F5J51V9]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"F5J51V9\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Andano 400/400-U Stainless Steel Undermount Sink</strong></span></p>\r\n<p id=\"CJ6EF8H\" style=\"text-align: justify;\">Blanco Andano 400/400-U Stainless Steel Undermount sinks bring sophistication to your kitchen with their timeless design and durable stainless steel construction. Blanco Andano 400 is a compact yet stylish sink that fits seamlessly into smaller kitchen spaces, offering both practicality and aesthetic appeal. Whether you choose the spacious Blanco Andano or the more compact Blanco Andano 400, you can trust in the quality and elegance that define the entire Andano series.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\r\n<li>Bowl(s) depth: 195mm</li>\r\n<li>Cabinet width: 900mm</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Style: Double Bowl SS Sink</li>\r\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow® and modern basket strainer</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1/2\" basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul></div></div></div>'),(15524,155,0,6090,'Exclude'),(15525,85,5,6091,'Blanco Claron 500-U Durinox&trade; Stainless Steel Undermount Sink'),(15526,85,0,6091,'Blanco Claron 500-U Durinox&trade; Stainless Steel Undermount Sink'),(15527,75,5,6091,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 500-U Durinox Stainless Steel Undermount Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 190mm</li>\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Innovative surface: highly resistant to scratches</li>\n<li>Pure, elegant design with concise corner radii of 10 mm</li>\n<li>With the covered C-overflow&trade; with Durinox&trade; surface</li>\n<li>InFino&trade; drain system &ndash; elegantly integrated and easy-care</li>\n\r<li>Matt velvet looks with a homogeneous surface structure, and pleasantly warm to the touch</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra-deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; InFino&trade; basket strainer</li>\n<li>Fixing kit included</li>\r\n</ul>\r\n\r'),(15528,75,0,6091,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 500-U Durinox Stainless Steel Undermount Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 190mm</li>\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Innovative surface: highly resistant to scratches</li>\n<li>Pure, elegant design with concise corner radii of 10 mm</li>\n<li>With the covered C-overflow&trade; with Durinox&trade; surface</li>\n<li>InFino&trade; drain system &ndash; elegantly integrated and easy-care</li>\n\r<li>Matt velvet looks with a homogeneous surface structure, and pleasantly warm to the touch</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra-deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; InFino&trade; basket strainer</li>\n<li>Fixing kit included</li>\r\n</ul>\r\n\r'),(15529,155,0,6091,'Exclude'),(15530,85,5,6092,'Blanco CLARON 700-U Durinox Stainless Steel Undermount Kitchen Sink'),(15531,85,0,6092,'Blanco CLARON 700-U Durinox Stainless Steel Undermount Kitchen Sink'),(15532,75,5,6092,'<p><span style=\"font-size: medium;\"><strong>Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: No</li>\n<li>No drainboard</li>\n<li>No Pop-up control</li>\n<li>Cabinet width: 800mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Installation: Undermount</li>\n<li>Overall size: 740 x 440mm</li>\n<li>Large bowl size: 700 x 400mm</li>\n<li>Version: Without Pop-up Waste</li>\n<li>Bowl Position: Universal Handing</li>\n<li>Sophisticated surface: Highly resistant to scratches</li>\n<li>Matt velvet Durinox finish is pleasantly warm to the touch</li>\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Concise 10 mm radius for a more refined design, without doing away with practical benefits</li>\n<li>Optimum utilisation of the bowl capacity thanks to extra-deep bowls and distinctively small radii</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit included</li>\n<li>Cut out: Template provided</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n<li>Waste and overflow ftting kit with space saving pipe</li>\n<li>Technical note: The undermount bowl edge is not closed at the corners</li>\n</ul>'),(15533,75,0,6092,'<p><span style=\"font-size: medium;\"><strong>Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: No</li>\n<li>No drainboard</li>\n<li>No Pop-up control</li>\n<li>Cabinet width: 800mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Installation: Undermount</li>\n<li>Overall size: 740 x 440mm</li>\n<li>Large bowl size: 700 x 400mm</li>\n<li>Version: Without Pop-up Waste</li>\n<li>Bowl Position: Universal Handing</li>\n<li>Sophisticated surface: Highly resistant to scratches</li>\n<li>Matt velvet Durinox finish is pleasantly warm to the touch</li>\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Concise 10 mm radius for a more refined design, without doing away with practical benefits</li>\n<li>Optimum utilisation of the bowl capacity thanks to extra-deep bowls and distinctively small radii</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit included</li>\n<li>Cut out: Template provided</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n<li>Waste and overflow ftting kit with space saving pipe</li>\n<li>Technical note: The undermount bowl edge is not closed at the corners</li>\n</ul>'),(15534,155,0,6092,'Exclude'),(15535,85,5,6093,'Blanco Delta-IF S/ST Sink, best Silgranit Sink, Blanco Delta-IF S/ST , Blanco classic Sinks,Blanco Delta Sink'),(15536,85,0,6093,'Blanco Delta-IF S/ST Sink, best Silgranit Sink, Blanco Delta-IF S/ST , Blanco classic Sinks,Blanco Delta Sink'),(15537,75,5,6093,'<p><span style=\"font-size: medium;\"><strong>Blanco Delta-IF Inset Stainless Steel Kitchen Sink RH Bowl </strong></span></p>\r\n<p>Blanco has been a worldwide renowned expert in engineering the exceeding <a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel kitchen sinks</span></a> for over 90 years has now manufactured the Blanco Delta-IF. This compact kitchen sink with its ultra modern designing, doesn&rsquo;t require too much space to be positioned on your worktop surface. This stainless steel kitchen sinkhas the Blanco IF edge profile which elevates the sink just 1mm above the worktops, boasting the beauty of your kitchen. This inset kitchen sink has an excellent and unyielding design with the corner installation and the main bowl of this compact kitchen sink is available only in right-handedfitting also including an additional half bowl. Blanco Delta-IF as an inset kitchen sink comes with a 3 &frac12;&rdquo; basket strainer and a 3 &frac12;&rdquo; pop-up waste for the main bowl. It also includes a 1 &frac12;&rdquo; basket strainer and a stainless steel colander for the half bowl and also featuring a waste fitting with a space-saving pipe. This stainless steel kitchen sink is neatly fitted in a 70cm cabinet width. The depth of the main bowl is 175mm while the half bowl has depth of 120mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Cabinet width: 600mm</li>\n<li>Overall size: 1057 x 575mm</li>\n<li>Small bowl size: 203 x 287 x 120mm</li>\n<li>Large bowl size: 370 x 427 x 175mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>Installation: Inset / Corner</li>\n<li>Ergonomic trapezoid bowl</li>\n<li>Recessed draining and working area</li>\n<li>Extra large bowl diagonal to accommodate bulky items</li>\r\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer</li>\n<li>Also with the attractive IF flat rim: Flexible for flushmount installation or inserted from above for a flushmount effect</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Stainless steel colander for additional bowl</li>\r\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; pop-up waste for the main bowl</li>\r\n<li>3 1&sol;2&quot; and 1 1&sol;2&quot; basket strainer</li>\r\n</ul>\r\n'),(15538,75,0,6093,'<p><span style=\"font-size: medium;\"><strong>Blanco Delta-IF Inset Stainless Steel Kitchen Sink RH Bowl </strong></span></p>\r\n<p>Blanco has been a worldwide renowned expert in engineering the exceeding <a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel kitchen sinks</span></a> for over 90 years has now manufactured the Blanco Delta-IF. This compact kitchen sink with its ultra modern designing, doesn&rsquo;t require too much space to be positioned on your worktop surface. This stainless steel kitchen sinkhas the Blanco IF edge profile which elevates the sink just 1mm above the worktops, boasting the beauty of your kitchen. This inset kitchen sink has an excellent and unyielding design with the corner installation and the main bowl of this compact kitchen sink is available only in right-handedfitting also including an additional half bowl. Blanco Delta-IF as an inset kitchen sink comes with a 3 &frac12;&rdquo; basket strainer and a 3 &frac12;&rdquo; pop-up waste for the main bowl. It also includes a 1 &frac12;&rdquo; basket strainer and a stainless steel colander for the half bowl and also featuring a waste fitting with a space-saving pipe. This stainless steel kitchen sink is neatly fitted in a 70cm cabinet width. The depth of the main bowl is 175mm while the half bowl has depth of 120mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Cabinet width: 600mm</li>\n<li>Overall size: 1057 x 575mm</li>\n<li>Small bowl size: 203 x 287 x 120mm</li>\n<li>Large bowl size: 370 x 427 x 175mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>Installation: Inset / Corner</li>\n<li>Ergonomic trapezoid bowl</li>\n<li>Recessed draining and working area</li>\n<li>Extra large bowl diagonal to accommodate bulky items</li>\r\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer</li>\n<li>Also with the attractive IF flat rim: Flexible for flushmount installation or inserted from above for a flushmount effect</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Stainless steel colander for additional bowl</li>\r\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; pop-up waste for the main bowl</li>\r\n<li>3 1&sol;2&quot; and 1 1&sol;2&quot; basket strainer</li>\r\n</ul>\r\n'),(15539,155,0,6093,'Exclude'),(15540,85,5,6094,'Best Subline 375-U CERAMIC, Stylish Blanco Sink, Buy Blanco  Sink, buy Blanco  Subline 375-U CERAMIC'),(15541,85,0,6094,'Best Subline 375-U CERAMIC, Stylish Blanco Sink, Buy Blanco  Sink, buy Blanco  Subline 375-U CERAMIC'),(15542,75,5,6094,'<style>#html-body [data-pb-style=GX3AEV1],#html-body [data-pb-style=WM02HO9]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"GX3AEV1\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Subline 375-U Undermount Ceramic Kitchen Sink </strong></span></p>\r\n<p>Blanco renowned for its long time expertise in producing excellent <a href=\"/brands/blanco/blanco-ceramic-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\"> ceramic kitchen sinks</span></a> now brings to you the Blanco Subline 375-U, an undermount sink. Blanco Subline 375-U is a large sized sink which can be installed into the kitchen as a main sink bowl. This undermount sink is a perfect choice to be used in both traditional and contemporary designed kitchens. Blanco Subline 375-U with its crystal white glossy finishing, will become the focal point of your kitchen. Blanco Subline 375-U, being an undermount sink comes with two 3 ½\" basket strainer waste for the main sink bowl and an overflow. This ceramic sink has 45cm cabinet width with 364x386xR15 cut out size and the depth of the bowl is 185mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Bowl depth: 185mm</li>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Material: Ceramic</li>\r\n<li>Finish: Crystal white</li>\r\n<li>Style: Single Bowl Sink</li>\r\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow and InFino strainer system</li>\r\n<li>Maximum bowl size provided by the very best in production and mounting technology</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>Two 3 1/2\" basket strainers</li>\r\n</ul></div></div></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"WM02HO9\"></div></div>'),(15543,75,0,6094,'<style>#html-body [data-pb-style=GX3AEV1],#html-body [data-pb-style=WM02HO9]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"GX3AEV1\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Subline 375-U Undermount Ceramic Kitchen Sink </strong></span></p>\r\n<p>Blanco renowned for its long time expertise in producing excellent <a href=\"/brands/blanco/blanco-ceramic-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\"> ceramic kitchen sinks</span></a> now brings to you the Blanco Subline 375-U, an undermount sink. Blanco Subline 375-U is a large sized sink which can be installed into the kitchen as a main sink bowl. This undermount sink is a perfect choice to be used in both traditional and contemporary designed kitchens. Blanco Subline 375-U with its crystal white glossy finishing, will become the focal point of your kitchen. Blanco Subline 375-U, being an undermount sink comes with two 3 ½\" basket strainer waste for the main sink bowl and an overflow. This ceramic sink has 45cm cabinet width with 364x386xR15 cut out size and the depth of the bowl is 185mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Bowl depth: 185mm</li>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Material: Ceramic</li>\r\n<li>Finish: Crystal white</li>\r\n<li>Style: Single Bowl Sink</li>\r\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow and InFino strainer system</li>\r\n<li>Maximum bowl size provided by the very best in production and mounting technology</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>Two 3 1/2\" basket strainers</li>\r\n</ul></div></div></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"WM02HO9\"></div></div>'),(15544,155,0,6094,'Exclude'),(15545,85,5,6095,'BlancoSubline 500-U CERAMIC, best Attika Sink, classic Sink, Blanco  Silgranit Sinks,Blanco Sink Deals, Blanco Sink Sales'),(15546,85,0,6095,'BlancoSubline 500-U CERAMIC, best Attika Sink, classic Sink, Blanco  Silgranit Sinks,Blanco Sink Deals, Blanco Sink Sales'),(15547,75,5,6095,'<p><span style=\"font-size: medium;\"><strong>Blanco Subline 500-U Undermount Ceramic Kitchen Sink</strong></span></p>\r\n<p>Blanco being nearly a century experienced manufacturer now produces the Blanco Subline 500-U, an undermount ceramic kitchen sink. Blanco Subline 500-U is a large sized sink which can be installed into the kitchen as a main sink bowl. Moreover it will also make a great impression as the main sink with its five unique and eye-catching colours. This <a href=\"/brands/blanco/blanco-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> PuraPlus ceramic sink</span></a> contains a 3 &frac12;&rdquo; basket strainer and an overflow kit. It also has a waste fitting with a space-saving pipe. This undermount sink has 60 cm cabinet width along with 490x386xR15 cut out size and the depth of the main bowl is 200mm with 15mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl(s) depth: 185mm</li>\n<li>Material: Ceramic</li>\n<li>Style: Single Bowl Sink</li>\n<li>Timelessly elegant, contoured bowl design</li>\n<li>Elegant and hygienic: the covered C-overflow and InFino strainer system</li>\n<li>Maximum bowl size provided by the very best in production and mounting technology</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\r\n'),(15548,75,0,6095,'<p><span style=\"font-size: medium;\"><strong>Blanco Subline 500-U Undermount Ceramic Kitchen Sink</strong></span></p>\r\n<p>Blanco being nearly a century experienced manufacturer now produces the Blanco Subline 500-U, an undermount ceramic kitchen sink. Blanco Subline 500-U is a large sized sink which can be installed into the kitchen as a main sink bowl. Moreover it will also make a great impression as the main sink with its five unique and eye-catching colours. This <a href=\"/brands/blanco/blanco-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> PuraPlus ceramic sink</span></a> contains a 3 &frac12;&rdquo; basket strainer and an overflow kit. It also has a waste fitting with a space-saving pipe. This undermount sink has 60 cm cabinet width along with 490x386xR15 cut out size and the depth of the main bowl is 200mm with 15mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl(s) depth: 185mm</li>\n<li>Material: Ceramic</li>\n<li>Style: Single Bowl Sink</li>\n<li>Timelessly elegant, contoured bowl design</li>\n<li>Elegant and hygienic: the covered C-overflow and InFino strainer system</li>\n<li>Maximum bowl size provided by the very best in production and mounting technology</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\r\n'),(15549,155,0,6095,'Exclude'),(15550,85,5,6096,'Blanco Subline 350/150-U CERAMIC, Blanco Sink sale, Best Blanco classic Sinks,Buy Blanco  Sink'),(15551,85,0,6096,'Blanco Subline 350/150-U CERAMIC, Blanco Sink sale, Best Blanco classic Sinks,Buy Blanco  Sink'),(15552,75,5,6096,'<style>#html-body [data-pb-style=E6GQOYH],#html-body [data-pb-style=T911G1M]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"E6GQOYH\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Subline 350/150-U Undermount Ceramic Kitchen Sink </strong></span></p>\r\n<p>Blanco renowned for its long time expertise in producing excellent <a href=\"/brands/blanco/blanco-ceramic-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\"> ceramic kitchen sinks</span></a> now brings to you the Blanco Subline 350/150-U. It is an undermount sink from the Subline family of Blanco ceramic kitchen sinks. Blanco Subline 350/150-U comes in two sink bowls i.e. the main sink bowl and a half sink bowl. Blanco Subline 350/150-U with its two bowls provides sufficient work space in the kitchen. This undermount sink is available in six different eye-catching colours. This ceramic sink contains a 3 ½” basket strainer and an overflow kit. It also has a waste fitting with a space-saving pipe. This undermount sink has 60 cm cabinet width and has 515x386xR15 cut out size with 15mm corner radius. The depth of the main bowl is 185mm and the half bowl has depth of 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Overall size: 567mm x 456mm</li>\r\n<li>Small bowl size: 150 x 396 x 130mm</li>\r\n<li>Large bowl size: 350 x 396 x 185mm</li>\r\n<li>Material: Ceramic</li>\r\n<li>Finish: Crystal white</li>\r\n<li>Style: One &amp; Half Bowl Sink</li>\r\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow and InFino strainer system</li>\r\n<li>Maximum bowl size provided by the very best in production and mounting technology</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space saving pipe</li>\r\n<li>Two 3 1/2\" basket strainers</li>\r\n<li>1/2\" bowl non close</li>\r\n</ul></div></div></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"T911G1M\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"></div></div></div>'),(15553,75,0,6096,'<style>#html-body [data-pb-style=E6GQOYH],#html-body [data-pb-style=T911G1M]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"E6GQOYH\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Subline 350/150-U Undermount Ceramic Kitchen Sink </strong></span></p>\r\n<p>Blanco renowned for its long time expertise in producing excellent <a href=\"/brands/blanco/blanco-ceramic-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\"> ceramic kitchen sinks</span></a> now brings to you the Blanco Subline 350/150-U. It is an undermount sink from the Subline family of Blanco ceramic kitchen sinks. Blanco Subline 350/150-U comes in two sink bowls i.e. the main sink bowl and a half sink bowl. Blanco Subline 350/150-U with its two bowls provides sufficient work space in the kitchen. This undermount sink is available in six different eye-catching colours. This ceramic sink contains a 3 ½” basket strainer and an overflow kit. It also has a waste fitting with a space-saving pipe. This undermount sink has 60 cm cabinet width and has 515x386xR15 cut out size with 15mm corner radius. The depth of the main bowl is 185mm and the half bowl has depth of 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Overall size: 567mm x 456mm</li>\r\n<li>Small bowl size: 150 x 396 x 130mm</li>\r\n<li>Large bowl size: 350 x 396 x 185mm</li>\r\n<li>Material: Ceramic</li>\r\n<li>Finish: Crystal white</li>\r\n<li>Style: One &amp; Half Bowl Sink</li>\r\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow and InFino strainer system</li>\r\n<li>Maximum bowl size provided by the very best in production and mounting technology</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space saving pipe</li>\r\n<li>Two 3 1/2\" basket strainers</li>\r\n<li>1/2\" bowl non close</li>\r\n</ul></div></div></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"T911G1M\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"></div></div></div>'),(15554,155,0,6096,'Exclude'),(15555,75,5,6097,'<p><span style=\"font-size: medium;\"><strong>Blanco Etagon 700-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation : Undermount</li>\n<li>Bowl depth: 190mm</li>\n<li>Cabinet width: 800mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Integrated step creates an additional functions level</li>\n<li>Innovative system concept with versatile ETAGON rails</li>\n<li>Generous staggered bowl with the functionality of a sink centre</li>\n<li>For undermount installation, ideal in combination with high quality worktops</li>\n<li>High-quality features with the covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space-saving pipe</li>\n<li>2 x ETAGON rails in stainless steel</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15556,75,0,6097,'<p><span style=\"font-size: medium;\"><strong>Blanco Etagon 700-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation : Undermount</li>\n<li>Bowl depth: 190mm</li>\n<li>Cabinet width: 800mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Integrated step creates an additional functions level</li>\n<li>Innovative system concept with versatile ETAGON rails</li>\n<li>Generous staggered bowl with the functionality of a sink centre</li>\n<li>For undermount installation, ideal in combination with high quality worktops</li>\n<li>High-quality features with the covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space-saving pipe</li>\n<li>2 x ETAGON rails in stainless steel</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15557,155,0,6097,'Exclude'),(15558,85,5,6098,'Blanco Etagon 700-IF Stainless Steel Inset Sink'),(15559,85,0,6098,'Blanco Etagon 700-IF Stainless Steel Inset Sink'),(15560,75,5,6098,'<p><span style=\"font-size: medium;\"><strong>Blanco Etagon 700-IF Stainless Steel Inset Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Integrated step creates an additional functions level</li>\r\n<li>Innovative system concept with versatile ETAGON rails</li>\r\n<li>Generous staggered bowl with the functionality of a sink centre</li>\n<li>High-quality features consisting of a covered C-overflow&trade; and InFino&trade; strainer &ndash; gracefully integrated and easy care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>With Etagon rails in stainless steel</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Waste fitting with space-saving pipe</li>\n</ul>'),(15561,75,0,6098,'<p><span style=\"font-size: medium;\"><strong>Blanco Etagon 700-IF Stainless Steel Inset Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Integrated step creates an additional functions level</li>\r\n<li>Innovative system concept with versatile ETAGON rails</li>\r\n<li>Generous staggered bowl with the functionality of a sink centre</li>\n<li>High-quality features consisting of a covered C-overflow&trade; and InFino&trade; strainer &ndash; gracefully integrated and easy care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>With Etagon rails in stainless steel</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Waste fitting with space-saving pipe</li>\n</ul>'),(15562,155,0,6098,'Exclude'),(15563,85,5,6099,'Blanco Etagon 700-IF/A Stainless Steel Inset Sink'),(15564,85,0,6099,'Blanco Etagon 700-IF/A Stainless Steel Inset Sink'),(15565,75,5,6099,'<p><span style=\"font-size: medium;\"><strong>Blanco Etagon 700-IF/A Stainless Steel Inset Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Integrated step creates an additional functions level</li>\r\n<li>Innovative system concept with versatile ETAGON rails</li>\n<li>Generous staggered bowl with the functionality of a sink centre</li>\n<li>High-quality features consisting of a covered C-overflow&trade; and InFino&trade; strainer &ndash; gracefully integrated and easy care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>With Etagon rails in stainless steel</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Waste fitting with space-saving pipe</li>\n</ul>\n'),(15566,75,0,6099,'<p><span style=\"font-size: medium;\"><strong>Blanco Etagon 700-IF/A Stainless Steel Inset Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Integrated step creates an additional functions level</li>\r\n<li>Innovative system concept with versatile ETAGON rails</li>\n<li>Generous staggered bowl with the functionality of a sink centre</li>\n<li>High-quality features consisting of a covered C-overflow&trade; and InFino&trade; strainer &ndash; gracefully integrated and easy care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>With Etagon rails in stainless steel</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Waste fitting with space-saving pipe</li>\n</ul>\n'),(15567,155,0,6099,'Exclude'),(15568,85,5,6100,'Blanco Etagon 500-U Ceramic Undermount Sink - Crystal White'),(15569,85,0,6100,'Blanco Etagon 500-U Ceramic Undermount Sink - Crystal White'),(15570,75,5,6100,'<style>#html-body [data-pb-style=T74ABWB]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"T74ABWB\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Etagon 500-U Ceramic Undermount Sink - Crystal White</strong></span></p>\r\n<p id=\"AU0DSF8\" style=\"text-align: justify;\">Blanco Etagon 500 U is a ceramic undermount sink that seamlessly integrates into your kitchen counter, offering a seamless and minimalist appearance. Blanco Etagon 500-U combines practicality with contemporary design, featuring a smooth, undermount installation for a clean and modern aesthetic in your kitchen space. The Blanco Etagon 500 series presents versatile options for your kitchen, and Blanco Etagon 500 stands out with its robust design and spacious basin, providing both style and functionality.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Bowl depth: 275mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Ceramic</li>\r\n<li>Finish: Crystal White</li>\r\n<li>Style: Single Bowl Sink</li>\r\n<li>Integrated step creates an additional functions level</li>\r\n<li>Innovative system concept with versatile Etagon rails</li>\r\n<li>Generous staggered bowl with the functionality of a sink centre</li>\r\n<li>High-quality features with the covered C-overflow™ and InFino™ drain system – elegantly integrated and extremely hygenic.</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>With Etagon rails in stainless steel</li>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 /2\" basket strainer</li>\r\n</ul></div></div></div>'),(15571,75,0,6100,'<style>#html-body [data-pb-style=T74ABWB]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"T74ABWB\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Etagon 500-U Ceramic Undermount Sink - Crystal White</strong></span></p>\r\n<p id=\"AU0DSF8\" style=\"text-align: justify;\">Blanco Etagon 500 U is a ceramic undermount sink that seamlessly integrates into your kitchen counter, offering a seamless and minimalist appearance. Blanco Etagon 500-U combines practicality with contemporary design, featuring a smooth, undermount installation for a clean and modern aesthetic in your kitchen space. The Blanco Etagon 500 series presents versatile options for your kitchen, and Blanco Etagon 500 stands out with its robust design and spacious basin, providing both style and functionality.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Bowl depth: 275mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Ceramic</li>\r\n<li>Finish: Crystal White</li>\r\n<li>Style: Single Bowl Sink</li>\r\n<li>Integrated step creates an additional functions level</li>\r\n<li>Innovative system concept with versatile Etagon rails</li>\r\n<li>Generous staggered bowl with the functionality of a sink centre</li>\r\n<li>High-quality features with the covered C-overflow™ and InFino™ drain system – elegantly integrated and extremely hygenic.</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>With Etagon rails in stainless steel</li>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 /2\" basket strainer</li>\r\n</ul></div></div></div>'),(15572,155,0,6100,'Exclude'),(15573,85,5,6101,'Blanco Etagon 6 Ceramic Inset Sink'),(15574,85,0,6101,'Blanco Etagon 6 Ceramic Inset Sink'),(15575,75,5,6101,'<style>#html-body [data-pb-style=SGP1KL5]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"SGP1KL5\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Etagon 6 Ceramic Inset Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><span style=\"font-size: medium;\">Blanco Etagon 6 is a sophisticated kitchen sink that combines modern design with practical functionality, featuring six precisely angled corners for a contemporary aesthetic. With its durable stainless steel construction and innovative design, Blanco Etagon 6 offers a spacious and efficient washing area for all your kitchen needs. The Blanco Etagon collection showcases elegant and functional sinks, and Blanco Etagon 6 stands out as a stylish centerpiece in any kitchen, providing both form and function.</span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\r\n<li>Bowl depth: 220mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Ceramic</li>\r\n<li>Style: Single Bowl Sink</li>\r\n<li>Finish: Crystal white</li>\r\n<li>Integrated step creates an additional functions level</li>\r\n<li>Innovative system concept with versatile Etagon rails</li>\r\n<li>Generous staggered bowl with the functionality of a sink centre</li>\r\n<li>High-quality features with the covered C-overflow™ and InFino™ drain system – elegantly integrated and extremely hygenic.</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>With Etagon rails in stainless steel</li>\r\n<li>3 1/2\" basket strainer</li>\r\n<li>Waste fitting with space-saving pipe</li>\r\n</ul></div></div></div>'),(15576,75,0,6101,'<style>#html-body [data-pb-style=SGP1KL5]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"SGP1KL5\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Etagon 6 Ceramic Inset Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><span style=\"font-size: medium;\">Blanco Etagon 6 is a sophisticated kitchen sink that combines modern design with practical functionality, featuring six precisely angled corners for a contemporary aesthetic. With its durable stainless steel construction and innovative design, Blanco Etagon 6 offers a spacious and efficient washing area for all your kitchen needs. The Blanco Etagon collection showcases elegant and functional sinks, and Blanco Etagon 6 stands out as a stylish centerpiece in any kitchen, providing both form and function.</span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\r\n<li>Bowl depth: 220mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Ceramic</li>\r\n<li>Style: Single Bowl Sink</li>\r\n<li>Finish: Crystal white</li>\r\n<li>Integrated step creates an additional functions level</li>\r\n<li>Innovative system concept with versatile Etagon rails</li>\r\n<li>Generous staggered bowl with the functionality of a sink centre</li>\r\n<li>High-quality features with the covered C-overflow™ and InFino™ drain system – elegantly integrated and extremely hygenic.</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>With Etagon rails in stainless steel</li>\r\n<li>3 1/2\" basket strainer</li>\r\n<li>Waste fitting with space-saving pipe</li>\r\n</ul></div></div></div>'),(15577,155,0,6101,'Exclude'),(15578,85,5,6102,'Blanco Villae Farmhouse Single Ceramic Inset Sink'),(15579,85,0,6102,'Blanco Villae Farmhouse Single Ceramic Inset Sink'),(15580,75,5,6102,'<p><span style=\"font-size: medium;\"><strong>Blanco Villae Farmhouse Single Ceramic Inset Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 196mm</li>\n<li>Cabinet width: 800mm</li>\n<li>Material: Ceramic</li>\n<li>Finish: Crystal White</li>\n<li>Style: Single Bowl Sink</li>\n<li>Tastefully traditional with modern design updates for that country style look</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>With 3 &sol;2&quot; standard strainer</li>\r\n</ul>\r\n\r\n'),(15581,75,0,6102,'<p><span style=\"font-size: medium;\"><strong>Blanco Villae Farmhouse Single Ceramic Inset Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 196mm</li>\n<li>Cabinet width: 800mm</li>\n<li>Material: Ceramic</li>\n<li>Finish: Crystal White</li>\n<li>Style: Single Bowl Sink</li>\n<li>Tastefully traditional with modern design updates for that country style look</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>With 3 &sol;2&quot; standard strainer</li>\r\n</ul>\r\n\r\n'),(15582,155,0,6102,'Exclude'),(15583,85,5,6103,'Blanco Villae Farmhouse Double Ceramic Inset Sink'),(15584,85,0,6103,'Blanco Villae Farmhouse Double Ceramic Inset Sink'),(15585,75,5,6103,'<p><span style=\"font-size: medium;\"><strong>Blanco Villae Farmhouse Double Ceramic Inset Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\r\n<li>Installation: Inset</li>\n<li>Cabinet width: 800mm</li>\r\n<li>Bowl(s) depth: 195mm</li>\r\n<li>Material: Ceramic</li>\n<li>Finish: Crystal White</li>\n<li>Style: Double Bowl Sink</li>\n<li>Tastefully traditional with modern design updates for that country style look</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>With 2 x 3 &sol;2&quot;\' standard strainer</li>\n</ul>\r\n\r\n'),(15586,75,0,6103,'<p><span style=\"font-size: medium;\"><strong>Blanco Villae Farmhouse Double Ceramic Inset Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\r\n<li>Installation: Inset</li>\n<li>Cabinet width: 800mm</li>\r\n<li>Bowl(s) depth: 195mm</li>\r\n<li>Material: Ceramic</li>\n<li>Finish: Crystal White</li>\n<li>Style: Double Bowl Sink</li>\n<li>Tastefully traditional with modern design updates for that country style look</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>With 2 x 3 &sol;2&quot;\' standard strainer</li>\n</ul>\r\n\r\n'),(15587,155,0,6103,'Exclude'),(15588,85,5,6104,'Blanco Villae 1.5 Bowl Ceramic Inset Sink'),(15589,85,0,6104,'Blanco Villae 1.5 Bowl Ceramic Inset Sink'),(15590,75,5,6104,'<p><span style=\"font-size: medium;\"><strong>Blanco Villae 1.5 Bowl Ceramic Inset Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset/Undermount</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Bowl(s) depth: 190mm</li>\r\n<li>Material: Ceramic</li>\r\n<li>Finish: Crystal White</li>\r\n<li>Style: One & Half Bowl Sink</li>\r\n<li>Tastefully traditional with modern design updates for that country style look</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>With 2 x 3 &sol;2&quot; standard strainer</li>\r\n</ul>\r\n\r\n'),(15591,75,0,6104,'<p><span style=\"font-size: medium;\"><strong>Blanco Villae 1.5 Bowl Ceramic Inset Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset/Undermount</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Bowl(s) depth: 190mm</li>\r\n<li>Material: Ceramic</li>\r\n<li>Finish: Crystal White</li>\r\n<li>Style: One & Half Bowl Sink</li>\r\n<li>Tastefully traditional with modern design updates for that country style look</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>With 2 x 3 &sol;2&quot; standard strainer</li>\r\n</ul>\r\n\r\n'),(15592,155,0,6104,'Exclude'),(15593,85,5,6105,'Buy Andano 400-IF/A S/ST Sink, Blanco Sink sale, cheap Blanco Anadano Sinks, best Blanco Anadano Sinks,Blanco 400-IF/A S/ST'),(15594,85,0,6105,'Buy Andano 400-IF/A S/ST Sink, Blanco Sink sale, cheap Blanco Anadano Sinks, best Blanco Anadano Sinks,Blanco 400-IF/A S/ST'),(15595,75,5,6105,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 400-IF/A Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco, the name of perfection in producing the <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a>, now brings forth the Blanco Andano 400-IF/A, an inset sink.Blanco Andano 400-IF/A with its finest design is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. It also has two tap ledge holes in the flat back rim; these holes can be utilized to fix a tap and flush-controller. Blanco Andano 400-IF/A, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer with a pop-up waste and a fixing element set. This stainless steel sink has 45cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Elegant accessories optional available</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n<li>Elegantly designed wet area with an integrated tap ledge in just one worktop cut-out</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Fixing kit (sealing not included)</li>\n</ul>\n'),(15596,75,0,6105,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 400-IF/A Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco, the name of perfection in producing the <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a>, now brings forth the Blanco Andano 400-IF/A, an inset sink.Blanco Andano 400-IF/A with its finest design is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. It also has two tap ledge holes in the flat back rim; these holes can be utilized to fix a tap and flush-controller. Blanco Andano 400-IF/A, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer with a pop-up waste and a fixing element set. This stainless steel sink has 45cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Elegant accessories optional available</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n<li>Elegantly designed wet area with an integrated tap ledge in just one worktop cut-out</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Fixing kit (sealing not included)</li>\n</ul>\n'),(15597,155,0,6105,'Exclude'),(15598,85,5,6106,'Andano 500-IF/A S/ST Sink, best Silgranit Sink, Anadano Sink,Blanco Andano 500-IF/A S/ST, Blanco Anadano Sinks'),(15599,85,0,6106,'Andano 500-IF/A S/ST Sink, best Silgranit Sink, Anadano Sink,Blanco Andano 500-IF/A S/ST, Blanco Anadano Sinks'),(15600,75,5,6106,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 500-IF/A Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with more than 90 years&rsquo; experience in manufacturing the <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks </span></a>has now introduced the new Blanco Andano 500-IF/A, an inset kitchen sink from the Andano family of Blanco STEELART. Blanco Andano 500-IF/A with its finest design is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. It also has two tap ledge holes in the flat back rim; these holes can be utilized to fix a tap and flush-controller. Blanco Andano 500-IF/A, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer with a pop-up waste and a fixing element set. This stainless steel sink has 60cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n<li>Elegantly designed wet area with an integrated tap ledge in just one worktop cut-out</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer with pop up waste</li>\n<li>Fixing kit (sealing not included)</li>\n</ul>\n'),(15601,75,0,6106,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 500-IF/A Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with more than 90 years&rsquo; experience in manufacturing the <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks </span></a>has now introduced the new Blanco Andano 500-IF/A, an inset kitchen sink from the Andano family of Blanco STEELART. Blanco Andano 500-IF/A with its finest design is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. It also has two tap ledge holes in the flat back rim; these holes can be utilized to fix a tap and flush-controller. Blanco Andano 500-IF/A, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer with a pop-up waste and a fixing element set. This stainless steel sink has 60cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n<li>Elegantly designed wet area with an integrated tap ledge in just one worktop cut-out</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer with pop up waste</li>\n<li>Fixing kit (sealing not included)</li>\n</ul>\n'),(15602,155,0,6106,'Exclude'),(15603,85,5,6107,'Blanco Andano 700-IF/A S/ST Sink,Blanco ceramic Sink, Blanco Silgranit Sink, Blanco 700-IF/A S/ST  Sink,Blanco Anadano Sink'),(15604,85,0,6107,'Blanco Andano 700-IF/A S/ST Sink,Blanco ceramic Sink, Blanco Silgranit Sink, Blanco 700-IF/A S/ST  Sink,Blanco Anadano Sink'),(15605,75,5,6107,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 700-IF/A Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with its almost a century&rsquo;s expertise in producing the <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings about the Blanco Andano 700-IF/A, an inset kitchen sink from the Andano family of Blanco STEELART. Blanco Andano 700-IF/A with its finest design is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. It also has two tap ledge holes in the flat back rim; these holes can be utilized to fix a tap and flush-controller. Blanco Andano 700-IF/A, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer with a pop-up waste and a fixing element set. This stainless steel sink has 80cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Unique composition of optical and functional elements</li>\n<li>Elegantly designed wet area with an integrated tap ledge in just one worktop cut-out</li>\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer with pop-up waste</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15606,75,0,6107,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 700-IF/A Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco with its almost a century&rsquo;s expertise in producing the <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings about the Blanco Andano 700-IF/A, an inset kitchen sink from the Andano family of Blanco STEELART. Blanco Andano 700-IF/A with its finest design is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. It also has two tap ledge holes in the flat back rim; these holes can be utilized to fix a tap and flush-controller. Blanco Andano 700-IF/A, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer with a pop-up waste and a fixing element set. This stainless steel sink has 80cm cabinet width and the depth of the bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Unique composition of optical and functional elements</li>\n<li>Elegantly designed wet area with an integrated tap ledge in just one worktop cut-out</li>\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer with pop-up waste</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n'),(15607,155,0,6107,'Exclude'),(15608,85,5,6108,'Andano 340/180-IF/A S/ST  Sink, Blanco ceramic Sink, Blanco Silgranit Sink, Blanco Anadano Sink, buy Blanco  Anadano Sink'),(15609,85,0,6108,'Andano 340/180-IF/A S/ST  Sink, Blanco ceramic Sink, Blanco Silgranit Sink, Blanco Anadano Sink, buy Blanco  Anadano Sink'),(15610,75,5,6108,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 340/180-IF/A Inset Stainless Steel Kitchen Sink </strong></span></p>\r\n<p>Blanco being a distinguished expert in manufacturing the <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> for nearly a century now brings forth the Blanco Andano 340/180-IF/A, an inset kitchen sink. Blanco Andano 340/180-IF/A with its high-quality design is perfect to give your kitchen an outlook with geometrical designing. This stainless steel kitchen sink is flawlessly built to be used as an individual main kitchen sink. It also has two tap ledge holes in the flat back rim; these holes can be utilized to fix a tap and flush-controller. This inset kitchen sink is perfectly built featuring main kitchen sink bowl and an attached half bowl. Blanco Andano 340/180-IF/A, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer with a pop-up waste and a fixing kit. It has 60cm cabinet width and the main bowl has a depth of 190mm while the depth for the half bowl is 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Cabinet width: 600mm</li>\r\n<li>Overall size: 585 x 500mm</li>\n<li>Small bowl size: 180 x 400 x 130mm</li>\n<li>Large bowl size: 340 x 400 x 190mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>Large bowl capacity and fully usable base</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>Elegantly designed wet area with an integrated tap ledge in just one worktop cut-out</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer with pop-up waste</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n\r\n'),(15611,75,0,6108,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 340/180-IF/A Inset Stainless Steel Kitchen Sink </strong></span></p>\r\n<p>Blanco being a distinguished expert in manufacturing the <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> for nearly a century now brings forth the Blanco Andano 340/180-IF/A, an inset kitchen sink. Blanco Andano 340/180-IF/A with its high-quality design is perfect to give your kitchen an outlook with geometrical designing. This stainless steel kitchen sink is flawlessly built to be used as an individual main kitchen sink. It also has two tap ledge holes in the flat back rim; these holes can be utilized to fix a tap and flush-controller. This inset kitchen sink is perfectly built featuring main kitchen sink bowl and an attached half bowl. Blanco Andano 340/180-IF/A, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer with a pop-up waste and a fixing kit. It has 60cm cabinet width and the main bowl has a depth of 190mm while the depth for the half bowl is 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Cabinet width: 600mm</li>\r\n<li>Overall size: 585 x 500mm</li>\n<li>Small bowl size: 180 x 400 x 130mm</li>\n<li>Large bowl size: 340 x 400 x 190mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>Large bowl capacity and fully usable base</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>Elegantly designed wet area with an integrated tap ledge in just one worktop cut-out</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer with pop-up waste</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n\r\n'),(15612,155,0,6108,'Exclude'),(15613,85,5,6109,'Blanco Silgranit Sink, Blanco Andano 400/400-IF/A S/ST Sink,Blanco Anadano Sink, Andano 400/400-IF/A S/ST Sales'),(15614,85,0,6109,'Blanco Silgranit Sink, Blanco Andano 400/400-IF/A S/ST Sink,Blanco Anadano Sink, Andano 400/400-IF/A S/ST Sales'),(15615,75,5,6109,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 400/400-IF/A Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco has been manufacturing the high-quality and best stainless steel kitchen sinks for more than 90 years. Now Blanco has manufactured the Blanco Andano 400/400-IF/A, an inset kitchen sink. Blanco Andano 400/400-IF/A comes with equal sized twin bowls to provide an adequate work space. This stainless steel kitchen sink is flawlessly built to be used as an individual main kitchen sink. It also has two tap ledge holes in the flat back rim; these holes can be utilized to fix a tap and flush-controller. This inset kitchen sink with its geometrical design will certainly provide a focal point for your modern kitchen. Blanco Andano 400/400-IF/A, in addition, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer with a pop-up waste and a fixing kit. This stainless steel sink has 90cm cabinet width and the depth of both bowls is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Inset</li>\n<li>Bowl(s) depth: 190mm</li>\r\n<li>Cabinet width: 900mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Double Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>Elegantly designed wet area with an integrated tap ledge in just one worktop cut-out</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\n<li>High quality features consisting of a covered C-overflow and InFino drain system with push control - the slim and intuitive remote control</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer with pop up waste</li>\n<li>Fixing kit (sealing not included)</li>\n</ul>\n'),(15616,75,0,6109,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 400/400-IF/A Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco has been manufacturing the high-quality and best stainless steel kitchen sinks for more than 90 years. Now Blanco has manufactured the Blanco Andano 400/400-IF/A, an inset kitchen sink. Blanco Andano 400/400-IF/A comes with equal sized twin bowls to provide an adequate work space. This stainless steel kitchen sink is flawlessly built to be used as an individual main kitchen sink. It also has two tap ledge holes in the flat back rim; these holes can be utilized to fix a tap and flush-controller. This inset kitchen sink with its geometrical design will certainly provide a focal point for your modern kitchen. Blanco Andano 400/400-IF/A, in addition, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer with a pop-up waste and a fixing kit. This stainless steel sink has 90cm cabinet width and the depth of both bowls is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Inset</li>\n<li>Bowl(s) depth: 190mm</li>\r\n<li>Cabinet width: 900mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Double Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Unique composition of optical and functional elements</li>\r\n<li>Elegantly designed wet area with an integrated tap ledge in just one worktop cut-out</li>\r\n<li>The harmonious interplay between the radii and surface design creates a modern appeal</li>\n<li>High quality features consisting of a covered C-overflow and InFino drain system with push control - the slim and intuitive remote control</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer with pop up waste</li>\n<li>Fixing kit (sealing not included)</li>\n</ul>\n'),(15617,155,0,6109,'Exclude'),(15618,75,5,6110,'<p><span style=\"font-size: medium;\"><strong>Blanco Classimo XL 6 S-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Bowl depth: 205mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>XL bowl for superb sink convenience</li>\n<li>Elegant IF flat-rim for flushmount and for installation from above</li>\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer with flat and intuitive Push Control remote control</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste kit with space saving pipe</li>\n<li>1 x 3 1&sol;2&quot; InFino basket strainer with drain remote control (Push Control)</li>\n</ul>'),(15619,75,0,6110,'<p><span style=\"font-size: medium;\"><strong>Blanco Classimo XL 6 S-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Bowl depth: 205mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>XL bowl for superb sink convenience</li>\n<li>Elegant IF flat-rim for flushmount and for installation from above</li>\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer with flat and intuitive Push Control remote control</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste kit with space saving pipe</li>\n<li>1 x 3 1&sol;2&quot; InFino basket strainer with drain remote control (Push Control)</li>\n</ul>'),(15620,155,0,6110,'Exclude'),(15621,75,5,6111,'<p><span style=\"font-size: medium;\"><strong>Blanco Classimo 6 S-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Overall size: 585 x 500mm</li>\n<li>Handing options: Reversible</li>\n<li>Small bowl size: 180 x 290 x 145mm</li>\n<li>Large bowl size: 335 x 424 x 205mm</li>\n<li>Can be installed reversibly</li>\n<li>Spacious main and additional bowl</li>\n<li>Elegant IF flat-rim for flushmount and for installation from above</li>\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer with flat and intuitive Push Control remote control</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste kit with space saving pipe</li>\n<li>2 x 3 1&sol;2&quot; InFino basket strainer with drain remote control (Push Control) for the main bowl</li>\n</ul>'),(15622,75,0,6111,'<p><span style=\"font-size: medium;\"><strong>Blanco Classimo 6 S-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Overall size: 585 x 500mm</li>\n<li>Handing options: Reversible</li>\n<li>Small bowl size: 180 x 290 x 145mm</li>\n<li>Large bowl size: 335 x 424 x 205mm</li>\n<li>Can be installed reversibly</li>\n<li>Spacious main and additional bowl</li>\n<li>Elegant IF flat-rim for flushmount and for installation from above</li>\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer with flat and intuitive Push Control remote control</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste kit with space saving pipe</li>\n<li>2 x 3 1&sol;2&quot; InFino basket strainer with drain remote control (Push Control) for the main bowl</li>\n</ul>'),(15623,155,0,6111,'Exclude'),(15624,75,5,6112,'<p><span style=\"font-size: medium;\"><strong>Blanco Classimo 45 S-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Bowl depth: 205mm</li>\n<li>Cabinet width: 450mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>Compact sink with spacious functional areas</li>\n<li>Elegant IF flat-rim for flushmount and for installation from above</li>\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer with flat and intuitive Push Control remote control</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste kit with space saving pipe</li>\n<li>1 x 3 1&sol;2&quot; InFino basket strainer with drain remote control (Push Control)</li>\n</ul>'),(15625,75,0,6112,'<p><span style=\"font-size: medium;\"><strong>Blanco Classimo 45 S-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Bowl depth: 205mm</li>\n<li>Cabinet width: 450mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>Compact sink with spacious functional areas</li>\n<li>Elegant IF flat-rim for flushmount and for installation from above</li>\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer with flat and intuitive Push Control remote control</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste kit with space saving pipe</li>\n<li>1 x 3 1&sol;2&quot; InFino basket strainer with drain remote control (Push Control)</li>\n</ul>'),(15626,155,0,6112,'Exclude'),(15627,85,5,6113,'Blanco SOLIS 180-U Stainless Steel Undermount Kitchen Sink'),(15628,85,0,6113,'Blanco SOLIS 180-U Stainless Steel Undermount Kitchen Sink'),(15629,75,5,6113,'<p><span style=\"font-size: medium;\"><strong>Blanco SOLIS 180-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: No</li>\n<li>No drainboard</li>\n<li>No Pop-up control</li>\n<li>Cabinet width: 300mm</li>\n<li>Brushed finish surface</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Half Bowl SS Sink</li>\n<li>Installation: Undermount</li>\n<li>Overall size: 220 x 440mm</li>\n<li>Version: Without Pop-up Waste</li>\n<li>Bowl Position: Universal Handing</li>\n<li>Bowl depth: 125mm</li>\n<li>Main bowl size: 180 x 400mm</li>\n<li>A harmonious interplay between functional and visual elements</li>\n<li>Convenient bowl volume and base surface designed for practical use</li>\n<li>High-quality features with covered C-overflow and InFino drain system – elegantly integrated and easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste kit with space-saving pipe</li>\n<li>Cut out information supplied with bowls</li>\n<li>With 3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15630,75,0,6113,'<p><span style=\"font-size: medium;\"><strong>Blanco SOLIS 180-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: No</li>\n<li>No drainboard</li>\n<li>No Pop-up control</li>\n<li>Cabinet width: 300mm</li>\n<li>Brushed finish surface</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Half Bowl SS Sink</li>\n<li>Installation: Undermount</li>\n<li>Overall size: 220 x 440mm</li>\n<li>Version: Without Pop-up Waste</li>\n<li>Bowl Position: Universal Handing</li>\n<li>Bowl depth: 125mm</li>\n<li>Main bowl size: 180 x 400mm</li>\n<li>A harmonious interplay between functional and visual elements</li>\n<li>Convenient bowl volume and base surface designed for practical use</li>\n<li>High-quality features with covered C-overflow and InFino drain system – elegantly integrated and easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste kit with space-saving pipe</li>\n<li>Cut out information supplied with bowls</li>\n<li>With 3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15631,155,0,6113,'Exclude'),(15632,75,5,6114,'<p><span style=\"font-size: medium;\"><strong>Blanco Solis 340-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount </li>\n<li>Bowl depth: 185mm</li>\n<li>Cabinet width: 400mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Harmonious interplay between functional and visual elements</li>\n<li>Convenient bowl volume and base surface designed for optimum use</li>\n<li>High-quality features with covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15633,75,0,6114,'<p><span style=\"font-size: medium;\"><strong>Blanco Solis 340-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount </li>\n<li>Bowl depth: 185mm</li>\n<li>Cabinet width: 400mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Harmonious interplay between functional and visual elements</li>\n<li>Convenient bowl volume and base surface designed for optimum use</li>\n<li>High-quality features with covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15634,155,0,6114,'Exclude'),(15635,75,5,6115,'<p><span style=\"font-size: medium;\"><strong>Blanco Solis 400-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n<li>Bowl depth: 185mm</li>\n<li>Cabinet width: 450mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Harmonious interplay between functional and visual elements</li>\n<li>Convenient bowl volume and base surface designed for optimum use</li>\n<li>High-quality features with covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15636,75,0,6115,'<p><span style=\"font-size: medium;\"><strong>Blanco Solis 400-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n<li>Bowl depth: 185mm</li>\n<li>Cabinet width: 450mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Harmonious interplay between functional and visual elements</li>\n<li>Convenient bowl volume and base surface designed for optimum use</li>\n<li>High-quality features with covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15637,155,0,6115,'Exclude'),(15638,75,5,6116,'<p><span style=\"font-size: medium;\"><strong>Blanco Solis 450-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n<li>Bowl depth: 185mm</li>\n<li>Cabinet width: 500mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Harmonious interplay between functional and visual elements</li>\n<li>Convenient bowl volume and base surface designed for optimum use</li>\n<li>High-quality features with covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15639,75,0,6116,'<p><span style=\"font-size: medium;\"><strong>Blanco Solis 450-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n<li>Bowl depth: 185mm</li>\n<li>Cabinet width: 500mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Harmonious interplay between functional and visual elements</li>\n<li>Convenient bowl volume and base surface designed for optimum use</li>\n<li>High-quality features with covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15640,155,0,6116,'Exclude'),(15641,75,5,6117,'<p><span style=\"font-size: medium;\"><strong>Blanco Solis 500-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n<li>Bowl depth: 185mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Harmonious interplay between functional and visual elements</li>\n<li>Convenient bowl volume and base surface designed for optimum use</li>\n<li>High-quality features with covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15642,75,0,6117,'<p><span style=\"font-size: medium;\"><strong>Blanco Solis 500-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n<li>Bowl depth: 185mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Harmonious interplay between functional and visual elements</li>\n<li>Convenient bowl volume and base surface designed for optimum use</li>\n<li>High-quality features with covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15643,155,0,6117,'Exclude'),(15644,75,5,6118,'<style>#html-body [data-pb-style=E7WUT6M]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"E7WUT6M\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Solis 700-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\r\n<p>Revamp your ideal kitchen with an undermount stainless steel sink from the biggest brands in the business.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Bowl depth: 185mm</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n<li>Harmonious interplay between functional and visual elements</li>\r\n<li>Convenient bowl volume and base surface designed for optimum use</li>\r\n<li>High-quality features with covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Fixing kit</li>\r\n<li>Waste kit with space saving pipe</li>\r\n<li>3 1/2\" InFino basket strainer</li>\r\n</ul></div></div></div>'),(15645,75,0,6118,'<style>#html-body [data-pb-style=E7WUT6M]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"E7WUT6M\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Solis 700-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\r\n<p>Revamp your ideal kitchen with an undermount stainless steel sink from the biggest brands in the business.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Bowl depth: 185mm</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n<li>Harmonious interplay between functional and visual elements</li>\r\n<li>Convenient bowl volume and base surface designed for optimum use</li>\r\n<li>High-quality features with covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Fixing kit</li>\r\n<li>Waste kit with space saving pipe</li>\r\n<li>3 1/2\" InFino basket strainer</li>\r\n</ul></div></div></div>'),(15646,155,0,6118,'Exclude'),(15647,75,5,6119,'<p><span style=\"font-size: medium;\"><strong>Blanco Zerox 500-U Dark Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n<li>Finish: Dark steel</li>\n<li>Bowl depth: 175mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Versatile: Can be combined with a plethora of colours and materials</li>\n<li>Surface is easy to clean and care for: Fingerprints and dirt are easy to remove</li>\n<li>Strikingly right angled stainless steel bowls with an elegant, dark grey surface</li>\n<li>High-quality equipment with InFino drain system – elegant and especially easy-care</li>\n<li>Harmonious surface mix: Inset rim and drain set stylish accents in polished stainless steel</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15648,75,0,6119,'<p><span style=\"font-size: medium;\"><strong>Blanco Zerox 500-U Dark Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n<li>Finish: Dark steel</li>\n<li>Bowl depth: 175mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Versatile: Can be combined with a plethora of colours and materials</li>\n<li>Surface is easy to clean and care for: Fingerprints and dirt are easy to remove</li>\n<li>Strikingly right angled stainless steel bowls with an elegant, dark grey surface</li>\n<li>High-quality equipment with InFino drain system – elegant and especially easy-care</li>\n<li>Harmonious surface mix: Inset rim and drain set stylish accents in polished stainless steel</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15649,155,0,6119,'Exclude'),(15650,75,5,6120,'<p><span style=\"font-size: medium;\"><strong>Blanco Zerox 700-U Dark Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n<li>Finish: Dark steel</li>\n<li>Bowl depth: 185mm</li>\n<li>Cabinet width: 800mm</li>\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Versatile: Can be combined with a plethora of colours and materials</li>\n<li>Surface is easy to clean and care for: Fingerprints and dirt are easy to remove</li>\n<li>Strikingly right angled stainless steel bowls with an elegant, dark grey surface</li>\n<li>High-quality equipment with InFino drain system – elegant and especially easy-care</li>\n<li>Harmonious surface mix: Inset rim and drain set stylish accents in polished stainless steel</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15651,75,0,6120,'<p><span style=\"font-size: medium;\"><strong>Blanco Zerox 700-U Dark Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n<li>Finish: Dark steel</li>\n<li>Bowl depth: 185mm</li>\n<li>Cabinet width: 800mm</li>\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Versatile: Can be combined with a plethora of colours and materials</li>\n<li>Surface is easy to clean and care for: Fingerprints and dirt are easy to remove</li>\n<li>Strikingly right angled stainless steel bowls with an elegant, dark grey surface</li>\n<li>High-quality equipment with InFino drain system – elegant and especially easy-care</li>\n<li>Harmonious surface mix: Inset rim and drain set stylish accents in polished stainless steel</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(15652,155,0,6120,'Exclude'),(15653,85,5,6121,'Blanco SUPRA 400-IF, Blanco Stainless Steel sink, Blanco Inset Kitchen Sink'),(15654,85,0,6121,'Blanco SUPRA 400-IF, Blanco Stainless Steel sink, Blanco Inset Kitchen Sink'),(15655,75,5,6121,'<p><span style=\"font-size: medium;\"><strong>Blanco SUPRA 400-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\r\n\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Bowl depth: 175mm</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n<li>Installation: Inset / Flushmount</li>\r\n<li>Elegant IF flat-rim for flushmount and for installation from above</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\r\n<li>Overflow and waste</li>\r\n<li>Fixing kit included</li>\r\n</ul>'),(15656,75,0,6121,'<p><span style=\"font-size: medium;\"><strong>Blanco SUPRA 400-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\r\n\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Bowl depth: 175mm</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n<li>Installation: Inset / Flushmount</li>\r\n<li>Elegant IF flat-rim for flushmount and for installation from above</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\r\n<li>Overflow and waste</li>\r\n<li>Fixing kit included</li>\r\n</ul>'),(15657,155,0,6121,'Exclude'),(15658,85,5,6122,'Blanco SUPRA 400-IF Stainless Steel Inset Kitchen Sink, Blanco Supra 400-IF, Blanco Stainless Steel Sink, Blanco Inset Kitchen Sink'),(15659,85,0,6122,'Blanco SUPRA 400-IF Stainless Steel Inset Kitchen Sink, Blanco Supra 400-IF, Blanco Stainless Steel Sink, Blanco Inset Kitchen Sink'),(15660,75,5,6122,'<p><span style=\"font-size: medium;\"><strong>Blanco SUPRA 500-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 175mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Installation: Inset / Flushmount</li>\n<li>Elegant IF flat-rim for flushmount and for installation from above</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\n<li>Overflow and waste</li>\n<li>Fixing kit 212 330 included</li>\n</ul>'),(15661,75,0,6122,'<p><span style=\"font-size: medium;\"><strong>Blanco SUPRA 500-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 175mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Installation: Inset / Flushmount</li>\n<li>Elegant IF flat-rim for flushmount and for installation from above</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\n<li>Overflow and waste</li>\n<li>Fixing kit 212 330 included</li>\n</ul>'),(15662,155,0,6122,'Exclude'),(15663,85,5,6123,'Blanco SUPRA 400-IF/A Stainless Steel Inset Kitchen Sink'),(15664,85,0,6123,'Blanco SUPRA 400-IF/A Stainless Steel Inset Kitchen Sink'),(15665,75,5,6123,'<p><span style=\"font-size: medium;\"><strong>Blanco SUPRA 400-IF/A Stainless Steel Inset Kitchen Sink</strong></span></p>\r\n\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Bowl depth: 175mm</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n<li>Installation: Inset / Flushmount</li>\r\n<li>With integrated tap ledge in just one worktop cut-out</li>\r\n<li>Elegant IF flat-rim for flushmount and for installation from above</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\r\n<li>Overflow and waste</li>\r\n<li>Fixing kit included</li>\r\n</ul>'),(15666,75,0,6123,'<p><span style=\"font-size: medium;\"><strong>Blanco SUPRA 400-IF/A Stainless Steel Inset Kitchen Sink</strong></span></p>\r\n\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Cabinet width: 450mm</li>\r\n<li>Bowl depth: 175mm</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Style: Single Bowl SS Sink</li>\r\n<li>Installation: Inset / Flushmount</li>\r\n<li>With integrated tap ledge in just one worktop cut-out</li>\r\n<li>Elegant IF flat-rim for flushmount and for installation from above</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\r\n<li>Overflow and waste</li>\r\n<li>Fixing kit included</li>\r\n</ul>'),(15667,155,0,6123,'Exclude'),(15668,85,5,6124,'Blanco SUPRA 500-IF/A, Blanco Stainless Steel Sink, Blanco Inset Kitchen Sink'),(15669,85,0,6124,'Blanco SUPRA 500-IF/A, Blanco Stainless Steel Sink, Blanco Inset Kitchen Sink'),(15670,75,5,6124,'<p><span style=\"font-size: medium;\"><strong>Blanco SUPRA 500-IF/A Stainless Steel Inset Kitchen Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 175mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Installation: Inset / Flushmount</li>\n<li>With integrated tap ledge in just one worktop cut-out</li>\r\n<li>Elegant IF flat-rim for flushmount and for installation from above</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\n<li>Overflow and waste</li>\n<li>Fixing kit 212 330 included</li>\n</ul>'),(15671,75,0,6124,'<p><span style=\"font-size: medium;\"><strong>Blanco SUPRA 500-IF/A Stainless Steel Inset Kitchen Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 175mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Installation: Inset / Flushmount</li>\n<li>With integrated tap ledge in just one worktop cut-out</li>\r\n<li>Elegant IF flat-rim for flushmount and for installation from above</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\n<li>Overflow and waste</li>\n<li>Fixing kit 212 330 included</li>\n</ul>'),(15672,155,0,6124,'Exclude'),(15673,85,5,6125,'Blanco CLARON 500-U Dark Steel Undermount Kitchen Sink'),(15674,85,0,6125,'Blanco CLARON 500-U Dark Steel Undermount Kitchen Sink'),(15675,75,5,6125,'<p><span style=\"font-size: medium;\"><strong>Blanco CLARON 500-U Dark Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: No</li>\n<li>No drainboard</li>\n<li>No Pop-up control</li>\n<li>Cabinet width: 600mm</li>\n<li>Dark Steel surface</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Installation: Undermount</li>\n<li>Overall size: 540 x 440mm</li>\n<li>Main bowl size: 500 x 400mm</li>\n<li>Version: Without Pop-up Waste</li>\n<li>Bowl Position: Universal Handing</li>\n<li>Elegant-pure bowl design with striking, dark grey surface</li>\n<li>Surface is easy to clean: Fingerprints and dirt are easy to remove</li>\n<li>Pleasantly warm feel thanks to high quality, pure, non-coated stainless steel</li>\n<li>Concise 10 mm radius for a more refined design, without doing away with practical benefits</li>\n<li>Optimum utilisation of the bowl capacity thanks to extra-deep bowls and distinctively small radii</li>\n<li>In this edition, seamlessly coordinated look with fittings in elegant satin dark steel (C-overflow and InFino drain system)?</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit included</li>\n<li>With 3 1&sol;2&quot; basket strainer</li>\n<li>Waste and overflow ftting kit with space saving pipe</li>\n</ul>'),(15676,75,0,6125,'<p><span style=\"font-size: medium;\"><strong>Blanco CLARON 500-U Dark Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: No</li>\n<li>No drainboard</li>\n<li>No Pop-up control</li>\n<li>Cabinet width: 600mm</li>\n<li>Dark Steel surface</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Installation: Undermount</li>\n<li>Overall size: 540 x 440mm</li>\n<li>Main bowl size: 500 x 400mm</li>\n<li>Version: Without Pop-up Waste</li>\n<li>Bowl Position: Universal Handing</li>\n<li>Elegant-pure bowl design with striking, dark grey surface</li>\n<li>Surface is easy to clean: Fingerprints and dirt are easy to remove</li>\n<li>Pleasantly warm feel thanks to high quality, pure, non-coated stainless steel</li>\n<li>Concise 10 mm radius for a more refined design, without doing away with practical benefits</li>\n<li>Optimum utilisation of the bowl capacity thanks to extra-deep bowls and distinctively small radii</li>\n<li>In this edition, seamlessly coordinated look with fittings in elegant satin dark steel (C-overflow and InFino drain system)?</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit included</li>\n<li>With 3 1&sol;2&quot; basket strainer</li>\n<li>Waste and overflow ftting kit with space saving pipe</li>\n</ul>'),(15677,155,0,6125,'Exclude'),(15678,85,5,6126,'Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink'),(15679,85,0,6126,'Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink'),(15680,75,5,6126,'<p><span style=\"font-size: medium;\"><strong>Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: No</li>\n<li>No drainboard</li>\n<li>No Pop-up control</li>\n<li>Cabinet width: 800mm</li>\n<li>Dark Steel surface</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Installation: Undermount</li>\n<li>Overall size: 740 x 440mm</li>\n<li>Main bowl size: 700 x 400mm</li>\n<li>Version: Without Pop-up Waste</li>\n<li>Bowl Position: Universal Handing</li>\n<li>Elegant and pure bowl design with striking, dark grey surface</li>\n<li>Surface is easy to clean: Fingerprints and dirt are easy to remove</li>\n<li>Pleasantly warm feel thanks to high quality, pure, non-coated stainless steel</li>\n<li>Concise 10 mm radius for a more refined design, without doing away with practical benefit</li>\n<li>Optimum utilisation of the bowl capacity thanks to extra-deep bowls and distinctively small radii</li>\n<li>In this edition, seamlessly coordinated look with fittings in elegant satin dark steel (C-overflow and InFino drain system)</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit included</li>\n<li>With 3 1&sol;2&quot; basket strainer</li>\n<li>Waste and overflow ftting kit with space saving pipe</li>\n</ul>'),(15681,75,0,6126,'<p><span style=\"font-size: medium;\"><strong>Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: No</li>\n<li>No drainboard</li>\n<li>No Pop-up control</li>\n<li>Cabinet width: 800mm</li>\n<li>Dark Steel surface</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Installation: Undermount</li>\n<li>Overall size: 740 x 440mm</li>\n<li>Main bowl size: 700 x 400mm</li>\n<li>Version: Without Pop-up Waste</li>\n<li>Bowl Position: Universal Handing</li>\n<li>Elegant and pure bowl design with striking, dark grey surface</li>\n<li>Surface is easy to clean: Fingerprints and dirt are easy to remove</li>\n<li>Pleasantly warm feel thanks to high quality, pure, non-coated stainless steel</li>\n<li>Concise 10 mm radius for a more refined design, without doing away with practical benefit</li>\n<li>Optimum utilisation of the bowl capacity thanks to extra-deep bowls and distinctively small radii</li>\n<li>In this edition, seamlessly coordinated look with fittings in elegant satin dark steel (C-overflow and InFino drain system)</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit included</li>\n<li>With 3 1&sol;2&quot; basket strainer</li>\n<li>Waste and overflow ftting kit with space saving pipe</li>\n</ul>'),(15682,155,0,6126,'Exclude'),(15683,85,5,6127,'Blanco ADIRA 45 S Silgranit Kitchen Sink'),(15684,85,0,6127,'Blanco ADIRA 45 S Silgranit Kitchen Sink'),(15685,75,5,6127,'<p><span style=\"font-size: medium;\"><strong>Blanco ADIRA 45 S Silgranit Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: Yes</li>\n<li>Drainboard: Yes</li>\n<li>Installation: Inset</li>\n<li>Material: SILGRANIT</li>\n<li>Pop-up control: Yes</li>\n<li>Cabinet width: 450mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Overall size: 780 x 500mm</li>\n<li>Handing options: Reversible</li>\n<li>Version: With Pop-up Waste</li>\n<li>Bowl depth: 200mm</li>\n<li>Main bowl size: 325 x 400mm</li>\n<li>High level of comfort due to large bowl and elegant draining board</li>\n<li>Modern sink in beautiful Silgranit colours with extended functionality</li>\n<li>Finishes: Black / Anthracite / Rock grey / Volcano grey / White / Soft white / Tartufo / Coffee</li>\n<li>The multi-functional ADIRA grid is included and can be used to create a top level on either the bowl or the drainer</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Foldable ADIRA grid</li>\n<li>Cut out size: 760 x 480 x R15</li>\n<li>Waste kit with space-saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer with remote control pop-up waste</li>\n</ul>'),(15686,75,0,6127,'<p><span style=\"font-size: medium;\"><strong>Blanco ADIRA 45 S Silgranit Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: Yes</li>\n<li>Drainboard: Yes</li>\n<li>Installation: Inset</li>\n<li>Material: SILGRANIT</li>\n<li>Pop-up control: Yes</li>\n<li>Cabinet width: 450mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Overall size: 780 x 500mm</li>\n<li>Handing options: Reversible</li>\n<li>Version: With Pop-up Waste</li>\n<li>Bowl depth: 200mm</li>\n<li>Main bowl size: 325 x 400mm</li>\n<li>High level of comfort due to large bowl and elegant draining board</li>\n<li>Modern sink in beautiful Silgranit colours with extended functionality</li>\n<li>Finishes: Black / Anthracite / Rock grey / Volcano grey / White / Soft white / Tartufo / Coffee</li>\n<li>The multi-functional ADIRA grid is included and can be used to create a top level on either the bowl or the drainer</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Foldable ADIRA grid</li>\n<li>Cut out size: 760 x 480 x R15</li>\n<li>Waste kit with space-saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer with remote control pop-up waste</li>\n</ul>'),(15687,155,0,6127,'Exclude'),(15688,85,5,6128,'Blanco ADIRA 6S Silgranit Kitchen Sink'),(15689,85,0,6128,'Blanco ADIRA 6S Silgranit Kitchen Sink'),(15690,75,5,6128,'<p><span style=\"font-size: medium;\"><strong>Blanco ADIRA 6S Silgranit Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: Yes</li>\n<li>Drainboard: Yes</li>\n<li>Installation: Inset</li>\n<li>Material: SILGRANIT</li>\n<li>Pop-up control: Yes</li>\n<li>Cabinet width: 600mm</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>Version: With Pop-up Waste</li>\n<li>Overall size: 1000 x 500mm</li>\n<li>Small bowl depth: 135mm</li>\n<li>Large bowl depth: 200mm</li>\n<li>Small bowl size: 152 x 310mm</li>\n<li>Large bowl size: 360 x 400mm</li>\n<li>High level of comfort due to large bowl and elegant draining board</li>\n<li>Modern sink in beautiful Silgranit colours with extended functionality</li>\n<li>Finishes: Black / Anthracite / Rock grey / Volcano grey / White / Soft white / Tartufo / Coffee</li>\n<li>The multi-functional ADIRA grid is included and can be used to create a top level on either the bowl or the drainer</li>\n<li>Colander fits elegantly into the half bowl and is great for preparing tasks. It can also be stored in SELECT II bins in the base cabinet</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Foldable ADIRA grid</li>\n<li>Cut out size: 980 x 480 x R15</li>\n<li>Multi-functional plastic colander</li>\n<li>Waste kit with space-saving pipe</li>\n<li>2 x 3 1&sol;2&quot; InFino basket strainer with rotary switch remote control for the main bowl</li>\n</ul>'),(15691,75,0,6128,'<p><span style=\"font-size: medium;\"><strong>Blanco ADIRA 6S Silgranit Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: Yes</li>\n<li>Drainboard: Yes</li>\n<li>Installation: Inset</li>\n<li>Material: SILGRANIT</li>\n<li>Pop-up control: Yes</li>\n<li>Cabinet width: 600mm</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>Version: With Pop-up Waste</li>\n<li>Overall size: 1000 x 500mm</li>\n<li>Small bowl depth: 135mm</li>\n<li>Large bowl depth: 200mm</li>\n<li>Small bowl size: 152 x 310mm</li>\n<li>Large bowl size: 360 x 400mm</li>\n<li>High level of comfort due to large bowl and elegant draining board</li>\n<li>Modern sink in beautiful Silgranit colours with extended functionality</li>\n<li>Finishes: Black / Anthracite / Rock grey / Volcano grey / White / Soft white / Tartufo / Coffee</li>\n<li>The multi-functional ADIRA grid is included and can be used to create a top level on either the bowl or the drainer</li>\n<li>Colander fits elegantly into the half bowl and is great for preparing tasks. It can also be stored in SELECT II bins in the base cabinet</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Foldable ADIRA grid</li>\n<li>Cut out size: 980 x 480 x R15</li>\n<li>Multi-functional plastic colander</li>\n<li>Waste kit with space-saving pipe</li>\n<li>2 x 3 1&sol;2&quot; InFino basket strainer with rotary switch remote control for the main bowl</li>\n</ul>'),(15692,155,0,6128,'Exclude'),(15693,85,5,6129,'Blanco ADIRA XL 6S Silgranit Kitchen Sink'),(15694,85,0,6129,'Blanco ADIRA XL 6S Silgranit Kitchen Sink'),(15695,75,5,6129,'<p><span style=\"font-size: medium;\"><strong>Blanco ADIRA XL 6S Silgranit Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: Yes</li>\n<li>Drainboard: Yes</li>\n<li>Installation: Inset</li>\n<li>Material: SILGRANIT</li>\n<li>Pop-up control: Yes</li>\n<li>Cabinet width: 600mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Overall size: 1000 x 500mm</li>\n<li>Handing options: Reversible</li>\n<li>Version: With Pop-up Waste</li>\n<li>Bowl depth: 200mm</li>\n<li>Main bowl size: 475 x 400mm</li>\n<li>High level of comfort due to large bowl and elegant draining board</li>\n<li>Modern sink in beautiful Silgranit colours with extended functionality</li>\n<li>Finishes: Black / Anthracite / Rock grey / Volcano grey / White / Soft white / Tartufo / Coffee</li>\n<li>The multi-functional ADIRA grid is included and can be used to create a top level on either the bowl or the drainer</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Foldable ADIRA grid</li>\n<li>Cut out size: 980 x 480 x R15</li>\n<li>Waste kit with space-saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer with rotary switch remote control</li>\n</ul>'),(15696,75,0,6129,'<p><span style=\"font-size: medium;\"><strong>Blanco ADIRA XL 6S Silgranit Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Tap legde: Yes</li>\n<li>Drainboard: Yes</li>\n<li>Installation: Inset</li>\n<li>Material: SILGRANIT</li>\n<li>Pop-up control: Yes</li>\n<li>Cabinet width: 600mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Overall size: 1000 x 500mm</li>\n<li>Handing options: Reversible</li>\n<li>Version: With Pop-up Waste</li>\n<li>Bowl depth: 200mm</li>\n<li>Main bowl size: 475 x 400mm</li>\n<li>High level of comfort due to large bowl and elegant draining board</li>\n<li>Modern sink in beautiful Silgranit colours with extended functionality</li>\n<li>Finishes: Black / Anthracite / Rock grey / Volcano grey / White / Soft white / Tartufo / Coffee</li>\n<li>The multi-functional ADIRA grid is included and can be used to create a top level on either the bowl or the drainer</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Foldable ADIRA grid</li>\n<li>Cut out size: 980 x 480 x R15</li>\n<li>Waste kit with space-saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer with rotary switch remote control</li>\n</ul>'),(15697,155,0,6129,'Exclude'),(15698,85,5,6130,'Franke Argos AGX 611-100 Inset 1.0 Bowl Kitchen Sink'),(15699,85,0,6130,'Franke Argos AGX 611-100 Inset 1.0 Bowl Kitchen Sink'),(15700,75,5,6130,'<style>#html-body [data-pb-style=NCGAXBP]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"NCGAXBP\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Argos AGX 611-100 Inset 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p id=\"BG74CBW\" style=\"text-align: justify;\">Finish your kitchen with the Franke Argos AGX 611-100 1.0 bowl inset kitchen sink. ARGOS AGX 611-100 1000x510mm, Inset, Reversible, Stainless Steel, Semi-Integrated Waste with Hygienic Overflow, 2 tap holes. 50 Year Guarantee on all Franke sinks. Get set for Franke Argos sink baskets at Banyo. The slim top profile of this rectangular shaped kitchen sink allows snug fitting. The revolutionary Slim fix clip system is easy to install and requires very less time for its cleaning. The stainless steel sink looks good in almost every kitchen as it is corrosion-resistant and the pore-free surface of it provides easy cleaning. It bonds with oxygen to make a passive protective layer which continuously renews itself. Stains and scratches cannot stay longer on its surface. The deep bowl provides excessive use without compromising its durability. The high nickel and chromium content make it more durable and increase its strength. If you are in the UK and want to buy shower taps and mixers, then you must contact with us.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 550mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Position of drainer: Reversible</li>\r\n</ul></div></div></div>'),(15701,75,0,6130,'<style>#html-body [data-pb-style=NCGAXBP]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"NCGAXBP\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Argos AGX 611-100 Inset 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p id=\"BG74CBW\" style=\"text-align: justify;\">Finish your kitchen with the Franke Argos AGX 611-100 1.0 bowl inset kitchen sink. ARGOS AGX 611-100 1000x510mm, Inset, Reversible, Stainless Steel, Semi-Integrated Waste with Hygienic Overflow, 2 tap holes. 50 Year Guarantee on all Franke sinks. Get set for Franke Argos sink baskets at Banyo. The slim top profile of this rectangular shaped kitchen sink allows snug fitting. The revolutionary Slim fix clip system is easy to install and requires very less time for its cleaning. The stainless steel sink looks good in almost every kitchen as it is corrosion-resistant and the pore-free surface of it provides easy cleaning. It bonds with oxygen to make a passive protective layer which continuously renews itself. Stains and scratches cannot stay longer on its surface. The deep bowl provides excessive use without compromising its durability. The high nickel and chromium content make it more durable and increase its strength. If you are in the UK and want to buy shower taps and mixers, then you must contact with us.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 550mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Position of drainer: Reversible</li>\r\n</ul></div></div></div>'),(15702,155,0,6130,'Exclude'),(15703,85,5,6131,'Franke Argos AGX 611-78 Inset Single Bowl Sink - Stainless Steel'),(15704,85,0,6131,'Franke Argos AGX 611-78 Inset Single Bowl Sink - Stainless Steel'),(15705,75,5,6131,'<p><span style=\"font-size: medium;\"><strong>Franke Argos AGX 611-78 Inset Single Bowl Sink - Stainless Steel</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 450mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Position of drainer: Reversible</li>\r\n</ul>\r\n'),(15706,75,0,6131,'<p><span style=\"font-size: medium;\"><strong>Franke Argos AGX 611-78 Inset Single Bowl Sink - Stainless Steel</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 450mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Position of drainer: Reversible</li>\r\n</ul>\r\n'),(15707,155,0,6131,'Exclude'),(15708,85,5,6132,'Franke Argos AGX 611-860 Inset 1.0 Bowl Kitchen Sink'),(15709,85,0,6132,'Franke Argos AGX 611-860 Inset 1.0 Bowl Kitchen Sink'),(15710,75,5,6132,'<p><span style=\"font-size: medium;\"><strong>Franke Argos AGX 611-860 Inset 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\n<li>Cabinet size: 450mm</li>\r\n<li>Installation type: Inset</li>\n<li>Sink: Stainless steel</li>\n<li>Position of drainer: Reversible</li>\r\n</ul>'),(15711,75,0,6132,'<p><span style=\"font-size: medium;\"><strong>Franke Argos AGX 611-860 Inset 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\n<li>Cabinet size: 450mm</li>\r\n<li>Installation type: Inset</li>\n<li>Sink: Stainless steel</li>\n<li>Position of drainer: Reversible</li>\r\n</ul>'),(15712,155,0,6132,'Exclude'),(15713,85,5,6133,'Franke Argos AGX 651 Inset 1.5 Bowl Kitchen Sink'),(15714,85,0,6133,'Franke Argos AGX 651 Inset 1.5 Bowl Kitchen Sink'),(15715,75,5,6133,'<style>#html-body [data-pb-style=EF33ESP]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"EF33ESP\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Argos AGX 651 Inset 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\">Buy <strong>Franke 1.5 Bowl Sinks</strong> at affordable Price from Banyo. Franke 1.5 bowl sinks have an additional pan to the left or right of the main bowl. This smaller part is around half the size and ideal for washing vegetables, hands, or pouring a drink away. They are manufactured to the highest values by a trade trusted brand while being easy to install and maintain. Upgrade your kitchen with the Franke Argos AGX 651 – a perfect blend of style and functionality. This sleek and modern sink, crafted from premium stainless steel, not only adds a touch of sophistication to your space but also ensures durability and easy maintenance. With its spacious design and integrated features, such as sound dampening technology, the Franke Argos AGX 651 delivers a superior sink experience, making it an ideal choice for a contemporary and efficient kitchen. Get set for&nbsp;washing up bowl&nbsp;at&nbsp;Banyo. Explore all of our current&nbsp;delivery&nbsp;and&nbsp;collection&nbsp;options.<br>&nbsp;<br>&nbsp;<span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Position of drainer: Reversible</li>\r\n<li>Position of small bowl: Reversible</li>\r\n</ul></div></div></div>'),(15716,75,0,6133,'<style>#html-body [data-pb-style=EF33ESP]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"EF33ESP\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Argos AGX 651 Inset 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\">Buy <strong>Franke 1.5 Bowl Sinks</strong> at affordable Price from Banyo. Franke 1.5 bowl sinks have an additional pan to the left or right of the main bowl. This smaller part is around half the size and ideal for washing vegetables, hands, or pouring a drink away. They are manufactured to the highest values by a trade trusted brand while being easy to install and maintain. Upgrade your kitchen with the Franke Argos AGX 651 – a perfect blend of style and functionality. This sleek and modern sink, crafted from premium stainless steel, not only adds a touch of sophistication to your space but also ensures durability and easy maintenance. With its spacious design and integrated features, such as sound dampening technology, the Franke Argos AGX 651 delivers a superior sink experience, making it an ideal choice for a contemporary and efficient kitchen. Get set for&nbsp;washing up bowl&nbsp;at&nbsp;Banyo. Explore all of our current&nbsp;delivery&nbsp;and&nbsp;collection&nbsp;options.<br>&nbsp;<br>&nbsp;<span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Position of drainer: Reversible</li>\r\n<li>Position of small bowl: Reversible</li>\r\n</ul></div></div></div>'),(15717,155,0,6133,'Exclude'),(15718,85,5,6134,'Franke Arcana AHK 611 Ceramic 1.0 Bowl Kitchen Sink White'),(15719,85,0,6134,'Franke Arcana AHK 611 Ceramic 1.0 Bowl Kitchen Sink White'),(15720,75,5,6134,'<p><span style=\"font-size: medium;\"><strong>Franke Arcana AHK 611 Ceramic 1.0 Bowl Kitchen Sink White</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>  \r\n<li>Single bowl sink</li>     \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Position of drainer: Reversible</li>\r\n<li>Sink: Ceramic</li>\r\n<li>Colour: White</li>\r\n</ul>'),(15721,75,0,6134,'<p><span style=\"font-size: medium;\"><strong>Franke Arcana AHK 611 Ceramic 1.0 Bowl Kitchen Sink White</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>  \r\n<li>Single bowl sink</li>     \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Position of drainer: Reversible</li>\r\n<li>Sink: Ceramic</li>\r\n<li>Colour: White</li>\r\n</ul>'),(15722,155,0,6134,'Exclude'),(15723,85,5,6135,'Reginox Alaska 1.5 Bowl Kitchen Sink'),(15724,85,0,6135,'Reginox Alaska 1.5 Bowl Kitchen Sink'),(15725,75,5,6135,'<style>#html-body [data-pb-style=ROTMOI2]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"ROTMOI2\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Alaska 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Stainless steel gauge: 0.8mm</li>\r\n<li>Drainer Position : Reversible</li>\r\n<li>Finish: Polished Inox</li>\r\n<li>Minimum cabinet size: 600mm</li>\r\n<li>Sink unit dimensions: 342 x 410 / 145 x 335 mm</li>\r\n<li>Total dimensions: 577 x 470 mm</li>\r\n<li>Large bowl depth: 160mm</li>\r\n<li>Small bowl depth 130mm</li>\r\n<li>Outlet : 3.5\" outlet</li>\r\n<li>Strainer Waste Included</li>\r\n<li>Supplied With Fitting kit</li>\r\n<li>Warranty/Guarantee: Lifetime</li>\r\n</ul></div></div></div>'),(15726,75,0,6135,'<style>#html-body [data-pb-style=ROTMOI2]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"ROTMOI2\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Alaska 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Stainless steel gauge: 0.8mm</li>\r\n<li>Drainer Position : Reversible</li>\r\n<li>Finish: Polished Inox</li>\r\n<li>Minimum cabinet size: 600mm</li>\r\n<li>Sink unit dimensions: 342 x 410 / 145 x 335 mm</li>\r\n<li>Total dimensions: 577 x 470 mm</li>\r\n<li>Large bowl depth: 160mm</li>\r\n<li>Small bowl depth 130mm</li>\r\n<li>Outlet : 3.5\" outlet</li>\r\n<li>Strainer Waste Included</li>\r\n<li>Supplied With Fitting kit</li>\r\n<li>Warranty/Guarantee: Lifetime</li>\r\n</ul></div></div></div>'),(15727,155,0,6135,'Exclude'),(15728,85,5,6136,'Reginox Alpha Inset 1 Bowl Kitchen Sink'),(15729,85,0,6136,'Reginox Alpha Inset 1 Bowl Kitchen Sink'),(15730,75,5,6136,'<p><span style=\"font-size: medium;\"><strong>Reginox Alpha Inset 1 Bowl Kitchen Sink - ALPHA10</strong></span></p>\r\n<p>Reginox Alpha inset kitchen sink is quite unique in shape and style. There are some trendy lines on the worktop of the sink that make it more elegant. Material is the most important thing to be considered while purchasing any product and this Reginox kitchen sink is made from stainless steel. Reginox never compromise on the quality of material and so the high quality material used in this sink makes it more precious. If you are worried about the corrosion or rust then you really need to rethink as this sink is resistant to corrosion, rust, and stains. Sometimes it becomes difficult to keep a sink hygienic but Reginox stainless steel sink keeps the hygiene level high by reducing the bacterial growth. More on, you can clean this sink within no time as the pore-free surface allows you to clean it effortlessly. Banyo is the right place from where you can get this sink at an affordable price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Alpha Inset 1 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink Unit Dimensions : 350 x 350 mm</li>\r\n<li>Total Dimensions: 860mm x 435mm</li>\r\n<li>Installation Method : Inset</li>\r\n<li>Depth : 135mm</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type : Sinks with Drainer</li>\r\n<li>Packaging : Box</li>\r\n<li>Position of Drainer: Reversible</li>\r\n<li>Finish:<span>Matt Stainless Steel</span></li>\r\n</ul>\r'),(15731,75,0,6136,'<p><span style=\"font-size: medium;\"><strong>Reginox Alpha Inset 1 Bowl Kitchen Sink - ALPHA10</strong></span></p>\r\n<p>Reginox Alpha inset kitchen sink is quite unique in shape and style. There are some trendy lines on the worktop of the sink that make it more elegant. Material is the most important thing to be considered while purchasing any product and this Reginox kitchen sink is made from stainless steel. Reginox never compromise on the quality of material and so the high quality material used in this sink makes it more precious. If you are worried about the corrosion or rust then you really need to rethink as this sink is resistant to corrosion, rust, and stains. Sometimes it becomes difficult to keep a sink hygienic but Reginox stainless steel sink keeps the hygiene level high by reducing the bacterial growth. More on, you can clean this sink within no time as the pore-free surface allows you to clean it effortlessly. Banyo is the right place from where you can get this sink at an affordable price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Alpha Inset 1 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink Unit Dimensions : 350 x 350 mm</li>\r\n<li>Total Dimensions: 860mm x 435mm</li>\r\n<li>Installation Method : Inset</li>\r\n<li>Depth : 135mm</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type : Sinks with Drainer</li>\r\n<li>Packaging : Box</li>\r\n<li>Position of Drainer: Reversible</li>\r\n<li>Finish:<span>Matt Stainless Steel</span></li>\r\n</ul>\r'),(15732,155,0,6136,'Exclude'),(15733,85,5,6137,'Blanco Andano 340/180-IF S/ST, Blanco Sink sale, cheap Blanco Anadano Sinks, best Blanco Anadano Sinks'),(15734,85,0,6137,'Blanco Andano 340/180-IF S/ST, Blanco Sink sale, cheap Blanco Anadano Sinks, best Blanco Anadano Sinks'),(15735,75,5,6137,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 340/180-IF Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco being a renowned expert in engineering the <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> for nearly a century now brings forth the Blanco Andano 340/180-IF, an inset kitchen sink. Blanco Andano 340/180-IF with its high-quality design is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is perfectly built featuring main kitchen sink bowl and an attached half bowl. Blanco Andano 340/180-IF, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. It has 60cm cabinet width and the main bowl has a depth of 190mm while the depth for the half bowl is 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Overall size: 585mm x 440mm</li>\n<li>Small bowl size: 180 x 400 x 130mm</li>\n<li>Large bowl size: 340 x 400 x 190mm</li>\n<li>Large bowl capacity and fully usable base</li>\n<li>For installation from above or undermount installation</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>Small bowl position can be selected from option given above</li>\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow and modern basket strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Fixing kit (sealing not included)</li>\n</ul>\n\n'),(15736,75,0,6137,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 340/180-IF Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco being a renowned expert in engineering the <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> for nearly a century now brings forth the Blanco Andano 340/180-IF, an inset kitchen sink. Blanco Andano 340/180-IF with its high-quality design is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is perfectly built featuring main kitchen sink bowl and an attached half bowl. Blanco Andano 340/180-IF, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. It has 60cm cabinet width and the main bowl has a depth of 190mm while the depth for the half bowl is 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Overall size: 585mm x 440mm</li>\n<li>Small bowl size: 180 x 400 x 130mm</li>\n<li>Large bowl size: 340 x 400 x 190mm</li>\n<li>Large bowl capacity and fully usable base</li>\n<li>For installation from above or undermount installation</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>Small bowl position can be selected from option given above</li>\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow and modern basket strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Fixing kit (sealing not included)</li>\n</ul>\n\n'),(15737,155,0,6137,'Exclude'),(15738,85,5,6138,'Blanco steel Sink, Blanco Silgranit Sink, Blanco BL 518 3 Anadano Sink,Blanco Anadano Sink, BL 518 3 Sink'),(15739,85,0,6138,'Blanco steel Sink, Blanco Silgranit Sink, Blanco BL 518 3 Anadano Sink,Blanco Anadano Sink, BL 518 3 Sink'),(15740,75,5,6138,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 340/180-U Undermount Stainless Steel Kitchen Sink</strong></span></p>\r\n<p> Blanco Andano 340/180-U is an undermount kitchen sink from the Andano family of Blanco STEELART <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a>. Blanco Andano 340/180-U with its supreme design is ideal to give your kitchen an outlook with geometrical designing. This undermount kitchen sink is perfectly built featuring main kitchen sink bowl and an attached half bowl. Blanco Andano 340/180-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. It has 60cm cabinet width and the main bowl has a depth of 190mm while the depth for the half bowl is 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Cabinet width: 600mm</li>\r\n<li>Overall size: 585 x 440mm</li>\n<li>Small bowl size: 180 x 400 x 130mm</li>\n<li>Large bowl size: 340 x 400 x 180mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow and modern basket strainer</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Fixing kit (sealing not included)</li>\n</ul>'),(15741,75,0,6138,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 340/180-U Undermount Stainless Steel Kitchen Sink</strong></span></p>\r\n<p> Blanco Andano 340/180-U is an undermount kitchen sink from the Andano family of Blanco STEELART <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a>. Blanco Andano 340/180-U with its supreme design is ideal to give your kitchen an outlook with geometrical designing. This undermount kitchen sink is perfectly built featuring main kitchen sink bowl and an attached half bowl. Blanco Andano 340/180-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. It has 60cm cabinet width and the main bowl has a depth of 190mm while the depth for the half bowl is 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Cabinet width: 600mm</li>\r\n<li>Overall size: 585 x 440mm</li>\n<li>Small bowl size: 180 x 400 x 130mm</li>\n<li>Large bowl size: 340 x 400 x 180mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered C-overflow and modern basket strainer</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Fixing kit (sealing not included)</li>\n</ul>'),(15742,155,0,6138,'Exclude'),(15743,85,5,6139,'Blanco BL467790 BL467791 Sink, Stainless Steel Sink, Stylish Sink, Cheap  Sink, Blanco BL467790 BL467791 Sink'),(15744,85,0,6139,'Blanco BL467790 BL467791 Sink, Stainless Steel Sink, Stylish Sink, Cheap  Sink, Blanco BL467790 BL467791 Sink'),(15745,75,5,6139,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 500/180-U Undermount Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco well-known for its long-time expertise in manufacturing <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings to you the Blanco Andano 500/180-U, an undermount kitchen sink. Blanco Andano 500/180-U with its premium design is perfect to give your kitchen an outlook with geometrical designing. This undermount kitchen sink is perfectly built featuring main kitchen sink bowl and an attached half bowl. Blanco Andano 500/180-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. It has 80cm cabinet width and the main bowl has a depth of 190mm while the depth for the half bowl is 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n\r<li>Cabinet width: 800mm</li>\r\n<li>Overall size: 745 x 440mm</li>\n<li>Small bowl size: 180 x 400 x 130mm</li>\n<li>Large bowl size: 500m x 400mm x 190mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered c-overflow&reg; and modern basket strainer</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n\r\n'),(15746,75,0,6139,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano 500/180-U Undermount Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco well-known for its long-time expertise in manufacturing <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings to you the Blanco Andano 500/180-U, an undermount kitchen sink. Blanco Andano 500/180-U with its premium design is perfect to give your kitchen an outlook with geometrical designing. This undermount kitchen sink is perfectly built featuring main kitchen sink bowl and an attached half bowl. Blanco Andano 500/180-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount kitchen sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing kit. It has 80cm cabinet width and the main bowl has a depth of 190mm while the depth for the half bowl is 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n\r<li>Cabinet width: 800mm</li>\r\n<li>Overall size: 745 x 440mm</li>\n<li>Small bowl size: 180 x 400 x 130mm</li>\n<li>Large bowl size: 500m x 400mm x 190mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>Unique composition of visual and functional elements</li>\r\n<li>The combination of radii and surface design creates a modern design</li>\r\n<li>High quality features consisting of a covered c-overflow&reg; and modern basket strainer</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing kit (sealing not included)</li>\r\n</ul>\r\n\r\n'),(15747,155,0,6139,'Exclude'),(15748,85,5,6140,'Blanco BL467838 BL467839 Ceramic  Sink, Blanco ceramic Sink, Blanco Silgranit Sink, Blanco classic Sink'),(15749,85,0,6140,'Blanco BL467838 BL467839 Ceramic  Sink, Blanco ceramic Sink, Blanco Silgranit Sink, Blanco classic Sink'),(15750,75,5,6140,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano XL 6 S-IF Inset Stainless Steel Kitchen Sink </strong></span></p>\r\n<p>Blanco being a renowned expert in producing the <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings forth the Blanco Andano XL 6 S-IF, an inset kitchen sink. Blanco Andano XL 6 S-IF with its finest and spacious design with a large main bow and a large draining area is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano XL 6 S-IF, additionally, features an overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer with remote controlled pop-up waste and a fixing kit. This stainless steel sink has 60cm cabinet width and the depth of the bowl is 210mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 215mm</li>\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Hang-in colander integrates flush in the sink design</li>\n<li>Elegant modern design with multifunctional elements</li>\r\n<li>Modern bowl design with tight corner and base radii and the covered c-overflow&reg;</li>\r\n<li>Lateral tap ledge - easily accessible and practical, also for window installations</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Multifunctional bowl</li>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer with remote pop-up control</li>\r\n<li>Fixing kit (to be sealed on site)</li>\r\n</ul>\r\n\r'),(15751,75,0,6140,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano XL 6 S-IF Inset Stainless Steel Kitchen Sink </strong></span></p>\r\n<p>Blanco being a renowned expert in producing the <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings forth the Blanco Andano XL 6 S-IF, an inset kitchen sink. Blanco Andano XL 6 S-IF with its finest and spacious design with a large main bow and a large draining area is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano XL 6 S-IF, additionally, features an overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer with remote controlled pop-up waste and a fixing kit. This stainless steel sink has 60cm cabinet width and the depth of the bowl is 210mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 215mm</li>\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Hang-in colander integrates flush in the sink design</li>\n<li>Elegant modern design with multifunctional elements</li>\r\n<li>Modern bowl design with tight corner and base radii and the covered c-overflow&reg;</li>\r\n<li>Lateral tap ledge - easily accessible and practical, also for window installations</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Multifunctional bowl</li>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer with remote pop-up control</li>\r\n<li>Fixing kit (to be sealed on site)</li>\r\n</ul>\r\n\r'),(15752,155,0,6140,'Exclude'),(15753,85,5,6141,'Blanco BL467840 BL467841 Sinks, Blanco Sink sale, cheap Blanco classic Sinks, best Blanco classic Sinks'),(15754,85,0,6141,'Blanco BL467840 BL467841 Sinks, Blanco Sink sale, cheap Blanco classic Sinks, best Blanco classic Sinks'),(15755,75,5,6141,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano XL 6 S-IF Compact Inset Stainless Steel Kitchen Sink </strong></span></p>\r\n<p>Blanco with its long-time period experience in manufacturing <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings to you the Blanco Andano XL 6 S-IF Compact, an inset kitchen sink. Blanco Andano XL 6 S-IF Compact with its finest compact design with a large main bow and a large draining area is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano XL 6 S-IF Compact, additionally, features an overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer with remote controlled pop-up waste and a fixing kit. This stainless steel sink has 60cm cabinet width and the depth of the bowl is 210mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 215mm</li>\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Elegant modern design with multifunctional elements</li>\r\n<li>Compact version for plenty of comfort in limited space</li>\r\n<li>Modern bowl design with tight corner and base radii and the covered c-overflow&reg;</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Multifunctional bowl</li>\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer with remote pop-up control</li>\r\n<li>Fixing kit (to be sealed on site)</li>\r\n</ul>\r\n\r'),(15756,75,0,6141,'<p><span style=\"font-size: medium;\"><strong>Blanco Andano XL 6 S-IF Compact Inset Stainless Steel Kitchen Sink </strong></span></p>\r\n<p>Blanco with its long-time period experience in manufacturing <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sinks</span></a> now brings to you the Blanco Andano XL 6 S-IF Compact, an inset kitchen sink. Blanco Andano XL 6 S-IF Compact with its finest compact design with a large main bow and a large draining area is perfect to give your kitchen an outlook with geometrical designing. This inset kitchen sink is flawlessly built to be used as an individual main kitchen sink. Blanco Andano XL 6 S-IF Compact, additionally, features an overflow and waste fitting with a space-saving pipe. This inset kitchen sink also comes with a 3 1&sol;2&quot; basket strainer with remote controlled pop-up waste and a fixing kit. This stainless steel sink has 60cm cabinet width and the depth of the bowl is 210mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 215mm</li>\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Elegant modern design with multifunctional elements</li>\r\n<li>Compact version for plenty of comfort in limited space</li>\r\n<li>Modern bowl design with tight corner and base radii and the covered c-overflow&reg;</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Multifunctional bowl</li>\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer with remote pop-up control</li>\r\n<li>Fixing kit (to be sealed on site)</li>\r\n</ul>\r\n\r'),(15757,155,0,6141,'Exclude'),(15758,85,5,6142,'Franke Ariane ARX 110 17 Undermount 0.5 Bowl Kitchen Sink'),(15759,85,0,6142,'Franke Ariane ARX 110 17 Undermount 0.5 Bowl Kitchen Sink'),(15760,75,5,6142,'<p><span style=\"font-size: medium;\"><strong>Franke Ariane ARX 110 17 Undermount 0.5 Bowl Kitchen Sink</strong></span></p>\n<p>Any kitchen decor will speak of class and sophistication with the Franke Ariane bowl stainless steel kitchen sink. This silk finish and shiny sink has been made from good quality nickel steel that not only adds grace but also provides high functional value to your kitchen space. You will find it suitable for solid surface worktops such as solid wood and granite. The bowl of this incredible sink is large enough that let you do your chores with efficiency and ease. Get this incredible sink from Banyo at highly affordable rate.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Half bowl</li>\n<li>Cabinet size: 400mm</li>\n<li>Installation type: Undermount</li>\n<li>Sink: Stainless steel</li>\n</ul>\n\n'),(15761,75,0,6142,'<p><span style=\"font-size: medium;\"><strong>Franke Ariane ARX 110 17 Undermount 0.5 Bowl Kitchen Sink</strong></span></p>\n<p>Any kitchen decor will speak of class and sophistication with the Franke Ariane bowl stainless steel kitchen sink. This silk finish and shiny sink has been made from good quality nickel steel that not only adds grace but also provides high functional value to your kitchen space. You will find it suitable for solid surface worktops such as solid wood and granite. The bowl of this incredible sink is large enough that let you do your chores with efficiency and ease. Get this incredible sink from Banyo at highly affordable rate.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Half bowl</li>\n<li>Cabinet size: 400mm</li>\n<li>Installation type: Undermount</li>\n<li>Sink: Stainless steel</li>\n</ul>\n\n'),(15762,155,0,6142,'Exclude'),(15763,85,5,6143,'Franke Kitchen Sink, Buy ARX 110 17-D Sink, Franke  Sink Sinks,Franke Sink Deals,Best Franke Sinks'),(15764,85,0,6143,'Franke Kitchen Sink, Buy ARX 110 17-D Sink, Franke  Sink Sinks,Franke Sink Deals,Best Franke Sinks'),(15765,75,5,6143,'<p><span style=\"font-size: medium;\"><strong>Franke Ariane ARX 110 17-D Undermount 0.5 Bowl Kitchen Sink</strong></span></p><p>\r\nFranke is a worldwide leader in manufacturing quality kitchen sinks that brings majestic comfort in your daily routine. Ariane Kitchen Sink is one of thThe Franke Ariane ARX kitchen sink is designed for under-mount installation on solid surface only. It has been fabricated by using finest quality nickel-steel so it is stain-proof, corrosion and rust resistant. The cut-out template makes it more special and gives an astonishing look to the kitchen. Franke stainless steel has chromium and nickel content due to which it is equally resistant to cold as well as heat. You will find it excellent for small spaced kitchens and it can be used in large kitchen to provide excessive usage. Though it has incredible benefits but still Banyo is providing this kitchen sink at reasonable rate.e foremost creation of Franke that would create wonders in any kitchen. Manufactured from Stainless Steel, this Undermount Kitchen Sink is guaranteed to withstand stain, rust, and corrosion.\r\n</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Half bowl</li> \r\n<li>Cabinet size: 400mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>\r\n\r\n\r\n\r\n\r\n\r\n\r\n'),(15766,75,0,6143,'<p><span style=\"font-size: medium;\"><strong>Franke Ariane ARX 110 17-D Undermount 0.5 Bowl Kitchen Sink</strong></span></p><p>\r\nFranke is a worldwide leader in manufacturing quality kitchen sinks that brings majestic comfort in your daily routine. Ariane Kitchen Sink is one of thThe Franke Ariane ARX kitchen sink is designed for under-mount installation on solid surface only. It has been fabricated by using finest quality nickel-steel so it is stain-proof, corrosion and rust resistant. The cut-out template makes it more special and gives an astonishing look to the kitchen. Franke stainless steel has chromium and nickel content due to which it is equally resistant to cold as well as heat. You will find it excellent for small spaced kitchens and it can be used in large kitchen to provide excessive usage. Though it has incredible benefits but still Banyo is providing this kitchen sink at reasonable rate.e foremost creation of Franke that would create wonders in any kitchen. Manufactured from Stainless Steel, this Undermount Kitchen Sink is guaranteed to withstand stain, rust, and corrosion.\r\n</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Half bowl</li> \r\n<li>Cabinet size: 400mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>\r\n\r\n\r\n\r\n\r\n\r\n\r\n'),(15767,155,0,6143,'Exclude'),(15768,85,5,6144,'Franke Ariane ARX 110 33 Sink,Undermount 1.0 Bowl Kitchen Sink,  Franke UK Deals,Franke Sinks, Franke Cheap Deals'),(15769,85,0,6144,'Franke Ariane ARX 110 33 Sink,Undermount 1.0 Bowl Kitchen Sink,  Franke UK Deals,Franke Sinks, Franke Cheap Deals'),(15770,75,5,6144,'<style>#html-body [data-pb-style=E8Y2Y3S]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"E8Y2Y3S\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Ariane ARX 110 33 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>Franke, one of leading manufacturers has brought a majestic comfort in your daily routine by presenting Franke Ariane ARX 110 33 kitchen sink. The absolutely pore-free surface is not only easy to clean but proves extremely hygienic. It has been manufactured with stainless steel so it is corrosion-resistant. It automatically forms a passive protective layer that can continuously renew itself. The rust-resistant quality of this sink makes it extraordinary and increases its overall worth. Despite the huge benefits, Banyo is providing this kitchen sink at highly affordable rate and there is a guarantee of 50 years from Franke against any manufacturing fault.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 400mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul></div></div></div>'),(15771,75,0,6144,'<style>#html-body [data-pb-style=E8Y2Y3S]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"E8Y2Y3S\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Ariane ARX 110 33 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>Franke, one of leading manufacturers has brought a majestic comfort in your daily routine by presenting Franke Ariane ARX 110 33 kitchen sink. The absolutely pore-free surface is not only easy to clean but proves extremely hygienic. It has been manufactured with stainless steel so it is corrosion-resistant. It automatically forms a passive protective layer that can continuously renew itself. The rust-resistant quality of this sink makes it extraordinary and increases its overall worth. Despite the huge benefits, Banyo is providing this kitchen sink at highly affordable rate and there is a guarantee of 50 years from Franke against any manufacturing fault.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 400mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul></div></div></div>'),(15772,155,0,6144,'Exclude'),(15773,85,5,6145,'Franke Ariane ARX 110 35, Franke Sinks,Undermount 1.0 Bowl Kitchen Sink,Franke Kitchen Systems, Franke Sinks UK'),(15774,85,0,6145,'Franke Ariane ARX 110 35, Franke Sinks,Undermount 1.0 Bowl Kitchen Sink,Franke Kitchen Systems, Franke Sinks UK'),(15775,75,5,6145,'<style>#html-body [data-pb-style=AMYRE5K]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"AMYRE5K\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Ariane ARX 110 35 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>Franke, one of leading manufacturers has brought a majestic comfort in your daily routine by presenting Franke Ariane ARX 110 35 kitchen sink. The absolutely pore-free surface is not only easy to clean but proves extremely hygienic. It has been manufactured with stainless steel so it is corrosion-resistant. It automatically forms a passive protective layer that can continuously renew itself. The rust-resistant quality of this sink makes it extraordinary and increases its overall worth. Despite the huge benefits, Banyo is providing this kitchen sink at highly affordable rate and there is a guarantee of 50 years from Franke against any manufacturing fault.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 400mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul></div></div></div>'),(15776,75,0,6145,'<style>#html-body [data-pb-style=AMYRE5K]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"AMYRE5K\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Ariane ARX 110 35 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>Franke, one of leading manufacturers has brought a majestic comfort in your daily routine by presenting Franke Ariane ARX 110 35 kitchen sink. The absolutely pore-free surface is not only easy to clean but proves extremely hygienic. It has been manufactured with stainless steel so it is corrosion-resistant. It automatically forms a passive protective layer that can continuously renew itself. The rust-resistant quality of this sink makes it extraordinary and increases its overall worth. Despite the huge benefits, Banyo is providing this kitchen sink at highly affordable rate and there is a guarantee of 50 years from Franke against any manufacturing fault.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 400mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul></div></div></div>'),(15777,155,0,6145,'Exclude'),(15778,85,5,6146,'Franke Ariane ARX 160n Sink, Frank Undermount 1.0 Bowl Kitchen Sink,Franke Sink Accessories,Franke Kitchen,'),(15779,85,0,6146,'Franke Ariane ARX 160n Sink, Frank Undermount 1.0 Bowl Kitchen Sink,Franke Sink Accessories,Franke Kitchen,'),(15780,75,5,6146,'<style>#html-body [data-pb-style=LDRQP9V]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"LDRQP9V\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Ariane ARX 160 Undermount 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p>The Franke Ariane ARX160 Stainless Steel Kitchen Sink would be a incredible, trendy addition to any modern kitchen. As a part of the Ariane Undermount range this product has other options for a small bowl that features on either the left or the right of the main sink bowl. With the application of the latest technology and innovative techniques, Franke has established itself as a market leader in manufacturing kitchen sinks. Franke has brought a more ingeniously crafted sink by giving it a name of Franke Ariane ARX 160 stainless steel kitchen sink. The finest stainless steel sink is crafted with minimal processing marks that make your sink more pleasing to the eye. You can turn your kitchen into a stylish yet practical one by installing this amazing kitchen sink. It has one and a half bowl which makes it more useful.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Position of small bowl: Right hand and left hand side</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul></div></div></div>'),(15781,75,0,6146,'<style>#html-body [data-pb-style=LDRQP9V]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"LDRQP9V\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Ariane ARX 160 Undermount 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p>The Franke Ariane ARX160 Stainless Steel Kitchen Sink would be a incredible, trendy addition to any modern kitchen. As a part of the Ariane Undermount range this product has other options for a small bowl that features on either the left or the right of the main sink bowl. With the application of the latest technology and innovative techniques, Franke has established itself as a market leader in manufacturing kitchen sinks. Franke has brought a more ingeniously crafted sink by giving it a name of Franke Ariane ARX 160 stainless steel kitchen sink. The finest stainless steel sink is crafted with minimal processing marks that make your sink more pleasing to the eye. You can turn your kitchen into a stylish yet practical one by installing this amazing kitchen sink. It has one and a half bowl which makes it more useful.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Position of small bowl: Right hand and left hand side</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul></div></div></div>'),(15782,155,0,6146,'Exclude'),(15783,85,5,6147,'Franke Ariane ARX 160-D, Undermount 1.0 Bowl Kitchen Sink, Stainless Steel  Kitchen Sink, ranke Sink Accessories'),(15784,85,0,6147,'Franke Ariane ARX 160-D, Undermount 1.0 Bowl Kitchen Sink, Stainless Steel  Kitchen Sink, ranke Sink Accessories'),(15785,75,5,6147,'<p><span style=\"font-size: medium;\"><strong>Franke Ariane ARX 160-D Undermount 1.5 Bowl Kitchen Sink</strong></span></p><p>\r\nIf you want to make your kitchen space a stylish yet practical one then Franke Ariane ARX kitchen sink is the right choice for you as it gives comfortable use and gives astonishing look to any kitchen. It will be installed underneath the worktop and so it is compatible with solid surface worktop only. As it is fabricated from nickel steel so it is stain, corrosion, and rust resistant. It requires worktop of depth 650mm and the seamless finish of this sink suits to any type of kitchen whether you install it in traditional kitchen or in modern one. </p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul> \r\n<li>One and half bowls sink</li>     \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Position of small bowl: Right hand and left hand side</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>'),(15786,75,0,6147,'<p><span style=\"font-size: medium;\"><strong>Franke Ariane ARX 160-D Undermount 1.5 Bowl Kitchen Sink</strong></span></p><p>\r\nIf you want to make your kitchen space a stylish yet practical one then Franke Ariane ARX kitchen sink is the right choice for you as it gives comfortable use and gives astonishing look to any kitchen. It will be installed underneath the worktop and so it is compatible with solid surface worktop only. As it is fabricated from nickel steel so it is stain, corrosion, and rust resistant. It requires worktop of depth 650mm and the seamless finish of this sink suits to any type of kitchen whether you install it in traditional kitchen or in modern one. </p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul> \r\n<li>One and half bowls sink</li>     \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Position of small bowl: Right hand and left hand side</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>'),(15787,155,0,6147,'Exclude'),(15788,85,5,6148,'Reginox Atlantis OPS L Integrated 1 Bowl Kitchen Sink'),(15789,85,0,6148,'Reginox Atlantis OPS L Integrated 1 Bowl Kitchen Sink'),(15790,75,5,6148,'<p><span style=\"font-size: medium;\"><strong>Reginox Atlantis OPS L Integrated 1 Bowl Kitchen Sink</strong></span></p>\r\n<p>Reginox Atlantis OPS kitchen sink is an outstanding choice for any kitchen. It will not only suit to the domestic kitchen but you will find it a perfect choice for commercial kitchens also. The integrated installation helps to fit the edge of the sink and worktop together seamlessly and effortlessly. It will give you the advantage of both sleek and hygienic. It is exceptionally easy to clean as it is stain, rust, and corrosion resistant. The depth of its bowl is 170mm whereas the cabinet size where it needs to be fit should be of 450mm. It will surely make your washing and cleaning moments comfortable and enjoyable. Get it from Banyo as it is offering an unbelievable discount on it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Atlantis OPS L Integrated 1 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink unit dimensions: 290 x 380 mm</li>\r\n<li>Total dimensions: &Oslash; 460 mm</li>\r\n<li>Depth: 170 mm</li>\r\n<li>Installation Method: Integrated</li>\r\n<li>Outlet : 1,25\" outlet</li>\r\n<li>Packaging: Box</li>\r\n</ul>\r'),(15791,75,0,6148,'<p><span style=\"font-size: medium;\"><strong>Reginox Atlantis OPS L Integrated 1 Bowl Kitchen Sink</strong></span></p>\r\n<p>Reginox Atlantis OPS kitchen sink is an outstanding choice for any kitchen. It will not only suit to the domestic kitchen but you will find it a perfect choice for commercial kitchens also. The integrated installation helps to fit the edge of the sink and worktop together seamlessly and effortlessly. It will give you the advantage of both sleek and hygienic. It is exceptionally easy to clean as it is stain, rust, and corrosion resistant. The depth of its bowl is 170mm whereas the cabinet size where it needs to be fit should be of 450mm. It will surely make your washing and cleaning moments comfortable and enjoyable. Get it from Banyo as it is offering an unbelievable discount on it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Atlantis OPS L Integrated 1 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink unit dimensions: 290 x 380 mm</li>\r\n<li>Total dimensions: &Oslash; 460 mm</li>\r\n<li>Depth: 170 mm</li>\r\n<li>Installation Method: Integrated</li>\r\n<li>Outlet : 1,25\" outlet</li>\r\n<li>Packaging: Box</li>\r\n</ul>\r'),(15792,155,0,6148,'Exclude'),(15793,85,5,6149,'Blanco AXIA III 6 S Silgranit PuraDur II® Inset Sink'),(15794,85,0,6149,'Blanco AXIA III 6 S Silgranit PuraDur II® Inset Sink'),(15795,75,5,6149,'<p><span style=\"font-size: medium;\"><strong>Blanco AXIA III 6 S Silgranit PuraDur II Inset Sink</strong></span></p>\r\n\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Small bowl depth: 145mm</li>\r\n<li>Large bowl depth: 190mm</li>\r\n<li>Style: One & Half Bowl Sink</li>\r\n<li>Tight radii for maximum utilisation of the surface and volume</li>\r\n<li> Design that is notable for clear lines and the ultra-narrow, flat rim</li>\r\n<li>High-quality features with the covered C-overflow and InFino drain system elegantly integrated and extremely easy-care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Glass cutting board</li>\r\n<li>Multifunctional stainless steel colander</li>\r\n<li>Waste kit with space-saving pipe</li>\r\n<li>2 x 3 1&sol;2&quot; basket strainer with remote control for the main bowl</li>\r\n</ul>\r\n'),(15796,75,0,6149,'<p><span style=\"font-size: medium;\"><strong>Blanco AXIA III 6 S Silgranit PuraDur II Inset Sink</strong></span></p>\r\n\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Small bowl depth: 145mm</li>\r\n<li>Large bowl depth: 190mm</li>\r\n<li>Style: One & Half Bowl Sink</li>\r\n<li>Tight radii for maximum utilisation of the surface and volume</li>\r\n<li> Design that is notable for clear lines and the ultra-narrow, flat rim</li>\r\n<li>High-quality features with the covered C-overflow and InFino drain system elegantly integrated and extremely easy-care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Glass cutting board</li>\r\n<li>Multifunctional stainless steel colander</li>\r\n<li>Waste kit with space-saving pipe</li>\r\n<li>2 x 3 1&sol;2&quot; basket strainer with remote control for the main bowl</li>\r\n</ul>\r\n'),(15797,155,0,6149,'Exclude'),(15798,85,5,6150,'Blanco AXIA III XL 6 S Silgranit PuraDur II® Inset Sink'),(15799,85,0,6150,'Blanco AXIA III XL 6 S Silgranit PuraDur II® Inset Sink'),(15800,75,5,6150,'<p><span style=\"font-size: medium;\"><strong>Blanco Axia III XL 6 SIII XL 6 S Silgranit PuraDur II Inset Sink</strong></span></p>\n\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation : Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>Tight radii for maximum utilisation of the surface and volume</li>\n<li> Design that is notable for clear lines and the ultra-narrow, flat rim</li>\n<li>Movable glass cutting board for working directly into cooking dishes</li>\n<li>Unbeatable roomy bowl and beautifully integrated, practical drainer groove</li>\n<li>Flowing ergonomic work space along a single axis thanks to arrangement of bowls and multifunctional accessories</li>\n<li>High-quality features with the covered C-overflow and InFino drain system elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Glass cutting board</il>\n<li>Waste kit with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer with remote control</li>\n</ul>\n\n'),(15801,75,0,6150,'<p><span style=\"font-size: medium;\"><strong>Blanco Axia III XL 6 SIII XL 6 S Silgranit PuraDur II Inset Sink</strong></span></p>\n\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation : Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>Tight radii for maximum utilisation of the surface and volume</li>\n<li> Design that is notable for clear lines and the ultra-narrow, flat rim</li>\n<li>Movable glass cutting board for working directly into cooking dishes</li>\n<li>Unbeatable roomy bowl and beautifully integrated, practical drainer groove</li>\n<li>Flowing ergonomic work space along a single axis thanks to arrangement of bowls and multifunctional accessories</li>\n<li>High-quality features with the covered C-overflow and InFino drain system elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Glass cutting board</il>\n<li>Waste kit with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer with remote control</li>\n</ul>\n\n'),(15802,155,0,6150,'Exclude'),(15803,85,5,6151,'Blanco AXIS III 6 S-IF Stainless Steel Inset Sink'),(15804,85,0,6151,'Blanco AXIS III 6 S-IF Stainless Steel Inset Sink'),(15805,75,5,6151,'<p><span style=\"font-size: medium;\"><strong>Blanco Axis III 6 S-IF Stainless Steel Inset Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n\r<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Overall size: 1000 x 510mm</li>\n<li>Small bowl size: 180 x 340 x 130mm</li>\n<li>Large bowl size: 340 x 420 x 190mm</li>\n<li>Flowing ergonomic work processes along two axis</li>\r\n<li>Accentuated base contours create an aesthetically pleasing contoured bowl with large base area</li>\r\n<li>High-quality features with the covered C-overflow and InFino drain system elegantly integrated and extremely easy-care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Movable glass cutting board</li>\n<li>Multifunctional colander in stainless steel</li>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Pop-up waste for main bowl</li>\n</ul>'),(15806,75,0,6151,'<p><span style=\"font-size: medium;\"><strong>Blanco Axis III 6 S-IF Stainless Steel Inset Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n\r<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Overall size: 1000 x 510mm</li>\n<li>Small bowl size: 180 x 340 x 130mm</li>\n<li>Large bowl size: 340 x 420 x 190mm</li>\n<li>Flowing ergonomic work processes along two axis</li>\r\n<li>Accentuated base contours create an aesthetically pleasing contoured bowl with large base area</li>\r\n<li>High-quality features with the covered C-overflow and InFino drain system elegantly integrated and extremely easy-care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Movable glass cutting board</li>\n<li>Multifunctional colander in stainless steel</li>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Pop-up waste for main bowl</li>\n</ul>'),(15807,155,0,6151,'Exclude'),(15808,85,5,6152,'Franke Antea AZG 611 78 Inset 1.0 Bowl Kitchen Sink'),(15809,85,0,6152,'Franke Antea AZG 611 78 Inset 1.0 Bowl Kitchen Sink'),(15810,75,5,6152,'<style>#html-body [data-pb-style=VRIYNH6]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"VRIYNH6\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Antea AZG 611 78 Inset 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p><strong>FRANKE ANTEA SINKS</strong></p>\r\n<p>The Franke Antea range consists of stylish fragranite and stainless steel sinks. With a rounded sink design, the Antea variety of sinks are both sleek and modern.&nbsp; Have a scan through, see what you think, and get your sink now! It couldn\'t be easier.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 450mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Position of drainer: Reversible</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available finish: Onyx, Polar white, Coffee</li>\r\n</ul></div></div></div>'),(15811,75,0,6152,'<style>#html-body [data-pb-style=VRIYNH6]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"VRIYNH6\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Antea AZG 611 78 Inset 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p><strong>FRANKE ANTEA SINKS</strong></p>\r\n<p>The Franke Antea range consists of stylish fragranite and stainless steel sinks. With a rounded sink design, the Antea variety of sinks are both sleek and modern.&nbsp; Have a scan through, see what you think, and get your sink now! It couldn\'t be easier.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 450mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Position of drainer: Reversible</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available finish: Onyx, Polar white, Coffee</li>\r\n</ul></div></div></div>'),(15812,155,0,6152,'Exclude'),(15813,85,5,6153,'Franke Antea AZG 621 Inset 2.0 Bowl Kitchen Sink'),(15814,85,0,6153,'Franke Antea AZG 621 Inset 2.0 Bowl Kitchen Sink'),(15815,75,5,6153,'<p><span style=\"font-size: medium;\"><strong>Franke Antea AZG 621 Inset 2.0 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Double bowls sink</li>       \n<li>Cabinet size: 800mm</li>\n<li>Installation type: Inset</li>\n<li>Position of drainer: Reversible</li>\n<li>Sink: Fragranite</li>\n<li>Drainers number: 1</li>\n<li>Tap ledge: No</li>\n<li>Waste kit include: Yes</li>\n<li>Siphon included: No</li>\n<li>Number of tap holes: 2 - pre drilled</li>\n<li>Soap dispenser hole: No</li>\n<li>Available colour: Polar white, onyx and stone grey</li>\n</ul>'),(15816,75,0,6153,'<p><span style=\"font-size: medium;\"><strong>Franke Antea AZG 621 Inset 2.0 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Double bowls sink</li>       \n<li>Cabinet size: 800mm</li>\n<li>Installation type: Inset</li>\n<li>Position of drainer: Reversible</li>\n<li>Sink: Fragranite</li>\n<li>Drainers number: 1</li>\n<li>Tap ledge: No</li>\n<li>Waste kit include: Yes</li>\n<li>Siphon included: No</li>\n<li>Number of tap holes: 2 - pre drilled</li>\n<li>Soap dispenser hole: No</li>\n<li>Available colour: Polar white, onyx and stone grey</li>\n</ul>'),(15817,155,0,6153,'Exclude'),(15818,85,5,6154,'Franke Antea AZG 651 Inset 1.5 Bowl Kitchen Sink'),(15819,85,0,6154,'Franke Antea AZG 651 Inset 1.5 Bowl Kitchen Sink'),(15820,75,5,6154,'<p><span style=\"font-size: medium;\"><strong>Franke Antea AZG 651 Inset 1.5 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>One and half bowls sink</li>       \n<li>Cabinet size: 600mm</li>\n<li>Installation type: Inset</li>\n<li>Position of drainer: Reversible</li>\n<li>Sink: Fragranite</li>\n<li>Drainers number: 1</li>\n<li>Tap ledge: No</li>\n<li>Waste kit include: Yes</li>\n<li>Siphon included: No</li>\n<li>Number of tap holes: 2 - pre drilled</li>\n<li>Soap dispenser hole: No</li>\n<li>Available colour: Polar white, onyx and stone grey</li>\n</ul>'),(15821,75,0,6154,'<p><span style=\"font-size: medium;\"><strong>Franke Antea AZG 651 Inset 1.5 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>One and half bowls sink</li>       \n<li>Cabinet size: 600mm</li>\n<li>Installation type: Inset</li>\n<li>Position of drainer: Reversible</li>\n<li>Sink: Fragranite</li>\n<li>Drainers number: 1</li>\n<li>Tap ledge: No</li>\n<li>Waste kit include: Yes</li>\n<li>Siphon included: No</li>\n<li>Number of tap holes: 2 - pre drilled</li>\n<li>Soap dispenser hole: No</li>\n<li>Available colour: Polar white, onyx and stone grey</li>\n</ul>'),(15822,155,0,6154,'Exclude'),(15823,85,5,6155,'Franke Antea AZN 611-100 Inset 1 Bowl Kitchen Sink Stainless Steel'),(15824,85,0,6155,'Franke Antea AZN 611-100 Inset 1 Bowl Kitchen Sink Stainless Steel'),(15825,75,5,6155,'<style>#html-body [data-pb-style=W2WBFEB]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"W2WBFEB\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong id=\"IGEMW9B\">Franke Antea AZN 611-100 Inset 1 Bowl Kitchen Sink Stainless Steel</strong></span></p>\r\n<p><strong>FRANKE ANTEA SINKS</strong></p>\r\n<p>The Franke Antea range consists of stylish fragranite and stainless steel sinks. With a rounded sink design, the Antea variety of sinks are both sleek and modern.&nbsp; Have a scan through, see what you think, and get your sink now! It couldn\'t be easier. ANTEA AZN 611-100&nbsp; Inset, Reversible, Polished Stainless Steel, Waste with Slotted Overflow. The Franke Antea wide range consists of trendy fragranite and stainless steel sinks. With a rounded sink design, the Antea range of sinks is both glossy and modern.&nbsp;&nbsp;</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Position of drainer: Reversible</li>\r\n</ul></div></div></div>'),(15826,75,0,6155,'<style>#html-body [data-pb-style=W2WBFEB]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"W2WBFEB\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong id=\"IGEMW9B\">Franke Antea AZN 611-100 Inset 1 Bowl Kitchen Sink Stainless Steel</strong></span></p>\r\n<p><strong>FRANKE ANTEA SINKS</strong></p>\r\n<p>The Franke Antea range consists of stylish fragranite and stainless steel sinks. With a rounded sink design, the Antea variety of sinks are both sleek and modern.&nbsp; Have a scan through, see what you think, and get your sink now! It couldn\'t be easier. ANTEA AZN 611-100&nbsp; Inset, Reversible, Polished Stainless Steel, Waste with Slotted Overflow. The Franke Antea wide range consists of trendy fragranite and stainless steel sinks. With a rounded sink design, the Antea range of sinks is both glossy and modern.&nbsp;&nbsp;</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Position of drainer: Reversible</li>\r\n</ul></div></div></div>'),(15827,155,0,6155,'Exclude'),(15828,85,5,6156,'Franke Antea AZN 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel'),(15829,85,0,6156,'Franke Antea AZN 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel'),(15830,75,5,6156,'<p><span style=\"font-size: medium;\"><strong>Franke Antea AZN 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single bowl sink</li>\n<li>Cabinet size: 450mm</li>\n<li>Installation type: Inset</li>\n<li>Sink: Stainless steel</li>\n<li>Position of drainer: Reversible</li>\n</ul>'),(15831,75,0,6156,'<p><span style=\"font-size: medium;\"><strong>Franke Antea AZN 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single bowl sink</li>\n<li>Cabinet size: 450mm</li>\n<li>Installation type: Inset</li>\n<li>Sink: Stainless steel</li>\n<li>Position of drainer: Reversible</li>\n</ul>'),(15832,155,0,6156,'Exclude'),(15833,85,5,6157,'Franke Antea AZN 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(15834,85,0,6157,'Franke Antea AZN 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(15835,75,5,6157,'<p><span style=\"font-size: medium;\"><strong>Franke Antea AZN 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>One and half bowls sink</li>\n<li>Cabinet size: 600mm</li>\n<li>Installation type: Inset</li>\n<li>Position of drainer: Reversible</li>\n<li>Sink: Stainless steel</li>\n</ul>\n'),(15836,75,0,6157,'<p><span style=\"font-size: medium;\"><strong>Franke Antea AZN 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>One and half bowls sink</li>\n<li>Cabinet size: 600mm</li>\n<li>Installation type: Inset</li>\n<li>Position of drainer: Reversible</li>\n<li>Sink: Stainless steel</li>\n</ul>\n'),(15837,155,0,6157,'Exclude'),(15838,85,5,6158,'Franke BAK 710 Belfast SINK, 1.0 Bowl Kitchen Sink, Ceramic White Sink, Franke 130.0050.116 Kitchen system'),(15839,85,0,6158,'Franke BAK 710 Belfast SINK, 1.0 Bowl Kitchen Sink, Ceramic White Sink, Franke 130.0050.116 Kitchen system'),(15840,75,5,6158,'<style>#html-body [data-pb-style=K8MNAH0]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"K8MNAH0\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke BAK 710 Belfast 1.0 Bowl Kitchen Sink Ceramic White - 130.0050.116</strong></span></p><p>\r\nThis Franke Belfast kitchen sink is as unique as you are. The ravishing kitchen sink looks stylish and smart with glossy white finish that remarkably suits any kitchen decor. It has been manufactured from ceramic white sinks so you will find it resistant to heat and it stops bacteria from growing. It is not only hygienic but suits your kitchen environment as well as it is a perfect choice for daily use. It makes your cooking preparation moments more comfortable. The deep bowl provides maximum use without compromising its strength and as well as it is easy to clean and maintain.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n\r\n<ul> \r\n<li>Single bowl sink</li>          \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Sit on</li>\r\n<li>Sink: Ceramic</li>\r\n<li>Colour: White</li>\r\n</ul>\r\n</div></div></div>'),(15841,75,0,6158,'<style>#html-body [data-pb-style=K8MNAH0]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"K8MNAH0\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke BAK 710 Belfast 1.0 Bowl Kitchen Sink Ceramic White - 130.0050.116</strong></span></p><p>\r\nThis Franke Belfast kitchen sink is as unique as you are. The ravishing kitchen sink looks stylish and smart with glossy white finish that remarkably suits any kitchen decor. It has been manufactured from ceramic white sinks so you will find it resistant to heat and it stops bacteria from growing. It is not only hygienic but suits your kitchen environment as well as it is a perfect choice for daily use. It makes your cooking preparation moments more comfortable. The deep bowl provides maximum use without compromising its strength and as well as it is easy to clean and maintain.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n\r\n<ul> \r\n<li>Single bowl sink</li>          \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Sit on</li>\r\n<li>Sink: Ceramic</li>\r\n<li>Colour: White</li>\r\n</ul>\r\n</div></div></div>'),(15842,155,0,6158,'Exclude'),(15843,85,5,6159,'Reginox Belfast Contemporary 1 Bowl Ceramic Kitchen Inset Sink'),(15844,85,0,6159,'Reginox Belfast Contemporary 1 Bowl Ceramic Kitchen Inset Sink'),(15845,75,5,6159,'<p><span style=\"font-size: medium;\"><strong>Reginox Belfast Contemporary 1 Bowl Ceramic Kitchen Inset Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Contemporary kitchen sink</strong> is offered to you by Reginox that always manufactures products that can facilitate your lives in a best way. The ceramic material used in its manufacturing makes it very stylish and amazingly practical. It will combine beautifully with any work surfaces such as granite, wood, and glass. It will stand up to impact, staining, and heat. Place it from above the worktop for inset installation and the size of the cabinet should be 600mm whereas the depth should be 255mm. The colour of this <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>ceramic sink</strong></span></a> is white and the amazing four-cornered square shape of this bowl look great in with any work surface. Get it from Banyo as it is offering an exciting discount on this product.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Belfast Contemporary 1 Bowl Ceramic Kitchen Inset Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink unit dimensions: 525 x 390 mm</li>\r\n<li>Total dimensions: 595 x 460 mm</li>\r\n<li>Depth: 255 mm</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Colour ceramic: White</li>\r\n<li>Waste kit supplied separately</li>\r\n<li>Waste flange is 85 mm, black plug 50 mm</li>\r\n</ul>\r\n'),(15846,75,0,6159,'<p><span style=\"font-size: medium;\"><strong>Reginox Belfast Contemporary 1 Bowl Ceramic Kitchen Inset Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Contemporary kitchen sink</strong> is offered to you by Reginox that always manufactures products that can facilitate your lives in a best way. The ceramic material used in its manufacturing makes it very stylish and amazingly practical. It will combine beautifully with any work surfaces such as granite, wood, and glass. It will stand up to impact, staining, and heat. Place it from above the worktop for inset installation and the size of the cabinet should be 600mm whereas the depth should be 255mm. The colour of this <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>ceramic sink</strong></span></a> is white and the amazing four-cornered square shape of this bowl look great in with any work surface. Get it from Banyo as it is offering an exciting discount on this product.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Belfast Contemporary 1 Bowl Ceramic Kitchen Inset Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink unit dimensions: 525 x 390 mm</li>\r\n<li>Total dimensions: 595 x 460 mm</li>\r\n<li>Depth: 255 mm</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Colour ceramic: White</li>\r\n<li>Waste kit supplied separately</li>\r\n<li>Waste flange is 85 mm, black plug 50 mm</li>\r\n</ul>\r\n'),(15847,155,0,6159,'Exclude'),(15848,85,5,6160,'Reginox Best 450 Inset 2 Bowl Granite Kitchen Sink'),(15849,85,0,6160,'Reginox Best 450 Inset 2 Bowl Granite Kitchen Sink'),(15850,75,5,6160,'<style>#html-body [data-pb-style=HT5YTNR]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"HT5YTNR\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Best 450 Inset 2 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Best 450 Inset 2 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 900mm</li>\r\n<li>Sink unit dimensions: 365 x 448 / 365 x 448 mm</li>\r\n<li>Total dimensions: 860 x 510 mm</li>\r\n<li>Depth: 200 mm / 200 mm</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Colour: White, Black, Titanium</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One-bowl sink with draining area</li>\r\n<li>Reversible sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n<li>Mimimal bowl radius</li>\r\n<li>Bigger bowls</li>\r\n<li>Integrated drain cover</li>\r\n<li>Rectangular overflow</li>\r\n</ul></div></div></div>'),(15851,75,0,6160,'<style>#html-body [data-pb-style=HT5YTNR]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"HT5YTNR\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Best 450 Inset 2 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Best 450 Inset 2 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 900mm</li>\r\n<li>Sink unit dimensions: 365 x 448 / 365 x 448 mm</li>\r\n<li>Total dimensions: 860 x 510 mm</li>\r\n<li>Depth: 200 mm / 200 mm</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Colour: White, Black, Titanium</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One-bowl sink with draining area</li>\r\n<li>Reversible sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n<li>Mimimal bowl radius</li>\r\n<li>Bigger bowls</li>\r\n<li>Integrated drain cover</li>\r\n<li>Rectangular overflow</li>\r\n</ul></div></div></div>'),(15852,155,0,6160,'Exclude'),(15853,85,5,6161,'Reginox Best 475 Inset 1.5 Bowl Granite Kitchen Sink'),(15854,85,0,6161,'Reginox Best 475 Inset 1.5 Bowl Granite Kitchen Sink'),(15855,75,5,6161,'<style>#html-body [data-pb-style=VGXLRFN]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"VGXLRFN\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Best 475 Inset 1.5 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Best 475 Inset 1.5 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink unit dimensions: 299 x 448 / 149 x 448 mm</li>\r\n<li>Total dimensions: 1000 x 510 mm</li>\r\n<li>Depth: 200 mm / 140 mm</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Colour: White, Black, Titanium</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One-bowl sink with draining area</li>\r\n<li>Reversible sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n<li>Mimimal bowl radius</li>\r\n<li>Bigger bowls</li>\r\n<li>Integrated drain cover</li>\r\n<li>Rectangular overflow</li>\r\n</ul></div></div></div>'),(15856,75,0,6161,'<style>#html-body [data-pb-style=VGXLRFN]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"VGXLRFN\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Best 475 Inset 1.5 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Best 475 Inset 1.5 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink unit dimensions: 299 x 448 / 149 x 448 mm</li>\r\n<li>Total dimensions: 1000 x 510 mm</li>\r\n<li>Depth: 200 mm / 140 mm</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Colour: White, Black, Titanium</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One-bowl sink with draining area</li>\r\n<li>Reversible sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n<li>Mimimal bowl radius</li>\r\n<li>Bigger bowls</li>\r\n<li>Integrated drain cover</li>\r\n<li>Rectangular overflow</li>\r\n</ul></div></div></div>'),(15857,155,0,6161,'Exclude'),(15858,85,5,6162,'Reginox Best 480 Inset 1 Bowl Granite Kitchen Sink'),(15859,85,0,6162,'Reginox Best 480 Inset 1 Bowl Granite Kitchen Sink'),(15860,75,5,6162,'<style>#html-body [data-pb-style=AI34L5J]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"AI34L5J\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Best 480 Inset 1 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Best 480 Inset 1 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink unit dimensions: 478 x 421 mm</li>\r\n<li>Total dimensions: 1000 x 510 mm</li>\r\n<li>Depth: 200 mm</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Colour: White, Black, Titanium</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One-bowl sink with draining area</li>\r\n<li>Reversible sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n<li>Mimimal bowl radius</li>\r\n<li>Bigger bowls</li>\r\n<li>Integrated drain cover</li>\r\n<li>Rectangular overflow</li>\r\n</ul>\r\n</div></div></div>'),(15861,75,0,6162,'<style>#html-body [data-pb-style=AI34L5J]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"AI34L5J\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Best 480 Inset 1 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Best 480 Inset 1 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink unit dimensions: 478 x 421 mm</li>\r\n<li>Total dimensions: 1000 x 510 mm</li>\r\n<li>Depth: 200 mm</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Colour: White, Black, Titanium</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One-bowl sink with draining area</li>\r\n<li>Reversible sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n<li>Mimimal bowl radius</li>\r\n<li>Bigger bowls</li>\r\n<li>Integrated drain cover</li>\r\n<li>Rectangular overflow</li>\r\n</ul>\r\n</div></div></div>'),(15862,155,0,6162,'Exclude'),(15863,85,5,6163,'Reginox Comfort BETA 20 Inset 2 Bowl Kitchen Sink'),(15864,85,0,6163,'Reginox Comfort BETA 20 Inset 2 Bowl Kitchen Sink'),(15865,75,5,6163,'<p><span style=\"font-size: medium;\"><strong>Reginox Comfort BETA 20 Inset 2 Bowl Kitchen Sink</strong></span></p>\r\n<p>Reginox Comfort Beta is an elegantly designed product of Reginox. The two bowls of this sink rendered for excessive use as you can wash vegetables, fruits or other things in one bowl while meat can be washed in other bowl. They both are of same size and have accurate positions of the drainers to drain the water efficiently. It will keep the hygiene level high as the bacterial growth will be reduced by 99%. You will need to fit it from above the worktop as it requires inset installation that makes it suitable with any worktop. It resists corrosion, rust, and stains because it has been crafted from high-grade material. Banyo is offering an incredible discount offer on this product.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Comfort BETA 20 Inset 2 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink unit dimensions: 330 x 350 / 330 x 350 mm</li>\r\n<li>Total dimensions: 780 x 430 mm</li>\r\n<li>Depth: 145 mm</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Type: Double bowl sinks</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Range: Comfort</li>\r\n<li>Series: Beta serie</li>\r\n<li>Packaging: Box</li>\r\n</ul>\r'),(15866,75,0,6163,'<p><span style=\"font-size: medium;\"><strong>Reginox Comfort BETA 20 Inset 2 Bowl Kitchen Sink</strong></span></p>\r\n<p>Reginox Comfort Beta is an elegantly designed product of Reginox. The two bowls of this sink rendered for excessive use as you can wash vegetables, fruits or other things in one bowl while meat can be washed in other bowl. They both are of same size and have accurate positions of the drainers to drain the water efficiently. It will keep the hygiene level high as the bacterial growth will be reduced by 99%. You will need to fit it from above the worktop as it requires inset installation that makes it suitable with any worktop. It resists corrosion, rust, and stains because it has been crafted from high-grade material. Banyo is offering an incredible discount offer on this product.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Comfort BETA 20 Inset 2 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink unit dimensions: 330 x 350 / 330 x 350 mm</li>\r\n<li>Total dimensions: 780 x 430 mm</li>\r\n<li>Depth: 145 mm</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Type: Double bowl sinks</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Range: Comfort</li>\r\n<li>Series: Beta serie</li>\r\n<li>Packaging: Box</li>\r\n</ul>\r'),(15867,155,0,6163,'Exclude'),(15868,85,5,6164,'Franke Basis BFG 611-78 Kitchen Sink'),(15869,85,0,6164,'Franke Basis BFG 611-78 Kitchen Sink'),(15870,75,5,6164,'<p><span style=\"font-size: medium;\"><strong>Franke Basis BFG 611-78 Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single bowl sink</li>\n<li>Sink: Fragranite</li>    \n<li>Cabinet size: 450mm</li>\n<li>Installation type: Inset</li>\n<li>Position of drainer: Reversible</li>\n<li>Comes with a 35mm diameter mixer hole</li>\n<li>Available finishes: Polar white, Coffee, Onyx, Stone Grey and Oyster</li>\n</ul>'),(15871,75,0,6164,'<p><span style=\"font-size: medium;\"><strong>Franke Basis BFG 611-78 Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single bowl sink</li>\n<li>Sink: Fragranite</li>    \n<li>Cabinet size: 450mm</li>\n<li>Installation type: Inset</li>\n<li>Position of drainer: Reversible</li>\n<li>Comes with a 35mm diameter mixer hole</li>\n<li>Available finishes: Polar white, Coffee, Onyx, Stone Grey and Oyster</li>\n</ul>'),(15872,155,0,6164,'Exclude'),(15873,85,5,6165,'Franke Basis BFG 611-97 Inset 1 Bowl Kitchen Sink Fragranite'),(15874,85,0,6165,'Franke Basis BFG 611-97 Inset 1 Bowl Kitchen Sink Fragranite'),(15875,75,5,6165,'<style>#html-body [data-pb-style=KS4GNP7]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"KS4GNP7\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Basis BFG 611-97 Inset 1 Bowl Kitchen Sink Fragranite</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Position of drainer: Reversible</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Polar white, onyx, oyster, coffee stone grey, slate grey, matt black</li>\r\n</ul></div></div></div>'),(15876,75,0,6165,'<style>#html-body [data-pb-style=KS4GNP7]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"KS4GNP7\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Basis BFG 611-97 Inset 1 Bowl Kitchen Sink Fragranite</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Position of drainer: Reversible</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Polar white, onyx, oyster, coffee stone grey, slate grey, matt black</li>\r\n</ul></div></div></div>'),(15877,155,0,6165,'Exclude'),(15878,85,5,6166,'Franke BFG 651 Sink, Fragranite Inset Sink,  Franke United Kingdom,Franke Appliances,Bathroom Mixer Taps'),(15879,85,0,6166,'Franke BFG 651 Sink, Fragranite Inset Sink,  Franke United Kingdom,Franke Appliances,Bathroom Mixer Taps'),(15880,75,5,6166,'<style>#html-body [data-pb-style=C3H8K6I]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">\r\n\r\n</div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"C3H8K6I\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke BFG 651 Basis Fragranite Inset 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p>Functionality, elegance and stylishness have come together in Franke basis fragranite kitchen sink, making it a must-have kitchen accessory. The two bowls of this beautiful sink have been designed to give ease of use. You can wash multiple things at the same time due to these two bowls. As the kitchen is the home ground of bacteria but the fragranite material used in manufacturing prevents bacterial growth by 99%. It is easy to empty the bowl and it requires very less time to clean the bowl. The position of its drainer is reversible and its cabinet size is 600mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Dimensions: 970mm x 500mm</li>\r\n<li>Bowl Size: 340mm x 420mm x 200mm</li>\r\n<li>Small Bowl Size: 150mm x 290mm x 100mm</li>\r\n<li>Cut-Out Size: 950mm x 480mm</li>\r\n<li>Cut-Out Template: No</li>\r\n<li>Position of Drainer: Reversible</li>\r\n<li>Finish: Polar White, Coffee, Onyx, Stone Grey, Oyster, Slate grey, Matt black</li>\r\n</ul></div></div></div>'),(15881,75,0,6166,'<style>#html-body [data-pb-style=C3H8K6I]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">\r\n\r\n</div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"C3H8K6I\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke BFG 651 Basis Fragranite Inset 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p>Functionality, elegance and stylishness have come together in Franke basis fragranite kitchen sink, making it a must-have kitchen accessory. The two bowls of this beautiful sink have been designed to give ease of use. You can wash multiple things at the same time due to these two bowls. As the kitchen is the home ground of bacteria but the fragranite material used in manufacturing prevents bacterial growth by 99%. It is easy to empty the bowl and it requires very less time to clean the bowl. The position of its drainer is reversible and its cabinet size is 600mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Dimensions: 970mm x 500mm</li>\r\n<li>Bowl Size: 340mm x 420mm x 200mm</li>\r\n<li>Small Bowl Size: 150mm x 290mm x 100mm</li>\r\n<li>Cut-Out Size: 950mm x 480mm</li>\r\n<li>Cut-Out Template: No</li>\r\n<li>Position of Drainer: Reversible</li>\r\n<li>Finish: Polar White, Coffee, Onyx, Stone Grey, Oyster, Slate grey, Matt black</li>\r\n</ul></div></div></div>'),(15882,155,0,6166,'Exclude'),(15883,85,5,6167,'Franke Box Center BWX 120-41-27 Inset Stainless Steel 1.5 Bowl Sink'),(15884,85,0,6167,'Franke Box Center BWX 120-41-27 Inset Stainless Steel 1.5 Bowl Sink'),(15885,75,5,6167,'<p><span style=\"font-size: medium;\"><strong>Franke Box Center BWX 120-41-27 Inset Stainless Steel 1.5 Bowl Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 900mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Slim top edge profile</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Accessories included in box : </li>\r\n<li>3 knives</li>\r\n<li>Chopping boards (1 wood, 1 plastic sanitized)</li>\r\n<li>Strainer bowl</li>\r\n<li>Draining rack</li>\r\n<li>Pop up waste</li>\r\n<li>Flush cover</li>\r\n</ul>'),(15886,75,0,6167,'<p><span style=\"font-size: medium;\"><strong>Franke Box Center BWX 120-41-27 Inset Stainless Steel 1.5 Bowl Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 900mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Slim top edge profile</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Accessories included in box : </li>\r\n<li>3 knives</li>\r\n<li>Chopping boards (1 wood, 1 plastic sanitized)</li>\r\n<li>Strainer bowl</li>\r\n<li>Draining rack</li>\r\n<li>Pop up waste</li>\r\n<li>Flush cover</li>\r\n</ul>'),(15887,155,0,6167,'Exclude'),(15888,85,5,6168,'Franke Box Center BWX 220 41-27 Inset Stainless Steel 1.5 Bowl Sink'),(15889,85,0,6168,'Franke Box Center BWX 220 41-27 Inset Stainless Steel 1.5 Bowl Sink'),(15890,75,5,6168,'<p><span style=\"font-size: medium;\"><strong>Franke Box Center BWX 220 41-27 Inset Stainless Steel 1.5 Bowl Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 900mm</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Installation type: Inset</li>\r\n</ul>\r\n'),(15891,75,0,6168,'<p><span style=\"font-size: medium;\"><strong>Franke Box Center BWX 220 41-27 Inset Stainless Steel 1.5 Bowl Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 900mm</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Installation type: Inset</li>\r\n</ul>\r\n'),(15892,155,0,6168,'Exclude'),(15893,85,5,6169,'Franke Box Center BWX 220 54-27 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(15894,85,0,6169,'Franke Box Center BWX 220 54-27 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(15895,75,5,6169,'<p><span style=\"font-size: medium;\"><strong>Franke Box Center BWX 220 54-27 Inset 1.5 Bowl Kitchen Sink Stainless Steel</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>One and half bowls sink</li>    \n<li>Cabinet size: 900mm</li>\n<li>Installation type: Inset</li>\n<li>Sink: Stainless steel</li>\n<li>Position of small bowl: Right hand and left hand side</li>\n<li>Edge profile flushmount</li>\n<li>Accessories included : </li>\n<li>Plastic and wooden chopping boards</li>\n<li>Inox strainer bowl</li>\n\n</ul>\n'),(15896,75,0,6169,'<p><span style=\"font-size: medium;\"><strong>Franke Box Center BWX 220 54-27 Inset 1.5 Bowl Kitchen Sink Stainless Steel</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>One and half bowls sink</li>    \n<li>Cabinet size: 900mm</li>\n<li>Installation type: Inset</li>\n<li>Sink: Stainless steel</li>\n<li>Position of small bowl: Right hand and left hand side</li>\n<li>Edge profile flushmount</li>\n<li>Accessories included : </li>\n<li>Plastic and wooden chopping boards</li>\n<li>Inox strainer bowl</li>\n\n</ul>\n'),(15897,155,0,6169,'Exclude'),(15898,85,5,6170,'Franke Box BXX 110-16 Half Bowl Kitchen Sink'),(15899,85,0,6170,'Franke Box BXX 110-16 Half Bowl Kitchen Sink'),(15900,75,5,6170,'<style>#html-body [data-pb-style=X3CS8P2]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"X3CS8P2\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Box BXX 110-16 Half Bowl Kitchen Sink</strong></span></p>\r\n<h2><strong><span style=\"font-size: 16px;\">Key Features</span></strong></h2>\r\n<ul>\r\n<li>Product code: BOX BXX 110 16</li>\r\n<li>Type: Half bowl sink</li>\r\n<li>Material: Brushed stainless steel</li>\r\n<li>Includes: 3½\" Basket strainer waste and hygienic overflow</li>\r\n<li>Mounting options: Can be inset or undermounted</li>\r\n<li>Warranty: 50-year guarantee on all franke sinks</li>\r\n</ul></div></div></div>'),(15901,75,0,6170,'<style>#html-body [data-pb-style=X3CS8P2]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"X3CS8P2\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Box BXX 110-16 Half Bowl Kitchen Sink</strong></span></p>\r\n<h2><strong><span style=\"font-size: 16px;\">Key Features</span></strong></h2>\r\n<ul>\r\n<li>Product code: BOX BXX 110 16</li>\r\n<li>Type: Half bowl sink</li>\r\n<li>Material: Brushed stainless steel</li>\r\n<li>Includes: 3½\" Basket strainer waste and hygienic overflow</li>\r\n<li>Mounting options: Can be inset or undermounted</li>\r\n<li>Warranty: 50-year guarantee on all franke sinks</li>\r\n</ul></div></div></div>'),(15902,155,0,6170,'Exclude'),(15903,85,5,6171,'Franke Box BXX 110 40 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(15904,85,0,6171,'Franke Box BXX 110 40 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(15905,75,5,6171,'<p><span style=\"font-size: medium;\"><strong>Franke Box BXX 110 40 Undermount 1 Bowl Kitchen Sink Stainless Steel</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single bowl sink</li>\n<li>Patented hygienic overflow</li>   \n<li>Cabinet size: 500mm</li>\n<li>Installation type: Undermount</li>\n<li>Sink: Stainless steel</li>\n<li>Compatible with waste disposal unit</li>\n<li>Edge profile flushmount</li>\n<li>Edge profile slimtop</li>\n</ul>'),(15906,75,0,6171,'<p><span style=\"font-size: medium;\"><strong>Franke Box BXX 110 40 Undermount 1 Bowl Kitchen Sink Stainless Steel</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single bowl sink</li>\n<li>Patented hygienic overflow</li>   \n<li>Cabinet size: 500mm</li>\n<li>Installation type: Undermount</li>\n<li>Sink: Stainless steel</li>\n<li>Compatible with waste disposal unit</li>\n<li>Edge profile flushmount</li>\n<li>Edge profile slimtop</li>\n</ul>'),(15907,155,0,6171,'Exclude'),(15908,85,5,6172,'Franke Box BXX 110 50 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(15909,85,0,6172,'Franke Box BXX 110 50 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(15910,75,5,6172,'<p><span style=\"font-size: medium;\"><strong>Franke Box BXX 110 50 Undermount 1 Bowl Kitchen Sink Stainless Steel</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>    \n<li>Single bowl sink</li>\n<li>Patented hygienic overflow</li>      \n<li>Cabinet size: 550mm</li>\n<li>Installation type: Undermount</li>\n<li>Sink: Stainless steel</li>\n<li>Compatible with waste disposal unit</li>\n<li>Edge profile flushmount</li>\n<li>Edge profile slimtop</li>\n</ul>\n\n'),(15911,75,0,6172,'<p><span style=\"font-size: medium;\"><strong>Franke Box BXX 110 50 Undermount 1 Bowl Kitchen Sink Stainless Steel</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>    \n<li>Single bowl sink</li>\n<li>Patented hygienic overflow</li>      \n<li>Cabinet size: 550mm</li>\n<li>Installation type: Undermount</li>\n<li>Sink: Stainless steel</li>\n<li>Compatible with waste disposal unit</li>\n<li>Edge profile flushmount</li>\n<li>Edge profile slimtop</li>\n</ul>\n\n'),(15912,155,0,6172,'Exclude'),(15913,85,5,6173,'Franke Box BXX 110 54 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(15914,85,0,6173,'Franke Box BXX 110 54 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(15915,75,5,6173,'<p><span style=\"font-size: medium;\"><strong>Franke Box BXX 110 54 Undermount 1 Bowl Kitchen Sink Stainless Steel</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul> \n<li>Single bowl sink</li>\n<li>Patented hygienic overflow</li>         \n<li>Cabinet size: 800mm</li>\n<li>Installation type: Undermount</li>\n<li>Sink: Stainless steel</li>\n<li>Compatible with waste disposal unit</li>\n</ul>'),(15916,75,0,6173,'<p><span style=\"font-size: medium;\"><strong>Franke Box BXX 110 54 Undermount 1 Bowl Kitchen Sink Stainless Steel</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul> \n<li>Single bowl sink</li>\n<li>Patented hygienic overflow</li>         \n<li>Cabinet size: 800mm</li>\n<li>Installation type: Undermount</li>\n<li>Sink: Stainless steel</li>\n<li>Compatible with waste disposal unit</li>\n</ul>'),(15917,155,0,6173,'Exclude'),(15918,85,5,6174,'Franke BXX 110-68 Box Single Bowl Undermount Kitchen Sink'),(15919,85,0,6174,'Franke BXX 110-68 Box Single Bowl Undermount Kitchen Sink'),(15920,75,5,6174,'<p><span style=\"font-size: medium;\"><strong>Franke BXX 110-68 Box Single Bowl Undermount Kitchen Sink</strong></span></p>\n<p>The Franke Box BXX 110-68 is a high-quality, durable single bowl sink designed for both functionality and style. Made from quality stainless steel, the brushed finish adds to its contemporary look. The large bowl provides plenty of room for washing up, and the sink comes with a hygienic overflow and a stainless steel basket strainer waste.</p>\n<h2><strong><span style=\"font-size: 16px;\">Key Features:</span></strong></h2>\n<ul>\n<li>Product code: BOX BXX 110 68</li>\n<li>Type: Single bowl sink</li>\n<li>Material: Brushed stainless steel</li>\n<li>Includes: 3½\" basket strainer waste and hygienic overflow</li>\n<li>Compatibility: Compatible with waste disposal units</li>\n<li>Cabinet Fit: Fits into 800mm cabinets</li>\n<li>Warranty: 50-year guarantee on all franke sinks</li>\n</ul>\n<h2><strong><span style=\"font-size: 16px;\">Mounting Options:</span></strong></h2>\n<ul>\n<li>Flushmount Installation</li>\n<li>Slim top Installation</li>\n<li>Undermount Installation</li>\n</ul>'),(15921,75,0,6174,'<p><span style=\"font-size: medium;\"><strong>Franke BXX 110-68 Box Single Bowl Undermount Kitchen Sink</strong></span></p>\n<p>The Franke Box BXX 110-68 is a high-quality, durable single bowl sink designed for both functionality and style. Made from quality stainless steel, the brushed finish adds to its contemporary look. The large bowl provides plenty of room for washing up, and the sink comes with a hygienic overflow and a stainless steel basket strainer waste.</p>\n<h2><strong><span style=\"font-size: 16px;\">Key Features:</span></strong></h2>\n<ul>\n<li>Product code: BOX BXX 110 68</li>\n<li>Type: Single bowl sink</li>\n<li>Material: Brushed stainless steel</li>\n<li>Includes: 3½\" basket strainer waste and hygienic overflow</li>\n<li>Compatibility: Compatible with waste disposal units</li>\n<li>Cabinet Fit: Fits into 800mm cabinets</li>\n<li>Warranty: 50-year guarantee on all franke sinks</li>\n</ul>\n<h2><strong><span style=\"font-size: 16px;\">Mounting Options:</span></strong></h2>\n<ul>\n<li>Flushmount Installation</li>\n<li>Slim top Installation</li>\n<li>Undermount Installation</li>\n</ul>'),(15922,155,0,6174,'Exclude'),(15923,85,5,6175,'Franke Box BXX 160 34-16 Undermount 1.5 Bowl Kitchen Sink Stainless Steel'),(15924,85,0,6175,'Franke Box BXX 160 34-16 Undermount 1.5 Bowl Kitchen Sink Stainless Steel'),(15925,75,5,6175,'<p><span style=\"font-size: medium;\"><strong>Franke Box BXX 160 34-16 Undermount 1.5 Bowl Kitchen Sink Stainless Steel</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>One and half bowls sink</li>           \n<li>Patented hygienic overflow</li>\n<li>Cabinet size: 600mm</li>\n<li>Installation type: Undermount</li>\n<li>Compatible with waste disposal unit</li>\n<li>Sink: Stainless steel</li>\n</ul>'),(15926,75,0,6175,'<p><span style=\"font-size: medium;\"><strong>Franke Box BXX 160 34-16 Undermount 1.5 Bowl Kitchen Sink Stainless Steel</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>One and half bowls sink</li>           \n<li>Patented hygienic overflow</li>\n<li>Cabinet size: 600mm</li>\n<li>Installation type: Undermount</li>\n<li>Compatible with waste disposal unit</li>\n<li>Sink: Stainless steel</li>\n</ul>'),(15927,155,0,6175,'Exclude'),(15928,85,5,6176,'Reginox Elite Centurio L Integrated 1.5 Bowl Kitchen Sink'),(15929,85,0,6176,'Reginox Elite Centurio L Integrated 1.5 Bowl Kitchen Sink'),(15930,75,5,6176,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Centurio L Integrated 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Centurio L Integrated 1.5 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink Unit Dimensions: 360 x 420 / 160 x 300 mm</li>\r\n<li>Total Dimensions: 940 x 490 mm</li>\r\n<li>Depth: 180 mm / 130 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Sinks with drainer, One and half bowl</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Centurio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>Sink is reversible</li>\r\n<li>Including stainless steel colander B0899RLU00GPZ</li>\r\n</ul>\r'),(15931,75,0,6176,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Centurio L Integrated 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Centurio L Integrated 1.5 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink Unit Dimensions: 360 x 420 / 160 x 300 mm</li>\r\n<li>Total Dimensions: 940 x 490 mm</li>\r\n<li>Depth: 180 mm / 130 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Sinks with drainer, One and half bowl</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Centurio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>Sink is reversible</li>\r\n<li>Including stainless steel colander B0899RLU00GPZ</li>\r\n</ul>\r'),(15932,155,0,6176,'Exclude'),(15933,85,5,6177,'Reginox Centurio L10 Single Bowl Kitchen Sink'),(15934,85,0,6177,'Reginox Centurio L10 Single Bowl Kitchen Sink'),(15935,75,5,6177,'<p><span style=\"font-size: medium;\"><strong>Reginox Centurio L10 Single Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 600mm</li>\n<li>Sink unit dimensions: 360 x 420 mm</li>\n<li>Total dimensions: 850 x 490 mm</li>\n<li>Bowl depth: 180mm </li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(15936,75,0,6177,'<p><span style=\"font-size: medium;\"><strong>Reginox Centurio L10 Single Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 600mm</li>\n<li>Sink unit dimensions: 360 x 420 mm</li>\n<li>Total dimensions: 850 x 490 mm</li>\n<li>Bowl depth: 180mm </li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(15937,155,0,6177,'Exclude'),(15938,85,5,6178,'Reginox Elite Centurio L20 Integrated 2 Bowl Kitchen Sink'),(15939,85,0,6178,'Reginox Elite Centurio L20 Integrated 2 Bowl Kitchen Sink'),(15940,75,5,6178,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Centurio L20 Integrated 2 Bowl Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\">Giving a new look to a kitchen is now easy as <strong>Reginox Elite Centurio kitchen sink</strong> is available in budget friendly price and the features of this sink cannot be seen in any other sink. The shape of this sink is seamless as well as elegant. The accurate size of the holes in the drainer drain water easily and with accurate speed as well as it will not allow food particles to enter the pipe. Reginox Comfort Diplomat kitchen sink has been crafted from superior quality material for making this hygienic. It will not allow bacteria to prevail in your kitchen to keep your kitchen safe for cooking and eating. Stains or scratches cannot stay longer on the surface of Reginox Pacific and so you will be able to clean it in very less time. 800mm is the required size of cabinet for its fitting and 180mm is the depth of one bowl as this <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><strong>sink</strong></a> has two bowls with size and depth. The position of the drainers in these two bowls is also same.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Centurio L20 Integrated 2 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink Unit Dimensions: 360 x 420 / 360 x 420 mm</li>\r\n<li>Total Dimensions: 850 x 490 mm</li>\r\n<li>Depth: 180 mm / 180 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Double bowl sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Centurio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>Sink is reversible</li>\r\n</ul>\r'),(15941,75,0,6178,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Centurio L20 Integrated 2 Bowl Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\">Giving a new look to a kitchen is now easy as <strong>Reginox Elite Centurio kitchen sink</strong> is available in budget friendly price and the features of this sink cannot be seen in any other sink. The shape of this sink is seamless as well as elegant. The accurate size of the holes in the drainer drain water easily and with accurate speed as well as it will not allow food particles to enter the pipe. Reginox Comfort Diplomat kitchen sink has been crafted from superior quality material for making this hygienic. It will not allow bacteria to prevail in your kitchen to keep your kitchen safe for cooking and eating. Stains or scratches cannot stay longer on the surface of Reginox Pacific and so you will be able to clean it in very less time. 800mm is the required size of cabinet for its fitting and 180mm is the depth of one bowl as this <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><strong>sink</strong></a> has two bowls with size and depth. The position of the drainers in these two bowls is also same.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Centurio L20 Integrated 2 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink Unit Dimensions: 360 x 420 / 360 x 420 mm</li>\r\n<li>Total Dimensions: 850 x 490 mm</li>\r\n<li>Depth: 180 mm / 180 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Double bowl sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Centurio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>Sink is reversible</li>\r\n</ul>\r'),(15942,155,0,6178,'Exclude'),(15943,85,5,6179,'Reginox Elite Centurio L30 Integrated 2 Bowl Kitchen Sink'),(15944,85,0,6179,'Reginox Elite Centurio L30 Integrated 2 Bowl Kitchen Sink'),(15945,75,5,6179,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Centurio L30 Integrated 2 Bowl Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Elite Centurio sink</strong> is an elegantly designed product of Reginox. The two bowls of this sink rendered for excessive use as you can wash vegetables, fruits or other things in one bowl while meat can be washed in other bowl. They both are of same size and have accurate positions of the drainers to drain the water efficiently. It will keep the hygiene level high as the bacterial growth will be reduced by 99%. It resists corrosion, rust, and stains because it has been crafted from high-grade material. Banyo is offering an incredible discount offer on this product. Integrated installation is suitable for installing this <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>kitchen sink</strong></span></a> so that the worktop and edge of the sink can fit together seamlessly.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Centurio L30 Integrated 2 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink Unit Dimensions: 360 x 420 / 360 x420 mm</li>\r\n<li>Total Dimensions: 1150 x 490 mm</li>\r\n<li>Depth: 180 mm / 180 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Sinks with drainer, Double bowl sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Centurio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>Sink is reversible</li>\r\n</ul>\r'),(15946,75,0,6179,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Centurio L30 Integrated 2 Bowl Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Elite Centurio sink</strong> is an elegantly designed product of Reginox. The two bowls of this sink rendered for excessive use as you can wash vegetables, fruits or other things in one bowl while meat can be washed in other bowl. They both are of same size and have accurate positions of the drainers to drain the water efficiently. It will keep the hygiene level high as the bacterial growth will be reduced by 99%. It resists corrosion, rust, and stains because it has been crafted from high-grade material. Banyo is offering an incredible discount offer on this product. Integrated installation is suitable for installing this <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>kitchen sink</strong></span></a> so that the worktop and edge of the sink can fit together seamlessly.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Centurio L30 Integrated 2 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink Unit Dimensions: 360 x 420 / 360 x420 mm</li>\r\n<li>Total Dimensions: 1150 x 490 mm</li>\r\n<li>Depth: 180 mm / 180 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Sinks with drainer, Double bowl sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Centurio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>Sink is reversible</li>\r\n</ul>\r'),(15947,155,0,6179,'Exclude'),(15948,85,5,6180,'Blanco CLARON 340/180-IF Stainless Steel Inset Kitchen Sink'),(15949,85,0,6180,'Blanco CLARON 340/180-IF Stainless Steel Inset Kitchen Sink'),(15950,75,5,6180,'<p><span style=\"font-size: medium;\"><strong>Blanco CLARON 340/180-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Satin polish surface</li>\r\n<li>Can be installed reversibly</li>\r\n<li>Style: One & Half Bowl Sink</li>\r\n<li>Overall size: 585 x 440mm</li>\r\n<li>Handing options: Reversible</li>\r\n<li>Version: Without Pop-up Waste</li>\r\n<li>Small bowl depth: 130mm</li>\r\n<li>Large bowl depth: 190mm</li>\r\n<li>Small bowl size: 180 x 400mm</li>\r\n<li>Large bowl size: 340 x 400mm</li>\r\n<li>Concise 10mm radius for a more refined design</li>\r\n<li>Elegant-pure bowl design without visible base pattern</li>\r\n<li>InFino drain system – elegantly integrated and easy-care</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra-deep bowls and distinctively small radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Fixing kit included</li>\r\n<li>Please state hand of bowl</li>\r\n<li>Cut out: Template provided</li>\r\n<li>3 1&sol;2&quot; InFino basket strainer</li>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n</ul>'),(15951,75,0,6180,'<p><span style=\"font-size: medium;\"><strong>Blanco CLARON 340/180-IF Stainless Steel Inset Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Satin polish surface</li>\r\n<li>Can be installed reversibly</li>\r\n<li>Style: One & Half Bowl Sink</li>\r\n<li>Overall size: 585 x 440mm</li>\r\n<li>Handing options: Reversible</li>\r\n<li>Version: Without Pop-up Waste</li>\r\n<li>Small bowl depth: 130mm</li>\r\n<li>Large bowl depth: 190mm</li>\r\n<li>Small bowl size: 180 x 400mm</li>\r\n<li>Large bowl size: 340 x 400mm</li>\r\n<li>Concise 10mm radius for a more refined design</li>\r\n<li>Elegant-pure bowl design without visible base pattern</li>\r\n<li>InFino drain system – elegantly integrated and easy-care</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra-deep bowls and distinctively small radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Fixing kit included</li>\r\n<li>Please state hand of bowl</li>\r\n<li>Cut out: Template provided</li>\r\n<li>3 1&sol;2&quot; InFino basket strainer</li>\r\n<li>Waste and overflow fitting with space-saving pipe</li>\r\n</ul>'),(15952,155,0,6180,'Exclude'),(15953,85,5,6181,'BlancoCLARON 340/180-U Sink,Claron Sink, Blanco Stainless Steel Sinks,CLARON 340/180-U Sink deals'),(15954,85,0,6181,'BlancoCLARON 340/180-U Sink,Claron Sink, Blanco Stainless Steel Sinks,CLARON 340/180-U Sink deals'),(15955,75,5,6181,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 340/180-U Undermount Sink</strong></span></p>\r\n<p>Blanco well-known for its long-time expertise in manufacturing stainless steel sinks now brings to you the Blanco Claron 340/180-U, an undermount sink. Blanco Claron 340/180-U with its premium design is perfect to give your kitchen an outlook with geometrical designing. This undermount sink is perfectly built featuring main kitchen sink bowl and an attached half bowl. Blanco Claron 340/180-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> undermount sink</span></a> also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. It has 60cm cabinet width and the main bowl has a depth of 190mm and the 130mm depth for the half bowl and 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Cabinet width: 800mm</li>\n<li>Overall size: 585 x 440mm</li>\n<li>Small bowl size: 180 x 400 x 130mm</li>\n<li>Large bowl size: 340 x 400 x 190mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer</li>\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing element set (sealing not included)</li>\r\n</ul>\r\n'),(15956,75,0,6181,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 340/180-U Undermount Sink</strong></span></p>\r\n<p>Blanco well-known for its long-time expertise in manufacturing stainless steel sinks now brings to you the Blanco Claron 340/180-U, an undermount sink. Blanco Claron 340/180-U with its premium design is perfect to give your kitchen an outlook with geometrical designing. This undermount sink is perfectly built featuring main kitchen sink bowl and an attached half bowl. Blanco Claron 340/180-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This <a href=\"/brands/blanco/stainlesssteel.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> undermount sink</span></a> also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. It has 60cm cabinet width and the main bowl has a depth of 190mm and the 130mm depth for the half bowl and 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Cabinet width: 800mm</li>\n<li>Overall size: 585 x 440mm</li>\n<li>Small bowl size: 180 x 400 x 130mm</li>\n<li>Large bowl size: 340 x 400 x 190mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer</li>\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing element set (sealing not included)</li>\r\n</ul>\r\n'),(15957,155,0,6181,'Exclude'),(15958,85,5,6182,'buy BL467694 Sink, Blanco Sink Deals, Stainless Steel Sink, Blanco Best, Blanco BL467694 Sink, Blanco Claron 550 U, Blanco Claron 550-U Sink, '),(15959,85,0,6182,'buy BL467694 Sink, Blanco Sink Deals, Stainless Steel Sink, Blanco Best, Blanco BL467694 Sink, Blanco Claron 550 U, Blanco Claron 550-U Sink, '),(15960,75,5,6182,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 550-U undermount Sink - 521579</strong></span></p>\r\n<p> Blanco Claron 550-U is an undermount sink from the Claron family of Blanco STEELART stainless steel sinks. Blanco Claron 550-U with its most excellent design is idyllic to give your kitchen an outlook with geometrical designing. This undermount sink is flawlessly built to be used as an individual main kitchen sink. Blanco Claron 550-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This <a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sink</span></a> has 60cm cabinet width and the depth of the bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing element set (sealing not included)</li>\r\n</ul>\r\n'),(15961,75,0,6182,'<p><span style=\"font-size: medium;\"><strong>Blanco Claron 550-U undermount Sink - 521579</strong></span></p>\r\n<p> Blanco Claron 550-U is an undermount sink from the Claron family of Blanco STEELART stainless steel sinks. Blanco Claron 550-U with its most excellent design is idyllic to give your kitchen an outlook with geometrical designing. This undermount sink is flawlessly built to be used as an individual main kitchen sink. Blanco Claron 550-U, additionally, features a manually controlled overflow and waste fitting with a space-saving pipe. This undermount sink also comes with a 3 1&sol;2&quot; basket strainer waste and a fixing element set. This <a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> stainless steel sink</span></a> has 60cm cabinet width and the depth of the bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Bowl depth: 190mm</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>InFino drain system – elegantly integrated and easy-care</li>\n<li>Concise 10mm radius for ultimate style &ndash; without sacrificing functionality</li>\r\n<li>Optimum utilisation of the bowl capacity thanks to extra deep bowls and smallest possible radii</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste and overflow fitting with space saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n<li>Fixing element set (sealing not included)</li>\r\n</ul>\r\n'),(15962,155,0,6182,'Exclude'),(15963,85,5,6183,'Blanco classic  Sink, Blanco Silgranit Sink, Classic 40 S S/ST Sink,Blanco classic Sink, classic Classic 40 S S/ST Sink Deals'),(15964,85,0,6183,'Blanco classic  Sink, Blanco Silgranit Sink, Classic 40 S S/ST Sink,Blanco classic Sink, classic Classic 40 S S/ST Sink Deals'),(15965,75,5,6183,'<p><span style=\"font-size: medium;\"><strong>Blanco Classic 40 S Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco has been employing the advanced STEELART technology in engineering the <span style=\"text-decoration: underline;\"><a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"> stainless steel kitchen sinks</a></span> while rendering excellence to them. Blanco with over 90 years&rsquo; experience has now introduced the Blanco Classic 40 S into the world of stainless steel kitchen sinks. This <span style=\"text-decoration: underline;\"><a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html?installation=1739\" target=\"_blank\"> inset kitchen sink </a></span>comes with a large sized main bowl along with a spacious draining area which ideally provides sufficient work space in all sizes of kitchens from the small ones to the large ones. This stainless steel kitchen sinkhas the Blanco IF edge profile which elevates the sink just 1mm above the worktops, boasting the beauty of your kitchen. This inset kitchen sink has an excellent and unyielding design with reversible installation with either the single main bowl with left-handed or right-handedpositioning. Blanco Classic 40 S as an inset kitchen sink comes with a 3 &frac12;&rdquo; basket strainer and a waste fitting with a space-saving pipe. This stainless steel sink is neatly fitted in a 40cm cabinet width. The depth of the main bowl is 175mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 195mm</li>\r\n<li>Cabinet width: 400mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\r\n<li>Maximum convenience in a minimum of space</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n</ul>\r\n'),(15966,75,0,6183,'<p><span style=\"font-size: medium;\"><strong>Blanco Classic 40 S Inset Stainless Steel Kitchen Sink</strong></span></p>\r\n<p>Blanco has been employing the advanced STEELART technology in engineering the <span style=\"text-decoration: underline;\"><a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"> stainless steel kitchen sinks</a></span> while rendering excellence to them. Blanco with over 90 years&rsquo; experience has now introduced the Blanco Classic 40 S into the world of stainless steel kitchen sinks. This <span style=\"text-decoration: underline;\"><a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html?installation=1739\" target=\"_blank\"> inset kitchen sink </a></span>comes with a large sized main bowl along with a spacious draining area which ideally provides sufficient work space in all sizes of kitchens from the small ones to the large ones. This stainless steel kitchen sinkhas the Blanco IF edge profile which elevates the sink just 1mm above the worktops, boasting the beauty of your kitchen. This inset kitchen sink has an excellent and unyielding design with reversible installation with either the single main bowl with left-handed or right-handedpositioning. Blanco Classic 40 S as an inset kitchen sink comes with a 3 &frac12;&rdquo; basket strainer and a waste fitting with a space-saving pipe. This stainless steel sink is neatly fitted in a 40cm cabinet width. The depth of the main bowl is 175mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 195mm</li>\r\n<li>Cabinet width: 400mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\r\n<li>Maximum convenience in a minimum of space</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n</ul>\r\n'),(15967,155,0,6183,'Exclude'),(15968,85,5,6184,'Blanco COLLECTIS 6 S Silgranit PuraDur II® Inset Sink'),(15969,85,0,6184,'Blanco COLLECTIS 6 S Silgranit PuraDur II® Inset Sink'),(15970,75,5,6184,'<style>#html-body [data-pb-style=UDSN9VH]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"UDSN9VH\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Collectis 6 S Silgranit Puradur Ii Inset Sink</strong></span></p>\r\n\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Small bowl depth: 155mm</li>\r\n<li>Large bowl depth: 190mm</li>\r\n<li>Style: One &amp; Half Bowl Sink</li>\r\n<li>Additional practical outflow</li>\r\n<li>Modern design with clear lines and an elegant edge</li>\r\n<li>Generous functional sink with a central sorting bowl</li>\r\n<li>Innovative concept for the optimum organisation when preparing food</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Plastic sorting basket with lid in anthracite colour</li>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 /2\" basket strainer for both bowls</li>\r\n<li>pop-up waste for main bowl and 1 /2\" non close strainer for additional drain point</li>\r\n</ul></div></div></div>'),(15971,75,0,6184,'<style>#html-body [data-pb-style=UDSN9VH]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"UDSN9VH\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Collectis 6 S Silgranit Puradur Ii Inset Sink</strong></span></p>\r\n\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Small bowl depth: 155mm</li>\r\n<li>Large bowl depth: 190mm</li>\r\n<li>Style: One &amp; Half Bowl Sink</li>\r\n<li>Additional practical outflow</li>\r\n<li>Modern design with clear lines and an elegant edge</li>\r\n<li>Generous functional sink with a central sorting bowl</li>\r\n<li>Innovative concept for the optimum organisation when preparing food</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Plastic sorting basket with lid in anthracite colour</li>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 /2\" basket strainer for both bowls</li>\r\n<li>pop-up waste for main bowl and 1 /2\" non close strainer for additional drain point</li>\r\n</ul></div></div></div>'),(15972,155,0,6184,'Exclude'),(15973,85,5,6185,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink'),(15974,85,0,6185,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink'),(15975,75,5,6185,'<p><span style=\"font-size: medium;\"><strong>Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink</strong></span></p>\r\n<p>Reginox Comfort Colorado kitchen sink has perfectly seamless round corners that differentiate it from others. The shape of this bowl can enhance the beauty of any kitchen because it has seamless corners in round shape. The cabinet size to fit this bowl should be of 450mm whereas the depth of this bowl is 160mm. The polished inox is an excellent feature of this product. An integral strainer is also available with this sink that gives unbeatable functionality. There is a guarantee of 10 years provided by Reginox against any manufacturing defect in this sink for your peace of mind. Banyo is offering an incredible discount on this product so avail this amazing offer today.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink Unit Dimensions: 403 x 353 mm</li>\r\n<li>Total Dimensions: 445 x 393 mm</li>\r\n<li>Depth: 160 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Comfort</li>\r\n<li>Series :<span>Miscellaneous sinks</span></li>\r\n<li>Material finish: polished inox</li>\r\n<li>With integral strainer, see picture below!</li>\r\n</ul>\r\n'),(15976,75,0,6185,'<p><span style=\"font-size: medium;\"><strong>Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink</strong></span></p>\r\n<p>Reginox Comfort Colorado kitchen sink has perfectly seamless round corners that differentiate it from others. The shape of this bowl can enhance the beauty of any kitchen because it has seamless corners in round shape. The cabinet size to fit this bowl should be of 450mm whereas the depth of this bowl is 160mm. The polished inox is an excellent feature of this product. An integral strainer is also available with this sink that gives unbeatable functionality. There is a guarantee of 10 years provided by Reginox against any manufacturing defect in this sink for your peace of mind. Banyo is offering an incredible discount on this product so avail this amazing offer today.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink Unit Dimensions: 403 x 353 mm</li>\r\n<li>Total Dimensions: 445 x 393 mm</li>\r\n<li>Depth: 160 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Comfort</li>\r\n<li>Series :<span>Miscellaneous sinks</span></li>\r\n<li>Material finish: polished inox</li>\r\n<li>With integral strainer, see picture below!</li>\r\n</ul>\r\n'),(15977,155,0,6185,'Exclude'),(15978,85,5,6186,'Buy BL467978 Silgranit Sink, Blanco Sink sale, cheap Blanco classic Sinks, best Blanco classic Sinks'),(15979,85,0,6186,'Buy BL467978 Silgranit Sink, Blanco Sink sale, cheap Blanco classic Sinks, best Blanco classic Sinks'),(15980,75,5,6186,'<p><span style=\"font-size: medium;\"><strong>Blanco Delta II Puradur II Inset Silgranit Kitchen Sink </strong></span></p>\r\n<p>Blanco with its almost a century&rsquo;s experience in engineering the advanced <a href=\"/brands/blanco/blanco-silgranit-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> silgranit kitchen sinks</span></a> has now manufactured the Blanco Delta II. This compact kitchen sink with its ultra modern designing, doesn&rsquo;t require too much space to be positioned on your worktop surface. You can also drill a tap ledge hole to fix a matching mixer tap into this inset kitchen sink. This inset kitchen sinkis available in nine eye-catching colours form white to alu metallic. This inset kitchen sink has an excellent and unyielding design with the corner installation and the main bowl of this compact kitchen sink is available only in right-handedfitting also including an additional half bowl. Blanco Delta II as an inset kitchen sink comes with a two 3 &frac12;&rdquo; basket strainers, a pop-up waste for the main bowl and a waste fitting with a space-saving pipe. This silgranit kitchen sink is neatly fitted in an 80cm cabinet width and it also includes a stainless steel colander. The depth of the main bowl is 183mm while the half bowl has depth of 120mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 800mm</li>\n<li>Small bowl depth: 120mm</li>\n<li>Large bowl depth: 183mm</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Modern drainer with round covered C-overflow</li>\n<li>Ideal for both corner installation or as a feature on a straight run of work surface</li>\n<li>Ergonomically positioned features include additional bowl and separate drainer</li>\r\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Stainless steel colander</li>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>Two 3 1&sol;2&quot; basket strainers</li>\r\n<li>Remote control for main bowl</li>\r\n</ul>\r\n\r'),(15981,75,0,6186,'<p><span style=\"font-size: medium;\"><strong>Blanco Delta II Puradur II Inset Silgranit Kitchen Sink </strong></span></p>\r\n<p>Blanco with its almost a century&rsquo;s experience in engineering the advanced <a href=\"/brands/blanco/blanco-silgranit-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> silgranit kitchen sinks</span></a> has now manufactured the Blanco Delta II. This compact kitchen sink with its ultra modern designing, doesn&rsquo;t require too much space to be positioned on your worktop surface. You can also drill a tap ledge hole to fix a matching mixer tap into this inset kitchen sink. This inset kitchen sinkis available in nine eye-catching colours form white to alu metallic. This inset kitchen sink has an excellent and unyielding design with the corner installation and the main bowl of this compact kitchen sink is available only in right-handedfitting also including an additional half bowl. Blanco Delta II as an inset kitchen sink comes with a two 3 &frac12;&rdquo; basket strainers, a pop-up waste for the main bowl and a waste fitting with a space-saving pipe. This silgranit kitchen sink is neatly fitted in an 80cm cabinet width and it also includes a stainless steel colander. The depth of the main bowl is 183mm while the half bowl has depth of 120mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 800mm</li>\n<li>Small bowl depth: 120mm</li>\n<li>Large bowl depth: 183mm</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Modern drainer with round covered C-overflow</li>\n<li>Ideal for both corner installation or as a feature on a straight run of work surface</li>\n<li>Ergonomically positioned features include additional bowl and separate drainer</li>\r\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Stainless steel colander</li>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>Two 3 1&sol;2&quot; basket strainers</li>\r\n<li>Remote control for main bowl</li>\r\n</ul>\r\n\r'),(15982,155,0,6186,'Exclude'),(15983,85,5,6187,'Reginox Diplomat Eco 1.5 Bowl Kitchen Sink'),(15984,85,0,6187,'Reginox Diplomat Eco 1.5 Bowl Kitchen Sink'),(15985,75,5,6187,'<p><span style=\"font-size: medium;\"><strong>Reginox Diplomat Eco 1.5 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Stainless steel gauge: 0.6mm</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 600mm</li>\n<li>Sink unit dimensions: 360 x 420 / 160 x 300 mm</li>\n<li>Total dimensions: 950 x 500 mm</li>\n<li>Large bowl depth: 160mm </li>\n<li>Small bowl depth 130mm</li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(15986,75,0,6187,'<p><span style=\"font-size: medium;\"><strong>Reginox Diplomat Eco 1.5 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Stainless steel gauge: 0.6mm</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 600mm</li>\n<li>Sink unit dimensions: 360 x 420 / 160 x 300 mm</li>\n<li>Total dimensions: 950 x 500 mm</li>\n<li>Large bowl depth: 160mm </li>\n<li>Small bowl depth 130mm</li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(15987,155,0,6187,'Exclude'),(15988,85,5,6188,'Reginox Diplomat 10 Eco Single Bowl Kitchen Sink'),(15989,85,0,6188,'Reginox Diplomat 10 Eco Single Bowl Kitchen Sink'),(15990,75,5,6188,'<p><span style=\"font-size: medium;\"><strong>Reginox Diplomat 10 Eco Single Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Stainless steel gauge: 0.6mm</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 500mm</li>\n<li>Sink unit dimensions: 360 x 420 mm</li>\n<li>Total dimensions: 860 x 500 mm</li>\n<li>Bowl depth: 160mm </li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(15991,75,0,6188,'<p><span style=\"font-size: medium;\"><strong>Reginox Diplomat 10 Eco Single Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Stainless steel gauge: 0.6mm</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 500mm</li>\n<li>Sink unit dimensions: 360 x 420 mm</li>\n<li>Total dimensions: 860 x 500 mm</li>\n<li>Bowl depth: 160mm </li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(15992,155,0,6188,'Exclude'),(15993,85,5,6189,'Blanco BL467018 BL467019 Sink , Blanco stainless steel Sink,  Silgranit Sink, Best Sink, Buy  Silgranit Sink'),(15994,85,0,6189,'Blanco BL467018 BL467019 Sink , Blanco stainless steel Sink,  Silgranit Sink, Best Sink, Buy  Silgranit Sink'),(15995,75,5,6189,'<p><span style=\"font-size: medium;\"><strong>Blanco Divon II 5 S-IF Inset Stainless Steel Kitchen Sink </strong></span></p>\r\n<p style=\"text-align: justify;\">Bring home the Blanco Divon kitchen sink that will make your kitchen a more comfortable and functional place to cook. The kitchen sink is provided with counter top to make things easy for you as it renders extra space to place the pots or other useful things on it. It requires the cabinet&rsquo;s width of 50cm and the depth of bowl is 195mm. It\'s irresistible performance adds value to it. The bowl has enough capacity to easily wash the pots. The manufacturing of the <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"> kitchen sink</span></a> is done by using the stainless steel so it is highly durable and provides a great use for the long run. The bowl has 10mm corner radius and its installation is also easy.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 195mm</li>\n<li>Cabinet width: 500mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Perfectly matched geometries and areas</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Straight lined bowls with an elegant 10 mm corner radius</li>\n<li>Beautifully shaped sink with an irresistible overall appearance</li>\r\n<li>Product line meets the requirements for almost any planning situation</li>\r\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; pop-up waste for the main bowl</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n\r</ul>\r\n\r'),(15996,75,0,6189,'<p><span style=\"font-size: medium;\"><strong>Blanco Divon II 5 S-IF Inset Stainless Steel Kitchen Sink </strong></span></p>\r\n<p style=\"text-align: justify;\">Bring home the Blanco Divon kitchen sink that will make your kitchen a more comfortable and functional place to cook. The kitchen sink is provided with counter top to make things easy for you as it renders extra space to place the pots or other useful things on it. It requires the cabinet&rsquo;s width of 50cm and the depth of bowl is 195mm. It\'s irresistible performance adds value to it. The bowl has enough capacity to easily wash the pots. The manufacturing of the <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"> kitchen sink</span></a> is done by using the stainless steel so it is highly durable and provides a great use for the long run. The bowl has 10mm corner radius and its installation is also easy.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Bowl depth: 195mm</li>\n<li>Cabinet width: 500mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Single Bowl SS Sink</li>\n<li>Perfectly matched geometries and areas</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Straight lined bowls with an elegant 10 mm corner radius</li>\n<li>Beautifully shaped sink with an irresistible overall appearance</li>\r\n<li>Product line meets the requirements for almost any planning situation</li>\r\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; pop-up waste for the main bowl</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n\r</ul>\r\n\r'),(15997,155,0,6189,'Exclude'),(15998,85,5,6190,'Blanco BL467020 BL467021 Sinks,Blanco Silgranit Sink, Blanco ceramic Sink, Blanco BL467020 BL467021 Sinks'),(15999,85,0,6190,'Blanco BL467020 BL467021 Sinks,Blanco Silgranit Sink, Blanco ceramic Sink, Blanco BL467020 BL467021 Sinks'),(16000,75,5,6190,'<p><span style=\"font-size: medium;\"><strong>Blanco Divon II 6 S-IF Inset Stainless Steel Kitchen Sink  </strong></span></p>\r\n<p style=\"text-align: justify;\">There is no match of the designing and functionality of Blanco Divon kitchen sink as it is free from any loophole and has distinctive features. The width of the cabinet should be 60cm whereas the <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"> kitchen sink</span></a> has one and a half bowl. The kitchen sink requires the inset style of installation. The large bowl is incredibly deep so you will be able to effortlessly wash the pots. The half bowl can be used for washing the spoons, folks, or other useful things without any effort. The high-quality stainless steel is used in its crafting so there is no doubt in its durability. The counter top is also adding value to it so you can place useful things on it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n\r<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Overall size: 1000 x 510mm</li>\n<li>Small bowl size: 170 x 370 x 135mm</li>\n<li>Large bowl size: 350 x 370 x 195mm</li>\n<li>Perfectly matched geometries and areas</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Straight lined bowls with an elegant 10 mm corner radius</li>\n<li>Beautifully shaped sink with an irresistible overall appearance</li>\r\n<li>Product line meets the requirements for almost any planning situation</li>\r\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; pop up waste for the main bowl</li>\r\n<li>Two 3 1&sol;2&quot; basket strainer</li>\r\n</ul>\r\n'),(16001,75,0,6190,'<p><span style=\"font-size: medium;\"><strong>Blanco Divon II 6 S-IF Inset Stainless Steel Kitchen Sink  </strong></span></p>\r\n<p style=\"text-align: justify;\">There is no match of the designing and functionality of Blanco Divon kitchen sink as it is free from any loophole and has distinctive features. The width of the cabinet should be 60cm whereas the <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"> kitchen sink</span></a> has one and a half bowl. The kitchen sink requires the inset style of installation. The large bowl is incredibly deep so you will be able to effortlessly wash the pots. The half bowl can be used for washing the spoons, folks, or other useful things without any effort. The high-quality stainless steel is used in its crafting so there is no doubt in its durability. The counter top is also adding value to it so you can place useful things on it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n\r<li>Cabinet width: 600mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Overall size: 1000 x 510mm</li>\n<li>Small bowl size: 170 x 370 x 135mm</li>\n<li>Large bowl size: 350 x 370 x 195mm</li>\n<li>Perfectly matched geometries and areas</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Straight lined bowls with an elegant 10 mm corner radius</li>\n<li>Beautifully shaped sink with an irresistible overall appearance</li>\r\n<li>Product line meets the requirements for almost any planning situation</li>\r\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; pop up waste for the main bowl</li>\r\n<li>Two 3 1&sol;2&quot; basket strainer</li>\r\n</ul>\r\n'),(16002,155,0,6190,'Exclude'),(16003,85,5,6191,'Blanco ceramic Sink, Blanco Silgranit Sink, Blanco Rondo Silgranit Sink,Blanco classic Sink, Blanco Cheap Sinks'),(16004,85,0,6191,'Blanco ceramic Sink, Blanco Silgranit Sink, Blanco Rondo Silgranit Sink,Blanco classic Sink, Blanco Cheap Sinks'),(16005,75,5,6191,'<p><span style=\"font-size: medium;\"><strong>Blanco Divon II 8 S-IF Inset Stainless Steel Kitchen Sink </strong></span></p>\r\n<p style=\"text-align: justify;\"> Blanco Divon kitchen sink is not only unique in designing but it effortlessly matches to the overall designing of the kitchen and its furniture. The <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"> kitchen sink </span></a>has two equal sized bowls and there is also a counter place for placing pots or other things. It is more than an efficient choice for using in the large kitchens. It is featured with perfectly matched geometrics and areas. The stainless steel manufacturing has made this sink highly durable and long lasting. More on, its pristine surface resists the scratches and rust so it&rsquo;s cleaning will be easier for you. You will find it easy to install as many professional plumbers recommend this sink due to its easy installation and unbeatable features.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Inset</li>\n<li>Bowl(s) depth: 195mm</li>\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Double Bowl SS Sink</li>\n<li>Perfectly matched geometries and areas</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Straight lined bowls with an elegant 10mm corner radius</li>\n<li>Beautifully shaped sink with an irresistible overall appearance</li>\r\n<li>Product line meets the requirements for almost any planning situation</li>\r\n<li>High-quality features with covered C-overflow and InFino drain system – gracefully integrated and easy-care</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; pop-up waste for the main bowl</li>\r\n<li>Two 3 1&sol;2&quot; basket strainer</li>\r\n</ul>\r\n'),(16006,75,0,6191,'<p><span style=\"font-size: medium;\"><strong>Blanco Divon II 8 S-IF Inset Stainless Steel Kitchen Sink </strong></span></p>\r\n<p style=\"text-align: justify;\"> Blanco Divon kitchen sink is not only unique in designing but it effortlessly matches to the overall designing of the kitchen and its furniture. The <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"> kitchen sink </span></a>has two equal sized bowls and there is also a counter place for placing pots or other things. It is more than an efficient choice for using in the large kitchens. It is featured with perfectly matched geometrics and areas. The stainless steel manufacturing has made this sink highly durable and long lasting. More on, its pristine surface resists the scratches and rust so it&rsquo;s cleaning will be easier for you. You will find it easy to install as many professional plumbers recommend this sink due to its easy installation and unbeatable features.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Inset</li>\n<li>Bowl(s) depth: 195mm</li>\n<li>Cabinet width: 800mm</li>\r\n<li>Material: Stainless Steel</li>\n<li>Style: Double Bowl SS Sink</li>\n<li>Perfectly matched geometries and areas</li>\n<li>Large bowl capacity and fully utilisable base</li>\n<li>Straight lined bowls with an elegant 10mm corner radius</li>\n<li>Beautifully shaped sink with an irresistible overall appearance</li>\r\n<li>Product line meets the requirements for almost any planning situation</li>\r\n<li>High-quality features with covered C-overflow and InFino drain system – gracefully integrated and easy-care</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; pop-up waste for the main bowl</li>\r\n<li>Two 3 1&sol;2&quot; basket strainer</li>\r\n</ul>\r\n'),(16007,155,0,6191,'Exclude'),(16008,85,5,6192,'Reginox EGO 400 Inset 1 Bowl Granite Kitchen Sink'),(16009,85,0,6192,'Reginox EGO 400 Inset 1 Bowl Granite Kitchen Sink'),(16010,75,5,6192,'<p><span style=\"font-size: medium;\"><strong>Reginox EGO 400 Inset 1 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\">Sinks which have made of granite not only look amazing but considered as the hardest sinks. <strong>Reginox Ego kitchen sink</strong> can bring a natural look to your kitchen as it has a subtle shine and feels warm to the touch. It will ensure you a high standard of hygiene as it has processed through sanitised treatment to reduce the growth of bacteria by 99%. More on, you will find it resistant to high temperatures and stains. This<a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong> inset sink</strong> </span></a>is available in various colours from which you can choose your own choice. It looks elegant in titanium, black, white, and cream colours. The cabinet size required for its fitting is 450mm and the depth of its bowl is 230mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox EGO 400 Inset 1 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink unit dimensions: 340 x 430 mm</li>\r\n<li>Total dimensions: 860 x 500 mm</li>\r\n<li>Depth: 230 mm</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Colour: Black, Cream,Titanium &amp; White</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One-bowl sink with draining area</li>\r\n<li>Reversible sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n</ul>\r\n'),(16011,75,0,6192,'<p><span style=\"font-size: medium;\"><strong>Reginox EGO 400 Inset 1 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\">Sinks which have made of granite not only look amazing but considered as the hardest sinks. <strong>Reginox Ego kitchen sink</strong> can bring a natural look to your kitchen as it has a subtle shine and feels warm to the touch. It will ensure you a high standard of hygiene as it has processed through sanitised treatment to reduce the growth of bacteria by 99%. More on, you will find it resistant to high temperatures and stains. This<a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong> inset sink</strong> </span></a>is available in various colours from which you can choose your own choice. It looks elegant in titanium, black, white, and cream colours. The cabinet size required for its fitting is 450mm and the depth of its bowl is 230mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox EGO 400 Inset 1 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink unit dimensions: 340 x 430 mm</li>\r\n<li>Total dimensions: 860 x 500 mm</li>\r\n<li>Depth: 230 mm</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Colour: Black, Cream,Titanium &amp; White</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One-bowl sink with draining area</li>\r\n<li>Reversible sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n</ul>\r\n'),(16012,155,0,6192,'Exclude'),(16013,85,5,6193,'Reginox EGO 475 Inset 1.5 Bowl Granite Kitchen Sink'),(16014,85,0,6193,'Reginox EGO 475 Inset 1.5 Bowl Granite Kitchen Sink'),(16015,75,5,6193,'<style>#html-body [data-pb-style=EX8MFJ4]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"EX8MFJ4\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox EGO 475 Inset 1.5 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Ego kitchen sink</strong> has a unique shape as well as excellent features. There are some modern lines on the work surface of this sink that make it a distinctive product. The rectangular shape of this sink can look elegant in any kitchen as it has crafted according to the latest standards of manufacturing. The position of the drainer is in the middle of small bowl to drain the water efficiently. The size of the cabinet should be 600mm to fit this bowl seamlessly. This granite kitchen sink is available in black, white, titanium, and cream colours. Inset installation method is required to fit this <a href=\"/brands/reginox.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>Reginox sink</strong></span></a> and so it will suit to any worktop. You will find it extremely hygienic as it does not allow bacteria to grow.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox EGO 475 Inset 1.5 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink unit dimensions: 330 x 430 / 140 x 430 mm</li>\r\n<li>Total dimensions: 1000 x 500 mm</li>\r\n<li>Depth: 230 / 170 mm</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Colour: Black, Cream,Titanium &amp; White</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One and half bowl sink with draining area</li>\r\n<li>Reversible sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n</ul></div></div></div>'),(16016,75,0,6193,'<style>#html-body [data-pb-style=EX8MFJ4]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"EX8MFJ4\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox EGO 475 Inset 1.5 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Ego kitchen sink</strong> has a unique shape as well as excellent features. There are some modern lines on the work surface of this sink that make it a distinctive product. The rectangular shape of this sink can look elegant in any kitchen as it has crafted according to the latest standards of manufacturing. The position of the drainer is in the middle of small bowl to drain the water efficiently. The size of the cabinet should be 600mm to fit this bowl seamlessly. This granite kitchen sink is available in black, white, titanium, and cream colours. Inset installation method is required to fit this <a href=\"/brands/reginox.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>Reginox sink</strong></span></a> and so it will suit to any worktop. You will find it extremely hygienic as it does not allow bacteria to grow.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox EGO 475 Inset 1.5 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink unit dimensions: 330 x 430 / 140 x 430 mm</li>\r\n<li>Total dimensions: 1000 x 500 mm</li>\r\n<li>Depth: 230 / 170 mm</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Colour: Black, Cream,Titanium &amp; White</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One and half bowl sink with draining area</li>\r\n<li>Reversible sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n</ul></div></div></div>'),(16017,155,0,6193,'Exclude'),(16018,85,5,6194,'Reginox EGO 800 Inset 1 Bowl Granite Kitchen Sink'),(16019,85,0,6194,'Reginox EGO 800 Inset 1 Bowl Granite Kitchen Sink'),(16020,75,5,6194,'<p><span style=\"font-size: medium;\"><strong>Reginox EGO 800 Inset 1 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Ego kitchen sink</strong> is designed in a way to bring more convenience in your life. Reginox brought this sink to you after as a result of deep research for giving an exceptional functionality to you. Work surface of this sink is wide enough to facilitate you during washing and cleaning as you can place pots on it because the strength of this work surface will not be compromised. The draining area is positioned straight to the work surface so that water can be drained easily. Depth of this bowl is 230mm whereas the cabinet size should be of 600mm. There are many options in the colours of this <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>kitchen sink</strong></span></a> that make it distinctive. Reginox is providing a guarantee of 10 years against any manufacturing defect in this sink.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox EGO 800 Inset 1 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink unit dimensions: 480 x 430 mm</li>\r\n<li>Total dimensions: 1000 x 500 mm</li>\r\n<li>Depth: 230 mm</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Colour: Black, Cream,Titanium &amp; White</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One Bowl sink with draining area</li>\r\n<li>Reversible sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n</ul>\r\n'),(16021,75,0,6194,'<p><span style=\"font-size: medium;\"><strong>Reginox EGO 800 Inset 1 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Ego kitchen sink</strong> is designed in a way to bring more convenience in your life. Reginox brought this sink to you after as a result of deep research for giving an exceptional functionality to you. Work surface of this sink is wide enough to facilitate you during washing and cleaning as you can place pots on it because the strength of this work surface will not be compromised. The draining area is positioned straight to the work surface so that water can be drained easily. Depth of this bowl is 230mm whereas the cabinet size should be of 600mm. There are many options in the colours of this <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>kitchen sink</strong></span></a> that make it distinctive. Reginox is providing a guarantee of 10 years against any manufacturing defect in this sink.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox EGO 800 Inset 1 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink unit dimensions: 480 x 430 mm</li>\r\n<li>Total dimensions: 1000 x 500 mm</li>\r\n<li>Depth: 230 mm</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Colour: Black, Cream,Titanium &amp; White</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One Bowl sink with draining area</li>\r\n<li>Reversible sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n</ul>\r\n'),(16022,155,0,6194,'Exclude'),(16023,85,5,6195,'Franke Elba ELK 611 Sink, Franke Kitchen Systems,Franke Sinks, Franke Sinks UK,Inset 1.0 Bowl Kitchen Sink'),(16024,85,0,6195,'Franke Elba ELK 611 Sink, Franke Kitchen Systems,Franke Sinks, Franke Sinks UK,Inset 1.0 Bowl Kitchen Sink'),(16025,75,5,6195,'<p><span style=\"font-size: medium;\"><strong>Franke Elba ELK 611 Inset 1.0 Bowl Kitchen Sink</strong></span></p>\n<p>Introduce a unique function in the kitchen with this artistic single bowl Franke Elba inset kitchen sink. The bowl is of normal size and it has a reversible drainer position. It comes in a glossy white finish and due to the inset installation the frame sits on top of the work surface. You will find it compatible with any work surface including the laminate worktops. There is a possibility that your cabinet wall may require modification to accommodate overflow. It has been crafted using ceramic and has a smooth impervious surface. You will find it resistant to all household chemicals and stands up to heat, impacts and staining with ease. </p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single bowl sink</li>    \n<li>Cabinet size: 500mm</li>\n<li>Installation type: Inset</li>\n<li>Sink: Ceramic</li>\n<li>Position of drainer: Reversible</li>\n<li>Colour: White</li>\n</ul>'),(16026,75,0,6195,'<p><span style=\"font-size: medium;\"><strong>Franke Elba ELK 611 Inset 1.0 Bowl Kitchen Sink</strong></span></p>\n<p>Introduce a unique function in the kitchen with this artistic single bowl Franke Elba inset kitchen sink. The bowl is of normal size and it has a reversible drainer position. It comes in a glossy white finish and due to the inset installation the frame sits on top of the work surface. You will find it compatible with any work surface including the laminate worktops. There is a possibility that your cabinet wall may require modification to accommodate overflow. It has been crafted using ceramic and has a smooth impervious surface. You will find it resistant to all household chemicals and stands up to heat, impacts and staining with ease. </p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single bowl sink</li>    \n<li>Cabinet size: 500mm</li>\n<li>Installation type: Inset</li>\n<li>Sink: Ceramic</li>\n<li>Position of drainer: Reversible</li>\n<li>Colour: White</li>\n</ul>'),(16027,155,0,6195,'Exclude'),(16028,85,5,6196,'Blanco BL4679 ELON Sink,Blanco ceramic Sink, Blanco Silgranit Sink, Blanco BL4679 ELON Sink,Blanco classic Sink'),(16029,85,0,6196,'Blanco BL4679 ELON Sink,Blanco ceramic Sink, Blanco Silgranit Sink, Blanco BL4679 ELON Sink,Blanco classic Sink'),(16030,75,5,6196,'<p><span style=\"font-size: medium;\"><strong>Blanco Elon 45 S Puradur II Inset Silgranit Kitchen Sink</strong></span></p>\n<p>Blanco with its more than 90 years&rsquo; experience of manufacturing <a href=\"/brands/blanco/blanco-silgranit-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> silgranit kitchen sink</span></a> has now introduced the Blanco ELON 45 S into the world of kitchen sinks. This inset kitchen sink comes in a compact design which is perfect to be used in small kitchen areas. Yet this silgranit kitchen sink has a spacious and large single sink bowl and an inventive draining area. The draining area of this inset kitchen sink is expandable due to its stainless steel drainer grid. It also includes a tap ledge on the side of the bowl, thus making the sink perfectly suitable for window installation. This inset kitchen sink is available in nine eye-catching colours form white to alu metallic. Blanco ELON 45 S includes a waste fitting with a space-saving pipe and a 3 1&sol;2&quot; pop-up waste for the main bowl. This silgranit kitchen sink has 45cm cabinet width and 630x480xR15 cut out size. The depth of the main bowl is 190mm and this sink can be positioned reversibly.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation : Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>Compact single-bowl sink, ideal for small kitchens</li>\n<li>Tap ledge on side, also ideal for window installation</li>\n<li>High-quality features with elegantly integrated InFino strainer</li>\n<li>Modern undulating design of sink and accessories match each other perfectly</li>\n<li>Innovative extending drainer area thanks to the movable stainless steel wave drainer grid</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Stainless steel drainer grid</li>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>'),(16031,75,0,6196,'<p><span style=\"font-size: medium;\"><strong>Blanco Elon 45 S Puradur II Inset Silgranit Kitchen Sink</strong></span></p>\n<p>Blanco with its more than 90 years&rsquo; experience of manufacturing <a href=\"/brands/blanco/blanco-silgranit-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> silgranit kitchen sink</span></a> has now introduced the Blanco ELON 45 S into the world of kitchen sinks. This inset kitchen sink comes in a compact design which is perfect to be used in small kitchen areas. Yet this silgranit kitchen sink has a spacious and large single sink bowl and an inventive draining area. The draining area of this inset kitchen sink is expandable due to its stainless steel drainer grid. It also includes a tap ledge on the side of the bowl, thus making the sink perfectly suitable for window installation. This inset kitchen sink is available in nine eye-catching colours form white to alu metallic. Blanco ELON 45 S includes a waste fitting with a space-saving pipe and a 3 1&sol;2&quot; pop-up waste for the main bowl. This silgranit kitchen sink has 45cm cabinet width and 630x480xR15 cut out size. The depth of the main bowl is 190mm and this sink can be positioned reversibly.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation : Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>Compact single-bowl sink, ideal for small kitchens</li>\n<li>Tap ledge on side, also ideal for window installation</li>\n<li>High-quality features with elegantly integrated InFino strainer</li>\n<li>Modern undulating design of sink and accessories match each other perfectly</li>\n<li>Innovative extending drainer area thanks to the movable stainless steel wave drainer grid</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Stainless steel drainer grid</li>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>'),(16032,155,0,6196,'Exclude'),(16033,85,5,6197,'Blanco BL4672 sink, Blanco ceramic Sink, Blanco Silgranit Sink, Blanco classic Sink, Buy Blanco sink'),(16034,85,0,6197,'Blanco BL4672 sink, Blanco ceramic Sink, Blanco Silgranit Sink, Blanco classic Sink, Buy Blanco sink'),(16035,75,5,6197,'<p>Blanco Elon XL 6 S Puradur II Inset Silgranit Kitchen Sinkrge main bowl and a large draining area, yet with a compact design. This <a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> inset kitchen sink </span></a>with its compact design is a perfect choice as a small kitchen areaand mediumkitchen area sink. Blanco ELON XL 6 S has a spacious and large single sink bowl and an inventive draining area. The draining area of this inset kitchen sink is expandable due to its stainless steel drainer grid. It also includes a tap ledge on the side of the bowl, thus making the sink perfectly suitable for window installation. This inset kitchen sink is available in nine eye-catching colours form white to alu metallic. Blanco ELON XL 6 S includes a waste fitting with a space-saving pipe and a 3 1&sol;2&quot; pop-up waste for the main bowl. This silgranit kitchen sink has 60cm cabinet width and 760x490xR15 cut out size. The depth of the main bowl is 190mm and this sink can be positioned reversibly.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation : Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Practical, comfortable XL bowl</li>\n<li>Handing options: Reversible</li>\n<li>Tap ledge on side, also ideal for window installation</li>\n<li>Compact single-bowl sink, also suitable for small kitchens</li>\n<li>High-quality features with elegantly integrated InFino strainer</li>\n<li>Modern undulating design of sink and accessories match each other perfectly</li>\n<li>Innovative extending drainer area thanks to the movable stainless steel wave drainer grid</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Stainless steel drainer grid</li>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(16036,75,0,6197,'<p>Blanco Elon XL 6 S Puradur II Inset Silgranit Kitchen Sinkrge main bowl and a large draining area, yet with a compact design. This <a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> inset kitchen sink </span></a>with its compact design is a perfect choice as a small kitchen areaand mediumkitchen area sink. Blanco ELON XL 6 S has a spacious and large single sink bowl and an inventive draining area. The draining area of this inset kitchen sink is expandable due to its stainless steel drainer grid. It also includes a tap ledge on the side of the bowl, thus making the sink perfectly suitable for window installation. This inset kitchen sink is available in nine eye-catching colours form white to alu metallic. Blanco ELON XL 6 S includes a waste fitting with a space-saving pipe and a 3 1&sol;2&quot; pop-up waste for the main bowl. This silgranit kitchen sink has 60cm cabinet width and 760x490xR15 cut out size. The depth of the main bowl is 190mm and this sink can be positioned reversibly.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation : Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Practical, comfortable XL bowl</li>\n<li>Handing options: Reversible</li>\n<li>Tap ledge on side, also ideal for window installation</li>\n<li>Compact single-bowl sink, also suitable for small kitchens</li>\n<li>High-quality features with elegantly integrated InFino strainer</li>\n<li>Modern undulating design of sink and accessories match each other perfectly</li>\n<li>Innovative extending drainer area thanks to the movable stainless steel wave drainer grid</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Stainless steel drainer grid</li>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(16037,155,0,6197,'Exclude'),(16038,85,5,6198,'Blanco ETAGON 500-U Silgranit PuraDur II® Undermount Sink'),(16039,85,0,6198,'Blanco ETAGON 500-U Silgranit PuraDur II® Undermount Sink'),(16040,75,5,6198,'<p><span style=\"font-size: medium;\"><strong>Blanco Etagon 500-u Silgranit Puradur II Undermount Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 200mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Integrated step creates an additional functions level</li>\r\n<li>Innovative system concept with versatile ETAGON rails</li>\r\n<li>Generous staggered bowl with the functionality of a sink centre</li>\n<li>Available for under mount installation or inset installation with integrated tap ledge</li>\n<li>High-quality features with the covered C-overflow and InFino drain system  elegantly integrated and extremely hygienic</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>With Etagon rails in stainless steel</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Waste fitting with space-saving pipe</li>\n</ul>\n'),(16041,75,0,6198,'<p><span style=\"font-size: medium;\"><strong>Blanco Etagon 500-u Silgranit Puradur II Undermount Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 200mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Integrated step creates an additional functions level</li>\r\n<li>Innovative system concept with versatile ETAGON rails</li>\r\n<li>Generous staggered bowl with the functionality of a sink centre</li>\n<li>Available for under mount installation or inset installation with integrated tap ledge</li>\n<li>High-quality features with the covered C-overflow and InFino drain system  elegantly integrated and extremely hygienic</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>With Etagon rails in stainless steel</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Waste fitting with space-saving pipe</li>\n</ul>\n'),(16042,155,0,6198,'Exclude'),(16043,85,5,6199,'Blanco Etagon 6 PuraDur&reg; Silgranit Inset Sink'),(16044,85,0,6199,'Blanco Etagon 6 PuraDur&reg; Silgranit Inset Sink'),(16045,75,5,6199,'<style>#html-body [data-pb-style=W0PIAMK]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"W0PIAMK\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Etagon 6 PuraDur® Silgranit Inset Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Granite</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Bowl depth: 220mm</li>\r\n<li>Style: Single Bowl Sink</li>\r\n<li>Integrated step creates an additional functions level</li>\r\n<li>Innovative system concept with versatile Etagon rails</li>\r\n<li>Generous staggered bowl with the functionality of a sink centre</li>\r\n<li>Available for inset installation with integrated tap ledge or under mount installation</li>\r\n<li>High-quality features consisting of a covered C-overflow™ and InFino™ strainer – gracefully integrated and easy care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>With Etagon rails in stainless steel</li>\r\n<li>3 1/2\" basket strainer</li>\r\n<li>Waste fitting with space-saving pipe</li>\r\n</ul></div></div></div>'),(16046,75,0,6199,'<style>#html-body [data-pb-style=W0PIAMK]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"W0PIAMK\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Etagon 6 PuraDur® Silgranit Inset Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Granite</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Bowl depth: 220mm</li>\r\n<li>Style: Single Bowl Sink</li>\r\n<li>Integrated step creates an additional functions level</li>\r\n<li>Innovative system concept with versatile Etagon rails</li>\r\n<li>Generous staggered bowl with the functionality of a sink centre</li>\r\n<li>Available for inset installation with integrated tap ledge or under mount installation</li>\r\n<li>High-quality features consisting of a covered C-overflow™ and InFino™ strainer – gracefully integrated and easy care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>With Etagon rails in stainless steel</li>\r\n<li>3 1/2\" basket strainer</li>\r\n<li>Waste fitting with space-saving pipe</li>\r\n</ul></div></div></div>'),(16047,155,0,6199,'Exclude'),(16048,85,5,6200,'Blanco Etagon 700-U Silgranit Undermount Sink'),(16049,85,0,6200,'Blanco Etagon 700-U Silgranit Undermount Sink'),(16050,75,5,6200,'<p><span style=\"font-size: medium;\"><strong>Blanco Etagon 700-U Silgranit Undermount Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Granite</li>\n<li>Cabinet width: 800mm</li>\n<li>Bowl depth: 200mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Integrated step creates an additional functions level</li>\n<li>Innovative system concept with versatile Etagon rails</li>\n<li>Generous staggered bowl with the functionality of a sink centre</li>\r\n<li>Available for under mount installation or inset installation with integrated tap ledge</li>\n<li>High-quality features with the covered C-overflow&trade; and InFino&trade; drain system &ndash; elegantly integrated and extremely easy-care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>With Etagon rails in stainless steel</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Waste fitting with space-saving pipe</li>\n</ul>'),(16051,75,0,6200,'<p><span style=\"font-size: medium;\"><strong>Blanco Etagon 700-U Silgranit Undermount Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Granite</li>\n<li>Cabinet width: 800mm</li>\n<li>Bowl depth: 200mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Integrated step creates an additional functions level</li>\n<li>Innovative system concept with versatile Etagon rails</li>\n<li>Generous staggered bowl with the functionality of a sink centre</li>\r\n<li>Available for under mount installation or inset installation with integrated tap ledge</li>\n<li>High-quality features with the covered C-overflow&trade; and InFino&trade; drain system &ndash; elegantly integrated and extremely easy-care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>With Etagon rails in stainless steel</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Waste fitting with space-saving pipe</li>\n</ul>'),(16052,155,0,6200,'Exclude'),(16053,85,5,6201,'Blanco Etagon 8 PuraDur&reg; Silgranit Inset Sink'),(16054,85,0,6201,'Blanco Etagon 8 PuraDur&reg; Silgranit Inset Sink'),(16055,75,5,6201,'<p><span style=\"font-size: medium;\"><strong>Blanco Etagon 8 PuraDur&reg; Silgranit Inset Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Granite</li>\n<li>Cabinet width: 800mm</li>\n<li>Bowl depth: 220mm</li>\n<li>Integrated step creates an additional functions level</li>\n<li>Innovative system concept with versatile Etagon rails</li>\n<li>Generous staggered bowl with the functionality of a sink centre</li>\r\n<li>Available for inset installation with integrated tap ledge or under mount installation</li>\n<li>High-quality features consisting of a covered C-overflow&trade; and InFino&trade; strainer &ndash; gracefully integrated and easy care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>With Etagon rails in stainless steel</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Waste fitting with space-saving pipe</li>\n</ul>\n\r'),(16056,75,0,6201,'<p><span style=\"font-size: medium;\"><strong>Blanco Etagon 8 PuraDur&reg; Silgranit Inset Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Granite</li>\n<li>Cabinet width: 800mm</li>\n<li>Bowl depth: 220mm</li>\n<li>Integrated step creates an additional functions level</li>\n<li>Innovative system concept with versatile Etagon rails</li>\n<li>Generous staggered bowl with the functionality of a sink centre</li>\r\n<li>Available for inset installation with integrated tap ledge or under mount installation</li>\n<li>High-quality features consisting of a covered C-overflow&trade; and InFino&trade; strainer &ndash; gracefully integrated and easy care</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>With Etagon rails in stainless steel</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n<li>Waste fitting with space-saving pipe</li>\n</ul>\n\r'),(16057,155,0,6201,'Exclude'),(16058,85,5,6202,'Franke Fresno FSG 111 Undermount 1.0 Bowl Kitchen Sink'),(16059,85,0,6202,'Franke Fresno FSG 111 Undermount 1.0 Bowl Kitchen Sink'),(16060,75,5,6202,'<p><span style=\"font-size: medium;\"><strong>Franke Fresno FSG 111 Undermount 1.0 Bowl Kitchen Sink</strong></span></p><p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl</li>       \r\n<li>Cabinet Size: 900mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Integrated overflow</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Matt black, stone grey and polar white</li>\r\n</ul>'),(16061,75,0,6202,'<p><span style=\"font-size: medium;\"><strong>Franke Fresno FSG 111 Undermount 1.0 Bowl Kitchen Sink</strong></span></p><p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl</li>       \r\n<li>Cabinet Size: 900mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Integrated overflow</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Matt black, stone grey and polar white</li>\r\n</ul>'),(16062,155,0,6202,'Exclude'),(16063,85,5,6203,'Franke Galassia Sink,Franke Cheap Sink, Franke Sink Accessories, GAK 611 Kitchen Sink Deals'),(16064,85,0,6203,'Franke Galassia Sink,Franke Cheap Sink, Franke Sink Accessories, GAK 611 Kitchen Sink Deals'),(16065,75,5,6203,'<style>#html-body [data-pb-style=UJGQBMY]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"UJGQBMY\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Galassia GAK 611 Inset 1.0 Bowl Kitchen Sink White </strong></span></p>\r\n<p>This Franke Galassia inset kitchen sink is presented by Franke, a leading manufacturer of world-class kitchen sinks. It has been constructed from stain, heat and corrosion resistant nickel steel. The drainer can be positioned either on the left-hand side or right-hand side depends on the requirements. The stainless steel construction brings wonderfully unique characteristics. It is naturally hygienic and does not harbour bacteria. The silky glistening surface comes from the final polish and ensures that your white kitchen sink will remain beautiful for a long time. Its silky mat surface is easy to clean and provides greater resistance to corrosion. Get it from Banyo at a highly affordable rate and enjoy its incredible benefits.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 800mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Position of drainer: Reversible</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Colour: White</li>\r\n</ul></div></div></div>'),(16066,75,0,6203,'<style>#html-body [data-pb-style=UJGQBMY]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"UJGQBMY\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Galassia GAK 611 Inset 1.0 Bowl Kitchen Sink White </strong></span></p>\r\n<p>This Franke Galassia inset kitchen sink is presented by Franke, a leading manufacturer of world-class kitchen sinks. It has been constructed from stain, heat and corrosion resistant nickel steel. The drainer can be positioned either on the left-hand side or right-hand side depends on the requirements. The stainless steel construction brings wonderfully unique characteristics. It is naturally hygienic and does not harbour bacteria. The silky glistening surface comes from the final polish and ensures that your white kitchen sink will remain beautiful for a long time. Its silky mat surface is easy to clean and provides greater resistance to corrosion. Get it from Banyo at a highly affordable rate and enjoy its incredible benefits.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 800mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Position of drainer: Reversible</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Colour: White</li>\r\n</ul></div></div></div>'),(16067,155,0,6203,'Exclude'),(16068,85,5,6204,'Franke Galassia GAK 651 Ceramic 1.5 Bowl Kitchen Sink White'),(16069,85,0,6204,'Franke Galassia GAK 651 Ceramic 1.5 Bowl Kitchen Sink White'),(16070,75,5,6204,'<p><span style=\"font-size: medium;\"><strong>Franke Galassia GAK 651 Ceramic 1.5 Bowl Kitchen Sink White</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>One and half bowls sink</li>              \n<li>Cabinet size: 600mm</li>\n<li>Installation type: Inset</li>\n<li>Position of drainer: Reversible</li>\n<li>Position of small bowl: Reversible</li>\n<li>Sink: Ceramic</li>\n<li>Colour: White</li>\n</ul>'),(16071,75,0,6204,'<p><span style=\"font-size: medium;\"><strong>Franke Galassia GAK 651 Ceramic 1.5 Bowl Kitchen Sink White</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>One and half bowls sink</li>              \n<li>Cabinet size: 600mm</li>\n<li>Installation type: Inset</li>\n<li>Position of drainer: Reversible</li>\n<li>Position of small bowl: Reversible</li>\n<li>Sink: Ceramic</li>\n<li>Colour: White</li>\n</ul>'),(16072,155,0,6204,'Exclude'),(16073,85,5,6205,'Reginox GALICIA 1.0 Bowl Reversible Stainless Steel Kitchen Sink'),(16074,85,0,6205,'Reginox GALICIA 1.0 Bowl Reversible Stainless Steel Kitchen Sink'),(16075,75,5,6205,'<p><span style=\"font-size: medium;\"><strong>Reginox GALICIA 1.0 Bowl Reversible Stainless Steel Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\r\n<li>Material finish: polished inox</li>\r\n<li>Reversible drainer</li>\r\n<li>Cabinet: 450 mm</li>\r\n<li>Total Dimensions:&nbsp;<span> 855 x 445 mm </span></li>\r\n<li>Installation Method : Inset</li>\r\n<li>Depth :&nbsp;<span> 160 mm </span></li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type :&nbsp;<span>Sinks with drainer</span></li>\r\n<li>Packaging : Box</li>\r\n<li>Range : Comfort</li>\r\n<li>Series : Miscellaneous sinks</li>\r\n</ul>\r'),(16076,75,0,6205,'<p><span style=\"font-size: medium;\"><strong>Reginox GALICIA 1.0 Bowl Reversible Stainless Steel Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\r\n<li>Material finish: polished inox</li>\r\n<li>Reversible drainer</li>\r\n<li>Cabinet: 450 mm</li>\r\n<li>Total Dimensions:&nbsp;<span> 855 x 445 mm </span></li>\r\n<li>Installation Method : Inset</li>\r\n<li>Depth :&nbsp;<span> 160 mm </span></li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type :&nbsp;<span>Sinks with drainer</span></li>\r\n<li>Packaging : Box</li>\r\n<li>Range : Comfort</li>\r\n<li>Series : Miscellaneous sinks</li>\r\n</ul>\r'),(16077,155,0,6205,'Exclude'),(16078,85,5,6206,'Franke Galassia Plus Sink, GAX 611 1.0 Bowl Sink,  Franke Sinks Hot offers,Stainless Steel Kitchen sink'),(16079,85,0,6206,'Franke Galassia Plus Sink, GAX 611 1.0 Bowl Sink,  Franke Sinks Hot offers,Stainless Steel Kitchen sink'),(16080,75,5,6206,'<p><span style=\"font-size: medium;\"><strong>Franke Galassia Plus GAX 611 Inset 1.0 Bowl Kitchen Sink Stainless Steel</strong></span></p><p>\r\nThis Franke Galassia inset kitchen sink is presented by Franke, a leading manufacturer of world-class kitchen sinks. It has been constructed from stain, heat and corrosion resistant nickel steel. The drainer can be positioned either on the left-hand side or right-hand side depends on the requirements. The stainless steel construction brings wonderfully unique characteristics. It is naturally hygienic and does not harbour bacteria. The silky glistening surface comes from the final polish and ensures that your sink will remain beautiful for a long time. Its silky mat surface is easy to clean and provides greater resistance to corrosion. Get it from Banyo at a highly affordable rate and enjoy its incredible benefits. </p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n\r\n<ul>\r\n<li>Single bowl sink</li>       \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Position of drainer: Right hand and left hand side</li>\r\n</ul>'),(16081,75,0,6206,'<p><span style=\"font-size: medium;\"><strong>Franke Galassia Plus GAX 611 Inset 1.0 Bowl Kitchen Sink Stainless Steel</strong></span></p><p>\r\nThis Franke Galassia inset kitchen sink is presented by Franke, a leading manufacturer of world-class kitchen sinks. It has been constructed from stain, heat and corrosion resistant nickel steel. The drainer can be positioned either on the left-hand side or right-hand side depends on the requirements. The stainless steel construction brings wonderfully unique characteristics. It is naturally hygienic and does not harbour bacteria. The silky glistening surface comes from the final polish and ensures that your sink will remain beautiful for a long time. Its silky mat surface is easy to clean and provides greater resistance to corrosion. Get it from Banyo at a highly affordable rate and enjoy its incredible benefits. </p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n\r\n<ul>\r\n<li>Single bowl sink</li>       \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Position of drainer: Right hand and left hand side</li>\r\n</ul>'),(16082,155,0,6206,'Exclude'),(16083,85,5,6207,'Galassia Plus Sink Deals, Franke GAX 621 Kitchen Sink,Franke Corner Sink, Stainless Steel  Kitchen Sink'),(16084,85,0,6207,'Galassia Plus Sink Deals, Franke GAX 621 Kitchen Sink,Franke Corner Sink, Stainless Steel  Kitchen Sink'),(16085,75,5,6207,'<p><span style=\"font-size: medium;\"><strong>Franke Galassia Plus GAX 621 Inset 1.5 Bowl Kitchen Sink Stainless Steel</strong></span></p>\r\n<p>\r\nFranke has presented a Franke Galassia plus GAX inset kitchen sink which has got the attraction of many. It&apos;s shape and style is quite different from others which make it more special. It has been designed with precision and the high-grade material of it makes any kitchen an ergonomic space to clean and cook. This inclusive nickel steel sink brings a smooth finish and the seamless look of it just enhances the beauty of any kitchen. The two bowls of it are quite useful for busy kitchens due to which it can be used in restaurants. One bowl is a bit small and the other is large and both have separate drainers which can be placed either on the right-hand side or left-hand side depends on your requirements. You will find it extremely useful even in extreme temperatures as the stainless steel makes it corrosion, rust and heat resistant.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Sink type: Two bowls</li>       \r\n<li>Cabinet size: 900mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Surface finish: X-Brushed/Satin</li>\r\n<li>Position of drainer: Right hand and left hand side</li>\r\n<li>Position of small bowl: Right hand side</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>\r\n\r\n\r\n'),(16086,75,0,6207,'<p><span style=\"font-size: medium;\"><strong>Franke Galassia Plus GAX 621 Inset 1.5 Bowl Kitchen Sink Stainless Steel</strong></span></p>\r\n<p>\r\nFranke has presented a Franke Galassia plus GAX inset kitchen sink which has got the attraction of many. It&apos;s shape and style is quite different from others which make it more special. It has been designed with precision and the high-grade material of it makes any kitchen an ergonomic space to clean and cook. This inclusive nickel steel sink brings a smooth finish and the seamless look of it just enhances the beauty of any kitchen. The two bowls of it are quite useful for busy kitchens due to which it can be used in restaurants. One bowl is a bit small and the other is large and both have separate drainers which can be placed either on the right-hand side or left-hand side depends on your requirements. You will find it extremely useful even in extreme temperatures as the stainless steel makes it corrosion, rust and heat resistant.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Sink type: Two bowls</li>       \r\n<li>Cabinet size: 900mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Surface finish: X-Brushed/Satin</li>\r\n<li>Position of drainer: Right hand and left hand side</li>\r\n<li>Position of small bowl: Right hand side</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>\r\n\r\n\r\n'),(16087,155,0,6207,'Exclude'),(16088,85,5,6208,'Reginox Harlem 10 Inset 1 Bowl Granite Kitchen Sink'),(16089,85,0,6208,'Reginox Harlem 10 Inset 1 Bowl Granite Kitchen Sink'),(16090,75,5,6208,'<p><span style=\"font-size: medium;\"><strong>Reginox Harlem 10 Inset 1 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Finish: Black silvery / Caffe silvery / Grey silvery / Pure white</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Outlet: 3.5\" outlet</li>\r\n<li>One bowl sink</li>\r\n<li>Depth: 200mm</li>\r\n<li> Sink comes with drainer</li>\r\n<li>Sink unit dimensions: 460 x 440mm</li>\r\n<li>Total dimensions: 1000 x 500mm</li>\r\n<li>Installation method: Inset</li>\r\n</ul>\r\n'),(16091,75,0,6208,'<p><span style=\"font-size: medium;\"><strong>Reginox Harlem 10 Inset 1 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Finish: Black silvery / Caffe silvery / Grey silvery / Pure white</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Outlet: 3.5\" outlet</li>\r\n<li>One bowl sink</li>\r\n<li>Depth: 200mm</li>\r\n<li> Sink comes with drainer</li>\r\n<li>Sink unit dimensions: 460 x 440mm</li>\r\n<li>Total dimensions: 1000 x 500mm</li>\r\n<li>Installation method: Inset</li>\r\n</ul>\r\n'),(16092,155,0,6208,'Exclude'),(16093,85,5,6209,'Reginox Harlem 15 Inset 1.5 Bowl Granite Kitchen Sink'),(16094,85,0,6209,'Reginox Harlem 15 Inset 1.5 Bowl Granite Kitchen Sink'),(16095,75,5,6209,'<p><span style=\"font-size: medium;\"><strong>Reginox Harlem 15 Inset 1.5 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Finish: Black silvery / Caffe silvery / Grey silvery / Pure white</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Outlet: 3.5\" outlet</li>\r\n<li>Depth: 200mm / 140mm</li>\r\n<li> Sink comes with drainer</li>\r\n<li>Sink unit dimensions: 330 x 440 / 156 x 300mm</li>\r\n<li>Total dimensions: 1000 x 500mm</li>\r\n<li>Installation method: Inset</li>\r\n</ul>\r\n'),(16096,75,0,6209,'<p><span style=\"font-size: medium;\"><strong>Reginox Harlem 15 Inset 1.5 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Finish: Black silvery / Caffe silvery / Grey silvery / Pure white</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Outlet: 3.5\" outlet</li>\r\n<li>Depth: 200mm / 140mm</li>\r\n<li> Sink comes with drainer</li>\r\n<li>Sink unit dimensions: 330 x 440 / 156 x 300mm</li>\r\n<li>Total dimensions: 1000 x 500mm</li>\r\n<li>Installation method: Inset</li>\r\n</ul>\r\n'),(16097,155,0,6209,'Exclude'),(16098,85,5,6210,'Reginox Elegance Jumbo Inset 1 Bowl Kitchen Sink'),(16099,85,0,6210,'Reginox Elegance Jumbo Inset 1 Bowl Kitchen Sink'),(16100,75,5,6210,'<p><span style=\"font-size: medium;\"><strong>Reginox Elegance Jumbo Inset 1 Bowl Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Elegance</strong> jumbo kitchen sinkis quite different from ordinary sinks as it gives exceptional functionality. The drainer is perfectly positioned front of the tap holethat efficiently drains water and makes this sink more functional. Material matters a lot in the manufacturing of any product and Reginox Eleganceis manufactured from high grade material that makes it corrosion, rust, and stain resistant. It will be fitted from above the worktop as there is an inset installation required for its fitting. You can get this product from Banyo as there is an incredible discount offer available at Banyo. <a href=\"/brands/reginox.html\" target=\"_blank\"><strong><span style=\"color: #3366ff;\">Reginox</span></strong></a> is providing a guarantee of 10 years against any manufacturing defect in this sink.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elegance Jumbo Inset 1 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 900mm</li>\r\n<li>Sink Unit Dimensions :<span>750 x 410 mm</span><span></span></li>\r\n<li>Total Dimensions:<span>860 x 510 mm</span><span></span></li>\r\n<li>Installation Method : Inset</li>\r\n<li>Depth :<span>230 mm</span><span></span></li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type :<span>Square sinks</span></li>\r\n<li>Packaging : Box</li>\r\n<li>Range :<span>Elite</span></li>\r\n<li>Series :<span>Miscellaneous sinks</span></li>\r\n<li>Material finish: polished inox</li>\r\n</ul>\r'),(16101,75,0,6210,'<p><span style=\"font-size: medium;\"><strong>Reginox Elegance Jumbo Inset 1 Bowl Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Elegance</strong> jumbo kitchen sinkis quite different from ordinary sinks as it gives exceptional functionality. The drainer is perfectly positioned front of the tap holethat efficiently drains water and makes this sink more functional. Material matters a lot in the manufacturing of any product and Reginox Eleganceis manufactured from high grade material that makes it corrosion, rust, and stain resistant. It will be fitted from above the worktop as there is an inset installation required for its fitting. You can get this product from Banyo as there is an incredible discount offer available at Banyo. <a href=\"/brands/reginox.html\" target=\"_blank\"><strong><span style=\"color: #3366ff;\">Reginox</span></strong></a> is providing a guarantee of 10 years against any manufacturing defect in this sink.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elegance Jumbo Inset 1 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 900mm</li>\r\n<li>Sink Unit Dimensions :<span>750 x 410 mm</span><span></span></li>\r\n<li>Total Dimensions:<span>860 x 510 mm</span><span></span></li>\r\n<li>Installation Method : Inset</li>\r\n<li>Depth :<span>230 mm</span><span></span></li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type :<span>Square sinks</span></li>\r\n<li>Packaging : Box</li>\r\n<li>Range :<span>Elite</span></li>\r\n<li>Series :<span>Miscellaneous sinks</span></li>\r\n<li>Material finish: polished inox</li>\r\n</ul>\r'),(16102,155,0,6210,'Exclude'),(16103,85,5,6211,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(16104,85,0,6211,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(16105,75,5,6211,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 40X40cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 40X40cm</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink Unit Dimensions: 403 x 403 mm</li>\r\n<li>Total Dimensions: 440 x 440 mm</li>\r\n<li>Depth: 250 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square Sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Kansas</li>\r\n<li>250 mm deep</li>\r\n<li>15+25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Material finish: Matt inox</li>\r\n</ul>\r'),(16106,75,0,6211,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 40X40cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 40X40cm</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink Unit Dimensions: 403 x 403 mm</li>\r\n<li>Total Dimensions: 440 x 440 mm</li>\r\n<li>Depth: 250 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square Sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Kansas</li>\r\n<li>250 mm deep</li>\r\n<li>15+25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Material finish: Matt inox</li>\r\n</ul>\r'),(16107,155,0,6211,'Exclude'),(16108,85,5,6212,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(16109,85,0,6212,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(16110,75,5,6212,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 50X40cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 50X40cm</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink Unit Dimensions: 503 x 403 mm</li>\r\n<li>Total Dimensions: 540 x 440 mm</li>\r\n<li>Depth: 250 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square Sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Kansas</li>\r\n<li>250 mm deep</li>\r\n<li>15+25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Material finish: Matt inox</li>\r\n</ul>\r'),(16111,75,0,6212,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 50X40cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 50X40cm</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink Unit Dimensions: 503 x 403 mm</li>\r\n<li>Total Dimensions: 540 x 440 mm</li>\r\n<li>Depth: 250 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square Sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Kansas</li>\r\n<li>250 mm deep</li>\r\n<li>15+25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Material finish: Matt inox</li>\r\n</ul>\r'),(16112,155,0,6212,'Exclude'),(16113,85,5,6213,'Franke Kubus KBX 110 40 Undermount 1.0 Bowl Kitchen Sink'),(16114,85,0,6213,'Franke Kubus KBX 110 40 Undermount 1.0 Bowl Kitchen Sink'),(16115,75,5,6213,'<p><span style=\"font-size: medium;\"><strong>Franke Kubus KBK 110 40 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>  \n<li>Single bowl sink</li>   \n<li>Cabinet size: 500mm</li>\n<li>Installation type: Undermount</li>\n<li>Sink: Ceramic</li>\n<li>Available colour: White, Graphite and Matt pearl grey</li>\n</ul>'),(16116,75,0,6213,'<p><span style=\"font-size: medium;\"><strong>Franke Kubus KBK 110 40 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>  \n<li>Single bowl sink</li>   \n<li>Cabinet size: 500mm</li>\n<li>Installation type: Undermount</li>\n<li>Sink: Ceramic</li>\n<li>Available colour: White, Graphite and Matt pearl grey</li>\n</ul>'),(16117,155,0,6213,'Exclude'),(16118,85,5,6214,'Franke Kubus KBK 110 50 Undermount 1.0 Bowl Kitchen Sink'),(16119,85,0,6214,'Franke Kubus KBK 110 50 Undermount 1.0 Bowl Kitchen Sink'),(16120,75,5,6214,'<p><span style=\"font-size: medium;\"><strong>Franke Kubus KBK 110 50 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single bowl sink</li>          \n<li>Cabinet size: 600mm</li>\n<li>Installation type: Undermount</li>\n<li>Sink: Ceramic</li>\n<li>Available colour: White, graphite and matt pearl grey</li>\n</ul>'),(16121,75,0,6214,'<p><span style=\"font-size: medium;\"><strong>Franke Kubus KBK 110 50 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single bowl sink</li>          \n<li>Cabinet size: 600mm</li>\n<li>Installation type: Undermount</li>\n<li>Sink: Ceramic</li>\n<li>Available colour: White, graphite and matt pearl grey</li>\n</ul>'),(16122,155,0,6214,'Exclude'),(16123,85,5,6215,'Franke Kubus KBK 160 Undermount 1.5 Bowl Kitchen Sink'),(16124,85,0,6215,'Franke Kubus KBK 160 Undermount 1.5 Bowl Kitchen Sink'),(16125,75,5,6215,'<p><span style=\"font-size: medium;\"><strong>Franke Kubus KBK 160 Undermount 1.5 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>   \n<li>One and half bowls sink</li>                  \n<li>Cabinet size: 600mm</li>\n<li>Installation type: Undermount</li>\n<li>Position of small bowl: Reversible</li>\n<li>Includes non-sealable basket strainer waste in small bowl</li>\n<li>Sink: Ceramic</li>\n<li>Available colour: White, graphite and matt pearl grey</li>\n</ul>'),(16126,75,0,6215,'<p><span style=\"font-size: medium;\"><strong>Franke Kubus KBK 160 Undermount 1.5 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>   \n<li>One and half bowls sink</li>                  \n<li>Cabinet size: 600mm</li>\n<li>Installation type: Undermount</li>\n<li>Position of small bowl: Reversible</li>\n<li>Includes non-sealable basket strainer waste in small bowl</li>\n<li>Sink: Ceramic</li>\n<li>Available colour: White, graphite and matt pearl grey</li>\n</ul>'),(16127,155,0,6215,'Exclude'),(16128,85,5,6216,'Franke Kubus KNG 110 37 Undermount 1.0 Bowl Kitchen Sink'),(16129,85,0,6216,'Franke Kubus KNG 110 37 Undermount 1.0 Bowl Kitchen Sink'),(16130,75,5,6216,'<style>#html-body [data-pb-style=BTEPHJN]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"BTEPHJN\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Kubus KNG 110 37 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>Buy Franke Kubus KNG 110 37 Undermount 1.0 Bowl Kitchen Sink from Banyo at a competitor Price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 450mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Edge profile undermount</li>\r\n<li>Waste Outlet Diameter: 3-1/2\'\'</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Matt black, stone grey, polar white, Slate grey</li>\r\n</ul></div></div></div>'),(16131,75,0,6216,'<style>#html-body [data-pb-style=BTEPHJN]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"BTEPHJN\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Kubus KNG 110 37 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>Buy Franke Kubus KNG 110 37 Undermount 1.0 Bowl Kitchen Sink from Banyo at a competitor Price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 450mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Edge profile undermount</li>\r\n<li>Waste Outlet Diameter: 3-1/2\'\'</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Matt black, stone grey, polar white, Slate grey</li>\r\n</ul></div></div></div>'),(16132,155,0,6216,'Exclude'),(16133,85,5,6217,'Franke Kubus KNG 110 52 Undermount 1.0 Bowl Kitchen Sink'),(16134,85,0,6217,'Franke Kubus KNG 110 52 Undermount 1.0 Bowl Kitchen Sink'),(16135,75,5,6217,'<style>#html-body [data-pb-style=T56E6SH]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"T56E6SH\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Kubus KNG 110 52 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Waste Outlet Diameter: 3-1/2\'\'</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Matt black, Polar white, Stone grey, Slate grey</li>\r\n</ul></div></div></div>'),(16136,75,0,6217,'<style>#html-body [data-pb-style=T56E6SH]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"T56E6SH\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Kubus KNG 110 52 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Waste Outlet Diameter: 3-1/2\'\'</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Matt black, Polar white, Stone grey, Slate grey</li>\r\n</ul></div></div></div>'),(16137,155,0,6217,'Exclude'),(16138,85,5,6218,'Franke Kubus KNG 110 62 Undermount 1.0 Bowl Kitchen Sink'),(16139,85,0,6218,'Franke Kubus KNG 110 62 Undermount 1.0 Bowl Kitchen Sink'),(16140,75,5,6218,'<style>#html-body [data-pb-style=BK2SLVE]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"BK2SLVE\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Kubus KNG 110 62 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 800mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Edge profile undermount</li>\r\n<li>Waste Outlet Diameter: 3-1/2\'\'</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Matt black, Polar white, Stone grey, Slate grey</li>\r\n</ul></div></div></div>'),(16141,75,0,6218,'<style>#html-body [data-pb-style=BK2SLVE]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"BK2SLVE\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Kubus KNG 110 62 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 800mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Edge profile undermount</li>\r\n<li>Waste Outlet Diameter: 3-1/2\'\'</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Matt black, Polar white, Stone grey, Slate grey</li>\r\n</ul></div></div></div>'),(16142,155,0,6218,'Exclude'),(16143,85,5,6219,'Franke Kubus KNG 120 Undermount 1.5 Bowl Kitchen Sink'),(16144,85,0,6219,'Franke Kubus KNG 120 Undermount 1.5 Bowl Kitchen Sink'),(16145,75,5,6219,'<style>#html-body [data-pb-style=J8TIQVB],#html-body [data-pb-style=X5UAQ51]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"X5UAQ51\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Kubus KNG 120 Undermount 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 800mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Position of small bowl: Right hand side</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Matt black, Polar white, Stone grey, Slate grey</li>\r\n</ul></div></div></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"J8TIQVB\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"></div></div></div>'),(16146,75,0,6219,'<style>#html-body [data-pb-style=J8TIQVB],#html-body [data-pb-style=X5UAQ51]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"X5UAQ51\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Kubus KNG 120 Undermount 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 800mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Position of small bowl: Right hand side</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Matt black, Polar white, Stone grey, Slate grey</li>\r\n</ul></div></div></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"J8TIQVB\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"></div></div></div>'),(16147,155,0,6219,'Exclude'),(16148,85,5,6220,'Reginox L183016 Single Bowl Kitchen Sink'),(16149,85,0,6220,'Reginox L183016 Single Bowl Kitchen Sink'),(16150,75,5,6220,'<p><span style=\"font-size: medium;\"><strong>Reginox L183016 Single Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Stainless steel gauge: 0.8mm</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 400mm</li>\n<li>Sink unit dimensions: 300 x 160 mm</li>\n<li>Bowl depth: 122mm </li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(16151,75,0,6220,'<p><span style=\"font-size: medium;\"><strong>Reginox L183016 Single Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Stainless steel gauge: 0.8mm</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 400mm</li>\n<li>Sink unit dimensions: 300 x 160 mm</li>\n<li>Bowl depth: 122mm </li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(16152,155,0,6220,'Exclude'),(16153,85,5,6221,'Reginox L183440 Single Bowl Kitchen Sink'),(16154,85,0,6221,'Reginox L183440 Single Bowl Kitchen Sink'),(16155,75,5,6221,'<p><span style=\"font-size: medium;\"><strong>Reginox L183440 Single Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Stainless steel gauge: 0.8mm</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 450mm</li>\n<li>Sink unit dimensions: 400 x 340 mm</li>\n<li>Total dimensions: 440 x 380 mm</li>\n<li>Bowl depth: 160mm </li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(16156,75,0,6221,'<p><span style=\"font-size: medium;\"><strong>Reginox L183440 Single Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Stainless steel gauge: 0.8mm</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 450mm</li>\n<li>Sink unit dimensions: 400 x 340 mm</li>\n<li>Total dimensions: 440 x 380 mm</li>\n<li>Bowl depth: 160mm </li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(16157,155,0,6221,'Exclude'),(16158,85,5,6222,'Reginox L18390 L Round Bowl Kitchen Sink'),(16159,85,0,6222,'Reginox L18390 L Round Bowl Kitchen Sink'),(16160,75,5,6222,'<style>#html-body [data-pb-style=SFGHXKX]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"SFGHXKX\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox L18390 L Round Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Inset</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Drainer Position : Reversible</li>\r\n<li>Finish: Polished Inox</li>\r\n<li>Cabinet size: 450mm</li>\r\n<li>Sink unit dimensions: Ø 390mm</li>\r\n<li>Total dimensions:Ø 440mm</li>\r\n<li>Bowl depth: 160mm</li>\r\n<li>Outlet : 3.5\" outlet</li>\r\n<li>Warranty/Guarantee: Lifetime</li>\r\n</ul></div></div></div>'),(16161,75,0,6222,'<style>#html-body [data-pb-style=SFGHXKX]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"SFGHXKX\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox L18390 L Round Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Inset</li>\r\n<li>Material: Stainless Steel</li>\r\n<li>Drainer Position : Reversible</li>\r\n<li>Finish: Polished Inox</li>\r\n<li>Cabinet size: 450mm</li>\r\n<li>Sink unit dimensions: Ø 390mm</li>\r\n<li>Total dimensions:Ø 440mm</li>\r\n<li>Bowl depth: 160mm</li>\r\n<li>Outlet : 3.5\" outlet</li>\r\n<li>Warranty/Guarantee: Lifetime</li>\r\n</ul></div></div></div>'),(16162,155,0,6222,'Exclude'),(16163,85,5,6223,'Franke Largo LAX Kitchen Sink, 110 45 Kitchen SiKitchen Sink, Undermount 1.0 Bowl Kitchen Sink, Stainless Steel Kitchen Sink'),(16164,85,0,6223,'Franke Largo LAX Kitchen Sink, 110 45 Kitchen SiKitchen Sink, Undermount 1.0 Bowl Kitchen Sink, Stainless Steel Kitchen Sink'),(16165,75,5,6223,'<p><span style=\"font-size: medium;\"><strong>Franke Largo LAX 110 45 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>\r\nOne of the most essential things in the kitchen is a Largo 1 Bowl Stainless Steel Kitchen Sink. Besides its main function as a place for washing utensils, it could also play the role as a center piece in the kitchen. This elegant Franke Largo 1 Bowl Stainless Steel Kitchen Sink will match most kitchens and will complement any kitchen styles.\r\n</p>\r\n\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li> Cabinet size: 500mm</li>\r\n<li> Length overall: 470mm</li>\r\n<li>Width overall: 415mm</li>\r\n<li> Length of large bowl: 445mm</li>\r\n<li>Width of large bowl: 390mm</li>\r\n<li>Depth of large bowl: 175mm</li>\r\n<li>Remarks: Important: Ensure mounting system can be accommodated in cabinet.</li>\r\n<li> Finish: Stainless Steel</li>\r\n</ul>'),(16166,75,0,6223,'<p><span style=\"font-size: medium;\"><strong>Franke Largo LAX 110 45 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>\r\nOne of the most essential things in the kitchen is a Largo 1 Bowl Stainless Steel Kitchen Sink. Besides its main function as a place for washing utensils, it could also play the role as a center piece in the kitchen. This elegant Franke Largo 1 Bowl Stainless Steel Kitchen Sink will match most kitchens and will complement any kitchen styles.\r\n</p>\r\n\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li> Cabinet size: 500mm</li>\r\n<li> Length overall: 470mm</li>\r\n<li>Width overall: 415mm</li>\r\n<li> Length of large bowl: 445mm</li>\r\n<li>Width of large bowl: 390mm</li>\r\n<li>Depth of large bowl: 175mm</li>\r\n<li>Remarks: Important: Ensure mounting system can be accommodated in cabinet.</li>\r\n<li> Finish: Stainless Steel</li>\r\n</ul>'),(16167,155,0,6223,'Exclude'),(16168,85,5,6224,'Franke Largo LAX Kitchen Sink,110 50 Kitchen Sink,Undermount Kitchen Sink, Stainless Steel Kitchen Sink'),(16169,85,0,6224,'Franke Largo LAX Kitchen Sink,110 50 Kitchen Sink,Undermount Kitchen Sink, Stainless Steel Kitchen Sink'),(16170,75,5,6224,'<p><span style=\"font-size: medium;\"><strong>Franke Largo LAX 110 50 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>\r\nOne of the most essential things in the kitchen is a Largo 1 Bowl Stainless Steel Kitchen Sink. Besides its main function as a place for washing utensils, it could also play the role as a center piece in the kitchen. This elegant Franke Largo 1 Bowl Stainless Steel Kitchen Sink will match most kitchens and will complement any kitchen styles.\r\n</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>    \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>'),(16171,75,0,6224,'<p><span style=\"font-size: medium;\"><strong>Franke Largo LAX 110 50 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>\r\nOne of the most essential things in the kitchen is a Largo 1 Bowl Stainless Steel Kitchen Sink. Besides its main function as a place for washing utensils, it could also play the role as a center piece in the kitchen. This elegant Franke Largo 1 Bowl Stainless Steel Kitchen Sink will match most kitchens and will complement any kitchen styles.\r\n</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>    \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>'),(16172,155,0,6224,'Exclude'),(16173,85,5,6225,'Franke Largo LAX Kitchen Sink, 110 50-41 Kitchen Sink,Undermount 1.0 Bowl Kitchen Sink, Stainless Steel Kitchen Sink,'),(16174,85,0,6225,'Franke Largo LAX Kitchen Sink, 110 50-41 Kitchen Sink,Undermount 1.0 Bowl Kitchen Sink, Stainless Steel Kitchen Sink,'),(16175,75,5,6225,'<p><span style=\"font-size: medium;\"><strong>Franke Largo LAX 110 50-41 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>One of the most essential things in the kitchen is a Largo 1 Bowl Stainless Steel Kitchen Sink. Besides its main function as a place for washing utensils, it could also play the role as a center piece in the kitchen. This elegant Franke Largo 1 Bowl Stainless Steel Kitchen Sink will match most kitchens and will complement any kitchen styles.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>  \r\n<li>Cabinet size: 550mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>'),(16176,75,0,6225,'<p><span style=\"font-size: medium;\"><strong>Franke Largo LAX 110 50-41 Undermount 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>One of the most essential things in the kitchen is a Largo 1 Bowl Stainless Steel Kitchen Sink. Besides its main function as a place for washing utensils, it could also play the role as a center piece in the kitchen. This elegant Franke Largo 1 Bowl Stainless Steel Kitchen Sink will match most kitchens and will complement any kitchen styles.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>  \r\n<li>Cabinet size: 550mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>'),(16177,155,0,6225,'Exclude'),(16178,85,5,6226,'Franke Largo Kitchen Sink,LAX 120 36-36 Kitchen Sink, Undermount 2.0 Bowl Kitchen Sink, Stainless Steel Kitchen Sink'),(16179,85,0,6226,'Franke Largo Kitchen Sink,LAX 120 36-36 Kitchen Sink, Undermount 2.0 Bowl Kitchen Sink, Stainless Steel Kitchen Sink'),(16180,75,5,6226,'<p><span style=\"font-size: medium;\"><strong>Franke Largo LAX 120 36-36 Undermount 2.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>Blend your kitchens decor with an innovative twist of installing this Largo Stainless Steel Undermount Sink. It features twin bowl that allow separation of clean and dirty dishes. This sink can be placed under the bottom of any worktop creating uniform flush countertop surface and attractive appearance.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double bowls sink</li>\r\n<li>Cabinet size: 900mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>'),(16181,75,0,6226,'<p><span style=\"font-size: medium;\"><strong>Franke Largo LAX 120 36-36 Undermount 2.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>Blend your kitchens decor with an innovative twist of installing this Largo Stainless Steel Undermount Sink. It features twin bowl that allow separation of clean and dirty dishes. This sink can be placed under the bottom of any worktop creating uniform flush countertop surface and attractive appearance.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double bowls sink</li>\r\n<li>Cabinet size: 900mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>'),(16182,155,0,6226,'Exclude'),(16183,85,5,6227,'Franke Largo Kitchen Sink, LAX 120 45-30 Kitchen Sink, Undermount 1.75 Bowl Kitchen Sink, Stainless Steel Kitchen Sink'),(16184,85,0,6227,'Franke Largo Kitchen Sink, LAX 120 45-30 Kitchen Sink, Undermount 1.75 Bowl Kitchen Sink, Stainless Steel Kitchen Sink'),(16185,75,5,6227,'<p><span style=\"font-size: medium;\"><strong>Franke Largo LAX 120 45-30 Undermount 1.75 Bowl Kitchen Sink</strong></span></p>\r\n<p>\r\nTreat your kitchen with this Largo Stainless Steel Undermount Sink from Franke to bring an attractive element at your workplace. This 1.5 bowl sink made from high grade material that is hygienic and easy to clean.\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 900mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Position of small bowl: Right hand side</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>'),(16186,75,0,6227,'<p><span style=\"font-size: medium;\"><strong>Franke Largo LAX 120 45-30 Undermount 1.75 Bowl Kitchen Sink</strong></span></p>\r\n<p>\r\nTreat your kitchen with this Largo Stainless Steel Undermount Sink from Franke to bring an attractive element at your workplace. This 1.5 bowl sink made from high grade material that is hygienic and easy to clean.\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 900mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Position of small bowl: Right hand side</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>'),(16187,155,0,6227,'Exclude'),(16188,85,5,6228,'Franke Largo LAX 160 36-16, Undermount 1.5 Bowl Kitchen Sink, Stainless Steel Kitchen Sink'),(16189,85,0,6228,'Franke Largo LAX 160 36-16, Undermount 1.5 Bowl Kitchen Sink, Stainless Steel Kitchen Sink'),(16190,75,5,6228,'<p><span style=\"font-size: medium;\"><strong>Franke Largo LAX 160 36-16 Undermount 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p>\r\nIntroducing stainless steel one and half bowl Kitchen Sink of Largo range by Franke. Fine quality materials blend with excellent design and forms this elegant kitchen sink.\r\n</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Position of small bowl: Right hand and left hand side</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>'),(16191,75,0,6228,'<p><span style=\"font-size: medium;\"><strong>Franke Largo LAX 160 36-16 Undermount 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p>\r\nIntroducing stainless steel one and half bowl Kitchen Sink of Largo range by Franke. Fine quality materials blend with excellent design and forms this elegant kitchen sink.\r\n</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Position of small bowl: Right hand and left hand side</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>'),(16192,155,0,6228,'Exclude'),(16193,85,5,6229,'Blanco LEGRA 45 S Silgranit ® Inset Sink'),(16194,85,0,6229,'Blanco LEGRA 45 S Silgranit ® Inset Sink'),(16195,75,5,6229,'<p><span style=\"font-size: medium;\"><strong>Blanco LEGRA 45 S Silgranit  Inset Sink</strong></span></p>\n\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 450mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Spacious main bowl</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>Classic lines combined with modern functionality</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(16196,75,0,6229,'<p><span style=\"font-size: medium;\"><strong>Blanco LEGRA 45 S Silgranit  Inset Sink</strong></span></p>\n\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 450mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Spacious main bowl</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>Classic lines combined with modern functionality</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(16197,155,0,6229,'Exclude'),(16198,85,5,6230,'Blanco LEGRA 6 Silgranit® Inset Sink'),(16199,85,0,6230,'Blanco LEGRA 6 Silgranit® Inset Sink'),(16200,75,5,6230,'<p><span style=\"font-size: medium;\"><strong>Blanco LEGRA 6 Silgranit Inset Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Continuous tap ledge</li>\r\n<li>Large bowl for best comfort</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li> 3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(16201,75,0,6230,'<p><span style=\"font-size: medium;\"><strong>Blanco LEGRA 6 Silgranit Inset Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Continuous tap ledge</li>\r\n<li>Large bowl for best comfort</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li> 3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(16202,155,0,6230,'Exclude'),(16203,75,5,6231,'<p><span style=\"font-size: medium;\"><strong>Blanco LEGRA 6 S Silgranit Inset Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Small bowl depth: 120mm</li>\n<li>Large bowl depth: 190mm</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Spacious main and additional bowl</li>\n<li>Handing options: Reversible</li>\n<li>Classic lines combined with modern functionality</li>\n<li>Available finishes: Anthracite, Alumetallic ,White, Jasmine,Black</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste kit with space saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(16204,75,0,6231,'<p><span style=\"font-size: medium;\"><strong>Blanco LEGRA 6 S Silgranit Inset Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Small bowl depth: 120mm</li>\n<li>Large bowl depth: 190mm</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Spacious main and additional bowl</li>\n<li>Handing options: Reversible</li>\n<li>Classic lines combined with modern functionality</li>\n<li>Available finishes: Anthracite, Alumetallic ,White, Jasmine,Black</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste kit with space saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(16205,155,0,6231,'Exclude'),(16206,85,5,6232,'Blanco LEGRA XL 6 S Silgranit® Inset Sink'),(16207,85,0,6232,'Blanco LEGRA XL 6 S Silgranit® Inset Sink'),(16208,75,5,6232,'<p><span style=\"font-size: medium;\"><strong>Blanco LEGRA XL 6 S Silgranit Inset Sink</strong></span></p>\n\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Spacious main bowl</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>Maximum size XL bowl for even more room to do the washing up</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope Of Supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(16209,75,0,6232,'<p><span style=\"font-size: medium;\"><strong>Blanco LEGRA XL 6 S Silgranit Inset Sink</strong></span></p>\n\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Spacious main bowl</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>Maximum size XL bowl for even more room to do the washing up</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope Of Supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(16210,155,0,6232,'Exclude'),(16211,85,5,6233,'Reginox Mataro Undermount 1.0 Bowl Ceramic Kitchen Sink'),(16212,85,0,6233,'Reginox Mataro Undermount 1.0 Bowl Ceramic Kitchen Sink'),(16213,75,5,6233,'<style>#html-body [data-pb-style=NM9HLTJ]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"NM9HLTJ\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Mataro Undermount 1.0 Bowl Ceramic Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Colour: White</li>\r\n<li>Material: Ceramic</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Outlet: 3.5\" outlet</li>\r\n<li>Single bowl sink</li>\r\n<li>Sink type: Square sink</li>\r\n<li>Installation method: Undermount</li>\r\n</ul></div></div></div>'),(16214,75,0,6233,'<style>#html-body [data-pb-style=NM9HLTJ]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"NM9HLTJ\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Mataro Undermount 1.0 Bowl Ceramic Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Colour: White</li>\r\n<li>Material: Ceramic</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Outlet: 3.5\" outlet</li>\r\n<li>Single bowl sink</li>\r\n<li>Sink type: Square sink</li>\r\n<li>Installation method: Undermount</li>\r\n</ul></div></div></div>'),(16215,155,0,6233,'Exclude'),(16216,85,5,6234,'Blanco Metra 45 S Silgranit Sink, Blanco Metra 45 S Silgranit Sink, Blanco  Sinks,Blanco Silgranit Sink, Blanco ceramic Sink'),(16217,85,0,6234,'Blanco Metra 45 S Silgranit Sink, Blanco Metra 45 S Silgranit Sink, Blanco  Sinks,Blanco Silgranit Sink, Blanco ceramic Sink'),(16218,75,5,6234,'<p><span style=\"font-size: medium;\"><strong>Blanco Metra 45 S Puradur II Inset Silgranit Kitchen Sink </strong></span></p>\n<p>Blanco as an expert in producing silgranit kitchen sinks for more than 90 years now manufactures the Blanco Metra 45 S. This inset kitchen sink now gives you the up-to-date design with large and shiny smooth surface, a trademark of the silgranit kitchen sinks of Blanco. The single large bowl and a large draining area will give you an adequate working space in your kitchen. Blanco Metra 45 S also includes two pre-drilled tap ledge holes which are used to fix a tap and pop-up waste controller. This inset kitchen sink is available in nine eye-catching coloursform white to alu metallic. Blanco Metra 45-S includes a waste fitting with a space-saving pipe and a 3 1&sol;2&quot; pop-up waste for the main bowl.This <a href=\"/brands/blanco/blanco-silgranit-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> silgranit kitchen sink</span></a> has 45cm cabinet width and 760x480xR15 cut out size. The depth of the main bowl is 190mm along with 15mm depth of the draining area and this sink can be positioned reversibly.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 450mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Modern, straight-lined design</li>\n<li>Ergonomic low-profile rim design</li>\n<li>Handing options: Reversible</li>\n<li>Separate drain provides a high degree of convenience</li>\n<li>The spacious bowl provides an excellent amount of room</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer plus remote control and mini drainer/overflow strainer</li>\n\n</ul>\n\n'),(16219,75,0,6234,'<p><span style=\"font-size: medium;\"><strong>Blanco Metra 45 S Puradur II Inset Silgranit Kitchen Sink </strong></span></p>\n<p>Blanco as an expert in producing silgranit kitchen sinks for more than 90 years now manufactures the Blanco Metra 45 S. This inset kitchen sink now gives you the up-to-date design with large and shiny smooth surface, a trademark of the silgranit kitchen sinks of Blanco. The single large bowl and a large draining area will give you an adequate working space in your kitchen. Blanco Metra 45 S also includes two pre-drilled tap ledge holes which are used to fix a tap and pop-up waste controller. This inset kitchen sink is available in nine eye-catching coloursform white to alu metallic. Blanco Metra 45-S includes a waste fitting with a space-saving pipe and a 3 1&sol;2&quot; pop-up waste for the main bowl.This <a href=\"/brands/blanco/blanco-silgranit-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> silgranit kitchen sink</span></a> has 45cm cabinet width and 760x480xR15 cut out size. The depth of the main bowl is 190mm along with 15mm depth of the draining area and this sink can be positioned reversibly.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 450mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Modern, straight-lined design</li>\n<li>Ergonomic low-profile rim design</li>\n<li>Handing options: Reversible</li>\n<li>Separate drain provides a high degree of convenience</li>\n<li>The spacious bowl provides an excellent amount of room</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer plus remote control and mini drainer/overflow strainer</li>\n\n</ul>\n\n'),(16220,155,0,6234,'Exclude'),(16221,85,5,6235,'Blanco Silgranit Sink, Blanco Metra 5 S Silgranit Sink,Blanco classic Sink, Metra 5 S Silgranit,Metra Silgranit Sink'),(16222,85,0,6235,'Blanco Silgranit Sink, Blanco Metra 5 S Silgranit Sink,Blanco classic Sink, Metra 5 S Silgranit,Metra Silgranit Sink'),(16223,75,5,6235,'<p><span style=\"font-size: medium;\"><strong>Blanco Metra 5 S Puradur II Inset Silgranit Kitchen Sink </strong></span></p>\n<p>Blanco has been manufacturing the silgranit kitchen sinks for more than 90 years. Now Blanco has manufactured the Blanco Metra 5 S, an <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> inset kitchen sink</span></a>. This compact kitchen sink with its ultra modern designing, doesn&rsquo;t require too much space to be positioned on your worktop surface. The single large bowl of this inset kitchen sink will give you an adequate working space in your kitchen. Blanco Metra 5 S is available in nine eye-catching coloursform white to alu metallic. This silgranit kitchen sink includes a waste fitting with a space-saving pipe and a 3 1&sol;2&quot; pop-up waste for the main bowl. Blanco Metra 5 S has 50cm cabinet width and 840x480xR15 cut out size. The depth of the main bowl is 190mm and this sink can be positioned reversibly.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 500mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Aesthetic low profile rim design</li>\n<li>Handing options: Reversible</li>\n<li>Modern, simple but striking linear design</li>\n<li>Spacious draining area provides a high degree of comfort</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; pop-up waste</li>\n\n</ul>\n'),(16224,75,0,6235,'<p><span style=\"font-size: medium;\"><strong>Blanco Metra 5 S Puradur II Inset Silgranit Kitchen Sink </strong></span></p>\n<p>Blanco has been manufacturing the silgranit kitchen sinks for more than 90 years. Now Blanco has manufactured the Blanco Metra 5 S, an <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> inset kitchen sink</span></a>. This compact kitchen sink with its ultra modern designing, doesn&rsquo;t require too much space to be positioned on your worktop surface. The single large bowl of this inset kitchen sink will give you an adequate working space in your kitchen. Blanco Metra 5 S is available in nine eye-catching coloursform white to alu metallic. This silgranit kitchen sink includes a waste fitting with a space-saving pipe and a 3 1&sol;2&quot; pop-up waste for the main bowl. Blanco Metra 5 S has 50cm cabinet width and 840x480xR15 cut out size. The depth of the main bowl is 190mm and this sink can be positioned reversibly.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 500mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Aesthetic low profile rim design</li>\n<li>Handing options: Reversible</li>\n<li>Modern, simple but striking linear design</li>\n<li>Spacious draining area provides a high degree of comfort</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; pop-up waste</li>\n\n</ul>\n'),(16225,155,0,6235,'Exclude'),(16226,85,5,6236,'Blanco Metra 6 Silgranitt Sink , Blanco stainless steel Sink,  Silgranit Sink, Metra 6 Silgranit Sink, Buy  Silgranit Sink'),(16227,85,0,6236,'Blanco Metra 6 Silgranitt Sink , Blanco stainless steel Sink,  Silgranit Sink, Metra 6 Silgranit Sink, Buy  Silgranit Sink'),(16228,75,5,6236,'<p><span style=\"font-size: medium;\"><strong>Blanco Metra 6 Puradur II Inset Silgranit Kitchen Sink</strong></span></p>\n<p>Blanco has been well-known for producing the outclass silgranit kitchen sinks for nearly a century. Now Blanco has manufactured the Blanco Metra 6, an inset kitchen sink. Blanco Metra 6 gives you a sufficient working space with its large main bowl and an additional half bowl. This silgranit kitchen sink is perfectly designed according to the demands of the modern kitchens. This inset kitchen sink is available in nine eye-catching colours form white to alu metallic. Blanco Metra 6, additionally, features a waste fitting with a space-saving pipe and two 3 1&sol;2&quot; basket strainer wastes for both bowls with pop-up waste control for main bowl. This silgranit kitchen sink has 60cm cabinet width and 760x480xR15 cut out size. The depth of the main bowl is 190mm and the half bowl has depth of 130mm and this sink can be positioned reversibly.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Small bowl depth: 130mm</li>\n<li>Large bowl depth: 190mm</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Stylish low-profile rim design</li>\n<li>Handing options: Reversible</li>\n<li>The additional bowl provides a high level of convenience</li>\n<li>The excellent capacity of the bowl provides even more room to do the washing up</li>\n<li>Can be installed either way round and also as undermount sink</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>Two 3 1&sol;2&quot; basket strainers</li>\n<li>Main bowl remote control</li>\n</ul>\n\n'),(16229,75,0,6236,'<p><span style=\"font-size: medium;\"><strong>Blanco Metra 6 Puradur II Inset Silgranit Kitchen Sink</strong></span></p>\n<p>Blanco has been well-known for producing the outclass silgranit kitchen sinks for nearly a century. Now Blanco has manufactured the Blanco Metra 6, an inset kitchen sink. Blanco Metra 6 gives you a sufficient working space with its large main bowl and an additional half bowl. This silgranit kitchen sink is perfectly designed according to the demands of the modern kitchens. This inset kitchen sink is available in nine eye-catching colours form white to alu metallic. Blanco Metra 6, additionally, features a waste fitting with a space-saving pipe and two 3 1&sol;2&quot; basket strainer wastes for both bowls with pop-up waste control for main bowl. This silgranit kitchen sink has 60cm cabinet width and 760x480xR15 cut out size. The depth of the main bowl is 190mm and the half bowl has depth of 130mm and this sink can be positioned reversibly.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Small bowl depth: 130mm</li>\n<li>Large bowl depth: 190mm</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Stylish low-profile rim design</li>\n<li>Handing options: Reversible</li>\n<li>The additional bowl provides a high level of convenience</li>\n<li>The excellent capacity of the bowl provides even more room to do the washing up</li>\n<li>Can be installed either way round and also as undermount sink</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>Two 3 1&sol;2&quot; basket strainers</li>\n<li>Main bowl remote control</li>\n</ul>\n\n'),(16230,155,0,6236,'Exclude'),(16231,85,5,6237,'Blanco Metra 6-S Puradur II Inset Silgranit Kitchen Sink, Banyo, banyo.co.uk, Blanco'),(16232,85,0,6237,'Blanco Metra 6-S Puradur II Inset Silgranit Kitchen Sink, Banyo, banyo.co.uk, Blanco'),(16233,75,5,6237,'<p><span style=\"font-size: medium;\"><strong>Blanco Metra 6-S Puradur II Inset Silgranit Kitchen Sink</strong></span></p>\n<p>Blanco Metra 6-S provides you with an efficient working space featuring its main bowl and an additional half bowl. This Silgranit kitchen sink is perfectly designed to complement your modern and stylish kitchens. This inset kitchen sink with its large draining area is ideal to be positioned into a large kitchen. Blanco Metra 6-S also includes two pre-drilled tap ledge holes which are used to fix a tap and pop-up waste controller. This <a title=\"Blanco Inset Kitchen Sinks\" href=\"/brands/blanco.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\"><strong>inset kitchen sink</strong> </span></a>is available in nine eye-catching colours from white to Alu metallic. This Silgranit kitchen sink includes a waste fitting with a space-saving pipe and two 3 1&sol;2 basket strainers for both bowls. It also has a pop-up waste for the main bowl and stainless steel colander for the additional half bowl. Blanco Metra 6-Shas <strong><a title=\"Blanco 600mm Cabinet Width Sinks\" href=\"/brands/blanco/600mm.html\" target=\"_self\">60cm cabinet width</a></strong> and 980x480xR15 cut out size. The depth of the main bowl is 190mm and the additional half bowl has a depth of 130mm. This sink can be positioned reversibly.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Small bowl depth: 145mm</li>\n<li>Large bowl depth: 190mm</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Ergonomic low-profile rim design</li>\n<li>Handing options: Reversible</li>\n<li>The additional bowl provides further practicality</li>\n<li>Separate drainer provides a high degree of convenience</li>\n<li>The unsurpassed capacity of the bowl provides plenty of space</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Stainless steel colander</li>\n<li>Waste fitting with space-saving pipe</li>\n<li>2 x 3 1&sol;2&quot; basket strainers</li>\n<li>Remote control pop-up waste for main bowl</li>\n</ul>\n'),(16234,75,0,6237,'<p><span style=\"font-size: medium;\"><strong>Blanco Metra 6-S Puradur II Inset Silgranit Kitchen Sink</strong></span></p>\n<p>Blanco Metra 6-S provides you with an efficient working space featuring its main bowl and an additional half bowl. This Silgranit kitchen sink is perfectly designed to complement your modern and stylish kitchens. This inset kitchen sink with its large draining area is ideal to be positioned into a large kitchen. Blanco Metra 6-S also includes two pre-drilled tap ledge holes which are used to fix a tap and pop-up waste controller. This <a title=\"Blanco Inset Kitchen Sinks\" href=\"/brands/blanco.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\"><strong>inset kitchen sink</strong> </span></a>is available in nine eye-catching colours from white to Alu metallic. This Silgranit kitchen sink includes a waste fitting with a space-saving pipe and two 3 1&sol;2 basket strainers for both bowls. It also has a pop-up waste for the main bowl and stainless steel colander for the additional half bowl. Blanco Metra 6-Shas <strong><a title=\"Blanco 600mm Cabinet Width Sinks\" href=\"/brands/blanco/600mm.html\" target=\"_self\">60cm cabinet width</a></strong> and 980x480xR15 cut out size. The depth of the main bowl is 190mm and the additional half bowl has a depth of 130mm. This sink can be positioned reversibly.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Small bowl depth: 145mm</li>\n<li>Large bowl depth: 190mm</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Ergonomic low-profile rim design</li>\n<li>Handing options: Reversible</li>\n<li>The additional bowl provides further practicality</li>\n<li>Separate drainer provides a high degree of convenience</li>\n<li>The unsurpassed capacity of the bowl provides plenty of space</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Stainless steel colander</li>\n<li>Waste fitting with space-saving pipe</li>\n<li>2 x 3 1&sol;2&quot; basket strainers</li>\n<li>Remote control pop-up waste for main bowl</li>\n</ul>\n'),(16235,155,0,6237,'Exclude'),(16236,85,5,6238,'Metra 8-S Silgranit  Sink, Blanco Sink, Blanco  Sink sale, Cheap Blanco classic Sinks, Best Metra 8-S Silgranit Sinks'),(16237,85,0,6238,'Metra 8-S Silgranit  Sink, Blanco Sink, Blanco  Sink sale, Cheap Blanco classic Sinks, Best Metra 8-S Silgranit Sinks'),(16238,75,5,6238,'<p><span style=\"font-size: medium;\"><strong>Blanco Metra 8-S Puradur II Inset Silgranit Kitchen Sink</strong></span></p>\n<p>If you are looking for an efficient  silgranit kitchen sink for your  large kitchen then  Blanco Metra 8-S is the perfect solution. This  inset kitchen sink come in a  large sized main bowl and an  additional half bowl which is  2/3 of the main bowl. This  silgranit kitchen sink also has a  large draining area. Thus putting all the three features you will get a <a href=\"/brands/blanco/granite.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> silgranit kitchen sink</span></a> with provision of sufficient work space. You can also drill a hole into the sink to fix a tap matching the sink. This  inset kitchen sink is available in nine eye-catching coloursform white to alu metallic.  Blanco Metra 8-S includes a  waste fitting with a  space-saving pipe and  two 3 1&sol;2&quot; basket strainers for both bowls.This  silgranit kitchensink has 80cm cabinet width and 1140x480xR15 cut out size. The depth of both bowls is 190mm and this sink can be positioned reversibly.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation : Inset</li>\n<li>Bowl(s) depth: 190mm</li>\n<li>Cabinet width: 800mm</li>\n<li>Material: Granite</li>\n<li>Style: Double Bowl Sink</li>\n<li>Ergonomic low-profile rim design</li>\n<li>Handing options: Reversible</li>\n<li>Modern, simple but striking linea design</li>\n<li>Separate drainer provides a high degree of convenience</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>Two 3 1&sol;2&quot; basket strainers</li>\n\n</ul>\n\n'),(16239,75,0,6238,'<p><span style=\"font-size: medium;\"><strong>Blanco Metra 8-S Puradur II Inset Silgranit Kitchen Sink</strong></span></p>\n<p>If you are looking for an efficient  silgranit kitchen sink for your  large kitchen then  Blanco Metra 8-S is the perfect solution. This  inset kitchen sink come in a  large sized main bowl and an  additional half bowl which is  2/3 of the main bowl. This  silgranit kitchen sink also has a  large draining area. Thus putting all the three features you will get a <a href=\"/brands/blanco/granite.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> silgranit kitchen sink</span></a> with provision of sufficient work space. You can also drill a hole into the sink to fix a tap matching the sink. This  inset kitchen sink is available in nine eye-catching coloursform white to alu metallic.  Blanco Metra 8-S includes a  waste fitting with a  space-saving pipe and  two 3 1&sol;2&quot; basket strainers for both bowls.This  silgranit kitchensink has 80cm cabinet width and 1140x480xR15 cut out size. The depth of both bowls is 190mm and this sink can be positioned reversibly.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation : Inset</li>\n<li>Bowl(s) depth: 190mm</li>\n<li>Cabinet width: 800mm</li>\n<li>Material: Granite</li>\n<li>Style: Double Bowl Sink</li>\n<li>Ergonomic low-profile rim design</li>\n<li>Handing options: Reversible</li>\n<li>Modern, simple but striking linea design</li>\n<li>Separate drainer provides a high degree of convenience</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>Two 3 1&sol;2&quot; basket strainers</li>\n\n</ul>\n\n'),(16240,155,0,6238,'Exclude'),(16241,85,5,6239,'Silgranit Sink, Blanco Metra XL Silgranit  Sink, Stainless Steel Sink, Blanco Best Sinks , Blanco Metra XL Silgranit Sink'),(16242,85,0,6239,'Silgranit Sink, Blanco Metra XL Silgranit  Sink, Stainless Steel Sink, Blanco Best Sinks , Blanco Metra XL Silgranit Sink'),(16243,75,5,6239,'<p><span style=\"font-size: medium;\"><strong>Blanco Metra XL Puradur II Inset Silgranit Kitchen Sink </strong></span></p>\n<p> Blanco Metra XL 6 S with its single large bowl and a large draining area adds functionality and expediency in your kitchen activities. Blanco Metra XL 6 S with its single large bowl and large draining area provides sufficient work space in all kinds of kitchens. This inset kitchen sink now gives you the up-to-date design with large and shiny smooth surface, a trademark of the silgranit kitchen sinks of Blanco. This inset kitchen sink is available in nine eye-catching colours form white to alu metallic. Blanco Metra XL 6 S includes a waste fitting with a space-saving pipe and a 3 1&sol;2&quot; basket strainer waste for the main bowl. This silgranit kitchen sink has 60cm cabinet width and 980x480xR15 cut out size. The depth of the main bowl is 190mm and this sink can be positioned reversibly.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Ergonomic low-profile rim design</li>\n<li>Handing options: Reversible</li>\n<li>Modern, simple but striking linear design</li>\n<li>Separate drainer provides a high degree of convenience</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer plus remote control pop-up waste</li>\n</ul>\n'),(16244,75,0,6239,'<p><span style=\"font-size: medium;\"><strong>Blanco Metra XL Puradur II Inset Silgranit Kitchen Sink </strong></span></p>\n<p> Blanco Metra XL 6 S with its single large bowl and a large draining area adds functionality and expediency in your kitchen activities. Blanco Metra XL 6 S with its single large bowl and large draining area provides sufficient work space in all kinds of kitchens. This inset kitchen sink now gives you the up-to-date design with large and shiny smooth surface, a trademark of the silgranit kitchen sinks of Blanco. This inset kitchen sink is available in nine eye-catching colours form white to alu metallic. Blanco Metra XL 6 S includes a waste fitting with a space-saving pipe and a 3 1&sol;2&quot; basket strainer waste for the main bowl. This silgranit kitchen sink has 60cm cabinet width and 980x480xR15 cut out size. The depth of the main bowl is 190mm and this sink can be positioned reversibly.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Ergonomic low-profile rim design</li>\n<li>Handing options: Reversible</li>\n<li>Modern, simple but striking linear design</li>\n<li>Separate drainer provides a high degree of convenience</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer plus remote control pop-up waste</li>\n</ul>\n'),(16245,155,0,6239,'Exclude'),(16246,85,5,6240,'Reginox Miami 40x40 Single Bowl Kitchen Sink '),(16247,85,0,6240,'Reginox Miami 40x40 Single Bowl Kitchen Sink '),(16248,75,5,6240,'<p><span style=\"font-size: medium;\"><strong>Reginox Miami 40x40 Single Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Finish: Gunmetal / Copper / Gold</li>\r\n<li>Material: Stainless steel</li>\r\n<li>Cabinet size: 500mm</li>\r\n<li>Outlet: 3.5\" outlet</li>\r\n<li>Single bowl sink</li>\r\n<li>Depth:200mm</li>\r\n<li>Sink type: Square sink</li>\r\n<li>Sink unit dimensions: 400 x 400mm</li>\r\n<li>Total dimensions: 440 x 440mm</li>\r\n<li>Installation method: Undermount, Integrated, Semi-integrated</li>\r\n</ul>\r\n'),(16249,75,0,6240,'<p><span style=\"font-size: medium;\"><strong>Reginox Miami 40x40 Single Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Finish: Gunmetal / Copper / Gold</li>\r\n<li>Material: Stainless steel</li>\r\n<li>Cabinet size: 500mm</li>\r\n<li>Outlet: 3.5\" outlet</li>\r\n<li>Single bowl sink</li>\r\n<li>Depth:200mm</li>\r\n<li>Sink type: Square sink</li>\r\n<li>Sink unit dimensions: 400 x 400mm</li>\r\n<li>Total dimensions: 440 x 440mm</li>\r\n<li>Installation method: Undermount, Integrated, Semi-integrated</li>\r\n</ul>\r\n'),(16250,155,0,6240,'Exclude'),(16251,85,5,6241,'Reginox Miami 50X40 Single Bowl Kitchen Sink '),(16252,85,0,6241,'Reginox Miami 50X40 Single Bowl Kitchen Sink '),(16253,75,5,6241,'<p><span style=\"font-size: medium;\"><strong>Reginox Miami 50X40 Single Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Finish: Gunmetal / Copper / Gold</li>\r\n<li>Material: Stainless steel</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Outlet: 3.5\" outlet</li>\r\n<li>One bowl sink</li>\r\n<li>Depth:200mm</li>\r\n<li>Sink type: Square sink</li>\r\n<li>Sink unit dimensions: 500 x 400mm</li>\r\n<li>Total dimensions: 540 x 400mm</li>\r\n<li>Installation method: Undermount, Integrated, Semi-integrated</li>\r\n</ul>\r\n'),(16254,75,0,6241,'<p><span style=\"font-size: medium;\"><strong>Reginox Miami 50X40 Single Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Finish: Gunmetal / Copper / Gold</li>\r\n<li>Material: Stainless steel</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Outlet: 3.5\" outlet</li>\r\n<li>One bowl sink</li>\r\n<li>Depth:200mm</li>\r\n<li>Sink type: Square sink</li>\r\n<li>Sink unit dimensions: 500 x 400mm</li>\r\n<li>Total dimensions: 540 x 400mm</li>\r\n<li>Installation method: Undermount, Integrated, Semi-integrated</li>\r\n</ul>\r\n'),(16255,155,0,6241,'Exclude'),(16256,85,5,6242,'Reginox Elegance Minister Reversible Inset 1 Bowl Kitchen Sink'),(16257,85,0,6242,'Reginox Elegance Minister Reversible Inset 1 Bowl Kitchen Sink'),(16258,75,5,6242,'<p><span style=\"font-size: medium;\"><strong>Reginox Elegance Minister Reversible Inset 1 Bowl Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Elegance kitchen sink</strong> is quite famous due to the polished inox and elegant design of the sink. Reginox has used a material of superior quality in its manufacturing that makes it a must-have sink in any kitchen. Its style can blend efficiently with any kitchen and the rectangular shape of this sink can be a need of many kitchens as there is an extra worktop with this sink that can facilitate you during the time of washing and cleaning. The cabinet size required for its fitting should be 600mm and the bowl is 200mm deep with an outlet of 3,5&rdquo;. This <a href=\"/brands/reginox.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>Reginoxkitchen sink</strong></span></a> is reversible and so you can install it according to your need. Bring it home as it will be a best choice for any kitchen.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elegance Minister Reversible Inset 1 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink Unit Dimensions :<span>520 x 420 mm</span><span></span></li>\r\n<li>Total Dimensions:<span>1000 x 500 mm</span><span></span></li>\r\n<li>Installation Method : Inset</li>\r\n<li>Depth :<span>200 mm</span></li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type :<span>Sinks with drainer</span></li>\r\n<li>Packaging : Box</li>\r\n<li>Range : Elegance</li>\r\n<li>Series :<span>Miscellaneous sinks</span></li>\r\n<li>Material finish: polished inox</li>\r\n<li><span><span>Sink is reversible</span></span></li>\r\n</ul>\r'),(16259,75,0,6242,'<p><span style=\"font-size: medium;\"><strong>Reginox Elegance Minister Reversible Inset 1 Bowl Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Elegance kitchen sink</strong> is quite famous due to the polished inox and elegant design of the sink. Reginox has used a material of superior quality in its manufacturing that makes it a must-have sink in any kitchen. Its style can blend efficiently with any kitchen and the rectangular shape of this sink can be a need of many kitchens as there is an extra worktop with this sink that can facilitate you during the time of washing and cleaning. The cabinet size required for its fitting should be 600mm and the bowl is 200mm deep with an outlet of 3,5&rdquo;. This <a href=\"/brands/reginox.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>Reginoxkitchen sink</strong></span></a> is reversible and so you can install it according to your need. Bring it home as it will be a best choice for any kitchen.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elegance Minister Reversible Inset 1 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink Unit Dimensions :<span>520 x 420 mm</span><span></span></li>\r\n<li>Total Dimensions:<span>1000 x 500 mm</span><span></span></li>\r\n<li>Installation Method : Inset</li>\r\n<li>Depth :<span>200 mm</span></li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type :<span>Sinks with drainer</span></li>\r\n<li>Packaging : Box</li>\r\n<li>Range : Elegance</li>\r\n<li>Series :<span>Miscellaneous sinks</span></li>\r\n<li>Material finish: polished inox</li>\r\n<li><span><span>Sink is reversible</span></span></li>\r\n</ul>\r'),(16260,155,0,6242,'Exclude'),(16261,85,5,6243,'Franke Maris Quiet MQX 110 50 Single Bowl Undermount Kitchen Sink'),(16262,85,0,6243,'Franke Maris Quiet MQX 110 50 Single Bowl Undermount Kitchen Sink'),(16263,75,5,6243,'<p><span style=\"font-size: medium;\"><strong>Franke Maris Quiet MQX 110 50 Single Bowl Undermount Kitchen Sink</strong></span></p>\r\n<p>The Maris Quiet MQX 110-50 is a premium single bowl sink designed for modern kitchens. Crafted from brushed stainless steel, it offers a sleek and contemporary look. This undermount sink measures 500mm x 400mm and features a 7\"\" waste with a hidden overflow, including a lid and connection pipe. It is suitable for installation in cabinets with a minimum width of 600mm. The sink comes with a 50-year guarantee, ensuring long-lasting durability and quality typical of all Franke sinks.</p>\r\n<h2><strong><span style=\"font-size: 16px;\">Key Features:</span></strong></h2>\r\n<ul>\r\n<li>Product code: Maris Quiet MQX 110-50</li>\r\n<li>Material: Brushed stainless steel</li>\r\n<li>Size: 500mm x 400mm</li>\r\n<li>Includes: 7\" waste with hidden overflow, lid, and connection pipe</li>\r\n<li>Type: Single bowl without drainer</li>\r\n<li>Installation: Undermount</li>\r\n<li>Cabinet width: Minimum 600mm</li>\r\n<li>Warranty: 50-year guarantee on all franke sinks</li>\r\n</ul>'),(16264,75,0,6243,'<p><span style=\"font-size: medium;\"><strong>Franke Maris Quiet MQX 110 50 Single Bowl Undermount Kitchen Sink</strong></span></p>\r\n<p>The Maris Quiet MQX 110-50 is a premium single bowl sink designed for modern kitchens. Crafted from brushed stainless steel, it offers a sleek and contemporary look. This undermount sink measures 500mm x 400mm and features a 7\"\" waste with a hidden overflow, including a lid and connection pipe. It is suitable for installation in cabinets with a minimum width of 600mm. The sink comes with a 50-year guarantee, ensuring long-lasting durability and quality typical of all Franke sinks.</p>\r\n<h2><strong><span style=\"font-size: 16px;\">Key Features:</span></strong></h2>\r\n<ul>\r\n<li>Product code: Maris Quiet MQX 110-50</li>\r\n<li>Material: Brushed stainless steel</li>\r\n<li>Size: 500mm x 400mm</li>\r\n<li>Includes: 7\" waste with hidden overflow, lid, and connection pipe</li>\r\n<li>Type: Single bowl without drainer</li>\r\n<li>Installation: Undermount</li>\r\n<li>Cabinet width: Minimum 600mm</li>\r\n<li>Warranty: 50-year guarantee on all franke sinks</li>\r\n</ul>'),(16265,155,0,6243,'Exclude'),(16266,85,5,6244,'Franke Maris Quiet MQX 110 82 Undermount 1 Bowl Kitchen Sink'),(16267,85,0,6244,'Franke Maris Quiet MQX 110 82 Undermount 1 Bowl Kitchen Sink'),(16268,75,5,6244,'<p><span style=\"font-size: medium;\"><strong>Franke Maris Quiet MQX 110 82 Undermount 1 Bowl Kitchen Sink</strong></span></p>\r\n<p>The Maris Quiet MQX 110-82 is a premium single bowl sink designed for modern kitchens. Crafted from brushed stainless steel, it offers a sleek and contemporary look. This undermount sink measures 820mm x 424mm and features a 7\"\" waste with a hidden overflow, including a lid and connection pipe. It fits perfectly in cabinets with a minimum width of 900mm. The sink comes with a 50-year guarantee, ensuring long-lasting durability and quality typical of all Franke sinks.</p>\r\n<h2><strong><span style=\"font-size: 16px;\">Key Features:</span></strong></h2>\r\n<ul>\r\n<li>Product code: Maris Quiet MQX 110-82</li>\r\n<li>Material: Brushed stainless steel</li>\r\n<li>Size: 820mm x 424mm</li>\r\n<li>Includes: 7\" Waste with hidden overflow, lid, and connection pipe</li>\r\n<li>Type: Single bowl without drainer</li>\r\n<li>Installation: Undermount</li>\r\n<li>Cabinet width: Minimum 900mm</li>\r\n<li>Warranty: 50-year guarantee on all franke sinks</li>\r\n</ul>'),(16269,75,0,6244,'<p><span style=\"font-size: medium;\"><strong>Franke Maris Quiet MQX 110 82 Undermount 1 Bowl Kitchen Sink</strong></span></p>\r\n<p>The Maris Quiet MQX 110-82 is a premium single bowl sink designed for modern kitchens. Crafted from brushed stainless steel, it offers a sleek and contemporary look. This undermount sink measures 820mm x 424mm and features a 7\"\" waste with a hidden overflow, including a lid and connection pipe. It fits perfectly in cabinets with a minimum width of 900mm. The sink comes with a 50-year guarantee, ensuring long-lasting durability and quality typical of all Franke sinks.</p>\r\n<h2><strong><span style=\"font-size: 16px;\">Key Features:</span></strong></h2>\r\n<ul>\r\n<li>Product code: Maris Quiet MQX 110-82</li>\r\n<li>Material: Brushed stainless steel</li>\r\n<li>Size: 820mm x 424mm</li>\r\n<li>Includes: 7\" Waste with hidden overflow, lid, and connection pipe</li>\r\n<li>Type: Single bowl without drainer</li>\r\n<li>Installation: Undermount</li>\r\n<li>Cabinet width: Minimum 900mm</li>\r\n<li>Warranty: 50-year guarantee on all franke sinks</li>\r\n</ul>'),(16270,155,0,6244,'Exclude'),(16271,75,5,6245,'<style>#html-body [data-pb-style=KXC4DKC]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"KXC4DKC\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Maris MRG 110-37 Kitchen Sink</strong></span></p>\r\n<p>This Frank Maris sink is a very basic design. This would kind word any modern day kitchen and would combine in very well. The large bowl allows for washing up and other day to day tasks to be completed with great ease. The vast Maris range offers a variety of Sinks &amp; Taps that are ideal for any type of kitchen.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 450mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Coffee, Oyster, Stone grey, Matt black, Polar white, Slate grey</li>\r\n</ul></div><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"></div></div></div>'),(16272,75,0,6245,'<style>#html-body [data-pb-style=KXC4DKC]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"KXC4DKC\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Maris MRG 110-37 Kitchen Sink</strong></span></p>\r\n<p>This Frank Maris sink is a very basic design. This would kind word any modern day kitchen and would combine in very well. The large bowl allows for washing up and other day to day tasks to be completed with great ease. The vast Maris range offers a variety of Sinks &amp; Taps that are ideal for any type of kitchen.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 450mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Coffee, Oyster, Stone grey, Matt black, Polar white, Slate grey</li>\r\n</ul></div><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"></div></div></div>'),(16273,155,0,6245,'Exclude'),(16274,75,5,6246,'<style>#html-body [data-pb-style=D9N4GB0]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"D9N4GB0\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Maris MRG 110-52 Kitchen Sink</strong></span></p>\r\n<p>This Frank Maris sink is a very basic design. This would kind word any modern day kitchen and would combine in very well. The large bowl allows for washing up and other day to day tasks to be completed with great ease. The vast Maris range offers a variety of Sinks &amp; Taps that are ideal for any type of kitchen.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Coffee, Stone grey, Polar white, Matt black, Slate grey</li>\r\n</ul></div></div></div>'),(16275,75,0,6246,'<style>#html-body [data-pb-style=D9N4GB0]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"D9N4GB0\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Maris MRG 110-52 Kitchen Sink</strong></span></p>\r\n<p>This Frank Maris sink is a very basic design. This would kind word any modern day kitchen and would combine in very well. The large bowl allows for washing up and other day to day tasks to be completed with great ease. The vast Maris range offers a variety of Sinks &amp; Taps that are ideal for any type of kitchen.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Coffee, Stone grey, Polar white, Matt black, Slate grey</li>\r\n</ul></div></div></div>'),(16276,155,0,6246,'Exclude'),(16277,75,5,6247,'<style>#html-body [data-pb-style=MGIX5PS]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"MGIX5PS\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Maris MRG 110-72 Kitchen Sink</strong></span></p>\r\n<p>This Frank Maris sink MRG 110-72 is a very basic design. This would kind word any modern day kitchen and would combine in very well. The large bowl allows for washing up and other day to day tasks to be completed with great ease. The vast Maris range offers a variety of Sinks &amp; Taps that are ideal for any type of kitchen.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 800mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Coffee, Oyster, Matt black, Stone grey, Polar white, Slate grey</li>\r\n</ul></div><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"></div></div></div>'),(16278,75,0,6247,'<style>#html-body [data-pb-style=MGIX5PS]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"MGIX5PS\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Maris MRG 110-72 Kitchen Sink</strong></span></p>\r\n<p>This Frank Maris sink MRG 110-72 is a very basic design. This would kind word any modern day kitchen and would combine in very well. The large bowl allows for washing up and other day to day tasks to be completed with great ease. The vast Maris range offers a variety of Sinks &amp; Taps that are ideal for any type of kitchen.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 800mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Coffee, Oyster, Matt black, Stone grey, Polar white, Slate grey</li>\r\n</ul></div><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"></div></div></div>'),(16279,155,0,6247,'Exclude'),(16280,75,5,6248,'<style>#html-body [data-pb-style=YHKUR23]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"YHKUR23\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Maris MRG 160-34-15 Kitchen Sink</strong></span></p>\r\n<p>This Frank Maris sink is a very basic design. This would kind word any modern day kitchen and would combine in very well. The large bowl allows for washing up and other day to day tasks to be completed with great ease. The vast Maris range offers a variety of Sinks &amp; Taps that are ideal for any type of kitchen.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Coffee, Oyster, Matt black, Stone grey, Polar white, Slate grey</li>\r\n</ul></div><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"></div></div></div>'),(16281,75,0,6248,'<style>#html-body [data-pb-style=YHKUR23]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"YHKUR23\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Maris MRG 160-34-15 Kitchen Sink</strong></span></p>\r\n<p>This Frank Maris sink is a very basic design. This would kind word any modern day kitchen and would combine in very well. The large bowl allows for washing up and other day to day tasks to be completed with great ease. The vast Maris range offers a variety of Sinks &amp; Taps that are ideal for any type of kitchen.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Coffee, Oyster, Matt black, Stone grey, Polar white, Slate grey</li>\r\n</ul></div><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"></div></div></div>'),(16282,155,0,6248,'Exclude'),(16283,85,5,6249,'Franke Maris MRX 210-19 Inset 0.5 Bowl Kitchen Sink Stainless Steel'),(16284,85,0,6249,'Franke Maris MRX 210-19 Inset 0.5 Bowl Kitchen Sink Stainless Steel'),(16285,75,5,6249,'<style>#html-body [data-pb-style=VPYNV54]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"VPYNV54\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Maris MRX 210-19 Inset 0.5 Bowl Kitchen Sink Stainless Steel</strong></span></p>\r\n<p>This Frank Maris sink is a very basic design. This would kind word any modern day kitchen and would combine in very well. The large bowl allows for washing up and other day to day tasks to be completed with great ease. The vast Maris range offers a variety of Sinks &amp; Taps that are ideal for any type of kitchen.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Cabinet size: 400mm</li>\r\n<li>Length overall: 230mm</li>\r\n<li>Width overall: 440mm</li>\r\n<li>Length of large bowl: 190mm</li>\r\n<li>Width of large bowl: 400mm</li>\r\n<li>Depth of large bowl: 130mm</li>\r\n<li>Cutout length: 190mm</li>\r\n<li>Cutout width: 400mm</li>\r\n</ul></div></div></div>'),(16286,75,0,6249,'<style>#html-body [data-pb-style=VPYNV54]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"VPYNV54\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Maris MRX 210-19 Inset 0.5 Bowl Kitchen Sink Stainless Steel</strong></span></p>\r\n<p>This Frank Maris sink is a very basic design. This would kind word any modern day kitchen and would combine in very well. The large bowl allows for washing up and other day to day tasks to be completed with great ease. The vast Maris range offers a variety of Sinks &amp; Taps that are ideal for any type of kitchen.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Cabinet size: 400mm</li>\r\n<li>Length overall: 230mm</li>\r\n<li>Width overall: 440mm</li>\r\n<li>Length of large bowl: 190mm</li>\r\n<li>Width of large bowl: 400mm</li>\r\n<li>Depth of large bowl: 130mm</li>\r\n<li>Cutout length: 190mm</li>\r\n<li>Cutout width: 400mm</li>\r\n</ul></div></div></div>'),(16287,155,0,6249,'Exclude'),(16288,85,5,6250,'Franke Maris Bowl MRX 210-34 Inset 1.0 Bowl Kitchen Sink'),(16289,85,0,6250,'Franke Maris Bowl MRX 210-34 Inset 1.0 Bowl Kitchen Sink'),(16290,75,5,6250,'<p><span style=\"font-size: medium;\"><strong>Franke Maris Bowl MRX 210-34 Inset 1.0 Bowl Kitchen Sink</strong></span></p>\r\n <p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li> \r\n<li>Cabinet Size: 400mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Surface finish: Brushed</li> \r\n</ul>'),(16291,75,0,6250,'<p><span style=\"font-size: medium;\"><strong>Franke Maris Bowl MRX 210-34 Inset 1.0 Bowl Kitchen Sink</strong></span></p>\r\n <p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li> \r\n<li>Cabinet Size: 400mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Surface finish: Brushed</li> \r\n</ul>'),(16292,155,0,6250,'Exclude'),(16293,85,5,6251,'Franke Maris MRX 210-45 Inset 1 Bowl Kitchen Sink Stainless Steel'),(16294,85,0,6251,'Franke Maris MRX 210-45 Inset 1 Bowl Kitchen Sink Stainless Steel'),(16295,75,5,6251,'<style>#html-body [data-pb-style=M18B6Y0]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"M18B6Y0\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Maris MRX 210-45 Inset 1 Bowl Kitchen Sink Stainless Steel</strong></span></p>\r\n<p>This stylish Franke Maris sink will be a compliment to any modern kitchen. The Franke Maris MRX 210-45 Inset 1 Bowl sink offers practicality and convenience for efficient meal preparation and clean-up.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 500mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Edge profile slimtop</li>\r\n</ul></div></div></div>'),(16296,75,0,6251,'<style>#html-body [data-pb-style=M18B6Y0]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"M18B6Y0\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Maris MRX 210-45 Inset 1 Bowl Kitchen Sink Stainless Steel</strong></span></p>\r\n<p>This stylish Franke Maris sink will be a compliment to any modern kitchen. The Franke Maris MRX 210-45 Inset 1 Bowl sink offers practicality and convenience for efficient meal preparation and clean-up.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 500mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Edge profile slimtop</li>\r\n</ul></div></div></div>'),(16297,155,0,6251,'Exclude'),(16298,85,5,6252,'Franke Maris Bowl MRX 210-70 Inset 1.0 Bowl Kitchen Sink'),(16299,85,0,6252,'Franke Maris Bowl MRX 210-70 Inset 1.0 Bowl Kitchen Sink'),(16300,75,5,6252,'<p><span style=\"font-size: medium;\"><strong>Franke Maris Bowl MRX 210-70 Inset 1.0 Bowl Kitchen Sink</strong></span></p>\r\n <p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>            \r\n<li>Cabinet size: 800mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>'),(16301,75,0,6252,'<p><span style=\"font-size: medium;\"><strong>Franke Maris Bowl MRX 210-70 Inset 1.0 Bowl Kitchen Sink</strong></span></p>\r\n <p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>            \r\n<li>Cabinet size: 800mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>'),(16302,155,0,6252,'Exclude'),(16303,85,5,6253,'Franke Maris  Kitchen Sink,MRX 211 Slim Kitchen Sink, Stainless Steel 1.0 Bowl Kitchen Sink, '),(16304,85,0,6253,'Franke Maris  Kitchen Sink,MRX 211 Slim Kitchen Sink, Stainless Steel 1.0 Bowl Kitchen Sink, '),(16305,75,5,6253,'<p><span style=\"font-size: medium;\"><strong>Franke Maris MRX 211 Slim-Top Inset 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>\r\nThe kitchen is considered as the heart of any kitchen and it can be beautified by installing the Franke Maris inset kitchen sink. It has been crafted from nickel steel material due to which it is resistant to stain, rust and corrosion. The bowl has curved angles which are very easy to clean and dirt or remains will not stick there for a long time as they can be removed effortlessly. The sleek design of its work surface gives extra space to place things on it. The company offers a guarantee of 50 years against manufacturing defects. If you want to buy it at an affordable rate then there is no best place other than Banyo. <p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul> \r\n<li>Single bowl sink</li>            \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Position of drainer: Right hand and left hand side</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Waste kit with remote twist control</li>\r\n</ul>'),(16306,75,0,6253,'<p><span style=\"font-size: medium;\"><strong>Franke Maris MRX 211 Slim-Top Inset 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>\r\nThe kitchen is considered as the heart of any kitchen and it can be beautified by installing the Franke Maris inset kitchen sink. It has been crafted from nickel steel material due to which it is resistant to stain, rust and corrosion. The bowl has curved angles which are very easy to clean and dirt or remains will not stick there for a long time as they can be removed effortlessly. The sleek design of its work surface gives extra space to place things on it. The company offers a guarantee of 50 years against manufacturing defects. If you want to buy it at an affordable rate then there is no best place other than Banyo. <p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul> \r\n<li>Single bowl sink</li>            \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Position of drainer: Right hand and left hand side</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Waste kit with remote twist control</li>\r\n</ul>'),(16307,155,0,6253,'Exclude'),(16308,85,5,6254,'Franke Maris MRX 220 34-34 Stainless Steel Double Bowl Sink'),(16309,85,0,6254,'Franke Maris MRX 220 34-34 Stainless Steel Double Bowl Sink'),(16310,75,5,6254,'<style>#html-body [data-pb-style=W4NCY4L]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"W4NCY4L\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Maris Bowl MRX 220 34-34 Inset 2.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>The Stainless Steel sinks&nbsp;from Franke&nbsp;are hygienic, easy to clean, and long-lasting, because of their high nickel and chromium content, Franke Maris MRX 220 34-34 Stainless Steel Double Bowl Sink&nbsp;is resistant to both heat and cold.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double bowls sink</li>\r\n<li>Cabinet size: 800mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul></div></div></div>'),(16311,75,0,6254,'<style>#html-body [data-pb-style=W4NCY4L]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"W4NCY4L\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Maris Bowl MRX 220 34-34 Inset 2.0 Bowl Kitchen Sink</strong></span></p>\r\n<p>The Stainless Steel sinks&nbsp;from Franke&nbsp;are hygienic, easy to clean, and long-lasting, because of their high nickel and chromium content, Franke Maris MRX 220 34-34 Stainless Steel Double Bowl Sink&nbsp;is resistant to both heat and cold.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double bowls sink</li>\r\n<li>Cabinet size: 800mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul></div></div></div>'),(16312,155,0,6254,'Exclude'),(16313,85,5,6255,'Franke Maris MRX 251 Kitchen Sink,Slim Top Inset 1.5 Bowl Kitchen Sink, Stainless Steel Kitchen Sink, '),(16314,85,0,6255,'Franke Maris MRX 251 Kitchen Sink,Slim Top Inset 1.5 Bowl Kitchen Sink, Stainless Steel Kitchen Sink, '),(16315,75,5,6255,'<p><span style=\"font-size: medium;\"><strong>Franke Maris MRX 251 Slim-Top Inset 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p>The world&apos;s foremost kitchen sink manufacturer, Franke has artistically and meticulously crafted Franke Maris inset kitchen sink. The company always meets its standards of top quality and that is why this kitchen sink is also manufactured using the superior quality kitchen sink. Stains, scratches and rust cannot stay longer on its surface as it is very easy to clean. It has two bowls, one is of small size and the other is of large size. The position of the small bowl and drainer can be either on the right-hand side or left-hand side depends on the requirements.</p> <p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Waste kit with remote twist control</li>\r\n<li>Position of drainer: Right hand and left hand side</li>\r\n<li>Position of small bowl: Right hand and left hand side</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>\r\n'),(16316,75,0,6255,'<p><span style=\"font-size: medium;\"><strong>Franke Maris MRX 251 Slim-Top Inset 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p>The world&apos;s foremost kitchen sink manufacturer, Franke has artistically and meticulously crafted Franke Maris inset kitchen sink. The company always meets its standards of top quality and that is why this kitchen sink is also manufactured using the superior quality kitchen sink. Stains, scratches and rust cannot stay longer on its surface as it is very easy to clean. It has two bowls, one is of small size and the other is of large size. The position of the small bowl and drainer can be either on the right-hand side or left-hand side depends on the requirements.</p> <p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Waste kit with remote twist control</li>\r\n<li>Position of drainer: Right hand and left hand side</li>\r\n<li>Position of small bowl: Right hand and left hand side</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul>\r\n'),(16317,155,0,6255,'Exclude'),(16318,85,5,6256,'Franke Maris MRX 260-34-19 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(16319,85,0,6256,'Franke Maris MRX 260-34-19 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(16320,75,5,6256,'<style>#html-body [data-pb-style=SJKT7FC]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"SJKT7FC\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Maris MRX 260-34-19 Inset 1.5 Bowl Kitchen Sink Stainless Steel</strong></span></p>\r\n<p>This Frank Maris sink is a very basic design. This would kind word any modern day kitchen and would combine in very well. The large bowl allows for washing up and other day to day tasks to be completed with great ease. The vast Maris range offers a variety of Sinks &amp; Taps that are ideal for any type of kitchen.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Position of small bowl: Right hand and left hand side</li>\r\n<li>Edge profile slimtop</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul></div></div></div>'),(16321,75,0,6256,'<style>#html-body [data-pb-style=SJKT7FC]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"SJKT7FC\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Maris MRX 260-34-19 Inset 1.5 Bowl Kitchen Sink Stainless Steel</strong></span></p>\r\n<p>This Frank Maris sink is a very basic design. This would kind word any modern day kitchen and would combine in very well. The large bowl allows for washing up and other day to day tasks to be completed with great ease. The vast Maris range offers a variety of Sinks &amp; Taps that are ideal for any type of kitchen.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Position of small bowl: Right hand and left hand side</li>\r\n<li>Edge profile slimtop</li>\r\n<li>Sink: Stainless steel</li>\r\n</ul></div></div></div>'),(16322,155,0,6256,'Exclude'),(16323,85,5,6257,'Franke MTG 651-100 Kitchen Sink, Mythos Fragranite Kitchen Sink, Franke Sink Offers, Franke Tap deals'),(16324,85,0,6257,'Franke MTG 651-100 Kitchen Sink, Mythos Fragranite Kitchen Sink, Franke Sink Offers, Franke Tap deals'),(16325,75,5,6257,'<style>#html-body [data-pb-style=D4ROY5U]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"D4ROY5U\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke MTG 651-100 Mythos 1.5 Bowl Fragranite Kitchen Sink</strong></span></p><ul>\r\n <p>Minimalist lines, considered ergonomics and uncompromising technical precision. The Mythos MMX stainless steel range now comes complete with robust Push-Button Knob Pop-Up Waste. The Mythos MTG and MTK ranges now comes complete with FREE Rollamat.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n <li> Cabinet Size: 600mm</li>\r\n <li> Dimensions: 1000mm x 515mm</li>\r\n <li> Bowl Size: 360mm x 390mm x 200mm</li>\r\n <li>Small Bowl Size: 160mm x 390mm x 140mm</li>\r\n  <li> Cut-Out Size: 984mm x 499mm</li>\r\n <li>Cut-Out Template: No</li>\r\n <li>Position of Drainer: Right hand side , Left hand side</li>\r\n<li> Finish: Coffee</li>\r\n</ul></ul></div></div></div>'),(16326,75,0,6257,'<style>#html-body [data-pb-style=D4ROY5U]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"D4ROY5U\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke MTG 651-100 Mythos 1.5 Bowl Fragranite Kitchen Sink</strong></span></p><ul>\r\n <p>Minimalist lines, considered ergonomics and uncompromising technical precision. The Mythos MMX stainless steel range now comes complete with robust Push-Button Knob Pop-Up Waste. The Mythos MTG and MTK ranges now comes complete with FREE Rollamat.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n <li> Cabinet Size: 600mm</li>\r\n <li> Dimensions: 1000mm x 515mm</li>\r\n <li> Bowl Size: 360mm x 390mm x 200mm</li>\r\n <li>Small Bowl Size: 160mm x 390mm x 140mm</li>\r\n  <li> Cut-Out Size: 984mm x 499mm</li>\r\n <li>Cut-Out Template: No</li>\r\n <li>Position of Drainer: Right hand side , Left hand side</li>\r\n<li> Finish: Coffee</li>\r\n</ul></ul></div></div></div>'),(16327,155,0,6257,'Exclude'),(16328,85,5,6258,'Reginox Multa 102 Inset Single Bowl Granite kitchen Sink'),(16329,85,0,6258,'Reginox Multa 102 Inset Single Bowl Granite kitchen Sink'),(16330,75,5,6258,'<style>#html-body [data-pb-style=BWOHWWJ]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"BWOHWWJ\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Multa 102 Inset Single Bowl Granite kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Finish: Black / White / Light grey</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet size: 500mm</li>\r\n<li>Outlet: 3.5\" outlet</li>\r\n<li>Depth: 200mm</li>\r\n<li>Sink unit dimensions: 400 x 400mm</li>\r\n<li>Total dimensions: 456 x 456mm</li>\r\n<li>Installation method: Inset</li>\r\n</ul>\r\n</div></div></div>'),(16331,75,0,6258,'<style>#html-body [data-pb-style=BWOHWWJ]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"BWOHWWJ\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Multa 102 Inset Single Bowl Granite kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Finish: Black / White / Light grey</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet size: 500mm</li>\r\n<li>Outlet: 3.5\" outlet</li>\r\n<li>Depth: 200mm</li>\r\n<li>Sink unit dimensions: 400 x 400mm</li>\r\n<li>Total dimensions: 456 x 456mm</li>\r\n<li>Installation method: Inset</li>\r\n</ul>\r\n</div></div></div>'),(16332,155,0,6258,'Exclude'),(16333,85,5,6259,'Reginox Multa 105 Inset Single Bowl Granite kitchen Sink'),(16334,85,0,6259,'Reginox Multa 105 Inset Single Bowl Granite kitchen Sink'),(16335,75,5,6259,'<style>#html-body [data-pb-style=Y05N7WV]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"Y05N7WV\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Multa 105 Inset Single Bowl Granite kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Finish: Black / White / Light grey</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Outlet: 3.5\" outlet</li>\r\n<li>Depth: 200mm</li>\r\n<li>Sink unit dimensions: 500 x 400mm</li>\r\n<li>Total dimensions: 556 x 456mm</li>\r\n<li>Installation method: Inset</li>\r\n</ul>\r\n</div></div></div>'),(16336,75,0,6259,'<style>#html-body [data-pb-style=Y05N7WV]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"Y05N7WV\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Multa 105 Inset Single Bowl Granite kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Finish: Black / White / Light grey</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Outlet: 3.5\" outlet</li>\r\n<li>Depth: 200mm</li>\r\n<li>Sink unit dimensions: 500 x 400mm</li>\r\n<li>Total dimensions: 556 x 456mm</li>\r\n<li>Installation method: Inset</li>\r\n</ul>\r\n</div></div></div>'),(16337,155,0,6259,'Exclude'),(16338,85,5,6260,'Reginox Multa 130 Black Square Single Bowl kitchen Sink'),(16339,85,0,6260,'Reginox Multa 130 Black Square Single Bowl kitchen Sink'),(16340,75,5,6260,'<p><span style=\"font-size: medium;\"><strong>Reginox Multa 130 Inset Single Bowl Granite kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Finish: Black / White / Light grey</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet size: 800mm</li>\r\n<li>Outlet: 3.5\" outlet</li>\r\n<li>Depth: 200mm</li>\r\n<li>Sink unit dimensions: 700 x 400mm</li>\r\n<li>Total dimensions: 756 x 456mm</li>\r\n<li>Installation method: Inset</li>\r\n</ul>\r\n'),(16341,75,0,6260,'<p><span style=\"font-size: medium;\"><strong>Reginox Multa 130 Inset Single Bowl Granite kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Finish: Black / White / Light grey</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet size: 800mm</li>\r\n<li>Outlet: 3.5\" outlet</li>\r\n<li>Depth: 200mm</li>\r\n<li>Sink unit dimensions: 700 x 400mm</li>\r\n<li>Total dimensions: 756 x 456mm</li>\r\n<li>Installation method: Inset</li>\r\n</ul>\r\n'),(16342,155,0,6260,'Exclude'),(16343,85,5,6261,'Franke Mythos MYX 160 34-16 Undermount Stainless Steel 1.5 Bowl Sink'),(16344,85,0,6261,'Franke Mythos MYX 160 34-16 Undermount Stainless Steel 1.5 Bowl Sink'),(16345,75,5,6261,'<style>#html-body [data-pb-style=F8N0XU9]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"F8N0XU9\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 160 34-16 Undermount Stainless Steel 1.5 Bowl Sink</strong></span></p>\r\n<p>The Franke Mythos MYX 160 34-16 Undermount Stainless Steel 1.5 Bowl Sink is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Position of small bowl: Right hand and left hand side</li>\r\n</ul></div></div></div>'),(16346,75,0,6261,'<style>#html-body [data-pb-style=F8N0XU9]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"F8N0XU9\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 160 34-16 Undermount Stainless Steel 1.5 Bowl Sink</strong></span></p>\r\n<p>The Franke Mythos MYX 160 34-16 Undermount Stainless Steel 1.5 Bowl Sink is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Position of small bowl: Right hand and left hand side</li>\r\n</ul></div></div></div>'),(16347,155,0,6261,'Exclude'),(16348,85,5,6262,'Franke Mythos MYX 160 50-16 Undermount Stainless Steel 1.5 Bowl Sink'),(16349,85,0,6262,'Franke Mythos MYX 160 50-16 Undermount Stainless Steel 1.5 Bowl Sink'),(16350,75,5,6262,'<style>#html-body [data-pb-style=SAD36G0]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"SAD36G0\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 160 50-16 Undermount Stainless Steel 1.5 Bowl Sink</strong></span></p>\r\n<p>The Franke Mythos MYX 160 50-16 Undermount Stainless Steel 1.5 Bowl Sink is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts. Top of Form MYTHOS BOWLS MYX 160 50-16, Undermount, One and half Bowl, Matt Brushed Stainless Steel, 3½\" Semi-Integrated Wastes with Hygienic Overflow.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Position of small bowl: Right hand and left hand side</li>\r\n</ul></div></div></div>'),(16351,75,0,6262,'<style>#html-body [data-pb-style=SAD36G0]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"SAD36G0\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 160 50-16 Undermount Stainless Steel 1.5 Bowl Sink</strong></span></p>\r\n<p>The Franke Mythos MYX 160 50-16 Undermount Stainless Steel 1.5 Bowl Sink is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts. Top of Form MYTHOS BOWLS MYX 160 50-16, Undermount, One and half Bowl, Matt Brushed Stainless Steel, 3½\" Semi-Integrated Wastes with Hygienic Overflow.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Position of small bowl: Right hand and left hand side</li>\r\n</ul></div></div></div>'),(16352,155,0,6262,'Exclude'),(16353,85,5,6263,'Franke Mythos MYX 210-34 Inset Single Bowl Sink - Stainless Steel'),(16354,85,0,6263,'Franke Mythos MYX 210-34 Inset Single Bowl Sink - Stainless Steel'),(16355,75,5,6263,'<style>#html-body [data-pb-style=SJ1DQO4]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"SJ1DQO4\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 210-34 Inset Single Bowl Sink - Stainless Steel </strong></span></p>\r\n<p>The Franke Mythos MYX 210-34 Inset Single Bowl Sink - Stainless Steel is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 400mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Waste outlet diameter: 3‐1/2\" ‐ Integrated waste hole</li>\r\n<li>Round flush cover plate</li>\r\n</ul></div></div></div>'),(16356,75,0,6263,'<style>#html-body [data-pb-style=SJ1DQO4]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"SJ1DQO4\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 210-34 Inset Single Bowl Sink - Stainless Steel </strong></span></p>\r\n<p>The Franke Mythos MYX 210-34 Inset Single Bowl Sink - Stainless Steel is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 400mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Waste outlet diameter: 3‐1/2\" ‐ Integrated waste hole</li>\r\n<li>Round flush cover plate</li>\r\n</ul></div></div></div>'),(16357,155,0,6263,'Exclude'),(16358,85,5,6264,'Franke Mythos MYX 210-45 Inset Single Bowl Sink - Stainless Steel'),(16359,85,0,6264,'Franke Mythos MYX 210-45 Inset Single Bowl Sink - Stainless Steel'),(16360,75,5,6264,'<style>#html-body [data-pb-style=NUALHAJ]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"NUALHAJ\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 210-45 Inset Single Bowl Sink - Stainless Steel</strong></span></p>\r\n<p>The Franke Mythos MYX 210-45 Inset Single Bowl Sink - Stainless Steel is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 500mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Round flush cover plate</li>\r\n</ul></div></div></div>'),(16361,75,0,6264,'<style>#html-body [data-pb-style=NUALHAJ]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"NUALHAJ\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 210-45 Inset Single Bowl Sink - Stainless Steel</strong></span></p>\r\n<p>The Franke Mythos MYX 210-45 Inset Single Bowl Sink - Stainless Steel is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 500mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Round flush cover plate</li>\r\n</ul></div></div></div>'),(16362,155,0,6264,'Exclude'),(16363,85,5,6265,'Franke Mythos MYX 210-55 Inset Single Bowl Sink - Stainless Steel'),(16364,85,0,6265,'Franke Mythos MYX 210-55 Inset Single Bowl Sink - Stainless Steel'),(16365,75,5,6265,'<style>#html-body [data-pb-style=B9HDP53]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"B9HDP53\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 210-55 Inset Single Bowl Sink - Stainless Steel</strong></span></p>\r\n<p>The Franke Mythos MYX 210-55 Inset Single Bowl Sink - Stainless Steel is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Round flush cover plate</li>\r\n</ul></div></div></div>'),(16366,75,0,6265,'<style>#html-body [data-pb-style=B9HDP53]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"B9HDP53\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 210-55 Inset Single Bowl Sink - Stainless Steel</strong></span></p>\r\n<p>The Franke Mythos MYX 210-55 Inset Single Bowl Sink - Stainless Steel is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Round flush cover plate</li>\r\n</ul></div></div></div>'),(16367,155,0,6265,'Exclude'),(16368,85,5,6266,'Franke Mythos MYX 210-70 Inset Single Bowl Sink - Stainless Steel'),(16369,85,0,6266,'Franke Mythos MYX 210-70 Inset Single Bowl Sink - Stainless Steel'),(16370,75,5,6266,'<style>#html-body [data-pb-style=IUK4G8I]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"IUK4G8I\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 210-70 Inset Single Bowl Sink - Stainless Steel</strong></span></p>\r\n<p>The Franke Mythos MYX 210-70 Inset Single Bowl Sink - Stainless Steel- Stainless Steel is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 800mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Round flush cover plate</li>\r\n</ul></div></div></div>'),(16371,75,0,6266,'<style>#html-body [data-pb-style=IUK4G8I]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"IUK4G8I\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 210-70 Inset Single Bowl Sink - Stainless Steel</strong></span></p>\r\n<p>The Franke Mythos MYX 210-70 Inset Single Bowl Sink - Stainless Steel- Stainless Steel is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 800mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Integrated overflow</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Round flush cover plate</li>\r\n</ul></div></div></div>'),(16372,155,0,6266,'Exclude'),(16373,85,5,6267,'Franke Mythos MYX 211-86 Stainless Steel Kitchen Sink'),(16374,85,0,6267,'Franke Mythos MYX 211-86 Stainless Steel Kitchen Sink'),(16375,75,5,6267,'<p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 211-86 Stainless Steel Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\n<li>Cabinet size: 600mm</li>\n<li>Installation type: Inset</li>\n<li>Sink: Stainless steel</li>\n<li>Hygienic overflow offers versatililty for cleaning</li>\r\n<li>Push button pop up waste</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Integrated overflow</li>\n<li>Round flush cover plate</li>\n</ul>\r'),(16376,75,0,6267,'<p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 211-86 Stainless Steel Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\n<li>Cabinet size: 600mm</li>\n<li>Installation type: Inset</li>\n<li>Sink: Stainless steel</li>\n<li>Hygienic overflow offers versatililty for cleaning</li>\r\n<li>Push button pop up waste</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Integrated overflow</li>\n<li>Round flush cover plate</li>\n</ul>\r'),(16377,155,0,6267,'Exclude'),(16378,85,5,6268,'Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink'),(16379,85,0,6268,'Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink'),(16380,75,5,6268,'<style>#html-body [data-pb-style=ARJ448C]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"ARJ448C\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\">The Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Slim top edge</li>\r\n<li>Hygienic overflow offers versatililty for cleaning</li>\r\n<li>Push button pop up waste</li>\r\n<li>Replaces the frames by Franke sink range</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Integrated overflow</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Technical Information</strong></span></p>\r\n<ul>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Length overall: 860mm</li>\r\n<li>Width overall: 520mm</li>\r\n<li>Length of large bowl: 340mm</li>\r\n<li>Width of large bowl: 400mm</li>\r\n<li>Depth of large bowl: 200mm</li>\r\n<li>Length of small bowl: 160mm</li>\r\n<li>Width of small bowl: 400mm</li>\r\n<li>Depth of small bowl: 200mm</li>\r\n<li>Cutout length: 846mm</li>\r\n<li>Cutout width: 506mm</li>\r\n</ul></div></div></div>'),(16381,75,0,6268,'<style>#html-body [data-pb-style=ARJ448C]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"ARJ448C\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\">The Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink is likely a high-quality kitchen sink designed for both functionality and aesthetics. Franke is known for producing sinks using various materials such as stainless steel, granite, or composite materials. The Mythos sink may feature a sleek and modern design, deep basin(s) for efficient dishwashing, and may come in different configurations to suit various kitchen layouts.</span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Slim top edge</li>\r\n<li>Hygienic overflow offers versatililty for cleaning</li>\r\n<li>Push button pop up waste</li>\r\n<li>Replaces the frames by Franke sink range</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Integrated overflow</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Technical Information</strong></span></p>\r\n<ul>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Length overall: 860mm</li>\r\n<li>Width overall: 520mm</li>\r\n<li>Length of large bowl: 340mm</li>\r\n<li>Width of large bowl: 400mm</li>\r\n<li>Depth of large bowl: 200mm</li>\r\n<li>Length of small bowl: 160mm</li>\r\n<li>Width of small bowl: 400mm</li>\r\n<li>Depth of small bowl: 200mm</li>\r\n<li>Cutout length: 846mm</li>\r\n<li>Cutout width: 506mm</li>\r\n</ul></div></div></div>'),(16382,155,0,6268,'Exclude'),(16383,85,5,6269,'Blanco NAYA 6 Silgranit PuraDur II® Inset Sink'),(16384,85,0,6269,'Blanco NAYA 6 Silgranit PuraDur II® Inset Sink'),(16385,75,5,6269,'<p><span style=\"font-size: medium;\"><strong>Blanco NAYA 6 Silgranit PuraDur II Inset Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n\r<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 200mm</li>\n<li>The unsurpassed capacity of the bowl provides even more room to do the washing up</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(16386,75,0,6269,'<p><span style=\"font-size: medium;\"><strong>Blanco NAYA 6 Silgranit PuraDur II Inset Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n\r<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 200mm</li>\n<li>The unsurpassed capacity of the bowl provides even more room to do the washing up</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(16387,155,0,6269,'Exclude'),(16388,85,5,6270,'Blanco NAYA XL 9 Inset Silgranit PuraDur II® Kitchen Sink'),(16389,85,0,6270,'Blanco NAYA XL 9 Inset Silgranit PuraDur II® Kitchen Sink'),(16390,75,5,6270,'<p><span style=\"font-size: medium;\"><strong>Blanco NAYA XL 9 Inset Silgranit PuraDur II Kitchen Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n\r<li>Cabinet width: 900mm</li>\r\n<li>Bowl depth: 220mm</li>\r\n<li>The unsurpassed capacity of the bowl provides even more room to do the washing up</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(16391,75,0,6270,'<p><span style=\"font-size: medium;\"><strong>Blanco NAYA XL 9 Inset Silgranit PuraDur II Kitchen Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n\r<li>Cabinet width: 900mm</li>\r\n<li>Bowl depth: 220mm</li>\r\n<li>The unsurpassed capacity of the bowl provides even more room to do the washing up</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(16392,155,0,6270,'Exclude'),(16393,85,5,6271,'Reginox New York 18x40 L Single Bowl Kitchen Sink'),(16394,85,0,6271,'Reginox New York 18x40 L Single Bowl Kitchen Sink'),(16395,75,5,6271,'<p><span style=\"font-size: medium;\"><strong>Reginox New York 18x40 L Single Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Stainless steel gauge: 0.9mm</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 400mm</li>\n<li>Sink unit dimensions: 183 x 403 mm</li>\n<li>Total dimensions: 220 x 440 mm</li>\n<li>Bowl depth: 145mm </li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(16396,75,0,6271,'<p><span style=\"font-size: medium;\"><strong>Reginox New York 18x40 L Single Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Stainless steel gauge: 0.9mm</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 400mm</li>\n<li>Sink unit dimensions: 183 x 403 mm</li>\n<li>Total dimensions: 220 x 440 mm</li>\n<li>Bowl depth: 145mm </li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(16397,155,0,6271,'Exclude'),(16398,85,5,6272,'Reginox New York 18x40+34x40 1.5 Bowl Kitchen Sink'),(16399,85,0,6272,'Reginox New York 18x40+34x40 1.5 Bowl Kitchen Sink'),(16400,75,5,6272,'<p><span style=\"font-size: medium;\"><strong>Reginox New York 18x40+34x40 1.5 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 600mm</li>\n<li>Sink unit dimensions: 183 x 403 / 343 x 403 mm</li>\n<li>Large bowl depth: 180mm </li>\n<li>Small bowl depth 145mm</li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(16401,75,0,6272,'<p><span style=\"font-size: medium;\"><strong>Reginox New York 18x40+34x40 1.5 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 600mm</li>\n<li>Sink unit dimensions: 183 x 403 / 343 x 403 mm</li>\n<li>Large bowl depth: 180mm </li>\n<li>Small bowl depth 145mm</li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(16402,155,0,6272,'Exclude'),(16403,85,5,6273,'Reginox New York 34x40 L Single Bowl Kitchen Sink'),(16404,85,0,6273,'Reginox New York 34x40 L Single Bowl Kitchen Sink'),(16405,75,5,6273,'<p><span style=\"font-size: medium;\"><strong>Reginox New York 34x40 L Single Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Stainless steel gauge: 0.9mm</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 400mm</li>\n<li>Total dimensions: 380 x 440 mm</li>\n<li>Bowl depth: 180mm </li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(16406,75,0,6273,'<p><span style=\"font-size: medium;\"><strong>Reginox New York 34x40 L Single Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Stainless steel gauge: 0.9mm</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 400mm</li>\n<li>Total dimensions: 380 x 440 mm</li>\n<li>Bowl depth: 180mm </li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(16407,155,0,6273,'Exclude'),(16408,85,5,6274,'Reginox New York 34x40+18x40 1.5 Bowl Kitchen Sink'),(16409,85,0,6274,'Reginox New York 34x40+18x40 1.5 Bowl Kitchen Sink'),(16410,75,5,6274,'<p><span style=\"font-size: medium;\"><strong>Reginox New York 34x40+18x40 1.5 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 600mm</li>\n<li>Sink unit dimensions: 343 x 403 / 183 x 403 mm</li>\n<li>Total dimensions: 580 x 440 mm</li>\n<li>Large bowl depth: 180mm </li>\n<li>Small bowl depth 145mm</li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(16411,75,0,6274,'<p><span style=\"font-size: medium;\"><strong>Reginox New York 34x40+18x40 1.5 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 600mm</li>\n<li>Sink unit dimensions: 343 x 403 / 183 x 403 mm</li>\n<li>Total dimensions: 580 x 440 mm</li>\n<li>Large bowl depth: 180mm </li>\n<li>Small bowl depth 145mm</li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(16412,155,0,6274,'Exclude'),(16413,85,5,6275,'Reginox New York 40x40 L Integrated Kitchen Sink'),(16414,85,0,6275,'Reginox New York 40x40 L Integrated Kitchen Sink'),(16415,75,5,6275,'<style>#html-body [data-pb-style=I0AU7HL]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"I0AU7HL\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox New York 40x40 L Integrated Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink Unit Dimensions: 403 x 403 mm</li>\r\n<li>Total Dimensions: 440 x 440 mm</li>\r\n<li>Depth: 180 mm</li>\r\n<li>Installation Method : Integrated, Semi integrated, Undermount</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Range: Elite</li>\r\n<li>Series: New York serie</li>\r\n</ul></div></div></div>'),(16416,75,0,6275,'<style>#html-body [data-pb-style=I0AU7HL]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"I0AU7HL\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox New York 40x40 L Integrated Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink Unit Dimensions: 403 x 403 mm</li>\r\n<li>Total Dimensions: 440 x 440 mm</li>\r\n<li>Depth: 180 mm</li>\r\n<li>Installation Method : Integrated, Semi integrated, Undermount</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Range: Elite</li>\r\n<li>Series: New York serie</li>\r\n</ul></div></div></div>'),(16417,155,0,6275,'Exclude'),(16418,85,5,6276,'Reginox New York 50x40 L Single Bowl Kitchen Sink'),(16419,85,0,6276,'Reginox New York 50x40 L Single Bowl Kitchen Sink'),(16420,75,5,6276,'<p><span style=\"font-size: medium;\"><strong>Reginox New York 50x40 L Single Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Stainless steel gauge: 0.9mm</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 600mm</li>\n<li>Sink unit dimensions: 503 x 403 mm</li>\n<li>Total dimensions: 540 x 440 mm</li>\n<li>Bowl depth: 200mm </li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(16421,75,0,6276,'<p><span style=\"font-size: medium;\"><strong>Reginox New York 50x40 L Single Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Stainless steel gauge: 0.9mm</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 600mm</li>\n<li>Sink unit dimensions: 503 x 403 mm</li>\n<li>Total dimensions: 540 x 440 mm</li>\n<li>Bowl depth: 200mm </li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(16422,155,0,6276,'Exclude'),(16423,85,5,6277,'Reginox New York 50x40+18x40 1.5 Bowl Kitchen Sink'),(16424,85,0,6277,'Reginox New York 50x40+18x40 1.5 Bowl Kitchen Sink'),(16425,75,5,6277,'<p><span style=\"font-size: medium;\"><strong>Reginox New York 50x40+18x40 1.5 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 900mm</li>\n<li>Sink unit dimensions : 503 x 403 / 183 x 403 mm</li>\n<li>Total dimensions: 740 x 440 mm</li>\n<li>Large bowl depth: 200mm </li>\n<li>Small bowl depth 145mm</li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(16426,75,0,6277,'<p><span style=\"font-size: medium;\"><strong>Reginox New York 50x40+18x40 1.5 Bowl Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n <li>Installation : Inset</li>\n <li>Material: Stainless Steel</li>\n<li>Drainer Position : Reversible</li>\n <li>Finish: Polished Inox</li>\n<li>Minimum cabinet size: 900mm</li>\n<li>Sink unit dimensions : 503 x 403 / 183 x 403 mm</li>\n<li>Total dimensions: 740 x 440 mm</li>\n<li>Large bowl depth: 200mm </li>\n<li>Small bowl depth 145mm</li>\n<li>Outlet : 3.5\" outlet</li>\n<li>Strainer Waste Included</li>\n<li>Supplied With Fitting kit</li>\n<li>Warranty/Guarantee: Lifetime</li>\n</ul>\n'),(16427,155,0,6277,'Exclude'),(16428,85,5,6278,'Franke Neptune Kitchen Sink, Franke Tap deals,NEX 211 Kitchen Sink, Stainless Steel Kitchen Sink,'),(16429,85,0,6278,'Franke Neptune Kitchen Sink, Franke Tap deals,NEX 211 Kitchen Sink, Stainless Steel Kitchen Sink,'),(16430,75,5,6278,'<p><span style=\"font-size: medium;\"><strong>Franke Neptune NEX 211 Inset 1.0 Bowl Kitchen Sink Stainless Steel</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Recessed drainer</li>\r\n<li>Position of drainer: Right hand and left hand side</li>\r\n</ul>\r\n'),(16431,75,0,6278,'<p><span style=\"font-size: medium;\"><strong>Franke Neptune NEX 211 Inset 1.0 Bowl Kitchen Sink Stainless Steel</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n<li>Recessed drainer</li>\r\n<li>Position of drainer: Right hand and left hand side</li>\r\n</ul>\r\n'),(16432,155,0,6278,'Exclude'),(16433,85,5,6279,'Franke Neptune Kitchen Sink,Franke Tap deals, Franke kitchen Appliances,NEX 251 Inset 1.5 Bowl Kitchen Sink'),(16434,85,0,6279,'Franke Neptune Kitchen Sink,Franke Tap deals, Franke kitchen Appliances,NEX 251 Inset 1.5 Bowl Kitchen Sink'),(16435,75,5,6279,'<p><span style=\"font-size: medium;\"><strong>Franke Neptune NEX 251 Inset 1.5 Bowl Kitchen Sink Stainless Steel</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Installation type: Inset </li>\r\n<li>Position of drainer: Right hand and left hand side</li>\r\n<li>Position of small bowl: Center</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Edge profile slimtop</li>\r\n<li>Sink: Stainless Steel</li>\r\n</ul>'),(16436,75,0,6279,'<p><span style=\"font-size: medium;\"><strong>Franke Neptune NEX 251 Inset 1.5 Bowl Kitchen Sink Stainless Steel</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Installation type: Inset </li>\r\n<li>Position of drainer: Right hand and left hand side</li>\r\n<li>Position of small bowl: Center</li>\r\n<li>Edge profile flushmount</li>\r\n<li>Edge profile slimtop</li>\r\n<li>Sink: Stainless Steel</li>\r\n</ul>'),(16437,155,0,6279,'Exclude'),(16438,85,5,6280,'RAK Laboratory 1 Ceramic Kitchen Sink - Single Bowl'),(16439,85,0,6280,'RAK Laboratory 1 Ceramic Kitchen Sink - Single Bowl'),(16440,75,5,6280,'<p><span style=\"font-size: medium;\"><strong>RAK Laboratory 1 Ceramic Kitchen Sink - Single Bowl - OC162AWHA</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Colour: Alpine White</li>\n<li>Weight: 12 Kg</li>\n<li>Style: Modern</li>\n<li>Material: Fireclay</li>\n<li>No Taphole</li>\n<li>Easy to install and use</li>\n<li>Manufactured for strength and durability </li>\n<li>Suitable for use in classrooms, laboratories, home and schools </li>\n<li>10 years guarantee on Sinks against any manufacturer fault</li>\n</ul>\n'),(16441,75,0,6280,'<p><span style=\"font-size: medium;\"><strong>RAK Laboratory 1 Ceramic Kitchen Sink - Single Bowl - OC162AWHA</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Colour: Alpine White</li>\n<li>Weight: 12 Kg</li>\n<li>Style: Modern</li>\n<li>Material: Fireclay</li>\n<li>No Taphole</li>\n<li>Easy to install and use</li>\n<li>Manufactured for strength and durability </li>\n<li>Suitable for use in classrooms, laboratories, home and schools </li>\n<li>10 years guarantee on Sinks against any manufacturer fault</li>\n</ul>\n'),(16442,155,0,6280,'Exclude'),(16443,85,5,6281,'RAK Laboratory 2 Ceramic Kitchen Sink - Single Bowl'),(16444,85,0,6281,'RAK Laboratory 2 Ceramic Kitchen Sink - Single Bowl'),(16445,75,5,6281,'<p><span style=\"font-size: medium;\"><strong>RAK Laboratory 2 Ceramic Kitchen Sink - Single Bowl - OC163AWHA</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Colour: Alpine White</li>\n<li>Weight: 15 Kg</li>\n<li>Style: Modern</li>\n<li>Material: Fireclay</li>\n<li>No Taphole</li>\n<li>Easy to install and use</li>\n<li>Manufactured for strength and durability </li>\n<li>Suitable for use in classrooms, laboratories, home and schools </li>\n<li>10 years guarantee on Sinks against any manufacturer fault</li>\n</ul>\n'),(16446,75,0,6281,'<p><span style=\"font-size: medium;\"><strong>RAK Laboratory 2 Ceramic Kitchen Sink - Single Bowl - OC163AWHA</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Colour: Alpine White</li>\n<li>Weight: 15 Kg</li>\n<li>Style: Modern</li>\n<li>Material: Fireclay</li>\n<li>No Taphole</li>\n<li>Easy to install and use</li>\n<li>Manufactured for strength and durability </li>\n<li>Suitable for use in classrooms, laboratories, home and schools </li>\n<li>10 years guarantee on Sinks against any manufacturer fault</li>\n</ul>\n'),(16447,155,0,6281,'Exclude'),(16448,85,5,6282,'RAK Laboratory Counter Top Single Bowl Kitchen Sink - LABSINK3'),(16449,85,0,6282,'RAK Laboratory Counter Top Single Bowl Kitchen Sink - LABSINK3'),(16450,75,5,6282,'<p><span style=\"font-size: medium;\"><strong>RAK Laboratory Counter Top Single Bowl Kitchen Sink - OC164AWHA</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Gloss white finish </li>\n<li>Manufactured for strength and durability </li>\n<li>Suitable for use in classrooms, laboratories, home and schools </li>\n<li> Colour: Alpine White</li>\n<li>Constructed from top quality fireclay </li>\n<li>Style: Modern </li>\n<li>10 years guarantee against any manufacturer default</li>\n</ul>\n'),(16451,75,0,6282,'<p><span style=\"font-size: medium;\"><strong>RAK Laboratory Counter Top Single Bowl Kitchen Sink - OC164AWHA</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Gloss white finish </li>\n<li>Manufactured for strength and durability </li>\n<li>Suitable for use in classrooms, laboratories, home and schools </li>\n<li> Colour: Alpine White</li>\n<li>Constructed from top quality fireclay </li>\n<li>Style: Modern </li>\n<li>10 years guarantee against any manufacturer default</li>\n</ul>\n'),(16452,155,0,6282,'Exclude'),(16453,85,5,6283,'RAK Laboratory Counter Top Single Bowl Ceramic Kitchen Sink - LABSINK4'),(16454,85,0,6283,'RAK Laboratory Counter Top Single Bowl Ceramic Kitchen Sink - LABSINK4'),(16455,75,5,6283,'<p><span style=\"font-size: medium;\"><strong>RAK Lab Drop In Counter Top Single Bowl Kitchen Sink - OC165AWHA</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Waste size: 50mm</li>\n<li>Can be over or undermounted with support </li>\n<li>Material: Ceramic</li>\n<li>Single Bowl</li>\n<li>No Taphole</li>\n<li>Comes in an attractive white finish</li>\n<li>Easy to clean</li>\n<li>Incredibly strong and durable</li>\n<li>Easy to install and use</li>\n<li>Constructed from top quality fireclay </li>\n<li>Style: Modern </li>\n<li>10 years guarantee From manufacturer</li>\n</ul>\n'),(16456,75,0,6283,'<p><span style=\"font-size: medium;\"><strong>RAK Lab Drop In Counter Top Single Bowl Kitchen Sink - OC165AWHA</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Waste size: 50mm</li>\n<li>Can be over or undermounted with support </li>\n<li>Material: Ceramic</li>\n<li>Single Bowl</li>\n<li>No Taphole</li>\n<li>Comes in an attractive white finish</li>\n<li>Easy to clean</li>\n<li>Incredibly strong and durable</li>\n<li>Easy to install and use</li>\n<li>Constructed from top quality fireclay </li>\n<li>Style: Modern </li>\n<li>10 years guarantee From manufacturer</li>\n</ul>\n'),(16457,155,0,6283,'Exclude'),(16458,85,5,6284,'Reginox Elite Ohio L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(16459,85,0,6284,'Reginox Elite Ohio L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(16460,75,5,6284,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Ohio L Integrated 0.5 Bowl Kitchen Sink 18X40cm</strong></span></p>\r\n<p style=\"text-align: justify;\">The <strong>kitchen sink</strong> is the most needed thing in any kitchen regardless the size of the kitchen. Reginox understands your requirements and so it has designed a sink that will give a perfect fit to small kitchens as well as can be used as an additional sink in comparatively large kitchens. It requires a cabinet of 400mm size to fit seamlessly. It has designed in a way to keep the hygiene level high. It has an outlet of 3,5&rdquo; and a depth of 145mm. Though the size of this sink is small but it gives an exceptional use. Get it from Banyo because it is giving an exciting discount offer on this <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>incredible sink</strong></span></a>. A guarantee of 10 years is provided by Reginox for your peace of mind.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Ohio L Integrated 0.5 Bowl Kitchen Sink 18X40cm</li>\r\n<li>Cabinet Size: 400mm</li>\r\n<li>Sink Unit Dimensions: 183 x 403 mm</li>\r\n<li>Total Dimensions: 220 x 440 mm</li>\r\n<li>Depth: 145 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Ohio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>15 and 25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Easy to clean, hygienic design</li>\r\n</ul>\r'),(16461,75,0,6284,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Ohio L Integrated 0.5 Bowl Kitchen Sink 18X40cm</strong></span></p>\r\n<p style=\"text-align: justify;\">The <strong>kitchen sink</strong> is the most needed thing in any kitchen regardless the size of the kitchen. Reginox understands your requirements and so it has designed a sink that will give a perfect fit to small kitchens as well as can be used as an additional sink in comparatively large kitchens. It requires a cabinet of 400mm size to fit seamlessly. It has designed in a way to keep the hygiene level high. It has an outlet of 3,5&rdquo; and a depth of 145mm. Though the size of this sink is small but it gives an exceptional use. Get it from Banyo because it is giving an exciting discount offer on this <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>incredible sink</strong></span></a>. A guarantee of 10 years is provided by Reginox for your peace of mind.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Ohio L Integrated 0.5 Bowl Kitchen Sink 18X40cm</li>\r\n<li>Cabinet Size: 400mm</li>\r\n<li>Sink Unit Dimensions: 183 x 403 mm</li>\r\n<li>Total Dimensions: 220 x 440 mm</li>\r\n<li>Depth: 145 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Ohio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>15 and 25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Easy to clean, hygienic design</li>\r\n</ul>\r'),(16462,155,0,6284,'Exclude'),(16463,85,5,6285,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 18X40+50X40cm'),(16464,85,0,6285,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 18X40+50X40cm'),(16465,75,5,6285,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 18X40+50X40cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 18X40+50X40cm</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink Unit Dimensions: 183 x 403 / 503 x 403 mm</li>\r\n<li>Total Dimensions: 753 x 440 mm</li>\r\n<li>Depth: 145 mm / 200 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type:  One and half bowl</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Ohio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>15 and 25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Easy to clean, hygienic design</li>\r\n</ul>\r'),(16466,75,0,6285,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 18X40+50X40cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 18X40+50X40cm</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink Unit Dimensions: 183 x 403 / 503 x 403 mm</li>\r\n<li>Total Dimensions: 753 x 440 mm</li>\r\n<li>Depth: 145 mm / 200 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type:  One and half bowl</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Ohio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>15 and 25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Easy to clean, hygienic design</li>\r\n</ul>\r'),(16467,155,0,6285,'Exclude'),(16468,85,5,6286,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 40X40cm'),(16469,85,0,6286,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 40X40cm'),(16470,75,5,6286,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 40X40cm</strong></span></p>\r\n<p style=\"text-align: justify;\">Sinks are included in the core accessories of any kitchen and so it should be selected with great care. A right sink can automatically make your washing and cleaning moments more comfortable. <strong>Reginox Elite Ohio kitchen sink</strong> can prove an incredible choice for any kitchen due to its elegant design and seamless shape. The bowl of this sink is polished and shiny to give a trendy look to any <a href=\"/kitchen-appliances.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>kitchen</strong> </span></a>as well as the worktop is unpolished. You can install it within a few minutes as it requires integrated installation. It can be cleaned within no time as no stains can stay on it for a longer time and it is also corrosion, rust, and stain resistant.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 40X40cm</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink Unit Dimensions: 403 x 403 mm</li>\r\n<li>Total Dimensions: 440 x 440 mm</li>\r\n<li>Depth: 180 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Ohio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>15 and 25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Easy to clean, hygienic design</li>\r\n</ul>\r'),(16471,75,0,6286,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 40X40cm</strong></span></p>\r\n<p style=\"text-align: justify;\">Sinks are included in the core accessories of any kitchen and so it should be selected with great care. A right sink can automatically make your washing and cleaning moments more comfortable. <strong>Reginox Elite Ohio kitchen sink</strong> can prove an incredible choice for any kitchen due to its elegant design and seamless shape. The bowl of this sink is polished and shiny to give a trendy look to any <a href=\"/kitchen-appliances.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>kitchen</strong> </span></a>as well as the worktop is unpolished. You can install it within a few minutes as it requires integrated installation. It can be cleaned within no time as no stains can stay on it for a longer time and it is also corrosion, rust, and stain resistant.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 40X40cm</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink Unit Dimensions: 403 x 403 mm</li>\r\n<li>Total Dimensions: 440 x 440 mm</li>\r\n<li>Depth: 180 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Ohio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>15 and 25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Easy to clean, hygienic design</li>\r\n</ul>\r'),(16472,155,0,6286,'Exclude'),(16473,85,5,6287,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 40X40cm'),(16474,85,0,6287,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 40X40cm'),(16475,75,5,6287,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 40X40cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 40X40cm</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink Unit Dimensions: 403 x 403 mm</li>\r\n<li>Total Dimensions: 440 x 510 mm</li>\r\n<li>Depth: 180 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Ohio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>15 and 25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Easy to clean, hygienic design</li>\r\n<li>Not suitable for undermount</li>\r\n</ul>\r'),(16476,75,0,6287,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 40X40cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 40X40cm</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink Unit Dimensions: 403 x 403 mm</li>\r\n<li>Total Dimensions: 440 x 510 mm</li>\r\n<li>Depth: 180 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Ohio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>15 and 25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Easy to clean, hygienic design</li>\r\n<li>Not suitable for undermount</li>\r\n</ul>\r'),(16477,155,0,6287,'Exclude'),(16478,85,5,6288,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 50X40cm'),(16479,85,0,6288,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 50X40cm'),(16480,75,5,6288,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 50X40cm</strong></span></p>\r\n<p style=\"text-align: justify;\"> Reginox Elite Ohio kitchen sinkis an absolutely perfect choice for busy kitchens because it is wide enough to give excessive use. Square sinks always look elegant with any kitchen decor. The drainer of this <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"> stainless steel sink</span></a> has round shape and holes of perfect size that can drain water easily and quickly. The cabinet size should be of 600mm to fit this sink seamlessly as it requires integrated method for installation. Depth of bowl is 200mm and its edges can fit seamlessly with worktop due to the integrated installation method. Rounded corners of bottom can be cleaned effortlessly as food particles can be wiped away easily. This stainless steel sink is rust resistant as well as withstands extreme temperatures.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 50X40cm</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink Unit Dimensions: 503 x 403 mm</li>\r\n<li>Total Dimensions: 540 x 440 mm</li>\r\n<li>Depth: 200 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Ohio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>15 and 25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Easy to clean, hygienic design</li>\r\n</ul>\r'),(16481,75,0,6288,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 50X40cm</strong></span></p>\r\n<p style=\"text-align: justify;\"> Reginox Elite Ohio kitchen sinkis an absolutely perfect choice for busy kitchens because it is wide enough to give excessive use. Square sinks always look elegant with any kitchen decor. The drainer of this <a href=\"/kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"> stainless steel sink</span></a> has round shape and holes of perfect size that can drain water easily and quickly. The cabinet size should be of 600mm to fit this sink seamlessly as it requires integrated method for installation. Depth of bowl is 200mm and its edges can fit seamlessly with worktop due to the integrated installation method. Rounded corners of bottom can be cleaned effortlessly as food particles can be wiped away easily. This stainless steel sink is rust resistant as well as withstands extreme temperatures.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 50X40cm</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink Unit Dimensions: 503 x 403 mm</li>\r\n<li>Total Dimensions: 540 x 440 mm</li>\r\n<li>Depth: 200 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Ohio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>15 and 25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Easy to clean, hygienic design</li>\r\n</ul>\r'),(16482,155,0,6288,'Exclude'),(16483,85,5,6289,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 50X40cm'),(16484,85,0,6289,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 50X40cm'),(16485,75,5,6289,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 50X40cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 50X40cm</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink Unit Dimensions: 503 x 403 mm</li>\r\n<li>Total Dimensions: 540 x 510 mm</li>\r\n<li>Depth: 200 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Ohio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>15 and 25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Easy to clean, hygienic design</li>\r\n<li>Not suitable for undermount</li>\r\n</ul>\r'),(16486,75,0,6289,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 50X40cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 50X40cm</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink Unit Dimensions: 503 x 403 mm</li>\r\n<li>Total Dimensions: 540 x 510 mm</li>\r\n<li>Depth: 200 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Ohio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>15 and 25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Easy to clean, hygienic design</li>\r\n<li>Not suitable for undermount</li>\r\n</ul>\r'),(16487,155,0,6289,'Exclude'),(16488,85,5,6290,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 50X40+18X40cm'),(16489,85,0,6290,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 50X40+18X40cm'),(16490,75,5,6290,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 50X40+18X40cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 50X40+18X40cm</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink Unit Dimensions: 503 x 403 / 183 x 403 mm</li>\r\n<li>Total Dimensions: 753 x 440 mm</li>\r\n<li>Depth: 200 mm / 145 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type:  One and half bowl</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Ohio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>15 and 25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Easy to clean, hygienic design</li>\r\n</ul>\r'),(16491,75,0,6290,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 50X40+18X40cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 50X40+18X40cm</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink Unit Dimensions: 503 x 403 / 183 x 403 mm</li>\r\n<li>Total Dimensions: 753 x 440 mm</li>\r\n<li>Depth: 200 mm / 145 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type:  One and half bowl</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Ohio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>15 and 25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Easy to clean, hygienic design</li>\r\n</ul>\r'),(16492,155,0,6290,'Exclude'),(16493,85,5,6291,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 80X42cm'),(16494,85,0,6291,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 80X42cm'),(16495,75,5,6291,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 80X42cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 80X42cm</li>\r\n<li>Cabinet Size: 900mm</li>\r\n<li>Sink Unit Dimensions:  803 x 423 mm</li>\r\n<li>Total Dimensions:  840 x 460 mm</li>\r\n<li>Depth: 220 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Ohio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>15 and 25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Easy to clean, hygienic design</li>\r\n</ul>\r'),(16496,75,0,6291,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 80X42cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 80X42cm</li>\r\n<li>Cabinet Size: 900mm</li>\r\n<li>Sink Unit Dimensions:  803 x 423 mm</li>\r\n<li>Total Dimensions:  840 x 460 mm</li>\r\n<li>Depth: 220 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Ohio</li>\r\n<li>Material finish: polished inox</li>\r\n<li>15 and 25 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Easy to clean, hygienic design</li>\r\n</ul>\r'),(16497,155,0,6291,'Exclude'),(16498,85,5,6292,'Franke Orion Kitchen Sink,OID 611-94  Kitchen Sink,Franke Kitchen Systems,Tectonite Kitchen Sink, '),(16499,85,0,6292,'Franke Orion Kitchen Sink,OID 611-94  Kitchen Sink,Franke Kitchen Systems,Tectonite Kitchen Sink, '),(16500,75,5,6292,'<p><span style=\"font-size: medium;\"><strong>Franke Orion OID 611-94 Tectonite Inset 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 500mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Position of drainer: Reversible</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Polar white, carbon black</li>\r\n</ul>'),(16501,75,0,6292,'<p><span style=\"font-size: medium;\"><strong>Franke Orion OID 611-94 Tectonite Inset 1.0 Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single bowl sink</li>\r\n<li>Cabinet size: 500mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Position of drainer: Reversible</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Polar white, carbon black</li>\r\n</ul>'),(16502,155,0,6292,'Exclude'),(16503,85,5,6293,'Franke OID 651 Kitchen Sink,Franke Cheap Sinks,Franke Sinks, Franke Sink Deals,Tectonite 1.5 Bowl Kitchen Sink'),(16504,85,0,6293,'Franke OID 651 Kitchen Sink,Franke Cheap Sinks,Franke Sinks, Franke Sink Deals,Tectonite 1.5 Bowl Kitchen Sink'),(16505,75,5,6293,'<style>#html-body [data-pb-style=EASKEDT]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"EASKEDT\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke OID 651 Tectonite 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\">Robustness combined with a unique freedom of design makes Tectonite sinks the ultimate choice for hardworking, stylish kitchens. Franke Tectonite is made from an advanced synthetic composite material. Its granite-like appearance and unique texture not only look stunning in your kitchen, but also make the sink heat and scratch-resistant.&nbsp;</span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Position of drainer: Reversible</li>\r\n<li>Position of small bowl: Reversible</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Polar white, carbon black</li>\r\n</ul></div></div></div>'),(16506,75,0,6293,'<style>#html-body [data-pb-style=EASKEDT]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"EASKEDT\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke OID 651 Tectonite 1.5 Bowl Kitchen Sink</strong></span></p>\r\n<p><span style=\"font-size: medium;\">Robustness combined with a unique freedom of design makes Tectonite sinks the ultimate choice for hardworking, stylish kitchens. Franke Tectonite is made from an advanced synthetic composite material. Its granite-like appearance and unique texture not only look stunning in your kitchen, but also make the sink heat and scratch-resistant.&nbsp;</span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Position of drainer: Reversible</li>\r\n<li>Position of small bowl: Reversible</li>\r\n<li>Sink: Fragranite</li>\r\n<li>Available colour: Polar white, carbon black</li>\r\n</ul></div></div></div>'),(16507,155,0,6293,'Exclude'),(16508,85,5,6294,'Reginox Quadra 100 Undermount 1 Bowl Granite Kitchen Sink'),(16509,85,0,6294,'Reginox Quadra 100 Undermount 1 Bowl Granite Kitchen Sink'),(16510,75,5,6294,'<p><span style=\"font-size: medium;\"><strong>Reginox Quadra 100 Undermount 1 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\">If you are searching for a sink that can give you excessive use then <strong>Reginox Quadra kitchen sink</strong> is the best choice for you. The accurate size of the bowl has a perfect position of drainer that does not allow anything other than water to enter the pipe. Inside corners of the bowl are in round shape so that you can clean them easily. Cabinet size should be 450mm to fit this bowl as the bowl is 22mm deep. It will suit to any worktop as it requires undermount installation. High-quality material is used in its crafting to makes it resistant to heat, shock, and impact. Its surface will shine even after the decades of use. Reginox is providing a guarantee of 10 years against any manufacturing defect in the <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>kitchen sink</strong></span></a>. More on, Banyo is offering an unbeatable discount offer on its price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Quadra 100 Undermount 1 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink unit dimensions: 340 x 400 mm</li>\r\n<li>Total dimensions: 380 x 440 mm</li>\r\n<li>Depth: 220 mm</li>\r\n<li>Installation Method: Undermount</li>\r\n<li>Colour: Black, Cream,Titanium &amp; White</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One bowl sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n</ul>\r\n'),(16511,75,0,6294,'<p><span style=\"font-size: medium;\"><strong>Reginox Quadra 100 Undermount 1 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\">If you are searching for a sink that can give you excessive use then <strong>Reginox Quadra kitchen sink</strong> is the best choice for you. The accurate size of the bowl has a perfect position of drainer that does not allow anything other than water to enter the pipe. Inside corners of the bowl are in round shape so that you can clean them easily. Cabinet size should be 450mm to fit this bowl as the bowl is 22mm deep. It will suit to any worktop as it requires undermount installation. High-quality material is used in its crafting to makes it resistant to heat, shock, and impact. Its surface will shine even after the decades of use. Reginox is providing a guarantee of 10 years against any manufacturing defect in the <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>kitchen sink</strong></span></a>. More on, Banyo is offering an unbeatable discount offer on its price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Quadra 100 Undermount 1 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink unit dimensions: 340 x 400 mm</li>\r\n<li>Total dimensions: 380 x 440 mm</li>\r\n<li>Depth: 220 mm</li>\r\n<li>Installation Method: Undermount</li>\r\n<li>Colour: Black, Cream,Titanium &amp; White</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One bowl sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n</ul>\r\n'),(16512,155,0,6294,'Exclude'),(16513,85,5,6295,'Reginox Quadra 105 Undermount 1 Bowl Granite Kitchen Sink'),(16514,85,0,6295,'Reginox Quadra 105 Undermount 1 Bowl Granite Kitchen Sink'),(16515,75,5,6295,'<p><span style=\"font-size: medium;\"><strong>Reginox Quadra 105 Undermount 1 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Quadra kitchen sink</strong> has a perfect square shape that adds elegance to its beauty. Four seamless corners are giving an eye-catching look to it. It is wide enough to give a wonderful use as you can place pots in it without worrying about its strength. Granite is used in its crafting as a fundamental material for making it durable, long lasting, and more incredible. Options of black, cream, white, and titanium colours are available in this sink. Undermount installation of this sink does not take any extra time as it is unbelievingly easy to install. It can be installed as a separate or additional sink in larger kitchens or as a main sink in small kitchens. You can clean this <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>kitchen sink</strong></span></a> within a blink of an eye as stains cannot stick on its surface for a longer time.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Quadra 105 Undermount 1 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink unit dimensions: 500 x 400 mm</li>\r\n<li>Total dimensions: 540 x 440 mm</li>\r\n<li>Depth: 220 mm</li>\r\n<li>Installation Method: Undermount</li>\r\n<li>Colour: Black, Cream,Titanium &amp; White</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One bowl sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n</ul>\r\n'),(16516,75,0,6295,'<p><span style=\"font-size: medium;\"><strong>Reginox Quadra 105 Undermount 1 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Quadra kitchen sink</strong> has a perfect square shape that adds elegance to its beauty. Four seamless corners are giving an eye-catching look to it. It is wide enough to give a wonderful use as you can place pots in it without worrying about its strength. Granite is used in its crafting as a fundamental material for making it durable, long lasting, and more incredible. Options of black, cream, white, and titanium colours are available in this sink. Undermount installation of this sink does not take any extra time as it is unbelievingly easy to install. It can be installed as a separate or additional sink in larger kitchens or as a main sink in small kitchens. You can clean this <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>kitchen sink</strong></span></a> within a blink of an eye as stains cannot stick on its surface for a longer time.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Quadra 105 Undermount 1 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink unit dimensions: 500 x 400 mm</li>\r\n<li>Total dimensions: 540 x 440 mm</li>\r\n<li>Depth: 220 mm</li>\r\n<li>Installation Method: Undermount</li>\r\n<li>Colour: Black, Cream,Titanium &amp; White</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One bowl sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n</ul>\r\n'),(16517,155,0,6295,'Exclude'),(16518,85,5,6296,'Reginox Quadra 130 Undermount 1 Bowl Granite Kitchen Sink'),(16519,85,0,6296,'Reginox Quadra 130 Undermount 1 Bowl Granite Kitchen Sink'),(16520,75,5,6296,'<p><span style=\"font-size: medium;\"><strong>Reginox Quadra 130 Undermount 1 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Quadra kitchen sink</strong> is designed in a way to bring more convenience in your life. Reginox brought this sink to you as a result of deep research for giving an exceptional functionality to you. Area of this sink is wide enough to facilitate you during washing and cleaning as you can place pots on it because the strength of this bowl will not be compromised. The draining area is positioned in a way that water can be drained easily. Depth of this bowl is 220mm whereas the cabinet size should be of 800mm. There are many options in the colours of this <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>undermount sink</strong></span></a> that make it distinctive. Reginox is providing a guarantee of 10 years against any manufacturing defect in this sink. Bring it home for enjoying the incredible features of this sink.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Quadra 130 Undermount 1 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink unit dimensions: 720 x 400 mm</li>\r\n<li>Total dimensions: 760 x 440 mm</li>\r\n<li>Depth: 220 mm</li>\r\n<li>Installation Method: Undermount</li>\r\n<li>Colour: Black, Cream,Titanium &amp; White</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One bowl sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n</ul>\r\n'),(16521,75,0,6296,'<p><span style=\"font-size: medium;\"><strong>Reginox Quadra 130 Undermount 1 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Quadra kitchen sink</strong> is designed in a way to bring more convenience in your life. Reginox brought this sink to you as a result of deep research for giving an exceptional functionality to you. Area of this sink is wide enough to facilitate you during washing and cleaning as you can place pots on it because the strength of this bowl will not be compromised. The draining area is positioned in a way that water can be drained easily. Depth of this bowl is 220mm whereas the cabinet size should be of 800mm. There are many options in the colours of this <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>undermount sink</strong></span></a> that make it distinctive. Reginox is providing a guarantee of 10 years against any manufacturing defect in this sink. Bring it home for enjoying the incredible features of this sink.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Quadra 130 Undermount 1 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink unit dimensions: 720 x 400 mm</li>\r\n<li>Total dimensions: 760 x 440 mm</li>\r\n<li>Depth: 220 mm</li>\r\n<li>Installation Method: Undermount</li>\r\n<li>Colour: Black, Cream,Titanium &amp; White</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>One bowl sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n</ul>\r\n'),(16522,155,0,6296,'Exclude'),(16523,85,5,6297,'Reginox Quadra 50 Undermount 0.5 Bowl Granite Kitchen Sink'),(16524,85,0,6297,'Reginox Quadra 50 Undermount 0.5 Bowl Granite Kitchen Sink'),(16525,75,5,6297,'<p><span style=\"font-size: medium;\"><strong>Reginox Quadra 50 Undermount 0.5 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p>Reginox quadra kitchen sink is a right choice for small kitchens where space is limited as the size of this sink is small. You can install it as an additional sink in large kitchens as it will be perfectly suitable for washing knives, spoons or folks. This granite sink has developed with sanitization technology that highly reduces bacterial growth. The construction with granite material makes it hard-wearing as it resists heat, chips, and stains. It will resist heat up to 536<sup>0</sup>F as well as you will find it long lasting. Whenever you run your fingers over the fine surface of this sink, you will feel that you are touching something extra special. You can clean it effortlessly by simply using the nylon brush or soapy water can also be used.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Quadra 50 Undermount 0.5 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 300mm</li>\r\n<li>Sink unit dimensions: 160 x 400 mm</li>\r\n<li>Total dimensions: 200 x 440 mm</li>\r\n<li>Depth: 170 mm</li>\r\n<li>Installation Method: Undermount</li>\r\n<li>Colour: Black, Cream,Titanium &amp; White</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Half-bowl sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n</ul>\r\n'),(16526,75,0,6297,'<p><span style=\"font-size: medium;\"><strong>Reginox Quadra 50 Undermount 0.5 Bowl Granite Kitchen Sink</strong></span></p>\r\n<p>Reginox quadra kitchen sink is a right choice for small kitchens where space is limited as the size of this sink is small. You can install it as an additional sink in large kitchens as it will be perfectly suitable for washing knives, spoons or folks. This granite sink has developed with sanitization technology that highly reduces bacterial growth. The construction with granite material makes it hard-wearing as it resists heat, chips, and stains. It will resist heat up to 536<sup>0</sup>F as well as you will find it long lasting. Whenever you run your fingers over the fine surface of this sink, you will feel that you are touching something extra special. You can clean it effortlessly by simply using the nylon brush or soapy water can also be used.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Quadra 50 Undermount 0.5 Bowl Granite Kitchen Sink</li>\r\n<li>Cabinet Size: 300mm</li>\r\n<li>Sink unit dimensions: 160 x 400 mm</li>\r\n<li>Total dimensions: 200 x 440 mm</li>\r\n<li>Depth: 170 mm</li>\r\n<li>Installation Method: Undermount</li>\r\n<li>Colour: Black, Cream,Titanium &amp; White</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Half-bowl sink</li>\r\n<li>Material: metaltek or granitek</li>\r\n</ul>\r\n'),(16527,155,0,6297,'Exclude'),(16528,85,5,6298,'Reginox R18 2330 OSK Single Bowl Inset Kitchen Sink'),(16529,85,0,6298,'Reginox R18 2330 OSK Single Bowl Inset Kitchen Sink'),(16530,75,5,6298,'<style>#html-body [data-pb-style=M8UT22R]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"M8UT22R\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox R18 2330 OSK Single Bowl Kitchen Sink - Inset </strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Finish: Chrome</li>\n<li>Gauge of steel: 06</li>\n<li>Type: square sinks</li>\n<li>Waste kit included</li>\n<li>Clips &amp; seals included</li>\n<li>Welded or pressed: Pressed</li>\n<li>Waste specifications: 50mm</li>\n<li>Material: 304 stainless steel&nbsp;</li>\n<li>Sink dimensions: 341 x 281 x 150mm</li>\n<li>Cut out size: 325 x 265mm</li>\n<li>Bowl size: 296 x 236mm</li>\n<li>Cabinet Size: 400mm</li>\n<li>Depth: 150 mm</li>\n</ul>'),(16531,75,0,6298,'<style>#html-body [data-pb-style=M8UT22R]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"M8UT22R\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox R18 2330 OSK Single Bowl Kitchen Sink - Inset </strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Finish: Chrome</li>\n<li>Gauge of steel: 06</li>\n<li>Type: square sinks</li>\n<li>Waste kit included</li>\n<li>Clips &amp; seals included</li>\n<li>Welded or pressed: Pressed</li>\n<li>Waste specifications: 50mm</li>\n<li>Material: 304 stainless steel&nbsp;</li>\n<li>Sink dimensions: 341 x 281 x 150mm</li>\n<li>Cut out size: 325 x 265mm</li>\n<li>Bowl size: 296 x 236mm</li>\n<li>Cabinet Size: 400mm</li>\n<li>Depth: 150 mm</li>\n</ul>'),(16532,155,0,6298,'Exclude'),(16533,85,5,6299,'Franke RBX 610, Rotondo 1.0 Bowl Kitchen Sink, Stainless Steel Sink,Franke Sinks, Franke Sink Deals,'),(16534,85,0,6299,'Franke RBX 610, Rotondo 1.0 Bowl Kitchen Sink, Stainless Steel Sink,Franke Sinks, Franke Sink Deals,'),(16535,75,5,6299,'<p><span style=\"font-size: medium;\"><strong>Franke RBX 610 Rotondo 1.0 Bowl Kitchen Sink Stainless Steel </strong></span></p>\r\n<p>\r\n The Franke Rotondo kitchen sink is made of stainless steel and gives a distinctive look to any kitchen. The enchanting round shape of it possesses superior corrosion, stain and rust resistant properties. It has been styled for an inset installation and is compatible with any work surface including the laminate worktops. The edge is rolled over to meet the worktop as it has a standard profile. 500mm is the measurement which the bowl needs to fit into. Its dimensions are 440mm and the cut-out size is 425mm. The luxurious look of this kitchen sink will enhance the beauty of any kitchen.\r\n</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>  \r\n<li>Single bowl sink </li>\r\n<li>Cabinet size: 500mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n </ul>'),(16536,75,0,6299,'<p><span style=\"font-size: medium;\"><strong>Franke RBX 610 Rotondo 1.0 Bowl Kitchen Sink Stainless Steel </strong></span></p>\r\n<p>\r\n The Franke Rotondo kitchen sink is made of stainless steel and gives a distinctive look to any kitchen. The enchanting round shape of it possesses superior corrosion, stain and rust resistant properties. It has been styled for an inset installation and is compatible with any work surface including the laminate worktops. The edge is rolled over to meet the worktop as it has a standard profile. 500mm is the measurement which the bowl needs to fit into. Its dimensions are 440mm and the cut-out size is 425mm. The luxurious look of this kitchen sink will enhance the beauty of any kitchen.\r\n</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>  \r\n<li>Single bowl sink </li>\r\n<li>Cabinet size: 500mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink: Stainless steel</li>\r\n </ul>'),(16537,155,0,6299,'Exclude'),(16538,85,5,6300,'Reginox Comfort Regent10-lux Inset 1 Bowl Kitchen Sink'),(16539,85,0,6300,'Reginox Comfort Regent10-lux Inset 1 Bowl Kitchen Sink'),(16540,75,5,6300,'<style>#html-body [data-pb-style=AK8PPC0]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"AK8PPC0\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Comfort Regent 10-lux Inset 1 Bowl Kitchen Sink</strong></span></p>\r\n<p>Reginox comfort kitchen sink is a perfect choice for those who want both style and functionality in one product. The round shape of this bowl enhances the overall look of this sink and makes it a right choice for your kitchen. The accurate position of the drainer will drain the water efficiently without allowing the food particles to enter the pipe. It will keep the hygiene level high by not allowing the bacteria to grow. The cabinet size where it needs to be fit should be of 450mm and the depth of this bowl is 170mm. It requires inset installation due to which edge of this will sit above the worktop. Reginox provides a guarantee of 10 years against any manufacturing fault and you can go to the site of Banyo to avail the incredible discount off on it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox comfort regent10-lux inset 1 bowl kitchen sink</li>\r\n<li>Cabinet size: 450mm</li>\r\n<li>Sink unit dimensions : 340 x 400mm</li>\r\n<li>Total dimensions: 805 x 480mm</li>\r\n<li>Installation method : Inset</li>\r\n<li>Depth : 170mm</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type : Sinks with right hand drainer&nbsp;</li>\r\n<li>Packaging : Box</li>\r\n<li>Range : Comfort</li>\r\n<li>Series : Regent serie</li>\r\n<li>Material finish: polished inox</li>\r\n</ul></div></div></div>'),(16541,75,0,6300,'<style>#html-body [data-pb-style=AK8PPC0]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"AK8PPC0\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Comfort Regent 10-lux Inset 1 Bowl Kitchen Sink</strong></span></p>\r\n<p>Reginox comfort kitchen sink is a perfect choice for those who want both style and functionality in one product. The round shape of this bowl enhances the overall look of this sink and makes it a right choice for your kitchen. The accurate position of the drainer will drain the water efficiently without allowing the food particles to enter the pipe. It will keep the hygiene level high by not allowing the bacteria to grow. The cabinet size where it needs to be fit should be of 450mm and the depth of this bowl is 170mm. It requires inset installation due to which edge of this will sit above the worktop. Reginox provides a guarantee of 10 years against any manufacturing fault and you can go to the site of Banyo to avail the incredible discount off on it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox comfort regent10-lux inset 1 bowl kitchen sink</li>\r\n<li>Cabinet size: 450mm</li>\r\n<li>Sink unit dimensions : 340 x 400mm</li>\r\n<li>Total dimensions: 805 x 480mm</li>\r\n<li>Installation method : Inset</li>\r\n<li>Depth : 170mm</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type : Sinks with right hand drainer&nbsp;</li>\r\n<li>Packaging : Box</li>\r\n<li>Range : Comfort</li>\r\n<li>Series : Regent serie</li>\r\n<li>Material finish: polished inox</li>\r\n</ul></div></div></div>'),(16542,155,0,6300,'Exclude'),(16543,85,5,6301,'Reginox Comfort Regidrain-R Inset 1 Bowl Kitchen Sink'),(16544,85,0,6301,'Reginox Comfort Regidrain-R Inset 1 Bowl Kitchen Sink'),(16545,75,5,6301,'<p><span style=\"font-size: medium;\"><strong>Reginox Comfort Regidrain-R Inset 1 Bowl Kitchen Sink</strong></span></p>\r\n<p>Your search for a sink with long lasting functionality and excellent designing stops exactly at Reginox Comfort Regidrain kitchen sink. There is one bowl is this sink that requires a cabinet of 450mm size. It has designed with a sharp eye to the precision in order to give a right balance between design and functionality. Reginox understands the value of design and so most beautiful and creative designs. The depth of its bowl is 160mm and the required cabinet size is 450mm. You can get it with or without tap holes depends on your choice. The design of its drainer is quite elegant and renders sufficient space to place things on it. The polished inox is making this product beautiful and long lasting</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Comfort Regidrain-R Inset 1 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink Unit Dimensions : 340 x 400 mm</li>\r\n<li>Total Dimensions: 595 x 470 mm</li>\r\n<li>Installation Method : Inset</li>\r\n<li>Depth : 160mm</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type : Sinks with drainer</li>\r\n<li>Packaging : Box</li>\r\n<li>Range : Comfort </li>\r\n<li>Series : Regent serie </li>\r\n<li>Material finish: polished inox</li>\r\n<li>Available with or without tapholes</li>\r\n</ul>\r'),(16546,75,0,6301,'<p><span style=\"font-size: medium;\"><strong>Reginox Comfort Regidrain-R Inset 1 Bowl Kitchen Sink</strong></span></p>\r\n<p>Your search for a sink with long lasting functionality and excellent designing stops exactly at Reginox Comfort Regidrain kitchen sink. There is one bowl is this sink that requires a cabinet of 450mm size. It has designed with a sharp eye to the precision in order to give a right balance between design and functionality. Reginox understands the value of design and so most beautiful and creative designs. The depth of its bowl is 160mm and the required cabinet size is 450mm. You can get it with or without tap holes depends on your choice. The design of its drainer is quite elegant and renders sufficient space to place things on it. The polished inox is making this product beautiful and long lasting</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Comfort Regidrain-R Inset 1 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink Unit Dimensions : 340 x 400 mm</li>\r\n<li>Total Dimensions: 595 x 470 mm</li>\r\n<li>Installation Method : Inset</li>\r\n<li>Depth : 160mm</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type : Sinks with drainer</li>\r\n<li>Packaging : Box</li>\r\n<li>Range : Comfort </li>\r\n<li>Series : Regent serie </li>\r\n<li>Material finish: polished inox</li>\r\n<li>Available with or without tapholes</li>\r\n</ul>\r'),(16547,155,0,6301,'Exclude'),(16548,85,5,6302,'Reginox Rio OPS L Integrated 1 Bowl Kitchen Sink'),(16549,85,0,6302,'Reginox Rio OPS L Integrated 1 Bowl Kitchen Sink'),(16550,75,5,6302,'<style>#html-body [data-pb-style=DCSBKNR]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"DCSBKNR\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Rio OPS L Integrated 1 Bowl Kitchen Sink</strong></span></p>\r\n<p>Reginox Rio Ops kitchen sink is a proud product of Reginox as there is an increased sale of this product. The round and seamless shape of this product always attracts the viewers. It looks elegant in any kitchen whether you install it in modern kitchen or in traditional kitchen. You will not only find it suitable for domestic kitchens but it is a perfect product for traditional kitchens also. The integrated installation method of this sink increases its worth. The depth of this bowl is sufficient enough to give you excessive use without making any compromise on the strength of this sink. The position of the drainer is in the middle of this bowl to drain the water efficiently.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Rio OPS L Integrated 1 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 400mm</li>\r\n<li>Sink unit dimensions: Ø 250 mm</li>\r\n<li>Total dimensions: Ø 290 mm</li>\r\n<li>Depth: 125 mm</li>\r\n<li>Installation Method: Integrated</li>\r\n<li>Outlet : 1.25\" outlet</li>\r\n<li>Polishing: Inside polished</li>\r\n<li>Packaging: Box</li>\r\n</ul></div></div></div>'),(16551,75,0,6302,'<style>#html-body [data-pb-style=DCSBKNR]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"DCSBKNR\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Rio OPS L Integrated 1 Bowl Kitchen Sink</strong></span></p>\r\n<p>Reginox Rio Ops kitchen sink is a proud product of Reginox as there is an increased sale of this product. The round and seamless shape of this product always attracts the viewers. It looks elegant in any kitchen whether you install it in modern kitchen or in traditional kitchen. You will not only find it suitable for domestic kitchens but it is a perfect product for traditional kitchens also. The integrated installation method of this sink increases its worth. The depth of this bowl is sufficient enough to give you excessive use without making any compromise on the strength of this sink. The position of the drainer is in the middle of this bowl to drain the water efficiently.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Rio OPS L Integrated 1 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 400mm</li>\r\n<li>Sink unit dimensions: Ø 250 mm</li>\r\n<li>Total dimensions: Ø 290 mm</li>\r\n<li>Depth: 125 mm</li>\r\n<li>Installation Method: Integrated</li>\r\n<li>Outlet : 1.25\" outlet</li>\r\n<li>Polishing: Inside polished</li>\r\n<li>Packaging: Box</li>\r\n</ul></div></div></div>'),(16552,155,0,6302,'Exclude'),(16553,85,5,6303,'Reginox Rio L Integrated 1 Bowl Kitchen Sink'),(16554,85,0,6303,'Reginox Rio L Integrated 1 Bowl Kitchen Sink'),(16555,75,5,6303,'<style>#html-body [data-pb-style=VPBDIRR]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"VPBDIRR\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Rio L Integrated 1 Bowl Kitchen Sink</strong></span></p>\r\n<p>Reginox Rio kitchen sink is an outstanding choice for any kitchen. It will not only suit to domestic kitchen but you will find it a perfect choice for commercial kitchens also. The integrated installation helps to fit the edge of the sink and worktop together seamlessly and effortlessly. It will give you advantage of both sleek and hygienic. It is exceptionally easy to clean as it is stain, rust, and corrosion resistant. The depth of its bowl is 125mm whereas the cabinet size where it needs to be fit should be of 300mm. It will surely make your washing and cleaning moments comfortable and enjoyable. Get it from Banyo as it is offering an unbelievable discount on it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Rio L Integrated 1 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 300mm</li>\r\n<li>Sink unit dimensions: Ø 250 mm</li>\r\n<li>Total dimensions: Ø  290 mm</li>\r\n<li>Depth: 125 mm</li>\r\n<li>Installation Method: Integrated</li>\r\n<li>Outlet : 1.25\" outlet</li>\r\n<li>Polishing: Inside polished</li>\r\n<li>Packaging: Box</li>\r\n</ul>\r\n</div></div></div>'),(16556,75,0,6303,'<style>#html-body [data-pb-style=VPBDIRR]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"VPBDIRR\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox Rio L Integrated 1 Bowl Kitchen Sink</strong></span></p>\r\n<p>Reginox Rio kitchen sink is an outstanding choice for any kitchen. It will not only suit to domestic kitchen but you will find it a perfect choice for commercial kitchens also. The integrated installation helps to fit the edge of the sink and worktop together seamlessly and effortlessly. It will give you advantage of both sleek and hygienic. It is exceptionally easy to clean as it is stain, rust, and corrosion resistant. The depth of its bowl is 125mm whereas the cabinet size where it needs to be fit should be of 300mm. It will surely make your washing and cleaning moments comfortable and enjoyable. Get it from Banyo as it is offering an unbelievable discount on it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Rio L Integrated 1 Bowl Kitchen Sink</li>\r\n<li>Cabinet Size: 300mm</li>\r\n<li>Sink unit dimensions: Ø 250 mm</li>\r\n<li>Total dimensions: Ø  290 mm</li>\r\n<li>Depth: 125 mm</li>\r\n<li>Installation Method: Integrated</li>\r\n<li>Outlet : 1.25\" outlet</li>\r\n<li>Polishing: Inside polished</li>\r\n<li>Packaging: Box</li>\r\n</ul>\r\n</div></div></div>'),(16557,155,0,6303,'Exclude'),(16558,85,5,6304,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL301CW'),(16559,85,0,6304,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL301CW'),(16560,75,5,6304,'<p><span style=\"font-size: medium;\"><strong>Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL301CW</strong></span></p>\r\n<p style=\"text-align: justify;\">Reginox is really considered a most useful sink because its functionality is beyond your expectations due to its perfect size and rectangular shape. There is a 1 and a half bowl in this sink that makes your cleaning and washing moments comfortable. A suitable worktop is also rendered with this sink to facilitate your washing moments. Any design of your <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><strong><span style=\"color: #3366ff;\">kitchen sink</span></strong></a> can be enhanced by installing this unique sink. The curved edges of this sink can fit easily with any worktop as you will have to install it from the above for inset installation. There are few sleek and stylish lines on the worktop to give this sink a modern look.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox 1.5 Bowl Ceramic Kitchen Inset Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink Unit Dimensions: 410 x 330 / 170 x 270 mm</li>\r\n<li>Total Dimensions: 1010 x 525 mm</li>\r\n<li>Depth: 180 mm</li>\r\n<li>Installation Method : Inset</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Sinks with drainer, One and half bowl</li>\r\n<li>Packaging : Box</li>\r\n<li>Colour ceramic: White</li>\r\n</ul>\r\n'),(16561,75,0,6304,'<p><span style=\"font-size: medium;\"><strong>Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL301CW</strong></span></p>\r\n<p style=\"text-align: justify;\">Reginox is really considered a most useful sink because its functionality is beyond your expectations due to its perfect size and rectangular shape. There is a 1 and a half bowl in this sink that makes your cleaning and washing moments comfortable. A suitable worktop is also rendered with this sink to facilitate your washing moments. Any design of your <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><strong><span style=\"color: #3366ff;\">kitchen sink</span></strong></a> can be enhanced by installing this unique sink. The curved edges of this sink can fit easily with any worktop as you will have to install it from the above for inset installation. There are few sleek and stylish lines on the worktop to give this sink a modern look.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox 1.5 Bowl Ceramic Kitchen Inset Sink</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink Unit Dimensions: 410 x 330 / 170 x 270 mm</li>\r\n<li>Total Dimensions: 1010 x 525 mm</li>\r\n<li>Depth: 180 mm</li>\r\n<li>Installation Method : Inset</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Sinks with drainer, One and half bowl</li>\r\n<li>Packaging : Box</li>\r\n<li>Colour ceramic: White</li>\r\n</ul>\r\n'),(16562,155,0,6304,'Exclude'),(16563,85,5,6305,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL304CW'),(16564,85,0,6305,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL304CW'),(16565,75,5,6305,'<style>#html-body [data-pb-style=CGR1ISX]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"CGR1ISX\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL304CW</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox 1 bowl kitchen sink</strong> is offered to you by Reginox that always manufactures products that can facilitate your lives in a best way. The ceramic material used in its manufacturing makes it very stylish and amazingly practical. It will combine beautifully with any work surfaces such as granite, wood, and glass. It will stand up to impact, staining, and heat. Place it from above the worktop for inset installation and the size of the cabinet should be 800mm whereas the depth should be 200mm. The colour of this <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>ceramic sink</strong></span></a> is white and the amazing four-cornered square shape of this sink look great in with any work surface. Get it from Banyo as it is offering an exciting discount on this product.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox 1 Bowl Ceramic Kitchen Inset Sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink Unit Dimensions: 495 x 525 mm</li>\r\n<li>Total Dimensions: 1015 x 525 mm</li>\r\n<li>Depth: 200 mm</li>\r\n<li>Installation Method : Inset</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks, Sinks with drainer</li>\r\n<li>Packaging : Box</li>\r\n<li>Colour ceramic: White</li>\r\n</ul></div></div></div>'),(16566,75,0,6305,'<style>#html-body [data-pb-style=CGR1ISX]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"CGR1ISX\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL304CW</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox 1 bowl kitchen sink</strong> is offered to you by Reginox that always manufactures products that can facilitate your lives in a best way. The ceramic material used in its manufacturing makes it very stylish and amazingly practical. It will combine beautifully with any work surfaces such as granite, wood, and glass. It will stand up to impact, staining, and heat. Place it from above the worktop for inset installation and the size of the cabinet should be 800mm whereas the depth should be 200mm. The colour of this <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>ceramic sink</strong></span></a> is white and the amazing four-cornered square shape of this sink look great in with any work surface. Get it from Banyo as it is offering an exciting discount on this product.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox 1 Bowl Ceramic Kitchen Inset Sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink Unit Dimensions: 495 x 525 mm</li>\r\n<li>Total Dimensions: 1015 x 525 mm</li>\r\n<li>Depth: 200 mm</li>\r\n<li>Installation Method : Inset</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks, Sinks with drainer</li>\r\n<li>Packaging : Box</li>\r\n<li>Colour ceramic: White</li>\r\n</ul></div></div></div>'),(16567,155,0,6305,'Exclude'),(16568,85,5,6306,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL401CB'),(16569,85,0,6306,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL401CB'),(16570,75,5,6306,'<style>#html-body [data-pb-style=PTS1S22]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"PTS1S22\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL401CB</strong></span></p>\r\n<p style=\"text-align: justify;\">Reginox 1.5 bowl kitchen sink is a perfect blend of design and nature as it has made from ceramic that makes it tremendously hard-wearing and incomparably smooth. Reginox is manufacturing its products with the most modern deep drawing techniques and the best quality material. As Reginox has more than 39 years of experience so it is obvious that its products give flawless functionality. The innovative design of this 1.5 bowl <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>kitchen sink</strong></span></a> enhances the overall appearance of your kitchen. The small bowl can be used for washing folks, knives or other small utensils. It is available in black colour that adds elegance to it. The size of cabinet should be 600mm for its fitting.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Waste kit included</li>\r\n<li>Waste size: 90mm</li>\r\n<li>Finish: Glossy black</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Handing options: Reversible</li>\r\n<li>Tap hole size: 35 (Pre-drilled under sink)</li>\r\n<li>Tap hole instructions: Using a 35mm diamond drill cutter. Use masking tape to prtect the sink surface.</li>\r\n</ul></div></div></div>'),(16571,75,0,6306,'<style>#html-body [data-pb-style=PTS1S22]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"PTS1S22\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL401CB</strong></span></p>\r\n<p style=\"text-align: justify;\">Reginox 1.5 bowl kitchen sink is a perfect blend of design and nature as it has made from ceramic that makes it tremendously hard-wearing and incomparably smooth. Reginox is manufacturing its products with the most modern deep drawing techniques and the best quality material. As Reginox has more than 39 years of experience so it is obvious that its products give flawless functionality. The innovative design of this 1.5 bowl <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>kitchen sink</strong></span></a> enhances the overall appearance of your kitchen. The small bowl can be used for washing folks, knives or other small utensils. It is available in black colour that adds elegance to it. The size of cabinet should be 600mm for its fitting.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Waste kit included</li>\r\n<li>Waste size: 90mm</li>\r\n<li>Finish: Glossy black</li>\r\n<li>Installation Method: Inset</li>\r\n<li>Handing options: Reversible</li>\r\n<li>Tap hole size: 35 (Pre-drilled under sink)</li>\r\n<li>Tap hole instructions: Using a 35mm diamond drill cutter. Use masking tape to prtect the sink surface.</li>\r\n</ul></div></div></div>'),(16572,155,0,6306,'Exclude'),(16573,85,5,6307,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL501CW'),(16574,85,0,6307,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL501CW'),(16575,75,5,6307,'<p><span style=\"font-size: medium;\"><strong>Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL501CW</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox 1.5 Bowl Ceramic Kitchen Inset Sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink Unit Dimensions: 310 x 340 / 130 x 280 mm</li>\r\n<li>Total Dimensions: 1000 x 500 mm</li>\r\n<li>Depth: 170 mm / 120 mm</li>\r\n<li>Installation Method : Inset</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Sinks with drainer, One and half bowl</li>\r\n<li>Packaging : Box</li>\r\n<li>Colour ceramic: White</li>\r\n</ul>\r'),(16576,75,0,6307,'<p><span style=\"font-size: medium;\"><strong>Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL501CW</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox 1.5 Bowl Ceramic Kitchen Inset Sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink Unit Dimensions: 310 x 340 / 130 x 280 mm</li>\r\n<li>Total Dimensions: 1000 x 500 mm</li>\r\n<li>Depth: 170 mm / 120 mm</li>\r\n<li>Installation Method : Inset</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Sinks with drainer, One and half bowl</li>\r\n<li>Packaging : Box</li>\r\n<li>Colour ceramic: White</li>\r\n</ul>\r'),(16577,155,0,6307,'Exclude'),(16578,85,5,6308,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL504CW'),(16579,85,0,6308,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL504CW'),(16580,75,5,6308,'<p><span style=\"font-size: medium;\"><strong>Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL504CW</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox</strong> kitchen sink is an incredible product for those who want to have something unique in their kitchen. It is very important to consider both factors while choosing a sink, its functionality as well as its designing. A sink can give an excellent functionality if it has made of high-quality material because material is considered as the backbone of any product. This<a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><strong><span style=\"color: #3366ff;\"> kitchen sink</span></strong></a> is made from ceramic that is known as the best material for sink manufacturing. It will prove wonderful for active families as it keeps your kitchen bacteria free. It is vital to maintain the standard hygiene level in your kitchen and so this sink is best from this perspective. It can be cleaned within no time by simply wiping the surface. Banyo is the right place from where you can get this incredible product at discounted price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox 1 Bowl Ceramic Kitchen Inset Sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink Unit Dimensions: 390 x 340 mm</li>\r\n<li>Total Dimensions: 1000 x 500 mm</li>\r\n<li>Depth: 170 mm</li>\r\n<li>Installation Method : Inset</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks, Sinks with drainer</li>\r\n<li>Packaging : Box</li>\r\n<li>Colour ceramic: White</li>\r\n</ul>\r'),(16581,75,0,6308,'<p><span style=\"font-size: medium;\"><strong>Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL504CW</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox</strong> kitchen sink is an incredible product for those who want to have something unique in their kitchen. It is very important to consider both factors while choosing a sink, its functionality as well as its designing. A sink can give an excellent functionality if it has made of high-quality material because material is considered as the backbone of any product. This<a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><strong><span style=\"color: #3366ff;\"> kitchen sink</span></strong></a> is made from ceramic that is known as the best material for sink manufacturing. It will prove wonderful for active families as it keeps your kitchen bacteria free. It is vital to maintain the standard hygiene level in your kitchen and so this sink is best from this perspective. It can be cleaned within no time by simply wiping the surface. Banyo is the right place from where you can get this incredible product at discounted price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox 1 Bowl Ceramic Kitchen Inset Sink</li>\r\n<li>Cabinet Size: 800mm</li>\r\n<li>Sink Unit Dimensions: 390 x 340 mm</li>\r\n<li>Total Dimensions: 1000 x 500 mm</li>\r\n<li>Depth: 170 mm</li>\r\n<li>Installation Method : Inset</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks, Sinks with drainer</li>\r\n<li>Packaging : Box</li>\r\n<li>Colour ceramic: White</li>\r\n</ul>\r'),(16582,155,0,6308,'Exclude'),(16583,85,5,6309,'Blanco ceramic Sink, Blanco Silgranit Sink, Blanco Rondo Silgranit Sink,Blanco classic Sink, Blanco Cheap Sinks'),(16584,85,0,6309,'Blanco ceramic Sink, Blanco Silgranit Sink, Blanco Rondo Silgranit Sink,Blanco classic Sink, Blanco Cheap Sinks'),(16585,75,5,6309,'<p><span style=\"font-size: medium;\"><strong>Blanco Rondo Puradur II Inset Silgranit Kitchen Sink</strong></span></p>\r\n<p> Blanco Rondo Puradur II belongs to the Rondo range of silgranit sinks by Blanco. Blanco Rondo kitchen sinks offer a unique style in inset sinks. Blanco Rondo Puradur II is a finely designed and a compact <a href=\"/brands/blanco/blanco-silgranit-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> silgranit sink</span></a>. This inset sink is perfectly used as the main kitchen sink. Yet it could be coupled with the any other silgranit sinks by Blanco providing extra working space. This sink especially used with a wooden work surface will become the focal point of your kitchen. Blanco Rondo Puradur II as an inset sink comes with a 3 &frac12;&rdquo; basket strainer waste and waste fitting with space-saving pipe. This silgranit sink has 45cm cabinet width; the bowl depth is 165mm and the cut out size of this sink is of 430mm diameter. It also comes in nine different eye-catching colours, thus enhancing the beauty of your kitchen.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 450mm</li>\n<li>Bowl depth: 220mm</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n\r</ul>\r\n\r'),(16586,75,0,6309,'<p><span style=\"font-size: medium;\"><strong>Blanco Rondo Puradur II Inset Silgranit Kitchen Sink</strong></span></p>\r\n<p> Blanco Rondo Puradur II belongs to the Rondo range of silgranit sinks by Blanco. Blanco Rondo kitchen sinks offer a unique style in inset sinks. Blanco Rondo Puradur II is a finely designed and a compact <a href=\"/brands/blanco/blanco-silgranit-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> silgranit sink</span></a>. This inset sink is perfectly used as the main kitchen sink. Yet it could be coupled with the any other silgranit sinks by Blanco providing extra working space. This sink especially used with a wooden work surface will become the focal point of your kitchen. Blanco Rondo Puradur II as an inset sink comes with a 3 &frac12;&rdquo; basket strainer waste and waste fitting with space-saving pipe. This silgranit sink has 45cm cabinet width; the bowl depth is 165mm and the cut out size of this sink is of 430mm diameter. It also comes in nine different eye-catching colours, thus enhancing the beauty of your kitchen.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 450mm</li>\n<li>Bowl depth: 220mm</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n\r</ul>\r\n\r'),(16587,155,0,6309,'Exclude'),(16588,85,5,6310,'Franke Spark SKX 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel'),(16589,85,0,6310,'Franke Spark SKX 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel'),(16590,75,5,6310,'<p><span style=\"font-size: medium;\"><strong>Franke Spark SKX 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul> \n<li>Single bowl sink with drainer  </li>   \n<li>Cabinet size: 450mm</li>\n<li>Installation type: Inset</li>\n<li>Sink: Stainless steel</li>\n<li>Position of drainer:  Reversible</li>\n<li>Edge profile standard</li>\n</ul>'),(16591,75,0,6310,'<p><span style=\"font-size: medium;\"><strong>Franke Spark SKX 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul> \n<li>Single bowl sink with drainer  </li>   \n<li>Cabinet size: 450mm</li>\n<li>Installation type: Inset</li>\n<li>Sink: Stainless steel</li>\n<li>Position of drainer:  Reversible</li>\n<li>Edge profile standard</li>\n</ul>'),(16592,155,0,6310,'Exclude'),(16593,85,5,6311,'Franke Spark SKX 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(16594,85,0,6311,'Franke Spark SKX 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(16595,75,5,6311,'<style>#html-body [data-pb-style=EB5XOFN]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"EB5XOFN\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Spark SKX 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel</strong></span></p>\r\n<p>An additional pan is located to the left or right of the primary bowl in Franke 1.5 bowl sinks. This smaller part is around half the size of the larger one and is ideal for washing veggies, hands, or dumping a drink away. They are manufactured to the highest standards by a trade-trusted brand and are simple to install and maintain.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink material: Stainless steel</li>\r\n<li>Position of drainer: Reversible</li>\r\n<li>Position of small bowl: Middle</li>\r\n</ul></div></div></div>'),(16596,75,0,6311,'<style>#html-body [data-pb-style=EB5XOFN]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"EB5XOFN\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Franke Spark SKX 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel</strong></span></p>\r\n<p>An additional pan is located to the left or right of the primary bowl in Franke 1.5 bowl sinks. This smaller part is around half the size of the larger one and is ideal for washing veggies, hands, or dumping a drink away. They are manufactured to the highest standards by a trade-trusted brand and are simple to install and maintain.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>One and half bowls sink</li>\r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Inset</li>\r\n<li>Sink material: Stainless steel</li>\r\n<li>Position of drainer: Reversible</li>\r\n<li>Position of small bowl: Middle</li>\r\n</ul></div></div></div>'),(16597,155,0,6311,'Exclude'),(16598,75,5,6312,'<p><span style=\"font-size: medium;\"><strong>Blanco Solis 340/180-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n<li>Cabinet width: 600mm</li>\n<li>Overall size: 585 x 440mm</li>\n<li>Small bowl size: 180 x 400mm</li>\n<li>Large bowl size: 545 x 400 x 185mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>Small bowl position can be selected from option given above</li>\n<li>Harmonious interplay between functional and visual elements</li>\n<li>Convenient bowl volume and base surface designed for optimum use</li>\n<li>High-quality features with covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space saving pipe</li>\n<li>2 x 3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(16599,75,0,6312,'<p><span style=\"font-size: medium;\"><strong>Blanco Solis 340/180-U Stainless Steel Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n<li>Cabinet width: 600mm</li>\n<li>Overall size: 585 x 440mm</li>\n<li>Small bowl size: 180 x 400mm</li>\n<li>Large bowl size: 545 x 400 x 185mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>Small bowl position can be selected from option given above</li>\n<li>Harmonious interplay between functional and visual elements</li>\n<li>Convenient bowl volume and base surface designed for optimum use</li>\n<li>High-quality features with covered C-overflow and InFino drain system – elegantly integrated and extremely easy-care</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space saving pipe</li>\n<li>2 x 3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(16600,155,0,6312,'Exclude'),(16601,85,5,6313,'Blanco Sona 5 S Puradur II Silgranit Inset Kitchen Sink'),(16602,85,0,6313,'Blanco Sona 5 S Puradur II Silgranit Inset Kitchen Sink'),(16603,75,5,6313,'<p><strong><span style=\"font-size: medium;\">Blanco Sona 5 S Puradur II Inset Silgranit Kitchen Sink</span></strong></p>\n<p>Those who have medium sized kitchen areas and are looking for a silgranit kitchen sink with compact design; Blanco Sona 5 S is a perfect choice. This <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> inset kitchen sink </span></a>will grab your attention at first glance with its acid resistant and food-safe surface. Blanco Sona 5 S with its large single bowl and large draining area, yet compact design provides an adequate work space even in small as well as medium sized kitchen areas. You can also drill a tap ledge hole to fix a matching mixer tap into this inset kitchen sink. This inset kitchen sinkis available in nine eye-catching colours form white to alu metallic. Blanco Sona 5 S includes a waste fitting with a space-saving pipe and a 3 1&sol;2&quot; basket strainer waste for the main bowl. This silgranit kitchen sink requires 50cm cabinet width to fit in neatly. The depth of the main bowl is 190mm and this sink can be positioned reversibly either right-handed or left-handed.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 500mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Can be installed reversibly</li>\n<li>Modern, independent design</li>\n<li>Handing options: Reversible</li>\n<li>Generous, strikingly-profiled tap ledge</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n\n</ul>\n'),(16604,75,0,6313,'<p><strong><span style=\"font-size: medium;\">Blanco Sona 5 S Puradur II Inset Silgranit Kitchen Sink</span></strong></p>\n<p>Those who have medium sized kitchen areas and are looking for a silgranit kitchen sink with compact design; Blanco Sona 5 S is a perfect choice. This <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> inset kitchen sink </span></a>will grab your attention at first glance with its acid resistant and food-safe surface. Blanco Sona 5 S with its large single bowl and large draining area, yet compact design provides an adequate work space even in small as well as medium sized kitchen areas. You can also drill a tap ledge hole to fix a matching mixer tap into this inset kitchen sink. This inset kitchen sinkis available in nine eye-catching colours form white to alu metallic. Blanco Sona 5 S includes a waste fitting with a space-saving pipe and a 3 1&sol;2&quot; basket strainer waste for the main bowl. This silgranit kitchen sink requires 50cm cabinet width to fit in neatly. The depth of the main bowl is 190mm and this sink can be positioned reversibly either right-handed or left-handed.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 500mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Can be installed reversibly</li>\n<li>Modern, independent design</li>\n<li>Handing options: Reversible</li>\n<li>Generous, strikingly-profiled tap ledge</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n\n</ul>\n'),(16605,155,0,6313,'Exclude'),(16606,85,5,6314,'Blanco Sona 6 S Puradur II Silgranit Inset Kitchen Sink'),(16607,85,0,6314,'Blanco Sona 6 S Puradur II Silgranit Inset Kitchen Sink'),(16608,75,5,6314,'<p><strong><span style=\"font-size: medium;\">Blanco Sona 6 S Puradur II Inset Silgranit Kitchen Sink</span></strong></p>\n<p>Blanco has been a worldwide renowned expert in engineering the exceeding silgranit kitchen sinks for over 90 years. Now Blanco has manufactured the Blanco Sona 6 S which, like other sinks of the Sona family, is an <a href=\"/brands/blanco/blanco-silgranit-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> inset kitchen sink </span></a>with compact design. This inset kitchen sinkwill grab your attention at first glance with its acid resistant and food-safe surface. Blanco Sona 6 S with its main large bowl and the additional half bowl along with a large draining area provides an adequate work space even all sizes of kitchen areas. You can also drill a tap ledge hole to fix a matching mixer tap into this inset kitchen sink. This inset kitchen sinkis available in nine eye-catching colours form white to alu metallic. Blanco Sona 6 S includes a waste fitting with a space-saving pipe and two 3 1&sol;2&quot; basket strainer wastes for both bowls. This silgranit kitchen sink requires 60cm cabinet width to fit in neatly. The depth of the main bowl is 190mm while the half bowl has depth of 100mm and this sink can be positioned reversibly with the main bowl positioned either right-handed or left-handed.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Small bowl depth: 120mm</li>\n<li>Large bowl depth: 190mm</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Modern, independent design</li>\n<li>Handing options: Reversible</li>\n<li>Generous, strikingly-profiled tap ledge</li>\n<li>Kitchen tasks are made much easier by the roomy main bowl and practical additional bowl</li>\n\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>Two 3 1&sol;2&quot; basket strainers</li>\n<li>1&sol;2&quot; bowl non close basket strainer</li>\n\n</ul>\n'),(16609,75,0,6314,'<p><strong><span style=\"font-size: medium;\">Blanco Sona 6 S Puradur II Inset Silgranit Kitchen Sink</span></strong></p>\n<p>Blanco has been a worldwide renowned expert in engineering the exceeding silgranit kitchen sinks for over 90 years. Now Blanco has manufactured the Blanco Sona 6 S which, like other sinks of the Sona family, is an <a href=\"/brands/blanco/blanco-silgranit-sinks.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> inset kitchen sink </span></a>with compact design. This inset kitchen sinkwill grab your attention at first glance with its acid resistant and food-safe surface. Blanco Sona 6 S with its main large bowl and the additional half bowl along with a large draining area provides an adequate work space even all sizes of kitchen areas. You can also drill a tap ledge hole to fix a matching mixer tap into this inset kitchen sink. This inset kitchen sinkis available in nine eye-catching colours form white to alu metallic. Blanco Sona 6 S includes a waste fitting with a space-saving pipe and two 3 1&sol;2&quot; basket strainer wastes for both bowls. This silgranit kitchen sink requires 60cm cabinet width to fit in neatly. The depth of the main bowl is 190mm while the half bowl has depth of 100mm and this sink can be positioned reversibly with the main bowl positioned either right-handed or left-handed.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Small bowl depth: 120mm</li>\n<li>Large bowl depth: 190mm</li>\n<li>Style: One & Half Bowl Sink</li>\n<li>Modern, independent design</li>\n<li>Handing options: Reversible</li>\n<li>Generous, strikingly-profiled tap ledge</li>\n<li>Kitchen tasks are made much easier by the roomy main bowl and practical additional bowl</li>\n\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>Two 3 1&sol;2&quot; basket strainers</li>\n<li>1&sol;2&quot; bowl non close basket strainer</li>\n\n</ul>\n'),(16610,155,0,6314,'Exclude'),(16611,85,5,6315,'Blanco Sona XL 6 S Puradur II Silgranit Inset Kitchen Sink'),(16612,85,0,6315,'Blanco Sona XL 6 S Puradur II Silgranit Inset Kitchen Sink'),(16613,75,5,6315,'<p><strong><span style=\"font-size: medium;\">Blanco Sona XL 6 S Puradur II Inset Silgranit Kitchen Sink</span></strong></p>\n<p>Blanco with its more than 90 years&rsquo; experience of manufacturing <a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> silgranit kitchen sink</span></a> has now introduced the Blanco Sona XL 6 S into the world of kitchen sinks. This inset kitchen sink will grab your attention at first glance with its acid resistant and food-safe surface. Blanco Sona XL 6 S with its spaciously large single bowl and large draining area, yet compact design provides an adequate work space even in small as well as medium sized kitchen areas. You can also drill a tap ledge hole to fix a matching mixer tap into this inset kitchen sink. This inset kitchen sinkis available in nine eye-catching colours form white to alu metallic. Blanco Sona XL 6 S includes a waste fitting with a space-saving pipe and a 3 1&sol;2&quot; basket strainer waste for the main bowl. This silgranit kitchen sink requires 60cm cabinet width to fit in neatly. The depth of the main bowl is 190mm and this sink can be positioned reversibly either right-handed or left-handed.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Can be installed reversibly</li>\n<li>Modern, independent design</li>\n<li>Handing options: Reversible</li>\n<li>Generous, strikingly-profiled tap ledge</li>\n<li>Particularly spacious XL bowl for even more room when washing dishes</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n\n</ul>\n'),(16614,75,0,6315,'<p><strong><span style=\"font-size: medium;\">Blanco Sona XL 6 S Puradur II Inset Silgranit Kitchen Sink</span></strong></p>\n<p>Blanco with its more than 90 years&rsquo; experience of manufacturing <a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> silgranit kitchen sink</span></a> has now introduced the Blanco Sona XL 6 S into the world of kitchen sinks. This inset kitchen sink will grab your attention at first glance with its acid resistant and food-safe surface. Blanco Sona XL 6 S with its spaciously large single bowl and large draining area, yet compact design provides an adequate work space even in small as well as medium sized kitchen areas. You can also drill a tap ledge hole to fix a matching mixer tap into this inset kitchen sink. This inset kitchen sinkis available in nine eye-catching colours form white to alu metallic. Blanco Sona XL 6 S includes a waste fitting with a space-saving pipe and a 3 1&sol;2&quot; basket strainer waste for the main bowl. This silgranit kitchen sink requires 60cm cabinet width to fit in neatly. The depth of the main bowl is 190mm and this sink can be positioned reversibly either right-handed or left-handed.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Can be installed reversibly</li>\n<li>Modern, independent design</li>\n<li>Handing options: Reversible</li>\n<li>Generous, strikingly-profiled tap ledge</li>\n<li>Particularly spacious XL bowl for even more room when washing dishes</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n\n</ul>\n'),(16615,155,0,6315,'Exclude'),(16616,85,5,6316,'Blanco SUBLINE 160-U Silgranit PuraDur II® Undermount Sink'),(16617,85,0,6316,'Blanco SUBLINE 160-U Silgranit PuraDur II® Undermount Sink'),(16618,75,5,6316,'<p><span style=\"font-size: medium;\"><strong>Blanco SUBLINE 160-U Silgranit PuraDur II Undermount Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\n<li>Bowl depth: 130mm</li>\n<li>Cabinet width: 300mm</li>\n<li>Material: Granite</li>\n<li>Style: Half Bowl Sink</li>\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow</li>\n<li>Entire system for a wide variety of plans featuring large and small bowls</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\r\n\r\n'),(16619,75,0,6316,'<p><span style=\"font-size: medium;\"><strong>Blanco SUBLINE 160-U Silgranit PuraDur II Undermount Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\n<li>Bowl depth: 130mm</li>\n<li>Cabinet width: 300mm</li>\n<li>Material: Granite</li>\n<li>Style: Half Bowl Sink</li>\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow</li>\n<li>Entire system for a wide variety of plans featuring large and small bowls</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\r\n\r\n'),(16620,155,0,6316,'Exclude'),(16621,85,5,6317,'Blanco Subline 320-U Silgranit PuraDur II® Undermount Sink'),(16622,85,0,6317,'Blanco Subline 320-U Silgranit PuraDur II® Undermount Sink'),(16623,75,5,6317,'<p><span style=\"font-size: medium;\"><strong>Blanco Subline 320-U Silgranit PuraDur II Undermount Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 400mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow</li>\n<li>Entire system for a wide variety of plans featuring large and small bowls</li>\r\n<li>Maximum bowl size provided by the very best in production and mounting technology</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\r\n</ul>\r\n'),(16624,75,0,6317,'<p><span style=\"font-size: medium;\"><strong>Blanco Subline 320-U Silgranit PuraDur II Undermount Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 400mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow</li>\n<li>Entire system for a wide variety of plans featuring large and small bowls</li>\r\n<li>Maximum bowl size provided by the very best in production and mounting technology</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\r\n</ul>\r\n'),(16625,155,0,6317,'Exclude'),(16626,85,5,6318,'Blanco ceramic Sink, Blanco Silgranit Sink, Blanco classic Sink, buy Blanco  Silgranit Sink, Blanco Sink, Blanco Subline 340 160'),(16627,85,0,6318,'Blanco ceramic Sink, Blanco Silgranit Sink, Blanco classic Sink, buy Blanco  Silgranit Sink, Blanco Sink, Blanco Subline 340 160'),(16628,75,5,6318,'<style>#html-body [data-pb-style=MU8FTHX]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"MU8FTHX\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Subline 340/160-U Undermount Silgranit Kitchen Sink</strong></span></p>\r\n<p>Blanco being a renowned expert in producing the <a title=\"Blanco Granite Composite Sinks\" href=\"/brands/blanco/blanco-sinks/blanco-silgranit-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\">silgranit kitchen sinks</span></a> now brings forth the Blanco Subline 340/160-U. It is an Undermount sink from the Subline family of Blanco silgranit kitchen sinks. Blanco Subline 340/160-U comes in two sink bowls i.e. the main sink bowl and a half sink bowl. Blanco Subline 340 160-U with its two bowls provides sufficient work space in the kitchen. This undermount sink is available in nine different eye-catching colours. This SilGranit PuraDur sink contains a 3 ½” basket strainer and also includes a fixing kit 218269. It also has a waste fitting with a space-saving pipe. This <a title=\"Undermount Kitchen Sinks\" href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\">undermount sink</span></a> has 60 cm cabinet width and has 525x400xR10 cut out size. The depth of the main bowl is 190mm and the half bowl has depth of 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Small bowl depth: 130mm</li>\r\n<li>Large bowl depth: 190mm</li>\r\n<li>Style: One &amp; Half Bowl Sink</li>\r\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: The covered C-overflow and InFino strainer system</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>Two 3 1/2\" basket strainer</li>\r\n</ul></div></div></div>'),(16629,75,0,6318,'<style>#html-body [data-pb-style=MU8FTHX]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"MU8FTHX\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Subline 340/160-U Undermount Silgranit Kitchen Sink</strong></span></p>\r\n<p>Blanco being a renowned expert in producing the <a title=\"Blanco Granite Composite Sinks\" href=\"/brands/blanco/blanco-sinks/blanco-silgranit-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\">silgranit kitchen sinks</span></a> now brings forth the Blanco Subline 340/160-U. It is an Undermount sink from the Subline family of Blanco silgranit kitchen sinks. Blanco Subline 340/160-U comes in two sink bowls i.e. the main sink bowl and a half sink bowl. Blanco Subline 340 160-U with its two bowls provides sufficient work space in the kitchen. This undermount sink is available in nine different eye-catching colours. This SilGranit PuraDur sink contains a 3 ½” basket strainer and also includes a fixing kit 218269. It also has a waste fitting with a space-saving pipe. This <a title=\"Undermount Kitchen Sinks\" href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\">undermount sink</span></a> has 60 cm cabinet width and has 525x400xR10 cut out size. The depth of the main bowl is 190mm and the half bowl has depth of 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet width: 600mm</li>\r\n<li>Small bowl depth: 130mm</li>\r\n<li>Large bowl depth: 190mm</li>\r\n<li>Style: One &amp; Half Bowl Sink</li>\r\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: The covered C-overflow and InFino strainer system</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>Two 3 1/2\" basket strainer</li>\r\n</ul></div></div></div>'),(16630,155,0,6318,'Exclude'),(16631,85,5,6319,'Blanco Subline 350/350-U Silgranit Sink, Blanco Sink, Blanco ceramic Sink, Blanco classic Sink'),(16632,85,0,6319,'Blanco Subline 350/350-U Silgranit Sink, Blanco Sink, Blanco ceramic Sink, Blanco classic Sink'),(16633,75,5,6319,'<p><span style=\"font-size: medium;\"><strong>Blanco Subline 350/350-U Undermount Silgranit Kitchen Sink</strong></span></p>\r\n<p> Blanco Subline 350/350-U belongs to the Subline <a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> silgranit kitchen sinks</span></a> range by Blanco. Blanco Subline 350/350-U is an undermount sink with twin equal sized bowl. This u ndermount sink with its two bowls provides sufficient work space in the kitchen. This SilGranit PuraDur sink is available in nine different eye-catching colours. Blanco Subline 350/350-U contains two 3 &frac12;&rdquo; basket strainers for both bowls with pop-up waste and also includes a fixing kit 218269. It also has a waste fitting with a space-saving pipe. This <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html?material=1749\" target=\"_blank\"><span style=\"text-decoration: underline;\"> SilGranit PuraDur sink</span></a> has 80 cm cabinet width with 725x400xR10 cut out size and the depth of both bowls is 200mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\n<li>Bowl(s) depth: 200mm</li>\n<li>Cabinet width: 800mm</li>\n<li>Material: Granite</li>\n<li>Style: Double Bowl Sink</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>Two 3 1&sol;2&quot; basket strainers</li>\r\n</ul>\r\n'),(16634,75,0,6319,'<p><span style=\"font-size: medium;\"><strong>Blanco Subline 350/350-U Undermount Silgranit Kitchen Sink</strong></span></p>\r\n<p> Blanco Subline 350/350-U belongs to the Subline <a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> silgranit kitchen sinks</span></a> range by Blanco. Blanco Subline 350/350-U is an undermount sink with twin equal sized bowl. This u ndermount sink with its two bowls provides sufficient work space in the kitchen. This SilGranit PuraDur sink is available in nine different eye-catching colours. Blanco Subline 350/350-U contains two 3 &frac12;&rdquo; basket strainers for both bowls with pop-up waste and also includes a fixing kit 218269. It also has a waste fitting with a space-saving pipe. This <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html?material=1749\" target=\"_blank\"><span style=\"text-decoration: underline;\"> SilGranit PuraDur sink</span></a> has 80 cm cabinet width with 725x400xR10 cut out size and the depth of both bowls is 200mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\n<li>Bowl(s) depth: 200mm</li>\n<li>Cabinet width: 800mm</li>\n<li>Material: Granite</li>\n<li>Style: Double Bowl Sink</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>Two 3 1&sol;2&quot; basket strainers</li>\r\n</ul>\r\n'),(16635,155,0,6319,'Exclude'),(16636,85,5,6320,'Blanco Subline 400-U PuraDur&reg; Silgranit Undermount Sink'),(16637,85,0,6320,'Blanco Subline 400-U PuraDur&reg; Silgranit Undermount Sink'),(16638,75,5,6320,'<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet width: 500mm</li>\r\n<li>Bowl depth: 190mm</li>\r\n<li>Style: Single Bowl Sink</li>\r\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow&reg;</li>\r\n<li>Entire system for a wide variety of plans featuring large and small bowls</li>\r\n<li>Maximum bowl size provided by the very best in production and mounting technology</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n</ul>\r\n\r\n\r\n'),(16639,75,0,6320,'<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet width: 500mm</li>\r\n<li>Bowl depth: 190mm</li>\r\n<li>Style: Single Bowl Sink</li>\r\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow&reg;</li>\r\n<li>Entire system for a wide variety of plans featuring large and small bowls</li>\r\n<li>Maximum bowl size provided by the very best in production and mounting technology</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n</ul>\r\n\r\n\r\n'),(16640,155,0,6320,'Exclude'),(16641,85,5,6321,'Blanco Subline 430/270-U Silgranit PuraDur® Undermount Sink'),(16642,85,0,6321,'Blanco Subline 430/270-U Silgranit PuraDur® Undermount Sink'),(16643,75,5,6321,'<p><span style=\"font-size: medium;\"><strong>Blanco Subline 430/270-U Silgranit PuraDur Undermount Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\n<li>Bowl(s) depth: 200mm</li>\n<li>Cabinet width: 800mm</li>\n<li>Material: Granite</li>\n<li>Style: Double Bowl Sink</li>\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow and InFino strainer system</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\r\n<li>Two 3 1&sol;2&quot; basket strainers</li>\r\n</ul>\r\n'),(16644,75,0,6321,'<p><span style=\"font-size: medium;\"><strong>Blanco Subline 430/270-U Silgranit PuraDur Undermount Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\n<li>Bowl(s) depth: 200mm</li>\n<li>Cabinet width: 800mm</li>\n<li>Material: Granite</li>\n<li>Style: Double Bowl Sink</li>\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow and InFino strainer system</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\r\n<li>Two 3 1&sol;2&quot; basket strainers</li>\r\n</ul>\r\n'),(16645,155,0,6321,'Exclude'),(16646,85,5,6322,'Subline 480/320-U Silgranit Sink, Ceramic Sink, Blanco Sink, Best Silgranit Sink, Blanco Subline 480/320-U Silgranit Sink'),(16647,85,0,6322,'Subline 480/320-U Silgranit Sink, Ceramic Sink, Blanco Sink, Best Silgranit Sink, Blanco Subline 480/320-U Silgranit Sink'),(16648,75,5,6322,'<style>#html-body [data-pb-style=RROBIQ9]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"RROBIQ9\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Subline 480/320-U Undermount Silgranit Kitchen Sink </strong></span></p>\r\n<p>Introducing the Blanco Subline 480/320-U Undermount <strong><a title=\"Blanco Silgranit Sinks - Blanco Granite Sinks\" href=\"/brands/blanco/blanco-silgranit-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\">Silgranit kitchen sinks</span></a></strong>, the epitome of elegance and functionality. Crafted from durable granite material, this double bowl sink enhances your kitchen with its timeless design and 200mm bowl depth. With a cabinet width requirement of 900mm, it offers ample space for your culinary needs.</p>\r\n<p>Experience hygiene at its finest with the covered C‐overflow and InFino strainer system, ensuring a clean and elegant look. The undermount bowl design caters to discerning design demands, while the 2‐in-1 setup simplifies installation with one cut‐out panel and mounting procedure. This high‐quality sink is perfect for various kitchen plans, delivering convenience and style in one package.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\r\n<li>Bowl(s) depth: 200mm</li>\r\n<li>Cabinet width: 900mm</li>\r\n<li>Material: Granite</li>\r\n<li>Style: Double Bowl Sink</li>\r\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow and InFino strainer system</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>Two 3 1/2\" basket strainers</li>\r\n</ul></div></div></div>'),(16649,75,0,6322,'<style>#html-body [data-pb-style=RROBIQ9]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"RROBIQ9\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Subline 480/320-U Undermount Silgranit Kitchen Sink </strong></span></p>\r\n<p>Introducing the Blanco Subline 480/320-U Undermount <strong><a title=\"Blanco Silgranit Sinks - Blanco Granite Sinks\" href=\"/brands/blanco/blanco-silgranit-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\">Silgranit kitchen sinks</span></a></strong>, the epitome of elegance and functionality. Crafted from durable granite material, this double bowl sink enhances your kitchen with its timeless design and 200mm bowl depth. With a cabinet width requirement of 900mm, it offers ample space for your culinary needs.</p>\r\n<p>Experience hygiene at its finest with the covered C‐overflow and InFino strainer system, ensuring a clean and elegant look. The undermount bowl design caters to discerning design demands, while the 2‐in-1 setup simplifies installation with one cut‐out panel and mounting procedure. This high‐quality sink is perfect for various kitchen plans, delivering convenience and style in one package.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation : Undermount</li>\r\n<li>Bowl(s) depth: 200mm</li>\r\n<li>Cabinet width: 900mm</li>\r\n<li>Material: Granite</li>\r\n<li>Style: Double Bowl Sink</li>\r\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow and InFino strainer system</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>Two 3 1/2\" basket strainers</li>\r\n</ul></div></div></div>'),(16650,155,0,6322,'Exclude'),(16651,85,5,6323,'Blanco Subline 500-IF Steel Frame PuraDur II Undermount Silgranit Kitchen Sink'),(16652,85,0,6323,'Blanco Subline 500-IF Steel Frame PuraDur II Undermount Silgranit Kitchen Sink'),(16653,75,5,6323,'<p><span style=\"font-size: medium;\"><strong>Blanco Subline 500-IF Steel Frame PuraDur II Inset / Flushmount Silgranit Kitchen Sink </strong></span></p>\r\n<p>Blanco well-known for its long-time expertise in manufacturing <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html?material=1749\" target=\"_blank\"><span style=\"text-decoration: underline;\"> silgranit kitchen sinks</span></a> now brings to you the Blanco Subline 500-IF Steel Frame, <strong>Inset / Flushmount</strong> sink. Blanco Subline 500-IF is a large sized sink which can be installed into the kitchen as a main sink bowl. Moreover with the Steel Frame this <strong>Inset / Flushmount</strong> sink will also make a great impression in your kitchen. Blanco Subline 500-IF is available in two eye-catching colours i.e. white and anthracite. This <a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> SilGranit PuraDur sink</span></a> contains a 3 &frac12;&rdquo; basket strainer and also includes a waste fitting with a space-saving pipe. This <strong>Inset / Flushmount</strong> sink has 60 cm cabinet width along with 532x499xR10 cut out size and the depth of the main bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n\r<li>Installation: Undermount</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Elegant and hygienic: The covered C-overflow&reg;</li>\n<li>Timelessly elegant, straight-lined bowl shape with filigree IF flat rim</li>\n<li>Innovative and unique material mix of stainless steel and SILGRANIT&reg;</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n</ul>\r\n'),(16654,75,0,6323,'<p><span style=\"font-size: medium;\"><strong>Blanco Subline 500-IF Steel Frame PuraDur II Inset / Flushmount Silgranit Kitchen Sink </strong></span></p>\r\n<p>Blanco well-known for its long-time expertise in manufacturing <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html?material=1749\" target=\"_blank\"><span style=\"text-decoration: underline;\"> silgranit kitchen sinks</span></a> now brings to you the Blanco Subline 500-IF Steel Frame, <strong>Inset / Flushmount</strong> sink. Blanco Subline 500-IF is a large sized sink which can be installed into the kitchen as a main sink bowl. Moreover with the Steel Frame this <strong>Inset / Flushmount</strong> sink will also make a great impression in your kitchen. Blanco Subline 500-IF is available in two eye-catching colours i.e. white and anthracite. This <a href=\"/brands/blanco.html\" target=\"_blank\"><span style=\"text-decoration: underline;\"> SilGranit PuraDur sink</span></a> contains a 3 &frac12;&rdquo; basket strainer and also includes a waste fitting with a space-saving pipe. This <strong>Inset / Flushmount</strong> sink has 60 cm cabinet width along with 532x499xR10 cut out size and the depth of the main bowl is 190mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n\r<li>Installation: Undermount</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Elegant and hygienic: The covered C-overflow&reg;</li>\n<li>Timelessly elegant, straight-lined bowl shape with filigree IF flat rim</li>\n<li>Innovative and unique material mix of stainless steel and SILGRANIT&reg;</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1&sol;2&quot; basket strainer</li>\r\n</ul>\r\n'),(16655,155,0,6323,'Exclude'),(16656,85,5,6324,'Blanco SUBLINE 500-U Silgranit PuraDur II® Undermount Sink'),(16657,85,0,6324,'Blanco SUBLINE 500-U Silgranit PuraDur II® Undermount Sink'),(16658,75,5,6324,'<p><span style=\"font-size: medium;\"><h2>Blanco SUBLINE 500-U Silgranit PuraDur II Undermount Sink</h2></span></p>\r\n\r<p><span style=\"font-size: medium;\"><h3>Features</h3></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Elegant and hygienic: The covered C-overflow&reg;</li>\n<li>Timelessly elegant, contoured bowl design</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(16659,75,0,6324,'<p><span style=\"font-size: medium;\"><h2>Blanco SUBLINE 500-U Silgranit PuraDur II Undermount Sink</h2></span></p>\r\n\r<p><span style=\"font-size: medium;\"><h3>Features</h3></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Elegant and hygienic: The covered C-overflow&reg;</li>\n<li>Timelessly elegant, contoured bowl design</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n'),(16660,155,0,6324,'Exclude'),(16661,85,5,6325,'Blanco BL 518 393 Sink, Blanco Sink, Blanco  Sink sale, Cheap Blanco Sinks, Best Silgranit Sinks'),(16662,85,0,6325,'Blanco BL 518 393 Sink, Blanco Sink, Blanco  Sink sale, Cheap Blanco Sinks, Best Silgranit Sinks'),(16663,75,5,6325,'<style>#html-body [data-pb-style=YJ1SJGB]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"YJ1SJGB\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><strong>Blanco Subline 700-U Level Silgranit Undermount Sink</strong></p>\r\n<p>Upgrade your kitchen with the exquisite Blanco Subline 700-U Level <strong><a title=\"Blanco Silgranit Kitchen Sinks\" href=\"/brands/blanco/blanco-silgranit-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\">Silgranit kitchen sinks</span></a></strong>. Designed to meet discerning demands on design, this single bowl undermount sink boasts a timelessly elegant, contoured bowl design. The entire system offers versatility with both large and small bowls, catering to various kitchen plans. Enjoy high-quality features, including the covered C-overflow and InFino drain system, which are elegantly integrated and easy to maintain. Discover the beauty and functionality of Silgranit kitchen sinks today.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Bowl depth: 190mm</li>\r\n<li>Style: Single Bowl Sink</li>\r\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow and InFino strainer system</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1/2\" basket strainer</li>\r\n</ul></div></div></div>'),(16664,75,0,6325,'<style>#html-body [data-pb-style=YJ1SJGB]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"YJ1SJGB\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><strong>Blanco Subline 700-U Level Silgranit Undermount Sink</strong></p>\r\n<p>Upgrade your kitchen with the exquisite Blanco Subline 700-U Level <strong><a title=\"Blanco Silgranit Kitchen Sinks\" href=\"/brands/blanco/blanco-silgranit-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\">Silgranit kitchen sinks</span></a></strong>. Designed to meet discerning demands on design, this single bowl undermount sink boasts a timelessly elegant, contoured bowl design. The entire system offers versatility with both large and small bowls, catering to various kitchen plans. Enjoy high-quality features, including the covered C-overflow and InFino drain system, which are elegantly integrated and easy to maintain. Discover the beauty and functionality of Silgranit kitchen sinks today.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Bowl depth: 190mm</li>\r\n<li>Style: Single Bowl Sink</li>\r\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow and InFino strainer system</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1/2\" basket strainer</li>\r\n</ul></div></div></div>'),(16665,155,0,6325,'Exclude'),(16666,85,5,6326,'Blanco Subline 700-U PuraDur II Undermount Silgranit Kitchen Sink'),(16667,85,0,6326,'Blanco Subline 700-U PuraDur II Undermount Silgranit Kitchen Sink'),(16668,75,5,6326,'<style>#html-body [data-pb-style=YBRT31Q]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"YBRT31Q\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Subline 700-U PuraDur II Undermount Silgranit Kitchen Sink</strong></span></p>\r\n<p>Blanco being a celebrated professional in producing the <a href=\"/brands/blanco/blanco-silgranit-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\"> silgranit kitchen sinks</span></a> now brings forth the Blanco Subline 700-U, an undermount sink. Blanco Subline 700-U is a large sized sink which can be installed into the kitchen as a main sink bowl. Furthermore it will also make a great impression with its exclusive design. Blanco Subline 700-U is available in nine different eye-catching colours. This SilGranit PuraDur sink contains a 3 ½” basket strainer and also includes a fixing kit 218269. It also has a waste fitting with a space-saving pipe. This undermount sink has 80 cm cabinet width along with 700x400xR10 cut out size and the depth of the main bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Bowl depth: 190mm</li>\r\n<li>Style: Single Bowl Sink</li>\r\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow and InFino strainer system</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1/2\" basket strainer</li>\r\n</ul></div></div></div>'),(16669,75,0,6326,'<style>#html-body [data-pb-style=YBRT31Q]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"YBRT31Q\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Subline 700-U PuraDur II Undermount Silgranit Kitchen Sink</strong></span></p>\r\n<p>Blanco being a celebrated professional in producing the <a href=\"/brands/blanco/blanco-silgranit-sinks.html\" target=\"_blank\" rel=\"noopener\"><span style=\"text-decoration: underline;\"> silgranit kitchen sinks</span></a> now brings forth the Blanco Subline 700-U, an undermount sink. Blanco Subline 700-U is a large sized sink which can be installed into the kitchen as a main sink bowl. Furthermore it will also make a great impression with its exclusive design. Blanco Subline 700-U is available in nine different eye-catching colours. This SilGranit PuraDur sink contains a 3 ½” basket strainer and also includes a fixing kit 218269. It also has a waste fitting with a space-saving pipe. This undermount sink has 80 cm cabinet width along with 700x400xR10 cut out size and the depth of the main bowl is 190mm with 10mm corner radius.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet width: 800mm</li>\r\n<li>Bowl depth: 190mm</li>\r\n<li>Style: Single Bowl Sink</li>\r\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow and InFino strainer system</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1/2\" basket strainer</li>\r\n</ul></div></div></div>'),(16670,155,0,6326,'Exclude'),(16671,85,5,6327,'Blanco Subline 800-U PuraDur&reg; Silgranit Undermount Sink'),(16672,85,0,6327,'Blanco Subline 800-U PuraDur&reg; Silgranit Undermount Sink'),(16673,75,5,6327,'<style>#html-body [data-pb-style=JERXG2P]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"JERXG2P\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Subline 800-U PuraDur® Silgranit Undermount Sink</strong></span></p>\r\n<p id=\"AR09B9P\" style=\"text-align: justify;\">Blanco Subline 800-U features an undermount design, seamlessly integrating into your countertop for a clean and contemporary look in your kitchen. With its spacious basin and modern aesthetics, Blanco Subline 800 U stands out as a top-mount sink that combines functionality with elegant design. Whether you prefer the sleek undermount style of Blanco Subline 800-U or the versatile top-mount installation of Blanco Subline 800 U, both options offer exceptional quality and practicality for your kitchen space.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet width: 900mm</li>\r\n<li>Bowl depth: 220mm</li>\r\n<li>Style: Single Bowl Sink</li>\r\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow and InFino strainer system</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1/2\" basket strainer</li>\r\n</ul></div></div></div>'),(16674,75,0,6327,'<style>#html-body [data-pb-style=JERXG2P]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"JERXG2P\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Subline 800-U PuraDur® Silgranit Undermount Sink</strong></span></p>\r\n<p id=\"AR09B9P\" style=\"text-align: justify;\">Blanco Subline 800-U features an undermount design, seamlessly integrating into your countertop for a clean and contemporary look in your kitchen. With its spacious basin and modern aesthetics, Blanco Subline 800 U stands out as a top-mount sink that combines functionality with elegant design. Whether you prefer the sleek undermount style of Blanco Subline 800-U or the versatile top-mount installation of Blanco Subline 800 U, both options offer exceptional quality and practicality for your kitchen space.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\r\n<li>Material: Granite</li>\r\n<li>Cabinet width: 900mm</li>\r\n<li>Bowl depth: 220mm</li>\r\n<li>Style: Single Bowl Sink</li>\r\n<li>Timelessly elegant, contoured bowl design</li>\r\n<li>Elegant and hygienic: the covered C-overflow and InFino strainer system</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\r\n<ul>\r\n<li>Waste fitting with space-saving pipe</li>\r\n<li>3 1/2\" basket strainer</li>\r\n</ul></div></div></div>'),(16675,155,0,6327,'Exclude'),(16676,85,5,6328,'Reginox Elite Texas L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(16677,85,0,6328,'Reginox Elite Texas L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(16678,75,5,6328,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Texas L Integrated 0.5 Bowl Kitchen Sink 18X40cm</strong></span></p>\r\n<p style=\"text-align: justify;\">The <strong>kitchen sink</strong> is the most needed thing in any kitchen regardless the size of the kitchen. Reginox understands your requirements and so it has designed Reginox <strong>Elite Texas kitchen sink</strong> that will give a perfect fit to small kitchens as well as can be used as an additional sink in comparatively large kitchens. It requires a cabinet of 400mm size to fit seamlessly. It has designed in a way to keep the hygiene level high. It has an outlet of 3,5&rdquo; and a depth of 145mm. Though the size of this sink is small but it gives an exceptional use. Get it from Banyo because it is giving an exciting discount offer on this incredible sink. A guarantee of 10 years is provided by Reginox for your peace of mind. Matt inox finish and square adapter waste disposal are incredible features of this <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>sink.</strong></span></a> Square basket strainer is also included in its price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Texas L Integrated 0.5 Bowl Kitchen Sink 18X40cm</li>\r\n<li>Cabinet Size: 400mm</li>\r\n<li>Sink Unit Dimensions: 183 x 403 mm</li>\r\n<li>Total Dimensions: 220 x 440mm</li>\r\n<li>Depth: 145 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Texas</li>\r\n<li>10 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Square basket strainer</li>\r\n<li>Easy to clean, hygienic design</li>\r\n<li>Now available: square adapter waste disposal</li>\r\n<li>Material finish: matt inox</li>\r\n</ul>\r'),(16679,75,0,6328,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Texas L Integrated 0.5 Bowl Kitchen Sink 18X40cm</strong></span></p>\r\n<p style=\"text-align: justify;\">The <strong>kitchen sink</strong> is the most needed thing in any kitchen regardless the size of the kitchen. Reginox understands your requirements and so it has designed Reginox <strong>Elite Texas kitchen sink</strong> that will give a perfect fit to small kitchens as well as can be used as an additional sink in comparatively large kitchens. It requires a cabinet of 400mm size to fit seamlessly. It has designed in a way to keep the hygiene level high. It has an outlet of 3,5&rdquo; and a depth of 145mm. Though the size of this sink is small but it gives an exceptional use. Get it from Banyo because it is giving an exciting discount offer on this incredible sink. A guarantee of 10 years is provided by Reginox for your peace of mind. Matt inox finish and square adapter waste disposal are incredible features of this <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>sink.</strong></span></a> Square basket strainer is also included in its price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Texas L Integrated 0.5 Bowl Kitchen Sink 18X40cm</li>\r\n<li>Cabinet Size: 400mm</li>\r\n<li>Sink Unit Dimensions: 183 x 403 mm</li>\r\n<li>Total Dimensions: 220 x 440mm</li>\r\n<li>Depth: 145 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Texas</li>\r\n<li>10 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Square basket strainer</li>\r\n<li>Easy to clean, hygienic design</li>\r\n<li>Now available: square adapter waste disposal</li>\r\n<li>Material finish: matt inox</li>\r\n</ul>\r'),(16680,155,0,6328,'Exclude'),(16681,85,5,6329,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 30X40cm'),(16682,85,0,6329,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 30X40cm'),(16683,75,5,6329,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 30X40cm</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Elite Texas kitchen sink</strong> is an incredible product for those who want to have something unique in their kitchen. It is very important to consider both factors while choosing a sink, its functionality as well as its designing. A sink can give an excellent functionality if it has made of high-quality material because material is considered as the backbone of any product. Reginox Elite kitchen sink is made from high-quality material that will prove wonderful for active families as it keeps your kitchen bacteria free. It is vital to maintain the standard hygiene level in your kitchen and so this <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>sink</strong></span></a> is best from this perspective. It can be cleaned within no time by simply wiping the surface. Banyo is the right place from where you can get this incredible product at discounted price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 30X40cm</li>\r\n<li>Cabinet Size: 400mm</li>\r\n<li>Sink Unit Dimensions: 303 x 403 mm</li>\r\n<li>Total Dimensions: 340 x 440mm</li>\r\n<li>Depth: 180 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Texas</li>\r\n<li>10 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Square basket strainer</li>\r\n<li>Easy to clean, hygienic design</li>\r\n<li>Now available: square adapter waste disposal</li>\r\n<li>Material finish: matt inox</li>\r\n</ul>\r'),(16684,75,0,6329,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 30X40cm</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Elite Texas kitchen sink</strong> is an incredible product for those who want to have something unique in their kitchen. It is very important to consider both factors while choosing a sink, its functionality as well as its designing. A sink can give an excellent functionality if it has made of high-quality material because material is considered as the backbone of any product. Reginox Elite kitchen sink is made from high-quality material that will prove wonderful for active families as it keeps your kitchen bacteria free. It is vital to maintain the standard hygiene level in your kitchen and so this <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>sink</strong></span></a> is best from this perspective. It can be cleaned within no time by simply wiping the surface. Banyo is the right place from where you can get this incredible product at discounted price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 30X40cm</li>\r\n<li>Cabinet Size: 400mm</li>\r\n<li>Sink Unit Dimensions: 303 x 403 mm</li>\r\n<li>Total Dimensions: 340 x 440mm</li>\r\n<li>Depth: 180 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Texas</li>\r\n<li>10 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Square basket strainer</li>\r\n<li>Easy to clean, hygienic design</li>\r\n<li>Now available: square adapter waste disposal</li>\r\n<li>Material finish: matt inox</li>\r\n</ul>\r'),(16685,155,0,6329,'Exclude'),(16686,85,5,6330,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(16687,85,0,6330,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(16688,75,5,6330,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 40X40cm</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Elite Texas</strong> kitchen sink has a shiny and eye-catching look. It has constructed very carefully that the edges of this sink are quite seamless. It will surely render flawless functionality as it has crafted from superior-quality material. You will never worry about the maintenance of this kitchen sink as stains or scratches cannot stay on them for a longer time and can be wiped away with only one wash.It will be a go-to sink for professional chefs as it has an absolutely pore-free surface where a passive protective layer continuously renews itself for keeping it hygienic. Square adapter waste disposal and matt inox finish are incredible features of this sink. More on, there is a square basket strainer that adds value to this <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>sink</strong>.</span></a></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 40X40cm</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink Unit Dimensions: 403 x 403 mm</li>\r\n<li>Total Dimensions: 440 x 440mm</li>\r\n<li>Depth: 180 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Texas</li>\r\n<li>10 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Square basket strainer</li>\r\n<li>Easy to clean, hygienic design</li>\r\n<li>Now available: square adapter waste disposal</li>\r\n<li>Material finish: matt inox</li>\r\n</ul>\r'),(16689,75,0,6330,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 40X40cm</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Reginox Elite Texas</strong> kitchen sink has a shiny and eye-catching look. It has constructed very carefully that the edges of this sink are quite seamless. It will surely render flawless functionality as it has crafted from superior-quality material. You will never worry about the maintenance of this kitchen sink as stains or scratches cannot stay on them for a longer time and can be wiped away with only one wash.It will be a go-to sink for professional chefs as it has an absolutely pore-free surface where a passive protective layer continuously renews itself for keeping it hygienic. Square adapter waste disposal and matt inox finish are incredible features of this sink. More on, there is a square basket strainer that adds value to this <a href=\"/kitchen-appliances/kitchen-sinks.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>sink</strong>.</span></a></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 40X40cm</li>\r\n<li>Cabinet Size: 450mm</li>\r\n<li>Sink Unit Dimensions: 403 x 403 mm</li>\r\n<li>Total Dimensions: 440 x 440mm</li>\r\n<li>Depth: 180 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Texas</li>\r\n<li>10 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Square basket strainer</li>\r\n<li>Easy to clean, hygienic design</li>\r\n<li>Now available: square adapter waste disposal</li>\r\n<li>Material finish: matt inox</li>\r\n</ul>\r'),(16690,155,0,6330,'Exclude'),(16691,85,5,6331,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(16692,85,0,6331,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(16693,75,5,6331,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 50X40cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 50X40cm</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink Unit Dimensions: 503 x 403 mm</li>\r\n<li>Total Dimensions: 540 x 440mm</li>\r\n<li>Depth: 200 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Texas</li>\r\n<li>10 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Square basket strainer</li>\r\n<li>Easy to clean, hygienic design</li>\r\n<li>Now available: square adapter waste disposal</li>\r\n<li>Material finish: matt inox</li>\r\n</ul>\r'),(16694,75,0,6331,'<p><span style=\"font-size: medium;\"><strong>Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 50X40cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 50X40cm</li>\r\n<li>Cabinet Size: 600mm</li>\r\n<li>Sink Unit Dimensions: 503 x 403 mm</li>\r\n<li>Total Dimensions: 540 x 440mm</li>\r\n<li>Depth: 200 mm</li>\r\n<li>Installation Method : Integrated</li>\r\n<li>Outlet : 3,5\" outlet</li>\r\n<li>Type: Square sinks</li>\r\n<li>Packaging : Box</li>\r\n<li>Range: Elite</li>\r\n<li>Series: Texas</li>\r\n<li>10 mm radius</li>\r\n<li>Design overflow</li>\r\n<li>Square basket strainer</li>\r\n<li>Easy to clean, hygienic design</li>\r\n<li>Now available: square adapter waste disposal</li>\r\n<li>Material finish: matt inox</li>\r\n</ul>\r'),(16695,155,0,6331,'Exclude'),(16696,85,5,6332,'Franke VBK 110-21 Undermount 0.5 Bowl Kitchen Sink Ceramic White'),(16697,85,0,6332,'Franke VBK 110-21 Undermount 0.5 Bowl Kitchen Sink Ceramic White'),(16698,75,5,6332,'<p><span style=\"font-size: medium;\"><strong>Franke VBK 110-21 Undermount 0.5 Bowl Kitchen Sink Ceramic White</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Half bowl sink</li>             \n<li>Cabinet size: 400mm</li>\n<li>Installation type: Undermount</li>\n<li>Sink: Ceramic</li>\n<li>Colour: White</li>\n</ul>\n'),(16699,75,0,6332,'<p><span style=\"font-size: medium;\"><strong>Franke VBK 110-21 Undermount 0.5 Bowl Kitchen Sink Ceramic White</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Half bowl sink</li>             \n<li>Cabinet size: 400mm</li>\n<li>Installation type: Undermount</li>\n<li>Sink: Ceramic</li>\n<li>Colour: White</li>\n</ul>\n'),(16700,155,0,6332,'Exclude'),(16701,85,5,6333,'Franke VBK 110-33 Undermount 1 Bowl Kitchen Sink Ceramic White'),(16702,85,0,6333,'Franke VBK 110-33 Undermount 1 Bowl Kitchen Sink Ceramic White'),(16703,75,5,6333,'<p><span style=\"font-size: medium;\"><strong>Franke VBK 110-33 Undermount 1 Bowl Kitchen Sink Ceramic White</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single bowl sink</li>                 \n<li>Cabinet size: 500mm</li>\n<li>Installation type: Undermount</li>\n<li>Sink: Ceramic</li>\n<li>Colour: White</li>\n</ul>'),(16704,75,0,6333,'<p><span style=\"font-size: medium;\"><strong>Franke VBK 110-33 Undermount 1 Bowl Kitchen Sink Ceramic White</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single bowl sink</li>                 \n<li>Cabinet size: 500mm</li>\n<li>Installation type: Undermount</li>\n<li>Sink: Ceramic</li>\n<li>Colour: White</li>\n</ul>'),(16705,155,0,6333,'Exclude'),(16706,85,5,6334,'Franke VBK  Kitchen Sink,Franke Sink Best Deals,Franke Sinks, Franke Sink Offers,VBK 110-50 Kitchen Sink,'),(16707,85,0,6334,'Franke VBK  Kitchen Sink,Franke Sink Best Deals,Franke Sinks, Franke Sink Offers,VBK 110-50 Kitchen Sink,'),(16708,75,5,6334,'<p><span style=\"font-size: medium;\"><strong>Franke VBK 110-50 Kitchen Sink Ceramic 1.0 Bowl</strong></span></p>\r\n<p>Franke brought you an ultimate beautiful Franke VBK kitchen sink which has made of ceramic. The appropriate shape, smooth edges, and brilliant colour of this incredible sink deliver all time classic appeal in any kitchen area. The sturdy and strong marvel is graced with a look that will complement both minimalist and luxuriously decorated bathroom settings. You can clean your kitchen in few seconds as it does not require extra effort. It does not allow bacteria to grow in your kitchen so you will find it hygienic as well as durable. </p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul> \r\n<li>Single bowl sink</li>  \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Ceramic</li>\r\n<li>Colour: White</li>\r\n</ul>\r\n'),(16709,75,0,6334,'<p><span style=\"font-size: medium;\"><strong>Franke VBK 110-50 Kitchen Sink Ceramic 1.0 Bowl</strong></span></p>\r\n<p>Franke brought you an ultimate beautiful Franke VBK kitchen sink which has made of ceramic. The appropriate shape, smooth edges, and brilliant colour of this incredible sink deliver all time classic appeal in any kitchen area. The sturdy and strong marvel is graced with a look that will complement both minimalist and luxuriously decorated bathroom settings. You can clean your kitchen in few seconds as it does not require extra effort. It does not allow bacteria to grow in your kitchen so you will find it hygienic as well as durable. </p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul> \r\n<li>Single bowl sink</li>  \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Undermount</li>\r\n<li>Sink: Ceramic</li>\r\n<li>Colour: White</li>\r\n</ul>\r\n'),(16710,155,0,6334,'Exclude'),(16711,85,5,6335,'Franke VBK 160 Undermount 1.5 Bowl Kitchen Sink Ceramic White'),(16712,85,0,6335,'Franke VBK 160 Undermount 1.5 Bowl Kitchen Sink Ceramic White'),(16713,75,5,6335,'<p><span style=\"font-size: medium;\"><strong>Franke VBK 160 Undermount 1.5 Bowl Kitchen Sink Ceramic White</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>  \n<li>One and half bowls sink</li>                \n<li>Cabinet size: 600mm</li>\n<li>Installation type: Undermount</li>\n<li>Position of small bowl: Left hand side</li>\n<li>Sink: Ceramic</li>\n<li>Colour: White</li>\n</ul>'),(16714,75,0,6335,'<p><span style=\"font-size: medium;\"><strong>Franke VBK 160 Undermount 1.5 Bowl Kitchen Sink Ceramic White</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>  \n<li>One and half bowls sink</li>                \n<li>Cabinet size: 600mm</li>\n<li>Installation type: Undermount</li>\n<li>Position of small bowl: Left hand side</li>\n<li>Sink: Ceramic</li>\n<li>Colour: White</li>\n</ul>'),(16715,155,0,6335,'Exclude'),(16716,85,5,6336,'Franke VBK 710  Sink, Belfast 1.0 Bowl Kitchen Sink, Ceramic White Sink, Franke Kitchen Systems,Franke Sinks'),(16717,85,0,6336,'Franke VBK 710  Sink, Belfast 1.0 Bowl Kitchen Sink, Ceramic White Sink, Franke Kitchen Systems,Franke Sinks'),(16718,75,5,6336,'<p><span style=\"font-size: medium;\"><strong>Franke VBK 710 Belfast 1.0 Bowl Kitchen Sink Ceramic White </strong></span></p>\r\n<p>Franke Belfast kitchen sink is offering a breathtaking combination of superior finish and classic design. You will find it truly versatile as it can be either free standing or gives flexibility to either drop-on to a cabinet.  The impervious surface effortlessly resists impact, stain, household chemicals, and heat. The chrome polish waste will offer you a hygienic and functional kitchen area. The external bowl is 200mm deep and the size of the cabinet is 600mm. Banyo is providing this incredible kitchen sink at the highly affordable rate.\r\n</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul> \r\n<li>Single bowl sink</li>      \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Sit on</li>\r\n<li>Sink: Ceramic</li>\r\n<li>Colour: White</li>\r\n</ul>'),(16719,75,0,6336,'<p><span style=\"font-size: medium;\"><strong>Franke VBK 710 Belfast 1.0 Bowl Kitchen Sink Ceramic White </strong></span></p>\r\n<p>Franke Belfast kitchen sink is offering a breathtaking combination of superior finish and classic design. You will find it truly versatile as it can be either free standing or gives flexibility to either drop-on to a cabinet.  The impervious surface effortlessly resists impact, stain, household chemicals, and heat. The chrome polish waste will offer you a hygienic and functional kitchen area. The external bowl is 200mm deep and the size of the cabinet is 600mm. Banyo is providing this incredible kitchen sink at the highly affordable rate.\r\n</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul> \r\n<li>Single bowl sink</li>      \r\n<li>Cabinet size: 600mm</li>\r\n<li>Installation type: Sit on</li>\r\n<li>Sink: Ceramic</li>\r\n<li>Colour: White</li>\r\n</ul>'),(16720,155,0,6336,'Exclude'),(16721,85,5,6337,'Franke VBK 720 Kichen Sink, Belfast 1.0 Bowl Kitchen Sink,ranke Stainless Steel Sinks,Franke Sink Accessories'),(16722,85,0,6337,'Franke VBK 720 Kichen Sink, Belfast 1.0 Bowl Kitchen Sink,ranke Stainless Steel Sinks,Franke Sink Accessories'),(16723,75,5,6337,'<p><span style=\"font-size: medium;\"><strong>Franke VBK 720 Belfast 2.0 Bowl Kitchen Sink Ceramic White - 130.0049.876</strong></span></p>\n<p>Franke, one of the UK&apos;s renowned brands has introduced another feather to its cap with its amazing creation of Franke VBK kitchen sink. It has two bowls and both have same size and depth due to which they are more useful in any routine. When you are going to cook for a large number of people, you will find it useful for cooking preparation. The seamless manufacturing of this kitchen sink makes it easy to clean as well as gives unique look to it. Ceramic makes it highly resistant to heat, impact and shock. More on, it prevents bacterial growth and keeps your kitchen a hygienic place to cook.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Double bowl sinks</li>\n<li>Cabinet size: 800mm</li>\n<li>Installation type: Sit on</li>\n<li>Sink: Ceramic</li>\n<li>Colour: White</li>\n</ul>'),(16724,75,0,6337,'<p><span style=\"font-size: medium;\"><strong>Franke VBK 720 Belfast 2.0 Bowl Kitchen Sink Ceramic White - 130.0049.876</strong></span></p>\n<p>Franke, one of the UK&apos;s renowned brands has introduced another feather to its cap with its amazing creation of Franke VBK kitchen sink. It has two bowls and both have same size and depth due to which they are more useful in any routine. When you are going to cook for a large number of people, you will find it useful for cooking preparation. The seamless manufacturing of this kitchen sink makes it easy to clean as well as gives unique look to it. Ceramic makes it highly resistant to heat, impact and shock. More on, it prevents bacterial growth and keeps your kitchen a hygienic place to cook.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Double bowl sinks</li>\n<li>Cabinet size: 800mm</li>\n<li>Installation type: Sit on</li>\n<li>Sink: Ceramic</li>\n<li>Colour: White</li>\n</ul>'),(16725,155,0,6337,'Exclude'),(16726,75,5,6338,'<p><span style=\"font-size: medium;\"><strong>Blanco Vintera XL 9 PuraDur II Silgranit Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Material: Granite</li>\n<li>Cabinet width: 900mm</li>\n<li>Bowl depth: 220mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Installation : Undermount or flush-mounted</li>\n<li>Extra-large bowl provides plenty of room</li>\n<li>Perfect fit: Right angled apron front fits the width of a 900mm cabinet</li>\n<li>Available finishes: Black, White, Coffee, Tartufo, Rock Grey, Anthracite, Soft White, Volcano Grey</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste kit with space-saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(16727,75,0,6338,'<p><span style=\"font-size: medium;\"><strong>Blanco Vintera XL 9 PuraDur II Silgranit Undermount Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Material: Granite</li>\n<li>Cabinet width: 900mm</li>\n<li>Bowl depth: 220mm</li>\n<li>Style: Single Bowl Sink</li>\n<li>Installation : Undermount or flush-mounted</li>\n<li>Extra-large bowl provides plenty of room</li>\n<li>Perfect fit: Right angled apron front fits the width of a 900mm cabinet</li>\n<li>Available finishes: Black, White, Coffee, Tartufo, Rock Grey, Anthracite, Soft White, Volcano Grey</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste kit with space-saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(16728,155,0,6338,'Exclude'),(16729,85,5,6339,'Best ZEROX 340/180-U Sink, Blanco Blanco ZEROX 340/180-U Sinks, Blanco ceramic Sink, Silgranit Sink'),(16730,85,0,6339,'Best ZEROX 340/180-U Sink, Blanco Blanco ZEROX 340/180-U Sinks, Blanco ceramic Sink, Silgranit Sink'),(16731,75,5,6339,'<p><span style=\"font-size: medium;\"><strong>Blanco Zerox 340/180-U Undermount Sink</strong></span></p>\r\n<p>Blanco Zerox 340/180-U is an Undermount sink from the Zerox family of Blanco STEELART stainless steel sinks. Blanco Zerox 340/180-U comes with two bowls i-e. Main bowl and the half to provide sufficient workspace. This Undermount sink with its geometrical design will certainly, provide a focal point for your modern kitchen. Blanco Zerox 340/180-U, also, features a manually controlled overflow and waste fitting with a space-saving pipe. This Undermount sink also comes with a 3 1&sol;2 basket strainer waste and a fixing element set. This stainless steel sink is compatible with 60cm cabinet width; the depth of the main bowl is 175mm, the half bowl has a depth of 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Cabinet width: 600mm</li>\n<li>Overall size: 585 x 440mm</li>\n<li>Small bowl size: 180 x 400 x 130mm</li>\n<li>Large bowl size: 340 x 400 x 175mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>Zero radius bowls with the striking rectangular bowl geometry</li>\r\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\n<li>Overflow and waste</li>\n<li>Fixing kit included</li>\n</ul>\n\r\n'),(16732,75,0,6339,'<p><span style=\"font-size: medium;\"><strong>Blanco Zerox 340/180-U Undermount Sink</strong></span></p>\r\n<p>Blanco Zerox 340/180-U is an Undermount sink from the Zerox family of Blanco STEELART stainless steel sinks. Blanco Zerox 340/180-U comes with two bowls i-e. Main bowl and the half to provide sufficient workspace. This Undermount sink with its geometrical design will certainly, provide a focal point for your modern kitchen. Blanco Zerox 340/180-U, also, features a manually controlled overflow and waste fitting with a space-saving pipe. This Undermount sink also comes with a 3 1&sol;2 basket strainer waste and a fixing element set. This stainless steel sink is compatible with 60cm cabinet width; the depth of the main bowl is 175mm, the half bowl has a depth of 130mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Undermount</li>\n<li>Cabinet width: 600mm</li>\n<li>Overall size: 585 x 440mm</li>\n<li>Small bowl size: 180 x 400 x 130mm</li>\n<li>Large bowl size: 340 x 400 x 175mm</li>\n<li>Material: Stainless Steel</li>\n<li>Style: One & Half Bowl SS Sink</li>\n<li>Zero radius bowls with the striking rectangular bowl geometry</li>\r\n<li>High-quality features with the covered C-overflow and elegantly integrated InFino strainer</li>\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Undermount bowl with 3 1&sol;2&quot; basket strainer waste</li>\n<li>Overflow and waste</li>\n<li>Fixing kit included</li>\n</ul>\n\r\n'),(16733,155,0,6339,'Exclude'),(16734,85,5,6340,'Blanco BL467746 Sink, Blanco Sink, Blanco ceramic Sink, Blanco classic Sink, Blanco BL467746 Deals'),(16735,85,0,6340,'Blanco BL467746 Sink, Blanco Sink, Blanco ceramic Sink, Blanco classic Sink, Blanco BL467746 Deals'),(16736,75,5,6340,'<style>#html-body [data-pb-style=RDRBL00]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"RDRBL00\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Zia 45 S Puradur II Inset Silgranit Kitchen Sink</strong></span></p>\n<p><span>The  <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks/blanco-granite.html\" target=\"_blank\"><span style=\"text-decoration: underline;\">granite Sink</span></a> usually provide great use and that is why Blanco has manufactured the Blanco silgranite kitchen sink in order to deliver comfort in your life. The width of its cabinet is 45cm whereas the bowl is 190mm deep. The separate bowl is provided for your convenience. You will be able to wash the pots, vegetables, or meat more easily in the spacious bowl. The manufacturing is done with silgranite that renders a seamless appeal and makes the sink hygienic to use in the kitchen as it stops the growth of bacteria. The modern design is available with clear lines. There are multiple colours available in this sink including white, nutmeg, anthracite, jasmine, coffee, and many others to suit the designing of your kitchen in the best possible way.</span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 450mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Can be installed reversibly</li>\n<li>Modern design with clear lines</li>\n<li>Handing options: Reversible</li>\n<li>Spacious bowl for comfortable working</li>\n<li>Straight lined outer contour emphasised by the narrow rim</li>\n<li>Characteristic tap ledge as a frame that enlarges the drainer</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1/2\" basket strainer</li>\n</ul></div></div></div>'),(16737,75,0,6340,'<style>#html-body [data-pb-style=RDRBL00]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"RDRBL00\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Zia 45 S Puradur II Inset Silgranit Kitchen Sink</strong></span></p>\n<p><span>The  <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks/blanco-granite.html\" target=\"_blank\"><span style=\"text-decoration: underline;\">granite Sink</span></a> usually provide great use and that is why Blanco has manufactured the Blanco silgranite kitchen sink in order to deliver comfort in your life. The width of its cabinet is 45cm whereas the bowl is 190mm deep. The separate bowl is provided for your convenience. You will be able to wash the pots, vegetables, or meat more easily in the spacious bowl. The manufacturing is done with silgranite that renders a seamless appeal and makes the sink hygienic to use in the kitchen as it stops the growth of bacteria. The modern design is available with clear lines. There are multiple colours available in this sink including white, nutmeg, anthracite, jasmine, coffee, and many others to suit the designing of your kitchen in the best possible way.</span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 450mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Can be installed reversibly</li>\n<li>Modern design with clear lines</li>\n<li>Handing options: Reversible</li>\n<li>Spacious bowl for comfortable working</li>\n<li>Straight lined outer contour emphasised by the narrow rim</li>\n<li>Characteristic tap ledge as a frame that enlarges the drainer</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1/2\" basket strainer</li>\n</ul></div></div></div>'),(16738,155,0,6340,'Exclude'),(16739,85,5,6341,'Blanco BL467755 Sink, classic Sink, Blanco ceramic Sink, Blanco BL467755 Sink, Buy Best Sink'),(16740,85,0,6341,'Blanco BL467755 Sink, classic Sink, Blanco ceramic Sink, Blanco BL467755 Sink, Buy Best Sink'),(16741,75,5,6341,'<p><span style=\"font-size: medium;\"><strong>Blanco Zia 5 S Puradur II Inset Silgranit Kitchen Sink </strong></span></p>\n<p>The <a href=\"/brands/blanco.html\" target=\"_blank\">Blanco Zia silgranite</a> kitchen sink is not only unique in designing but makes your life easier by offering the comfortable use. The sink is available in multiple finishes of incredible colours including white, jasmine, rock grey, pearl grey, coffee, and many others in order to make you able to select the best one for your kitchen. The width of the cabinet is 50cm whereas the depth of bowl is 190mm. It has modern designing with clear lines as well as it has universal handling. The Blanco kitchen sink is easy to clean and its inset installation is also easy. It stops the growth of bacteria to keep the hygiene level high.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 500mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Modern design with clear lines</li>\n<li>Handing options: Reversible</li>\n<li>Straightlined outer contour emphasised by the narrow rim</li>\n<li>Characteristic tap ledge as a frame that enlarges the drainer</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n\n'),(16742,75,0,6341,'<p><span style=\"font-size: medium;\"><strong>Blanco Zia 5 S Puradur II Inset Silgranit Kitchen Sink </strong></span></p>\n<p>The <a href=\"/brands/blanco.html\" target=\"_blank\">Blanco Zia silgranite</a> kitchen sink is not only unique in designing but makes your life easier by offering the comfortable use. The sink is available in multiple finishes of incredible colours including white, jasmine, rock grey, pearl grey, coffee, and many others in order to make you able to select the best one for your kitchen. The width of the cabinet is 50cm whereas the depth of bowl is 190mm. It has modern designing with clear lines as well as it has universal handling. The Blanco kitchen sink is easy to clean and its inset installation is also easy. It stops the growth of bacteria to keep the hygiene level high.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 500mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Modern design with clear lines</li>\n<li>Handing options: Reversible</li>\n<li>Straightlined outer contour emphasised by the narrow rim</li>\n<li>Characteristic tap ledge as a frame that enlarges the drainer</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>\n\n\n'),(16743,155,0,6341,'Exclude'),(16744,85,5,6342,'Blanco ceramic Sink, Blanco Silgranit Sink, Blanco classic Sin Sink, buy Blanco  Silgranit Sink, Blanco Sinks'),(16745,85,0,6342,'Blanco ceramic Sink, Blanco Silgranit Sink, Blanco classic Sin Sink, buy Blanco  Silgranit Sink, Blanco Sinks'),(16746,75,5,6342,'<style>#html-body [data-pb-style=U1VKQ3P]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"U1VKQ3P\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Zia 6 S Puradur II Inset Silgranit Kitchen Sink </strong></span></p>\n<p>Give a luxurious touch to the overall designing of the kitchen by installing the <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks/blanco-granite.html\" target=\"_blank\"> Blanco Zia silgranite kitchen sink</a> that is unique in designing and renders exceptional functionality. It has spacious bowl that allows you to easily wash the large pots, vegetables, and meat. It is easy to maintain as its surface is resistant to scratches and rust as well as keeps the hygiene level high in the kitchen. The width of cabinet is 60cm and it is provided with universal handling. The modern design of the kitchen sink has clear lines and it blends easily with the design and furniture of the kitchen. Options in the colours are also available so you can choose any one that will suit your kitchen in the best way.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Small bowl depth: 140mm</li>\n<li>Large bowl depth: 190mm</li>\n<li>Style: One &amp; Half Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>Spacious main bowl for comfortable working</li>\n<li>Straight lined outer contour emphasised by the narrow rim</li>\n<li>Characteristic tap ledge as a frame that enlarges the drainer</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>Two 3 1/2\" basket strainers</li>\n</ul></div></div></div>'),(16747,75,0,6342,'<style>#html-body [data-pb-style=U1VKQ3P]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"U1VKQ3P\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Blanco Zia 6 S Puradur II Inset Silgranit Kitchen Sink </strong></span></p>\n<p>Give a luxurious touch to the overall designing of the kitchen by installing the <a href=\"/kitchen-appliances/kitchen-sinks/full-sinks/blanco-granite.html\" target=\"_blank\"> Blanco Zia silgranite kitchen sink</a> that is unique in designing and renders exceptional functionality. It has spacious bowl that allows you to easily wash the large pots, vegetables, and meat. It is easy to maintain as its surface is resistant to scratches and rust as well as keeps the hygiene level high in the kitchen. The width of cabinet is 60cm and it is provided with universal handling. The modern design of the kitchen sink has clear lines and it blends easily with the design and furniture of the kitchen. Options in the colours are also available so you can choose any one that will suit your kitchen in the best way.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Undermount</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Small bowl depth: 140mm</li>\n<li>Large bowl depth: 190mm</li>\n<li>Style: One &amp; Half Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>Spacious main bowl for comfortable working</li>\n<li>Straight lined outer contour emphasised by the narrow rim</li>\n<li>Characteristic tap ledge as a frame that enlarges the drainer</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>Two 3 1/2\" basket strainers</li>\n</ul></div></div></div>'),(16748,155,0,6342,'Exclude'),(16749,85,5,6343,'Blanco ZIA 9 E Corner Silgranit PuraDur II® Inset Sink'),(16750,85,0,6343,'Blanco ZIA 9 E Corner Silgranit PuraDur II® Inset Sink'),(16751,75,5,6343,'<p><span style=\"font-size: medium;\"><strong>Blanco ZIA 9 E Corner Silgranit PuraDur II Inset Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Modern design with clear lines</li>\r\n<li>Suitable for both corner and in-line designs</li>\n<li>Compact drainer and recessed draining area</li>\n<li>Symmetrical setup with balanced proportions</li>\n<li>Very spacious, centred bowl with small corner radiuses</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>'),(16752,75,0,6343,'<p><span style=\"font-size: medium;\"><strong>Blanco ZIA 9 E Corner Silgranit PuraDur II Inset Sink</strong></span></p>\r\n\r<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Modern design with clear lines</li>\r\n<li>Suitable for both corner and in-line designs</li>\n<li>Compact drainer and recessed draining area</li>\n<li>Symmetrical setup with balanced proportions</li>\n<li>Very spacious, centred bowl with small corner radiuses</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>'),(16753,155,0,6343,'Exclude'),(16754,85,5,6344,'Blanco ZIA XL 6 S Silgranit PuraDur II® Inset Sink'),(16755,85,0,6344,'Blanco ZIA XL 6 S Silgranit PuraDur II® Inset Sink'),(16756,75,5,6344,'<p><span style=\"font-size: medium;\"><strong>Blanco ZIA XL 6 S Silgranit PuraDur II Inset Sink</strong></span></p>\n\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Can be installed reversibly </li>\n<li>Modern design with clear lines</li>\n<li>Handing options: Reversible</li>\n<li>XL bowl for even more space when washing your dishes</li>\n<li>Straight-lined outer contour emphasised by the narrow rim</li>\n<li>Characteristic tap ledge as a frame that enlarges the drainer</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>'),(16757,75,0,6344,'<p><span style=\"font-size: medium;\"><strong>Blanco ZIA XL 6 S Silgranit PuraDur II Inset Sink</strong></span></p>\n\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Material: Granite</li>\n<li>Cabinet width: 600mm</li>\n<li>Bowl depth: 190mm</li>\n<li>Can be installed reversibly </li>\n<li>Modern design with clear lines</li>\n<li>Handing options: Reversible</li>\n<li>XL bowl for even more space when washing your dishes</li>\n<li>Straight-lined outer contour emphasised by the narrow rim</li>\n<li>Characteristic tap ledge as a frame that enlarges the drainer</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Waste fitting with space-saving pipe</li>\n<li>3 1&sol;2&quot; basket strainer</li>\n</ul>'),(16758,155,0,6344,'Exclude'),(16759,75,5,6345,'<p><span style=\"font-size: medium;\"><strong>Blanco Zia XL 6 S Compact Silgranit Inset Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Granite</li>\n<li>Style: Single Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>Modern design with clear lines</li>\n<li>Stain resistant and easy to clean</li>\n<li>Extra large bowl for maximum comfort</li>\n<li>Straight lined outer contour emphasized by the narrow rim</li>\n<li>Available finishes: Anthracite, Alumetallic , White , Jasmine , Black</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(16760,75,0,6345,'<p><span style=\"font-size: medium;\"><strong>Blanco Zia XL 6 S Compact Silgranit Inset Kitchen Sink</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Installation: Inset</li>\n<li>Bowl depth: 190mm</li>\n<li>Cabinet width: 600mm</li>\n<li>Material: Granite</li>\n<li>Style: Single Bowl Sink</li>\n<li>Can be installed reversibly</li>\n<li>Handing options: Reversible</li>\n<li>Modern design with clear lines</li>\n<li>Stain resistant and easy to clean</li>\n<li>Extra large bowl for maximum comfort</li>\n<li>Straight lined outer contour emphasized by the narrow rim</li>\n<li>Available finishes: Anthracite, Alumetallic , White , Jasmine , Black</li>\n</ul>\n<p><span style=\"font-size: medium;\"><strong>Scope of supply</strong></span></p>\n<ul>\n<li>Fixing kit</li>\n<li>Waste kit with space saving pipe</li>\n<li>3 1&sol;2&quot; InFino basket strainer</li>\n</ul>'),(16761,155,0,6345,'Exclude'),(16762,156,0,6035,'0'),(16763,146,0,6035,NULL),(16764,145,0,6035,NULL),(16765,156,0,6036,'0'),(16766,146,0,6036,NULL),(16767,145,0,6036,NULL),(16768,85,5,6346,'Royce Morgan Balmoral Freestanding Bath 1680mm x 730mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16769,85,0,6346,'Royce Morgan Balmoral Freestanding Bath 1680mm x 730mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16770,75,5,6346,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Balmoral Freestanding Bath 168cm x 73cm</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Royce Morgan Free Standing Bath</strong> has a versatile bath design and its shape can fit all corner options. The size of this bath is accurate enough to fit easily at any place as it is a freestanding bath so installation is not required for it. It has a length of 1680mm, a width of 730mm and a height of 600mm. The weight of this traditional ended bath is 36kg as well as it incorporates a tap platform. This alluring bath is designed to be tiled-in as well as it renders 189 litres of water to overflow. It is manufactured by using the high grade European white double skinned sanitary grade acrylic that renders excellent thermal properties to it as well as the feet of this bath are manufactured by using chrome plated aluminium due to which it renders stability to it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1680mm x Width 730mm x Height 600mm</li>\r\n<li>Traditional double-ended bath</li>\r\n<li>Weight: 36kg</li>\r\n<li>Weight (with water): 225kg</li>\r\n<li>Flat top finish</li>\r\n<li>Incorporates a tap platform</li>\r\n<li>Designed to be tiled-in</li>\r\n<li>Litres to Overflow: 189</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic:Feet are manufactured using chrome plated aluminium</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Feet are manufactured using chrome plated aluminium</li>\r\n<li>Tap Holes can be drilled on request</li>\r\n</ul>'),(16771,75,0,6346,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Balmoral Freestanding Bath 168cm x 73cm</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Royce Morgan Free Standing Bath</strong> has a versatile bath design and its shape can fit all corner options. The size of this bath is accurate enough to fit easily at any place as it is a freestanding bath so installation is not required for it. It has a length of 1680mm, a width of 730mm and a height of 600mm. The weight of this traditional ended bath is 36kg as well as it incorporates a tap platform. This alluring bath is designed to be tiled-in as well as it renders 189 litres of water to overflow. It is manufactured by using the high grade European white double skinned sanitary grade acrylic that renders excellent thermal properties to it as well as the feet of this bath are manufactured by using chrome plated aluminium due to which it renders stability to it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1680mm x Width 730mm x Height 600mm</li>\r\n<li>Traditional double-ended bath</li>\r\n<li>Weight: 36kg</li>\r\n<li>Weight (with water): 225kg</li>\r\n<li>Flat top finish</li>\r\n<li>Incorporates a tap platform</li>\r\n<li>Designed to be tiled-in</li>\r\n<li>Litres to Overflow: 189</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic:Feet are manufactured using chrome plated aluminium</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Feet are manufactured using chrome plated aluminium</li>\r\n<li>Tap Holes can be drilled on request</li>\r\n</ul>'),(16772,155,0,6346,'Exclude'),(16773,85,5,6347,'Royce Morgan Bolton Freestanding Bath 1690mm x 800mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16774,85,0,6347,'Royce Morgan Bolton Freestanding Bath 1690mm x 800mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16775,75,5,6347,'<style>#html-body [data-pb-style=JYHGOCX]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"JYHGOCX\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Royce Morgan Bolton Freestanding Bath 169cm x 80cm</strong></span></p>\r\n<p style=\"text-align: justify;\">The oval shaped Royce Morgan Bolton bath embodies beauty and sophistication. You can place it anywhere without worrying about its installation as it is a <span style=\"color: #333399;\"><a href=\"https://www.banyo.co.uk/bathroom/baths/free-standing-baths.html\" target=\"_blank\"><span style=\"color: #333399;\"> freestanding bath</span></a></span>. It renders 190 litres to overflow and its weight is 42kg. This luxurious bathtub has a flat top finish as well as it is easy to be cleaned and maintained. The material used in its manufacturing is European white double skinned sanitary grade acrylic that brings excellent thermal properties to it. It has the efficiency to retain water heat for longer than cast iron baths. Tap holes are not pre-drilled in it and it is suitable for wall mounted taps or freestanding only. Royce Morgan renders a whopping guarantee of a lifetime for your peace of mind.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1690mm x Width 800mm x Height 600mm</li>\r\n<li>Contemporary double-ended bath</li>\r\n<li>Weight: 42kg</li>\r\n<li>Weight (with water): 232kg</li>\r\n<li>Flat top finish</li>\r\n<li>Litres to Overflow: 190</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li><strong>No tap holes, suitable for freestanding or wall mounted taps only</strong></li>\r\n</ul>\r\n</div></div></div>'),(16776,75,0,6347,'<style>#html-body [data-pb-style=JYHGOCX]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"JYHGOCX\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Royce Morgan Bolton Freestanding Bath 169cm x 80cm</strong></span></p>\r\n<p style=\"text-align: justify;\">The oval shaped Royce Morgan Bolton bath embodies beauty and sophistication. You can place it anywhere without worrying about its installation as it is a <span style=\"color: #333399;\"><a href=\"https://www.banyo.co.uk/bathroom/baths/free-standing-baths.html\" target=\"_blank\"><span style=\"color: #333399;\"> freestanding bath</span></a></span>. It renders 190 litres to overflow and its weight is 42kg. This luxurious bathtub has a flat top finish as well as it is easy to be cleaned and maintained. The material used in its manufacturing is European white double skinned sanitary grade acrylic that brings excellent thermal properties to it. It has the efficiency to retain water heat for longer than cast iron baths. Tap holes are not pre-drilled in it and it is suitable for wall mounted taps or freestanding only. Royce Morgan renders a whopping guarantee of a lifetime for your peace of mind.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1690mm x Width 800mm x Height 600mm</li>\r\n<li>Contemporary double-ended bath</li>\r\n<li>Weight: 42kg</li>\r\n<li>Weight (with water): 232kg</li>\r\n<li>Flat top finish</li>\r\n<li>Litres to Overflow: 190</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li><strong>No tap holes, suitable for freestanding or wall mounted taps only</strong></li>\r\n</ul>\r\n</div></div></div>'),(16777,155,0,6347,'Exclude'),(16778,85,5,6348,'Royce Morgan Bolton Freestanding Bath 1805mm x 860mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16779,85,0,6348,'Royce Morgan Bolton Freestanding Bath 1805mm x 860mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16780,75,5,6348,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Bolton Freestanding Bath 1805mm x 860mm</strong></span></p>\r\n<p style=\"text-align: justify;\"> Royce Morgan Bolton bath has perfect dimensions that make it an outstanding freestanding bath for any bathing area. It has designed with a length of 1805mm, a width of 860mm and a height of 600mm. It renders 215 litres of water to overflow and has manufactured by using European white double skinned sanitary grade acrylic due to which there is no comparison of its excellent thermal properties. It retains water heat for longer than cast iron baths due to which you will be able to enjoy a comfortable bath in any season. A concealed chain waste is included in its price and tap holes are not pre-drilled in it that makes it suitable for freestanding or <strong><a href=\"https://www.banyo.co.uk/taps/bathroom-taps/bath-taps.html\" title=\"bath wall hung taps\" target=\"_blank\"><span style=\"color: #3366ff;\">wall mounted taps</span></a> </strong>only.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1805mm x Width 860mm x Height 600mm</li>\r\n<li>Contemporary double-ended bath</li>\r\n<li>Weight: 48kg</li>\r\n<li>Weight (with water): 263kg</li>\r\n<li>Flat top finish</li>\r\n<li>Litres to Overflow: 215</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Concealed Chain Waste included</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16781,75,0,6348,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Bolton Freestanding Bath 1805mm x 860mm</strong></span></p>\r\n<p style=\"text-align: justify;\"> Royce Morgan Bolton bath has perfect dimensions that make it an outstanding freestanding bath for any bathing area. It has designed with a length of 1805mm, a width of 860mm and a height of 600mm. It renders 215 litres of water to overflow and has manufactured by using European white double skinned sanitary grade acrylic due to which there is no comparison of its excellent thermal properties. It retains water heat for longer than cast iron baths due to which you will be able to enjoy a comfortable bath in any season. A concealed chain waste is included in its price and tap holes are not pre-drilled in it that makes it suitable for freestanding or <strong><a href=\"https://www.banyo.co.uk/taps/bathroom-taps/bath-taps.html\" title=\"bath wall hung taps\" target=\"_blank\"><span style=\"color: #3366ff;\">wall mounted taps</span></a> </strong>only.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1805mm x Width 860mm x Height 600mm</li>\r\n<li>Contemporary double-ended bath</li>\r\n<li>Weight: 48kg</li>\r\n<li>Weight (with water): 263kg</li>\r\n<li>Flat top finish</li>\r\n<li>Litres to Overflow: 215</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Concealed Chain Waste included</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16782,155,0,6348,'Exclude'),(16783,85,5,6349,'Royce Morgan Chatsworth Freestanding Bath 1530mm x 710mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16784,85,0,6349,'Royce Morgan Chatsworth Freestanding Bath 1530mm x 710mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16785,75,5,6349,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Chatsworth Freestanding Bath 1530mm x 710mm</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Royce Morgan Free Standing bath</strong> is a traditional single-ended slipper bath that looks great with the design of any bathroom as it has smooth curves and beautiful shape. The length of this bath is 1530mm whereas its width is 710mm and it has a height of 755mm. Though it looks small but it has excellent features so it will just enhance your conventional setting. The weight of this bath is 39kg whereas the roll top finish of this bath incorporates a defined tap platform. It renders 160 litres of water to overflow and the European white double skinned sanitary grade acrylic is used in the manufacturing of this bath due to which it will retain water heat for longer than <strong>cast iron baths</strong> and it can be maintained easily as it can be cleaned effortlessly. The feet of this <a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>bath</strong></span></a> are manufactured by using chrome plated aluminium to render excellent durability to it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1530mm x Width 710mm x Height 755mm</li>\r\n<li>Traditional single-ended slipper bath</li>\r\n<li>Weight: 39kg</li>\r\n<li>Weight (with water): 199kg</li>\r\n<li>Roll top finish</li>\r\n<li>Incorporates a defined tap platform</li>\r\n<li>Litres to Overflow: 160</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic:Feet are manufactured using chrome plated aluminium</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Feet are manufactured using chrome plated aluminium</li>\r\n<li>Tap Holes can be drilled on request</li>\r\n</ul>'),(16786,75,0,6349,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Chatsworth Freestanding Bath 1530mm x 710mm</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Royce Morgan Free Standing bath</strong> is a traditional single-ended slipper bath that looks great with the design of any bathroom as it has smooth curves and beautiful shape. The length of this bath is 1530mm whereas its width is 710mm and it has a height of 755mm. Though it looks small but it has excellent features so it will just enhance your conventional setting. The weight of this bath is 39kg whereas the roll top finish of this bath incorporates a defined tap platform. It renders 160 litres of water to overflow and the European white double skinned sanitary grade acrylic is used in the manufacturing of this bath due to which it will retain water heat for longer than <strong>cast iron baths</strong> and it can be maintained easily as it can be cleaned effortlessly. The feet of this <a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>bath</strong></span></a> are manufactured by using chrome plated aluminium to render excellent durability to it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1530mm x Width 710mm x Height 755mm</li>\r\n<li>Traditional single-ended slipper bath</li>\r\n<li>Weight: 39kg</li>\r\n<li>Weight (with water): 199kg</li>\r\n<li>Roll top finish</li>\r\n<li>Incorporates a defined tap platform</li>\r\n<li>Litres to Overflow: 160</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic:Feet are manufactured using chrome plated aluminium</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Feet are manufactured using chrome plated aluminium</li>\r\n<li>Tap Holes can be drilled on request</li>\r\n</ul>'),(16787,155,0,6349,'Exclude'),(16788,85,5,6350,'Royce Morgan Ebony Freestanding Bath 1710mm x 735mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16789,85,0,6350,'Royce Morgan Ebony Freestanding Bath 1710mm x 735mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16790,75,5,6350,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Ebony Freestanding Bath 1710mm x 735mm</strong></span></p>\r\n<p style=\"text-align: justify;\">Lift the design of your bathroom to an upgrade level by making a place for Royce Morgan Ebony bath. It does not require any installation as it is designed as a freestanding bath. The design of this Ebony bath blends easily with any design of bathroom to give a new exciting look. The smooth curves of this bath are seamlessly designed and it renders 175 litres of water to overflow. The length of this bath is 1710mm whereas its width is 735mm and it has a height of 730mm. Ebony bath simply means indulgence and enjoyment as it offers maximum comfort and tranquillity. This <strong>contemporary slipper bath</strong> has integrated overflow and push waste buttons as well as the excellent thermal properties of this <a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>bath</strong></span></a> allow it to retain water heat for a longer time than cast iron baths.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1710mm x Width 735mm x Height 730mm</li>\r\n<li>Litres to Overflow: 175</li>\r\n<li>Contemporary slipper bath, complete with integrated overflow and push button waste</li>\r\n<li>Boasts distinctive thin edges</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16791,75,0,6350,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Ebony Freestanding Bath 1710mm x 735mm</strong></span></p>\r\n<p style=\"text-align: justify;\">Lift the design of your bathroom to an upgrade level by making a place for Royce Morgan Ebony bath. It does not require any installation as it is designed as a freestanding bath. The design of this Ebony bath blends easily with any design of bathroom to give a new exciting look. The smooth curves of this bath are seamlessly designed and it renders 175 litres of water to overflow. The length of this bath is 1710mm whereas its width is 735mm and it has a height of 730mm. Ebony bath simply means indulgence and enjoyment as it offers maximum comfort and tranquillity. This <strong>contemporary slipper bath</strong> has integrated overflow and push waste buttons as well as the excellent thermal properties of this <a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>bath</strong></span></a> allow it to retain water heat for a longer time than cast iron baths.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1710mm x Width 735mm x Height 730mm</li>\r\n<li>Litres to Overflow: 175</li>\r\n<li>Contemporary slipper bath, complete with integrated overflow and push button waste</li>\r\n<li>Boasts distinctive thin edges</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16792,155,0,6350,'Exclude'),(16793,85,5,6351,'Royce Morgan Hexham Freestanding Bath 1690mm x 760mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16794,85,0,6351,'Royce Morgan Hexham Freestanding Bath 1690mm x 760mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16795,75,5,6351,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Hexham Freestanding Bath 1690mm x 760mm</strong></span></p>\r\n<p style=\"text-align: justify;\">Let the beauty of Royce Morgan Hexham bath hypnotise you as its incredible designing is simply unbeatable. The perfect dimensions of this bath are perfect for your contemporary bathroom. The length of this bath is 1690mm whereas its width is 760mm and it has a height of 590mm. The weight of this contemporary double ended bath is 42kg and it incorporates a defined tap platform. Feet of this stylish bath are manufactured by using chrome plated aluminium whereas the European white double skinned sanitary grade acrylic is used in its overall manufacturing that brings excellent thermal properties to it. This bathtub retains water heat for longer than cast iron baths. There is no pre-drilled tap hole so it is suitable for freestanding or wall mounted taps only.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1690mm x Width 760mm x Height 590mm</li>\r\n<li>Contemporary double-ended bath</li>\r\n<li>Weight: 42kg</li>\r\n<li>Weight (with water): 227kg</li>\r\n<li>Flat top finish</li>\r\n<li>Incorporates a tap platform</li>\r\n<li>Litres to Overflow: 185</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16796,75,0,6351,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Hexham Freestanding Bath 1690mm x 760mm</strong></span></p>\r\n<p style=\"text-align: justify;\">Let the beauty of Royce Morgan Hexham bath hypnotise you as its incredible designing is simply unbeatable. The perfect dimensions of this bath are perfect for your contemporary bathroom. The length of this bath is 1690mm whereas its width is 760mm and it has a height of 590mm. The weight of this contemporary double ended bath is 42kg and it incorporates a defined tap platform. Feet of this stylish bath are manufactured by using chrome plated aluminium whereas the European white double skinned sanitary grade acrylic is used in its overall manufacturing that brings excellent thermal properties to it. This bathtub retains water heat for longer than cast iron baths. There is no pre-drilled tap hole so it is suitable for freestanding or wall mounted taps only.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1690mm x Width 760mm x Height 590mm</li>\r\n<li>Contemporary double-ended bath</li>\r\n<li>Weight: 42kg</li>\r\n<li>Weight (with water): 227kg</li>\r\n<li>Flat top finish</li>\r\n<li>Incorporates a tap platform</li>\r\n<li>Litres to Overflow: 185</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16797,155,0,6351,'Exclude'),(16798,85,5,6352,'Royce Morgan Kensington Freestanding Bath 1495mm x 785mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16799,85,0,6352,'Royce Morgan Kensington Freestanding Bath 1495mm x 785mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16800,75,5,6352,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Kensington Freestanding Bath 1495mm x 785mm</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Royce Morgan Free Standing</strong> can really add comfort in your life as they have rendered to you after a complete procedure of testing and examination to make them free from any loophole. The material used in its manufacturing is European white double skinned sanitary grade acrylic that brings excellent thermal properties to it. It has the efficiency to retain water heat for longer than cast iron baths. Tap holes are not pre-drilled in it but they can be drilled on your request. Royce Morgan renders a whopping guarantee of a lifetime for your peace of mind. The excellent dimensions of this <span style=\"color: #3366ff;\"><a href=\"https://www.banyo.co.uk/brands/royce-morgan.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>Royce MorganBath</strong></span></a></span> include a length of 1495mm, a width of 785mm, and a height of 610mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1495mm x Width 785mm x Height 610mm</li>\r\n<li>Traditional double-ended bath</li>\r\n<li>Weight: 33kg</li>\r\n<li>Weight (with water): 198kg</li>\r\n<li>Roll top finish</li>\r\n<li>Incorporates a defined tap platform</li>\r\n<li>Litres to Overflow: 165</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Tap Holes Can be drilled on request</li>\r\n<li>Feet are manufactured using chrome plated aluminium</li>\r\n</ul>'),(16801,75,0,6352,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Kensington Freestanding Bath 1495mm x 785mm</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Royce Morgan Free Standing</strong> can really add comfort in your life as they have rendered to you after a complete procedure of testing and examination to make them free from any loophole. The material used in its manufacturing is European white double skinned sanitary grade acrylic that brings excellent thermal properties to it. It has the efficiency to retain water heat for longer than cast iron baths. Tap holes are not pre-drilled in it but they can be drilled on your request. Royce Morgan renders a whopping guarantee of a lifetime for your peace of mind. The excellent dimensions of this <span style=\"color: #3366ff;\"><a href=\"https://www.banyo.co.uk/brands/royce-morgan.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>Royce MorganBath</strong></span></a></span> include a length of 1495mm, a width of 785mm, and a height of 610mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1495mm x Width 785mm x Height 610mm</li>\r\n<li>Traditional double-ended bath</li>\r\n<li>Weight: 33kg</li>\r\n<li>Weight (with water): 198kg</li>\r\n<li>Roll top finish</li>\r\n<li>Incorporates a defined tap platform</li>\r\n<li>Litres to Overflow: 165</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Tap Holes Can be drilled on request</li>\r\n<li>Feet are manufactured using chrome plated aluminium</li>\r\n</ul>'),(16802,155,0,6352,'Exclude'),(16803,85,5,6353,'Royce Morgan Kensington Freestanding Bath 1695mm x 740mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16804,85,0,6353,'Royce Morgan Kensington Freestanding Bath 1695mm x 740mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16805,75,5,6353,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Kensington Freestanding Bath 1695mm x 740mm</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Royce Morgan Kensington bath</strong> is designed by the highly expert engineers of Royce Morgan. The features and designing of this incredible bath cannot be seen in any other bath. You will find it an ideal centrepiece for any en-suite or bathroom. Freestanding baths usually render more comfort as they do not require any installation and you can install them anywhere in your bathing area. More on the position of a <span style=\"color: #3366ff;\"><a href=\"https://www.banyo.co.uk/bathroom/baths/free-standing-baths.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>Freestanding Bath</strong> </span></a></span>can be easily changed anytime as it can be moved easily. Royce Morgan gave white colour to this elegant design for making it more eye-catching. It renders 185 litres of water to overflow and European white doubled skinned sanitary grade acrylic is used in its crafting as this material brings lots of advantages to this bathtub. It contains excellent thermal properties as well as retains water heat for longer than cast iron baths.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1695mm x Width 740mm x Height 610mm</li>\r\n<li>Traditional double-ended bath</li>\r\n<li>Weight: 38kg</li>\r\n<li>Weight (with water): 223kg</li>\r\n<li>Roll top finish</li>\r\n<li>Incorporates a defined tap platform</li>\r\n<li>Litres to Overflow: 185</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Tap Holes Can be drilled on request</li>\r\n<li>Feet are manufactured using chrome plated aluminium</li>\r\n</ul>'),(16806,75,0,6353,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Kensington Freestanding Bath 1695mm x 740mm</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Royce Morgan Kensington bath</strong> is designed by the highly expert engineers of Royce Morgan. The features and designing of this incredible bath cannot be seen in any other bath. You will find it an ideal centrepiece for any en-suite or bathroom. Freestanding baths usually render more comfort as they do not require any installation and you can install them anywhere in your bathing area. More on the position of a <span style=\"color: #3366ff;\"><a href=\"https://www.banyo.co.uk/bathroom/baths/free-standing-baths.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>Freestanding Bath</strong> </span></a></span>can be easily changed anytime as it can be moved easily. Royce Morgan gave white colour to this elegant design for making it more eye-catching. It renders 185 litres of water to overflow and European white doubled skinned sanitary grade acrylic is used in its crafting as this material brings lots of advantages to this bathtub. It contains excellent thermal properties as well as retains water heat for longer than cast iron baths.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1695mm x Width 740mm x Height 610mm</li>\r\n<li>Traditional double-ended bath</li>\r\n<li>Weight: 38kg</li>\r\n<li>Weight (with water): 223kg</li>\r\n<li>Roll top finish</li>\r\n<li>Incorporates a defined tap platform</li>\r\n<li>Litres to Overflow: 185</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Tap Holes Can be drilled on request</li>\r\n<li>Feet are manufactured using chrome plated aluminium</li>\r\n</ul>'),(16807,155,0,6353,'Exclude'),(16808,85,5,6354,'Royce Morgan Lambeth Freestanding Bath 1665mm x 715mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16809,85,0,6354,'Royce Morgan Lambeth Freestanding Bath 1665mm x 715mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16810,75,5,6354,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Lambeth Freestanding Bath 1665mm x 715mm</strong></span></p>\r\n<p style=\"text-align: justify;\">There is no doubt that the baths that are manufactured by Royce Morgan are free from any loophole and give long lasting results. <strong>Royce Morgan Lambeth bath</strong> is one of the most functional baths of Royce Morgan. This traditional single ended bath has a weight of 36kg and it is available with the flat top finish. It is manufactured by using European white double skinned sanitary grade acrylic that has excellent thermal properties. This alluring <span style=\"color: #3366ff;\"><a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>bathtub</strong></span></a></span> retains water heat for longer than cast iron baths. The length of this functional bathtub is 1665mm whereas its width is 715mm and the height of this bath is 570mm. Tap holes can be drilled on your request as they are not pre-drilled. It is available as left hand, single ended, and right hand.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1665mm x Width 715mm x Height 570mm</li>\r\n<li>Traditional single-ended bath</li>\r\n<li>Weight: 36kg</li>\r\n<li>Weight (with water): 216kg</li>\r\n<li>Flat top finish</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic:Feet are manufactured using chrome plated aluminium</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Feet are manufactured using chrome plated aluminium</li>\r\n<li>Available as: Single Ended, Left Hand, Right Hand</li>\r\n<li>Tap Holes can be drilled on request</li>\r\n</ul>'),(16811,75,0,6354,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Lambeth Freestanding Bath 1665mm x 715mm</strong></span></p>\r\n<p style=\"text-align: justify;\">There is no doubt that the baths that are manufactured by Royce Morgan are free from any loophole and give long lasting results. <strong>Royce Morgan Lambeth bath</strong> is one of the most functional baths of Royce Morgan. This traditional single ended bath has a weight of 36kg and it is available with the flat top finish. It is manufactured by using European white double skinned sanitary grade acrylic that has excellent thermal properties. This alluring <span style=\"color: #3366ff;\"><a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>bathtub</strong></span></a></span> retains water heat for longer than cast iron baths. The length of this functional bathtub is 1665mm whereas its width is 715mm and the height of this bath is 570mm. Tap holes can be drilled on your request as they are not pre-drilled. It is available as left hand, single ended, and right hand.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1665mm x Width 715mm x Height 570mm</li>\r\n<li>Traditional single-ended bath</li>\r\n<li>Weight: 36kg</li>\r\n<li>Weight (with water): 216kg</li>\r\n<li>Flat top finish</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic:Feet are manufactured using chrome plated aluminium</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Feet are manufactured using chrome plated aluminium</li>\r\n<li>Available as: Single Ended, Left Hand, Right Hand</li>\r\n<li>Tap Holes can be drilled on request</li>\r\n</ul>'),(16812,155,0,6354,'Exclude'),(16813,85,5,6355,'Royce Morgan Melrose Freestanding Bath 1700mm x 700mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16814,85,0,6355,'Royce Morgan Melrose Freestanding Bath 1700mm x 700mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16815,75,5,6355,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Melrose Double Ended Boat Bath with Plinth 1700 x 700mm</strong></span></p>\r\n<p style=\"text-align: justify;\">Lift the design of your bathroom to a modern level by bringing <strong>Royce Morgan Melrose bath</strong>. The highly useful features of this bath will amaze you immediately. The material used in its manufacturing is European white double skinned sanitary grade acrylic that brings excellent thermal properties to it. It has the efficiency to retain water heat for longer than <strong>cast iron bath</strong>s. Tap holes are not pre-drilled in it as it is suitable for freestanding or wall mounted taps only. Royce Morgan renders a whopping guarantee of a lifetime for your peace of mind. The excellent dimensions of this <a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>bath</strong></span></a> include a length of 1700mm, a width of 700mm, and a height of 700mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1700mm x Width 700mm x Height 700mm</li>\r\n<li>Traditional double-ended &lsquo;boat&rsquo; bath</li>\r\n<li>Weight: 37kg</li>\r\n<li>Weight (with water): 227kg</li>\r\n<li>Roll top finish</li>\r\n<li>Litres to Overflow: 190</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Bath supplied with plinth</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16816,75,0,6355,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Melrose Double Ended Boat Bath with Plinth 1700 x 700mm</strong></span></p>\r\n<p style=\"text-align: justify;\">Lift the design of your bathroom to a modern level by bringing <strong>Royce Morgan Melrose bath</strong>. The highly useful features of this bath will amaze you immediately. The material used in its manufacturing is European white double skinned sanitary grade acrylic that brings excellent thermal properties to it. It has the efficiency to retain water heat for longer than <strong>cast iron bath</strong>s. Tap holes are not pre-drilled in it as it is suitable for freestanding or wall mounted taps only. Royce Morgan renders a whopping guarantee of a lifetime for your peace of mind. The excellent dimensions of this <a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>bath</strong></span></a> include a length of 1700mm, a width of 700mm, and a height of 700mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1700mm x Width 700mm x Height 700mm</li>\r\n<li>Traditional double-ended &lsquo;boat&rsquo; bath</li>\r\n<li>Weight: 37kg</li>\r\n<li>Weight (with water): 227kg</li>\r\n<li>Roll top finish</li>\r\n<li>Litres to Overflow: 190</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Bath supplied with plinth</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16817,155,0,6355,'Exclude'),(16818,85,5,6356,'Royce Morgan Melrose Freestanding Bath 1740mm x 700mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16819,85,0,6356,'Royce Morgan Melrose Freestanding Bath 1740mm x 700mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16820,75,5,6356,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Melrose Freestanding Bath 1740mm x 700mm</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Royce Morgan Melrose bath</strong> is famous for its outstanding features and superior quality. The design of this freestanding bath is quite different from others that can enhance the visual appearance of any bathroom. It has seamless round curves from both sides that really look awesome. The white shiny surface of this bath blends easily with any design of bathroom. It is a double-ended boat bath and has a weight of 39kg. The roll top finish of this bath is adding worth to it. It renders 192 litres of water to overflow as it is manufactured by using European white double skinned sanitary grade acrylic due to which it has excellent thermal properties. It can retain water heat for longer than cast iron baths so you will be able to enjoy comfortable bath moments in winters. <a href=\"https://www.banyo.co.uk/brands/royce-morgan.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>Royce Morgan bath</strong></span></a> is rendering a guarantee of lifetime for your peace of mind.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1740mm x Width 700mm x Height 700mm</li>\r\n<li>Traditional double-ended &lsquo;boat&rsquo; bath</li>\r\n<li>Weight: 39kg</li>\r\n<li>Weight (with water): 231kg</li>\r\n<li>FA Chrome Foot</li>\r\n<li>Roll top finish</li>\r\n<li>Litres to Overflow: 192</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Tap Holes, Can be drilled on request</li>\r\n<li>Feet are manufactured using chrome plated aluminium</li>\r\n</ul>'),(16821,75,0,6356,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Melrose Freestanding Bath 1740mm x 700mm</strong></span></p>\r\n<p style=\"text-align: justify;\"><strong>Royce Morgan Melrose bath</strong> is famous for its outstanding features and superior quality. The design of this freestanding bath is quite different from others that can enhance the visual appearance of any bathroom. It has seamless round curves from both sides that really look awesome. The white shiny surface of this bath blends easily with any design of bathroom. It is a double-ended boat bath and has a weight of 39kg. The roll top finish of this bath is adding worth to it. It renders 192 litres of water to overflow as it is manufactured by using European white double skinned sanitary grade acrylic due to which it has excellent thermal properties. It can retain water heat for longer than cast iron baths so you will be able to enjoy comfortable bath moments in winters. <a href=\"https://www.banyo.co.uk/brands/royce-morgan.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>Royce Morgan bath</strong></span></a> is rendering a guarantee of lifetime for your peace of mind.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1740mm x Width 700mm x Height 700mm</li>\r\n<li>Traditional double-ended &lsquo;boat&rsquo; bath</li>\r\n<li>Weight: 39kg</li>\r\n<li>Weight (with water): 231kg</li>\r\n<li>FA Chrome Foot</li>\r\n<li>Roll top finish</li>\r\n<li>Litres to Overflow: 192</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Tap Holes, Can be drilled on request</li>\r\n<li>Feet are manufactured using chrome plated aluminium</li>\r\n</ul>'),(16822,155,0,6356,'Exclude'),(16823,85,5,6357,'Royce Morgan Onyx Freestanding Bath 1700mm x 670mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16824,85,0,6357,'Royce Morgan Onyx Freestanding Bath 1700mm x 670mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16825,75,5,6357,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Onyx Freestanding Bath 1700mm x 670mm</strong></span></p>\r\n<p style=\"text-align: justify;\"> Royce Morgan Onyx bath is a unique effusion of gracefulness with a great sensation of tranquillity and warmth. The subtle design of this Onyx freestanding bath is quite catching and it can immediately enhance the design of any bathroom. It boasts distinctive thin edges and the excellent thermal properties of this bath are due to its manufacturing with European white double skinned sanitary grade acrylic. Taking bath in winters is not a big deal now as this exceptional bathtub retains water heat for a longer time than <strong>cast iron</strong> <strong>baths</strong>. It is suitable for freestanding or <a href=\"/taps/bathroom-taps/bath-taps/wall-hung-taps.html\" title=\"Wall Mounted Bath taps\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>wall mounted taps</strong> </span></a>only as there is no tap hole pre-drilled in it. Push button waste and integrated overflow are included in this double-ended bath as it renders 180 litres of water to overflow.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1700mm x Width 670mm x Height 600mm</li>\r\n<li>Litres to Overflow: 180</li>\r\n<li>Modern double-ended bath, complete with integrated overflow and push button waste</li>\r\n<li>Boasts distinctive thin edges</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16826,75,0,6357,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Onyx Freestanding Bath 1700mm x 670mm</strong></span></p>\r\n<p style=\"text-align: justify;\"> Royce Morgan Onyx bath is a unique effusion of gracefulness with a great sensation of tranquillity and warmth. The subtle design of this Onyx freestanding bath is quite catching and it can immediately enhance the design of any bathroom. It boasts distinctive thin edges and the excellent thermal properties of this bath are due to its manufacturing with European white double skinned sanitary grade acrylic. Taking bath in winters is not a big deal now as this exceptional bathtub retains water heat for a longer time than <strong>cast iron</strong> <strong>baths</strong>. It is suitable for freestanding or <a href=\"/taps/bathroom-taps/bath-taps/wall-hung-taps.html\" title=\"Wall Mounted Bath taps\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>wall mounted taps</strong> </span></a>only as there is no tap hole pre-drilled in it. Push button waste and integrated overflow are included in this double-ended bath as it renders 180 litres of water to overflow.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1700mm x Width 670mm x Height 600mm</li>\r\n<li>Litres to Overflow: 180</li>\r\n<li>Modern double-ended bath, complete with integrated overflow and push button waste</li>\r\n<li>Boasts distinctive thin edges</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16827,155,0,6357,'Exclude'),(16828,85,5,6358,'Royce Morgan Onyx Freestanding Bath 1700mm x 670mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16829,85,0,6358,'Royce Morgan Onyx Freestanding Bath 1700mm x 670mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16830,75,5,6358,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Opal Freestanding Bath 1790mm x 820mm</strong></span></p>\r\n<p style=\"text-align: justify;\">Give a new look to the design of your bathroom by bringing Royce Morgan Opal bath as it has distinctive features and elegant designing. More on the position of a freestanding bath can be easily changed anytime as it can be moved easily. Royce Morgan gave white colour to this elegant design for making it more eye-catching. It renders 200 litres of water to overflow and European white doubled skinned sanitary grade acrylic is used in its crafting as this material brings lots of advantages to this bathtub. It contains excellent thermal properties as well as retains water heat for longer than cast iron baths. It is suitable for freestanding or wall mounted taps only as tap holes are not drilled in it. Bring this simple yet <strong><a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\">elegant bathtub</span></a></strong> home by availing the incredible discount from the side of Banyo.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1790mm x Width 820mm x Height 630mm</li>\r\n<li>Litres to Overflow: 200</li>\r\n<li>Modern double-ended bath, complete with integrated overflow and push button waste</li>\r\n<li>Boasts distinctive thin edges</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16831,75,0,6358,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Opal Freestanding Bath 1790mm x 820mm</strong></span></p>\r\n<p style=\"text-align: justify;\">Give a new look to the design of your bathroom by bringing Royce Morgan Opal bath as it has distinctive features and elegant designing. More on the position of a freestanding bath can be easily changed anytime as it can be moved easily. Royce Morgan gave white colour to this elegant design for making it more eye-catching. It renders 200 litres of water to overflow and European white doubled skinned sanitary grade acrylic is used in its crafting as this material brings lots of advantages to this bathtub. It contains excellent thermal properties as well as retains water heat for longer than cast iron baths. It is suitable for freestanding or wall mounted taps only as tap holes are not drilled in it. Bring this simple yet <strong><a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\">elegant bathtub</span></a></strong> home by availing the incredible discount from the side of Banyo.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1790mm x Width 820mm x Height 630mm</li>\r\n<li>Litres to Overflow: 200</li>\r\n<li>Modern double-ended bath, complete with integrated overflow and push button waste</li>\r\n<li>Boasts distinctive thin edges</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16832,155,0,6358,'Exclude'),(16833,85,5,6359,'Royce Morgan Orlando Freestanding Bath 1380mm x 750mm - Orlando1380, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16834,85,0,6359,'Royce Morgan Orlando Freestanding Bath 1380mm x 750mm - Orlando1380, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16835,75,5,6359,'<style>#html-body [data-pb-style=G71STPC]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"G71STPC\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Royce Morgan Orlando Freestanding Bath 1380mm x 750mm</strong></span></p>\r\n<p style=\"text-align: justify;\">Orlando bath of Royce Morgan is quite famous as it has excellent designing and seamless beautiful curved shape. Feet of this bath are also very stylish whereas the roll top finish is making it more wonderful. 33kg is the weight of this <strong>single ended bath</strong> whereas its length is 1380mm and it has a width of 750mm. It will render 157 litres of water to overflow and the excellent thermal properties of this bath are due to high-quality manufacturing. European white double skinned sanitary grade acrylic is the material that is used in its crafting. Chrome plated aluminium is used in the manufacturing of its feet due to which they render maximum strength to this <a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>bath</strong></span></a>.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1380mm x Width 750mm x Height 590mm</li>\r\n<li>Traditional single-ended bath</li>\r\n<li>Weight: 33kg</li>\r\n<li>Weight (with water): 187kg</li>\r\n<li>Roll top finish</li>\r\n<li>Litres to Overflow: 157</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic:Feet are manufactured using chrome plated aluminium</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Feet are manufactured using chrome plated aluminium</li>\r\n<li><strong>Tap Holes can be drilled on request</strong></li>\r\n</ul></div></div></div>'),(16836,75,0,6359,'<style>#html-body [data-pb-style=G71STPC]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"G71STPC\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Royce Morgan Orlando Freestanding Bath 1380mm x 750mm</strong></span></p>\r\n<p style=\"text-align: justify;\">Orlando bath of Royce Morgan is quite famous as it has excellent designing and seamless beautiful curved shape. Feet of this bath are also very stylish whereas the roll top finish is making it more wonderful. 33kg is the weight of this <strong>single ended bath</strong> whereas its length is 1380mm and it has a width of 750mm. It will render 157 litres of water to overflow and the excellent thermal properties of this bath are due to high-quality manufacturing. European white double skinned sanitary grade acrylic is the material that is used in its crafting. Chrome plated aluminium is used in the manufacturing of its feet due to which they render maximum strength to this <a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>bath</strong></span></a>.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1380mm x Width 750mm x Height 590mm</li>\r\n<li>Traditional single-ended bath</li>\r\n<li>Weight: 33kg</li>\r\n<li>Weight (with water): 187kg</li>\r\n<li>Roll top finish</li>\r\n<li>Litres to Overflow: 157</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic:Feet are manufactured using chrome plated aluminium</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>Feet are manufactured using chrome plated aluminium</li>\r\n<li><strong>Tap Holes can be drilled on request</strong></li>\r\n</ul></div></div></div>'),(16837,155,0,6359,'Exclude'),(16838,85,5,6360,'Royce Morgan Quartz Freestanding Bath 1760mm x 680mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16839,85,0,6360,'Royce Morgan Quartz Freestanding Bath 1760mm x 680mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16840,75,5,6360,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Quartz Freestanding Bath 1760mm x 680mm</strong></span></p>\r\n<p style=\"text-align: justify;\">Quartz is an exciting range of <strong>Royce Morgan Bath</strong> as its designing is unique and its features are distinctive. Dimensions are crucial while manufacturing any bath. 1760mm is the length of this bath whereas its width is 680mm and the height of this bath is 565mm. It incorporates a defined tap platform. The European white double skinned sanitary grade acrylic is used in its overall manufacturing that brings excellent thermal properties to it. Quartz&nbsp;<a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>bathtub</strong></span></a> retains water heat for longer than cast iron baths. There is no pre-drilled tap hole so it is suitable for freestanding or wall mounted taps only. Bring this functional bathtub to home and give a new exciting look to your bathroom.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1760mm x Width 680mm x Height 670mm</li>\r\n<li>Litres to Overflow: 170</li>\r\n<li>Contemporary double-ended bath, complete with integrated overflow and push button waste</li>\r\n<li>Boasts distinctive thin edges</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16841,75,0,6360,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Quartz Freestanding Bath 1760mm x 680mm</strong></span></p>\r\n<p style=\"text-align: justify;\">Quartz is an exciting range of <strong>Royce Morgan Bath</strong> as its designing is unique and its features are distinctive. Dimensions are crucial while manufacturing any bath. 1760mm is the length of this bath whereas its width is 680mm and the height of this bath is 565mm. It incorporates a defined tap platform. The European white double skinned sanitary grade acrylic is used in its overall manufacturing that brings excellent thermal properties to it. Quartz&nbsp;<a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>bathtub</strong></span></a> retains water heat for longer than cast iron baths. There is no pre-drilled tap hole so it is suitable for freestanding or wall mounted taps only. Bring this functional bathtub to home and give a new exciting look to your bathroom.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1760mm x Width 680mm x Height 670mm</li>\r\n<li>Litres to Overflow: 170</li>\r\n<li>Contemporary double-ended bath, complete with integrated overflow and push button waste</li>\r\n<li>Boasts distinctive thin edges</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16842,155,0,6360,'Exclude'),(16843,85,5,6361,'Royce Morgan Ruby Freestanding Bath 1580mm x 740mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16844,85,0,6361,'Royce Morgan Ruby Freestanding Bath 1580mm x 740mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16845,75,5,6361,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Ruby Freestanding Bath 1580mm x 740mm</strong></span></p>\r\n<p style=\"text-align: justify;\">The design of a bathtub matters a lot in the overall appearance of any bathroom so Royce Morgan has designed a unique Ruby bathtub for people who want to give a luxurious touch to their bathroom. The excellent thermal properties of this bath are due to its manufacturing with European white double skinned sanitary grade acrylic that renders unbeatable benefits to it. Tap holes are not pre-drilled in it so you will find it suitable for freestanding or wall mounted taps only. <a href=\"/brands/royce-morgan.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>Royce Morgan</strong></span></a> is rendering a whopping guarantee of a lifetime against any manufacturing fault to bring you peace of mind. This <strong>contemporary slipper bath</strong>renders 228 litres of water to outflow and Banyo is offering an incredible discount on it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1580mm x Width 740mm x Height 550mm</li>\r\n<li>Contemporary double-ended bath, complete with integrated overflow and push button waste</li>\r\n<li>Litres to Overflow: 228</li>\r\n<li>Contemporary slipper bath</li>\r\n<li>Boasts distinctive thin edges</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16846,75,0,6361,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Ruby Freestanding Bath 1580mm x 740mm</strong></span></p>\r\n<p style=\"text-align: justify;\">The design of a bathtub matters a lot in the overall appearance of any bathroom so Royce Morgan has designed a unique Ruby bathtub for people who want to give a luxurious touch to their bathroom. The excellent thermal properties of this bath are due to its manufacturing with European white double skinned sanitary grade acrylic that renders unbeatable benefits to it. Tap holes are not pre-drilled in it so you will find it suitable for freestanding or wall mounted taps only. <a href=\"/brands/royce-morgan.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>Royce Morgan</strong></span></a> is rendering a whopping guarantee of a lifetime against any manufacturing fault to bring you peace of mind. This <strong>contemporary slipper bath</strong>renders 228 litres of water to outflow and Banyo is offering an incredible discount on it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1580mm x Width 740mm x Height 550mm</li>\r\n<li>Contemporary double-ended bath, complete with integrated overflow and push button waste</li>\r\n<li>Litres to Overflow: 228</li>\r\n<li>Contemporary slipper bath</li>\r\n<li>Boasts distinctive thin edges</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16847,155,0,6361,'Exclude'),(16848,85,5,6362,'Royce Morgan Sunstone Freestanding Bath 1590mm x 700mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16849,85,0,6362,'Royce Morgan Sunstone Freestanding Bath 1590mm x 700mm, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16850,75,5,6362,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Sunstone Freestanding Bath 1590mm x 700mm</strong></span></p>\r\n<p style=\"text-align: justify;\"> Royce Morgan Sunstone Bath is a bathtub that can render you both style and comfort as it is designed in a distinctive way. It has a comfortable back and seamless round curves that can give an absolutely great touch to your bathroom. Push button waste and integrated overflow are added to this <span style=\"color: #3366ff;\"><a href=\"/brands/royce-morgan.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>contemporary bath</strong></span></a></span> whereas it boasts distinctive thin edges. The excellent thermal properties of this bath are due to its manufacturing with European double skinned sanitary grade acrylic that also makes it able to retain water heat for a longer time than any other cast iron bath. It renders 216 litres of water to overflow. It can be easily maintained and cleaned. The length of this bathtub is 1590 whereas its width is 700mm and the height of this bath is 780mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1590mm x Width 700mm x Height 780mm</li>\r\n<li>Litres to Overflow: 216</li>\r\n<li>Contemporary slipper bath, complete with integrated overflow and push button waste</li>\r\n<li>Boasts distinctive thin edges</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16851,75,0,6362,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Sunstone Freestanding Bath 1590mm x 700mm</strong></span></p>\r\n<p style=\"text-align: justify;\"> Royce Morgan Sunstone Bath is a bathtub that can render you both style and comfort as it is designed in a distinctive way. It has a comfortable back and seamless round curves that can give an absolutely great touch to your bathroom. Push button waste and integrated overflow are added to this <span style=\"color: #3366ff;\"><a href=\"/brands/royce-morgan.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>contemporary bath</strong></span></a></span> whereas it boasts distinctive thin edges. The excellent thermal properties of this bath are due to its manufacturing with European double skinned sanitary grade acrylic that also makes it able to retain water heat for a longer time than any other cast iron bath. It renders 216 litres of water to overflow. It can be easily maintained and cleaned. The length of this bathtub is 1590 whereas its width is 700mm and the height of this bath is 780mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1590mm x Width 700mm x Height 780mm</li>\r\n<li>Litres to Overflow: 216</li>\r\n<li>Contemporary slipper bath, complete with integrated overflow and push button waste</li>\r\n<li>Boasts distinctive thin edges</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16852,155,0,6362,'Exclude'),(16853,85,5,6363,'Royce Morgan Westminster Double Ended Acrylic Bath 1490 x 850mm'),(16854,85,0,6363,'Royce Morgan Westminster Double Ended Acrylic Bath 1490 x 850mm'),(16855,75,5,6363,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Westminster Freestanding Bath 149cm x 85cm</strong></span></p>\r\n<p style=\"text-align: justify;\"> Royce Morgan Westminster bath is an oval shaped bath with flawless dimensions and features. This <strong>contemporary</strong> double ended bath has the weight of 35kg. This <a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>luxurious bathtub</strong> </span></a>has no feet as well as it is easy to be cleaned and maintained. The material used in its manufacturing is European white double skinned sanitary grade acrylic that brings excellent thermal properties to it. It has the efficiency to retain water heat for longer than cast iron baths. Tap holes are not pre-drilled in it and it is suitable for wall mounted taps or freestanding only. Royce Morgan renders a whopping guarantee of a lifetime for your peace of mind.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1490mm x Width 850mm x Height 580mm</li>\r\n<li>Contemporary double-ended bath</li>\r\n<li>Weight: 35kg</li>\r\n<li>Weight (with water): 195kg</li>\r\n<li>Flat top finish</li>\r\n<li>Litres to Overflow: 160</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16856,75,0,6363,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Westminster Freestanding Bath 149cm x 85cm</strong></span></p>\r\n<p style=\"text-align: justify;\"> Royce Morgan Westminster bath is an oval shaped bath with flawless dimensions and features. This <strong>contemporary</strong> double ended bath has the weight of 35kg. This <a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>luxurious bathtub</strong> </span></a>has no feet as well as it is easy to be cleaned and maintained. The material used in its manufacturing is European white double skinned sanitary grade acrylic that brings excellent thermal properties to it. It has the efficiency to retain water heat for longer than cast iron baths. Tap holes are not pre-drilled in it and it is suitable for wall mounted taps or freestanding only. Royce Morgan renders a whopping guarantee of a lifetime for your peace of mind.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1490mm x Width 850mm x Height 580mm</li>\r\n<li>Contemporary double-ended bath</li>\r\n<li>Weight: 35kg</li>\r\n<li>Weight (with water): 195kg</li>\r\n<li>Flat top finish</li>\r\n<li>Litres to Overflow: 160</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16857,155,0,6363,'Exclude'),(16858,85,5,6364,'Royce Morgan Westminster Freestanding Acrylic Bath 1860 x 880mm'),(16859,85,0,6364,'Royce Morgan Westminster Freestanding Acrylic Bath 1860 x 880mm'),(16860,75,5,6364,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Westminster Freestanding Bath 186cm x 88cm</strong></span></p>\r\n<p style=\"text-align: justify;\">A bath can really turn the look of your ordinary bathroom into the most luxurious one but it can be possible only if you have an efficient bath. Royce Morgan Westminster bath will be an outstanding choice for your bathroom. It is manufactured by using European white double skinned sanitary grade acrylic that has excellent thermal properties. This alluring bathtub retains water heat for longer than cast iron baths. The length of this functional bathtub is 1860mm whereas its width is 880mm and the height of this bath is 590mm. It is suitable for freestanding or wall mounted taps only as there is no tap hole pre-drilled in it. Royce Morgan is offering a whopping guarantee of a lifetime on it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1860mm x Width 880mm x Height 590mm</li>\r\n<li>Contemporary double-ended bath</li>\r\n<li>Weight: 45kg</li>\r\n<li>Weight (with water): 238kg</li>\r\n<li>Flat top finish</li>\r\n<li>Litres to Overflow: 193</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16861,75,0,6364,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Westminster Freestanding Bath 186cm x 88cm</strong></span></p>\r\n<p style=\"text-align: justify;\">A bath can really turn the look of your ordinary bathroom into the most luxurious one but it can be possible only if you have an efficient bath. Royce Morgan Westminster bath will be an outstanding choice for your bathroom. It is manufactured by using European white double skinned sanitary grade acrylic that has excellent thermal properties. This alluring bathtub retains water heat for longer than cast iron baths. The length of this functional bathtub is 1860mm whereas its width is 880mm and the height of this bath is 590mm. It is suitable for freestanding or wall mounted taps only as there is no tap hole pre-drilled in it. Royce Morgan is offering a whopping guarantee of a lifetime on it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1860mm x Width 880mm x Height 590mm</li>\r\n<li>Contemporary double-ended bath</li>\r\n<li>Weight: 45kg</li>\r\n<li>Weight (with water): 238kg</li>\r\n<li>Flat top finish</li>\r\n<li>Litres to Overflow: 193</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps only</li>\r\n</ul>'),(16862,155,0,6364,'Exclude'),(16863,85,5,6365,'Royce Morgan Woburn Freestanding Bath 1490mm x 790mm - Woburn1490, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16864,85,0,6365,'Royce Morgan Woburn Freestanding Bath 1490mm x 790mm - Woburn1490, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16865,75,5,6365,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Woburn Freestanding Bath 149cm x 79cm</strong></span></p>\r\n<p style=\"text-align: justify;\">Enhance the look of your bathroom by installing Royce Morgan Woburn freestanding bath as its incredible features cannot be compared with any other bath. The weight of this contemporary double ended bath is 34kg and it incorporates a defined tap platform. Feet are not required for placing this bath whereas the European white double skinned sanitary grade acrylic is used in its overall manufacturing that brings excellent thermal properties to it. Woburn bathtub retains water heat for longer than cast iron <a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\"><strong><span style=\"color: #3366ff;\">baths</span></strong></a>. There is no pre-drilled tap hole so it is suitable for freestanding or wall mounted taps only. Royce Morgan is giving a guarantee of lifetime to bring you peace of mind.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1490mm x Width 790mm x Height 590mm</li>\r\n<li>Contemporary double-ended bath</li>\r\n<li>Weight: 34kg</li>\r\n<li>Weight (with water): 214kg</li>\r\n<li>Flat top finish</li>\r\n<li>Litres to Overflow: 180</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps</li>\r\n</ul>'),(16866,75,0,6365,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Woburn Freestanding Bath 149cm x 79cm</strong></span></p>\r\n<p style=\"text-align: justify;\">Enhance the look of your bathroom by installing Royce Morgan Woburn freestanding bath as its incredible features cannot be compared with any other bath. The weight of this contemporary double ended bath is 34kg and it incorporates a defined tap platform. Feet are not required for placing this bath whereas the European white double skinned sanitary grade acrylic is used in its overall manufacturing that brings excellent thermal properties to it. Woburn bathtub retains water heat for longer than cast iron <a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\"><strong><span style=\"color: #3366ff;\">baths</span></strong></a>. There is no pre-drilled tap hole so it is suitable for freestanding or wall mounted taps only. Royce Morgan is giving a guarantee of lifetime to bring you peace of mind.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1490mm x Width 790mm x Height 590mm</li>\r\n<li>Contemporary double-ended bath</li>\r\n<li>Weight: 34kg</li>\r\n<li>Weight (with water): 214kg</li>\r\n<li>Flat top finish</li>\r\n<li>Litres to Overflow: 180</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps</li>\r\n</ul>'),(16867,155,0,6365,'Exclude'),(16868,85,5,6366,'Royce Morgan Woburn Freestanding Bath 1675mm x 780mm - Woburn1675, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16869,85,0,6366,'Royce Morgan Woburn Freestanding Bath 1675mm x 780mm - Woburn1675, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16870,75,5,6366,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Woburn Freestanding Bath 1675mm x 780mm</strong></span></p>\r\n<p style=\"text-align: justify;\"> Royce Morgan Woburn bath is simple in design yet rich in looks. You can install it with any design of your bathroom whether it is classical, vintage, or modern as this bath is beyond compare. This <span style=\"color: #3366ff;\"><a href=\"/brands/royce-morgan.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>contemporary double ended bath</strong></span></a></span> has a flat top finish. European white double skinned sanitary grade acrylic is used in its construction that renders durability as well as functionality to it. The length of this bathtub is 1675mm whereas its width is 780mm and has a height of 540mm. The weight of this bath is 39kg and it renders 190 litres of water to overflow. It has excellent thermal properties as well as it can retain water heat for a longer time than other cast iron baths.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1675mm x Width 780mm x Height 540mm</li>\r\n<li>Contemporary double-ended bath</li>\r\n<li>Weight: 39kg</li>\r\n<li>Weight (with water): 229kg</li>\r\n<li>Flat top finish</li>\r\n<li>Litres to Overflow: 190</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps</li>\r\n</ul>'),(16871,75,0,6366,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Woburn Freestanding Bath 1675mm x 780mm</strong></span></p>\r\n<p style=\"text-align: justify;\"> Royce Morgan Woburn bath is simple in design yet rich in looks. You can install it with any design of your bathroom whether it is classical, vintage, or modern as this bath is beyond compare. This <span style=\"color: #3366ff;\"><a href=\"/brands/royce-morgan.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>contemporary double ended bath</strong></span></a></span> has a flat top finish. European white double skinned sanitary grade acrylic is used in its construction that renders durability as well as functionality to it. The length of this bathtub is 1675mm whereas its width is 780mm and has a height of 540mm. The weight of this bath is 39kg and it renders 190 litres of water to overflow. It has excellent thermal properties as well as it can retain water heat for a longer time than other cast iron baths.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1675mm x Width 780mm x Height 540mm</li>\r\n<li>Contemporary double-ended bath</li>\r\n<li>Weight: 39kg</li>\r\n<li>Weight (with water): 229kg</li>\r\n<li>Flat top finish</li>\r\n<li>Litres to Overflow: 190</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps</li>\r\n</ul>'),(16872,155,0,6366,'Exclude'),(16873,85,5,6367,'Royce Morgan Woburn Freestanding Bath 1765mm x 800mm - Woburn1765, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16874,85,0,6367,'Royce Morgan Woburn Freestanding Bath 1765mm x 800mm - Woburn1765, Banyo, Royce Morgan, banyo.co.uk, Freestanding Bath'),(16875,75,5,6367,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Woburn Freestanding Bath 1765mm x 800mm</strong></span></p>\r\n<p style=\"text-align: justify;\">Give a more exciting look to your bathroom by installing a Royce Morgan Woburn bath that has a unique seamless oval design. Feet are not required for placing this bath and it is a<span style=\"color: #3366ff;\"> <a href=\"/bathroom/baths/free-standing-baths.html\" target=\"_blank\"><span style=\"color: #3366ff;\"> freestanding bath</span></a> </span>that occupies less space but renders more functionality to your bathroom as you can easily enter into it for enjoying a comfortable bath. European white double skinned sanitary grade acrylic is used in the manufacturing of this Woburn bath due to which it renders extra durability and functionality. This Royce Morgan has Flamboyant European design with oval styling that can upgrade the design of any bathroom to a modern level. The base of this bath is manufactured from solid oak wood. It is the perfect time to bring it home as Banyo is offering incredible discounts on it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1765mm x Width 800mm x Height 560mm</li>\r\n<li>Contemporary double-ended bath</li>\r\n<li>Weight: 41kg</li>\r\n<li>Weight (with water): 236kg</li>\r\n<li>Flat top finish</li>\r\n<li>Litres to Overflow: 195</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps</li>\r\n</ul>'),(16876,75,0,6367,'<p><span style=\"font-size: medium;\"><strong>Royce Morgan Woburn Freestanding Bath 1765mm x 800mm</strong></span></p>\r\n<p style=\"text-align: justify;\">Give a more exciting look to your bathroom by installing a Royce Morgan Woburn bath that has a unique seamless oval design. Feet are not required for placing this bath and it is a<span style=\"color: #3366ff;\"> <a href=\"/bathroom/baths/free-standing-baths.html\" target=\"_blank\"><span style=\"color: #3366ff;\"> freestanding bath</span></a> </span>that occupies less space but renders more functionality to your bathroom as you can easily enter into it for enjoying a comfortable bath. European white double skinned sanitary grade acrylic is used in the manufacturing of this Woburn bath due to which it renders extra durability and functionality. This Royce Morgan has Flamboyant European design with oval styling that can upgrade the design of any bathroom to a modern level. The base of this bath is manufactured from solid oak wood. It is the perfect time to bring it home as Banyo is offering incredible discounts on it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Size: Length 1765mm x Width 800mm x Height 560mm</li>\r\n<li>Contemporary double-ended bath</li>\r\n<li>Weight: 41kg</li>\r\n<li>Weight (with water): 236kg</li>\r\n<li>Flat top finish</li>\r\n<li>Litres to Overflow: 195</li>\r\n<li>Manufactured using European white double skinned sanitary grade acrylic</li>\r\n<li>Excellent thermal properties</li>\r\n<li>Will retain water heat for longer than cast iron baths</li>\r\n<li>Easy to clean and maintain</li>\r\n<li>No tap holes, suitable for freestanding or wall mounted taps</li>\r\n</ul>'),(16877,155,0,6367,'Exclude'),(16878,85,5,6368,'Premier Asselby Square  Acrylic Bath with Leg Set 170 x 70cm'),(16879,85,0,6368,'Premier Asselby Square  Acrylic Bath with Leg Set 170 x 70cm'),(16880,75,5,6368,'<p><span style=\"font-size: medium;\"><strong>Premier Asselby Square Acrylic Bath with Leg Set 170 x 70cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Supplied with legset</li>\r\n<li>Double ended bath</li>\r\n<li>Bath panel sold separately</li>\r\n<li>Material thickness: 4mm</li>\r\n<li>Volume (literage): 161L </li>\r\n<li>Displaced capacity: 91L</li>\r\n<li>Square bath shape</li>\r\n<li>Supplied un-drilled for taps</li>\r\n<li>Suitable for use with bath screens</li>\r\n<li>waste positioned in centre of bath</li>\r\n<li>Bath material colour: European white</li>\r\n<li>Manufactured from sanitary grade acrylic</li>\r\n<li>5 years guarantee</li>\r\n</ul>'),(16881,75,0,6368,'<p><span style=\"font-size: medium;\"><strong>Premier Asselby Square Acrylic Bath with Leg Set 170 x 70cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Supplied with legset</li>\r\n<li>Double ended bath</li>\r\n<li>Bath panel sold separately</li>\r\n<li>Material thickness: 4mm</li>\r\n<li>Volume (literage): 161L </li>\r\n<li>Displaced capacity: 91L</li>\r\n<li>Square bath shape</li>\r\n<li>Supplied un-drilled for taps</li>\r\n<li>Suitable for use with bath screens</li>\r\n<li>waste positioned in centre of bath</li>\r\n<li>Bath material colour: European white</li>\r\n<li>Manufactured from sanitary grade acrylic</li>\r\n<li>5 years guarantee</li>\r\n</ul>'),(16882,155,0,6368,'Exclude'),(16883,85,5,6369,'Premier Asselby Square Acrylic Bath with Leg Set 170cm x 75cm'),(16884,85,0,6369,'Premier Asselby Square Acrylic Bath with Leg Set 170cm x 75cm'),(16885,75,5,6369,'<p><span style=\"font-size: medium;\"><strong>Premier Asselby Square Acrylic Bath with Leg Set 170cm x 75cm - NBA210</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Double ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 179L </li>\n<li>Displaced capacity: 109L</li>\n<li>Square bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in centre of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16886,75,0,6369,'<p><span style=\"font-size: medium;\"><strong>Premier Asselby Square Acrylic Bath with Leg Set 170cm x 75cm - NBA210</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Double ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 179L </li>\n<li>Displaced capacity: 109L</li>\n<li>Square bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in centre of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16887,155,0,6369,'Exclude'),(16888,85,5,6370,'Premier Asselby Square Acrylic Bath with Leg Set 180cm x 80cm'),(16889,85,0,6370,'Premier Asselby Square Acrylic Bath with Leg Set 180cm x 80cm'),(16890,75,5,6370,'<p><span style=\"font-size: medium;\"><strong>Premier Asselby Square Acrylic Bath with Leg Set 180cm x 80cm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Double ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 216L </li>\n<li>Displaced capacity: 146L</li>\n<li>Square bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in centre of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16891,75,0,6370,'<p><span style=\"font-size: medium;\"><strong>Premier Asselby Square Acrylic Bath with Leg Set 180cm x 80cm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Double ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 216L </li>\n<li>Displaced capacity: 146L</li>\n<li>Square bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in centre of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16892,155,0,6370,'Exclude'),(16893,85,5,6371,'Premier Barmby Round Acrylic Bath with Leg Set 150cm x 70cm '),(16894,85,0,6371,'Premier Barmby Round Acrylic Bath with Leg Set 150cm x 70cm '),(16895,75,5,6371,'<p><span style=\"font-size: medium;\"><strong>Premier Barmby Round Acrylic Bath with Leg Set 150cm x 70cm </strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Single ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 131L </li>\n<li>Displaced capacity: 61L</li>\n<li>Round bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in end of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16896,75,0,6371,'<p><span style=\"font-size: medium;\"><strong>Premier Barmby Round Acrylic Bath with Leg Set 150cm x 70cm </strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Single ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 131L </li>\n<li>Displaced capacity: 61L</li>\n<li>Round bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in end of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16897,155,0,6371,'Exclude'),(16898,85,5,6372,'Premier Barmby Round Acrylic Bath with Leg Set 160cm x 70cm '),(16899,85,0,6372,'Premier Barmby Round Acrylic Bath with Leg Set 160cm x 70cm '),(16900,75,5,6372,'<p><span style=\"font-size: medium;\"><strong>Premier Barmby Round Single Ended Acrylic Bath 160cm x 70cm </strong></span></p>\r\n<p>When designer class, meets with magnificent elegance, you get this dazzlingly impressive <a title=\"Premier\" href=\"/brands/premier.html\" target=\"_blank\"><strong>Premier</strong></a> Barmby Round Single Ended Acrylic Bath. Made from durable, high quality Lucite acrylic, this charming bathroom beauty is finished in scintillating high gloss white.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Supplied with legset</li>\r\n<li>Single ended bath</li>\r\n<li>Bath panel sold separately</li>\r\n<li>Material thickness: 4mm</li>\r\n<li>Volume (literage): 136L </li>\r\n<li>Displaced capacity: 66L</li>\r\n<li>Round bath shape</li>\r\n<li>Supplied un-drilled for taps</li>\r\n<li>Suitable for use with bath screens</li>\r\n<li>waste positioned in end of bath</li>\r\n<li>Bath material colour: European white</li>\r\n<li>Manufactured from sanitary grade acrylic</li>\r\n<li>5 year guarantee</li>\r\n</ul>'),(16901,75,0,6372,'<p><span style=\"font-size: medium;\"><strong>Premier Barmby Round Single Ended Acrylic Bath 160cm x 70cm </strong></span></p>\r\n<p>When designer class, meets with magnificent elegance, you get this dazzlingly impressive <a title=\"Premier\" href=\"/brands/premier.html\" target=\"_blank\"><strong>Premier</strong></a> Barmby Round Single Ended Acrylic Bath. Made from durable, high quality Lucite acrylic, this charming bathroom beauty is finished in scintillating high gloss white.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Supplied with legset</li>\r\n<li>Single ended bath</li>\r\n<li>Bath panel sold separately</li>\r\n<li>Material thickness: 4mm</li>\r\n<li>Volume (literage): 136L </li>\r\n<li>Displaced capacity: 66L</li>\r\n<li>Round bath shape</li>\r\n<li>Supplied un-drilled for taps</li>\r\n<li>Suitable for use with bath screens</li>\r\n<li>waste positioned in end of bath</li>\r\n<li>Bath material colour: European white</li>\r\n<li>Manufactured from sanitary grade acrylic</li>\r\n<li>5 year guarantee</li>\r\n</ul>'),(16902,155,0,6372,'Exclude'),(16903,85,5,6373,'Premier Barmby Round Acrylic Bath with Leg Set 170cm x 70cm '),(16904,85,0,6373,'Premier Barmby Round Acrylic Bath with Leg Set 170cm x 70cm '),(16905,75,5,6373,'<p><span style=\"font-size: medium;\"><strong>Premier Barmby Round Acrylic Bath with Leg Set 170cm x 70cm </strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Single ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 147L </li>\n<li>Displaced capacity: 77L</li>\n<li>Round bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in end of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16906,75,0,6373,'<p><span style=\"font-size: medium;\"><strong>Premier Barmby Round Acrylic Bath with Leg Set 170cm x 70cm </strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Single ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 147L </li>\n<li>Displaced capacity: 77L</li>\n<li>Round bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in end of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16907,155,0,6373,'Exclude'),(16908,85,5,6374,'Premier Barmby Round Acrylic Bath with Leg Set 170cm x 75cm'),(16909,85,0,6374,'Premier Barmby Round Acrylic Bath with Leg Set 170cm x 75cm'),(16910,75,5,6374,'<p><span style=\"font-size: medium;\"><strong>Premier Barmby Round Acrylic Bath with Leg Set 170cm x 75cm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Single ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 158L </li>\n<li>Displaced capacity: 88L</li>\n<li>Round bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in end of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16911,75,0,6374,'<p><span style=\"font-size: medium;\"><strong>Premier Barmby Round Acrylic Bath with Leg Set 170cm x 75cm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Single ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 158L </li>\n<li>Displaced capacity: 88L</li>\n<li>Round bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in end of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16912,155,0,6374,'Exclude'),(16913,85,5,6375,'Premier Barmby Round Acrylic Bath with Leg Set 180cm x 80cm '),(16914,85,0,6375,'Premier Barmby Round Acrylic Bath with Leg Set 180cm x 80cm '),(16915,75,5,6375,'<p><span style=\"font-size: medium;\"><strong>Premier Barmby Round Acrylic Bath with Leg Set 180cm x 80cm </strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Single ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 173L </li>\n<li>Displaced capacity: 103L</li>\n<li>Round bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in end of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16916,75,0,6375,'<p><span style=\"font-size: medium;\"><strong>Premier Barmby Round Acrylic Bath with Leg Set 180cm x 80cm </strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Single ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 173L </li>\n<li>Displaced capacity: 103L</li>\n<li>Round bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in end of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16917,155,0,6375,'Exclude'),(16918,85,5,6376,'Premier Linton Square Acrylic Bath & Leg Set 1500mm x 700mm'),(16919,85,0,6376,'Premier Linton Square Acrylic Bath & Leg Set 1500mm x 700mm'),(16920,75,5,6376,'<p><span style=\"font-size: medium;\"><strong>Premier Linton Square Acrylic Bath & Leg Set 1500mm x 700mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Supplied with legset</li>\r\n<li>Single ended bath</li>\r\n<li>Bath panel sold separately</li>\r\n<li>Material thickness: 4mm</li>\r\n<li>Volume (literage): 158L </li>\r\n<li>Displaced capacity: 88L</li>\r\n<li>Square bath shape</li>\r\n<li>Supplied un-drilled for taps</li>\r\n<li>Suitable for use with bath screens</li>\r\n<li>waste positioned in end of bath</li>\r\n<li>Bath material colour: European white</li>\r\n<li>Manufactured from sanitary grade acrylic</li>\r\n<li>5 year guarantee</li>\r\n</ul>'),(16921,75,0,6376,'<p><span style=\"font-size: medium;\"><strong>Premier Linton Square Acrylic Bath & Leg Set 1500mm x 700mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Supplied with legset</li>\r\n<li>Single ended bath</li>\r\n<li>Bath panel sold separately</li>\r\n<li>Material thickness: 4mm</li>\r\n<li>Volume (literage): 158L </li>\r\n<li>Displaced capacity: 88L</li>\r\n<li>Square bath shape</li>\r\n<li>Supplied un-drilled for taps</li>\r\n<li>Suitable for use with bath screens</li>\r\n<li>waste positioned in end of bath</li>\r\n<li>Bath material colour: European white</li>\r\n<li>Manufactured from sanitary grade acrylic</li>\r\n<li>5 year guarantee</li>\r\n</ul>'),(16922,155,0,6376,'Exclude'),(16923,85,5,6377,'Premier Linton Square Acrylic Bath with Leg Set 160 x 70cm'),(16924,85,0,6377,'Premier Linton Square Acrylic Bath with Leg Set 160 x 70cm'),(16925,75,5,6377,'<p><span style=\"font-size: medium;\"><strong>Premier Linton Square Acrylic Bath with Leg Set 160 x 70cm - N-NBA407</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Single ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 158L </li>\n<li>Displaced capacity: 88L</li>\n<li>Square bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in end of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16926,75,0,6377,'<p><span style=\"font-size: medium;\"><strong>Premier Linton Square Acrylic Bath with Leg Set 160 x 70cm - N-NBA407</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Single ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 158L </li>\n<li>Displaced capacity: 88L</li>\n<li>Square bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in end of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16927,155,0,6377,'Exclude'),(16928,85,5,6378,'Premier Linton Square Acrylic Bath with Leg Set 170cm x 70cm'),(16929,85,0,6378,'Premier Linton Square Acrylic Bath with Leg Set 170cm x 70cm'),(16930,75,5,6378,'<p><span style=\"font-size: medium;\"><strong>Premier Linton Square Acrylic Bath with Leg Set 170cm x 70cm - N-NBA409</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Supplied with legset</li>\r\n<li>Single ended bath</li>\r\n<li>Bath panel sold separately</li>\r\n<li>Material thickness: 4mm</li>\r\n<li>Volume (literage): 178L </li>\r\n<li>Displaced capacity: 108L</li>\r\n<li>Square bath shape</li>\r\n<li>Supplied un-drilled for taps</li>\r\n<li>Suitable for use with bath screens</li>\r\n<li>waste positioned in end of bath</li>\r\n<li>Bath material colour: European white</li>\r\n<li>Manufactured from sanitary grade acrylic</li>\r\n<li>5 year guarantee</li>\r\n</ul>'),(16931,75,0,6378,'<p><span style=\"font-size: medium;\"><strong>Premier Linton Square Acrylic Bath with Leg Set 170cm x 70cm - N-NBA409</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Supplied with legset</li>\r\n<li>Single ended bath</li>\r\n<li>Bath panel sold separately</li>\r\n<li>Material thickness: 4mm</li>\r\n<li>Volume (literage): 178L </li>\r\n<li>Displaced capacity: 108L</li>\r\n<li>Square bath shape</li>\r\n<li>Supplied un-drilled for taps</li>\r\n<li>Suitable for use with bath screens</li>\r\n<li>waste positioned in end of bath</li>\r\n<li>Bath material colour: European white</li>\r\n<li>Manufactured from sanitary grade acrylic</li>\r\n<li>5 year guarantee</li>\r\n</ul>'),(16932,155,0,6378,'Exclude'),(16933,85,5,6379,'Premier Linton Square Acrylic Bath with Leg Set 170cm x 75cm'),(16934,85,0,6379,'Premier Linton Square Acrylic Bath with Leg Set 170cm x 75cm'),(16935,75,5,6379,'<p><span style=\"font-size: medium;\"><strong>Premier Linton Square Acrylic Bath with Leg Set 170cm x 75cm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Single ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 193L </li>\n<li>Displaced capacity: 123L</li>\n<li>Square bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in end of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16936,75,0,6379,'<p><span style=\"font-size: medium;\"><strong>Premier Linton Square Acrylic Bath with Leg Set 170cm x 75cm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Single ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 193L </li>\n<li>Displaced capacity: 123L</li>\n<li>Square bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in end of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16937,155,0,6379,'Exclude'),(16938,85,5,6380,'Premier Linton Square Acrylic Bath with Leg Set 180 x 80cm'),(16939,85,0,6380,'Premier Linton Square Acrylic Bath with Leg Set 180 x 80cm'),(16940,75,5,6380,'<p><span style=\"font-size: medium;\"><strong>Premier Linton Square Acrylic Bath with Leg Set 180 x 80cm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Single ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 218L </li>\n<li>Displaced capacity: 148L</li>\n<li>Square bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in end of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16941,75,0,6380,'<p><span style=\"font-size: medium;\"><strong>Premier Linton Square Acrylic Bath with Leg Set 180 x 80cm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Single ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 218L </li>\n<li>Displaced capacity: 148L</li>\n<li>Square bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Suitable for use with bath screens</li>\n<li>waste positioned in end of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16942,155,0,6380,'Exclude'),(16943,85,5,6381,'Premier Otley Round Acrylic Bath with Leg Set 170cm x 70cm'),(16944,85,0,6381,'Premier Otley Round Acrylic Bath with Leg Set 170cm x 70cm'),(16945,75,5,6381,'<p><span style=\"font-size: medium;\"><strong>Premier Otley Round Acrylic Bath with Leg Set 170cm x 70cm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Double ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 170L </li>\n<li>Displaced capacity: 100L</li>\n<li>Round bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Can be coordinated with a wall mounted bath filler</li>\n<li>waste positioned in centre of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16946,75,0,6381,'<p><span style=\"font-size: medium;\"><strong>Premier Otley Round Acrylic Bath with Leg Set 170cm x 70cm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Double ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 170L </li>\n<li>Displaced capacity: 100L</li>\n<li>Round bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Can be coordinated with a wall mounted bath filler</li>\n<li>waste positioned in centre of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16947,155,0,6381,'Exclude'),(16948,85,5,6382,'Premier Otley Round Acrylic Bath with Leg Set 170cm x 75cm'),(16949,85,0,6382,'Premier Otley Round Acrylic Bath with Leg Set 170cm x 75cm'),(16950,75,5,6382,'<p><span style=\"font-size: medium;\"><strong>Premier Otley Round Acrylic Bath with Leg Set 170cm x 75cm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Double ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 180L </li>\n<li>Displaced capacity: 110L</li>\n<li>Round bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Can be coordinated with a wall mounted bath filler</li>\n<li>waste positioned in centre of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16951,75,0,6382,'<p><span style=\"font-size: medium;\"><strong>Premier Otley Round Acrylic Bath with Leg Set 170cm x 75cm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Double ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 180L </li>\n<li>Displaced capacity: 110L</li>\n<li>Round bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Can be coordinated with a wall mounted bath filler</li>\n<li>waste positioned in centre of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16952,155,0,6382,'Exclude'),(16953,85,5,6383,'Premier Otley Round Acrylic Bath 180cm x 80cm'),(16954,85,0,6383,'Premier Otley Round Acrylic Bath 180cm x 80cm'),(16955,75,5,6383,'<p><span style=\"font-size: medium;\"><strong>Premier Otley Round Acrylic Bath with Leg Set 180cm x 80cm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Double ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 221L </li>\n<li>Displaced capacity: 151L</li>\n<li>Round bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Can be coordinated with a wall mounted bath filler</li>\n<li>waste positioned in centre of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16956,75,0,6383,'<p><span style=\"font-size: medium;\"><strong>Premier Otley Round Acrylic Bath with Leg Set 180cm x 80cm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Supplied with legset</li>\n<li>Double ended bath</li>\n<li>Bath panel sold separately</li>\n<li>Material thickness: 4mm</li>\n<li>Volume (literage): 221L </li>\n<li>Displaced capacity: 151L</li>\n<li>Round bath shape</li>\n<li>Supplied un-drilled for taps</li>\n<li>Can be coordinated with a wall mounted bath filler</li>\n<li>waste positioned in centre of bath</li>\n<li>Bath material colour: European white</li>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>5 year guarantee</li>\n</ul>'),(16957,155,0,6383,'Exclude'),(16958,85,5,6384,'RAK DKM Acrylic Bath ,Double Ended Acrylic Bath, NDKMBATH Acrylic Bath'),(16959,85,0,6384,'RAK DKM Acrylic Bath ,Double Ended Acrylic Bath, NDKMBATH Acrylic Bath'),(16960,76,5,6384,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(16961,76,0,6384,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(16962,75,5,6384,'<p><span style=\"font-size: medium;\"><strong>RAK DKM Double Ended Easyflow Bath 1800mm x 800mm</strong></span></p>\r\n<p>If you want to make your bath moments comfortable then <a href=\"/brands/rak-ceramics.html\" target=\"_blank\"><span style=\"color: #0000ff;\">RAK</span></a> DKM Double Ended Easyflow White Acrylic bath is an effective choice of yours. It has been designed according to latest designs and by taking deep care, it&rsquo;s manufacturing has done according to the UK-based Lucite International. The gelcoat finish of RAK DKM <span style=\"color: #0000ff;\"><a href=\"/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #0000ff;\">bath</span></a> </span>successfully maintains the durable and shiny look of it. Even after a long use, you can&rsquo;t judge that it&rsquo;s a new bath or the old one. For its manufacturing, superior quality vitreous china is used in it in order to enhance its overall flawless functioning.&nbsp;</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bathtub with centre waste position</li>\r\n<li>Supplied with adjustable support feet allowing total height of 500 - 550mm</li>\r\n<li>5mm easyflow acrylic bath</li>\r\n<li>Triple reinforced bath with an encapsulated gelcoat finish baseboard</li>\r\n<li>White colour bath</li>\r\n<li>Comes without tap holes</li>\r\n<li>25 years guarantee on bath</li>\r\n</ul>\r'),(16963,75,0,6384,'<p><span style=\"font-size: medium;\"><strong>RAK DKM Double Ended Easyflow Bath 1800mm x 800mm</strong></span></p>\r\n<p>If you want to make your bath moments comfortable then <a href=\"/brands/rak-ceramics.html\" target=\"_blank\"><span style=\"color: #0000ff;\">RAK</span></a> DKM Double Ended Easyflow White Acrylic bath is an effective choice of yours. It has been designed according to latest designs and by taking deep care, it&rsquo;s manufacturing has done according to the UK-based Lucite International. The gelcoat finish of RAK DKM <span style=\"color: #0000ff;\"><a href=\"/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #0000ff;\">bath</span></a> </span>successfully maintains the durable and shiny look of it. Even after a long use, you can&rsquo;t judge that it&rsquo;s a new bath or the old one. For its manufacturing, superior quality vitreous china is used in it in order to enhance its overall flawless functioning.&nbsp;</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bathtub with centre waste position</li>\r\n<li>Supplied with adjustable support feet allowing total height of 500 - 550mm</li>\r\n<li>5mm easyflow acrylic bath</li>\r\n<li>Triple reinforced bath with an encapsulated gelcoat finish baseboard</li>\r\n<li>White colour bath</li>\r\n<li>Comes without tap holes</li>\r\n<li>25 years guarantee on bath</li>\r\n</ul>\r'),(16964,155,0,6384,'Exclude'),(16965,85,5,6385,'RAK Metropolitan, Single Ended Easyflow Bath, White Acrylic Bath, NMETBATH '),(16966,85,0,6385,'RAK Metropolitan, Single Ended Easyflow Bath, White Acrylic Bath, NMETBATH '),(16967,76,5,6385,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(16968,76,0,6385,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(16969,75,5,6385,'<p><span style=\"font-size: medium;\"><strong>RAK Metropolitan Single Ended Easyflow 1800mm x 800mm</strong></span></p>\r\n<p><strong>RAK Metropolitan</strong> Single Ended Acrylic bath is more than just a practical bathing solution due to its cutting edge technical innovation. It is an exciting new addition in the range of <a href=\"/brands/rak-ceramics.html\" target=\"_blank\"><span style=\"color: #0000ff;\">RAK ceramics</span></a>. Its stylish innovative look with unique designing is quite eye-catching and is suitable for any bathroom d&eacute;cor. To stand the test time, its modern look has been built to give comfortable bathroom moments. It does not cover much space but gives effective use with easy water flow technology. Across the entire product range, it has increased depth which proves quite useful while bathing. It has suitable dimensions of 1800 x 800mm. The acrylic sheets used in it are manufactured according to UK-based Lucite international. RAK Metropolitan <a href=\"/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #0000ff;\">bath</span></a> has gel coat finish and it has an encapsulated baseboard with adjustable leg set. So just grab it anytime from the showroom of BANYO to make your bathroom more incredible.&nbsp;</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>5mm easyflow acrylic bath</li>\r\n<li>Triple reinforced bath with an encapsulated gel coat finish baseboard</li>\r\n<li>Bath comes without tap holes</li>\r\n<li>Single ended bath</li>\r\n<li>White finish bath</li>\r\n<li>25 years guarantee on bath</li>\r\n</ul>\r'),(16970,75,0,6385,'<p><span style=\"font-size: medium;\"><strong>RAK Metropolitan Single Ended Easyflow 1800mm x 800mm</strong></span></p>\r\n<p><strong>RAK Metropolitan</strong> Single Ended Acrylic bath is more than just a practical bathing solution due to its cutting edge technical innovation. It is an exciting new addition in the range of <a href=\"/brands/rak-ceramics.html\" target=\"_blank\"><span style=\"color: #0000ff;\">RAK ceramics</span></a>. Its stylish innovative look with unique designing is quite eye-catching and is suitable for any bathroom d&eacute;cor. To stand the test time, its modern look has been built to give comfortable bathroom moments. It does not cover much space but gives effective use with easy water flow technology. Across the entire product range, it has increased depth which proves quite useful while bathing. It has suitable dimensions of 1800 x 800mm. The acrylic sheets used in it are manufactured according to UK-based Lucite international. RAK Metropolitan <a href=\"/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #0000ff;\">bath</span></a> has gel coat finish and it has an encapsulated baseboard with adjustable leg set. So just grab it anytime from the showroom of BANYO to make your bathroom more incredible.&nbsp;</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>5mm easyflow acrylic bath</li>\r\n<li>Triple reinforced bath with an encapsulated gel coat finish baseboard</li>\r\n<li>Bath comes without tap holes</li>\r\n<li>Single ended bath</li>\r\n<li>White finish bath</li>\r\n<li>25 years guarantee on bath</li>\r\n</ul>\r'),(16971,155,0,6385,'Exclude'),(16972,85,5,6386,'RAK Metropolitan, Single Ended Acrylic Bath, NMETBATH, Metropolitan  Acrylic Bath'),(16973,85,0,6386,'RAK Metropolitan, Single Ended Acrylic Bath, NMETBATH, Metropolitan  Acrylic Bath'),(16974,76,5,6386,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(16975,76,0,6386,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(16976,75,5,6386,'<p><span style=\"font-size: medium;\"><strong>RAK Metropolitan Single Ended Bath Easyflow 1700mm x 700mm</strong></span></p>\r\n<p><strong>RAK Metropolitan</strong> Single Ended Acrylic <a href=\"/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #0000ff;\">bath</span></a> is more than just a practical bathing solution due to its cutting edge technical innovation. It is an exciting new addition in the range of <a href=\"/brands/rak-ceramics.html\" target=\"_blank\"><span style=\"color: #0000ff;\">RAK ceramics</span></a>. Its stylish innovative look with unique designing is quite eye-catching and is suitable for any bathroom d&eacute;cor. To stand the test time, its modern look has been built to give comfortable bathroom moments. It does not cover much space but gives effective use with easy water flow technology. Across the entire product range, it has increased depth which proves quite useful while bathing. The acrylic sheets used in it are manufactured according to UK-based Lucite international. RAK Metropolitan bath has gelcoat finish and it has an encapsulated baseboard with adjustable leg set. So just grab it anytime from the showroom of BANYO to make your bathroom more incredible.&nbsp;</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended design - waste positioned at one end, allowing relaxation at the other</li>\r\n<li>Stylish design suits modern and contemporary interiors</li>\r\n<li>5mm easyflow acrylic bath</li>\r\n<li>Bath in white finish</li>\r\n<li>Bath comes without tap holes</li>\r\n<li>25 years guarantee on bath</li>\r\n</ul>\r\n'),(16977,75,0,6386,'<p><span style=\"font-size: medium;\"><strong>RAK Metropolitan Single Ended Bath Easyflow 1700mm x 700mm</strong></span></p>\r\n<p><strong>RAK Metropolitan</strong> Single Ended Acrylic <a href=\"/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #0000ff;\">bath</span></a> is more than just a practical bathing solution due to its cutting edge technical innovation. It is an exciting new addition in the range of <a href=\"/brands/rak-ceramics.html\" target=\"_blank\"><span style=\"color: #0000ff;\">RAK ceramics</span></a>. Its stylish innovative look with unique designing is quite eye-catching and is suitable for any bathroom d&eacute;cor. To stand the test time, its modern look has been built to give comfortable bathroom moments. It does not cover much space but gives effective use with easy water flow technology. Across the entire product range, it has increased depth which proves quite useful while bathing. The acrylic sheets used in it are manufactured according to UK-based Lucite international. RAK Metropolitan bath has gelcoat finish and it has an encapsulated baseboard with adjustable leg set. So just grab it anytime from the showroom of BANYO to make your bathroom more incredible.&nbsp;</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended design - waste positioned at one end, allowing relaxation at the other</li>\r\n<li>Stylish design suits modern and contemporary interiors</li>\r\n<li>5mm easyflow acrylic bath</li>\r\n<li>Bath in white finish</li>\r\n<li>Bath comes without tap holes</li>\r\n<li>25 years guarantee on bath</li>\r\n</ul>\r\n'),(16978,155,0,6386,'Exclude'),(16979,85,5,6387,'RAK Orient Acrylic Bath, Single Ended Acrylic Bath, White Acrylic Bath, NORIBATH'),(16980,85,0,6387,'RAK Orient Acrylic Bath, Single Ended Acrylic Bath, White Acrylic Bath, NORIBATH'),(16981,76,5,6387,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(16982,76,0,6387,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(16983,75,5,6387,'<p><span style=\"font-size: medium;\"><strong>RAK Orient Single Ended Easyflow White Acrylic Bath - BT01AAWHA</strong></span></p>\n<p>Latest <a href=\"/bathroom.html\" target=\"_blank\"><span style=\"color: #0000ff;\">bathroom</span></a> fashion look is possible in any bathroom by installing <strong>RAK Orient</strong> Single Ended Acrylic <a href=\"/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #0000ff;\">Bath</span></a>. It has been manufactured from 5mm easyflow acrylic which increases its overall worth. It&rsquo;s installing will give you a luxurious statement in your bathroom. It really offers you a room for totally relax in and its bright white finish and modern lines present a perfect picture of the unique, stylish and highly practical bathtub. So just don&rsquo;t miss this amazing opportunity and avail it from BANYO at very affordable price.&nbsp;</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Stylish design suits modern and contemporary interiors</li>\n<li>Single ended bath</li>\n<li>5mm easyflow acrylic bath</li>\n<li>Triple reinforced bath with an encapsulated gelcoat finish baseboard</li>\n<li>White colour bath</li>\n<li>Comes without tap holes</li>\n<li>25 years guarantee on bath</li>\n</ul>\n'),(16984,75,0,6387,'<p><span style=\"font-size: medium;\"><strong>RAK Orient Single Ended Easyflow White Acrylic Bath - BT01AAWHA</strong></span></p>\n<p>Latest <a href=\"/bathroom.html\" target=\"_blank\"><span style=\"color: #0000ff;\">bathroom</span></a> fashion look is possible in any bathroom by installing <strong>RAK Orient</strong> Single Ended Acrylic <a href=\"/bathroom/baths.html\" target=\"_blank\"><span style=\"color: #0000ff;\">Bath</span></a>. It has been manufactured from 5mm easyflow acrylic which increases its overall worth. It&rsquo;s installing will give you a luxurious statement in your bathroom. It really offers you a room for totally relax in and its bright white finish and modern lines present a perfect picture of the unique, stylish and highly practical bathtub. So just don&rsquo;t miss this amazing opportunity and avail it from BANYO at very affordable price.&nbsp;</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Stylish design suits modern and contemporary interiors</li>\n<li>Single ended bath</li>\n<li>5mm easyflow acrylic bath</li>\n<li>Triple reinforced bath with an encapsulated gelcoat finish baseboard</li>\n<li>White colour bath</li>\n<li>Comes without tap holes</li>\n<li>25 years guarantee on bath</li>\n</ul>\n'),(16985,155,0,6387,'Exclude'),(16986,85,5,6388,' Roca Contesa Steel Bath, Roca Steel Bath,Contesa Steel Bath, Cheap Roca Steel Bath, Buy Contesa Steel Bath'),(16987,85,0,6388,' Roca Contesa Steel Bath, Roca Steel Bath,Contesa Steel Bath, Cheap Roca Steel Bath, Buy Contesa Steel Bath'),(16988,75,5,6388,'<p><span style=\"font-size: medium;\"><strong>Roca Contesa Steel Bath 170cm x 70cm - 2370J 2370K</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>Finish : White</li>\n<li>Without taphole.</li>\n<li>Rectangular bath.</li>\n<li>Made of 2mm steel sheet.</li>\n<li>Available options: with Antislip, without Antislip</li>\n<li>Water capacity to overflow: 195 litres</li>\n</ul>\n'),(16989,75,0,6388,'<p><span style=\"font-size: medium;\"><strong>Roca Contesa Steel Bath 170cm x 70cm - 2370J 2370K</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>Finish : White</li>\n<li>Without taphole.</li>\n<li>Rectangular bath.</li>\n<li>Made of 2mm steel sheet.</li>\n<li>Available options: with Antislip, without Antislip</li>\n<li>Water capacity to overflow: 195 litres</li>\n</ul>\n'),(16990,155,0,6388,'Exclude'),(16991,85,5,6389,'Roca Bathroom sinks, Roca bath tubsRoca The Gap Single Ended Acrylic Bath 1700mm x 700mm,'),(16992,85,0,6389,'Roca Bathroom sinks, Roca bath tubsRoca The Gap Single Ended Acrylic Bath 1700mm x 700mm,'),(16993,75,5,6389,'<p><span style=\"font-size: medium;\"><strong>Roca The Gap Acrylic Bath 170cm x 70cm no Tap Hole - 24717000 </strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>White finish</li>\n<li>Material: Acrylic</li>\n<li>Sound insulation</li>\n<li>Water capacity to overflow (l): 228 litres</li>\n<li>Bath has fully encapsulated baseboards and adjustable feet</li>\n</ul>\n'),(16994,75,0,6389,'<p><span style=\"font-size: medium;\"><strong>Roca The Gap Acrylic Bath 170cm x 70cm no Tap Hole - 24717000 </strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>White finish</li>\n<li>Material: Acrylic</li>\n<li>Sound insulation</li>\n<li>Water capacity to overflow (l): 228 litres</li>\n<li>Bath has fully encapsulated baseboards and adjustable feet</li>\n</ul>\n'),(16995,155,0,6389,'Exclude'),(16996,85,5,6390,'Roca The Gap Double Ended Acrylic Bath 1700mm x 750mm,Roca Bathroom spares, cheap Bathrooms uk'),(16997,85,0,6390,'Roca The Gap Double Ended Acrylic Bath 1700mm x 750mm,Roca Bathroom spares, cheap Bathrooms uk'),(16998,75,5,6390,'<p><span style=\"font-size: medium;\"><strong>Roca The Gap Acrylic Bath 170cm x 75cm No Tap Hole - 24719000 </strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Double ended bath</li>\n<li>White finish</li>\n<li>Material: Acrylic</li>\n<li>Shape: Rectangular</li>\n<li>Sound insulation</li>\n<li>Water capacity to overflow (l): 190 litre</li>\n<li>Installation structure: with feet</li>\n<li>Installation type: drop-in or with front panel</li>\n<li>Bath has fully encapsulated baseboards and adjustable feet</li>\n</ul>\n'),(16999,75,0,6390,'<p><span style=\"font-size: medium;\"><strong>Roca The Gap Acrylic Bath 170cm x 75cm No Tap Hole - 24719000 </strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Double ended bath</li>\n<li>White finish</li>\n<li>Material: Acrylic</li>\n<li>Shape: Rectangular</li>\n<li>Sound insulation</li>\n<li>Water capacity to overflow (l): 190 litre</li>\n<li>Installation structure: with feet</li>\n<li>Installation type: drop-in or with front panel</li>\n<li>Bath has fully encapsulated baseboards and adjustable feet</li>\n</ul>\n'),(17000,155,0,6390,'Exclude'),(17001,85,5,6391,'Roca The Gap Single Ended Acrylic Bath 1700mm x 750mm,Roca Bathroom sinks, Roca suppliers uk, '),(17002,85,0,6391,'Roca The Gap Single Ended Acrylic Bath 1700mm x 750mm,Roca Bathroom sinks, Roca suppliers uk, '),(17003,75,5,6391,'<p><span style=\"font-size: medium;\"><strong>Roca The Gap Single Ended Acrylic Bath 170cm x 75cm No Tap Hole - 24718000 </strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>White finish</li>\n<li>Material: Acrylic</li>\n<li>Shape: Rectangular</li>\n<li>Sound insulation</li>\n<li>Water capacity to overflow (l): 240 litres</li>\n<li>Bath has fully encapsulated baseboards and adjustable feet</li>\n</ul>\n'),(17004,75,0,6391,'<p><span style=\"font-size: medium;\"><strong>Roca The Gap Single Ended Acrylic Bath 170cm x 75cm No Tap Hole - 24718000 </strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>White finish</li>\n<li>Material: Acrylic</li>\n<li>Shape: Rectangular</li>\n<li>Sound insulation</li>\n<li>Water capacity to overflow (l): 240 litres</li>\n<li>Bath has fully encapsulated baseboards and adjustable feet</li>\n</ul>\n'),(17005,155,0,6391,'Exclude'),(17006,85,5,6392,'Bette Classic Super Steel Single Ended Bath'),(17007,85,0,6392,'Bette Classic Super Steel Single Ended Bath'),(17008,76,5,6392,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17009,76,0,6392,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17010,75,5,6392,'<style>#html-body [data-pb-style=J5JN6DY]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"J5JN6DY\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Classic Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : Sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n</div></div></div>'),(17011,75,0,6392,'<style>#html-body [data-pb-style=J5JN6DY]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"J5JN6DY\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Classic Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : Sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n</div></div></div>'),(17012,155,0,6392,'Exclude'),(17013,85,5,6393,'Bette Comodo Super Steel Bath with Side Overflow'),(17014,85,0,6393,'Bette Comodo Super Steel Bath with Side Overflow'),(17015,76,5,6393,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17016,76,0,6393,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17017,75,5,6393,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath with Side Overflow</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Made using 2mm steel</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Extremely narrow rim only 20mm high</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\r\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\r\n</ul>\r\n'),(17018,75,0,6393,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath with Side Overflow</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Made using 2mm steel</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Extremely narrow rim only 20mm high</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\r\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\r\n</ul>\r\n'),(17019,155,0,6393,'Exclude'),(17020,85,5,6394,'Bette Duett Super Steel Rectangular Bath'),(17021,85,0,6394,'Bette Duett Super Steel Rectangular Bath'),(17022,76,5,6394,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17023,76,0,6394,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17024,75,5,6394,'<p><span style=\"font-size: medium;\"><strong>Bette Duett Super Steel Rectangular Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>Supplied undrilled</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Tap hole option is only available in this size - 1700 x 800mm</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n'),(17025,75,0,6394,'<p><span style=\"font-size: medium;\"><strong>Bette Duett Super Steel Rectangular Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>Supplied undrilled</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Tap hole option is only available in this size - 1700 x 800mm</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n'),(17026,155,0,6394,'Exclude'),(17027,85,5,6395,'Bette Free Super Steel Double Ended Rectangular Bath'),(17028,85,0,6395,'Bette Free Super Steel Double Ended Rectangular Bath'),(17029,76,5,6395,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17030,76,0,6395,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17031,75,5,6395,'<style>#html-body [data-pb-style=WEVIGID]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"WEVIGID\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p style=\"text-align: justify;\"><span style=\"font-size: medium;\"><strong>Bette Free Super Steel Double Ended Rectangular Bath</strong></span></p>\r\n<p style=\"text-align: justify;\">Discover the freedom of design with Bette Free Baths. From the Bette Free Baths collection, experience the versatility of super steel rectangular baths. Create a stylish and contemporary bathroom with the exceptional quality of Bette Free.</p>\r\n<p style=\"text-align: justify;\"><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li style=\"text-align: justify;\">Double Ended bath</li>\r\n<li style=\"text-align: justify;\">Super Steel bath</li>\r\n<li style=\"text-align: justify;\">Centrally positioned drain</li>\r\n<li style=\"text-align: justify;\">Anti-noise pad is fitted as standard</li>\r\n<li style=\"text-align: justify;\">Strong and highly durable than other normal baths</li>\r\n<li style=\"text-align: justify;\">Tapholes, Legset, Antislip, BETTEGLAZE® [Optional]</li>\r\n<li style=\"text-align: justify;\">Striking design using clear, architectural and geometric elements</li>\r\n<li style=\"text-align: justify;\">Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li style=\"text-align: justify;\">Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17032,75,0,6395,'<style>#html-body [data-pb-style=WEVIGID]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"WEVIGID\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p style=\"text-align: justify;\"><span style=\"font-size: medium;\"><strong>Bette Free Super Steel Double Ended Rectangular Bath</strong></span></p>\r\n<p style=\"text-align: justify;\">Discover the freedom of design with Bette Free Baths. From the Bette Free Baths collection, experience the versatility of super steel rectangular baths. Create a stylish and contemporary bathroom with the exceptional quality of Bette Free.</p>\r\n<p style=\"text-align: justify;\"><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li style=\"text-align: justify;\">Double Ended bath</li>\r\n<li style=\"text-align: justify;\">Super Steel bath</li>\r\n<li style=\"text-align: justify;\">Centrally positioned drain</li>\r\n<li style=\"text-align: justify;\">Anti-noise pad is fitted as standard</li>\r\n<li style=\"text-align: justify;\">Strong and highly durable than other normal baths</li>\r\n<li style=\"text-align: justify;\">Tapholes, Legset, Antislip, BETTEGLAZE® [Optional]</li>\r\n<li style=\"text-align: justify;\">Striking design using clear, architectural and geometric elements</li>\r\n<li style=\"text-align: justify;\">Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li style=\"text-align: justify;\">Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17033,155,0,6395,'Exclude'),(17034,85,5,6396,'Bette Ocean Lowline Super Steel Single Ended Bath'),(17035,85,0,6396,'Bette Ocean Lowline Super Steel Single Ended Bath'),(17036,76,5,6396,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17037,76,0,6396,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17038,75,5,6396,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Lowline Super Steel Single Ended Bath</strong></span></p>\r\n<p style=\"text-align: justify;\">Being one of the best choices in steel baths&lsquor; Bette Ocean Lowline Single Ended Super Steel Bath is a super durable and simple yet exquisite choice for most of the homeowners. The refined Bette Glaze gives an elegant white surface and protects the bath from several harms. It has been designed to be highly scratch resistant. Any abrasive item that can usually be found in a bathroom can’t damage it because it is harder than other materials and has a chemical-resistant nature. Bette Glaze uses titanium-steel alloy&lsquor; together with enamel creating its beautiful unique finish that provides the bath&prime;s surface with a heat conductive feature. The advanced and innovative design keeps the bathroom silence by preventing loud reverberations. </p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Super steel bath</li>\r\n<li>Spacious, body-contoured lying profile</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Tap hole option is only available in one size - 1700 x 700mm</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and sodad</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n'),(17039,75,0,6396,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Lowline Super Steel Single Ended Bath</strong></span></p>\r\n<p style=\"text-align: justify;\">Being one of the best choices in steel baths&lsquor; Bette Ocean Lowline Single Ended Super Steel Bath is a super durable and simple yet exquisite choice for most of the homeowners. The refined Bette Glaze gives an elegant white surface and protects the bath from several harms. It has been designed to be highly scratch resistant. Any abrasive item that can usually be found in a bathroom can’t damage it because it is harder than other materials and has a chemical-resistant nature. Bette Glaze uses titanium-steel alloy&lsquor; together with enamel creating its beautiful unique finish that provides the bath&prime;s surface with a heat conductive feature. The advanced and innovative design keeps the bathroom silence by preventing loud reverberations. </p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Super steel bath</li>\r\n<li>Spacious, body-contoured lying profile</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Tap hole option is only available in one size - 1700 x 700mm</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and sodad</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n'),(17040,155,0,6396,'Exclude'),(17041,85,5,6397,'Bette One Super Steel Double Ended Bath'),(17042,85,0,6397,'Bette One Super Steel Double Ended Bath'),(17043,76,5,6397,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17044,76,0,6397,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17045,75,5,6397,'<style>#html-body [data-pb-style=G91GPWA]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"G91GPWA\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p style=\"text-align: justify;\"><span style=\"font-size: medium;\"><strong>Bette One Super Steel Double Ended Bath</strong></span></p>\r\n<p style=\"text-align: justify;\">Experience elegance and comfort with the Bette One Bath. Designed for ultimate relaxation, the Bette One Double Ended Bath offers a spacious bathing experience. Crafted with superior quality, the Bette One Super Steel Bath combines style and durability for your bathroom sanctuary.</p>\r\n<p style=\"text-align: justify;\"><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li style=\"text-align: justify;\">Double ended bath</li>\r\n<li style=\"text-align: justify;\">Super steel bath</li>\r\n<li style=\"text-align: justify;\">Made from glazed titanium steel</li>\r\n<li style=\"text-align: justify;\">Constructed using sustainable quality</li>\r\n<li style=\"text-align: justify;\">Tapholes, Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li style=\"text-align: justify;\">Duo bath with a central outlet and a generous inside body</li>\r\n</ul></div></div></div>');
INSERT INTO `catalog_product_entity_text` VALUES (17046,75,0,6397,'<style>#html-body [data-pb-style=G91GPWA]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"G91GPWA\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p style=\"text-align: justify;\"><span style=\"font-size: medium;\"><strong>Bette One Super Steel Double Ended Bath</strong></span></p>\r\n<p style=\"text-align: justify;\">Experience elegance and comfort with the Bette One Bath. Designed for ultimate relaxation, the Bette One Double Ended Bath offers a spacious bathing experience. Crafted with superior quality, the Bette One Super Steel Bath combines style and durability for your bathroom sanctuary.</p>\r\n<p style=\"text-align: justify;\"><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li style=\"text-align: justify;\">Double ended bath</li>\r\n<li style=\"text-align: justify;\">Super steel bath</li>\r\n<li style=\"text-align: justify;\">Made from glazed titanium steel</li>\r\n<li style=\"text-align: justify;\">Constructed using sustainable quality</li>\r\n<li style=\"text-align: justify;\">Tapholes, Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li style=\"text-align: justify;\">Duo bath with a central outlet and a generous inside body</li>\r\n</ul></div></div></div>'),(17047,155,0,6397,'Exclude'),(17048,85,5,6398,'Bette One Relax Super Steel Single Ended Bath'),(17049,85,0,6398,'Bette One Relax Super Steel Single Ended Bath'),(17050,76,5,6398,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17051,76,0,6398,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17052,75,5,6398,'<p><span style=\"font-size: medium;\"><strong>Bette One Relax Super Steel Single Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n<li>With broad trayedge is highlighted by the angular, flush outlet with an enamelled cover</li>\r\n</ul>\r\n\r\n\r\n'),(17053,75,0,6398,'<p><span style=\"font-size: medium;\"><strong>Bette One Relax Super Steel Single Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n<li>With broad trayedge is highlighted by the angular, flush outlet with an enamelled cover</li>\r\n</ul>\r\n\r\n\r\n'),(17054,155,0,6398,'Exclude'),(17055,85,5,6399,'Bette Starlet Flair Oval Super Steel Double Ended Bath'),(17056,85,0,6399,'Bette Starlet Flair Oval Super Steel Double Ended Bath'),(17057,76,5,6399,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17058,76,0,6399,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17059,75,5,6399,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Flair Oval Super Steel Double Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Extremely thin bath edges</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n'),(17060,75,0,6399,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Flair Oval Super Steel Double Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Extremely thin bath edges</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n'),(17061,155,0,6399,'Exclude'),(17062,85,5,6400,'Bette Starlet IV Silhouette Steel Double Ended Bath'),(17063,85,0,6400,'Bette Starlet IV Silhouette Steel Double Ended Bath'),(17064,76,5,6400,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17065,76,0,6400,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17066,75,5,6400,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet IV Silhouette Steel Double Ended Bath</strong></span></p>\n<p>Bette starlet oval silhouette steel bath is a free standing bath with flawless design and excellent craftsmanship, both interior and exterior bath body is smoothly joined. The completely symmetrical bath is suitable for both small and generous size bathrooms.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>For fitting in the corner</li>\n<li>Centrally-positioned drain</li>\n<li>Anti-noise pad is fitted as standard</li>\n<li>Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Strong and highly durable than other normal baths</li>\n<li>Tap hole option is available in all sizes except this size - 1750 x 800mm</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n</ul>\n\n'),(17067,75,0,6400,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet IV Silhouette Steel Double Ended Bath</strong></span></p>\n<p>Bette starlet oval silhouette steel bath is a free standing bath with flawless design and excellent craftsmanship, both interior and exterior bath body is smoothly joined. The completely symmetrical bath is suitable for both small and generous size bathrooms.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>For fitting in the corner</li>\n<li>Centrally-positioned drain</li>\n<li>Anti-noise pad is fitted as standard</li>\n<li>Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Strong and highly durable than other normal baths</li>\n<li>Tap hole option is available in all sizes except this size - 1750 x 800mm</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n</ul>\n\n'),(17068,155,0,6400,'Exclude'),(17069,85,5,6401,'Bette Starlet Oval Super Steel Double Ended Bath'),(17070,85,0,6401,'Bette Starlet Oval Super Steel Double Ended Bath'),(17071,76,5,6401,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17072,76,0,6401,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17073,75,5,6401,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Oval Super Steel Double Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17074,75,0,6401,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Oval Super Steel Double Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17075,155,0,6401,'Exclude'),(17076,85,5,6402,'Bette Starlet V Silhouette Steel Double Ended Bath'),(17077,85,0,6402,'Bette Starlet V Silhouette Steel Double Ended Bath'),(17078,76,5,6402,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17079,76,0,6402,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17080,75,5,6402,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet V Silhouette Steel Double Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>For fitting in the corner</li>\r\n<li>Bath with centrally-positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n'),(17081,75,0,6402,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet V Silhouette Steel Double Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>For fitting in the corner</li>\r\n<li>Bath with centrally-positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n'),(17082,155,0,6402,'Exclude'),(17083,85,5,6403,'Roca Lun Plus Steel Bath with Anti-Slip 1700 x 750mm'),(17084,85,0,6403,'Roca Lun Plus Steel Bath with Anti-Slip 1700 x 750mm'),(17085,75,5,6403,'<style>#html-body [data-pb-style=IOIA912]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"IOIA912\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Roca Lun Plus Steel Bath with 1700 x 750mm - Anti-Slip</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Roca Contesa White Steel Bath 160cm x 70cm</li>\r\n<li>Dimensions: 1700mm Length x 750mm Width</li>\r\n<li>Double ended bath</li>\r\n<li>Finish : White</li>\r\n<li>Rectangular bath.</li>\r\n<li>Made of 3.5mm steel sheet.</li>\r\n<li>Water capacity to overflow: 225 litres</li>\r\n</ul></div></div></div>'),(17086,75,0,6403,'<style>#html-body [data-pb-style=IOIA912]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"IOIA912\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Roca Lun Plus Steel Bath with 1700 x 750mm - Anti-Slip</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Roca Contesa White Steel Bath 160cm x 70cm</li>\r\n<li>Dimensions: 1700mm Length x 750mm Width</li>\r\n<li>Double ended bath</li>\r\n<li>Finish : White</li>\r\n<li>Rectangular bath.</li>\r\n<li>Made of 3.5mm steel sheet.</li>\r\n<li>Water capacity to overflow: 225 litres</li>\r\n</ul></div></div></div>'),(17087,85,5,6404,'Roca Carla Steel Bath,Cheap Steel Bath, Buy Roca Carla Steel Bath,Roca Carla Steel Bath with Anti-Slip Base'),(17088,85,0,6404,'Roca Carla Steel Bath,Cheap Steel Bath, Buy Roca Carla Steel Bath,Roca Carla Steel Bath with Anti-Slip Base'),(17089,75,5,6404,'<style>#html-body [data-pb-style=T26UFQX]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"T26UFQX\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Roca Carla Steel Bath with 2 Tap Hole 160cm x 70cm - 2375L3000 2375M3000</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>White finish</li>\r\n<li>Made using 2mm steel sheet</li>\r\n<li>Bath comes with 2 prepunched tapholes</li>\r\n<li>Material: Steel</li>\r\n<li>The grip holes are predrilled</li>\r\n<li>Shape: Rectangular</li>\r\n<li>Water capacity to overflow (l): 180</li>\r\n</ul>\r\n</div></div></div>'),(17090,75,0,6404,'<style>#html-body [data-pb-style=T26UFQX]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"T26UFQX\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Roca Carla Steel Bath with 2 Tap Hole 160cm x 70cm - 2375L3000 2375M3000</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>White finish</li>\r\n<li>Made using 2mm steel sheet</li>\r\n<li>Bath comes with 2 prepunched tapholes</li>\r\n<li>Material: Steel</li>\r\n<li>The grip holes are predrilled</li>\r\n<li>Shape: Rectangular</li>\r\n<li>Water capacity to overflow (l): 180</li>\r\n</ul>\r\n</div></div></div>'),(17091,155,0,6404,'Exclude'),(17092,85,5,6405,'Bette Labette Super Steel Bath 108 x 73cm No Tap Hole - BE1080-000\r\n\r\n\r\n\r\n.\r\n\r\n'),(17093,85,0,6405,'Bette Labette Super Steel Bath 108 x 73cm No Tap Hole - BE1080-000\r\n\r\n\r\n\r\n.\r\n\r\n'),(17094,76,5,6405,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-labette-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Labette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17095,76,0,6405,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-labette-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Labette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17096,75,5,6405,'<p><span style=\"font-size: medium;\"><strong>Bette Labette Super Steel Bath 108 x 73cm No tap Hole - 1080-000 </strong></span></p>\n<p style=\"text-align: justify;\">Bette Labette bath is brought to you by Bette which is a leading brand. The smooth contours of this bath are rendered to extend comfort so it will bring a great change to your bathroom. Everybody wants to get comfortable bath and it is possible only when you love the surface of your bath. If the surface of the bath does not give you a smooth touch then it simply means you need to change your bath. This 1080 bath has 730mm width whereas its depth is 380mm. The outer shape of this single ended bath is rectangular whereas the inner shape has rounded curves that can catch your eye easily. It will be a great choice for small bathrooms as it occupies less space but renders unmatchable functionality. Material is the most vital thing in any products and this <span style=\"color: #3366ff;\"><a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>super steel Bette bath</strong></span></a></span> is made from sturdy titanium finished steel which makes it strong, durable, and long lasting.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Comfortable hip-bath</li>\n<li>Supplied with no tap hole</li>\n<li>Fitted with anti noise pad as standard</li>\n<li>Space-saving bath for small bathrooms</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17097,75,0,6405,'<p><span style=\"font-size: medium;\"><strong>Bette Labette Super Steel Bath 108 x 73cm No tap Hole - 1080-000 </strong></span></p>\n<p style=\"text-align: justify;\">Bette Labette bath is brought to you by Bette which is a leading brand. The smooth contours of this bath are rendered to extend comfort so it will bring a great change to your bathroom. Everybody wants to get comfortable bath and it is possible only when you love the surface of your bath. If the surface of the bath does not give you a smooth touch then it simply means you need to change your bath. This 1080 bath has 730mm width whereas its depth is 380mm. The outer shape of this single ended bath is rectangular whereas the inner shape has rounded curves that can catch your eye easily. It will be a great choice for small bathrooms as it occupies less space but renders unmatchable functionality. Material is the most vital thing in any products and this <span style=\"color: #3366ff;\"><a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>super steel Bette bath</strong></span></a></span> is made from sturdy titanium finished steel which makes it strong, durable, and long lasting.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Comfortable hip-bath</li>\n<li>Supplied with no tap hole</li>\n<li>Fitted with anti noise pad as standard</li>\n<li>Space-saving bath for small bathrooms</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17098,155,0,6405,'Exclude'),(17099,85,5,6406,'Bette Labette Super Steel Bath 118 x 73cm No Tap Hole - BE1180-000'),(17100,85,0,6406,'Bette Labette Super Steel Bath 118 x 73cm No Tap Hole - BE1180-000'),(17101,76,5,6406,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-labette-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Labette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17102,76,0,6406,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-labette-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Labette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17103,75,5,6406,'<p><span style=\"font-size: medium;\"><strong>Bette Labette Super Steel Bath 118 x 73cm - 1180-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">Give a new exciting look to your bathroom by giving place to Bette Labette bath as its unique eye catching shape can enhance the visual appeal of any bathroom. It is not special due to its design only but its functionality is also admirable. It will efficiently fulfil your need of a comfort bath as its surface gives a smooth touch to your skin and leave you to enjoy comfortable bath moments. It is fitted with anti-noise pad as standard as well as it is a space saving bath. This single ended bath can be filled up to 52 litres of water that is more than enough for a good bath. More on, this comfortable hip bath is suppliedand there is No tap Hole in it. Bette uper steel baths usually render more comfort than ordinary baths so this <span style=\"color: #3366ff;\"><a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>Bette steel bath</strong> </span></a></span>will prove a wise decision for your bathroom.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Comfortable hip-bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17104,75,0,6406,'<p><span style=\"font-size: medium;\"><strong>Bette Labette Super Steel Bath 118 x 73cm - 1180-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">Give a new exciting look to your bathroom by giving place to Bette Labette bath as its unique eye catching shape can enhance the visual appeal of any bathroom. It is not special due to its design only but its functionality is also admirable. It will efficiently fulfil your need of a comfort bath as its surface gives a smooth touch to your skin and leave you to enjoy comfortable bath moments. It is fitted with anti-noise pad as standard as well as it is a space saving bath. This single ended bath can be filled up to 52 litres of water that is more than enough for a good bath. More on, this comfortable hip bath is suppliedand there is No tap Hole in it. Bette uper steel baths usually render more comfort than ordinary baths so this <span style=\"color: #3366ff;\"><a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>Bette steel bath</strong> </span></a></span>will prove a wise decision for your bathroom.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Comfortable hip-bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17105,155,0,6406,'Exclude'),(17106,85,5,6407,'Bette Labette Super Steel Bath 120 x 70cm - BE1200-000'),(17107,85,0,6407,'Bette Labette Super Steel Bath 120 x 70cm - BE1200-000'),(17108,76,5,6407,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-labette-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Labette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17109,76,0,6407,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-labette-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Labette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17110,75,5,6407,'<style>#html-body [data-pb-style=MGWMAC1]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"MGWMAC1\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Labette Super Steel Bath 120 x 70cm- 1200-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">If you want to add an alluring touch to your bathroom then Bette Labette bath is more than an efficient choice for you. It will keep your bathroom a clean place to be used as bacteria cannot grow there. The construction from steel has made it extra durable so it will render perfect results without compromising its quality. It is intelligently manufactured so there are no loopholes in this 1200 bath and it is brought to you after so many tests to give to satisfactory results. Bring it home by availing an exciting discount offered by Banyo. <a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>Bette</strong></span></a> is rendering a guarantee of 30 years on this product for your peace of mind. This comfortable hip bath is suppliedand there is No tap Hole in it. Its non-fading stable white colour is making it more incredible as it will retain its look even after decades of use.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features </strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Comfortable hip-bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17111,75,0,6407,'<style>#html-body [data-pb-style=MGWMAC1]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"MGWMAC1\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Labette Super Steel Bath 120 x 70cm- 1200-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">If you want to add an alluring touch to your bathroom then Bette Labette bath is more than an efficient choice for you. It will keep your bathroom a clean place to be used as bacteria cannot grow there. The construction from steel has made it extra durable so it will render perfect results without compromising its quality. It is intelligently manufactured so there are no loopholes in this 1200 bath and it is brought to you after so many tests to give to satisfactory results. Bring it home by availing an exciting discount offered by Banyo. <a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>Bette</strong></span></a> is rendering a guarantee of 30 years on this product for your peace of mind. This comfortable hip bath is suppliedand there is No tap Hole in it. Its non-fading stable white colour is making it more incredible as it will retain its look even after decades of use.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features </strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Comfortable hip-bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17112,155,0,6407,'Exclude'),(17113,85,5,6408,'Bette Starlet Super Steel Bath 150 x 80cm No Tap Hole - BE1210-000'),(17114,85,0,6408,'Bette Starlet Super Steel Bath 150 x 80cm No Tap Hole - BE1210-000'),(17115,76,5,6408,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17116,76,0,6408,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17117,75,5,6408,'<style>#html-body [data-pb-style=SWSYFRM]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"SWSYFRM\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 150 x 80cm No tap Hole - 1210-000 </strong></span></p>\r\n<p>Our collection of 1500 x 800 Bathtubs is ideal for when you have a smaller-sized bathroom .Bette Starlet bath is offered to you by a leading brand, Bette. There are round curves inside the rectangular shape of this bath that look great and enhance the overall visual appearance of this bath. The unique BETTE GLAZE enamel finish of this bath is made by using glass, borax, water quartz, and soda. Bette steel bath is an excellent conductor of heat to give you a smooth and warm touch in winters. It will allow you to relax in the very best way as its surface will give a smooth touch to your skin. Spend your money on the right product and enjoy its advantages in your whole life as its durability is unbeatable.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17118,75,0,6408,'<style>#html-body [data-pb-style=SWSYFRM]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"SWSYFRM\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 150 x 80cm No tap Hole - 1210-000 </strong></span></p>\r\n<p>Our collection of 1500 x 800 Bathtubs is ideal for when you have a smaller-sized bathroom .Bette Starlet bath is offered to you by a leading brand, Bette. There are round curves inside the rectangular shape of this bath that look great and enhance the overall visual appearance of this bath. The unique BETTE GLAZE enamel finish of this bath is made by using glass, borax, water quartz, and soda. Bette steel bath is an excellent conductor of heat to give you a smooth and warm touch in winters. It will allow you to relax in the very best way as its surface will give a smooth touch to your skin. Spend your money on the right product and enjoy its advantages in your whole life as its durability is unbeatable.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17119,155,0,6408,'Exclude'),(17120,85,5,6409,'Bette Starlet Steel Bath 1600 x 700mm  - Banyo.co.uk'),(17121,85,0,6409,'Bette Starlet Steel Bath 1600 x 700mm  - Banyo.co.uk'),(17122,76,5,6409,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17123,76,0,6409,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17124,75,5,6409,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 160 x 70cm- BE1220-000 </strong></span></p>\r\n<p>Baths which have centrally positioned drain usually render more functionality than other normal baths. There is No tap Hole in this bath and it is supplied . It is refined with a unique BETTEGLAZE enamel finish that is made by using quartz, glass, soda, borax, and water. Heat can pass through it easily so it is an absolutely perfect choice for getting the warm and cosy feeling in winters. Scratches cannot stay longer on it as you can clean it effortlessly. It allows the volume of water up to 116 litres. There is No tap Hole in it but feet are supplied with it. This super steel bath is hygienic and keeps your bathroom clean so your time will also be saved. Bette is offering a guarantee of 30 years for your peace of mind.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n'),(17125,75,0,6409,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 160 x 70cm- BE1220-000 </strong></span></p>\r\n<p>Baths which have centrally positioned drain usually render more functionality than other normal baths. There is No tap Hole in this bath and it is supplied . It is refined with a unique BETTEGLAZE enamel finish that is made by using quartz, glass, soda, borax, and water. Heat can pass through it easily so it is an absolutely perfect choice for getting the warm and cosy feeling in winters. Scratches cannot stay longer on it as you can clean it effortlessly. It allows the volume of water up to 116 litres. There is No tap Hole in it but feet are supplied with it. This super steel bath is hygienic and keeps your bathroom clean so your time will also be saved. Bette is offering a guarantee of 30 years for your peace of mind.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n'),(17126,155,0,6409,'Exclude'),(17127,85,5,6410,'Bette Starlet Super Steel Bath 165 x 70cm - BE1230-000'),(17128,85,0,6410,'Bette Starlet Super Steel Bath 165 x 70cm - BE1230-000'),(17129,76,5,6410,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17130,76,0,6410,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17131,75,5,6410,'<style>#html-body [data-pb-style=XVM57F7]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"XVM57F7\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 165 x 70cm- BE1230-000 </strong></span></p>\r\n<p>Baths that contain centrally-positioned drain are usually more efficient and render more benefit to the users. Bette Starlet bath also has a centrally-positioned drain that increases the efficiency of this bath. This super steel bath can be filled up to 116 litres of water and there is an anti-noised pad fitted in this double ended bath. The sturdy titanium finished steel has made it highly durable and long lasting. The feet (or cradle) are optional and there are NO pre-drilled tap Holes in this bath. . It occupies less space so it will prove a space saving bath for smaller bathrooms. It is heat conducting, hygienic, resistant to chemicals as well as resists UV rays also. A guarantee of 30 years is rendered from the side of Bette to bring you peace of mind.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>1650 steel bath</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17132,75,0,6410,'<style>#html-body [data-pb-style=XVM57F7]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"XVM57F7\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 165 x 70cm- BE1230-000 </strong></span></p>\r\n<p>Baths that contain centrally-positioned drain are usually more efficient and render more benefit to the users. Bette Starlet bath also has a centrally-positioned drain that increases the efficiency of this bath. This super steel bath can be filled up to 116 litres of water and there is an anti-noised pad fitted in this double ended bath. The sturdy titanium finished steel has made it highly durable and long lasting. The feet (or cradle) are optional and there are NO pre-drilled tap Holes in this bath. . It occupies less space so it will prove a space saving bath for smaller bathrooms. It is heat conducting, hygienic, resistant to chemicals as well as resists UV rays also. A guarantee of 30 years is rendered from the side of Bette to bring you peace of mind.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>1650 steel bath</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17133,155,0,6410,'Exclude'),(17134,85,5,6411,'Bette Labette Super Steel Bath 124 x 70cm and No Tap Hole - BE1240-000'),(17135,85,0,6411,'Bette Labette Super Steel Bath 124 x 70cm and No Tap Hole - BE1240-000'),(17136,76,5,6411,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-labette-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Labette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17137,76,0,6411,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-labette-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Labette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17138,75,5,6411,'<p><span style=\"font-size: medium;\"><strong>Bette Labette Super Steel Bath 124 x 70cm and No tap Hole - 1240-000</strong></span></p>\n<p style=\"text-align: justify;\">Now you can easily turn your ordinary bathroom into luxurious one by installing Bette Labette super steel bath as there is no comparison of its features and functionality. You will find it resistant against scouring agents and fluids as it is constructed from super steel which makes it a strong bath with durable quality and long lasting functionality. It renders you an additional benefit as there is No tap Hole in this bath. Germs and bacteria usually grow with speed in bathrooms but you should be happy that your bathroom will be bacteria free as the smooth and hygienic surface of Bette bath does not allow bacteria to grow and keeps your bathroom a hygienic place to be used. The white shine of this bath is long lasting as it will stay same even after the decades of use. This <a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\">Bette steel bath</span></a> is available at banyo with a discounted price.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Comfortable hip-bath</li>\n<li>Supplied with no tap hole</li>\n<li>Fitted with anti noise pad as standard</li>\n<li>Space-saving bath for small bathrooms</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17139,75,0,6411,'<p><span style=\"font-size: medium;\"><strong>Bette Labette Super Steel Bath 124 x 70cm and No tap Hole - 1240-000</strong></span></p>\n<p style=\"text-align: justify;\">Now you can easily turn your ordinary bathroom into luxurious one by installing Bette Labette super steel bath as there is no comparison of its features and functionality. You will find it resistant against scouring agents and fluids as it is constructed from super steel which makes it a strong bath with durable quality and long lasting functionality. It renders you an additional benefit as there is No tap Hole in this bath. Germs and bacteria usually grow with speed in bathrooms but you should be happy that your bathroom will be bacteria free as the smooth and hygienic surface of Bette bath does not allow bacteria to grow and keeps your bathroom a hygienic place to be used. The white shine of this bath is long lasting as it will stay same even after the decades of use. This <a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\">Bette steel bath</span></a> is available at banyo with a discounted price.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Comfortable hip-bath</li>\n<li>Supplied with no tap hole</li>\n<li>Fitted with anti noise pad as standard</li>\n<li>Space-saving bath for small bathrooms</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17140,155,0,6411,'Exclude'),(17141,85,5,6412,'Bette Comodo Super Steel Bath 1700 × 750mm No Tap Hole - 1250'),(17142,85,0,6412,'Bette Comodo Super Steel Bath 1700 × 750mm No Tap Hole - 1250'),(17143,76,5,6412,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-comodo-super-steel-bath-with-side-overflow.html\">&gt;&nbsp;&nbsp;View all Bette Comodo Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17144,76,0,6412,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-comodo-super-steel-bath-with-side-overflow.html\">&gt;&nbsp;&nbsp;View all Bette Comodo Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17145,75,5,6412,'<style>#html-body [data-pb-style=U2QF4AO]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"U2QF4AO\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath 1700 x 750mm No Tap Hole - 1250</strong></span></p>\r\n<p>Experience pure comfort with the Bette Comodo Bath. Available in the size of 1700 x 750, this bath combines sleek design with optimal functionality. Transform your bathroom into a haven of relaxation with the Bette Comodo.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Colour : White</li>\r\n<li>Made using 2mm steel</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Extremely narrow rim only 20mm high</li>\r\n<li>Bath filler shown in the image is not included</li>\r\n<li>Legset, Antislip sense, Bette GLAZE Plus [Optional]</li>\r\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\r\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\r\n</ul></div></div></div>'),(17146,75,0,6412,'<style>#html-body [data-pb-style=U2QF4AO]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"U2QF4AO\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath 1700 x 750mm No Tap Hole - 1250</strong></span></p>\r\n<p>Experience pure comfort with the Bette Comodo Bath. Available in the size of 1700 x 750, this bath combines sleek design with optimal functionality. Transform your bathroom into a haven of relaxation with the Bette Comodo.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Colour : White</li>\r\n<li>Made using 2mm steel</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Extremely narrow rim only 20mm high</li>\r\n<li>Bath filler shown in the image is not included</li>\r\n<li>Legset, Antislip sense, Bette GLAZE Plus [Optional]</li>\r\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\r\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\r\n</ul></div></div></div>'),(17147,155,0,6412,'Exclude'),(17148,85,5,6413,'Bette Classic Super Steel Bath 180 x 80cm - BE1270-000'),(17149,85,0,6413,'Bette Classic Super Steel Bath 180 x 80cm - BE1270-000'),(17150,76,5,6413,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17151,76,0,6413,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17152,75,5,6413,'<p><strong><a href=\"/bette-classic-super-steel-single-ended-bath.html\" title=\"Bette Classic Super Steel Bath - Single Ended\" target=\"_blank\">Bette Classic Super Steel Bath 180 x 80cm- BE1270-000</a></strong></p>\r\n<p>Bette always renders you products that work beyond your expectations and Bette Classic super steel bath is also a product of Bette. The rectangular shape of this bath has perfect dimensions of 800mm width and 450mm depth. It will render you spacious standing area with an outlet to the centre so it will be a great addition to your contemporary bathroom. Bette steel bath is an excellent conductor of heat to give you a smooth and warm touch in winters. It will allow you to relax in the very best way as its surface will give a smooth touch to your skin. Spend your money on the right product and enjoy its advantages in your whole life as its durability is unbeatable.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Colour : White</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17153,75,0,6413,'<p><strong><a href=\"/bette-classic-super-steel-single-ended-bath.html\" title=\"Bette Classic Super Steel Bath - Single Ended\" target=\"_blank\">Bette Classic Super Steel Bath 180 x 80cm- BE1270-000</a></strong></p>\r\n<p>Bette always renders you products that work beyond your expectations and Bette Classic super steel bath is also a product of Bette. The rectangular shape of this bath has perfect dimensions of 800mm width and 450mm depth. It will render you spacious standing area with an outlet to the centre so it will be a great addition to your contemporary bathroom. Bette steel bath is an excellent conductor of heat to give you a smooth and warm touch in winters. It will allow you to relax in the very best way as its surface will give a smooth touch to your skin. Spend your money on the right product and enjoy its advantages in your whole life as its durability is unbeatable.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Colour : White</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17154,155,0,6413,'Exclude'),(17155,85,5,6414,'Bette Classic Super Steel Bath 180 x 70cm - BE1271-000'),(17156,85,0,6414,'Bette Classic Super Steel Bath 180 x 70cm - BE1271-000'),(17157,76,5,6414,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17158,76,0,6414,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17159,75,5,6414,'<style>#html-body [data-pb-style=CKJYBBC]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"CKJYBBC\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><strong><a title=\"Bette Classic Super Steel Bath - Single Ended\" href=\"https://www.banyo.co.uk/bette-classic-super-steel-bath-180-x-70cm.html\" target=\"_blank\" rel=\"noopener\">Bette Classic Super Steel Bath 180 x 70cm- BE1271-000</a></strong></p>\r\n<p>Bette Classic <a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\" rel=\"noopener\">Super Steel bath</a> is an efficient choice for those who want to add a functional bath in their bathroom. The length of this bath is 1800mm whereas its width is 700mm and depth is 450mm. The efficiently designed depth of this bath allows people of large size to enter easily into this bath to completely submerge and relax. It is intelligently manufactured so there are no loopholes in this bath and it is brought to you after so many tests to give to satisfactory results. Bring it home by availing an exciting discount offered by Banyo. Bette is rendering a guarantee of 30 years on this product for your peace of mind. This comfortable hip bath has no tap hole in it. Its non-fading stable white colour is making it more incredible as it will retain its look even after decades of use.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Colour : White</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17160,75,0,6414,'<style>#html-body [data-pb-style=CKJYBBC]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"CKJYBBC\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><strong><a title=\"Bette Classic Super Steel Bath - Single Ended\" href=\"https://www.banyo.co.uk/bette-classic-super-steel-bath-180-x-70cm.html\" target=\"_blank\" rel=\"noopener\">Bette Classic Super Steel Bath 180 x 70cm- BE1271-000</a></strong></p>\r\n<p>Bette Classic <a href=\"https://www.banyo.co.uk/bathroom/baths.html\" target=\"_blank\" rel=\"noopener\">Super Steel bath</a> is an efficient choice for those who want to add a functional bath in their bathroom. The length of this bath is 1800mm whereas its width is 700mm and depth is 450mm. The efficiently designed depth of this bath allows people of large size to enter easily into this bath to completely submerge and relax. It is intelligently manufactured so there are no loopholes in this bath and it is brought to you after so many tests to give to satisfactory results. Bring it home by availing an exciting discount offered by Banyo. Bette is rendering a guarantee of 30 years on this product for your peace of mind. This comfortable hip bath has no tap hole in it. Its non-fading stable white colour is making it more incredible as it will retain its look even after decades of use.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Colour : White</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17161,155,0,6414,'Exclude'),(17162,85,5,6415,'Bette Classic Super Steel Bath 180 x 75cm - BE1272-000'),(17163,85,0,6415,'Bette Classic Super Steel Bath 180 x 75cm - BE1272-000'),(17164,76,5,6415,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17165,76,0,6415,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17166,75,5,6415,'<p><strong><a href=\"/bette-classic-super-steel-single-ended-bath.html\" title=\"Bette Classic Super Steel Bath - Single Ended\" target=\"_blank\">Bette Classic Super Steel Bath 180 x 75cm- BE1272-000</a></strong></p>\r\n<p>Bette Classic Super Steel bath is designed by one of the leading brands, Bette. They are heat conducting as heat can pass through it effortlessly so it will give you a warm and cosy touch in winters. Scratches cannot stay on the surface of this bath for a long time as super steel manufacturing has made it scratch resistant. It has ergonomically designed back support to render you more relaxed bathing. It is refined with a unique BETTEGLAZE enamel finish that is made by using glass, water, quartz, borax, and soda. The inner body of this bath harmonises perfectly with the outer rectangle to give a seamless look. There is no pre-drilled tap hole. It is a single ended bath and can be filled up to 140 litres of water.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Colour : White</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17167,75,0,6415,'<p><strong><a href=\"/bette-classic-super-steel-single-ended-bath.html\" title=\"Bette Classic Super Steel Bath - Single Ended\" target=\"_blank\">Bette Classic Super Steel Bath 180 x 75cm- BE1272-000</a></strong></p>\r\n<p>Bette Classic Super Steel bath is designed by one of the leading brands, Bette. They are heat conducting as heat can pass through it effortlessly so it will give you a warm and cosy touch in winters. Scratches cannot stay on the surface of this bath for a long time as super steel manufacturing has made it scratch resistant. It has ergonomically designed back support to render you more relaxed bathing. It is refined with a unique BETTEGLAZE enamel finish that is made by using glass, water, quartz, borax, and soda. The inner body of this bath harmonises perfectly with the outer rectangle to give a seamless look. There is no pre-drilled tap hole. It is a single ended bath and can be filled up to 140 litres of water.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Colour : White</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17168,155,0,6415,'Exclude'),(17169,85,5,6416,'Bette Labette Super Steel Bath 130 x 70cm - BE1300-000'),(17170,85,0,6416,'Bette Labette Super Steel Bath 130 x 70cm - BE1300-000'),(17171,76,5,6416,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-labette-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Labette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17172,76,0,6416,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-labette-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Labette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17173,75,5,6416,'<style>#html-body [data-pb-style=POQ1OBR]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"POQ1OBR\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Labette Super Steel Bath 130 x 70cm- 1300-000 </strong></span></p><p style=\"text-align: justify;\">The Bette Labette bath is a great addition to the collection of Bette as its functionality and design both are admirable. It is available with white finish with no pre-drilled tap holes and it is beautifully manufactured by using very best materials. Super steel has made this bath an efficient and durable product and BETTEGLAZE enamel has rendered a beautiful finish to this product. The rectangular shape of this 1300 x 700 bath looks quite elegant in any bathroom and it is a space saving bath as it does not cover extra space. This single ended bath can be filled up to 85 litres of water and it is an excellent conductor of heat so it will definitely give you a warm touch in winters. Bring it home for getting a warm and comfortable touch.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Comfortable hip-bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n</div></div></div>'),(17174,75,0,6416,'<style>#html-body [data-pb-style=POQ1OBR]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"POQ1OBR\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Labette Super Steel Bath 130 x 70cm- 1300-000 </strong></span></p><p style=\"text-align: justify;\">The Bette Labette bath is a great addition to the collection of Bette as its functionality and design both are admirable. It is available with white finish with no pre-drilled tap holes and it is beautifully manufactured by using very best materials. Super steel has made this bath an efficient and durable product and BETTEGLAZE enamel has rendered a beautiful finish to this product. The rectangular shape of this 1300 x 700 bath looks quite elegant in any bathroom and it is a space saving bath as it does not cover extra space. This single ended bath can be filled up to 85 litres of water and it is an excellent conductor of heat so it will definitely give you a warm touch in winters. Bring it home for getting a warm and comfortable touch.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Comfortable hip-bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n</div></div></div>'),(17175,155,0,6416,'Exclude'),(17176,85,5,6417,'Bette Starlet Steel Bath 1700 x 750mm, Bette Starlet Double Ended Steel Bath, Bette Starlet  - Banyo.co.uk\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n'),(17177,85,0,6417,'Bette Starlet Steel Bath 1700 x 750mm, Bette Starlet Double Ended Steel Bath, Bette Starlet  - Banyo.co.uk\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n'),(17178,76,5,6417,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17179,76,0,6417,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17180,75,5,6417,'<style>#html-body [data-pb-style=EKQ1LTC]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"EKQ1LTC\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p style=\"text-align: justify;\"><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 170 x 75cm- BE1380-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">Indulge in the luxurious Bette Starlet Bath, designed for ultimate relaxation. Available in the size of steel bath 1700 x 750, this stunning bath offers both style and comfort. Elevate your bathing experience with the Bette Starlet. Bette Starlet 1700, High Quality Steel, Double Ended Bath. Design of anything matters a lot as we all prefer those things that catch our eyes. Bette Starlet bath is offered to you by Bette as its designing is mind blowing and can capture many eyes in the first sight. It has centrally-positioned drain that is making it a more efficient bath regarding its functionality. This double ended bath will allow you to enjoy comfortable bath moments every time you use it. The manufacturing of this Bette bath is done with high-quality stainless steel that has made it extremely hygienic and long lasting. Heat can effortlessly pass through it so you will get a warm touch whenever you use this bath. It is fitted with anti-noise pad as standard. It is resistant to chemicals, scratches, and impact so you can clean it easily with any bath cleaner.</p>\r\n<p style=\"text-align: justify;\"><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li style=\"text-align: justify;\">Shape : Rectangular</li>\r\n<li style=\"text-align: justify;\">Double ended bath</li>\r\n<li style=\"text-align: justify;\">Super steel bath</li>\r\n<li style=\"text-align: justify;\">No tap hole and 2 tap holes option available</li>\r\n<li style=\"text-align: justify;\">Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li style=\"text-align: justify;\">Centrally-positioned drain</li>\r\n<li style=\"text-align: justify;\">Comes fitted with anti noise pad as standard</li>\r\n<li style=\"text-align: justify;\">Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li style=\"text-align: justify;\">Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17181,75,0,6417,'<style>#html-body [data-pb-style=EKQ1LTC]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"EKQ1LTC\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p style=\"text-align: justify;\"><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 170 x 75cm- BE1380-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">Indulge in the luxurious Bette Starlet Bath, designed for ultimate relaxation. Available in the size of steel bath 1700 x 750, this stunning bath offers both style and comfort. Elevate your bathing experience with the Bette Starlet. Bette Starlet 1700, High Quality Steel, Double Ended Bath. Design of anything matters a lot as we all prefer those things that catch our eyes. Bette Starlet bath is offered to you by Bette as its designing is mind blowing and can capture many eyes in the first sight. It has centrally-positioned drain that is making it a more efficient bath regarding its functionality. This double ended bath will allow you to enjoy comfortable bath moments every time you use it. The manufacturing of this Bette bath is done with high-quality stainless steel that has made it extremely hygienic and long lasting. Heat can effortlessly pass through it so you will get a warm touch whenever you use this bath. It is fitted with anti-noise pad as standard. It is resistant to chemicals, scratches, and impact so you can clean it easily with any bath cleaner.</p>\r\n<p style=\"text-align: justify;\"><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li style=\"text-align: justify;\">Shape : Rectangular</li>\r\n<li style=\"text-align: justify;\">Double ended bath</li>\r\n<li style=\"text-align: justify;\">Super steel bath</li>\r\n<li style=\"text-align: justify;\">No tap hole and 2 tap holes option available</li>\r\n<li style=\"text-align: justify;\">Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li style=\"text-align: justify;\">Centrally-positioned drain</li>\r\n<li style=\"text-align: justify;\">Comes fitted with anti noise pad as standard</li>\r\n<li style=\"text-align: justify;\">Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li style=\"text-align: justify;\">Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17182,155,0,6417,'Exclude'),(17183,85,5,6418,'Bette Starlet Steel Bath 1800 x 750mm  - Banyo.co.uk'),(17184,85,0,6418,'Bette Starlet Steel Bath 1800 x 750mm  - Banyo.co.uk'),(17185,76,5,6418,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17186,76,0,6418,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17187,75,5,6418,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 180 x 75cm No tap Hole - BE1430-000 </strong></span></p>\n<p>Bette Starlet Super Steel bath has a unique rectangular shape that catches the eye even at first sight. This super steel bath is refined with a unique BETTEGLAZE enamel finish that is made of using water, borax, soda, quartz, glass. It is hygienic because it is made from sturdy titanium finished steel so germs will not grow in your bathroom. It can be cleaned with any bath cleaner as it is resistant to chemicals. The centrally positioned drain is increasing the functionality of this bath and it is supplied without any pre-drilled tap hole. Bette is rendering a guarantee of 30 years for your peace of mind and Banyo is offering an incredible discount on this Bette Starlet bath.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Centrally-positioned drain</li><li>Comes fitted with anti noise pad as standard</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17188,75,0,6418,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 180 x 75cm No tap Hole - BE1430-000 </strong></span></p>\n<p>Bette Starlet Super Steel bath has a unique rectangular shape that catches the eye even at first sight. This super steel bath is refined with a unique BETTEGLAZE enamel finish that is made of using water, borax, soda, quartz, glass. It is hygienic because it is made from sturdy titanium finished steel so germs will not grow in your bathroom. It can be cleaned with any bath cleaner as it is resistant to chemicals. The centrally positioned drain is increasing the functionality of this bath and it is supplied without any pre-drilled tap hole. Bette is rendering a guarantee of 30 years for your peace of mind and Banyo is offering an incredible discount on this Bette Starlet bath.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Centrally-positioned drain</li><li>Comes fitted with anti noise pad as standard</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17189,155,0,6418,'Exclude'),(17190,85,5,6419,'Bette Starlet Super Steel Bath 175 x 80cm - BE1450-000'),(17191,85,0,6419,'Bette Starlet Super Steel Bath 175 x 80cm - BE1450-000'),(17192,76,5,6419,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17193,76,0,6419,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17194,75,5,6419,'<style>#html-body [data-pb-style=Y97YCJK]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"Y97YCJK\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 175 x 80cm- BE1450-000</strong></span></p>\r\n<p id=\"N12KMVL\" style=\"text-align: justify;\">Bette Starlet Super bath is brought to you by one of the leading brands, Bette. This 1750 bath has a width of 800mm and a depth of 420mm. The shape of this incredible deep bathtubs 1700 x 700 is rectangular and it can be installed in any extra large bathroom whether it is large or small as it is intelligently designed. An anti-noise pad is also fitted with this big bath as a standard as well as there is a centrally positioned drain. This double ended bath can be filled up to 139 litres of water that renders a comfortable use to you. The white colour looks quite elegant whereas the seamless round shape inside the rectangular shape is adding worth to it. This 1750 x 800 double ended super steel bath is supplied without tap hole but feet are supplied with it. The sturdy titanium finished steel is making it highly durable and long-lasting. Bring it home to give an enlightening touch to your home.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17195,75,0,6419,'<style>#html-body [data-pb-style=Y97YCJK]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"Y97YCJK\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 175 x 80cm- BE1450-000</strong></span></p>\r\n<p id=\"N12KMVL\" style=\"text-align: justify;\">Bette Starlet Super bath is brought to you by one of the leading brands, Bette. This 1750 bath has a width of 800mm and a depth of 420mm. The shape of this incredible deep bathtubs 1700 x 700 is rectangular and it can be installed in any extra large bathroom whether it is large or small as it is intelligently designed. An anti-noise pad is also fitted with this big bath as a standard as well as there is a centrally positioned drain. This double ended bath can be filled up to 139 litres of water that renders a comfortable use to you. The white colour looks quite elegant whereas the seamless round shape inside the rectangular shape is adding worth to it. This 1750 x 800 double ended super steel bath is supplied without tap hole but feet are supplied with it. The sturdy titanium finished steel is making it highly durable and long-lasting. Bring it home to give an enlightening touch to your home.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17196,155,0,6419,'Exclude'),(17197,85,5,6420,'Bette Starlet Super Steel Bath 180 x 80cm - BE1630-000'),(17198,85,0,6420,'Bette Starlet Super Steel Bath 180 x 80cm - BE1630-000'),(17199,76,5,6420,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17200,76,0,6420,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17201,75,5,6420,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 180 x 80cm - BE1630-000 </strong></span></p>\r\n<p>Your search for comfortable bath should stop exactly at Bette Starlet Super bath as there is no comparison of its features and designing. The eye-catching designing of this bath attracts everyone as it looks great with any type of designs and gives an elegant look. There is an anti-noised pad fitted with this bath to give you comfortable use. UV rays can affect the surface of this bath as it is resistant to UV due to the construction with sturdy titanium finished steel. Scratches will not stay longer on it as this double ended bath is scratch and impact resistant. The length of this 1800mm whereas the width is 800mm and the depth is of 420mm. You can clean it with any bath cleaner as it is resistant to chemicals so they will not react with its smooth and shiny surface.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17202,75,0,6420,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 180 x 80cm - BE1630-000 </strong></span></p>\r\n<p>Your search for comfortable bath should stop exactly at Bette Starlet Super bath as there is no comparison of its features and designing. The eye-catching designing of this bath attracts everyone as it looks great with any type of designs and gives an elegant look. There is an anti-noised pad fitted with this bath to give you comfortable use. UV rays can affect the surface of this bath as it is resistant to UV due to the construction with sturdy titanium finished steel. Scratches will not stay longer on it as this double ended bath is scratch and impact resistant. The length of this 1800mm whereas the width is 800mm and the depth is of 420mm. You can clean it with any bath cleaner as it is resistant to chemicals so they will not react with its smooth and shiny surface.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17203,155,0,6420,'Exclude'),(17204,85,5,6421,'Bette Starlet Super Steel Bath 170 x 70cm No Tap Hole - BE1730-000'),(17205,85,0,6421,'Bette Starlet Super Steel Bath 170 x 70cm No Tap Hole - BE1730-000'),(17206,76,5,6421,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17207,76,0,6421,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17208,75,5,6421,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 170 x 70cm No tap Hole - BE1730-000 </strong></span></p>\n<p>The elegant designing of Bette starlet bath is quite eye catching whereas the features of this double ended bath are also unmatchable. Any type of bath cleaner can be used for its cleaning as it is highly resistant to chemicals. You will find it hygienic as germs cannot grow in the presence of this bath so you will be able to enjoy with peaceful mind. Bring it home by availing an exciting discount offered by Banyo. Bette is rendering a guarantee of 30 years on this product for your peace of mind. This comfortable single ended bath is suppliedand there is No tap Hole in it. Its non-fading stable white colour is making it more incredible as it will retain its look even after decades of use.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17209,75,0,6421,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 170 x 70cm No tap Hole - BE1730-000 </strong></span></p>\n<p>The elegant designing of Bette starlet bath is quite eye catching whereas the features of this double ended bath are also unmatchable. Any type of bath cleaner can be used for its cleaning as it is highly resistant to chemicals. You will find it hygienic as germs cannot grow in the presence of this bath so you will be able to enjoy with peaceful mind. Bring it home by availing an exciting discount offered by Banyo. Bette is rendering a guarantee of 30 years on this product for your peace of mind. This comfortable single ended bath is suppliedand there is No tap Hole in it. Its non-fading stable white colour is making it more incredible as it will retain its look even after decades of use.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17210,155,0,6421,'Exclude'),(17211,85,5,6422,'Bette Starlet Super Steel Bath 190 x 90cm - BE1830-000'),(17212,85,0,6422,'Bette Starlet Super Steel Bath 190 x 90cm - BE1830-000'),(17213,76,5,6422,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17214,76,0,6422,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17215,75,5,6422,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 190 x 90cm- BE1830-000 </strong></span></p><p>Bette Starlet super bath is offered to you by Bette as there is no comparison of its functionality and features. The dimensions of this bath include a length of 1900mm, a width of 900mm and a depth of 420mm. This double ended bath is available in rectangular shape whereas it can be filled up to 205 litres. You will find it highly hygienic as germs cannot prevail in the presence of this bath because it is made from sturdy titanium finished steel that makes it hygienic as well as durable. It is resistant to chemicals so you can use any bath cleaner to clean this bath as well as UV rays will also not affect this bath because it is resistant to UV rays also. Bring it home for making your bathroom a functional place to use.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17216,75,0,6422,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 190 x 90cm- BE1830-000 </strong></span></p><p>Bette Starlet super bath is offered to you by Bette as there is no comparison of its functionality and features. The dimensions of this bath include a length of 1900mm, a width of 900mm and a depth of 420mm. This double ended bath is available in rectangular shape whereas it can be filled up to 205 litres. You will find it highly hygienic as germs cannot prevail in the presence of this bath because it is made from sturdy titanium finished steel that makes it hygienic as well as durable. It is resistant to chemicals so you can use any bath cleaner to clean this bath as well as UV rays will also not affect this bath because it is resistant to UV rays also. Bring it home for making your bathroom a functional place to use.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17217,155,0,6422,'Exclude'),(17218,85,5,6423,'Bette Starlet Super Steel Bath 160 x 65cm No Tap Hole - BE2540-000'),(17219,85,0,6423,'Bette Starlet Super Steel Bath 160 x 65cm No Tap Hole - BE2540-000'),(17220,76,5,6423,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17221,76,0,6423,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17222,75,5,6423,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 160 x 65cm No tap Hole - BE2540-000 </strong></span></p>\n<p>Bette Starlet bath is an incredible choice for those who want to add a functional bath in their bathroom. The outstanding dimensions of this bath include a length of 1600mm, a width of 650mm wide bath and a depth of 420mm. The colour of this super steel bath is white that looks great with any design of bathroom and it can efficiently retain its shiny finish for many years. You will find its surface as smooth and glossy as at the time of its purchasing. No tap Hole is included in its features and it is fitted with anti-noise pad as standard. It will render spacious standing area with outlet to the centre. It is made from sturdy titanium finished steel as well as refined with a unique BETTEGLAZE enamel finish. Bring it home to get an amazing discount offered by Banyo.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Centrally-positioned drain</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17223,75,0,6423,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 160 x 65cm No tap Hole - BE2540-000 </strong></span></p>\n<p>Bette Starlet bath is an incredible choice for those who want to add a functional bath in their bathroom. The outstanding dimensions of this bath include a length of 1600mm, a width of 650mm wide bath and a depth of 420mm. The colour of this super steel bath is white that looks great with any design of bathroom and it can efficiently retain its shiny finish for many years. You will find its surface as smooth and glossy as at the time of its purchasing. No tap Hole is included in its features and it is fitted with anti-noise pad as standard. It will render spacious standing area with outlet to the centre. It is made from sturdy titanium finished steel as well as refined with a unique BETTEGLAZE enamel finish. Bring it home to get an amazing discount offered by Banyo.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Centrally-positioned drain</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17224,155,0,6423,'Exclude'),(17225,85,5,6424,'Bette Set Super Steel Bath 150 x 75cm - BE2560-000 '),(17226,85,0,6424,'Bette Set Super Steel Bath 150 x 75cm - BE2560-000 '),(17227,76,5,6424,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Set Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17228,76,0,6424,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Set Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17229,75,5,6424,'<style>#html-body [data-pb-style=N9LGPMC]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"N9LGPMC\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Set Super Steel Bath 150 x 75cm- BE2560-000</strong></span></p>\r\n<p>Bring home an exciting bath that will make your life easier as you can relax in this bath after a hectic routine. Your comfort matters for Bette and that is why all of its products are always designed with the thought to render you unbeatable comfort. This Bette Set bath renders you an additional benefit as there is No tap Hole in this bath. Germs and bacteria usually grow with speed in bathrooms but you should be happy that your bathroom will be bacteria free as the smooth and hygienic surface of Bette bath does not allow bacteria to grow and keeps your bathroom a hygienic place to be used. The white shine of this bath is long lasting as it will stay same even after the decades of use. This Bette steel bath is available at banyo with a discounted price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Distinctive bath form</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17230,75,0,6424,'<style>#html-body [data-pb-style=N9LGPMC]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"N9LGPMC\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Set Super Steel Bath 150 x 75cm- BE2560-000</strong></span></p>\r\n<p>Bring home an exciting bath that will make your life easier as you can relax in this bath after a hectic routine. Your comfort matters for Bette and that is why all of its products are always designed with the thought to render you unbeatable comfort. This Bette Set bath renders you an additional benefit as there is No tap Hole in this bath. Germs and bacteria usually grow with speed in bathrooms but you should be happy that your bathroom will be bacteria free as the smooth and hygienic surface of Bette bath does not allow bacteria to grow and keeps your bathroom a hygienic place to be used. The white shine of this bath is long lasting as it will stay same even after the decades of use. This Bette steel bath is available at banyo with a discounted price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Distinctive bath form</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17231,155,0,6424,'Exclude'),(17232,85,5,6425,'Bette Starlet Super Steel Bath 157 x 70cm  - No TH - BE2590-000'),(17233,85,0,6425,'Bette Starlet Super Steel Bath 157 x 70cm  - No TH - BE2590-000'),(17234,76,5,6425,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17235,76,0,6425,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17236,75,5,6425,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 157 x 70cm &amp; Feet - No TH - BE2590-000 </strong></span></p><p>Bette Starlet Super bath is famous for its unique features and unmatchable quality. This 1570 bath is an ideal solution for those who need a functional bath for their bathroom. There is a centrally positioned drain that will render more functionality as it can be filled up to 116 litres. The dimensions of this bath are suitable enough to give a comfortable use as its width is 700mm and depth of 420mm. There is no pre-drilled tap hole in this bath to give you maximum comfort. An anti-noised pad is fitted with it as a standard and the sturdy titanium finished steel increase the durability of this bath. It is an excellent conductor of heat so you will get a warm and cosy feeling in the winters as heat will pass through it effortlessly.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li><li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n'),(17237,75,0,6425,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 157 x 70cm &amp; Feet - No TH - BE2590-000 </strong></span></p><p>Bette Starlet Super bath is famous for its unique features and unmatchable quality. This 1570 bath is an ideal solution for those who need a functional bath for their bathroom. There is a centrally positioned drain that will render more functionality as it can be filled up to 116 litres. The dimensions of this bath are suitable enough to give a comfortable use as its width is 700mm and depth of 420mm. There is no pre-drilled tap hole in this bath to give you maximum comfort. An anti-noised pad is fitted with it as a standard and the sturdy titanium finished steel increase the durability of this bath. It is an excellent conductor of heat so you will get a warm and cosy feeling in the winters as heat will pass through it effortlessly.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li><li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n'),(17238,155,0,6425,'Exclude'),(17239,85,5,6426,'Bette Set Super Steel Bath 170 x 75cm  - BE3060-000, Bette Set\r\n\r\n'),(17240,85,0,6426,'Bette Set Super Steel Bath 170 x 75cm  - BE3060-000, Bette Set\r\n\r\n'),(17241,76,5,6426,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Set Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17242,76,0,6426,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Set Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17243,75,5,6426,'<style>#html-body [data-pb-style=VO45C5U]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"VO45C5U\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p style=\"text-align: justify;\"><span style=\"font-size: medium;\"><strong>Bette Set Super Steel Bath 170 x 75cm- BE3060-000</strong></span></p>\r\n<p style=\"text-align: justify;\">Discover the elegance of the Bette Set Baths. With its superior design and durability, the Bette Set in the size of 1700 x 750 offers a luxurious bathing experience. Choose the Bette Set Super Steel Bath to enhance your bathroom with timeless style and exceptional quality. Bette Set bath is designed for comfort. If you want to enjoy comfortable bath moments then there is no other bath is recommended to you other than Bette super steel bath. The outer shape of this single ended bath is rectangular whereas the inner shape has rounded curves that can catch your eye easily. It will be a great choice for small bathrooms as it occupies less space but renders unmatchable functionality. Material is the most vital thing in any products and this Bette bath is made from sturdy titanium finished steel which makes it strong, durable, and long lasting.</p>\r\n<p style=\"text-align: justify;\"><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li style=\"text-align: justify;\">Shape : Rectangular</li>\r\n<li style=\"text-align: justify;\">Single ended bath</li>\r\n<li style=\"text-align: justify;\">Super steel bath</li>\r\n<li style=\"text-align: justify;\">Distinctive bath form</li>\r\n<li style=\"text-align: justify;\">Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li style=\"text-align: justify;\">No tap hole and 2 tap holes option available</li>\r\n<li style=\"text-align: justify;\">Fitted with anti noise pad as standard</li>\r\n<li style=\"text-align: justify;\">Space-saving bath for small bathrooms</li>\r\n<li style=\"text-align: justify;\">Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li style=\"text-align: justify;\">The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li style=\"text-align: justify;\">Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17244,75,0,6426,'<style>#html-body [data-pb-style=VO45C5U]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"VO45C5U\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p style=\"text-align: justify;\"><span style=\"font-size: medium;\"><strong>Bette Set Super Steel Bath 170 x 75cm- BE3060-000</strong></span></p>\r\n<p style=\"text-align: justify;\">Discover the elegance of the Bette Set Baths. With its superior design and durability, the Bette Set in the size of 1700 x 750 offers a luxurious bathing experience. Choose the Bette Set Super Steel Bath to enhance your bathroom with timeless style and exceptional quality. Bette Set bath is designed for comfort. If you want to enjoy comfortable bath moments then there is no other bath is recommended to you other than Bette super steel bath. The outer shape of this single ended bath is rectangular whereas the inner shape has rounded curves that can catch your eye easily. It will be a great choice for small bathrooms as it occupies less space but renders unmatchable functionality. Material is the most vital thing in any products and this Bette bath is made from sturdy titanium finished steel which makes it strong, durable, and long lasting.</p>\r\n<p style=\"text-align: justify;\"><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li style=\"text-align: justify;\">Shape : Rectangular</li>\r\n<li style=\"text-align: justify;\">Single ended bath</li>\r\n<li style=\"text-align: justify;\">Super steel bath</li>\r\n<li style=\"text-align: justify;\">Distinctive bath form</li>\r\n<li style=\"text-align: justify;\">Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li style=\"text-align: justify;\">No tap hole and 2 tap holes option available</li>\r\n<li style=\"text-align: justify;\">Fitted with anti noise pad as standard</li>\r\n<li style=\"text-align: justify;\">Space-saving bath for small bathrooms</li>\r\n<li style=\"text-align: justify;\">Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li style=\"text-align: justify;\">The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li style=\"text-align: justify;\">Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17245,155,0,6426,'Exclude'),(17246,85,5,6427,'Bette Classic Super Steel Bath 170 x 75cm - BE3110-000, Bette Classic, Banyo'),(17247,85,0,6427,'Bette Classic Super Steel Bath 170 x 75cm - BE3110-000, Bette Classic, Banyo'),(17248,76,5,6427,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17249,76,0,6427,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17250,75,5,6427,'<p><strong><a title=\"Bette Classic Super Steel Bath - Single Ended\" href=\"/bette-classic-super-steel-single-ended-bath.html\" target=\"_blank\" rel=\"noopener\">Bette Classic Super Steel Bath 170 x 75cm- BE3110-000</a></strong></p>\r\n<p style=\"text-align: justify;\">Bette classic steel bath is really a classic bath from all its aspects. It has intelligently designed as its each every corner is seamlessly manufactured. The straight line inner body of this <a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>Bette bath</strong></span></a> harmonises perfectly with the outer rectangle. You can relax in this steel bath easily as its back is ergonomically designed to give you more comfort. The sturdy titanium finished steel is making this bath not only durable but a hygienic product.  </p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li></ul>\r\n'),(17251,75,0,6427,'<p><strong><a title=\"Bette Classic Super Steel Bath - Single Ended\" href=\"/bette-classic-super-steel-single-ended-bath.html\" target=\"_blank\" rel=\"noopener\">Bette Classic Super Steel Bath 170 x 75cm- BE3110-000</a></strong></p>\r\n<p style=\"text-align: justify;\">Bette classic steel bath is really a classic bath from all its aspects. It has intelligently designed as its each every corner is seamlessly manufactured. The straight line inner body of this <a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>Bette bath</strong></span></a> harmonises perfectly with the outer rectangle. You can relax in this steel bath easily as its back is ergonomically designed to give you more comfort. The sturdy titanium finished steel is making this bath not only durable but a hygienic product.  </p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li></ul>\r\n'),(17252,155,0,6427,'Exclude'),(17253,85,5,6428,'Bette One Relax Super Steel Bath 180 x 80cm No Tap Hole - BE3323-000'),(17254,85,0,6428,'Bette One Relax Super Steel Bath 180 x 80cm No Tap Hole - BE3323-000'),(17255,76,5,6428,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-one-relax-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette One Relax Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17256,76,0,6428,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-one-relax-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette One Relax Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17257,75,5,6428,'<p><span style=\"font-size: medium;\"><strong>Bette One Relax Super Steel Bath 180 x 80cm No tap Hole - BE3323-000 </strong></span></p>\n<p>Choosing Bette One Relax Super Steel bath is a wise decision as there is no comparison of its functionality. It is designed with broad tray edge that is highlighted by the flush, angular outlet with an enamelled cover. This single ended bath can be filled up to 155 litres to render you ease of use. The length of this bath is 1800mm whereas the width is 800mm and the depth is 450mm. It is highly durable and strong than other ordinary baths and the white colour of this bath can suit to any design of the bathroom. It will be rendered to you without any tap hole. It is made from sturdy steel so there is no doubt in its durability and you can use any bath cleaner for its cleaning as it is resistant to chemicals. Bring it home for giving an incredible touch to the design of your bathroom.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Fitted with anti noise pad as standard</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n<li>With broad trayedge is highlighted by the angular, flush outlet with an enamelled cover</li>\n</ul>'),(17258,75,0,6428,'<p><span style=\"font-size: medium;\"><strong>Bette One Relax Super Steel Bath 180 x 80cm No tap Hole - BE3323-000 </strong></span></p>\n<p>Choosing Bette One Relax Super Steel bath is a wise decision as there is no comparison of its functionality. It is designed with broad tray edge that is highlighted by the flush, angular outlet with an enamelled cover. This single ended bath can be filled up to 155 litres to render you ease of use. The length of this bath is 1800mm whereas the width is 800mm and the depth is 450mm. It is highly durable and strong than other ordinary baths and the white colour of this bath can suit to any design of the bathroom. It will be rendered to you without any tap hole. It is made from sturdy steel so there is no doubt in its durability and you can use any bath cleaner for its cleaning as it is resistant to chemicals. Bring it home for giving an incredible touch to the design of your bathroom.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Fitted with anti noise pad as standard</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n<li>With broad trayedge is highlighted by the angular, flush outlet with an enamelled cover</li>\n</ul>'),(17259,155,0,6428,'Exclude'),(17260,85,5,6429,'Bette One Relax Super Steel Bath 190 x 90cm No Tap Hole - BE3324-000'),(17261,85,0,6429,'Bette One Relax Super Steel Bath 190 x 90cm No Tap Hole - BE3324-000'),(17262,76,5,6429,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-one-relax-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette One Relax Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17263,76,0,6429,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-one-relax-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette One Relax Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17264,75,5,6429,'<p><span style=\"font-size: medium;\"><strong>Bette One Relax Super Steel Bath 190 x 90cm No tap Hole - BE3324-000 </strong></span></p><p>Give a place to Bette One Relax Super Steel Bath in your bathroom to render more functionality to your bathroom. It is designed without any pre-drilled tap hole and can be filled up to 210 litres of water. It is a single ended bath and has a rectangular shape which adds beauty to any design of the bathroom. An anti-noise pad is fitted in this bath as a standard. You can clean it with any bathroom cleaner as it will not react with any chemical. It is supplied with broad trayedge that highlights it by angular, a flush outlet with an enamelled cover. It is made from sturdy titanium super steel that renders durability and stability to it for making it an incredible choice for you.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Fitted with anti noise pad as standard</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n<li>With broad tray edge is highlighted by the angular, flush outlet with an enamelled cover</li>\n</ul>'),(17265,75,0,6429,'<p><span style=\"font-size: medium;\"><strong>Bette One Relax Super Steel Bath 190 x 90cm No tap Hole - BE3324-000 </strong></span></p><p>Give a place to Bette One Relax Super Steel Bath in your bathroom to render more functionality to your bathroom. It is designed without any pre-drilled tap hole and can be filled up to 210 litres of water. It is a single ended bath and has a rectangular shape which adds beauty to any design of the bathroom. An anti-noise pad is fitted in this bath as a standard. You can clean it with any bathroom cleaner as it will not react with any chemical. It is supplied with broad trayedge that highlights it by angular, a flush outlet with an enamelled cover. It is made from sturdy titanium super steel that renders durability and stability to it for making it an incredible choice for you.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Fitted with anti noise pad as standard</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n<li>With broad tray edge is highlighted by the angular, flush outlet with an enamelled cover</li>\n</ul>'),(17266,155,0,6429,'Exclude'),(17267,85,5,6430,'Bette One Relax Super Steel Bath 2000 × 900mm - No TH'),(17268,85,0,6430,'Bette One Relax Super Steel Bath 2000 × 900mm - No TH'),(17269,76,5,6430,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-one-relax-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette One Relax Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17270,76,0,6430,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-one-relax-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette One Relax Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17271,75,5,6430,'<p><span style=\"font-size: medium;\"><strong>Bette One Relax Super Steel Bath 2000 x 900mm No tap Hole - 3325 </strong></span></p><p>Bette One Relax Super Steel Bath 2000 x 900mm No tap Hole - 3325</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>With broad trayedge is highlighted by the angular, flush outlet with an enamelled cover</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n\n</ul> '),(17272,75,0,6430,'<p><span style=\"font-size: medium;\"><strong>Bette One Relax Super Steel Bath 2000 x 900mm No tap Hole - 3325 </strong></span></p><p>Bette One Relax Super Steel Bath 2000 x 900mm No tap Hole - 3325</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>With broad trayedge is highlighted by the angular, flush outlet with an enamelled cover</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n\n</ul> '),(17273,155,0,6430,'Exclude'),(17274,85,5,6431,'Bette Form Normal Steel Bath 1400 x 700mm  - Banyo'),(17275,85,0,6431,'Bette Form Normal Steel Bath 1400 x 700mm  - Banyo'),(17276,76,5,6431,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17277,76,0,6431,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17278,75,5,6431,'<style>#html-body [data-pb-style=T0CIRTV]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"T0CIRTV\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 140 x 70cm - BE3400-000</strong></span></p>\r\n<p style=\"text-align: justify;\">If you want to get wonderful bath 1400 x 700 moments then Bette super steel bath is more than an efficient choice for you. This 700mm bath works beyond your expectations as it is a good heat conductor, resistant to chemicals and UV as well as hygienic to use. You can clean this single ended bath within no time as it resists stains, scratches, and impact. It is not only durable but renders long lasting functionality than other normal baths. 85 litres of water can be filled in this bath so you can take an easy and comfortable bath anytime. It is suppliedand its depth is 420mm. The white colour of this <span style=\"color: #333399;\"><a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #333399;\"><strong>super steel bath</strong></span></a> l</span>ooks quite elegant with any bathroom design and its installation is also very easy. Bring it home for converting your ordinary bath moments into the comfortable ones.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape: Rectangular</li>\r\n<li>Single Ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17279,75,0,6431,'<style>#html-body [data-pb-style=T0CIRTV]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"T0CIRTV\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 140 x 70cm - BE3400-000</strong></span></p>\r\n<p style=\"text-align: justify;\">If you want to get wonderful bath 1400 x 700 moments then Bette super steel bath is more than an efficient choice for you. This 700mm bath works beyond your expectations as it is a good heat conductor, resistant to chemicals and UV as well as hygienic to use. You can clean this single ended bath within no time as it resists stains, scratches, and impact. It is not only durable but renders long lasting functionality than other normal baths. 85 litres of water can be filled in this bath so you can take an easy and comfortable bath anytime. It is suppliedand its depth is 420mm. The white colour of this <span style=\"color: #333399;\"><a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #333399;\"><strong>super steel bath</strong></span></a> l</span>ooks quite elegant with any bathroom design and its installation is also very easy. Bring it home for converting your ordinary bath moments into the comfortable ones.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape: Rectangular</li>\r\n<li>Single Ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17280,155,0,6431,'Exclude'),(17281,85,5,6432,'Bette Select Super Steel Bath 160 x 70cm - BE3410-000HL'),(17282,85,0,6432,'Bette Select Super Steel Bath 160 x 70cm - BE3410-000HL'),(17283,76,5,6432,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-select-bath-with-overflow-foot-end.html\">&gt;&nbsp;&nbsp;View all Bette Select Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17284,76,0,6432,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-select-bath-with-overflow-foot-end.html\">&gt;&nbsp;&nbsp;View all Bette Select Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17285,75,5,6432,'<p><strong>Bette Select Super Steel Bath 160 x 70cm - BE3410-000HL</strong></p>\r\n<p style=\"text-align: justify;\">Are you going to rebuild your bathroom or making new one? Well, a bath is the most essential thing in any bathroom that should be selected carefully. Bette&rsquo;s all products usually display outstanding quality and designing. Bette Select super steel bath is a new range introduced by Bette to make your lives more comfortable. It is manufactured by following latest standards of manufacturing and the material used in its crafting is of high-quality. This <a href=\"/brands/bette.html\" target=\"_blank\"><span style=\"color: #3366ff;\">Bette steel bath</span></a> is made from super steel that brings lots of unbeatable features to it. It is supplied with overflow hole at foot end and the rectangular shape of this bath gives an enlightening touch to the design of your bathroom. It is refined with a unique BETTEGLAZE enamel finish that adds worth to it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n'),(17286,75,0,6432,'<p><strong>Bette Select Super Steel Bath 160 x 70cm - BE3410-000HL</strong></p>\r\n<p style=\"text-align: justify;\">Are you going to rebuild your bathroom or making new one? Well, a bath is the most essential thing in any bathroom that should be selected carefully. Bette&rsquo;s all products usually display outstanding quality and designing. Bette Select super steel bath is a new range introduced by Bette to make your lives more comfortable. It is manufactured by following latest standards of manufacturing and the material used in its crafting is of high-quality. This <a href=\"/brands/bette.html\" target=\"_blank\"><span style=\"color: #3366ff;\">Bette steel bath</span></a> is made from super steel that brings lots of unbeatable features to it. It is supplied with overflow hole at foot end and the rectangular shape of this bath gives an enlightening touch to the design of your bathroom. It is refined with a unique BETTEGLAZE enamel finish that adds worth to it.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n'),(17287,155,0,6432,'Exclude'),(17288,85,5,6433,'Bette Select Super Steel Bath 170 x 70cm - BE3411-000'),(17289,85,0,6433,'Bette Select Super Steel Bath 170 x 70cm - BE3411-000'),(17290,76,5,6433,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-select-bath-with-overflow-foot-end.html\">&gt;&nbsp;&nbsp;View all Bette Select Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17291,76,0,6433,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-select-bath-with-overflow-foot-end.html\">&gt;&nbsp;&nbsp;View all Bette Select Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17292,75,5,6433,'<p><span style=\"font-size: medium;\"><strong>Bette Select Super Steel Bath 170 x 70cm- BE3411-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">Bette bath is famous for its functionality and alluring designing. It is supplied with the overflow hole at foot end. You will find this super steel bath a perfect addition to your contemporary bathroom. It is manufactured by following latest standards of manufacturing and the material used in its crafting is of high-quality. This <a href=\"/brands/bette.html\" target=\"_blank\"><span style=\"color: #3366ff;\">Bette steel bath</span></a> is made from super steel that brings lots of unbeatable features to it. It is supplied with overflow hole at foot end and the rectangular shape of this bath gives an enlightening touch to the design of your bathroom. It is refined with a unique BETTEGLAZE enamel finish that adds worth to it. Bring it home to enjoy its warm touch.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17293,75,0,6433,'<p><span style=\"font-size: medium;\"><strong>Bette Select Super Steel Bath 170 x 70cm- BE3411-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">Bette bath is famous for its functionality and alluring designing. It is supplied with the overflow hole at foot end. You will find this super steel bath a perfect addition to your contemporary bathroom. It is manufactured by following latest standards of manufacturing and the material used in its crafting is of high-quality. This <a href=\"/brands/bette.html\" target=\"_blank\"><span style=\"color: #3366ff;\">Bette steel bath</span></a> is made from super steel that brings lots of unbeatable features to it. It is supplied with overflow hole at foot end and the rectangular shape of this bath gives an enlightening touch to the design of your bathroom. It is refined with a unique BETTEGLAZE enamel finish that adds worth to it. Bring it home to enjoy its warm touch.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17294,155,0,6433,'Exclude'),(17295,85,5,6434,'Bette Select Super Steel Bath 170 x 75cm  - BE3412-000, Bette Select\r\n\r\n'),(17296,85,0,6434,'Bette Select Super Steel Bath 170 x 75cm  - BE3412-000, Bette Select\r\n\r\n'),(17297,76,5,6434,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-select-bath-with-overflow-foot-end.html\">&gt;&nbsp;&nbsp;View all Bette Select Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17298,76,0,6434,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-select-bath-with-overflow-foot-end.html\">&gt;&nbsp;&nbsp;View all Bette Select Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17299,75,5,6434,'<style>#html-body [data-pb-style=GS7PNUV]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"GS7PNUV\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Select Super Steel Bath 170 x 75cm &amp; Feet - BE3412-000</strong></span></p>\r\n<p style=\"text-align: justify;\">Bette always manufactures its products according to the latest standards of manufacturing to fulfil your need in the very best way. High-quality products of Bette are always available at cost effective rates. This bette select bath 1700 x 750 is made from high grade material to bring you convenience in the best way. It is intelligently manufactured so there are no loopholes in this bath and it is brought to you after so many tests to give to satisfactory results. Bring it home by availing an exciting discount offered by Banyo. Bette is rendering a guarantee of 30 years on this product for your peace of mind. This comfortable single ended bath is suppliedand there is No tap Hole in it. Its non-fading stable white colour is making it more incredible as it will retain its look even after decades of use.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n</div></div></div>'),(17300,75,0,6434,'<style>#html-body [data-pb-style=GS7PNUV]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"GS7PNUV\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Select Super Steel Bath 170 x 75cm &amp; Feet - BE3412-000</strong></span></p>\r\n<p style=\"text-align: justify;\">Bette always manufactures its products according to the latest standards of manufacturing to fulfil your need in the very best way. High-quality products of Bette are always available at cost effective rates. This bette select bath 1700 x 750 is made from high grade material to bring you convenience in the best way. It is intelligently manufactured so there are no loopholes in this bath and it is brought to you after so many tests to give to satisfactory results. Bring it home by availing an exciting discount offered by Banyo. Bette is rendering a guarantee of 30 years on this product for your peace of mind. This comfortable single ended bath is suppliedand there is No tap Hole in it. Its non-fading stable white colour is making it more incredible as it will retain its look even after decades of use.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n</div></div></div>'),(17301,155,0,6434,'Exclude'),(17302,85,5,6435,'Bette Select Super Steel Bath 180 x 80cm - BE3413-000'),(17303,85,0,6435,'Bette Select Super Steel Bath 180 x 80cm - BE3413-000'),(17304,76,5,6435,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-select-bath-with-overflow-foot-end.html\">&gt;&nbsp;&nbsp;View all Bette Select Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17305,76,0,6435,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-select-bath-with-overflow-foot-end.html\">&gt;&nbsp;&nbsp;View all Bette Select Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17306,75,5,6435,'<p><span style=\"font-size: medium;\"><strong>Bette Select Super Steel Bath 180 x 80cm- BE3413-000</strong></span></p><p>Bette Select bath is available in rectangular shape that looks great in any bathroom. It is a space saving bath so it will be great choice for small spaced bathrooms.There is an anti-noise pad fitted in this super steel bath and it is supplied without any tap hole. It is refined with unique BETTLE GLAZE enamel finish that is made by using quartz, borax, soda, glass, and water. It is intelligently manufactured so there are no loopholes in this bath and it is brought to you after so many tests to give to satisfactory results. Bring it home by availing an exciting discount offered by Banyo. Bette is rendering a guarantee of 30 years on this product for your peace of mind. This comfortable hip bath is suppliedand there is No tap Hole in it. Its non-fading stable white colour is making it more incredible as it will retain its look even after decades of use.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17307,75,0,6435,'<p><span style=\"font-size: medium;\"><strong>Bette Select Super Steel Bath 180 x 80cm- BE3413-000</strong></span></p><p>Bette Select bath is available in rectangular shape that looks great in any bathroom. It is a space saving bath so it will be great choice for small spaced bathrooms.There is an anti-noise pad fitted in this super steel bath and it is supplied without any tap hole. It is refined with unique BETTLE GLAZE enamel finish that is made by using quartz, borax, soda, glass, and water. It is intelligently manufactured so there are no loopholes in this bath and it is brought to you after so many tests to give to satisfactory results. Bring it home by availing an exciting discount offered by Banyo. Bette is rendering a guarantee of 30 years on this product for your peace of mind. This comfortable hip bath is suppliedand there is No tap Hole in it. Its non-fading stable white colour is making it more incredible as it will retain its look even after decades of use.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17308,155,0,6435,'Exclude'),(17309,85,5,6436,'Bette Select Super Steel Bath 160 x 70cm No Tap Hole - BE3420-000'),(17310,85,0,6436,'Bette Select Super Steel Bath 160 x 70cm No Tap Hole - BE3420-000'),(17311,76,5,6436,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-select-bath-with-overflow-foot-end.html\">&gt;&nbsp;&nbsp;View all Bette Select Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17312,76,0,6436,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-select-bath-with-overflow-foot-end.html\">&gt;&nbsp;&nbsp;View all Bette Select Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17313,75,5,6436,'<p><span style=\"font-size: medium;\"><strong>Bette Select Super Steel Bath 160 x 70cm No tap Hole - BE3420-000 BE3430-000 </strong></span></p>\n<p style=\"text-align: justify;\">Bette Super Steel bath has 700mm width and 420mm depth that is making it highly capable for any sized bathroom. This foot ended bath can be filled up to 119 litres of water to add comfort in your life. It is available with side overflow foot end right overflow as well as with side overflow foot end left overflow front. The colour of this <a href=\"/bette-select-super-steel-bath-160-x-70cm-feet-no-th.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>super steel bath</strong></span></a> is white that looks great with any design of bathroom and it can efficiently retain its shiny finish for many years. You will find its surface as smooth and glossy as at the time of its purchasing. No tap Hole is included in its features and it is fitted with anti-noise pad as standard. It will render a spacious standing area with an outlet to the centre. It is made from sturdy titanium finished steel as well as refined with a unique BETTEGLAZE enamel finish. Bring it home to get an amazing discount offered by Banyo.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Spacious standing area, with outlet to the center</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>Made from sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat-conducting, hygienic easy-care, resistant to chemicals, scratch and impact-resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17314,75,0,6436,'<p><span style=\"font-size: medium;\"><strong>Bette Select Super Steel Bath 160 x 70cm No tap Hole - BE3420-000 BE3430-000 </strong></span></p>\n<p style=\"text-align: justify;\">Bette Super Steel bath has 700mm width and 420mm depth that is making it highly capable for any sized bathroom. This foot ended bath can be filled up to 119 litres of water to add comfort in your life. It is available with side overflow foot end right overflow as well as with side overflow foot end left overflow front. The colour of this <a href=\"/bette-select-super-steel-bath-160-x-70cm-feet-no-th.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>super steel bath</strong></span></a> is white that looks great with any design of bathroom and it can efficiently retain its shiny finish for many years. You will find its surface as smooth and glossy as at the time of its purchasing. No tap Hole is included in its features and it is fitted with anti-noise pad as standard. It will render a spacious standing area with an outlet to the centre. It is made from sturdy titanium finished steel as well as refined with a unique BETTEGLAZE enamel finish. Bring it home to get an amazing discount offered by Banyo.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Spacious standing area, with outlet to the center</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>Made from sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat-conducting, hygienic easy-care, resistant to chemicals, scratch and impact-resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17315,155,0,6436,'Exclude'),(17316,85,5,6437,'Bette Select Super Steel Bath 170 x 70cm No Tap Hole - BE3421-000 BE3431-000'),(17317,85,0,6437,'Bette Select Super Steel Bath 170 x 70cm No Tap Hole - BE3421-000 BE3431-000'),(17318,76,5,6437,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-select-bath-with-overflow-foot-end.html\">&gt;&nbsp;&nbsp;View all Bette Select Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17319,76,0,6437,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-select-bath-with-overflow-foot-end.html\">&gt;&nbsp;&nbsp;View all Bette Select Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17320,75,5,6437,'<p><span style=\"font-size: medium;\"><strong>Bette Select Super Steel Bath 170 x 70cm No tap Hole - BE3421-000 BE3431-000 </strong></span></p>\n<p style=\"text-align: justify;\">Give a place to Bette Super Steel bath in your bathroom to get more functional results. It’s perfect dimensions will facilitate you in the very best way. The width of this bath is 700mm whereas its depth is 420mm. It is rendered to you with side overflow foot end right overflow as well as with side overflow foot end left overflow end. It will render you spacious standing area with outlet to the centre so it will be a great addition to your contemporary bathroom. Bette steel bath is an excellent conductor of heat to give you a smooth and warm touch in winters. It will allow you to relax in the very best way as its surface will give a smooth touch to your skin. Spend your money on the right product and enjoy its advantages in your whole life as its durability is unbeatable.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Spacious standing area, with outlet to the center</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17321,75,0,6437,'<p><span style=\"font-size: medium;\"><strong>Bette Select Super Steel Bath 170 x 70cm No tap Hole - BE3421-000 BE3431-000 </strong></span></p>\n<p style=\"text-align: justify;\">Give a place to Bette Super Steel bath in your bathroom to get more functional results. It’s perfect dimensions will facilitate you in the very best way. The width of this bath is 700mm whereas its depth is 420mm. It is rendered to you with side overflow foot end right overflow as well as with side overflow foot end left overflow end. It will render you spacious standing area with outlet to the centre so it will be a great addition to your contemporary bathroom. Bette steel bath is an excellent conductor of heat to give you a smooth and warm touch in winters. It will allow you to relax in the very best way as its surface will give a smooth touch to your skin. Spend your money on the right product and enjoy its advantages in your whole life as its durability is unbeatable.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Spacious standing area, with outlet to the center</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17322,155,0,6437,'Exclude'),(17323,85,5,6438,'Bette Select Super Steel Bath 170 x 75cm No Tap Hole - BE3432-000 BE3422-000'),(17324,85,0,6438,'Bette Select Super Steel Bath 170 x 75cm No Tap Hole - BE3432-000 BE3422-000'),(17325,76,5,6438,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-select-bath-with-overflow-foot-end.html\">&gt;&nbsp;&nbsp;View all Bette Select Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17326,76,0,6438,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-select-bath-with-overflow-foot-end.html\">&gt;&nbsp;&nbsp;View all Bette Select Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17327,75,5,6438,'<p><span style=\"font-size: medium;\"><strong>Bette Select Super Steel Bath 170 x 75cm No tap Hole - BE3432-000 BE3422-000 </strong></span></p>\n<p style=\"text-align: justify;\">Experience the excellence of the Bette Select Bath. With its sophisticated design and versatile functionality, the Bette Select 1700 Bath offers a perfect balance of style and comfort. Elevate your bathing experience with the exceptional quality of the Bette Select. Your search for an extraordinary bath should stop at Bette Select bath as its amazing features cannot be seen in any other bath. It is unique and works beyond your expectations. The width of this bath is 750mm whereas its depth is 420mm. There is No tap Hole available with this bath and it renders spacious standing area with an outlet to the centre. <span style=\"color: #253960;\"><a style=\"color: #253930;\" href=\"/bathroom.html\" target=\"_blank\" rel=\"noopener\"><strong><span style=\"color: #253960;\">Bathroom</span></strong></a> </span>is the home ground of germs but Bette super steel bath will not allow germs to prevail in your bathroom as the high quality manufacturing of this bath efficiently stops bacterial growth to keep your bathroom clean in the very best way. It is fitted with anti-noise pad as standard. The spacious standing area will be rendered with an outlet to the centre. You can clean it with any bath cleaner as its surface does not react with any chemical and it is resistant to scratches, stains, and impact.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Spacious standing area, with outlet to the center</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>Made from sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat-conducting, hygienic easy-care, resistant to chemicals, scratch and impact-resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17328,75,0,6438,'<p><span style=\"font-size: medium;\"><strong>Bette Select Super Steel Bath 170 x 75cm No tap Hole - BE3432-000 BE3422-000 </strong></span></p>\n<p style=\"text-align: justify;\">Experience the excellence of the Bette Select Bath. With its sophisticated design and versatile functionality, the Bette Select 1700 Bath offers a perfect balance of style and comfort. Elevate your bathing experience with the exceptional quality of the Bette Select. Your search for an extraordinary bath should stop at Bette Select bath as its amazing features cannot be seen in any other bath. It is unique and works beyond your expectations. The width of this bath is 750mm whereas its depth is 420mm. There is No tap Hole available with this bath and it renders spacious standing area with an outlet to the centre. <span style=\"color: #253960;\"><a style=\"color: #253930;\" href=\"/bathroom.html\" target=\"_blank\" rel=\"noopener\"><strong><span style=\"color: #253960;\">Bathroom</span></strong></a> </span>is the home ground of germs but Bette super steel bath will not allow germs to prevail in your bathroom as the high quality manufacturing of this bath efficiently stops bacterial growth to keep your bathroom clean in the very best way. It is fitted with anti-noise pad as standard. The spacious standing area will be rendered with an outlet to the centre. You can clean it with any bath cleaner as its surface does not react with any chemical and it is resistant to scratches, stains, and impact.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Spacious standing area, with outlet to the center</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>Made from sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat-conducting, hygienic easy-care, resistant to chemicals, scratch and impact-resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17329,155,0,6438,'Exclude'),(17330,85,5,6439,'Bette Select Super Steel Bath 180 x 80cm No Tap Hole - BE3433-000 BE3423-000'),(17331,85,0,6439,'Bette Select Super Steel Bath 180 x 80cm No Tap Hole - BE3433-000 BE3423-000'),(17332,76,5,6439,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-select-bath-with-overflow-foot-end.html\">&gt;&nbsp;&nbsp;View all Bette Select Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17333,76,0,6439,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-select-bath-with-overflow-foot-end.html\">&gt;&nbsp;&nbsp;View all Bette Select Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17334,75,5,6439,'<p><span style=\"font-size: medium;\"><strong>Bette Select Super Steel Bath 180 x 80cm No tap Hole - BE3433-000 BE3423-000 </strong></span></p>\r\n<p>Give a place to Bette Select super bath in your bathroom and enjoy the incredible advantages of it till its whole lifetime. It is supplied with side overflow foot end right overflow as well as with side overflow foot end left overflow front. You can fill it up to 187 litres of water and this foot ended bath will prove a great choice for you. It renders you an additional benefit as there is No tap Hole in this bath. Germs and bacteria usually grow with speed in bathrooms but you should be happy that your bathroom will be bacteria-free as the smooth and hygienic surface of Bette bath does not allow bacteria to grow and keeps your bathroom a hygienic place to be used. The white shine of this bath is long-lasting as it will stay the same even after the decades of use. This Bette steel bath is available at Banyo with a discounted price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Spacious standing area, with outlet to the center</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Made from sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat-conducting, hygienic easy-care, resistant to chemicals, scratch and impact-resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17335,75,0,6439,'<p><span style=\"font-size: medium;\"><strong>Bette Select Super Steel Bath 180 x 80cm No tap Hole - BE3433-000 BE3423-000 </strong></span></p>\r\n<p>Give a place to Bette Select super bath in your bathroom and enjoy the incredible advantages of it till its whole lifetime. It is supplied with side overflow foot end right overflow as well as with side overflow foot end left overflow front. You can fill it up to 187 litres of water and this foot ended bath will prove a great choice for you. It renders you an additional benefit as there is No tap Hole in this bath. Germs and bacteria usually grow with speed in bathrooms but you should be happy that your bathroom will be bacteria-free as the smooth and hygienic surface of Bette bath does not allow bacteria to grow and keeps your bathroom a hygienic place to be used. The white shine of this bath is long-lasting as it will stay the same even after the decades of use. This Bette steel bath is available at Banyo with a discounted price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Spacious standing area, with outlet to the center</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Made from sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat-conducting, hygienic easy-care, resistant to chemicals, scratch and impact-resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17336,155,0,6439,'Exclude'),(17337,85,5,6440,'Bette Form Super Steel Bath 175 x 75cm - BE3450-000'),(17338,85,0,6440,'Bette Form Super Steel Bath 175 x 75cm - BE3450-000'),(17339,76,5,6440,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17340,76,0,6440,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17341,75,5,6440,'<style>#html-body [data-pb-style=O236O50]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"O236O50\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 175 x 75cm- BE3450-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">A right <strong>1750 bath</strong> can bring comfort and convenience in your life and there is no bath that will suit well to your bathroom other than Bette Form bath. You will find it resistant against scouring agents and fluids as it is constructed from super steel which makes it a strong bath with durable quality and long-lasting functionality. It renders you an additional benefit as there is No tap Hole in this bath. Germs and bacteria usually grow with speed in bathrooms but you should be happy that your bathroom will be bacteria-free as the smooth and hygienic surface of <strong>Bette form steel bath</strong> does not allow bacteria to grow and keeps your bathroom a hygienic place to be used. The white shine of this <strong>1750 x 700 bath</strong> is long-lasting as it will stay the same even after the decades of use. This <span style=\"color: #253960;\"><a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #253960;\"><strong>Bette steel bath</strong> </span></a></span>is available at Banyo with a discounted price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat-conducting, hygienic easy-care, resistant to chemicals, scratch and impact-resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17342,75,0,6440,'<style>#html-body [data-pb-style=O236O50]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"O236O50\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 175 x 75cm- BE3450-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">A right <strong>1750 bath</strong> can bring comfort and convenience in your life and there is no bath that will suit well to your bathroom other than Bette Form bath. You will find it resistant against scouring agents and fluids as it is constructed from super steel which makes it a strong bath with durable quality and long-lasting functionality. It renders you an additional benefit as there is No tap Hole in this bath. Germs and bacteria usually grow with speed in bathrooms but you should be happy that your bathroom will be bacteria-free as the smooth and hygienic surface of <strong>Bette form steel bath</strong> does not allow bacteria to grow and keeps your bathroom a hygienic place to be used. The white shine of this <strong>1750 x 700 bath</strong> is long-lasting as it will stay the same even after the decades of use. This <span style=\"color: #253960;\"><a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #253960;\"><strong>Bette steel bath</strong> </span></a></span>is available at Banyo with a discounted price.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat-conducting, hygienic easy-care, resistant to chemicals, scratch and impact-resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17343,155,0,6440,'Exclude'),(17344,85,5,6441,'Bette Form Super Steel Bath 170 x 80cm  - BE3490-000'),(17345,85,0,6441,'Bette Form Super Steel Bath 170 x 80cm  - BE3490-000'),(17346,76,5,6441,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17347,76,0,6441,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17348,75,5,6441,'<style>#html-body [data-pb-style=OLHDPVI]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"OLHDPVI\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 170 x 80cm- BE3490-000 </strong></span></p>\r\n<p>Bette Form Super bath is brought to you by a leading brand, Bette. This Bette super steel bath has brought a revolution in the world of steel baths. It gave a very tough competition by offering unmatchable features and functionality. Bette has designed this bath in a rectangular shape that looks quite elegant and sophisticated in any bathroom. The tap hole is not pre-drilled in it to render you more convenience. This 1700 x 800 super steel bath is available in the white colour that can be maintained easily as it will not fade away regardless of how you use it. There are no other baths that are strong and durable like Bette Form bath because its manufacturing is done by using high-quality super steel that has efficiently enhanced the functionality of this bath.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat-conducting, hygienic easy-care, resistant to chemicals, scratch and impact-resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17349,75,0,6441,'<style>#html-body [data-pb-style=OLHDPVI]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"OLHDPVI\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 170 x 80cm- BE3490-000 </strong></span></p>\r\n<p>Bette Form Super bath is brought to you by a leading brand, Bette. This Bette super steel bath has brought a revolution in the world of steel baths. It gave a very tough competition by offering unmatchable features and functionality. Bette has designed this bath in a rectangular shape that looks quite elegant and sophisticated in any bathroom. The tap hole is not pre-drilled in it to render you more convenience. This 1700 x 800 super steel bath is available in the white colour that can be maintained easily as it will not fade away regardless of how you use it. There are no other baths that are strong and durable like Bette Form bath because its manufacturing is done by using high-quality super steel that has efficiently enhanced the functionality of this bath.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat-conducting, hygienic easy-care, resistant to chemicals, scratch and impact-resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17350,155,0,6441,'Exclude'),(17351,85,5,6442,'Bette Form Super Steel Bath 150 x 70cm - BE3500-000'),(17352,85,0,6442,'Bette Form Super Steel Bath 150 x 70cm - BE3500-000'),(17353,76,5,6442,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17354,76,0,6442,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17355,75,5,6442,'<p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 150 x 70cm- BE3500-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">Enhance the visual appeal of your luxury bathroom by installing Bette super steel bath as this bath delivers unbeatable and long-lasting functionality. This smart super steel bath has a unique and seamless rectangular shape with 700mm width and 420mm depth. It can be filled with a maximum of 95 litres of water. It has manufactured with super steel so germs cannot prevail in this bath as it has the ability to stop bacterial growth efficiently. Super steel is making it highly durable than other ordinary baths so it will give you comfort for a lifetime. No tap Hole is supplied with it and the white colour of this bath looks great with any bathroom design. The sturdy titanium finished steel retains its look even after decades of usage. It is heat-conducting, resistant to chemicals, UV resistant as well as impact resistant. The sustainable material assures robust so it will be a great choice for your <a href=\"/bathroom.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>contemporary bathroom</strong></span></a>.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat-conducting, hygienic easy-care, resistant to chemicals, scratch and impact-resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17356,75,0,6442,'<p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 150 x 70cm- BE3500-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">Enhance the visual appeal of your luxury bathroom by installing Bette super steel bath as this bath delivers unbeatable and long-lasting functionality. This smart super steel bath has a unique and seamless rectangular shape with 700mm width and 420mm depth. It can be filled with a maximum of 95 litres of water. It has manufactured with super steel so germs cannot prevail in this bath as it has the ability to stop bacterial growth efficiently. Super steel is making it highly durable than other ordinary baths so it will give you comfort for a lifetime. No tap Hole is supplied with it and the white colour of this bath looks great with any bathroom design. The sturdy titanium finished steel retains its look even after decades of usage. It is heat-conducting, resistant to chemicals, UV resistant as well as impact resistant. The sustainable material assures robust so it will be a great choice for your <a href=\"/bathroom.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>contemporary bathroom</strong></span></a>.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat-conducting, hygienic easy-care, resistant to chemicals, scratch and impact-resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17357,155,0,6442,'Exclude'),(17358,85,5,6443,'Bette Set Super Steel Bath 165 x 75cm - BE3560-000'),(17359,85,0,6443,'Bette Set Super Steel Bath 165 x 75cm - BE3560-000'),(17360,76,5,6443,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Set Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17361,76,0,6443,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Set Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17362,75,5,6443,'<style>#html-body [data-pb-style=Y3F9JKT]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"Y3F9JKT\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Set Super Steel Bath 165 x 75cm- BE3560-000</strong></span></p>\r\n<p>Take a wise decision and install Bette Set Super Steel Bath 1650 x 750mm in your bathroom. Taking bath in winters is not a problem anymore as this bath will render you a cosy and warm feeling in winters due to its heat-conducting quality. It is very easy to maintain as well as ultraviolet rays will also not affect its surface because it is UV resistant. You can completely submerge and relax into this bath due to its efficiently designed depth of 450mm. It has a spacious, body-contoured lying profile. Avail the incredible discount offered by Banyo to make your dream bathroom within your budget. Bette is offering a whopping guarantee of 30 years on this bath to keep your mind peaceful regarding this bath.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Distinctive bath form</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Made from sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li>Bette steel baths are heat-conducting, hygienic easy-care, resistant to chemicals, scratch and impact-resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17363,75,0,6443,'<style>#html-body [data-pb-style=Y3F9JKT]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"Y3F9JKT\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Set Super Steel Bath 165 x 75cm- BE3560-000</strong></span></p>\r\n<p>Take a wise decision and install Bette Set Super Steel Bath 1650 x 750mm in your bathroom. Taking bath in winters is not a problem anymore as this bath will render you a cosy and warm feeling in winters due to its heat-conducting quality. It is very easy to maintain as well as ultraviolet rays will also not affect its surface because it is UV resistant. You can completely submerge and relax into this bath due to its efficiently designed depth of 450mm. It has a spacious, body-contoured lying profile. Avail the incredible discount offered by Banyo to make your dream bathroom within your budget. Bette is offering a whopping guarantee of 30 years on this bath to keep your mind peaceful regarding this bath.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Distinctive bath form</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Made from sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li>Bette steel baths are heat-conducting, hygienic easy-care, resistant to chemicals, scratch and impact-resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17364,155,0,6443,'Exclude'),(17365,85,5,6444,'Bette Form Super Steel Bath 160 x 70cm - BE3600-000'),(17366,85,0,6444,'Bette Form Super Steel Bath 160 x 70cm - BE3600-000'),(17367,76,5,6444,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17368,76,0,6444,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17369,75,5,6444,'<p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 160 x 70cm- BE3600-000 </strong></span></p><p style=\"text-align: justify;\">This 1600mm Bette Form Steel bath is brought to you by Bette as it never compromises on the quality so bring this Bette bath home for adding a functional touch to your bathroom. It is a good conductor to heat and highly resists fluids and scouring agents to retain a non-fading colour efficiently. It is refined with a unique BETTEGLAZE enamel finish so you will see it as shiny as it was at the time of purchasing. It doesn&rsquo;t matter that how many times you use this <span style=\"color: #3366ff;\"><a href=\"/brands/bette.html\" target=\"_blank\"><span style=\"color: #3366ff;\">Bette bath</span></a></span> it will always shine as new. It can be filled up to 108 litres of water and its shape is rectangular which looks great in any bathroom.Its length is 1600mm whereas its width is 700mm and the depth of this bath is 420mm. There is No tap Hole and you will find it durable than other baths. Bette is rendering a whopping guarantee of 30 years to bring you peace of mind.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17370,75,0,6444,'<p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 160 x 70cm- BE3600-000 </strong></span></p><p style=\"text-align: justify;\">This 1600mm Bette Form Steel bath is brought to you by Bette as it never compromises on the quality so bring this Bette bath home for adding a functional touch to your bathroom. It is a good conductor to heat and highly resists fluids and scouring agents to retain a non-fading colour efficiently. It is refined with a unique BETTEGLAZE enamel finish so you will see it as shiny as it was at the time of purchasing. It doesn&rsquo;t matter that how many times you use this <span style=\"color: #3366ff;\"><a href=\"/brands/bette.html\" target=\"_blank\"><span style=\"color: #3366ff;\">Bette bath</span></a></span> it will always shine as new. It can be filled up to 108 litres of water and its shape is rectangular which looks great in any bathroom.Its length is 1600mm whereas its width is 700mm and the depth of this bath is 420mm. There is No tap Hole and you will find it durable than other baths. Bette is rendering a whopping guarantee of 30 years to bring you peace of mind.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17371,155,0,6444,'Exclude'),(17372,85,5,6445,'Bette Form Super Steel Bath 160 x 75cm  - BE3620-000'),(17373,85,0,6445,'Bette Form Super Steel Bath 160 x 75cm  - BE3620-000'),(17374,76,5,6445,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17375,76,0,6445,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17376,75,5,6445,'<p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 160 x 75cm - BE3620-000</strong></span></p><p style=\"text-align: justify;\">Bette Form super steel bath is manufactured to bring you comfort as no bath can beat its features. It is a single endedbath and there is a perfectly rounded shape inside the rectangular shape of this bath.It is suppliedand its colour is glossy white that can look great with any bathroom design. The sturdy titanium finished steel is used in its manufacturing whereas it is refined with BETTEGLAZE enamel finish. It is easy to use as its smooth surface will give you a warm feeling and you will just love to take bath in <a href=\"/brands/bette.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>Bette bath tub</strong></span></a>. It is resistant to chemicals so you can use any bath washer liquid to clean this bath. A warm bath tub is badly needed in winters and this Bette bath is an efficient conductor of heat so it will render you comfortable bath moments.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17377,75,0,6445,'<p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 160 x 75cm - BE3620-000</strong></span></p><p style=\"text-align: justify;\">Bette Form super steel bath is manufactured to bring you comfort as no bath can beat its features. It is a single endedbath and there is a perfectly rounded shape inside the rectangular shape of this bath.It is suppliedand its colour is glossy white that can look great with any bathroom design. The sturdy titanium finished steel is used in its manufacturing whereas it is refined with BETTEGLAZE enamel finish. It is easy to use as its smooth surface will give you a warm feeling and you will just love to take bath in <a href=\"/brands/bette.html\" target=\"_blank\"><span style=\"color: #3366ff;\"><strong>Bette bath tub</strong></span></a>. It is resistant to chemicals so you can use any bath washer liquid to clean this bath. A warm bath tub is badly needed in winters and this Bette bath is an efficient conductor of heat so it will render you comfortable bath moments.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17378,155,0,6445,'Exclude'),(17412,85,5,6446,'Bette Form Super Steel Bath 165 x 75cm - BE3640-000'),(17413,85,0,6446,'Bette Form Super Steel Bath 165 x 75cm - BE3640-000'),(17414,76,5,6446,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17415,76,0,6446,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17416,75,5,6446,'<style>#html-body [data-pb-style=IR6B456]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"IR6B456\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 165 x 75cm- BE3640-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">This Super Steel bath has manufactured by one of the leading brands, Bette. The main reason for Bette’s success is its high-quality manufacturing and Bette form 1650 x 750 bath is also manufactured from sturdy titanium finished steel. It is refined with a unique BETTE GLAZE enamel finish and it will be super hygienic as germs cannot prevail in the presence of this bath. This single ended bath can be filled with up to 108 liters of water. It is not only strong but highly durable than other ordinary baths. The sturdy titanium-finished steel is making it highly resistant to chemicals and scratches. The gentle curves inside this bath 1650 x 750 add comfort to your life and you will be able to enjoy comfortable bath moments. 1650mm bath is the length of this bath whereas 420mm is its depth of it. Bring it home for giving your <span style=\"color: #3366ff;\"><a tabindex=\"0\" href=\"/bathroom.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>bathroom</strong></span></a></span> an enlightening touch as there is an incredible discount offered by Banyo.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape: Rectangular</li>\r\n<li>Single-ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from: sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax, and soda.</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy to care for, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17417,75,0,6446,'<style>#html-body [data-pb-style=IR6B456]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"IR6B456\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 165 x 75cm- BE3640-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">This Super Steel bath has manufactured by one of the leading brands, Bette. The main reason for Bette’s success is its high-quality manufacturing and Bette form 1650 x 750 bath is also manufactured from sturdy titanium finished steel. It is refined with a unique BETTE GLAZE enamel finish and it will be super hygienic as germs cannot prevail in the presence of this bath. This single ended bath can be filled with up to 108 liters of water. It is not only strong but highly durable than other ordinary baths. The sturdy titanium-finished steel is making it highly resistant to chemicals and scratches. The gentle curves inside this bath 1650 x 750 add comfort to your life and you will be able to enjoy comfortable bath moments. 1650mm bath is the length of this bath whereas 420mm is its depth of it. Bring it home for giving your <span style=\"color: #3366ff;\"><a tabindex=\"0\" href=\"/bathroom.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>bathroom</strong></span></a></span> an enlightening touch as there is an incredible discount offered by Banyo.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape: Rectangular</li>\r\n<li>Single-ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from: sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax, and soda.</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy to care for, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17418,155,0,6446,'Exclude'),(17419,85,5,6447,'Bette Set Super Steel Bath 160 x 70cm - BE3650-000'),(17420,85,0,6447,'Bette Set Super Steel Bath 160 x 70cm - BE3650-000'),(17421,76,5,6447,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Set Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17422,76,0,6447,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Set Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17423,75,5,6447,'<p><span style=\"font-size: medium;\"><strong><a title=\"Bette Set Super Steel Bath\" href=\"/bette-set-super-steel-single-ended-bath.html\" target=\"_blank\" rel=\"noopener\">Bette Set Super Steel Bath 160 x 70cm- BE3650-000</a> </strong></span></p>\r\n<p>The design of Bette Set Super steel bath is quite different from others as there is a slight curve in the middle of this bath and this slight curve is making it unique. 86 litres of water can be filled in this bath to get a comfortable bath. This distinctive bath is available in white colour with seamless and eye catching look. An anti-noise pad is fitted in it as a standard and is supplied without any tap hole. You will find it a space saving bath for relatively small bathrooms. The shallow tub depth is rendered for comfortable entrance as well as it is a water saving bath. It is not only a good conductor of heat but stops bacterial growth with great percentage. It is resistant to chemicals so you can clean it with any bath cleaner as its surface will remain shiny and new after using any cleaner.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Distinctive bath form</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17424,75,0,6447,'<p><span style=\"font-size: medium;\"><strong><a title=\"Bette Set Super Steel Bath\" href=\"/bette-set-super-steel-single-ended-bath.html\" target=\"_blank\" rel=\"noopener\">Bette Set Super Steel Bath 160 x 70cm- BE3650-000</a> </strong></span></p>\r\n<p>The design of Bette Set Super steel bath is quite different from others as there is a slight curve in the middle of this bath and this slight curve is making it unique. 86 litres of water can be filled in this bath to get a comfortable bath. This distinctive bath is available in white colour with seamless and eye catching look. An anti-noise pad is fitted in it as a standard and is supplied without any tap hole. You will find it a space saving bath for relatively small bathrooms. The shallow tub depth is rendered for comfortable entrance as well as it is a water saving bath. It is not only a good conductor of heat but stops bacterial growth with great percentage. It is resistant to chemicals so you can clean it with any bath cleaner as its surface will remain shiny and new after using any cleaner.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Distinctive bath form</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17425,155,0,6447,'Exclude'),(17426,85,5,6448,'Bette Set Super Steel Bath 160 x 75cm  - BE3660-000'),(17427,85,0,6448,'Bette Set Super Steel Bath 160 x 75cm  - BE3660-000'),(17428,76,5,6448,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Set Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17429,76,0,6448,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Set Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17430,75,5,6448,'<h2><strong><a href=\"/bette-set-super-steel-single-ended-bath.html\" title=\"Bette Set Super Steel Bath\" target=\"_blank\">Bette Set Super Steel Bath 160 x 75cm - BE3660-000</a></strong></h2>\r\n<p>Bette Set super steel bath is famous for its seamless slight curves in the middle. It looks great because of its seamless curves, elegant designing, beautiful look and eye-catching shape. This single ended bath can be filled up to 105 litres of water that is more than enough for a good bath. More on, this comfortable hip bath is suppliedand there is No tap Hole in it. Super steel baths usually render more comfort than ordinary baths so this Bette steel bath will prove a wise decision for your bathroom. Bette is offering a whopping guarantee of 30 years on it to bring you peace of mind. More on, a never seen before price is offered to you from the side of Banyo to make this product highly affordable for you. The shallow bath tub will allow comfortable entrance as well as it saves water to save your extra cost.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Distinctive bath form</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17431,75,0,6448,'<h2><strong><a href=\"/bette-set-super-steel-single-ended-bath.html\" title=\"Bette Set Super Steel Bath\" target=\"_blank\">Bette Set Super Steel Bath 160 x 75cm - BE3660-000</a></strong></h2>\r\n<p>Bette Set super steel bath is famous for its seamless slight curves in the middle. It looks great because of its seamless curves, elegant designing, beautiful look and eye-catching shape. This single ended bath can be filled up to 105 litres of water that is more than enough for a good bath. More on, this comfortable hip bath is suppliedand there is No tap Hole in it. Super steel baths usually render more comfort than ordinary baths so this Bette steel bath will prove a wise decision for your bathroom. Bette is offering a whopping guarantee of 30 years on it to bring you peace of mind. More on, a never seen before price is offered to you from the side of Banyo to make this product highly affordable for you. The shallow bath tub will allow comfortable entrance as well as it saves water to save your extra cost.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Distinctive bath form</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17432,155,0,6448,'Exclude'),(17433,85,5,6449,'Bette Form Super Steel Bath 1700 × 730mm - 3700'),(17434,85,0,6449,'Bette Form Super Steel Bath 1700 × 730mm - 3700'),(17435,76,5,6449,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17436,76,0,6449,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17437,75,5,6449,'<p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 1700 x 730mm - 3700 </strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul> '),(17438,75,0,6449,'<p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 1700 x 730mm - 3700 </strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul> '),(17439,155,0,6449,'Exclude'),(17440,85,5,6450,'Bette Form Super Steel Bath 170 x 75cm - BE3710-000'),(17441,85,0,6450,'Bette Form Super Steel Bath 170 x 75cm - BE3710-000'),(17442,76,5,6450,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17443,76,0,6450,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17444,75,5,6450,'<style>#html-body [data-pb-style=UT9VAGY]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"UT9VAGY\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 170 x 75cm- BE3710-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">Supplied in a range of no less than ten different sizes, <a href=\"https://www.banyo.co.uk/bette-form-super-steel-bath-1700-x-750mm.html\"><strong>Bette Form 1700 x 750 Super Steel Bath</strong></a> is a compact preferred with our customers. &nbsp;Fashioned from 2.4mm thick titanium steel, Bette Form Super Steel Baths are built to last, making them a one-off, lifetime investment. Guaranteed for thirty years against manufacturing defects, Bette are proud to stand behind their products. Bette Steel bath is famous for its unbeatable performance and long lasting quality. Soak yourself in a warm and cosy bath with Bette Form super steel bath which is manufactured by a leading brand, Bette. The pristine white finish will give a seamless blend with your existing bathroom setting. The superior quality titanium steel material is making this bath extra durable and more functional. It will elevate your luxury quotient as this single-ended bath gives a perfect fit to your bathroom. It will prove a great investment of your money as you will be able to enjoy wonderful bath moments after a tiring day. There is No tap Hole in this <strong><a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\">bette bath &nbsp;</span></a></strong>x 750 and an anti-noised pad is fitted as a standard. It is a good heat conductor so it will give you a warm feeling in winters as heat can pass through it easily. It is supplied and the shape of this bath is rectangular.It can be filled up to 120 litres of water that is more than sufficient for a perfect bath. Experience sleek elegance with the Bette Form Bath. Designed to impress, the Bette Form in the size of <strong>steel bath 1700 x 750</strong> offers a perfect combination of style and functionality. Transform your bathroom with the exceptional quality of the Bette Form.&nbsp;</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17445,75,0,6450,'<style>#html-body [data-pb-style=UT9VAGY]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"UT9VAGY\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 170 x 75cm- BE3710-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">Supplied in a range of no less than ten different sizes, <a href=\"https://www.banyo.co.uk/bette-form-super-steel-bath-1700-x-750mm.html\"><strong>Bette Form 1700 x 750 Super Steel Bath</strong></a> is a compact preferred with our customers. &nbsp;Fashioned from 2.4mm thick titanium steel, Bette Form Super Steel Baths are built to last, making them a one-off, lifetime investment. Guaranteed for thirty years against manufacturing defects, Bette are proud to stand behind their products. Bette Steel bath is famous for its unbeatable performance and long lasting quality. Soak yourself in a warm and cosy bath with Bette Form super steel bath which is manufactured by a leading brand, Bette. The pristine white finish will give a seamless blend with your existing bathroom setting. The superior quality titanium steel material is making this bath extra durable and more functional. It will elevate your luxury quotient as this single-ended bath gives a perfect fit to your bathroom. It will prove a great investment of your money as you will be able to enjoy wonderful bath moments after a tiring day. There is No tap Hole in this <strong><a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\">bette bath &nbsp;</span></a></strong>x 750 and an anti-noised pad is fitted as a standard. It is a good heat conductor so it will give you a warm feeling in winters as heat can pass through it easily. It is supplied and the shape of this bath is rectangular.It can be filled up to 120 litres of water that is more than sufficient for a perfect bath. Experience sleek elegance with the Bette Form Bath. Designed to impress, the Bette Form in the size of <strong>steel bath 1700 x 750</strong> offers a perfect combination of style and functionality. Transform your bathroom with the exceptional quality of the Bette Form.&nbsp;</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17446,155,0,6450,'Exclude'),(17447,85,5,6451,'Bette Set Super Steel Bath 170 x 80cm  - BE3760-000'),(17448,85,0,6451,'Bette Set Super Steel Bath 170 x 80cm  - BE3760-000'),(17449,76,5,6451,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Set Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17450,76,0,6451,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Set Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17451,75,5,6451,'<style>#html-body [data-pb-style=VP2ABJ7]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"VP2ABJ7\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><h2><span style=\"font-size: medium;\"><strong><a title=\"Bette Set Super Steel Bath\" href=\"/bette-set-super-steel-single-ended-bath.html\" target=\"_blank\" rel=\"noopener\">Bette Set Super Steel Bath 170 x 80cm - BE3760-000</a> </strong></span></h2>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Distinctive bath form</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17452,75,0,6451,'<style>#html-body [data-pb-style=VP2ABJ7]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"VP2ABJ7\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><h2><span style=\"font-size: medium;\"><strong><a title=\"Bette Set Super Steel Bath\" href=\"/bette-set-super-steel-single-ended-bath.html\" target=\"_blank\" rel=\"noopener\">Bette Set Super Steel Bath 170 x 80cm - BE3760-000</a> </strong></span></h2>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Distinctive bath form</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17453,155,0,6451,'Exclude'),(17454,85,5,6452,'Bette Form Steel Bath 180 x 80cm - BE3800-000'),(17455,85,0,6452,'Bette Form Steel Bath 180 x 80cm - BE3800-000'),(17456,76,5,6452,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17457,76,0,6452,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17458,75,5,6452,'<style>#html-body [data-pb-style=EWB7O1V]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"EWB7O1V\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 180 x 80cm- 2950-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">Your dream of getting comfortable bath moments can be fulfilled by installing <strong>Bette Form steel bath</strong> as it is made specially to give you comfort. Its length is 1800mm whereas width is 800mm and the depth is 420mm. The rectangular shape of this single ended bath gives an alluring look to the design of your luxurious bathroom. You will find it highly durable than other ordinary baths. Tap hole is not pre-drilled in this bath to render you more convenience. It is an excellent conductor of heat so you will find it an effective choice as it will give you a soothing warm touch. It is not made for taking bath only but it is made to give you relaxing moments. This <a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>super steel bath</strong></span></a> 1800 x 800 is made from sturdy titanium finished steel that makes it a hygienic product as Bette takes care of your health by manufacturing the high-quality products for you.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features </strong></span></p>\r\n<ul>\r\n<li>Shape: Rectangular</li>\r\n<li>Single Ended Bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, made from sustainable materials and reassuringly robust</li>\r\n</ul></div></div></div>'),(17459,75,0,6452,'<style>#html-body [data-pb-style=EWB7O1V]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"EWB7O1V\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 180 x 80cm- 2950-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">Your dream of getting comfortable bath moments can be fulfilled by installing <strong>Bette Form steel bath</strong> as it is made specially to give you comfort. Its length is 1800mm whereas width is 800mm and the depth is 420mm. The rectangular shape of this single ended bath gives an alluring look to the design of your luxurious bathroom. You will find it highly durable than other ordinary baths. Tap hole is not pre-drilled in this bath to render you more convenience. It is an excellent conductor of heat so you will find it an effective choice as it will give you a soothing warm touch. It is not made for taking bath only but it is made to give you relaxing moments. This <a href=\"/brands/bette.html\" target=\"_blank\" rel=\"noopener\"><span style=\"color: #3366ff;\"><strong>super steel bath</strong></span></a> 1800 x 800 is made from sturdy titanium finished steel that makes it a hygienic product as Bette takes care of your health by manufacturing the high-quality products for you.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features </strong></span></p>\r\n<ul>\r\n<li>Shape: Rectangular</li>\r\n<li>Single Ended Bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, made from sustainable materials and reassuringly robust</li>\r\n</ul></div></div></div>'),(17460,155,0,6452,'Exclude'),(17461,85,5,6453,'Bette Set Super Steel Bath 180 x 80cm  - BE3860-000'),(17462,85,0,6453,'Bette Set Super Steel Bath 180 x 80cm  - BE3860-000'),(17463,76,5,6453,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Set Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17464,76,0,6453,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Set Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17465,75,5,6453,'<h2><strong><a href=\"/bette-set-super-steel-single-ended-bath.html\" title=\"Bette Set Super Steel Bath\" target=\"_self\">Bette Set Super Steel Bath 180 x 80cm- BE3860-000</a></strong></h2>\r\n<p>This distinctive Bette Set bath is designed for bathrooms where space is less as this Bette super steel bath occupies very less space but renders unbeatable functionality. The shallow tub depth allows comfortable entrance as it will give you nothing other than comfort. There is no pre-drilled tap hole so you&rsquo;ll have more comfort. The sturdy titanium finished steel renders it durability, strength, stability, and long lasting functionality. Water, glass, quartz, borax and soda are used for the making of BETTEGLAZE enamel finish. This bath is not only heat conducting but will resist chemicals as well. The surface of this bath will stay shiny and smooth during the entire life of this bath because it resists ultraviolet rays, impact, and scratches.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Distinctive bath form</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17466,75,0,6453,'<h2><strong><a href=\"/bette-set-super-steel-single-ended-bath.html\" title=\"Bette Set Super Steel Bath\" target=\"_self\">Bette Set Super Steel Bath 180 x 80cm- BE3860-000</a></strong></h2>\r\n<p>This distinctive Bette Set bath is designed for bathrooms where space is less as this Bette super steel bath occupies very less space but renders unbeatable functionality. The shallow tub depth allows comfortable entrance as it will give you nothing other than comfort. There is no pre-drilled tap hole so you&rsquo;ll have more comfort. The sturdy titanium finished steel renders it durability, strength, stability, and long lasting functionality. Water, glass, quartz, borax and soda are used for the making of BETTEGLAZE enamel finish. This bath is not only heat conducting but will resist chemicals as well. The surface of this bath will stay shiny and smooth during the entire life of this bath because it resists ultraviolet rays, impact, and scratches.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Distinctive bath form</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17467,155,0,6453,'Exclude'),(17468,85,5,6454,'Bette Starlet Flair Oval Super Steel Bath 158 x 68cm No Tap Hole - BE8772-000'),(17469,85,0,6454,'Bette Starlet Flair Oval Super Steel Bath 158 x 68cm No Tap Hole - BE8772-000'),(17470,76,5,6454,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Flair Oval Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17471,76,0,6454,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Flair Oval Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17472,75,5,6454,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Flair Oval Super Steel Bath 158 x 68cm No tap Hole - 8772-000 </strong></span></p>\n<p>You cannot enjoy comfortable bath if your bathtub is not effective enough. Throw your away because Bette Starlet flair bath works beyond your expectations. This super steel bath is available to you without any pre-drilled tap hole. It is constructed from high-grade super steel for extra stability and strength. It creates a sense of understated opulence and the installation of this double ended bath is also very easy. It is available in white colour and there is no tap hole pre-drilled in it. You can fill it up with 116 litres of water that is more than efficient for a comfortable bath. The length of this bath 1580mm whereas its width is 680mm and has a depth of 420mm.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Oval</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Centrally-positioned drain</li>\n<li>Anti-noise pad is fitted as standard</li>\n<li>Made from sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Extremely thin bath edges</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17473,75,0,6454,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Flair Oval Super Steel Bath 158 x 68cm No tap Hole - 8772-000 </strong></span></p>\n<p>You cannot enjoy comfortable bath if your bathtub is not effective enough. Throw your away because Bette Starlet flair bath works beyond your expectations. This super steel bath is available to you without any pre-drilled tap hole. It is constructed from high-grade super steel for extra stability and strength. It creates a sense of understated opulence and the installation of this double ended bath is also very easy. It is available in white colour and there is no tap hole pre-drilled in it. You can fill it up with 116 litres of water that is more than efficient for a comfortable bath. The length of this bath 1580mm whereas its width is 680mm and has a depth of 420mm.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Oval</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Centrally-positioned drain</li>\n<li>Anti-noise pad is fitted as standard</li>\n<li>Made from sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Extremely thin bath edges</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17474,155,0,6454,'Exclude'),(17475,85,5,6455,'Bette Starlet Flair Oval Super Steel Bath 168 x 73cm with Feet No tap Hole - BE8773-000'),(17476,85,0,6455,'Bette Starlet Flair Oval Super Steel Bath 168 x 73cm with Feet No tap Hole - BE8773-000'),(17477,76,5,6455,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Flair Oval Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17478,76,0,6455,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Flair Oval Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17479,75,5,6455,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Flair Oval Super Steel Bath 168 x 73cm No tap Hole - 8773-000 </strong></span></p>\r\n<p>Bette Starlet flair oval bath is a new exciting product from the starlet flair range of Bette. It is a bath with centrally positioned drain so you can fill this bathtub up to 139 litres of water as well as there is an anti-noised pad fitted as a standard. The extremely thin bath edges are making this bath more incredible. The length of this bath is 1680mm whereas its width is 730mm and has a depth of 420mm. This Bette super steel bath is a good conductor of heat so you will have a cosy and soothing feeling whenever you will take bath in this bathtub. The sturdy titanium finished steel is used in its manufacturing whereas its refining is done with BETTEGLAZE enamel finish that is made by using water, borax, quartz, soda, and glass.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Oval</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Extremely thin bath edges</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17480,75,0,6455,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Flair Oval Super Steel Bath 168 x 73cm No tap Hole - 8773-000 </strong></span></p>\r\n<p>Bette Starlet flair oval bath is a new exciting product from the starlet flair range of Bette. It is a bath with centrally positioned drain so you can fill this bathtub up to 139 litres of water as well as there is an anti-noised pad fitted as a standard. The extremely thin bath edges are making this bath more incredible. The length of this bath is 1680mm whereas its width is 730mm and has a depth of 420mm. This Bette super steel bath is a good conductor of heat so you will have a cosy and soothing feeling whenever you will take bath in this bathtub. The sturdy titanium finished steel is used in its manufacturing whereas its refining is done with BETTEGLAZE enamel finish that is made by using water, borax, quartz, soda, and glass.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Oval</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Extremely thin bath edges</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17481,155,0,6455,'Exclude'),(17482,85,5,6456,'Bette Starlet Flair Oval Super Steel Bath 178 x 78cm with Feet No tap Hole - BE8774-000'),(17483,85,0,6456,'Bette Starlet Flair Oval Super Steel Bath 178 x 78cm with Feet No tap Hole - BE8774-000'),(17484,76,5,6456,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Flair Oval Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17485,76,0,6456,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Flair Oval Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17486,75,5,6456,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Flair Oval Super Steel Bath 178 x 78cm No tap Hole - BE8774-000 </strong></span></p>\r\n<p>Bette Starlet Flair Oval is famous for its unique features and outstanding quality. The perfect dimensions of 1780mm length, 780mm width and 420mm depth are making it exceptionally fantastic. Its oval shape is adding worth to it as it is intelligently designed. This Bette super steel bath is a good conductor of heat so you will have a cosy and soothing feeling whenever you will take bath in this bathtub. The sturdy titanium finished steel is used in its manufacturing whereas its refining is done with BETTEGLAZE enamel finish that is made by using water, borax, quartz, soda, and glass. Bring this high-quality bath to your home and enjoy its benefits till its lifetime.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Oval</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li><li>Anti-noise pad is fitted as standard</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Extremely thin bath edges</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17487,75,0,6456,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Flair Oval Super Steel Bath 178 x 78cm No tap Hole - BE8774-000 </strong></span></p>\r\n<p>Bette Starlet Flair Oval is famous for its unique features and outstanding quality. The perfect dimensions of 1780mm length, 780mm width and 420mm depth are making it exceptionally fantastic. Its oval shape is adding worth to it as it is intelligently designed. This Bette super steel bath is a good conductor of heat so you will have a cosy and soothing feeling whenever you will take bath in this bathtub. The sturdy titanium finished steel is used in its manufacturing whereas its refining is done with BETTEGLAZE enamel finish that is made by using water, borax, quartz, soda, and glass. Bring this high-quality bath to your home and enjoy its benefits till its lifetime.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Oval</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li><li>Anti-noise pad is fitted as standard</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Extremely thin bath edges</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17488,155,0,6456,'Exclude'),(17489,85,5,6457,'Bette Starlet Flair Oval Super Steel Bath 188 x 88cm No Tap Hole - BE8775-000'),(17490,85,0,6457,'Bette Starlet Flair Oval Super Steel Bath 188 x 88cm No Tap Hole - BE8775-000'),(17491,76,5,6457,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Flair Oval Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17492,76,0,6457,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-set-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Flair Oval Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17493,75,5,6457,'<style>#html-body [data-pb-style=UQ3J1DO]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"UQ3J1DO\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Starlet Flair Oval Super Steel Bath 188 x 88cm No tap Hole - 8775-000 </strong></span></p>\r\n<p>Bette Starlet Flair Oval bath is an efficient choice for those who want a functional bath in their bathroom. There is a centrally-positioned drain in this bath so it can be filled up to 205 litres of water. There is an anti-noise pad that is fitted as a standard so it will be a great choice for your luxury bathroom. Now you can enchantingly unwind by dipping your body in this alluring bath as it is an excellent creation of Bette. The minimalist design of this contemporary bath can attract you at very first sight. This fresh bath design is ripe with style as well as with functionality. It is supplied with extremely narrow bath rim and there is an anti-noised pad fitted with it. Quartz, water, borax, glass, and soda are making an efficient BETTEGLAZE enamel finish. You can fill it up with 205 litres of water that is more than sufficient for a comfortable bath.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Oval</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Extremely thin bath edges</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17494,75,0,6457,'<style>#html-body [data-pb-style=UQ3J1DO]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"UQ3J1DO\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Starlet Flair Oval Super Steel Bath 188 x 88cm No tap Hole - 8775-000 </strong></span></p>\r\n<p>Bette Starlet Flair Oval bath is an efficient choice for those who want a functional bath in their bathroom. There is a centrally-positioned drain in this bath so it can be filled up to 205 litres of water. There is an anti-noise pad that is fitted as a standard so it will be a great choice for your luxury bathroom. Now you can enchantingly unwind by dipping your body in this alluring bath as it is an excellent creation of Bette. The minimalist design of this contemporary bath can attract you at very first sight. This fresh bath design is ripe with style as well as with functionality. It is supplied with extremely narrow bath rim and there is an anti-noised pad fitted with it. Quartz, water, borax, glass, and soda are making an efficient BETTEGLAZE enamel finish. You can fill it up with 205 litres of water that is more than sufficient for a comfortable bath.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Oval</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Extremely thin bath edges</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul></div></div></div>'),(17495,155,0,6457,'Exclude'),(17496,85,5,6458,'Bette Starlet Oval Super Steel Bath 150 x 80cm No Tap Hole - BE2700-000'),(17497,85,0,6458,'Bette Starlet Oval Super Steel Bath 150 x 80cm No Tap Hole - BE2700-000'),(17498,76,5,6458,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-oval-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Oval Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17499,76,0,6458,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-oval-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Oval Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17500,75,5,6458,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Oval Super Steel Bath 150 x 80cm No tap Hole - 2700-000 </strong></span></p>\n<p>Your search for a functional bath should stop exactly at Bette Starlet Oval bath as it is designed by the highly capable engineers of Bette. There is no comparison of its functionality and features so just bring it home and give more functionality to your bathroom. There is no tap hole in this bath. It is refined with a unique BETTEGLAZE enamel finish that is made by using quartz, glass, soda, borax, and water. Heat can pass through it easily so it is an absolutely perfect choice for getting the warm and cosy feeling in winters. Scratches cannot stay longer on it as you can clean it effortlessly. There is no tap hole in it. This super steel bath is hygienic and keeps your bathroom clean so your time will also be saved. Bette is offering a guarantee of 30 years for your peace of mind.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Oval</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>\n'),(17501,75,0,6458,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Oval Super Steel Bath 150 x 80cm No tap Hole - 2700-000 </strong></span></p>\n<p>Your search for a functional bath should stop exactly at Bette Starlet Oval bath as it is designed by the highly capable engineers of Bette. There is no comparison of its functionality and features so just bring it home and give more functionality to your bathroom. There is no tap hole in this bath. It is refined with a unique BETTEGLAZE enamel finish that is made by using quartz, glass, soda, borax, and water. Heat can pass through it easily so it is an absolutely perfect choice for getting the warm and cosy feeling in winters. Scratches cannot stay longer on it as you can clean it effortlessly. There is no tap hole in it. This super steel bath is hygienic and keeps your bathroom clean so your time will also be saved. Bette is offering a guarantee of 30 years for your peace of mind.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Oval</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>\n'),(17502,155,0,6458,'Exclude'),(17503,85,5,6459,'Bette Starlet Oval Super Steel Bath 165 x 75cm No Tap Hole - BE2720-000'),(17504,85,0,6459,'Bette Starlet Oval Super Steel Bath 165 x 75cm No Tap Hole - BE2720-000'),(17505,76,5,6459,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-oval-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Oval Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17506,76,0,6459,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-oval-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Oval Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17507,75,5,6459,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Oval Super Steel Bath 165 x 75cm No tap Hole - 2720-000 </strong></span></p>\n<p>Bette Starlet Oval bath is offered to you by a leading brand, Bette. Its dimensions are accurate enough to give you exceptional usage because all Bette&rsquo;s products render unbeatable results. The eye-catching designing of this bath attracts everyone as it looks great with any type of designs and gives an elegant look. There is an anti-noise pad fitted with this bath to give you comfortable use. UV rays can affect the surface of this bath as it is resistant to UV due to the construction with sturdy titanium finished steel. Scratches will not stay longer on it as this double ended bath is scratch and impact resistant. The length of this bath is 1650mm whereas the width is 750mm and the depth is of 420mm. You can clean it with any bath cleaner as it is resistant to chemicals so they will not react with its smooth and shiny surface.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Oval</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>\n\n\n'),(17508,75,0,6459,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Oval Super Steel Bath 165 x 75cm No tap Hole - 2720-000 </strong></span></p>\n<p>Bette Starlet Oval bath is offered to you by a leading brand, Bette. Its dimensions are accurate enough to give you exceptional usage because all Bette&rsquo;s products render unbeatable results. The eye-catching designing of this bath attracts everyone as it looks great with any type of designs and gives an elegant look. There is an anti-noise pad fitted with this bath to give you comfortable use. UV rays can affect the surface of this bath as it is resistant to UV due to the construction with sturdy titanium finished steel. Scratches will not stay longer on it as this double ended bath is scratch and impact resistant. The length of this bath is 1650mm whereas the width is 750mm and the depth is of 420mm. You can clean it with any bath cleaner as it is resistant to chemicals so they will not react with its smooth and shiny surface.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Oval</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>\n\n\n'),(17509,155,0,6459,'Exclude'),(17510,85,5,6460,'Bette Starlet Oval Super Steel Bath 175 x 80cm No Tap Hole - BE2680-000'),(17511,85,0,6460,'Bette Starlet Oval Super Steel Bath 175 x 80cm No Tap Hole - BE2680-000'),(17512,76,5,6460,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-oval-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Oval Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17513,76,0,6460,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-oval-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Oval Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17514,75,5,6460,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Oval Super Steel Bath 175 x 80cm No tap Hole - 2680-000 </strong></span></p>\n<p>Are you searching for a bath that can turn your ordinary bath into luxury one? Then Bette Starlet Oval bath is a right choice for you as there is no comparison of its quality and functions. There is no pre-drilled tap hole in this bath whereas the volume of water can be stored up to 139 litres. It is a double ended bath and keeps your bathroom clean by reducing the growth of germs and bacteria. It will keep your bathroom hygienic for you so you can relax easily. There is an anti-noise pad fitted as a standard. The smooth curvesinside the four seamless corners are making it extra unique and enhancing the visual appearance of this bath. It will resist scratches and impact by allowing its surface to stay shiny for a longer time.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Oval</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>\n\n\n'),(17515,75,0,6460,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Oval Super Steel Bath 175 x 80cm No tap Hole - 2680-000 </strong></span></p>\n<p>Are you searching for a bath that can turn your ordinary bath into luxury one? Then Bette Starlet Oval bath is a right choice for you as there is no comparison of its quality and functions. There is no pre-drilled tap hole in this bath whereas the volume of water can be stored up to 139 litres. It is a double ended bath and keeps your bathroom clean by reducing the growth of germs and bacteria. It will keep your bathroom hygienic for you so you can relax easily. There is an anti-noise pad fitted as a standard. The smooth curvesinside the four seamless corners are making it extra unique and enhancing the visual appearance of this bath. It will resist scratches and impact by allowing its surface to stay shiny for a longer time.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Oval</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>\n\n\n'),(17516,155,0,6460,'Exclude'),(17517,85,5,6461,'Bette Starlet Oval Super Steel Bath 185 x 85cm No Tap Hole - BE2740-000'),(17518,85,0,6461,'Bette Starlet Oval Super Steel Bath 185 x 85cm No Tap Hole - BE2740-000'),(17519,76,5,6461,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-oval-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Oval Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17520,76,0,6461,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-oval-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Oval Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17521,75,5,6461,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Oval Super Steel Bath 185 x 85cm No tap Hole - 2740-000 </strong></span></p>\n<p>Invest your money on the right bath for getting comfortable bath moments as bath matters a lot in any bathroom. If the bath you have installed in your bathroom does not work efficiently then it simply means you will not be able to get comfortable bath moments. Bette Starlet Oval bath is a proud product of Bette due to its high-quality manufacturing. Bette steel bath is heat conducting as well as hygienic. Heat can effortlessly pass through this bath so you will be able to enjoy comfortable bath moments in winters as most of the people find it difficult to take bath in winters. Bring this bath home to turn your hectic day into the relaxing one.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Oval</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>\n\n\n'),(17522,75,0,6461,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Oval Super Steel Bath 185 x 85cm No tap Hole - 2740-000 </strong></span></p>\n<p>Invest your money on the right bath for getting comfortable bath moments as bath matters a lot in any bathroom. If the bath you have installed in your bathroom does not work efficiently then it simply means you will not be able to get comfortable bath moments. Bette Starlet Oval bath is a proud product of Bette due to its high-quality manufacturing. Bette steel bath is heat conducting as well as hygienic. Heat can effortlessly pass through this bath so you will be able to enjoy comfortable bath moments in winters as most of the people find it difficult to take bath in winters. Bring this bath home to turn your hectic day into the relaxing one.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Oval</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>\n\n\n'),(17523,155,0,6461,'Exclude'),(17524,85,5,6462,'Bette Starlet Oval Super Steel Bath 195 x 95cm No Tap Hole - BE2745-000'),(17525,85,0,6462,'Bette Starlet Oval Super Steel Bath 195 x 95cm No Tap Hole - BE2745-000'),(17526,76,5,6462,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-oval-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Oval Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17527,76,0,6462,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-oval-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet Oval Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17528,75,5,6462,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Oval Super Steel Bath 195 x 95cm No tap Hole - BE2745-000 </strong></span></p>\n<p>Give your bathroom a more enlightening look by installing Bette Starlet Oval bath as it catches the eye even at very first sight. The edges of this bath are seamlessly curved and give a shape of an oval that looks great with any design of the bathroom. The length of this bath is 1950mm whereas its width is 950mm and the depth of this bath is 420mm. The colour of this bathtub is white that effortlessly blends with the design of any bathroom. 205 litres of water can be filled in this bath. This double ended bath is specially designed to give you comfort so there will be no better choice other than Bette Starlet oval bath. It is resistant to chemicals so you can clean it with any bath cleaner as its surface will not react to any chemical.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Oval</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>\n\n\n'),(17529,75,0,6462,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Oval Super Steel Bath 195 x 95cm No tap Hole - BE2745-000 </strong></span></p>\n<p>Give your bathroom a more enlightening look by installing Bette Starlet Oval bath as it catches the eye even at very first sight. The edges of this bath are seamlessly curved and give a shape of an oval that looks great with any design of the bathroom. The length of this bath is 1950mm whereas its width is 950mm and the depth of this bath is 420mm. The colour of this bathtub is white that effortlessly blends with the design of any bathroom. 205 litres of water can be filled in this bath. This double ended bath is specially designed to give you comfort so there will be no better choice other than Bette Starlet oval bath. It is resistant to chemicals so you can clean it with any bath cleaner as its surface will not react to any chemical.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Oval</li>\n<li>Double ended bath</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>\n\n\n'),(17530,155,0,6462,'Exclude'),(17531,85,5,6463,'Bette Form Super Steel Bath 190 x 80cm - BE3900-000'),(17532,85,0,6463,'Bette Form Super Steel Bath 190 x 80cm - BE3900-000'),(17533,76,5,6463,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17534,76,0,6463,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17535,75,5,6463,'<p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 190 x 80cm- BE3900-000 </strong></span></p>\r\n<p>Bette Form bath is a proud product of Bette and it has designed intelligently by following the latest standards of manufacturing as Bette&rsquo;s all products are always innovative and unique. The seamless round curves inside the rectangular shape of this bath give a unique touch to it. This <a href=\"/bathroom/baths/straight-baths.html\" target=\"_blank\">single ended bath </a>can be filled up to 150 litres to render you ease of use. The length of this bath is 1900mm whereas the width is 800mm and the depth is 420mm. It is highly durable and strong than other ordinary baths and the white colour of this bath can suit to any design of the bathroom. It will be rendered to you without any tap hole. It is made from sturdy steel so there is no doubt in its durability and you can use any bath cleaner for its cleaning as it is resistant to chemicals. Bring it home for giving an incredible touch to the design of your bathroom.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17536,75,0,6463,'<p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 190 x 80cm- BE3900-000 </strong></span></p>\r\n<p>Bette Form bath is a proud product of Bette and it has designed intelligently by following the latest standards of manufacturing as Bette&rsquo;s all products are always innovative and unique. The seamless round curves inside the rectangular shape of this bath give a unique touch to it. This <a href=\"/bathroom/baths/straight-baths.html\" target=\"_blank\">single ended bath </a>can be filled up to 150 litres to render you ease of use. The length of this bath is 1900mm whereas the width is 800mm and the depth is 420mm. It is highly durable and strong than other ordinary baths and the white colour of this bath can suit to any design of the bathroom. It will be rendered to you without any tap hole. It is made from sturdy steel so there is no doubt in its durability and you can use any bath cleaner for its cleaning as it is resistant to chemicals. Bring it home for giving an incredible touch to the design of your bathroom.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17537,155,0,6463,'Exclude'),(17538,85,5,6464,'Bette Form Super Steel Bath 170 x 70cm - BE3970-000, Bette Form, Modern Affordable Bathroom Products\r\n\r\n\r\n\r\n\r\n'),(17539,85,0,6464,'Bette Form Super Steel Bath 170 x 70cm - BE3970-000, Bette Form, Modern Affordable Bathroom Products\r\n\r\n\r\n\r\n\r\n'),(17540,76,5,6464,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17541,76,0,6464,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-form-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Form Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17542,75,5,6464,'<p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 170 x 70cm - 2945-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">Bette Form bath is famous for its unbeatable performance and long lasting quality. Soak yourself in a warm and cosy bath with Bette Form super steel bath which is manufactured by a leading brand, Bette. The pristine white finish will give a seamless blend with your existing bathroom setting. The superior quality titanium steel material is making this bath extra durable and more functional. It will elevate your luxury quotient as this single ended bath gives a perfect fit to your bathroom. There is  No tap Hole in this bette bath 1700x 700 and an anti-noised pad is fitted as a standard. It is a good heat conductor so it will give you a warm feeling in winters as heat can pass through it easily. Shape of this bath is rectangular. It can be filled up to 120 litres of water that is more than sufficient for a perfect bath.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant and reassuringly robust</li>\r\n</ul>\r\n'),(17543,75,0,6464,'<p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Bath 170 x 70cm - 2945-000 </strong></span></p>\r\n<p style=\"text-align: justify;\">Bette Form bath is famous for its unbeatable performance and long lasting quality. Soak yourself in a warm and cosy bath with Bette Form super steel bath which is manufactured by a leading brand, Bette. The pristine white finish will give a seamless blend with your existing bathroom setting. The superior quality titanium steel material is making this bath extra durable and more functional. It will elevate your luxury quotient as this single ended bath gives a perfect fit to your bathroom. There is  No tap Hole in this bette bath 1700x 700 and an anti-noised pad is fitted as a standard. It is a good heat conductor so it will give you a warm feeling in winters as heat can pass through it easily. Shape of this bath is rectangular. It can be filled up to 120 litres of water that is more than sufficient for a perfect bath.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant and reassuringly robust</li>\r\n</ul>\r\n'),(17544,155,0,6464,'Exclude'),(17545,85,5,6465,'Bette Starlet IV Silhouette Steel Bath 165 x 75cm No Tap Hole - BE6650-000CERVK'),(17546,85,0,6465,'Bette Starlet IV Silhouette Steel Bath 165 x 75cm No Tap Hole - BE6650-000CERVK'),(17547,76,5,6465,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-iv-silhouette-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet IV Silhouette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17548,76,0,6465,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-iv-silhouette-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet IV Silhouette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17549,75,5,6465,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet IV Silhouette Steel Bath 1950 x 950mm - No TH</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>For fitting in the corner</li>\r\n<li>Super steel bath</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17550,75,0,6465,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet IV Silhouette Steel Bath 1950 x 950mm - No TH</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>For fitting in the corner</li>\r\n<li>Super steel bath</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17551,155,0,6465,'Exclude'),(17552,85,5,6466,'Bette Starlet IV Silhouette Steel Bath 175 x 80cm No Tap Hole - BE6660-000'),(17553,85,0,6466,'Bette Starlet IV Silhouette Steel Bath 175 x 80cm No Tap Hole - BE6660-000'),(17554,76,5,6466,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-iv-silhouette-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet IV Silhouette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17555,76,0,6466,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-iv-silhouette-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet IV Silhouette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17556,75,5,6466,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet IV Silhouette Steel Bath 165 x 75cm No tap Hole - BE6650-000CERVK </strong></span></p>\r\n<p>Manufacturing innovative products is the habit of Bette. Bette Starlet IV Silhouette is an amazing combination of durability and flexibility. It will save sufficient space in your bathroom and will look stylish at the same time. The bath in your bathroom reflects your taste so make sure that it is good enough to impress others. There is a centrally positioned drain that will render more functionality as it can be filled up to 116 litres. The dimensions of this bath are suitable enough to give a comfortable use as its width is 750mm and depth of 420mm. There is no pre-drilled tap hole in this bath to give you maximum comfort. An anti-noised pad is fitted with it as a standard and the sturdy titanium finished steel increase the durability of this bath. It is an excellent conductor of heat so you will get a warm and cosy feeling in the winters as heat will pass through it effortlessly.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>For fitting in the corner</li>\r\n<li>Super steel bath</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n\r\n</ul>\r\n\r\n'),(17557,75,0,6466,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet IV Silhouette Steel Bath 165 x 75cm No tap Hole - BE6650-000CERVK </strong></span></p>\r\n<p>Manufacturing innovative products is the habit of Bette. Bette Starlet IV Silhouette is an amazing combination of durability and flexibility. It will save sufficient space in your bathroom and will look stylish at the same time. The bath in your bathroom reflects your taste so make sure that it is good enough to impress others. There is a centrally positioned drain that will render more functionality as it can be filled up to 116 litres. The dimensions of this bath are suitable enough to give a comfortable use as its width is 750mm and depth of 420mm. There is no pre-drilled tap hole in this bath to give you maximum comfort. An anti-noised pad is fitted with it as a standard and the sturdy titanium finished steel increase the durability of this bath. It is an excellent conductor of heat so you will get a warm and cosy feeling in the winters as heat will pass through it effortlessly.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>For fitting in the corner</li>\r\n<li>Super steel bath</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n\r\n</ul>\r\n\r\n'),(17558,155,0,6466,'Exclude'),(17559,85,5,6467,'Bette Starlet IV Silhouette Steel Bath 185 x 85cm No Tap Hole - BE6670-000CERVK'),(17560,85,0,6467,'Bette Starlet IV Silhouette Steel Bath 185 x 85cm No Tap Hole - BE6670-000CERVK'),(17561,76,5,6467,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-iv-silhouette-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet IV Silhouette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17562,76,0,6467,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-iv-silhouette-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet IV Silhouette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17563,75,5,6467,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet IV Silhouette Steel Bath 175 x 80cm No tap Hole - BE6660-000\r\n</strong></span></p>\r\n<p>Give place to Bette Starlet IV Silhouette bath in your bathroom for making it extra functional and extra luxurious. The accurate dimensions of this bath include a length of 1750mm, width of 800mm and a depth of 420mm. You can fill it with maximum 139 litres of water that is sufficient for making your bath comfortable. This distinctive bath is available in white colour with seamless and eye catching look. An anti-noise pad is fitted in it as a standard and is supplied without any tap hole. You will find it a space saving bath for relatively small bathrooms. It is not only a good conductor of heat but stops bacterial growth with great percentage. It is resistant to chemicals so you can clean it with any bath cleaner as its surface will remain shiny and new after using any cleaner. </p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>For fitting in the corner </li>\r\n<li>Super steel bath</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17564,75,0,6467,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet IV Silhouette Steel Bath 175 x 80cm No tap Hole - BE6660-000\r\n</strong></span></p>\r\n<p>Give place to Bette Starlet IV Silhouette bath in your bathroom for making it extra functional and extra luxurious. The accurate dimensions of this bath include a length of 1750mm, width of 800mm and a depth of 420mm. You can fill it with maximum 139 litres of water that is sufficient for making your bath comfortable. This distinctive bath is available in white colour with seamless and eye catching look. An anti-noise pad is fitted in it as a standard and is supplied without any tap hole. You will find it a space saving bath for relatively small bathrooms. It is not only a good conductor of heat but stops bacterial growth with great percentage. It is resistant to chemicals so you can clean it with any bath cleaner as its surface will remain shiny and new after using any cleaner. </p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>For fitting in the corner </li>\r\n<li>Super steel bath</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17565,155,0,6467,'Exclude'),(17566,85,5,6468,'Bette Starlet V Silhouette Steel Bath 165 x 75cm No Tap Hole - BE6680-000CELVK'),(17567,85,0,6468,'Bette Starlet V Silhouette Steel Bath 165 x 75cm No Tap Hole - BE6680-000CELVK'),(17568,76,5,6468,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-v-silhouette-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet V Silhouette Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17569,76,0,6468,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-v-silhouette-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet V Silhouette Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17570,75,5,6468,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet V Silhouette Steel Bath 165 x 75cm No tap Hole - BE6680-000CELVK </strong></span></p>\n<p>Bette Starlet V Silhouette bath is manufactured to make your life more comfortable. It is designed for fitting in the corner so it will save an ample space in your bathroom where you can easily place other essential things. It is supplied with feet without rendering you any pre-drilled tap hole. This double ended bath can be filled up to 116 litres of water that are enough for making your bath comfortable. There is an anti-noise pad fitted with this bath to give you comfortable use. UV rays cannot affect the surface of this bath as it is resistant to UV due to the construction with sturdy titanium finished steel. Scratches will not stay longer on it as this double ended bath is scratch and impact resistant. The length of this 1650mm whereas the width is 750mm and the depth is of 420mm.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Super steel bath</li>\n<li>Double ended bath</li>\n<li>For fitting in the corner</li>\n<li>Supplied with no tap hole</li>\n<li>Anti-noise pad is fitted as standard</li>\n<li>Bath with centrally-positioned drain</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n\n</ul>\n\n'),(17571,75,0,6468,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet V Silhouette Steel Bath 165 x 75cm No tap Hole - BE6680-000CELVK </strong></span></p>\n<p>Bette Starlet V Silhouette bath is manufactured to make your life more comfortable. It is designed for fitting in the corner so it will save an ample space in your bathroom where you can easily place other essential things. It is supplied with feet without rendering you any pre-drilled tap hole. This double ended bath can be filled up to 116 litres of water that are enough for making your bath comfortable. There is an anti-noise pad fitted with this bath to give you comfortable use. UV rays cannot affect the surface of this bath as it is resistant to UV due to the construction with sturdy titanium finished steel. Scratches will not stay longer on it as this double ended bath is scratch and impact resistant. The length of this 1650mm whereas the width is 750mm and the depth is of 420mm.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Super steel bath</li>\n<li>Double ended bath</li>\n<li>For fitting in the corner</li>\n<li>Supplied with no tap hole</li>\n<li>Anti-noise pad is fitted as standard</li>\n<li>Bath with centrally-positioned drain</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n\n</ul>\n\n'),(17572,155,0,6468,'Exclude'),(17573,85,5,6469,'Bette Starlet V Silhouette Steel Bath 175 x 80cm No Tap Hole - BE6690-000CELVK'),(17574,85,0,6469,'Bette Starlet V Silhouette Steel Bath 175 x 80cm No Tap Hole - BE6690-000CELVK'),(17575,76,5,6469,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-v-silhouette-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet V Silhouette Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17576,76,0,6469,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-v-silhouette-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet V Silhouette Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17577,75,5,6469,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet V Silhouette Steel Bath 175 x 80cm No Tap Hole - BE6690-000CELVK </strong></span></p>\n<p>Are you tired of uncomfortable bath? Well, Bette has brought to you a solution by offering Bette Starlet V Silhouette bath that works beyond your expectations. This double ended bath is designed to give more comfort while you take bath. It renders you an additional benefit as there is no tap hole in this bath. Germs and bacteria usually grow with high speed in bathrooms but you should be happy that your bathroom will be bacteria free as the smooth and hygienic surface of Bette bath does not allow bacteria to grow and keeps your bathroom a hygienic place to be used. The white shine of this bath is long lasting as it will stay same even after the decades of use. This Bette steel bath is available at Banyo with a discounted price.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Super steel bath</li>\n<li>Double ended bath</li>\n<li>For fitting in the corner</li>\n<li>Supplied with no tap hole</li>\n<li>Anti-noise pad is fitted as standard</li>\n<li>Bath with centrally-positioned drain</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>\n'),(17578,75,0,6469,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet V Silhouette Steel Bath 175 x 80cm No Tap Hole - BE6690-000CELVK </strong></span></p>\n<p>Are you tired of uncomfortable bath? Well, Bette has brought to you a solution by offering Bette Starlet V Silhouette bath that works beyond your expectations. This double ended bath is designed to give more comfort while you take bath. It renders you an additional benefit as there is no tap hole in this bath. Germs and bacteria usually grow with high speed in bathrooms but you should be happy that your bathroom will be bacteria free as the smooth and hygienic surface of Bette bath does not allow bacteria to grow and keeps your bathroom a hygienic place to be used. The white shine of this bath is long lasting as it will stay same even after the decades of use. This Bette steel bath is available at Banyo with a discounted price.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Super steel bath</li>\n<li>Double ended bath</li>\n<li>For fitting in the corner</li>\n<li>Supplied with no tap hole</li>\n<li>Anti-noise pad is fitted as standard</li>\n<li>Bath with centrally-positioned drain</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>\n'),(17579,155,0,6469,'Exclude'),(17580,85,5,6470,'Bette Starlet V Silhouette Steel Bath 185 x 85cm No Tap Hole - BE6700-000CELVK'),(17581,85,0,6470,'Bette Starlet V Silhouette Steel Bath 185 x 85cm No Tap Hole - BE6700-000CELVK'),(17582,76,5,6470,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-v-silhouette-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet V Silhouette Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17583,76,0,6470,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-v-silhouette-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Starlet V Silhouette Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17584,75,5,6470,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet V Silhouette Steel Bath 185 x 85cm No tap Hole - BE6700-000CELVK </strong></span></p>\n<p>If your bath is shortage of space and still you want to install a functional as well as beautiful bath then there is no better choice other than Bette Starlet V Silhouette bath. It is designed by highly experienced team of Bette due to which it renders functionality that cannot be seen in any other bath. The soft touch can make you feel good as its surface is unbelievingly smooth and seamless. The manufacturing of this Bette bath is done with high-quality stainless steel that has made it extremely hygienic and long lasting. Heat can effortlessly pass through it so you will get a warm touch whenever you use this bath. It is fitted with anti-noise pad as standard. It is resistant to chemicals, scratches, and impact so you can clean it easily with any bath cleaner.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Super steel bath</li>\n<li>Double ended bath</li>\n<li>For fitting in the corner</li>\n<li>Supplied with no tap hole</li>\n<li>Anti-noise pad is fitted as standard</li>\n<li>Bath with centrally-positioned drain</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>\n\n'),(17585,75,0,6470,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet V Silhouette Steel Bath 185 x 85cm No tap Hole - BE6700-000CELVK </strong></span></p>\n<p>If your bath is shortage of space and still you want to install a functional as well as beautiful bath then there is no better choice other than Bette Starlet V Silhouette bath. It is designed by highly experienced team of Bette due to which it renders functionality that cannot be seen in any other bath. The soft touch can make you feel good as its surface is unbelievingly smooth and seamless. The manufacturing of this Bette bath is done with high-quality stainless steel that has made it extremely hygienic and long lasting. Heat can effortlessly pass through it so you will get a warm touch whenever you use this bath. It is fitted with anti-noise pad as standard. It is resistant to chemicals, scratches, and impact so you can clean it easily with any bath cleaner.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Super steel bath</li>\n<li>Double ended bath</li>\n<li>For fitting in the corner</li>\n<li>Supplied with no tap hole</li>\n<li>Anti-noise pad is fitted as standard</li>\n<li>Bath with centrally-positioned drain</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>\n\n'),(17586,155,0,6470,'Exclude'),(17587,85,5,6471,'Bette Ocean Super Steel Bath 1800 x 800mm No tap Hole - 8856 8857'),(17588,85,0,6471,'Bette Ocean Super Steel Bath 1800 x 800mm No tap Hole - 8856 8857'),(17589,76,5,6471,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-single-ended-super-steel-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17590,76,0,6471,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-single-ended-super-steel-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17591,75,5,6471,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Super Steel Bath 1800 x 800mm No tap Hole - 8856 8857</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Spacious, body-contoured lying profile</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>The 45cm bath depth also enables larger people to completely submerge and relax</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and sodad</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n'),(17592,75,0,6471,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Super Steel Bath 1800 x 800mm No tap Hole - 8856 8857</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Spacious, body-contoured lying profile</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>The 45cm bath depth also enables larger people to completely submerge and relax</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and sodad</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n\r\n'),(17593,155,0,6471,'Exclude'),(17594,85,5,6472,'Bette Ocean Lowline Super Steel Bath 1500 x 700mm - Banyo'),(17595,85,0,6472,'Bette Ocean Lowline Super Steel Bath 1500 x 700mm - Banyo'),(17596,76,5,6472,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-lowline-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Lowline Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17597,76,0,6472,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-lowline-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Lowline Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17598,75,5,6472,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Lowline Super Steel Bath 150 x 70cm No Tap Hole - BE8841-000 BE8842-000</strong></span></p>\n<p>Bette Ocean Lowline super steel bath is a proud product of Bette as the highly capable team of Bette has designed this bath to render you comfort. With Bette bath, bathing simply means getting relaxed. There is a shallow tub depth that will allow you to effortlessly enter into the bath tub. It is hygienic as well as resistant to chemicals. An anti-noised pad is fitted in this bath as a standard. Germs and bacteria usually grow with speed in bathrooms but you should be happy that your bathroom will be freed from bacteria as the smooth and hygienic surface of Bette bath does not allow bacteria to grow and keeps your bathroom a hygienic place to be used. The white shine of this bath is long lasting as it will stay same even after the decades of use. This Bette steel bath is available at Banyo with a discounted price.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Spacious, body-contoured lying profile</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and sodad</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>\n'),(17599,75,0,6472,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Lowline Super Steel Bath 150 x 70cm No Tap Hole - BE8841-000 BE8842-000</strong></span></p>\n<p>Bette Ocean Lowline super steel bath is a proud product of Bette as the highly capable team of Bette has designed this bath to render you comfort. With Bette bath, bathing simply means getting relaxed. There is a shallow tub depth that will allow you to effortlessly enter into the bath tub. It is hygienic as well as resistant to chemicals. An anti-noised pad is fitted in this bath as a standard. Germs and bacteria usually grow with speed in bathrooms but you should be happy that your bathroom will be freed from bacteria as the smooth and hygienic surface of Bette bath does not allow bacteria to grow and keeps your bathroom a hygienic place to be used. The white shine of this bath is long lasting as it will stay same even after the decades of use. This Bette steel bath is available at Banyo with a discounted price.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Spacious, body-contoured lying profile</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and sodad</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>\n'),(17600,155,0,6472,'Exclude'),(17601,85,5,6473,'Bette Ocean Super Steel Bath 1500 x 700mm - Banyo'),(17602,85,0,6473,'Bette Ocean Super Steel Bath 1500 x 700mm - Banyo'),(17603,76,5,6473,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-single-ended-super-steel-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17604,76,0,6473,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-single-ended-super-steel-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17605,75,5,6473,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Super Steel Bath 150 x 70cm No tap Hole - BE8858-000 BE8859-000 </strong></span></p>\r\n<p>Bette Ocean is an exciting range of Bette that is designed to bring an ultimate comfort in your life. There is a shallow tub depth that will allow you to effortlessly enter into the bath tub. It is hygienic as well as resistant to chemicals. An anti-noised pad is fitted in this bath as a standard. Germs and bacteria usually grow with speed in bathrooms but you should be happy that your bathroom will be freed from bacteria as the smooth and hygienic surface of Bette bath does not allow bacteria to grow and keeps your bathroom a hygienic place to be used. The white shine of this bath is long lasting as it will stay same even after the decades of use. This Bette steel bath is available at Banyo with a discounted price. The depth of this bath tub is 450mm that allows people of larger height and size to enter into the bath easily and effortlessly.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Spacious, body-contoured lying profile</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>The 45cm bath depth also enables larger people to completely submerge and relax</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and sodad</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17606,75,0,6473,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Super Steel Bath 150 x 70cm No tap Hole - BE8858-000 BE8859-000 </strong></span></p>\r\n<p>Bette Ocean is an exciting range of Bette that is designed to bring an ultimate comfort in your life. There is a shallow tub depth that will allow you to effortlessly enter into the bath tub. It is hygienic as well as resistant to chemicals. An anti-noised pad is fitted in this bath as a standard. Germs and bacteria usually grow with speed in bathrooms but you should be happy that your bathroom will be freed from bacteria as the smooth and hygienic surface of Bette bath does not allow bacteria to grow and keeps your bathroom a hygienic place to be used. The white shine of this bath is long lasting as it will stay same even after the decades of use. This Bette steel bath is available at Banyo with a discounted price. The depth of this bath tub is 450mm that allows people of larger height and size to enter into the bath easily and effortlessly.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Spacious, body-contoured lying profile</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>The 45cm bath depth also enables larger people to completely submerge and relax</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and sodad</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17607,155,0,6473,'Exclude'),(17608,85,5,6474,'Bette Ocean Super Steel Bath 1600 x 700mm - Banyo'),(17609,85,0,6474,'Bette Ocean Super Steel Bath 1600 x 700mm - Banyo'),(17610,76,5,6474,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-single-ended-super-steel-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17611,76,0,6474,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-single-ended-super-steel-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17612,75,5,6474,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Super Steel Bath 160 x 70cm No tap Hole - BE8850-000 </strong></span></p>\n<p>Turn your ordinary bathroom into the most stylish one by installing <strong>Bette Ocean</strong> Super Steel Bath as it brings style to your bathroom. It has a spacious, body contoured lying profile. The depth of this bath is 450mm that will allow people of larger size to completely submerge and relax. Water can be filled in this bath up to 148 litres to render you more comfortable use. Bette Ocean 1600 Single ended bath is available in white colour that looks great with any bathroom design. There is no pre-drilled tap hole in this 1600 bath. Ultraviolet rays will not affect the smooth surface of this bath because it is UV resistant. More on, germs and bacteria cannot grow in your bathroom if you will install Bette Ocean bath as it stops bacterial growth and keeps your ocean bathroom hygienic.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Spacious, body-contoured lying profile</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>The 45cm bath depth also enables larger people to completely submerge and relax</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17613,75,0,6474,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Super Steel Bath 160 x 70cm No tap Hole - BE8850-000 </strong></span></p>\n<p>Turn your ordinary bathroom into the most stylish one by installing <strong>Bette Ocean</strong> Super Steel Bath as it brings style to your bathroom. It has a spacious, body contoured lying profile. The depth of this bath is 450mm that will allow people of larger size to completely submerge and relax. Water can be filled in this bath up to 148 litres to render you more comfortable use. Bette Ocean 1600 Single ended bath is available in white colour that looks great with any bathroom design. There is no pre-drilled tap hole in this 1600 bath. Ultraviolet rays will not affect the smooth surface of this bath because it is UV resistant. More on, germs and bacteria cannot grow in your bathroom if you will install Bette Ocean bath as it stops bacterial growth and keeps your ocean bathroom hygienic.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Spacious, body-contoured lying profile</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>The 45cm bath depth also enables larger people to completely submerge and relax</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17614,155,0,6474,'Exclude'),(17615,85,5,6475,'Bette Ocean Super Steel Bath 1700 x 800mm - Banyo'),(17616,85,0,6475,'Bette Ocean Super Steel Bath 1700 x 800mm - Banyo'),(17617,76,5,6475,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-single-ended-super-steel-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17618,76,0,6475,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-single-ended-super-steel-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17619,75,5,6475,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Super Steel Bath 170 x 80cm No tap Hole - BE8765-000 BE8865-000 </strong></span></p>\n<p>Bring home Bette Ocean Super steel 1700 x 800 bath to enhance the visual appearance of your bathroom. The overflow of this bath is on right hand side as well as on left hand side. No tap hole is pre-drilled in this bath. You can fill the volume of water up to 202 litres and the colour of this single ended bath is white. You will be able to clean your bath within no time as it does not react to any chemical or <a tabindex=\"0\" href=\"/bathroom/baths.html\" target=\"_blank\" rel=\"noopener\">bath</a> cleaners. Taking bath in winters is not a problem anymore as this bath will render you cosy and warm feeling in winters due to its heat conducting quality. It is very easy to maintain as well as ultraviolet rays will also not affect its surface because it is UV resistant. You can completely submerge and relax into this bath due to its efficiently designed depth of 450mm. It has a spacious, body-contoured lying profile. Avail the incredible discount offered by Banyo to make your dream bathroom within your budget.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Spacious, body-contoured lying profile</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>The 45cm bath depth also enables larger people to completely submerge and relax</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and sodad</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17620,75,0,6475,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Super Steel Bath 170 x 80cm No tap Hole - BE8765-000 BE8865-000 </strong></span></p>\n<p>Bring home Bette Ocean Super steel 1700 x 800 bath to enhance the visual appearance of your bathroom. The overflow of this bath is on right hand side as well as on left hand side. No tap hole is pre-drilled in this bath. You can fill the volume of water up to 202 litres and the colour of this single ended bath is white. You will be able to clean your bath within no time as it does not react to any chemical or <a tabindex=\"0\" href=\"/bathroom/baths.html\" target=\"_blank\" rel=\"noopener\">bath</a> cleaners. Taking bath in winters is not a problem anymore as this bath will render you cosy and warm feeling in winters due to its heat conducting quality. It is very easy to maintain as well as ultraviolet rays will also not affect its surface because it is UV resistant. You can completely submerge and relax into this bath due to its efficiently designed depth of 450mm. It has a spacious, body-contoured lying profile. Avail the incredible discount offered by Banyo to make your dream bathroom within your budget.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Spacious, body-contoured lying profile</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>The 45cm bath depth also enables larger people to completely submerge and relax</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and sodad</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n</ul>'),(17621,155,0,6475,'Exclude'),(17622,85,5,6476,'Bette Ocean Super Steel Bath 1700 x 700mm - Banyo'),(17623,85,0,6476,'Bette Ocean Super Steel Bath 1700 x 700mm - Banyo'),(17624,76,5,6476,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-single-ended-super-steel-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17625,76,0,6476,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-single-ended-super-steel-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17626,75,5,6476,'<style>#html-body [data-pb-style=XC9RWY7]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"XC9RWY7\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Ocean Super Steel Bath 170 x 70cm- BE8852-000 BE8853-000 </strong></span></p>\r\n<p>We have a high quality bath 1700 x 700 variety for you to choose from. A right bath can make your bath moments more comfortable and that is why Bette has offered you Bette Ocean Super steel bath that is designed after many tests and research. This Bette bath is designed to bring you a lot of convenience. It is heat conducting, hygienic as well as easy to maintain. The sturdy titanium finished steel is used in its manufacturing to enhance the performance of it. There is an anti-noise pad fitted in this super steel bath and it is supplied without any tap hole. It is refined with unique BETTLE GLAZE enamel finish that is made by using quartz, borax, soda, glass, and water. It is intelligently manufactured so there are no loopholes in this bath and it is brought to you after so many tests to give to satisfactory results. Bring it home by availing an exciting discount offered by Banyo. Bette is rendering a guarantee of 30 years on this product for your peace of mind. This comfortable Ocean bath has no tap hole in it. Its non-fading stable white colour is making it more incredible as it will retain its look even after decades of use.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Spacious, body-contoured lying profile</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n<li>The 45cm bath depth also enables larger people to completely submerge and relax robust</li>\r\n</ul></div></div></div>'),(17627,75,0,6476,'<style>#html-body [data-pb-style=XC9RWY7]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"XC9RWY7\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Bette Ocean Super Steel Bath 170 x 70cm- BE8852-000 BE8853-000 </strong></span></p>\r\n<p>We have a high quality bath 1700 x 700 variety for you to choose from. A right bath can make your bath moments more comfortable and that is why Bette has offered you Bette Ocean Super steel bath that is designed after many tests and research. This Bette bath is designed to bring you a lot of convenience. It is heat conducting, hygienic as well as easy to maintain. The sturdy titanium finished steel is used in its manufacturing to enhance the performance of it. There is an anti-noise pad fitted in this super steel bath and it is supplied without any tap hole. It is refined with unique BETTLE GLAZE enamel finish that is made by using quartz, borax, soda, glass, and water. It is intelligently manufactured so there are no loopholes in this bath and it is brought to you after so many tests to give to satisfactory results. Bring it home by availing an exciting discount offered by Banyo. Bette is rendering a guarantee of 30 years on this product for your peace of mind. This comfortable Ocean bath has no tap hole in it. Its non-fading stable white colour is making it more incredible as it will retain its look even after decades of use.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Spacious, body-contoured lying profile</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n<li>The 45cm bath depth also enables larger people to completely submerge and relax robust</li>\r\n</ul></div></div></div>'),(17628,155,0,6476,'Exclude'),(17629,85,5,6477,'Bette Ocean Super Steel Bath 1700 x 750mm - Banyo'),(17630,85,0,6477,'Bette Ocean Super Steel Bath 1700 x 750mm - Banyo'),(17631,76,5,6477,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-single-ended-super-steel-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17632,76,0,6477,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-single-ended-super-steel-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17633,75,5,6477,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Super Steel Bath 170 x 75cm No tap Hole- BE8854 -000 BE8855-000 </strong></span></p>\r\n<p>Your search for a functional bath should stop at Bette Ocean Super Steel bath as it gives you a complete blend of design and functionality. Its dimensions include a length of 1700mm, a width of 750mm whereas a depth of 450mm. It will make your life easier by giving you comfortable bath moments. Bring it home and turn your ordinary <strong><a href=\"/bathroom.html\" target=\"_blank\" rel=\"noopener\">bathroom</a></strong> into a functional one. It’s inner shape blends melodiously with its outer rectangular seamless corners. The profile of this bath is spacious and body contoured. It can be filled up to 185 litres of water and it is a single ended bath. It is refined with a unique BETTEGLAZE enamel finish that is made by using water, glass, quartz, borax, and soda.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Spacious, body-contoured lying profile</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>The 45cm bath depth also enables larger people to completely submerge and relax</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and sodad</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17634,75,0,6477,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Super Steel Bath 170 x 75cm No tap Hole- BE8854 -000 BE8855-000 </strong></span></p>\r\n<p>Your search for a functional bath should stop at Bette Ocean Super Steel bath as it gives you a complete blend of design and functionality. Its dimensions include a length of 1700mm, a width of 750mm whereas a depth of 450mm. It will make your life easier by giving you comfortable bath moments. Bring it home and turn your ordinary <strong><a href=\"/bathroom.html\" target=\"_blank\" rel=\"noopener\">bathroom</a></strong> into a functional one. It’s inner shape blends melodiously with its outer rectangular seamless corners. The profile of this bath is spacious and body contoured. It can be filled up to 185 litres of water and it is a single ended bath. It is refined with a unique BETTEGLAZE enamel finish that is made by using water, glass, quartz, borax, and soda.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Spacious, body-contoured lying profile</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>The 45cm bath depth also enables larger people to completely submerge and relax</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and sodad</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17635,155,0,6477,'Exclude'),(17636,85,5,6478,'Bette Ocean Lowline Super Steel Bath 1600 x 700mm - Banyo'),(17637,85,0,6478,'Bette Ocean Lowline Super Steel Bath 1600 x 700mm - Banyo'),(17638,76,5,6478,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-lowline-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Lowline Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17639,76,0,6478,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-lowline-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Lowline Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17640,75,5,6478,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Lowline Super Steel Bath 160 x 70cm No tap Hole - BE8830-000 BE8831-000</strong></span></p>\n<p>Spend your money on the right product and Bring Bette Ocean Lowline in your home for redecorating your bathroom. It will definitely turn your ordinary bathroom into the most stylish one. But the thing does not end here only as its functionality is also unmatchable. The volume of water that can be filled in this bath is up to 120 litres as well as it has spacious and body contoured profile. This bath and shower combination will be an effective choice for your contemporary bathroom. You can give an enlightening touch to your bathroom by installing this bath. It will save your cost as it is a water saving bath so the bill of water also be reduced. Bette is offering a guarantee of 30 years against any defect for your peace of mind.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Spacious, body-contoured lying profile</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Optimal use of the bathing area using extremely thin bath edges</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n\n</ul>\n\n'),(17641,75,0,6478,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Lowline Super Steel Bath 160 x 70cm No tap Hole - BE8830-000 BE8831-000</strong></span></p>\n<p>Spend your money on the right product and Bring Bette Ocean Lowline in your home for redecorating your bathroom. It will definitely turn your ordinary bathroom into the most stylish one. But the thing does not end here only as its functionality is also unmatchable. The volume of water that can be filled in this bath is up to 120 litres as well as it has spacious and body contoured profile. This bath and shower combination will be an effective choice for your contemporary bathroom. You can give an enlightening touch to your bathroom by installing this bath. It will save your cost as it is a water saving bath so the bill of water also be reduced. Bette is offering a guarantee of 30 years against any defect for your peace of mind.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Spacious, body-contoured lying profile</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Optimal use of the bathing area using extremely thin bath edges</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n\n</ul>\n\n'),(17642,155,0,6478,'Exclude'),(17643,85,5,6479,'Bette Ocean Lowline Super Steel Bath 1700 x 800mm - Banyo'),(17644,85,0,6479,'Bette Ocean Lowline Super Steel Bath 1700 x 800mm - Banyo'),(17645,76,5,6479,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-lowline-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Lowline Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17646,76,0,6479,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-lowline-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Lowline Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17647,75,5,6479,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Lowline Super Steel Bath 170 x 80cm No tap Hole - BE8836-000 BE8837-000</strong></span></p>\n<p>Dimensions matter a lot in the manufacturing of any bath so the dimensions of Bette Ocean Lowline super steel bath are designed to make it a perfect choice for you. The shallow tub depth will allow comfortable entrance and will save your water cost also. This bath and shower combination gives a unique touch to the design of your bathroom. It can suit to all designs of bathroom because its colour is white that looks great with any design of bathroom. The length of this bath is 1700mm whereas its width is 800mm and depth is 380mm. This super steel bath is manufactured from sturdy titanium finished steel that makes it scratch, impact, chemicals and UV resistant.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Spacious, body-contoured lying profile</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>Optimal use of the bathing area using extremely thin bath edges</li>\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n\n</ul>\n\n\n\n'),(17648,75,0,6479,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Lowline Super Steel Bath 170 x 80cm No tap Hole - BE8836-000 BE8837-000</strong></span></p>\n<p>Dimensions matter a lot in the manufacturing of any bath so the dimensions of Bette Ocean Lowline super steel bath are designed to make it a perfect choice for you. The shallow tub depth will allow comfortable entrance and will save your water cost also. This bath and shower combination gives a unique touch to the design of your bathroom. It can suit to all designs of bathroom because its colour is white that looks great with any design of bathroom. The length of this bath is 1700mm whereas its width is 800mm and depth is 380mm. This super steel bath is manufactured from sturdy titanium finished steel that makes it scratch, impact, chemicals and UV resistant.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Spacious, body-contoured lying profile</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>Optimal use of the bathing area using extremely thin bath edges</li>\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n\n</ul>\n\n\n\n'),(17649,155,0,6479,'Exclude'),(17650,85,5,6480,'Bette Ocean Lowline Super Steel Bath 1700 x 700mm - Banyo'),(17651,85,0,6480,'Bette Ocean Lowline Super Steel Bath 1700 x 700mm - Banyo'),(17652,76,5,6480,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-lowline-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Lowline Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17653,76,0,6480,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-lowline-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Lowline Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17654,75,5,6480,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Lowline Super Steel Bath 170 x 70cm- BE8832-000 BE8833-000</strong></span></p>\r\n<p>Get comfortable bath moments by installing Bette Ocean Lowline super steel bath. It will render you overflow on left hand side as well as on right hand side. It&rsquo;s designing is schimddem, Berlin as well as it has a spacious, body contoured lying profile. The shallow tub depth will allow comfortable entrance. There is an anti-noised pad fitted in this bath as a standard. It is a water saving bath and can be filled up to 120 litres of water. It is a combination of bath and shower and there is no pre-drilled tap hole in this bath. Bring it home by availing an exciting discount offered by Banyo. Bette is rendering a guarantee of 30 years on this product for your peace of mind. This comfortable hip bath is supplied with feet and there is no tap hole in it. Its non-fading stable white colour is making it more incredible as it will retain its look even after decades of use.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Spacious, body-contoured lying profile</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Optimal use of the bathing area using extremely thin bath edges</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n\r\n</ul>\r\n\r\n'),(17655,75,0,6480,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Lowline Super Steel Bath 170 x 70cm- BE8832-000 BE8833-000</strong></span></p>\r\n<p>Get comfortable bath moments by installing Bette Ocean Lowline super steel bath. It will render you overflow on left hand side as well as on right hand side. It&rsquo;s designing is schimddem, Berlin as well as it has a spacious, body contoured lying profile. The shallow tub depth will allow comfortable entrance. There is an anti-noised pad fitted in this bath as a standard. It is a water saving bath and can be filled up to 120 litres of water. It is a combination of bath and shower and there is no pre-drilled tap hole in this bath. Bring it home by availing an exciting discount offered by Banyo. Bette is rendering a guarantee of 30 years on this product for your peace of mind. This comfortable hip bath is supplied with feet and there is no tap hole in it. Its non-fading stable white colour is making it more incredible as it will retain its look even after decades of use.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Spacious, body-contoured lying profile</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Optimal use of the bathing area using extremely thin bath edges</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n\r\n</ul>\r\n\r\n'),(17656,155,0,6480,'Exclude'),(17657,85,5,6481,'Bette Ocean Lowline Super Steel Bath 1700 x 750mm - Banyo'),(17658,85,0,6481,'Bette Ocean Lowline Super Steel Bath 1700 x 750mm - Banyo'),(17659,76,5,6481,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-lowline-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Lowline Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17660,76,0,6481,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-lowline-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Lowline Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17661,75,5,6481,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Lowline Super Steel Bath 170 x 75cm No tap Hole - BE8834-000 BE8835-000</strong></span></p>\n<p>Are you searching for a bath that will turn your hectic day into comfortable one? Well, Bette understands your needs regarding a perfect bathroom and that is why it has offered you Bette Ocean Lowline bath with incredible designing and unmatchable features. This double ended bath will allow you to enjoy comfortable bath moments every time you use it. The manufacturing of this Bette bath is done with high-quality stainless steel that has made it extremely hygienic and long lasting. Heat can effortlessly pass through it so you will get a warm touch whenever you use this bath. It is fitted with anti-noise pad as standard. It is resistant to chemicals, scratches, and impact so you can clean it easily with any bath cleaner.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Spacious, body-contoured lying profile</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>Optimal use of the bathing area using extremely thin bath edges</li>\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n\n</ul>\n\n\n\n'),(17662,75,0,6481,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Lowline Super Steel Bath 170 x 75cm No tap Hole - BE8834-000 BE8835-000</strong></span></p>\n<p>Are you searching for a bath that will turn your hectic day into comfortable one? Well, Bette understands your needs regarding a perfect bathroom and that is why it has offered you Bette Ocean Lowline bath with incredible designing and unmatchable features. This double ended bath will allow you to enjoy comfortable bath moments every time you use it. The manufacturing of this Bette bath is done with high-quality stainless steel that has made it extremely hygienic and long lasting. Heat can effortlessly pass through it so you will get a warm touch whenever you use this bath. It is fitted with anti-noise pad as standard. It is resistant to chemicals, scratches, and impact so you can clean it easily with any bath cleaner.</p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Spacious, body-contoured lying profile</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>Optimal use of the bathing area using extremely thin bath edges</li>\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n\n</ul>\n\n\n\n'),(17663,155,0,6481,'Exclude'),(17664,85,5,6482,'Bette Ocean Lowline Super Steel Bath 1800 x 800mm - Banyo'),(17665,85,0,6482,'Bette Ocean Lowline Super Steel Bath 1800 x 800mm - Banyo'),(17666,76,5,6482,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-lowline-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Lowline Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17667,76,0,6482,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-ocean-lowline-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Ocean Lowline Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17668,75,5,6482,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Lowline Super Steel Bath 1800 x 800</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Spacious, body-contoured lying profile</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>Optimal use of the bathing area using extremely thin bath edges</li>\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n\n</ul>\n\n\n\n\n\n'),(17669,75,0,6482,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Lowline Super Steel Bath 1800 x 800</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Shape : Rectangular</li>\n<li>Super steel bath</li>\n<li>Supplied with no tap hole</li>\n<li>Spacious, body-contoured lying profile</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Comes fitted with anti noise pad as standard</li>\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\n<li>Optimal use of the bathing area using extremely thin bath edges</li>\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\n\n</ul>\n\n\n\n\n\n'),(17670,155,0,6482,'Exclude'),(17671,85,5,6483,'Bette Art Steel Oval Bath 1800 × 750mm No Tap Hole - 3480 CFXXK '),(17672,85,0,6483,'Bette Art Steel Oval Bath 1800 × 750mm No Tap Hole - 3480 CFXXK '),(17673,76,5,6483,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17674,76,0,6483,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17675,75,5,6483,'<p><span style=\"font-size: medium;\"><strong>Bette Art Steel Oval Bath 1800 x 750mm No Tap Hole - 3480 CFXXK </strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Dimension : 1800 x 750 x 420mm [Length x Width x Depth]</li>\n<li>Volume : 248Litres</li>\n<li>Double ended bath</li>\n<li>Steel freestanding bath</li>\n<li>Supplied with no tap hole</li>\n<li>Tapholes, Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n</ul>'),(17676,75,0,6483,'<p><span style=\"font-size: medium;\"><strong>Bette Art Steel Oval Bath 1800 x 750mm No Tap Hole - 3480 CFXXK </strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Dimension : 1800 x 750 x 420mm [Length x Width x Depth]</li>\n<li>Volume : 248Litres</li>\n<li>Double ended bath</li>\n<li>Steel freestanding bath</li>\n<li>Supplied with no tap hole</li>\n<li>Tapholes, Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n</ul>'),(17677,155,0,6483,'Exclude'),(17678,85,5,6484,'Bette Duo Super Steel Rectangular Bath 1800 x 800mm - 3820'),(17679,85,0,6484,'Bette Duo Super Steel Rectangular Bath 1800 x 800mm - 3820'),(17680,76,5,6484,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17681,76,0,6484,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17682,75,5,6484,'<p><span style=\"font-size: medium;\"><strong>Bette Duo Super Steel Rectangular Bath 1800 x 800mm - 3820</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p><ul><li>Dimension : 1800 x 800 x 420 mm [Length x Width x Depth]</li><li>Volume: 143 litre</li><li>Double ended bath</li><li>Shape: Rectangular</li><li>Centrally-positioned drain</li><li>Fitted with anti noise pad as standard</li><li>Armrests in the bath provide additional comfort</li><li>Tapholes, Legset, Antislip, Bette GLAZE Plus [Optional]</li><li>Strong and highly durable than other normal baths</li><li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust<br/></li></ul>\r\n'),(17683,75,0,6484,'<p><span style=\"font-size: medium;\"><strong>Bette Duo Super Steel Rectangular Bath 1800 x 800mm - 3820</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p><ul><li>Dimension : 1800 x 800 x 420 mm [Length x Width x Depth]</li><li>Volume: 143 litre</li><li>Double ended bath</li><li>Shape: Rectangular</li><li>Centrally-positioned drain</li><li>Fitted with anti noise pad as standard</li><li>Armrests in the bath provide additional comfort</li><li>Tapholes, Legset, Antislip, Bette GLAZE Plus [Optional]</li><li>Strong and highly durable than other normal baths</li><li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust<br/></li></ul>\r\n'),(17684,155,0,6484,'Exclude'),(17685,85,5,6485,'RAK Cloud Freestanding Bath 1400 x 753mm'),(17686,85,0,6485,'RAK Cloud Freestanding Bath 1400 x 753mm'),(17687,76,5,6485,'<p><strong>For other options please click below</strong></p>\r\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \r\n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(17688,76,0,6485,'<p><strong>For other options please click below</strong></p>\r\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \r\n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(17689,75,5,6485,'<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Bath type: Freestanding</li>\r\n<li>Bath shape: Oval</li>\r\n<li>Bath configuration: Double Ended</li>\r\n<li>Bath length: 1400mm</li>\r\n<li>Bath width: 753mm</li>\r\n<li>Bath height: 560mm</li>\r\n<li>Bath internal length top: 1376mm</li>\r\n<li>Bath internal width top: 700mm</li>\r\n<li>Bath internal depth: 419.5mm</li>\r\n<li>Bath thickness: 3mm</li>\r\n<li>Waste position: Centre</li>\r\n<li>Material: Lucite Acrylic</li>\r\n<li>Weight: 125 Kg</li>\r\n<li>Style: Modern</li>\r\n</ul>'),(17690,75,0,6485,'<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Bath type: Freestanding</li>\r\n<li>Bath shape: Oval</li>\r\n<li>Bath configuration: Double Ended</li>\r\n<li>Bath length: 1400mm</li>\r\n<li>Bath width: 753mm</li>\r\n<li>Bath height: 560mm</li>\r\n<li>Bath internal length top: 1376mm</li>\r\n<li>Bath internal width top: 700mm</li>\r\n<li>Bath internal depth: 419.5mm</li>\r\n<li>Bath thickness: 3mm</li>\r\n<li>Waste position: Centre</li>\r\n<li>Material: Lucite Acrylic</li>\r\n<li>Weight: 125 Kg</li>\r\n<li>Style: Modern</li>\r\n</ul>'),(17691,155,0,6485,'Exclude'),(17692,85,5,6486,'RAK Evolution Double Ended Rectangular Bath 1750 x 750mm'),(17693,85,0,6486,'RAK Evolution Double Ended Rectangular Bath 1750 x 750mm'),(17694,76,5,6486,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(17695,76,0,6486,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(17696,75,5,6486,'<p><span style=\"font-size: medium;\"><strong>RAK Evolution Double Ended Rectangular Bath 1750 x 750mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Bath type: Standard</li>\n<li>Bath shape: Rectangular</li>\n<li>Bath configuration: Double ended</li>\n<li>Bath thickness: 5mm</li>\n<li>Capacity: 250 liters</li>\n<li>Weight: 17 kg</li>\n<li>Handed: Reversible</li>\n<li>Waste position: Centre</li>\n<li>Outlet connection size: 52mm</li>\n<li>Colour: White</li>\n</ul>\n'),(17697,75,0,6486,'<p><span style=\"font-size: medium;\"><strong>RAK Evolution Double Ended Rectangular Bath 1750 x 750mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Bath type: Standard</li>\n<li>Bath shape: Rectangular</li>\n<li>Bath configuration: Double ended</li>\n<li>Bath thickness: 5mm</li>\n<li>Capacity: 250 liters</li>\n<li>Weight: 17 kg</li>\n<li>Handed: Reversible</li>\n<li>Waste position: Centre</li>\n<li>Outlet connection size: 52mm</li>\n<li>Colour: White</li>\n</ul>\n'),(17698,155,0,6486,'Exclude'),(17699,85,5,6487,'RAK Karla Single Ended Rectangular Bath 1700 x 700mm'),(17700,85,0,6487,'RAK Karla Single Ended Rectangular Bath 1700 x 700mm'),(17701,76,5,6487,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(17702,76,0,6487,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(17703,75,5,6487,'<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Bath type: Standard</li>\r\n<li>Bath shape: Rectangular</li>\r\n<li>Bath configuration: Single ended</li>\r\n<li>Bath thickness: 5mm</li>\r\n<li>Weight: 19.24 kg</li>\r\n<li>Waste position: End</li>\r\n<li>Material: Acrylic</li>\r\n<li>Style: Modern</li>\r\n</ul>\r\n'),(17704,75,0,6487,'<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Bath type: Standard</li>\r\n<li>Bath shape: Rectangular</li>\r\n<li>Bath configuration: Single ended</li>\r\n<li>Bath thickness: 5mm</li>\r\n<li>Weight: 19.24 kg</li>\r\n<li>Waste position: End</li>\r\n<li>Material: Acrylic</li>\r\n<li>Style: Modern</li>\r\n</ul>\r\n'),(17705,155,0,6487,'Exclude'),(17706,85,5,6488,'RAK Reserva Single Ended Rectangular Bath 1700 x 800mm'),(17707,85,0,6488,'RAK Reserva Single Ended Rectangular Bath 1700 x 800mm'),(17708,76,5,6488,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(17709,76,0,6488,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(17710,75,5,6488,'<p><span style=\"font-size: medium;\"><strong>RAK Reserva Single Ended Rectangular Bath 1700 x 800mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Bath type: Standard</li>\n<li>Bath shape: Rectangular</li>\n<li>Bath configuration: Single ended</li>\n<li>Bath thickness: 5mm</li>\n<li>Weight: 17 kg</li>\n<li>Waste position: End</li>\n<li>Material: Acrylic</li>\n</ul>\n'),(17711,75,0,6488,'<p><span style=\"font-size: medium;\"><strong>RAK Reserva Single Ended Rectangular Bath 1700 x 800mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Bath type: Standard</li>\n<li>Bath shape: Rectangular</li>\n<li>Bath configuration: Single ended</li>\n<li>Bath thickness: 5mm</li>\n<li>Weight: 17 kg</li>\n<li>Waste position: End</li>\n<li>Material: Acrylic</li>\n</ul>\n'),(17712,155,0,6488,'Exclude'),(17713,85,5,6489,'RAK Washington Single Ended Bath with Leg Set 1700 x 700mm'),(17714,85,0,6489,'RAK Washington Single Ended Bath with Leg Set 1700 x 700mm'),(17715,76,5,6489,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(17716,76,0,6489,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(17717,75,5,6489,'<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Bath type: Standard</li>\r\n<li>Bath shape: Rectangular</li>\r\n<li>Bath configuration: Single ended</li>\r\n<li>Bath thickness: 4mm</li>\r\n<li>Capacity: 178 litres</li>\r\n<li>Bath tap holes: 0</li>\r\n<li>Waste position: End</li>\r\n<li>Outlet connection size: 52mm</li>\r\n<li>Material: Lucite acrylic</li>\r\n<li>Weight: 21.20 kg</li>\r\n</ul>'),(17718,75,0,6489,'<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Bath type: Standard</li>\r\n<li>Bath shape: Rectangular</li>\r\n<li>Bath configuration: Single ended</li>\r\n<li>Bath thickness: 4mm</li>\r\n<li>Capacity: 178 litres</li>\r\n<li>Bath tap holes: 0</li>\r\n<li>Waste position: End</li>\r\n<li>Outlet connection size: 52mm</li>\r\n<li>Material: Lucite acrylic</li>\r\n<li>Weight: 21.20 kg</li>\r\n</ul>'),(17719,155,0,6489,'Exclude'),(17720,85,5,6490,'RAK Washington Single Ended Bath with Leg Set 1700 x 750mm'),(17721,85,0,6490,'RAK Washington Single Ended Bath with Leg Set 1700 x 750mm'),(17722,76,5,6490,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(17723,76,0,6490,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(17724,75,5,6490,'<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Bath type: Standard</li>\r\n<li>Bath shape: Rectangular</li>\r\n<li>Bath configuration: Single ended</li>\r\n<li>Bath thickness: 4mm</li>\r\n<li>Capacity: 193 litres</li>\r\n<li>Waste position: End</li>\r\n<li>Outlet connection size: 52mm</li>\r\n<li>Material: Lucite acrylic</li>\r\n<li>Colour: White</li>\r\n</ul>\n'),(17725,75,0,6490,'<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Bath type: Standard</li>\r\n<li>Bath shape: Rectangular</li>\r\n<li>Bath configuration: Single ended</li>\r\n<li>Bath thickness: 4mm</li>\r\n<li>Capacity: 193 litres</li>\r\n<li>Waste position: End</li>\r\n<li>Outlet connection size: 52mm</li>\r\n<li>Material: Lucite acrylic</li>\r\n<li>Colour: White</li>\r\n</ul>\n'),(17726,155,0,6490,'Exclude'),(17727,85,5,6491,'RAK Washington Freestanding Bath 1560 x 810mm'),(17728,85,0,6491,'RAK Washington Freestanding Bath 1560 x 810mm'),(17729,76,5,6491,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(17730,76,0,6491,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/rak-ceramics/baths.html\"><strong>Rak Baths</strong></a> / \n<a href=\"/brands/rak-ceramics.html\"><strong>Rak All Products</strong></a>'),(17731,75,5,6491,'<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Bath type: Freestanding</li>\r\n<li>Bath shape: Oval</li>\r\n<li>Bath configuration: Double ended</li>\r\n<li>Waste position: Centre</li>\r\n<li>Material: Mineral resin</li>\r\n<li>Weight: 91 kg</li>\r\n</ul>\r'),(17732,75,0,6491,'<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Bath type: Freestanding</li>\r\n<li>Bath shape: Oval</li>\r\n<li>Bath configuration: Double ended</li>\r\n<li>Waste position: Centre</li>\r\n<li>Material: Mineral resin</li>\r\n<li>Weight: 91 kg</li>\r\n</ul>\r'),(17733,155,0,6491,'Exclude'),(17734,75,5,6492,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Grace Freestanding Round Bath 1510 x 760mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>This freestanding round bath provides a luxury focal point in your bathroom</li>\r\n<li>Suitable for use with freestanding bath fillers only</li>\r\n<li>Beautifully curved shape and luxuriously spacious bathing area</li>\r\n<li>The non-porous cian solid surface guarantees superior stain resistance as well as microbial resistance</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Cian solid surface</li>\r\n<li>Bath material finish: White</li>\r\n<li>Includes waste: Waste included</li>\r\n<li>Volume (Literage): 150</li>\r\n<li>Displaced capacity (L): 80</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Freestanding</li>\r\n<li>Bath waste position: Central</li>\r\n<li>Material thickness: 16mm</li>\r\n</ul>\r\n'),(17735,75,0,6492,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Grace Freestanding Round Bath 1510 x 760mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>This freestanding round bath provides a luxury focal point in your bathroom</li>\r\n<li>Suitable for use with freestanding bath fillers only</li>\r\n<li>Beautifully curved shape and luxuriously spacious bathing area</li>\r\n<li>The non-porous cian solid surface guarantees superior stain resistance as well as microbial resistance</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Cian solid surface</li>\r\n<li>Bath material finish: White</li>\r\n<li>Includes waste: Waste included</li>\r\n<li>Volume (Literage): 150</li>\r\n<li>Displaced capacity (L): 80</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Freestanding</li>\r\n<li>Bath waste position: Central</li>\r\n<li>Material thickness: 16mm</li>\r\n</ul>\r\n'),(17736,155,0,6492,'Exclude'),(17737,75,5,6493,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Rose Freestanding Bath 1510 x 760mm </strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>This freestanding oval bath provides a striking focal point in your bathroom</li>\r\n<li>Suitable for use with freestanding bath fillers only</li>\r\n<li>The non-porous cian solid surface guarantees superior stain resistance as well as microbial resistance</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Cian solid surface</li>\r\n<li>Bath material finish: White</li>\r\n<li>Includes waste: Waste included</li>\r\n<li>Volume (Literage): 160</li>\r\n<li>Displaced capacity (L): 90</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Freestanding</li>\r\n<li>Bath waste position: Central</li>\r\n<li>Material thickness: 16mm</li>\r\n</ul>\r\n'),(17738,75,0,6493,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Rose Freestanding Bath 1510 x 760mm </strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>This freestanding oval bath provides a striking focal point in your bathroom</li>\r\n<li>Suitable for use with freestanding bath fillers only</li>\r\n<li>The non-porous cian solid surface guarantees superior stain resistance as well as microbial resistance</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Cian solid surface</li>\r\n<li>Bath material finish: White</li>\r\n<li>Includes waste: Waste included</li>\r\n<li>Volume (Literage): 160</li>\r\n<li>Displaced capacity (L): 90</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Freestanding</li>\r\n<li>Bath waste position: Central</li>\r\n<li>Material thickness: 16mm</li>\r\n</ul>\r\n'),(17739,155,0,6493,'Exclude'),(17740,75,5,6494,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Bella Freestanding Bath 1495 x 720mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>This freestanding soft square bath provides a luxury focal point in your bathroom</li>\r\n<li>Suitable for use with freestanding bath fillers only</li>\r\n<li>Beautifully curved shape and luxuriously spacious bathing area</li>\r\n<li>The non-porous cian solid surface guarantees superior stain resistance as well as microbial resistance</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Cian solid surface</li>\r\n<li>Bath material finish: White</li>\r\n<li>Includes waste: Waste included</li>\r\n<li>Volume (Literage): 175</li>\r\n<li>Displaced capacity (L): 105</li>\r\n<li>Bath shape: Square</li>\r\n<li>Bath style: Freestanding</li>\r\n<li>Bath waste position: Central</li>\r\n<li>Material thickness: 16mm</li>\r\n</ul>\r\n'),(17741,75,0,6494,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Bella Freestanding Bath 1495 x 720mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>This freestanding soft square bath provides a luxury focal point in your bathroom</li>\r\n<li>Suitable for use with freestanding bath fillers only</li>\r\n<li>Beautifully curved shape and luxuriously spacious bathing area</li>\r\n<li>The non-porous cian solid surface guarantees superior stain resistance as well as microbial resistance</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Cian solid surface</li>\r\n<li>Bath material finish: White</li>\r\n<li>Includes waste: Waste included</li>\r\n<li>Volume (Literage): 175</li>\r\n<li>Displaced capacity (L): 105</li>\r\n<li>Bath shape: Square</li>\r\n<li>Bath style: Freestanding</li>\r\n<li>Bath waste position: Central</li>\r\n<li>Material thickness: 16mm</li>\r\n</ul>\r\n'),(17742,155,0,6494,'Exclude'),(17743,75,5,6495,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Farringdon Freestanding Bath 1555 X 740mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>This freestanding double ended bath provides a luxury focal point within your bathroom.</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>Suitable for use with freestanding bath fillers only</li>\r\n<li>The non-porous cian solid surface guarantees superior stain resistance as well as microbial resistance</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Cian solid surface</li>\r\n<li>Bath material finish: White</li>\r\n<li>Includes waste: Waste included</li>\r\n<li>Volume (Literage): 175</li>\r\n<li>Displaced capacity (L): 105</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Freestanding</li>\r\n<li>Bath waste position: Central</li>\r\n<li>Material thickness: 24mm</li>\r\n</ul>\r\n'),(17744,75,0,6495,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Farringdon Freestanding Bath 1555 X 740mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>This freestanding double ended bath provides a luxury focal point within your bathroom.</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>Suitable for use with freestanding bath fillers only</li>\r\n<li>The non-porous cian solid surface guarantees superior stain resistance as well as microbial resistance</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Cian solid surface</li>\r\n<li>Bath material finish: White</li>\r\n<li>Includes waste: Waste included</li>\r\n<li>Volume (Literage): 175</li>\r\n<li>Displaced capacity (L): 105</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Freestanding</li>\r\n<li>Bath waste position: Central</li>\r\n<li>Material thickness: 24mm</li>\r\n</ul>\r\n'),(17745,155,0,6495,'Exclude'),(17746,75,5,6496,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Ascott Art Deco Bath - 1700 X 700mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>Choose from our range of bath panels to create the perfect look</li>\r\n<li>This classic style bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 178L</li>\r\n<li>Displaced capacity (L): 108L</li>\r\n<li>Bath shape: Square</li>\r\n<li>Bath style: Single Ended</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>Material thickness: 4mm</li>\r\n</ul>\r\n'),(17747,75,0,6496,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Ascott Art Deco Bath - 1700 X 700mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>Choose from our range of bath panels to create the perfect look</li>\r\n<li>This classic style bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 178L</li>\r\n<li>Displaced capacity (L): 108L</li>\r\n<li>Bath shape: Square</li>\r\n<li>Bath style: Single Ended</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>Material thickness: 4mm</li>\r\n</ul>\r\n'),(17748,155,0,6496,'Exclude'),(17749,75,5,6497,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Ascott Art Deco Bath - 1700 X 750mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>Choose from our range of bath panels to create the perfect look</li>\r\n<li>This classic style bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 193L</li>\r\n<li>Displaced capacity (L): 123L</li>\r\n<li>Bath shape: Square</li>\r\n<li>Bath style: Single Ended</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>Material thickness: 4mm</li>\r\n</ul>\r\n'),(17750,75,0,6497,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Ascott Art Deco Bath - 1700 X 750mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>Choose from our range of bath panels to create the perfect look</li>\r\n<li>This classic style bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 193L</li>\r\n<li>Displaced capacity (L): 123L</li>\r\n<li>Bath shape: Square</li>\r\n<li>Bath style: Single Ended</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>Material thickness: 4mm</li>\r\n</ul>\r\n'),(17751,155,0,6497,'Exclude'),(17752,75,5,6498,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Ascott Art Deco Bath - 1800 X 800mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>Choose from our range of bath panels to create the perfect look</li>\r\n<li>This classic style bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 215L</li>\r\n<li>Displaced capacity (L): 145L</li>\r\n<li>Bath shape: Square</li>\r\n<li>Bath style: Double Ended</li>\r\n<li>Bath waste position: Central</li>\r\n<li>Material thickness: 4mm</li>\r\n</ul>\r\n'),(17753,75,0,6498,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Ascott Art Deco Bath - 1800 X 800mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>Choose from our range of bath panels to create the perfect look</li>\r\n<li>This classic style bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 215L</li>\r\n<li>Displaced capacity (L): 145L</li>\r\n<li>Bath shape: Square</li>\r\n<li>Bath style: Double Ended</li>\r\n<li>Bath waste position: Central</li>\r\n<li>Material thickness: 4mm</li>\r\n</ul>\r\n'),(17754,155,0,6498,'Exclude'),(17755,75,5,6499,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Kenton Freestanding Bath 1700 x 750mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>All baths come supplied with leg sets as standard</li>\r\n<li>Choice of ornate chrome legs available</li>\r\n<li>Tap and standpipes not included</li>\r\n<li>This freestanding bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 228L</li>\r\n<li>Displaced capacity (L): 158L</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Freestanding</li>\r\n<li>Bath waste position: Central</li>\r\n<li>Material thickness: 14mm</li>\r\n</ul>'),(17756,75,0,6499,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Kenton Freestanding Bath 1700 x 750mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>All baths come supplied with leg sets as standard</li>\r\n<li>Choice of ornate chrome legs available</li>\r\n<li>Tap and standpipes not included</li>\r\n<li>This freestanding bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 228L</li>\r\n<li>Displaced capacity (L): 158L</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Freestanding</li>\r\n<li>Bath waste position: Central</li>\r\n<li>Material thickness: 14mm</li>\r\n</ul>'),(17757,155,0,6499,'Exclude'),(17758,75,5,6500,'<style>#html-body [data-pb-style=WPQ1AH6]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"WPQ1AH6\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Hudson Reed Brockley Freestanding Bath 1500 x 750mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\">We provide a stunning range of 1500 roll top baths. Available in many sizes and finishes.</span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>All baths come supplied with leg sets as standard</li>\r\n<li>Choice of ornate chrome legs available</li>\r\n<li>Tap and standpipes not included</li>\r\n<li>This freestanding bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 155L</li>\r\n<li>Displaced capacity (L): 85L</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Single ended</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>Material thickness: 14mm</li>\r\n</ul></div></div></div>'),(17759,75,0,6500,'<style>#html-body [data-pb-style=WPQ1AH6]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"WPQ1AH6\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Hudson Reed Brockley Freestanding Bath 1500 x 750mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\">We provide a stunning range of 1500 roll top baths. Available in many sizes and finishes.</span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>All baths come supplied with leg sets as standard</li>\r\n<li>Choice of ornate chrome legs available</li>\r\n<li>Tap and standpipes not included</li>\r\n<li>This freestanding bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 155L</li>\r\n<li>Displaced capacity (L): 85L</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Single ended</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>Material thickness: 14mm</li>\r\n</ul></div></div></div>'),(17760,155,0,6500,'Exclude'),(17761,75,5,6501,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Kingsbury Freestanding Bath 1500 x 750mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>All baths come supplied with leg sets as standard</li>\r\n<li>Choice of ornate chrome legs available</li>\r\n<li>Tap and standpipes not included</li>\r\n<li>This freestanding bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 185L</li>\r\n<li>Displaced capacity (L): 115L</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Double ended</li>\r\n<li>Bath waste position: Central</li>\r\n<li>Material thickness: 14mm</li>\r\n</ul>'),(17762,75,0,6501,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Kingsbury Freestanding Bath 1500 x 750mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>All baths come supplied with leg sets as standard</li>\r\n<li>Choice of ornate chrome legs available</li>\r\n<li>Tap and standpipes not included</li>\r\n<li>This freestanding bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 185L</li>\r\n<li>Displaced capacity (L): 115L</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Double ended</li>\r\n<li>Bath waste position: Central</li>\r\n<li>Material thickness: 14mm</li>\r\n</ul>'),(17763,155,0,6501,'Exclude'),(17764,75,5,6502,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Brockley Freestanding Bath 1700 x 750mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>All baths come supplied with leg sets as standard</li>\r\n<li>Choice of ornate chrome legs available</li>\r\n<li>Tap and standpipes not included</li>\r\n<li>This freestanding bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 197L</li>\r\n<li>Displaced capacity (L): 125L</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Single ended</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>Material thickness: 14mm</li>\r\n</ul>'),(17765,75,0,6502,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Brockley Freestanding Bath 1700 x 750mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>All baths come supplied with leg sets as standard</li>\r\n<li>Choice of ornate chrome legs available</li>\r\n<li>Tap and standpipes not included</li>\r\n<li>This freestanding bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 197L</li>\r\n<li>Displaced capacity (L): 125L</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Single ended</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>Material thickness: 14mm</li>\r\n</ul>'),(17766,155,0,6502,'Exclude'),(17767,75,5,6503,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Kingsbury Freestanding Bath 1700 x 750mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>All baths come supplied with leg sets as standard</li>\r\n<li>Choice of ornate chrome legs available</li>\r\n<li>Tap and standpipes not included</li>\r\n<li>This freestanding bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 200L</li>\r\n<li>Displaced capacity (L): 130L</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Freestanding</li>\r\n<li>Bath waste position: Central</li>\r\n<li>Material thickness: 14mm</li>\r\n</ul>'),(17768,75,0,6503,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Kingsbury Freestanding Bath 1700 x 750mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>All baths come supplied with leg sets as standard</li>\r\n<li>Choice of ornate chrome legs available</li>\r\n<li>Tap and standpipes not included</li>\r\n<li>This freestanding bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 200L</li>\r\n<li>Displaced capacity (L): 130L</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Freestanding</li>\r\n<li>Bath waste position: Central</li>\r\n<li>Material thickness: 14mm</li>\r\n</ul>'),(17769,155,0,6503,'Exclude'),(17770,75,5,6504,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Barnsbury Freestanding Bath 1700 x 750mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>All baths come supplied with leg sets as standard</li>\r\n<li>Choice of ornate chrome legs available</li>\r\n<li>Tap and standpipes not included</li>\r\n<li>This freestanding bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 200L</li>\r\n<li>Displaced capacity (L): 130L</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Single ended</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>Material thickness: 14mm</li>\r\n</ul>'),(17771,75,0,6504,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Barnsbury Freestanding Bath 1700 x 750mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Undrilled For Taps</li>\r\n<li>Designed and built to the highest quality</li>\r\n<li>All baths come supplied with leg sets as standard</li>\r\n<li>Choice of ornate chrome legs available</li>\r\n<li>Tap and standpipes not included</li>\r\n<li>This freestanding bath adds a timeless focal point to any traditional bathroom</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 200L</li>\r\n<li>Displaced capacity (L): 130L</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Single ended</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>Material thickness: 14mm</li>\r\n</ul>'),(17772,155,0,6504,'Exclude'),(17773,75,5,6505,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Winterburn Freestanding Shower Bath 1500 x 750mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>This classically styled shower bath adds a timeless focal point to any traditional bathroom</li>\r\n<li>Designed and built from the highest quality Acrylic</li>\r\n<li>All baths come supplied with leg sets as standard</li>\r\n<li>Choice of ornate chrome legs available</li>\r\n<li>Supplied un-drilled, tap sold separately</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 175</li>\r\n<li>Displaced capacity (L): 105</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Freestanding</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>Material thickness: 12mm</li>\r\n</ul>'),(17774,75,0,6505,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Winterburn Freestanding Shower Bath 1500 x 750mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>This classically styled shower bath adds a timeless focal point to any traditional bathroom</li>\r\n<li>Designed and built from the highest quality Acrylic</li>\r\n<li>All baths come supplied with leg sets as standard</li>\r\n<li>Choice of ornate chrome legs available</li>\r\n<li>Supplied un-drilled, tap sold separately</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 175</li>\r\n<li>Displaced capacity (L): 105</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Freestanding</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>Material thickness: 12mm</li>\r\n</ul>'),(17775,155,0,6505,'Exclude'),(17776,75,5,6506,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Winterburn Freestanding Shower Bath 1700 x 750mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>This classically styled shower bath adds a timeless focal point to any traditional bathroom</li>\r\n<li>Designed and built from the highest quality Acrylic</li>\r\n<li>All baths come supplied with leg sets as standard</li>\r\n<li>Choice of ornate chrome legs available</li>\r\n<li>Supplied un-drilled, tap sold separately</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 210</li>\r\n<li>Displaced capacity (L): 170</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Freestanding</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>Material thickness: 12mm</li>\r\n</ul>'),(17777,75,0,6506,'<p><span style=\"font-size: medium;\"><strong>Hudson Reed Winterburn Freestanding Shower Bath 1700 x 750mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>This classically styled shower bath adds a timeless focal point to any traditional bathroom</li>\r\n<li>Designed and built from the highest quality Acrylic</li>\r\n<li>All baths come supplied with leg sets as standard</li>\r\n<li>Choice of ornate chrome legs available</li>\r\n<li>Supplied un-drilled, tap sold separately</li>\r\n</ul>\r\n<p><span style=\"font-size: medium;\"><strong>Specification</strong></span></p>\r\n<ul>\r\n<li>Bath material: Acrylic</li>\r\n<li>Bath material Finish: White</li>\r\n<li>Includes waste: Waste not included</li>\r\n<li>Volume (Literage): 210</li>\r\n<li>Displaced capacity (L): 170</li>\r\n<li>Bath shape: Round</li>\r\n<li>Bath style: Freestanding</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>Material thickness: 12mm</li>\r\n</ul>'),(17778,155,0,6506,'Exclude'),(17779,76,5,6507,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-comodo-super-steel-bath-with-side-overflow.html\">&gt;&nbsp;&nbsp;View all Bette Comodo Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17780,76,0,6507,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-comodo-super-steel-bath-with-side-overflow.html\">&gt;&nbsp;&nbsp;View all Bette Comodo Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17781,75,5,6507,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo 1900 x 900mm Steel Single Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Colour : White</li>\r\n<li>Made using 2mm steel</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Extremely narrow rim only 20mm high</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\r\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\r\n</ul>'),(17782,75,0,6507,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo 1900 x 900mm Steel Single Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Colour : White</li>\r\n<li>Made using 2mm steel</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Extremely narrow rim only 20mm high</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\r\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\r\n</ul>'),(17783,155,0,6507,'Exclude'),(17784,85,5,6508,'Bette Select Bath With Overflow Foot End'),(17785,85,0,6508,'Bette Select Bath With Overflow Foot End'),(17786,76,5,6508,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17787,76,0,6508,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17788,75,5,6508,'<p><span style=\"font-size: medium;\"><strong>Bette Select Bath With Overflow Foot End</strong></span></p>\r\n<p>Bette select bath with overflow foot end is available in four different sizes of 1600 x 700mm, 1700 x 700mm, 1700 x 750mm andÂ Bette select bath 1800 x 800mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Spacious standing area, with outlet to the center</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17789,75,0,6508,'<p><span style=\"font-size: medium;\"><strong>Bette Select Bath With Overflow Foot End</strong></span></p>\r\n<p>Bette select bath with overflow foot end is available in four different sizes of 1600 x 700mm, 1700 x 700mm, 1700 x 750mm andÂ Bette select bath 1800 x 800mm.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Super steel bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Spacious standing area, with outlet to the center</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17790,155,0,6508,'Exclude'),(17791,85,5,6509,'Bette Form Normal Steel Bath 1400 x 700mm  - Banyo'),(17792,85,0,6509,'Bette Form Normal Steel Bath 1400 x 700mm  - Banyo'),(17793,76,5,6509,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17794,76,0,6509,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17795,75,5,6509,'<p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Single Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single Ended bath</li>\r\n<li>Super Steel bath</li>\r\n<li>Strong and durable material</li>\r\n<li>Non-fading stable colour</li>\r\n<li>Finest quality of 1.6mm gauge steel</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Resistance against fluids and scouring agents</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n</ul>\r\n'),(17796,75,0,6509,'<p><span style=\"font-size: medium;\"><strong>Bette Form Super Steel Single Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single Ended bath</li>\r\n<li>Super Steel bath</li>\r\n<li>Strong and durable material</li>\r\n<li>Non-fading stable colour</li>\r\n<li>Finest quality of 1.6mm gauge steel</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Resistance against fluids and scouring agents</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n</ul>\r\n'),(17797,155,0,6509,'Exclude'),(17798,85,5,6510,'Bette Labette Super Steel Bath 108 x 73cm No Tap Hole - BE1080-000'),(17799,85,0,6510,'Bette Labette Super Steel Bath 108 x 73cm No Tap Hole - BE1080-000'),(17800,76,5,6510,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17801,76,0,6510,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17802,75,5,6510,'<p><span style=\"font-size: medium;\"><strong>Bette Labette Super Steel Single Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Comfortable hip-bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17803,75,0,6510,'<p><span style=\"font-size: medium;\"><strong>Bette Labette Super Steel Single Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Comfortable hip-bath</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17804,155,0,6510,'Exclude'),(17805,85,5,6511,'Bette Ocean Super Steel Single Ended Bath'),(17806,85,0,6511,'Bette Ocean Super Steel Single Ended Bath'),(17807,76,5,6511,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17808,76,0,6511,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17809,75,5,6511,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Steel Single Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Super steel bath</li>\r\n<li>Spacious, body-contoured lying profile</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Tap hole option is only available in one size - 1700 x 700mm</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>The 45cm bath depth also enables larger people to completely submerge and relax</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and sodad</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17810,75,0,6511,'<p><span style=\"font-size: medium;\"><strong>Bette Ocean Steel Single Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Super steel bath</li>\r\n<li>Spacious, body-contoured lying profile</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Tap hole option is only available in one size - 1700 x 700mm</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>The 45cm bath depth also enables larger people to completely submerge and relax</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and sodad</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17811,155,0,6511,'Exclude'),(17812,85,5,6512,'Bette Set Super Steel Single Ended Bath'),(17813,85,0,6512,'Bette Set Super Steel Single Ended Bath'),(17814,76,5,6512,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17815,76,0,6512,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17816,75,5,6512,'<p><span style=\"font-size: medium;\"><strong>Bette Set Super Steel Single Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17817,75,0,6512,'<p><span style=\"font-size: medium;\"><strong>Bette Set Super Steel Single Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Space-saving bath for small bathrooms</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>The shallow tub depth enables comfortable entrance and a water-saving bath</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17818,155,0,6512,'Exclude'),(17819,85,5,6513,'Bette Starlet Super Steel Double Ended Bath'),(17820,85,0,6513,'Bette Starlet Super Steel Double Ended Bath'),(17821,76,5,6513,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17822,76,0,6513,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17823,75,5,6513,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Double Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17824,75,0,6513,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Double Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Tapholes,Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17825,155,0,6513,'Exclude'),(17826,76,5,6514,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-one-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette One Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17827,76,0,6514,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-one-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette One Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17828,75,5,6514,'<p><span style=\"font-size: medium;\"><strong>Bette One Super Steel Double Ended 1600 x 700mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Super steel bath</li>\r\n<li>Double ended bath</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Duo bath with a central outlet and a generous inside body</li>\r\n</ul>\r\n\r\n'),(17829,75,0,6514,'<p><span style=\"font-size: medium;\"><strong>Bette One Super Steel Double Ended 1600 x 700mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Super steel bath</li>\r\n<li>Double ended bath</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Duo bath with a central outlet and a generous inside body</li>\r\n</ul>\r\n\r\n'),(17830,155,0,6514,'Exclude'),(17831,76,5,6515,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-one-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette One Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17832,76,0,6515,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-one-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette One Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17833,75,5,6515,'<p><span style=\"font-size: medium;\"><strong>Bette One Super Steel Double Ended 1700 x 700mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Super steel bath</li>\r\n<li>Double ended bath</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Duo bath with a central outlet and a generous inside body</li>\r\n</ul>\r\n'),(17834,75,0,6515,'<p><span style=\"font-size: medium;\"><strong>Bette One Super Steel Double Ended 1700 x 700mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Super steel bath</li>\r\n<li>Double ended bath</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Duo bath with a central outlet and a generous inside body</li>\r\n</ul>\r\n'),(17835,155,0,6515,'Exclude'),(17836,76,5,6516,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-one-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette One Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17837,76,0,6516,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-one-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette One Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17838,75,5,6516,'<p><span style=\"font-size: medium;\"><strong>Bette One Super Steel Double Ended 1700 x 750mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Super steel bath</li>\r\n<li>Double ended bath</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Duo bath with a central outlet and a generous inside body</li>\r\n</ul>\r\n'),(17839,75,0,6516,'<p><span style=\"font-size: medium;\"><strong>Bette One Super Steel Double Ended 1700 x 750mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Super steel bath</li>\r\n<li>Double ended bath</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Duo bath with a central outlet and a generous inside body</li>\r\n</ul>\r\n'),(17840,155,0,6516,'Exclude'),(17841,76,5,6517,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-one-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette One Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17842,76,0,6517,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-one-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette One Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17843,75,5,6517,'<p><span style=\"font-size: medium;\"><strong>Bette One Super Steel Double Ended 1800 x 800mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Super steel bath</li>\r\n<li>Double ended bath</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Duo bath with a central outlet and a generous inside body</li>\r\n</ul>\r\n'),(17844,75,0,6517,'<p><span style=\"font-size: medium;\"><strong>Bette One Super Steel Double Ended 1800 x 800mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Super steel bath</li>\r\n<li>Double ended bath</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Duo bath with a central outlet and a generous inside body</li>\r\n</ul>\r\n'),(17845,155,0,6517,'Exclude'),(17846,76,5,6518,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-one-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette One Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17847,76,0,6518,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-one-super-steel-double-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette One Super Steel Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17848,75,5,6518,'<p><span style=\"font-size: medium;\"><strong>Bette One Super Steel Double Ended 1900 x 900mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Super steel bath</li>\r\n<li>Double ended bath</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Duo bath with a central outlet and a generous inside body</li>\r\n</ul>\r\n'),(17849,75,0,6518,'<p><span style=\"font-size: medium;\"><strong>Bette One Super Steel Double Ended 1900 x 900mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Super steel bath</li>\r\n<li>Double ended bath</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Duo bath with a central outlet and a generous inside body</li>\r\n</ul>\r\n'),(17850,155,0,6518,'Exclude'),(17851,76,5,6519,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-iv-silhouette-steel-double-ended-bath.html\">&gt;&nbsp; View all Bette Starlet IV Silhouette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17852,76,0,6519,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-iv-silhouette-steel-double-ended-bath.html\">&gt;&nbsp; View all Bette Starlet IV Silhouette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17853,75,5,6519,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet IV Silhouette Steel Bath 185 x 85cm No tap Hole - BE6670-000CERVK </strong></span></p>\r\n<p>Your search for a functional as well as beautiful bath should stop at Bette Starlet IV Silhouette bath. The surface of this bath will look as shiny as at the time of purchasing even after the years of use. It is refined with a very unique BETTEGLAZE enamel finish that is made by using borax, quartz, water, soda, and glass so there is no doubt in its durability. Bring this incredible bath home for turning your ordinary bath into the most luxurious one. It is heat conducting so heat will pass through it effortlessly and taking bath in winters will not be a problem anymore. There is no pre-drilled tap hole and it is supplied with feet. It is scratch resistant so you can clean it within no time.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>For fitting in the corner</li>\r\n<li>Super steel bath</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Antislip, Bette GLAZE Plus [Optional]</li><li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n\r\n</ul>\r\n\r\n'),(17854,75,0,6519,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet IV Silhouette Steel Bath 185 x 85cm No tap Hole - BE6670-000CERVK </strong></span></p>\r\n<p>Your search for a functional as well as beautiful bath should stop at Bette Starlet IV Silhouette bath. The surface of this bath will look as shiny as at the time of purchasing even after the years of use. It is refined with a very unique BETTEGLAZE enamel finish that is made by using borax, quartz, water, soda, and glass so there is no doubt in its durability. Bring this incredible bath home for turning your ordinary bath into the most luxurious one. It is heat conducting so heat will pass through it effortlessly and taking bath in winters will not be a problem anymore. There is no pre-drilled tap hole and it is supplied with feet. It is scratch resistant so you can clean it within no time.</p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>For fitting in the corner</li>\r\n<li>Super steel bath</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Antislip, Bette GLAZE Plus [Optional]</li><li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n\r\n</ul>\r\n\r\n'),(17855,155,0,6519,'Exclude'),(17856,76,5,6520,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-v-silhouette-steel-double-ended-bath.html\">&gt;&nbsp; View all Bette Starlet V Silhouette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17857,76,0,6520,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-starlet-v-silhouette-steel-double-ended-bath.html\">&gt;&nbsp; View all Bette Starlet V Silhouette Baths</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17858,75,5,6520,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet V Silhouette Steel Bath 1950 x 950mm - No TH</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Super steel bath</li>\r\n<li>Double ended bath</li>\r\n<li>For fitting in the corner</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Bath with centrally-positioned drain</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17859,75,0,6520,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet V Silhouette Steel Bath 1950 x 950mm - No TH</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Super steel bath</li>\r\n<li>Double ended bath</li>\r\n<li>For fitting in the corner</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Bath with centrally-positioned drain</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17860,155,0,6520,'Exclude'),(17861,76,5,6521,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17862,76,0,6521,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17863,75,5,6521,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath with Side Overflow - 1700 x 750mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Made using 2mm steel</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Extremely narrow rim only 20mm high</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\r\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\r\n</ul>\r\n'),(17864,75,0,6521,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath with Side Overflow - 1700 x 750mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Made using 2mm steel</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Extremely narrow rim only 20mm high</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\r\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\r\n</ul>\r\n'),(17865,155,0,6521,'Exclude'),(17866,76,5,6522,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17867,76,0,6522,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17868,75,5,6522,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath with Side Overflow - 1700 x 800mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Made using 2mm steel</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Extremely narrow rim only 20mm high</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\r\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\r\n</ul>\r\n'),(17869,75,0,6522,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath with Side Overflow - 1700 x 800mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Made using 2mm steel</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Extremely narrow rim only 20mm high</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\r\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\r\n</ul>\r\n'),(17870,155,0,6522,'Exclude'),(17871,76,5,6523,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17872,76,0,6523,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17873,75,5,6523,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath with Side Overflow - 1800 x 800mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Made using 2mm steel</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Extremely narrow rim only 20mm high</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\r\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\r\n</ul>\r\n'),(17874,75,0,6523,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath with Side Overflow - 1800 x 800mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Made using 2mm steel</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Extremely narrow rim only 20mm high</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\r\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\r\n</ul>\r\n'),(17875,155,0,6523,'Exclude'),(17876,76,5,6524,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17877,76,0,6524,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17878,75,5,6524,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath with Side Overflow - 1900 x 900mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Made using 2mm steel</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Extremely narrow rim only 20mm high</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\r\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\r\n</ul>\r\n'),(17879,75,0,6524,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath with Side Overflow - 1900 x 900mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Made using 2mm steel</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Extremely narrow rim only 20mm high</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Foot end right, overflow front/Foot end right, overflow rear</li>\r\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\r\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\r\n</ul>\r\n'),(17880,155,0,6524,'Exclude'),(17881,76,5,6525,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17882,76,0,6525,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17883,75,5,6525,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 140 x 70cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17884,75,0,6525,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 140 x 70cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17885,155,0,6525,'Exclude'),(17886,76,5,6526,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17887,76,0,6526,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17888,75,5,6526,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 150 x 70cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17889,75,0,6526,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 150 x 70cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17890,155,0,6526,'Exclude'),(17891,76,5,6527,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17892,76,0,6527,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17893,75,5,6527,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 160 x 70cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17894,75,0,6527,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 160 x 70cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17895,155,0,6527,'Exclude'),(17896,76,5,6528,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17897,76,0,6528,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17898,75,5,6528,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 160 x 75cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17899,75,0,6528,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 160 x 75cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17900,155,0,6528,'Exclude'),(17901,76,5,6529,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17902,76,0,6529,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17903,75,5,6529,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 165 x 75cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17904,75,0,6529,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 165 x 75cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17905,155,0,6529,'Exclude'),(17906,76,5,6530,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17907,76,0,6530,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17908,75,5,6530,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 170 x 70cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17909,75,0,6530,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 170 x 70cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17910,155,0,6530,'Exclude'),(17911,76,5,6531,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17912,76,0,6531,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17913,75,5,6531,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 170 x 73cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17914,75,0,6531,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 170 x 73cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17915,155,0,6531,'Exclude'),(17916,76,5,6532,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17917,76,0,6532,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17918,75,5,6532,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 170 x 80cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17919,75,0,6532,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 170 x 80cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17920,155,0,6532,'Exclude'),(17921,76,5,6533,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17922,76,0,6533,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17923,75,5,6533,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 175 x 75cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17924,75,0,6533,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 175 x 75cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17925,155,0,6533,'Exclude'),(17926,76,5,6534,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17927,76,0,6534,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17928,75,5,6534,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 190 x 80cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17929,75,0,6534,'<p><span style=\"font-size: medium;\"><strong>Bette Classic Super Steel Bath 190 x 80cm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Material: Super steel </li>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Ergonomically-designed back support for relaxed bathing</li>\r\n<li>The 45cm bath depth enables larger people to completely submerge and relax</li>\r\n<li>Straight-line inner body harmonises perfectly with the outer rectangle</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17930,155,0,6534,'Exclude'),(17931,76,5,6535,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17932,76,0,6535,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-classic-super-steel-single-ended-bath.html\">&gt;&nbsp;&nbsp;View all Bette Classic Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17933,75,5,6535,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 1850 x 850mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17934,75,0,6535,'<p><span style=\"font-size: medium;\"><strong>Bette Starlet Super Steel Bath 1850 x 850mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Double ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Comes fitted with anti noise pad as standard</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li><li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17935,155,0,6535,'Exclude'),(17936,76,5,6536,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17937,76,0,6536,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17938,75,5,6536,'<p><span style=\"font-size: medium;\"><strong>Bette Select Super Steel Single Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Colour : White</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Tapholes, Legset, Antislip, BETTEGLAZE&reg; [Optional]</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust<br /><br /></li>\r\n</ul>\r\n'),(17939,75,0,6536,'<p><span style=\"font-size: medium;\"><strong>Bette Select Super Steel Single Ended Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Shape : Rectangular</li>\r\n<li>Single ended bath</li>\r\n<li>Super steel bath</li>\r\n<li>Colour : White</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Tapholes, Legset, Antislip, BETTEGLAZE&reg; [Optional]</li>\r\n<li>Made from : sturdy titanium finished steel, refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust<br /><br /></li>\r\n</ul>\r\n'),(17940,155,0,6536,'Exclude'),(17941,75,5,6537,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Colour : White</li>\r\n<li>Made using 2mm steel</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Extremely narrow rim only 20mm high</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\r\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\r\n</ul>'),(17942,75,0,6537,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Single ended bath</li>\r\n<li>Colour : White</li>\r\n<li>Made using 2mm steel</li>\r\n<li>Made from glazed titanium steel</li>\r\n<li>Constructed using sustainable quality</li>\r\n<li>Extremely narrow rim only 20mm high</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\r\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\r\n</ul>'),(17943,155,0,6537,'Exclude'),(17944,76,5,6538,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-comodo-super-steel-bath-with-side-overflow.html\">&gt;&nbsp;&nbsp;View all Bette Comodo Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17945,76,0,6538,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-comodo-super-steel-bath-with-side-overflow.html\">&gt;&nbsp;&nbsp;View all Bette Comodo Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17946,75,5,6538,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath 1700 x 800mm - No TH</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>Colour : White</li>\n<li>Made using 2mm steel</li>\n<li>Supplied with no tap hole</li>\n<li>Made from glazed titanium steel</li>\n<li>Constructed using sustainable quality</li>\n<li>Extremely narrow rim only 20mm high</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\n</ul>'),(17947,75,0,6538,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath 1700 x 800mm - No TH</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>Colour : White</li>\n<li>Made using 2mm steel</li>\n<li>Supplied with no tap hole</li>\n<li>Made from glazed titanium steel</li>\n<li>Constructed using sustainable quality</li>\n<li>Extremely narrow rim only 20mm high</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\n</ul>'),(17948,155,0,6538,'Exclude'),(17949,76,5,6539,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-comodo-super-steel-bath-with-side-overflow.html\">&gt;&nbsp;&nbsp;View all Bette Comodo Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17950,76,0,6539,'<div>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/bette-comodo-super-steel-bath-with-side-overflow.html\">&gt;&nbsp;&nbsp;View all Bette Comodo Baths</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17951,75,5,6539,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath 1800 x 800mm - No TH</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>Colour : White</li>\n<li>Made using 2mm steel</li>\n<li>Supplied with no tap hole</li>\n<li>Made from glazed titanium steel</li>\n<li>Constructed using sustainable quality</li>\n<li>Extremely narrow rim only 20mm high</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\n</ul>'),(17952,75,0,6539,'<p><span style=\"font-size: medium;\"><strong>Bette Comodo Super Steel Bath 1800 x 800mm - No TH</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Single ended bath</li>\n<li>Colour : White</li>\n<li>Made using 2mm steel</li>\n<li>Supplied with no tap hole</li>\n<li>Made from glazed titanium steel</li>\n<li>Constructed using sustainable quality</li>\n<li>Extremely narrow rim only 20mm high</li>\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\n<li>Highly precise formation of corners for perfect transitions when tiling</li>\n<li>Oval interior with softly shaped neck section and comfortable back angle provides plenty of space for a relaxing</li>\n</ul>'),(17953,155,0,6539,'Exclude'),(17954,76,5,6540,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17955,76,0,6540,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17956,75,5,6540,'<p><span style=\"font-size: medium;\"><strong>Bette Duett Super Steel Rectangular Bath 1700 x 750mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>Supplied undrilled</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17957,75,0,6540,'<p><span style=\"font-size: medium;\"><strong>Bette Duett Super Steel Rectangular Bath 1700 x 750mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>Supplied undrilled</li>\r\n<li>Supplied with no tap hole</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17958,155,0,6540,'Exclude'),(17959,76,5,6541,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17960,76,0,6541,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17961,75,5,6541,'<p><span style=\"font-size: medium;\"><strong>Bette Duett Super Steel Rectangular Bath 1700 x 800mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>Supplied undrilled</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17962,75,0,6541,'<p><span style=\"font-size: medium;\"><strong>Bette Duett Super Steel Rectangular Bath 1700 x 800mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double ended bath</li>\r\n<li>Supplied undrilled</li>\r\n<li>Centrally-positioned drain</li>\r\n<li>Fitted with anti noise pad as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17963,155,0,6541,'Exclude'),(17964,76,5,6542,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17965,76,0,6542,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17966,75,5,6542,'<p><span style=\"font-size: medium;\"><strong>Bette Free Super Steel Double Ended Rectangular Bath 1700 x 750mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double Ended bath</li>\r\n<li>Super Steel bath</li>\r\n<li>Tap hole option available</li>\r\n<li>Centrally positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Striking design using clear, architectural and geometric elements</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17967,75,0,6542,'<p><span style=\"font-size: medium;\"><strong>Bette Free Super Steel Double Ended Rectangular Bath 1700 x 750mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double Ended bath</li>\r\n<li>Super Steel bath</li>\r\n<li>Tap hole option available</li>\r\n<li>Centrally positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Striking design using clear, architectural and geometric elements</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17968,155,0,6542,'Exclude'),(17969,76,5,6543,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17970,76,0,6543,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17971,75,5,6543,'<p><span style=\"font-size: medium;\"><strong>Bette Free Super Steel Double Ended Rectangular Bath 1800 x 800mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double Ended bath</li>\r\n<li>Super Steel bath</li>\r\n<li>Tap hole option available</li>\r\n<li>Centrally positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Striking design using clear, architectural and geometric elements</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17972,75,0,6543,'<p><span style=\"font-size: medium;\"><strong>Bette Free Super Steel Double Ended Rectangular Bath 1800 x 800mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double Ended bath</li>\r\n<li>Super Steel bath</li>\r\n<li>Tap hole option available</li>\r\n<li>Centrally positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Striking design using clear, architectural and geometric elements</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17973,155,0,6543,'Exclude'),(17974,76,5,6544,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17975,76,0,6544,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17976,75,5,6544,'<p><span style=\"font-size: medium;\"><strong>Bette Free Super Steel Double Ended Rectangular Bath 1900 x 800mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double Ended bath</li>\r\n<li>Super Steel bath</li>\r\n<li>Tap hole option available</li>\r\n<li>Centrally positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Striking design using clear, architectural and geometric elements</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17977,75,0,6544,'<p><span style=\"font-size: medium;\"><strong>Bette Free Super Steel Double Ended Rectangular Bath 1900 x 800mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double Ended bath</li>\r\n<li>Super Steel bath</li>\r\n<li>Tap hole option available</li>\r\n<li>Centrally positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Striking design using clear, architectural and geometric elements</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>\r\n'),(17978,155,0,6544,'Exclude'),(17979,76,5,6545,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17980,76,0,6545,'<div>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette.html\">&gt;&nbsp; View all Bette Bath Ranges</a></span></strong></li>\r\n\r\n<li><strong><span style=\"font-size: 12pt;\"><a href=\"/brands/bette/bette-accessories.html\">&gt;&nbsp; View all Bette Bath Accessories</a></span></strong></li>\r\n</div>'),(17981,75,5,6545,'<p><span style=\"font-size: medium;\"><strong>Bette Free Super Steel Double Ended Rectangular Bath 2000 x 1000mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double Ended bath</li>\r\n<li>Super Steel bath</li>\r\n<li>Tap hole option available</li>\r\n<li>Centrally positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Striking design using clear, architectural and geometric elements</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17982,75,0,6545,'<p><span style=\"font-size: medium;\"><strong>Bette Free Super Steel Double Ended Rectangular Bath 2000 x 1000mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Double Ended bath</li>\r\n<li>Super Steel bath</li>\r\n<li>Tap hole option available</li>\r\n<li>Centrally positioned drain</li>\r\n<li>Anti-noise pad is fitted as standard</li>\r\n<li>Legset, Antislip, Bette GLAZE Plus [Optional]</li>\r\n<li>No tap hole and 2 tap holes option available</li>\r\n<li>Strong and highly durable than other normal baths</li>\r\n<li>Striking design using clear, architectural and geometric elements</li>\r\n<li>Made from : sturdy titanium finished steel , refined with a unique BETTEGLAZE enamel finish, which is made using water, glass, quartz, borax and soda</li>\r\n<li>Bette steel baths are heat conducting, hygienic easy care, resistant to chemicals, scratch and impact resistant, UV resistant, and reassuringly robust</li>\r\n</ul>'),(17983,155,0,6545,'Exclude'),(17984,85,5,6546,'Vitra Balance Rectangular Single Ended Bath'),(17985,85,0,6546,'Vitra Balance Rectangular Single Ended Bath'),(17986,76,5,6546,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(17987,76,0,6546,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(17988,75,5,6546,'<p><span style=\"font-size: medium;\"><strong>Vitra Balance Rectangular Single Ended Bath</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Available in 3 different sizes: 1500mm, 1600mm, 1700mm</li>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(17989,75,0,6546,'<p><span style=\"font-size: medium;\"><strong>Vitra Balance Rectangular Single Ended Bath</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Available in 3 different sizes: 1500mm, 1600mm, 1700mm</li>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(17990,155,0,6546,'Exclude'),(17991,85,5,6547,'Vitra Balance Rectangular Single Ended Bath 1500 x 700mm'),(17992,85,0,6547,'Vitra Balance Rectangular Single Ended Bath 1500 x 700mm'),(17993,76,5,6547,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(17994,76,0,6547,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(17995,75,5,6547,'<p><span style=\"font-size: medium;\"><strong>Vitra Balance Rectangular Single Ended Bath 1500 x 700mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(17996,75,0,6547,'<p><span style=\"font-size: medium;\"><strong>Vitra Balance Rectangular Single Ended Bath 1500 x 700mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(17997,155,0,6547,'Exclude'),(17998,85,5,6548,'Vitra Balance Rectangular Single Ended Bath 1600 x 700mm'),(17999,85,0,6548,'Vitra Balance Rectangular Single Ended Bath 1600 x 700mm'),(18000,76,5,6548,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18001,76,0,6548,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18002,75,5,6548,'<p><span style=\"font-size: medium;\"><strong>Vitra Balance Rectangular Single Ended Bath 1600 x 700mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18003,75,0,6548,'<p><span style=\"font-size: medium;\"><strong>Vitra Balance Rectangular Single Ended Bath 1600 x 700mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18004,155,0,6548,'Exclude'),(18005,85,5,6549,'Vitra Balance Rectangular Single Ended Bath 1700 x 700mm'),(18006,85,0,6549,'Vitra Balance Rectangular Single Ended Bath 1700 x 700mm'),(18007,76,5,6549,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18008,76,0,6549,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18009,75,5,6549,'<p><span style=\"font-size: medium;\"><strong>Vitra Balance Rectangular Single Ended Bath 1700 x 700mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18010,75,0,6549,'<p><span style=\"font-size: medium;\"><strong>Vitra Balance Rectangular Single Ended Bath 1700 x 700mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18011,155,0,6549,'Exclude'),(18012,85,5,6550,'Vitra Neon Rectangular Single Ended Bath'),(18013,85,0,6550,'Vitra Neon Rectangular Single Ended Bath'),(18014,76,5,6550,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18015,76,0,6550,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18016,75,5,6550,'<p><span style=\"font-size: medium;\"><strong>Vitra Neon Rectangular Single Ended Bath</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Available in 3 different sizes: 1500mm, 1600mm, 1700mm</li>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18017,75,0,6550,'<p><span style=\"font-size: medium;\"><strong>Vitra Neon Rectangular Single Ended Bath</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Available in 3 different sizes: 1500mm, 1600mm, 1700mm</li>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18018,155,0,6550,'Exclude'),(18019,85,5,6551,'Vitra Neon Rectangular Single Ended Bath 1500 x 700mm'),(18020,85,0,6551,'Vitra Neon Rectangular Single Ended Bath 1500 x 700mm'),(18021,76,5,6551,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18022,76,0,6551,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18023,75,5,6551,'<p><span style=\"font-size: medium;\"><strong>Vitra Neon Rectangular Single Ended Bath 1500 x 700mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Available in 3 different sizes: 1500mm, 1600mm, 1700mm</li>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18024,75,0,6551,'<p><span style=\"font-size: medium;\"><strong>Vitra Neon Rectangular Single Ended Bath 1500 x 700mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Available in 3 different sizes: 1500mm, 1600mm, 1700mm</li>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18025,155,0,6551,'Exclude'),(18026,85,5,6552,'Vitra Neon Rectangular Single Ended Bath 1600 x 700mm'),(18027,85,0,6552,'Vitra Neon Rectangular Single Ended Bath 1600 x 700mm'),(18028,76,5,6552,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18029,76,0,6552,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18030,75,5,6552,'<p><span style=\"font-size: medium;\"><strong>Vitra Neon Rectangular Single Ended Bath 1600 x 700mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Available in 3 different sizes: 1500mm, 1600mm, 1700mm</li>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18031,75,0,6552,'<p><span style=\"font-size: medium;\"><strong>Vitra Neon Rectangular Single Ended Bath 1600 x 700mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Available in 3 different sizes: 1500mm, 1600mm, 1700mm</li>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18032,155,0,6552,'Exclude'),(18033,85,5,6553,'Vitra Neon Rectangular Single Ended Bath 1600 x 750mm'),(18034,85,0,6553,'Vitra Neon Rectangular Single Ended Bath 1600 x 750mm'),(18035,76,5,6553,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18036,76,0,6553,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18037,75,5,6553,'<p><span style=\"font-size: medium;\"><strong>Vitra Neon Rectangular Single Ended Bath 1600 x 750mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Available in 3 different sizes: 1500mm, 1600mm, 1700mm</li>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18038,75,0,6553,'<p><span style=\"font-size: medium;\"><strong>Vitra Neon Rectangular Single Ended Bath 1600 x 750mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Available in 3 different sizes: 1500mm, 1600mm, 1700mm</li>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18039,155,0,6553,'Exclude'),(18040,85,5,6554,'Vitra Neon Rectangular Single Ended Bath 1700 x 700mm'),(18041,85,0,6554,'Vitra Neon Rectangular Single Ended Bath 1700 x 700mm'),(18042,76,5,6554,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18043,76,0,6554,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18044,75,5,6554,'<p><span style=\"font-size: medium;\"><strong>Vitra Neon Rectangular Single Ended Bath 1700 x 700mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Available in 3 different sizes: 1500mm, 1600mm, 1700mm</li>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18045,75,0,6554,'<p><span style=\"font-size: medium;\"><strong>Vitra Neon Rectangular Single Ended Bath 1700 x 700mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Available in 3 different sizes: 1500mm, 1600mm, 1700mm</li>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18046,155,0,6554,'Exclude'),(18047,85,5,6555,'Vitra Neon Rectangular Single Ended Bath 1700 x 750mm'),(18048,85,0,6555,'Vitra Neon Rectangular Single Ended Bath 1700 x 750mm'),(18049,76,5,6555,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18050,76,0,6555,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18051,75,5,6555,'<p><span style=\"font-size: medium;\"><strong>Vitra Neon Rectangular Single Ended Bath 1700 x 750mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Available in 3 different sizes: 1500mm, 1600mm, 1700mm</li>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18052,75,0,6555,'<p><span style=\"font-size: medium;\"><strong>Vitra Neon Rectangular Single Ended Bath 1700 x 750mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Available in 3 different sizes: 1500mm, 1600mm, 1700mm</li>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18053,155,0,6555,'Exclude'),(18054,85,5,6556,'Vitra Neon Space Saver LH Single Ended Bath 1700 x 850mm'),(18055,85,0,6556,'Vitra Neon Space Saver LH Single Ended Bath 1700 x 850mm'),(18056,76,5,6556,'<p><strong>For other options please click below</strong></p>\r\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \r\n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18057,76,0,6556,'<p><strong>For other options please click below</strong></p>\r\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \r\n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18058,75,5,6556,'<p><span style=\"font-size: medium;\"><strong>Vitra Neon Space Saver LH Single Ended Bath 1700 x 850mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Comes in white finish</li>	\r\n<li>Offset bath shape</li>\r\n<li>Left / Right hand bath options</li>	\r\n<li>Contemporary and stylish design</li>	\r\n<li>10 Years guarantee from manufacturer</li>\r\n</ul>'),(18059,75,0,6556,'<p><span style=\"font-size: medium;\"><strong>Vitra Neon Space Saver LH Single Ended Bath 1700 x 850mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Comes in white finish</li>	\r\n<li>Offset bath shape</li>\r\n<li>Left / Right hand bath options</li>	\r\n<li>Contemporary and stylish design</li>	\r\n<li>10 Years guarantee from manufacturer</li>\r\n</ul>'),(18060,155,0,6556,'Exclude'),(18061,85,5,6557,'Vitra Neon Rectangular Double Ended Bath 1800 x 800mm'),(18062,85,0,6557,'Vitra Neon Rectangular Double Ended Bath 1800 x 800mm'),(18063,76,5,6557,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18064,76,0,6557,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18065,75,5,6557,'<p><span style=\"font-size: medium;\"><strong>Vitra Neon Rectangular Double Ended Bath 1800 x 800mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n	\n<li>Comes in white finish</li>	\n<li>Rectangular bath shape</li>\n<li>Acrylic material</li>	\n<li>Contemporary and stylish design</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18066,75,0,6557,'<p><span style=\"font-size: medium;\"><strong>Vitra Neon Rectangular Double Ended Bath 1800 x 800mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n	\n<li>Comes in white finish</li>	\n<li>Rectangular bath shape</li>\n<li>Acrylic material</li>	\n<li>Contemporary and stylish design</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18067,155,0,6557,'Exclude'),(18068,85,5,6558,'Vitra Optima Rectangular Single Ended Bath'),(18069,85,0,6558,'Vitra Optima Rectangular Single Ended Bath'),(18070,76,5,6558,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18071,76,0,6558,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18072,75,5,6558,'<p><span style=\"font-size: medium;\"><strong>Vitra Optima Rectangular Single Ended Bath</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Available in 3 different sizes: 1500mm, 1600mm, 1700mm</li>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18073,75,0,6558,'<p><span style=\"font-size: medium;\"><strong>Vitra Optima Rectangular Single Ended Bath</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Available in 3 different sizes: 1500mm, 1600mm, 1700mm</li>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18074,155,0,6558,'Exclude'),(18075,85,5,6559,'Vitra Optima Rectangular Single Ended Bath 1500 x 700mm'),(18076,85,0,6559,'Vitra Optima Rectangular Single Ended Bath 1500 x 700mm'),(18077,76,5,6559,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18078,76,0,6559,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18079,75,5,6559,'<p><span style=\"font-size: medium;\"><strong>Vitra Optima Rectangular Single Ended Bath 1500 x 700mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18080,75,0,6559,'<p><span style=\"font-size: medium;\"><strong>Vitra Optima Rectangular Single Ended Bath 1500 x 700mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18081,155,0,6559,'Exclude'),(18082,85,5,6560,'Vitra Optima Rectangular Single Ended Bath 1600 x 700mm'),(18083,85,0,6560,'Vitra Optima Rectangular Single Ended Bath 1600 x 700mm'),(18084,76,5,6560,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18085,76,0,6560,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18086,75,5,6560,'<p><span style=\"font-size: medium;\"><strong>Vitra Optima Rectangular Single Ended Bath 1600 x 700mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18087,75,0,6560,'<p><span style=\"font-size: medium;\"><strong>Vitra Optima Rectangular Single Ended Bath 1600 x 700mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18088,155,0,6560,'Exclude'),(18089,85,5,6561,'Vitra Optima Rectangular Single Ended Bath 1700 x 700mm'),(18090,85,0,6561,'Vitra Optima Rectangular Single Ended Bath 1700 x 700mm'),(18091,76,5,6561,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18092,76,0,6561,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18093,75,5,6561,'<p><span style=\"font-size: medium;\"><strong>Vitra Optima Rectangular Single Ended Bath 1600 x 750mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18094,75,0,6561,'<p><span style=\"font-size: medium;\"><strong>Vitra Optima Rectangular Single Ended Bath 1600 x 750mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18095,155,0,6561,'Exclude'),(18096,85,5,6562,'Vitra Optima Rectangular Single Ended Bath 1700 x 750mm'),(18097,85,0,6562,'Vitra Optima Rectangular Single Ended Bath 1700 x 750mm'),(18098,76,5,6562,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18099,76,0,6562,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18100,75,5,6562,'<p><span style=\"font-size: medium;\"><strong>Vitra Optima Rectangular Double Ended Bath 1700 x 750mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18101,75,0,6562,'<p><span style=\"font-size: medium;\"><strong>Vitra Optima Rectangular Double Ended Bath 1700 x 750mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Comes in white finish</li>	\n<li>Supplied without tap hole</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Made from 5mm standard acrylic</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18102,155,0,6562,'Exclude'),(18103,85,5,6563,'Vitra Silence Freestanding Bath 1700 x 900mm'),(18104,85,0,6563,'Vitra Silence Freestanding Bath 1700 x 900mm'),(18105,76,5,6563,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18106,76,0,6563,'<p><strong>For other options please click below</strong></p>\n<a href=\"/brands/vitra/baths.html\"><strong>Vitra Baths</strong></a> / \n<a href=\"/brands/vitra.html\"><strong>Vitra All Products</strong></a>'),(18107,75,5,6563,'<p><span style=\"font-size: medium;\"><strong>Vitra Silence Freestanding Bath 1700 x 900mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Comes in white finish</li>	\n<li>Freestanding Oval Bath</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Leg set and waste included</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18108,75,0,6563,'<p><span style=\"font-size: medium;\"><strong>Vitra Silence Freestanding Bath 1700 x 900mm</strong></span></p>\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Comes in white finish</li>	\n<li>Freestanding Oval Bath</li>\n<li>Hydromassage option: Without massage</li>	\n<li>Leg set and waste included</li>	\n<li>10 Years guarantee from manufacturer</li>\n</ul>'),(18109,155,0,6563,'Exclude'),(18110,85,5,6564,'Nuie Square L-Shaped Shower Bath 1500 x 850mm'),(18111,85,0,6564,'Nuie Square L-Shaped Shower Bath 1500 x 850mm'),(18112,75,5,6564,'<p><span style=\"font-size: medium;\"><strong>Nuie Square L-Shaped Shower Bath 1500 x 850mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>Contemporary square design</li>\n<li>Displaced capacity: 130L</li>\n<li>Volume (Literage): 200L</li>\n<li>Configurable left or right hand options</li>	\n<li>Suitable for use with a bath screen </li>\n<li>Un-drilled for taps</li>\n<li>4mm material thickness</li>\n<li>Bath waste position: End of bath</li>\n<li>5 Years guarantee from manufacturer</li>\n</ul>'),(18113,75,0,6564,'<p><span style=\"font-size: medium;\"><strong>Nuie Square L-Shaped Shower Bath 1500 x 850mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>Contemporary square design</li>\n<li>Displaced capacity: 130L</li>\n<li>Volume (Literage): 200L</li>\n<li>Configurable left or right hand options</li>	\n<li>Suitable for use with a bath screen </li>\n<li>Un-drilled for taps</li>\n<li>4mm material thickness</li>\n<li>Bath waste position: End of bath</li>\n<li>5 Years guarantee from manufacturer</li>\n</ul>'),(18114,155,0,6564,'Exclude'),(18115,85,5,6565,'Nuie Square L-Shaped Shower Bath 1600 x 850mm'),(18116,85,0,6565,'Nuie Square L-Shaped Shower Bath 1600 x 850mm'),(18117,75,5,6565,'<p><span style=\"font-size: medium;\"><strong>Nuie Square L-Shaped Shower Bath 1600 x 850mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>Contemporary square design</li>\n<li>Displaced capacity: 130L</li>\n<li>Volume (Literage): 200L</li>\n<li>Configurable left or right hand options</li>	\n<li>Suitable for use with a bath screen </li>\n<li>Un-drilled for taps</li>\n<li>4mm material thickness</li>\n<li>Bath waste position: End of bath</li>\n<li>5 Years guarantee from manufacturer</li>\n</ul>'),(18118,75,0,6565,'<p><span style=\"font-size: medium;\"><strong>Nuie Square L-Shaped Shower Bath 1600 x 850mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>Contemporary square design</li>\n<li>Displaced capacity: 130L</li>\n<li>Volume (Literage): 200L</li>\n<li>Configurable left or right hand options</li>	\n<li>Suitable for use with a bath screen </li>\n<li>Un-drilled for taps</li>\n<li>4mm material thickness</li>\n<li>Bath waste position: End of bath</li>\n<li>5 Years guarantee from manufacturer</li>\n</ul>'),(18119,155,0,6565,'Exclude'),(18120,85,5,6566,'Nuie Square L-Shaped Shower Bath 1700 x 850mm'),(18121,85,0,6566,'Nuie Square L-Shaped Shower Bath 1700 x 850mm'),(18122,75,5,6566,'<p><span style=\"font-size: medium;\"><strong>Nuie Square L-Shaped Shower Bath 1700 x 850mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>Contemporary square design</li>\n<li>Displaced capacity: 165L</li>\n<li>Volume (Literage): 235L</li>\n<li>Configurable left or right hand options</li>	\n<li>Suitable for use with a bath screen </li>\n<li>Un-drilled for taps</li>\n<li>4mm material thickness</li>\n<li>Bath waste position: End of bath</li>\n<li>5 Years guarantee from manufacturer</li>\n</ul>'),(18123,75,0,6566,'<p><span style=\"font-size: medium;\"><strong>Nuie Square L-Shaped Shower Bath 1700 x 850mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>Contemporary square design</li>\n<li>Displaced capacity: 165L</li>\n<li>Volume (Literage): 235L</li>\n<li>Configurable left or right hand options</li>	\n<li>Suitable for use with a bath screen </li>\n<li>Un-drilled for taps</li>\n<li>4mm material thickness</li>\n<li>Bath waste position: End of bath</li>\n<li>5 Years guarantee from manufacturer</li>\n</ul>'),(18124,155,0,6566,'Exclude'),(18125,85,5,6567,'Nuie Square B Shaped Shower Bath 1500 x 900mm'),(18126,85,0,6567,'Nuie Square B Shaped Shower Bath 1500 x 900mm'),(18127,75,5,6567,'<p><span style=\"font-size: medium;\"><strong>Nuie Square B Shaped Shower Bath 1500 x 900mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>Modern rounded design</li>\n<li>Displaced capacity: 130L</li>\n<li>Volume (Literage): 200L</li>\n<li>Configurable left or right hand options</li>	\n<li>Suitable for use with a bath screen </li>\n<li>Un-drilled for taps</li>\n<li>4mm material thickness</li>\n<li>Bath waste position: End of bath</li>\n<li>5 Years guarantee from manufacturer</li>\n</ul>'),(18128,75,0,6567,'<p><span style=\"font-size: medium;\"><strong>Nuie Square B Shaped Shower Bath 1500 x 900mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>Modern rounded design</li>\n<li>Displaced capacity: 130L</li>\n<li>Volume (Literage): 200L</li>\n<li>Configurable left or right hand options</li>	\n<li>Suitable for use with a bath screen </li>\n<li>Un-drilled for taps</li>\n<li>4mm material thickness</li>\n<li>Bath waste position: End of bath</li>\n<li>5 Years guarantee from manufacturer</li>\n</ul>'),(18129,155,0,6567,'Exclude'),(18130,85,5,6568,'Nuie Square B Shaped Shower Bath 1700 x 900mm'),(18131,85,0,6568,'Nuie Square B Shaped Shower Bath 1700 x 900mm'),(18132,75,5,6568,'<style>#html-body [data-pb-style=CFL268K]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"CFL268K\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Nuie Square B Shaped Shower Bath 1700 x 900mm</strong></span></p>\r\n<p>Buy our vast range of Nuie Square b shaped bath panels styles &amp; sizes available on Banyo UK. Order online!</p>\r\n<p><strong>Features</strong></p>\r\n<ul>\r\n<li>Manufactured from sanitary grade acrylic</li>\r\n<li>Modern rounded design</li>\r\n<li>Displaced capacity: 170L</li>\r\n<li>Volume (Literage): 240L</li>\r\n<li>Configurable left or right hand options</li>\r\n<li>Suitable for use with a bath screen</li>\r\n<li>Un-drilled for taps</li>\r\n<li>4mm material thickness</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>5 Years guarantee from manufacturer</li>\r\n</ul></div></div></div>'),(18133,75,0,6568,'<style>#html-body [data-pb-style=CFL268K]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"CFL268K\"><div data-content-type=\"text\" data-appearance=\"default\" data-element=\"main\"><p><span style=\"font-size: medium;\"><strong>Nuie Square B Shaped Shower Bath 1700 x 900mm</strong></span></p>\r\n<p>Buy our vast range of Nuie Square b shaped bath panels styles &amp; sizes available on Banyo UK. Order online!</p>\r\n<p><strong>Features</strong></p>\r\n<ul>\r\n<li>Manufactured from sanitary grade acrylic</li>\r\n<li>Modern rounded design</li>\r\n<li>Displaced capacity: 170L</li>\r\n<li>Volume (Literage): 240L</li>\r\n<li>Configurable left or right hand options</li>\r\n<li>Suitable for use with a bath screen</li>\r\n<li>Un-drilled for taps</li>\r\n<li>4mm material thickness</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>5 Years guarantee from manufacturer</li>\r\n</ul></div></div></div>'),(18134,155,0,6568,'Exclude'),(18135,85,5,6569,'Nuie Square P Shaped Shower Bath 1500 x 850mm'),(18136,85,0,6569,'Nuie Square P Shaped Shower Bath 1500 x 850mm'),(18137,75,5,6569,'<p><span style=\"font-size: medium;\"><strong>Nuie Square P Shaped Shower Bath 1500 x 850mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>Modern rounded design</li>\n<li>Configurable left or right hand options</li>	\n<li>Suitable for use with a bath screen </li>\n<li>Un-drilled for taps</li>\n<li>4mm material thickness</li>\n<li>Bath waste position: End of bath</li>\n<li>5 Years guarantee from manufacturer</li>\n</ul>'),(18138,75,0,6569,'<p><span style=\"font-size: medium;\"><strong>Nuie Square P Shaped Shower Bath 1500 x 850mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>Modern rounded design</li>\n<li>Configurable left or right hand options</li>	\n<li>Suitable for use with a bath screen </li>\n<li>Un-drilled for taps</li>\n<li>4mm material thickness</li>\n<li>Bath waste position: End of bath</li>\n<li>5 Years guarantee from manufacturer</li>\n</ul>'),(18139,155,0,6569,'Exclude'),(18140,85,5,6570,'Nuie Square P Shaped Shower Bath 1600 x 850mm'),(18141,85,0,6570,'Nuie Square P Shaped Shower Bath 1600 x 850mm'),(18142,75,5,6570,'<p><span style=\"font-size: medium;\"><strong>Nuie Square P Shaped Shower Bath 1600 x 850mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>Modern rounded design</li>\n<li>Displaced capacity: 120L</li>\n<li>Volume (Literage): 190L</li>\n<li>Configurable left or right hand options</li>	\n<li>Suitable for use with a bath screen </li>\n<li>Un-drilled for taps</li>\n<li>4mm material thickness</li>\n<li>Bath waste position: End of bath</li>\n<li>5 Years guarantee from manufacturer</li>\n</ul>'),(18143,75,0,6570,'<p><span style=\"font-size: medium;\"><strong>Nuie Square P Shaped Shower Bath 1600 x 850mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\n<ul>\n<li>Manufactured from sanitary grade acrylic</li>\n<li>Modern rounded design</li>\n<li>Displaced capacity: 120L</li>\n<li>Volume (Literage): 190L</li>\n<li>Configurable left or right hand options</li>	\n<li>Suitable for use with a bath screen </li>\n<li>Un-drilled for taps</li>\n<li>4mm material thickness</li>\n<li>Bath waste position: End of bath</li>\n<li>5 Years guarantee from manufacturer</li>\n</ul>'),(18144,155,0,6570,'Exclude'),(18145,85,5,6571,'Nuie Square P Shaped Shower Bath 1700 x 850mm'),(18146,85,0,6571,'Nuie Square P Shaped Shower Bath 1700 x 850mm'),(18147,75,5,6571,'<p><span style=\"font-size: medium;\"><strong>Nuie Square P Shaped Shower Bath 1700 x 850mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Manufactured from sanitary grade acrylic</li>\r\n<li>Modern rounded design</li>\r\n<li>Displaced capacity: 130L</li>\r\n<li>Volume (Literage): 200L</li>\r\n<li>Configurable left or right hand options</li>	\r\n<li>Suitable for use with a bath screen </li>\r\n<li>Un-drilled for taps</li>\r\n<li>4mm material thickness</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>5 Years guarantee from manufacturer</li>\r\n</ul>'),(18148,75,0,6571,'<p><span style=\"font-size: medium;\"><strong>Nuie Square P Shaped Shower Bath 1700 x 850mm</strong></span></p><p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Manufactured from sanitary grade acrylic</li>\r\n<li>Modern rounded design</li>\r\n<li>Displaced capacity: 130L</li>\r\n<li>Volume (Literage): 200L</li>\r\n<li>Configurable left or right hand options</li>	\r\n<li>Suitable for use with a bath screen </li>\r\n<li>Un-drilled for taps</li>\r\n<li>4mm material thickness</li>\r\n<li>Bath waste position: End of bath</li>\r\n<li>5 Years guarantee from manufacturer</li>\r\n</ul>'),(18149,155,0,6571,'Exclude'),(18150,85,5,6572,'Bette Select Duo Rectangular White Bath - 1800 x 800mm'),(18151,85,0,6572,'Bette Select Duo Rectangular White Bath - 1800 x 800mm'),(18152,75,5,6572,'<p><span-style=\"font-size:-medium;\"><strong>Bette Select Duo Rectangular White Bath - 1800 x 800mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Sustainable quality</li>\r\n<li>Shape: Rectangular</li>\r\n<li>Capacity: 170 (litres)</li>\r\n<li>Glazed titanium -steel</li>\r\n<li>Functions: 2 Seater bath</li>\r\n<li>Installation type: Fitted, Undermounted</li>\r\n</ul>\r\n'),(18153,75,0,6572,'<p><span-style=\"font-size:-medium;\"><strong>Bette Select Duo Rectangular White Bath - 1800 x 800mm</strong></span></p>\r\n<p><span style=\"font-size: medium;\"><strong>Features</strong></span></p>\r\n<ul>\r\n<li>Sustainable quality</li>\r\n<li>Shape: Rectangular</li>\r\n<li>Capacity: 170 (litres)</li>\r\n<li>Glazed titanium -steel</li>\r\n<li>Functions: 2 Seater bath</li>\r\n<li>Installation type: Fitted, Undermounted</li>\r\n</ul>\r\n'),(18154,155,0,6572,'Exclude');
/*!40000 ALTER TABLE `catalog_product_entity_text` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_text_after_insert` AFTER INSERT ON `catalog_product_entity_text` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`entity_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_text_after_update` AFTER UPDATE ON `catalog_product_entity_text` FOR EACH ROW BEGIN
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_text_after_delete` AFTER DELETE ON `catalog_product_entity_text` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (OLD.`entity_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (OLD.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `catalog_product_entity_tier_price`
--

DROP TABLE IF EXISTS `catalog_product_entity_tier_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_entity_tier_price` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `all_groups` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Is Applicable To All Customer Groups',
  `customer_group_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `qty` decimal(12,4) NOT NULL DEFAULT '1.0000' COMMENT 'QTY',
  `value` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Value',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `percentage_value` decimal(5,2) DEFAULT NULL COMMENT 'Percentage value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `UNQ_E8AB433B9ACB00343ABB312AD2FAB087` (`entity_id`,`all_groups`,`customer_group_id`,`qty`,`website_id`),
  KEY `CATALOG_PRODUCT_ENTITY_TIER_PRICE_CUSTOMER_GROUP_ID` (`customer_group_id`),
  KEY `CATALOG_PRODUCT_ENTITY_TIER_PRICE_WEBSITE_ID` (`website_id`),
  CONSTRAINT `CAT_PRD_ENTT_TIER_PRICE_CSTR_GROUP_ID_CSTR_GROUP_CSTR_GROUP_ID` FOREIGN KEY (`customer_group_id`) REFERENCES `customer_group` (`customer_group_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_ENTT_TIER_PRICE_ENTT_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_ENTT_TIER_PRICE_WS_ID_STORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Tier Price Attribute Backend Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_entity_tier_price`
--

LOCK TABLES `catalog_product_entity_tier_price` WRITE;
/*!40000 ALTER TABLE `catalog_product_entity_tier_price` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_entity_tier_price` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_tier_price_after_insert` AFTER INSERT ON `catalog_product_entity_tier_price` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (NEW.`entity_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_tier_price_after_update` AFTER UPDATE ON `catalog_product_entity_tier_price` FOR EACH ROW BEGIN
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`all_groups` <=> OLD.`all_groups`) OR NOT(NEW.`customer_group_id` <=> OLD.`customer_group_id`) OR NOT(NEW.`qty` <=> OLD.`qty`) OR NOT(NEW.`value` <=> OLD.`value`) OR NOT(NEW.`website_id` <=> OLD.`website_id`) OR NOT(NEW.`percentage_value` <=> OLD.`percentage_value`)) THEN INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`all_groups` <=> OLD.`all_groups`) OR NOT(NEW.`customer_group_id` <=> OLD.`customer_group_id`) OR NOT(NEW.`qty` <=> OLD.`qty`) OR NOT(NEW.`value` <=> OLD.`value`) OR NOT(NEW.`website_id` <=> OLD.`website_id`) OR NOT(NEW.`percentage_value` <=> OLD.`percentage_value`)) THEN INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_tier_price_after_delete` AFTER DELETE ON `catalog_product_entity_tier_price` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (OLD.`entity_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (OLD.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `catalog_product_entity_varchar`
--

DROP TABLE IF EXISTS `catalog_product_entity_varchar`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_entity_varchar` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CATALOG_PRODUCT_ENTITY_VARCHAR_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `CATALOG_PRODUCT_ENTITY_VARCHAR_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_PRODUCT_ENTITY_VARCHAR_STORE_ID` (`store_id`),
  CONSTRAINT `CAT_PRD_ENTT_VCHR_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_ENTT_VCHR_ENTT_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_PRODUCT_ENTITY_VARCHAR_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=47415 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Varchar Attribute Backend Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_entity_varchar`
--

LOCK TABLES `catalog_product_entity_varchar` WRITE;
/*!40000 ALTER TABLE `catalog_product_entity_varchar` DISABLE KEYS */;
INSERT INTO `catalog_product_entity_varchar` VALUES (39820,134,0,5760,'2'),(39821,86,0,5760,'test-product'),(39822,84,0,5760,'test-product'),(39823,124,0,5760,'0'),(39824,73,0,5760,'test-product'),(39825,106,0,5760,'container2'),(39826,104,0,5760,'product-full-width'),(39827,121,0,5760,'test-product'),(41711,121,5,6035,'franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel'),(41712,121,0,6035,'franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel'),(41713,84,5,6035,'Franke Mythos MYX 110-34 Undermount Single Bowl Sink -Stainless Steel'),(41714,84,0,6035,'Franke Mythos MYX 110-34 Undermount Single Bowl Sink -Stainless Steel'),(41715,86,5,6035,'Franke Mythos MYX 110-34 Undermount Single Bowl Sink -Stainless Steel '),(41716,86,0,6035,'Franke Mythos MYX 110-34 Undermount Single Bowl Sink -Stainless Steel '),(41717,73,5,6035,'Franke Mythos MYX 110-34 Undermount Single Bowl Sink -Stainless Steel'),(41718,73,0,6035,'Franke Mythos MYX 110-34 Undermount Single Bowl Sink -Stainless Steel test '),(41719,121,5,6036,'franke-mythos-myx-110-45-undermount-single-bowl-sink-stainless-steel'),(41720,121,0,6036,'franke-mythos-myx-110-45-undermount-single-bowl-sink-stainless-steel'),(41721,84,5,6036,'Franke Mythos MYX 110-45 Undermount Single Bowl Sink -Stainless Steel'),(41722,84,0,6036,'Franke Mythos MYX 110-45 Undermount Single Bowl Sink -Stainless Steel'),(41723,86,5,6036,'Franke Mythos MYX 110-45 Undermount Single Bowl Sink -Stainless Steel'),(41724,86,0,6036,'Franke Mythos MYX 110-45 Undermount Single Bowl Sink -Stainless Steel'),(41725,73,5,6036,'Franke Mythos MYX 110-45 Undermount Single Bowl Sink -Stainless Steel'),(41726,73,0,6036,'Franke Mythos MYX 110-45 Undermount Single Bowl Sink -Stainless Steel'),(41727,121,5,6037,'franke-mythos-myx-110-55-undermount-single-bowl-sink-stainless-steel'),(41728,121,0,6037,'franke-mythos-myx-110-55-undermount-single-bowl-sink-stainless-steel'),(41729,84,5,6037,'Franke Mythos MYX 110-55 1.0 Bowl Undermount Sink | Banyo'),(41730,84,0,6037,'Franke Mythos MYX 110-55 1.0 Bowl Undermount Sink | Banyo'),(41731,86,5,6037,'Franke Mythos MYX 110-55 1.0 Bowl Undermount Sink is an elegantly designed with Flawless Finish (Seamless 6mm rim Design). Cabinet size: 800mm, Round flush cover place. Banyo offers low prices and a fast delivery service!'),(41732,86,0,6037,'Franke Mythos MYX 110-55 1.0 Bowl Undermount Sink is an elegantly designed with Flawless Finish (Seamless 6mm rim Design). Cabinet size: 800mm, Round flush cover place. Banyo offers low prices and a fast delivery service!'),(41733,73,5,6037,'Franke Mythos MYX 110-55 Undermount Single Bowl Sink -Stainless Steel'),(41734,73,0,6037,'Franke Mythos MYX 110-55 Undermount Single Bowl Sink -Stainless Steel'),(41735,121,5,6038,'franke-mythos-myx-110-70-undermount-single-bowl-sink-stainless-steel'),(41736,121,0,6038,'franke-mythos-myx-110-70-undermount-single-bowl-sink-stainless-steel'),(41737,84,5,6038,'Franke Mythos MYX 110-70 Undermount Single Bowl Sink -Stainless Steel'),(41738,84,0,6038,'Franke Mythos MYX 110-70 Undermount Single Bowl Sink -Stainless Steel'),(41739,86,5,6038,'Franke Mythos MYX 110-70 Undermount Single Bowl Sink -Stainless Steel '),(41740,86,0,6038,'Franke Mythos MYX 110-70 Undermount Single Bowl Sink -Stainless Steel '),(41741,73,5,6038,'Franke Mythos MYX 110-70 Undermount Single Bowl Sink -Stainless Steel'),(41742,73,0,6038,'Franke Mythos MYX 110-70 Undermount Single Bowl Sink -Stainless Steel'),(41743,121,5,6039,'franke-mythos-myx-120-34-34-undermount-double-bowl-sink-stainless-steel'),(41744,121,0,6039,'franke-mythos-myx-120-34-34-undermount-double-bowl-sink-stainless-steel'),(41745,84,5,6039,'Franke Mythos MYX 120 34-34 Undermount Double Bowl Sink -Stainless Steel'),(41746,84,0,6039,'Franke Mythos MYX 120 34-34 Undermount Double Bowl Sink -Stainless Steel'),(41747,86,5,6039,'Franke Mythos MYX 120 34-34 Undermount Double Bowl Sink -Stainless Steel'),(41748,86,0,6039,'Franke Mythos MYX 120 34-34 Undermount Double Bowl Sink -Stainless Steel'),(41749,73,5,6039,'Franke Mythos MYX 120 34-34 Undermount Double Bowl Sink -Stainless Steel'),(41750,73,0,6039,'Franke Mythos MYX 120 34-34 Undermount Double Bowl Sink -Stainless Steel'),(41751,121,5,6040,'franke-arcana-ahk-651-ceramic-inset-1-5-bowl-sink'),(41752,121,0,6040,'franke-arcana-ahk-651-ceramic-inset-1-5-bowl-sink'),(41753,84,5,6040,'Franke Arcana AHK 651 Ceramic Inset 1.5 Bowl Sink'),(41754,84,0,6040,'Franke Arcana AHK 651 Ceramic Inset 1.5 Bowl Sink'),(41755,86,5,6040,'Franke Arcana AHK 651 Ceramic Inset 1.5 Bowl Sink '),(41756,86,0,6040,'Franke Arcana AHK 651 Ceramic Inset 1.5 Bowl Sink '),(41757,73,5,6040,'Franke Arcana AHK 651 Ceramic Inset 1.5 Bowl Sink White'),(41758,73,0,6040,'Franke Arcana AHK 651 Ceramic Inset 1.5 Bowl Sink White'),(41759,121,5,6041,'blanco-supra-160-u-undermount-stainless-steel-sink-450748'),(41760,121,0,6041,'blanco-supra-160-u-undermount-stainless-steel-sink-450748'),(41761,84,5,6041,'Blanco Supra 160-U BL450748 Stainless Steel Undermount Sink | Banyo UK'),(41762,84,0,6041,'Blanco Supra 160-U BL450748 Stainless Steel Undermount Sink | Banyo UK'),(41763,86,5,6041,' Blanco Supra 160-U Undermount Stainless Steel Kitchen Sink - BL 450 748 offers a clean and simple design with excellent performance.'),(41764,86,0,6041,' Blanco Supra 160-U Undermount Stainless Steel Kitchen Sink - BL 450 748 offers a clean and simple design with excellent performance.'),(41765,73,5,6041,'Blanco Supra 160-U Undermount Stainless Steel Sink - 450748'),(41766,73,0,6041,'Blanco Supra 160-U Undermount Stainless Steel Sink - 450748'),(41767,109,5,6041,'Blanco Supra 160-U Undermount Stainless Steel Sink - 450748'),(41768,109,0,6041,'Blanco Supra 160-U Undermount Stainless Steel Sink - 450748'),(41769,121,5,6042,'blanco-supra-340-u-undermount-stainless-steel-sink-450762'),(41770,121,0,6042,'blanco-supra-340-u-undermount-stainless-steel-sink-450762'),(41771,84,5,6042,'Blanco Supra 340-U BL450762 Stainless Steel Kitchen Sink | Banyo   UK'),(41772,84,0,6042,'Blanco Supra 340-U BL450762 Stainless Steel Kitchen Sink | Banyo   UK'),(41773,86,5,6042,'We have a huge range of advanced Blanco  BL 450 762 Supra 340-U Undermount Stainless Steel Kitchen Sink here at banyo.we are the most trusted and reliable suppliers of kitchen appliances across UK'),(41774,86,0,6042,'We have a huge range of advanced Blanco  BL 450 762 Supra 340-U Undermount Stainless Steel Kitchen Sink here at banyo.we are the most trusted and reliable suppliers of kitchen appliances across UK'),(41775,73,5,6042,'Blanco Supra 340-U Undermount Stainless Steel Sink - 450762'),(41776,73,0,6042,'Blanco Supra 340-U Undermount Stainless Steel Sink - 450762'),(41777,109,5,6042,'Blanco Supra 340-U Undermount Stainless Steel Sink - 450762'),(41778,109,0,6042,'Blanco Supra 340-U Undermount Stainless Steel Sink - 450762'),(41779,121,5,6043,'blanco-livit-45-s-salto-stainless-steel-inset-sink'),(41780,121,0,6043,'blanco-livit-45-s-salto-stainless-steel-inset-sink'),(41781,84,5,6043,'Blanco Livit 45 S Salto Stainless Steel Inset Sink | Banyo UK'),(41782,84,0,6043,'Blanco Livit 45 S Salto Stainless Steel Inset Sink | Banyo UK'),(41783,86,5,6043,'Blanco Livit 45 S Salto Stainless Steel Kitchen Sink is advanced in design and has the practical feature. A stylish Blanco sink will add a perfect finishing touch to any contemporary kitchen.'),(41784,86,0,6043,'Blanco Livit 45 S Salto Stainless Steel Kitchen Sink is advanced in design and has the practical feature. A stylish Blanco sink will add a perfect finishing touch to any contemporary kitchen.'),(41785,73,5,6043,'Blanco Livit 45 S Salto Stainless Steel Inset Sink'),(41786,73,0,6043,'Blanco Livit 45 S Salto Stainless Steel Inset Sink'),(41787,109,5,6043,'Blanco Livit 45 S Salto Stainless Steel Inset Sink'),(41788,109,0,6043,'Blanco Livit 45 S Salto Stainless Steel Inset Sink'),(41789,121,5,6044,'blanco-livit-xl-5-s-inset-stainless-steel-kitchen-sink'),(41790,121,0,6044,'blanco-livit-xl-5-s-inset-stainless-steel-kitchen-sink'),(41791,84,5,6044,'Blanco Livit XL 5 S Inset Stainless Steel 1.0 Bowl Kitchen Sink | Banyo'),(41792,84,0,6044,'Blanco Livit XL 5 S Inset Stainless Steel 1.0 Bowl Kitchen Sink | Banyo'),(41793,86,5,6044,'The Blanco Livit XL 5 S comes in stainless steel is a smartly designed kitchen sink availabe at banyo on reasonable prices with two manufacturer guranteed.'),(41794,86,0,6044,'The Blanco Livit XL 5 S comes in stainless steel is a smartly designed kitchen sink availabe at banyo on reasonable prices with two manufacturer guranteed.'),(41795,73,5,6044,'Blanco Livit XL 5 S Stainless Steel Inset Kitchen Sink'),(41796,73,0,6044,'Blanco Livit XL 5 S Stainless Steel Inset Kitchen Sink'),(41797,109,5,6044,'Blanco Livit XL 5 S Stainless Steel Inset Kitchen Sink'),(41798,109,0,6044,'Blanco Livit XL 5 S Stainless Steel Inset Kitchen Sink'),(41799,121,5,6045,'blanco-supra-400-u-undermount-kitchen-sink-452613'),(41800,121,0,6045,'blanco-supra-400-u-undermount-kitchen-sink-452613'),(41801,84,5,6045,'Blanco Supra 400-U 1.0 Bowl Undermount Kitchen Sink - BL452613 | Banyo'),(41802,84,0,6045,'Blanco Supra 400-U 1.0 Bowl Undermount Kitchen Sink - BL452613 | Banyo'),(41803,86,5,6045,'Blanco Supra 400-U Undermount Stainless Steel Kitchen Sink - BL 452 613 has the great flexibility of adjustable available at banyo.We are sure we will have all the products what you looking for and we proud to provide best quality to all'),(41804,86,0,6045,'Blanco Supra 400-U Undermount Stainless Steel Kitchen Sink - BL 452 613 has the great flexibility of adjustable available at banyo.We are sure we will have all the products what you looking for and we proud to provide best quality to all'),(41805,73,5,6045,'Blanco Supra 400-U Undermount Kitchen Sink - BL452613'),(41806,73,0,6045,'Blanco Supra 400-U Undermount Kitchen Sink - BL452613'),(41807,109,5,6045,'Blanco Supra 400-U Undermount Kitchen Sink - BL452613'),(41808,109,0,6045,'Blanco Supra 400-U Undermount Kitchen Sink - BL452613'),(41809,121,5,6046,'blanco-supra-450-u-undermount-kitchen-sink-452614'),(41810,121,0,6046,'blanco-supra-450-u-undermount-kitchen-sink-452614'),(41811,84,5,6046,'Blanco Supra 450-U Undermount Stainless Steel Kitchen Sink | Banyo UK'),(41812,84,0,6046,'Blanco Supra 450-U Undermount Stainless Steel Kitchen Sink | Banyo UK'),(41813,86,5,6046,'Banyo offers Blanco Supra 450-U Undermount Stainless Steel Kitchen Sink - BL 452 614 adds style and sophistication to your kitchen and gives you Perfect result without compromising on style'),(41814,86,0,6046,'Banyo offers Blanco Supra 450-U Undermount Stainless Steel Kitchen Sink - BL 452 614 adds style and sophistication to your kitchen and gives you Perfect result without compromising on style'),(41815,73,5,6046,'Blanco Supra 450-U Undermount Kitchen Sink - 452614'),(41816,73,0,6046,'Blanco Supra 450-U Undermount Kitchen Sink - 452614'),(41817,109,5,6046,'Blanco Supra 450-U Undermount Kitchen Sink - 452614'),(41818,109,0,6046,'Blanco Supra 450-U Undermount Kitchen Sink - 452614'),(41819,121,5,6047,'blanco-supra-500-u-undermount-kitchen-sink-452615'),(41820,121,0,6047,'blanco-supra-500-u-undermount-kitchen-sink-452615'),(41821,84,5,6047,'Blanco Supra 500-U Undermount Stainless Steel Kitchen Sink | Banyo UK'),(41822,84,0,6047,'Blanco Supra 500-U Undermount Stainless Steel Kitchen Sink | Banyo UK'),(41823,86,5,6047,'Find fantastic deals on Blanco Supra 500-U Undermount Stainless Steel Kitchen Sink - BL 452 615 and Manufacturer\'s Guarantee here at banyo.'),(41824,86,0,6047,'Find fantastic deals on Blanco Supra 500-U Undermount Stainless Steel Kitchen Sink - BL 452 615 and Manufacturer\'s Guarantee here at banyo.'),(41825,73,5,6047,'Blanco Supra 500-U Undermount Kitchen Sink - 452615'),(41826,73,0,6047,'Blanco Supra 500-U Undermount Kitchen Sink - 452615'),(41827,109,5,6047,'Blanco Supra 500-U Undermount Kitchen Sink - 452615'),(41828,109,0,6047,'Blanco Supra 500-U Undermount Kitchen Sink - 452615'),(41829,121,5,6048,'blanco-livit-xl-6-s-inset-kitchen-sink-livit-xl-6-s'),(41830,121,0,6048,'blanco-livit-xl-6-s-inset-kitchen-sink-livit-xl-6-s'),(41831,84,5,6048,'Blanco Livit XL 6 S Stainless Steel 1.0 Bowl Inset Kitchen Sink | Banyo'),(41832,84,0,6048,'Blanco Livit XL 6 S Stainless Steel 1.0 Bowl Inset Kitchen Sink | Banyo'),(41833,86,5,6048,'Blanco Livit XL 6 S Inset Kitchen Sink is a modern design kitchen sink which is elegant in form and easily wiped clean.We have been providing high quality products at discount rates to customers throughout the UK since many years.'),(41834,86,0,6048,'Blanco Livit XL 6 S Inset Kitchen Sink is a modern design kitchen sink which is elegant in form and easily wiped clean.We have been providing high quality products at discount rates to customers throughout the UK since many years.'),(41835,73,5,6048,'Blanco Livit XL 6 S Inset Kitchen Sink - 453364'),(41836,73,0,6048,'Blanco Livit XL 6 S Inset Kitchen Sink - 453364'),(41837,109,5,6048,'Blanco Livit XL 6 S Inset Kitchen Sink - 453364'),(41838,109,0,6048,'Blanco Livit XL 6 S Inset Kitchen Sink - 453364'),(41839,121,5,6049,'blanco-essential-530-u-stainless-steel-undermount-sink'),(41840,121,0,6049,'blanco-essential-530-u-stainless-steel-undermount-sink'),(41841,84,5,6049,'Blanco Essential 530-U Stainless Steel 1.5 Bowl Kitchen Sink | Banyo'),(41842,84,0,6049,'Blanco Essential 530-U Stainless Steel 1.5 Bowl Kitchen Sink | Banyo'),(41843,86,5,6049,'Blanco Essential 530-U Stainless Steel Undermount Sink'),(41844,86,0,6049,'Blanco Essential 530-U Stainless Steel Undermount Sink'),(41845,73,5,6049,'Blanco Essential 530-U Stainless Steel Undermount Sink'),(41846,73,0,6049,'Blanco Essential 530-U Stainless Steel Undermount Sink'),(41847,109,5,6049,'Blanco Essential 530-U Stainless Steel Undermount Sink'),(41848,109,0,6049,'Blanco Essential 530-U Stainless Steel Undermount Sink'),(41849,121,5,6050,'blanco-lemis-6-s-if-stainless-steel-inset-kitchen-sink'),(41850,121,0,6050,'blanco-lemis-6-s-if-stainless-steel-inset-kitchen-sink'),(41851,84,5,6050,'Blanco LEMIS 6 S-IF Stainless Steel Sink - 1.5 Bowl | Banyo.co.uk'),(41852,84,0,6050,'Blanco LEMIS 6 S-IF Stainless Steel Sink - 1.5 Bowl | Banyo.co.uk'),(41853,86,5,6050,'Blanco LEMIS 6 S-IF Stainless Steel Inset Kitchen Sink'),(41854,86,0,6050,'Blanco LEMIS 6 S-IF Stainless Steel Inset Kitchen Sink'),(41855,73,5,6050,'Blanco LEMIS 6 S-IF Stainless Steel Inset Kitchen Sink'),(41856,73,0,6050,'Blanco LEMIS 6 S-IF Stainless Steel Inset Kitchen Sink'),(41857,109,5,6050,'Blanco LEMIS 6 S-IF Stainless Steel Inset Kitchen Sink'),(41858,109,0,6050,'Blanco LEMIS 6 S-IF Stainless Steel Inset Kitchen Sink'),(41859,121,5,6051,'blanco-lemis-xl-6-s-if-stainless-steel-inset-kitchen-sink'),(41860,121,0,6051,'blanco-lemis-xl-6-s-if-stainless-steel-inset-kitchen-sink'),(41861,84,5,6051,'Blanco LEMIS XL 6 S-IF Stainless Steel 1.0 Bowl Kitchen Sink | Banyo'),(41862,84,0,6051,'Blanco LEMIS XL 6 S-IF Stainless Steel 1.0 Bowl Kitchen Sink | Banyo'),(41863,86,5,6051,'Blanco LEMIS XL 6 S-IF Stainless Steel Inset Kitchen Sink'),(41864,86,0,6051,'Blanco LEMIS XL 6 S-IF Stainless Steel Inset Kitchen Sink'),(41865,73,5,6051,'Blanco LEMIS XL 6 S-IF Stainless Steel Inset Kitchen Sink'),(41866,73,0,6051,'Blanco LEMIS XL 6 S-IF Stainless Steel Inset Kitchen Sink'),(41867,109,5,6051,'Blanco LEMIS XL 6 S-IF Stainless Steel Inset Kitchen Sink'),(41868,109,0,6051,'Blanco LEMIS XL 6 S-IF Stainless Steel Inset Kitchen Sink'),(41869,121,5,6052,'blanco-lemis-45-s-if-stainless-steel-inset-kitchen-sink'),(41870,121,0,6052,'blanco-lemis-45-s-if-stainless-steel-inset-kitchen-sink'),(41871,84,5,6052,'Blanco LEMIS 45 S-IF Stainless Steel Reversible Kitchen Sink | Banyo'),(41872,84,0,6052,'Blanco LEMIS 45 S-IF Stainless Steel Reversible Kitchen Sink | Banyo'),(41873,86,5,6052,'Blanco LEMIS 45 S-IF Stainless Steel Inset Kitchen Sink'),(41874,86,0,6052,'Blanco LEMIS 45 S-IF Stainless Steel Inset Kitchen Sink'),(41875,73,5,6052,'Blanco LEMIS 45 S-IF Stainless Steel Inset Kitchen Sink'),(41876,73,0,6052,'Blanco LEMIS 45 S-IF Stainless Steel Inset Kitchen Sink'),(41877,109,5,6052,'Blanco LEMIS 45 S-IF Stainless Steel Inset Kitchen Sink'),(41878,109,0,6052,'Blanco LEMIS 45 S-IF Stainless Steel Inset Kitchen Sink'),(41879,121,5,6053,'blanco-livit-ii-6-s-stainless-steel-inset-kitchen-sink'),(41880,121,0,6053,'blanco-livit-ii-6-s-stainless-steel-inset-kitchen-sink'),(41881,84,5,6053,'Blanco LIVIT II 6 S Stainless Steel Inset Kitchen Sink'),(41882,84,0,6053,'Blanco LIVIT II 6 S Stainless Steel Inset Kitchen Sink'),(41883,86,5,6053,'Blanco LIVIT II 6 S Stainless Steel Inset Kitchen Sink'),(41884,86,0,6053,'Blanco LIVIT II 6 S Stainless Steel Inset Kitchen Sink'),(41885,73,5,6053,'Blanco LIVIT II 6 S Stainless Steel Inset Kitchen Sink'),(41886,73,0,6053,'Blanco LIVIT II 6 S Stainless Steel Inset Kitchen Sink'),(41887,109,5,6053,'Blanco LIVIT II 6 S Stainless Steel Inset Kitchen Sink'),(41888,109,0,6053,'Blanco LIVIT II 6 S Stainless Steel Inset Kitchen Sink'),(41889,110,5,6053,'Blanco LIVIT II 6 S Stainless Steel Inset Kitchen Sink'),(41890,110,0,6053,'Blanco LIVIT II 6 S Stainless Steel Inset Kitchen Sink'),(41891,111,5,6053,'Blanco LIVIT II 6 S Stainless Steel Inset Kitchen Sink'),(41892,111,0,6053,'Blanco LIVIT II 6 S Stainless Steel Inset Kitchen Sink'),(41893,121,5,6054,'blanco-rondosol-stainless-steel-inset-kitchen-sink'),(41894,121,0,6054,'blanco-rondosol-stainless-steel-inset-kitchen-sink'),(41895,84,5,6054,'Blanco RONDOSOL Stainless Steel Inset Kitchen Sink'),(41896,84,0,6054,'Blanco RONDOSOL Stainless Steel Inset Kitchen Sink'),(41897,86,5,6054,'Blanco RONDOSOL Stainless Steel Inset Kitchen Sink'),(41898,86,0,6054,'Blanco RONDOSOL Stainless Steel Inset Kitchen Sink'),(41899,73,5,6054,'Blanco RONDOSOL Stainless Steel Inset Kitchen Sink'),(41900,73,0,6054,'Blanco RONDOSOL Stainless Steel Inset Kitchen Sink'),(41901,109,5,6054,'Blanco RONDOSOL Stainless Steel Inset Kitchen Sink'),(41902,109,0,6054,'Blanco RONDOSOL Stainless Steel Inset Kitchen Sink'),(41903,110,5,6054,'Blanco RONDOSOL Stainless Steel Inset Kitchen Sink'),(41904,110,0,6054,'Blanco RONDOSOL Stainless Steel Inset Kitchen Sink'),(41905,111,5,6054,'Blanco RONDOSOL Stainless Steel Inset Kitchen Sink'),(41906,111,0,6054,'Blanco RONDOSOL Stainless Steel Inset Kitchen Sink'),(41907,121,5,6055,'blanco-panor-60-9-puraplus-inset-ceramic-kitchen-sink-crystal-white'),(41908,121,0,6055,'blanco-panor-60-9-puraplus-inset-ceramic-kitchen-sink-crystal-white'),(41909,84,5,6055,'Blanco Panor 60 Crystal White Inset Ceramic Kitchen Sink | Banyo.co.uk'),(41910,84,0,6055,'Blanco Panor 60 Crystal White Inset Ceramic Kitchen Sink | Banyo.co.uk'),(41911,86,5,6055,'Blanco Panor 60-9 PuraPlus Inset Ceramic Kitchen Sink has a spirit that satisfies your entire sink needs.Blanco series delivers endless personalization options. '),(41912,86,0,6055,'Blanco Panor 60-9 PuraPlus Inset Ceramic Kitchen Sink has a spirit that satisfies your entire sink needs.Blanco series delivers endless personalization options. '),(41913,73,5,6055,'Blanco Panor 60 PuraPlus Inset Ceramic Kitchen Sink'),(41914,73,0,6055,'Blanco Panor 60 PuraPlus Inset Ceramic Kitchen Sink'),(41915,109,5,6055,'Blanco Panor 60 PuraPlus Inset Ceramic Kitchen Sink'),(41916,109,0,6055,'Blanco Panor 60 PuraPlus Inset Ceramic Kitchen Sink'),(41917,121,5,6056,'blanco-rondo-sol-if-stainless-steel-inset-kitchen-sink-514647'),(41918,121,0,6056,'blanco-rondo-sol-if-stainless-steel-inset-kitchen-sink-514647'),(41919,84,5,6056,'Blanco Rondo Sol-IF BL467027 Stainless Steel Kitchen Sink | Banyo UK'),(41920,84,0,6056,'Blanco Rondo Sol-IF BL467027 Stainless Steel Kitchen Sink | Banyo UK'),(41921,86,5,6056,'Banyo offers Blanco Rondo Sol-IF Inset Stainless Steel Kitchen Sink - Rondo Sol-IF S/ST with Great Discounts and Manufacturer\'s Guarantee. avail fastest delivery services across UK only from banyo.'),(41922,86,0,6056,'Banyo offers Blanco Rondo Sol-IF Inset Stainless Steel Kitchen Sink - Rondo Sol-IF S/ST with Great Discounts and Manufacturer\'s Guarantee. avail fastest delivery services across UK only from banyo.'),(41923,73,5,6056,'Blanco Rondo Sol-IF Stainless Steel Inset Kitchen Sink - 514647'),(41924,73,0,6056,'Blanco Rondo Sol-IF Stainless Steel Inset Kitchen Sink - 514647'),(41925,109,5,6056,'Blanco Rondo Sol-IF Stainless Steel Inset Kitchen Sink - 514647'),(41926,109,0,6056,'Blanco Rondo Sol-IF Stainless Steel Inset Kitchen Sink - 514647'),(41927,121,5,6057,'blanco-belfast-undermount-ceramic-kitchen-sink-518497'),(41928,121,0,6057,'blanco-belfast-undermount-ceramic-kitchen-sink-518497'),(41929,84,5,6057,'Blanco Belfast Ceramic Undermount Sink - BL468008 - Large Bowl | Banyo'),(41930,84,0,6057,'Blanco Belfast Ceramic Undermount Sink - BL468008 - Large Bowl | Banyo'),(41931,86,5,6057,'Blanco Belfast Undermount Ceramic Kitchen Sink - BL468008'),(41932,86,0,6057,'Blanco Belfast Undermount Ceramic Kitchen Sink - BL468008'),(41933,73,5,6057,'Blanco Belfast Undermount Ceramic Kitchen Sink - BL468008'),(41934,73,0,6057,'Blanco Belfast Undermount Ceramic Kitchen Sink - BL468008'),(41935,109,5,6057,'Blanco Belfast Undermount Ceramic Kitchen Sink - BL468008'),(41936,109,0,6057,'Blanco Belfast Undermount Ceramic Kitchen Sink - BL468008'),(41937,121,5,6058,'blanco-zerox-500-u-durinox-stainless-steel-undermount-sink'),(41938,121,0,6058,'blanco-zerox-500-u-durinox-stainless-steel-undermount-sink'),(41939,84,5,6058,'Blanco ZEROX 500-U Durinox Stainless Steel Undermount Sink'),(41940,84,0,6058,'Blanco ZEROX 500-U Durinox Stainless Steel Undermount Sink'),(41941,86,5,6058,'Blanco ZEROX 500-U Durinox is a Stainless Steel Undermount Kitchen Sink with Matt velvet looks with a homogeneous surface structure and pleasantly warm to the touch. For best prices visit Banyo.co.uk.'),(41942,86,0,6058,'Blanco ZEROX 500-U Durinox is a Stainless Steel Undermount Kitchen Sink with Matt velvet looks with a homogeneous surface structure and pleasantly warm to the touch. For best prices visit Banyo.co.uk.'),(41943,73,5,6058,'Blanco ZEROX 500-U Durinox Stainless Steel Undermount Sink'),(41944,73,0,6058,'Blanco ZEROX 500-U Durinox Stainless Steel Undermount Sink'),(41945,109,5,6058,'Blanco ZEROX 500-U Durinox Stainless Steel Undermount Sink'),(41946,109,0,6058,'Blanco ZEROX 500-U Durinox Stainless Steel Undermount Sink'),(41947,121,5,6059,'blanco-zerox-700-u-durinoxr-stainless-steel-undermount-sink'),(41948,121,0,6059,'blanco-zerox-700-u-durinoxr-stainless-steel-undermount-sink'),(41949,84,5,6059,'Blanco ZEROX 700-U Durinox® Stainless Steel Undermount Sink'),(41950,84,0,6059,'Blanco ZEROX 700-U Durinox® Stainless Steel Undermount Sink'),(41951,86,5,6059,'Blanco ZEROX 700-U Durinox is a Stainless Steel Sink with Zero Radius Bowl and Highly resistant to scratches. For best online prices on high quality kitchen sinks in UK visit Banyo.co.uk.'),(41952,86,0,6059,'Blanco ZEROX 700-U Durinox is a Stainless Steel Sink with Zero Radius Bowl and Highly resistant to scratches. For best online prices on high quality kitchen sinks in UK visit Banyo.co.uk.'),(41953,73,5,6059,'Blanco ZEROX 700-U DurinoxÂ® Stainless Steel Undermount Sink'),(41954,73,0,6059,'Blanco ZEROX 700-U DurinoxÂ® Stainless Steel Undermount Sink'),(41955,109,5,6059,'Blanco ZEROX 700-U Durinox® Stainless Steel Undermount Sink'),(41956,109,0,6059,'Blanco ZEROX 700-U Durinox® Stainless Steel Undermount Sink'),(41957,121,5,6060,'blanco-claron-180-u-undermount-0-5-bowl-sink-521565'),(41958,121,0,6060,'blanco-claron-180-u-undermount-0-5-bowl-sink-521565'),(41959,84,5,6060,'Blanco Claron 180-U Undermount Stainless Steel Kitchen Sink | Banyo.co.uk'),(41960,84,0,6060,'Blanco Claron 180-U Undermount Stainless Steel Kitchen Sink | Banyo.co.uk'),(41961,86,5,6060,'Blanco Claron 180-U Undermount Sink BL467689 designs are so clean and the taps so elegant your kitchen sink becomes amazing you will never want to discard.'),(41962,86,0,6060,'Blanco Claron 180-U Undermount Sink BL467689 designs are so clean and the taps so elegant your kitchen sink becomes amazing you will never want to discard.'),(41963,73,5,6060,'Blanco Claron 180-U Undermount 0.5 Bowl Sink - 521565'),(41964,73,0,6060,'Blanco Claron 180-U Undermount 0.5 Bowl Sink - 521565'),(41965,109,5,6060,'Blanco Claron 180-U Undermount 0.5 Bowl Sink - 521565'),(41966,109,0,6060,'Blanco Claron 180-U Undermount 0.5 Bowl Sink - 521565'),(41967,121,5,6061,'blanco-claron-340-u-undermount-sink-bl467690'),(41968,121,0,6061,'blanco-claron-340-u-undermount-sink-bl467690'),(41969,84,5,6061,'Blanco Claron 340-U Undermount Stainless Steel Kitchen Sink | Banyo'),(41970,84,0,6061,'Blanco Claron 340-U Undermount Stainless Steel Kitchen Sink | Banyo'),(41971,86,5,6061,'Blanco Claron 340U Undermount Sink offers a Perfect design and functionality. Super discount offer, the more products you buy, the more we can discount.'),(41972,86,0,6061,'Blanco Claron 340U Undermount Sink offers a Perfect design and functionality. Super discount offer, the more products you buy, the more we can discount.'),(41973,73,5,6061,'Blanco Claron 340-U Undermount Sink - 521571'),(41974,73,0,6061,'Blanco Claron 340-U Undermount Sink - 521571'),(41975,109,5,6061,'Blanco Claron 340-U Undermount Sink - 521571'),(41976,109,0,6061,'Blanco Claron 340-U Undermount Sink - 521571'),(41977,121,5,6062,'blanco-claron-400-u-undermount-sink-bl467691'),(41978,121,0,6062,'blanco-claron-400-u-undermount-sink-bl467691'),(41979,84,5,6062,'Blanco Claron 400-U Undermount Stainless Steel Kitchen Sink | Banyo'),(41980,84,0,6062,'Blanco Claron 400-U Undermount Stainless Steel Kitchen Sink | Banyo'),(41981,86,5,6062,'Blanco Claron 400-U Undermount Sink BL467691 will blend with modern beautiful kitchen environment available on reasonable at banyo.Banyo has the perfect combination of style, price and function. '),(41982,86,0,6062,'Blanco Claron 400-U Undermount Sink BL467691 will blend with modern beautiful kitchen environment available on reasonable at banyo.Banyo has the perfect combination of style, price and function. '),(41983,73,5,6062,'Blanco Claron 400-U Undermount Sink - BL467691'),(41984,73,0,6062,'Blanco Claron 400-U Undermount Sink - BL467691'),(41985,109,5,6062,'Blanco Claron 400-U Undermount Sink - BL467691'),(41986,109,0,6062,'Blanco Claron 400-U Undermount Sink - BL467691'),(41987,121,5,6063,'blanco-claron-450-u-undermount-sink-521575'),(41988,121,0,6063,'blanco-claron-450-u-undermount-sink-521575'),(41989,84,5,6063,'Blanco Claron 450-U Undermount Stainless Steel Kitchen Sink | Banyo UK'),(41990,84,0,6063,'Blanco Claron 450-U Undermount Stainless Steel Kitchen Sink | Banyo UK'),(41991,86,5,6063,'Blanco Claron 450-U Undermount Sink BL467692 are made from high quality material which will never rust,a high quality sink ensure long lasting and intense looking too.'),(41992,86,0,6063,'Blanco Claron 450-U Undermount Sink BL467692 are made from high quality material which will never rust,a high quality sink ensure long lasting and intense looking too.'),(41993,73,5,6063,'Blanco Claron 450-U Undermount Sink - 521575'),(41994,73,0,6063,'Blanco Claron 450-U Undermount Sink - 521575'),(41995,109,5,6063,'Blanco Claron 450-U Undermount Sink - 521575'),(41996,109,0,6063,'Blanco Claron 450-U Undermount Sink - 521575'),(41997,121,5,6064,'blanco-claron-500-if-inset-kitchen-sink-521576'),(41998,121,0,6064,'blanco-claron-500-if-inset-kitchen-sink-521576'),(41999,84,5,6064,'Blanco Claron 500-IF Insert Stainless Steel Kitchen Sink | Banyo.co.uk'),(42000,84,0,6064,'Blanco Claron 500-IF Insert Stainless Steel Kitchen Sink | Banyo.co.uk'),(42001,86,5,6064,'Blanco BL467656 Claron 500-IF Insert Kitchen Sink is good sized kitchen sink bowl designed for insetting into your worktop. This stylish Blanco sink has the size and versatility to suit any kitchen.'),(42002,86,0,6064,'Blanco BL467656 Claron 500-IF Insert Kitchen Sink is good sized kitchen sink bowl designed for insetting into your worktop. This stylish Blanco sink has the size and versatility to suit any kitchen.'),(42003,73,5,6064,'Blanco Claron 500-IF Inset Kitchen Sink - BL467656'),(42004,73,0,6064,'Blanco Claron 500-IF Inset Kitchen Sink - BL467656'),(42005,109,5,6064,'Blanco Claron 500-IF Inset Kitchen Sink - BL467656'),(42006,109,0,6064,'Blanco Claron 500-IF Inset Kitchen Sink - BL467656'),(42007,121,5,6065,'blanco-claron-500-u-undermount-sink-bl467693'),(42008,121,0,6065,'blanco-claron-500-u-undermount-sink-bl467693'),(42009,84,5,6065,'Blanco Claron 500-U 1.0 Bowl Undermount Stainless Steel Sink | Banyo'),(42010,84,0,6065,'Blanco Claron 500-U 1.0 Bowl Undermount Stainless Steel Sink | Banyo'),(42011,86,5,6065,'Claron 500-U Undermount Sink BL467693 manufactured by Blanco from the finest raw materials (stainless steel) represents excellent value for money. This stylish Undermount Blanco sink has the size and versatility to suit any kitchen.'),(42012,86,0,6065,'Claron 500-U Undermount Sink BL467693 manufactured by Blanco from the finest raw materials (stainless steel) represents excellent value for money. This stylish Undermount Blanco sink has the size and versatility to suit any kitchen.'),(42013,73,5,6065,'Blanco Claron 500-U Undermount Sink - 521577'),(42014,73,0,6065,'Blanco Claron 500-U Undermount Sink - 521577'),(42015,109,5,6065,'Blanco Claron 500-U Undermount Sink - 521577'),(42016,109,0,6065,'Blanco Claron 500-U Undermount Sink - 521577'),(42017,121,5,6066,'blanco-claron-700-if-inset-kitchen-sink-521580'),(42018,121,0,6066,'blanco-claron-700-if-inset-kitchen-sink-521580'),(42019,84,5,6066,'Blanco Claron 700-IF Insert Stainless Steel Kitchen Sink BL467659 | Banyo'),(42020,84,0,6066,'Blanco Claron 700-IF Insert Stainless Steel Kitchen Sink BL467659 | Banyo'),(42021,86,5,6066,'Blanco BL467659 Claron 700-IF Insert Kitchen Sink with its simple design has so much to offer. Simple but generous bowls in a variety of configurations bring the luxury feel to the kitchen. '),(42022,86,0,6066,'Blanco BL467659 Claron 700-IF Insert Kitchen Sink with its simple design has so much to offer. Simple but generous bowls in a variety of configurations bring the luxury feel to the kitchen. '),(42023,73,5,6066,'Blanco Claron 700-IF Inset Kitchen Sink - 521580'),(42024,73,0,6066,'Blanco Claron 700-IF Inset Kitchen Sink - 521580'),(42025,109,5,6066,'Blanco Claron 700-IF Inset Kitchen Sink - 521580'),(42026,109,0,6066,'Blanco Claron 700-IF Inset Kitchen Sink - 521580'),(42027,121,5,6067,'blanco-claron-700-u-undermount-sink-bl467695'),(42028,121,0,6067,'blanco-claron-700-u-undermount-sink-bl467695'),(42029,84,5,6067,'Blanco Claron 700-U Undermount Stainless Steel Sink BL467695 | Banyo UK'),(42030,84,0,6067,'Blanco Claron 700-U Undermount Stainless Steel Sink BL467695 | Banyo UK'),(42031,86,5,6067,'Blanco BL467695 Claron 700-U Undermount Sink features a classic design and durability. BLANCO sinks are supported by a limited lifetime warranty.We bet that the kitchen looks great with this lovely sink.'),(42032,86,0,6067,'Blanco BL467695 Claron 700-U Undermount Sink features a classic design and durability. BLANCO sinks are supported by a limited lifetime warranty.We bet that the kitchen looks great with this lovely sink.'),(42033,73,5,6067,'Blanco Claron 700-U Undermount Sink - 521581'),(42034,73,0,6067,'Blanco Claron 700-U Undermount Sink - 521581'),(42035,109,5,6067,'Blanco Claron 700-U Undermount Sink - 521581'),(42036,109,0,6067,'Blanco Claron 700-U Undermount Sink - 521581'),(42037,121,5,6068,'blanco-zerox-500-u-undermount-sink-521589'),(42038,121,0,6068,'blanco-zerox-500-u-undermount-sink-521589'),(42039,84,5,6068,'Blanco Zerox 500-U Undermount Sink BL467707 - 1.0 Bowl | Banyo.co.uk'),(42040,84,0,6068,'Blanco Zerox 500-U Undermount Sink BL467707 - 1.0 Bowl | Banyo.co.uk'),(42041,86,5,6068,'Blanco Zerox 500-U Undermount Sink BL467707 traditional and advanced design available in a wide variety range, at truly unbeatable prices. '),(42042,86,0,6068,'Blanco Zerox 500-U Undermount Sink BL467707 traditional and advanced design available in a wide variety range, at truly unbeatable prices. '),(42043,73,5,6068,'Blanco Zerox 500-U Undermount Sink - 521589'),(42044,73,0,6068,'Blanco Zerox 500-U Undermount Sink - 521589'),(42045,109,5,6068,'Blanco Zerox 500-U Undermount Sink - 521589'),(42046,109,0,6068,'Blanco Zerox 500-U Undermount Sink - 521589'),(42047,121,5,6069,'blanco-zerox-550-u-undermount-sink-521591'),(42048,121,0,6069,'blanco-zerox-550-u-undermount-sink-521591'),(42049,84,5,6069,'Blanco Zerox 550-U Undermount Sink BL467708 - 1.0 Large Bowl | Banyo'),(42050,84,0,6069,'Blanco Zerox 550-U Undermount Sink BL467708 - 1.0 Large Bowl | Banyo'),(42051,86,5,6069,'Buy Cheap Blanco Zerox 550-U Undermount Sink BL467708 at banyo.Buy a Blanco brand sink from Banyo, guaranteed it will never let you down.'),(42052,86,0,6069,'Buy Cheap Blanco Zerox 550-U Undermount Sink BL467708 at banyo.Buy a Blanco brand sink from Banyo, guaranteed it will never let you down.'),(42053,73,5,6069,'Blanco Zerox 550-U Undermount Sink - 521591'),(42054,73,0,6069,'Blanco Zerox 550-U Undermount Sink - 521591'),(42055,109,5,6069,'Blanco Zerox 550-U Undermount Sink - 521591'),(42056,109,0,6069,'Blanco Zerox 550-U Undermount Sink - 521591'),(42057,121,5,6070,'blanco-zerox-700-u-stainless-steel-undermount-kitchen-sink'),(42058,121,0,6070,'blanco-zerox-700-u-stainless-steel-undermount-kitchen-sink'),(42059,73,5,6070,'Blanco Zerox 700-U Stainless Steel Undermount Kitchen Sink'),(42060,73,0,6070,'Blanco Zerox 700-U Stainless Steel Undermount Kitchen Sink'),(42061,109,5,6070,'blanco-zerox-700-U-521593'),(42062,109,0,6070,'blanco-zerox-700-U-521593'),(42063,110,5,6070,'blanco-zerox-700-U-521593'),(42064,110,0,6070,'blanco-zerox-700-U-521593'),(42065,111,5,6070,'blanco-zerox-700-U-521593'),(42066,111,0,6070,'blanco-zerox-700-U-521593'),(42067,121,5,6071,'blanco-claron-400-400-u-stainless-steel-undermount-kitchen-sink'),(42068,121,0,6071,'blanco-claron-400-400-u-stainless-steel-undermount-kitchen-sink'),(42069,84,5,6071,'Blanco CLARON 400/400-U Stainless Steel Undermount Kitchen Sink'),(42070,84,0,6071,'Blanco CLARON 400/400-U Stainless Steel Undermount Kitchen Sink'),(42071,86,5,6071,'Blanco CLARON 400/400-U Stainless Steel Undermount Kitchen Sink'),(42072,86,0,6071,'Blanco CLARON 400/400-U Stainless Steel Undermount Kitchen Sink'),(42073,73,5,6071,'Blanco CLARON 400/400-U Stainless Steel Undermount Kitchen Sink'),(42074,73,0,6071,'Blanco CLARON 400/400-U Stainless Steel Undermount Kitchen Sink'),(42075,109,5,6071,'Blanco CLARON 400/400-U Stainless Steel Undermount Kitchen Sink'),(42076,109,0,6071,'Blanco CLARON 400/400-U Stainless Steel Undermount Kitchen Sink'),(42077,110,5,6071,'Blanco CLARON 400/400-U Stainless Steel Undermount Kitchen Sink'),(42078,110,0,6071,'Blanco CLARON 400/400-U Stainless Steel Undermount Kitchen Sink'),(42079,111,5,6071,'Blanco CLARON 400/400-U Stainless Steel Undermount Kitchen Sink'),(42080,111,0,6071,'Blanco CLARON 400/400-U Stainless Steel Undermount Kitchen Sink'),(42081,121,5,6072,'blanco-etagon-500-if-a-stainless-steel-inset-sink'),(42082,121,0,6072,'blanco-etagon-500-if-a-stainless-steel-inset-sink'),(42083,84,5,6072,'Blanco ETAGON 500 IF/A 1.0 Bowl Stainless Steel Inset Sink | Banyo'),(42084,84,0,6072,'Blanco ETAGON 500 IF/A 1.0 Bowl Stainless Steel Inset Sink | Banyo'),(42085,86,5,6072,'Buy Blanco ETAGON 500 IF/A Stainless Steel Inset Sink from Banyo with the lowest price offer in the UK. We offer a wide range of Blanco Stainless Steel Kitchen Sinks with Single Bowl Configuration.'),(42086,86,0,6072,'Buy Blanco ETAGON 500 IF/A Stainless Steel Inset Sink from Banyo with the lowest price offer in the UK. We offer a wide range of Blanco Stainless Steel Kitchen Sinks with Single Bowl Configuration.'),(42087,73,5,6072,'Blanco ETAGON 500 IF/A Stainless Steel Inset Sink'),(42088,73,0,6072,'Blanco ETAGON 500 IF/A Stainless Steel Inset Sink'),(42089,109,5,6072,'Blanco ETAGON 500 IF/A Stainless Steel Inset Sink'),(42090,109,0,6072,'Blanco ETAGON 500 IF/A Stainless Steel Inset Sink'),(42091,121,5,6073,'blanco-etagon-500-if-stainless-steel-inset-sink'),(42092,121,0,6073,'blanco-etagon-500-if-stainless-steel-inset-sink'),(42093,84,5,6073,'Blanco ETAGON 500-IF 1.0 Bowl Stainless Steel Inset Sink | Banyo'),(42094,84,0,6073,'Blanco ETAGON 500-IF 1.0 Bowl Stainless Steel Inset Sink | Banyo'),(42095,86,5,6073,'Blanco ETAGON 500-IF Stainless Steel Inset Sink'),(42096,86,0,6073,'Blanco ETAGON 500-IF Stainless Steel Inset Sink'),(42097,73,5,6073,'Blanco ETAGON 500-IF Stainless Steel Inset Sink'),(42098,73,0,6073,'Blanco ETAGON 500-IF Stainless Steel Inset Sink'),(42099,109,5,6073,'Blanco ETAGON 500-IF Stainless Steel Inset Sink'),(42100,109,0,6073,'Blanco ETAGON 500-IF Stainless Steel Inset Sink'),(42101,121,5,6074,'blanco-etagon-500-u-stainless-steel-undermount-kitchen-sink'),(42102,121,0,6074,'blanco-etagon-500-u-stainless-steel-undermount-kitchen-sink'),(42103,73,5,6074,'Blanco Etagon 500-U Stainless Steel Undermount Kitchen Sink'),(42104,73,0,6074,'Blanco Etagon 500-U Stainless Steel Undermount Kitchen Sink'),(42105,109,5,6074,'blanco-etagon-500-U-521841'),(42106,109,0,6074,'blanco-etagon-500-U-521841'),(42107,110,5,6074,'blanco-etagon-500-U-521841'),(42108,110,0,6074,'blanco-etagon-500-U-521841'),(42109,111,5,6074,'blanco-etagon-500-U-521841'),(42110,111,0,6074,'blanco-etagon-500-U-521841'),(42111,121,5,6075,'blanco-axis-iii-5-s-if-stainless-steel-inset-sink'),(42112,121,0,6075,'blanco-axis-iii-5-s-if-stainless-steel-inset-sink'),(42113,84,5,6075,'Blanco Axis III 5 S-IF Stainless Steel Inset Sink'),(42114,84,0,6075,'Blanco Axis III 5 S-IF Stainless Steel Inset Sink'),(42115,86,5,6075,'Blanco Axis III 5 S-IF Stainless Steel Inset Sink'),(42116,86,0,6075,'Blanco Axis III 5 S-IF Stainless Steel Inset Sink'),(42117,73,5,6075,'Blanco Axis III 5 S-IF Stainless Steel Inset Sink'),(42118,73,0,6075,'Blanco Axis III 5 S-IF Stainless Steel Inset Sink'),(42119,109,5,6075,'Blanco Axis III 5 S-IF Stainless Steel Inset Sink'),(42120,109,0,6075,'Blanco Axis III 5 S-IF Stainless Steel Inset Sink'),(42121,121,5,6076,'blanco-andano-180-if-inset-stainless-steel-kitchen-sink'),(42122,121,0,6076,'blanco-andano-180-if-inset-stainless-steel-kitchen-sink'),(42123,84,5,6076,'Blanco Andano 180-IF Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42124,84,0,6076,'Blanco Andano 180-IF Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42125,86,5,6076,'Blanco Andano 180-IF Inset Kitchen Sink BL 518 303 comes in stainless steel is a unique composition of optical and functional elements creates a modern contemporary look in your home.'),(42126,86,0,6076,'Blanco Andano 180-IF Inset Kitchen Sink BL 518 303 comes in stainless steel is a unique composition of optical and functional elements creates a modern contemporary look in your home.'),(42127,73,5,6076,'Blanco Andano 180-IF Half Bowl Inset Kitchen Sink'),(42128,73,0,6076,'Blanco Andano 180-IF Half Bowl Inset Kitchen Sink'),(42129,109,5,6076,'Blanco Andano 180-IF Half Bowl Inset Kitchen Sink'),(42130,109,0,6076,'Blanco Andano 180-IF Half Bowl Inset Kitchen Sink'),(42131,121,5,6077,'blanco-andano-180-u-undermount-stainless-steel-kitchen-sink'),(42132,121,0,6077,'blanco-andano-180-u-undermount-stainless-steel-kitchen-sink'),(42133,84,5,6077,'Blanco Andano 180-U Undermount Stainless Steel Kitchen Sink - Banyo'),(42134,84,0,6077,'Blanco Andano 180-U Undermount Stainless Steel Kitchen Sink - Banyo'),(42135,86,5,6077,'Replacing a kitchen sink with a new one or fitting a new sink, Blanco Andano 180-U Undermount Stainless Steel Kitchen Sink BL 518 301 is ideal choice and surprisingly an easy project . '),(42136,86,0,6077,'Replacing a kitchen sink with a new one or fitting a new sink, Blanco Andano 180-U Undermount Stainless Steel Kitchen Sink BL 518 301 is ideal choice and surprisingly an easy project . '),(42137,73,5,6077,'Blanco Andano 180-U Undermount Half Bowl Kitchen Sink'),(42138,73,0,6077,'Blanco Andano 180-U Undermount Half Bowl Kitchen Sink'),(42139,109,5,6077,'Blanco Andano 180-U Undermount Half Bowl Kitchen Sink'),(42140,109,0,6077,'Blanco Andano 180-U Undermount Half Bowl Kitchen Sink'),(42141,121,5,6078,'blanco-andano-340-if-inset-stainless-steel-kitchen-sink'),(42142,121,0,6078,'blanco-andano-340-if-inset-stainless-steel-kitchen-sink'),(42143,84,5,6078,'Blanco Andano 340-IF Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42144,84,0,6078,'Blanco Andano 340-IF Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42145,86,5,6078,'Blanco Andano 340-IF Inset Stainless Steel Kitchen Sink BL 518 307 features a classic design and affordability. BLANCO sinks are supported by a limited lifetime warranty.'),(42146,86,0,6078,'Blanco Andano 340-IF Inset Stainless Steel Kitchen Sink BL 518 307 features a classic design and affordability. BLANCO sinks are supported by a limited lifetime warranty.'),(42147,73,5,6078,'Blanco Andano 340-IF Stainless Steel Inset Kitchen Sink'),(42148,73,0,6078,'Blanco Andano 340-IF Stainless Steel Inset Kitchen Sink'),(42149,109,5,6078,'Blanco Andano 340-IF Stainless Steel Inset Kitchen Sink'),(42150,109,0,6078,'Blanco Andano 340-IF Stainless Steel Inset Kitchen Sink'),(42151,121,5,6079,'blanco-andano-340-u-undermount-stainless-steel-kitchen-sink-bl-518-305'),(42152,121,0,6079,'blanco-andano-340-u-undermount-stainless-steel-kitchen-sink-bl-518-305'),(42153,84,5,6079,'Blanco Andano 340-U Undermount Stainless Steel Kitchen Sink | Banyo.co.uk'),(42154,84,0,6079,'Blanco Andano 340-U Undermount Stainless Steel Kitchen Sink | Banyo.co.uk'),(42155,86,5,6079,'With Blanco Andano 340-U Undermount BL 518 305 Stainless Steel Kitchen Sink, you can create a customized look in your kitchen that reflects your personal style.'),(42156,86,0,6079,'With Blanco Andano 340-U Undermount BL 518 305 Stainless Steel Kitchen Sink, you can create a customized look in your kitchen that reflects your personal style.'),(42157,73,5,6079,'Blanco Andano 340-U Undermount Stainless Steel Kitchen Sink'),(42158,73,0,6079,'Blanco Andano 340-U Undermount Stainless Steel Kitchen Sink'),(42159,109,5,6079,'Blanco Andano 340-U Undermount Stainless Steel Kitchen Sink'),(42160,109,0,6079,'Blanco Andano 340-U Undermount Stainless Steel Kitchen Sink'),(42161,121,5,6080,'blanco-andano-400-if-inset-stainless-steel-kitchen-sink'),(42162,121,0,6080,'blanco-andano-400-if-inset-stainless-steel-kitchen-sink'),(42163,84,5,6080,'Blanco Andano 400-IF Undermount 1.0 Bowl Stainless Steel Sink | Banyo'),(42164,84,0,6080,'Blanco Andano 400-IF Undermount 1.0 Bowl Stainless Steel Sink | Banyo'),(42165,86,5,6080,'Blanco Andano 400-IF Undermount Stainless Steel Kitchen Sink '),(42166,86,0,6080,'Blanco Andano 400-IF Undermount Stainless Steel Kitchen Sink '),(42167,73,5,6080,'Blanco Andano 400-IF Stainless Steel Inset Kitchen Sink '),(42168,73,0,6080,'Blanco Andano 400-IF Stainless Steel Inset Kitchen Sink '),(42169,109,5,6080,'Blanco Andano 400-IF Stainless Steel Inset Kitchen Sink '),(42170,109,0,6080,'Blanco Andano 400-IF Stainless Steel Inset Kitchen Sink '),(42171,121,5,6081,'blanco-andano-400-u-undermount-stainless-steel-kitchen-sink'),(42172,121,0,6081,'blanco-andano-400-u-undermount-stainless-steel-kitchen-sink'),(42173,84,5,6081,'Blanco Andano 400-U Undermount Stainless Steel Kitchen Sink | Banyo.co.uk'),(42174,84,0,6081,'Blanco Andano 400-U Undermount Stainless Steel Kitchen Sink | Banyo.co.uk'),(42175,86,5,6081,'Blanco Andano 400-U Undermount Stainless Steel Kitchen Sink BL 518 309 is a contemporary bowl, so works particularly well in a modern, geometric kitchen design.'),(42176,86,0,6081,'Blanco Andano 400-U Undermount Stainless Steel Kitchen Sink BL 518 309 is a contemporary bowl, so works particularly well in a modern, geometric kitchen design.'),(42177,73,5,6081,'Blanco Andano 400-U Undermount Stainless Steel Kitchen Sink'),(42178,73,0,6081,'Blanco Andano 400-U Undermount Stainless Steel Kitchen Sink'),(42179,109,5,6081,'Blanco Andano 400-U Undermount Stainless Steel Kitchen Sink'),(42180,109,0,6081,'Blanco Andano 400-U Undermount Stainless Steel Kitchen Sink'),(42181,121,5,6082,'blanco-andano-450-if-inset-stainless-steel-kitchen-sink-bl-519-375'),(42182,121,0,6082,'blanco-andano-450-if-inset-stainless-steel-kitchen-sink-bl-519-375'),(42183,84,5,6082,'Blanco Andano 450-IF Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42184,84,0,6082,'Blanco Andano 450-IF Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42185,86,5,6082,'Featuring the best in European design, Blanco BL 519 375 Andano 450-IF Inset Stainless Steel Kitchen Sink will make an impressive addition to your kitchen decoration. '),(42186,86,0,6082,'Featuring the best in European design, Blanco BL 519 375 Andano 450-IF Inset Stainless Steel Kitchen Sink will make an impressive addition to your kitchen decoration. '),(42187,73,5,6082,'Blanco Andano 450-IF Stainless Steel Inset Kitchen Sink'),(42188,73,0,6082,'Blanco Andano 450-IF Stainless Steel Inset Kitchen Sink'),(42189,109,5,6082,'Blanco Andano 450-IF Stainless Steel Inset Kitchen Sink'),(42190,109,0,6082,'Blanco Andano 450-IF Stainless Steel Inset Kitchen Sink'),(42191,121,5,6083,'blanco-andano-450-u-undermount-stainless-steel-kitchen-sink'),(42192,121,0,6083,'blanco-andano-450-u-undermount-stainless-steel-kitchen-sink'),(42193,84,5,6083,'Blanco Andano 450-U Undermount Stainless Steel Kitchen Sink | Banyo.co.uk'),(42194,84,0,6083,'Blanco Andano 450-U Undermount Stainless Steel Kitchen Sink | Banyo.co.uk'),(42195,86,5,6083,'Blanco Andano 450-U Undermount Stainless Steel Kitchen Sink BL 519 373 is modern in appearance and will complement with other appliances.Banyo has the perfect combination of style, price and function. '),(42196,86,0,6083,'Blanco Andano 450-U Undermount Stainless Steel Kitchen Sink BL 519 373 is modern in appearance and will complement with other appliances.Banyo has the perfect combination of style, price and function. '),(42197,73,5,6083,'Blanco Andano 450-U Undermount Stainless Steel Kitchen Sink'),(42198,73,0,6083,'Blanco Andano 450-U Undermount Stainless Steel Kitchen Sink'),(42199,109,5,6083,'Blanco Andano 450-U Undermount Stainless Steel Kitchen Sink'),(42200,109,0,6083,'Blanco Andano 450-U Undermount Stainless Steel Kitchen Sink'),(42201,121,5,6084,'blanco-andano-500-if-inset-stainless-steel-kitchen-sink'),(42202,121,0,6084,'blanco-andano-500-if-inset-stainless-steel-kitchen-sink'),(42203,84,5,6084,'Blanco Andano 500-IF Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42204,84,0,6084,'Blanco Andano 500-IF Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42205,86,5,6084,'We have a huge range of contemporary Blanco Andano 500-IF Inset Stainless Steel Kitchen Sink BL 518 315, to match your home suites whatever the style, no matter it is modern or traditional.'),(42206,86,0,6084,'We have a huge range of contemporary Blanco Andano 500-IF Inset Stainless Steel Kitchen Sink BL 518 315, to match your home suites whatever the style, no matter it is modern or traditional.'),(42207,73,5,6084,'Blanco Andano 500-IF Stainless Steel Inset Kitchen Sink'),(42208,73,0,6084,'Blanco Andano 500-IF Stainless Steel Inset Kitchen Sink'),(42209,109,5,6084,'Blanco Andano 500-IF Stainless Steel Inset Kitchen Sink'),(42210,109,0,6084,'Blanco Andano 500-IF Stainless Steel Inset Kitchen Sink'),(42211,121,5,6085,'blanco-andano-500-u-undermount-stainless-steel-kitchen-sink'),(42212,121,0,6085,'blanco-andano-500-u-undermount-stainless-steel-kitchen-sink'),(42213,84,5,6085,'Blanco Andano 500-U Undermount Stainless Steel Kitchen Sink | Banyo.co.uk'),(42214,84,0,6085,'Blanco Andano 500-U Undermount Stainless Steel Kitchen Sink | Banyo.co.uk'),(42215,86,5,6085,'The Smart and Stylish Blanco Andano 500-U Undermount Stainless Steel Kitchen Sink BL 518 313 is ideal for your washing needs and would look great in any kitchen.'),(42216,86,0,6085,'The Smart and Stylish Blanco Andano 500-U Undermount Stainless Steel Kitchen Sink BL 518 313 is ideal for your washing needs and would look great in any kitchen.'),(42217,73,5,6085,'Blanco Andano 500-U Undermount Stainless Steel Kitchen Sink'),(42218,73,0,6085,'Blanco Andano 500-U Undermount Stainless Steel Kitchen Sink'),(42219,109,5,6085,'Blanco Andano 500-U Undermount Stainless Steel Kitchen Sink'),(42220,109,0,6085,'Blanco Andano 500-U Undermount Stainless Steel Kitchen Sink'),(42221,121,5,6086,'blanco-andano-700-if-inset-stainless-steel-kitchen-sink'),(42222,121,0,6086,'blanco-andano-700-if-inset-stainless-steel-kitchen-sink'),(42223,84,5,6086,'Blanco Andano 700-IF Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42224,84,0,6086,'Blanco Andano 700-IF Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42225,86,5,6086,'Blanco Andano 700-IF Inset Stainless Steel Kitchen Sink large enough to handle whatever dirty dishes you throw at it, it is an impressive unit, and would suit a large advanced kitchen. '),(42226,86,0,6086,'Blanco Andano 700-IF Inset Stainless Steel Kitchen Sink large enough to handle whatever dirty dishes you throw at it, it is an impressive unit, and would suit a large advanced kitchen. '),(42227,73,5,6086,'Blanco Andano 700-IF Stainless Steel Inset Kitchen Sink'),(42228,73,0,6086,'Blanco Andano 700-IF Stainless Steel Inset Kitchen Sink'),(42229,109,5,6086,'Blanco Andano 700-IF Stainless Steel Inset Kitchen Sink'),(42230,109,0,6086,'Blanco Andano 700-IF Stainless Steel Inset Kitchen Sink'),(42231,121,5,6087,'blanco-andano-700-u-undermount-stainless-steel-kitchen-sink'),(42232,121,0,6087,'blanco-andano-700-u-undermount-stainless-steel-kitchen-sink'),(42233,84,5,6087,'Blanco Andano 700-U Undermount Stainless Steel Kitchen Sink | Blanco.co.uk'),(42234,84,0,6087,'Blanco Andano 700-U Undermount Stainless Steel Kitchen Sink | Blanco.co.uk'),(42235,86,5,6087,'Blanco Andano 700-U Undermount Stainless Steel Kitchen BL 518 614 offers an excellent flexibility in the sink area. All our products are made from finest material to make them durable and attractive.'),(42236,86,0,6087,'Blanco Andano 700-U Undermount Stainless Steel Kitchen BL 518 614 offers an excellent flexibility in the sink area. All our products are made from finest material to make them durable and attractive.'),(42237,73,5,6087,'Blanco Andano 700-U Undermount Stainless Steel Kitchen Sink'),(42238,73,0,6087,'Blanco Andano 700-U Undermount Stainless Steel Kitchen Sink'),(42239,109,5,6087,'Blanco Andano 700-U Undermount Stainless Steel Kitchen Sink'),(42240,109,0,6087,'Blanco Andano 700-U Undermount Stainless Steel Kitchen Sink'),(42241,121,5,6088,'blanco-andano-340-340-u-undermount-stainless-steel-kitchen-sink'),(42242,121,0,6088,'blanco-andano-340-340-u-undermount-stainless-steel-kitchen-sink'),(42243,84,5,6088,'Blanco Andano 340/340-U Stainless Steel Undermount Kitchen Sink | Banyo'),(42244,84,0,6088,'Blanco Andano 340/340-U Stainless Steel Undermount Kitchen Sink | Banyo'),(42245,86,5,6088,'We have an excellent choice  of Blanco Andano 340/340-U Undermount Stainless Steel Kitchen Sinks here at banyo.Buy a Blanco brand sink from Banyo, guaranteed it will never let you down.'),(42246,86,0,6088,'We have an excellent choice  of Blanco Andano 340/340-U Undermount Stainless Steel Kitchen Sinks here at banyo.Buy a Blanco brand sink from Banyo, guaranteed it will never let you down.'),(42247,73,5,6088,'Blanco Andano 340/340-U Undermount Kitchen Sink '),(42248,73,0,6088,'Blanco Andano 340/340-U Undermount Kitchen Sink '),(42249,109,5,6088,'Blanco Andano 340/340'),(42250,109,0,6088,'Blanco Andano 340/340'),(42251,110,5,6088,'Blanco Andano 340/340'),(42252,110,0,6088,'Blanco Andano 340/340'),(42253,111,5,6088,'Blanco Andano 340/340'),(42254,111,0,6088,'Blanco Andano 340/340'),(42255,121,5,6089,'blanco-andano-400-400-if-inset-stainless-steel-kitchen-sink'),(42256,121,0,6089,'blanco-andano-400-400-if-inset-stainless-steel-kitchen-sink'),(42257,84,5,6089,'Blanco Andano 400/400-IF Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42258,84,0,6089,'Blanco Andano 400/400-IF Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42259,86,5,6089,'Experience the exceptional performance and immerse yourself in the simplicity, style and sophistication of Blanco Andano 400/400-IF Inset Kitchen Sink comes in premium Stainless Steel available at banyo.'),(42260,86,0,6089,'Experience the exceptional performance and immerse yourself in the simplicity, style and sophistication of Blanco Andano 400/400-IF Inset Kitchen Sink comes in premium Stainless Steel available at banyo.'),(42261,73,5,6089,'Blanco Andano 400/400-IF Stainless Steel Inset Kitchen Sink'),(42262,73,0,6089,'Blanco Andano 400/400-IF Stainless Steel Inset Kitchen Sink'),(42263,109,5,6089,'Blanco Andano 400/400-IF Stainless Steel Inset Kitchen Sink'),(42264,109,0,6089,'Blanco Andano 400/400-IF Stainless Steel Inset Kitchen Sink'),(42265,121,5,6090,'blanco-andano-400-400-u-stainless-steel-undermount-sink'),(42266,121,0,6090,'blanco-andano-400-400-u-stainless-steel-undermount-sink'),(42267,84,5,6090,'Blanco ANDANO 400/400-U Stainless Steel Undermount Sink | Banyo'),(42268,84,0,6090,'Blanco ANDANO 400/400-U Stainless Steel Undermount Sink | Banyo'),(42269,86,5,6090,'Buy Blanco ANDANO 400/400-U Stainless Steel Undermount Sink from Banyo with the lowest price offer in the UK. Andano 400/400U is compatible with a cabinet width of 90cm. This Double Bowl Sink is an ideal solution for a busy kitchen.'),(42270,86,0,6090,'Buy Blanco ANDANO 400/400-U Stainless Steel Undermount Sink from Banyo with the lowest price offer in the UK. Andano 400/400U is compatible with a cabinet width of 90cm. This Double Bowl Sink is an ideal solution for a busy kitchen.'),(42271,73,5,6090,'Blanco ANDANO 400/400-U Stainless Steel Undermount Sink'),(42272,73,0,6090,'Blanco ANDANO 400/400-U Stainless Steel Undermount Sink'),(42273,109,5,6090,'Blanco ANDANO 400/400-U Stainless Steel Undermount Sink'),(42274,109,0,6090,'Blanco ANDANO 400/400-U Stainless Steel Undermount Sink'),(42275,121,5,6091,'blanco-claron-500-u-durinox-stainless-steel-undermount-sink'),(42276,121,0,6091,'blanco-claron-500-u-durinox-stainless-steel-undermount-sink'),(42277,84,5,6091,'Blanco Claron 500-U Durinox&trade; Stainless Steel Undermount Sink'),(42278,84,0,6091,'Blanco Claron 500-U Durinox&trade; Stainless Steel Undermount Sink'),(42279,86,5,6091,'Blanco Claron 500-U Durinox&trade; Stainless Steel Undermount Sink'),(42280,86,0,6091,'Blanco Claron 500-U Durinox&trade; Stainless Steel Undermount Sink'),(42281,73,5,6091,'Blanco Claron 500-U Durinox Stainless Steel Undermount Sink'),(42282,73,0,6091,'Blanco Claron 500-U Durinox Stainless Steel Undermount Sink'),(42283,109,5,6091,'Blanco Claron 500-U Durinox Stainless Steel Undermount Sink'),(42284,109,0,6091,'Blanco Claron 500-U Durinox Stainless Steel Undermount Sink'),(42285,121,5,6092,'blanco-claron-700-u-durinox-stainless-steel-undermount-kitchen-sink'),(42286,121,0,6092,'blanco-claron-700-u-durinox-stainless-steel-undermount-kitchen-sink'),(42287,84,5,6092,'Blanco CLARON 700-U Durinox Stainless Steel Undermount Kitchen Sink'),(42288,84,0,6092,'Blanco CLARON 700-U Durinox Stainless Steel Undermount Kitchen Sink'),(42289,86,5,6092,'Blanco CLARON 700-U Durinox Stainless Steel Undermount Kitchen Sink'),(42290,86,0,6092,'Blanco CLARON 700-U Durinox Stainless Steel Undermount Kitchen Sink'),(42291,73,5,6092,'Blanco CLARON 700-U Durinox Stainless Steel Undermount Kitchen Sink'),(42292,73,0,6092,'Blanco CLARON 700-U Durinox Stainless Steel Undermount Kitchen Sink'),(42293,109,5,6092,'Blanco CLARON 700-U Durinox Stainless Steel Undermount Kitchen Sink'),(42294,109,0,6092,'Blanco CLARON 700-U Durinox Stainless Steel Undermount Kitchen Sink'),(42295,110,5,6092,'Blanco CLARON 700-U Durinox Stainless Steel Undermount Kitchen Sink'),(42296,110,0,6092,'Blanco CLARON 700-U Durinox Stainless Steel Undermount Kitchen Sink'),(42297,111,5,6092,'Blanco CLARON 700-U Durinox Stainless Steel Undermount Kitchen Sink'),(42298,111,0,6092,'Blanco CLARON 700-U Durinox Stainless Steel Undermount Kitchen Sink'),(42299,121,5,6093,'blanco-delta-if-inset-stainless-steel-kitchen-sink-rh-bowl'),(42300,121,0,6093,'blanco-delta-if-inset-stainless-steel-kitchen-sink-rh-bowl'),(42301,84,5,6093,'Blanco Delta-IF S/ST Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42302,84,0,6093,'Blanco Delta-IF S/ST Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42303,86,5,6093,'The Smart Blanco Delta-IF Inset Stainless Steel Kitchen Sink RH Bowl with advanced feature is ideal for any contemporary and modern kitchen setting.'),(42304,86,0,6093,'The Smart Blanco Delta-IF Inset Stainless Steel Kitchen Sink RH Bowl with advanced feature is ideal for any contemporary and modern kitchen setting.'),(42305,73,5,6093,'Blanco Delta-IF Stainless Steel Inset Kitchen Sink'),(42306,73,0,6093,'Blanco Delta-IF Stainless Steel Inset Kitchen Sink'),(42307,109,5,6093,'Blanco Delta-IF Stainless Steel Inset Kitchen Sink'),(42308,109,0,6093,'Blanco Delta-IF Stainless Steel Inset Kitchen Sink'),(42309,121,5,6094,'blanco-subline-375-u-undermount-ceramic-kitchen-sink'),(42310,121,0,6094,'blanco-subline-375-u-undermount-ceramic-kitchen-sink'),(42311,84,5,6094,'Blanco Subline 375-U Ceramic Undermount Kitchen Sink  | Banyo.co.uk'),(42312,84,0,6094,'Blanco Subline 375-U Ceramic Undermount Kitchen Sink  | Banyo.co.uk'),(42313,86,5,6094,'Blanco Subline 375-U Undermount Ceramic Kitchen Sink Creates a classy and contemporary look in kitchen suitesWe sell kitchen suites in a wide variety of styles and all at great value prices to make it both easy and affordable to find your dream kitchen su'),(42314,86,0,6094,'Blanco Subline 375-U Undermount Ceramic Kitchen Sink Creates a classy and contemporary look in kitchen suitesWe sell kitchen suites in a wide variety of styles and all at great value prices to make it both easy and affordable to find your dream kitchen su'),(42315,73,5,6094,'Blanco Subline 375-U Undermount Ceramic Kitchen Sink'),(42316,73,0,6094,'Blanco Subline 375-U Undermount Ceramic Kitchen Sink'),(42317,109,5,6094,'Blanco Subline 375-U Undermount Ceramic Kitchen Sink'),(42318,109,0,6094,'Blanco Subline 375-U Undermount Ceramic Kitchen Sink'),(42319,121,5,6095,'blanco-subline-500-u-undermount-ceramic-kitchen-sink'),(42320,121,0,6095,'blanco-subline-500-u-undermount-ceramic-kitchen-sink'),(42321,84,5,6095,'Blanco Subline 500-U Ceramic Undermount 1.0 Bowl Kitchen Sink | Banyo UK'),(42322,84,0,6095,'Blanco Subline 500-U Ceramic Undermount 1.0 Bowl Kitchen Sink | Banyo UK'),(42323,86,5,6095,'Get fantastic deals on Blanco Subline 500-U Undermount Ceramic Kitchen Sink from banyo.guaranteed we have the unbeatable prices'),(42324,86,0,6095,'Get fantastic deals on Blanco Subline 500-U Undermount Ceramic Kitchen Sink from banyo.guaranteed we have the unbeatable prices'),(42325,73,5,6095,'Blanco Subline 500-U Undermount Ceramic Kitchen Sink'),(42326,73,0,6095,'Blanco Subline 500-U Undermount Ceramic Kitchen Sink'),(42327,109,5,6095,'Blanco Subline 500-U Undermount Ceramic Kitchen Sink'),(42328,109,0,6095,'Blanco Subline 500-U Undermount Ceramic Kitchen Sink'),(42329,121,5,6096,'blanco-subline-350-150-u-undermount-ceramic-kitchen-sink'),(42330,121,0,6096,'blanco-subline-350-150-u-undermount-ceramic-kitchen-sink'),(42331,84,5,6096,'Blanco Subline 350/150-U Undermount Ceramic 1.5 Bowl Sink | Banyo UK'),(42332,84,0,6096,'Blanco Subline 350/150-U Undermount Ceramic 1.5 Bowl Sink | Banyo UK'),(42333,86,5,6096,'Banyo offers Blanco Subline 350/150-U Undermount Ceramic Kitchen Sink with Great Discounts and Manufacturer\'s Guarantee. To avail fastest delivery services across UK, visit banyo.co.uk'),(42334,86,0,6096,'Banyo offers Blanco Subline 350/150-U Undermount Ceramic Kitchen Sink with Great Discounts and Manufacturer\'s Guarantee. To avail fastest delivery services across UK, visit banyo.co.uk'),(42335,73,5,6096,'Blanco Subline 350/150-U Undermount Ceramic Kitchen Sink'),(42336,73,0,6096,'Blanco Subline 350/150-U Undermount Ceramic Kitchen Sink'),(42337,109,5,6096,'blanco_subline_350-150-u'),(42338,109,0,6096,'blanco_subline_350-150-u'),(42339,110,5,6096,'blanco_subline_350-150-u'),(42340,110,0,6096,'blanco_subline_350-150-u'),(42341,111,5,6096,'blanco_subline_350-150-u'),(42342,111,0,6096,'blanco_subline_350-150-u'),(42343,121,5,6097,'blanco-etagon-700-u-stainless-steel-undermount-kitchen-sink'),(42344,121,0,6097,'blanco-etagon-700-u-stainless-steel-undermount-kitchen-sink'),(42345,73,5,6097,'Blanco Etagon 700-U Stainless Steel Undermount Kitchen Sink'),(42346,73,0,6097,'Blanco Etagon 700-U Stainless Steel Undermount Kitchen Sink'),(42347,109,5,6097,'blanco-etagon-700-U-524270'),(42348,109,0,6097,'blanco-etagon-700-U-524270'),(42349,110,5,6097,'blanco-etagon-700-U-524270'),(42350,110,0,6097,'blanco-etagon-700-U-524270'),(42351,111,5,6097,'blanco-etagon-700-U-524270'),(42352,111,0,6097,'blanco-etagon-700-U-524270'),(42353,121,5,6098,'blanco-etagon-700-if-stainless-steel-inset-sink'),(42354,121,0,6098,'blanco-etagon-700-if-stainless-steel-inset-sink'),(42355,84,5,6098,'Blanco Etagon 700-IF Stainless Steel Inset Sink'),(42356,84,0,6098,'Blanco Etagon 700-IF Stainless Steel Inset Sink'),(42357,86,5,6098,'Blanco Etagon 700-IF Stainless Steel Inset Sink'),(42358,86,0,6098,'Blanco Etagon 700-IF Stainless Steel Inset Sink'),(42359,73,5,6098,'Blanco Etagon 700-IF Stainless Steel Inset Sink'),(42360,73,0,6098,'Blanco Etagon 700-IF Stainless Steel Inset Sink'),(42361,109,5,6098,'Blanco Etagon 700-IF Stainless Steel Inset Sink'),(42362,109,0,6098,'Blanco Etagon 700-IF Stainless Steel Inset Sink'),(42363,121,5,6099,'blanco-etagon-700-if-a-stainless-steel-inset-sink'),(42364,121,0,6099,'blanco-etagon-700-if-a-stainless-steel-inset-sink'),(42365,84,5,6099,'Blanco Etagon 700-IF/A Stainless Steel Inset Sink'),(42366,84,0,6099,'Blanco Etagon 700-IF/A Stainless Steel Inset Sink'),(42367,86,5,6099,'Buy Blanco Etagon 700-IF/A Stainless Steel Inset Sink from Banyo with the lowest price offer in the UK. Compatible with 800mm Cabinet width. We offer an extensive range of Blanco Stainless Steel Kitchen Sinks.\r\n'),(42368,86,0,6099,'Buy Blanco Etagon 700-IF/A Stainless Steel Inset Sink from Banyo with the lowest price offer in the UK. Compatible with 800mm Cabinet width. We offer an extensive range of Blanco Stainless Steel Kitchen Sinks.\r\n'),(42369,73,5,6099,'Blanco Etagon 700-IF/A Stainless Steel Inset Sink'),(42370,73,0,6099,'Blanco Etagon 700-IF/A Stainless Steel Inset Sink'),(42371,109,5,6099,'Blanco Etagon 700-IF/A Stainless Steel Inset Sink'),(42372,109,0,6099,'Blanco Etagon 700-IF/A Stainless Steel Inset Sink'),(42373,121,5,6100,'blanco-etagon-500-u-ceramic-undermount-sink-crystal-white'),(42374,121,0,6100,'blanco-etagon-500-u-ceramic-undermount-sink-crystal-white'),(42375,84,5,6100,'Blanco Etagon 500-U Ceramic Undermount Sink - Crystal White'),(42376,84,0,6100,'Blanco Etagon 500-U Ceramic Undermount Sink - Crystal White'),(42377,86,5,6100,'Blanco Etagon 500-U Ceramic Undermount Sink - Crystal White'),(42378,86,0,6100,'Blanco Etagon 500-U Ceramic Undermount Sink - Crystal White'),(42379,73,5,6100,'Blanco Etagon 500-U Ceramic Undermount Sink - Crystal White'),(42380,73,0,6100,'Blanco Etagon 500-U Ceramic Undermount Sink - Crystal White'),(42381,109,5,6100,'Blanco Etagon 500-U Ceramic Undermount Sink - Crystal White'),(42382,109,0,6100,'Blanco Etagon 500-U Ceramic Undermount Sink - Crystal White'),(42383,121,5,6101,'blanco-etagon-6-ceramic-inset-sink'),(42384,121,0,6101,'blanco-etagon-6-ceramic-inset-sink'),(42385,84,5,6101,'Blanco Etagon 6 Ceramic Inset Sink'),(42386,84,0,6101,'Blanco Etagon 6 Ceramic Inset Sink'),(42387,86,5,6101,'Blanco Etagon 6 Ceramic Inset Sink'),(42388,86,0,6101,'Blanco Etagon 6 Ceramic Inset Sink'),(42389,73,5,6101,'Blanco Etagon 6 Ceramic Inset Sink'),(42390,73,0,6101,'Blanco Etagon 6 Ceramic Inset Sink'),(42391,109,5,6101,'Blanco Etagon 6 Ceramic Inset Sink'),(42392,109,0,6101,'Blanco Etagon 6 Ceramic Inset Sink'),(42393,121,5,6102,'blanco-villae-farmhouse-single-ceramic-inset-sink'),(42394,121,0,6102,'blanco-villae-farmhouse-single-ceramic-inset-sink'),(42395,84,5,6102,'Blanco Villae Farmhouse Single Ceramic Inset Sink'),(42396,84,0,6102,'Blanco Villae Farmhouse Single Ceramic Inset Sink'),(42397,86,5,6102,'Blanco Villae Farmhouse Single Ceramic Inset Sink'),(42398,86,0,6102,'Blanco Villae Farmhouse Single Ceramic Inset Sink'),(42399,73,5,6102,'Blanco Villae Farmhouse Single Ceramic Inset Sink'),(42400,73,0,6102,'Blanco Villae Farmhouse Single Ceramic Inset Sink'),(42401,109,5,6102,'Blanco Villae Farmhouse Single Ceramic Inset Sink'),(42402,109,0,6102,'Blanco Villae Farmhouse Single Ceramic Inset Sink'),(42403,121,5,6103,'blanco-villae-farmhouse-double-ceramic-inset-sink'),(42404,121,0,6103,'blanco-villae-farmhouse-double-ceramic-inset-sink'),(42405,84,5,6103,'Blanco Villae Farmhouse Double Ceramic Inset Sink'),(42406,84,0,6103,'Blanco Villae Farmhouse Double Ceramic Inset Sink'),(42407,86,5,6103,'Blanco Villae Farmhouse Double Ceramic Inset Sink'),(42408,86,0,6103,'Blanco Villae Farmhouse Double Ceramic Inset Sink'),(42409,73,5,6103,'Blanco Villae Farmhouse Double Ceramic Inset Sink'),(42410,73,0,6103,'Blanco Villae Farmhouse Double Ceramic Inset Sink'),(42411,109,5,6103,'Blanco Villae Farmhouse Double Ceramic Inset Sink'),(42412,109,0,6103,'Blanco Villae Farmhouse Double Ceramic Inset Sink'),(42413,121,5,6104,'blanco-villae-1-5-bowl-ceramic-inset-sink'),(42414,121,0,6104,'blanco-villae-1-5-bowl-ceramic-inset-sink'),(42415,84,5,6104,'Blanco Villae 1.5 Bowl Ceramic Inset Sink'),(42416,84,0,6104,'Blanco Villae 1.5 Bowl Ceramic Inset Sink'),(42417,86,5,6104,'Blanco Villae 1.5 Bowl Ceramic Inset Sink'),(42418,86,0,6104,'Blanco Villae 1.5 Bowl Ceramic Inset Sink'),(42419,73,5,6104,'Blanco Villae 1.5 Bowl Ceramic Inset Sink'),(42420,73,0,6104,'Blanco Villae 1.5 Bowl Ceramic Inset Sink'),(42421,109,5,6104,'Blanco Villae 1.5 Bowl Ceramic Inset Sink'),(42422,109,0,6104,'Blanco Villae 1.5 Bowl Ceramic Inset Sink'),(42423,121,5,6105,'blanco-andano-400-if-a-inset-stainless-steel-kitchen-sink'),(42424,121,0,6105,'blanco-andano-400-if-a-inset-stainless-steel-kitchen-sink'),(42425,84,5,6105,'Blanco Andano 400-IF/A Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42426,84,0,6105,'Blanco Andano 400-IF/A Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42427,86,5,6105,'Blanco Andano 400-IF/A Inset Stainless Steel Kitchen Sink designed specially with a decent sized bowl able to cope the daily washing up in the average household. '),(42428,86,0,6105,'Blanco Andano 400-IF/A Inset Stainless Steel Kitchen Sink designed specially with a decent sized bowl able to cope the daily washing up in the average household. '),(42429,73,5,6105,'Blanco Andano 400-IF/A Stainless Steel Inset Kitchen Sink'),(42430,73,0,6105,'Blanco Andano 400-IF/A Stainless Steel Inset Kitchen Sink'),(42431,109,5,6105,'blanco_andano_400-if-a'),(42432,109,0,6105,'blanco_andano_400-if-a'),(42433,110,5,6105,'blanco_andano_400-if-a'),(42434,110,0,6105,'blanco_andano_400-if-a'),(42435,111,5,6105,'blanco_andano_400-if-a'),(42436,111,0,6105,'blanco_andano_400-if-a'),(42437,121,5,6106,'blanco-andano-500-if-a-inset-stainless-steel-kitchen-sink'),(42438,121,0,6106,'blanco-andano-500-if-a-inset-stainless-steel-kitchen-sink'),(42439,84,5,6106,'Blanco Andano 500-IF/A Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42440,84,0,6106,'Blanco Andano 500-IF/A Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42441,86,5,6106,'Blanco Andano 500-IF/A Inset Stainless Steel Kitchen Sink designed to fit at eye level, this model would be fit seamlessly into a contemporary kitchen.We always have best deals on all quality products for our respected clients.'),(42442,86,0,6106,'Blanco Andano 500-IF/A Inset Stainless Steel Kitchen Sink designed to fit at eye level, this model would be fit seamlessly into a contemporary kitchen.We always have best deals on all quality products for our respected clients.'),(42443,73,5,6106,'Blanco Andano 500-IF/A Stainless Steel Inset Kitchen Sink'),(42444,73,0,6106,'Blanco Andano 500-IF/A Stainless Steel Inset Kitchen Sink'),(42445,109,5,6106,'Blanco Andano 500-IF/A Stainless Steel Inset Kitchen Sink'),(42446,109,0,6106,'Blanco Andano 500-IF/A Stainless Steel Inset Kitchen Sink'),(42447,121,5,6107,'blanco-andano-700-if-a-inset-stainless-steel-kitchen-sink'),(42448,121,0,6107,'blanco-andano-700-if-a-inset-stainless-steel-kitchen-sink'),(42449,84,5,6107,'Blanco Andano 700-IF/A Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42450,84,0,6107,'Blanco Andano 700-IF/A Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(42451,86,5,6107,'Blanco Andano 700-IF/A Stainless Steel is a large inset kitchen sink bowl which is elegant in form and easily wiped clean. We have a brilliant discount offer, the more products you buy, the more we are able to discount.'),(42452,86,0,6107,'Blanco Andano 700-IF/A Stainless Steel is a large inset kitchen sink bowl which is elegant in form and easily wiped clean. We have a brilliant discount offer, the more products you buy, the more we are able to discount.'),(42453,73,5,6107,'Blanco Andano 700-IF/A Stainless Steel Inset Kitchen Sink'),(42454,73,0,6107,'Blanco Andano 700-IF/A Stainless Steel Inset Kitchen Sink'),(42455,109,5,6107,'Blanco Andano 700-IF/A Stainless Steel Inset Kitchen Sink'),(42456,109,0,6107,'Blanco Andano 700-IF/A Stainless Steel Inset Kitchen Sink'),(42457,121,5,6108,'blanco-andano-340-180-if-a-inset-stainless-steel-kitchen-sink'),(42458,121,0,6108,'blanco-andano-340-180-if-a-inset-stainless-steel-kitchen-sink'),(42459,84,5,6108,'Blanco Andano 340/180-IF/A Inset Stainless Steel Kitchen Sink | Banyo'),(42460,84,0,6108,'Blanco Andano 340/180-IF/A Inset Stainless Steel Kitchen Sink | Banyo'),(42461,86,5,6108,'Blanco Andano 340/180-IF/A Inset Stainless Steel Kitchen Sink offers generous contemporary modern design and shiny finish at affordable prices for daily kitchen use. '),(42462,86,0,6108,'Blanco Andano 340/180-IF/A Inset Stainless Steel Kitchen Sink offers generous contemporary modern design and shiny finish at affordable prices for daily kitchen use. '),(42463,73,5,6108,'Blanco Andano 340/180 IF/A Stainless Steel Inset Kitchen Sink'),(42464,73,0,6108,'Blanco Andano 340/180 IF/A Stainless Steel Inset Kitchen Sink'),(42465,109,5,6108,'Blanco Andano 340/180IF/A Stainless Steel Inset Kitchen Sink'),(42466,109,0,6108,'Blanco Andano 340/180IF/A Stainless Steel Inset Kitchen Sink'),(42467,121,5,6109,'blanco-andano-400-400-if-a-inset-kitchen-sink-bl467013'),(42468,121,0,6109,'blanco-andano-400-400-if-a-inset-kitchen-sink-bl467013'),(42469,84,5,6109,'Blanco Andano 400/400-IF/A, Double Bowl, Kitchen Sink | Banyo'),(42470,84,0,6109,'Blanco Andano 400/400-IF/A, Double Bowl, Kitchen Sink | Banyo'),(42471,86,5,6109,'Blanco Andano 400/400-U Undermount Stainless Steel double bowl Kitchen Sink BL 518 325 is a beautiful addition to the modern contemporary kitchen available at banyo.'),(42472,86,0,6109,'Blanco Andano 400/400-U Undermount Stainless Steel double bowl Kitchen Sink BL 518 325 is a beautiful addition to the modern contemporary kitchen available at banyo.'),(42473,73,5,6109,'Blanco Andano 400/400-IF/A Inset Kitchen Sink - 522998'),(42474,73,0,6109,'Blanco Andano 400/400-IF/A Inset Kitchen Sink - 522998'),(42475,109,5,6109,'Blanco Andano 400/400-IF/A Inset Kitchen Sink - 522998'),(42476,109,0,6109,'Blanco Andano 400/400-IF/A Inset Kitchen Sink - 522998'),(42477,110,5,6109,'blanco_andano_400-400-if-a'),(42478,110,0,6109,'blanco_andano_400-400-if-a'),(42479,111,5,6109,'blanco_andano_400-400-if-a'),(42480,111,0,6109,'blanco_andano_400-400-if-a'),(42481,121,5,6110,'blanco-classimo-xl-6-s-if-stainless-steel-inset-kitchen-sink'),(42482,121,0,6110,'blanco-classimo-xl-6-s-if-stainless-steel-inset-kitchen-sink'),(42483,73,5,6110,'Blanco Classimo XL 6 S-IF Stainless Steel Inset Kitchen Sink'),(42484,73,0,6110,'Blanco Classimo XL 6 S-IF Stainless Steel Inset Kitchen Sink'),(42485,109,5,6110,'blanco-classimo-XL-6-S-IF'),(42486,109,0,6110,'blanco-classimo-XL-6-S-IF'),(42487,110,5,6110,'blanco-classimo-XL-6-S-IF'),(42488,110,0,6110,'blanco-classimo-XL-6-S-IF'),(42489,111,5,6110,'blanco-classimo-XL-6-S-IF'),(42490,111,0,6110,'blanco-classimo-XL-6-S-IF'),(42491,121,5,6111,'blanco-classimo-6-s-if-stainless-steel-inset-kitchen-sink'),(42492,121,0,6111,'blanco-classimo-6-s-if-stainless-steel-inset-kitchen-sink'),(42493,73,5,6111,'Blanco Classimo 6 S-IF Stainless Steel Inset Kitchen Sink'),(42494,73,0,6111,'Blanco Classimo 6 S-IF Stainless Steel Inset Kitchen Sink'),(42495,109,5,6111,'blanco-classimo-6-S-IF-525328'),(42496,109,0,6111,'blanco-classimo-6-S-IF-525328'),(42497,110,5,6111,'blanco-classimo-6-S-IF-525328'),(42498,110,0,6111,'blanco-classimo-6-S-IF-525328'),(42499,111,5,6111,'blanco-classimo-6-S-IF-525328'),(42500,111,0,6111,'blanco-classimo-6-S-IF-525328'),(42501,121,5,6112,'blanco-classimo-45-s-if-stainless-steel-inset-kitchen-sink'),(42502,121,0,6112,'blanco-classimo-45-s-if-stainless-steel-inset-kitchen-sink'),(42503,73,5,6112,'Blanco Classimo 45 S-IF Stainless Steel Inset Kitchen Sink'),(42504,73,0,6112,'Blanco Classimo 45 S-IF Stainless Steel Inset Kitchen Sink'),(42505,109,5,6112,'blanco-classimo-45-S-IF'),(42506,109,0,6112,'blanco-classimo-45-S-IF'),(42507,110,5,6112,'blanco-classimo-45-S-IF'),(42508,110,0,6112,'blanco-classimo-45-S-IF'),(42509,111,5,6112,'blanco-classimo-45-S-IF'),(42510,111,0,6112,'blanco-classimo-45-S-IF'),(42511,121,5,6113,'blanco-solis-180-u-stainless-steel-undermount-kitchen-sink'),(42512,121,0,6113,'blanco-solis-180-u-stainless-steel-undermount-kitchen-sink'),(42513,84,5,6113,'Blanco SOLIS 180-U Stainless Steel Undermount Kitchen Sink'),(42514,84,0,6113,'Blanco SOLIS 180-U Stainless Steel Undermount Kitchen Sink'),(42515,86,5,6113,'Blanco SOLIS 180-U Stainless Steel Undermount Kitchen Sink'),(42516,86,0,6113,'Blanco SOLIS 180-U Stainless Steel Undermount Kitchen Sink'),(42517,73,5,6113,'Blanco SOLIS 180-U Stainless Steel Undermount Kitchen Sink'),(42518,73,0,6113,'Blanco SOLIS 180-U Stainless Steel Undermount Kitchen Sink'),(42519,109,5,6113,'Blanco SOLIS 180-U Stainless Steel Undermount Kitchen Sink'),(42520,109,0,6113,'Blanco SOLIS 180-U Stainless Steel Undermount Kitchen Sink'),(42521,110,5,6113,'Blanco SOLIS 180-U Stainless Steel Undermount Kitchen Sink'),(42522,110,0,6113,'Blanco SOLIS 180-U Stainless Steel Undermount Kitchen Sink'),(42523,111,5,6113,'Blanco SOLIS 180-U Stainless Steel Undermount Kitchen Sink'),(42524,111,0,6113,'Blanco SOLIS 180-U Stainless Steel Undermount Kitchen Sink'),(42525,121,5,6114,'blanco-solis-340-u-stainless-steel-undermount-kitchen-sink'),(42526,121,0,6114,'blanco-solis-340-u-stainless-steel-undermount-kitchen-sink'),(42527,73,5,6114,'Blanco Solis 340-U Stainless Steel Undermount Kitchen Sink'),(42528,73,0,6114,'Blanco Solis 340-U Stainless Steel Undermount Kitchen Sink'),(42529,109,5,6114,'blanco-solis-340-U'),(42530,109,0,6114,'blanco-solis-340-U'),(42531,110,5,6114,'blanco-solis-340-U'),(42532,110,0,6114,'blanco-solis-340-U'),(42533,111,5,6114,'blanco-solis-340-U'),(42534,111,0,6114,'blanco-solis-340-U'),(42535,121,5,6115,'blanco-solis-400-u-stainless-steel-undermount-kitchen-sink'),(42536,121,0,6115,'blanco-solis-400-u-stainless-steel-undermount-kitchen-sink'),(42537,73,5,6115,'Blanco Solis 400-U Stainless Steel Undermount Kitchen Sink'),(42538,73,0,6115,'Blanco Solis 400-U Stainless Steel Undermount Kitchen Sink'),(42539,109,5,6115,'blanco-solis-400-U-526117'),(42540,109,0,6115,'blanco-solis-400-U-526117'),(42541,110,5,6115,'blanco-solis-400-U-526117'),(42542,110,0,6115,'blanco-solis-400-U-526117'),(42543,111,5,6115,'blanco-solis-400-U-526117'),(42544,111,0,6115,'blanco-solis-400-U-526117'),(42545,121,5,6116,'blanco-solis-450-u-stainless-steel-undermount-kitchen-sink'),(42546,121,0,6116,'blanco-solis-450-u-stainless-steel-undermount-kitchen-sink'),(42547,73,5,6116,'Blanco Solis 450-U Stainless Steel Undermount Kitchen Sink'),(42548,73,0,6116,'Blanco Solis 450-U Stainless Steel Undermount Kitchen Sink'),(42549,109,5,6116,'blanco-solis-450-U-526120\r\n'),(42550,109,0,6116,'blanco-solis-450-U-526120\r\n'),(42551,110,5,6116,'blanco-solis-450-U-526120\r\n'),(42552,110,0,6116,'blanco-solis-450-U-526120\r\n'),(42553,111,5,6116,'blanco-solis-450-U-526120\r\n'),(42554,111,0,6116,'blanco-solis-450-U-526120\r\n'),(42555,121,5,6117,'blanco-solis-500-u-stainless-steel-undermount-kitchen-sink'),(42556,121,0,6117,'blanco-solis-500-u-stainless-steel-undermount-kitchen-sink'),(42557,73,5,6117,'Blanco Solis 500-U Stainless Steel Undermount Kitchen Sink'),(42558,73,0,6117,'Blanco Solis 500-U Stainless Steel Undermount Kitchen Sink'),(42559,109,5,6117,'blanco-solis-500-U-526122'),(42560,109,0,6117,'blanco-solis-500-U-526122'),(42561,110,5,6117,'blanco-solis-500-U-526122'),(42562,110,0,6117,'blanco-solis-500-U-526122'),(42563,111,5,6117,'blanco-solis-500-U-526122'),(42564,111,0,6117,'blanco-solis-500-U-526122'),(42565,121,5,6118,'blanco-solis-700-u-stainless-steel-undermount-kitchen-sink'),(42566,121,0,6118,'blanco-solis-700-u-stainless-steel-undermount-kitchen-sink'),(42567,73,5,6118,'Blanco Solis 700-U Stainless Steel Undermount Kitchen Sink'),(42568,73,0,6118,'Blanco Solis 700-U Stainless Steel Undermount Kitchen Sink'),(42569,109,5,6118,'blanco-solis-700-U-526125'),(42570,109,0,6118,'blanco-solis-700-U-526125'),(42571,110,5,6118,'blanco-solis-700-U-526125'),(42572,110,0,6118,'blanco-solis-700-U-526125'),(42573,111,5,6118,'blanco-solis-700-U-526125'),(42574,111,0,6118,'blanco-solis-700-U-526125'),(42575,121,5,6119,'blanco-zerox-500-u-dark-steel-undermount-kitchen-sink'),(42576,121,0,6119,'blanco-zerox-500-u-dark-steel-undermount-kitchen-sink'),(42577,73,5,6119,'Blanco Zerox 500-U Dark Steel Undermount Kitchen Sink'),(42578,73,0,6119,'Blanco Zerox 500-U Dark Steel Undermount Kitchen Sink'),(42579,109,5,6119,'blanco-zerox-500-U-526243-drk-stl'),(42580,109,0,6119,'blanco-zerox-500-U-526243-drk-stl'),(42581,110,5,6119,'blanco-zerox-500-U-526243-drk-stl'),(42582,110,0,6119,'blanco-zerox-500-U-526243-drk-stl'),(42583,111,5,6119,'blanco-zerox-500-U-526243-drk-stl'),(42584,111,0,6119,'blanco-zerox-500-U-526243-drk-stl'),(42585,121,5,6120,'blanco-zerox-700-u-dark-steel-undermount-kitchen-sink'),(42586,121,0,6120,'blanco-zerox-700-u-dark-steel-undermount-kitchen-sink'),(42587,73,5,6120,'Blanco Zerox 700-U Dark Steel Undermount Kitchen Sink'),(42588,73,0,6120,'Blanco Zerox 700-U Dark Steel Undermount Kitchen Sink'),(42589,109,5,6120,'blanco-zerox-700-U-526244-drk-stl'),(42590,109,0,6120,'blanco-zerox-700-U-526244-drk-stl'),(42591,110,5,6120,'blanco-zerox-700-U-526244-drk-stl'),(42592,110,0,6120,'blanco-zerox-700-U-526244-drk-stl'),(42593,111,5,6120,'blanco-zerox-700-U-526244-drk-stl'),(42594,111,0,6120,'blanco-zerox-700-U-526244-drk-stl'),(42595,121,5,6121,'blanco-supra-400-if-stainless-steel-inset-kitchen-sink'),(42596,121,0,6121,'blanco-supra-400-if-stainless-steel-inset-kitchen-sink'),(42597,84,5,6121,'Blanco SUPRA 400-IF Stainless Steel Inset Kitchen Sink | Banyo'),(42598,84,0,6121,'Blanco SUPRA 400-IF Stainless Steel Inset Kitchen Sink | Banyo'),(42599,86,5,6121,'Blanco SUPRA 400-IF Stainless Steel Sink with Inset Installation is available at Banyo with Lowest price offer in the UK. Compatible with Cabinet width: 450mm, Universal handing, Stainless steel quality grades 18/10. For more info visit or give us a call '),(42600,86,0,6121,'Blanco SUPRA 400-IF Stainless Steel Sink with Inset Installation is available at Banyo with Lowest price offer in the UK. Compatible with Cabinet width: 450mm, Universal handing, Stainless steel quality grades 18/10. For more info visit or give us a call '),(42601,73,5,6121,'Blanco SUPRA 400-IF Stainless Steel Inset Kitchen Sink'),(42602,73,0,6121,'Blanco SUPRA 400-IF Stainless Steel Inset Kitchen Sink'),(42603,109,5,6121,'Blanco SUPRA 400-IF Stainless Steel Inset Kitchen Sink'),(42604,109,0,6121,'Blanco SUPRA 400-IF Stainless Steel Inset Kitchen Sink'),(42605,121,5,6122,'blanco-supra-500-if-stainless-steel-inset-kitchen-sink'),(42606,121,0,6122,'blanco-supra-500-if-stainless-steel-inset-kitchen-sink'),(42607,84,5,6122,'Blanco SUPRA 400-IF Stainless Steel Inset Kitchen Sink'),(42608,84,0,6122,'Blanco SUPRA 400-IF Stainless Steel Inset Kitchen Sink'),(42609,86,5,6122,'Blanco SUPRA 400-IF Stainless Steel Inset Kitchen Sink compatible with Cabinet width: 600mm, Universal handing, Elegant IF flat-rim for Flushmount and for installation from above. Banyo offers the best prices and fast delivery service in the UK.'),(42610,86,0,6122,'Blanco SUPRA 400-IF Stainless Steel Inset Kitchen Sink compatible with Cabinet width: 600mm, Universal handing, Elegant IF flat-rim for Flushmount and for installation from above. Banyo offers the best prices and fast delivery service in the UK.'),(42611,73,5,6122,'Blanco SUPRA 500-IF Stainless Steel Inset Kitchen Sink'),(42612,73,0,6122,'Blanco SUPRA 500-IF Stainless Steel Inset Kitchen Sink'),(42613,109,5,6122,'Blanco SUPRA 500-IF Stainless Steel Inset Kitchen Sink'),(42614,109,0,6122,'Blanco SUPRA 500-IF Stainless Steel Inset Kitchen Sink'),(42615,121,5,6123,'blanco-supra-400-if-a-stainless-steel-inset-kitchen-sink'),(42616,121,0,6123,'blanco-supra-400-if-a-stainless-steel-inset-kitchen-sink'),(42617,84,5,6123,'Blanco SUPRA 400-IF/A Stainless Steel Reversible Kitchen Sink | Banyo'),(42618,84,0,6123,'Blanco SUPRA 400-IF/A Stainless Steel Reversible Kitchen Sink | Banyo'),(42619,86,5,6123,'Blanco SUPRA 400-IF/A Stainless Steel Inset Kitchen Sink'),(42620,86,0,6123,'Blanco SUPRA 400-IF/A Stainless Steel Inset Kitchen Sink'),(42621,73,5,6123,'Blanco SUPRA 400-IF/A Stainless Steel Inset Kitchen Sink'),(42622,73,0,6123,'Blanco SUPRA 400-IF/A Stainless Steel Inset Kitchen Sink'),(42623,109,5,6123,'Blanco SUPRA 400-IF/A Stainless Steel Inset Kitchen Sink'),(42624,109,0,6123,'Blanco SUPRA 400-IF/A Stainless Steel Inset Kitchen Sink'),(42625,121,5,6124,'blanco-supra-500-if-a-stainless-steel-inset-kitchen-sink'),(42626,121,0,6124,'blanco-supra-500-if-a-stainless-steel-inset-kitchen-sink'),(42627,84,5,6124,'Blanco SUPRA 500-IF/A Stainless Steel Inset Kitchen Sink | Banyo'),(42628,84,0,6124,'Blanco SUPRA 500-IF/A Stainless Steel Inset Kitchen Sink | Banyo'),(42629,86,5,6124,'Buy Blanco SUPRA 400-IF Stainless Steel Sink with Inset Installation from Banyo with the lowest price offer in the UK. Cabinet width: 600mm, Stainless steel quality grades 18/10, For individual configuration of the main and additional bowl, drainer and ac'),(42630,86,0,6124,'Buy Blanco SUPRA 400-IF Stainless Steel Sink with Inset Installation from Banyo with the lowest price offer in the UK. Cabinet width: 600mm, Stainless steel quality grades 18/10, For individual configuration of the main and additional bowl, drainer and ac'),(42631,73,5,6124,'Blanco SUPRA 500-IF/A Stainless Steel Inset Kitchen Sink'),(42632,73,0,6124,'Blanco SUPRA 500-IF/A Stainless Steel Inset Kitchen Sink'),(42633,109,5,6124,'Blanco SUPRA 500-IF/A Stainless Steel Inset Kitchen Sink'),(42634,109,0,6124,'Blanco SUPRA 500-IF/A Stainless Steel Inset Kitchen Sink'),(42635,121,5,6125,'blanco-claron-500-u-dark-steel-undermount-kitchen-sink'),(42636,121,0,6125,'blanco-claron-500-u-dark-steel-undermount-kitchen-sink'),(42637,84,5,6125,'Blanco CLARON 500-U Dark Steel Undermount Kitchen Sink'),(42638,84,0,6125,'Blanco CLARON 500-U Dark Steel Undermount Kitchen Sink'),(42639,86,5,6125,'Blanco CLARON 500-U Dark Steel Undermount Kitchen Sink'),(42640,86,0,6125,'Blanco CLARON 500-U Dark Steel Undermount Kitchen Sink'),(42641,73,5,6125,'Blanco CLARON 500-U Dark Steel Undermount Kitchen Sink'),(42642,73,0,6125,'Blanco CLARON 500-U Dark Steel Undermount Kitchen Sink'),(42643,109,5,6125,'Blanco CLARON 500-U Dark Steel Undermount Kitchen Sink'),(42644,109,0,6125,'Blanco CLARON 500-U Dark Steel Undermount Kitchen Sink'),(42645,110,5,6125,'Blanco CLARON 500-U Dark Steel Undermount Kitchen Sink'),(42646,110,0,6125,'Blanco CLARON 500-U Dark Steel Undermount Kitchen Sink'),(42647,111,5,6125,'Blanco CLARON 500-U Dark Steel Undermount Kitchen Sink'),(42648,111,0,6125,'Blanco CLARON 500-U Dark Steel Undermount Kitchen Sink'),(42649,121,5,6126,'blanco-claron-700-u-dark-steel-undermount-kitchen-sink'),(42650,121,0,6126,'blanco-claron-700-u-dark-steel-undermount-kitchen-sink'),(42651,84,5,6126,'Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink'),(42652,84,0,6126,'Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink'),(42653,86,5,6126,'Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink'),(42654,86,0,6126,'Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink'),(42655,73,5,6126,'Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink'),(42656,73,0,6126,'Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink'),(42657,109,5,6126,'Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink'),(42658,109,0,6126,'Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink'),(42659,110,5,6126,'Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink'),(42660,110,0,6126,'Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink'),(42661,111,5,6126,'Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink'),(42662,111,0,6126,'Blanco CLARON 700-U Dark Steel Undermount Kitchen Sink'),(42663,121,5,6127,'blanco-adira-45-s-silgranit-kitchen-sink'),(42664,121,0,6127,'blanco-adira-45-s-silgranit-kitchen-sink'),(42665,84,5,6127,'Blanco ADIRA 45 S Silgranit Kitchen Sink'),(42666,84,0,6127,'Blanco ADIRA 45 S Silgranit Kitchen Sink'),(42667,86,5,6127,'Blanco ADIRA 45 S Silgranit Kitchen Sink'),(42668,86,0,6127,'Blanco ADIRA 45 S Silgranit Kitchen Sink'),(42669,73,5,6127,'Blanco ADIRA 45 S Silgranit Kitchen Sink'),(42670,73,0,6127,'Blanco ADIRA 45 S Silgranit Kitchen Sink'),(42671,109,5,6127,'Blanco ADIRA 45 S Silgranit Kitchen Sink'),(42672,109,0,6127,'Blanco ADIRA 45 S Silgranit Kitchen Sink'),(42673,110,5,6127,'Blanco ADIRA 45 S Silgranit Kitchen Sink'),(42674,110,0,6127,'Blanco ADIRA 45 S Silgranit Kitchen Sink'),(42675,111,5,6127,'Blanco ADIRA 45 S Silgranit Kitchen Sink'),(42676,111,0,6127,'Blanco ADIRA 45 S Silgranit Kitchen Sink'),(42677,121,5,6128,'blanco-adira-6s-silgranit-kitchen-sink'),(42678,121,0,6128,'blanco-adira-6s-silgranit-kitchen-sink'),(42679,84,5,6128,'Blanco ADIRA 6S Silgranit Kitchen Sink'),(42680,84,0,6128,'Blanco ADIRA 6S Silgranit Kitchen Sink'),(42681,86,5,6128,'Blanco ADIRA 6S Silgranit Kitchen Sink'),(42682,86,0,6128,'Blanco ADIRA 6S Silgranit Kitchen Sink'),(42683,73,5,6128,'Blanco ADIRA 6S Silgranit Kitchen Sink'),(42684,73,0,6128,'Blanco ADIRA 6S Silgranit Kitchen Sink'),(42685,109,5,6128,'Blanco ADIRA 6S Silgranit Kitchen Sink'),(42686,109,0,6128,'Blanco ADIRA 6S Silgranit Kitchen Sink'),(42687,110,5,6128,'Blanco ADIRA 6S Silgranit Kitchen Sink'),(42688,110,0,6128,'Blanco ADIRA 6S Silgranit Kitchen Sink'),(42689,111,5,6128,'Blanco ADIRA 6S Silgranit Kitchen Sink'),(42690,111,0,6128,'Blanco ADIRA 6S Silgranit Kitchen Sink'),(42691,121,5,6129,'blanco-adira-xl-6s-silgranit-kitchen-sink'),(42692,121,0,6129,'blanco-adira-xl-6s-silgranit-kitchen-sink'),(42693,84,5,6129,'Blanco ADIRA XL 6S Silgranit Kitchen Sink'),(42694,84,0,6129,'Blanco ADIRA XL 6S Silgranit Kitchen Sink'),(42695,86,5,6129,'Blanco ADIRA XL 6S Silgranit Kitchen Sink'),(42696,86,0,6129,'Blanco ADIRA XL 6S Silgranit Kitchen Sink'),(42697,73,5,6129,'Blanco ADIRA XL 6S Silgranit Kitchen Sink'),(42698,73,0,6129,'Blanco ADIRA XL 6S Silgranit Kitchen Sink'),(42699,109,5,6129,'Blanco ADIRA XL 6S Silgranit Kitchen Sink'),(42700,109,0,6129,'Blanco ADIRA XL 6S Silgranit Kitchen Sink'),(42701,110,5,6129,'Blanco ADIRA XL 6S Silgranit Kitchen Sink'),(42702,110,0,6129,'Blanco ADIRA XL 6S Silgranit Kitchen Sink'),(42703,111,5,6129,'Blanco ADIRA XL 6S Silgranit Kitchen Sink'),(42704,111,0,6129,'Blanco ADIRA XL 6S Silgranit Kitchen Sink'),(42705,121,5,6130,'franke-ascona-agx-611-100-inset-1-0-bowl-kitchen-sink'),(42706,121,0,6130,'franke-ascona-agx-611-100-inset-1-0-bowl-kitchen-sink'),(42707,84,5,6130,'Franke Argos AGX 611-100 Inset 1.0 Bowl Kitchen Sink'),(42708,84,0,6130,'Franke Argos AGX 611-100 Inset 1.0 Bowl Kitchen Sink'),(42709,86,5,6130,'Argos AGX 611-100 is a slim top Inset 1.0 Bowl Kitchen Sink by Franke manufactured with stainless steel and looks great on any surface. Stains and scratches cannot stay longer on its surface.'),(42710,86,0,6130,'Argos AGX 611-100 is a slim top Inset 1.0 Bowl Kitchen Sink by Franke manufactured with stainless steel and looks great on any surface. Stains and scratches cannot stay longer on its surface.'),(42711,73,5,6130,'Franke Argos AGX 611-100 Inset 1.0 Bowl Kitchen Sink'),(42712,73,0,6130,'Franke Argos AGX 611-100 Inset 1.0 Bowl Kitchen Sink'),(42713,109,5,6130,'Franke Argos AGX 611-100 Inset 1.0 Bowl Kitchen Sink'),(42714,109,0,6130,'Franke Argos AGX 611-100 Inset 1.0 Bowl Kitchen Sink'),(42715,121,5,6131,'franke-argos-agx-611-78-inset-single-bowl-sink-stainless-steel'),(42716,121,0,6131,'franke-argos-agx-611-78-inset-single-bowl-sink-stainless-steel'),(42717,84,5,6131,'Franke Argos AGX 611-78 Inset Single Bowl Sink - Stainless Steel'),(42718,84,0,6131,'Franke Argos AGX 611-78 Inset Single Bowl Sink - Stainless Steel'),(42719,86,5,6131,'Franke Argos AGX 611-78 Inset Single Bowl Sink - Stainless Steel'),(42720,86,0,6131,'Franke Argos AGX 611-78 Inset Single Bowl Sink - Stainless Steel'),(42721,73,5,6131,'Franke Argos AGX 611-78 Inset Single Bowl Sink - Stainless Steel'),(42722,73,0,6131,'Franke Argos AGX 611-78 Inset Single Bowl Sink - Stainless Steel'),(42723,109,5,6131,'Franke Argos AGX 611-78 Inset Single Bowl Sink - Stainless Steel'),(42724,109,0,6131,'Franke Argos AGX 611-78 Inset Single Bowl Sink - Stainless Steel'),(42725,110,5,6131,'Franke Argos AGX 611-78 Inset Single Bowl Sink - Stainless Steel'),(42726,110,0,6131,'Franke Argos AGX 611-78 Inset Single Bowl Sink - Stainless Steel'),(42727,111,5,6131,'Franke Argos AGX 611-78 Inset Single Bowl Sink - Stainless Steel'),(42728,111,0,6131,'Franke Argos AGX 611-78 Inset Single Bowl Sink - Stainless Steel'),(42729,121,5,6132,'franke-argos-agx-611-860-inset-1-0-bowl-kitchen-sink'),(42730,121,0,6132,'franke-argos-agx-611-860-inset-1-0-bowl-kitchen-sink'),(42731,84,5,6132,'Franke Argos AGX 611-86 Inset 1.0 Bowl Kitchen Sink'),(42732,84,0,6132,'Franke Argos AGX 611-86 Inset 1.0 Bowl Kitchen Sink'),(42733,86,5,6132,'Buy Franke Argos AGX 611-86 Stainless Steel Single Bowl Sink with a special price discount from Banyo. Reverisable Drainer, Inset Installation, Durable are just a few features.'),(42734,86,0,6132,'Buy Franke Argos AGX 611-86 Stainless Steel Single Bowl Sink with a special price discount from Banyo. Reverisable Drainer, Inset Installation, Durable are just a few features.'),(42735,73,5,6132,'Franke Argos AGX 611-860 Inset 1.0 Bowl Kitchen Sink'),(42736,73,0,6132,'Franke Argos AGX 611-860 Inset 1.0 Bowl Kitchen Sink'),(42737,109,5,6132,'Franke Argos AGX 611-860 Inset 1.0 Bowl Kitchen Sink'),(42738,109,0,6132,'Franke Argos AGX 611-860 Inset 1.0 Bowl Kitchen Sink'),(42739,121,5,6133,'franke-argos-agx-651-inset-1-5-bowl-kitchen-sink'),(42740,121,0,6133,'franke-argos-agx-651-inset-1-5-bowl-kitchen-sink'),(42741,84,5,6133,'Franke Argos AGX 651 Inset 1.5 Bowl Kitchen Sink'),(42742,84,0,6133,'Franke Argos AGX 651 Inset 1.5 Bowl Kitchen Sink'),(42743,86,5,6133,'Buy Franke Argos AGX 651 Kitchen Sink with Inset Installation and 1.5 Bowl configuration from Banyo. We offer a complete range of Stainless Steel Sinks from top UK brands with the lowest prices. Fast delivery!'),(42744,86,0,6133,'Buy Franke Argos AGX 651 Kitchen Sink with Inset Installation and 1.5 Bowl configuration from Banyo. We offer a complete range of Stainless Steel Sinks from top UK brands with the lowest prices. Fast delivery!'),(42745,73,5,6133,'Franke Argos AGX 651 Inset 1.5 Bowl Kitchen Sink'),(42746,73,0,6133,'Franke Argos AGX 651 Inset 1.5 Bowl Kitchen Sink'),(42747,109,5,6133,'Franke Argos AGX 651 Inset 1.5 Bowl Kitchen Sink'),(42748,109,0,6133,'Franke Argos AGX 651 Inset 1.5 Bowl Kitchen Sink'),(42749,121,5,6134,'franke-arcana-ahk-611-ceramic-1-0-bowl-kitchen-sink-white'),(42750,121,0,6134,'franke-arcana-ahk-611-ceramic-1-0-bowl-kitchen-sink-white'),(42751,84,5,6134,'Franke Arcana AHK 611 Ceramic 1.0 Bowl Kitchen Sink White'),(42752,84,0,6134,'Franke Arcana AHK 611 Ceramic 1.0 Bowl Kitchen Sink White'),(42753,86,5,6134,'Franke Arcana AHK 611 is a Single Bowl Ceramic Sink with an optional Turbo Elite Waste Disposal Unit available on Banyo with the Lowest price in the UK. Reversible drainer, Durable & Glossy Finish.'),(42754,86,0,6134,'Franke Arcana AHK 611 is a Single Bowl Ceramic Sink with an optional Turbo Elite Waste Disposal Unit available on Banyo with the Lowest price in the UK. Reversible drainer, Durable & Glossy Finish.'),(42755,73,5,6134,'Franke Arcana AHK 611 Ceramic 1.0 Bowl Kitchen Sink White'),(42756,73,0,6134,'Franke Arcana AHK 611 Ceramic 1.0 Bowl Kitchen Sink White'),(42757,109,5,6134,'Franke Arcana AHK 611 Ceramic 1.0 Bowl Kitchen Sink White'),(42758,109,0,6134,'Franke Arcana AHK 611 Ceramic 1.0 Bowl Kitchen Sink White'),(42759,121,5,6135,'reginox-alaska-1-5-bowl-kitchen-sink'),(42760,121,0,6135,'reginox-alaska-1-5-bowl-kitchen-sink'),(42761,84,5,6135,'Reginox Alaska 1.5 Bowl Kitchen Sink'),(42762,84,0,6135,'Reginox Alaska 1.5 Bowl Kitchen Sink'),(42763,86,5,6135,'Reginox Alaska 1.5 Bowl Kitchen Sink'),(42764,86,0,6135,'Reginox Alaska 1.5 Bowl Kitchen Sink'),(42765,73,5,6135,'Reginox Alaska 1.5 Bowl Kitchen Sink'),(42766,73,0,6135,'Reginox Alaska 1.5 Bowl Kitchen Sink'),(42767,109,5,6135,'Reginox Alaska 1.5 Bowl Kitchen Sink'),(42768,109,0,6135,'Reginox Alaska 1.5 Bowl Kitchen Sink'),(42769,110,5,6135,'Reginox Alaska 1.5 Bowl Kitchen Sink'),(42770,110,0,6135,'Reginox Alaska 1.5 Bowl Kitchen Sink'),(42771,111,5,6135,'Reginox Alaska 1.5 Bowl Kitchen Sink'),(42772,111,0,6135,'Reginox Alaska 1.5 Bowl Kitchen Sink'),(42773,121,5,6136,'reginox-alpha-inset-1-bowl-kitchen-sink'),(42774,121,0,6136,'reginox-alpha-inset-1-bowl-kitchen-sink'),(42775,84,5,6136,'Reginox Alpha Inset 1 Bowl Kitchen Sink'),(42776,84,0,6136,'Reginox Alpha Inset 1 Bowl Kitchen Sink'),(42777,86,5,6136,'Reginox Alpha Inset 1 Bowl Kitchen Sink'),(42778,86,0,6136,'Reginox Alpha Inset 1 Bowl Kitchen Sink'),(42779,73,5,6136,'Reginox Alpha Inset 1 Bowl Kitchen Sink'),(42780,73,0,6136,'Reginox Alpha Inset 1 Bowl Kitchen Sink'),(42781,109,5,6136,'Reginox Alpha Inset 1 Bowl Kitchen Sink'),(42782,109,0,6136,'Reginox Alpha Inset 1 Bowl Kitchen Sink'),(42783,121,5,6137,'blanco-andano-340-180-if-inset-stainless-steel-kitchen-sink'),(42784,121,0,6137,'blanco-andano-340-180-if-inset-stainless-steel-kitchen-sink'),(42785,84,5,6137,'Blanco Andano 340/180-IF - Inset Stainless Steel Kitchen Sink | Banyo'),(42786,84,0,6137,'Blanco Andano 340/180-IF - Inset Stainless Steel Kitchen Sink | Banyo'),(42787,86,5,6137,'Daily kitchen work can be made easier with the Blanco Andano 340/180-IF Inset Stainless Steel Kitchen Sink, offering contemporary setting for convenience of cleaning and functional style. '),(42788,86,0,6137,'Daily kitchen work can be made easier with the Blanco Andano 340/180-IF Inset Stainless Steel Kitchen Sink, offering contemporary setting for convenience of cleaning and functional style. '),(42789,73,5,6137,'Blanco Andano 340/180-IF Stainless Steel Inset Kitchen Sink'),(42790,73,0,6137,'Blanco Andano 340/180-IF Stainless Steel Inset Kitchen Sink'),(42791,109,5,6137,'Blanco Andano 340/180-IF Stainless Steel Inset Kitchen Sink'),(42792,109,0,6137,'Blanco Andano 340/180-IF Stainless Steel Inset Kitchen Sink'),(42793,121,5,6138,'blanco-andano-340-180-u-undermount-stainless-steel-kitchen-sink'),(42794,121,0,6138,'blanco-andano-340-180-u-undermount-stainless-steel-kitchen-sink'),(42795,84,5,6138,'Blanco Andano 340/180-U Undermount Stainless Steel Kitchen Sink | Banyo'),(42796,84,0,6138,'Blanco Andano 340/180-U Undermount Stainless Steel Kitchen Sink | Banyo'),(42797,86,5,6138,'Blanco Andano 340/180-U Undermount Stainless Steel Kitchen Sink provides basic style and function at affordable prices.A stylish Blanco kitchen sink will add the perfect finishing touch to any contemporary kitchen'),(42798,86,0,6138,'Blanco Andano 340/180-U Undermount Stainless Steel Kitchen Sink provides basic style and function at affordable prices.A stylish Blanco kitchen sink will add the perfect finishing touch to any contemporary kitchen'),(42799,73,5,6138,'Blanco Andano 340/180-U Undermount Kitchen Sink'),(42800,73,0,6138,'Blanco Andano 340/180-U Undermount Kitchen Sink'),(42801,109,5,6138,'Blanco Andano 340/180-U Undermount Kitchen Sink'),(42802,109,0,6138,'Blanco Andano 340/180-U Undermount Kitchen Sink'),(42803,121,5,6139,'blanco-andano-500-180-u-undermount-kitchen-sink'),(42804,121,0,6139,'blanco-andano-500-180-u-undermount-kitchen-sink'),(42805,84,5,6139,'Blanco Andano 500/180-U Undermount Stainless Steel Sink | Banyo.co.uk'),(42806,84,0,6139,'Blanco Andano 500/180-U Undermount Stainless Steel Sink | Banyo.co.uk'),(42807,86,5,6139,'Blanco Andano 500/180-U Undermount Stainless Steel Kitchen Sink with best price and manufacturer gurantee availabe at banyo. Everything you need to complete your Kitchen is available at Banyo'),(42808,86,0,6139,'Blanco Andano 500/180-U Undermount Stainless Steel Kitchen Sink with best price and manufacturer gurantee availabe at banyo. Everything you need to complete your Kitchen is available at Banyo'),(42809,73,5,6139,'Blanco Andano 500/180-U Undermount Kitchen Sink '),(42810,73,0,6139,'Blanco Andano 500/180-U Undermount Kitchen Sink '),(42811,109,5,6139,'Blanco Andano 500/180-U Undermount Kitchen Sink '),(42812,109,0,6139,'Blanco Andano 500/180-U Undermount Kitchen Sink '),(42813,121,5,6140,'blanco-andano-xl-6-s-if-inset-stainless-steel-kitchen-sink'),(42814,121,0,6140,'blanco-andano-xl-6-s-if-inset-stainless-steel-kitchen-sink'),(42815,84,5,6140,'Blanco Andano XL 6 S-IF Inset Stainless Steel Kitchen Sink | Banyo UK'),(42816,84,0,6140,'Blanco Andano XL 6 S-IF Inset Stainless Steel Kitchen Sink | Banyo UK'),(42817,86,5,6140,'Blanco Andano XL 6 S-IF Inset Stainless Steel Kitchen Sink cheap sale at banyo. Banyo unbeatable prices and fastest delivery makes life less complicated and much easier.'),(42818,86,0,6140,'Blanco Andano XL 6 S-IF Inset Stainless Steel Kitchen Sink cheap sale at banyo. Banyo unbeatable prices and fastest delivery makes life less complicated and much easier.'),(42819,73,5,6140,'Blanco Andano XL 6 S-IF Stainless Steel Inset Kitchen Sink'),(42820,73,0,6140,'Blanco Andano XL 6 S-IF Stainless Steel Inset Kitchen Sink'),(42821,109,5,6140,'Blanco Andano XL 6 S-IF Stainless Steel Inset Kitchen Sink'),(42822,109,0,6140,'Blanco Andano XL 6 S-IF Stainless Steel Inset Kitchen Sink'),(42823,121,5,6141,'blanco-andano-xl-6-s-if-compact-inset-stainless-steel-kitchen-sink'),(42824,121,0,6141,'blanco-andano-xl-6-s-if-compact-inset-stainless-steel-kitchen-sink'),(42825,84,5,6141,'Blanco Andano XL 6 S-IF Compact Inset Stainless Steel Sink | Banyo UK'),(42826,84,0,6141,'Blanco Andano XL 6 S-IF Compact Inset Stainless Steel Sink | Banyo UK'),(42827,86,5,6141,'Wide range of Blanco Andano XL 6 S-IF Compact Inset Stainless Steel Kitchen Sink availabe for at banyo.all our products are made from finest material to make them durable and attractive.'),(42828,86,0,6141,'Wide range of Blanco Andano XL 6 S-IF Compact Inset Stainless Steel Kitchen Sink availabe for at banyo.all our products are made from finest material to make them durable and attractive.'),(42829,73,5,6141,'Blanco Andano XL 6 S-IF Compact Inset Kitchen Sink'),(42830,73,0,6141,'Blanco Andano XL 6 S-IF Compact Inset Kitchen Sink'),(42831,109,5,6141,'Blanco Andano XL 6 S-IF Compact Inset Kitchen Sink'),(42832,109,0,6141,'Blanco Andano XL 6 S-IF Compact Inset Kitchen Sink'),(42833,121,5,6142,'franke-ariane-arx-110-17-undermount-1-0-bowl-kitchen-sink'),(42834,121,0,6142,'franke-ariane-arx-110-17-undermount-1-0-bowl-kitchen-sink'),(42835,84,5,6142,'Franke Ariane ARX 110 17 Undermount 0.5 Bowl Kitchen Sink'),(42836,84,0,6142,'Franke Ariane ARX 110 17 Undermount 0.5 Bowl Kitchen Sink'),(42837,86,5,6142,'Franke Ariane ARX 110 17 is an Undermount Stainless Steel 0.5 Bowl Sink available at Banyo with a special discounted price. Suitable for solid worktop surfaces like Solid wood and Granite.'),(42838,86,0,6142,'Franke Ariane ARX 110 17 is an Undermount Stainless Steel 0.5 Bowl Sink available at Banyo with a special discounted price. Suitable for solid worktop surfaces like Solid wood and Granite.'),(42839,73,5,6142,'Franke Ariane ARX 110 17 Undermount 0.5 Bowl Kitchen Sink'),(42840,73,0,6142,'Franke Ariane ARX 110 17 Undermount 0.5 Bowl Kitchen Sink'),(42841,109,5,6142,'Franke Ariane ARX 110 17 Undermount 0.5 Bowl Kitchen Sink'),(42842,109,0,6142,'Franke Ariane ARX 110 17 Undermount 0.5 Bowl Kitchen Sink'),(42843,121,5,6143,'franke-ariane-arx-110-17-d-undermount-kitchen-sink-stainless-steel'),(42844,121,0,6143,'franke-ariane-arx-110-17-d-undermount-kitchen-sink-stainless-steel'),(42845,84,5,6143,'Franke Ariane ARX 110 17-D Undermount 1.0 Bowl Kitchen Sink - ARX 110 17-D'),(42846,84,0,6143,'Franke Ariane ARX 110 17-D Undermount 1.0 Bowl Kitchen Sink - ARX 110 17-D'),(42847,86,5,6143,'Big savings Deals on Franke Ariane ARX 110 17-D Undermount 1.0 Bowl Kitchen Sink only at Banyo. Get manufacturer warranty and fastest delivery services just call us now.'),(42848,86,0,6143,'Big savings Deals on Franke Ariane ARX 110 17-D Undermount 1.0 Bowl Kitchen Sink only at Banyo. Get manufacturer warranty and fastest delivery services just call us now.'),(42849,73,5,6143,'Franke Ariane ARX 110 17-D Undermount 0.5 Bowl Kitchen Sink'),(42850,73,0,6143,'Franke Ariane ARX 110 17-D Undermount 0.5 Bowl Kitchen Sink'),(42851,109,5,6143,'Franke Ariane ARX 110 17-D Undermount 0.5 Bowl Kitchen Sink'),(42852,109,0,6143,'Franke Ariane ARX 110 17-D Undermount 0.5 Bowl Kitchen Sink'),(42853,121,5,6144,'franke-ariane-arx-110-33-undermount-kitchen-sink-stainless-steel'),(42854,121,0,6144,'franke-ariane-arx-110-33-undermount-kitchen-sink-stainless-steel'),(42855,84,5,6144,'Franke Ariane ARX 110 33 Undermount 1.0 Bowl Kitchen Sink - Stainless Steel - ARX 110 33'),(42856,84,0,6144,'Franke Ariane ARX 110 33 Undermount 1.0 Bowl Kitchen Sink - Stainless Steel - ARX 110 33'),(42857,86,5,6144,'Big savings sales on Franke Ariane ARX 110 33 Undermount 1.0 Bowl Stainless Steel Kitchen Sink at Banyo. We are offering unbeatable prices and fastest delivery across UK.'),(42858,86,0,6144,'Big savings sales on Franke Ariane ARX 110 33 Undermount 1.0 Bowl Stainless Steel Kitchen Sink at Banyo. We are offering unbeatable prices and fastest delivery across UK.'),(42859,73,5,6144,'Franke Ariane ARX 110 33 Undermount 1.0 Bowl Kitchen Sink'),(42860,73,0,6144,'Franke Ariane ARX 110 33 Undermount 1.0 Bowl Kitchen Sink'),(42861,109,5,6144,'Franke Ariane ARX 110 33 Undermount 1.0 Bowl Kitchen Sink'),(42862,109,0,6144,'Franke Ariane ARX 110 33 Undermount 1.0 Bowl Kitchen Sink'),(42863,121,5,6145,'franke-ariane-arx-110-35-undermount-kitchen-sink-stainless-steel'),(42864,121,0,6145,'franke-ariane-arx-110-35-undermount-kitchen-sink-stainless-steel'),(42865,84,5,6145,'Franke Ariane ARX 110 35 Undermount 1.0 Bowl Kitchen Sink Stainless Steel - ARX 110 35'),(42866,84,0,6145,'Franke Ariane ARX 110 35 Undermount 1.0 Bowl Kitchen Sink Stainless Steel - ARX 110 35'),(42867,86,5,6145,'Get the best Deals on Franke Ariane ARX 110 35 Undermount Kitchen Sink at Banyo.we boast high quality and fastest delivery services in all over United Kingdom.'),(42868,86,0,6145,'Get the best Deals on Franke Ariane ARX 110 35 Undermount Kitchen Sink at Banyo.we boast high quality and fastest delivery services in all over United Kingdom.'),(42869,73,5,6145,'Franke Ariane ARX 110 35 Undermount 1.0 Bowl Kitchen Sink'),(42870,73,0,6145,'Franke Ariane ARX 110 35 Undermount 1.0 Bowl Kitchen Sink'),(42871,109,5,6145,'Franke Ariane ARX 110 35 Undermount 1.0 Bowl Kitchen Sink'),(42872,109,0,6145,'Franke Ariane ARX 110 35 Undermount 1.0 Bowl Kitchen Sink'),(42873,121,5,6146,'franke-ariane-arx-160-undermount-kitchen-sink-stainless-steel'),(42874,121,0,6146,'franke-ariane-arx-160-undermount-kitchen-sink-stainless-steel'),(42875,84,5,6146,'Franke Ariane ARX 160 Undermount 1.0 Bowl Kitchen Sink Stainless Steel - ARX 160'),(42876,84,0,6146,'Franke Ariane ARX 160 Undermount 1.0 Bowl Kitchen Sink Stainless Steel - ARX 160'),(42877,86,5,6146,'We sell highest quality home appliances at lowest competitive prices. Franke Ariane ARX 160 Undermount 1.0 Bowl Kitchen Sink best deals are now available at Banyo.'),(42878,86,0,6146,'We sell highest quality home appliances at lowest competitive prices. Franke Ariane ARX 160 Undermount 1.0 Bowl Kitchen Sink best deals are now available at Banyo.'),(42879,73,5,6146,'Franke Ariane ARX 160 Undermount 1.5 Bowl Kitchen Sink'),(42880,73,0,6146,'Franke Ariane ARX 160 Undermount 1.5 Bowl Kitchen Sink'),(42881,109,5,6146,'Franke Ariane ARX 160 Undermount 1.5 Bowl Kitchen Sink'),(42882,109,0,6146,'Franke Ariane ARX 160 Undermount 1.5 Bowl Kitchen Sink'),(42883,121,5,6147,'franke-ariane-arx-160-d-undermount-kitchen-sink-stainless-steel'),(42884,121,0,6147,'franke-ariane-arx-160-d-undermount-kitchen-sink-stainless-steel'),(42885,84,5,6147,'Franke Ariane ARX 160-D Undermount 1.0 Bowl Kitchen Sink Stainless Steel - ARX 160-D'),(42886,84,0,6147,'Franke Ariane ARX 160-D Undermount 1.0 Bowl Kitchen Sink Stainless Steel - ARX 160-D'),(42887,86,5,6147,'Get the best Price deals for Franke Ariane ARX 160-D Undermount 1.0 Bowl Kitchen Sink Stainless Steel at Banyo. Fantastic deals and free delivery services available right now.'),(42888,86,0,6147,'Get the best Price deals for Franke Ariane ARX 160-D Undermount 1.0 Bowl Kitchen Sink Stainless Steel at Banyo. Fantastic deals and free delivery services available right now.'),(42889,73,5,6147,'Franke Ariane ARX 160-D Undermount 1.5 Bowl Kitchen Sink'),(42890,73,0,6147,'Franke Ariane ARX 160-D Undermount 1.5 Bowl Kitchen Sink'),(42891,109,5,6147,'Franke Ariane ARX 160-D Undermount 1.5 Bowl Kitchen Sink'),(42892,109,0,6147,'Franke Ariane ARX 160-D Undermount 1.5 Bowl Kitchen Sink'),(42893,121,5,6148,'reginox-atlantis-ops-l-integrated-1-bowl-kitchen-sink'),(42894,121,0,6148,'reginox-atlantis-ops-l-integrated-1-bowl-kitchen-sink'),(42895,84,5,6148,'Reginox Atlantis OPS L Integrated 1 Bowl Kitchen Sink'),(42896,84,0,6148,'Reginox Atlantis OPS L Integrated 1 Bowl Kitchen Sink'),(42897,86,5,6148,'Reginox Atlantis OPS L Integrated 1 Bowl Kitchen Sink'),(42898,86,0,6148,'Reginox Atlantis OPS L Integrated 1 Bowl Kitchen Sink'),(42899,73,5,6148,'Reginox Atlantis OPS L Integrated 1 Bowl Kitchen Sink'),(42900,73,0,6148,'Reginox Atlantis OPS L Integrated 1 Bowl Kitchen Sink'),(42901,109,5,6148,'Reginox Atlantis OPS L Integrated 1 Bowl Kitchen Sink'),(42902,109,0,6148,'Reginox Atlantis OPS L Integrated 1 Bowl Kitchen Sink'),(42903,121,5,6149,'blanco-axia-iii-6-s-silgranit-puradur-iir-inset-sink'),(42904,121,0,6149,'blanco-axia-iii-6-s-silgranit-puradur-iir-inset-sink'),(42905,84,5,6149,'Blanco AXIA III 6 S - Silgranit PuraDur - 1.5 Bowl Kitchen Sink | Banyo'),(42906,84,0,6149,'Blanco AXIA III 6 S - Silgranit PuraDur - 1.5 Bowl Kitchen Sink | Banyo'),(42907,86,5,6149,'Blanco AXIA III 6 S Silgranit PuraDur II® Inset Sink'),(42908,86,0,6149,'Blanco AXIA III 6 S Silgranit PuraDur II® Inset Sink'),(42909,73,5,6149,'Blanco AXIA III 6 S Silgranit PuraDur IIÂ® Inset Sink'),(42910,73,0,6149,'Blanco AXIA III 6 S Silgranit PuraDur IIÂ® Inset Sink'),(42911,109,5,6149,'Blanco AXIA III 6 S Silgranit PuraDur II® Inset Sink'),(42912,109,0,6149,'Blanco AXIA III 6 S Silgranit PuraDur II® Inset Sink'),(42913,121,5,6150,'blanco-axia-iii-xl-6-s-silgranit-puradur-iir-inset-sink'),(42914,121,0,6150,'blanco-axia-iii-xl-6-s-silgranit-puradur-iir-inset-sink'),(42915,84,5,6150,'Blanco AXIA III XL 6 S Silgranit PuraDur Inset Kitchen Sink | Banyo'),(42916,84,0,6150,'Blanco AXIA III XL 6 S Silgranit PuraDur Inset Kitchen Sink | Banyo'),(42917,86,5,6150,'Blanco AXIA III XL 6 S Silgranit PuraDur II® Inset Sink'),(42918,86,0,6150,'Blanco AXIA III XL 6 S Silgranit PuraDur II® Inset Sink'),(42919,73,5,6150,'Blanco AXIA III XL 6 S Silgranit PuraDur IIÂ® Inset Sink'),(42920,73,0,6150,'Blanco AXIA III XL 6 S Silgranit PuraDur IIÂ® Inset Sink'),(42921,109,5,6150,'Blanco AXIA III XL 6 S Silgranit PuraDur II® Inset Sink'),(42922,109,0,6150,'Blanco AXIA III XL 6 S Silgranit PuraDur II® Inset Sink'),(42923,121,5,6151,'blanco-axis-iii-6-s-if-stainless-steel-inset-sink'),(42924,121,0,6151,'blanco-axis-iii-6-s-if-stainless-steel-inset-sink'),(42925,84,5,6151,'Blanco AXIS III 6 S-IF Stainless Steel 1.5 Bowl Sink | Banyo'),(42926,84,0,6151,'Blanco AXIS III 6 S-IF Stainless Steel 1.5 Bowl Sink | Banyo'),(42927,86,5,6151,'Blanco AXIS III 6 S-IF Stainless Steel Inset Sink'),(42928,86,0,6151,'Blanco AXIS III 6 S-IF Stainless Steel Inset Sink'),(42929,73,5,6151,'Blanco AXIS III 6 S-IF Stainless Steel Inset Sink'),(42930,73,0,6151,'Blanco AXIS III 6 S-IF Stainless Steel Inset Sink'),(42931,109,5,6151,'Blanco AXIS III 6 S-IF Stainless Steel Inset Sink'),(42932,109,0,6151,'Blanco AXIS III 6 S-IF Stainless Steel Inset Sink'),(42933,121,5,6152,'franke-antea-azg-611-78-inset-1-0-bowl-kitchen-sink'),(42934,121,0,6152,'franke-antea-azg-611-78-inset-1-0-bowl-kitchen-sink'),(42935,84,5,6152,'Franke Antea AZG 611 78 Inset 1.0 Bowl Fragranite Sink'),(42936,84,0,6152,'Franke Antea AZG 611 78 Inset 1.0 Bowl Fragranite Sink'),(42937,86,5,6152,'Buy Franke Antea AZG 611 78 Single Bowl Fragranite Sink from Banyo with a special price discount. Inset installation, Reversible Drainer, Colour options available are Polar White, Coffee & Onyx.'),(42938,86,0,6152,'Buy Franke Antea AZG 611 78 Single Bowl Fragranite Sink from Banyo with a special price discount. Inset installation, Reversible Drainer, Colour options available are Polar White, Coffee & Onyx.'),(42939,73,5,6152,'Franke Antea AZG 611 78 Inset 1.0 Bowl Kitchen Sink'),(42940,73,0,6152,'Franke Antea AZG 611 78 Inset 1.0 Bowl Kitchen Sink'),(42941,109,5,6152,'Franke Antea AZG 611 78 Inset 1.0 Bowl Kitchen Sink'),(42942,109,0,6152,'Franke Antea AZG 611 78 Inset 1.0 Bowl Kitchen Sink'),(42943,121,5,6153,'franke-antea-azg-621-inset-2-0-bowl-kitchen-sink'),(42944,121,0,6153,'franke-antea-azg-621-inset-2-0-bowl-kitchen-sink'),(42945,84,5,6153,'Franke Antea AZG 621 Inset 2.0 Bowl Fragranite Sink'),(42946,84,0,6153,'Franke Antea AZG 621 Inset 2.0 Bowl Fragranite Sink'),(42947,86,5,6153,'Franke Antea AZG 621 is a stylish Double Bowl Fragranite Sink available in elegant shades of Polar White, Coffee & Onyx. A stylish addition to any modern designed kitchen. Unbeatable Prices Guaranteed!'),(42948,86,0,6153,'Franke Antea AZG 621 is a stylish Double Bowl Fragranite Sink available in elegant shades of Polar White, Coffee & Onyx. A stylish addition to any modern designed kitchen. Unbeatable Prices Guaranteed!'),(42949,73,5,6153,'Franke Antea AZG 621 Inset 2.0 Bowl Kitchen Sink'),(42950,73,0,6153,'Franke Antea AZG 621 Inset 2.0 Bowl Kitchen Sink'),(42951,109,5,6153,'Franke Antea AZG 621 Inset 2.0 Bowl Kitchen Sink'),(42952,109,0,6153,'Franke Antea AZG 621 Inset 2.0 Bowl Kitchen Sink'),(42953,121,5,6154,'franke-antea-azg-651-inset-1-5-bowl-kitchen-sink'),(42954,121,0,6154,'franke-antea-azg-651-inset-1-5-bowl-kitchen-sink'),(42955,84,5,6154,'Franke Antea AZG 651 Inset 1.5 Bowl Fragranite Sink'),(42956,84,0,6154,'Franke Antea AZG 651 Inset 1.5 Bowl Fragranite Sink'),(42957,86,5,6154,'Special price discount is available on Franke Antea AZG 651 1.5 Bowl Fragranite Sink from Banyo. Inset Installation, Reversible Drainer and colour options available are Polar White, Onyx and Coffee.'),(42958,86,0,6154,'Special price discount is available on Franke Antea AZG 651 1.5 Bowl Fragranite Sink from Banyo. Inset Installation, Reversible Drainer and colour options available are Polar White, Onyx and Coffee.'),(42959,73,5,6154,'Franke Antea AZG 651 Inset 1.5 Bowl Kitchen Sink'),(42960,73,0,6154,'Franke Antea AZG 651 Inset 1.5 Bowl Kitchen Sink'),(42961,109,5,6154,'Franke Antea AZG 651 Inset 1.5 Bowl Kitchen Sink'),(42962,109,0,6154,'Franke Antea AZG 651 Inset 1.5 Bowl Kitchen Sink'),(42963,121,5,6155,'franke-antea-azn-611-100-inset-1-bowl-kitchen-sink-stainless-steel'),(42964,121,0,6155,'franke-antea-azn-611-100-inset-1-bowl-kitchen-sink-stainless-steel'),(42965,84,5,6155,'Franke Antea AZN 611-100 Inset 1 Bowl Kitchen Sink Stainless Steel'),(42966,84,0,6155,'Franke Antea AZN 611-100 Inset 1 Bowl Kitchen Sink Stainless Steel'),(42967,86,5,6155,'Buy Franke Antea AZN 611-100 Stainless Steel Single Bowl Sink with a special price discount from Banyo. Reversible Drainer, Inset Installation are just a few features which makes this a perfect fit for any kitchen.'),(42968,86,0,6155,'Buy Franke Antea AZN 611-100 Stainless Steel Single Bowl Sink with a special price discount from Banyo. Reversible Drainer, Inset Installation are just a few features which makes this a perfect fit for any kitchen.'),(42969,73,5,6155,'Franke Antea AZN 611-100 Inset 1 Bowl Kitchen Sink Stainless Steel'),(42970,73,0,6155,'Franke Antea AZN 611-100 Inset 1 Bowl Kitchen Sink Stainless Steel'),(42971,109,5,6155,'Franke Antea AZN 611-100 Inset 1 Bowl Kitchen Sink Stainless Steel'),(42972,109,0,6155,'Franke Antea AZN 611-100 Inset 1 Bowl Kitchen Sink Stainless Steel'),(42973,121,5,6156,'franke-antea-azn-611-86-stainless-steel-1-bowl-kitchen-sink'),(42974,121,0,6156,'franke-antea-azn-611-86-stainless-steel-1-bowl-kitchen-sink'),(42975,84,5,6156,'Franke Antea AZN 611-86 Stainless Steel 1 Bowl Kitchen Sink'),(42976,84,0,6156,'Franke Antea AZN 611-86 Stainless Steel 1 Bowl Kitchen Sink'),(42977,86,5,6156,'Franke Antea AZN 611-86 is an Inset Single Bowl Stainless Steel Sink with optional Siphon I, Plumbing Kit & Turbo Elite Waste Disposal Unit. Durable, Reversible Drainer makes it a perfect fit for any modern Kitchen.'),(42978,86,0,6156,'Franke Antea AZN 611-86 is an Inset Single Bowl Stainless Steel Sink with optional Siphon I, Plumbing Kit & Turbo Elite Waste Disposal Unit. Durable, Reversible Drainer makes it a perfect fit for any modern Kitchen.'),(42979,73,5,6156,'Franke Antea AZN 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel'),(42980,73,0,6156,'Franke Antea AZN 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel'),(42981,109,5,6156,'Franke Antea AZN 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel'),(42982,109,0,6156,'Franke Antea AZN 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel'),(42983,121,5,6157,'franke-antea-azn-651-inset-1-5-bowl-kitchen-sink-stainless-steel'),(42984,121,0,6157,'franke-antea-azn-651-inset-1-5-bowl-kitchen-sink-stainless-steel'),(42985,84,5,6157,'Franke Antea AZN 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(42986,84,0,6157,'Franke Antea AZN 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(42987,86,5,6157,'Best saving deals on Franke Antea AZN 651 Inset 1.5 Bowl Stainless Steel Kitchen Sink available at Banyo. Get fantastic deals and fastest delivery to your doorstep.'),(42988,86,0,6157,'Best saving deals on Franke Antea AZN 651 Inset 1.5 Bowl Stainless Steel Kitchen Sink available at Banyo. Get fantastic deals and fastest delivery to your doorstep.'),(42989,73,5,6157,'Franke Antea AZN 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(42990,73,0,6157,'Franke Antea AZN 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(42991,109,5,6157,'Franke Antea AZN 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(42992,109,0,6157,'Franke Antea AZN 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(42993,121,5,6158,'franke-bak-710-pro-value-belfast-kitchen-sink-ceramic-white'),(42994,121,0,6158,'franke-bak-710-pro-value-belfast-kitchen-sink-ceramic-white'),(42995,84,5,6158,'Franke BAK 710 Belfast Kitchen Sink Ceramic White - 130.0050.116 - BAK 710'),(42996,84,0,6158,'Franke BAK 710 Belfast Kitchen Sink Ceramic White - 130.0050.116 - BAK 710'),(42997,86,5,6158,'Franke BAK 710 Belfast white Ceramic Kitchen Sink best possible deals at Banyo. We are offering cheapest sinks deals in UK. To get a fastest delivery place an order right now.'),(42998,86,0,6158,'Franke BAK 710 Belfast white Ceramic Kitchen Sink best possible deals at Banyo. We are offering cheapest sinks deals in UK. To get a fastest delivery place an order right now.'),(42999,73,5,6158,'Franke BAK 710 Belfast 1.0 Bowl Kitchen Sink Ceramic White - 130.0050.116'),(43000,73,0,6158,'Franke BAK 710 Belfast 1.0 Bowl Kitchen Sink Ceramic White - 130.0050.116'),(43001,109,5,6158,'Franke BAK 710 Belfast 1.0 Bowl Kitchen Sink Ceramic White - 130.0050.116'),(43002,109,0,6158,'Franke BAK 710 Belfast 1.0 Bowl Kitchen Sink Ceramic White - 130.0050.116'),(43003,121,5,6159,'reginox-belfast-contemporary-1-bowl-ceramic-kitchen-inset-sink'),(43004,121,0,6159,'reginox-belfast-contemporary-1-bowl-ceramic-kitchen-inset-sink'),(43005,84,5,6159,'Reginox Belfast Contemporary 1 Bowl Ceramic Kitchen Inset Sink'),(43006,84,0,6159,'Reginox Belfast Contemporary 1 Bowl Ceramic Kitchen Inset Sink'),(43007,86,5,6159,'Reginox Belfast Contemporary 1 Bowl Ceramic Kitchen Inset Sink'),(43008,86,0,6159,'Reginox Belfast Contemporary 1 Bowl Ceramic Kitchen Inset Sink'),(43009,73,5,6159,'Reginox Belfast Contemporary 1 Bowl Ceramic Kitchen Inset Sink'),(43010,73,0,6159,'Reginox Belfast Contemporary 1 Bowl Ceramic Kitchen Inset Sink'),(43011,109,5,6159,'Reginox Belfast Contemporary 1 Bowl Ceramic Kitchen Inset Sink'),(43012,109,0,6159,'Reginox Belfast Contemporary 1 Bowl Ceramic Kitchen Inset Sink'),(43013,121,5,6160,'reginox-best-450-inset-2-bowl-granite-kitchen-sink'),(43014,121,0,6160,'reginox-best-450-inset-2-bowl-granite-kitchen-sink'),(43015,84,5,6160,'Reginox Best 450 Inset 2 Bowl Granite Kitchen Sink'),(43016,84,0,6160,'Reginox Best 450 Inset 2 Bowl Granite Kitchen Sink'),(43017,86,5,6160,'Reginox Best 450 Inset 2 Bowl Granite Kitchen Sink'),(43018,86,0,6160,'Reginox Best 450 Inset 2 Bowl Granite Kitchen Sink'),(43019,73,5,6160,'Reginox Best 450 Inset 2 Bowl Granite Kitchen Sink'),(43020,73,0,6160,'Reginox Best 450 Inset 2 Bowl Granite Kitchen Sink'),(43021,109,5,6160,'Reginox Best 450 Inset 2 Bowl Granite Kitchen Sink'),(43022,109,0,6160,'Reginox Best 450 Inset 2 Bowl Granite Kitchen Sink'),(43023,121,5,6161,'reginox-best-475-inset-1-5-bowl-granite-kitchen-sink'),(43024,121,0,6161,'reginox-best-475-inset-1-5-bowl-granite-kitchen-sink'),(43025,84,5,6161,'Reginox Best 475 Inset 1.5 Bowl Granite Kitchen Sink'),(43026,84,0,6161,'Reginox Best 475 Inset 1.5 Bowl Granite Kitchen Sink'),(43027,86,5,6161,'Reginox Best 475 Inset 1.5 Bowl Granite Kitchen Sink'),(43028,86,0,6161,'Reginox Best 475 Inset 1.5 Bowl Granite Kitchen Sink'),(43029,73,5,6161,'Reginox Best 475 Inset 1.5 Bowl Granite Kitchen Sink'),(43030,73,0,6161,'Reginox Best 475 Inset 1.5 Bowl Granite Kitchen Sink'),(43031,109,5,6161,'Reginox Best 475 Inset 1.5 Bowl Granite Kitchen Sink'),(43032,109,0,6161,'Reginox Best 475 Inset 1.5 Bowl Granite Kitchen Sink'),(43033,121,5,6162,'reginox-best-480-inset-1-bowl-granite-kitchen-sink'),(43034,121,0,6162,'reginox-best-480-inset-1-bowl-granite-kitchen-sink'),(43035,84,5,6162,'Reginox Best 480 Inset 1 Bowl Granite Kitchen Sink'),(43036,84,0,6162,'Reginox Best 480 Inset 1 Bowl Granite Kitchen Sink'),(43037,86,5,6162,'Reginox Best 480 Inset 1 Bowl Granite Kitchen Sink'),(43038,86,0,6162,'Reginox Best 480 Inset 1 Bowl Granite Kitchen Sink'),(43039,73,5,6162,'Reginox Best 480 Inset 1 Bowl Granite Kitchen Sink'),(43040,73,0,6162,'Reginox Best 480 Inset 1 Bowl Granite Kitchen Sink'),(43041,109,5,6162,'Reginox Best 480 Inset 1 Bowl Granite Kitchen Sink'),(43042,109,0,6162,'Reginox Best 480 Inset 1 Bowl Granite Kitchen Sink'),(43043,121,5,6163,'reginox-comfort-beta-20-inset-2-bowl-kitchen-sink'),(43044,121,0,6163,'reginox-comfort-beta-20-inset-2-bowl-kitchen-sink'),(43045,84,5,6163,'Reginox Comfort BETA 20 Inset 2 Bowl Kitchen Sink'),(43046,84,0,6163,'Reginox Comfort BETA 20 Inset 2 Bowl Kitchen Sink'),(43047,86,5,6163,'Reginox Comfort BETA 20 Inset 2 Bowl Kitchen Sink'),(43048,86,0,6163,'Reginox Comfort BETA 20 Inset 2 Bowl Kitchen Sink'),(43049,73,5,6163,'Reginox Comfort BETA 20 Inset 2 Bowl Kitchen Sink'),(43050,73,0,6163,'Reginox Comfort BETA 20 Inset 2 Bowl Kitchen Sink'),(43051,109,5,6163,'Reginox Comfort BETA 20 Inset 2 Bowl Kitchen Sink'),(43052,109,0,6163,'Reginox Comfort BETA 20 Inset 2 Bowl Kitchen Sink'),(43053,121,5,6164,'franke-basis-bfg-611-78-kitchen-sink'),(43054,121,0,6164,'franke-basis-bfg-611-78-kitchen-sink'),(43055,84,5,6164,'Franke Basis BFG 611-78 Kitchen Sink'),(43056,84,0,6164,'Franke Basis BFG 611-78 Kitchen Sink'),(43057,86,5,6164,'Franke Basis BFG 611-78 Kitchen Sink'),(43058,86,0,6164,'Franke Basis BFG 611-78 Kitchen Sink'),(43059,73,5,6164,'Franke Basis BFG 611-78 Kitchen Sink'),(43060,73,0,6164,'Franke Basis BFG 611-78 Kitchen Sink'),(43061,109,5,6164,'Franke Basis BFG 611-78 Kitchen Sink'),(43062,109,0,6164,'Franke Basis BFG 611-78 Kitchen Sink'),(43063,110,5,6164,'Franke Basis BFG 611-78 Kitchen Sink'),(43064,110,0,6164,'Franke Basis BFG 611-78 Kitchen Sink'),(43065,111,5,6164,'Franke Basis BFG 611-78 Kitchen Sink'),(43066,111,0,6164,'Franke Basis BFG 611-78 Kitchen Sink'),(43067,121,5,6165,'franke-basis-bfg-611-97-inset-1-bowl-kitchen-sink-fragranite'),(43068,121,0,6165,'franke-basis-bfg-611-97-inset-1-bowl-kitchen-sink-fragranite'),(43069,84,5,6165,'Franke Basis BFG 611-97 Inset 1 Bowl Kitchen Sink Fragranite'),(43070,84,0,6165,'Franke Basis BFG 611-97 Inset 1 Bowl Kitchen Sink Fragranite'),(43071,86,5,6165,'Buy Franke Basis BFG 611-97 Single Bowl Fragranite Sink with a special price discount from Banyo. Reversible Drainer, Available Colour choices are Coffee, Onyx, Polar White and Stone Grey.'),(43072,86,0,6165,'Buy Franke Basis BFG 611-97 Single Bowl Fragranite Sink with a special price discount from Banyo. Reversible Drainer, Available Colour choices are Coffee, Onyx, Polar White and Stone Grey.'),(43073,73,5,6165,'Franke Basis BFG 611-97 Inset 1 Bowl Kitchen Sink Fragranite'),(43074,73,0,6165,'Franke Basis BFG 611-97 Inset 1 Bowl Kitchen Sink Fragranite'),(43075,109,5,6165,'Franke Basis BFG 611-97 Inset 1 Bowl Kitchen Sink Fragranite'),(43076,109,0,6165,'Franke Basis BFG 611-97 Inset 1 Bowl Kitchen Sink Fragranite'),(43077,121,5,6166,'franke-bfg-651-basis-fragranite-kitchen-sink'),(43078,121,0,6166,'franke-bfg-651-basis-fragranite-kitchen-sink'),(43079,84,5,6166,'Franke BFG 651 Basis Fragranite Inset Kitchen Sink - BFG 651'),(43080,84,0,6166,'Franke BFG 651 Basis Fragranite Inset Kitchen Sink - BFG 651'),(43081,86,5,6166,'We are offering Franke BFG 651 Basis Fragranite Inset Kitchen Sink at unbeatable prices on banyo. We have the cheapest deals on all bathroom appliances in United Kingdom.'),(43082,86,0,6166,'We are offering Franke BFG 651 Basis Fragranite Inset Kitchen Sink at unbeatable prices on banyo. We have the cheapest deals on all bathroom appliances in United Kingdom.'),(43083,73,5,6166,'Franke BFG 651 Basis Fragranite Inset 1.5 Bowl Kitchen Sink'),(43084,73,0,6166,'Franke BFG 651 Basis Fragranite Inset 1.5 Bowl Kitchen Sink'),(43085,109,5,6166,'Franke BFG 651 Basis Fragranite Inset 1.5 Bowl Kitchen Sink'),(43086,109,0,6166,'Franke BFG 651 Basis Fragranite Inset 1.5 Bowl Kitchen Sink'),(43087,121,5,6167,'franke-box-center-bwx-120-41-27-inset-stainless-steel-1-5-bowl-sink'),(43088,121,0,6167,'franke-box-center-bwx-120-41-27-inset-stainless-steel-1-5-bowl-sink'),(43089,84,5,6167,'Franke Box Center BWX 120-41-27 Inset Stainless Steel 1.5 Bowl Sink'),(43090,84,0,6167,'Franke Box Center BWX 120-41-27 Inset Stainless Steel 1.5 Bowl Sink'),(43091,86,5,6167,'Franke Box Center BWX 120-41-27 Inset Stainless Steel 1.5 Bowl Sink '),(43092,86,0,6167,'Franke Box Center BWX 120-41-27 Inset Stainless Steel 1.5 Bowl Sink '),(43093,73,5,6167,'Franke Box Center BWX 120-41-27 Inset Stainless Steel 1.5 Bowl Sink'),(43094,73,0,6167,'Franke Box Center BWX 120-41-27 Inset Stainless Steel 1.5 Bowl Sink'),(43095,121,5,6168,'franke-box-center-bwx-220-41-27-inset-stainless-steel-1-5-bowl-sink'),(43096,121,0,6168,'franke-box-center-bwx-220-41-27-inset-stainless-steel-1-5-bowl-sink'),(43097,84,5,6168,'Franke Box Center BWX 220 41-27 Inset Stainless Steel 1.5 Bowl Sink'),(43098,84,0,6168,'Franke Box Center BWX 220 41-27 Inset Stainless Steel 1.5 Bowl Sink'),(43099,86,5,6168,'Franke Box Center BWX 220 41-27 Inset Stainless Steel 1.5 Bowl Sink'),(43100,86,0,6168,'Franke Box Center BWX 220 41-27 Inset Stainless Steel 1.5 Bowl Sink'),(43101,73,5,6168,'Franke Box Center BWX 220 41-27 Inset Stainless Steel 1.5 Bowl Sink'),(43102,73,0,6168,'Franke Box Center BWX 220 41-27 Inset Stainless Steel 1.5 Bowl Sink'),(43103,121,5,6169,'franke-box-center-bwx-220-54-27-undermount-1-5-bowl-kitchen-sink-stainless-steel'),(43104,121,0,6169,'franke-box-center-bwx-220-54-27-undermount-1-5-bowl-kitchen-sink-stainless-steel'),(43105,84,5,6169,'Franke Box Center BWX 220 54-27 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(43106,84,0,6169,'Franke Box Center BWX 220 54-27 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(43107,86,5,6169,'Box Center BWX 220 54-27 by Franke is a stainless steel 1.5 Bowl Inset Sink with Left or Right-hand choice for the Accessory compartment (Small Bowl). All the Accessories are included.'),(43108,86,0,6169,'Box Center BWX 220 54-27 by Franke is a stainless steel 1.5 Bowl Inset Sink with Left or Right-hand choice for the Accessory compartment (Small Bowl). All the Accessories are included.'),(43109,73,5,6169,'Franke Box Center BWX 220 54-27 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(43110,73,0,6169,'Franke Box Center BWX 220 54-27 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(43111,109,5,6169,'Franke Box Center BWX 220 54-27 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(43112,109,0,6169,'Franke Box Center BWX 220 54-27 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(43113,121,5,6170,'franke-box-bxx-110-16-half-bowl-kitchen-sink'),(43114,121,0,6170,'franke-box-bxx-110-16-half-bowl-kitchen-sink'),(43115,84,5,6170,'Franke Box BXX 110-16 Half Bowl Kitchen Sink'),(43116,84,0,6170,'Franke Box BXX 110-16 Half Bowl Kitchen Sink'),(43117,86,5,6170,'Franke Box BXX 110-16 Half Bowl Kitchen Sink'),(43118,86,0,6170,'Franke Box BXX 110-16 Half Bowl Kitchen Sink'),(43119,73,5,6170,'Franke Box BXX 110-16 Half Bowl Kitchen Sink'),(43120,73,0,6170,'Franke Box BXX 110-16 Half Bowl Kitchen Sink'),(43121,109,5,6170,'Franke Box BXX 110-16 Half Bowl Stainless Steel Sink'),(43122,109,0,6170,'Franke Box BXX 110-16 Half Bowl Stainless Steel Sink'),(43123,110,5,6170,'Franke Box BXX 110-16 Half Bowl Stainless Steel Sink'),(43124,110,0,6170,'Franke Box BXX 110-16 Half Bowl Stainless Steel Sink'),(43125,111,5,6170,'Franke Box BXX 110-16 Half Bowl Stainless Steel Sink'),(43126,111,0,6170,'Franke Box BXX 110-16 Half Bowl Stainless Steel Sink'),(43127,121,5,6171,'franke-box-bxx-110-40-undermount-1-bowl-kitchen-sink-stainless-steel'),(43128,121,0,6171,'franke-box-bxx-110-40-undermount-1-bowl-kitchen-sink-stainless-steel'),(43129,84,5,6171,'Franke Box BXX 110 40 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43130,84,0,6171,'Franke Box BXX 110 40 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43131,86,5,6171,'Franke Box BXX 110 40 is an Undermount Single Bowl Sink with a brushed stainless steel finish. Patented hygienic overflow, Suitable for 500mm cabinet, Compatible with waste disposal unit.'),(43132,86,0,6171,'Franke Box BXX 110 40 is an Undermount Single Bowl Sink with a brushed stainless steel finish. Patented hygienic overflow, Suitable for 500mm cabinet, Compatible with waste disposal unit.'),(43133,73,5,6171,'Franke Box BXX 110 40 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43134,73,0,6171,'Franke Box BXX 110 40 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43135,109,5,6171,'Franke Box BXX 110 40 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43136,109,0,6171,'Franke Box BXX 110 40 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43137,121,5,6172,'franke-box-bxx-110-50-undermount-1-bowl-kitchen-sink-stainless-steel'),(43138,121,0,6172,'franke-box-bxx-110-50-undermount-1-bowl-kitchen-sink-stainless-steel'),(43139,84,5,6172,'Franke Box BXX 110 50 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43140,84,0,6172,'Franke Box BXX 110 50 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43141,86,5,6172,'Franke Box BXX 110 50 is a Single Bowl Kitchen Sink with new contemporary brushed Stainless Steel finish. Undermount Installation, Patented Hygienic Overflow, Suitable with 600mm cabinet.'),(43142,86,0,6172,'Franke Box BXX 110 50 is a Single Bowl Kitchen Sink with new contemporary brushed Stainless Steel finish. Undermount Installation, Patented Hygienic Overflow, Suitable with 600mm cabinet.'),(43143,73,5,6172,'Franke Box BXX 110 50 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43144,73,0,6172,'Franke Box BXX 110 50 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43145,109,5,6172,'Franke Box BXX 110 50 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43146,109,0,6172,'Franke Box BXX 110 50 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43147,121,5,6173,'franke-box-bxx-110-54-undermount-1-bowl-kitchen-sink-stainless-steel'),(43148,121,0,6173,'franke-box-bxx-110-54-undermount-1-bowl-kitchen-sink-stainless-steel'),(43149,84,5,6173,'Franke Box BXX 110 54 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43150,84,0,6173,'Franke Box BXX 110 54 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43151,86,5,6173,'Buy Franke Box BXX 110 54 Undermount Single Bowl Kitchen Sink with new contemporary brushed Stainless Steel finish from Banyo with the lowest price in the UK. Patented hygienic overflow, Suitable for 600mm cabinet.'),(43152,86,0,6173,'Buy Franke Box BXX 110 54 Undermount Single Bowl Kitchen Sink with new contemporary brushed Stainless Steel finish from Banyo with the lowest price in the UK. Patented hygienic overflow, Suitable for 600mm cabinet.'),(43153,73,5,6173,'Franke Box BXX 110 54 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43154,73,0,6173,'Franke Box BXX 110 54 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43155,109,5,6173,'Franke Box BXX 110 54 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43156,109,0,6173,'Franke Box BXX 110 54 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43157,121,5,6174,'franke-bxx-110-68-box-single-bowl-undermount-kitchen-sink'),(43158,121,0,6174,'franke-bxx-110-68-box-single-bowl-undermount-kitchen-sink'),(43159,84,5,6174,'Franke BXX 110-68 Box Single Bowl Undermount Kitchen Sink'),(43160,84,0,6174,'Franke BXX 110-68 Box Single Bowl Undermount Kitchen Sink'),(43161,86,5,6174,'Franke BXX 110-68 Box Single Bowl Undermount Kitchen Sink'),(43162,86,0,6174,'Franke BXX 110-68 Box Single Bowl Undermount Kitchen Sink'),(43163,73,5,6174,'Franke BXX 110-68 Box Single Bowl Undermount Kitchen Sink'),(43164,73,0,6174,'Franke BXX 110-68 Box Single Bowl Undermount Kitchen Sink'),(43165,109,5,6174,'Franke BXX 110-68 Box Single Bowl Undermount Kitchen Sink'),(43166,109,0,6174,'Franke BXX 110-68 Box Single Bowl Undermount Kitchen Sink'),(43167,110,5,6174,'Franke BXX 110-68 Box Single Bowl Undermount Kitchen Sink'),(43168,110,0,6174,'Franke BXX 110-68 Box Single Bowl Undermount Kitchen Sink'),(43169,111,5,6174,'Franke BXX 110-68 Box Single Bowl Undermount Kitchen Sink'),(43170,111,0,6174,'Franke BXX 110-68 Box Single Bowl Undermount Kitchen Sink'),(43171,121,5,6175,'franke-box-bxx-160-34-16-undermount-1-5-bowl-kitchen-sink-stainless-steel'),(43172,121,0,6175,'franke-box-bxx-160-34-16-undermount-1-5-bowl-kitchen-sink-stainless-steel'),(43173,84,5,6175,'Franke Box BXX 160 34-16 Undermount 1.5 Bowl Kitchen Sink Stainless Steel'),(43174,84,0,6175,'Franke Box BXX 160 34-16 Undermount 1.5 Bowl Kitchen Sink Stainless Steel'),(43175,86,5,6175,'Franke Box BXX 160 34-16 Undermount 1.5 Bowl Kitchen Sink with a new contemporary brushed Stainless Steel finish. At Banyo, we offer the lowest prices, Fast delivery service all across the UK.'),(43176,86,0,6175,'Franke Box BXX 160 34-16 Undermount 1.5 Bowl Kitchen Sink with a new contemporary brushed Stainless Steel finish. At Banyo, we offer the lowest prices, Fast delivery service all across the UK.'),(43177,73,5,6175,'Franke Box BXX 160 34-16 Undermount 1.5 Bowl Kitchen Sink Stainless Steel'),(43178,73,0,6175,'Franke Box BXX 160 34-16 Undermount 1.5 Bowl Kitchen Sink Stainless Steel'),(43179,109,5,6175,'Franke Box BXX 160 34-16 Undermount 1.5 Bowl Kitchen Sink Stainless Steel'),(43180,109,0,6175,'Franke Box BXX 160 34-16 Undermount 1.5 Bowl Kitchen Sink Stainless Steel'),(43181,121,5,6176,'reginox-elite-centurio-l-integrated-1-5-bowl-kitchen-sink'),(43182,121,0,6176,'reginox-elite-centurio-l-integrated-1-5-bowl-kitchen-sink'),(43183,84,5,6176,'Reginox Elite Centurio L Integrated 1.5 Bowl Kitchen Sink'),(43184,84,0,6176,'Reginox Elite Centurio L Integrated 1.5 Bowl Kitchen Sink'),(43185,86,5,6176,'Reginox Elite Centurio L Integrated 1.5 Bowl Kitchen Sink'),(43186,86,0,6176,'Reginox Elite Centurio L Integrated 1.5 Bowl Kitchen Sink'),(43187,73,5,6176,'Reginox Elite Centurio L Integrated 1.5 Bowl Kitchen Sink'),(43188,73,0,6176,'Reginox Elite Centurio L Integrated 1.5 Bowl Kitchen Sink'),(43189,109,5,6176,'Reginox Elite Centurio L Integrated 1.5 Bowl Kitchen Sink'),(43190,109,0,6176,'Reginox Elite Centurio L Integrated 1.5 Bowl Kitchen Sink'),(43191,121,5,6177,'reginox-centurio-l10-single-bowl-kitchen-sink'),(43192,121,0,6177,'reginox-centurio-l10-single-bowl-kitchen-sink'),(43193,84,5,6177,'Reginox Centurio L10 Single Bowl Kitchen Sink'),(43194,84,0,6177,'Reginox Centurio L10 Single Bowl Kitchen Sink'),(43195,86,5,6177,'Reginox Centurio L10 Single Bowl Kitchen Sink'),(43196,86,0,6177,'Reginox Centurio L10 Single Bowl Kitchen Sink'),(43197,73,5,6177,'Reginox Centurio L10 Single Bowl Kitchen Sink'),(43198,73,0,6177,'Reginox Centurio L10 Single Bowl Kitchen Sink'),(43199,109,5,6177,'Reginox Centurio L10 Single Bowl Kitchen Sink'),(43200,109,0,6177,'Reginox Centurio L10 Single Bowl Kitchen Sink'),(43201,110,5,6177,'Reginox Centurio L10 Single Bowl Kitchen Sink'),(43202,110,0,6177,'Reginox Centurio L10 Single Bowl Kitchen Sink'),(43203,111,5,6177,'Reginox Centurio L10 Single Bowl Kitchen Sink'),(43204,111,0,6177,'Reginox Centurio L10 Single Bowl Kitchen Sink'),(43205,121,5,6178,'reginox-elite-centurio-l20-integrated-2-bowl-kitchen-sink'),(43206,121,0,6178,'reginox-elite-centurio-l20-integrated-2-bowl-kitchen-sink'),(43207,84,5,6178,'Reginox Elite Centurio L20 Integrated 2 Bowl Kitchen Sink'),(43208,84,0,6178,'Reginox Elite Centurio L20 Integrated 2 Bowl Kitchen Sink'),(43209,86,5,6178,'Reginox Elite Centurio L20 Integrated 2 Bowl Kitchen Sink'),(43210,86,0,6178,'Reginox Elite Centurio L20 Integrated 2 Bowl Kitchen Sink'),(43211,73,5,6178,'Reginox Elite Centurio L20 Integrated 2 Bowl Kitchen Sink'),(43212,73,0,6178,'Reginox Elite Centurio L20 Integrated 2 Bowl Kitchen Sink'),(43213,109,5,6178,'Reginox Elite Centurio L20 Integrated 2 Bowl Kitchen Sink'),(43214,109,0,6178,'Reginox Elite Centurio L20 Integrated 2 Bowl Kitchen Sink'),(43215,121,5,6179,'reginox-elite-centurio-l30-integrated-2-bowl-kitchen-sink'),(43216,121,0,6179,'reginox-elite-centurio-l30-integrated-2-bowl-kitchen-sink'),(43217,84,5,6179,'Reginox Elite Centurio L30 Integrated 2 Bowl Kitchen Sink'),(43218,84,0,6179,'Reginox Elite Centurio L30 Integrated 2 Bowl Kitchen Sink'),(43219,86,5,6179,'Reginox Elite Centurio L30 Integrated 2 Bowl Kitchen Sink'),(43220,86,0,6179,'Reginox Elite Centurio L30 Integrated 2 Bowl Kitchen Sink'),(43221,73,5,6179,'Reginox Elite Centurio L30 Integrated 2 Bowl Kitchen Sink'),(43222,73,0,6179,'Reginox Elite Centurio L30 Integrated 2 Bowl Kitchen Sink'),(43223,109,5,6179,'Reginox Elite Centurio L30 Integrated 2 Bowl Kitchen Sink'),(43224,109,0,6179,'Reginox Elite Centurio L30 Integrated 2 Bowl Kitchen Sink'),(43225,121,5,6180,'blanco-claron-340-180-if-stainless-steel-inset-kitchen-sink'),(43226,121,0,6180,'blanco-claron-340-180-if-stainless-steel-inset-kitchen-sink'),(43227,84,5,6180,'Blanco CLARON 340/180-IF Stainless Steel Inset Kitchen Sink'),(43228,84,0,6180,'Blanco CLARON 340/180-IF Stainless Steel Inset Kitchen Sink'),(43229,86,5,6180,'Blanco CLARON 340/180-IF Stainless Steel Inset Kitchen Sink'),(43230,86,0,6180,'Blanco CLARON 340/180-IF Stainless Steel Inset Kitchen Sink'),(43231,73,5,6180,'Blanco CLARON 340/180-IF Stainless Steel Inset Kitchen Sink'),(43232,73,0,6180,'Blanco CLARON 340/180-IF Stainless Steel Inset Kitchen Sink'),(43233,109,5,6180,'Blanco CLARON 340/180-IF Stainless Steel Inset Kitchen Sink'),(43234,109,0,6180,'Blanco CLARON 340/180-IF Stainless Steel Inset Kitchen Sink'),(43235,110,5,6180,'Blanco CLARON 340/180-IF Stainless Steel Inset Kitchen Sink'),(43236,110,0,6180,'Blanco CLARON 340/180-IF Stainless Steel Inset Kitchen Sink'),(43237,111,5,6180,'Blanco CLARON 340/180-IF Stainless Steel Inset Kitchen Sink'),(43238,111,0,6180,'Blanco CLARON 340/180-IF Stainless Steel Inset Kitchen Sink'),(43239,121,5,6181,'blanco-claron-340-180-undermount-sink-claron-340-180-u'),(43240,121,0,6181,'blanco-claron-340-180-undermount-sink-claron-340-180-u'),(43241,84,5,6181,'Blanco Claron 340/180-U Stainless Steel Undermount Kitchen Sink | Banyo'),(43242,84,0,6181,'Blanco Claron 340/180-U Stainless Steel Undermount Kitchen Sink | Banyo'),(43243,86,5,6181,'Blanco Claron 340/180-Undermount Sink CLARON 340/180-U are graceful and easy to fit, stylish and affordable. At banyo online store, choose your desire one among the wide variety of modern and stylish Kitchen sink.'),(43244,86,0,6181,'Blanco Claron 340/180-Undermount Sink CLARON 340/180-U are graceful and easy to fit, stylish and affordable. At banyo online store, choose your desire one among the wide variety of modern and stylish Kitchen sink.'),(43245,73,5,6181,'Blanco Claron 340/180-U Undermount Sink - BL467696 BL467697'),(43246,73,0,6181,'Blanco Claron 340/180-U Undermount Sink - BL467696 BL467697'),(43247,109,5,6181,'Blanco Claron 340/180-U Undermount Sink - BL467696 BL467697'),(43248,109,0,6181,'Blanco Claron 340/180-U Undermount Sink - BL467696 BL467697'),(43249,121,5,6182,'blanco-claron-550-u-undermount-sink-bl467694'),(43250,121,0,6182,'blanco-claron-550-u-undermount-sink-bl467694'),(43251,84,5,6182,'Blanco Claron 550-U Undermount Stainless Steel Sink BL467694 | Banyo UK'),(43252,84,0,6182,'Blanco Claron 550-U Undermount Stainless Steel Sink BL467694 | Banyo UK'),(43253,86,5,6182,'Blanco Claron 550-U Undermount Sink offers a contemporary modern design and shiny finish on reasonable price available at banyo.'),(43254,86,0,6182,'Blanco Claron 550-U Undermount Sink offers a contemporary modern design and shiny finish on reasonable price available at banyo.'),(43255,73,5,6182,'Blanco Claron 550-U undermount Sink - 521579'),(43256,73,0,6182,'Blanco Claron 550-U undermount Sink - 521579'),(43257,109,5,6182,'Blanco Claron 550-U undermount Sink - 521579'),(43258,109,0,6182,'Blanco Claron 550-U undermount Sink - 521579'),(43259,121,5,6183,'blanco-classic-40-s-inset-stainless-steel-kitchen-sink'),(43260,121,0,6183,'blanco-classic-40-s-inset-stainless-steel-kitchen-sink'),(43261,84,5,6183,'Blanco Classic 40 S Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(43262,84,0,6183,'Blanco Classic 40 S Inset Stainless Steel Kitchen Sink | Banyo.co.uk'),(43263,86,5,6183,'Blanco Classic 40 S Inset Kitchen Sink comes in Stainless Steel is a perfectly hygienic kitchen sink option, and out of all sink materials are the easiest to look after. '),(43264,86,0,6183,'Blanco Classic 40 S Inset Kitchen Sink comes in Stainless Steel is a perfectly hygienic kitchen sink option, and out of all sink materials are the easiest to look after. '),(43265,73,5,6183,'Blanco Classic 40 S Stainless Steel Inset Kitchen Sink'),(43266,73,0,6183,'Blanco Classic 40 S Stainless Steel Inset Kitchen Sink'),(43267,109,5,6183,'Blanco Classic 40 S Stainless Steel Inset Kitchen Sink'),(43268,109,0,6183,'Blanco Classic 40 S Stainless Steel Inset Kitchen Sink'),(43269,121,5,6184,'blanco-collectis-6-s-silgranit-puradur-iir-inset-sink'),(43270,121,0,6184,'blanco-collectis-6-s-silgranit-puradur-iir-inset-sink'),(43271,84,5,6184,'Blanco COLLECTIS 6 S Silgranit 1.5 Bowl Kitchen Sink | banyo'),(43272,84,0,6184,'Blanco COLLECTIS 6 S Silgranit 1.5 Bowl Kitchen Sink | banyo'),(43273,86,5,6184,'Blanco COLLECTIS 6 S Silgranit PuraDur II® Inset Sink'),(43274,86,0,6184,'Blanco COLLECTIS 6 S Silgranit PuraDur II® Inset Sink'),(43275,73,5,6184,'Blanco COLLECTIS 6 S Silgranit PuraDur II &reg; Inset Sink'),(43276,73,0,6184,'Blanco COLLECTIS 6 S Silgranit PuraDur II &reg; Inset Sink'),(43277,109,5,6184,'Blanco COLLECTIS 6 S Silgranit PuraDur II® Inset Sink'),(43278,109,0,6184,'Blanco COLLECTIS 6 S Silgranit PuraDur II® Inset Sink'),(43279,121,5,6185,'reginox-comfort-colorado-l-integrated-1-bowl-kitchen-sink'),(43280,121,0,6185,'reginox-comfort-colorado-l-integrated-1-bowl-kitchen-sink'),(43281,84,5,6185,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink'),(43282,84,0,6185,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink'),(43283,86,5,6185,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink'),(43284,86,0,6185,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink'),(43285,73,5,6185,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink'),(43286,73,0,6185,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink'),(43287,109,5,6185,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink'),(43288,109,0,6185,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink'),(43289,121,5,6186,'blanco-codelta-ii-puradur-ii-inset-silgranit-kitchen-sink'),(43290,121,0,6186,'blanco-codelta-ii-puradur-ii-inset-silgranit-kitchen-sink'),(43291,84,5,6186,'Blanco Delta II Silgranit Puradur Kitchen Sink - Diagonal Bowl | Banyo'),(43292,84,0,6186,'Blanco Delta II Silgranit Puradur Kitchen Sink - Diagonal Bowl | Banyo'),(43293,86,5,6186,'Big saving deals on Blanco Codelta II Puradur II Inset Silgranit Kitchen Sink only at banyo online.we have fastest delivery services across UK.'),(43294,86,0,6186,'Big saving deals on Blanco Codelta II Puradur II Inset Silgranit Kitchen Sink only at banyo online.we have fastest delivery services across UK.'),(43295,73,5,6186,'Blanco Delta II Puradur II Inset Silgranit Kitchen Sink'),(43296,73,0,6186,'Blanco Delta II Puradur II Inset Silgranit Kitchen Sink'),(43297,109,5,6186,'Blanco Delta II Puradur II Inset Silgranit Kitchen Sink'),(43298,109,0,6186,'Blanco Delta II Puradur II Inset Silgranit Kitchen Sink'),(43299,121,5,6187,'reginox-diplomat-eco-1-5-bowl-kitchen-sink'),(43300,121,0,6187,'reginox-diplomat-eco-1-5-bowl-kitchen-sink'),(43301,84,5,6187,'Reginox Diplomat Eco 1.5 Bowl Kitchen Sink'),(43302,84,0,6187,'Reginox Diplomat Eco 1.5 Bowl Kitchen Sink'),(43303,86,5,6187,'Reginox Diplomat Eco 1.5 Bowl Kitchen Sink'),(43304,86,0,6187,'Reginox Diplomat Eco 1.5 Bowl Kitchen Sink'),(43305,73,5,6187,'Reginox Diplomat Eco 1.5 Bowl Kitchen Sink'),(43306,73,0,6187,'Reginox Diplomat Eco 1.5 Bowl Kitchen Sink'),(43307,109,5,6187,'Reginox Diplomat Eco 1.5 Bowl Kitchen Sink'),(43308,109,0,6187,'Reginox Diplomat Eco 1.5 Bowl Kitchen Sink'),(43309,110,5,6187,'Reginox Diplomat Eco 1.5 Bowl Kitchen Sink'),(43310,110,0,6187,'Reginox Diplomat Eco 1.5 Bowl Kitchen Sink'),(43311,111,5,6187,'Reginox Diplomat Eco 1.5 Bowl Kitchen Sink'),(43312,111,0,6187,'Reginox Diplomat Eco 1.5 Bowl Kitchen Sink'),(43313,121,5,6188,'reginox-diplomat-10-eco-single-bowl-kitchen-sink'),(43314,121,0,6188,'reginox-diplomat-10-eco-single-bowl-kitchen-sink'),(43315,84,5,6188,'Reginox Diplomat 10 Eco Single Bowl Kitchen Sink'),(43316,84,0,6188,'Reginox Diplomat 10 Eco Single Bowl Kitchen Sink'),(43317,86,5,6188,'Reginox Diplomat 10 Eco Single Bowl Kitchen Sink'),(43318,86,0,6188,'Reginox Diplomat 10 Eco Single Bowl Kitchen Sink'),(43319,73,5,6188,'Reginox Diplomat 10 Eco Single Bowl Kitchen Sink'),(43320,73,0,6188,'Reginox Diplomat 10 Eco Single Bowl Kitchen Sink'),(43321,109,5,6188,'Reginox Diplomat 10 Eco Single Bowl Kitchen Sink'),(43322,109,0,6188,'Reginox Diplomat 10 Eco Single Bowl Kitchen Sink'),(43323,110,5,6188,'Reginox Diplomat 10 Eco Single Bowl Kitchen Sink'),(43324,110,0,6188,'Reginox Diplomat 10 Eco Single Bowl Kitchen Sink'),(43325,111,5,6188,'Reginox Diplomat 10 Eco Single Bowl Kitchen Sink'),(43326,111,0,6188,'Reginox Diplomat 10 Eco Single Bowl Kitchen Sink'),(43327,121,5,6189,'blanco-divon-ii-5-s-if-inset-stainless-steel-kitchen-sink'),(43328,121,0,6189,'blanco-divon-ii-5-s-if-inset-stainless-steel-kitchen-sink'),(43329,84,5,6189,'Blanco Divon II 5 S-IF - Stainless Steel 1.0 Bowl Kitchen SInk | Banyo'),(43330,84,0,6189,'Blanco Divon II 5 S-IF - Stainless Steel 1.0 Bowl Kitchen SInk | Banyo'),(43331,86,5,6189,'Save now with amazing prices on Blanco Divon II 5 S-IF Inset Stainless Steel Kitchen Sink   sale at banyo.Blanco has created a huge range of stunning, unique sinks, made from the very best materials.'),(43332,86,0,6189,'Save now with amazing prices on Blanco Divon II 5 S-IF Inset Stainless Steel Kitchen Sink   sale at banyo.Blanco has created a huge range of stunning, unique sinks, made from the very best materials.'),(43333,73,5,6189,'Blanco Divon II 5 S-IF Stainless Steel Inset Kitchen Sink'),(43334,73,0,6189,'Blanco Divon II 5 S-IF Stainless Steel Inset Kitchen Sink'),(43335,109,5,6189,'Blanco Divon II 5 S-IF Stainless Steel Inset Kitchen Sink'),(43336,109,0,6189,'Blanco Divon II 5 S-IF Stainless Steel Inset Kitchen Sink'),(43337,121,5,6190,'blanco-divon-ii-6-s-if-inset-stainless-steel-kitchen-sink'),(43338,121,0,6190,'blanco-divon-ii-6-s-if-inset-stainless-steel-kitchen-sink'),(43339,84,5,6190,'Blanco Divon II 6 S-IF Stainless Steel 1.5 Bowl Kitchen Sink | Banyo'),(43340,84,0,6190,'Blanco Divon II 6 S-IF Stainless Steel 1.5 Bowl Kitchen Sink | Banyo'),(43341,86,5,6190,'banyo offers Blanco DivonII 6 S-IF Inset Stainless Steel Kitchen Sink at lowest prices with fastest home delivery.Guaranteed we have the unbeatable prices.'),(43342,86,0,6190,'banyo offers Blanco DivonII 6 S-IF Inset Stainless Steel Kitchen Sink at lowest prices with fastest home delivery.Guaranteed we have the unbeatable prices.'),(43343,73,5,6190,'Blanco Divon II 6 S-IF Stainless Steel Inset Kitchen Sink'),(43344,73,0,6190,'Blanco Divon II 6 S-IF Stainless Steel Inset Kitchen Sink'),(43345,109,5,6190,'Blanco Divon II 6 S-IF Stainless Steel Inset Kitchen Sink'),(43346,109,0,6190,'Blanco Divon II 6 S-IF Stainless Steel Inset Kitchen Sink'),(43347,121,5,6191,'blanco-divon-ii-8-s-if-inset-stainless-steel-kitchen-sink'),(43348,121,0,6191,'blanco-divon-ii-8-s-if-inset-stainless-steel-kitchen-sink'),(43349,84,5,6191,'Blanco Divon II 8 S-IF Inset 2 Large Bowl Stainless Steel Sink | Banyo'),(43350,84,0,6191,'Blanco Divon II 8 S-IF Inset 2 Large Bowl Stainless Steel Sink | Banyo'),(43351,86,5,6191,'Blanco Divon II 8 S-IF Inset Stainless Steel Kitchen Sink at unbeatable prices on banyo.Our kitchen appliances come in a wide range of styles, shapes and colors so you can find a product that is perfect for you'),(43352,86,0,6191,'Blanco Divon II 8 S-IF Inset Stainless Steel Kitchen Sink at unbeatable prices on banyo.Our kitchen appliances come in a wide range of styles, shapes and colors so you can find a product that is perfect for you'),(43353,73,5,6191,'Blanco Divon II 8 S-IF Stainless Steel Inset Kitchen Sink'),(43354,73,0,6191,'Blanco Divon II 8 S-IF Stainless Steel Inset Kitchen Sink'),(43355,109,5,6191,'Blanco Divon II 8 S-IF Stainless Steel Inset Kitchen Sink'),(43356,109,0,6191,'Blanco Divon II 8 S-IF Stainless Steel Inset Kitchen Sink'),(43357,121,5,6192,'reginox-ego-400-inset-1-bowl-granite-kitchen-sink'),(43358,121,0,6192,'reginox-ego-400-inset-1-bowl-granite-kitchen-sink'),(43359,84,5,6192,'Reginox EGO 400 Inset 1 Bowl Granite Kitchen Sink'),(43360,84,0,6192,'Reginox EGO 400 Inset 1 Bowl Granite Kitchen Sink'),(43361,86,5,6192,'Reginox EGO 400 Inset 1 Bowl Granite Kitchen Sink'),(43362,86,0,6192,'Reginox EGO 400 Inset 1 Bowl Granite Kitchen Sink'),(43363,73,5,6192,'Reginox EGO 400 Inset 1 Bowl Granite Kitchen Sink'),(43364,73,0,6192,'Reginox EGO 400 Inset 1 Bowl Granite Kitchen Sink'),(43365,109,5,6192,'Reginox EGO 400 Inset 1 Bowl Granite Kitchen Sink'),(43366,109,0,6192,'Reginox EGO 400 Inset 1 Bowl Granite Kitchen Sink'),(43367,121,5,6193,'reginox-ego-475-inset-1-5-bowl-granite-kitchen-sink'),(43368,121,0,6193,'reginox-ego-475-inset-1-5-bowl-granite-kitchen-sink'),(43369,84,5,6193,'Reginox EGO 475 Inset 1.5 Bowl Granite Kitchen Sink'),(43370,84,0,6193,'Reginox EGO 475 Inset 1.5 Bowl Granite Kitchen Sink'),(43371,86,5,6193,'Reginox EGO 475 Inset 1.5 Bowl Granite Kitchen Sink'),(43372,86,0,6193,'Reginox EGO 475 Inset 1.5 Bowl Granite Kitchen Sink'),(43373,73,5,6193,'Reginox EGO 475 Inset 1.5 Bowl Granite Kitchen Sink'),(43374,73,0,6193,'Reginox EGO 475 Inset 1.5 Bowl Granite Kitchen Sink'),(43375,109,5,6193,'Reginox EGO 475 Inset 1.5 Bowl Granite Kitchen Sink'),(43376,109,0,6193,'Reginox EGO 475 Inset 1.5 Bowl Granite Kitchen Sink'),(43377,121,5,6194,'reginox-ego-800-inset-1-bowl-granite-kitchen-sink'),(43378,121,0,6194,'reginox-ego-800-inset-1-bowl-granite-kitchen-sink'),(43379,84,5,6194,'Reginox EGO 800 Inset 1 Bowl Granite Kitchen Sink'),(43380,84,0,6194,'Reginox EGO 800 Inset 1 Bowl Granite Kitchen Sink'),(43381,86,5,6194,'Reginox EGO 800 Inset 1 Bowl Granite Kitchen Sink'),(43382,86,0,6194,'Reginox EGO 800 Inset 1 Bowl Granite Kitchen Sink'),(43383,73,5,6194,'Reginox EGO 800 Inset 1 Bowl Granite Kitchen Sink'),(43384,73,0,6194,'Reginox EGO 800 Inset 1 Bowl Granite Kitchen Sink'),(43385,109,5,6194,'Reginox EGO 800 Inset 1 Bowl Granite Kitchen Sink'),(43386,109,0,6194,'Reginox EGO 800 Inset 1 Bowl Granite Kitchen Sink'),(43387,121,5,6195,'franke-elba-elk-611-inset-1-0-bowl-kitchen-sink'),(43388,121,0,6195,'franke-elba-elk-611-inset-1-0-bowl-kitchen-sink'),(43389,84,5,6195,'Franke Elba ELK 611 Kitchen Sink Ceramic White - 124.0184.408 - ELK 611'),(43390,84,0,6195,'Franke Elba ELK 611 Kitchen Sink Ceramic White - 124.0184.408 - ELK 611'),(43391,86,5,6195,'Franke Elba ELK 611 Kitchen Sink Ceramic White with guaranteed unbeatable prices availabe at banyo.Get amazing service from banyo just place an order.'),(43392,86,0,6195,'Franke Elba ELK 611 Kitchen Sink Ceramic White with guaranteed unbeatable prices availabe at banyo.Get amazing service from banyo just place an order.'),(43393,73,5,6195,'Franke Elba ELK 611 Inset 1.0 Bowl Kitchen Sink Ceramic White'),(43394,73,0,6195,'Franke Elba ELK 611 Inset 1.0 Bowl Kitchen Sink Ceramic White'),(43395,109,5,6195,'Franke Elba ELK 611 Inset 1.0 Bowl Kitchen Sink Ceramic White'),(43396,109,0,6195,'Franke Elba ELK 611 Inset 1.0 Bowl Kitchen Sink Ceramic White'),(43397,121,5,6196,'blanco-elon-45-s-puradur-ii-inset-silgranit-kitchen-sink'),(43398,121,0,6196,'blanco-elon-45-s-puradur-ii-inset-silgranit-kitchen-sink'),(43399,84,5,6196,'Blanco ELON 45 S Silgranit Puradur Reversible Kitchen Sink | Banyo.co.uk '),(43400,84,0,6196,'Blanco ELON 45 S Silgranit Puradur Reversible Kitchen Sink | Banyo.co.uk '),(43401,86,5,6196,'Blanco ELON 45 S Puradur II Inset Silgranit Kitchen Sink with an unbeatable sale available now at banyo.Our Sinks create a sophisticated and modern look in kitchen suites.'),(43402,86,0,6196,'Blanco ELON 45 S Puradur II Inset Silgranit Kitchen Sink with an unbeatable sale available now at banyo.Our Sinks create a sophisticated and modern look in kitchen suites.'),(43403,73,5,6196,'Blanco ELON 45 S Puradur II Inset Silgranit Kitchen Sink'),(43404,73,0,6196,'Blanco ELON 45 S Puradur II Inset Silgranit Kitchen Sink'),(43405,109,5,6196,'Blanco ELON 45 S Puradur II Inset Silgranit Kitchen Sink'),(43406,109,0,6196,'Blanco ELON 45 S Puradur II Inset Silgranit Kitchen Sink'),(43407,121,5,6197,'blanco-elon-xl-6-s-puradur-ii-inset-silgranit-kitchen-sink'),(43408,121,0,6197,'blanco-elon-xl-6-s-puradur-ii-inset-silgranit-kitchen-sink'),(43409,84,5,6197,'Blanco ELON XL 6 S Silgranit Puradur Reversible Kitchen Sink | Banyo UK'),(43410,84,0,6197,'Blanco ELON XL 6 S Silgranit Puradur Reversible Kitchen Sink | Banyo UK'),(43411,86,5,6197,'Blanco Elon XL 6 S Puradur II Inset Silgranit Kitchen Sink is modern in appearance and will complement with other appliances in your kitchen.Banyo has the perfect combination of style, price and function. '),(43412,86,0,6197,'Blanco Elon XL 6 S Puradur II Inset Silgranit Kitchen Sink is modern in appearance and will complement with other appliances in your kitchen.Banyo has the perfect combination of style, price and function. '),(43413,73,5,6197,'Blanco ELON XL 6 S Puradur II Inset Silgranit Kitchen Sink'),(43414,73,0,6197,'Blanco ELON XL 6 S Puradur II Inset Silgranit Kitchen Sink'),(43415,109,5,6197,'Blanco ELON XL 6 S Puradur II Inset Silgranit Kitchen Sink'),(43416,109,0,6197,'Blanco ELON XL 6 S Puradur II Inset Silgranit Kitchen Sink'),(43417,121,5,6198,'blanco-etagon-500-u-silgranit-puradur-iir-undermount-sink'),(43418,121,0,6198,'blanco-etagon-500-u-silgranit-puradur-iir-undermount-sink'),(43419,84,5,6198,'Blanco ETAGON 500-U Silgranit PuraDur Undermount Kitchen Sink | Banyo'),(43420,84,0,6198,'Blanco ETAGON 500-U Silgranit PuraDur Undermount Kitchen Sink | Banyo'),(43421,86,5,6198,'Blanco ETAGON 500-U Silgranit PuraDur II® Undermount Sink'),(43422,86,0,6198,'Blanco ETAGON 500-U Silgranit PuraDur II® Undermount Sink'),(43423,73,5,6198,'Blanco ETAGON 500-U Silgranit PuraDur IIÂ® Undermount Sink'),(43424,73,0,6198,'Blanco ETAGON 500-U Silgranit PuraDur IIÂ® Undermount Sink'),(43425,109,5,6198,'Blanco ETAGON 500-U Silgranit PuraDur II® Undermount Sink'),(43426,109,0,6198,'Blanco ETAGON 500-U Silgranit PuraDur II® Undermount Sink'),(43427,121,5,6199,'blanco-etagon-6-puradur-reg-silgranit-inset-sink'),(43428,121,0,6199,'blanco-etagon-6-puradur-reg-silgranit-inset-sink'),(43429,84,5,6199,'Blanco Etagon 6 PuraDur&reg; Silgranit Inset Sink'),(43430,84,0,6199,'Blanco Etagon 6 PuraDur&reg; Silgranit Inset Sink'),(43431,86,5,6199,'Blanco Etagon 6 PuraDur&reg; Silgranit Inset Sink'),(43432,86,0,6199,'Blanco Etagon 6 PuraDur&reg; Silgranit Inset Sink'),(43433,73,5,6199,'Blanco Etagon 6 PuraDur&reg; Silgranit Inset Sink'),(43434,73,0,6199,'Blanco Etagon 6 PuraDur&reg; Silgranit Inset Sink'),(43435,109,5,6199,'Blanco Etagon 6 PuraDur&reg; Silgranit Inset Sink'),(43436,109,0,6199,'Blanco Etagon 6 PuraDur&reg; Silgranit Inset Sink'),(43437,110,5,6199,'blanco_etagon_6_-_silgranit_-_black'),(43438,110,0,6199,'blanco_etagon_6_-_silgranit_-_black'),(43439,111,5,6199,'blanco_etagon_6_-_silgranit_-_black'),(43440,111,0,6199,'blanco_etagon_6_-_silgranit_-_black'),(43441,121,5,6200,'blanco-etagon-700-u-silgranit-undermount-sink'),(43442,121,0,6200,'blanco-etagon-700-u-silgranit-undermount-sink'),(43443,84,5,6200,'Blanco Etagon 700-U Silgranit Undermount Sink'),(43444,84,0,6200,'Blanco Etagon 700-U Silgranit Undermount Sink'),(43445,86,5,6200,'Blanco Etagon 700-U Silgranit Undermount Sink'),(43446,86,0,6200,'Blanco Etagon 700-U Silgranit Undermount Sink'),(43447,73,5,6200,'Blanco Etagon 700-U Silgranit Undermount Sink'),(43448,73,0,6200,'Blanco Etagon 700-U Silgranit Undermount Sink'),(43449,109,5,6200,'Blanco Etagon 700-U Silgranit Undermount Sink'),(43450,109,0,6200,'Blanco Etagon 700-U Silgranit Undermount Sink'),(43451,121,5,6201,'blanco-etagon-8-puradur-reg-silgranit-inset-sink'),(43452,121,0,6201,'blanco-etagon-8-puradur-reg-silgranit-inset-sink'),(43453,84,5,6201,'Blanco Etagon 8 PuraDur&reg; Silgranit Inset Sink'),(43454,84,0,6201,'Blanco Etagon 8 PuraDur&reg; Silgranit Inset Sink'),(43455,86,5,6201,'Blanco Etagon 8 PuraDur&reg; Silgranit Inset Sink'),(43456,86,0,6201,'Blanco Etagon 8 PuraDur&reg; Silgranit Inset Sink'),(43457,73,5,6201,'Blanco Etagon 8 PuraDur&reg; Silgranit Inset Sink'),(43458,73,0,6201,'Blanco Etagon 8 PuraDur&reg; Silgranit Inset Sink'),(43459,109,5,6201,'Blanco Etagon 8 PuraDur&reg; Silgranit Inset Sink'),(43460,109,0,6201,'Blanco Etagon 8 PuraDur&reg; Silgranit Inset Sink'),(43461,121,5,6202,'franke-fresno-fsg-111-undermount-1-0-bowl-kitchen-sink'),(43462,121,0,6202,'franke-fresno-fsg-111-undermount-1-0-bowl-kitchen-sink'),(43463,84,5,6202,'Franke Fresno FSG 111 Undermount 1.0 Bowl Kitchen Sink'),(43464,84,0,6202,'Franke Fresno FSG 111 Undermount 1.0 Bowl Kitchen Sink'),(43465,86,5,6202,'Franke Fresno FSG 111 Undermount Single Bowl Fragranite Sink is a contemporary style with Trendy colours and Texture available in 4 Super metallic colours of Copper Gold, Copper Grey, Lunar Grey and Sterling Silver.'),(43466,86,0,6202,'Franke Fresno FSG 111 Undermount Single Bowl Fragranite Sink is a contemporary style with Trendy colours and Texture available in 4 Super metallic colours of Copper Gold, Copper Grey, Lunar Grey and Sterling Silver.'),(43467,73,5,6202,'Franke Fresno FSG 111 Undermount 1.0 Bowl Kitchen Sink'),(43468,73,0,6202,'Franke Fresno FSG 111 Undermount 1.0 Bowl Kitchen Sink'),(43469,109,5,6202,'Franke Fresno FSG 111 Undermount 1.0 Bowl Kitchen Sink'),(43470,109,0,6202,'Franke Fresno FSG 111 Undermount 1.0 Bowl Kitchen Sink'),(43471,121,5,6203,'franke-galassia-gak-611-kitchen-sink-white'),(43472,121,0,6203,'franke-galassia-gak-611-kitchen-sink-white'),(43473,84,5,6203,'Franke Galassia GAK 611 Inset Kitchen Sink White - GAK 611 -'),(43474,84,0,6203,'Franke Galassia GAK 611 Inset Kitchen Sink White - GAK 611 -'),(43475,86,5,6203,'Franke FTU 3807-P XS 70H Tube Kitchen Hood designed to make your kitchen a more comfotable place to be.We have guaranteed unbeatable prices here at banyo.'),(43476,86,0,6203,'Franke FTU 3807-P XS 70H Tube Kitchen Hood designed to make your kitchen a more comfotable place to be.We have guaranteed unbeatable prices here at banyo.'),(43477,73,5,6203,'Franke Galassia GAK 611 Inset 1.0 Bowl Kitchen Ceramic Sink White '),(43478,73,0,6203,'Franke Galassia GAK 611 Inset 1.0 Bowl Kitchen Ceramic Sink White '),(43479,109,5,6203,'Franke Galassia GAK 611 Inset 1.0 Bowl Kitchen Ceramic Sink White '),(43480,109,0,6203,'Franke Galassia GAK 611 Inset 1.0 Bowl Kitchen Ceramic Sink White '),(43481,121,5,6204,'franke-galassia-gak-651-ceramic-1-5-bowl-kitchen-sink-white'),(43482,121,0,6204,'franke-galassia-gak-651-ceramic-1-5-bowl-kitchen-sink-white'),(43483,84,5,6204,'Franke Galassia GAK 651 Ceramic 1.5 Bowl Kitchen Sink White'),(43484,84,0,6204,'Franke Galassia GAK 651 Ceramic 1.5 Bowl Kitchen Sink White'),(43485,86,5,6204,'Buy Franke Galassia GAK 651 1.5 Bowl White Ceramic Sink from Banyo with the lowest price in the UK. Reversible Drainer, Modern, Durable and Inset Installation, Lifetime guarantee.'),(43486,86,0,6204,'Buy Franke Galassia GAK 651 1.5 Bowl White Ceramic Sink from Banyo with the lowest price in the UK. Reversible Drainer, Modern, Durable and Inset Installation, Lifetime guarantee.'),(43487,73,5,6204,'Franke Galassia GAK 651 Ceramic 1.5 Bowl Kitchen Sink White'),(43488,73,0,6204,'Franke Galassia GAK 651 Ceramic 1.5 Bowl Kitchen Sink White'),(43489,109,5,6204,'Franke Galassia GAK 651 Ceramic 1.5 Bowl Kitchen Sink White'),(43490,109,0,6204,'Franke Galassia GAK 651 Ceramic 1.5 Bowl Kitchen Sink White'),(43491,121,5,6205,'reginox-galicia-1-0-bowl-reversible-stainless-steel-kitchen-sink'),(43492,121,0,6205,'reginox-galicia-1-0-bowl-reversible-stainless-steel-kitchen-sink'),(43493,84,5,6205,'Reginox GALICIA 1.0 Bowl Reversible Stainless Steel Kitchen Sink'),(43494,84,0,6205,'Reginox GALICIA 1.0 Bowl Reversible Stainless Steel Kitchen Sink'),(43495,86,5,6205,'Reginox GALICIA 1.0 Bowl Reversible Stainless Steel Kitchen Sink'),(43496,86,0,6205,'Reginox GALICIA 1.0 Bowl Reversible Stainless Steel Kitchen Sink'),(43497,73,5,6205,'Reginox GALICIA 1.0 Bowl Reversible Stainless Steel Kitchen Sink'),(43498,73,0,6205,'Reginox GALICIA 1.0 Bowl Reversible Stainless Steel Kitchen Sink'),(43499,109,5,6205,'Reginox GALICIA 1.0 Bowl Reversible Stainless Steel Kitchen Sink'),(43500,109,0,6205,'Reginox GALICIA 1.0 Bowl Reversible Stainless Steel Kitchen Sink'),(43501,121,5,6206,'franke-galassia-plus-gax-611-bowl-inset-kitchen-sink-stainless-steel'),(43502,121,0,6206,'franke-galassia-plus-gax-611-bowl-inset-kitchen-sink-stainless-steel'),(43503,84,5,6206,'Franke Galassia Plus GAX 611 Inset Kitchen Sink Stainless Steel - GAX 611 -'),(43504,84,0,6206,'Franke Galassia Plus GAX 611 Inset Kitchen Sink Stainless Steel - GAX 611 -'),(43505,86,5,6206,'Franke Galassia Plus GAX 611 is a stainless steel kitchen sink with 1.0 Bowl Configuration and is compatible with 600mm Cabinet Size. Banyo offers the lowest prices and fast delivery service in the UK.'),(43506,86,0,6206,'Franke Galassia Plus GAX 611 is a stainless steel kitchen sink with 1.0 Bowl Configuration and is compatible with 600mm Cabinet Size. Banyo offers the lowest prices and fast delivery service in the UK.'),(43507,73,5,6206,'Franke Galassia Plus GAX 611 Inset 1.0 Bowl Kitchen Sink Stainless Steel'),(43508,73,0,6206,'Franke Galassia Plus GAX 611 Inset 1.0 Bowl Kitchen Sink Stainless Steel'),(43509,109,5,6206,'Franke Galassia Plus GAX 611 Inset 1.0 Bowl Kitchen Sink Stainless Steel'),(43510,109,0,6206,'Franke Galassia Plus GAX 611 Inset 1.0 Bowl Kitchen Sink Stainless Steel'),(43511,110,5,6206,'Franke Galassia Plus GAX 611 Inset 1.0 Bowl Kitchen Sink Stainless Steel'),(43512,110,0,6206,'Franke Galassia Plus GAX 611 Inset 1.0 Bowl Kitchen Sink Stainless Steel'),(43513,111,5,6206,'Franke Galassia Plus GAX 611 Inset 1.0 Bowl Kitchen Sink Stainless Steel'),(43514,111,0,6206,'Franke Galassia Plus GAX 611 Inset 1.0 Bowl Kitchen Sink Stainless Steel'),(43515,121,5,6207,'franke-galassia-plus-gax-621-bowl-inset-kitchen-sink-stainless-steel'),(43516,121,0,6207,'franke-galassia-plus-gax-621-bowl-inset-kitchen-sink-stainless-steel'),(43517,84,5,6207,'Franke Galassia Plus GAX 621 Inset Kitchen Sink Stainless Steel - GAX 621 -'),(43518,84,0,6207,'Franke Galassia Plus GAX 621 Inset Kitchen Sink Stainless Steel - GAX 621 -'),(43519,86,5,6207,'Franke Galassia GAK 611 Inset Kitchen Sink with smooth finish design look perfectly pristine in your home.Best Deals are available at banyo.'),(43520,86,0,6207,'Franke Galassia GAK 611 Inset Kitchen Sink with smooth finish design look perfectly pristine in your home.Best Deals are available at banyo.'),(43521,73,5,6207,'Franke Galassia Plus GAX 621 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(43522,73,0,6207,'Franke Galassia Plus GAX 621 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(43523,109,5,6207,'franke_galassia_plus_gax_621_inset_1.5_bowl_kitchen_sink_stainless_steel'),(43524,109,0,6207,'franke_galassia_plus_gax_621_inset_1.5_bowl_kitchen_sink_stainless_steel'),(43525,110,5,6207,'franke_galassia_plus_gax_621_inset_1.5_bowl_kitchen_sink_stainless_steel'),(43526,110,0,6207,'franke_galassia_plus_gax_621_inset_1.5_bowl_kitchen_sink_stainless_steel'),(43527,111,5,6207,'franke_galassia_plus_gax_621_inset_1.5_bowl_kitchen_sink_stainless_steel'),(43528,111,0,6207,'franke_galassia_plus_gax_621_inset_1.5_bowl_kitchen_sink_stainless_steel'),(43529,121,5,6208,'reginox-harlem-10-inset-1-bowl-granite-kitchen-sink'),(43530,121,0,6208,'reginox-harlem-10-inset-1-bowl-granite-kitchen-sink'),(43531,84,5,6208,'Reginox Harlem 10 Inset 1 Bowl Granite Kitchen Sink'),(43532,84,0,6208,'Reginox Harlem 10 Inset 1 Bowl Granite Kitchen Sink'),(43533,73,5,6208,'Reginox Harlem 10 Inset 1 Bowl Granite Kitchen Sink'),(43534,73,0,6208,'Reginox Harlem 10 Inset 1 Bowl Granite Kitchen Sink'),(43535,109,5,6208,'Reginox Harlem 10 Inset 1 Bowl Granite Kitchen Sink'),(43536,109,0,6208,'Reginox Harlem 10 Inset 1 Bowl Granite Kitchen Sink'),(43537,110,5,6208,'Reginox Harlem 10 Inset 1 Bowl Granite Kitchen Sink'),(43538,110,0,6208,'Reginox Harlem 10 Inset 1 Bowl Granite Kitchen Sink'),(43539,111,5,6208,'Reginox Harlem 10 Inset 1 Bowl Granite Kitchen Sink'),(43540,111,0,6208,'Reginox Harlem 10 Inset 1 Bowl Granite Kitchen Sink'),(43541,121,5,6209,'reginox-harlem-15-inset-1-5-bowl-granite-kitchen-sink'),(43542,121,0,6209,'reginox-harlem-15-inset-1-5-bowl-granite-kitchen-sink'),(43543,84,5,6209,'Reginox Harlem 15 Inset 1.5 Bowl Granite Kitchen Sink'),(43544,84,0,6209,'Reginox Harlem 15 Inset 1.5 Bowl Granite Kitchen Sink'),(43545,73,5,6209,'Reginox Harlem 15 Inset 1.5 Bowl Granite Kitchen Sink'),(43546,73,0,6209,'Reginox Harlem 15 Inset 1.5 Bowl Granite Kitchen Sink'),(43547,109,5,6209,'Reginox Harlem 15 Inset 1.5 Bowl Granite Kitchen Sink'),(43548,109,0,6209,'Reginox Harlem 15 Inset 1.5 Bowl Granite Kitchen Sink'),(43549,110,5,6209,'Reginox Harlem 15 Inset 1.5 Bowl Granite Kitchen Sink'),(43550,110,0,6209,'Reginox Harlem 15 Inset 1.5 Bowl Granite Kitchen Sink'),(43551,111,5,6209,'Reginox Harlem 15 Inset 1.5 Bowl Granite Kitchen Sink'),(43552,111,0,6209,'Reginox Harlem 15 Inset 1.5 Bowl Granite Kitchen Sink'),(43553,121,5,6210,'reginox-elegance-jumbo-inset-1-bowl-kitchen-sink'),(43554,121,0,6210,'reginox-elegance-jumbo-inset-1-bowl-kitchen-sink'),(43555,84,5,6210,'Reginox Elegance Jumbo Inset 1 Bowl Kitchen Sink'),(43556,84,0,6210,'Reginox Elegance Jumbo Inset 1 Bowl Kitchen Sink'),(43557,86,5,6210,'Reginox Elegance Jumbo Inset 1 Bowl Kitchen Sink'),(43558,86,0,6210,'Reginox Elegance Jumbo Inset 1 Bowl Kitchen Sink'),(43559,73,5,6210,'Reginox Elegance Jumbo Inset 1 Bowl Kitchen Sink'),(43560,73,0,6210,'Reginox Elegance Jumbo Inset 1 Bowl Kitchen Sink'),(43561,109,5,6210,'Reginox Elegance Jumbo Inset 1 Bowl Kitchen Sink'),(43562,109,0,6210,'Reginox Elegance Jumbo Inset 1 Bowl Kitchen Sink'),(43563,121,5,6211,'reginox-elite-kansas-l-integrated-1-bowl-kitchen-sink-40x40cm'),(43564,121,0,6211,'reginox-elite-kansas-l-integrated-1-bowl-kitchen-sink-40x40cm'),(43565,84,5,6211,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(43566,84,0,6211,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(43567,86,5,6211,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(43568,86,0,6211,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(43569,73,5,6211,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(43570,73,0,6211,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(43571,109,5,6211,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(43572,109,0,6211,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(43573,121,5,6212,'reginox-elite-kansas-l-integrated-1-bowl-kitchen-sink-50x40cm'),(43574,121,0,6212,'reginox-elite-kansas-l-integrated-1-bowl-kitchen-sink-50x40cm'),(43575,84,5,6212,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(43576,84,0,6212,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(43577,86,5,6212,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(43578,86,0,6212,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(43579,73,5,6212,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(43580,73,0,6212,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(43581,109,5,6212,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(43582,109,0,6212,'Reginox Elite Kansas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(43583,121,5,6213,'franke-kubus-kbk-110-40-undermount-1-0-bowl-kitchen-sink'),(43584,121,0,6213,'franke-kubus-kbk-110-40-undermount-1-0-bowl-kitchen-sink'),(43585,84,5,6213,'Franke Kubus KBX 110 40 Undermount 1.0 Bowl Kitchen Sink'),(43586,84,0,6213,'Franke Kubus KBX 110 40 Undermount 1.0 Bowl Kitchen Sink'),(43587,86,5,6213,'Franke Kubus KBK 110 40 Undermount 1.0 Bowl Kitchen Sink is available in wide range of sizes. Banyo offers cheapest online prices and best delivery service in UK.'),(43588,86,0,6213,'Franke Kubus KBK 110 40 Undermount 1.0 Bowl Kitchen Sink is available in wide range of sizes. Banyo offers cheapest online prices and best delivery service in UK.'),(43589,73,5,6213,'Franke Kubus KBK 110 40 Undermount 1.0 Bowl Kitchen Sink'),(43590,73,0,6213,'Franke Kubus KBK 110 40 Undermount 1.0 Bowl Kitchen Sink'),(43591,109,5,6213,'Franke Kubus KBK 110 40 Undermount 1.0 Bowl Kitchen Sink'),(43592,109,0,6213,'Franke Kubus KBK 110 40 Undermount 1.0 Bowl Kitchen Sink'),(43593,121,5,6214,'franke-kubus-kbk-110-50-undermount-1-0-bowl-kitchen-sink'),(43594,121,0,6214,'franke-kubus-kbk-110-50-undermount-1-0-bowl-kitchen-sink'),(43595,84,5,6214,'Franke Kubus KBK 110 50 Undermount 1.0 Bowl Kitchen Sink'),(43596,84,0,6214,'Franke Kubus KBK 110 50 Undermount 1.0 Bowl Kitchen Sink'),(43597,86,5,6214,'Franke Kubus KBK 110 50 Undermount 1.0 Bowl Kitchen Sink is only compatible with solid surfaces. Browse our extensive range of high quality Kitchen Sinks and Taps from Franke at affordable prices and fastest delivery in UK.'),(43598,86,0,6214,'Franke Kubus KBK 110 50 Undermount 1.0 Bowl Kitchen Sink is only compatible with solid surfaces. Browse our extensive range of high quality Kitchen Sinks and Taps from Franke at affordable prices and fastest delivery in UK.'),(43599,73,5,6214,'Franke Kubus KBK 110 50 Undermount 1.0 Bowl Kitchen Sink'),(43600,73,0,6214,'Franke Kubus KBK 110 50 Undermount 1.0 Bowl Kitchen Sink'),(43601,109,5,6214,'Franke Kubus KBK 110 50 Undermount 1.0 Bowl Kitchen Sink'),(43602,109,0,6214,'Franke Kubus KBK 110 50 Undermount 1.0 Bowl Kitchen Sink'),(43603,121,5,6215,'franke-kubus-kbk-160-undermount-1-5-bowl-ceramic-kitchen-sink'),(43604,121,0,6215,'franke-kubus-kbk-160-undermount-1-5-bowl-ceramic-kitchen-sink'),(43605,84,5,6215,'Franke Kubus KBK 160 Undermount 1.5 Bowl Kitchen Sink'),(43606,84,0,6215,'Franke Kubus KBK 160 Undermount 1.5 Bowl Kitchen Sink'),(43607,86,5,6215,'Buy Franke Kubus KBK 160 Ceramic 1.5 Bowl Undermount Sink with a special price discount from Banyo. Finish Options of White, Graphite & Grey, Reversible small bowl position.'),(43608,86,0,6215,'Buy Franke Kubus KBK 160 Ceramic 1.5 Bowl Undermount Sink with a special price discount from Banyo. Finish Options of White, Graphite & Grey, Reversible small bowl position.'),(43609,73,5,6215,'Franke Kubus KBK 160 Undermount 1.5 Bowl Kitchen Sink'),(43610,73,0,6215,'Franke Kubus KBK 160 Undermount 1.5 Bowl Kitchen Sink'),(43611,109,5,6215,'Franke Kubus KBK 160 Undermount 1.5 Bowl Kitchen Sink'),(43612,109,0,6215,'Franke Kubus KBK 160 Undermount 1.5 Bowl Kitchen Sink'),(43613,121,5,6216,'franke-kubus-kng-110-37-undermount-1-0-bowl-kitchen-sink'),(43614,121,0,6216,'franke-kubus-kng-110-37-undermount-1-0-bowl-kitchen-sink'),(43615,84,5,6216,'Franke Kubus KNG 110 37 Undermount 1.0 Bowl Kitchen Sink'),(43616,84,0,6216,'Franke Kubus KNG 110 37 Undermount 1.0 Bowl Kitchen Sink'),(43617,86,5,6216,'Franke Kubus KNG 110 37 is an Undermount Single Bowl Fragranite Sink with elegant shades of Copper Gold, Lunar Grey, Sterling Silver and Copper Grey.'),(43618,86,0,6216,'Franke Kubus KNG 110 37 is an Undermount Single Bowl Fragranite Sink with elegant shades of Copper Gold, Lunar Grey, Sterling Silver and Copper Grey.'),(43619,73,5,6216,'Franke Kubus KNG 110 37 Undermount 1.0 Bowl Kitchen Sink'),(43620,73,0,6216,'Franke Kubus KNG 110 37 Undermount 1.0 Bowl Kitchen Sink'),(43621,109,5,6216,'Franke Kubus KNG 110 37 Undermount 1.0 Bowl Kitchen Sink'),(43622,109,0,6216,'Franke Kubus KNG 110 37 Undermount 1.0 Bowl Kitchen Sink'),(43623,121,5,6217,'franke-kubus-kng-110-52-undermount-1-0-bowl-kitchen-sink'),(43624,121,0,6217,'franke-kubus-kng-110-52-undermount-1-0-bowl-kitchen-sink'),(43625,84,5,6217,'Franke Kubus KNG 110 52 Undermount 1.0 Bowl Kitchen Sink'),(43626,84,0,6217,'Franke Kubus KNG 110 52 Undermount 1.0 Bowl Kitchen Sink'),(43627,86,5,6217,'Franke Kubus KNG 110 37 is an Undermount Large Single Bowl Fragranite Sink with elegant shades of Copper Gold, Lunar Grey, Sterling Silver and Copper Grey.'),(43628,86,0,6217,'Franke Kubus KNG 110 37 is an Undermount Large Single Bowl Fragranite Sink with elegant shades of Copper Gold, Lunar Grey, Sterling Silver and Copper Grey.'),(43629,73,5,6217,'Franke Kubus KNG 110 52 Undermount 1.0 Bowl Kitchen Sink'),(43630,73,0,6217,'Franke Kubus KNG 110 52 Undermount 1.0 Bowl Kitchen Sink'),(43631,109,5,6217,'Franke Kubus KNG 110 52 Undermount 1.0 Bowl Kitchen Sink'),(43632,109,0,6217,'Franke Kubus KNG 110 52 Undermount 1.0 Bowl Kitchen Sink'),(43633,121,5,6218,'franke-kubus-kng-110-62-undermount-1-0-bowl-kitchen-sink'),(43634,121,0,6218,'franke-kubus-kng-110-62-undermount-1-0-bowl-kitchen-sink'),(43635,84,5,6218,'Franke Kubus KNG 110 62 Undermount 1.0 Bowl Kitchen Sink'),(43636,84,0,6218,'Franke Kubus KNG 110 62 Undermount 1.0 Bowl Kitchen Sink'),(43637,86,5,6218,'Banyo offers wide range of Franke Kubus 2 KNG 110 62 Undermount 1.0 Bowl Kitchen Sink at affordable price. Kubus KNG sinks are available in stain proof, non-fading super metallic colours.'),(43638,86,0,6218,'Banyo offers wide range of Franke Kubus 2 KNG 110 62 Undermount 1.0 Bowl Kitchen Sink at affordable price. Kubus KNG sinks are available in stain proof, non-fading super metallic colours.'),(43639,73,5,6218,'Franke Kubus KNG 110 62 Undermount 1.0 Bowl Kitchen Sink'),(43640,73,0,6218,'Franke Kubus KNG 110 62 Undermount 1.0 Bowl Kitchen Sink'),(43641,109,5,6218,'Franke Kubus KNG 110 62 Undermount 1.0 Bowl Kitchen Sink'),(43642,109,0,6218,'Franke Kubus KNG 110 62 Undermount 1.0 Bowl Kitchen Sink'),(43643,121,5,6219,'franke-kubus-kng-120-undermount-1-5-bowl-kitchen-sink'),(43644,121,0,6219,'franke-kubus-kng-120-undermount-1-5-bowl-kitchen-sink'),(43645,84,5,6219,'Franke Kubus KNG 120 Undermount 1.5 Bowl Kitchen Sink'),(43646,84,0,6219,'Franke Kubus KNG 120 Undermount 1.5 Bowl Kitchen Sink'),(43647,86,5,6219,'Franke Kubus KNG 120 Undermount 1.5 Bowl Fragranite Sink available in an exceptional range of stain-proof, non-fading super metallic colours of Copper Gold, Lunar Grey, Sterling Silver, Copper Grey.'),(43648,86,0,6219,'Franke Kubus KNG 120 Undermount 1.5 Bowl Fragranite Sink available in an exceptional range of stain-proof, non-fading super metallic colours of Copper Gold, Lunar Grey, Sterling Silver, Copper Grey.'),(43649,73,5,6219,'Franke Kubus KNG 120 Undermount 1.5 Bowl Kitchen Sink'),(43650,73,0,6219,'Franke Kubus KNG 120 Undermount 1.5 Bowl Kitchen Sink'),(43651,109,5,6219,'Franke Kubus KNG 120 Undermount 1.5 Bowl Kitchen Sink'),(43652,109,0,6219,'Franke Kubus KNG 120 Undermount 1.5 Bowl Kitchen Sink'),(43653,121,5,6220,'reginox-l183016-single-bowl-kitchen-sink'),(43654,121,0,6220,'reginox-l183016-single-bowl-kitchen-sink'),(43655,84,5,6220,'Reginox L183016 Single Bowl Kitchen Sink'),(43656,84,0,6220,'Reginox L183016 Single Bowl Kitchen Sink'),(43657,86,5,6220,'Reginox L183016 Single Bowl Kitchen Sink'),(43658,86,0,6220,'Reginox L183016 Single Bowl Kitchen Sink'),(43659,73,5,6220,'Reginox L183016 Single Bowl Kitchen Sink'),(43660,73,0,6220,'Reginox L183016 Single Bowl Kitchen Sink'),(43661,109,5,6220,'Reginox L183016 Single Bowl Kitchen Sink'),(43662,109,0,6220,'Reginox L183016 Single Bowl Kitchen Sink'),(43663,110,5,6220,'Reginox L183016 Single Bowl Kitchen Sink'),(43664,110,0,6220,'Reginox L183016 Single Bowl Kitchen Sink'),(43665,111,5,6220,'Reginox L183016 Single Bowl Kitchen Sink'),(43666,111,0,6220,'Reginox L183016 Single Bowl Kitchen Sink'),(43667,121,5,6221,'reginox-l183440-single-bowl-kitchen-sink'),(43668,121,0,6221,'reginox-l183440-single-bowl-kitchen-sink'),(43669,84,5,6221,'Reginox L183440 Single Bowl Kitchen Sink'),(43670,84,0,6221,'Reginox L183440 Single Bowl Kitchen Sink'),(43671,86,5,6221,'Reginox L183440 Single Bowl Kitchen Sink'),(43672,86,0,6221,'Reginox L183440 Single Bowl Kitchen Sink'),(43673,73,5,6221,'Reginox L183440 Single Bowl Kitchen Sink'),(43674,73,0,6221,'Reginox L183440 Single Bowl Kitchen Sink'),(43675,109,5,6221,'Reginox L183440 Single Bowl Kitchen Sink'),(43676,109,0,6221,'Reginox L183440 Single Bowl Kitchen Sink'),(43677,110,5,6221,'Reginox L183440 Single Bowl Kitchen Sink'),(43678,110,0,6221,'Reginox L183440 Single Bowl Kitchen Sink'),(43679,111,5,6221,'Reginox L183440 Single Bowl Kitchen Sink'),(43680,111,0,6221,'Reginox L183440 Single Bowl Kitchen Sink'),(43681,121,5,6222,'reginox-l18390-l-round-bowl-kitchen-sink'),(43682,121,0,6222,'reginox-l18390-l-round-bowl-kitchen-sink'),(43683,84,5,6222,'Reginox L18390 L Round Bowl Kitchen Sink'),(43684,84,0,6222,'Reginox L18390 L Round Bowl Kitchen Sink'),(43685,86,5,6222,'Reginox L18390 L Round Bowl Kitchen Sink'),(43686,86,0,6222,'Reginox L18390 L Round Bowl Kitchen Sink'),(43687,73,5,6222,'Reginox L18390 L Round Bowl Kitchen Sink'),(43688,73,0,6222,'Reginox L18390 L Round Bowl Kitchen Sink'),(43689,109,5,6222,'Reginox L18390 L Round Bowl Kitchen Sink'),(43690,109,0,6222,'Reginox L18390 L Round Bowl Kitchen Sink'),(43691,110,5,6222,'Reginox L18390 L Round Bowl Kitchen Sink'),(43692,110,0,6222,'Reginox L18390 L Round Bowl Kitchen Sink'),(43693,111,5,6222,'Reginox L18390 L Round Bowl Kitchen Sink'),(43694,111,0,6222,'Reginox L18390 L Round Bowl Kitchen Sink'),(43695,121,5,6223,'franke-largo-lax-110-45-undermount-kitchen-sink-stainless-steel'),(43696,121,0,6223,'franke-largo-lax-110-45-undermount-kitchen-sink-stainless-steel'),(43697,84,5,6223,'Franke Largo LAX 110 45 Undermount Kitchen Sink Stainless Steel - LAX 110 45 -'),(43698,84,0,6223,'Franke Largo LAX 110 45 Undermount Kitchen Sink Stainless Steel - LAX 110 45 -'),(43699,86,5,6223,'A wide variety of Franke Kubus KBX 160 45-20 Undermount Kitchen Sink Stainless Steel at unbeatable prices availabe on Banyo website and showroom in Leicester.'),(43700,86,0,6223,'A wide variety of Franke Kubus KBX 160 45-20 Undermount Kitchen Sink Stainless Steel at unbeatable prices availabe on Banyo website and showroom in Leicester.'),(43701,73,5,6223,'Franke Largo LAX 110 45 Undermount 1.0 Bowl Kitchen Sink'),(43702,73,0,6223,'Franke Largo LAX 110 45 Undermount 1.0 Bowl Kitchen Sink'),(43703,109,5,6223,'Franke Largo LAX 110 45 Undermount 1.0 Bowl Kitchen Sink'),(43704,109,0,6223,'Franke Largo LAX 110 45 Undermount 1.0 Bowl Kitchen Sink'),(43705,121,5,6224,'franke-largo-lax-110-50-undermount-kitchen-sink-stainless-steel'),(43706,121,0,6224,'franke-largo-lax-110-50-undermount-kitchen-sink-stainless-steel'),(43707,84,5,6224,'Franke Largo LAX 110 50 Undermount Kitchen Sink Stainless Steel - LAX 110 50 -'),(43708,84,0,6224,'Franke Largo LAX 110 50 Undermount Kitchen Sink Stainless Steel - LAX 110 50 -'),(43709,86,5,6224,'Get Franke Kubus KBX 160 55-20 Stainless Steel Undermount Kitchen Sink cheap deals only at banyo.To avail our free and fastest delivery services place an order online.'),(43710,86,0,6224,'Get Franke Kubus KBX 160 55-20 Stainless Steel Undermount Kitchen Sink cheap deals only at banyo.To avail our free and fastest delivery services place an order online.'),(43711,73,5,6224,'Franke Largo LAX 110 50 Undermount 1.0 Bowl Kitchen Sink'),(43712,73,0,6224,'Franke Largo LAX 110 50 Undermount 1.0 Bowl Kitchen Sink'),(43713,109,5,6224,'Franke Largo LAX 110 50 Undermount 1.0 Bowl Kitchen Sink'),(43714,109,0,6224,'Franke Largo LAX 110 50 Undermount 1.0 Bowl Kitchen Sink'),(43715,121,5,6225,'franke-largo-lax-110-50-41-undermount-kitchen-sink-stainless-steel'),(43716,121,0,6225,'franke-largo-lax-110-50-41-undermount-kitchen-sink-stainless-steel'),(43717,84,5,6225,'Franke Largo LAX 110 50-41 Undermount Kitchen Sink Stainless Steel - LAX 110 50-41 -'),(43718,84,0,6225,'Franke Largo LAX 110 50-41 Undermount Kitchen Sink Stainless Steel - LAX 110 50-41 -'),(43719,86,5,6225,'Fantastic deals on Franke Largo LAX 110 45 Undermount Kitchen Sink Stainless Steel available now at banyo.get manifacturer guarantee and fastest delivery just place an order now.'),(43720,86,0,6225,'Fantastic deals on Franke Largo LAX 110 45 Undermount Kitchen Sink Stainless Steel available now at banyo.get manifacturer guarantee and fastest delivery just place an order now.'),(43721,73,5,6225,'Franke Largo LAX 110 50-41 Undermount 1.0 Bowl Kitchen Sink'),(43722,73,0,6225,'Franke Largo LAX 110 50-41 Undermount 1.0 Bowl Kitchen Sink'),(43723,109,5,6225,'Franke Largo LAX 110 50-41 Undermount 1.0 Bowl Kitchen Sink'),(43724,109,0,6225,'Franke Largo LAX 110 50-41 Undermount 1.0 Bowl Kitchen Sink'),(43725,121,5,6226,'franke-largo-lax-120-36-36-undermount-kitchen-sink-stainless-steel'),(43726,121,0,6226,'franke-largo-lax-120-36-36-undermount-kitchen-sink-stainless-steel'),(43727,84,5,6226,'Franke Largo LAX 120 36-36 Undermount Kitchen Sink Stainless Steel - LAX 120 36-36 -'),(43728,84,0,6226,'Franke Largo LAX 120 36-36 Undermount Kitchen Sink Stainless Steel - LAX 120 36-36 -'),(43729,86,5,6226,'Franke Largo LAX 110 50 Undermount Kitchen Sink Stainless Steel best deal at Banyo.visit our showroom in Leicester or place an order online on our website.'),(43730,86,0,6226,'Franke Largo LAX 110 50 Undermount Kitchen Sink Stainless Steel best deal at Banyo.visit our showroom in Leicester or place an order online on our website.'),(43731,73,5,6226,'Franke Largo LAX 120 36-36 Undermount 2.0 Bowl Kitchen Sink'),(43732,73,0,6226,'Franke Largo LAX 120 36-36 Undermount 2.0 Bowl Kitchen Sink'),(43733,109,5,6226,'Franke Largo LAX 120 36-36 Undermount 2.0 Bowl Kitchen Sink'),(43734,109,0,6226,'Franke Largo LAX 120 36-36 Undermount 2.0 Bowl Kitchen Sink'),(43735,121,5,6227,'franke-largo-lax-120-45-30-undermount-kitchen-sink-stainless-steel'),(43736,121,0,6227,'franke-largo-lax-120-45-30-undermount-kitchen-sink-stainless-steel'),(43737,84,5,6227,'Franke Largo LAX 120 45-30 Undermount Kitchen Sink Stainless Steel - LAX 120 45-30 -'),(43738,84,0,6227,'Franke Largo LAX 120 45-30 Undermount Kitchen Sink Stainless Steel - LAX 120 45-30 -'),(43739,86,5,6227,'We have an exclusive collection of Franke Largo LAX 110 50-41 Stainless Steel Undermount Kitchen Sink online on banyo site and our showroon in Leicester.'),(43740,86,0,6227,'We have an exclusive collection of Franke Largo LAX 110 50-41 Stainless Steel Undermount Kitchen Sink online on banyo site and our showroon in Leicester.'),(43741,73,5,6227,'Franke Largo LAX 120 45-30 Undermount 1.75 Bowl Kitchen Sink'),(43742,73,0,6227,'Franke Largo LAX 120 45-30 Undermount 1.75 Bowl Kitchen Sink'),(43743,109,5,6227,'Franke Largo LAX 120 45-30 Undermount 1.75 Bowl Kitchen Sink'),(43744,109,0,6227,'Franke Largo LAX 120 45-30 Undermount 1.75 Bowl Kitchen Sink'),(43745,121,5,6228,'franke-largo-lax-160-36-16-undermount-kitchen-sink-stainless-steel'),(43746,121,0,6228,'franke-largo-lax-160-36-16-undermount-kitchen-sink-stainless-steel'),(43747,84,5,6228,'Franke Largo LAX 160 36-16 Undermount Kitchen Sink Stainless Steel - LAX 160 36-16 -'),(43748,84,0,6228,'Franke Largo LAX 160 36-16 Undermount Kitchen Sink Stainless Steel - LAX 160 36-16 -'),(43749,86,5,6228,'Big saving deals on Franke Largo LAX 120 36-36 Undermount Kitchen Sink Stainless Steel at Banyo.Check our showroom in Leicester or palce an order online for best deals.'),(43750,86,0,6228,'Big saving deals on Franke Largo LAX 120 36-36 Undermount Kitchen Sink Stainless Steel at Banyo.Check our showroom in Leicester or palce an order online for best deals.'),(43751,73,5,6228,'Franke Largo LAX 160 36-16 Undermount 1.5 Bowl Kitchen Sink'),(43752,73,0,6228,'Franke Largo LAX 160 36-16 Undermount 1.5 Bowl Kitchen Sink'),(43753,109,5,6228,'Franke Largo LAX 160 36-16 Undermount 1.5 Bowl Kitchen Sink'),(43754,109,0,6228,'Franke Largo LAX 160 36-16 Undermount 1.5 Bowl Kitchen Sink'),(43755,121,5,6229,'blanco-legra-45-s-silgranit-r-inset-sink'),(43756,121,0,6229,'blanco-legra-45-s-silgranit-r-inset-sink'),(43757,84,5,6229,'Blanco LEGRA 45 S Silgranit 1.0 Bowl Kitchen Sink | Banyo'),(43758,84,0,6229,'Blanco LEGRA 45 S Silgranit 1.0 Bowl Kitchen Sink | Banyo'),(43759,86,5,6229,'Blanco LEGRA 45 S Silgranit ® Inset Sink'),(43760,86,0,6229,'Blanco LEGRA 45 S Silgranit ® Inset Sink'),(43761,73,5,6229,'Blanco LEGRA 45 S Silgranit Â® Inset Sink'),(43762,73,0,6229,'Blanco LEGRA 45 S Silgranit Â® Inset Sink'),(43763,109,5,6229,'Blanco LEGRA 45 S Silgranit ® Inset Sink'),(43764,109,0,6229,'Blanco LEGRA 45 S Silgranit ® Inset Sink'),(43765,121,5,6230,'blanco-legra-6-silgranitr-inset-sink'),(43766,121,0,6230,'blanco-legra-6-silgranitr-inset-sink'),(43767,84,5,6230,'Blanco LEGRA 6 Silgranit Inset 1.0 Bowl  Sink | Banyo'),(43768,84,0,6230,'Blanco LEGRA 6 Silgranit Inset 1.0 Bowl  Sink | Banyo'),(43769,86,5,6230,'Blanco LEGRA 6 Silgranit® Inset Sink'),(43770,86,0,6230,'Blanco LEGRA 6 Silgranit® Inset Sink'),(43771,73,5,6230,'Blanco LEGRA 6 SilgranitÂ® Inset Sink'),(43772,73,0,6230,'Blanco LEGRA 6 SilgranitÂ® Inset Sink'),(43773,109,5,6230,'Blanco LEGRA 6 Silgranit® Inset Sink'),(43774,109,0,6230,'Blanco LEGRA 6 Silgranit® Inset Sink'),(43775,121,5,6231,'blanco-legra-6-s-silgranit-inset-kitchen-sink'),(43776,121,0,6231,'blanco-legra-6-s-silgranit-inset-kitchen-sink'),(43777,73,5,6231,'Blanco LEGRA 6 S Silgranit Inset Kitchen Sink'),(43778,73,0,6231,'Blanco LEGRA 6 S Silgranit Inset Kitchen Sink'),(43779,121,5,6232,'blanco-legra-xl-6-s-silgranitr-inset-sink'),(43780,121,0,6232,'blanco-legra-xl-6-s-silgranitr-inset-sink'),(43781,84,5,6232,'Blanco LEGRA XL 6 S Silgranit - XL Bowl - Inset Kitchen Sink | Banyo'),(43782,84,0,6232,'Blanco LEGRA XL 6 S Silgranit - XL Bowl - Inset Kitchen Sink | Banyo'),(43783,86,5,6232,'Blanco LEGRA XL 6 S Silgranit® Inset Sink'),(43784,86,0,6232,'Blanco LEGRA XL 6 S Silgranit® Inset Sink'),(43785,73,5,6232,'Blanco LEGRA XL 6 S SilgranitÂ® Inset Sink'),(43786,73,0,6232,'Blanco LEGRA XL 6 S SilgranitÂ® Inset Sink'),(43787,109,5,6232,'Blanco LEGRA XL 6 S Silgranit® Inset Sink'),(43788,109,0,6232,'Blanco LEGRA XL 6 S Silgranit® Inset Sink'),(43789,121,5,6233,'reginox-mataro-undermount-1-0-bowl-ceramic-kitchen-sink'),(43790,121,0,6233,'reginox-mataro-undermount-1-0-bowl-ceramic-kitchen-sink'),(43791,84,5,6233,'Reginox Mataro Undermount 1.0 Bowl Ceramic Kitchen Sink'),(43792,84,0,6233,'Reginox Mataro Undermount 1.0 Bowl Ceramic Kitchen Sink'),(43793,73,5,6233,'Reginox Mataro Undermount 1.0 Bowl Ceramic Kitchen Sink'),(43794,73,0,6233,'Reginox Mataro Undermount 1.0 Bowl Ceramic Kitchen Sink'),(43795,109,5,6233,'Reginox Mataro Undermount 1.0 Bowl Ceramic Kitchen Sink'),(43796,109,0,6233,'Reginox Mataro Undermount 1.0 Bowl Ceramic Kitchen Sink'),(43797,110,5,6233,'Reginox Mataro Undermount 1.0 Bowl Ceramic Kitchen Sink'),(43798,110,0,6233,'Reginox Mataro Undermount 1.0 Bowl Ceramic Kitchen Sink'),(43799,111,5,6233,'Reginox Mataro Undermount 1.0 Bowl Ceramic Kitchen Sink'),(43800,111,0,6233,'Reginox Mataro Undermount 1.0 Bowl Ceramic Kitchen Sink'),(43801,121,5,6234,'blanco-metra-45-s-puradur-ii-inset-silgranit-kitchen-sink'),(43802,121,0,6234,'blanco-metra-45-s-puradur-ii-inset-silgranit-kitchen-sink'),(43803,84,5,6234,'Blanco Metra 45 S Puradur II Inset Silgranit Kitchen Sink | Banyo UK'),(43804,84,0,6234,'Blanco Metra 45 S Puradur II Inset Silgranit Kitchen Sink | Banyo UK'),(43805,86,5,6234,'Blanco Metra 45 S Puradur II Inset Silgranit Kitchen Sink with its contemporary design and preeminent functionality is most popular kitchen sink now available on a great deal at banyo.'),(43806,86,0,6234,'Blanco Metra 45 S Puradur II Inset Silgranit Kitchen Sink with its contemporary design and preeminent functionality is most popular kitchen sink now available on a great deal at banyo.'),(43807,73,5,6234,'Blanco Metra 45 S Puradur II Inset Silgranit Kitchen Sink'),(43808,73,0,6234,'Blanco Metra 45 S Puradur II Inset Silgranit Kitchen Sink'),(43809,109,5,6234,'Blanco Metra 45 S Puradur II Inset Silgranit Kitchen Sink'),(43810,109,0,6234,'Blanco Metra 45 S Puradur II Inset Silgranit Kitchen Sink'),(43811,121,5,6235,'blanco-metra-5-s-puradur-ii-inset-silgranit-kitchen-sink'),(43812,121,0,6235,'blanco-metra-5-s-puradur-ii-inset-silgranit-kitchen-sink'),(43813,84,5,6235,'Blanco Metra 5 S Puradur II Inset Silgranit Kitchen Sink | Banyo.co.uk'),(43814,84,0,6235,'Blanco Metra 5 S Puradur II Inset Silgranit Kitchen Sink | Banyo.co.uk'),(43815,86,5,6235,'Blanco Metra 5 S Puradur II Inset Silgranit Kitchen Sink comes in different colours available on a cheap deal here at banyo.Banyo offers a huge range of sinks in modern and traditional designs.'),(43816,86,0,6235,'Blanco Metra 5 S Puradur II Inset Silgranit Kitchen Sink comes in different colours available on a cheap deal here at banyo.Banyo offers a huge range of sinks in modern and traditional designs.'),(43817,73,5,6235,'Blanco Metra 5 S Puradur II Inset Silgranit Kitchen Sink'),(43818,73,0,6235,'Blanco Metra 5 S Puradur II Inset Silgranit Kitchen Sink'),(43819,109,5,6235,'Blanco Metra 5 S Puradur II Inset Silgranit Kitchen Sink'),(43820,109,0,6235,'Blanco Metra 5 S Puradur II Inset Silgranit Kitchen Sink'),(43821,121,5,6236,'blanco-metra-6-puradur-ii-inset-silgranit-kitchen-sink'),(43822,121,0,6236,'blanco-metra-6-puradur-ii-inset-silgranit-kitchen-sink'),(43823,84,5,6236,'Blanco Metra 6 Puradur II Silgranit Inset Kitchen Sink | Banyo.co.uk'),(43824,84,0,6236,'Blanco Metra 6 Puradur II Silgranit Inset Kitchen Sink | Banyo.co.uk'),(43825,86,5,6236,'Blanco Metra 6 Puradur II Inset Silgranit Kitchen Sink offers an excellent flexibility and modern looks available now at banyo.We sell kitchen suites in a wide variety of styles and all at great value prices to make it both easy and affordable to find you'),(43826,86,0,6236,'Blanco Metra 6 Puradur II Inset Silgranit Kitchen Sink offers an excellent flexibility and modern looks available now at banyo.We sell kitchen suites in a wide variety of styles and all at great value prices to make it both easy and affordable to find you'),(43827,73,5,6236,'Blanco Metra 6 Puradur II Inset Silgranit Kitchen Sink'),(43828,73,0,6236,'Blanco Metra 6 Puradur II Inset Silgranit Kitchen Sink'),(43829,109,5,6236,'Blanco Metra 6 Puradur II Inset Silgranit Kitchen Sink'),(43830,109,0,6236,'Blanco Metra 6 Puradur II Inset Silgranit Kitchen Sink'),(43831,121,5,6237,'blanco-metra-6-s-puradur-ii-inset-silgranit-kitchen-sink'),(43832,121,0,6237,'blanco-metra-6-s-puradur-ii-inset-silgranit-kitchen-sink'),(43833,84,5,6237,'Blanco Metra 6S Silgranit Puradur Inset Kitchen Sink | Banyo UK'),(43834,84,0,6237,'Blanco Metra 6S Silgranit Puradur Inset Kitchen Sink | Banyo UK'),(43835,86,5,6237,'Banyo offers Blanco Metra 6-S Puradur II Inset Silgranit Kitchen Sink with Great Discounts and Manufacturer\'s Guarantee. To avail fastest delivery services across UK, visit banyo.co.uk'),(43836,86,0,6237,'Banyo offers Blanco Metra 6-S Puradur II Inset Silgranit Kitchen Sink with Great Discounts and Manufacturer\'s Guarantee. To avail fastest delivery services across UK, visit banyo.co.uk'),(43837,73,5,6237,'Blanco Metra 6-S Puradur II Inset Silgranit Kitchen Sink'),(43838,73,0,6237,'Blanco Metra 6-S Puradur II Inset Silgranit Kitchen Sink'),(43839,109,5,6237,'Blanco Metra 6-S Puradur II Inset Silgranit Kitchen Sink'),(43840,109,0,6237,'Blanco Metra 6-S Puradur II Inset Silgranit Kitchen Sink'),(43841,121,5,6238,'blanco-metra-8-s-puradur-ii-inset-silgranit-kitchen-sink'),(43842,121,0,6238,'blanco-metra-8-s-puradur-ii-inset-silgranit-kitchen-sink'),(43843,84,5,6238,'Blanco Metra 8S Silgranit Puradur Silgranit Kitchen Sink | Banyo.co.uk'),(43844,84,0,6238,'Blanco Metra 8S Silgranit Puradur Silgranit Kitchen Sink | Banyo.co.uk'),(43845,86,5,6238,'Blanco Metra 8-S Puradur II Inset Silgranit Kitchen Sink with its exceptional performance and simplicity add a style and sophistication in your kitchen from banyo available on a big sale.'),(43846,86,0,6238,'Blanco Metra 8-S Puradur II Inset Silgranit Kitchen Sink with its exceptional performance and simplicity add a style and sophistication in your kitchen from banyo available on a big sale.'),(43847,73,5,6238,'Blanco Metra 8-S Puradur II Inset Silgranit Kitchen Sink'),(43848,73,0,6238,'Blanco Metra 8-S Puradur II Inset Silgranit Kitchen Sink'),(43849,109,5,6238,'Blanco Metra 8-S Puradur II Inset Silgranit Kitchen Sink'),(43850,109,0,6238,'Blanco Metra 8-S Puradur II Inset Silgranit Kitchen Sink'),(43851,121,5,6239,'blanco-metra-xl-puradur-ii-inset-silgranit-kitchen-sink'),(43852,121,0,6239,'blanco-metra-xl-puradur-ii-inset-silgranit-kitchen-sink'),(43853,84,5,6239,'Blanco Metra XL 6 S Silgranit Puradur Large Bowl Kitchen Sink | Banyo UK'),(43854,84,0,6239,'Blanco Metra XL 6 S Silgranit Puradur Large Bowl Kitchen Sink | Banyo UK'),(43855,86,5,6239,'Stylish and smart Blanco Metra XL Puradur II Inset Silgranit Kitchen Sink offering a practical kitchen now available at banyo on cheap deals. A stylish Blanco sink will add a perfect finishing touch to any contemporary kitchen'),(43856,86,0,6239,'Stylish and smart Blanco Metra XL Puradur II Inset Silgranit Kitchen Sink offering a practical kitchen now available at banyo on cheap deals. A stylish Blanco sink will add a perfect finishing touch to any contemporary kitchen'),(43857,73,5,6239,'Blanco Metra XL 6 S Puradur II Silgranit Inset Kitchen Sink'),(43858,73,0,6239,'Blanco Metra XL 6 S Puradur II Silgranit Inset Kitchen Sink'),(43859,109,5,6239,'Blanco Metra XL 6 S Puradur II Silgranit Inset Kitchen Sink'),(43860,109,0,6239,'Blanco Metra XL 6 S Puradur II Silgranit Inset Kitchen Sink'),(43861,121,5,6240,'reginox-miami-40x40-single-bowl-kitchen-sink'),(43862,121,0,6240,'reginox-miami-40x40-single-bowl-kitchen-sink'),(43863,84,5,6240,'Reginox Miami 40x40 Single Bowl Kitchen Sink '),(43864,84,0,6240,'Reginox Miami 40x40 Single Bowl Kitchen Sink '),(43865,73,5,6240,'Reginox Miami 40x40 Single Bowl Kitchen Sink '),(43866,73,0,6240,'Reginox Miami 40x40 Single Bowl Kitchen Sink '),(43867,109,5,6240,'Reginox Miami 40x40 Single Bowl Kitchen Sink '),(43868,109,0,6240,'Reginox Miami 40x40 Single Bowl Kitchen Sink '),(43869,110,5,6240,'Reginox Miami 40x40 Single Bowl Kitchen Sink '),(43870,110,0,6240,'Reginox Miami 40x40 Single Bowl Kitchen Sink '),(43871,111,5,6240,'Reginox Miami 40x40 Single Bowl Kitchen Sink '),(43872,111,0,6240,'Reginox Miami 40x40 Single Bowl Kitchen Sink '),(43873,121,5,6241,'reginox-miami-50x40-single-bowl-kitchen-sink'),(43874,121,0,6241,'reginox-miami-50x40-single-bowl-kitchen-sink'),(43875,84,5,6241,'Reginox Miami 50X40 Single Bowl Kitchen Sink '),(43876,84,0,6241,'Reginox Miami 50X40 Single Bowl Kitchen Sink '),(43877,73,5,6241,'Reginox Miami 50X40 Single Bowl Kitchen Sink '),(43878,73,0,6241,'Reginox Miami 50X40 Single Bowl Kitchen Sink '),(43879,109,5,6241,'Reginox Miami 50X40 Single Bowl Kitchen Sink '),(43880,109,0,6241,'Reginox Miami 50X40 Single Bowl Kitchen Sink '),(43881,110,5,6241,'Reginox Miami 50X40 Single Bowl Kitchen Sink '),(43882,110,0,6241,'Reginox Miami 50X40 Single Bowl Kitchen Sink '),(43883,111,5,6241,'Reginox Miami 50X40 Single Bowl Kitchen Sink '),(43884,111,0,6241,'Reginox Miami 50X40 Single Bowl Kitchen Sink '),(43885,121,5,6242,'reginox-elegance-minister-reversible-inset-1-bowl-kitchen-sink'),(43886,121,0,6242,'reginox-elegance-minister-reversible-inset-1-bowl-kitchen-sink'),(43887,84,5,6242,'Reginox Elegance Minister Reversible Inset 1 Bowl Kitchen Sink'),(43888,84,0,6242,'Reginox Elegance Minister Reversible Inset 1 Bowl Kitchen Sink'),(43889,86,5,6242,'Reginox Elegance Minister Reversible Inset 1 Bowl Kitchen Sink'),(43890,86,0,6242,'Reginox Elegance Minister Reversible Inset 1 Bowl Kitchen Sink'),(43891,73,5,6242,'Reginox Elegance Minister Reversible Inset 1 Bowl Kitchen Sink'),(43892,73,0,6242,'Reginox Elegance Minister Reversible Inset 1 Bowl Kitchen Sink'),(43893,109,5,6242,'Reginox Elegance Minister Reversible Inset 1 Bowl Kitchen Sink'),(43894,109,0,6242,'Reginox Elegance Minister Reversible Inset 1 Bowl Kitchen Sink'),(43895,121,5,6243,'franke-maris-quiet-mqx-110-50-single-bowl-undermount-kitchen-sink'),(43896,121,0,6243,'franke-maris-quiet-mqx-110-50-single-bowl-undermount-kitchen-sink'),(43897,84,5,6243,'Franke Maris Quiet MQX 110 50 Single Bowl Undermount Kitchen Sink'),(43898,84,0,6243,'Franke Maris Quiet MQX 110 50 Single Bowl Undermount Kitchen Sink'),(43899,86,5,6243,'Franke Maris Quiet MQX 110 50 Single Bowl Undermount Kitchen Sink'),(43900,86,0,6243,'Franke Maris Quiet MQX 110 50 Single Bowl Undermount Kitchen Sink'),(43901,73,5,6243,'Franke Maris Quiet MQX 110 50 Single Bowl Undermount Kitchen Sink'),(43902,73,0,6243,'Franke Maris Quiet MQX 110 50 Single Bowl Undermount Kitchen Sink'),(43903,109,5,6243,'Franke Maris Quiet MQX 110 50 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43904,109,0,6243,'Franke Maris Quiet MQX 110 50 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43905,110,5,6243,'Franke Maris Quiet MQX 110 50 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43906,110,0,6243,'Franke Maris Quiet MQX 110 50 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43907,111,5,6243,'Franke Maris Quiet MQX 110 50 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43908,111,0,6243,'Franke Maris Quiet MQX 110 50 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43909,121,5,6244,'franke-maris-quiet-mqx-110-82-undermount-1-bowl-kitchen-sink'),(43910,121,0,6244,'franke-maris-quiet-mqx-110-82-undermount-1-bowl-kitchen-sink'),(43911,84,5,6244,'Franke Maris Quiet MQX 110 82 Undermount 1 Bowl Kitchen Sink'),(43912,84,0,6244,'Franke Maris Quiet MQX 110 82 Undermount 1 Bowl Kitchen Sink'),(43913,86,5,6244,'Franke Maris Quiet MQX 110 82 Undermount 1 Bowl Kitchen Sink'),(43914,86,0,6244,'Franke Maris Quiet MQX 110 82 Undermount 1 Bowl Kitchen Sink'),(43915,73,5,6244,'Franke Maris Quiet MQX 110 82 Undermount 1 Bowl Kitchen Sink'),(43916,73,0,6244,'Franke Maris Quiet MQX 110 82 Undermount 1 Bowl Kitchen Sink'),(43917,109,5,6244,'Franke Maris Quiet MQX 110 82 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43918,109,0,6244,'Franke Maris Quiet MQX 110 82 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43919,110,5,6244,'Franke Maris Quiet MQX 110 82 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43920,110,0,6244,'Franke Maris Quiet MQX 110 82 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43921,111,5,6244,'Franke Maris Quiet MQX 110 82 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43922,111,0,6244,'Franke Maris Quiet MQX 110 82 Undermount 1 Bowl Kitchen Sink Stainless Steel'),(43923,121,5,6245,'franke-maris-mrg-110-37-kitchen-sink'),(43924,121,0,6245,'franke-maris-mrg-110-37-kitchen-sink'),(43925,73,5,6245,'Franke Maris MRG 110-37 Kitchen Sink'),(43926,73,0,6245,'Franke Maris MRG 110-37 Kitchen Sink'),(43927,109,5,6245,'Franke Maris MRG 110-37 Kitchen Sink'),(43928,109,0,6245,'Franke Maris MRG 110-37 Kitchen Sink'),(43929,110,5,6245,'Franke Maris MRG 110-37 Kitchen Sink'),(43930,110,0,6245,'Franke Maris MRG 110-37 Kitchen Sink'),(43931,111,5,6245,'Franke Maris MRG 110-37 Kitchen Sink'),(43932,111,0,6245,'Franke Maris MRG 110-37 Kitchen Sink'),(43933,121,5,6246,'franke-maris-mrg-110-52-kitchen-sink'),(43934,121,0,6246,'franke-maris-mrg-110-52-kitchen-sink'),(43935,73,5,6246,'Franke Maris MRG 110-52 Kitchen Sink'),(43936,73,0,6246,'Franke Maris MRG 110-52 Kitchen Sink'),(43937,109,5,6246,'Franke Maris MRG 110-52 Kitchen Sink'),(43938,109,0,6246,'Franke Maris MRG 110-52 Kitchen Sink'),(43939,110,5,6246,'Franke Maris MRG 110-52 Kitchen Sink'),(43940,110,0,6246,'Franke Maris MRG 110-52 Kitchen Sink'),(43941,111,5,6246,'Franke Maris MRG 110-52 Kitchen Sink'),(43942,111,0,6246,'Franke Maris MRG 110-52 Kitchen Sink'),(43943,121,5,6247,'franke-maris-mrg-110-72-kitchen-sink'),(43944,121,0,6247,'franke-maris-mrg-110-72-kitchen-sink'),(43945,73,5,6247,'Franke Maris MRG 110-72 Kitchen Sink'),(43946,73,0,6247,'Franke Maris MRG 110-72 Kitchen Sink'),(43947,109,5,6247,'Franke Maris MRG 110-72 Kitchen Sink'),(43948,109,0,6247,'Franke Maris MRG 110-72 Kitchen Sink'),(43949,110,5,6247,'Franke Maris MRG 110-72 Kitchen Sink'),(43950,110,0,6247,'Franke Maris MRG 110-72 Kitchen Sink'),(43951,111,5,6247,'Franke Maris MRG 110-72 Kitchen Sink'),(43952,111,0,6247,'Franke Maris MRG 110-72 Kitchen Sink'),(43953,121,5,6248,'franke-maris-mrg-160-34-15-kitchen-sink'),(43954,121,0,6248,'franke-maris-mrg-160-34-15-kitchen-sink'),(43955,73,5,6248,'Franke Maris MRG 160-34-15 Kitchen Sink'),(43956,73,0,6248,'Franke Maris MRG 160-34-15 Kitchen Sink'),(43957,109,5,6248,'Franke Maris MRG 160-34-15 Kitchen Sink'),(43958,109,0,6248,'Franke Maris MRG 160-34-15 Kitchen Sink'),(43959,110,5,6248,'Franke Maris MRG 160-34-15 Kitchen Sink'),(43960,110,0,6248,'Franke Maris MRG 160-34-15 Kitchen Sink'),(43961,111,5,6248,'Franke Maris MRG 160-34-15 Kitchen Sink'),(43962,111,0,6248,'Franke Maris MRG 160-34-15 Kitchen Sink'),(43963,121,5,6249,'franke-maris-mrx-210-19-inset-1-bowl-kitchen-sink-stainless-steel'),(43964,121,0,6249,'franke-maris-mrx-210-19-inset-1-bowl-kitchen-sink-stainless-steel'),(43965,84,5,6249,'Franke Maris MRX 210-19 Inset 0.5 Bowl Kitchen Sink Stainless Steel'),(43966,84,0,6249,'Franke Maris MRX 210-19 Inset 0.5 Bowl Kitchen Sink Stainless Steel'),(43967,86,5,6249,'Buy Franke Maris MRX 210-19 Stainless Steel half bowl sink from Banyo with the lowest price in the UK. Minimalistic Inset Slim top design, Hygienic overflow is a perfect add-on for any Kitchen Sink.'),(43968,86,0,6249,'Buy Franke Maris MRX 210-19 Stainless Steel half bowl sink from Banyo with the lowest price in the UK. Minimalistic Inset Slim top design, Hygienic overflow is a perfect add-on for any Kitchen Sink.'),(43969,73,5,6249,'Franke Maris MRX 210-19 Inset 0.5 Bowl Kitchen Sink Stainless Steel'),(43970,73,0,6249,'Franke Maris MRX 210-19 Inset 0.5 Bowl Kitchen Sink Stainless Steel'),(43971,109,5,6249,'Franke Maris MRX 210-19 Inset 0.5 Bowl Kitchen Sink Stainless Steel'),(43972,109,0,6249,'Franke Maris MRX 210-19 Inset 0.5 Bowl Kitchen Sink Stainless Steel'),(43973,121,5,6250,'franke-maris-bowl-mrx-210-34-inset-1-0-bowl-kitchen-sink'),(43974,121,0,6250,'franke-maris-bowl-mrx-210-34-inset-1-0-bowl-kitchen-sink'),(43975,84,5,6250,'Franke Maris Bowl MRX 210-34 Inset 1.0 Bowl Kitchen Sink'),(43976,84,0,6250,'Franke Maris Bowl MRX 210-34 Inset 1.0 Bowl Kitchen Sink'),(43977,86,5,6250,'Franke Maris Bowl MRX 210-34 is a Stainless steel single Bowl Sink with inset installation. Minimalistic slim top design, Hygenic Overflow are just a few features which makes this a perfect fit for any modern kitchen.'),(43978,86,0,6250,'Franke Maris Bowl MRX 210-34 is a Stainless steel single Bowl Sink with inset installation. Minimalistic slim top design, Hygenic Overflow are just a few features which makes this a perfect fit for any modern kitchen.'),(43979,73,5,6250,'Franke Maris MRX 210-34 Inset 1.0 Bowl Kitchen Sink'),(43980,73,0,6250,'Franke Maris MRX 210-34 Inset 1.0 Bowl Kitchen Sink'),(43981,109,5,6250,'Franke Maris MRX 210-34 Inset 1.0 Bowl Kitchen Sink'),(43982,109,0,6250,'Franke Maris MRX 210-34 Inset 1.0 Bowl Kitchen Sink'),(43983,121,5,6251,'franke-maris-mrx-210-45-inset-1-bowl-kitchen-sink-stainless-steel'),(43984,121,0,6251,'franke-maris-mrx-210-45-inset-1-bowl-kitchen-sink-stainless-steel'),(43985,84,5,6251,'Franke Maris MRX 210-45 Inset 1 Bowl Kitchen Sink Stainless Steel'),(43986,84,0,6251,'Franke Maris MRX 210-45 Inset 1 Bowl Kitchen Sink Stainless Steel'),(43987,86,5,6251,'Franke Maris MRX 210-45 Inset 1 Bowl Stainless Steel Kitchen Sink is a modern minimalistic kitchen sink. Banyo offers best delivery service and cheapest online prices on Franke Sinks and Taps.'),(43988,86,0,6251,'Franke Maris MRX 210-45 Inset 1 Bowl Stainless Steel Kitchen Sink is a modern minimalistic kitchen sink. Banyo offers best delivery service and cheapest online prices on Franke Sinks and Taps.'),(43989,73,5,6251,'Franke Maris MRX 210-45 Inset 1 Bowl Kitchen Sink Stainless Steel'),(43990,73,0,6251,'Franke Maris MRX 210-45 Inset 1 Bowl Kitchen Sink Stainless Steel'),(43991,109,5,6251,'Franke Maris MRX 210-45 Inset 1 Bowl Kitchen Sink Stainless Steel\r\n'),(43992,109,0,6251,'Franke Maris MRX 210-45 Inset 1 Bowl Kitchen Sink Stainless Steel\r\n'),(43993,110,5,6251,'Franke Maris MRX 210-45 Inset 1 Bowl Kitchen Sink Stainless Steel\r\n'),(43994,110,0,6251,'Franke Maris MRX 210-45 Inset 1 Bowl Kitchen Sink Stainless Steel\r\n'),(43995,111,5,6251,'Franke Maris MRX 210-45 Inset 1 Bowl Kitchen Sink Stainless Steel\r\n'),(43996,111,0,6251,'Franke Maris MRX 210-45 Inset 1 Bowl Kitchen Sink Stainless Steel\r\n'),(43997,121,5,6252,'franke-maris-bowl-mrx-210-70-inset-1-0-bowl-kitchen-sink'),(43998,121,0,6252,'franke-maris-bowl-mrx-210-70-inset-1-0-bowl-kitchen-sink'),(43999,84,5,6252,'Franke Maris Bowl MRX 210-70 Inset 1.0 Bowl Kitchen Sink'),(44000,84,0,6252,'Franke Maris Bowl MRX 210-70 Inset 1.0 Bowl Kitchen Sink'),(44001,86,5,6252,'Franke Maris Bowl MRX 210-70 is a stainless steel single large bowl sink with an inset installation. Slim Top Design, Hygienic overflow, Durable are just a few features which make this a perfect fit for any contemporary style kitchen.'),(44002,86,0,6252,'Franke Maris Bowl MRX 210-70 is a stainless steel single large bowl sink with an inset installation. Slim Top Design, Hygienic overflow, Durable are just a few features which make this a perfect fit for any contemporary style kitchen.'),(44003,73,5,6252,'Franke Maris MRX 210-70 Inset 1.0 Bowl Kitchen Sink'),(44004,73,0,6252,'Franke Maris MRX 210-70 Inset 1.0 Bowl Kitchen Sink'),(44005,109,5,6252,'Franke Maris MRX 210-70 Inset 1.0 Bowl Kitchen Sink'),(44006,109,0,6252,'Franke Maris MRX 210-70 Inset 1.0 Bowl Kitchen Sink'),(44007,121,5,6253,'franke-maris-mrx-211-slim-top-bowl-inset-kitchen-sink-stainless-steel'),(44008,121,0,6253,'franke-maris-mrx-211-slim-top-bowl-inset-kitchen-sink-stainless-steel'),(44009,84,5,6253,'Franke Maris MRX 211 Slim-Top Inset Kitchen Sink Stainless Steel - MRX 211 -'),(44010,84,0,6253,'Franke Maris MRX 211 Slim-Top Inset Kitchen Sink Stainless Steel - MRX 211 -'),(44011,86,5,6253,'Modern Franke Laser LSX 651 Inset Stainless Steel Kitchen Sink with simply unbeatable prices available at banyo.We have Fastest and free delivery services across UK.'),(44012,86,0,6253,'Modern Franke Laser LSX 651 Inset Stainless Steel Kitchen Sink with simply unbeatable prices available at banyo.We have Fastest and free delivery services across UK.'),(44013,73,5,6253,'Franke Maris MRX 211 Slim-Top Inset 1.0 Bowl Kitchen Sink'),(44014,73,0,6253,'Franke Maris MRX 211 Slim-Top Inset 1.0 Bowl Kitchen Sink'),(44015,109,5,6253,'Franke Maris MRX 211 Slim-Top Inset 1.0 Bowl Kitchen Sink'),(44016,109,0,6253,'Franke Maris MRX 211 Slim-Top Inset 1.0 Bowl Kitchen Sink'),(44017,121,5,6254,'franke-maris-mrx-220-34-34-stainless-steel-double-bowl-sink'),(44018,121,0,6254,'franke-maris-mrx-220-34-34-stainless-steel-double-bowl-sink'),(44019,84,5,6254,'Franke Maris MRX 220 34-34 Stainless Steel Double Bowl Sink'),(44020,84,0,6254,'Franke Maris MRX 220 34-34 Stainless Steel Double Bowl Sink'),(44021,86,5,6254,'Buy Franke Maris MRX 220 34-34 Stainless Steel Double Bowl Sink with the lowest price in the UK only offered at Banyo. Slim-Top design, hygienic overflow and Inset Installation.'),(44022,86,0,6254,'Buy Franke Maris MRX 220 34-34 Stainless Steel Double Bowl Sink with the lowest price in the UK only offered at Banyo. Slim-Top design, hygienic overflow and Inset Installation.'),(44023,73,5,6254,'Franke Maris MRX 220 34-34 Stainless Steel Double Bowl Sink'),(44024,73,0,6254,'Franke Maris MRX 220 34-34 Stainless Steel Double Bowl Sink'),(44025,109,5,6254,'Franke Maris MRX 220 34-34 Stainless Steel Double Bowl Sink'),(44026,109,0,6254,'Franke Maris MRX 220 34-34 Stainless Steel Double Bowl Sink'),(44027,121,5,6255,'franke-maris-mrx-251-slim-top-inset-1-5-bowl-kitchen-sink'),(44028,121,0,6255,'franke-maris-mrx-251-slim-top-inset-1-5-bowl-kitchen-sink'),(44029,84,5,6255,'Franke Maris MRX 251 Slim-Top Inset Kitchen Sink Stainless Steel - MRX 251 -'),(44030,84,0,6255,'Franke Maris MRX 251 Slim-Top Inset Kitchen Sink Stainless Steel - MRX 251 -'),(44031,86,5,6255,'Unbeatable prices for Franke Maris MRX 211 Slim-Top Inset Kitchen Sink Stainless Steel only at Banyo.co.uk. We are the most trusted and reliable suppliers of all kitchen appliances in UK.'),(44032,86,0,6255,'Unbeatable prices for Franke Maris MRX 211 Slim-Top Inset Kitchen Sink Stainless Steel only at Banyo.co.uk. We are the most trusted and reliable suppliers of all kitchen appliances in UK.'),(44033,73,5,6255,'Franke Maris MRX 251 Slim-Top Inset 1.5 Bowl Kitchen Sink'),(44034,73,0,6255,'Franke Maris MRX 251 Slim-Top Inset 1.5 Bowl Kitchen Sink'),(44035,109,5,6255,'Franke Maris MRX 251 Slim-Top Inset 1.5 Bowl Kitchen Sink'),(44036,109,0,6255,'Franke Maris MRX 251 Slim-Top Inset 1.5 Bowl Kitchen Sink'),(44037,110,5,6255,'Franke Maris MRX 251 Slim-Top Inset 1.5 Bowl Kitchen Sink'),(44038,110,0,6255,'Franke Maris MRX 251 Slim-Top Inset 1.5 Bowl Kitchen Sink'),(44039,111,5,6255,'Franke Maris MRX 251 Slim-Top Inset 1.5 Bowl Kitchen Sink'),(44040,111,0,6255,'Franke Maris MRX 251 Slim-Top Inset 1.5 Bowl Kitchen Sink'),(44041,121,5,6256,'franke-maris-mrx-260-34-19-inset-1-5-bowl-kitchen-sink-stainless-steel'),(44042,121,0,6256,'franke-maris-mrx-260-34-19-inset-1-5-bowl-kitchen-sink-stainless-steel'),(44043,84,5,6256,'Franke Maris MRX 260-34-19 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44044,84,0,6256,'Franke Maris MRX 260-34-19 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44045,86,5,6256,'Buy Franke Maris MRX 260-34-19 1.5 Bowl Kitchen Sink with Stainless Steel finish with the lowest price and fast delivery service all across the UK. For best deals on Inset Kitchen Sinks visit our Showroom today! '),(44046,86,0,6256,'Buy Franke Maris MRX 260-34-19 1.5 Bowl Kitchen Sink with Stainless Steel finish with the lowest price and fast delivery service all across the UK. For best deals on Inset Kitchen Sinks visit our Showroom today! '),(44047,73,5,6256,'Franke Maris MRX 260-34-19 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44048,73,0,6256,'Franke Maris MRX 260-34-19 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44049,109,5,6256,'Franke Maris MRX 260-34-19 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44050,109,0,6256,'Franke Maris MRX 260-34-19 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44051,121,5,6257,'franke-mtg-651-100-mythos-fragranite-kitchen-sink'),(44052,121,0,6257,'franke-mtg-651-100-mythos-fragranite-kitchen-sink'),(44053,84,5,6257,'Franke Mythos 1.5 Bowl Fragranite Kitchen Sink - MTG 651-100 -'),(44054,84,0,6257,'Franke Mythos 1.5 Bowl Fragranite Kitchen Sink - MTG 651-100 -'),(44055,86,5,6257,'Banyo offers Franke Mythos Fusion Fragranite Kitchen Sink Onyx with discount and manufacturer warranty. MTF 651-100 available in an elegant colour finish of Onyx, Polar White, Stone Grey, Coffee, Oyster.'),(44056,86,0,6257,'Banyo offers Franke Mythos Fusion Fragranite Kitchen Sink Onyx with discount and manufacturer warranty. MTF 651-100 available in an elegant colour finish of Onyx, Polar White, Stone Grey, Coffee, Oyster.'),(44057,73,5,6257,'Franke MTG 651-100 Mythos 1.5 Bowl Fragranite Kitchen Sink'),(44058,73,0,6257,'Franke MTG 651-100 Mythos 1.5 Bowl Fragranite Kitchen Sink'),(44059,109,5,6257,'Franke MTG 651-100 Mythos 1.5 Bowl Fragranite Kitchen Sink'),(44060,109,0,6257,'Franke MTG 651-100 Mythos 1.5 Bowl Fragranite Kitchen Sink'),(44061,121,5,6258,'reginox-multa-102-inset-single-bowl-granite-kitchen-sink'),(44062,121,0,6258,'reginox-multa-102-inset-single-bowl-granite-kitchen-sink'),(44063,84,5,6258,'Reginox Multa 102 Inset Single Bowl Granite kitchen Sink'),(44064,84,0,6258,'Reginox Multa 102 Inset Single Bowl Granite kitchen Sink'),(44065,73,5,6258,'Reginox Multa 102 Inset Single Bowl Granite kitchen Sink'),(44066,73,0,6258,'Reginox Multa 102 Inset Single Bowl Granite kitchen Sink'),(44067,109,5,6258,'Reginox Multa 102 Inset Single Bowl Granite kitchen Sink'),(44068,109,0,6258,'Reginox Multa 102 Inset Single Bowl Granite kitchen Sink'),(44069,110,5,6258,'Reginox Multa 102 Inset Single Bowl Granite kitchen Sink'),(44070,110,0,6258,'Reginox Multa 102 Inset Single Bowl Granite kitchen Sink'),(44071,111,5,6258,'Reginox Multa 102 Inset Single Bowl Granite kitchen Sink'),(44072,111,0,6258,'Reginox Multa 102 Inset Single Bowl Granite kitchen Sink'),(44073,121,5,6259,'reginox-multa-105-inset-single-bowl-granite-kitchen-sink'),(44074,121,0,6259,'reginox-multa-105-inset-single-bowl-granite-kitchen-sink'),(44075,84,5,6259,'Reginox Multa 105 Inset Single Bowl Granite kitchen Sink'),(44076,84,0,6259,'Reginox Multa 105 Inset Single Bowl Granite kitchen Sink'),(44077,73,5,6259,'Reginox Multa 105 Inset Single Bowl Granite kitchen Sink'),(44078,73,0,6259,'Reginox Multa 105 Inset Single Bowl Granite kitchen Sink'),(44079,109,5,6259,'Reginox Multa 105 Inset Single Bowl Granite kitchen Sink'),(44080,109,0,6259,'Reginox Multa 105 Inset Single Bowl Granite kitchen Sink'),(44081,110,5,6259,'Reginox Multa 105 Inset Single Bowl Granite kitchen Sink'),(44082,110,0,6259,'Reginox Multa 105 Inset Single Bowl Granite kitchen Sink'),(44083,111,5,6259,'Reginox Multa 105 Inset Single Bowl Granite kitchen Sink'),(44084,111,0,6259,'Reginox Multa 105 Inset Single Bowl Granite kitchen Sink'),(44085,121,5,6260,'reginox-multa-130-inset-single-bowl-granite-kitchen-sink'),(44086,121,0,6260,'reginox-multa-130-inset-single-bowl-granite-kitchen-sink'),(44087,84,5,6260,'Reginox Multa 130 Black Square Single Bowl kitchen Sink'),(44088,84,0,6260,'Reginox Multa 130 Black Square Single Bowl kitchen Sink'),(44089,73,5,6260,'Reginox Multa 130 Inset Single Bowl Granite kitchen Sink'),(44090,73,0,6260,'Reginox Multa 130 Inset Single Bowl Granite kitchen Sink'),(44091,109,5,6260,'Reginox Multa 130 Inset Single Bowl Granite kitchen Sink'),(44092,109,0,6260,'Reginox Multa 130 Inset Single Bowl Granite kitchen Sink'),(44093,110,5,6260,'Reginox Multa 130 Inset Single Bowl Granite kitchen Sink'),(44094,110,0,6260,'Reginox Multa 130 Inset Single Bowl Granite kitchen Sink'),(44095,111,5,6260,'Reginox Multa 130 Inset Single Bowl Granite kitchen Sink'),(44096,111,0,6260,'Reginox Multa 130 Inset Single Bowl Granite kitchen Sink'),(44097,121,5,6261,'franke-mythos-myx-160-34-16-undermount-stainless-steel-1-5-bowl-sink'),(44098,121,0,6261,'franke-mythos-myx-160-34-16-undermount-stainless-steel-1-5-bowl-sink'),(44099,84,5,6261,'Franke Mythos MYX 160 34-16 Undermount Stainless Steel 1.5 Bowl Sink'),(44100,84,0,6261,'Franke Mythos MYX 160 34-16 Undermount Stainless Steel 1.5 Bowl Sink'),(44101,86,5,6261,'Franke Mythos MYX 160 34-16 Undermount Stainless Steel 1.5 Bowl Sink '),(44102,86,0,6261,'Franke Mythos MYX 160 34-16 Undermount Stainless Steel 1.5 Bowl Sink '),(44103,73,5,6261,'Franke Mythos MYX 160 34-16 Undermount Stainless Steel 1.5 Bowl Sink'),(44104,73,0,6261,'Franke Mythos MYX 160 34-16 Undermount Stainless Steel 1.5 Bowl Sink'),(44105,121,5,6262,'franke-mythos-myx-160-50-16-undermount-stainless-steel-1-5-bowl-sink'),(44106,121,0,6262,'franke-mythos-myx-160-50-16-undermount-stainless-steel-1-5-bowl-sink'),(44107,84,5,6262,'Franke Mythos MYX 160 50-16 Undermount Stainless Steel 1.5 Bowl Sink'),(44108,84,0,6262,'Franke Mythos MYX 160 50-16 Undermount Stainless Steel 1.5 Bowl Sink'),(44109,86,5,6262,'Franke Mythos MYX 160 50-16 Undermount Stainless Steel 1.5 Bowl Sink '),(44110,86,0,6262,'Franke Mythos MYX 160 50-16 Undermount Stainless Steel 1.5 Bowl Sink '),(44111,73,5,6262,'Franke Mythos MYX 160 50-16 Undermount Stainless Steel 1.5 Bowl Sink'),(44112,73,0,6262,'Franke Mythos MYX 160 50-16 Undermount Stainless Steel 1.5 Bowl Sink'),(44113,121,5,6263,'franke-mythos-myx-210-34-inset-single-bowl-sink-stainless-steel'),(44114,121,0,6263,'franke-mythos-myx-210-34-inset-single-bowl-sink-stainless-steel'),(44115,84,5,6263,'Franke Mythos MYX 210-34 Inset Single Bowl Sink - Stainless Steel'),(44116,84,0,6263,'Franke Mythos MYX 210-34 Inset Single Bowl Sink - Stainless Steel'),(44117,86,5,6263,'Franke Mythos MYX 210-34 Inset Single Bowl Sink - Stainless Steel'),(44118,86,0,6263,'Franke Mythos MYX 210-34 Inset Single Bowl Sink - Stainless Steel'),(44119,73,5,6263,'Franke Mythos MYX 210-34 Inset Single Bowl Sink - Stainless Steel'),(44120,73,0,6263,'Franke Mythos MYX 210-34 Inset Single Bowl Sink - Stainless Steel'),(44121,121,5,6264,'franke-mythos-myx-210-45-inset-single-bowl-sink-stainless-steel'),(44122,121,0,6264,'franke-mythos-myx-210-45-inset-single-bowl-sink-stainless-steel'),(44123,84,5,6264,'Franke Mythos MYX 210-45 Inset Single Bowl Sink - Stainless Steel'),(44124,84,0,6264,'Franke Mythos MYX 210-45 Inset Single Bowl Sink - Stainless Steel'),(44125,86,5,6264,'Franke Mythos MYX 210-45 Inset Single Bowl Sink - Stainless Steel'),(44126,86,0,6264,'Franke Mythos MYX 210-45 Inset Single Bowl Sink - Stainless Steel'),(44127,73,5,6264,'Franke Mythos MYX 210-45 Inset Single Bowl Sink - Stainless Steel'),(44128,73,0,6264,'Franke Mythos MYX 210-45 Inset Single Bowl Sink - Stainless Steel'),(44129,121,5,6265,'franke-mythos-myx-210-55-inset-single-bowl-sink-stainless-steel'),(44130,121,0,6265,'franke-mythos-myx-210-55-inset-single-bowl-sink-stainless-steel'),(44131,84,5,6265,'Franke Mythos MYX 210-55 Inset Single Bowl Sink - Stainless Steel'),(44132,84,0,6265,'Franke Mythos MYX 210-55 Inset Single Bowl Sink - Stainless Steel'),(44133,86,5,6265,'Franke Mythos MYX 210-55 Inset Single Bowl Sink - Stainless Steel'),(44134,86,0,6265,'Franke Mythos MYX 210-55 Inset Single Bowl Sink - Stainless Steel'),(44135,73,5,6265,'Franke Mythos MYX 210-55 Inset Single Bowl Sink - Stainless Steel'),(44136,73,0,6265,'Franke Mythos MYX 210-55 Inset Single Bowl Sink - Stainless Steel'),(44137,121,5,6266,'franke-mythos-myx-210-70-inset-single-bowl-sink-stainless-steel'),(44138,121,0,6266,'franke-mythos-myx-210-70-inset-single-bowl-sink-stainless-steel'),(44139,84,5,6266,'Franke Mythos MYX 210-70 Inset Single Bowl Sink - Stainless Steel'),(44140,84,0,6266,'Franke Mythos MYX 210-70 Inset Single Bowl Sink - Stainless Steel'),(44141,86,5,6266,'Franke Mythos MYX 210-70 Inset Single Bowl Sink - Stainless Steel'),(44142,86,0,6266,'Franke Mythos MYX 210-70 Inset Single Bowl Sink - Stainless Steel'),(44143,73,5,6266,'Franke Mythos MYX 210-70 Inset Single Bowl Sink - Stainless Steel'),(44144,73,0,6266,'Franke Mythos MYX 210-70 Inset Single Bowl Sink - Stainless Steel'),(44145,121,5,6267,'franke-mythos-myx-211-86-stainless-steel-kitchen-sink'),(44146,121,0,6267,'franke-mythos-myx-211-86-stainless-steel-kitchen-sink'),(44147,84,5,6267,'Franke Mythos MYX 211-86 Stainless Steel Kitchen Sink'),(44148,84,0,6267,'Franke Mythos MYX 211-86 Stainless Steel Kitchen Sink'),(44149,86,5,6267,'Franke Mythos MYX 211-86 Stainless Steel Kitchen Sink'),(44150,86,0,6267,'Franke Mythos MYX 211-86 Stainless Steel Kitchen Sink'),(44151,73,5,6267,'Franke Mythos MYX 211-86 Stainless Steel Kitchen Sink'),(44152,73,0,6267,'Franke Mythos MYX 211-86 Stainless Steel Kitchen Sink'),(44153,109,5,6267,'Franke Mythos MYX 211-86 Stainless Steel Kitchen Sink'),(44154,109,0,6267,'Franke Mythos MYX 211-86 Stainless Steel Kitchen Sink'),(44155,110,5,6267,'Franke Mythos MYX 211-86 Stainless Steel Kitchen Sink'),(44156,110,0,6267,'Franke Mythos MYX 211-86 Stainless Steel Kitchen Sink'),(44157,111,5,6267,'Franke Mythos MYX 211-86 Stainless Steel Kitchen Sink'),(44158,111,0,6267,'Franke Mythos MYX 211-86 Stainless Steel Kitchen Sink'),(44159,121,5,6268,'franke-mythos-myx-251-86-stainless-steel-kitchen-sink'),(44160,121,0,6268,'franke-mythos-myx-251-86-stainless-steel-kitchen-sink'),(44161,84,5,6268,'Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink'),(44162,84,0,6268,'Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink'),(44163,86,5,6268,'Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink'),(44164,86,0,6268,'Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink'),(44165,73,5,6268,'Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink'),(44166,73,0,6268,'Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink'),(44167,109,5,6268,'Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink'),(44168,109,0,6268,'Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink'),(44169,110,5,6268,'Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink'),(44170,110,0,6268,'Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink'),(44171,111,5,6268,'Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink'),(44172,111,0,6268,'Franke Mythos MYX 251-86 Stainless Steel Kitchen Sink'),(44173,121,5,6269,'blanco-naya-6-silgranit-puradur-iir-inset-sink'),(44174,121,0,6269,'blanco-naya-6-silgranit-puradur-iir-inset-sink'),(44175,84,5,6269,'Blanco NAYA 6 Silgranit PuraDur II Inset Single Bowl Kitchen Sink | Banyo'),(44176,84,0,6269,'Blanco NAYA 6 Silgranit PuraDur II Inset Single Bowl Kitchen Sink | Banyo'),(44177,86,5,6269,'Blanco NAYA 6 Silgranit PuraDur II® Inset Sink'),(44178,86,0,6269,'Blanco NAYA 6 Silgranit PuraDur II® Inset Sink'),(44179,73,5,6269,'Blanco NAYA 6 Silgranit PuraDur IIÂ® Inset Sink'),(44180,73,0,6269,'Blanco NAYA 6 Silgranit PuraDur IIÂ® Inset Sink'),(44181,109,5,6269,'Blanco NAYA 6 Silgranit PuraDur II® Inset Sink'),(44182,109,0,6269,'Blanco NAYA 6 Silgranit PuraDur II® Inset Sink'),(44183,121,5,6270,'blanco-naya-xl-9-inset-silgranit-puradur-iir-kitchen-sink'),(44184,121,0,6270,'blanco-naya-xl-9-inset-silgranit-puradur-iir-kitchen-sink'),(44185,84,5,6270,'Blanco NAYA XL 9 Silgranit PuraDur Inset Kitchen Sink | Banyo'),(44186,84,0,6270,'Blanco NAYA XL 9 Silgranit PuraDur Inset Kitchen Sink | Banyo'),(44187,86,5,6270,'Blanco NAYA XL 9 Inset Silgranit PuraDur II® Kitchen Sink'),(44188,86,0,6270,'Blanco NAYA XL 9 Inset Silgranit PuraDur II® Kitchen Sink'),(44189,73,5,6270,'Blanco NAYA XL 9 Inset Silgranit PuraDur IIÂ® Kitchen Sink'),(44190,73,0,6270,'Blanco NAYA XL 9 Inset Silgranit PuraDur IIÂ® Kitchen Sink'),(44191,109,5,6270,'Blanco NAYA XL 9 Inset Silgranit PuraDur II® Kitchen Sink'),(44192,109,0,6270,'Blanco NAYA XL 9 Inset Silgranit PuraDur II® Kitchen Sink'),(44193,121,5,6271,'reginox-new-york-18x40-l-single-bowl-kitchen-sink'),(44194,121,0,6271,'reginox-new-york-18x40-l-single-bowl-kitchen-sink'),(44195,84,5,6271,'Reginox New York 18x40 L Single Bowl Kitchen Sink'),(44196,84,0,6271,'Reginox New York 18x40 L Single Bowl Kitchen Sink'),(44197,86,5,6271,'Reginox New York 18x40 L Single Bowl Kitchen Sink'),(44198,86,0,6271,'Reginox New York 18x40 L Single Bowl Kitchen Sink'),(44199,73,5,6271,'Reginox New York 18x40 L Single Bowl Kitchen Sink'),(44200,73,0,6271,'Reginox New York 18x40 L Single Bowl Kitchen Sink'),(44201,109,5,6271,'Reginox New York 18x40 L Single Bowl Kitchen Sink'),(44202,109,0,6271,'Reginox New York 18x40 L Single Bowl Kitchen Sink'),(44203,110,5,6271,'Reginox New York 18x40 L Single Bowl Kitchen Sink'),(44204,110,0,6271,'Reginox New York 18x40 L Single Bowl Kitchen Sink'),(44205,111,5,6271,'Reginox New York 18x40 L Single Bowl Kitchen Sink'),(44206,111,0,6271,'Reginox New York 18x40 L Single Bowl Kitchen Sink'),(44207,121,5,6272,'reginox-new-york-18x40-34x40-1-5-bowl-kitchen-sink'),(44208,121,0,6272,'reginox-new-york-18x40-34x40-1-5-bowl-kitchen-sink'),(44209,84,5,6272,'Reginox New York 18x40+34x40 1.5 Bowl Kitchen Sink'),(44210,84,0,6272,'Reginox New York 18x40+34x40 1.5 Bowl Kitchen Sink'),(44211,86,5,6272,'Reginox New York 18x40+34x40 1.5 Bowl Kitchen Sink'),(44212,86,0,6272,'Reginox New York 18x40+34x40 1.5 Bowl Kitchen Sink'),(44213,73,5,6272,'Reginox New York 18x40+34x40 1.5 Bowl Kitchen Sink'),(44214,73,0,6272,'Reginox New York 18x40+34x40 1.5 Bowl Kitchen Sink'),(44215,109,5,6272,'Reginox New York 18x40+34x40 1.5 Bowl Kitchen Sink'),(44216,109,0,6272,'Reginox New York 18x40+34x40 1.5 Bowl Kitchen Sink'),(44217,110,5,6272,'Reginox New York 18x40+34x40 1.5 Bowl Kitchen Sink'),(44218,110,0,6272,'Reginox New York 18x40+34x40 1.5 Bowl Kitchen Sink'),(44219,111,5,6272,'Reginox New York 18x40+34x40 1.5 Bowl Kitchen Sink'),(44220,111,0,6272,'Reginox New York 18x40+34x40 1.5 Bowl Kitchen Sink'),(44221,121,5,6273,'reginox-new-york-34x40-l-single-bowl-kitchen-sink'),(44222,121,0,6273,'reginox-new-york-34x40-l-single-bowl-kitchen-sink'),(44223,84,5,6273,'Reginox New York 34x40 L Single Bowl Kitchen Sink'),(44224,84,0,6273,'Reginox New York 34x40 L Single Bowl Kitchen Sink'),(44225,86,5,6273,'Reginox New York 34x40 L Single Bowl Kitchen Sink'),(44226,86,0,6273,'Reginox New York 34x40 L Single Bowl Kitchen Sink'),(44227,73,5,6273,'Reginox New York 34x40 L Single Bowl Kitchen Sink'),(44228,73,0,6273,'Reginox New York 34x40 L Single Bowl Kitchen Sink'),(44229,109,5,6273,'Reginox New York 34x40 L Single Bowl Kitchen Sink'),(44230,109,0,6273,'Reginox New York 34x40 L Single Bowl Kitchen Sink'),(44231,110,5,6273,'Reginox New York 34x40 L Single Bowl Kitchen Sink'),(44232,110,0,6273,'Reginox New York 34x40 L Single Bowl Kitchen Sink'),(44233,111,5,6273,'Reginox New York 34x40 L Single Bowl Kitchen Sink'),(44234,111,0,6273,'Reginox New York 34x40 L Single Bowl Kitchen Sink'),(44235,121,5,6274,'reginox-new-york-34x40-18x40-1-5-bowl-kitchen-sink'),(44236,121,0,6274,'reginox-new-york-34x40-18x40-1-5-bowl-kitchen-sink'),(44237,84,5,6274,'Reginox New York 34x40+18x40 1.5 Bowl Kitchen Sink'),(44238,84,0,6274,'Reginox New York 34x40+18x40 1.5 Bowl Kitchen Sink'),(44239,86,5,6274,'Reginox New York 34x40+18x40 1.5 Bowl Kitchen Sink'),(44240,86,0,6274,'Reginox New York 34x40+18x40 1.5 Bowl Kitchen Sink'),(44241,73,5,6274,'Reginox New York 34x40+18x40 1.5 Bowl Kitchen Sink'),(44242,73,0,6274,'Reginox New York 34x40+18x40 1.5 Bowl Kitchen Sink'),(44243,109,5,6274,'Reginox New York 34x40+18x40 1.5 Bowl Kitchen Sink'),(44244,109,0,6274,'Reginox New York 34x40+18x40 1.5 Bowl Kitchen Sink'),(44245,110,5,6274,'Reginox New York 34x40+18x40 1.5 Bowl Kitchen Sink'),(44246,110,0,6274,'Reginox New York 34x40+18x40 1.5 Bowl Kitchen Sink'),(44247,111,5,6274,'Reginox New York 34x40+18x40 1.5 Bowl Kitchen Sink'),(44248,111,0,6274,'Reginox New York 34x40+18x40 1.5 Bowl Kitchen Sink'),(44249,121,5,6275,'reginox-new-york-40x40-l-integrated-kitchen-sink'),(44250,121,0,6275,'reginox-new-york-40x40-l-integrated-kitchen-sink'),(44251,84,5,6275,'Reginox New York 40x40 L Integrated Kitchen Sink'),(44252,84,0,6275,'Reginox New York 40x40 L Integrated Kitchen Sink'),(44253,86,5,6275,'Reginox New York 40x40 L Integrated Kitchen Sink'),(44254,86,0,6275,'Reginox New York 40x40 L Integrated Kitchen Sink'),(44255,73,5,6275,'Reginox New York 40x40 L Integrated Kitchen Sink'),(44256,73,0,6275,'Reginox New York 40x40 L Integrated Kitchen Sink'),(44257,109,5,6275,'Reginox New York 40x40 L Integrated Kitchen Sink'),(44258,109,0,6275,'Reginox New York 40x40 L Integrated Kitchen Sink'),(44259,121,5,6276,'reginox-new-york-50x40-l-single-bowl-kitchen-sink'),(44260,121,0,6276,'reginox-new-york-50x40-l-single-bowl-kitchen-sink'),(44261,84,5,6276,'Reginox New York 50x40 L Single Bowl Kitchen Sink'),(44262,84,0,6276,'Reginox New York 50x40 L Single Bowl Kitchen Sink'),(44263,86,5,6276,'Reginox New York 50x40 L Single Bowl Kitchen Sink'),(44264,86,0,6276,'Reginox New York 50x40 L Single Bowl Kitchen Sink'),(44265,73,5,6276,'Reginox New York 50x40 L Single Bowl Kitchen Sink'),(44266,73,0,6276,'Reginox New York 50x40 L Single Bowl Kitchen Sink'),(44267,109,5,6276,'Reginox New York 50x40 L Single Bowl Kitchen Sink'),(44268,109,0,6276,'Reginox New York 50x40 L Single Bowl Kitchen Sink'),(44269,110,5,6276,'Reginox New York 50x40 L Single Bowl Kitchen Sink'),(44270,110,0,6276,'Reginox New York 50x40 L Single Bowl Kitchen Sink'),(44271,111,5,6276,'Reginox New York 50x40 L Single Bowl Kitchen Sink'),(44272,111,0,6276,'Reginox New York 50x40 L Single Bowl Kitchen Sink'),(44273,121,5,6277,'reginox-new-york-50x40-18x40-1-5-bowl-kitchen-sink'),(44274,121,0,6277,'reginox-new-york-50x40-18x40-1-5-bowl-kitchen-sink'),(44275,84,5,6277,'Reginox New York 50x40+18x40 1.5 Bowl Kitchen Sink'),(44276,84,0,6277,'Reginox New York 50x40+18x40 1.5 Bowl Kitchen Sink'),(44277,86,5,6277,'Reginox New York 50x40+18x40 1.5 Bowl Kitchen Sink'),(44278,86,0,6277,'Reginox New York 50x40+18x40 1.5 Bowl Kitchen Sink'),(44279,73,5,6277,'Reginox New York 50x40+18x40 1.5 Bowl Kitchen Sink'),(44280,73,0,6277,'Reginox New York 50x40+18x40 1.5 Bowl Kitchen Sink'),(44281,109,5,6277,'Reginox New York 50x40+18x40 1.5 Bowl Kitchen Sink'),(44282,109,0,6277,'Reginox New York 50x40+18x40 1.5 Bowl Kitchen Sink'),(44283,110,5,6277,'Reginox New York 50x40+18x40 1.5 Bowl Kitchen Sink'),(44284,110,0,6277,'Reginox New York 50x40+18x40 1.5 Bowl Kitchen Sink'),(44285,111,5,6277,'Reginox New York 50x40+18x40 1.5 Bowl Kitchen Sink'),(44286,111,0,6277,'Reginox New York 50x40+18x40 1.5 Bowl Kitchen Sink'),(44287,121,5,6278,'franke-neptune-nex-211-kitchen-inset-sink-stainless-steel'),(44288,121,0,6278,'franke-neptune-nex-211-kitchen-inset-sink-stainless-steel'),(44289,84,5,6278,'Franke Neptune NEX 211 Inset Kitchen Sink Stainless Steel - NEX 211 -'),(44290,84,0,6278,'Franke Neptune NEX 211 Inset Kitchen Sink Stainless Steel - NEX 211 -'),(44291,86,5,6278,'Franke Neptune NEX 211 is an inset stainless steel single bowl sink with drainer options (left or right). Find the lowest price in the UK on Banyo with fast delivery service.'),(44292,86,0,6278,'Franke Neptune NEX 211 is an inset stainless steel single bowl sink with drainer options (left or right). Find the lowest price in the UK on Banyo with fast delivery service.'),(44293,73,5,6278,'Franke Neptune NEX 211 Inset 1.0 Bowl Kitchen Sink Stainless Steel'),(44294,73,0,6278,'Franke Neptune NEX 211 Inset 1.0 Bowl Kitchen Sink Stainless Steel'),(44295,109,5,6278,'Franke Neptune NEX 211 Inset 1.0 Bowl Kitchen Sink Stainless Steel'),(44296,109,0,6278,'Franke Neptune NEX 211 Inset 1.0 Bowl Kitchen Sink Stainless Steel'),(44297,110,5,6278,'Franke Neptune NEX 211 Inset 1.0 Bowl Kitchen Sink Stainless Steel'),(44298,110,0,6278,'Franke Neptune NEX 211 Inset 1.0 Bowl Kitchen Sink Stainless Steel'),(44299,111,5,6278,'Franke Neptune NEX 211 Inset 1.0 Bowl Kitchen Sink Stainless Steel'),(44300,111,0,6278,'Franke Neptune NEX 211 Inset 1.0 Bowl Kitchen Sink Stainless Steel'),(44301,121,5,6279,'franke-neptune-nex-251-kitchen-inset-sink-stainless-steel'),(44302,121,0,6279,'franke-neptune-nex-251-kitchen-inset-sink-stainless-steel'),(44303,84,5,6279,'Franke Neptune NEX 251 Inset Kitchen Sink Stainless Steel - NEX 251 -'),(44304,84,0,6279,'Franke Neptune NEX 251 Inset Kitchen Sink Stainless Steel - NEX 251 -'),(44305,86,5,6279,'Best Saving Deals on Franke Neptune NEX 251 Stainless Steel 1.5 Bowl Kitchen Sink at Banyo. For the best prices in the UK and fast delivery service visit our showroom today!'),(44306,86,0,6279,'Best Saving Deals on Franke Neptune NEX 251 Stainless Steel 1.5 Bowl Kitchen Sink at Banyo. For the best prices in the UK and fast delivery service visit our showroom today!'),(44307,73,5,6279,'Franke Neptune NEX 251 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44308,73,0,6279,'Franke Neptune NEX 251 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44309,109,5,6279,'Franke Neptune NEX 251 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44310,109,0,6279,'Franke Neptune NEX 251 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44311,110,5,6279,'Franke Neptune NEX 251 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44312,110,0,6279,'Franke Neptune NEX 251 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44313,111,5,6279,'Franke Neptune NEX 251 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44314,111,0,6279,'Franke Neptune NEX 251 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44315,121,5,6280,'rak-laboratory-1-ceramic-kitchen-sink-single-bowl'),(44316,121,0,6280,'rak-laboratory-1-ceramic-kitchen-sink-single-bowl'),(44317,84,5,6280,'RAK Laboratory 1 Ceramic Kitchen Sink - Single Bowl'),(44318,84,0,6280,'RAK Laboratory 1 Ceramic Kitchen Sink - Single Bowl'),(44319,86,5,6280,'RAK Laboratory 1 Ceramic Kitchen Sink - Single Bowl'),(44320,86,0,6280,'RAK Laboratory 1 Ceramic Kitchen Sink - Single Bowl'),(44321,73,5,6280,'RAK Laboratory 1 Ceramic Kitchen Sink - Single Bowl'),(44322,73,0,6280,'RAK Laboratory 1 Ceramic Kitchen Sink - Single Bowl'),(44323,109,5,6280,'RAK Laboratory 1 Ceramic Kitchen Sink - Single Bowl'),(44324,109,0,6280,'RAK Laboratory 1 Ceramic Kitchen Sink - Single Bowl'),(44325,121,5,6281,'rak-laboratory-2-ceramic-kitchen-sink-single-bowl'),(44326,121,0,6281,'rak-laboratory-2-ceramic-kitchen-sink-single-bowl'),(44327,84,5,6281,'RAK Laboratory 2 Ceramic Kitchen Sink - Single Bowl'),(44328,84,0,6281,'RAK Laboratory 2 Ceramic Kitchen Sink - Single Bowl'),(44329,86,5,6281,'RAK Laboratory 2 Ceramic Kitchen Sink - Single Bowl'),(44330,86,0,6281,'RAK Laboratory 2 Ceramic Kitchen Sink - Single Bowl'),(44331,73,5,6281,'RAK Laboratory 2 Ceramic Kitchen Sink - Single Bowl'),(44332,73,0,6281,'RAK Laboratory 2 Ceramic Kitchen Sink - Single Bowl'),(44333,109,5,6281,'RAK Laboratory 2 Ceramic Kitchen Sink - Single Bowl'),(44334,109,0,6281,'RAK Laboratory 2 Ceramic Kitchen Sink - Single Bowl'),(44335,121,5,6282,'rak-laboratory-counter-top-single-bowl-kitchen-sink-labsink3'),(44336,121,0,6282,'rak-laboratory-counter-top-single-bowl-kitchen-sink-labsink3'),(44337,84,5,6282,'RAK Laboratory Counter Top Single Bowl Kitchen Sink - LABSINK3'),(44338,84,0,6282,'RAK Laboratory Counter Top Single Bowl Kitchen Sink - LABSINK3'),(44339,86,5,6282,'RAK Laboratory Counter Top Single Bowl Ceramic Kitchen Sink - LABSINK3'),(44340,86,0,6282,'RAK Laboratory Counter Top Single Bowl Ceramic Kitchen Sink - LABSINK3'),(44341,73,5,6282,'RAK Laboratory Counter Top Single Bowl Ceramic Kitchen Sink - OC164AWHA'),(44342,73,0,6282,'RAK Laboratory Counter Top Single Bowl Ceramic Kitchen Sink - OC164AWHA'),(44343,109,5,6282,'RAK Laboratory Counter Top Single Bowl Ceramic Kitchen Sink - LABSINK3'),(44344,109,0,6282,'RAK Laboratory Counter Top Single Bowl Ceramic Kitchen Sink - LABSINK3'),(44345,121,5,6283,'rak-laboratory-counter-top-single-bowl-ceramic-kitchen-sink-labsink4'),(44346,121,0,6283,'rak-laboratory-counter-top-single-bowl-ceramic-kitchen-sink-labsink4'),(44347,84,5,6283,'RAK Laboratory Counter Top Single Bowl Ceramic Kitchen Sink - LABSINK4'),(44348,84,0,6283,'RAK Laboratory Counter Top Single Bowl Ceramic Kitchen Sink - LABSINK4'),(44349,86,5,6283,'RAK Laboratory Counter Top Single Bowl Ceramic Kitchen Sink - LABSINK4'),(44350,86,0,6283,'RAK Laboratory Counter Top Single Bowl Ceramic Kitchen Sink - LABSINK4'),(44351,73,5,6283,'RAK Laboratory Counter Top Single Bowl Ceramic Kitchen Sink - OC165AWHA'),(44352,73,0,6283,'RAK Laboratory Counter Top Single Bowl Ceramic Kitchen Sink - OC165AWHA'),(44353,109,5,6283,'RAK Laboratory Counter Top Single Bowl Ceramic Kitchen Sink - LABSINK4'),(44354,109,0,6283,'RAK Laboratory Counter Top Single Bowl Ceramic Kitchen Sink - LABSINK4'),(44355,121,5,6284,'reginox-elite-ohio-l-integrated-0-5-bowl-kitchen-sink-18x40cm'),(44356,121,0,6284,'reginox-elite-ohio-l-integrated-0-5-bowl-kitchen-sink-18x40cm'),(44357,84,5,6284,'Reginox Elite Ohio L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(44358,84,0,6284,'Reginox Elite Ohio L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(44359,86,5,6284,'Reginox Elite Ohio L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(44360,86,0,6284,'Reginox Elite Ohio L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(44361,73,5,6284,'Reginox Elite Ohio L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(44362,73,0,6284,'Reginox Elite Ohio L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(44363,109,5,6284,'Reginox Elite Ohio L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(44364,109,0,6284,'Reginox Elite Ohio L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(44365,121,5,6285,'reginox-elite-ohio-l-integrated-1-5-bowl-kitchen-sink-18x40-50x40cm'),(44366,121,0,6285,'reginox-elite-ohio-l-integrated-1-5-bowl-kitchen-sink-18x40-50x40cm'),(44367,84,5,6285,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 18X40+50X40cm'),(44368,84,0,6285,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 18X40+50X40cm'),(44369,86,5,6285,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 18X40+50X40cm'),(44370,86,0,6285,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 18X40+50X40cm'),(44371,73,5,6285,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 18X40+50X40cm'),(44372,73,0,6285,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 18X40+50X40cm'),(44373,109,5,6285,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 18X40+50X40cm'),(44374,109,0,6285,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 18X40+50X40cm'),(44375,121,5,6286,'reginox-elite-ohio-l-integrated-1-bowl-kitchen-sink-40x40cm'),(44376,121,0,6286,'reginox-elite-ohio-l-integrated-1-bowl-kitchen-sink-40x40cm'),(44377,84,5,6286,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 40X40cm'),(44378,84,0,6286,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 40X40cm'),(44379,86,5,6286,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 40X40cm'),(44380,86,0,6286,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 40X40cm'),(44381,73,5,6286,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 40X40cm'),(44382,73,0,6286,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 40X40cm'),(44383,109,5,6286,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 40X40cm'),(44384,109,0,6286,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 40X40cm'),(44385,121,5,6287,'reginox-elite-ohio-l-integrated-1-bowl-kitchen-sink-with-tap-wing-40x40cm'),(44386,121,0,6287,'reginox-elite-ohio-l-integrated-1-bowl-kitchen-sink-with-tap-wing-40x40cm'),(44387,84,5,6287,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 40X40cm'),(44388,84,0,6287,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 40X40cm'),(44389,86,5,6287,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 40X40cm'),(44390,86,0,6287,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 40X40cm'),(44391,73,5,6287,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 40X40cm'),(44392,73,0,6287,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 40X40cm'),(44393,109,5,6287,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 40X40cm'),(44394,109,0,6287,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 40X40cm'),(44395,121,5,6288,'reginox-elite-ohio-l-integrated-1-bowl-kitchen-sink-50x40cm'),(44396,121,0,6288,'reginox-elite-ohio-l-integrated-1-bowl-kitchen-sink-50x40cm'),(44397,84,5,6288,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 50X40cm'),(44398,84,0,6288,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 50X40cm'),(44399,86,5,6288,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 50X40cm'),(44400,86,0,6288,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 50X40cm'),(44401,73,5,6288,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 50X40cm'),(44402,73,0,6288,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 50X40cm'),(44403,109,5,6288,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 50X40cm'),(44404,109,0,6288,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 50X40cm'),(44405,121,5,6289,'reginox-elite-ohio-l-integrated-1-bowl-kitchen-sink-with-tap-wing-50x40cm'),(44406,121,0,6289,'reginox-elite-ohio-l-integrated-1-bowl-kitchen-sink-with-tap-wing-50x40cm'),(44407,84,5,6289,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 50X40cm'),(44408,84,0,6289,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 50X40cm'),(44409,86,5,6289,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 50X40cm'),(44410,86,0,6289,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 50X40cm'),(44411,73,5,6289,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 50X40cm'),(44412,73,0,6289,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 50X40cm'),(44413,109,5,6289,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 50X40cm'),(44414,109,0,6289,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink with Tap Wing 50X40cm'),(44415,121,5,6290,'reginox-elite-ohio-l-integrated-1-5-bowl-kitchen-sink-50x40-18x40cm'),(44416,121,0,6290,'reginox-elite-ohio-l-integrated-1-5-bowl-kitchen-sink-50x40-18x40cm'),(44417,84,5,6290,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 50X40+18X40cm'),(44418,84,0,6290,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 50X40+18X40cm'),(44419,86,5,6290,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 50X40+18X40cm'),(44420,86,0,6290,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 50X40+18X40cm'),(44421,73,5,6290,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 50X40+18X40cm'),(44422,73,0,6290,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 50X40+18X40cm'),(44423,109,5,6290,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 50X40+18X40cm'),(44424,109,0,6290,'Reginox Elite Ohio L Integrated 1.5 Bowl Kitchen Sink 50X40+18X40cm'),(44425,121,5,6291,'reginox-elite-ohio-l-integrated-1-bowl-kitchen-sink-80x42cm'),(44426,121,0,6291,'reginox-elite-ohio-l-integrated-1-bowl-kitchen-sink-80x42cm'),(44427,84,5,6291,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 80X42cm'),(44428,84,0,6291,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 80X42cm'),(44429,86,5,6291,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 80X42cm'),(44430,86,0,6291,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 80X42cm'),(44431,73,5,6291,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 80X42cm'),(44432,73,0,6291,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 80X42cm'),(44433,109,5,6291,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 80X42cm'),(44434,109,0,6291,'Reginox Elite Ohio L Integrated 1 Bowl Kitchen Sink 80X42cm'),(44435,121,5,6292,'franke-orion-oid-611-94-tectonite-kitchen-sink'),(44436,121,0,6292,'franke-orion-oid-611-94-tectonite-kitchen-sink'),(44437,84,5,6292,'Franke Orion OID 611-94 Tectonite Inset Kitchen Sink - OID 611-94 -'),(44438,84,0,6292,'Franke Orion OID 611-94 Tectonite Inset Kitchen Sink - OID 611-94 -'),(44439,86,5,6292,'Money Saving Deals on Franke Neptune NEX 211 Inset Kitchen Sink Stainless Steel only at Banyo.Get Free and fastest delivery services only at banyo.'),(44440,86,0,6292,'Money Saving Deals on Franke Neptune NEX 211 Inset Kitchen Sink Stainless Steel only at Banyo.Get Free and fastest delivery services only at banyo.'),(44441,73,5,6292,'Franke Orion OID 611-94 Tectonite Inset 1.0 Bowl Kitchen Sink'),(44442,73,0,6292,'Franke Orion OID 611-94 Tectonite Inset 1.0 Bowl Kitchen Sink'),(44443,109,5,6292,'Franke Orion OID 611-94 Tectonite Inset 1.0 Bowl Kitchen Sink'),(44444,109,0,6292,'Franke Orion OID 611-94 Tectonite Inset 1.0 Bowl Kitchen Sink'),(44445,121,5,6293,'franke-oid-651-tectonite-kitchen-sink'),(44446,121,0,6293,'franke-oid-651-tectonite-kitchen-sink'),(44447,84,5,6293,'Franke OID 651 Tectonite 1.5 Bowl Kitchen Sink - OID 651 -'),(44448,84,0,6293,'Franke OID 651 Tectonite 1.5 Bowl Kitchen Sink - OID 651 -'),(44449,86,5,6293,'Unbeatable Sales offers on Franke OID 651 Tectonite 1.5 Bowl Kitchen Sink only at Banyo. Tectonite construction makes it extremely strong and resistant to heat and strains. To avail our fastest delivery system, place an order online.'),(44450,86,0,6293,'Unbeatable Sales offers on Franke OID 651 Tectonite 1.5 Bowl Kitchen Sink only at Banyo. Tectonite construction makes it extremely strong and resistant to heat and strains. To avail our fastest delivery system, place an order online.'),(44451,73,5,6293,'Franke OID 651 Tectonite 1.5 Bowl Kitchen Sink'),(44452,73,0,6293,'Franke OID 651 Tectonite 1.5 Bowl Kitchen Sink'),(44453,109,5,6293,'Franke OID 651 Tectonite 1.5 Bowl Kitchen Sink'),(44454,109,0,6293,'Franke OID 651 Tectonite 1.5 Bowl Kitchen Sink'),(44455,121,5,6294,'reginox-quadra-100-undermount-1-bowl-granite-kitchen-sink'),(44456,121,0,6294,'reginox-quadra-100-undermount-1-bowl-granite-kitchen-sink'),(44457,84,5,6294,'Reginox Quadra 100 Undermount 1 Bowl Granite Kitchen Sink'),(44458,84,0,6294,'Reginox Quadra 100 Undermount 1 Bowl Granite Kitchen Sink'),(44459,86,5,6294,'Reginox Quadra 100 Undermount 1 Bowl Granite Kitchen Sink'),(44460,86,0,6294,'Reginox Quadra 100 Undermount 1 Bowl Granite Kitchen Sink'),(44461,73,5,6294,'Reginox Quadra 100 Undermount 1 Bowl Granite Kitchen Sink'),(44462,73,0,6294,'Reginox Quadra 100 Undermount 1 Bowl Granite Kitchen Sink'),(44463,109,5,6294,'Reginox Quadra 100 Undermount 1 Bowl Granite Kitchen Sink'),(44464,109,0,6294,'Reginox Quadra 100 Undermount 1 Bowl Granite Kitchen Sink'),(44465,121,5,6295,'reginox-quadra-105-undermount-1-bowl-granite-kitchen-sink'),(44466,121,0,6295,'reginox-quadra-105-undermount-1-bowl-granite-kitchen-sink'),(44467,84,5,6295,'Reginox Quadra 105 Undermount 1 Bowl Granite Kitchen Sink'),(44468,84,0,6295,'Reginox Quadra 105 Undermount 1 Bowl Granite Kitchen Sink'),(44469,86,5,6295,'Reginox Quadra 105 Undermount 1 Bowl Granite Kitchen Sink'),(44470,86,0,6295,'Reginox Quadra 105 Undermount 1 Bowl Granite Kitchen Sink'),(44471,73,5,6295,'Reginox Quadra 105 Undermount 1 Bowl Granite Kitchen Sink'),(44472,73,0,6295,'Reginox Quadra 105 Undermount 1 Bowl Granite Kitchen Sink'),(44473,109,5,6295,'Reginox Quadra 105 Undermount 1 Bowl Granite Kitchen Sink'),(44474,109,0,6295,'Reginox Quadra 105 Undermount 1 Bowl Granite Kitchen Sink'),(44475,121,5,6296,'reginox-quadra-130-undermount-1-bowl-granite-kitchen-sink'),(44476,121,0,6296,'reginox-quadra-130-undermount-1-bowl-granite-kitchen-sink'),(44477,84,5,6296,'Reginox Quadra 130 Undermount 1 Bowl Granite Kitchen Sink'),(44478,84,0,6296,'Reginox Quadra 130 Undermount 1 Bowl Granite Kitchen Sink'),(44479,86,5,6296,'Reginox Quadra 130 Undermount 1 Bowl Granite Kitchen Sink'),(44480,86,0,6296,'Reginox Quadra 130 Undermount 1 Bowl Granite Kitchen Sink'),(44481,73,5,6296,'Reginox Quadra 130 Undermount 1 Bowl Granite Kitchen Sink'),(44482,73,0,6296,'Reginox Quadra 130 Undermount 1 Bowl Granite Kitchen Sink'),(44483,109,5,6296,'Reginox Quadra 130 Undermount 1 Bowl Granite Kitchen Sink'),(44484,109,0,6296,'Reginox Quadra 130 Undermount 1 Bowl Granite Kitchen Sink'),(44485,121,5,6297,'reginox-quadra-50-undermount-0-5-bowl-granite-kitchen-sink'),(44486,121,0,6297,'reginox-quadra-50-undermount-0-5-bowl-granite-kitchen-sink'),(44487,84,5,6297,'Reginox Quadra 50 Undermount 0.5 Bowl Granite Kitchen Sink'),(44488,84,0,6297,'Reginox Quadra 50 Undermount 0.5 Bowl Granite Kitchen Sink'),(44489,86,5,6297,'Reginox Quadra 50 Undermount 0.5 Bowl Granite Kitchen Sink'),(44490,86,0,6297,'Reginox Quadra 50 Undermount 0.5 Bowl Granite Kitchen Sink'),(44491,73,5,6297,'Reginox Quadra 50 Undermount 0.5 Bowl Granite Kitchen Sink'),(44492,73,0,6297,'Reginox Quadra 50 Undermount 0.5 Bowl Granite Kitchen Sink'),(44493,109,5,6297,'Reginox Quadra 50 Undermount 0.5 Bowl Granite Kitchen Sink'),(44494,109,0,6297,'Reginox Quadra 50 Undermount 0.5 Bowl Granite Kitchen Sink'),(44495,121,5,6298,'reginox-r18-2330-osk-single-bowl-inset-kitchen-sink'),(44496,121,0,6298,'reginox-r18-2330-osk-single-bowl-inset-kitchen-sink'),(44497,84,5,6298,'Reginox R18 2330 OSK Single Bowl Inset Kitchen Sink'),(44498,84,0,6298,'Reginox R18 2330 OSK Single Bowl Inset Kitchen Sink'),(44499,86,5,6298,'Reginox R18 2330 OSK Single Bowl Inset Kitchen Sink'),(44500,86,0,6298,'Reginox R18 2330 OSK Single Bowl Inset Kitchen Sink'),(44501,73,5,6298,'Reginox R18 2330 OSK Single Bowl Inset Kitchen Sink'),(44502,73,0,6298,'Reginox R18 2330 OSK Single Bowl Inset Kitchen Sink'),(44503,109,5,6298,'Reginox R18 2330 OSK Stainless Steel Kitchen Sink'),(44504,109,0,6298,'Reginox R18 2330 OSK Stainless Steel Kitchen Sink'),(44505,110,5,6298,'Reginox R18 2330 OSK Stainless Steel Kitchen Sink'),(44506,110,0,6298,'Reginox R18 2330 OSK Stainless Steel Kitchen Sink'),(44507,111,5,6298,'Reginox R18 2330 OSK Stainless Steel Kitchen Sink'),(44508,111,0,6298,'Reginox R18 2330 OSK Stainless Steel Kitchen Sink'),(44509,121,5,6299,'franke-rbx-610-rotondo-kitchen-sink-stainless-steel'),(44510,121,0,6299,'franke-rbx-610-rotondo-kitchen-sink-stainless-steel'),(44511,84,5,6299,'Franke RBX 610 Rotondo Kitchen Sink Stainless Steel - RBX 610 -'),(44512,84,0,6299,'Franke RBX 610 Rotondo Kitchen Sink Stainless Steel - RBX 610 -'),(44513,86,5,6299,'Banyo is offering cheapest online price on Franke RBX 610 Rotondo Stainless Steel Kitchen Sink. For best deals and offers visit our website for the ideal product for your kitchen.'),(44514,86,0,6299,'Banyo is offering cheapest online price on Franke RBX 610 Rotondo Stainless Steel Kitchen Sink. For best deals and offers visit our website for the ideal product for your kitchen.'),(44515,73,5,6299,'Franke RBX 610 Rotondo 1.0 Bowl Kitchen Sink Stainless Steel '),(44516,73,0,6299,'Franke RBX 610 Rotondo 1.0 Bowl Kitchen Sink Stainless Steel '),(44517,109,5,6299,'Franke RBX 610 Rotondo 1.0 Bowl Kitchen Sink Stainless Steel'),(44518,109,0,6299,'Franke RBX 610 Rotondo 1.0 Bowl Kitchen Sink Stainless Steel'),(44519,110,5,6299,'Franke RBX 610 Rotondo 1.0 Bowl Kitchen Sink Stainless Steel'),(44520,110,0,6299,'Franke RBX 610 Rotondo 1.0 Bowl Kitchen Sink Stainless Steel'),(44521,111,5,6299,'Franke RBX 610 Rotondo 1.0 Bowl Kitchen Sink Stainless Steel'),(44522,111,0,6299,'Franke RBX 610 Rotondo 1.0 Bowl Kitchen Sink Stainless Steel'),(44523,121,5,6300,'reginox-comfort-regent10-lux-inset-1-bowl-kitchen-sink'),(44524,121,0,6300,'reginox-comfort-regent10-lux-inset-1-bowl-kitchen-sink'),(44525,84,5,6300,'Reginox Comfort Regent10-lux Inset 1 Bowl Kitchen Sink'),(44526,84,0,6300,'Reginox Comfort Regent10-lux Inset 1 Bowl Kitchen Sink'),(44527,86,5,6300,'Reginox Comfort Regent10-lux Inset 1 Bowl Kitchen Sink'),(44528,86,0,6300,'Reginox Comfort Regent10-lux Inset 1 Bowl Kitchen Sink'),(44529,73,5,6300,'Reginox Comfort Regent10-lux Inset 1 Bowl Kitchen Sink'),(44530,73,0,6300,'Reginox Comfort Regent10-lux Inset 1 Bowl Kitchen Sink'),(44531,109,5,6300,'Reginox Comfort Regent10-lux Inset 1 Bowl Kitchen Sink'),(44532,109,0,6300,'Reginox Comfort Regent10-lux Inset 1 Bowl Kitchen Sink'),(44533,121,5,6301,'reginox-comfort-regidrain-r-inset-1-bowl-kitchen-sink'),(44534,121,0,6301,'reginox-comfort-regidrain-r-inset-1-bowl-kitchen-sink'),(44535,84,5,6301,'Reginox Comfort Regidrain-R Inset 1 Bowl Kitchen Sink'),(44536,84,0,6301,'Reginox Comfort Regidrain-R Inset 1 Bowl Kitchen Sink'),(44537,86,5,6301,'Reginox Comfort Regidrain-R Inset 1 Bowl Kitchen Sink'),(44538,86,0,6301,'Reginox Comfort Regidrain-R Inset 1 Bowl Kitchen Sink'),(44539,73,5,6301,'Reginox Comfort Regidrain-R Inset 1 Bowl Kitchen Sink'),(44540,73,0,6301,'Reginox Comfort Regidrain-R Inset 1 Bowl Kitchen Sink'),(44541,109,5,6301,'Reginox Comfort Regidrain-R Inset 1 Bowl Kitchen Sink'),(44542,109,0,6301,'Reginox Comfort Regidrain-R Inset 1 Bowl Kitchen Sink'),(44543,121,5,6302,'reginox-rio-ops-l-integrated-1-bowl-kitchen-sink'),(44544,121,0,6302,'reginox-rio-ops-l-integrated-1-bowl-kitchen-sink'),(44545,84,5,6302,'Reginox Rio OPS L Integrated 1 Bowl Kitchen Sink'),(44546,84,0,6302,'Reginox Rio OPS L Integrated 1 Bowl Kitchen Sink'),(44547,86,5,6302,'Reginox Rio OPS L Integrated 1 Bowl Kitchen Sink'),(44548,86,0,6302,'Reginox Rio OPS L Integrated 1 Bowl Kitchen Sink'),(44549,73,5,6302,'Reginox Rio OPS L Integrated 1 Bowl Kitchen Sink'),(44550,73,0,6302,'Reginox Rio OPS L Integrated 1 Bowl Kitchen Sink'),(44551,109,5,6302,'Reginox Rio OPS L Integrated 1 Bowl Kitchen Sink'),(44552,109,0,6302,'Reginox Rio OPS L Integrated 1 Bowl Kitchen Sink'),(44553,121,5,6303,'reginox-rio-l-integrated-1-bowl-kitchen-sink'),(44554,121,0,6303,'reginox-rio-l-integrated-1-bowl-kitchen-sink'),(44555,84,5,6303,'Reginox Rio L Integrated 1 Bowl Kitchen Sink'),(44556,84,0,6303,'Reginox Rio L Integrated 1 Bowl Kitchen Sink'),(44557,86,5,6303,'Reginox Rio L Integrated 1 Bowl Kitchen Sink'),(44558,86,0,6303,'Reginox Rio L Integrated 1 Bowl Kitchen Sink'),(44559,73,5,6303,'Reginox Rio L Integrated 1 Bowl Kitchen Sink'),(44560,73,0,6303,'Reginox Rio L Integrated 1 Bowl Kitchen Sink'),(44561,109,5,6303,'Reginox Rio L Integrated 1 Bowl Kitchen Sink'),(44562,109,0,6303,'Reginox Rio L Integrated 1 Bowl Kitchen Sink'),(44563,121,5,6304,'reginox-1-5-bowl-ceramic-kitchen-inset-sink-rl301cw'),(44564,121,0,6304,'reginox-1-5-bowl-ceramic-kitchen-inset-sink-rl301cw'),(44565,84,5,6304,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL301CW'),(44566,84,0,6304,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL301CW'),(44567,86,5,6304,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL301CW'),(44568,86,0,6304,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL301CW'),(44569,73,5,6304,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL301CW'),(44570,73,0,6304,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL301CW'),(44571,109,5,6304,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL301CW'),(44572,109,0,6304,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL301CW'),(44573,121,5,6305,'reginox-1-bowl-ceramic-kitchen-inset-sink-rl304cw'),(44574,121,0,6305,'reginox-1-bowl-ceramic-kitchen-inset-sink-rl304cw'),(44575,84,5,6305,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL304CW'),(44576,84,0,6305,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL304CW'),(44577,86,5,6305,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL304CW'),(44578,86,0,6305,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL304CW'),(44579,73,5,6305,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL304CW'),(44580,73,0,6305,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL304CW'),(44581,109,5,6305,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL304CW'),(44582,109,0,6305,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL304CW'),(44583,121,5,6306,'reginox-1-5-bowl-ceramic-kitchen-inset-sink-rl401cb'),(44584,121,0,6306,'reginox-1-5-bowl-ceramic-kitchen-inset-sink-rl401cb'),(44585,84,5,6306,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL401CB'),(44586,84,0,6306,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL401CB'),(44587,86,5,6306,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL401CB'),(44588,86,0,6306,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL401CB'),(44589,73,5,6306,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL401CB'),(44590,73,0,6306,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL401CB'),(44591,109,5,6306,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL401CB'),(44592,109,0,6306,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL401CB'),(44593,121,5,6307,'reginox-1-5-bowl-ceramic-kitchen-inset-sink-rl501cw'),(44594,121,0,6307,'reginox-1-5-bowl-ceramic-kitchen-inset-sink-rl501cw'),(44595,84,5,6307,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL501CW'),(44596,84,0,6307,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL501CW'),(44597,86,5,6307,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL501CW'),(44598,86,0,6307,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL501CW'),(44599,73,5,6307,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL501CW'),(44600,73,0,6307,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL501CW'),(44601,109,5,6307,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL501CW'),(44602,109,0,6307,'Reginox 1.5 Bowl Ceramic Kitchen Inset Sink - RL501CW'),(44603,121,5,6308,'reginox-1-bowl-ceramic-kitchen-inset-sink-rl504cw'),(44604,121,0,6308,'reginox-1-bowl-ceramic-kitchen-inset-sink-rl504cw'),(44605,84,5,6308,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL504CW'),(44606,84,0,6308,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL504CW'),(44607,86,5,6308,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL504CW'),(44608,86,0,6308,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL504CW'),(44609,73,5,6308,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL504CW'),(44610,73,0,6308,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL504CW'),(44611,109,5,6308,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL504CW'),(44612,109,0,6308,'Reginox 1 Bowl Ceramic Kitchen Inset Sink - RL504CW'),(44613,121,5,6309,'blanco-rondo-puradur-ii-inset-silgranit-kitchen-sink'),(44614,121,0,6309,'blanco-rondo-puradur-ii-inset-silgranit-kitchen-sink'),(44615,84,5,6309,'Blanco Rondo Silgranit Puradur Inset Large Bowl Kitchen Sink | Banyo'),(44616,84,0,6309,'Blanco Rondo Silgranit Puradur Inset Large Bowl Kitchen Sink | Banyo'),(44617,86,5,6309,'Banyo offers Blanco Rondo Puradur II Inset Silgranit Kitchen Sink with manufacturer\'s guarantee and heap rates is availabe at banyo.avail our fastest delivery services across UK, just call now.'),(44618,86,0,6309,'Banyo offers Blanco Rondo Puradur II Inset Silgranit Kitchen Sink with manufacturer\'s guarantee and heap rates is availabe at banyo.avail our fastest delivery services across UK, just call now.'),(44619,73,5,6309,'Blanco Rondo Puradur II Inset Silgranit Kitchen Sink'),(44620,73,0,6309,'Blanco Rondo Puradur II Inset Silgranit Kitchen Sink'),(44621,109,5,6309,'Blanco Rondo Puradur II Inset Silgranit Kitchen Sink'),(44622,109,0,6309,'Blanco Rondo Puradur II Inset Silgranit Kitchen Sink'),(44623,121,5,6310,'franke-spark-skx-611-86-inset-1-bowl-kitchen-sink-stainless-steel'),(44624,121,0,6310,'franke-spark-skx-611-86-inset-1-bowl-kitchen-sink-stainless-steel'),(44625,84,5,6310,'Franke Spark SKX 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel'),(44626,84,0,6310,'Franke Spark SKX 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel'),(44627,86,5,6310,'Banyo offers best price on Franke Spark SKX 611 86 Inset 1.0 Bowl Stainless Steel Kitchen Sink. Spark SKX comes with a reversible drainer which gives you the freedom to position in either left or right direction.'),(44628,86,0,6310,'Banyo offers best price on Franke Spark SKX 611 86 Inset 1.0 Bowl Stainless Steel Kitchen Sink. Spark SKX comes with a reversible drainer which gives you the freedom to position in either left or right direction.'),(44629,73,5,6310,'Franke Spark SKX 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel'),(44630,73,0,6310,'Franke Spark SKX 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel'),(44631,109,5,6310,'Franke Spark SKX 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel'),(44632,109,0,6310,'Franke Spark SKX 611-86 Inset 1 Bowl Kitchen Sink Stainless Steel'),(44633,121,5,6311,'franke-spark-skx-651-inset-1-5-bowl-kitchen-sink-stainless-steel'),(44634,121,0,6311,'franke-spark-skx-651-inset-1-5-bowl-kitchen-sink-stainless-steel'),(44635,84,5,6311,'Franke Spark SKX 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44636,84,0,6311,'Franke Spark SKX 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44637,86,5,6311,'Banyo offers special discounts and offers on Franke Spark SKX 651 Inset 1.5 Bowl Stainless Steel Kitchen Sink. For Best and Cheap Deals visit banyo.co.uk. Get a chance of fast and free delivery by placing order online now!'),(44638,86,0,6311,'Banyo offers special discounts and offers on Franke Spark SKX 651 Inset 1.5 Bowl Stainless Steel Kitchen Sink. For Best and Cheap Deals visit banyo.co.uk. Get a chance of fast and free delivery by placing order online now!'),(44639,73,5,6311,'Franke Spark SKX 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44640,73,0,6311,'Franke Spark SKX 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44641,109,5,6311,'Franke Spark SKX 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44642,109,0,6311,'Franke Spark SKX 651 Inset 1.5 Bowl Kitchen Sink Stainless Steel'),(44643,121,5,6312,'blanco-solis-340-180-u-stainless-steel-undermount-kitchen-sink'),(44644,121,0,6312,'blanco-solis-340-180-u-stainless-steel-undermount-kitchen-sink'),(44645,73,5,6312,'Blanco Solis 340/180-U Stainless Steel Undermount Kitchen Sink'),(44646,73,0,6312,'Blanco Solis 340/180-U Stainless Steel Undermount Kitchen Sink'),(44647,109,5,6312,'blanco-solis-340-180-U-526128-rght-hnd'),(44648,109,0,6312,'blanco-solis-340-180-U-526128-rght-hnd'),(44649,110,5,6312,'blanco-solis-340-180-U-526128-rght-hnd'),(44650,110,0,6312,'blanco-solis-340-180-U-526128-rght-hnd'),(44651,111,5,6312,'blanco-solis-340-180-U-526128-rght-hnd'),(44652,111,0,6312,'blanco-solis-340-180-U-526128-rght-hnd'),(44653,121,5,6313,'blanco-sona-5-s-puradur-ii-inset-silgranit-kitchen-sink'),(44654,121,0,6313,'blanco-sona-5-s-puradur-ii-inset-silgranit-kitchen-sink'),(44655,84,5,6313,'Blanco Sona 5 S Silgranit Puradur II Inset Kitchen Sink | Banyo.co.uk'),(44656,84,0,6313,'Blanco Sona 5 S Silgranit Puradur II Inset Kitchen Sink | Banyo.co.uk'),(44657,86,5,6313,'Sona 5 S by Blanco is a Silgranit PuraDur Kitchen Sink with modern, independent design with spacious main bowl. For unbeatable prices in UK with wide range of inset/ Undermount sinks visit Nexus.'),(44658,86,0,6313,'Sona 5 S by Blanco is a Silgranit PuraDur Kitchen Sink with modern, independent design with spacious main bowl. For unbeatable prices in UK with wide range of inset/ Undermount sinks visit Nexus.'),(44659,73,5,6313,'Blanco Sona 5 S Puradur II Inset Silgranit Kitchen Sink'),(44660,73,0,6313,'Blanco Sona 5 S Puradur II Inset Silgranit Kitchen Sink'),(44661,109,5,6313,'Blanco Sona 5 S Puradur II Inset Silgranit Kitchen Sink'),(44662,109,0,6313,'Blanco Sona 5 S Puradur II Inset Silgranit Kitchen Sink'),(44663,121,5,6314,'blanco-sona-6-s-puradur-ii-inset-silgranit-kitchen-sink'),(44664,121,0,6314,'blanco-sona-6-s-puradur-ii-inset-silgranit-kitchen-sink'),(44665,84,5,6314,'Blanco Sona 6 S - Silgranit Puradur Inset  Kitchen Sink | Banyo.co.uk'),(44666,84,0,6314,'Blanco Sona 6 S - Silgranit Puradur Inset  Kitchen Sink | Banyo.co.uk'),(44667,86,5,6314,'Sona 6 S by Blanco is a Silgranit Puradur 1.5 Bowl Kitchen Sink with modern and independent design. Nexus offers huge variety of top quality inset/ Undermount sinks at affordable prices.'),(44668,86,0,6314,'Sona 6 S by Blanco is a Silgranit Puradur 1.5 Bowl Kitchen Sink with modern and independent design. Nexus offers huge variety of top quality inset/ Undermount sinks at affordable prices.'),(44669,73,5,6314,'Blanco Sona 6 S Puradur II Inset Silgranit Kitchen Sink'),(44670,73,0,6314,'Blanco Sona 6 S Puradur II Inset Silgranit Kitchen Sink'),(44671,109,5,6314,'Blanco Sona 6 S Puradur II Inset Silgranit Kitchen Sink'),(44672,109,0,6314,'Blanco Sona 6 S Puradur II Inset Silgranit Kitchen Sink'),(44673,121,5,6315,'blanco-sona-xl-6-s-puradur-ii-inset-silgranit-kitchen-sink'),(44674,121,0,6315,'blanco-sona-xl-6-s-puradur-ii-inset-silgranit-kitchen-sink'),(44675,84,5,6315,'Blanco Sona XL 6 S Silgranit Puradur Inset Kitchen Sink | Banyo.co.uk'),(44676,84,0,6315,'Blanco Sona XL 6 S Silgranit Puradur Inset Kitchen Sink | Banyo.co.uk'),(44677,86,5,6315,'Sona XL 6 S by Blanco is a Silgranit PuraDur Spacious XL Bowl Kitchen sink for 60cm base cabinet. Nexus offers wide range of high quality inset / Undermount sinks at affordable prices.'),(44678,86,0,6315,'Sona XL 6 S by Blanco is a Silgranit PuraDur Spacious XL Bowl Kitchen sink for 60cm base cabinet. Nexus offers wide range of high quality inset / Undermount sinks at affordable prices.'),(44679,73,5,6315,'Blanco Sona XL 6 S Puradur II Inset Silgranit Kitchen Sink'),(44680,73,0,6315,'Blanco Sona XL 6 S Puradur II Inset Silgranit Kitchen Sink'),(44681,109,5,6315,'Blanco Sona XL 6 S Puradur II Inset Silgranit Kitchen Sink'),(44682,109,0,6315,'Blanco Sona XL 6 S Puradur II Inset Silgranit Kitchen Sink'),(44683,121,5,6316,'blanco-subline-160-u-silgranit-puradur-iir-undermount-sink'),(44684,121,0,6316,'blanco-subline-160-u-silgranit-puradur-iir-undermount-sink'),(44685,84,5,6316,'Blanco SUBLINE 160-U Silgranit PuraDur Undermount Sink | Banyo'),(44686,84,0,6316,'Blanco SUBLINE 160-U Silgranit PuraDur Undermount Sink | Banyo'),(44687,86,5,6316,'Blanco SUBLINE 160-U Silgranit PuraDur II® Undermount Sink'),(44688,86,0,6316,'Blanco SUBLINE 160-U Silgranit PuraDur II® Undermount Sink'),(44689,73,5,6316,'Blanco SUBLINE 160-U Silgranit PuraDur IIÂ® Undermount Sink'),(44690,73,0,6316,'Blanco SUBLINE 160-U Silgranit PuraDur IIÂ® Undermount Sink'),(44691,109,5,6316,'Blanco SUBLINE 160-U Silgranit PuraDur II® Undermount Sink'),(44692,109,0,6316,'Blanco SUBLINE 160-U Silgranit PuraDur II® Undermount Sink'),(44693,121,5,6317,'blanco-subline-320-u-silgranit-puradur-iir-undermount-sink'),(44694,121,0,6317,'blanco-subline-320-u-silgranit-puradur-iir-undermount-sink'),(44695,84,5,6317,'Blanco Subline 320-U Silgranit PuraDur Undermount Kitchen Sink | Banyo'),(44696,84,0,6317,'Blanco Subline 320-U Silgranit PuraDur Undermount Kitchen Sink | Banyo'),(44697,86,5,6317,'Blanco Subline 320-U Silgranit PuraDur II® Undermount Sink'),(44698,86,0,6317,'Blanco Subline 320-U Silgranit PuraDur II® Undermount Sink'),(44699,73,5,6317,'Blanco Subline 320-U Silgranit PuraDur IIÂ® Undermount Sink'),(44700,73,0,6317,'Blanco Subline 320-U Silgranit PuraDur IIÂ® Undermount Sink'),(44701,109,5,6317,'Blanco Subline 320-U Silgranit PuraDur II® Undermount Sink'),(44702,109,0,6317,'Blanco Subline 320-U Silgranit PuraDur II® Undermount Sink'),(44703,121,5,6318,'blanco-subline-340-160-u-undermount-silgranit-kitchen-sink'),(44704,121,0,6318,'blanco-subline-340-160-u-undermount-silgranit-kitchen-sink'),(44705,84,5,6318,'Blanco Subline 340/160-U Undermount Silgranit Kitchen Sink | Blanco Subline 340 160'),(44706,84,0,6318,'Blanco Subline 340/160-U Undermount Silgranit Kitchen Sink | Blanco Subline 340 160'),(44707,86,5,6318,'Buy Blanco Subline 340/160-U Undermount Silgranit Kitchen Sink with Price match Promise from Banyo. Blanco Subline 340 160 U compatible with Cabinet width of 600mm.'),(44708,86,0,6318,'Buy Blanco Subline 340/160-U Undermount Silgranit Kitchen Sink with Price match Promise from Banyo. Blanco Subline 340 160 U compatible with Cabinet width of 600mm.'),(44709,73,5,6318,'Blanco Subline 340/160-U Undermount Silgranit Kitchen Sink'),(44710,73,0,6318,'Blanco Subline 340/160-U Undermount Silgranit Kitchen Sink'),(44711,109,5,6318,'Blanco Subline 340/160-U Undermount Silgranit Kitchen Sink'),(44712,109,0,6318,'Blanco Subline 340/160-U Undermount Silgranit Kitchen Sink'),(44713,121,5,6319,'blanco-subline-350-350-u-undermount-silgranit-kitchen-sink'),(44714,121,0,6319,'blanco-subline-350-350-u-undermount-silgranit-kitchen-sink'),(44715,84,5,6319,'Blanco Subline 350/350-U Undermount Silgranit 2.0 Bowl Sink | Banyo UK'),(44716,84,0,6319,'Blanco Subline 350/350-U Undermount Silgranit 2.0 Bowl Sink | Banyo UK'),(44717,86,5,6319,'We provide a great range of exclusive and contemporary Blanco Subline 350/350-U Undermount Silgranit Kitchen Sink here at banyo.Our Sinks create a sophisticated and modern look in kitchen suites.'),(44718,86,0,6319,'We provide a great range of exclusive and contemporary Blanco Subline 350/350-U Undermount Silgranit Kitchen Sink here at banyo.Our Sinks create a sophisticated and modern look in kitchen suites.'),(44719,73,5,6319,'Blanco Subline 350/350-U Undermount Silgranit Kitchen Sink'),(44720,73,0,6319,'Blanco Subline 350/350-U Undermount Silgranit Kitchen Sink'),(44721,109,5,6319,'Blanco Subline 350/350-U Undermount Silgranit Kitchen Sink'),(44722,109,0,6319,'Blanco Subline 350/350-U Undermount Silgranit Kitchen Sink'),(44723,121,5,6320,'blanco-subline-400-u-puradur-reg-silgranit-undermount-sink'),(44724,121,0,6320,'blanco-subline-400-u-puradur-reg-silgranit-undermount-sink'),(44725,84,5,6320,'Blanco Subline 400-U PuraDur&reg; Silgranit Undermount Sink'),(44726,84,0,6320,'Blanco Subline 400-U PuraDur&reg; Silgranit Undermount Sink'),(44727,86,5,6320,'Blanco Subline 400-U PuraDur&reg; Silgranit Undermount Sink'),(44728,86,0,6320,'Blanco Subline 400-U PuraDur&reg; Silgranit Undermount Sink'),(44729,73,5,6320,'Blanco Subline 400-U PuraDur&reg; Silgranit Undermount Sink'),(44730,73,0,6320,'Blanco Subline 400-U PuraDur&reg; Silgranit Undermount Sink'),(44731,109,5,6320,'Blanco Subline 400-U PuraDur&reg; Silgranit Undermount Sink'),(44732,109,0,6320,'Blanco Subline 400-U PuraDur&reg; Silgranit Undermount Sink'),(44733,121,5,6321,'blanco-subline-430-270-u-silgranit-puradurr-undermount-sink'),(44734,121,0,6321,'blanco-subline-430-270-u-silgranit-puradurr-undermount-sink'),(44735,84,5,6321,'Blanco Subline 430/270-U Silgranit PuraDur Undermount Sink | Banyo'),(44736,84,0,6321,'Blanco Subline 430/270-U Silgranit PuraDur Undermount Sink | Banyo'),(44737,86,5,6321,'Blanco Subline 430/270-U Silgranit PuraDur® Undermount Sink'),(44738,86,0,6321,'Blanco Subline 430/270-U Silgranit PuraDur® Undermount Sink'),(44739,73,5,6321,'Blanco Subline 430/270-U Silgranit PuraDurÂ® Undermount Sink'),(44740,73,0,6321,'Blanco Subline 430/270-U Silgranit PuraDurÂ® Undermount Sink'),(44741,109,5,6321,'Blanco Subline 430/270-U Silgranit PuraDur® Undermount Sink'),(44742,109,0,6321,'Blanco Subline 430/270-U Silgranit PuraDur® Undermount Sink'),(44743,121,5,6322,'blanco-subline-480-320-u-undermount-silgranit-kitchen-sink'),(44744,121,0,6322,'blanco-subline-480-320-u-undermount-silgranit-kitchen-sink'),(44745,84,5,6322,'Blanco Subline 480/320-U Silgranit - Undermount Kitchen Sink | Banyo UK'),(44746,84,0,6322,'Blanco Subline 480/320-U Silgranit - Undermount Kitchen Sink | Banyo UK'),(44747,86,5,6322,'Contemporary and stylish Blanco Subline 480/320-U Undermount Silgranit Kitchen Sink on great deals and mannfacturers guarantee available at banyo.'),(44748,86,0,6322,'Contemporary and stylish Blanco Subline 480/320-U Undermount Silgranit Kitchen Sink on great deals and mannfacturers guarantee available at banyo.'),(44749,73,5,6322,'Blanco Subline 480/320-U Undermount Silgranit Kitchen Sink'),(44750,73,0,6322,'Blanco Subline 480/320-U Undermount Silgranit Kitchen Sink'),(44751,109,5,6322,'Blanco Subline 480/320-U Undermount Silgranit Kitchen Sink'),(44752,109,0,6322,'Blanco Subline 480/320-U Undermount Silgranit Kitchen Sink'),(44753,121,5,6323,'blanco-subline-500-if-steel-frame-puradur-ii-kitchen-sink'),(44754,121,0,6323,'blanco-subline-500-if-steel-frame-puradur-ii-kitchen-sink'),(44755,84,5,6323,'Blanco Subline 500-IF Steel Frame Silgranit Kitchen Sink | Banyo'),(44756,84,0,6323,'Blanco Subline 500-IF Steel Frame Silgranit Kitchen Sink | Banyo'),(44757,86,5,6323,'Blanco Subline 500-IF Steel Frame PuraDur II Undermount Silgranit Kitchen Sink'),(44758,86,0,6323,'Blanco Subline 500-IF Steel Frame PuraDur II Undermount Silgranit Kitchen Sink'),(44759,73,5,6323,'Blanco Subline 500-IF Steel Frame PuraDur II Kitchen Sink'),(44760,73,0,6323,'Blanco Subline 500-IF Steel Frame PuraDur II Kitchen Sink'),(44761,109,5,6323,'Blanco Subline 500-IF Steel Frame PuraDur II Kitchen Sink'),(44762,109,0,6323,'Blanco Subline 500-IF Steel Frame PuraDur II Kitchen Sink'),(44763,121,5,6324,'blanco-subline-500-u-silgranit-puradur-iir-undermount-sink'),(44764,121,0,6324,'blanco-subline-500-u-silgranit-puradur-iir-undermount-sink'),(44765,84,5,6324,'Blanco SUBLINE 500-U Silgranit PuraDur Undermount 1.0 Bowl Sink | Banyo'),(44766,84,0,6324,'Blanco SUBLINE 500-U Silgranit PuraDur Undermount 1.0 Bowl Sink | Banyo'),(44767,86,5,6324,'Blanco SUBLINE 500-U Silgranit PuraDur II® Undermount Sink with Cabinet Width of 600mm, Bowl Depth of 190mm is available at Banyo with Price Match Promise. We offer a wide range of Blanco Undermount Kitchen Sinks - Timelessly elegant, contoured bowl desig'),(44768,86,0,6324,'Blanco SUBLINE 500-U Silgranit PuraDur II® Undermount Sink with Cabinet Width of 600mm, Bowl Depth of 190mm is available at Banyo with Price Match Promise. We offer a wide range of Blanco Undermount Kitchen Sinks - Timelessly elegant, contoured bowl desig'),(44769,73,5,6324,'Blanco SUBLINE 500-U Silgranit PuraDur IIÂ® Undermount Sink'),(44770,73,0,6324,'Blanco SUBLINE 500-U Silgranit PuraDur IIÂ® Undermount Sink'),(44771,109,5,6324,'Blanco SUBLINE 500-U Silgranit PuraDur II® Undermount Sink'),(44772,109,0,6324,'Blanco SUBLINE 500-U Silgranit PuraDur II® Undermount Sink'),(44773,121,5,6325,'blanco-subline-700-u-level-silgranit-undermount-sink'),(44774,121,0,6325,'blanco-subline-700-u-level-silgranit-undermount-sink'),(44775,84,5,6325,'Blanco Subline 700-U Level Silgranit Undermount Kitchen Sink | Banyo UK'),(44776,84,0,6325,'Blanco Subline 700-U Level Silgranit Undermount Kitchen Sink | Banyo UK'),(44777,86,5,6325,'Blanco Subline 700-U Level Silgranit Undermount Sink have fantastic features and ideal for all.Banyo is one of the most trusted and reliable suppliers of all kitchen appliances across UK'),(44778,86,0,6325,'Blanco Subline 700-U Level Silgranit Undermount Sink have fantastic features and ideal for all.Banyo is one of the most trusted and reliable suppliers of all kitchen appliances across UK'),(44779,73,5,6325,'Blanco Subline 700-U Level Silgranit Undermount Sink'),(44780,73,0,6325,'Blanco Subline 700-U Level Silgranit Undermount Sink'),(44781,109,5,6325,'Blanco Subline 700-U Level Silgranit Undermount Sink'),(44782,109,0,6325,'Blanco Subline 700-U Level Silgranit Undermount Sink'),(44783,121,5,6326,'blanco-subline-700-u-puradur-ii-undermount-silgranit-kitchen-sink'),(44784,121,0,6326,'blanco-subline-700-u-puradur-ii-undermount-silgranit-kitchen-sink'),(44785,84,5,6326,'Blanco Subline 700-U Silgranit PuraDur Undermount Kitchen Sink | Banyo'),(44786,84,0,6326,'Blanco Subline 700-U Silgranit PuraDur Undermount Kitchen Sink | Banyo'),(44787,86,5,6326,'Blanco Subline 700-U PuraDur II Undermount Silgranit Kitchen Sink'),(44788,86,0,6326,'Blanco Subline 700-U PuraDur II Undermount Silgranit Kitchen Sink'),(44789,73,5,6326,'Blanco Subline 700-U PuraDur II Undermount Kitchen Sink'),(44790,73,0,6326,'Blanco Subline 700-U PuraDur II Undermount Kitchen Sink'),(44791,109,5,6326,'Blanco Subline 700-U PuraDur II Undermount Kitchen Sink'),(44792,109,0,6326,'Blanco Subline 700-U PuraDur II Undermount Kitchen Sink'),(44793,121,5,6327,'blanco-subline-800-u-puradur-reg-silgranit-undermount-sink'),(44794,121,0,6327,'blanco-subline-800-u-puradur-reg-silgranit-undermount-sink'),(44795,84,5,6327,'Blanco Subline 800-U PuraDur&reg; Silgranit Undermount Sink'),(44796,84,0,6327,'Blanco Subline 800-U PuraDur&reg; Silgranit Undermount Sink'),(44797,86,5,6327,'Blanco Subline 800-U PuraDur&reg; Silgranit Undermount Sink'),(44798,86,0,6327,'Blanco Subline 800-U PuraDur&reg; Silgranit Undermount Sink'),(44799,73,5,6327,'Blanco Subline 800-U PuraDur&reg; Silgranit Undermount Sink'),(44800,73,0,6327,'Blanco Subline 800-U PuraDur&reg; Silgranit Undermount Sink'),(44801,109,5,6327,'Blanco Subline 800-U PuraDur&reg; Silgranit Undermount Sink'),(44802,109,0,6327,'Blanco Subline 800-U PuraDur&reg; Silgranit Undermount Sink'),(44803,121,5,6328,'reginox-elite-texas-l-integrated-0-5-bowl-kitchen-sink-18x40cm'),(44804,121,0,6328,'reginox-elite-texas-l-integrated-0-5-bowl-kitchen-sink-18x40cm'),(44805,84,5,6328,'Reginox Elite Texas L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(44806,84,0,6328,'Reginox Elite Texas L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(44807,86,5,6328,'Reginox Elite Texas L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(44808,86,0,6328,'Reginox Elite Texas L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(44809,73,5,6328,'Reginox Elite Texas L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(44810,73,0,6328,'Reginox Elite Texas L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(44811,109,5,6328,'Reginox Elite Texas L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(44812,109,0,6328,'Reginox Elite Texas L Integrated 0.5 Bowl Kitchen Sink 18X40cm'),(44813,121,5,6329,'reginox-elite-texas-l-integrated-1-bowl-kitchen-sink-30x40cm'),(44814,121,0,6329,'reginox-elite-texas-l-integrated-1-bowl-kitchen-sink-30x40cm'),(44815,84,5,6329,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 30X40cm'),(44816,84,0,6329,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 30X40cm'),(44817,86,5,6329,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 30X40cm'),(44818,86,0,6329,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 30X40cm'),(44819,73,5,6329,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 30X40cm'),(44820,73,0,6329,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 30X40cm'),(44821,109,5,6329,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 30X40cm'),(44822,109,0,6329,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 30X40cm'),(44823,121,5,6330,'reginox-elite-texas-l-integrated-1-bowl-kitchen-sink-40x40cm'),(44824,121,0,6330,'reginox-elite-texas-l-integrated-1-bowl-kitchen-sink-40x40cm'),(44825,84,5,6330,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(44826,84,0,6330,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(44827,86,5,6330,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(44828,86,0,6330,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(44829,73,5,6330,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(44830,73,0,6330,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(44831,109,5,6330,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(44832,109,0,6330,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 40X40cm'),(44833,121,5,6331,'reginox-elite-texas-l-integrated-1-bowl-kitchen-sink-50x40cm'),(44834,121,0,6331,'reginox-elite-texas-l-integrated-1-bowl-kitchen-sink-50x40cm'),(44835,84,5,6331,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(44836,84,0,6331,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(44837,86,5,6331,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(44838,86,0,6331,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(44839,73,5,6331,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(44840,73,0,6331,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(44841,109,5,6331,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(44842,109,0,6331,'Reginox Elite Texas L Integrated 1 Bowl Kitchen Sink 50X40cm'),(44843,121,5,6332,'franke-vbk-110-21-undermount-0-5-bowl-kitchen-sink-ceramic-white'),(44844,121,0,6332,'franke-vbk-110-21-undermount-0-5-bowl-kitchen-sink-ceramic-white'),(44845,84,5,6332,'Franke VBK 110-21 Undermount 0.5 Bowl Kitchen Sink Ceramic White'),(44846,84,0,6332,'Franke VBK 110-21 Undermount 0.5 Bowl Kitchen Sink Ceramic White'),(44847,86,5,6332,'Buy Franke VBK 110-21 Undermount half Bowl Ceramic Sink with White Colour finish from Banyo with the lowest Price offered in the UK. Suitable for 400mm Kitchen Cabinet.'),(44848,86,0,6332,'Buy Franke VBK 110-21 Undermount half Bowl Ceramic Sink with White Colour finish from Banyo with the lowest Price offered in the UK. Suitable for 400mm Kitchen Cabinet.'),(44849,73,5,6332,'Franke VBK 110-21 Undermount 0.5 Bowl Kitchen Sink Ceramic White'),(44850,73,0,6332,'Franke VBK 110-21 Undermount 0.5 Bowl Kitchen Sink Ceramic White'),(44851,109,5,6332,'Franke VBK 110-21 Undermount 0.5 Bowl Kitchen Sink Ceramic White'),(44852,109,0,6332,'Franke VBK 110-21 Undermount 0.5 Bowl Kitchen Sink Ceramic White'),(44853,121,5,6333,'franke-vbk-110-33-undermount-1-bowl-kitchen-sink-ceramic-white'),(44854,121,0,6333,'franke-vbk-110-33-undermount-1-bowl-kitchen-sink-ceramic-white'),(44855,84,5,6333,'Franke VBK 110-33 Undermount 1 Bowl Kitchen Sink Ceramic White'),(44856,84,0,6333,'Franke VBK 110-33 Undermount 1 Bowl Kitchen Sink Ceramic White'),(44857,86,5,6333,'Purchase Franke VBK 110-33 Ceramic White Kitchen Sink from Banyo with the lowest price offered in the UK. Undermount Installation, Single Bowl, Suitable for 500mm Kitchen Cabinet.'),(44858,86,0,6333,'Purchase Franke VBK 110-33 Ceramic White Kitchen Sink from Banyo with the lowest price offered in the UK. Undermount Installation, Single Bowl, Suitable for 500mm Kitchen Cabinet.'),(44859,73,5,6333,'Franke VBK 110-33 Undermount 1 Bowl Kitchen Sink Ceramic White'),(44860,73,0,6333,'Franke VBK 110-33 Undermount 1 Bowl Kitchen Sink Ceramic White'),(44861,109,5,6333,'Franke VBK 110-33 Undermount 1 Bowl Kitchen Sink Ceramic White'),(44862,109,0,6333,'Franke VBK 110-33 Undermount 1 Bowl Kitchen Sink Ceramic White'),(44863,121,5,6334,'franke-vbk-110-50-kitchen-sink-ceramic'),(44864,121,0,6334,'franke-vbk-110-50-kitchen-sink-ceramic'),(44865,84,5,6334,'Franke VBK 110-50 Kitchen Sink Ceramic 1.0 Bowl - VBK 110-50 -'),(44866,84,0,6334,'Franke VBK 110-50 Kitchen Sink Ceramic 1.0 Bowl - VBK 110-50 -'),(44867,86,5,6334,'Stylish and contemporary Franke VBK 110-50 Kitchen Sink Ceramic 1.0 Bowl at unbeatable prices available on our website banyo and our showroom in Leicester.'),(44868,86,0,6334,'Stylish and contemporary Franke VBK 110-50 Kitchen Sink Ceramic 1.0 Bowl at unbeatable prices available on our website banyo and our showroom in Leicester.'),(44869,73,5,6334,'Franke VBK 110-50 Kitchen Sink Ceramic 1.0 Bowl'),(44870,73,0,6334,'Franke VBK 110-50 Kitchen Sink Ceramic 1.0 Bowl'),(44871,109,5,6334,'Franke VBK 110-50 Kitchen Sink Ceramic 1.0 Bowl'),(44872,109,0,6334,'Franke VBK 110-50 Kitchen Sink Ceramic 1.0 Bowl'),(44873,121,5,6335,'franke-vbk-160-undermount-1-5-bowl-kitchen-sink-ceramic-white'),(44874,121,0,6335,'franke-vbk-160-undermount-1-5-bowl-kitchen-sink-ceramic-white'),(44875,84,5,6335,'Franke VBK 160 Undermount 1.5 Bowl Kitchen Sink Ceramic White'),(44876,84,0,6335,'Franke VBK 160 Undermount 1.5 Bowl Kitchen Sink Ceramic White'),(44877,86,5,6335,'Buy Franke VBK 160 White Ceramic Sink from Banyo with the lowest price offered in the UK. We offer an extensive range of Franke Undermount 1.5 Bowl Kitchen Sinks.'),(44878,86,0,6335,'Buy Franke VBK 160 White Ceramic Sink from Banyo with the lowest price offered in the UK. We offer an extensive range of Franke Undermount 1.5 Bowl Kitchen Sinks.'),(44879,73,5,6335,'Franke VBK 160 Undermount 1.5 Bowl Kitchen Sink Ceramic White'),(44880,73,0,6335,'Franke VBK 160 Undermount 1.5 Bowl Kitchen Sink Ceramic White'),(44881,109,5,6335,'Franke VBK 160 Undermount 1.5 Bowl Kitchen Sink Ceramic White'),(44882,109,0,6335,'Franke VBK 160 Undermount 1.5 Bowl Kitchen Sink Ceramic White'),(44883,121,5,6336,'franke-belfast-vbk-710-kitchen-sink-ceramic-white'),(44884,121,0,6336,'franke-belfast-vbk-710-kitchen-sink-ceramic-white'),(44885,84,5,6336,'Franke Belfast VBK 710 Kitchen Sink Ceramic White - VBK 710'),(44886,84,0,6336,'Franke Belfast VBK 710 Kitchen Sink Ceramic White - VBK 710'),(44887,86,5,6336,'Only £318, Cheapest Deals on Franke Belfast VBK 710 White Ceramic Kitchen Sinks at Banyo. We offer the lowest possible competitive prices here at Banyo. Call us today for quick delivery 0116 274 4059'),(44888,86,0,6336,'Only £318, Cheapest Deals on Franke Belfast VBK 710 White Ceramic Kitchen Sinks at Banyo. We offer the lowest possible competitive prices here at Banyo. Call us today for quick delivery 0116 274 4059'),(44889,73,5,6336,'Franke VBK 710 Belfast 1.0 Bowl Kitchen Sink Ceramic White '),(44890,73,0,6336,'Franke VBK 710 Belfast 1.0 Bowl Kitchen Sink Ceramic White '),(44891,109,5,6336,'Franke VBK 710 Belfast 1.0 Bowl Kitchen Sink Ceramic White '),(44892,109,0,6336,'Franke VBK 710 Belfast 1.0 Bowl Kitchen Sink Ceramic White '),(44893,121,5,6337,'franke-belfast-vbk-720-kitchen-sink-ceramic-white'),(44894,121,0,6337,'franke-belfast-vbk-720-kitchen-sink-ceramic-white'),(44895,84,5,6337,'Franke Belfast VBK 720 Kitchen Sink Ceramic White - 130.0049.876 - VBK 720'),(44896,84,0,6337,'Franke Belfast VBK 720 Kitchen Sink Ceramic White - 130.0049.876 - VBK 720'),(44897,86,5,6337,'Big discount offer on Franke Belfast VBK 720 Kitchen Sink Ceramic White at Banyo. We have fastest delivery services and fantastic deals here at banyo.'),(44898,86,0,6337,'Big discount offer on Franke Belfast VBK 720 Kitchen Sink Ceramic White at Banyo. We have fastest delivery services and fantastic deals here at banyo.'),(44899,73,5,6337,'Franke VBK 720 Belfast 2.0 Bowl Kitchen Sink Ceramic White - 130.0049.876'),(44900,73,0,6337,'Franke VBK 720 Belfast 2.0 Bowl Kitchen Sink Ceramic White - 130.0049.876'),(44901,109,5,6337,'Franke VBK 720 Belfast 2.0 Bowl Kitchen Sink Ceramic White - 130.0049.876'),(44902,109,0,6337,'Franke VBK 720 Belfast 2.0 Bowl Kitchen Sink Ceramic White - 130.0049.876'),(44903,121,5,6338,'blanco-vintera-xl-9-puradur-ii-silgranit-undermount-kitchen-sink'),(44904,121,0,6338,'blanco-vintera-xl-9-puradur-ii-silgranit-undermount-kitchen-sink'),(44905,73,5,6338,'Blanco Vintera XL 9 PuraDur II Silgranit Undermount Kitchen Sink'),(44906,73,0,6338,'Blanco Vintera XL 9 PuraDur II Silgranit Undermount Kitchen Sink'),(44907,109,5,6338,'blanco-vintera-526105-wht'),(44908,109,0,6338,'blanco-vintera-526105-wht'),(44909,110,5,6338,'blanco-vintera-526105-wht'),(44910,110,0,6338,'blanco-vintera-526105-wht'),(44911,111,5,6338,'blanco-vintera-526105-wht'),(44912,111,0,6338,'blanco-vintera-526105-wht'),(44913,121,5,6339,'blanco-zerox-340-180-u-undermount-kitchen-sink'),(44914,121,0,6339,'blanco-zerox-340-180-u-undermount-kitchen-sink'),(44915,84,5,6339,'Blanco Zerox 340/180-U Undermount Stainless Steel Kitchen Sink | Banyo'),(44916,84,0,6339,'Blanco Zerox 340/180-U Undermount Stainless Steel Kitchen Sink | Banyo'),(44917,86,5,6339,'Blanco Zerox 340/180-U Undermount Sink is stunning and creates a wonderful impact in any kitchen suite.Buy a Blanco brand sink from Banyo, guaranteed it will never let you down.'),(44918,86,0,6339,'Blanco Zerox 340/180-U Undermount Sink is stunning and creates a wonderful impact in any kitchen suite.Buy a Blanco brand sink from Banyo, guaranteed it will never let you down.'),(44919,73,5,6339,'Blanco Zerox 340/180-U Undermount Sink'),(44920,73,0,6339,'Blanco Zerox 340/180-U Undermount Sink'),(44921,109,5,6339,'Blanco Zerox 340/180-U Undermount Sink'),(44922,109,0,6339,'Blanco Zerox 340/180-U Undermount Sink'),(44923,121,5,6340,'blanco-zia-45-s-puradur-ii-inset-silgranit-kitchen-sink'),(44924,121,0,6340,'blanco-zia-45-s-puradur-ii-inset-silgranit-kitchen-sink'),(44925,84,5,6340,'Blanco Zia 45 S Silgranit Puradur Large Bowl Inset Kitchen Sink | Banyo'),(44926,84,0,6340,'Blanco Zia 45 S Silgranit Puradur Large Bowl Inset Kitchen Sink | Banyo'),(44927,86,5,6340,'Blanco Zia 45 S Puradur II Inset Silgranit Kitchen Sink best deals are now available at banyo.We will not be beaten on Price.Banyo is one of the most trusted and reliable suppliers of all kitchen appliances across UK'),(44928,86,0,6340,'Blanco Zia 45 S Puradur II Inset Silgranit Kitchen Sink best deals are now available at banyo.We will not be beaten on Price.Banyo is one of the most trusted and reliable suppliers of all kitchen appliances across UK'),(44929,73,5,6340,'Blanco Zia 45 S Puradur II Inset Silgranit Kitchen Sink'),(44930,73,0,6340,'Blanco Zia 45 S Puradur II Inset Silgranit Kitchen Sink'),(44931,109,5,6340,'Blanco Zia 45 S Puradur II Inset Silgranit Kitchen Sink'),(44932,109,0,6340,'Blanco Zia 45 S Puradur II Inset Silgranit Kitchen Sink'),(44933,121,5,6341,'blanco-zia-5-s-puradur-ii-inset-silgranit-kitchen-sink'),(44934,121,0,6341,'blanco-zia-5-s-puradur-ii-inset-silgranit-kitchen-sink'),(44935,84,5,6341,'Blanco Zia 5 S Inset Reversible Silgranit Puradur Kitchen Sink | Banyo'),(44936,84,0,6341,'Blanco Zia 5 S Inset Reversible Silgranit Puradur Kitchen Sink | Banyo'),(44937,86,5,6341,'Banyo stock an extensive range of Blanco Zia 5 S Puradur II Inset Silgranit Kitchen Sink at lowest prices.We are sure we will have all the products what you looking for and we proud to provide best quality to all'),(44938,86,0,6341,'Banyo stock an extensive range of Blanco Zia 5 S Puradur II Inset Silgranit Kitchen Sink at lowest prices.We are sure we will have all the products what you looking for and we proud to provide best quality to all'),(44939,73,5,6341,'Blanco Zia 5 S Puradur II Inset Silgranit Kitchen Sink'),(44940,73,0,6341,'Blanco Zia 5 S Puradur II Inset Silgranit Kitchen Sink'),(44941,109,5,6341,'Blanco Zia 5 S Puradur II Inset Silgranit Kitchen Sink'),(44942,109,0,6341,'Blanco Zia 5 S Puradur II Inset Silgranit Kitchen Sink'),(44943,121,5,6342,'blanco-zia-6-s-puradur-ii-inset-silgranit-kitchen-sink'),(44944,121,0,6342,'blanco-zia-6-s-puradur-ii-inset-silgranit-kitchen-sink'),(44945,84,5,6342,'Blanco ZIA 6 S Reversible Inset Silgranit Puradur Kitchen Sink | Banyo'),(44946,84,0,6342,'Blanco ZIA 6 S Reversible Inset Silgranit Puradur Kitchen Sink | Banyo'),(44947,86,5,6342,'Save on Blanco Zia 6 S Puradur II Inset Silgranit Kitchen Sink at banyo.Buy a Blanco brand sink from Banyo, guaranteed it will never let you down.'),(44948,86,0,6342,'Save on Blanco Zia 6 S Puradur II Inset Silgranit Kitchen Sink at banyo.Buy a Blanco brand sink from Banyo, guaranteed it will never let you down.'),(44949,73,5,6342,'Blanco Zia 6 S Puradur II Inset Silgranit Kitchen Sink'),(44950,73,0,6342,'Blanco Zia 6 S Puradur II Inset Silgranit Kitchen Sink'),(44951,109,5,6342,'Blanco Zia 6 S Puradur II Inset Silgranit Kitchen Sink'),(44952,109,0,6342,'Blanco Zia 6 S Puradur II Inset Silgranit Kitchen Sink'),(44953,121,5,6343,'blanco-zia-9-e-corner-silgranit-puradur-iir-inset-sink'),(44954,121,0,6343,'blanco-zia-9-e-corner-silgranit-puradur-iir-inset-sink'),(44955,84,5,6343,'Blanco ZIA 9 E Corner Silgranit PuraDur Inset Sink - 1.0 Bowl | Banyo'),(44956,84,0,6343,'Blanco ZIA 9 E Corner Silgranit PuraDur Inset Sink - 1.0 Bowl | Banyo'),(44957,86,5,6343,'Blanco ZIA 9 E Corner Silgranit PuraDur II® Inset Sink'),(44958,86,0,6343,'Blanco ZIA 9 E Corner Silgranit PuraDur II® Inset Sink'),(44959,73,5,6343,'Blanco ZIA 9 E Corner Silgranit PuraDur IIÂ® Inset Sink'),(44960,73,0,6343,'Blanco ZIA 9 E Corner Silgranit PuraDur IIÂ® Inset Sink'),(44961,109,5,6343,'Blanco ZIA 9 E Corner Silgranit PuraDur II® Inset Sink'),(44962,109,0,6343,'Blanco ZIA 9 E Corner Silgranit PuraDur II® Inset Sink'),(44963,121,5,6344,'blanco-zia-xl-6-s-silgranit-puradur-iir-inset-sink'),(44964,121,0,6344,'blanco-zia-xl-6-s-silgranit-puradur-iir-inset-sink'),(44965,84,5,6344,'Blanco ZIA XL 6 S Silgranit PuraDur II® Inset Sink'),(44966,84,0,6344,'Blanco ZIA XL 6 S Silgranit PuraDur II® Inset Sink'),(44967,86,5,6344,'Blanco ZIA XL 6 S is a Silgranit PuraDur II Inset XL Bowl Kitchen Sink with modern design and clear lines. For best online prices on high quality kitchen sinks in UK visit Banyo.co.uk.'),(44968,86,0,6344,'Blanco ZIA XL 6 S is a Silgranit PuraDur II Inset XL Bowl Kitchen Sink with modern design and clear lines. For best online prices on high quality kitchen sinks in UK visit Banyo.co.uk.'),(44969,73,5,6344,'Blanco ZIA XL 6 S Silgranit PuraDur IIÂ® Inset Sink'),(44970,73,0,6344,'Blanco ZIA XL 6 S Silgranit PuraDur IIÂ® Inset Sink'),(44971,109,5,6344,'Blanco ZIA XL 6 S Silgranit PuraDur II® Inset Sink'),(44972,109,0,6344,'Blanco ZIA XL 6 S Silgranit PuraDur II® Inset Sink'),(44973,121,5,6345,'blanco-zia-xl-6-s-compact-silgranit-inset-kitchen-sink'),(44974,121,0,6345,'blanco-zia-xl-6-s-compact-silgranit-inset-kitchen-sink'),(44975,73,5,6345,'Blanco Zia XL 6 S Compact Silgranit Inset Kitchen Sink'),(44976,73,0,6345,'Blanco Zia XL 6 S Compact Silgranit Inset Kitchen Sink'),(44977,109,5,6345,'blanco-zia-XL-6-S-Compact-526019-black'),(44978,109,0,6345,'blanco-zia-XL-6-S-Compact-526019-black'),(44979,110,5,6345,'blanco-zia-XL-6-S-Compact-526019-black'),(44980,110,0,6345,'blanco-zia-XL-6-S-Compact-526019-black'),(44981,111,5,6345,'blanco-zia-XL-6-S-Compact-526019-black'),(44982,111,0,6345,'blanco-zia-XL-6-S-Compact-526019-black'),(44983,134,0,6035,'0'),(44984,124,5,6035,'0'),(44985,124,1,6035,'0'),(44986,106,5,6035,'container2'),(44987,162,0,6035,NULL),(44988,152,0,6035,NULL),(44989,124,0,6035,'0'),(44990,106,0,6035,'container1'),(44991,134,0,6036,'0'),(44992,124,5,6036,'0'),(44993,124,1,6036,'0'),(44994,106,5,6036,'container2'),(44995,162,0,6036,NULL),(44996,152,0,6036,NULL),(44997,124,0,6036,'0'),(44998,106,0,6036,'container1'),(44999,106,1,6036,'container2'),(45002,124,3,6035,'0'),(45003,106,3,6035,'container2'),(45004,121,5,6346,'royce-morgan-balmoral-freestanding-bath-1680mm-x-730mm-balmoral'),(45005,121,0,6346,'royce-morgan-balmoral-freestanding-bath-1680mm-x-730mm-balmoral'),(45006,84,5,6346,'Royce Morgan Balmoral Freestanding Bath 1680mm x 730mm - Banyo'),(45007,84,0,6346,'Royce Morgan Balmoral Freestanding Bath 1680mm x 730mm - Banyo'),(45008,86,5,6346,'Great Discount price on Royce Morgan Balmoral freestanding Baths. You can save up to 25%. Banyo is one of the largest independent bathroom retailers in UK , We truly believe that we\'re helping our customers to build their dreams for their lives.'),(45009,86,0,6346,'Great Discount price on Royce Morgan Balmoral freestanding Baths. You can save up to 25%. Banyo is one of the largest independent bathroom retailers in UK , We truly believe that we\'re helping our customers to build their dreams for their lives.'),(45010,73,5,6346,'Royce Morgan Balmoral Freestanding Acrylic Bath 1680 x 730mm'),(45011,73,0,6346,'Royce Morgan Balmoral Freestanding Acrylic Bath 1680 x 730mm'),(45012,109,5,6346,'Royce Morgan Balmoral Freestanding Acrylic Bath 1680 x 730mm'),(45013,109,0,6346,'Royce Morgan Balmoral Freestanding Acrylic Bath 1680 x 730mm'),(45014,121,5,6347,'royce-morgan-bolton-freestanding-bath-1690mm-x-800mm-bolton1690'),(45015,121,0,6347,'royce-morgan-bolton-freestanding-bath-1690mm-x-800mm-bolton1690'),(45016,84,5,6347,'Royce Morgan Bolton Freestanding Bath 1690mm x 800mm - Banyo'),(45017,84,0,6347,'Royce Morgan Bolton Freestanding Bath 1690mm x 800mm - Banyo'),(45018,86,5,6347,'Royce Morgan freestanding bath has elegant designing and seamless look. This contemporary double ended bath has excellent features and thermal properties.'),(45019,86,0,6347,'Royce Morgan freestanding bath has elegant designing and seamless look. This contemporary double ended bath has excellent features and thermal properties.'),(45020,73,5,6347,'Royce Morgan Bolton Contemporary Double Ended Bath 1690 x 800mm'),(45021,73,0,6347,'Royce Morgan Bolton Contemporary Double Ended Bath 1690 x 800mm'),(45022,109,5,6347,'Royce Morgan Bolton Contemporary Double Ended Bath 1690 x 800mm'),(45023,109,0,6347,'Royce Morgan Bolton Contemporary Double Ended Bath 1690 x 800mm'),(45024,121,5,6348,'royce-morgan-bolton-freestanding-bath-1805mm-x-860mm-bolton1805'),(45025,121,0,6348,'royce-morgan-bolton-freestanding-bath-1805mm-x-860mm-bolton1805'),(45026,84,5,6348,'Royce Morgan Bolton Freestanding Bath 1805mm x 860mm - Banyo'),(45027,84,0,6348,'Royce Morgan Bolton Freestanding Bath 1805mm x 860mm - Banyo'),(45028,86,5,6348,'Lift the design of your bathroom to an amazing level by installing the Royce Morgan Bolton freestanding bath as it has seamless and eye-catching look.'),(45029,86,0,6348,'Lift the design of your bathroom to an amazing level by installing the Royce Morgan Bolton freestanding bath as it has seamless and eye-catching look.'),(45030,73,5,6348,'Royce Morgan Bolton Acrylic Freestanding Bath 1805 x 860mm'),(45031,73,0,6348,'Royce Morgan Bolton Acrylic Freestanding Bath 1805 x 860mm'),(45032,109,5,6348,'Royce Morgan Bolton Acrylic Freestanding Bath 1805 x 860mm'),(45033,109,0,6348,'Royce Morgan Bolton Acrylic Freestanding Bath 1805 x 860mm'),(45034,121,5,6349,'royce-morgan-chatsworth-freestanding-bath-1530mm-x-710mm-chatsworth'),(45035,121,0,6349,'royce-morgan-chatsworth-freestanding-bath-1530mm-x-710mm-chatsworth'),(45036,84,5,6349,'Royce Morgan Chatsworth Freestanding Bath 1530mm x 710mm - Banyo'),(45037,84,0,6349,'Royce Morgan Chatsworth Freestanding Bath 1530mm x 710mm - Banyo'),(45038,86,5,6349,'Click to explore one of the finest range of Royce Morgan Chatsworth Bath by the biggest stockest of branded baths at banyo. Visit us now and get Huge Discounts on Royce Morgan Freestanding Baths.'),(45039,86,0,6349,'Click to explore one of the finest range of Royce Morgan Chatsworth Bath by the biggest stockest of branded baths at banyo. Visit us now and get Huge Discounts on Royce Morgan Freestanding Baths.'),(45040,73,5,6349,'Royce Morgan Chatsworth Traditional Roll Top Slipper 1530 x 710mm'),(45041,73,0,6349,'Royce Morgan Chatsworth Traditional Roll Top Slipper 1530 x 710mm'),(45042,109,5,6349,'Royce Morgan Chatsworth Traditional Roll Top Slipper 1530 x 710mm'),(45043,109,0,6349,'Royce Morgan Chatsworth Traditional Roll Top Slipper 1530 x 710mm'),(45044,121,5,6350,'royce-morgan-ebony-freestanding-bath-1710mm-x-735mm-ebony'),(45045,121,0,6350,'royce-morgan-ebony-freestanding-bath-1710mm-x-735mm-ebony'),(45046,84,5,6350,'Royce Morgan Ebony Freestanding Bath 1710mm x 735mm - Banyo'),(45047,84,0,6350,'Royce Morgan Ebony Freestanding Bath 1710mm x 735mm - Banyo'),(45048,86,5,6350,'Don\'t Go Buying Without Us! We have special discount pricing for you. Save on Royce Morgan Ebony Freestanding Bath with very quick transportation And lifetime guarantee on the product.'),(45049,86,0,6350,'Don\'t Go Buying Without Us! We have special discount pricing for you. Save on Royce Morgan Ebony Freestanding Bath with very quick transportation And lifetime guarantee on the product.'),(45050,73,5,6350,'Royce Morgan Ebony Freestanding Slipper Bath 1710 x 735mm'),(45051,73,0,6350,'Royce Morgan Ebony Freestanding Slipper Bath 1710 x 735mm'),(45052,109,5,6350,'Royce Morgan Ebony Freestanding Slipper Bath 1710 x 735mm'),(45053,109,0,6350,'Royce Morgan Ebony Freestanding Slipper Bath 1710 x 735mm'),(45054,121,5,6351,'royce-morgan-hexham-freestanding-bath-1690mm-x-760mm-hexham'),(45055,121,0,6351,'royce-morgan-hexham-freestanding-bath-1690mm-x-760mm-hexham'),(45056,84,5,6351,'Royce Morgan Hexham Freestanding Bath 1690mm x 760mm - Banyo'),(45057,84,0,6351,'Royce Morgan Hexham Freestanding Bath 1690mm x 760mm - Banyo'),(45058,86,5,6351,'Unbeatable prices, Fast delivery, Lifetime Guarantee on Royce Morgan Hexham Freestanding Baths. We have several styles, which come in a range of sizes to accommodate both big and small bathrooms. '),(45059,86,0,6351,'Unbeatable prices, Fast delivery, Lifetime Guarantee on Royce Morgan Hexham Freestanding Baths. We have several styles, which come in a range of sizes to accommodate both big and small bathrooms. '),(45060,73,5,6351,'Royce Morgan Hexham Freestanding Double-ended Bath 1690 x 760mm'),(45061,73,0,6351,'Royce Morgan Hexham Freestanding Double-ended Bath 1690 x 760mm'),(45062,109,5,6351,'Royce Morgan Hexham Freestanding Double-ended Bath 1690 x 760mm'),(45063,109,0,6351,'Royce Morgan Hexham Freestanding Double-ended Bath 1690 x 760mm'),(45064,121,5,6352,'royce-morgan-kensington-freestanding-bath-1495mm-x-785mm-kensington1495'),(45065,121,0,6352,'royce-morgan-kensington-freestanding-bath-1495mm-x-785mm-kensington1495'),(45066,84,5,6352,'Royce Morgan Kensington Freestanding Bath 1495mm x 785mm - Banyo'),(45067,84,0,6352,'Royce Morgan Kensington Freestanding Bath 1495mm x 785mm - Banyo'),(45068,86,5,6352,'Banyo have a great selection of Bathrooms and Bath Tubs for your Bathrooms. Take a look at our wide range of Royce Morgan Kensington Freestanding Baths at guaranteed low rates. Order Online: 011-627-44-059.'),(45069,86,0,6352,'Banyo have a great selection of Bathrooms and Bath Tubs for your Bathrooms. Take a look at our wide range of Royce Morgan Kensington Freestanding Baths at guaranteed low rates. Order Online: 011-627-44-059.'),(45070,73,5,6352,'Royce Morgan Kensington Traditional Double Ended Bath 1495 x 785mm'),(45071,73,0,6352,'Royce Morgan Kensington Traditional Double Ended Bath 1495 x 785mm'),(45072,109,5,6352,'Royce Morgan Kensington Traditional Double Ended Bath 1495 x 785mm'),(45073,109,0,6352,'Royce Morgan Kensington Traditional Double Ended Bath 1495 x 785mm'),(45074,121,5,6353,'royce-morgan-kensington-freestanding-bath-1695mm-x-740mm-kensington1695'),(45075,121,0,6353,'royce-morgan-kensington-freestanding-bath-1695mm-x-740mm-kensington1695'),(45076,84,5,6353,'Royce Morgan Kensington Freestanding Bath 1695mm x 740mm - Banyo'),(45077,84,0,6353,'Royce Morgan Kensington Freestanding Bath 1695mm x 740mm - Banyo'),(45078,86,5,6353,'Banyo offers a wide range of Bathroom Tubs , Freestanding Baths. Get Huge Discounts on Royce Morgan Kensington Freestanding Baths and bathroom products available to buy online. Call us for Order Online: 011 627 44 059 '),(45079,86,0,6353,'Banyo offers a wide range of Bathroom Tubs , Freestanding Baths. Get Huge Discounts on Royce Morgan Kensington Freestanding Baths and bathroom products available to buy online. Call us for Order Online: 011 627 44 059 '),(45080,73,5,6353,'Royce Morgan Kensington Freestanding Acrylic Bath 1695 x 740mm'),(45081,73,0,6353,'Royce Morgan Kensington Freestanding Acrylic Bath 1695 x 740mm'),(45082,109,5,6353,'Royce Morgan Kensington Freestanding Acrylic Bath 1695 x 740mm'),(45083,109,0,6353,'Royce Morgan Kensington Freestanding Acrylic Bath 1695 x 740mm'),(45084,121,5,6354,'royce-morgan-lambeth-freestanding-bath-1665mm-x-715mm-lambeth'),(45085,121,0,6354,'royce-morgan-lambeth-freestanding-bath-1665mm-x-715mm-lambeth'),(45086,84,5,6354,'Royce Morgan Lambeth Freestanding Bath 1665mm x 715mm - Banyo'),(45087,84,0,6354,'Royce Morgan Lambeth Freestanding Bath 1665mm x 715mm - Banyo'),(45088,86,5,6354,'Huge blowout sale on Royce Morgan Lambeth Freestanding Bath with Lifetime manufacture guarantee. Banyo brings the worldís largest and finest range of Bathroom Products & Accesories at your doorsteps. Fastest delivery across all UK. Visit Now!'),(45089,86,0,6354,'Huge blowout sale on Royce Morgan Lambeth Freestanding Bath with Lifetime manufacture guarantee. Banyo brings the worldís largest and finest range of Bathroom Products & Accesories at your doorsteps. Fastest delivery across all UK. Visit Now!'),(45090,73,5,6354,'Royce Morgan Lambeth Single Ended Acrylic Bath 1665 x 715mm'),(45091,73,0,6354,'Royce Morgan Lambeth Single Ended Acrylic Bath 1665 x 715mm'),(45092,109,5,6354,'Royce Morgan Lambeth Single Ended Acrylic Bath 1665 x 715mm'),(45093,109,0,6354,'Royce Morgan Lambeth Single Ended Acrylic Bath 1665 x 715mm'),(45094,121,5,6355,'royce-morgan-melrose-freestanding-bath-1700mm-x-700mm-melrose'),(45095,121,0,6355,'royce-morgan-melrose-freestanding-bath-1700mm-x-700mm-melrose'),(45096,84,5,6355,'Royce Morgan Melrose Freestanding Bath 1700mm x 700mm - Banyo'),(45097,84,0,6355,'Royce Morgan Melrose Freestanding Bath 1700mm x 700mm - Banyo'),(45098,86,5,6355,'Click to explore one of the finest range of Royce Morgan Melrose Bath by the biggest stockest of branded baths at Banyo. Visit us now and check out complete range of Bath Tubs and Freestanding Baths in the UK!'),(45099,86,0,6355,'Click to explore one of the finest range of Royce Morgan Melrose Bath by the biggest stockest of branded baths at Banyo. Visit us now and check out complete range of Bath Tubs and Freestanding Baths in the UK!'),(45100,73,5,6355,'Royce Morgan Melrose Double Ended Boat Bath with Plinth 1700 x 700mm'),(45101,73,0,6355,'Royce Morgan Melrose Double Ended Boat Bath with Plinth 1700 x 700mm'),(45102,109,5,6355,'Royce Morgan Melrose Double Ended Boat Bath 1700 x 700mm'),(45103,109,0,6355,'Royce Morgan Melrose Double Ended Boat Bath 1700 x 700mm'),(45104,121,5,6356,'royce-morgan-melrose-freestanding-bath-1740mm-x-700mm-melrosefa'),(45105,121,0,6356,'royce-morgan-melrose-freestanding-bath-1740mm-x-700mm-melrosefa'),(45106,84,5,6356,'Royce Morgan Melrose Freestanding Bath 1740mm x 700mm - Banyo'),(45107,84,0,6356,'Royce Morgan Melrose Freestanding Bath 1740mm x 700mm - Banyo'),(45108,86,5,6356,'Don\'t Go Buying Without Us! We have special discount pricing for you. Save on Royce Morgan Melrose Freestanding Baths with very quick transportation And lifetime guarantee on the product.'),(45109,86,0,6356,'Don\'t Go Buying Without Us! We have special discount pricing for you. Save on Royce Morgan Melrose Freestanding Baths with very quick transportation And lifetime guarantee on the product.'),(45110,73,5,6356,'Royce Morgan Melrose Double Ended Boat Bath 1740 x 700mm'),(45111,73,0,6356,'Royce Morgan Melrose Double Ended Boat Bath 1740 x 700mm'),(45112,109,5,6356,'Royce Morgan Melrose Double Ended Boat Bath 1740 x 700mm'),(45113,109,0,6356,'Royce Morgan Melrose Double Ended Boat Bath 1740 x 700mm'),(45114,121,5,6357,'royce-morgan-onyx-freestanding-bath-1700mm-x-670mm-onyx'),(45115,121,0,6357,'royce-morgan-onyx-freestanding-bath-1700mm-x-670mm-onyx'),(45116,84,5,6357,'Royce Morgan Onyx Freestanding Bath 1700mm x 670mm - Banyo'),(45117,84,0,6357,'Royce Morgan Onyx Freestanding Bath 1700mm x 670mm - Banyo'),(45118,86,5,6357,'Royce Morgan Onyx Freestanding Bath 1700mm x 670mm - Onyx. Our aim is to make the transformation of your bathroom the easiest and most enjoyable experience possible for you, as it should be..'),(45119,86,0,6357,'Royce Morgan Onyx Freestanding Bath 1700mm x 670mm - Onyx. Our aim is to make the transformation of your bathroom the easiest and most enjoyable experience possible for you, as it should be..'),(45120,73,5,6357,'Royce Morgan Onyx Modren Double Ended Bath 1700 x 670mm'),(45121,73,0,6357,'Royce Morgan Onyx Modren Double Ended Bath 1700 x 670mm'),(45122,109,5,6357,'Royce Morgan Onyx Modren Double Ended Bath 1700 x 670mm'),(45123,109,0,6357,'Royce Morgan Onyx Modren Double Ended Bath 1700 x 670mm'),(45124,121,5,6358,'royce-morgan-opal-freestanding-bath-1790mm-x-820mm-opal'),(45125,121,0,6358,'royce-morgan-opal-freestanding-bath-1790mm-x-820mm-opal'),(45126,84,5,6358,'Royce Morgan Opal Freestanding Bath 1790mm x 820mm - Banyo'),(45127,84,0,6358,'Royce Morgan Opal Freestanding Bath 1790mm x 820mm - Banyo'),(45128,86,5,6358,'Royce Morgan Opal Freestanding Bath 1790mm x 820mm - Opal. Our aim is to make the transformation of your bathroom the easiest and most enjoyable experience possible for you, as it should be..'),(45129,86,0,6358,'Royce Morgan Opal Freestanding Bath 1790mm x 820mm - Opal. Our aim is to make the transformation of your bathroom the easiest and most enjoyable experience possible for you, as it should be..'),(45130,73,5,6358,'Royce Morgan Opal Modern Freestanding Bath 1790 x 820mm'),(45131,73,0,6358,'Royce Morgan Opal Modern Freestanding Bath 1790 x 820mm'),(45132,109,5,6358,'Royce Morgan Opal Modern Freestanding Bath 1790 x 820mm'),(45133,109,0,6358,'Royce Morgan Opal Modern Freestanding Bath 1790 x 820mm'),(45134,121,5,6359,'royce-morgan-orlando-freestanding-bath-1380mm-x-750mm-orlando1380'),(45135,121,0,6359,'royce-morgan-orlando-freestanding-bath-1380mm-x-750mm-orlando1380'),(45136,84,5,6359,'Royce Morgan Orlando Freestanding Bath 1380mm x 750mm - Orlando1380 - Banyo'),(45137,84,0,6359,'Royce Morgan Orlando Freestanding Bath 1380mm x 750mm - Orlando1380 - Banyo'),(45138,86,5,6359,'Exclusive Offers on all top Bathroom Products and Accesories brands at Banyo Uk. Check out our Royce Morgan Orlando Freestanding Baths range that comes with Lifetime Guarantee and at a very affordable price. Banyo delivers it fast.'),(45139,86,0,6359,'Exclusive Offers on all top Bathroom Products and Accesories brands at Banyo Uk. Check out our Royce Morgan Orlando Freestanding Baths range that comes with Lifetime Guarantee and at a very affordable price. Banyo delivers it fast.'),(45140,73,5,6359,'Royce Morgan Orlando Traditional Single Ended Bath 1380 x 750mm'),(45141,73,0,6359,'Royce Morgan Orlando Traditional Single Ended Bath 1380 x 750mm'),(45142,109,5,6359,'Royce Morgan Orlando Traditional Single Ended Bath 1380 x 750mm'),(45143,109,0,6359,'Royce Morgan Orlando Traditional Single Ended Bath 1380 x 750mm'),(45144,121,5,6360,'royce-morgan-quartz-freestanding-bath-1760mm-x-680mm-quartz'),(45145,121,0,6360,'royce-morgan-quartz-freestanding-bath-1760mm-x-680mm-quartz'),(45146,84,5,6360,'Royce Morgan Quartz Freestanding Bath 1760mm x 680mm - Banyo'),(45147,84,0,6360,'Royce Morgan Quartz Freestanding Bath 1760mm x 680mm - Banyo'),(45148,86,5,6360,'Royce Morgan Quartz Freestanding Bath 1760mm x 680mm - Quartz. Our aim is to make the transformation of your bathroom the easiest and most enjoyable experience possible for you, as it should be..'),(45149,86,0,6360,'Royce Morgan Quartz Freestanding Bath 1760mm x 680mm - Quartz. Our aim is to make the transformation of your bathroom the easiest and most enjoyable experience possible for you, as it should be..'),(45150,73,5,6360,'Royce Morgan Quartz Double Ended Acrylic Bath 1760 x 680mm'),(45151,73,0,6360,'Royce Morgan Quartz Double Ended Acrylic Bath 1760 x 680mm'),(45152,109,5,6360,'Royce Morgan Quartz Double Ended Acrylic Bath 1760 x 680mm'),(45153,109,0,6360,'Royce Morgan Quartz Double Ended Acrylic Bath 1760 x 680mm'),(45154,121,5,6361,'royce-morgan-ruby-freestanding-bath-1580mm-x-740mm-ruby'),(45155,121,0,6361,'royce-morgan-ruby-freestanding-bath-1580mm-x-740mm-ruby'),(45156,84,5,6361,'Royce Morgan Ruby Freestanding Bath 1580mm x 740mm - Banyo'),(45157,84,0,6361,'Royce Morgan Ruby Freestanding Bath 1580mm x 740mm - Banyo'),(45158,86,5,6361,'Royce Morgan Ruby Freestanding Bath 1580mm x 740mm - Ruby. Our aim is to make the transformation of your bathroom the easiest and most enjoyable experience possible for you, as it should be..'),(45159,86,0,6361,'Royce Morgan Ruby Freestanding Bath 1580mm x 740mm - Ruby. Our aim is to make the transformation of your bathroom the easiest and most enjoyable experience possible for you, as it should be..'),(45160,73,5,6361,'Royce Morgan Ruby Double Ended Freestanding Bath 1580 x 740mm'),(45161,73,0,6361,'Royce Morgan Ruby Double Ended Freestanding Bath 1580 x 740mm'),(45162,109,5,6361,'Royce Morgan Ruby Double Ended Freestanding Bath 1580 x 740mm'),(45163,109,0,6361,'Royce Morgan Ruby Double Ended Freestanding Bath 1580 x 740mm'),(45164,121,5,6362,'royce-morgan-sunstone-freestanding-bath-1590mm-x-700mm-sunstone'),(45165,121,0,6362,'royce-morgan-sunstone-freestanding-bath-1590mm-x-700mm-sunstone'),(45166,84,5,6362,'Royce Morgan Sunstone Freestanding Bath 1590mm x 700mm - Banyo'),(45167,84,0,6362,'Royce Morgan Sunstone Freestanding Bath 1590mm x 700mm - Banyo'),(45168,86,5,6362,'Royce Morgan Sunstone Freestanding Bath 1590mm x 700mm - Sunstone. Our aim is to make the transformation of your bathroom the easiest and most enjoyable experience possible for you, as it should be..'),(45169,86,0,6362,'Royce Morgan Sunstone Freestanding Bath 1590mm x 700mm - Sunstone. Our aim is to make the transformation of your bathroom the easiest and most enjoyable experience possible for you, as it should be..'),(45170,73,5,6362,'Royce Morgan Sunstone Contemporary Slipper Bath 1590 x 700mm'),(45171,73,0,6362,'Royce Morgan Sunstone Contemporary Slipper Bath 1590 x 700mm'),(45172,109,5,6362,'Royce Morgan Sunstone Contemporary Slipper Bath 1590 x 700mm'),(45173,109,0,6362,'Royce Morgan Sunstone Contemporary Slipper Bath 1590 x 700mm'),(45174,121,5,6363,'royce-morgan-westminster-freestanding-bath-1490mm-x-850mm-westminster1490'),(45175,121,0,6363,'royce-morgan-westminster-freestanding-bath-1490mm-x-850mm-westminster1490'),(45176,84,5,6363,'Royce Morgan Westminster Double Ended Acrylic Bath 1490 x 850mm'),(45177,84,0,6363,'Royce Morgan Westminster Double Ended Acrylic Bath 1490 x 850mm'),(45178,86,5,6363,'Royce Morgan Westminster Double Ended Acrylic Bath 1490 x 850mm'),(45179,86,0,6363,'Royce Morgan Westminster Double Ended Acrylic Bath 1490 x 850mm'),(45180,73,5,6363,'Royce Morgan Westminster Double Ended Acrylic Bath 1490 x 850mm'),(45181,73,0,6363,'Royce Morgan Westminster Double Ended Acrylic Bath 1490 x 850mm'),(45182,109,5,6363,'Royce Morgan Westminster Double Ended Acrylic Bath 1490 x 850mm'),(45183,109,0,6363,'Royce Morgan Westminster Double Ended Acrylic Bath 1490 x 850mm'),(45184,121,5,6364,'royce-morgan-westminster-freestanding-bath-1860mm-x-880mm-westminster1860'),(45185,121,0,6364,'royce-morgan-westminster-freestanding-bath-1860mm-x-880mm-westminster1860'),(45186,84,5,6364,'Royce Morgan Westminster Freestanding Acrylic Bath 1860 x 880mm'),(45187,84,0,6364,'Royce Morgan Westminster Freestanding Acrylic Bath 1860 x 880mm'),(45188,86,5,6364,'Royce Morgan Westminster Freestanding Acrylic Bath 1860 x 880mm'),(45189,86,0,6364,'Royce Morgan Westminster Freestanding Acrylic Bath 1860 x 880mm'),(45190,73,5,6364,'Royce Morgan Westminster Freestanding Acrylic Bath 1860 x 880mm'),(45191,73,0,6364,'Royce Morgan Westminster Freestanding Acrylic Bath 1860 x 880mm'),(45192,109,5,6364,'Royce Morgan Westminster Freestanding Acrylic Bath 1860 x 880mm'),(45193,109,0,6364,'Royce Morgan Westminster Freestanding Acrylic Bath 1860 x 880mm'),(45194,121,5,6365,'royce-morgan-woburn-freestanding-bath-1490mm-x-790mm-woburn1490'),(45195,121,0,6365,'royce-morgan-woburn-freestanding-bath-1490mm-x-790mm-woburn1490'),(45196,84,5,6365,'Royce Morgan Woburn Freestanding Bath 1490mm x 790mm - Woburn1490 - Banyo'),(45197,84,0,6365,'Royce Morgan Woburn Freestanding Bath 1490mm x 790mm - Woburn1490 - Banyo'),(45198,86,5,6365,'Buy Best Quality Bathroom Tubs on low Budget. Lifetime Guarantee, Super fast delivery. This deal is only available at Banyo UK. Huge Discounts at Royce Morgan Woburn Freestanding Bath. Limited Quantity!!!'),(45199,86,0,6365,'Buy Best Quality Bathroom Tubs on low Budget. Lifetime Guarantee, Super fast delivery. This deal is only available at Banyo UK. Huge Discounts at Royce Morgan Woburn Freestanding Bath. Limited Quantity!!!'),(45200,73,5,6365,'Royce Morgan Woburn Contemporary Double Ended Bath 1490 x 790mm'),(45201,73,0,6365,'Royce Morgan Woburn Contemporary Double Ended Bath 1490 x 790mm'),(45202,109,5,6365,'Royce Morgan Woburn Contemporary Double Ended Bath 1490 x 790mm'),(45203,109,0,6365,'Royce Morgan Woburn Contemporary Double Ended Bath 1490 x 790mm'),(45204,121,5,6366,'royce-morgan-woburn-freestanding-bath-1675mm-x-780mm-woburn1675'),(45205,121,0,6366,'royce-morgan-woburn-freestanding-bath-1675mm-x-780mm-woburn1675'),(45206,84,5,6366,'Royce Morgan Woburn Freestanding Bath 1675mm x 780mm - Woburn1675 - Banyo'),(45207,84,0,6366,'Royce Morgan Woburn Freestanding Bath 1675mm x 780mm - Woburn1675 - Banyo'),(45208,86,5,6366,'Explore the finest range of Royce Morgan Woburn Bath by the biggest stockest of branded baths at Banyo. Visit us now and check out the latest range of Bath Tubs and Freestanding Baths in the UK !'),(45209,86,0,6366,'Explore the finest range of Royce Morgan Woburn Bath by the biggest stockest of branded baths at Banyo. Visit us now and check out the latest range of Bath Tubs and Freestanding Baths in the UK !'),(45210,73,5,6366,'Royce Morgan Woburn Double Ended Acrylic Bath 1675 x 780mm'),(45211,73,0,6366,'Royce Morgan Woburn Double Ended Acrylic Bath 1675 x 780mm'),(45212,109,5,6366,'Royce Morgan Woburn Double Ended Acrylic Bath 1675 x 780mm'),(45213,109,0,6366,'Royce Morgan Woburn Double Ended Acrylic Bath 1675 x 780mm'),(45214,121,5,6367,'royce-morgan-woburn-freestanding-bath-1765mm-x-800mm-woburn1765'),(45215,121,0,6367,'royce-morgan-woburn-freestanding-bath-1765mm-x-800mm-woburn1765'),(45216,84,5,6367,'Royce Morgan Woburn Freestanding Bath 1765mm x 800mm - Woburn1765 - Banyo'),(45217,84,0,6367,'Royce Morgan Woburn Freestanding Bath 1765mm x 800mm - Woburn1765 - Banyo'),(45218,86,5,6367,'Surprising Offer on Royce Morgan Woburn Freestanding Bath. Great Quality, fast delivery across UK, We take pride in our high quality workmanship and exemplary customer service.  We use only quality products with the best warranties.'),(45219,86,0,6367,'Surprising Offer on Royce Morgan Woburn Freestanding Bath. Great Quality, fast delivery across UK, We take pride in our high quality workmanship and exemplary customer service.  We use only quality products with the best warranties.'),(45220,73,5,6367,'Royce Morgan Woburn Double Ended Acrylic Bath 1765 x 800mm'),(45221,73,0,6367,'Royce Morgan Woburn Double Ended Acrylic Bath 1765 x 800mm'),(45222,109,5,6367,'Royce Morgan Woburn Double Ended Acrylic Bath 1765 x 800mm'),(45223,109,0,6367,'Royce Morgan Woburn Double Ended Acrylic Bath 1765 x 800mm'),(45224,121,5,6368,'premier-asselby-square-acrylic-bath-with-leg-set-170-x-70cm'),(45225,121,0,6368,'premier-asselby-square-acrylic-bath-with-leg-set-170-x-70cm'),(45226,84,5,6368,'Premier Asselby Square  Acrylic Bath with Leg Set 1700 x 700mm'),(45227,84,0,6368,'Premier Asselby Square  Acrylic Bath with Leg Set 1700 x 700mm'),(45228,86,5,6368,'Premier Asselby Square  Acrylic Bath with Leg Set 1700 x 700mm'),(45229,86,0,6368,'Premier Asselby Square  Acrylic Bath with Leg Set 1700 x 700mm'),(45230,73,5,6368,'Nuie Asselby Square  Acrylic Bath - 1700 x 700mm'),(45231,73,0,6368,'Nuie Asselby Square  Acrylic Bath - 1700 x 700mm'),(45232,109,5,6368,'Premier Asselby Square  Acrylic Bath with Leg Set 1700 x 700mm'),(45233,109,0,6368,'Premier Asselby Square  Acrylic Bath with Leg Set 1700 x 700mm'),(45234,121,5,6369,'premier-asselby-square-acrylic-bath-with-leg-set-170cm-x-75cm'),(45235,121,0,6369,'premier-asselby-square-acrylic-bath-with-leg-set-170cm-x-75cm'),(45236,84,5,6369,'Premier Asselby Square Acrylic Bath with Leg Set 1700 x 750mm'),(45237,84,0,6369,'Premier Asselby Square Acrylic Bath with Leg Set 1700 x 750mm'),(45238,86,5,6369,'Premier Asselby Square Acrylic Bath with Leg Set 1700 x 750mm'),(45239,86,0,6369,'Premier Asselby Square Acrylic Bath with Leg Set 1700 x 750mm'),(45240,73,5,6369,'Nuie Asselby Square Acrylic Bath - 1700 x 750mm'),(45241,73,0,6369,'Nuie Asselby Square Acrylic Bath - 1700 x 750mm'),(45242,109,5,6369,'Premier Asselby Square Acrylic Bath with Leg Set 1700 x 750mm'),(45243,109,0,6369,'Premier Asselby Square Acrylic Bath with Leg Set 1700 x 750mm'),(45244,121,5,6370,'premier-asselby-square-acrylic-bath-with-leg-set-180cm-x-80cm'),(45245,121,0,6370,'premier-asselby-square-acrylic-bath-with-leg-set-180cm-x-80cm'),(45246,84,5,6370,'Premier Asselby Square Acrylic Bath with Leg Set 1800 x 800mm'),(45247,84,0,6370,'Premier Asselby Square Acrylic Bath with Leg Set 1800 x 800mm'),(45248,86,5,6370,'Premier Asselby Square Acrylic Bath with Leg Set 1800 x 800mm'),(45249,86,0,6370,'Premier Asselby Square Acrylic Bath with Leg Set 1800 x 800mm'),(45250,73,5,6370,'Nuie Asselby Square Acrylic Bath - 1800 x 800mm'),(45251,73,0,6370,'Nuie Asselby Square Acrylic Bath - 1800 x 800mm'),(45252,109,5,6370,'Premier Asselby Square Acrylic Bath with Leg Set 1800 x 800mm'),(45253,109,0,6370,'Premier Asselby Square Acrylic Bath with Leg Set 1800 x 800mm'),(45254,121,5,6371,'premier-barmby-round-acrylic-bath-150cm-x-70cm'),(45255,121,0,6371,'premier-barmby-round-acrylic-bath-150cm-x-70cm'),(45256,84,5,6371,'Premier Barmby Round Acrylic Bath with Leg Set 1500 x 700mm '),(45257,84,0,6371,'Premier Barmby Round Acrylic Bath with Leg Set 1500 x 700mm '),(45258,86,5,6371,'Premier Barmby Round Acrylic Bath with Leg Set 1500 x 700mm '),(45259,86,0,6371,'Premier Barmby Round Acrylic Bath with Leg Set 1500 x 700mm '),(45260,73,5,6371,'Nuie Barmby Round Acrylic Bath - 1500 x 700mm '),(45261,73,0,6371,'Nuie Barmby Round Acrylic Bath - 1500 x 700mm '),(45262,109,5,6371,'Premier Barmby Round Acrylic Bath with Leg Set 1500 x 700mm '),(45263,109,0,6371,'Premier Barmby Round Acrylic Bath with Leg Set 1500 x 700mm '),(45264,121,5,6372,'premier-barmby-round-acrylic-bath-160cm-x-70cm'),(45265,121,0,6372,'premier-barmby-round-acrylic-bath-160cm-x-70cm'),(45266,84,5,6372,'Premier Barmby Round Acrylic Bath with Leg Set 160cm x 70cm '),(45267,84,0,6372,'Premier Barmby Round Acrylic Bath with Leg Set 160cm x 70cm '),(45268,86,5,6372,'Premier Barmby Round Acrylic Bath with Leg Set 160cm x 70cm '),(45269,86,0,6372,'Premier Barmby Round Acrylic Bath with Leg Set 160cm x 70cm '),(45270,73,5,6372,'Nuie Barmby Round Acrylic Bath - 1600 x 700mm '),(45271,73,0,6372,'Nuie Barmby Round Acrylic Bath - 1600 x 700mm '),(45272,109,5,6372,'Premier Barmby Round Acrylic Bath with Leg Set 160cm x 70cm '),(45273,109,0,6372,'Premier Barmby Round Acrylic Bath with Leg Set 160cm x 70cm '),(45274,121,5,6373,'premier-barmby-round-acrylic-bath-170cm-x-70cm'),(45275,121,0,6373,'premier-barmby-round-acrylic-bath-170cm-x-70cm'),(45276,84,5,6373,'Premier Barmby Round Acrylic Bath with Leg Set 1700 x 700mm '),(45277,84,0,6373,'Premier Barmby Round Acrylic Bath with Leg Set 1700 x 700mm '),(45278,86,5,6373,'Premier Barmby Round Acrylic Bath with Leg Set 1700 x 700mm '),(45279,86,0,6373,'Premier Barmby Round Acrylic Bath with Leg Set 1700 x 700mm '),(45280,73,5,6373,'Nuie Barmby Round Acrylic Bath - 1700 x 700mm '),(45281,73,0,6373,'Nuie Barmby Round Acrylic Bath - 1700 x 700mm '),(45282,109,5,6373,'Premier Barmby Round Acrylic Bath with Leg Set 1700 x 700mm '),(45283,109,0,6373,'Premier Barmby Round Acrylic Bath with Leg Set 1700 x 700mm '),(45284,121,5,6374,'premier-barmby-acrylic-bath-170cm-x-75cm'),(45285,121,0,6374,'premier-barmby-acrylic-bath-170cm-x-75cm'),(45286,84,5,6374,'Premier Barmby Round Acrylic Bath with Leg Set 1700 x 750mm'),(45287,84,0,6374,'Premier Barmby Round Acrylic Bath with Leg Set 1700 x 750mm'),(45288,86,5,6374,'Premier Barmby Round Acrylic Bath with Leg Set 1700 x 750mm'),(45289,86,0,6374,'Premier Barmby Round Acrylic Bath with Leg Set 1700 x 750mm'),(45290,73,5,6374,'Nuie Barmby Round Acrylic Bath - 1700 x 750mm'),(45291,73,0,6374,'Nuie Barmby Round Acrylic Bath - 1700 x 750mm'),(45292,109,5,6374,'Premier Barmby Round Acrylic Bath with Leg Set 1700 x 750mm'),(45293,109,0,6374,'Premier Barmby Round Acrylic Bath with Leg Set 1700 x 750mm'),(45294,121,5,6375,'premier-barmby-acrylic-bath-180cm-x-80cm'),(45295,121,0,6375,'premier-barmby-acrylic-bath-180cm-x-80cm'),(45296,84,5,6375,'Premier Barmby Round Acrylic Bath with Leg Set 1800 x 800mm'),(45297,84,0,6375,'Premier Barmby Round Acrylic Bath with Leg Set 1800 x 800mm'),(45298,86,5,6375,'Premier Barmby Round Acrylic Bath with Leg Set 1800 x 800mm'),(45299,86,0,6375,'Premier Barmby Round Acrylic Bath with Leg Set 1800 x 800mm'),(45300,73,5,6375,'Nuie Barmby Round Acrylic Bath - 1800 x 800mm'),(45301,73,0,6375,'Nuie Barmby Round Acrylic Bath - 1800 x 800mm'),(45302,109,5,6375,'Premier Barmby Round Acrylic Bath with Leg Set 1800 x 800mm'),(45303,109,0,6375,'Premier Barmby Round Acrylic Bath with Leg Set 1800 x 800mm'),(45304,121,5,6376,'premier-linton-square-acrylic-bath-leg-set-1500mm-x-700mm'),(45305,121,0,6376,'premier-linton-square-acrylic-bath-leg-set-1500mm-x-700mm'),(45306,84,5,6376,'Premier Linton Square Acrylic Bath & Leg Set 1500mm x 700mm'),(45307,84,0,6376,'Premier Linton Square Acrylic Bath & Leg Set 1500mm x 700mm'),(45308,86,5,6376,'Premier Linton Square Acrylic Bath & Leg Set 1500mm x 700mm'),(45309,86,0,6376,'Premier Linton Square Acrylic Bath & Leg Set 1500mm x 700mm'),(45310,73,5,6376,'Nuie Linton Square Acrylic Bath - 1500 x 700mm'),(45311,73,0,6376,'Nuie Linton Square Acrylic Bath - 1500 x 700mm'),(45312,109,5,6376,'Premier Linton Square Acrylic Bath & Leg Set 1500mm x 700mm'),(45313,109,0,6376,'Premier Linton Square Acrylic Bath & Leg Set 1500mm x 700mm'),(45314,121,5,6377,'premier-linton-square-acrylic-bath-leg-set-160-x-70cm'),(45315,121,0,6377,'premier-linton-square-acrylic-bath-leg-set-160-x-70cm'),(45316,84,5,6377,'Premier Linton Square Acrylic Bath & Leg Set 1600 x 700mm'),(45317,84,0,6377,'Premier Linton Square Acrylic Bath & Leg Set 1600 x 700mm'),(45318,86,5,6377,'Premier Linton Square Acrylic Bath & Leg Set 1600 x 700mm'),(45319,86,0,6377,'Premier Linton Square Acrylic Bath & Leg Set 1600 x 700mm'),(45320,73,5,6377,'Nuie Linton Square Acrylic Bath - 1600 x 700mm'),(45321,73,0,6377,'Nuie Linton Square Acrylic Bath - 1600 x 700mm'),(45322,109,5,6377,'Premier Linton Square Acrylic Bath & Leg Set 1600 x 700mm'),(45323,109,0,6377,'Premier Linton Square Acrylic Bath & Leg Set 1600 x 700mm'),(45324,121,5,6378,'premier-linton-square-acrylic-bath-leg-set-170cm-x-70cm'),(45325,121,0,6378,'premier-linton-square-acrylic-bath-leg-set-170cm-x-70cm'),(45326,84,5,6378,'Premier Linton Square Acrylic Bath & Leg Set 1700 x 700 mm'),(45327,84,0,6378,'Premier Linton Square Acrylic Bath & Leg Set 1700 x 700 mm'),(45328,86,5,6378,'Premier Linton Square Acrylic Bath & Leg Set 1700 x 700 mm'),(45329,86,0,6378,'Premier Linton Square Acrylic Bath & Leg Set 1700 x 700 mm'),(45330,73,5,6378,'Nuie Linton Square Acrylic Bath - 1700 x 700 mm'),(45331,73,0,6378,'Nuie Linton Square Acrylic Bath - 1700 x 700 mm'),(45332,109,5,6378,'Premier Linton Square Acrylic Bath & Leg Set 1700 x 700 mm'),(45333,109,0,6378,'Premier Linton Square Acrylic Bath & Leg Set 1700 x 700 mm'),(45334,121,5,6379,'premier-linton-square-acrylic-bath-leg-set-170cm-x-75cm'),(45335,121,0,6379,'premier-linton-square-acrylic-bath-leg-set-170cm-x-75cm'),(45336,84,5,6379,'Premier Linton Square Acrylic Bath & Leg Set 1700 x 750mm'),(45337,84,0,6379,'Premier Linton Square Acrylic Bath & Leg Set 1700 x 750mm'),(45338,86,5,6379,'Premier Linton Square Acrylic Bath & Leg Set 1700 x 750mm'),(45339,86,0,6379,'Premier Linton Square Acrylic Bath & Leg Set 1700 x 750mm'),(45340,73,5,6379,'Nuie Linton Square Acrylic Bath - 1700 x 750mm'),(45341,73,0,6379,'Nuie Linton Square Acrylic Bath - 1700 x 750mm'),(45342,109,5,6379,'Premier Linton Square Acrylic Bath & Leg Set 1700 x 750mm'),(45343,109,0,6379,'Premier Linton Square Acrylic Bath & Leg Set 1700 x 750mm'),(45344,121,5,6380,'premier-linton-square-acrylic-bath-leg-set-180-x-80cm'),(45345,121,0,6380,'premier-linton-square-acrylic-bath-leg-set-180-x-80cm'),(45346,84,5,6380,'Premier Linton Square Acrylic Bath & Leg Set 1800 x 800mm'),(45347,84,0,6380,'Premier Linton Square Acrylic Bath & Leg Set 1800 x 800mm'),(45348,86,5,6380,'Premier Linton Square Acrylic Bath & Leg Set 1800 x 800mm'),(45349,86,0,6380,'Premier Linton Square Acrylic Bath & Leg Set 1800 x 800mm'),(45350,73,5,6380,'Nuie Linton Square Acrylic Bath - 1800 x 800mm'),(45351,73,0,6380,'Nuie Linton Square Acrylic Bath - 1800 x 800mm'),(45352,109,5,6380,'Premier Linton Square Acrylic Bath & Leg Set 1800 x 800mm'),(45353,109,0,6380,'Premier Linton Square Acrylic Bath & Leg Set 1800 x 800mm'),(45354,121,5,6381,'premier-otley-round-acrylic-bath-with-leg-set-170cm-x-70cm'),(45355,121,0,6381,'premier-otley-round-acrylic-bath-with-leg-set-170cm-x-70cm'),(45356,84,5,6381,'Premier Otley Round Acrylic Bath with Leg Set 1700 x 700mm'),(45357,84,0,6381,'Premier Otley Round Acrylic Bath with Leg Set 1700 x 700mm'),(45358,86,5,6381,'Premier Otley Round Acrylic Bath with Leg Set 1700 x 700mm'),(45359,86,0,6381,'Premier Otley Round Acrylic Bath with Leg Set 1700 x 700mm'),(45360,73,5,6381,'Nuie Otley Round Acrylic Bath - 1700 x 700mm'),(45361,73,0,6381,'Nuie Otley Round Acrylic Bath - 1700 x 700mm'),(45362,109,5,6381,'Premier Otley Round Acrylic Bath with Leg Set 1700 x 700mm'),(45363,109,0,6381,'Premier Otley Round Acrylic Bath with Leg Set 1700 x 700mm'),(45364,121,5,6382,'premier-otley-round-acrylic-bath-with-leg-set-170cm-x-75cm'),(45365,121,0,6382,'premier-otley-round-acrylic-bath-with-leg-set-170cm-x-75cm'),(45366,84,5,6382,'Premier Otley Round Acrylic Bath with Leg Set 1700 x 750mm'),(45367,84,0,6382,'Premier Otley Round Acrylic Bath with Leg Set 1700 x 750mm'),(45368,86,5,6382,'Premier Otley Round Acrylic Bath with Leg Set 1700 x 750mm'),(45369,86,0,6382,'Premier Otley Round Acrylic Bath with Leg Set 1700 x 750mm'),(45370,73,5,6382,'Nuie Otley Round Acrylic Bath - 1700 x 750mm'),(45371,73,0,6382,'Nuie Otley Round Acrylic Bath - 1700 x 750mm'),(45372,109,5,6382,'Premier Otley Round Acrylic Bath with Leg Set 1700 x 750mm'),(45373,109,0,6382,'Premier Otley Round Acrylic Bath with Leg Set 1700 x 750mm'),(45374,121,5,6383,'premier-otley-round-acrylic-bath-with-leg-set-180cm-x-80cm'),(45375,121,0,6383,'premier-otley-round-acrylic-bath-with-leg-set-180cm-x-80cm'),(45376,84,5,6383,'Premier Otley Round Acrylic Bath with Leg Set 1800 x 800mm'),(45377,84,0,6383,'Premier Otley Round Acrylic Bath with Leg Set 1800 x 800mm'),(45378,86,5,6383,'Premier Otley Round Acrylic Bath with Leg Set 1800 x 800mm'),(45379,86,0,6383,'Premier Otley Round Acrylic Bath with Leg Set 1800 x 800mm'),(45380,73,5,6383,'Nuie Otley Round Acrylic Bath - 1800 x 800mm'),(45381,73,0,6383,'Nuie Otley Round Acrylic Bath - 1800 x 800mm'),(45382,109,5,6383,'Premier Otley Round Acrylic Bath with Leg Set 1800 x 800mm'),(45383,109,0,6383,'Premier Otley Round Acrylic Bath with Leg Set 1800 x 800mm'),(45384,121,5,6384,'rak-dkm-double-ended-easyflow-bath-1800mm-x-800mm'),(45385,121,0,6384,'rak-dkm-double-ended-easyflow-bath-1800mm-x-800mm'),(45386,84,5,6384,'RAK DKM Double Ended Easyflow White Acrylic Bath - NDKMBATH'),(45387,84,0,6384,'RAK DKM Double Ended Easyflow White Acrylic Bath - NDKMBATH'),(45388,86,5,6384,'Absolute Best deals on RAK DKM Double Ended Easyflow White Acrylic Bath NDKMBATH being offered at Banyo.Our Fastest Delivery system will deliver right to your door in no time.'),(45389,86,0,6384,'Absolute Best deals on RAK DKM Double Ended Easyflow White Acrylic Bath NDKMBATH being offered at Banyo.Our Fastest Delivery system will deliver right to your door in no time.'),(45390,73,5,6384,'RAK DKM Double Ended Easyflow Bath 1800mm x 800mm'),(45391,73,0,6384,'RAK DKM Double Ended Easyflow Bath 1800mm x 800mm'),(45392,109,5,6384,'RAK DKM Double Ended Easyflow Bath 1800mm x 800mm'),(45393,109,0,6384,'RAK DKM Double Ended Easyflow Bath 1800mm x 800mm'),(45394,121,5,6385,'rak-metropolitan-single-ended-easyflow-1800mm-x-800mm'),(45395,121,0,6385,'rak-metropolitan-single-ended-easyflow-1800mm-x-800mm'),(45396,84,5,6385,'RAK Metropolitan Single Ended Easyflow White Acrylic Bath - NMETBATH '),(45397,84,0,6385,'RAK Metropolitan Single Ended Easyflow White Acrylic Bath - NMETBATH '),(45398,86,5,6385,'RAK Metropolitan Single Ended Easyflow Acrylic Bath comes with a contemporary white finish is highly efficient and modern available at extremely low prices on banyo.'),(45399,86,0,6385,'RAK Metropolitan Single Ended Easyflow Acrylic Bath comes with a contemporary white finish is highly efficient and modern available at extremely low prices on banyo.'),(45400,73,5,6385,'RAK Metropolitan Single Ended Easyflow 1800mm x 800mm'),(45401,73,0,6385,'RAK Metropolitan Single Ended Easyflow 1800mm x 800mm'),(45402,109,5,6385,'RAK Metropolitan Single Ended Easyflow 1800mm x 800mm'),(45403,109,0,6385,'RAK Metropolitan Single Ended Easyflow 1800mm x 800mm'),(45404,121,5,6386,'rak-metropolitan-single-ended-bath-easyflow-1700mm-x-700mm-nmetbath'),(45405,121,0,6386,'rak-metropolitan-single-ended-bath-easyflow-1700mm-x-700mm-nmetbath'),(45406,84,5,6386,'RAK Metropolitan Single Ended Bath Easyflow 1700mm x 700mm'),(45407,84,0,6386,'RAK Metropolitan Single Ended Bath Easyflow 1700mm x 700mm'),(45408,86,5,6386,'Nothing beat the modern feeling and comfort generated by RAK Metropolitan Single Ended Easyflow White Acrylic Bath. Buy at Banyo with Manufacturer Guarantee and Great Discount.'),(45409,86,0,6386,'Nothing beat the modern feeling and comfort generated by RAK Metropolitan Single Ended Easyflow White Acrylic Bath. Buy at Banyo with Manufacturer Guarantee and Great Discount.'),(45410,73,5,6386,'RAK Metropolitan Single Ended Bath Easyflow 1700mm x 700mm'),(45411,73,0,6386,'RAK Metropolitan Single Ended Bath Easyflow 1700mm x 700mm'),(45412,109,5,6386,'RAK Metropolitan Single Ended Bath Easyflow 1700mm x 700mm'),(45413,109,0,6386,'RAK Metropolitan Single Ended Bath Easyflow 1700mm x 700mm'),(45414,121,5,6387,'rak-orient-single-ended-easyflow-bath-1700mm-x-745mm'),(45415,121,0,6387,'rak-orient-single-ended-easyflow-bath-1700mm-x-745mm'),(45416,84,5,6387,'RAK Orient Single Ended Easyflow White Acrylic Bath - NORIBATH'),(45417,84,0,6387,'RAK Orient Single Ended Easyflow White Acrylic Bath - NORIBATH'),(45418,86,5,6387,'Big Deals on RAK Orient Single Ended Easyflow White Acrylic Bath available at banyo. We guarantee that our prices are unbeatable in UK. Place an order now.'),(45419,86,0,6387,'Big Deals on RAK Orient Single Ended Easyflow White Acrylic Bath available at banyo. We guarantee that our prices are unbeatable in UK. Place an order now.'),(45420,73,5,6387,'RAK Orient Single Ended Easyflow Bath 1700mm x 745mm'),(45421,73,0,6387,'RAK Orient Single Ended Easyflow Bath 1700mm x 745mm'),(45422,109,5,6387,'RAK Orient Single Ended Easyflow Bath 1700mm x 745mm'),(45423,109,0,6387,'RAK Orient Single Ended Easyflow Bath 1700mm x 745mm'),(45424,121,5,6388,'roca-contesa-steel-bath-170cm-x-70cm-2370j-2370k'),(45425,121,0,6388,'roca-contesa-steel-bath-170cm-x-70cm-2370j-2370k'),(45426,84,5,6388,'Roca Contesa Steel Bath 1700mm | Single Ended Bath - Banyo'),(45427,84,0,6388,'Roca Contesa Steel Bath 1700mm | Single Ended Bath - Banyo'),(45428,86,5,6388,'We have an impressive range of Roca Contesa Steel Bath at extremely Low prices.  Roca Contesa bath offers durability, rigidity and easy installation. Place your order now.'),(45429,86,0,6388,'We have an impressive range of Roca Contesa Steel Bath at extremely Low prices.  Roca Contesa bath offers durability, rigidity and easy installation. Place your order now.'),(45430,73,5,6388,'Roca Contesa 1700 x 700mm Steel Bath - 2370J 2370K'),(45431,73,0,6388,'Roca Contesa 1700 x 700mm Steel Bath - 2370J 2370K'),(45432,109,5,6388,'Roca Contesa 1700 x 700mm Steel Bath - 2370J 2370K'),(45433,109,0,6388,'Roca Contesa 1700 x 700mm Steel Bath - 2370J 2370K'),(45434,121,5,6389,'roca-the-gap-acrylic-bath-170cm-x-70cm-no-th'),(45435,121,0,6389,'roca-the-gap-acrylic-bath-170cm-x-70cm-no-th'),(45436,84,5,6389,'Roca The Gap Acrylic Bath 170cm | 24717000 | Single Ended Bath'),(45437,84,0,6389,'Roca The Gap Acrylic Bath 170cm | 24717000 | Single Ended Bath'),(45438,86,5,6389,'We are offering amazing deals on Roca Gap Single Ended Acrylic Bath at banyo. We offer the things you love at the prices you afford. In case of any query please do not hesitate to contact us.'),(45439,86,0,6389,'We are offering amazing deals on Roca Gap Single Ended Acrylic Bath at banyo. We offer the things you love at the prices you afford. In case of any query please do not hesitate to contact us.'),(45440,73,5,6389,'Roca The Gap 1700 x 700mm Acrylic Bath - No TH'),(45441,73,0,6389,'Roca The Gap 1700 x 700mm Acrylic Bath - No TH'),(45442,109,5,6389,'Roca The Gap 1700 x 700mm Acrylic Bath - No TH'),(45443,109,0,6389,'Roca The Gap 1700 x 700mm Acrylic Bath - No TH'),(45444,121,5,6390,'roca-the-gap-acrylic-bath-170cm-x-75cm-no-th'),(45445,121,0,6390,'roca-the-gap-acrylic-bath-170cm-x-75cm-no-th'),(45446,84,5,6390,'Roca The Gap Acrylic Double Ended Bath 170cm | Banyo.co.uk'),(45447,84,0,6390,'Roca The Gap Acrylic Double Ended Bath 170cm | Banyo.co.uk'),(45448,86,5,6390,'Roca The Gap Double Ended Acrylic Bath Manufactured in the finest acrylic, the bath has a gracefully simple form and smoothness. Buy at banyo with Great Discount.'),(45449,86,0,6390,'Roca The Gap Double Ended Acrylic Bath Manufactured in the finest acrylic, the bath has a gracefully simple form and smoothness. Buy at banyo with Great Discount.'),(45450,73,5,6390,'Roca The Gap 1700 x 750mm Acrylic Bath - No TH'),(45451,73,0,6390,'Roca The Gap 1700 x 750mm Acrylic Bath - No TH'),(45452,109,5,6390,'Roca The Gap 1700 x 750mm Acrylic Bath - No TH'),(45453,109,0,6390,'Roca The Gap 1700 x 750mm Acrylic Bath - No TH'),(45454,121,5,6391,'roca-the-gap-single-ended-acrylic-bath-170cm-x-75cm-no-th'),(45455,121,0,6391,'roca-the-gap-single-ended-acrylic-bath-170cm-x-75cm-no-th'),(45456,84,5,6391,'Roca The Gap Single Ended Acrylic Bath 170cm x 75cm | Banyo'),(45457,84,0,6391,'Roca The Gap Single Ended Acrylic Bath 170cm x 75cm | Banyo'),(45458,86,5,6391,'Buy Roca The Gap Single Ended Acrylic Bath at best prices online. We offer the quality standards you love at the prices you afford. For a super fast delivery just buy from banyo.'),(45459,86,0,6391,'Buy Roca The Gap Single Ended Acrylic Bath at best prices online. We offer the quality standards you love at the prices you afford. For a super fast delivery just buy from banyo.'),(45460,73,5,6391,'Roca The Gap 1700 x 750mm Single Ended Acrylic Bath - No TH'),(45461,73,0,6391,'Roca The Gap 1700 x 750mm Single Ended Acrylic Bath - No TH'),(45462,109,5,6391,'Roca The Gap 1700 x 750mm Single Ended Acrylic Bath - No TH'),(45463,109,0,6391,'Roca The Gap 1700 x 750mm Single Ended Acrylic Bath - No TH'),(45464,121,5,6392,'bette-classic-super-steel-single-ended-bath'),(45465,121,0,6392,'bette-classic-super-steel-single-ended-bath'),(45466,84,5,6392,'Bette Classic Single Ended Bath - Super Steel Bathtubs | Banyo UK'),(45467,84,0,6392,'Bette Classic Single Ended Bath - Super Steel Bathtubs | Banyo UK'),(45468,86,5,6392,'Special Discount on Bette Classic Single Ended Bath is available on Banyo. We offer a wide range of  Super Steel Bathtubs with the affordable prices in the UK.\r\n'),(45469,86,0,6392,'Special Discount on Bette Classic Single Ended Bath is available on Banyo. We offer a wide range of  Super Steel Bathtubs with the affordable prices in the UK.\r\n'),(45470,73,5,6392,'Bette Classic Super Steel Single Ended Bath'),(45471,73,0,6392,'Bette Classic Super Steel Single Ended Bath'),(45472,109,5,6392,'Bette Classic Super Steel Single Ended Bath'),(45473,109,0,6392,'Bette Classic Super Steel Single Ended Bath'),(45474,121,5,6393,'bette-comodo-super-steel-bath-with-side-overflow'),(45475,121,0,6393,'bette-comodo-super-steel-bath-with-side-overflow'),(45476,84,5,6393,'Bette Comodo Bath - Super Steel Bathtubs with Side Overflow | Banyo'),(45477,84,0,6393,'Bette Comodo Bath - Super Steel Bathtubs with Side Overflow | Banyo'),(45478,86,5,6393,'Bette Comodo Super Steel Bathtubs with Side Overflow is available on Banyo at an affordable price & fast delivery service in the UK. Our Price Match Promise - Guaranteed to Beat any Price!'),(45479,86,0,6393,'Bette Comodo Super Steel Bathtubs with Side Overflow is available on Banyo at an affordable price & fast delivery service in the UK. Our Price Match Promise - Guaranteed to Beat any Price!'),(45480,73,5,6393,'Bette Comodo Super Steel Bath with Side Overflow'),(45481,73,0,6393,'Bette Comodo Super Steel Bath with Side Overflow'),(45482,109,5,6393,'Bette Comodo Super Steel Bath with Side Overflow'),(45483,109,0,6393,'Bette Comodo Super Steel Bath with Side Overflow'),(45484,121,5,6394,'bette-duett-super-steel-rectangular-bath'),(45485,121,0,6394,'bette-duett-super-steel-rectangular-bath'),(45486,84,5,6394,'Bette Duett Bath - Rectangular Inset Bath | Banyo'),(45487,84,0,6394,'Bette Duett Bath - Rectangular Inset Bath | Banyo'),(45488,86,5,6394,'Shop for Bette Duett Bath from Banyo at an affordable price and manufacturer warranty. We offer a wide range of Rectangular Inset Bathtubs with the lowest prices in the UK.'),(45489,86,0,6394,'Shop for Bette Duett Bath from Banyo at an affordable price and manufacturer warranty. We offer a wide range of Rectangular Inset Bathtubs with the lowest prices in the UK.'),(45490,73,5,6394,'Bette Duett Super Steel Rectangular Bath'),(45491,73,0,6394,'Bette Duett Super Steel Rectangular Bath'),(45492,109,5,6394,'Bette Duett Super Steel Rectangular Bath'),(45493,109,0,6394,'Bette Duett Super Steel Rectangular Bath'),(45494,121,5,6395,'bette-free-super-steel-double-ended-rectangular-bath'),(45495,121,0,6395,'bette-free-super-steel-double-ended-rectangular-bath'),(45496,84,5,6395,'Bette Free Bath - Rectangular Double Ended Super Steel Bathtubs | Banyo'),(45497,84,0,6395,'Bette Free Bath - Rectangular Double Ended Super Steel Bathtubs | Banyo'),(45498,86,5,6395,'Special Discount is available on the Bette Free Super Steel bath at Banyo. We offer a wide range of Double Ended Rectangular Bathtubs with the lowest prices in the UK.'),(45499,86,0,6395,'Special Discount is available on the Bette Free Super Steel bath at Banyo. We offer a wide range of Double Ended Rectangular Bathtubs with the lowest prices in the UK.'),(45500,73,5,6395,'Bette Free Super Steel Double Ended Rectangular Bath'),(45501,73,0,6395,'Bette Free Super Steel Double Ended Rectangular Bath'),(45502,109,5,6395,'Bette Free Super Steel Double Ended Rectangular Bath'),(45503,109,0,6395,'Bette Free Super Steel Double Ended Rectangular Bath'),(45504,121,5,6396,'bette-ocean-lowline-super-steel-single-ended-bath'),(45505,121,0,6396,'bette-ocean-lowline-super-steel-single-ended-bath'),(45506,84,5,6396,'Bette Ocean Lowline Bath - Single Ended Steel Bathtubs | Banyo'),(45507,84,0,6396,'Bette Ocean Lowline Bath - Single Ended Steel Bathtubs | Banyo'),(45508,86,5,6396,'Bette Ocean Lowline Bath is available on Banyo with affordable price and fast delivery service in the UK. We offer Single Ended Steel Bathtubs with the lowest prices.'),(45509,86,0,6396,'Bette Ocean Lowline Bath is available on Banyo with affordable price and fast delivery service in the UK. We offer Single Ended Steel Bathtubs with the lowest prices.'),(45510,73,5,6396,'Bette Ocean Lowline Super Steel Single Ended Bath'),(45511,73,0,6396,'Bette Ocean Lowline Super Steel Single Ended Bath'),(45512,109,5,6396,'Bette Ocean Lowline Super Steel Single Ended Bath'),(45513,109,0,6396,'Bette Ocean Lowline Super Steel Single Ended Bath'),(45514,110,5,6396,'Bette Ocean Lowline Super Steel Single Ended Bath'),(45515,110,0,6396,'Bette Ocean Lowline Super Steel Single Ended Bath'),(45516,111,5,6396,'Bette Ocean Lowline Super Steel Single Ended Bath'),(45517,111,0,6396,'Bette Ocean Lowline Super Steel Single Ended Bath'),(45518,121,5,6397,'bette-one-super-steel-double-ended-bath'),(45519,121,0,6397,'bette-one-super-steel-double-ended-bath'),(45520,84,5,6397,'Bette One Super Steel Bath - Double Ended Bathtubs | Banyo UK'),(45521,84,0,6397,'Bette One Super Steel Bath - Double Ended Bathtubs | Banyo UK'),(45522,86,5,6397,'Special discounted price is available on Bette One Super Steel Bath at Banyo. We offer High-Quality Double Ended Bathtubs with the lowest prices in the UK.'),(45523,86,0,6397,'Special discounted price is available on Bette One Super Steel Bath at Banyo. We offer High-Quality Double Ended Bathtubs with the lowest prices in the UK.'),(45524,73,5,6397,'Bette One Super Steel Double Ended Bath'),(45525,73,0,6397,'Bette One Super Steel Double Ended Bath'),(45526,109,5,6397,'Bette One Super Steel Double Ended Bath'),(45527,109,0,6397,'Bette One Super Steel Double Ended Bath'),(45528,121,5,6398,'bette-one-relax-super-steel-single-ended-bath'),(45529,121,0,6398,'bette-one-relax-super-steel-single-ended-bath'),(45530,84,5,6398,'Bette One Relax Super Steel Bath - Single Ended Bathtubs | Banyo'),(45531,84,0,6398,'Bette One Relax Super Steel Bath - Single Ended Bathtubs | Banyo'),(45532,86,5,6398,'All sizes of Bette One Relax Super Steel Bath available at Banyo. We offer affordable prices on all Single Ended Bathtubs and fast delivery service in the UK.'),(45533,86,0,6398,'All sizes of Bette One Relax Super Steel Bath available at Banyo. We offer affordable prices on all Single Ended Bathtubs and fast delivery service in the UK.'),(45534,73,5,6398,'Bette One Relax Super Steel Single Ended Bath'),(45535,73,0,6398,'Bette One Relax Super Steel Single Ended Bath'),(45536,109,5,6398,'Bette One Relax Super Steel Single Ended Bath'),(45537,109,0,6398,'Bette One Relax Super Steel Single Ended Bath'),(45538,121,5,6399,'bette-starlet-flair-oval-super-steel-double-ended-bath'),(45539,121,0,6399,'bette-starlet-flair-oval-super-steel-double-ended-bath'),(45540,84,5,6399,'Bette Starlet Flair Oval Bath - Double Ended Steel Bathtubs | Banyo UK'),(45541,84,0,6399,'Bette Starlet Flair Oval Bath - Double Ended Steel Bathtubs | Banyo UK'),(45542,86,5,6399,'All Sizes of Bette Starlet Flair Oval Bath available on Banyo. We offer the lowest prices on all Double Ended Steel Bathtubs with fast delivery all across the UK.'),(45543,86,0,6399,'All Sizes of Bette Starlet Flair Oval Bath available on Banyo. We offer the lowest prices on all Double Ended Steel Bathtubs with fast delivery all across the UK.'),(45544,73,5,6399,'Bette Starlet Flair Oval Super Steel Double Ended Bath'),(45545,73,0,6399,'Bette Starlet Flair Oval Super Steel Double Ended Bath'),(45546,109,5,6399,'Bette Starlet Flair Oval Super Steel Double Ended Bath'),(45547,109,0,6399,'Bette Starlet Flair Oval Super Steel Double Ended Bath'),(45548,121,5,6400,'bette-starlet-iv-silhouette-steel-double-ended-bath'),(45549,121,0,6400,'bette-starlet-iv-silhouette-steel-double-ended-bath'),(45550,84,5,6400,'Bette Starlet IV Silhouette - Steel Double Ended White Bath | Banyo'),(45551,84,0,6400,'Bette Starlet IV Silhouette - Steel Double Ended White Bath | Banyo'),(45552,86,5,6400,'Bette Starlet IV Silhouette is a Steel Enamel Double Ended Bath with white finish and is available on Banyo with affordable price and fast delivery service in the UK.'),(45553,86,0,6400,'Bette Starlet IV Silhouette is a Steel Enamel Double Ended Bath with white finish and is available on Banyo with affordable price and fast delivery service in the UK.'),(45554,73,5,6400,'Bette Starlet IV Silhouette Steel Double Ended Bath'),(45555,73,0,6400,'Bette Starlet IV Silhouette Steel Double Ended Bath'),(45556,109,5,6400,'Bette Starlet IV Silhouette Steel Double Ended Bath'),(45557,109,0,6400,'Bette Starlet IV Silhouette Steel Double Ended Bath'),(45558,121,5,6401,'bette-starlet-oval-super-steel-double-ended-bath'),(45559,121,0,6401,'bette-starlet-oval-super-steel-double-ended-bath'),(45560,84,5,6401,'Bette Starlet Oval Bath - Double Ended Super Steel Bathtubs | Banyo'),(45561,84,0,6401,'Bette Starlet Oval Bath - Double Ended Super Steel Bathtubs | Banyo'),(45562,86,5,6401,'We offer a wide range of high quality Bette Baths with the lowest prices in the UK. Special discount on offer for Starlet Oval bathtubs. For more info contact us 0116 274 4059.'),(45563,86,0,6401,'We offer a wide range of high quality Bette Baths with the lowest prices in the UK. Special discount on offer for Starlet Oval bathtubs. For more info contact us 0116 274 4059.'),(45564,73,5,6401,'Bette Starlet Oval Super Steel Double Ended Bath'),(45565,73,0,6401,'Bette Starlet Oval Super Steel Double Ended Bath'),(45566,109,5,6401,'Bette Starlet Oval Super Steel Double Ended Bath'),(45567,109,0,6401,'Bette Starlet Oval Super Steel Double Ended Bath'),(45568,121,5,6402,'bette-starlet-v-silhouette-steel-double-ended-bath'),(45569,121,0,6402,'bette-starlet-v-silhouette-steel-double-ended-bath'),(45570,84,5,6402,'Bette Starlet V Silhouette Bath- Double Ended Steel Baths | Banyo'),(45571,84,0,6402,'Bette Starlet V Silhouette Bath- Double Ended Steel Baths | Banyo'),(45572,86,5,6402,'Bette Starlet V Silhouette is a Double Ended Steel Bath available in all sizes and styles on Banyo at an affordable price and fastest delivery service in the UK.'),(45573,86,0,6402,'Bette Starlet V Silhouette is a Double Ended Steel Bath available in all sizes and styles on Banyo at an affordable price and fastest delivery service in the UK.'),(45574,73,5,6402,'Bette Starlet V Silhouette Steel Double Ended Bath'),(45575,73,0,6402,'Bette Starlet V Silhouette Steel Double Ended Bath'),(45576,109,5,6402,'Bette Starlet V Silhouette Steel Double Ended Bath'),(45577,109,0,6402,'Bette Starlet V Silhouette Steel Double Ended Bath'),(45578,121,5,6403,'roca-lun-plus-steel-bath-with-1700-x-750mm-anti-slip'),(45579,121,0,6403,'roca-lun-plus-steel-bath-with-1700-x-750mm-anti-slip'),(45580,84,5,6403,'Roca Lun Plus Steel Bath with Anti-Slip 1700 x 750mm'),(45581,84,0,6403,'Roca Lun Plus Steel Bath with Anti-Slip 1700 x 750mm'),(45582,86,5,6403,'Roca Lun Plus Steel Bath with Anti-Slip 1700 x 750mm'),(45583,86,0,6403,'Roca Lun Plus Steel Bath with Anti-Slip 1700 x 750mm'),(45584,73,5,6403,'Roca Lun Plus Steel Bath with 1700 x 750mm -  Anti-Slip'),(45585,73,0,6403,'Roca Lun Plus Steel Bath with 1700 x 750mm -  Anti-Slip'),(45586,121,5,6404,'roca-carla-steel-bath-with-2-tap-hole-160cm-x-70cm'),(45587,121,0,6404,'roca-carla-steel-bath-with-2-tap-hole-160cm-x-70cm'),(45588,84,5,6404,'Roca Carla Steel Bath Tub 1600mm | Rectangular Shape | 2 TH'),(45589,84,0,6404,'Roca Carla Steel Bath Tub 1600mm | Rectangular Shape | 2 TH'),(45590,86,5,6404,'Special Discount Being offered on Roca Carla Steel Bath with Anti-Slip Base at Banyo. We Offer Great Discount, Manufacturer Guarantee and Fastest Delivery Services across UK.'),(45591,86,0,6404,'Special Discount Being offered on Roca Carla Steel Bath with Anti-Slip Base at Banyo. We Offer Great Discount, Manufacturer Guarantee and Fastest Delivery Services across UK.'),(45592,73,5,6404,'Roca Carla Steel Bath 1600 x 700mm - 2 Tap Hole'),(45593,73,0,6404,'Roca Carla Steel Bath 1600 x 700mm - 2 Tap Hole'),(45594,109,5,6404,'Roca Carla Steel Bath 1600 x 700mm - 2 Tap Hole'),(45595,109,0,6404,'Roca Carla Steel Bath 1600 x 700mm - 2 Tap Hole'),(45596,121,5,6405,'bette-labette-super-steel-bath-108-x-73cm-feet-no-th'),(45597,121,0,6405,'bette-labette-super-steel-bath-108-x-73cm-feet-no-th'),(45598,84,5,6405,'Bette Labette Super Steel Bath 1080 x 730 | BE1080-000 - Bette Labette'),(45599,84,0,6405,'Bette Labette Super Steel Bath 1080 x 730 | BE1080-000 - Bette Labette'),(45600,86,5,6405,'Bette Labette : we Banyo Uk offer a special discounted price on Bette Labette 1080 x 730 bath with the manufacturer warranty. We offer a full range of Super Steel Baths with lowest prices.\r\n\r\n\r\n'),(45601,86,0,6405,'Bette Labette : we Banyo Uk offer a special discounted price on Bette Labette 1080 x 730 bath with the manufacturer warranty. We offer a full range of Super Steel Baths with lowest prices.\r\n\r\n\r\n'),(45602,73,5,6405,'Bette Labette Super Steel Bath 1080 x 730mm - No TH'),(45603,73,0,6405,'Bette Labette Super Steel Bath 1080 x 730mm - No TH'),(45604,109,5,6405,'Bette Labette Super Steel Bath 1080 x 730mm - No TH'),(45605,109,0,6405,'Bette Labette Super Steel Bath 1080 x 730mm - No TH'),(45606,121,5,6406,'bette-labette-super-steel-bath-1180-x-730mm-no-th'),(45607,121,0,6406,'bette-labette-super-steel-bath-1180-x-730mm-no-th'),(45608,84,5,6406,'Bette Labette 1180 x 730 - Super Steel Bath | Banyo UK'),(45609,84,0,6406,'Bette Labette 1180 x 730 - Super Steel Bath | Banyo UK'),(45610,86,5,6406,'Bette Labette 1180 x 730 is a Single Ended Super Steel Bath available on Banyo with a special price discount. We offer the best prices and fastest delivery service all across the UK.'),(45611,86,0,6406,'Bette Labette 1180 x 730 is a Single Ended Super Steel Bath available on Banyo with a special price discount. We offer the best prices and fastest delivery service all across the UK.'),(45612,73,5,6406,'Bette Labette Super Steel Bath 1180 x 730mm'),(45613,73,0,6406,'Bette Labette Super Steel Bath 1180 x 730mm'),(45614,109,5,6406,'Bette Labette Super Steel Bath 1180 x 730mm - No TH'),(45615,109,0,6406,'Bette Labette Super Steel Bath 1180 x 730mm - No TH'),(45616,121,5,6407,'bette-labette-super-steel-bath-1200-x-700mm'),(45617,121,0,6407,'bette-labette-super-steel-bath-1200-x-700mm'),(45618,84,5,6407,'Bette Labette Super Steel Bath 1200 x 700 | Banyo UK'),(45619,84,0,6407,'Bette Labette Super Steel Bath 1200 x 700 | Banyo UK'),(45620,86,5,6407,'Shop for Bette Labette Super Steel Bath 1200 x 700 from Banyo.co.uk with the lowest price in the UK. For affordable prices on Single Ended Baths visit our online store today!'),(45621,86,0,6407,'Shop for Bette Labette Super Steel Bath 1200 x 700 from Banyo.co.uk with the lowest price in the UK. For affordable prices on Single Ended Baths visit our online store today!'),(45622,73,5,6407,'Bette Labette Super Steel Bath 1200 x 700mm '),(45623,73,0,6407,'Bette Labette Super Steel Bath 1200 x 700mm '),(45624,109,5,6407,'Bette Labette Super Steel Bath 1200 x 700mm '),(45625,109,0,6407,'Bette Labette Super Steel Bath 1200 x 700mm '),(45626,121,5,6408,'bette-starlet-super-steel-bath-1500-x-800mm-no-th'),(45627,121,0,6408,'bette-starlet-super-steel-bath-1500-x-800mm-no-th'),(45628,84,5,6408,'Bette Starlet Oval 1500 x 800mm - Double Ended Steel Bath | Banyo'),(45629,84,0,6408,'Bette Starlet Oval 1500 x 800mm - Double Ended Steel Bath | Banyo'),(45630,86,5,6408,'Special discounted price available on Bette Starlet Oval 1500 x 800mm on Banyo. We offer an extensive range of Double Ended Steel Baths with the lowest prices in the UK.'),(45631,86,0,6408,'Special discounted price available on Bette Starlet Oval 1500 x 800mm on Banyo. We offer an extensive range of Double Ended Steel Baths with the lowest prices in the UK.'),(45632,73,5,6408,'Bette Starlet Super Steel Bath 1500 x 800mm - No TH'),(45633,73,0,6408,'Bette Starlet Super Steel Bath 1500 x 800mm - No TH'),(45634,109,5,6408,'Bette Starlet Super Steel Bath 1500 x 800mm - No TH'),(45635,109,0,6408,'Bette Starlet Super Steel Bath 1500 x 800mm - No TH'),(45636,121,5,6409,'bette-starlet-super-steel-bath-1600-x-700mm'),(45637,121,0,6409,'bette-starlet-super-steel-bath-1600-x-700mm'),(45638,84,5,6409,'Bette Starlet 1600 x 700mm Bath - Rectangular Steel Bath | Banyo'),(45639,84,0,6409,'Bette Starlet 1600 x 700mm Bath - Rectangular Steel Bath | Banyo'),(45640,86,5,6409,'Banyo offers special price discount on Bette Starlet 1600 x 700mm Double Ended Steel Bath. We offer the lowest prices in the UK for more info on Bette Starlet contact 0116 274 4059.'),(45641,86,0,6409,'Banyo offers special price discount on Bette Starlet 1600 x 700mm Double Ended Steel Bath. We offer the lowest prices in the UK for more info on Bette Starlet contact 0116 274 4059.'),(45642,73,5,6409,'Bette Starlet Super Steel Bath 1600 x 700mm '),(45643,73,0,6409,'Bette Starlet Super Steel Bath 1600 x 700mm '),(45644,109,5,6409,'Bette Starlet Super Steel Bath 1600 x 700mm '),(45645,109,0,6409,'Bette Starlet Super Steel Bath 1600 x 700mm '),(45646,121,5,6410,'bette-starlet-super-steel-bath-1650-x-700mm'),(45647,121,0,6410,'bette-starlet-super-steel-bath-1650-x-700mm'),(45648,84,5,6410,'Bette Starlet 1650 x 700mm Bath - Oval Steel Enamel Bathtubs | Banyo'),(45649,84,0,6410,'Bette Starlet 1650 x 700mm Bath - Oval Steel Enamel Bathtubs | Banyo'),(45650,86,5,6410,'Buy Bette Starlet Oval Bath 165 x 70cm from Banyo with a special price discount. We offer a wide range of Steel Enamelled Bathtubs, lowest prices Guaranteed!'),(45651,86,0,6410,'Buy Bette Starlet Oval Bath 165 x 70cm from Banyo with a special price discount. We offer a wide range of Steel Enamelled Bathtubs, lowest prices Guaranteed!'),(45652,73,5,6410,'Bette Starlet Super Steel Bath 1650 x 700mm '),(45653,73,0,6410,'Bette Starlet Super Steel Bath 1650 x 700mm '),(45654,109,5,6410,'Bette Starlet Super Steel Bath 1650 x 700mm '),(45655,109,0,6410,'Bette Starlet Super Steel Bath 1650 x 700mm '),(45656,121,5,6411,'bette-labette-super-steel-bath-1240-x-700mm-no-th'),(45657,121,0,6411,'bette-labette-super-steel-bath-1240-x-700mm-no-th'),(45658,84,5,6411,'Bette Labette Super Steel Bath 1240 x 700 | Banyo UK'),(45659,84,0,6411,'Bette Labette Super Steel Bath 1240 x 700 | Banyo UK'),(45660,86,5,6411,'Banyo offers special discount on Bette Labette Super Steel Bath 124x70 cm with manufacturer warranty & fast delivery in the UK. We offer a full range of Steel Enamel baths with affordable prices.'),(45661,86,0,6411,'Banyo offers special discount on Bette Labette Super Steel Bath 124x70 cm with manufacturer warranty & fast delivery in the UK. We offer a full range of Steel Enamel baths with affordable prices.'),(45662,73,5,6411,'Bette Labette Super Steel Bath 1240 x 700mm - No TH'),(45663,73,0,6411,'Bette Labette Super Steel Bath 1240 x 700mm - No TH'),(45664,109,5,6411,'Bette Labette Super Steel Bath 1240 x 700mm - No TH'),(45665,109,0,6411,'Bette Labette Super Steel Bath 1240 x 700mm - No TH'),(45666,121,5,6412,'bette-comodo-super-steel-bath-1700-750mm-no-th'),(45667,121,0,6412,'bette-comodo-super-steel-bath-1700-750mm-no-th'),(45668,84,5,6412,'Bette Comodo 1700 x 750 - Single Ended Steel Bath | Banyo'),(45669,84,0,6412,'Bette Comodo 1700 x 750 - Single Ended Steel Bath | Banyo'),(45670,86,5,6412,'At Banyo, we offer a special discounted price on Bette Comodo 1700 x 750 bath. We offer a wide range of Single Ended Steel Bathtubs with affordable prices & Fast delivery in the UK.'),(45671,86,0,6412,'At Banyo, we offer a special discounted price on Bette Comodo 1700 x 750 bath. We offer a wide range of Single Ended Steel Bathtubs with affordable prices & Fast delivery in the UK.'),(45672,73,5,6412,'Bette Comodo Super Steel Bath 1700 x 750mm - No TH'),(45673,73,0,6412,'Bette Comodo Super Steel Bath 1700 x 750mm - No TH'),(45674,109,5,6412,'Bette Comodo Super Steel Bath 1700 x 750mm - No TH'),(45675,109,0,6412,'Bette Comodo Super Steel Bath 1700 x 750mm - No TH'),(45676,121,5,6413,'bette-classic-super-steel-bath-180-x-80cm'),(45677,121,0,6413,'bette-classic-super-steel-bath-180-x-80cm'),(45678,84,5,6413,'Bette Classic 1800 x 800 - White Inset Steel bath | Banyo'),(45679,84,0,6413,'Bette Classic 1800 x 800 - White Inset Steel bath | Banyo'),(45680,86,5,6413,'Special discount price on Bette Classic 1800 x 800 with the White finish and is available on Banyo. We offer a wide range of Inset Steel baths with the lowest prices in the UK. '),(45681,86,0,6413,'Special discount price on Bette Classic 1800 x 800 with the White finish and is available on Banyo. We offer a wide range of Inset Steel baths with the lowest prices in the UK. '),(45682,73,5,6413,'Bette Classic Super Steel Bath 180 x 80cm '),(45683,73,0,6413,'Bette Classic Super Steel Bath 180 x 80cm '),(45684,109,5,6413,'Bette Classic Super Steel Bath 180 x 80cm '),(45685,109,0,6413,'Bette Classic Super Steel Bath 180 x 80cm '),(45686,121,5,6414,'bette-classic-super-steel-bath-180-x-70cm'),(45687,121,0,6414,'bette-classic-super-steel-bath-180-x-70cm'),(45688,84,5,6414,'Bette Classic Rectangular Super Steel bath 1800 x 700mm | Banyo'),(45689,84,0,6414,'Bette Classic Rectangular Super Steel bath 1800 x 700mm | Banyo'),(45690,86,5,6414,'At Banyo, we offer a wide range of Bette Steel baths with special discounts. Shop for Bette Classic Rectangular Super Steel bath 1800 x 700mm with the lowest price in the UK.'),(45691,86,0,6414,'At Banyo, we offer a wide range of Bette Steel baths with special discounts. Shop for Bette Classic Rectangular Super Steel bath 1800 x 700mm with the lowest price in the UK.'),(45692,73,5,6414,'Bette Classic Super Steel Bath 180 x 70cm '),(45693,73,0,6414,'Bette Classic Super Steel Bath 180 x 70cm '),(45694,109,5,6414,'Bette Classic Super Steel Bath 180 x 70cm '),(45695,109,0,6414,'Bette Classic Super Steel Bath 180 x 70cm '),(45696,121,5,6415,'bette-classic-super-steel-bath-180-x-75cm'),(45697,121,0,6415,'bette-classic-super-steel-bath-180-x-75cm'),(45698,84,5,6415,'Bette Classic Bath 1800 x 750 - Rectangular White Steel Bath | Banyo'),(45699,84,0,6415,'Bette Classic Bath 1800 x 750 - Rectangular White Steel Bath | Banyo'),(45700,86,5,6415,'Bette 1800x750 classic rectangular bath with white finish is available on Banyo with exclusive discounted price. Full range of Bette Steel Baths available with the lowest prices in the UK.'),(45701,86,0,6415,'Bette 1800x750 classic rectangular bath with white finish is available on Banyo with exclusive discounted price. Full range of Bette Steel Baths available with the lowest prices in the UK.'),(45702,73,5,6415,'Bette Classic Super Steel Bath 180 x 75cm '),(45703,73,0,6415,'Bette Classic Super Steel Bath 180 x 75cm '),(45704,109,5,6415,'Bette Classic Super Steel Bath 180 x 75cm '),(45705,109,0,6415,'Bette Classic Super Steel Bath 180 x 75cm '),(45706,121,5,6416,'bette-labette-super-steel-bath-1300-x-700mm'),(45707,121,0,6416,'bette-labette-super-steel-bath-1300-x-700mm'),(45708,84,5,6416,'Bette Labette Super Steel Bath 1300 x 700 | Banyo UK'),(45709,84,0,6416,'Bette Labette Super Steel Bath 1300 x 700 | Banyo UK'),(45710,86,5,6416,'Special discount on Bette Labette Super Steel Bath 1300 x 700 available at Banyo. We offer the best prices and fast delivery service all across the UK.'),(45711,86,0,6416,'Special discount on Bette Labette Super Steel Bath 1300 x 700 available at Banyo. We offer the best prices and fast delivery service all across the UK.'),(45712,73,5,6416,'Bette Labette Super Steel Bath 1300 x 700mm '),(45713,73,0,6416,'Bette Labette Super Steel Bath 1300 x 700mm '),(45714,109,5,6416,'Bette Labette Super Steel Bath 1300 x 700mm '),(45715,109,0,6416,'Bette Labette Super Steel Bath 1300 x 700mm '),(45716,121,5,6417,'bette-starlet-super-steel-bath-170-x-75cm-feet'),(45717,121,0,6417,'bette-starlet-super-steel-bath-170-x-75cm-feet'),(45718,84,5,6417,'Bette Starlet Super Steel Bath 1700 x 750mm - Bette Starlet Double Ended Steel Bath'),(45719,84,0,6417,'Bette Starlet Super Steel Bath 1700 x 750mm - Bette Starlet Double Ended Steel Bath'),(45720,86,5,6417,'Bette Starlet Super Steel Bath 1700 x 750mm stands out with its inside Oval shape. Bette Starlet, this double ended bath comes with a central waste and is perfect for extreme'),(45721,86,0,6417,'Bette Starlet Super Steel Bath 1700 x 750mm stands out with its inside Oval shape. Bette Starlet, this double ended bath comes with a central waste and is perfect for extreme'),(45722,73,5,6417,'Bette Starlet Super Steel Bath 1700 x 750mm '),(45723,73,0,6417,'Bette Starlet Super Steel Bath 1700 x 750mm '),(45724,109,5,6417,'Bette Starlet Super Steel Bath 1700 x 750mm '),(45725,109,0,6417,'Bette Starlet Super Steel Bath 1700 x 750mm '),(45726,121,5,6418,'bette-starlet-super-steel-bath-1800-x-750mm-no-th'),(45727,121,0,6418,'bette-starlet-super-steel-bath-1800-x-750mm-no-th'),(45728,84,5,6418,'Bette Starlet 1800 x 750mm - Steel Enamel Bath | Banyo'),(45729,84,0,6418,'Bette Starlet 1800 x 750mm - Steel Enamel Bath | Banyo'),(45730,86,5,6418,'Bette Starlet 1800 x 750mm Steel Enamel Bath is a uniquely designed steel bath with Built-in Oval Shape, Bette Starlet 1800x750mm is a Double Ended Bath and is available with a special price discount.'),(45731,86,0,6418,'Bette Starlet 1800 x 750mm Steel Enamel Bath is a uniquely designed steel bath with Built-in Oval Shape, Bette Starlet 1800x750mm is a Double Ended Bath and is available with a special price discount.'),(45732,73,5,6418,'Bette Starlet Super Steel Bath 1800 x 750mm - No TH'),(45733,73,0,6418,'Bette Starlet Super Steel Bath 1800 x 750mm - No TH'),(45734,109,5,6418,'Bette Starlet Super Steel Bath 1800 x 750mm - No TH'),(45735,109,0,6418,'Bette Starlet Super Steel Bath 1800 x 750mm - No TH'),(45736,121,5,6419,'bette-starlet-super-steel-bath-1750-x-800mm'),(45737,121,0,6419,'bette-starlet-super-steel-bath-1750-x-800mm'),(45738,84,5,6419,'Bette Starlet 1750 x 800mm - Super Steel Rectangular Bath | Banyo'),(45739,84,0,6419,'Bette Starlet 1750 x 800mm - Super Steel Rectangular Bath | Banyo'),(45740,86,5,6419,'Buy Bette Starlet 1750 x 800mm with a special price discount only on Banyo. This Super Steel Rectangular shape Bath is available with Centrally Positioned Drain. For more info contact 0116 274 4059.'),(45741,86,0,6419,'Buy Bette Starlet 1750 x 800mm with a special price discount only on Banyo. This Super Steel Rectangular shape Bath is available with Centrally Positioned Drain. For more info contact 0116 274 4059.'),(45742,73,5,6419,'Bette Starlet Super Steel Bath 1750 x 800mm '),(45743,73,0,6419,'Bette Starlet Super Steel Bath 1750 x 800mm '),(45744,109,5,6419,'Bette Starlet Super Steel Bath 1750 x 800mm '),(45745,109,0,6419,'Bette Starlet Super Steel Bath 1750 x 800mm '),(45746,121,5,6420,'bette-starlet-super-steel-bath-1800-x-800mm'),(45747,121,0,6420,'bette-starlet-super-steel-bath-1800-x-800mm'),(45748,84,5,6420,'Bette Starlet 180 x 80 - Bette Super Steel Bath | Banyo'),(45749,84,0,6420,'Bette Starlet 180 x 80 - Bette Super Steel Bath | Banyo'),(45750,86,5,6420,'Buy Bette Starlet 180 x 80 with a special price discount and 30years manufacturer warranty from Banyo. Bette Super Steel Bath with a unique BETTEGLAZE enamel finish. For more info 0116 274 4059.'),(45751,86,0,6420,'Buy Bette Starlet 180 x 80 with a special price discount and 30years manufacturer warranty from Banyo. Bette Super Steel Bath with a unique BETTEGLAZE enamel finish. For more info 0116 274 4059.'),(45752,73,5,6420,'Bette Starlet Super Steel Bath 1800 x 800mm '),(45753,73,0,6420,'Bette Starlet Super Steel Bath 1800 x 800mm '),(45754,109,5,6420,'Bette Starlet Super Steel Bath 1800 x 800mm '),(45755,109,0,6420,'Bette Starlet Super Steel Bath 1800 x 800mm '),(45756,121,5,6421,'bette-starlet-super-steel-bath-1700-x-700mm-no-th'),(45757,121,0,6421,'bette-starlet-super-steel-bath-1700-x-700mm-no-th'),(45758,84,5,6421,'Bette Starlet 1700x700mm - Super Steel Bath | Banyo'),(45759,84,0,6421,'Bette Starlet 1700x700mm - Super Steel Bath | Banyo'),(45760,86,5,6421,'Buy Bette Starlet 1700x700mm from Banyo with special discounted price. Bette Super Steel Baths are available in a wide range with the lowest prices in the UK for more info 0116 274 4059.'),(45761,86,0,6421,'Buy Bette Starlet 1700x700mm from Banyo with special discounted price. Bette Super Steel Baths are available in a wide range with the lowest prices in the UK for more info 0116 274 4059.'),(45762,73,5,6421,'Bette Starlet Super Steel Bath 1700 x 700mm - No TH'),(45763,73,0,6421,'Bette Starlet Super Steel Bath 1700 x 700mm - No TH'),(45764,109,5,6421,'Bette Starlet Super Steel Bath 1700 x 700mm - No TH'),(45765,109,0,6421,'Bette Starlet Super Steel Bath 1700 x 700mm - No TH'),(45766,121,5,6422,'bette-starlet-super-steel-bath-1900-x-900mm'),(45767,121,0,6422,'bette-starlet-super-steel-bath-1900-x-900mm'),(45768,84,5,6422,'Bette Starlet 190x90cm - Rectangular Super Steel Bath | Banyo'),(45769,84,0,6422,'Bette Starlet 190x90cm - Rectangular Super Steel Bath | Banyo'),(45770,86,5,6422,'Shop for Bette Starlet 190x90cm Rectangular Super Steel Bath from Banyo with special price discount and fast delivery service all across the UK. All sizes & styles of Bette Starlet available.'),(45771,86,0,6422,'Shop for Bette Starlet 190x90cm Rectangular Super Steel Bath from Banyo with special price discount and fast delivery service all across the UK. All sizes & styles of Bette Starlet available.'),(45772,73,5,6422,'Bette Starlet Super Steel Bath 1900 x 900mm '),(45773,73,0,6422,'Bette Starlet Super Steel Bath 1900 x 900mm '),(45774,109,5,6422,'Bette Starlet Super Steel Bath 1900 x 900mm '),(45775,109,0,6422,'Bette Starlet Super Steel Bath 1900 x 900mm '),(45776,121,5,6423,'bette-starlet-super-steel-bath-1600-x-650mm-no-th'),(45777,121,0,6423,'bette-starlet-super-steel-bath-1600-x-650mm-no-th'),(45778,84,5,6423,'Bette Starlet 1600x650mm - Double ended bath | Banyo'),(45779,84,0,6423,'Bette Starlet 1600x650mm - Double ended bath | Banyo'),(45780,86,5,6423,'Buy Bette Starlet 1600x650mm from Banyo with a special price discount. We offer a complete range of Bette Double ended bath with the lowest prices in the UK.'),(45781,86,0,6423,'Buy Bette Starlet 1600x650mm from Banyo with a special price discount. We offer a complete range of Bette Double ended bath with the lowest prices in the UK.'),(45782,73,5,6423,'Bette Starlet Super Steel Bath 1600 x 650mm - No TH'),(45783,73,0,6423,'Bette Starlet Super Steel Bath 1600 x 650mm - No TH'),(45784,109,5,6423,'Bette Starlet Super Steel Bath 1600 x 650mm - No TH'),(45785,109,0,6423,'Bette Starlet Super Steel Bath 1600 x 650mm - No TH'),(45786,121,5,6424,'bette-set-super-steel-bath-150-x-75cm-feet'),(45787,121,0,6424,'bette-set-super-steel-bath-150-x-75cm-feet'),(45788,84,5,6424,'Bette Set 1500 x 750 - Super Steel Single Ended Bath | Banyo'),(45789,84,0,6424,'Bette Set 1500 x 750 - Super Steel Single Ended Bath | Banyo'),(45790,86,5,6424,'Special discounted price on Bette Set Bath 1500 x 750mm on Banyo. We offer a full range of Super Steel Single Ended Baths with lowest prices in the UK for more info 0116 274 4059.\r\n'),(45791,86,0,6424,'Special discounted price on Bette Set Bath 1500 x 750mm on Banyo. We offer a full range of Super Steel Single Ended Baths with lowest prices in the UK for more info 0116 274 4059.\r\n'),(45792,73,5,6424,'Bette Set Super Steel Bath 1500 x 750mm '),(45793,73,0,6424,'Bette Set Super Steel Bath 1500 x 750mm '),(45794,109,5,6424,'Bette Set Super Steel Bath 1500 x 750mm '),(45795,109,0,6424,'Bette Set Super Steel Bath 1500 x 750mm '),(45796,121,5,6425,'bette-starlet-super-steel-bath-1570-x-700mm-no-th'),(45797,121,0,6425,'bette-starlet-super-steel-bath-1570-x-700mm-no-th'),(45798,84,5,6425,'Bette Starlet 157x70cm -Rectangular Double ended bath | Banyo'),(45799,84,0,6425,'Bette Starlet 157x70cm -Rectangular Double ended bath | Banyo'),(45800,86,5,6425,'Buy Bette Starlet 157x70cm Rectangular Double ended bath is available on Banyo. All Sizes of Bette Starlet Double Ended bath are available with the lowest prices in the UK.'),(45801,86,0,6425,'Buy Bette Starlet 157x70cm Rectangular Double ended bath is available on Banyo. All Sizes of Bette Starlet Double Ended bath are available with the lowest prices in the UK.'),(45802,73,5,6425,'Bette Starlet Super Steel Bath 1570 x 700mm - No TH'),(45803,73,0,6425,'Bette Starlet Super Steel Bath 1570 x 700mm - No TH'),(45804,109,5,6425,'Bette Starlet Super Steel Bath 1570 x 700mm - No TH'),(45805,109,0,6425,'Bette Starlet Super Steel Bath 1570 x 700mm - No TH'),(45806,121,5,6426,'bette-set-super-steel-bath-170-x-75cm-feet'),(45807,121,0,6426,'bette-set-super-steel-bath-170-x-75cm-feet'),(45808,84,5,6426,'Bette Set Super Steel Bath 1700 x 750 | BE3060-000 | Bette Set - Banyo'),(45809,84,0,6426,'Bette Set Super Steel Bath 1700 x 750 | BE3060-000 | Bette Set - Banyo'),(45810,86,5,6426,'Bette Set Super Steel Bath 170 x 75cm - BE3060-000. Bette Set The versatile bath set for a little bathroom has a rectangular exterior and a rounded interior with a limited bath area.'),(45811,86,0,6426,'Bette Set Super Steel Bath 170 x 75cm - BE3060-000. Bette Set The versatile bath set for a little bathroom has a rectangular exterior and a rounded interior with a limited bath area.'),(45812,73,5,6426,'Bette Set Super Steel Bath 1700 x 750mm '),(45813,73,0,6426,'Bette Set Super Steel Bath 1700 x 750mm '),(45814,109,5,6426,'Bette Set Super Steel Bath 1700 x 750mm '),(45815,109,0,6426,'Bette Set Super Steel Bath 1700 x 750mm '),(45816,121,5,6427,'bette-classic-super-steel-bath-170-x-75mm-feet'),(45817,121,0,6427,'bette-classic-super-steel-bath-170-x-75mm-feet'),(45818,84,5,6427,'Bette Classic 1700 x 750 - Steel Inset Bath | Banyo'),(45819,84,0,6427,'Bette Classic 1700 x 750 - Steel Inset Bath | Banyo'),(45820,86,5,6427,'Shop for Bette Classic 1700 x 750 Steel Inset Bath on Banyo with a special price discount. We offer a full range of Modern Steel Enamel bath with the lowest price in the UK.'),(45821,86,0,6427,'Shop for Bette Classic 1700 x 750 Steel Inset Bath on Banyo with a special price discount. We offer a full range of Modern Steel Enamel bath with the lowest price in the UK.'),(45822,73,5,6427,'Bette Classic Super Steel Bath 170 x 75cm '),(45823,73,0,6427,'Bette Classic Super Steel Bath 170 x 75cm '),(45824,109,5,6427,'Bette Classic Super Steel Bath 170 x 75cm '),(45825,109,0,6427,'Bette Classic Super Steel Bath 170 x 75cm '),(45826,121,5,6428,'bette-one-relax-super-steel-bath-180-x-80cm-no-th'),(45827,121,0,6428,'bette-one-relax-super-steel-bath-180-x-80cm-no-th'),(45828,84,5,6428,'Bette One Relax 1800 x 800 - Steel Enamel Bath | Banyo UK'),(45829,84,0,6428,'Bette One Relax 1800 x 800 - Steel Enamel Bath | Banyo UK'),(45830,86,5,6428,'Bette one Relax 1800 x 800 is available on Banyo with a special discounted price. We offer a complete range of Single Ended Steel Enamel baths with low prices and fast delivery. '),(45831,86,0,6428,'Bette one Relax 1800 x 800 is available on Banyo with a special discounted price. We offer a complete range of Single Ended Steel Enamel baths with low prices and fast delivery. '),(45832,73,5,6428,'Bette One Relax Super Steel Bath 1800 x 800mm - No TH'),(45833,73,0,6428,'Bette One Relax Super Steel Bath 1800 x 800mm - No TH'),(45834,109,5,6428,'Bette One Relax Super Steel Bath 1800 x 800mm - No TH'),(45835,109,0,6428,'Bette One Relax Super Steel Bath 1800 x 800mm - No TH'),(45836,121,5,6429,'bette-one-relax-super-steel-bath-1900-x-900mm-no-th'),(45837,121,0,6429,'bette-one-relax-super-steel-bath-1900-x-900mm-no-th'),(45838,84,5,6429,'Bette One Relax 1900 x 900 - Super Steel Bath | Banyo UK'),(45839,84,0,6429,'Bette One Relax 1900 x 900 - Super Steel Bath | Banyo UK'),(45840,86,5,6429,'Special discounted price on Bette One Relax 1900 x 900 bath available on Banyo. We offer an extensive range of Super Steel Baths with the lowest prices in the UK.'),(45841,86,0,6429,'Special discounted price on Bette One Relax 1900 x 900 bath available on Banyo. We offer an extensive range of Super Steel Baths with the lowest prices in the UK.'),(45842,73,5,6429,'Bette One Relax Super Steel Bath 1900 x 900mm - No TH'),(45843,73,0,6429,'Bette One Relax Super Steel Bath 1900 x 900mm - No TH'),(45844,109,5,6429,'Bette One Relax Super Steel Bath 1900 x 900mm - No TH'),(45845,109,0,6429,'Bette One Relax Super Steel Bath 1900 x 900mm - No TH'),(45846,121,5,6430,'bette-one-relax-super-steel-bath-2000-900mm-no-th'),(45847,121,0,6430,'bette-one-relax-super-steel-bath-2000-900mm-no-th'),(45848,84,5,6430,'Bette One Relax 200 x 90 - Rectangular Steel Bath | Banyo'),(45849,84,0,6430,'Bette One Relax 200 x 90 - Rectangular Steel Bath | Banyo'),(45850,86,5,6430,'Bette One Relax 200 x 90 is a Rectangular Steel Bath available on Banyo at an affordable price and manufacturer warranty. We offer the lowest prices in the UK.'),(45851,86,0,6430,'Bette One Relax 200 x 90 is a Rectangular Steel Bath available on Banyo at an affordable price and manufacturer warranty. We offer the lowest prices in the UK.'),(45852,73,5,6430,'Bette One Relax Super Steel Bath 2000 x 900mm - No TH'),(45853,73,0,6430,'Bette One Relax Super Steel Bath 2000 x 900mm - No TH'),(45854,109,5,6430,'Bette One Relax Super Steel Bath 2000 Ã— 900mm - No TH'),(45855,109,0,6430,'Bette One Relax Super Steel Bath 2000 Ã— 900mm - No TH'),(45856,121,5,6431,'bette-form-super-steel-bath-1400-x-700mm'),(45857,121,0,6431,'bette-form-super-steel-bath-1400-x-700mm'),(45858,84,5,6431,'Bette Form 1400 x 700mm Bath - Bette Single Ended Bath | Banyo'),(45859,84,0,6431,'Bette Form 1400 x 700mm Bath - Bette Single Ended Bath | Banyo'),(45860,86,5,6431,'Bette Form 1400 x 700mm is a Single Ended Bath Super Steel Rectangular Bath and is available on Banyo with 30years manufacturer warranty. We offer the lowest prices in the UK along.'),(45861,86,0,6431,'Bette Form 1400 x 700mm is a Single Ended Bath Super Steel Rectangular Bath and is available on Banyo with 30years manufacturer warranty. We offer the lowest prices in the UK along.'),(45862,73,5,6431,'Bette Form Super Steel Bath 1400 x 700mm '),(45863,73,0,6431,'Bette Form Super Steel Bath 1400 x 700mm '),(45864,109,5,6431,'Bette Form Super Steel Bath 1400 x 700mm '),(45865,109,0,6431,'Bette Form Super Steel Bath 1400 x 700mm '),(45866,110,5,6431,'Bette Form Super Steel Bath 1400 x 700mm '),(45867,110,0,6431,'Bette Form Super Steel Bath 1400 x 700mm '),(45868,111,5,6431,'Bette Form Super Steel Bath 1400 x 700mm '),(45869,111,0,6431,'Bette Form Super Steel Bath 1400 x 700mm '),(45870,121,5,6432,'bette-select-super-steel-bath-1600-x-700mm'),(45871,121,0,6432,'bette-select-super-steel-bath-1600-x-700mm'),(45872,84,5,6432,'Bette Select 1600x700mm - Single Ended Rectangular Bath | Banyo'),(45873,84,0,6432,'Bette Select 1600x700mm - Single Ended Rectangular Bath | Banyo'),(45874,86,5,6432,'Bette Select 1600x700mm is a Single Ended Rectangular Bath available on Banyo with a special price discount. All sizes of Bette Select available with affordable prices & fast delivery in the UK.'),(45875,86,0,6432,'Bette Select 1600x700mm is a Single Ended Rectangular Bath available on Banyo with a special price discount. All sizes of Bette Select available with affordable prices & fast delivery in the UK.'),(45876,73,5,6432,'Bette Select Super Steel Bath 1600 x 700mm '),(45877,73,0,6432,'Bette Select Super Steel Bath 1600 x 700mm '),(45878,109,5,6432,'Bette Select Super Steel Bath 1600 x 700mm '),(45879,109,0,6432,'Bette Select Super Steel Bath 1600 x 700mm '),(45880,121,5,6433,'bette-select-super-steel-bath-1700-x-700mm'),(45881,121,0,6433,'bette-select-super-steel-bath-1700-x-700mm'),(45882,84,5,6433,'Bette Select 170x70cm - Single Ended Super Steel Bath | Banyo'),(45883,84,0,6433,'Bette Select 170x70cm - Single Ended Super Steel Bath | Banyo'),(45884,86,5,6433,'Bette Select 170x70cm is a single ended rectangular bath supplied with no tap hole. We offer all sizes of Bette select with the lowest prices in the UK.'),(45885,86,0,6433,'Bette Select 170x70cm is a single ended rectangular bath supplied with no tap hole. We offer all sizes of Bette select with the lowest prices in the UK.'),(45886,73,5,6433,'Bette Select Super Steel Bath 1700 x 700mm '),(45887,73,0,6433,'Bette Select Super Steel Bath 1700 x 700mm '),(45888,109,5,6433,'Bette Select Super Steel Bath 1700 x 700mm '),(45889,109,0,6433,'Bette Select Super Steel Bath 1700 x 700mm '),(45890,121,5,6434,'bette-select-super-steel-bath-170-x-75cm-feet'),(45891,121,0,6434,'bette-select-super-steel-bath-170-x-75cm-feet'),(45892,84,5,6434,'Bette Select Super Steel Bath 1700 x 750 | Bette Select - BE3412-000'),(45893,84,0,6434,'Bette Select Super Steel Bath 1700 x 750 | Bette Select - BE3412-000'),(45894,86,5,6434,'Shop for Bette Select Super Steel Bath 170 x 75cm - BE3412-000 from Banyo UK. Bette Select combines a clear, classic style with a tremendous level of comfort its a versatility, and sufficient creative product.\r\n\r\n\r\n'),(45895,86,0,6434,'Shop for Bette Select Super Steel Bath 170 x 75cm - BE3412-000 from Banyo UK. Bette Select combines a clear, classic style with a tremendous level of comfort its a versatility, and sufficient creative product.\r\n\r\n\r\n'),(45896,73,5,6434,'Bette Select Super Steel Bath 1700 x 750mm '),(45897,73,0,6434,'Bette Select Super Steel Bath 1700 x 750mm '),(45898,109,5,6434,'Bette Select Super Steel Bath 1700 x 750mm '),(45899,109,0,6434,'Bette Select Super Steel Bath 1700 x 750mm '),(45900,121,5,6435,'bette-select-super-steel-bath-1800-x-800mm'),(45901,121,0,6435,'bette-select-super-steel-bath-1800-x-800mm'),(45902,84,5,6435,'Bette Select Bath 1800 x 800 Overflow hole at foot end | Banyo'),(45903,84,0,6435,'Bette Select Bath 1800 x 800 Overflow hole at foot end | Banyo'),(45904,86,5,6435,'Buy Bette Select Bath 1800 x 800 Overflow hole at foot end on Banyo with discounted price and fastest delivery service all across the UK. Call us on 0116 274 4059.'),(45905,86,0,6435,'Buy Bette Select Bath 1800 x 800 Overflow hole at foot end on Banyo with discounted price and fastest delivery service all across the UK. Call us on 0116 274 4059.'),(45906,73,5,6435,'Bette Select Super Steel Bath 1800 x 800mm'),(45907,73,0,6435,'Bette Select Super Steel Bath 1800 x 800mm'),(45908,109,5,6435,'Bette Select Super Steel Bath 1800 x 800mm'),(45909,109,0,6435,'Bette Select Super Steel Bath 1800 x 800mm'),(45910,121,5,6436,'bette-select-super-steel-bath-160-x-70cm-feet-no-th'),(45911,121,0,6436,'bette-select-super-steel-bath-160-x-70cm-feet-no-th'),(45912,84,5,6436,'Bette Select 1600 x 700mm - Super Steel Bath No TH | Banyo'),(45913,84,0,6436,'Bette Select 1600 x 700mm - Super Steel Bath No TH | Banyo'),(45914,86,5,6436,'Bette Select 1600 x 700mm is a Super Steel Bath with No Tap Hole and is available on Banyo with special price discount and fast delivery all across the UK. For more info 0116 274 4059.'),(45915,86,0,6436,'Bette Select 1600 x 700mm is a Super Steel Bath with No Tap Hole and is available on Banyo with special price discount and fast delivery all across the UK. For more info 0116 274 4059.'),(45916,73,5,6436,'Bette Select Super Steel Bath 1600 x 700mm - No TH'),(45917,73,0,6436,'Bette Select Super Steel Bath 1600 x 700mm - No TH'),(45918,109,5,6436,'Bette Select Super Steel Bath 1600 x 700mm - No TH'),(45919,109,0,6436,'Bette Select Super Steel Bath 1600 x 700mm - No TH'),(45920,121,5,6437,'bette-select-super-steel-bath-170-x-70cm-feet-no-th'),(45921,121,0,6437,'bette-select-super-steel-bath-170-x-70cm-feet-no-th'),(45922,84,5,6437,'Bette Select bath 1700 x 700mm - Rectangular Steel Bath No TH | Banyo'),(45923,84,0,6437,'Bette Select bath 1700 x 700mm - Rectangular Steel Bath No TH | Banyo'),(45924,86,5,6437,'Buy Bette Select bath 1700 x 700mm is a Rectangular Steel Bath with No Tap Hole is available on Banyo. We offer a complete range of Single Ended baths from Bette at discounted prices.'),(45925,86,0,6437,'Buy Bette Select bath 1700 x 700mm is a Rectangular Steel Bath with No Tap Hole is available on Banyo. We offer a complete range of Single Ended baths from Bette at discounted prices.'),(45926,73,5,6437,'Bette Select Super Steel Bath 1700 x 700mm - No TH'),(45927,73,0,6437,'Bette Select Super Steel Bath 1700 x 700mm - No TH'),(45928,109,5,6437,'Bette Select Super Steel Bath 1700 x 700mm - No TH'),(45929,109,0,6437,'Bette Select Super Steel Bath 1700 x 700mm - No TH'),(45930,110,5,6437,'Bette Select Super Steel Bath 1700 x 700mm - No TH'),(45931,110,0,6437,'Bette Select Super Steel Bath 1700 x 700mm - No TH'),(45932,111,5,6437,'Bette Select Super Steel Bath 1700 x 700mm - No TH'),(45933,111,0,6437,'Bette Select Super Steel Bath 1700 x 700mm - No TH'),(45934,121,5,6438,'bette-select-super-steel-bath-1700-x-750mm-no-th'),(45935,121,0,6438,'bette-select-super-steel-bath-1700-x-750mm-no-th'),(45936,84,5,6438,'Bette Select 1700 x 750mm - No TH Super Steel Drop IN Bath | Banyo'),(45937,84,0,6438,'Bette Select 1700 x 750mm - No TH Super Steel Drop IN Bath | Banyo'),(45938,86,5,6438,'Bette Select 1700 x 750mm with No Tap Hole is a  Super Steel Drop IN Bath available with a special price discount on Banyo with fast delivery service in the UK. For more info call 0116 274 4059.'),(45939,86,0,6438,'Bette Select 1700 x 750mm with No Tap Hole is a  Super Steel Drop IN Bath available with a special price discount on Banyo with fast delivery service in the UK. For more info call 0116 274 4059.'),(45940,73,5,6438,'Bette Select Super Steel Bath 1700 x 750mm - No TH'),(45941,73,0,6438,'Bette Select Super Steel Bath 1700 x 750mm - No TH'),(45942,109,5,6438,'Bette Select Super Steel Bath 1700 x 750mm - No TH'),(45943,109,0,6438,'Bette Select Super Steel Bath 1700 x 750mm - No TH'),(45944,121,5,6439,'bette-select-super-steel-bath-1800-x-800mm-no-th'),(45945,121,0,6439,'bette-select-super-steel-bath-1800-x-800mm-no-th'),(45946,84,5,6439,'Bette Select Bath 1800 x 800mm - Super Rectangular Steel No TH | Banyo'),(45947,84,0,6439,'Bette Select Bath 1800 x 800mm - Super Rectangular Steel No TH | Banyo'),(45948,86,5,6439,'Bette Select Bath 1800 x 800mm is a Super Rectangular Steel with No Tap Hole is foot end overflow front bath and is available on Banyo with the lowest prices in the UK.'),(45949,86,0,6439,'Bette Select Bath 1800 x 800mm is a Super Rectangular Steel with No Tap Hole is foot end overflow front bath and is available on Banyo with the lowest prices in the UK.'),(45950,73,5,6439,'Bette Select Super Steel Bath 1800 x 800mm - No TH'),(45951,73,0,6439,'Bette Select Super Steel Bath 1800 x 800mm - No TH'),(45952,109,5,6439,'Bette Select Super Steel Bath 1800 x 800mm - No TH'),(45953,109,0,6439,'Bette Select Super Steel Bath 1800 x 800mm - No TH'),(45954,121,5,6440,'bette-form-super-steel-bath-1750-x-750mm'),(45955,121,0,6440,'bette-form-super-steel-bath-1750-x-750mm'),(45956,84,5,6440,'Bette Form Super Steel Bath 1750 x 750mm  - Rectangular Baths | Banyo'),(45957,84,0,6440,'Bette Form Super Steel Bath 1750 x 750mm  - Rectangular Baths | Banyo'),(45958,86,5,6440,'Shop for Bette Form Super Steel Bath 1750 x 750mm with a special discounted price from Banyo. We offer a full range of Single Ended bathtubs with the lowest prices in the UK.'),(45959,86,0,6440,'Shop for Bette Form Super Steel Bath 1750 x 750mm with a special discounted price from Banyo. We offer a full range of Single Ended bathtubs with the lowest prices in the UK.'),(45960,73,5,6440,'Bette Form Super Steel Bath 1750 x 750mm '),(45961,73,0,6440,'Bette Form Super Steel Bath 1750 x 750mm '),(45962,109,5,6440,'bette-form-1'),(45963,109,0,6440,'bette-form-1'),(45964,110,5,6440,'bette-form-1'),(45965,110,0,6440,'bette-form-1'),(45966,111,5,6440,'bette-form-1'),(45967,111,0,6440,'bette-form-1'),(45968,121,5,6441,'bette-form-super-steel-bath-1700-x-800mm'),(45969,121,0,6441,'bette-form-super-steel-bath-1700-x-800mm'),(45970,84,5,6441,'Bette Form Super Steel Bath 1700 x 800mm - BE3490-000 | Banyo'),(45971,84,0,6441,'Bette Form Super Steel Bath 1700 x 800mm - BE3490-000 | Banyo'),(45972,86,5,6441,'Buy Bette Form Super Steel Bath 1700 x 800mm from Banyo with special discounted price and manufacturers warranty. We offer a complete range of Rectangular Single Ended bathtubs with the lowest prices in the UK.'),(45973,86,0,6441,'Buy Bette Form Super Steel Bath 1700 x 800mm from Banyo with special discounted price and manufacturers warranty. We offer a complete range of Rectangular Single Ended bathtubs with the lowest prices in the UK.'),(45974,73,5,6441,'Bette Form Super Steel Bath 1700 x 800mm '),(45975,73,0,6441,'Bette Form Super Steel Bath 1700 x 800mm '),(45976,109,5,6441,'Bette Form Super Steel Bath 1700 x 800mm '),(45977,109,0,6441,'Bette Form Super Steel Bath 1700 x 800mm '),(45978,110,5,6441,'Bette Form Super Steel Bath 1700 x 800mm '),(45979,110,0,6441,'Bette Form Super Steel Bath 1700 x 800mm '),(45980,111,5,6441,'Bette Form Super Steel Bath 1700 x 800mm '),(45981,111,0,6441,'Bette Form Super Steel Bath 1700 x 800mm '),(45982,121,5,6442,'bette-form-super-steel-bath-1500-x-700mm'),(45983,121,0,6442,'bette-form-super-steel-bath-1500-x-700mm'),(45984,84,5,6442,'Bette Form Super Steel Bath 1500 x 700 - BE3500-000 | Banyo'),(45985,84,0,6442,'Bette Form Super Steel Bath 1500 x 700 - BE3500-000 | Banyo'),(45986,86,5,6442,'Special discount on Bette Form Super Steel Bath 1500 x 700 available on Banyo. We offer a complete range of Bette bathroom products with the lowest prices in the UK.'),(45987,86,0,6442,'Special discount on Bette Form Super Steel Bath 1500 x 700 available on Banyo. We offer a complete range of Bette bathroom products with the lowest prices in the UK.'),(45988,73,5,6442,'Bette Form Super Steel Bath 1500 x 700mm '),(45989,73,0,6442,'Bette Form Super Steel Bath 1500 x 700mm '),(45990,109,5,6442,'Bette Form Super Steel Bath 1500 x 700mm '),(45991,109,0,6442,'Bette Form Super Steel Bath 1500 x 700mm '),(45992,110,5,6442,'Bette Form Super Steel Bath 1500 x 700mm '),(45993,110,0,6442,'Bette Form Super Steel Bath 1500 x 700mm '),(45994,111,5,6442,'Bette Form Super Steel Bath 1500 x 700mm '),(45995,111,0,6442,'Bette Form Super Steel Bath 1500 x 700mm '),(45996,121,5,6443,'bette-set-super-steel-bath-165-x-75cm-feet'),(45997,121,0,6443,'bette-set-super-steel-bath-165-x-75cm-feet'),(45998,84,5,6443,'Bette Set 1650 x 750 - Super Steel Rectangular Bath | Banyo'),(45999,84,0,6443,'Bette Set 1650 x 750 - Super Steel Rectangular Bath | Banyo'),(46000,86,5,6443,'Bette Set 1650x750 mm is a super steel rectangular bath available on Banyo with a special price discount.  We offer a wide range of Bette Baths with low prices and fast delivery service in the UK.'),(46001,86,0,6443,'Bette Set 1650x750 mm is a super steel rectangular bath available on Banyo with a special price discount.  We offer a wide range of Bette Baths with low prices and fast delivery service in the UK.'),(46002,73,5,6443,'Bette Set Super Steel Bath 1650 x 750mm '),(46003,73,0,6443,'Bette Set Super Steel Bath 1650 x 750mm '),(46004,109,5,6443,'Bette Set Super Steel Bath 1650 x 750mm '),(46005,109,0,6443,'Bette Set Super Steel Bath 1650 x 750mm '),(46006,121,5,6444,'bette-form-super-steel-bath-1600-x-700mm'),(46007,121,0,6444,'bette-form-super-steel-bath-1600-x-700mm'),(46008,84,5,6444,'Bette Form 1600 x 700 - Super Steel Bath - BE3600-000 | Banyo'),(46009,84,0,6444,'Bette Form 1600 x 700 - Super Steel Bath - BE3600-000 | Banyo'),(46010,86,5,6444,'Shop for Bette Form 1600 x 700 Super Steel Bath (BE3600-000) at Banyo with special price discount and manufacturers warranty. For the Best Deals on Modern Bathrooms visit our website or call us on 0116 274 4059.'),(46011,86,0,6444,'Shop for Bette Form 1600 x 700 Super Steel Bath (BE3600-000) at Banyo with special price discount and manufacturers warranty. For the Best Deals on Modern Bathrooms visit our website or call us on 0116 274 4059.'),(46012,73,5,6444,'Bette Form Super Steel Bath 1600 x 700mm '),(46013,73,0,6444,'Bette Form Super Steel Bath 1600 x 700mm '),(46014,109,5,6444,'Bette Form Super Steel Bath 1600 x 700mm '),(46015,109,0,6444,'Bette Form Super Steel Bath 1600 x 700mm '),(46016,110,5,6444,'Bette Form Super Steel Bath 1600 x 700mm '),(46017,110,0,6444,'Bette Form Super Steel Bath 1600 x 700mm '),(46018,111,5,6444,'Bette Form Super Steel Bath 1600 x 700mm '),(46019,111,0,6444,'Bette Form Super Steel Bath 1600 x 700mm '),(46020,121,5,6445,'bette-form-super-steel-bath-1600-x-750mm'),(46021,121,0,6445,'bette-form-super-steel-bath-1600-x-750mm'),(46022,84,5,6445,'Bette Form 1600 x 750 - Super Steel Standard Bath | Banyo'),(46023,84,0,6445,'Bette Form 1600 x 750 - Super Steel Standard Bath | Banyo'),(46024,86,5,6445,'Bette Form 1600 x 750mm is a Super Steel Standard Bath available on Banyo with affordable price and manufacturer warranty. We offer a wide range of Modern inset bathtubs with the lowest prices.'),(46025,86,0,6445,'Bette Form 1600 x 750mm is a Super Steel Standard Bath available on Banyo with affordable price and manufacturer warranty. We offer a wide range of Modern inset bathtubs with the lowest prices.'),(46026,73,5,6445,'Bette Form Super Steel Bath 1600 x 750mm '),(46027,73,0,6445,'Bette Form Super Steel Bath 1600 x 750mm '),(46028,109,5,6445,'Bette Form Super Steel Bath 1600 x 750mm '),(46029,109,0,6445,'Bette Form Super Steel Bath 1600 x 750mm '),(46030,110,5,6445,'Bette Form Super Steel Bath 1600 x 750mm '),(46031,110,0,6445,'Bette Form Super Steel Bath 1600 x 750mm '),(46032,111,5,6445,'Bette Form Super Steel Bath 1600 x 750mm '),(46033,111,0,6445,'Bette Form Super Steel Bath 1600 x 750mm '),(46089,121,5,6446,'bette-form-super-steel-bath-1650-x-750mm'),(46090,121,0,6446,'bette-form-super-steel-bath-1650-x-750mm'),(46091,84,5,6446,'Bette Form 1650 x 750 - Super Steel White Bath | Banyo'),(46092,84,0,6446,'Bette Form 1650 x 750 - Super Steel White Bath | Banyo'),(46093,86,5,6446,'Banyo offers a special discounted price on Bette Form 1650 x 750mm Super Steel White Bath. We offer a complete range of Traditional bathtubs with the lowest prices in the UK.'),(46094,86,0,6446,'Banyo offers a special discounted price on Bette Form 1650 x 750mm Super Steel White Bath. We offer a complete range of Traditional bathtubs with the lowest prices in the UK.'),(46095,73,5,6446,'Bette Form Super Steel Bath 1650 x 750mm '),(46096,73,0,6446,'Bette Form Super Steel Bath 1650 x 750mm '),(46097,109,5,6446,'Bette Form Super Steel Bath 1650 x 750mm '),(46098,109,0,6446,'Bette Form Super Steel Bath 1650 x 750mm '),(46099,110,5,6446,'Bette Form Super Steel Bath 1650 x 750mm '),(46100,110,0,6446,'Bette Form Super Steel Bath 1650 x 750mm '),(46101,111,5,6446,'Bette Form Super Steel Bath 1650 x 750mm '),(46102,111,0,6446,'Bette Form Super Steel Bath 1650 x 750mm '),(46103,121,5,6447,'bette-set-super-steel-bath-160-x-70cm-feet'),(46104,121,0,6447,'bette-set-super-steel-bath-160-x-70cm-feet'),(46105,84,5,6447,'Bette Set 1600mm Rectangular Bath - BE3650-000 | Banyo'),(46106,84,0,6447,'Bette Set 1600mm Rectangular Bath - BE3650-000 | Banyo'),(46107,86,5,6447,'Special discount on Bette Set 1600x700mm Rectangular steel Bath is available on Banyo. We offer all sizes and styles of Bette Rectangular Steel baths with lowest prices in the UK.'),(46108,86,0,6447,'Special discount on Bette Set 1600x700mm Rectangular steel Bath is available on Banyo. We offer all sizes and styles of Bette Rectangular Steel baths with lowest prices in the UK.'),(46109,73,5,6447,'Bette Set Super Steel Bath 1600 x 700mm '),(46110,73,0,6447,'Bette Set Super Steel Bath 1600 x 700mm '),(46111,109,5,6447,'Bette Set Super Steel Bath 1600 x 700mm '),(46112,109,0,6447,'Bette Set Super Steel Bath 1600 x 700mm '),(46113,121,5,6448,'bette-set-super-steel-bath-160-x-75cm'),(46114,121,0,6448,'bette-set-super-steel-bath-160-x-75cm'),(46115,84,5,6448,'Bette Set 1600 x 750 - Rectangular Single Ended Steel Bath | Banyo'),(46116,84,0,6448,'Bette Set 1600 x 750 - Rectangular Single Ended Steel Bath | Banyo'),(46117,86,5,6448,'Bette Set 1600 x 750 is a Rectangular Single Ended Steel Bath with Distinctive form and is available on Banyo with a special price discount. For best pricing in Leicester UK call on 0116 274 4059.'),(46118,86,0,6448,'Bette Set 1600 x 750 is a Rectangular Single Ended Steel Bath with Distinctive form and is available on Banyo with a special price discount. For best pricing in Leicester UK call on 0116 274 4059.'),(46119,73,5,6448,'Bette Set Super Steel Bath 1600 x 750mm '),(46120,73,0,6448,'Bette Set Super Steel Bath 1600 x 750mm '),(46121,109,5,6448,'Bette Set Super Steel Bath 1600 x 750mm '),(46122,109,0,6448,'Bette Set Super Steel Bath 1600 x 750mm '),(46123,121,5,6449,'bette-form-super-steel-bath-1700-730mm'),(46124,121,0,6449,'bette-form-super-steel-bath-1700-730mm'),(46125,84,5,6449,'Bette Form 1700 x 730 - Glazed Steel Bath | Banyo UK'),(46126,84,0,6449,'Bette Form 1700 x 730 - Glazed Steel Bath | Banyo UK'),(46127,86,5,6449,'At Banyo, we offer a special discount on Bette Form 1700 x 730 Glazed Steel Bath. Our wide variety of Straight Baths includes both Single and Double Ended bathtubs.'),(46128,86,0,6449,'At Banyo, we offer a special discount on Bette Form 1700 x 730 Glazed Steel Bath. Our wide variety of Straight Baths includes both Single and Double Ended bathtubs.'),(46129,73,5,6449,'Bette Form Super Steel Bath 1700 x 730mm'),(46130,73,0,6449,'Bette Form Super Steel Bath 1700 x 730mm'),(46131,109,5,6449,'bette-form-1'),(46132,109,0,6449,'bette-form-1'),(46133,110,5,6449,'bette-form-1'),(46134,110,0,6449,'bette-form-1'),(46135,111,5,6449,'bette-form-1'),(46136,111,0,6449,'bette-form-1'),(46137,121,5,6450,'bette-form-super-steel-bath-1700-x-750mm'),(46138,121,0,6450,'bette-form-super-steel-bath-1700-x-750mm'),(46139,84,5,6450,'Bette Form 1700 x 750 - Super Steel Modern Bath - BE3710-000 | Banyo'),(46140,84,0,6450,'Bette Form 1700 x 750 - Super Steel Modern Bath - BE3710-000 | Banyo'),(46141,86,5,6450,'Special Price discount on Bette Form 1700 x 750 available on Banyo. We Super Steel Modern Bathtubs with the lowest prices in the UK for more info call 0116 274 4059.'),(46142,86,0,6450,'Special Price discount on Bette Form 1700 x 750 available on Banyo. We Super Steel Modern Bathtubs with the lowest prices in the UK for more info call 0116 274 4059.'),(46143,73,5,6450,'Bette Form Super Steel Bath 1700 x 750mm '),(46144,73,0,6450,'Bette Form Super Steel Bath 1700 x 750mm '),(46145,109,5,6450,'Bette Form Super Steel Bath 1700 x 750mm '),(46146,109,0,6450,'Bette Form Super Steel Bath 1700 x 750mm '),(46147,110,5,6450,'Bette Form Super Steel Bath 1700 x 750mm '),(46148,110,0,6450,'Bette Form Super Steel Bath 1700 x 750mm '),(46149,111,5,6450,'Bette Form Super Steel Bath 1700 x 750mm '),(46150,111,0,6450,'Bette Form Super Steel Bath 1700 x 750mm '),(46151,121,5,6451,'bette-set-super-steel-bath-170-x-80cm-feet'),(46152,121,0,6451,'bette-set-super-steel-bath-170-x-80cm-feet'),(46153,84,5,6451,'Bette Set Bath 1700 x 800 - Rectangular Single Ended | Banyo'),(46154,84,0,6451,'Bette Set Bath 1700 x 800 - Rectangular Single Ended | Banyo'),(46155,86,5,6451,'Buy Bette Set Bath 1700 x 800mm is a Rectangular Single Ended bath available on Banyo. We offer special discounts on Bette Steel baths with fast delivery service in the UK.'),(46156,86,0,6451,'Buy Bette Set Bath 1700 x 800mm is a Rectangular Single Ended bath available on Banyo. We offer special discounts on Bette Steel baths with fast delivery service in the UK.'),(46157,73,5,6451,'Bette Set Super Steel Bath 1700 x 800mm '),(46158,73,0,6451,'Bette Set Super Steel Bath 1700 x 800mm '),(46159,109,5,6451,'Bette Set Super Steel Bath 1700 x 800mm '),(46160,109,0,6451,'Bette Set Super Steel Bath 1700 x 800mm '),(46161,121,5,6452,'bette-form-super-steel-bath-1800-x-800mm'),(46162,121,0,6452,'bette-form-super-steel-bath-1800-x-800mm'),(46163,84,5,6452,'Bette Form 1800 x 800mm Bath - Bette Single Ended Bath | Banyo'),(46164,84,0,6452,'Bette Form 1800 x 800mm Bath - Bette Single Ended Bath | Banyo'),(46165,86,5,6452,'Bette Form 1800 x 800mm is a Single Ended Rectangular Bath is strong & highly durable compared to other baths and is available on Banyo. We offer a full range of Bette Baths.'),(46166,86,0,6452,'Bette Form 1800 x 800mm is a Single Ended Rectangular Bath is strong & highly durable compared to other baths and is available on Banyo. We offer a full range of Bette Baths.'),(46167,73,5,6452,'Bette Form Super Steel Bath 1800 x 800mm '),(46168,73,0,6452,'Bette Form Super Steel Bath 1800 x 800mm '),(46169,109,5,6452,'bette-form-1'),(46170,109,0,6452,'bette-form-1'),(46171,110,5,6452,'bette-form-1'),(46172,110,0,6452,'bette-form-1'),(46173,111,5,6452,'bette-form-1'),(46174,111,0,6452,'bette-form-1'),(46175,121,5,6453,'bette-set-super-steel-bath-180-x-80cm-feet'),(46176,121,0,6453,'bette-set-super-steel-bath-180-x-80cm-feet'),(46177,84,5,6453,'Bette Set White Steel Bath 1800 x 800 - Single Ended  | Banyo'),(46178,84,0,6453,'Bette Set White Steel Bath 1800 x 800 - Single Ended  | Banyo'),(46179,86,5,6453,'Shop for Bette Set White Steel Bath 1800 x 800 mm with a special discount on Banyo.  We offer a wide range of Rectangular Steel Baths with the lowest prices in the UK.'),(46180,86,0,6453,'Shop for Bette Set White Steel Bath 1800 x 800 mm with a special discount on Banyo.  We offer a wide range of Rectangular Steel Baths with the lowest prices in the UK.'),(46181,73,5,6453,'Bette Set Super Steel Bath 1800 x 800mm '),(46182,73,0,6453,'Bette Set Super Steel Bath 1800 x 800mm '),(46183,109,5,6453,'Bette Set Super Steel Bath 1800 x 800mm '),(46184,109,0,6453,'Bette Set Super Steel Bath 1800 x 800mm '),(46185,121,5,6454,'bette-starlet-flair-oval-super-steel-bath-1580-x-680mm-no-th'),(46186,121,0,6454,'bette-starlet-flair-oval-super-steel-bath-1580-x-680mm-no-th'),(46187,84,5,6454,'Bette Starlet Flair Oval 8772 - 1580 x 680mm Steel Enamel Bath | Banyo'),(46188,84,0,6454,'Bette Starlet Flair Oval 8772 - 1580 x 680mm Steel Enamel Bath | Banyo'),(46189,86,5,6454,'Special Discount - Affordable Prices on Bette Starlet Flair Oval 8772 at Banyo. Wide range of Double Sided Steel Enamel Baths available in all sizes & styles with the fastest delivery.'),(46190,86,0,6454,'Special Discount - Affordable Prices on Bette Starlet Flair Oval 8772 at Banyo. Wide range of Double Sided Steel Enamel Baths available in all sizes & styles with the fastest delivery.'),(46191,73,5,6454,'Bette Starlet Flair Oval Super Steel Bath 1580 x 680mm - No TH'),(46192,73,0,6454,'Bette Starlet Flair Oval Super Steel Bath 1580 x 680mm - No TH'),(46193,109,5,6454,'Bette Starlet Flair Oval Super Steel Bath 1580 x 680mm - No TH'),(46194,109,0,6454,'Bette Starlet Flair Oval Super Steel Bath 1580 x 680mm - No TH'),(46195,121,5,6455,'bette-starlet-flair-oval-super-steel-bath-1680-x-730mm-feet'),(46196,121,0,6455,'bette-starlet-flair-oval-super-steel-bath-1680-x-730mm-feet'),(46197,84,5,6455,'Bette Starlet Flair Oval 8773 - 1680x730mm Steel Enamel Bath | Banyo'),(46198,84,0,6455,'Bette Starlet Flair Oval 8773 - 1680x730mm Steel Enamel Bath | Banyo'),(46199,86,5,6455,'Shop for Bette Starlet Flair Oval 8773 from Banyo with special discounted price. We offer a wide range of high-quality steel enamel baths with the lowest price in the UK.'),(46200,86,0,6455,'Shop for Bette Starlet Flair Oval 8773 from Banyo with special discounted price. We offer a wide range of high-quality steel enamel baths with the lowest price in the UK.'),(46201,73,5,6455,'Bette Starlet Flair Oval Super Steel Bath 1680 x 730mm'),(46202,73,0,6455,'Bette Starlet Flair Oval Super Steel Bath 1680 x 730mm'),(46203,109,5,6455,'Bette Starlet Flair Oval Super Steel Bath 1680 x 730mm & Feet'),(46204,109,0,6455,'Bette Starlet Flair Oval Super Steel Bath 1680 x 730mm & Feet'),(46205,121,5,6456,'bette-starlet-flair-oval-super-steel-bath-1780-x-780mm'),(46206,121,0,6456,'bette-starlet-flair-oval-super-steel-bath-1780-x-780mm'),(46207,84,5,6456,'Bette Starlet Flair Oval 8774 - Steel Enamel Bath 1780 x 780 | Banyo'),(46208,84,0,6456,'Bette Starlet Flair Oval 8774 - Steel Enamel Bath 1780 x 780 | Banyo'),(46209,86,5,6456,'Buy Bette Starlet Flair Oval 8774 on Banyo with a special price discount. We offer affordable prices on all Steel Enamel Baths with the fastest delivery in the UK.'),(46210,86,0,6456,'Buy Bette Starlet Flair Oval 8774 on Banyo with a special price discount. We offer affordable prices on all Steel Enamel Baths with the fastest delivery in the UK.'),(46211,73,5,6456,'Bette Starlet Flair Oval Super Steel Bath 1780 x 780mm'),(46212,73,0,6456,'Bette Starlet Flair Oval Super Steel Bath 1780 x 780mm'),(46213,109,5,6456,'Bette Starlet Flair Oval Super Steel Bath 1780 x 780mm & Feet'),(46214,109,0,6456,'Bette Starlet Flair Oval Super Steel Bath 1780 x 780mm & Feet'),(46215,121,5,6457,'bette-starlet-flair-oval-super-steel-bath-1880-x-880mm-no-th'),(46216,121,0,6457,'bette-starlet-flair-oval-super-steel-bath-1880-x-880mm-no-th'),(46217,84,5,6457,'Bette Starlet Flair Oval 8775 - Double Ended Steel Bath 1880x880 | Banyo'),(46218,84,0,6457,'Bette Starlet Flair Oval 8775 - Double Ended Steel Bath 1880x880 | Banyo'),(46219,86,5,6457,'At Banyo, we offer a special discounted price on Bette Starlet Flair Oval 8775. We offer affordable prices on all Double Ended Steel Bath 1880x880 with the fastest delivery in the UK.'),(46220,86,0,6457,'At Banyo, we offer a special discounted price on Bette Starlet Flair Oval 8775. We offer affordable prices on all Double Ended Steel Bath 1880x880 with the fastest delivery in the UK.'),(46221,73,5,6457,'Bette Starlet Flair Oval Super Steel Bath 1880 x 880mm - No TH'),(46222,73,0,6457,'Bette Starlet Flair Oval Super Steel Bath 1880 x 880mm - No TH'),(46223,109,5,6457,'Bette Starlet Flair Oval Super Steel Bath 1880 x 880mm - No TH'),(46224,109,0,6457,'Bette Starlet Flair Oval Super Steel Bath 1880 x 880mm - No TH'),(46225,121,5,6458,'bette-starlet-oval-super-steel-bath-1500-x-800mm-no-th'),(46226,121,0,6458,'bette-starlet-oval-super-steel-bath-1500-x-800mm-no-th'),(46227,84,5,6458,'Bette Starlet Oval Super Steel Bath 150 x 80cm  No Tap Hole - BE2700-000'),(46228,84,0,6458,'Bette Starlet Oval Super Steel Bath 150 x 80cm  No Tap Hole - BE2700-000'),(46229,86,5,6458,'Shop for Bette Starlet Oval Super Steel Bath 1500 x 800mm with No Tap Hole (SKU: BE2700-000) at Banyo. We offer a comprehensive range of Oval Steel baths with low prices in the UK.'),(46230,86,0,6458,'Shop for Bette Starlet Oval Super Steel Bath 1500 x 800mm with No Tap Hole (SKU: BE2700-000) at Banyo. We offer a comprehensive range of Oval Steel baths with low prices in the UK.'),(46231,73,5,6458,'Bette Starlet Oval Super Steel Bath 1500 x 800mm - No TH'),(46232,73,0,6458,'Bette Starlet Oval Super Steel Bath 1500 x 800mm - No TH'),(46233,109,5,6458,'Bette Starlet Oval Super Steel Bath 1500 x 800mm - No TH'),(46234,109,0,6458,'Bette Starlet Oval Super Steel Bath 1500 x 800mm - No TH'),(46235,121,5,6459,'bette-starlet-oval-super-steel-bath-1650-x-750mm-no-th'),(46236,121,0,6459,'bette-starlet-oval-super-steel-bath-1650-x-750mm-no-th'),(46237,84,5,6459,'Bette Starlet Oval 1650 x 750 - Double Ended Steel Enamel Bath | Banyo'),(46238,84,0,6459,'Bette Starlet Oval 1650 x 750 - Double Ended Steel Enamel Bath | Banyo'),(46239,86,5,6459,'Special discounted price on Bette Starlet Oval 1650 x 750mm Bath at Banyo. We offer the lowest prices in the UK on all Double Ended Steel Enamel Baths with the fast delivery.'),(46240,86,0,6459,'Special discounted price on Bette Starlet Oval 1650 x 750mm Bath at Banyo. We offer the lowest prices in the UK on all Double Ended Steel Enamel Baths with the fast delivery.'),(46241,73,5,6459,'Bette Starlet Oval Super Steel Bath 1650 x 750mm - No TH'),(46242,73,0,6459,'Bette Starlet Oval Super Steel Bath 1650 x 750mm - No TH'),(46243,109,5,6459,'Bette Starlet Oval Super Steel Bath 1650 x 750mm - No TH'),(46244,109,0,6459,'Bette Starlet Oval Super Steel Bath 1650 x 750mm - No TH'),(46245,121,5,6460,'bette-starlet-oval-super-steel-bath-1750-x-800mm-no-th'),(46246,121,0,6460,'bette-starlet-oval-super-steel-bath-1750-x-800mm-no-th'),(46247,84,5,6460,'Bette Starlet Oval Bath 1750 x 800 - Steel Enamel Baths | Banyo'),(46248,84,0,6460,'Bette Starlet Oval Bath 1750 x 800 - Steel Enamel Baths | Banyo'),(46249,86,5,6460,'At Banyo we offer a special discounted price on Bette Starlet Oval Bath 1750 x 800 with a manufacturers warranty. Extensive collection of Steel Enamel Baths on display at our online store.'),(46250,86,0,6460,'At Banyo we offer a special discounted price on Bette Starlet Oval Bath 1750 x 800 with a manufacturers warranty. Extensive collection of Steel Enamel Baths on display at our online store.'),(46251,73,5,6460,'Bette Starlet Oval Super Steel Bath 1750 x 800mm - No TH'),(46252,73,0,6460,'Bette Starlet Oval Super Steel Bath 1750 x 800mm - No TH'),(46253,109,5,6460,'Bette Starlet Oval Super Steel Bath 1750 x 800mm - No TH'),(46254,109,0,6460,'Bette Starlet Oval Super Steel Bath 1750 x 800mm - No TH'),(46255,121,5,6461,'bette-starlet-oval-super-steel-bath-1850-x-850mm-no-th'),(46256,121,0,6461,'bette-starlet-oval-super-steel-bath-1850-x-850mm-no-th'),(46257,84,5,6461,'Bette Starlet Oval 1850 x 850 - Double Ended Steel Bath | Banyo'),(46258,84,0,6461,'Bette Starlet Oval 1850 x 850 - Double Ended Steel Bath | Banyo'),(46259,86,5,6461,'Buy Bette Starlet Oval 1850 x 850 Bath with a special price discount from Banyo. We offer the lowest prices on double Ended Steel Baths with fast delivery in the UK.'),(46260,86,0,6461,'Buy Bette Starlet Oval 1850 x 850 Bath with a special price discount from Banyo. We offer the lowest prices on double Ended Steel Baths with fast delivery in the UK.'),(46261,73,5,6461,'Bette Starlet Oval Super Steel Bath 1850 x 850mm - No TH'),(46262,73,0,6461,'Bette Starlet Oval Super Steel Bath 1850 x 850mm - No TH'),(46263,109,5,6461,'Bette Starlet Oval Super Steel Bath 1850 x 850mm - No TH'),(46264,109,0,6461,'Bette Starlet Oval Super Steel Bath 1850 x 850mm - No TH'),(46265,121,5,6462,'bette-starlet-oval-super-steel-bath-1950-x-950mm-no-th'),(46266,121,0,6462,'bette-starlet-oval-super-steel-bath-1950-x-950mm-no-th'),(46267,84,5,6462,'Bette Starlet Oval 1950 x 950 - Titanium Steel Bath BE2745 | Banyo'),(46268,84,0,6462,'Bette Starlet Oval 1950 x 950 - Titanium Steel Bath BE2745 | Banyo'),(46269,86,5,6462,'Special price discount on Bette Starlet Oval 1950 x 950 (SKU: BE2745) bath at Banyo. We offer the lowest prices on all high-quality Titanium Steel Baths in the UK.'),(46270,86,0,6462,'Special price discount on Bette Starlet Oval 1950 x 950 (SKU: BE2745) bath at Banyo. We offer the lowest prices on all high-quality Titanium Steel Baths in the UK.'),(46271,73,5,6462,'Bette Starlet Oval Super Steel Bath 1950 x 950mm - No TH'),(46272,73,0,6462,'Bette Starlet Oval Super Steel Bath 1950 x 950mm - No TH'),(46273,109,5,6462,'Bette Starlet Oval Super Steel Bath 1950 x 950mm - No TH'),(46274,109,0,6462,'Bette Starlet Oval Super Steel Bath 1950 x 950mm - No TH'),(46275,121,5,6463,'bette-form-super-steel-bath-1900-x-800mm'),(46276,121,0,6463,'bette-form-super-steel-bath-1900-x-800mm'),(46277,84,5,6463,'Bette Form 1900 x 800 - Rectangular Single Ended Bath | Banyo'),(46278,84,0,6463,'Bette Form 1900 x 800 - Rectangular Single Ended Bath | Banyo'),(46279,86,5,6463,'Buy online Bette Form 1900 x 800  Rectangular Single Ended Bath from Banyo with special price discount. We offer a wide range of Modern Steel Bathtubs with the lowest prices in the UK.'),(46280,86,0,6463,'Buy online Bette Form 1900 x 800  Rectangular Single Ended Bath from Banyo with special price discount. We offer a wide range of Modern Steel Bathtubs with the lowest prices in the UK.'),(46281,73,5,6463,'Bette Form Super Steel Bath 1900 x 800mm '),(46282,73,0,6463,'Bette Form Super Steel Bath 1900 x 800mm '),(46283,109,5,6463,'bette-form-1'),(46284,109,0,6463,'bette-form-1'),(46285,110,5,6463,'bette-form-1'),(46286,110,0,6463,'bette-form-1'),(46287,111,5,6463,'bette-form-1'),(46288,111,0,6463,'bette-form-1'),(46289,121,5,6464,'bette-form-super-steel-bath-170-x-70mm-feet'),(46290,121,0,6464,'bette-form-super-steel-bath-170-x-70mm-feet'),(46291,84,5,6464,'Bette Form 1700 x 700 Rectangular Steel Bath - BE3970-000 | Bette Form'),(46292,84,0,6464,'Bette Form 1700 x 700 Rectangular Steel Bath - BE3970-000 | Bette Form'),(46293,86,5,6464,'Shop Online for Bette Form 1700 x 700 Rectangular Steel Bath from Banyo at a special discounted price. We offer special discounts on Bette Form Modern Affordable Bathroom products for more information call us on 0116 274 4059.'),(46294,86,0,6464,'Shop Online for Bette Form 1700 x 700 Rectangular Steel Bath from Banyo at a special discounted price. We offer special discounts on Bette Form Modern Affordable Bathroom products for more information call us on 0116 274 4059.'),(46295,73,5,6464,'Bette Form Super Steel Bath 1700 x 700mm'),(46296,73,0,6464,'Bette Form Super Steel Bath 1700 x 700mm'),(46297,109,5,6464,'Bette Form Super Steel Bath 1700 x 700mm'),(46298,109,0,6464,'Bette Form Super Steel Bath 1700 x 700mm'),(46299,110,5,6464,'Bette Form Super Steel Bath 1700 x 700mm'),(46300,110,0,6464,'Bette Form Super Steel Bath 1700 x 700mm'),(46301,111,5,6464,'Bette Form Super Steel Bath 1700 x 700mm'),(46302,111,0,6464,'Bette Form Super Steel Bath 1700 x 700mm'),(46303,121,5,6465,'bette-starlet-iv-silhouette-steel-bath-1650-x-750mm-no-th'),(46304,121,0,6465,'bette-starlet-iv-silhouette-steel-bath-1650-x-750mm-no-th'),(46305,84,5,6465,'Bette Starlet IV Silhouette 1650 x 750 - Enamel Steel Bath | Banyo'),(46306,84,0,6465,'Bette Starlet IV Silhouette 1650 x 750 - Enamel Steel Bath | Banyo'),(46307,86,5,6465,'Bette Starlet IV Silhouette 1650 x 750 is a Double Ended Enamel Steel Bath available on Banyo with affordable price. We offer the lowest prices in the UK along with the fastest delivery service.'),(46308,86,0,6465,'Bette Starlet IV Silhouette 1650 x 750 is a Double Ended Enamel Steel Bath available on Banyo with affordable price. We offer the lowest prices in the UK along with the fastest delivery service.'),(46309,73,5,6465,'Bette Starlet IV Silhouette Steel Bath 1650 x 750mm'),(46310,73,0,6465,'Bette Starlet IV Silhouette Steel Bath 1650 x 750mm'),(46311,109,5,6465,'Bette Starlet IV Silhouette Steel Bath 1650 x 750mm - No TH'),(46312,109,0,6465,'Bette Starlet IV Silhouette Steel Bath 1650 x 750mm - No TH'),(46313,121,5,6466,'bette-starlet-iv-silhouette-steel-bath-1750-x-800mm-no-th'),(46314,121,0,6466,'bette-starlet-iv-silhouette-steel-bath-1750-x-800mm-no-th'),(46315,84,5,6466,'Bette Starlet IV Silhouette 1750 x 800 - Super Steel Bath | Banyo'),(46316,84,0,6466,'Bette Starlet IV Silhouette 1750 x 800 - Super Steel Bath | Banyo'),(46317,86,5,6466,'Shop for Bette Starlet IV Silhouette 1750 x 800 with special discounted price offer on Banyo. We offer the best prices in the UK on all Double Ended Steel Baths.'),(46318,86,0,6466,'Shop for Bette Starlet IV Silhouette 1750 x 800 with special discounted price offer on Banyo. We offer the best prices in the UK on all Double Ended Steel Baths.'),(46319,73,5,6466,'Bette Starlet IV Silhouette Steel Bath 1750 x 800mm'),(46320,73,0,6466,'Bette Starlet IV Silhouette Steel Bath 1750 x 800mm'),(46321,109,5,6466,'Bette Starlet IV Silhouette Steel Bath 1750 x 800mm - No TH'),(46322,109,0,6466,'Bette Starlet IV Silhouette Steel Bath 1750 x 800mm - No TH'),(46323,121,5,6467,'bette-starlet-iv-silhouette-steel-bath-1850-x-850mm-no-th'),(46324,121,0,6467,'bette-starlet-iv-silhouette-steel-bath-1850-x-850mm-no-th'),(46325,84,5,6467,'Bette Starlet IV Silhouette 1850 x 850 Steel Bath | Banyo UK'),(46326,84,0,6467,'Bette Starlet IV Silhouette 1850 x 850 Steel Bath | Banyo UK'),(46327,86,5,6467,'Buy Bette Starlet IV Silhouette 1850 x 850 Steel Bath with special discounted price from Banyo.co.uk. We offer a full range of Double Ended Baths with the lowest prices.'),(46328,86,0,6467,'Buy Bette Starlet IV Silhouette 1850 x 850 Steel Bath with special discounted price from Banyo.co.uk. We offer a full range of Double Ended Baths with the lowest prices.'),(46329,73,5,6467,'Bette Starlet IV Silhouette Steel Bath 1850 x 850mm'),(46330,73,0,6467,'Bette Starlet IV Silhouette Steel Bath 1850 x 850mm'),(46331,109,5,6467,'Bette Starlet IV Silhouette Steel Bath 1850 x 850mm - No TH'),(46332,109,0,6467,'Bette Starlet IV Silhouette Steel Bath 1850 x 850mm - No TH'),(46333,121,5,6468,'bette-starlet-v-silhouette-steel-bath-1650-x-750mm-no-th'),(46334,121,0,6468,'bette-starlet-v-silhouette-steel-bath-1650-x-750mm-no-th'),(46335,84,5,6468,'Bette Starlet V Silhouette 1650 x 750 Steel Bath | Banyo UK'),(46336,84,0,6468,'Bette Starlet V Silhouette 1650 x 750 Steel Bath | Banyo UK'),(46337,86,5,6468,'Shop for Bette Starlet V Silhouette 165x75cm Steel Bath with a special discount on Banyo.co.uk. We offer the lowest prices on all Double Ended Enamel Steel baths.'),(46338,86,0,6468,'Shop for Bette Starlet V Silhouette 165x75cm Steel Bath with a special discount on Banyo.co.uk. We offer the lowest prices on all Double Ended Enamel Steel baths.'),(46339,73,5,6468,'Bette Starlet V Silhouette Steel Bath 1650 x 750mm - No TH'),(46340,73,0,6468,'Bette Starlet V Silhouette Steel Bath 1650 x 750mm - No TH'),(46341,109,5,6468,'Bette Starlet V Silhouette Steel Bath 1650 x 750mm - No TH'),(46342,109,0,6468,'Bette Starlet V Silhouette Steel Bath 1650 x 750mm - No TH'),(46343,121,5,6469,'bette-starlet-v-silhouette-steel-bath-1750-x-800mm-no-th'),(46344,121,0,6469,'bette-starlet-v-silhouette-steel-bath-1750-x-800mm-no-th'),(46345,84,5,6469,'Bette Starlet V Silhouette Steel Bath 1750 x 800 | Banyo.co.uk'),(46346,84,0,6469,'Bette Starlet V Silhouette Steel Bath 1750 x 800 | Banyo.co.uk'),(46347,86,5,6469,'At Banyo, we offer a special discounted price on Bette Starlet V Silhouette Steel Bath 1750 x 800 with manufacturers warranty and fastest delivery service in the UK.'),(46348,86,0,6469,'At Banyo, we offer a special discounted price on Bette Starlet V Silhouette Steel Bath 1750 x 800 with manufacturers warranty and fastest delivery service in the UK.'),(46349,73,5,6469,'Bette Starlet V Silhouette Steel Bath 1750 x 800mm - No TH'),(46350,73,0,6469,'Bette Starlet V Silhouette Steel Bath 1750 x 800mm - No TH'),(46351,109,5,6469,'Bette Starlet V Silhouette Steel Bath 1750 x 800mm - No TH'),(46352,109,0,6469,'Bette Starlet V Silhouette Steel Bath 1750 x 800mm - No TH'),(46353,121,5,6470,'bette-starlet-v-silhouette-steel-bath-1850-x-850mm-no-th'),(46354,121,0,6470,'bette-starlet-v-silhouette-steel-bath-1850-x-850mm-no-th'),(46355,84,5,6470,'Bette Starlet V Silhouette 1850 x 850 Steel Bath | Banyo UK'),(46356,84,0,6470,'Bette Starlet V Silhouette 1850 x 850 Steel Bath | Banyo UK'),(46357,86,5,6470,'Shop for Bette Starlet V Silhouette 1850 x 850 bath from Banyo. We offer affordable prices on all Steel Enamel Baths in the UK along with the fastest delivery service.'),(46358,86,0,6470,'Shop for Bette Starlet V Silhouette 1850 x 850 bath from Banyo. We offer affordable prices on all Steel Enamel Baths in the UK along with the fastest delivery service.'),(46359,73,5,6470,'Bette Starlet V Silhouette Steel Bath 1850 x 850mm - No TH'),(46360,73,0,6470,'Bette Starlet V Silhouette Steel Bath 1850 x 850mm - No TH'),(46361,109,5,6470,'Bette Starlet V Silhouette Steel Bath 1850 x 850mm - No TH'),(46362,109,0,6470,'Bette Starlet V Silhouette Steel Bath 1850 x 850mm - No TH'),(46363,121,5,6471,'bette-ocean-super-steel-bath-1800-x-800mm-no-th'),(46364,121,0,6471,'bette-ocean-super-steel-bath-1800-x-800mm-no-th'),(46365,84,5,6471,'Bette Ocean 1800 x 800 - Super Steel Bath 8856 8857 | Banyo'),(46366,84,0,6471,'Bette Ocean 1800 x 800 - Super Steel Bath 8856 8857 | Banyo'),(46367,86,5,6471,'Bette Ocean 1800 x 800 Super Steel Bath 8856 8857 is a Single-Ended Rectangular bathtub with White colour finish available on Banyo at an affordable price and fastest delivery service.'),(46368,86,0,6471,'Bette Ocean 1800 x 800 Super Steel Bath 8856 8857 is a Single-Ended Rectangular bathtub with White colour finish available on Banyo at an affordable price and fastest delivery service.'),(46369,73,5,6471,'Bette Ocean Super Steel Bath 1800 x 800mm - No TH'),(46370,73,0,6471,'Bette Ocean Super Steel Bath 1800 x 800mm - No TH'),(46371,109,5,6471,'Bette Ocean Super Steel Bath'),(46372,109,0,6471,'Bette Ocean Super Steel Bath'),(46373,110,5,6471,'Bette Ocean Super Steel Bath'),(46374,110,0,6471,'Bette Ocean Super Steel Bath'),(46375,111,5,6471,'Bette Ocean Super Steel Bath'),(46376,111,0,6471,'Bette Ocean Super Steel Bath'),(46377,121,5,6472,'bette-ocean-lowline-super-steel-bath-1500-x-700mm-no-th'),(46378,121,0,6472,'bette-ocean-lowline-super-steel-bath-1500-x-700mm-no-th'),(46379,84,5,6472,'Bette Lowline Ocean 1500 x 700mm - Bette Steel Bath | Banyo'),(46380,84,0,6472,'Bette Lowline Ocean 1500 x 700mm - Bette Steel Bath | Banyo'),(46381,86,5,6472,'At Banyo, we offer a complete range of Bette Bath Products with the lowest prices in the UK. Special discount on Bette Lowline Ocean 1500 x 700mm Steel Bath for more info contact 0116 274 4059.'),(46382,86,0,6472,'At Banyo, we offer a complete range of Bette Bath Products with the lowest prices in the UK. Special discount on Bette Lowline Ocean 1500 x 700mm Steel Bath for more info contact 0116 274 4059.'),(46383,73,5,6472,'Bette Ocean Lowline Super Steel Bath 1500 x 700mm - No TH'),(46384,73,0,6472,'Bette Ocean Lowline Super Steel Bath 1500 x 700mm - No TH'),(46385,109,5,6472,'Bette Ocean Lowline 1500'),(46386,109,0,6472,'Bette Ocean Lowline 1500'),(46387,110,5,6472,'Bette Ocean Lowline 1500'),(46388,110,0,6472,'Bette Ocean Lowline 1500'),(46389,111,5,6472,'Bette Ocean Lowline 1500'),(46390,111,0,6472,'Bette Ocean Lowline 1500'),(46391,121,5,6473,'bette-ocean-super-steel-bath-150-x-70cm-feet-no-th'),(46392,121,0,6473,'bette-ocean-super-steel-bath-150-x-70cm-feet-no-th'),(46393,84,5,6473,'Bette Ocean 1500 x 700mm - Bette Super Steel Bath | Banyo'),(46394,84,0,6473,'Bette Ocean 1500 x 700mm - Bette Super Steel Bath | Banyo'),(46395,86,5,6473,'Bette Ocean 1500 x 700mm Super Steel Bath is available on Banyo with a special discounted price. We offer the lowest prices in the UK along with the fastest delivery service.'),(46396,86,0,6473,'Bette Ocean 1500 x 700mm Super Steel Bath is available on Banyo with a special discounted price. We offer the lowest prices in the UK along with the fastest delivery service.'),(46397,73,5,6473,'Bette Ocean Super Steel Bath 1500 x 700mm - No TH'),(46398,73,0,6473,'Bette Ocean Super Steel Bath 1500 x 700mm - No TH'),(46399,109,5,6473,'Bette Ocean 1500'),(46400,109,0,6473,'Bette Ocean 1500'),(46401,110,5,6473,'Bette Ocean 1500'),(46402,110,0,6473,'Bette Ocean 1500'),(46403,111,5,6473,'Bette Ocean 1500'),(46404,111,0,6473,'Bette Ocean 1500'),(46405,121,5,6474,'bette-ocean-super-steel-bath-1600-x-700mm-no-th'),(46406,121,0,6474,'bette-ocean-super-steel-bath-1600-x-700mm-no-th'),(46407,84,5,6474,'Bette Ocean 1600 x 700mm - Rectangular Steel Bath | Banyo'),(46408,84,0,6474,'Bette Ocean 1600 x 700mm - Rectangular Steel Bath | Banyo'),(46409,86,5,6474,'Bette Ocean Bath 1600 x 700mm is a Rectangular Steel Bath and is available with a special price discount on Banyo. We offer an extensive range of Bette Bath products with the lowest prices in the UK.'),(46410,86,0,6474,'Bette Ocean Bath 1600 x 700mm is a Rectangular Steel Bath and is available with a special price discount on Banyo. We offer an extensive range of Bette Bath products with the lowest prices in the UK.'),(46411,73,5,6474,'Bette Ocean Super Steel Bath 1600 x 700mm - No TH'),(46412,73,0,6474,'Bette Ocean Super Steel Bath 1600 x 700mm - No TH'),(46413,109,5,6474,'Bette Ocean Super Steel Bath 1600 x 700mm - No TH'),(46414,109,0,6474,'Bette Ocean Super Steel Bath 1600 x 700mm - No TH'),(46415,110,5,6474,'Bette Ocean Super Steel Bath 1600 x 700mm - No TH'),(46416,110,0,6474,'Bette Ocean Super Steel Bath 1600 x 700mm - No TH'),(46417,111,5,6474,'Bette Ocean Super Steel Bath 1600 x 700mm - No TH'),(46418,111,0,6474,'Bette Ocean Super Steel Bath 1600 x 700mm - No TH'),(46419,121,5,6475,'bette-ocean-super-steel-bath-1700-x-800mm-no-th'),(46420,121,0,6475,'bette-ocean-super-steel-bath-1700-x-800mm-no-th'),(46421,84,5,6475,'Bette Ocean 1700 x 800mm - Rectangular Super Steel Bath | Banyo'),(46422,84,0,6475,'Bette Ocean 1700 x 800mm - Rectangular Super Steel Bath | Banyo'),(46423,86,5,6475,'Special price discount is available on Bette Ocean Bath 1700 x 800mm Rectangular Super Steel Bath. At Banyo, we offer the lowest prices on all Bette bath products for more info contact 0116 274 4059.'),(46424,86,0,6475,'Special price discount is available on Bette Ocean Bath 1700 x 800mm Rectangular Super Steel Bath. At Banyo, we offer the lowest prices on all Bette bath products for more info contact 0116 274 4059.'),(46425,73,5,6475,'Bette Ocean Super Steel Bath 1700 x 800mm - No TH'),(46426,73,0,6475,'Bette Ocean Super Steel Bath 1700 x 800mm - No TH'),(46427,109,5,6475,'Bette Ocean Super Steel Bath 1700 x 800mm - No TH'),(46428,109,0,6475,'Bette Ocean Super Steel Bath 1700 x 800mm - No TH'),(46429,110,5,6475,'Bette Ocean Super Steel Bath 1700 x 800mm - No TH'),(46430,110,0,6475,'Bette Ocean Super Steel Bath 1700 x 800mm - No TH'),(46431,111,5,6475,'Bette Ocean Super Steel Bath 1700 x 800mm - No TH'),(46432,111,0,6475,'Bette Ocean Super Steel Bath 1700 x 800mm - No TH'),(46433,121,5,6476,'bette-ocean-super-steel-bath-1700-x-700mm'),(46434,121,0,6476,'bette-ocean-super-steel-bath-1700-x-700mm'),(46435,84,5,6476,'Bette Ocean 1700 x 700mm - Super Steel Rectangular Bath | Banyo'),(46436,84,0,6476,'Bette Ocean 1700 x 700mm - Super Steel Rectangular Bath | Banyo'),(46437,86,5,6476,'Bette Ocean Bath 1700 x 700mm is a Super Steel Rectangular Bath available on Banyo with 30years of manufacturer warranty. We offer the lowest prices in the UK on all Bette bath products.'),(46438,86,0,6476,'Bette Ocean Bath 1700 x 700mm is a Super Steel Rectangular Bath available on Banyo with 30years of manufacturer warranty. We offer the lowest prices in the UK on all Bette bath products.'),(46439,73,5,6476,'Bette Ocean Super Steel Bath 1700 x 700mm '),(46440,73,0,6476,'Bette Ocean Super Steel Bath 1700 x 700mm '),(46441,109,5,6476,'Bette Ocean Super Steel Bath'),(46442,109,0,6476,'Bette Ocean Super Steel Bath'),(46443,110,5,6476,'Bette Ocean Super Steel Bath'),(46444,110,0,6476,'Bette Ocean Super Steel Bath'),(46445,111,5,6476,'Bette Ocean Super Steel Bath'),(46446,111,0,6476,'Bette Ocean Super Steel Bath'),(46447,121,5,6477,'bette-ocean-super-steel-bath-170-x-75cm-feet-no-th'),(46448,121,0,6477,'bette-ocean-super-steel-bath-170-x-75cm-feet-no-th'),(46449,84,5,6477,'Bette Ocean Bath - 1700 x 750mm Super Steel Bath | Banyo'),(46450,84,0,6477,'Bette Ocean Bath - 1700 x 750mm Super Steel Bath | Banyo'),(46451,86,5,6477,'Banyo offers a complete range of Bette Baths products with the lowest prices in the UK. Special discounted price available on Bette Ocean 1700 x 750mm Super Steel Bath.'),(46452,86,0,6477,'Banyo offers a complete range of Bette Baths products with the lowest prices in the UK. Special discounted price available on Bette Ocean 1700 x 750mm Super Steel Bath.'),(46453,73,5,6477,'Bette Ocean Super Steel Bath 1700 x 750mm - No TH'),(46454,73,0,6477,'Bette Ocean Super Steel Bath 1700 x 750mm - No TH'),(46455,109,5,6477,'Bette Ocean Super Steel Bath 1700 x 750mm - No TH'),(46456,109,0,6477,'Bette Ocean Super Steel Bath 1700 x 750mm - No TH'),(46457,110,5,6477,'Bette Ocean Super Steel Bath 1700 x 750mm - No TH'),(46458,110,0,6477,'Bette Ocean Super Steel Bath 1700 x 750mm - No TH'),(46459,111,5,6477,'Bette Ocean Super Steel Bath 1700 x 750mm - No TH'),(46460,111,0,6477,'Bette Ocean Super Steel Bath 1700 x 750mm - No TH'),(46461,121,5,6478,'bette-ocean-lowline-super-steel-bath-1600-x-700mm-no-th'),(46462,121,0,6478,'bette-ocean-lowline-super-steel-bath-1600-x-700mm-no-th'),(46463,84,5,6478,'Bette Ocean Lowline 1600 x 700mm Bath - Rectangular Steel Bath | Banyo'),(46464,84,0,6478,'Bette Ocean Lowline 1600 x 700mm Bath - Rectangular Steel Bath | Banyo'),(46465,86,5,6478,'Bette Ocean Lowline 1600 x 700mm is a Rectangular Steel double ended Bath supplied with No tap Hole. At Banyo, we offer the fastest delivery service and the best prices in the UK.'),(46466,86,0,6478,'Bette Ocean Lowline 1600 x 700mm is a Rectangular Steel double ended Bath supplied with No tap Hole. At Banyo, we offer the fastest delivery service and the best prices in the UK.'),(46467,73,5,6478,'Bette Ocean Lowline Super Steel Bath 1600 x 700mm - No TH'),(46468,73,0,6478,'Bette Ocean Lowline Super Steel Bath 1600 x 700mm - No TH'),(46469,109,5,6478,'Bette Ocean Lowline Super Steel Bath 1600 x 700mm - No TH'),(46470,109,0,6478,'Bette Ocean Lowline Super Steel Bath 1600 x 700mm - No TH'),(46471,110,5,6478,'Bette Ocean Lowline Super Steel Bath 1600 x 700mm - No TH'),(46472,110,0,6478,'Bette Ocean Lowline Super Steel Bath 1600 x 700mm - No TH'),(46473,111,5,6478,'Bette Ocean Lowline Super Steel Bath 1600 x 700mm - No TH'),(46474,111,0,6478,'Bette Ocean Lowline Super Steel Bath 1600 x 700mm - No TH'),(46475,121,5,6479,'bette-ocean-lowline-super-steel-bath-1700-x-800mm-no-th'),(46476,121,0,6479,'bette-ocean-lowline-super-steel-bath-1700-x-800mm-no-th'),(46477,84,5,6479,'Bette Ocean Lowline 1700 x 800mm - 30% Price Discount | Banyo'),(46478,84,0,6479,'Bette Ocean Lowline 1700 x 800mm - 30% Price Discount | Banyo'),(46479,86,5,6479,'Bette Ocean Lowline 1700 x 800mm is available on Banyo with 30% Price Discount and 30years of manufacturer warranty. We offer the Unbeatable prices (Price match promise) in the UK.'),(46480,86,0,6479,'Bette Ocean Lowline 1700 x 800mm is available on Banyo with 30% Price Discount and 30years of manufacturer warranty. We offer the Unbeatable prices (Price match promise) in the UK.'),(46481,73,5,6479,'Bette Ocean Lowline Super Steel Bath 1700 x 800mm - No TH'),(46482,73,0,6479,'Bette Ocean Lowline Super Steel Bath 1700 x 800mm - No TH'),(46483,109,5,6479,'Bette Ocean Super Steel Bath'),(46484,109,0,6479,'Bette Ocean Super Steel Bath'),(46485,110,5,6479,'Bette Ocean Super Steel Bath'),(46486,110,0,6479,'Bette Ocean Super Steel Bath'),(46487,111,5,6479,'Bette Ocean Super Steel Bath'),(46488,111,0,6479,'Bette Ocean Super Steel Bath'),(46489,121,5,6480,'bette-ocean-lowline-super-steel-bath-1700-x-700mm'),(46490,121,0,6480,'bette-ocean-lowline-super-steel-bath-1700-x-700mm'),(46491,84,5,6480,'Bette 1700 x 700mm Ocean Lowline - Super Steel Bath | Banyo'),(46492,84,0,6480,'Bette 1700 x 700mm Ocean Lowline - Super Steel Bath | Banyo'),(46493,86,5,6480,'At Banyo, we are offering special price discount on Bette 1700 x 700mm Ocean Lowline Super Steel Rectangular Bath (no tap hole) and 30years of manufacturer warranty.'),(46494,86,0,6480,'At Banyo, we are offering special price discount on Bette 1700 x 700mm Ocean Lowline Super Steel Rectangular Bath (no tap hole) and 30years of manufacturer warranty.'),(46495,73,5,6480,'Bette Ocean Lowline Super Steel Bath 1700 x 700mm '),(46496,73,0,6480,'Bette Ocean Lowline Super Steel Bath 1700 x 700mm '),(46497,109,5,6480,'Bette Ocean Lowline Super Steel Bath 1700 x 700mm '),(46498,109,0,6480,'Bette Ocean Lowline Super Steel Bath 1700 x 700mm '),(46499,110,5,6480,'Bette Ocean Lowline Super Steel Bath 1700 x 700mm '),(46500,110,0,6480,'Bette Ocean Lowline Super Steel Bath 1700 x 700mm '),(46501,111,5,6480,'Bette Ocean Lowline Super Steel Bath 1700 x 700mm '),(46502,111,0,6480,'Bette Ocean Lowline Super Steel Bath 1700 x 700mm '),(46503,121,5,6481,'bette-ocean-lowline-super-steel-bath-1700-x-750mm-no-th'),(46504,121,0,6481,'bette-ocean-lowline-super-steel-bath-1700-x-750mm-no-th'),(46505,84,5,6481,'Bette Ocean 1700 x 750mm Lowline Bath - Super Steel Bath | Banyo'),(46506,84,0,6481,'Bette Ocean 1700 x 750mm Lowline Bath - Super Steel Bath | Banyo'),(46507,86,5,6481,'At Banyo, we are offering a 30% price discount on Bette Ocean Lowline 1700 x 750mm super steel bath (no tap holes) for more information feel free to contact us on 0116 274 4059.'),(46508,86,0,6481,'At Banyo, we are offering a 30% price discount on Bette Ocean Lowline 1700 x 750mm super steel bath (no tap holes) for more information feel free to contact us on 0116 274 4059.'),(46509,73,5,6481,'Bette Ocean Lowline Super Steel Bath 1700 x 750mm - No TH'),(46510,73,0,6481,'Bette Ocean Lowline Super Steel Bath 1700 x 750mm - No TH'),(46511,109,5,6481,'Bette Ocean Lowline Super Steel Bath 1700 x 750mm - No TH'),(46512,109,0,6481,'Bette Ocean Lowline Super Steel Bath 1700 x 750mm - No TH'),(46513,110,5,6481,'Bette Ocean Lowline Super Steel Bath 1700 x 750mm - No TH'),(46514,110,0,6481,'Bette Ocean Lowline Super Steel Bath 1700 x 750mm - No TH'),(46515,111,5,6481,'Bette Ocean Lowline Super Steel Bath 1700 x 750mm - No TH'),(46516,111,0,6481,'Bette Ocean Lowline Super Steel Bath 1700 x 750mm - No TH'),(46517,121,5,6482,'bette-ocean-lowline-super-steel-bath-1800-x-800mm-no-th'),(46518,121,0,6482,'bette-ocean-lowline-super-steel-bath-1800-x-800mm-no-th'),(46519,84,5,6482,'Bette Ocean 1800 x 800mm Lowline Bath - Rectangular Steel Bath | Banyo'),(46520,84,0,6482,'Bette Ocean 1800 x 800mm Lowline Bath - Rectangular Steel Bath | Banyo'),(46521,86,5,6482,'Stylish and Spacious! Bette Ocean 1800 x 800mm Lowline Rectangular Steel Bath supplied with no tap hole is available on Banyo with a special discounted price for more info 0116 274 4059.'),(46522,86,0,6482,'Stylish and Spacious! Bette Ocean 1800 x 800mm Lowline Rectangular Steel Bath supplied with no tap hole is available on Banyo with a special discounted price for more info 0116 274 4059.'),(46523,73,5,6482,'Bette Ocean Lowline Super Steel Bath 1800 x 800mm - No TH'),(46524,73,0,6482,'Bette Ocean Lowline Super Steel Bath 1800 x 800mm - No TH'),(46525,109,5,6482,'Bette Ocean Lowline Super Steel Bath 1800 x 800mm - No TH'),(46526,109,0,6482,'Bette Ocean Lowline Super Steel Bath 1800 x 800mm - No TH'),(46527,110,5,6482,'Bette Ocean Lowline Super Steel Bath 1800 x 800mm - No TH'),(46528,110,0,6482,'Bette Ocean Lowline Super Steel Bath 1800 x 800mm - No TH'),(46529,111,5,6482,'Bette Ocean Lowline Super Steel Bath 1800 x 800mm - No TH'),(46530,111,0,6482,'Bette Ocean Lowline Super Steel Bath 1800 x 800mm - No TH'),(46531,121,5,6483,'bette-art-steel-oval-bath-1800-750mm-no-th'),(46532,121,0,6483,'bette-art-steel-oval-bath-1800-750mm-no-th'),(46533,84,5,6483,'Bette Art Oval 1800 x 750 - Double Ended Steel Bath | Banyo'),(46534,84,0,6483,'Bette Art Oval 1800 x 750 - Double Ended Steel Bath | Banyo'),(46535,86,5,6483,'Bette Art Oval 1800 x 750 is a Double Ended Freestanding Steel Bath with White colour finish available on Banyo at an affordable price and fastest delivery service in the UK.'),(46536,86,0,6483,'Bette Art Oval 1800 x 750 is a Double Ended Freestanding Steel Bath with White colour finish available on Banyo at an affordable price and fastest delivery service in the UK.'),(46537,73,5,6483,'Bette Art Steel Oval Bath 1800 x 750mm - No TH'),(46538,73,0,6483,'Bette Art Steel Oval Bath 1800 x 750mm - No TH'),(46539,109,5,6483,'Bette Art Steel Oval Bath 1800 x 750mm - No TH'),(46540,109,0,6483,'Bette Art Steel Oval Bath 1800 x 750mm - No TH'),(46541,121,5,6484,'bette-duo-super-steel-rectangular-bath-1800-x-800mm'),(46542,121,0,6484,'bette-duo-super-steel-rectangular-bath-1800-x-800mm'),(46543,84,5,6484,'Bette Duo 1800 x 800 - Super Steel Rectangular Bath | Banyo'),(46544,84,0,6484,'Bette Duo 1800 x 800 - Super Steel Rectangular Bath | Banyo'),(46545,86,5,6484,'Special Price discount is available on Bette Duo 1800 x 800 at Banyo. We offer the lowest price in the UK on all Rectangular steel Bathtubs along with a fast delivery service.'),(46546,86,0,6484,'Special Price discount is available on Bette Duo 1800 x 800 at Banyo. We offer the lowest price in the UK on all Rectangular steel Bathtubs along with a fast delivery service.'),(46547,73,5,6484,'Bette Duo Super Steel Rectangular Bath 1800 x 800mm'),(46548,73,0,6484,'Bette Duo Super Steel Rectangular Bath 1800 x 800mm'),(46549,109,5,6484,'Bette Duo Super Steel Rectangular Bath 1800 x 800mm'),(46550,109,0,6484,'Bette Duo Super Steel Rectangular Bath 1800 x 800mm'),(46551,121,5,6485,'rak-cloud-freestanding-bath-1400-x-753mm'),(46552,121,0,6485,'rak-cloud-freestanding-bath-1400-x-753mm'),(46553,84,5,6485,'RAK Cloud Freestanding Bath 1400 x 753mm'),(46554,84,0,6485,'RAK Cloud Freestanding Bath 1400 x 753mm'),(46555,86,5,6485,'RAK Cloud Freestanding Bath 1400 x 753mm '),(46556,86,0,6485,'RAK Cloud Freestanding Bath 1400 x 753mm '),(46557,73,5,6485,'RAK Cloud Freestanding Bath 1400 x 753mm'),(46558,73,0,6485,'RAK Cloud Freestanding Bath 1400 x 753mm'),(46559,121,5,6486,'rak-evolution-double-ended-rectangular-bath-1750-x-750mm'),(46560,121,0,6486,'rak-evolution-double-ended-rectangular-bath-1750-x-750mm'),(46561,84,5,6486,'RAK Evolution Double Ended Rectangular Bath 1750 x 750mm'),(46562,84,0,6486,'RAK Evolution Double Ended Rectangular Bath 1750 x 750mm'),(46563,86,5,6486,'RAK Evolution Double Ended Rectangular Bath 1750 x 750mm '),(46564,86,0,6486,'RAK Evolution Double Ended Rectangular Bath 1750 x 750mm '),(46565,73,5,6486,'RAK Evolution Double Ended Rectangular Bath 1750 x 750mm'),(46566,73,0,6486,'RAK Evolution Double Ended Rectangular Bath 1750 x 750mm'),(46567,121,5,6487,'rak-karla-single-ended-rectangular-bath-1700-x-700mm'),(46568,121,0,6487,'rak-karla-single-ended-rectangular-bath-1700-x-700mm'),(46569,84,5,6487,'RAK Karla Single Ended Rectangular Bath 1700 x 700mm'),(46570,84,0,6487,'RAK Karla Single Ended Rectangular Bath 1700 x 700mm'),(46571,86,5,6487,'RAK Karla Single Ended Rectangular Bath 1700 x 700mm '),(46572,86,0,6487,'RAK Karla Single Ended Rectangular Bath 1700 x 700mm '),(46573,73,5,6487,'RAK Karla Single Ended Rectangular Bath 1700 x 700mm'),(46574,73,0,6487,'RAK Karla Single Ended Rectangular Bath 1700 x 700mm'),(46575,121,5,6488,'rak-reserva-single-ended-rectangular-bath-1700-x-800mm'),(46576,121,0,6488,'rak-reserva-single-ended-rectangular-bath-1700-x-800mm'),(46577,84,5,6488,'RAK Reserva Single Ended Rectangular Bath 1700 x 800mm'),(46578,84,0,6488,'RAK Reserva Single Ended Rectangular Bath 1700 x 800mm'),(46579,86,5,6488,'RAK Reserva Single Ended Rectangular Bath 1700 x 800mm '),(46580,86,0,6488,'RAK Reserva Single Ended Rectangular Bath 1700 x 800mm '),(46581,73,5,6488,'RAK Reserva Single Ended Rectangular Bath 1700 x 800mm'),(46582,73,0,6488,'RAK Reserva Single Ended Rectangular Bath 1700 x 800mm'),(46583,121,5,6489,'rak-washington-single-ended-bath-with-leg-set-1700-x-700mm'),(46584,121,0,6489,'rak-washington-single-ended-bath-with-leg-set-1700-x-700mm'),(46585,84,5,6489,'RAK Washington Single Ended Bath with Leg Set 1700 x 700mm'),(46586,84,0,6489,'RAK Washington Single Ended Bath with Leg Set 1700 x 700mm'),(46587,86,5,6489,'RAK Washington Single Ended Bath with Leg Set 1700 x 700mm '),(46588,86,0,6489,'RAK Washington Single Ended Bath with Leg Set 1700 x 700mm '),(46589,73,5,6489,'RAK Washington Single Ended Bath with Leg Set 1700 x 700mm'),(46590,73,0,6489,'RAK Washington Single Ended Bath with Leg Set 1700 x 700mm'),(46591,121,5,6490,'rak-washington-single-ended-bath-with-leg-set-1700-x-750mm'),(46592,121,0,6490,'rak-washington-single-ended-bath-with-leg-set-1700-x-750mm'),(46593,84,5,6490,'RAK Washington Single Ended Bath with Leg Set 1700 x 750mm'),(46594,84,0,6490,'RAK Washington Single Ended Bath with Leg Set 1700 x 750mm'),(46595,86,5,6490,'RAK Washington Single Ended Bath with Leg Set 1700 x 750mm '),(46596,86,0,6490,'RAK Washington Single Ended Bath with Leg Set 1700 x 750mm '),(46597,73,5,6490,'RAK Washington Single Ended Bath with Leg Set 1700 x 750mm'),(46598,73,0,6490,'RAK Washington Single Ended Bath with Leg Set 1700 x 750mm'),(46599,121,5,6491,'rak-washington-freestanding-bath-1560-x-810mm'),(46600,121,0,6491,'rak-washington-freestanding-bath-1560-x-810mm'),(46601,84,5,6491,'RAK Washington Freestanding Bath 1560 x 810mm'),(46602,84,0,6491,'RAK Washington Freestanding Bath 1560 x 810mm'),(46603,86,5,6491,'RAK Washington Freestanding Bath 1560 x 810mm '),(46604,86,0,6491,'RAK Washington Freestanding Bath 1560 x 810mm '),(46605,73,5,6491,'RAK Washington Freestanding Bath 1560 x 810mm'),(46606,73,0,6491,'RAK Washington Freestanding Bath 1560 x 810mm'),(46607,121,5,6492,'hudson-reed-grace-freestanding-round-bath-1510-x-760mm'),(46608,121,0,6492,'hudson-reed-grace-freestanding-round-bath-1510-x-760mm'),(46609,73,5,6492,'Hudson Reed Grace Freestanding Round Bath 1510 x 760mm'),(46610,73,0,6492,'Hudson Reed Grace Freestanding Round Bath 1510 x 760mm'),(46611,109,5,6492,'Hudson Reed Grace Freestanding Bath'),(46612,109,0,6492,'Hudson Reed Grace Freestanding Bath'),(46613,110,5,6492,'Hudson Reed Grace Freestanding Bath'),(46614,110,0,6492,'Hudson Reed Grace Freestanding Bath'),(46615,111,5,6492,'Hudson Reed Grace Freestanding Bath'),(46616,111,0,6492,'Hudson Reed Grace Freestanding Bath'),(46617,121,5,6493,'hudson-reed-rose-freestanding-bath-1510-x-760mm'),(46618,121,0,6493,'hudson-reed-rose-freestanding-bath-1510-x-760mm'),(46619,73,5,6493,'Hudson Reed Rose Freestanding Bath 1510 x 760mm '),(46620,73,0,6493,'Hudson Reed Rose Freestanding Bath 1510 x 760mm '),(46621,109,5,6493,'Hudson Reed Rose Freestanding Bath'),(46622,109,0,6493,'Hudson Reed Rose Freestanding Bath'),(46623,110,5,6493,'Hudson Reed Rose Freestanding Bath'),(46624,110,0,6493,'Hudson Reed Rose Freestanding Bath'),(46625,111,5,6493,'Hudson Reed Rose Freestanding Bath'),(46626,111,0,6493,'Hudson Reed Rose Freestanding Bath'),(46627,121,5,6494,'hudson-reed-bella-freestanding-bath-1495-x-720mm'),(46628,121,0,6494,'hudson-reed-bella-freestanding-bath-1495-x-720mm'),(46629,73,5,6494,'Hudson Reed Bella Freestanding Bath 1495 x 720mm'),(46630,73,0,6494,'Hudson Reed Bella Freestanding Bath 1495 x 720mm'),(46631,109,5,6494,'Hudson Reed Bella Freestanding Bath'),(46632,109,0,6494,'Hudson Reed Bella Freestanding Bath'),(46633,110,5,6494,'Hudson Reed Bella Freestanding Bath'),(46634,110,0,6494,'Hudson Reed Bella Freestanding Bath'),(46635,111,5,6494,'Hudson Reed Bella Freestanding Bath'),(46636,111,0,6494,'Hudson Reed Bella Freestanding Bath'),(46637,121,5,6495,'hudson-reed-farringdon-freestanding-bath-1555-x-740mm'),(46638,121,0,6495,'hudson-reed-farringdon-freestanding-bath-1555-x-740mm'),(46639,73,5,6495,'Hudson Reed Farringdon Freestanding Bath 1555 X 740mm'),(46640,73,0,6495,'Hudson Reed Farringdon Freestanding Bath 1555 X 740mm'),(46641,109,5,6495,'Hudson Reed Farringdon Freestanding Bath'),(46642,109,0,6495,'Hudson Reed Farringdon Freestanding Bath'),(46643,110,5,6495,'Hudson Reed Farringdon Freestanding Bath'),(46644,110,0,6495,'Hudson Reed Farringdon Freestanding Bath'),(46645,111,5,6495,'Hudson Reed Farringdon Freestanding Bath'),(46646,111,0,6495,'Hudson Reed Farringdon Freestanding Bath'),(46647,121,5,6496,'hudson-reed-ascott-art-deco-bath-1700-x-700mm'),(46648,121,0,6496,'hudson-reed-ascott-art-deco-bath-1700-x-700mm'),(46649,73,5,6496,'Hudson Reed Ascott Art Deco Bath - 1700 X 700mm'),(46650,73,0,6496,'Hudson Reed Ascott Art Deco Bath - 1700 X 700mm'),(46651,109,5,6496,'Hudson Reed Ascott Art Deco Bath - 1700 X 700mm'),(46652,109,0,6496,'Hudson Reed Ascott Art Deco Bath - 1700 X 700mm'),(46653,110,5,6496,'Hudson Reed Ascott Art Deco Bath - 1700 X 700mm'),(46654,110,0,6496,'Hudson Reed Ascott Art Deco Bath - 1700 X 700mm'),(46655,111,5,6496,'Hudson Reed Ascott Art Deco Bath - 1700 X 700mm'),(46656,111,0,6496,'Hudson Reed Ascott Art Deco Bath - 1700 X 700mm'),(46657,121,5,6497,'hudson-reed-ascott-art-deco-bath-1700-x-750mm'),(46658,121,0,6497,'hudson-reed-ascott-art-deco-bath-1700-x-750mm'),(46659,73,5,6497,'Hudson Reed Ascott Art Deco Bath - 1700 X 750mm'),(46660,73,0,6497,'Hudson Reed Ascott Art Deco Bath - 1700 X 750mm'),(46661,109,5,6497,'Hudson Reed Ascott Art Deco Bath - 1700 X 750mm'),(46662,109,0,6497,'Hudson Reed Ascott Art Deco Bath - 1700 X 750mm'),(46663,110,5,6497,'Hudson Reed Ascott Art Deco Bath - 1700 X 750mm'),(46664,110,0,6497,'Hudson Reed Ascott Art Deco Bath - 1700 X 750mm'),(46665,111,5,6497,'Hudson Reed Ascott Art Deco Bath - 1700 X 750mm'),(46666,111,0,6497,'Hudson Reed Ascott Art Deco Bath - 1700 X 750mm'),(46667,121,5,6498,'hudson-reed-ascott-art-deco-bath-1800-x-800mm'),(46668,121,0,6498,'hudson-reed-ascott-art-deco-bath-1800-x-800mm'),(46669,73,5,6498,'Hudson Reed Ascott Art Deco Bath - 1800 X 800mm'),(46670,73,0,6498,'Hudson Reed Ascott Art Deco Bath - 1800 X 800mm'),(46671,109,5,6498,'Hudson Reed Ascott Art Deco Bath - 1800 X 800mm'),(46672,109,0,6498,'Hudson Reed Ascott Art Deco Bath - 1800 X 800mm'),(46673,110,5,6498,'Hudson Reed Ascott Art Deco Bath - 1800 X 800mm'),(46674,110,0,6498,'Hudson Reed Ascott Art Deco Bath - 1800 X 800mm'),(46675,111,5,6498,'Hudson Reed Ascott Art Deco Bath - 1800 X 800mm'),(46676,111,0,6498,'Hudson Reed Ascott Art Deco Bath - 1800 X 800mm'),(46677,121,5,6499,'hudson-reed-kenton-freestanding-bath-1700-x-750mm'),(46678,121,0,6499,'hudson-reed-kenton-freestanding-bath-1700-x-750mm'),(46679,73,5,6499,'Hudson Reed Kenton Freestanding Bath 1700 x 750mm'),(46680,73,0,6499,'Hudson Reed Kenton Freestanding Bath 1700 x 750mm'),(46681,109,5,6499,'Hudson Reed Kenton Freestanding Bath Pride Leg Set - 1700mm'),(46682,109,0,6499,'Hudson Reed Kenton Freestanding Bath Pride Leg Set - 1700mm'),(46683,110,5,6499,'Hudson Reed Kenton Freestanding Bath Pride Leg Set - 1700mm'),(46684,110,0,6499,'Hudson Reed Kenton Freestanding Bath Pride Leg Set - 1700mm'),(46685,111,5,6499,'Hudson Reed Kenton Freestanding Bath Pride Leg Set - 1700mm'),(46686,111,0,6499,'Hudson Reed Kenton Freestanding Bath Pride Leg Set - 1700mm'),(46687,121,5,6500,'hudson-reed-brockley-freestanding-bath-1500-x-750mm'),(46688,121,0,6500,'hudson-reed-brockley-freestanding-bath-1500-x-750mm'),(46689,73,5,6500,'Hudson Reed Brockley Freestanding Bath 1500 x 750mm'),(46690,73,0,6500,'Hudson Reed Brockley Freestanding Bath 1500 x 750mm'),(46691,109,5,6500,'Hudson Reed Brockley Freestanding Bath Pride Leg Set - 1500mm'),(46692,109,0,6500,'Hudson Reed Brockley Freestanding Bath Pride Leg Set - 1500mm'),(46693,110,5,6500,'Hudson Reed Brockley Freestanding Bath Pride Leg Set - 1500mm'),(46694,110,0,6500,'Hudson Reed Brockley Freestanding Bath Pride Leg Set - 1500mm'),(46695,111,5,6500,'Hudson Reed Brockley Freestanding Bath Pride Leg Set - 1500mm'),(46696,111,0,6500,'Hudson Reed Brockley Freestanding Bath Pride Leg Set - 1500mm'),(46697,121,5,6501,'hudson-reed-kingsbury-freestanding-bath-1500-x-750mm'),(46698,121,0,6501,'hudson-reed-kingsbury-freestanding-bath-1500-x-750mm'),(46699,73,5,6501,'Hudson Reed Kingsbury Freestanding Bath 1500 x 750mm'),(46700,73,0,6501,'Hudson Reed Kingsbury Freestanding Bath 1500 x 750mm'),(46701,109,5,6501,'Hudson Reed Kingsbury Freestanding Bath Pride Leg Set - 1500mm'),(46702,109,0,6501,'Hudson Reed Kingsbury Freestanding Bath Pride Leg Set - 1500mm'),(46703,110,5,6501,'Hudson Reed Kingsbury Freestanding Bath Pride Leg Set - 1500mm'),(46704,110,0,6501,'Hudson Reed Kingsbury Freestanding Bath Pride Leg Set - 1500mm'),(46705,111,5,6501,'Hudson Reed Kingsbury Freestanding Bath Pride Leg Set - 1500mm'),(46706,111,0,6501,'Hudson Reed Kingsbury Freestanding Bath Pride Leg Set - 1500mm'),(46707,121,5,6502,'hudson-reed-brockley-freestanding-bath-1700-x-750mm'),(46708,121,0,6502,'hudson-reed-brockley-freestanding-bath-1700-x-750mm'),(46709,73,5,6502,'Hudson Reed Brockley Freestanding Bath 1700 x 750mm'),(46710,73,0,6502,'Hudson Reed Brockley Freestanding Bath 1700 x 750mm'),(46711,109,5,6502,'Hudson Reed Brockley Freestanding Bath Pride Leg Set - 1700mm'),(46712,109,0,6502,'Hudson Reed Brockley Freestanding Bath Pride Leg Set - 1700mm'),(46713,110,5,6502,'Hudson Reed Brockley Freestanding Bath Pride Leg Set - 1700mm'),(46714,110,0,6502,'Hudson Reed Brockley Freestanding Bath Pride Leg Set - 1700mm'),(46715,111,5,6502,'Hudson Reed Brockley Freestanding Bath Pride Leg Set - 1700mm'),(46716,111,0,6502,'Hudson Reed Brockley Freestanding Bath Pride Leg Set - 1700mm'),(46717,121,5,6503,'hudson-reed-kingsbury-freestanding-bath-1700-x-750mm'),(46718,121,0,6503,'hudson-reed-kingsbury-freestanding-bath-1700-x-750mm'),(46719,73,5,6503,'Hudson Reed Kingsbury Freestanding Bath 1700 x 750mm'),(46720,73,0,6503,'Hudson Reed Kingsbury Freestanding Bath 1700 x 750mm'),(46721,109,5,6503,'Hudson Reed Kingsbury Freestanding Bath Pride Leg Set - 1700mm'),(46722,109,0,6503,'Hudson Reed Kingsbury Freestanding Bath Pride Leg Set - 1700mm'),(46723,110,5,6503,'Hudson Reed Kingsbury Freestanding Bath Pride Leg Set - 1700mm'),(46724,110,0,6503,'Hudson Reed Kingsbury Freestanding Bath Pride Leg Set - 1700mm'),(46725,111,5,6503,'Hudson Reed Kingsbury Freestanding Bath Pride Leg Set - 1700mm'),(46726,111,0,6503,'Hudson Reed Kingsbury Freestanding Bath Pride Leg Set - 1700mm'),(46727,121,5,6504,'hudson-reed-barnsbury-freestanding-bath-1700-x-750mm'),(46728,121,0,6504,'hudson-reed-barnsbury-freestanding-bath-1700-x-750mm'),(46729,73,5,6504,'Hudson Reed Barnsbury Freestanding Bath 1700 x 750mm'),(46730,73,0,6504,'Hudson Reed Barnsbury Freestanding Bath 1700 x 750mm'),(46731,109,5,6504,'Hudson Reed Barnsbury Freestanding Bath Corbel Leg Set - 1700mm'),(46732,109,0,6504,'Hudson Reed Barnsbury Freestanding Bath Corbel Leg Set - 1700mm'),(46733,110,5,6504,'Hudson Reed Barnsbury Freestanding Bath Corbel Leg Set - 1700mm'),(46734,110,0,6504,'Hudson Reed Barnsbury Freestanding Bath Corbel Leg Set - 1700mm'),(46735,111,5,6504,'Hudson Reed Barnsbury Freestanding Bath Corbel Leg Set - 1700mm'),(46736,111,0,6504,'Hudson Reed Barnsbury Freestanding Bath Corbel Leg Set - 1700mm'),(46737,121,5,6505,'hudson-reed-winterburn-freestanding-shower-bath-1500-x-750mm'),(46738,121,0,6505,'hudson-reed-winterburn-freestanding-shower-bath-1500-x-750mm'),(46739,73,5,6505,'Hudson Reed Winterburn Freestanding Shower Bath 1500 x 750mm'),(46740,73,0,6505,'Hudson Reed Winterburn Freestanding Shower Bath 1500 x 750mm'),(46741,109,5,6505,'Hudson Reed Winterburn Freestanding Shower Bath Pride Leg Set - 1500mm'),(46742,109,0,6505,'Hudson Reed Winterburn Freestanding Shower Bath Pride Leg Set - 1500mm'),(46743,110,5,6505,'Hudson Reed Winterburn Freestanding Shower Bath Pride Leg Set - 1500mm'),(46744,110,0,6505,'Hudson Reed Winterburn Freestanding Shower Bath Pride Leg Set - 1500mm'),(46745,111,5,6505,'Hudson Reed Winterburn Freestanding Shower Bath Pride Leg Set - 1500mm'),(46746,111,0,6505,'Hudson Reed Winterburn Freestanding Shower Bath Pride Leg Set - 1500mm'),(46747,121,5,6506,'hudson-reed-winterburn-freestanding-shower-bath-1700-x-750mm'),(46748,121,0,6506,'hudson-reed-winterburn-freestanding-shower-bath-1700-x-750mm'),(46749,73,5,6506,'Hudson Reed Winterburn Freestanding Shower Bath 1700 x 750mm'),(46750,73,0,6506,'Hudson Reed Winterburn Freestanding Shower Bath 1700 x 750mm'),(46751,109,5,6506,'Hudson Reed Winterburn Freestanding Shower Bath Pride Leg Set - 1700mm'),(46752,109,0,6506,'Hudson Reed Winterburn Freestanding Shower Bath Pride Leg Set - 1700mm'),(46753,110,5,6506,'Hudson Reed Winterburn Freestanding Shower Bath Pride Leg Set - 1700mm'),(46754,110,0,6506,'Hudson Reed Winterburn Freestanding Shower Bath Pride Leg Set - 1700mm'),(46755,111,5,6506,'Hudson Reed Winterburn Freestanding Shower Bath Pride Leg Set - 1700mm'),(46756,111,0,6506,'Hudson Reed Winterburn Freestanding Shower Bath Pride Leg Set - 1700mm'),(46757,121,5,6507,'bette-comodo-steel-single-ended-bath-1900-x-900mm'),(46758,121,0,6507,'bette-comodo-steel-single-ended-bath-1900-x-900mm'),(46759,84,5,6507,'Bette Comodo 1900 x 900 - Super Steel Single Ended Steel Bath | Banyo'),(46760,84,0,6507,'Bette Comodo 1900 x 900 - Super Steel Single Ended Steel Bath | Banyo'),(46761,86,5,6507,'At Banyo, we offer a special discounted price on Bette Comodo 1900 x 900 bath. We offer a huge range of Super Steel Single Ended Bathtubs with affordable prices & Fast delivery in the UK.'),(46762,86,0,6507,'At Banyo, we offer a special discounted price on Bette Comodo 1900 x 900 bath. We offer a huge range of Super Steel Single Ended Bathtubs with affordable prices & Fast delivery in the UK.'),(46763,73,5,6507,'Bette Comodo Steel Single Ended Bath 1900 x 900mm '),(46764,73,0,6507,'Bette Comodo Steel Single Ended Bath 1900 x 900mm '),(46765,121,5,6508,'bette-select-bath-with-overflow-foot-end'),(46766,121,0,6508,'bette-select-bath-with-overflow-foot-end'),(46767,84,5,6508,'Bette Select Bath - Overflow Foot End | Banyo'),(46768,84,0,6508,'Bette Select Bath - Overflow Foot End | Banyo'),(46769,86,5,6508,'Bette Select Bath with Overflow Foot End is available on Banyo with different Overflow styles and supplied with no Tap hole. We offer the lowest prices in the UK.'),(46770,86,0,6508,'Bette Select Bath with Overflow Foot End is available on Banyo with different Overflow styles and supplied with no Tap hole. We offer the lowest prices in the UK.'),(46771,73,5,6508,'Bette Select Bath With Overflow Foot End'),(46772,73,0,6508,'Bette Select Bath With Overflow Foot End'),(46773,109,5,6508,'Bette Select Bath With Overflow Foot End'),(46774,109,0,6508,'Bette Select Bath With Overflow Foot End'),(46775,110,5,6508,'Bette Select Bath With Overflow Foot End'),(46776,110,0,6508,'Bette Select Bath With Overflow Foot End'),(46777,111,5,6508,'Bette Select Bath With Overflow Foot End'),(46778,111,0,6508,'Bette Select Bath With Overflow Foot End'),(46779,121,5,6509,'bette-form-super-steel-single-ended-bath'),(46780,121,0,6509,'bette-form-super-steel-single-ended-bath'),(46781,84,5,6509,'Bette Form 1400 x 700 - Standard Steel Bath | Banyo UK'),(46782,84,0,6509,'Bette Form 1400 x 700 - Standard Steel Bath | Banyo UK'),(46783,86,5,6509,'Banyo offers the lowest online price on Bette Form steel bath 1400 x 700. We offer an extensive range of  Standard Baths and Shower trays with a 30-year guarantee.'),(46784,86,0,6509,'Banyo offers the lowest online price on Bette Form steel bath 1400 x 700. We offer an extensive range of  Standard Baths and Shower trays with a 30-year guarantee.'),(46785,73,5,6509,'Bette Form Super Steel Single Ended Bath'),(46786,73,0,6509,'Bette Form Super Steel Single Ended Bath'),(46787,109,5,6509,'Bette Form Super Steel Single Ended Bath'),(46788,109,0,6509,'Bette Form Super Steel Single Ended Bath'),(46789,110,5,6509,'Bette Form Super Steel Single Ended Bath'),(46790,110,0,6509,'Bette Form Super Steel Single Ended Bath'),(46791,111,5,6509,'Bette Form Super Steel Single Ended Bath'),(46792,111,0,6509,'Bette Form Super Steel Single Ended Bath'),(46793,121,5,6510,'bette-labette-super-steel-single-ended-bath'),(46794,121,0,6510,'bette-labette-super-steel-single-ended-bath'),(46795,84,5,6510,'Bette Labette Super Steel Bath - Single Ended Bathtubs | Banyo   '),(46796,84,0,6510,'Bette Labette Super Steel Bath - Single Ended Bathtubs | Banyo   '),(46797,86,5,6510,'Buy Bette Labette Super Steel Bath from Banyo with special discounted price. We offer a wide range of Single Ended Bathtubs with the lowest prices in the UK.'),(46798,86,0,6510,'Buy Bette Labette Super Steel Bath from Banyo with special discounted price. We offer a wide range of Single Ended Bathtubs with the lowest prices in the UK.'),(46799,73,5,6510,'Bette Labette Super Steel Single Ended Bath'),(46800,73,0,6510,'Bette Labette Super Steel Single Ended Bath'),(46801,109,5,6510,'Bette Labette Super Steel Single Ended Bath'),(46802,109,0,6510,'Bette Labette Super Steel Single Ended Bath'),(46803,110,5,6510,'Bette Labette Super Steel Single Ended Bath'),(46804,110,0,6510,'Bette Labette Super Steel Single Ended Bath'),(46805,111,5,6510,'Bette Labette Super Steel Single Ended Bath'),(46806,111,0,6510,'Bette Labette Super Steel Single Ended Bath'),(46807,121,5,6511,'bette-ocean-single-ended-super-steel-bath'),(46808,121,0,6511,'bette-ocean-single-ended-super-steel-bath'),(46809,84,5,6511,'Bette Ocean Super Steel Bath - Single Ended Bathtubs | Banyo'),(46810,84,0,6511,'Bette Ocean Super Steel Bath - Single Ended Bathtubs | Banyo'),(46811,86,5,6511,'At Banyo, we offer affordable prices on Super Steel Rectangular Bathtubs. Bette Ocean Super Steel Bath available with special discount. For more info contact us 0116 274 4059.'),(46812,86,0,6511,'At Banyo, we offer affordable prices on Super Steel Rectangular Bathtubs. Bette Ocean Super Steel Bath available with special discount. For more info contact us 0116 274 4059.'),(46813,73,5,6511,'Bette Ocean Single Ended Super Steel Bath'),(46814,73,0,6511,'Bette Ocean Single Ended Super Steel Bath'),(46815,109,5,6511,'Bette Ocean Single Ended Super Steel Bath'),(46816,109,0,6511,'Bette Ocean Single Ended Super Steel Bath'),(46817,110,5,6511,'Bette Ocean Single Ended Super Steel Bath'),(46818,110,0,6511,'Bette Ocean Single Ended Super Steel Bath'),(46819,111,5,6511,'Bette Ocean Single Ended Super Steel Bath'),(46820,111,0,6511,'Bette Ocean Single Ended Super Steel Bath'),(46821,121,5,6512,'bette-set-super-steel-single-ended-bath'),(46822,121,0,6512,'bette-set-super-steel-single-ended-bath'),(46823,84,5,6512,'Bette Set Super Steel Bath - Single Ended Bathtubs | Banyo'),(46824,84,0,6512,'Bette Set Super Steel Bath - Single Ended Bathtubs | Banyo'),(46825,86,5,6512,'At Banyo, we offer amazing discounts on all sizes of Bette Set Super Steel Bath with manufacturer warranty and fast delivery in the UK. For more info contact us 0116 274 4059. '),(46826,86,0,6512,'At Banyo, we offer amazing discounts on all sizes of Bette Set Super Steel Bath with manufacturer warranty and fast delivery in the UK. For more info contact us 0116 274 4059. '),(46827,73,5,6512,'Bette Set Super Steel Single Ended Bath'),(46828,73,0,6512,'Bette Set Super Steel Single Ended Bath'),(46829,109,5,6512,'Bette Set Super Steel Single Ended Bath'),(46830,109,0,6512,'Bette Set Super Steel Single Ended Bath'),(46831,110,5,6512,'Bette Set Super Steel Single Ended Bath'),(46832,110,0,6512,'Bette Set Super Steel Single Ended Bath'),(46833,111,5,6512,'Bette Set Super Steel Single Ended Bath'),(46834,111,0,6512,'Bette Set Super Steel Single Ended Bath'),(46835,121,5,6513,'bette-starlet-super-steel-double-ended-bath'),(46836,121,0,6513,'bette-starlet-super-steel-double-ended-bath'),(46837,84,5,6513,'Bette Starlet Super Steel Double Ended Bath | Banyo'),(46838,84,0,6513,'Bette Starlet Super Steel Double Ended Bath | Banyo'),(46839,86,5,6513,'Bette Starlet Super Steel Double Ended Bath available on Banyo with the lowest price in the UK along with fastest delivery service. for more info 0116 274 4059.'),(46840,86,0,6513,'Bette Starlet Super Steel Double Ended Bath available on Banyo with the lowest price in the UK along with fastest delivery service. for more info 0116 274 4059.'),(46841,73,5,6513,'Bette Starlet Super Steel Double Ended Bath'),(46842,73,0,6513,'Bette Starlet Super Steel Double Ended Bath'),(46843,109,5,6513,'Bette Starlet Super Steel Double Ended Bath'),(46844,109,0,6513,'Bette Starlet Super Steel Double Ended Bath'),(46845,110,5,6513,'Bette Starlet Super Steel Double Ended Bath'),(46846,110,0,6513,'Bette Starlet Super Steel Double Ended Bath'),(46847,111,5,6513,'Bette Starlet Super Steel Double Ended Bath'),(46848,111,0,6513,'Bette Starlet Super Steel Double Ended Bath'),(46849,121,5,6514,'bette-one-steel-double-ended-bath-1600-x-700mm'),(46850,121,0,6514,'bette-one-steel-double-ended-bath-1600-x-700mm'),(46851,73,5,6514,'Bette One Steel Double Ended Bath 1600 x 700mm'),(46852,73,0,6514,'Bette One Steel Double Ended Bath 1600 x 700mm'),(46853,121,5,6515,'bette-one-steel-double-ended-bath-1700-x-700mm'),(46854,121,0,6515,'bette-one-steel-double-ended-bath-1700-x-700mm'),(46855,73,5,6515,'Bette One Steel Double Ended Bath 1700 x 700mm'),(46856,73,0,6515,'Bette One Steel Double Ended Bath 1700 x 700mm'),(46857,121,5,6516,'bette-one-steel-double-ended-bath-1700-x-750mm'),(46858,121,0,6516,'bette-one-steel-double-ended-bath-1700-x-750mm'),(46859,73,5,6516,'Bette One Steel Double Ended Bath 1700 x 750mm'),(46860,73,0,6516,'Bette One Steel Double Ended Bath 1700 x 750mm'),(46861,121,5,6517,'bette-one-steel-double-ended-bath-1800-x-800mm'),(46862,121,0,6517,'bette-one-steel-double-ended-bath-1800-x-800mm'),(46863,73,5,6517,'Bette One Steel Double Ended Bath 1800 x 800mm'),(46864,73,0,6517,'Bette One Steel Double Ended Bath 1800 x 800mm'),(46865,121,5,6518,'bette-one-steel-double-ended-bath-1900-x-900mm'),(46866,121,0,6518,'bette-one-steel-double-ended-bath-1900-x-900mm'),(46867,73,5,6518,'Bette One Steel Double Ended Bath 1900 x 900mm'),(46868,73,0,6518,'Bette One Steel Double Ended Bath 1900 x 900mm'),(46869,121,5,6519,'bette-starlet-iv-silhouette-steel-bath-1950-x-950mm'),(46870,121,0,6519,'bette-starlet-iv-silhouette-steel-bath-1950-x-950mm'),(46871,73,5,6519,'Bette Starlet IV Silhouette Steel Bath 1950 x 950mm'),(46872,73,0,6519,'Bette Starlet IV Silhouette Steel Bath 1950 x 950mm'),(46873,121,5,6520,'bette-starlet-v-silhouette-steel-bath-1950-x-950mm'),(46874,121,0,6520,'bette-starlet-v-silhouette-steel-bath-1950-x-950mm'),(46875,73,5,6520,'Bette Starlet V Silhouette Steel Bath 1950 x 950mm'),(46876,73,0,6520,'Bette Starlet V Silhouette Steel Bath 1950 x 950mm'),(46877,121,5,6521,'bette-comodo-steel-bath-with-side-overflow-1700-x-750mm'),(46878,121,0,6521,'bette-comodo-steel-bath-with-side-overflow-1700-x-750mm'),(46879,73,5,6521,'Bette Comodo Steel Bath with Side Overflow - 1700 x 750mm'),(46880,73,0,6521,'Bette Comodo Steel Bath with Side Overflow - 1700 x 750mm'),(46881,109,5,6521,'bette-comodo-with-side-overflow'),(46882,109,0,6521,'bette-comodo-with-side-overflow'),(46883,110,5,6521,'bette-comodo-with-side-overflow'),(46884,110,0,6521,'bette-comodo-with-side-overflow'),(46885,111,5,6521,'bette-comodo-with-side-overflow'),(46886,111,0,6521,'bette-comodo-with-side-overflow'),(46887,121,5,6522,'bette-comodo-steel-bath-with-side-overflow-1700-x-800mm'),(46888,121,0,6522,'bette-comodo-steel-bath-with-side-overflow-1700-x-800mm'),(46889,73,5,6522,'Bette Comodo Steel Bath with Side Overflow - 1700 x 800mm'),(46890,73,0,6522,'Bette Comodo Steel Bath with Side Overflow - 1700 x 800mm'),(46891,109,5,6522,'bette-comodo-with-side-overflow'),(46892,109,0,6522,'bette-comodo-with-side-overflow'),(46893,110,5,6522,'bette-comodo-with-side-overflow'),(46894,110,0,6522,'bette-comodo-with-side-overflow'),(46895,111,5,6522,'bette-comodo-with-side-overflow'),(46896,111,0,6522,'bette-comodo-with-side-overflow'),(46897,121,5,6523,'bette-comodo-steel-bath-with-side-overflow-1800-x-800mm'),(46898,121,0,6523,'bette-comodo-steel-bath-with-side-overflow-1800-x-800mm'),(46899,73,5,6523,'Bette Comodo Steel Bath with Side Overflow - 1800 x 800mm'),(46900,73,0,6523,'Bette Comodo Steel Bath with Side Overflow - 1800 x 800mm'),(46901,109,5,6523,'bette-comodo-with-side-overflow'),(46902,109,0,6523,'bette-comodo-with-side-overflow'),(46903,110,5,6523,'bette-comodo-with-side-overflow'),(46904,110,0,6523,'bette-comodo-with-side-overflow'),(46905,111,5,6523,'bette-comodo-with-side-overflow'),(46906,111,0,6523,'bette-comodo-with-side-overflow'),(46907,121,5,6524,'bette-comodo-steel-bath-with-side-overflow-1900-x-900mm'),(46908,121,0,6524,'bette-comodo-steel-bath-with-side-overflow-1900-x-900mm'),(46909,73,5,6524,'Bette Comodo Steel Bath with Side Overflow - 1900 x 900mm'),(46910,73,0,6524,'Bette Comodo Steel Bath with Side Overflow - 1900 x 900mm'),(46911,109,5,6524,'bette-comodo-with-side-overflow'),(46912,109,0,6524,'bette-comodo-with-side-overflow'),(46913,110,5,6524,'bette-comodo-with-side-overflow'),(46914,110,0,6524,'bette-comodo-with-side-overflow'),(46915,111,5,6524,'bette-comodo-with-side-overflow'),(46916,111,0,6524,'bette-comodo-with-side-overflow'),(46917,121,5,6525,'bette-classic-steel-bath-140-x-70cm'),(46918,121,0,6525,'bette-classic-steel-bath-140-x-70cm'),(46919,73,5,6525,'Bette Classic Steel Bath 140 x 70cm'),(46920,73,0,6525,'Bette Classic Steel Bath 140 x 70cm'),(46921,121,5,6526,'bette-classic-steel-bath-150-x-70cm'),(46922,121,0,6526,'bette-classic-steel-bath-150-x-70cm'),(46923,73,5,6526,'Bette Classic Steel Bath 150 x 70cm'),(46924,73,0,6526,'Bette Classic Steel Bath 150 x 70cm'),(46925,121,5,6527,'bette-classic-steel-bath-160-x-70cm'),(46926,121,0,6527,'bette-classic-steel-bath-160-x-70cm'),(46927,73,5,6527,'Bette Classic Steel Bath 160 x 70cm'),(46928,73,0,6527,'Bette Classic Steel Bath 160 x 70cm'),(46929,121,5,6528,'bette-classic-steel-bath-160-x-75cm'),(46930,121,0,6528,'bette-classic-steel-bath-160-x-75cm'),(46931,73,5,6528,'Bette Classic Steel Bath 160 x 75cm'),(46932,73,0,6528,'Bette Classic Steel Bath 160 x 75cm'),(46933,121,5,6529,'bette-classic-steel-bath-165-x-75cm'),(46934,121,0,6529,'bette-classic-steel-bath-165-x-75cm'),(46935,73,5,6529,'Bette Classic Steel Bath 165 x 75cm'),(46936,73,0,6529,'Bette Classic Steel Bath 165 x 75cm'),(46937,121,5,6530,'bette-classic-steel-bath-170-x-70cm'),(46938,121,0,6530,'bette-classic-steel-bath-170-x-70cm'),(46939,73,5,6530,'Bette Classic Steel Bath 170 x 70cm'),(46940,73,0,6530,'Bette Classic Steel Bath 170 x 70cm'),(46941,121,5,6531,'bette-classic-steel-bath-170-x-73cm'),(46942,121,0,6531,'bette-classic-steel-bath-170-x-73cm'),(46943,73,5,6531,'Bette Classic Steel Bath 170 x 73cm'),(46944,73,0,6531,'Bette Classic Steel Bath 170 x 73cm'),(46945,121,5,6532,'bette-classic-steel-bath-170-x-80cm'),(46946,121,0,6532,'bette-classic-steel-bath-170-x-80cm'),(46947,73,5,6532,'Bette Classic Steel Bath 170 x 80cm'),(46948,73,0,6532,'Bette Classic Steel Bath 170 x 80cm'),(46949,121,5,6533,'bette-classic-steel-bath-175-x-75cm'),(46950,121,0,6533,'bette-classic-steel-bath-175-x-75cm'),(46951,73,5,6533,'Bette Classic Steel Bath 175 x 75cm'),(46952,73,0,6533,'Bette Classic Steel Bath 175 x 75cm'),(46953,121,5,6534,'bette-classic-steel-bath-190-x-80cm'),(46954,121,0,6534,'bette-classic-steel-bath-190-x-80cm'),(46955,73,5,6534,'Bette Classic Steel Bath 190 x 80cm'),(46956,73,0,6534,'Bette Classic Steel Bath 190 x 80cm'),(46957,121,5,6535,'bette-starlet-steel-bath-1850-x-850mm'),(46958,121,0,6535,'bette-starlet-steel-bath-1850-x-850mm'),(46959,73,5,6535,'Bette Starlet Steel Bath 1850 x 850mm'),(46960,73,0,6535,'Bette Starlet Steel Bath 1850 x 850mm'),(46961,121,5,6536,'bette-select-steel-single-ended-bath'),(46962,121,0,6536,'bette-select-steel-single-ended-bath'),(46963,73,5,6536,'Bette Select Steel Single Ended Bath'),(46964,73,0,6536,'Bette Select Steel Single Ended Bath'),(46965,121,5,6537,'bette-comodo-steel-bath'),(46966,121,0,6537,'bette-comodo-steel-bath'),(46967,73,5,6537,'Bette Comodo Steel Bath'),(46968,73,0,6537,'Bette Comodo Steel Bath'),(46969,121,5,6538,'bette-comodo-steel-bath-1700-x-800mm-no-th'),(46970,121,0,6538,'bette-comodo-steel-bath-1700-x-800mm-no-th'),(46971,73,5,6538,'Bette Comodo Steel Bath 1700 x 800mm - No TH'),(46972,73,0,6538,'Bette Comodo Steel Bath 1700 x 800mm - No TH'),(46973,121,5,6539,'bette-comodo-steel-bath-1800-x-800mm-no-th'),(46974,121,0,6539,'bette-comodo-steel-bath-1800-x-800mm-no-th'),(46975,73,5,6539,'Bette Comodo Steel Bath 1800 x 800mm - No TH'),(46976,73,0,6539,'Bette Comodo Steel Bath 1800 x 800mm - No TH'),(46977,121,5,6540,'bette-duett-super-steel-rectangular-bath-1700-x-750mm'),(46978,121,0,6540,'bette-duett-super-steel-rectangular-bath-1700-x-750mm'),(46979,73,5,6540,'Bette Duett Super Steel Rectangular Bath 1700 x 750mm'),(46980,73,0,6540,'Bette Duett Super Steel Rectangular Bath 1700 x 750mm'),(46981,109,5,6540,'bette-duett_3'),(46982,109,0,6540,'bette-duett_3'),(46983,110,5,6540,'bette-duett_3'),(46984,110,0,6540,'bette-duett_3'),(46985,111,5,6540,'bette-duett_3'),(46986,111,0,6540,'bette-duett_3'),(46987,121,5,6541,'bette-duett-super-steel-rectangular-bath-1700-x-800mm'),(46988,121,0,6541,'bette-duett-super-steel-rectangular-bath-1700-x-800mm'),(46989,73,5,6541,'Bette Duett Super Steel Rectangular Bath 1700 x 800mm'),(46990,73,0,6541,'Bette Duett Super Steel Rectangular Bath 1700 x 800mm'),(46991,109,5,6541,'bette-duett_3'),(46992,109,0,6541,'bette-duett_3'),(46993,110,5,6541,'bette-duett_3'),(46994,110,0,6541,'bette-duett_3'),(46995,111,5,6541,'bette-duett_3'),(46996,111,0,6541,'bette-duett_3'),(46997,121,5,6542,'bette-free-super-steel-double-ended-rectangular-bath-1700-x-750mm'),(46998,121,0,6542,'bette-free-super-steel-double-ended-rectangular-bath-1700-x-750mm'),(46999,73,5,6542,'Bette Free Super Steel Double Ended Rectangular Bath 1700 x 750mm'),(47000,73,0,6542,'Bette Free Super Steel Double Ended Rectangular Bath 1700 x 750mm'),(47001,109,5,6542,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47002,109,0,6542,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47003,110,5,6542,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47004,110,0,6542,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47005,111,5,6542,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47006,111,0,6542,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47007,121,5,6543,'bette-free-super-steel-double-ended-rectangular-bath-1800-x-800mm'),(47008,121,0,6543,'bette-free-super-steel-double-ended-rectangular-bath-1800-x-800mm'),(47009,73,5,6543,'Bette Free Super Steel Double Ended Rectangular Bath 1800 x 800mm'),(47010,73,0,6543,'Bette Free Super Steel Double Ended Rectangular Bath 1800 x 800mm'),(47011,109,5,6543,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47012,109,0,6543,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47013,110,5,6543,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47014,110,0,6543,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47015,111,5,6543,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47016,111,0,6543,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47017,121,5,6544,'bette-free-super-steel-double-ended-rectangular-bath-1900-x-900mm'),(47018,121,0,6544,'bette-free-super-steel-double-ended-rectangular-bath-1900-x-900mm'),(47019,73,5,6544,'Bette Free Super Steel Double Ended Rectangular Bath 1900 x 900mm'),(47020,73,0,6544,'Bette Free Super Steel Double Ended Rectangular Bath 1900 x 900mm'),(47021,109,5,6544,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47022,109,0,6544,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47023,110,5,6544,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47024,110,0,6544,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47025,111,5,6544,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47026,111,0,6544,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47027,121,5,6545,'bette-free-super-steel-double-ended-rectangular-bath-2000-x-1000mm'),(47028,121,0,6545,'bette-free-super-steel-double-ended-rectangular-bath-2000-x-1000mm'),(47029,73,5,6545,'Bette Free Super Steel Double Ended Rectangular Bath 2000 x 1000mm'),(47030,73,0,6545,'Bette Free Super Steel Double Ended Rectangular Bath 2000 x 1000mm'),(47031,109,5,6545,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47032,109,0,6545,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47033,110,5,6545,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47034,110,0,6545,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47035,111,5,6545,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47036,111,0,6545,'bette-free-super-steel-double-ended-rectangular-bath_1'),(47037,121,5,6546,'vitra-balance-single-ended-rectangular-bath'),(47038,121,0,6546,'vitra-balance-single-ended-rectangular-bath'),(47039,84,5,6546,'Vitra Balance Rectangular Single Ended Bath'),(47040,84,0,6546,'Vitra Balance Rectangular Single Ended Bath'),(47041,86,5,6546,'Vitra Balance Rectangular Single Ended Bath'),(47042,86,0,6546,'Vitra Balance Rectangular Single Ended Bath'),(47043,73,5,6546,'Vitra Balance Single Ended Rectangular Bath'),(47044,73,0,6546,'Vitra Balance Single Ended Rectangular Bath'),(47045,109,5,6546,'Vitra Balance Rectangular Single Ended Bath'),(47046,109,0,6546,'Vitra Balance Rectangular Single Ended Bath'),(47047,110,5,6546,'Vitra Balance Rectangular Single Ended Bath'),(47048,110,0,6546,'Vitra Balance Rectangular Single Ended Bath'),(47049,111,5,6546,'Vitra Balance Rectangular Single Ended Bath'),(47050,111,0,6546,'Vitra Balance Rectangular Single Ended Bath'),(47051,121,5,6547,'vitra-balance-single-ended-rectangular-1500-x-700mm-bath'),(47052,121,0,6547,'vitra-balance-single-ended-rectangular-1500-x-700mm-bath'),(47053,84,5,6547,'Vitra Balance Rectangular Single Ended Bath 1500 x 700mm'),(47054,84,0,6547,'Vitra Balance Rectangular Single Ended Bath 1500 x 700mm'),(47055,86,5,6547,'Vitra Balance Rectangular Single Ended Bath 1500 x 700mm'),(47056,86,0,6547,'Vitra Balance Rectangular Single Ended Bath 1500 x 700mm'),(47057,73,5,6547,'Vitra Balance Single Ended Rectangular 1500 x 700mm Bath '),(47058,73,0,6547,'Vitra Balance Single Ended Rectangular 1500 x 700mm Bath '),(47059,109,5,6547,'Vitra Balance Rectangular Single Ended Bath 1500 x 700mm'),(47060,109,0,6547,'Vitra Balance Rectangular Single Ended Bath 1500 x 700mm'),(47061,110,5,6547,'Vitra Balance Rectangular Single Ended Bath 1500 x 700mm'),(47062,110,0,6547,'Vitra Balance Rectangular Single Ended Bath 1500 x 700mm'),(47063,111,5,6547,'Vitra Balance Rectangular Single Ended Bath 1500 x 700mm'),(47064,111,0,6547,'Vitra Balance Rectangular Single Ended Bath 1500 x 700mm'),(47065,121,5,6548,'vitra-balance-single-ended-rectangular-1600-x-700mm-bath'),(47066,121,0,6548,'vitra-balance-single-ended-rectangular-1600-x-700mm-bath'),(47067,84,5,6548,'Vitra Balance Rectangular Single Ended Bath 1600 x 700mm'),(47068,84,0,6548,'Vitra Balance Rectangular Single Ended Bath 1600 x 700mm'),(47069,86,5,6548,'Vitra Balance Rectangular Single Ended Bath 1600 x 700mm'),(47070,86,0,6548,'Vitra Balance Rectangular Single Ended Bath 1600 x 700mm'),(47071,73,5,6548,'Vitra Balance Single Ended Rectangular 1600 x 700mm Bath '),(47072,73,0,6548,'Vitra Balance Single Ended Rectangular 1600 x 700mm Bath '),(47073,109,5,6548,'Vitra Balance Rectangular Single Ended Bath 1600 x 700mm'),(47074,109,0,6548,'Vitra Balance Rectangular Single Ended Bath 1600 x 700mm'),(47075,110,5,6548,'Vitra Balance Rectangular Single Ended Bath 1600 x 700mm'),(47076,110,0,6548,'Vitra Balance Rectangular Single Ended Bath 1600 x 700mm'),(47077,111,5,6548,'Vitra Balance Rectangular Single Ended Bath 1600 x 700mm'),(47078,111,0,6548,'Vitra Balance Rectangular Single Ended Bath 1600 x 700mm'),(47079,121,5,6549,'vitra-balance-single-ended-rectangular-1700-x-700mm-bath'),(47080,121,0,6549,'vitra-balance-single-ended-rectangular-1700-x-700mm-bath'),(47081,84,5,6549,'Vitra Balance Rectangular Single Ended Bath 1700 x 700mm'),(47082,84,0,6549,'Vitra Balance Rectangular Single Ended Bath 1700 x 700mm'),(47083,86,5,6549,'Vitra Balance Rectangular Single Ended Bath 1700 x 700mm'),(47084,86,0,6549,'Vitra Balance Rectangular Single Ended Bath 1700 x 700mm'),(47085,73,5,6549,'Vitra Balance Single Ended Rectangular 1700 x 700mm Bath'),(47086,73,0,6549,'Vitra Balance Single Ended Rectangular 1700 x 700mm Bath'),(47087,109,5,6549,'Vitra Balance Rectangular Single Ended Bath 1700 x 700mm'),(47088,109,0,6549,'Vitra Balance Rectangular Single Ended Bath 1700 x 700mm'),(47089,110,5,6549,'Vitra Balance Rectangular Single Ended Bath 1700 x 700mm'),(47090,110,0,6549,'Vitra Balance Rectangular Single Ended Bath 1700 x 700mm'),(47091,111,5,6549,'Vitra Balance Rectangular Single Ended Bath 1700 x 700mm'),(47092,111,0,6549,'Vitra Balance Rectangular Single Ended Bath 1700 x 700mm'),(47093,121,5,6550,'vitra-neon-single-ended-rectangular-bath'),(47094,121,0,6550,'vitra-neon-single-ended-rectangular-bath'),(47095,84,5,6550,'Vitra Neon Rectangular Single Ended Bath'),(47096,84,0,6550,'Vitra Neon Rectangular Single Ended Bath'),(47097,86,5,6550,'Vitra Neon Rectangular Single Ended Bath'),(47098,86,0,6550,'Vitra Neon Rectangular Single Ended Bath'),(47099,73,5,6550,'Vitra Neon Single Ended Rectangular Bath'),(47100,73,0,6550,'Vitra Neon Single Ended Rectangular Bath'),(47101,109,5,6550,'Vitra Neon Rectangular Single Ended Bath'),(47102,109,0,6550,'Vitra Neon Rectangular Single Ended Bath'),(47103,110,5,6550,'Vitra Neon Rectangular Single Ended Bath'),(47104,110,0,6550,'Vitra Neon Rectangular Single Ended Bath'),(47105,111,5,6550,'Vitra Neon Rectangular Single Ended Bath'),(47106,111,0,6550,'Vitra Neon Rectangular Single Ended Bath'),(47107,121,5,6551,'vitra-neon-single-ended-rectangular-bath-1500-x-700mm'),(47108,121,0,6551,'vitra-neon-single-ended-rectangular-bath-1500-x-700mm'),(47109,84,5,6551,'Vitra Neon Rectangular Single Ended Bath 1500 x 700mm'),(47110,84,0,6551,'Vitra Neon Rectangular Single Ended Bath 1500 x 700mm'),(47111,86,5,6551,'Vitra Neon Rectangular Single Ended Bath 1500 x 700mm'),(47112,86,0,6551,'Vitra Neon Rectangular Single Ended Bath 1500 x 700mm'),(47113,73,5,6551,'Vitra Neon Single Ended Rectangular Bath 1500 x 700mm'),(47114,73,0,6551,'Vitra Neon Single Ended Rectangular Bath 1500 x 700mm'),(47115,109,5,6551,'Vitra Neon Rectangular Single Ended Bath 1500 x 700mm'),(47116,109,0,6551,'Vitra Neon Rectangular Single Ended Bath 1500 x 700mm'),(47117,110,5,6551,'Vitra Neon Rectangular Single Ended Bath 1500 x 700mm'),(47118,110,0,6551,'Vitra Neon Rectangular Single Ended Bath 1500 x 700mm'),(47119,111,5,6551,'Vitra Neon Rectangular Single Ended Bath 1500 x 700mm'),(47120,111,0,6551,'Vitra Neon Rectangular Single Ended Bath 1500 x 700mm'),(47121,121,5,6552,'vitra-neonsingle-ended-rectangular-1600-x-700mm-bath'),(47122,121,0,6552,'vitra-neonsingle-ended-rectangular-1600-x-700mm-bath'),(47123,84,5,6552,'Vitra Neon Rectangular Single Ended Bath 1600 x 700mm'),(47124,84,0,6552,'Vitra Neon Rectangular Single Ended Bath 1600 x 700mm'),(47125,86,5,6552,'Vitra Neon Rectangular Single Ended Bath 1600 x 700mm'),(47126,86,0,6552,'Vitra Neon Rectangular Single Ended Bath 1600 x 700mm'),(47127,73,5,6552,'Vitra NeonSingle Ended Rectangular 1600 x 700mm Bath '),(47128,73,0,6552,'Vitra NeonSingle Ended Rectangular 1600 x 700mm Bath '),(47129,109,5,6552,'Vitra Neon Rectangular Single Ended Bath 1600 x 700mm'),(47130,109,0,6552,'Vitra Neon Rectangular Single Ended Bath 1600 x 700mm'),(47131,110,5,6552,'Vitra Neon Rectangular Single Ended Bath 1600 x 700mm'),(47132,110,0,6552,'Vitra Neon Rectangular Single Ended Bath 1600 x 700mm'),(47133,111,5,6552,'Vitra Neon Rectangular Single Ended Bath 1600 x 700mm'),(47134,111,0,6552,'Vitra Neon Rectangular Single Ended Bath 1600 x 700mm'),(47135,121,5,6553,'vitra-neon-single-ended-rectangular-1600-x-750mm-bath'),(47136,121,0,6553,'vitra-neon-single-ended-rectangular-1600-x-750mm-bath'),(47137,84,5,6553,'Vitra Neon Rectangular Single Ended Bath 1600 x 750mm'),(47138,84,0,6553,'Vitra Neon Rectangular Single Ended Bath 1600 x 750mm'),(47139,86,5,6553,'Vitra Neon Rectangular Single Ended Bath 1600 x 750mm'),(47140,86,0,6553,'Vitra Neon Rectangular Single Ended Bath 1600 x 750mm'),(47141,73,5,6553,'Vitra Neon  Single Ended Rectangular 1600 x 750mm Bath '),(47142,73,0,6553,'Vitra Neon  Single Ended Rectangular 1600 x 750mm Bath '),(47143,109,5,6553,'Vitra Neon Rectangular Single Ended Bath 1600 x 750mm'),(47144,109,0,6553,'Vitra Neon Rectangular Single Ended Bath 1600 x 750mm'),(47145,110,5,6553,'Vitra Neon Rectangular Single Ended Bath 1600 x 750mm'),(47146,110,0,6553,'Vitra Neon Rectangular Single Ended Bath 1600 x 750mm'),(47147,111,5,6553,'Vitra Neon Rectangular Single Ended Bath 1600 x 750mm'),(47148,111,0,6553,'Vitra Neon Rectangular Single Ended Bath 1600 x 750mm'),(47149,121,5,6554,'vitra-neon-single-ended-rectangular-1700-x-700mm-bath'),(47150,121,0,6554,'vitra-neon-single-ended-rectangular-1700-x-700mm-bath'),(47151,84,5,6554,'Vitra Neon Rectangular Single Ended Bath 1700 x 700mm'),(47152,84,0,6554,'Vitra Neon Rectangular Single Ended Bath 1700 x 700mm'),(47153,86,5,6554,'Vitra Neon Rectangular Single Ended Bath 1700 x 700mm'),(47154,86,0,6554,'Vitra Neon Rectangular Single Ended Bath 1700 x 700mm'),(47155,73,5,6554,'Vitra Neon  Single Ended Rectangular 1700 x 700mm Bath '),(47156,73,0,6554,'Vitra Neon  Single Ended Rectangular 1700 x 700mm Bath '),(47157,109,5,6554,'Vitra Neon Rectangular Single Ended Bath 1700 x 700mm'),(47158,109,0,6554,'Vitra Neon Rectangular Single Ended Bath 1700 x 700mm'),(47159,110,5,6554,'Vitra Neon Rectangular Single Ended Bath 1700 x 700mm'),(47160,110,0,6554,'Vitra Neon Rectangular Single Ended Bath 1700 x 700mm'),(47161,111,5,6554,'Vitra Neon Rectangular Single Ended Bath 1700 x 700mm'),(47162,111,0,6554,'Vitra Neon Rectangular Single Ended Bath 1700 x 700mm'),(47163,121,5,6555,'vitra-neon-single-ended-rectangular-1700-x-750mm-bath'),(47164,121,0,6555,'vitra-neon-single-ended-rectangular-1700-x-750mm-bath'),(47165,84,5,6555,'Vitra Neon Rectangular Single Ended Bath 1700 x 750mm'),(47166,84,0,6555,'Vitra Neon Rectangular Single Ended Bath 1700 x 750mm'),(47167,86,5,6555,'Vitra Neon Rectangular Single Ended Bath 1700 x 750mm'),(47168,86,0,6555,'Vitra Neon Rectangular Single Ended Bath 1700 x 750mm'),(47169,73,5,6555,'Vitra Neon Single Ended Rectangular 1700 x 750mm Bath '),(47170,73,0,6555,'Vitra Neon Single Ended Rectangular 1700 x 750mm Bath '),(47171,109,5,6555,'Vitra Neon Rectangular Single Ended Bath 1700 x 750mm'),(47172,109,0,6555,'Vitra Neon Rectangular Single Ended Bath 1700 x 750mm'),(47173,110,5,6555,'Vitra Neon Rectangular Single Ended Bath 1700 x 750mm'),(47174,110,0,6555,'Vitra Neon Rectangular Single Ended Bath 1700 x 750mm'),(47175,111,5,6555,'Vitra Neon Rectangular Single Ended Bath 1700 x 750mm'),(47176,111,0,6555,'Vitra Neon Rectangular Single Ended Bath 1700 x 750mm'),(47177,121,5,6556,'vitra-neon-shower-single-ended-1700-x-850mm-bath'),(47178,121,0,6556,'vitra-neon-shower-single-ended-1700-x-850mm-bath'),(47179,84,5,6556,'Vitra Neon Space Saver LH Single Ended Bath 1700 x 850mm'),(47180,84,0,6556,'Vitra Neon Space Saver LH Single Ended Bath 1700 x 850mm'),(47181,86,5,6556,'Vitra Neon Space Saver LH Single Ended Bath 1700 x 850mm'),(47182,86,0,6556,'Vitra Neon Space Saver LH Single Ended Bath 1700 x 850mm'),(47183,73,5,6556,'Vitra Neon Shower Single Ended 1700 x 850mm Bath '),(47184,73,0,6556,'Vitra Neon Shower Single Ended 1700 x 850mm Bath '),(47185,109,5,6556,'Vitra Neon Space Saver LH Single Ended Bath 1700 x 850mm'),(47186,109,0,6556,'Vitra Neon Space Saver LH Single Ended Bath 1700 x 850mm'),(47187,110,5,6556,'Vitra Neon Space Saver LH Single Ended Bath 1700 x 850mm'),(47188,110,0,6556,'Vitra Neon Space Saver LH Single Ended Bath 1700 x 850mm'),(47189,111,5,6556,'Vitra Neon Space Saver LH Single Ended Bath 1700 x 850mm'),(47190,111,0,6556,'Vitra Neon Space Saver LH Single Ended Bath 1700 x 850mm'),(47191,121,5,6557,'vitra-neon-double-ended-rectangular-1800-x-800mm-bath'),(47192,121,0,6557,'vitra-neon-double-ended-rectangular-1800-x-800mm-bath'),(47193,84,5,6557,'Vitra Neon Rectangular Double Ended Bath 1800 x 800mm'),(47194,84,0,6557,'Vitra Neon Rectangular Double Ended Bath 1800 x 800mm'),(47195,86,5,6557,'Vitra Neon Rectangular Double Ended Bath 1800 x 800mm'),(47196,86,0,6557,'Vitra Neon Rectangular Double Ended Bath 1800 x 800mm'),(47197,73,5,6557,'Vitra Neon Double Ended Rectangular 1800 x 800mm Bath '),(47198,73,0,6557,'Vitra Neon Double Ended Rectangular 1800 x 800mm Bath '),(47199,109,5,6557,'Vitra Neon Rectangular Double Ended Bath 1800 x 800mm'),(47200,109,0,6557,'Vitra Neon Rectangular Double Ended Bath 1800 x 800mm'),(47201,110,5,6557,'Vitra Neon Rectangular Double Ended Bath 1800 x 800mm'),(47202,110,0,6557,'Vitra Neon Rectangular Double Ended Bath 1800 x 800mm'),(47203,111,5,6557,'Vitra Neon Rectangular Double Ended Bath 1800 x 800mm'),(47204,111,0,6557,'Vitra Neon Rectangular Double Ended Bath 1800 x 800mm'),(47205,121,5,6558,'vitra-optima-rectangular-single-ended-bath'),(47206,121,0,6558,'vitra-optima-rectangular-single-ended-bath'),(47207,84,5,6558,'Vitra Optima Rectangular Single Ended Bath'),(47208,84,0,6558,'Vitra Optima Rectangular Single Ended Bath'),(47209,86,5,6558,'Vitra Optima Rectangular Single Ended Bath'),(47210,86,0,6558,'Vitra Optima Rectangular Single Ended Bath'),(47211,73,5,6558,'Vitra Optima Rectangular Single Ended Bath'),(47212,73,0,6558,'Vitra Optima Rectangular Single Ended Bath'),(47213,109,5,6558,'Vitra Optima Rectangular Single Ended Bath'),(47214,109,0,6558,'Vitra Optima Rectangular Single Ended Bath'),(47215,110,5,6558,'Vitra Optima Rectangular Single Ended Bath'),(47216,110,0,6558,'Vitra Optima Rectangular Single Ended Bath'),(47217,111,5,6558,'Vitra Optima Rectangular Single Ended Bath'),(47218,111,0,6558,'Vitra Optima Rectangular Single Ended Bath'),(47219,121,5,6559,'vitra-optima-1500-x-700mm-single-ended-rectangular-bath'),(47220,121,0,6559,'vitra-optima-1500-x-700mm-single-ended-rectangular-bath'),(47221,84,5,6559,'Vitra Optima Rectangular Single Ended Bath 1500 x 700mm'),(47222,84,0,6559,'Vitra Optima Rectangular Single Ended Bath 1500 x 700mm'),(47223,86,5,6559,'Vitra Optima Rectangular Single Ended Bath 1500 x 700mm'),(47224,86,0,6559,'Vitra Optima Rectangular Single Ended Bath 1500 x 700mm'),(47225,73,5,6559,'Vitra Optima 1500 x 700mm Single Ended Rectangular Bath '),(47226,73,0,6559,'Vitra Optima 1500 x 700mm Single Ended Rectangular Bath '),(47227,109,5,6559,'Vitra Optima Rectangular Single Ended Bath 1500 x 700mm'),(47228,109,0,6559,'Vitra Optima Rectangular Single Ended Bath 1500 x 700mm'),(47229,110,5,6559,'Vitra Optima Rectangular Single Ended Bath 1500 x 700mm'),(47230,110,0,6559,'Vitra Optima Rectangular Single Ended Bath 1500 x 700mm'),(47231,111,5,6559,'Vitra Optima Rectangular Single Ended Bath 1500 x 700mm'),(47232,111,0,6559,'Vitra Optima Rectangular Single Ended Bath 1500 x 700mm'),(47233,121,5,6560,'vitra-optima-rectangular-single-ended-1600-x-700mm-bath'),(47234,121,0,6560,'vitra-optima-rectangular-single-ended-1600-x-700mm-bath'),(47235,84,5,6560,'Vitra Optima Rectangular Single Ended Bath 1600 x 700mm'),(47236,84,0,6560,'Vitra Optima Rectangular Single Ended Bath 1600 x 700mm'),(47237,86,5,6560,'Vitra Optima Rectangular Single Ended Bath 1600 x 700mm'),(47238,86,0,6560,'Vitra Optima Rectangular Single Ended Bath 1600 x 700mm'),(47239,73,5,6560,'Vitra Optima Rectangular Single Ended 1600 x 700mm  Bath '),(47240,73,0,6560,'Vitra Optima Rectangular Single Ended 1600 x 700mm  Bath '),(47241,109,5,6560,'Vitra Optima Rectangular Single Ended Bath 1600 x 700mm'),(47242,109,0,6560,'Vitra Optima Rectangular Single Ended Bath 1600 x 700mm'),(47243,110,5,6560,'Vitra Optima Rectangular Single Ended Bath 1600 x 700mm'),(47244,110,0,6560,'Vitra Optima Rectangular Single Ended Bath 1600 x 700mm'),(47245,111,5,6560,'Vitra Optima Rectangular Single Ended Bath 1600 x 700mm'),(47246,111,0,6560,'Vitra Optima Rectangular Single Ended Bath 1600 x 700mm'),(47247,121,5,6561,'vitra-optima-single-ended-rectangular-1700-x-700mm-bath'),(47248,121,0,6561,'vitra-optima-single-ended-rectangular-1700-x-700mm-bath'),(47249,84,5,6561,'Vitra Optima Rectangular Single Ended Bath 1700 x 700mm'),(47250,84,0,6561,'Vitra Optima Rectangular Single Ended Bath 1700 x 700mm'),(47251,86,5,6561,'Vitra Optima Rectangular Single Ended Bath 1700 x 700mm'),(47252,86,0,6561,'Vitra Optima Rectangular Single Ended Bath 1700 x 700mm'),(47253,73,5,6561,'Vitra Optima Single Ended Rectangular 1700 x 700mm Bath '),(47254,73,0,6561,'Vitra Optima Single Ended Rectangular 1700 x 700mm Bath '),(47255,109,5,6561,'Vitra Optima Rectangular Single Ended Bath 1700 x 700mm'),(47256,109,0,6561,'Vitra Optima Rectangular Single Ended Bath 1700 x 700mm'),(47257,110,5,6561,'Vitra Optima Rectangular Single Ended Bath 1700 x 700mm'),(47258,110,0,6561,'Vitra Optima Rectangular Single Ended Bath 1700 x 700mm'),(47259,111,5,6561,'Vitra Optima Rectangular Single Ended Bath 1700 x 700mm'),(47260,111,0,6561,'Vitra Optima Rectangular Single Ended Bath 1700 x 700mm'),(47261,121,5,6562,'vitra-optima-single-ended-rectangular-1700-x-750mm-bath'),(47262,121,0,6562,'vitra-optima-single-ended-rectangular-1700-x-750mm-bath'),(47263,84,5,6562,'Vitra Optima Rectangular Single Ended Bath 1700 x 750mm'),(47264,84,0,6562,'Vitra Optima Rectangular Single Ended Bath 1700 x 750mm'),(47265,86,5,6562,'Vitra Optima Rectangular Single Ended Bath 1700 x 750mm'),(47266,86,0,6562,'Vitra Optima Rectangular Single Ended Bath 1700 x 750mm'),(47267,73,5,6562,'Vitra Optima Single Ended Rectangular 1700 x 750mm Bath '),(47268,73,0,6562,'Vitra Optima Single Ended Rectangular 1700 x 750mm Bath '),(47269,109,5,6562,'Vitra Optima Rectangular Single Ended Bath 1700 x 750mm'),(47270,109,0,6562,'Vitra Optima Rectangular Single Ended Bath 1700 x 750mm'),(47271,110,5,6562,'Vitra Optima Rectangular Single Ended Bath 1700 x 750mm'),(47272,110,0,6562,'Vitra Optima Rectangular Single Ended Bath 1700 x 750mm'),(47273,111,5,6562,'Vitra Optima Rectangular Single Ended Bath 1700 x 750mm'),(47274,111,0,6562,'Vitra Optima Rectangular Single Ended Bath 1700 x 750mm'),(47275,121,5,6563,'vitra-silence-freestanding-bath-1700-x-900mm'),(47276,121,0,6563,'vitra-silence-freestanding-bath-1700-x-900mm'),(47277,84,5,6563,'Vitra Silence Freestanding Bath 1700 x 900mm'),(47278,84,0,6563,'Vitra Silence Freestanding Bath 1700 x 900mm'),(47279,86,5,6563,'Vitra Silence Freestanding Bath 1700 x 900mm'),(47280,86,0,6563,'Vitra Silence Freestanding Bath 1700 x 900mm'),(47281,73,5,6563,'Vitra Silence Freestanding Bath 1700 x 900mm'),(47282,73,0,6563,'Vitra Silence Freestanding Bath 1700 x 900mm'),(47283,109,5,6563,'Vitra Silence Freestanding Bath 1700 x 900mm'),(47284,109,0,6563,'Vitra Silence Freestanding Bath 1700 x 900mm'),(47285,110,5,6563,'Vitra Silence Freestanding Bath 1700 x 900mm'),(47286,110,0,6563,'Vitra Silence Freestanding Bath 1700 x 900mm'),(47287,111,5,6563,'Vitra Silence Freestanding Bath 1700 x 900mm'),(47288,111,0,6563,'Vitra Silence Freestanding Bath 1700 x 900mm'),(47289,121,5,6564,'nuie-square-l-shaped-shower-bath-1500-x-850mm'),(47290,121,0,6564,'nuie-square-l-shaped-shower-bath-1500-x-850mm'),(47291,84,5,6564,'Nuie Square L-Shaped Shower Bath 1500 x 850mm'),(47292,84,0,6564,'Nuie Square L-Shaped Shower Bath 1500 x 850mm'),(47293,86,5,6564,'Nuie Square L-Shaped Shower Bath 1500 x 850mm'),(47294,86,0,6564,'Nuie Square L-Shaped Shower Bath 1500 x 850mm'),(47295,73,5,6564,'Nuie Square L-Shaped Shower Bath 1500 x 850mm'),(47296,73,0,6564,'Nuie Square L-Shaped Shower Bath 1500 x 850mm'),(47297,109,5,6564,'Nuie Square L-Shaped Shower Bath 1500 x 850mm'),(47298,109,0,6564,'Nuie Square L-Shaped Shower Bath 1500 x 850mm'),(47299,110,5,6564,'Nuie Square L-Shaped Shower Bath 1500 x 850mm'),(47300,110,0,6564,'Nuie Square L-Shaped Shower Bath 1500 x 850mm'),(47301,111,5,6564,'Nuie Square L-Shaped Shower Bath 1500 x 850mm'),(47302,111,0,6564,'Nuie Square L-Shaped Shower Bath 1500 x 850mm'),(47303,121,5,6565,'nuie-square-l-shaped-shower-bath-1600-x-850mm'),(47304,121,0,6565,'nuie-square-l-shaped-shower-bath-1600-x-850mm'),(47305,84,5,6565,'Nuie Square L-Shaped Shower Bath 1600 x 850mm'),(47306,84,0,6565,'Nuie Square L-Shaped Shower Bath 1600 x 850mm'),(47307,86,5,6565,'Nuie Square L-Shaped Shower Bath 1600 x 850mm'),(47308,86,0,6565,'Nuie Square L-Shaped Shower Bath 1600 x 850mm'),(47309,73,5,6565,'Nuie Square L-Shaped Shower Bath 1600 x 850mm'),(47310,73,0,6565,'Nuie Square L-Shaped Shower Bath 1600 x 850mm'),(47311,109,5,6565,'Nuie Square L-Shaped Shower Bath 1600 x 850mm'),(47312,109,0,6565,'Nuie Square L-Shaped Shower Bath 1600 x 850mm'),(47313,110,5,6565,'Nuie Square L-Shaped Shower Bath 1600 x 850mm'),(47314,110,0,6565,'Nuie Square L-Shaped Shower Bath 1600 x 850mm'),(47315,111,5,6565,'Nuie Square L-Shaped Shower Bath 1600 x 850mm'),(47316,111,0,6565,'Nuie Square L-Shaped Shower Bath 1600 x 850mm'),(47317,121,5,6566,'nuie-square-l-shaped-shower-bath-1700-x-850mm'),(47318,121,0,6566,'nuie-square-l-shaped-shower-bath-1700-x-850mm'),(47319,84,5,6566,'Nuie Square L-Shaped Shower Bath 1700 x 850mm'),(47320,84,0,6566,'Nuie Square L-Shaped Shower Bath 1700 x 850mm'),(47321,86,5,6566,'Nuie Square L-Shaped Shower Bath 1700 x 850mm'),(47322,86,0,6566,'Nuie Square L-Shaped Shower Bath 1700 x 850mm'),(47323,73,5,6566,'Nuie Square L-Shaped Shower Bath 1700 x 850mm'),(47324,73,0,6566,'Nuie Square L-Shaped Shower Bath 1700 x 850mm'),(47325,109,5,6566,'Nuie Square L-Shaped Shower Bath 1700 x 850mm'),(47326,109,0,6566,'Nuie Square L-Shaped Shower Bath 1700 x 850mm'),(47327,110,5,6566,'Nuie Square L-Shaped Shower Bath 1700 x 850mm'),(47328,110,0,6566,'Nuie Square L-Shaped Shower Bath 1700 x 850mm'),(47329,111,5,6566,'Nuie Square L-Shaped Shower Bath 1700 x 850mm'),(47330,111,0,6566,'Nuie Square L-Shaped Shower Bath 1700 x 850mm'),(47331,121,5,6567,'nuie-square-b-shaped-shower-bath-1500-x-900mm'),(47332,121,0,6567,'nuie-square-b-shaped-shower-bath-1500-x-900mm'),(47333,84,5,6567,'Nuie Square B Shaped Shower Bath 1500 x 900mm'),(47334,84,0,6567,'Nuie Square B Shaped Shower Bath 1500 x 900mm'),(47335,86,5,6567,'Nuie Square B Shaped Shower Bath 1500 x 900mm'),(47336,86,0,6567,'Nuie Square B Shaped Shower Bath 1500 x 900mm'),(47337,73,5,6567,'Nuie Square B Shaped Shower Bath 1500 x 900mm'),(47338,73,0,6567,'Nuie Square B Shaped Shower Bath 1500 x 900mm'),(47339,109,5,6567,'Nuie Square B Shaped Shower Bath 1500 x 900mm'),(47340,109,0,6567,'Nuie Square B Shaped Shower Bath 1500 x 900mm'),(47341,110,5,6567,'Nuie Square B Shaped Shower Bath 1500 x 900mm'),(47342,110,0,6567,'Nuie Square B Shaped Shower Bath 1500 x 900mm'),(47343,111,5,6567,'Nuie Square B Shaped Shower Bath 1500 x 900mm'),(47344,111,0,6567,'Nuie Square B Shaped Shower Bath 1500 x 900mm'),(47345,121,5,6568,'nuie-square-b-shaped-shower-bath-1700-x-900mm'),(47346,121,0,6568,'nuie-square-b-shaped-shower-bath-1700-x-900mm'),(47347,84,5,6568,'Nuie Square B Shaped Shower Bath 1700 x 900mm'),(47348,84,0,6568,'Nuie Square B Shaped Shower Bath 1700 x 900mm'),(47349,86,5,6568,'Nuie Square B Shaped Shower Bath 1700 x 900mm'),(47350,86,0,6568,'Nuie Square B Shaped Shower Bath 1700 x 900mm'),(47351,73,5,6568,'Nuie Square B Shaped Shower Bath 1700 x 900mm'),(47352,73,0,6568,'Nuie Square B Shaped Shower Bath 1700 x 900mm'),(47353,109,5,6568,'Nuie Square B Shaped Shower Bath 1700 x 900mm'),(47354,109,0,6568,'Nuie Square B Shaped Shower Bath 1700 x 900mm'),(47355,110,5,6568,'Nuie Square B Shaped Shower Bath 1700 x 900mm'),(47356,110,0,6568,'Nuie Square B Shaped Shower Bath 1700 x 900mm'),(47357,111,5,6568,'Nuie Square B Shaped Shower Bath 1700 x 900mm'),(47358,111,0,6568,'Nuie Square B Shaped Shower Bath 1700 x 900mm'),(47359,121,5,6569,'nuie-square-p-shaped-shower-bath-1500-x-850mm'),(47360,121,0,6569,'nuie-square-p-shaped-shower-bath-1500-x-850mm'),(47361,84,5,6569,'Nuie Square P Shaped Shower Bath 1500 x 850mm'),(47362,84,0,6569,'Nuie Square P Shaped Shower Bath 1500 x 850mm'),(47363,86,5,6569,'Nuie Square P Shaped Shower Bath 1500 x 850mm'),(47364,86,0,6569,'Nuie Square P Shaped Shower Bath 1500 x 850mm'),(47365,73,5,6569,'Nuie Square P Shaped Shower Bath 1500 x 850mm'),(47366,73,0,6569,'Nuie Square P Shaped Shower Bath 1500 x 850mm'),(47367,109,5,6569,'Nuie Square P Shaped Shower Bath 1500 x 850mm'),(47368,109,0,6569,'Nuie Square P Shaped Shower Bath 1500 x 850mm'),(47369,110,5,6569,'Nuie Square P Shaped Shower Bath 1500 x 850mm'),(47370,110,0,6569,'Nuie Square P Shaped Shower Bath 1500 x 850mm'),(47371,111,5,6569,'Nuie Square P Shaped Shower Bath 1500 x 850mm'),(47372,111,0,6569,'Nuie Square P Shaped Shower Bath 1500 x 850mm'),(47373,121,5,6570,'nuie-square-p-shaped-shower-bath-1600-x-850mm'),(47374,121,0,6570,'nuie-square-p-shaped-shower-bath-1600-x-850mm'),(47375,84,5,6570,'Nuie Square P Shaped Shower Bath 1600 x 850mm'),(47376,84,0,6570,'Nuie Square P Shaped Shower Bath 1600 x 850mm'),(47377,86,5,6570,'Nuie Square P Shaped Shower Bath 1600 x 850mm'),(47378,86,0,6570,'Nuie Square P Shaped Shower Bath 1600 x 850mm'),(47379,73,5,6570,'Nuie Square P Shaped Shower Bath 1600 x 850mm'),(47380,73,0,6570,'Nuie Square P Shaped Shower Bath 1600 x 850mm'),(47381,109,5,6570,'Nuie Square P Shaped Shower Bath 1600 x 850mm'),(47382,109,0,6570,'Nuie Square P Shaped Shower Bath 1600 x 850mm'),(47383,110,5,6570,'Nuie Square P Shaped Shower Bath 1600 x 850mm'),(47384,110,0,6570,'Nuie Square P Shaped Shower Bath 1600 x 850mm'),(47385,111,5,6570,'Nuie Square P Shaped Shower Bath 1600 x 850mm'),(47386,111,0,6570,'Nuie Square P Shaped Shower Bath 1600 x 850mm'),(47387,121,5,6571,'nuie-square-p-shaped-shower-bath-1700-x-850mm'),(47388,121,0,6571,'nuie-square-p-shaped-shower-bath-1700-x-850mm'),(47389,84,5,6571,'Nuie Square P Shaped Shower Bath 1700 x 850mm'),(47390,84,0,6571,'Nuie Square P Shaped Shower Bath 1700 x 850mm'),(47391,86,5,6571,'Nuie Square P Shaped Shower Bath 1700 x 850mm'),(47392,86,0,6571,'Nuie Square P Shaped Shower Bath 1700 x 850mm'),(47393,73,5,6571,'Nuie Square P Shaped Shower Bath 1700 x 850mm'),(47394,73,0,6571,'Nuie Square P Shaped Shower Bath 1700 x 850mm'),(47395,109,5,6571,'Nuie Square P Shaped Shower Bath 1700 x 850mm'),(47396,109,0,6571,'Nuie Square P Shaped Shower Bath 1700 x 850mm'),(47397,110,5,6571,'Nuie Square P Shaped Shower Bath 1700 x 850mm'),(47398,110,0,6571,'Nuie Square P Shaped Shower Bath 1700 x 850mm'),(47399,111,5,6571,'Nuie Square P Shaped Shower Bath 1700 x 850mm'),(47400,111,0,6571,'Nuie Square P Shaped Shower Bath 1700 x 850mm'),(47401,121,5,6572,'bette-select-duo-rectangular-white-bath-1800-x-800mm'),(47402,121,0,6572,'bette-select-duo-rectangular-white-bath-1800-x-800mm'),(47403,84,5,6572,'Bette Select Duo Rectangular White Bath - 1800 x 800mm'),(47404,84,0,6572,'Bette Select Duo Rectangular White Bath - 1800 x 800mm'),(47405,86,5,6572,'Bette Select Duo Rectangular White Bath - 1800 x 800mm'),(47406,86,0,6572,'Bette Select Duo Rectangular White Bath - 1800 x 800mm'),(47407,73,5,6572,'Bette Select Duo Rectangular White Bath - 1800 x 800mm'),(47408,73,0,6572,'Bette Select Duo Rectangular White Bath - 1800 x 800mm'),(47409,109,5,6572,'Bette Select Duo Rectangular White Bath - 1800 x 800mm'),(47410,109,0,6572,'Bette Select Duo Rectangular White Bath - 1800 x 800mm'),(47411,110,5,6572,'Bette Select Duo Rectangular White Bath - 1800 x 800mm'),(47412,110,0,6572,'Bette Select Duo Rectangular White Bath - 1800 x 800mm'),(47413,111,5,6572,'Bette Select Duo Rectangular White Bath - 1800 x 800mm'),(47414,111,0,6572,'Bette Select Duo Rectangular White Bath - 1800 x 800mm');
/*!40000 ALTER TABLE `catalog_product_entity_varchar` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_varchar_after_insert` AFTER INSERT ON `catalog_product_entity_varchar` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`entity_id`);
INSERT IGNORE INTO `catalog_product_attribute_cl` (`entity_id`) VALUES (NEW.`entity_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_varchar_after_update` AFTER UPDATE ON `catalog_product_entity_varchar` FOR EACH ROW BEGIN
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalog_product_attribute_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
IF (NOT(NEW.`value_id` <=> OLD.`value_id`) OR NOT(NEW.`attribute_id` <=> OLD.`attribute_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`value` <=> OLD.`value`)) THEN INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_entity_varchar_after_delete` AFTER DELETE ON `catalog_product_entity_varchar` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (OLD.`entity_id`);
INSERT IGNORE INTO `catalog_product_attribute_cl` (`entity_id`) VALUES (OLD.`entity_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (OLD.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `catalog_product_frontend_action`
--

DROP TABLE IF EXISTS `catalog_product_frontend_action`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_frontend_action` (
  `action_id` bigint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Product Action ID',
  `type_id` varchar(64) NOT NULL COMMENT 'Type of product action',
  `visitor_id` int unsigned DEFAULT NULL COMMENT 'Visitor ID',
  `customer_id` int unsigned DEFAULT NULL COMMENT 'Customer ID',
  `product_id` int unsigned NOT NULL COMMENT 'Product ID',
  `added_at` bigint NOT NULL COMMENT 'Added At',
  PRIMARY KEY (`action_id`),
  UNIQUE KEY `CATALOG_PRODUCT_FRONTEND_ACTION_VISITOR_ID_PRODUCT_ID_TYPE_ID` (`visitor_id`,`product_id`,`type_id`),
  UNIQUE KEY `CATALOG_PRODUCT_FRONTEND_ACTION_CUSTOMER_ID_PRODUCT_ID_TYPE_ID` (`customer_id`,`product_id`,`type_id`),
  KEY `CAT_PRD_FRONTEND_ACTION_PRD_ID_CAT_PRD_ENTT_ENTT_ID` (`product_id`),
  CONSTRAINT `CAT_PRD_FRONTEND_ACTION_CSTR_ID_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_FRONTEND_ACTION_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Frontend Action Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_frontend_action`
--

LOCK TABLES `catalog_product_frontend_action` WRITE;
/*!40000 ALTER TABLE `catalog_product_frontend_action` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_frontend_action` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_eav`
--

DROP TABLE IF EXISTS `catalog_product_index_eav`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_eav` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `attribute_id` smallint unsigned NOT NULL COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `value` int unsigned NOT NULL COMMENT 'Value',
  `source_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Original entity ID for attribute value',
  PRIMARY KEY (`entity_id`,`attribute_id`,`store_id`,`value`,`source_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_STORE_ID` (`store_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_VALUE` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product EAV Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_eav`
--

LOCK TABLES `catalog_product_index_eav` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_eav` DISABLE KEYS */;
INSERT INTO `catalog_product_index_eav` VALUES (5760,99,1,4,5760),(5760,99,2,4,5760),(5760,99,3,4,5760),(5760,99,4,4,5760),(5760,99,5,4,5760),(6035,99,1,4,6035),(6035,99,2,4,6035),(6035,99,3,4,6035),(6035,99,4,4,6035),(6035,99,5,4,6035),(6036,99,1,4,6036),(6036,99,2,4,6036),(6036,99,3,4,6036),(6036,99,4,4,6036),(6036,99,5,4,6036),(6037,99,1,4,6037),(6037,99,2,4,6037),(6037,99,3,4,6037),(6037,99,4,4,6037),(6037,99,5,4,6037),(6038,99,1,4,6038),(6038,99,2,4,6038),(6038,99,3,4,6038),(6038,99,4,4,6038),(6038,99,5,4,6038),(6039,99,1,4,6039),(6039,99,2,4,6039),(6039,99,3,4,6039),(6039,99,4,4,6039),(6039,99,5,4,6039),(6040,99,1,4,6040),(6040,99,2,4,6040),(6040,99,3,4,6040),(6040,99,4,4,6040),(6040,99,5,4,6040),(6041,99,1,4,6041),(6041,99,2,4,6041),(6041,99,3,4,6041),(6041,99,4,4,6041),(6041,99,5,4,6041),(6042,99,1,4,6042),(6042,99,2,4,6042),(6042,99,3,4,6042),(6042,99,4,4,6042),(6042,99,5,4,6042),(6043,99,1,4,6043),(6043,99,2,4,6043),(6043,99,3,4,6043),(6043,99,4,4,6043),(6043,99,5,4,6043),(6044,99,1,4,6044),(6044,99,2,4,6044),(6044,99,3,4,6044),(6044,99,4,4,6044),(6044,99,5,4,6044),(6045,99,1,4,6045),(6045,99,2,4,6045),(6045,99,3,4,6045),(6045,99,4,4,6045),(6045,99,5,4,6045),(6046,99,1,4,6046),(6046,99,2,4,6046),(6046,99,3,4,6046),(6046,99,4,4,6046),(6046,99,5,4,6046),(6047,99,1,4,6047),(6047,99,2,4,6047),(6047,99,3,4,6047),(6047,99,4,4,6047),(6047,99,5,4,6047),(6048,99,1,4,6048),(6048,99,2,4,6048),(6048,99,3,4,6048),(6048,99,4,4,6048),(6048,99,5,4,6048),(6049,99,1,4,6049),(6049,99,2,4,6049),(6049,99,3,4,6049),(6049,99,4,4,6049),(6049,99,5,4,6049),(6050,99,1,4,6050),(6050,99,2,4,6050),(6050,99,3,4,6050),(6050,99,4,4,6050),(6050,99,5,4,6050),(6051,99,1,4,6051),(6051,99,2,4,6051),(6051,99,3,4,6051),(6051,99,4,4,6051),(6051,99,5,4,6051),(6052,99,1,4,6052),(6052,99,2,4,6052),(6052,99,3,4,6052),(6052,99,4,4,6052),(6052,99,5,4,6052),(6053,99,1,4,6053),(6053,99,2,4,6053),(6053,99,3,4,6053),(6053,99,4,4,6053),(6053,99,5,4,6053),(6054,99,1,4,6054),(6054,99,2,4,6054),(6054,99,3,4,6054),(6054,99,4,4,6054),(6054,99,5,4,6054),(6055,99,1,4,6055),(6055,99,2,4,6055),(6055,99,3,4,6055),(6055,99,4,4,6055),(6055,99,5,4,6055),(6056,99,1,4,6056),(6056,99,2,4,6056),(6056,99,3,4,6056),(6056,99,4,4,6056),(6056,99,5,4,6056),(6057,99,1,4,6057),(6057,99,2,4,6057),(6057,99,3,4,6057),(6057,99,4,4,6057),(6057,99,5,4,6057),(6058,99,1,4,6058),(6058,99,2,4,6058),(6058,99,3,4,6058),(6058,99,4,4,6058),(6058,99,5,4,6058),(6059,99,1,4,6059),(6059,99,2,4,6059),(6059,99,3,4,6059),(6059,99,4,4,6059),(6059,99,5,4,6059),(6060,99,1,4,6060),(6060,99,2,4,6060),(6060,99,3,4,6060),(6060,99,4,4,6060),(6060,99,5,4,6060),(6061,99,1,4,6061),(6061,99,2,4,6061),(6061,99,3,4,6061),(6061,99,4,4,6061),(6061,99,5,4,6061),(6062,99,1,4,6062),(6062,99,2,4,6062),(6062,99,3,4,6062),(6062,99,4,4,6062),(6062,99,5,4,6062),(6063,99,1,4,6063),(6063,99,2,4,6063),(6063,99,3,4,6063),(6063,99,4,4,6063),(6063,99,5,4,6063),(6064,99,1,4,6064),(6064,99,2,4,6064),(6064,99,3,4,6064),(6064,99,4,4,6064),(6064,99,5,4,6064),(6065,99,1,4,6065),(6065,99,2,4,6065),(6065,99,3,4,6065),(6065,99,4,4,6065),(6065,99,5,4,6065),(6066,99,1,4,6066),(6066,99,2,4,6066),(6066,99,3,4,6066),(6066,99,4,4,6066),(6066,99,5,4,6066),(6067,99,1,4,6067),(6067,99,2,4,6067),(6067,99,3,4,6067),(6067,99,4,4,6067),(6067,99,5,4,6067),(6068,99,1,4,6068),(6068,99,2,4,6068),(6068,99,3,4,6068),(6068,99,4,4,6068),(6068,99,5,4,6068),(6069,99,1,4,6069),(6069,99,2,4,6069),(6069,99,3,4,6069),(6069,99,4,4,6069),(6069,99,5,4,6069),(6070,99,1,4,6070),(6070,99,2,4,6070),(6070,99,3,4,6070),(6070,99,4,4,6070),(6070,99,5,4,6070),(6071,99,1,4,6071),(6071,99,2,4,6071),(6071,99,3,4,6071),(6071,99,4,4,6071),(6071,99,5,4,6071),(6072,99,1,4,6072),(6072,99,2,4,6072),(6072,99,3,4,6072),(6072,99,4,4,6072),(6072,99,5,4,6072),(6073,99,1,4,6073),(6073,99,2,4,6073),(6073,99,3,4,6073),(6073,99,4,4,6073),(6073,99,5,4,6073),(6074,99,1,4,6074),(6074,99,2,4,6074),(6074,99,3,4,6074),(6074,99,4,4,6074),(6074,99,5,4,6074),(6075,99,1,4,6075),(6075,99,2,4,6075),(6075,99,3,4,6075),(6075,99,4,4,6075),(6075,99,5,4,6075),(6076,99,1,4,6076),(6076,99,2,4,6076),(6076,99,3,4,6076),(6076,99,4,4,6076),(6076,99,5,4,6076),(6077,99,1,4,6077),(6077,99,2,4,6077),(6077,99,3,4,6077),(6077,99,4,4,6077),(6077,99,5,4,6077),(6078,99,1,4,6078),(6078,99,2,4,6078),(6078,99,3,4,6078),(6078,99,4,4,6078),(6078,99,5,4,6078),(6079,99,1,4,6079),(6079,99,2,4,6079),(6079,99,3,4,6079),(6079,99,4,4,6079),(6079,99,5,4,6079),(6080,99,1,4,6080),(6080,99,2,4,6080),(6080,99,3,4,6080),(6080,99,4,4,6080),(6080,99,5,4,6080),(6081,99,1,4,6081),(6081,99,2,4,6081),(6081,99,3,4,6081),(6081,99,4,4,6081),(6081,99,5,4,6081),(6082,99,1,4,6082),(6082,99,2,4,6082),(6082,99,3,4,6082),(6082,99,4,4,6082),(6082,99,5,4,6082),(6083,99,1,4,6083),(6083,99,2,4,6083),(6083,99,3,4,6083),(6083,99,4,4,6083),(6083,99,5,4,6083),(6084,99,1,4,6084),(6084,99,2,4,6084),(6084,99,3,4,6084),(6084,99,4,4,6084),(6084,99,5,4,6084),(6085,99,1,4,6085),(6085,99,2,4,6085),(6085,99,3,4,6085),(6085,99,4,4,6085),(6085,99,5,4,6085),(6086,99,1,4,6086),(6086,99,2,4,6086),(6086,99,3,4,6086),(6086,99,4,4,6086),(6086,99,5,4,6086),(6087,99,1,4,6087),(6087,99,2,4,6087),(6087,99,3,4,6087),(6087,99,4,4,6087),(6087,99,5,4,6087),(6088,99,1,4,6088),(6088,99,2,4,6088),(6088,99,3,4,6088),(6088,99,4,4,6088),(6088,99,5,4,6088),(6089,99,1,4,6089),(6089,99,2,4,6089),(6089,99,3,4,6089),(6089,99,4,4,6089),(6089,99,5,4,6089),(6090,99,1,4,6090),(6090,99,2,4,6090),(6090,99,3,4,6090),(6090,99,4,4,6090),(6090,99,5,4,6090),(6091,99,1,4,6091),(6091,99,2,4,6091),(6091,99,3,4,6091),(6091,99,4,4,6091),(6091,99,5,4,6091),(6092,99,1,4,6092),(6092,99,2,4,6092),(6092,99,3,4,6092),(6092,99,4,4,6092),(6092,99,5,4,6092),(6093,99,1,4,6093),(6093,99,2,4,6093),(6093,99,3,4,6093),(6093,99,4,4,6093),(6093,99,5,4,6093),(6094,99,1,4,6094),(6094,99,2,4,6094),(6094,99,3,4,6094),(6094,99,4,4,6094),(6094,99,5,4,6094),(6095,99,1,4,6095),(6095,99,2,4,6095),(6095,99,3,4,6095),(6095,99,4,4,6095),(6095,99,5,4,6095),(6096,99,1,4,6096),(6096,99,2,4,6096),(6096,99,3,4,6096),(6096,99,4,4,6096),(6096,99,5,4,6096),(6097,99,1,4,6097),(6097,99,2,4,6097),(6097,99,3,4,6097),(6097,99,4,4,6097),(6097,99,5,4,6097),(6098,99,1,4,6098),(6098,99,2,4,6098),(6098,99,3,4,6098),(6098,99,4,4,6098),(6098,99,5,4,6098),(6099,99,1,4,6099),(6099,99,2,4,6099),(6099,99,3,4,6099),(6099,99,4,4,6099),(6099,99,5,4,6099),(6100,99,1,4,6100),(6100,99,2,4,6100),(6100,99,3,4,6100),(6100,99,4,4,6100),(6100,99,5,4,6100),(6101,99,1,4,6101),(6101,99,2,4,6101),(6101,99,3,4,6101),(6101,99,4,4,6101),(6101,99,5,4,6101),(6102,99,1,4,6102),(6102,99,2,4,6102),(6102,99,3,4,6102),(6102,99,4,4,6102),(6102,99,5,4,6102),(6103,99,1,4,6103),(6103,99,2,4,6103),(6103,99,3,4,6103),(6103,99,4,4,6103),(6103,99,5,4,6103),(6104,99,1,4,6104),(6104,99,2,4,6104),(6104,99,3,4,6104),(6104,99,4,4,6104),(6104,99,5,4,6104),(6105,99,1,4,6105),(6105,99,2,4,6105),(6105,99,3,4,6105),(6105,99,4,4,6105),(6105,99,5,4,6105),(6106,99,1,4,6106),(6106,99,2,4,6106),(6106,99,3,4,6106),(6106,99,4,4,6106),(6106,99,5,4,6106),(6107,99,1,4,6107),(6107,99,2,4,6107),(6107,99,3,4,6107),(6107,99,4,4,6107),(6107,99,5,4,6107),(6108,99,1,4,6108),(6108,99,2,4,6108),(6108,99,3,4,6108),(6108,99,4,4,6108),(6108,99,5,4,6108),(6109,99,1,4,6109),(6109,99,2,4,6109),(6109,99,3,4,6109),(6109,99,4,4,6109),(6109,99,5,4,6109),(6110,99,1,4,6110),(6110,99,2,4,6110),(6110,99,3,4,6110),(6110,99,4,4,6110),(6110,99,5,4,6110),(6111,99,1,4,6111),(6111,99,2,4,6111),(6111,99,3,4,6111),(6111,99,4,4,6111),(6111,99,5,4,6111),(6112,99,1,4,6112),(6112,99,2,4,6112),(6112,99,3,4,6112),(6112,99,4,4,6112),(6112,99,5,4,6112),(6113,99,1,4,6113),(6113,99,2,4,6113),(6113,99,3,4,6113),(6113,99,4,4,6113),(6113,99,5,4,6113),(6114,99,1,4,6114),(6114,99,2,4,6114),(6114,99,3,4,6114),(6114,99,4,4,6114),(6114,99,5,4,6114),(6115,99,1,4,6115),(6115,99,2,4,6115),(6115,99,3,4,6115),(6115,99,4,4,6115),(6115,99,5,4,6115),(6116,99,1,4,6116),(6116,99,2,4,6116),(6116,99,3,4,6116),(6116,99,4,4,6116),(6116,99,5,4,6116),(6117,99,1,4,6117),(6117,99,2,4,6117),(6117,99,3,4,6117),(6117,99,4,4,6117),(6117,99,5,4,6117),(6118,99,1,4,6118),(6118,99,2,4,6118),(6118,99,3,4,6118),(6118,99,4,4,6118),(6118,99,5,4,6118),(6119,99,1,4,6119),(6119,99,2,4,6119),(6119,99,3,4,6119),(6119,99,4,4,6119),(6119,99,5,4,6119),(6120,99,1,4,6120),(6120,99,2,4,6120),(6120,99,3,4,6120),(6120,99,4,4,6120),(6120,99,5,4,6120),(6121,99,1,4,6121),(6121,99,2,4,6121),(6121,99,3,4,6121),(6121,99,4,4,6121),(6121,99,5,4,6121),(6122,99,1,4,6122),(6122,99,2,4,6122),(6122,99,3,4,6122),(6122,99,4,4,6122),(6122,99,5,4,6122),(6123,99,1,4,6123),(6123,99,2,4,6123),(6123,99,3,4,6123),(6123,99,4,4,6123),(6123,99,5,4,6123),(6124,99,1,4,6124),(6124,99,2,4,6124),(6124,99,3,4,6124),(6124,99,4,4,6124),(6124,99,5,4,6124),(6125,99,1,4,6125),(6125,99,2,4,6125),(6125,99,3,4,6125),(6125,99,4,4,6125),(6125,99,5,4,6125),(6126,99,1,4,6126),(6126,99,2,4,6126),(6126,99,3,4,6126),(6126,99,4,4,6126),(6126,99,5,4,6126),(6127,99,1,4,6127),(6127,99,2,4,6127),(6127,99,3,4,6127),(6127,99,4,4,6127),(6127,99,5,4,6127),(6128,99,1,4,6128),(6128,99,2,4,6128),(6128,99,3,4,6128),(6128,99,4,4,6128),(6128,99,5,4,6128),(6129,99,1,4,6129),(6129,99,2,4,6129),(6129,99,3,4,6129),(6129,99,4,4,6129),(6129,99,5,4,6129),(6130,99,1,4,6130),(6130,99,2,4,6130),(6130,99,3,4,6130),(6130,99,4,4,6130),(6130,99,5,4,6130),(6131,99,1,4,6131),(6131,99,2,4,6131),(6131,99,3,4,6131),(6131,99,4,4,6131),(6131,99,5,4,6131),(6132,99,1,4,6132),(6132,99,2,4,6132),(6132,99,3,4,6132),(6132,99,4,4,6132),(6132,99,5,4,6132),(6133,99,1,4,6133),(6133,99,2,4,6133),(6133,99,3,4,6133),(6133,99,4,4,6133),(6133,99,5,4,6133),(6134,99,1,4,6134),(6134,99,2,4,6134),(6134,99,3,4,6134),(6134,99,4,4,6134),(6134,99,5,4,6134),(6135,99,1,4,6135),(6135,99,2,4,6135),(6135,99,3,4,6135),(6135,99,4,4,6135),(6135,99,5,4,6135),(6136,99,1,4,6136),(6136,99,2,4,6136),(6136,99,3,4,6136),(6136,99,4,4,6136),(6136,99,5,4,6136),(6137,99,1,4,6137),(6137,99,2,4,6137),(6137,99,3,4,6137),(6137,99,4,4,6137),(6137,99,5,4,6137),(6138,99,1,4,6138),(6138,99,2,4,6138),(6138,99,3,4,6138),(6138,99,4,4,6138),(6138,99,5,4,6138),(6139,99,1,4,6139),(6139,99,2,4,6139),(6139,99,3,4,6139),(6139,99,4,4,6139),(6139,99,5,4,6139),(6140,99,1,4,6140),(6140,99,2,4,6140),(6140,99,3,4,6140),(6140,99,4,4,6140),(6140,99,5,4,6140),(6141,99,1,4,6141),(6141,99,2,4,6141),(6141,99,3,4,6141),(6141,99,4,4,6141),(6141,99,5,4,6141),(6142,99,1,4,6142),(6142,99,2,4,6142),(6142,99,3,4,6142),(6142,99,4,4,6142),(6142,99,5,4,6142),(6143,99,1,4,6143),(6143,99,2,4,6143),(6143,99,3,4,6143),(6143,99,4,4,6143),(6143,99,5,4,6143),(6144,99,1,4,6144),(6144,99,2,4,6144),(6144,99,3,4,6144),(6144,99,4,4,6144),(6144,99,5,4,6144),(6145,99,1,4,6145),(6145,99,2,4,6145),(6145,99,3,4,6145),(6145,99,4,4,6145),(6145,99,5,4,6145),(6146,99,1,4,6146),(6146,99,2,4,6146),(6146,99,3,4,6146),(6146,99,4,4,6146),(6146,99,5,4,6146),(6147,99,1,4,6147),(6147,99,2,4,6147),(6147,99,3,4,6147),(6147,99,4,4,6147),(6147,99,5,4,6147),(6148,99,1,4,6148),(6148,99,2,4,6148),(6148,99,3,4,6148),(6148,99,4,4,6148),(6148,99,5,4,6148),(6149,99,1,4,6149),(6149,99,2,4,6149),(6149,99,3,4,6149),(6149,99,4,4,6149),(6149,99,5,4,6149),(6150,99,1,4,6150),(6150,99,2,4,6150),(6150,99,3,4,6150),(6150,99,4,4,6150),(6150,99,5,4,6150),(6151,99,1,4,6151),(6151,99,2,4,6151),(6151,99,3,4,6151),(6151,99,4,4,6151),(6151,99,5,4,6151),(6152,99,1,4,6152),(6152,99,2,4,6152),(6152,99,3,4,6152),(6152,99,4,4,6152),(6152,99,5,4,6152),(6153,99,1,4,6153),(6153,99,2,4,6153),(6153,99,3,4,6153),(6153,99,4,4,6153),(6153,99,5,4,6153),(6154,99,1,4,6154),(6154,99,2,4,6154),(6154,99,3,4,6154),(6154,99,4,4,6154),(6154,99,5,4,6154),(6155,99,1,4,6155),(6155,99,2,4,6155),(6155,99,3,4,6155),(6155,99,4,4,6155),(6155,99,5,4,6155),(6156,99,1,4,6156),(6156,99,2,4,6156),(6156,99,3,4,6156),(6156,99,4,4,6156),(6156,99,5,4,6156),(6157,99,1,4,6157),(6157,99,2,4,6157),(6157,99,3,4,6157),(6157,99,4,4,6157),(6157,99,5,4,6157),(6158,99,1,4,6158),(6158,99,2,4,6158),(6158,99,3,4,6158),(6158,99,4,4,6158),(6158,99,5,4,6158),(6159,99,1,4,6159),(6159,99,2,4,6159),(6159,99,3,4,6159),(6159,99,4,4,6159),(6159,99,5,4,6159),(6160,99,1,4,6160),(6160,99,2,4,6160),(6160,99,3,4,6160),(6160,99,4,4,6160),(6160,99,5,4,6160),(6161,99,1,4,6161),(6161,99,2,4,6161),(6161,99,3,4,6161),(6161,99,4,4,6161),(6161,99,5,4,6161),(6162,99,1,4,6162),(6162,99,2,4,6162),(6162,99,3,4,6162),(6162,99,4,4,6162),(6162,99,5,4,6162),(6163,99,1,4,6163),(6163,99,2,4,6163),(6163,99,3,4,6163),(6163,99,4,4,6163),(6163,99,5,4,6163),(6164,99,1,4,6164),(6164,99,2,4,6164),(6164,99,3,4,6164),(6164,99,4,4,6164),(6164,99,5,4,6164),(6165,99,1,4,6165),(6165,99,2,4,6165),(6165,99,3,4,6165),(6165,99,4,4,6165),(6165,99,5,4,6165),(6166,99,1,4,6166),(6166,99,2,4,6166),(6166,99,3,4,6166),(6166,99,4,4,6166),(6166,99,5,4,6166),(6167,99,1,4,6167),(6167,99,2,4,6167),(6167,99,3,4,6167),(6167,99,4,4,6167),(6167,99,5,4,6167),(6168,99,1,4,6168),(6168,99,2,4,6168),(6168,99,3,4,6168),(6168,99,4,4,6168),(6168,99,5,4,6168),(6169,99,1,4,6169),(6169,99,2,4,6169),(6169,99,3,4,6169),(6169,99,4,4,6169),(6169,99,5,4,6169),(6170,99,1,4,6170),(6170,99,2,4,6170),(6170,99,3,4,6170),(6170,99,4,4,6170),(6170,99,5,4,6170),(6171,99,1,4,6171),(6171,99,2,4,6171),(6171,99,3,4,6171),(6171,99,4,4,6171),(6171,99,5,4,6171),(6172,99,1,4,6172),(6172,99,2,4,6172),(6172,99,3,4,6172),(6172,99,4,4,6172),(6172,99,5,4,6172),(6173,99,1,4,6173),(6173,99,2,4,6173),(6173,99,3,4,6173),(6173,99,4,4,6173),(6173,99,5,4,6173),(6174,99,1,4,6174),(6174,99,2,4,6174),(6174,99,3,4,6174),(6174,99,4,4,6174),(6174,99,5,4,6174),(6175,99,1,4,6175),(6175,99,2,4,6175),(6175,99,3,4,6175),(6175,99,4,4,6175),(6175,99,5,4,6175),(6176,99,1,4,6176),(6176,99,2,4,6176),(6176,99,3,4,6176),(6176,99,4,4,6176),(6176,99,5,4,6176),(6177,99,1,4,6177),(6177,99,2,4,6177),(6177,99,3,4,6177),(6177,99,4,4,6177),(6177,99,5,4,6177),(6178,99,1,4,6178),(6178,99,2,4,6178),(6178,99,3,4,6178),(6178,99,4,4,6178),(6178,99,5,4,6178),(6179,99,1,4,6179),(6179,99,2,4,6179),(6179,99,3,4,6179),(6179,99,4,4,6179),(6179,99,5,4,6179),(6180,99,1,4,6180),(6180,99,2,4,6180),(6180,99,3,4,6180),(6180,99,4,4,6180),(6180,99,5,4,6180),(6181,99,1,4,6181),(6181,99,2,4,6181),(6181,99,3,4,6181),(6181,99,4,4,6181),(6181,99,5,4,6181),(6182,99,1,4,6182),(6182,99,2,4,6182),(6182,99,3,4,6182),(6182,99,4,4,6182),(6182,99,5,4,6182),(6183,99,1,4,6183),(6183,99,2,4,6183),(6183,99,3,4,6183),(6183,99,4,4,6183),(6183,99,5,4,6183),(6184,99,1,4,6184),(6184,99,2,4,6184),(6184,99,3,4,6184),(6184,99,4,4,6184),(6184,99,5,4,6184),(6185,99,1,4,6185),(6185,99,2,4,6185),(6185,99,3,4,6185),(6185,99,4,4,6185),(6185,99,5,4,6185),(6186,99,1,4,6186),(6186,99,2,4,6186),(6186,99,3,4,6186),(6186,99,4,4,6186),(6186,99,5,4,6186),(6187,99,1,4,6187),(6187,99,2,4,6187),(6187,99,3,4,6187),(6187,99,4,4,6187),(6187,99,5,4,6187),(6188,99,1,4,6188),(6188,99,2,4,6188),(6188,99,3,4,6188),(6188,99,4,4,6188),(6188,99,5,4,6188),(6189,99,1,4,6189),(6189,99,2,4,6189),(6189,99,3,4,6189),(6189,99,4,4,6189),(6189,99,5,4,6189),(6190,99,1,4,6190),(6190,99,2,4,6190),(6190,99,3,4,6190),(6190,99,4,4,6190),(6190,99,5,4,6190),(6191,99,1,4,6191),(6191,99,2,4,6191),(6191,99,3,4,6191),(6191,99,4,4,6191),(6191,99,5,4,6191),(6192,99,1,4,6192),(6192,99,2,4,6192),(6192,99,3,4,6192),(6192,99,4,4,6192),(6192,99,5,4,6192),(6193,99,1,4,6193),(6193,99,2,4,6193),(6193,99,3,4,6193),(6193,99,4,4,6193),(6193,99,5,4,6193),(6194,99,1,4,6194),(6194,99,2,4,6194),(6194,99,3,4,6194),(6194,99,4,4,6194),(6194,99,5,4,6194),(6195,99,1,4,6195),(6195,99,2,4,6195),(6195,99,3,4,6195),(6195,99,4,4,6195),(6195,99,5,4,6195),(6196,99,1,4,6196),(6196,99,2,4,6196),(6196,99,3,4,6196),(6196,99,4,4,6196),(6196,99,5,4,6196),(6197,99,1,4,6197),(6197,99,2,4,6197),(6197,99,3,4,6197),(6197,99,4,4,6197),(6197,99,5,4,6197),(6198,99,1,4,6198),(6198,99,2,4,6198),(6198,99,3,4,6198),(6198,99,4,4,6198),(6198,99,5,4,6198),(6199,99,1,4,6199),(6199,99,2,4,6199),(6199,99,3,4,6199),(6199,99,4,4,6199),(6199,99,5,4,6199),(6200,99,1,4,6200),(6200,99,2,4,6200),(6200,99,3,4,6200),(6200,99,4,4,6200),(6200,99,5,4,6200),(6201,99,1,4,6201),(6201,99,2,4,6201),(6201,99,3,4,6201),(6201,99,4,4,6201),(6201,99,5,4,6201),(6202,99,1,4,6202),(6202,99,2,4,6202),(6202,99,3,4,6202),(6202,99,4,4,6202),(6202,99,5,4,6202),(6203,99,1,4,6203),(6203,99,2,4,6203),(6203,99,3,4,6203),(6203,99,4,4,6203),(6203,99,5,4,6203),(6204,99,1,4,6204),(6204,99,2,4,6204),(6204,99,3,4,6204),(6204,99,4,4,6204),(6204,99,5,4,6204),(6205,99,1,4,6205),(6205,99,2,4,6205),(6205,99,3,4,6205),(6205,99,4,4,6205),(6205,99,5,4,6205),(6206,99,1,4,6206),(6206,99,2,4,6206),(6206,99,3,4,6206),(6206,99,4,4,6206),(6206,99,5,4,6206),(6207,99,1,4,6207),(6207,99,2,4,6207),(6207,99,3,4,6207),(6207,99,4,4,6207),(6207,99,5,4,6207),(6208,99,1,4,6208),(6208,99,2,4,6208),(6208,99,3,4,6208),(6208,99,4,4,6208),(6208,99,5,4,6208),(6209,99,1,4,6209),(6209,99,2,4,6209),(6209,99,3,4,6209),(6209,99,4,4,6209),(6209,99,5,4,6209),(6210,99,1,4,6210),(6210,99,2,4,6210),(6210,99,3,4,6210),(6210,99,4,4,6210),(6210,99,5,4,6210),(6211,99,1,4,6211),(6211,99,2,4,6211),(6211,99,3,4,6211),(6211,99,4,4,6211),(6211,99,5,4,6211),(6212,99,1,4,6212),(6212,99,2,4,6212),(6212,99,3,4,6212),(6212,99,4,4,6212),(6212,99,5,4,6212),(6213,99,1,4,6213),(6213,99,2,4,6213),(6213,99,3,4,6213),(6213,99,4,4,6213),(6213,99,5,4,6213),(6214,99,1,4,6214),(6214,99,2,4,6214),(6214,99,3,4,6214),(6214,99,4,4,6214),(6214,99,5,4,6214),(6215,99,1,4,6215),(6215,99,2,4,6215),(6215,99,3,4,6215),(6215,99,4,4,6215),(6215,99,5,4,6215),(6216,99,1,4,6216),(6216,99,2,4,6216),(6216,99,3,4,6216),(6216,99,4,4,6216),(6216,99,5,4,6216),(6217,99,1,4,6217),(6217,99,2,4,6217),(6217,99,3,4,6217),(6217,99,4,4,6217),(6217,99,5,4,6217),(6218,99,1,4,6218),(6218,99,2,4,6218),(6218,99,3,4,6218),(6218,99,4,4,6218),(6218,99,5,4,6218),(6219,99,1,2,6219),(6219,99,2,2,6219),(6219,99,3,2,6219),(6219,99,4,2,6219),(6219,99,5,2,6219),(6220,99,1,4,6220),(6220,99,2,4,6220),(6220,99,3,4,6220),(6220,99,4,4,6220),(6220,99,5,4,6220),(6221,99,1,4,6221),(6221,99,2,4,6221),(6221,99,3,4,6221),(6221,99,4,4,6221),(6221,99,5,4,6221),(6222,99,1,4,6222),(6222,99,2,4,6222),(6222,99,3,4,6222),(6222,99,4,4,6222),(6222,99,5,4,6222),(6223,99,1,4,6223),(6223,99,2,4,6223),(6223,99,3,4,6223),(6223,99,4,4,6223),(6223,99,5,4,6223),(6224,99,1,4,6224),(6224,99,2,4,6224),(6224,99,3,4,6224),(6224,99,4,4,6224),(6224,99,5,4,6224),(6225,99,1,4,6225),(6225,99,2,4,6225),(6225,99,3,4,6225),(6225,99,4,4,6225),(6225,99,5,4,6225),(6226,99,1,4,6226),(6226,99,2,4,6226),(6226,99,3,4,6226),(6226,99,4,4,6226),(6226,99,5,4,6226),(6227,99,1,4,6227),(6227,99,2,4,6227),(6227,99,3,4,6227),(6227,99,4,4,6227),(6227,99,5,4,6227),(6228,99,1,4,6228),(6228,99,2,4,6228),(6228,99,3,4,6228),(6228,99,4,4,6228),(6228,99,5,4,6228),(6229,99,1,4,6229),(6229,99,2,4,6229),(6229,99,3,4,6229),(6229,99,4,4,6229),(6229,99,5,4,6229),(6230,99,1,4,6230),(6230,99,2,4,6230),(6230,99,3,4,6230),(6230,99,4,4,6230),(6230,99,5,4,6230),(6231,99,1,4,6231),(6231,99,2,4,6231),(6231,99,3,4,6231),(6231,99,4,4,6231),(6231,99,5,4,6231),(6232,99,1,4,6232),(6232,99,2,4,6232),(6232,99,3,4,6232),(6232,99,4,4,6232),(6232,99,5,4,6232),(6233,99,1,4,6233),(6233,99,2,4,6233),(6233,99,3,4,6233),(6233,99,4,4,6233),(6233,99,5,4,6233),(6234,99,1,4,6234),(6234,99,2,4,6234),(6234,99,3,4,6234),(6234,99,4,4,6234),(6234,99,5,4,6234),(6235,99,1,4,6235),(6235,99,2,4,6235),(6235,99,3,4,6235),(6235,99,4,4,6235),(6235,99,5,4,6235),(6236,99,1,4,6236),(6236,99,2,4,6236),(6236,99,3,4,6236),(6236,99,4,4,6236),(6236,99,5,4,6236),(6237,99,1,4,6237),(6237,99,2,4,6237),(6237,99,3,4,6237),(6237,99,4,4,6237),(6237,99,5,4,6237),(6238,99,1,4,6238),(6238,99,2,4,6238),(6238,99,3,4,6238),(6238,99,4,4,6238),(6238,99,5,4,6238),(6239,99,1,4,6239),(6239,99,2,4,6239),(6239,99,3,4,6239),(6239,99,4,4,6239),(6239,99,5,4,6239),(6240,99,1,4,6240),(6240,99,2,4,6240),(6240,99,3,4,6240),(6240,99,4,4,6240),(6240,99,5,4,6240),(6241,99,1,4,6241),(6241,99,2,4,6241),(6241,99,3,4,6241),(6241,99,4,4,6241),(6241,99,5,4,6241),(6242,99,1,4,6242),(6242,99,2,4,6242),(6242,99,3,4,6242),(6242,99,4,4,6242),(6242,99,5,4,6242),(6243,99,1,4,6243),(6243,99,2,4,6243),(6243,99,3,4,6243),(6243,99,4,4,6243),(6243,99,5,4,6243),(6244,99,1,4,6244),(6244,99,2,4,6244),(6244,99,3,4,6244),(6244,99,4,4,6244),(6244,99,5,4,6244),(6245,99,1,4,6245),(6245,99,2,4,6245),(6245,99,3,4,6245),(6245,99,4,4,6245),(6245,99,5,4,6245),(6246,99,1,4,6246),(6246,99,2,4,6246),(6246,99,3,4,6246),(6246,99,4,4,6246),(6246,99,5,4,6246),(6247,99,1,4,6247),(6247,99,2,4,6247),(6247,99,3,4,6247),(6247,99,4,4,6247),(6247,99,5,4,6247),(6248,99,1,4,6248),(6248,99,2,4,6248),(6248,99,3,4,6248),(6248,99,4,4,6248),(6248,99,5,4,6248),(6249,99,1,4,6249),(6249,99,2,4,6249),(6249,99,3,4,6249),(6249,99,4,4,6249),(6249,99,5,4,6249),(6250,99,1,4,6250),(6250,99,2,4,6250),(6250,99,3,4,6250),(6250,99,4,4,6250),(6250,99,5,4,6250),(6251,99,1,4,6251),(6251,99,2,4,6251),(6251,99,3,4,6251),(6251,99,4,4,6251),(6251,99,5,4,6251),(6252,99,1,4,6252),(6252,99,2,4,6252),(6252,99,3,4,6252),(6252,99,4,4,6252),(6252,99,5,4,6252),(6253,99,1,4,6253),(6253,99,2,4,6253),(6253,99,3,4,6253),(6253,99,4,4,6253),(6253,99,5,4,6253),(6254,99,1,4,6254),(6254,99,2,4,6254),(6254,99,3,4,6254),(6254,99,4,4,6254),(6254,99,5,4,6254),(6255,99,1,4,6255),(6255,99,2,4,6255),(6255,99,3,4,6255),(6255,99,4,4,6255),(6255,99,5,4,6255),(6256,99,1,4,6256),(6256,99,2,4,6256),(6256,99,3,4,6256),(6256,99,4,4,6256),(6256,99,5,4,6256),(6257,99,1,2,6257),(6257,99,2,2,6257),(6257,99,3,2,6257),(6257,99,4,2,6257),(6257,99,5,2,6257),(6258,99,1,4,6258),(6258,99,2,4,6258),(6258,99,3,4,6258),(6258,99,4,4,6258),(6258,99,5,4,6258),(6259,99,1,4,6259),(6259,99,2,4,6259),(6259,99,3,4,6259),(6259,99,4,4,6259),(6259,99,5,4,6259),(6260,99,1,4,6260),(6260,99,2,4,6260),(6260,99,3,4,6260),(6260,99,4,4,6260),(6260,99,5,4,6260),(6261,99,1,4,6261),(6261,99,2,4,6261),(6261,99,3,4,6261),(6261,99,4,4,6261),(6261,99,5,4,6261),(6262,99,1,4,6262),(6262,99,2,4,6262),(6262,99,3,4,6262),(6262,99,4,4,6262),(6262,99,5,4,6262),(6263,99,1,4,6263),(6263,99,2,4,6263),(6263,99,3,4,6263),(6263,99,4,4,6263),(6263,99,5,4,6263),(6264,99,1,4,6264),(6264,99,2,4,6264),(6264,99,3,4,6264),(6264,99,4,4,6264),(6264,99,5,4,6264),(6265,99,1,4,6265),(6265,99,2,4,6265),(6265,99,3,4,6265),(6265,99,4,4,6265),(6265,99,5,4,6265),(6266,99,1,4,6266),(6266,99,2,4,6266),(6266,99,3,4,6266),(6266,99,4,4,6266),(6266,99,5,4,6266),(6267,99,1,4,6267),(6267,99,2,4,6267),(6267,99,3,4,6267),(6267,99,4,4,6267),(6267,99,5,4,6267),(6268,99,1,4,6268),(6268,99,2,4,6268),(6268,99,3,4,6268),(6268,99,4,4,6268),(6268,99,5,4,6268),(6269,99,1,4,6269),(6269,99,2,4,6269),(6269,99,3,4,6269),(6269,99,4,4,6269),(6269,99,5,4,6269),(6270,99,1,4,6270),(6270,99,2,4,6270),(6270,99,3,4,6270),(6270,99,4,4,6270),(6270,99,5,4,6270),(6271,99,1,4,6271),(6271,99,2,4,6271),(6271,99,3,4,6271),(6271,99,4,4,6271),(6271,99,5,4,6271),(6272,99,1,4,6272),(6272,99,2,4,6272),(6272,99,3,4,6272),(6272,99,4,4,6272),(6272,99,5,4,6272),(6273,99,1,4,6273),(6273,99,2,4,6273),(6273,99,3,4,6273),(6273,99,4,4,6273),(6273,99,5,4,6273),(6274,99,1,4,6274),(6274,99,2,4,6274),(6274,99,3,4,6274),(6274,99,4,4,6274),(6274,99,5,4,6274),(6275,99,1,4,6275),(6275,99,2,4,6275),(6275,99,3,4,6275),(6275,99,4,4,6275),(6275,99,5,4,6275),(6276,99,1,4,6276),(6276,99,2,4,6276),(6276,99,3,4,6276),(6276,99,4,4,6276),(6276,99,5,4,6276),(6277,99,1,4,6277),(6277,99,2,4,6277),(6277,99,3,4,6277),(6277,99,4,4,6277),(6277,99,5,4,6277),(6278,99,1,4,6278),(6278,99,2,4,6278),(6278,99,3,4,6278),(6278,99,4,4,6278),(6278,99,5,4,6278),(6279,99,1,4,6279),(6279,99,2,4,6279),(6279,99,3,4,6279),(6279,99,4,4,6279),(6279,99,5,4,6279),(6280,99,1,4,6280),(6280,99,2,4,6280),(6280,99,3,4,6280),(6280,99,4,4,6280),(6280,99,5,4,6280),(6281,99,1,4,6281),(6281,99,2,4,6281),(6281,99,3,4,6281),(6281,99,4,4,6281),(6281,99,5,4,6281),(6282,99,1,4,6282),(6282,99,2,4,6282),(6282,99,3,4,6282),(6282,99,4,4,6282),(6282,99,5,4,6282),(6283,99,1,4,6283),(6283,99,2,4,6283),(6283,99,3,4,6283),(6283,99,4,4,6283),(6283,99,5,4,6283),(6284,99,1,4,6284),(6284,99,2,4,6284),(6284,99,3,4,6284),(6284,99,4,4,6284),(6284,99,5,4,6284),(6285,99,1,4,6285),(6285,99,2,4,6285),(6285,99,3,4,6285),(6285,99,4,4,6285),(6285,99,5,4,6285),(6286,99,1,4,6286),(6286,99,2,4,6286),(6286,99,3,4,6286),(6286,99,4,4,6286),(6286,99,5,4,6286),(6287,99,1,4,6287),(6287,99,2,4,6287),(6287,99,3,4,6287),(6287,99,4,4,6287),(6287,99,5,4,6287),(6288,99,1,4,6288),(6288,99,2,4,6288),(6288,99,3,4,6288),(6288,99,4,4,6288),(6288,99,5,4,6288),(6289,99,1,4,6289),(6289,99,2,4,6289),(6289,99,3,4,6289),(6289,99,4,4,6289),(6289,99,5,4,6289),(6290,99,1,4,6290),(6290,99,2,4,6290),(6290,99,3,4,6290),(6290,99,4,4,6290),(6290,99,5,4,6290),(6291,99,1,4,6291),(6291,99,2,4,6291),(6291,99,3,4,6291),(6291,99,4,4,6291),(6291,99,5,4,6291),(6292,99,1,4,6292),(6292,99,2,4,6292),(6292,99,3,4,6292),(6292,99,4,4,6292),(6292,99,5,4,6292),(6293,99,1,4,6293),(6293,99,2,4,6293),(6293,99,3,4,6293),(6293,99,4,4,6293),(6293,99,5,4,6293),(6294,99,1,4,6294),(6294,99,2,4,6294),(6294,99,3,4,6294),(6294,99,4,4,6294),(6294,99,5,4,6294),(6295,99,1,4,6295),(6295,99,2,4,6295),(6295,99,3,4,6295),(6295,99,4,4,6295),(6295,99,5,4,6295),(6296,99,1,4,6296),(6296,99,2,4,6296),(6296,99,3,4,6296),(6296,99,4,4,6296),(6296,99,5,4,6296),(6297,99,1,4,6297),(6297,99,2,4,6297),(6297,99,3,4,6297),(6297,99,4,4,6297),(6297,99,5,4,6297),(6298,99,1,4,6298),(6298,99,2,4,6298),(6298,99,3,4,6298),(6298,99,4,4,6298),(6298,99,5,4,6298),(6299,99,1,4,6299),(6299,99,2,4,6299),(6299,99,3,4,6299),(6299,99,4,4,6299),(6299,99,5,4,6299),(6300,99,1,4,6300),(6300,99,2,4,6300),(6300,99,3,4,6300),(6300,99,4,4,6300),(6300,99,5,4,6300),(6301,99,1,4,6301),(6301,99,2,4,6301),(6301,99,3,4,6301),(6301,99,4,4,6301),(6301,99,5,4,6301),(6302,99,1,4,6302),(6302,99,2,4,6302),(6302,99,3,4,6302),(6302,99,4,4,6302),(6302,99,5,4,6302),(6303,99,1,4,6303),(6303,99,2,4,6303),(6303,99,3,4,6303),(6303,99,4,4,6303),(6303,99,5,4,6303),(6304,99,1,4,6304),(6304,99,2,4,6304),(6304,99,3,4,6304),(6304,99,4,4,6304),(6304,99,5,4,6304),(6305,99,1,4,6305),(6305,99,2,4,6305),(6305,99,3,4,6305),(6305,99,4,4,6305),(6305,99,5,4,6305),(6306,99,1,4,6306),(6306,99,2,4,6306),(6306,99,3,4,6306),(6306,99,4,4,6306),(6306,99,5,4,6306),(6307,99,1,4,6307),(6307,99,2,4,6307),(6307,99,3,4,6307),(6307,99,4,4,6307),(6307,99,5,4,6307),(6308,99,1,4,6308),(6308,99,2,4,6308),(6308,99,3,4,6308),(6308,99,4,4,6308),(6308,99,5,4,6308),(6309,99,1,4,6309),(6309,99,2,4,6309),(6309,99,3,4,6309),(6309,99,4,4,6309),(6309,99,5,4,6309),(6310,99,1,4,6310),(6310,99,2,4,6310),(6310,99,3,4,6310),(6310,99,4,4,6310),(6310,99,5,4,6310),(6311,99,1,4,6311),(6311,99,2,4,6311),(6311,99,3,4,6311),(6311,99,4,4,6311),(6311,99,5,4,6311),(6312,99,1,4,6312),(6312,99,2,4,6312),(6312,99,3,4,6312),(6312,99,4,4,6312),(6312,99,5,4,6312),(6313,99,1,4,6313),(6313,99,2,4,6313),(6313,99,3,4,6313),(6313,99,4,4,6313),(6313,99,5,4,6313),(6314,99,1,4,6314),(6314,99,2,4,6314),(6314,99,3,4,6314),(6314,99,4,4,6314),(6314,99,5,4,6314),(6315,99,1,4,6315),(6315,99,2,4,6315),(6315,99,3,4,6315),(6315,99,4,4,6315),(6315,99,5,4,6315),(6316,99,1,4,6316),(6316,99,2,4,6316),(6316,99,3,4,6316),(6316,99,4,4,6316),(6316,99,5,4,6316),(6317,99,1,4,6317),(6317,99,2,4,6317),(6317,99,3,4,6317),(6317,99,4,4,6317),(6317,99,5,4,6317),(6318,99,1,4,6318),(6318,99,2,4,6318),(6318,99,3,4,6318),(6318,99,4,4,6318),(6318,99,5,4,6318),(6319,99,1,4,6319),(6319,99,2,4,6319),(6319,99,3,4,6319),(6319,99,4,4,6319),(6319,99,5,4,6319),(6320,99,1,4,6320),(6320,99,2,4,6320),(6320,99,3,4,6320),(6320,99,4,4,6320),(6320,99,5,4,6320),(6321,99,1,4,6321),(6321,99,2,4,6321),(6321,99,3,4,6321),(6321,99,4,4,6321),(6321,99,5,4,6321),(6322,99,1,4,6322),(6322,99,2,4,6322),(6322,99,3,4,6322),(6322,99,4,4,6322),(6322,99,5,4,6322),(6323,99,1,4,6323),(6323,99,2,4,6323),(6323,99,3,4,6323),(6323,99,4,4,6323),(6323,99,5,4,6323),(6324,99,1,4,6324),(6324,99,2,4,6324),(6324,99,3,4,6324),(6324,99,4,4,6324),(6324,99,5,4,6324),(6325,99,1,4,6325),(6325,99,2,4,6325),(6325,99,3,4,6325),(6325,99,4,4,6325),(6325,99,5,4,6325),(6326,99,1,4,6326),(6326,99,2,4,6326),(6326,99,3,4,6326),(6326,99,4,4,6326),(6326,99,5,4,6326),(6327,99,1,4,6327),(6327,99,2,4,6327),(6327,99,3,4,6327),(6327,99,4,4,6327),(6327,99,5,4,6327),(6328,99,1,4,6328),(6328,99,2,4,6328),(6328,99,3,4,6328),(6328,99,4,4,6328),(6328,99,5,4,6328),(6329,99,1,4,6329),(6329,99,2,4,6329),(6329,99,3,4,6329),(6329,99,4,4,6329),(6329,99,5,4,6329),(6330,99,1,4,6330),(6330,99,2,4,6330),(6330,99,3,4,6330),(6330,99,4,4,6330),(6330,99,5,4,6330),(6331,99,1,4,6331),(6331,99,2,4,6331),(6331,99,3,4,6331),(6331,99,4,4,6331),(6331,99,5,4,6331),(6332,99,1,4,6332),(6332,99,2,4,6332),(6332,99,3,4,6332),(6332,99,4,4,6332),(6332,99,5,4,6332),(6333,99,1,4,6333),(6333,99,2,4,6333),(6333,99,3,4,6333),(6333,99,4,4,6333),(6333,99,5,4,6333),(6334,99,1,4,6334),(6334,99,2,4,6334),(6334,99,3,4,6334),(6334,99,4,4,6334),(6334,99,5,4,6334),(6335,99,1,4,6335),(6335,99,2,4,6335),(6335,99,3,4,6335),(6335,99,4,4,6335),(6335,99,5,4,6335),(6336,99,1,4,6336),(6336,99,2,4,6336),(6336,99,3,4,6336),(6336,99,4,4,6336),(6336,99,5,4,6336),(6337,99,1,4,6337),(6337,99,2,4,6337),(6337,99,3,4,6337),(6337,99,4,4,6337),(6337,99,5,4,6337),(6338,99,1,4,6338),(6338,99,2,4,6338),(6338,99,3,4,6338),(6338,99,4,4,6338),(6338,99,5,4,6338),(6339,99,1,4,6339),(6339,99,2,4,6339),(6339,99,3,4,6339),(6339,99,4,4,6339),(6339,99,5,4,6339),(6340,99,1,4,6340),(6340,99,2,4,6340),(6340,99,3,4,6340),(6340,99,4,4,6340),(6340,99,5,4,6340),(6341,99,1,4,6341),(6341,99,2,4,6341),(6341,99,3,4,6341),(6341,99,4,4,6341),(6341,99,5,4,6341),(6342,99,1,4,6342),(6342,99,2,4,6342),(6342,99,3,4,6342),(6342,99,4,4,6342),(6342,99,5,4,6342),(6343,99,1,4,6343),(6343,99,2,4,6343),(6343,99,3,4,6343),(6343,99,4,4,6343),(6343,99,5,4,6343),(6344,99,1,4,6344),(6344,99,2,4,6344),(6344,99,3,4,6344),(6344,99,4,4,6344),(6344,99,5,4,6344),(6345,99,1,4,6345),(6345,99,2,4,6345),(6345,99,3,4,6345),(6345,99,4,4,6345),(6345,99,5,4,6345),(6346,99,1,4,6346),(6346,99,2,4,6346),(6346,99,3,4,6346),(6346,99,4,4,6346),(6346,99,5,4,6346),(6347,99,1,4,6347),(6347,99,2,4,6347),(6347,99,3,4,6347),(6347,99,4,4,6347),(6347,99,5,4,6347),(6348,99,1,4,6348),(6348,99,2,4,6348),(6348,99,3,4,6348),(6348,99,4,4,6348),(6348,99,5,4,6348),(6349,99,1,4,6349),(6349,99,2,4,6349),(6349,99,3,4,6349),(6349,99,4,4,6349),(6349,99,5,4,6349),(6350,99,1,4,6350),(6350,99,2,4,6350),(6350,99,3,4,6350),(6350,99,4,4,6350),(6350,99,5,4,6350),(6351,99,1,4,6351),(6351,99,2,4,6351),(6351,99,3,4,6351),(6351,99,4,4,6351),(6351,99,5,4,6351),(6352,99,1,4,6352),(6352,99,2,4,6352),(6352,99,3,4,6352),(6352,99,4,4,6352),(6352,99,5,4,6352),(6353,99,1,2,6353),(6353,99,2,2,6353),(6353,99,3,2,6353),(6353,99,4,2,6353),(6353,99,5,2,6353),(6354,99,1,4,6354),(6354,99,2,4,6354),(6354,99,3,4,6354),(6354,99,4,4,6354),(6354,99,5,4,6354),(6355,99,1,4,6355),(6355,99,2,4,6355),(6355,99,3,4,6355),(6355,99,4,4,6355),(6355,99,5,4,6355),(6356,99,1,4,6356),(6356,99,2,4,6356),(6356,99,3,4,6356),(6356,99,4,4,6356),(6356,99,5,4,6356),(6357,99,1,4,6357),(6357,99,2,4,6357),(6357,99,3,4,6357),(6357,99,4,4,6357),(6357,99,5,4,6357),(6358,99,1,4,6358),(6358,99,2,4,6358),(6358,99,3,4,6358),(6358,99,4,4,6358),(6358,99,5,4,6358),(6359,99,1,4,6359),(6359,99,2,4,6359),(6359,99,3,4,6359),(6359,99,4,4,6359),(6359,99,5,4,6359),(6360,99,1,4,6360),(6360,99,2,4,6360),(6360,99,3,4,6360),(6360,99,4,4,6360),(6360,99,5,4,6360),(6361,99,1,4,6361),(6361,99,2,4,6361),(6361,99,3,4,6361),(6361,99,4,4,6361),(6361,99,5,4,6361),(6362,99,1,4,6362),(6362,99,2,4,6362),(6362,99,3,4,6362),(6362,99,4,4,6362),(6362,99,5,4,6362),(6363,99,1,4,6363),(6363,99,2,4,6363),(6363,99,3,4,6363),(6363,99,4,4,6363),(6363,99,5,4,6363),(6364,99,1,4,6364),(6364,99,2,4,6364),(6364,99,3,4,6364),(6364,99,4,4,6364),(6364,99,5,4,6364),(6365,99,1,4,6365),(6365,99,2,4,6365),(6365,99,3,4,6365),(6365,99,4,4,6365),(6365,99,5,4,6365),(6366,99,1,4,6366),(6366,99,2,4,6366),(6366,99,3,4,6366),(6366,99,4,4,6366),(6366,99,5,4,6366),(6367,99,1,4,6367),(6367,99,2,4,6367),(6367,99,3,4,6367),(6367,99,4,4,6367),(6367,99,5,4,6367),(6368,99,1,4,6368),(6368,99,2,4,6368),(6368,99,3,4,6368),(6368,99,4,4,6368),(6368,99,5,4,6368),(6369,99,1,4,6369),(6369,99,2,4,6369),(6369,99,3,4,6369),(6369,99,4,4,6369),(6369,99,5,4,6369),(6370,99,1,4,6370),(6370,99,2,4,6370),(6370,99,3,4,6370),(6370,99,4,4,6370),(6370,99,5,4,6370),(6371,99,1,4,6371),(6371,99,2,4,6371),(6371,99,3,4,6371),(6371,99,4,4,6371),(6371,99,5,4,6371),(6372,99,1,4,6372),(6372,99,2,4,6372),(6372,99,3,4,6372),(6372,99,4,4,6372),(6372,99,5,4,6372),(6373,99,1,4,6373),(6373,99,2,4,6373),(6373,99,3,4,6373),(6373,99,4,4,6373),(6373,99,5,4,6373),(6374,99,1,4,6374),(6374,99,2,4,6374),(6374,99,3,4,6374),(6374,99,4,4,6374),(6374,99,5,4,6374),(6375,99,1,4,6375),(6375,99,2,4,6375),(6375,99,3,4,6375),(6375,99,4,4,6375),(6375,99,5,4,6375),(6376,99,1,4,6376),(6376,99,2,4,6376),(6376,99,3,4,6376),(6376,99,4,4,6376),(6376,99,5,4,6376),(6377,99,1,4,6377),(6377,99,2,4,6377),(6377,99,3,4,6377),(6377,99,4,4,6377),(6377,99,5,4,6377),(6378,99,1,4,6378),(6378,99,2,4,6378),(6378,99,3,4,6378),(6378,99,4,4,6378),(6378,99,5,4,6378),(6379,99,1,4,6379),(6379,99,2,4,6379),(6379,99,3,4,6379),(6379,99,4,4,6379),(6379,99,5,4,6379),(6380,99,1,4,6380),(6380,99,2,4,6380),(6380,99,3,4,6380),(6380,99,4,4,6380),(6380,99,5,4,6380),(6381,99,1,4,6381),(6381,99,2,4,6381),(6381,99,3,4,6381),(6381,99,4,4,6381),(6381,99,5,4,6381),(6382,99,1,4,6382),(6382,99,2,4,6382),(6382,99,3,4,6382),(6382,99,4,4,6382),(6382,99,5,4,6382),(6383,99,1,4,6383),(6383,99,2,4,6383),(6383,99,3,4,6383),(6383,99,4,4,6383),(6383,99,5,4,6383),(6384,99,1,4,6384),(6384,99,2,4,6384),(6384,99,3,4,6384),(6384,99,4,4,6384),(6384,99,5,4,6384),(6385,99,1,4,6385),(6385,99,2,4,6385),(6385,99,3,4,6385),(6385,99,4,4,6385),(6385,99,5,4,6385),(6386,99,1,4,6386),(6386,99,2,4,6386),(6386,99,3,4,6386),(6386,99,4,4,6386),(6386,99,5,4,6386),(6387,99,1,4,6387),(6387,99,2,4,6387),(6387,99,3,4,6387),(6387,99,4,4,6387),(6387,99,5,4,6387),(6388,99,1,4,6388),(6388,99,2,4,6388),(6388,99,3,4,6388),(6388,99,4,4,6388),(6388,99,5,4,6388),(6389,99,1,4,6389),(6389,99,2,4,6389),(6389,99,3,4,6389),(6389,99,4,4,6389),(6389,99,5,4,6389),(6390,99,1,4,6390),(6390,99,2,4,6390),(6390,99,3,4,6390),(6390,99,4,4,6390),(6390,99,5,4,6390),(6391,99,1,4,6391),(6391,99,2,4,6391),(6391,99,3,4,6391),(6391,99,4,4,6391),(6391,99,5,4,6391),(6392,99,1,4,6392),(6392,99,2,4,6392),(6392,99,3,4,6392),(6392,99,4,4,6392),(6392,99,5,4,6392),(6393,99,1,4,6393),(6393,99,2,4,6393),(6393,99,3,4,6393),(6393,99,4,4,6393),(6393,99,5,4,6393),(6394,99,1,4,6394),(6394,99,2,4,6394),(6394,99,3,4,6394),(6394,99,4,4,6394),(6394,99,5,4,6394),(6395,99,1,4,6395),(6395,99,2,4,6395),(6395,99,3,4,6395),(6395,99,4,4,6395),(6395,99,5,4,6395),(6396,99,1,4,6396),(6396,99,2,4,6396),(6396,99,3,4,6396),(6396,99,4,4,6396),(6396,99,5,4,6396),(6397,99,1,4,6397),(6397,99,2,4,6397),(6397,99,3,4,6397),(6397,99,4,4,6397),(6397,99,5,4,6397),(6398,99,1,4,6398),(6398,99,2,4,6398),(6398,99,3,4,6398),(6398,99,4,4,6398),(6398,99,5,4,6398),(6399,99,1,4,6399),(6399,99,2,4,6399),(6399,99,3,4,6399),(6399,99,4,4,6399),(6399,99,5,4,6399),(6400,99,1,4,6400),(6400,99,2,4,6400),(6400,99,3,4,6400),(6400,99,4,4,6400),(6400,99,5,4,6400),(6401,99,1,4,6401),(6401,99,2,4,6401),(6401,99,3,4,6401),(6401,99,4,4,6401),(6401,99,5,4,6401),(6402,99,1,4,6402),(6402,99,2,4,6402),(6402,99,3,4,6402),(6402,99,4,4,6402),(6402,99,5,4,6402),(6403,99,1,4,6403),(6403,99,2,4,6403),(6403,99,3,4,6403),(6403,99,4,4,6403),(6403,99,5,4,6403),(6404,99,1,4,6404),(6404,99,2,4,6404),(6404,99,3,4,6404),(6404,99,4,4,6404),(6404,99,5,4,6404),(6405,99,1,4,6405),(6405,99,2,4,6405),(6405,99,3,4,6405),(6405,99,4,4,6405),(6405,99,5,4,6405),(6406,99,1,4,6406),(6406,99,2,4,6406),(6406,99,3,4,6406),(6406,99,4,4,6406),(6406,99,5,4,6406),(6407,99,1,4,6407),(6407,99,2,4,6407),(6407,99,3,4,6407),(6407,99,4,4,6407),(6407,99,5,4,6407),(6408,99,1,4,6408),(6408,99,2,4,6408),(6408,99,3,4,6408),(6408,99,4,4,6408),(6408,99,5,4,6408),(6409,99,1,4,6409),(6409,99,2,4,6409),(6409,99,3,4,6409),(6409,99,4,4,6409),(6409,99,5,4,6409),(6410,99,1,4,6410),(6410,99,2,4,6410),(6410,99,3,4,6410),(6410,99,4,4,6410),(6410,99,5,4,6410),(6411,99,1,4,6411),(6411,99,2,4,6411),(6411,99,3,4,6411),(6411,99,4,4,6411),(6411,99,5,4,6411),(6412,99,1,4,6412),(6412,99,2,4,6412),(6412,99,3,4,6412),(6412,99,4,4,6412),(6412,99,5,4,6412),(6413,99,1,4,6413),(6413,99,2,4,6413),(6413,99,3,4,6413),(6413,99,4,4,6413),(6413,99,5,4,6413),(6414,99,1,4,6414),(6414,99,2,4,6414),(6414,99,3,4,6414),(6414,99,4,4,6414),(6414,99,5,4,6414),(6415,99,1,4,6415),(6415,99,2,4,6415),(6415,99,3,4,6415),(6415,99,4,4,6415),(6415,99,5,4,6415),(6416,99,1,4,6416),(6416,99,2,4,6416),(6416,99,3,4,6416),(6416,99,4,4,6416),(6416,99,5,4,6416),(6417,99,1,4,6417),(6417,99,2,4,6417),(6417,99,3,4,6417),(6417,99,4,4,6417),(6417,99,5,4,6417),(6418,99,1,4,6418),(6418,99,2,4,6418),(6418,99,3,4,6418),(6418,99,4,4,6418),(6418,99,5,4,6418),(6419,99,1,4,6419),(6419,99,2,4,6419),(6419,99,3,4,6419),(6419,99,4,4,6419),(6419,99,5,4,6419),(6420,99,1,4,6420),(6420,99,2,4,6420),(6420,99,3,4,6420),(6420,99,4,4,6420),(6420,99,5,4,6420),(6421,99,1,4,6421),(6421,99,2,4,6421),(6421,99,3,4,6421),(6421,99,4,4,6421),(6421,99,5,4,6421),(6422,99,1,4,6422),(6422,99,2,4,6422),(6422,99,3,4,6422),(6422,99,4,4,6422),(6422,99,5,4,6422),(6423,99,1,4,6423),(6423,99,2,4,6423),(6423,99,3,4,6423),(6423,99,4,4,6423),(6423,99,5,4,6423),(6424,99,1,4,6424),(6424,99,2,4,6424),(6424,99,3,4,6424),(6424,99,4,4,6424),(6424,99,5,4,6424),(6425,99,1,4,6425),(6425,99,2,4,6425),(6425,99,3,4,6425),(6425,99,4,4,6425),(6425,99,5,4,6425),(6426,99,1,4,6426),(6426,99,2,4,6426),(6426,99,3,4,6426),(6426,99,4,4,6426),(6426,99,5,4,6426),(6427,99,1,4,6427),(6427,99,2,4,6427),(6427,99,3,4,6427),(6427,99,4,4,6427),(6427,99,5,4,6427),(6428,99,1,4,6428),(6428,99,2,4,6428),(6428,99,3,4,6428),(6428,99,4,4,6428),(6428,99,5,4,6428),(6429,99,1,4,6429),(6429,99,2,4,6429),(6429,99,3,4,6429),(6429,99,4,4,6429),(6429,99,5,4,6429),(6430,99,1,4,6430),(6430,99,2,4,6430),(6430,99,3,4,6430),(6430,99,4,4,6430),(6430,99,5,4,6430),(6431,99,1,4,6431),(6431,99,2,4,6431),(6431,99,3,4,6431),(6431,99,4,4,6431),(6431,99,5,4,6431),(6432,99,1,4,6432),(6432,99,2,4,6432),(6432,99,3,4,6432),(6432,99,4,4,6432),(6432,99,5,4,6432),(6433,99,1,4,6433),(6433,99,2,4,6433),(6433,99,3,4,6433),(6433,99,4,4,6433),(6433,99,5,4,6433),(6434,99,1,4,6434),(6434,99,2,4,6434),(6434,99,3,4,6434),(6434,99,4,4,6434),(6434,99,5,4,6434),(6435,99,1,4,6435),(6435,99,2,4,6435),(6435,99,3,4,6435),(6435,99,4,4,6435),(6435,99,5,4,6435),(6436,99,1,4,6436),(6436,99,2,4,6436),(6436,99,3,4,6436),(6436,99,4,4,6436),(6436,99,5,4,6436),(6437,99,1,4,6437),(6437,99,2,4,6437),(6437,99,3,4,6437),(6437,99,4,4,6437),(6437,99,5,4,6437),(6438,99,1,4,6438),(6438,99,2,4,6438),(6438,99,3,4,6438),(6438,99,4,4,6438),(6438,99,5,4,6438),(6439,99,1,4,6439),(6439,99,2,4,6439),(6439,99,3,4,6439),(6439,99,4,4,6439),(6439,99,5,4,6439),(6440,99,1,4,6440),(6440,99,2,4,6440),(6440,99,3,4,6440),(6440,99,4,4,6440),(6440,99,5,4,6440),(6441,99,1,4,6441),(6441,99,2,4,6441),(6441,99,3,4,6441),(6441,99,4,4,6441),(6441,99,5,4,6441),(6442,99,1,4,6442),(6442,99,2,4,6442),(6442,99,3,4,6442),(6442,99,4,4,6442),(6442,99,5,4,6442),(6443,99,1,4,6443),(6443,99,2,4,6443),(6443,99,3,4,6443),(6443,99,4,4,6443),(6443,99,5,4,6443),(6444,99,1,4,6444),(6444,99,2,4,6444),(6444,99,3,4,6444),(6444,99,4,4,6444),(6444,99,5,4,6444),(6445,99,1,4,6445),(6445,99,2,4,6445),(6445,99,3,4,6445),(6445,99,4,4,6445),(6445,99,5,4,6445),(6446,99,1,4,6446),(6446,99,2,4,6446),(6446,99,3,4,6446),(6446,99,4,4,6446),(6446,99,5,4,6446),(6447,99,1,4,6447),(6447,99,2,4,6447),(6447,99,3,4,6447),(6447,99,4,4,6447),(6447,99,5,4,6447),(6448,99,1,4,6448),(6448,99,2,4,6448),(6448,99,3,4,6448),(6448,99,4,4,6448),(6448,99,5,4,6448),(6449,99,1,4,6449),(6449,99,2,4,6449),(6449,99,3,4,6449),(6449,99,4,4,6449),(6449,99,5,4,6449),(6450,99,1,4,6450),(6450,99,2,4,6450),(6450,99,3,4,6450),(6450,99,4,4,6450),(6450,99,5,4,6450),(6451,99,1,4,6451),(6451,99,2,4,6451),(6451,99,3,4,6451),(6451,99,4,4,6451),(6451,99,5,4,6451),(6452,99,1,4,6452),(6452,99,2,4,6452),(6452,99,3,4,6452),(6452,99,4,4,6452),(6452,99,5,4,6452),(6453,99,1,4,6453),(6453,99,2,4,6453),(6453,99,3,4,6453),(6453,99,4,4,6453),(6453,99,5,4,6453),(6454,99,1,4,6454),(6454,99,2,4,6454),(6454,99,3,4,6454),(6454,99,4,4,6454),(6454,99,5,4,6454),(6455,99,1,4,6455),(6455,99,2,4,6455),(6455,99,3,4,6455),(6455,99,4,4,6455),(6455,99,5,4,6455),(6456,99,1,4,6456),(6456,99,2,4,6456),(6456,99,3,4,6456),(6456,99,4,4,6456),(6456,99,5,4,6456),(6457,99,1,4,6457),(6457,99,2,4,6457),(6457,99,3,4,6457),(6457,99,4,4,6457),(6457,99,5,4,6457),(6458,99,1,4,6458),(6458,99,2,4,6458),(6458,99,3,4,6458),(6458,99,4,4,6458),(6458,99,5,4,6458),(6459,99,1,4,6459),(6459,99,2,4,6459),(6459,99,3,4,6459),(6459,99,4,4,6459),(6459,99,5,4,6459),(6460,99,1,4,6460),(6460,99,2,4,6460),(6460,99,3,4,6460),(6460,99,4,4,6460),(6460,99,5,4,6460),(6461,99,1,4,6461),(6461,99,2,4,6461),(6461,99,3,4,6461),(6461,99,4,4,6461),(6461,99,5,4,6461),(6462,99,1,4,6462),(6462,99,2,4,6462),(6462,99,3,4,6462),(6462,99,4,4,6462),(6462,99,5,4,6462),(6463,99,1,4,6463),(6463,99,2,4,6463),(6463,99,3,4,6463),(6463,99,4,4,6463),(6463,99,5,4,6463),(6464,99,1,4,6464),(6464,99,2,4,6464),(6464,99,3,4,6464),(6464,99,4,4,6464),(6464,99,5,4,6464),(6465,99,1,4,6465),(6465,99,2,4,6465),(6465,99,3,4,6465),(6465,99,4,4,6465),(6465,99,5,4,6465),(6466,99,1,4,6466),(6466,99,2,4,6466),(6466,99,3,4,6466),(6466,99,4,4,6466),(6466,99,5,4,6466),(6467,99,1,4,6467),(6467,99,2,4,6467),(6467,99,3,4,6467),(6467,99,4,4,6467),(6467,99,5,4,6467),(6468,99,1,4,6468),(6468,99,2,4,6468),(6468,99,3,4,6468),(6468,99,4,4,6468),(6468,99,5,4,6468),(6469,99,1,4,6469),(6469,99,2,4,6469),(6469,99,3,4,6469),(6469,99,4,4,6469),(6469,99,5,4,6469),(6470,99,1,4,6470),(6470,99,2,4,6470),(6470,99,3,4,6470),(6470,99,4,4,6470),(6470,99,5,4,6470),(6471,99,1,4,6471),(6471,99,2,4,6471),(6471,99,3,4,6471),(6471,99,4,4,6471),(6471,99,5,4,6471),(6472,99,1,4,6472),(6472,99,2,4,6472),(6472,99,3,4,6472),(6472,99,4,4,6472),(6472,99,5,4,6472),(6473,99,1,4,6473),(6473,99,2,4,6473),(6473,99,3,4,6473),(6473,99,4,4,6473),(6473,99,5,4,6473),(6474,99,1,4,6474),(6474,99,2,4,6474),(6474,99,3,4,6474),(6474,99,4,4,6474),(6474,99,5,4,6474),(6475,99,1,4,6475),(6475,99,2,4,6475),(6475,99,3,4,6475),(6475,99,4,4,6475),(6475,99,5,4,6475),(6476,99,1,4,6476),(6476,99,2,4,6476),(6476,99,3,4,6476),(6476,99,4,4,6476),(6476,99,5,4,6476),(6477,99,1,4,6477),(6477,99,2,4,6477),(6477,99,3,4,6477),(6477,99,4,4,6477),(6477,99,5,4,6477),(6478,99,1,4,6478),(6478,99,2,4,6478),(6478,99,3,4,6478),(6478,99,4,4,6478),(6478,99,5,4,6478),(6479,99,1,4,6479),(6479,99,2,4,6479),(6479,99,3,4,6479),(6479,99,4,4,6479),(6479,99,5,4,6479),(6480,99,1,4,6480),(6480,99,2,4,6480),(6480,99,3,4,6480),(6480,99,4,4,6480),(6480,99,5,4,6480),(6481,99,1,4,6481),(6481,99,2,4,6481),(6481,99,3,4,6481),(6481,99,4,4,6481),(6481,99,5,4,6481),(6482,99,1,4,6482),(6482,99,2,4,6482),(6482,99,3,4,6482),(6482,99,4,4,6482),(6482,99,5,4,6482),(6483,99,1,4,6483),(6483,99,2,4,6483),(6483,99,3,4,6483),(6483,99,4,4,6483),(6483,99,5,4,6483),(6484,99,1,4,6484),(6484,99,2,4,6484),(6484,99,3,4,6484),(6484,99,4,4,6484),(6484,99,5,4,6484),(6485,99,1,4,6485),(6485,99,2,4,6485),(6485,99,3,4,6485),(6485,99,4,4,6485),(6485,99,5,4,6485),(6486,99,1,4,6486),(6486,99,2,4,6486),(6486,99,3,4,6486),(6486,99,4,4,6486),(6486,99,5,4,6486),(6487,99,1,4,6487),(6487,99,2,4,6487),(6487,99,3,4,6487),(6487,99,4,4,6487),(6487,99,5,4,6487),(6488,99,1,4,6488),(6488,99,2,4,6488),(6488,99,3,4,6488),(6488,99,4,4,6488),(6488,99,5,4,6488),(6489,99,1,4,6489),(6489,99,2,4,6489),(6489,99,3,4,6489),(6489,99,4,4,6489),(6489,99,5,4,6489),(6490,99,1,4,6490),(6490,99,2,4,6490),(6490,99,3,4,6490),(6490,99,4,4,6490),(6490,99,5,4,6490),(6491,99,1,4,6491),(6491,99,2,4,6491),(6491,99,3,4,6491),(6491,99,4,4,6491),(6491,99,5,4,6491),(6492,99,1,4,6492),(6492,99,2,4,6492),(6492,99,3,4,6492),(6492,99,4,4,6492),(6492,99,5,4,6492),(6493,99,1,4,6493),(6493,99,2,4,6493),(6493,99,3,4,6493),(6493,99,4,4,6493),(6493,99,5,4,6493),(6494,99,1,4,6494),(6494,99,2,4,6494),(6494,99,3,4,6494),(6494,99,4,4,6494),(6494,99,5,4,6494),(6495,99,1,4,6495),(6495,99,2,4,6495),(6495,99,3,4,6495),(6495,99,4,4,6495),(6495,99,5,4,6495),(6496,99,1,4,6496),(6496,99,2,4,6496),(6496,99,3,4,6496),(6496,99,4,4,6496),(6496,99,5,4,6496),(6497,99,1,4,6497),(6497,99,2,4,6497),(6497,99,3,4,6497),(6497,99,4,4,6497),(6497,99,5,4,6497),(6498,99,1,4,6498),(6498,99,2,4,6498),(6498,99,3,4,6498),(6498,99,4,4,6498),(6498,99,5,4,6498),(6499,99,1,4,6499),(6499,99,2,4,6499),(6499,99,3,4,6499),(6499,99,4,4,6499),(6499,99,5,4,6499),(6500,99,1,4,6500),(6500,99,2,4,6500),(6500,99,3,4,6500),(6500,99,4,4,6500),(6500,99,5,4,6500),(6501,99,1,4,6501),(6501,99,2,4,6501),(6501,99,3,4,6501),(6501,99,4,4,6501),(6501,99,5,4,6501),(6502,99,1,4,6502),(6502,99,2,4,6502),(6502,99,3,4,6502),(6502,99,4,4,6502),(6502,99,5,4,6502),(6503,99,1,4,6503),(6503,99,2,4,6503),(6503,99,3,4,6503),(6503,99,4,4,6503),(6503,99,5,4,6503),(6504,99,1,4,6504),(6504,99,2,4,6504),(6504,99,3,4,6504),(6504,99,4,4,6504),(6504,99,5,4,6504),(6505,99,1,4,6505),(6505,99,2,4,6505),(6505,99,3,4,6505),(6505,99,4,4,6505),(6505,99,5,4,6505),(6506,99,1,4,6506),(6506,99,2,4,6506),(6506,99,3,4,6506),(6506,99,4,4,6506),(6506,99,5,4,6506),(6507,99,1,4,6507),(6507,99,2,4,6507),(6507,99,3,4,6507),(6507,99,4,4,6507),(6507,99,5,4,6507),(6508,99,1,4,6508),(6508,99,2,4,6508),(6508,99,3,4,6508),(6508,99,4,4,6508),(6508,99,5,4,6508),(6509,99,1,4,6509),(6509,99,2,4,6509),(6509,99,3,4,6509),(6509,99,4,4,6509),(6509,99,5,4,6509),(6510,99,1,4,6510),(6510,99,2,4,6510),(6510,99,3,4,6510),(6510,99,4,4,6510),(6510,99,5,4,6510),(6511,99,1,4,6511),(6511,99,2,4,6511),(6511,99,3,4,6511),(6511,99,4,4,6511),(6511,99,5,4,6511),(6512,99,1,4,6512),(6512,99,2,4,6512),(6512,99,3,4,6512),(6512,99,4,4,6512),(6512,99,5,4,6512),(6513,99,1,4,6513),(6513,99,2,4,6513),(6513,99,3,4,6513),(6513,99,4,4,6513),(6513,99,5,4,6513),(6514,99,1,4,6514),(6514,99,2,4,6514),(6514,99,3,4,6514),(6514,99,4,4,6514),(6514,99,5,4,6514),(6515,99,1,4,6515),(6515,99,2,4,6515),(6515,99,3,4,6515),(6515,99,4,4,6515),(6515,99,5,4,6515),(6516,99,1,4,6516),(6516,99,2,4,6516),(6516,99,3,4,6516),(6516,99,4,4,6516),(6516,99,5,4,6516),(6517,99,1,4,6517),(6517,99,2,4,6517),(6517,99,3,4,6517),(6517,99,4,4,6517),(6517,99,5,4,6517),(6518,99,1,4,6518),(6518,99,2,4,6518),(6518,99,3,4,6518),(6518,99,4,4,6518),(6518,99,5,4,6518),(6519,99,1,4,6519),(6519,99,2,4,6519),(6519,99,3,4,6519),(6519,99,4,4,6519),(6519,99,5,4,6519),(6520,99,1,4,6520),(6520,99,2,4,6520),(6520,99,3,4,6520),(6520,99,4,4,6520),(6520,99,5,4,6520),(6521,99,1,4,6521),(6521,99,2,4,6521),(6521,99,3,4,6521),(6521,99,4,4,6521),(6521,99,5,4,6521),(6522,99,1,4,6522),(6522,99,2,4,6522),(6522,99,3,4,6522),(6522,99,4,4,6522),(6522,99,5,4,6522),(6523,99,1,4,6523),(6523,99,2,4,6523),(6523,99,3,4,6523),(6523,99,4,4,6523),(6523,99,5,4,6523),(6524,99,1,4,6524),(6524,99,2,4,6524),(6524,99,3,4,6524),(6524,99,4,4,6524),(6524,99,5,4,6524),(6525,99,1,4,6525),(6525,99,2,4,6525),(6525,99,3,4,6525),(6525,99,4,4,6525),(6525,99,5,4,6525),(6526,99,1,4,6526),(6526,99,2,4,6526),(6526,99,3,4,6526),(6526,99,4,4,6526),(6526,99,5,4,6526),(6527,99,1,4,6527),(6527,99,2,4,6527),(6527,99,3,4,6527),(6527,99,4,4,6527),(6527,99,5,4,6527),(6528,99,1,4,6528),(6528,99,2,4,6528),(6528,99,3,4,6528),(6528,99,4,4,6528),(6528,99,5,4,6528),(6529,99,1,4,6529),(6529,99,2,4,6529),(6529,99,3,4,6529),(6529,99,4,4,6529),(6529,99,5,4,6529),(6530,99,1,4,6530),(6530,99,2,4,6530),(6530,99,3,4,6530),(6530,99,4,4,6530),(6530,99,5,4,6530),(6531,99,1,4,6531),(6531,99,2,4,6531),(6531,99,3,4,6531),(6531,99,4,4,6531),(6531,99,5,4,6531),(6532,99,1,4,6532),(6532,99,2,4,6532),(6532,99,3,4,6532),(6532,99,4,4,6532),(6532,99,5,4,6532),(6533,99,1,4,6533),(6533,99,2,4,6533),(6533,99,3,4,6533),(6533,99,4,4,6533),(6533,99,5,4,6533),(6534,99,1,4,6534),(6534,99,2,4,6534),(6534,99,3,4,6534),(6534,99,4,4,6534),(6534,99,5,4,6534),(6535,99,1,4,6535),(6535,99,2,4,6535),(6535,99,3,4,6535),(6535,99,4,4,6535),(6535,99,5,4,6535),(6536,99,1,4,6536),(6536,99,2,4,6536),(6536,99,3,4,6536),(6536,99,4,4,6536),(6536,99,5,4,6536),(6537,99,1,4,6537),(6537,99,2,4,6537),(6537,99,3,4,6537),(6537,99,4,4,6537),(6537,99,5,4,6537),(6538,99,1,4,6538),(6538,99,2,4,6538),(6538,99,3,4,6538),(6538,99,4,4,6538),(6538,99,5,4,6538),(6539,99,1,4,6539),(6539,99,2,4,6539),(6539,99,3,4,6539),(6539,99,4,4,6539),(6539,99,5,4,6539),(6540,99,1,4,6540),(6540,99,2,4,6540),(6540,99,3,4,6540),(6540,99,4,4,6540),(6540,99,5,4,6540),(6541,99,1,4,6541),(6541,99,2,4,6541),(6541,99,3,4,6541),(6541,99,4,4,6541),(6541,99,5,4,6541),(6542,99,1,4,6542),(6542,99,2,4,6542),(6542,99,3,4,6542),(6542,99,4,4,6542),(6542,99,5,4,6542),(6543,99,1,4,6543),(6543,99,2,4,6543),(6543,99,3,4,6543),(6543,99,4,4,6543),(6543,99,5,4,6543),(6544,99,1,4,6544),(6544,99,2,4,6544),(6544,99,3,4,6544),(6544,99,4,4,6544),(6544,99,5,4,6544),(6545,99,1,4,6545),(6545,99,2,4,6545),(6545,99,3,4,6545),(6545,99,4,4,6545),(6545,99,5,4,6545),(6546,99,1,4,6546),(6546,99,2,4,6546),(6546,99,3,4,6546),(6546,99,4,4,6546),(6546,99,5,4,6546),(6547,99,1,2,6547),(6547,99,2,2,6547),(6547,99,3,2,6547),(6547,99,4,2,6547),(6547,99,5,2,6547),(6548,99,1,2,6548),(6548,99,2,2,6548),(6548,99,3,2,6548),(6548,99,4,2,6548),(6548,99,5,2,6548),(6549,99,1,2,6549),(6549,99,2,2,6549),(6549,99,3,2,6549),(6549,99,4,2,6549),(6549,99,5,2,6549),(6550,99,1,4,6550),(6550,99,2,4,6550),(6550,99,3,4,6550),(6550,99,4,4,6550),(6550,99,5,4,6550),(6551,99,1,2,6551),(6551,99,2,2,6551),(6551,99,3,2,6551),(6551,99,4,2,6551),(6551,99,5,2,6551),(6552,99,1,2,6552),(6552,99,2,2,6552),(6552,99,3,2,6552),(6552,99,4,2,6552),(6552,99,5,2,6552),(6553,99,1,2,6553),(6553,99,2,2,6553),(6553,99,3,2,6553),(6553,99,4,2,6553),(6553,99,5,2,6553),(6554,99,1,2,6554),(6554,99,2,2,6554),(6554,99,3,2,6554),(6554,99,4,2,6554),(6554,99,5,2,6554),(6555,99,1,2,6555),(6555,99,2,2,6555),(6555,99,3,2,6555),(6555,99,4,2,6555),(6555,99,5,2,6555),(6556,99,1,2,6556),(6556,99,2,2,6556),(6556,99,3,2,6556),(6556,99,4,2,6556),(6556,99,5,2,6556),(6557,99,1,4,6557),(6557,99,2,4,6557),(6557,99,3,4,6557),(6557,99,4,4,6557),(6557,99,5,4,6557),(6558,99,1,4,6558),(6558,99,2,4,6558),(6558,99,3,4,6558),(6558,99,4,4,6558),(6558,99,5,4,6558),(6559,99,1,2,6559),(6559,99,2,2,6559),(6559,99,3,2,6559),(6559,99,4,2,6559),(6559,99,5,2,6559),(6560,99,1,2,6560),(6560,99,2,2,6560),(6560,99,3,2,6560),(6560,99,4,2,6560),(6560,99,5,2,6560),(6561,99,1,2,6561),(6561,99,2,2,6561),(6561,99,3,2,6561),(6561,99,4,2,6561),(6561,99,5,2,6561),(6562,99,1,4,6562),(6562,99,2,4,6562),(6562,99,3,4,6562),(6562,99,4,4,6562),(6562,99,5,4,6562),(6563,99,1,4,6563),(6563,99,2,4,6563),(6563,99,3,4,6563),(6563,99,4,4,6563),(6563,99,5,4,6563),(6564,99,1,4,6564),(6564,99,2,4,6564),(6564,99,3,4,6564),(6564,99,4,4,6564),(6564,99,5,4,6564),(6565,99,1,4,6565),(6565,99,2,4,6565),(6565,99,3,4,6565),(6565,99,4,4,6565),(6565,99,5,4,6565),(6566,99,1,4,6566),(6566,99,2,4,6566),(6566,99,3,4,6566),(6566,99,4,4,6566),(6566,99,5,4,6566),(6567,99,1,4,6567),(6567,99,2,4,6567),(6567,99,3,4,6567),(6567,99,4,4,6567),(6567,99,5,4,6567),(6568,99,1,4,6568),(6568,99,2,4,6568),(6568,99,3,4,6568),(6568,99,4,4,6568),(6568,99,5,4,6568),(6569,99,1,4,6569),(6569,99,2,4,6569),(6569,99,3,4,6569),(6569,99,4,4,6569),(6569,99,5,4,6569),(6570,99,1,4,6570),(6570,99,2,4,6570),(6570,99,3,4,6570),(6570,99,4,4,6570),(6570,99,5,4,6570),(6571,99,1,4,6571),(6571,99,2,4,6571),(6571,99,3,4,6571),(6571,99,4,4,6571),(6571,99,5,4,6571),(6572,99,1,4,6572),(6572,99,2,4,6572),(6572,99,3,4,6572),(6572,99,4,4,6572),(6572,99,5,4,6572);
/*!40000 ALTER TABLE `catalog_product_index_eav` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_eav_decimal`
--

DROP TABLE IF EXISTS `catalog_product_index_eav_decimal`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_eav_decimal` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `attribute_id` smallint unsigned NOT NULL COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `value` decimal(12,4) NOT NULL COMMENT 'Value',
  `source_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Original entity ID for attribute value',
  PRIMARY KEY (`entity_id`,`attribute_id`,`store_id`,`value`,`source_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_DECIMAL_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_DECIMAL_STORE_ID` (`store_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_DECIMAL_VALUE` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product EAV Decimal Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_eav_decimal`
--

LOCK TABLES `catalog_product_index_eav_decimal` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_eav_decimal` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_eav_decimal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_eav_decimal_idx`
--

DROP TABLE IF EXISTS `catalog_product_index_eav_decimal_idx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_eav_decimal_idx` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `attribute_id` smallint unsigned NOT NULL COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `value` decimal(12,4) NOT NULL COMMENT 'Value',
  `source_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Original entity ID for attribute value',
  PRIMARY KEY (`entity_id`,`attribute_id`,`store_id`,`value`,`source_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_DECIMAL_IDX_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_DECIMAL_IDX_STORE_ID` (`store_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_DECIMAL_IDX_VALUE` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product EAV Decimal Indexer Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_eav_decimal_idx`
--

LOCK TABLES `catalog_product_index_eav_decimal_idx` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_eav_decimal_idx` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_eav_decimal_idx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_eav_decimal_replica`
--

DROP TABLE IF EXISTS `catalog_product_index_eav_decimal_replica`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_eav_decimal_replica` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `attribute_id` smallint unsigned NOT NULL COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `value` decimal(12,4) NOT NULL COMMENT 'Value',
  `source_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Original entity ID for attribute value',
  PRIMARY KEY (`entity_id`,`attribute_id`,`store_id`,`value`,`source_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_DECIMAL_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_DECIMAL_STORE_ID` (`store_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_DECIMAL_VALUE` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product EAV Decimal Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_eav_decimal_replica`
--

LOCK TABLES `catalog_product_index_eav_decimal_replica` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_eav_decimal_replica` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_eav_decimal_replica` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_eav_decimal_tmp`
--

DROP TABLE IF EXISTS `catalog_product_index_eav_decimal_tmp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_eav_decimal_tmp` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `attribute_id` smallint unsigned NOT NULL COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `value` decimal(12,4) NOT NULL COMMENT 'Value',
  `source_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Original entity ID for attribute value',
  PRIMARY KEY (`entity_id`,`attribute_id`,`store_id`,`value`,`source_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_DECIMAL_TMP_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_DECIMAL_TMP_STORE_ID` (`store_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_DECIMAL_TMP_VALUE` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product EAV Decimal Indexer Temp Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_eav_decimal_tmp`
--

LOCK TABLES `catalog_product_index_eav_decimal_tmp` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_eav_decimal_tmp` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_eav_decimal_tmp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_eav_idx`
--

DROP TABLE IF EXISTS `catalog_product_index_eav_idx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_eav_idx` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `attribute_id` smallint unsigned NOT NULL COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `value` int unsigned NOT NULL COMMENT 'Value',
  `source_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Original entity ID for attribute value',
  PRIMARY KEY (`entity_id`,`attribute_id`,`store_id`,`value`,`source_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_IDX_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_IDX_STORE_ID` (`store_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_IDX_VALUE` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product EAV Indexer Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_eav_idx`
--

LOCK TABLES `catalog_product_index_eav_idx` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_eav_idx` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_eav_idx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_eav_replica`
--

DROP TABLE IF EXISTS `catalog_product_index_eav_replica`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_eav_replica` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `attribute_id` smallint unsigned NOT NULL COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `value` int unsigned NOT NULL COMMENT 'Value',
  `source_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Original entity ID for attribute value',
  PRIMARY KEY (`entity_id`,`attribute_id`,`store_id`,`value`,`source_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_STORE_ID` (`store_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_VALUE` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product EAV Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_eav_replica`
--

LOCK TABLES `catalog_product_index_eav_replica` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_eav_replica` DISABLE KEYS */;
INSERT INTO `catalog_product_index_eav_replica` VALUES (5760,99,1,4,5760),(5760,99,2,4,5760),(5760,99,3,4,5760),(5760,99,4,4,5760),(5760,99,5,4,5760),(6035,99,1,4,6035),(6035,99,2,4,6035),(6035,99,3,4,6035),(6035,99,4,4,6035),(6035,99,5,4,6035),(6036,99,1,4,6036),(6036,99,2,4,6036),(6036,99,3,4,6036),(6036,99,4,4,6036),(6036,99,5,4,6036),(6037,99,1,4,6037),(6037,99,2,4,6037),(6037,99,3,4,6037),(6037,99,4,4,6037),(6037,99,5,4,6037),(6038,99,1,4,6038),(6038,99,2,4,6038),(6038,99,3,4,6038),(6038,99,4,4,6038),(6038,99,5,4,6038),(6039,99,1,4,6039),(6039,99,2,4,6039),(6039,99,3,4,6039),(6039,99,4,4,6039),(6039,99,5,4,6039),(6040,99,1,4,6040),(6040,99,2,4,6040),(6040,99,3,4,6040),(6040,99,4,4,6040),(6040,99,5,4,6040),(6041,99,1,4,6041),(6041,99,2,4,6041),(6041,99,3,4,6041),(6041,99,4,4,6041),(6041,99,5,4,6041),(6042,99,1,4,6042),(6042,99,2,4,6042),(6042,99,3,4,6042),(6042,99,4,4,6042),(6042,99,5,4,6042),(6043,99,1,4,6043),(6043,99,2,4,6043),(6043,99,3,4,6043),(6043,99,4,4,6043),(6043,99,5,4,6043),(6044,99,1,4,6044),(6044,99,2,4,6044),(6044,99,3,4,6044),(6044,99,4,4,6044),(6044,99,5,4,6044),(6045,99,1,4,6045),(6045,99,2,4,6045),(6045,99,3,4,6045),(6045,99,4,4,6045),(6045,99,5,4,6045),(6046,99,1,4,6046),(6046,99,2,4,6046),(6046,99,3,4,6046),(6046,99,4,4,6046),(6046,99,5,4,6046),(6047,99,1,4,6047),(6047,99,2,4,6047),(6047,99,3,4,6047),(6047,99,4,4,6047),(6047,99,5,4,6047),(6048,99,1,4,6048),(6048,99,2,4,6048),(6048,99,3,4,6048),(6048,99,4,4,6048),(6048,99,5,4,6048),(6049,99,1,4,6049),(6049,99,2,4,6049),(6049,99,3,4,6049),(6049,99,4,4,6049),(6049,99,5,4,6049),(6050,99,1,4,6050),(6050,99,2,4,6050),(6050,99,3,4,6050),(6050,99,4,4,6050),(6050,99,5,4,6050),(6051,99,1,4,6051),(6051,99,2,4,6051),(6051,99,3,4,6051),(6051,99,4,4,6051),(6051,99,5,4,6051),(6052,99,1,4,6052),(6052,99,2,4,6052),(6052,99,3,4,6052),(6052,99,4,4,6052),(6052,99,5,4,6052),(6053,99,1,4,6053),(6053,99,2,4,6053),(6053,99,3,4,6053),(6053,99,4,4,6053),(6053,99,5,4,6053),(6054,99,1,4,6054),(6054,99,2,4,6054),(6054,99,3,4,6054),(6054,99,4,4,6054),(6054,99,5,4,6054),(6055,99,1,4,6055),(6055,99,2,4,6055),(6055,99,3,4,6055),(6055,99,4,4,6055),(6055,99,5,4,6055),(6056,99,1,4,6056),(6056,99,2,4,6056),(6056,99,3,4,6056),(6056,99,4,4,6056),(6056,99,5,4,6056),(6057,99,1,4,6057),(6057,99,2,4,6057),(6057,99,3,4,6057),(6057,99,4,4,6057),(6057,99,5,4,6057),(6058,99,1,4,6058),(6058,99,2,4,6058),(6058,99,3,4,6058),(6058,99,4,4,6058),(6058,99,5,4,6058),(6059,99,1,4,6059),(6059,99,2,4,6059),(6059,99,3,4,6059),(6059,99,4,4,6059),(6059,99,5,4,6059),(6060,99,1,4,6060),(6060,99,2,4,6060),(6060,99,3,4,6060),(6060,99,4,4,6060),(6060,99,5,4,6060),(6061,99,1,4,6061),(6061,99,2,4,6061),(6061,99,3,4,6061),(6061,99,4,4,6061),(6061,99,5,4,6061),(6062,99,1,4,6062),(6062,99,2,4,6062),(6062,99,3,4,6062),(6062,99,4,4,6062),(6062,99,5,4,6062),(6063,99,1,4,6063),(6063,99,2,4,6063),(6063,99,3,4,6063),(6063,99,4,4,6063),(6063,99,5,4,6063),(6064,99,1,4,6064),(6064,99,2,4,6064),(6064,99,3,4,6064),(6064,99,4,4,6064),(6064,99,5,4,6064),(6065,99,1,4,6065),(6065,99,2,4,6065),(6065,99,3,4,6065),(6065,99,4,4,6065),(6065,99,5,4,6065),(6066,99,1,4,6066),(6066,99,2,4,6066),(6066,99,3,4,6066),(6066,99,4,4,6066),(6066,99,5,4,6066),(6067,99,1,4,6067),(6067,99,2,4,6067),(6067,99,3,4,6067),(6067,99,4,4,6067),(6067,99,5,4,6067),(6068,99,1,4,6068),(6068,99,2,4,6068),(6068,99,3,4,6068),(6068,99,4,4,6068),(6068,99,5,4,6068),(6069,99,1,4,6069),(6069,99,2,4,6069),(6069,99,3,4,6069),(6069,99,4,4,6069),(6069,99,5,4,6069),(6070,99,1,4,6070),(6070,99,2,4,6070),(6070,99,3,4,6070),(6070,99,4,4,6070),(6070,99,5,4,6070),(6071,99,1,4,6071),(6071,99,2,4,6071),(6071,99,3,4,6071),(6071,99,4,4,6071),(6071,99,5,4,6071),(6072,99,1,4,6072),(6072,99,2,4,6072),(6072,99,3,4,6072),(6072,99,4,4,6072),(6072,99,5,4,6072),(6073,99,1,4,6073),(6073,99,2,4,6073),(6073,99,3,4,6073),(6073,99,4,4,6073),(6073,99,5,4,6073),(6074,99,1,4,6074),(6074,99,2,4,6074),(6074,99,3,4,6074),(6074,99,4,4,6074),(6074,99,5,4,6074),(6075,99,1,4,6075),(6075,99,2,4,6075),(6075,99,3,4,6075),(6075,99,4,4,6075),(6075,99,5,4,6075),(6076,99,1,4,6076),(6076,99,2,4,6076),(6076,99,3,4,6076),(6076,99,4,4,6076),(6076,99,5,4,6076),(6077,99,1,4,6077),(6077,99,2,4,6077),(6077,99,3,4,6077),(6077,99,4,4,6077),(6077,99,5,4,6077),(6078,99,1,4,6078),(6078,99,2,4,6078),(6078,99,3,4,6078),(6078,99,4,4,6078),(6078,99,5,4,6078),(6079,99,1,4,6079),(6079,99,2,4,6079),(6079,99,3,4,6079),(6079,99,4,4,6079),(6079,99,5,4,6079),(6080,99,1,4,6080),(6080,99,2,4,6080),(6080,99,3,4,6080),(6080,99,4,4,6080),(6080,99,5,4,6080),(6081,99,1,4,6081),(6081,99,2,4,6081),(6081,99,3,4,6081),(6081,99,4,4,6081),(6081,99,5,4,6081),(6082,99,1,4,6082),(6082,99,2,4,6082),(6082,99,3,4,6082),(6082,99,4,4,6082),(6082,99,5,4,6082),(6083,99,1,4,6083),(6083,99,2,4,6083),(6083,99,3,4,6083),(6083,99,4,4,6083),(6083,99,5,4,6083),(6084,99,1,4,6084),(6084,99,2,4,6084),(6084,99,3,4,6084),(6084,99,4,4,6084),(6084,99,5,4,6084),(6085,99,1,4,6085),(6085,99,2,4,6085),(6085,99,3,4,6085),(6085,99,4,4,6085),(6085,99,5,4,6085),(6086,99,1,4,6086),(6086,99,2,4,6086),(6086,99,3,4,6086),(6086,99,4,4,6086),(6086,99,5,4,6086),(6087,99,1,4,6087),(6087,99,2,4,6087),(6087,99,3,4,6087),(6087,99,4,4,6087),(6087,99,5,4,6087),(6088,99,1,4,6088),(6088,99,2,4,6088),(6088,99,3,4,6088),(6088,99,4,4,6088),(6088,99,5,4,6088),(6089,99,1,4,6089),(6089,99,2,4,6089),(6089,99,3,4,6089),(6089,99,4,4,6089),(6089,99,5,4,6089),(6090,99,1,4,6090),(6090,99,2,4,6090),(6090,99,3,4,6090),(6090,99,4,4,6090),(6090,99,5,4,6090),(6091,99,1,4,6091),(6091,99,2,4,6091),(6091,99,3,4,6091),(6091,99,4,4,6091),(6091,99,5,4,6091),(6092,99,1,4,6092),(6092,99,2,4,6092),(6092,99,3,4,6092),(6092,99,4,4,6092),(6092,99,5,4,6092),(6093,99,1,4,6093),(6093,99,2,4,6093),(6093,99,3,4,6093),(6093,99,4,4,6093),(6093,99,5,4,6093),(6094,99,1,4,6094),(6094,99,2,4,6094),(6094,99,3,4,6094),(6094,99,4,4,6094),(6094,99,5,4,6094),(6095,99,1,4,6095),(6095,99,2,4,6095),(6095,99,3,4,6095),(6095,99,4,4,6095),(6095,99,5,4,6095),(6096,99,1,4,6096),(6096,99,2,4,6096),(6096,99,3,4,6096),(6096,99,4,4,6096),(6096,99,5,4,6096),(6097,99,1,4,6097),(6097,99,2,4,6097),(6097,99,3,4,6097),(6097,99,4,4,6097),(6097,99,5,4,6097),(6098,99,1,4,6098),(6098,99,2,4,6098),(6098,99,3,4,6098),(6098,99,4,4,6098),(6098,99,5,4,6098),(6099,99,1,4,6099),(6099,99,2,4,6099),(6099,99,3,4,6099),(6099,99,4,4,6099),(6099,99,5,4,6099),(6100,99,1,4,6100),(6100,99,2,4,6100),(6100,99,3,4,6100),(6100,99,4,4,6100),(6100,99,5,4,6100),(6101,99,1,4,6101),(6101,99,2,4,6101),(6101,99,3,4,6101),(6101,99,4,4,6101),(6101,99,5,4,6101),(6102,99,1,4,6102),(6102,99,2,4,6102),(6102,99,3,4,6102),(6102,99,4,4,6102),(6102,99,5,4,6102),(6103,99,1,4,6103),(6103,99,2,4,6103),(6103,99,3,4,6103),(6103,99,4,4,6103),(6103,99,5,4,6103),(6104,99,1,4,6104),(6104,99,2,4,6104),(6104,99,3,4,6104),(6104,99,4,4,6104),(6104,99,5,4,6104),(6105,99,1,4,6105),(6105,99,2,4,6105),(6105,99,3,4,6105),(6105,99,4,4,6105),(6105,99,5,4,6105),(6106,99,1,4,6106),(6106,99,2,4,6106),(6106,99,3,4,6106),(6106,99,4,4,6106),(6106,99,5,4,6106),(6107,99,1,4,6107),(6107,99,2,4,6107),(6107,99,3,4,6107),(6107,99,4,4,6107),(6107,99,5,4,6107),(6108,99,1,4,6108),(6108,99,2,4,6108),(6108,99,3,4,6108),(6108,99,4,4,6108),(6108,99,5,4,6108),(6109,99,1,4,6109),(6109,99,2,4,6109),(6109,99,3,4,6109),(6109,99,4,4,6109),(6109,99,5,4,6109),(6110,99,1,4,6110),(6110,99,2,4,6110),(6110,99,3,4,6110),(6110,99,4,4,6110),(6110,99,5,4,6110),(6111,99,1,4,6111),(6111,99,2,4,6111),(6111,99,3,4,6111),(6111,99,4,4,6111),(6111,99,5,4,6111),(6112,99,1,4,6112),(6112,99,2,4,6112),(6112,99,3,4,6112),(6112,99,4,4,6112),(6112,99,5,4,6112),(6113,99,1,4,6113),(6113,99,2,4,6113),(6113,99,3,4,6113),(6113,99,4,4,6113),(6113,99,5,4,6113),(6114,99,1,4,6114),(6114,99,2,4,6114),(6114,99,3,4,6114),(6114,99,4,4,6114),(6114,99,5,4,6114),(6115,99,1,4,6115),(6115,99,2,4,6115),(6115,99,3,4,6115),(6115,99,4,4,6115),(6115,99,5,4,6115),(6116,99,1,4,6116),(6116,99,2,4,6116),(6116,99,3,4,6116),(6116,99,4,4,6116),(6116,99,5,4,6116),(6117,99,1,4,6117),(6117,99,2,4,6117),(6117,99,3,4,6117),(6117,99,4,4,6117),(6117,99,5,4,6117),(6118,99,1,4,6118),(6118,99,2,4,6118),(6118,99,3,4,6118),(6118,99,4,4,6118),(6118,99,5,4,6118),(6119,99,1,4,6119),(6119,99,2,4,6119),(6119,99,3,4,6119),(6119,99,4,4,6119),(6119,99,5,4,6119),(6120,99,1,4,6120),(6120,99,2,4,6120),(6120,99,3,4,6120),(6120,99,4,4,6120),(6120,99,5,4,6120),(6121,99,1,4,6121),(6121,99,2,4,6121),(6121,99,3,4,6121),(6121,99,4,4,6121),(6121,99,5,4,6121),(6122,99,1,4,6122),(6122,99,2,4,6122),(6122,99,3,4,6122),(6122,99,4,4,6122),(6122,99,5,4,6122),(6123,99,1,4,6123),(6123,99,2,4,6123),(6123,99,3,4,6123),(6123,99,4,4,6123),(6123,99,5,4,6123),(6124,99,1,4,6124),(6124,99,2,4,6124),(6124,99,3,4,6124),(6124,99,4,4,6124),(6124,99,5,4,6124),(6125,99,1,4,6125),(6125,99,2,4,6125),(6125,99,3,4,6125),(6125,99,4,4,6125),(6125,99,5,4,6125),(6126,99,1,4,6126),(6126,99,2,4,6126),(6126,99,3,4,6126),(6126,99,4,4,6126),(6126,99,5,4,6126),(6127,99,1,4,6127),(6127,99,2,4,6127),(6127,99,3,4,6127),(6127,99,4,4,6127),(6127,99,5,4,6127),(6128,99,1,4,6128),(6128,99,2,4,6128),(6128,99,3,4,6128),(6128,99,4,4,6128),(6128,99,5,4,6128),(6129,99,1,4,6129),(6129,99,2,4,6129),(6129,99,3,4,6129),(6129,99,4,4,6129),(6129,99,5,4,6129),(6130,99,1,4,6130),(6130,99,2,4,6130),(6130,99,3,4,6130),(6130,99,4,4,6130),(6130,99,5,4,6130),(6131,99,1,4,6131),(6131,99,2,4,6131),(6131,99,3,4,6131),(6131,99,4,4,6131),(6131,99,5,4,6131),(6132,99,1,4,6132),(6132,99,2,4,6132),(6132,99,3,4,6132),(6132,99,4,4,6132),(6132,99,5,4,6132),(6133,99,1,4,6133),(6133,99,2,4,6133),(6133,99,3,4,6133),(6133,99,4,4,6133),(6133,99,5,4,6133),(6134,99,1,4,6134),(6134,99,2,4,6134),(6134,99,3,4,6134),(6134,99,4,4,6134),(6134,99,5,4,6134),(6135,99,1,4,6135),(6135,99,2,4,6135),(6135,99,3,4,6135),(6135,99,4,4,6135),(6135,99,5,4,6135),(6136,99,1,4,6136),(6136,99,2,4,6136),(6136,99,3,4,6136),(6136,99,4,4,6136),(6136,99,5,4,6136),(6137,99,1,4,6137),(6137,99,2,4,6137),(6137,99,3,4,6137),(6137,99,4,4,6137),(6137,99,5,4,6137),(6138,99,1,4,6138),(6138,99,2,4,6138),(6138,99,3,4,6138),(6138,99,4,4,6138),(6138,99,5,4,6138),(6139,99,1,4,6139),(6139,99,2,4,6139),(6139,99,3,4,6139),(6139,99,4,4,6139),(6139,99,5,4,6139),(6140,99,1,4,6140),(6140,99,2,4,6140),(6140,99,3,4,6140),(6140,99,4,4,6140),(6140,99,5,4,6140),(6141,99,1,4,6141),(6141,99,2,4,6141),(6141,99,3,4,6141),(6141,99,4,4,6141),(6141,99,5,4,6141),(6142,99,1,4,6142),(6142,99,2,4,6142),(6142,99,3,4,6142),(6142,99,4,4,6142),(6142,99,5,4,6142),(6143,99,1,4,6143),(6143,99,2,4,6143),(6143,99,3,4,6143),(6143,99,4,4,6143),(6143,99,5,4,6143),(6144,99,1,4,6144),(6144,99,2,4,6144),(6144,99,3,4,6144),(6144,99,4,4,6144),(6144,99,5,4,6144),(6145,99,1,4,6145),(6145,99,2,4,6145),(6145,99,3,4,6145),(6145,99,4,4,6145),(6145,99,5,4,6145),(6146,99,1,4,6146),(6146,99,2,4,6146),(6146,99,3,4,6146),(6146,99,4,4,6146),(6146,99,5,4,6146),(6147,99,1,4,6147),(6147,99,2,4,6147),(6147,99,3,4,6147),(6147,99,4,4,6147),(6147,99,5,4,6147),(6148,99,1,4,6148),(6148,99,2,4,6148),(6148,99,3,4,6148),(6148,99,4,4,6148),(6148,99,5,4,6148),(6149,99,1,4,6149),(6149,99,2,4,6149),(6149,99,3,4,6149),(6149,99,4,4,6149),(6149,99,5,4,6149),(6150,99,1,4,6150),(6150,99,2,4,6150),(6150,99,3,4,6150),(6150,99,4,4,6150),(6150,99,5,4,6150),(6151,99,1,4,6151),(6151,99,2,4,6151),(6151,99,3,4,6151),(6151,99,4,4,6151),(6151,99,5,4,6151),(6152,99,1,4,6152),(6152,99,2,4,6152),(6152,99,3,4,6152),(6152,99,4,4,6152),(6152,99,5,4,6152),(6153,99,1,4,6153),(6153,99,2,4,6153),(6153,99,3,4,6153),(6153,99,4,4,6153),(6153,99,5,4,6153),(6154,99,1,4,6154),(6154,99,2,4,6154),(6154,99,3,4,6154),(6154,99,4,4,6154),(6154,99,5,4,6154),(6155,99,1,4,6155),(6155,99,2,4,6155),(6155,99,3,4,6155),(6155,99,4,4,6155),(6155,99,5,4,6155),(6156,99,1,4,6156),(6156,99,2,4,6156),(6156,99,3,4,6156),(6156,99,4,4,6156),(6156,99,5,4,6156),(6157,99,1,4,6157),(6157,99,2,4,6157),(6157,99,3,4,6157),(6157,99,4,4,6157),(6157,99,5,4,6157),(6158,99,1,4,6158),(6158,99,2,4,6158),(6158,99,3,4,6158),(6158,99,4,4,6158),(6158,99,5,4,6158),(6159,99,1,4,6159),(6159,99,2,4,6159),(6159,99,3,4,6159),(6159,99,4,4,6159),(6159,99,5,4,6159),(6160,99,1,4,6160),(6160,99,2,4,6160),(6160,99,3,4,6160),(6160,99,4,4,6160),(6160,99,5,4,6160),(6161,99,1,4,6161),(6161,99,2,4,6161),(6161,99,3,4,6161),(6161,99,4,4,6161),(6161,99,5,4,6161),(6162,99,1,4,6162),(6162,99,2,4,6162),(6162,99,3,4,6162),(6162,99,4,4,6162),(6162,99,5,4,6162),(6163,99,1,4,6163),(6163,99,2,4,6163),(6163,99,3,4,6163),(6163,99,4,4,6163),(6163,99,5,4,6163),(6164,99,1,4,6164),(6164,99,2,4,6164),(6164,99,3,4,6164),(6164,99,4,4,6164),(6164,99,5,4,6164),(6165,99,1,4,6165),(6165,99,2,4,6165),(6165,99,3,4,6165),(6165,99,4,4,6165),(6165,99,5,4,6165),(6166,99,1,4,6166),(6166,99,2,4,6166),(6166,99,3,4,6166),(6166,99,4,4,6166),(6166,99,5,4,6166),(6167,99,1,4,6167),(6167,99,2,4,6167),(6167,99,3,4,6167),(6167,99,4,4,6167),(6167,99,5,4,6167),(6168,99,1,4,6168),(6168,99,2,4,6168),(6168,99,3,4,6168),(6168,99,4,4,6168),(6168,99,5,4,6168),(6169,99,1,4,6169),(6169,99,2,4,6169),(6169,99,3,4,6169),(6169,99,4,4,6169),(6169,99,5,4,6169),(6170,99,1,4,6170),(6170,99,2,4,6170),(6170,99,3,4,6170),(6170,99,4,4,6170),(6170,99,5,4,6170),(6171,99,1,4,6171),(6171,99,2,4,6171),(6171,99,3,4,6171),(6171,99,4,4,6171),(6171,99,5,4,6171),(6172,99,1,4,6172),(6172,99,2,4,6172),(6172,99,3,4,6172),(6172,99,4,4,6172),(6172,99,5,4,6172),(6173,99,1,4,6173),(6173,99,2,4,6173),(6173,99,3,4,6173),(6173,99,4,4,6173),(6173,99,5,4,6173),(6174,99,1,4,6174),(6174,99,2,4,6174),(6174,99,3,4,6174),(6174,99,4,4,6174),(6174,99,5,4,6174),(6175,99,1,4,6175),(6175,99,2,4,6175),(6175,99,3,4,6175),(6175,99,4,4,6175),(6175,99,5,4,6175),(6176,99,1,4,6176),(6176,99,2,4,6176),(6176,99,3,4,6176),(6176,99,4,4,6176),(6176,99,5,4,6176),(6177,99,1,4,6177),(6177,99,2,4,6177),(6177,99,3,4,6177),(6177,99,4,4,6177),(6177,99,5,4,6177),(6178,99,1,4,6178),(6178,99,2,4,6178),(6178,99,3,4,6178),(6178,99,4,4,6178),(6178,99,5,4,6178),(6179,99,1,4,6179),(6179,99,2,4,6179),(6179,99,3,4,6179),(6179,99,4,4,6179),(6179,99,5,4,6179),(6180,99,1,4,6180),(6180,99,2,4,6180),(6180,99,3,4,6180),(6180,99,4,4,6180),(6180,99,5,4,6180),(6181,99,1,4,6181),(6181,99,2,4,6181),(6181,99,3,4,6181),(6181,99,4,4,6181),(6181,99,5,4,6181),(6182,99,1,4,6182),(6182,99,2,4,6182),(6182,99,3,4,6182),(6182,99,4,4,6182),(6182,99,5,4,6182),(6183,99,1,4,6183),(6183,99,2,4,6183),(6183,99,3,4,6183),(6183,99,4,4,6183),(6183,99,5,4,6183),(6184,99,1,4,6184),(6184,99,2,4,6184),(6184,99,3,4,6184),(6184,99,4,4,6184),(6184,99,5,4,6184),(6185,99,1,4,6185),(6185,99,2,4,6185),(6185,99,3,4,6185),(6185,99,4,4,6185),(6185,99,5,4,6185),(6186,99,1,4,6186),(6186,99,2,4,6186),(6186,99,3,4,6186),(6186,99,4,4,6186),(6186,99,5,4,6186),(6187,99,1,4,6187),(6187,99,2,4,6187),(6187,99,3,4,6187),(6187,99,4,4,6187),(6187,99,5,4,6187),(6188,99,1,4,6188),(6188,99,2,4,6188),(6188,99,3,4,6188),(6188,99,4,4,6188),(6188,99,5,4,6188),(6189,99,1,4,6189),(6189,99,2,4,6189),(6189,99,3,4,6189),(6189,99,4,4,6189),(6189,99,5,4,6189),(6190,99,1,4,6190),(6190,99,2,4,6190),(6190,99,3,4,6190),(6190,99,4,4,6190),(6190,99,5,4,6190),(6191,99,1,4,6191),(6191,99,2,4,6191),(6191,99,3,4,6191),(6191,99,4,4,6191),(6191,99,5,4,6191),(6192,99,1,4,6192),(6192,99,2,4,6192),(6192,99,3,4,6192),(6192,99,4,4,6192),(6192,99,5,4,6192),(6193,99,1,4,6193),(6193,99,2,4,6193),(6193,99,3,4,6193),(6193,99,4,4,6193),(6193,99,5,4,6193),(6194,99,1,4,6194),(6194,99,2,4,6194),(6194,99,3,4,6194),(6194,99,4,4,6194),(6194,99,5,4,6194),(6195,99,1,4,6195),(6195,99,2,4,6195),(6195,99,3,4,6195),(6195,99,4,4,6195),(6195,99,5,4,6195),(6196,99,1,4,6196),(6196,99,2,4,6196),(6196,99,3,4,6196),(6196,99,4,4,6196),(6196,99,5,4,6196),(6197,99,1,4,6197),(6197,99,2,4,6197),(6197,99,3,4,6197),(6197,99,4,4,6197),(6197,99,5,4,6197),(6198,99,1,4,6198),(6198,99,2,4,6198),(6198,99,3,4,6198),(6198,99,4,4,6198),(6198,99,5,4,6198),(6199,99,1,4,6199),(6199,99,2,4,6199),(6199,99,3,4,6199),(6199,99,4,4,6199),(6199,99,5,4,6199),(6200,99,1,4,6200),(6200,99,2,4,6200),(6200,99,3,4,6200),(6200,99,4,4,6200),(6200,99,5,4,6200),(6201,99,1,4,6201),(6201,99,2,4,6201),(6201,99,3,4,6201),(6201,99,4,4,6201),(6201,99,5,4,6201),(6202,99,1,4,6202),(6202,99,2,4,6202),(6202,99,3,4,6202),(6202,99,4,4,6202),(6202,99,5,4,6202),(6203,99,1,4,6203),(6203,99,2,4,6203),(6203,99,3,4,6203),(6203,99,4,4,6203),(6203,99,5,4,6203),(6204,99,1,4,6204),(6204,99,2,4,6204),(6204,99,3,4,6204),(6204,99,4,4,6204),(6204,99,5,4,6204),(6205,99,1,4,6205),(6205,99,2,4,6205),(6205,99,3,4,6205),(6205,99,4,4,6205),(6205,99,5,4,6205),(6206,99,1,4,6206),(6206,99,2,4,6206),(6206,99,3,4,6206),(6206,99,4,4,6206),(6206,99,5,4,6206),(6207,99,1,4,6207),(6207,99,2,4,6207),(6207,99,3,4,6207),(6207,99,4,4,6207),(6207,99,5,4,6207),(6208,99,1,4,6208),(6208,99,2,4,6208),(6208,99,3,4,6208),(6208,99,4,4,6208),(6208,99,5,4,6208),(6209,99,1,4,6209),(6209,99,2,4,6209),(6209,99,3,4,6209),(6209,99,4,4,6209),(6209,99,5,4,6209),(6210,99,1,4,6210),(6210,99,2,4,6210),(6210,99,3,4,6210),(6210,99,4,4,6210),(6210,99,5,4,6210),(6211,99,1,4,6211),(6211,99,2,4,6211),(6211,99,3,4,6211),(6211,99,4,4,6211),(6211,99,5,4,6211),(6212,99,1,4,6212),(6212,99,2,4,6212),(6212,99,3,4,6212),(6212,99,4,4,6212),(6212,99,5,4,6212),(6213,99,1,4,6213),(6213,99,2,4,6213),(6213,99,3,4,6213),(6213,99,4,4,6213),(6213,99,5,4,6213),(6214,99,1,4,6214),(6214,99,2,4,6214),(6214,99,3,4,6214),(6214,99,4,4,6214),(6214,99,5,4,6214),(6215,99,1,4,6215),(6215,99,2,4,6215),(6215,99,3,4,6215),(6215,99,4,4,6215),(6215,99,5,4,6215),(6216,99,1,4,6216),(6216,99,2,4,6216),(6216,99,3,4,6216),(6216,99,4,4,6216),(6216,99,5,4,6216),(6217,99,1,4,6217),(6217,99,2,4,6217),(6217,99,3,4,6217),(6217,99,4,4,6217),(6217,99,5,4,6217),(6218,99,1,4,6218),(6218,99,2,4,6218),(6218,99,3,4,6218),(6218,99,4,4,6218),(6218,99,5,4,6218),(6219,99,1,2,6219),(6219,99,2,2,6219),(6219,99,3,2,6219),(6219,99,4,2,6219),(6219,99,5,2,6219),(6220,99,1,4,6220),(6220,99,2,4,6220),(6220,99,3,4,6220),(6220,99,4,4,6220),(6220,99,5,4,6220),(6221,99,1,4,6221),(6221,99,2,4,6221),(6221,99,3,4,6221),(6221,99,4,4,6221),(6221,99,5,4,6221),(6222,99,1,4,6222),(6222,99,2,4,6222),(6222,99,3,4,6222),(6222,99,4,4,6222),(6222,99,5,4,6222),(6223,99,1,4,6223),(6223,99,2,4,6223),(6223,99,3,4,6223),(6223,99,4,4,6223),(6223,99,5,4,6223),(6224,99,1,4,6224),(6224,99,2,4,6224),(6224,99,3,4,6224),(6224,99,4,4,6224),(6224,99,5,4,6224),(6225,99,1,4,6225),(6225,99,2,4,6225),(6225,99,3,4,6225),(6225,99,4,4,6225),(6225,99,5,4,6225),(6226,99,1,4,6226),(6226,99,2,4,6226),(6226,99,3,4,6226),(6226,99,4,4,6226),(6226,99,5,4,6226),(6227,99,1,4,6227),(6227,99,2,4,6227),(6227,99,3,4,6227),(6227,99,4,4,6227),(6227,99,5,4,6227),(6228,99,1,4,6228),(6228,99,2,4,6228),(6228,99,3,4,6228),(6228,99,4,4,6228),(6228,99,5,4,6228),(6229,99,1,4,6229),(6229,99,2,4,6229),(6229,99,3,4,6229),(6229,99,4,4,6229),(6229,99,5,4,6229),(6230,99,1,4,6230),(6230,99,2,4,6230),(6230,99,3,4,6230),(6230,99,4,4,6230),(6230,99,5,4,6230),(6231,99,1,4,6231),(6231,99,2,4,6231),(6231,99,3,4,6231),(6231,99,4,4,6231),(6231,99,5,4,6231),(6232,99,1,4,6232),(6232,99,2,4,6232),(6232,99,3,4,6232),(6232,99,4,4,6232),(6232,99,5,4,6232),(6233,99,1,4,6233),(6233,99,2,4,6233),(6233,99,3,4,6233),(6233,99,4,4,6233),(6233,99,5,4,6233),(6234,99,1,4,6234),(6234,99,2,4,6234),(6234,99,3,4,6234),(6234,99,4,4,6234),(6234,99,5,4,6234),(6235,99,1,4,6235),(6235,99,2,4,6235),(6235,99,3,4,6235),(6235,99,4,4,6235),(6235,99,5,4,6235),(6236,99,1,4,6236),(6236,99,2,4,6236),(6236,99,3,4,6236),(6236,99,4,4,6236),(6236,99,5,4,6236),(6237,99,1,4,6237),(6237,99,2,4,6237),(6237,99,3,4,6237),(6237,99,4,4,6237),(6237,99,5,4,6237),(6238,99,1,4,6238),(6238,99,2,4,6238),(6238,99,3,4,6238),(6238,99,4,4,6238),(6238,99,5,4,6238),(6239,99,1,4,6239),(6239,99,2,4,6239),(6239,99,3,4,6239),(6239,99,4,4,6239),(6239,99,5,4,6239),(6240,99,1,4,6240),(6240,99,2,4,6240),(6240,99,3,4,6240),(6240,99,4,4,6240),(6240,99,5,4,6240),(6241,99,1,4,6241),(6241,99,2,4,6241),(6241,99,3,4,6241),(6241,99,4,4,6241),(6241,99,5,4,6241),(6242,99,1,4,6242),(6242,99,2,4,6242),(6242,99,3,4,6242),(6242,99,4,4,6242),(6242,99,5,4,6242),(6243,99,1,4,6243),(6243,99,2,4,6243),(6243,99,3,4,6243),(6243,99,4,4,6243),(6243,99,5,4,6243),(6244,99,1,4,6244),(6244,99,2,4,6244),(6244,99,3,4,6244),(6244,99,4,4,6244),(6244,99,5,4,6244),(6245,99,1,4,6245),(6245,99,2,4,6245),(6245,99,3,4,6245),(6245,99,4,4,6245),(6245,99,5,4,6245),(6246,99,1,4,6246),(6246,99,2,4,6246),(6246,99,3,4,6246),(6246,99,4,4,6246),(6246,99,5,4,6246),(6247,99,1,4,6247),(6247,99,2,4,6247),(6247,99,3,4,6247),(6247,99,4,4,6247),(6247,99,5,4,6247),(6248,99,1,4,6248),(6248,99,2,4,6248),(6248,99,3,4,6248),(6248,99,4,4,6248),(6248,99,5,4,6248),(6249,99,1,4,6249),(6249,99,2,4,6249),(6249,99,3,4,6249),(6249,99,4,4,6249),(6249,99,5,4,6249),(6250,99,1,4,6250),(6250,99,2,4,6250),(6250,99,3,4,6250),(6250,99,4,4,6250),(6250,99,5,4,6250),(6251,99,1,4,6251),(6251,99,2,4,6251),(6251,99,3,4,6251),(6251,99,4,4,6251),(6251,99,5,4,6251),(6252,99,1,4,6252),(6252,99,2,4,6252),(6252,99,3,4,6252),(6252,99,4,4,6252),(6252,99,5,4,6252),(6253,99,1,4,6253),(6253,99,2,4,6253),(6253,99,3,4,6253),(6253,99,4,4,6253),(6253,99,5,4,6253),(6254,99,1,4,6254),(6254,99,2,4,6254),(6254,99,3,4,6254),(6254,99,4,4,6254),(6254,99,5,4,6254),(6255,99,1,4,6255),(6255,99,2,4,6255),(6255,99,3,4,6255),(6255,99,4,4,6255),(6255,99,5,4,6255),(6256,99,1,4,6256),(6256,99,2,4,6256),(6256,99,3,4,6256),(6256,99,4,4,6256),(6256,99,5,4,6256),(6257,99,1,2,6257),(6257,99,2,2,6257),(6257,99,3,2,6257),(6257,99,4,2,6257),(6257,99,5,2,6257),(6258,99,1,4,6258),(6258,99,2,4,6258),(6258,99,3,4,6258),(6258,99,4,4,6258),(6258,99,5,4,6258),(6259,99,1,4,6259),(6259,99,2,4,6259),(6259,99,3,4,6259),(6259,99,4,4,6259),(6259,99,5,4,6259),(6260,99,1,4,6260),(6260,99,2,4,6260),(6260,99,3,4,6260),(6260,99,4,4,6260),(6260,99,5,4,6260),(6261,99,1,4,6261),(6261,99,2,4,6261),(6261,99,3,4,6261),(6261,99,4,4,6261),(6261,99,5,4,6261),(6262,99,1,4,6262),(6262,99,2,4,6262),(6262,99,3,4,6262),(6262,99,4,4,6262),(6262,99,5,4,6262),(6263,99,1,4,6263),(6263,99,2,4,6263),(6263,99,3,4,6263),(6263,99,4,4,6263),(6263,99,5,4,6263),(6264,99,1,4,6264),(6264,99,2,4,6264),(6264,99,3,4,6264),(6264,99,4,4,6264),(6264,99,5,4,6264),(6265,99,1,4,6265),(6265,99,2,4,6265),(6265,99,3,4,6265),(6265,99,4,4,6265),(6265,99,5,4,6265),(6266,99,1,4,6266),(6266,99,2,4,6266),(6266,99,3,4,6266),(6266,99,4,4,6266),(6266,99,5,4,6266),(6267,99,1,4,6267),(6267,99,2,4,6267),(6267,99,3,4,6267),(6267,99,4,4,6267),(6267,99,5,4,6267),(6268,99,1,4,6268),(6268,99,2,4,6268),(6268,99,3,4,6268),(6268,99,4,4,6268),(6268,99,5,4,6268),(6269,99,1,4,6269),(6269,99,2,4,6269),(6269,99,3,4,6269),(6269,99,4,4,6269),(6269,99,5,4,6269),(6270,99,1,4,6270),(6270,99,2,4,6270),(6270,99,3,4,6270),(6270,99,4,4,6270),(6270,99,5,4,6270),(6271,99,1,4,6271),(6271,99,2,4,6271),(6271,99,3,4,6271),(6271,99,4,4,6271),(6271,99,5,4,6271),(6272,99,1,4,6272),(6272,99,2,4,6272),(6272,99,3,4,6272),(6272,99,4,4,6272),(6272,99,5,4,6272),(6273,99,1,4,6273),(6273,99,2,4,6273),(6273,99,3,4,6273),(6273,99,4,4,6273),(6273,99,5,4,6273),(6274,99,1,4,6274),(6274,99,2,4,6274),(6274,99,3,4,6274),(6274,99,4,4,6274),(6274,99,5,4,6274),(6275,99,1,4,6275),(6275,99,2,4,6275),(6275,99,3,4,6275),(6275,99,4,4,6275),(6275,99,5,4,6275),(6276,99,1,4,6276),(6276,99,2,4,6276),(6276,99,3,4,6276),(6276,99,4,4,6276),(6276,99,5,4,6276),(6277,99,1,4,6277),(6277,99,2,4,6277),(6277,99,3,4,6277),(6277,99,4,4,6277),(6277,99,5,4,6277),(6278,99,1,4,6278),(6278,99,2,4,6278),(6278,99,3,4,6278),(6278,99,4,4,6278),(6278,99,5,4,6278),(6279,99,1,4,6279),(6279,99,2,4,6279),(6279,99,3,4,6279),(6279,99,4,4,6279),(6279,99,5,4,6279),(6280,99,1,4,6280),(6280,99,2,4,6280),(6280,99,3,4,6280),(6280,99,4,4,6280),(6280,99,5,4,6280),(6281,99,1,4,6281),(6281,99,2,4,6281),(6281,99,3,4,6281),(6281,99,4,4,6281),(6281,99,5,4,6281),(6282,99,1,4,6282),(6282,99,2,4,6282),(6282,99,3,4,6282),(6282,99,4,4,6282),(6282,99,5,4,6282),(6283,99,1,4,6283),(6283,99,2,4,6283),(6283,99,3,4,6283),(6283,99,4,4,6283),(6283,99,5,4,6283),(6284,99,1,4,6284),(6284,99,2,4,6284),(6284,99,3,4,6284),(6284,99,4,4,6284),(6284,99,5,4,6284),(6285,99,1,4,6285),(6285,99,2,4,6285),(6285,99,3,4,6285),(6285,99,4,4,6285),(6285,99,5,4,6285),(6286,99,1,4,6286),(6286,99,2,4,6286),(6286,99,3,4,6286),(6286,99,4,4,6286),(6286,99,5,4,6286),(6287,99,1,4,6287),(6287,99,2,4,6287),(6287,99,3,4,6287),(6287,99,4,4,6287),(6287,99,5,4,6287),(6288,99,1,4,6288),(6288,99,2,4,6288),(6288,99,3,4,6288),(6288,99,4,4,6288),(6288,99,5,4,6288),(6289,99,1,4,6289),(6289,99,2,4,6289),(6289,99,3,4,6289),(6289,99,4,4,6289),(6289,99,5,4,6289),(6290,99,1,4,6290),(6290,99,2,4,6290),(6290,99,3,4,6290),(6290,99,4,4,6290),(6290,99,5,4,6290),(6291,99,1,4,6291),(6291,99,2,4,6291),(6291,99,3,4,6291),(6291,99,4,4,6291),(6291,99,5,4,6291),(6292,99,1,4,6292),(6292,99,2,4,6292),(6292,99,3,4,6292),(6292,99,4,4,6292),(6292,99,5,4,6292),(6293,99,1,4,6293),(6293,99,2,4,6293),(6293,99,3,4,6293),(6293,99,4,4,6293),(6293,99,5,4,6293),(6294,99,1,4,6294),(6294,99,2,4,6294),(6294,99,3,4,6294),(6294,99,4,4,6294),(6294,99,5,4,6294),(6295,99,1,4,6295),(6295,99,2,4,6295),(6295,99,3,4,6295),(6295,99,4,4,6295),(6295,99,5,4,6295),(6296,99,1,4,6296),(6296,99,2,4,6296),(6296,99,3,4,6296),(6296,99,4,4,6296),(6296,99,5,4,6296),(6297,99,1,4,6297),(6297,99,2,4,6297),(6297,99,3,4,6297),(6297,99,4,4,6297),(6297,99,5,4,6297),(6298,99,1,4,6298),(6298,99,2,4,6298),(6298,99,3,4,6298),(6298,99,4,4,6298),(6298,99,5,4,6298),(6299,99,1,4,6299),(6299,99,2,4,6299),(6299,99,3,4,6299),(6299,99,4,4,6299),(6299,99,5,4,6299),(6300,99,1,4,6300),(6300,99,2,4,6300),(6300,99,3,4,6300),(6300,99,4,4,6300),(6300,99,5,4,6300),(6301,99,1,4,6301),(6301,99,2,4,6301),(6301,99,3,4,6301),(6301,99,4,4,6301),(6301,99,5,4,6301),(6302,99,1,4,6302),(6302,99,2,4,6302),(6302,99,3,4,6302),(6302,99,4,4,6302),(6302,99,5,4,6302),(6303,99,1,4,6303),(6303,99,2,4,6303),(6303,99,3,4,6303),(6303,99,4,4,6303),(6303,99,5,4,6303),(6304,99,1,4,6304),(6304,99,2,4,6304),(6304,99,3,4,6304),(6304,99,4,4,6304),(6304,99,5,4,6304),(6305,99,1,4,6305),(6305,99,2,4,6305),(6305,99,3,4,6305),(6305,99,4,4,6305),(6305,99,5,4,6305),(6306,99,1,4,6306),(6306,99,2,4,6306),(6306,99,3,4,6306),(6306,99,4,4,6306),(6306,99,5,4,6306),(6307,99,1,4,6307),(6307,99,2,4,6307),(6307,99,3,4,6307),(6307,99,4,4,6307),(6307,99,5,4,6307),(6308,99,1,4,6308),(6308,99,2,4,6308),(6308,99,3,4,6308),(6308,99,4,4,6308),(6308,99,5,4,6308),(6309,99,1,4,6309),(6309,99,2,4,6309),(6309,99,3,4,6309),(6309,99,4,4,6309),(6309,99,5,4,6309),(6310,99,1,4,6310),(6310,99,2,4,6310),(6310,99,3,4,6310),(6310,99,4,4,6310),(6310,99,5,4,6310),(6311,99,1,4,6311),(6311,99,2,4,6311),(6311,99,3,4,6311),(6311,99,4,4,6311),(6311,99,5,4,6311),(6312,99,1,4,6312),(6312,99,2,4,6312),(6312,99,3,4,6312),(6312,99,4,4,6312),(6312,99,5,4,6312),(6313,99,1,4,6313),(6313,99,2,4,6313),(6313,99,3,4,6313),(6313,99,4,4,6313),(6313,99,5,4,6313),(6314,99,1,4,6314),(6314,99,2,4,6314),(6314,99,3,4,6314),(6314,99,4,4,6314),(6314,99,5,4,6314),(6315,99,1,4,6315),(6315,99,2,4,6315),(6315,99,3,4,6315),(6315,99,4,4,6315),(6315,99,5,4,6315),(6316,99,1,4,6316),(6316,99,2,4,6316),(6316,99,3,4,6316),(6316,99,4,4,6316),(6316,99,5,4,6316),(6317,99,1,4,6317),(6317,99,2,4,6317),(6317,99,3,4,6317),(6317,99,4,4,6317),(6317,99,5,4,6317),(6318,99,1,4,6318),(6318,99,2,4,6318),(6318,99,3,4,6318),(6318,99,4,4,6318),(6318,99,5,4,6318),(6319,99,1,4,6319),(6319,99,2,4,6319),(6319,99,3,4,6319),(6319,99,4,4,6319),(6319,99,5,4,6319),(6320,99,1,4,6320),(6320,99,2,4,6320),(6320,99,3,4,6320),(6320,99,4,4,6320),(6320,99,5,4,6320),(6321,99,1,4,6321),(6321,99,2,4,6321),(6321,99,3,4,6321),(6321,99,4,4,6321),(6321,99,5,4,6321),(6322,99,1,4,6322),(6322,99,2,4,6322),(6322,99,3,4,6322),(6322,99,4,4,6322),(6322,99,5,4,6322),(6323,99,1,4,6323),(6323,99,2,4,6323),(6323,99,3,4,6323),(6323,99,4,4,6323),(6323,99,5,4,6323),(6324,99,1,4,6324),(6324,99,2,4,6324),(6324,99,3,4,6324),(6324,99,4,4,6324),(6324,99,5,4,6324),(6325,99,1,4,6325),(6325,99,2,4,6325),(6325,99,3,4,6325),(6325,99,4,4,6325),(6325,99,5,4,6325),(6326,99,1,4,6326),(6326,99,2,4,6326),(6326,99,3,4,6326),(6326,99,4,4,6326),(6326,99,5,4,6326),(6327,99,1,4,6327),(6327,99,2,4,6327),(6327,99,3,4,6327),(6327,99,4,4,6327),(6327,99,5,4,6327),(6328,99,1,4,6328),(6328,99,2,4,6328),(6328,99,3,4,6328),(6328,99,4,4,6328),(6328,99,5,4,6328),(6329,99,1,4,6329),(6329,99,2,4,6329),(6329,99,3,4,6329),(6329,99,4,4,6329),(6329,99,5,4,6329),(6330,99,1,4,6330),(6330,99,2,4,6330),(6330,99,3,4,6330),(6330,99,4,4,6330),(6330,99,5,4,6330),(6331,99,1,4,6331),(6331,99,2,4,6331),(6331,99,3,4,6331),(6331,99,4,4,6331),(6331,99,5,4,6331),(6332,99,1,4,6332),(6332,99,2,4,6332),(6332,99,3,4,6332),(6332,99,4,4,6332),(6332,99,5,4,6332),(6333,99,1,4,6333),(6333,99,2,4,6333),(6333,99,3,4,6333),(6333,99,4,4,6333),(6333,99,5,4,6333),(6334,99,1,4,6334),(6334,99,2,4,6334),(6334,99,3,4,6334),(6334,99,4,4,6334),(6334,99,5,4,6334),(6335,99,1,4,6335),(6335,99,2,4,6335),(6335,99,3,4,6335),(6335,99,4,4,6335),(6335,99,5,4,6335),(6336,99,1,4,6336),(6336,99,2,4,6336),(6336,99,3,4,6336),(6336,99,4,4,6336),(6336,99,5,4,6336),(6337,99,1,4,6337),(6337,99,2,4,6337),(6337,99,3,4,6337),(6337,99,4,4,6337),(6337,99,5,4,6337),(6338,99,1,4,6338),(6338,99,2,4,6338),(6338,99,3,4,6338),(6338,99,4,4,6338),(6338,99,5,4,6338),(6339,99,1,4,6339),(6339,99,2,4,6339),(6339,99,3,4,6339),(6339,99,4,4,6339),(6339,99,5,4,6339),(6340,99,1,4,6340),(6340,99,2,4,6340),(6340,99,3,4,6340),(6340,99,4,4,6340),(6340,99,5,4,6340),(6341,99,1,4,6341),(6341,99,2,4,6341),(6341,99,3,4,6341),(6341,99,4,4,6341),(6341,99,5,4,6341),(6342,99,1,4,6342),(6342,99,2,4,6342),(6342,99,3,4,6342),(6342,99,4,4,6342),(6342,99,5,4,6342),(6343,99,1,4,6343),(6343,99,2,4,6343),(6343,99,3,4,6343),(6343,99,4,4,6343),(6343,99,5,4,6343),(6344,99,1,4,6344),(6344,99,2,4,6344),(6344,99,3,4,6344),(6344,99,4,4,6344),(6344,99,5,4,6344),(6345,99,1,4,6345),(6345,99,2,4,6345),(6345,99,3,4,6345),(6345,99,4,4,6345),(6345,99,5,4,6345);
/*!40000 ALTER TABLE `catalog_product_index_eav_replica` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_eav_tmp`
--

DROP TABLE IF EXISTS `catalog_product_index_eav_tmp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_eav_tmp` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `attribute_id` smallint unsigned NOT NULL COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `value` int unsigned NOT NULL COMMENT 'Value',
  `source_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Original entity ID for attribute value',
  PRIMARY KEY (`entity_id`,`attribute_id`,`store_id`,`value`,`source_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_TMP_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_TMP_STORE_ID` (`store_id`),
  KEY `CATALOG_PRODUCT_INDEX_EAV_TMP_VALUE` (`value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product EAV Indexer Temp Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_eav_tmp`
--

LOCK TABLES `catalog_product_index_eav_tmp` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_eav_tmp` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_eav_tmp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price`
--

DROP TABLE IF EXISTS `catalog_product_index_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `tax_class_id` smallint unsigned DEFAULT '0' COMMENT 'Tax Class ID',
  `price` decimal(20,6) DEFAULT NULL COMMENT 'Price',
  `final_price` decimal(20,6) DEFAULT NULL COMMENT 'Final Price',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(20,6) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`),
  KEY `CATALOG_PRODUCT_INDEX_PRICE_CUSTOMER_GROUP_ID` (`customer_group_id`),
  KEY `CATALOG_PRODUCT_INDEX_PRICE_MIN_PRICE` (`min_price`),
  KEY `CAT_PRD_IDX_PRICE_WS_ID_CSTR_GROUP_ID_MIN_PRICE` (`website_id`,`customer_group_id`,`min_price`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Price Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price`
--

LOCK TABLES `catalog_product_index_price` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price` DISABLE KEYS */;
INSERT INTO `catalog_product_index_price` VALUES (5760,0,1,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,0,2,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,0,3,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,0,4,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,1,1,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,1,2,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,1,3,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,1,4,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,2,1,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,2,2,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,2,3,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,2,4,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,3,1,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,3,2,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,3,3,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,3,4,0,0.010000,0.010000,0.010000,0.010000,NULL),(6035,0,1,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,0,2,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,0,3,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,0,4,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,1,1,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,1,2,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,1,3,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,1,4,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,2,1,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,2,2,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,2,3,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,2,4,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,3,1,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,3,2,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,3,3,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,3,4,0,348.000000,278.400000,278.400000,278.400000,NULL),(6036,0,1,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,0,2,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,0,3,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,0,4,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,1,1,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,1,2,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,1,3,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,1,4,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,2,1,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,2,2,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,2,3,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,2,4,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,3,1,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,3,2,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,3,3,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,3,4,0,408.000000,326.400000,326.400000,326.400000,NULL),(6037,0,1,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,0,2,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,0,3,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,0,4,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,1,1,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,1,2,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,1,3,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,1,4,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,2,1,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,2,2,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,2,3,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,2,4,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,3,1,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,3,2,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,3,3,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,3,4,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6038,0,1,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,0,2,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,0,3,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,0,4,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,1,1,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,1,2,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,1,3,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,1,4,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,2,1,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,2,2,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,2,3,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,2,4,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,3,1,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,3,2,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,3,3,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,3,4,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6039,0,1,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,0,2,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,0,3,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,0,4,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,1,1,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,1,2,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,1,3,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,1,4,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,2,1,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,2,2,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,2,3,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,2,4,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,3,1,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,3,2,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,3,3,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,3,4,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6040,0,1,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,0,2,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,0,3,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,0,4,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,1,1,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,1,2,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,1,3,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,1,4,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,2,1,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,2,2,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,2,3,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,2,4,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,3,1,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,3,2,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,3,3,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,3,4,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6041,0,1,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,0,2,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,0,3,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,0,4,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,1,1,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,1,2,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,1,3,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,1,4,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,2,1,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,2,2,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,2,3,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,2,4,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,3,1,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,3,2,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,3,3,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,3,4,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6042,0,1,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,0,2,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,0,3,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,0,4,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,1,1,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,1,2,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,1,3,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,1,4,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,2,1,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,2,2,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,2,3,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,2,4,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,3,1,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,3,2,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,3,3,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,3,4,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6043,0,1,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,0,2,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,0,3,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,0,4,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,1,1,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,1,2,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,1,3,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,1,4,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,2,1,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,2,2,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,2,3,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,2,4,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,3,1,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,3,2,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,3,3,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,3,4,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6044,0,1,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,0,2,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,0,3,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,0,4,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,1,1,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,1,2,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,1,3,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,1,4,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,2,1,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,2,2,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,2,3,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,2,4,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,3,1,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,3,2,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,3,3,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,3,4,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6045,0,1,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,0,2,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,0,3,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,0,4,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,1,1,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,1,2,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,1,3,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,1,4,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,2,1,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,2,2,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,2,3,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,2,4,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,3,1,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,3,2,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,3,3,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,3,4,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6046,0,1,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,0,2,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,0,3,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,0,4,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,1,1,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,1,2,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,1,3,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,1,4,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,2,1,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,2,2,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,2,3,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,2,4,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,3,1,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,3,2,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,3,3,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,3,4,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6047,0,1,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,0,2,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,0,3,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,0,4,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,1,1,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,1,2,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,1,3,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,1,4,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,2,1,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,2,2,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,2,3,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,2,4,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,3,1,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,3,2,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,3,3,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,3,4,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6048,0,1,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,0,2,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,0,3,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,0,4,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,1,1,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,1,2,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,1,3,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,1,4,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,2,1,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,2,2,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,2,3,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,2,4,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,3,1,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,3,2,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,3,3,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,3,4,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6049,0,1,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,0,2,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,0,3,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,0,4,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,1,1,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,1,2,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,1,3,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,1,4,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,2,1,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,2,2,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,2,3,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,2,4,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,3,1,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,3,2,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,3,3,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,3,4,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6050,0,1,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,0,2,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,0,3,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,0,4,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,1,1,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,1,2,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,1,3,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,1,4,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,2,1,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,2,2,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,2,3,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,2,4,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,3,1,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,3,2,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,3,3,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,3,4,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6051,0,1,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,0,2,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,0,3,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,0,4,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,1,1,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,1,2,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,1,3,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,1,4,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,2,1,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,2,2,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,2,3,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,2,4,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,3,1,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,3,2,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,3,3,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,3,4,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6052,0,1,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,0,2,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,0,3,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,0,4,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,1,1,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,1,2,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,1,3,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,1,4,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,2,1,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,2,2,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,2,3,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,2,4,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,3,1,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,3,2,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,3,3,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,3,4,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6053,0,1,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,0,2,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,0,3,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,0,4,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,1,1,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,1,2,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,1,3,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,1,4,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,2,1,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,2,2,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,2,3,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,2,4,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,3,1,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,3,2,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,3,3,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,3,4,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6054,0,1,NULL,198.000000,152.540000,152.540000,152.540000,NULL),(6054,1,1,NULL,198.000000,152.540000,152.540000,152.540000,NULL),(6054,2,1,NULL,198.000000,152.540000,152.540000,152.540000,NULL),(6054,3,1,NULL,198.000000,152.540000,152.540000,152.540000,NULL),(6055,0,1,NULL,448.000000,309.291667,309.291667,309.291667,NULL),(6055,1,1,NULL,448.000000,309.291667,309.291667,309.291667,NULL),(6055,2,1,NULL,448.000000,309.291667,309.291667,309.291667,NULL),(6055,3,1,NULL,448.000000,309.291667,309.291667,309.291667,NULL),(6056,0,1,NULL,198.000000,138.600000,138.600000,138.600000,NULL),(6056,1,1,NULL,198.000000,138.600000,138.600000,138.600000,NULL),(6056,2,1,NULL,198.000000,138.600000,138.600000,138.600000,NULL),(6056,3,1,NULL,198.000000,138.600000,138.600000,138.600000,NULL),(6057,0,1,NULL,308.000000,215.833333,215.833333,215.833333,NULL),(6057,1,1,NULL,308.000000,215.833333,215.833333,215.833333,NULL),(6057,2,1,NULL,308.000000,215.833333,215.833333,215.833333,NULL),(6057,3,1,NULL,308.000000,215.833333,215.833333,215.833333,NULL),(6058,0,1,NULL,698.000000,443.000000,443.000000,443.000000,NULL),(6058,1,1,NULL,698.000000,443.000000,443.000000,443.000000,NULL),(6058,2,1,NULL,698.000000,443.000000,443.000000,443.000000,NULL),(6058,3,1,NULL,698.000000,443.000000,443.000000,443.000000,NULL),(6059,0,1,NULL,848.000000,530.825000,530.825000,530.825000,NULL),(6059,1,1,NULL,848.000000,530.825000,530.825000,530.825000,NULL),(6059,2,1,NULL,848.000000,530.825000,530.825000,530.825000,NULL),(6059,3,1,NULL,848.000000,530.825000,530.825000,530.825000,NULL),(6060,0,1,NULL,538.000000,352.500000,352.500000,352.500000,NULL),(6060,1,1,NULL,538.000000,352.500000,352.500000,352.500000,NULL),(6060,2,1,NULL,538.000000,352.500000,352.500000,352.500000,NULL),(6060,3,1,NULL,538.000000,352.500000,352.500000,352.500000,NULL),(6061,0,1,NULL,598.000000,385.000000,385.000000,385.000000,NULL),(6061,1,1,NULL,598.000000,385.000000,385.000000,385.000000,NULL),(6061,2,1,NULL,598.000000,385.000000,385.000000,385.000000,NULL),(6061,3,1,NULL,598.000000,385.000000,385.000000,385.000000,NULL),(6062,0,1,NULL,628.000000,398.491667,398.491667,398.491667,NULL),(6062,1,1,NULL,628.000000,398.491667,398.491667,398.491667,NULL),(6062,2,1,NULL,628.000000,398.491667,398.491667,398.491667,NULL),(6062,3,1,NULL,628.000000,398.491667,398.491667,398.491667,NULL),(6063,0,1,NULL,638.000000,413.333333,413.333333,413.333333,NULL),(6063,1,1,NULL,638.000000,413.333333,413.333333,413.333333,NULL),(6063,2,1,NULL,638.000000,413.333333,413.333333,413.333333,NULL),(6063,3,1,NULL,638.000000,413.333333,413.333333,413.333333,NULL),(6064,0,1,NULL,738.000000,516.600000,516.600000,516.600000,NULL),(6064,1,1,NULL,738.000000,516.600000,516.600000,516.600000,NULL),(6064,2,1,NULL,738.000000,516.600000,516.600000,516.600000,NULL),(6064,3,1,NULL,738.000000,516.600000,516.600000,516.600000,NULL),(6065,0,1,NULL,648.000000,417.741667,417.741667,417.741667,NULL),(6065,1,1,NULL,648.000000,417.741667,417.741667,417.741667,NULL),(6065,2,1,NULL,648.000000,417.741667,417.741667,417.741667,NULL),(6065,3,1,NULL,648.000000,417.741667,417.741667,417.741667,NULL),(6066,0,1,NULL,798.000000,518.333333,518.333333,518.333333,NULL),(6066,1,1,NULL,798.000000,518.333333,518.333333,518.333333,NULL),(6066,2,1,NULL,798.000000,518.333333,518.333333,518.333333,NULL),(6066,3,1,NULL,798.000000,518.333333,518.333333,518.333333,NULL),(6067,0,1,NULL,738.000000,476.666667,476.666667,476.666667,NULL),(6067,1,1,NULL,738.000000,476.666667,476.666667,476.666667,NULL),(6067,2,1,NULL,738.000000,476.666667,476.666667,476.666667,NULL),(6067,3,1,NULL,738.000000,476.666667,476.666667,476.666667,NULL),(6068,0,1,NULL,568.000000,397.600000,397.600000,397.600000,NULL),(6068,1,1,NULL,568.000000,397.600000,397.600000,397.600000,NULL),(6068,2,1,NULL,568.000000,397.600000,397.600000,397.600000,NULL),(6068,3,1,NULL,568.000000,397.600000,397.600000,397.600000,NULL),(6069,0,1,NULL,598.000000,389.241667,389.241667,389.241667,NULL),(6069,1,1,NULL,598.000000,389.241667,389.241667,389.241667,NULL),(6069,2,1,NULL,598.000000,389.241667,389.241667,389.241667,NULL),(6069,3,1,NULL,598.000000,389.241667,389.241667,389.241667,NULL),(6070,0,1,NULL,678.000000,451.666667,451.666667,451.666667,NULL),(6070,1,1,NULL,678.000000,451.666667,451.666667,451.666667,NULL),(6070,2,1,NULL,678.000000,451.666667,451.666667,451.666667,NULL),(6070,3,1,NULL,678.000000,451.666667,451.666667,451.666667,NULL),(6071,0,1,NULL,1198.000000,802.630000,802.630000,802.630000,NULL),(6071,1,1,NULL,1198.000000,802.630000,802.630000,802.630000,NULL),(6071,2,1,NULL,1198.000000,802.630000,802.630000,802.630000,NULL),(6071,3,1,NULL,1198.000000,802.630000,802.630000,802.630000,NULL),(6072,0,1,NULL,698.000000,461.800000,461.800000,461.800000,NULL),(6072,1,1,NULL,698.000000,461.800000,461.800000,461.800000,NULL),(6072,2,1,NULL,698.000000,461.800000,461.800000,461.800000,NULL),(6072,3,1,NULL,698.000000,461.800000,461.800000,461.800000,NULL),(6073,0,1,NULL,598.000000,405.833333,405.833333,405.833333,NULL),(6073,1,1,NULL,598.000000,405.833333,405.833333,405.833333,NULL),(6073,2,1,NULL,598.000000,405.833333,405.833333,405.833333,NULL),(6073,3,1,NULL,598.000000,405.833333,405.833333,405.833333,NULL),(6074,0,1,NULL,598.000000,404.166667,404.166667,404.166667,NULL),(6074,1,1,NULL,598.000000,404.166667,404.166667,404.166667,NULL),(6074,2,1,NULL,598.000000,404.166667,404.166667,404.166667,NULL),(6074,3,1,NULL,598.000000,404.166667,404.166667,404.166667,NULL),(6075,0,1,NULL,578.000000,412.325000,412.325000,412.325000,NULL),(6075,1,1,NULL,578.000000,412.325000,412.325000,412.325000,NULL),(6075,2,1,NULL,578.000000,412.325000,412.325000,412.325000,NULL),(6075,3,1,NULL,578.000000,412.325000,412.325000,412.325000,NULL),(6076,0,1,NULL,368.000000,251.666667,251.666667,251.666667,NULL),(6076,1,1,NULL,368.000000,251.666667,251.666667,251.666667,NULL),(6076,2,1,NULL,368.000000,251.666667,251.666667,251.666667,NULL),(6076,3,1,NULL,368.000000,251.666667,251.666667,251.666667,NULL),(6077,0,1,NULL,328.000000,226.666667,226.666667,226.666667,NULL),(6077,1,1,NULL,328.000000,226.666667,226.666667,226.666667,NULL),(6077,2,1,NULL,328.000000,226.666667,226.666667,226.666667,NULL),(6077,3,1,NULL,328.000000,226.666667,226.666667,226.666667,NULL),(6078,0,1,NULL,458.000000,296.666667,296.666667,296.666667,NULL),(6078,1,1,NULL,458.000000,296.666667,296.666667,296.666667,NULL),(6078,2,1,NULL,458.000000,296.666667,296.666667,296.666667,NULL),(6078,3,1,NULL,458.000000,296.666667,296.666667,296.666667,NULL),(6079,0,1,NULL,408.000000,276.666667,276.666667,276.666667,NULL),(6079,1,1,NULL,408.000000,276.666667,276.666667,276.666667,NULL),(6079,2,1,NULL,408.000000,276.666667,276.666667,276.666667,NULL),(6079,3,1,NULL,408.000000,276.666667,276.666667,276.666667,NULL),(6080,0,1,NULL,478.000000,318.333333,318.333333,318.333333,NULL),(6080,1,1,NULL,478.000000,318.333333,318.333333,318.333333,NULL),(6080,2,1,NULL,478.000000,318.333333,318.333333,318.333333,NULL),(6080,3,1,NULL,478.000000,318.333333,318.333333,318.333333,NULL),(6081,0,1,NULL,428.000000,288.333333,288.333333,288.333333,NULL),(6081,1,1,NULL,428.000000,288.333333,288.333333,288.333333,NULL),(6081,2,1,NULL,428.000000,288.333333,288.333333,288.333333,NULL),(6081,3,1,NULL,428.000000,288.333333,288.333333,288.333333,NULL),(6082,0,1,NULL,488.000000,312.908333,312.908333,312.908333,NULL),(6082,1,1,NULL,488.000000,312.908333,312.908333,312.908333,NULL),(6082,2,1,NULL,488.000000,312.908333,312.908333,312.908333,NULL),(6082,3,1,NULL,488.000000,312.908333,312.908333,312.908333,NULL),(6083,0,1,NULL,448.000000,301.666667,301.666667,301.666667,NULL),(6083,1,1,NULL,448.000000,301.666667,301.666667,301.666667,NULL),(6083,2,1,NULL,448.000000,301.666667,301.666667,301.666667,NULL),(6083,3,1,NULL,448.000000,301.666667,301.666667,301.666667,NULL),(6084,0,1,NULL,498.000000,321.666667,321.666667,321.666667,NULL),(6084,1,1,NULL,498.000000,321.666667,321.666667,321.666667,NULL),(6084,2,1,NULL,498.000000,321.666667,321.666667,321.666667,NULL),(6084,3,1,NULL,498.000000,321.666667,321.666667,321.666667,NULL),(6085,0,1,NULL,458.000000,320.600000,320.600000,320.600000,NULL),(6085,1,1,NULL,458.000000,320.600000,320.600000,320.600000,NULL),(6085,2,1,NULL,458.000000,320.600000,320.600000,320.600000,NULL),(6085,3,1,NULL,458.000000,320.600000,320.600000,320.600000,NULL),(6086,0,1,NULL,598.000000,388.333333,388.333333,388.333333,NULL),(6086,1,1,NULL,598.000000,388.333333,388.333333,388.333333,NULL),(6086,2,1,NULL,598.000000,388.333333,388.333333,388.333333,NULL),(6086,3,1,NULL,598.000000,388.333333,388.333333,388.333333,NULL),(6087,0,1,NULL,548.000000,374.991667,374.991667,374.991667,NULL),(6087,1,1,NULL,548.000000,374.991667,374.991667,374.991667,NULL),(6087,2,1,NULL,548.000000,374.991667,374.991667,374.991667,NULL),(6087,3,1,NULL,548.000000,374.991667,374.991667,374.991667,NULL),(6088,0,1,NULL,688.000000,460.960000,460.960000,460.960000,NULL),(6088,1,1,NULL,688.000000,460.960000,460.960000,460.960000,NULL),(6088,2,1,NULL,688.000000,460.960000,460.960000,460.960000,NULL),(6088,3,1,NULL,688.000000,460.960000,460.960000,460.960000,NULL),(6089,0,1,NULL,958.000000,605.000000,605.000000,605.000000,NULL),(6089,1,1,NULL,958.000000,605.000000,605.000000,605.000000,NULL),(6089,2,1,NULL,958.000000,605.000000,605.000000,605.000000,NULL),(6089,3,1,NULL,958.000000,605.000000,605.000000,605.000000,NULL),(6090,0,1,NULL,848.000000,568.160000,568.160000,568.160000,NULL),(6090,1,1,NULL,848.000000,568.160000,568.160000,568.160000,NULL),(6090,2,1,NULL,848.000000,568.160000,568.160000,568.160000,NULL),(6090,3,1,NULL,848.000000,568.160000,568.160000,568.160000,NULL),(6091,0,1,NULL,798.000000,558.600000,558.600000,558.600000,NULL),(6091,1,1,NULL,798.000000,558.600000,558.600000,558.600000,NULL),(6091,2,1,NULL,798.000000,558.600000,558.600000,558.600000,NULL),(6091,3,1,NULL,798.000000,558.600000,558.600000,558.600000,NULL),(6092,0,1,NULL,898.000000,619.960000,619.960000,619.960000,NULL),(6092,1,1,NULL,898.000000,619.960000,619.960000,619.960000,NULL),(6092,2,1,NULL,898.000000,619.960000,619.960000,619.960000,NULL),(6092,3,1,NULL,898.000000,619.960000,619.960000,619.960000,NULL),(6093,0,1,NULL,828.000000,555.000000,555.000000,555.000000,NULL),(6093,1,1,NULL,828.000000,555.000000,555.000000,555.000000,NULL),(6093,2,1,NULL,828.000000,555.000000,555.000000,555.000000,NULL),(6093,3,1,NULL,828.000000,555.000000,555.000000,555.000000,NULL),(6094,0,1,NULL,498.000000,320.158333,320.158333,320.158333,NULL),(6094,1,1,NULL,498.000000,320.158333,320.158333,320.158333,NULL),(6094,2,1,NULL,498.000000,320.158333,320.158333,320.158333,NULL),(6094,3,1,NULL,498.000000,320.158333,320.158333,320.158333,NULL),(6095,0,1,NULL,548.000000,368.333333,368.333333,368.333333,NULL),(6095,1,1,NULL,548.000000,368.333333,368.333333,368.333333,NULL),(6095,2,1,NULL,548.000000,368.333333,368.333333,368.333333,NULL),(6095,3,1,NULL,548.000000,368.333333,368.333333,368.333333,NULL),(6096,0,1,NULL,598.000000,403.141667,403.141667,403.141667,NULL),(6096,1,1,NULL,598.000000,403.141667,403.141667,403.141667,NULL),(6096,2,1,NULL,598.000000,403.141667,403.141667,403.141667,NULL),(6096,3,1,NULL,598.000000,403.141667,403.141667,403.141667,NULL),(6097,0,1,NULL,688.000000,473.541667,473.541667,473.541667,NULL),(6097,1,1,NULL,688.000000,473.541667,473.541667,473.541667,NULL),(6097,2,1,NULL,688.000000,473.541667,473.541667,473.541667,NULL),(6097,3,1,NULL,688.000000,473.541667,473.541667,473.541667,NULL),(6098,0,1,NULL,678.000000,435.833333,435.833333,435.833333,NULL),(6098,1,1,NULL,678.000000,435.833333,435.833333,435.833333,NULL),(6098,2,1,NULL,678.000000,435.833333,435.833333,435.833333,NULL),(6098,3,1,NULL,678.000000,435.833333,435.833333,435.833333,NULL),(6099,0,1,NULL,768.000000,509.275000,509.275000,509.275000,NULL),(6099,1,1,NULL,768.000000,509.275000,509.275000,509.275000,NULL),(6099,2,1,NULL,768.000000,509.275000,509.275000,509.275000,NULL),(6099,3,1,NULL,768.000000,509.275000,509.275000,509.275000,NULL),(6100,0,1,NULL,598.000000,409.990000,409.990000,409.990000,NULL),(6100,1,1,NULL,598.000000,409.990000,409.990000,409.990000,NULL),(6100,2,1,NULL,598.000000,409.990000,409.990000,409.990000,NULL),(6100,3,1,NULL,598.000000,409.990000,409.990000,409.990000,NULL),(6101,0,1,NULL,648.000000,423.333333,423.333333,423.333333,NULL),(6101,1,1,NULL,648.000000,423.333333,423.333333,423.333333,NULL),(6101,2,1,NULL,648.000000,423.333333,423.333333,423.333333,NULL),(6101,3,1,NULL,648.000000,423.333333,423.333333,423.333333,NULL),(6102,0,1,NULL,558.000000,380.833333,380.833333,380.833333,NULL),(6102,1,1,NULL,558.000000,380.833333,380.833333,380.833333,NULL),(6102,2,1,NULL,558.000000,380.833333,380.833333,380.833333,NULL),(6102,3,1,NULL,558.000000,380.833333,380.833333,380.833333,NULL),(6103,0,1,NULL,558.000000,368.333333,368.333333,368.333333,NULL),(6103,1,1,NULL,558.000000,368.333333,368.333333,368.333333,NULL),(6103,2,1,NULL,558.000000,368.333333,368.333333,368.333333,NULL),(6103,3,1,NULL,558.000000,368.333333,368.333333,368.333333,NULL),(6104,0,1,NULL,478.000000,318.333333,318.333333,318.333333,NULL),(6104,1,1,NULL,478.000000,318.333333,318.333333,318.333333,NULL),(6104,2,1,NULL,478.000000,318.333333,318.333333,318.333333,NULL),(6104,3,1,NULL,478.000000,318.333333,318.333333,318.333333,NULL),(6105,0,1,NULL,598.000000,396.666667,396.666667,396.666667,NULL),(6105,1,1,NULL,598.000000,396.666667,396.666667,396.666667,NULL),(6105,2,1,NULL,598.000000,396.666667,396.666667,396.666667,NULL),(6105,3,1,NULL,598.000000,396.666667,396.666667,396.666667,NULL),(6106,0,1,NULL,638.000000,413.333333,413.333333,413.333333,NULL),(6106,1,1,NULL,638.000000,413.333333,413.333333,413.333333,NULL),(6106,2,1,NULL,638.000000,413.333333,413.333333,413.333333,NULL),(6106,3,1,NULL,638.000000,413.333333,413.333333,413.333333,NULL),(6107,0,1,NULL,688.000000,443.333333,443.333333,443.333333,NULL),(6107,1,1,NULL,688.000000,443.333333,443.333333,443.333333,NULL),(6107,2,1,NULL,688.000000,443.333333,443.333333,443.333333,NULL),(6107,3,1,NULL,688.000000,443.333333,443.333333,443.333333,NULL),(6108,0,1,NULL,978.000000,635.000000,635.000000,635.000000,NULL),(6108,1,1,NULL,978.000000,635.000000,635.000000,635.000000,NULL),(6108,2,1,NULL,978.000000,635.000000,635.000000,635.000000,NULL),(6108,3,1,NULL,978.000000,635.000000,635.000000,635.000000,NULL),(6109,0,1,NULL,998.000000,647.420000,647.420000,647.420000,NULL),(6109,1,1,NULL,998.000000,647.420000,647.420000,647.420000,NULL),(6109,2,1,NULL,998.000000,647.420000,647.420000,647.420000,NULL),(6109,3,1,NULL,998.000000,647.420000,647.420000,647.420000,NULL),(6110,0,1,NULL,398.000000,271.666667,271.666667,271.666667,NULL),(6110,1,1,NULL,398.000000,271.666667,271.666667,271.666667,NULL),(6110,2,1,NULL,398.000000,271.666667,271.666667,271.666667,NULL),(6110,3,1,NULL,398.000000,271.666667,271.666667,271.666667,NULL),(6111,0,1,NULL,418.000000,292.600000,292.600000,292.600000,NULL),(6111,1,1,NULL,418.000000,292.600000,292.600000,292.600000,NULL),(6111,2,1,NULL,418.000000,292.600000,292.600000,292.600000,NULL),(6111,3,1,NULL,418.000000,292.600000,292.600000,292.600000,NULL),(6112,0,1,NULL,348.000000,249.166667,249.166667,249.166667,NULL),(6112,1,1,NULL,348.000000,249.166667,249.166667,249.166667,NULL),(6112,2,1,NULL,348.000000,249.166667,249.166667,249.166667,NULL),(6112,3,1,NULL,348.000000,249.166667,249.166667,249.166667,NULL),(6113,0,1,NULL,228.000000,153.910000,153.910000,153.910000,NULL),(6113,1,1,NULL,228.000000,153.910000,153.910000,153.910000,NULL),(6113,2,1,NULL,228.000000,153.910000,153.910000,153.910000,NULL),(6113,3,1,NULL,228.000000,153.910000,153.910000,153.910000,NULL),(6114,0,1,NULL,298.000000,211.650000,211.650000,211.650000,NULL),(6114,1,1,NULL,298.000000,211.650000,211.650000,211.650000,NULL),(6114,2,1,NULL,298.000000,211.650000,211.650000,211.650000,NULL),(6114,3,1,NULL,298.000000,211.650000,211.650000,211.650000,NULL),(6115,0,1,NULL,338.000000,225.000000,225.000000,225.000000,NULL),(6115,1,1,NULL,338.000000,225.000000,225.000000,225.000000,NULL),(6115,2,1,NULL,338.000000,225.000000,225.000000,225.000000,NULL),(6115,3,1,NULL,338.000000,225.000000,225.000000,225.000000,NULL),(6116,0,1,NULL,358.000000,250.600000,250.600000,250.600000,NULL),(6116,1,1,NULL,358.000000,250.600000,250.600000,250.600000,NULL),(6116,2,1,NULL,358.000000,250.600000,250.600000,250.600000,NULL),(6116,3,1,NULL,358.000000,250.600000,250.600000,250.600000,NULL),(6117,0,1,NULL,368.000000,246.666667,246.666667,246.666667,NULL),(6117,1,1,NULL,368.000000,246.666667,246.666667,246.666667,NULL),(6117,2,1,NULL,368.000000,246.666667,246.666667,246.666667,NULL),(6117,3,1,NULL,368.000000,246.666667,246.666667,246.666667,NULL),(6118,0,1,NULL,478.000000,321.666667,321.666667,321.666667,NULL),(6118,1,1,NULL,478.000000,321.666667,321.666667,321.666667,NULL),(6118,2,1,NULL,478.000000,321.666667,321.666667,321.666667,NULL),(6118,3,1,NULL,478.000000,321.666667,321.666667,321.666667,NULL),(6119,0,1,NULL,828.000000,561.666667,561.666667,561.666667,NULL),(6119,1,1,NULL,828.000000,561.666667,561.666667,561.666667,NULL),(6119,2,1,NULL,828.000000,561.666667,561.666667,561.666667,NULL),(6119,3,1,NULL,828.000000,561.666667,561.666667,561.666667,NULL),(6120,0,1,NULL,978.000000,659.166667,659.166667,659.166667,NULL),(6120,1,1,NULL,978.000000,659.166667,659.166667,659.166667,NULL),(6120,2,1,NULL,978.000000,659.166667,659.166667,659.166667,NULL),(6120,3,1,NULL,978.000000,659.166667,659.166667,659.166667,NULL),(6121,0,1,NULL,278.000000,185.970000,185.970000,185.970000,NULL),(6121,1,1,NULL,278.000000,185.970000,185.970000,185.970000,NULL),(6121,2,1,NULL,278.000000,185.970000,185.970000,185.970000,NULL),(6121,3,1,NULL,278.000000,185.970000,185.970000,185.970000,NULL),(6122,0,1,NULL,328.000000,233.875000,233.875000,233.875000,NULL),(6122,1,1,NULL,328.000000,233.875000,233.875000,233.875000,NULL),(6122,2,1,NULL,328.000000,233.875000,233.875000,233.875000,NULL),(6122,3,1,NULL,328.000000,233.875000,233.875000,233.875000,NULL),(6123,0,1,NULL,348.000000,243.600000,243.600000,243.600000,NULL),(6123,1,1,NULL,348.000000,243.600000,243.600000,243.600000,NULL),(6123,2,1,NULL,348.000000,243.600000,243.600000,243.600000,NULL),(6123,3,1,NULL,348.000000,243.600000,243.600000,243.600000,NULL),(6124,0,1,NULL,398.000000,277.316667,277.316667,277.316667,NULL),(6124,1,1,NULL,398.000000,277.316667,277.316667,277.316667,NULL),(6124,2,1,NULL,398.000000,277.316667,277.316667,277.316667,NULL),(6124,3,1,NULL,398.000000,277.316667,277.316667,277.316667,NULL),(6125,0,1,NULL,998.000000,673.330000,673.330000,673.330000,NULL),(6125,1,1,NULL,998.000000,673.330000,673.330000,673.330000,NULL),(6125,2,1,NULL,998.000000,673.330000,673.330000,673.330000,NULL),(6125,3,1,NULL,998.000000,673.330000,673.330000,673.330000,NULL),(6126,0,1,NULL,1298.000000,869.340000,869.340000,869.340000,NULL),(6126,1,1,NULL,1298.000000,869.340000,869.340000,869.340000,NULL),(6126,2,1,NULL,1298.000000,869.340000,869.340000,869.340000,NULL),(6126,3,1,NULL,1298.000000,869.340000,869.340000,869.340000,NULL),(6127,0,1,NULL,478.000000,315.633333,315.633333,315.633333,NULL),(6127,1,1,NULL,478.000000,315.633333,315.633333,315.633333,NULL),(6127,2,1,NULL,478.000000,315.633333,315.633333,315.633333,NULL),(6127,3,1,NULL,478.000000,315.633333,315.633333,315.633333,NULL),(6128,0,1,NULL,548.000000,383.466667,383.466667,383.466667,NULL),(6128,1,1,NULL,548.000000,383.466667,383.466667,383.466667,NULL),(6128,2,1,NULL,548.000000,383.466667,383.466667,383.466667,NULL),(6128,3,1,NULL,548.000000,383.466667,383.466667,383.466667,NULL),(6129,0,1,NULL,518.000000,365.830000,365.830000,365.830000,NULL),(6129,1,1,NULL,518.000000,365.830000,365.830000,365.830000,NULL),(6129,2,1,NULL,518.000000,365.830000,365.830000,365.830000,NULL),(6129,3,1,NULL,518.000000,365.830000,365.830000,365.830000,NULL),(6130,0,1,NULL,270.000000,216.000000,216.000000,216.000000,NULL),(6130,1,1,NULL,270.000000,216.000000,216.000000,216.000000,NULL),(6130,2,1,NULL,270.000000,216.000000,216.000000,216.000000,NULL),(6130,3,1,NULL,270.000000,216.000000,216.000000,216.000000,NULL),(6131,0,1,NULL,183.000000,146.400000,146.400000,146.400000,NULL),(6131,1,1,NULL,183.000000,146.400000,146.400000,146.400000,NULL),(6131,2,1,NULL,183.000000,146.400000,146.400000,146.400000,NULL),(6131,3,1,NULL,183.000000,146.400000,146.400000,146.400000,NULL),(6132,0,1,NULL,198.000000,158.400000,158.400000,158.400000,NULL),(6132,1,1,NULL,198.000000,158.400000,158.400000,158.400000,NULL),(6132,2,1,NULL,198.000000,158.400000,158.400000,158.400000,NULL),(6132,3,1,NULL,198.000000,158.400000,158.400000,158.400000,NULL),(6133,0,1,NULL,296.000000,236.800000,236.800000,236.800000,NULL),(6133,1,1,NULL,296.000000,236.800000,236.800000,236.800000,NULL),(6133,2,1,NULL,296.000000,236.800000,236.800000,236.800000,NULL),(6133,3,1,NULL,296.000000,236.800000,236.800000,236.800000,NULL),(6134,0,1,NULL,421.683333,337.346667,337.346667,337.346667,NULL),(6134,1,1,NULL,421.683333,337.346667,337.346667,337.346667,NULL),(6134,2,1,NULL,421.683333,337.346667,337.346667,337.346667,NULL),(6134,3,1,NULL,421.683333,337.346667,337.346667,337.346667,NULL),(6135,0,1,NULL,220.916667,200.833334,200.833334,200.833334,NULL),(6135,1,1,NULL,220.916667,200.833334,200.833334,200.833334,NULL),(6135,2,1,NULL,220.916667,200.833334,200.833334,200.833334,NULL),(6135,3,1,NULL,220.916667,200.833334,200.833334,200.833334,NULL),(6136,0,1,NULL,95.333333,86.666667,86.666667,86.666667,NULL),(6136,1,1,NULL,95.333333,86.666667,86.666667,86.666667,NULL),(6136,2,1,NULL,95.333333,86.666667,86.666667,86.666667,NULL),(6136,3,1,NULL,95.333333,86.666667,86.666667,86.666667,NULL),(6137,0,1,NULL,778.000000,501.666667,501.666667,501.666667,NULL),(6137,1,1,NULL,778.000000,501.666667,501.666667,501.666667,NULL),(6137,2,1,NULL,778.000000,501.666667,501.666667,501.666667,NULL),(6137,3,1,NULL,778.000000,501.666667,501.666667,501.666667,NULL),(6138,0,1,NULL,598.000000,405.000000,405.000000,405.000000,NULL),(6138,1,1,NULL,598.000000,405.000000,405.000000,405.000000,NULL),(6138,2,1,NULL,598.000000,405.000000,405.000000,405.000000,NULL),(6138,3,1,NULL,598.000000,405.000000,405.000000,405.000000,NULL),(6139,0,1,NULL,718.000000,496.758333,496.758333,496.758333,NULL),(6139,1,1,NULL,718.000000,496.758333,496.758333,496.758333,NULL),(6139,2,1,NULL,718.000000,496.758333,496.758333,496.758333,NULL),(6139,3,1,NULL,718.000000,496.758333,496.758333,496.758333,NULL),(6140,0,1,NULL,598.000000,444.983333,444.983333,444.983333,NULL),(6140,1,1,NULL,598.000000,444.983333,444.983333,444.983333,NULL),(6140,2,1,NULL,598.000000,444.983333,444.983333,444.983333,NULL),(6140,3,1,NULL,598.000000,444.983333,444.983333,444.983333,NULL),(6141,0,1,NULL,568.000000,363.333333,363.333333,363.333333,NULL),(6141,1,1,NULL,568.000000,363.333333,363.333333,363.333333,NULL),(6141,2,1,NULL,568.000000,363.333333,363.333333,363.333333,NULL),(6141,3,1,NULL,568.000000,363.333333,363.333333,363.333333,NULL),(6142,0,1,NULL,192.058333,153.646667,153.646667,153.646667,NULL),(6142,1,1,NULL,192.058333,153.646667,153.646667,153.646667,NULL),(6142,2,1,NULL,192.058333,153.646667,153.646667,153.646667,NULL),(6142,3,1,NULL,192.058333,153.646667,153.646667,153.646667,NULL),(6143,0,1,NULL,256.658333,205.326667,205.326667,205.326667,NULL),(6143,1,1,NULL,256.658333,205.326667,205.326667,205.326667,NULL),(6143,2,1,NULL,256.658333,205.326667,205.326667,205.326667,NULL),(6143,3,1,NULL,256.658333,205.326667,205.326667,205.326667,NULL),(6144,0,1,NULL,205.000000,164.000000,164.000000,164.000000,NULL),(6144,1,1,NULL,205.000000,164.000000,164.000000,164.000000,NULL),(6144,2,1,NULL,205.000000,164.000000,164.000000,164.000000,NULL),(6144,3,1,NULL,205.000000,164.000000,164.000000,164.000000,NULL),(6145,0,1,NULL,257.000000,205.600000,205.600000,205.600000,NULL),(6145,1,1,NULL,257.000000,205.600000,205.600000,205.600000,NULL),(6145,2,1,NULL,257.000000,205.600000,205.600000,205.600000,NULL),(6145,3,1,NULL,257.000000,205.600000,205.600000,205.600000,NULL),(6146,0,1,NULL,385.641667,308.513333,308.513333,308.513333,NULL),(6146,1,1,NULL,385.641667,308.513333,308.513333,308.513333,NULL),(6146,2,1,NULL,385.641667,308.513333,308.513333,308.513333,NULL),(6146,3,1,NULL,385.641667,308.513333,308.513333,308.513333,NULL),(6147,0,1,NULL,450.083333,360.066667,360.066667,360.066667,NULL),(6147,1,1,NULL,450.083333,360.066667,360.066667,360.066667,NULL),(6147,2,1,NULL,450.083333,360.066667,360.066667,360.066667,NULL),(6147,3,1,NULL,450.083333,360.066667,360.066667,360.066667,NULL),(6148,0,1,NULL,144.833333,131.666667,131.666667,131.666667,NULL),(6148,1,1,NULL,144.833333,131.666667,131.666667,131.666667,NULL),(6148,2,1,NULL,144.833333,131.666667,131.666667,131.666667,NULL),(6148,3,1,NULL,144.833333,131.666667,131.666667,131.666667,NULL),(6149,0,1,NULL,798.000000,578.291667,578.291667,578.291667,NULL),(6149,1,1,NULL,798.000000,578.291667,578.291667,578.291667,NULL),(6149,2,1,NULL,798.000000,578.291667,578.291667,578.291667,NULL),(6149,3,1,NULL,798.000000,578.291667,578.291667,578.291667,NULL),(6150,0,1,NULL,768.000000,508.333333,508.333333,508.333333,NULL),(6150,1,1,NULL,768.000000,508.333333,508.333333,508.333333,NULL),(6150,2,1,NULL,768.000000,508.333333,508.333333,508.333333,NULL),(6150,3,1,NULL,768.000000,508.333333,508.333333,508.333333,NULL),(6151,0,1,NULL,628.000000,450.833333,450.833333,450.833333,NULL),(6151,1,1,NULL,628.000000,450.833333,450.833333,450.833333,NULL),(6151,2,1,NULL,628.000000,450.833333,450.833333,450.833333,NULL),(6151,3,1,NULL,628.000000,450.833333,450.833333,450.833333,NULL),(6152,0,1,NULL,326.666667,261.333333,261.333333,261.333333,NULL),(6152,1,1,NULL,326.666667,261.333333,261.333333,261.333333,NULL),(6152,2,1,NULL,326.666667,261.333333,261.333333,261.333333,NULL),(6152,3,1,NULL,326.666667,261.333333,261.333333,261.333333,NULL),(6153,0,1,NULL,435.300000,348.240000,348.240000,348.240000,NULL),(6153,1,1,NULL,435.300000,348.240000,348.240000,348.240000,NULL),(6153,2,1,NULL,435.300000,348.240000,348.240000,348.240000,NULL),(6153,3,1,NULL,435.300000,348.240000,348.240000,348.240000,NULL),(6154,0,1,NULL,381.000000,304.800000,304.800000,304.800000,NULL),(6154,1,1,NULL,381.000000,304.800000,304.800000,304.800000,NULL),(6154,2,1,NULL,381.000000,304.800000,304.800000,304.800000,NULL),(6154,3,1,NULL,381.000000,304.800000,304.800000,304.800000,NULL),(6155,0,1,NULL,147.000000,117.600000,117.600000,117.600000,NULL),(6155,1,1,NULL,147.000000,117.600000,117.600000,117.600000,NULL),(6155,2,1,NULL,147.000000,117.600000,117.600000,117.600000,NULL),(6155,3,1,NULL,147.000000,117.600000,117.600000,117.600000,NULL),(6156,0,1,NULL,118.333333,94.666667,94.666667,94.666667,NULL),(6156,1,1,NULL,118.333333,94.666667,94.666667,94.666667,NULL),(6156,2,1,NULL,118.333333,94.666667,94.666667,94.666667,NULL),(6156,3,1,NULL,118.333333,94.666667,94.666667,94.666667,NULL),(6157,0,1,NULL,155.000000,124.000000,124.000000,124.000000,NULL),(6157,1,1,NULL,155.000000,124.000000,124.000000,124.000000,NULL),(6157,2,1,NULL,155.000000,124.000000,124.000000,124.000000,NULL),(6157,3,1,NULL,155.000000,124.000000,124.000000,124.000000,NULL),(6158,0,1,NULL,305.000000,244.000000,244.000000,244.000000,NULL),(6158,1,1,NULL,305.000000,244.000000,244.000000,244.000000,NULL),(6158,2,1,NULL,305.000000,244.000000,244.000000,244.000000,NULL),(6158,3,1,NULL,305.000000,244.000000,244.000000,244.000000,NULL),(6159,0,1,NULL,182.376333,165.796667,165.796667,165.796667,NULL),(6159,1,1,NULL,182.376333,165.796667,165.796667,165.796667,NULL),(6159,2,1,NULL,182.376333,165.796667,165.796667,165.796667,NULL),(6159,3,1,NULL,182.376333,165.796667,165.796667,165.796667,NULL),(6160,0,1,NULL,253.920000,230.840000,230.840000,230.840000,NULL),(6160,1,1,NULL,253.920000,230.840000,230.840000,230.840000,NULL),(6160,2,1,NULL,253.920000,230.840000,230.840000,230.840000,NULL),(6160,3,1,NULL,253.920000,230.840000,230.840000,230.840000,NULL),(6161,0,1,NULL,248.420000,225.840000,225.840000,225.840000,NULL),(6161,1,1,NULL,248.420000,225.840000,225.840000,225.840000,NULL),(6161,2,1,NULL,248.420000,225.840000,225.840000,225.840000,NULL),(6161,3,1,NULL,248.420000,225.840000,225.840000,225.840000,NULL),(6162,0,1,NULL,248.420000,225.840000,225.840000,225.840000,NULL),(6162,1,1,NULL,248.420000,225.840000,225.840000,225.840000,NULL),(6162,2,1,NULL,248.420000,225.840000,225.840000,225.840000,NULL),(6162,3,1,NULL,248.420000,225.840000,225.840000,225.840000,NULL),(6163,0,1,NULL,121.916667,110.833334,110.833334,110.833334,NULL),(6163,1,1,NULL,121.916667,110.833334,110.833334,110.833334,NULL),(6163,2,1,NULL,121.916667,110.833334,110.833334,110.833334,NULL),(6163,3,1,NULL,121.916667,110.833334,110.833334,110.833334,NULL),(6164,0,1,NULL,376.666667,301.333333,301.333333,301.333333,NULL),(6164,1,1,NULL,376.666667,301.333333,301.333333,301.333333,NULL),(6164,2,1,NULL,376.666667,301.333333,301.333333,301.333333,NULL),(6164,3,1,NULL,376.666667,301.333333,301.333333,301.333333,NULL),(6165,0,1,NULL,385.400000,308.320000,308.320000,308.320000,NULL),(6165,1,1,NULL,385.400000,308.320000,308.320000,308.320000,NULL),(6165,2,1,NULL,385.400000,308.320000,308.320000,308.320000,NULL),(6165,3,1,NULL,385.400000,308.320000,308.320000,308.320000,NULL),(6166,0,1,NULL,411.158333,328.926667,328.926667,328.926667,NULL),(6166,1,1,NULL,411.158333,328.926667,328.926667,328.926667,NULL),(6166,2,1,NULL,411.158333,328.926667,328.926667,328.926667,NULL),(6166,3,1,NULL,411.158333,328.926667,328.926667,328.926667,NULL),(6167,0,1,NULL,1373.000000,1098.400000,1098.400000,1098.400000,NULL),(6167,1,1,NULL,1373.000000,1098.400000,1098.400000,1098.400000,NULL),(6167,2,1,NULL,1373.000000,1098.400000,1098.400000,1098.400000,NULL),(6167,3,1,NULL,1373.000000,1098.400000,1098.400000,1098.400000,NULL),(6168,0,1,NULL,1581.000000,1264.800000,1264.800000,1264.800000,NULL),(6168,1,1,NULL,1581.000000,1264.800000,1264.800000,1264.800000,NULL),(6168,2,1,NULL,1581.000000,1264.800000,1264.800000,1264.800000,NULL),(6168,3,1,NULL,1581.000000,1264.800000,1264.800000,1264.800000,NULL),(6169,0,1,NULL,1498.000000,1198.400000,1198.400000,1198.400000,NULL),(6169,1,1,NULL,1498.000000,1198.400000,1198.400000,1198.400000,NULL),(6169,2,1,NULL,1498.000000,1198.400000,1198.400000,1198.400000,NULL),(6169,3,1,NULL,1498.000000,1198.400000,1198.400000,1198.400000,NULL),(6170,0,1,NULL,302.458333,241.966667,241.966667,241.966667,NULL),(6170,1,1,NULL,302.458333,241.966667,241.966667,241.966667,NULL),(6170,2,1,NULL,302.458333,241.966667,241.966667,241.966667,NULL),(6170,3,1,NULL,302.458333,241.966667,241.966667,241.966667,NULL),(6171,0,1,NULL,342.283333,273.826667,273.826667,273.826667,NULL),(6171,1,1,NULL,342.283333,273.826667,273.826667,273.826667,NULL),(6171,2,1,NULL,342.283333,273.826667,273.826667,273.826667,NULL),(6171,3,1,NULL,342.283333,273.826667,273.826667,273.826667,NULL),(6172,0,1,NULL,363.700000,290.960000,290.960000,290.960000,NULL),(6172,1,1,NULL,363.700000,290.960000,290.960000,290.960000,NULL),(6172,2,1,NULL,363.700000,290.960000,290.960000,290.960000,NULL),(6172,3,1,NULL,363.700000,290.960000,290.960000,290.960000,NULL),(6173,0,1,NULL,374.383333,299.506667,299.506667,299.506667,NULL),(6173,1,1,NULL,374.383333,299.506667,299.506667,299.506667,NULL),(6173,2,1,NULL,374.383333,299.506667,299.506667,299.506667,NULL),(6173,3,1,NULL,374.383333,299.506667,299.506667,299.506667,NULL),(6174,0,1,NULL,413.383333,330.706667,330.706667,330.706667,NULL),(6174,1,1,NULL,413.383333,330.706667,330.706667,330.706667,NULL),(6174,2,1,NULL,413.383333,330.706667,330.706667,330.706667,NULL),(6174,3,1,NULL,413.383333,330.706667,330.706667,330.706667,NULL),(6175,0,1,NULL,486.716667,389.373333,389.373333,389.373333,NULL),(6175,1,1,NULL,486.716667,389.373333,389.373333,389.373333,NULL),(6175,2,1,NULL,486.716667,389.373333,389.373333,389.373333,NULL),(6175,3,1,NULL,486.716667,389.373333,389.373333,389.373333,NULL),(6176,0,1,NULL,276.833333,251.666667,251.666667,251.666667,NULL),(6176,1,1,NULL,276.833333,251.666667,251.666667,251.666667,NULL),(6176,2,1,NULL,276.833333,251.666667,251.666667,251.666667,NULL),(6176,3,1,NULL,276.833333,251.666667,251.666667,251.666667,NULL),(6177,0,1,NULL,183.333333,166.666667,166.666667,166.666667,NULL),(6177,1,1,NULL,183.333333,166.666667,166.666667,166.666667,NULL),(6177,2,1,NULL,183.333333,166.666667,166.666667,166.666667,NULL),(6177,3,1,NULL,183.333333,166.666667,166.666667,166.666667,NULL),(6178,0,1,NULL,199.833333,181.666667,181.666667,181.666667,NULL),(6178,1,1,NULL,199.833333,181.666667,181.666667,181.666667,NULL),(6178,2,1,NULL,199.833333,181.666667,181.666667,181.666667,NULL),(6178,3,1,NULL,199.833333,181.666667,181.666667,181.666667,NULL),(6179,0,1,NULL,224.583333,204.166667,204.166667,204.166667,NULL),(6179,1,1,NULL,224.583333,204.166667,204.166667,204.166667,NULL),(6179,2,1,NULL,224.583333,204.166667,204.166667,204.166667,NULL),(6179,3,1,NULL,224.583333,204.166667,204.166667,204.166667,NULL),(6180,0,1,NULL,1098.000000,769.980000,769.980000,769.980000,NULL),(6180,1,1,NULL,1098.000000,769.980000,769.980000,769.980000,NULL),(6180,2,1,NULL,1098.000000,769.980000,769.980000,769.980000,NULL),(6180,3,1,NULL,1098.000000,769.980000,769.980000,769.980000,NULL),(6181,0,1,NULL,998.000000,638.383333,638.383333,638.383333,NULL),(6181,1,1,NULL,998.000000,638.383333,638.383333,638.383333,NULL),(6181,2,1,NULL,998.000000,638.383333,638.383333,638.383333,NULL),(6181,3,1,NULL,998.000000,638.383333,638.383333,638.383333,NULL),(6182,0,1,NULL,668.000000,450.133333,450.133333,450.133333,NULL),(6182,1,1,NULL,668.000000,450.133333,450.133333,450.133333,NULL),(6182,2,1,NULL,668.000000,450.133333,450.133333,450.133333,NULL),(6182,3,1,NULL,668.000000,450.133333,450.133333,450.133333,NULL),(6183,0,1,NULL,348.000000,254.166667,254.166667,254.166667,NULL),(6183,1,1,NULL,348.000000,254.166667,254.166667,254.166667,NULL),(6183,2,1,NULL,348.000000,254.166667,254.166667,254.166667,NULL),(6183,3,1,NULL,348.000000,254.166667,254.166667,254.166667,NULL),(6184,0,1,NULL,598.000000,444.975000,444.975000,444.975000,NULL),(6184,1,1,NULL,598.000000,444.975000,444.975000,444.975000,NULL),(6184,2,1,NULL,598.000000,444.975000,444.975000,444.975000,NULL),(6184,3,1,NULL,598.000000,444.975000,444.975000,444.975000,NULL),(6185,0,1,NULL,120.908333,109.916667,109.916667,109.916667,NULL),(6185,1,1,NULL,120.908333,109.916667,109.916667,109.916667,NULL),(6185,2,1,NULL,120.908333,109.916667,109.916667,109.916667,NULL),(6185,3,1,NULL,120.908333,109.916667,109.916667,109.916667,NULL),(6186,0,1,NULL,728.000000,503.425000,503.425000,503.425000,NULL),(6186,1,1,NULL,728.000000,503.425000,503.425000,503.425000,NULL),(6186,2,1,NULL,728.000000,503.425000,503.425000,503.425000,NULL),(6186,3,1,NULL,728.000000,503.425000,503.425000,503.425000,NULL),(6187,0,1,NULL,196.166667,178.333334,178.333334,178.333334,NULL),(6187,1,1,NULL,196.166667,178.333334,178.333334,178.333334,NULL),(6187,2,1,NULL,196.166667,178.333334,178.333334,178.333334,NULL),(6187,3,1,NULL,196.166667,178.333334,178.333334,178.333334,NULL),(6188,0,1,NULL,139.333333,126.666667,126.666667,126.666667,NULL),(6188,1,1,NULL,139.333333,126.666667,126.666667,126.666667,NULL),(6188,2,1,NULL,139.333333,126.666667,126.666667,126.666667,NULL),(6188,3,1,NULL,139.333333,126.666667,126.666667,126.666667,NULL),(6189,0,1,NULL,878.000000,614.600000,614.600000,614.600000,NULL),(6189,1,1,NULL,878.000000,614.600000,614.600000,614.600000,NULL),(6189,2,1,NULL,878.000000,614.600000,614.600000,614.600000,NULL),(6189,3,1,NULL,878.000000,614.600000,614.600000,614.600000,NULL),(6190,0,1,NULL,1098.000000,768.600000,768.600000,768.600000,NULL),(6190,1,1,NULL,1098.000000,768.600000,768.600000,768.600000,NULL),(6190,2,1,NULL,1098.000000,768.600000,768.600000,768.600000,NULL),(6190,3,1,NULL,1098.000000,768.600000,768.600000,768.600000,NULL),(6191,0,1,NULL,1198.000000,802.660000,802.660000,802.660000,NULL),(6191,1,1,NULL,1198.000000,802.660000,802.660000,802.660000,NULL),(6191,2,1,NULL,1198.000000,802.660000,802.660000,802.660000,NULL),(6191,3,1,NULL,1198.000000,802.660000,802.660000,802.660000,NULL),(6192,0,1,NULL,208.358333,189.416667,189.416667,189.416667,NULL),(6192,1,1,NULL,208.358333,189.416667,189.416667,189.416667,NULL),(6192,2,1,NULL,208.358333,189.416667,189.416667,189.416667,NULL),(6192,3,1,NULL,208.358333,189.416667,189.416667,189.416667,NULL),(6193,0,1,NULL,208.358333,189.416667,189.416667,189.416667,NULL),(6193,1,1,NULL,208.358333,189.416667,189.416667,189.416667,NULL),(6193,2,1,NULL,208.358333,189.416667,189.416667,189.416667,NULL),(6193,3,1,NULL,208.358333,189.416667,189.416667,189.416667,NULL),(6194,0,1,NULL,199.833333,181.666667,181.666667,181.666667,NULL),(6194,1,1,NULL,199.833333,181.666667,181.666667,181.666667,NULL),(6194,2,1,NULL,199.833333,181.666667,181.666667,181.666667,NULL),(6194,3,1,NULL,199.833333,181.666667,181.666667,181.666667,NULL),(6195,0,1,NULL,499.000000,399.200000,399.200000,399.200000,NULL),(6195,1,1,NULL,499.000000,399.200000,399.200000,399.200000,NULL),(6195,2,1,NULL,499.000000,399.200000,399.200000,399.200000,NULL),(6195,3,1,NULL,499.000000,399.200000,399.200000,399.200000,NULL),(6196,0,1,NULL,428.000000,299.600000,299.600000,299.600000,NULL),(6196,1,1,NULL,428.000000,299.600000,299.600000,299.600000,NULL),(6196,2,1,NULL,428.000000,299.600000,299.600000,299.600000,NULL),(6196,3,1,NULL,428.000000,299.600000,299.600000,299.600000,NULL),(6197,0,1,NULL,498.000000,367.980000,367.980000,367.980000,NULL),(6197,1,1,NULL,498.000000,367.980000,367.980000,367.980000,NULL),(6197,2,1,NULL,498.000000,367.980000,367.980000,367.980000,NULL),(6197,3,1,NULL,498.000000,367.980000,367.980000,367.980000,NULL),(6198,0,1,NULL,668.000000,421.166667,421.166667,421.166667,NULL),(6198,1,1,NULL,668.000000,421.166667,421.166667,421.166667,NULL),(6198,2,1,NULL,668.000000,421.166667,421.166667,421.166667,NULL),(6198,3,1,NULL,668.000000,421.166667,421.166667,421.166667,NULL),(6199,0,1,NULL,658.000000,423.333333,423.333333,423.333333,NULL),(6199,1,1,NULL,658.000000,423.333333,423.333333,423.333333,NULL),(6199,2,1,NULL,658.000000,423.333333,423.333333,423.333333,NULL),(6199,3,1,NULL,658.000000,423.333333,423.333333,423.333333,NULL),(6200,0,1,NULL,748.000000,470.833333,470.833333,470.833333,NULL),(6200,1,1,NULL,748.000000,470.833333,470.833333,470.833333,NULL),(6200,2,1,NULL,748.000000,470.833333,470.833333,470.833333,NULL),(6200,3,1,NULL,748.000000,470.833333,470.833333,470.833333,NULL),(6201,0,1,NULL,708.000000,482.600000,482.600000,482.600000,NULL),(6201,1,1,NULL,708.000000,482.600000,482.600000,482.600000,NULL),(6201,2,1,NULL,708.000000,482.600000,482.600000,482.600000,NULL),(6201,3,1,NULL,708.000000,482.600000,482.600000,482.600000,NULL),(6202,0,1,NULL,514.841667,411.873333,411.873333,411.873333,NULL),(6202,1,1,NULL,514.841667,411.873333,411.873333,411.873333,NULL),(6202,2,1,NULL,514.841667,411.873333,411.873333,411.873333,NULL),(6202,3,1,NULL,514.841667,411.873333,411.873333,411.873333,NULL),(6203,0,1,NULL,492.920000,443.628000,443.628000,443.628000,NULL),(6203,1,1,NULL,492.920000,443.628000,443.628000,443.628000,NULL),(6203,2,1,NULL,492.920000,443.628000,443.628000,443.628000,NULL),(6203,3,1,NULL,492.920000,443.628000,443.628000,443.628000,NULL),(6204,0,1,NULL,520.410000,468.369000,468.369000,468.369000,NULL),(6204,1,1,NULL,520.410000,468.369000,468.369000,468.369000,NULL),(6204,2,1,NULL,520.410000,468.369000,468.369000,468.369000,NULL),(6204,3,1,NULL,520.410000,468.369000,468.369000,468.369000,NULL),(6205,0,1,NULL,116.416667,105.833334,105.833334,105.833334,NULL),(6205,1,1,NULL,116.416667,105.833334,105.833334,105.833334,NULL),(6205,2,1,NULL,116.416667,105.833334,105.833334,105.833334,NULL),(6205,3,1,NULL,116.416667,105.833334,105.833334,105.833334,NULL),(6206,0,1,NULL,251.666667,201.333333,201.333333,201.333333,NULL),(6206,1,1,NULL,251.666667,201.333333,201.333333,201.333333,NULL),(6206,2,1,NULL,251.666667,201.333333,201.333333,201.333333,NULL),(6206,3,1,NULL,251.666667,201.333333,201.333333,201.333333,NULL),(6207,0,1,NULL,359.216667,287.373333,287.373333,287.373333,NULL),(6207,1,1,NULL,359.216667,287.373333,287.373333,287.373333,NULL),(6207,2,1,NULL,359.216667,287.373333,287.373333,287.373333,NULL),(6207,3,1,NULL,359.216667,287.373333,287.373333,287.373333,NULL),(6208,0,1,NULL,156.750000,142.500000,142.500000,142.500000,NULL),(6208,1,1,NULL,156.750000,142.500000,142.500000,142.500000,NULL),(6208,2,1,NULL,156.750000,142.500000,142.500000,142.500000,NULL),(6208,3,1,NULL,156.750000,142.500000,142.500000,142.500000,NULL),(6209,0,1,NULL,157.480000,143.170000,143.170000,143.170000,NULL),(6209,1,1,NULL,157.480000,143.170000,143.170000,143.170000,NULL),(6209,2,1,NULL,157.480000,143.170000,143.170000,143.170000,NULL),(6209,3,1,NULL,157.480000,143.170000,143.170000,143.170000,NULL),(6210,0,1,NULL,228.250000,207.500000,207.500000,207.500000,NULL),(6210,1,1,NULL,228.250000,207.500000,207.500000,207.500000,NULL),(6210,2,1,NULL,228.250000,207.500000,207.500000,207.500000,NULL),(6210,3,1,NULL,228.250000,207.500000,207.500000,207.500000,NULL),(6211,0,1,NULL,284.166667,258.333334,258.333334,258.333334,NULL),(6211,1,1,NULL,284.166667,258.333334,258.333334,258.333334,NULL),(6211,2,1,NULL,284.166667,258.333334,258.333334,258.333334,NULL),(6211,3,1,NULL,284.166667,258.333334,258.333334,258.333334,NULL),(6212,0,1,NULL,307.083333,279.166667,279.166667,279.166667,NULL),(6212,1,1,NULL,307.083333,279.166667,279.166667,279.166667,NULL),(6212,2,1,NULL,307.083333,279.166667,279.166667,279.166667,NULL),(6212,3,1,NULL,307.083333,279.166667,279.166667,279.166667,NULL),(6213,0,1,NULL,496.683333,397.346667,397.346667,397.346667,NULL),(6213,1,1,NULL,496.683333,397.346667,397.346667,397.346667,NULL),(6213,2,1,NULL,496.683333,397.346667,397.346667,397.346667,NULL),(6213,3,1,NULL,496.683333,397.346667,397.346667,397.346667,NULL),(6214,0,1,NULL,591.683333,473.346667,473.346667,473.346667,NULL),(6214,1,1,NULL,591.683333,473.346667,473.346667,473.346667,NULL),(6214,2,1,NULL,591.683333,473.346667,473.346667,473.346667,NULL),(6214,3,1,NULL,591.683333,473.346667,473.346667,473.346667,NULL),(6215,0,1,NULL,665.841667,532.673333,532.673333,532.673333,NULL),(6215,1,1,NULL,665.841667,532.673333,532.673333,532.673333,NULL),(6215,2,1,NULL,665.841667,532.673333,532.673333,532.673333,NULL),(6215,3,1,NULL,665.841667,532.673333,532.673333,532.673333,NULL),(6216,0,1,NULL,441.583333,353.266667,353.266667,353.266667,NULL),(6216,1,1,NULL,441.583333,353.266667,353.266667,353.266667,NULL),(6216,2,1,NULL,441.583333,353.266667,353.266667,353.266667,NULL),(6216,3,1,NULL,441.583333,353.266667,353.266667,353.266667,NULL),(6217,0,1,NULL,501.441667,401.153333,401.153333,401.153333,NULL),(6217,1,1,NULL,501.441667,401.153333,401.153333,401.153333,NULL),(6217,2,1,NULL,501.441667,401.153333,401.153333,401.153333,NULL),(6217,3,1,NULL,501.441667,401.153333,401.153333,401.153333,NULL),(6218,0,1,NULL,545.800000,436.640000,436.640000,436.640000,NULL),(6218,1,1,NULL,545.800000,436.640000,436.640000,436.640000,NULL),(6218,2,1,NULL,545.800000,436.640000,436.640000,436.640000,NULL),(6218,3,1,NULL,545.800000,436.640000,436.640000,436.640000,NULL),(6219,0,1,NULL,580.858333,464.686667,464.686667,464.686667,NULL),(6219,1,1,NULL,580.858333,464.686667,464.686667,464.686667,NULL),(6219,2,1,NULL,580.858333,464.686667,464.686667,464.686667,NULL),(6219,3,1,NULL,580.858333,464.686667,464.686667,464.686667,NULL),(6220,0,1,NULL,78.466667,71.333334,71.333334,71.333334,NULL),(6220,1,1,NULL,78.466667,71.333334,71.333334,71.333334,NULL),(6220,2,1,NULL,78.466667,71.333334,71.333334,71.333334,NULL),(6220,3,1,NULL,78.466667,71.333334,71.333334,71.333334,NULL),(6221,0,1,NULL,86.350000,78.500000,78.500000,78.500000,NULL),(6221,1,1,NULL,86.350000,78.500000,78.500000,78.500000,NULL),(6221,2,1,NULL,86.350000,78.500000,78.500000,78.500000,NULL),(6221,3,1,NULL,86.350000,78.500000,78.500000,78.500000,NULL),(6222,0,1,NULL,114.583333,104.166667,104.166667,104.166667,NULL),(6222,1,1,NULL,114.583333,104.166667,104.166667,104.166667,NULL),(6222,2,1,NULL,114.583333,104.166667,104.166667,104.166667,NULL),(6222,3,1,NULL,114.583333,104.166667,104.166667,104.166667,NULL),(6223,0,1,NULL,261.258333,209.006667,209.006667,209.006667,NULL),(6223,1,1,NULL,261.258333,209.006667,209.006667,209.006667,NULL),(6223,2,1,NULL,261.258333,209.006667,209.006667,209.006667,NULL),(6223,3,1,NULL,261.258333,209.006667,209.006667,209.006667,NULL),(6224,0,1,NULL,333.316667,266.653333,266.653333,266.653333,NULL),(6224,1,1,NULL,333.316667,266.653333,266.653333,266.653333,NULL),(6224,2,1,NULL,333.316667,266.653333,266.653333,266.653333,NULL),(6224,3,1,NULL,333.316667,266.653333,266.653333,266.653333,NULL),(6225,0,1,NULL,346.758333,277.406667,277.406667,277.406667,NULL),(6225,1,1,NULL,346.758333,277.406667,277.406667,277.406667,NULL),(6225,2,1,NULL,346.758333,277.406667,277.406667,277.406667,NULL),(6225,3,1,NULL,346.758333,277.406667,277.406667,277.406667,NULL),(6226,0,1,NULL,438.283333,350.626667,350.626667,350.626667,NULL),(6226,1,1,NULL,438.283333,350.626667,350.626667,350.626667,NULL),(6226,2,1,NULL,438.283333,350.626667,350.626667,350.626667,NULL),(6226,3,1,NULL,438.283333,350.626667,350.626667,350.626667,NULL),(6227,0,1,NULL,423.500000,338.800000,338.800000,338.800000,NULL),(6227,1,1,NULL,423.500000,338.800000,338.800000,338.800000,NULL),(6227,2,1,NULL,423.500000,338.800000,338.800000,338.800000,NULL),(6227,3,1,NULL,423.500000,338.800000,338.800000,338.800000,NULL),(6228,0,1,NULL,435.458333,348.366667,348.366667,348.366667,NULL),(6228,1,1,NULL,435.458333,348.366667,348.366667,348.366667,NULL),(6228,2,1,NULL,435.458333,348.366667,348.366667,348.366667,NULL),(6228,3,1,NULL,435.458333,348.366667,348.366667,348.366667,NULL),(6229,0,1,NULL,358.000000,259.158333,259.158333,259.158333,NULL),(6229,1,1,NULL,358.000000,259.158333,259.158333,259.158333,NULL),(6229,2,1,NULL,358.000000,259.158333,259.158333,259.158333,NULL),(6229,3,1,NULL,358.000000,259.158333,259.158333,259.158333,NULL),(6230,0,1,NULL,398.000000,306.708333,306.708333,306.708333,NULL),(6230,1,1,NULL,398.000000,306.708333,306.708333,306.708333,NULL),(6230,2,1,NULL,398.000000,306.708333,306.708333,306.708333,NULL),(6230,3,1,NULL,398.000000,306.708333,306.708333,306.708333,NULL),(6231,0,1,NULL,428.000000,291.650000,291.650000,291.650000,NULL),(6231,1,1,NULL,428.000000,291.650000,291.650000,291.650000,NULL),(6231,2,1,NULL,428.000000,291.650000,291.650000,291.650000,NULL),(6231,3,1,NULL,428.000000,291.650000,291.650000,291.650000,NULL),(6232,0,1,NULL,398.000000,282.166667,282.166667,282.166667,NULL),(6232,1,1,NULL,398.000000,282.166667,282.166667,282.166667,NULL),(6232,2,1,NULL,398.000000,282.166667,282.166667,282.166667,NULL),(6232,3,1,NULL,398.000000,282.166667,282.166667,282.166667,NULL),(6233,0,1,NULL,191.220000,173.830000,173.830000,173.830000,NULL),(6233,1,1,NULL,191.220000,173.830000,173.830000,173.830000,NULL),(6233,2,1,NULL,191.220000,173.830000,173.830000,173.830000,NULL),(6233,3,1,NULL,191.220000,173.830000,173.830000,173.830000,NULL),(6234,0,1,NULL,448.000000,313.450000,313.450000,313.450000,NULL),(6234,1,1,NULL,448.000000,313.450000,313.450000,313.450000,NULL),(6234,2,1,NULL,448.000000,313.450000,313.450000,313.450000,NULL),(6234,3,1,NULL,448.000000,313.450000,313.450000,313.450000,NULL),(6235,0,1,NULL,478.000000,332.741667,332.741667,332.741667,NULL),(6235,1,1,NULL,478.000000,332.741667,332.741667,332.741667,NULL),(6235,2,1,NULL,478.000000,332.741667,332.741667,332.741667,NULL),(6235,3,1,NULL,478.000000,332.741667,332.741667,332.741667,NULL),(6236,0,1,NULL,538.000000,348.075000,348.075000,348.075000,NULL),(6236,1,1,NULL,538.000000,348.075000,348.075000,348.075000,NULL),(6236,2,1,NULL,538.000000,348.075000,348.075000,348.075000,NULL),(6236,3,1,NULL,538.000000,348.075000,348.075000,348.075000,NULL),(6237,0,1,NULL,518.000000,348.330000,348.330000,348.330000,NULL),(6237,1,1,NULL,518.000000,348.330000,348.330000,348.330000,NULL),(6237,2,1,NULL,518.000000,348.330000,348.330000,348.330000,NULL),(6237,3,1,NULL,518.000000,348.330000,348.330000,348.330000,NULL),(6238,0,1,NULL,598.000000,385.966667,385.966667,385.966667,NULL),(6238,1,1,NULL,598.000000,385.966667,385.966667,385.966667,NULL),(6238,2,1,NULL,598.000000,385.966667,385.966667,385.966667,NULL),(6238,3,1,NULL,598.000000,385.966667,385.966667,385.966667,NULL),(6239,0,1,NULL,488.000000,367.710000,367.710000,367.710000,NULL),(6239,1,1,NULL,488.000000,367.710000,367.710000,367.710000,NULL),(6239,2,1,NULL,488.000000,367.710000,367.710000,367.710000,NULL),(6239,3,1,NULL,488.000000,367.710000,367.710000,367.710000,NULL),(6240,0,1,NULL,357.500000,325.000000,325.000000,325.000000,NULL),(6240,1,1,NULL,357.500000,325.000000,325.000000,325.000000,NULL),(6240,2,1,NULL,357.500000,325.000000,325.000000,325.000000,NULL),(6240,3,1,NULL,357.500000,325.000000,325.000000,325.000000,NULL),(6241,0,1,NULL,383.070000,348.250000,348.250000,348.250000,NULL),(6241,1,1,NULL,383.070000,348.250000,348.250000,348.250000,NULL),(6241,2,1,NULL,383.070000,348.250000,348.250000,348.250000,NULL),(6241,3,1,NULL,383.070000,348.250000,348.250000,348.250000,NULL),(6242,0,1,NULL,176.916667,160.833334,160.833334,160.833334,NULL),(6242,1,1,NULL,176.916667,160.833334,160.833334,160.833334,NULL),(6242,2,1,NULL,176.916667,160.833334,160.833334,160.833334,NULL),(6242,3,1,NULL,176.916667,160.833334,160.833334,160.833334,NULL),(6243,0,1,NULL,366.666667,293.333333,293.333333,293.333333,NULL),(6243,1,1,NULL,366.666667,293.333333,293.333333,293.333333,NULL),(6243,2,1,NULL,366.666667,293.333333,293.333333,293.333333,NULL),(6243,3,1,NULL,366.666667,293.333333,293.333333,293.333333,NULL),(6244,0,1,NULL,440.000000,352.000000,352.000000,352.000000,NULL),(6244,1,1,NULL,440.000000,352.000000,352.000000,352.000000,NULL),(6244,2,1,NULL,440.000000,352.000000,352.000000,352.000000,NULL),(6244,3,1,NULL,440.000000,352.000000,352.000000,352.000000,NULL),(6245,0,1,NULL,398.416667,318.733333,318.733333,318.733333,NULL),(6245,1,1,NULL,398.416667,318.733333,318.733333,318.733333,NULL),(6245,2,1,NULL,398.416667,318.733333,318.733333,318.733333,NULL),(6245,3,1,NULL,398.416667,318.733333,318.733333,318.733333,NULL),(6246,0,1,NULL,450.916667,360.733333,360.733333,360.733333,NULL),(6246,1,1,NULL,450.916667,360.733333,360.733333,360.733333,NULL),(6246,2,1,NULL,450.916667,360.733333,360.733333,360.733333,NULL),(6246,3,1,NULL,450.916667,360.733333,360.733333,360.733333,NULL),(6247,0,1,NULL,533.191667,426.553333,426.553333,426.553333,NULL),(6247,1,1,NULL,533.191667,426.553333,426.553333,426.553333,NULL),(6247,2,1,NULL,533.191667,426.553333,426.553333,426.553333,NULL),(6247,3,1,NULL,533.191667,426.553333,426.553333,426.553333,NULL),(6248,0,1,NULL,525.383333,420.306667,420.306667,420.306667,NULL),(6248,1,1,NULL,525.383333,420.306667,420.306667,420.306667,NULL),(6248,2,1,NULL,525.383333,420.306667,420.306667,420.306667,NULL),(6248,3,1,NULL,525.383333,420.306667,420.306667,420.306667,NULL),(6249,0,1,NULL,216.666667,174.400000,174.400000,174.400000,NULL),(6249,1,1,NULL,216.666667,174.400000,174.400000,174.400000,NULL),(6249,2,1,NULL,216.666667,174.400000,174.400000,174.400000,NULL),(6249,3,1,NULL,216.666667,174.400000,174.400000,174.400000,NULL),(6250,0,1,NULL,294.000000,235.200000,235.200000,235.200000,NULL),(6250,1,1,NULL,294.000000,235.200000,235.200000,235.200000,NULL),(6250,2,1,NULL,294.000000,235.200000,235.200000,235.200000,NULL),(6250,3,1,NULL,294.000000,235.200000,235.200000,235.200000,NULL),(6251,0,1,NULL,301.000000,240.800000,240.800000,240.800000,NULL),(6251,1,1,NULL,301.000000,240.800000,240.800000,240.800000,NULL),(6251,2,1,NULL,301.000000,240.800000,240.800000,240.800000,NULL),(6251,3,1,NULL,301.000000,240.800000,240.800000,240.800000,NULL),(6252,0,1,NULL,494.000000,395.200000,395.200000,395.200000,NULL),(6252,1,1,NULL,494.000000,395.200000,395.200000,395.200000,NULL),(6252,2,1,NULL,494.000000,395.200000,395.200000,395.200000,NULL),(6252,3,1,NULL,494.000000,395.200000,395.200000,395.200000,NULL),(6253,0,1,NULL,341.941667,273.553333,273.553333,273.553333,NULL),(6253,1,1,NULL,341.941667,273.553333,273.553333,273.553333,NULL),(6253,2,1,NULL,341.941667,273.553333,273.553333,273.553333,NULL),(6253,3,1,NULL,341.941667,273.553333,273.553333,273.553333,NULL),(6254,0,1,NULL,538.000000,430.400000,430.400000,430.400000,NULL),(6254,1,1,NULL,538.000000,430.400000,430.400000,430.400000,NULL),(6254,2,1,NULL,538.000000,430.400000,430.400000,430.400000,NULL),(6254,3,1,NULL,538.000000,430.400000,430.400000,430.400000,NULL),(6255,0,1,NULL,393.333333,314.666667,314.666667,314.666667,NULL),(6255,1,1,NULL,393.333333,314.666667,314.666667,314.666667,NULL),(6255,2,1,NULL,393.333333,314.666667,314.666667,314.666667,NULL),(6255,3,1,NULL,393.333333,314.666667,314.666667,314.666667,NULL),(6256,0,1,NULL,538.000000,430.400000,430.400000,430.400000,NULL),(6256,1,1,NULL,538.000000,430.400000,430.400000,430.400000,NULL),(6256,2,1,NULL,538.000000,430.400000,430.400000,430.400000,NULL),(6256,3,1,NULL,538.000000,430.400000,430.400000,430.400000,NULL),(6257,0,1,NULL,444.460000,311.120000,311.120000,311.120000,NULL),(6257,1,1,NULL,444.460000,311.120000,311.120000,311.120000,NULL),(6257,2,1,NULL,444.460000,311.120000,311.120000,311.120000,NULL),(6257,3,1,NULL,444.460000,311.120000,311.120000,311.120000,NULL),(6258,0,1,NULL,224.580000,204.170000,204.170000,204.170000,NULL),(6258,1,1,NULL,224.580000,204.170000,204.170000,204.170000,NULL),(6258,2,1,NULL,224.580000,204.170000,204.170000,204.170000,NULL),(6258,3,1,NULL,224.580000,204.170000,204.170000,204.170000,NULL),(6259,0,1,NULL,240.170000,218.330000,218.330000,218.330000,NULL),(6259,1,1,NULL,240.170000,218.330000,218.330000,218.330000,NULL),(6259,2,1,NULL,240.170000,218.330000,218.330000,218.330000,NULL),(6259,3,1,NULL,240.170000,218.330000,218.330000,218.330000,NULL),(6260,0,1,NULL,248.420000,225.830000,225.830000,225.830000,NULL),(6260,1,1,NULL,248.420000,225.830000,225.830000,225.830000,NULL),(6260,2,1,NULL,248.420000,225.830000,225.830000,225.830000,NULL),(6260,3,1,NULL,248.420000,225.830000,225.830000,225.830000,NULL),(6261,0,1,NULL,571.000000,456.800000,456.800000,456.800000,NULL),(6261,1,1,NULL,571.000000,456.800000,456.800000,456.800000,NULL),(6261,2,1,NULL,571.000000,456.800000,456.800000,456.800000,NULL),(6261,3,1,NULL,571.000000,456.800000,456.800000,456.800000,NULL),(6262,0,1,NULL,571.000000,456.800000,456.800000,456.800000,NULL),(6262,1,1,NULL,571.000000,456.800000,456.800000,456.800000,NULL),(6262,2,1,NULL,571.000000,456.800000,456.800000,456.800000,NULL),(6262,3,1,NULL,571.000000,456.800000,456.800000,456.800000,NULL),(6263,0,1,NULL,389.000000,311.200000,311.200000,311.200000,NULL),(6263,1,1,NULL,389.000000,311.200000,311.200000,311.200000,NULL),(6263,2,1,NULL,389.000000,311.200000,311.200000,311.200000,NULL),(6263,3,1,NULL,389.000000,311.200000,311.200000,311.200000,NULL),(6264,0,1,NULL,454.000000,363.200000,363.200000,363.200000,NULL),(6264,1,1,NULL,454.000000,363.200000,363.200000,363.200000,NULL),(6264,2,1,NULL,454.000000,363.200000,363.200000,363.200000,NULL),(6264,3,1,NULL,454.000000,363.200000,363.200000,363.200000,NULL),(6265,0,1,NULL,546.000000,436.800000,436.800000,436.800000,NULL),(6265,1,1,NULL,546.000000,436.800000,436.800000,436.800000,NULL),(6265,2,1,NULL,546.000000,436.800000,436.800000,436.800000,NULL),(6265,3,1,NULL,546.000000,436.800000,436.800000,436.800000,NULL),(6266,0,1,NULL,615.000000,492.000000,492.000000,492.000000,NULL),(6266,1,1,NULL,615.000000,492.000000,492.000000,492.000000,NULL),(6266,2,1,NULL,615.000000,492.000000,492.000000,492.000000,NULL),(6266,3,1,NULL,615.000000,492.000000,492.000000,492.000000,NULL),(6267,0,1,NULL,642.000000,513.600000,513.600000,513.600000,NULL),(6267,1,1,NULL,642.000000,513.600000,513.600000,513.600000,NULL),(6267,2,1,NULL,642.000000,513.600000,513.600000,513.600000,NULL),(6267,3,1,NULL,642.000000,513.600000,513.600000,513.600000,NULL),(6268,0,1,NULL,708.250000,566.600000,566.600000,566.600000,NULL),(6268,1,1,NULL,708.250000,566.600000,566.600000,566.600000,NULL),(6268,2,1,NULL,708.250000,566.600000,566.600000,566.600000,NULL),(6268,3,1,NULL,708.250000,566.600000,566.600000,566.600000,NULL),(6269,0,1,NULL,458.000000,325.850000,325.850000,325.850000,NULL),(6269,1,1,NULL,458.000000,325.850000,325.850000,325.850000,NULL),(6269,2,1,NULL,458.000000,325.850000,325.850000,325.850000,NULL),(6269,3,1,NULL,458.000000,325.850000,325.850000,325.850000,NULL),(6270,0,1,NULL,508.000000,343.333333,343.333333,343.333333,NULL),(6270,1,1,NULL,508.000000,343.333333,343.333333,343.333333,NULL),(6270,2,1,NULL,508.000000,343.333333,343.333333,343.333333,NULL),(6270,3,1,NULL,508.000000,343.333333,343.333333,343.333333,NULL),(6271,0,1,NULL,179.666667,163.333334,163.333334,163.333334,NULL),(6271,1,1,NULL,179.666667,163.333334,163.333334,163.333334,NULL),(6271,2,1,NULL,179.666667,163.333334,163.333334,163.333334,NULL),(6271,3,1,NULL,179.666667,163.333334,163.333334,163.333334,NULL),(6272,0,1,NULL,410.666667,373.333334,373.333334,373.333334,NULL),(6272,1,1,NULL,410.666667,373.333334,373.333334,373.333334,NULL),(6272,2,1,NULL,410.666667,373.333334,373.333334,373.333334,NULL),(6272,3,1,NULL,410.666667,373.333334,373.333334,373.333334,NULL),(6273,0,1,NULL,187.733333,170.666667,170.666667,170.666667,NULL),(6273,1,1,NULL,187.733333,170.666667,170.666667,170.666667,NULL),(6273,2,1,NULL,187.733333,170.666667,170.666667,170.666667,NULL),(6273,3,1,NULL,187.733333,170.666667,170.666667,170.666667,NULL),(6274,0,1,NULL,410.666667,373.333334,373.333334,373.333334,NULL),(6274,1,1,NULL,410.666667,373.333334,373.333334,373.333334,NULL),(6274,2,1,NULL,410.666667,373.333334,373.333334,373.333334,NULL),(6274,3,1,NULL,410.666667,373.333334,373.333334,373.333334,NULL),(6275,0,1,NULL,189.750000,172.500000,172.500000,172.500000,NULL),(6275,1,1,NULL,189.750000,172.500000,172.500000,172.500000,NULL),(6275,2,1,NULL,189.750000,172.500000,172.500000,172.500000,NULL),(6275,3,1,NULL,189.750000,172.500000,172.500000,172.500000,NULL),(6276,0,1,NULL,216.333333,196.666667,196.666667,196.666667,NULL),(6276,1,1,NULL,216.333333,196.666667,196.666667,196.666667,NULL),(6276,2,1,NULL,216.333333,196.666667,196.666667,196.666667,NULL),(6276,3,1,NULL,216.333333,196.666667,196.666667,196.666667,NULL),(6277,0,1,NULL,434.500000,395.000000,395.000000,395.000000,NULL),(6277,1,1,NULL,434.500000,395.000000,395.000000,395.000000,NULL),(6277,2,1,NULL,434.500000,395.000000,395.000000,395.000000,NULL),(6277,3,1,NULL,434.500000,395.000000,395.000000,395.000000,NULL),(6278,0,1,NULL,365.216667,292.173333,292.173333,292.173333,NULL),(6278,1,1,NULL,365.216667,292.173333,292.173333,292.173333,NULL),(6278,2,1,NULL,365.216667,292.173333,292.173333,292.173333,NULL),(6278,3,1,NULL,365.216667,292.173333,292.173333,292.173333,NULL),(6279,0,1,NULL,432.300000,345.840000,345.840000,345.840000,NULL),(6279,1,1,NULL,432.300000,345.840000,345.840000,345.840000,NULL),(6279,2,1,NULL,432.300000,345.840000,345.840000,345.840000,NULL),(6279,3,1,NULL,432.300000,345.840000,345.840000,345.840000,NULL),(6280,0,1,NULL,263.330000,144.830000,144.830000,144.830000,NULL),(6280,1,1,NULL,263.330000,144.830000,144.830000,144.830000,NULL),(6280,2,1,NULL,263.330000,144.830000,144.830000,144.830000,NULL),(6280,3,1,NULL,263.330000,144.830000,144.830000,144.830000,NULL),(6281,0,1,NULL,282.500000,155.380000,155.380000,155.380000,NULL),(6281,1,1,NULL,282.500000,155.380000,155.380000,155.380000,NULL),(6281,2,1,NULL,282.500000,155.380000,155.380000,155.380000,NULL),(6281,3,1,NULL,282.500000,155.380000,155.380000,155.380000,NULL),(6282,0,1,NULL,402.500000,221.380000,221.380000,221.380000,NULL),(6282,1,1,NULL,402.500000,221.380000,221.380000,221.380000,NULL),(6282,2,1,NULL,402.500000,221.380000,221.380000,221.380000,NULL),(6282,3,1,NULL,402.500000,221.380000,221.380000,221.380000,NULL),(6283,0,1,NULL,345.000000,189.750000,189.750000,189.750000,NULL),(6283,1,1,NULL,345.000000,189.750000,189.750000,189.750000,NULL),(6283,2,1,NULL,345.000000,189.750000,189.750000,189.750000,NULL),(6283,3,1,NULL,345.000000,189.750000,189.750000,189.750000,NULL),(6284,0,1,NULL,172.333333,156.666667,156.666667,156.666667,NULL),(6284,1,1,NULL,172.333333,156.666667,156.666667,156.666667,NULL),(6284,2,1,NULL,172.333333,156.666667,156.666667,156.666667,NULL),(6284,3,1,NULL,172.333333,156.666667,156.666667,156.666667,NULL),(6285,0,1,NULL,487.666667,443.333334,443.333334,443.333334,NULL),(6285,1,1,NULL,487.666667,443.333334,443.333334,443.333334,NULL),(6285,2,1,NULL,487.666667,443.333334,443.333334,443.333334,NULL),(6285,3,1,NULL,487.666667,443.333334,443.333334,443.333334,NULL),(6286,0,1,NULL,220.916667,200.833334,200.833334,200.833334,NULL),(6286,1,1,NULL,220.916667,200.833334,200.833334,200.833334,NULL),(6286,2,1,NULL,220.916667,200.833334,200.833334,200.833334,NULL),(6286,3,1,NULL,220.916667,200.833334,200.833334,200.833334,NULL),(6287,0,1,NULL,262.166667,238.333334,238.333334,238.333334,NULL),(6287,1,1,NULL,262.166667,238.333334,238.333334,238.333334,NULL),(6287,2,1,NULL,262.166667,238.333334,238.333334,238.333334,NULL),(6287,3,1,NULL,262.166667,238.333334,238.333334,238.333334,NULL),(6288,0,1,NULL,230.083333,209.166667,209.166667,209.166667,NULL),(6288,1,1,NULL,230.083333,209.166667,209.166667,209.166667,NULL),(6288,2,1,NULL,230.083333,209.166667,209.166667,209.166667,NULL),(6288,3,1,NULL,230.083333,209.166667,209.166667,209.166667,NULL),(6289,0,1,NULL,282.241667,256.583334,256.583334,256.583334,NULL),(6289,1,1,NULL,282.241667,256.583334,256.583334,256.583334,NULL),(6289,2,1,NULL,282.241667,256.583334,256.583334,256.583334,NULL),(6289,3,1,NULL,282.241667,256.583334,256.583334,256.583334,NULL),(6290,0,1,NULL,436.333333,396.666667,396.666667,396.666667,NULL),(6290,1,1,NULL,436.333333,396.666667,396.666667,396.666667,NULL),(6290,2,1,NULL,436.333333,396.666667,396.666667,396.666667,NULL),(6290,3,1,NULL,436.333333,396.666667,396.666667,396.666667,NULL),(6291,0,1,NULL,294.250000,267.500000,267.500000,267.500000,NULL),(6291,1,1,NULL,294.250000,267.500000,267.500000,267.500000,NULL),(6291,2,1,NULL,294.250000,267.500000,267.500000,267.500000,NULL),(6291,3,1,NULL,294.250000,267.500000,267.500000,267.500000,NULL),(6292,0,1,NULL,268.216667,214.573333,214.573333,214.573333,NULL),(6292,1,1,NULL,268.216667,214.573333,214.573333,214.573333,NULL),(6292,2,1,NULL,268.216667,214.573333,214.573333,214.573333,NULL),(6292,3,1,NULL,268.216667,214.573333,214.573333,214.573333,NULL),(6293,0,1,NULL,319.166667,255.333333,255.333333,255.333333,NULL),(6293,1,1,NULL,319.166667,255.333333,255.333333,255.333333,NULL),(6293,2,1,NULL,319.166667,255.333333,255.333333,255.333333,NULL),(6293,3,1,NULL,319.166667,255.333333,255.333333,255.333333,NULL),(6294,0,1,NULL,230.083333,209.166667,209.166667,209.166667,NULL),(6294,1,1,NULL,230.083333,209.166667,209.166667,209.166667,NULL),(6294,2,1,NULL,230.083333,209.166667,209.166667,209.166667,NULL),(6294,3,1,NULL,230.083333,209.166667,209.166667,209.166667,NULL),(6295,0,1,NULL,225.500000,205.000000,205.000000,205.000000,NULL),(6295,1,1,NULL,225.500000,205.000000,205.000000,205.000000,NULL),(6295,2,1,NULL,225.500000,205.000000,205.000000,205.000000,NULL),(6295,3,1,NULL,225.500000,205.000000,205.000000,205.000000,NULL),(6296,0,1,NULL,224.583333,204.166667,204.166667,204.166667,NULL),(6296,1,1,NULL,224.583333,204.166667,204.166667,204.166667,NULL),(6296,2,1,NULL,224.583333,204.166667,204.166667,204.166667,NULL),(6296,3,1,NULL,224.583333,204.166667,204.166667,204.166667,NULL),(6297,0,1,NULL,143.000000,130.000000,130.000000,130.000000,NULL),(6297,1,1,NULL,143.000000,130.000000,130.000000,130.000000,NULL),(6297,2,1,NULL,143.000000,130.000000,130.000000,130.000000,NULL),(6297,3,1,NULL,143.000000,130.000000,130.000000,130.000000,NULL),(6298,0,1,NULL,123.856333,112.596667,112.596667,112.596667,NULL),(6298,1,1,NULL,123.856333,112.596667,112.596667,112.596667,NULL),(6298,2,1,NULL,123.856333,112.596667,112.596667,112.596667,NULL),(6298,3,1,NULL,123.856333,112.596667,112.596667,112.596667,NULL),(6299,0,1,NULL,293.458333,234.766667,234.766667,234.766667,NULL),(6299,1,1,NULL,293.458333,234.766667,234.766667,234.766667,NULL),(6299,2,1,NULL,293.458333,234.766667,234.766667,234.766667,NULL),(6299,3,1,NULL,293.458333,234.766667,234.766667,234.766667,NULL),(6300,0,1,NULL,121.920000,110.840000,110.840000,110.840000,NULL),(6300,1,1,NULL,121.920000,110.840000,110.840000,110.840000,NULL),(6300,2,1,NULL,121.920000,110.840000,110.840000,110.840000,NULL),(6300,3,1,NULL,121.920000,110.840000,110.840000,110.840000,NULL),(6301,0,1,NULL,107.250000,97.500000,97.500000,97.500000,NULL),(6301,1,1,NULL,107.250000,97.500000,97.500000,97.500000,NULL),(6301,2,1,NULL,107.250000,97.500000,97.500000,97.500000,NULL),(6301,3,1,NULL,107.250000,97.500000,97.500000,97.500000,NULL),(6302,0,1,NULL,114.583333,104.166667,104.166667,104.166667,NULL),(6302,1,1,NULL,114.583333,104.166667,104.166667,104.166667,NULL),(6302,2,1,NULL,114.583333,104.166667,104.166667,104.166667,NULL),(6302,3,1,NULL,114.583333,104.166667,104.166667,104.166667,NULL),(6303,0,1,NULL,115.500000,105.000000,105.000000,105.000000,NULL),(6303,1,1,NULL,115.500000,105.000000,105.000000,105.000000,NULL),(6303,2,1,NULL,115.500000,105.000000,105.000000,105.000000,NULL),(6303,3,1,NULL,115.500000,105.000000,105.000000,105.000000,NULL),(6304,0,1,NULL,203.133333,184.666667,184.666667,184.666667,NULL),(6304,1,1,NULL,203.133333,184.666667,184.666667,184.666667,NULL),(6304,2,1,NULL,203.133333,184.666667,184.666667,184.666667,NULL),(6304,3,1,NULL,203.133333,184.666667,184.666667,184.666667,NULL),(6305,0,1,NULL,176.546333,160.496667,160.496667,160.496667,NULL),(6305,1,1,NULL,176.546333,160.496667,160.496667,160.496667,NULL),(6305,2,1,NULL,176.546333,160.496667,160.496667,160.496667,NULL),(6305,3,1,NULL,176.546333,160.496667,160.496667,160.496667,NULL),(6306,0,1,NULL,220.546333,200.496667,200.496667,200.496667,NULL),(6306,1,1,NULL,220.546333,200.496667,200.496667,200.496667,NULL),(6306,2,1,NULL,220.546333,200.496667,200.496667,200.496667,NULL),(6306,3,1,NULL,220.546333,200.496667,200.496667,200.496667,NULL),(6307,0,1,NULL,218.841333,198.946667,198.946667,198.946667,NULL),(6307,1,1,NULL,218.841333,198.946667,198.946667,198.946667,NULL),(6307,2,1,NULL,218.841333,198.946667,198.946667,198.946667,NULL),(6307,3,1,NULL,218.841333,198.946667,198.946667,198.946667,NULL),(6308,0,1,NULL,219.798333,199.816667,199.816667,199.816667,NULL),(6308,1,1,NULL,219.798333,199.816667,199.816667,199.816667,NULL),(6308,2,1,NULL,219.798333,199.816667,199.816667,199.816667,NULL),(6308,3,1,NULL,219.798333,199.816667,199.816667,199.816667,NULL),(6309,0,1,NULL,348.000000,243.600000,243.600000,243.600000,NULL),(6309,1,1,NULL,348.000000,243.600000,243.600000,243.600000,NULL),(6309,2,1,NULL,348.000000,243.600000,243.600000,243.600000,NULL),(6309,3,1,NULL,348.000000,243.600000,243.600000,243.600000,NULL),(6310,0,1,NULL,148.400000,118.720000,118.720000,118.720000,NULL),(6310,1,1,NULL,148.400000,118.720000,118.720000,118.720000,NULL),(6310,2,1,NULL,148.400000,118.720000,118.720000,118.720000,NULL),(6310,3,1,NULL,148.400000,118.720000,118.720000,118.720000,NULL),(6311,0,1,NULL,199.316667,159.453333,159.453333,159.453333,NULL),(6311,1,1,NULL,199.316667,159.453333,159.453333,159.453333,NULL),(6311,2,1,NULL,199.316667,159.453333,159.453333,159.453333,NULL),(6311,3,1,NULL,199.316667,159.453333,159.453333,159.453333,NULL),(6312,0,1,NULL,528.000000,342.450000,342.450000,342.450000,NULL),(6312,1,1,NULL,528.000000,342.450000,342.450000,342.450000,NULL),(6312,2,1,NULL,528.000000,342.450000,342.450000,342.450000,NULL),(6312,3,1,NULL,528.000000,342.450000,342.450000,342.450000,NULL),(6313,0,1,NULL,398.000000,256.770000,256.770000,256.770000,NULL),(6313,1,1,NULL,398.000000,256.770000,256.770000,256.770000,NULL),(6313,2,1,NULL,398.000000,256.770000,256.770000,256.770000,NULL),(6313,3,1,NULL,398.000000,256.770000,256.770000,256.770000,NULL),(6314,0,1,NULL,438.000000,301.666667,301.666667,301.666667,NULL),(6314,1,1,NULL,438.000000,301.666667,301.666667,301.666667,NULL),(6314,2,1,NULL,438.000000,301.666667,301.666667,301.666667,NULL),(6314,3,1,NULL,438.000000,301.666667,301.666667,301.666667,NULL),(6315,0,1,NULL,408.000000,285.600000,285.600000,285.600000,NULL),(6315,1,1,NULL,408.000000,285.600000,285.600000,285.600000,NULL),(6315,2,1,NULL,408.000000,285.600000,285.600000,285.600000,NULL),(6315,3,1,NULL,408.000000,285.600000,285.600000,285.600000,NULL),(6316,0,1,NULL,338.000000,231.708333,231.708333,231.708333,NULL),(6316,1,1,NULL,338.000000,231.708333,231.708333,231.708333,NULL),(6316,2,1,NULL,338.000000,231.708333,231.708333,231.708333,NULL),(6316,3,1,NULL,338.000000,231.708333,231.708333,231.708333,NULL),(6317,0,1,NULL,568.000000,363.491667,363.491667,363.491667,NULL),(6317,1,1,NULL,568.000000,363.491667,363.491667,363.491667,NULL),(6317,2,1,NULL,568.000000,363.491667,363.491667,363.491667,NULL),(6317,3,1,NULL,568.000000,363.491667,363.491667,363.491667,NULL),(6318,0,1,NULL,748.000000,470.833333,470.833333,470.833333,NULL),(6318,1,1,NULL,748.000000,470.833333,470.833333,470.833333,NULL),(6318,2,1,NULL,748.000000,470.833333,470.833333,470.833333,NULL),(6318,3,1,NULL,748.000000,470.833333,470.833333,470.833333,NULL),(6319,0,1,NULL,818.000000,515.000000,515.000000,515.000000,NULL),(6319,1,1,NULL,818.000000,515.000000,515.000000,515.000000,NULL),(6319,2,1,NULL,818.000000,515.000000,515.000000,515.000000,NULL),(6319,3,1,NULL,818.000000,515.000000,515.000000,515.000000,NULL),(6320,0,1,NULL,598.000000,382.650000,382.650000,382.650000,NULL),(6320,1,1,NULL,598.000000,382.650000,382.650000,382.650000,NULL),(6320,2,1,NULL,598.000000,382.650000,382.650000,382.650000,NULL),(6320,3,1,NULL,598.000000,382.650000,382.650000,382.650000,NULL),(6321,0,1,NULL,838.000000,534.366667,534.366667,534.366667,NULL),(6321,1,1,NULL,838.000000,534.366667,534.366667,534.366667,NULL),(6321,2,1,NULL,838.000000,534.366667,534.366667,534.366667,NULL),(6321,3,1,NULL,838.000000,534.366667,534.366667,534.366667,NULL),(6322,0,1,NULL,848.000000,541.733333,541.733333,541.733333,NULL),(6322,1,1,NULL,848.000000,541.733333,541.733333,541.733333,NULL),(6322,2,1,NULL,848.000000,541.733333,541.733333,541.733333,NULL),(6322,3,1,NULL,848.000000,541.733333,541.733333,541.733333,NULL),(6323,0,1,NULL,678.000000,465.541667,465.541667,465.541667,NULL),(6323,1,1,NULL,678.000000,465.541667,465.541667,465.541667,NULL),(6323,2,1,NULL,678.000000,465.541667,465.541667,465.541667,NULL),(6323,3,1,NULL,678.000000,465.541667,465.541667,465.541667,NULL),(6324,0,1,NULL,648.000000,426.666667,426.666667,426.666667,NULL),(6324,1,1,NULL,648.000000,426.666667,426.666667,426.666667,NULL),(6324,2,1,NULL,648.000000,426.666667,426.666667,426.666667,NULL),(6324,3,1,NULL,648.000000,426.666667,426.666667,426.666667,NULL),(6325,0,1,NULL,768.000000,514.560000,514.560000,514.560000,NULL),(6325,1,1,NULL,768.000000,514.560000,514.560000,514.560000,NULL),(6325,2,1,NULL,768.000000,514.560000,514.560000,514.560000,NULL),(6325,3,1,NULL,768.000000,514.560000,514.560000,514.560000,NULL),(6326,0,1,NULL,718.000000,460.833333,460.833333,460.833333,NULL),(6326,1,1,NULL,718.000000,460.833333,460.833333,460.833333,NULL),(6326,2,1,NULL,718.000000,460.833333,460.833333,460.833333,NULL),(6326,3,1,NULL,718.000000,460.833333,460.833333,460.833333,NULL),(6327,0,1,NULL,738.000000,505.816667,505.816667,505.816667,NULL),(6327,1,1,NULL,738.000000,505.816667,505.816667,505.816667,NULL),(6327,2,1,NULL,738.000000,505.816667,505.816667,505.816667,NULL),(6327,3,1,NULL,738.000000,505.816667,505.816667,505.816667,NULL),(6328,0,1,NULL,192.500000,175.000000,175.000000,175.000000,NULL),(6328,1,1,NULL,192.500000,175.000000,175.000000,175.000000,NULL),(6328,2,1,NULL,192.500000,175.000000,175.000000,175.000000,NULL),(6328,3,1,NULL,192.500000,175.000000,175.000000,175.000000,NULL),(6329,0,1,NULL,220.000000,200.000000,200.000000,200.000000,NULL),(6329,1,1,NULL,220.000000,200.000000,200.000000,200.000000,NULL),(6329,2,1,NULL,220.000000,200.000000,200.000000,200.000000,NULL),(6329,3,1,NULL,220.000000,200.000000,200.000000,200.000000,NULL),(6330,0,1,NULL,232.833333,211.666667,211.666667,211.666667,NULL),(6330,1,1,NULL,232.833333,211.666667,211.666667,211.666667,NULL),(6330,2,1,NULL,232.833333,211.666667,211.666667,211.666667,NULL),(6330,3,1,NULL,232.833333,211.666667,211.666667,211.666667,NULL),(6331,0,1,NULL,252.083333,229.166667,229.166667,229.166667,NULL),(6331,1,1,NULL,252.083333,229.166667,229.166667,229.166667,NULL),(6331,2,1,NULL,252.083333,229.166667,229.166667,229.166667,NULL),(6331,3,1,NULL,252.083333,229.166667,229.166667,229.166667,NULL),(6332,0,1,NULL,397.116667,317.693333,317.693333,317.693333,NULL),(6332,1,1,NULL,397.116667,317.693333,317.693333,317.693333,NULL),(6332,2,1,NULL,397.116667,317.693333,317.693333,317.693333,NULL),(6332,3,1,NULL,397.116667,317.693333,317.693333,317.693333,NULL),(6333,0,1,NULL,468.358333,374.686667,374.686667,374.686667,NULL),(6333,1,1,NULL,468.358333,374.686667,374.686667,374.686667,NULL),(6333,2,1,NULL,468.358333,374.686667,374.686667,374.686667,NULL),(6333,3,1,NULL,468.358333,374.686667,374.686667,374.686667,NULL),(6334,0,1,NULL,528.083333,422.466667,422.466667,422.466667,NULL),(6334,1,1,NULL,528.083333,422.466667,422.466667,422.466667,NULL),(6334,2,1,NULL,528.083333,422.466667,422.466667,422.466667,NULL),(6334,3,1,NULL,528.083333,422.466667,422.466667,422.466667,NULL),(6335,0,1,NULL,625.941667,500.753333,500.753333,500.753333,NULL),(6335,1,1,NULL,625.941667,500.753333,500.753333,500.753333,NULL),(6335,2,1,NULL,625.941667,500.753333,500.753333,500.753333,NULL),(6335,3,1,NULL,625.941667,500.753333,500.753333,500.753333,NULL),(6336,0,1,NULL,433.341667,346.673333,346.673333,346.673333,NULL),(6336,1,1,NULL,433.341667,346.673333,346.673333,346.673333,NULL),(6336,2,1,NULL,433.341667,346.673333,346.673333,346.673333,NULL),(6336,3,1,NULL,433.341667,346.673333,346.673333,346.673333,NULL),(6337,0,1,NULL,510.000000,408.000000,408.000000,408.000000,NULL),(6337,1,1,NULL,510.000000,408.000000,408.000000,408.000000,NULL),(6337,2,1,NULL,510.000000,408.000000,408.000000,408.000000,NULL),(6337,3,1,NULL,510.000000,408.000000,408.000000,408.000000,NULL),(6338,0,1,NULL,948.000000,665.830000,665.830000,665.830000,NULL),(6338,1,1,NULL,948.000000,665.830000,665.830000,665.830000,NULL),(6338,2,1,NULL,948.000000,665.830000,665.830000,665.830000,NULL),(6338,3,1,NULL,948.000000,665.830000,665.830000,665.830000,NULL),(6339,0,1,NULL,748.000000,519.208333,519.208333,519.208333,NULL),(6339,1,1,NULL,748.000000,519.208333,519.208333,519.208333,NULL),(6339,2,1,NULL,748.000000,519.208333,519.208333,519.208333,NULL),(6339,3,1,NULL,748.000000,519.208333,519.208333,519.208333,NULL),(6340,0,1,NULL,408.000000,276.666667,276.666667,276.666667,NULL),(6340,1,1,NULL,408.000000,276.666667,276.666667,276.666667,NULL),(6340,2,1,NULL,408.000000,276.666667,276.666667,276.666667,NULL),(6340,3,1,NULL,408.000000,276.666667,276.666667,276.666667,NULL),(6341,0,1,NULL,438.000000,293.333333,293.333333,293.333333,NULL),(6341,1,1,NULL,438.000000,293.333333,293.333333,293.333333,NULL),(6341,2,1,NULL,438.000000,293.333333,293.333333,293.333333,NULL),(6341,3,1,NULL,438.000000,293.333333,293.333333,293.333333,NULL),(6342,0,1,NULL,478.000000,305.000000,305.000000,305.000000,NULL),(6342,1,1,NULL,478.000000,305.000000,305.000000,305.000000,NULL),(6342,2,1,NULL,478.000000,305.000000,305.000000,305.000000,NULL),(6342,3,1,NULL,478.000000,305.000000,305.000000,305.000000,NULL),(6343,0,1,NULL,548.000000,383.600000,383.600000,383.600000,NULL),(6343,1,1,NULL,548.000000,383.600000,383.600000,383.600000,NULL),(6343,2,1,NULL,548.000000,383.600000,383.600000,383.600000,NULL),(6343,3,1,NULL,548.000000,383.600000,383.600000,383.600000,NULL),(6344,0,1,NULL,448.000000,299.991667,299.991667,299.991667,NULL),(6344,1,1,NULL,448.000000,299.991667,299.991667,299.991667,NULL),(6344,2,1,NULL,448.000000,299.991667,299.991667,299.991667,NULL),(6344,3,1,NULL,448.000000,299.991667,299.991667,299.991667,NULL),(6345,0,1,NULL,378.000000,260.000000,260.000000,260.000000,NULL),(6345,1,1,NULL,378.000000,260.000000,260.000000,260.000000,NULL),(6345,2,1,NULL,378.000000,260.000000,260.000000,260.000000,NULL),(6345,3,1,NULL,378.000000,260.000000,260.000000,260.000000,NULL),(6346,0,1,NULL,954.170000,532.730000,532.730000,532.730000,NULL),(6346,1,1,NULL,954.170000,532.730000,532.730000,532.730000,NULL),(6346,2,1,NULL,954.170000,532.730000,532.730000,532.730000,NULL),(6346,3,1,NULL,954.170000,532.730000,532.730000,532.730000,NULL),(6347,0,1,NULL,1358.330000,758.210000,758.210000,758.210000,NULL),(6347,1,1,NULL,1358.330000,758.210000,758.210000,758.210000,NULL),(6347,2,1,NULL,1358.330000,758.210000,758.210000,758.210000,NULL),(6347,3,1,NULL,1358.330000,758.210000,758.210000,758.210000,NULL),(6348,0,1,NULL,1358.330000,733.210000,733.210000,733.210000,NULL),(6348,1,1,NULL,1358.330000,733.210000,733.210000,733.210000,NULL),(6348,2,1,NULL,1358.330000,733.210000,733.210000,733.210000,NULL),(6348,3,1,NULL,1358.330000,733.210000,733.210000,733.210000,NULL),(6349,0,1,NULL,829.170000,539.880000,539.880000,539.880000,NULL),(6349,1,1,NULL,829.170000,539.880000,539.880000,539.880000,NULL),(6349,2,1,NULL,829.170000,539.880000,539.880000,539.880000,NULL),(6349,3,1,NULL,829.170000,539.880000,539.880000,539.880000,NULL),(6350,0,1,NULL,1704.170000,950.160000,950.160000,950.160000,NULL),(6350,1,1,NULL,1704.170000,950.160000,950.160000,950.160000,NULL),(6350,2,1,NULL,1704.170000,950.160000,950.160000,950.160000,NULL),(6350,3,1,NULL,1704.170000,950.160000,950.160000,950.160000,NULL),(6351,0,1,NULL,829.170000,515.370000,515.370000,515.370000,NULL),(6351,1,1,NULL,829.170000,515.370000,515.370000,515.370000,NULL),(6351,2,1,NULL,829.170000,515.370000,515.370000,515.370000,NULL),(6351,3,1,NULL,829.170000,515.370000,515.370000,515.370000,NULL),(6352,0,1,NULL,904.170000,542.730000,542.730000,542.730000,NULL),(6352,1,1,NULL,904.170000,542.730000,542.730000,542.730000,NULL),(6352,2,1,NULL,904.170000,542.730000,542.730000,542.730000,NULL),(6352,3,1,NULL,904.170000,542.730000,542.730000,542.730000,NULL),(6353,0,1,NULL,820.830000,559.640000,559.640000,559.640000,NULL),(6353,1,1,NULL,820.830000,559.640000,559.640000,559.640000,NULL),(6353,2,1,NULL,820.830000,559.640000,559.640000,559.640000,NULL),(6353,3,1,NULL,820.830000,559.640000,559.640000,559.640000,NULL),(6354,0,1,NULL,829.170000,482.500000,482.500000,482.500000,NULL),(6354,1,1,NULL,829.170000,482.500000,482.500000,482.500000,NULL),(6354,2,1,NULL,829.170000,482.500000,482.500000,482.500000,NULL),(6354,3,1,NULL,829.170000,482.500000,482.500000,482.500000,NULL),(6355,0,1,NULL,1133.330000,645.960000,645.960000,645.960000,NULL),(6355,1,1,NULL,1133.330000,645.960000,645.960000,645.960000,NULL),(6355,2,1,NULL,1133.330000,645.960000,645.960000,645.960000,NULL),(6355,3,1,NULL,1133.330000,645.960000,645.960000,645.960000,NULL),(6356,0,1,NULL,1054.166667,563.800000,563.800000,563.800000,NULL),(6356,1,1,NULL,1054.166667,563.800000,563.800000,563.800000,NULL),(6356,2,1,NULL,1054.166667,563.800000,563.800000,563.800000,NULL),(6356,3,1,NULL,1054.166667,563.800000,563.800000,563.800000,NULL),(6357,0,1,NULL,1708.330000,926.900000,926.900000,926.900000,NULL),(6357,1,1,NULL,1708.330000,926.900000,926.900000,926.900000,NULL),(6357,2,1,NULL,1708.330000,926.900000,926.900000,926.900000,NULL),(6357,3,1,NULL,1708.330000,926.900000,926.900000,926.900000,NULL),(6358,0,1,NULL,1804.170000,1107.500000,1107.500000,1107.500000,NULL),(6358,1,1,NULL,1804.170000,1107.500000,1107.500000,1107.500000,NULL),(6358,2,1,NULL,1804.170000,1107.500000,1107.500000,1107.500000,NULL),(6358,3,1,NULL,1804.170000,1107.500000,1107.500000,1107.500000,NULL),(6359,0,1,NULL,1054.170000,616.580000,616.580000,616.580000,NULL),(6359,1,1,NULL,1054.170000,616.580000,616.580000,616.580000,NULL),(6359,2,1,NULL,1054.170000,616.580000,616.580000,616.580000,NULL),(6359,3,1,NULL,1054.170000,616.580000,616.580000,616.580000,NULL),(6360,0,1,NULL,1704.170000,1045.830000,1045.830000,1045.830000,NULL),(6360,1,1,NULL,1704.170000,1045.830000,1045.830000,1045.830000,NULL),(6360,2,1,NULL,1704.170000,1045.830000,1045.830000,1045.830000,NULL),(6360,3,1,NULL,1704.170000,1045.830000,1045.830000,1045.830000,NULL),(6361,0,1,NULL,1758.330000,956.820000,956.820000,956.820000,NULL),(6361,1,1,NULL,1758.330000,956.820000,956.820000,956.820000,NULL),(6361,2,1,NULL,1758.330000,956.820000,956.820000,956.820000,NULL),(6361,3,1,NULL,1758.330000,956.820000,956.820000,956.820000,NULL),(6362,0,1,NULL,1758.330000,956.810000,956.810000,956.810000,NULL),(6362,1,1,NULL,1758.330000,956.810000,956.810000,956.810000,NULL),(6362,2,1,NULL,1758.330000,956.810000,956.810000,956.810000,NULL),(6362,3,1,NULL,1758.330000,956.810000,956.810000,956.810000,NULL),(6363,0,1,NULL,1354.170000,808.180000,808.180000,808.180000,NULL),(6363,1,1,NULL,1354.170000,808.180000,808.180000,808.180000,NULL),(6363,2,1,NULL,1354.170000,808.180000,808.180000,808.180000,NULL),(6363,3,1,NULL,1354.170000,808.180000,808.180000,808.180000,NULL),(6364,0,1,NULL,1354.170000,732.630000,732.630000,732.630000,NULL),(6364,1,1,NULL,1354.170000,732.630000,732.630000,732.630000,NULL),(6364,2,1,NULL,1354.170000,732.630000,732.630000,732.630000,NULL),(6364,3,1,NULL,1354.170000,732.630000,732.630000,732.630000,NULL),(6365,0,1,NULL,1133.330000,683.330000,683.330000,683.330000,NULL),(6365,1,1,NULL,1133.330000,683.330000,683.330000,683.330000,NULL),(6365,2,1,NULL,1133.330000,683.330000,683.330000,683.330000,NULL),(6365,3,1,NULL,1133.330000,683.330000,683.330000,683.330000,NULL),(6366,0,1,NULL,1133.330000,683.330000,683.330000,683.330000,NULL),(6366,1,1,NULL,1133.330000,683.330000,683.330000,683.330000,NULL),(6366,2,1,NULL,1133.330000,683.330000,683.330000,683.330000,NULL),(6366,3,1,NULL,1133.330000,683.330000,683.330000,683.330000,NULL),(6367,0,1,NULL,1133.330000,683.330000,683.330000,683.330000,NULL),(6367,1,1,NULL,1133.330000,683.330000,683.330000,683.330000,NULL),(6367,2,1,NULL,1133.330000,683.330000,683.330000,683.330000,NULL),(6367,3,1,NULL,1133.330000,683.330000,683.330000,683.330000,NULL),(6368,0,1,NULL,314.170000,188.500000,188.500000,188.500000,NULL),(6368,1,1,NULL,314.170000,188.500000,188.500000,188.500000,NULL),(6368,2,1,NULL,314.170000,188.500000,188.500000,188.500000,NULL),(6368,3,1,NULL,314.170000,188.500000,188.500000,188.500000,NULL),(6369,0,1,NULL,355.000000,213.000000,213.000000,213.000000,NULL),(6369,1,1,NULL,355.000000,213.000000,213.000000,213.000000,NULL),(6369,2,1,NULL,355.000000,213.000000,213.000000,213.000000,NULL),(6369,3,1,NULL,355.000000,213.000000,213.000000,213.000000,NULL),(6370,0,1,NULL,383.330000,230.000000,230.000000,230.000000,NULL),(6370,1,1,NULL,383.330000,230.000000,230.000000,230.000000,NULL),(6370,2,1,NULL,383.330000,230.000000,230.000000,230.000000,NULL),(6370,3,1,NULL,383.330000,230.000000,230.000000,230.000000,NULL),(6371,0,1,NULL,283.330000,170.000000,170.000000,170.000000,NULL),(6371,1,1,NULL,283.330000,170.000000,170.000000,170.000000,NULL),(6371,2,1,NULL,283.330000,170.000000,170.000000,170.000000,NULL),(6371,3,1,NULL,283.330000,170.000000,170.000000,170.000000,NULL),(6372,0,1,NULL,293.330000,176.000000,176.000000,176.000000,NULL),(6372,1,1,NULL,293.330000,176.000000,176.000000,176.000000,NULL),(6372,2,1,NULL,293.330000,176.000000,176.000000,176.000000,NULL),(6372,3,1,NULL,293.330000,176.000000,176.000000,176.000000,NULL),(6373,0,1,NULL,302.500000,181.500000,181.500000,181.500000,NULL),(6373,1,1,NULL,302.500000,181.500000,181.500000,181.500000,NULL),(6373,2,1,NULL,302.500000,181.500000,181.500000,181.500000,NULL),(6373,3,1,NULL,302.500000,181.500000,181.500000,181.500000,NULL),(6374,0,1,NULL,352.500000,211.500000,211.500000,211.500000,NULL),(6374,1,1,NULL,352.500000,211.500000,211.500000,211.500000,NULL),(6374,2,1,NULL,352.500000,211.500000,211.500000,211.500000,NULL),(6374,3,1,NULL,352.500000,211.500000,211.500000,211.500000,NULL),(6375,0,1,NULL,370.830000,222.500000,222.500000,222.500000,NULL),(6375,1,1,NULL,370.830000,222.500000,222.500000,222.500000,NULL),(6375,2,1,NULL,370.830000,222.500000,222.500000,222.500000,NULL),(6375,3,1,NULL,370.830000,222.500000,222.500000,222.500000,NULL),(6376,0,1,NULL,297.500000,178.500000,178.500000,178.500000,NULL),(6376,1,1,NULL,297.500000,178.500000,178.500000,178.500000,NULL),(6376,2,1,NULL,297.500000,178.500000,178.500000,178.500000,NULL),(6376,3,1,NULL,297.500000,178.500000,178.500000,178.500000,NULL),(6377,0,1,NULL,305.830000,183.500000,183.500000,183.500000,NULL),(6377,1,1,NULL,305.830000,183.500000,183.500000,183.500000,NULL),(6377,2,1,NULL,305.830000,183.500000,183.500000,183.500000,NULL),(6377,3,1,NULL,305.830000,183.500000,183.500000,183.500000,NULL),(6378,0,1,NULL,314.170000,188.500000,188.500000,188.500000,NULL),(6378,1,1,NULL,314.170000,188.500000,188.500000,188.500000,NULL),(6378,2,1,NULL,314.170000,188.500000,188.500000,188.500000,NULL),(6378,3,1,NULL,314.170000,188.500000,188.500000,188.500000,NULL),(6379,0,1,NULL,355.000000,213.000000,213.000000,213.000000,NULL),(6379,1,1,NULL,355.000000,213.000000,213.000000,213.000000,NULL),(6379,2,1,NULL,355.000000,213.000000,213.000000,213.000000,NULL),(6379,3,1,NULL,355.000000,213.000000,213.000000,213.000000,NULL),(6380,0,1,NULL,383.330000,230.000000,230.000000,230.000000,NULL),(6380,1,1,NULL,383.330000,230.000000,230.000000,230.000000,NULL),(6380,2,1,NULL,383.330000,230.000000,230.000000,230.000000,NULL),(6380,3,1,NULL,383.330000,230.000000,230.000000,230.000000,NULL),(6381,0,1,NULL,312.500000,187.500000,187.500000,187.500000,NULL),(6381,1,1,NULL,312.500000,187.500000,187.500000,187.500000,NULL),(6381,2,1,NULL,312.500000,187.500000,187.500000,187.500000,NULL),(6381,3,1,NULL,312.500000,187.500000,187.500000,187.500000,NULL),(6382,0,1,NULL,352.500000,211.500000,211.500000,211.500000,NULL),(6382,1,1,NULL,352.500000,211.500000,211.500000,211.500000,NULL),(6382,2,1,NULL,352.500000,211.500000,211.500000,211.500000,NULL),(6382,3,1,NULL,352.500000,211.500000,211.500000,211.500000,NULL),(6383,0,1,NULL,376.670000,226.000000,226.000000,226.000000,NULL),(6383,1,1,NULL,376.670000,226.000000,226.000000,226.000000,NULL),(6383,2,1,NULL,376.670000,226.000000,226.000000,226.000000,NULL),(6383,3,1,NULL,376.670000,226.000000,226.000000,226.000000,NULL),(6384,0,1,NULL,683.330000,375.830000,375.830000,375.830000,NULL),(6384,1,1,NULL,683.330000,375.830000,375.830000,375.830000,NULL),(6384,2,1,NULL,683.330000,375.830000,375.830000,375.830000,NULL),(6384,3,1,NULL,683.330000,375.830000,375.830000,375.830000,NULL),(6385,0,1,NULL,500.000000,275.000000,275.000000,275.000000,NULL),(6385,1,1,NULL,500.000000,275.000000,275.000000,275.000000,NULL),(6385,2,1,NULL,500.000000,275.000000,275.000000,275.000000,NULL),(6385,3,1,NULL,500.000000,275.000000,275.000000,275.000000,NULL),(6386,0,1,NULL,394.170000,216.790000,216.790000,216.790000,NULL),(6386,1,1,NULL,394.170000,216.790000,216.790000,216.790000,NULL),(6386,2,1,NULL,394.170000,216.790000,216.790000,216.790000,NULL),(6386,3,1,NULL,394.170000,216.790000,216.790000,216.790000,NULL),(6387,0,1,NULL,457.500000,251.630000,251.630000,251.630000,NULL),(6387,1,1,NULL,457.500000,251.630000,251.630000,251.630000,NULL),(6387,2,1,NULL,457.500000,251.630000,251.630000,251.630000,NULL),(6387,3,1,NULL,457.500000,251.630000,251.630000,251.630000,NULL),(6388,0,1,NULL,246.970000,167.939600,167.939600,167.939600,NULL),(6388,1,1,NULL,246.970000,167.939600,167.939600,167.939600,NULL),(6388,2,1,NULL,246.970000,167.939600,167.939600,167.939600,NULL),(6388,3,1,NULL,246.970000,167.939600,167.939600,167.939600,NULL),(6389,0,1,NULL,411.280000,279.670400,279.670400,279.670400,NULL),(6389,1,1,NULL,411.280000,279.670400,279.670400,279.670400,NULL),(6389,2,1,NULL,411.280000,279.670400,279.670400,279.670400,NULL),(6389,3,1,NULL,411.280000,279.670400,279.670400,279.670400,NULL),(6390,0,1,NULL,555.820000,377.960000,377.960000,377.960000,NULL),(6390,1,1,NULL,555.820000,377.960000,377.960000,377.960000,NULL),(6390,2,1,NULL,555.820000,377.960000,377.960000,377.960000,NULL),(6390,3,1,NULL,555.820000,377.960000,377.960000,377.960000,NULL),(6391,0,1,NULL,555.820000,377.960000,377.960000,377.960000,NULL),(6391,1,1,NULL,555.820000,377.960000,377.960000,377.960000,NULL),(6391,2,1,NULL,555.820000,377.960000,377.960000,377.960000,NULL),(6391,3,1,NULL,555.820000,377.960000,377.960000,377.960000,NULL),(6392,0,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6392,1,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6392,2,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6392,3,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6393,0,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6393,1,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6393,2,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6393,3,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6394,0,1,NULL,923.000000,618.410000,618.410000,618.410000,NULL),(6394,1,1,NULL,923.000000,618.410000,618.410000,618.410000,NULL),(6394,2,1,NULL,923.000000,618.410000,618.410000,618.410000,NULL),(6394,3,1,NULL,923.000000,618.410000,618.410000,618.410000,NULL),(6395,0,1,NULL,1212.000000,812.040000,812.040000,812.040000,NULL),(6395,1,1,NULL,1212.000000,812.040000,812.040000,812.040000,NULL),(6395,2,1,NULL,1212.000000,812.040000,812.040000,812.040000,NULL),(6395,3,1,NULL,1212.000000,812.040000,812.040000,812.040000,NULL),(6396,0,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6396,1,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6396,2,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6396,3,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6397,0,1,NULL,970.000000,649.900000,649.900000,649.900000,NULL),(6397,1,1,NULL,970.000000,649.900000,649.900000,649.900000,NULL),(6397,2,1,NULL,970.000000,649.900000,649.900000,649.900000,NULL),(6397,3,1,NULL,970.000000,649.900000,649.900000,649.900000,NULL),(6398,0,1,NULL,1280.000000,857.600000,857.600000,857.600000,NULL),(6398,1,1,NULL,1280.000000,857.600000,857.600000,857.600000,NULL),(6398,2,1,NULL,1280.000000,857.600000,857.600000,857.600000,NULL),(6398,3,1,NULL,1280.000000,857.600000,857.600000,857.600000,NULL),(6399,0,1,NULL,1484.000000,994.280000,994.280000,994.280000,NULL),(6399,1,1,NULL,1484.000000,994.280000,994.280000,994.280000,NULL),(6399,2,1,NULL,1484.000000,994.280000,994.280000,994.280000,NULL),(6399,3,1,NULL,1484.000000,994.280000,994.280000,994.280000,NULL),(6400,0,1,NULL,3757.000000,2517.190000,2517.190000,2517.190000,NULL),(6400,1,1,NULL,3757.000000,2517.190000,2517.190000,2517.190000,NULL),(6400,2,1,NULL,3757.000000,2517.190000,2517.190000,2517.190000,NULL),(6400,3,1,NULL,3757.000000,2517.190000,2517.190000,2517.190000,NULL),(6401,0,1,NULL,1385.000000,927.950000,927.950000,927.950000,NULL),(6401,1,1,NULL,1385.000000,927.950000,927.950000,927.950000,NULL),(6401,2,1,NULL,1385.000000,927.950000,927.950000,927.950000,NULL),(6401,3,1,NULL,1385.000000,927.950000,927.950000,927.950000,NULL),(6402,0,1,NULL,3757.000000,2517.190000,2517.190000,2517.190000,NULL),(6402,1,1,NULL,3757.000000,2517.190000,2517.190000,2517.190000,NULL),(6402,2,1,NULL,3757.000000,2517.190000,2517.190000,2517.190000,NULL),(6402,3,1,NULL,3757.000000,2517.190000,2517.190000,2517.190000,NULL),(6403,0,1,NULL,693.440000,693.440000,693.440000,693.440000,NULL),(6403,1,1,NULL,693.440000,693.440000,693.440000,693.440000,NULL),(6403,2,1,NULL,693.440000,693.440000,693.440000,693.440000,NULL),(6403,3,1,NULL,693.440000,693.440000,693.440000,693.440000,NULL),(6404,0,1,NULL,275.400000,187.270000,187.270000,187.270000,NULL),(6404,1,1,NULL,275.400000,187.270000,187.270000,187.270000,NULL),(6404,2,1,NULL,275.400000,187.270000,187.270000,187.270000,NULL),(6404,3,1,NULL,275.400000,187.270000,187.270000,187.270000,NULL),(6405,0,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6405,1,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6405,2,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6405,3,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6406,0,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6406,1,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6406,2,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6406,3,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6407,0,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6407,1,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6407,2,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6407,3,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6408,0,1,NULL,766.000000,519.960000,519.960000,519.960000,NULL),(6408,1,1,NULL,766.000000,519.960000,519.960000,519.960000,NULL),(6408,2,1,NULL,766.000000,519.960000,519.960000,519.960000,NULL),(6408,3,1,NULL,766.000000,519.960000,519.960000,519.960000,NULL),(6409,0,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6409,1,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6409,2,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6409,3,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6410,0,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6410,1,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6410,2,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6410,3,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6411,0,1,NULL,724.000000,485.080000,485.080000,485.080000,NULL),(6411,1,1,NULL,724.000000,485.080000,485.080000,485.080000,NULL),(6411,2,1,NULL,724.000000,485.080000,485.080000,485.080000,NULL),(6411,3,1,NULL,724.000000,485.080000,485.080000,485.080000,NULL),(6412,0,1,NULL,777.000000,528.370000,528.370000,528.370000,NULL),(6412,1,1,NULL,777.000000,528.370000,528.370000,528.370000,NULL),(6412,2,1,NULL,777.000000,528.370000,528.370000,528.370000,NULL),(6412,3,1,NULL,777.000000,528.370000,528.370000,528.370000,NULL),(6413,0,1,NULL,894.000000,598.980000,598.980000,598.980000,NULL),(6413,1,1,NULL,894.000000,598.980000,598.980000,598.980000,NULL),(6413,2,1,NULL,894.000000,598.980000,598.980000,598.980000,NULL),(6413,3,1,NULL,894.000000,598.980000,598.980000,598.980000,NULL),(6414,0,1,NULL,853.000000,571.510000,571.510000,571.510000,NULL),(6414,1,1,NULL,853.000000,571.510000,571.510000,571.510000,NULL),(6414,2,1,NULL,853.000000,571.510000,571.510000,571.510000,NULL),(6414,3,1,NULL,853.000000,571.510000,571.510000,571.510000,NULL),(6415,0,1,NULL,853.000000,571.510000,571.510000,571.510000,NULL),(6415,1,1,NULL,853.000000,571.510000,571.510000,571.510000,NULL),(6415,2,1,NULL,853.000000,571.510000,571.510000,571.510000,NULL),(6415,3,1,NULL,853.000000,571.510000,571.510000,571.510000,NULL),(6416,0,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6416,1,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6416,2,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6416,3,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6417,0,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6417,1,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6417,2,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6417,3,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6418,0,1,NULL,873.000000,584.910000,584.910000,584.910000,NULL),(6418,1,1,NULL,873.000000,584.910000,584.910000,584.910000,NULL),(6418,2,1,NULL,873.000000,584.910000,584.910000,584.910000,NULL),(6418,3,1,NULL,873.000000,584.910000,584.910000,584.910000,NULL),(6419,0,1,NULL,824.000000,552.080000,552.080000,552.080000,NULL),(6419,1,1,NULL,824.000000,552.080000,552.080000,552.080000,NULL),(6419,2,1,NULL,824.000000,552.080000,552.080000,552.080000,NULL),(6419,3,1,NULL,824.000000,552.080000,552.080000,552.080000,NULL),(6420,0,1,NULL,914.000000,612.380000,612.380000,612.380000,NULL),(6420,1,1,NULL,914.000000,612.380000,612.380000,612.380000,NULL),(6420,2,1,NULL,914.000000,612.380000,612.380000,612.380000,NULL),(6420,3,1,NULL,914.000000,612.380000,612.380000,612.380000,NULL),(6421,0,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6421,1,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6421,2,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6421,3,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6422,0,1,NULL,1148.000000,769.160000,769.160000,769.160000,NULL),(6422,1,1,NULL,1148.000000,769.160000,769.160000,769.160000,NULL),(6422,2,1,NULL,1148.000000,769.160000,769.160000,769.160000,NULL),(6422,3,1,NULL,1148.000000,769.160000,769.160000,769.160000,NULL),(6423,0,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6423,1,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6423,2,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6423,3,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6424,0,1,NULL,697.000000,473.580000,473.580000,473.580000,NULL),(6424,1,1,NULL,697.000000,473.580000,473.580000,473.580000,NULL),(6424,2,1,NULL,697.000000,473.580000,473.580000,473.580000,NULL),(6424,3,1,NULL,697.000000,473.580000,473.580000,473.580000,NULL),(6425,0,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6425,1,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6425,2,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6425,3,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6426,0,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6426,1,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6426,2,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6426,3,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6427,0,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6427,1,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6427,2,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6427,3,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6428,0,1,NULL,1249.000000,849.200000,849.200000,849.200000,NULL),(6428,1,1,NULL,1249.000000,849.200000,849.200000,849.200000,NULL),(6428,2,1,NULL,1249.000000,849.200000,849.200000,849.200000,NULL),(6428,3,1,NULL,1249.000000,849.200000,849.200000,849.200000,NULL),(6429,0,1,NULL,1446.000000,968.820000,968.820000,968.820000,NULL),(6429,1,1,NULL,1446.000000,968.820000,968.820000,968.820000,NULL),(6429,2,1,NULL,1446.000000,968.820000,968.820000,968.820000,NULL),(6429,3,1,NULL,1446.000000,968.820000,968.820000,968.820000,NULL),(6430,0,1,NULL,1621.000000,1086.070000,1086.070000,1086.070000,NULL),(6430,1,1,NULL,1621.000000,1086.070000,1086.070000,1086.070000,NULL),(6430,2,1,NULL,1621.000000,1086.070000,1086.070000,1086.070000,NULL),(6430,3,1,NULL,1621.000000,1086.070000,1086.070000,1086.070000,NULL),(6431,0,1,NULL,560.000000,375.200000,375.200000,375.200000,NULL),(6431,1,1,NULL,560.000000,375.200000,375.200000,375.200000,NULL),(6431,2,1,NULL,560.000000,375.200000,375.200000,375.200000,NULL),(6431,3,1,NULL,560.000000,375.200000,375.200000,375.200000,NULL),(6432,0,1,NULL,664.000000,415.583333,415.583333,415.583333,NULL),(6432,1,1,NULL,664.000000,415.583333,415.583333,415.583333,NULL),(6432,2,1,NULL,664.000000,415.583333,415.583333,415.583333,NULL),(6432,3,1,NULL,664.000000,415.583333,415.583333,415.583333,NULL),(6433,0,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6433,1,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6433,2,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6433,3,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6434,0,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6434,1,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6434,2,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6434,3,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6435,0,1,NULL,749.000000,501.830000,501.830000,501.830000,NULL),(6435,1,1,NULL,749.000000,501.830000,501.830000,501.830000,NULL),(6435,2,1,NULL,749.000000,501.830000,501.830000,501.830000,NULL),(6435,3,1,NULL,749.000000,501.830000,501.830000,501.830000,NULL),(6436,0,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6436,1,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6436,2,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6436,3,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6437,0,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6437,1,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6437,2,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6437,3,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6438,0,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6438,1,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6438,2,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6438,3,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6439,0,1,NULL,749.000000,501.830000,501.830000,501.830000,NULL),(6439,1,1,NULL,749.000000,501.830000,501.830000,501.830000,NULL),(6439,2,1,NULL,749.000000,501.830000,501.830000,501.830000,NULL),(6439,3,1,NULL,749.000000,501.830000,501.830000,501.830000,NULL),(6440,0,1,NULL,619.000000,414.730000,414.730000,414.730000,NULL),(6440,1,1,NULL,619.000000,414.730000,414.730000,414.730000,NULL),(6440,2,1,NULL,619.000000,414.730000,414.730000,414.730000,NULL),(6440,3,1,NULL,619.000000,414.730000,414.730000,414.730000,NULL),(6441,0,1,NULL,590.000000,395.300000,395.300000,395.300000,NULL),(6441,1,1,NULL,590.000000,395.300000,395.300000,395.300000,NULL),(6441,2,1,NULL,590.000000,395.300000,395.300000,395.300000,NULL),(6441,3,1,NULL,590.000000,395.300000,395.300000,395.300000,NULL),(6442,0,1,NULL,560.000000,375.200000,375.200000,375.200000,NULL),(6442,1,1,NULL,560.000000,375.200000,375.200000,375.200000,NULL),(6442,2,1,NULL,560.000000,375.200000,375.200000,375.200000,NULL),(6442,3,1,NULL,560.000000,375.200000,375.200000,375.200000,NULL),(6443,0,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6443,1,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6443,2,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6443,3,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6444,0,1,NULL,489.000000,330.866667,330.866667,330.866667,NULL),(6444,1,1,NULL,489.000000,330.866667,330.866667,330.866667,NULL),(6444,2,1,NULL,489.000000,330.866667,330.866667,330.866667,NULL),(6444,3,1,NULL,489.000000,330.866667,330.866667,330.866667,NULL),(6445,0,1,NULL,501.000000,335.670000,335.670000,335.670000,NULL),(6445,1,1,NULL,501.000000,335.670000,335.670000,335.670000,NULL),(6445,2,1,NULL,501.000000,335.670000,335.670000,335.670000,NULL),(6445,3,1,NULL,501.000000,335.670000,335.670000,335.670000,NULL),(6446,0,1,NULL,560.000000,375.200000,375.200000,375.200000,NULL),(6446,1,1,NULL,560.000000,375.200000,375.200000,375.200000,NULL),(6446,2,1,NULL,560.000000,375.200000,375.200000,375.200000,NULL),(6446,3,1,NULL,560.000000,375.200000,375.200000,375.200000,NULL),(6447,0,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6447,1,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6447,2,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6447,3,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6448,0,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6448,1,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6448,2,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6448,3,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6449,0,1,NULL,560.000000,375.200000,375.200000,375.200000,NULL),(6449,1,1,NULL,560.000000,375.200000,375.200000,375.200000,NULL),(6449,2,1,NULL,560.000000,375.200000,375.200000,375.200000,NULL),(6449,3,1,NULL,560.000000,375.200000,375.200000,375.200000,NULL),(6450,0,1,NULL,501.000000,335.670000,335.670000,335.670000,NULL),(6450,1,1,NULL,501.000000,335.670000,335.670000,335.670000,NULL),(6450,2,1,NULL,501.000000,335.670000,335.670000,335.670000,NULL),(6450,3,1,NULL,501.000000,335.670000,335.670000,335.670000,NULL),(6451,0,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6451,1,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6451,2,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6451,3,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6452,0,1,NULL,616.000000,412.720000,412.720000,412.720000,NULL),(6452,1,1,NULL,616.000000,412.720000,412.720000,412.720000,NULL),(6452,2,1,NULL,616.000000,412.720000,412.720000,412.720000,NULL),(6452,3,1,NULL,616.000000,412.720000,412.720000,412.720000,NULL),(6453,0,1,NULL,786.000000,526.620000,526.620000,526.620000,NULL),(6453,1,1,NULL,786.000000,526.620000,526.620000,526.620000,NULL),(6453,2,1,NULL,786.000000,526.620000,526.620000,526.620000,NULL),(6453,3,1,NULL,786.000000,526.620000,526.620000,526.620000,NULL),(6454,0,1,NULL,1484.000000,994.280000,994.280000,994.280000,NULL),(6454,1,1,NULL,1484.000000,994.280000,994.280000,994.280000,NULL),(6454,2,1,NULL,1484.000000,994.280000,994.280000,994.280000,NULL),(6454,3,1,NULL,1484.000000,994.280000,994.280000,994.280000,NULL),(6455,0,1,NULL,1484.000000,994.280000,994.280000,994.280000,NULL),(6455,1,1,NULL,1484.000000,994.280000,994.280000,994.280000,NULL),(6455,2,1,NULL,1484.000000,994.280000,994.280000,994.280000,NULL),(6455,3,1,NULL,1484.000000,994.280000,994.280000,994.280000,NULL),(6456,0,1,NULL,1558.000000,1043.860000,1043.860000,1043.860000,NULL),(6456,1,1,NULL,1558.000000,1043.860000,1043.860000,1043.860000,NULL),(6456,2,1,NULL,1558.000000,1043.860000,1043.860000,1043.860000,NULL),(6456,3,1,NULL,1558.000000,1043.860000,1043.860000,1043.860000,NULL),(6457,0,1,NULL,1633.000000,1094.110000,1094.110000,1094.110000,NULL),(6457,1,1,NULL,1633.000000,1094.110000,1094.110000,1094.110000,NULL),(6457,2,1,NULL,1633.000000,1094.110000,1094.110000,1094.110000,NULL),(6457,3,1,NULL,1633.000000,1094.110000,1094.110000,1094.110000,NULL),(6458,0,1,NULL,1385.000000,927.950000,927.950000,927.950000,NULL),(6458,1,1,NULL,1385.000000,927.950000,927.950000,927.950000,NULL),(6458,2,1,NULL,1385.000000,927.950000,927.950000,927.950000,NULL),(6458,3,1,NULL,1385.000000,927.950000,927.950000,927.950000,NULL),(6459,0,1,NULL,1385.000000,927.950000,927.950000,927.950000,NULL),(6459,1,1,NULL,1385.000000,927.950000,927.950000,927.950000,NULL),(6459,2,1,NULL,1385.000000,927.950000,927.950000,927.950000,NULL),(6459,3,1,NULL,1385.000000,927.950000,927.950000,927.950000,NULL),(6460,0,1,NULL,1454.000000,974.180000,974.180000,974.180000,NULL),(6460,1,1,NULL,1454.000000,974.180000,974.180000,974.180000,NULL),(6460,2,1,NULL,1454.000000,974.180000,974.180000,974.180000,NULL),(6460,3,1,NULL,1454.000000,974.180000,974.180000,974.180000,NULL),(6461,0,1,NULL,1524.000000,1021.080000,1021.080000,1021.080000,NULL),(6461,1,1,NULL,1524.000000,1021.080000,1021.080000,1021.080000,NULL),(6461,2,1,NULL,1524.000000,1021.080000,1021.080000,1021.080000,NULL),(6461,3,1,NULL,1524.000000,1021.080000,1021.080000,1021.080000,NULL),(6462,0,1,NULL,1781.000000,1193.270000,1193.270000,1193.270000,NULL),(6462,1,1,NULL,1781.000000,1193.270000,1193.270000,1193.270000,NULL),(6462,2,1,NULL,1781.000000,1193.270000,1193.270000,1193.270000,NULL),(6462,3,1,NULL,1781.000000,1193.270000,1193.270000,1193.270000,NULL),(6463,0,1,NULL,733.000000,491.110000,491.110000,491.110000,NULL),(6463,1,1,NULL,733.000000,491.110000,491.110000,491.110000,NULL),(6463,2,1,NULL,733.000000,491.110000,491.110000,491.110000,NULL),(6463,3,1,NULL,733.000000,491.110000,491.110000,491.110000,NULL),(6464,0,1,NULL,501.000000,335.670000,335.670000,335.670000,NULL),(6464,1,1,NULL,501.000000,335.670000,335.670000,335.670000,NULL),(6464,2,1,NULL,501.000000,335.670000,335.670000,335.670000,NULL),(6464,3,1,NULL,501.000000,335.670000,335.670000,335.670000,NULL),(6465,0,1,NULL,3666.000000,2451.690000,2451.690000,2451.690000,NULL),(6465,1,1,NULL,3666.000000,2451.690000,2451.690000,2451.690000,NULL),(6465,2,1,NULL,3666.000000,2451.690000,2451.690000,2451.690000,NULL),(6465,3,1,NULL,3666.000000,2451.690000,2451.690000,2451.690000,NULL),(6466,0,1,NULL,3945.000000,2643.150000,2643.150000,2643.150000,NULL),(6466,1,1,NULL,3945.000000,2643.150000,2643.150000,2643.150000,NULL),(6466,2,1,NULL,3945.000000,2643.150000,2643.150000,2643.150000,NULL),(6466,3,1,NULL,3945.000000,2643.150000,2643.150000,2643.150000,NULL),(6467,0,1,NULL,4133.000000,2769.110000,2769.110000,2769.110000,NULL),(6467,1,1,NULL,4133.000000,2769.110000,2769.110000,2769.110000,NULL),(6467,2,1,NULL,4133.000000,2769.110000,2769.110000,2769.110000,NULL),(6467,3,1,NULL,4133.000000,2769.110000,2769.110000,2769.110000,NULL),(6468,0,1,NULL,3666.000000,2451.690000,2451.690000,2451.690000,NULL),(6468,1,1,NULL,3666.000000,2451.690000,2451.690000,2451.690000,NULL),(6468,2,1,NULL,3666.000000,2451.690000,2451.690000,2451.690000,NULL),(6468,3,1,NULL,3666.000000,2451.690000,2451.690000,2451.690000,NULL),(6469,0,1,NULL,3945.000000,2643.150000,2643.150000,2643.150000,NULL),(6469,1,1,NULL,3945.000000,2643.150000,2643.150000,2643.150000,NULL),(6469,2,1,NULL,3945.000000,2643.150000,2643.150000,2643.150000,NULL),(6469,3,1,NULL,3945.000000,2643.150000,2643.150000,2643.150000,NULL),(6470,0,1,NULL,4133.000000,2769.110000,2769.110000,2769.110000,NULL),(6470,1,1,NULL,4133.000000,2769.110000,2769.110000,2769.110000,NULL),(6470,2,1,NULL,4133.000000,2769.110000,2769.110000,2769.110000,NULL),(6470,3,1,NULL,4133.000000,2769.110000,2769.110000,2769.110000,NULL),(6471,0,1,NULL,1122.000000,751.740000,751.740000,751.740000,NULL),(6471,1,1,NULL,1122.000000,751.740000,751.740000,751.740000,NULL),(6471,2,1,NULL,1122.000000,751.740000,751.740000,751.740000,NULL),(6471,3,1,NULL,1122.000000,751.740000,751.740000,751.740000,NULL),(6472,0,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6472,1,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6472,2,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6472,3,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6473,0,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6473,1,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6473,2,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6473,3,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6474,0,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6474,1,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6474,2,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6474,3,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6475,0,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6475,1,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6475,2,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6475,3,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6476,0,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6476,1,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6476,2,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6476,3,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6477,0,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6477,1,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6477,2,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6477,3,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6478,0,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6478,1,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6478,2,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6478,3,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6479,0,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6479,1,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6479,2,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6479,3,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6480,0,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6480,1,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6480,2,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6480,3,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6481,0,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6481,1,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6481,2,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6481,3,1,NULL,918.000000,615.060000,615.060000,615.060000,NULL),(6482,0,1,NULL,1122.000000,751.740000,751.740000,751.740000,NULL),(6482,1,1,NULL,1122.000000,751.740000,751.740000,751.740000,NULL),(6482,2,1,NULL,1122.000000,751.740000,751.740000,751.740000,NULL),(6482,3,1,NULL,1122.000000,751.740000,751.740000,751.740000,NULL),(6483,0,1,NULL,5890.000000,3946.300000,3946.300000,3946.300000,NULL),(6483,1,1,NULL,5890.000000,3946.300000,3946.300000,3946.300000,NULL),(6483,2,1,NULL,5890.000000,3946.300000,3946.300000,3946.300000,NULL),(6483,3,1,NULL,5890.000000,3946.300000,3946.300000,3946.300000,NULL),(6484,0,1,NULL,1016.000000,680.720000,680.720000,680.720000,NULL),(6484,1,1,NULL,1016.000000,680.720000,680.720000,680.720000,NULL),(6484,2,1,NULL,1016.000000,680.720000,680.720000,680.720000,NULL),(6484,3,1,NULL,1016.000000,680.720000,680.720000,680.720000,NULL),(6485,0,1,NULL,4113.330000,2468.000000,2468.000000,2468.000000,NULL),(6485,1,1,NULL,4113.330000,2468.000000,2468.000000,2468.000000,NULL),(6485,2,1,NULL,4113.330000,2468.000000,2468.000000,2468.000000,NULL),(6485,3,1,NULL,4113.330000,2468.000000,2468.000000,2468.000000,NULL),(6486,0,1,NULL,555.000000,305.250000,305.250000,305.250000,NULL),(6486,1,1,NULL,555.000000,305.250000,305.250000,305.250000,NULL),(6486,2,1,NULL,555.000000,305.250000,305.250000,305.250000,NULL),(6486,3,1,NULL,555.000000,305.250000,305.250000,305.250000,NULL),(6487,0,1,NULL,320.000000,176.000000,176.000000,176.000000,NULL),(6487,1,1,NULL,320.000000,176.000000,176.000000,176.000000,NULL),(6487,2,1,NULL,320.000000,176.000000,176.000000,176.000000,NULL),(6487,3,1,NULL,320.000000,176.000000,176.000000,176.000000,NULL),(6488,0,1,NULL,500.000000,275.000000,275.000000,275.000000,NULL),(6488,1,1,NULL,500.000000,275.000000,275.000000,275.000000,NULL),(6488,2,1,NULL,500.000000,275.000000,275.000000,275.000000,NULL),(6488,3,1,NULL,500.000000,275.000000,275.000000,275.000000,NULL),(6489,0,1,NULL,457.500000,274.500000,274.500000,274.500000,NULL),(6489,1,1,NULL,457.500000,274.500000,274.500000,274.500000,NULL),(6489,2,1,NULL,457.500000,274.500000,274.500000,274.500000,NULL),(6489,3,1,NULL,457.500000,274.500000,274.500000,274.500000,NULL),(6490,0,1,NULL,516.670000,303.800000,303.800000,303.800000,NULL),(6490,1,1,NULL,516.670000,303.800000,303.800000,303.800000,NULL),(6490,2,1,NULL,516.670000,303.800000,303.800000,303.800000,NULL),(6490,3,1,NULL,516.670000,303.800000,303.800000,303.800000,NULL),(6491,0,1,NULL,3716.670000,2230.002000,2230.002000,2230.002000,NULL),(6491,1,1,NULL,3716.670000,2230.002000,2230.002000,2230.002000,NULL),(6491,2,1,NULL,3716.670000,2230.002000,2230.002000,2230.002000,NULL),(6491,3,1,NULL,3716.670000,2230.002000,2230.002000,2230.002000,NULL),(6492,0,1,NULL,3779.170000,1511.668000,1511.668000,1511.668000,NULL),(6492,1,1,NULL,3779.170000,1511.668000,1511.668000,1511.668000,NULL),(6492,2,1,NULL,3779.170000,1511.668000,1511.668000,1511.668000,NULL),(6492,3,1,NULL,3779.170000,1511.668000,1511.668000,1511.668000,NULL),(6493,0,1,NULL,3779.170000,1511.668000,1511.668000,1511.668000,NULL),(6493,1,1,NULL,3779.170000,1511.668000,1511.668000,1511.668000,NULL),(6493,2,1,NULL,3779.170000,1511.668000,1511.668000,1511.668000,NULL),(6493,3,1,NULL,3779.170000,1511.668000,1511.668000,1511.668000,NULL),(6494,0,1,NULL,3779.170000,1511.668000,1511.668000,1511.668000,NULL),(6494,1,1,NULL,3779.170000,1511.668000,1511.668000,1511.668000,NULL),(6494,2,1,NULL,3779.170000,1511.668000,1511.668000,1511.668000,NULL),(6494,3,1,NULL,3779.170000,1511.668000,1511.668000,1511.668000,NULL),(6495,0,1,NULL,4133.330000,1653.332000,1653.332000,1653.332000,NULL),(6495,1,1,NULL,4133.330000,1653.332000,1653.332000,1653.332000,NULL),(6495,2,1,NULL,4133.330000,1653.332000,1653.332000,1653.332000,NULL),(6495,3,1,NULL,4133.330000,1653.332000,1653.332000,1653.332000,NULL),(6496,0,1,NULL,373.330000,149.332000,149.332000,149.332000,NULL),(6496,1,1,NULL,373.330000,149.332000,149.332000,149.332000,NULL),(6496,2,1,NULL,373.330000,149.332000,149.332000,149.332000,NULL),(6496,3,1,NULL,373.330000,149.332000,149.332000,149.332000,NULL),(6497,0,1,NULL,395.830000,158.332000,158.332000,158.332000,NULL),(6497,1,1,NULL,395.830000,158.332000,158.332000,158.332000,NULL),(6497,2,1,NULL,395.830000,158.332000,158.332000,158.332000,NULL),(6497,3,1,NULL,395.830000,158.332000,158.332000,158.332000,NULL),(6498,0,1,NULL,423.330000,169.332000,169.332000,169.332000,NULL),(6498,1,1,NULL,423.330000,169.332000,169.332000,169.332000,NULL),(6498,2,1,NULL,423.330000,169.332000,169.332000,169.332000,NULL),(6498,3,1,NULL,423.330000,169.332000,169.332000,169.332000,NULL),(6499,0,1,NULL,1535.830000,614.332000,614.332000,614.332000,NULL),(6499,1,1,NULL,1535.830000,614.332000,614.332000,614.332000,NULL),(6499,2,1,NULL,1535.830000,614.332000,614.332000,614.332000,NULL),(6499,3,1,NULL,1535.830000,614.332000,614.332000,614.332000,NULL),(6500,0,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6500,1,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6500,2,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6500,3,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6501,0,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6501,1,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6501,2,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6501,3,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6502,0,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6502,1,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6502,2,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6502,3,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6503,0,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6503,1,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6503,2,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6503,3,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6504,0,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6504,1,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6504,2,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6504,3,1,NULL,1222.500000,489.000000,489.000000,489.000000,NULL),(6505,0,1,NULL,1479.170000,591.668000,591.668000,591.668000,NULL),(6505,1,1,NULL,1479.170000,591.668000,591.668000,591.668000,NULL),(6505,2,1,NULL,1479.170000,591.668000,591.668000,591.668000,NULL),(6505,3,1,NULL,1479.170000,591.668000,591.668000,591.668000,NULL),(6506,0,1,NULL,1479.170000,591.668000,591.668000,591.668000,NULL),(6506,1,1,NULL,1479.170000,591.668000,591.668000,591.668000,NULL),(6506,2,1,NULL,1479.170000,591.668000,591.668000,591.668000,NULL),(6506,3,1,NULL,1479.170000,591.668000,591.668000,591.668000,NULL),(6507,0,1,NULL,1100.000000,737.000000,737.000000,737.000000,NULL),(6507,1,1,NULL,1100.000000,737.000000,737.000000,737.000000,NULL),(6507,2,1,NULL,1100.000000,737.000000,737.000000,737.000000,NULL),(6507,3,1,NULL,1100.000000,737.000000,737.000000,737.000000,NULL),(6508,0,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6508,1,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6508,2,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6508,3,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6509,0,1,NULL,501.000000,335.670000,335.670000,335.670000,NULL),(6509,1,1,NULL,501.000000,335.670000,335.670000,335.670000,NULL),(6509,2,1,NULL,501.000000,335.670000,335.670000,335.670000,NULL),(6509,3,1,NULL,501.000000,335.670000,335.670000,335.670000,NULL),(6510,0,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6510,1,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6510,2,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6510,3,1,NULL,760.000000,509.200000,509.200000,509.200000,NULL),(6511,0,1,NULL,156.000000,104.520000,104.520000,104.520000,NULL),(6511,1,1,NULL,156.000000,104.520000,104.520000,104.520000,NULL),(6511,2,1,NULL,156.000000,104.520000,104.520000,104.520000,NULL),(6511,3,1,NULL,156.000000,104.520000,104.520000,104.520000,NULL),(6512,0,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6512,1,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6512,2,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6512,3,1,NULL,715.000000,479.050000,479.050000,479.050000,NULL),(6513,0,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6513,1,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6513,2,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6513,3,1,NULL,785.000000,525.950000,525.950000,525.950000,NULL),(6514,0,1,NULL,946.000000,642.533333,642.533333,642.533333,NULL),(6514,1,1,NULL,946.000000,642.533333,642.533333,642.533333,NULL),(6514,2,1,NULL,946.000000,642.533333,642.533333,642.533333,NULL),(6514,3,1,NULL,946.000000,642.533333,642.533333,642.533333,NULL),(6515,0,1,NULL,970.000000,649.900000,649.900000,649.900000,NULL),(6515,1,1,NULL,970.000000,649.900000,649.900000,649.900000,NULL),(6515,2,1,NULL,970.000000,649.900000,649.900000,649.900000,NULL),(6515,3,1,NULL,970.000000,649.900000,649.900000,649.900000,NULL),(6516,0,1,NULL,970.000000,649.900000,649.900000,649.900000,NULL),(6516,1,1,NULL,970.000000,649.900000,649.900000,649.900000,NULL),(6516,2,1,NULL,970.000000,649.900000,649.900000,649.900000,NULL),(6516,3,1,NULL,970.000000,649.900000,649.900000,649.900000,NULL),(6517,0,1,NULL,1067.000000,714.890000,714.890000,714.890000,NULL),(6517,1,1,NULL,1067.000000,714.890000,714.890000,714.890000,NULL),(6517,2,1,NULL,1067.000000,714.890000,714.890000,714.890000,NULL),(6517,3,1,NULL,1067.000000,714.890000,714.890000,714.890000,NULL),(6518,0,1,NULL,1205.000000,807.350000,807.350000,807.350000,NULL),(6518,1,1,NULL,1205.000000,807.350000,807.350000,807.350000,NULL),(6518,2,1,NULL,1205.000000,807.350000,807.350000,807.350000,NULL),(6518,3,1,NULL,1205.000000,807.350000,807.350000,807.350000,NULL),(6519,0,1,NULL,4799.000000,3215.330000,3215.330000,3215.330000,NULL),(6519,1,1,NULL,4799.000000,3215.330000,3215.330000,3215.330000,NULL),(6519,2,1,NULL,4799.000000,3215.330000,3215.330000,3215.330000,NULL),(6519,3,1,NULL,4799.000000,3215.330000,3215.330000,3215.330000,NULL),(6520,0,1,NULL,4799.000000,3215.330000,3215.330000,3215.330000,NULL),(6520,1,1,NULL,4799.000000,3215.330000,3215.330000,3215.330000,NULL),(6520,2,1,NULL,4799.000000,3215.330000,3215.330000,3215.330000,NULL),(6520,3,1,NULL,4799.000000,3215.330000,3215.330000,3215.330000,NULL),(6521,0,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6521,1,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6521,2,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6521,3,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6522,0,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6522,1,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6522,2,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6522,3,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6523,0,1,NULL,876.000000,586.920000,586.920000,586.920000,NULL),(6523,1,1,NULL,876.000000,586.920000,586.920000,586.920000,NULL),(6523,2,1,NULL,876.000000,586.920000,586.920000,586.920000,NULL),(6523,3,1,NULL,876.000000,586.920000,586.920000,586.920000,NULL),(6524,0,1,NULL,1100.000000,737.000000,737.000000,737.000000,NULL),(6524,1,1,NULL,1100.000000,737.000000,737.000000,737.000000,NULL),(6524,2,1,NULL,1100.000000,737.000000,737.000000,737.000000,NULL),(6524,3,1,NULL,1100.000000,737.000000,737.000000,737.000000,NULL),(6525,0,1,NULL,793.000000,592.533333,592.533333,592.533333,NULL),(6525,1,1,NULL,793.000000,592.533333,592.533333,592.533333,NULL),(6525,2,1,NULL,793.000000,592.533333,592.533333,592.533333,NULL),(6525,3,1,NULL,793.000000,592.533333,592.533333,592.533333,NULL),(6526,0,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6526,1,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6526,2,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6526,3,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6527,0,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6527,1,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6527,2,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6527,3,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6528,0,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6528,1,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6528,2,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6528,3,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6529,0,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6529,1,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6529,2,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6529,3,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6530,0,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6530,1,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6530,2,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6530,3,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6531,0,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6531,1,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6531,2,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6531,3,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6532,0,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6532,1,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6532,2,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6532,3,1,NULL,812.000000,544.040000,544.040000,544.040000,NULL),(6533,0,1,NULL,853.000000,571.510000,571.510000,571.510000,NULL),(6533,1,1,NULL,853.000000,571.510000,571.510000,571.510000,NULL),(6533,2,1,NULL,853.000000,571.510000,571.510000,571.510000,NULL),(6533,3,1,NULL,853.000000,571.510000,571.510000,571.510000,NULL),(6534,0,1,NULL,1010.000000,676.700000,676.700000,676.700000,NULL),(6534,1,1,NULL,1010.000000,676.700000,676.700000,676.700000,NULL),(6534,2,1,NULL,1010.000000,676.700000,676.700000,676.700000,NULL),(6534,3,1,NULL,1010.000000,676.700000,676.700000,676.700000,NULL),(6535,0,1,NULL,1016.000000,680.720000,680.720000,680.720000,NULL),(6535,1,1,NULL,1016.000000,680.720000,680.720000,680.720000,NULL),(6535,2,1,NULL,1016.000000,680.720000,680.720000,680.720000,NULL),(6535,3,1,NULL,1016.000000,680.720000,680.720000,680.720000,NULL),(6536,0,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6536,1,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6536,2,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6536,3,1,NULL,681.000000,456.270000,456.270000,456.270000,NULL),(6537,0,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6537,1,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6537,2,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6537,3,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6538,0,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6538,1,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6538,2,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6538,3,1,NULL,797.000000,533.990000,533.990000,533.990000,NULL),(6539,0,1,NULL,876.000000,586.920000,586.920000,586.920000,NULL),(6539,1,1,NULL,876.000000,586.920000,586.920000,586.920000,NULL),(6539,2,1,NULL,876.000000,586.920000,586.920000,586.920000,NULL),(6539,3,1,NULL,876.000000,586.920000,586.920000,586.920000,NULL),(6540,0,1,NULL,901.000000,611.700000,611.700000,611.700000,NULL),(6540,1,1,NULL,901.000000,611.700000,611.700000,611.700000,NULL),(6540,2,1,NULL,901.000000,611.700000,611.700000,611.700000,NULL),(6540,3,1,NULL,901.000000,611.700000,611.700000,611.700000,NULL),(6541,0,1,NULL,923.000000,618.410000,618.410000,618.410000,NULL),(6541,1,1,NULL,923.000000,618.410000,618.410000,618.410000,NULL),(6541,2,1,NULL,923.000000,618.410000,618.410000,618.410000,NULL),(6541,3,1,NULL,923.000000,618.410000,618.410000,618.410000,NULL),(6542,0,1,NULL,1182.000000,804.200000,804.200000,804.200000,NULL),(6542,1,1,NULL,1182.000000,804.200000,804.200000,804.200000,NULL),(6542,2,1,NULL,1182.000000,804.200000,804.200000,804.200000,NULL),(6542,3,1,NULL,1182.000000,804.200000,804.200000,804.200000,NULL),(6543,0,1,NULL,1333.000000,893.110000,893.110000,893.110000,NULL),(6543,1,1,NULL,1333.000000,893.110000,893.110000,893.110000,NULL),(6543,2,1,NULL,1333.000000,893.110000,893.110000,893.110000,NULL),(6543,3,1,NULL,1333.000000,893.110000,893.110000,893.110000,NULL),(6544,0,1,NULL,1506.000000,1009.020000,1009.020000,1009.020000,NULL),(6544,1,1,NULL,1506.000000,1009.020000,1009.020000,1009.020000,NULL),(6544,2,1,NULL,1506.000000,1009.020000,1009.020000,1009.020000,NULL),(6544,3,1,NULL,1506.000000,1009.020000,1009.020000,1009.020000,NULL),(6545,0,1,NULL,1818.000000,1218.060000,1218.060000,1218.060000,NULL),(6545,1,1,NULL,1818.000000,1218.060000,1218.060000,1218.060000,NULL),(6545,2,1,NULL,1818.000000,1218.060000,1218.060000,1218.060000,NULL),(6545,3,1,NULL,1818.000000,1218.060000,1218.060000,1218.060000,NULL),(6546,0,1,NULL,273.330000,273.330000,273.330000,273.330000,NULL),(6546,1,1,NULL,273.330000,273.330000,273.330000,273.330000,NULL),(6546,2,1,NULL,273.330000,273.330000,273.330000,273.330000,NULL),(6546,3,1,NULL,273.330000,273.330000,273.330000,273.330000,NULL),(6547,0,1,NULL,273.330000,273.330000,273.330000,273.330000,NULL),(6547,1,1,NULL,273.330000,273.330000,273.330000,273.330000,NULL),(6547,2,1,NULL,273.330000,273.330000,273.330000,273.330000,NULL),(6547,3,1,NULL,273.330000,273.330000,273.330000,273.330000,NULL),(6548,0,1,NULL,273.330000,273.330000,273.330000,273.330000,NULL),(6548,1,1,NULL,273.330000,273.330000,273.330000,273.330000,NULL),(6548,2,1,NULL,273.330000,273.330000,273.330000,273.330000,NULL),(6548,3,1,NULL,273.330000,273.330000,273.330000,273.330000,NULL),(6549,0,1,NULL,273.330000,273.330000,273.330000,273.330000,NULL),(6549,1,1,NULL,273.330000,273.330000,273.330000,273.330000,NULL),(6549,2,1,NULL,273.330000,273.330000,273.330000,273.330000,NULL),(6549,3,1,NULL,273.330000,273.330000,273.330000,273.330000,NULL),(6550,0,1,NULL,333.330000,333.330000,333.330000,333.330000,NULL),(6550,1,1,NULL,333.330000,333.330000,333.330000,333.330000,NULL),(6550,2,1,NULL,333.330000,333.330000,333.330000,333.330000,NULL),(6550,3,1,NULL,333.330000,333.330000,333.330000,333.330000,NULL),(6551,0,1,NULL,333.330000,333.330000,333.330000,333.330000,NULL),(6551,1,1,NULL,333.330000,333.330000,333.330000,333.330000,NULL),(6551,2,1,NULL,333.330000,333.330000,333.330000,333.330000,NULL),(6551,3,1,NULL,333.330000,333.330000,333.330000,333.330000,NULL),(6552,0,1,NULL,333.480000,333.480000,333.480000,333.480000,NULL),(6552,1,1,NULL,333.480000,333.480000,333.480000,333.480000,NULL),(6552,2,1,NULL,333.480000,333.480000,333.480000,333.480000,NULL),(6552,3,1,NULL,333.480000,333.480000,333.480000,333.480000,NULL),(6553,0,1,NULL,399.170000,399.170000,399.170000,399.170000,NULL),(6553,1,1,NULL,399.170000,399.170000,399.170000,399.170000,NULL),(6553,2,1,NULL,399.170000,399.170000,399.170000,399.170000,NULL),(6553,3,1,NULL,399.170000,399.170000,399.170000,399.170000,NULL),(6554,0,1,NULL,333.330000,333.330000,333.330000,333.330000,NULL),(6554,1,1,NULL,333.330000,333.330000,333.330000,333.330000,NULL),(6554,2,1,NULL,333.330000,333.330000,333.330000,333.330000,NULL),(6554,3,1,NULL,333.330000,333.330000,333.330000,333.330000,NULL),(6555,0,1,NULL,399.170000,399.170000,399.170000,399.170000,NULL),(6555,1,1,NULL,399.170000,399.170000,399.170000,399.170000,NULL),(6555,2,1,NULL,399.170000,399.170000,399.170000,399.170000,NULL),(6555,3,1,NULL,399.170000,399.170000,399.170000,399.170000,NULL),(6556,0,1,NULL,425.000000,425.000000,425.000000,425.000000,NULL),(6556,1,1,NULL,425.000000,425.000000,425.000000,425.000000,NULL),(6556,2,1,NULL,425.000000,425.000000,425.000000,425.000000,NULL),(6556,3,1,NULL,425.000000,425.000000,425.000000,425.000000,NULL),(6557,0,1,NULL,632.500000,632.500000,632.500000,632.500000,NULL),(6557,1,1,NULL,632.500000,632.500000,632.500000,632.500000,NULL),(6557,2,1,NULL,632.500000,632.500000,632.500000,632.500000,NULL),(6557,3,1,NULL,632.500000,632.500000,632.500000,632.500000,NULL),(6558,0,1,NULL,225.830000,225.830000,225.830000,225.830000,NULL),(6558,1,1,NULL,225.830000,225.830000,225.830000,225.830000,NULL),(6558,2,1,NULL,225.830000,225.830000,225.830000,225.830000,NULL),(6558,3,1,NULL,225.830000,225.830000,225.830000,225.830000,NULL),(6559,0,1,NULL,225.830000,225.830000,225.830000,225.830000,NULL),(6559,1,1,NULL,225.830000,225.830000,225.830000,225.830000,NULL),(6559,2,1,NULL,225.830000,225.830000,225.830000,225.830000,NULL),(6559,3,1,NULL,225.830000,225.830000,225.830000,225.830000,NULL),(6560,0,1,NULL,225.830000,225.830000,225.830000,225.830000,NULL),(6560,1,1,NULL,225.830000,225.830000,225.830000,225.830000,NULL),(6560,2,1,NULL,225.830000,225.830000,225.830000,225.830000,NULL),(6560,3,1,NULL,225.830000,225.830000,225.830000,225.830000,NULL),(6561,0,1,NULL,225.830000,225.830000,225.830000,225.830000,NULL),(6561,1,1,NULL,225.830000,225.830000,225.830000,225.830000,NULL),(6561,2,1,NULL,225.830000,225.830000,225.830000,225.830000,NULL),(6561,3,1,NULL,225.830000,225.830000,225.830000,225.830000,NULL),(6562,0,1,NULL,309.170000,309.170000,309.170000,309.170000,NULL),(6562,1,1,NULL,309.170000,309.170000,309.170000,309.170000,NULL),(6562,2,1,NULL,309.170000,309.170000,309.170000,309.170000,NULL),(6562,3,1,NULL,309.170000,309.170000,309.170000,309.170000,NULL),(6563,0,1,NULL,3608.330000,3608.330000,3608.330000,3608.330000,NULL),(6563,1,1,NULL,3608.330000,3608.330000,3608.330000,3608.330000,NULL),(6563,2,1,NULL,3608.330000,3608.330000,3608.330000,3608.330000,NULL),(6563,3,1,NULL,3608.330000,3608.330000,3608.330000,3608.330000,NULL),(6564,0,1,NULL,444.170000,266.500000,266.500000,266.500000,NULL),(6564,1,1,NULL,444.170000,266.500000,266.500000,266.500000,NULL),(6564,2,1,NULL,444.170000,266.500000,266.500000,266.500000,NULL),(6564,3,1,NULL,444.170000,266.500000,266.500000,266.500000,NULL),(6565,0,1,NULL,444.170000,266.500000,266.500000,266.500000,NULL),(6565,1,1,NULL,444.170000,266.500000,266.500000,266.500000,NULL),(6565,2,1,NULL,444.170000,266.500000,266.500000,266.500000,NULL),(6565,3,1,NULL,444.170000,266.500000,266.500000,266.500000,NULL),(6566,0,1,NULL,444.170000,266.500000,266.500000,266.500000,NULL),(6566,1,1,NULL,444.170000,266.500000,266.500000,266.500000,NULL),(6566,2,1,NULL,444.170000,266.500000,266.500000,266.500000,NULL),(6566,3,1,NULL,444.170000,266.500000,266.500000,266.500000,NULL),(6567,0,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6567,1,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6567,2,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6567,3,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6568,0,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6568,1,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6568,2,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6568,3,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6569,0,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6569,1,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6569,2,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6569,3,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6570,0,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6570,1,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6570,2,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6570,3,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6571,0,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6571,1,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6571,2,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6571,3,1,NULL,421.670000,253.000000,253.000000,253.000000,NULL),(6572,0,1,NULL,783.000000,524.610000,524.610000,524.610000,NULL),(6572,1,1,NULL,783.000000,524.610000,524.610000,524.610000,NULL),(6572,2,1,NULL,783.000000,524.610000,524.610000,524.610000,NULL),(6572,3,1,NULL,783.000000,524.610000,524.610000,524.610000,NULL);
/*!40000 ALTER TABLE `catalog_product_index_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_bundle_idx`
--

DROP TABLE IF EXISTS `catalog_product_index_price_bundle_idx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_bundle_idx` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int NOT NULL,
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `tax_class_id` smallint unsigned DEFAULT '0' COMMENT 'Tax Class ID',
  `price_type` smallint unsigned NOT NULL COMMENT 'Price Type',
  `special_price` decimal(20,6) DEFAULT NULL COMMENT 'Special Price',
  `tier_percent` decimal(20,6) DEFAULT NULL COMMENT 'Tier Percent',
  `orig_price` decimal(20,6) DEFAULT NULL COMMENT 'Orig Price',
  `price` decimal(20,6) DEFAULT NULL COMMENT 'Price',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(20,6) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  `base_tier` decimal(20,6) DEFAULT NULL COMMENT 'Base Tier',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Index Price Bundle Idx';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_bundle_idx`
--

LOCK TABLES `catalog_product_index_price_bundle_idx` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_bundle_idx` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_bundle_idx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_bundle_opt_idx`
--

DROP TABLE IF EXISTS `catalog_product_index_price_bundle_opt_idx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_bundle_opt_idx` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int NOT NULL,
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `option_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  `alt_price` decimal(20,6) DEFAULT NULL COMMENT 'Alt Price',
  `max_price` decimal(20,6) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  `alt_tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Alt Tier Price',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`,`option_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Index Price Bundle Opt Idx';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_bundle_opt_idx`
--

LOCK TABLES `catalog_product_index_price_bundle_opt_idx` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_bundle_opt_idx` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_bundle_opt_idx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_bundle_opt_tmp`
--

DROP TABLE IF EXISTS `catalog_product_index_price_bundle_opt_tmp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_bundle_opt_tmp` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int NOT NULL,
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `option_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  `alt_price` decimal(20,6) DEFAULT NULL COMMENT 'Alt Price',
  `max_price` decimal(20,6) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  `alt_tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Alt Tier Price',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`,`option_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Index Price Bundle Opt Tmp';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_bundle_opt_tmp`
--

LOCK TABLES `catalog_product_index_price_bundle_opt_tmp` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_bundle_opt_tmp` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_bundle_opt_tmp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_bundle_sel_idx`
--

DROP TABLE IF EXISTS `catalog_product_index_price_bundle_sel_idx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_bundle_sel_idx` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int NOT NULL,
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `option_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `selection_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Selection ID',
  `group_type` smallint unsigned DEFAULT '0' COMMENT 'Group Type',
  `is_required` smallint unsigned DEFAULT '0' COMMENT 'Is Required',
  `price` decimal(20,6) DEFAULT NULL COMMENT 'Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`,`option_id`,`selection_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Index Price Bundle Sel Idx';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_bundle_sel_idx`
--

LOCK TABLES `catalog_product_index_price_bundle_sel_idx` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_bundle_sel_idx` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_bundle_sel_idx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_bundle_sel_tmp`
--

DROP TABLE IF EXISTS `catalog_product_index_price_bundle_sel_tmp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_bundle_sel_tmp` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int NOT NULL,
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `option_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `selection_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Selection ID',
  `group_type` smallint unsigned DEFAULT '0' COMMENT 'Group Type',
  `is_required` smallint unsigned DEFAULT '0' COMMENT 'Is Required',
  `price` decimal(20,6) DEFAULT NULL COMMENT 'Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`,`option_id`,`selection_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Index Price Bundle Sel Tmp';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_bundle_sel_tmp`
--

LOCK TABLES `catalog_product_index_price_bundle_sel_tmp` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_bundle_sel_tmp` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_bundle_sel_tmp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_bundle_tmp`
--

DROP TABLE IF EXISTS `catalog_product_index_price_bundle_tmp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_bundle_tmp` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int NOT NULL,
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `tax_class_id` smallint unsigned DEFAULT '0' COMMENT 'Tax Class ID',
  `price_type` smallint unsigned NOT NULL COMMENT 'Price Type',
  `special_price` decimal(20,6) DEFAULT NULL COMMENT 'Special Price',
  `tier_percent` decimal(20,6) DEFAULT NULL COMMENT 'Tier Percent',
  `orig_price` decimal(20,6) DEFAULT NULL COMMENT 'Orig Price',
  `price` decimal(20,6) DEFAULT NULL COMMENT 'Price',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(20,6) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  `base_tier` decimal(20,6) DEFAULT NULL COMMENT 'Base Tier',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Index Price Bundle Tmp';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_bundle_tmp`
--

LOCK TABLES `catalog_product_index_price_bundle_tmp` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_bundle_tmp` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_bundle_tmp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_cfg_opt_agr_idx`
--

DROP TABLE IF EXISTS `catalog_product_index_price_cfg_opt_agr_idx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_cfg_opt_agr_idx` (
  `parent_id` int unsigned NOT NULL COMMENT 'Parent ID',
  `child_id` int unsigned NOT NULL COMMENT 'Child ID',
  `customer_group_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `price` decimal(20,6) DEFAULT NULL COMMENT 'Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  PRIMARY KEY (`parent_id`,`child_id`,`customer_group_id`,`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Price Indexer Config Option Aggregate Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_cfg_opt_agr_idx`
--

LOCK TABLES `catalog_product_index_price_cfg_opt_agr_idx` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_cfg_opt_agr_idx` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_cfg_opt_agr_idx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_cfg_opt_agr_tmp`
--

DROP TABLE IF EXISTS `catalog_product_index_price_cfg_opt_agr_tmp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_cfg_opt_agr_tmp` (
  `parent_id` int unsigned NOT NULL COMMENT 'Parent ID',
  `child_id` int unsigned NOT NULL COMMENT 'Child ID',
  `customer_group_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `price` decimal(20,6) DEFAULT NULL COMMENT 'Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  PRIMARY KEY (`parent_id`,`child_id`,`customer_group_id`,`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Price Indexer Config Option Aggregate Temp Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_cfg_opt_agr_tmp`
--

LOCK TABLES `catalog_product_index_price_cfg_opt_agr_tmp` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_cfg_opt_agr_tmp` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_cfg_opt_agr_tmp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_cfg_opt_idx`
--

DROP TABLE IF EXISTS `catalog_product_index_price_cfg_opt_idx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_cfg_opt_idx` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(20,6) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Price Indexer Config Option Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_cfg_opt_idx`
--

LOCK TABLES `catalog_product_index_price_cfg_opt_idx` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_cfg_opt_idx` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_cfg_opt_idx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_cfg_opt_tmp`
--

DROP TABLE IF EXISTS `catalog_product_index_price_cfg_opt_tmp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_cfg_opt_tmp` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(20,6) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Price Indexer Config Option Temp Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_cfg_opt_tmp`
--

LOCK TABLES `catalog_product_index_price_cfg_opt_tmp` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_cfg_opt_tmp` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_cfg_opt_tmp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_downlod_idx`
--

DROP TABLE IF EXISTS `catalog_product_index_price_downlod_idx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_downlod_idx` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int NOT NULL,
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `min_price` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Minimum price',
  `max_price` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Maximum price',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Indexer Table for price of downloadable products';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_downlod_idx`
--

LOCK TABLES `catalog_product_index_price_downlod_idx` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_downlod_idx` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_downlod_idx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_downlod_tmp`
--

DROP TABLE IF EXISTS `catalog_product_index_price_downlod_tmp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_downlod_tmp` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int NOT NULL,
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `min_price` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Minimum price',
  `max_price` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Maximum price',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Temporary Indexer Table for price of downloadable products';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_downlod_tmp`
--

LOCK TABLES `catalog_product_index_price_downlod_tmp` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_downlod_tmp` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_downlod_tmp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_final_idx`
--

DROP TABLE IF EXISTS `catalog_product_index_price_final_idx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_final_idx` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `tax_class_id` smallint unsigned DEFAULT '0' COMMENT 'Tax Class ID',
  `orig_price` decimal(20,6) DEFAULT NULL COMMENT 'Original Price',
  `price` decimal(20,6) DEFAULT NULL COMMENT 'Price',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(20,6) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  `base_tier` decimal(20,6) DEFAULT NULL COMMENT 'Base Tier',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Price Indexer Final Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_final_idx`
--

LOCK TABLES `catalog_product_index_price_final_idx` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_final_idx` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_final_idx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_final_tmp`
--

DROP TABLE IF EXISTS `catalog_product_index_price_final_tmp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_final_tmp` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `tax_class_id` smallint unsigned DEFAULT '0' COMMENT 'Tax Class ID',
  `orig_price` decimal(20,6) DEFAULT NULL COMMENT 'Original Price',
  `price` decimal(20,6) DEFAULT NULL COMMENT 'Price',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(20,6) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  `base_tier` decimal(20,6) DEFAULT NULL COMMENT 'Base Tier',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Price Indexer Final Temp Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_final_tmp`
--

LOCK TABLES `catalog_product_index_price_final_tmp` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_final_tmp` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_final_tmp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_idx`
--

DROP TABLE IF EXISTS `catalog_product_index_price_idx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_idx` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `tax_class_id` smallint unsigned DEFAULT '0' COMMENT 'Tax Class ID',
  `price` decimal(20,6) DEFAULT NULL COMMENT 'Price',
  `final_price` decimal(20,6) DEFAULT NULL COMMENT 'Final Price',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(20,6) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`),
  KEY `CATALOG_PRODUCT_INDEX_PRICE_IDX_CUSTOMER_GROUP_ID` (`customer_group_id`),
  KEY `CATALOG_PRODUCT_INDEX_PRICE_IDX_WEBSITE_ID` (`website_id`),
  KEY `CATALOG_PRODUCT_INDEX_PRICE_IDX_MIN_PRICE` (`min_price`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Price Indexer Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_idx`
--

LOCK TABLES `catalog_product_index_price_idx` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_idx` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_idx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_opt_agr_idx`
--

DROP TABLE IF EXISTS `catalog_product_index_price_opt_agr_idx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_opt_agr_idx` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `option_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(20,6) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`,`option_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Price Indexer Option Aggregate Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_opt_agr_idx`
--

LOCK TABLES `catalog_product_index_price_opt_agr_idx` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_opt_agr_idx` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_opt_agr_idx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_opt_agr_tmp`
--

DROP TABLE IF EXISTS `catalog_product_index_price_opt_agr_tmp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_opt_agr_tmp` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `option_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(20,6) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`,`option_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Price Indexer Option Aggregate Temp Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_opt_agr_tmp`
--

LOCK TABLES `catalog_product_index_price_opt_agr_tmp` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_opt_agr_tmp` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_opt_agr_tmp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_opt_idx`
--

DROP TABLE IF EXISTS `catalog_product_index_price_opt_idx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_opt_idx` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(20,6) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Price Indexer Option Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_opt_idx`
--

LOCK TABLES `catalog_product_index_price_opt_idx` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_opt_idx` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_opt_idx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_opt_tmp`
--

DROP TABLE IF EXISTS `catalog_product_index_price_opt_tmp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_opt_tmp` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(20,6) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Price Indexer Option Temp Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_opt_tmp`
--

LOCK TABLES `catalog_product_index_price_opt_tmp` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_opt_tmp` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_opt_tmp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_replica`
--

DROP TABLE IF EXISTS `catalog_product_index_price_replica`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_replica` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `tax_class_id` smallint unsigned DEFAULT '0' COMMENT 'Tax Class ID',
  `price` decimal(20,6) DEFAULT NULL COMMENT 'Price',
  `final_price` decimal(20,6) DEFAULT NULL COMMENT 'Final Price',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(20,6) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`),
  KEY `CATALOG_PRODUCT_INDEX_PRICE_CUSTOMER_GROUP_ID` (`customer_group_id`),
  KEY `CATALOG_PRODUCT_INDEX_PRICE_MIN_PRICE` (`min_price`),
  KEY `CAT_PRD_IDX_PRICE_WS_ID_CSTR_GROUP_ID_MIN_PRICE` (`website_id`,`customer_group_id`,`min_price`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Price Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_replica`
--

LOCK TABLES `catalog_product_index_price_replica` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_replica` DISABLE KEYS */;
INSERT INTO `catalog_product_index_price_replica` VALUES (5760,0,1,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,0,2,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,0,3,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,0,4,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,1,1,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,1,2,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,1,3,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,1,4,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,2,1,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,2,2,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,2,3,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,2,4,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,3,1,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,3,2,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,3,3,0,0.010000,0.010000,0.010000,0.010000,NULL),(5760,3,4,0,0.010000,0.010000,0.010000,0.010000,NULL),(6035,0,1,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,0,2,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,0,3,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,0,4,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,1,1,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,1,2,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,1,3,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,1,4,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,2,1,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,2,2,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,2,3,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,2,4,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,3,1,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,3,2,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,3,3,0,348.000000,278.400000,278.400000,278.400000,NULL),(6035,3,4,0,348.000000,278.400000,278.400000,278.400000,NULL),(6036,0,1,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,0,2,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,0,3,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,0,4,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,1,1,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,1,2,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,1,3,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,1,4,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,2,1,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,2,2,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,2,3,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,2,4,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,3,1,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,3,2,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,3,3,0,408.000000,326.400000,326.400000,326.400000,NULL),(6036,3,4,0,408.000000,326.400000,326.400000,326.400000,NULL),(6037,0,1,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,0,2,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,0,3,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,0,4,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,1,1,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,1,2,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,1,3,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,1,4,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,2,1,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,2,2,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,2,3,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,2,4,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,3,1,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,3,2,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,3,3,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6037,3,4,NULL,489.000000,391.200000,391.200000,391.200000,NULL),(6038,0,1,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,0,2,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,0,3,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,0,4,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,1,1,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,1,2,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,1,3,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,1,4,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,2,1,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,2,2,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,2,3,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,2,4,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,3,1,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,3,2,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,3,3,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6038,3,4,NULL,550.000000,440.000000,440.000000,440.000000,NULL),(6039,0,1,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,0,2,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,0,3,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,0,4,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,1,1,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,1,2,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,1,3,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,1,4,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,2,1,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,2,2,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,2,3,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,2,4,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,3,1,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,3,2,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,3,3,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6039,3,4,NULL,664.000000,531.200000,531.200000,531.200000,NULL),(6040,0,1,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,0,2,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,0,3,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,0,4,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,1,1,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,1,2,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,1,3,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,1,4,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,2,1,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,2,2,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,2,3,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,2,4,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,3,1,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,3,2,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,3,3,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6040,3,4,NULL,464.166667,371.333333,371.333333,371.333333,NULL),(6041,0,1,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,0,2,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,0,3,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,0,4,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,1,1,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,1,2,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,1,3,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,1,4,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,2,1,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,2,2,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,2,3,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,2,4,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,3,1,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,3,2,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,3,3,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6041,3,4,NULL,128.000000,90.466667,90.466667,90.466667,NULL),(6042,0,1,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,0,2,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,0,3,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,0,4,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,1,1,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,1,2,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,1,3,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,1,4,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,2,1,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,2,2,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,2,3,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,2,4,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,3,1,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,3,2,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,3,3,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6042,3,4,NULL,138.000000,98.380000,98.380000,98.380000,NULL),(6043,0,1,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,0,2,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,0,3,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,0,4,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,1,1,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,1,2,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,1,3,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,1,4,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,2,1,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,2,2,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,2,3,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,2,4,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,3,1,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,3,2,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,3,3,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6043,3,4,NULL,228.000000,154.666667,154.666667,154.666667,NULL),(6044,0,1,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,0,2,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,0,3,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,0,4,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,1,1,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,1,2,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,1,3,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,1,4,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,2,1,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,2,2,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,2,3,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,2,4,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,3,1,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,3,2,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,3,3,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6044,3,4,NULL,248.000000,167.875000,167.875000,167.875000,NULL),(6045,0,1,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,0,2,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,0,3,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,0,4,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,1,1,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,1,2,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,1,3,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,1,4,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,2,1,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,2,2,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,2,3,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,2,4,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,3,1,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,3,2,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,3,3,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6045,3,4,NULL,148.000000,104.991667,104.991667,104.991667,NULL),(6046,0,1,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,0,2,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,0,3,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,0,4,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,1,1,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,1,2,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,1,3,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,1,4,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,2,1,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,2,2,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,2,3,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,2,4,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,3,1,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,3,2,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,3,3,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6046,3,4,NULL,168.000000,117.600000,117.600000,117.600000,NULL),(6047,0,1,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,0,2,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,0,3,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,0,4,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,1,1,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,1,2,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,1,3,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,1,4,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,2,1,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,2,2,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,2,3,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,2,4,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,3,1,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,3,2,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,3,3,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6047,3,4,NULL,188.000000,134.166667,134.166667,134.166667,NULL),(6048,0,1,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,0,2,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,0,3,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,0,4,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,1,1,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,1,2,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,1,3,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,1,4,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,2,1,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,2,2,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,2,3,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,2,4,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,3,1,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,3,2,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,3,3,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6048,3,4,NULL,278.000000,183.875000,183.875000,183.875000,NULL),(6049,0,1,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,0,2,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,0,3,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,0,4,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,1,1,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,1,2,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,1,3,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,1,4,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,2,1,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,2,2,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,2,3,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,2,4,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,3,1,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,3,2,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,3,3,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6049,3,4,NULL,328.000000,221.666667,221.666667,221.666667,NULL),(6050,0,1,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,0,2,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,0,3,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,0,4,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,1,1,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,1,2,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,1,3,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,1,4,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,2,1,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,2,2,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,2,3,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,2,4,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,3,1,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,3,2,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,3,3,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6050,3,4,NULL,398.000000,260.133333,260.133333,260.133333,NULL),(6051,0,1,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,0,2,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,0,3,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,0,4,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,1,1,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,1,2,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,1,3,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,1,4,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,2,1,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,2,2,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,2,3,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,2,4,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,3,1,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,3,2,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,3,3,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6051,3,4,NULL,358.000000,234.800000,234.800000,234.800000,NULL),(6052,0,1,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,0,2,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,0,3,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,0,4,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,1,1,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,1,2,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,1,3,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,1,4,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,2,1,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,2,2,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,2,3,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,2,4,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,3,1,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,3,2,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,3,3,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6052,3,4,NULL,298.000000,196.658333,196.658333,196.658333,NULL),(6053,0,1,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,0,2,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,0,3,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,0,4,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,1,1,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,1,2,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,1,3,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,1,4,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,2,1,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,2,2,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,2,3,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,2,4,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,3,1,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,3,2,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,3,3,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6053,3,4,NULL,338.000000,226.780000,226.780000,226.780000,NULL),(6054,0,1,NULL,198.000000,152.540000,152.540000,152.540000,NULL),(6054,1,1,NULL,198.000000,152.540000,152.540000,152.540000,NULL),(6054,2,1,NULL,198.000000,152.540000,152.540000,152.540000,NULL),(6054,3,1,NULL,198.000000,152.540000,152.540000,152.540000,NULL),(6055,0,1,NULL,448.000000,309.291667,309.291667,309.291667,NULL),(6055,1,1,NULL,448.000000,309.291667,309.291667,309.291667,NULL),(6055,2,1,NULL,448.000000,309.291667,309.291667,309.291667,NULL),(6055,3,1,NULL,448.000000,309.291667,309.291667,309.291667,NULL),(6056,0,1,NULL,198.000000,138.600000,138.600000,138.600000,NULL),(6056,1,1,NULL,198.000000,138.600000,138.600000,138.600000,NULL),(6056,2,1,NULL,198.000000,138.600000,138.600000,138.600000,NULL),(6056,3,1,NULL,198.000000,138.600000,138.600000,138.600000,NULL),(6057,0,1,NULL,308.000000,215.833333,215.833333,215.833333,NULL),(6057,1,1,NULL,308.000000,215.833333,215.833333,215.833333,NULL),(6057,2,1,NULL,308.000000,215.833333,215.833333,215.833333,NULL),(6057,3,1,NULL,308.000000,215.833333,215.833333,215.833333,NULL),(6058,0,1,NULL,698.000000,443.000000,443.000000,443.000000,NULL),(6058,1,1,NULL,698.000000,443.000000,443.000000,443.000000,NULL),(6058,2,1,NULL,698.000000,443.000000,443.000000,443.000000,NULL),(6058,3,1,NULL,698.000000,443.000000,443.000000,443.000000,NULL),(6059,0,1,NULL,848.000000,530.825000,530.825000,530.825000,NULL),(6059,1,1,NULL,848.000000,530.825000,530.825000,530.825000,NULL),(6059,2,1,NULL,848.000000,530.825000,530.825000,530.825000,NULL),(6059,3,1,NULL,848.000000,530.825000,530.825000,530.825000,NULL),(6060,0,1,NULL,538.000000,352.500000,352.500000,352.500000,NULL),(6060,1,1,NULL,538.000000,352.500000,352.500000,352.500000,NULL),(6060,2,1,NULL,538.000000,352.500000,352.500000,352.500000,NULL),(6060,3,1,NULL,538.000000,352.500000,352.500000,352.500000,NULL),(6061,0,1,NULL,598.000000,385.000000,385.000000,385.000000,NULL),(6061,1,1,NULL,598.000000,385.000000,385.000000,385.000000,NULL),(6061,2,1,NULL,598.000000,385.000000,385.000000,385.000000,NULL),(6061,3,1,NULL,598.000000,385.000000,385.000000,385.000000,NULL),(6062,0,1,NULL,628.000000,398.491667,398.491667,398.491667,NULL),(6062,1,1,NULL,628.000000,398.491667,398.491667,398.491667,NULL),(6062,2,1,NULL,628.000000,398.491667,398.491667,398.491667,NULL),(6062,3,1,NULL,628.000000,398.491667,398.491667,398.491667,NULL),(6063,0,1,NULL,638.000000,413.333333,413.333333,413.333333,NULL),(6063,1,1,NULL,638.000000,413.333333,413.333333,413.333333,NULL),(6063,2,1,NULL,638.000000,413.333333,413.333333,413.333333,NULL),(6063,3,1,NULL,638.000000,413.333333,413.333333,413.333333,NULL),(6064,0,1,NULL,738.000000,516.600000,516.600000,516.600000,NULL),(6064,1,1,NULL,738.000000,516.600000,516.600000,516.600000,NULL),(6064,2,1,NULL,738.000000,516.600000,516.600000,516.600000,NULL),(6064,3,1,NULL,738.000000,516.600000,516.600000,516.600000,NULL),(6065,0,1,NULL,648.000000,417.741667,417.741667,417.741667,NULL),(6065,1,1,NULL,648.000000,417.741667,417.741667,417.741667,NULL),(6065,2,1,NULL,648.000000,417.741667,417.741667,417.741667,NULL),(6065,3,1,NULL,648.000000,417.741667,417.741667,417.741667,NULL),(6066,0,1,NULL,798.000000,518.333333,518.333333,518.333333,NULL),(6066,1,1,NULL,798.000000,518.333333,518.333333,518.333333,NULL),(6066,2,1,NULL,798.000000,518.333333,518.333333,518.333333,NULL),(6066,3,1,NULL,798.000000,518.333333,518.333333,518.333333,NULL),(6067,0,1,NULL,738.000000,476.666667,476.666667,476.666667,NULL),(6067,1,1,NULL,738.000000,476.666667,476.666667,476.666667,NULL),(6067,2,1,NULL,738.000000,476.666667,476.666667,476.666667,NULL),(6067,3,1,NULL,738.000000,476.666667,476.666667,476.666667,NULL),(6068,0,1,NULL,568.000000,397.600000,397.600000,397.600000,NULL),(6068,1,1,NULL,568.000000,397.600000,397.600000,397.600000,NULL),(6068,2,1,NULL,568.000000,397.600000,397.600000,397.600000,NULL),(6068,3,1,NULL,568.000000,397.600000,397.600000,397.600000,NULL),(6069,0,1,NULL,598.000000,389.241667,389.241667,389.241667,NULL),(6069,1,1,NULL,598.000000,389.241667,389.241667,389.241667,NULL),(6069,2,1,NULL,598.000000,389.241667,389.241667,389.241667,NULL),(6069,3,1,NULL,598.000000,389.241667,389.241667,389.241667,NULL),(6070,0,1,NULL,678.000000,451.666667,451.666667,451.666667,NULL),(6070,1,1,NULL,678.000000,451.666667,451.666667,451.666667,NULL),(6070,2,1,NULL,678.000000,451.666667,451.666667,451.666667,NULL),(6070,3,1,NULL,678.000000,451.666667,451.666667,451.666667,NULL),(6071,0,1,NULL,1198.000000,802.630000,802.630000,802.630000,NULL),(6071,1,1,NULL,1198.000000,802.630000,802.630000,802.630000,NULL),(6071,2,1,NULL,1198.000000,802.630000,802.630000,802.630000,NULL),(6071,3,1,NULL,1198.000000,802.630000,802.630000,802.630000,NULL),(6072,0,1,NULL,698.000000,461.800000,461.800000,461.800000,NULL),(6072,1,1,NULL,698.000000,461.800000,461.800000,461.800000,NULL),(6072,2,1,NULL,698.000000,461.800000,461.800000,461.800000,NULL),(6072,3,1,NULL,698.000000,461.800000,461.800000,461.800000,NULL),(6073,0,1,NULL,598.000000,405.833333,405.833333,405.833333,NULL),(6073,1,1,NULL,598.000000,405.833333,405.833333,405.833333,NULL),(6073,2,1,NULL,598.000000,405.833333,405.833333,405.833333,NULL),(6073,3,1,NULL,598.000000,405.833333,405.833333,405.833333,NULL),(6074,0,1,NULL,598.000000,404.166667,404.166667,404.166667,NULL),(6074,1,1,NULL,598.000000,404.166667,404.166667,404.166667,NULL),(6074,2,1,NULL,598.000000,404.166667,404.166667,404.166667,NULL),(6074,3,1,NULL,598.000000,404.166667,404.166667,404.166667,NULL),(6075,0,1,NULL,578.000000,412.325000,412.325000,412.325000,NULL),(6075,1,1,NULL,578.000000,412.325000,412.325000,412.325000,NULL),(6075,2,1,NULL,578.000000,412.325000,412.325000,412.325000,NULL),(6075,3,1,NULL,578.000000,412.325000,412.325000,412.325000,NULL),(6076,0,1,NULL,368.000000,251.666667,251.666667,251.666667,NULL),(6076,1,1,NULL,368.000000,251.666667,251.666667,251.666667,NULL),(6076,2,1,NULL,368.000000,251.666667,251.666667,251.666667,NULL),(6076,3,1,NULL,368.000000,251.666667,251.666667,251.666667,NULL),(6077,0,1,NULL,328.000000,226.666667,226.666667,226.666667,NULL),(6077,1,1,NULL,328.000000,226.666667,226.666667,226.666667,NULL),(6077,2,1,NULL,328.000000,226.666667,226.666667,226.666667,NULL),(6077,3,1,NULL,328.000000,226.666667,226.666667,226.666667,NULL),(6078,0,1,NULL,458.000000,296.666667,296.666667,296.666667,NULL),(6078,1,1,NULL,458.000000,296.666667,296.666667,296.666667,NULL),(6078,2,1,NULL,458.000000,296.666667,296.666667,296.666667,NULL),(6078,3,1,NULL,458.000000,296.666667,296.666667,296.666667,NULL),(6079,0,1,NULL,408.000000,276.666667,276.666667,276.666667,NULL),(6079,1,1,NULL,408.000000,276.666667,276.666667,276.666667,NULL),(6079,2,1,NULL,408.000000,276.666667,276.666667,276.666667,NULL),(6079,3,1,NULL,408.000000,276.666667,276.666667,276.666667,NULL),(6080,0,1,NULL,478.000000,318.333333,318.333333,318.333333,NULL),(6080,1,1,NULL,478.000000,318.333333,318.333333,318.333333,NULL),(6080,2,1,NULL,478.000000,318.333333,318.333333,318.333333,NULL),(6080,3,1,NULL,478.000000,318.333333,318.333333,318.333333,NULL),(6081,0,1,NULL,428.000000,288.333333,288.333333,288.333333,NULL),(6081,1,1,NULL,428.000000,288.333333,288.333333,288.333333,NULL),(6081,2,1,NULL,428.000000,288.333333,288.333333,288.333333,NULL),(6081,3,1,NULL,428.000000,288.333333,288.333333,288.333333,NULL),(6082,0,1,NULL,488.000000,312.908333,312.908333,312.908333,NULL),(6082,1,1,NULL,488.000000,312.908333,312.908333,312.908333,NULL),(6082,2,1,NULL,488.000000,312.908333,312.908333,312.908333,NULL),(6082,3,1,NULL,488.000000,312.908333,312.908333,312.908333,NULL),(6083,0,1,NULL,448.000000,301.666667,301.666667,301.666667,NULL),(6083,1,1,NULL,448.000000,301.666667,301.666667,301.666667,NULL),(6083,2,1,NULL,448.000000,301.666667,301.666667,301.666667,NULL),(6083,3,1,NULL,448.000000,301.666667,301.666667,301.666667,NULL),(6084,0,1,NULL,498.000000,321.666667,321.666667,321.666667,NULL),(6084,1,1,NULL,498.000000,321.666667,321.666667,321.666667,NULL),(6084,2,1,NULL,498.000000,321.666667,321.666667,321.666667,NULL),(6084,3,1,NULL,498.000000,321.666667,321.666667,321.666667,NULL),(6085,0,1,NULL,458.000000,320.600000,320.600000,320.600000,NULL),(6085,1,1,NULL,458.000000,320.600000,320.600000,320.600000,NULL),(6085,2,1,NULL,458.000000,320.600000,320.600000,320.600000,NULL),(6085,3,1,NULL,458.000000,320.600000,320.600000,320.600000,NULL),(6086,0,1,NULL,598.000000,388.333333,388.333333,388.333333,NULL),(6086,1,1,NULL,598.000000,388.333333,388.333333,388.333333,NULL),(6086,2,1,NULL,598.000000,388.333333,388.333333,388.333333,NULL),(6086,3,1,NULL,598.000000,388.333333,388.333333,388.333333,NULL),(6087,0,1,NULL,548.000000,374.991667,374.991667,374.991667,NULL),(6087,1,1,NULL,548.000000,374.991667,374.991667,374.991667,NULL),(6087,2,1,NULL,548.000000,374.991667,374.991667,374.991667,NULL),(6087,3,1,NULL,548.000000,374.991667,374.991667,374.991667,NULL),(6088,0,1,NULL,688.000000,460.960000,460.960000,460.960000,NULL),(6088,1,1,NULL,688.000000,460.960000,460.960000,460.960000,NULL),(6088,2,1,NULL,688.000000,460.960000,460.960000,460.960000,NULL),(6088,3,1,NULL,688.000000,460.960000,460.960000,460.960000,NULL),(6089,0,1,NULL,958.000000,605.000000,605.000000,605.000000,NULL),(6089,1,1,NULL,958.000000,605.000000,605.000000,605.000000,NULL),(6089,2,1,NULL,958.000000,605.000000,605.000000,605.000000,NULL),(6089,3,1,NULL,958.000000,605.000000,605.000000,605.000000,NULL),(6090,0,1,NULL,848.000000,568.160000,568.160000,568.160000,NULL),(6090,1,1,NULL,848.000000,568.160000,568.160000,568.160000,NULL),(6090,2,1,NULL,848.000000,568.160000,568.160000,568.160000,NULL),(6090,3,1,NULL,848.000000,568.160000,568.160000,568.160000,NULL),(6091,0,1,NULL,798.000000,558.600000,558.600000,558.600000,NULL),(6091,1,1,NULL,798.000000,558.600000,558.600000,558.600000,NULL),(6091,2,1,NULL,798.000000,558.600000,558.600000,558.600000,NULL),(6091,3,1,NULL,798.000000,558.600000,558.600000,558.600000,NULL),(6092,0,1,NULL,898.000000,619.960000,619.960000,619.960000,NULL),(6092,1,1,NULL,898.000000,619.960000,619.960000,619.960000,NULL),(6092,2,1,NULL,898.000000,619.960000,619.960000,619.960000,NULL),(6092,3,1,NULL,898.000000,619.960000,619.960000,619.960000,NULL),(6093,0,1,NULL,828.000000,555.000000,555.000000,555.000000,NULL),(6093,1,1,NULL,828.000000,555.000000,555.000000,555.000000,NULL),(6093,2,1,NULL,828.000000,555.000000,555.000000,555.000000,NULL),(6093,3,1,NULL,828.000000,555.000000,555.000000,555.000000,NULL),(6094,0,1,NULL,498.000000,320.158333,320.158333,320.158333,NULL),(6094,1,1,NULL,498.000000,320.158333,320.158333,320.158333,NULL),(6094,2,1,NULL,498.000000,320.158333,320.158333,320.158333,NULL),(6094,3,1,NULL,498.000000,320.158333,320.158333,320.158333,NULL),(6095,0,1,NULL,548.000000,368.333333,368.333333,368.333333,NULL),(6095,1,1,NULL,548.000000,368.333333,368.333333,368.333333,NULL),(6095,2,1,NULL,548.000000,368.333333,368.333333,368.333333,NULL),(6095,3,1,NULL,548.000000,368.333333,368.333333,368.333333,NULL),(6096,0,1,NULL,598.000000,403.141667,403.141667,403.141667,NULL),(6096,1,1,NULL,598.000000,403.141667,403.141667,403.141667,NULL),(6096,2,1,NULL,598.000000,403.141667,403.141667,403.141667,NULL),(6096,3,1,NULL,598.000000,403.141667,403.141667,403.141667,NULL),(6097,0,1,NULL,688.000000,473.541667,473.541667,473.541667,NULL),(6097,1,1,NULL,688.000000,473.541667,473.541667,473.541667,NULL),(6097,2,1,NULL,688.000000,473.541667,473.541667,473.541667,NULL),(6097,3,1,NULL,688.000000,473.541667,473.541667,473.541667,NULL),(6098,0,1,NULL,678.000000,435.833333,435.833333,435.833333,NULL),(6098,1,1,NULL,678.000000,435.833333,435.833333,435.833333,NULL),(6098,2,1,NULL,678.000000,435.833333,435.833333,435.833333,NULL),(6098,3,1,NULL,678.000000,435.833333,435.833333,435.833333,NULL),(6099,0,1,NULL,768.000000,509.275000,509.275000,509.275000,NULL),(6099,1,1,NULL,768.000000,509.275000,509.275000,509.275000,NULL),(6099,2,1,NULL,768.000000,509.275000,509.275000,509.275000,NULL),(6099,3,1,NULL,768.000000,509.275000,509.275000,509.275000,NULL),(6100,0,1,NULL,598.000000,409.990000,409.990000,409.990000,NULL),(6100,1,1,NULL,598.000000,409.990000,409.990000,409.990000,NULL),(6100,2,1,NULL,598.000000,409.990000,409.990000,409.990000,NULL),(6100,3,1,NULL,598.000000,409.990000,409.990000,409.990000,NULL),(6101,0,1,NULL,648.000000,423.333333,423.333333,423.333333,NULL),(6101,1,1,NULL,648.000000,423.333333,423.333333,423.333333,NULL),(6101,2,1,NULL,648.000000,423.333333,423.333333,423.333333,NULL),(6101,3,1,NULL,648.000000,423.333333,423.333333,423.333333,NULL),(6102,0,1,NULL,558.000000,380.833333,380.833333,380.833333,NULL),(6102,1,1,NULL,558.000000,380.833333,380.833333,380.833333,NULL),(6102,2,1,NULL,558.000000,380.833333,380.833333,380.833333,NULL),(6102,3,1,NULL,558.000000,380.833333,380.833333,380.833333,NULL),(6103,0,1,NULL,558.000000,368.333333,368.333333,368.333333,NULL),(6103,1,1,NULL,558.000000,368.333333,368.333333,368.333333,NULL),(6103,2,1,NULL,558.000000,368.333333,368.333333,368.333333,NULL),(6103,3,1,NULL,558.000000,368.333333,368.333333,368.333333,NULL),(6104,0,1,NULL,478.000000,318.333333,318.333333,318.333333,NULL),(6104,1,1,NULL,478.000000,318.333333,318.333333,318.333333,NULL),(6104,2,1,NULL,478.000000,318.333333,318.333333,318.333333,NULL),(6104,3,1,NULL,478.000000,318.333333,318.333333,318.333333,NULL),(6105,0,1,NULL,598.000000,396.666667,396.666667,396.666667,NULL),(6105,1,1,NULL,598.000000,396.666667,396.666667,396.666667,NULL),(6105,2,1,NULL,598.000000,396.666667,396.666667,396.666667,NULL),(6105,3,1,NULL,598.000000,396.666667,396.666667,396.666667,NULL),(6106,0,1,NULL,638.000000,413.333333,413.333333,413.333333,NULL),(6106,1,1,NULL,638.000000,413.333333,413.333333,413.333333,NULL),(6106,2,1,NULL,638.000000,413.333333,413.333333,413.333333,NULL),(6106,3,1,NULL,638.000000,413.333333,413.333333,413.333333,NULL),(6107,0,1,NULL,688.000000,443.333333,443.333333,443.333333,NULL),(6107,1,1,NULL,688.000000,443.333333,443.333333,443.333333,NULL),(6107,2,1,NULL,688.000000,443.333333,443.333333,443.333333,NULL),(6107,3,1,NULL,688.000000,443.333333,443.333333,443.333333,NULL),(6108,0,1,NULL,978.000000,635.000000,635.000000,635.000000,NULL),(6108,1,1,NULL,978.000000,635.000000,635.000000,635.000000,NULL),(6108,2,1,NULL,978.000000,635.000000,635.000000,635.000000,NULL),(6108,3,1,NULL,978.000000,635.000000,635.000000,635.000000,NULL),(6109,0,1,NULL,998.000000,647.420000,647.420000,647.420000,NULL),(6109,1,1,NULL,998.000000,647.420000,647.420000,647.420000,NULL),(6109,2,1,NULL,998.000000,647.420000,647.420000,647.420000,NULL),(6109,3,1,NULL,998.000000,647.420000,647.420000,647.420000,NULL),(6110,0,1,NULL,398.000000,271.666667,271.666667,271.666667,NULL),(6110,1,1,NULL,398.000000,271.666667,271.666667,271.666667,NULL),(6110,2,1,NULL,398.000000,271.666667,271.666667,271.666667,NULL),(6110,3,1,NULL,398.000000,271.666667,271.666667,271.666667,NULL),(6111,0,1,NULL,418.000000,292.600000,292.600000,292.600000,NULL),(6111,1,1,NULL,418.000000,292.600000,292.600000,292.600000,NULL),(6111,2,1,NULL,418.000000,292.600000,292.600000,292.600000,NULL),(6111,3,1,NULL,418.000000,292.600000,292.600000,292.600000,NULL),(6112,0,1,NULL,348.000000,249.166667,249.166667,249.166667,NULL),(6112,1,1,NULL,348.000000,249.166667,249.166667,249.166667,NULL),(6112,2,1,NULL,348.000000,249.166667,249.166667,249.166667,NULL),(6112,3,1,NULL,348.000000,249.166667,249.166667,249.166667,NULL),(6113,0,1,NULL,228.000000,153.910000,153.910000,153.910000,NULL),(6113,1,1,NULL,228.000000,153.910000,153.910000,153.910000,NULL),(6113,2,1,NULL,228.000000,153.910000,153.910000,153.910000,NULL),(6113,3,1,NULL,228.000000,153.910000,153.910000,153.910000,NULL),(6114,0,1,NULL,298.000000,211.650000,211.650000,211.650000,NULL),(6114,1,1,NULL,298.000000,211.650000,211.650000,211.650000,NULL),(6114,2,1,NULL,298.000000,211.650000,211.650000,211.650000,NULL),(6114,3,1,NULL,298.000000,211.650000,211.650000,211.650000,NULL),(6115,0,1,NULL,338.000000,225.000000,225.000000,225.000000,NULL),(6115,1,1,NULL,338.000000,225.000000,225.000000,225.000000,NULL),(6115,2,1,NULL,338.000000,225.000000,225.000000,225.000000,NULL),(6115,3,1,NULL,338.000000,225.000000,225.000000,225.000000,NULL),(6116,0,1,NULL,358.000000,250.600000,250.600000,250.600000,NULL),(6116,1,1,NULL,358.000000,250.600000,250.600000,250.600000,NULL),(6116,2,1,NULL,358.000000,250.600000,250.600000,250.600000,NULL),(6116,3,1,NULL,358.000000,250.600000,250.600000,250.600000,NULL),(6117,0,1,NULL,368.000000,246.666667,246.666667,246.666667,NULL),(6117,1,1,NULL,368.000000,246.666667,246.666667,246.666667,NULL),(6117,2,1,NULL,368.000000,246.666667,246.666667,246.666667,NULL),(6117,3,1,NULL,368.000000,246.666667,246.666667,246.666667,NULL),(6118,0,1,NULL,478.000000,321.666667,321.666667,321.666667,NULL),(6118,1,1,NULL,478.000000,321.666667,321.666667,321.666667,NULL),(6118,2,1,NULL,478.000000,321.666667,321.666667,321.666667,NULL),(6118,3,1,NULL,478.000000,321.666667,321.666667,321.666667,NULL),(6119,0,1,NULL,828.000000,561.666667,561.666667,561.666667,NULL),(6119,1,1,NULL,828.000000,561.666667,561.666667,561.666667,NULL),(6119,2,1,NULL,828.000000,561.666667,561.666667,561.666667,NULL),(6119,3,1,NULL,828.000000,561.666667,561.666667,561.666667,NULL),(6120,0,1,NULL,978.000000,659.166667,659.166667,659.166667,NULL),(6120,1,1,NULL,978.000000,659.166667,659.166667,659.166667,NULL),(6120,2,1,NULL,978.000000,659.166667,659.166667,659.166667,NULL),(6120,3,1,NULL,978.000000,659.166667,659.166667,659.166667,NULL),(6121,0,1,NULL,278.000000,185.970000,185.970000,185.970000,NULL),(6121,1,1,NULL,278.000000,185.970000,185.970000,185.970000,NULL),(6121,2,1,NULL,278.000000,185.970000,185.970000,185.970000,NULL),(6121,3,1,NULL,278.000000,185.970000,185.970000,185.970000,NULL),(6122,0,1,NULL,328.000000,233.875000,233.875000,233.875000,NULL),(6122,1,1,NULL,328.000000,233.875000,233.875000,233.875000,NULL),(6122,2,1,NULL,328.000000,233.875000,233.875000,233.875000,NULL),(6122,3,1,NULL,328.000000,233.875000,233.875000,233.875000,NULL),(6123,0,1,NULL,348.000000,243.600000,243.600000,243.600000,NULL),(6123,1,1,NULL,348.000000,243.600000,243.600000,243.600000,NULL),(6123,2,1,NULL,348.000000,243.600000,243.600000,243.600000,NULL),(6123,3,1,NULL,348.000000,243.600000,243.600000,243.600000,NULL),(6124,0,1,NULL,398.000000,277.316667,277.316667,277.316667,NULL),(6124,1,1,NULL,398.000000,277.316667,277.316667,277.316667,NULL),(6124,2,1,NULL,398.000000,277.316667,277.316667,277.316667,NULL),(6124,3,1,NULL,398.000000,277.316667,277.316667,277.316667,NULL),(6125,0,1,NULL,998.000000,673.330000,673.330000,673.330000,NULL),(6125,1,1,NULL,998.000000,673.330000,673.330000,673.330000,NULL),(6125,2,1,NULL,998.000000,673.330000,673.330000,673.330000,NULL),(6125,3,1,NULL,998.000000,673.330000,673.330000,673.330000,NULL),(6126,0,1,NULL,1298.000000,869.340000,869.340000,869.340000,NULL),(6126,1,1,NULL,1298.000000,869.340000,869.340000,869.340000,NULL),(6126,2,1,NULL,1298.000000,869.340000,869.340000,869.340000,NULL),(6126,3,1,NULL,1298.000000,869.340000,869.340000,869.340000,NULL),(6127,0,1,NULL,478.000000,315.633333,315.633333,315.633333,NULL),(6127,1,1,NULL,478.000000,315.633333,315.633333,315.633333,NULL),(6127,2,1,NULL,478.000000,315.633333,315.633333,315.633333,NULL),(6127,3,1,NULL,478.000000,315.633333,315.633333,315.633333,NULL),(6128,0,1,NULL,548.000000,383.466667,383.466667,383.466667,NULL),(6128,1,1,NULL,548.000000,383.466667,383.466667,383.466667,NULL),(6128,2,1,NULL,548.000000,383.466667,383.466667,383.466667,NULL),(6128,3,1,NULL,548.000000,383.466667,383.466667,383.466667,NULL),(6129,0,1,NULL,518.000000,365.830000,365.830000,365.830000,NULL),(6129,1,1,NULL,518.000000,365.830000,365.830000,365.830000,NULL),(6129,2,1,NULL,518.000000,365.830000,365.830000,365.830000,NULL),(6129,3,1,NULL,518.000000,365.830000,365.830000,365.830000,NULL),(6130,0,1,NULL,270.000000,216.000000,216.000000,216.000000,NULL),(6130,1,1,NULL,270.000000,216.000000,216.000000,216.000000,NULL),(6130,2,1,NULL,270.000000,216.000000,216.000000,216.000000,NULL),(6130,3,1,NULL,270.000000,216.000000,216.000000,216.000000,NULL),(6131,0,1,NULL,183.000000,146.400000,146.400000,146.400000,NULL),(6131,1,1,NULL,183.000000,146.400000,146.400000,146.400000,NULL),(6131,2,1,NULL,183.000000,146.400000,146.400000,146.400000,NULL),(6131,3,1,NULL,183.000000,146.400000,146.400000,146.400000,NULL),(6132,0,1,NULL,198.000000,158.400000,158.400000,158.400000,NULL),(6132,1,1,NULL,198.000000,158.400000,158.400000,158.400000,NULL),(6132,2,1,NULL,198.000000,158.400000,158.400000,158.400000,NULL),(6132,3,1,NULL,198.000000,158.400000,158.400000,158.400000,NULL),(6133,0,1,NULL,296.000000,236.800000,236.800000,236.800000,NULL),(6133,1,1,NULL,296.000000,236.800000,236.800000,236.800000,NULL),(6133,2,1,NULL,296.000000,236.800000,236.800000,236.800000,NULL),(6133,3,1,NULL,296.000000,236.800000,236.800000,236.800000,NULL),(6134,0,1,NULL,421.683333,337.346667,337.346667,337.346667,NULL),(6134,1,1,NULL,421.683333,337.346667,337.346667,337.346667,NULL),(6134,2,1,NULL,421.683333,337.346667,337.346667,337.346667,NULL),(6134,3,1,NULL,421.683333,337.346667,337.346667,337.346667,NULL),(6135,0,1,NULL,220.916667,200.833334,200.833334,200.833334,NULL),(6135,1,1,NULL,220.916667,200.833334,200.833334,200.833334,NULL),(6135,2,1,NULL,220.916667,200.833334,200.833334,200.833334,NULL),(6135,3,1,NULL,220.916667,200.833334,200.833334,200.833334,NULL),(6136,0,1,NULL,95.333333,86.666667,86.666667,86.666667,NULL),(6136,1,1,NULL,95.333333,86.666667,86.666667,86.666667,NULL),(6136,2,1,NULL,95.333333,86.666667,86.666667,86.666667,NULL),(6136,3,1,NULL,95.333333,86.666667,86.666667,86.666667,NULL),(6137,0,1,NULL,778.000000,501.666667,501.666667,501.666667,NULL),(6137,1,1,NULL,778.000000,501.666667,501.666667,501.666667,NULL),(6137,2,1,NULL,778.000000,501.666667,501.666667,501.666667,NULL),(6137,3,1,NULL,778.000000,501.666667,501.666667,501.666667,NULL),(6138,0,1,NULL,598.000000,405.000000,405.000000,405.000000,NULL),(6138,1,1,NULL,598.000000,405.000000,405.000000,405.000000,NULL),(6138,2,1,NULL,598.000000,405.000000,405.000000,405.000000,NULL),(6138,3,1,NULL,598.000000,405.000000,405.000000,405.000000,NULL),(6139,0,1,NULL,718.000000,496.758333,496.758333,496.758333,NULL),(6139,1,1,NULL,718.000000,496.758333,496.758333,496.758333,NULL),(6139,2,1,NULL,718.000000,496.758333,496.758333,496.758333,NULL),(6139,3,1,NULL,718.000000,496.758333,496.758333,496.758333,NULL),(6140,0,1,NULL,598.000000,444.983333,444.983333,444.983333,NULL),(6140,1,1,NULL,598.000000,444.983333,444.983333,444.983333,NULL),(6140,2,1,NULL,598.000000,444.983333,444.983333,444.983333,NULL),(6140,3,1,NULL,598.000000,444.983333,444.983333,444.983333,NULL),(6141,0,1,NULL,568.000000,363.333333,363.333333,363.333333,NULL),(6141,1,1,NULL,568.000000,363.333333,363.333333,363.333333,NULL),(6141,2,1,NULL,568.000000,363.333333,363.333333,363.333333,NULL),(6141,3,1,NULL,568.000000,363.333333,363.333333,363.333333,NULL),(6142,0,1,NULL,192.058333,153.646667,153.646667,153.646667,NULL),(6142,1,1,NULL,192.058333,153.646667,153.646667,153.646667,NULL),(6142,2,1,NULL,192.058333,153.646667,153.646667,153.646667,NULL),(6142,3,1,NULL,192.058333,153.646667,153.646667,153.646667,NULL),(6143,0,1,NULL,256.658333,205.326667,205.326667,205.326667,NULL),(6143,1,1,NULL,256.658333,205.326667,205.326667,205.326667,NULL),(6143,2,1,NULL,256.658333,205.326667,205.326667,205.326667,NULL),(6143,3,1,NULL,256.658333,205.326667,205.326667,205.326667,NULL),(6144,0,1,NULL,205.000000,164.000000,164.000000,164.000000,NULL),(6144,1,1,NULL,205.000000,164.000000,164.000000,164.000000,NULL),(6144,2,1,NULL,205.000000,164.000000,164.000000,164.000000,NULL),(6144,3,1,NULL,205.000000,164.000000,164.000000,164.000000,NULL),(6145,0,1,NULL,257.000000,205.600000,205.600000,205.600000,NULL),(6145,1,1,NULL,257.000000,205.600000,205.600000,205.600000,NULL),(6145,2,1,NULL,257.000000,205.600000,205.600000,205.600000,NULL),(6145,3,1,NULL,257.000000,205.600000,205.600000,205.600000,NULL),(6146,0,1,NULL,385.641667,308.513333,308.513333,308.513333,NULL),(6146,1,1,NULL,385.641667,308.513333,308.513333,308.513333,NULL),(6146,2,1,NULL,385.641667,308.513333,308.513333,308.513333,NULL),(6146,3,1,NULL,385.641667,308.513333,308.513333,308.513333,NULL),(6147,0,1,NULL,450.083333,360.066667,360.066667,360.066667,NULL),(6147,1,1,NULL,450.083333,360.066667,360.066667,360.066667,NULL),(6147,2,1,NULL,450.083333,360.066667,360.066667,360.066667,NULL),(6147,3,1,NULL,450.083333,360.066667,360.066667,360.066667,NULL),(6148,0,1,NULL,144.833333,131.666667,131.666667,131.666667,NULL),(6148,1,1,NULL,144.833333,131.666667,131.666667,131.666667,NULL),(6148,2,1,NULL,144.833333,131.666667,131.666667,131.666667,NULL),(6148,3,1,NULL,144.833333,131.666667,131.666667,131.666667,NULL),(6149,0,1,NULL,798.000000,578.291667,578.291667,578.291667,NULL),(6149,1,1,NULL,798.000000,578.291667,578.291667,578.291667,NULL),(6149,2,1,NULL,798.000000,578.291667,578.291667,578.291667,NULL),(6149,3,1,NULL,798.000000,578.291667,578.291667,578.291667,NULL),(6150,0,1,NULL,768.000000,508.333333,508.333333,508.333333,NULL),(6150,1,1,NULL,768.000000,508.333333,508.333333,508.333333,NULL),(6150,2,1,NULL,768.000000,508.333333,508.333333,508.333333,NULL),(6150,3,1,NULL,768.000000,508.333333,508.333333,508.333333,NULL),(6151,0,1,NULL,628.000000,450.833333,450.833333,450.833333,NULL),(6151,1,1,NULL,628.000000,450.833333,450.833333,450.833333,NULL),(6151,2,1,NULL,628.000000,450.833333,450.833333,450.833333,NULL),(6151,3,1,NULL,628.000000,450.833333,450.833333,450.833333,NULL),(6152,0,1,NULL,326.666667,261.333333,261.333333,261.333333,NULL),(6152,1,1,NULL,326.666667,261.333333,261.333333,261.333333,NULL),(6152,2,1,NULL,326.666667,261.333333,261.333333,261.333333,NULL),(6152,3,1,NULL,326.666667,261.333333,261.333333,261.333333,NULL),(6153,0,1,NULL,435.300000,348.240000,348.240000,348.240000,NULL),(6153,1,1,NULL,435.300000,348.240000,348.240000,348.240000,NULL),(6153,2,1,NULL,435.300000,348.240000,348.240000,348.240000,NULL),(6153,3,1,NULL,435.300000,348.240000,348.240000,348.240000,NULL),(6154,0,1,NULL,381.000000,304.800000,304.800000,304.800000,NULL),(6154,1,1,NULL,381.000000,304.800000,304.800000,304.800000,NULL),(6154,2,1,NULL,381.000000,304.800000,304.800000,304.800000,NULL),(6154,3,1,NULL,381.000000,304.800000,304.800000,304.800000,NULL),(6155,0,1,NULL,147.000000,117.600000,117.600000,117.600000,NULL),(6155,1,1,NULL,147.000000,117.600000,117.600000,117.600000,NULL),(6155,2,1,NULL,147.000000,117.600000,117.600000,117.600000,NULL),(6155,3,1,NULL,147.000000,117.600000,117.600000,117.600000,NULL),(6156,0,1,NULL,118.333333,94.666667,94.666667,94.666667,NULL),(6156,1,1,NULL,118.333333,94.666667,94.666667,94.666667,NULL),(6156,2,1,NULL,118.333333,94.666667,94.666667,94.666667,NULL),(6156,3,1,NULL,118.333333,94.666667,94.666667,94.666667,NULL),(6157,0,1,NULL,155.000000,124.000000,124.000000,124.000000,NULL),(6157,1,1,NULL,155.000000,124.000000,124.000000,124.000000,NULL),(6157,2,1,NULL,155.000000,124.000000,124.000000,124.000000,NULL),(6157,3,1,NULL,155.000000,124.000000,124.000000,124.000000,NULL),(6158,0,1,NULL,305.000000,244.000000,244.000000,244.000000,NULL),(6158,1,1,NULL,305.000000,244.000000,244.000000,244.000000,NULL),(6158,2,1,NULL,305.000000,244.000000,244.000000,244.000000,NULL),(6158,3,1,NULL,305.000000,244.000000,244.000000,244.000000,NULL),(6159,0,1,NULL,182.376333,165.796667,165.796667,165.796667,NULL),(6159,1,1,NULL,182.376333,165.796667,165.796667,165.796667,NULL),(6159,2,1,NULL,182.376333,165.796667,165.796667,165.796667,NULL),(6159,3,1,NULL,182.376333,165.796667,165.796667,165.796667,NULL),(6160,0,1,NULL,253.920000,230.840000,230.840000,230.840000,NULL),(6160,1,1,NULL,253.920000,230.840000,230.840000,230.840000,NULL),(6160,2,1,NULL,253.920000,230.840000,230.840000,230.840000,NULL),(6160,3,1,NULL,253.920000,230.840000,230.840000,230.840000,NULL),(6161,0,1,NULL,248.420000,225.840000,225.840000,225.840000,NULL),(6161,1,1,NULL,248.420000,225.840000,225.840000,225.840000,NULL),(6161,2,1,NULL,248.420000,225.840000,225.840000,225.840000,NULL),(6161,3,1,NULL,248.420000,225.840000,225.840000,225.840000,NULL),(6162,0,1,NULL,248.420000,225.840000,225.840000,225.840000,NULL),(6162,1,1,NULL,248.420000,225.840000,225.840000,225.840000,NULL),(6162,2,1,NULL,248.420000,225.840000,225.840000,225.840000,NULL),(6162,3,1,NULL,248.420000,225.840000,225.840000,225.840000,NULL),(6163,0,1,NULL,121.916667,110.833334,110.833334,110.833334,NULL),(6163,1,1,NULL,121.916667,110.833334,110.833334,110.833334,NULL),(6163,2,1,NULL,121.916667,110.833334,110.833334,110.833334,NULL),(6163,3,1,NULL,121.916667,110.833334,110.833334,110.833334,NULL),(6164,0,1,NULL,376.666667,301.333333,301.333333,301.333333,NULL),(6164,1,1,NULL,376.666667,301.333333,301.333333,301.333333,NULL),(6164,2,1,NULL,376.666667,301.333333,301.333333,301.333333,NULL),(6164,3,1,NULL,376.666667,301.333333,301.333333,301.333333,NULL),(6165,0,1,NULL,385.400000,308.320000,308.320000,308.320000,NULL),(6165,1,1,NULL,385.400000,308.320000,308.320000,308.320000,NULL),(6165,2,1,NULL,385.400000,308.320000,308.320000,308.320000,NULL),(6165,3,1,NULL,385.400000,308.320000,308.320000,308.320000,NULL),(6166,0,1,NULL,411.158333,328.926667,328.926667,328.926667,NULL),(6166,1,1,NULL,411.158333,328.926667,328.926667,328.926667,NULL),(6166,2,1,NULL,411.158333,328.926667,328.926667,328.926667,NULL),(6166,3,1,NULL,411.158333,328.926667,328.926667,328.926667,NULL),(6167,0,1,NULL,1373.000000,1098.400000,1098.400000,1098.400000,NULL),(6167,1,1,NULL,1373.000000,1098.400000,1098.400000,1098.400000,NULL),(6167,2,1,NULL,1373.000000,1098.400000,1098.400000,1098.400000,NULL),(6167,3,1,NULL,1373.000000,1098.400000,1098.400000,1098.400000,NULL),(6168,0,1,NULL,1581.000000,1264.800000,1264.800000,1264.800000,NULL),(6168,1,1,NULL,1581.000000,1264.800000,1264.800000,1264.800000,NULL),(6168,2,1,NULL,1581.000000,1264.800000,1264.800000,1264.800000,NULL),(6168,3,1,NULL,1581.000000,1264.800000,1264.800000,1264.800000,NULL),(6169,0,1,NULL,1498.000000,1198.400000,1198.400000,1198.400000,NULL),(6169,1,1,NULL,1498.000000,1198.400000,1198.400000,1198.400000,NULL),(6169,2,1,NULL,1498.000000,1198.400000,1198.400000,1198.400000,NULL),(6169,3,1,NULL,1498.000000,1198.400000,1198.400000,1198.400000,NULL),(6170,0,1,NULL,302.458333,241.966667,241.966667,241.966667,NULL),(6170,1,1,NULL,302.458333,241.966667,241.966667,241.966667,NULL),(6170,2,1,NULL,302.458333,241.966667,241.966667,241.966667,NULL),(6170,3,1,NULL,302.458333,241.966667,241.966667,241.966667,NULL),(6171,0,1,NULL,342.283333,273.826667,273.826667,273.826667,NULL),(6171,1,1,NULL,342.283333,273.826667,273.826667,273.826667,NULL),(6171,2,1,NULL,342.283333,273.826667,273.826667,273.826667,NULL),(6171,3,1,NULL,342.283333,273.826667,273.826667,273.826667,NULL),(6172,0,1,NULL,363.700000,290.960000,290.960000,290.960000,NULL),(6172,1,1,NULL,363.700000,290.960000,290.960000,290.960000,NULL),(6172,2,1,NULL,363.700000,290.960000,290.960000,290.960000,NULL),(6172,3,1,NULL,363.700000,290.960000,290.960000,290.960000,NULL),(6173,0,1,NULL,374.383333,299.506667,299.506667,299.506667,NULL),(6173,1,1,NULL,374.383333,299.506667,299.506667,299.506667,NULL),(6173,2,1,NULL,374.383333,299.506667,299.506667,299.506667,NULL),(6173,3,1,NULL,374.383333,299.506667,299.506667,299.506667,NULL),(6174,0,1,NULL,413.383333,330.706667,330.706667,330.706667,NULL),(6174,1,1,NULL,413.383333,330.706667,330.706667,330.706667,NULL),(6174,2,1,NULL,413.383333,330.706667,330.706667,330.706667,NULL),(6174,3,1,NULL,413.383333,330.706667,330.706667,330.706667,NULL),(6175,0,1,NULL,486.716667,389.373333,389.373333,389.373333,NULL),(6175,1,1,NULL,486.716667,389.373333,389.373333,389.373333,NULL),(6175,2,1,NULL,486.716667,389.373333,389.373333,389.373333,NULL),(6175,3,1,NULL,486.716667,389.373333,389.373333,389.373333,NULL),(6176,0,1,NULL,276.833333,251.666667,251.666667,251.666667,NULL),(6176,1,1,NULL,276.833333,251.666667,251.666667,251.666667,NULL),(6176,2,1,NULL,276.833333,251.666667,251.666667,251.666667,NULL),(6176,3,1,NULL,276.833333,251.666667,251.666667,251.666667,NULL),(6177,0,1,NULL,183.333333,166.666667,166.666667,166.666667,NULL),(6177,1,1,NULL,183.333333,166.666667,166.666667,166.666667,NULL),(6177,2,1,NULL,183.333333,166.666667,166.666667,166.666667,NULL),(6177,3,1,NULL,183.333333,166.666667,166.666667,166.666667,NULL),(6178,0,1,NULL,199.833333,181.666667,181.666667,181.666667,NULL),(6178,1,1,NULL,199.833333,181.666667,181.666667,181.666667,NULL),(6178,2,1,NULL,199.833333,181.666667,181.666667,181.666667,NULL),(6178,3,1,NULL,199.833333,181.666667,181.666667,181.666667,NULL),(6179,0,1,NULL,224.583333,204.166667,204.166667,204.166667,NULL),(6179,1,1,NULL,224.583333,204.166667,204.166667,204.166667,NULL),(6179,2,1,NULL,224.583333,204.166667,204.166667,204.166667,NULL),(6179,3,1,NULL,224.583333,204.166667,204.166667,204.166667,NULL),(6180,0,1,NULL,1098.000000,769.980000,769.980000,769.980000,NULL),(6180,1,1,NULL,1098.000000,769.980000,769.980000,769.980000,NULL),(6180,2,1,NULL,1098.000000,769.980000,769.980000,769.980000,NULL),(6180,3,1,NULL,1098.000000,769.980000,769.980000,769.980000,NULL),(6181,0,1,NULL,998.000000,638.383333,638.383333,638.383333,NULL),(6181,1,1,NULL,998.000000,638.383333,638.383333,638.383333,NULL),(6181,2,1,NULL,998.000000,638.383333,638.383333,638.383333,NULL),(6181,3,1,NULL,998.000000,638.383333,638.383333,638.383333,NULL),(6182,0,1,NULL,668.000000,450.133333,450.133333,450.133333,NULL),(6182,1,1,NULL,668.000000,450.133333,450.133333,450.133333,NULL),(6182,2,1,NULL,668.000000,450.133333,450.133333,450.133333,NULL),(6182,3,1,NULL,668.000000,450.133333,450.133333,450.133333,NULL),(6183,0,1,NULL,348.000000,254.166667,254.166667,254.166667,NULL),(6183,1,1,NULL,348.000000,254.166667,254.166667,254.166667,NULL),(6183,2,1,NULL,348.000000,254.166667,254.166667,254.166667,NULL),(6183,3,1,NULL,348.000000,254.166667,254.166667,254.166667,NULL),(6184,0,1,NULL,598.000000,444.975000,444.975000,444.975000,NULL),(6184,1,1,NULL,598.000000,444.975000,444.975000,444.975000,NULL),(6184,2,1,NULL,598.000000,444.975000,444.975000,444.975000,NULL),(6184,3,1,NULL,598.000000,444.975000,444.975000,444.975000,NULL),(6185,0,1,NULL,120.908333,109.916667,109.916667,109.916667,NULL),(6185,1,1,NULL,120.908333,109.916667,109.916667,109.916667,NULL),(6185,2,1,NULL,120.908333,109.916667,109.916667,109.916667,NULL),(6185,3,1,NULL,120.908333,109.916667,109.916667,109.916667,NULL),(6186,0,1,NULL,728.000000,503.425000,503.425000,503.425000,NULL),(6186,1,1,NULL,728.000000,503.425000,503.425000,503.425000,NULL),(6186,2,1,NULL,728.000000,503.425000,503.425000,503.425000,NULL),(6186,3,1,NULL,728.000000,503.425000,503.425000,503.425000,NULL),(6187,0,1,NULL,196.166667,178.333334,178.333334,178.333334,NULL),(6187,1,1,NULL,196.166667,178.333334,178.333334,178.333334,NULL),(6187,2,1,NULL,196.166667,178.333334,178.333334,178.333334,NULL),(6187,3,1,NULL,196.166667,178.333334,178.333334,178.333334,NULL),(6188,0,1,NULL,139.333333,126.666667,126.666667,126.666667,NULL),(6188,1,1,NULL,139.333333,126.666667,126.666667,126.666667,NULL),(6188,2,1,NULL,139.333333,126.666667,126.666667,126.666667,NULL),(6188,3,1,NULL,139.333333,126.666667,126.666667,126.666667,NULL),(6189,0,1,NULL,878.000000,614.600000,614.600000,614.600000,NULL),(6189,1,1,NULL,878.000000,614.600000,614.600000,614.600000,NULL),(6189,2,1,NULL,878.000000,614.600000,614.600000,614.600000,NULL),(6189,3,1,NULL,878.000000,614.600000,614.600000,614.600000,NULL),(6190,0,1,NULL,1098.000000,768.600000,768.600000,768.600000,NULL),(6190,1,1,NULL,1098.000000,768.600000,768.600000,768.600000,NULL),(6190,2,1,NULL,1098.000000,768.600000,768.600000,768.600000,NULL),(6190,3,1,NULL,1098.000000,768.600000,768.600000,768.600000,NULL),(6191,0,1,NULL,1198.000000,802.660000,802.660000,802.660000,NULL),(6191,1,1,NULL,1198.000000,802.660000,802.660000,802.660000,NULL),(6191,2,1,NULL,1198.000000,802.660000,802.660000,802.660000,NULL),(6191,3,1,NULL,1198.000000,802.660000,802.660000,802.660000,NULL),(6192,0,1,NULL,208.358333,189.416667,189.416667,189.416667,NULL),(6192,1,1,NULL,208.358333,189.416667,189.416667,189.416667,NULL),(6192,2,1,NULL,208.358333,189.416667,189.416667,189.416667,NULL),(6192,3,1,NULL,208.358333,189.416667,189.416667,189.416667,NULL),(6193,0,1,NULL,208.358333,189.416667,189.416667,189.416667,NULL),(6193,1,1,NULL,208.358333,189.416667,189.416667,189.416667,NULL),(6193,2,1,NULL,208.358333,189.416667,189.416667,189.416667,NULL),(6193,3,1,NULL,208.358333,189.416667,189.416667,189.416667,NULL),(6194,0,1,NULL,199.833333,181.666667,181.666667,181.666667,NULL),(6194,1,1,NULL,199.833333,181.666667,181.666667,181.666667,NULL),(6194,2,1,NULL,199.833333,181.666667,181.666667,181.666667,NULL),(6194,3,1,NULL,199.833333,181.666667,181.666667,181.666667,NULL),(6195,0,1,NULL,499.000000,399.200000,399.200000,399.200000,NULL),(6195,1,1,NULL,499.000000,399.200000,399.200000,399.200000,NULL),(6195,2,1,NULL,499.000000,399.200000,399.200000,399.200000,NULL),(6195,3,1,NULL,499.000000,399.200000,399.200000,399.200000,NULL),(6196,0,1,NULL,428.000000,299.600000,299.600000,299.600000,NULL),(6196,1,1,NULL,428.000000,299.600000,299.600000,299.600000,NULL),(6196,2,1,NULL,428.000000,299.600000,299.600000,299.600000,NULL),(6196,3,1,NULL,428.000000,299.600000,299.600000,299.600000,NULL),(6197,0,1,NULL,498.000000,367.980000,367.980000,367.980000,NULL),(6197,1,1,NULL,498.000000,367.980000,367.980000,367.980000,NULL),(6197,2,1,NULL,498.000000,367.980000,367.980000,367.980000,NULL),(6197,3,1,NULL,498.000000,367.980000,367.980000,367.980000,NULL),(6198,0,1,NULL,668.000000,421.166667,421.166667,421.166667,NULL),(6198,1,1,NULL,668.000000,421.166667,421.166667,421.166667,NULL),(6198,2,1,NULL,668.000000,421.166667,421.166667,421.166667,NULL),(6198,3,1,NULL,668.000000,421.166667,421.166667,421.166667,NULL),(6199,0,1,NULL,658.000000,423.333333,423.333333,423.333333,NULL),(6199,1,1,NULL,658.000000,423.333333,423.333333,423.333333,NULL),(6199,2,1,NULL,658.000000,423.333333,423.333333,423.333333,NULL),(6199,3,1,NULL,658.000000,423.333333,423.333333,423.333333,NULL),(6200,0,1,NULL,748.000000,470.833333,470.833333,470.833333,NULL),(6200,1,1,NULL,748.000000,470.833333,470.833333,470.833333,NULL),(6200,2,1,NULL,748.000000,470.833333,470.833333,470.833333,NULL),(6200,3,1,NULL,748.000000,470.833333,470.833333,470.833333,NULL),(6201,0,1,NULL,708.000000,482.600000,482.600000,482.600000,NULL),(6201,1,1,NULL,708.000000,482.600000,482.600000,482.600000,NULL),(6201,2,1,NULL,708.000000,482.600000,482.600000,482.600000,NULL),(6201,3,1,NULL,708.000000,482.600000,482.600000,482.600000,NULL),(6202,0,1,NULL,514.841667,411.873333,411.873333,411.873333,NULL),(6202,1,1,NULL,514.841667,411.873333,411.873333,411.873333,NULL),(6202,2,1,NULL,514.841667,411.873333,411.873333,411.873333,NULL),(6202,3,1,NULL,514.841667,411.873333,411.873333,411.873333,NULL),(6203,0,1,NULL,492.920000,443.628000,443.628000,443.628000,NULL),(6203,1,1,NULL,492.920000,443.628000,443.628000,443.628000,NULL),(6203,2,1,NULL,492.920000,443.628000,443.628000,443.628000,NULL),(6203,3,1,NULL,492.920000,443.628000,443.628000,443.628000,NULL),(6204,0,1,NULL,520.410000,468.369000,468.369000,468.369000,NULL),(6204,1,1,NULL,520.410000,468.369000,468.369000,468.369000,NULL),(6204,2,1,NULL,520.410000,468.369000,468.369000,468.369000,NULL),(6204,3,1,NULL,520.410000,468.369000,468.369000,468.369000,NULL),(6205,0,1,NULL,116.416667,105.833334,105.833334,105.833334,NULL),(6205,1,1,NULL,116.416667,105.833334,105.833334,105.833334,NULL),(6205,2,1,NULL,116.416667,105.833334,105.833334,105.833334,NULL),(6205,3,1,NULL,116.416667,105.833334,105.833334,105.833334,NULL),(6206,0,1,NULL,251.666667,201.333333,201.333333,201.333333,NULL),(6206,1,1,NULL,251.666667,201.333333,201.333333,201.333333,NULL),(6206,2,1,NULL,251.666667,201.333333,201.333333,201.333333,NULL),(6206,3,1,NULL,251.666667,201.333333,201.333333,201.333333,NULL),(6207,0,1,NULL,359.216667,287.373333,287.373333,287.373333,NULL),(6207,1,1,NULL,359.216667,287.373333,287.373333,287.373333,NULL),(6207,2,1,NULL,359.216667,287.373333,287.373333,287.373333,NULL),(6207,3,1,NULL,359.216667,287.373333,287.373333,287.373333,NULL),(6208,0,1,NULL,156.750000,142.500000,142.500000,142.500000,NULL),(6208,1,1,NULL,156.750000,142.500000,142.500000,142.500000,NULL),(6208,2,1,NULL,156.750000,142.500000,142.500000,142.500000,NULL),(6208,3,1,NULL,156.750000,142.500000,142.500000,142.500000,NULL),(6209,0,1,NULL,157.480000,143.170000,143.170000,143.170000,NULL),(6209,1,1,NULL,157.480000,143.170000,143.170000,143.170000,NULL),(6209,2,1,NULL,157.480000,143.170000,143.170000,143.170000,NULL),(6209,3,1,NULL,157.480000,143.170000,143.170000,143.170000,NULL),(6210,0,1,NULL,228.250000,207.500000,207.500000,207.500000,NULL),(6210,1,1,NULL,228.250000,207.500000,207.500000,207.500000,NULL),(6210,2,1,NULL,228.250000,207.500000,207.500000,207.500000,NULL),(6210,3,1,NULL,228.250000,207.500000,207.500000,207.500000,NULL),(6211,0,1,NULL,284.166667,258.333334,258.333334,258.333334,NULL),(6211,1,1,NULL,284.166667,258.333334,258.333334,258.333334,NULL),(6211,2,1,NULL,284.166667,258.333334,258.333334,258.333334,NULL),(6211,3,1,NULL,284.166667,258.333334,258.333334,258.333334,NULL),(6212,0,1,NULL,307.083333,279.166667,279.166667,279.166667,NULL),(6212,1,1,NULL,307.083333,279.166667,279.166667,279.166667,NULL),(6212,2,1,NULL,307.083333,279.166667,279.166667,279.166667,NULL),(6212,3,1,NULL,307.083333,279.166667,279.166667,279.166667,NULL),(6213,0,1,NULL,496.683333,397.346667,397.346667,397.346667,NULL),(6213,1,1,NULL,496.683333,397.346667,397.346667,397.346667,NULL),(6213,2,1,NULL,496.683333,397.346667,397.346667,397.346667,NULL),(6213,3,1,NULL,496.683333,397.346667,397.346667,397.346667,NULL),(6214,0,1,NULL,591.683333,473.346667,473.346667,473.346667,NULL),(6214,1,1,NULL,591.683333,473.346667,473.346667,473.346667,NULL),(6214,2,1,NULL,591.683333,473.346667,473.346667,473.346667,NULL),(6214,3,1,NULL,591.683333,473.346667,473.346667,473.346667,NULL),(6215,0,1,NULL,665.841667,532.673333,532.673333,532.673333,NULL),(6215,1,1,NULL,665.841667,532.673333,532.673333,532.673333,NULL),(6215,2,1,NULL,665.841667,532.673333,532.673333,532.673333,NULL),(6215,3,1,NULL,665.841667,532.673333,532.673333,532.673333,NULL),(6216,0,1,NULL,441.583333,353.266667,353.266667,353.266667,NULL),(6216,1,1,NULL,441.583333,353.266667,353.266667,353.266667,NULL),(6216,2,1,NULL,441.583333,353.266667,353.266667,353.266667,NULL),(6216,3,1,NULL,441.583333,353.266667,353.266667,353.266667,NULL),(6217,0,1,NULL,501.441667,401.153333,401.153333,401.153333,NULL),(6217,1,1,NULL,501.441667,401.153333,401.153333,401.153333,NULL),(6217,2,1,NULL,501.441667,401.153333,401.153333,401.153333,NULL),(6217,3,1,NULL,501.441667,401.153333,401.153333,401.153333,NULL),(6218,0,1,NULL,545.800000,436.640000,436.640000,436.640000,NULL),(6218,1,1,NULL,545.800000,436.640000,436.640000,436.640000,NULL),(6218,2,1,NULL,545.800000,436.640000,436.640000,436.640000,NULL),(6218,3,1,NULL,545.800000,436.640000,436.640000,436.640000,NULL),(6219,0,1,NULL,580.858333,464.686667,464.686667,464.686667,NULL),(6219,1,1,NULL,580.858333,464.686667,464.686667,464.686667,NULL),(6219,2,1,NULL,580.858333,464.686667,464.686667,464.686667,NULL),(6219,3,1,NULL,580.858333,464.686667,464.686667,464.686667,NULL),(6220,0,1,NULL,78.466667,71.333334,71.333334,71.333334,NULL),(6220,1,1,NULL,78.466667,71.333334,71.333334,71.333334,NULL),(6220,2,1,NULL,78.466667,71.333334,71.333334,71.333334,NULL),(6220,3,1,NULL,78.466667,71.333334,71.333334,71.333334,NULL),(6221,0,1,NULL,86.350000,78.500000,78.500000,78.500000,NULL),(6221,1,1,NULL,86.350000,78.500000,78.500000,78.500000,NULL),(6221,2,1,NULL,86.350000,78.500000,78.500000,78.500000,NULL),(6221,3,1,NULL,86.350000,78.500000,78.500000,78.500000,NULL),(6222,0,1,NULL,114.583333,104.166667,104.166667,104.166667,NULL),(6222,1,1,NULL,114.583333,104.166667,104.166667,104.166667,NULL),(6222,2,1,NULL,114.583333,104.166667,104.166667,104.166667,NULL),(6222,3,1,NULL,114.583333,104.166667,104.166667,104.166667,NULL),(6223,0,1,NULL,261.258333,209.006667,209.006667,209.006667,NULL),(6223,1,1,NULL,261.258333,209.006667,209.006667,209.006667,NULL),(6223,2,1,NULL,261.258333,209.006667,209.006667,209.006667,NULL),(6223,3,1,NULL,261.258333,209.006667,209.006667,209.006667,NULL),(6224,0,1,NULL,333.316667,266.653333,266.653333,266.653333,NULL),(6224,1,1,NULL,333.316667,266.653333,266.653333,266.653333,NULL),(6224,2,1,NULL,333.316667,266.653333,266.653333,266.653333,NULL),(6224,3,1,NULL,333.316667,266.653333,266.653333,266.653333,NULL),(6225,0,1,NULL,346.758333,277.406667,277.406667,277.406667,NULL),(6225,1,1,NULL,346.758333,277.406667,277.406667,277.406667,NULL),(6225,2,1,NULL,346.758333,277.406667,277.406667,277.406667,NULL),(6225,3,1,NULL,346.758333,277.406667,277.406667,277.406667,NULL),(6226,0,1,NULL,438.283333,350.626667,350.626667,350.626667,NULL),(6226,1,1,NULL,438.283333,350.626667,350.626667,350.626667,NULL),(6226,2,1,NULL,438.283333,350.626667,350.626667,350.626667,NULL),(6226,3,1,NULL,438.283333,350.626667,350.626667,350.626667,NULL),(6227,0,1,NULL,423.500000,338.800000,338.800000,338.800000,NULL),(6227,1,1,NULL,423.500000,338.800000,338.800000,338.800000,NULL),(6227,2,1,NULL,423.500000,338.800000,338.800000,338.800000,NULL),(6227,3,1,NULL,423.500000,338.800000,338.800000,338.800000,NULL),(6228,0,1,NULL,435.458333,348.366667,348.366667,348.366667,NULL),(6228,1,1,NULL,435.458333,348.366667,348.366667,348.366667,NULL),(6228,2,1,NULL,435.458333,348.366667,348.366667,348.366667,NULL),(6228,3,1,NULL,435.458333,348.366667,348.366667,348.366667,NULL),(6229,0,1,NULL,358.000000,259.158333,259.158333,259.158333,NULL),(6229,1,1,NULL,358.000000,259.158333,259.158333,259.158333,NULL),(6229,2,1,NULL,358.000000,259.158333,259.158333,259.158333,NULL),(6229,3,1,NULL,358.000000,259.158333,259.158333,259.158333,NULL),(6230,0,1,NULL,398.000000,306.708333,306.708333,306.708333,NULL),(6230,1,1,NULL,398.000000,306.708333,306.708333,306.708333,NULL),(6230,2,1,NULL,398.000000,306.708333,306.708333,306.708333,NULL),(6230,3,1,NULL,398.000000,306.708333,306.708333,306.708333,NULL),(6231,0,1,NULL,428.000000,291.650000,291.650000,291.650000,NULL),(6231,1,1,NULL,428.000000,291.650000,291.650000,291.650000,NULL),(6231,2,1,NULL,428.000000,291.650000,291.650000,291.650000,NULL),(6231,3,1,NULL,428.000000,291.650000,291.650000,291.650000,NULL),(6232,0,1,NULL,398.000000,282.166667,282.166667,282.166667,NULL),(6232,1,1,NULL,398.000000,282.166667,282.166667,282.166667,NULL),(6232,2,1,NULL,398.000000,282.166667,282.166667,282.166667,NULL),(6232,3,1,NULL,398.000000,282.166667,282.166667,282.166667,NULL),(6233,0,1,NULL,191.220000,173.830000,173.830000,173.830000,NULL),(6233,1,1,NULL,191.220000,173.830000,173.830000,173.830000,NULL),(6233,2,1,NULL,191.220000,173.830000,173.830000,173.830000,NULL),(6233,3,1,NULL,191.220000,173.830000,173.830000,173.830000,NULL),(6234,0,1,NULL,448.000000,313.450000,313.450000,313.450000,NULL),(6234,1,1,NULL,448.000000,313.450000,313.450000,313.450000,NULL),(6234,2,1,NULL,448.000000,313.450000,313.450000,313.450000,NULL),(6234,3,1,NULL,448.000000,313.450000,313.450000,313.450000,NULL),(6235,0,1,NULL,478.000000,332.741667,332.741667,332.741667,NULL),(6235,1,1,NULL,478.000000,332.741667,332.741667,332.741667,NULL),(6235,2,1,NULL,478.000000,332.741667,332.741667,332.741667,NULL),(6235,3,1,NULL,478.000000,332.741667,332.741667,332.741667,NULL),(6236,0,1,NULL,538.000000,348.075000,348.075000,348.075000,NULL),(6236,1,1,NULL,538.000000,348.075000,348.075000,348.075000,NULL),(6236,2,1,NULL,538.000000,348.075000,348.075000,348.075000,NULL),(6236,3,1,NULL,538.000000,348.075000,348.075000,348.075000,NULL),(6237,0,1,NULL,518.000000,348.330000,348.330000,348.330000,NULL),(6237,1,1,NULL,518.000000,348.330000,348.330000,348.330000,NULL),(6237,2,1,NULL,518.000000,348.330000,348.330000,348.330000,NULL),(6237,3,1,NULL,518.000000,348.330000,348.330000,348.330000,NULL),(6238,0,1,NULL,598.000000,385.966667,385.966667,385.966667,NULL),(6238,1,1,NULL,598.000000,385.966667,385.966667,385.966667,NULL),(6238,2,1,NULL,598.000000,385.966667,385.966667,385.966667,NULL),(6238,3,1,NULL,598.000000,385.966667,385.966667,385.966667,NULL),(6239,0,1,NULL,488.000000,367.710000,367.710000,367.710000,NULL),(6239,1,1,NULL,488.000000,367.710000,367.710000,367.710000,NULL),(6239,2,1,NULL,488.000000,367.710000,367.710000,367.710000,NULL),(6239,3,1,NULL,488.000000,367.710000,367.710000,367.710000,NULL),(6240,0,1,NULL,357.500000,325.000000,325.000000,325.000000,NULL),(6240,1,1,NULL,357.500000,325.000000,325.000000,325.000000,NULL),(6240,2,1,NULL,357.500000,325.000000,325.000000,325.000000,NULL),(6240,3,1,NULL,357.500000,325.000000,325.000000,325.000000,NULL),(6241,0,1,NULL,383.070000,348.250000,348.250000,348.250000,NULL),(6241,1,1,NULL,383.070000,348.250000,348.250000,348.250000,NULL),(6241,2,1,NULL,383.070000,348.250000,348.250000,348.250000,NULL),(6241,3,1,NULL,383.070000,348.250000,348.250000,348.250000,NULL),(6242,0,1,NULL,176.916667,160.833334,160.833334,160.833334,NULL),(6242,1,1,NULL,176.916667,160.833334,160.833334,160.833334,NULL),(6242,2,1,NULL,176.916667,160.833334,160.833334,160.833334,NULL),(6242,3,1,NULL,176.916667,160.833334,160.833334,160.833334,NULL),(6243,0,1,NULL,366.666667,293.333333,293.333333,293.333333,NULL),(6243,1,1,NULL,366.666667,293.333333,293.333333,293.333333,NULL),(6243,2,1,NULL,366.666667,293.333333,293.333333,293.333333,NULL),(6243,3,1,NULL,366.666667,293.333333,293.333333,293.333333,NULL),(6244,0,1,NULL,440.000000,352.000000,352.000000,352.000000,NULL),(6244,1,1,NULL,440.000000,352.000000,352.000000,352.000000,NULL),(6244,2,1,NULL,440.000000,352.000000,352.000000,352.000000,NULL),(6244,3,1,NULL,440.000000,352.000000,352.000000,352.000000,NULL),(6245,0,1,NULL,398.416667,318.733333,318.733333,318.733333,NULL),(6245,1,1,NULL,398.416667,318.733333,318.733333,318.733333,NULL),(6245,2,1,NULL,398.416667,318.733333,318.733333,318.733333,NULL),(6245,3,1,NULL,398.416667,318.733333,318.733333,318.733333,NULL),(6246,0,1,NULL,450.916667,360.733333,360.733333,360.733333,NULL),(6246,1,1,NULL,450.916667,360.733333,360.733333,360.733333,NULL),(6246,2,1,NULL,450.916667,360.733333,360.733333,360.733333,NULL),(6246,3,1,NULL,450.916667,360.733333,360.733333,360.733333,NULL),(6247,0,1,NULL,533.191667,426.553333,426.553333,426.553333,NULL),(6247,1,1,NULL,533.191667,426.553333,426.553333,426.553333,NULL),(6247,2,1,NULL,533.191667,426.553333,426.553333,426.553333,NULL),(6247,3,1,NULL,533.191667,426.553333,426.553333,426.553333,NULL),(6248,0,1,NULL,525.383333,420.306667,420.306667,420.306667,NULL),(6248,1,1,NULL,525.383333,420.306667,420.306667,420.306667,NULL),(6248,2,1,NULL,525.383333,420.306667,420.306667,420.306667,NULL),(6248,3,1,NULL,525.383333,420.306667,420.306667,420.306667,NULL),(6249,0,1,NULL,216.666667,174.400000,174.400000,174.400000,NULL),(6249,1,1,NULL,216.666667,174.400000,174.400000,174.400000,NULL),(6249,2,1,NULL,216.666667,174.400000,174.400000,174.400000,NULL),(6249,3,1,NULL,216.666667,174.400000,174.400000,174.400000,NULL),(6250,0,1,NULL,294.000000,235.200000,235.200000,235.200000,NULL),(6250,1,1,NULL,294.000000,235.200000,235.200000,235.200000,NULL),(6250,2,1,NULL,294.000000,235.200000,235.200000,235.200000,NULL),(6250,3,1,NULL,294.000000,235.200000,235.200000,235.200000,NULL),(6251,0,1,NULL,301.000000,240.800000,240.800000,240.800000,NULL),(6251,1,1,NULL,301.000000,240.800000,240.800000,240.800000,NULL),(6251,2,1,NULL,301.000000,240.800000,240.800000,240.800000,NULL),(6251,3,1,NULL,301.000000,240.800000,240.800000,240.800000,NULL),(6252,0,1,NULL,494.000000,395.200000,395.200000,395.200000,NULL),(6252,1,1,NULL,494.000000,395.200000,395.200000,395.200000,NULL),(6252,2,1,NULL,494.000000,395.200000,395.200000,395.200000,NULL),(6252,3,1,NULL,494.000000,395.200000,395.200000,395.200000,NULL),(6253,0,1,NULL,341.941667,273.553333,273.553333,273.553333,NULL),(6253,1,1,NULL,341.941667,273.553333,273.553333,273.553333,NULL),(6253,2,1,NULL,341.941667,273.553333,273.553333,273.553333,NULL),(6253,3,1,NULL,341.941667,273.553333,273.553333,273.553333,NULL),(6254,0,1,NULL,538.000000,430.400000,430.400000,430.400000,NULL),(6254,1,1,NULL,538.000000,430.400000,430.400000,430.400000,NULL),(6254,2,1,NULL,538.000000,430.400000,430.400000,430.400000,NULL),(6254,3,1,NULL,538.000000,430.400000,430.400000,430.400000,NULL),(6255,0,1,NULL,393.333333,314.666667,314.666667,314.666667,NULL),(6255,1,1,NULL,393.333333,314.666667,314.666667,314.666667,NULL),(6255,2,1,NULL,393.333333,314.666667,314.666667,314.666667,NULL),(6255,3,1,NULL,393.333333,314.666667,314.666667,314.666667,NULL),(6256,0,1,NULL,538.000000,430.400000,430.400000,430.400000,NULL),(6256,1,1,NULL,538.000000,430.400000,430.400000,430.400000,NULL),(6256,2,1,NULL,538.000000,430.400000,430.400000,430.400000,NULL),(6256,3,1,NULL,538.000000,430.400000,430.400000,430.400000,NULL),(6257,0,1,NULL,444.460000,311.120000,311.120000,311.120000,NULL),(6257,1,1,NULL,444.460000,311.120000,311.120000,311.120000,NULL),(6257,2,1,NULL,444.460000,311.120000,311.120000,311.120000,NULL),(6257,3,1,NULL,444.460000,311.120000,311.120000,311.120000,NULL),(6258,0,1,NULL,224.580000,204.170000,204.170000,204.170000,NULL),(6258,1,1,NULL,224.580000,204.170000,204.170000,204.170000,NULL),(6258,2,1,NULL,224.580000,204.170000,204.170000,204.170000,NULL),(6258,3,1,NULL,224.580000,204.170000,204.170000,204.170000,NULL),(6259,0,1,NULL,240.170000,218.330000,218.330000,218.330000,NULL),(6259,1,1,NULL,240.170000,218.330000,218.330000,218.330000,NULL),(6259,2,1,NULL,240.170000,218.330000,218.330000,218.330000,NULL),(6259,3,1,NULL,240.170000,218.330000,218.330000,218.330000,NULL),(6260,0,1,NULL,248.420000,225.830000,225.830000,225.830000,NULL),(6260,1,1,NULL,248.420000,225.830000,225.830000,225.830000,NULL),(6260,2,1,NULL,248.420000,225.830000,225.830000,225.830000,NULL),(6260,3,1,NULL,248.420000,225.830000,225.830000,225.830000,NULL),(6261,0,1,NULL,571.000000,456.800000,456.800000,456.800000,NULL),(6261,1,1,NULL,571.000000,456.800000,456.800000,456.800000,NULL),(6261,2,1,NULL,571.000000,456.800000,456.800000,456.800000,NULL),(6261,3,1,NULL,571.000000,456.800000,456.800000,456.800000,NULL),(6262,0,1,NULL,571.000000,456.800000,456.800000,456.800000,NULL),(6262,1,1,NULL,571.000000,456.800000,456.800000,456.800000,NULL),(6262,2,1,NULL,571.000000,456.800000,456.800000,456.800000,NULL),(6262,3,1,NULL,571.000000,456.800000,456.800000,456.800000,NULL),(6263,0,1,NULL,389.000000,311.200000,311.200000,311.200000,NULL),(6263,1,1,NULL,389.000000,311.200000,311.200000,311.200000,NULL),(6263,2,1,NULL,389.000000,311.200000,311.200000,311.200000,NULL),(6263,3,1,NULL,389.000000,311.200000,311.200000,311.200000,NULL),(6264,0,1,NULL,454.000000,363.200000,363.200000,363.200000,NULL),(6264,1,1,NULL,454.000000,363.200000,363.200000,363.200000,NULL),(6264,2,1,NULL,454.000000,363.200000,363.200000,363.200000,NULL),(6264,3,1,NULL,454.000000,363.200000,363.200000,363.200000,NULL),(6265,0,1,NULL,546.000000,436.800000,436.800000,436.800000,NULL),(6265,1,1,NULL,546.000000,436.800000,436.800000,436.800000,NULL),(6265,2,1,NULL,546.000000,436.800000,436.800000,436.800000,NULL),(6265,3,1,NULL,546.000000,436.800000,436.800000,436.800000,NULL),(6266,0,1,NULL,615.000000,492.000000,492.000000,492.000000,NULL),(6266,1,1,NULL,615.000000,492.000000,492.000000,492.000000,NULL),(6266,2,1,NULL,615.000000,492.000000,492.000000,492.000000,NULL),(6266,3,1,NULL,615.000000,492.000000,492.000000,492.000000,NULL),(6267,0,1,NULL,642.000000,513.600000,513.600000,513.600000,NULL),(6267,1,1,NULL,642.000000,513.600000,513.600000,513.600000,NULL),(6267,2,1,NULL,642.000000,513.600000,513.600000,513.600000,NULL),(6267,3,1,NULL,642.000000,513.600000,513.600000,513.600000,NULL),(6268,0,1,NULL,708.250000,566.600000,566.600000,566.600000,NULL),(6268,1,1,NULL,708.250000,566.600000,566.600000,566.600000,NULL),(6268,2,1,NULL,708.250000,566.600000,566.600000,566.600000,NULL),(6268,3,1,NULL,708.250000,566.600000,566.600000,566.600000,NULL),(6269,0,1,NULL,458.000000,325.850000,325.850000,325.850000,NULL),(6269,1,1,NULL,458.000000,325.850000,325.850000,325.850000,NULL),(6269,2,1,NULL,458.000000,325.850000,325.850000,325.850000,NULL),(6269,3,1,NULL,458.000000,325.850000,325.850000,325.850000,NULL),(6270,0,1,NULL,508.000000,343.333333,343.333333,343.333333,NULL),(6270,1,1,NULL,508.000000,343.333333,343.333333,343.333333,NULL),(6270,2,1,NULL,508.000000,343.333333,343.333333,343.333333,NULL),(6270,3,1,NULL,508.000000,343.333333,343.333333,343.333333,NULL),(6271,0,1,NULL,179.666667,163.333334,163.333334,163.333334,NULL),(6271,1,1,NULL,179.666667,163.333334,163.333334,163.333334,NULL),(6271,2,1,NULL,179.666667,163.333334,163.333334,163.333334,NULL),(6271,3,1,NULL,179.666667,163.333334,163.333334,163.333334,NULL),(6272,0,1,NULL,410.666667,373.333334,373.333334,373.333334,NULL),(6272,1,1,NULL,410.666667,373.333334,373.333334,373.333334,NULL),(6272,2,1,NULL,410.666667,373.333334,373.333334,373.333334,NULL),(6272,3,1,NULL,410.666667,373.333334,373.333334,373.333334,NULL),(6273,0,1,NULL,187.733333,170.666667,170.666667,170.666667,NULL),(6273,1,1,NULL,187.733333,170.666667,170.666667,170.666667,NULL),(6273,2,1,NULL,187.733333,170.666667,170.666667,170.666667,NULL),(6273,3,1,NULL,187.733333,170.666667,170.666667,170.666667,NULL),(6274,0,1,NULL,410.666667,373.333334,373.333334,373.333334,NULL),(6274,1,1,NULL,410.666667,373.333334,373.333334,373.333334,NULL),(6274,2,1,NULL,410.666667,373.333334,373.333334,373.333334,NULL),(6274,3,1,NULL,410.666667,373.333334,373.333334,373.333334,NULL),(6275,0,1,NULL,189.750000,172.500000,172.500000,172.500000,NULL),(6275,1,1,NULL,189.750000,172.500000,172.500000,172.500000,NULL),(6275,2,1,NULL,189.750000,172.500000,172.500000,172.500000,NULL),(6275,3,1,NULL,189.750000,172.500000,172.500000,172.500000,NULL),(6276,0,1,NULL,216.333333,196.666667,196.666667,196.666667,NULL),(6276,1,1,NULL,216.333333,196.666667,196.666667,196.666667,NULL),(6276,2,1,NULL,216.333333,196.666667,196.666667,196.666667,NULL),(6276,3,1,NULL,216.333333,196.666667,196.666667,196.666667,NULL),(6277,0,1,NULL,434.500000,395.000000,395.000000,395.000000,NULL),(6277,1,1,NULL,434.500000,395.000000,395.000000,395.000000,NULL),(6277,2,1,NULL,434.500000,395.000000,395.000000,395.000000,NULL),(6277,3,1,NULL,434.500000,395.000000,395.000000,395.000000,NULL),(6278,0,1,NULL,365.216667,292.173333,292.173333,292.173333,NULL),(6278,1,1,NULL,365.216667,292.173333,292.173333,292.173333,NULL),(6278,2,1,NULL,365.216667,292.173333,292.173333,292.173333,NULL),(6278,3,1,NULL,365.216667,292.173333,292.173333,292.173333,NULL),(6279,0,1,NULL,432.300000,345.840000,345.840000,345.840000,NULL),(6279,1,1,NULL,432.300000,345.840000,345.840000,345.840000,NULL),(6279,2,1,NULL,432.300000,345.840000,345.840000,345.840000,NULL),(6279,3,1,NULL,432.300000,345.840000,345.840000,345.840000,NULL),(6280,0,1,NULL,263.330000,144.830000,144.830000,144.830000,NULL),(6280,1,1,NULL,263.330000,144.830000,144.830000,144.830000,NULL),(6280,2,1,NULL,263.330000,144.830000,144.830000,144.830000,NULL),(6280,3,1,NULL,263.330000,144.830000,144.830000,144.830000,NULL),(6281,0,1,NULL,282.500000,155.380000,155.380000,155.380000,NULL),(6281,1,1,NULL,282.500000,155.380000,155.380000,155.380000,NULL),(6281,2,1,NULL,282.500000,155.380000,155.380000,155.380000,NULL),(6281,3,1,NULL,282.500000,155.380000,155.380000,155.380000,NULL),(6282,0,1,NULL,402.500000,221.380000,221.380000,221.380000,NULL),(6282,1,1,NULL,402.500000,221.380000,221.380000,221.380000,NULL),(6282,2,1,NULL,402.500000,221.380000,221.380000,221.380000,NULL),(6282,3,1,NULL,402.500000,221.380000,221.380000,221.380000,NULL),(6283,0,1,NULL,345.000000,189.750000,189.750000,189.750000,NULL),(6283,1,1,NULL,345.000000,189.750000,189.750000,189.750000,NULL),(6283,2,1,NULL,345.000000,189.750000,189.750000,189.750000,NULL),(6283,3,1,NULL,345.000000,189.750000,189.750000,189.750000,NULL),(6284,0,1,NULL,172.333333,156.666667,156.666667,156.666667,NULL),(6284,1,1,NULL,172.333333,156.666667,156.666667,156.666667,NULL),(6284,2,1,NULL,172.333333,156.666667,156.666667,156.666667,NULL),(6284,3,1,NULL,172.333333,156.666667,156.666667,156.666667,NULL),(6285,0,1,NULL,487.666667,443.333334,443.333334,443.333334,NULL),(6285,1,1,NULL,487.666667,443.333334,443.333334,443.333334,NULL),(6285,2,1,NULL,487.666667,443.333334,443.333334,443.333334,NULL),(6285,3,1,NULL,487.666667,443.333334,443.333334,443.333334,NULL),(6286,0,1,NULL,220.916667,200.833334,200.833334,200.833334,NULL),(6286,1,1,NULL,220.916667,200.833334,200.833334,200.833334,NULL),(6286,2,1,NULL,220.916667,200.833334,200.833334,200.833334,NULL),(6286,3,1,NULL,220.916667,200.833334,200.833334,200.833334,NULL),(6287,0,1,NULL,262.166667,238.333334,238.333334,238.333334,NULL),(6287,1,1,NULL,262.166667,238.333334,238.333334,238.333334,NULL),(6287,2,1,NULL,262.166667,238.333334,238.333334,238.333334,NULL),(6287,3,1,NULL,262.166667,238.333334,238.333334,238.333334,NULL),(6288,0,1,NULL,230.083333,209.166667,209.166667,209.166667,NULL),(6288,1,1,NULL,230.083333,209.166667,209.166667,209.166667,NULL),(6288,2,1,NULL,230.083333,209.166667,209.166667,209.166667,NULL),(6288,3,1,NULL,230.083333,209.166667,209.166667,209.166667,NULL),(6289,0,1,NULL,282.241667,256.583334,256.583334,256.583334,NULL),(6289,1,1,NULL,282.241667,256.583334,256.583334,256.583334,NULL),(6289,2,1,NULL,282.241667,256.583334,256.583334,256.583334,NULL),(6289,3,1,NULL,282.241667,256.583334,256.583334,256.583334,NULL),(6290,0,1,NULL,436.333333,396.666667,396.666667,396.666667,NULL),(6290,1,1,NULL,436.333333,396.666667,396.666667,396.666667,NULL),(6290,2,1,NULL,436.333333,396.666667,396.666667,396.666667,NULL),(6290,3,1,NULL,436.333333,396.666667,396.666667,396.666667,NULL),(6291,0,1,NULL,294.250000,267.500000,267.500000,267.500000,NULL),(6291,1,1,NULL,294.250000,267.500000,267.500000,267.500000,NULL),(6291,2,1,NULL,294.250000,267.500000,267.500000,267.500000,NULL),(6291,3,1,NULL,294.250000,267.500000,267.500000,267.500000,NULL),(6292,0,1,NULL,268.216667,214.573333,214.573333,214.573333,NULL),(6292,1,1,NULL,268.216667,214.573333,214.573333,214.573333,NULL),(6292,2,1,NULL,268.216667,214.573333,214.573333,214.573333,NULL),(6292,3,1,NULL,268.216667,214.573333,214.573333,214.573333,NULL),(6293,0,1,NULL,319.166667,255.333333,255.333333,255.333333,NULL),(6293,1,1,NULL,319.166667,255.333333,255.333333,255.333333,NULL),(6293,2,1,NULL,319.166667,255.333333,255.333333,255.333333,NULL),(6293,3,1,NULL,319.166667,255.333333,255.333333,255.333333,NULL),(6294,0,1,NULL,230.083333,209.166667,209.166667,209.166667,NULL),(6294,1,1,NULL,230.083333,209.166667,209.166667,209.166667,NULL),(6294,2,1,NULL,230.083333,209.166667,209.166667,209.166667,NULL),(6294,3,1,NULL,230.083333,209.166667,209.166667,209.166667,NULL),(6295,0,1,NULL,225.500000,205.000000,205.000000,205.000000,NULL),(6295,1,1,NULL,225.500000,205.000000,205.000000,205.000000,NULL),(6295,2,1,NULL,225.500000,205.000000,205.000000,205.000000,NULL),(6295,3,1,NULL,225.500000,205.000000,205.000000,205.000000,NULL),(6296,0,1,NULL,224.583333,204.166667,204.166667,204.166667,NULL),(6296,1,1,NULL,224.583333,204.166667,204.166667,204.166667,NULL),(6296,2,1,NULL,224.583333,204.166667,204.166667,204.166667,NULL),(6296,3,1,NULL,224.583333,204.166667,204.166667,204.166667,NULL),(6297,0,1,NULL,143.000000,130.000000,130.000000,130.000000,NULL),(6297,1,1,NULL,143.000000,130.000000,130.000000,130.000000,NULL),(6297,2,1,NULL,143.000000,130.000000,130.000000,130.000000,NULL),(6297,3,1,NULL,143.000000,130.000000,130.000000,130.000000,NULL),(6298,0,1,NULL,123.856333,112.596667,112.596667,112.596667,NULL),(6298,1,1,NULL,123.856333,112.596667,112.596667,112.596667,NULL),(6298,2,1,NULL,123.856333,112.596667,112.596667,112.596667,NULL),(6298,3,1,NULL,123.856333,112.596667,112.596667,112.596667,NULL),(6299,0,1,NULL,293.458333,234.766667,234.766667,234.766667,NULL),(6299,1,1,NULL,293.458333,234.766667,234.766667,234.766667,NULL),(6299,2,1,NULL,293.458333,234.766667,234.766667,234.766667,NULL),(6299,3,1,NULL,293.458333,234.766667,234.766667,234.766667,NULL),(6300,0,1,NULL,121.920000,110.840000,110.840000,110.840000,NULL),(6300,1,1,NULL,121.920000,110.840000,110.840000,110.840000,NULL),(6300,2,1,NULL,121.920000,110.840000,110.840000,110.840000,NULL),(6300,3,1,NULL,121.920000,110.840000,110.840000,110.840000,NULL),(6301,0,1,NULL,107.250000,97.500000,97.500000,97.500000,NULL),(6301,1,1,NULL,107.250000,97.500000,97.500000,97.500000,NULL),(6301,2,1,NULL,107.250000,97.500000,97.500000,97.500000,NULL),(6301,3,1,NULL,107.250000,97.500000,97.500000,97.500000,NULL),(6302,0,1,NULL,114.583333,104.166667,104.166667,104.166667,NULL),(6302,1,1,NULL,114.583333,104.166667,104.166667,104.166667,NULL),(6302,2,1,NULL,114.583333,104.166667,104.166667,104.166667,NULL),(6302,3,1,NULL,114.583333,104.166667,104.166667,104.166667,NULL),(6303,0,1,NULL,115.500000,105.000000,105.000000,105.000000,NULL),(6303,1,1,NULL,115.500000,105.000000,105.000000,105.000000,NULL),(6303,2,1,NULL,115.500000,105.000000,105.000000,105.000000,NULL),(6303,3,1,NULL,115.500000,105.000000,105.000000,105.000000,NULL),(6304,0,1,NULL,203.133333,184.666667,184.666667,184.666667,NULL),(6304,1,1,NULL,203.133333,184.666667,184.666667,184.666667,NULL),(6304,2,1,NULL,203.133333,184.666667,184.666667,184.666667,NULL),(6304,3,1,NULL,203.133333,184.666667,184.666667,184.666667,NULL),(6305,0,1,NULL,176.546333,160.496667,160.496667,160.496667,NULL),(6305,1,1,NULL,176.546333,160.496667,160.496667,160.496667,NULL),(6305,2,1,NULL,176.546333,160.496667,160.496667,160.496667,NULL),(6305,3,1,NULL,176.546333,160.496667,160.496667,160.496667,NULL),(6306,0,1,NULL,220.546333,200.496667,200.496667,200.496667,NULL),(6306,1,1,NULL,220.546333,200.496667,200.496667,200.496667,NULL),(6306,2,1,NULL,220.546333,200.496667,200.496667,200.496667,NULL),(6306,3,1,NULL,220.546333,200.496667,200.496667,200.496667,NULL),(6307,0,1,NULL,218.841333,198.946667,198.946667,198.946667,NULL),(6307,1,1,NULL,218.841333,198.946667,198.946667,198.946667,NULL),(6307,2,1,NULL,218.841333,198.946667,198.946667,198.946667,NULL),(6307,3,1,NULL,218.841333,198.946667,198.946667,198.946667,NULL),(6308,0,1,NULL,219.798333,199.816667,199.816667,199.816667,NULL),(6308,1,1,NULL,219.798333,199.816667,199.816667,199.816667,NULL),(6308,2,1,NULL,219.798333,199.816667,199.816667,199.816667,NULL),(6308,3,1,NULL,219.798333,199.816667,199.816667,199.816667,NULL),(6309,0,1,NULL,348.000000,243.600000,243.600000,243.600000,NULL),(6309,1,1,NULL,348.000000,243.600000,243.600000,243.600000,NULL),(6309,2,1,NULL,348.000000,243.600000,243.600000,243.600000,NULL),(6309,3,1,NULL,348.000000,243.600000,243.600000,243.600000,NULL),(6310,0,1,NULL,148.400000,118.720000,118.720000,118.720000,NULL),(6310,1,1,NULL,148.400000,118.720000,118.720000,118.720000,NULL),(6310,2,1,NULL,148.400000,118.720000,118.720000,118.720000,NULL),(6310,3,1,NULL,148.400000,118.720000,118.720000,118.720000,NULL),(6311,0,1,NULL,199.316667,159.453333,159.453333,159.453333,NULL),(6311,1,1,NULL,199.316667,159.453333,159.453333,159.453333,NULL),(6311,2,1,NULL,199.316667,159.453333,159.453333,159.453333,NULL),(6311,3,1,NULL,199.316667,159.453333,159.453333,159.453333,NULL),(6312,0,1,NULL,528.000000,342.450000,342.450000,342.450000,NULL),(6312,1,1,NULL,528.000000,342.450000,342.450000,342.450000,NULL),(6312,2,1,NULL,528.000000,342.450000,342.450000,342.450000,NULL),(6312,3,1,NULL,528.000000,342.450000,342.450000,342.450000,NULL),(6313,0,1,NULL,398.000000,256.770000,256.770000,256.770000,NULL),(6313,1,1,NULL,398.000000,256.770000,256.770000,256.770000,NULL),(6313,2,1,NULL,398.000000,256.770000,256.770000,256.770000,NULL),(6313,3,1,NULL,398.000000,256.770000,256.770000,256.770000,NULL),(6314,0,1,NULL,438.000000,301.666667,301.666667,301.666667,NULL),(6314,1,1,NULL,438.000000,301.666667,301.666667,301.666667,NULL),(6314,2,1,NULL,438.000000,301.666667,301.666667,301.666667,NULL),(6314,3,1,NULL,438.000000,301.666667,301.666667,301.666667,NULL),(6315,0,1,NULL,408.000000,285.600000,285.600000,285.600000,NULL),(6315,1,1,NULL,408.000000,285.600000,285.600000,285.600000,NULL),(6315,2,1,NULL,408.000000,285.600000,285.600000,285.600000,NULL),(6315,3,1,NULL,408.000000,285.600000,285.600000,285.600000,NULL),(6316,0,1,NULL,338.000000,231.708333,231.708333,231.708333,NULL),(6316,1,1,NULL,338.000000,231.708333,231.708333,231.708333,NULL),(6316,2,1,NULL,338.000000,231.708333,231.708333,231.708333,NULL),(6316,3,1,NULL,338.000000,231.708333,231.708333,231.708333,NULL),(6317,0,1,NULL,568.000000,363.491667,363.491667,363.491667,NULL),(6317,1,1,NULL,568.000000,363.491667,363.491667,363.491667,NULL),(6317,2,1,NULL,568.000000,363.491667,363.491667,363.491667,NULL),(6317,3,1,NULL,568.000000,363.491667,363.491667,363.491667,NULL),(6318,0,1,NULL,748.000000,470.833333,470.833333,470.833333,NULL),(6318,1,1,NULL,748.000000,470.833333,470.833333,470.833333,NULL),(6318,2,1,NULL,748.000000,470.833333,470.833333,470.833333,NULL),(6318,3,1,NULL,748.000000,470.833333,470.833333,470.833333,NULL),(6319,0,1,NULL,818.000000,515.000000,515.000000,515.000000,NULL),(6319,1,1,NULL,818.000000,515.000000,515.000000,515.000000,NULL),(6319,2,1,NULL,818.000000,515.000000,515.000000,515.000000,NULL),(6319,3,1,NULL,818.000000,515.000000,515.000000,515.000000,NULL),(6320,0,1,NULL,598.000000,382.650000,382.650000,382.650000,NULL),(6320,1,1,NULL,598.000000,382.650000,382.650000,382.650000,NULL),(6320,2,1,NULL,598.000000,382.650000,382.650000,382.650000,NULL),(6320,3,1,NULL,598.000000,382.650000,382.650000,382.650000,NULL),(6321,0,1,NULL,838.000000,534.366667,534.366667,534.366667,NULL),(6321,1,1,NULL,838.000000,534.366667,534.366667,534.366667,NULL),(6321,2,1,NULL,838.000000,534.366667,534.366667,534.366667,NULL),(6321,3,1,NULL,838.000000,534.366667,534.366667,534.366667,NULL),(6322,0,1,NULL,848.000000,541.733333,541.733333,541.733333,NULL),(6322,1,1,NULL,848.000000,541.733333,541.733333,541.733333,NULL),(6322,2,1,NULL,848.000000,541.733333,541.733333,541.733333,NULL),(6322,3,1,NULL,848.000000,541.733333,541.733333,541.733333,NULL),(6323,0,1,NULL,678.000000,465.541667,465.541667,465.541667,NULL),(6323,1,1,NULL,678.000000,465.541667,465.541667,465.541667,NULL),(6323,2,1,NULL,678.000000,465.541667,465.541667,465.541667,NULL),(6323,3,1,NULL,678.000000,465.541667,465.541667,465.541667,NULL),(6324,0,1,NULL,648.000000,426.666667,426.666667,426.666667,NULL),(6324,1,1,NULL,648.000000,426.666667,426.666667,426.666667,NULL),(6324,2,1,NULL,648.000000,426.666667,426.666667,426.666667,NULL),(6324,3,1,NULL,648.000000,426.666667,426.666667,426.666667,NULL),(6325,0,1,NULL,768.000000,514.560000,514.560000,514.560000,NULL),(6325,1,1,NULL,768.000000,514.560000,514.560000,514.560000,NULL),(6325,2,1,NULL,768.000000,514.560000,514.560000,514.560000,NULL),(6325,3,1,NULL,768.000000,514.560000,514.560000,514.560000,NULL),(6326,0,1,NULL,718.000000,460.833333,460.833333,460.833333,NULL),(6326,1,1,NULL,718.000000,460.833333,460.833333,460.833333,NULL),(6326,2,1,NULL,718.000000,460.833333,460.833333,460.833333,NULL),(6326,3,1,NULL,718.000000,460.833333,460.833333,460.833333,NULL),(6327,0,1,NULL,738.000000,505.816667,505.816667,505.816667,NULL),(6327,1,1,NULL,738.000000,505.816667,505.816667,505.816667,NULL),(6327,2,1,NULL,738.000000,505.816667,505.816667,505.816667,NULL),(6327,3,1,NULL,738.000000,505.816667,505.816667,505.816667,NULL),(6328,0,1,NULL,192.500000,175.000000,175.000000,175.000000,NULL),(6328,1,1,NULL,192.500000,175.000000,175.000000,175.000000,NULL),(6328,2,1,NULL,192.500000,175.000000,175.000000,175.000000,NULL),(6328,3,1,NULL,192.500000,175.000000,175.000000,175.000000,NULL),(6329,0,1,NULL,220.000000,200.000000,200.000000,200.000000,NULL),(6329,1,1,NULL,220.000000,200.000000,200.000000,200.000000,NULL),(6329,2,1,NULL,220.000000,200.000000,200.000000,200.000000,NULL),(6329,3,1,NULL,220.000000,200.000000,200.000000,200.000000,NULL),(6330,0,1,NULL,232.833333,211.666667,211.666667,211.666667,NULL),(6330,1,1,NULL,232.833333,211.666667,211.666667,211.666667,NULL),(6330,2,1,NULL,232.833333,211.666667,211.666667,211.666667,NULL),(6330,3,1,NULL,232.833333,211.666667,211.666667,211.666667,NULL),(6331,0,1,NULL,252.083333,229.166667,229.166667,229.166667,NULL),(6331,1,1,NULL,252.083333,229.166667,229.166667,229.166667,NULL),(6331,2,1,NULL,252.083333,229.166667,229.166667,229.166667,NULL),(6331,3,1,NULL,252.083333,229.166667,229.166667,229.166667,NULL),(6332,0,1,NULL,397.116667,317.693333,317.693333,317.693333,NULL),(6332,1,1,NULL,397.116667,317.693333,317.693333,317.693333,NULL),(6332,2,1,NULL,397.116667,317.693333,317.693333,317.693333,NULL),(6332,3,1,NULL,397.116667,317.693333,317.693333,317.693333,NULL),(6333,0,1,NULL,468.358333,374.686667,374.686667,374.686667,NULL),(6333,1,1,NULL,468.358333,374.686667,374.686667,374.686667,NULL),(6333,2,1,NULL,468.358333,374.686667,374.686667,374.686667,NULL),(6333,3,1,NULL,468.358333,374.686667,374.686667,374.686667,NULL),(6334,0,1,NULL,528.083333,422.466667,422.466667,422.466667,NULL),(6334,1,1,NULL,528.083333,422.466667,422.466667,422.466667,NULL),(6334,2,1,NULL,528.083333,422.466667,422.466667,422.466667,NULL),(6334,3,1,NULL,528.083333,422.466667,422.466667,422.466667,NULL),(6335,0,1,NULL,625.941667,500.753333,500.753333,500.753333,NULL),(6335,1,1,NULL,625.941667,500.753333,500.753333,500.753333,NULL),(6335,2,1,NULL,625.941667,500.753333,500.753333,500.753333,NULL),(6335,3,1,NULL,625.941667,500.753333,500.753333,500.753333,NULL),(6336,0,1,NULL,433.341667,346.673333,346.673333,346.673333,NULL),(6336,1,1,NULL,433.341667,346.673333,346.673333,346.673333,NULL),(6336,2,1,NULL,433.341667,346.673333,346.673333,346.673333,NULL),(6336,3,1,NULL,433.341667,346.673333,346.673333,346.673333,NULL),(6337,0,1,NULL,510.000000,408.000000,408.000000,408.000000,NULL),(6337,1,1,NULL,510.000000,408.000000,408.000000,408.000000,NULL),(6337,2,1,NULL,510.000000,408.000000,408.000000,408.000000,NULL),(6337,3,1,NULL,510.000000,408.000000,408.000000,408.000000,NULL),(6338,0,1,NULL,948.000000,665.830000,665.830000,665.830000,NULL),(6338,1,1,NULL,948.000000,665.830000,665.830000,665.830000,NULL),(6338,2,1,NULL,948.000000,665.830000,665.830000,665.830000,NULL),(6338,3,1,NULL,948.000000,665.830000,665.830000,665.830000,NULL),(6339,0,1,NULL,748.000000,519.208333,519.208333,519.208333,NULL),(6339,1,1,NULL,748.000000,519.208333,519.208333,519.208333,NULL),(6339,2,1,NULL,748.000000,519.208333,519.208333,519.208333,NULL),(6339,3,1,NULL,748.000000,519.208333,519.208333,519.208333,NULL),(6340,0,1,NULL,408.000000,276.666667,276.666667,276.666667,NULL),(6340,1,1,NULL,408.000000,276.666667,276.666667,276.666667,NULL),(6340,2,1,NULL,408.000000,276.666667,276.666667,276.666667,NULL),(6340,3,1,NULL,408.000000,276.666667,276.666667,276.666667,NULL),(6341,0,1,NULL,438.000000,293.333333,293.333333,293.333333,NULL),(6341,1,1,NULL,438.000000,293.333333,293.333333,293.333333,NULL),(6341,2,1,NULL,438.000000,293.333333,293.333333,293.333333,NULL),(6341,3,1,NULL,438.000000,293.333333,293.333333,293.333333,NULL),(6342,0,1,NULL,478.000000,305.000000,305.000000,305.000000,NULL),(6342,1,1,NULL,478.000000,305.000000,305.000000,305.000000,NULL),(6342,2,1,NULL,478.000000,305.000000,305.000000,305.000000,NULL),(6342,3,1,NULL,478.000000,305.000000,305.000000,305.000000,NULL),(6343,0,1,NULL,548.000000,383.600000,383.600000,383.600000,NULL),(6343,1,1,NULL,548.000000,383.600000,383.600000,383.600000,NULL),(6343,2,1,NULL,548.000000,383.600000,383.600000,383.600000,NULL),(6343,3,1,NULL,548.000000,383.600000,383.600000,383.600000,NULL),(6344,0,1,NULL,448.000000,299.991667,299.991667,299.991667,NULL),(6344,1,1,NULL,448.000000,299.991667,299.991667,299.991667,NULL),(6344,2,1,NULL,448.000000,299.991667,299.991667,299.991667,NULL),(6344,3,1,NULL,448.000000,299.991667,299.991667,299.991667,NULL),(6345,0,1,NULL,378.000000,260.000000,260.000000,260.000000,NULL),(6345,1,1,NULL,378.000000,260.000000,260.000000,260.000000,NULL),(6345,2,1,NULL,378.000000,260.000000,260.000000,260.000000,NULL),(6345,3,1,NULL,378.000000,260.000000,260.000000,260.000000,NULL);
/*!40000 ALTER TABLE `catalog_product_index_price_replica` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_price_tmp`
--

DROP TABLE IF EXISTS `catalog_product_index_price_tmp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_price_tmp` (
  `entity_id` int unsigned NOT NULL COMMENT 'Product ID',
  `customer_group_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `tax_class_id` smallint unsigned DEFAULT '0' COMMENT 'Tax Class ID',
  `price` decimal(20,6) DEFAULT NULL COMMENT 'Price',
  `final_price` decimal(20,6) DEFAULT NULL COMMENT 'Final Price',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(20,6) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(20,6) DEFAULT NULL COMMENT 'Tier Price',
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Price Indexer Temp Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_price_tmp`
--

LOCK TABLES `catalog_product_index_price_tmp` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_price_tmp` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_price_tmp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_tier_price`
--

DROP TABLE IF EXISTS `catalog_product_index_tier_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_tier_price` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` int unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `min_price` decimal(20,6) DEFAULT NULL COMMENT 'Min Price',
  PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`),
  KEY `CATALOG_PRODUCT_INDEX_TIER_PRICE_CUSTOMER_GROUP_ID` (`customer_group_id`),
  KEY `CATALOG_PRODUCT_INDEX_TIER_PRICE_WEBSITE_ID` (`website_id`),
  CONSTRAINT `CAT_PRD_IDX_TIER_PRICE_CSTR_GROUP_ID_CSTR_GROUP_CSTR_GROUP_ID` FOREIGN KEY (`customer_group_id`) REFERENCES `customer_group` (`customer_group_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_IDX_TIER_PRICE_ENTT_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_IDX_TIER_PRICE_WS_ID_STORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Tier Price Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_tier_price`
--

LOCK TABLES `catalog_product_index_tier_price` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_tier_price` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_index_tier_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_index_website`
--

DROP TABLE IF EXISTS `catalog_product_index_website`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_index_website` (
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `default_store_id` smallint unsigned NOT NULL COMMENT 'Default store ID for website',
  `website_date` date DEFAULT NULL COMMENT 'Website Date',
  `rate` float DEFAULT '1' COMMENT 'Rate',
  PRIMARY KEY (`website_id`),
  KEY `CATALOG_PRODUCT_INDEX_WEBSITE_WEBSITE_DATE` (`website_date`),
  CONSTRAINT `CAT_PRD_IDX_WS_WS_ID_STORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Website Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_index_website`
--

LOCK TABLES `catalog_product_index_website` WRITE;
/*!40000 ALTER TABLE `catalog_product_index_website` DISABLE KEYS */;
INSERT INTO `catalog_product_index_website` VALUES (1,1,'2025-02-05',1),(2,2,'2025-02-05',1),(3,3,'2025-02-05',1),(4,4,'2025-02-05',1);
/*!40000 ALTER TABLE `catalog_product_index_website` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_link`
--

DROP TABLE IF EXISTS `catalog_product_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_link` (
  `link_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Link ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `linked_product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Linked Product ID',
  `link_type_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Link Type ID',
  `store_id` int NOT NULL DEFAULT '0' COMMENT 'Store Id',
  PRIMARY KEY (`link_id`),
  UNIQUE KEY `CATALOG_PRODUCT_LINK_LINK_TYPE_ID_PRODUCT_ID_LINKED_PRODUCT_ID` (`link_type_id`,`product_id`,`linked_product_id`),
  KEY `CATALOG_PRODUCT_LINK_PRODUCT_ID` (`product_id`),
  KEY `CATALOG_PRODUCT_LINK_LINKED_PRODUCT_ID` (`linked_product_id`),
  CONSTRAINT `CAT_PRD_LNK_LNK_TYPE_ID_CAT_PRD_LNK_TYPE_LNK_TYPE_ID` FOREIGN KEY (`link_type_id`) REFERENCES `catalog_product_link_type` (`link_type_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_LNK_LNKED_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`linked_product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_PRODUCT_LINK_PRODUCT_ID_CATALOG_PRODUCT_ENTITY_ENTITY_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=185 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product To Product Linkage Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_link`
--

LOCK TABLES `catalog_product_link` WRITE;
/*!40000 ALTER TABLE `catalog_product_link` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_link` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_link_after_insert` AFTER INSERT ON `catalog_product_link` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`product_id`);
INSERT IGNORE INTO `catalog_product_attribute_cl` (`entity_id`) VALUES (NEW.`product_id`);
INSERT IGNORE INTO `cataloginventory_stock_cl` (`entity_id`) VALUES (NEW.`product_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`product_id`);
INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (NEW.`product_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_link_after_update` AFTER UPDATE ON `catalog_product_link` FOR EACH ROW BEGIN
IF (NOT(NEW.`link_id` <=> OLD.`link_id`) OR NOT(NEW.`product_id` <=> OLD.`product_id`) OR NOT(NEW.`linked_product_id` <=> OLD.`linked_product_id`) OR NOT(NEW.`link_type_id` <=> OLD.`link_type_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`)) THEN INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`product_id`); END IF;
IF (NOT(NEW.`link_id` <=> OLD.`link_id`) OR NOT(NEW.`product_id` <=> OLD.`product_id`) OR NOT(NEW.`linked_product_id` <=> OLD.`linked_product_id`) OR NOT(NEW.`link_type_id` <=> OLD.`link_type_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`)) THEN INSERT IGNORE INTO `catalog_product_attribute_cl` (`entity_id`) VALUES (NEW.`product_id`); END IF;
IF (NOT(NEW.`link_id` <=> OLD.`link_id`) OR NOT(NEW.`product_id` <=> OLD.`product_id`) OR NOT(NEW.`linked_product_id` <=> OLD.`linked_product_id`) OR NOT(NEW.`link_type_id` <=> OLD.`link_type_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`)) THEN INSERT IGNORE INTO `cataloginventory_stock_cl` (`entity_id`) VALUES (NEW.`product_id`); END IF;
IF (NOT(NEW.`link_id` <=> OLD.`link_id`) OR NOT(NEW.`product_id` <=> OLD.`product_id`) OR NOT(NEW.`linked_product_id` <=> OLD.`linked_product_id`) OR NOT(NEW.`link_type_id` <=> OLD.`link_type_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`)) THEN INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (NEW.`product_id`); END IF;
IF (NOT(NEW.`link_id` <=> OLD.`link_id`) OR NOT(NEW.`product_id` <=> OLD.`product_id`) OR NOT(NEW.`linked_product_id` <=> OLD.`linked_product_id`) OR NOT(NEW.`link_type_id` <=> OLD.`link_type_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`)) THEN INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (NEW.`product_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_link_after_delete` AFTER DELETE ON `catalog_product_link` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (OLD.`product_id`);
INSERT IGNORE INTO `catalog_product_attribute_cl` (`entity_id`) VALUES (OLD.`product_id`);
INSERT IGNORE INTO `cataloginventory_stock_cl` (`entity_id`) VALUES (OLD.`product_id`);
INSERT IGNORE INTO `catalogrule_product_cl` (`entity_id`) VALUES (OLD.`product_id`);
INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (OLD.`product_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `catalog_product_link_attribute`
--

DROP TABLE IF EXISTS `catalog_product_link_attribute`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_link_attribute` (
  `product_link_attribute_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Product Link Attribute ID',
  `link_type_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Link Type ID',
  `product_link_attribute_code` varchar(32) DEFAULT NULL COMMENT 'Product Link Attribute Code',
  `data_type` varchar(32) DEFAULT NULL COMMENT 'Data Type',
  PRIMARY KEY (`product_link_attribute_id`),
  KEY `CATALOG_PRODUCT_LINK_ATTRIBUTE_LINK_TYPE_ID` (`link_type_id`),
  CONSTRAINT `CAT_PRD_LNK_ATTR_LNK_TYPE_ID_CAT_PRD_LNK_TYPE_LNK_TYPE_ID` FOREIGN KEY (`link_type_id`) REFERENCES `catalog_product_link_type` (`link_type_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Link Attribute Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_link_attribute`
--

LOCK TABLES `catalog_product_link_attribute` WRITE;
/*!40000 ALTER TABLE `catalog_product_link_attribute` DISABLE KEYS */;
INSERT INTO `catalog_product_link_attribute` VALUES (1,1,'position','int'),(2,4,'position','int'),(3,5,'position','int'),(4,3,'position','int'),(5,3,'qty','decimal'),(6,13,'position','int');
/*!40000 ALTER TABLE `catalog_product_link_attribute` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_link_attribute_decimal`
--

DROP TABLE IF EXISTS `catalog_product_link_attribute_decimal`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_link_attribute_decimal` (
  `value_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `product_link_attribute_id` smallint unsigned DEFAULT NULL COMMENT 'Product Link Attribute ID',
  `link_id` int unsigned NOT NULL COMMENT 'Link ID',
  `value` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CAT_PRD_LNK_ATTR_DEC_PRD_LNK_ATTR_ID_LNK_ID` (`product_link_attribute_id`,`link_id`),
  KEY `CATALOG_PRODUCT_LINK_ATTRIBUTE_DECIMAL_LINK_ID` (`link_id`),
  CONSTRAINT `CAT_PRD_LNK_ATTR_DEC_LNK_ID_CAT_PRD_LNK_LNK_ID` FOREIGN KEY (`link_id`) REFERENCES `catalog_product_link` (`link_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_AB2EFA9A14F7BCF1D5400056203D14B6` FOREIGN KEY (`product_link_attribute_id`) REFERENCES `catalog_product_link_attribute` (`product_link_attribute_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Link Decimal Attribute Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_link_attribute_decimal`
--

LOCK TABLES `catalog_product_link_attribute_decimal` WRITE;
/*!40000 ALTER TABLE `catalog_product_link_attribute_decimal` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_link_attribute_decimal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_link_attribute_int`
--

DROP TABLE IF EXISTS `catalog_product_link_attribute_int`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_link_attribute_int` (
  `value_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `product_link_attribute_id` smallint unsigned DEFAULT NULL COMMENT 'Product Link Attribute ID',
  `link_id` int unsigned NOT NULL COMMENT 'Link ID',
  `value` int NOT NULL DEFAULT '0' COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CAT_PRD_LNK_ATTR_INT_PRD_LNK_ATTR_ID_LNK_ID` (`product_link_attribute_id`,`link_id`),
  KEY `CATALOG_PRODUCT_LINK_ATTRIBUTE_INT_LINK_ID` (`link_id`),
  CONSTRAINT `CAT_PRD_LNK_ATTR_INT_LNK_ID_CAT_PRD_LNK_LNK_ID` FOREIGN KEY (`link_id`) REFERENCES `catalog_product_link` (`link_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_D6D878F8BA2A4282F8DDED7E6E3DE35C` FOREIGN KEY (`product_link_attribute_id`) REFERENCES `catalog_product_link_attribute` (`product_link_attribute_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=149 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Link Integer Attribute Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_link_attribute_int`
--

LOCK TABLES `catalog_product_link_attribute_int` WRITE;
/*!40000 ALTER TABLE `catalog_product_link_attribute_int` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_link_attribute_int` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_link_attribute_varchar`
--

DROP TABLE IF EXISTS `catalog_product_link_attribute_varchar`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_link_attribute_varchar` (
  `value_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `product_link_attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Product Link Attribute ID',
  `link_id` int unsigned NOT NULL COMMENT 'Link ID',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CAT_PRD_LNK_ATTR_VCHR_PRD_LNK_ATTR_ID_LNK_ID` (`product_link_attribute_id`,`link_id`),
  KEY `CATALOG_PRODUCT_LINK_ATTRIBUTE_VARCHAR_LINK_ID` (`link_id`),
  CONSTRAINT `CAT_PRD_LNK_ATTR_VCHR_LNK_ID_CAT_PRD_LNK_LNK_ID` FOREIGN KEY (`link_id`) REFERENCES `catalog_product_link` (`link_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_DEE9C4DA61CFCC01DFCF50F0D79CEA51` FOREIGN KEY (`product_link_attribute_id`) REFERENCES `catalog_product_link_attribute` (`product_link_attribute_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Link Varchar Attribute Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_link_attribute_varchar`
--

LOCK TABLES `catalog_product_link_attribute_varchar` WRITE;
/*!40000 ALTER TABLE `catalog_product_link_attribute_varchar` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_link_attribute_varchar` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_link_type`
--

DROP TABLE IF EXISTS `catalog_product_link_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_link_type` (
  `link_type_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Link Type ID',
  `code` varchar(32) DEFAULT NULL COMMENT 'Code',
  PRIMARY KEY (`link_type_id`)
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Link Type Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_link_type`
--

LOCK TABLES `catalog_product_link_type` WRITE;
/*!40000 ALTER TABLE `catalog_product_link_type` DISABLE KEYS */;
INSERT INTO `catalog_product_link_type` VALUES (1,'relation'),(3,'super'),(4,'up_sell'),(5,'cross_sell'),(13,'fbt');
/*!40000 ALTER TABLE `catalog_product_link_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_option`
--

DROP TABLE IF EXISTS `catalog_product_option`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_option` (
  `option_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `type` varchar(50) DEFAULT NULL COMMENT 'Type',
  `is_require` smallint NOT NULL DEFAULT '1' COMMENT 'Is Required',
  `sku` varchar(64) DEFAULT NULL COMMENT 'SKU',
  `max_characters` int unsigned DEFAULT NULL COMMENT 'Max Characters',
  `file_extension` varchar(50) DEFAULT NULL COMMENT 'File Extension',
  `image_size_x` smallint unsigned DEFAULT NULL COMMENT 'Image Size X',
  `image_size_y` smallint unsigned DEFAULT NULL COMMENT 'Image Size Y',
  `sort_order` int unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `qty_input` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Qty Input Flag (added by MageWorx_OptionFeatures)',
  `one_time` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'One Time Option Flag (added by MageWorx_OptionFeatures)',
  `div_class` varchar(255) NOT NULL COMMENT 'Option Div Class (added by MageWorx_OptionFeatures)',
  `mageworx_option_gallery` smallint NOT NULL DEFAULT '0' COMMENT 'MageWorx option gallery display type (added by MageWorx_OptionFeatures)',
  `mageworx_option_image_mode` smallint NOT NULL DEFAULT '0' COMMENT 'Option image mode (added by MageWorx_OptionFeatures)',
  `selection_limit_from` smallint NOT NULL DEFAULT '0' COMMENT 'Option Selection Limit From (added by MageWorx_OptionFeatures)',
  `selection_limit_to` smallint NOT NULL DEFAULT '0' COMMENT 'Option Selection Limit To (added by MageWorx_OptionFeatures)',
  `is_hidden` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Is Hidden Flag (added by MageWorx_OptionFeatures)',
  `option_title_id` varchar(255) NOT NULL COMMENT 'Option Title Identifier (added by MageWorx Option Dependency)',
  `dependency_type` smallint NOT NULL DEFAULT '0' COMMENT 'Option Dependency Type (added by MageWorx Option Dependency)',
  `group_option_id` int unsigned DEFAULT NULL COMMENT 'Group Option Id (added by MageWorx OptionTemplates)',
  `sku_policy` varchar(20) NOT NULL DEFAULT 'use_config' COMMENT 'SKU Policy (added by MageWorx Option Sku Policy)',
  `is_swatch` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Is Swatch Flag (added by MageWorx Option Swatches)',
  `is_all_groups` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'ALL Customer Group ID (added by MageWorx Option Visibility)',
  `is_all_websites` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'ALL Store ID (added by MageWorx Option Visibility)',
  `disabled` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Disabled (added by MageWorx Option Visibility)',
  `disabled_by_values` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Disabled by values (added by MageWorx Option Visibility)',
  `hide_product_page_value_price` int unsigned NOT NULL DEFAULT '0' COMMENT 'Hide Value Price On Product Page (added by MageWorx_OptionFeatures)',
  PRIMARY KEY (`option_id`),
  KEY `CATALOG_PRODUCT_OPTION_PRODUCT_ID` (`product_id`),
  CONSTRAINT `CAT_PRD_OPT_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COMMENT='Magento Catalog Product Option Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_option`
--

LOCK TABLES `catalog_product_option` WRITE;
/*!40000 ALTER TABLE `catalog_product_option` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_option` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_option_price`
--

DROP TABLE IF EXISTS `catalog_product_option_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_option_price` (
  `option_price_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Price ID',
  `option_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `price` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Price',
  `price_type` varchar(7) NOT NULL DEFAULT 'fixed' COMMENT 'Price Type',
  PRIMARY KEY (`option_price_id`),
  UNIQUE KEY `CATALOG_PRODUCT_OPTION_PRICE_OPTION_ID_STORE_ID` (`option_id`,`store_id`),
  KEY `CATALOG_PRODUCT_OPTION_PRICE_STORE_ID` (`store_id`),
  CONSTRAINT `CAT_PRD_OPT_PRICE_OPT_ID_CAT_PRD_OPT_OPT_ID` FOREIGN KEY (`option_id`) REFERENCES `catalog_product_option` (`option_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_PRODUCT_OPTION_PRICE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Option Price Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_option_price`
--

LOCK TABLES `catalog_product_option_price` WRITE;
/*!40000 ALTER TABLE `catalog_product_option_price` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_option_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_option_title`
--

DROP TABLE IF EXISTS `catalog_product_option_title`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_option_title` (
  `option_title_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Title ID',
  `option_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title',
  PRIMARY KEY (`option_title_id`),
  UNIQUE KEY `CATALOG_PRODUCT_OPTION_TITLE_OPTION_ID_STORE_ID` (`option_id`,`store_id`),
  KEY `CATALOG_PRODUCT_OPTION_TITLE_STORE_ID` (`store_id`),
  CONSTRAINT `CAT_PRD_OPT_TTL_OPT_ID_CAT_PRD_OPT_OPT_ID` FOREIGN KEY (`option_id`) REFERENCES `catalog_product_option` (`option_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_PRODUCT_OPTION_TITLE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Option Title Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_option_title`
--

LOCK TABLES `catalog_product_option_title` WRITE;
/*!40000 ALTER TABLE `catalog_product_option_title` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_option_title` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_option_type_price`
--

DROP TABLE IF EXISTS `catalog_product_option_type_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_option_type_price` (
  `option_type_price_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type Price ID',
  `option_type_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option Type ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `price` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Price',
  `price_type` varchar(7) NOT NULL DEFAULT 'fixed' COMMENT 'Price Type',
  PRIMARY KEY (`option_type_price_id`),
  UNIQUE KEY `CATALOG_PRODUCT_OPTION_TYPE_PRICE_OPTION_TYPE_ID_STORE_ID` (`option_type_id`,`store_id`),
  KEY `CATALOG_PRODUCT_OPTION_TYPE_PRICE_STORE_ID` (`store_id`),
  CONSTRAINT `CATALOG_PRODUCT_OPTION_TYPE_PRICE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_B523E3378E8602F376CC415825576B7F` FOREIGN KEY (`option_type_id`) REFERENCES `catalog_product_option_type_value` (`option_type_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Option Type Price Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_option_type_price`
--

LOCK TABLES `catalog_product_option_type_price` WRITE;
/*!40000 ALTER TABLE `catalog_product_option_type_price` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_option_type_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_option_type_title`
--

DROP TABLE IF EXISTS `catalog_product_option_type_title`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_option_type_title` (
  `option_type_title_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type Title ID',
  `option_type_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option Type ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title',
  PRIMARY KEY (`option_type_title_id`),
  UNIQUE KEY `CATALOG_PRODUCT_OPTION_TYPE_TITLE_OPTION_TYPE_ID_STORE_ID` (`option_type_id`,`store_id`),
  KEY `CATALOG_PRODUCT_OPTION_TYPE_TITLE_STORE_ID` (`store_id`),
  CONSTRAINT `CATALOG_PRODUCT_OPTION_TYPE_TITLE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_C085B9CF2C2A302E8043FDEA1937D6A2` FOREIGN KEY (`option_type_id`) REFERENCES `catalog_product_option_type_value` (`option_type_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Option Type Title Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_option_type_title`
--

LOCK TABLES `catalog_product_option_type_title` WRITE;
/*!40000 ALTER TABLE `catalog_product_option_type_title` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_option_type_title` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_option_type_value`
--

DROP TABLE IF EXISTS `catalog_product_option_type_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_option_type_value` (
  `option_type_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type ID',
  `option_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `sku` varchar(64) DEFAULT NULL COMMENT 'SKU',
  `sort_order` int unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `cost` decimal(10,2) DEFAULT NULL COMMENT 'Cost (added by MageWorx_OptionFeatures)',
  `weight` decimal(20,6) DEFAULT NULL COMMENT 'Weight (added by MageWorx_OptionFeatures)',
  `weight_type` varchar(7) NOT NULL DEFAULT 'fixed' COMMENT 'Type weight (added by MageWorx_OptionFeatures)',
  `qty_multiplier` int unsigned NOT NULL DEFAULT '0' COMMENT 'Qty Multiplier (added by MageWorx_OptionFeatures)',
  `load_linked_product` int unsigned NOT NULL DEFAULT '0' COMMENT 'Load Linked Product (added by MageWorx_OptionFeatures)',
  `option_type_title_id` varchar(255) NOT NULL COMMENT 'Option Type Title Identifier (added by MageWorx Option Dependency)',
  `dependency_type` smallint NOT NULL DEFAULT '0' COMMENT 'Option Type Dependency Type (added by MageWorx Option Dependency)',
  `sku_is_valid` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Sku Is Valid (added by MageWorx OptionLink)',
  `group_option_value_id` int unsigned DEFAULT NULL COMMENT 'Group Option Value Id (added by MageWorx OptionTemplates)',
  `manage_stock` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Manage Stock (added by MageWorx OptionInventory)',
  `qty` decimal(10,2) DEFAULT NULL COMMENT 'Option Value Qty (added by MageWorx OptionInventory)',
  `disabled` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Disabled (added by MageWorx Option Visibility)',
  PRIMARY KEY (`option_type_id`),
  KEY `CATALOG_PRODUCT_OPTION_TYPE_VALUE_OPTION_ID` (`option_id`),
  CONSTRAINT `CAT_PRD_OPT_TYPE_VAL_OPT_ID_CAT_PRD_OPT_OPT_ID` FOREIGN KEY (`option_id`) REFERENCES `catalog_product_option` (`option_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8mb3 COMMENT='Magento Catalog Product Option Value Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_option_type_value`
--

LOCK TABLES `catalog_product_option_type_value` WRITE;
/*!40000 ALTER TABLE `catalog_product_option_type_value` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_option_type_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_price_cl`
--

DROP TABLE IF EXISTS `catalog_product_price_cl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_price_cl` (
  `version_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Version ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  PRIMARY KEY (`version_id`)
) ENGINE=InnoDB AUTO_INCREMENT=68241 DEFAULT CHARSET=utf8mb3 COMMENT='catalog_product_price_cl';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_price_cl`
--

LOCK TABLES `catalog_product_price_cl` WRITE;
/*!40000 ALTER TABLE `catalog_product_price_cl` DISABLE KEYS */;
INSERT INTO `catalog_product_price_cl` VALUES (1,1),(2,2),(3,3),(4,4),(5,5),(6,6),(7,1),(8,2),(9,3),(10,4),(11,5),(12,6),(13,1),(14,1),(15,2),(16,2),(17,3),(18,3),(19,5),(20,5),(21,6),(22,6),(23,1),(24,1),(25,1),(26,1),(27,2),(28,2),(29,2),(30,2),(31,3),(32,3),(33,3),(34,3),(35,4),(36,4),(37,4),(38,5),(39,5),(40,5),(41,5),(42,5),(43,5),(44,5),(45,5),(46,5),(47,6),(48,6),(49,6),(50,6),(51,6),(52,6),(53,6),(54,6),(55,6),(56,4),(57,4),(58,1),(59,1),(60,1),(61,1),(62,1),(63,1),(64,2),(65,2),(66,2),(67,3),(68,3),(69,3),(70,4),(71,4),(72,4),(73,4),(74,4),(75,4),(76,5),(77,5),(78,5),(79,5),(80,5),(81,5),(82,6),(83,6),(84,6),(85,6),(86,6),(87,6),(88,1),(89,1),(90,1),(91,1),(92,1),(93,1),(94,1),(95,1),(96,1),(97,1),(98,1),(99,1),(100,1),(101,2),(102,2),(103,2),(104,2),(105,2),(106,2),(107,2),(108,6),(109,6),(110,6),(111,6),(112,6),(113,6),(114,6),(115,6),(116,6),(117,6),(118,6),(119,6),(120,6),(121,5),(122,5),(123,5),(124,5),(125,5),(126,5),(127,5),(128,5),(129,5),(130,5),(131,5),(132,5),(133,5),(134,4),(135,4),(136,4),(137,4),(138,4),(139,4),(140,4),(141,4),(142,4),(143,4),(144,4),(145,4),(146,4),(147,4),(148,4),(149,4),(150,3),(151,3),(152,3),(153,3),(154,3),(155,3),(156,3),(157,7),(158,7),(159,7),(160,7),(161,7),(162,7),(163,7),(164,7),(165,7),(166,7),(167,7),(168,7),(169,7),(170,7),(171,8),(172,9),(173,10),(174,11),(175,12),(176,13),(177,14),(178,15),(179,16),(180,17),(181,18),(182,19),(183,20),(184,21),(185,22),(186,23),(187,24),(188,25),(189,26),(190,27),(191,28),(192,29),(193,30),(194,31),(195,32),(196,33),(197,34),(198,35),(199,36),(200,37),(201,38),(202,39),(203,40),(204,41),(205,42),(206,43),(207,44),(208,45),(209,46),(210,47),(211,48),(212,49),(213,50),(214,51),(215,52),(216,53),(217,54),(218,55),(219,56),(220,57),(221,58),(222,59),(223,60),(224,61),(225,62),(226,63),(227,64),(228,65),(229,66),(230,67),(231,68),(232,69),(233,70),(234,71),(235,72),(236,73),(237,74),(238,75),(239,76),(240,77),(241,78),(242,79),(243,80),(244,81),(245,82),(246,83),(247,84),(248,85),(249,86),(250,87),(251,88),(252,89),(253,90),(254,91),(255,92),(256,93),(257,94),(258,95),(259,96),(260,97),(261,98),(262,99),(263,100),(264,101),(265,102),(266,103),(267,104),(268,105),(269,106),(270,8),(271,9),(272,10),(273,11),(274,12),(275,13),(276,14),(277,15),(278,16),(279,17),(280,18),(281,19),(282,20),(283,21),(284,22),(285,23),(286,24),(287,25),(288,26),(289,27),(290,28),(291,29),(292,30),(293,31),(294,32),(295,33),(296,34),(297,35),(298,36),(299,37),(300,38),(301,39),(302,40),(303,41),(304,42),(305,43),(306,44),(307,45),(308,46),(309,47),(310,48),(311,49),(312,50),(313,51),(314,52),(315,53),(316,54),(317,55),(318,56),(319,57),(320,58),(321,59),(322,60),(323,61),(324,62),(325,63),(326,64),(327,65),(328,66),(329,67),(330,68),(331,69),(332,70),(333,71),(334,72),(335,73),(336,74),(337,75),(338,76),(339,77),(340,78),(341,79),(342,80),(343,81),(344,82),(345,83),(346,84),(347,85),(348,86),(349,87),(350,88),(351,89),(352,90),(353,91),(354,92),(355,93),(356,94),(357,95),(358,96),(359,97),(360,98),(361,99),(362,100),(363,101),(364,102),(365,103),(366,104),(367,105),(368,106),(369,7),(370,8),(371,8),(372,8),(373,9),(374,9),(375,9),(376,10),(377,10),(378,10),(379,11),(380,11),(381,11),(382,12),(383,12),(384,12),(385,13),(386,13),(387,13),(388,14),(389,14),(390,14),(391,15),(392,15),(393,15),(394,16),(395,16),(396,16),(397,17),(398,17),(399,17),(400,18),(401,18),(402,18),(403,19),(404,19),(405,19),(406,20),(407,20),(408,20),(409,21),(410,21),(411,21),(412,22),(413,22),(414,22),(415,23),(416,23),(417,23),(418,24),(419,24),(420,24),(421,25),(422,25),(423,25),(424,26),(425,26),(426,26),(427,27),(428,27),(429,27),(430,28),(431,28),(432,28),(433,29),(434,29),(435,29),(436,30),(437,30),(438,30),(439,31),(440,31),(441,31),(442,32),(443,32),(444,32),(445,33),(446,33),(447,33),(448,34),(449,34),(450,34),(451,35),(452,35),(453,35),(454,36),(455,36),(456,36),(457,37),(458,37),(459,37),(460,38),(461,38),(462,38),(463,39),(464,40),(465,40),(466,40),(467,41),(468,41),(469,41),(470,42),(471,42),(472,42),(473,43),(474,43),(475,43),(476,44),(477,44),(478,44),(479,45),(480,45),(481,45),(482,46),(483,46),(484,46),(485,47),(486,47),(487,47),(488,48),(489,48),(490,48),(491,49),(492,49),(493,49),(494,50),(495,50),(496,50),(497,51),(498,51),(499,51),(500,52),(501,52),(502,52),(503,53),(504,53),(505,53),(506,54),(507,54),(508,54),(509,55),(510,55),(511,55),(512,56),(513,56),(514,56),(515,57),(516,57),(517,57),(518,58),(519,58),(520,58),(521,59),(522,59),(523,59),(524,60),(525,60),(526,60),(527,61),(528,61),(529,61),(530,62),(531,62),(532,62),(533,63),(534,63),(535,63),(536,64),(537,64),(538,64),(539,65),(540,65),(541,65),(542,66),(543,66),(544,66),(545,67),(546,67),(547,67),(548,68),(549,68),(550,68),(551,69),(552,69),(553,69),(554,70),(555,70),(556,70),(557,71),(558,71),(559,71),(560,72),(561,72),(562,72),(563,73),(564,73),(565,73),(566,74),(567,74),(568,74),(569,75),(570,75),(571,75),(572,76),(573,76),(574,76),(575,77),(576,77),(577,77),(578,78),(579,78),(580,78),(581,79),(582,79),(583,79),(584,80),(585,80),(586,80),(587,81),(588,81),(589,81),(590,82),(591,82),(592,82),(593,83),(594,83),(595,83),(596,84),(597,84),(598,84),(599,85),(600,85),(601,85),(602,86),(603,86),(604,86),(605,87),(606,87),(607,87),(608,88),(609,88),(610,88),(611,89),(612,89),(613,89),(614,90),(615,90),(616,90),(617,91),(618,91),(619,91),(620,92),(621,92),(622,92),(623,93),(624,93),(625,93),(626,94),(627,94),(628,94),(629,95),(630,95),(631,95),(632,96),(633,96),(634,97),(635,97),(636,98),(637,98),(638,99),(639,99),(640,100),(641,100),(642,101),(643,101),(644,102),(645,102),(646,103),(647,103),(648,104),(649,104),(650,105),(651,105),(652,106),(653,106),(654,8),(655,8),(656,8),(657,8),(658,9),(659,9),(660,9),(661,9),(662,10),(663,10),(664,10),(665,10),(666,11),(667,11),(668,11),(669,11),(670,12),(671,12),(672,12),(673,12),(674,13),(675,13),(676,13),(677,13),(678,14),(679,14),(680,14),(681,14),(682,15),(683,15),(684,15),(685,15),(686,16),(687,16),(688,16),(689,16),(690,17),(691,17),(692,17),(693,17),(694,18),(695,18),(696,18),(697,18),(698,19),(699,19),(700,19),(701,19),(702,20),(703,20),(704,20),(705,20),(706,21),(707,21),(708,21),(709,21),(710,22),(711,22),(712,22),(713,22),(714,23),(715,23),(716,23),(717,23),(718,24),(719,24),(720,24),(721,24),(722,25),(723,25),(724,25),(725,25),(726,26),(727,26),(728,26),(729,26),(730,27),(731,27),(732,27),(733,27),(734,28),(735,28),(736,28),(737,28),(738,29),(739,29),(740,29),(741,29),(742,30),(743,30),(744,30),(745,30),(746,31),(747,31),(748,31),(749,31),(750,32),(751,32),(752,32),(753,32),(754,33),(755,33),(756,33),(757,33),(758,34),(759,34),(760,34),(761,34),(762,35),(763,35),(764,35),(765,35),(766,36),(767,36),(768,36),(769,36),(770,37),(771,37),(772,37),(773,37),(774,38),(775,38),(776,38),(777,38),(778,39),(779,39),(780,39),(781,39),(782,40),(783,40),(784,40),(785,40),(786,41),(787,41),(788,41),(789,41),(790,42),(791,42),(792,42),(793,42),(794,43),(795,43),(796,43),(797,43),(798,44),(799,44),(800,44),(801,44),(802,45),(803,45),(804,45),(805,45),(806,46),(807,46),(808,46),(809,46),(810,47),(811,47),(812,47),(813,47),(814,48),(815,48),(816,48),(817,48),(818,49),(819,49),(820,49),(821,49),(822,50),(823,50),(824,50),(825,50),(826,51),(827,51),(828,51),(829,51),(830,52),(831,52),(832,52),(833,52),(834,53),(835,53),(836,53),(837,53),(838,54),(839,54),(840,54),(841,54),(842,55),(843,55),(844,55),(845,55),(846,56),(847,56),(848,56),(849,56),(850,57),(851,57),(852,57),(853,57),(854,58),(855,58),(856,58),(857,58),(858,59),(859,59),(860,59),(861,59),(862,60),(863,60),(864,60),(865,60),(866,61),(867,61),(868,61),(869,61),(870,62),(871,62),(872,62),(873,62),(874,63),(875,63),(876,63),(877,63),(878,64),(879,64),(880,64),(881,64),(882,65),(883,65),(884,65),(885,65),(886,66),(887,66),(888,66),(889,66),(890,67),(891,67),(892,67),(893,67),(894,68),(895,68),(896,68),(897,68),(898,69),(899,69),(900,69),(901,69),(902,70),(903,70),(904,70),(905,70),(906,71),(907,71),(908,71),(909,71),(910,72),(911,72),(912,72),(913,72),(914,73),(915,73),(916,73),(917,73),(918,74),(919,74),(920,74),(921,74),(922,75),(923,75),(924,75),(925,75),(926,76),(927,76),(928,76),(929,76),(930,77),(931,77),(932,77),(933,77),(934,78),(935,78),(936,78),(937,78),(938,79),(939,79),(940,79),(941,79),(942,80),(943,80),(944,80),(945,80),(946,81),(947,81),(948,81),(949,81),(950,82),(951,82),(952,82),(953,82),(954,83),(955,83),(956,83),(957,83),(958,84),(959,84),(960,84),(961,84),(962,85),(963,85),(964,85),(965,85),(966,86),(967,86),(968,86),(969,86),(970,87),(971,87),(972,87),(973,87),(974,88),(975,88),(976,88),(977,88),(978,89),(979,89),(980,89),(981,89),(982,90),(983,90),(984,90),(985,90),(986,91),(987,91),(988,91),(989,91),(990,92),(991,92),(992,92),(993,92),(994,93),(995,93),(996,93),(997,93),(998,94),(999,94),(1000,94),(1001,94),(1002,95),(1003,95),(1004,95),(1005,95),(1006,96),(1007,96),(1008,96),(1009,96),(1010,97),(1011,97),(1012,97),(1013,97),(1014,98),(1015,98),(1016,98),(1017,98),(1018,99),(1019,99),(1020,99),(1021,99),(1022,100),(1023,100),(1024,100),(1025,100),(1026,101),(1027,101),(1028,101),(1029,101),(1030,102),(1031,102),(1032,102),(1033,102),(1034,103),(1035,103),(1036,103),(1037,103),(1038,104),(1039,104),(1040,104),(1041,104),(1042,105),(1043,105),(1044,105),(1045,105),(1046,106),(1047,106),(1048,106),(1049,106),(1050,107),(1051,108),(1052,109),(1053,110),(1054,111),(1055,112),(1056,113),(1057,114),(1058,115),(1059,116),(1060,117),(1061,118),(1062,119),(1063,120),(1064,121),(1065,122),(1066,123),(1067,124),(1068,125),(1069,126),(1070,127),(1071,128),(1072,129),(1073,130),(1074,131),(1075,132),(1076,133),(1077,134),(1078,135),(1079,136),(1080,137),(1081,138),(1082,139),(1083,140),(1084,141),(1085,142),(1086,143),(1087,144),(1088,145),(1089,146),(1090,147),(1091,148),(1092,149),(1093,150),(1094,151),(1095,152),(1096,153),(1097,154),(1098,155),(1099,156),(1100,157),(1101,158),(1102,159),(1103,160),(1104,161),(1105,162),(1106,163),(1107,164),(1108,165),(1109,166),(1110,167),(1111,168),(1112,169),(1113,170),(1114,171),(1115,172),(1116,173),(1117,174),(1118,175),(1119,176),(1120,177),(1121,178),(1122,179),(1123,180),(1124,181),(1125,182),(1126,183),(1127,184),(1128,185),(1129,186),(1130,187),(1131,188),(1132,189),(1133,190),(1134,191),(1135,192),(1136,193),(1137,194),(1138,195),(1139,196),(1140,197),(1141,198),(1142,199),(1143,200),(1144,201),(1145,202),(1146,203),(1147,204),(1148,205),(1149,206),(1150,107),(1151,108),(1152,109),(1153,110),(1154,111),(1155,112),(1156,113),(1157,114),(1158,115),(1159,116),(1160,117),(1161,118),(1162,119),(1163,120),(1164,121),(1165,122),(1166,123),(1167,124),(1168,125),(1169,126),(1170,127),(1171,128),(1172,129),(1173,130),(1174,131),(1175,132),(1176,133),(1177,134),(1178,135),(1179,136),(1180,137),(1181,138),(1182,139),(1183,140),(1184,141),(1185,142),(1186,143),(1187,144),(1188,145),(1189,146),(1190,147),(1191,148),(1192,149),(1193,150),(1194,151),(1195,152),(1196,153),(1197,154),(1198,155),(1199,156),(1200,157),(1201,158),(1202,159),(1203,160),(1204,161),(1205,162),(1206,163),(1207,164),(1208,165),(1209,166),(1210,167),(1211,168),(1212,169),(1213,170),(1214,171),(1215,172),(1216,173),(1217,174),(1218,175),(1219,176),(1220,177),(1221,178),(1222,179),(1223,180),(1224,181),(1225,182),(1226,183),(1227,184),(1228,185),(1229,186),(1230,187),(1231,188),(1232,189),(1233,190),(1234,191),(1235,192),(1236,193),(1237,194),(1238,195),(1239,196),(1240,197),(1241,198),(1242,199),(1243,200),(1244,201),(1245,202),(1246,203),(1247,204),(1248,205),(1249,206),(1250,107),(1251,107),(1252,108),(1253,108),(1254,109),(1255,109),(1256,110),(1257,110),(1258,110),(1259,111),(1260,111),(1261,111),(1262,112),(1263,112),(1264,112),(1265,113),(1266,113),(1267,113),(1268,114),(1269,114),(1270,114),(1271,115),(1272,115),(1273,115),(1274,116),(1275,116),(1276,116),(1277,117),(1278,117),(1279,117),(1280,118),(1281,118),(1282,118),(1283,119),(1284,119),(1285,119),(1286,120),(1287,120),(1288,120),(1289,121),(1290,121),(1291,121),(1292,122),(1293,122),(1294,122),(1295,123),(1296,123),(1297,123),(1298,124),(1299,124),(1300,124),(1301,125),(1302,125),(1303,125),(1304,126),(1305,126),(1306,126),(1307,127),(1308,127),(1309,127),(1310,128),(1311,128),(1312,128),(1313,129),(1314,129),(1315,129),(1316,130),(1317,130),(1318,130),(1319,131),(1320,131),(1321,131),(1322,132),(1323,132),(1324,132),(1325,133),(1326,133),(1327,133),(1328,134),(1329,134),(1330,134),(1331,135),(1332,135),(1333,135),(1334,136),(1335,136),(1336,136),(1337,137),(1338,137),(1339,137),(1340,138),(1341,138),(1342,139),(1343,139),(1344,139),(1345,140),(1346,140),(1347,140),(1348,141),(1349,141),(1350,141),(1351,142),(1352,142),(1353,142),(1354,143),(1355,143),(1356,143),(1357,144),(1358,144),(1359,144),(1360,145),(1361,145),(1362,145),(1363,146),(1364,146),(1365,146),(1366,147),(1367,147),(1368,147),(1369,148),(1370,148),(1371,148),(1372,149),(1373,149),(1374,149),(1375,150),(1376,150),(1377,150),(1378,151),(1379,151),(1380,151),(1381,152),(1382,152),(1383,152),(1384,153),(1385,153),(1386,153),(1387,154),(1388,154),(1389,154),(1390,155),(1391,155),(1392,155),(1393,156),(1394,156),(1395,156),(1396,157),(1397,157),(1398,157),(1399,158),(1400,158),(1401,158),(1402,159),(1403,159),(1404,159),(1405,160),(1406,160),(1407,160),(1408,161),(1409,161),(1410,161),(1411,162),(1412,162),(1413,162),(1414,163),(1415,163),(1416,163),(1417,164),(1418,164),(1419,164),(1420,165),(1421,165),(1422,165),(1423,166),(1424,166),(1425,166),(1426,167),(1427,167),(1428,167),(1429,168),(1430,168),(1431,168),(1432,169),(1433,169),(1434,169),(1435,170),(1436,170),(1437,170),(1438,171),(1439,171),(1440,171),(1441,172),(1442,172),(1443,172),(1444,173),(1445,173),(1446,173),(1447,174),(1448,174),(1449,174),(1450,175),(1451,175),(1452,175),(1453,176),(1454,176),(1455,176),(1456,177),(1457,177),(1458,177),(1459,178),(1460,178),(1461,178),(1462,179),(1463,179),(1464,179),(1465,180),(1466,180),(1467,180),(1468,181),(1469,181),(1470,181),(1471,182),(1472,182),(1473,182),(1474,183),(1475,183),(1476,183),(1477,184),(1478,184),(1479,184),(1480,185),(1481,185),(1482,185),(1483,186),(1484,186),(1485,186),(1486,187),(1487,187),(1488,187),(1489,188),(1490,188),(1491,188),(1492,189),(1493,189),(1494,189),(1495,190),(1496,190),(1497,190),(1498,191),(1499,191),(1500,191),(1501,192),(1502,192),(1503,192),(1504,193),(1505,193),(1506,193),(1507,194),(1508,194),(1509,194),(1510,195),(1511,195),(1512,195),(1513,196),(1514,196),(1515,196),(1516,197),(1517,197),(1518,197),(1519,198),(1520,198),(1521,198),(1522,199),(1523,199),(1524,199),(1525,200),(1526,200),(1527,200),(1528,201),(1529,201),(1530,201),(1531,202),(1532,202),(1533,202),(1534,203),(1535,203),(1536,203),(1537,204),(1538,204),(1539,204),(1540,205),(1541,205),(1542,205),(1543,206),(1544,206),(1545,206),(1546,107),(1547,107),(1548,107),(1549,107),(1550,108),(1551,108),(1552,108),(1553,108),(1554,109),(1555,109),(1556,109),(1557,109),(1558,110),(1559,110),(1560,110),(1561,110),(1562,111),(1563,111),(1564,111),(1565,111),(1566,112),(1567,112),(1568,112),(1569,112),(1570,113),(1571,113),(1572,113),(1573,113),(1574,114),(1575,114),(1576,114),(1577,114),(1578,115),(1579,115),(1580,115),(1581,115),(1582,116),(1583,116),(1584,116),(1585,116),(1586,117),(1587,117),(1588,117),(1589,117),(1590,118),(1591,118),(1592,118),(1593,118),(1594,119),(1595,119),(1596,119),(1597,119),(1598,120),(1599,120),(1600,120),(1601,120),(1602,121),(1603,121),(1604,121),(1605,121),(1606,122),(1607,122),(1608,122),(1609,122),(1610,123),(1611,123),(1612,123),(1613,123),(1614,124),(1615,124),(1616,124),(1617,124),(1618,125),(1619,125),(1620,125),(1621,125),(1622,126),(1623,126),(1624,126),(1625,126),(1626,127),(1627,127),(1628,127),(1629,127),(1630,128),(1631,128),(1632,128),(1633,128),(1634,129),(1635,129),(1636,129),(1637,129),(1638,130),(1639,130),(1640,130),(1641,130),(1642,131),(1643,131),(1644,131),(1645,131),(1646,132),(1647,132),(1648,132),(1649,132),(1650,133),(1651,133),(1652,133),(1653,133),(1654,134),(1655,134),(1656,134),(1657,134),(1658,135),(1659,135),(1660,135),(1661,135),(1662,136),(1663,136),(1664,136),(1665,136),(1666,137),(1667,137),(1668,137),(1669,137),(1670,138),(1671,138),(1672,138),(1673,138),(1674,139),(1675,139),(1676,139),(1677,139),(1678,140),(1679,140),(1680,140),(1681,140),(1682,141),(1683,141),(1684,141),(1685,141),(1686,142),(1687,142),(1688,142),(1689,142),(1690,143),(1691,143),(1692,143),(1693,143),(1694,144),(1695,144),(1696,144),(1697,144),(1698,145),(1699,145),(1700,145),(1701,145),(1702,146),(1703,146),(1704,146),(1705,146),(1706,147),(1707,147),(1708,147),(1709,147),(1710,148),(1711,148),(1712,148),(1713,148),(1714,149),(1715,149),(1716,149),(1717,149),(1718,150),(1719,150),(1720,150),(1721,150),(1722,151),(1723,151),(1724,151),(1725,151),(1726,152),(1727,152),(1728,152),(1729,152),(1730,153),(1731,153),(1732,153),(1733,153),(1734,154),(1735,154),(1736,154),(1737,154),(1738,155),(1739,155),(1740,155),(1741,155),(1742,156),(1743,156),(1744,156),(1745,156),(1746,157),(1747,157),(1748,157),(1749,157),(1750,158),(1751,158),(1752,158),(1753,158),(1754,159),(1755,159),(1756,159),(1757,159),(1758,160),(1759,160),(1760,160),(1761,160),(1762,161),(1763,161),(1764,161),(1765,161),(1766,162),(1767,162),(1768,162),(1769,162),(1770,163),(1771,163),(1772,163),(1773,163),(1774,164),(1775,164),(1776,164),(1777,164),(1778,165),(1779,165),(1780,165),(1781,165),(1782,166),(1783,166),(1784,166),(1785,166),(1786,167),(1787,167),(1788,167),(1789,167),(1790,168),(1791,168),(1792,168),(1793,168),(1794,169),(1795,169),(1796,169),(1797,169),(1798,170),(1799,170),(1800,170),(1801,170),(1802,171),(1803,171),(1804,171),(1805,171),(1806,172),(1807,172),(1808,172),(1809,172),(1810,173),(1811,173),(1812,173),(1813,173),(1814,174),(1815,174),(1816,174),(1817,174),(1818,175),(1819,175),(1820,175),(1821,175),(1822,176),(1823,176),(1824,176),(1825,176),(1826,177),(1827,177),(1828,177),(1829,177),(1830,178),(1831,178),(1832,178),(1833,178),(1834,179),(1835,179),(1836,179),(1837,179),(1838,180),(1839,180),(1840,180),(1841,180),(1842,181),(1843,181),(1844,181),(1845,181),(1846,182),(1847,182),(1848,182),(1849,182),(1850,183),(1851,183),(1852,183),(1853,183),(1854,184),(1855,184),(1856,184),(1857,184),(1858,185),(1859,185),(1860,185),(1861,185),(1862,186),(1863,186),(1864,186),(1865,186),(1866,187),(1867,187),(1868,187),(1869,187),(1870,188),(1871,188),(1872,188),(1873,188),(1874,189),(1875,189),(1876,189),(1877,189),(1878,190),(1879,190),(1880,190),(1881,190),(1882,191),(1883,191),(1884,191),(1885,191),(1886,192),(1887,192),(1888,192),(1889,192),(1890,193),(1891,193),(1892,193),(1893,193),(1894,194),(1895,194),(1896,194),(1897,194),(1898,195),(1899,195),(1900,195),(1901,195),(1902,196),(1903,196),(1904,196),(1905,196),(1906,197),(1907,197),(1908,197),(1909,197),(1910,198),(1911,198),(1912,198),(1913,198),(1914,199),(1915,199),(1916,199),(1917,199),(1918,200),(1919,200),(1920,200),(1921,200),(1922,201),(1923,201),(1924,201),(1925,201),(1926,202),(1927,202),(1928,202),(1929,202),(1930,203),(1931,203),(1932,203),(1933,203),(1934,204),(1935,204),(1936,204),(1937,204),(1938,205),(1939,205),(1940,205),(1941,205),(1942,206),(1943,206),(1944,206),(1945,206),(1946,207),(1947,208),(1948,209),(1949,210),(1950,211),(1951,212),(1952,213),(1953,214),(1954,215),(1955,216),(1956,217),(1957,218),(1958,219),(1959,220),(1960,221),(1961,222),(1962,223),(1963,224),(1964,225),(1965,226),(1966,227),(1967,228),(1968,229),(1969,230),(1970,231),(1971,232),(1972,233),(1973,234),(1974,235),(1975,236),(1976,237),(1977,238),(1978,239),(1979,240),(1980,241),(1981,242),(1982,243),(1983,244),(1984,245),(1985,246),(1986,247),(1987,248),(1988,249),(1989,250),(1990,251),(1991,252),(1992,253),(1993,254),(1994,255),(1995,256),(1996,257),(1997,258),(1998,259),(1999,260),(2000,261),(2001,262),(2002,263),(2003,264),(2004,265),(2005,266),(2006,267),(2007,268),(2008,269),(2009,270),(2010,271),(2011,272),(2012,273),(2013,274),(2014,275),(2015,276),(2016,277),(2017,278),(2018,279),(2019,280),(2020,207),(2021,208),(2022,209),(2023,210),(2024,211),(2025,212),(2026,213),(2027,214),(2028,215),(2029,216),(2030,217),(2031,218),(2032,219),(2033,220),(2034,221),(2035,222),(2036,223),(2037,224),(2038,225),(2039,226),(2040,227),(2041,228),(2042,229),(2043,230),(2044,231),(2045,232),(2046,233),(2047,234),(2048,235),(2049,236),(2050,237),(2051,238),(2052,239),(2053,240),(2054,241),(2055,242),(2056,243),(2057,244),(2058,245),(2059,246),(2060,247),(2061,248),(2062,249),(2063,250),(2064,251),(2065,252),(2066,253),(2067,254),(2068,255),(2069,256),(2070,257),(2071,258),(2072,259),(2073,260),(2074,261),(2075,262),(2076,263),(2077,264),(2078,265),(2079,266),(2080,267),(2081,268),(2082,269),(2083,270),(2084,271),(2085,272),(2086,273),(2087,274),(2088,275),(2089,276),(2090,277),(2091,278),(2092,279),(2093,280),(2094,207),(2095,207),(2096,207),(2097,208),(2098,208),(2099,208),(2100,209),(2101,209),(2102,209),(2103,210),(2104,210),(2105,210),(2106,211),(2107,211),(2108,211),(2109,212),(2110,212),(2111,212),(2112,213),(2113,213),(2114,213),(2115,214),(2116,214),(2117,214),(2118,215),(2119,215),(2120,215),(2121,216),(2122,216),(2123,216),(2124,217),(2125,217),(2126,217),(2127,218),(2128,218),(2129,218),(2130,219),(2131,219),(2132,219),(2133,220),(2134,220),(2135,220),(2136,221),(2137,221),(2138,221),(2139,222),(2140,222),(2141,222),(2142,223),(2143,223),(2144,223),(2145,224),(2146,224),(2147,224),(2148,225),(2149,225),(2150,225),(2151,226),(2152,226),(2153,226),(2154,227),(2155,227),(2156,227),(2157,228),(2158,228),(2159,228),(2160,229),(2161,229),(2162,229),(2163,230),(2164,230),(2165,230),(2166,231),(2167,231),(2168,231),(2169,232),(2170,232),(2171,232),(2172,233),(2173,233),(2174,233),(2175,234),(2176,234),(2177,234),(2178,235),(2179,235),(2180,235),(2181,236),(2182,236),(2183,236),(2184,237),(2185,237),(2186,237),(2187,238),(2188,238),(2189,238),(2190,239),(2191,239),(2192,239),(2193,240),(2194,240),(2195,240),(2196,241),(2197,241),(2198,241),(2199,242),(2200,242),(2201,242),(2202,243),(2203,243),(2204,243),(2205,244),(2206,244),(2207,245),(2208,245),(2209,246),(2210,246),(2211,246),(2212,247),(2213,247),(2214,247),(2215,248),(2216,248),(2217,248),(2218,249),(2219,249),(2220,249),(2221,250),(2222,250),(2223,250),(2224,251),(2225,251),(2226,252),(2227,252),(2228,252),(2229,253),(2230,253),(2231,253),(2232,254),(2233,254),(2234,254),(2235,255),(2236,255),(2237,255),(2238,256),(2239,256),(2240,256),(2241,257),(2242,257),(2243,257),(2244,258),(2245,258),(2246,258),(2247,259),(2248,259),(2249,259),(2250,260),(2251,260),(2252,260),(2253,261),(2254,261),(2255,261),(2256,262),(2257,262),(2258,262),(2259,263),(2260,263),(2261,263),(2262,264),(2263,264),(2264,264),(2265,265),(2266,265),(2267,265),(2268,266),(2269,266),(2270,266),(2271,267),(2272,267),(2273,267),(2274,268),(2275,268),(2276,268),(2277,269),(2278,269),(2279,269),(2280,270),(2281,270),(2282,270),(2283,271),(2284,271),(2285,271),(2286,272),(2287,272),(2288,272),(2289,273),(2290,273),(2291,273),(2292,274),(2293,274),(2294,274),(2295,275),(2296,275),(2297,275),(2298,276),(2299,276),(2300,276),(2301,277),(2302,277),(2303,277),(2304,278),(2305,278),(2306,278),(2307,279),(2308,279),(2309,279),(2310,280),(2311,280),(2312,280),(2313,207),(2314,207),(2315,207),(2316,207),(2317,208),(2318,208),(2319,208),(2320,208),(2321,209),(2322,209),(2323,209),(2324,209),(2325,210),(2326,210),(2327,210),(2328,210),(2329,211),(2330,211),(2331,211),(2332,211),(2333,212),(2334,212),(2335,212),(2336,212),(2337,213),(2338,213),(2339,213),(2340,213),(2341,214),(2342,214),(2343,214),(2344,214),(2345,215),(2346,215),(2347,215),(2348,215),(2349,216),(2350,216),(2351,216),(2352,216),(2353,217),(2354,217),(2355,217),(2356,217),(2357,218),(2358,218),(2359,218),(2360,218),(2361,219),(2362,219),(2363,219),(2364,219),(2365,220),(2366,220),(2367,220),(2368,220),(2369,221),(2370,221),(2371,221),(2372,221),(2373,222),(2374,222),(2375,222),(2376,222),(2377,223),(2378,223),(2379,223),(2380,223),(2381,224),(2382,224),(2383,224),(2384,224),(2385,225),(2386,225),(2387,225),(2388,225),(2389,226),(2390,226),(2391,226),(2392,226),(2393,227),(2394,227),(2395,227),(2396,227),(2397,228),(2398,228),(2399,228),(2400,228),(2401,229),(2402,229),(2403,229),(2404,229),(2405,230),(2406,230),(2407,230),(2408,230),(2409,231),(2410,231),(2411,231),(2412,231),(2413,232),(2414,232),(2415,232),(2416,232),(2417,233),(2418,233),(2419,233),(2420,233),(2421,234),(2422,234),(2423,234),(2424,234),(2425,235),(2426,235),(2427,235),(2428,235),(2429,236),(2430,236),(2431,236),(2432,236),(2433,237),(2434,237),(2435,237),(2436,237),(2437,238),(2438,238),(2439,238),(2440,238),(2441,239),(2442,239),(2443,239),(2444,239),(2445,240),(2446,240),(2447,240),(2448,240),(2449,241),(2450,241),(2451,241),(2452,241),(2453,242),(2454,242),(2455,242),(2456,242),(2457,243),(2458,243),(2459,243),(2460,243),(2461,244),(2462,244),(2463,244),(2464,244),(2465,245),(2466,245),(2467,245),(2468,245),(2469,246),(2470,246),(2471,246),(2472,246),(2473,247),(2474,247),(2475,247),(2476,247),(2477,248),(2478,248),(2479,248),(2480,248),(2481,249),(2482,249),(2483,249),(2484,249),(2485,250),(2486,250),(2487,250),(2488,250),(2489,251),(2490,251),(2491,251),(2492,251),(2493,252),(2494,252),(2495,252),(2496,252),(2497,253),(2498,253),(2499,253),(2500,253),(2501,254),(2502,254),(2503,254),(2504,254),(2505,255),(2506,255),(2507,255),(2508,255),(2509,256),(2510,256),(2511,256),(2512,256),(2513,257),(2514,257),(2515,257),(2516,257),(2517,258),(2518,258),(2519,258),(2520,258),(2521,259),(2522,259),(2523,259),(2524,259),(2525,260),(2526,260),(2527,260),(2528,260),(2529,261),(2530,261),(2531,261),(2532,261),(2533,262),(2534,262),(2535,262),(2536,262),(2537,263),(2538,263),(2539,263),(2540,263),(2541,264),(2542,264),(2543,264),(2544,264),(2545,265),(2546,265),(2547,265),(2548,265),(2549,266),(2550,266),(2551,266),(2552,266),(2553,267),(2554,267),(2555,267),(2556,267),(2557,268),(2558,268),(2559,268),(2560,268),(2561,269),(2562,269),(2563,269),(2564,269),(2565,270),(2566,270),(2567,270),(2568,270),(2569,271),(2570,271),(2571,271),(2572,271),(2573,272),(2574,272),(2575,272),(2576,272),(2577,273),(2578,273),(2579,273),(2580,273),(2581,274),(2582,274),(2583,274),(2584,274),(2585,275),(2586,275),(2587,275),(2588,275),(2589,276),(2590,276),(2591,276),(2592,276),(2593,277),(2594,277),(2595,277),(2596,277),(2597,278),(2598,278),(2599,278),(2600,278),(2601,279),(2602,279),(2603,279),(2604,279),(2605,280),(2606,280),(2607,280),(2608,280),(2609,281),(2610,282),(2611,283),(2612,284),(2613,285),(2614,286),(2615,287),(2616,288),(2617,289),(2618,290),(2619,291),(2620,292),(2621,293),(2622,294),(2623,295),(2624,296),(2625,297),(2626,298),(2627,299),(2628,300),(2629,301),(2630,302),(2631,303),(2632,304),(2633,305),(2634,306),(2635,307),(2636,308),(2637,309),(2638,310),(2639,311),(2640,312),(2641,313),(2642,314),(2643,315),(2644,316),(2645,317),(2646,318),(2647,319),(2648,320),(2649,321),(2650,322),(2651,323),(2652,324),(2653,325),(2654,326),(2655,327),(2656,328),(2657,329),(2658,330),(2659,331),(2660,332),(2661,333),(2662,334),(2663,335),(2664,336),(2665,337),(2666,338),(2667,339),(2668,340),(2669,341),(2670,342),(2671,343),(2672,344),(2673,345),(2674,346),(2675,347),(2676,348),(2677,349),(2678,350),(2679,351),(2680,352),(2681,353),(2682,354),(2683,355),(2684,356),(2685,357),(2686,358),(2687,359),(2688,360),(2689,361),(2690,362),(2691,363),(2692,364),(2693,365),(2694,366),(2695,367),(2696,368),(2697,369),(2698,370),(2699,371),(2700,372),(2701,373),(2702,374),(2703,375),(2704,376),(2705,377),(2706,378),(2707,379),(2708,380),(2709,281),(2710,282),(2711,283),(2712,284),(2713,285),(2714,286),(2715,287),(2716,288),(2717,289),(2718,290),(2719,291),(2720,292),(2721,293),(2722,294),(2723,295),(2724,296),(2725,297),(2726,298),(2727,299),(2728,300),(2729,301),(2730,302),(2731,303),(2732,304),(2733,305),(2734,306),(2735,307),(2736,308),(2737,309),(2738,310),(2739,311),(2740,312),(2741,313),(2742,314),(2743,315),(2744,316),(2745,317),(2746,318),(2747,319),(2748,320),(2749,321),(2750,322),(2751,323),(2752,324),(2753,325),(2754,326),(2755,327),(2756,328),(2757,329),(2758,330),(2759,331),(2760,332),(2761,333),(2762,334),(2763,335),(2764,336),(2765,337),(2766,338),(2767,339),(2768,340),(2769,341),(2770,342),(2771,343),(2772,344),(2773,345),(2774,346),(2775,347),(2776,348),(2777,349),(2778,350),(2779,351),(2780,352),(2781,353),(2782,354),(2783,355),(2784,356),(2785,357),(2786,358),(2787,359),(2788,360),(2789,361),(2790,362),(2791,363),(2792,364),(2793,365),(2794,366),(2795,367),(2796,368),(2797,369),(2798,370),(2799,371),(2800,372),(2801,373),(2802,374),(2803,375),(2804,376),(2805,377),(2806,378),(2807,379),(2808,380),(2809,281),(2810,281),(2811,281),(2812,282),(2813,282),(2814,282),(2815,283),(2816,283),(2817,283),(2818,284),(2819,284),(2820,284),(2821,285),(2822,285),(2823,285),(2824,286),(2825,286),(2826,286),(2827,287),(2828,287),(2829,287),(2830,288),(2831,288),(2832,288),(2833,289),(2834,289),(2835,289),(2836,290),(2837,290),(2838,290),(2839,291),(2840,291),(2841,291),(2842,292),(2843,292),(2844,292),(2845,293),(2846,293),(2847,293),(2848,294),(2849,294),(2850,294),(2851,295),(2852,295),(2853,295),(2854,296),(2855,296),(2856,296),(2857,297),(2858,297),(2859,297),(2860,298),(2861,298),(2862,298),(2863,299),(2864,299),(2865,299),(2866,300),(2867,300),(2868,300),(2869,301),(2870,301),(2871,301),(2872,302),(2873,302),(2874,302),(2875,303),(2876,303),(2877,303),(2878,304),(2879,304),(2880,304),(2881,305),(2882,305),(2883,305),(2884,306),(2885,306),(2886,306),(2887,307),(2888,307),(2889,307),(2890,308),(2891,308),(2892,308),(2893,309),(2894,309),(2895,309),(2896,310),(2897,310),(2898,310),(2899,311),(2900,311),(2901,311),(2902,312),(2903,312),(2904,312),(2905,313),(2906,313),(2907,313),(2908,314),(2909,314),(2910,314),(2911,315),(2912,315),(2913,315),(2914,316),(2915,316),(2916,316),(2917,317),(2918,317),(2919,317),(2920,318),(2921,318),(2922,318),(2923,319),(2924,319),(2925,319),(2926,320),(2927,320),(2928,320),(2929,321),(2930,321),(2931,321),(2932,322),(2933,322),(2934,322),(2935,323),(2936,323),(2937,323),(2938,324),(2939,324),(2940,324),(2941,325),(2942,325),(2943,325),(2944,326),(2945,326),(2946,326),(2947,327),(2948,327),(2949,327),(2950,328),(2951,328),(2952,328),(2953,329),(2954,329),(2955,329),(2956,330),(2957,330),(2958,330),(2959,331),(2960,331),(2961,331),(2962,332),(2963,332),(2964,332),(2965,333),(2966,333),(2967,333),(2968,334),(2969,334),(2970,334),(2971,335),(2972,335),(2973,335),(2974,336),(2975,336),(2976,336),(2977,337),(2978,337),(2979,337),(2980,338),(2981,338),(2982,338),(2983,339),(2984,339),(2985,339),(2986,340),(2987,340),(2988,340),(2989,341),(2990,341),(2991,341),(2992,342),(2993,342),(2994,342),(2995,343),(2996,343),(2997,343),(2998,344),(2999,344),(3000,344),(3001,345),(3002,345),(3003,345),(3004,346),(3005,346),(3006,346),(3007,347),(3008,347),(3009,347),(3010,348),(3011,348),(3012,348),(3013,349),(3014,349),(3015,349),(3016,350),(3017,350),(3018,350),(3019,351),(3020,351),(3021,351),(3022,352),(3023,352),(3024,352),(3025,353),(3026,353),(3027,353),(3028,354),(3029,354),(3030,354),(3031,355),(3032,355),(3033,355),(3034,356),(3035,356),(3036,356),(3037,357),(3038,357),(3039,357),(3040,358),(3041,358),(3042,358),(3043,359),(3044,359),(3045,359),(3046,360),(3047,360),(3048,360),(3049,361),(3050,361),(3051,361),(3052,362),(3053,362),(3054,362),(3055,363),(3056,363),(3057,363),(3058,364),(3059,364),(3060,364),(3061,365),(3062,365),(3063,365),(3064,366),(3065,366),(3066,366),(3067,367),(3068,367),(3069,367),(3070,368),(3071,368),(3072,368),(3073,369),(3074,369),(3075,369),(3076,370),(3077,370),(3078,370),(3079,371),(3080,371),(3081,371),(3082,372),(3083,372),(3084,372),(3085,373),(3086,373),(3087,373),(3088,374),(3089,374),(3090,374),(3091,375),(3092,375),(3093,375),(3094,376),(3095,376),(3096,376),(3097,377),(3098,377),(3099,377),(3100,378),(3101,378),(3102,378),(3103,379),(3104,379),(3105,379),(3106,380),(3107,380),(3108,380),(3109,281),(3110,281),(3111,281),(3112,281),(3113,282),(3114,282),(3115,282),(3116,282),(3117,283),(3118,283),(3119,283),(3120,283),(3121,284),(3122,284),(3123,284),(3124,284),(3125,285),(3126,285),(3127,285),(3128,285),(3129,286),(3130,286),(3131,286),(3132,286),(3133,287),(3134,287),(3135,287),(3136,287),(3137,288),(3138,288),(3139,288),(3140,288),(3141,289),(3142,289),(3143,289),(3144,289),(3145,290),(3146,290),(3147,290),(3148,290),(3149,291),(3150,291),(3151,291),(3152,291),(3153,292),(3154,292),(3155,292),(3156,292),(3157,293),(3158,293),(3159,293),(3160,293),(3161,294),(3162,294),(3163,294),(3164,294),(3165,295),(3166,295),(3167,295),(3168,295),(3169,296),(3170,296),(3171,296),(3172,296),(3173,297),(3174,297),(3175,297),(3176,297),(3177,298),(3178,298),(3179,298),(3180,298),(3181,299),(3182,299),(3183,299),(3184,299),(3185,300),(3186,300),(3187,300),(3188,300),(3189,301),(3190,301),(3191,301),(3192,301),(3193,302),(3194,302),(3195,302),(3196,302),(3197,303),(3198,303),(3199,303),(3200,303),(3201,304),(3202,304),(3203,304),(3204,304),(3205,305),(3206,305),(3207,305),(3208,305),(3209,306),(3210,306),(3211,306),(3212,306),(3213,307),(3214,307),(3215,307),(3216,307),(3217,308),(3218,308),(3219,308),(3220,308),(3221,309),(3222,309),(3223,309),(3224,309),(3225,310),(3226,310),(3227,310),(3228,310),(3229,311),(3230,311),(3231,311),(3232,311),(3233,312),(3234,312),(3235,312),(3236,312),(3237,313),(3238,313),(3239,313),(3240,313),(3241,314),(3242,314),(3243,314),(3244,314),(3245,315),(3246,315),(3247,315),(3248,315),(3249,316),(3250,316),(3251,316),(3252,316),(3253,317),(3254,317),(3255,317),(3256,317),(3257,318),(3258,318),(3259,318),(3260,318),(3261,319),(3262,319),(3263,319),(3264,319),(3265,320),(3266,320),(3267,320),(3268,320),(3269,321),(3270,321),(3271,321),(3272,321),(3273,322),(3274,322),(3275,322),(3276,322),(3277,323),(3278,323),(3279,323),(3280,323),(3281,324),(3282,324),(3283,324),(3284,324),(3285,325),(3286,325),(3287,325),(3288,325),(3289,326),(3290,326),(3291,326),(3292,326),(3293,327),(3294,327),(3295,327),(3296,327),(3297,328),(3298,328),(3299,328),(3300,328),(3301,329),(3302,329),(3303,329),(3304,329),(3305,330),(3306,330),(3307,330),(3308,330),(3309,331),(3310,331),(3311,331),(3312,331),(3313,332),(3314,332),(3315,332),(3316,332),(3317,333),(3318,333),(3319,333),(3320,333),(3321,334),(3322,334),(3323,334),(3324,334),(3325,335),(3326,335),(3327,335),(3328,335),(3329,336),(3330,336),(3331,336),(3332,336),(3333,337),(3334,337),(3335,337),(3336,337),(3337,338),(3338,338),(3339,338),(3340,338),(3341,339),(3342,339),(3343,339),(3344,339),(3345,340),(3346,340),(3347,340),(3348,340),(3349,341),(3350,341),(3351,341),(3352,341),(3353,342),(3354,342),(3355,342),(3356,342),(3357,343),(3358,343),(3359,343),(3360,343),(3361,344),(3362,344),(3363,344),(3364,344),(3365,345),(3366,345),(3367,345),(3368,345),(3369,346),(3370,346),(3371,346),(3372,346),(3373,347),(3374,347),(3375,347),(3376,347),(3377,348),(3378,348),(3379,348),(3380,348),(3381,349),(3382,349),(3383,349),(3384,349),(3385,350),(3386,350),(3387,350),(3388,350),(3389,351),(3390,351),(3391,351),(3392,351),(3393,352),(3394,352),(3395,352),(3396,352),(3397,353),(3398,353),(3399,353),(3400,353),(3401,354),(3402,354),(3403,354),(3404,354),(3405,355),(3406,355),(3407,355),(3408,355),(3409,356),(3410,356),(3411,356),(3412,356),(3413,357),(3414,357),(3415,357),(3416,357),(3417,358),(3418,358),(3419,358),(3420,358),(3421,359),(3422,359),(3423,359),(3424,359),(3425,360),(3426,360),(3427,360),(3428,360),(3429,361),(3430,361),(3431,361),(3432,361),(3433,362),(3434,362),(3435,362),(3436,362),(3437,363),(3438,363),(3439,363),(3440,363),(3441,364),(3442,364),(3443,364),(3444,364),(3445,365),(3446,365),(3447,365),(3448,365),(3449,366),(3450,366),(3451,366),(3452,366),(3453,367),(3454,367),(3455,367),(3456,367),(3457,368),(3458,368),(3459,368),(3460,368),(3461,369),(3462,369),(3463,369),(3464,369),(3465,370),(3466,370),(3467,370),(3468,370),(3469,371),(3470,371),(3471,371),(3472,371),(3473,372),(3474,372),(3475,372),(3476,372),(3477,373),(3478,373),(3479,373),(3480,373),(3481,374),(3482,374),(3483,374),(3484,374),(3485,375),(3486,375),(3487,375),(3488,375),(3489,376),(3490,376),(3491,376),(3492,376),(3493,377),(3494,377),(3495,377),(3496,377),(3497,378),(3498,378),(3499,378),(3500,378),(3501,379),(3502,379),(3503,379),(3504,379),(3505,380),(3506,380),(3507,380),(3508,380),(3509,381),(3510,382),(3511,383),(3512,384),(3513,385),(3514,386),(3515,387),(3516,388),(3517,389),(3518,390),(3519,391),(3520,392),(3521,393),(3522,394),(3523,395),(3524,396),(3525,397),(3526,398),(3527,399),(3528,400),(3529,401),(3530,402),(3531,403),(3532,404),(3533,405),(3534,406),(3535,407),(3536,408),(3537,409),(3538,410),(3539,411),(3540,412),(3541,413),(3542,414),(3543,415),(3544,416),(3545,417),(3546,418),(3547,419),(3548,420),(3549,421),(3550,422),(3551,423),(3552,424),(3553,425),(3554,426),(3555,427),(3556,428),(3557,429),(3558,430),(3559,431),(3560,432),(3561,433),(3562,434),(3563,435),(3564,436),(3565,437),(3566,438),(3567,439),(3568,440),(3569,441),(3570,442),(3571,443),(3572,444),(3573,445),(3574,446),(3575,447),(3576,448),(3577,449),(3578,450),(3579,451),(3580,452),(3581,453),(3582,454),(3583,455),(3584,456),(3585,457),(3586,458),(3587,459),(3588,460),(3589,461),(3590,462),(3591,463),(3592,464),(3593,465),(3594,466),(3595,467),(3596,468),(3597,469),(3598,470),(3599,471),(3600,472),(3601,473),(3602,474),(3603,475),(3604,476),(3605,477),(3606,478),(3607,479),(3608,480),(3609,381),(3610,382),(3611,383),(3612,384),(3613,385),(3614,386),(3615,387),(3616,388),(3617,389),(3618,390),(3619,391),(3620,392),(3621,393),(3622,394),(3623,395),(3624,396),(3625,397),(3626,398),(3627,399),(3628,400),(3629,401),(3630,402),(3631,403),(3632,404),(3633,405),(3634,406),(3635,407),(3636,408),(3637,409),(3638,410),(3639,411),(3640,412),(3641,413),(3642,414),(3643,415),(3644,416),(3645,417),(3646,418),(3647,419),(3648,420),(3649,421),(3650,422),(3651,423),(3652,424),(3653,425),(3654,426),(3655,427),(3656,428),(3657,429),(3658,430),(3659,431),(3660,432),(3661,433),(3662,434),(3663,435),(3664,436),(3665,437),(3666,438),(3667,439),(3668,440),(3669,441),(3670,442),(3671,443),(3672,444),(3673,445),(3674,446),(3675,447),(3676,448),(3677,449),(3678,450),(3679,451),(3680,452),(3681,453),(3682,454),(3683,455),(3684,456),(3685,457),(3686,458),(3687,459),(3688,460),(3689,461),(3690,462),(3691,463),(3692,464),(3693,465),(3694,466),(3695,467),(3696,468),(3697,469),(3698,470),(3699,471),(3700,472),(3701,473),(3702,474),(3703,475),(3704,476),(3705,477),(3706,478),(3707,479),(3708,480),(3709,381),(3710,381),(3711,381),(3712,382),(3713,382),(3714,382),(3715,383),(3716,383),(3717,383),(3718,384),(3719,384),(3720,384),(3721,385),(3722,385),(3723,385),(3724,386),(3725,386),(3726,386),(3727,387),(3728,387),(3729,387),(3730,388),(3731,388),(3732,388),(3733,389),(3734,389),(3735,389),(3736,390),(3737,390),(3738,390),(3739,391),(3740,391),(3741,391),(3742,392),(3743,392),(3744,392),(3745,393),(3746,393),(3747,393),(3748,394),(3749,394),(3750,394),(3751,395),(3752,395),(3753,395),(3754,396),(3755,396),(3756,396),(3757,397),(3758,397),(3759,397),(3760,398),(3761,398),(3762,398),(3763,399),(3764,399),(3765,399),(3766,400),(3767,400),(3768,400),(3769,401),(3770,401),(3771,401),(3772,402),(3773,402),(3774,402),(3775,403),(3776,403),(3777,403),(3778,404),(3779,404),(3780,404),(3781,405),(3782,405),(3783,405),(3784,406),(3785,406),(3786,406),(3787,407),(3788,407),(3789,407),(3790,408),(3791,408),(3792,408),(3793,409),(3794,409),(3795,409),(3796,410),(3797,410),(3798,410),(3799,411),(3800,411),(3801,411),(3802,412),(3803,412),(3804,412),(3805,413),(3806,413),(3807,413),(3808,414),(3809,414),(3810,414),(3811,415),(3812,415),(3813,415),(3814,416),(3815,416),(3816,416),(3817,417),(3818,417),(3819,417),(3820,418),(3821,418),(3822,418),(3823,419),(3824,419),(3825,419),(3826,420),(3827,420),(3828,420),(3829,421),(3830,421),(3831,421),(3832,422),(3833,422),(3834,422),(3835,423),(3836,423),(3837,423),(3838,424),(3839,424),(3840,424),(3841,425),(3842,425),(3843,425),(3844,426),(3845,426),(3846,426),(3847,427),(3848,427),(3849,427),(3850,428),(3851,428),(3852,428),(3853,429),(3854,429),(3855,429),(3856,430),(3857,430),(3858,430),(3859,431),(3860,431),(3861,431),(3862,432),(3863,432),(3864,432),(3865,433),(3866,433),(3867,433),(3868,434),(3869,434),(3870,434),(3871,435),(3872,435),(3873,435),(3874,436),(3875,436),(3876,436),(3877,437),(3878,437),(3879,437),(3880,438),(3881,438),(3882,438),(3883,439),(3884,439),(3885,439),(3886,440),(3887,440),(3888,440),(3889,441),(3890,441),(3891,441),(3892,442),(3893,442),(3894,442),(3895,443),(3896,443),(3897,443),(3898,444),(3899,444),(3900,444),(3901,445),(3902,445),(3903,445),(3904,446),(3905,446),(3906,446),(3907,447),(3908,447),(3909,447),(3910,448),(3911,448),(3912,448),(3913,449),(3914,449),(3915,449),(3916,450),(3917,450),(3918,450),(3919,451),(3920,451),(3921,451),(3922,452),(3923,452),(3924,452),(3925,453),(3926,453),(3927,453),(3928,454),(3929,454),(3930,454),(3931,455),(3932,455),(3933,455),(3934,456),(3935,456),(3936,456),(3937,457),(3938,457),(3939,457),(3940,458),(3941,458),(3942,458),(3943,459),(3944,459),(3945,459),(3946,460),(3947,460),(3948,460),(3949,461),(3950,461),(3951,461),(3952,462),(3953,462),(3954,462),(3955,463),(3956,463),(3957,463),(3958,464),(3959,464),(3960,464),(3961,465),(3962,465),(3963,465),(3964,466),(3965,466),(3966,466),(3967,467),(3968,467),(3969,467),(3970,468),(3971,468),(3972,468),(3973,469),(3974,469),(3975,469),(3976,470),(3977,470),(3978,470),(3979,471),(3980,471),(3981,471),(3982,472),(3983,472),(3984,472),(3985,473),(3986,473),(3987,473),(3988,474),(3989,474),(3990,474),(3991,475),(3992,475),(3993,475),(3994,476),(3995,476),(3996,476),(3997,477),(3998,477),(3999,477),(4000,478),(4001,478),(4002,478),(4003,479),(4004,479),(4005,479),(4006,480),(4007,480),(4008,480),(4009,381),(4010,381),(4011,381),(4012,381),(4013,382),(4014,382),(4015,382),(4016,382),(4017,383),(4018,383),(4019,383),(4020,383),(4021,384),(4022,384),(4023,384),(4024,384),(4025,385),(4026,385),(4027,385),(4028,385),(4029,386),(4030,386),(4031,386),(4032,386),(4033,387),(4034,387),(4035,387),(4036,387),(4037,388),(4038,388),(4039,388),(4040,388),(4041,389),(4042,389),(4043,389),(4044,389),(4045,390),(4046,390),(4047,390),(4048,390),(4049,391),(4050,391),(4051,391),(4052,391),(4053,392),(4054,392),(4055,392),(4056,392),(4057,393),(4058,393),(4059,393),(4060,393),(4061,394),(4062,394),(4063,394),(4064,394),(4065,395),(4066,395),(4067,395),(4068,395),(4069,396),(4070,396),(4071,396),(4072,396),(4073,397),(4074,397),(4075,397),(4076,397),(4077,398),(4078,398),(4079,398),(4080,398),(4081,399),(4082,399),(4083,399),(4084,399),(4085,400),(4086,400),(4087,400),(4088,400),(4089,401),(4090,401),(4091,401),(4092,401),(4093,402),(4094,402),(4095,402),(4096,402),(4097,403),(4098,403),(4099,403),(4100,403),(4101,404),(4102,404),(4103,404),(4104,404),(4105,405),(4106,405),(4107,405),(4108,405),(4109,406),(4110,406),(4111,406),(4112,406),(4113,407),(4114,407),(4115,407),(4116,407),(4117,408),(4118,408),(4119,408),(4120,408),(4121,409),(4122,409),(4123,409),(4124,409),(4125,410),(4126,410),(4127,410),(4128,410),(4129,411),(4130,411),(4131,411),(4132,411),(4133,412),(4134,412),(4135,412),(4136,412),(4137,413),(4138,413),(4139,413),(4140,413),(4141,414),(4142,414),(4143,414),(4144,414),(4145,415),(4146,415),(4147,415),(4148,415),(4149,416),(4150,416),(4151,416),(4152,416),(4153,417),(4154,417),(4155,417),(4156,417),(4157,418),(4158,418),(4159,418),(4160,418),(4161,419),(4162,419),(4163,419),(4164,419),(4165,420),(4166,420),(4167,420),(4168,420),(4169,421),(4170,421),(4171,421),(4172,421),(4173,422),(4174,422),(4175,422),(4176,422),(4177,423),(4178,423),(4179,423),(4180,423),(4181,424),(4182,424),(4183,424),(4184,424),(4185,425),(4186,425),(4187,425),(4188,425),(4189,426),(4190,426),(4191,426),(4192,426),(4193,427),(4194,427),(4195,427),(4196,427),(4197,428),(4198,428),(4199,428),(4200,428),(4201,429),(4202,429),(4203,429),(4204,429),(4205,430),(4206,430),(4207,430),(4208,430),(4209,431),(4210,431),(4211,431),(4212,431),(4213,432),(4214,432),(4215,432),(4216,432),(4217,433),(4218,433),(4219,433),(4220,433),(4221,434),(4222,434),(4223,434),(4224,434),(4225,435),(4226,435),(4227,435),(4228,435),(4229,436),(4230,436),(4231,436),(4232,436),(4233,437),(4234,437),(4235,437),(4236,437),(4237,438),(4238,438),(4239,438),(4240,438),(4241,439),(4242,439),(4243,439),(4244,439),(4245,440),(4246,440),(4247,440),(4248,440),(4249,441),(4250,441),(4251,441),(4252,441),(4253,442),(4254,442),(4255,442),(4256,442),(4257,443),(4258,443),(4259,443),(4260,443),(4261,444),(4262,444),(4263,444),(4264,444),(4265,445),(4266,445),(4267,445),(4268,445),(4269,446),(4270,446),(4271,446),(4272,446),(4273,447),(4274,447),(4275,447),(4276,447),(4277,448),(4278,448),(4279,448),(4280,448),(4281,449),(4282,449),(4283,449),(4284,449),(4285,450),(4286,450),(4287,450),(4288,450),(4289,451),(4290,451),(4291,451),(4292,451),(4293,452),(4294,452),(4295,452),(4296,452),(4297,453),(4298,453),(4299,453),(4300,453),(4301,454),(4302,454),(4303,454),(4304,454),(4305,455),(4306,455),(4307,455),(4308,455),(4309,456),(4310,456),(4311,456),(4312,456),(4313,457),(4314,457),(4315,457),(4316,457),(4317,458),(4318,458),(4319,458),(4320,458),(4321,459),(4322,459),(4323,459),(4324,459),(4325,460),(4326,460),(4327,460),(4328,460),(4329,461),(4330,461),(4331,461),(4332,461),(4333,462),(4334,462),(4335,462),(4336,462),(4337,463),(4338,463),(4339,463),(4340,463),(4341,464),(4342,464),(4343,464),(4344,464),(4345,465),(4346,465),(4347,465),(4348,465),(4349,466),(4350,466),(4351,466),(4352,466),(4353,467),(4354,467),(4355,467),(4356,467),(4357,468),(4358,468),(4359,468),(4360,468),(4361,469),(4362,469),(4363,469),(4364,469),(4365,470),(4366,470),(4367,470),(4368,470),(4369,471),(4370,471),(4371,471),(4372,471),(4373,472),(4374,472),(4375,472),(4376,472),(4377,473),(4378,473),(4379,473),(4380,473),(4381,474),(4382,474),(4383,474),(4384,474),(4385,475),(4386,475),(4387,475),(4388,475),(4389,476),(4390,476),(4391,476),(4392,476),(4393,477),(4394,477),(4395,477),(4396,477),(4397,478),(4398,478),(4399,478),(4400,478),(4401,479),(4402,479),(4403,479),(4404,479),(4405,480),(4406,480),(4407,480),(4408,480),(4409,481),(4410,482),(4411,483),(4412,484),(4413,485),(4414,486),(4415,487),(4416,488),(4417,489),(4418,490),(4419,491),(4420,492),(4421,493),(4422,494),(4423,495),(4424,496),(4425,497),(4426,498),(4427,499),(4428,500),(4429,501),(4430,502),(4431,503),(4432,504),(4433,505),(4434,506),(4435,507),(4436,508),(4437,509),(4438,510),(4439,511),(4440,512),(4441,513),(4442,514),(4443,515),(4444,516),(4445,517),(4446,518),(4447,519),(4448,520),(4449,521),(4450,522),(4451,523),(4452,524),(4453,525),(4454,526),(4455,527),(4456,528),(4457,529),(4458,530),(4459,531),(4460,532),(4461,533),(4462,534),(4463,535),(4464,536),(4465,537),(4466,538),(4467,539),(4468,540),(4469,541),(4470,542),(4471,543),(4472,544),(4473,545),(4474,546),(4475,547),(4476,548),(4477,549),(4478,550),(4479,551),(4480,552),(4481,553),(4482,554),(4483,555),(4484,556),(4485,557),(4486,558),(4487,559),(4488,560),(4489,561),(4490,562),(4491,563),(4492,564),(4493,565),(4494,566),(4495,567),(4496,568),(4497,569),(4498,570),(4499,571),(4500,572),(4501,573),(4502,574),(4503,575),(4504,576),(4505,577),(4506,578),(4507,579),(4508,580),(4509,481),(4510,482),(4511,483),(4512,484),(4513,485),(4514,486),(4515,487),(4516,488),(4517,489),(4518,490),(4519,491),(4520,492),(4521,493),(4522,494),(4523,495),(4524,496),(4525,497),(4526,498),(4527,499),(4528,500),(4529,501),(4530,502),(4531,503),(4532,504),(4533,505),(4534,506),(4535,507),(4536,508),(4537,509),(4538,510),(4539,511),(4540,512),(4541,513),(4542,514),(4543,515),(4544,516),(4545,517),(4546,518),(4547,519),(4548,520),(4549,521),(4550,522),(4551,523),(4552,524),(4553,525),(4554,526),(4555,527),(4556,528),(4557,529),(4558,530),(4559,531),(4560,532),(4561,533),(4562,534),(4563,535),(4564,536),(4565,537),(4566,538),(4567,539),(4568,540),(4569,541),(4570,542),(4571,543),(4572,544),(4573,545),(4574,546),(4575,547),(4576,548),(4577,549),(4578,550),(4579,551),(4580,552),(4581,553),(4582,554),(4583,555),(4584,556),(4585,557),(4586,558),(4587,559),(4588,560),(4589,561),(4590,562),(4591,563),(4592,564),(4593,565),(4594,566),(4595,567),(4596,568),(4597,569),(4598,570),(4599,571),(4600,572),(4601,573),(4602,574),(4603,575),(4604,576),(4605,577),(4606,578),(4607,579),(4608,580),(4609,481),(4610,481),(4611,481),(4612,482),(4613,482),(4614,482),(4615,483),(4616,483),(4617,483),(4618,484),(4619,484),(4620,484),(4621,485),(4622,485),(4623,485),(4624,486),(4625,486),(4626,486),(4627,487),(4628,487),(4629,487),(4630,488),(4631,488),(4632,488),(4633,489),(4634,489),(4635,489),(4636,490),(4637,490),(4638,490),(4639,491),(4640,491),(4641,491),(4642,492),(4643,492),(4644,492),(4645,493),(4646,493),(4647,493),(4648,494),(4649,494),(4650,494),(4651,495),(4652,495),(4653,495),(4654,496),(4655,496),(4656,496),(4657,497),(4658,497),(4659,497),(4660,498),(4661,498),(4662,498),(4663,499),(4664,499),(4665,499),(4666,500),(4667,500),(4668,500),(4669,501),(4670,501),(4671,501),(4672,502),(4673,502),(4674,502),(4675,503),(4676,503),(4677,503),(4678,504),(4679,504),(4680,504),(4681,505),(4682,505),(4683,505),(4684,506),(4685,506),(4686,506),(4687,507),(4688,507),(4689,507),(4690,508),(4691,508),(4692,508),(4693,509),(4694,509),(4695,509),(4696,510),(4697,510),(4698,510),(4699,511),(4700,511),(4701,511),(4702,512),(4703,512),(4704,512),(4705,513),(4706,513),(4707,513),(4708,514),(4709,514),(4710,514),(4711,515),(4712,515),(4713,515),(4714,516),(4715,516),(4716,516),(4717,517),(4718,517),(4719,517),(4720,518),(4721,518),(4722,518),(4723,519),(4724,519),(4725,519),(4726,520),(4727,520),(4728,520),(4729,521),(4730,521),(4731,521),(4732,522),(4733,522),(4734,522),(4735,523),(4736,523),(4737,523),(4738,524),(4739,524),(4740,524),(4741,525),(4742,525),(4743,525),(4744,526),(4745,526),(4746,526),(4747,527),(4748,527),(4749,527),(4750,528),(4751,528),(4752,528),(4753,529),(4754,529),(4755,529),(4756,530),(4757,530),(4758,530),(4759,531),(4760,531),(4761,531),(4762,532),(4763,532),(4764,532),(4765,533),(4766,533),(4767,533),(4768,534),(4769,534),(4770,534),(4771,535),(4772,535),(4773,535),(4774,536),(4775,536),(4776,536),(4777,537),(4778,537),(4779,537),(4780,538),(4781,538),(4782,538),(4783,539),(4784,539),(4785,539),(4786,540),(4787,540),(4788,540),(4789,541),(4790,541),(4791,541),(4792,542),(4793,542),(4794,542),(4795,543),(4796,543),(4797,543),(4798,544),(4799,544),(4800,544),(4801,545),(4802,545),(4803,545),(4804,546),(4805,546),(4806,546),(4807,547),(4808,547),(4809,547),(4810,548),(4811,548),(4812,548),(4813,549),(4814,549),(4815,549),(4816,550),(4817,550),(4818,550),(4819,551),(4820,551),(4821,551),(4822,552),(4823,552),(4824,552),(4825,553),(4826,553),(4827,553),(4828,554),(4829,554),(4830,554),(4831,555),(4832,555),(4833,555),(4834,556),(4835,556),(4836,556),(4837,557),(4838,557),(4839,557),(4840,558),(4841,558),(4842,558),(4843,559),(4844,559),(4845,559),(4846,560),(4847,560),(4848,560),(4849,561),(4850,561),(4851,561),(4852,562),(4853,562),(4854,562),(4855,563),(4856,563),(4857,563),(4858,564),(4859,564),(4860,564),(4861,565),(4862,565),(4863,565),(4864,566),(4865,566),(4866,566),(4867,567),(4868,567),(4869,567),(4870,568),(4871,568),(4872,568),(4873,569),(4874,569),(4875,569),(4876,570),(4877,570),(4878,570),(4879,571),(4880,571),(4881,571),(4882,572),(4883,572),(4884,572),(4885,573),(4886,573),(4887,573),(4888,574),(4889,574),(4890,574),(4891,575),(4892,575),(4893,575),(4894,576),(4895,576),(4896,576),(4897,577),(4898,577),(4899,577),(4900,578),(4901,578),(4902,578),(4903,579),(4904,579),(4905,579),(4906,580),(4907,580),(4908,580),(4909,481),(4910,481),(4911,481),(4912,481),(4913,482),(4914,482),(4915,482),(4916,482),(4917,483),(4918,483),(4919,483),(4920,483),(4921,484),(4922,484),(4923,484),(4924,484),(4925,485),(4926,485),(4927,485),(4928,485),(4929,486),(4930,486),(4931,486),(4932,486),(4933,487),(4934,487),(4935,487),(4936,487),(4937,488),(4938,488),(4939,488),(4940,488),(4941,489),(4942,489),(4943,489),(4944,489),(4945,490),(4946,490),(4947,490),(4948,490),(4949,491),(4950,491),(4951,491),(4952,491),(4953,492),(4954,492),(4955,492),(4956,492),(4957,493),(4958,493),(4959,493),(4960,493),(4961,494),(4962,494),(4963,494),(4964,494),(4965,495),(4966,495),(4967,495),(4968,495),(4969,496),(4970,496),(4971,496),(4972,496),(4973,497),(4974,497),(4975,497),(4976,497),(4977,498),(4978,498),(4979,498),(4980,498),(4981,499),(4982,499),(4983,499),(4984,499),(4985,500),(4986,500),(4987,500),(4988,500),(4989,501),(4990,501),(4991,501),(4992,501),(4993,502),(4994,502),(4995,502),(4996,502),(4997,503),(4998,503),(4999,503),(5000,503),(5001,504),(5002,504),(5003,504),(5004,504),(5005,505),(5006,505),(5007,505),(5008,505),(5009,506),(5010,506),(5011,506),(5012,506),(5013,507),(5014,507),(5015,507),(5016,507),(5017,508),(5018,508),(5019,508),(5020,508),(5021,509),(5022,509),(5023,509),(5024,509),(5025,510),(5026,510),(5027,510),(5028,510),(5029,511),(5030,511),(5031,511),(5032,511),(5033,512),(5034,512),(5035,512),(5036,512),(5037,513),(5038,513),(5039,513),(5040,513),(5041,514),(5042,514),(5043,514),(5044,514),(5045,515),(5046,515),(5047,515),(5048,515),(5049,516),(5050,516),(5051,516),(5052,516),(5053,517),(5054,517),(5055,517),(5056,517),(5057,518),(5058,518),(5059,518),(5060,518),(5061,519),(5062,519),(5063,519),(5064,519),(5065,520),(5066,520),(5067,520),(5068,520),(5069,521),(5070,521),(5071,521),(5072,521),(5073,522),(5074,522),(5075,522),(5076,522),(5077,523),(5078,523),(5079,523),(5080,523),(5081,524),(5082,524),(5083,524),(5084,524),(5085,525),(5086,525),(5087,525),(5088,525),(5089,526),(5090,526),(5091,526),(5092,526),(5093,527),(5094,527),(5095,527),(5096,527),(5097,528),(5098,528),(5099,528),(5100,528),(5101,529),(5102,529),(5103,529),(5104,529),(5105,530),(5106,530),(5107,530),(5108,530),(5109,531),(5110,531),(5111,531),(5112,531),(5113,532),(5114,532),(5115,532),(5116,532),(5117,533),(5118,533),(5119,533),(5120,533),(5121,534),(5122,534),(5123,534),(5124,534),(5125,535),(5126,535),(5127,535),(5128,535),(5129,536),(5130,536),(5131,536),(5132,536),(5133,537),(5134,537),(5135,537),(5136,537),(5137,538),(5138,538),(5139,538),(5140,538),(5141,539),(5142,539),(5143,539),(5144,539),(5145,540),(5146,540),(5147,540),(5148,540),(5149,541),(5150,541),(5151,541),(5152,541),(5153,542),(5154,542),(5155,542),(5156,542),(5157,543),(5158,543),(5159,543),(5160,543),(5161,544),(5162,544),(5163,544),(5164,544),(5165,545),(5166,545),(5167,545),(5168,545),(5169,546),(5170,546),(5171,546),(5172,546),(5173,547),(5174,547),(5175,547),(5176,547),(5177,548),(5178,548),(5179,548),(5180,548),(5181,549),(5182,549),(5183,549),(5184,549),(5185,550),(5186,550),(5187,550),(5188,550),(5189,551),(5190,551),(5191,551),(5192,551),(5193,552),(5194,552),(5195,552),(5196,552),(5197,553),(5198,553),(5199,553),(5200,553),(5201,554),(5202,554),(5203,554),(5204,554),(5205,555),(5206,555),(5207,555),(5208,555),(5209,556),(5210,556),(5211,556),(5212,556),(5213,557),(5214,557),(5215,557),(5216,557),(5217,558),(5218,558),(5219,558),(5220,558),(5221,559),(5222,559),(5223,559),(5224,559),(5225,560),(5226,560),(5227,560),(5228,560),(5229,561),(5230,561),(5231,561),(5232,561),(5233,562),(5234,562),(5235,562),(5236,562),(5237,563),(5238,563),(5239,563),(5240,563),(5241,564),(5242,564),(5243,564),(5244,564),(5245,565),(5246,565),(5247,565),(5248,565),(5249,566),(5250,566),(5251,566),(5252,566),(5253,567),(5254,567),(5255,567),(5256,567),(5257,568),(5258,568),(5259,568),(5260,568),(5261,569),(5262,569),(5263,569),(5264,569),(5265,570),(5266,570),(5267,570),(5268,570),(5269,571),(5270,571),(5271,571),(5272,571),(5273,572),(5274,572),(5275,572),(5276,572),(5277,573),(5278,573),(5279,573),(5280,573),(5281,574),(5282,574),(5283,574),(5284,574),(5285,575),(5286,575),(5287,575),(5288,575),(5289,576),(5290,576),(5291,576),(5292,576),(5293,577),(5294,577),(5295,577),(5296,577),(5297,578),(5298,578),(5299,578),(5300,578),(5301,579),(5302,579),(5303,579),(5304,579),(5305,580),(5306,580),(5307,580),(5308,580),(5309,581),(5310,582),(5311,583),(5312,584),(5313,585),(5314,586),(5315,587),(5316,588),(5317,589),(5318,590),(5319,591),(5320,592),(5321,593),(5322,594),(5323,595),(5324,596),(5325,597),(5326,598),(5327,599),(5328,600),(5329,601),(5330,602),(5331,603),(5332,604),(5333,605),(5334,606),(5335,607),(5336,608),(5337,609),(5338,610),(5339,611),(5340,612),(5341,613),(5342,614),(5343,615),(5344,616),(5345,617),(5346,618),(5347,619),(5348,620),(5349,621),(5350,622),(5351,623),(5352,624),(5353,625),(5354,626),(5355,627),(5356,628),(5357,629),(5358,630),(5359,631),(5360,632),(5361,633),(5362,634),(5363,635),(5364,636),(5365,637),(5366,638),(5367,639),(5368,640),(5369,641),(5370,642),(5371,643),(5372,644),(5373,645),(5374,646),(5375,647),(5376,648),(5377,649),(5378,650),(5379,651),(5380,652),(5381,653),(5382,654),(5383,655),(5384,656),(5385,657),(5386,658),(5387,659),(5388,660),(5389,661),(5390,662),(5391,663),(5392,664),(5393,665),(5394,666),(5395,667),(5396,668),(5397,669),(5398,670),(5399,671),(5400,672),(5401,673),(5402,674),(5403,675),(5404,676),(5405,677),(5406,678),(5407,679),(5408,680),(5409,581),(5410,582),(5411,583),(5412,584),(5413,585),(5414,586),(5415,587),(5416,588),(5417,589),(5418,590),(5419,591),(5420,592),(5421,593),(5422,594),(5423,595),(5424,596),(5425,597),(5426,598),(5427,599),(5428,600),(5429,601),(5430,602),(5431,603),(5432,604),(5433,605),(5434,606),(5435,607),(5436,608),(5437,609),(5438,610),(5439,611),(5440,612),(5441,613),(5442,614),(5443,615),(5444,616),(5445,617),(5446,618),(5447,619),(5448,620),(5449,621),(5450,622),(5451,623),(5452,624),(5453,625),(5454,626),(5455,627),(5456,628),(5457,629),(5458,630),(5459,631),(5460,632),(5461,633),(5462,634),(5463,635),(5464,636),(5465,637),(5466,638),(5467,639),(5468,640),(5469,641),(5470,642),(5471,643),(5472,644),(5473,645),(5474,646),(5475,647),(5476,648),(5477,649),(5478,650),(5479,651),(5480,652),(5481,653),(5482,654),(5483,655),(5484,656),(5485,657),(5486,658),(5487,659),(5488,660),(5489,661),(5490,662),(5491,663),(5492,664),(5493,665),(5494,666),(5495,667),(5496,668),(5497,669),(5498,670),(5499,671),(5500,672),(5501,673),(5502,674),(5503,675),(5504,676),(5505,677),(5506,678),(5507,679),(5508,680),(5509,581),(5510,581),(5511,581),(5512,582),(5513,582),(5514,582),(5515,583),(5516,583),(5517,583),(5518,584),(5519,584),(5520,584),(5521,585),(5522,585),(5523,585),(5524,586),(5525,586),(5526,586),(5527,587),(5528,587),(5529,587),(5530,588),(5531,588),(5532,588),(5533,589),(5534,589),(5535,589),(5536,590),(5537,590),(5538,590),(5539,591),(5540,591),(5541,591),(5542,592),(5543,592),(5544,592),(5545,593),(5546,593),(5547,593),(5548,594),(5549,594),(5550,594),(5551,595),(5552,595),(5553,595),(5554,596),(5555,596),(5556,596),(5557,597),(5558,597),(5559,597),(5560,598),(5561,598),(5562,598),(5563,599),(5564,599),(5565,599),(5566,600),(5567,600),(5568,600),(5569,601),(5570,601),(5571,601),(5572,602),(5573,602),(5574,602),(5575,603),(5576,603),(5577,603),(5578,604),(5579,604),(5580,604),(5581,605),(5582,605),(5583,605),(5584,606),(5585,606),(5586,606),(5587,607),(5588,607),(5589,607),(5590,608),(5591,608),(5592,608),(5593,609),(5594,609),(5595,609),(5596,610),(5597,610),(5598,610),(5599,611),(5600,611),(5601,611),(5602,612),(5603,612),(5604,612),(5605,613),(5606,613),(5607,613),(5608,614),(5609,614),(5610,614),(5611,615),(5612,615),(5613,615),(5614,616),(5615,616),(5616,616),(5617,617),(5618,617),(5619,617),(5620,618),(5621,618),(5622,618),(5623,619),(5624,619),(5625,619),(5626,620),(5627,620),(5628,620),(5629,621),(5630,621),(5631,621),(5632,622),(5633,622),(5634,622),(5635,623),(5636,623),(5637,623),(5638,624),(5639,624),(5640,624),(5641,625),(5642,625),(5643,625),(5644,626),(5645,626),(5646,626),(5647,627),(5648,627),(5649,627),(5650,628),(5651,628),(5652,628),(5653,629),(5654,629),(5655,629),(5656,630),(5657,630),(5658,630),(5659,631),(5660,631),(5661,631),(5662,632),(5663,632),(5664,632),(5665,633),(5666,633),(5667,633),(5668,634),(5669,634),(5670,634),(5671,635),(5672,635),(5673,635),(5674,636),(5675,636),(5676,636),(5677,637),(5678,637),(5679,637),(5680,638),(5681,638),(5682,638),(5683,639),(5684,639),(5685,639),(5686,640),(5687,640),(5688,640),(5689,641),(5690,641),(5691,641),(5692,642),(5693,642),(5694,642),(5695,643),(5696,643),(5697,643),(5698,644),(5699,644),(5700,644),(5701,645),(5702,645),(5703,645),(5704,646),(5705,646),(5706,646),(5707,647),(5708,647),(5709,647),(5710,648),(5711,648),(5712,648),(5713,649),(5714,649),(5715,649),(5716,650),(5717,650),(5718,650),(5719,651),(5720,651),(5721,651),(5722,652),(5723,652),(5724,652),(5725,653),(5726,653),(5727,653),(5728,654),(5729,654),(5730,654),(5731,655),(5732,655),(5733,655),(5734,656),(5735,656),(5736,656),(5737,657),(5738,657),(5739,657),(5740,658),(5741,658),(5742,658),(5743,659),(5744,659),(5745,659),(5746,660),(5747,660),(5748,660),(5749,661),(5750,661),(5751,661),(5752,662),(5753,662),(5754,662),(5755,663),(5756,663),(5757,663),(5758,664),(5759,664),(5760,664),(5761,665),(5762,665),(5763,665),(5764,666),(5765,666),(5766,666),(5767,667),(5768,667),(5769,667),(5770,668),(5771,668),(5772,668),(5773,669),(5774,669),(5775,669),(5776,670),(5777,670),(5778,670),(5779,671),(5780,671),(5781,671),(5782,672),(5783,672),(5784,672),(5785,673),(5786,673),(5787,673),(5788,674),(5789,674),(5790,674),(5791,675),(5792,675),(5793,675),(5794,676),(5795,676),(5796,676),(5797,677),(5798,677),(5799,677),(5800,678),(5801,678),(5802,678),(5803,679),(5804,679),(5805,679),(5806,680),(5807,680),(5808,680),(5809,581),(5810,581),(5811,581),(5812,581),(5813,582),(5814,582),(5815,582),(5816,582),(5817,583),(5818,583),(5819,583),(5820,583),(5821,584),(5822,584),(5823,584),(5824,584),(5825,585),(5826,585),(5827,585),(5828,585),(5829,586),(5830,586),(5831,586),(5832,586),(5833,587),(5834,587),(5835,587),(5836,587),(5837,588),(5838,588),(5839,588),(5840,588),(5841,589),(5842,589),(5843,589),(5844,589),(5845,590),(5846,590),(5847,590),(5848,590),(5849,591),(5850,591),(5851,591),(5852,591),(5853,592),(5854,592),(5855,592),(5856,592),(5857,593),(5858,593),(5859,593),(5860,593),(5861,594),(5862,594),(5863,594),(5864,594),(5865,595),(5866,595),(5867,595),(5868,595),(5869,596),(5870,596),(5871,596),(5872,596),(5873,597),(5874,597),(5875,597),(5876,597),(5877,598),(5878,598),(5879,598),(5880,598),(5881,599),(5882,599),(5883,599),(5884,599),(5885,600),(5886,600),(5887,600),(5888,600),(5889,601),(5890,601),(5891,601),(5892,601),(5893,602),(5894,602),(5895,602),(5896,602),(5897,603),(5898,603),(5899,603),(5900,603),(5901,604),(5902,604),(5903,604),(5904,604),(5905,605),(5906,605),(5907,605),(5908,605),(5909,606),(5910,606),(5911,606),(5912,606),(5913,607),(5914,607),(5915,607),(5916,607),(5917,608),(5918,608),(5919,608),(5920,608),(5921,609),(5922,609),(5923,609),(5924,609),(5925,610),(5926,610),(5927,610),(5928,610),(5929,611),(5930,611),(5931,611),(5932,611),(5933,612),(5934,612),(5935,612),(5936,612),(5937,613),(5938,613),(5939,613),(5940,613),(5941,614),(5942,614),(5943,614),(5944,614),(5945,615),(5946,615),(5947,615),(5948,615),(5949,616),(5950,616),(5951,616),(5952,616),(5953,617),(5954,617),(5955,617),(5956,617),(5957,618),(5958,618),(5959,618),(5960,618),(5961,619),(5962,619),(5963,619),(5964,619),(5965,620),(5966,620),(5967,620),(5968,620),(5969,621),(5970,621),(5971,621),(5972,621),(5973,622),(5974,622),(5975,622),(5976,622),(5977,623),(5978,623),(5979,623),(5980,623),(5981,624),(5982,624),(5983,624),(5984,624),(5985,625),(5986,625),(5987,625),(5988,625),(5989,626),(5990,626),(5991,626),(5992,626),(5993,627),(5994,627),(5995,627),(5996,627),(5997,628),(5998,628),(5999,628),(6000,628),(6001,629),(6002,629),(6003,629),(6004,629),(6005,630),(6006,630),(6007,630),(6008,630),(6009,631),(6010,631),(6011,631),(6012,631),(6013,632),(6014,632),(6015,632),(6016,632),(6017,633),(6018,633),(6019,633),(6020,633),(6021,634),(6022,634),(6023,634),(6024,634),(6025,635),(6026,635),(6027,635),(6028,635),(6029,636),(6030,636),(6031,636),(6032,636),(6033,637),(6034,637),(6035,637),(6036,637),(6037,638),(6038,638),(6039,638),(6040,638),(6041,639),(6042,639),(6043,639),(6044,639),(6045,640),(6046,640),(6047,640),(6048,640),(6049,641),(6050,641),(6051,641),(6052,641),(6053,642),(6054,642),(6055,642),(6056,642),(6057,643),(6058,643),(6059,643),(6060,643),(6061,644),(6062,644),(6063,644),(6064,644),(6065,645),(6066,645),(6067,645),(6068,645),(6069,646),(6070,646),(6071,646),(6072,646),(6073,647),(6074,647),(6075,647),(6076,647),(6077,648),(6078,648),(6079,648),(6080,648),(6081,649),(6082,649),(6083,649),(6084,649),(6085,650),(6086,650),(6087,650),(6088,650),(6089,651),(6090,651),(6091,651),(6092,651),(6093,652),(6094,652),(6095,652),(6096,652),(6097,653),(6098,653),(6099,653),(6100,653),(6101,654),(6102,654),(6103,654),(6104,654),(6105,655),(6106,655),(6107,655),(6108,655),(6109,656),(6110,656),(6111,656),(6112,656),(6113,657),(6114,657),(6115,657),(6116,657),(6117,658),(6118,658),(6119,658),(6120,658),(6121,659),(6122,659),(6123,659),(6124,659),(6125,660),(6126,660),(6127,660),(6128,660),(6129,661),(6130,661),(6131,661),(6132,661),(6133,662),(6134,662),(6135,662),(6136,662),(6137,663),(6138,663),(6139,663),(6140,663),(6141,664),(6142,664),(6143,664),(6144,664),(6145,665),(6146,665),(6147,665),(6148,665),(6149,666),(6150,666),(6151,666),(6152,666),(6153,667),(6154,667),(6155,667),(6156,667),(6157,668),(6158,668),(6159,668),(6160,668),(6161,669),(6162,669),(6163,669),(6164,669),(6165,670),(6166,670),(6167,670),(6168,670),(6169,671),(6170,671),(6171,671),(6172,671),(6173,672),(6174,672),(6175,672),(6176,672),(6177,673),(6178,673),(6179,673),(6180,673),(6181,674),(6182,674),(6183,674),(6184,674),(6185,675),(6186,675),(6187,675),(6188,675),(6189,676),(6190,676),(6191,676),(6192,676),(6193,677),(6194,677),(6195,677),(6196,677),(6197,678),(6198,678),(6199,678),(6200,678),(6201,679),(6202,679),(6203,679),(6204,679),(6205,680),(6206,680),(6207,680),(6208,680),(6209,681),(6210,682),(6211,683),(6212,684),(6213,685),(6214,686),(6215,687),(6216,688),(6217,689),(6218,690),(6219,691),(6220,692),(6221,693),(6222,694),(6223,695),(6224,696),(6225,697),(6226,698),(6227,699),(6228,700),(6229,701),(6230,702),(6231,703),(6232,704),(6233,705),(6234,706),(6235,707),(6236,708),(6237,709),(6238,710),(6239,711),(6240,712),(6241,713),(6242,714),(6243,715),(6244,716),(6245,717),(6246,718),(6247,719),(6248,720),(6249,721),(6250,722),(6251,723),(6252,724),(6253,725),(6254,726),(6255,727),(6256,728),(6257,729),(6258,730),(6259,731),(6260,732),(6261,733),(6262,734),(6263,735),(6264,736),(6265,737),(6266,738),(6267,739),(6268,740),(6269,741),(6270,742),(6271,743),(6272,744),(6273,745),(6274,746),(6275,747),(6276,748),(6277,749),(6278,750),(6279,751),(6280,752),(6281,753),(6282,754),(6283,755),(6284,756),(6285,757),(6286,758),(6287,759),(6288,760),(6289,761),(6290,762),(6291,763),(6292,764),(6293,765),(6294,766),(6295,767),(6296,768),(6297,769),(6298,770),(6299,771),(6300,772),(6301,773),(6302,774),(6303,775),(6304,776),(6305,777),(6306,778),(6307,779),(6308,780),(6309,681),(6310,682),(6311,683),(6312,684),(6313,685),(6314,686),(6315,687),(6316,688),(6317,689),(6318,690),(6319,691),(6320,692),(6321,693),(6322,694),(6323,695),(6324,696),(6325,697),(6326,698),(6327,699),(6328,700),(6329,701),(6330,702),(6331,703),(6332,704),(6333,705),(6334,706),(6335,707),(6336,708),(6337,709),(6338,710),(6339,711),(6340,712),(6341,713),(6342,714),(6343,715),(6344,716),(6345,717),(6346,718),(6347,719),(6348,720),(6349,721),(6350,722),(6351,723),(6352,724),(6353,725),(6354,726),(6355,727),(6356,728),(6357,729),(6358,730),(6359,731),(6360,732),(6361,733),(6362,734),(6363,735),(6364,736),(6365,737),(6366,738),(6367,739),(6368,740),(6369,741),(6370,742),(6371,743),(6372,744),(6373,745),(6374,746),(6375,747),(6376,748),(6377,749),(6378,750),(6379,751),(6380,752),(6381,753),(6382,754),(6383,755),(6384,756),(6385,757),(6386,758),(6387,759),(6388,760),(6389,761),(6390,762),(6391,763),(6392,764),(6393,765),(6394,766),(6395,767),(6396,768),(6397,769),(6398,770),(6399,771),(6400,772),(6401,773),(6402,774),(6403,775),(6404,776),(6405,777),(6406,778),(6407,779),(6408,780),(6409,681),(6410,681),(6411,681),(6412,682),(6413,682),(6414,682),(6415,683),(6416,683),(6417,683),(6418,684),(6419,684),(6420,684),(6421,685),(6422,685),(6423,685),(6424,686),(6425,686),(6426,686),(6427,687),(6428,687),(6429,687),(6430,688),(6431,688),(6432,688),(6433,689),(6434,689),(6435,689),(6436,690),(6437,690),(6438,690),(6439,691),(6440,691),(6441,691),(6442,692),(6443,692),(6444,692),(6445,693),(6446,693),(6447,693),(6448,694),(6449,694),(6450,694),(6451,695),(6452,695),(6453,695),(6454,696),(6455,696),(6456,696),(6457,697),(6458,697),(6459,697),(6460,698),(6461,698),(6462,698),(6463,699),(6464,699),(6465,699),(6466,700),(6467,700),(6468,700),(6469,701),(6470,701),(6471,701),(6472,702),(6473,702),(6474,702),(6475,703),(6476,703),(6477,703),(6478,704),(6479,704),(6480,704),(6481,705),(6482,705),(6483,705),(6484,706),(6485,706),(6486,706),(6487,707),(6488,707),(6489,707),(6490,708),(6491,708),(6492,708),(6493,709),(6494,709),(6495,709),(6496,710),(6497,710),(6498,710),(6499,711),(6500,711),(6501,711),(6502,712),(6503,712),(6504,712),(6505,713),(6506,713),(6507,713),(6508,714),(6509,714),(6510,714),(6511,715),(6512,715),(6513,715),(6514,716),(6515,716),(6516,716),(6517,717),(6518,717),(6519,717),(6520,718),(6521,718),(6522,718),(6523,719),(6524,719),(6525,719),(6526,720),(6527,720),(6528,720),(6529,721),(6530,721),(6531,721),(6532,722),(6533,722),(6534,722),(6535,723),(6536,723),(6537,723),(6538,724),(6539,724),(6540,724),(6541,725),(6542,725),(6543,725),(6544,726),(6545,726),(6546,726),(6547,727),(6548,727),(6549,727),(6550,728),(6551,728),(6552,728),(6553,729),(6554,729),(6555,729),(6556,730),(6557,730),(6558,730),(6559,731),(6560,731),(6561,731),(6562,732),(6563,732),(6564,732),(6565,733),(6566,733),(6567,733),(6568,734),(6569,734),(6570,734),(6571,735),(6572,735),(6573,735),(6574,736),(6575,736),(6576,736),(6577,737),(6578,737),(6579,737),(6580,738),(6581,738),(6582,738),(6583,739),(6584,739),(6585,739),(6586,740),(6587,740),(6588,740),(6589,741),(6590,741),(6591,741),(6592,742),(6593,742),(6594,742),(6595,743),(6596,743),(6597,743),(6598,744),(6599,744),(6600,744),(6601,745),(6602,745),(6603,745),(6604,746),(6605,746),(6606,746),(6607,747),(6608,747),(6609,747),(6610,748),(6611,748),(6612,748),(6613,749),(6614,749),(6615,749),(6616,750),(6617,750),(6618,750),(6619,751),(6620,751),(6621,751),(6622,752),(6623,752),(6624,752),(6625,753),(6626,753),(6627,753),(6628,754),(6629,754),(6630,754),(6631,755),(6632,755),(6633,755),(6634,756),(6635,756),(6636,756),(6637,757),(6638,757),(6639,757),(6640,758),(6641,758),(6642,758),(6643,759),(6644,759),(6645,759),(6646,760),(6647,760),(6648,760),(6649,761),(6650,761),(6651,761),(6652,762),(6653,762),(6654,762),(6655,763),(6656,763),(6657,763),(6658,764),(6659,764),(6660,764),(6661,765),(6662,765),(6663,765),(6664,766),(6665,766),(6666,766),(6667,767),(6668,767),(6669,767),(6670,768),(6671,768),(6672,768),(6673,769),(6674,769),(6675,769),(6676,770),(6677,770),(6678,770),(6679,771),(6680,771),(6681,771),(6682,772),(6683,772),(6684,772),(6685,773),(6686,773),(6687,773),(6688,774),(6689,774),(6690,774),(6691,775),(6692,775),(6693,775),(6694,776),(6695,776),(6696,776),(6697,777),(6698,777),(6699,777),(6700,778),(6701,778),(6702,778),(6703,779),(6704,779),(6705,779),(6706,780),(6707,780),(6708,780),(6709,681),(6710,681),(6711,681),(6712,681),(6713,682),(6714,682),(6715,682),(6716,682),(6717,683),(6718,683),(6719,683),(6720,683),(6721,684),(6722,684),(6723,684),(6724,684),(6725,685),(6726,685),(6727,685),(6728,685),(6729,686),(6730,686),(6731,686),(6732,686),(6733,687),(6734,687),(6735,687),(6736,687),(6737,688),(6738,688),(6739,688),(6740,688),(6741,689),(6742,689),(6743,689),(6744,689),(6745,690),(6746,690),(6747,690),(6748,690),(6749,691),(6750,691),(6751,691),(6752,691),(6753,692),(6754,692),(6755,692),(6756,692),(6757,693),(6758,693),(6759,693),(6760,693),(6761,694),(6762,694),(6763,694),(6764,694),(6765,695),(6766,695),(6767,695),(6768,695),(6769,696),(6770,696),(6771,696),(6772,696),(6773,697),(6774,697),(6775,697),(6776,697),(6777,698),(6778,698),(6779,698),(6780,698),(6781,699),(6782,699),(6783,699),(6784,699),(6785,700),(6786,700),(6787,700),(6788,700),(6789,701),(6790,701),(6791,701),(6792,701),(6793,702),(6794,702),(6795,702),(6796,702),(6797,703),(6798,703),(6799,703),(6800,703),(6801,704),(6802,704),(6803,704),(6804,704),(6805,705),(6806,705),(6807,705),(6808,705),(6809,706),(6810,706),(6811,706),(6812,706),(6813,707),(6814,707),(6815,707),(6816,707),(6817,708),(6818,708),(6819,708),(6820,708),(6821,709),(6822,709),(6823,709),(6824,709),(6825,710),(6826,710),(6827,710),(6828,710),(6829,711),(6830,711),(6831,711),(6832,711),(6833,712),(6834,712),(6835,712),(6836,712),(6837,713),(6838,713),(6839,713),(6840,713),(6841,714),(6842,714),(6843,714),(6844,714),(6845,715),(6846,715),(6847,715),(6848,715),(6849,716),(6850,716),(6851,716),(6852,716),(6853,717),(6854,717),(6855,717),(6856,717),(6857,718),(6858,718),(6859,718),(6860,718),(6861,719),(6862,719),(6863,719),(6864,719),(6865,720),(6866,720),(6867,720),(6868,720),(6869,721),(6870,721),(6871,721),(6872,721),(6873,722),(6874,722),(6875,722),(6876,722),(6877,723),(6878,723),(6879,723),(6880,723),(6881,724),(6882,724),(6883,724),(6884,724),(6885,725),(6886,725),(6887,725),(6888,725),(6889,726),(6890,726),(6891,726),(6892,726),(6893,727),(6894,727),(6895,727),(6896,727),(6897,728),(6898,728),(6899,728),(6900,728),(6901,729),(6902,729),(6903,729),(6904,729),(6905,730),(6906,730),(6907,730),(6908,730),(6909,731),(6910,731),(6911,731),(6912,731),(6913,732),(6914,732),(6915,732),(6916,732),(6917,733),(6918,733),(6919,733),(6920,733),(6921,734),(6922,734),(6923,734),(6924,734),(6925,735),(6926,735),(6927,735),(6928,735),(6929,736),(6930,736),(6931,736),(6932,736),(6933,737),(6934,737),(6935,737),(6936,737),(6937,738),(6938,738),(6939,738),(6940,738),(6941,739),(6942,739),(6943,739),(6944,739),(6945,740),(6946,740),(6947,740),(6948,740),(6949,741),(6950,741),(6951,741),(6952,741),(6953,742),(6954,742),(6955,742),(6956,742),(6957,743),(6958,743),(6959,743),(6960,743),(6961,744),(6962,744),(6963,744),(6964,744),(6965,745),(6966,745),(6967,745),(6968,745),(6969,746),(6970,746),(6971,746),(6972,746),(6973,747),(6974,747),(6975,747),(6976,747),(6977,748),(6978,748),(6979,748),(6980,748),(6981,749),(6982,749),(6983,749),(6984,749),(6985,750),(6986,750),(6987,750),(6988,750),(6989,751),(6990,751),(6991,751),(6992,751),(6993,752),(6994,752),(6995,752),(6996,752),(6997,753),(6998,753),(6999,753),(7000,753),(7001,754),(7002,754),(7003,754),(7004,754),(7005,755),(7006,755),(7007,755),(7008,755),(7009,756),(7010,756),(7011,756),(7012,756),(7013,757),(7014,757),(7015,757),(7016,757),(7017,758),(7018,758),(7019,758),(7020,758),(7021,759),(7022,759),(7023,759),(7024,759),(7025,760),(7026,760),(7027,760),(7028,760),(7029,761),(7030,761),(7031,761),(7032,761),(7033,762),(7034,762),(7035,762),(7036,762),(7037,763),(7038,763),(7039,763),(7040,763),(7041,764),(7042,764),(7043,764),(7044,764),(7045,765),(7046,765),(7047,765),(7048,765),(7049,766),(7050,766),(7051,766),(7052,766),(7053,767),(7054,767),(7055,767),(7056,767),(7057,768),(7058,768),(7059,768),(7060,768),(7061,769),(7062,769),(7063,769),(7064,769),(7065,770),(7066,770),(7067,770),(7068,770),(7069,771),(7070,771),(7071,771),(7072,771),(7073,772),(7074,772),(7075,772),(7076,772),(7077,773),(7078,773),(7079,773),(7080,773),(7081,774),(7082,774),(7083,774),(7084,774),(7085,775),(7086,775),(7087,775),(7088,775),(7089,776),(7090,776),(7091,776),(7092,776),(7093,777),(7094,777),(7095,777),(7096,777),(7097,778),(7098,778),(7099,778),(7100,778),(7101,779),(7102,779),(7103,779),(7104,779),(7105,780),(7106,780),(7107,780),(7108,780),(7109,781),(7110,782),(7111,783),(7112,784),(7113,785),(7114,786),(7115,787),(7116,788),(7117,789),(7118,790),(7119,791),(7120,792),(7121,793),(7122,794),(7123,795),(7124,796),(7125,797),(7126,798),(7127,799),(7128,800),(7129,801),(7130,802),(7131,803),(7132,804),(7133,805),(7134,806),(7135,807),(7136,808),(7137,809),(7138,810),(7139,811),(7140,812),(7141,813),(7142,814),(7143,815),(7144,816),(7145,817),(7146,818),(7147,819),(7148,820),(7149,821),(7150,822),(7151,823),(7152,824),(7153,825),(7154,826),(7155,827),(7156,828),(7157,829),(7158,830),(7159,831),(7160,832),(7161,833),(7162,834),(7163,835),(7164,836),(7165,837),(7166,838),(7167,839),(7168,840),(7169,841),(7170,842),(7171,843),(7172,844),(7173,845),(7174,846),(7175,847),(7176,848),(7177,849),(7178,850),(7179,851),(7180,852),(7181,853),(7182,854),(7183,855),(7184,856),(7185,857),(7186,858),(7187,859),(7188,860),(7189,861),(7190,862),(7191,863),(7192,864),(7193,865),(7194,866),(7195,867),(7196,868),(7197,869),(7198,870),(7199,871),(7200,872),(7201,873),(7202,874),(7203,875),(7204,876),(7205,877),(7206,878),(7207,879),(7208,880),(7209,781),(7210,782),(7211,783),(7212,784),(7213,785),(7214,786),(7215,787),(7216,788),(7217,789),(7218,790),(7219,791),(7220,792),(7221,793),(7222,794),(7223,795),(7224,796),(7225,797),(7226,798),(7227,799),(7228,800),(7229,801),(7230,802),(7231,803),(7232,804),(7233,805),(7234,806),(7235,807),(7236,808),(7237,809),(7238,810),(7239,811),(7240,812),(7241,813),(7242,814),(7243,815),(7244,816),(7245,817),(7246,818),(7247,819),(7248,820),(7249,821),(7250,822),(7251,823),(7252,824),(7253,825),(7254,826),(7255,827),(7256,828),(7257,829),(7258,830),(7259,831),(7260,832),(7261,833),(7262,834),(7263,835),(7264,836),(7265,837),(7266,838),(7267,839),(7268,840),(7269,841),(7270,842),(7271,843),(7272,844),(7273,845),(7274,846),(7275,847),(7276,848),(7277,849),(7278,850),(7279,851),(7280,852),(7281,853),(7282,854),(7283,855),(7284,856),(7285,857),(7286,858),(7287,859),(7288,860),(7289,861),(7290,862),(7291,863),(7292,864),(7293,865),(7294,866),(7295,867),(7296,868),(7297,869),(7298,870),(7299,871),(7300,872),(7301,873),(7302,874),(7303,875),(7304,876),(7305,877),(7306,878),(7307,879),(7308,880),(7309,781),(7310,781),(7311,781),(7312,782),(7313,782),(7314,782),(7315,783),(7316,783),(7317,783),(7318,784),(7319,784),(7320,784),(7321,785),(7322,785),(7323,785),(7324,786),(7325,786),(7326,786),(7327,787),(7328,787),(7329,787),(7330,788),(7331,788),(7332,788),(7333,789),(7334,789),(7335,789),(7336,790),(7337,790),(7338,790),(7339,791),(7340,791),(7341,791),(7342,792),(7343,792),(7344,792),(7345,793),(7346,793),(7347,793),(7348,794),(7349,794),(7350,794),(7351,795),(7352,795),(7353,795),(7354,796),(7355,796),(7356,796),(7357,797),(7358,797),(7359,797),(7360,798),(7361,798),(7362,798),(7363,799),(7364,799),(7365,799),(7366,800),(7367,800),(7368,800),(7369,801),(7370,801),(7371,801),(7372,802),(7373,802),(7374,802),(7375,803),(7376,803),(7377,803),(7378,804),(7379,804),(7380,804),(7381,805),(7382,805),(7383,805),(7384,806),(7385,806),(7386,806),(7387,807),(7388,807),(7389,807),(7390,808),(7391,808),(7392,808),(7393,809),(7394,809),(7395,809),(7396,810),(7397,810),(7398,810),(7399,811),(7400,811),(7401,811),(7402,812),(7403,812),(7404,812),(7405,813),(7406,813),(7407,813),(7408,814),(7409,814),(7410,814),(7411,815),(7412,815),(7413,815),(7414,816),(7415,816),(7416,816),(7417,817),(7418,817),(7419,817),(7420,818),(7421,818),(7422,818),(7423,819),(7424,819),(7425,819),(7426,820),(7427,820),(7428,820),(7429,821),(7430,821),(7431,821),(7432,822),(7433,822),(7434,822),(7435,823),(7436,823),(7437,823),(7438,824),(7439,824),(7440,824),(7441,825),(7442,825),(7443,825),(7444,826),(7445,826),(7446,826),(7447,827),(7448,827),(7449,827),(7450,828),(7451,828),(7452,828),(7453,829),(7454,829),(7455,829),(7456,830),(7457,830),(7458,830),(7459,831),(7460,831),(7461,831),(7462,832),(7463,832),(7464,832),(7465,833),(7466,833),(7467,833),(7468,834),(7469,834),(7470,834),(7471,835),(7472,835),(7473,835),(7474,836),(7475,836),(7476,836),(7477,837),(7478,837),(7479,837),(7480,838),(7481,838),(7482,838),(7483,839),(7484,839),(7485,839),(7486,840),(7487,840),(7488,840),(7489,841),(7490,841),(7491,841),(7492,842),(7493,842),(7494,842),(7495,843),(7496,843),(7497,843),(7498,844),(7499,844),(7500,844),(7501,845),(7502,845),(7503,845),(7504,846),(7505,846),(7506,846),(7507,847),(7508,847),(7509,847),(7510,848),(7511,848),(7512,848),(7513,849),(7514,849),(7515,849),(7516,850),(7517,850),(7518,850),(7519,851),(7520,851),(7521,851),(7522,852),(7523,852),(7524,852),(7525,853),(7526,853),(7527,853),(7528,854),(7529,854),(7530,854),(7531,855),(7532,855),(7533,855),(7534,856),(7535,856),(7536,856),(7537,857),(7538,857),(7539,857),(7540,858),(7541,858),(7542,858),(7543,859),(7544,859),(7545,859),(7546,860),(7547,860),(7548,860),(7549,861),(7550,861),(7551,861),(7552,862),(7553,862),(7554,862),(7555,863),(7556,863),(7557,863),(7558,864),(7559,864),(7560,864),(7561,865),(7562,865),(7563,865),(7564,866),(7565,866),(7566,866),(7567,867),(7568,867),(7569,867),(7570,868),(7571,868),(7572,868),(7573,869),(7574,869),(7575,869),(7576,870),(7577,870),(7578,870),(7579,871),(7580,871),(7581,871),(7582,872),(7583,872),(7584,872),(7585,873),(7586,873),(7587,874),(7588,874),(7589,875),(7590,875),(7591,876),(7592,876),(7593,877),(7594,877),(7595,878),(7596,878),(7597,879),(7598,879),(7599,880),(7600,880),(7601,781),(7602,781),(7603,781),(7604,781),(7605,782),(7606,782),(7607,782),(7608,782),(7609,783),(7610,783),(7611,783),(7612,783),(7613,784),(7614,784),(7615,784),(7616,784),(7617,785),(7618,785),(7619,785),(7620,785),(7621,786),(7622,786),(7623,786),(7624,786),(7625,787),(7626,787),(7627,787),(7628,787),(7629,788),(7630,788),(7631,788),(7632,788),(7633,789),(7634,789),(7635,789),(7636,789),(7637,790),(7638,790),(7639,790),(7640,790),(7641,791),(7642,791),(7643,791),(7644,791),(7645,792),(7646,792),(7647,792),(7648,792),(7649,793),(7650,793),(7651,793),(7652,793),(7653,794),(7654,794),(7655,794),(7656,794),(7657,795),(7658,795),(7659,795),(7660,795),(7661,796),(7662,796),(7663,796),(7664,796),(7665,797),(7666,797),(7667,797),(7668,797),(7669,798),(7670,798),(7671,798),(7672,798),(7673,799),(7674,799),(7675,799),(7676,799),(7677,800),(7678,800),(7679,800),(7680,800),(7681,801),(7682,801),(7683,801),(7684,801),(7685,802),(7686,802),(7687,802),(7688,802),(7689,803),(7690,803),(7691,803),(7692,803),(7693,804),(7694,804),(7695,804),(7696,804),(7697,805),(7698,805),(7699,805),(7700,805),(7701,806),(7702,806),(7703,806),(7704,806),(7705,807),(7706,807),(7707,807),(7708,807),(7709,808),(7710,808),(7711,808),(7712,808),(7713,809),(7714,809),(7715,809),(7716,809),(7717,810),(7718,810),(7719,810),(7720,810),(7721,811),(7722,811),(7723,811),(7724,811),(7725,812),(7726,812),(7727,812),(7728,812),(7729,813),(7730,813),(7731,813),(7732,813),(7733,814),(7734,814),(7735,814),(7736,814),(7737,815),(7738,815),(7739,815),(7740,815),(7741,816),(7742,816),(7743,816),(7744,816),(7745,817),(7746,817),(7747,817),(7748,817),(7749,818),(7750,818),(7751,818),(7752,818),(7753,819),(7754,819),(7755,819),(7756,819),(7757,820),(7758,820),(7759,820),(7760,820),(7761,821),(7762,821),(7763,821),(7764,821),(7765,822),(7766,822),(7767,822),(7768,822),(7769,823),(7770,823),(7771,823),(7772,823),(7773,824),(7774,824),(7775,824),(7776,824),(7777,825),(7778,825),(7779,825),(7780,825),(7781,826),(7782,826),(7783,826),(7784,826),(7785,827),(7786,827),(7787,827),(7788,827),(7789,828),(7790,828),(7791,828),(7792,828),(7793,829),(7794,829),(7795,829),(7796,829),(7797,830),(7798,830),(7799,830),(7800,830),(7801,831),(7802,831),(7803,831),(7804,831),(7805,832),(7806,832),(7807,832),(7808,832),(7809,833),(7810,833),(7811,833),(7812,833),(7813,834),(7814,834),(7815,834),(7816,834),(7817,835),(7818,835),(7819,835),(7820,835),(7821,836),(7822,836),(7823,836),(7824,836),(7825,837),(7826,837),(7827,837),(7828,837),(7829,838),(7830,838),(7831,838),(7832,838),(7833,839),(7834,839),(7835,839),(7836,839),(7837,840),(7838,840),(7839,840),(7840,840),(7841,841),(7842,841),(7843,841),(7844,841),(7845,842),(7846,842),(7847,842),(7848,842),(7849,843),(7850,843),(7851,843),(7852,843),(7853,844),(7854,844),(7855,844),(7856,844),(7857,845),(7858,845),(7859,845),(7860,845),(7861,846),(7862,846),(7863,846),(7864,846),(7865,847),(7866,847),(7867,847),(7868,847),(7869,848),(7870,848),(7871,848),(7872,848),(7873,849),(7874,849),(7875,849),(7876,849),(7877,850),(7878,850),(7879,850),(7880,850),(7881,851),(7882,851),(7883,851),(7884,851),(7885,852),(7886,852),(7887,852),(7888,852),(7889,853),(7890,853),(7891,853),(7892,853),(7893,854),(7894,854),(7895,854),(7896,854),(7897,855),(7898,855),(7899,855),(7900,855),(7901,856),(7902,856),(7903,856),(7904,856),(7905,857),(7906,857),(7907,857),(7908,857),(7909,858),(7910,858),(7911,858),(7912,858),(7913,859),(7914,859),(7915,859),(7916,859),(7917,860),(7918,860),(7919,860),(7920,860),(7921,861),(7922,861),(7923,861),(7924,861),(7925,862),(7926,862),(7927,862),(7928,862),(7929,863),(7930,863),(7931,863),(7932,863),(7933,864),(7934,864),(7935,864),(7936,864),(7937,865),(7938,865),(7939,865),(7940,865),(7941,866),(7942,866),(7943,866),(7944,866),(7945,867),(7946,867),(7947,867),(7948,867),(7949,868),(7950,868),(7951,868),(7952,868),(7953,869),(7954,869),(7955,869),(7956,869),(7957,870),(7958,870),(7959,870),(7960,870),(7961,871),(7962,871),(7963,871),(7964,871),(7965,872),(7966,872),(7967,872),(7968,872),(7969,873),(7970,873),(7971,873),(7972,873),(7973,874),(7974,874),(7975,874),(7976,874),(7977,875),(7978,875),(7979,875),(7980,875),(7981,876),(7982,876),(7983,876),(7984,876),(7985,877),(7986,877),(7987,877),(7988,877),(7989,878),(7990,878),(7991,878),(7992,878),(7993,879),(7994,879),(7995,879),(7996,879),(7997,880),(7998,880),(7999,880),(8000,880),(8001,881),(8002,882),(8003,883),(8004,884),(8005,885),(8006,886),(8007,887),(8008,888),(8009,889),(8010,890),(8011,891),(8012,892),(8013,893),(8014,894),(8015,895),(8016,896),(8017,897),(8018,898),(8019,899),(8020,900),(8021,901),(8022,902),(8023,903),(8024,904),(8025,905),(8026,906),(8027,907),(8028,908),(8029,909),(8030,910),(8031,911),(8032,912),(8033,913),(8034,914),(8035,915),(8036,916),(8037,917),(8038,918),(8039,919),(8040,920),(8041,921),(8042,922),(8043,923),(8044,924),(8045,925),(8046,926),(8047,927),(8048,928),(8049,929),(8050,930),(8051,931),(8052,932),(8053,933),(8054,934),(8055,935),(8056,936),(8057,937),(8058,938),(8059,939),(8060,940),(8061,941),(8062,942),(8063,943),(8064,944),(8065,945),(8066,946),(8067,947),(8068,948),(8069,949),(8070,950),(8071,951),(8072,952),(8073,953),(8074,954),(8075,955),(8076,956),(8077,957),(8078,958),(8079,959),(8080,960),(8081,961),(8082,962),(8083,963),(8084,964),(8085,965),(8086,966),(8087,967),(8088,968),(8089,969),(8090,970),(8091,971),(8092,972),(8093,973),(8094,974),(8095,975),(8096,976),(8097,977),(8098,978),(8099,979),(8100,980),(8101,881),(8102,882),(8103,883),(8104,884),(8105,885),(8106,886),(8107,887),(8108,888),(8109,889),(8110,890),(8111,891),(8112,892),(8113,893),(8114,894),(8115,895),(8116,896),(8117,897),(8118,898),(8119,899),(8120,900),(8121,901),(8122,902),(8123,903),(8124,904),(8125,905),(8126,906),(8127,907),(8128,908),(8129,909),(8130,910),(8131,911),(8132,912),(8133,913),(8134,914),(8135,915),(8136,916),(8137,917),(8138,918),(8139,919),(8140,920),(8141,921),(8142,922),(8143,923),(8144,924),(8145,925),(8146,926),(8147,927),(8148,928),(8149,929),(8150,930),(8151,931),(8152,932),(8153,933),(8154,934),(8155,935),(8156,936),(8157,937),(8158,938),(8159,939),(8160,940),(8161,941),(8162,942),(8163,943),(8164,944),(8165,945),(8166,946),(8167,947),(8168,948),(8169,949),(8170,950),(8171,951),(8172,952),(8173,953),(8174,954),(8175,955),(8176,956),(8177,957),(8178,958),(8179,959),(8180,960),(8181,961),(8182,962),(8183,963),(8184,964),(8185,965),(8186,966),(8187,967),(8188,968),(8189,969),(8190,970),(8191,971),(8192,972),(8193,973),(8194,974),(8195,975),(8196,976),(8197,977),(8198,978),(8199,979),(8200,980),(8201,881),(8202,881),(8203,882),(8204,882),(8205,882),(8206,883),(8207,884),(8208,884),(8209,884),(8210,885),(8211,885),(8212,885),(8213,886),(8214,886),(8215,886),(8216,887),(8217,887),(8218,887),(8219,888),(8220,888),(8221,888),(8222,889),(8223,889),(8224,889),(8225,890),(8226,890),(8227,890),(8228,891),(8229,891),(8230,891),(8231,892),(8232,892),(8233,892),(8234,893),(8235,893),(8236,893),(8237,894),(8238,894),(8239,894),(8240,895),(8241,895),(8242,895),(8243,896),(8244,896),(8245,896),(8246,897),(8247,897),(8248,897),(8249,898),(8250,898),(8251,898),(8252,899),(8253,899),(8254,899),(8255,900),(8256,900),(8257,900),(8258,901),(8259,901),(8260,901),(8261,902),(8262,902),(8263,902),(8264,903),(8265,903),(8266,903),(8267,904),(8268,904),(8269,904),(8270,905),(8271,905),(8272,905),(8273,906),(8274,906),(8275,906),(8276,907),(8277,907),(8278,907),(8279,908),(8280,908),(8281,908),(8282,909),(8283,909),(8284,909),(8285,910),(8286,910),(8287,910),(8288,911),(8289,911),(8290,911),(8291,912),(8292,912),(8293,912),(8294,913),(8295,913),(8296,913),(8297,914),(8298,914),(8299,914),(8300,915),(8301,915),(8302,915),(8303,916),(8304,916),(8305,916),(8306,917),(8307,917),(8308,917),(8309,918),(8310,918),(8311,918),(8312,919),(8313,919),(8314,919),(8315,920),(8316,920),(8317,920),(8318,921),(8319,921),(8320,921),(8321,922),(8322,922),(8323,922),(8324,923),(8325,923),(8326,923),(8327,924),(8328,924),(8329,924),(8330,925),(8331,925),(8332,925),(8333,926),(8334,926),(8335,926),(8336,927),(8337,927),(8338,927),(8339,928),(8340,928),(8341,928),(8342,929),(8343,929),(8344,929),(8345,930),(8346,930),(8347,930),(8348,931),(8349,931),(8350,931),(8351,932),(8352,932),(8353,932),(8354,933),(8355,933),(8356,933),(8357,934),(8358,934),(8359,934),(8360,935),(8361,935),(8362,935),(8363,936),(8364,936),(8365,936),(8366,937),(8367,937),(8368,937),(8369,938),(8370,938),(8371,938),(8372,939),(8373,939),(8374,939),(8375,940),(8376,940),(8377,940),(8378,941),(8379,941),(8380,941),(8381,942),(8382,942),(8383,942),(8384,943),(8385,943),(8386,943),(8387,944),(8388,944),(8389,944),(8390,945),(8391,945),(8392,945),(8393,946),(8394,946),(8395,946),(8396,947),(8397,947),(8398,947),(8399,948),(8400,948),(8401,948),(8402,949),(8403,949),(8404,949),(8405,950),(8406,950),(8407,950),(8408,951),(8409,951),(8410,951),(8411,952),(8412,952),(8413,952),(8414,953),(8415,953),(8416,953),(8417,954),(8418,954),(8419,954),(8420,955),(8421,955),(8422,955),(8423,956),(8424,956),(8425,956),(8426,957),(8427,957),(8428,957),(8429,958),(8430,958),(8431,958),(8432,959),(8433,959),(8434,959),(8435,960),(8436,960),(8437,960),(8438,961),(8439,961),(8440,961),(8441,962),(8442,962),(8443,962),(8444,963),(8445,963),(8446,963),(8447,964),(8448,964),(8449,964),(8450,965),(8451,965),(8452,965),(8453,966),(8454,966),(8455,966),(8456,967),(8457,967),(8458,967),(8459,968),(8460,968),(8461,968),(8462,969),(8463,969),(8464,969),(8465,970),(8466,970),(8467,970),(8468,971),(8469,971),(8470,971),(8471,972),(8472,972),(8473,972),(8474,973),(8475,973),(8476,973),(8477,974),(8478,974),(8479,974),(8480,975),(8481,975),(8482,975),(8483,976),(8484,976),(8485,976),(8486,977),(8487,977),(8488,977),(8489,978),(8490,978),(8491,978),(8492,979),(8493,979),(8494,979),(8495,980),(8496,980),(8497,980),(8498,881),(8499,881),(8500,881),(8501,881),(8502,882),(8503,882),(8504,882),(8505,882),(8506,883),(8507,883),(8508,883),(8509,883),(8510,884),(8511,884),(8512,884),(8513,884),(8514,885),(8515,885),(8516,885),(8517,885),(8518,886),(8519,886),(8520,886),(8521,886),(8522,887),(8523,887),(8524,887),(8525,887),(8526,888),(8527,888),(8528,888),(8529,888),(8530,889),(8531,889),(8532,889),(8533,889),(8534,890),(8535,890),(8536,890),(8537,890),(8538,891),(8539,891),(8540,891),(8541,891),(8542,892),(8543,892),(8544,892),(8545,892),(8546,893),(8547,893),(8548,893),(8549,893),(8550,894),(8551,894),(8552,894),(8553,894),(8554,895),(8555,895),(8556,895),(8557,895),(8558,896),(8559,896),(8560,896),(8561,896),(8562,897),(8563,897),(8564,897),(8565,897),(8566,898),(8567,898),(8568,898),(8569,898),(8570,899),(8571,899),(8572,899),(8573,899),(8574,900),(8575,900),(8576,900),(8577,900),(8578,901),(8579,901),(8580,901),(8581,901),(8582,902),(8583,902),(8584,902),(8585,902),(8586,903),(8587,903),(8588,903),(8589,903),(8590,904),(8591,904),(8592,904),(8593,904),(8594,905),(8595,905),(8596,905),(8597,905),(8598,906),(8599,906),(8600,906),(8601,906),(8602,907),(8603,907),(8604,907),(8605,907),(8606,908),(8607,908),(8608,908),(8609,908),(8610,909),(8611,909),(8612,909),(8613,909),(8614,910),(8615,910),(8616,910),(8617,910),(8618,911),(8619,911),(8620,911),(8621,911),(8622,912),(8623,912),(8624,912),(8625,912),(8626,913),(8627,913),(8628,913),(8629,913),(8630,914),(8631,914),(8632,914),(8633,914),(8634,915),(8635,915),(8636,915),(8637,915),(8638,916),(8639,916),(8640,916),(8641,916),(8642,917),(8643,917),(8644,917),(8645,917),(8646,918),(8647,918),(8648,918),(8649,918),(8650,919),(8651,919),(8652,919),(8653,919),(8654,920),(8655,920),(8656,920),(8657,920),(8658,921),(8659,921),(8660,921),(8661,921),(8662,922),(8663,922),(8664,922),(8665,922),(8666,923),(8667,923),(8668,923),(8669,923),(8670,924),(8671,924),(8672,924),(8673,924),(8674,925),(8675,925),(8676,925),(8677,925),(8678,926),(8679,926),(8680,926),(8681,926),(8682,927),(8683,927),(8684,927),(8685,927),(8686,928),(8687,928),(8688,928),(8689,928),(8690,929),(8691,929),(8692,929),(8693,929),(8694,930),(8695,930),(8696,930),(8697,930),(8698,931),(8699,931),(8700,931),(8701,931),(8702,932),(8703,932),(8704,932),(8705,932),(8706,933),(8707,933),(8708,933),(8709,933),(8710,934),(8711,934),(8712,934),(8713,934),(8714,935),(8715,935),(8716,935),(8717,935),(8718,936),(8719,936),(8720,936),(8721,936),(8722,937),(8723,937),(8724,937),(8725,937),(8726,938),(8727,938),(8728,938),(8729,938),(8730,939),(8731,939),(8732,939),(8733,939),(8734,940),(8735,940),(8736,940),(8737,940),(8738,941),(8739,941),(8740,941),(8741,941),(8742,942),(8743,942),(8744,942),(8745,942),(8746,943),(8747,943),(8748,943),(8749,943),(8750,944),(8751,944),(8752,944),(8753,944),(8754,945),(8755,945),(8756,945),(8757,945),(8758,946),(8759,946),(8760,946),(8761,946),(8762,947),(8763,947),(8764,947),(8765,947),(8766,948),(8767,948),(8768,948),(8769,948),(8770,949),(8771,949),(8772,949),(8773,949),(8774,950),(8775,950),(8776,950),(8777,950),(8778,951),(8779,951),(8780,951),(8781,951),(8782,952),(8783,952),(8784,952),(8785,952),(8786,953),(8787,953),(8788,953),(8789,953),(8790,954),(8791,954),(8792,954),(8793,954),(8794,955),(8795,955),(8796,955),(8797,955),(8798,956),(8799,956),(8800,956),(8801,956),(8802,957),(8803,957),(8804,957),(8805,957),(8806,958),(8807,958),(8808,958),(8809,958),(8810,959),(8811,959),(8812,959),(8813,959),(8814,960),(8815,960),(8816,960),(8817,960),(8818,961),(8819,961),(8820,961),(8821,961),(8822,962),(8823,962),(8824,962),(8825,962),(8826,963),(8827,963),(8828,963),(8829,963),(8830,964),(8831,964),(8832,964),(8833,964),(8834,965),(8835,965),(8836,965),(8837,965),(8838,966),(8839,966),(8840,966),(8841,966),(8842,967),(8843,967),(8844,967),(8845,967),(8846,968),(8847,968),(8848,968),(8849,968),(8850,969),(8851,969),(8852,969),(8853,969),(8854,970),(8855,970),(8856,970),(8857,970),(8858,971),(8859,971),(8860,971),(8861,971),(8862,972),(8863,972),(8864,972),(8865,972),(8866,973),(8867,973),(8868,973),(8869,973),(8870,974),(8871,974),(8872,974),(8873,974),(8874,975),(8875,975),(8876,975),(8877,975),(8878,976),(8879,976),(8880,976),(8881,976),(8882,977),(8883,977),(8884,977),(8885,977),(8886,978),(8887,978),(8888,978),(8889,978),(8890,979),(8891,979),(8892,979),(8893,979),(8894,980),(8895,980),(8896,980),(8897,980),(8898,981),(8899,982),(8900,983),(8901,984),(8902,985),(8903,986),(8904,987),(8905,988),(8906,989),(8907,990),(8908,991),(8909,992),(8910,993),(8911,994),(8912,995),(8913,996),(8914,997),(8915,998),(8916,999),(8917,1000),(8918,1001),(8919,1002),(8920,1003),(8921,1004),(8922,1005),(8923,1006),(8924,1007),(8925,1008),(8926,1009),(8927,1010),(8928,1011),(8929,1012),(8930,1013),(8931,1014),(8932,1015),(8933,1016),(8934,1017),(8935,1018),(8936,1019),(8937,1020),(8938,1021),(8939,1022),(8940,1023),(8941,1024),(8942,1025),(8943,1026),(8944,1027),(8945,1028),(8946,1029),(8947,1030),(8948,1031),(8949,1032),(8950,1033),(8951,1034),(8952,1035),(8953,1036),(8954,1037),(8955,1038),(8956,1039),(8957,1040),(8958,1041),(8959,1042),(8960,1043),(8961,1044),(8962,1045),(8963,1046),(8964,1047),(8965,1048),(8966,1049),(8967,1050),(8968,1051),(8969,1052),(8970,1053),(8971,1054),(8972,1055),(8973,1056),(8974,1057),(8975,1058),(8976,1059),(8977,1060),(8978,1061),(8979,1062),(8980,1063),(8981,1064),(8982,1065),(8983,1066),(8984,1067),(8985,1068),(8986,1069),(8987,1070),(8988,1071),(8989,1072),(8990,1073),(8991,1074),(8992,1075),(8993,1076),(8994,1077),(8995,1078),(8996,1079),(8997,1080),(8998,981),(8999,982),(9000,983),(9001,984),(9002,985),(9003,986),(9004,987),(9005,988),(9006,989),(9007,990),(9008,991),(9009,992),(9010,993),(9011,994),(9012,995),(9013,996),(9014,997),(9015,998),(9016,999),(9017,1000),(9018,1001),(9019,1002),(9020,1003),(9021,1004),(9022,1005),(9023,1006),(9024,1007),(9025,1008),(9026,1009),(9027,1010),(9028,1011),(9029,1012),(9030,1013),(9031,1014),(9032,1015),(9033,1016),(9034,1017),(9035,1018),(9036,1019),(9037,1020),(9038,1021),(9039,1022),(9040,1023),(9041,1024),(9042,1025),(9043,1026),(9044,1027),(9045,1028),(9046,1029),(9047,1030),(9048,1031),(9049,1032),(9050,1033),(9051,1034),(9052,1035),(9053,1036),(9054,1037),(9055,1038),(9056,1039),(9057,1040),(9058,1041),(9059,1042),(9060,1043),(9061,1044),(9062,1045),(9063,1046),(9064,1047),(9065,1048),(9066,1049),(9067,1050),(9068,1051),(9069,1052),(9070,1053),(9071,1054),(9072,1055),(9073,1056),(9074,1057),(9075,1058),(9076,1059),(9077,1060),(9078,1061),(9079,1062),(9080,1063),(9081,1064),(9082,1065),(9083,1066),(9084,1067),(9085,1068),(9086,1069),(9087,1070),(9088,1071),(9089,1072),(9090,1073),(9091,1074),(9092,1075),(9093,1076),(9094,1077),(9095,1078),(9096,1079),(9097,1080),(9098,981),(9099,981),(9100,981),(9101,982),(9102,982),(9103,982),(9104,983),(9105,983),(9106,983),(9107,984),(9108,984),(9109,984),(9110,985),(9111,985),(9112,985),(9113,986),(9114,986),(9115,986),(9116,987),(9117,987),(9118,987),(9119,988),(9120,988),(9121,988),(9122,989),(9123,989),(9124,989),(9125,990),(9126,990),(9127,990),(9128,991),(9129,991),(9130,991),(9131,992),(9132,992),(9133,992),(9134,993),(9135,993),(9136,993),(9137,994),(9138,994),(9139,994),(9140,995),(9141,995),(9142,995),(9143,996),(9144,996),(9145,996),(9146,997),(9147,997),(9148,997),(9149,998),(9150,998),(9151,998),(9152,999),(9153,999),(9154,999),(9155,1000),(9156,1000),(9157,1000),(9158,1001),(9159,1001),(9160,1001),(9161,1002),(9162,1002),(9163,1002),(9164,1003),(9165,1003),(9166,1003),(9167,1004),(9168,1004),(9169,1004),(9170,1005),(9171,1005),(9172,1005),(9173,1006),(9174,1006),(9175,1006),(9176,1007),(9177,1007),(9178,1007),(9179,1008),(9180,1008),(9181,1008),(9182,1009),(9183,1009),(9184,1009),(9185,1010),(9186,1010),(9187,1010),(9188,1011),(9189,1011),(9190,1011),(9191,1012),(9192,1012),(9193,1012),(9194,1013),(9195,1013),(9196,1013),(9197,1014),(9198,1014),(9199,1014),(9200,1015),(9201,1015),(9202,1015),(9203,1016),(9204,1016),(9205,1016),(9206,1017),(9207,1017),(9208,1017),(9209,1018),(9210,1018),(9211,1018),(9212,1019),(9213,1019),(9214,1019),(9215,1020),(9216,1020),(9217,1020),(9218,1021),(9219,1021),(9220,1021),(9221,1022),(9222,1022),(9223,1022),(9224,1023),(9225,1023),(9226,1023),(9227,1024),(9228,1024),(9229,1024),(9230,1025),(9231,1025),(9232,1025),(9233,1026),(9234,1026),(9235,1026),(9236,1027),(9237,1027),(9238,1027),(9239,1028),(9240,1028),(9241,1028),(9242,1029),(9243,1029),(9244,1029),(9245,1030),(9246,1030),(9247,1030),(9248,1031),(9249,1031),(9250,1031),(9251,1032),(9252,1032),(9253,1032),(9254,1033),(9255,1033),(9256,1033),(9257,1034),(9258,1034),(9259,1034),(9260,1035),(9261,1035),(9262,1035),(9263,1036),(9264,1036),(9265,1036),(9266,1037),(9267,1037),(9268,1037),(9269,1038),(9270,1038),(9271,1038),(9272,1039),(9273,1039),(9274,1040),(9275,1040),(9276,1040),(9277,1041),(9278,1041),(9279,1041),(9280,1042),(9281,1042),(9282,1042),(9283,1043),(9284,1043),(9285,1043),(9286,1044),(9287,1044),(9288,1044),(9289,1045),(9290,1045),(9291,1045),(9292,1046),(9293,1046),(9294,1046),(9295,1047),(9296,1047),(9297,1047),(9298,1048),(9299,1048),(9300,1048),(9301,1049),(9302,1049),(9303,1049),(9304,1050),(9305,1050),(9306,1050),(9307,1051),(9308,1051),(9309,1051),(9310,1052),(9311,1052),(9312,1052),(9313,1053),(9314,1053),(9315,1053),(9316,1054),(9317,1054),(9318,1054),(9319,1055),(9320,1055),(9321,1055),(9322,1056),(9323,1056),(9324,1056),(9325,1057),(9326,1057),(9327,1057),(9328,1058),(9329,1058),(9330,1058),(9331,1059),(9332,1059),(9333,1059),(9334,1060),(9335,1060),(9336,1060),(9337,1061),(9338,1061),(9339,1061),(9340,1062),(9341,1062),(9342,1062),(9343,1063),(9344,1063),(9345,1063),(9346,1064),(9347,1064),(9348,1064),(9349,1065),(9350,1065),(9351,1065),(9352,1066),(9353,1066),(9354,1066),(9355,1067),(9356,1067),(9357,1067),(9358,1068),(9359,1068),(9360,1068),(9361,1069),(9362,1069),(9363,1069),(9364,1070),(9365,1070),(9366,1070),(9367,1071),(9368,1071),(9369,1071),(9370,1072),(9371,1072),(9372,1072),(9373,1073),(9374,1073),(9375,1073),(9376,1074),(9377,1074),(9378,1074),(9379,1075),(9380,1075),(9381,1075),(9382,1076),(9383,1076),(9384,1076),(9385,1077),(9386,1077),(9387,1077),(9388,1078),(9389,1078),(9390,1078),(9391,1079),(9392,1079),(9393,1079),(9394,1080),(9395,1080),(9396,1080),(9397,981),(9398,981),(9399,981),(9400,981),(9401,982),(9402,982),(9403,982),(9404,982),(9405,983),(9406,983),(9407,983),(9408,983),(9409,984),(9410,984),(9411,984),(9412,984),(9413,985),(9414,985),(9415,985),(9416,985),(9417,986),(9418,986),(9419,986),(9420,986),(9421,987),(9422,987),(9423,987),(9424,987),(9425,988),(9426,988),(9427,988),(9428,988),(9429,989),(9430,989),(9431,989),(9432,989),(9433,990),(9434,990),(9435,990),(9436,990),(9437,991),(9438,991),(9439,991),(9440,991),(9441,992),(9442,992),(9443,992),(9444,992),(9445,993),(9446,993),(9447,993),(9448,993),(9449,994),(9450,994),(9451,994),(9452,994),(9453,995),(9454,995),(9455,995),(9456,995),(9457,996),(9458,996),(9459,996),(9460,996),(9461,997),(9462,997),(9463,997),(9464,997),(9465,998),(9466,998),(9467,998),(9468,998),(9469,999),(9470,999),(9471,999),(9472,999),(9473,1000),(9474,1000),(9475,1000),(9476,1000),(9477,1001),(9478,1001),(9479,1001),(9480,1001),(9481,1002),(9482,1002),(9483,1002),(9484,1002),(9485,1003),(9486,1003),(9487,1003),(9488,1003),(9489,1004),(9490,1004),(9491,1004),(9492,1004),(9493,1005),(9494,1005),(9495,1005),(9496,1005),(9497,1006),(9498,1006),(9499,1006),(9500,1006),(9501,1007),(9502,1007),(9503,1007),(9504,1007),(9505,1008),(9506,1008),(9507,1008),(9508,1008),(9509,1009),(9510,1009),(9511,1009),(9512,1009),(9513,1010),(9514,1010),(9515,1010),(9516,1010),(9517,1011),(9518,1011),(9519,1011),(9520,1011),(9521,1012),(9522,1012),(9523,1012),(9524,1012),(9525,1013),(9526,1013),(9527,1013),(9528,1013),(9529,1014),(9530,1014),(9531,1014),(9532,1014),(9533,1015),(9534,1015),(9535,1015),(9536,1015),(9537,1016),(9538,1016),(9539,1016),(9540,1016),(9541,1017),(9542,1017),(9543,1017),(9544,1017),(9545,1018),(9546,1018),(9547,1018),(9548,1018),(9549,1019),(9550,1019),(9551,1019),(9552,1019),(9553,1020),(9554,1020),(9555,1020),(9556,1020),(9557,1021),(9558,1021),(9559,1021),(9560,1021),(9561,1022),(9562,1022),(9563,1022),(9564,1022),(9565,1023),(9566,1023),(9567,1023),(9568,1023),(9569,1024),(9570,1024),(9571,1024),(9572,1024),(9573,1025),(9574,1025),(9575,1025),(9576,1025),(9577,1026),(9578,1026),(9579,1026),(9580,1026),(9581,1027),(9582,1027),(9583,1027),(9584,1027),(9585,1028),(9586,1028),(9587,1028),(9588,1028),(9589,1029),(9590,1029),(9591,1029),(9592,1029),(9593,1030),(9594,1030),(9595,1030),(9596,1030),(9597,1031),(9598,1031),(9599,1031),(9600,1031),(9601,1032),(9602,1032),(9603,1032),(9604,1032),(9605,1033),(9606,1033),(9607,1033),(9608,1033),(9609,1034),(9610,1034),(9611,1034),(9612,1034),(9613,1035),(9614,1035),(9615,1035),(9616,1035),(9617,1036),(9618,1036),(9619,1036),(9620,1036),(9621,1037),(9622,1037),(9623,1037),(9624,1037),(9625,1038),(9626,1038),(9627,1038),(9628,1038),(9629,1039),(9630,1039),(9631,1039),(9632,1039),(9633,1040),(9634,1040),(9635,1040),(9636,1040),(9637,1041),(9638,1041),(9639,1041),(9640,1041),(9641,1042),(9642,1042),(9643,1042),(9644,1042),(9645,1043),(9646,1043),(9647,1043),(9648,1043),(9649,1044),(9650,1044),(9651,1044),(9652,1044),(9653,1045),(9654,1045),(9655,1045),(9656,1045),(9657,1046),(9658,1046),(9659,1046),(9660,1046),(9661,1047),(9662,1047),(9663,1047),(9664,1047),(9665,1048),(9666,1048),(9667,1048),(9668,1048),(9669,1049),(9670,1049),(9671,1049),(9672,1049),(9673,1050),(9674,1050),(9675,1050),(9676,1050),(9677,1051),(9678,1051),(9679,1051),(9680,1051),(9681,1052),(9682,1052),(9683,1052),(9684,1052),(9685,1053),(9686,1053),(9687,1053),(9688,1053),(9689,1054),(9690,1054),(9691,1054),(9692,1054),(9693,1055),(9694,1055),(9695,1055),(9696,1055),(9697,1056),(9698,1056),(9699,1056),(9700,1056),(9701,1057),(9702,1057),(9703,1057),(9704,1057),(9705,1058),(9706,1058),(9707,1058),(9708,1058),(9709,1059),(9710,1059),(9711,1059),(9712,1059),(9713,1060),(9714,1060),(9715,1060),(9716,1060),(9717,1061),(9718,1061),(9719,1061),(9720,1061),(9721,1062),(9722,1062),(9723,1062),(9724,1062),(9725,1063),(9726,1063),(9727,1063),(9728,1063),(9729,1064),(9730,1064),(9731,1064),(9732,1064),(9733,1065),(9734,1065),(9735,1065),(9736,1065),(9737,1066),(9738,1066),(9739,1066),(9740,1066),(9741,1067),(9742,1067),(9743,1067),(9744,1067),(9745,1068),(9746,1068),(9747,1068),(9748,1068),(9749,1069),(9750,1069),(9751,1069),(9752,1069),(9753,1070),(9754,1070),(9755,1070),(9756,1070),(9757,1071),(9758,1071),(9759,1071),(9760,1071),(9761,1072),(9762,1072),(9763,1072),(9764,1072),(9765,1073),(9766,1073),(9767,1073),(9768,1073),(9769,1074),(9770,1074),(9771,1074),(9772,1074),(9773,1075),(9774,1075),(9775,1075),(9776,1075),(9777,1076),(9778,1076),(9779,1076),(9780,1076),(9781,1077),(9782,1077),(9783,1077),(9784,1077),(9785,1078),(9786,1078),(9787,1078),(9788,1078),(9789,1079),(9790,1079),(9791,1079),(9792,1079),(9793,1080),(9794,1080),(9795,1080),(9796,1080),(9797,1081),(9798,1082),(9799,1083),(9800,1084),(9801,1085),(9802,1086),(9803,1087),(9804,1088),(9805,1089),(9806,1090),(9807,1091),(9808,1092),(9809,1093),(9810,1094),(9811,1095),(9812,1096),(9813,1097),(9814,1098),(9815,1099),(9816,1100),(9817,1101),(9818,1102),(9819,1103),(9820,1104),(9821,1105),(9822,1106),(9823,1107),(9824,1108),(9825,1109),(9826,1110),(9827,1111),(9828,1112),(9829,1113),(9830,1114),(9831,1115),(9832,1116),(9833,1117),(9834,1118),(9835,1119),(9836,1120),(9837,1121),(9838,1122),(9839,1123),(9840,1124),(9841,1125),(9842,1126),(9843,1127),(9844,1128),(9845,1129),(9846,1130),(9847,1131),(9848,1132),(9849,1133),(9850,1134),(9851,1135),(9852,1136),(9853,1137),(9854,1138),(9855,1139),(9856,1081),(9857,1082),(9858,1083),(9859,1084),(9860,1085),(9861,1086),(9862,1087),(9863,1088),(9864,1089),(9865,1090),(9866,1091),(9867,1092),(9868,1093),(9869,1094),(9870,1095),(9871,1096),(9872,1097),(9873,1098),(9874,1099),(9875,1100),(9876,1101),(9877,1102),(9878,1103),(9879,1104),(9880,1105),(9881,1106),(9882,1107),(9883,1108),(9884,1109),(9885,1110),(9886,1111),(9887,1112),(9888,1113),(9889,1114),(9890,1115),(9891,1116),(9892,1117),(9893,1118),(9894,1119),(9895,1120),(9896,1121),(9897,1122),(9898,1123),(9899,1124),(9900,1125),(9901,1126),(9902,1127),(9903,1128),(9904,1129),(9905,1130),(9906,1131),(9907,1132),(9908,1133),(9909,1134),(9910,1135),(9911,1136),(9912,1137),(9913,1138),(9914,1139),(9915,1081),(9916,1081),(9917,1081),(9918,1082),(9919,1082),(9920,1082),(9921,1083),(9922,1083),(9923,1083),(9924,1084),(9925,1084),(9926,1084),(9927,1085),(9928,1085),(9929,1085),(9930,1086),(9931,1086),(9932,1086),(9933,1087),(9934,1087),(9935,1087),(9936,1088),(9937,1088),(9938,1088),(9939,1089),(9940,1089),(9941,1089),(9942,1090),(9943,1090),(9944,1090),(9945,1091),(9946,1091),(9947,1091),(9948,1092),(9949,1092),(9950,1092),(9951,1093),(9952,1093),(9953,1093),(9954,1094),(9955,1094),(9956,1094),(9957,1095),(9958,1095),(9959,1095),(9960,1096),(9961,1096),(9962,1096),(9963,1097),(9964,1097),(9965,1097),(9966,1098),(9967,1098),(9968,1098),(9969,1099),(9970,1099),(9971,1100),(9972,1100),(9973,1100),(9974,1101),(9975,1101),(9976,1101),(9977,1102),(9978,1102),(9979,1102),(9980,1103),(9981,1103),(9982,1103),(9983,1104),(9984,1104),(9985,1104),(9986,1105),(9987,1105),(9988,1105),(9989,1106),(9990,1106),(9991,1106),(9992,1107),(9993,1107),(9994,1107),(9995,1108),(9996,1108),(9997,1108),(9998,1109),(9999,1109),(10000,1109),(10001,1110),(10002,1110),(10003,1110),(10004,1111),(10005,1111),(10006,1111),(10007,1112),(10008,1112),(10009,1112),(10010,1113),(10011,1113),(10012,1113),(10013,1114),(10014,1114),(10015,1114),(10016,1115),(10017,1115),(10018,1115),(10019,1116),(10020,1116),(10021,1116),(10022,1117),(10023,1117),(10024,1117),(10025,1118),(10026,1118),(10027,1118),(10028,1119),(10029,1119),(10030,1119),(10031,1120),(10032,1120),(10033,1120),(10034,1121),(10035,1121),(10036,1121),(10037,1122),(10038,1122),(10039,1122),(10040,1123),(10041,1123),(10042,1123),(10043,1124),(10044,1124),(10045,1124),(10046,1125),(10047,1125),(10048,1125),(10049,1126),(10050,1126),(10051,1126),(10052,1127),(10053,1127),(10054,1127),(10055,1128),(10056,1128),(10057,1128),(10058,1129),(10059,1129),(10060,1129),(10061,1130),(10062,1130),(10063,1130),(10064,1131),(10065,1131),(10066,1131),(10067,1132),(10068,1132),(10069,1132),(10070,1133),(10071,1133),(10072,1133),(10073,1134),(10074,1134),(10075,1134),(10076,1135),(10077,1135),(10078,1135),(10079,1136),(10080,1136),(10081,1136),(10082,1137),(10083,1137),(10084,1137),(10085,1138),(10086,1138),(10087,1138),(10088,1139),(10089,1139),(10090,1139),(10091,1081),(10092,1081),(10093,1081),(10094,1081),(10095,1082),(10096,1082),(10097,1082),(10098,1082),(10099,1083),(10100,1083),(10101,1083),(10102,1083),(10103,1084),(10104,1084),(10105,1084),(10106,1084),(10107,1085),(10108,1085),(10109,1085),(10110,1085),(10111,1086),(10112,1086),(10113,1086),(10114,1086),(10115,1087),(10116,1087),(10117,1087),(10118,1087),(10119,1088),(10120,1088),(10121,1088),(10122,1088),(10123,1089),(10124,1089),(10125,1089),(10126,1089),(10127,1090),(10128,1090),(10129,1090),(10130,1090),(10131,1091),(10132,1091),(10133,1091),(10134,1091),(10135,1092),(10136,1092),(10137,1092),(10138,1092),(10139,1093),(10140,1093),(10141,1093),(10142,1093),(10143,1094),(10144,1094),(10145,1094),(10146,1094),(10147,1095),(10148,1095),(10149,1095),(10150,1095),(10151,1096),(10152,1096),(10153,1096),(10154,1096),(10155,1097),(10156,1097),(10157,1097),(10158,1097),(10159,1098),(10160,1098),(10161,1098),(10162,1098),(10163,1099),(10164,1099),(10165,1099),(10166,1099),(10167,1100),(10168,1100),(10169,1100),(10170,1100),(10171,1101),(10172,1101),(10173,1101),(10174,1101),(10175,1102),(10176,1102),(10177,1102),(10178,1102),(10179,1103),(10180,1103),(10181,1103),(10182,1103),(10183,1104),(10184,1104),(10185,1104),(10186,1104),(10187,1105),(10188,1105),(10189,1105),(10190,1105),(10191,1106),(10192,1106),(10193,1106),(10194,1106),(10195,1107),(10196,1107),(10197,1107),(10198,1107),(10199,1108),(10200,1108),(10201,1108),(10202,1108),(10203,1109),(10204,1109),(10205,1109),(10206,1109),(10207,1110),(10208,1110),(10209,1110),(10210,1110),(10211,1111),(10212,1111),(10213,1111),(10214,1111),(10215,1112),(10216,1112),(10217,1112),(10218,1112),(10219,1113),(10220,1113),(10221,1113),(10222,1113),(10223,1114),(10224,1114),(10225,1114),(10226,1114),(10227,1115),(10228,1115),(10229,1115),(10230,1115),(10231,1116),(10232,1116),(10233,1116),(10234,1116),(10235,1117),(10236,1117),(10237,1117),(10238,1117),(10239,1118),(10240,1118),(10241,1118),(10242,1118),(10243,1119),(10244,1119),(10245,1119),(10246,1119),(10247,1120),(10248,1120),(10249,1120),(10250,1120),(10251,1121),(10252,1121),(10253,1121),(10254,1121),(10255,1122),(10256,1122),(10257,1122),(10258,1122),(10259,1123),(10260,1123),(10261,1123),(10262,1123),(10263,1124),(10264,1124),(10265,1124),(10266,1124),(10267,1125),(10268,1125),(10269,1125),(10270,1125),(10271,1126),(10272,1126),(10273,1126),(10274,1126),(10275,1127),(10276,1127),(10277,1127),(10278,1127),(10279,1128),(10280,1128),(10281,1128),(10282,1128),(10283,1129),(10284,1129),(10285,1129),(10286,1129),(10287,1130),(10288,1130),(10289,1130),(10290,1130),(10291,1131),(10292,1131),(10293,1131),(10294,1131),(10295,1132),(10296,1132),(10297,1132),(10298,1132),(10299,1133),(10300,1133),(10301,1133),(10302,1133),(10303,1134),(10304,1134),(10305,1134),(10306,1134),(10307,1135),(10308,1135),(10309,1135),(10310,1135),(10311,1136),(10312,1136),(10313,1136),(10314,1136),(10315,1137),(10316,1137),(10317,1137),(10318,1137),(10319,1138),(10320,1138),(10321,1138),(10322,1138),(10323,1139),(10324,1139),(10325,1139),(10326,1139),(10327,1140),(10328,1141),(10329,1142),(10330,1143),(10331,1144),(10332,1145),(10333,1146),(10334,1147),(10335,1148),(10336,1149),(10337,1150),(10338,1140),(10339,1141),(10340,1142),(10341,1143),(10342,1144),(10343,1145),(10344,1146),(10345,1147),(10346,1148),(10347,1149),(10348,1150),(10349,1140),(10350,1140),(10351,1141),(10352,1141),(10353,1142),(10354,1142),(10355,1143),(10356,1143),(10357,1144),(10358,1144),(10359,1144),(10360,1145),(10361,1145),(10362,1145),(10363,1146),(10364,1146),(10365,1146),(10366,1147),(10367,1147),(10368,1147),(10369,1148),(10370,1148),(10371,1148),(10372,1149),(10373,1149),(10374,1150),(10375,1150),(10376,1140),(10377,1140),(10378,1140),(10379,1140),(10380,1141),(10381,1141),(10382,1141),(10383,1141),(10384,1142),(10385,1142),(10386,1142),(10387,1142),(10388,1143),(10389,1143),(10390,1143),(10391,1143),(10392,1144),(10393,1144),(10394,1144),(10395,1144),(10396,1145),(10397,1145),(10398,1145),(10399,1145),(10400,1146),(10401,1146),(10402,1146),(10403,1146),(10404,1147),(10405,1147),(10406,1147),(10407,1147),(10408,1148),(10409,1148),(10410,1148),(10411,1148),(10412,1149),(10413,1149),(10414,1149),(10415,1149),(10416,1150),(10417,1150),(10418,1150),(10419,1150),(10420,1151),(10421,1152),(10422,1153),(10423,1154),(10424,1155),(10425,1156),(10426,1157),(10427,1158),(10428,1159),(10429,1160),(10430,1161),(10431,1151),(10432,1152),(10433,1153),(10434,1154),(10435,1155),(10436,1156),(10437,1157),(10438,1158),(10439,1159),(10440,1160),(10441,1161),(10442,1151),(10443,1151),(10444,1151),(10445,1152),(10446,1152),(10447,1152),(10448,1153),(10449,1153),(10450,1153),(10451,1154),(10452,1154),(10453,1154),(10454,1155),(10455,1155),(10456,1155),(10457,1156),(10458,1156),(10459,1156),(10460,1157),(10461,1157),(10462,1157),(10463,1158),(10464,1158),(10465,1158),(10466,1159),(10467,1159),(10468,1159),(10469,1160),(10470,1160),(10471,1160),(10472,1161),(10473,1161),(10474,1161),(10475,1151),(10476,1151),(10477,1151),(10478,1151),(10479,1152),(10480,1152),(10481,1152),(10482,1152),(10483,1153),(10484,1153),(10485,1153),(10486,1153),(10487,1154),(10488,1154),(10489,1154),(10490,1154),(10491,1155),(10492,1155),(10493,1155),(10494,1155),(10495,1156),(10496,1156),(10497,1156),(10498,1156),(10499,1157),(10500,1157),(10501,1157),(10502,1157),(10503,1158),(10504,1158),(10505,1158),(10506,1158),(10507,1159),(10508,1159),(10509,1159),(10510,1159),(10511,1160),(10512,1160),(10513,1160),(10514,1160),(10515,1161),(10516,1161),(10517,1161),(10518,1161),(10519,1162),(10520,1162),(10521,1162),(10522,1162),(10523,1162),(10524,1162),(10525,1163),(10526,1163),(10527,1163),(10528,1163),(10529,1163),(10530,1163),(10531,1163),(10532,1163),(10533,1163),(10534,1164),(10535,1164),(10536,1164),(10537,1164),(10538,1164),(10539,1164),(10540,1164),(10541,1164),(10542,1164),(10543,1165),(10544,1165),(10545,1165),(10546,1165),(10547,1165),(10548,1165),(10549,1165),(10550,1165),(10551,1165),(10552,1166),(10553,1167),(10554,1168),(10555,1169),(10556,1170),(10557,1171),(10558,1172),(10559,1173),(10560,1174),(10561,1175),(10562,1176),(10563,1166),(10564,1167),(10565,1168),(10566,1169),(10567,1170),(10568,1171),(10569,1172),(10570,1173),(10571,1174),(10572,1175),(10573,1176),(10574,1166),(10575,1166),(10576,1166),(10577,1167),(10578,1167),(10579,1167),(10580,1168),(10581,1168),(10582,1168),(10583,1169),(10584,1169),(10585,1169),(10586,1170),(10587,1170),(10588,1170),(10589,1171),(10590,1171),(10591,1171),(10592,1172),(10593,1172),(10594,1172),(10595,1173),(10596,1173),(10597,1173),(10598,1174),(10599,1174),(10600,1174),(10601,1175),(10602,1175),(10603,1175),(10604,1176),(10605,1176),(10606,1176),(10607,1166),(10608,1166),(10609,1166),(10610,1166),(10611,1167),(10612,1167),(10613,1167),(10614,1167),(10615,1168),(10616,1168),(10617,1168),(10618,1168),(10619,1169),(10620,1169),(10621,1169),(10622,1169),(10623,1170),(10624,1170),(10625,1170),(10626,1170),(10627,1171),(10628,1171),(10629,1171),(10630,1171),(10631,1172),(10632,1172),(10633,1172),(10634,1172),(10635,1173),(10636,1173),(10637,1173),(10638,1173),(10639,1174),(10640,1174),(10641,1174),(10642,1174),(10643,1175),(10644,1175),(10645,1175),(10646,1175),(10647,1176),(10648,1176),(10649,1176),(10650,1176),(10651,1177),(10652,1178),(10653,1179),(10654,1180),(10655,1181),(10656,1182),(10657,1183),(10658,1184),(10659,1185),(10660,1186),(10661,1187),(10662,1188),(10663,1189),(10664,1190),(10665,1191),(10666,1192),(10667,1193),(10668,1194),(10669,1195),(10670,1196),(10671,1197),(10672,1198),(10673,1199),(10674,1200),(10675,1201),(10676,1202),(10677,1203),(10678,1204),(10679,1205),(10680,1206),(10681,1207),(10682,1208),(10683,1209),(10684,1210),(10685,1211),(10686,1212),(10687,1213),(10688,1214),(10689,1215),(10690,1216),(10691,1217),(10692,1218),(10693,1219),(10694,1220),(10695,1221),(10696,1222),(10697,1223),(10698,1224),(10699,1225),(10700,1226),(10701,1227),(10702,1228),(10703,1229),(10704,1230),(10705,1231),(10706,1232),(10707,1233),(10708,1234),(10709,1235),(10710,1236),(10711,1237),(10712,1238),(10713,1239),(10714,1240),(10715,1241),(10716,1242),(10717,1243),(10718,1244),(10719,1245),(10720,1246),(10721,1247),(10722,1248),(10723,1249),(10724,1250),(10725,1251),(10726,1252),(10727,1253),(10728,1254),(10729,1255),(10730,1256),(10731,1257),(10732,1258),(10733,1259),(10734,1260),(10735,1261),(10736,1262),(10737,1263),(10738,1264),(10739,1265),(10740,1177),(10741,1178),(10742,1179),(10743,1180),(10744,1181),(10745,1182),(10746,1183),(10747,1184),(10748,1185),(10749,1186),(10750,1187),(10751,1188),(10752,1189),(10753,1190),(10754,1191),(10755,1192),(10756,1193),(10757,1194),(10758,1195),(10759,1196),(10760,1197),(10761,1198),(10762,1199),(10763,1200),(10764,1201),(10765,1202),(10766,1203),(10767,1204),(10768,1205),(10769,1206),(10770,1207),(10771,1208),(10772,1209),(10773,1210),(10774,1211),(10775,1212),(10776,1213),(10777,1214),(10778,1215),(10779,1216),(10780,1217),(10781,1218),(10782,1219),(10783,1220),(10784,1221),(10785,1222),(10786,1223),(10787,1224),(10788,1225),(10789,1226),(10790,1227),(10791,1228),(10792,1229),(10793,1230),(10794,1231),(10795,1232),(10796,1233),(10797,1234),(10798,1235),(10799,1236),(10800,1237),(10801,1238),(10802,1239),(10803,1240),(10804,1241),(10805,1242),(10806,1243),(10807,1244),(10808,1245),(10809,1246),(10810,1247),(10811,1248),(10812,1249),(10813,1250),(10814,1251),(10815,1252),(10816,1253),(10817,1254),(10818,1255),(10819,1256),(10820,1257),(10821,1258),(10822,1259),(10823,1260),(10824,1261),(10825,1262),(10826,1263),(10827,1264),(10828,1265),(10829,1177),(10830,1177),(10831,1177),(10832,1178),(10833,1178),(10834,1178),(10835,1179),(10836,1179),(10837,1179),(10838,1180),(10839,1180),(10840,1180),(10841,1181),(10842,1181),(10843,1181),(10844,1182),(10845,1182),(10846,1182),(10847,1183),(10848,1183),(10849,1183),(10850,1184),(10851,1184),(10852,1184),(10853,1185),(10854,1185),(10855,1185),(10856,1186),(10857,1186),(10858,1186),(10859,1187),(10860,1187),(10861,1187),(10862,1188),(10863,1188),(10864,1188),(10865,1189),(10866,1189),(10867,1189),(10868,1190),(10869,1190),(10870,1190),(10871,1191),(10872,1191),(10873,1191),(10874,1192),(10875,1192),(10876,1192),(10877,1193),(10878,1193),(10879,1193),(10880,1194),(10881,1194),(10882,1194),(10883,1195),(10884,1195),(10885,1195),(10886,1196),(10887,1196),(10888,1196),(10889,1197),(10890,1197),(10891,1197),(10892,1198),(10893,1198),(10894,1198),(10895,1199),(10896,1199),(10897,1199),(10898,1200),(10899,1200),(10900,1200),(10901,1201),(10902,1201),(10903,1201),(10904,1202),(10905,1202),(10906,1202),(10907,1203),(10908,1203),(10909,1203),(10910,1204),(10911,1204),(10912,1204),(10913,1205),(10914,1205),(10915,1205),(10916,1206),(10917,1206),(10918,1206),(10919,1207),(10920,1207),(10921,1207),(10922,1208),(10923,1208),(10924,1208),(10925,1209),(10926,1209),(10927,1209),(10928,1210),(10929,1210),(10930,1210),(10931,1211),(10932,1211),(10933,1211),(10934,1212),(10935,1212),(10936,1212),(10937,1213),(10938,1213),(10939,1213),(10940,1214),(10941,1214),(10942,1214),(10943,1215),(10944,1215),(10945,1215),(10946,1216),(10947,1216),(10948,1216),(10949,1217),(10950,1217),(10951,1217),(10952,1218),(10953,1218),(10954,1218),(10955,1219),(10956,1219),(10957,1219),(10958,1220),(10959,1220),(10960,1220),(10961,1221),(10962,1221),(10963,1221),(10964,1222),(10965,1222),(10966,1222),(10967,1223),(10968,1223),(10969,1223),(10970,1224),(10971,1224),(10972,1224),(10973,1225),(10974,1225),(10975,1225),(10976,1226),(10977,1226),(10978,1226),(10979,1227),(10980,1227),(10981,1227),(10982,1228),(10983,1228),(10984,1228),(10985,1229),(10986,1229),(10987,1229),(10988,1230),(10989,1230),(10990,1230),(10991,1231),(10992,1231),(10993,1231),(10994,1232),(10995,1232),(10996,1232),(10997,1233),(10998,1233),(10999,1233),(11000,1234),(11001,1234),(11002,1234),(11003,1235),(11004,1235),(11005,1235),(11006,1236),(11007,1236),(11008,1236),(11009,1237),(11010,1237),(11011,1237),(11012,1238),(11013,1238),(11014,1238),(11015,1239),(11016,1239),(11017,1239),(11018,1240),(11019,1240),(11020,1240),(11021,1241),(11022,1241),(11023,1241),(11024,1242),(11025,1242),(11026,1242),(11027,1243),(11028,1243),(11029,1243),(11030,1244),(11031,1244),(11032,1244),(11033,1245),(11034,1245),(11035,1245),(11036,1246),(11037,1246),(11038,1246),(11039,1247),(11040,1247),(11041,1247),(11042,1248),(11043,1248),(11044,1248),(11045,1249),(11046,1249),(11047,1249),(11048,1250),(11049,1250),(11050,1250),(11051,1251),(11052,1251),(11053,1251),(11054,1252),(11055,1252),(11056,1252),(11057,1253),(11058,1253),(11059,1253),(11060,1254),(11061,1254),(11062,1254),(11063,1255),(11064,1255),(11065,1255),(11066,1256),(11067,1256),(11068,1256),(11069,1257),(11070,1257),(11071,1257),(11072,1258),(11073,1258),(11074,1258),(11075,1259),(11076,1259),(11077,1259),(11078,1260),(11079,1260),(11080,1260),(11081,1261),(11082,1261),(11083,1261),(11084,1262),(11085,1262),(11086,1262),(11087,1263),(11088,1263),(11089,1263),(11090,1264),(11091,1264),(11092,1264),(11093,1265),(11094,1265),(11095,1265),(11096,1177),(11097,1177),(11098,1177),(11099,1177),(11100,1178),(11101,1178),(11102,1178),(11103,1178),(11104,1179),(11105,1179),(11106,1179),(11107,1179),(11108,1180),(11109,1180),(11110,1180),(11111,1180),(11112,1181),(11113,1181),(11114,1181),(11115,1181),(11116,1182),(11117,1182),(11118,1182),(11119,1182),(11120,1183),(11121,1183),(11122,1183),(11123,1183),(11124,1184),(11125,1184),(11126,1184),(11127,1184),(11128,1185),(11129,1185),(11130,1185),(11131,1185),(11132,1186),(11133,1186),(11134,1186),(11135,1186),(11136,1187),(11137,1187),(11138,1187),(11139,1187),(11140,1188),(11141,1188),(11142,1188),(11143,1188),(11144,1189),(11145,1189),(11146,1189),(11147,1189),(11148,1190),(11149,1190),(11150,1190),(11151,1190),(11152,1191),(11153,1191),(11154,1191),(11155,1191),(11156,1192),(11157,1192),(11158,1192),(11159,1192),(11160,1193),(11161,1193),(11162,1193),(11163,1193),(11164,1194),(11165,1194),(11166,1194),(11167,1194),(11168,1195),(11169,1195),(11170,1195),(11171,1195),(11172,1196),(11173,1196),(11174,1196),(11175,1196),(11176,1197),(11177,1197),(11178,1197),(11179,1197),(11180,1198),(11181,1198),(11182,1198),(11183,1198),(11184,1199),(11185,1199),(11186,1199),(11187,1199),(11188,1200),(11189,1200),(11190,1200),(11191,1200),(11192,1201),(11193,1201),(11194,1201),(11195,1201),(11196,1202),(11197,1202),(11198,1202),(11199,1202),(11200,1203),(11201,1203),(11202,1203),(11203,1203),(11204,1204),(11205,1204),(11206,1204),(11207,1204),(11208,1205),(11209,1205),(11210,1205),(11211,1205),(11212,1206),(11213,1206),(11214,1206),(11215,1206),(11216,1207),(11217,1207),(11218,1207),(11219,1207),(11220,1208),(11221,1208),(11222,1208),(11223,1208),(11224,1209),(11225,1209),(11226,1209),(11227,1209),(11228,1210),(11229,1210),(11230,1210),(11231,1210),(11232,1211),(11233,1211),(11234,1211),(11235,1211),(11236,1212),(11237,1212),(11238,1212),(11239,1212),(11240,1213),(11241,1213),(11242,1213),(11243,1213),(11244,1214),(11245,1214),(11246,1214),(11247,1214),(11248,1215),(11249,1215),(11250,1215),(11251,1215),(11252,1216),(11253,1216),(11254,1216),(11255,1216),(11256,1217),(11257,1217),(11258,1217),(11259,1217),(11260,1218),(11261,1218),(11262,1218),(11263,1218),(11264,1219),(11265,1219),(11266,1219),(11267,1219),(11268,1220),(11269,1220),(11270,1220),(11271,1220),(11272,1221),(11273,1221),(11274,1221),(11275,1221),(11276,1222),(11277,1222),(11278,1222),(11279,1222),(11280,1223),(11281,1223),(11282,1223),(11283,1223),(11284,1224),(11285,1224),(11286,1224),(11287,1224),(11288,1225),(11289,1225),(11290,1225),(11291,1225),(11292,1226),(11293,1226),(11294,1226),(11295,1226),(11296,1227),(11297,1227),(11298,1227),(11299,1227),(11300,1228),(11301,1228),(11302,1228),(11303,1228),(11304,1229),(11305,1229),(11306,1229),(11307,1229),(11308,1230),(11309,1230),(11310,1230),(11311,1230),(11312,1231),(11313,1231),(11314,1231),(11315,1231),(11316,1232),(11317,1232),(11318,1232),(11319,1232),(11320,1233),(11321,1233),(11322,1233),(11323,1233),(11324,1234),(11325,1234),(11326,1234),(11327,1234),(11328,1235),(11329,1235),(11330,1235),(11331,1235),(11332,1236),(11333,1236),(11334,1236),(11335,1236),(11336,1237),(11337,1237),(11338,1237),(11339,1237),(11340,1238),(11341,1238),(11342,1238),(11343,1238),(11344,1239),(11345,1239),(11346,1239),(11347,1239),(11348,1240),(11349,1240),(11350,1240),(11351,1240),(11352,1241),(11353,1241),(11354,1241),(11355,1241),(11356,1242),(11357,1242),(11358,1242),(11359,1242),(11360,1243),(11361,1243),(11362,1243),(11363,1243),(11364,1244),(11365,1244),(11366,1244),(11367,1244),(11368,1245),(11369,1245),(11370,1245),(11371,1245),(11372,1246),(11373,1246),(11374,1246),(11375,1246),(11376,1247),(11377,1247),(11378,1247),(11379,1247),(11380,1248),(11381,1248),(11382,1248),(11383,1248),(11384,1249),(11385,1249),(11386,1249),(11387,1249),(11388,1250),(11389,1250),(11390,1250),(11391,1250),(11392,1251),(11393,1251),(11394,1251),(11395,1251),(11396,1252),(11397,1252),(11398,1252),(11399,1252),(11400,1253),(11401,1253),(11402,1253),(11403,1253),(11404,1254),(11405,1254),(11406,1254),(11407,1254),(11408,1255),(11409,1255),(11410,1255),(11411,1255),(11412,1256),(11413,1256),(11414,1256),(11415,1256),(11416,1257),(11417,1257),(11418,1257),(11419,1257),(11420,1258),(11421,1258),(11422,1258),(11423,1258),(11424,1259),(11425,1259),(11426,1259),(11427,1259),(11428,1260),(11429,1260),(11430,1260),(11431,1260),(11432,1261),(11433,1261),(11434,1261),(11435,1261),(11436,1262),(11437,1262),(11438,1262),(11439,1262),(11440,1263),(11441,1263),(11442,1263),(11443,1263),(11444,1264),(11445,1264),(11446,1264),(11447,1264),(11448,1265),(11449,1265),(11450,1265),(11451,1265),(11452,1266),(11453,1267),(11454,1268),(11455,1269),(11456,1270),(11457,1271),(11458,1272),(11459,1273),(11460,1274),(11461,1275),(11462,1276),(11463,1277),(11464,1278),(11465,1279),(11466,1280),(11467,1281),(11468,1282),(11469,1283),(11470,1284),(11471,1285),(11472,1286),(11473,1287),(11474,1288),(11475,1289),(11476,1290),(11477,1291),(11478,1292),(11479,1293),(11480,1294),(11481,1295),(11482,1296),(11483,1297),(11484,1298),(11485,1299),(11486,1300),(11487,1301),(11488,1302),(11489,1303),(11490,1304),(11491,1305),(11492,1306),(11493,1307),(11494,1308),(11495,1309),(11496,1310),(11497,1311),(11498,1312),(11499,1313),(11500,1314),(11501,1315),(11502,1316),(11503,1317),(11504,1318),(11505,1319),(11506,1320),(11507,1321),(11508,1322),(11509,1323),(11510,1324),(11511,1325),(11512,1326),(11513,1327),(11514,1328),(11515,1329),(11516,1330),(11517,1331),(11518,1332),(11519,1333),(11520,1334),(11521,1335),(11522,1336),(11523,1337),(11524,1338),(11525,1339),(11526,1340),(11527,1341),(11528,1342),(11529,1343),(11530,1344),(11531,1345),(11532,1346),(11533,1347),(11534,1348),(11535,1349),(11536,1350),(11537,1351),(11538,1352),(11539,1353),(11540,1354),(11541,1355),(11542,1356),(11543,1357),(11544,1358),(11545,1359),(11546,1360),(11547,1361),(11548,1362),(11549,1363),(11550,1364),(11551,1365),(11552,1266),(11553,1267),(11554,1268),(11555,1269),(11556,1270),(11557,1271),(11558,1272),(11559,1273),(11560,1274),(11561,1275),(11562,1276),(11563,1277),(11564,1278),(11565,1279),(11566,1280),(11567,1281),(11568,1282),(11569,1283),(11570,1284),(11571,1285),(11572,1286),(11573,1287),(11574,1288),(11575,1289),(11576,1290),(11577,1291),(11578,1292),(11579,1293),(11580,1294),(11581,1295),(11582,1296),(11583,1297),(11584,1298),(11585,1299),(11586,1300),(11587,1301),(11588,1302),(11589,1303),(11590,1304),(11591,1305),(11592,1306),(11593,1307),(11594,1308),(11595,1309),(11596,1310),(11597,1311),(11598,1312),(11599,1313),(11600,1314),(11601,1315),(11602,1316),(11603,1317),(11604,1318),(11605,1319),(11606,1320),(11607,1321),(11608,1322),(11609,1323),(11610,1324),(11611,1325),(11612,1326),(11613,1327),(11614,1328),(11615,1329),(11616,1330),(11617,1331),(11618,1332),(11619,1333),(11620,1334),(11621,1335),(11622,1336),(11623,1337),(11624,1338),(11625,1339),(11626,1340),(11627,1341),(11628,1342),(11629,1343),(11630,1344),(11631,1345),(11632,1346),(11633,1347),(11634,1348),(11635,1349),(11636,1350),(11637,1351),(11638,1352),(11639,1353),(11640,1354),(11641,1355),(11642,1356),(11643,1357),(11644,1358),(11645,1359),(11646,1360),(11647,1361),(11648,1362),(11649,1363),(11650,1364),(11651,1365),(11652,1266),(11653,1266),(11654,1266),(11655,1267),(11656,1267),(11657,1267),(11658,1268),(11659,1268),(11660,1268),(11661,1269),(11662,1269),(11663,1269),(11664,1270),(11665,1270),(11666,1270),(11667,1271),(11668,1271),(11669,1271),(11670,1272),(11671,1272),(11672,1272),(11673,1273),(11674,1273),(11675,1273),(11676,1274),(11677,1274),(11678,1274),(11679,1275),(11680,1275),(11681,1275),(11682,1276),(11683,1276),(11684,1276),(11685,1277),(11686,1277),(11687,1277),(11688,1278),(11689,1278),(11690,1278),(11691,1279),(11692,1279),(11693,1279),(11694,1280),(11695,1280),(11696,1280),(11697,1281),(11698,1281),(11699,1281),(11700,1282),(11701,1282),(11702,1282),(11703,1283),(11704,1283),(11705,1283),(11706,1284),(11707,1284),(11708,1284),(11709,1285),(11710,1285),(11711,1285),(11712,1286),(11713,1286),(11714,1286),(11715,1287),(11716,1287),(11717,1287),(11718,1288),(11719,1288),(11720,1288),(11721,1289),(11722,1289),(11723,1289),(11724,1290),(11725,1290),(11726,1290),(11727,1291),(11728,1291),(11729,1291),(11730,1292),(11731,1292),(11732,1292),(11733,1293),(11734,1293),(11735,1293),(11736,1294),(11737,1294),(11738,1294),(11739,1295),(11740,1295),(11741,1295),(11742,1296),(11743,1296),(11744,1296),(11745,1297),(11746,1297),(11747,1297),(11748,1298),(11749,1298),(11750,1298),(11751,1299),(11752,1299),(11753,1299),(11754,1300),(11755,1300),(11756,1300),(11757,1301),(11758,1301),(11759,1301),(11760,1302),(11761,1302),(11762,1302),(11763,1303),(11764,1303),(11765,1303),(11766,1304),(11767,1304),(11768,1304),(11769,1305),(11770,1305),(11771,1305),(11772,1306),(11773,1306),(11774,1306),(11775,1307),(11776,1307),(11777,1307),(11778,1308),(11779,1308),(11780,1308),(11781,1309),(11782,1309),(11783,1309),(11784,1310),(11785,1310),(11786,1310),(11787,1311),(11788,1311),(11789,1311),(11790,1312),(11791,1312),(11792,1312),(11793,1313),(11794,1313),(11795,1313),(11796,1314),(11797,1314),(11798,1314),(11799,1315),(11800,1315),(11801,1315),(11802,1316),(11803,1316),(11804,1316),(11805,1317),(11806,1317),(11807,1317),(11808,1318),(11809,1318),(11810,1318),(11811,1319),(11812,1319),(11813,1319),(11814,1320),(11815,1320),(11816,1320),(11817,1321),(11818,1321),(11819,1321),(11820,1322),(11821,1322),(11822,1322),(11823,1323),(11824,1323),(11825,1323),(11826,1324),(11827,1324),(11828,1324),(11829,1325),(11830,1325),(11831,1325),(11832,1326),(11833,1326),(11834,1326),(11835,1327),(11836,1327),(11837,1327),(11838,1328),(11839,1328),(11840,1328),(11841,1329),(11842,1329),(11843,1329),(11844,1330),(11845,1330),(11846,1330),(11847,1331),(11848,1331),(11849,1331),(11850,1332),(11851,1332),(11852,1332),(11853,1333),(11854,1333),(11855,1333),(11856,1334),(11857,1334),(11858,1334),(11859,1335),(11860,1335),(11861,1335),(11862,1336),(11863,1336),(11864,1336),(11865,1337),(11866,1337),(11867,1337),(11868,1338),(11869,1338),(11870,1338),(11871,1339),(11872,1339),(11873,1339),(11874,1340),(11875,1340),(11876,1340),(11877,1341),(11878,1341),(11879,1341),(11880,1342),(11881,1342),(11882,1342),(11883,1343),(11884,1343),(11885,1343),(11886,1344),(11887,1344),(11888,1344),(11889,1345),(11890,1345),(11891,1345),(11892,1346),(11893,1346),(11894,1346),(11895,1347),(11896,1347),(11897,1347),(11898,1348),(11899,1348),(11900,1348),(11901,1349),(11902,1349),(11903,1349),(11904,1350),(11905,1350),(11906,1350),(11907,1351),(11908,1351),(11909,1351),(11910,1352),(11911,1352),(11912,1352),(11913,1353),(11914,1353),(11915,1353),(11916,1354),(11917,1354),(11918,1354),(11919,1355),(11920,1355),(11921,1355),(11922,1356),(11923,1356),(11924,1356),(11925,1357),(11926,1357),(11927,1357),(11928,1358),(11929,1358),(11930,1358),(11931,1359),(11932,1359),(11933,1359),(11934,1360),(11935,1360),(11936,1360),(11937,1361),(11938,1361),(11939,1361),(11940,1362),(11941,1362),(11942,1362),(11943,1363),(11944,1363),(11945,1363),(11946,1364),(11947,1364),(11948,1364),(11949,1365),(11950,1365),(11951,1365),(11952,1266),(11953,1266),(11954,1266),(11955,1266),(11956,1267),(11957,1267),(11958,1267),(11959,1267),(11960,1268),(11961,1268),(11962,1268),(11963,1268),(11964,1269),(11965,1269),(11966,1269),(11967,1269),(11968,1270),(11969,1270),(11970,1270),(11971,1270),(11972,1271),(11973,1271),(11974,1271),(11975,1271),(11976,1272),(11977,1272),(11978,1272),(11979,1272),(11980,1273),(11981,1273),(11982,1273),(11983,1273),(11984,1274),(11985,1274),(11986,1274),(11987,1274),(11988,1275),(11989,1275),(11990,1275),(11991,1275),(11992,1276),(11993,1276),(11994,1276),(11995,1276),(11996,1277),(11997,1277),(11998,1277),(11999,1277),(12000,1278),(12001,1278),(12002,1278),(12003,1278),(12004,1279),(12005,1279),(12006,1279),(12007,1279),(12008,1280),(12009,1280),(12010,1280),(12011,1280),(12012,1281),(12013,1281),(12014,1281),(12015,1281),(12016,1282),(12017,1282),(12018,1282),(12019,1282),(12020,1283),(12021,1283),(12022,1283),(12023,1283),(12024,1284),(12025,1284),(12026,1284),(12027,1284),(12028,1285),(12029,1285),(12030,1285),(12031,1285),(12032,1286),(12033,1286),(12034,1286),(12035,1286),(12036,1287),(12037,1287),(12038,1287),(12039,1287),(12040,1288),(12041,1288),(12042,1288),(12043,1288),(12044,1289),(12045,1289),(12046,1289),(12047,1289),(12048,1290),(12049,1290),(12050,1290),(12051,1290),(12052,1291),(12053,1291),(12054,1291),(12055,1291),(12056,1292),(12057,1292),(12058,1292),(12059,1292),(12060,1293),(12061,1293),(12062,1293),(12063,1293),(12064,1294),(12065,1294),(12066,1294),(12067,1294),(12068,1295),(12069,1295),(12070,1295),(12071,1295),(12072,1296),(12073,1296),(12074,1296),(12075,1296),(12076,1297),(12077,1297),(12078,1297),(12079,1297),(12080,1298),(12081,1298),(12082,1298),(12083,1298),(12084,1299),(12085,1299),(12086,1299),(12087,1299),(12088,1300),(12089,1300),(12090,1300),(12091,1300),(12092,1301),(12093,1301),(12094,1301),(12095,1301),(12096,1302),(12097,1302),(12098,1302),(12099,1302),(12100,1303),(12101,1303),(12102,1303),(12103,1303),(12104,1304),(12105,1304),(12106,1304),(12107,1304),(12108,1305),(12109,1305),(12110,1305),(12111,1305),(12112,1306),(12113,1306),(12114,1306),(12115,1306),(12116,1307),(12117,1307),(12118,1307),(12119,1307),(12120,1308),(12121,1308),(12122,1308),(12123,1308),(12124,1309),(12125,1309),(12126,1309),(12127,1309),(12128,1310),(12129,1310),(12130,1310),(12131,1310),(12132,1311),(12133,1311),(12134,1311),(12135,1311),(12136,1312),(12137,1312),(12138,1312),(12139,1312),(12140,1313),(12141,1313),(12142,1313),(12143,1313),(12144,1314),(12145,1314),(12146,1314),(12147,1314),(12148,1315),(12149,1315),(12150,1315),(12151,1315),(12152,1316),(12153,1316),(12154,1316),(12155,1316),(12156,1317),(12157,1317),(12158,1317),(12159,1317),(12160,1318),(12161,1318),(12162,1318),(12163,1318),(12164,1319),(12165,1319),(12166,1319),(12167,1319),(12168,1320),(12169,1320),(12170,1320),(12171,1320),(12172,1321),(12173,1321),(12174,1321),(12175,1321),(12176,1322),(12177,1322),(12178,1322),(12179,1322),(12180,1323),(12181,1323),(12182,1323),(12183,1323),(12184,1324),(12185,1324),(12186,1324),(12187,1324),(12188,1325),(12189,1325),(12190,1325),(12191,1325),(12192,1326),(12193,1326),(12194,1326),(12195,1326),(12196,1327),(12197,1327),(12198,1327),(12199,1327),(12200,1328),(12201,1328),(12202,1328),(12203,1328),(12204,1329),(12205,1329),(12206,1329),(12207,1329),(12208,1330),(12209,1330),(12210,1330),(12211,1330),(12212,1331),(12213,1331),(12214,1331),(12215,1331),(12216,1332),(12217,1332),(12218,1332),(12219,1332),(12220,1333),(12221,1333),(12222,1333),(12223,1333),(12224,1334),(12225,1334),(12226,1334),(12227,1334),(12228,1335),(12229,1335),(12230,1335),(12231,1335),(12232,1336),(12233,1336),(12234,1336),(12235,1336),(12236,1337),(12237,1337),(12238,1337),(12239,1337),(12240,1338),(12241,1338),(12242,1338),(12243,1338),(12244,1339),(12245,1339),(12246,1339),(12247,1339),(12248,1340),(12249,1340),(12250,1340),(12251,1340),(12252,1341),(12253,1341),(12254,1341),(12255,1341),(12256,1342),(12257,1342),(12258,1342),(12259,1342),(12260,1343),(12261,1343),(12262,1343),(12263,1343),(12264,1344),(12265,1344),(12266,1344),(12267,1344),(12268,1345),(12269,1345),(12270,1345),(12271,1345),(12272,1346),(12273,1346),(12274,1346),(12275,1346),(12276,1347),(12277,1347),(12278,1347),(12279,1347),(12280,1348),(12281,1348),(12282,1348),(12283,1348),(12284,1349),(12285,1349),(12286,1349),(12287,1349),(12288,1350),(12289,1350),(12290,1350),(12291,1350),(12292,1351),(12293,1351),(12294,1351),(12295,1351),(12296,1352),(12297,1352),(12298,1352),(12299,1352),(12300,1353),(12301,1353),(12302,1353),(12303,1353),(12304,1354),(12305,1354),(12306,1354),(12307,1354),(12308,1355),(12309,1355),(12310,1355),(12311,1355),(12312,1356),(12313,1356),(12314,1356),(12315,1356),(12316,1357),(12317,1357),(12318,1357),(12319,1357),(12320,1358),(12321,1358),(12322,1358),(12323,1358),(12324,1359),(12325,1359),(12326,1359),(12327,1359),(12328,1360),(12329,1360),(12330,1360),(12331,1360),(12332,1361),(12333,1361),(12334,1361),(12335,1361),(12336,1362),(12337,1362),(12338,1362),(12339,1362),(12340,1363),(12341,1363),(12342,1363),(12343,1363),(12344,1364),(12345,1364),(12346,1364),(12347,1364),(12348,1365),(12349,1365),(12350,1365),(12351,1365),(12352,1366),(12353,1367),(12354,1368),(12355,1369),(12356,1370),(12357,1371),(12358,1372),(12359,1373),(12360,1374),(12361,1375),(12362,1376),(12363,1377),(12364,1378),(12365,1379),(12366,1380),(12367,1381),(12368,1382),(12369,1383),(12370,1384),(12371,1385),(12372,1386),(12373,1387),(12374,1388),(12375,1389),(12376,1390),(12377,1391),(12378,1392),(12379,1393),(12380,1394),(12381,1395),(12382,1396),(12383,1397),(12384,1398),(12385,1399),(12386,1400),(12387,1401),(12388,1402),(12389,1403),(12390,1404),(12391,1405),(12392,1406),(12393,1407),(12394,1408),(12395,1409),(12396,1410),(12397,1411),(12398,1412),(12399,1413),(12400,1414),(12401,1415),(12402,1416),(12403,1417),(12404,1418),(12405,1419),(12406,1420),(12407,1421),(12408,1422),(12409,1423),(12410,1424),(12411,1425),(12412,1426),(12413,1427),(12414,1428),(12415,1429),(12416,1430),(12417,1431),(12418,1432),(12419,1433),(12420,1434),(12421,1435),(12422,1436),(12423,1437),(12424,1438),(12425,1439),(12426,1440),(12427,1441),(12428,1442),(12429,1443),(12430,1444),(12431,1445),(12432,1446),(12433,1447),(12434,1448),(12435,1449),(12436,1450),(12437,1451),(12438,1452),(12439,1453),(12440,1454),(12441,1455),(12442,1456),(12443,1457),(12444,1458),(12445,1459),(12446,1460),(12447,1461),(12448,1462),(12449,1463),(12450,1464),(12451,1465),(12452,1366),(12453,1367),(12454,1368),(12455,1369),(12456,1370),(12457,1371),(12458,1372),(12459,1373),(12460,1374),(12461,1375),(12462,1376),(12463,1377),(12464,1378),(12465,1379),(12466,1380),(12467,1381),(12468,1382),(12469,1383),(12470,1384),(12471,1385),(12472,1386),(12473,1387),(12474,1388),(12475,1389),(12476,1390),(12477,1391),(12478,1392),(12479,1393),(12480,1394),(12481,1395),(12482,1396),(12483,1397),(12484,1398),(12485,1399),(12486,1400),(12487,1401),(12488,1402),(12489,1403),(12490,1404),(12491,1405),(12492,1406),(12493,1407),(12494,1408),(12495,1409),(12496,1410),(12497,1411),(12498,1412),(12499,1413),(12500,1414),(12501,1415),(12502,1416),(12503,1417),(12504,1418),(12505,1419),(12506,1420),(12507,1421),(12508,1422),(12509,1423),(12510,1424),(12511,1425),(12512,1426),(12513,1427),(12514,1428),(12515,1429),(12516,1430),(12517,1431),(12518,1432),(12519,1433),(12520,1434),(12521,1435),(12522,1436),(12523,1437),(12524,1438),(12525,1439),(12526,1440),(12527,1441),(12528,1442),(12529,1443),(12530,1444),(12531,1445),(12532,1446),(12533,1447),(12534,1448),(12535,1449),(12536,1450),(12537,1451),(12538,1452),(12539,1453),(12540,1454),(12541,1455),(12542,1456),(12543,1457),(12544,1458),(12545,1459),(12546,1460),(12547,1461),(12548,1462),(12549,1463),(12550,1464),(12551,1465),(12552,1366),(12553,1366),(12554,1366),(12555,1367),(12556,1367),(12557,1367),(12558,1368),(12559,1368),(12560,1368),(12561,1369),(12562,1369),(12563,1369),(12564,1370),(12565,1370),(12566,1370),(12567,1371),(12568,1371),(12569,1371),(12570,1372),(12571,1372),(12572,1372),(12573,1373),(12574,1373),(12575,1373),(12576,1374),(12577,1374),(12578,1374),(12579,1375),(12580,1375),(12581,1375),(12582,1376),(12583,1376),(12584,1376),(12585,1377),(12586,1377),(12587,1377),(12588,1378),(12589,1378),(12590,1378),(12591,1379),(12592,1379),(12593,1379),(12594,1380),(12595,1380),(12596,1380),(12597,1381),(12598,1381),(12599,1381),(12600,1382),(12601,1382),(12602,1382),(12603,1383),(12604,1383),(12605,1383),(12606,1384),(12607,1384),(12608,1384),(12609,1385),(12610,1385),(12611,1385),(12612,1386),(12613,1386),(12614,1386),(12615,1387),(12616,1387),(12617,1387),(12618,1388),(12619,1388),(12620,1388),(12621,1389),(12622,1389),(12623,1389),(12624,1390),(12625,1390),(12626,1390),(12627,1391),(12628,1391),(12629,1391),(12630,1392),(12631,1392),(12632,1392),(12633,1393),(12634,1393),(12635,1393),(12636,1394),(12637,1394),(12638,1394),(12639,1395),(12640,1395),(12641,1395),(12642,1396),(12643,1396),(12644,1396),(12645,1397),(12646,1397),(12647,1397),(12648,1398),(12649,1398),(12650,1398),(12651,1399),(12652,1399),(12653,1399),(12654,1400),(12655,1400),(12656,1400),(12657,1401),(12658,1401),(12659,1401),(12660,1402),(12661,1402),(12662,1402),(12663,1403),(12664,1403),(12665,1403),(12666,1404),(12667,1404),(12668,1404),(12669,1405),(12670,1405),(12671,1405),(12672,1406),(12673,1406),(12674,1406),(12675,1407),(12676,1407),(12677,1407),(12678,1408),(12679,1408),(12680,1408),(12681,1409),(12682,1409),(12683,1409),(12684,1410),(12685,1410),(12686,1410),(12687,1411),(12688,1411),(12689,1411),(12690,1412),(12691,1412),(12692,1412),(12693,1413),(12694,1413),(12695,1413),(12696,1414),(12697,1414),(12698,1414),(12699,1415),(12700,1415),(12701,1415),(12702,1416),(12703,1416),(12704,1416),(12705,1417),(12706,1417),(12707,1417),(12708,1418),(12709,1418),(12710,1418),(12711,1419),(12712,1419),(12713,1419),(12714,1420),(12715,1420),(12716,1420),(12717,1421),(12718,1421),(12719,1421),(12720,1422),(12721,1422),(12722,1422),(12723,1423),(12724,1423),(12725,1423),(12726,1424),(12727,1424),(12728,1424),(12729,1425),(12730,1425),(12731,1425),(12732,1426),(12733,1426),(12734,1426),(12735,1427),(12736,1427),(12737,1427),(12738,1428),(12739,1428),(12740,1428),(12741,1429),(12742,1429),(12743,1429),(12744,1430),(12745,1430),(12746,1430),(12747,1431),(12748,1431),(12749,1431),(12750,1432),(12751,1432),(12752,1432),(12753,1433),(12754,1433),(12755,1433),(12756,1434),(12757,1434),(12758,1434),(12759,1435),(12760,1435),(12761,1435),(12762,1436),(12763,1436),(12764,1436),(12765,1437),(12766,1437),(12767,1437),(12768,1438),(12769,1438),(12770,1438),(12771,1439),(12772,1439),(12773,1439),(12774,1440),(12775,1440),(12776,1440),(12777,1441),(12778,1441),(12779,1441),(12780,1442),(12781,1442),(12782,1442),(12783,1443),(12784,1443),(12785,1443),(12786,1444),(12787,1444),(12788,1444),(12789,1445),(12790,1445),(12791,1445),(12792,1446),(12793,1446),(12794,1446),(12795,1447),(12796,1447),(12797,1447),(12798,1448),(12799,1448),(12800,1448),(12801,1449),(12802,1449),(12803,1449),(12804,1450),(12805,1450),(12806,1450),(12807,1451),(12808,1451),(12809,1451),(12810,1452),(12811,1452),(12812,1452),(12813,1453),(12814,1453),(12815,1453),(12816,1454),(12817,1454),(12818,1454),(12819,1455),(12820,1455),(12821,1455),(12822,1456),(12823,1456),(12824,1456),(12825,1457),(12826,1457),(12827,1457),(12828,1458),(12829,1458),(12830,1458),(12831,1459),(12832,1459),(12833,1459),(12834,1460),(12835,1460),(12836,1460),(12837,1461),(12838,1461),(12839,1461),(12840,1462),(12841,1462),(12842,1462),(12843,1463),(12844,1463),(12845,1463),(12846,1464),(12847,1464),(12848,1464),(12849,1465),(12850,1465),(12851,1465),(12852,1366),(12853,1366),(12854,1366),(12855,1366),(12856,1367),(12857,1367),(12858,1367),(12859,1367),(12860,1368),(12861,1368),(12862,1368),(12863,1368),(12864,1369),(12865,1369),(12866,1369),(12867,1369),(12868,1370),(12869,1370),(12870,1370),(12871,1370),(12872,1371),(12873,1371),(12874,1371),(12875,1371),(12876,1372),(12877,1372),(12878,1372),(12879,1372),(12880,1373),(12881,1373),(12882,1373),(12883,1373),(12884,1374),(12885,1374),(12886,1374),(12887,1374),(12888,1375),(12889,1375),(12890,1375),(12891,1375),(12892,1376),(12893,1376),(12894,1376),(12895,1376),(12896,1377),(12897,1377),(12898,1377),(12899,1377),(12900,1378),(12901,1378),(12902,1378),(12903,1378),(12904,1379),(12905,1379),(12906,1379),(12907,1379),(12908,1380),(12909,1380),(12910,1380),(12911,1380),(12912,1381),(12913,1381),(12914,1381),(12915,1381),(12916,1382),(12917,1382),(12918,1382),(12919,1382),(12920,1383),(12921,1383),(12922,1383),(12923,1383),(12924,1384),(12925,1384),(12926,1384),(12927,1384),(12928,1385),(12929,1385),(12930,1385),(12931,1385),(12932,1386),(12933,1386),(12934,1386),(12935,1386),(12936,1387),(12937,1387),(12938,1387),(12939,1387),(12940,1388),(12941,1388),(12942,1388),(12943,1388),(12944,1389),(12945,1389),(12946,1389),(12947,1389),(12948,1390),(12949,1390),(12950,1390),(12951,1390),(12952,1391),(12953,1391),(12954,1391),(12955,1391),(12956,1392),(12957,1392),(12958,1392),(12959,1392),(12960,1393),(12961,1393),(12962,1393),(12963,1393),(12964,1394),(12965,1394),(12966,1394),(12967,1394),(12968,1395),(12969,1395),(12970,1395),(12971,1395),(12972,1396),(12973,1396),(12974,1396),(12975,1396),(12976,1397),(12977,1397),(12978,1397),(12979,1397),(12980,1398),(12981,1398),(12982,1398),(12983,1398),(12984,1399),(12985,1399),(12986,1399),(12987,1399),(12988,1400),(12989,1400),(12990,1400),(12991,1400),(12992,1401),(12993,1401),(12994,1401),(12995,1401),(12996,1402),(12997,1402),(12998,1402),(12999,1402),(13000,1403),(13001,1403),(13002,1403),(13003,1403),(13004,1404),(13005,1404),(13006,1404),(13007,1404),(13008,1405),(13009,1405),(13010,1405),(13011,1405),(13012,1406),(13013,1406),(13014,1406),(13015,1406),(13016,1407),(13017,1407),(13018,1407),(13019,1407),(13020,1408),(13021,1408),(13022,1408),(13023,1408),(13024,1409),(13025,1409),(13026,1409),(13027,1409),(13028,1410),(13029,1410),(13030,1410),(13031,1410),(13032,1411),(13033,1411),(13034,1411),(13035,1411),(13036,1412),(13037,1412),(13038,1412),(13039,1412),(13040,1413),(13041,1413),(13042,1413),(13043,1413),(13044,1414),(13045,1414),(13046,1414),(13047,1414),(13048,1415),(13049,1415),(13050,1415),(13051,1415),(13052,1416),(13053,1416),(13054,1416),(13055,1416),(13056,1417),(13057,1417),(13058,1417),(13059,1417),(13060,1418),(13061,1418),(13062,1418),(13063,1418),(13064,1419),(13065,1419),(13066,1419),(13067,1419),(13068,1420),(13069,1420),(13070,1420),(13071,1420),(13072,1421),(13073,1421),(13074,1421),(13075,1421),(13076,1422),(13077,1422),(13078,1422),(13079,1422),(13080,1423),(13081,1423),(13082,1423),(13083,1423),(13084,1424),(13085,1424),(13086,1424),(13087,1424),(13088,1425),(13089,1425),(13090,1425),(13091,1425),(13092,1426),(13093,1426),(13094,1426),(13095,1426),(13096,1427),(13097,1427),(13098,1427),(13099,1427),(13100,1428),(13101,1428),(13102,1428),(13103,1428),(13104,1429),(13105,1429),(13106,1429),(13107,1429),(13108,1430),(13109,1430),(13110,1430),(13111,1430),(13112,1431),(13113,1431),(13114,1431),(13115,1431),(13116,1432),(13117,1432),(13118,1432),(13119,1432),(13120,1433),(13121,1433),(13122,1433),(13123,1433),(13124,1434),(13125,1434),(13126,1434),(13127,1434),(13128,1435),(13129,1435),(13130,1435),(13131,1435),(13132,1436),(13133,1436),(13134,1436),(13135,1436),(13136,1437),(13137,1437),(13138,1437),(13139,1437),(13140,1438),(13141,1438),(13142,1438),(13143,1438),(13144,1439),(13145,1439),(13146,1439),(13147,1439),(13148,1440),(13149,1440),(13150,1440),(13151,1440),(13152,1441),(13153,1441),(13154,1441),(13155,1441),(13156,1442),(13157,1442),(13158,1442),(13159,1442),(13160,1443),(13161,1443),(13162,1443),(13163,1443),(13164,1444),(13165,1444),(13166,1444),(13167,1444),(13168,1445),(13169,1445),(13170,1445),(13171,1445),(13172,1446),(13173,1446),(13174,1446),(13175,1446),(13176,1447),(13177,1447),(13178,1447),(13179,1447),(13180,1448),(13181,1448),(13182,1448),(13183,1448),(13184,1449),(13185,1449),(13186,1449),(13187,1449),(13188,1450),(13189,1450),(13190,1450),(13191,1450),(13192,1451),(13193,1451),(13194,1451),(13195,1451),(13196,1452),(13197,1452),(13198,1452),(13199,1452),(13200,1453),(13201,1453),(13202,1453),(13203,1453),(13204,1454),(13205,1454),(13206,1454),(13207,1454),(13208,1455),(13209,1455),(13210,1455),(13211,1455),(13212,1456),(13213,1456),(13214,1456),(13215,1456),(13216,1457),(13217,1457),(13218,1457),(13219,1457),(13220,1458),(13221,1458),(13222,1458),(13223,1458),(13224,1459),(13225,1459),(13226,1459),(13227,1459),(13228,1460),(13229,1460),(13230,1460),(13231,1460),(13232,1461),(13233,1461),(13234,1461),(13235,1461),(13236,1462),(13237,1462),(13238,1462),(13239,1462),(13240,1463),(13241,1463),(13242,1463),(13243,1463),(13244,1464),(13245,1464),(13246,1464),(13247,1464),(13248,1465),(13249,1465),(13250,1465),(13251,1465),(13252,1466),(13253,1467),(13254,1468),(13255,1469),(13256,1470),(13257,1471),(13258,1472),(13259,1473),(13260,1474),(13261,1475),(13262,1476),(13263,1477),(13264,1478),(13265,1479),(13266,1480),(13267,1481),(13268,1482),(13269,1483),(13270,1484),(13271,1485),(13272,1486),(13273,1487),(13274,1488),(13275,1489),(13276,1490),(13277,1491),(13278,1492),(13279,1493),(13280,1494),(13281,1495),(13282,1496),(13283,1497),(13284,1498),(13285,1499),(13286,1500),(13287,1501),(13288,1502),(13289,1503),(13290,1504),(13291,1505),(13292,1506),(13293,1507),(13294,1508),(13295,1509),(13296,1510),(13297,1511),(13298,1512),(13299,1513),(13300,1514),(13301,1515),(13302,1516),(13303,1517),(13304,1518),(13305,1519),(13306,1520),(13307,1521),(13308,1522),(13309,1523),(13310,1524),(13311,1525),(13312,1526),(13313,1527),(13314,1528),(13315,1529),(13316,1530),(13317,1531),(13318,1532),(13319,1533),(13320,1534),(13321,1535),(13322,1536),(13323,1537),(13324,1538),(13325,1539),(13326,1540),(13327,1541),(13328,1542),(13329,1543),(13330,1544),(13331,1545),(13332,1546),(13333,1547),(13334,1548),(13335,1549),(13336,1550),(13337,1551),(13338,1552),(13339,1553),(13340,1554),(13341,1555),(13342,1556),(13343,1557),(13344,1558),(13345,1559),(13346,1560),(13347,1561),(13348,1562),(13349,1563),(13350,1564),(13351,1565),(13352,1466),(13353,1467),(13354,1468),(13355,1469),(13356,1470),(13357,1471),(13358,1472),(13359,1473),(13360,1474),(13361,1475),(13362,1476),(13363,1477),(13364,1478),(13365,1479),(13366,1480),(13367,1481),(13368,1482),(13369,1483),(13370,1484),(13371,1485),(13372,1486),(13373,1487),(13374,1488),(13375,1489),(13376,1490),(13377,1491),(13378,1492),(13379,1493),(13380,1494),(13381,1495),(13382,1496),(13383,1497),(13384,1498),(13385,1499),(13386,1500),(13387,1501),(13388,1502),(13389,1503),(13390,1504),(13391,1505),(13392,1506),(13393,1507),(13394,1508),(13395,1509),(13396,1510),(13397,1511),(13398,1512),(13399,1513),(13400,1514),(13401,1515),(13402,1516),(13403,1517),(13404,1518),(13405,1519),(13406,1520),(13407,1521),(13408,1522),(13409,1523),(13410,1524),(13411,1525),(13412,1526),(13413,1527),(13414,1528),(13415,1529),(13416,1530),(13417,1531),(13418,1532),(13419,1533),(13420,1534),(13421,1535),(13422,1536),(13423,1537),(13424,1538),(13425,1539),(13426,1540),(13427,1541),(13428,1542),(13429,1543),(13430,1544),(13431,1545),(13432,1546),(13433,1547),(13434,1548),(13435,1549),(13436,1550),(13437,1551),(13438,1552),(13439,1553),(13440,1554),(13441,1555),(13442,1556),(13443,1557),(13444,1558),(13445,1559),(13446,1560),(13447,1561),(13448,1562),(13449,1563),(13450,1564),(13451,1565),(13452,1466),(13453,1466),(13454,1466),(13455,1467),(13456,1467),(13457,1467),(13458,1468),(13459,1468),(13460,1468),(13461,1469),(13462,1469),(13463,1469),(13464,1470),(13465,1470),(13466,1470),(13467,1471),(13468,1471),(13469,1471),(13470,1472),(13471,1472),(13472,1472),(13473,1473),(13474,1473),(13475,1473),(13476,1474),(13477,1474),(13478,1474),(13479,1475),(13480,1475),(13481,1475),(13482,1476),(13483,1476),(13484,1476),(13485,1477),(13486,1477),(13487,1477),(13488,1478),(13489,1478),(13490,1478),(13491,1479),(13492,1479),(13493,1479),(13494,1480),(13495,1480),(13496,1480),(13497,1481),(13498,1481),(13499,1481),(13500,1482),(13501,1482),(13502,1482),(13503,1483),(13504,1483),(13505,1483),(13506,1484),(13507,1484),(13508,1484),(13509,1485),(13510,1485),(13511,1485),(13512,1486),(13513,1486),(13514,1486),(13515,1487),(13516,1487),(13517,1487),(13518,1488),(13519,1488),(13520,1488),(13521,1489),(13522,1489),(13523,1489),(13524,1490),(13525,1490),(13526,1490),(13527,1491),(13528,1491),(13529,1491),(13530,1492),(13531,1492),(13532,1492),(13533,1493),(13534,1493),(13535,1493),(13536,1494),(13537,1494),(13538,1494),(13539,1495),(13540,1495),(13541,1496),(13542,1496),(13543,1496),(13544,1497),(13545,1497),(13546,1498),(13547,1498),(13548,1499),(13549,1499),(13550,1500),(13551,1500),(13552,1501),(13553,1501),(13554,1502),(13555,1502),(13556,1503),(13557,1503),(13558,1504),(13559,1504),(13560,1505),(13561,1505),(13562,1506),(13563,1506),(13564,1507),(13565,1507),(13566,1508),(13567,1508),(13568,1509),(13569,1509),(13570,1510),(13571,1510),(13572,1511),(13573,1511),(13574,1512),(13575,1512),(13576,1513),(13577,1513),(13578,1514),(13579,1514),(13580,1515),(13581,1515),(13582,1515),(13583,1516),(13584,1516),(13585,1516),(13586,1517),(13587,1517),(13588,1517),(13589,1518),(13590,1518),(13591,1518),(13592,1519),(13593,1519),(13594,1519),(13595,1520),(13596,1520),(13597,1520),(13598,1521),(13599,1521),(13600,1521),(13601,1522),(13602,1522),(13603,1522),(13604,1523),(13605,1523),(13606,1523),(13607,1524),(13608,1524),(13609,1524),(13610,1525),(13611,1525),(13612,1525),(13613,1526),(13614,1526),(13615,1526),(13616,1527),(13617,1527),(13618,1527),(13619,1528),(13620,1528),(13621,1528),(13622,1529),(13623,1529),(13624,1529),(13625,1530),(13626,1530),(13627,1530),(13628,1531),(13629,1531),(13630,1531),(13631,1532),(13632,1532),(13633,1532),(13634,1533),(13635,1533),(13636,1533),(13637,1534),(13638,1534),(13639,1534),(13640,1535),(13641,1535),(13642,1535),(13643,1536),(13644,1536),(13645,1536),(13646,1537),(13647,1537),(13648,1537),(13649,1538),(13650,1538),(13651,1538),(13652,1539),(13653,1539),(13654,1539),(13655,1540),(13656,1540),(13657,1540),(13658,1541),(13659,1541),(13660,1541),(13661,1542),(13662,1542),(13663,1542),(13664,1543),(13665,1543),(13666,1543),(13667,1544),(13668,1544),(13669,1544),(13670,1545),(13671,1545),(13672,1545),(13673,1546),(13674,1546),(13675,1546),(13676,1547),(13677,1547),(13678,1547),(13679,1548),(13680,1548),(13681,1548),(13682,1549),(13683,1549),(13684,1549),(13685,1550),(13686,1550),(13687,1550),(13688,1551),(13689,1551),(13690,1551),(13691,1552),(13692,1552),(13693,1552),(13694,1553),(13695,1553),(13696,1553),(13697,1554),(13698,1554),(13699,1554),(13700,1555),(13701,1555),(13702,1555),(13703,1556),(13704,1556),(13705,1556),(13706,1557),(13707,1557),(13708,1557),(13709,1558),(13710,1558),(13711,1558),(13712,1559),(13713,1559),(13714,1559),(13715,1560),(13716,1560),(13717,1560),(13718,1561),(13719,1561),(13720,1561),(13721,1562),(13722,1562),(13723,1562),(13724,1563),(13725,1563),(13726,1563),(13727,1564),(13728,1564),(13729,1564),(13730,1565),(13731,1565),(13732,1565),(13733,1466),(13734,1466),(13735,1466),(13736,1466),(13737,1467),(13738,1467),(13739,1467),(13740,1467),(13741,1468),(13742,1468),(13743,1468),(13744,1468),(13745,1469),(13746,1469),(13747,1469),(13748,1469),(13749,1470),(13750,1470),(13751,1470),(13752,1470),(13753,1471),(13754,1471),(13755,1471),(13756,1471),(13757,1472),(13758,1472),(13759,1472),(13760,1472),(13761,1473),(13762,1473),(13763,1473),(13764,1473),(13765,1474),(13766,1474),(13767,1474),(13768,1474),(13769,1475),(13770,1475),(13771,1475),(13772,1475),(13773,1476),(13774,1476),(13775,1476),(13776,1476),(13777,1477),(13778,1477),(13779,1477),(13780,1477),(13781,1478),(13782,1478),(13783,1478),(13784,1478),(13785,1479),(13786,1479),(13787,1479),(13788,1479),(13789,1480),(13790,1480),(13791,1480),(13792,1480),(13793,1481),(13794,1481),(13795,1481),(13796,1481),(13797,1482),(13798,1482),(13799,1482),(13800,1482),(13801,1483),(13802,1483),(13803,1483),(13804,1483),(13805,1484),(13806,1484),(13807,1484),(13808,1484),(13809,1485),(13810,1485),(13811,1485),(13812,1485),(13813,1486),(13814,1486),(13815,1486),(13816,1486),(13817,1487),(13818,1487),(13819,1487),(13820,1487),(13821,1488),(13822,1488),(13823,1488),(13824,1488),(13825,1489),(13826,1489),(13827,1489),(13828,1489),(13829,1490),(13830,1490),(13831,1490),(13832,1490),(13833,1491),(13834,1491),(13835,1491),(13836,1491),(13837,1492),(13838,1492),(13839,1492),(13840,1492),(13841,1493),(13842,1493),(13843,1493),(13844,1493),(13845,1494),(13846,1494),(13847,1494),(13848,1494),(13849,1495),(13850,1495),(13851,1495),(13852,1495),(13853,1496),(13854,1496),(13855,1496),(13856,1496),(13857,1497),(13858,1497),(13859,1497),(13860,1497),(13861,1498),(13862,1498),(13863,1498),(13864,1498),(13865,1499),(13866,1499),(13867,1499),(13868,1499),(13869,1500),(13870,1500),(13871,1500),(13872,1500),(13873,1501),(13874,1501),(13875,1501),(13876,1501),(13877,1502),(13878,1502),(13879,1502),(13880,1502),(13881,1503),(13882,1503),(13883,1503),(13884,1503),(13885,1504),(13886,1504),(13887,1504),(13888,1504),(13889,1505),(13890,1505),(13891,1505),(13892,1505),(13893,1506),(13894,1506),(13895,1506),(13896,1506),(13897,1507),(13898,1507),(13899,1507),(13900,1507),(13901,1508),(13902,1508),(13903,1508),(13904,1508),(13905,1509),(13906,1509),(13907,1509),(13908,1509),(13909,1510),(13910,1510),(13911,1510),(13912,1510),(13913,1511),(13914,1511),(13915,1511),(13916,1511),(13917,1512),(13918,1512),(13919,1512),(13920,1512),(13921,1513),(13922,1513),(13923,1513),(13924,1513),(13925,1514),(13926,1514),(13927,1514),(13928,1514),(13929,1515),(13930,1515),(13931,1515),(13932,1515),(13933,1516),(13934,1516),(13935,1516),(13936,1516),(13937,1517),(13938,1517),(13939,1517),(13940,1517),(13941,1518),(13942,1518),(13943,1518),(13944,1518),(13945,1519),(13946,1519),(13947,1519),(13948,1519),(13949,1520),(13950,1520),(13951,1520),(13952,1520),(13953,1521),(13954,1521),(13955,1521),(13956,1521),(13957,1522),(13958,1522),(13959,1522),(13960,1522),(13961,1523),(13962,1523),(13963,1523),(13964,1523),(13965,1524),(13966,1524),(13967,1524),(13968,1524),(13969,1525),(13970,1525),(13971,1525),(13972,1525),(13973,1526),(13974,1526),(13975,1526),(13976,1526),(13977,1527),(13978,1527),(13979,1527),(13980,1527),(13981,1528),(13982,1528),(13983,1528),(13984,1528),(13985,1529),(13986,1529),(13987,1529),(13988,1529),(13989,1530),(13990,1530),(13991,1530),(13992,1530),(13993,1531),(13994,1531),(13995,1531),(13996,1531),(13997,1532),(13998,1532),(13999,1532),(14000,1532),(14001,1533),(14002,1533),(14003,1533),(14004,1533),(14005,1534),(14006,1534),(14007,1534),(14008,1534),(14009,1535),(14010,1535),(14011,1535),(14012,1535),(14013,1536),(14014,1536),(14015,1536),(14016,1536),(14017,1537),(14018,1537),(14019,1537),(14020,1537),(14021,1538),(14022,1538),(14023,1538),(14024,1538),(14025,1539),(14026,1539),(14027,1539),(14028,1539),(14029,1540),(14030,1540),(14031,1540),(14032,1540),(14033,1541),(14034,1541),(14035,1541),(14036,1541),(14037,1542),(14038,1542),(14039,1542),(14040,1542),(14041,1543),(14042,1543),(14043,1543),(14044,1543),(14045,1544),(14046,1544),(14047,1544),(14048,1544),(14049,1545),(14050,1545),(14051,1545),(14052,1545),(14053,1546),(14054,1546),(14055,1546),(14056,1546),(14057,1547),(14058,1547),(14059,1547),(14060,1547),(14061,1548),(14062,1548),(14063,1548),(14064,1548),(14065,1549),(14066,1549),(14067,1549),(14068,1549),(14069,1550),(14070,1550),(14071,1550),(14072,1550),(14073,1551),(14074,1551),(14075,1551),(14076,1551),(14077,1552),(14078,1552),(14079,1552),(14080,1552),(14081,1553),(14082,1553),(14083,1553),(14084,1553),(14085,1554),(14086,1554),(14087,1554),(14088,1554),(14089,1555),(14090,1555),(14091,1555),(14092,1555),(14093,1556),(14094,1556),(14095,1556),(14096,1556),(14097,1557),(14098,1557),(14099,1557),(14100,1557),(14101,1558),(14102,1558),(14103,1558),(14104,1558),(14105,1559),(14106,1559),(14107,1559),(14108,1559),(14109,1560),(14110,1560),(14111,1560),(14112,1560),(14113,1561),(14114,1561),(14115,1561),(14116,1561),(14117,1562),(14118,1562),(14119,1562),(14120,1562),(14121,1563),(14122,1563),(14123,1563),(14124,1563),(14125,1564),(14126,1564),(14127,1564),(14128,1564),(14129,1565),(14130,1565),(14131,1565),(14132,1565),(14133,1566),(14134,1567),(14135,1568),(14136,1569),(14137,1570),(14138,1571),(14139,1572),(14140,1573),(14141,1574),(14142,1575),(14143,1576),(14144,1577),(14145,1578),(14146,1579),(14147,1580),(14148,1581),(14149,1582),(14150,1583),(14151,1584),(14152,1585),(14153,1586),(14154,1587),(14155,1588),(14156,1589),(14157,1590),(14158,1591),(14159,1592),(14160,1593),(14161,1594),(14162,1595),(14163,1596),(14164,1597),(14165,1598),(14166,1599),(14167,1600),(14168,1601),(14169,1602),(14170,1603),(14171,1604),(14172,1605),(14173,1606),(14174,1607),(14175,1608),(14176,1609),(14177,1610),(14178,1611),(14179,1612),(14180,1613),(14181,1614),(14182,1615),(14183,1616),(14184,1617),(14185,1618),(14186,1619),(14187,1620),(14188,1621),(14189,1622),(14190,1623),(14191,1624),(14192,1625),(14193,1626),(14194,1627),(14195,1628),(14196,1629),(14197,1630),(14198,1631),(14199,1632),(14200,1633),(14201,1634),(14202,1635),(14203,1636),(14204,1637),(14205,1638),(14206,1639),(14207,1640),(14208,1641),(14209,1642),(14210,1643),(14211,1644),(14212,1645),(14213,1646),(14214,1647),(14215,1648),(14216,1649),(14217,1650),(14218,1651),(14219,1652),(14220,1653),(14221,1654),(14222,1655),(14223,1656),(14224,1657),(14225,1658),(14226,1659),(14227,1660),(14228,1661),(14229,1662),(14230,1663),(14231,1664),(14232,1665),(14233,1566),(14234,1567),(14235,1568),(14236,1569),(14237,1570),(14238,1571),(14239,1572),(14240,1573),(14241,1574),(14242,1575),(14243,1576),(14244,1577),(14245,1578),(14246,1579),(14247,1580),(14248,1581),(14249,1582),(14250,1583),(14251,1584),(14252,1585),(14253,1586),(14254,1587),(14255,1588),(14256,1589),(14257,1590),(14258,1591),(14259,1592),(14260,1593),(14261,1594),(14262,1595),(14263,1596),(14264,1597),(14265,1598),(14266,1599),(14267,1600),(14268,1601),(14269,1602),(14270,1603),(14271,1604),(14272,1605),(14273,1606),(14274,1607),(14275,1608),(14276,1609),(14277,1610),(14278,1611),(14279,1612),(14280,1613),(14281,1614),(14282,1615),(14283,1616),(14284,1617),(14285,1618),(14286,1619),(14287,1620),(14288,1621),(14289,1622),(14290,1623),(14291,1624),(14292,1625),(14293,1626),(14294,1627),(14295,1628),(14296,1629),(14297,1630),(14298,1631),(14299,1632),(14300,1633),(14301,1634),(14302,1635),(14303,1636),(14304,1637),(14305,1638),(14306,1639),(14307,1640),(14308,1641),(14309,1642),(14310,1643),(14311,1644),(14312,1645),(14313,1646),(14314,1647),(14315,1648),(14316,1649),(14317,1650),(14318,1651),(14319,1652),(14320,1653),(14321,1654),(14322,1655),(14323,1656),(14324,1657),(14325,1658),(14326,1659),(14327,1660),(14328,1661),(14329,1662),(14330,1663),(14331,1664),(14332,1665),(14333,1566),(14334,1566),(14335,1566),(14336,1567),(14337,1567),(14338,1567),(14339,1568),(14340,1568),(14341,1568),(14342,1569),(14343,1569),(14344,1569),(14345,1570),(14346,1570),(14347,1570),(14348,1571),(14349,1571),(14350,1571),(14351,1572),(14352,1572),(14353,1572),(14354,1573),(14355,1573),(14356,1573),(14357,1574),(14358,1574),(14359,1574),(14360,1575),(14361,1575),(14362,1575),(14363,1576),(14364,1576),(14365,1576),(14366,1577),(14367,1577),(14368,1577),(14369,1578),(14370,1578),(14371,1578),(14372,1579),(14373,1579),(14374,1579),(14375,1580),(14376,1580),(14377,1580),(14378,1581),(14379,1581),(14380,1581),(14381,1582),(14382,1582),(14383,1582),(14384,1583),(14385,1583),(14386,1583),(14387,1584),(14388,1584),(14389,1584),(14390,1585),(14391,1585),(14392,1585),(14393,1586),(14394,1586),(14395,1586),(14396,1587),(14397,1587),(14398,1587),(14399,1588),(14400,1588),(14401,1588),(14402,1589),(14403,1589),(14404,1589),(14405,1590),(14406,1590),(14407,1590),(14408,1591),(14409,1591),(14410,1591),(14411,1592),(14412,1592),(14413,1592),(14414,1593),(14415,1593),(14416,1593),(14417,1594),(14418,1594),(14419,1594),(14420,1595),(14421,1595),(14422,1595),(14423,1596),(14424,1596),(14425,1596),(14426,1597),(14427,1597),(14428,1597),(14429,1598),(14430,1598),(14431,1598),(14432,1599),(14433,1599),(14434,1599),(14435,1600),(14436,1600),(14437,1600),(14438,1601),(14439,1601),(14440,1601),(14441,1602),(14442,1602),(14443,1602),(14444,1603),(14445,1603),(14446,1603),(14447,1604),(14448,1604),(14449,1604),(14450,1605),(14451,1605),(14452,1605),(14453,1606),(14454,1606),(14455,1606),(14456,1607),(14457,1607),(14458,1607),(14459,1608),(14460,1608),(14461,1608),(14462,1609),(14463,1609),(14464,1609),(14465,1610),(14466,1610),(14467,1610),(14468,1611),(14469,1611),(14470,1611),(14471,1612),(14472,1612),(14473,1612),(14474,1613),(14475,1613),(14476,1613),(14477,1614),(14478,1614),(14479,1614),(14480,1615),(14481,1615),(14482,1615),(14483,1616),(14484,1616),(14485,1616),(14486,1617),(14487,1617),(14488,1617),(14489,1618),(14490,1618),(14491,1618),(14492,1619),(14493,1619),(14494,1619),(14495,1620),(14496,1620),(14497,1620),(14498,1621),(14499,1621),(14500,1621),(14501,1622),(14502,1622),(14503,1622),(14504,1623),(14505,1623),(14506,1623),(14507,1624),(14508,1624),(14509,1624),(14510,1625),(14511,1625),(14512,1625),(14513,1626),(14514,1626),(14515,1626),(14516,1627),(14517,1627),(14518,1627),(14519,1628),(14520,1628),(14521,1628),(14522,1629),(14523,1629),(14524,1629),(14525,1629),(14526,1630),(14527,1630),(14528,1630),(14529,1631),(14530,1631),(14531,1631),(14532,1632),(14533,1632),(14534,1632),(14535,1633),(14536,1633),(14537,1633),(14538,1634),(14539,1634),(14540,1634),(14541,1635),(14542,1635),(14543,1635),(14544,1636),(14545,1636),(14546,1636),(14547,1637),(14548,1637),(14549,1637),(14550,1638),(14551,1638),(14552,1638),(14553,1639),(14554,1639),(14555,1639),(14556,1640),(14557,1640),(14558,1640),(14559,1640),(14560,1641),(14561,1641),(14562,1641),(14563,1641),(14564,1642),(14565,1642),(14566,1642),(14567,1642),(14568,1643),(14569,1643),(14570,1643),(14571,1644),(14572,1644),(14573,1644),(14574,1645),(14575,1645),(14576,1645),(14577,1646),(14578,1646),(14579,1646),(14580,1647),(14581,1647),(14582,1647),(14583,1648),(14584,1648),(14585,1648),(14586,1649),(14587,1649),(14588,1649),(14589,1650),(14590,1650),(14591,1650),(14592,1651),(14593,1651),(14594,1651),(14595,1652),(14596,1652),(14597,1652),(14598,1653),(14599,1653),(14600,1653),(14601,1654),(14602,1654),(14603,1654),(14604,1655),(14605,1655),(14606,1655),(14607,1656),(14608,1656),(14609,1656),(14610,1657),(14611,1657),(14612,1657),(14613,1658),(14614,1658),(14615,1658),(14616,1659),(14617,1659),(14618,1659),(14619,1660),(14620,1660),(14621,1660),(14622,1661),(14623,1661),(14624,1661),(14625,1662),(14626,1662),(14627,1662),(14628,1663),(14629,1663),(14630,1663),(14631,1664),(14632,1664),(14633,1664),(14634,1665),(14635,1665),(14636,1665),(14637,1566),(14638,1566),(14639,1566),(14640,1566),(14641,1567),(14642,1567),(14643,1567),(14644,1567),(14645,1568),(14646,1568),(14647,1568),(14648,1568),(14649,1569),(14650,1569),(14651,1569),(14652,1569),(14653,1570),(14654,1570),(14655,1570),(14656,1570),(14657,1571),(14658,1571),(14659,1571),(14660,1571),(14661,1572),(14662,1572),(14663,1572),(14664,1572),(14665,1573),(14666,1573),(14667,1573),(14668,1573),(14669,1574),(14670,1574),(14671,1574),(14672,1574),(14673,1575),(14674,1575),(14675,1575),(14676,1575),(14677,1576),(14678,1576),(14679,1576),(14680,1576),(14681,1577),(14682,1577),(14683,1577),(14684,1577),(14685,1578),(14686,1578),(14687,1578),(14688,1578),(14689,1579),(14690,1579),(14691,1579),(14692,1579),(14693,1580),(14694,1580),(14695,1580),(14696,1580),(14697,1581),(14698,1581),(14699,1581),(14700,1581),(14701,1582),(14702,1582),(14703,1582),(14704,1582),(14705,1583),(14706,1583),(14707,1583),(14708,1583),(14709,1584),(14710,1584),(14711,1584),(14712,1584),(14713,1585),(14714,1585),(14715,1585),(14716,1585),(14717,1586),(14718,1586),(14719,1586),(14720,1586),(14721,1587),(14722,1587),(14723,1587),(14724,1587),(14725,1588),(14726,1588),(14727,1588),(14728,1588),(14729,1589),(14730,1589),(14731,1589),(14732,1589),(14733,1590),(14734,1590),(14735,1590),(14736,1590),(14737,1591),(14738,1591),(14739,1591),(14740,1591),(14741,1592),(14742,1592),(14743,1592),(14744,1592),(14745,1593),(14746,1593),(14747,1593),(14748,1593),(14749,1594),(14750,1594),(14751,1594),(14752,1594),(14753,1595),(14754,1595),(14755,1595),(14756,1595),(14757,1596),(14758,1596),(14759,1596),(14760,1596),(14761,1597),(14762,1597),(14763,1597),(14764,1597),(14765,1598),(14766,1598),(14767,1598),(14768,1598),(14769,1599),(14770,1599),(14771,1599),(14772,1599),(14773,1600),(14774,1600),(14775,1600),(14776,1600),(14777,1601),(14778,1601),(14779,1601),(14780,1601),(14781,1602),(14782,1602),(14783,1602),(14784,1602),(14785,1603),(14786,1603),(14787,1603),(14788,1603),(14789,1604),(14790,1604),(14791,1604),(14792,1604),(14793,1605),(14794,1605),(14795,1605),(14796,1605),(14797,1606),(14798,1606),(14799,1606),(14800,1606),(14801,1607),(14802,1607),(14803,1607),(14804,1607),(14805,1608),(14806,1608),(14807,1608),(14808,1608),(14809,1609),(14810,1609),(14811,1609),(14812,1609),(14813,1610),(14814,1610),(14815,1610),(14816,1610),(14817,1611),(14818,1611),(14819,1611),(14820,1611),(14821,1612),(14822,1612),(14823,1612),(14824,1612),(14825,1613),(14826,1613),(14827,1613),(14828,1613),(14829,1614),(14830,1614),(14831,1614),(14832,1614),(14833,1615),(14834,1615),(14835,1615),(14836,1615),(14837,1616),(14838,1616),(14839,1616),(14840,1616),(14841,1617),(14842,1617),(14843,1617),(14844,1617),(14845,1618),(14846,1618),(14847,1618),(14848,1618),(14849,1619),(14850,1619),(14851,1619),(14852,1619),(14853,1620),(14854,1620),(14855,1620),(14856,1620),(14857,1621),(14858,1621),(14859,1621),(14860,1621),(14861,1622),(14862,1622),(14863,1622),(14864,1622),(14865,1623),(14866,1623),(14867,1623),(14868,1623),(14869,1624),(14870,1624),(14871,1624),(14872,1624),(14873,1625),(14874,1625),(14875,1625),(14876,1625),(14877,1626),(14878,1626),(14879,1626),(14880,1626),(14881,1627),(14882,1627),(14883,1627),(14884,1627),(14885,1628),(14886,1628),(14887,1628),(14888,1628),(14889,1629),(14890,1629),(14891,1629),(14892,1629),(14893,1630),(14894,1630),(14895,1630),(14896,1630),(14897,1631),(14898,1631),(14899,1631),(14900,1631),(14901,1632),(14902,1632),(14903,1632),(14904,1632),(14905,1633),(14906,1633),(14907,1633),(14908,1633),(14909,1634),(14910,1634),(14911,1634),(14912,1634),(14913,1635),(14914,1635),(14915,1635),(14916,1635),(14917,1636),(14918,1636),(14919,1636),(14920,1636),(14921,1637),(14922,1637),(14923,1637),(14924,1637),(14925,1638),(14926,1638),(14927,1638),(14928,1638),(14929,1639),(14930,1639),(14931,1639),(14932,1639),(14933,1640),(14934,1640),(14935,1640),(14936,1640),(14937,1641),(14938,1641),(14939,1641),(14940,1641),(14941,1642),(14942,1642),(14943,1642),(14944,1642),(14945,1643),(14946,1643),(14947,1643),(14948,1643),(14949,1644),(14950,1644),(14951,1644),(14952,1644),(14953,1645),(14954,1645),(14955,1645),(14956,1645),(14957,1646),(14958,1646),(14959,1646),(14960,1646),(14961,1647),(14962,1647),(14963,1647),(14964,1647),(14965,1648),(14966,1648),(14967,1648),(14968,1648),(14969,1649),(14970,1649),(14971,1649),(14972,1649),(14973,1650),(14974,1650),(14975,1650),(14976,1650),(14977,1651),(14978,1651),(14979,1651),(14980,1651),(14981,1652),(14982,1652),(14983,1652),(14984,1652),(14985,1653),(14986,1653),(14987,1653),(14988,1653),(14989,1654),(14990,1654),(14991,1654),(14992,1654),(14993,1655),(14994,1655),(14995,1655),(14996,1655),(14997,1656),(14998,1656),(14999,1656),(15000,1656),(15001,1657),(15002,1657),(15003,1657),(15004,1657),(15005,1658),(15006,1658),(15007,1658),(15008,1658),(15009,1659),(15010,1659),(15011,1659),(15012,1659),(15013,1660),(15014,1660),(15015,1660),(15016,1660),(15017,1661),(15018,1661),(15019,1661),(15020,1661),(15021,1662),(15022,1662),(15023,1662),(15024,1662),(15025,1663),(15026,1663),(15027,1663),(15028,1663),(15029,1664),(15030,1664),(15031,1664),(15032,1664),(15033,1665),(15034,1665),(15035,1665),(15036,1665),(15037,1666),(15038,1667),(15039,1668),(15040,1669),(15041,1670),(15042,1671),(15043,1672),(15044,1673),(15045,1674),(15046,1675),(15047,1676),(15048,1677),(15049,1678),(15050,1679),(15051,1680),(15052,1681),(15053,1682),(15054,1683),(15055,1684),(15056,1685),(15057,1686),(15058,1687),(15059,1688),(15060,1689),(15061,1690),(15062,1691),(15063,1692),(15064,1693),(15065,1694),(15066,1695),(15067,1696),(15068,1697),(15069,1698),(15070,1699),(15071,1700),(15072,1701),(15073,1702),(15074,1703),(15075,1704),(15076,1705),(15077,1706),(15078,1707),(15079,1708),(15080,1709),(15081,1710),(15082,1711),(15083,1712),(15084,1713),(15085,1714),(15086,1715),(15087,1716),(15088,1717),(15089,1718),(15090,1719),(15091,1720),(15092,1721),(15093,1722),(15094,1723),(15095,1724),(15096,1725),(15097,1726),(15098,1727),(15099,1728),(15100,1729),(15101,1730),(15102,1731),(15103,1732),(15104,1733),(15105,1734),(15106,1735),(15107,1736),(15108,1737),(15109,1738),(15110,1739),(15111,1740),(15112,1741),(15113,1742),(15114,1743),(15115,1744),(15116,1745),(15117,1746),(15118,1747),(15119,1748),(15120,1749),(15121,1750),(15122,1751),(15123,1752),(15124,1753),(15125,1754),(15126,1755),(15127,1756),(15128,1757),(15129,1758),(15130,1759),(15131,1760),(15132,1761),(15133,1762),(15134,1763),(15135,1764),(15136,1765),(15137,1666),(15138,1667),(15139,1668),(15140,1669),(15141,1670),(15142,1671),(15143,1672),(15144,1673),(15145,1674),(15146,1675),(15147,1676),(15148,1677),(15149,1678),(15150,1679),(15151,1680),(15152,1681),(15153,1682),(15154,1683),(15155,1684),(15156,1685),(15157,1686),(15158,1687),(15159,1688),(15160,1689),(15161,1690),(15162,1691),(15163,1692),(15164,1693),(15165,1694),(15166,1695),(15167,1696),(15168,1697),(15169,1698),(15170,1699),(15171,1700),(15172,1701),(15173,1702),(15174,1703),(15175,1704),(15176,1705),(15177,1706),(15178,1707),(15179,1708),(15180,1709),(15181,1710),(15182,1711),(15183,1712),(15184,1713),(15185,1714),(15186,1715),(15187,1716),(15188,1717),(15189,1718),(15190,1719),(15191,1720),(15192,1721),(15193,1722),(15194,1723),(15195,1724),(15196,1725),(15197,1726),(15198,1727),(15199,1728),(15200,1729),(15201,1730),(15202,1731),(15203,1732),(15204,1733),(15205,1734),(15206,1735),(15207,1736),(15208,1737),(15209,1738),(15210,1739),(15211,1740),(15212,1741),(15213,1742),(15214,1743),(15215,1744),(15216,1745),(15217,1746),(15218,1747),(15219,1748),(15220,1749),(15221,1750),(15222,1751),(15223,1752),(15224,1753),(15225,1754),(15226,1755),(15227,1756),(15228,1757),(15229,1758),(15230,1759),(15231,1760),(15232,1761),(15233,1762),(15234,1763),(15235,1764),(15236,1765),(15237,1666),(15238,1666),(15239,1666),(15240,1667),(15241,1667),(15242,1667),(15243,1668),(15244,1668),(15245,1668),(15246,1669),(15247,1669),(15248,1669),(15249,1670),(15250,1670),(15251,1670),(15252,1671),(15253,1671),(15254,1671),(15255,1672),(15256,1672),(15257,1672),(15258,1673),(15259,1673),(15260,1673),(15261,1674),(15262,1674),(15263,1674),(15264,1675),(15265,1675),(15266,1675),(15267,1676),(15268,1676),(15269,1676),(15270,1677),(15271,1677),(15272,1677),(15273,1678),(15274,1678),(15275,1678),(15276,1679),(15277,1679),(15278,1679),(15279,1680),(15280,1680),(15281,1680),(15282,1681),(15283,1681),(15284,1681),(15285,1682),(15286,1682),(15287,1682),(15288,1683),(15289,1683),(15290,1683),(15291,1684),(15292,1684),(15293,1684),(15294,1685),(15295,1685),(15296,1685),(15297,1686),(15298,1686),(15299,1686),(15300,1687),(15301,1687),(15302,1687),(15303,1688),(15304,1688),(15305,1688),(15306,1689),(15307,1689),(15308,1689),(15309,1690),(15310,1690),(15311,1690),(15312,1691),(15313,1691),(15314,1691),(15315,1692),(15316,1692),(15317,1692),(15318,1693),(15319,1693),(15320,1693),(15321,1694),(15322,1694),(15323,1694),(15324,1695),(15325,1695),(15326,1695),(15327,1696),(15328,1696),(15329,1696),(15330,1697),(15331,1697),(15332,1697),(15333,1698),(15334,1698),(15335,1698),(15336,1699),(15337,1699),(15338,1699),(15339,1700),(15340,1700),(15341,1700),(15342,1701),(15343,1701),(15344,1701),(15345,1702),(15346,1702),(15347,1702),(15348,1703),(15349,1703),(15350,1703),(15351,1704),(15352,1704),(15353,1704),(15354,1705),(15355,1705),(15356,1705),(15357,1706),(15358,1706),(15359,1706),(15360,1707),(15361,1707),(15362,1707),(15363,1708),(15364,1708),(15365,1708),(15366,1709),(15367,1709),(15368,1709),(15369,1710),(15370,1710),(15371,1710),(15372,1711),(15373,1711),(15374,1711),(15375,1711),(15376,1712),(15377,1712),(15378,1712),(15379,1713),(15380,1713),(15381,1713),(15382,1713),(15383,1714),(15384,1714),(15385,1714),(15386,1715),(15387,1715),(15388,1715),(15389,1716),(15390,1716),(15391,1716),(15392,1717),(15393,1717),(15394,1717),(15395,1718),(15396,1718),(15397,1718),(15398,1719),(15399,1719),(15400,1719),(15401,1720),(15402,1720),(15403,1720),(15404,1721),(15405,1721),(15406,1721),(15407,1722),(15408,1722),(15409,1722),(15410,1723),(15411,1723),(15412,1723),(15413,1724),(15414,1724),(15415,1724),(15416,1725),(15417,1725),(15418,1725),(15419,1726),(15420,1726),(15421,1726),(15422,1727),(15423,1727),(15424,1727),(15425,1728),(15426,1728),(15427,1728),(15428,1729),(15429,1729),(15430,1729),(15431,1730),(15432,1730),(15433,1730),(15434,1731),(15435,1731),(15436,1731),(15437,1732),(15438,1732),(15439,1732),(15440,1733),(15441,1733),(15442,1733),(15443,1734),(15444,1734),(15445,1734),(15446,1735),(15447,1735),(15448,1735),(15449,1736),(15450,1736),(15451,1736),(15452,1737),(15453,1737),(15454,1737),(15455,1738),(15456,1738),(15457,1738),(15458,1739),(15459,1739),(15460,1739),(15461,1740),(15462,1740),(15463,1740),(15464,1741),(15465,1741),(15466,1741),(15467,1742),(15468,1742),(15469,1742),(15470,1743),(15471,1743),(15472,1743),(15473,1744),(15474,1744),(15475,1744),(15476,1745),(15477,1745),(15478,1745),(15479,1746),(15480,1746),(15481,1746),(15482,1747),(15483,1747),(15484,1747),(15485,1748),(15486,1748),(15487,1748),(15488,1749),(15489,1749),(15490,1749),(15491,1750),(15492,1750),(15493,1750),(15494,1751),(15495,1751),(15496,1751),(15497,1752),(15498,1752),(15499,1752),(15500,1753),(15501,1753),(15502,1753),(15503,1754),(15504,1754),(15505,1754),(15506,1755),(15507,1755),(15508,1755),(15509,1756),(15510,1756),(15511,1756),(15512,1757),(15513,1757),(15514,1757),(15515,1758),(15516,1758),(15517,1758),(15518,1759),(15519,1759),(15520,1759),(15521,1760),(15522,1760),(15523,1760),(15524,1761),(15525,1761),(15526,1761),(15527,1762),(15528,1762),(15529,1762),(15530,1763),(15531,1763),(15532,1763),(15533,1764),(15534,1764),(15535,1764),(15536,1765),(15537,1765),(15538,1765),(15539,1666),(15540,1666),(15541,1666),(15542,1666),(15543,1667),(15544,1667),(15545,1667),(15546,1667),(15547,1668),(15548,1668),(15549,1668),(15550,1668),(15551,1669),(15552,1669),(15553,1669),(15554,1669),(15555,1670),(15556,1670),(15557,1670),(15558,1670),(15559,1671),(15560,1671),(15561,1671),(15562,1671),(15563,1672),(15564,1672),(15565,1672),(15566,1672),(15567,1673),(15568,1673),(15569,1673),(15570,1673),(15571,1674),(15572,1674),(15573,1674),(15574,1674),(15575,1675),(15576,1675),(15577,1675),(15578,1675),(15579,1676),(15580,1676),(15581,1676),(15582,1676),(15583,1677),(15584,1677),(15585,1677),(15586,1677),(15587,1678),(15588,1678),(15589,1678),(15590,1678),(15591,1679),(15592,1679),(15593,1679),(15594,1679),(15595,1680),(15596,1680),(15597,1680),(15598,1680),(15599,1681),(15600,1681),(15601,1681),(15602,1681),(15603,1682),(15604,1682),(15605,1682),(15606,1682),(15607,1683),(15608,1683),(15609,1683),(15610,1683),(15611,1684),(15612,1684),(15613,1684),(15614,1684),(15615,1685),(15616,1685),(15617,1685),(15618,1685),(15619,1686),(15620,1686),(15621,1686),(15622,1686),(15623,1687),(15624,1687),(15625,1687),(15626,1687),(15627,1688),(15628,1688),(15629,1688),(15630,1688),(15631,1689),(15632,1689),(15633,1689),(15634,1689),(15635,1690),(15636,1690),(15637,1690),(15638,1690),(15639,1691),(15640,1691),(15641,1691),(15642,1691),(15643,1692),(15644,1692),(15645,1692),(15646,1692),(15647,1693),(15648,1693),(15649,1693),(15650,1693),(15651,1694),(15652,1694),(15653,1694),(15654,1694),(15655,1695),(15656,1695),(15657,1695),(15658,1695),(15659,1696),(15660,1696),(15661,1696),(15662,1696),(15663,1697),(15664,1697),(15665,1697),(15666,1697),(15667,1698),(15668,1698),(15669,1698),(15670,1698),(15671,1699),(15672,1699),(15673,1699),(15674,1699),(15675,1700),(15676,1700),(15677,1700),(15678,1700),(15679,1701),(15680,1701),(15681,1701),(15682,1701),(15683,1702),(15684,1702),(15685,1702),(15686,1702),(15687,1703),(15688,1703),(15689,1703),(15690,1703),(15691,1704),(15692,1704),(15693,1704),(15694,1704),(15695,1705),(15696,1705),(15697,1705),(15698,1705),(15699,1706),(15700,1706),(15701,1706),(15702,1706),(15703,1707),(15704,1707),(15705,1707),(15706,1707),(15707,1708),(15708,1708),(15709,1708),(15710,1708),(15711,1709),(15712,1709),(15713,1709),(15714,1709),(15715,1710),(15716,1710),(15717,1710),(15718,1710),(15719,1711),(15720,1711),(15721,1711),(15722,1711),(15723,1712),(15724,1712),(15725,1712),(15726,1712),(15727,1713),(15728,1713),(15729,1713),(15730,1713),(15731,1714),(15732,1714),(15733,1714),(15734,1714),(15735,1715),(15736,1715),(15737,1715),(15738,1715),(15739,1716),(15740,1716),(15741,1716),(15742,1716),(15743,1717),(15744,1717),(15745,1717),(15746,1717),(15747,1718),(15748,1718),(15749,1718),(15750,1718),(15751,1719),(15752,1719),(15753,1719),(15754,1719),(15755,1720),(15756,1720),(15757,1720),(15758,1720),(15759,1721),(15760,1721),(15761,1721),(15762,1721),(15763,1722),(15764,1722),(15765,1722),(15766,1722),(15767,1723),(15768,1723),(15769,1723),(15770,1723),(15771,1724),(15772,1724),(15773,1724),(15774,1724),(15775,1725),(15776,1725),(15777,1725),(15778,1725),(15779,1726),(15780,1726),(15781,1726),(15782,1726),(15783,1727),(15784,1727),(15785,1727),(15786,1727),(15787,1728),(15788,1728),(15789,1728),(15790,1728),(15791,1729),(15792,1729),(15793,1729),(15794,1729),(15795,1730),(15796,1730),(15797,1730),(15798,1730),(15799,1731),(15800,1731),(15801,1731),(15802,1731),(15803,1732),(15804,1732),(15805,1732),(15806,1732),(15807,1733),(15808,1733),(15809,1733),(15810,1733),(15811,1734),(15812,1734),(15813,1734),(15814,1734),(15815,1735),(15816,1735),(15817,1735),(15818,1735),(15819,1736),(15820,1736),(15821,1736),(15822,1736),(15823,1737),(15824,1737),(15825,1737),(15826,1737),(15827,1738),(15828,1738),(15829,1738),(15830,1738),(15831,1739),(15832,1739),(15833,1739),(15834,1739),(15835,1740),(15836,1740),(15837,1740),(15838,1740),(15839,1741),(15840,1741),(15841,1741),(15842,1741),(15843,1742),(15844,1742),(15845,1742),(15846,1742),(15847,1743),(15848,1743),(15849,1743),(15850,1743),(15851,1744),(15852,1744),(15853,1744),(15854,1744),(15855,1745),(15856,1745),(15857,1745),(15858,1745),(15859,1746),(15860,1746),(15861,1746),(15862,1746),(15863,1747),(15864,1747),(15865,1747),(15866,1747),(15867,1748),(15868,1748),(15869,1748),(15870,1748),(15871,1749),(15872,1749),(15873,1749),(15874,1749),(15875,1750),(15876,1750),(15877,1750),(15878,1750),(15879,1751),(15880,1751),(15881,1751),(15882,1751),(15883,1752),(15884,1752),(15885,1752),(15886,1752),(15887,1753),(15888,1753),(15889,1753),(15890,1753),(15891,1754),(15892,1754),(15893,1754),(15894,1754),(15895,1755),(15896,1755),(15897,1755),(15898,1755),(15899,1756),(15900,1756),(15901,1756),(15902,1756),(15903,1757),(15904,1757),(15905,1757),(15906,1757),(15907,1758),(15908,1758),(15909,1758),(15910,1758),(15911,1759),(15912,1759),(15913,1759),(15914,1759),(15915,1760),(15916,1760),(15917,1760),(15918,1760),(15919,1761),(15920,1761),(15921,1761),(15922,1761),(15923,1762),(15924,1762),(15925,1762),(15926,1762),(15927,1763),(15928,1763),(15929,1763),(15930,1763),(15931,1764),(15932,1764),(15933,1764),(15934,1764),(15935,1765),(15936,1765),(15937,1765),(15938,1765),(15939,1766),(15940,1767),(15941,1768),(15942,1769),(15943,1770),(15944,1771),(15945,1772),(15946,1773),(15947,1774),(15948,1775),(15949,1776),(15950,1777),(15951,1778),(15952,1779),(15953,1780),(15954,1781),(15955,1782),(15956,1783),(15957,1784),(15958,1785),(15959,1786),(15960,1787),(15961,1788),(15962,1789),(15963,1790),(15964,1791),(15965,1792),(15966,1793),(15967,1794),(15968,1795),(15969,1796),(15970,1797),(15971,1798),(15972,1799),(15973,1800),(15974,1801),(15975,1802),(15976,1803),(15977,1804),(15978,1805),(15979,1806),(15980,1807),(15981,1808),(15982,1809),(15983,1810),(15984,1811),(15985,1812),(15986,1766),(15987,1767),(15988,1768),(15989,1769),(15990,1770),(15991,1771),(15992,1772),(15993,1773),(15994,1774),(15995,1775),(15996,1776),(15997,1777),(15998,1778),(15999,1779),(16000,1780),(16001,1781),(16002,1782),(16003,1783),(16004,1784),(16005,1785),(16006,1786),(16007,1787),(16008,1788),(16009,1789),(16010,1790),(16011,1791),(16012,1792),(16013,1793),(16014,1794),(16015,1795),(16016,1796),(16017,1797),(16018,1798),(16019,1799),(16020,1800),(16021,1801),(16022,1802),(16023,1803),(16024,1804),(16025,1805),(16026,1806),(16027,1807),(16028,1808),(16029,1809),(16030,1810),(16031,1811),(16032,1812),(16033,1766),(16034,1766),(16035,1766),(16036,1767),(16037,1767),(16038,1767),(16039,1768),(16040,1768),(16041,1768),(16042,1769),(16043,1769),(16044,1769),(16045,1770),(16046,1770),(16047,1770),(16048,1771),(16049,1771),(16050,1771),(16051,1772),(16052,1772),(16053,1772),(16054,1773),(16055,1773),(16056,1773),(16057,1774),(16058,1774),(16059,1774),(16060,1775),(16061,1775),(16062,1775),(16063,1776),(16064,1776),(16065,1776),(16066,1777),(16067,1777),(16068,1777),(16069,1778),(16070,1778),(16071,1778),(16072,1779),(16073,1779),(16074,1779),(16075,1780),(16076,1780),(16077,1780),(16078,1781),(16079,1781),(16080,1781),(16081,1782),(16082,1782),(16083,1782),(16084,1783),(16085,1783),(16086,1783),(16087,1784),(16088,1784),(16089,1784),(16090,1785),(16091,1785),(16092,1785),(16093,1786),(16094,1786),(16095,1786),(16096,1787),(16097,1787),(16098,1787),(16099,1788),(16100,1788),(16101,1788),(16102,1789),(16103,1789),(16104,1789),(16105,1790),(16106,1790),(16107,1790),(16108,1791),(16109,1791),(16110,1791),(16111,1792),(16112,1792),(16113,1792),(16114,1793),(16115,1793),(16116,1793),(16117,1794),(16118,1794),(16119,1794),(16120,1795),(16121,1795),(16122,1795),(16123,1796),(16124,1796),(16125,1797),(16126,1797),(16127,1798),(16128,1798),(16129,1798),(16130,1799),(16131,1799),(16132,1799),(16133,1800),(16134,1800),(16135,1800),(16136,1801),(16137,1801),(16138,1801),(16139,1802),(16140,1802),(16141,1802),(16142,1803),(16143,1803),(16144,1803),(16145,1803),(16146,1804),(16147,1804),(16148,1804),(16149,1805),(16150,1805),(16151,1805),(16152,1806),(16153,1806),(16154,1806),(16155,1807),(16156,1807),(16157,1807),(16158,1808),(16159,1808),(16160,1808),(16161,1809),(16162,1809),(16163,1809),(16164,1810),(16165,1810),(16166,1810),(16167,1811),(16168,1811),(16169,1811),(16170,1812),(16171,1812),(16172,1812),(16173,1766),(16174,1766),(16175,1766),(16176,1766),(16177,1767),(16178,1767),(16179,1767),(16180,1767),(16181,1768),(16182,1768),(16183,1768),(16184,1768),(16185,1769),(16186,1769),(16187,1769),(16188,1769),(16189,1770),(16190,1770),(16191,1770),(16192,1770),(16193,1771),(16194,1771),(16195,1771),(16196,1771),(16197,1772),(16198,1772),(16199,1772),(16200,1772),(16201,1773),(16202,1773),(16203,1773),(16204,1773),(16205,1774),(16206,1774),(16207,1774),(16208,1774),(16209,1775),(16210,1775),(16211,1775),(16212,1775),(16213,1776),(16214,1776),(16215,1776),(16216,1776),(16217,1777),(16218,1777),(16219,1777),(16220,1777),(16221,1778),(16222,1778),(16223,1778),(16224,1778),(16225,1779),(16226,1779),(16227,1779),(16228,1779),(16229,1780),(16230,1780),(16231,1780),(16232,1780),(16233,1781),(16234,1781),(16235,1781),(16236,1781),(16237,1782),(16238,1782),(16239,1782),(16240,1782),(16241,1783),(16242,1783),(16243,1783),(16244,1783),(16245,1784),(16246,1784),(16247,1784),(16248,1784),(16249,1785),(16250,1785),(16251,1785),(16252,1785),(16253,1786),(16254,1786),(16255,1786),(16256,1786),(16257,1787),(16258,1787),(16259,1787),(16260,1787),(16261,1788),(16262,1788),(16263,1788),(16264,1788),(16265,1789),(16266,1789),(16267,1789),(16268,1789),(16269,1790),(16270,1790),(16271,1790),(16272,1790),(16273,1791),(16274,1791),(16275,1791),(16276,1791),(16277,1792),(16278,1792),(16279,1792),(16280,1792),(16281,1793),(16282,1793),(16283,1793),(16284,1793),(16285,1794),(16286,1794),(16287,1794),(16288,1794),(16289,1795),(16290,1795),(16291,1795),(16292,1795),(16293,1796),(16294,1796),(16295,1796),(16296,1796),(16297,1797),(16298,1797),(16299,1797),(16300,1797),(16301,1798),(16302,1798),(16303,1798),(16304,1798),(16305,1799),(16306,1799),(16307,1799),(16308,1799),(16309,1800),(16310,1800),(16311,1800),(16312,1800),(16313,1801),(16314,1801),(16315,1801),(16316,1801),(16317,1802),(16318,1802),(16319,1802),(16320,1802),(16321,1803),(16322,1803),(16323,1803),(16324,1803),(16325,1804),(16326,1804),(16327,1804),(16328,1804),(16329,1805),(16330,1805),(16331,1805),(16332,1805),(16333,1806),(16334,1806),(16335,1806),(16336,1806),(16337,1807),(16338,1807),(16339,1807),(16340,1807),(16341,1808),(16342,1808),(16343,1808),(16344,1808),(16345,1809),(16346,1809),(16347,1809),(16348,1809),(16349,1810),(16350,1810),(16351,1810),(16352,1810),(16353,1811),(16354,1811),(16355,1811),(16356,1811),(16357,1812),(16358,1812),(16359,1812),(16360,1812),(16361,1813),(16362,1814),(16363,1815),(16364,1816),(16365,1817),(16366,1818),(16367,1819),(16368,1820),(16369,1821),(16370,1822),(16371,1823),(16372,1813),(16373,1814),(16374,1815),(16375,1816),(16376,1817),(16377,1818),(16378,1819),(16379,1820),(16380,1821),(16381,1822),(16382,1823),(16383,1813),(16384,1813),(16385,1813),(16386,1814),(16387,1814),(16388,1814),(16389,1815),(16390,1815),(16391,1815),(16392,1816),(16393,1816),(16394,1816),(16395,1817),(16396,1817),(16397,1817),(16398,1818),(16399,1818),(16400,1818),(16401,1819),(16402,1819),(16403,1819),(16404,1820),(16405,1820),(16406,1820),(16407,1821),(16408,1821),(16409,1821),(16410,1822),(16411,1822),(16412,1822),(16413,1823),(16414,1823),(16415,1823),(16416,1813),(16417,1813),(16418,1813),(16419,1813),(16420,1814),(16421,1814),(16422,1814),(16423,1814),(16424,1815),(16425,1815),(16426,1815),(16427,1815),(16428,1816),(16429,1816),(16430,1816),(16431,1816),(16432,1817),(16433,1817),(16434,1817),(16435,1817),(16436,1818),(16437,1818),(16438,1818),(16439,1818),(16440,1819),(16441,1819),(16442,1819),(16443,1819),(16444,1820),(16445,1820),(16446,1820),(16447,1820),(16448,1821),(16449,1821),(16450,1821),(16451,1821),(16452,1822),(16453,1822),(16454,1822),(16455,1822),(16456,1823),(16457,1823),(16458,1823),(16459,1823),(16460,1824),(16461,1825),(16462,1826),(16463,1827),(16464,1828),(16465,1829),(16466,1830),(16467,1831),(16468,1832),(16469,1833),(16470,1834),(16471,1835),(16472,1836),(16473,1837),(16474,1838),(16475,1839),(16476,1840),(16477,1841),(16478,1842),(16479,1843),(16480,1844),(16481,1845),(16482,1846),(16483,1847),(16484,1848),(16485,1849),(16486,1850),(16487,1851),(16488,1852),(16489,1853),(16490,1854),(16491,1855),(16492,1856),(16493,1857),(16494,1858),(16495,1859),(16496,1860),(16497,1861),(16498,1862),(16499,1863),(16500,1864),(16501,1865),(16502,1866),(16503,1867),(16504,1868),(16505,1869),(16506,1870),(16507,1871),(16508,1872),(16509,1873),(16510,1874),(16511,1875),(16512,1876),(16513,1877),(16514,1878),(16515,1879),(16516,1880),(16517,1881),(16518,1882),(16519,1883),(16520,1884),(16521,1885),(16522,1886),(16523,1887),(16524,1888),(16525,1889),(16526,1890),(16527,1891),(16528,1892),(16529,1893),(16530,1894),(16531,1895),(16532,1896),(16533,1897),(16534,1898),(16535,1899),(16536,1900),(16537,1901),(16538,1902),(16539,1903),(16540,1904),(16541,1905),(16542,1906),(16543,1907),(16544,1908),(16545,1909),(16546,1910),(16547,1911),(16548,1912),(16549,1824),(16550,1825),(16551,1826),(16552,1827),(16553,1828),(16554,1829),(16555,1830),(16556,1831),(16557,1832),(16558,1833),(16559,1834),(16560,1835),(16561,1836),(16562,1837),(16563,1838),(16564,1839),(16565,1840),(16566,1841),(16567,1842),(16568,1843),(16569,1844),(16570,1845),(16571,1846),(16572,1847),(16573,1848),(16574,1849),(16575,1850),(16576,1851),(16577,1852),(16578,1853),(16579,1854),(16580,1855),(16581,1856),(16582,1857),(16583,1858),(16584,1859),(16585,1860),(16586,1861),(16587,1862),(16588,1863),(16589,1864),(16590,1865),(16591,1866),(16592,1867),(16593,1868),(16594,1869),(16595,1870),(16596,1871),(16597,1872),(16598,1873),(16599,1874),(16600,1875),(16601,1876),(16602,1877),(16603,1878),(16604,1879),(16605,1880),(16606,1881),(16607,1882),(16608,1883),(16609,1884),(16610,1885),(16611,1886),(16612,1887),(16613,1888),(16614,1889),(16615,1890),(16616,1891),(16617,1892),(16618,1893),(16619,1894),(16620,1895),(16621,1896),(16622,1897),(16623,1898),(16624,1899),(16625,1900),(16626,1901),(16627,1902),(16628,1903),(16629,1904),(16630,1905),(16631,1906),(16632,1907),(16633,1908),(16634,1909),(16635,1910),(16636,1911),(16637,1912),(16638,1824),(16639,1824),(16640,1824),(16641,1825),(16642,1825),(16643,1825),(16644,1826),(16645,1826),(16646,1826),(16647,1827),(16648,1827),(16649,1827),(16650,1828),(16651,1828),(16652,1828),(16653,1829),(16654,1829),(16655,1829),(16656,1830),(16657,1830),(16658,1830),(16659,1831),(16660,1831),(16661,1831),(16662,1832),(16663,1832),(16664,1832),(16665,1833),(16666,1833),(16667,1833),(16668,1834),(16669,1834),(16670,1834),(16671,1835),(16672,1835),(16673,1835),(16674,1836),(16675,1836),(16676,1836),(16677,1837),(16678,1837),(16679,1837),(16680,1838),(16681,1838),(16682,1838),(16683,1839),(16684,1839),(16685,1839),(16686,1840),(16687,1840),(16688,1840),(16689,1841),(16690,1841),(16691,1841),(16692,1842),(16693,1842),(16694,1842),(16695,1843),(16696,1843),(16697,1843),(16698,1844),(16699,1844),(16700,1844),(16701,1845),(16702,1845),(16703,1845),(16704,1846),(16705,1846),(16706,1846),(16707,1847),(16708,1847),(16709,1847),(16710,1848),(16711,1848),(16712,1848),(16713,1849),(16714,1849),(16715,1849),(16716,1850),(16717,1850),(16718,1850),(16719,1851),(16720,1851),(16721,1851),(16722,1852),(16723,1852),(16724,1852),(16725,1853),(16726,1853),(16727,1853),(16728,1854),(16729,1854),(16730,1854),(16731,1855),(16732,1855),(16733,1855),(16734,1856),(16735,1856),(16736,1856),(16737,1857),(16738,1857),(16739,1857),(16740,1858),(16741,1858),(16742,1858),(16743,1859),(16744,1859),(16745,1859),(16746,1860),(16747,1860),(16748,1860),(16749,1861),(16750,1861),(16751,1861),(16752,1862),(16753,1862),(16754,1862),(16755,1863),(16756,1863),(16757,1863),(16758,1864),(16759,1864),(16760,1864),(16761,1865),(16762,1865),(16763,1865),(16764,1866),(16765,1866),(16766,1866),(16767,1867),(16768,1867),(16769,1867),(16770,1868),(16771,1868),(16772,1868),(16773,1869),(16774,1869),(16775,1869),(16776,1870),(16777,1870),(16778,1870),(16779,1871),(16780,1871),(16781,1871),(16782,1872),(16783,1872),(16784,1872),(16785,1873),(16786,1873),(16787,1873),(16788,1874),(16789,1874),(16790,1874),(16791,1875),(16792,1875),(16793,1875),(16794,1876),(16795,1876),(16796,1876),(16797,1877),(16798,1877),(16799,1877),(16800,1878),(16801,1878),(16802,1878),(16803,1879),(16804,1879),(16805,1879),(16806,1880),(16807,1880),(16808,1880),(16809,1881),(16810,1881),(16811,1881),(16812,1882),(16813,1882),(16814,1882),(16815,1883),(16816,1883),(16817,1883),(16818,1884),(16819,1884),(16820,1884),(16821,1885),(16822,1885),(16823,1885),(16824,1886),(16825,1886),(16826,1886),(16827,1887),(16828,1887),(16829,1887),(16830,1888),(16831,1888),(16832,1888),(16833,1889),(16834,1889),(16835,1889),(16836,1890),(16837,1890),(16838,1890),(16839,1891),(16840,1891),(16841,1891),(16842,1892),(16843,1892),(16844,1892),(16845,1893),(16846,1893),(16847,1893),(16848,1894),(16849,1894),(16850,1894),(16851,1895),(16852,1895),(16853,1895),(16854,1896),(16855,1896),(16856,1896),(16857,1897),(16858,1897),(16859,1897),(16860,1898),(16861,1898),(16862,1898),(16863,1899),(16864,1899),(16865,1899),(16866,1900),(16867,1900),(16868,1900),(16869,1901),(16870,1901),(16871,1901),(16872,1902),(16873,1902),(16874,1902),(16875,1903),(16876,1903),(16877,1903),(16878,1904),(16879,1904),(16880,1904),(16881,1905),(16882,1905),(16883,1905),(16884,1906),(16885,1906),(16886,1906),(16887,1907),(16888,1907),(16889,1907),(16890,1908),(16891,1908),(16892,1908),(16893,1909),(16894,1909),(16895,1909),(16896,1910),(16897,1910),(16898,1910),(16899,1911),(16900,1911),(16901,1911),(16902,1912),(16903,1912),(16904,1912),(16905,1824),(16906,1824),(16907,1824),(16908,1824),(16909,1825),(16910,1825),(16911,1825),(16912,1825),(16913,1826),(16914,1826),(16915,1826),(16916,1826),(16917,1827),(16918,1827),(16919,1827),(16920,1827),(16921,1828),(16922,1828),(16923,1828),(16924,1828),(16925,1829),(16926,1829),(16927,1829),(16928,1829),(16929,1830),(16930,1830),(16931,1830),(16932,1830),(16933,1831),(16934,1831),(16935,1831),(16936,1831),(16937,1832),(16938,1832),(16939,1832),(16940,1832),(16941,1833),(16942,1833),(16943,1833),(16944,1833),(16945,1834),(16946,1834),(16947,1834),(16948,1834),(16949,1835),(16950,1835),(16951,1835),(16952,1835),(16953,1836),(16954,1836),(16955,1836),(16956,1836),(16957,1837),(16958,1837),(16959,1837),(16960,1837),(16961,1838),(16962,1838),(16963,1838),(16964,1838),(16965,1839),(16966,1839),(16967,1839),(16968,1839),(16969,1840),(16970,1840),(16971,1840),(16972,1840),(16973,1841),(16974,1841),(16975,1841),(16976,1841),(16977,1842),(16978,1842),(16979,1842),(16980,1842),(16981,1843),(16982,1843),(16983,1843),(16984,1843),(16985,1844),(16986,1844),(16987,1844),(16988,1844),(16989,1845),(16990,1845),(16991,1845),(16992,1845),(16993,1846),(16994,1846),(16995,1846),(16996,1846),(16997,1847),(16998,1847),(16999,1847),(17000,1847),(17001,1848),(17002,1848),(17003,1848),(17004,1848),(17005,1849),(17006,1849),(17007,1849),(17008,1849),(17009,1850),(17010,1850),(17011,1850),(17012,1850),(17013,1851),(17014,1851),(17015,1851),(17016,1851),(17017,1852),(17018,1852),(17019,1852),(17020,1852),(17021,1853),(17022,1853),(17023,1853),(17024,1853),(17025,1854),(17026,1854),(17027,1854),(17028,1854),(17029,1855),(17030,1855),(17031,1855),(17032,1855),(17033,1856),(17034,1856),(17035,1856),(17036,1856),(17037,1857),(17038,1857),(17039,1857),(17040,1857),(17041,1858),(17042,1858),(17043,1858),(17044,1858),(17045,1859),(17046,1859),(17047,1859),(17048,1859),(17049,1860),(17050,1860),(17051,1860),(17052,1860),(17053,1861),(17054,1861),(17055,1861),(17056,1861),(17057,1862),(17058,1862),(17059,1862),(17060,1862),(17061,1863),(17062,1863),(17063,1863),(17064,1863),(17065,1864),(17066,1864),(17067,1864),(17068,1864),(17069,1865),(17070,1865),(17071,1865),(17072,1865),(17073,1866),(17074,1866),(17075,1866),(17076,1866),(17077,1867),(17078,1867),(17079,1867),(17080,1867),(17081,1868),(17082,1868),(17083,1868),(17084,1868),(17085,1869),(17086,1869),(17087,1869),(17088,1869),(17089,1870),(17090,1870),(17091,1870),(17092,1870),(17093,1871),(17094,1871),(17095,1871),(17096,1871),(17097,1872),(17098,1872),(17099,1872),(17100,1872),(17101,1873),(17102,1873),(17103,1873),(17104,1873),(17105,1874),(17106,1874),(17107,1874),(17108,1874),(17109,1875),(17110,1875),(17111,1875),(17112,1875),(17113,1876),(17114,1876),(17115,1876),(17116,1876),(17117,1877),(17118,1877),(17119,1877),(17120,1877),(17121,1878),(17122,1878),(17123,1878),(17124,1878),(17125,1879),(17126,1879),(17127,1879),(17128,1879),(17129,1880),(17130,1880),(17131,1880),(17132,1880),(17133,1881),(17134,1881),(17135,1881),(17136,1881),(17137,1882),(17138,1882),(17139,1882),(17140,1882),(17141,1883),(17142,1883),(17143,1883),(17144,1883),(17145,1884),(17146,1884),(17147,1884),(17148,1884),(17149,1885),(17150,1885),(17151,1885),(17152,1885),(17153,1886),(17154,1886),(17155,1886),(17156,1886),(17157,1887),(17158,1887),(17159,1887),(17160,1887),(17161,1888),(17162,1888),(17163,1888),(17164,1888),(17165,1889),(17166,1889),(17167,1889),(17168,1889),(17169,1890),(17170,1890),(17171,1890),(17172,1890),(17173,1891),(17174,1891),(17175,1891),(17176,1891),(17177,1892),(17178,1892),(17179,1892),(17180,1892),(17181,1893),(17182,1893),(17183,1893),(17184,1893),(17185,1894),(17186,1894),(17187,1894),(17188,1894),(17189,1895),(17190,1895),(17191,1895),(17192,1895),(17193,1896),(17194,1896),(17195,1896),(17196,1896),(17197,1897),(17198,1897),(17199,1897),(17200,1897),(17201,1898),(17202,1898),(17203,1898),(17204,1898),(17205,1899),(17206,1899),(17207,1899),(17208,1899),(17209,1900),(17210,1900),(17211,1900),(17212,1900),(17213,1901),(17214,1901),(17215,1901),(17216,1901),(17217,1902),(17218,1902),(17219,1902),(17220,1902),(17221,1903),(17222,1903),(17223,1903),(17224,1903),(17225,1904),(17226,1904),(17227,1904),(17228,1904),(17229,1905),(17230,1905),(17231,1905),(17232,1905),(17233,1906),(17234,1906),(17235,1906),(17236,1906),(17237,1907),(17238,1907),(17239,1907),(17240,1907),(17241,1908),(17242,1908),(17243,1908),(17244,1908),(17245,1909),(17246,1909),(17247,1909),(17248,1909),(17249,1910),(17250,1910),(17251,1910),(17252,1910),(17253,1911),(17254,1911),(17255,1911),(17256,1911),(17257,1912),(17258,1912),(17259,1912),(17260,1912),(17261,1913),(17262,1914),(17263,1915),(17264,1916),(17265,1917),(17266,1918),(17267,1919),(17268,1920),(17269,1921),(17270,1922),(17271,1923),(17272,1924),(17273,1925),(17274,1926),(17275,1927),(17276,1928),(17277,1929),(17278,1930),(17279,1931),(17280,1932),(17281,1933),(17282,1934),(17283,1935),(17284,1936),(17285,1937),(17286,1938),(17287,1939),(17288,1940),(17289,1941),(17290,1942),(17291,1943),(17292,1944),(17293,1945),(17294,1946),(17295,1947),(17296,1948),(17297,1949),(17298,1950),(17299,1951),(17300,1952),(17301,1953),(17302,1954),(17303,1955),(17304,1956),(17305,1957),(17306,1958),(17307,1959),(17308,1960),(17309,1961),(17310,1962),(17311,1963),(17312,1964),(17313,1965),(17314,1966),(17315,1967),(17316,1968),(17317,1969),(17318,1970),(17319,1971),(17320,1972),(17321,1973),(17322,1974),(17323,1975),(17324,1976),(17325,1977),(17326,1978),(17327,1979),(17328,1980),(17329,1981),(17330,1982),(17331,1983),(17332,1984),(17333,1985),(17334,1986),(17335,1987),(17336,1988),(17337,1989),(17338,1990),(17339,1991),(17340,1992),(17341,1993),(17342,1994),(17343,1995),(17344,1996),(17345,1997),(17346,1998),(17347,1999),(17348,2000),(17349,2001),(17350,2002),(17351,2003),(17352,2004),(17353,2005),(17354,2006),(17355,2007),(17356,2008),(17357,2009),(17358,2010),(17359,2011),(17360,2012),(17361,1913),(17362,1914),(17363,1915),(17364,1916),(17365,1917),(17366,1918),(17367,1919),(17368,1920),(17369,1921),(17370,1922),(17371,1923),(17372,1924),(17373,1925),(17374,1926),(17375,1927),(17376,1928),(17377,1929),(17378,1930),(17379,1931),(17380,1932),(17381,1933),(17382,1934),(17383,1935),(17384,1936),(17385,1937),(17386,1938),(17387,1939),(17388,1940),(17389,1941),(17390,1942),(17391,1943),(17392,1944),(17393,1945),(17394,1946),(17395,1947),(17396,1948),(17397,1949),(17398,1950),(17399,1951),(17400,1952),(17401,1953),(17402,1954),(17403,1955),(17404,1956),(17405,1957),(17406,1958),(17407,1959),(17408,1960),(17409,1961),(17410,1962),(17411,1963),(17412,1964),(17413,1965),(17414,1966),(17415,1967),(17416,1968),(17417,1969),(17418,1970),(17419,1971),(17420,1972),(17421,1973),(17422,1974),(17423,1975),(17424,1976),(17425,1977),(17426,1978),(17427,1979),(17428,1980),(17429,1981),(17430,1982),(17431,1983),(17432,1984),(17433,1985),(17434,1986),(17435,1987),(17436,1988),(17437,1989),(17438,1990),(17439,1991),(17440,1992),(17441,1993),(17442,1994),(17443,1995),(17444,1996),(17445,1997),(17446,1998),(17447,1999),(17448,2000),(17449,2001),(17450,2002),(17451,2003),(17452,2004),(17453,2005),(17454,2006),(17455,2007),(17456,2008),(17457,2009),(17458,2010),(17459,2011),(17460,2012),(17461,1913),(17462,1913),(17463,1913),(17464,1914),(17465,1914),(17466,1914),(17467,1915),(17468,1915),(17469,1915),(17470,1916),(17471,1916),(17472,1916),(17473,1917),(17474,1917),(17475,1917),(17476,1918),(17477,1918),(17478,1918),(17479,1919),(17480,1919),(17481,1919),(17482,1920),(17483,1920),(17484,1920),(17485,1921),(17486,1921),(17487,1921),(17488,1922),(17489,1922),(17490,1922),(17491,1923),(17492,1923),(17493,1923),(17494,1924),(17495,1924),(17496,1924),(17497,1925),(17498,1925),(17499,1925),(17500,1926),(17501,1926),(17502,1926),(17503,1927),(17504,1927),(17505,1927),(17506,1928),(17507,1928),(17508,1928),(17509,1929),(17510,1929),(17511,1929),(17512,1930),(17513,1930),(17514,1930),(17515,1931),(17516,1931),(17517,1931),(17518,1932),(17519,1932),(17520,1932),(17521,1933),(17522,1933),(17523,1933),(17524,1934),(17525,1934),(17526,1934),(17527,1935),(17528,1935),(17529,1935),(17530,1936),(17531,1936),(17532,1936),(17533,1937),(17534,1937),(17535,1937),(17536,1938),(17537,1938),(17538,1938),(17539,1939),(17540,1939),(17541,1939),(17542,1940),(17543,1940),(17544,1940),(17545,1941),(17546,1941),(17547,1941),(17548,1942),(17549,1942),(17550,1942),(17551,1943),(17552,1943),(17553,1943),(17554,1944),(17555,1944),(17556,1944),(17557,1945),(17558,1945),(17559,1945),(17560,1946),(17561,1946),(17562,1946),(17563,1947),(17564,1947),(17565,1947),(17566,1948),(17567,1948),(17568,1948),(17569,1949),(17570,1949),(17571,1949),(17572,1950),(17573,1950),(17574,1950),(17575,1951),(17576,1951),(17577,1951),(17578,1952),(17579,1952),(17580,1952),(17581,1953),(17582,1953),(17583,1953),(17584,1954),(17585,1954),(17586,1954),(17587,1955),(17588,1955),(17589,1955),(17590,1956),(17591,1956),(17592,1956),(17593,1957),(17594,1957),(17595,1957),(17596,1958),(17597,1958),(17598,1958),(17599,1959),(17600,1959),(17601,1959),(17602,1960),(17603,1960),(17604,1960),(17605,1961),(17606,1961),(17607,1961),(17608,1962),(17609,1962),(17610,1962),(17611,1963),(17612,1963),(17613,1963),(17614,1964),(17615,1964),(17616,1964),(17617,1965),(17618,1965),(17619,1965),(17620,1966),(17621,1966),(17622,1966),(17623,1967),(17624,1967),(17625,1967),(17626,1968),(17627,1968),(17628,1968),(17629,1969),(17630,1969),(17631,1969),(17632,1970),(17633,1970),(17634,1970),(17635,1971),(17636,1971),(17637,1971),(17638,1972),(17639,1972),(17640,1972),(17641,1973),(17642,1973),(17643,1973),(17644,1974),(17645,1974),(17646,1974),(17647,1975),(17648,1975),(17649,1975),(17650,1976),(17651,1976),(17652,1976),(17653,1977),(17654,1977),(17655,1977),(17656,1978),(17657,1978),(17658,1978),(17659,1979),(17660,1979),(17661,1979),(17662,1980),(17663,1980),(17664,1980),(17665,1981),(17666,1981),(17667,1981),(17668,1982),(17669,1982),(17670,1982),(17671,1983),(17672,1983),(17673,1983),(17674,1984),(17675,1984),(17676,1984),(17677,1985),(17678,1985),(17679,1985),(17680,1986),(17681,1986),(17682,1986),(17683,1987),(17684,1987),(17685,1987),(17686,1988),(17687,1988),(17688,1988),(17689,1989),(17690,1989),(17691,1989),(17692,1990),(17693,1990),(17694,1990),(17695,1991),(17696,1991),(17697,1991),(17698,1992),(17699,1992),(17700,1992),(17701,1993),(17702,1993),(17703,1993),(17704,1994),(17705,1994),(17706,1994),(17707,1995),(17708,1995),(17709,1995),(17710,1996),(17711,1996),(17712,1996),(17713,1997),(17714,1997),(17715,1997),(17716,1998),(17717,1998),(17718,1998),(17719,1999),(17720,1999),(17721,1999),(17722,2000),(17723,2000),(17724,2000),(17725,2001),(17726,2001),(17727,2001),(17728,2002),(17729,2002),(17730,2002),(17731,2003),(17732,2003),(17733,2003),(17734,2004),(17735,2004),(17736,2004),(17737,2005),(17738,2005),(17739,2005),(17740,2006),(17741,2006),(17742,2006),(17743,2007),(17744,2007),(17745,2007),(17746,2008),(17747,2008),(17748,2008),(17749,2009),(17750,2009),(17751,2009),(17752,2010),(17753,2010),(17754,2010),(17755,2011),(17756,2011),(17757,2011),(17758,2012),(17759,2012),(17760,2012),(17761,1913),(17762,1913),(17763,1913),(17764,1913),(17765,1914),(17766,1914),(17767,1914),(17768,1914),(17769,1915),(17770,1915),(17771,1915),(17772,1915),(17773,1916),(17774,1916),(17775,1916),(17776,1916),(17777,1917),(17778,1917),(17779,1917),(17780,1917),(17781,1918),(17782,1918),(17783,1918),(17784,1918),(17785,1919),(17786,1919),(17787,1919),(17788,1919),(17789,1920),(17790,1920),(17791,1920),(17792,1920),(17793,1921),(17794,1921),(17795,1921),(17796,1921),(17797,1922),(17798,1922),(17799,1922),(17800,1922),(17801,1923),(17802,1923),(17803,1923),(17804,1923),(17805,1924),(17806,1924),(17807,1924),(17808,1924),(17809,1925),(17810,1925),(17811,1925),(17812,1925),(17813,1926),(17814,1926),(17815,1926),(17816,1926),(17817,1927),(17818,1927),(17819,1927),(17820,1927),(17821,1928),(17822,1928),(17823,1928),(17824,1928),(17825,1929),(17826,1929),(17827,1929),(17828,1929),(17829,1930),(17830,1930),(17831,1930),(17832,1930),(17833,1931),(17834,1931),(17835,1931),(17836,1931),(17837,1932),(17838,1932),(17839,1932),(17840,1932),(17841,1933),(17842,1933),(17843,1933),(17844,1933),(17845,1934),(17846,1934),(17847,1934),(17848,1934),(17849,1935),(17850,1935),(17851,1935),(17852,1935),(17853,1936),(17854,1936),(17855,1936),(17856,1936),(17857,1937),(17858,1937),(17859,1937),(17860,1937),(17861,1938),(17862,1938),(17863,1938),(17864,1938),(17865,1939),(17866,1939),(17867,1939),(17868,1939),(17869,1940),(17870,1940),(17871,1940),(17872,1940),(17873,1941),(17874,1941),(17875,1941),(17876,1941),(17877,1942),(17878,1942),(17879,1942),(17880,1942),(17881,1943),(17882,1943),(17883,1943),(17884,1943),(17885,1944),(17886,1944),(17887,1944),(17888,1944),(17889,1945),(17890,1945),(17891,1945),(17892,1945),(17893,1946),(17894,1946),(17895,1946),(17896,1946),(17897,1947),(17898,1947),(17899,1947),(17900,1947),(17901,1948),(17902,1948),(17903,1948),(17904,1948),(17905,1949),(17906,1949),(17907,1949),(17908,1949),(17909,1950),(17910,1950),(17911,1950),(17912,1950),(17913,1951),(17914,1951),(17915,1951),(17916,1951),(17917,1952),(17918,1952),(17919,1952),(17920,1952),(17921,1953),(17922,1953),(17923,1953),(17924,1953),(17925,1954),(17926,1954),(17927,1954),(17928,1954),(17929,1955),(17930,1955),(17931,1955),(17932,1955),(17933,1956),(17934,1956),(17935,1956),(17936,1956),(17937,1957),(17938,1957),(17939,1957),(17940,1957),(17941,1958),(17942,1958),(17943,1958),(17944,1958),(17945,1959),(17946,1959),(17947,1959),(17948,1959),(17949,1960),(17950,1960),(17951,1960),(17952,1960),(17953,1961),(17954,1961),(17955,1961),(17956,1961),(17957,1962),(17958,1962),(17959,1962),(17960,1962),(17961,1963),(17962,1963),(17963,1963),(17964,1963),(17965,1964),(17966,1964),(17967,1964),(17968,1964),(17969,1965),(17970,1965),(17971,1965),(17972,1965),(17973,1966),(17974,1966),(17975,1966),(17976,1966),(17977,1967),(17978,1967),(17979,1967),(17980,1967),(17981,1968),(17982,1968),(17983,1968),(17984,1968),(17985,1969),(17986,1969),(17987,1969),(17988,1969),(17989,1970),(17990,1970),(17991,1970),(17992,1970),(17993,1971),(17994,1971),(17995,1971),(17996,1971),(17997,1972),(17998,1972),(17999,1972),(18000,1972),(18001,1973),(18002,1973),(18003,1973),(18004,1973),(18005,1974),(18006,1974),(18007,1974),(18008,1974),(18009,1975),(18010,1975),(18011,1975),(18012,1975),(18013,1976),(18014,1976),(18015,1976),(18016,1976),(18017,1977),(18018,1977),(18019,1977),(18020,1977),(18021,1978),(18022,1978),(18023,1978),(18024,1978),(18025,1979),(18026,1979),(18027,1979),(18028,1979),(18029,1980),(18030,1980),(18031,1980),(18032,1980),(18033,1981),(18034,1981),(18035,1981),(18036,1981),(18037,1982),(18038,1982),(18039,1982),(18040,1982),(18041,1983),(18042,1983),(18043,1983),(18044,1983),(18045,1984),(18046,1984),(18047,1984),(18048,1984),(18049,1985),(18050,1985),(18051,1985),(18052,1985),(18053,1986),(18054,1986),(18055,1986),(18056,1986),(18057,1987),(18058,1987),(18059,1987),(18060,1987),(18061,1988),(18062,1988),(18063,1988),(18064,1988),(18065,1989),(18066,1989),(18067,1989),(18068,1989),(18069,1990),(18070,1990),(18071,1990),(18072,1990),(18073,1991),(18074,1991),(18075,1991),(18076,1991),(18077,1992),(18078,1992),(18079,1992),(18080,1992),(18081,1993),(18082,1993),(18083,1993),(18084,1993),(18085,1994),(18086,1994),(18087,1994),(18088,1994),(18089,1995),(18090,1995),(18091,1995),(18092,1995),(18093,1996),(18094,1996),(18095,1996),(18096,1996),(18097,1997),(18098,1997),(18099,1997),(18100,1997),(18101,1998),(18102,1998),(18103,1998),(18104,1998),(18105,1999),(18106,1999),(18107,1999),(18108,1999),(18109,2000),(18110,2000),(18111,2000),(18112,2000),(18113,2001),(18114,2001),(18115,2001),(18116,2001),(18117,2002),(18118,2002),(18119,2002),(18120,2002),(18121,2003),(18122,2003),(18123,2003),(18124,2003),(18125,2004),(18126,2004),(18127,2004),(18128,2004),(18129,2005),(18130,2005),(18131,2005),(18132,2005),(18133,2006),(18134,2006),(18135,2006),(18136,2006),(18137,2007),(18138,2007),(18139,2007),(18140,2007),(18141,2008),(18142,2008),(18143,2008),(18144,2008),(18145,2009),(18146,2009),(18147,2009),(18148,2009),(18149,2010),(18150,2010),(18151,2010),(18152,2010),(18153,2011),(18154,2011),(18155,2011),(18156,2011),(18157,2012),(18158,2012),(18159,2012),(18160,2012),(18161,2013),(18162,2014),(18163,2015),(18164,2016),(18165,2017),(18166,2018),(18167,2019),(18168,2020),(18169,2021),(18170,2022),(18171,2023),(18172,2024),(18173,2025),(18174,2026),(18175,2027),(18176,2028),(18177,2029),(18178,2030),(18179,2031),(18180,2032),(18181,2033),(18182,2034),(18183,2035),(18184,2036),(18185,2037),(18186,2038),(18187,2039),(18188,2040),(18189,2041),(18190,2042),(18191,2043),(18192,2044),(18193,2045),(18194,2046),(18195,2047),(18196,2048),(18197,2049),(18198,2050),(18199,2051),(18200,2052),(18201,2053),(18202,2054),(18203,2055),(18204,2056),(18205,2057),(18206,2058),(18207,2059),(18208,2060),(18209,2061),(18210,2062),(18211,2063),(18212,2064),(18213,2065),(18214,2066),(18215,2067),(18216,2068),(18217,2069),(18218,2070),(18219,2071),(18220,2072),(18221,2073),(18222,2074),(18223,2075),(18224,2076),(18225,2077),(18226,2078),(18227,2079),(18228,2080),(18229,2081),(18230,2082),(18231,2083),(18232,2084),(18233,2085),(18234,2086),(18235,2087),(18236,2088),(18237,2089),(18238,2090),(18239,2091),(18240,2092),(18241,2093),(18242,2094),(18243,2095),(18244,2096),(18245,2097),(18246,2098),(18247,2099),(18248,2100),(18249,2101),(18250,2102),(18251,2103),(18252,2104),(18253,2105),(18254,2106),(18255,2107),(18256,2108),(18257,2109),(18258,2110),(18259,2111),(18260,2112),(18261,2013),(18262,2014),(18263,2015),(18264,2016),(18265,2017),(18266,2018),(18267,2019),(18268,2020),(18269,2021),(18270,2022),(18271,2023),(18272,2024),(18273,2025),(18274,2026),(18275,2027),(18276,2028),(18277,2029),(18278,2030),(18279,2031),(18280,2032),(18281,2033),(18282,2034),(18283,2035),(18284,2036),(18285,2037),(18286,2038),(18287,2039),(18288,2040),(18289,2041),(18290,2042),(18291,2043),(18292,2044),(18293,2045),(18294,2046),(18295,2047),(18296,2048),(18297,2049),(18298,2050),(18299,2051),(18300,2052),(18301,2053),(18302,2054),(18303,2055),(18304,2056),(18305,2057),(18306,2058),(18307,2059),(18308,2060),(18309,2061),(18310,2062),(18311,2063),(18312,2064),(18313,2065),(18314,2066),(18315,2067),(18316,2068),(18317,2069),(18318,2070),(18319,2071),(18320,2072),(18321,2073),(18322,2074),(18323,2075),(18324,2076),(18325,2077),(18326,2078),(18327,2079),(18328,2080),(18329,2081),(18330,2082),(18331,2083),(18332,2084),(18333,2085),(18334,2086),(18335,2087),(18336,2088),(18337,2089),(18338,2090),(18339,2091),(18340,2092),(18341,2093),(18342,2094),(18343,2095),(18344,2096),(18345,2097),(18346,2098),(18347,2099),(18348,2100),(18349,2101),(18350,2102),(18351,2103),(18352,2104),(18353,2105),(18354,2106),(18355,2107),(18356,2108),(18357,2109),(18358,2110),(18359,2111),(18360,2112),(18361,2013),(18362,2013),(18363,2013),(18364,2014),(18365,2014),(18366,2014),(18367,2015),(18368,2015),(18369,2015),(18370,2016),(18371,2016),(18372,2016),(18373,2017),(18374,2017),(18375,2017),(18376,2018),(18377,2018),(18378,2018),(18379,2019),(18380,2019),(18381,2019),(18382,2020),(18383,2020),(18384,2020),(18385,2021),(18386,2021),(18387,2021),(18388,2022),(18389,2022),(18390,2022),(18391,2023),(18392,2023),(18393,2023),(18394,2024),(18395,2024),(18396,2024),(18397,2025),(18398,2025),(18399,2025),(18400,2026),(18401,2026),(18402,2026),(18403,2027),(18404,2027),(18405,2027),(18406,2028),(18407,2028),(18408,2028),(18409,2029),(18410,2029),(18411,2029),(18412,2030),(18413,2030),(18414,2030),(18415,2031),(18416,2031),(18417,2031),(18418,2032),(18419,2032),(18420,2032),(18421,2033),(18422,2033),(18423,2033),(18424,2034),(18425,2034),(18426,2034),(18427,2035),(18428,2035),(18429,2035),(18430,2036),(18431,2036),(18432,2036),(18433,2037),(18434,2037),(18435,2037),(18436,2038),(18437,2038),(18438,2038),(18439,2039),(18440,2039),(18441,2039),(18442,2040),(18443,2040),(18444,2040),(18445,2041),(18446,2041),(18447,2041),(18448,2042),(18449,2042),(18450,2042),(18451,2043),(18452,2043),(18453,2043),(18454,2044),(18455,2044),(18456,2044),(18457,2045),(18458,2045),(18459,2045),(18460,2046),(18461,2046),(18462,2046),(18463,2047),(18464,2047),(18465,2047),(18466,2048),(18467,2048),(18468,2048),(18469,2049),(18470,2049),(18471,2049),(18472,2050),(18473,2050),(18474,2050),(18475,2051),(18476,2051),(18477,2051),(18478,2052),(18479,2052),(18480,2052),(18481,2053),(18482,2053),(18483,2053),(18484,2054),(18485,2054),(18486,2054),(18487,2055),(18488,2055),(18489,2055),(18490,2056),(18491,2056),(18492,2056),(18493,2057),(18494,2057),(18495,2057),(18496,2058),(18497,2058),(18498,2058),(18499,2059),(18500,2059),(18501,2059),(18502,2060),(18503,2060),(18504,2060),(18505,2061),(18506,2061),(18507,2061),(18508,2062),(18509,2062),(18510,2062),(18511,2063),(18512,2063),(18513,2063),(18514,2064),(18515,2064),(18516,2064),(18517,2065),(18518,2065),(18519,2065),(18520,2066),(18521,2066),(18522,2066),(18523,2067),(18524,2067),(18525,2067),(18526,2068),(18527,2068),(18528,2068),(18529,2069),(18530,2069),(18531,2069),(18532,2070),(18533,2070),(18534,2070),(18535,2071),(18536,2071),(18537,2071),(18538,2072),(18539,2072),(18540,2072),(18541,2073),(18542,2073),(18543,2073),(18544,2074),(18545,2074),(18546,2074),(18547,2075),(18548,2075),(18549,2075),(18550,2076),(18551,2076),(18552,2076),(18553,2077),(18554,2077),(18555,2077),(18556,2078),(18557,2078),(18558,2078),(18559,2079),(18560,2079),(18561,2079),(18562,2080),(18563,2080),(18564,2080),(18565,2081),(18566,2081),(18567,2081),(18568,2082),(18569,2082),(18570,2082),(18571,2083),(18572,2083),(18573,2083),(18574,2084),(18575,2084),(18576,2084),(18577,2085),(18578,2085),(18579,2085),(18580,2086),(18581,2086),(18582,2086),(18583,2087),(18584,2087),(18585,2087),(18586,2088),(18587,2088),(18588,2088),(18589,2089),(18590,2089),(18591,2089),(18592,2090),(18593,2090),(18594,2090),(18595,2091),(18596,2091),(18597,2091),(18598,2092),(18599,2092),(18600,2092),(18601,2093),(18602,2093),(18603,2093),(18604,2094),(18605,2094),(18606,2094),(18607,2095),(18608,2095),(18609,2095),(18610,2096),(18611,2096),(18612,2096),(18613,2097),(18614,2097),(18615,2097),(18616,2098),(18617,2098),(18618,2098),(18619,2099),(18620,2099),(18621,2099),(18622,2100),(18623,2100),(18624,2100),(18625,2101),(18626,2101),(18627,2101),(18628,2102),(18629,2102),(18630,2102),(18631,2103),(18632,2103),(18633,2103),(18634,2104),(18635,2104),(18636,2104),(18637,2105),(18638,2105),(18639,2105),(18640,2106),(18641,2106),(18642,2106),(18643,2107),(18644,2107),(18645,2107),(18646,2108),(18647,2108),(18648,2108),(18649,2109),(18650,2109),(18651,2109),(18652,2110),(18653,2110),(18654,2110),(18655,2111),(18656,2111),(18657,2111),(18658,2112),(18659,2112),(18660,2112),(18661,2013),(18662,2013),(18663,2013),(18664,2013),(18665,2014),(18666,2014),(18667,2014),(18668,2014),(18669,2015),(18670,2015),(18671,2015),(18672,2015),(18673,2016),(18674,2016),(18675,2016),(18676,2016),(18677,2017),(18678,2017),(18679,2017),(18680,2017),(18681,2018),(18682,2018),(18683,2018),(18684,2018),(18685,2019),(18686,2019),(18687,2019),(18688,2019),(18689,2020),(18690,2020),(18691,2020),(18692,2020),(18693,2021),(18694,2021),(18695,2021),(18696,2021),(18697,2022),(18698,2022),(18699,2022),(18700,2022),(18701,2023),(18702,2023),(18703,2023),(18704,2023),(18705,2024),(18706,2024),(18707,2024),(18708,2024),(18709,2025),(18710,2025),(18711,2025),(18712,2025),(18713,2026),(18714,2026),(18715,2026),(18716,2026),(18717,2027),(18718,2027),(18719,2027),(18720,2027),(18721,2028),(18722,2028),(18723,2028),(18724,2028),(18725,2029),(18726,2029),(18727,2029),(18728,2029),(18729,2030),(18730,2030),(18731,2030),(18732,2030),(18733,2031),(18734,2031),(18735,2031),(18736,2031),(18737,2032),(18738,2032),(18739,2032),(18740,2032),(18741,2033),(18742,2033),(18743,2033),(18744,2033),(18745,2034),(18746,2034),(18747,2034),(18748,2034),(18749,2035),(18750,2035),(18751,2035),(18752,2035),(18753,2036),(18754,2036),(18755,2036),(18756,2036),(18757,2037),(18758,2037),(18759,2037),(18760,2037),(18761,2038),(18762,2038),(18763,2038),(18764,2038),(18765,2039),(18766,2039),(18767,2039),(18768,2039),(18769,2040),(18770,2040),(18771,2040),(18772,2040),(18773,2041),(18774,2041),(18775,2041),(18776,2041),(18777,2042),(18778,2042),(18779,2042),(18780,2042),(18781,2043),(18782,2043),(18783,2043),(18784,2043),(18785,2044),(18786,2044),(18787,2044),(18788,2044),(18789,2045),(18790,2045),(18791,2045),(18792,2045),(18793,2046),(18794,2046),(18795,2046),(18796,2046),(18797,2047),(18798,2047),(18799,2047),(18800,2047),(18801,2048),(18802,2048),(18803,2048),(18804,2048),(18805,2049),(18806,2049),(18807,2049),(18808,2049),(18809,2050),(18810,2050),(18811,2050),(18812,2050),(18813,2051),(18814,2051),(18815,2051),(18816,2051),(18817,2052),(18818,2052),(18819,2052),(18820,2052),(18821,2053),(18822,2053),(18823,2053),(18824,2053),(18825,2054),(18826,2054),(18827,2054),(18828,2054),(18829,2055),(18830,2055),(18831,2055),(18832,2055),(18833,2056),(18834,2056),(18835,2056),(18836,2056),(18837,2057),(18838,2057),(18839,2057),(18840,2057),(18841,2058),(18842,2058),(18843,2058),(18844,2058),(18845,2059),(18846,2059),(18847,2059),(18848,2059),(18849,2060),(18850,2060),(18851,2060),(18852,2060),(18853,2061),(18854,2061),(18855,2061),(18856,2061),(18857,2062),(18858,2062),(18859,2062),(18860,2062),(18861,2063),(18862,2063),(18863,2063),(18864,2063),(18865,2064),(18866,2064),(18867,2064),(18868,2064),(18869,2065),(18870,2065),(18871,2065),(18872,2065),(18873,2066),(18874,2066),(18875,2066),(18876,2066),(18877,2067),(18878,2067),(18879,2067),(18880,2067),(18881,2068),(18882,2068),(18883,2068),(18884,2068),(18885,2069),(18886,2069),(18887,2069),(18888,2069),(18889,2070),(18890,2070),(18891,2070),(18892,2070),(18893,2071),(18894,2071),(18895,2071),(18896,2071),(18897,2072),(18898,2072),(18899,2072),(18900,2072),(18901,2073),(18902,2073),(18903,2073),(18904,2073),(18905,2074),(18906,2074),(18907,2074),(18908,2074),(18909,2075),(18910,2075),(18911,2075),(18912,2075),(18913,2076),(18914,2076),(18915,2076),(18916,2076),(18917,2077),(18918,2077),(18919,2077),(18920,2077),(18921,2078),(18922,2078),(18923,2078),(18924,2078),(18925,2079),(18926,2079),(18927,2079),(18928,2079),(18929,2080),(18930,2080),(18931,2080),(18932,2080),(18933,2081),(18934,2081),(18935,2081),(18936,2081),(18937,2082),(18938,2082),(18939,2082),(18940,2082),(18941,2083),(18942,2083),(18943,2083),(18944,2083),(18945,2084),(18946,2084),(18947,2084),(18948,2084),(18949,2085),(18950,2085),(18951,2085),(18952,2085),(18953,2086),(18954,2086),(18955,2086),(18956,2086),(18957,2087),(18958,2087),(18959,2087),(18960,2087),(18961,2088),(18962,2088),(18963,2088),(18964,2088),(18965,2089),(18966,2089),(18967,2089),(18968,2089),(18969,2090),(18970,2090),(18971,2090),(18972,2090),(18973,2091),(18974,2091),(18975,2091),(18976,2091),(18977,2092),(18978,2092),(18979,2092),(18980,2092),(18981,2093),(18982,2093),(18983,2093),(18984,2093),(18985,2094),(18986,2094),(18987,2094),(18988,2094),(18989,2095),(18990,2095),(18991,2095),(18992,2095),(18993,2096),(18994,2096),(18995,2096),(18996,2096),(18997,2097),(18998,2097),(18999,2097),(19000,2097),(19001,2098),(19002,2098),(19003,2098),(19004,2098),(19005,2099),(19006,2099),(19007,2099),(19008,2099),(19009,2100),(19010,2100),(19011,2100),(19012,2100),(19013,2101),(19014,2101),(19015,2101),(19016,2101),(19017,2102),(19018,2102),(19019,2102),(19020,2102),(19021,2103),(19022,2103),(19023,2103),(19024,2103),(19025,2104),(19026,2104),(19027,2104),(19028,2104),(19029,2105),(19030,2105),(19031,2105),(19032,2105),(19033,2106),(19034,2106),(19035,2106),(19036,2106),(19037,2107),(19038,2107),(19039,2107),(19040,2107),(19041,2108),(19042,2108),(19043,2108),(19044,2108),(19045,2109),(19046,2109),(19047,2109),(19048,2109),(19049,2110),(19050,2110),(19051,2110),(19052,2110),(19053,2111),(19054,2111),(19055,2111),(19056,2111),(19057,2112),(19058,2112),(19059,2112),(19060,2112),(19061,2113),(19062,2114),(19063,2115),(19064,2116),(19065,2117),(19066,2118),(19067,2119),(19068,2120),(19069,2121),(19070,2122),(19071,2123),(19072,2124),(19073,2125),(19074,2126),(19075,2127),(19076,2128),(19077,2129),(19078,2130),(19079,2131),(19080,2132),(19081,2133),(19082,2134),(19083,2135),(19084,2136),(19085,2137),(19086,2138),(19087,2139),(19088,2140),(19089,2141),(19090,2142),(19091,2143),(19092,2144),(19093,2145),(19094,2146),(19095,2147),(19096,2148),(19097,2149),(19098,2150),(19099,2151),(19100,2152),(19101,2153),(19102,2154),(19103,2155),(19104,2156),(19105,2157),(19106,2158),(19107,2159),(19108,2160),(19109,2161),(19110,2162),(19111,2163),(19112,2164),(19113,2165),(19114,2166),(19115,2167),(19116,2168),(19117,2169),(19118,2170),(19119,2171),(19120,2172),(19121,2173),(19122,2174),(19123,2175),(19124,2176),(19125,2177),(19126,2178),(19127,2179),(19128,2180),(19129,2181),(19130,2182),(19131,2183),(19132,2184),(19133,2185),(19134,2186),(19135,2187),(19136,2188),(19137,2189),(19138,2190),(19139,2191),(19140,2192),(19141,2193),(19142,2194),(19143,2195),(19144,2196),(19145,2197),(19146,2198),(19147,2199),(19148,2200),(19149,2201),(19150,2202),(19151,2203),(19152,2204),(19153,2205),(19154,2206),(19155,2207),(19156,2208),(19157,2209),(19158,2210),(19159,2211),(19160,2212),(19161,2113),(19162,2114),(19163,2115),(19164,2116),(19165,2117),(19166,2118),(19167,2119),(19168,2120),(19169,2121),(19170,2122),(19171,2123),(19172,2124),(19173,2125),(19174,2126),(19175,2127),(19176,2128),(19177,2129),(19178,2130),(19179,2131),(19180,2132),(19181,2133),(19182,2134),(19183,2135),(19184,2136),(19185,2137),(19186,2138),(19187,2139),(19188,2140),(19189,2141),(19190,2142),(19191,2143),(19192,2144),(19193,2145),(19194,2146),(19195,2147),(19196,2148),(19197,2149),(19198,2150),(19199,2151),(19200,2152),(19201,2153),(19202,2154),(19203,2155),(19204,2156),(19205,2157),(19206,2158),(19207,2159),(19208,2160),(19209,2161),(19210,2162),(19211,2163),(19212,2164),(19213,2165),(19214,2166),(19215,2167),(19216,2168),(19217,2169),(19218,2170),(19219,2171),(19220,2172),(19221,2173),(19222,2174),(19223,2175),(19224,2176),(19225,2177),(19226,2178),(19227,2179),(19228,2180),(19229,2181),(19230,2182),(19231,2183),(19232,2184),(19233,2185),(19234,2186),(19235,2187),(19236,2188),(19237,2189),(19238,2190),(19239,2191),(19240,2192),(19241,2193),(19242,2194),(19243,2195),(19244,2196),(19245,2197),(19246,2198),(19247,2199),(19248,2200),(19249,2201),(19250,2202),(19251,2203),(19252,2204),(19253,2205),(19254,2206),(19255,2207),(19256,2208),(19257,2209),(19258,2210),(19259,2211),(19260,2212),(19261,2113),(19262,2113),(19263,2113),(19264,2114),(19265,2114),(19266,2114),(19267,2115),(19268,2115),(19269,2115),(19270,2116),(19271,2116),(19272,2116),(19273,2117),(19274,2117),(19275,2117),(19276,2118),(19277,2118),(19278,2118),(19279,2119),(19280,2119),(19281,2119),(19282,2120),(19283,2120),(19284,2120),(19285,2121),(19286,2121),(19287,2121),(19288,2122),(19289,2122),(19290,2122),(19291,2123),(19292,2123),(19293,2123),(19294,2124),(19295,2124),(19296,2124),(19297,2125),(19298,2125),(19299,2125),(19300,2126),(19301,2126),(19302,2126),(19303,2127),(19304,2127),(19305,2127),(19306,2128),(19307,2128),(19308,2128),(19309,2129),(19310,2129),(19311,2129),(19312,2130),(19313,2130),(19314,2130),(19315,2131),(19316,2131),(19317,2131),(19318,2132),(19319,2132),(19320,2132),(19321,2133),(19322,2133),(19323,2133),(19324,2134),(19325,2134),(19326,2134),(19327,2135),(19328,2135),(19329,2135),(19330,2136),(19331,2136),(19332,2136),(19333,2137),(19334,2137),(19335,2137),(19336,2138),(19337,2138),(19338,2138),(19339,2139),(19340,2139),(19341,2139),(19342,2140),(19343,2140),(19344,2140),(19345,2141),(19346,2141),(19347,2141),(19348,2142),(19349,2142),(19350,2142),(19351,2143),(19352,2143),(19353,2143),(19354,2144),(19355,2144),(19356,2144),(19357,2145),(19358,2145),(19359,2145),(19360,2146),(19361,2146),(19362,2146),(19363,2147),(19364,2147),(19365,2147),(19366,2148),(19367,2148),(19368,2148),(19369,2149),(19370,2149),(19371,2149),(19372,2150),(19373,2150),(19374,2150),(19375,2151),(19376,2151),(19377,2151),(19378,2152),(19379,2152),(19380,2152),(19381,2153),(19382,2153),(19383,2153),(19384,2154),(19385,2154),(19386,2154),(19387,2155),(19388,2155),(19389,2155),(19390,2156),(19391,2156),(19392,2156),(19393,2157),(19394,2157),(19395,2157),(19396,2158),(19397,2158),(19398,2158),(19399,2159),(19400,2159),(19401,2159),(19402,2160),(19403,2160),(19404,2160),(19405,2161),(19406,2161),(19407,2161),(19408,2162),(19409,2162),(19410,2162),(19411,2163),(19412,2163),(19413,2163),(19414,2164),(19415,2164),(19416,2164),(19417,2165),(19418,2165),(19419,2165),(19420,2166),(19421,2166),(19422,2166),(19423,2167),(19424,2167),(19425,2167),(19426,2168),(19427,2168),(19428,2168),(19429,2169),(19430,2169),(19431,2169),(19432,2169),(19433,2170),(19434,2170),(19435,2170),(19436,2171),(19437,2171),(19438,2171),(19439,2172),(19440,2172),(19441,2172),(19442,2173),(19443,2173),(19444,2173),(19445,2174),(19446,2174),(19447,2174),(19448,2175),(19449,2175),(19450,2175),(19451,2176),(19452,2176),(19453,2176),(19454,2177),(19455,2177),(19456,2177),(19457,2178),(19458,2178),(19459,2178),(19460,2179),(19461,2179),(19462,2179),(19463,2180),(19464,2180),(19465,2180),(19466,2181),(19467,2181),(19468,2181),(19469,2182),(19470,2182),(19471,2182),(19472,2183),(19473,2183),(19474,2183),(19475,2184),(19476,2184),(19477,2184),(19478,2185),(19479,2185),(19480,2185),(19481,2186),(19482,2186),(19483,2186),(19484,2187),(19485,2187),(19486,2187),(19487,2188),(19488,2188),(19489,2188),(19490,2189),(19491,2189),(19492,2189),(19493,2190),(19494,2190),(19495,2190),(19496,2191),(19497,2191),(19498,2191),(19499,2192),(19500,2192),(19501,2192),(19502,2193),(19503,2193),(19504,2193),(19505,2194),(19506,2194),(19507,2194),(19508,2195),(19509,2195),(19510,2195),(19511,2196),(19512,2196),(19513,2196),(19514,2197),(19515,2197),(19516,2197),(19517,2198),(19518,2198),(19519,2198),(19520,2199),(19521,2199),(19522,2199),(19523,2200),(19524,2200),(19525,2200),(19526,2201),(19527,2201),(19528,2201),(19529,2202),(19530,2202),(19531,2202),(19532,2203),(19533,2203),(19534,2203),(19535,2204),(19536,2204),(19537,2204),(19538,2205),(19539,2205),(19540,2205),(19541,2206),(19542,2206),(19543,2206),(19544,2207),(19545,2207),(19546,2207),(19547,2208),(19548,2208),(19549,2208),(19550,2209),(19551,2209),(19552,2209),(19553,2210),(19554,2210),(19555,2210),(19556,2211),(19557,2211),(19558,2211),(19559,2212),(19560,2212),(19561,2212),(19562,2113),(19563,2113),(19564,2113),(19565,2113),(19566,2114),(19567,2114),(19568,2114),(19569,2114),(19570,2115),(19571,2115),(19572,2115),(19573,2115),(19574,2116),(19575,2116),(19576,2116),(19577,2116),(19578,2117),(19579,2117),(19580,2117),(19581,2117),(19582,2118),(19583,2118),(19584,2118),(19585,2118),(19586,2119),(19587,2119),(19588,2119),(19589,2119),(19590,2120),(19591,2120),(19592,2120),(19593,2120),(19594,2121),(19595,2121),(19596,2121),(19597,2121),(19598,2122),(19599,2122),(19600,2122),(19601,2122),(19602,2123),(19603,2123),(19604,2123),(19605,2123),(19606,2124),(19607,2124),(19608,2124),(19609,2124),(19610,2125),(19611,2125),(19612,2125),(19613,2125),(19614,2126),(19615,2126),(19616,2126),(19617,2126),(19618,2127),(19619,2127),(19620,2127),(19621,2127),(19622,2128),(19623,2128),(19624,2128),(19625,2128),(19626,2129),(19627,2129),(19628,2129),(19629,2129),(19630,2130),(19631,2130),(19632,2130),(19633,2130),(19634,2131),(19635,2131),(19636,2131),(19637,2131),(19638,2132),(19639,2132),(19640,2132),(19641,2132),(19642,2133),(19643,2133),(19644,2133),(19645,2133),(19646,2134),(19647,2134),(19648,2134),(19649,2134),(19650,2135),(19651,2135),(19652,2135),(19653,2135),(19654,2136),(19655,2136),(19656,2136),(19657,2136),(19658,2137),(19659,2137),(19660,2137),(19661,2137),(19662,2138),(19663,2138),(19664,2138),(19665,2138),(19666,2139),(19667,2139),(19668,2139),(19669,2139),(19670,2140),(19671,2140),(19672,2140),(19673,2140),(19674,2141),(19675,2141),(19676,2141),(19677,2141),(19678,2142),(19679,2142),(19680,2142),(19681,2142),(19682,2143),(19683,2143),(19684,2143),(19685,2143),(19686,2144),(19687,2144),(19688,2144),(19689,2144),(19690,2145),(19691,2145),(19692,2145),(19693,2145),(19694,2146),(19695,2146),(19696,2146),(19697,2146),(19698,2147),(19699,2147),(19700,2147),(19701,2147),(19702,2148),(19703,2148),(19704,2148),(19705,2148),(19706,2149),(19707,2149),(19708,2149),(19709,2149),(19710,2150),(19711,2150),(19712,2150),(19713,2150),(19714,2151),(19715,2151),(19716,2151),(19717,2151),(19718,2152),(19719,2152),(19720,2152),(19721,2152),(19722,2153),(19723,2153),(19724,2153),(19725,2153),(19726,2154),(19727,2154),(19728,2154),(19729,2154),(19730,2155),(19731,2155),(19732,2155),(19733,2155),(19734,2156),(19735,2156),(19736,2156),(19737,2156),(19738,2157),(19739,2157),(19740,2157),(19741,2157),(19742,2158),(19743,2158),(19744,2158),(19745,2158),(19746,2159),(19747,2159),(19748,2159),(19749,2159),(19750,2160),(19751,2160),(19752,2160),(19753,2160),(19754,2161),(19755,2161),(19756,2161),(19757,2161),(19758,2162),(19759,2162),(19760,2162),(19761,2162),(19762,2163),(19763,2163),(19764,2163),(19765,2163),(19766,2164),(19767,2164),(19768,2164),(19769,2164),(19770,2165),(19771,2165),(19772,2165),(19773,2165),(19774,2166),(19775,2166),(19776,2166),(19777,2166),(19778,2167),(19779,2167),(19780,2167),(19781,2167),(19782,2168),(19783,2168),(19784,2168),(19785,2168),(19786,2169),(19787,2169),(19788,2169),(19789,2169),(19790,2170),(19791,2170),(19792,2170),(19793,2170),(19794,2171),(19795,2171),(19796,2171),(19797,2171),(19798,2172),(19799,2172),(19800,2172),(19801,2172),(19802,2173),(19803,2173),(19804,2173),(19805,2173),(19806,2174),(19807,2174),(19808,2174),(19809,2174),(19810,2175),(19811,2175),(19812,2175),(19813,2175),(19814,2176),(19815,2176),(19816,2176),(19817,2176),(19818,2177),(19819,2177),(19820,2177),(19821,2177),(19822,2178),(19823,2178),(19824,2178),(19825,2178),(19826,2179),(19827,2179),(19828,2179),(19829,2179),(19830,2180),(19831,2180),(19832,2180),(19833,2180),(19834,2181),(19835,2181),(19836,2181),(19837,2181),(19838,2182),(19839,2182),(19840,2182),(19841,2182),(19842,2183),(19843,2183),(19844,2183),(19845,2183),(19846,2184),(19847,2184),(19848,2184),(19849,2184),(19850,2185),(19851,2185),(19852,2185),(19853,2185),(19854,2186),(19855,2186),(19856,2186),(19857,2186),(19858,2187),(19859,2187),(19860,2187),(19861,2187),(19862,2188),(19863,2188),(19864,2188),(19865,2188),(19866,2189),(19867,2189),(19868,2189),(19869,2189),(19870,2190),(19871,2190),(19872,2190),(19873,2190),(19874,2191),(19875,2191),(19876,2191),(19877,2191),(19878,2192),(19879,2192),(19880,2192),(19881,2192),(19882,2193),(19883,2193),(19884,2193),(19885,2193),(19886,2194),(19887,2194),(19888,2194),(19889,2194),(19890,2195),(19891,2195),(19892,2195),(19893,2195),(19894,2196),(19895,2196),(19896,2196),(19897,2196),(19898,2197),(19899,2197),(19900,2197),(19901,2197),(19902,2198),(19903,2198),(19904,2198),(19905,2198),(19906,2199),(19907,2199),(19908,2199),(19909,2199),(19910,2200),(19911,2200),(19912,2200),(19913,2200),(19914,2201),(19915,2201),(19916,2201),(19917,2201),(19918,2202),(19919,2202),(19920,2202),(19921,2202),(19922,2203),(19923,2203),(19924,2203),(19925,2203),(19926,2204),(19927,2204),(19928,2204),(19929,2204),(19930,2205),(19931,2205),(19932,2205),(19933,2205),(19934,2206),(19935,2206),(19936,2206),(19937,2206),(19938,2207),(19939,2207),(19940,2207),(19941,2207),(19942,2208),(19943,2208),(19944,2208),(19945,2208),(19946,2209),(19947,2209),(19948,2209),(19949,2209),(19950,2210),(19951,2210),(19952,2210),(19953,2210),(19954,2211),(19955,2211),(19956,2211),(19957,2211),(19958,2212),(19959,2212),(19960,2212),(19961,2212),(19962,2213),(19963,2214),(19964,2215),(19965,2216),(19966,2217),(19967,2218),(19968,2219),(19969,2220),(19970,2221),(19971,2222),(19972,2223),(19973,2224),(19974,2225),(19975,2226),(19976,2227),(19977,2228),(19978,2229),(19979,2230),(19980,2231),(19981,2232),(19982,2233),(19983,2234),(19984,2235),(19985,2236),(19986,2237),(19987,2238),(19988,2239),(19989,2240),(19990,2241),(19991,2242),(19992,2243),(19993,2244),(19994,2245),(19995,2246),(19996,2247),(19997,2248),(19998,2249),(19999,2250),(20000,2251),(20001,2252),(20002,2253),(20003,2254),(20004,2255),(20005,2256),(20006,2257),(20007,2258),(20008,2259),(20009,2260),(20010,2261),(20011,2262),(20012,2263),(20013,2264),(20014,2265),(20015,2266),(20016,2267),(20017,2268),(20018,2269),(20019,2270),(20020,2271),(20021,2272),(20022,2273),(20023,2274),(20024,2275),(20025,2276),(20026,2277),(20027,2278),(20028,2279),(20029,2280),(20030,2281),(20031,2282),(20032,2283),(20033,2284),(20034,2285),(20035,2286),(20036,2287),(20037,2288),(20038,2289),(20039,2290),(20040,2291),(20041,2292),(20042,2293),(20043,2294),(20044,2295),(20045,2296),(20046,2297),(20047,2298),(20048,2299),(20049,2300),(20050,2301),(20051,2302),(20052,2303),(20053,2304),(20054,2305),(20055,2306),(20056,2307),(20057,2308),(20058,2309),(20059,2310),(20060,2213),(20061,2214),(20062,2215),(20063,2216),(20064,2217),(20065,2218),(20066,2219),(20067,2220),(20068,2221),(20069,2222),(20070,2223),(20071,2224),(20072,2225),(20073,2226),(20074,2227),(20075,2228),(20076,2229),(20077,2230),(20078,2231),(20079,2232),(20080,2233),(20081,2234),(20082,2235),(20083,2236),(20084,2237),(20085,2238),(20086,2239),(20087,2240),(20088,2241),(20089,2242),(20090,2243),(20091,2244),(20092,2245),(20093,2246),(20094,2247),(20095,2248),(20096,2249),(20097,2250),(20098,2251),(20099,2252),(20100,2253),(20101,2254),(20102,2255),(20103,2256),(20104,2257),(20105,2258),(20106,2259),(20107,2260),(20108,2261),(20109,2262),(20110,2263),(20111,2264),(20112,2265),(20113,2266),(20114,2267),(20115,2268),(20116,2269),(20117,2270),(20118,2271),(20119,2272),(20120,2273),(20121,2274),(20122,2275),(20123,2276),(20124,2277),(20125,2278),(20126,2279),(20127,2280),(20128,2281),(20129,2282),(20130,2283),(20131,2284),(20132,2285),(20133,2286),(20134,2287),(20135,2288),(20136,2289),(20137,2290),(20138,2291),(20139,2292),(20140,2293),(20141,2294),(20142,2295),(20143,2296),(20144,2297),(20145,2298),(20146,2299),(20147,2300),(20148,2301),(20149,2302),(20150,2303),(20151,2304),(20152,2305),(20153,2306),(20154,2307),(20155,2308),(20156,2309),(20157,2310),(20158,2213),(20159,2213),(20160,2213),(20161,2214),(20162,2214),(20163,2214),(20164,2215),(20165,2215),(20166,2215),(20167,2216),(20168,2216),(20169,2216),(20170,2217),(20171,2217),(20172,2217),(20173,2218),(20174,2218),(20175,2218),(20176,2219),(20177,2219),(20178,2219),(20179,2220),(20180,2220),(20181,2220),(20182,2221),(20183,2221),(20184,2221),(20185,2222),(20186,2222),(20187,2222),(20188,2223),(20189,2223),(20190,2223),(20191,2224),(20192,2224),(20193,2224),(20194,2225),(20195,2225),(20196,2225),(20197,2226),(20198,2226),(20199,2226),(20200,2227),(20201,2227),(20202,2227),(20203,2228),(20204,2228),(20205,2228),(20206,2229),(20207,2229),(20208,2229),(20209,2230),(20210,2230),(20211,2230),(20212,2231),(20213,2231),(20214,2231),(20215,2232),(20216,2232),(20217,2232),(20218,2233),(20219,2233),(20220,2233),(20221,2234),(20222,2234),(20223,2234),(20224,2235),(20225,2235),(20226,2235),(20227,2236),(20228,2236),(20229,2236),(20230,2237),(20231,2237),(20232,2237),(20233,2238),(20234,2238),(20235,2238),(20236,2239),(20237,2239),(20238,2239),(20239,2239),(20240,2240),(20241,2240),(20242,2240),(20243,2241),(20244,2242),(20245,2243),(20246,2244),(20247,2245),(20248,2245),(20249,2245),(20250,2245),(20251,2246),(20252,2246),(20253,2246),(20254,2247),(20255,2247),(20256,2247),(20257,2248),(20258,2248),(20259,2248),(20260,2249),(20261,2249),(20262,2249),(20263,2250),(20264,2250),(20265,2250),(20266,2251),(20267,2251),(20268,2251),(20269,2252),(20270,2252),(20271,2252),(20272,2253),(20273,2253),(20274,2253),(20275,2254),(20276,2254),(20277,2254),(20278,2255),(20279,2255),(20280,2255),(20281,2256),(20282,2256),(20283,2256),(20284,2257),(20285,2257),(20286,2257),(20287,2258),(20288,2258),(20289,2258),(20290,2259),(20291,2259),(20292,2259),(20293,2260),(20294,2260),(20295,2260),(20296,2261),(20297,2261),(20298,2261),(20299,2262),(20300,2262),(20301,2262),(20302,2263),(20303,2263),(20304,2263),(20305,2264),(20306,2264),(20307,2264),(20308,2265),(20309,2265),(20310,2265),(20311,2266),(20312,2266),(20313,2266),(20314,2267),(20315,2267),(20316,2267),(20317,2268),(20318,2268),(20319,2268),(20320,2269),(20321,2269),(20322,2269),(20323,2270),(20324,2270),(20325,2270),(20326,2271),(20327,2271),(20328,2271),(20329,2272),(20330,2272),(20331,2272),(20332,2273),(20333,2273),(20334,2273),(20335,2274),(20336,2274),(20337,2274),(20338,2275),(20339,2275),(20340,2275),(20341,2276),(20342,2276),(20343,2276),(20344,2277),(20345,2277),(20346,2277),(20347,2278),(20348,2278),(20349,2278),(20350,2279),(20351,2279),(20352,2279),(20353,2280),(20354,2280),(20355,2280),(20356,2281),(20357,2281),(20358,2281),(20359,2282),(20360,2282),(20361,2282),(20362,2283),(20363,2283),(20364,2283),(20365,2284),(20366,2284),(20367,2284),(20368,2285),(20369,2285),(20370,2285),(20371,2286),(20372,2286),(20373,2286),(20374,2287),(20375,2287),(20376,2287),(20377,2288),(20378,2288),(20379,2288),(20380,2289),(20381,2289),(20382,2289),(20383,2290),(20384,2290),(20385,2290),(20386,2291),(20387,2291),(20388,2291),(20389,2292),(20390,2292),(20391,2292),(20392,2293),(20393,2293),(20394,2293),(20395,2294),(20396,2294),(20397,2294),(20398,2295),(20399,2295),(20400,2295),(20401,2296),(20402,2296),(20403,2296),(20404,2297),(20405,2297),(20406,2297),(20407,2298),(20408,2298),(20409,2298),(20410,2299),(20411,2299),(20412,2299),(20413,2300),(20414,2300),(20415,2300),(20416,2301),(20417,2301),(20418,2301),(20419,2302),(20420,2302),(20421,2302),(20422,2303),(20423,2303),(20424,2303),(20425,2304),(20426,2304),(20427,2304),(20428,2305),(20429,2305),(20430,2305),(20431,2306),(20432,2306),(20433,2306),(20434,2307),(20435,2307),(20436,2307),(20437,2308),(20438,2308),(20439,2308),(20440,2309),(20441,2309),(20442,2309),(20443,2310),(20444,2310),(20445,2310),(20446,2213),(20447,2213),(20448,2213),(20449,2213),(20450,2214),(20451,2214),(20452,2214),(20453,2214),(20454,2215),(20455,2215),(20456,2215),(20457,2215),(20458,2216),(20459,2216),(20460,2216),(20461,2216),(20462,2217),(20463,2217),(20464,2217),(20465,2217),(20466,2218),(20467,2218),(20468,2218),(20469,2218),(20470,2219),(20471,2219),(20472,2219),(20473,2219),(20474,2220),(20475,2220),(20476,2220),(20477,2220),(20478,2221),(20479,2221),(20480,2221),(20481,2221),(20482,2222),(20483,2222),(20484,2222),(20485,2222),(20486,2223),(20487,2223),(20488,2223),(20489,2223),(20490,2224),(20491,2224),(20492,2224),(20493,2224),(20494,2225),(20495,2225),(20496,2225),(20497,2225),(20498,2226),(20499,2226),(20500,2226),(20501,2226),(20502,2227),(20503,2227),(20504,2227),(20505,2227),(20506,2228),(20507,2228),(20508,2228),(20509,2228),(20510,2229),(20511,2229),(20512,2229),(20513,2229),(20514,2230),(20515,2230),(20516,2230),(20517,2230),(20518,2231),(20519,2231),(20520,2231),(20521,2231),(20522,2232),(20523,2232),(20524,2232),(20525,2232),(20526,2233),(20527,2233),(20528,2233),(20529,2233),(20530,2234),(20531,2234),(20532,2234),(20533,2234),(20534,2235),(20535,2235),(20536,2235),(20537,2235),(20538,2236),(20539,2236),(20540,2236),(20541,2236),(20542,2237),(20543,2237),(20544,2237),(20545,2237),(20546,2238),(20547,2238),(20548,2238),(20549,2238),(20550,2239),(20551,2239),(20552,2239),(20553,2239),(20554,2240),(20555,2240),(20556,2240),(20557,2240),(20558,2241),(20559,2241),(20560,2241),(20561,2241),(20562,2242),(20563,2242),(20564,2242),(20565,2242),(20566,2243),(20567,2243),(20568,2243),(20569,2243),(20570,2244),(20571,2244),(20572,2244),(20573,2244),(20574,2245),(20575,2245),(20576,2245),(20577,2245),(20578,2246),(20579,2246),(20580,2246),(20581,2246),(20582,2247),(20583,2247),(20584,2247),(20585,2247),(20586,2248),(20587,2248),(20588,2248),(20589,2248),(20590,2249),(20591,2249),(20592,2249),(20593,2249),(20594,2250),(20595,2250),(20596,2250),(20597,2250),(20598,2251),(20599,2251),(20600,2251),(20601,2251),(20602,2252),(20603,2252),(20604,2252),(20605,2252),(20606,2253),(20607,2253),(20608,2253),(20609,2253),(20610,2254),(20611,2254),(20612,2254),(20613,2254),(20614,2255),(20615,2255),(20616,2255),(20617,2255),(20618,2256),(20619,2256),(20620,2256),(20621,2256),(20622,2257),(20623,2257),(20624,2257),(20625,2257),(20626,2258),(20627,2258),(20628,2258),(20629,2258),(20630,2259),(20631,2259),(20632,2259),(20633,2259),(20634,2260),(20635,2260),(20636,2260),(20637,2260),(20638,2261),(20639,2261),(20640,2261),(20641,2261),(20642,2262),(20643,2262),(20644,2262),(20645,2262),(20646,2263),(20647,2263),(20648,2263),(20649,2263),(20650,2264),(20651,2264),(20652,2264),(20653,2264),(20654,2265),(20655,2265),(20656,2265),(20657,2265),(20658,2266),(20659,2266),(20660,2266),(20661,2266),(20662,2267),(20663,2267),(20664,2267),(20665,2267),(20666,2268),(20667,2268),(20668,2268),(20669,2268),(20670,2269),(20671,2269),(20672,2269),(20673,2269),(20674,2270),(20675,2270),(20676,2270),(20677,2270),(20678,2271),(20679,2271),(20680,2271),(20681,2271),(20682,2272),(20683,2272),(20684,2272),(20685,2272),(20686,2273),(20687,2273),(20688,2273),(20689,2273),(20690,2274),(20691,2274),(20692,2274),(20693,2274),(20694,2275),(20695,2275),(20696,2275),(20697,2275),(20698,2276),(20699,2276),(20700,2276),(20701,2276),(20702,2277),(20703,2277),(20704,2277),(20705,2277),(20706,2278),(20707,2278),(20708,2278),(20709,2278),(20710,2279),(20711,2279),(20712,2279),(20713,2279),(20714,2280),(20715,2280),(20716,2280),(20717,2280),(20718,2281),(20719,2281),(20720,2281),(20721,2281),(20722,2282),(20723,2282),(20724,2282),(20725,2282),(20726,2283),(20727,2283),(20728,2283),(20729,2283),(20730,2284),(20731,2284),(20732,2284),(20733,2284),(20734,2285),(20735,2285),(20736,2285),(20737,2285),(20738,2286),(20739,2286),(20740,2286),(20741,2286),(20742,2287),(20743,2287),(20744,2287),(20745,2287),(20746,2288),(20747,2288),(20748,2288),(20749,2288),(20750,2289),(20751,2289),(20752,2289),(20753,2289),(20754,2290),(20755,2290),(20756,2290),(20757,2290),(20758,2291),(20759,2291),(20760,2291),(20761,2291),(20762,2292),(20763,2292),(20764,2292),(20765,2292),(20766,2293),(20767,2293),(20768,2293),(20769,2293),(20770,2294),(20771,2294),(20772,2294),(20773,2294),(20774,2295),(20775,2295),(20776,2295),(20777,2295),(20778,2296),(20779,2296),(20780,2296),(20781,2296),(20782,2297),(20783,2297),(20784,2297),(20785,2297),(20786,2298),(20787,2298),(20788,2298),(20789,2298),(20790,2299),(20791,2299),(20792,2299),(20793,2299),(20794,2300),(20795,2300),(20796,2300),(20797,2300),(20798,2301),(20799,2301),(20800,2301),(20801,2301),(20802,2302),(20803,2302),(20804,2302),(20805,2302),(20806,2303),(20807,2303),(20808,2303),(20809,2303),(20810,2304),(20811,2304),(20812,2304),(20813,2304),(20814,2305),(20815,2305),(20816,2305),(20817,2305),(20818,2306),(20819,2306),(20820,2306),(20821,2306),(20822,2307),(20823,2307),(20824,2307),(20825,2307),(20826,2308),(20827,2308),(20828,2308),(20829,2308),(20830,2309),(20831,2309),(20832,2309),(20833,2309),(20834,2310),(20835,2310),(20836,2310),(20837,2310),(20838,2311),(20839,2312),(20840,2313),(20841,2314),(20842,2315),(20843,2316),(20844,2317),(20845,2318),(20846,2319),(20847,2320),(20848,2321),(20849,2311),(20850,2312),(20851,2313),(20852,2314),(20853,2315),(20854,2316),(20855,2317),(20856,2318),(20857,2319),(20858,2320),(20859,2321),(20860,2311),(20861,2311),(20862,2311),(20863,2312),(20864,2312),(20865,2312),(20866,2313),(20867,2313),(20868,2313),(20869,2314),(20870,2314),(20871,2314),(20872,2315),(20873,2315),(20874,2315),(20875,2316),(20876,2316),(20877,2316),(20878,2317),(20879,2317),(20880,2317),(20881,2318),(20882,2318),(20883,2318),(20884,2319),(20885,2319),(20886,2319),(20887,2320),(20888,2320),(20889,2320),(20890,2321),(20891,2321),(20892,2321),(20893,2311),(20894,2311),(20895,2311),(20896,2311),(20897,2312),(20898,2312),(20899,2312),(20900,2312),(20901,2313),(20902,2313),(20903,2313),(20904,2313),(20905,2314),(20906,2314),(20907,2314),(20908,2314),(20909,2315),(20910,2315),(20911,2315),(20912,2315),(20913,2316),(20914,2316),(20915,2316),(20916,2316),(20917,2317),(20918,2317),(20919,2317),(20920,2317),(20921,2318),(20922,2318),(20923,2318),(20924,2318),(20925,2319),(20926,2319),(20927,2319),(20928,2319),(20929,2320),(20930,2320),(20931,2320),(20932,2320),(20933,2321),(20934,2321),(20935,2321),(20936,2321),(20937,2322),(20938,2323),(20939,2324),(20940,2325),(20941,2326),(20942,2327),(20943,2328),(20944,2329),(20945,2330),(20946,2331),(20947,2332),(20948,2333),(20949,2334),(20950,2335),(20951,2336),(20952,2337),(20953,2338),(20954,2339),(20955,2340),(20956,2341),(20957,2342),(20958,2343),(20959,2344),(20960,2345),(20961,2346),(20962,2347),(20963,2348),(20964,2349),(20965,2350),(20966,2351),(20967,2352),(20968,2353),(20969,2354),(20970,2355),(20971,2356),(20972,2357),(20973,2358),(20974,2359),(20975,2360),(20976,2361),(20977,2362),(20978,2363),(20979,2364),(20980,2365),(20981,2366),(20982,2367),(20983,2368),(20984,2369),(20985,2370),(20986,2371),(20987,2372),(20988,2373),(20989,2374),(20990,2375),(20991,2376),(20992,2377),(20993,2378),(20994,2379),(20995,2380),(20996,2381),(20997,2382),(20998,2383),(20999,2384),(21000,2385),(21001,2386),(21002,2387),(21003,2388),(21004,2389),(21005,2390),(21006,2391),(21007,2392),(21008,2393),(21009,2394),(21010,2395),(21011,2396),(21012,2397),(21013,2398),(21014,2399),(21015,2400),(21016,2401),(21017,2402),(21018,2403),(21019,2404),(21020,2405),(21021,2406),(21022,2407),(21023,2408),(21024,2409),(21025,2410),(21026,2322),(21027,2323),(21028,2324),(21029,2325),(21030,2326),(21031,2327),(21032,2328),(21033,2329),(21034,2330),(21035,2331),(21036,2332),(21037,2333),(21038,2334),(21039,2335),(21040,2336),(21041,2337),(21042,2338),(21043,2339),(21044,2340),(21045,2341),(21046,2342),(21047,2343),(21048,2344),(21049,2345),(21050,2346),(21051,2347),(21052,2348),(21053,2349),(21054,2350),(21055,2351),(21056,2352),(21057,2353),(21058,2354),(21059,2355),(21060,2356),(21061,2357),(21062,2358),(21063,2359),(21064,2360),(21065,2361),(21066,2362),(21067,2363),(21068,2364),(21069,2365),(21070,2366),(21071,2367),(21072,2368),(21073,2369),(21074,2370),(21075,2371),(21076,2372),(21077,2373),(21078,2374),(21079,2375),(21080,2376),(21081,2377),(21082,2378),(21083,2379),(21084,2380),(21085,2381),(21086,2382),(21087,2383),(21088,2384),(21089,2385),(21090,2386),(21091,2387),(21092,2388),(21093,2389),(21094,2390),(21095,2391),(21096,2392),(21097,2393),(21098,2394),(21099,2395),(21100,2396),(21101,2397),(21102,2398),(21103,2399),(21104,2400),(21105,2401),(21106,2402),(21107,2403),(21108,2404),(21109,2405),(21110,2406),(21111,2407),(21112,2408),(21113,2409),(21114,2410),(21115,2322),(21116,2322),(21117,2322),(21118,2323),(21119,2323),(21120,2323),(21121,2324),(21122,2324),(21123,2324),(21124,2325),(21125,2325),(21126,2325),(21127,2326),(21128,2326),(21129,2326),(21130,2327),(21131,2327),(21132,2327),(21133,2328),(21134,2328),(21135,2328),(21136,2329),(21137,2329),(21138,2329),(21139,2330),(21140,2330),(21141,2330),(21142,2331),(21143,2331),(21144,2331),(21145,2332),(21146,2332),(21147,2332),(21148,2333),(21149,2333),(21150,2333),(21151,2334),(21152,2334),(21153,2334),(21154,2335),(21155,2335),(21156,2335),(21157,2336),(21158,2336),(21159,2336),(21160,2337),(21161,2337),(21162,2337),(21163,2338),(21164,2338),(21165,2338),(21166,2339),(21167,2339),(21168,2339),(21169,2340),(21170,2340),(21171,2340),(21172,2341),(21173,2341),(21174,2341),(21175,2342),(21176,2342),(21177,2342),(21178,2343),(21179,2343),(21180,2343),(21181,2344),(21182,2344),(21183,2344),(21184,2345),(21185,2345),(21186,2345),(21187,2346),(21188,2346),(21189,2346),(21190,2347),(21191,2347),(21192,2347),(21193,2348),(21194,2348),(21195,2348),(21196,2349),(21197,2349),(21198,2349),(21199,2350),(21200,2350),(21201,2350),(21202,2351),(21203,2351),(21204,2351),(21205,2352),(21206,2352),(21207,2352),(21208,2353),(21209,2353),(21210,2353),(21211,2354),(21212,2354),(21213,2354),(21214,2355),(21215,2355),(21216,2355),(21217,2356),(21218,2356),(21219,2356),(21220,2357),(21221,2357),(21222,2357),(21223,2358),(21224,2358),(21225,2358),(21226,2359),(21227,2359),(21228,2359),(21229,2360),(21230,2360),(21231,2360),(21232,2361),(21233,2361),(21234,2361),(21235,2362),(21236,2362),(21237,2362),(21238,2363),(21239,2363),(21240,2363),(21241,2364),(21242,2364),(21243,2364),(21244,2365),(21245,2365),(21246,2365),(21247,2366),(21248,2366),(21249,2366),(21250,2367),(21251,2367),(21252,2367),(21253,2368),(21254,2368),(21255,2368),(21256,2369),(21257,2369),(21258,2369),(21259,2370),(21260,2370),(21261,2370),(21262,2371),(21263,2371),(21264,2371),(21265,2372),(21266,2372),(21267,2372),(21268,2373),(21269,2373),(21270,2373),(21271,2374),(21272,2374),(21273,2374),(21274,2375),(21275,2375),(21276,2375),(21277,2376),(21278,2376),(21279,2376),(21280,2377),(21281,2377),(21282,2377),(21283,2378),(21284,2378),(21285,2378),(21286,2379),(21287,2379),(21288,2379),(21289,2380),(21290,2380),(21291,2380),(21292,2381),(21293,2381),(21294,2381),(21295,2382),(21296,2382),(21297,2382),(21298,2383),(21299,2383),(21300,2383),(21301,2384),(21302,2384),(21303,2384),(21304,2385),(21305,2385),(21306,2385),(21307,2386),(21308,2386),(21309,2386),(21310,2387),(21311,2387),(21312,2387),(21313,2388),(21314,2388),(21315,2388),(21316,2389),(21317,2389),(21318,2389),(21319,2390),(21320,2390),(21321,2390),(21322,2391),(21323,2391),(21324,2391),(21325,2392),(21326,2392),(21327,2392),(21328,2393),(21329,2393),(21330,2393),(21331,2394),(21332,2394),(21333,2394),(21334,2395),(21335,2395),(21336,2395),(21337,2396),(21338,2396),(21339,2396),(21340,2397),(21341,2397),(21342,2397),(21343,2398),(21344,2398),(21345,2398),(21346,2399),(21347,2399),(21348,2399),(21349,2400),(21350,2400),(21351,2400),(21352,2401),(21353,2401),(21354,2401),(21355,2402),(21356,2402),(21357,2402),(21358,2403),(21359,2403),(21360,2403),(21361,2404),(21362,2404),(21363,2404),(21364,2405),(21365,2405),(21366,2405),(21367,2406),(21368,2406),(21369,2406),(21370,2407),(21371,2407),(21372,2407),(21373,2408),(21374,2408),(21375,2408),(21376,2409),(21377,2409),(21378,2409),(21379,2410),(21380,2410),(21381,2410),(21382,2322),(21383,2322),(21384,2322),(21385,2322),(21386,2323),(21387,2323),(21388,2323),(21389,2323),(21390,2324),(21391,2324),(21392,2324),(21393,2324),(21394,2325),(21395,2325),(21396,2325),(21397,2325),(21398,2326),(21399,2326),(21400,2326),(21401,2326),(21402,2327),(21403,2327),(21404,2327),(21405,2327),(21406,2328),(21407,2328),(21408,2328),(21409,2328),(21410,2329),(21411,2329),(21412,2329),(21413,2329),(21414,2330),(21415,2330),(21416,2330),(21417,2330),(21418,2331),(21419,2331),(21420,2331),(21421,2331),(21422,2332),(21423,2332),(21424,2332),(21425,2332),(21426,2333),(21427,2333),(21428,2333),(21429,2333),(21430,2334),(21431,2334),(21432,2334),(21433,2334),(21434,2335),(21435,2335),(21436,2335),(21437,2335),(21438,2336),(21439,2336),(21440,2336),(21441,2336),(21442,2337),(21443,2337),(21444,2337),(21445,2337),(21446,2338),(21447,2338),(21448,2338),(21449,2338),(21450,2339),(21451,2339),(21452,2339),(21453,2339),(21454,2340),(21455,2340),(21456,2340),(21457,2340),(21458,2341),(21459,2341),(21460,2341),(21461,2341),(21462,2342),(21463,2342),(21464,2342),(21465,2342),(21466,2343),(21467,2343),(21468,2343),(21469,2343),(21470,2344),(21471,2344),(21472,2344),(21473,2344),(21474,2345),(21475,2345),(21476,2345),(21477,2345),(21478,2346),(21479,2346),(21480,2346),(21481,2346),(21482,2347),(21483,2347),(21484,2347),(21485,2347),(21486,2348),(21487,2348),(21488,2348),(21489,2348),(21490,2349),(21491,2349),(21492,2349),(21493,2349),(21494,2350),(21495,2350),(21496,2350),(21497,2350),(21498,2351),(21499,2351),(21500,2351),(21501,2351),(21502,2352),(21503,2352),(21504,2352),(21505,2352),(21506,2353),(21507,2353),(21508,2353),(21509,2353),(21510,2354),(21511,2354),(21512,2354),(21513,2354),(21514,2355),(21515,2355),(21516,2355),(21517,2355),(21518,2356),(21519,2356),(21520,2356),(21521,2356),(21522,2357),(21523,2357),(21524,2357),(21525,2357),(21526,2358),(21527,2358),(21528,2358),(21529,2358),(21530,2359),(21531,2359),(21532,2359),(21533,2359),(21534,2360),(21535,2360),(21536,2360),(21537,2360),(21538,2361),(21539,2361),(21540,2361),(21541,2361),(21542,2362),(21543,2362),(21544,2362),(21545,2362),(21546,2363),(21547,2363),(21548,2363),(21549,2363),(21550,2364),(21551,2364),(21552,2364),(21553,2364),(21554,2365),(21555,2365),(21556,2365),(21557,2365),(21558,2366),(21559,2366),(21560,2366),(21561,2366),(21562,2367),(21563,2367),(21564,2367),(21565,2367),(21566,2368),(21567,2368),(21568,2368),(21569,2368),(21570,2369),(21571,2369),(21572,2369),(21573,2369),(21574,2370),(21575,2370),(21576,2370),(21577,2370),(21578,2371),(21579,2371),(21580,2371),(21581,2371),(21582,2372),(21583,2372),(21584,2372),(21585,2372),(21586,2373),(21587,2373),(21588,2373),(21589,2373),(21590,2374),(21591,2374),(21592,2374),(21593,2374),(21594,2375),(21595,2375),(21596,2375),(21597,2375),(21598,2376),(21599,2376),(21600,2376),(21601,2376),(21602,2377),(21603,2377),(21604,2377),(21605,2377),(21606,2378),(21607,2378),(21608,2378),(21609,2378),(21610,2379),(21611,2379),(21612,2379),(21613,2379),(21614,2380),(21615,2380),(21616,2380),(21617,2380),(21618,2381),(21619,2381),(21620,2381),(21621,2381),(21622,2382),(21623,2382),(21624,2382),(21625,2382),(21626,2383),(21627,2383),(21628,2383),(21629,2383),(21630,2384),(21631,2384),(21632,2384),(21633,2384),(21634,2385),(21635,2385),(21636,2385),(21637,2385),(21638,2386),(21639,2386),(21640,2386),(21641,2386),(21642,2387),(21643,2387),(21644,2387),(21645,2387),(21646,2388),(21647,2388),(21648,2388),(21649,2388),(21650,2389),(21651,2389),(21652,2389),(21653,2389),(21654,2390),(21655,2390),(21656,2390),(21657,2390),(21658,2391),(21659,2391),(21660,2391),(21661,2391),(21662,2392),(21663,2392),(21664,2392),(21665,2392),(21666,2393),(21667,2393),(21668,2393),(21669,2393),(21670,2394),(21671,2394),(21672,2394),(21673,2394),(21674,2395),(21675,2395),(21676,2395),(21677,2395),(21678,2396),(21679,2396),(21680,2396),(21681,2396),(21682,2397),(21683,2397),(21684,2397),(21685,2397),(21686,2398),(21687,2398),(21688,2398),(21689,2398),(21690,2399),(21691,2399),(21692,2399),(21693,2399),(21694,2400),(21695,2400),(21696,2400),(21697,2400),(21698,2401),(21699,2401),(21700,2401),(21701,2401),(21702,2402),(21703,2402),(21704,2402),(21705,2402),(21706,2403),(21707,2403),(21708,2403),(21709,2403),(21710,2404),(21711,2404),(21712,2404),(21713,2404),(21714,2405),(21715,2405),(21716,2405),(21717,2405),(21718,2406),(21719,2406),(21720,2406),(21721,2406),(21722,2407),(21723,2407),(21724,2407),(21725,2407),(21726,2408),(21727,2408),(21728,2408),(21729,2408),(21730,2409),(21731,2409),(21732,2409),(21733,2409),(21734,2410),(21735,2410),(21736,2410),(21737,2410),(21738,2411),(21739,2412),(21740,2413),(21741,2414),(21742,2415),(21743,2416),(21744,2417),(21745,2418),(21746,2419),(21747,2420),(21748,2421),(21749,2422),(21750,2423),(21751,2424),(21752,2425),(21753,2426),(21754,2427),(21755,2428),(21756,2429),(21757,2430),(21758,2431),(21759,2432),(21760,2433),(21761,2434),(21762,2435),(21763,2436),(21764,2437),(21765,2438),(21766,2439),(21767,2440),(21768,2441),(21769,2442),(21770,2443),(21771,2444),(21772,2445),(21773,2446),(21774,2447),(21775,2448),(21776,2449),(21777,2450),(21778,2451),(21779,2452),(21780,2453),(21781,2454),(21782,2455),(21783,2456),(21784,2457),(21785,2458),(21786,2459),(21787,2460),(21788,2461),(21789,2462),(21790,2463),(21791,2464),(21792,2465),(21793,2466),(21794,2467),(21795,2468),(21796,2469),(21797,2470),(21798,2471),(21799,2472),(21800,2473),(21801,2474),(21802,2475),(21803,2476),(21804,2477),(21805,2478),(21806,2479),(21807,2480),(21808,2481),(21809,2482),(21810,2483),(21811,2484),(21812,2485),(21813,2486),(21814,2487),(21815,2488),(21816,2489),(21817,2490),(21818,2491),(21819,2492),(21820,2493),(21821,2494),(21822,2495),(21823,2496),(21824,2497),(21825,2498),(21826,2499),(21827,2500),(21828,2501),(21829,2502),(21830,2503),(21831,2504),(21832,2505),(21833,2506),(21834,2507),(21835,2508),(21836,2509),(21837,2510),(21838,2411),(21839,2412),(21840,2413),(21841,2414),(21842,2415),(21843,2416),(21844,2417),(21845,2418),(21846,2419),(21847,2420),(21848,2421),(21849,2422),(21850,2423),(21851,2424),(21852,2425),(21853,2426),(21854,2427),(21855,2428),(21856,2429),(21857,2430),(21858,2431),(21859,2432),(21860,2433),(21861,2434),(21862,2435),(21863,2436),(21864,2437),(21865,2438),(21866,2439),(21867,2440),(21868,2441),(21869,2442),(21870,2443),(21871,2444),(21872,2445),(21873,2446),(21874,2447),(21875,2448),(21876,2449),(21877,2450),(21878,2451),(21879,2452),(21880,2453),(21881,2454),(21882,2455),(21883,2456),(21884,2457),(21885,2458),(21886,2459),(21887,2460),(21888,2461),(21889,2462),(21890,2463),(21891,2464),(21892,2465),(21893,2466),(21894,2467),(21895,2468),(21896,2469),(21897,2470),(21898,2471),(21899,2472),(21900,2473),(21901,2474),(21902,2475),(21903,2476),(21904,2477),(21905,2478),(21906,2479),(21907,2480),(21908,2481),(21909,2482),(21910,2483),(21911,2484),(21912,2485),(21913,2486),(21914,2487),(21915,2488),(21916,2489),(21917,2490),(21918,2491),(21919,2492),(21920,2493),(21921,2494),(21922,2495),(21923,2496),(21924,2497),(21925,2498),(21926,2499),(21927,2500),(21928,2501),(21929,2502),(21930,2503),(21931,2504),(21932,2505),(21933,2506),(21934,2507),(21935,2508),(21936,2509),(21937,2510),(21938,2411),(21939,2411),(21940,2411),(21941,2412),(21942,2412),(21943,2412),(21944,2413),(21945,2413),(21946,2413),(21947,2414),(21948,2414),(21949,2414),(21950,2415),(21951,2415),(21952,2415),(21953,2416),(21954,2416),(21955,2416),(21956,2417),(21957,2417),(21958,2417),(21959,2418),(21960,2418),(21961,2418),(21962,2419),(21963,2419),(21964,2419),(21965,2420),(21966,2420),(21967,2420),(21968,2421),(21969,2421),(21970,2421),(21971,2422),(21972,2422),(21973,2422),(21974,2423),(21975,2423),(21976,2423),(21977,2424),(21978,2424),(21979,2424),(21980,2425),(21981,2425),(21982,2425),(21983,2426),(21984,2426),(21985,2426),(21986,2426),(21987,2427),(21988,2427),(21989,2427),(21990,2428),(21991,2428),(21992,2428),(21993,2429),(21994,2429),(21995,2429),(21996,2430),(21997,2430),(21998,2430),(21999,2431),(22000,2431),(22001,2431),(22002,2432),(22003,2432),(22004,2432),(22005,2433),(22006,2433),(22007,2433),(22008,2434),(22009,2434),(22010,2434),(22011,2435),(22012,2435),(22013,2435),(22014,2436),(22015,2436),(22016,2436),(22017,2437),(22018,2437),(22019,2437),(22020,2438),(22021,2438),(22022,2438),(22023,2439),(22024,2439),(22025,2439),(22026,2440),(22027,2440),(22028,2440),(22029,2441),(22030,2441),(22031,2441),(22032,2442),(22033,2442),(22034,2442),(22035,2443),(22036,2443),(22037,2443),(22038,2444),(22039,2444),(22040,2444),(22041,2445),(22042,2445),(22043,2445),(22044,2446),(22045,2446),(22046,2446),(22047,2447),(22048,2447),(22049,2447),(22050,2448),(22051,2448),(22052,2448),(22053,2449),(22054,2450),(22055,2450),(22056,2450),(22057,2451),(22058,2451),(22059,2451),(22060,2452),(22061,2452),(22062,2452),(22063,2453),(22064,2453),(22065,2453),(22066,2454),(22067,2454),(22068,2454),(22069,2455),(22070,2455),(22071,2455),(22072,2456),(22073,2456),(22074,2456),(22075,2457),(22076,2457),(22077,2457),(22078,2458),(22079,2458),(22080,2458),(22081,2459),(22082,2459),(22083,2459),(22084,2460),(22085,2460),(22086,2460),(22087,2461),(22088,2461),(22089,2461),(22090,2462),(22091,2462),(22092,2462),(22093,2463),(22094,2463),(22095,2463),(22096,2464),(22097,2464),(22098,2464),(22099,2465),(22100,2465),(22101,2465),(22102,2466),(22103,2466),(22104,2466),(22105,2467),(22106,2467),(22107,2467),(22108,2468),(22109,2468),(22110,2468),(22111,2469),(22112,2469),(22113,2469),(22114,2470),(22115,2470),(22116,2470),(22117,2471),(22118,2471),(22119,2471),(22120,2472),(22121,2472),(22122,2472),(22123,2473),(22124,2473),(22125,2473),(22126,2474),(22127,2474),(22128,2474),(22129,2475),(22130,2475),(22131,2475),(22132,2476),(22133,2476),(22134,2476),(22135,2477),(22136,2477),(22137,2477),(22138,2478),(22139,2478),(22140,2478),(22141,2479),(22142,2479),(22143,2479),(22144,2480),(22145,2480),(22146,2480),(22147,2481),(22148,2481),(22149,2481),(22150,2482),(22151,2482),(22152,2482),(22153,2483),(22154,2483),(22155,2483),(22156,2484),(22157,2484),(22158,2484),(22159,2485),(22160,2485),(22161,2485),(22162,2486),(22163,2486),(22164,2486),(22165,2487),(22166,2487),(22167,2487),(22168,2488),(22169,2488),(22170,2488),(22171,2489),(22172,2489),(22173,2489),(22174,2490),(22175,2490),(22176,2490),(22177,2491),(22178,2491),(22179,2491),(22180,2492),(22181,2492),(22182,2492),(22183,2493),(22184,2493),(22185,2493),(22186,2494),(22187,2494),(22188,2494),(22189,2495),(22190,2495),(22191,2495),(22192,2496),(22193,2496),(22194,2496),(22195,2497),(22196,2497),(22197,2497),(22198,2498),(22199,2498),(22200,2498),(22201,2499),(22202,2499),(22203,2499),(22204,2500),(22205,2500),(22206,2500),(22207,2501),(22208,2501),(22209,2501),(22210,2502),(22211,2502),(22212,2502),(22213,2503),(22214,2503),(22215,2503),(22216,2504),(22217,2504),(22218,2504),(22219,2505),(22220,2505),(22221,2505),(22222,2506),(22223,2506),(22224,2506),(22225,2507),(22226,2507),(22227,2507),(22228,2508),(22229,2508),(22230,2508),(22231,2509),(22232,2509),(22233,2509),(22234,2510),(22235,2510),(22236,2510),(22237,2411),(22238,2411),(22239,2411),(22240,2411),(22241,2412),(22242,2412),(22243,2412),(22244,2412),(22245,2413),(22246,2413),(22247,2413),(22248,2413),(22249,2414),(22250,2414),(22251,2414),(22252,2414),(22253,2415),(22254,2415),(22255,2415),(22256,2415),(22257,2416),(22258,2416),(22259,2416),(22260,2416),(22261,2417),(22262,2417),(22263,2417),(22264,2417),(22265,2418),(22266,2418),(22267,2418),(22268,2418),(22269,2419),(22270,2419),(22271,2419),(22272,2419),(22273,2420),(22274,2420),(22275,2420),(22276,2420),(22277,2421),(22278,2421),(22279,2421),(22280,2421),(22281,2422),(22282,2422),(22283,2422),(22284,2422),(22285,2423),(22286,2423),(22287,2423),(22288,2423),(22289,2424),(22290,2424),(22291,2424),(22292,2424),(22293,2425),(22294,2425),(22295,2425),(22296,2425),(22297,2426),(22298,2426),(22299,2426),(22300,2426),(22301,2427),(22302,2427),(22303,2427),(22304,2427),(22305,2428),(22306,2428),(22307,2428),(22308,2428),(22309,2429),(22310,2429),(22311,2429),(22312,2429),(22313,2430),(22314,2430),(22315,2430),(22316,2430),(22317,2431),(22318,2431),(22319,2431),(22320,2431),(22321,2432),(22322,2432),(22323,2432),(22324,2432),(22325,2433),(22326,2433),(22327,2433),(22328,2433),(22329,2434),(22330,2434),(22331,2434),(22332,2434),(22333,2435),(22334,2435),(22335,2435),(22336,2435),(22337,2436),(22338,2436),(22339,2436),(22340,2436),(22341,2437),(22342,2437),(22343,2437),(22344,2437),(22345,2438),(22346,2438),(22347,2438),(22348,2438),(22349,2439),(22350,2439),(22351,2439),(22352,2439),(22353,2440),(22354,2440),(22355,2440),(22356,2440),(22357,2441),(22358,2441),(22359,2441),(22360,2441),(22361,2442),(22362,2442),(22363,2442),(22364,2442),(22365,2443),(22366,2443),(22367,2443),(22368,2443),(22369,2444),(22370,2444),(22371,2444),(22372,2444),(22373,2445),(22374,2445),(22375,2445),(22376,2445),(22377,2446),(22378,2446),(22379,2446),(22380,2446),(22381,2447),(22382,2447),(22383,2447),(22384,2447),(22385,2448),(22386,2448),(22387,2448),(22388,2448),(22389,2449),(22390,2449),(22391,2449),(22392,2449),(22393,2450),(22394,2450),(22395,2450),(22396,2450),(22397,2451),(22398,2451),(22399,2451),(22400,2451),(22401,2452),(22402,2452),(22403,2452),(22404,2452),(22405,2453),(22406,2453),(22407,2453),(22408,2453),(22409,2454),(22410,2454),(22411,2454),(22412,2454),(22413,2455),(22414,2455),(22415,2455),(22416,2455),(22417,2456),(22418,2456),(22419,2456),(22420,2456),(22421,2457),(22422,2457),(22423,2457),(22424,2457),(22425,2458),(22426,2458),(22427,2458),(22428,2458),(22429,2459),(22430,2459),(22431,2459),(22432,2459),(22433,2460),(22434,2460),(22435,2460),(22436,2460),(22437,2461),(22438,2461),(22439,2461),(22440,2461),(22441,2462),(22442,2462),(22443,2462),(22444,2462),(22445,2463),(22446,2463),(22447,2463),(22448,2463),(22449,2464),(22450,2464),(22451,2464),(22452,2464),(22453,2465),(22454,2465),(22455,2465),(22456,2465),(22457,2466),(22458,2466),(22459,2466),(22460,2466),(22461,2467),(22462,2467),(22463,2467),(22464,2467),(22465,2468),(22466,2468),(22467,2468),(22468,2468),(22469,2469),(22470,2469),(22471,2469),(22472,2469),(22473,2470),(22474,2470),(22475,2470),(22476,2470),(22477,2471),(22478,2471),(22479,2471),(22480,2471),(22481,2472),(22482,2472),(22483,2472),(22484,2472),(22485,2473),(22486,2473),(22487,2473),(22488,2473),(22489,2474),(22490,2474),(22491,2474),(22492,2474),(22493,2475),(22494,2475),(22495,2475),(22496,2475),(22497,2476),(22498,2476),(22499,2476),(22500,2476),(22501,2477),(22502,2477),(22503,2477),(22504,2477),(22505,2478),(22506,2478),(22507,2478),(22508,2478),(22509,2479),(22510,2479),(22511,2479),(22512,2479),(22513,2480),(22514,2480),(22515,2480),(22516,2480),(22517,2481),(22518,2481),(22519,2481),(22520,2481),(22521,2482),(22522,2482),(22523,2482),(22524,2482),(22525,2483),(22526,2483),(22527,2483),(22528,2483),(22529,2484),(22530,2484),(22531,2484),(22532,2484),(22533,2485),(22534,2485),(22535,2485),(22536,2485),(22537,2486),(22538,2486),(22539,2486),(22540,2486),(22541,2487),(22542,2487),(22543,2487),(22544,2487),(22545,2488),(22546,2488),(22547,2488),(22548,2488),(22549,2489),(22550,2489),(22551,2489),(22552,2489),(22553,2490),(22554,2490),(22555,2490),(22556,2490),(22557,2491),(22558,2491),(22559,2491),(22560,2491),(22561,2492),(22562,2492),(22563,2492),(22564,2492),(22565,2493),(22566,2493),(22567,2493),(22568,2493),(22569,2494),(22570,2494),(22571,2494),(22572,2494),(22573,2495),(22574,2495),(22575,2495),(22576,2495),(22577,2496),(22578,2496),(22579,2496),(22580,2496),(22581,2497),(22582,2497),(22583,2497),(22584,2497),(22585,2498),(22586,2498),(22587,2498),(22588,2498),(22589,2499),(22590,2499),(22591,2499),(22592,2499),(22593,2500),(22594,2500),(22595,2500),(22596,2500),(22597,2501),(22598,2501),(22599,2501),(22600,2501),(22601,2502),(22602,2502),(22603,2502),(22604,2502),(22605,2503),(22606,2503),(22607,2503),(22608,2503),(22609,2504),(22610,2504),(22611,2504),(22612,2504),(22613,2505),(22614,2505),(22615,2505),(22616,2505),(22617,2506),(22618,2506),(22619,2506),(22620,2506),(22621,2507),(22622,2507),(22623,2507),(22624,2507),(22625,2508),(22626,2508),(22627,2508),(22628,2508),(22629,2509),(22630,2509),(22631,2509),(22632,2509),(22633,2510),(22634,2510),(22635,2510),(22636,2510),(22637,2511),(22638,2512),(22639,2513),(22640,2514),(22641,2515),(22642,2516),(22643,2517),(22644,2518),(22645,2519),(22646,2520),(22647,2521),(22648,2522),(22649,2523),(22650,2524),(22651,2525),(22652,2526),(22653,2527),(22654,2528),(22655,2529),(22656,2530),(22657,2531),(22658,2532),(22659,2533),(22660,2534),(22661,2535),(22662,2536),(22663,2537),(22664,2538),(22665,2539),(22666,2540),(22667,2541),(22668,2542),(22669,2543),(22670,2544),(22671,2545),(22672,2546),(22673,2547),(22674,2548),(22675,2549),(22676,2550),(22677,2551),(22678,2552),(22679,2553),(22680,2554),(22681,2555),(22682,2556),(22683,2557),(22684,2558),(22685,2559),(22686,2560),(22687,2561),(22688,2562),(22689,2563),(22690,2564),(22691,2565),(22692,2566),(22693,2567),(22694,2568),(22695,2569),(22696,2570),(22697,2571),(22698,2572),(22699,2573),(22700,2574),(22701,2575),(22702,2576),(22703,2577),(22704,2578),(22705,2579),(22706,2580),(22707,2581),(22708,2582),(22709,2583),(22710,2584),(22711,2585),(22712,2586),(22713,2587),(22714,2588),(22715,2589),(22716,2590),(22717,2591),(22718,2592),(22719,2593),(22720,2594),(22721,2595),(22722,2596),(22723,2597),(22724,2598),(22725,2599),(22726,2600),(22727,2601),(22728,2602),(22729,2603),(22730,2604),(22731,2605),(22732,2606),(22733,2607),(22734,2608),(22735,2609),(22736,2610),(22737,2511),(22738,2512),(22739,2513),(22740,2514),(22741,2515),(22742,2516),(22743,2517),(22744,2518),(22745,2519),(22746,2520),(22747,2521),(22748,2522),(22749,2523),(22750,2524),(22751,2525),(22752,2526),(22753,2527),(22754,2528),(22755,2529),(22756,2530),(22757,2531),(22758,2532),(22759,2533),(22760,2534),(22761,2535),(22762,2536),(22763,2537),(22764,2538),(22765,2539),(22766,2540),(22767,2541),(22768,2542),(22769,2543),(22770,2544),(22771,2545),(22772,2546),(22773,2547),(22774,2548),(22775,2549),(22776,2550),(22777,2551),(22778,2552),(22779,2553),(22780,2554),(22781,2555),(22782,2556),(22783,2557),(22784,2558),(22785,2559),(22786,2560),(22787,2561),(22788,2562),(22789,2563),(22790,2564),(22791,2565),(22792,2566),(22793,2567),(22794,2568),(22795,2569),(22796,2570),(22797,2571),(22798,2572),(22799,2573),(22800,2574),(22801,2575),(22802,2576),(22803,2577),(22804,2578),(22805,2579),(22806,2580),(22807,2581),(22808,2582),(22809,2583),(22810,2584),(22811,2585),(22812,2586),(22813,2587),(22814,2588),(22815,2589),(22816,2590),(22817,2591),(22818,2592),(22819,2593),(22820,2594),(22821,2595),(22822,2596),(22823,2597),(22824,2598),(22825,2599),(22826,2600),(22827,2601),(22828,2602),(22829,2603),(22830,2604),(22831,2605),(22832,2606),(22833,2607),(22834,2608),(22835,2609),(22836,2610),(22837,2511),(22838,2511),(22839,2511),(22840,2512),(22841,2512),(22842,2512),(22843,2513),(22844,2513),(22845,2513),(22846,2514),(22847,2514),(22848,2514),(22849,2515),(22850,2515),(22851,2515),(22852,2516),(22853,2516),(22854,2516),(22855,2517),(22856,2517),(22857,2517),(22858,2518),(22859,2518),(22860,2518),(22861,2519),(22862,2519),(22863,2519),(22864,2520),(22865,2520),(22866,2520),(22867,2521),(22868,2521),(22869,2521),(22870,2522),(22871,2522),(22872,2522),(22873,2523),(22874,2523),(22875,2523),(22876,2524),(22877,2524),(22878,2524),(22879,2525),(22880,2525),(22881,2525),(22882,2526),(22883,2526),(22884,2526),(22885,2527),(22886,2527),(22887,2527),(22888,2528),(22889,2528),(22890,2528),(22891,2529),(22892,2529),(22893,2529),(22894,2530),(22895,2530),(22896,2530),(22897,2531),(22898,2531),(22899,2531),(22900,2532),(22901,2532),(22902,2532),(22903,2533),(22904,2533),(22905,2533),(22906,2534),(22907,2534),(22908,2534),(22909,2535),(22910,2535),(22911,2535),(22912,2536),(22913,2536),(22914,2536),(22915,2537),(22916,2537),(22917,2537),(22918,2538),(22919,2538),(22920,2538),(22921,2539),(22922,2539),(22923,2539),(22924,2540),(22925,2540),(22926,2540),(22927,2541),(22928,2541),(22929,2541),(22930,2542),(22931,2542),(22932,2542),(22933,2543),(22934,2543),(22935,2543),(22936,2544),(22937,2544),(22938,2544),(22939,2545),(22940,2545),(22941,2545),(22942,2546),(22943,2546),(22944,2546),(22945,2547),(22946,2547),(22947,2547),(22948,2548),(22949,2548),(22950,2548),(22951,2549),(22952,2549),(22953,2549),(22954,2550),(22955,2550),(22956,2550),(22957,2551),(22958,2551),(22959,2551),(22960,2552),(22961,2552),(22962,2552),(22963,2553),(22964,2553),(22965,2553),(22966,2554),(22967,2554),(22968,2554),(22969,2555),(22970,2555),(22971,2555),(22972,2556),(22973,2556),(22974,2556),(22975,2557),(22976,2557),(22977,2557),(22978,2558),(22979,2558),(22980,2558),(22981,2559),(22982,2559),(22983,2559),(22984,2560),(22985,2560),(22986,2560),(22987,2561),(22988,2561),(22989,2561),(22990,2562),(22991,2562),(22992,2562),(22993,2563),(22994,2563),(22995,2563),(22996,2564),(22997,2564),(22998,2564),(22999,2565),(23000,2565),(23001,2565),(23002,2566),(23003,2566),(23004,2566),(23005,2567),(23006,2567),(23007,2567),(23008,2568),(23009,2568),(23010,2568),(23011,2569),(23012,2569),(23013,2569),(23014,2570),(23015,2570),(23016,2570),(23017,2571),(23018,2571),(23019,2571),(23020,2572),(23021,2572),(23022,2572),(23023,2573),(23024,2573),(23025,2573),(23026,2574),(23027,2574),(23028,2574),(23029,2575),(23030,2575),(23031,2575),(23032,2576),(23033,2576),(23034,2576),(23035,2577),(23036,2577),(23037,2577),(23038,2578),(23039,2578),(23040,2578),(23041,2579),(23042,2579),(23043,2579),(23044,2580),(23045,2580),(23046,2580),(23047,2581),(23048,2581),(23049,2581),(23050,2582),(23051,2582),(23052,2582),(23053,2583),(23054,2583),(23055,2583),(23056,2584),(23057,2584),(23058,2584),(23059,2585),(23060,2585),(23061,2585),(23062,2586),(23063,2586),(23064,2586),(23065,2587),(23066,2587),(23067,2587),(23068,2588),(23069,2588),(23070,2588),(23071,2589),(23072,2589),(23073,2589),(23074,2590),(23075,2590),(23076,2590),(23077,2591),(23078,2591),(23079,2591),(23080,2592),(23081,2592),(23082,2592),(23083,2593),(23084,2593),(23085,2593),(23086,2594),(23087,2594),(23088,2594),(23089,2595),(23090,2595),(23091,2595),(23092,2596),(23093,2596),(23094,2596),(23095,2597),(23096,2597),(23097,2597),(23098,2598),(23099,2598),(23100,2598),(23101,2599),(23102,2599),(23103,2599),(23104,2600),(23105,2600),(23106,2600),(23107,2601),(23108,2601),(23109,2601),(23110,2602),(23111,2602),(23112,2602),(23113,2603),(23114,2603),(23115,2603),(23116,2604),(23117,2604),(23118,2604),(23119,2605),(23120,2605),(23121,2605),(23122,2606),(23123,2606),(23124,2606),(23125,2607),(23126,2607),(23127,2607),(23128,2608),(23129,2608),(23130,2608),(23131,2609),(23132,2609),(23133,2609),(23134,2610),(23135,2610),(23136,2610),(23137,2511),(23138,2511),(23139,2511),(23140,2511),(23141,2512),(23142,2512),(23143,2512),(23144,2512),(23145,2513),(23146,2513),(23147,2513),(23148,2513),(23149,2514),(23150,2514),(23151,2514),(23152,2514),(23153,2515),(23154,2515),(23155,2515),(23156,2515),(23157,2516),(23158,2516),(23159,2516),(23160,2516),(23161,2517),(23162,2517),(23163,2517),(23164,2517),(23165,2518),(23166,2518),(23167,2518),(23168,2518),(23169,2519),(23170,2519),(23171,2519),(23172,2519),(23173,2520),(23174,2520),(23175,2520),(23176,2520),(23177,2521),(23178,2521),(23179,2521),(23180,2521),(23181,2522),(23182,2522),(23183,2522),(23184,2522),(23185,2523),(23186,2523),(23187,2523),(23188,2523),(23189,2524),(23190,2524),(23191,2524),(23192,2524),(23193,2525),(23194,2525),(23195,2525),(23196,2525),(23197,2526),(23198,2526),(23199,2526),(23200,2526),(23201,2527),(23202,2527),(23203,2527),(23204,2527),(23205,2528),(23206,2528),(23207,2528),(23208,2528),(23209,2529),(23210,2529),(23211,2529),(23212,2529),(23213,2530),(23214,2530),(23215,2530),(23216,2530),(23217,2531),(23218,2531),(23219,2531),(23220,2531),(23221,2532),(23222,2532),(23223,2532),(23224,2532),(23225,2533),(23226,2533),(23227,2533),(23228,2533),(23229,2534),(23230,2534),(23231,2534),(23232,2534),(23233,2535),(23234,2535),(23235,2535),(23236,2535),(23237,2536),(23238,2536),(23239,2536),(23240,2536),(23241,2537),(23242,2537),(23243,2537),(23244,2537),(23245,2538),(23246,2538),(23247,2538),(23248,2538),(23249,2539),(23250,2539),(23251,2539),(23252,2539),(23253,2540),(23254,2540),(23255,2540),(23256,2540),(23257,2541),(23258,2541),(23259,2541),(23260,2541),(23261,2542),(23262,2542),(23263,2542),(23264,2542),(23265,2543),(23266,2543),(23267,2543),(23268,2543),(23269,2544),(23270,2544),(23271,2544),(23272,2544),(23273,2545),(23274,2545),(23275,2545),(23276,2545),(23277,2546),(23278,2546),(23279,2546),(23280,2546),(23281,2547),(23282,2547),(23283,2547),(23284,2547),(23285,2548),(23286,2548),(23287,2548),(23288,2548),(23289,2549),(23290,2549),(23291,2549),(23292,2549),(23293,2550),(23294,2550),(23295,2550),(23296,2550),(23297,2551),(23298,2551),(23299,2551),(23300,2551),(23301,2552),(23302,2552),(23303,2552),(23304,2552),(23305,2553),(23306,2553),(23307,2553),(23308,2553),(23309,2554),(23310,2554),(23311,2554),(23312,2554),(23313,2555),(23314,2555),(23315,2555),(23316,2555),(23317,2556),(23318,2556),(23319,2556),(23320,2556),(23321,2557),(23322,2557),(23323,2557),(23324,2557),(23325,2558),(23326,2558),(23327,2558),(23328,2558),(23329,2559),(23330,2559),(23331,2559),(23332,2559),(23333,2560),(23334,2560),(23335,2560),(23336,2560),(23337,2561),(23338,2561),(23339,2561),(23340,2561),(23341,2562),(23342,2562),(23343,2562),(23344,2562),(23345,2563),(23346,2563),(23347,2563),(23348,2563),(23349,2564),(23350,2564),(23351,2564),(23352,2564),(23353,2565),(23354,2565),(23355,2565),(23356,2565),(23357,2566),(23358,2566),(23359,2566),(23360,2566),(23361,2567),(23362,2567),(23363,2567),(23364,2567),(23365,2568),(23366,2568),(23367,2568),(23368,2568),(23369,2569),(23370,2569),(23371,2569),(23372,2569),(23373,2570),(23374,2570),(23375,2570),(23376,2570),(23377,2571),(23378,2571),(23379,2571),(23380,2571),(23381,2572),(23382,2572),(23383,2572),(23384,2572),(23385,2573),(23386,2573),(23387,2573),(23388,2573),(23389,2574),(23390,2574),(23391,2574),(23392,2574),(23393,2575),(23394,2575),(23395,2575),(23396,2575),(23397,2576),(23398,2576),(23399,2576),(23400,2576),(23401,2577),(23402,2577),(23403,2577),(23404,2577),(23405,2578),(23406,2578),(23407,2578),(23408,2578),(23409,2579),(23410,2579),(23411,2579),(23412,2579),(23413,2580),(23414,2580),(23415,2580),(23416,2580),(23417,2581),(23418,2581),(23419,2581),(23420,2581),(23421,2582),(23422,2582),(23423,2582),(23424,2582),(23425,2583),(23426,2583),(23427,2583),(23428,2583),(23429,2584),(23430,2584),(23431,2584),(23432,2584),(23433,2585),(23434,2585),(23435,2585),(23436,2585),(23437,2586),(23438,2586),(23439,2586),(23440,2586),(23441,2587),(23442,2587),(23443,2587),(23444,2587),(23445,2588),(23446,2588),(23447,2588),(23448,2588),(23449,2589),(23450,2589),(23451,2589),(23452,2589),(23453,2590),(23454,2590),(23455,2590),(23456,2590),(23457,2591),(23458,2591),(23459,2591),(23460,2591),(23461,2592),(23462,2592),(23463,2592),(23464,2592),(23465,2593),(23466,2593),(23467,2593),(23468,2593),(23469,2594),(23470,2594),(23471,2594),(23472,2594),(23473,2595),(23474,2595),(23475,2595),(23476,2595),(23477,2596),(23478,2596),(23479,2596),(23480,2596),(23481,2597),(23482,2597),(23483,2597),(23484,2597),(23485,2598),(23486,2598),(23487,2598),(23488,2598),(23489,2599),(23490,2599),(23491,2599),(23492,2599),(23493,2600),(23494,2600),(23495,2600),(23496,2600),(23497,2601),(23498,2601),(23499,2601),(23500,2601),(23501,2602),(23502,2602),(23503,2602),(23504,2602),(23505,2603),(23506,2603),(23507,2603),(23508,2603),(23509,2604),(23510,2604),(23511,2604),(23512,2604),(23513,2605),(23514,2605),(23515,2605),(23516,2605),(23517,2606),(23518,2606),(23519,2606),(23520,2606),(23521,2607),(23522,2607),(23523,2607),(23524,2607),(23525,2608),(23526,2608),(23527,2608),(23528,2608),(23529,2609),(23530,2609),(23531,2609),(23532,2609),(23533,2610),(23534,2610),(23535,2610),(23536,2610),(23537,2611),(23538,2612),(23539,2613),(23540,2614),(23541,2615),(23542,2616),(23543,2617),(23544,2618),(23545,2619),(23546,2620),(23547,2621),(23548,2611),(23549,2612),(23550,2613),(23551,2614),(23552,2615),(23553,2616),(23554,2617),(23555,2618),(23556,2619),(23557,2620),(23558,2621),(23559,2611),(23560,2611),(23561,2611),(23562,2612),(23563,2612),(23564,2612),(23565,2613),(23566,2613),(23567,2613),(23568,2614),(23569,2614),(23570,2614),(23571,2615),(23572,2615),(23573,2615),(23574,2616),(23575,2616),(23576,2616),(23577,2617),(23578,2617),(23579,2617),(23580,2618),(23581,2618),(23582,2618),(23583,2619),(23584,2619),(23585,2619),(23586,2620),(23587,2620),(23588,2620),(23589,2621),(23590,2621),(23591,2621),(23592,2611),(23593,2611),(23594,2611),(23595,2611),(23596,2612),(23597,2612),(23598,2612),(23599,2612),(23600,2613),(23601,2613),(23602,2613),(23603,2613),(23604,2614),(23605,2614),(23606,2614),(23607,2614),(23608,2615),(23609,2615),(23610,2615),(23611,2615),(23612,2616),(23613,2616),(23614,2616),(23615,2616),(23616,2617),(23617,2617),(23618,2617),(23619,2617),(23620,2618),(23621,2618),(23622,2618),(23623,2618),(23624,2619),(23625,2619),(23626,2619),(23627,2619),(23628,2620),(23629,2620),(23630,2620),(23631,2620),(23632,2621),(23633,2621),(23634,2621),(23635,2621),(23636,2622),(23637,2623),(23638,2624),(23639,2625),(23640,2626),(23641,2627),(23642,2628),(23643,2629),(23644,2630),(23645,2631),(23646,2632),(23647,2633),(23648,2634),(23649,2635),(23650,2636),(23651,2637),(23652,2638),(23653,2639),(23654,2640),(23655,2641),(23656,2642),(23657,2643),(23658,2644),(23659,2645),(23660,2646),(23661,2647),(23662,2648),(23663,2649),(23664,2650),(23665,2651),(23666,2652),(23667,2653),(23668,2654),(23669,2655),(23670,2656),(23671,2657),(23672,2658),(23673,2659),(23674,2660),(23675,2661),(23676,2662),(23677,2663),(23678,2664),(23679,2665),(23680,2666),(23681,2667),(23682,2668),(23683,2669),(23684,2670),(23685,2671),(23686,2672),(23687,2673),(23688,2674),(23689,2675),(23690,2676),(23691,2677),(23692,2678),(23693,2679),(23694,2680),(23695,2681),(23696,2682),(23697,2683),(23698,2684),(23699,2685),(23700,2686),(23701,2687),(23702,2688),(23703,2689),(23704,2690),(23705,2691),(23706,2692),(23707,2693),(23708,2694),(23709,2695),(23710,2696),(23711,2697),(23712,2698),(23713,2699),(23714,2700),(23715,2701),(23716,2702),(23717,2703),(23718,2704),(23719,2705),(23720,2706),(23721,2707),(23722,2708),(23723,2709),(23724,2710),(23725,2711),(23726,2712),(23727,2713),(23728,2714),(23729,2715),(23730,2716),(23731,2717),(23732,2718),(23733,2719),(23734,2720),(23735,2721),(23736,2622),(23737,2623),(23738,2624),(23739,2625),(23740,2626),(23741,2627),(23742,2628),(23743,2629),(23744,2630),(23745,2631),(23746,2632),(23747,2633),(23748,2634),(23749,2635),(23750,2636),(23751,2637),(23752,2638),(23753,2639),(23754,2640),(23755,2641),(23756,2642),(23757,2643),(23758,2644),(23759,2645),(23760,2646),(23761,2647),(23762,2648),(23763,2649),(23764,2650),(23765,2651),(23766,2652),(23767,2653),(23768,2654),(23769,2655),(23770,2656),(23771,2657),(23772,2658),(23773,2659),(23774,2660),(23775,2661),(23776,2662),(23777,2663),(23778,2664),(23779,2665),(23780,2666),(23781,2667),(23782,2668),(23783,2669),(23784,2670),(23785,2671),(23786,2672),(23787,2673),(23788,2674),(23789,2675),(23790,2676),(23791,2677),(23792,2678),(23793,2679),(23794,2680),(23795,2681),(23796,2682),(23797,2683),(23798,2684),(23799,2685),(23800,2686),(23801,2687),(23802,2688),(23803,2689),(23804,2690),(23805,2691),(23806,2692),(23807,2693),(23808,2694),(23809,2695),(23810,2696),(23811,2697),(23812,2698),(23813,2699),(23814,2700),(23815,2701),(23816,2702),(23817,2703),(23818,2704),(23819,2705),(23820,2706),(23821,2707),(23822,2708),(23823,2709),(23824,2710),(23825,2711),(23826,2712),(23827,2713),(23828,2714),(23829,2715),(23830,2716),(23831,2717),(23832,2718),(23833,2719),(23834,2720),(23835,2721),(23836,2622),(23837,2622),(23838,2622),(23839,2623),(23840,2623),(23841,2623),(23842,2624),(23843,2624),(23844,2624),(23845,2625),(23846,2625),(23847,2625),(23848,2626),(23849,2626),(23850,2626),(23851,2627),(23852,2627),(23853,2627),(23854,2628),(23855,2628),(23856,2628),(23857,2629),(23858,2629),(23859,2629),(23860,2630),(23861,2630),(23862,2630),(23863,2631),(23864,2631),(23865,2631),(23866,2632),(23867,2632),(23868,2632),(23869,2633),(23870,2633),(23871,2633),(23872,2634),(23873,2634),(23874,2634),(23875,2635),(23876,2635),(23877,2635),(23878,2636),(23879,2636),(23880,2636),(23881,2637),(23882,2637),(23883,2637),(23884,2638),(23885,2638),(23886,2638),(23887,2639),(23888,2639),(23889,2639),(23890,2640),(23891,2640),(23892,2640),(23893,2641),(23894,2641),(23895,2641),(23896,2642),(23897,2642),(23898,2642),(23899,2643),(23900,2643),(23901,2643),(23902,2644),(23903,2644),(23904,2644),(23905,2645),(23906,2645),(23907,2645),(23908,2646),(23909,2646),(23910,2646),(23911,2647),(23912,2647),(23913,2647),(23914,2648),(23915,2648),(23916,2648),(23917,2649),(23918,2649),(23919,2649),(23920,2650),(23921,2650),(23922,2650),(23923,2651),(23924,2651),(23925,2651),(23926,2652),(23927,2652),(23928,2652),(23929,2653),(23930,2653),(23931,2653),(23932,2654),(23933,2654),(23934,2654),(23935,2655),(23936,2655),(23937,2655),(23938,2656),(23939,2656),(23940,2656),(23941,2657),(23942,2657),(23943,2657),(23944,2658),(23945,2658),(23946,2658),(23947,2659),(23948,2659),(23949,2659),(23950,2660),(23951,2660),(23952,2660),(23953,2661),(23954,2661),(23955,2661),(23956,2662),(23957,2662),(23958,2662),(23959,2663),(23960,2663),(23961,2663),(23962,2664),(23963,2664),(23964,2664),(23965,2665),(23966,2665),(23967,2665),(23968,2666),(23969,2666),(23970,2666),(23971,2667),(23972,2667),(23973,2667),(23974,2668),(23975,2668),(23976,2668),(23977,2669),(23978,2669),(23979,2669),(23980,2670),(23981,2670),(23982,2670),(23983,2671),(23984,2671),(23985,2671),(23986,2672),(23987,2672),(23988,2672),(23989,2673),(23990,2673),(23991,2673),(23992,2674),(23993,2674),(23994,2674),(23995,2675),(23996,2675),(23997,2675),(23998,2676),(23999,2676),(24000,2676),(24001,2677),(24002,2677),(24003,2677),(24004,2678),(24005,2678),(24006,2678),(24007,2679),(24008,2679),(24009,2679),(24010,2680),(24011,2680),(24012,2680),(24013,2681),(24014,2681),(24015,2681),(24016,2682),(24017,2682),(24018,2682),(24019,2683),(24020,2683),(24021,2683),(24022,2684),(24023,2684),(24024,2684),(24025,2685),(24026,2685),(24027,2685),(24028,2686),(24029,2686),(24030,2686),(24031,2687),(24032,2687),(24033,2687),(24034,2688),(24035,2688),(24036,2688),(24037,2689),(24038,2689),(24039,2689),(24040,2690),(24041,2690),(24042,2690),(24043,2691),(24044,2691),(24045,2691),(24046,2692),(24047,2692),(24048,2692),(24049,2693),(24050,2693),(24051,2693),(24052,2694),(24053,2694),(24054,2694),(24055,2695),(24056,2695),(24057,2695),(24058,2696),(24059,2696),(24060,2696),(24061,2697),(24062,2697),(24063,2697),(24064,2698),(24065,2698),(24066,2698),(24067,2699),(24068,2699),(24069,2699),(24070,2700),(24071,2700),(24072,2700),(24073,2701),(24074,2701),(24075,2701),(24076,2702),(24077,2702),(24078,2702),(24079,2703),(24080,2703),(24081,2703),(24082,2704),(24083,2704),(24084,2704),(24085,2705),(24086,2705),(24087,2705),(24088,2706),(24089,2706),(24090,2706),(24091,2707),(24092,2707),(24093,2708),(24094,2708),(24095,2708),(24096,2709),(24097,2709),(24098,2709),(24099,2710),(24100,2710),(24101,2710),(24102,2711),(24103,2711),(24104,2711),(24105,2712),(24106,2712),(24107,2712),(24108,2713),(24109,2713),(24110,2713),(24111,2714),(24112,2714),(24113,2714),(24114,2715),(24115,2715),(24116,2715),(24117,2716),(24118,2716),(24119,2716),(24120,2717),(24121,2717),(24122,2717),(24123,2718),(24124,2718),(24125,2718),(24126,2719),(24127,2719),(24128,2719),(24129,2720),(24130,2720),(24131,2720),(24132,2721),(24133,2721),(24134,2721),(24135,2622),(24136,2622),(24137,2622),(24138,2622),(24139,2623),(24140,2623),(24141,2623),(24142,2623),(24143,2624),(24144,2624),(24145,2624),(24146,2624),(24147,2625),(24148,2625),(24149,2625),(24150,2625),(24151,2626),(24152,2626),(24153,2626),(24154,2626),(24155,2627),(24156,2627),(24157,2627),(24158,2627),(24159,2628),(24160,2628),(24161,2628),(24162,2628),(24163,2629),(24164,2629),(24165,2629),(24166,2629),(24167,2630),(24168,2630),(24169,2630),(24170,2630),(24171,2631),(24172,2631),(24173,2631),(24174,2631),(24175,2632),(24176,2632),(24177,2632),(24178,2632),(24179,2633),(24180,2633),(24181,2633),(24182,2633),(24183,2634),(24184,2634),(24185,2634),(24186,2634),(24187,2635),(24188,2635),(24189,2635),(24190,2635),(24191,2636),(24192,2636),(24193,2636),(24194,2636),(24195,2637),(24196,2637),(24197,2637),(24198,2637),(24199,2638),(24200,2638),(24201,2638),(24202,2638),(24203,2639),(24204,2639),(24205,2639),(24206,2639),(24207,2640),(24208,2640),(24209,2640),(24210,2640),(24211,2641),(24212,2641),(24213,2641),(24214,2641),(24215,2642),(24216,2642),(24217,2642),(24218,2642),(24219,2643),(24220,2643),(24221,2643),(24222,2643),(24223,2644),(24224,2644),(24225,2644),(24226,2644),(24227,2645),(24228,2645),(24229,2645),(24230,2645),(24231,2646),(24232,2646),(24233,2646),(24234,2646),(24235,2647),(24236,2647),(24237,2647),(24238,2647),(24239,2648),(24240,2648),(24241,2648),(24242,2648),(24243,2649),(24244,2649),(24245,2649),(24246,2649),(24247,2650),(24248,2650),(24249,2650),(24250,2650),(24251,2651),(24252,2651),(24253,2651),(24254,2651),(24255,2652),(24256,2652),(24257,2652),(24258,2652),(24259,2653),(24260,2653),(24261,2653),(24262,2653),(24263,2654),(24264,2654),(24265,2654),(24266,2654),(24267,2655),(24268,2655),(24269,2655),(24270,2655),(24271,2656),(24272,2656),(24273,2656),(24274,2656),(24275,2657),(24276,2657),(24277,2657),(24278,2657),(24279,2658),(24280,2658),(24281,2658),(24282,2658),(24283,2659),(24284,2659),(24285,2659),(24286,2659),(24287,2660),(24288,2660),(24289,2660),(24290,2660),(24291,2661),(24292,2661),(24293,2661),(24294,2661),(24295,2662),(24296,2662),(24297,2662),(24298,2662),(24299,2663),(24300,2663),(24301,2663),(24302,2663),(24303,2664),(24304,2664),(24305,2664),(24306,2664),(24307,2665),(24308,2665),(24309,2665),(24310,2665),(24311,2666),(24312,2666),(24313,2666),(24314,2666),(24315,2667),(24316,2667),(24317,2667),(24318,2667),(24319,2668),(24320,2668),(24321,2668),(24322,2668),(24323,2669),(24324,2669),(24325,2669),(24326,2669),(24327,2670),(24328,2670),(24329,2670),(24330,2670),(24331,2671),(24332,2671),(24333,2671),(24334,2671),(24335,2672),(24336,2672),(24337,2672),(24338,2672),(24339,2673),(24340,2673),(24341,2673),(24342,2673),(24343,2674),(24344,2674),(24345,2674),(24346,2674),(24347,2675),(24348,2675),(24349,2675),(24350,2675),(24351,2676),(24352,2676),(24353,2676),(24354,2676),(24355,2677),(24356,2677),(24357,2677),(24358,2677),(24359,2678),(24360,2678),(24361,2678),(24362,2678),(24363,2679),(24364,2679),(24365,2679),(24366,2679),(24367,2680),(24368,2680),(24369,2680),(24370,2680),(24371,2681),(24372,2681),(24373,2681),(24374,2681),(24375,2682),(24376,2682),(24377,2682),(24378,2682),(24379,2683),(24380,2683),(24381,2683),(24382,2683),(24383,2684),(24384,2684),(24385,2684),(24386,2684),(24387,2685),(24388,2685),(24389,2685),(24390,2685),(24391,2686),(24392,2686),(24393,2686),(24394,2686),(24395,2687),(24396,2687),(24397,2687),(24398,2687),(24399,2688),(24400,2688),(24401,2688),(24402,2688),(24403,2689),(24404,2689),(24405,2689),(24406,2689),(24407,2690),(24408,2690),(24409,2690),(24410,2690),(24411,2691),(24412,2691),(24413,2691),(24414,2691),(24415,2692),(24416,2692),(24417,2692),(24418,2692),(24419,2693),(24420,2693),(24421,2693),(24422,2693),(24423,2694),(24424,2694),(24425,2694),(24426,2694),(24427,2695),(24428,2695),(24429,2695),(24430,2695),(24431,2696),(24432,2696),(24433,2696),(24434,2696),(24435,2697),(24436,2697),(24437,2697),(24438,2697),(24439,2698),(24440,2698),(24441,2698),(24442,2698),(24443,2699),(24444,2699),(24445,2699),(24446,2699),(24447,2700),(24448,2700),(24449,2700),(24450,2700),(24451,2701),(24452,2701),(24453,2701),(24454,2701),(24455,2702),(24456,2702),(24457,2702),(24458,2702),(24459,2703),(24460,2703),(24461,2703),(24462,2703),(24463,2704),(24464,2704),(24465,2704),(24466,2704),(24467,2705),(24468,2705),(24469,2705),(24470,2705),(24471,2706),(24472,2706),(24473,2706),(24474,2706),(24475,2707),(24476,2707),(24477,2707),(24478,2707),(24479,2708),(24480,2708),(24481,2708),(24482,2708),(24483,2709),(24484,2709),(24485,2709),(24486,2709),(24487,2710),(24488,2710),(24489,2710),(24490,2710),(24491,2711),(24492,2711),(24493,2711),(24494,2711),(24495,2712),(24496,2712),(24497,2712),(24498,2712),(24499,2713),(24500,2713),(24501,2713),(24502,2713),(24503,2714),(24504,2714),(24505,2714),(24506,2714),(24507,2715),(24508,2715),(24509,2715),(24510,2715),(24511,2716),(24512,2716),(24513,2716),(24514,2716),(24515,2717),(24516,2717),(24517,2717),(24518,2717),(24519,2718),(24520,2718),(24521,2718),(24522,2718),(24523,2719),(24524,2719),(24525,2719),(24526,2719),(24527,2720),(24528,2720),(24529,2720),(24530,2720),(24531,2721),(24532,2721),(24533,2721),(24534,2721),(24535,2722),(24536,2723),(24537,2724),(24538,2725),(24539,2726),(24540,2727),(24541,2728),(24542,2729),(24543,2730),(24544,2731),(24545,2732),(24546,2733),(24547,2734),(24548,2735),(24549,2736),(24550,2737),(24551,2738),(24552,2739),(24553,2740),(24554,2741),(24555,2742),(24556,2743),(24557,2744),(24558,2745),(24559,2746),(24560,2747),(24561,2748),(24562,2749),(24563,2750),(24564,2751),(24565,2752),(24566,2753),(24567,2754),(24568,2755),(24569,2756),(24570,2757),(24571,2758),(24572,2759),(24573,2760),(24574,2761),(24575,2762),(24576,2763),(24577,2764),(24578,2765),(24579,2766),(24580,2767),(24581,2768),(24582,2769),(24583,2770),(24584,2771),(24585,2772),(24586,2773),(24587,2774),(24588,2775),(24589,2776),(24590,2777),(24591,2778),(24592,2779),(24593,2780),(24594,2781),(24595,2782),(24596,2783),(24597,2784),(24598,2785),(24599,2786),(24600,2787),(24601,2788),(24602,2789),(24603,2790),(24604,2791),(24605,2792),(24606,2793),(24607,2794),(24608,2795),(24609,2796),(24610,2797),(24611,2798),(24612,2799),(24613,2800),(24614,2801),(24615,2802),(24616,2803),(24617,2804),(24618,2805),(24619,2806),(24620,2807),(24621,2808),(24622,2809),(24623,2810),(24624,2811),(24625,2812),(24626,2813),(24627,2814),(24628,2815),(24629,2816),(24630,2817),(24631,2818),(24632,2819),(24633,2820),(24634,2821),(24635,2722),(24636,2723),(24637,2724),(24638,2725),(24639,2726),(24640,2727),(24641,2728),(24642,2729),(24643,2730),(24644,2731),(24645,2732),(24646,2733),(24647,2734),(24648,2735),(24649,2736),(24650,2737),(24651,2738),(24652,2739),(24653,2740),(24654,2741),(24655,2742),(24656,2743),(24657,2744),(24658,2745),(24659,2746),(24660,2747),(24661,2748),(24662,2749),(24663,2750),(24664,2751),(24665,2752),(24666,2753),(24667,2754),(24668,2755),(24669,2756),(24670,2757),(24671,2758),(24672,2759),(24673,2760),(24674,2761),(24675,2762),(24676,2763),(24677,2764),(24678,2765),(24679,2766),(24680,2767),(24681,2768),(24682,2769),(24683,2770),(24684,2771),(24685,2772),(24686,2773),(24687,2774),(24688,2775),(24689,2776),(24690,2777),(24691,2778),(24692,2779),(24693,2780),(24694,2781),(24695,2782),(24696,2783),(24697,2784),(24698,2785),(24699,2786),(24700,2787),(24701,2788),(24702,2789),(24703,2790),(24704,2791),(24705,2792),(24706,2793),(24707,2794),(24708,2795),(24709,2796),(24710,2797),(24711,2798),(24712,2799),(24713,2800),(24714,2801),(24715,2802),(24716,2803),(24717,2804),(24718,2805),(24719,2806),(24720,2807),(24721,2808),(24722,2809),(24723,2810),(24724,2811),(24725,2812),(24726,2813),(24727,2814),(24728,2815),(24729,2816),(24730,2817),(24731,2818),(24732,2819),(24733,2820),(24734,2821),(24735,2722),(24736,2722),(24737,2722),(24738,2723),(24739,2723),(24740,2723),(24741,2724),(24742,2724),(24743,2724),(24744,2725),(24745,2725),(24746,2725),(24747,2726),(24748,2726),(24749,2726),(24750,2727),(24751,2727),(24752,2727),(24753,2728),(24754,2728),(24755,2728),(24756,2729),(24757,2729),(24758,2729),(24759,2730),(24760,2730),(24761,2730),(24762,2731),(24763,2731),(24764,2731),(24765,2732),(24766,2732),(24767,2732),(24768,2733),(24769,2733),(24770,2733),(24771,2734),(24772,2734),(24773,2734),(24774,2735),(24775,2735),(24776,2735),(24777,2736),(24778,2736),(24779,2736),(24780,2737),(24781,2737),(24782,2737),(24783,2738),(24784,2738),(24785,2738),(24786,2739),(24787,2739),(24788,2739),(24789,2740),(24790,2740),(24791,2740),(24792,2741),(24793,2741),(24794,2741),(24795,2742),(24796,2742),(24797,2742),(24798,2743),(24799,2743),(24800,2743),(24801,2744),(24802,2744),(24803,2744),(24804,2745),(24805,2745),(24806,2745),(24807,2746),(24808,2746),(24809,2746),(24810,2747),(24811,2747),(24812,2747),(24813,2748),(24814,2748),(24815,2748),(24816,2749),(24817,2749),(24818,2749),(24819,2750),(24820,2750),(24821,2750),(24822,2751),(24823,2751),(24824,2751),(24825,2752),(24826,2752),(24827,2752),(24828,2753),(24829,2753),(24830,2753),(24831,2754),(24832,2754),(24833,2754),(24834,2755),(24835,2755),(24836,2755),(24837,2756),(24838,2756),(24839,2756),(24840,2757),(24841,2757),(24842,2757),(24843,2758),(24844,2758),(24845,2758),(24846,2759),(24847,2759),(24848,2759),(24849,2760),(24850,2760),(24851,2760),(24852,2761),(24853,2761),(24854,2761),(24855,2762),(24856,2762),(24857,2762),(24858,2763),(24859,2763),(24860,2763),(24861,2764),(24862,2764),(24863,2764),(24864,2765),(24865,2765),(24866,2765),(24867,2766),(24868,2766),(24869,2766),(24870,2767),(24871,2767),(24872,2767),(24873,2768),(24874,2768),(24875,2768),(24876,2769),(24877,2769),(24878,2769),(24879,2770),(24880,2770),(24881,2770),(24882,2771),(24883,2771),(24884,2771),(24885,2772),(24886,2772),(24887,2772),(24888,2773),(24889,2773),(24890,2773),(24891,2774),(24892,2774),(24893,2774),(24894,2775),(24895,2775),(24896,2775),(24897,2776),(24898,2776),(24899,2776),(24900,2777),(24901,2777),(24902,2777),(24903,2778),(24904,2778),(24905,2778),(24906,2779),(24907,2779),(24908,2779),(24909,2780),(24910,2780),(24911,2780),(24912,2781),(24913,2781),(24914,2781),(24915,2782),(24916,2782),(24917,2782),(24918,2783),(24919,2783),(24920,2783),(24921,2784),(24922,2784),(24923,2784),(24924,2785),(24925,2785),(24926,2785),(24927,2786),(24928,2786),(24929,2786),(24930,2787),(24931,2787),(24932,2787),(24933,2788),(24934,2788),(24935,2788),(24936,2789),(24937,2789),(24938,2789),(24939,2790),(24940,2790),(24941,2790),(24942,2791),(24943,2791),(24944,2791),(24945,2792),(24946,2792),(24947,2792),(24948,2793),(24949,2793),(24950,2793),(24951,2794),(24952,2794),(24953,2794),(24954,2795),(24955,2795),(24956,2795),(24957,2796),(24958,2796),(24959,2796),(24960,2797),(24961,2797),(24962,2797),(24963,2798),(24964,2798),(24965,2798),(24966,2799),(24967,2799),(24968,2799),(24969,2800),(24970,2800),(24971,2800),(24972,2801),(24973,2801),(24974,2801),(24975,2802),(24976,2802),(24977,2802),(24978,2803),(24979,2803),(24980,2803),(24981,2804),(24982,2804),(24983,2804),(24984,2805),(24985,2805),(24986,2805),(24987,2806),(24988,2806),(24989,2806),(24990,2807),(24991,2807),(24992,2807),(24993,2808),(24994,2808),(24995,2808),(24996,2809),(24997,2809),(24998,2809),(24999,2810),(25000,2810),(25001,2810),(25002,2811),(25003,2811),(25004,2811),(25005,2812),(25006,2812),(25007,2812),(25008,2813),(25009,2813),(25010,2813),(25011,2814),(25012,2814),(25013,2814),(25014,2815),(25015,2815),(25016,2815),(25017,2816),(25018,2816),(25019,2816),(25020,2817),(25021,2817),(25022,2817),(25023,2818),(25024,2818),(25025,2818),(25026,2819),(25027,2819),(25028,2819),(25029,2820),(25030,2820),(25031,2820),(25032,2821),(25033,2821),(25034,2821),(25035,2722),(25036,2722),(25037,2722),(25038,2722),(25039,2723),(25040,2723),(25041,2723),(25042,2723),(25043,2724),(25044,2724),(25045,2724),(25046,2724),(25047,2725),(25048,2725),(25049,2725),(25050,2725),(25051,2726),(25052,2726),(25053,2726),(25054,2726),(25055,2727),(25056,2727),(25057,2727),(25058,2727),(25059,2728),(25060,2728),(25061,2728),(25062,2728),(25063,2729),(25064,2729),(25065,2729),(25066,2729),(25067,2730),(25068,2730),(25069,2730),(25070,2730),(25071,2731),(25072,2731),(25073,2731),(25074,2731),(25075,2732),(25076,2732),(25077,2732),(25078,2732),(25079,2733),(25080,2733),(25081,2733),(25082,2733),(25083,2734),(25084,2734),(25085,2734),(25086,2734),(25087,2735),(25088,2735),(25089,2735),(25090,2735),(25091,2736),(25092,2736),(25093,2736),(25094,2736),(25095,2737),(25096,2737),(25097,2737),(25098,2737),(25099,2738),(25100,2738),(25101,2738),(25102,2738),(25103,2739),(25104,2739),(25105,2739),(25106,2739),(25107,2740),(25108,2740),(25109,2740),(25110,2740),(25111,2741),(25112,2741),(25113,2741),(25114,2741),(25115,2742),(25116,2742),(25117,2742),(25118,2742),(25119,2743),(25120,2743),(25121,2743),(25122,2743),(25123,2744),(25124,2744),(25125,2744),(25126,2744),(25127,2745),(25128,2745),(25129,2745),(25130,2745),(25131,2746),(25132,2746),(25133,2746),(25134,2746),(25135,2747),(25136,2747),(25137,2747),(25138,2747),(25139,2748),(25140,2748),(25141,2748),(25142,2748),(25143,2749),(25144,2749),(25145,2749),(25146,2749),(25147,2750),(25148,2750),(25149,2750),(25150,2750),(25151,2751),(25152,2751),(25153,2751),(25154,2751),(25155,2752),(25156,2752),(25157,2752),(25158,2752),(25159,2753),(25160,2753),(25161,2753),(25162,2753),(25163,2754),(25164,2754),(25165,2754),(25166,2754),(25167,2755),(25168,2755),(25169,2755),(25170,2755),(25171,2756),(25172,2756),(25173,2756),(25174,2756),(25175,2757),(25176,2757),(25177,2757),(25178,2757),(25179,2758),(25180,2758),(25181,2758),(25182,2758),(25183,2759),(25184,2759),(25185,2759),(25186,2759),(25187,2760),(25188,2760),(25189,2760),(25190,2760),(25191,2761),(25192,2761),(25193,2761),(25194,2761),(25195,2762),(25196,2762),(25197,2762),(25198,2762),(25199,2763),(25200,2763),(25201,2763),(25202,2763),(25203,2764),(25204,2764),(25205,2764),(25206,2764),(25207,2765),(25208,2765),(25209,2765),(25210,2765),(25211,2766),(25212,2766),(25213,2766),(25214,2766),(25215,2767),(25216,2767),(25217,2767),(25218,2767),(25219,2768),(25220,2768),(25221,2768),(25222,2768),(25223,2769),(25224,2769),(25225,2769),(25226,2769),(25227,2770),(25228,2770),(25229,2770),(25230,2770),(25231,2771),(25232,2771),(25233,2771),(25234,2771),(25235,2772),(25236,2772),(25237,2772),(25238,2772),(25239,2773),(25240,2773),(25241,2773),(25242,2773),(25243,2774),(25244,2774),(25245,2774),(25246,2774),(25247,2775),(25248,2775),(25249,2775),(25250,2775),(25251,2776),(25252,2776),(25253,2776),(25254,2776),(25255,2777),(25256,2777),(25257,2777),(25258,2777),(25259,2778),(25260,2778),(25261,2778),(25262,2778),(25263,2779),(25264,2779),(25265,2779),(25266,2779),(25267,2780),(25268,2780),(25269,2780),(25270,2780),(25271,2781),(25272,2781),(25273,2781),(25274,2781),(25275,2782),(25276,2782),(25277,2782),(25278,2782),(25279,2783),(25280,2783),(25281,2783),(25282,2783),(25283,2784),(25284,2784),(25285,2784),(25286,2784),(25287,2785),(25288,2785),(25289,2785),(25290,2785),(25291,2786),(25292,2786),(25293,2786),(25294,2786),(25295,2787),(25296,2787),(25297,2787),(25298,2787),(25299,2788),(25300,2788),(25301,2788),(25302,2788),(25303,2789),(25304,2789),(25305,2789),(25306,2789),(25307,2790),(25308,2790),(25309,2790),(25310,2790),(25311,2791),(25312,2791),(25313,2791),(25314,2791),(25315,2792),(25316,2792),(25317,2792),(25318,2792),(25319,2793),(25320,2793),(25321,2793),(25322,2793),(25323,2794),(25324,2794),(25325,2794),(25326,2794),(25327,2795),(25328,2795),(25329,2795),(25330,2795),(25331,2796),(25332,2796),(25333,2796),(25334,2796),(25335,2797),(25336,2797),(25337,2797),(25338,2797),(25339,2798),(25340,2798),(25341,2798),(25342,2798),(25343,2799),(25344,2799),(25345,2799),(25346,2799),(25347,2800),(25348,2800),(25349,2800),(25350,2800),(25351,2801),(25352,2801),(25353,2801),(25354,2801),(25355,2802),(25356,2802),(25357,2802),(25358,2802),(25359,2803),(25360,2803),(25361,2803),(25362,2803),(25363,2804),(25364,2804),(25365,2804),(25366,2804),(25367,2805),(25368,2805),(25369,2805),(25370,2805),(25371,2806),(25372,2806),(25373,2806),(25374,2806),(25375,2807),(25376,2807),(25377,2807),(25378,2807),(25379,2808),(25380,2808),(25381,2808),(25382,2808),(25383,2809),(25384,2809),(25385,2809),(25386,2809),(25387,2810),(25388,2810),(25389,2810),(25390,2810),(25391,2811),(25392,2811),(25393,2811),(25394,2811),(25395,2812),(25396,2812),(25397,2812),(25398,2812),(25399,2813),(25400,2813),(25401,2813),(25402,2813),(25403,2814),(25404,2814),(25405,2814),(25406,2814),(25407,2815),(25408,2815),(25409,2815),(25410,2815),(25411,2816),(25412,2816),(25413,2816),(25414,2816),(25415,2817),(25416,2817),(25417,2817),(25418,2817),(25419,2818),(25420,2818),(25421,2818),(25422,2818),(25423,2819),(25424,2819),(25425,2819),(25426,2819),(25427,2820),(25428,2820),(25429,2820),(25430,2820),(25431,2821),(25432,2821),(25433,2821),(25434,2821),(25435,2822),(25436,2823),(25437,2824),(25438,2825),(25439,2826),(25440,2827),(25441,2828),(25442,2829),(25443,2830),(25444,2831),(25445,2832),(25446,2833),(25447,2834),(25448,2835),(25449,2836),(25450,2837),(25451,2838),(25452,2839),(25453,2840),(25454,2841),(25455,2842),(25456,2843),(25457,2844),(25458,2845),(25459,2846),(25460,2847),(25461,2848),(25462,2849),(25463,2850),(25464,2851),(25465,2852),(25466,2853),(25467,2854),(25468,2855),(25469,2856),(25470,2857),(25471,2858),(25472,2859),(25473,2860),(25474,2861),(25475,2862),(25476,2863),(25477,2864),(25478,2865),(25479,2866),(25480,2867),(25481,2868),(25482,2869),(25483,2870),(25484,2871),(25485,2872),(25486,2873),(25487,2874),(25488,2875),(25489,2876),(25490,2877),(25491,2878),(25492,2879),(25493,2880),(25494,2881),(25495,2882),(25496,2883),(25497,2884),(25498,2885),(25499,2886),(25500,2887),(25501,2888),(25502,2889),(25503,2890),(25504,2891),(25505,2892),(25506,2893),(25507,2894),(25508,2895),(25509,2896),(25510,2897),(25511,2898),(25512,2899),(25513,2900),(25514,2901),(25515,2902),(25516,2903),(25517,2904),(25518,2905),(25519,2906),(25520,2907),(25521,2908),(25522,2909),(25523,2910),(25524,2911),(25525,2912),(25526,2913),(25527,2914),(25528,2915),(25529,2916),(25530,2917),(25531,2918),(25532,2919),(25533,2920),(25534,2921),(25535,2822),(25536,2823),(25537,2824),(25538,2825),(25539,2826),(25540,2827),(25541,2828),(25542,2829),(25543,2830),(25544,2831),(25545,2832),(25546,2833),(25547,2834),(25548,2835),(25549,2836),(25550,2837),(25551,2838),(25552,2839),(25553,2840),(25554,2841),(25555,2842),(25556,2843),(25557,2844),(25558,2845),(25559,2846),(25560,2847),(25561,2848),(25562,2849),(25563,2850),(25564,2851),(25565,2852),(25566,2853),(25567,2854),(25568,2855),(25569,2856),(25570,2857),(25571,2858),(25572,2859),(25573,2860),(25574,2861),(25575,2862),(25576,2863),(25577,2864),(25578,2865),(25579,2866),(25580,2867),(25581,2868),(25582,2869),(25583,2870),(25584,2871),(25585,2872),(25586,2873),(25587,2874),(25588,2875),(25589,2876),(25590,2877),(25591,2878),(25592,2879),(25593,2880),(25594,2881),(25595,2882),(25596,2883),(25597,2884),(25598,2885),(25599,2886),(25600,2887),(25601,2888),(25602,2889),(25603,2890),(25604,2891),(25605,2892),(25606,2893),(25607,2894),(25608,2895),(25609,2896),(25610,2897),(25611,2898),(25612,2899),(25613,2900),(25614,2901),(25615,2902),(25616,2903),(25617,2904),(25618,2905),(25619,2906),(25620,2907),(25621,2908),(25622,2909),(25623,2910),(25624,2911),(25625,2912),(25626,2913),(25627,2914),(25628,2915),(25629,2916),(25630,2917),(25631,2918),(25632,2919),(25633,2920),(25634,2921),(25635,2822),(25636,2822),(25637,2822),(25638,2823),(25639,2823),(25640,2823),(25641,2824),(25642,2824),(25643,2824),(25644,2825),(25645,2825),(25646,2825),(25647,2826),(25648,2826),(25649,2826),(25650,2827),(25651,2827),(25652,2827),(25653,2828),(25654,2828),(25655,2828),(25656,2829),(25657,2829),(25658,2829),(25659,2830),(25660,2830),(25661,2830),(25662,2831),(25663,2831),(25664,2831),(25665,2832),(25666,2832),(25667,2832),(25668,2833),(25669,2833),(25670,2833),(25671,2834),(25672,2834),(25673,2834),(25674,2835),(25675,2835),(25676,2835),(25677,2836),(25678,2836),(25679,2836),(25680,2837),(25681,2837),(25682,2837),(25683,2838),(25684,2838),(25685,2838),(25686,2839),(25687,2839),(25688,2839),(25689,2840),(25690,2840),(25691,2840),(25692,2841),(25693,2841),(25694,2841),(25695,2842),(25696,2842),(25697,2842),(25698,2843),(25699,2843),(25700,2843),(25701,2844),(25702,2844),(25703,2844),(25704,2845),(25705,2845),(25706,2845),(25707,2846),(25708,2846),(25709,2846),(25710,2847),(25711,2847),(25712,2847),(25713,2848),(25714,2848),(25715,2848),(25716,2849),(25717,2849),(25718,2849),(25719,2850),(25720,2850),(25721,2850),(25722,2851),(25723,2851),(25724,2851),(25725,2852),(25726,2852),(25727,2852),(25728,2853),(25729,2853),(25730,2853),(25731,2854),(25732,2854),(25733,2854),(25734,2855),(25735,2855),(25736,2855),(25737,2856),(25738,2856),(25739,2856),(25740,2857),(25741,2857),(25742,2857),(25743,2858),(25744,2858),(25745,2858),(25746,2859),(25747,2859),(25748,2859),(25749,2860),(25750,2860),(25751,2860),(25752,2861),(25753,2861),(25754,2861),(25755,2862),(25756,2862),(25757,2862),(25758,2863),(25759,2863),(25760,2863),(25761,2864),(25762,2864),(25763,2864),(25764,2865),(25765,2865),(25766,2865),(25767,2866),(25768,2866),(25769,2866),(25770,2867),(25771,2867),(25772,2867),(25773,2868),(25774,2868),(25775,2868),(25776,2869),(25777,2869),(25778,2869),(25779,2870),(25780,2870),(25781,2870),(25782,2871),(25783,2871),(25784,2871),(25785,2872),(25786,2872),(25787,2872),(25788,2873),(25789,2873),(25790,2873),(25791,2874),(25792,2874),(25793,2874),(25794,2875),(25795,2875),(25796,2875),(25797,2876),(25798,2876),(25799,2876),(25800,2877),(25801,2877),(25802,2877),(25803,2878),(25804,2878),(25805,2878),(25806,2879),(25807,2879),(25808,2879),(25809,2880),(25810,2880),(25811,2880),(25812,2881),(25813,2881),(25814,2881),(25815,2882),(25816,2882),(25817,2882),(25818,2883),(25819,2883),(25820,2883),(25821,2884),(25822,2884),(25823,2884),(25824,2885),(25825,2885),(25826,2885),(25827,2886),(25828,2886),(25829,2886),(25830,2887),(25831,2887),(25832,2887),(25833,2888),(25834,2888),(25835,2888),(25836,2889),(25837,2889),(25838,2889),(25839,2890),(25840,2890),(25841,2890),(25842,2891),(25843,2891),(25844,2891),(25845,2892),(25846,2892),(25847,2892),(25848,2893),(25849,2893),(25850,2893),(25851,2894),(25852,2894),(25853,2894),(25854,2895),(25855,2895),(25856,2895),(25857,2896),(25858,2896),(25859,2896),(25860,2897),(25861,2897),(25862,2897),(25863,2898),(25864,2898),(25865,2898),(25866,2899),(25867,2899),(25868,2899),(25869,2900),(25870,2900),(25871,2900),(25872,2901),(25873,2901),(25874,2901),(25875,2902),(25876,2902),(25877,2902),(25878,2903),(25879,2903),(25880,2903),(25881,2904),(25882,2904),(25883,2904),(25884,2905),(25885,2905),(25886,2905),(25887,2906),(25888,2906),(25889,2906),(25890,2907),(25891,2907),(25892,2907),(25893,2908),(25894,2908),(25895,2908),(25896,2909),(25897,2909),(25898,2909),(25899,2910),(25900,2910),(25901,2910),(25902,2911),(25903,2911),(25904,2911),(25905,2912),(25906,2912),(25907,2912),(25908,2913),(25909,2913),(25910,2913),(25911,2914),(25912,2914),(25913,2914),(25914,2915),(25915,2915),(25916,2915),(25917,2916),(25918,2916),(25919,2916),(25920,2917),(25921,2917),(25922,2917),(25923,2918),(25924,2918),(25925,2918),(25926,2919),(25927,2919),(25928,2919),(25929,2920),(25930,2920),(25931,2920),(25932,2921),(25933,2921),(25934,2921),(25935,2822),(25936,2822),(25937,2822),(25938,2822),(25939,2823),(25940,2823),(25941,2823),(25942,2823),(25943,2824),(25944,2824),(25945,2824),(25946,2824),(25947,2825),(25948,2825),(25949,2825),(25950,2825),(25951,2826),(25952,2826),(25953,2826),(25954,2826),(25955,2827),(25956,2827),(25957,2827),(25958,2827),(25959,2828),(25960,2828),(25961,2828),(25962,2828),(25963,2829),(25964,2829),(25965,2829),(25966,2829),(25967,2830),(25968,2830),(25969,2830),(25970,2830),(25971,2831),(25972,2831),(25973,2831),(25974,2831),(25975,2832),(25976,2832),(25977,2832),(25978,2832),(25979,2833),(25980,2833),(25981,2833),(25982,2833),(25983,2834),(25984,2834),(25985,2834),(25986,2834),(25987,2835),(25988,2835),(25989,2835),(25990,2835),(25991,2836),(25992,2836),(25993,2836),(25994,2836),(25995,2837),(25996,2837),(25997,2837),(25998,2837),(25999,2838),(26000,2838),(26001,2838),(26002,2838),(26003,2839),(26004,2839),(26005,2839),(26006,2839),(26007,2840),(26008,2840),(26009,2840),(26010,2840),(26011,2841),(26012,2841),(26013,2841),(26014,2841),(26015,2842),(26016,2842),(26017,2842),(26018,2842),(26019,2843),(26020,2843),(26021,2843),(26022,2843),(26023,2844),(26024,2844),(26025,2844),(26026,2844),(26027,2845),(26028,2845),(26029,2845),(26030,2845),(26031,2846),(26032,2846),(26033,2846),(26034,2846),(26035,2847),(26036,2847),(26037,2847),(26038,2847),(26039,2848),(26040,2848),(26041,2848),(26042,2848),(26043,2849),(26044,2849),(26045,2849),(26046,2849),(26047,2850),(26048,2850),(26049,2850),(26050,2850),(26051,2851),(26052,2851),(26053,2851),(26054,2851),(26055,2852),(26056,2852),(26057,2852),(26058,2852),(26059,2853),(26060,2853),(26061,2853),(26062,2853),(26063,2854),(26064,2854),(26065,2854),(26066,2854),(26067,2855),(26068,2855),(26069,2855),(26070,2855),(26071,2856),(26072,2856),(26073,2856),(26074,2856),(26075,2857),(26076,2857),(26077,2857),(26078,2857),(26079,2858),(26080,2858),(26081,2858),(26082,2858),(26083,2859),(26084,2859),(26085,2859),(26086,2859),(26087,2860),(26088,2860),(26089,2860),(26090,2860),(26091,2861),(26092,2861),(26093,2861),(26094,2861),(26095,2862),(26096,2862),(26097,2862),(26098,2862),(26099,2863),(26100,2863),(26101,2863),(26102,2863),(26103,2864),(26104,2864),(26105,2864),(26106,2864),(26107,2865),(26108,2865),(26109,2865),(26110,2865),(26111,2866),(26112,2866),(26113,2866),(26114,2866),(26115,2867),(26116,2867),(26117,2867),(26118,2867),(26119,2868),(26120,2868),(26121,2868),(26122,2868),(26123,2869),(26124,2869),(26125,2869),(26126,2869),(26127,2870),(26128,2870),(26129,2870),(26130,2870),(26131,2871),(26132,2871),(26133,2871),(26134,2871),(26135,2872),(26136,2872),(26137,2872),(26138,2872),(26139,2873),(26140,2873),(26141,2873),(26142,2873),(26143,2874),(26144,2874),(26145,2874),(26146,2874),(26147,2875),(26148,2875),(26149,2875),(26150,2875),(26151,2876),(26152,2876),(26153,2876),(26154,2876),(26155,2877),(26156,2877),(26157,2877),(26158,2877),(26159,2878),(26160,2878),(26161,2878),(26162,2878),(26163,2879),(26164,2879),(26165,2879),(26166,2879),(26167,2880),(26168,2880),(26169,2880),(26170,2880),(26171,2881),(26172,2881),(26173,2881),(26174,2881),(26175,2882),(26176,2882),(26177,2882),(26178,2882),(26179,2883),(26180,2883),(26181,2883),(26182,2883),(26183,2884),(26184,2884),(26185,2884),(26186,2884),(26187,2885),(26188,2885),(26189,2885),(26190,2885),(26191,2886),(26192,2886),(26193,2886),(26194,2886),(26195,2887),(26196,2887),(26197,2887),(26198,2887),(26199,2888),(26200,2888),(26201,2888),(26202,2888),(26203,2889),(26204,2889),(26205,2889),(26206,2889),(26207,2890),(26208,2890),(26209,2890),(26210,2890),(26211,2891),(26212,2891),(26213,2891),(26214,2891),(26215,2892),(26216,2892),(26217,2892),(26218,2892),(26219,2893),(26220,2893),(26221,2893),(26222,2893),(26223,2894),(26224,2894),(26225,2894),(26226,2894),(26227,2895),(26228,2895),(26229,2895),(26230,2895),(26231,2896),(26232,2896),(26233,2896),(26234,2896),(26235,2897),(26236,2897),(26237,2897),(26238,2897),(26239,2898),(26240,2898),(26241,2898),(26242,2898),(26243,2899),(26244,2899),(26245,2899),(26246,2899),(26247,2900),(26248,2900),(26249,2900),(26250,2900),(26251,2901),(26252,2901),(26253,2901),(26254,2901),(26255,2902),(26256,2902),(26257,2902),(26258,2902),(26259,2903),(26260,2903),(26261,2903),(26262,2903),(26263,2904),(26264,2904),(26265,2904),(26266,2904),(26267,2905),(26268,2905),(26269,2905),(26270,2905),(26271,2906),(26272,2906),(26273,2906),(26274,2906),(26275,2907),(26276,2907),(26277,2907),(26278,2907),(26279,2908),(26280,2908),(26281,2908),(26282,2908),(26283,2909),(26284,2909),(26285,2909),(26286,2909),(26287,2910),(26288,2910),(26289,2910),(26290,2910),(26291,2911),(26292,2911),(26293,2911),(26294,2911),(26295,2912),(26296,2912),(26297,2912),(26298,2912),(26299,2913),(26300,2913),(26301,2913),(26302,2913),(26303,2914),(26304,2914),(26305,2914),(26306,2914),(26307,2915),(26308,2915),(26309,2915),(26310,2915),(26311,2916),(26312,2916),(26313,2916),(26314,2916),(26315,2917),(26316,2917),(26317,2917),(26318,2917),(26319,2918),(26320,2918),(26321,2918),(26322,2918),(26323,2919),(26324,2919),(26325,2919),(26326,2919),(26327,2920),(26328,2920),(26329,2920),(26330,2920),(26331,2921),(26332,2921),(26333,2921),(26334,2921),(26335,2922),(26336,2923),(26337,2924),(26338,2925),(26339,2926),(26340,2927),(26341,2928),(26342,2929),(26343,2930),(26344,2931),(26345,2932),(26346,2933),(26347,2934),(26348,2935),(26349,2936),(26350,2937),(26351,2938),(26352,2939),(26353,2940),(26354,2941),(26355,2942),(26356,2943),(26357,2944),(26358,2945),(26359,2946),(26360,2947),(26361,2948),(26362,2949),(26363,2950),(26364,2951),(26365,2952),(26366,2953),(26367,2954),(26368,2955),(26369,2956),(26370,2957),(26371,2958),(26372,2959),(26373,2960),(26374,2961),(26375,2962),(26376,2963),(26377,2964),(26378,2965),(26379,2966),(26380,2967),(26381,2968),(26382,2969),(26383,2970),(26384,2971),(26385,2972),(26386,2973),(26387,2974),(26388,2975),(26389,2976),(26390,2977),(26391,2978),(26392,2979),(26393,2980),(26394,2981),(26395,2982),(26396,2983),(26397,2984),(26398,2985),(26399,2986),(26400,2987),(26401,2988),(26402,2989),(26403,2990),(26404,2991),(26405,2992),(26406,2993),(26407,2994),(26408,2995),(26409,2996),(26410,2997),(26411,2998),(26412,2999),(26413,3000),(26414,3001),(26415,3002),(26416,3003),(26417,3004),(26418,3005),(26419,3006),(26420,3007),(26421,3008),(26422,3009),(26423,3010),(26424,3011),(26425,3012),(26426,3013),(26427,3014),(26428,3015),(26429,3016),(26430,3017),(26431,3018),(26432,3019),(26433,3020),(26434,3021),(26435,2922),(26436,2923),(26437,2924),(26438,2925),(26439,2926),(26440,2927),(26441,2928),(26442,2929),(26443,2930),(26444,2931),(26445,2932),(26446,2933),(26447,2934),(26448,2935),(26449,2936),(26450,2937),(26451,2938),(26452,2939),(26453,2940),(26454,2941),(26455,2942),(26456,2943),(26457,2944),(26458,2945),(26459,2946),(26460,2947),(26461,2948),(26462,2949),(26463,2950),(26464,2951),(26465,2952),(26466,2953),(26467,2954),(26468,2955),(26469,2956),(26470,2957),(26471,2958),(26472,2959),(26473,2960),(26474,2961),(26475,2962),(26476,2963),(26477,2964),(26478,2965),(26479,2966),(26480,2967),(26481,2968),(26482,2969),(26483,2970),(26484,2971),(26485,2972),(26486,2973),(26487,2974),(26488,2975),(26489,2976),(26490,2977),(26491,2978),(26492,2979),(26493,2980),(26494,2981),(26495,2982),(26496,2983),(26497,2984),(26498,2985),(26499,2986),(26500,2987),(26501,2988),(26502,2989),(26503,2990),(26504,2991),(26505,2992),(26506,2993),(26507,2994),(26508,2995),(26509,2996),(26510,2997),(26511,2998),(26512,2999),(26513,3000),(26514,3001),(26515,3002),(26516,3003),(26517,3004),(26518,3005),(26519,3006),(26520,3007),(26521,3008),(26522,3009),(26523,3010),(26524,3011),(26525,3012),(26526,3013),(26527,3014),(26528,3015),(26529,3016),(26530,3017),(26531,3018),(26532,3019),(26533,3020),(26534,3021),(26535,2922),(26536,2922),(26537,2922),(26538,2923),(26539,2923),(26540,2923),(26541,2924),(26542,2924),(26543,2924),(26544,2925),(26545,2925),(26546,2925),(26547,2926),(26548,2926),(26549,2926),(26550,2927),(26551,2927),(26552,2927),(26553,2928),(26554,2928),(26555,2928),(26556,2929),(26557,2929),(26558,2929),(26559,2930),(26560,2930),(26561,2930),(26562,2931),(26563,2931),(26564,2931),(26565,2932),(26566,2932),(26567,2932),(26568,2933),(26569,2933),(26570,2933),(26571,2934),(26572,2934),(26573,2934),(26574,2935),(26575,2935),(26576,2935),(26577,2936),(26578,2936),(26579,2936),(26580,2937),(26581,2937),(26582,2937),(26583,2938),(26584,2938),(26585,2938),(26586,2939),(26587,2939),(26588,2939),(26589,2940),(26590,2940),(26591,2940),(26592,2941),(26593,2941),(26594,2941),(26595,2942),(26596,2942),(26597,2942),(26598,2943),(26599,2943),(26600,2943),(26601,2944),(26602,2944),(26603,2944),(26604,2945),(26605,2945),(26606,2945),(26607,2946),(26608,2946),(26609,2946),(26610,2947),(26611,2947),(26612,2947),(26613,2948),(26614,2948),(26615,2948),(26616,2949),(26617,2949),(26618,2949),(26619,2950),(26620,2950),(26621,2950),(26622,2951),(26623,2951),(26624,2951),(26625,2952),(26626,2952),(26627,2952),(26628,2953),(26629,2953),(26630,2953),(26631,2954),(26632,2954),(26633,2954),(26634,2955),(26635,2955),(26636,2955),(26637,2956),(26638,2956),(26639,2956),(26640,2957),(26641,2957),(26642,2957),(26643,2958),(26644,2958),(26645,2958),(26646,2959),(26647,2959),(26648,2959),(26649,2960),(26650,2960),(26651,2960),(26652,2961),(26653,2961),(26654,2961),(26655,2962),(26656,2962),(26657,2962),(26658,2963),(26659,2963),(26660,2963),(26661,2964),(26662,2964),(26663,2964),(26664,2965),(26665,2965),(26666,2965),(26667,2966),(26668,2966),(26669,2966),(26670,2967),(26671,2967),(26672,2967),(26673,2968),(26674,2968),(26675,2968),(26676,2969),(26677,2969),(26678,2969),(26679,2970),(26680,2970),(26681,2970),(26682,2971),(26683,2971),(26684,2971),(26685,2972),(26686,2972),(26687,2972),(26688,2973),(26689,2973),(26690,2973),(26691,2974),(26692,2974),(26693,2974),(26694,2975),(26695,2975),(26696,2975),(26697,2976),(26698,2976),(26699,2976),(26700,2977),(26701,2977),(26702,2977),(26703,2978),(26704,2978),(26705,2978),(26706,2979),(26707,2979),(26708,2979),(26709,2980),(26710,2980),(26711,2980),(26712,2981),(26713,2981),(26714,2981),(26715,2982),(26716,2982),(26717,2982),(26718,2983),(26719,2983),(26720,2983),(26721,2984),(26722,2984),(26723,2984),(26724,2985),(26725,2985),(26726,2985),(26727,2986),(26728,2986),(26729,2986),(26730,2987),(26731,2987),(26732,2987),(26733,2988),(26734,2988),(26735,2988),(26736,2989),(26737,2989),(26738,2989),(26739,2990),(26740,2990),(26741,2990),(26742,2991),(26743,2991),(26744,2991),(26745,2992),(26746,2992),(26747,2992),(26748,2993),(26749,2993),(26750,2993),(26751,2994),(26752,2994),(26753,2994),(26754,2995),(26755,2995),(26756,2995),(26757,2996),(26758,2996),(26759,2996),(26760,2997),(26761,2997),(26762,2997),(26763,2998),(26764,2998),(26765,2998),(26766,2999),(26767,2999),(26768,2999),(26769,3000),(26770,3000),(26771,3000),(26772,3001),(26773,3001),(26774,3001),(26775,3002),(26776,3002),(26777,3002),(26778,3003),(26779,3003),(26780,3003),(26781,3004),(26782,3004),(26783,3004),(26784,3005),(26785,3005),(26786,3005),(26787,3006),(26788,3006),(26789,3006),(26790,3007),(26791,3007),(26792,3007),(26793,3008),(26794,3008),(26795,3008),(26796,3009),(26797,3009),(26798,3009),(26799,3010),(26800,3010),(26801,3010),(26802,3011),(26803,3011),(26804,3011),(26805,3012),(26806,3012),(26807,3012),(26808,3013),(26809,3013),(26810,3013),(26811,3014),(26812,3014),(26813,3014),(26814,3015),(26815,3015),(26816,3015),(26817,3016),(26818,3016),(26819,3016),(26820,3017),(26821,3017),(26822,3017),(26823,3018),(26824,3018),(26825,3018),(26826,3019),(26827,3019),(26828,3019),(26829,3020),(26830,3020),(26831,3020),(26832,3021),(26833,3021),(26834,3021),(26835,2922),(26836,2922),(26837,2922),(26838,2922),(26839,2923),(26840,2923),(26841,2923),(26842,2923),(26843,2924),(26844,2924),(26845,2924),(26846,2924),(26847,2925),(26848,2925),(26849,2925),(26850,2925),(26851,2926),(26852,2926),(26853,2926),(26854,2926),(26855,2927),(26856,2927),(26857,2927),(26858,2927),(26859,2928),(26860,2928),(26861,2928),(26862,2928),(26863,2929),(26864,2929),(26865,2929),(26866,2929),(26867,2930),(26868,2930),(26869,2930),(26870,2930),(26871,2931),(26872,2931),(26873,2931),(26874,2931),(26875,2932),(26876,2932),(26877,2932),(26878,2932),(26879,2933),(26880,2933),(26881,2933),(26882,2933),(26883,2934),(26884,2934),(26885,2934),(26886,2934),(26887,2935),(26888,2935),(26889,2935),(26890,2935),(26891,2936),(26892,2936),(26893,2936),(26894,2936),(26895,2937),(26896,2937),(26897,2937),(26898,2937),(26899,2938),(26900,2938),(26901,2938),(26902,2938),(26903,2939),(26904,2939),(26905,2939),(26906,2939),(26907,2940),(26908,2940),(26909,2940),(26910,2940),(26911,2941),(26912,2941),(26913,2941),(26914,2941),(26915,2942),(26916,2942),(26917,2942),(26918,2942),(26919,2943),(26920,2943),(26921,2943),(26922,2943),(26923,2944),(26924,2944),(26925,2944),(26926,2944),(26927,2945),(26928,2945),(26929,2945),(26930,2945),(26931,2946),(26932,2946),(26933,2946),(26934,2946),(26935,2947),(26936,2947),(26937,2947),(26938,2947),(26939,2948),(26940,2948),(26941,2948),(26942,2948),(26943,2949),(26944,2949),(26945,2949),(26946,2949),(26947,2950),(26948,2950),(26949,2950),(26950,2950),(26951,2951),(26952,2951),(26953,2951),(26954,2951),(26955,2952),(26956,2952),(26957,2952),(26958,2952),(26959,2953),(26960,2953),(26961,2953),(26962,2953),(26963,2954),(26964,2954),(26965,2954),(26966,2954),(26967,2955),(26968,2955),(26969,2955),(26970,2955),(26971,2956),(26972,2956),(26973,2956),(26974,2956),(26975,2957),(26976,2957),(26977,2957),(26978,2957),(26979,2958),(26980,2958),(26981,2958),(26982,2958),(26983,2959),(26984,2959),(26985,2959),(26986,2959),(26987,2960),(26988,2960),(26989,2960),(26990,2960),(26991,2961),(26992,2961),(26993,2961),(26994,2961),(26995,2962),(26996,2962),(26997,2962),(26998,2962),(26999,2963),(27000,2963),(27001,2963),(27002,2963),(27003,2964),(27004,2964),(27005,2964),(27006,2964),(27007,2965),(27008,2965),(27009,2965),(27010,2965),(27011,2966),(27012,2966),(27013,2966),(27014,2966),(27015,2967),(27016,2967),(27017,2967),(27018,2967),(27019,2968),(27020,2968),(27021,2968),(27022,2968),(27023,2969),(27024,2969),(27025,2969),(27026,2969),(27027,2970),(27028,2970),(27029,2970),(27030,2970),(27031,2971),(27032,2971),(27033,2971),(27034,2971),(27035,2972),(27036,2972),(27037,2972),(27038,2972),(27039,2973),(27040,2973),(27041,2973),(27042,2973),(27043,2974),(27044,2974),(27045,2974),(27046,2974),(27047,2975),(27048,2975),(27049,2975),(27050,2975),(27051,2976),(27052,2976),(27053,2976),(27054,2976),(27055,2977),(27056,2977),(27057,2977),(27058,2977),(27059,2978),(27060,2978),(27061,2978),(27062,2978),(27063,2979),(27064,2979),(27065,2979),(27066,2979),(27067,2980),(27068,2980),(27069,2980),(27070,2980),(27071,2981),(27072,2981),(27073,2981),(27074,2981),(27075,2982),(27076,2982),(27077,2982),(27078,2982),(27079,2983),(27080,2983),(27081,2983),(27082,2983),(27083,2984),(27084,2984),(27085,2984),(27086,2984),(27087,2985),(27088,2985),(27089,2985),(27090,2985),(27091,2986),(27092,2986),(27093,2986),(27094,2986),(27095,2987),(27096,2987),(27097,2987),(27098,2987),(27099,2988),(27100,2988),(27101,2988),(27102,2988),(27103,2989),(27104,2989),(27105,2989),(27106,2989),(27107,2990),(27108,2990),(27109,2990),(27110,2990),(27111,2991),(27112,2991),(27113,2991),(27114,2991),(27115,2992),(27116,2992),(27117,2992),(27118,2992),(27119,2993),(27120,2993),(27121,2993),(27122,2993),(27123,2994),(27124,2994),(27125,2994),(27126,2994),(27127,2995),(27128,2995),(27129,2995),(27130,2995),(27131,2996),(27132,2996),(27133,2996),(27134,2996),(27135,2997),(27136,2997),(27137,2997),(27138,2997),(27139,2998),(27140,2998),(27141,2998),(27142,2998),(27143,2999),(27144,2999),(27145,2999),(27146,2999),(27147,3000),(27148,3000),(27149,3000),(27150,3000),(27151,3001),(27152,3001),(27153,3001),(27154,3001),(27155,3002),(27156,3002),(27157,3002),(27158,3002),(27159,3003),(27160,3003),(27161,3003),(27162,3003),(27163,3004),(27164,3004),(27165,3004),(27166,3004),(27167,3005),(27168,3005),(27169,3005),(27170,3005),(27171,3006),(27172,3006),(27173,3006),(27174,3006),(27175,3007),(27176,3007),(27177,3007),(27178,3007),(27179,3008),(27180,3008),(27181,3008),(27182,3008),(27183,3009),(27184,3009),(27185,3009),(27186,3009),(27187,3010),(27188,3010),(27189,3010),(27190,3010),(27191,3011),(27192,3011),(27193,3011),(27194,3011),(27195,3012),(27196,3012),(27197,3012),(27198,3012),(27199,3013),(27200,3013),(27201,3013),(27202,3013),(27203,3014),(27204,3014),(27205,3014),(27206,3014),(27207,3015),(27208,3015),(27209,3015),(27210,3015),(27211,3016),(27212,3016),(27213,3016),(27214,3016),(27215,3017),(27216,3017),(27217,3017),(27218,3017),(27219,3018),(27220,3018),(27221,3018),(27222,3018),(27223,3019),(27224,3019),(27225,3019),(27226,3019),(27227,3020),(27228,3020),(27229,3020),(27230,3020),(27231,3021),(27232,3021),(27233,3021),(27234,3021),(27235,3022),(27236,3023),(27237,3024),(27238,3025),(27239,3026),(27240,3027),(27241,3028),(27242,3029),(27243,3030),(27244,3031),(27245,3032),(27246,3033),(27247,3034),(27248,3035),(27249,3036),(27250,3037),(27251,3038),(27252,3039),(27253,3040),(27254,3041),(27255,3042),(27256,3043),(27257,3044),(27258,3045),(27259,3046),(27260,3047),(27261,3048),(27262,3049),(27263,3050),(27264,3051),(27265,3052),(27266,3053),(27267,3054),(27268,3055),(27269,3056),(27270,3057),(27271,3058),(27272,3059),(27273,3060),(27274,3061),(27275,3062),(27276,3063),(27277,3064),(27278,3065),(27279,3066),(27280,3067),(27281,3068),(27282,3069),(27283,3070),(27284,3071),(27285,3072),(27286,3073),(27287,3074),(27288,3075),(27289,3076),(27290,3077),(27291,3078),(27292,3079),(27293,3080),(27294,3081),(27295,3082),(27296,3083),(27297,3084),(27298,3085),(27299,3086),(27300,3087),(27301,3088),(27302,3089),(27303,3090),(27304,3091),(27305,3092),(27306,3093),(27307,3094),(27308,3095),(27309,3096),(27310,3097),(27311,3098),(27312,3099),(27313,3100),(27314,3101),(27315,3102),(27316,3103),(27317,3104),(27318,3105),(27319,3106),(27320,3107),(27321,3108),(27322,3109),(27323,3110),(27324,3111),(27325,3112),(27326,3113),(27327,3114),(27328,3115),(27329,3116),(27330,3117),(27331,3118),(27332,3119),(27333,3120),(27334,3121),(27335,3022),(27336,3023),(27337,3024),(27338,3025),(27339,3026),(27340,3027),(27341,3028),(27342,3029),(27343,3030),(27344,3031),(27345,3032),(27346,3033),(27347,3034),(27348,3035),(27349,3036),(27350,3037),(27351,3038),(27352,3039),(27353,3040),(27354,3041),(27355,3042),(27356,3043),(27357,3044),(27358,3045),(27359,3046),(27360,3047),(27361,3048),(27362,3049),(27363,3050),(27364,3051),(27365,3052),(27366,3053),(27367,3054),(27368,3055),(27369,3056),(27370,3057),(27371,3058),(27372,3059),(27373,3060),(27374,3061),(27375,3062),(27376,3063),(27377,3064),(27378,3065),(27379,3066),(27380,3067),(27381,3068),(27382,3069),(27383,3070),(27384,3071),(27385,3072),(27386,3073),(27387,3074),(27388,3075),(27389,3076),(27390,3077),(27391,3078),(27392,3079),(27393,3080),(27394,3081),(27395,3082),(27396,3083),(27397,3084),(27398,3085),(27399,3086),(27400,3087),(27401,3088),(27402,3089),(27403,3090),(27404,3091),(27405,3092),(27406,3093),(27407,3094),(27408,3095),(27409,3096),(27410,3097),(27411,3098),(27412,3099),(27413,3100),(27414,3101),(27415,3102),(27416,3103),(27417,3104),(27418,3105),(27419,3106),(27420,3107),(27421,3108),(27422,3109),(27423,3110),(27424,3111),(27425,3112),(27426,3113),(27427,3114),(27428,3115),(27429,3116),(27430,3117),(27431,3118),(27432,3119),(27433,3120),(27434,3121),(27435,3022),(27436,3022),(27437,3022),(27438,3023),(27439,3023),(27440,3023),(27441,3024),(27442,3024),(27443,3024),(27444,3025),(27445,3025),(27446,3025),(27447,3026),(27448,3026),(27449,3026),(27450,3027),(27451,3027),(27452,3027),(27453,3028),(27454,3028),(27455,3028),(27456,3029),(27457,3029),(27458,3029),(27459,3030),(27460,3030),(27461,3030),(27462,3031),(27463,3031),(27464,3031),(27465,3032),(27466,3032),(27467,3032),(27468,3033),(27469,3033),(27470,3033),(27471,3034),(27472,3034),(27473,3034),(27474,3035),(27475,3035),(27476,3035),(27477,3036),(27478,3036),(27479,3036),(27480,3037),(27481,3037),(27482,3037),(27483,3038),(27484,3038),(27485,3038),(27486,3039),(27487,3039),(27488,3039),(27489,3040),(27490,3040),(27491,3040),(27492,3041),(27493,3041),(27494,3041),(27495,3042),(27496,3042),(27497,3042),(27498,3043),(27499,3043),(27500,3043),(27501,3044),(27502,3044),(27503,3044),(27504,3045),(27505,3045),(27506,3045),(27507,3046),(27508,3046),(27509,3046),(27510,3047),(27511,3047),(27512,3047),(27513,3048),(27514,3048),(27515,3048),(27516,3049),(27517,3049),(27518,3049),(27519,3050),(27520,3050),(27521,3050),(27522,3051),(27523,3051),(27524,3051),(27525,3052),(27526,3052),(27527,3052),(27528,3053),(27529,3053),(27530,3053),(27531,3054),(27532,3054),(27533,3054),(27534,3055),(27535,3055),(27536,3055),(27537,3056),(27538,3056),(27539,3056),(27540,3057),(27541,3057),(27542,3057),(27543,3058),(27544,3058),(27545,3058),(27546,3059),(27547,3059),(27548,3059),(27549,3060),(27550,3060),(27551,3060),(27552,3061),(27553,3061),(27554,3061),(27555,3062),(27556,3062),(27557,3062),(27558,3063),(27559,3063),(27560,3063),(27561,3064),(27562,3064),(27563,3064),(27564,3065),(27565,3065),(27566,3065),(27567,3066),(27568,3066),(27569,3066),(27570,3067),(27571,3067),(27572,3067),(27573,3068),(27574,3068),(27575,3068),(27576,3069),(27577,3069),(27578,3069),(27579,3070),(27580,3070),(27581,3070),(27582,3071),(27583,3071),(27584,3071),(27585,3072),(27586,3072),(27587,3072),(27588,3073),(27589,3073),(27590,3073),(27591,3074),(27592,3074),(27593,3074),(27594,3075),(27595,3075),(27596,3075),(27597,3076),(27598,3076),(27599,3076),(27600,3077),(27601,3077),(27602,3077),(27603,3078),(27604,3078),(27605,3078),(27606,3079),(27607,3079),(27608,3079),(27609,3080),(27610,3080),(27611,3080),(27612,3081),(27613,3081),(27614,3081),(27615,3082),(27616,3082),(27617,3082),(27618,3083),(27619,3083),(27620,3083),(27621,3084),(27622,3084),(27623,3084),(27624,3085),(27625,3085),(27626,3085),(27627,3086),(27628,3086),(27629,3086),(27630,3087),(27631,3087),(27632,3087),(27633,3088),(27634,3088),(27635,3088),(27636,3089),(27637,3089),(27638,3089),(27639,3090),(27640,3090),(27641,3090),(27642,3091),(27643,3091),(27644,3091),(27645,3092),(27646,3092),(27647,3092),(27648,3093),(27649,3093),(27650,3093),(27651,3094),(27652,3094),(27653,3094),(27654,3095),(27655,3095),(27656,3095),(27657,3096),(27658,3096),(27659,3096),(27660,3097),(27661,3097),(27662,3097),(27663,3098),(27664,3098),(27665,3098),(27666,3099),(27667,3099),(27668,3099),(27669,3100),(27670,3100),(27671,3100),(27672,3101),(27673,3101),(27674,3101),(27675,3102),(27676,3102),(27677,3102),(27678,3103),(27679,3103),(27680,3103),(27681,3104),(27682,3104),(27683,3104),(27684,3105),(27685,3105),(27686,3105),(27687,3106),(27688,3106),(27689,3106),(27690,3107),(27691,3107),(27692,3107),(27693,3108),(27694,3108),(27695,3108),(27696,3109),(27697,3109),(27698,3109),(27699,3110),(27700,3110),(27701,3110),(27702,3111),(27703,3111),(27704,3111),(27705,3112),(27706,3112),(27707,3112),(27708,3113),(27709,3113),(27710,3113),(27711,3114),(27712,3114),(27713,3114),(27714,3115),(27715,3115),(27716,3115),(27717,3116),(27718,3116),(27719,3116),(27720,3117),(27721,3117),(27722,3117),(27723,3118),(27724,3118),(27725,3118),(27726,3119),(27727,3119),(27728,3119),(27729,3120),(27730,3120),(27731,3120),(27732,3121),(27733,3121),(27734,3121),(27735,3022),(27736,3022),(27737,3022),(27738,3022),(27739,3023),(27740,3023),(27741,3023),(27742,3023),(27743,3024),(27744,3024),(27745,3024),(27746,3024),(27747,3025),(27748,3025),(27749,3025),(27750,3025),(27751,3026),(27752,3026),(27753,3026),(27754,3026),(27755,3027),(27756,3027),(27757,3027),(27758,3027),(27759,3028),(27760,3028),(27761,3028),(27762,3028),(27763,3029),(27764,3029),(27765,3029),(27766,3029),(27767,3030),(27768,3030),(27769,3030),(27770,3030),(27771,3031),(27772,3031),(27773,3031),(27774,3031),(27775,3032),(27776,3032),(27777,3032),(27778,3032),(27779,3033),(27780,3033),(27781,3033),(27782,3033),(27783,3034),(27784,3034),(27785,3034),(27786,3034),(27787,3035),(27788,3035),(27789,3035),(27790,3035),(27791,3036),(27792,3036),(27793,3036),(27794,3036),(27795,3037),(27796,3037),(27797,3037),(27798,3037),(27799,3038),(27800,3038),(27801,3038),(27802,3038),(27803,3039),(27804,3039),(27805,3039),(27806,3039),(27807,3040),(27808,3040),(27809,3040),(27810,3040),(27811,3041),(27812,3041),(27813,3041),(27814,3041),(27815,3042),(27816,3042),(27817,3042),(27818,3042),(27819,3043),(27820,3043),(27821,3043),(27822,3043),(27823,3044),(27824,3044),(27825,3044),(27826,3044),(27827,3045),(27828,3045),(27829,3045),(27830,3045),(27831,3046),(27832,3046),(27833,3046),(27834,3046),(27835,3047),(27836,3047),(27837,3047),(27838,3047),(27839,3048),(27840,3048),(27841,3048),(27842,3048),(27843,3049),(27844,3049),(27845,3049),(27846,3049),(27847,3050),(27848,3050),(27849,3050),(27850,3050),(27851,3051),(27852,3051),(27853,3051),(27854,3051),(27855,3052),(27856,3052),(27857,3052),(27858,3052),(27859,3053),(27860,3053),(27861,3053),(27862,3053),(27863,3054),(27864,3054),(27865,3054),(27866,3054),(27867,3055),(27868,3055),(27869,3055),(27870,3055),(27871,3056),(27872,3056),(27873,3056),(27874,3056),(27875,3057),(27876,3057),(27877,3057),(27878,3057),(27879,3058),(27880,3058),(27881,3058),(27882,3058),(27883,3059),(27884,3059),(27885,3059),(27886,3059),(27887,3060),(27888,3060),(27889,3060),(27890,3060),(27891,3061),(27892,3061),(27893,3061),(27894,3061),(27895,3062),(27896,3062),(27897,3062),(27898,3062),(27899,3063),(27900,3063),(27901,3063),(27902,3063),(27903,3064),(27904,3064),(27905,3064),(27906,3064),(27907,3065),(27908,3065),(27909,3065),(27910,3065),(27911,3066),(27912,3066),(27913,3066),(27914,3066),(27915,3067),(27916,3067),(27917,3067),(27918,3067),(27919,3068),(27920,3068),(27921,3068),(27922,3068),(27923,3069),(27924,3069),(27925,3069),(27926,3069),(27927,3070),(27928,3070),(27929,3070),(27930,3070),(27931,3071),(27932,3071),(27933,3071),(27934,3071),(27935,3072),(27936,3072),(27937,3072),(27938,3072),(27939,3073),(27940,3073),(27941,3073),(27942,3073),(27943,3074),(27944,3074),(27945,3074),(27946,3074),(27947,3075),(27948,3075),(27949,3075),(27950,3075),(27951,3076),(27952,3076),(27953,3076),(27954,3076),(27955,3077),(27956,3077),(27957,3077),(27958,3077),(27959,3078),(27960,3078),(27961,3078),(27962,3078),(27963,3079),(27964,3079),(27965,3079),(27966,3079),(27967,3080),(27968,3080),(27969,3080),(27970,3080),(27971,3081),(27972,3081),(27973,3081),(27974,3081),(27975,3082),(27976,3082),(27977,3082),(27978,3082),(27979,3083),(27980,3083),(27981,3083),(27982,3083),(27983,3084),(27984,3084),(27985,3084),(27986,3084),(27987,3085),(27988,3085),(27989,3085),(27990,3085),(27991,3086),(27992,3086),(27993,3086),(27994,3086),(27995,3087),(27996,3087),(27997,3087),(27998,3087),(27999,3088),(28000,3088),(28001,3088),(28002,3088),(28003,3089),(28004,3089),(28005,3089),(28006,3089),(28007,3090),(28008,3090),(28009,3090),(28010,3090),(28011,3091),(28012,3091),(28013,3091),(28014,3091),(28015,3092),(28016,3092),(28017,3092),(28018,3092),(28019,3093),(28020,3093),(28021,3093),(28022,3093),(28023,3094),(28024,3094),(28025,3094),(28026,3094),(28027,3095),(28028,3095),(28029,3095),(28030,3095),(28031,3096),(28032,3096),(28033,3096),(28034,3096),(28035,3097),(28036,3097),(28037,3097),(28038,3097),(28039,3098),(28040,3098),(28041,3098),(28042,3098),(28043,3099),(28044,3099),(28045,3099),(28046,3099),(28047,3100),(28048,3100),(28049,3100),(28050,3100),(28051,3101),(28052,3101),(28053,3101),(28054,3101),(28055,3102),(28056,3102),(28057,3102),(28058,3102),(28059,3103),(28060,3103),(28061,3103),(28062,3103),(28063,3104),(28064,3104),(28065,3104),(28066,3104),(28067,3105),(28068,3105),(28069,3105),(28070,3105),(28071,3106),(28072,3106),(28073,3106),(28074,3106),(28075,3107),(28076,3107),(28077,3107),(28078,3107),(28079,3108),(28080,3108),(28081,3108),(28082,3108),(28083,3109),(28084,3109),(28085,3109),(28086,3109),(28087,3110),(28088,3110),(28089,3110),(28090,3110),(28091,3111),(28092,3111),(28093,3111),(28094,3111),(28095,3112),(28096,3112),(28097,3112),(28098,3112),(28099,3113),(28100,3113),(28101,3113),(28102,3113),(28103,3114),(28104,3114),(28105,3114),(28106,3114),(28107,3115),(28108,3115),(28109,3115),(28110,3115),(28111,3116),(28112,3116),(28113,3116),(28114,3116),(28115,3117),(28116,3117),(28117,3117),(28118,3117),(28119,3118),(28120,3118),(28121,3118),(28122,3118),(28123,3119),(28124,3119),(28125,3119),(28126,3119),(28127,3120),(28128,3120),(28129,3120),(28130,3120),(28131,3121),(28132,3121),(28133,3121),(28134,3121),(28135,3122),(28136,3123),(28137,3124),(28138,3125),(28139,3126),(28140,3127),(28141,3128),(28142,3129),(28143,3130),(28144,3131),(28145,3132),(28146,3133),(28147,3134),(28148,3135),(28149,3136),(28150,3137),(28151,3138),(28152,3139),(28153,3140),(28154,3141),(28155,3142),(28156,3143),(28157,3144),(28158,3145),(28159,3146),(28160,3147),(28161,3148),(28162,3149),(28163,3150),(28164,3151),(28165,3152),(28166,3153),(28167,3154),(28168,3155),(28169,3156),(28170,3157),(28171,3158),(28172,3159),(28173,3160),(28174,3161),(28175,3162),(28176,3163),(28177,3164),(28178,3165),(28179,3166),(28180,3167),(28181,3168),(28182,3122),(28183,3123),(28184,3124),(28185,3125),(28186,3126),(28187,3127),(28188,3128),(28189,3129),(28190,3130),(28191,3131),(28192,3132),(28193,3133),(28194,3134),(28195,3135),(28196,3136),(28197,3137),(28198,3138),(28199,3139),(28200,3140),(28201,3141),(28202,3142),(28203,3143),(28204,3144),(28205,3145),(28206,3146),(28207,3147),(28208,3148),(28209,3149),(28210,3150),(28211,3151),(28212,3152),(28213,3153),(28214,3154),(28215,3155),(28216,3156),(28217,3157),(28218,3158),(28219,3159),(28220,3160),(28221,3161),(28222,3162),(28223,3163),(28224,3164),(28225,3165),(28226,3166),(28227,3167),(28228,3168),(28229,3122),(28230,3122),(28231,3122),(28232,3123),(28233,3123),(28234,3123),(28235,3124),(28236,3124),(28237,3124),(28238,3125),(28239,3125),(28240,3125),(28241,3126),(28242,3126),(28243,3126),(28244,3127),(28245,3127),(28246,3127),(28247,3128),(28248,3128),(28249,3128),(28250,3129),(28251,3129),(28252,3129),(28253,3130),(28254,3130),(28255,3130),(28256,3131),(28257,3131),(28258,3131),(28259,3132),(28260,3132),(28261,3132),(28262,3133),(28263,3133),(28264,3133),(28265,3134),(28266,3134),(28267,3134),(28268,3135),(28269,3135),(28270,3135),(28271,3136),(28272,3136),(28273,3136),(28274,3137),(28275,3137),(28276,3137),(28277,3138),(28278,3138),(28279,3138),(28280,3139),(28281,3139),(28282,3139),(28283,3140),(28284,3140),(28285,3140),(28286,3141),(28287,3141),(28288,3141),(28289,3142),(28290,3142),(28291,3142),(28292,3143),(28293,3143),(28294,3143),(28295,3144),(28296,3144),(28297,3144),(28298,3145),(28299,3145),(28300,3145),(28301,3146),(28302,3146),(28303,3146),(28304,3147),(28305,3147),(28306,3147),(28307,3148),(28308,3148),(28309,3148),(28310,3149),(28311,3149),(28312,3149),(28313,3150),(28314,3150),(28315,3150),(28316,3151),(28317,3151),(28318,3151),(28319,3152),(28320,3152),(28321,3152),(28322,3153),(28323,3153),(28324,3153),(28325,3154),(28326,3154),(28327,3154),(28328,3155),(28329,3155),(28330,3155),(28331,3156),(28332,3156),(28333,3156),(28334,3157),(28335,3157),(28336,3157),(28337,3158),(28338,3158),(28339,3158),(28340,3159),(28341,3159),(28342,3159),(28343,3160),(28344,3160),(28345,3160),(28346,3161),(28347,3161),(28348,3161),(28349,3162),(28350,3162),(28351,3162),(28352,3163),(28353,3163),(28354,3163),(28355,3164),(28356,3164),(28357,3164),(28358,3165),(28359,3165),(28360,3165),(28361,3166),(28362,3166),(28363,3166),(28364,3167),(28365,3167),(28366,3167),(28367,3168),(28368,3168),(28369,3168),(28370,3122),(28371,3122),(28372,3122),(28373,3122),(28374,3123),(28375,3123),(28376,3123),(28377,3123),(28378,3124),(28379,3124),(28380,3124),(28381,3124),(28382,3125),(28383,3125),(28384,3125),(28385,3125),(28386,3126),(28387,3126),(28388,3126),(28389,3126),(28390,3127),(28391,3127),(28392,3127),(28393,3127),(28394,3128),(28395,3128),(28396,3128),(28397,3128),(28398,3129),(28399,3129),(28400,3129),(28401,3129),(28402,3130),(28403,3130),(28404,3130),(28405,3130),(28406,3131),(28407,3131),(28408,3131),(28409,3131),(28410,3132),(28411,3132),(28412,3132),(28413,3132),(28414,3133),(28415,3133),(28416,3133),(28417,3133),(28418,3134),(28419,3134),(28420,3134),(28421,3134),(28422,3135),(28423,3135),(28424,3135),(28425,3135),(28426,3136),(28427,3136),(28428,3136),(28429,3136),(28430,3137),(28431,3137),(28432,3137),(28433,3137),(28434,3138),(28435,3138),(28436,3138),(28437,3138),(28438,3139),(28439,3139),(28440,3139),(28441,3139),(28442,3140),(28443,3140),(28444,3140),(28445,3140),(28446,3141),(28447,3141),(28448,3141),(28449,3141),(28450,3142),(28451,3142),(28452,3142),(28453,3142),(28454,3143),(28455,3143),(28456,3143),(28457,3143),(28458,3144),(28459,3144),(28460,3144),(28461,3144),(28462,3145),(28463,3145),(28464,3145),(28465,3145),(28466,3146),(28467,3146),(28468,3146),(28469,3146),(28470,3147),(28471,3147),(28472,3147),(28473,3147),(28474,3148),(28475,3148),(28476,3148),(28477,3148),(28478,3149),(28479,3149),(28480,3149),(28481,3149),(28482,3150),(28483,3150),(28484,3150),(28485,3150),(28486,3151),(28487,3151),(28488,3151),(28489,3151),(28490,3152),(28491,3152),(28492,3152),(28493,3152),(28494,3153),(28495,3153),(28496,3153),(28497,3153),(28498,3154),(28499,3154),(28500,3154),(28501,3154),(28502,3155),(28503,3155),(28504,3155),(28505,3155),(28506,3156),(28507,3156),(28508,3156),(28509,3156),(28510,3157),(28511,3157),(28512,3157),(28513,3157),(28514,3158),(28515,3158),(28516,3158),(28517,3158),(28518,3159),(28519,3159),(28520,3159),(28521,3159),(28522,3160),(28523,3160),(28524,3160),(28525,3160),(28526,3161),(28527,3161),(28528,3161),(28529,3161),(28530,3162),(28531,3162),(28532,3162),(28533,3162),(28534,3163),(28535,3163),(28536,3163),(28537,3163),(28538,3164),(28539,3164),(28540,3164),(28541,3164),(28542,3165),(28543,3165),(28544,3165),(28545,3165),(28546,3166),(28547,3166),(28548,3166),(28549,3166),(28550,3167),(28551,3167),(28552,3167),(28553,3167),(28554,3168),(28555,3168),(28556,3168),(28557,3168),(28558,3169),(28559,3170),(28560,3171),(28561,3172),(28562,3173),(28563,3174),(28564,3175),(28565,3176),(28566,3177),(28567,3178),(28568,3179),(28569,3180),(28570,3181),(28571,3182),(28572,3183),(28573,3184),(28574,3185),(28575,3186),(28576,3187),(28577,3188),(28578,3189),(28579,3190),(28580,3191),(28581,3192),(28582,3193),(28583,3194),(28584,3195),(28585,3196),(28586,3197),(28587,3198),(28588,3199),(28589,3200),(28590,3201),(28591,3202),(28592,3203),(28593,3204),(28594,3205),(28595,3206),(28596,3207),(28597,3208),(28598,3209),(28599,3210),(28600,3211),(28601,3212),(28602,3213),(28603,3214),(28604,3215),(28605,3216),(28606,3217),(28607,3218),(28608,3219),(28609,3220),(28610,3221),(28611,3222),(28612,3223),(28613,3224),(28614,3225),(28615,3226),(28616,3227),(28617,3228),(28618,3229),(28619,3230),(28620,3231),(28621,3232),(28622,3233),(28623,3234),(28624,3235),(28625,3236),(28626,3237),(28627,3238),(28628,3239),(28629,3240),(28630,3241),(28631,3242),(28632,3243),(28633,3244),(28634,3245),(28635,3246),(28636,3247),(28637,3248),(28638,3249),(28639,3250),(28640,3251),(28641,3252),(28642,3253),(28643,3254),(28644,3255),(28645,3256),(28646,3257),(28647,3258),(28648,3259),(28649,3260),(28650,3261),(28651,3262),(28652,3263),(28653,3264),(28654,3265),(28655,3266),(28656,3267),(28657,3268),(28658,3169),(28659,3170),(28660,3171),(28661,3172),(28662,3173),(28663,3174),(28664,3175),(28665,3176),(28666,3177),(28667,3178),(28668,3179),(28669,3180),(28670,3181),(28671,3182),(28672,3183),(28673,3184),(28674,3185),(28675,3186),(28676,3187),(28677,3188),(28678,3189),(28679,3190),(28680,3191),(28681,3192),(28682,3193),(28683,3194),(28684,3195),(28685,3196),(28686,3197),(28687,3198),(28688,3199),(28689,3200),(28690,3201),(28691,3202),(28692,3203),(28693,3204),(28694,3205),(28695,3206),(28696,3207),(28697,3208),(28698,3209),(28699,3210),(28700,3211),(28701,3212),(28702,3213),(28703,3214),(28704,3215),(28705,3216),(28706,3217),(28707,3218),(28708,3219),(28709,3220),(28710,3221),(28711,3222),(28712,3223),(28713,3224),(28714,3225),(28715,3226),(28716,3227),(28717,3228),(28718,3229),(28719,3230),(28720,3231),(28721,3232),(28722,3233),(28723,3234),(28724,3235),(28725,3236),(28726,3237),(28727,3238),(28728,3239),(28729,3240),(28730,3241),(28731,3242),(28732,3243),(28733,3244),(28734,3245),(28735,3246),(28736,3247),(28737,3248),(28738,3249),(28739,3250),(28740,3251),(28741,3252),(28742,3253),(28743,3254),(28744,3255),(28745,3256),(28746,3257),(28747,3258),(28748,3259),(28749,3260),(28750,3261),(28751,3262),(28752,3263),(28753,3264),(28754,3265),(28755,3266),(28756,3267),(28757,3268),(28758,3169),(28759,3169),(28760,3169),(28761,3170),(28762,3170),(28763,3170),(28764,3171),(28765,3171),(28766,3171),(28767,3172),(28768,3172),(28769,3172),(28770,3173),(28771,3173),(28772,3173),(28773,3174),(28774,3174),(28775,3174),(28776,3175),(28777,3175),(28778,3175),(28779,3176),(28780,3176),(28781,3176),(28782,3177),(28783,3177),(28784,3177),(28785,3178),(28786,3178),(28787,3178),(28788,3179),(28789,3179),(28790,3179),(28791,3180),(28792,3180),(28793,3180),(28794,3181),(28795,3181),(28796,3181),(28797,3182),(28798,3182),(28799,3182),(28800,3183),(28801,3183),(28802,3183),(28803,3184),(28804,3184),(28805,3184),(28806,3185),(28807,3185),(28808,3185),(28809,3186),(28810,3186),(28811,3186),(28812,3187),(28813,3187),(28814,3187),(28815,3188),(28816,3188),(28817,3188),(28818,3189),(28819,3189),(28820,3189),(28821,3190),(28822,3190),(28823,3190),(28824,3191),(28825,3191),(28826,3191),(28827,3192),(28828,3192),(28829,3192),(28830,3193),(28831,3193),(28832,3193),(28833,3194),(28834,3194),(28835,3194),(28836,3195),(28837,3195),(28838,3195),(28839,3196),(28840,3196),(28841,3196),(28842,3197),(28843,3197),(28844,3197),(28845,3198),(28846,3198),(28847,3198),(28848,3199),(28849,3199),(28850,3199),(28851,3200),(28852,3200),(28853,3200),(28854,3201),(28855,3201),(28856,3201),(28857,3202),(28858,3202),(28859,3202),(28860,3203),(28861,3203),(28862,3203),(28863,3204),(28864,3204),(28865,3204),(28866,3205),(28867,3205),(28868,3205),(28869,3206),(28870,3206),(28871,3206),(28872,3207),(28873,3207),(28874,3207),(28875,3208),(28876,3208),(28877,3208),(28878,3209),(28879,3209),(28880,3209),(28881,3210),(28882,3210),(28883,3210),(28884,3211),(28885,3211),(28886,3211),(28887,3212),(28888,3212),(28889,3212),(28890,3213),(28891,3213),(28892,3213),(28893,3214),(28894,3214),(28895,3214),(28896,3215),(28897,3215),(28898,3215),(28899,3216),(28900,3216),(28901,3216),(28902,3217),(28903,3217),(28904,3217),(28905,3218),(28906,3218),(28907,3218),(28908,3219),(28909,3219),(28910,3219),(28911,3220),(28912,3220),(28913,3220),(28914,3221),(28915,3221),(28916,3221),(28917,3222),(28918,3222),(28919,3222),(28920,3223),(28921,3223),(28922,3223),(28923,3224),(28924,3224),(28925,3224),(28926,3225),(28927,3225),(28928,3225),(28929,3226),(28930,3226),(28931,3226),(28932,3227),(28933,3227),(28934,3227),(28935,3228),(28936,3228),(28937,3228),(28938,3229),(28939,3229),(28940,3229),(28941,3230),(28942,3230),(28943,3230),(28944,3231),(28945,3231),(28946,3231),(28947,3232),(28948,3232),(28949,3232),(28950,3233),(28951,3233),(28952,3233),(28953,3234),(28954,3234),(28955,3234),(28956,3235),(28957,3235),(28958,3235),(28959,3236),(28960,3236),(28961,3236),(28962,3237),(28963,3237),(28964,3237),(28965,3238),(28966,3238),(28967,3238),(28968,3239),(28969,3239),(28970,3239),(28971,3240),(28972,3240),(28973,3240),(28974,3241),(28975,3241),(28976,3241),(28977,3242),(28978,3242),(28979,3242),(28980,3243),(28981,3243),(28982,3243),(28983,3244),(28984,3244),(28985,3244),(28986,3245),(28987,3245),(28988,3245),(28989,3246),(28990,3246),(28991,3246),(28992,3247),(28993,3247),(28994,3247),(28995,3248),(28996,3248),(28997,3248),(28998,3249),(28999,3249),(29000,3249),(29001,3250),(29002,3250),(29003,3250),(29004,3251),(29005,3251),(29006,3251),(29007,3252),(29008,3252),(29009,3252),(29010,3253),(29011,3253),(29012,3253),(29013,3254),(29014,3254),(29015,3254),(29016,3255),(29017,3255),(29018,3255),(29019,3256),(29020,3256),(29021,3256),(29022,3257),(29023,3257),(29024,3257),(29025,3258),(29026,3258),(29027,3258),(29028,3259),(29029,3259),(29030,3259),(29031,3260),(29032,3260),(29033,3260),(29034,3261),(29035,3261),(29036,3261),(29037,3262),(29038,3262),(29039,3262),(29040,3263),(29041,3263),(29042,3263),(29043,3264),(29044,3264),(29045,3264),(29046,3265),(29047,3265),(29048,3265),(29049,3266),(29050,3266),(29051,3266),(29052,3267),(29053,3267),(29054,3267),(29055,3268),(29056,3268),(29057,3268),(29058,3169),(29059,3169),(29060,3169),(29061,3169),(29062,3170),(29063,3170),(29064,3170),(29065,3170),(29066,3171),(29067,3171),(29068,3171),(29069,3171),(29070,3172),(29071,3172),(29072,3172),(29073,3172),(29074,3173),(29075,3173),(29076,3173),(29077,3173),(29078,3174),(29079,3174),(29080,3174),(29081,3174),(29082,3175),(29083,3175),(29084,3175),(29085,3175),(29086,3176),(29087,3176),(29088,3176),(29089,3176),(29090,3177),(29091,3177),(29092,3177),(29093,3177),(29094,3178),(29095,3178),(29096,3178),(29097,3178),(29098,3179),(29099,3179),(29100,3179),(29101,3179),(29102,3180),(29103,3180),(29104,3180),(29105,3180),(29106,3181),(29107,3181),(29108,3181),(29109,3181),(29110,3182),(29111,3182),(29112,3182),(29113,3182),(29114,3183),(29115,3183),(29116,3183),(29117,3183),(29118,3184),(29119,3184),(29120,3184),(29121,3184),(29122,3185),(29123,3185),(29124,3185),(29125,3185),(29126,3186),(29127,3186),(29128,3186),(29129,3186),(29130,3187),(29131,3187),(29132,3187),(29133,3187),(29134,3188),(29135,3188),(29136,3188),(29137,3188),(29138,3189),(29139,3189),(29140,3189),(29141,3189),(29142,3190),(29143,3190),(29144,3190),(29145,3190),(29146,3191),(29147,3191),(29148,3191),(29149,3191),(29150,3192),(29151,3192),(29152,3192),(29153,3192),(29154,3193),(29155,3193),(29156,3193),(29157,3193),(29158,3194),(29159,3194),(29160,3194),(29161,3194),(29162,3195),(29163,3195),(29164,3195),(29165,3195),(29166,3196),(29167,3196),(29168,3196),(29169,3196),(29170,3197),(29171,3197),(29172,3197),(29173,3197),(29174,3198),(29175,3198),(29176,3198),(29177,3198),(29178,3199),(29179,3199),(29180,3199),(29181,3199),(29182,3200),(29183,3200),(29184,3200),(29185,3200),(29186,3201),(29187,3201),(29188,3201),(29189,3201),(29190,3202),(29191,3202),(29192,3202),(29193,3202),(29194,3203),(29195,3203),(29196,3203),(29197,3203),(29198,3204),(29199,3204),(29200,3204),(29201,3204),(29202,3205),(29203,3205),(29204,3205),(29205,3205),(29206,3206),(29207,3206),(29208,3206),(29209,3206),(29210,3207),(29211,3207),(29212,3207),(29213,3207),(29214,3208),(29215,3208),(29216,3208),(29217,3208),(29218,3209),(29219,3209),(29220,3209),(29221,3209),(29222,3210),(29223,3210),(29224,3210),(29225,3210),(29226,3211),(29227,3211),(29228,3211),(29229,3211),(29230,3212),(29231,3212),(29232,3212),(29233,3212),(29234,3213),(29235,3213),(29236,3213),(29237,3213),(29238,3214),(29239,3214),(29240,3214),(29241,3214),(29242,3215),(29243,3215),(29244,3215),(29245,3215),(29246,3216),(29247,3216),(29248,3216),(29249,3216),(29250,3217),(29251,3217),(29252,3217),(29253,3217),(29254,3218),(29255,3218),(29256,3218),(29257,3218),(29258,3219),(29259,3219),(29260,3219),(29261,3219),(29262,3220),(29263,3220),(29264,3220),(29265,3220),(29266,3221),(29267,3221),(29268,3221),(29269,3221),(29270,3222),(29271,3222),(29272,3222),(29273,3222),(29274,3223),(29275,3223),(29276,3223),(29277,3223),(29278,3224),(29279,3224),(29280,3224),(29281,3224),(29282,3225),(29283,3225),(29284,3225),(29285,3225),(29286,3226),(29287,3226),(29288,3226),(29289,3226),(29290,3227),(29291,3227),(29292,3227),(29293,3227),(29294,3228),(29295,3228),(29296,3228),(29297,3228),(29298,3229),(29299,3229),(29300,3229),(29301,3229),(29302,3230),(29303,3230),(29304,3230),(29305,3230),(29306,3231),(29307,3231),(29308,3231),(29309,3231),(29310,3232),(29311,3232),(29312,3232),(29313,3232),(29314,3233),(29315,3233),(29316,3233),(29317,3233),(29318,3234),(29319,3234),(29320,3234),(29321,3234),(29322,3235),(29323,3235),(29324,3235),(29325,3235),(29326,3236),(29327,3236),(29328,3236),(29329,3236),(29330,3237),(29331,3237),(29332,3237),(29333,3237),(29334,3238),(29335,3238),(29336,3238),(29337,3238),(29338,3239),(29339,3239),(29340,3239),(29341,3239),(29342,3240),(29343,3240),(29344,3240),(29345,3240),(29346,3241),(29347,3241),(29348,3241),(29349,3241),(29350,3242),(29351,3242),(29352,3242),(29353,3242),(29354,3243),(29355,3243),(29356,3243),(29357,3243),(29358,3244),(29359,3244),(29360,3244),(29361,3244),(29362,3245),(29363,3245),(29364,3245),(29365,3245),(29366,3246),(29367,3246),(29368,3246),(29369,3246),(29370,3247),(29371,3247),(29372,3247),(29373,3247),(29374,3248),(29375,3248),(29376,3248),(29377,3248),(29378,3249),(29379,3249),(29380,3249),(29381,3249),(29382,3250),(29383,3250),(29384,3250),(29385,3250),(29386,3251),(29387,3251),(29388,3251),(29389,3251),(29390,3252),(29391,3252),(29392,3252),(29393,3252),(29394,3253),(29395,3253),(29396,3253),(29397,3253),(29398,3254),(29399,3254),(29400,3254),(29401,3254),(29402,3255),(29403,3255),(29404,3255),(29405,3255),(29406,3256),(29407,3256),(29408,3256),(29409,3256),(29410,3257),(29411,3257),(29412,3257),(29413,3257),(29414,3258),(29415,3258),(29416,3258),(29417,3258),(29418,3259),(29419,3259),(29420,3259),(29421,3259),(29422,3260),(29423,3260),(29424,3260),(29425,3260),(29426,3261),(29427,3261),(29428,3261),(29429,3261),(29430,3262),(29431,3262),(29432,3262),(29433,3262),(29434,3263),(29435,3263),(29436,3263),(29437,3263),(29438,3264),(29439,3264),(29440,3264),(29441,3264),(29442,3265),(29443,3265),(29444,3265),(29445,3265),(29446,3266),(29447,3266),(29448,3266),(29449,3266),(29450,3267),(29451,3267),(29452,3267),(29453,3267),(29454,3268),(29455,3268),(29456,3268),(29457,3268),(29458,3269),(29459,3270),(29460,3271),(29461,3272),(29462,3273),(29463,3274),(29464,3275),(29465,3276),(29466,3277),(29467,3278),(29468,3279),(29469,3280),(29470,3281),(29471,3282),(29472,3283),(29473,3284),(29474,3285),(29475,3286),(29476,3287),(29477,3288),(29478,3289),(29479,3290),(29480,3291),(29481,3292),(29482,3293),(29483,3294),(29484,3295),(29485,3296),(29486,3297),(29487,3298),(29488,3299),(29489,3300),(29490,3301),(29491,3302),(29492,3303),(29493,3304),(29494,3305),(29495,3306),(29496,3307),(29497,3308),(29498,3309),(29499,3310),(29500,3311),(29501,3312),(29502,3313),(29503,3314),(29504,3315),(29505,3316),(29506,3317),(29507,3318),(29508,3319),(29509,3320),(29510,3321),(29511,3322),(29512,3323),(29513,3324),(29514,3325),(29515,3326),(29516,3327),(29517,3328),(29518,3329),(29519,3330),(29520,3331),(29521,3332),(29522,3333),(29523,3334),(29524,3335),(29525,3336),(29526,3337),(29527,3338),(29528,3339),(29529,3340),(29530,3341),(29531,3342),(29532,3343),(29533,3344),(29534,3345),(29535,3346),(29536,3347),(29537,3348),(29538,3349),(29539,3350),(29540,3351),(29541,3352),(29542,3353),(29543,3354),(29544,3355),(29545,3356),(29546,3357),(29547,3358),(29548,3359),(29549,3360),(29550,3361),(29551,3362),(29552,3363),(29553,3364),(29554,3365),(29555,3366),(29556,3367),(29557,3368),(29558,3269),(29559,3270),(29560,3271),(29561,3272),(29562,3273),(29563,3274),(29564,3275),(29565,3276),(29566,3277),(29567,3278),(29568,3279),(29569,3280),(29570,3281),(29571,3282),(29572,3283),(29573,3284),(29574,3285),(29575,3286),(29576,3287),(29577,3288),(29578,3289),(29579,3290),(29580,3291),(29581,3292),(29582,3293),(29583,3294),(29584,3295),(29585,3296),(29586,3297),(29587,3298),(29588,3299),(29589,3300),(29590,3301),(29591,3302),(29592,3303),(29593,3304),(29594,3305),(29595,3306),(29596,3307),(29597,3308),(29598,3309),(29599,3310),(29600,3311),(29601,3312),(29602,3313),(29603,3314),(29604,3315),(29605,3316),(29606,3317),(29607,3318),(29608,3319),(29609,3320),(29610,3321),(29611,3322),(29612,3323),(29613,3324),(29614,3325),(29615,3326),(29616,3327),(29617,3328),(29618,3329),(29619,3330),(29620,3331),(29621,3332),(29622,3333),(29623,3334),(29624,3335),(29625,3336),(29626,3337),(29627,3338),(29628,3339),(29629,3340),(29630,3341),(29631,3342),(29632,3343),(29633,3344),(29634,3345),(29635,3346),(29636,3347),(29637,3348),(29638,3349),(29639,3350),(29640,3351),(29641,3352),(29642,3353),(29643,3354),(29644,3355),(29645,3356),(29646,3357),(29647,3358),(29648,3359),(29649,3360),(29650,3361),(29651,3362),(29652,3363),(29653,3364),(29654,3365),(29655,3366),(29656,3367),(29657,3368),(29658,3269),(29659,3269),(29660,3269),(29661,3270),(29662,3270),(29663,3270),(29664,3271),(29665,3271),(29666,3271),(29667,3272),(29668,3272),(29669,3272),(29670,3273),(29671,3273),(29672,3273),(29673,3274),(29674,3274),(29675,3274),(29676,3275),(29677,3275),(29678,3275),(29679,3276),(29680,3276),(29681,3276),(29682,3277),(29683,3277),(29684,3277),(29685,3278),(29686,3278),(29687,3278),(29688,3279),(29689,3279),(29690,3279),(29691,3280),(29692,3280),(29693,3280),(29694,3281),(29695,3281),(29696,3281),(29697,3282),(29698,3282),(29699,3282),(29700,3283),(29701,3283),(29702,3283),(29703,3284),(29704,3284),(29705,3284),(29706,3285),(29707,3285),(29708,3285),(29709,3286),(29710,3286),(29711,3286),(29712,3287),(29713,3287),(29714,3287),(29715,3288),(29716,3288),(29717,3288),(29718,3289),(29719,3289),(29720,3289),(29721,3290),(29722,3290),(29723,3290),(29724,3291),(29725,3291),(29726,3291),(29727,3292),(29728,3292),(29729,3292),(29730,3293),(29731,3293),(29732,3293),(29733,3294),(29734,3294),(29735,3294),(29736,3295),(29737,3295),(29738,3295),(29739,3296),(29740,3296),(29741,3296),(29742,3297),(29743,3297),(29744,3297),(29745,3298),(29746,3298),(29747,3298),(29748,3299),(29749,3299),(29750,3299),(29751,3300),(29752,3300),(29753,3300),(29754,3301),(29755,3301),(29756,3301),(29757,3302),(29758,3302),(29759,3302),(29760,3303),(29761,3303),(29762,3303),(29763,3304),(29764,3304),(29765,3304),(29766,3305),(29767,3305),(29768,3305),(29769,3306),(29770,3306),(29771,3306),(29772,3307),(29773,3307),(29774,3307),(29775,3308),(29776,3308),(29777,3308),(29778,3309),(29779,3309),(29780,3309),(29781,3310),(29782,3310),(29783,3310),(29784,3311),(29785,3311),(29786,3311),(29787,3312),(29788,3312),(29789,3312),(29790,3313),(29791,3313),(29792,3313),(29793,3314),(29794,3314),(29795,3314),(29796,3315),(29797,3315),(29798,3315),(29799,3316),(29800,3316),(29801,3316),(29802,3317),(29803,3317),(29804,3317),(29805,3318),(29806,3318),(29807,3318),(29808,3319),(29809,3319),(29810,3319),(29811,3320),(29812,3320),(29813,3320),(29814,3321),(29815,3321),(29816,3321),(29817,3322),(29818,3322),(29819,3322),(29820,3323),(29821,3323),(29822,3323),(29823,3324),(29824,3324),(29825,3324),(29826,3325),(29827,3325),(29828,3325),(29829,3326),(29830,3326),(29831,3326),(29832,3327),(29833,3327),(29834,3327),(29835,3328),(29836,3328),(29837,3328),(29838,3329),(29839,3329),(29840,3329),(29841,3330),(29842,3330),(29843,3330),(29844,3331),(29845,3331),(29846,3331),(29847,3332),(29848,3332),(29849,3332),(29850,3333),(29851,3333),(29852,3333),(29853,3334),(29854,3334),(29855,3334),(29856,3335),(29857,3335),(29858,3335),(29859,3336),(29860,3336),(29861,3336),(29862,3337),(29863,3337),(29864,3337),(29865,3338),(29866,3338),(29867,3338),(29868,3339),(29869,3339),(29870,3339),(29871,3340),(29872,3340),(29873,3340),(29874,3341),(29875,3341),(29876,3341),(29877,3342),(29878,3342),(29879,3342),(29880,3343),(29881,3343),(29882,3343),(29883,3344),(29884,3344),(29885,3344),(29886,3345),(29887,3345),(29888,3345),(29889,3346),(29890,3346),(29891,3346),(29892,3347),(29893,3347),(29894,3347),(29895,3348),(29896,3348),(29897,3348),(29898,3349),(29899,3349),(29900,3349),(29901,3350),(29902,3350),(29903,3350),(29904,3351),(29905,3351),(29906,3351),(29907,3352),(29908,3352),(29909,3352),(29910,3353),(29911,3353),(29912,3353),(29913,3354),(29914,3354),(29915,3354),(29916,3355),(29917,3355),(29918,3355),(29919,3356),(29920,3356),(29921,3356),(29922,3357),(29923,3357),(29924,3357),(29925,3358),(29926,3358),(29927,3358),(29928,3359),(29929,3359),(29930,3359),(29931,3360),(29932,3360),(29933,3360),(29934,3361),(29935,3361),(29936,3361),(29937,3362),(29938,3362),(29939,3362),(29940,3363),(29941,3363),(29942,3363),(29943,3364),(29944,3364),(29945,3364),(29946,3365),(29947,3365),(29948,3365),(29949,3366),(29950,3366),(29951,3366),(29952,3367),(29953,3367),(29954,3367),(29955,3368),(29956,3368),(29957,3368),(29958,3269),(29959,3269),(29960,3269),(29961,3269),(29962,3270),(29963,3270),(29964,3270),(29965,3270),(29966,3271),(29967,3271),(29968,3271),(29969,3271),(29970,3272),(29971,3272),(29972,3272),(29973,3272),(29974,3273),(29975,3273),(29976,3273),(29977,3273),(29978,3274),(29979,3274),(29980,3274),(29981,3274),(29982,3275),(29983,3275),(29984,3275),(29985,3275),(29986,3276),(29987,3276),(29988,3276),(29989,3276),(29990,3277),(29991,3277),(29992,3277),(29993,3277),(29994,3278),(29995,3278),(29996,3278),(29997,3278),(29998,3279),(29999,3279),(30000,3279),(30001,3279),(30002,3280),(30003,3280),(30004,3280),(30005,3280),(30006,3281),(30007,3281),(30008,3281),(30009,3281),(30010,3282),(30011,3282),(30012,3282),(30013,3282),(30014,3283),(30015,3283),(30016,3283),(30017,3283),(30018,3284),(30019,3284),(30020,3284),(30021,3284),(30022,3285),(30023,3285),(30024,3285),(30025,3285),(30026,3286),(30027,3286),(30028,3286),(30029,3286),(30030,3287),(30031,3287),(30032,3287),(30033,3287),(30034,3288),(30035,3288),(30036,3288),(30037,3288),(30038,3289),(30039,3289),(30040,3289),(30041,3289),(30042,3290),(30043,3290),(30044,3290),(30045,3290),(30046,3291),(30047,3291),(30048,3291),(30049,3291),(30050,3292),(30051,3292),(30052,3292),(30053,3292),(30054,3293),(30055,3293),(30056,3293),(30057,3293),(30058,3294),(30059,3294),(30060,3294),(30061,3294),(30062,3295),(30063,3295),(30064,3295),(30065,3295),(30066,3296),(30067,3296),(30068,3296),(30069,3296),(30070,3297),(30071,3297),(30072,3297),(30073,3297),(30074,3298),(30075,3298),(30076,3298),(30077,3298),(30078,3299),(30079,3299),(30080,3299),(30081,3299),(30082,3300),(30083,3300),(30084,3300),(30085,3300),(30086,3301),(30087,3301),(30088,3301),(30089,3301),(30090,3302),(30091,3302),(30092,3302),(30093,3302),(30094,3303),(30095,3303),(30096,3303),(30097,3303),(30098,3304),(30099,3304),(30100,3304),(30101,3304),(30102,3305),(30103,3305),(30104,3305),(30105,3305),(30106,3306),(30107,3306),(30108,3306),(30109,3306),(30110,3307),(30111,3307),(30112,3307),(30113,3307),(30114,3308),(30115,3308),(30116,3308),(30117,3308),(30118,3309),(30119,3309),(30120,3309),(30121,3309),(30122,3310),(30123,3310),(30124,3310),(30125,3310),(30126,3311),(30127,3311),(30128,3311),(30129,3311),(30130,3312),(30131,3312),(30132,3312),(30133,3312),(30134,3313),(30135,3313),(30136,3313),(30137,3313),(30138,3314),(30139,3314),(30140,3314),(30141,3314),(30142,3315),(30143,3315),(30144,3315),(30145,3315),(30146,3316),(30147,3316),(30148,3316),(30149,3316),(30150,3317),(30151,3317),(30152,3317),(30153,3317),(30154,3318),(30155,3318),(30156,3318),(30157,3318),(30158,3319),(30159,3319),(30160,3319),(30161,3319),(30162,3320),(30163,3320),(30164,3320),(30165,3320),(30166,3321),(30167,3321),(30168,3321),(30169,3321),(30170,3322),(30171,3322),(30172,3322),(30173,3322),(30174,3323),(30175,3323),(30176,3323),(30177,3323),(30178,3324),(30179,3324),(30180,3324),(30181,3324),(30182,3325),(30183,3325),(30184,3325),(30185,3325),(30186,3326),(30187,3326),(30188,3326),(30189,3326),(30190,3327),(30191,3327),(30192,3327),(30193,3327),(30194,3328),(30195,3328),(30196,3328),(30197,3328),(30198,3329),(30199,3329),(30200,3329),(30201,3329),(30202,3330),(30203,3330),(30204,3330),(30205,3330),(30206,3331),(30207,3331),(30208,3331),(30209,3331),(30210,3332),(30211,3332),(30212,3332),(30213,3332),(30214,3333),(30215,3333),(30216,3333),(30217,3333),(30218,3334),(30219,3334),(30220,3334),(30221,3334),(30222,3335),(30223,3335),(30224,3335),(30225,3335),(30226,3336),(30227,3336),(30228,3336),(30229,3336),(30230,3337),(30231,3337),(30232,3337),(30233,3337),(30234,3338),(30235,3338),(30236,3338),(30237,3338),(30238,3339),(30239,3339),(30240,3339),(30241,3339),(30242,3340),(30243,3340),(30244,3340),(30245,3340),(30246,3341),(30247,3341),(30248,3341),(30249,3341),(30250,3342),(30251,3342),(30252,3342),(30253,3342),(30254,3343),(30255,3343),(30256,3343),(30257,3343),(30258,3344),(30259,3344),(30260,3344),(30261,3344),(30262,3345),(30263,3345),(30264,3345),(30265,3345),(30266,3346),(30267,3346),(30268,3346),(30269,3346),(30270,3347),(30271,3347),(30272,3347),(30273,3347),(30274,3348),(30275,3348),(30276,3348),(30277,3348),(30278,3349),(30279,3349),(30280,3349),(30281,3349),(30282,3350),(30283,3350),(30284,3350),(30285,3350),(30286,3351),(30287,3351),(30288,3351),(30289,3351),(30290,3352),(30291,3352),(30292,3352),(30293,3352),(30294,3353),(30295,3353),(30296,3353),(30297,3353),(30298,3354),(30299,3354),(30300,3354),(30301,3354),(30302,3355),(30303,3355),(30304,3355),(30305,3355),(30306,3356),(30307,3356),(30308,3356),(30309,3356),(30310,3357),(30311,3357),(30312,3357),(30313,3357),(30314,3358),(30315,3358),(30316,3358),(30317,3358),(30318,3359),(30319,3359),(30320,3359),(30321,3359),(30322,3360),(30323,3360),(30324,3360),(30325,3360),(30326,3361),(30327,3361),(30328,3361),(30329,3361),(30330,3362),(30331,3362),(30332,3362),(30333,3362),(30334,3363),(30335,3363),(30336,3363),(30337,3363),(30338,3364),(30339,3364),(30340,3364),(30341,3364),(30342,3365),(30343,3365),(30344,3365),(30345,3365),(30346,3366),(30347,3366),(30348,3366),(30349,3366),(30350,3367),(30351,3367),(30352,3367),(30353,3367),(30354,3368),(30355,3368),(30356,3368),(30357,3368),(30358,3369),(30359,3370),(30360,3371),(30361,3372),(30362,3373),(30363,3374),(30364,3375),(30365,3376),(30366,3377),(30367,3378),(30368,3379),(30369,3380),(30370,3381),(30371,3382),(30372,3383),(30373,3384),(30374,3385),(30375,3386),(30376,3387),(30377,3388),(30378,3389),(30379,3390),(30380,3391),(30381,3392),(30382,3393),(30383,3394),(30384,3395),(30385,3396),(30386,3397),(30387,3398),(30388,3399),(30389,3400),(30390,3401),(30391,3402),(30392,3403),(30393,3404),(30394,3405),(30395,3406),(30396,3407),(30397,3408),(30398,3409),(30399,3410),(30400,3411),(30401,3412),(30402,3413),(30403,3414),(30404,3415),(30405,3416),(30406,3417),(30407,3418),(30408,3419),(30409,3420),(30410,3421),(30411,3422),(30412,3423),(30413,3424),(30414,3425),(30415,3426),(30416,3427),(30417,3428),(30418,3429),(30419,3430),(30420,3431),(30421,3432),(30422,3433),(30423,3434),(30424,3435),(30425,3436),(30426,3437),(30427,3438),(30428,3439),(30429,3440),(30430,3441),(30431,3442),(30432,3443),(30433,3444),(30434,3445),(30435,3446),(30436,3447),(30437,3448),(30438,3449),(30439,3450),(30440,3451),(30441,3452),(30442,3453),(30443,3454),(30444,3455),(30445,3456),(30446,3457),(30447,3458),(30448,3459),(30449,3460),(30450,3461),(30451,3462),(30452,3463),(30453,3464),(30454,3465),(30455,3466),(30456,3467),(30457,3468),(30458,3369),(30459,3370),(30460,3371),(30461,3372),(30462,3373),(30463,3374),(30464,3375),(30465,3376),(30466,3377),(30467,3378),(30468,3379),(30469,3380),(30470,3381),(30471,3382),(30472,3383),(30473,3384),(30474,3385),(30475,3386),(30476,3387),(30477,3388),(30478,3389),(30479,3390),(30480,3391),(30481,3392),(30482,3393),(30483,3394),(30484,3395),(30485,3396),(30486,3397),(30487,3398),(30488,3399),(30489,3400),(30490,3401),(30491,3402),(30492,3403),(30493,3404),(30494,3405),(30495,3406),(30496,3407),(30497,3408),(30498,3409),(30499,3410),(30500,3411),(30501,3412),(30502,3413),(30503,3414),(30504,3415),(30505,3416),(30506,3417),(30507,3418),(30508,3419),(30509,3420),(30510,3421),(30511,3422),(30512,3423),(30513,3424),(30514,3425),(30515,3426),(30516,3427),(30517,3428),(30518,3429),(30519,3430),(30520,3431),(30521,3432),(30522,3433),(30523,3434),(30524,3435),(30525,3436),(30526,3437),(30527,3438),(30528,3439),(30529,3440),(30530,3441),(30531,3442),(30532,3443),(30533,3444),(30534,3445),(30535,3446),(30536,3447),(30537,3448),(30538,3449),(30539,3450),(30540,3451),(30541,3452),(30542,3453),(30543,3454),(30544,3455),(30545,3456),(30546,3457),(30547,3458),(30548,3459),(30549,3460),(30550,3461),(30551,3462),(30552,3463),(30553,3464),(30554,3465),(30555,3466),(30556,3467),(30557,3468),(30558,3369),(30559,3369),(30560,3369),(30561,3370),(30562,3370),(30563,3370),(30564,3371),(30565,3371),(30566,3371),(30567,3372),(30568,3372),(30569,3372),(30570,3373),(30571,3373),(30572,3373),(30573,3374),(30574,3374),(30575,3374),(30576,3375),(30577,3375),(30578,3375),(30579,3376),(30580,3376),(30581,3376),(30582,3377),(30583,3377),(30584,3377),(30585,3378),(30586,3378),(30587,3378),(30588,3379),(30589,3379),(30590,3379),(30591,3380),(30592,3380),(30593,3380),(30594,3381),(30595,3381),(30596,3381),(30597,3382),(30598,3382),(30599,3382),(30600,3383),(30601,3383),(30602,3383),(30603,3384),(30604,3384),(30605,3384),(30606,3385),(30607,3385),(30608,3385),(30609,3386),(30610,3386),(30611,3386),(30612,3387),(30613,3387),(30614,3387),(30615,3388),(30616,3388),(30617,3388),(30618,3389),(30619,3389),(30620,3389),(30621,3390),(30622,3390),(30623,3390),(30624,3391),(30625,3391),(30626,3391),(30627,3392),(30628,3392),(30629,3392),(30630,3393),(30631,3393),(30632,3393),(30633,3394),(30634,3394),(30635,3394),(30636,3395),(30637,3395),(30638,3395),(30639,3396),(30640,3396),(30641,3396),(30642,3397),(30643,3397),(30644,3397),(30645,3398),(30646,3398),(30647,3398),(30648,3399),(30649,3399),(30650,3399),(30651,3400),(30652,3400),(30653,3400),(30654,3401),(30655,3401),(30656,3401),(30657,3402),(30658,3402),(30659,3402),(30660,3403),(30661,3403),(30662,3403),(30663,3404),(30664,3404),(30665,3404),(30666,3405),(30667,3405),(30668,3405),(30669,3406),(30670,3406),(30671,3406),(30672,3407),(30673,3407),(30674,3407),(30675,3408),(30676,3408),(30677,3408),(30678,3409),(30679,3409),(30680,3409),(30681,3410),(30682,3410),(30683,3410),(30684,3411),(30685,3411),(30686,3411),(30687,3412),(30688,3412),(30689,3412),(30690,3413),(30691,3413),(30692,3413),(30693,3414),(30694,3414),(30695,3414),(30696,3415),(30697,3415),(30698,3415),(30699,3416),(30700,3416),(30701,3416),(30702,3417),(30703,3417),(30704,3417),(30705,3418),(30706,3418),(30707,3418),(30708,3419),(30709,3419),(30710,3419),(30711,3420),(30712,3420),(30713,3420),(30714,3421),(30715,3421),(30716,3421),(30717,3422),(30718,3422),(30719,3422),(30720,3423),(30721,3423),(30722,3423),(30723,3424),(30724,3424),(30725,3424),(30726,3425),(30727,3425),(30728,3425),(30729,3426),(30730,3426),(30731,3426),(30732,3427),(30733,3427),(30734,3427),(30735,3428),(30736,3428),(30737,3428),(30738,3429),(30739,3429),(30740,3429),(30741,3430),(30742,3430),(30743,3430),(30744,3431),(30745,3431),(30746,3431),(30747,3432),(30748,3432),(30749,3432),(30750,3433),(30751,3433),(30752,3433),(30753,3434),(30754,3434),(30755,3434),(30756,3435),(30757,3435),(30758,3435),(30759,3436),(30760,3436),(30761,3436),(30762,3437),(30763,3437),(30764,3437),(30765,3438),(30766,3438),(30767,3438),(30768,3439),(30769,3439),(30770,3439),(30771,3440),(30772,3440),(30773,3440),(30774,3441),(30775,3441),(30776,3441),(30777,3442),(30778,3442),(30779,3442),(30780,3443),(30781,3443),(30782,3443),(30783,3444),(30784,3444),(30785,3444),(30786,3445),(30787,3445),(30788,3445),(30789,3446),(30790,3446),(30791,3446),(30792,3447),(30793,3447),(30794,3447),(30795,3448),(30796,3448),(30797,3448),(30798,3449),(30799,3449),(30800,3449),(30801,3450),(30802,3450),(30803,3450),(30804,3451),(30805,3451),(30806,3451),(30807,3452),(30808,3452),(30809,3452),(30810,3453),(30811,3453),(30812,3453),(30813,3454),(30814,3454),(30815,3454),(30816,3455),(30817,3455),(30818,3455),(30819,3456),(30820,3456),(30821,3456),(30822,3457),(30823,3457),(30824,3457),(30825,3458),(30826,3458),(30827,3458),(30828,3459),(30829,3459),(30830,3459),(30831,3460),(30832,3460),(30833,3460),(30834,3461),(30835,3461),(30836,3461),(30837,3462),(30838,3462),(30839,3462),(30840,3463),(30841,3463),(30842,3463),(30843,3464),(30844,3464),(30845,3464),(30846,3465),(30847,3465),(30848,3465),(30849,3466),(30850,3466),(30851,3466),(30852,3467),(30853,3467),(30854,3467),(30855,3468),(30856,3468),(30857,3468),(30858,3369),(30859,3369),(30860,3369),(30861,3369),(30862,3370),(30863,3370),(30864,3370),(30865,3370),(30866,3371),(30867,3371),(30868,3371),(30869,3371),(30870,3372),(30871,3372),(30872,3372),(30873,3372),(30874,3373),(30875,3373),(30876,3373),(30877,3373),(30878,3374),(30879,3374),(30880,3374),(30881,3374),(30882,3375),(30883,3375),(30884,3375),(30885,3375),(30886,3376),(30887,3376),(30888,3376),(30889,3376),(30890,3377),(30891,3377),(30892,3377),(30893,3377),(30894,3378),(30895,3378),(30896,3378),(30897,3378),(30898,3379),(30899,3379),(30900,3379),(30901,3379),(30902,3380),(30903,3380),(30904,3380),(30905,3380),(30906,3381),(30907,3381),(30908,3381),(30909,3381),(30910,3382),(30911,3382),(30912,3382),(30913,3382),(30914,3383),(30915,3383),(30916,3383),(30917,3383),(30918,3384),(30919,3384),(30920,3384),(30921,3384),(30922,3385),(30923,3385),(30924,3385),(30925,3385),(30926,3386),(30927,3386),(30928,3386),(30929,3386),(30930,3387),(30931,3387),(30932,3387),(30933,3387),(30934,3388),(30935,3388),(30936,3388),(30937,3388),(30938,3389),(30939,3389),(30940,3389),(30941,3389),(30942,3390),(30943,3390),(30944,3390),(30945,3390),(30946,3391),(30947,3391),(30948,3391),(30949,3391),(30950,3392),(30951,3392),(30952,3392),(30953,3392),(30954,3393),(30955,3393),(30956,3393),(30957,3393),(30958,3394),(30959,3394),(30960,3394),(30961,3394),(30962,3395),(30963,3395),(30964,3395),(30965,3395),(30966,3396),(30967,3396),(30968,3396),(30969,3396),(30970,3397),(30971,3397),(30972,3397),(30973,3397),(30974,3398),(30975,3398),(30976,3398),(30977,3398),(30978,3399),(30979,3399),(30980,3399),(30981,3399),(30982,3400),(30983,3400),(30984,3400),(30985,3400),(30986,3401),(30987,3401),(30988,3401),(30989,3401),(30990,3402),(30991,3402),(30992,3402),(30993,3402),(30994,3403),(30995,3403),(30996,3403),(30997,3403),(30998,3404),(30999,3404),(31000,3404),(31001,3404),(31002,3405),(31003,3405),(31004,3405),(31005,3405),(31006,3406),(31007,3406),(31008,3406),(31009,3406),(31010,3407),(31011,3407),(31012,3407),(31013,3407),(31014,3408),(31015,3408),(31016,3408),(31017,3408),(31018,3409),(31019,3409),(31020,3409),(31021,3409),(31022,3410),(31023,3410),(31024,3410),(31025,3410),(31026,3411),(31027,3411),(31028,3411),(31029,3411),(31030,3412),(31031,3412),(31032,3412),(31033,3412),(31034,3413),(31035,3413),(31036,3413),(31037,3413),(31038,3414),(31039,3414),(31040,3414),(31041,3414),(31042,3415),(31043,3415),(31044,3415),(31045,3415),(31046,3416),(31047,3416),(31048,3416),(31049,3416),(31050,3417),(31051,3417),(31052,3417),(31053,3417),(31054,3418),(31055,3418),(31056,3418),(31057,3418),(31058,3419),(31059,3419),(31060,3419),(31061,3419),(31062,3420),(31063,3420),(31064,3420),(31065,3420),(31066,3421),(31067,3421),(31068,3421),(31069,3421),(31070,3422),(31071,3422),(31072,3422),(31073,3422),(31074,3423),(31075,3423),(31076,3423),(31077,3423),(31078,3424),(31079,3424),(31080,3424),(31081,3424),(31082,3425),(31083,3425),(31084,3425),(31085,3425),(31086,3426),(31087,3426),(31088,3426),(31089,3426),(31090,3427),(31091,3427),(31092,3427),(31093,3427),(31094,3428),(31095,3428),(31096,3428),(31097,3428),(31098,3429),(31099,3429),(31100,3429),(31101,3429),(31102,3430),(31103,3430),(31104,3430),(31105,3430),(31106,3431),(31107,3431),(31108,3431),(31109,3431),(31110,3432),(31111,3432),(31112,3432),(31113,3432),(31114,3433),(31115,3433),(31116,3433),(31117,3433),(31118,3434),(31119,3434),(31120,3434),(31121,3434),(31122,3435),(31123,3435),(31124,3435),(31125,3435),(31126,3436),(31127,3436),(31128,3436),(31129,3436),(31130,3437),(31131,3437),(31132,3437),(31133,3437),(31134,3438),(31135,3438),(31136,3438),(31137,3438),(31138,3439),(31139,3439),(31140,3439),(31141,3439),(31142,3440),(31143,3440),(31144,3440),(31145,3440),(31146,3441),(31147,3441),(31148,3441),(31149,3441),(31150,3442),(31151,3442),(31152,3442),(31153,3442),(31154,3443),(31155,3443),(31156,3443),(31157,3443),(31158,3444),(31159,3444),(31160,3444),(31161,3444),(31162,3445),(31163,3445),(31164,3445),(31165,3445),(31166,3446),(31167,3446),(31168,3446),(31169,3446),(31170,3447),(31171,3447),(31172,3447),(31173,3447),(31174,3448),(31175,3448),(31176,3448),(31177,3448),(31178,3449),(31179,3449),(31180,3449),(31181,3449),(31182,3450),(31183,3450),(31184,3450),(31185,3450),(31186,3451),(31187,3451),(31188,3451),(31189,3451),(31190,3452),(31191,3452),(31192,3452),(31193,3452),(31194,3453),(31195,3453),(31196,3453),(31197,3453),(31198,3454),(31199,3454),(31200,3454),(31201,3454),(31202,3455),(31203,3455),(31204,3455),(31205,3455),(31206,3456),(31207,3456),(31208,3456),(31209,3456),(31210,3457),(31211,3457),(31212,3457),(31213,3457),(31214,3458),(31215,3458),(31216,3458),(31217,3458),(31218,3459),(31219,3459),(31220,3459),(31221,3459),(31222,3460),(31223,3460),(31224,3460),(31225,3460),(31226,3461),(31227,3461),(31228,3461),(31229,3461),(31230,3462),(31231,3462),(31232,3462),(31233,3462),(31234,3463),(31235,3463),(31236,3463),(31237,3463),(31238,3464),(31239,3464),(31240,3464),(31241,3464),(31242,3465),(31243,3465),(31244,3465),(31245,3465),(31246,3466),(31247,3466),(31248,3466),(31249,3466),(31250,3467),(31251,3467),(31252,3467),(31253,3467),(31254,3468),(31255,3468),(31256,3468),(31257,3468),(31258,3469),(31259,3470),(31260,3471),(31261,3472),(31262,3473),(31263,3474),(31264,3475),(31265,3476),(31266,3477),(31267,3478),(31268,3479),(31269,3480),(31270,3481),(31271,3482),(31272,3483),(31273,3484),(31274,3485),(31275,3486),(31276,3487),(31277,3488),(31278,3489),(31279,3490),(31280,3491),(31281,3492),(31282,3493),(31283,3494),(31284,3495),(31285,3496),(31286,3497),(31287,3498),(31288,3499),(31289,3500),(31290,3501),(31291,3502),(31292,3503),(31293,3504),(31294,3505),(31295,3506),(31296,3507),(31297,3508),(31298,3509),(31299,3510),(31300,3511),(31301,3512),(31302,3513),(31303,3514),(31304,3515),(31305,3516),(31306,3517),(31307,3518),(31308,3519),(31309,3520),(31310,3521),(31311,3522),(31312,3523),(31313,3524),(31314,3525),(31315,3526),(31316,3527),(31317,3528),(31318,3529),(31319,3530),(31320,3531),(31321,3532),(31322,3533),(31323,3534),(31324,3535),(31325,3536),(31326,3537),(31327,3538),(31328,3539),(31329,3540),(31330,3541),(31331,3542),(31332,3543),(31333,3544),(31334,3545),(31335,3546),(31336,3547),(31337,3548),(31338,3549),(31339,3550),(31340,3551),(31341,3552),(31342,3553),(31343,3554),(31344,3555),(31345,3556),(31346,3557),(31347,3558),(31348,3559),(31349,3560),(31350,3561),(31351,3562),(31352,3563),(31353,3564),(31354,3565),(31355,3566),(31356,3567),(31357,3568),(31358,3469),(31359,3470),(31360,3471),(31361,3472),(31362,3473),(31363,3474),(31364,3475),(31365,3476),(31366,3477),(31367,3478),(31368,3479),(31369,3480),(31370,3481),(31371,3482),(31372,3483),(31373,3484),(31374,3485),(31375,3486),(31376,3487),(31377,3488),(31378,3489),(31379,3490),(31380,3491),(31381,3492),(31382,3493),(31383,3494),(31384,3495),(31385,3496),(31386,3497),(31387,3498),(31388,3499),(31389,3500),(31390,3501),(31391,3502),(31392,3503),(31393,3504),(31394,3505),(31395,3506),(31396,3507),(31397,3508),(31398,3509),(31399,3510),(31400,3511),(31401,3512),(31402,3513),(31403,3514),(31404,3515),(31405,3516),(31406,3517),(31407,3518),(31408,3519),(31409,3520),(31410,3521),(31411,3522),(31412,3523),(31413,3524),(31414,3525),(31415,3526),(31416,3527),(31417,3528),(31418,3529),(31419,3530),(31420,3531),(31421,3532),(31422,3533),(31423,3534),(31424,3535),(31425,3536),(31426,3537),(31427,3538),(31428,3539),(31429,3540),(31430,3541),(31431,3542),(31432,3543),(31433,3544),(31434,3545),(31435,3546),(31436,3547),(31437,3548),(31438,3549),(31439,3550),(31440,3551),(31441,3552),(31442,3553),(31443,3554),(31444,3555),(31445,3556),(31446,3557),(31447,3558),(31448,3559),(31449,3560),(31450,3561),(31451,3562),(31452,3563),(31453,3564),(31454,3565),(31455,3566),(31456,3567),(31457,3568),(31458,3469),(31459,3469),(31460,3469),(31461,3470),(31462,3470),(31463,3470),(31464,3471),(31465,3471),(31466,3471),(31467,3472),(31468,3472),(31469,3472),(31470,3473),(31471,3473),(31472,3473),(31473,3474),(31474,3474),(31475,3474),(31476,3475),(31477,3475),(31478,3475),(31479,3476),(31480,3476),(31481,3476),(31482,3477),(31483,3477),(31484,3477),(31485,3478),(31486,3478),(31487,3478),(31488,3479),(31489,3479),(31490,3479),(31491,3480),(31492,3480),(31493,3480),(31494,3481),(31495,3481),(31496,3481),(31497,3482),(31498,3482),(31499,3482),(31500,3483),(31501,3483),(31502,3483),(31503,3484),(31504,3484),(31505,3484),(31506,3485),(31507,3485),(31508,3485),(31509,3486),(31510,3486),(31511,3486),(31512,3487),(31513,3487),(31514,3487),(31515,3488),(31516,3488),(31517,3488),(31518,3489),(31519,3489),(31520,3489),(31521,3490),(31522,3490),(31523,3490),(31524,3491),(31525,3491),(31526,3491),(31527,3492),(31528,3492),(31529,3492),(31530,3493),(31531,3493),(31532,3493),(31533,3494),(31534,3494),(31535,3494),(31536,3495),(31537,3495),(31538,3495),(31539,3496),(31540,3496),(31541,3496),(31542,3497),(31543,3497),(31544,3497),(31545,3498),(31546,3498),(31547,3498),(31548,3499),(31549,3499),(31550,3499),(31551,3500),(31552,3500),(31553,3500),(31554,3501),(31555,3501),(31556,3501),(31557,3502),(31558,3502),(31559,3502),(31560,3503),(31561,3503),(31562,3503),(31563,3504),(31564,3504),(31565,3504),(31566,3505),(31567,3505),(31568,3505),(31569,3506),(31570,3506),(31571,3506),(31572,3507),(31573,3507),(31574,3507),(31575,3508),(31576,3508),(31577,3508),(31578,3509),(31579,3509),(31580,3509),(31581,3510),(31582,3510),(31583,3510),(31584,3511),(31585,3511),(31586,3511),(31587,3512),(31588,3512),(31589,3512),(31590,3513),(31591,3513),(31592,3513),(31593,3514),(31594,3514),(31595,3514),(31596,3515),(31597,3515),(31598,3515),(31599,3516),(31600,3516),(31601,3516),(31602,3517),(31603,3517),(31604,3517),(31605,3518),(31606,3518),(31607,3518),(31608,3519),(31609,3519),(31610,3519),(31611,3520),(31612,3520),(31613,3520),(31614,3521),(31615,3521),(31616,3521),(31617,3522),(31618,3522),(31619,3522),(31620,3523),(31621,3523),(31622,3523),(31623,3524),(31624,3524),(31625,3524),(31626,3525),(31627,3525),(31628,3525),(31629,3526),(31630,3526),(31631,3526),(31632,3527),(31633,3527),(31634,3527),(31635,3528),(31636,3528),(31637,3528),(31638,3529),(31639,3529),(31640,3529),(31641,3530),(31642,3530),(31643,3530),(31644,3531),(31645,3531),(31646,3531),(31647,3532),(31648,3532),(31649,3532),(31650,3533),(31651,3533),(31652,3533),(31653,3534),(31654,3534),(31655,3534),(31656,3535),(31657,3535),(31658,3535),(31659,3536),(31660,3536),(31661,3536),(31662,3537),(31663,3537),(31664,3537),(31665,3538),(31666,3538),(31667,3538),(31668,3539),(31669,3539),(31670,3539),(31671,3540),(31672,3540),(31673,3540),(31674,3541),(31675,3541),(31676,3541),(31677,3542),(31678,3542),(31679,3542),(31680,3543),(31681,3543),(31682,3543),(31683,3544),(31684,3544),(31685,3544),(31686,3545),(31687,3545),(31688,3545),(31689,3546),(31690,3546),(31691,3546),(31692,3547),(31693,3547),(31694,3547),(31695,3548),(31696,3548),(31697,3548),(31698,3549),(31699,3549),(31700,3549),(31701,3550),(31702,3550),(31703,3550),(31704,3551),(31705,3551),(31706,3551),(31707,3552),(31708,3552),(31709,3552),(31710,3553),(31711,3553),(31712,3553),(31713,3554),(31714,3554),(31715,3554),(31716,3555),(31717,3555),(31718,3555),(31719,3556),(31720,3556),(31721,3556),(31722,3557),(31723,3557),(31724,3557),(31725,3558),(31726,3558),(31727,3558),(31728,3559),(31729,3559),(31730,3559),(31731,3560),(31732,3560),(31733,3560),(31734,3561),(31735,3561),(31736,3561),(31737,3562),(31738,3562),(31739,3562),(31740,3563),(31741,3563),(31742,3563),(31743,3564),(31744,3564),(31745,3564),(31746,3565),(31747,3565),(31748,3565),(31749,3566),(31750,3566),(31751,3566),(31752,3567),(31753,3567),(31754,3567),(31755,3568),(31756,3568),(31757,3568),(31758,3469),(31759,3469),(31760,3469),(31761,3469),(31762,3470),(31763,3470),(31764,3470),(31765,3470),(31766,3471),(31767,3471),(31768,3471),(31769,3471),(31770,3472),(31771,3472),(31772,3472),(31773,3472),(31774,3473),(31775,3473),(31776,3473),(31777,3473),(31778,3474),(31779,3474),(31780,3474),(31781,3474),(31782,3475),(31783,3475),(31784,3475),(31785,3475),(31786,3476),(31787,3476),(31788,3476),(31789,3476),(31790,3477),(31791,3477),(31792,3477),(31793,3477),(31794,3478),(31795,3478),(31796,3478),(31797,3478),(31798,3479),(31799,3479),(31800,3479),(31801,3479),(31802,3480),(31803,3480),(31804,3480),(31805,3480),(31806,3481),(31807,3481),(31808,3481),(31809,3481),(31810,3482),(31811,3482),(31812,3482),(31813,3482),(31814,3483),(31815,3483),(31816,3483),(31817,3483),(31818,3484),(31819,3484),(31820,3484),(31821,3484),(31822,3485),(31823,3485),(31824,3485),(31825,3485),(31826,3486),(31827,3486),(31828,3486),(31829,3486),(31830,3487),(31831,3487),(31832,3487),(31833,3487),(31834,3488),(31835,3488),(31836,3488),(31837,3488),(31838,3489),(31839,3489),(31840,3489),(31841,3489),(31842,3490),(31843,3490),(31844,3490),(31845,3490),(31846,3491),(31847,3491),(31848,3491),(31849,3491),(31850,3492),(31851,3492),(31852,3492),(31853,3492),(31854,3493),(31855,3493),(31856,3493),(31857,3493),(31858,3494),(31859,3494),(31860,3494),(31861,3494),(31862,3495),(31863,3495),(31864,3495),(31865,3495),(31866,3496),(31867,3496),(31868,3496),(31869,3496),(31870,3497),(31871,3497),(31872,3497),(31873,3497),(31874,3498),(31875,3498),(31876,3498),(31877,3498),(31878,3499),(31879,3499),(31880,3499),(31881,3499),(31882,3500),(31883,3500),(31884,3500),(31885,3500),(31886,3501),(31887,3501),(31888,3501),(31889,3501),(31890,3502),(31891,3502),(31892,3502),(31893,3502),(31894,3503),(31895,3503),(31896,3503),(31897,3503),(31898,3504),(31899,3504),(31900,3504),(31901,3504),(31902,3505),(31903,3505),(31904,3505),(31905,3505),(31906,3506),(31907,3506),(31908,3506),(31909,3506),(31910,3507),(31911,3507),(31912,3507),(31913,3507),(31914,3508),(31915,3508),(31916,3508),(31917,3508),(31918,3509),(31919,3509),(31920,3509),(31921,3509),(31922,3510),(31923,3510),(31924,3510),(31925,3510),(31926,3511),(31927,3511),(31928,3511),(31929,3511),(31930,3512),(31931,3512),(31932,3512),(31933,3512),(31934,3513),(31935,3513),(31936,3513),(31937,3513),(31938,3514),(31939,3514),(31940,3514),(31941,3514),(31942,3515),(31943,3515),(31944,3515),(31945,3515),(31946,3516),(31947,3516),(31948,3516),(31949,3516),(31950,3517),(31951,3517),(31952,3517),(31953,3517),(31954,3518),(31955,3518),(31956,3518),(31957,3518),(31958,3519),(31959,3519),(31960,3519),(31961,3519),(31962,3520),(31963,3520),(31964,3520),(31965,3520),(31966,3521),(31967,3521),(31968,3521),(31969,3521),(31970,3522),(31971,3522),(31972,3522),(31973,3522),(31974,3523),(31975,3523),(31976,3523),(31977,3523),(31978,3524),(31979,3524),(31980,3524),(31981,3524),(31982,3525),(31983,3525),(31984,3525),(31985,3525),(31986,3526),(31987,3526),(31988,3526),(31989,3526),(31990,3527),(31991,3527),(31992,3527),(31993,3527),(31994,3528),(31995,3528),(31996,3528),(31997,3528),(31998,3529),(31999,3529),(32000,3529),(32001,3529),(32002,3530),(32003,3530),(32004,3530),(32005,3530),(32006,3531),(32007,3531),(32008,3531),(32009,3531),(32010,3532),(32011,3532),(32012,3532),(32013,3532),(32014,3533),(32015,3533),(32016,3533),(32017,3533),(32018,3534),(32019,3534),(32020,3534),(32021,3534),(32022,3535),(32023,3535),(32024,3535),(32025,3535),(32026,3536),(32027,3536),(32028,3536),(32029,3536),(32030,3537),(32031,3537),(32032,3537),(32033,3537),(32034,3538),(32035,3538),(32036,3538),(32037,3538),(32038,3539),(32039,3539),(32040,3539),(32041,3539),(32042,3540),(32043,3540),(32044,3540),(32045,3540),(32046,3541),(32047,3541),(32048,3541),(32049,3541),(32050,3542),(32051,3542),(32052,3542),(32053,3542),(32054,3543),(32055,3543),(32056,3543),(32057,3543),(32058,3544),(32059,3544),(32060,3544),(32061,3544),(32062,3545),(32063,3545),(32064,3545),(32065,3545),(32066,3546),(32067,3546),(32068,3546),(32069,3546),(32070,3547),(32071,3547),(32072,3547),(32073,3547),(32074,3548),(32075,3548),(32076,3548),(32077,3548),(32078,3549),(32079,3549),(32080,3549),(32081,3549),(32082,3550),(32083,3550),(32084,3550),(32085,3550),(32086,3551),(32087,3551),(32088,3551),(32089,3551),(32090,3552),(32091,3552),(32092,3552),(32093,3552),(32094,3553),(32095,3553),(32096,3553),(32097,3553),(32098,3554),(32099,3554),(32100,3554),(32101,3554),(32102,3555),(32103,3555),(32104,3555),(32105,3555),(32106,3556),(32107,3556),(32108,3556),(32109,3556),(32110,3557),(32111,3557),(32112,3557),(32113,3557),(32114,3558),(32115,3558),(32116,3558),(32117,3558),(32118,3559),(32119,3559),(32120,3559),(32121,3559),(32122,3560),(32123,3560),(32124,3560),(32125,3560),(32126,3561),(32127,3561),(32128,3561),(32129,3561),(32130,3562),(32131,3562),(32132,3562),(32133,3562),(32134,3563),(32135,3563),(32136,3563),(32137,3563),(32138,3564),(32139,3564),(32140,3564),(32141,3564),(32142,3565),(32143,3565),(32144,3565),(32145,3565),(32146,3566),(32147,3566),(32148,3566),(32149,3566),(32150,3567),(32151,3567),(32152,3567),(32153,3567),(32154,3568),(32155,3568),(32156,3568),(32157,3568),(32158,3569),(32159,3570),(32160,3571),(32161,3572),(32162,3573),(32163,3574),(32164,3575),(32165,3576),(32166,3577),(32167,3578),(32168,3579),(32169,3580),(32170,3581),(32171,3582),(32172,3583),(32173,3584),(32174,3585),(32175,3586),(32176,3587),(32177,3588),(32178,3589),(32179,3590),(32180,3591),(32181,3592),(32182,3593),(32183,3594),(32184,3595),(32185,3596),(32186,3597),(32187,3598),(32188,3599),(32189,3600),(32190,3601),(32191,3602),(32192,3603),(32193,3604),(32194,3605),(32195,3606),(32196,3607),(32197,3608),(32198,3609),(32199,3610),(32200,3611),(32201,3612),(32202,3613),(32203,3614),(32204,3615),(32205,3616),(32206,3617),(32207,3618),(32208,3619),(32209,3620),(32210,3621),(32211,3622),(32212,3623),(32213,3624),(32214,3625),(32215,3626),(32216,3627),(32217,3628),(32218,3629),(32219,3630),(32220,3631),(32221,3632),(32222,3633),(32223,3634),(32224,3635),(32225,3636),(32226,3637),(32227,3638),(32228,3639),(32229,3640),(32230,3641),(32231,3642),(32232,3643),(32233,3644),(32234,3645),(32235,3646),(32236,3647),(32237,3648),(32238,3649),(32239,3650),(32240,3651),(32241,3652),(32242,3653),(32243,3654),(32244,3655),(32245,3656),(32246,3657),(32247,3658),(32248,3659),(32249,3660),(32250,3661),(32251,3662),(32252,3663),(32253,3664),(32254,3665),(32255,3666),(32256,3667),(32257,3668),(32258,3569),(32259,3570),(32260,3571),(32261,3572),(32262,3573),(32263,3574),(32264,3575),(32265,3576),(32266,3577),(32267,3578),(32268,3579),(32269,3580),(32270,3581),(32271,3582),(32272,3583),(32273,3584),(32274,3585),(32275,3586),(32276,3587),(32277,3588),(32278,3589),(32279,3590),(32280,3591),(32281,3592),(32282,3593),(32283,3594),(32284,3595),(32285,3596),(32286,3597),(32287,3598),(32288,3599),(32289,3600),(32290,3601),(32291,3602),(32292,3603),(32293,3604),(32294,3605),(32295,3606),(32296,3607),(32297,3608),(32298,3609),(32299,3610),(32300,3611),(32301,3612),(32302,3613),(32303,3614),(32304,3615),(32305,3616),(32306,3617),(32307,3618),(32308,3619),(32309,3620),(32310,3621),(32311,3622),(32312,3623),(32313,3624),(32314,3625),(32315,3626),(32316,3627),(32317,3628),(32318,3629),(32319,3630),(32320,3631),(32321,3632),(32322,3633),(32323,3634),(32324,3635),(32325,3636),(32326,3637),(32327,3638),(32328,3639),(32329,3640),(32330,3641),(32331,3642),(32332,3643),(32333,3644),(32334,3645),(32335,3646),(32336,3647),(32337,3648),(32338,3649),(32339,3650),(32340,3651),(32341,3652),(32342,3653),(32343,3654),(32344,3655),(32345,3656),(32346,3657),(32347,3658),(32348,3659),(32349,3660),(32350,3661),(32351,3662),(32352,3663),(32353,3664),(32354,3665),(32355,3666),(32356,3667),(32357,3668),(32358,3569),(32359,3569),(32360,3569),(32361,3570),(32362,3570),(32363,3570),(32364,3571),(32365,3571),(32366,3571),(32367,3572),(32368,3572),(32369,3572),(32370,3573),(32371,3573),(32372,3573),(32373,3574),(32374,3574),(32375,3574),(32376,3575),(32377,3575),(32378,3575),(32379,3576),(32380,3576),(32381,3576),(32382,3577),(32383,3577),(32384,3577),(32385,3578),(32386,3578),(32387,3578),(32388,3579),(32389,3579),(32390,3579),(32391,3580),(32392,3580),(32393,3580),(32394,3581),(32395,3581),(32396,3581),(32397,3582),(32398,3582),(32399,3582),(32400,3583),(32401,3583),(32402,3583),(32403,3584),(32404,3584),(32405,3584),(32406,3585),(32407,3585),(32408,3585),(32409,3586),(32410,3586),(32411,3586),(32412,3587),(32413,3587),(32414,3587),(32415,3588),(32416,3588),(32417,3588),(32418,3589),(32419,3589),(32420,3589),(32421,3590),(32422,3590),(32423,3590),(32424,3591),(32425,3591),(32426,3591),(32427,3592),(32428,3592),(32429,3592),(32430,3593),(32431,3593),(32432,3593),(32433,3594),(32434,3594),(32435,3594),(32436,3595),(32437,3595),(32438,3595),(32439,3596),(32440,3596),(32441,3596),(32442,3597),(32443,3597),(32444,3597),(32445,3598),(32446,3598),(32447,3598),(32448,3599),(32449,3599),(32450,3599),(32451,3600),(32452,3600),(32453,3600),(32454,3601),(32455,3601),(32456,3601),(32457,3602),(32458,3602),(32459,3602),(32460,3603),(32461,3603),(32462,3603),(32463,3604),(32464,3604),(32465,3604),(32466,3605),(32467,3605),(32468,3605),(32469,3606),(32470,3606),(32471,3606),(32472,3607),(32473,3607),(32474,3607),(32475,3608),(32476,3608),(32477,3608),(32478,3609),(32479,3609),(32480,3609),(32481,3610),(32482,3610),(32483,3610),(32484,3611),(32485,3611),(32486,3611),(32487,3612),(32488,3612),(32489,3612),(32490,3613),(32491,3613),(32492,3613),(32493,3614),(32494,3614),(32495,3614),(32496,3615),(32497,3615),(32498,3615),(32499,3616),(32500,3616),(32501,3616),(32502,3617),(32503,3617),(32504,3617),(32505,3618),(32506,3618),(32507,3618),(32508,3619),(32509,3619),(32510,3619),(32511,3620),(32512,3620),(32513,3620),(32514,3621),(32515,3621),(32516,3621),(32517,3622),(32518,3622),(32519,3622),(32520,3623),(32521,3623),(32522,3623),(32523,3624),(32524,3624),(32525,3624),(32526,3625),(32527,3625),(32528,3625),(32529,3626),(32530,3626),(32531,3626),(32532,3627),(32533,3627),(32534,3627),(32535,3628),(32536,3628),(32537,3628),(32538,3629),(32539,3629),(32540,3629),(32541,3630),(32542,3630),(32543,3630),(32544,3631),(32545,3631),(32546,3631),(32547,3632),(32548,3632),(32549,3632),(32550,3633),(32551,3633),(32552,3633),(32553,3634),(32554,3634),(32555,3634),(32556,3635),(32557,3635),(32558,3635),(32559,3636),(32560,3636),(32561,3636),(32562,3637),(32563,3637),(32564,3637),(32565,3638),(32566,3638),(32567,3638),(32568,3639),(32569,3639),(32570,3639),(32571,3640),(32572,3640),(32573,3640),(32574,3641),(32575,3641),(32576,3641),(32577,3642),(32578,3642),(32579,3642),(32580,3643),(32581,3643),(32582,3643),(32583,3644),(32584,3644),(32585,3644),(32586,3645),(32587,3645),(32588,3645),(32589,3646),(32590,3646),(32591,3646),(32592,3647),(32593,3647),(32594,3647),(32595,3648),(32596,3648),(32597,3648),(32598,3649),(32599,3649),(32600,3649),(32601,3650),(32602,3650),(32603,3650),(32604,3651),(32605,3651),(32606,3651),(32607,3652),(32608,3652),(32609,3652),(32610,3653),(32611,3653),(32612,3653),(32613,3654),(32614,3654),(32615,3654),(32616,3655),(32617,3655),(32618,3655),(32619,3656),(32620,3656),(32621,3656),(32622,3657),(32623,3657),(32624,3657),(32625,3658),(32626,3658),(32627,3658),(32628,3659),(32629,3659),(32630,3659),(32631,3660),(32632,3660),(32633,3660),(32634,3661),(32635,3661),(32636,3661),(32637,3662),(32638,3662),(32639,3662),(32640,3663),(32641,3663),(32642,3663),(32643,3664),(32644,3664),(32645,3664),(32646,3665),(32647,3665),(32648,3665),(32649,3666),(32650,3666),(32651,3666),(32652,3667),(32653,3667),(32654,3667),(32655,3668),(32656,3668),(32657,3668),(32658,3569),(32659,3569),(32660,3569),(32661,3569),(32662,3570),(32663,3570),(32664,3570),(32665,3570),(32666,3571),(32667,3571),(32668,3571),(32669,3571),(32670,3572),(32671,3572),(32672,3572),(32673,3572),(32674,3573),(32675,3573),(32676,3573),(32677,3573),(32678,3574),(32679,3574),(32680,3574),(32681,3574),(32682,3575),(32683,3575),(32684,3575),(32685,3575),(32686,3576),(32687,3576),(32688,3576),(32689,3576),(32690,3577),(32691,3577),(32692,3577),(32693,3577),(32694,3578),(32695,3578),(32696,3578),(32697,3578),(32698,3579),(32699,3579),(32700,3579),(32701,3579),(32702,3580),(32703,3580),(32704,3580),(32705,3580),(32706,3581),(32707,3581),(32708,3581),(32709,3581),(32710,3582),(32711,3582),(32712,3582),(32713,3582),(32714,3583),(32715,3583),(32716,3583),(32717,3583),(32718,3584),(32719,3584),(32720,3584),(32721,3584),(32722,3585),(32723,3585),(32724,3585),(32725,3585),(32726,3586),(32727,3586),(32728,3586),(32729,3586),(32730,3587),(32731,3587),(32732,3587),(32733,3587),(32734,3588),(32735,3588),(32736,3588),(32737,3588),(32738,3589),(32739,3589),(32740,3589),(32741,3589),(32742,3590),(32743,3590),(32744,3590),(32745,3590),(32746,3591),(32747,3591),(32748,3591),(32749,3591),(32750,3592),(32751,3592),(32752,3592),(32753,3592),(32754,3593),(32755,3593),(32756,3593),(32757,3593),(32758,3594),(32759,3594),(32760,3594),(32761,3594),(32762,3595),(32763,3595),(32764,3595),(32765,3595),(32766,3596),(32767,3596),(32768,3596),(32769,3596),(32770,3597),(32771,3597),(32772,3597),(32773,3597),(32774,3598),(32775,3598),(32776,3598),(32777,3598),(32778,3599),(32779,3599),(32780,3599),(32781,3599),(32782,3600),(32783,3600),(32784,3600),(32785,3600),(32786,3601),(32787,3601),(32788,3601),(32789,3601),(32790,3602),(32791,3602),(32792,3602),(32793,3602),(32794,3603),(32795,3603),(32796,3603),(32797,3603),(32798,3604),(32799,3604),(32800,3604),(32801,3604),(32802,3605),(32803,3605),(32804,3605),(32805,3605),(32806,3606),(32807,3606),(32808,3606),(32809,3606),(32810,3607),(32811,3607),(32812,3607),(32813,3607),(32814,3608),(32815,3608),(32816,3608),(32817,3608),(32818,3609),(32819,3609),(32820,3609),(32821,3609),(32822,3610),(32823,3610),(32824,3610),(32825,3610),(32826,3611),(32827,3611),(32828,3611),(32829,3611),(32830,3612),(32831,3612),(32832,3612),(32833,3612),(32834,3613),(32835,3613),(32836,3613),(32837,3613),(32838,3614),(32839,3614),(32840,3614),(32841,3614),(32842,3615),(32843,3615),(32844,3615),(32845,3615),(32846,3616),(32847,3616),(32848,3616),(32849,3616),(32850,3617),(32851,3617),(32852,3617),(32853,3617),(32854,3618),(32855,3618),(32856,3618),(32857,3618),(32858,3619),(32859,3619),(32860,3619),(32861,3619),(32862,3620),(32863,3620),(32864,3620),(32865,3620),(32866,3621),(32867,3621),(32868,3621),(32869,3621),(32870,3622),(32871,3622),(32872,3622),(32873,3622),(32874,3623),(32875,3623),(32876,3623),(32877,3623),(32878,3624),(32879,3624),(32880,3624),(32881,3624),(32882,3625),(32883,3625),(32884,3625),(32885,3625),(32886,3626),(32887,3626),(32888,3626),(32889,3626),(32890,3627),(32891,3627),(32892,3627),(32893,3627),(32894,3628),(32895,3628),(32896,3628),(32897,3628),(32898,3629),(32899,3629),(32900,3629),(32901,3629),(32902,3630),(32903,3630),(32904,3630),(32905,3630),(32906,3631),(32907,3631),(32908,3631),(32909,3631),(32910,3632),(32911,3632),(32912,3632),(32913,3632),(32914,3633),(32915,3633),(32916,3633),(32917,3633),(32918,3634),(32919,3634),(32920,3634),(32921,3634),(32922,3635),(32923,3635),(32924,3635),(32925,3635),(32926,3636),(32927,3636),(32928,3636),(32929,3636),(32930,3637),(32931,3637),(32932,3637),(32933,3637),(32934,3638),(32935,3638),(32936,3638),(32937,3638),(32938,3639),(32939,3639),(32940,3639),(32941,3639),(32942,3640),(32943,3640),(32944,3640),(32945,3640),(32946,3641),(32947,3641),(32948,3641),(32949,3641),(32950,3642),(32951,3642),(32952,3642),(32953,3642),(32954,3643),(32955,3643),(32956,3643),(32957,3643),(32958,3644),(32959,3644),(32960,3644),(32961,3644),(32962,3645),(32963,3645),(32964,3645),(32965,3645),(32966,3646),(32967,3646),(32968,3646),(32969,3646),(32970,3647),(32971,3647),(32972,3647),(32973,3647),(32974,3648),(32975,3648),(32976,3648),(32977,3648),(32978,3649),(32979,3649),(32980,3649),(32981,3649),(32982,3650),(32983,3650),(32984,3650),(32985,3650),(32986,3651),(32987,3651),(32988,3651),(32989,3651),(32990,3652),(32991,3652),(32992,3652),(32993,3652),(32994,3653),(32995,3653),(32996,3653),(32997,3653),(32998,3654),(32999,3654),(33000,3654),(33001,3654),(33002,3655),(33003,3655),(33004,3655),(33005,3655),(33006,3656),(33007,3656),(33008,3656),(33009,3656),(33010,3657),(33011,3657),(33012,3657),(33013,3657),(33014,3658),(33015,3658),(33016,3658),(33017,3658),(33018,3659),(33019,3659),(33020,3659),(33021,3659),(33022,3660),(33023,3660),(33024,3660),(33025,3660),(33026,3661),(33027,3661),(33028,3661),(33029,3661),(33030,3662),(33031,3662),(33032,3662),(33033,3662),(33034,3663),(33035,3663),(33036,3663),(33037,3663),(33038,3664),(33039,3664),(33040,3664),(33041,3664),(33042,3665),(33043,3665),(33044,3665),(33045,3665),(33046,3666),(33047,3666),(33048,3666),(33049,3666),(33050,3667),(33051,3667),(33052,3667),(33053,3667),(33054,3668),(33055,3668),(33056,3668),(33057,3668),(33058,3669),(33059,3670),(33060,3671),(33061,3672),(33062,3673),(33063,3674),(33064,3675),(33065,3676),(33066,3677),(33067,3678),(33068,3679),(33069,3680),(33070,3681),(33071,3682),(33072,3683),(33073,3684),(33074,3685),(33075,3686),(33076,3687),(33077,3688),(33078,3689),(33079,3690),(33080,3691),(33081,3692),(33082,3693),(33083,3694),(33084,3695),(33085,3696),(33086,3697),(33087,3698),(33088,3699),(33089,3700),(33090,3701),(33091,3702),(33092,3703),(33093,3704),(33094,3705),(33095,3706),(33096,3707),(33097,3708),(33098,3709),(33099,3710),(33100,3711),(33101,3712),(33102,3713),(33103,3714),(33104,3669),(33105,3670),(33106,3671),(33107,3672),(33108,3673),(33109,3674),(33110,3675),(33111,3676),(33112,3677),(33113,3678),(33114,3679),(33115,3680),(33116,3681),(33117,3682),(33118,3683),(33119,3684),(33120,3685),(33121,3686),(33122,3687),(33123,3688),(33124,3689),(33125,3690),(33126,3691),(33127,3692),(33128,3693),(33129,3694),(33130,3695),(33131,3696),(33132,3697),(33133,3698),(33134,3699),(33135,3700),(33136,3701),(33137,3702),(33138,3703),(33139,3704),(33140,3705),(33141,3706),(33142,3707),(33143,3708),(33144,3709),(33145,3710),(33146,3711),(33147,3712),(33148,3713),(33149,3714),(33150,3669),(33151,3669),(33152,3669),(33153,3670),(33154,3670),(33155,3670),(33156,3671),(33157,3671),(33158,3671),(33159,3672),(33160,3672),(33161,3672),(33162,3673),(33163,3673),(33164,3673),(33165,3674),(33166,3674),(33167,3674),(33168,3675),(33169,3675),(33170,3675),(33171,3676),(33172,3676),(33173,3676),(33174,3677),(33175,3677),(33176,3677),(33177,3678),(33178,3678),(33179,3678),(33180,3679),(33181,3679),(33182,3679),(33183,3680),(33184,3680),(33185,3680),(33186,3681),(33187,3681),(33188,3681),(33189,3682),(33190,3682),(33191,3682),(33192,3683),(33193,3683),(33194,3683),(33195,3684),(33196,3684),(33197,3684),(33198,3685),(33199,3685),(33200,3685),(33201,3686),(33202,3686),(33203,3686),(33204,3687),(33205,3687),(33206,3687),(33207,3688),(33208,3688),(33209,3688),(33210,3689),(33211,3689),(33212,3689),(33213,3690),(33214,3690),(33215,3690),(33216,3691),(33217,3691),(33218,3691),(33219,3692),(33220,3692),(33221,3692),(33222,3693),(33223,3693),(33224,3693),(33225,3694),(33226,3694),(33227,3694),(33228,3695),(33229,3695),(33230,3695),(33231,3696),(33232,3696),(33233,3696),(33234,3697),(33235,3697),(33236,3697),(33237,3698),(33238,3698),(33239,3698),(33240,3699),(33241,3699),(33242,3699),(33243,3700),(33244,3700),(33245,3700),(33246,3701),(33247,3701),(33248,3701),(33249,3702),(33250,3702),(33251,3702),(33252,3703),(33253,3703),(33254,3703),(33255,3704),(33256,3704),(33257,3704),(33258,3705),(33259,3705),(33260,3705),(33261,3706),(33262,3706),(33263,3706),(33264,3707),(33265,3707),(33266,3707),(33267,3708),(33268,3708),(33269,3708),(33270,3709),(33271,3709),(33272,3709),(33273,3710),(33274,3710),(33275,3710),(33276,3711),(33277,3711),(33278,3711),(33279,3712),(33280,3712),(33281,3712),(33282,3713),(33283,3713),(33284,3713),(33285,3714),(33286,3714),(33287,3714),(33288,3669),(33289,3669),(33290,3669),(33291,3669),(33292,3670),(33293,3670),(33294,3670),(33295,3670),(33296,3671),(33297,3671),(33298,3671),(33299,3671),(33300,3672),(33301,3672),(33302,3672),(33303,3672),(33304,3673),(33305,3673),(33306,3673),(33307,3673),(33308,3674),(33309,3674),(33310,3674),(33311,3674),(33312,3675),(33313,3675),(33314,3675),(33315,3675),(33316,3676),(33317,3676),(33318,3676),(33319,3676),(33320,3677),(33321,3677),(33322,3677),(33323,3677),(33324,3678),(33325,3678),(33326,3678),(33327,3678),(33328,3679),(33329,3679),(33330,3679),(33331,3679),(33332,3680),(33333,3680),(33334,3680),(33335,3680),(33336,3681),(33337,3681),(33338,3681),(33339,3681),(33340,3682),(33341,3682),(33342,3682),(33343,3682),(33344,3683),(33345,3683),(33346,3683),(33347,3683),(33348,3684),(33349,3684),(33350,3684),(33351,3684),(33352,3685),(33353,3685),(33354,3685),(33355,3685),(33356,3686),(33357,3686),(33358,3686),(33359,3686),(33360,3687),(33361,3687),(33362,3687),(33363,3687),(33364,3688),(33365,3688),(33366,3688),(33367,3688),(33368,3689),(33369,3689),(33370,3689),(33371,3689),(33372,3690),(33373,3690),(33374,3690),(33375,3690),(33376,3691),(33377,3691),(33378,3691),(33379,3691),(33380,3692),(33381,3692),(33382,3692),(33383,3692),(33384,3693),(33385,3693),(33386,3693),(33387,3693),(33388,3694),(33389,3694),(33390,3694),(33391,3694),(33392,3695),(33393,3695),(33394,3695),(33395,3695),(33396,3696),(33397,3696),(33398,3696),(33399,3696),(33400,3697),(33401,3697),(33402,3697),(33403,3697),(33404,3698),(33405,3698),(33406,3698),(33407,3698),(33408,3699),(33409,3699),(33410,3699),(33411,3699),(33412,3700),(33413,3700),(33414,3700),(33415,3700),(33416,3701),(33417,3701),(33418,3701),(33419,3701),(33420,3702),(33421,3702),(33422,3702),(33423,3702),(33424,3703),(33425,3703),(33426,3703),(33427,3703),(33428,3704),(33429,3704),(33430,3704),(33431,3704),(33432,3705),(33433,3705),(33434,3705),(33435,3705),(33436,3706),(33437,3706),(33438,3706),(33439,3706),(33440,3707),(33441,3707),(33442,3707),(33443,3707),(33444,3708),(33445,3708),(33446,3708),(33447,3708),(33448,3709),(33449,3709),(33450,3709),(33451,3709),(33452,3710),(33453,3710),(33454,3710),(33455,3710),(33456,3711),(33457,3711),(33458,3711),(33459,3711),(33460,3712),(33461,3712),(33462,3712),(33463,3712),(33464,3713),(33465,3713),(33466,3713),(33467,3713),(33468,3714),(33469,3714),(33470,3714),(33471,3714),(33472,3715),(33473,3716),(33474,3717),(33475,3718),(33476,3719),(33477,3720),(33478,3721),(33479,3722),(33480,3723),(33481,3724),(33482,3725),(33483,3726),(33484,3727),(33485,3728),(33486,3729),(33487,3730),(33488,3731),(33489,3732),(33490,3733),(33491,3734),(33492,3735),(33493,3736),(33494,3737),(33495,3738),(33496,3739),(33497,3740),(33498,3741),(33499,3742),(33500,3743),(33501,3744),(33502,3745),(33503,3746),(33504,3747),(33505,3748),(33506,3749),(33507,3750),(33508,3751),(33509,3752),(33510,3753),(33511,3754),(33512,3755),(33513,3756),(33514,3757),(33515,3758),(33516,3759),(33517,3760),(33518,3761),(33519,3762),(33520,3763),(33521,3764),(33522,3765),(33523,3766),(33524,3767),(33525,3768),(33526,3769),(33527,3770),(33528,3771),(33529,3772),(33530,3773),(33531,3774),(33532,3775),(33533,3776),(33534,3777),(33535,3778),(33536,3779),(33537,3780),(33538,3781),(33539,3782),(33540,3783),(33541,3784),(33542,3785),(33543,3786),(33544,3787),(33545,3788),(33546,3789),(33547,3790),(33548,3791),(33549,3792),(33550,3793),(33551,3794),(33552,3795),(33553,3796),(33554,3797),(33555,3798),(33556,3799),(33557,3800),(33558,3801),(33559,3802),(33560,3803),(33561,3804),(33562,3805),(33563,3806),(33564,3807),(33565,3808),(33566,3809),(33567,3810),(33568,3811),(33569,3812),(33570,3813),(33571,3814),(33572,3715),(33573,3716),(33574,3717),(33575,3718),(33576,3719),(33577,3720),(33578,3721),(33579,3722),(33580,3723),(33581,3724),(33582,3725),(33583,3726),(33584,3727),(33585,3728),(33586,3729),(33587,3730),(33588,3731),(33589,3732),(33590,3733),(33591,3734),(33592,3735),(33593,3736),(33594,3737),(33595,3738),(33596,3739),(33597,3740),(33598,3741),(33599,3742),(33600,3743),(33601,3744),(33602,3745),(33603,3746),(33604,3747),(33605,3748),(33606,3749),(33607,3750),(33608,3751),(33609,3752),(33610,3753),(33611,3754),(33612,3755),(33613,3756),(33614,3757),(33615,3758),(33616,3759),(33617,3760),(33618,3761),(33619,3762),(33620,3763),(33621,3764),(33622,3765),(33623,3766),(33624,3767),(33625,3768),(33626,3769),(33627,3770),(33628,3771),(33629,3772),(33630,3773),(33631,3774),(33632,3775),(33633,3776),(33634,3777),(33635,3778),(33636,3779),(33637,3780),(33638,3781),(33639,3782),(33640,3783),(33641,3784),(33642,3785),(33643,3786),(33644,3787),(33645,3788),(33646,3789),(33647,3790),(33648,3791),(33649,3792),(33650,3793),(33651,3794),(33652,3795),(33653,3796),(33654,3797),(33655,3798),(33656,3799),(33657,3800),(33658,3801),(33659,3802),(33660,3803),(33661,3804),(33662,3805),(33663,3806),(33664,3807),(33665,3808),(33666,3809),(33667,3810),(33668,3811),(33669,3812),(33670,3813),(33671,3814),(33672,3715),(33673,3715),(33674,3715),(33675,3716),(33676,3716),(33677,3716),(33678,3717),(33679,3717),(33680,3717),(33681,3718),(33682,3718),(33683,3718),(33684,3719),(33685,3719),(33686,3719),(33687,3720),(33688,3720),(33689,3720),(33690,3721),(33691,3721),(33692,3721),(33693,3722),(33694,3722),(33695,3722),(33696,3723),(33697,3723),(33698,3723),(33699,3724),(33700,3724),(33701,3724),(33702,3725),(33703,3725),(33704,3725),(33705,3726),(33706,3726),(33707,3726),(33708,3727),(33709,3727),(33710,3727),(33711,3728),(33712,3728),(33713,3728),(33714,3729),(33715,3729),(33716,3729),(33717,3730),(33718,3730),(33719,3730),(33720,3731),(33721,3731),(33722,3731),(33723,3732),(33724,3732),(33725,3732),(33726,3733),(33727,3733),(33728,3733),(33729,3734),(33730,3734),(33731,3734),(33732,3735),(33733,3735),(33734,3735),(33735,3736),(33736,3736),(33737,3736),(33738,3737),(33739,3737),(33740,3737),(33741,3738),(33742,3738),(33743,3738),(33744,3739),(33745,3739),(33746,3739),(33747,3740),(33748,3740),(33749,3740),(33750,3741),(33751,3741),(33752,3741),(33753,3742),(33754,3742),(33755,3742),(33756,3743),(33757,3743),(33758,3743),(33759,3744),(33760,3744),(33761,3744),(33762,3745),(33763,3745),(33764,3745),(33765,3746),(33766,3746),(33767,3746),(33768,3747),(33769,3747),(33770,3747),(33771,3748),(33772,3748),(33773,3748),(33774,3749),(33775,3749),(33776,3749),(33777,3750),(33778,3750),(33779,3750),(33780,3751),(33781,3751),(33782,3751),(33783,3752),(33784,3752),(33785,3752),(33786,3753),(33787,3753),(33788,3753),(33789,3754),(33790,3754),(33791,3754),(33792,3755),(33793,3755),(33794,3755),(33795,3756),(33796,3756),(33797,3756),(33798,3757),(33799,3757),(33800,3757),(33801,3758),(33802,3758),(33803,3758),(33804,3759),(33805,3759),(33806,3759),(33807,3760),(33808,3760),(33809,3760),(33810,3761),(33811,3761),(33812,3761),(33813,3762),(33814,3762),(33815,3762),(33816,3763),(33817,3763),(33818,3763),(33819,3764),(33820,3764),(33821,3764),(33822,3765),(33823,3765),(33824,3765),(33825,3766),(33826,3766),(33827,3766),(33828,3767),(33829,3767),(33830,3767),(33831,3768),(33832,3768),(33833,3768),(33834,3769),(33835,3769),(33836,3769),(33837,3770),(33838,3770),(33839,3770),(33840,3771),(33841,3771),(33842,3771),(33843,3772),(33844,3772),(33845,3772),(33846,3773),(33847,3773),(33848,3773),(33849,3774),(33850,3774),(33851,3774),(33852,3775),(33853,3775),(33854,3775),(33855,3776),(33856,3776),(33857,3776),(33858,3777),(33859,3777),(33860,3777),(33861,3778),(33862,3778),(33863,3778),(33864,3779),(33865,3779),(33866,3779),(33867,3780),(33868,3780),(33869,3780),(33870,3781),(33871,3781),(33872,3781),(33873,3782),(33874,3782),(33875,3782),(33876,3783),(33877,3783),(33878,3783),(33879,3784),(33880,3784),(33881,3784),(33882,3785),(33883,3785),(33884,3785),(33885,3786),(33886,3786),(33887,3786),(33888,3787),(33889,3787),(33890,3787),(33891,3788),(33892,3788),(33893,3788),(33894,3789),(33895,3789),(33896,3789),(33897,3790),(33898,3790),(33899,3790),(33900,3791),(33901,3791),(33902,3791),(33903,3792),(33904,3792),(33905,3792),(33906,3793),(33907,3793),(33908,3793),(33909,3794),(33910,3794),(33911,3794),(33912,3795),(33913,3795),(33914,3795),(33915,3796),(33916,3796),(33917,3796),(33918,3797),(33919,3797),(33920,3797),(33921,3798),(33922,3798),(33923,3798),(33924,3799),(33925,3799),(33926,3799),(33927,3800),(33928,3800),(33929,3800),(33930,3801),(33931,3801),(33932,3801),(33933,3802),(33934,3802),(33935,3802),(33936,3803),(33937,3803),(33938,3803),(33939,3804),(33940,3804),(33941,3804),(33942,3805),(33943,3805),(33944,3805),(33945,3806),(33946,3806),(33947,3806),(33948,3807),(33949,3807),(33950,3807),(33951,3808),(33952,3808),(33953,3808),(33954,3809),(33955,3809),(33956,3809),(33957,3810),(33958,3810),(33959,3810),(33960,3811),(33961,3811),(33962,3811),(33963,3812),(33964,3812),(33965,3812),(33966,3813),(33967,3813),(33968,3813),(33969,3814),(33970,3814),(33971,3814),(33972,3715),(33973,3715),(33974,3715),(33975,3715),(33976,3716),(33977,3716),(33978,3716),(33979,3716),(33980,3717),(33981,3717),(33982,3717),(33983,3717),(33984,3718),(33985,3718),(33986,3718),(33987,3718),(33988,3719),(33989,3719),(33990,3719),(33991,3719),(33992,3720),(33993,3720),(33994,3720),(33995,3720),(33996,3721),(33997,3721),(33998,3721),(33999,3721),(34000,3722),(34001,3722),(34002,3722),(34003,3722),(34004,3723),(34005,3723),(34006,3723),(34007,3723),(34008,3724),(34009,3724),(34010,3724),(34011,3724),(34012,3725),(34013,3725),(34014,3725),(34015,3725),(34016,3726),(34017,3726),(34018,3726),(34019,3726),(34020,3727),(34021,3727),(34022,3727),(34023,3727),(34024,3728),(34025,3728),(34026,3728),(34027,3728),(34028,3729),(34029,3729),(34030,3729),(34031,3729),(34032,3730),(34033,3730),(34034,3730),(34035,3730),(34036,3731),(34037,3731),(34038,3731),(34039,3731),(34040,3732),(34041,3732),(34042,3732),(34043,3732),(34044,3733),(34045,3733),(34046,3733),(34047,3733),(34048,3734),(34049,3734),(34050,3734),(34051,3734),(34052,3735),(34053,3735),(34054,3735),(34055,3735),(34056,3736),(34057,3736),(34058,3736),(34059,3736),(34060,3737),(34061,3737),(34062,3737),(34063,3737),(34064,3738),(34065,3738),(34066,3738),(34067,3738),(34068,3739),(34069,3739),(34070,3739),(34071,3739),(34072,3740),(34073,3740),(34074,3740),(34075,3740),(34076,3741),(34077,3741),(34078,3741),(34079,3741),(34080,3742),(34081,3742),(34082,3742),(34083,3742),(34084,3743),(34085,3743),(34086,3743),(34087,3743),(34088,3744),(34089,3744),(34090,3744),(34091,3744),(34092,3745),(34093,3745),(34094,3745),(34095,3745),(34096,3746),(34097,3746),(34098,3746),(34099,3746),(34100,3747),(34101,3747),(34102,3747),(34103,3747),(34104,3748),(34105,3748),(34106,3748),(34107,3748),(34108,3749),(34109,3749),(34110,3749),(34111,3749),(34112,3750),(34113,3750),(34114,3750),(34115,3750),(34116,3751),(34117,3751),(34118,3751),(34119,3751),(34120,3752),(34121,3752),(34122,3752),(34123,3752),(34124,3753),(34125,3753),(34126,3753),(34127,3753),(34128,3754),(34129,3754),(34130,3754),(34131,3754),(34132,3755),(34133,3755),(34134,3755),(34135,3755),(34136,3756),(34137,3756),(34138,3756),(34139,3756),(34140,3757),(34141,3757),(34142,3757),(34143,3757),(34144,3758),(34145,3758),(34146,3758),(34147,3758),(34148,3759),(34149,3759),(34150,3759),(34151,3759),(34152,3760),(34153,3760),(34154,3760),(34155,3760),(34156,3761),(34157,3761),(34158,3761),(34159,3761),(34160,3762),(34161,3762),(34162,3762),(34163,3762),(34164,3763),(34165,3763),(34166,3763),(34167,3763),(34168,3764),(34169,3764),(34170,3764),(34171,3764),(34172,3765),(34173,3765),(34174,3765),(34175,3765),(34176,3766),(34177,3766),(34178,3766),(34179,3766),(34180,3767),(34181,3767),(34182,3767),(34183,3767),(34184,3768),(34185,3768),(34186,3768),(34187,3768),(34188,3769),(34189,3769),(34190,3769),(34191,3769),(34192,3770),(34193,3770),(34194,3770),(34195,3770),(34196,3771),(34197,3771),(34198,3771),(34199,3771),(34200,3772),(34201,3772),(34202,3772),(34203,3772),(34204,3773),(34205,3773),(34206,3773),(34207,3773),(34208,3774),(34209,3774),(34210,3774),(34211,3774),(34212,3775),(34213,3775),(34214,3775),(34215,3775),(34216,3776),(34217,3776),(34218,3776),(34219,3776),(34220,3777),(34221,3777),(34222,3777),(34223,3777),(34224,3778),(34225,3778),(34226,3778),(34227,3778),(34228,3779),(34229,3779),(34230,3779),(34231,3779),(34232,3780),(34233,3780),(34234,3780),(34235,3780),(34236,3781),(34237,3781),(34238,3781),(34239,3781),(34240,3782),(34241,3782),(34242,3782),(34243,3782),(34244,3783),(34245,3783),(34246,3783),(34247,3783),(34248,3784),(34249,3784),(34250,3784),(34251,3784),(34252,3785),(34253,3785),(34254,3785),(34255,3785),(34256,3786),(34257,3786),(34258,3786),(34259,3786),(34260,3787),(34261,3787),(34262,3787),(34263,3787),(34264,3788),(34265,3788),(34266,3788),(34267,3788),(34268,3789),(34269,3789),(34270,3789),(34271,3789),(34272,3790),(34273,3790),(34274,3790),(34275,3790),(34276,3791),(34277,3791),(34278,3791),(34279,3791),(34280,3792),(34281,3792),(34282,3792),(34283,3792),(34284,3793),(34285,3793),(34286,3793),(34287,3793),(34288,3794),(34289,3794),(34290,3794),(34291,3794),(34292,3795),(34293,3795),(34294,3795),(34295,3795),(34296,3796),(34297,3796),(34298,3796),(34299,3796),(34300,3797),(34301,3797),(34302,3797),(34303,3797),(34304,3798),(34305,3798),(34306,3798),(34307,3798),(34308,3799),(34309,3799),(34310,3799),(34311,3799),(34312,3800),(34313,3800),(34314,3800),(34315,3800),(34316,3801),(34317,3801),(34318,3801),(34319,3801),(34320,3802),(34321,3802),(34322,3802),(34323,3802),(34324,3803),(34325,3803),(34326,3803),(34327,3803),(34328,3804),(34329,3804),(34330,3804),(34331,3804),(34332,3805),(34333,3805),(34334,3805),(34335,3805),(34336,3806),(34337,3806),(34338,3806),(34339,3806),(34340,3807),(34341,3807),(34342,3807),(34343,3807),(34344,3808),(34345,3808),(34346,3808),(34347,3808),(34348,3809),(34349,3809),(34350,3809),(34351,3809),(34352,3810),(34353,3810),(34354,3810),(34355,3810),(34356,3811),(34357,3811),(34358,3811),(34359,3811),(34360,3812),(34361,3812),(34362,3812),(34363,3812),(34364,3813),(34365,3813),(34366,3813),(34367,3813),(34368,3814),(34369,3814),(34370,3814),(34371,3814),(34372,3815),(34373,3816),(34374,3817),(34375,3818),(34376,3819),(34377,3820),(34378,3821),(34379,3822),(34380,3823),(34381,3824),(34382,3825),(34383,3826),(34384,3827),(34385,3828),(34386,3829),(34387,3830),(34388,3831),(34389,3832),(34390,3833),(34391,3834),(34392,3835),(34393,3836),(34394,3837),(34395,3838),(34396,3839),(34397,3840),(34398,3841),(34399,3842),(34400,3843),(34401,3844),(34402,3845),(34403,3846),(34404,3847),(34405,3848),(34406,3849),(34407,3850),(34408,3851),(34409,3852),(34410,3853),(34411,3854),(34412,3855),(34413,3856),(34414,3857),(34415,3858),(34416,3859),(34417,3860),(34418,3861),(34419,3862),(34420,3863),(34421,3864),(34422,3865),(34423,3866),(34424,3867),(34425,3868),(34426,3869),(34427,3870),(34428,3871),(34429,3872),(34430,3873),(34431,3874),(34432,3875),(34433,3876),(34434,3877),(34435,3878),(34436,3879),(34437,3880),(34438,3881),(34439,3882),(34440,3883),(34441,3884),(34442,3885),(34443,3886),(34444,3887),(34445,3888),(34446,3889),(34447,3890),(34448,3891),(34449,3892),(34450,3893),(34451,3894),(34452,3895),(34453,3896),(34454,3897),(34455,3898),(34456,3899),(34457,3900),(34458,3901),(34459,3902),(34460,3903),(34461,3904),(34462,3905),(34463,3906),(34464,3907),(34465,3908),(34466,3909),(34467,3910),(34468,3911),(34469,3912),(34470,3913),(34471,3914),(34472,3815),(34473,3816),(34474,3817),(34475,3818),(34476,3819),(34477,3820),(34478,3821),(34479,3822),(34480,3823),(34481,3824),(34482,3825),(34483,3826),(34484,3827),(34485,3828),(34486,3829),(34487,3830),(34488,3831),(34489,3832),(34490,3833),(34491,3834),(34492,3835),(34493,3836),(34494,3837),(34495,3838),(34496,3839),(34497,3840),(34498,3841),(34499,3842),(34500,3843),(34501,3844),(34502,3845),(34503,3846),(34504,3847),(34505,3848),(34506,3849),(34507,3850),(34508,3851),(34509,3852),(34510,3853),(34511,3854),(34512,3855),(34513,3856),(34514,3857),(34515,3858),(34516,3859),(34517,3860),(34518,3861),(34519,3862),(34520,3863),(34521,3864),(34522,3865),(34523,3866),(34524,3867),(34525,3868),(34526,3869),(34527,3870),(34528,3871),(34529,3872),(34530,3873),(34531,3874),(34532,3875),(34533,3876),(34534,3877),(34535,3878),(34536,3879),(34537,3880),(34538,3881),(34539,3882),(34540,3883),(34541,3884),(34542,3885),(34543,3886),(34544,3887),(34545,3888),(34546,3889),(34547,3890),(34548,3891),(34549,3892),(34550,3893),(34551,3894),(34552,3895),(34553,3896),(34554,3897),(34555,3898),(34556,3899),(34557,3900),(34558,3901),(34559,3902),(34560,3903),(34561,3904),(34562,3905),(34563,3906),(34564,3907),(34565,3908),(34566,3909),(34567,3910),(34568,3911),(34569,3912),(34570,3913),(34571,3914),(34572,3815),(34573,3815),(34574,3815),(34575,3816),(34576,3816),(34577,3816),(34578,3817),(34579,3817),(34580,3817),(34581,3818),(34582,3818),(34583,3818),(34584,3819),(34585,3819),(34586,3819),(34587,3820),(34588,3820),(34589,3820),(34590,3821),(34591,3821),(34592,3821),(34593,3822),(34594,3822),(34595,3822),(34596,3823),(34597,3823),(34598,3823),(34599,3824),(34600,3824),(34601,3824),(34602,3825),(34603,3825),(34604,3825),(34605,3826),(34606,3826),(34607,3826),(34608,3827),(34609,3827),(34610,3827),(34611,3828),(34612,3828),(34613,3828),(34614,3829),(34615,3829),(34616,3829),(34617,3830),(34618,3830),(34619,3830),(34620,3831),(34621,3831),(34622,3831),(34623,3832),(34624,3832),(34625,3832),(34626,3833),(34627,3833),(34628,3833),(34629,3834),(34630,3834),(34631,3834),(34632,3835),(34633,3835),(34634,3835),(34635,3836),(34636,3836),(34637,3836),(34638,3837),(34639,3837),(34640,3837),(34641,3838),(34642,3838),(34643,3838),(34644,3839),(34645,3839),(34646,3839),(34647,3840),(34648,3840),(34649,3840),(34650,3841),(34651,3841),(34652,3841),(34653,3842),(34654,3842),(34655,3842),(34656,3843),(34657,3843),(34658,3843),(34659,3844),(34660,3844),(34661,3844),(34662,3845),(34663,3845),(34664,3845),(34665,3846),(34666,3846),(34667,3846),(34668,3847),(34669,3847),(34670,3847),(34671,3848),(34672,3848),(34673,3848),(34674,3849),(34675,3849),(34676,3849),(34677,3850),(34678,3850),(34679,3850),(34680,3851),(34681,3851),(34682,3851),(34683,3852),(34684,3852),(34685,3852),(34686,3853),(34687,3853),(34688,3853),(34689,3854),(34690,3854),(34691,3854),(34692,3855),(34693,3855),(34694,3855),(34695,3856),(34696,3856),(34697,3856),(34698,3857),(34699,3857),(34700,3857),(34701,3858),(34702,3858),(34703,3858),(34704,3859),(34705,3859),(34706,3859),(34707,3860),(34708,3860),(34709,3860),(34710,3861),(34711,3861),(34712,3861),(34713,3862),(34714,3862),(34715,3862),(34716,3863),(34717,3863),(34718,3863),(34719,3864),(34720,3864),(34721,3864),(34722,3865),(34723,3865),(34724,3865),(34725,3866),(34726,3866),(34727,3866),(34728,3867),(34729,3867),(34730,3867),(34731,3868),(34732,3868),(34733,3868),(34734,3869),(34735,3869),(34736,3869),(34737,3870),(34738,3870),(34739,3870),(34740,3871),(34741,3871),(34742,3871),(34743,3872),(34744,3872),(34745,3873),(34746,3873),(34747,3874),(34748,3874),(34749,3874),(34750,3875),(34751,3875),(34752,3875),(34753,3876),(34754,3876),(34755,3876),(34756,3877),(34757,3877),(34758,3877),(34759,3878),(34760,3878),(34761,3878),(34762,3879),(34763,3879),(34764,3879),(34765,3880),(34766,3880),(34767,3880),(34768,3881),(34769,3881),(34770,3881),(34771,3882),(34772,3882),(34773,3882),(34774,3883),(34775,3883),(34776,3883),(34777,3884),(34778,3884),(34779,3884),(34780,3885),(34781,3885),(34782,3886),(34783,3886),(34784,3886),(34785,3887),(34786,3887),(34787,3887),(34788,3888),(34789,3888),(34790,3888),(34791,3889),(34792,3889),(34793,3889),(34794,3890),(34795,3890),(34796,3890),(34797,3891),(34798,3891),(34799,3891),(34800,3892),(34801,3892),(34802,3892),(34803,3893),(34804,3893),(34805,3893),(34806,3894),(34807,3894),(34808,3894),(34809,3895),(34810,3895),(34811,3895),(34812,3896),(34813,3896),(34814,3896),(34815,3897),(34816,3897),(34817,3897),(34818,3898),(34819,3898),(34820,3898),(34821,3899),(34822,3899),(34823,3899),(34824,3900),(34825,3900),(34826,3900),(34827,3901),(34828,3901),(34829,3901),(34830,3902),(34831,3902),(34832,3902),(34833,3903),(34834,3903),(34835,3903),(34836,3904),(34837,3904),(34838,3904),(34839,3905),(34840,3905),(34841,3905),(34842,3906),(34843,3906),(34844,3906),(34845,3907),(34846,3907),(34847,3907),(34848,3908),(34849,3908),(34850,3908),(34851,3909),(34852,3909),(34853,3909),(34854,3910),(34855,3910),(34856,3910),(34857,3911),(34858,3911),(34859,3911),(34860,3912),(34861,3912),(34862,3912),(34863,3913),(34864,3913),(34865,3913),(34866,3914),(34867,3914),(34868,3914),(34869,3815),(34870,3815),(34871,3815),(34872,3815),(34873,3816),(34874,3816),(34875,3816),(34876,3816),(34877,3817),(34878,3817),(34879,3817),(34880,3817),(34881,3818),(34882,3818),(34883,3818),(34884,3818),(34885,3819),(34886,3819),(34887,3819),(34888,3819),(34889,3820),(34890,3820),(34891,3820),(34892,3820),(34893,3821),(34894,3821),(34895,3821),(34896,3821),(34897,3822),(34898,3822),(34899,3822),(34900,3822),(34901,3823),(34902,3823),(34903,3823),(34904,3823),(34905,3824),(34906,3824),(34907,3824),(34908,3824),(34909,3825),(34910,3825),(34911,3825),(34912,3825),(34913,3826),(34914,3826),(34915,3826),(34916,3826),(34917,3827),(34918,3827),(34919,3827),(34920,3827),(34921,3828),(34922,3828),(34923,3828),(34924,3828),(34925,3829),(34926,3829),(34927,3829),(34928,3829),(34929,3830),(34930,3830),(34931,3830),(34932,3830),(34933,3831),(34934,3831),(34935,3831),(34936,3831),(34937,3832),(34938,3832),(34939,3832),(34940,3832),(34941,3833),(34942,3833),(34943,3833),(34944,3833),(34945,3834),(34946,3834),(34947,3834),(34948,3834),(34949,3835),(34950,3835),(34951,3835),(34952,3835),(34953,3836),(34954,3836),(34955,3836),(34956,3836),(34957,3837),(34958,3837),(34959,3837),(34960,3837),(34961,3838),(34962,3838),(34963,3838),(34964,3838),(34965,3839),(34966,3839),(34967,3839),(34968,3839),(34969,3840),(34970,3840),(34971,3840),(34972,3840),(34973,3841),(34974,3841),(34975,3841),(34976,3841),(34977,3842),(34978,3842),(34979,3842),(34980,3842),(34981,3843),(34982,3843),(34983,3843),(34984,3843),(34985,3844),(34986,3844),(34987,3844),(34988,3844),(34989,3845),(34990,3845),(34991,3845),(34992,3845),(34993,3846),(34994,3846),(34995,3846),(34996,3846),(34997,3847),(34998,3847),(34999,3847),(35000,3847),(35001,3848),(35002,3848),(35003,3848),(35004,3848),(35005,3849),(35006,3849),(35007,3849),(35008,3849),(35009,3850),(35010,3850),(35011,3850),(35012,3850),(35013,3851),(35014,3851),(35015,3851),(35016,3851),(35017,3852),(35018,3852),(35019,3852),(35020,3852),(35021,3853),(35022,3853),(35023,3853),(35024,3853),(35025,3854),(35026,3854),(35027,3854),(35028,3854),(35029,3855),(35030,3855),(35031,3855),(35032,3855),(35033,3856),(35034,3856),(35035,3856),(35036,3856),(35037,3857),(35038,3857),(35039,3857),(35040,3857),(35041,3858),(35042,3858),(35043,3858),(35044,3858),(35045,3859),(35046,3859),(35047,3859),(35048,3859),(35049,3860),(35050,3860),(35051,3860),(35052,3860),(35053,3861),(35054,3861),(35055,3861),(35056,3861),(35057,3862),(35058,3862),(35059,3862),(35060,3862),(35061,3863),(35062,3863),(35063,3863),(35064,3863),(35065,3864),(35066,3864),(35067,3864),(35068,3864),(35069,3865),(35070,3865),(35071,3865),(35072,3865),(35073,3866),(35074,3866),(35075,3866),(35076,3866),(35077,3867),(35078,3867),(35079,3867),(35080,3867),(35081,3868),(35082,3868),(35083,3868),(35084,3868),(35085,3869),(35086,3869),(35087,3869),(35088,3869),(35089,3870),(35090,3870),(35091,3870),(35092,3870),(35093,3871),(35094,3871),(35095,3871),(35096,3871),(35097,3872),(35098,3872),(35099,3872),(35100,3872),(35101,3873),(35102,3873),(35103,3873),(35104,3873),(35105,3874),(35106,3874),(35107,3874),(35108,3874),(35109,3875),(35110,3875),(35111,3875),(35112,3875),(35113,3876),(35114,3876),(35115,3876),(35116,3876),(35117,3877),(35118,3877),(35119,3877),(35120,3877),(35121,3878),(35122,3878),(35123,3878),(35124,3878),(35125,3879),(35126,3879),(35127,3879),(35128,3879),(35129,3880),(35130,3880),(35131,3880),(35132,3880),(35133,3881),(35134,3881),(35135,3881),(35136,3881),(35137,3882),(35138,3882),(35139,3882),(35140,3882),(35141,3883),(35142,3883),(35143,3883),(35144,3883),(35145,3884),(35146,3884),(35147,3884),(35148,3884),(35149,3885),(35150,3885),(35151,3885),(35152,3885),(35153,3886),(35154,3886),(35155,3886),(35156,3886),(35157,3887),(35158,3887),(35159,3887),(35160,3887),(35161,3888),(35162,3888),(35163,3888),(35164,3888),(35165,3889),(35166,3889),(35167,3889),(35168,3889),(35169,3890),(35170,3890),(35171,3890),(35172,3890),(35173,3891),(35174,3891),(35175,3891),(35176,3891),(35177,3892),(35178,3892),(35179,3892),(35180,3892),(35181,3893),(35182,3893),(35183,3893),(35184,3893),(35185,3894),(35186,3894),(35187,3894),(35188,3894),(35189,3895),(35190,3895),(35191,3895),(35192,3895),(35193,3896),(35194,3896),(35195,3896),(35196,3896),(35197,3897),(35198,3897),(35199,3897),(35200,3897),(35201,3898),(35202,3898),(35203,3898),(35204,3898),(35205,3899),(35206,3899),(35207,3899),(35208,3899),(35209,3900),(35210,3900),(35211,3900),(35212,3900),(35213,3901),(35214,3901),(35215,3901),(35216,3901),(35217,3902),(35218,3902),(35219,3902),(35220,3902),(35221,3903),(35222,3903),(35223,3903),(35224,3903),(35225,3904),(35226,3904),(35227,3904),(35228,3904),(35229,3905),(35230,3905),(35231,3905),(35232,3905),(35233,3906),(35234,3906),(35235,3906),(35236,3906),(35237,3907),(35238,3907),(35239,3907),(35240,3907),(35241,3908),(35242,3908),(35243,3908),(35244,3908),(35245,3909),(35246,3909),(35247,3909),(35248,3909),(35249,3910),(35250,3910),(35251,3910),(35252,3910),(35253,3911),(35254,3911),(35255,3911),(35256,3911),(35257,3912),(35258,3912),(35259,3912),(35260,3912),(35261,3913),(35262,3913),(35263,3913),(35264,3913),(35265,3914),(35266,3914),(35267,3914),(35268,3914),(35269,3915),(35270,3916),(35271,3917),(35272,3918),(35273,3919),(35274,3920),(35275,3921),(35276,3922),(35277,3923),(35278,3924),(35279,3925),(35280,3926),(35281,3927),(35282,3928),(35283,3929),(35284,3930),(35285,3931),(35286,3932),(35287,3933),(35288,3934),(35289,3935),(35290,3936),(35291,3937),(35292,3938),(35293,3939),(35294,3940),(35295,3941),(35296,3942),(35297,3943),(35298,3944),(35299,3945),(35300,3946),(35301,3947),(35302,3948),(35303,3949),(35304,3950),(35305,3951),(35306,3952),(35307,3953),(35308,3954),(35309,3955),(35310,3956),(35311,3957),(35312,3958),(35313,3959),(35314,3960),(35315,3961),(35316,3962),(35317,3963),(35318,3964),(35319,3965),(35320,3966),(35321,3967),(35322,3968),(35323,3969),(35324,3970),(35325,3971),(35326,3972),(35327,3973),(35328,3974),(35329,3975),(35330,3976),(35331,3977),(35332,3978),(35333,3979),(35334,3980),(35335,3981),(35336,3982),(35337,3983),(35338,3984),(35339,3985),(35340,3986),(35341,3987),(35342,3988),(35343,3989),(35344,3990),(35345,3991),(35346,3992),(35347,3993),(35348,3994),(35349,3995),(35350,3996),(35351,3997),(35352,3998),(35353,3999),(35354,4000),(35355,4001),(35356,4002),(35357,4003),(35358,4004),(35359,4005),(35360,4006),(35361,4007),(35362,4008),(35363,4009),(35364,4010),(35365,4011),(35366,4012),(35367,4013),(35368,4014),(35369,3915),(35370,3916),(35371,3917),(35372,3918),(35373,3919),(35374,3920),(35375,3921),(35376,3922),(35377,3923),(35378,3924),(35379,3925),(35380,3926),(35381,3927),(35382,3928),(35383,3929),(35384,3930),(35385,3931),(35386,3932),(35387,3933),(35388,3934),(35389,3935),(35390,3936),(35391,3937),(35392,3938),(35393,3939),(35394,3940),(35395,3941),(35396,3942),(35397,3943),(35398,3944),(35399,3945),(35400,3946),(35401,3947),(35402,3948),(35403,3949),(35404,3950),(35405,3951),(35406,3952),(35407,3953),(35408,3954),(35409,3955),(35410,3956),(35411,3957),(35412,3958),(35413,3959),(35414,3960),(35415,3961),(35416,3962),(35417,3963),(35418,3964),(35419,3965),(35420,3966),(35421,3967),(35422,3968),(35423,3969),(35424,3970),(35425,3971),(35426,3972),(35427,3973),(35428,3974),(35429,3975),(35430,3976),(35431,3977),(35432,3978),(35433,3979),(35434,3980),(35435,3981),(35436,3982),(35437,3983),(35438,3984),(35439,3985),(35440,3986),(35441,3987),(35442,3988),(35443,3989),(35444,3990),(35445,3991),(35446,3992),(35447,3993),(35448,3994),(35449,3995),(35450,3996),(35451,3997),(35452,3998),(35453,3999),(35454,4000),(35455,4001),(35456,4002),(35457,4003),(35458,4004),(35459,4005),(35460,4006),(35461,4007),(35462,4008),(35463,4009),(35464,4010),(35465,4011),(35466,4012),(35467,4013),(35468,4014),(35469,3915),(35470,3915),(35471,3915),(35472,3916),(35473,3916),(35474,3916),(35475,3917),(35476,3917),(35477,3917),(35478,3918),(35479,3918),(35480,3918),(35481,3919),(35482,3919),(35483,3920),(35484,3920),(35485,3921),(35486,3921),(35487,3922),(35488,3922),(35489,3923),(35490,3923),(35491,3923),(35492,3924),(35493,3924),(35494,3924),(35495,3925),(35496,3925),(35497,3925),(35498,3926),(35499,3926),(35500,3926),(35501,3927),(35502,3927),(35503,3927),(35504,3928),(35505,3928),(35506,3928),(35507,3929),(35508,3929),(35509,3929),(35510,3930),(35511,3930),(35512,3930),(35513,3931),(35514,3931),(35515,3931),(35516,3932),(35517,3932),(35518,3932),(35519,3933),(35520,3933),(35521,3933),(35522,3934),(35523,3934),(35524,3934),(35525,3935),(35526,3935),(35527,3935),(35528,3936),(35529,3936),(35530,3936),(35531,3937),(35532,3937),(35533,3937),(35534,3938),(35535,3938),(35536,3938),(35537,3939),(35538,3939),(35539,3939),(35540,3940),(35541,3940),(35542,3940),(35543,3941),(35544,3941),(35545,3941),(35546,3942),(35547,3942),(35548,3942),(35549,3943),(35550,3943),(35551,3943),(35552,3944),(35553,3944),(35554,3944),(35555,3945),(35556,3945),(35557,3945),(35558,3946),(35559,3946),(35560,3946),(35561,3947),(35562,3947),(35563,3947),(35564,3948),(35565,3948),(35566,3948),(35567,3949),(35568,3949),(35569,3949),(35570,3950),(35571,3950),(35572,3950),(35573,3951),(35574,3951),(35575,3951),(35576,3952),(35577,3952),(35578,3952),(35579,3953),(35580,3953),(35581,3953),(35582,3954),(35583,3954),(35584,3954),(35585,3955),(35586,3955),(35587,3955),(35588,3956),(35589,3956),(35590,3956),(35591,3957),(35592,3957),(35593,3957),(35594,3958),(35595,3958),(35596,3958),(35597,3959),(35598,3959),(35599,3959),(35600,3960),(35601,3960),(35602,3960),(35603,3961),(35604,3961),(35605,3961),(35606,3962),(35607,3962),(35608,3962),(35609,3963),(35610,3963),(35611,3963),(35612,3964),(35613,3964),(35614,3964),(35615,3965),(35616,3965),(35617,3965),(35618,3966),(35619,3966),(35620,3966),(35621,3967),(35622,3967),(35623,3967),(35624,3968),(35625,3968),(35626,3968),(35627,3969),(35628,3969),(35629,3969),(35630,3970),(35631,3970),(35632,3970),(35633,3971),(35634,3971),(35635,3971),(35636,3972),(35637,3972),(35638,3972),(35639,3973),(35640,3973),(35641,3973),(35642,3974),(35643,3974),(35644,3974),(35645,3975),(35646,3975),(35647,3975),(35648,3976),(35649,3976),(35650,3976),(35651,3977),(35652,3977),(35653,3977),(35654,3978),(35655,3978),(35656,3978),(35657,3979),(35658,3979),(35659,3979),(35660,3980),(35661,3980),(35662,3980),(35663,3981),(35664,3981),(35665,3981),(35666,3982),(35667,3982),(35668,3982),(35669,3983),(35670,3983),(35671,3983),(35672,3984),(35673,3984),(35674,3984),(35675,3985),(35676,3985),(35677,3985),(35678,3986),(35679,3986),(35680,3986),(35681,3987),(35682,3987),(35683,3987),(35684,3988),(35685,3988),(35686,3988),(35687,3989),(35688,3989),(35689,3989),(35690,3990),(35691,3990),(35692,3990),(35693,3991),(35694,3991),(35695,3991),(35696,3992),(35697,3992),(35698,3992),(35699,3993),(35700,3993),(35701,3993),(35702,3994),(35703,3994),(35704,3994),(35705,3995),(35706,3995),(35707,3995),(35708,3996),(35709,3996),(35710,3996),(35711,3997),(35712,3997),(35713,3997),(35714,3998),(35715,3998),(35716,3998),(35717,3999),(35718,3999),(35719,3999),(35720,4000),(35721,4000),(35722,4000),(35723,4001),(35724,4001),(35725,4001),(35726,4002),(35727,4002),(35728,4002),(35729,4003),(35730,4003),(35731,4003),(35732,4004),(35733,4004),(35734,4004),(35735,4005),(35736,4005),(35737,4005),(35738,4006),(35739,4006),(35740,4006),(35741,4007),(35742,4007),(35743,4007),(35744,4008),(35745,4008),(35746,4008),(35747,4009),(35748,4009),(35749,4009),(35750,4010),(35751,4010),(35752,4010),(35753,4011),(35754,4011),(35755,4011),(35756,4012),(35757,4012),(35758,4012),(35759,4013),(35760,4013),(35761,4013),(35762,4014),(35763,4014),(35764,4014),(35765,3915),(35766,3915),(35767,3915),(35768,3915),(35769,3916),(35770,3916),(35771,3916),(35772,3916),(35773,3917),(35774,3917),(35775,3917),(35776,3917),(35777,3918),(35778,3918),(35779,3918),(35780,3918),(35781,3919),(35782,3919),(35783,3919),(35784,3919),(35785,3920),(35786,3920),(35787,3920),(35788,3920),(35789,3921),(35790,3921),(35791,3921),(35792,3921),(35793,3922),(35794,3922),(35795,3922),(35796,3922),(35797,3923),(35798,3923),(35799,3923),(35800,3923),(35801,3924),(35802,3924),(35803,3924),(35804,3924),(35805,3925),(35806,3925),(35807,3925),(35808,3925),(35809,3926),(35810,3926),(35811,3926),(35812,3926),(35813,3927),(35814,3927),(35815,3927),(35816,3927),(35817,3928),(35818,3928),(35819,3928),(35820,3928),(35821,3929),(35822,3929),(35823,3929),(35824,3929),(35825,3930),(35826,3930),(35827,3930),(35828,3930),(35829,3931),(35830,3931),(35831,3931),(35832,3931),(35833,3932),(35834,3932),(35835,3932),(35836,3932),(35837,3933),(35838,3933),(35839,3933),(35840,3933),(35841,3934),(35842,3934),(35843,3934),(35844,3934),(35845,3935),(35846,3935),(35847,3935),(35848,3935),(35849,3936),(35850,3936),(35851,3936),(35852,3936),(35853,3937),(35854,3937),(35855,3937),(35856,3937),(35857,3938),(35858,3938),(35859,3938),(35860,3938),(35861,3939),(35862,3939),(35863,3939),(35864,3939),(35865,3940),(35866,3940),(35867,3940),(35868,3940),(35869,3941),(35870,3941),(35871,3941),(35872,3941),(35873,3942),(35874,3942),(35875,3942),(35876,3942),(35877,3943),(35878,3943),(35879,3943),(35880,3943),(35881,3944),(35882,3944),(35883,3944),(35884,3944),(35885,3945),(35886,3945),(35887,3945),(35888,3945),(35889,3946),(35890,3946),(35891,3946),(35892,3946),(35893,3947),(35894,3947),(35895,3947),(35896,3947),(35897,3948),(35898,3948),(35899,3948),(35900,3948),(35901,3949),(35902,3949),(35903,3949),(35904,3949),(35905,3950),(35906,3950),(35907,3950),(35908,3950),(35909,3951),(35910,3951),(35911,3951),(35912,3951),(35913,3952),(35914,3952),(35915,3952),(35916,3952),(35917,3953),(35918,3953),(35919,3953),(35920,3953),(35921,3954),(35922,3954),(35923,3954),(35924,3954),(35925,3955),(35926,3955),(35927,3955),(35928,3955),(35929,3956),(35930,3956),(35931,3956),(35932,3956),(35933,3957),(35934,3957),(35935,3957),(35936,3957),(35937,3958),(35938,3958),(35939,3958),(35940,3958),(35941,3959),(35942,3959),(35943,3959),(35944,3959),(35945,3960),(35946,3960),(35947,3960),(35948,3960),(35949,3961),(35950,3961),(35951,3961),(35952,3961),(35953,3962),(35954,3962),(35955,3962),(35956,3962),(35957,3963),(35958,3963),(35959,3963),(35960,3963),(35961,3964),(35962,3964),(35963,3964),(35964,3964),(35965,3965),(35966,3965),(35967,3965),(35968,3965),(35969,3966),(35970,3966),(35971,3966),(35972,3966),(35973,3967),(35974,3967),(35975,3967),(35976,3967),(35977,3968),(35978,3968),(35979,3968),(35980,3968),(35981,3969),(35982,3969),(35983,3969),(35984,3969),(35985,3970),(35986,3970),(35987,3970),(35988,3970),(35989,3971),(35990,3971),(35991,3971),(35992,3971),(35993,3972),(35994,3972),(35995,3972),(35996,3972),(35997,3973),(35998,3973),(35999,3973),(36000,3973),(36001,3974),(36002,3974),(36003,3974),(36004,3974),(36005,3975),(36006,3975),(36007,3975),(36008,3975),(36009,3976),(36010,3976),(36011,3976),(36012,3976),(36013,3977),(36014,3977),(36015,3977),(36016,3977),(36017,3978),(36018,3978),(36019,3978),(36020,3978),(36021,3979),(36022,3979),(36023,3979),(36024,3979),(36025,3980),(36026,3980),(36027,3980),(36028,3980),(36029,3981),(36030,3981),(36031,3981),(36032,3981),(36033,3982),(36034,3982),(36035,3982),(36036,3982),(36037,3983),(36038,3983),(36039,3983),(36040,3983),(36041,3984),(36042,3984),(36043,3984),(36044,3984),(36045,3985),(36046,3985),(36047,3985),(36048,3985),(36049,3986),(36050,3986),(36051,3986),(36052,3986),(36053,3987),(36054,3987),(36055,3987),(36056,3987),(36057,3988),(36058,3988),(36059,3988),(36060,3988),(36061,3989),(36062,3989),(36063,3989),(36064,3989),(36065,3990),(36066,3990),(36067,3990),(36068,3990),(36069,3991),(36070,3991),(36071,3991),(36072,3991),(36073,3992),(36074,3992),(36075,3992),(36076,3992),(36077,3993),(36078,3993),(36079,3993),(36080,3993),(36081,3994),(36082,3994),(36083,3994),(36084,3994),(36085,3995),(36086,3995),(36087,3995),(36088,3995),(36089,3996),(36090,3996),(36091,3996),(36092,3996),(36093,3997),(36094,3997),(36095,3997),(36096,3997),(36097,3998),(36098,3998),(36099,3998),(36100,3998),(36101,3999),(36102,3999),(36103,3999),(36104,3999),(36105,4000),(36106,4000),(36107,4000),(36108,4000),(36109,4001),(36110,4001),(36111,4001),(36112,4001),(36113,4002),(36114,4002),(36115,4002),(36116,4002),(36117,4003),(36118,4003),(36119,4003),(36120,4003),(36121,4004),(36122,4004),(36123,4004),(36124,4004),(36125,4005),(36126,4005),(36127,4005),(36128,4005),(36129,4006),(36130,4006),(36131,4006),(36132,4006),(36133,4007),(36134,4007),(36135,4007),(36136,4007),(36137,4008),(36138,4008),(36139,4008),(36140,4008),(36141,4009),(36142,4009),(36143,4009),(36144,4009),(36145,4010),(36146,4010),(36147,4010),(36148,4010),(36149,4011),(36150,4011),(36151,4011),(36152,4011),(36153,4012),(36154,4012),(36155,4012),(36156,4012),(36157,4013),(36158,4013),(36159,4013),(36160,4013),(36161,4014),(36162,4014),(36163,4014),(36164,4014),(36165,4015),(36166,4016),(36167,4017),(36168,4018),(36169,4019),(36170,4020),(36171,4021),(36172,4022),(36173,4023),(36174,4024),(36175,4025),(36176,4026),(36177,4027),(36178,4028),(36179,4029),(36180,4030),(36181,4031),(36182,4032),(36183,4033),(36184,4034),(36185,4035),(36186,4036),(36187,4037),(36188,4038),(36189,4039),(36190,4040),(36191,4041),(36192,4042),(36193,4043),(36194,4044),(36195,4045),(36196,4046),(36197,4047),(36198,4048),(36199,4049),(36200,4050),(36201,4051),(36202,4052),(36203,4053),(36204,4054),(36205,4055),(36206,4056),(36207,4057),(36208,4058),(36209,4059),(36210,4060),(36211,4061),(36212,4062),(36213,4063),(36214,4064),(36215,4065),(36216,4066),(36217,4067),(36218,4068),(36219,4069),(36220,4070),(36221,4071),(36222,4072),(36223,4073),(36224,4074),(36225,4075),(36226,4076),(36227,4077),(36228,4078),(36229,4079),(36230,4080),(36231,4081),(36232,4082),(36233,4083),(36234,4084),(36235,4085),(36236,4086),(36237,4087),(36238,4088),(36239,4089),(36240,4090),(36241,4091),(36242,4092),(36243,4093),(36244,4094),(36245,4095),(36246,4096),(36247,4097),(36248,4098),(36249,4099),(36250,4100),(36251,4101),(36252,4102),(36253,4103),(36254,4104),(36255,4105),(36256,4106),(36257,4107),(36258,4108),(36259,4109),(36260,4110),(36261,4111),(36262,4112),(36263,4113),(36264,4114),(36265,4015),(36266,4016),(36267,4017),(36268,4018),(36269,4019),(36270,4020),(36271,4021),(36272,4022),(36273,4023),(36274,4024),(36275,4025),(36276,4026),(36277,4027),(36278,4028),(36279,4029),(36280,4030),(36281,4031),(36282,4032),(36283,4033),(36284,4034),(36285,4035),(36286,4036),(36287,4037),(36288,4038),(36289,4039),(36290,4040),(36291,4041),(36292,4042),(36293,4043),(36294,4044),(36295,4045),(36296,4046),(36297,4047),(36298,4048),(36299,4049),(36300,4050),(36301,4051),(36302,4052),(36303,4053),(36304,4054),(36305,4055),(36306,4056),(36307,4057),(36308,4058),(36309,4059),(36310,4060),(36311,4061),(36312,4062),(36313,4063),(36314,4064),(36315,4065),(36316,4066),(36317,4067),(36318,4068),(36319,4069),(36320,4070),(36321,4071),(36322,4072),(36323,4073),(36324,4074),(36325,4075),(36326,4076),(36327,4077),(36328,4078),(36329,4079),(36330,4080),(36331,4081),(36332,4082),(36333,4083),(36334,4084),(36335,4085),(36336,4086),(36337,4087),(36338,4088),(36339,4089),(36340,4090),(36341,4091),(36342,4092),(36343,4093),(36344,4094),(36345,4095),(36346,4096),(36347,4097),(36348,4098),(36349,4099),(36350,4100),(36351,4101),(36352,4102),(36353,4103),(36354,4104),(36355,4105),(36356,4106),(36357,4107),(36358,4108),(36359,4109),(36360,4110),(36361,4111),(36362,4112),(36363,4113),(36364,4114),(36365,4015),(36366,4015),(36367,4015),(36368,4016),(36369,4016),(36370,4016),(36371,4017),(36372,4017),(36373,4017),(36374,4018),(36375,4018),(36376,4018),(36377,4019),(36378,4019),(36379,4019),(36380,4020),(36381,4020),(36382,4020),(36383,4021),(36384,4021),(36385,4021),(36386,4022),(36387,4022),(36388,4022),(36389,4023),(36390,4023),(36391,4023),(36392,4024),(36393,4024),(36394,4024),(36395,4025),(36396,4025),(36397,4025),(36398,4026),(36399,4026),(36400,4026),(36401,4027),(36402,4027),(36403,4027),(36404,4028),(36405,4028),(36406,4028),(36407,4029),(36408,4029),(36409,4029),(36410,4030),(36411,4030),(36412,4030),(36413,4031),(36414,4031),(36415,4031),(36416,4032),(36417,4032),(36418,4032),(36419,4033),(36420,4033),(36421,4033),(36422,4034),(36423,4034),(36424,4034),(36425,4035),(36426,4035),(36427,4035),(36428,4036),(36429,4036),(36430,4036),(36431,4037),(36432,4037),(36433,4037),(36434,4038),(36435,4038),(36436,4038),(36437,4039),(36438,4039),(36439,4039),(36440,4040),(36441,4040),(36442,4040),(36443,4041),(36444,4041),(36445,4041),(36446,4042),(36447,4042),(36448,4042),(36449,4043),(36450,4043),(36451,4044),(36452,4044),(36453,4044),(36454,4045),(36455,4045),(36456,4045),(36457,4046),(36458,4046),(36459,4046),(36460,4047),(36461,4047),(36462,4047),(36463,4048),(36464,4048),(36465,4048),(36466,4049),(36467,4049),(36468,4049),(36469,4050),(36470,4050),(36471,4050),(36472,4051),(36473,4051),(36474,4051),(36475,4052),(36476,4052),(36477,4052),(36478,4053),(36479,4053),(36480,4053),(36481,4054),(36482,4054),(36483,4055),(36484,4055),(36485,4056),(36486,4056),(36487,4056),(36488,4057),(36489,4057),(36490,4057),(36491,4058),(36492,4058),(36493,4058),(36494,4059),(36495,4059),(36496,4059),(36497,4060),(36498,4060),(36499,4060),(36500,4061),(36501,4061),(36502,4061),(36503,4062),(36504,4062),(36505,4062),(36506,4063),(36507,4063),(36508,4063),(36509,4064),(36510,4064),(36511,4064),(36512,4065),(36513,4065),(36514,4065),(36515,4066),(36516,4066),(36517,4066),(36518,4067),(36519,4067),(36520,4067),(36521,4068),(36522,4068),(36523,4068),(36524,4069),(36525,4069),(36526,4069),(36527,4070),(36528,4070),(36529,4070),(36530,4071),(36531,4071),(36532,4071),(36533,4072),(36534,4072),(36535,4072),(36536,4073),(36537,4073),(36538,4073),(36539,4074),(36540,4074),(36541,4074),(36542,4075),(36543,4075),(36544,4076),(36545,4076),(36546,4077),(36547,4077),(36548,4078),(36549,4078),(36550,4079),(36551,4079),(36552,4079),(36553,4080),(36554,4080),(36555,4080),(36556,4081),(36557,4081),(36558,4081),(36559,4082),(36560,4082),(36561,4082),(36562,4083),(36563,4083),(36564,4083),(36565,4084),(36566,4084),(36567,4084),(36568,4085),(36569,4085),(36570,4085),(36571,4086),(36572,4086),(36573,4086),(36574,4087),(36575,4087),(36576,4087),(36577,4088),(36578,4088),(36579,4088),(36580,4089),(36581,4089),(36582,4089),(36583,4090),(36584,4090),(36585,4090),(36586,4091),(36587,4091),(36588,4091),(36589,4092),(36590,4092),(36591,4093),(36592,4093),(36593,4094),(36594,4094),(36595,4095),(36596,4095),(36597,4096),(36598,4096),(36599,4097),(36600,4097),(36601,4098),(36602,4098),(36603,4098),(36604,4099),(36605,4099),(36606,4099),(36607,4100),(36608,4100),(36609,4100),(36610,4101),(36611,4101),(36612,4101),(36613,4102),(36614,4102),(36615,4102),(36616,4103),(36617,4103),(36618,4103),(36619,4104),(36620,4104),(36621,4104),(36622,4105),(36623,4105),(36624,4105),(36625,4106),(36626,4106),(36627,4106),(36628,4107),(36629,4107),(36630,4107),(36631,4108),(36632,4108),(36633,4108),(36634,4109),(36635,4109),(36636,4109),(36637,4110),(36638,4110),(36639,4110),(36640,4111),(36641,4111),(36642,4111),(36643,4112),(36644,4112),(36645,4112),(36646,4113),(36647,4113),(36648,4113),(36649,4114),(36650,4114),(36651,4114),(36652,4015),(36653,4015),(36654,4015),(36655,4015),(36656,4016),(36657,4016),(36658,4016),(36659,4016),(36660,4017),(36661,4017),(36662,4017),(36663,4017),(36664,4018),(36665,4018),(36666,4018),(36667,4018),(36668,4019),(36669,4019),(36670,4019),(36671,4019),(36672,4020),(36673,4020),(36674,4020),(36675,4020),(36676,4021),(36677,4021),(36678,4021),(36679,4021),(36680,4022),(36681,4022),(36682,4022),(36683,4022),(36684,4023),(36685,4023),(36686,4023),(36687,4023),(36688,4024),(36689,4024),(36690,4024),(36691,4024),(36692,4025),(36693,4025),(36694,4025),(36695,4025),(36696,4026),(36697,4026),(36698,4026),(36699,4026),(36700,4027),(36701,4027),(36702,4027),(36703,4027),(36704,4028),(36705,4028),(36706,4028),(36707,4028),(36708,4029),(36709,4029),(36710,4029),(36711,4029),(36712,4030),(36713,4030),(36714,4030),(36715,4030),(36716,4031),(36717,4031),(36718,4031),(36719,4031),(36720,4032),(36721,4032),(36722,4032),(36723,4032),(36724,4033),(36725,4033),(36726,4033),(36727,4033),(36728,4034),(36729,4034),(36730,4034),(36731,4034),(36732,4035),(36733,4035),(36734,4035),(36735,4035),(36736,4036),(36737,4036),(36738,4036),(36739,4036),(36740,4037),(36741,4037),(36742,4037),(36743,4037),(36744,4038),(36745,4038),(36746,4038),(36747,4038),(36748,4039),(36749,4039),(36750,4039),(36751,4039),(36752,4040),(36753,4040),(36754,4040),(36755,4040),(36756,4041),(36757,4041),(36758,4041),(36759,4041),(36760,4042),(36761,4042),(36762,4042),(36763,4042),(36764,4043),(36765,4043),(36766,4043),(36767,4043),(36768,4044),(36769,4044),(36770,4044),(36771,4044),(36772,4045),(36773,4045),(36774,4045),(36775,4045),(36776,4046),(36777,4046),(36778,4046),(36779,4046),(36780,4047),(36781,4047),(36782,4047),(36783,4047),(36784,4048),(36785,4048),(36786,4048),(36787,4048),(36788,4049),(36789,4049),(36790,4049),(36791,4049),(36792,4050),(36793,4050),(36794,4050),(36795,4050),(36796,4051),(36797,4051),(36798,4051),(36799,4051),(36800,4052),(36801,4052),(36802,4052),(36803,4052),(36804,4053),(36805,4053),(36806,4053),(36807,4053),(36808,4054),(36809,4054),(36810,4054),(36811,4054),(36812,4055),(36813,4055),(36814,4055),(36815,4055),(36816,4056),(36817,4056),(36818,4056),(36819,4056),(36820,4057),(36821,4057),(36822,4057),(36823,4057),(36824,4058),(36825,4058),(36826,4058),(36827,4058),(36828,4059),(36829,4059),(36830,4059),(36831,4059),(36832,4060),(36833,4060),(36834,4060),(36835,4060),(36836,4061),(36837,4061),(36838,4061),(36839,4061),(36840,4062),(36841,4062),(36842,4062),(36843,4062),(36844,4063),(36845,4063),(36846,4063),(36847,4063),(36848,4064),(36849,4064),(36850,4064),(36851,4064),(36852,4065),(36853,4065),(36854,4065),(36855,4065),(36856,4066),(36857,4066),(36858,4066),(36859,4066),(36860,4067),(36861,4067),(36862,4067),(36863,4067),(36864,4068),(36865,4068),(36866,4068),(36867,4068),(36868,4069),(36869,4069),(36870,4069),(36871,4069),(36872,4070),(36873,4070),(36874,4070),(36875,4070),(36876,4071),(36877,4071),(36878,4071),(36879,4071),(36880,4072),(36881,4072),(36882,4072),(36883,4072),(36884,4073),(36885,4073),(36886,4073),(36887,4073),(36888,4074),(36889,4074),(36890,4074),(36891,4074),(36892,4075),(36893,4075),(36894,4075),(36895,4075),(36896,4076),(36897,4076),(36898,4076),(36899,4076),(36900,4077),(36901,4077),(36902,4077),(36903,4077),(36904,4078),(36905,4078),(36906,4078),(36907,4078),(36908,4079),(36909,4079),(36910,4079),(36911,4079),(36912,4080),(36913,4080),(36914,4080),(36915,4080),(36916,4081),(36917,4081),(36918,4081),(36919,4081),(36920,4082),(36921,4082),(36922,4082),(36923,4082),(36924,4083),(36925,4083),(36926,4083),(36927,4083),(36928,4084),(36929,4084),(36930,4084),(36931,4084),(36932,4085),(36933,4085),(36934,4085),(36935,4085),(36936,4086),(36937,4086),(36938,4086),(36939,4086),(36940,4087),(36941,4087),(36942,4087),(36943,4087),(36944,4088),(36945,4088),(36946,4088),(36947,4088),(36948,4089),(36949,4089),(36950,4089),(36951,4089),(36952,4090),(36953,4090),(36954,4090),(36955,4090),(36956,4091),(36957,4091),(36958,4091),(36959,4091),(36960,4092),(36961,4092),(36962,4092),(36963,4092),(36964,4093),(36965,4093),(36966,4093),(36967,4093),(36968,4094),(36969,4094),(36970,4094),(36971,4094),(36972,4095),(36973,4095),(36974,4095),(36975,4095),(36976,4096),(36977,4096),(36978,4096),(36979,4096),(36980,4097),(36981,4097),(36982,4097),(36983,4097),(36984,4098),(36985,4098),(36986,4098),(36987,4098),(36988,4099),(36989,4099),(36990,4099),(36991,4099),(36992,4100),(36993,4100),(36994,4100),(36995,4100),(36996,4101),(36997,4101),(36998,4101),(36999,4101),(37000,4102),(37001,4102),(37002,4102),(37003,4102),(37004,4103),(37005,4103),(37006,4103),(37007,4103),(37008,4104),(37009,4104),(37010,4104),(37011,4104),(37012,4105),(37013,4105),(37014,4105),(37015,4105),(37016,4106),(37017,4106),(37018,4106),(37019,4106),(37020,4107),(37021,4107),(37022,4107),(37023,4107),(37024,4108),(37025,4108),(37026,4108),(37027,4108),(37028,4109),(37029,4109),(37030,4109),(37031,4109),(37032,4110),(37033,4110),(37034,4110),(37035,4110),(37036,4111),(37037,4111),(37038,4111),(37039,4111),(37040,4112),(37041,4112),(37042,4112),(37043,4112),(37044,4113),(37045,4113),(37046,4113),(37047,4113),(37048,4114),(37049,4114),(37050,4114),(37051,4114),(37052,4115),(37053,4116),(37054,4117),(37055,4118),(37056,4119),(37057,4120),(37058,4121),(37059,4122),(37060,4123),(37061,4124),(37062,4125),(37063,4126),(37064,4127),(37065,4128),(37066,4129),(37067,4130),(37068,4131),(37069,4132),(37070,4133),(37071,4134),(37072,4135),(37073,4136),(37074,4137),(37075,4138),(37076,4139),(37077,4140),(37078,4141),(37079,4142),(37080,4143),(37081,4144),(37082,4145),(37083,4146),(37084,4147),(37085,4148),(37086,4149),(37087,4150),(37088,4151),(37089,4152),(37090,4153),(37091,4154),(37092,4155),(37093,4156),(37094,4157),(37095,4158),(37096,4159),(37097,4160),(37098,4161),(37099,4162),(37100,4163),(37101,4164),(37102,4165),(37103,4166),(37104,4167),(37105,4168),(37106,4169),(37107,4170),(37108,4171),(37109,4172),(37110,4173),(37111,4174),(37112,4175),(37113,4176),(37114,4177),(37115,4178),(37116,4179),(37117,4180),(37118,4181),(37119,4182),(37120,4183),(37121,4184),(37122,4185),(37123,4186),(37124,4187),(37125,4188),(37126,4189),(37127,4190),(37128,4191),(37129,4192),(37130,4193),(37131,4194),(37132,4195),(37133,4196),(37134,4197),(37135,4198),(37136,4199),(37137,4200),(37138,4201),(37139,4202),(37140,4203),(37141,4204),(37142,4205),(37143,4206),(37144,4207),(37145,4208),(37146,4209),(37147,4210),(37148,4211),(37149,4212),(37150,4213),(37151,4115),(37152,4116),(37153,4117),(37154,4118),(37155,4119),(37156,4120),(37157,4121),(37158,4122),(37159,4123),(37160,4124),(37161,4125),(37162,4126),(37163,4127),(37164,4128),(37165,4129),(37166,4130),(37167,4131),(37168,4132),(37169,4133),(37170,4134),(37171,4135),(37172,4136),(37173,4137),(37174,4138),(37175,4139),(37176,4140),(37177,4141),(37178,4142),(37179,4143),(37180,4144),(37181,4145),(37182,4146),(37183,4147),(37184,4148),(37185,4149),(37186,4150),(37187,4151),(37188,4152),(37189,4153),(37190,4154),(37191,4155),(37192,4156),(37193,4157),(37194,4158),(37195,4159),(37196,4160),(37197,4161),(37198,4162),(37199,4163),(37200,4164),(37201,4165),(37202,4166),(37203,4167),(37204,4168),(37205,4169),(37206,4170),(37207,4171),(37208,4172),(37209,4173),(37210,4174),(37211,4175),(37212,4176),(37213,4177),(37214,4178),(37215,4179),(37216,4180),(37217,4181),(37218,4182),(37219,4183),(37220,4184),(37221,4185),(37222,4186),(37223,4187),(37224,4188),(37225,4189),(37226,4190),(37227,4191),(37228,4192),(37229,4193),(37230,4194),(37231,4195),(37232,4196),(37233,4197),(37234,4198),(37235,4199),(37236,4200),(37237,4201),(37238,4202),(37239,4203),(37240,4204),(37241,4205),(37242,4206),(37243,4207),(37244,4208),(37245,4209),(37246,4210),(37247,4211),(37248,4212),(37249,4213),(37250,4115),(37251,4115),(37252,4115),(37253,4116),(37254,4116),(37255,4116),(37256,4117),(37257,4117),(37258,4117),(37259,4118),(37260,4118),(37261,4118),(37262,4119),(37263,4119),(37264,4119),(37265,4120),(37266,4120),(37267,4121),(37268,4121),(37269,4121),(37270,4122),(37271,4122),(37272,4122),(37273,4123),(37274,4123),(37275,4123),(37276,4124),(37277,4124),(37278,4124),(37279,4125),(37280,4125),(37281,4125),(37282,4126),(37283,4126),(37284,4126),(37285,4127),(37286,4127),(37287,4127),(37288,4128),(37289,4128),(37290,4128),(37291,4129),(37292,4129),(37293,4129),(37294,4130),(37295,4130),(37296,4130),(37297,4131),(37298,4131),(37299,4131),(37300,4132),(37301,4132),(37302,4132),(37303,4133),(37304,4133),(37305,4133),(37306,4134),(37307,4134),(37308,4134),(37309,4135),(37310,4135),(37311,4135),(37312,4136),(37313,4136),(37314,4136),(37315,4137),(37316,4137),(37317,4137),(37318,4138),(37319,4138),(37320,4138),(37321,4139),(37322,4139),(37323,4139),(37324,4140),(37325,4140),(37326,4140),(37327,4141),(37328,4141),(37329,4141),(37330,4142),(37331,4142),(37332,4143),(37333,4143),(37334,4144),(37335,4144),(37336,4144),(37337,4145),(37338,4145),(37339,4145),(37340,4146),(37341,4146),(37342,4146),(37343,4147),(37344,4147),(37345,4147),(37346,4148),(37347,4148),(37348,4148),(37349,4149),(37350,4149),(37351,4149),(37352,4150),(37353,4150),(37354,4151),(37355,4151),(37356,4152),(37357,4152),(37358,4152),(37359,4153),(37360,4153),(37361,4153),(37362,4154),(37363,4154),(37364,4154),(37365,4155),(37366,4155),(37367,4155),(37368,4156),(37369,4156),(37370,4156),(37371,4157),(37372,4157),(37373,4157),(37374,4158),(37375,4158),(37376,4158),(37377,4159),(37378,4159),(37379,4159),(37380,4160),(37381,4160),(37382,4160),(37383,4161),(37384,4161),(37385,4161),(37386,4162),(37387,4162),(37388,4163),(37389,4163),(37390,4163),(37391,4164),(37392,4164),(37393,4164),(37394,4165),(37395,4165),(37396,4165),(37397,4166),(37398,4166),(37399,4166),(37400,4167),(37401,4167),(37402,4167),(37403,4168),(37404,4168),(37405,4168),(37406,4169),(37407,4169),(37408,4169),(37409,4170),(37410,4170),(37411,4170),(37412,4171),(37413,4171),(37414,4171),(37415,4172),(37416,4172),(37417,4172),(37418,4173),(37419,4173),(37420,4173),(37421,4174),(37422,4174),(37423,4174),(37424,4175),(37425,4175),(37426,4175),(37427,4176),(37428,4176),(37429,4176),(37430,4177),(37431,4177),(37432,4177),(37433,4178),(37434,4178),(37435,4178),(37436,4179),(37437,4179),(37438,4179),(37439,4180),(37440,4180),(37441,4180),(37442,4181),(37443,4181),(37444,4181),(37445,4182),(37446,4182),(37447,4182),(37448,4183),(37449,4183),(37450,4183),(37451,4184),(37452,4184),(37453,4184),(37454,4185),(37455,4185),(37456,4185),(37457,4186),(37458,4186),(37459,4186),(37460,4187),(37461,4187),(37462,4187),(37463,4188),(37464,4188),(37465,4188),(37466,4189),(37467,4189),(37468,4189),(37469,4190),(37470,4190),(37471,4190),(37472,4191),(37473,4191),(37474,4191),(37475,4192),(37476,4192),(37477,4192),(37478,4193),(37479,4193),(37480,4193),(37481,4194),(37482,4194),(37483,4194),(37484,4195),(37485,4195),(37486,4195),(37487,4196),(37488,4196),(37489,4196),(37490,4197),(37491,4197),(37492,4197),(37493,4198),(37494,4198),(37495,4198),(37496,4199),(37497,4199),(37498,4200),(37499,4200),(37500,4201),(37501,4201),(37502,4202),(37503,4202),(37504,4202),(37505,4203),(37506,4203),(37507,4203),(37508,4204),(37509,4204),(37510,4204),(37511,4205),(37512,4205),(37513,4205),(37514,4206),(37515,4206),(37516,4206),(37517,4207),(37518,4207),(37519,4207),(37520,4208),(37521,4208),(37522,4208),(37523,4209),(37524,4209),(37525,4209),(37526,4210),(37527,4210),(37528,4210),(37529,4211),(37530,4211),(37531,4211),(37532,4212),(37533,4212),(37534,4212),(37535,4213),(37536,4213),(37537,4213),(37538,4115),(37539,4115),(37540,4115),(37541,4115),(37542,4116),(37543,4116),(37544,4116),(37545,4116),(37546,4117),(37547,4117),(37548,4117),(37549,4117),(37550,4118),(37551,4118),(37552,4118),(37553,4118),(37554,4119),(37555,4119),(37556,4119),(37557,4119),(37558,4120),(37559,4120),(37560,4120),(37561,4120),(37562,4121),(37563,4121),(37564,4121),(37565,4121),(37566,4122),(37567,4122),(37568,4122),(37569,4122),(37570,4123),(37571,4123),(37572,4123),(37573,4123),(37574,4124),(37575,4124),(37576,4124),(37577,4124),(37578,4125),(37579,4125),(37580,4125),(37581,4125),(37582,4126),(37583,4126),(37584,4126),(37585,4126),(37586,4127),(37587,4127),(37588,4127),(37589,4127),(37590,4128),(37591,4128),(37592,4128),(37593,4128),(37594,4129),(37595,4129),(37596,4129),(37597,4129),(37598,4130),(37599,4130),(37600,4130),(37601,4130),(37602,4131),(37603,4131),(37604,4131),(37605,4131),(37606,4132),(37607,4132),(37608,4132),(37609,4132),(37610,4133),(37611,4133),(37612,4133),(37613,4133),(37614,4134),(37615,4134),(37616,4134),(37617,4134),(37618,4135),(37619,4135),(37620,4135),(37621,4135),(37622,4136),(37623,4136),(37624,4136),(37625,4136),(37626,4137),(37627,4137),(37628,4137),(37629,4137),(37630,4138),(37631,4138),(37632,4138),(37633,4138),(37634,4139),(37635,4139),(37636,4139),(37637,4139),(37638,4140),(37639,4140),(37640,4140),(37641,4140),(37642,4141),(37643,4141),(37644,4141),(37645,4141),(37646,4142),(37647,4142),(37648,4142),(37649,4142),(37650,4143),(37651,4143),(37652,4143),(37653,4143),(37654,4144),(37655,4144),(37656,4144),(37657,4144),(37658,4145),(37659,4145),(37660,4145),(37661,4145),(37662,4146),(37663,4146),(37664,4146),(37665,4146),(37666,4147),(37667,4147),(37668,4147),(37669,4147),(37670,4148),(37671,4148),(37672,4148),(37673,4148),(37674,4149),(37675,4149),(37676,4149),(37677,4149),(37678,4150),(37679,4150),(37680,4150),(37681,4150),(37682,4151),(37683,4151),(37684,4151),(37685,4151),(37686,4152),(37687,4152),(37688,4152),(37689,4152),(37690,4153),(37691,4153),(37692,4153),(37693,4153),(37694,4154),(37695,4154),(37696,4154),(37697,4154),(37698,4155),(37699,4155),(37700,4155),(37701,4155),(37702,4156),(37703,4156),(37704,4156),(37705,4156),(37706,4157),(37707,4157),(37708,4157),(37709,4157),(37710,4158),(37711,4158),(37712,4158),(37713,4158),(37714,4159),(37715,4159),(37716,4159),(37717,4159),(37718,4160),(37719,4160),(37720,4160),(37721,4160),(37722,4161),(37723,4161),(37724,4161),(37725,4161),(37726,4162),(37727,4162),(37728,4162),(37729,4162),(37730,4163),(37731,4163),(37732,4163),(37733,4163),(37734,4164),(37735,4164),(37736,4164),(37737,4164),(37738,4165),(37739,4165),(37740,4165),(37741,4165),(37742,4166),(37743,4166),(37744,4166),(37745,4166),(37746,4167),(37747,4167),(37748,4167),(37749,4167),(37750,4168),(37751,4168),(37752,4168),(37753,4168),(37754,4169),(37755,4169),(37756,4169),(37757,4169),(37758,4170),(37759,4170),(37760,4170),(37761,4170),(37762,4171),(37763,4171),(37764,4171),(37765,4171),(37766,4172),(37767,4172),(37768,4172),(37769,4172),(37770,4173),(37771,4173),(37772,4173),(37773,4173),(37774,4174),(37775,4174),(37776,4174),(37777,4174),(37778,4175),(37779,4175),(37780,4175),(37781,4175),(37782,4176),(37783,4176),(37784,4176),(37785,4176),(37786,4177),(37787,4177),(37788,4177),(37789,4177),(37790,4178),(37791,4178),(37792,4178),(37793,4178),(37794,4179),(37795,4179),(37796,4179),(37797,4179),(37798,4180),(37799,4180),(37800,4180),(37801,4180),(37802,4181),(37803,4181),(37804,4181),(37805,4181),(37806,4182),(37807,4182),(37808,4182),(37809,4182),(37810,4183),(37811,4183),(37812,4183),(37813,4183),(37814,4184),(37815,4184),(37816,4184),(37817,4184),(37818,4185),(37819,4185),(37820,4185),(37821,4185),(37822,4186),(37823,4186),(37824,4186),(37825,4186),(37826,4187),(37827,4187),(37828,4187),(37829,4187),(37830,4188),(37831,4188),(37832,4188),(37833,4188),(37834,4189),(37835,4189),(37836,4189),(37837,4189),(37838,4190),(37839,4190),(37840,4190),(37841,4190),(37842,4191),(37843,4191),(37844,4191),(37845,4191),(37846,4192),(37847,4192),(37848,4192),(37849,4192),(37850,4193),(37851,4193),(37852,4193),(37853,4193),(37854,4194),(37855,4194),(37856,4194),(37857,4194),(37858,4195),(37859,4195),(37860,4195),(37861,4195),(37862,4196),(37863,4196),(37864,4196),(37865,4196),(37866,4197),(37867,4197),(37868,4197),(37869,4197),(37870,4198),(37871,4198),(37872,4198),(37873,4198),(37874,4199),(37875,4199),(37876,4199),(37877,4199),(37878,4200),(37879,4200),(37880,4200),(37881,4200),(37882,4201),(37883,4201),(37884,4201),(37885,4201),(37886,4202),(37887,4202),(37888,4202),(37889,4202),(37890,4203),(37891,4203),(37892,4203),(37893,4203),(37894,4204),(37895,4204),(37896,4204),(37897,4204),(37898,4205),(37899,4205),(37900,4205),(37901,4205),(37902,4206),(37903,4206),(37904,4206),(37905,4206),(37906,4207),(37907,4207),(37908,4207),(37909,4207),(37910,4208),(37911,4208),(37912,4208),(37913,4208),(37914,4209),(37915,4209),(37916,4209),(37917,4209),(37918,4210),(37919,4210),(37920,4210),(37921,4210),(37922,4211),(37923,4211),(37924,4211),(37925,4211),(37926,4212),(37927,4212),(37928,4212),(37929,4212),(37930,4213),(37931,4213),(37932,4213),(37933,4213),(37934,4214),(37935,4215),(37936,4216),(37937,4217),(37938,4218),(37939,4219),(37940,4220),(37941,4221),(37942,4222),(37943,4223),(37944,4224),(37945,4225),(37946,4226),(37947,4227),(37948,4228),(37949,4229),(37950,4230),(37951,4231),(37952,4232),(37953,4233),(37954,4234),(37955,4235),(37956,4236),(37957,4237),(37958,4238),(37959,4239),(37960,4240),(37961,4241),(37962,4242),(37963,4243),(37964,4244),(37965,4245),(37966,4246),(37967,4247),(37968,4248),(37969,4249),(37970,4250),(37971,4251),(37972,4252),(37973,4253),(37974,4254),(37975,4255),(37976,4256),(37977,4257),(37978,4258),(37979,4259),(37980,4260),(37981,4261),(37982,4262),(37983,4263),(37984,4264),(37985,4265),(37986,4266),(37987,4267),(37988,4268),(37989,4269),(37990,4270),(37991,4271),(37992,4272),(37993,4273),(37994,4274),(37995,4275),(37996,4276),(37997,4277),(37998,4278),(37999,4279),(38000,4280),(38001,4281),(38002,4282),(38003,4283),(38004,4284),(38005,4285),(38006,4286),(38007,4287),(38008,4288),(38009,4289),(38010,4290),(38011,4291),(38012,4292),(38013,4293),(38014,4294),(38015,4295),(38016,4296),(38017,4297),(38018,4298),(38019,4299),(38020,4300),(38021,4301),(38022,4302),(38023,4303),(38024,4304),(38025,4305),(38026,4306),(38027,4307),(38028,4308),(38029,4309),(38030,4310),(38031,4311),(38032,4312),(38033,4313),(38034,4214),(38035,4215),(38036,4216),(38037,4217),(38038,4218),(38039,4219),(38040,4220),(38041,4221),(38042,4222),(38043,4223),(38044,4224),(38045,4225),(38046,4226),(38047,4227),(38048,4228),(38049,4229),(38050,4230),(38051,4231),(38052,4232),(38053,4233),(38054,4234),(38055,4235),(38056,4236),(38057,4237),(38058,4238),(38059,4239),(38060,4240),(38061,4241),(38062,4242),(38063,4243),(38064,4244),(38065,4245),(38066,4246),(38067,4247),(38068,4248),(38069,4249),(38070,4250),(38071,4251),(38072,4252),(38073,4253),(38074,4254),(38075,4255),(38076,4256),(38077,4257),(38078,4258),(38079,4259),(38080,4260),(38081,4261),(38082,4262),(38083,4263),(38084,4264),(38085,4265),(38086,4266),(38087,4267),(38088,4268),(38089,4269),(38090,4270),(38091,4271),(38092,4272),(38093,4273),(38094,4274),(38095,4275),(38096,4276),(38097,4277),(38098,4278),(38099,4279),(38100,4280),(38101,4281),(38102,4282),(38103,4283),(38104,4284),(38105,4285),(38106,4286),(38107,4287),(38108,4288),(38109,4289),(38110,4290),(38111,4291),(38112,4292),(38113,4293),(38114,4294),(38115,4295),(38116,4296),(38117,4297),(38118,4298),(38119,4299),(38120,4300),(38121,4301),(38122,4302),(38123,4303),(38124,4304),(38125,4305),(38126,4306),(38127,4307),(38128,4308),(38129,4309),(38130,4310),(38131,4311),(38132,4312),(38133,4313),(38134,4214),(38135,4214),(38136,4215),(38137,4215),(38138,4215),(38139,4216),(38140,4216),(38141,4216),(38142,4217),(38143,4217),(38144,4217),(38145,4218),(38146,4218),(38147,4218),(38148,4219),(38149,4219),(38150,4219),(38151,4220),(38152,4220),(38153,4220),(38154,4221),(38155,4221),(38156,4221),(38157,4222),(38158,4222),(38159,4222),(38160,4223),(38161,4223),(38162,4223),(38163,4224),(38164,4224),(38165,4224),(38166,4225),(38167,4225),(38168,4225),(38169,4226),(38170,4226),(38171,4226),(38172,4227),(38173,4227),(38174,4227),(38175,4228),(38176,4228),(38177,4228),(38178,4229),(38179,4229),(38180,4229),(38181,4230),(38182,4230),(38183,4230),(38184,4231),(38185,4231),(38186,4231),(38187,4232),(38188,4232),(38189,4232),(38190,4233),(38191,4233),(38192,4233),(38193,4234),(38194,4234),(38195,4234),(38196,4235),(38197,4235),(38198,4235),(38199,4236),(38200,4236),(38201,4236),(38202,4237),(38203,4237),(38204,4237),(38205,4238),(38206,4238),(38207,4238),(38208,4239),(38209,4239),(38210,4239),(38211,4240),(38212,4240),(38213,4240),(38214,4241),(38215,4241),(38216,4241),(38217,4242),(38218,4242),(38219,4242),(38220,4243),(38221,4243),(38222,4243),(38223,4244),(38224,4244),(38225,4244),(38226,4245),(38227,4245),(38228,4245),(38229,4246),(38230,4246),(38231,4246),(38232,4247),(38233,4247),(38234,4247),(38235,4248),(38236,4248),(38237,4248),(38238,4249),(38239,4249),(38240,4249),(38241,4250),(38242,4250),(38243,4250),(38244,4251),(38245,4251),(38246,4251),(38247,4252),(38248,4252),(38249,4252),(38250,4253),(38251,4253),(38252,4253),(38253,4254),(38254,4254),(38255,4254),(38256,4255),(38257,4255),(38258,4255),(38259,4256),(38260,4256),(38261,4256),(38262,4257),(38263,4257),(38264,4257),(38265,4258),(38266,4258),(38267,4258),(38268,4259),(38269,4259),(38270,4259),(38271,4260),(38272,4260),(38273,4260),(38274,4261),(38275,4261),(38276,4261),(38277,4262),(38278,4262),(38279,4262),(38280,4263),(38281,4263),(38282,4263),(38283,4264),(38284,4264),(38285,4264),(38286,4265),(38287,4265),(38288,4265),(38289,4266),(38290,4266),(38291,4266),(38292,4267),(38293,4267),(38294,4267),(38295,4268),(38296,4268),(38297,4268),(38298,4269),(38299,4269),(38300,4269),(38301,4270),(38302,4270),(38303,4270),(38304,4271),(38305,4271),(38306,4272),(38307,4272),(38308,4273),(38309,4273),(38310,4274),(38311,4274),(38312,4274),(38313,4275),(38314,4275),(38315,4275),(38316,4276),(38317,4276),(38318,4276),(38319,4277),(38320,4277),(38321,4277),(38322,4278),(38323,4278),(38324,4278),(38325,4279),(38326,4279),(38327,4279),(38328,4280),(38329,4280),(38330,4280),(38331,4281),(38332,4281),(38333,4281),(38334,4282),(38335,4282),(38336,4282),(38337,4283),(38338,4283),(38339,4283),(38340,4284),(38341,4284),(38342,4284),(38343,4285),(38344,4285),(38345,4285),(38346,4286),(38347,4286),(38348,4286),(38349,4287),(38350,4287),(38351,4287),(38352,4288),(38353,4288),(38354,4288),(38355,4289),(38356,4289),(38357,4289),(38358,4290),(38359,4290),(38360,4290),(38361,4291),(38362,4291),(38363,4291),(38364,4292),(38365,4292),(38366,4292),(38367,4293),(38368,4293),(38369,4293),(38370,4294),(38371,4294),(38372,4294),(38373,4295),(38374,4295),(38375,4295),(38376,4296),(38377,4296),(38378,4296),(38379,4297),(38380,4297),(38381,4297),(38382,4298),(38383,4298),(38384,4298),(38385,4299),(38386,4299),(38387,4299),(38388,4300),(38389,4300),(38390,4300),(38391,4301),(38392,4301),(38393,4301),(38394,4302),(38395,4302),(38396,4302),(38397,4303),(38398,4303),(38399,4303),(38400,4304),(38401,4304),(38402,4304),(38403,4305),(38404,4305),(38405,4305),(38406,4306),(38407,4306),(38408,4307),(38409,4307),(38410,4307),(38411,4308),(38412,4308),(38413,4308),(38414,4309),(38415,4309),(38416,4309),(38417,4310),(38418,4310),(38419,4310),(38420,4311),(38421,4311),(38422,4311),(38423,4312),(38424,4312),(38425,4312),(38426,4313),(38427,4313),(38428,4214),(38429,4214),(38430,4214),(38431,4214),(38432,4215),(38433,4215),(38434,4215),(38435,4215),(38436,4216),(38437,4216),(38438,4216),(38439,4216),(38440,4217),(38441,4217),(38442,4217),(38443,4217),(38444,4218),(38445,4218),(38446,4218),(38447,4218),(38448,4219),(38449,4219),(38450,4219),(38451,4219),(38452,4220),(38453,4220),(38454,4220),(38455,4220),(38456,4221),(38457,4221),(38458,4221),(38459,4221),(38460,4222),(38461,4222),(38462,4222),(38463,4222),(38464,4223),(38465,4223),(38466,4223),(38467,4223),(38468,4224),(38469,4224),(38470,4224),(38471,4224),(38472,4225),(38473,4225),(38474,4225),(38475,4225),(38476,4226),(38477,4226),(38478,4226),(38479,4226),(38480,4227),(38481,4227),(38482,4227),(38483,4227),(38484,4228),(38485,4228),(38486,4228),(38487,4228),(38488,4229),(38489,4229),(38490,4229),(38491,4229),(38492,4230),(38493,4230),(38494,4230),(38495,4230),(38496,4231),(38497,4231),(38498,4231),(38499,4231),(38500,4232),(38501,4232),(38502,4232),(38503,4232),(38504,4233),(38505,4233),(38506,4233),(38507,4233),(38508,4234),(38509,4234),(38510,4234),(38511,4234),(38512,4235),(38513,4235),(38514,4235),(38515,4235),(38516,4236),(38517,4236),(38518,4236),(38519,4236),(38520,4237),(38521,4237),(38522,4237),(38523,4237),(38524,4238),(38525,4238),(38526,4238),(38527,4238),(38528,4239),(38529,4239),(38530,4239),(38531,4239),(38532,4240),(38533,4240),(38534,4240),(38535,4240),(38536,4241),(38537,4241),(38538,4241),(38539,4241),(38540,4242),(38541,4242),(38542,4242),(38543,4242),(38544,4243),(38545,4243),(38546,4243),(38547,4243),(38548,4244),(38549,4244),(38550,4244),(38551,4244),(38552,4245),(38553,4245),(38554,4245),(38555,4245),(38556,4246),(38557,4246),(38558,4246),(38559,4246),(38560,4247),(38561,4247),(38562,4247),(38563,4247),(38564,4248),(38565,4248),(38566,4248),(38567,4248),(38568,4249),(38569,4249),(38570,4249),(38571,4249),(38572,4250),(38573,4250),(38574,4250),(38575,4250),(38576,4251),(38577,4251),(38578,4251),(38579,4251),(38580,4252),(38581,4252),(38582,4252),(38583,4252),(38584,4253),(38585,4253),(38586,4253),(38587,4253),(38588,4254),(38589,4254),(38590,4254),(38591,4254),(38592,4255),(38593,4255),(38594,4255),(38595,4255),(38596,4256),(38597,4256),(38598,4256),(38599,4256),(38600,4257),(38601,4257),(38602,4257),(38603,4257),(38604,4258),(38605,4258),(38606,4258),(38607,4258),(38608,4259),(38609,4259),(38610,4259),(38611,4259),(38612,4260),(38613,4260),(38614,4260),(38615,4260),(38616,4261),(38617,4261),(38618,4261),(38619,4261),(38620,4262),(38621,4262),(38622,4262),(38623,4262),(38624,4263),(38625,4263),(38626,4263),(38627,4263),(38628,4264),(38629,4264),(38630,4264),(38631,4264),(38632,4265),(38633,4265),(38634,4265),(38635,4265),(38636,4266),(38637,4266),(38638,4266),(38639,4266),(38640,4267),(38641,4267),(38642,4267),(38643,4267),(38644,4268),(38645,4268),(38646,4268),(38647,4268),(38648,4269),(38649,4269),(38650,4269),(38651,4269),(38652,4270),(38653,4270),(38654,4270),(38655,4270),(38656,4271),(38657,4271),(38658,4271),(38659,4271),(38660,4272),(38661,4272),(38662,4272),(38663,4272),(38664,4273),(38665,4273),(38666,4273),(38667,4273),(38668,4274),(38669,4274),(38670,4274),(38671,4274),(38672,4275),(38673,4275),(38674,4275),(38675,4275),(38676,4276),(38677,4276),(38678,4276),(38679,4276),(38680,4277),(38681,4277),(38682,4277),(38683,4277),(38684,4278),(38685,4278),(38686,4278),(38687,4278),(38688,4279),(38689,4279),(38690,4279),(38691,4279),(38692,4280),(38693,4280),(38694,4280),(38695,4280),(38696,4281),(38697,4281),(38698,4281),(38699,4281),(38700,4282),(38701,4282),(38702,4282),(38703,4282),(38704,4283),(38705,4283),(38706,4283),(38707,4283),(38708,4284),(38709,4284),(38710,4284),(38711,4284),(38712,4285),(38713,4285),(38714,4285),(38715,4285),(38716,4286),(38717,4286),(38718,4286),(38719,4286),(38720,4287),(38721,4287),(38722,4287),(38723,4287),(38724,4288),(38725,4288),(38726,4288),(38727,4288),(38728,4289),(38729,4289),(38730,4289),(38731,4289),(38732,4290),(38733,4290),(38734,4290),(38735,4290),(38736,4291),(38737,4291),(38738,4291),(38739,4291),(38740,4292),(38741,4292),(38742,4292),(38743,4292),(38744,4293),(38745,4293),(38746,4293),(38747,4293),(38748,4294),(38749,4294),(38750,4294),(38751,4294),(38752,4295),(38753,4295),(38754,4295),(38755,4295),(38756,4296),(38757,4296),(38758,4296),(38759,4296),(38760,4297),(38761,4297),(38762,4297),(38763,4297),(38764,4298),(38765,4298),(38766,4298),(38767,4298),(38768,4299),(38769,4299),(38770,4299),(38771,4299),(38772,4300),(38773,4300),(38774,4300),(38775,4300),(38776,4301),(38777,4301),(38778,4301),(38779,4301),(38780,4302),(38781,4302),(38782,4302),(38783,4302),(38784,4303),(38785,4303),(38786,4303),(38787,4303),(38788,4304),(38789,4304),(38790,4304),(38791,4304),(38792,4305),(38793,4305),(38794,4305),(38795,4305),(38796,4306),(38797,4306),(38798,4306),(38799,4306),(38800,4307),(38801,4307),(38802,4307),(38803,4307),(38804,4308),(38805,4308),(38806,4308),(38807,4308),(38808,4309),(38809,4309),(38810,4309),(38811,4309),(38812,4310),(38813,4310),(38814,4310),(38815,4310),(38816,4311),(38817,4311),(38818,4311),(38819,4311),(38820,4312),(38821,4312),(38822,4312),(38823,4312),(38824,4313),(38825,4313),(38826,4313),(38827,4313),(38828,4314),(38829,4315),(38830,4316),(38831,4317),(38832,4318),(38833,4319),(38834,4320),(38835,4321),(38836,4322),(38837,4323),(38838,4324),(38839,4325),(38840,4326),(38841,4327),(38842,4328),(38843,4329),(38844,4330),(38845,4331),(38846,4332),(38847,4333),(38848,4334),(38849,4335),(38850,4336),(38851,4337),(38852,4338),(38853,4339),(38854,4340),(38855,4341),(38856,4342),(38857,4343),(38858,4344),(38859,4345),(38860,4346),(38861,4347),(38862,4348),(38863,4349),(38864,4350),(38865,4351),(38866,4352),(38867,4353),(38868,4354),(38869,4355),(38870,4356),(38871,4357),(38872,4358),(38873,4359),(38874,4360),(38875,4361),(38876,4362),(38877,4363),(38878,4364),(38879,4365),(38880,4366),(38881,4367),(38882,4368),(38883,4369),(38884,4370),(38885,4371),(38886,4372),(38887,4373),(38888,4374),(38889,4375),(38890,4376),(38891,4377),(38892,4378),(38893,4379),(38894,4380),(38895,4381),(38896,4382),(38897,4383),(38898,4384),(38899,4385),(38900,4386),(38901,4387),(38902,4388),(38903,4389),(38904,4390),(38905,4391),(38906,4392),(38907,4393),(38908,4394),(38909,4395),(38910,4396),(38911,4397),(38912,4398),(38913,4399),(38914,4400),(38915,4401),(38916,4402),(38917,4403),(38918,4404),(38919,4405),(38920,4406),(38921,4407),(38922,4408),(38923,4409),(38924,4410),(38925,4411),(38926,4412),(38927,4413),(38928,4314),(38929,4315),(38930,4316),(38931,4317),(38932,4318),(38933,4319),(38934,4320),(38935,4321),(38936,4322),(38937,4323),(38938,4324),(38939,4325),(38940,4326),(38941,4327),(38942,4328),(38943,4329),(38944,4330),(38945,4331),(38946,4332),(38947,4333),(38948,4334),(38949,4335),(38950,4336),(38951,4337),(38952,4338),(38953,4339),(38954,4340),(38955,4341),(38956,4342),(38957,4343),(38958,4344),(38959,4345),(38960,4346),(38961,4347),(38962,4348),(38963,4349),(38964,4350),(38965,4351),(38966,4352),(38967,4353),(38968,4354),(38969,4355),(38970,4356),(38971,4357),(38972,4358),(38973,4359),(38974,4360),(38975,4361),(38976,4362),(38977,4363),(38978,4364),(38979,4365),(38980,4366),(38981,4367),(38982,4368),(38983,4369),(38984,4370),(38985,4371),(38986,4372),(38987,4373),(38988,4374),(38989,4375),(38990,4376),(38991,4377),(38992,4378),(38993,4379),(38994,4380),(38995,4381),(38996,4382),(38997,4383),(38998,4384),(38999,4385),(39000,4386),(39001,4387),(39002,4388),(39003,4389),(39004,4390),(39005,4391),(39006,4392),(39007,4393),(39008,4394),(39009,4395),(39010,4396),(39011,4397),(39012,4398),(39013,4399),(39014,4400),(39015,4401),(39016,4402),(39017,4403),(39018,4404),(39019,4405),(39020,4406),(39021,4407),(39022,4408),(39023,4409),(39024,4410),(39025,4411),(39026,4412),(39027,4413),(39028,4314),(39029,4314),(39030,4315),(39031,4315),(39032,4315),(39033,4316),(39034,4316),(39035,4316),(39036,4317),(39037,4317),(39038,4317),(39039,4318),(39040,4318),(39041,4318),(39042,4319),(39043,4319),(39044,4319),(39045,4320),(39046,4320),(39047,4320),(39048,4321),(39049,4321),(39050,4321),(39051,4322),(39052,4322),(39053,4322),(39054,4323),(39055,4323),(39056,4323),(39057,4324),(39058,4324),(39059,4324),(39060,4325),(39061,4325),(39062,4325),(39063,4326),(39064,4326),(39065,4326),(39066,4327),(39067,4327),(39068,4327),(39069,4328),(39070,4328),(39071,4328),(39072,4329),(39073,4329),(39074,4329),(39075,4330),(39076,4330),(39077,4330),(39078,4331),(39079,4331),(39080,4331),(39081,4332),(39082,4332),(39083,4332),(39084,4333),(39085,4333),(39086,4333),(39087,4334),(39088,4334),(39089,4334),(39090,4335),(39091,4335),(39092,4335),(39093,4336),(39094,4336),(39095,4336),(39096,4337),(39097,4337),(39098,4337),(39099,4338),(39100,4338),(39101,4338),(39102,4339),(39103,4339),(39104,4339),(39105,4340),(39106,4340),(39107,4340),(39108,4341),(39109,4341),(39110,4342),(39111,4342),(39112,4342),(39113,4343),(39114,4343),(39115,4343),(39116,4344),(39117,4344),(39118,4344),(39119,4345),(39120,4345),(39121,4345),(39122,4346),(39123,4346),(39124,4346),(39125,4347),(39126,4347),(39127,4347),(39128,4348),(39129,4348),(39130,4348),(39131,4349),(39132,4349),(39133,4349),(39134,4350),(39135,4350),(39136,4350),(39137,4351),(39138,4351),(39139,4351),(39140,4352),(39141,4352),(39142,4352),(39143,4353),(39144,4353),(39145,4353),(39146,4354),(39147,4354),(39148,4354),(39149,4355),(39150,4355),(39151,4355),(39152,4356),(39153,4356),(39154,4356),(39155,4357),(39156,4357),(39157,4357),(39158,4358),(39159,4358),(39160,4359),(39161,4359),(39162,4359),(39163,4360),(39164,4360),(39165,4360),(39166,4361),(39167,4361),(39168,4361),(39169,4362),(39170,4362),(39171,4362),(39172,4363),(39173,4363),(39174,4363),(39175,4364),(39176,4364),(39177,4364),(39178,4365),(39179,4365),(39180,4365),(39181,4366),(39182,4366),(39183,4366),(39184,4367),(39185,4367),(39186,4367),(39187,4368),(39188,4368),(39189,4368),(39190,4369),(39191,4369),(39192,4369),(39193,4370),(39194,4370),(39195,4370),(39196,4371),(39197,4371),(39198,4371),(39199,4372),(39200,4372),(39201,4372),(39202,4373),(39203,4373),(39204,4373),(39205,4374),(39206,4374),(39207,4374),(39208,4375),(39209,4375),(39210,4375),(39211,4376),(39212,4376),(39213,4376),(39214,4377),(39215,4377),(39216,4377),(39217,4378),(39218,4378),(39219,4378),(39220,4379),(39221,4379),(39222,4379),(39223,4380),(39224,4380),(39225,4380),(39226,4381),(39227,4381),(39228,4381),(39229,4382),(39230,4382),(39231,4382),(39232,4383),(39233,4383),(39234,4383),(39235,4384),(39236,4384),(39237,4384),(39238,4385),(39239,4385),(39240,4385),(39241,4386),(39242,4386),(39243,4386),(39244,4387),(39245,4387),(39246,4387),(39247,4388),(39248,4388),(39249,4388),(39250,4389),(39251,4389),(39252,4389),(39253,4390),(39254,4390),(39255,4390),(39256,4391),(39257,4391),(39258,4391),(39259,4392),(39260,4392),(39261,4392),(39262,4393),(39263,4393),(39264,4393),(39265,4394),(39266,4394),(39267,4394),(39268,4395),(39269,4395),(39270,4395),(39271,4396),(39272,4396),(39273,4396),(39274,4397),(39275,4397),(39276,4397),(39277,4398),(39278,4398),(39279,4398),(39280,4399),(39281,4399),(39282,4399),(39283,4400),(39284,4400),(39285,4400),(39286,4401),(39287,4401),(39288,4401),(39289,4402),(39290,4402),(39291,4402),(39292,4403),(39293,4403),(39294,4403),(39295,4404),(39296,4404),(39297,4404),(39298,4405),(39299,4405),(39300,4405),(39301,4406),(39302,4406),(39303,4406),(39304,4407),(39305,4407),(39306,4407),(39307,4408),(39308,4408),(39309,4408),(39310,4409),(39311,4409),(39312,4409),(39313,4410),(39314,4410),(39315,4410),(39316,4411),(39317,4411),(39318,4411),(39319,4412),(39320,4412),(39321,4412),(39322,4413),(39323,4413),(39324,4413),(39325,4314),(39326,4314),(39327,4314),(39328,4314),(39329,4315),(39330,4315),(39331,4315),(39332,4315),(39333,4316),(39334,4316),(39335,4316),(39336,4316),(39337,4317),(39338,4317),(39339,4317),(39340,4317),(39341,4318),(39342,4318),(39343,4318),(39344,4318),(39345,4319),(39346,4319),(39347,4319),(39348,4319),(39349,4320),(39350,4320),(39351,4320),(39352,4320),(39353,4321),(39354,4321),(39355,4321),(39356,4321),(39357,4322),(39358,4322),(39359,4322),(39360,4322),(39361,4323),(39362,4323),(39363,4323),(39364,4323),(39365,4324),(39366,4324),(39367,4324),(39368,4324),(39369,4325),(39370,4325),(39371,4325),(39372,4325),(39373,4326),(39374,4326),(39375,4326),(39376,4326),(39377,4327),(39378,4327),(39379,4327),(39380,4327),(39381,4328),(39382,4328),(39383,4328),(39384,4328),(39385,4329),(39386,4329),(39387,4329),(39388,4329),(39389,4330),(39390,4330),(39391,4330),(39392,4330),(39393,4331),(39394,4331),(39395,4331),(39396,4331),(39397,4332),(39398,4332),(39399,4332),(39400,4332),(39401,4333),(39402,4333),(39403,4333),(39404,4333),(39405,4334),(39406,4334),(39407,4334),(39408,4334),(39409,4335),(39410,4335),(39411,4335),(39412,4335),(39413,4336),(39414,4336),(39415,4336),(39416,4336),(39417,4337),(39418,4337),(39419,4337),(39420,4337),(39421,4338),(39422,4338),(39423,4338),(39424,4338),(39425,4339),(39426,4339),(39427,4339),(39428,4339),(39429,4340),(39430,4340),(39431,4340),(39432,4340),(39433,4341),(39434,4341),(39435,4341),(39436,4341),(39437,4342),(39438,4342),(39439,4342),(39440,4342),(39441,4343),(39442,4343),(39443,4343),(39444,4343),(39445,4344),(39446,4344),(39447,4344),(39448,4344),(39449,4345),(39450,4345),(39451,4345),(39452,4345),(39453,4346),(39454,4346),(39455,4346),(39456,4346),(39457,4347),(39458,4347),(39459,4347),(39460,4347),(39461,4348),(39462,4348),(39463,4348),(39464,4348),(39465,4349),(39466,4349),(39467,4349),(39468,4349),(39469,4350),(39470,4350),(39471,4350),(39472,4350),(39473,4351),(39474,4351),(39475,4351),(39476,4351),(39477,4352),(39478,4352),(39479,4352),(39480,4352),(39481,4353),(39482,4353),(39483,4353),(39484,4353),(39485,4354),(39486,4354),(39487,4354),(39488,4354),(39489,4355),(39490,4355),(39491,4355),(39492,4355),(39493,4356),(39494,4356),(39495,4356),(39496,4356),(39497,4357),(39498,4357),(39499,4357),(39500,4357),(39501,4358),(39502,4358),(39503,4358),(39504,4358),(39505,4359),(39506,4359),(39507,4359),(39508,4359),(39509,4360),(39510,4360),(39511,4360),(39512,4360),(39513,4361),(39514,4361),(39515,4361),(39516,4361),(39517,4362),(39518,4362),(39519,4362),(39520,4362),(39521,4363),(39522,4363),(39523,4363),(39524,4363),(39525,4364),(39526,4364),(39527,4364),(39528,4364),(39529,4365),(39530,4365),(39531,4365),(39532,4365),(39533,4366),(39534,4366),(39535,4366),(39536,4366),(39537,4367),(39538,4367),(39539,4367),(39540,4367),(39541,4368),(39542,4368),(39543,4368),(39544,4368),(39545,4369),(39546,4369),(39547,4369),(39548,4369),(39549,4370),(39550,4370),(39551,4370),(39552,4370),(39553,4371),(39554,4371),(39555,4371),(39556,4371),(39557,4372),(39558,4372),(39559,4372),(39560,4372),(39561,4373),(39562,4373),(39563,4373),(39564,4373),(39565,4374),(39566,4374),(39567,4374),(39568,4374),(39569,4375),(39570,4375),(39571,4375),(39572,4375),(39573,4376),(39574,4376),(39575,4376),(39576,4376),(39577,4377),(39578,4377),(39579,4377),(39580,4377),(39581,4378),(39582,4378),(39583,4378),(39584,4378),(39585,4379),(39586,4379),(39587,4379),(39588,4379),(39589,4380),(39590,4380),(39591,4380),(39592,4380),(39593,4381),(39594,4381),(39595,4381),(39596,4381),(39597,4382),(39598,4382),(39599,4382),(39600,4382),(39601,4383),(39602,4383),(39603,4383),(39604,4383),(39605,4384),(39606,4384),(39607,4384),(39608,4384),(39609,4385),(39610,4385),(39611,4385),(39612,4385),(39613,4386),(39614,4386),(39615,4386),(39616,4386),(39617,4387),(39618,4387),(39619,4387),(39620,4387),(39621,4388),(39622,4388),(39623,4388),(39624,4388),(39625,4389),(39626,4389),(39627,4389),(39628,4389),(39629,4390),(39630,4390),(39631,4390),(39632,4390),(39633,4391),(39634,4391),(39635,4391),(39636,4391),(39637,4392),(39638,4392),(39639,4392),(39640,4392),(39641,4393),(39642,4393),(39643,4393),(39644,4393),(39645,4394),(39646,4394),(39647,4394),(39648,4394),(39649,4395),(39650,4395),(39651,4395),(39652,4395),(39653,4396),(39654,4396),(39655,4396),(39656,4396),(39657,4397),(39658,4397),(39659,4397),(39660,4397),(39661,4398),(39662,4398),(39663,4398),(39664,4398),(39665,4399),(39666,4399),(39667,4399),(39668,4399),(39669,4400),(39670,4400),(39671,4400),(39672,4400),(39673,4401),(39674,4401),(39675,4401),(39676,4401),(39677,4402),(39678,4402),(39679,4402),(39680,4402),(39681,4403),(39682,4403),(39683,4403),(39684,4403),(39685,4404),(39686,4404),(39687,4404),(39688,4404),(39689,4405),(39690,4405),(39691,4405),(39692,4405),(39693,4406),(39694,4406),(39695,4406),(39696,4406),(39697,4407),(39698,4407),(39699,4407),(39700,4407),(39701,4408),(39702,4408),(39703,4408),(39704,4408),(39705,4409),(39706,4409),(39707,4409),(39708,4409),(39709,4410),(39710,4410),(39711,4410),(39712,4410),(39713,4411),(39714,4411),(39715,4411),(39716,4411),(39717,4412),(39718,4412),(39719,4412),(39720,4412),(39721,4413),(39722,4413),(39723,4413),(39724,4413),(39725,4414),(39726,4415),(39727,4416),(39728,4417),(39729,4418),(39730,4419),(39731,4420),(39732,4421),(39733,4422),(39734,4423),(39735,4424),(39736,4425),(39737,4426),(39738,4427),(39739,4428),(39740,4429),(39741,4430),(39742,4431),(39743,4432),(39744,4433),(39745,4434),(39746,4435),(39747,4436),(39748,4437),(39749,4438),(39750,4439),(39751,4440),(39752,4441),(39753,4442),(39754,4443),(39755,4444),(39756,4445),(39757,4446),(39758,4447),(39759,4448),(39760,4449),(39761,4450),(39762,4451),(39763,4452),(39764,4453),(39765,4454),(39766,4455),(39767,4456),(39768,4457),(39769,4458),(39770,4459),(39771,4460),(39772,4461),(39773,4462),(39774,4463),(39775,4464),(39776,4465),(39777,4466),(39778,4467),(39779,4468),(39780,4469),(39781,4470),(39782,4471),(39783,4472),(39784,4473),(39785,4474),(39786,4475),(39787,4476),(39788,4477),(39789,4478),(39790,4479),(39791,4480),(39792,4481),(39793,4482),(39794,4483),(39795,4484),(39796,4485),(39797,4486),(39798,4487),(39799,4488),(39800,4489),(39801,4490),(39802,4414),(39803,4415),(39804,4416),(39805,4417),(39806,4418),(39807,4419),(39808,4420),(39809,4421),(39810,4422),(39811,4423),(39812,4424),(39813,4425),(39814,4426),(39815,4427),(39816,4428),(39817,4429),(39818,4430),(39819,4431),(39820,4432),(39821,4433),(39822,4434),(39823,4435),(39824,4436),(39825,4437),(39826,4438),(39827,4439),(39828,4440),(39829,4441),(39830,4442),(39831,4443),(39832,4444),(39833,4445),(39834,4446),(39835,4447),(39836,4448),(39837,4449),(39838,4450),(39839,4451),(39840,4452),(39841,4453),(39842,4454),(39843,4455),(39844,4456),(39845,4457),(39846,4458),(39847,4459),(39848,4460),(39849,4461),(39850,4462),(39851,4463),(39852,4464),(39853,4465),(39854,4466),(39855,4467),(39856,4468),(39857,4469),(39858,4470),(39859,4471),(39860,4472),(39861,4473),(39862,4474),(39863,4475),(39864,4476),(39865,4477),(39866,4478),(39867,4479),(39868,4480),(39869,4481),(39870,4482),(39871,4483),(39872,4484),(39873,4485),(39874,4486),(39875,4487),(39876,4488),(39877,4489),(39878,4490),(39879,4414),(39880,4414),(39881,4414),(39882,4415),(39883,4415),(39884,4415),(39885,4416),(39886,4416),(39887,4417),(39888,4417),(39889,4417),(39890,4418),(39891,4418),(39892,4418),(39893,4419),(39894,4419),(39895,4419),(39896,4420),(39897,4420),(39898,4420),(39899,4421),(39900,4421),(39901,4421),(39902,4422),(39903,4422),(39904,4422),(39905,4423),(39906,4423),(39907,4423),(39908,4424),(39909,4424),(39910,4424),(39911,4425),(39912,4425),(39913,4425),(39914,4426),(39915,4426),(39916,4426),(39917,4427),(39918,4427),(39919,4427),(39920,4428),(39921,4428),(39922,4428),(39923,4429),(39924,4429),(39925,4429),(39926,4430),(39927,4430),(39928,4431),(39929,4431),(39930,4432),(39931,4432),(39932,4432),(39933,4433),(39934,4433),(39935,4433),(39936,4434),(39937,4434),(39938,4434),(39939,4435),(39940,4435),(39941,4435),(39942,4436),(39943,4436),(39944,4436),(39945,4437),(39946,4437),(39947,4437),(39948,4438),(39949,4438),(39950,4438),(39951,4439),(39952,4439),(39953,4439),(39954,4440),(39955,4440),(39956,4440),(39957,4441),(39958,4441),(39959,4441),(39960,4442),(39961,4442),(39962,4442),(39963,4443),(39964,4443),(39965,4443),(39966,4444),(39967,4444),(39968,4444),(39969,4445),(39970,4445),(39971,4445),(39972,4446),(39973,4446),(39974,4446),(39975,4447),(39976,4447),(39977,4447),(39978,4448),(39979,4448),(39980,4448),(39981,4449),(39982,4449),(39983,4449),(39984,4450),(39985,4450),(39986,4450),(39987,4451),(39988,4451),(39989,4451),(39990,4452),(39991,4452),(39992,4452),(39993,4453),(39994,4453),(39995,4453),(39996,4454),(39997,4454),(39998,4454),(39999,4455),(40000,4455),(40001,4455),(40002,4456),(40003,4456),(40004,4456),(40005,4457),(40006,4457),(40007,4458),(40008,4458),(40009,4458),(40010,4459),(40011,4459),(40012,4459),(40013,4460),(40014,4460),(40015,4460),(40016,4461),(40017,4461),(40018,4461),(40019,4462),(40020,4462),(40021,4462),(40022,4463),(40023,4463),(40024,4463),(40025,4464),(40026,4464),(40027,4464),(40028,4465),(40029,4465),(40030,4465),(40031,4466),(40032,4466),(40033,4466),(40034,4467),(40035,4467),(40036,4467),(40037,4468),(40038,4468),(40039,4468),(40040,4469),(40041,4469),(40042,4469),(40043,4470),(40044,4470),(40045,4470),(40046,4471),(40047,4471),(40048,4471),(40049,4472),(40050,4472),(40051,4472),(40052,4473),(40053,4473),(40054,4473),(40055,4474),(40056,4474),(40057,4474),(40058,4475),(40059,4475),(40060,4475),(40061,4476),(40062,4476),(40063,4476),(40064,4477),(40065,4477),(40066,4477),(40067,4478),(40068,4478),(40069,4478),(40070,4479),(40071,4479),(40072,4479),(40073,4480),(40074,4480),(40075,4480),(40076,4481),(40077,4481),(40078,4481),(40079,4482),(40080,4482),(40081,4482),(40082,4483),(40083,4483),(40084,4483),(40085,4484),(40086,4484),(40087,4484),(40088,4485),(40089,4485),(40090,4485),(40091,4486),(40092,4486),(40093,4486),(40094,4487),(40095,4487),(40096,4487),(40097,4488),(40098,4488),(40099,4488),(40100,4489),(40101,4489),(40102,4489),(40103,4490),(40104,4490),(40105,4490),(40106,4414),(40107,4414),(40108,4414),(40109,4414),(40110,4415),(40111,4415),(40112,4415),(40113,4415),(40114,4416),(40115,4416),(40116,4416),(40117,4416),(40118,4417),(40119,4417),(40120,4417),(40121,4417),(40122,4418),(40123,4418),(40124,4418),(40125,4418),(40126,4419),(40127,4419),(40128,4419),(40129,4419),(40130,4420),(40131,4420),(40132,4420),(40133,4420),(40134,4421),(40135,4421),(40136,4421),(40137,4421),(40138,4422),(40139,4422),(40140,4422),(40141,4422),(40142,4423),(40143,4423),(40144,4423),(40145,4423),(40146,4424),(40147,4424),(40148,4424),(40149,4424),(40150,4425),(40151,4425),(40152,4425),(40153,4425),(40154,4426),(40155,4426),(40156,4426),(40157,4426),(40158,4427),(40159,4427),(40160,4427),(40161,4427),(40162,4428),(40163,4428),(40164,4428),(40165,4428),(40166,4429),(40167,4429),(40168,4429),(40169,4429),(40170,4430),(40171,4430),(40172,4430),(40173,4430),(40174,4431),(40175,4431),(40176,4431),(40177,4431),(40178,4432),(40179,4432),(40180,4432),(40181,4432),(40182,4433),(40183,4433),(40184,4433),(40185,4433),(40186,4434),(40187,4434),(40188,4434),(40189,4434),(40190,4435),(40191,4435),(40192,4435),(40193,4435),(40194,4436),(40195,4436),(40196,4436),(40197,4436),(40198,4437),(40199,4437),(40200,4437),(40201,4437),(40202,4438),(40203,4438),(40204,4438),(40205,4438),(40206,4439),(40207,4439),(40208,4439),(40209,4439),(40210,4440),(40211,4440),(40212,4440),(40213,4440),(40214,4441),(40215,4441),(40216,4441),(40217,4441),(40218,4442),(40219,4442),(40220,4442),(40221,4442),(40222,4443),(40223,4443),(40224,4443),(40225,4443),(40226,4444),(40227,4444),(40228,4444),(40229,4444),(40230,4445),(40231,4445),(40232,4445),(40233,4445),(40234,4446),(40235,4446),(40236,4446),(40237,4446),(40238,4447),(40239,4447),(40240,4447),(40241,4447),(40242,4448),(40243,4448),(40244,4448),(40245,4448),(40246,4449),(40247,4449),(40248,4449),(40249,4449),(40250,4450),(40251,4450),(40252,4450),(40253,4450),(40254,4451),(40255,4451),(40256,4451),(40257,4451),(40258,4452),(40259,4452),(40260,4452),(40261,4452),(40262,4453),(40263,4453),(40264,4453),(40265,4453),(40266,4454),(40267,4454),(40268,4454),(40269,4454),(40270,4455),(40271,4455),(40272,4455),(40273,4455),(40274,4456),(40275,4456),(40276,4456),(40277,4456),(40278,4457),(40279,4457),(40280,4457),(40281,4457),(40282,4458),(40283,4458),(40284,4458),(40285,4458),(40286,4459),(40287,4459),(40288,4459),(40289,4459),(40290,4460),(40291,4460),(40292,4460),(40293,4460),(40294,4461),(40295,4461),(40296,4461),(40297,4461),(40298,4462),(40299,4462),(40300,4462),(40301,4462),(40302,4463),(40303,4463),(40304,4463),(40305,4463),(40306,4464),(40307,4464),(40308,4464),(40309,4464),(40310,4465),(40311,4465),(40312,4465),(40313,4465),(40314,4466),(40315,4466),(40316,4466),(40317,4466),(40318,4467),(40319,4467),(40320,4467),(40321,4467),(40322,4468),(40323,4468),(40324,4468),(40325,4468),(40326,4469),(40327,4469),(40328,4469),(40329,4469),(40330,4470),(40331,4470),(40332,4470),(40333,4470),(40334,4471),(40335,4471),(40336,4471),(40337,4471),(40338,4472),(40339,4472),(40340,4472),(40341,4472),(40342,4473),(40343,4473),(40344,4473),(40345,4473),(40346,4474),(40347,4474),(40348,4474),(40349,4474),(40350,4475),(40351,4475),(40352,4475),(40353,4475),(40354,4476),(40355,4476),(40356,4476),(40357,4476),(40358,4477),(40359,4477),(40360,4477),(40361,4477),(40362,4478),(40363,4478),(40364,4478),(40365,4478),(40366,4479),(40367,4479),(40368,4479),(40369,4479),(40370,4480),(40371,4480),(40372,4480),(40373,4480),(40374,4481),(40375,4481),(40376,4481),(40377,4481),(40378,4482),(40379,4482),(40380,4482),(40381,4482),(40382,4483),(40383,4483),(40384,4483),(40385,4483),(40386,4484),(40387,4484),(40388,4484),(40389,4484),(40390,4485),(40391,4485),(40392,4485),(40393,4485),(40394,4486),(40395,4486),(40396,4486),(40397,4486),(40398,4487),(40399,4487),(40400,4487),(40401,4487),(40402,4488),(40403,4488),(40404,4488),(40405,4488),(40406,4489),(40407,4489),(40408,4489),(40409,4489),(40410,4490),(40411,4490),(40412,4490),(40413,4490),(40414,4491),(40415,4492),(40416,4493),(40417,4494),(40418,4495),(40419,4496),(40420,4497),(40421,4498),(40422,4499),(40423,4500),(40424,4501),(40425,4502),(40426,4503),(40427,4504),(40428,4505),(40429,4506),(40430,4507),(40431,4508),(40432,4509),(40433,4510),(40434,4511),(40435,4512),(40436,4513),(40437,4514),(40438,4515),(40439,4516),(40440,4517),(40441,4518),(40442,4519),(40443,4520),(40444,4521),(40445,4522),(40446,4523),(40447,4524),(40448,4525),(40449,4526),(40450,4527),(40451,4528),(40452,4529),(40453,4530),(40454,4531),(40455,4532),(40456,4533),(40457,4534),(40458,4535),(40459,4536),(40460,4537),(40461,4538),(40462,4539),(40463,4540),(40464,4541),(40465,4542),(40466,4543),(40467,4544),(40468,4545),(40469,4546),(40470,4547),(40471,4548),(40472,4549),(40473,4550),(40474,4551),(40475,4552),(40476,4553),(40477,4554),(40478,4555),(40479,4556),(40480,4557),(40481,4558),(40482,4559),(40483,4560),(40484,4561),(40485,4562),(40486,4563),(40487,4564),(40488,4565),(40489,4566),(40490,4567),(40491,4568),(40492,4569),(40493,4570),(40494,4571),(40495,4572),(40496,4573),(40497,4574),(40498,4575),(40499,4576),(40500,4577),(40501,4578),(40502,4579),(40503,4491),(40504,4492),(40505,4493),(40506,4494),(40507,4495),(40508,4496),(40509,4497),(40510,4498),(40511,4499),(40512,4500),(40513,4501),(40514,4502),(40515,4503),(40516,4504),(40517,4505),(40518,4506),(40519,4507),(40520,4508),(40521,4509),(40522,4510),(40523,4511),(40524,4512),(40525,4513),(40526,4514),(40527,4515),(40528,4516),(40529,4517),(40530,4518),(40531,4519),(40532,4520),(40533,4521),(40534,4522),(40535,4523),(40536,4524),(40537,4525),(40538,4526),(40539,4527),(40540,4528),(40541,4529),(40542,4530),(40543,4531),(40544,4532),(40545,4533),(40546,4534),(40547,4535),(40548,4536),(40549,4537),(40550,4538),(40551,4539),(40552,4540),(40553,4541),(40554,4542),(40555,4543),(40556,4544),(40557,4545),(40558,4546),(40559,4547),(40560,4548),(40561,4549),(40562,4550),(40563,4551),(40564,4552),(40565,4553),(40566,4554),(40567,4555),(40568,4556),(40569,4557),(40570,4558),(40571,4559),(40572,4560),(40573,4561),(40574,4562),(40575,4563),(40576,4564),(40577,4565),(40578,4566),(40579,4567),(40580,4568),(40581,4569),(40582,4570),(40583,4571),(40584,4572),(40585,4573),(40586,4574),(40587,4575),(40588,4576),(40589,4577),(40590,4578),(40591,4579),(40592,4491),(40593,4491),(40594,4491),(40595,4492),(40596,4492),(40597,4492),(40598,4493),(40599,4493),(40600,4493),(40601,4494),(40602,4494),(40603,4494),(40604,4495),(40605,4495),(40606,4495),(40607,4496),(40608,4496),(40609,4496),(40610,4497),(40611,4497),(40612,4497),(40613,4498),(40614,4498),(40615,4498),(40616,4499),(40617,4499),(40618,4499),(40619,4500),(40620,4500),(40621,4500),(40622,4501),(40623,4501),(40624,4501),(40625,4502),(40626,4502),(40627,4502),(40628,4503),(40629,4503),(40630,4503),(40631,4504),(40632,4504),(40633,4504),(40634,4505),(40635,4505),(40636,4505),(40637,4506),(40638,4506),(40639,4506),(40640,4507),(40641,4507),(40642,4507),(40643,4508),(40644,4508),(40645,4508),(40646,4509),(40647,4509),(40648,4509),(40649,4510),(40650,4510),(40651,4510),(40652,4511),(40653,4511),(40654,4511),(40655,4512),(40656,4512),(40657,4512),(40658,4513),(40659,4513),(40660,4513),(40661,4514),(40662,4514),(40663,4514),(40664,4515),(40665,4515),(40666,4515),(40667,4516),(40668,4516),(40669,4516),(40670,4517),(40671,4517),(40672,4517),(40673,4518),(40674,4518),(40675,4518),(40676,4519),(40677,4519),(40678,4519),(40679,4520),(40680,4520),(40681,4520),(40682,4521),(40683,4521),(40684,4521),(40685,4522),(40686,4522),(40687,4522),(40688,4523),(40689,4523),(40690,4523),(40691,4524),(40692,4524),(40693,4524),(40694,4525),(40695,4525),(40696,4525),(40697,4526),(40698,4526),(40699,4526),(40700,4527),(40701,4527),(40702,4527),(40703,4528),(40704,4528),(40705,4528),(40706,4529),(40707,4529),(40708,4529),(40709,4530),(40710,4530),(40711,4530),(40712,4531),(40713,4531),(40714,4531),(40715,4532),(40716,4532),(40717,4532),(40718,4533),(40719,4533),(40720,4533),(40721,4534),(40722,4534),(40723,4534),(40724,4535),(40725,4535),(40726,4535),(40727,4536),(40728,4536),(40729,4536),(40730,4537),(40731,4537),(40732,4537),(40733,4538),(40734,4538),(40735,4539),(40736,4539),(40737,4539),(40738,4540),(40739,4540),(40740,4540),(40741,4541),(40742,4541),(40743,4541),(40744,4542),(40745,4542),(40746,4542),(40747,4543),(40748,4543),(40749,4543),(40750,4544),(40751,4544),(40752,4544),(40753,4545),(40754,4545),(40755,4545),(40756,4546),(40757,4546),(40758,4546),(40759,4547),(40760,4547),(40761,4547),(40762,4548),(40763,4548),(40764,4548),(40765,4549),(40766,4549),(40767,4549),(40768,4550),(40769,4550),(40770,4550),(40771,4551),(40772,4551),(40773,4551),(40774,4552),(40775,4552),(40776,4552),(40777,4553),(40778,4553),(40779,4553),(40780,4554),(40781,4554),(40782,4554),(40783,4555),(40784,4555),(40785,4555),(40786,4556),(40787,4556),(40788,4556),(40789,4557),(40790,4557),(40791,4557),(40792,4558),(40793,4558),(40794,4558),(40795,4559),(40796,4559),(40797,4559),(40798,4560),(40799,4560),(40800,4560),(40801,4561),(40802,4561),(40803,4561),(40804,4562),(40805,4562),(40806,4562),(40807,4563),(40808,4563),(40809,4563),(40810,4564),(40811,4564),(40812,4564),(40813,4565),(40814,4565),(40815,4565),(40816,4566),(40817,4566),(40818,4566),(40819,4567),(40820,4567),(40821,4567),(40822,4568),(40823,4568),(40824,4568),(40825,4569),(40826,4569),(40827,4569),(40828,4570),(40829,4570),(40830,4570),(40831,4571),(40832,4571),(40833,4571),(40834,4572),(40835,4572),(40836,4572),(40837,4573),(40838,4573),(40839,4573),(40840,4574),(40841,4574),(40842,4574),(40843,4575),(40844,4575),(40845,4575),(40846,4576),(40847,4576),(40848,4576),(40849,4577),(40850,4577),(40851,4577),(40852,4578),(40853,4578),(40854,4578),(40855,4579),(40856,4579),(40857,4579),(40858,4491),(40859,4491),(40860,4491),(40861,4491),(40862,4492),(40863,4492),(40864,4492),(40865,4492),(40866,4493),(40867,4493),(40868,4493),(40869,4493),(40870,4494),(40871,4494),(40872,4494),(40873,4494),(40874,4495),(40875,4495),(40876,4495),(40877,4495),(40878,4496),(40879,4496),(40880,4496),(40881,4496),(40882,4497),(40883,4497),(40884,4497),(40885,4497),(40886,4498),(40887,4498),(40888,4498),(40889,4498),(40890,4499),(40891,4499),(40892,4499),(40893,4499),(40894,4500),(40895,4500),(40896,4500),(40897,4500),(40898,4501),(40899,4501),(40900,4501),(40901,4501),(40902,4502),(40903,4502),(40904,4502),(40905,4502),(40906,4503),(40907,4503),(40908,4503),(40909,4503),(40910,4504),(40911,4504),(40912,4504),(40913,4504),(40914,4505),(40915,4505),(40916,4505),(40917,4505),(40918,4506),(40919,4506),(40920,4506),(40921,4506),(40922,4507),(40923,4507),(40924,4507),(40925,4507),(40926,4508),(40927,4508),(40928,4508),(40929,4508),(40930,4509),(40931,4509),(40932,4509),(40933,4509),(40934,4510),(40935,4510),(40936,4510),(40937,4510),(40938,4511),(40939,4511),(40940,4511),(40941,4511),(40942,4512),(40943,4512),(40944,4512),(40945,4512),(40946,4513),(40947,4513),(40948,4513),(40949,4513),(40950,4514),(40951,4514),(40952,4514),(40953,4514),(40954,4515),(40955,4515),(40956,4515),(40957,4515),(40958,4516),(40959,4516),(40960,4516),(40961,4516),(40962,4517),(40963,4517),(40964,4517),(40965,4517),(40966,4518),(40967,4518),(40968,4518),(40969,4518),(40970,4519),(40971,4519),(40972,4519),(40973,4519),(40974,4520),(40975,4520),(40976,4520),(40977,4520),(40978,4521),(40979,4521),(40980,4521),(40981,4521),(40982,4522),(40983,4522),(40984,4522),(40985,4522),(40986,4523),(40987,4523),(40988,4523),(40989,4523),(40990,4524),(40991,4524),(40992,4524),(40993,4524),(40994,4525),(40995,4525),(40996,4525),(40997,4525),(40998,4526),(40999,4526),(41000,4526),(41001,4526),(41002,4527),(41003,4527),(41004,4527),(41005,4527),(41006,4528),(41007,4528),(41008,4528),(41009,4528),(41010,4529),(41011,4529),(41012,4529),(41013,4529),(41014,4530),(41015,4530),(41016,4530),(41017,4530),(41018,4531),(41019,4531),(41020,4531),(41021,4531),(41022,4532),(41023,4532),(41024,4532),(41025,4532),(41026,4533),(41027,4533),(41028,4533),(41029,4533),(41030,4534),(41031,4534),(41032,4534),(41033,4534),(41034,4535),(41035,4535),(41036,4535),(41037,4535),(41038,4536),(41039,4536),(41040,4536),(41041,4536),(41042,4537),(41043,4537),(41044,4537),(41045,4537),(41046,4538),(41047,4538),(41048,4538),(41049,4538),(41050,4539),(41051,4539),(41052,4539),(41053,4539),(41054,4540),(41055,4540),(41056,4540),(41057,4540),(41058,4541),(41059,4541),(41060,4541),(41061,4541),(41062,4542),(41063,4542),(41064,4542),(41065,4542),(41066,4543),(41067,4543),(41068,4543),(41069,4543),(41070,4544),(41071,4544),(41072,4544),(41073,4544),(41074,4545),(41075,4545),(41076,4545),(41077,4545),(41078,4546),(41079,4546),(41080,4546),(41081,4546),(41082,4547),(41083,4547),(41084,4547),(41085,4547),(41086,4548),(41087,4548),(41088,4548),(41089,4548),(41090,4549),(41091,4549),(41092,4549),(41093,4549),(41094,4550),(41095,4550),(41096,4550),(41097,4550),(41098,4551),(41099,4551),(41100,4551),(41101,4551),(41102,4552),(41103,4552),(41104,4552),(41105,4552),(41106,4553),(41107,4553),(41108,4553),(41109,4553),(41110,4554),(41111,4554),(41112,4554),(41113,4554),(41114,4555),(41115,4555),(41116,4555),(41117,4555),(41118,4556),(41119,4556),(41120,4556),(41121,4556),(41122,4557),(41123,4557),(41124,4557),(41125,4557),(41126,4558),(41127,4558),(41128,4558),(41129,4558),(41130,4559),(41131,4559),(41132,4559),(41133,4559),(41134,4560),(41135,4560),(41136,4560),(41137,4560),(41138,4561),(41139,4561),(41140,4561),(41141,4561),(41142,4562),(41143,4562),(41144,4562),(41145,4562),(41146,4563),(41147,4563),(41148,4563),(41149,4563),(41150,4564),(41151,4564),(41152,4564),(41153,4564),(41154,4565),(41155,4565),(41156,4565),(41157,4565),(41158,4566),(41159,4566),(41160,4566),(41161,4566),(41162,4567),(41163,4567),(41164,4567),(41165,4567),(41166,4568),(41167,4568),(41168,4568),(41169,4568),(41170,4569),(41171,4569),(41172,4569),(41173,4569),(41174,4570),(41175,4570),(41176,4570),(41177,4570),(41178,4571),(41179,4571),(41180,4571),(41181,4571),(41182,4572),(41183,4572),(41184,4572),(41185,4572),(41186,4573),(41187,4573),(41188,4573),(41189,4573),(41190,4574),(41191,4574),(41192,4574),(41193,4574),(41194,4575),(41195,4575),(41196,4575),(41197,4575),(41198,4576),(41199,4576),(41200,4576),(41201,4576),(41202,4577),(41203,4577),(41204,4577),(41205,4577),(41206,4578),(41207,4578),(41208,4578),(41209,4578),(41210,4579),(41211,4579),(41212,4579),(41213,4579),(41214,4580),(41215,4581),(41216,4582),(41217,4583),(41218,4584),(41219,4585),(41220,4586),(41221,4587),(41222,4588),(41223,4589),(41224,4590),(41225,4591),(41226,4592),(41227,4593),(41228,4594),(41229,4595),(41230,4596),(41231,4597),(41232,4598),(41233,4599),(41234,4600),(41235,4601),(41236,4602),(41237,4603),(41238,4604),(41239,4605),(41240,4606),(41241,4607),(41242,4608),(41243,4609),(41244,4610),(41245,4611),(41246,4612),(41247,4613),(41248,4614),(41249,4615),(41250,4616),(41251,4617),(41252,4618),(41253,4619),(41254,4620),(41255,4621),(41256,4622),(41257,4623),(41258,4624),(41259,4625),(41260,4626),(41261,4627),(41262,4628),(41263,4629),(41264,4630),(41265,4631),(41266,4632),(41267,4633),(41268,4634),(41269,4635),(41270,4636),(41271,4637),(41272,4638),(41273,4639),(41274,4640),(41275,4641),(41276,4642),(41277,4643),(41278,4644),(41279,4645),(41280,4646),(41281,4647),(41282,4648),(41283,4649),(41284,4650),(41285,4651),(41286,4652),(41287,4653),(41288,4654),(41289,4655),(41290,4656),(41291,4657),(41292,4658),(41293,4659),(41294,4660),(41295,4661),(41296,4662),(41297,4663),(41298,4664),(41299,4665),(41300,4666),(41301,4667),(41302,4668),(41303,4669),(41304,4670),(41305,4671),(41306,4672),(41307,4673),(41308,4674),(41309,4675),(41310,4676),(41311,4677),(41312,4678),(41313,4679),(41314,4580),(41315,4581),(41316,4582),(41317,4583),(41318,4584),(41319,4585),(41320,4586),(41321,4587),(41322,4588),(41323,4589),(41324,4590),(41325,4591),(41326,4592),(41327,4593),(41328,4594),(41329,4595),(41330,4596),(41331,4597),(41332,4598),(41333,4599),(41334,4600),(41335,4601),(41336,4602),(41337,4603),(41338,4604),(41339,4605),(41340,4606),(41341,4607),(41342,4608),(41343,4609),(41344,4610),(41345,4611),(41346,4612),(41347,4613),(41348,4614),(41349,4615),(41350,4616),(41351,4617),(41352,4618),(41353,4619),(41354,4620),(41355,4621),(41356,4622),(41357,4623),(41358,4624),(41359,4625),(41360,4626),(41361,4627),(41362,4628),(41363,4629),(41364,4630),(41365,4631),(41366,4632),(41367,4633),(41368,4634),(41369,4635),(41370,4636),(41371,4637),(41372,4638),(41373,4639),(41374,4640),(41375,4641),(41376,4642),(41377,4643),(41378,4644),(41379,4645),(41380,4646),(41381,4647),(41382,4648),(41383,4649),(41384,4650),(41385,4651),(41386,4652),(41387,4653),(41388,4654),(41389,4655),(41390,4656),(41391,4657),(41392,4658),(41393,4659),(41394,4660),(41395,4661),(41396,4662),(41397,4663),(41398,4664),(41399,4665),(41400,4666),(41401,4667),(41402,4668),(41403,4669),(41404,4670),(41405,4671),(41406,4672),(41407,4673),(41408,4674),(41409,4675),(41410,4676),(41411,4677),(41412,4678),(41413,4679),(41414,4580),(41415,4580),(41416,4580),(41417,4581),(41418,4581),(41419,4581),(41420,4582),(41421,4582),(41422,4582),(41423,4583),(41424,4583),(41425,4583),(41426,4584),(41427,4584),(41428,4584),(41429,4585),(41430,4585),(41431,4585),(41432,4586),(41433,4586),(41434,4586),(41435,4587),(41436,4587),(41437,4587),(41438,4588),(41439,4588),(41440,4588),(41441,4589),(41442,4589),(41443,4589),(41444,4590),(41445,4590),(41446,4590),(41447,4591),(41448,4591),(41449,4591),(41450,4592),(41451,4592),(41452,4592),(41453,4593),(41454,4593),(41455,4593),(41456,4594),(41457,4594),(41458,4594),(41459,4595),(41460,4595),(41461,4595),(41462,4596),(41463,4596),(41464,4596),(41465,4597),(41466,4597),(41467,4597),(41468,4598),(41469,4598),(41470,4598),(41471,4599),(41472,4599),(41473,4599),(41474,4600),(41475,4600),(41476,4600),(41477,4601),(41478,4601),(41479,4601),(41480,4602),(41481,4602),(41482,4602),(41483,4603),(41484,4603),(41485,4603),(41486,4604),(41487,4604),(41488,4604),(41489,4605),(41490,4605),(41491,4605),(41492,4606),(41493,4606),(41494,4606),(41495,4607),(41496,4607),(41497,4607),(41498,4608),(41499,4608),(41500,4608),(41501,4609),(41502,4609),(41503,4609),(41504,4610),(41505,4610),(41506,4610),(41507,4611),(41508,4611),(41509,4611),(41510,4612),(41511,4612),(41512,4612),(41513,4613),(41514,4613),(41515,4613),(41516,4614),(41517,4614),(41518,4614),(41519,4615),(41520,4615),(41521,4615),(41522,4616),(41523,4616),(41524,4616),(41525,4617),(41526,4617),(41527,4617),(41528,4618),(41529,4618),(41530,4618),(41531,4619),(41532,4619),(41533,4619),(41534,4620),(41535,4620),(41536,4620),(41537,4621),(41538,4621),(41539,4621),(41540,4622),(41541,4622),(41542,4622),(41543,4623),(41544,4623),(41545,4623),(41546,4624),(41547,4624),(41548,4624),(41549,4625),(41550,4625),(41551,4625),(41552,4626),(41553,4626),(41554,4626),(41555,4627),(41556,4627),(41557,4627),(41558,4628),(41559,4628),(41560,4628),(41561,4629),(41562,4629),(41563,4629),(41564,4630),(41565,4630),(41566,4630),(41567,4631),(41568,4631),(41569,4631),(41570,4632),(41571,4632),(41572,4632),(41573,4633),(41574,4633),(41575,4633),(41576,4634),(41577,4634),(41578,4634),(41579,4635),(41580,4635),(41581,4635),(41582,4636),(41583,4636),(41584,4636),(41585,4637),(41586,4637),(41587,4637),(41588,4638),(41589,4638),(41590,4638),(41591,4639),(41592,4639),(41593,4639),(41594,4640),(41595,4640),(41596,4640),(41597,4641),(41598,4641),(41599,4641),(41600,4642),(41601,4642),(41602,4642),(41603,4643),(41604,4643),(41605,4643),(41606,4644),(41607,4644),(41608,4644),(41609,4645),(41610,4645),(41611,4645),(41612,4646),(41613,4646),(41614,4646),(41615,4647),(41616,4647),(41617,4647),(41618,4648),(41619,4648),(41620,4648),(41621,4649),(41622,4649),(41623,4649),(41624,4650),(41625,4650),(41626,4650),(41627,4651),(41628,4651),(41629,4651),(41630,4652),(41631,4652),(41632,4652),(41633,4653),(41634,4653),(41635,4653),(41636,4654),(41637,4654),(41638,4654),(41639,4655),(41640,4655),(41641,4655),(41642,4656),(41643,4656),(41644,4656),(41645,4657),(41646,4657),(41647,4657),(41648,4658),(41649,4658),(41650,4658),(41651,4659),(41652,4659),(41653,4659),(41654,4660),(41655,4660),(41656,4660),(41657,4661),(41658,4661),(41659,4661),(41660,4662),(41661,4662),(41662,4662),(41663,4663),(41664,4663),(41665,4663),(41666,4664),(41667,4664),(41668,4664),(41669,4665),(41670,4665),(41671,4665),(41672,4666),(41673,4666),(41674,4666),(41675,4667),(41676,4667),(41677,4667),(41678,4668),(41679,4668),(41680,4668),(41681,4669),(41682,4669),(41683,4669),(41684,4670),(41685,4670),(41686,4670),(41687,4671),(41688,4671),(41689,4671),(41690,4672),(41691,4672),(41692,4672),(41693,4673),(41694,4673),(41695,4673),(41696,4674),(41697,4674),(41698,4674),(41699,4675),(41700,4675),(41701,4675),(41702,4676),(41703,4676),(41704,4676),(41705,4677),(41706,4677),(41707,4677),(41708,4678),(41709,4678),(41710,4678),(41711,4679),(41712,4679),(41713,4679),(41714,4580),(41715,4580),(41716,4580),(41717,4580),(41718,4581),(41719,4581),(41720,4581),(41721,4581),(41722,4582),(41723,4582),(41724,4582),(41725,4582),(41726,4583),(41727,4583),(41728,4583),(41729,4583),(41730,4584),(41731,4584),(41732,4584),(41733,4584),(41734,4585),(41735,4585),(41736,4585),(41737,4585),(41738,4586),(41739,4586),(41740,4586),(41741,4586),(41742,4587),(41743,4587),(41744,4587),(41745,4587),(41746,4588),(41747,4588),(41748,4588),(41749,4588),(41750,4589),(41751,4589),(41752,4589),(41753,4589),(41754,4590),(41755,4590),(41756,4590),(41757,4590),(41758,4591),(41759,4591),(41760,4591),(41761,4591),(41762,4592),(41763,4592),(41764,4592),(41765,4592),(41766,4593),(41767,4593),(41768,4593),(41769,4593),(41770,4594),(41771,4594),(41772,4594),(41773,4594),(41774,4595),(41775,4595),(41776,4595),(41777,4595),(41778,4596),(41779,4596),(41780,4596),(41781,4596),(41782,4597),(41783,4597),(41784,4597),(41785,4597),(41786,4598),(41787,4598),(41788,4598),(41789,4598),(41790,4599),(41791,4599),(41792,4599),(41793,4599),(41794,4600),(41795,4600),(41796,4600),(41797,4600),(41798,4601),(41799,4601),(41800,4601),(41801,4601),(41802,4602),(41803,4602),(41804,4602),(41805,4602),(41806,4603),(41807,4603),(41808,4603),(41809,4603),(41810,4604),(41811,4604),(41812,4604),(41813,4604),(41814,4605),(41815,4605),(41816,4605),(41817,4605),(41818,4606),(41819,4606),(41820,4606),(41821,4606),(41822,4607),(41823,4607),(41824,4607),(41825,4607),(41826,4608),(41827,4608),(41828,4608),(41829,4608),(41830,4609),(41831,4609),(41832,4609),(41833,4609),(41834,4610),(41835,4610),(41836,4610),(41837,4610),(41838,4611),(41839,4611),(41840,4611),(41841,4611),(41842,4612),(41843,4612),(41844,4612),(41845,4612),(41846,4613),(41847,4613),(41848,4613),(41849,4613),(41850,4614),(41851,4614),(41852,4614),(41853,4614),(41854,4615),(41855,4615),(41856,4615),(41857,4615),(41858,4616),(41859,4616),(41860,4616),(41861,4616),(41862,4617),(41863,4617),(41864,4617),(41865,4617),(41866,4618),(41867,4618),(41868,4618),(41869,4618),(41870,4619),(41871,4619),(41872,4619),(41873,4619),(41874,4620),(41875,4620),(41876,4620),(41877,4620),(41878,4621),(41879,4621),(41880,4621),(41881,4621),(41882,4622),(41883,4622),(41884,4622),(41885,4622),(41886,4623),(41887,4623),(41888,4623),(41889,4623),(41890,4624),(41891,4624),(41892,4624),(41893,4624),(41894,4625),(41895,4625),(41896,4625),(41897,4625),(41898,4626),(41899,4626),(41900,4626),(41901,4626),(41902,4627),(41903,4627),(41904,4627),(41905,4627),(41906,4628),(41907,4628),(41908,4628),(41909,4628),(41910,4629),(41911,4629),(41912,4629),(41913,4629),(41914,4630),(41915,4630),(41916,4630),(41917,4630),(41918,4631),(41919,4631),(41920,4631),(41921,4631),(41922,4632),(41923,4632),(41924,4632),(41925,4632),(41926,4633),(41927,4633),(41928,4633),(41929,4633),(41930,4634),(41931,4634),(41932,4634),(41933,4634),(41934,4635),(41935,4635),(41936,4635),(41937,4635),(41938,4636),(41939,4636),(41940,4636),(41941,4636),(41942,4637),(41943,4637),(41944,4637),(41945,4637),(41946,4638),(41947,4638),(41948,4638),(41949,4638),(41950,4639),(41951,4639),(41952,4639),(41953,4639),(41954,4640),(41955,4640),(41956,4640),(41957,4640),(41958,4641),(41959,4641),(41960,4641),(41961,4641),(41962,4642),(41963,4642),(41964,4642),(41965,4642),(41966,4643),(41967,4643),(41968,4643),(41969,4643),(41970,4644),(41971,4644),(41972,4644),(41973,4644),(41974,4645),(41975,4645),(41976,4645),(41977,4645),(41978,4646),(41979,4646),(41980,4646),(41981,4646),(41982,4647),(41983,4647),(41984,4647),(41985,4647),(41986,4648),(41987,4648),(41988,4648),(41989,4648),(41990,4649),(41991,4649),(41992,4649),(41993,4649),(41994,4650),(41995,4650),(41996,4650),(41997,4650),(41998,4651),(41999,4651),(42000,4651),(42001,4651),(42002,4652),(42003,4652),(42004,4652),(42005,4652),(42006,4653),(42007,4653),(42008,4653),(42009,4653),(42010,4654),(42011,4654),(42012,4654),(42013,4654),(42014,4655),(42015,4655),(42016,4655),(42017,4655),(42018,4656),(42019,4656),(42020,4656),(42021,4656),(42022,4657),(42023,4657),(42024,4657),(42025,4657),(42026,4658),(42027,4658),(42028,4658),(42029,4658),(42030,4659),(42031,4659),(42032,4659),(42033,4659),(42034,4660),(42035,4660),(42036,4660),(42037,4660),(42038,4661),(42039,4661),(42040,4661),(42041,4661),(42042,4662),(42043,4662),(42044,4662),(42045,4662),(42046,4663),(42047,4663),(42048,4663),(42049,4663),(42050,4664),(42051,4664),(42052,4664),(42053,4664),(42054,4665),(42055,4665),(42056,4665),(42057,4665),(42058,4666),(42059,4666),(42060,4666),(42061,4666),(42062,4667),(42063,4667),(42064,4667),(42065,4667),(42066,4668),(42067,4668),(42068,4668),(42069,4668),(42070,4669),(42071,4669),(42072,4669),(42073,4669),(42074,4670),(42075,4670),(42076,4670),(42077,4670),(42078,4671),(42079,4671),(42080,4671),(42081,4671),(42082,4672),(42083,4672),(42084,4672),(42085,4672),(42086,4673),(42087,4673),(42088,4673),(42089,4673),(42090,4674),(42091,4674),(42092,4674),(42093,4674),(42094,4675),(42095,4675),(42096,4675),(42097,4675),(42098,4676),(42099,4676),(42100,4676),(42101,4676),(42102,4677),(42103,4677),(42104,4677),(42105,4677),(42106,4678),(42107,4678),(42108,4678),(42109,4678),(42110,4679),(42111,4679),(42112,4679),(42113,4679),(42114,4680),(42115,4681),(42116,4682),(42117,4683),(42118,4684),(42119,4685),(42120,4686),(42121,4687),(42122,4688),(42123,4689),(42124,4690),(42125,4691),(42126,4692),(42127,4693),(42128,4694),(42129,4695),(42130,4696),(42131,4697),(42132,4698),(42133,4699),(42134,4700),(42135,4701),(42136,4702),(42137,4703),(42138,4704),(42139,4705),(42140,4706),(42141,4707),(42142,4708),(42143,4709),(42144,4710),(42145,4711),(42146,4712),(42147,4713),(42148,4714),(42149,4715),(42150,4716),(42151,4717),(42152,4718),(42153,4719),(42154,4720),(42155,4721),(42156,4722),(42157,4723),(42158,4724),(42159,4725),(42160,4726),(42161,4727),(42162,4728),(42163,4729),(42164,4730),(42165,4731),(42166,4732),(42167,4733),(42168,4734),(42169,4735),(42170,4736),(42171,4737),(42172,4738),(42173,4739),(42174,4740),(42175,4741),(42176,4742),(42177,4743),(42178,4744),(42179,4745),(42180,4746),(42181,4747),(42182,4748),(42183,4749),(42184,4750),(42185,4751),(42186,4752),(42187,4753),(42188,4754),(42189,4755),(42190,4756),(42191,4757),(42192,4758),(42193,4759),(42194,4760),(42195,4761),(42196,4762),(42197,4763),(42198,4764),(42199,4765),(42200,4766),(42201,4767),(42202,4768),(42203,4769),(42204,4770),(42205,4771),(42206,4772),(42207,4773),(42208,4774),(42209,4775),(42210,4776),(42211,4777),(42212,4778),(42213,4779),(42214,4680),(42215,4681),(42216,4682),(42217,4683),(42218,4684),(42219,4685),(42220,4686),(42221,4687),(42222,4688),(42223,4689),(42224,4690),(42225,4691),(42226,4692),(42227,4693),(42228,4694),(42229,4695),(42230,4696),(42231,4697),(42232,4698),(42233,4699),(42234,4700),(42235,4701),(42236,4702),(42237,4703),(42238,4704),(42239,4705),(42240,4706),(42241,4707),(42242,4708),(42243,4709),(42244,4710),(42245,4711),(42246,4712),(42247,4713),(42248,4714),(42249,4715),(42250,4716),(42251,4717),(42252,4718),(42253,4719),(42254,4720),(42255,4721),(42256,4722),(42257,4723),(42258,4724),(42259,4725),(42260,4726),(42261,4727),(42262,4728),(42263,4729),(42264,4730),(42265,4731),(42266,4732),(42267,4733),(42268,4734),(42269,4735),(42270,4736),(42271,4737),(42272,4738),(42273,4739),(42274,4740),(42275,4741),(42276,4742),(42277,4743),(42278,4744),(42279,4745),(42280,4746),(42281,4747),(42282,4748),(42283,4749),(42284,4750),(42285,4751),(42286,4752),(42287,4753),(42288,4754),(42289,4755),(42290,4756),(42291,4757),(42292,4758),(42293,4759),(42294,4760),(42295,4761),(42296,4762),(42297,4763),(42298,4764),(42299,4765),(42300,4766),(42301,4767),(42302,4768),(42303,4769),(42304,4770),(42305,4771),(42306,4772),(42307,4773),(42308,4774),(42309,4775),(42310,4776),(42311,4777),(42312,4778),(42313,4779),(42314,4680),(42315,4680),(42316,4680),(42317,4681),(42318,4681),(42319,4681),(42320,4682),(42321,4682),(42322,4682),(42323,4683),(42324,4683),(42325,4683),(42326,4684),(42327,4684),(42328,4684),(42329,4685),(42330,4685),(42331,4685),(42332,4686),(42333,4686),(42334,4686),(42335,4687),(42336,4687),(42337,4687),(42338,4688),(42339,4688),(42340,4688),(42341,4689),(42342,4689),(42343,4689),(42344,4690),(42345,4690),(42346,4690),(42347,4691),(42348,4691),(42349,4691),(42350,4692),(42351,4692),(42352,4692),(42353,4693),(42354,4693),(42355,4693),(42356,4694),(42357,4694),(42358,4694),(42359,4695),(42360,4695),(42361,4695),(42362,4696),(42363,4696),(42364,4696),(42365,4697),(42366,4697),(42367,4697),(42368,4698),(42369,4698),(42370,4698),(42371,4699),(42372,4699),(42373,4699),(42374,4700),(42375,4700),(42376,4700),(42377,4701),(42378,4701),(42379,4701),(42380,4702),(42381,4702),(42382,4702),(42383,4703),(42384,4703),(42385,4703),(42386,4704),(42387,4704),(42388,4704),(42389,4705),(42390,4705),(42391,4705),(42392,4706),(42393,4706),(42394,4706),(42395,4707),(42396,4707),(42397,4707),(42398,4708),(42399,4708),(42400,4708),(42401,4709),(42402,4709),(42403,4709),(42404,4710),(42405,4710),(42406,4710),(42407,4711),(42408,4711),(42409,4711),(42410,4712),(42411,4712),(42412,4712),(42413,4713),(42414,4713),(42415,4713),(42416,4714),(42417,4714),(42418,4714),(42419,4715),(42420,4715),(42421,4715),(42422,4716),(42423,4716),(42424,4716),(42425,4717),(42426,4717),(42427,4717),(42428,4718),(42429,4718),(42430,4718),(42431,4719),(42432,4719),(42433,4719),(42434,4720),(42435,4720),(42436,4720),(42437,4721),(42438,4721),(42439,4721),(42440,4722),(42441,4722),(42442,4722),(42443,4723),(42444,4723),(42445,4723),(42446,4724),(42447,4724),(42448,4724),(42449,4725),(42450,4725),(42451,4725),(42452,4726),(42453,4726),(42454,4726),(42455,4727),(42456,4727),(42457,4727),(42458,4728),(42459,4728),(42460,4728),(42461,4729),(42462,4729),(42463,4729),(42464,4730),(42465,4730),(42466,4730),(42467,4731),(42468,4731),(42469,4731),(42470,4732),(42471,4732),(42472,4732),(42473,4733),(42474,4733),(42475,4733),(42476,4734),(42477,4734),(42478,4734),(42479,4735),(42480,4735),(42481,4735),(42482,4736),(42483,4736),(42484,4736),(42485,4737),(42486,4737),(42487,4737),(42488,4738),(42489,4738),(42490,4738),(42491,4739),(42492,4739),(42493,4739),(42494,4740),(42495,4740),(42496,4740),(42497,4741),(42498,4741),(42499,4741),(42500,4742),(42501,4742),(42502,4742),(42503,4743),(42504,4743),(42505,4743),(42506,4744),(42507,4744),(42508,4744),(42509,4745),(42510,4745),(42511,4745),(42512,4746),(42513,4746),(42514,4746),(42515,4747),(42516,4747),(42517,4747),(42518,4748),(42519,4748),(42520,4748),(42521,4749),(42522,4749),(42523,4749),(42524,4750),(42525,4750),(42526,4750),(42527,4751),(42528,4751),(42529,4751),(42530,4752),(42531,4752),(42532,4752),(42533,4753),(42534,4753),(42535,4753),(42536,4754),(42537,4754),(42538,4754),(42539,4755),(42540,4755),(42541,4755),(42542,4756),(42543,4756),(42544,4756),(42545,4757),(42546,4757),(42547,4757),(42548,4758),(42549,4758),(42550,4758),(42551,4759),(42552,4759),(42553,4759),(42554,4760),(42555,4760),(42556,4760),(42557,4761),(42558,4761),(42559,4761),(42560,4762),(42561,4762),(42562,4762),(42563,4763),(42564,4763),(42565,4763),(42566,4764),(42567,4764),(42568,4764),(42569,4765),(42570,4765),(42571,4765),(42572,4766),(42573,4766),(42574,4766),(42575,4767),(42576,4767),(42577,4767),(42578,4768),(42579,4768),(42580,4768),(42581,4769),(42582,4769),(42583,4769),(42584,4770),(42585,4770),(42586,4770),(42587,4771),(42588,4771),(42589,4771),(42590,4772),(42591,4772),(42592,4772),(42593,4773),(42594,4773),(42595,4773),(42596,4774),(42597,4774),(42598,4774),(42599,4775),(42600,4775),(42601,4775),(42602,4776),(42603,4776),(42604,4776),(42605,4777),(42606,4777),(42607,4777),(42608,4778),(42609,4778),(42610,4778),(42611,4779),(42612,4779),(42613,4779),(42614,4680),(42615,4680),(42616,4680),(42617,4680),(42618,4681),(42619,4681),(42620,4681),(42621,4681),(42622,4682),(42623,4682),(42624,4682),(42625,4682),(42626,4683),(42627,4683),(42628,4683),(42629,4683),(42630,4684),(42631,4684),(42632,4684),(42633,4684),(42634,4685),(42635,4685),(42636,4685),(42637,4685),(42638,4686),(42639,4686),(42640,4686),(42641,4686),(42642,4687),(42643,4687),(42644,4687),(42645,4687),(42646,4688),(42647,4688),(42648,4688),(42649,4688),(42650,4689),(42651,4689),(42652,4689),(42653,4689),(42654,4690),(42655,4690),(42656,4690),(42657,4690),(42658,4691),(42659,4691),(42660,4691),(42661,4691),(42662,4692),(42663,4692),(42664,4692),(42665,4692),(42666,4693),(42667,4693),(42668,4693),(42669,4693),(42670,4694),(42671,4694),(42672,4694),(42673,4694),(42674,4695),(42675,4695),(42676,4695),(42677,4695),(42678,4696),(42679,4696),(42680,4696),(42681,4696),(42682,4697),(42683,4697),(42684,4697),(42685,4697),(42686,4698),(42687,4698),(42688,4698),(42689,4698),(42690,4699),(42691,4699),(42692,4699),(42693,4699),(42694,4700),(42695,4700),(42696,4700),(42697,4700),(42698,4701),(42699,4701),(42700,4701),(42701,4701),(42702,4702),(42703,4702),(42704,4702),(42705,4702),(42706,4703),(42707,4703),(42708,4703),(42709,4703),(42710,4704),(42711,4704),(42712,4704),(42713,4704),(42714,4705),(42715,4705),(42716,4705),(42717,4705),(42718,4706),(42719,4706),(42720,4706),(42721,4706),(42722,4707),(42723,4707),(42724,4707),(42725,4707),(42726,4708),(42727,4708),(42728,4708),(42729,4708),(42730,4709),(42731,4709),(42732,4709),(42733,4709),(42734,4710),(42735,4710),(42736,4710),(42737,4710),(42738,4711),(42739,4711),(42740,4711),(42741,4711),(42742,4712),(42743,4712),(42744,4712),(42745,4712),(42746,4713),(42747,4713),(42748,4713),(42749,4713),(42750,4714),(42751,4714),(42752,4714),(42753,4714),(42754,4715),(42755,4715),(42756,4715),(42757,4715),(42758,4716),(42759,4716),(42760,4716),(42761,4716),(42762,4717),(42763,4717),(42764,4717),(42765,4717),(42766,4718),(42767,4718),(42768,4718),(42769,4718),(42770,4719),(42771,4719),(42772,4719),(42773,4719),(42774,4720),(42775,4720),(42776,4720),(42777,4720),(42778,4721),(42779,4721),(42780,4721),(42781,4721),(42782,4722),(42783,4722),(42784,4722),(42785,4722),(42786,4723),(42787,4723),(42788,4723),(42789,4723),(42790,4724),(42791,4724),(42792,4724),(42793,4724),(42794,4725),(42795,4725),(42796,4725),(42797,4725),(42798,4726),(42799,4726),(42800,4726),(42801,4726),(42802,4727),(42803,4727),(42804,4727),(42805,4727),(42806,4728),(42807,4728),(42808,4728),(42809,4728),(42810,4729),(42811,4729),(42812,4729),(42813,4729),(42814,4730),(42815,4730),(42816,4730),(42817,4730),(42818,4731),(42819,4731),(42820,4731),(42821,4731),(42822,4732),(42823,4732),(42824,4732),(42825,4732),(42826,4733),(42827,4733),(42828,4733),(42829,4733),(42830,4734),(42831,4734),(42832,4734),(42833,4734),(42834,4735),(42835,4735),(42836,4735),(42837,4735),(42838,4736),(42839,4736),(42840,4736),(42841,4736),(42842,4737),(42843,4737),(42844,4737),(42845,4737),(42846,4738),(42847,4738),(42848,4738),(42849,4738),(42850,4739),(42851,4739),(42852,4739),(42853,4739),(42854,4740),(42855,4740),(42856,4740),(42857,4740),(42858,4741),(42859,4741),(42860,4741),(42861,4741),(42862,4742),(42863,4742),(42864,4742),(42865,4742),(42866,4743),(42867,4743),(42868,4743),(42869,4743),(42870,4744),(42871,4744),(42872,4744),(42873,4744),(42874,4745),(42875,4745),(42876,4745),(42877,4745),(42878,4746),(42879,4746),(42880,4746),(42881,4746),(42882,4747),(42883,4747),(42884,4747),(42885,4747),(42886,4748),(42887,4748),(42888,4748),(42889,4748),(42890,4749),(42891,4749),(42892,4749),(42893,4749),(42894,4750),(42895,4750),(42896,4750),(42897,4750),(42898,4751),(42899,4751),(42900,4751),(42901,4751),(42902,4752),(42903,4752),(42904,4752),(42905,4752),(42906,4753),(42907,4753),(42908,4753),(42909,4753),(42910,4754),(42911,4754),(42912,4754),(42913,4754),(42914,4755),(42915,4755),(42916,4755),(42917,4755),(42918,4756),(42919,4756),(42920,4756),(42921,4756),(42922,4757),(42923,4757),(42924,4757),(42925,4757),(42926,4758),(42927,4758),(42928,4758),(42929,4758),(42930,4759),(42931,4759),(42932,4759),(42933,4759),(42934,4760),(42935,4760),(42936,4760),(42937,4760),(42938,4761),(42939,4761),(42940,4761),(42941,4761),(42942,4762),(42943,4762),(42944,4762),(42945,4762),(42946,4763),(42947,4763),(42948,4763),(42949,4763),(42950,4764),(42951,4764),(42952,4764),(42953,4764),(42954,4765),(42955,4765),(42956,4765),(42957,4765),(42958,4766),(42959,4766),(42960,4766),(42961,4766),(42962,4767),(42963,4767),(42964,4767),(42965,4767),(42966,4768),(42967,4768),(42968,4768),(42969,4768),(42970,4769),(42971,4769),(42972,4769),(42973,4769),(42974,4770),(42975,4770),(42976,4770),(42977,4770),(42978,4771),(42979,4771),(42980,4771),(42981,4771),(42982,4772),(42983,4772),(42984,4772),(42985,4772),(42986,4773),(42987,4773),(42988,4773),(42989,4773),(42990,4774),(42991,4774),(42992,4774),(42993,4774),(42994,4775),(42995,4775),(42996,4775),(42997,4775),(42998,4776),(42999,4776),(43000,4776),(43001,4776),(43002,4777),(43003,4777),(43004,4777),(43005,4777),(43006,4778),(43007,4778),(43008,4778),(43009,4778),(43010,4779),(43011,4779),(43012,4779),(43013,4779),(43014,4780),(43015,4781),(43016,4782),(43017,4783),(43018,4784),(43019,4785),(43020,4786),(43021,4787),(43022,4788),(43023,4789),(43024,4790),(43025,4791),(43026,4792),(43027,4793),(43028,4794),(43029,4795),(43030,4796),(43031,4797),(43032,4798),(43033,4799),(43034,4800),(43035,4801),(43036,4802),(43037,4803),(43038,4804),(43039,4805),(43040,4806),(43041,4807),(43042,4808),(43043,4809),(43044,4810),(43045,4811),(43046,4812),(43047,4813),(43048,4814),(43049,4815),(43050,4816),(43051,4817),(43052,4818),(43053,4819),(43054,4820),(43055,4821),(43056,4822),(43057,4823),(43058,4824),(43059,4825),(43060,4826),(43061,4827),(43062,4828),(43063,4829),(43064,4830),(43065,4831),(43066,4832),(43067,4833),(43068,4834),(43069,4835),(43070,4836),(43071,4837),(43072,4838),(43073,4839),(43074,4840),(43075,4841),(43076,4842),(43077,4843),(43078,4844),(43079,4845),(43080,4846),(43081,4847),(43082,4848),(43083,4849),(43084,4850),(43085,4851),(43086,4852),(43087,4853),(43088,4854),(43089,4855),(43090,4856),(43091,4857),(43092,4858),(43093,4859),(43094,4860),(43095,4861),(43096,4862),(43097,4863),(43098,4864),(43099,4865),(43100,4866),(43101,4867),(43102,4868),(43103,4869),(43104,4870),(43105,4871),(43106,4872),(43107,4873),(43108,4874),(43109,4875),(43110,4876),(43111,4877),(43112,4878),(43113,4879),(43114,4780),(43115,4781),(43116,4782),(43117,4783),(43118,4784),(43119,4785),(43120,4786),(43121,4787),(43122,4788),(43123,4789),(43124,4790),(43125,4791),(43126,4792),(43127,4793),(43128,4794),(43129,4795),(43130,4796),(43131,4797),(43132,4798),(43133,4799),(43134,4800),(43135,4801),(43136,4802),(43137,4803),(43138,4804),(43139,4805),(43140,4806),(43141,4807),(43142,4808),(43143,4809),(43144,4810),(43145,4811),(43146,4812),(43147,4813),(43148,4814),(43149,4815),(43150,4816),(43151,4817),(43152,4818),(43153,4819),(43154,4820),(43155,4821),(43156,4822),(43157,4823),(43158,4824),(43159,4825),(43160,4826),(43161,4827),(43162,4828),(43163,4829),(43164,4830),(43165,4831),(43166,4832),(43167,4833),(43168,4834),(43169,4835),(43170,4836),(43171,4837),(43172,4838),(43173,4839),(43174,4840),(43175,4841),(43176,4842),(43177,4843),(43178,4844),(43179,4845),(43180,4846),(43181,4847),(43182,4848),(43183,4849),(43184,4850),(43185,4851),(43186,4852),(43187,4853),(43188,4854),(43189,4855),(43190,4856),(43191,4857),(43192,4858),(43193,4859),(43194,4860),(43195,4861),(43196,4862),(43197,4863),(43198,4864),(43199,4865),(43200,4866),(43201,4867),(43202,4868),(43203,4869),(43204,4870),(43205,4871),(43206,4872),(43207,4873),(43208,4874),(43209,4875),(43210,4876),(43211,4877),(43212,4878),(43213,4879),(43214,4780),(43215,4780),(43216,4780),(43217,4781),(43218,4781),(43219,4781),(43220,4782),(43221,4782),(43222,4782),(43223,4783),(43224,4783),(43225,4783),(43226,4784),(43227,4784),(43228,4784),(43229,4785),(43230,4785),(43231,4785),(43232,4786),(43233,4786),(43234,4786),(43235,4787),(43236,4787),(43237,4787),(43238,4788),(43239,4788),(43240,4788),(43241,4789),(43242,4789),(43243,4789),(43244,4790),(43245,4790),(43246,4790),(43247,4791),(43248,4791),(43249,4791),(43250,4792),(43251,4792),(43252,4792),(43253,4793),(43254,4793),(43255,4793),(43256,4794),(43257,4794),(43258,4794),(43259,4795),(43260,4795),(43261,4795),(43262,4796),(43263,4796),(43264,4796),(43265,4797),(43266,4797),(43267,4797),(43268,4798),(43269,4798),(43270,4798),(43271,4799),(43272,4799),(43273,4799),(43274,4800),(43275,4800),(43276,4800),(43277,4801),(43278,4801),(43279,4801),(43280,4802),(43281,4802),(43282,4802),(43283,4803),(43284,4803),(43285,4803),(43286,4804),(43287,4804),(43288,4804),(43289,4805),(43290,4805),(43291,4805),(43292,4806),(43293,4806),(43294,4806),(43295,4807),(43296,4807),(43297,4807),(43298,4808),(43299,4808),(43300,4808),(43301,4809),(43302,4809),(43303,4809),(43304,4810),(43305,4810),(43306,4810),(43307,4811),(43308,4811),(43309,4811),(43310,4812),(43311,4812),(43312,4812),(43313,4813),(43314,4813),(43315,4813),(43316,4814),(43317,4814),(43318,4814),(43319,4815),(43320,4815),(43321,4815),(43322,4816),(43323,4816),(43324,4816),(43325,4817),(43326,4817),(43327,4817),(43328,4818),(43329,4818),(43330,4818),(43331,4819),(43332,4819),(43333,4819),(43334,4820),(43335,4820),(43336,4820),(43337,4821),(43338,4821),(43339,4821),(43340,4822),(43341,4822),(43342,4822),(43343,4823),(43344,4823),(43345,4823),(43346,4824),(43347,4824),(43348,4824),(43349,4825),(43350,4825),(43351,4825),(43352,4826),(43353,4826),(43354,4826),(43355,4827),(43356,4827),(43357,4827),(43358,4828),(43359,4828),(43360,4828),(43361,4829),(43362,4829),(43363,4829),(43364,4830),(43365,4830),(43366,4830),(43367,4831),(43368,4831),(43369,4831),(43370,4832),(43371,4832),(43372,4832),(43373,4833),(43374,4833),(43375,4833),(43376,4834),(43377,4834),(43378,4834),(43379,4835),(43380,4835),(43381,4835),(43382,4836),(43383,4836),(43384,4836),(43385,4837),(43386,4837),(43387,4837),(43388,4838),(43389,4838),(43390,4838),(43391,4839),(43392,4839),(43393,4839),(43394,4840),(43395,4840),(43396,4840),(43397,4841),(43398,4841),(43399,4841),(43400,4842),(43401,4842),(43402,4842),(43403,4843),(43404,4843),(43405,4843),(43406,4844),(43407,4844),(43408,4844),(43409,4845),(43410,4845),(43411,4845),(43412,4846),(43413,4846),(43414,4846),(43415,4847),(43416,4847),(43417,4847),(43418,4848),(43419,4848),(43420,4848),(43421,4849),(43422,4849),(43423,4849),(43424,4850),(43425,4850),(43426,4850),(43427,4851),(43428,4851),(43429,4851),(43430,4852),(43431,4852),(43432,4852),(43433,4853),(43434,4853),(43435,4853),(43436,4854),(43437,4854),(43438,4854),(43439,4855),(43440,4855),(43441,4855),(43442,4856),(43443,4856),(43444,4856),(43445,4857),(43446,4857),(43447,4857),(43448,4858),(43449,4858),(43450,4858),(43451,4859),(43452,4859),(43453,4859),(43454,4860),(43455,4860),(43456,4860),(43457,4861),(43458,4861),(43459,4861),(43460,4862),(43461,4862),(43462,4862),(43463,4863),(43464,4863),(43465,4863),(43466,4864),(43467,4864),(43468,4864),(43469,4865),(43470,4865),(43471,4865),(43472,4866),(43473,4866),(43474,4866),(43475,4867),(43476,4867),(43477,4867),(43478,4868),(43479,4868),(43480,4868),(43481,4869),(43482,4869),(43483,4869),(43484,4870),(43485,4870),(43486,4870),(43487,4871),(43488,4871),(43489,4871),(43490,4872),(43491,4872),(43492,4872),(43493,4873),(43494,4873),(43495,4873),(43496,4874),(43497,4874),(43498,4874),(43499,4875),(43500,4875),(43501,4875),(43502,4876),(43503,4876),(43504,4876),(43505,4877),(43506,4877),(43507,4877),(43508,4878),(43509,4878),(43510,4878),(43511,4879),(43512,4879),(43513,4879),(43514,4780),(43515,4780),(43516,4780),(43517,4780),(43518,4781),(43519,4781),(43520,4781),(43521,4781),(43522,4782),(43523,4782),(43524,4782),(43525,4782),(43526,4783),(43527,4783),(43528,4783),(43529,4783),(43530,4784),(43531,4784),(43532,4784),(43533,4784),(43534,4785),(43535,4785),(43536,4785),(43537,4785),(43538,4786),(43539,4786),(43540,4786),(43541,4786),(43542,4787),(43543,4787),(43544,4787),(43545,4787),(43546,4788),(43547,4788),(43548,4788),(43549,4788),(43550,4789),(43551,4789),(43552,4789),(43553,4789),(43554,4790),(43555,4790),(43556,4790),(43557,4790),(43558,4791),(43559,4791),(43560,4791),(43561,4791),(43562,4792),(43563,4792),(43564,4792),(43565,4792),(43566,4793),(43567,4793),(43568,4793),(43569,4793),(43570,4794),(43571,4794),(43572,4794),(43573,4794),(43574,4795),(43575,4795),(43576,4795),(43577,4795),(43578,4796),(43579,4796),(43580,4796),(43581,4796),(43582,4797),(43583,4797),(43584,4797),(43585,4797),(43586,4798),(43587,4798),(43588,4798),(43589,4798),(43590,4799),(43591,4799),(43592,4799),(43593,4799),(43594,4800),(43595,4800),(43596,4800),(43597,4800),(43598,4801),(43599,4801),(43600,4801),(43601,4801),(43602,4802),(43603,4802),(43604,4802),(43605,4802),(43606,4803),(43607,4803),(43608,4803),(43609,4803),(43610,4804),(43611,4804),(43612,4804),(43613,4804),(43614,4805),(43615,4805),(43616,4805),(43617,4805),(43618,4806),(43619,4806),(43620,4806),(43621,4806),(43622,4807),(43623,4807),(43624,4807),(43625,4807),(43626,4808),(43627,4808),(43628,4808),(43629,4808),(43630,4809),(43631,4809),(43632,4809),(43633,4809),(43634,4810),(43635,4810),(43636,4810),(43637,4810),(43638,4811),(43639,4811),(43640,4811),(43641,4811),(43642,4812),(43643,4812),(43644,4812),(43645,4812),(43646,4813),(43647,4813),(43648,4813),(43649,4813),(43650,4814),(43651,4814),(43652,4814),(43653,4814),(43654,4815),(43655,4815),(43656,4815),(43657,4815),(43658,4816),(43659,4816),(43660,4816),(43661,4816),(43662,4817),(43663,4817),(43664,4817),(43665,4817),(43666,4818),(43667,4818),(43668,4818),(43669,4818),(43670,4819),(43671,4819),(43672,4819),(43673,4819),(43674,4820),(43675,4820),(43676,4820),(43677,4820),(43678,4821),(43679,4821),(43680,4821),(43681,4821),(43682,4822),(43683,4822),(43684,4822),(43685,4822),(43686,4823),(43687,4823),(43688,4823),(43689,4823),(43690,4824),(43691,4824),(43692,4824),(43693,4824),(43694,4825),(43695,4825),(43696,4825),(43697,4825),(43698,4826),(43699,4826),(43700,4826),(43701,4826),(43702,4827),(43703,4827),(43704,4827),(43705,4827),(43706,4828),(43707,4828),(43708,4828),(43709,4828),(43710,4829),(43711,4829),(43712,4829),(43713,4829),(43714,4830),(43715,4830),(43716,4830),(43717,4830),(43718,4831),(43719,4831),(43720,4831),(43721,4831),(43722,4832),(43723,4832),(43724,4832),(43725,4832),(43726,4833),(43727,4833),(43728,4833),(43729,4833),(43730,4834),(43731,4834),(43732,4834),(43733,4834),(43734,4835),(43735,4835),(43736,4835),(43737,4835),(43738,4836),(43739,4836),(43740,4836),(43741,4836),(43742,4837),(43743,4837),(43744,4837),(43745,4837),(43746,4838),(43747,4838),(43748,4838),(43749,4838),(43750,4839),(43751,4839),(43752,4839),(43753,4839),(43754,4840),(43755,4840),(43756,4840),(43757,4840),(43758,4841),(43759,4841),(43760,4841),(43761,4841),(43762,4842),(43763,4842),(43764,4842),(43765,4842),(43766,4843),(43767,4843),(43768,4843),(43769,4843),(43770,4844),(43771,4844),(43772,4844),(43773,4844),(43774,4845),(43775,4845),(43776,4845),(43777,4845),(43778,4846),(43779,4846),(43780,4846),(43781,4846),(43782,4847),(43783,4847),(43784,4847),(43785,4847),(43786,4848),(43787,4848),(43788,4848),(43789,4848),(43790,4849),(43791,4849),(43792,4849),(43793,4849),(43794,4850),(43795,4850),(43796,4850),(43797,4850),(43798,4851),(43799,4851),(43800,4851),(43801,4851),(43802,4852),(43803,4852),(43804,4852),(43805,4852),(43806,4853),(43807,4853),(43808,4853),(43809,4853),(43810,4854),(43811,4854),(43812,4854),(43813,4854),(43814,4855),(43815,4855),(43816,4855),(43817,4855),(43818,4856),(43819,4856),(43820,4856),(43821,4856),(43822,4857),(43823,4857),(43824,4857),(43825,4857),(43826,4858),(43827,4858),(43828,4858),(43829,4858),(43830,4859),(43831,4859),(43832,4859),(43833,4859),(43834,4860),(43835,4860),(43836,4860),(43837,4860),(43838,4861),(43839,4861),(43840,4861),(43841,4861),(43842,4862),(43843,4862),(43844,4862),(43845,4862),(43846,4863),(43847,4863),(43848,4863),(43849,4863),(43850,4864),(43851,4864),(43852,4864),(43853,4864),(43854,4865),(43855,4865),(43856,4865),(43857,4865),(43858,4866),(43859,4866),(43860,4866),(43861,4866),(43862,4867),(43863,4867),(43864,4867),(43865,4867),(43866,4868),(43867,4868),(43868,4868),(43869,4868),(43870,4869),(43871,4869),(43872,4869),(43873,4869),(43874,4870),(43875,4870),(43876,4870),(43877,4870),(43878,4871),(43879,4871),(43880,4871),(43881,4871),(43882,4872),(43883,4872),(43884,4872),(43885,4872),(43886,4873),(43887,4873),(43888,4873),(43889,4873),(43890,4874),(43891,4874),(43892,4874),(43893,4874),(43894,4875),(43895,4875),(43896,4875),(43897,4875),(43898,4876),(43899,4876),(43900,4876),(43901,4876),(43902,4877),(43903,4877),(43904,4877),(43905,4877),(43906,4878),(43907,4878),(43908,4878),(43909,4878),(43910,4879),(43911,4879),(43912,4879),(43913,4879),(43914,4880),(43915,4881),(43916,4882),(43917,4883),(43918,4884),(43919,4885),(43920,4886),(43921,4887),(43922,4888),(43923,4889),(43924,4890),(43925,4891),(43926,4892),(43927,4893),(43928,4894),(43929,4895),(43930,4896),(43931,4897),(43932,4898),(43933,4899),(43934,4900),(43935,4901),(43936,4902),(43937,4903),(43938,4904),(43939,4905),(43940,4906),(43941,4907),(43942,4908),(43943,4909),(43944,4910),(43945,4911),(43946,4912),(43947,4913),(43948,4914),(43949,4915),(43950,4916),(43951,4917),(43952,4918),(43953,4919),(43954,4920),(43955,4921),(43956,4922),(43957,4923),(43958,4924),(43959,4925),(43960,4926),(43961,4927),(43962,4928),(43963,4929),(43964,4930),(43965,4931),(43966,4932),(43967,4933),(43968,4934),(43969,4935),(43970,4936),(43971,4937),(43972,4938),(43973,4939),(43974,4940),(43975,4941),(43976,4942),(43977,4943),(43978,4944),(43979,4945),(43980,4946),(43981,4947),(43982,4948),(43983,4949),(43984,4950),(43985,4951),(43986,4952),(43987,4953),(43988,4954),(43989,4955),(43990,4956),(43991,4957),(43992,4958),(43993,4959),(43994,4960),(43995,4961),(43996,4962),(43997,4963),(43998,4964),(43999,4965),(44000,4966),(44001,4967),(44002,4968),(44003,4969),(44004,4970),(44005,4971),(44006,4972),(44007,4973),(44008,4974),(44009,4975),(44010,4976),(44011,4977),(44012,4978),(44013,4979),(44014,4880),(44015,4881),(44016,4882),(44017,4883),(44018,4884),(44019,4885),(44020,4886),(44021,4887),(44022,4888),(44023,4889),(44024,4890),(44025,4891),(44026,4892),(44027,4893),(44028,4894),(44029,4895),(44030,4896),(44031,4897),(44032,4898),(44033,4899),(44034,4900),(44035,4901),(44036,4902),(44037,4903),(44038,4904),(44039,4905),(44040,4906),(44041,4907),(44042,4908),(44043,4909),(44044,4910),(44045,4911),(44046,4912),(44047,4913),(44048,4914),(44049,4915),(44050,4916),(44051,4917),(44052,4918),(44053,4919),(44054,4920),(44055,4921),(44056,4922),(44057,4923),(44058,4924),(44059,4925),(44060,4926),(44061,4927),(44062,4928),(44063,4929),(44064,4930),(44065,4931),(44066,4932),(44067,4933),(44068,4934),(44069,4935),(44070,4936),(44071,4937),(44072,4938),(44073,4939),(44074,4940),(44075,4941),(44076,4942),(44077,4943),(44078,4944),(44079,4945),(44080,4946),(44081,4947),(44082,4948),(44083,4949),(44084,4950),(44085,4951),(44086,4952),(44087,4953),(44088,4954),(44089,4955),(44090,4956),(44091,4957),(44092,4958),(44093,4959),(44094,4960),(44095,4961),(44096,4962),(44097,4963),(44098,4964),(44099,4965),(44100,4966),(44101,4967),(44102,4968),(44103,4969),(44104,4970),(44105,4971),(44106,4972),(44107,4973),(44108,4974),(44109,4975),(44110,4976),(44111,4977),(44112,4978),(44113,4979),(44114,4880),(44115,4880),(44116,4880),(44117,4881),(44118,4881),(44119,4881),(44120,4882),(44121,4882),(44122,4882),(44123,4883),(44124,4883),(44125,4883),(44126,4884),(44127,4884),(44128,4884),(44129,4885),(44130,4885),(44131,4885),(44132,4886),(44133,4886),(44134,4886),(44135,4887),(44136,4887),(44137,4887),(44138,4888),(44139,4888),(44140,4888),(44141,4889),(44142,4889),(44143,4889),(44144,4890),(44145,4890),(44146,4890),(44147,4891),(44148,4891),(44149,4891),(44150,4892),(44151,4892),(44152,4892),(44153,4893),(44154,4893),(44155,4893),(44156,4894),(44157,4894),(44158,4894),(44159,4895),(44160,4895),(44161,4895),(44162,4896),(44163,4896),(44164,4896),(44165,4897),(44166,4897),(44167,4897),(44168,4898),(44169,4898),(44170,4898),(44171,4899),(44172,4899),(44173,4899),(44174,4900),(44175,4900),(44176,4900),(44177,4901),(44178,4901),(44179,4901),(44180,4902),(44181,4902),(44182,4902),(44183,4903),(44184,4903),(44185,4903),(44186,4904),(44187,4904),(44188,4904),(44189,4905),(44190,4905),(44191,4905),(44192,4906),(44193,4906),(44194,4906),(44195,4907),(44196,4907),(44197,4907),(44198,4908),(44199,4908),(44200,4908),(44201,4909),(44202,4909),(44203,4909),(44204,4910),(44205,4910),(44206,4910),(44207,4911),(44208,4911),(44209,4911),(44210,4912),(44211,4912),(44212,4912),(44213,4913),(44214,4913),(44215,4913),(44216,4914),(44217,4914),(44218,4914),(44219,4915),(44220,4915),(44221,4915),(44222,4916),(44223,4916),(44224,4916),(44225,4917),(44226,4917),(44227,4917),(44228,4918),(44229,4918),(44230,4918),(44231,4919),(44232,4919),(44233,4919),(44234,4920),(44235,4920),(44236,4920),(44237,4921),(44238,4921),(44239,4921),(44240,4922),(44241,4922),(44242,4922),(44243,4923),(44244,4923),(44245,4923),(44246,4924),(44247,4924),(44248,4924),(44249,4925),(44250,4925),(44251,4925),(44252,4926),(44253,4926),(44254,4926),(44255,4927),(44256,4927),(44257,4927),(44258,4928),(44259,4928),(44260,4928),(44261,4929),(44262,4929),(44263,4929),(44264,4930),(44265,4930),(44266,4930),(44267,4931),(44268,4931),(44269,4931),(44270,4932),(44271,4932),(44272,4932),(44273,4933),(44274,4933),(44275,4933),(44276,4934),(44277,4934),(44278,4934),(44279,4935),(44280,4935),(44281,4935),(44282,4936),(44283,4936),(44284,4936),(44285,4937),(44286,4937),(44287,4937),(44288,4938),(44289,4938),(44290,4938),(44291,4939),(44292,4939),(44293,4939),(44294,4940),(44295,4940),(44296,4940),(44297,4941),(44298,4941),(44299,4941),(44300,4942),(44301,4942),(44302,4942),(44303,4943),(44304,4943),(44305,4943),(44306,4944),(44307,4944),(44308,4944),(44309,4945),(44310,4945),(44311,4945),(44312,4946),(44313,4946),(44314,4946),(44315,4947),(44316,4947),(44317,4947),(44318,4948),(44319,4948),(44320,4948),(44321,4949),(44322,4949),(44323,4949),(44324,4950),(44325,4950),(44326,4950),(44327,4951),(44328,4951),(44329,4951),(44330,4952),(44331,4952),(44332,4952),(44333,4953),(44334,4953),(44335,4953),(44336,4954),(44337,4954),(44338,4954),(44339,4955),(44340,4955),(44341,4955),(44342,4956),(44343,4956),(44344,4956),(44345,4957),(44346,4957),(44347,4957),(44348,4958),(44349,4958),(44350,4958),(44351,4959),(44352,4959),(44353,4959),(44354,4960),(44355,4960),(44356,4960),(44357,4961),(44358,4961),(44359,4961),(44360,4962),(44361,4962),(44362,4962),(44363,4963),(44364,4963),(44365,4963),(44366,4964),(44367,4964),(44368,4964),(44369,4965),(44370,4965),(44371,4965),(44372,4966),(44373,4966),(44374,4966),(44375,4967),(44376,4967),(44377,4967),(44378,4968),(44379,4968),(44380,4968),(44381,4969),(44382,4969),(44383,4969),(44384,4970),(44385,4970),(44386,4970),(44387,4971),(44388,4971),(44389,4971),(44390,4972),(44391,4972),(44392,4972),(44393,4973),(44394,4973),(44395,4973),(44396,4974),(44397,4974),(44398,4974),(44399,4975),(44400,4975),(44401,4975),(44402,4976),(44403,4976),(44404,4976),(44405,4977),(44406,4977),(44407,4977),(44408,4978),(44409,4978),(44410,4978),(44411,4979),(44412,4979),(44413,4979),(44414,4880),(44415,4880),(44416,4880),(44417,4880),(44418,4881),(44419,4881),(44420,4881),(44421,4881),(44422,4882),(44423,4882),(44424,4882),(44425,4882),(44426,4883),(44427,4883),(44428,4883),(44429,4883),(44430,4884),(44431,4884),(44432,4884),(44433,4884),(44434,4885),(44435,4885),(44436,4885),(44437,4885),(44438,4886),(44439,4886),(44440,4886),(44441,4886),(44442,4887),(44443,4887),(44444,4887),(44445,4887),(44446,4888),(44447,4888),(44448,4888),(44449,4888),(44450,4889),(44451,4889),(44452,4889),(44453,4889),(44454,4890),(44455,4890),(44456,4890),(44457,4890),(44458,4891),(44459,4891),(44460,4891),(44461,4891),(44462,4892),(44463,4892),(44464,4892),(44465,4892),(44466,4893),(44467,4893),(44468,4893),(44469,4893),(44470,4894),(44471,4894),(44472,4894),(44473,4894),(44474,4895),(44475,4895),(44476,4895),(44477,4895),(44478,4896),(44479,4896),(44480,4896),(44481,4896),(44482,4897),(44483,4897),(44484,4897),(44485,4897),(44486,4898),(44487,4898),(44488,4898),(44489,4898),(44490,4899),(44491,4899),(44492,4899),(44493,4899),(44494,4900),(44495,4900),(44496,4900),(44497,4900),(44498,4901),(44499,4901),(44500,4901),(44501,4901),(44502,4902),(44503,4902),(44504,4902),(44505,4902),(44506,4903),(44507,4903),(44508,4903),(44509,4903),(44510,4904),(44511,4904),(44512,4904),(44513,4904),(44514,4905),(44515,4905),(44516,4905),(44517,4905),(44518,4906),(44519,4906),(44520,4906),(44521,4906),(44522,4907),(44523,4907),(44524,4907),(44525,4907),(44526,4908),(44527,4908),(44528,4908),(44529,4908),(44530,4909),(44531,4909),(44532,4909),(44533,4909),(44534,4910),(44535,4910),(44536,4910),(44537,4910),(44538,4911),(44539,4911),(44540,4911),(44541,4911),(44542,4912),(44543,4912),(44544,4912),(44545,4912),(44546,4913),(44547,4913),(44548,4913),(44549,4913),(44550,4914),(44551,4914),(44552,4914),(44553,4914),(44554,4915),(44555,4915),(44556,4915),(44557,4915),(44558,4916),(44559,4916),(44560,4916),(44561,4916),(44562,4917),(44563,4917),(44564,4917),(44565,4917),(44566,4918),(44567,4918),(44568,4918),(44569,4918),(44570,4919),(44571,4919),(44572,4919),(44573,4919),(44574,4920),(44575,4920),(44576,4920),(44577,4920),(44578,4921),(44579,4921),(44580,4921),(44581,4921),(44582,4922),(44583,4922),(44584,4922),(44585,4922),(44586,4923),(44587,4923),(44588,4923),(44589,4923),(44590,4924),(44591,4924),(44592,4924),(44593,4924),(44594,4925),(44595,4925),(44596,4925),(44597,4925),(44598,4926),(44599,4926),(44600,4926),(44601,4926),(44602,4927),(44603,4927),(44604,4927),(44605,4927),(44606,4928),(44607,4928),(44608,4928),(44609,4928),(44610,4929),(44611,4929),(44612,4929),(44613,4929),(44614,4930),(44615,4930),(44616,4930),(44617,4930),(44618,4931),(44619,4931),(44620,4931),(44621,4931),(44622,4932),(44623,4932),(44624,4932),(44625,4932),(44626,4933),(44627,4933),(44628,4933),(44629,4933),(44630,4934),(44631,4934),(44632,4934),(44633,4934),(44634,4935),(44635,4935),(44636,4935),(44637,4935),(44638,4936),(44639,4936),(44640,4936),(44641,4936),(44642,4937),(44643,4937),(44644,4937),(44645,4937),(44646,4938),(44647,4938),(44648,4938),(44649,4938),(44650,4939),(44651,4939),(44652,4939),(44653,4939),(44654,4940),(44655,4940),(44656,4940),(44657,4940),(44658,4941),(44659,4941),(44660,4941),(44661,4941),(44662,4942),(44663,4942),(44664,4942),(44665,4942),(44666,4943),(44667,4943),(44668,4943),(44669,4943),(44670,4944),(44671,4944),(44672,4944),(44673,4944),(44674,4945),(44675,4945),(44676,4945),(44677,4945),(44678,4946),(44679,4946),(44680,4946),(44681,4946),(44682,4947),(44683,4947),(44684,4947),(44685,4947),(44686,4948),(44687,4948),(44688,4948),(44689,4948),(44690,4949),(44691,4949),(44692,4949),(44693,4949),(44694,4950),(44695,4950),(44696,4950),(44697,4950),(44698,4951),(44699,4951),(44700,4951),(44701,4951),(44702,4952),(44703,4952),(44704,4952),(44705,4952),(44706,4953),(44707,4953),(44708,4953),(44709,4953),(44710,4954),(44711,4954),(44712,4954),(44713,4954),(44714,4955),(44715,4955),(44716,4955),(44717,4955),(44718,4956),(44719,4956),(44720,4956),(44721,4956),(44722,4957),(44723,4957),(44724,4957),(44725,4957),(44726,4958),(44727,4958),(44728,4958),(44729,4958),(44730,4959),(44731,4959),(44732,4959),(44733,4959),(44734,4960),(44735,4960),(44736,4960),(44737,4960),(44738,4961),(44739,4961),(44740,4961),(44741,4961),(44742,4962),(44743,4962),(44744,4962),(44745,4962),(44746,4963),(44747,4963),(44748,4963),(44749,4963),(44750,4964),(44751,4964),(44752,4964),(44753,4964),(44754,4965),(44755,4965),(44756,4965),(44757,4965),(44758,4966),(44759,4966),(44760,4966),(44761,4966),(44762,4967),(44763,4967),(44764,4967),(44765,4967),(44766,4968),(44767,4968),(44768,4968),(44769,4968),(44770,4969),(44771,4969),(44772,4969),(44773,4969),(44774,4970),(44775,4970),(44776,4970),(44777,4970),(44778,4971),(44779,4971),(44780,4971),(44781,4971),(44782,4972),(44783,4972),(44784,4972),(44785,4972),(44786,4973),(44787,4973),(44788,4973),(44789,4973),(44790,4974),(44791,4974),(44792,4974),(44793,4974),(44794,4975),(44795,4975),(44796,4975),(44797,4975),(44798,4976),(44799,4976),(44800,4976),(44801,4976),(44802,4977),(44803,4977),(44804,4977),(44805,4977),(44806,4978),(44807,4978),(44808,4978),(44809,4978),(44810,4979),(44811,4979),(44812,4979),(44813,4979),(44814,4980),(44815,4981),(44816,4982),(44817,4983),(44818,4984),(44819,4985),(44820,4986),(44821,4987),(44822,4988),(44823,4989),(44824,4990),(44825,4991),(44826,4992),(44827,4993),(44828,4994),(44829,4995),(44830,4996),(44831,4997),(44832,4998),(44833,4999),(44834,5000),(44835,5001),(44836,5002),(44837,5003),(44838,5004),(44839,5005),(44840,5006),(44841,5007),(44842,5008),(44843,5009),(44844,5010),(44845,5011),(44846,5012),(44847,5013),(44848,5014),(44849,5015),(44850,5016),(44851,5017),(44852,5018),(44853,5019),(44854,5020),(44855,5021),(44856,5022),(44857,5023),(44858,5024),(44859,5025),(44860,5026),(44861,5027),(44862,5028),(44863,5029),(44864,5030),(44865,5031),(44866,5032),(44867,5033),(44868,5034),(44869,5035),(44870,5036),(44871,5037),(44872,5038),(44873,5039),(44874,5040),(44875,5041),(44876,5042),(44877,5043),(44878,5044),(44879,5045),(44880,5046),(44881,5047),(44882,5048),(44883,5049),(44884,5050),(44885,5051),(44886,5052),(44887,5053),(44888,5054),(44889,5055),(44890,5056),(44891,5057),(44892,5058),(44893,5059),(44894,5060),(44895,5061),(44896,5062),(44897,5063),(44898,5064),(44899,5065),(44900,5066),(44901,5067),(44902,5068),(44903,5069),(44904,5070),(44905,5071),(44906,5072),(44907,5073),(44908,5074),(44909,5075),(44910,5076),(44911,5077),(44912,5078),(44913,5079),(44914,4980),(44915,4981),(44916,4982),(44917,4983),(44918,4984),(44919,4985),(44920,4986),(44921,4987),(44922,4988),(44923,4989),(44924,4990),(44925,4991),(44926,4992),(44927,4993),(44928,4994),(44929,4995),(44930,4996),(44931,4997),(44932,4998),(44933,4999),(44934,5000),(44935,5001),(44936,5002),(44937,5003),(44938,5004),(44939,5005),(44940,5006),(44941,5007),(44942,5008),(44943,5009),(44944,5010),(44945,5011),(44946,5012),(44947,5013),(44948,5014),(44949,5015),(44950,5016),(44951,5017),(44952,5018),(44953,5019),(44954,5020),(44955,5021),(44956,5022),(44957,5023),(44958,5024),(44959,5025),(44960,5026),(44961,5027),(44962,5028),(44963,5029),(44964,5030),(44965,5031),(44966,5032),(44967,5033),(44968,5034),(44969,5035),(44970,5036),(44971,5037),(44972,5038),(44973,5039),(44974,5040),(44975,5041),(44976,5042),(44977,5043),(44978,5044),(44979,5045),(44980,5046),(44981,5047),(44982,5048),(44983,5049),(44984,5050),(44985,5051),(44986,5052),(44987,5053),(44988,5054),(44989,5055),(44990,5056),(44991,5057),(44992,5058),(44993,5059),(44994,5060),(44995,5061),(44996,5062),(44997,5063),(44998,5064),(44999,5065),(45000,5066),(45001,5067),(45002,5068),(45003,5069),(45004,5070),(45005,5071),(45006,5072),(45007,5073),(45008,5074),(45009,5075),(45010,5076),(45011,5077),(45012,5078),(45013,5079),(45014,4980),(45015,4980),(45016,4980),(45017,4981),(45018,4981),(45019,4981),(45020,4982),(45021,4982),(45022,4982),(45023,4983),(45024,4983),(45025,4983),(45026,4984),(45027,4984),(45028,4984),(45029,4985),(45030,4985),(45031,4985),(45032,4986),(45033,4986),(45034,4986),(45035,4987),(45036,4987),(45037,4987),(45038,4988),(45039,4988),(45040,4988),(45041,4989),(45042,4989),(45043,4989),(45044,4990),(45045,4990),(45046,4990),(45047,4991),(45048,4991),(45049,4991),(45050,4992),(45051,4992),(45052,4992),(45053,4993),(45054,4993),(45055,4993),(45056,4994),(45057,4994),(45058,4994),(45059,4995),(45060,4995),(45061,4995),(45062,4996),(45063,4996),(45064,4996),(45065,4997),(45066,4997),(45067,4997),(45068,4998),(45069,4998),(45070,4998),(45071,4999),(45072,4999),(45073,4999),(45074,5000),(45075,5000),(45076,5000),(45077,5001),(45078,5001),(45079,5001),(45080,5002),(45081,5002),(45082,5002),(45083,5003),(45084,5003),(45085,5003),(45086,5004),(45087,5004),(45088,5004),(45089,5005),(45090,5005),(45091,5005),(45092,5006),(45093,5006),(45094,5006),(45095,5007),(45096,5007),(45097,5007),(45098,5008),(45099,5008),(45100,5008),(45101,5009),(45102,5009),(45103,5009),(45104,5010),(45105,5010),(45106,5010),(45107,5011),(45108,5011),(45109,5011),(45110,5012),(45111,5012),(45112,5012),(45113,5013),(45114,5013),(45115,5013),(45116,5014),(45117,5014),(45118,5014),(45119,5015),(45120,5015),(45121,5015),(45122,5016),(45123,5016),(45124,5016),(45125,5017),(45126,5017),(45127,5017),(45128,5018),(45129,5018),(45130,5018),(45131,5019),(45132,5019),(45133,5019),(45134,5020),(45135,5020),(45136,5020),(45137,5021),(45138,5021),(45139,5021),(45140,5022),(45141,5022),(45142,5023),(45143,5023),(45144,5023),(45145,5024),(45146,5024),(45147,5024),(45148,5025),(45149,5025),(45150,5025),(45151,5026),(45152,5026),(45153,5026),(45154,5027),(45155,5027),(45156,5027),(45157,5028),(45158,5028),(45159,5028),(45160,5029),(45161,5029),(45162,5029),(45163,5030),(45164,5030),(45165,5030),(45166,5031),(45167,5031),(45168,5031),(45169,5032),(45170,5032),(45171,5032),(45172,5033),(45173,5033),(45174,5033),(45175,5034),(45176,5034),(45177,5034),(45178,5035),(45179,5035),(45180,5035),(45181,5036),(45182,5036),(45183,5036),(45184,5037),(45185,5037),(45186,5037),(45187,5038),(45188,5038),(45189,5038),(45190,5039),(45191,5039),(45192,5039),(45193,5040),(45194,5040),(45195,5040),(45196,5041),(45197,5041),(45198,5041),(45199,5042),(45200,5042),(45201,5042),(45202,5043),(45203,5043),(45204,5043),(45205,5044),(45206,5044),(45207,5044),(45208,5045),(45209,5045),(45210,5045),(45211,5046),(45212,5046),(45213,5046),(45214,5047),(45215,5047),(45216,5047),(45217,5048),(45218,5048),(45219,5048),(45220,5049),(45221,5049),(45222,5049),(45223,5050),(45224,5050),(45225,5050),(45226,5051),(45227,5051),(45228,5051),(45229,5052),(45230,5052),(45231,5052),(45232,5053),(45233,5053),(45234,5053),(45235,5054),(45236,5054),(45237,5054),(45238,5055),(45239,5055),(45240,5055),(45241,5056),(45242,5056),(45243,5056),(45244,5057),(45245,5057),(45246,5057),(45247,5058),(45248,5058),(45249,5058),(45250,5059),(45251,5059),(45252,5059),(45253,5060),(45254,5060),(45255,5060),(45256,5061),(45257,5061),(45258,5061),(45259,5062),(45260,5062),(45261,5062),(45262,5063),(45263,5063),(45264,5063),(45265,5064),(45266,5064),(45267,5064),(45268,5065),(45269,5065),(45270,5065),(45271,5066),(45272,5066),(45273,5066),(45274,5067),(45275,5067),(45276,5067),(45277,5068),(45278,5068),(45279,5068),(45280,5069),(45281,5069),(45282,5069),(45283,5070),(45284,5070),(45285,5070),(45286,5071),(45287,5071),(45288,5071),(45289,5072),(45290,5072),(45291,5072),(45292,5073),(45293,5073),(45294,5073),(45295,5074),(45296,5074),(45297,5074),(45298,5075),(45299,5075),(45300,5075),(45301,5076),(45302,5076),(45303,5076),(45304,5077),(45305,5077),(45306,5077),(45307,5078),(45308,5078),(45309,5078),(45310,5079),(45311,5079),(45312,5079),(45313,4980),(45314,4980),(45315,4980),(45316,4980),(45317,4981),(45318,4981),(45319,4981),(45320,4981),(45321,4982),(45322,4982),(45323,4982),(45324,4982),(45325,4983),(45326,4983),(45327,4983),(45328,4983),(45329,4984),(45330,4984),(45331,4984),(45332,4984),(45333,4985),(45334,4985),(45335,4985),(45336,4985),(45337,4986),(45338,4986),(45339,4986),(45340,4986),(45341,4987),(45342,4987),(45343,4987),(45344,4987),(45345,4988),(45346,4988),(45347,4988),(45348,4988),(45349,4989),(45350,4989),(45351,4989),(45352,4989),(45353,4990),(45354,4990),(45355,4990),(45356,4990),(45357,4991),(45358,4991),(45359,4991),(45360,4991),(45361,4992),(45362,4992),(45363,4992),(45364,4992),(45365,4993),(45366,4993),(45367,4993),(45368,4993),(45369,4994),(45370,4994),(45371,4994),(45372,4994),(45373,4995),(45374,4995),(45375,4995),(45376,4995),(45377,4996),(45378,4996),(45379,4996),(45380,4996),(45381,4997),(45382,4997),(45383,4997),(45384,4997),(45385,4998),(45386,4998),(45387,4998),(45388,4998),(45389,4999),(45390,4999),(45391,4999),(45392,4999),(45393,5000),(45394,5000),(45395,5000),(45396,5000),(45397,5001),(45398,5001),(45399,5001),(45400,5001),(45401,5002),(45402,5002),(45403,5002),(45404,5002),(45405,5003),(45406,5003),(45407,5003),(45408,5003),(45409,5004),(45410,5004),(45411,5004),(45412,5004),(45413,5005),(45414,5005),(45415,5005),(45416,5005),(45417,5006),(45418,5006),(45419,5006),(45420,5006),(45421,5007),(45422,5007),(45423,5007),(45424,5007),(45425,5008),(45426,5008),(45427,5008),(45428,5008),(45429,5009),(45430,5009),(45431,5009),(45432,5009),(45433,5010),(45434,5010),(45435,5010),(45436,5010),(45437,5011),(45438,5011),(45439,5011),(45440,5011),(45441,5012),(45442,5012),(45443,5012),(45444,5012),(45445,5013),(45446,5013),(45447,5013),(45448,5013),(45449,5014),(45450,5014),(45451,5014),(45452,5014),(45453,5015),(45454,5015),(45455,5015),(45456,5015),(45457,5016),(45458,5016),(45459,5016),(45460,5016),(45461,5017),(45462,5017),(45463,5017),(45464,5017),(45465,5018),(45466,5018),(45467,5018),(45468,5018),(45469,5019),(45470,5019),(45471,5019),(45472,5019),(45473,5020),(45474,5020),(45475,5020),(45476,5020),(45477,5021),(45478,5021),(45479,5021),(45480,5021),(45481,5022),(45482,5022),(45483,5022),(45484,5022),(45485,5023),(45486,5023),(45487,5023),(45488,5023),(45489,5024),(45490,5024),(45491,5024),(45492,5024),(45493,5025),(45494,5025),(45495,5025),(45496,5025),(45497,5026),(45498,5026),(45499,5026),(45500,5026),(45501,5027),(45502,5027),(45503,5027),(45504,5027),(45505,5028),(45506,5028),(45507,5028),(45508,5028),(45509,5029),(45510,5029),(45511,5029),(45512,5029),(45513,5030),(45514,5030),(45515,5030),(45516,5030),(45517,5031),(45518,5031),(45519,5031),(45520,5031),(45521,5032),(45522,5032),(45523,5032),(45524,5032),(45525,5033),(45526,5033),(45527,5033),(45528,5033),(45529,5034),(45530,5034),(45531,5034),(45532,5034),(45533,5035),(45534,5035),(45535,5035),(45536,5035),(45537,5036),(45538,5036),(45539,5036),(45540,5036),(45541,5037),(45542,5037),(45543,5037),(45544,5037),(45545,5038),(45546,5038),(45547,5038),(45548,5038),(45549,5039),(45550,5039),(45551,5039),(45552,5039),(45553,5040),(45554,5040),(45555,5040),(45556,5040),(45557,5041),(45558,5041),(45559,5041),(45560,5041),(45561,5042),(45562,5042),(45563,5042),(45564,5042),(45565,5043),(45566,5043),(45567,5043),(45568,5043),(45569,5044),(45570,5044),(45571,5044),(45572,5044),(45573,5045),(45574,5045),(45575,5045),(45576,5045),(45577,5046),(45578,5046),(45579,5046),(45580,5046),(45581,5047),(45582,5047),(45583,5047),(45584,5047),(45585,5048),(45586,5048),(45587,5048),(45588,5048),(45589,5049),(45590,5049),(45591,5049),(45592,5049),(45593,5050),(45594,5050),(45595,5050),(45596,5050),(45597,5051),(45598,5051),(45599,5051),(45600,5051),(45601,5052),(45602,5052),(45603,5052),(45604,5052),(45605,5053),(45606,5053),(45607,5053),(45608,5053),(45609,5054),(45610,5054),(45611,5054),(45612,5054),(45613,5055),(45614,5055),(45615,5055),(45616,5055),(45617,5056),(45618,5056),(45619,5056),(45620,5056),(45621,5057),(45622,5057),(45623,5057),(45624,5057),(45625,5058),(45626,5058),(45627,5058),(45628,5058),(45629,5059),(45630,5059),(45631,5059),(45632,5059),(45633,5060),(45634,5060),(45635,5060),(45636,5060),(45637,5061),(45638,5061),(45639,5061),(45640,5061),(45641,5062),(45642,5062),(45643,5062),(45644,5062),(45645,5063),(45646,5063),(45647,5063),(45648,5063),(45649,5064),(45650,5064),(45651,5064),(45652,5064),(45653,5065),(45654,5065),(45655,5065),(45656,5065),(45657,5066),(45658,5066),(45659,5066),(45660,5066),(45661,5067),(45662,5067),(45663,5067),(45664,5067),(45665,5068),(45666,5068),(45667,5068),(45668,5068),(45669,5069),(45670,5069),(45671,5069),(45672,5069),(45673,5070),(45674,5070),(45675,5070),(45676,5070),(45677,5071),(45678,5071),(45679,5071),(45680,5071),(45681,5072),(45682,5072),(45683,5072),(45684,5072),(45685,5073),(45686,5073),(45687,5073),(45688,5073),(45689,5074),(45690,5074),(45691,5074),(45692,5074),(45693,5075),(45694,5075),(45695,5075),(45696,5075),(45697,5076),(45698,5076),(45699,5076),(45700,5076),(45701,5077),(45702,5077),(45703,5077),(45704,5077),(45705,5078),(45706,5078),(45707,5078),(45708,5078),(45709,5079),(45710,5079),(45711,5079),(45712,5079),(45713,5080),(45714,5081),(45715,5082),(45716,5083),(45717,5084),(45718,5085),(45719,5086),(45720,5087),(45721,5088),(45722,5089),(45723,5090),(45724,5091),(45725,5092),(45726,5093),(45727,5094),(45728,5095),(45729,5096),(45730,5097),(45731,5098),(45732,5099),(45733,5100),(45734,5101),(45735,5102),(45736,5103),(45737,5104),(45738,5105),(45739,5106),(45740,5107),(45741,5108),(45742,5109),(45743,5110),(45744,5111),(45745,5112),(45746,5113),(45747,5114),(45748,5115),(45749,5116),(45750,5117),(45751,5118),(45752,5119),(45753,5120),(45754,5121),(45755,5122),(45756,5123),(45757,5124),(45758,5125),(45759,5126),(45760,5127),(45761,5128),(45762,5129),(45763,5130),(45764,5131),(45765,5132),(45766,5133),(45767,5134),(45768,5135),(45769,5136),(45770,5137),(45771,5138),(45772,5139),(45773,5140),(45774,5141),(45775,5142),(45776,5143),(45777,5144),(45778,5145),(45779,5146),(45780,5147),(45781,5148),(45782,5149),(45783,5150),(45784,5151),(45785,5152),(45786,5153),(45787,5154),(45788,5155),(45789,5156),(45790,5157),(45791,5158),(45792,5159),(45793,5160),(45794,5161),(45795,5162),(45796,5163),(45797,5164),(45798,5165),(45799,5166),(45800,5167),(45801,5168),(45802,5169),(45803,5170),(45804,5171),(45805,5172),(45806,5173),(45807,5174),(45808,5175),(45809,5176),(45810,5177),(45811,5178),(45812,5179),(45813,5080),(45814,5081),(45815,5082),(45816,5083),(45817,5084),(45818,5085),(45819,5086),(45820,5087),(45821,5088),(45822,5089),(45823,5090),(45824,5091),(45825,5092),(45826,5093),(45827,5094),(45828,5095),(45829,5096),(45830,5097),(45831,5098),(45832,5099),(45833,5100),(45834,5101),(45835,5102),(45836,5103),(45837,5104),(45838,5105),(45839,5106),(45840,5107),(45841,5108),(45842,5109),(45843,5110),(45844,5111),(45845,5112),(45846,5113),(45847,5114),(45848,5115),(45849,5116),(45850,5117),(45851,5118),(45852,5119),(45853,5120),(45854,5121),(45855,5122),(45856,5123),(45857,5124),(45858,5125),(45859,5126),(45860,5127),(45861,5128),(45862,5129),(45863,5130),(45864,5131),(45865,5132),(45866,5133),(45867,5134),(45868,5135),(45869,5136),(45870,5137),(45871,5138),(45872,5139),(45873,5140),(45874,5141),(45875,5142),(45876,5143),(45877,5144),(45878,5145),(45879,5146),(45880,5147),(45881,5148),(45882,5149),(45883,5150),(45884,5151),(45885,5152),(45886,5153),(45887,5154),(45888,5155),(45889,5156),(45890,5157),(45891,5158),(45892,5159),(45893,5160),(45894,5161),(45895,5162),(45896,5163),(45897,5164),(45898,5165),(45899,5166),(45900,5167),(45901,5168),(45902,5169),(45903,5170),(45904,5171),(45905,5172),(45906,5173),(45907,5174),(45908,5175),(45909,5176),(45910,5177),(45911,5178),(45912,5179),(45913,5080),(45914,5080),(45915,5080),(45916,5081),(45917,5081),(45918,5081),(45919,5082),(45920,5082),(45921,5082),(45922,5083),(45923,5083),(45924,5083),(45925,5084),(45926,5084),(45927,5084),(45928,5085),(45929,5085),(45930,5085),(45931,5086),(45932,5086),(45933,5086),(45934,5087),(45935,5087),(45936,5087),(45937,5088),(45938,5088),(45939,5088),(45940,5089),(45941,5089),(45942,5089),(45943,5090),(45944,5090),(45945,5090),(45946,5091),(45947,5091),(45948,5091),(45949,5092),(45950,5092),(45951,5092),(45952,5093),(45953,5093),(45954,5093),(45955,5094),(45956,5094),(45957,5094),(45958,5095),(45959,5095),(45960,5095),(45961,5096),(45962,5096),(45963,5096),(45964,5097),(45965,5097),(45966,5097),(45967,5098),(45968,5098),(45969,5098),(45970,5099),(45971,5099),(45972,5099),(45973,5100),(45974,5100),(45975,5100),(45976,5101),(45977,5101),(45978,5101),(45979,5102),(45980,5102),(45981,5102),(45982,5103),(45983,5103),(45984,5103),(45985,5104),(45986,5104),(45987,5104),(45988,5105),(45989,5105),(45990,5105),(45991,5106),(45992,5106),(45993,5106),(45994,5107),(45995,5107),(45996,5107),(45997,5108),(45998,5108),(45999,5108),(46000,5109),(46001,5109),(46002,5109),(46003,5110),(46004,5110),(46005,5110),(46006,5111),(46007,5111),(46008,5111),(46009,5112),(46010,5112),(46011,5112),(46012,5113),(46013,5113),(46014,5113),(46015,5114),(46016,5114),(46017,5114),(46018,5115),(46019,5115),(46020,5115),(46021,5116),(46022,5116),(46023,5116),(46024,5117),(46025,5117),(46026,5117),(46027,5118),(46028,5118),(46029,5118),(46030,5119),(46031,5119),(46032,5119),(46033,5120),(46034,5120),(46035,5120),(46036,5121),(46037,5121),(46038,5121),(46039,5122),(46040,5122),(46041,5122),(46042,5123),(46043,5123),(46044,5123),(46045,5124),(46046,5124),(46047,5124),(46048,5125),(46049,5125),(46050,5125),(46051,5126),(46052,5126),(46053,5126),(46054,5127),(46055,5127),(46056,5127),(46057,5128),(46058,5128),(46059,5128),(46060,5129),(46061,5129),(46062,5129),(46063,5130),(46064,5130),(46065,5130),(46066,5131),(46067,5131),(46068,5131),(46069,5132),(46070,5132),(46071,5132),(46072,5133),(46073,5133),(46074,5133),(46075,5134),(46076,5134),(46077,5134),(46078,5135),(46079,5135),(46080,5135),(46081,5136),(46082,5136),(46083,5136),(46084,5137),(46085,5137),(46086,5137),(46087,5138),(46088,5138),(46089,5138),(46090,5139),(46091,5139),(46092,5139),(46093,5140),(46094,5140),(46095,5140),(46096,5141),(46097,5141),(46098,5141),(46099,5142),(46100,5142),(46101,5142),(46102,5143),(46103,5143),(46104,5143),(46105,5144),(46106,5144),(46107,5144),(46108,5145),(46109,5145),(46110,5145),(46111,5146),(46112,5146),(46113,5146),(46114,5147),(46115,5147),(46116,5147),(46117,5148),(46118,5148),(46119,5148),(46120,5149),(46121,5149),(46122,5149),(46123,5150),(46124,5150),(46125,5150),(46126,5151),(46127,5151),(46128,5151),(46129,5152),(46130,5152),(46131,5152),(46132,5153),(46133,5153),(46134,5153),(46135,5154),(46136,5154),(46137,5154),(46138,5155),(46139,5155),(46140,5155),(46141,5156),(46142,5156),(46143,5156),(46144,5157),(46145,5157),(46146,5157),(46147,5158),(46148,5158),(46149,5158),(46150,5159),(46151,5159),(46152,5159),(46153,5160),(46154,5160),(46155,5160),(46156,5161),(46157,5161),(46158,5161),(46159,5162),(46160,5162),(46161,5162),(46162,5163),(46163,5163),(46164,5163),(46165,5164),(46166,5164),(46167,5164),(46168,5165),(46169,5165),(46170,5165),(46171,5166),(46172,5166),(46173,5166),(46174,5167),(46175,5167),(46176,5167),(46177,5168),(46178,5168),(46179,5168),(46180,5169),(46181,5169),(46182,5169),(46183,5170),(46184,5170),(46185,5170),(46186,5171),(46187,5171),(46188,5172),(46189,5172),(46190,5172),(46191,5173),(46192,5173),(46193,5173),(46194,5174),(46195,5174),(46196,5174),(46197,5175),(46198,5175),(46199,5175),(46200,5176),(46201,5176),(46202,5176),(46203,5177),(46204,5177),(46205,5177),(46206,5178),(46207,5178),(46208,5178),(46209,5179),(46210,5179),(46211,5179),(46212,5080),(46213,5080),(46214,5080),(46215,5080),(46216,5081),(46217,5081),(46218,5081),(46219,5081),(46220,5082),(46221,5082),(46222,5082),(46223,5082),(46224,5083),(46225,5083),(46226,5083),(46227,5083),(46228,5084),(46229,5084),(46230,5084),(46231,5084),(46232,5085),(46233,5085),(46234,5085),(46235,5085),(46236,5086),(46237,5086),(46238,5086),(46239,5086),(46240,5087),(46241,5087),(46242,5087),(46243,5087),(46244,5088),(46245,5088),(46246,5088),(46247,5088),(46248,5089),(46249,5089),(46250,5089),(46251,5089),(46252,5090),(46253,5090),(46254,5090),(46255,5090),(46256,5091),(46257,5091),(46258,5091),(46259,5091),(46260,5092),(46261,5092),(46262,5092),(46263,5092),(46264,5093),(46265,5093),(46266,5093),(46267,5093),(46268,5094),(46269,5094),(46270,5094),(46271,5094),(46272,5095),(46273,5095),(46274,5095),(46275,5095),(46276,5096),(46277,5096),(46278,5096),(46279,5096),(46280,5097),(46281,5097),(46282,5097),(46283,5097),(46284,5098),(46285,5098),(46286,5098),(46287,5098),(46288,5099),(46289,5099),(46290,5099),(46291,5099),(46292,5100),(46293,5100),(46294,5100),(46295,5100),(46296,5101),(46297,5101),(46298,5101),(46299,5101),(46300,5102),(46301,5102),(46302,5102),(46303,5102),(46304,5103),(46305,5103),(46306,5103),(46307,5103),(46308,5104),(46309,5104),(46310,5104),(46311,5104),(46312,5105),(46313,5105),(46314,5105),(46315,5105),(46316,5106),(46317,5106),(46318,5106),(46319,5106),(46320,5107),(46321,5107),(46322,5107),(46323,5107),(46324,5108),(46325,5108),(46326,5108),(46327,5108),(46328,5109),(46329,5109),(46330,5109),(46331,5109),(46332,5110),(46333,5110),(46334,5110),(46335,5110),(46336,5111),(46337,5111),(46338,5111),(46339,5111),(46340,5112),(46341,5112),(46342,5112),(46343,5112),(46344,5113),(46345,5113),(46346,5113),(46347,5113),(46348,5114),(46349,5114),(46350,5114),(46351,5114),(46352,5115),(46353,5115),(46354,5115),(46355,5115),(46356,5116),(46357,5116),(46358,5116),(46359,5116),(46360,5117),(46361,5117),(46362,5117),(46363,5117),(46364,5118),(46365,5118),(46366,5118),(46367,5118),(46368,5119),(46369,5119),(46370,5119),(46371,5119),(46372,5120),(46373,5120),(46374,5120),(46375,5120),(46376,5121),(46377,5121),(46378,5121),(46379,5121),(46380,5122),(46381,5122),(46382,5122),(46383,5122),(46384,5123),(46385,5123),(46386,5123),(46387,5123),(46388,5124),(46389,5124),(46390,5124),(46391,5124),(46392,5125),(46393,5125),(46394,5125),(46395,5125),(46396,5126),(46397,5126),(46398,5126),(46399,5126),(46400,5127),(46401,5127),(46402,5127),(46403,5127),(46404,5128),(46405,5128),(46406,5128),(46407,5128),(46408,5129),(46409,5129),(46410,5129),(46411,5129),(46412,5130),(46413,5130),(46414,5130),(46415,5130),(46416,5131),(46417,5131),(46418,5131),(46419,5131),(46420,5132),(46421,5132),(46422,5132),(46423,5132),(46424,5133),(46425,5133),(46426,5133),(46427,5133),(46428,5134),(46429,5134),(46430,5134),(46431,5134),(46432,5135),(46433,5135),(46434,5135),(46435,5135),(46436,5136),(46437,5136),(46438,5136),(46439,5136),(46440,5137),(46441,5137),(46442,5137),(46443,5137),(46444,5138),(46445,5138),(46446,5138),(46447,5138),(46448,5139),(46449,5139),(46450,5139),(46451,5139),(46452,5140),(46453,5140),(46454,5140),(46455,5140),(46456,5141),(46457,5141),(46458,5141),(46459,5141),(46460,5142),(46461,5142),(46462,5142),(46463,5142),(46464,5143),(46465,5143),(46466,5143),(46467,5143),(46468,5144),(46469,5144),(46470,5144),(46471,5144),(46472,5145),(46473,5145),(46474,5145),(46475,5145),(46476,5146),(46477,5146),(46478,5146),(46479,5146),(46480,5147),(46481,5147),(46482,5147),(46483,5147),(46484,5148),(46485,5148),(46486,5148),(46487,5148),(46488,5149),(46489,5149),(46490,5149),(46491,5149),(46492,5150),(46493,5150),(46494,5150),(46495,5150),(46496,5151),(46497,5151),(46498,5151),(46499,5151),(46500,5152),(46501,5152),(46502,5152),(46503,5152),(46504,5153),(46505,5153),(46506,5153),(46507,5153),(46508,5154),(46509,5154),(46510,5154),(46511,5154),(46512,5155),(46513,5155),(46514,5155),(46515,5155),(46516,5156),(46517,5156),(46518,5156),(46519,5156),(46520,5157),(46521,5157),(46522,5157),(46523,5157),(46524,5158),(46525,5158),(46526,5158),(46527,5158),(46528,5159),(46529,5159),(46530,5159),(46531,5159),(46532,5160),(46533,5160),(46534,5160),(46535,5160),(46536,5161),(46537,5161),(46538,5161),(46539,5161),(46540,5162),(46541,5162),(46542,5162),(46543,5162),(46544,5163),(46545,5163),(46546,5163),(46547,5163),(46548,5164),(46549,5164),(46550,5164),(46551,5164),(46552,5165),(46553,5165),(46554,5165),(46555,5165),(46556,5166),(46557,5166),(46558,5166),(46559,5166),(46560,5167),(46561,5167),(46562,5167),(46563,5167),(46564,5168),(46565,5168),(46566,5168),(46567,5168),(46568,5169),(46569,5169),(46570,5169),(46571,5169),(46572,5170),(46573,5170),(46574,5170),(46575,5170),(46576,5171),(46577,5171),(46578,5171),(46579,5171),(46580,5172),(46581,5172),(46582,5172),(46583,5172),(46584,5173),(46585,5173),(46586,5173),(46587,5173),(46588,5174),(46589,5174),(46590,5174),(46591,5174),(46592,5175),(46593,5175),(46594,5175),(46595,5175),(46596,5176),(46597,5176),(46598,5176),(46599,5176),(46600,5177),(46601,5177),(46602,5177),(46603,5177),(46604,5178),(46605,5178),(46606,5178),(46607,5178),(46608,5179),(46609,5179),(46610,5179),(46611,5179),(46612,5180),(46613,5181),(46614,5182),(46615,5183),(46616,5184),(46617,5185),(46618,5186),(46619,5187),(46620,5188),(46621,5189),(46622,5190),(46623,5191),(46624,5192),(46625,5193),(46626,5194),(46627,5195),(46628,5196),(46629,5197),(46630,5198),(46631,5199),(46632,5200),(46633,5201),(46634,5202),(46635,5203),(46636,5204),(46637,5205),(46638,5206),(46639,5207),(46640,5208),(46641,5209),(46642,5210),(46643,5211),(46644,5212),(46645,5213),(46646,5214),(46647,5215),(46648,5216),(46649,5217),(46650,5218),(46651,5219),(46652,5220),(46653,5221),(46654,5222),(46655,5223),(46656,5224),(46657,5225),(46658,5226),(46659,5227),(46660,5228),(46661,5229),(46662,5230),(46663,5231),(46664,5232),(46665,5233),(46666,5234),(46667,5235),(46668,5236),(46669,5237),(46670,5238),(46671,5239),(46672,5240),(46673,5241),(46674,5242),(46675,5243),(46676,5244),(46677,5245),(46678,5246),(46679,5247),(46680,5248),(46681,5249),(46682,5250),(46683,5251),(46684,5252),(46685,5253),(46686,5254),(46687,5255),(46688,5256),(46689,5257),(46690,5258),(46691,5259),(46692,5260),(46693,5261),(46694,5262),(46695,5263),(46696,5264),(46697,5265),(46698,5266),(46699,5267),(46700,5268),(46701,5269),(46702,5270),(46703,5180),(46704,5181),(46705,5182),(46706,5183),(46707,5184),(46708,5185),(46709,5186),(46710,5187),(46711,5188),(46712,5189),(46713,5190),(46714,5191),(46715,5192),(46716,5193),(46717,5194),(46718,5195),(46719,5196),(46720,5197),(46721,5198),(46722,5199),(46723,5200),(46724,5201),(46725,5202),(46726,5203),(46727,5204),(46728,5205),(46729,5206),(46730,5207),(46731,5208),(46732,5209),(46733,5210),(46734,5211),(46735,5212),(46736,5213),(46737,5214),(46738,5215),(46739,5216),(46740,5217),(46741,5218),(46742,5219),(46743,5220),(46744,5221),(46745,5222),(46746,5223),(46747,5224),(46748,5225),(46749,5226),(46750,5227),(46751,5228),(46752,5229),(46753,5230),(46754,5231),(46755,5232),(46756,5233),(46757,5234),(46758,5235),(46759,5236),(46760,5237),(46761,5238),(46762,5239),(46763,5240),(46764,5241),(46765,5242),(46766,5243),(46767,5244),(46768,5245),(46769,5246),(46770,5247),(46771,5248),(46772,5249),(46773,5250),(46774,5251),(46775,5252),(46776,5253),(46777,5254),(46778,5255),(46779,5256),(46780,5257),(46781,5258),(46782,5259),(46783,5260),(46784,5261),(46785,5262),(46786,5263),(46787,5264),(46788,5265),(46789,5266),(46790,5267),(46791,5268),(46792,5269),(46793,5270),(46794,5180),(46795,5180),(46796,5180),(46797,5181),(46798,5181),(46799,5181),(46800,5182),(46801,5182),(46802,5182),(46803,5183),(46804,5183),(46805,5183),(46806,5184),(46807,5184),(46808,5184),(46809,5185),(46810,5185),(46811,5185),(46812,5186),(46813,5186),(46814,5186),(46815,5187),(46816,5187),(46817,5187),(46818,5188),(46819,5188),(46820,5188),(46821,5189),(46822,5189),(46823,5189),(46824,5190),(46825,5190),(46826,5190),(46827,5191),(46828,5191),(46829,5191),(46830,5192),(46831,5192),(46832,5192),(46833,5193),(46834,5193),(46835,5193),(46836,5194),(46837,5194),(46838,5194),(46839,5195),(46840,5195),(46841,5195),(46842,5196),(46843,5196),(46844,5196),(46845,5197),(46846,5197),(46847,5197),(46848,5198),(46849,5198),(46850,5198),(46851,5199),(46852,5199),(46853,5200),(46854,5200),(46855,5200),(46856,5201),(46857,5201),(46858,5201),(46859,5202),(46860,5202),(46861,5202),(46862,5203),(46863,5203),(46864,5203),(46865,5204),(46866,5204),(46867,5204),(46868,5205),(46869,5205),(46870,5205),(46871,5206),(46872,5206),(46873,5206),(46874,5207),(46875,5207),(46876,5207),(46877,5208),(46878,5208),(46879,5208),(46880,5209),(46881,5209),(46882,5209),(46883,5210),(46884,5210),(46885,5210),(46886,5211),(46887,5211),(46888,5211),(46889,5212),(46890,5212),(46891,5212),(46892,5213),(46893,5213),(46894,5213),(46895,5214),(46896,5214),(46897,5214),(46898,5215),(46899,5215),(46900,5215),(46901,5216),(46902,5216),(46903,5216),(46904,5217),(46905,5217),(46906,5217),(46907,5218),(46908,5218),(46909,5218),(46910,5219),(46911,5219),(46912,5219),(46913,5220),(46914,5220),(46915,5220),(46916,5221),(46917,5221),(46918,5221),(46919,5222),(46920,5222),(46921,5222),(46922,5223),(46923,5223),(46924,5223),(46925,5224),(46926,5224),(46927,5224),(46928,5225),(46929,5225),(46930,5225),(46931,5226),(46932,5226),(46933,5226),(46934,5227),(46935,5227),(46936,5227),(46937,5228),(46938,5228),(46939,5228),(46940,5229),(46941,5229),(46942,5229),(46943,5230),(46944,5230),(46945,5230),(46946,5231),(46947,5231),(46948,5231),(46949,5232),(46950,5232),(46951,5232),(46952,5233),(46953,5233),(46954,5233),(46955,5234),(46956,5234),(46957,5234),(46958,5235),(46959,5235),(46960,5235),(46961,5236),(46962,5236),(46963,5236),(46964,5237),(46965,5237),(46966,5237),(46967,5238),(46968,5238),(46969,5238),(46970,5239),(46971,5239),(46972,5239),(46973,5240),(46974,5240),(46975,5240),(46976,5241),(46977,5241),(46978,5241),(46979,5242),(46980,5242),(46981,5242),(46982,5243),(46983,5243),(46984,5243),(46985,5244),(46986,5244),(46987,5244),(46988,5245),(46989,5245),(46990,5245),(46991,5246),(46992,5246),(46993,5246),(46994,5247),(46995,5247),(46996,5247),(46997,5248),(46998,5248),(46999,5248),(47000,5249),(47001,5249),(47002,5249),(47003,5250),(47004,5250),(47005,5250),(47006,5251),(47007,5251),(47008,5251),(47009,5252),(47010,5252),(47011,5252),(47012,5253),(47013,5253),(47014,5253),(47015,5254),(47016,5254),(47017,5254),(47018,5255),(47019,5255),(47020,5255),(47021,5256),(47022,5256),(47023,5256),(47024,5257),(47025,5257),(47026,5257),(47027,5258),(47028,5258),(47029,5258),(47030,5259),(47031,5259),(47032,5259),(47033,5260),(47034,5260),(47035,5260),(47036,5261),(47037,5261),(47038,5261),(47039,5262),(47040,5262),(47041,5262),(47042,5263),(47043,5263),(47044,5263),(47045,5264),(47046,5264),(47047,5264),(47048,5265),(47049,5265),(47050,5265),(47051,5266),(47052,5266),(47053,5266),(47054,5267),(47055,5267),(47056,5267),(47057,5268),(47058,5268),(47059,5268),(47060,5269),(47061,5269),(47062,5269),(47063,5270),(47064,5270),(47065,5270),(47066,5180),(47067,5180),(47068,5180),(47069,5180),(47070,5181),(47071,5181),(47072,5181),(47073,5181),(47074,5182),(47075,5182),(47076,5182),(47077,5182),(47078,5183),(47079,5183),(47080,5183),(47081,5183),(47082,5184),(47083,5184),(47084,5184),(47085,5184),(47086,5185),(47087,5185),(47088,5185),(47089,5185),(47090,5186),(47091,5186),(47092,5186),(47093,5186),(47094,5187),(47095,5187),(47096,5187),(47097,5187),(47098,5188),(47099,5188),(47100,5188),(47101,5188),(47102,5189),(47103,5189),(47104,5189),(47105,5189),(47106,5190),(47107,5190),(47108,5190),(47109,5190),(47110,5191),(47111,5191),(47112,5191),(47113,5191),(47114,5192),(47115,5192),(47116,5192),(47117,5192),(47118,5193),(47119,5193),(47120,5193),(47121,5193),(47122,5194),(47123,5194),(47124,5194),(47125,5194),(47126,5195),(47127,5195),(47128,5195),(47129,5195),(47130,5196),(47131,5196),(47132,5196),(47133,5196),(47134,5197),(47135,5197),(47136,5197),(47137,5197),(47138,5198),(47139,5198),(47140,5198),(47141,5198),(47142,5199),(47143,5199),(47144,5199),(47145,5199),(47146,5200),(47147,5200),(47148,5200),(47149,5200),(47150,5201),(47151,5201),(47152,5201),(47153,5201),(47154,5202),(47155,5202),(47156,5202),(47157,5202),(47158,5203),(47159,5203),(47160,5203),(47161,5203),(47162,5204),(47163,5204),(47164,5204),(47165,5204),(47166,5205),(47167,5205),(47168,5205),(47169,5205),(47170,5206),(47171,5206),(47172,5206),(47173,5206),(47174,5207),(47175,5207),(47176,5207),(47177,5207),(47178,5208),(47179,5208),(47180,5208),(47181,5208),(47182,5209),(47183,5209),(47184,5209),(47185,5209),(47186,5210),(47187,5210),(47188,5210),(47189,5210),(47190,5211),(47191,5211),(47192,5211),(47193,5211),(47194,5212),(47195,5212),(47196,5212),(47197,5212),(47198,5213),(47199,5213),(47200,5213),(47201,5213),(47202,5214),(47203,5214),(47204,5214),(47205,5214),(47206,5215),(47207,5215),(47208,5215),(47209,5215),(47210,5216),(47211,5216),(47212,5216),(47213,5216),(47214,5217),(47215,5217),(47216,5217),(47217,5217),(47218,5218),(47219,5218),(47220,5218),(47221,5218),(47222,5219),(47223,5219),(47224,5219),(47225,5219),(47226,5220),(47227,5220),(47228,5220),(47229,5220),(47230,5221),(47231,5221),(47232,5221),(47233,5221),(47234,5222),(47235,5222),(47236,5222),(47237,5222),(47238,5223),(47239,5223),(47240,5223),(47241,5223),(47242,5224),(47243,5224),(47244,5224),(47245,5224),(47246,5225),(47247,5225),(47248,5225),(47249,5225),(47250,5226),(47251,5226),(47252,5226),(47253,5226),(47254,5227),(47255,5227),(47256,5227),(47257,5227),(47258,5228),(47259,5228),(47260,5228),(47261,5228),(47262,5229),(47263,5229),(47264,5229),(47265,5229),(47266,5230),(47267,5230),(47268,5230),(47269,5230),(47270,5231),(47271,5231),(47272,5231),(47273,5231),(47274,5232),(47275,5232),(47276,5232),(47277,5232),(47278,5233),(47279,5233),(47280,5233),(47281,5233),(47282,5234),(47283,5234),(47284,5234),(47285,5234),(47286,5235),(47287,5235),(47288,5235),(47289,5235),(47290,5236),(47291,5236),(47292,5236),(47293,5236),(47294,5237),(47295,5237),(47296,5237),(47297,5237),(47298,5238),(47299,5238),(47300,5238),(47301,5238),(47302,5239),(47303,5239),(47304,5239),(47305,5239),(47306,5240),(47307,5240),(47308,5240),(47309,5240),(47310,5241),(47311,5241),(47312,5241),(47313,5241),(47314,5242),(47315,5242),(47316,5242),(47317,5242),(47318,5243),(47319,5243),(47320,5243),(47321,5243),(47322,5244),(47323,5244),(47324,5244),(47325,5244),(47326,5245),(47327,5245),(47328,5245),(47329,5245),(47330,5246),(47331,5246),(47332,5246),(47333,5246),(47334,5247),(47335,5247),(47336,5247),(47337,5247),(47338,5248),(47339,5248),(47340,5248),(47341,5248),(47342,5249),(47343,5249),(47344,5249),(47345,5249),(47346,5250),(47347,5250),(47348,5250),(47349,5250),(47350,5251),(47351,5251),(47352,5251),(47353,5251),(47354,5252),(47355,5252),(47356,5252),(47357,5252),(47358,5253),(47359,5253),(47360,5253),(47361,5253),(47362,5254),(47363,5254),(47364,5254),(47365,5254),(47366,5255),(47367,5255),(47368,5255),(47369,5255),(47370,5256),(47371,5256),(47372,5256),(47373,5256),(47374,5257),(47375,5257),(47376,5257),(47377,5257),(47378,5258),(47379,5258),(47380,5258),(47381,5258),(47382,5259),(47383,5259),(47384,5259),(47385,5259),(47386,5260),(47387,5260),(47388,5260),(47389,5260),(47390,5261),(47391,5261),(47392,5261),(47393,5261),(47394,5262),(47395,5262),(47396,5262),(47397,5262),(47398,5263),(47399,5263),(47400,5263),(47401,5263),(47402,5264),(47403,5264),(47404,5264),(47405,5264),(47406,5265),(47407,5265),(47408,5265),(47409,5265),(47410,5266),(47411,5266),(47412,5266),(47413,5266),(47414,5267),(47415,5267),(47416,5267),(47417,5267),(47418,5268),(47419,5268),(47420,5268),(47421,5268),(47422,5269),(47423,5269),(47424,5269),(47425,5269),(47426,5270),(47427,5270),(47428,5270),(47429,5270),(47430,5271),(47431,5272),(47432,5273),(47433,5274),(47434,5275),(47435,5276),(47436,5277),(47437,5278),(47438,5279),(47439,5280),(47440,5281),(47441,5282),(47442,5283),(47443,5284),(47444,5285),(47445,5286),(47446,5287),(47447,5288),(47448,5289),(47449,5290),(47450,5291),(47451,5292),(47452,5293),(47453,5294),(47454,5295),(47455,5296),(47456,5297),(47457,5298),(47458,5299),(47459,5300),(47460,5301),(47461,5302),(47462,5303),(47463,5304),(47464,5305),(47465,5306),(47466,5307),(47467,5308),(47468,5309),(47469,5310),(47470,5311),(47471,5312),(47472,5313),(47473,5314),(47474,5315),(47475,5316),(47476,5317),(47477,5318),(47478,5319),(47479,5320),(47480,5321),(47481,5322),(47482,5323),(47483,5324),(47484,5325),(47485,5326),(47486,5327),(47487,5328),(47488,5329),(47489,5330),(47490,5331),(47491,5332),(47492,5333),(47493,5334),(47494,5335),(47495,5336),(47496,5337),(47497,5338),(47498,5339),(47499,5340),(47500,5341),(47501,5342),(47502,5343),(47503,5344),(47504,5345),(47505,5346),(47506,5347),(47507,5348),(47508,5349),(47509,5350),(47510,5351),(47511,5352),(47512,5353),(47513,5354),(47514,5355),(47515,5356),(47516,5357),(47517,5358),(47518,5359),(47519,5271),(47520,5272),(47521,5273),(47522,5274),(47523,5275),(47524,5276),(47525,5277),(47526,5278),(47527,5279),(47528,5280),(47529,5281),(47530,5282),(47531,5283),(47532,5284),(47533,5285),(47534,5286),(47535,5287),(47536,5288),(47537,5289),(47538,5290),(47539,5291),(47540,5292),(47541,5293),(47542,5294),(47543,5295),(47544,5296),(47545,5297),(47546,5298),(47547,5299),(47548,5300),(47549,5301),(47550,5302),(47551,5303),(47552,5304),(47553,5305),(47554,5306),(47555,5307),(47556,5308),(47557,5309),(47558,5310),(47559,5311),(47560,5312),(47561,5313),(47562,5314),(47563,5315),(47564,5316),(47565,5317),(47566,5318),(47567,5319),(47568,5320),(47569,5321),(47570,5322),(47571,5323),(47572,5324),(47573,5325),(47574,5326),(47575,5327),(47576,5328),(47577,5329),(47578,5330),(47579,5331),(47580,5332),(47581,5333),(47582,5334),(47583,5335),(47584,5336),(47585,5337),(47586,5338),(47587,5339),(47588,5340),(47589,5341),(47590,5342),(47591,5343),(47592,5344),(47593,5345),(47594,5346),(47595,5347),(47596,5348),(47597,5349),(47598,5350),(47599,5351),(47600,5352),(47601,5353),(47602,5354),(47603,5355),(47604,5356),(47605,5357),(47606,5358),(47607,5359),(47608,5271),(47609,5271),(47610,5271),(47611,5272),(47612,5272),(47613,5272),(47614,5273),(47615,5273),(47616,5273),(47617,5274),(47618,5274),(47619,5274),(47620,5275),(47621,5275),(47622,5275),(47623,5276),(47624,5276),(47625,5276),(47626,5277),(47627,5277),(47628,5277),(47629,5278),(47630,5278),(47631,5278),(47632,5279),(47633,5279),(47634,5279),(47635,5280),(47636,5280),(47637,5280),(47638,5281),(47639,5281),(47640,5281),(47641,5282),(47642,5282),(47643,5282),(47644,5283),(47645,5283),(47646,5283),(47647,5284),(47648,5284),(47649,5284),(47650,5285),(47651,5285),(47652,5286),(47653,5286),(47654,5286),(47655,5287),(47656,5287),(47657,5288),(47658,5288),(47659,5289),(47660,5289),(47661,5290),(47662,5290),(47663,5291),(47664,5291),(47665,5292),(47666,5292),(47667,5293),(47668,5293),(47669,5294),(47670,5294),(47671,5295),(47672,5295),(47673,5296),(47674,5296),(47675,5297),(47676,5297),(47677,5298),(47678,5298),(47679,5299),(47680,5299),(47681,5300),(47682,5300),(47683,5301),(47684,5301),(47685,5301),(47686,5302),(47687,5302),(47688,5303),(47689,5303),(47690,5304),(47691,5304),(47692,5305),(47693,5305),(47694,5306),(47695,5306),(47696,5307),(47697,5307),(47698,5308),(47699,5308),(47700,5309),(47701,5309),(47702,5309),(47703,5310),(47704,5310),(47705,5310),(47706,5311),(47707,5311),(47708,5311),(47709,5312),(47710,5312),(47711,5312),(47712,5313),(47713,5313),(47714,5313),(47715,5314),(47716,5314),(47717,5314),(47718,5315),(47719,5315),(47720,5315),(47721,5316),(47722,5316),(47723,5316),(47724,5317),(47725,5317),(47726,5317),(47727,5318),(47728,5318),(47729,5318),(47730,5319),(47731,5319),(47732,5319),(47733,5320),(47734,5320),(47735,5320),(47736,5321),(47737,5321),(47738,5322),(47739,5322),(47740,5323),(47741,5323),(47742,5323),(47743,5324),(47744,5324),(47745,5324),(47746,5325),(47747,5325),(47748,5325),(47749,5326),(47750,5326),(47751,5326),(47752,5327),(47753,5327),(47754,5327),(47755,5328),(47756,5328),(47757,5328),(47758,5329),(47759,5329),(47760,5329),(47761,5330),(47762,5330),(47763,5330),(47764,5331),(47765,5331),(47766,5331),(47767,5332),(47768,5332),(47769,5332),(47770,5333),(47771,5333),(47772,5333),(47773,5334),(47774,5334),(47775,5334),(47776,5335),(47777,5335),(47778,5335),(47779,5336),(47780,5336),(47781,5336),(47782,5337),(47783,5337),(47784,5337),(47785,5338),(47786,5338),(47787,5338),(47788,5339),(47789,5339),(47790,5339),(47791,5340),(47792,5340),(47793,5340),(47794,5341),(47795,5341),(47796,5341),(47797,5342),(47798,5342),(47799,5342),(47800,5343),(47801,5343),(47802,5343),(47803,5344),(47804,5344),(47805,5344),(47806,5345),(47807,5345),(47808,5345),(47809,5346),(47810,5346),(47811,5346),(47812,5347),(47813,5347),(47814,5347),(47815,5348),(47816,5348),(47817,5348),(47818,5349),(47819,5349),(47820,5349),(47821,5350),(47822,5350),(47823,5350),(47824,5351),(47825,5351),(47826,5351),(47827,5352),(47828,5352),(47829,5352),(47830,5353),(47831,5353),(47832,5353),(47833,5354),(47834,5354),(47835,5354),(47836,5355),(47837,5355),(47838,5355),(47839,5356),(47840,5356),(47841,5356),(47842,5357),(47843,5357),(47844,5357),(47845,5358),(47846,5358),(47847,5358),(47848,5359),(47849,5359),(47850,5359),(47851,5271),(47852,5271),(47853,5271),(47854,5271),(47855,5272),(47856,5272),(47857,5272),(47858,5272),(47859,5273),(47860,5273),(47861,5273),(47862,5273),(47863,5274),(47864,5274),(47865,5274),(47866,5274),(47867,5275),(47868,5275),(47869,5275),(47870,5275),(47871,5276),(47872,5276),(47873,5276),(47874,5276),(47875,5277),(47876,5277),(47877,5277),(47878,5277),(47879,5278),(47880,5278),(47881,5278),(47882,5278),(47883,5279),(47884,5279),(47885,5279),(47886,5279),(47887,5280),(47888,5280),(47889,5280),(47890,5280),(47891,5281),(47892,5281),(47893,5281),(47894,5281),(47895,5282),(47896,5282),(47897,5282),(47898,5282),(47899,5283),(47900,5283),(47901,5283),(47902,5283),(47903,5284),(47904,5284),(47905,5284),(47906,5284),(47907,5285),(47908,5285),(47909,5285),(47910,5285),(47911,5286),(47912,5286),(47913,5286),(47914,5286),(47915,5287),(47916,5287),(47917,5287),(47918,5287),(47919,5288),(47920,5288),(47921,5288),(47922,5288),(47923,5289),(47924,5289),(47925,5289),(47926,5289),(47927,5290),(47928,5290),(47929,5290),(47930,5290),(47931,5291),(47932,5291),(47933,5291),(47934,5291),(47935,5292),(47936,5292),(47937,5292),(47938,5292),(47939,5293),(47940,5293),(47941,5293),(47942,5293),(47943,5294),(47944,5294),(47945,5294),(47946,5294),(47947,5295),(47948,5295),(47949,5295),(47950,5295),(47951,5296),(47952,5296),(47953,5296),(47954,5296),(47955,5297),(47956,5297),(47957,5297),(47958,5297),(47959,5298),(47960,5298),(47961,5298),(47962,5298),(47963,5299),(47964,5299),(47965,5299),(47966,5299),(47967,5300),(47968,5300),(47969,5300),(47970,5300),(47971,5301),(47972,5301),(47973,5301),(47974,5301),(47975,5302),(47976,5302),(47977,5302),(47978,5302),(47979,5303),(47980,5303),(47981,5303),(47982,5303),(47983,5304),(47984,5304),(47985,5304),(47986,5304),(47987,5305),(47988,5305),(47989,5305),(47990,5305),(47991,5306),(47992,5306),(47993,5306),(47994,5306),(47995,5307),(47996,5307),(47997,5307),(47998,5307),(47999,5308),(48000,5308),(48001,5308),(48002,5308),(48003,5309),(48004,5309),(48005,5309),(48006,5309),(48007,5310),(48008,5310),(48009,5310),(48010,5310),(48011,5311),(48012,5311),(48013,5311),(48014,5311),(48015,5312),(48016,5312),(48017,5312),(48018,5312),(48019,5313),(48020,5313),(48021,5313),(48022,5313),(48023,5314),(48024,5314),(48025,5314),(48026,5314),(48027,5315),(48028,5315),(48029,5315),(48030,5315),(48031,5316),(48032,5316),(48033,5316),(48034,5316),(48035,5317),(48036,5317),(48037,5317),(48038,5317),(48039,5318),(48040,5318),(48041,5318),(48042,5318),(48043,5319),(48044,5319),(48045,5319),(48046,5319),(48047,5320),(48048,5320),(48049,5320),(48050,5320),(48051,5321),(48052,5321),(48053,5321),(48054,5321),(48055,5322),(48056,5322),(48057,5322),(48058,5322),(48059,5323),(48060,5323),(48061,5323),(48062,5323),(48063,5324),(48064,5324),(48065,5324),(48066,5324),(48067,5325),(48068,5325),(48069,5325),(48070,5325),(48071,5326),(48072,5326),(48073,5326),(48074,5326),(48075,5327),(48076,5327),(48077,5327),(48078,5327),(48079,5328),(48080,5328),(48081,5328),(48082,5328),(48083,5329),(48084,5329),(48085,5329),(48086,5329),(48087,5330),(48088,5330),(48089,5330),(48090,5330),(48091,5331),(48092,5331),(48093,5331),(48094,5331),(48095,5332),(48096,5332),(48097,5332),(48098,5332),(48099,5333),(48100,5333),(48101,5333),(48102,5333),(48103,5334),(48104,5334),(48105,5334),(48106,5334),(48107,5335),(48108,5335),(48109,5335),(48110,5335),(48111,5336),(48112,5336),(48113,5336),(48114,5336),(48115,5337),(48116,5337),(48117,5337),(48118,5337),(48119,5338),(48120,5338),(48121,5338),(48122,5338),(48123,5339),(48124,5339),(48125,5339),(48126,5339),(48127,5340),(48128,5340),(48129,5340),(48130,5340),(48131,5341),(48132,5341),(48133,5341),(48134,5341),(48135,5342),(48136,5342),(48137,5342),(48138,5342),(48139,5343),(48140,5343),(48141,5343),(48142,5343),(48143,5344),(48144,5344),(48145,5344),(48146,5344),(48147,5345),(48148,5345),(48149,5345),(48150,5345),(48151,5346),(48152,5346),(48153,5346),(48154,5346),(48155,5347),(48156,5347),(48157,5347),(48158,5347),(48159,5348),(48160,5348),(48161,5348),(48162,5348),(48163,5349),(48164,5349),(48165,5349),(48166,5349),(48167,5350),(48168,5350),(48169,5350),(48170,5350),(48171,5351),(48172,5351),(48173,5351),(48174,5351),(48175,5352),(48176,5352),(48177,5352),(48178,5352),(48179,5353),(48180,5353),(48181,5353),(48182,5353),(48183,5354),(48184,5354),(48185,5354),(48186,5354),(48187,5355),(48188,5355),(48189,5355),(48190,5355),(48191,5356),(48192,5356),(48193,5356),(48194,5356),(48195,5357),(48196,5357),(48197,5357),(48198,5357),(48199,5358),(48200,5358),(48201,5358),(48202,5358),(48203,5359),(48204,5359),(48205,5359),(48206,5359),(48207,5360),(48208,5361),(48209,5362),(48210,5363),(48211,5364),(48212,5365),(48213,5366),(48214,5367),(48215,5368),(48216,5369),(48217,5370),(48218,5371),(48219,5372),(48220,5373),(48221,5374),(48222,5375),(48223,5376),(48224,5377),(48225,5378),(48226,5379),(48227,5380),(48228,5381),(48229,5382),(48230,5383),(48231,5384),(48232,5385),(48233,5386),(48234,5387),(48235,5388),(48236,5389),(48237,5390),(48238,5391),(48239,5392),(48240,5393),(48241,5394),(48242,5395),(48243,5396),(48244,5397),(48245,5398),(48246,5399),(48247,5400),(48248,5401),(48249,5402),(48250,5403),(48251,5404),(48252,5405),(48253,5406),(48254,5407),(48255,5408),(48256,5409),(48257,5410),(48258,5411),(48259,5412),(48260,5413),(48261,5414),(48262,5415),(48263,5416),(48264,5417),(48265,5418),(48266,5419),(48267,5420),(48268,5421),(48269,5422),(48270,5423),(48271,5424),(48272,5425),(48273,5426),(48274,5427),(48275,5428),(48276,5429),(48277,5430),(48278,5431),(48279,5432),(48280,5433),(48281,5434),(48282,5435),(48283,5436),(48284,5437),(48285,5438),(48286,5439),(48287,5440),(48288,5441),(48289,5442),(48290,5443),(48291,5444),(48292,5445),(48293,5446),(48294,5447),(48295,5448),(48296,5449),(48297,5450),(48298,5451),(48299,5452),(48300,5453),(48301,5454),(48302,5455),(48303,5456),(48304,5457),(48305,5458),(48306,5459),(48307,5360),(48308,5361),(48309,5362),(48310,5363),(48311,5364),(48312,5365),(48313,5366),(48314,5367),(48315,5368),(48316,5369),(48317,5370),(48318,5371),(48319,5372),(48320,5373),(48321,5374),(48322,5375),(48323,5376),(48324,5377),(48325,5378),(48326,5379),(48327,5380),(48328,5381),(48329,5382),(48330,5383),(48331,5384),(48332,5385),(48333,5386),(48334,5387),(48335,5388),(48336,5389),(48337,5390),(48338,5391),(48339,5392),(48340,5393),(48341,5394),(48342,5395),(48343,5396),(48344,5397),(48345,5398),(48346,5399),(48347,5400),(48348,5401),(48349,5402),(48350,5403),(48351,5404),(48352,5405),(48353,5406),(48354,5407),(48355,5408),(48356,5409),(48357,5410),(48358,5411),(48359,5412),(48360,5413),(48361,5414),(48362,5415),(48363,5416),(48364,5417),(48365,5418),(48366,5419),(48367,5420),(48368,5421),(48369,5422),(48370,5423),(48371,5424),(48372,5425),(48373,5426),(48374,5427),(48375,5428),(48376,5429),(48377,5430),(48378,5431),(48379,5432),(48380,5433),(48381,5434),(48382,5435),(48383,5436),(48384,5437),(48385,5438),(48386,5439),(48387,5440),(48388,5441),(48389,5442),(48390,5443),(48391,5444),(48392,5445),(48393,5446),(48394,5447),(48395,5448),(48396,5449),(48397,5450),(48398,5451),(48399,5452),(48400,5453),(48401,5454),(48402,5455),(48403,5456),(48404,5457),(48405,5458),(48406,5459),(48407,5360),(48408,5360),(48409,5360),(48410,5361),(48411,5361),(48412,5361),(48413,5362),(48414,5362),(48415,5362),(48416,5363),(48417,5363),(48418,5363),(48419,5364),(48420,5364),(48421,5364),(48422,5365),(48423,5365),(48424,5365),(48425,5366),(48426,5366),(48427,5366),(48428,5367),(48429,5367),(48430,5367),(48431,5368),(48432,5368),(48433,5368),(48434,5369),(48435,5369),(48436,5369),(48437,5370),(48438,5370),(48439,5370),(48440,5371),(48441,5371),(48442,5371),(48443,5372),(48444,5372),(48445,5372),(48446,5373),(48447,5373),(48448,5373),(48449,5374),(48450,5374),(48451,5374),(48452,5375),(48453,5375),(48454,5375),(48455,5376),(48456,5376),(48457,5376),(48458,5377),(48459,5377),(48460,5377),(48461,5378),(48462,5378),(48463,5378),(48464,5379),(48465,5379),(48466,5379),(48467,5380),(48468,5380),(48469,5380),(48470,5381),(48471,5381),(48472,5381),(48473,5382),(48474,5382),(48475,5382),(48476,5383),(48477,5383),(48478,5383),(48479,5384),(48480,5384),(48481,5384),(48482,5385),(48483,5385),(48484,5385),(48485,5386),(48486,5386),(48487,5386),(48488,5387),(48489,5387),(48490,5387),(48491,5388),(48492,5388),(48493,5388),(48494,5389),(48495,5389),(48496,5389),(48497,5390),(48498,5390),(48499,5390),(48500,5391),(48501,5391),(48502,5391),(48503,5392),(48504,5392),(48505,5392),(48506,5393),(48507,5393),(48508,5393),(48509,5394),(48510,5394),(48511,5394),(48512,5395),(48513,5395),(48514,5395),(48515,5396),(48516,5396),(48517,5396),(48518,5397),(48519,5397),(48520,5397),(48521,5398),(48522,5398),(48523,5398),(48524,5399),(48525,5399),(48526,5399),(48527,5400),(48528,5400),(48529,5400),(48530,5401),(48531,5401),(48532,5401),(48533,5402),(48534,5402),(48535,5402),(48536,5403),(48537,5403),(48538,5403),(48539,5404),(48540,5404),(48541,5404),(48542,5405),(48543,5405),(48544,5405),(48545,5406),(48546,5406),(48547,5406),(48548,5407),(48549,5407),(48550,5407),(48551,5408),(48552,5408),(48553,5408),(48554,5409),(48555,5409),(48556,5409),(48557,5410),(48558,5410),(48559,5410),(48560,5411),(48561,5411),(48562,5411),(48563,5411),(48564,5412),(48565,5412),(48566,5412),(48567,5413),(48568,5413),(48569,5413),(48570,5414),(48571,5414),(48572,5414),(48573,5415),(48574,5415),(48575,5415),(48576,5416),(48577,5416),(48578,5416),(48579,5417),(48580,5417),(48581,5417),(48582,5418),(48583,5418),(48584,5418),(48585,5419),(48586,5419),(48587,5419),(48588,5420),(48589,5420),(48590,5420),(48591,5421),(48592,5421),(48593,5421),(48594,5422),(48595,5422),(48596,5422),(48597,5423),(48598,5423),(48599,5423),(48600,5424),(48601,5424),(48602,5424),(48603,5425),(48604,5425),(48605,5425),(48606,5426),(48607,5426),(48608,5426),(48609,5427),(48610,5427),(48611,5427),(48612,5428),(48613,5428),(48614,5428),(48615,5429),(48616,5429),(48617,5429),(48618,5430),(48619,5430),(48620,5430),(48621,5431),(48622,5431),(48623,5431),(48624,5432),(48625,5432),(48626,5432),(48627,5433),(48628,5433),(48629,5433),(48630,5434),(48631,5434),(48632,5434),(48633,5435),(48634,5435),(48635,5435),(48636,5436),(48637,5436),(48638,5436),(48639,5437),(48640,5437),(48641,5437),(48642,5438),(48643,5438),(48644,5438),(48645,5439),(48646,5439),(48647,5439),(48648,5440),(48649,5440),(48650,5440),(48651,5441),(48652,5441),(48653,5441),(48654,5442),(48655,5442),(48656,5442),(48657,5443),(48658,5443),(48659,5443),(48660,5444),(48661,5444),(48662,5444),(48663,5445),(48664,5445),(48665,5445),(48666,5446),(48667,5446),(48668,5446),(48669,5447),(48670,5447),(48671,5447),(48672,5448),(48673,5448),(48674,5448),(48675,5449),(48676,5449),(48677,5449),(48678,5450),(48679,5450),(48680,5450),(48681,5451),(48682,5451),(48683,5451),(48684,5452),(48685,5452),(48686,5452),(48687,5453),(48688,5453),(48689,5453),(48690,5454),(48691,5454),(48692,5454),(48693,5455),(48694,5455),(48695,5455),(48696,5456),(48697,5456),(48698,5456),(48699,5457),(48700,5457),(48701,5457),(48702,5458),(48703,5458),(48704,5458),(48705,5459),(48706,5459),(48707,5459),(48708,5360),(48709,5360),(48710,5360),(48711,5360),(48712,5361),(48713,5361),(48714,5361),(48715,5361),(48716,5362),(48717,5362),(48718,5362),(48719,5362),(48720,5363),(48721,5363),(48722,5363),(48723,5363),(48724,5364),(48725,5364),(48726,5364),(48727,5364),(48728,5365),(48729,5365),(48730,5365),(48731,5365),(48732,5366),(48733,5366),(48734,5366),(48735,5366),(48736,5367),(48737,5367),(48738,5367),(48739,5367),(48740,5368),(48741,5368),(48742,5368),(48743,5368),(48744,5369),(48745,5369),(48746,5369),(48747,5369),(48748,5370),(48749,5370),(48750,5370),(48751,5370),(48752,5371),(48753,5371),(48754,5371),(48755,5371),(48756,5372),(48757,5372),(48758,5372),(48759,5372),(48760,5373),(48761,5373),(48762,5373),(48763,5373),(48764,5374),(48765,5374),(48766,5374),(48767,5374),(48768,5375),(48769,5375),(48770,5375),(48771,5375),(48772,5376),(48773,5376),(48774,5376),(48775,5376),(48776,5377),(48777,5377),(48778,5377),(48779,5377),(48780,5378),(48781,5378),(48782,5378),(48783,5378),(48784,5379),(48785,5379),(48786,5379),(48787,5379),(48788,5380),(48789,5380),(48790,5380),(48791,5380),(48792,5381),(48793,5381),(48794,5381),(48795,5381),(48796,5382),(48797,5382),(48798,5382),(48799,5382),(48800,5383),(48801,5383),(48802,5383),(48803,5383),(48804,5384),(48805,5384),(48806,5384),(48807,5384),(48808,5385),(48809,5385),(48810,5385),(48811,5385),(48812,5386),(48813,5386),(48814,5386),(48815,5386),(48816,5387),(48817,5387),(48818,5387),(48819,5387),(48820,5388),(48821,5388),(48822,5388),(48823,5388),(48824,5389),(48825,5389),(48826,5389),(48827,5389),(48828,5390),(48829,5390),(48830,5390),(48831,5390),(48832,5391),(48833,5391),(48834,5391),(48835,5391),(48836,5392),(48837,5392),(48838,5392),(48839,5392),(48840,5393),(48841,5393),(48842,5393),(48843,5393),(48844,5394),(48845,5394),(48846,5394),(48847,5394),(48848,5395),(48849,5395),(48850,5395),(48851,5395),(48852,5396),(48853,5396),(48854,5396),(48855,5396),(48856,5397),(48857,5397),(48858,5397),(48859,5397),(48860,5398),(48861,5398),(48862,5398),(48863,5398),(48864,5399),(48865,5399),(48866,5399),(48867,5399),(48868,5400),(48869,5400),(48870,5400),(48871,5400),(48872,5401),(48873,5401),(48874,5401),(48875,5401),(48876,5402),(48877,5402),(48878,5402),(48879,5402),(48880,5403),(48881,5403),(48882,5403),(48883,5403),(48884,5404),(48885,5404),(48886,5404),(48887,5404),(48888,5405),(48889,5405),(48890,5405),(48891,5405),(48892,5406),(48893,5406),(48894,5406),(48895,5406),(48896,5407),(48897,5407),(48898,5407),(48899,5407),(48900,5408),(48901,5408),(48902,5408),(48903,5408),(48904,5409),(48905,5409),(48906,5409),(48907,5409),(48908,5410),(48909,5410),(48910,5410),(48911,5410),(48912,5411),(48913,5411),(48914,5411),(48915,5411),(48916,5412),(48917,5412),(48918,5412),(48919,5412),(48920,5413),(48921,5413),(48922,5413),(48923,5413),(48924,5414),(48925,5414),(48926,5414),(48927,5414),(48928,5415),(48929,5415),(48930,5415),(48931,5415),(48932,5416),(48933,5416),(48934,5416),(48935,5416),(48936,5417),(48937,5417),(48938,5417),(48939,5417),(48940,5418),(48941,5418),(48942,5418),(48943,5418),(48944,5419),(48945,5419),(48946,5419),(48947,5419),(48948,5420),(48949,5420),(48950,5420),(48951,5420),(48952,5421),(48953,5421),(48954,5421),(48955,5421),(48956,5422),(48957,5422),(48958,5422),(48959,5422),(48960,5423),(48961,5423),(48962,5423),(48963,5423),(48964,5424),(48965,5424),(48966,5424),(48967,5424),(48968,5425),(48969,5425),(48970,5425),(48971,5425),(48972,5426),(48973,5426),(48974,5426),(48975,5426),(48976,5427),(48977,5427),(48978,5427),(48979,5427),(48980,5428),(48981,5428),(48982,5428),(48983,5428),(48984,5429),(48985,5429),(48986,5429),(48987,5429),(48988,5430),(48989,5430),(48990,5430),(48991,5430),(48992,5431),(48993,5431),(48994,5431),(48995,5431),(48996,5432),(48997,5432),(48998,5432),(48999,5432),(49000,5433),(49001,5433),(49002,5433),(49003,5433),(49004,5434),(49005,5434),(49006,5434),(49007,5434),(49008,5435),(49009,5435),(49010,5435),(49011,5435),(49012,5436),(49013,5436),(49014,5436),(49015,5436),(49016,5437),(49017,5437),(49018,5437),(49019,5437),(49020,5438),(49021,5438),(49022,5438),(49023,5438),(49024,5439),(49025,5439),(49026,5439),(49027,5439),(49028,5440),(49029,5440),(49030,5440),(49031,5440),(49032,5441),(49033,5441),(49034,5441),(49035,5441),(49036,5442),(49037,5442),(49038,5442),(49039,5442),(49040,5443),(49041,5443),(49042,5443),(49043,5443),(49044,5444),(49045,5444),(49046,5444),(49047,5444),(49048,5445),(49049,5445),(49050,5445),(49051,5445),(49052,5446),(49053,5446),(49054,5446),(49055,5446),(49056,5447),(49057,5447),(49058,5447),(49059,5447),(49060,5448),(49061,5448),(49062,5448),(49063,5448),(49064,5449),(49065,5449),(49066,5449),(49067,5449),(49068,5450),(49069,5450),(49070,5450),(49071,5450),(49072,5451),(49073,5451),(49074,5451),(49075,5451),(49076,5452),(49077,5452),(49078,5452),(49079,5452),(49080,5453),(49081,5453),(49082,5453),(49083,5453),(49084,5454),(49085,5454),(49086,5454),(49087,5454),(49088,5455),(49089,5455),(49090,5455),(49091,5455),(49092,5456),(49093,5456),(49094,5456),(49095,5456),(49096,5457),(49097,5457),(49098,5457),(49099,5457),(49100,5458),(49101,5458),(49102,5458),(49103,5458),(49104,5459),(49105,5459),(49106,5459),(49107,5459),(49108,5460),(49109,5461),(49110,5462),(49111,5463),(49112,5464),(49113,5465),(49114,5466),(49115,5467),(49116,5468),(49117,5469),(49118,5470),(49119,5471),(49120,5472),(49121,5473),(49122,5474),(49123,5475),(49124,5476),(49125,5477),(49126,5478),(49127,5479),(49128,5480),(49129,5481),(49130,5482),(49131,5483),(49132,5484),(49133,5485),(49134,5486),(49135,5487),(49136,5488),(49137,5489),(49138,5490),(49139,5491),(49140,5492),(49141,5493),(49142,5494),(49143,5495),(49144,5496),(49145,5497),(49146,5498),(49147,5499),(49148,5500),(49149,5501),(49150,5502),(49151,5503),(49152,5504),(49153,5505),(49154,5506),(49155,5507),(49156,5508),(49157,5509),(49158,5510),(49159,5511),(49160,5512),(49161,5513),(49162,5514),(49163,5515),(49164,5516),(49165,5517),(49166,5518),(49167,5519),(49168,5520),(49169,5521),(49170,5522),(49171,5523),(49172,5524),(49173,5525),(49174,5526),(49175,5527),(49176,5528),(49177,5529),(49178,5530),(49179,5531),(49180,5532),(49181,5533),(49182,5534),(49183,5535),(49184,5536),(49185,5537),(49186,5538),(49187,5539),(49188,5540),(49189,5541),(49190,5542),(49191,5543),(49192,5544),(49193,5545),(49194,5546),(49195,5547),(49196,5548),(49197,5549),(49198,5550),(49199,5551),(49200,5552),(49201,5553),(49202,5554),(49203,5555),(49204,5556),(49205,5557),(49206,5558),(49207,5559),(49208,5460),(49209,5461),(49210,5462),(49211,5463),(49212,5464),(49213,5465),(49214,5466),(49215,5467),(49216,5468),(49217,5469),(49218,5470),(49219,5471),(49220,5472),(49221,5473),(49222,5474),(49223,5475),(49224,5476),(49225,5477),(49226,5478),(49227,5479),(49228,5480),(49229,5481),(49230,5482),(49231,5483),(49232,5484),(49233,5485),(49234,5486),(49235,5487),(49236,5488),(49237,5489),(49238,5490),(49239,5491),(49240,5492),(49241,5493),(49242,5494),(49243,5495),(49244,5496),(49245,5497),(49246,5498),(49247,5499),(49248,5500),(49249,5501),(49250,5502),(49251,5503),(49252,5504),(49253,5505),(49254,5506),(49255,5507),(49256,5508),(49257,5509),(49258,5510),(49259,5511),(49260,5512),(49261,5513),(49262,5514),(49263,5515),(49264,5516),(49265,5517),(49266,5518),(49267,5519),(49268,5520),(49269,5521),(49270,5522),(49271,5523),(49272,5524),(49273,5525),(49274,5526),(49275,5527),(49276,5528),(49277,5529),(49278,5530),(49279,5531),(49280,5532),(49281,5533),(49282,5534),(49283,5535),(49284,5536),(49285,5537),(49286,5538),(49287,5539),(49288,5540),(49289,5541),(49290,5542),(49291,5543),(49292,5544),(49293,5545),(49294,5546),(49295,5547),(49296,5548),(49297,5549),(49298,5550),(49299,5551),(49300,5552),(49301,5553),(49302,5554),(49303,5555),(49304,5556),(49305,5557),(49306,5558),(49307,5559),(49308,5460),(49309,5460),(49310,5460),(49311,5461),(49312,5461),(49313,5461),(49314,5462),(49315,5462),(49316,5462),(49317,5463),(49318,5463),(49319,5463),(49320,5464),(49321,5464),(49322,5464),(49323,5465),(49324,5465),(49325,5465),(49326,5466),(49327,5466),(49328,5466),(49329,5467),(49330,5467),(49331,5467),(49332,5468),(49333,5468),(49334,5468),(49335,5469),(49336,5469),(49337,5469),(49338,5470),(49339,5470),(49340,5470),(49341,5471),(49342,5471),(49343,5471),(49344,5471),(49345,5472),(49346,5472),(49347,5472),(49348,5472),(49349,5473),(49350,5473),(49351,5473),(49352,5474),(49353,5474),(49354,5474),(49355,5475),(49356,5475),(49357,5475),(49358,5476),(49359,5476),(49360,5476),(49361,5477),(49362,5477),(49363,5477),(49364,5478),(49365,5478),(49366,5478),(49367,5479),(49368,5479),(49369,5479),(49370,5480),(49371,5480),(49372,5480),(49373,5481),(49374,5481),(49375,5481),(49376,5482),(49377,5482),(49378,5482),(49379,5483),(49380,5483),(49381,5483),(49382,5484),(49383,5484),(49384,5484),(49385,5485),(49386,5485),(49387,5485),(49388,5486),(49389,5486),(49390,5486),(49391,5487),(49392,5487),(49393,5487),(49394,5488),(49395,5488),(49396,5488),(49397,5489),(49398,5489),(49399,5489),(49400,5490),(49401,5490),(49402,5490),(49403,5491),(49404,5491),(49405,5491),(49406,5492),(49407,5492),(49408,5492),(49409,5493),(49410,5493),(49411,5493),(49412,5494),(49413,5494),(49414,5494),(49415,5495),(49416,5495),(49417,5495),(49418,5496),(49419,5496),(49420,5496),(49421,5497),(49422,5497),(49423,5497),(49424,5498),(49425,5498),(49426,5498),(49427,5499),(49428,5499),(49429,5499),(49430,5500),(49431,5500),(49432,5500),(49433,5501),(49434,5501),(49435,5501),(49436,5502),(49437,5502),(49438,5502),(49439,5503),(49440,5503),(49441,5503),(49442,5504),(49443,5504),(49444,5504),(49445,5505),(49446,5505),(49447,5505),(49448,5506),(49449,5506),(49450,5506),(49451,5507),(49452,5507),(49453,5507),(49454,5508),(49455,5508),(49456,5508),(49457,5509),(49458,5509),(49459,5509),(49460,5510),(49461,5510),(49462,5510),(49463,5511),(49464,5511),(49465,5511),(49466,5512),(49467,5512),(49468,5512),(49469,5513),(49470,5513),(49471,5513),(49472,5514),(49473,5514),(49474,5514),(49475,5515),(49476,5515),(49477,5515),(49478,5516),(49479,5516),(49480,5516),(49481,5517),(49482,5517),(49483,5517),(49484,5518),(49485,5518),(49486,5518),(49487,5519),(49488,5519),(49489,5519),(49490,5520),(49491,5520),(49492,5520),(49493,5521),(49494,5521),(49495,5521),(49496,5522),(49497,5522),(49498,5522),(49499,5523),(49500,5523),(49501,5523),(49502,5524),(49503,5524),(49504,5524),(49505,5525),(49506,5525),(49507,5525),(49508,5526),(49509,5526),(49510,5526),(49511,5527),(49512,5527),(49513,5527),(49514,5528),(49515,5528),(49516,5528),(49517,5529),(49518,5529),(49519,5529),(49520,5530),(49521,5530),(49522,5530),(49523,5531),(49524,5531),(49525,5531),(49526,5532),(49527,5532),(49528,5532),(49529,5533),(49530,5533),(49531,5533),(49532,5534),(49533,5534),(49534,5534),(49535,5535),(49536,5535),(49537,5535),(49538,5536),(49539,5536),(49540,5537),(49541,5537),(49542,5538),(49543,5538),(49544,5538),(49545,5539),(49546,5539),(49547,5539),(49548,5540),(49549,5540),(49550,5540),(49551,5540),(49552,5541),(49553,5541),(49554,5541),(49555,5541),(49556,5542),(49557,5542),(49558,5542),(49559,5542),(49560,5543),(49561,5543),(49562,5543),(49563,5543),(49564,5544),(49565,5544),(49566,5544),(49567,5544),(49568,5545),(49569,5545),(49570,5545),(49571,5545),(49572,5546),(49573,5546),(49574,5546),(49575,5547),(49576,5547),(49577,5547),(49578,5548),(49579,5548),(49580,5548),(49581,5549),(49582,5549),(49583,5549),(49584,5550),(49585,5550),(49586,5550),(49587,5551),(49588,5551),(49589,5551),(49590,5552),(49591,5552),(49592,5552),(49593,5553),(49594,5553),(49595,5553),(49596,5554),(49597,5554),(49598,5554),(49599,5555),(49600,5555),(49601,5555),(49602,5556),(49603,5556),(49604,5556),(49605,5557),(49606,5557),(49607,5557),(49608,5558),(49609,5558),(49610,5558),(49611,5559),(49612,5559),(49613,5559),(49614,5460),(49615,5460),(49616,5460),(49617,5460),(49618,5461),(49619,5461),(49620,5461),(49621,5461),(49622,5462),(49623,5462),(49624,5462),(49625,5462),(49626,5463),(49627,5463),(49628,5463),(49629,5463),(49630,5464),(49631,5464),(49632,5464),(49633,5464),(49634,5465),(49635,5465),(49636,5465),(49637,5465),(49638,5466),(49639,5466),(49640,5466),(49641,5466),(49642,5467),(49643,5467),(49644,5467),(49645,5467),(49646,5468),(49647,5468),(49648,5468),(49649,5468),(49650,5469),(49651,5469),(49652,5469),(49653,5469),(49654,5470),(49655,5470),(49656,5470),(49657,5470),(49658,5471),(49659,5471),(49660,5471),(49661,5471),(49662,5472),(49663,5472),(49664,5472),(49665,5472),(49666,5473),(49667,5473),(49668,5473),(49669,5473),(49670,5474),(49671,5474),(49672,5474),(49673,5474),(49674,5475),(49675,5475),(49676,5475),(49677,5475),(49678,5476),(49679,5476),(49680,5476),(49681,5476),(49682,5477),(49683,5477),(49684,5477),(49685,5477),(49686,5478),(49687,5478),(49688,5478),(49689,5478),(49690,5479),(49691,5479),(49692,5479),(49693,5479),(49694,5480),(49695,5480),(49696,5480),(49697,5480),(49698,5481),(49699,5481),(49700,5481),(49701,5481),(49702,5482),(49703,5482),(49704,5482),(49705,5482),(49706,5483),(49707,5483),(49708,5483),(49709,5483),(49710,5484),(49711,5484),(49712,5484),(49713,5484),(49714,5485),(49715,5485),(49716,5485),(49717,5485),(49718,5486),(49719,5486),(49720,5486),(49721,5486),(49722,5487),(49723,5487),(49724,5487),(49725,5487),(49726,5488),(49727,5488),(49728,5488),(49729,5488),(49730,5489),(49731,5489),(49732,5489),(49733,5489),(49734,5490),(49735,5490),(49736,5490),(49737,5490),(49738,5491),(49739,5491),(49740,5491),(49741,5491),(49742,5492),(49743,5492),(49744,5492),(49745,5492),(49746,5493),(49747,5493),(49748,5493),(49749,5493),(49750,5494),(49751,5494),(49752,5494),(49753,5494),(49754,5495),(49755,5495),(49756,5495),(49757,5495),(49758,5496),(49759,5496),(49760,5496),(49761,5496),(49762,5497),(49763,5497),(49764,5497),(49765,5497),(49766,5498),(49767,5498),(49768,5498),(49769,5498),(49770,5499),(49771,5499),(49772,5499),(49773,5499),(49774,5500),(49775,5500),(49776,5500),(49777,5500),(49778,5501),(49779,5501),(49780,5501),(49781,5501),(49782,5502),(49783,5502),(49784,5502),(49785,5502),(49786,5503),(49787,5503),(49788,5503),(49789,5503),(49790,5504),(49791,5504),(49792,5504),(49793,5504),(49794,5505),(49795,5505),(49796,5505),(49797,5505),(49798,5506),(49799,5506),(49800,5506),(49801,5506),(49802,5507),(49803,5507),(49804,5507),(49805,5507),(49806,5508),(49807,5508),(49808,5508),(49809,5508),(49810,5509),(49811,5509),(49812,5509),(49813,5509),(49814,5510),(49815,5510),(49816,5510),(49817,5510),(49818,5511),(49819,5511),(49820,5511),(49821,5511),(49822,5512),(49823,5512),(49824,5512),(49825,5512),(49826,5513),(49827,5513),(49828,5513),(49829,5513),(49830,5514),(49831,5514),(49832,5514),(49833,5514),(49834,5515),(49835,5515),(49836,5515),(49837,5515),(49838,5516),(49839,5516),(49840,5516),(49841,5516),(49842,5517),(49843,5517),(49844,5517),(49845,5517),(49846,5518),(49847,5518),(49848,5518),(49849,5518),(49850,5519),(49851,5519),(49852,5519),(49853,5519),(49854,5520),(49855,5520),(49856,5520),(49857,5520),(49858,5521),(49859,5521),(49860,5521),(49861,5521),(49862,5522),(49863,5522),(49864,5522),(49865,5522),(49866,5523),(49867,5523),(49868,5523),(49869,5523),(49870,5524),(49871,5524),(49872,5524),(49873,5524),(49874,5525),(49875,5525),(49876,5525),(49877,5525),(49878,5526),(49879,5526),(49880,5526),(49881,5526),(49882,5527),(49883,5527),(49884,5527),(49885,5527),(49886,5528),(49887,5528),(49888,5528),(49889,5528),(49890,5529),(49891,5529),(49892,5529),(49893,5529),(49894,5530),(49895,5530),(49896,5530),(49897,5530),(49898,5531),(49899,5531),(49900,5531),(49901,5531),(49902,5532),(49903,5532),(49904,5532),(49905,5532),(49906,5533),(49907,5533),(49908,5533),(49909,5533),(49910,5534),(49911,5534),(49912,5534),(49913,5534),(49914,5535),(49915,5535),(49916,5535),(49917,5535),(49918,5536),(49919,5536),(49920,5536),(49921,5536),(49922,5537),(49923,5537),(49924,5537),(49925,5537),(49926,5538),(49927,5538),(49928,5538),(49929,5538),(49930,5539),(49931,5539),(49932,5539),(49933,5539),(49934,5540),(49935,5540),(49936,5540),(49937,5540),(49938,5541),(49939,5541),(49940,5541),(49941,5541),(49942,5542),(49943,5542),(49944,5542),(49945,5542),(49946,5543),(49947,5543),(49948,5543),(49949,5543),(49950,5544),(49951,5544),(49952,5544),(49953,5544),(49954,5545),(49955,5545),(49956,5545),(49957,5545),(49958,5546),(49959,5546),(49960,5546),(49961,5546),(49962,5547),(49963,5547),(49964,5547),(49965,5547),(49966,5548),(49967,5548),(49968,5548),(49969,5548),(49970,5549),(49971,5549),(49972,5549),(49973,5549),(49974,5550),(49975,5550),(49976,5550),(49977,5550),(49978,5551),(49979,5551),(49980,5551),(49981,5551),(49982,5552),(49983,5552),(49984,5552),(49985,5552),(49986,5553),(49987,5553),(49988,5553),(49989,5553),(49990,5554),(49991,5554),(49992,5554),(49993,5554),(49994,5555),(49995,5555),(49996,5555),(49997,5555),(49998,5556),(49999,5556),(50000,5556),(50001,5556),(50002,5557),(50003,5557),(50004,5557),(50005,5557),(50006,5558),(50007,5558),(50008,5558),(50009,5558),(50010,5559),(50011,5559),(50012,5559),(50013,5559),(50014,5560),(50015,5561),(50016,5562),(50017,5563),(50018,5564),(50019,5565),(50020,5566),(50021,5567),(50022,5568),(50023,5569),(50024,5570),(50025,5571),(50026,5572),(50027,5573),(50028,5574),(50029,5575),(50030,5576),(50031,5577),(50032,5578),(50033,5579),(50034,5580),(50035,5581),(50036,5582),(50037,5583),(50038,5584),(50039,5585),(50040,5586),(50041,5587),(50042,5588),(50043,5589),(50044,5590),(50045,5591),(50046,5592),(50047,5593),(50048,5594),(50049,5595),(50050,5596),(50051,5597),(50052,5598),(50053,5599),(50054,5600),(50055,5601),(50056,5602),(50057,5603),(50058,5604),(50059,5605),(50060,5606),(50061,5607),(50062,5608),(50063,5609),(50064,5610),(50065,5611),(50066,5612),(50067,5613),(50068,5614),(50069,5615),(50070,5616),(50071,5617),(50072,5618),(50073,5619),(50074,5620),(50075,5621),(50076,5622),(50077,5623),(50078,5624),(50079,5625),(50080,5626),(50081,5627),(50082,5628),(50083,5629),(50084,5630),(50085,5631),(50086,5632),(50087,5633),(50088,5634),(50089,5635),(50090,5636),(50091,5637),(50092,5638),(50093,5639),(50094,5640),(50095,5641),(50096,5642),(50097,5643),(50098,5644),(50099,5645),(50100,5646),(50101,5647),(50102,5648),(50103,5649),(50104,5650),(50105,5651),(50106,5652),(50107,5653),(50108,5654),(50109,5655),(50110,5656),(50111,5657),(50112,5658),(50113,5659),(50114,5560),(50115,5561),(50116,5562),(50117,5563),(50118,5564),(50119,5565),(50120,5566),(50121,5567),(50122,5568),(50123,5569),(50124,5570),(50125,5571),(50126,5572),(50127,5573),(50128,5574),(50129,5575),(50130,5576),(50131,5577),(50132,5578),(50133,5579),(50134,5580),(50135,5581),(50136,5582),(50137,5583),(50138,5584),(50139,5585),(50140,5586),(50141,5587),(50142,5588),(50143,5589),(50144,5590),(50145,5591),(50146,5592),(50147,5593),(50148,5594),(50149,5595),(50150,5596),(50151,5597),(50152,5598),(50153,5599),(50154,5600),(50155,5601),(50156,5602),(50157,5603),(50158,5604),(50159,5605),(50160,5606),(50161,5607),(50162,5608),(50163,5609),(50164,5610),(50165,5611),(50166,5612),(50167,5613),(50168,5614),(50169,5615),(50170,5616),(50171,5617),(50172,5618),(50173,5619),(50174,5620),(50175,5621),(50176,5622),(50177,5623),(50178,5624),(50179,5625),(50180,5626),(50181,5627),(50182,5628),(50183,5629),(50184,5630),(50185,5631),(50186,5632),(50187,5633),(50188,5634),(50189,5635),(50190,5636),(50191,5637),(50192,5638),(50193,5639),(50194,5640),(50195,5641),(50196,5642),(50197,5643),(50198,5644),(50199,5645),(50200,5646),(50201,5647),(50202,5648),(50203,5649),(50204,5650),(50205,5651),(50206,5652),(50207,5653),(50208,5654),(50209,5655),(50210,5656),(50211,5657),(50212,5658),(50213,5659),(50214,5560),(50215,5560),(50216,5560),(50217,5561),(50218,5561),(50219,5561),(50220,5562),(50221,5562),(50222,5562),(50223,5563),(50224,5563),(50225,5563),(50226,5564),(50227,5564),(50228,5564),(50229,5565),(50230,5565),(50231,5565),(50232,5566),(50233,5566),(50234,5566),(50235,5567),(50236,5567),(50237,5567),(50238,5568),(50239,5568),(50240,5568),(50241,5569),(50242,5569),(50243,5569),(50244,5570),(50245,5570),(50246,5570),(50247,5571),(50248,5571),(50249,5571),(50250,5572),(50251,5572),(50252,5572),(50253,5573),(50254,5573),(50255,5573),(50256,5574),(50257,5574),(50258,5574),(50259,5575),(50260,5575),(50261,5575),(50262,5576),(50263,5576),(50264,5576),(50265,5577),(50266,5577),(50267,5577),(50268,5578),(50269,5578),(50270,5578),(50271,5579),(50272,5579),(50273,5579),(50274,5580),(50275,5580),(50276,5580),(50277,5581),(50278,5581),(50279,5581),(50280,5582),(50281,5582),(50282,5582),(50283,5583),(50284,5583),(50285,5583),(50286,5584),(50287,5584),(50288,5584),(50289,5585),(50290,5585),(50291,5585),(50292,5586),(50293,5586),(50294,5586),(50295,5587),(50296,5587),(50297,5587),(50298,5588),(50299,5588),(50300,5588),(50301,5589),(50302,5589),(50303,5589),(50304,5590),(50305,5590),(50306,5590),(50307,5591),(50308,5591),(50309,5591),(50310,5592),(50311,5592),(50312,5592),(50313,5592),(50314,5593),(50315,5593),(50316,5593),(50317,5594),(50318,5594),(50319,5594),(50320,5595),(50321,5595),(50322,5595),(50323,5596),(50324,5596),(50325,5596),(50326,5597),(50327,5597),(50328,5597),(50329,5598),(50330,5598),(50331,5598),(50332,5599),(50333,5599),(50334,5599),(50335,5600),(50336,5600),(50337,5600),(50338,5601),(50339,5601),(50340,5601),(50341,5602),(50342,5602),(50343,5602),(50344,5602),(50345,5603),(50346,5603),(50347,5603),(50348,5603),(50349,5604),(50350,5604),(50351,5604),(50352,5605),(50353,5605),(50354,5605),(50355,5605),(50356,5606),(50357,5606),(50358,5606),(50359,5607),(50360,5607),(50361,5607),(50362,5608),(50363,5608),(50364,5608),(50365,5608),(50366,5609),(50367,5609),(50368,5609),(50369,5609),(50370,5610),(50371,5610),(50372,5610),(50373,5610),(50374,5611),(50375,5611),(50376,5611),(50377,5611),(50378,5612),(50379,5612),(50380,5612),(50381,5612),(50382,5613),(50383,5613),(50384,5613),(50385,5613),(50386,5614),(50387,5614),(50388,5614),(50389,5614),(50390,5615),(50391,5615),(50392,5615),(50393,5616),(50394,5616),(50395,5616),(50396,5617),(50397,5617),(50398,5617),(50399,5618),(50400,5618),(50401,5618),(50402,5619),(50403,5619),(50404,5619),(50405,5620),(50406,5620),(50407,5620),(50408,5620),(50409,5621),(50410,5621),(50411,5621),(50412,5622),(50413,5622),(50414,5622),(50415,5623),(50416,5623),(50417,5623),(50418,5624),(50419,5624),(50420,5624),(50421,5625),(50422,5625),(50423,5625),(50424,5626),(50425,5626),(50426,5626),(50427,5627),(50428,5627),(50429,5627),(50430,5628),(50431,5628),(50432,5628),(50433,5629),(50434,5629),(50435,5629),(50436,5630),(50437,5630),(50438,5630),(50439,5631),(50440,5631),(50441,5631),(50442,5632),(50443,5632),(50444,5632),(50445,5633),(50446,5633),(50447,5633),(50448,5634),(50449,5634),(50450,5634),(50451,5635),(50452,5635),(50453,5635),(50454,5636),(50455,5636),(50456,5636),(50457,5637),(50458,5637),(50459,5637),(50460,5638),(50461,5638),(50462,5638),(50463,5639),(50464,5639),(50465,5639),(50466,5640),(50467,5640),(50468,5640),(50469,5641),(50470,5641),(50471,5641),(50472,5642),(50473,5642),(50474,5642),(50475,5643),(50476,5643),(50477,5643),(50478,5644),(50479,5644),(50480,5644),(50481,5645),(50482,5645),(50483,5645),(50484,5646),(50485,5646),(50486,5646),(50487,5647),(50488,5647),(50489,5647),(50490,5648),(50491,5648),(50492,5648),(50493,5649),(50494,5649),(50495,5649),(50496,5650),(50497,5650),(50498,5650),(50499,5651),(50500,5651),(50501,5651),(50502,5652),(50503,5652),(50504,5652),(50505,5653),(50506,5653),(50507,5653),(50508,5654),(50509,5654),(50510,5654),(50511,5655),(50512,5655),(50513,5655),(50514,5656),(50515,5656),(50516,5656),(50517,5657),(50518,5657),(50519,5657),(50520,5658),(50521,5658),(50522,5658),(50523,5659),(50524,5659),(50525,5659),(50526,5560),(50527,5560),(50528,5560),(50529,5560),(50530,5561),(50531,5561),(50532,5561),(50533,5561),(50534,5562),(50535,5562),(50536,5562),(50537,5562),(50538,5563),(50539,5563),(50540,5563),(50541,5563),(50542,5564),(50543,5564),(50544,5564),(50545,5564),(50546,5565),(50547,5565),(50548,5565),(50549,5565),(50550,5566),(50551,5566),(50552,5566),(50553,5566),(50554,5567),(50555,5567),(50556,5567),(50557,5567),(50558,5568),(50559,5568),(50560,5568),(50561,5568),(50562,5569),(50563,5569),(50564,5569),(50565,5569),(50566,5570),(50567,5570),(50568,5570),(50569,5570),(50570,5571),(50571,5571),(50572,5571),(50573,5571),(50574,5572),(50575,5572),(50576,5572),(50577,5572),(50578,5573),(50579,5573),(50580,5573),(50581,5573),(50582,5574),(50583,5574),(50584,5574),(50585,5574),(50586,5575),(50587,5575),(50588,5575),(50589,5575),(50590,5576),(50591,5576),(50592,5576),(50593,5576),(50594,5577),(50595,5577),(50596,5577),(50597,5577),(50598,5578),(50599,5578),(50600,5578),(50601,5578),(50602,5579),(50603,5579),(50604,5579),(50605,5579),(50606,5580),(50607,5580),(50608,5580),(50609,5580),(50610,5581),(50611,5581),(50612,5581),(50613,5581),(50614,5582),(50615,5582),(50616,5582),(50617,5582),(50618,5583),(50619,5583),(50620,5583),(50621,5583),(50622,5584),(50623,5584),(50624,5584),(50625,5584),(50626,5585),(50627,5585),(50628,5585),(50629,5585),(50630,5586),(50631,5586),(50632,5586),(50633,5586),(50634,5587),(50635,5587),(50636,5587),(50637,5587),(50638,5588),(50639,5588),(50640,5588),(50641,5588),(50642,5589),(50643,5589),(50644,5589),(50645,5589),(50646,5590),(50647,5590),(50648,5590),(50649,5590),(50650,5591),(50651,5591),(50652,5591),(50653,5591),(50654,5592),(50655,5592),(50656,5592),(50657,5592),(50658,5593),(50659,5593),(50660,5593),(50661,5593),(50662,5594),(50663,5594),(50664,5594),(50665,5594),(50666,5595),(50667,5595),(50668,5595),(50669,5595),(50670,5596),(50671,5596),(50672,5596),(50673,5596),(50674,5597),(50675,5597),(50676,5597),(50677,5597),(50678,5598),(50679,5598),(50680,5598),(50681,5598),(50682,5599),(50683,5599),(50684,5599),(50685,5599),(50686,5600),(50687,5600),(50688,5600),(50689,5600),(50690,5601),(50691,5601),(50692,5601),(50693,5601),(50694,5602),(50695,5602),(50696,5602),(50697,5602),(50698,5603),(50699,5603),(50700,5603),(50701,5603),(50702,5604),(50703,5604),(50704,5604),(50705,5604),(50706,5605),(50707,5605),(50708,5605),(50709,5605),(50710,5606),(50711,5606),(50712,5606),(50713,5606),(50714,5607),(50715,5607),(50716,5607),(50717,5607),(50718,5608),(50719,5608),(50720,5608),(50721,5608),(50722,5609),(50723,5609),(50724,5609),(50725,5609),(50726,5610),(50727,5610),(50728,5610),(50729,5610),(50730,5611),(50731,5611),(50732,5611),(50733,5611),(50734,5612),(50735,5612),(50736,5612),(50737,5612),(50738,5613),(50739,5613),(50740,5613),(50741,5613),(50742,5614),(50743,5614),(50744,5614),(50745,5614),(50746,5615),(50747,5615),(50748,5615),(50749,5615),(50750,5616),(50751,5616),(50752,5616),(50753,5616),(50754,5617),(50755,5617),(50756,5617),(50757,5617),(50758,5618),(50759,5618),(50760,5618),(50761,5618),(50762,5619),(50763,5619),(50764,5619),(50765,5619),(50766,5620),(50767,5620),(50768,5620),(50769,5620),(50770,5621),(50771,5621),(50772,5621),(50773,5621),(50774,5622),(50775,5622),(50776,5622),(50777,5622),(50778,5623),(50779,5623),(50780,5623),(50781,5623),(50782,5624),(50783,5624),(50784,5624),(50785,5624),(50786,5625),(50787,5625),(50788,5625),(50789,5625),(50790,5626),(50791,5626),(50792,5626),(50793,5626),(50794,5627),(50795,5627),(50796,5627),(50797,5627),(50798,5628),(50799,5628),(50800,5628),(50801,5628),(50802,5629),(50803,5629),(50804,5629),(50805,5629),(50806,5630),(50807,5630),(50808,5630),(50809,5630),(50810,5631),(50811,5631),(50812,5631),(50813,5631),(50814,5632),(50815,5632),(50816,5632),(50817,5632),(50818,5633),(50819,5633),(50820,5633),(50821,5633),(50822,5634),(50823,5634),(50824,5634),(50825,5634),(50826,5635),(50827,5635),(50828,5635),(50829,5635),(50830,5636),(50831,5636),(50832,5636),(50833,5636),(50834,5637),(50835,5637),(50836,5637),(50837,5637),(50838,5638),(50839,5638),(50840,5638),(50841,5638),(50842,5639),(50843,5639),(50844,5639),(50845,5639),(50846,5640),(50847,5640),(50848,5640),(50849,5640),(50850,5641),(50851,5641),(50852,5641),(50853,5641),(50854,5642),(50855,5642),(50856,5642),(50857,5642),(50858,5643),(50859,5643),(50860,5643),(50861,5643),(50862,5644),(50863,5644),(50864,5644),(50865,5644),(50866,5645),(50867,5645),(50868,5645),(50869,5645),(50870,5646),(50871,5646),(50872,5646),(50873,5646),(50874,5647),(50875,5647),(50876,5647),(50877,5647),(50878,5648),(50879,5648),(50880,5648),(50881,5648),(50882,5649),(50883,5649),(50884,5649),(50885,5649),(50886,5650),(50887,5650),(50888,5650),(50889,5650),(50890,5651),(50891,5651),(50892,5651),(50893,5651),(50894,5652),(50895,5652),(50896,5652),(50897,5652),(50898,5653),(50899,5653),(50900,5653),(50901,5653),(50902,5654),(50903,5654),(50904,5654),(50905,5654),(50906,5655),(50907,5655),(50908,5655),(50909,5655),(50910,5656),(50911,5656),(50912,5656),(50913,5656),(50914,5657),(50915,5657),(50916,5657),(50917,5657),(50918,5658),(50919,5658),(50920,5658),(50921,5658),(50922,5659),(50923,5659),(50924,5659),(50925,5659),(50926,5660),(50927,5661),(50928,5662),(50929,5663),(50930,5664),(50931,5665),(50932,5666),(50933,5667),(50934,5668),(50935,5669),(50936,5670),(50937,5671),(50938,5672),(50939,5673),(50940,5674),(50941,5675),(50942,5676),(50943,5677),(50944,5678),(50945,5679),(50946,5680),(50947,5681),(50948,5682),(50949,5683),(50950,5684),(50951,5685),(50952,5686),(50953,5687),(50954,5688),(50955,5689),(50956,5690),(50957,5691),(50958,5692),(50959,5693),(50960,5694),(50961,5695),(50962,5696),(50963,5697),(50964,5698),(50965,5699),(50966,5700),(50967,5701),(50968,5702),(50969,5703),(50970,5704),(50971,5705),(50972,5706),(50973,5707),(50974,5708),(50975,5709),(50976,5710),(50977,5711),(50978,5712),(50979,5713),(50980,5714),(50981,5715),(50982,5716),(50983,5717),(50984,5718),(50985,5719),(50986,5720),(50987,5721),(50988,5722),(50989,5723),(50990,5724),(50991,5725),(50992,5726),(50993,5727),(50994,5728),(50995,5729),(50996,5730),(50997,5731),(50998,5732),(50999,5733),(51000,5734),(51001,5735),(51002,5736),(51003,5737),(51004,5738),(51005,5739),(51006,5740),(51007,5741),(51008,5742),(51009,5743),(51010,5744),(51011,5745),(51012,5746),(51013,5747),(51014,5748),(51015,5749),(51016,5750),(51017,5751),(51018,5752),(51019,5660),(51020,5661),(51021,5662),(51022,5663),(51023,5664),(51024,5665),(51025,5666),(51026,5667),(51027,5668),(51028,5669),(51029,5670),(51030,5671),(51031,5672),(51032,5673),(51033,5674),(51034,5675),(51035,5676),(51036,5677),(51037,5678),(51038,5679),(51039,5680),(51040,5681),(51041,5682),(51042,5683),(51043,5684),(51044,5685),(51045,5686),(51046,5687),(51047,5688),(51048,5689),(51049,5690),(51050,5691),(51051,5692),(51052,5693),(51053,5694),(51054,5695),(51055,5696),(51056,5697),(51057,5698),(51058,5699),(51059,5700),(51060,5701),(51061,5702),(51062,5703),(51063,5704),(51064,5705),(51065,5706),(51066,5707),(51067,5708),(51068,5709),(51069,5710),(51070,5711),(51071,5712),(51072,5713),(51073,5714),(51074,5715),(51075,5716),(51076,5717),(51077,5718),(51078,5719),(51079,5720),(51080,5721),(51081,5722),(51082,5723),(51083,5724),(51084,5725),(51085,5726),(51086,5727),(51087,5728),(51088,5729),(51089,5730),(51090,5731),(51091,5732),(51092,5733),(51093,5734),(51094,5735),(51095,5736),(51096,5737),(51097,5738),(51098,5739),(51099,5740),(51100,5741),(51101,5742),(51102,5743),(51103,5744),(51104,5745),(51105,5746),(51106,5747),(51107,5748),(51108,5749),(51109,5750),(51110,5751),(51111,5752),(51112,5660),(51113,5660),(51114,5660),(51115,5661),(51116,5661),(51117,5661),(51118,5662),(51119,5662),(51120,5662),(51121,5663),(51122,5663),(51123,5663),(51124,5664),(51125,5664),(51126,5664),(51127,5665),(51128,5665),(51129,5665),(51130,5666),(51131,5666),(51132,5666),(51133,5667),(51134,5667),(51135,5667),(51136,5668),(51137,5668),(51138,5668),(51139,5669),(51140,5669),(51141,5669),(51142,5670),(51143,5670),(51144,5670),(51145,5671),(51146,5671),(51147,5671),(51148,5672),(51149,5672),(51150,5672),(51151,5673),(51152,5673),(51153,5673),(51154,5674),(51155,5674),(51156,5674),(51157,5675),(51158,5675),(51159,5675),(51160,5676),(51161,5676),(51162,5676),(51163,5677),(51164,5677),(51165,5677),(51166,5678),(51167,5678),(51168,5678),(51169,5679),(51170,5679),(51171,5679),(51172,5680),(51173,5680),(51174,5680),(51175,5681),(51176,5681),(51177,5681),(51178,5682),(51179,5682),(51180,5682),(51181,5682),(51182,5683),(51183,5683),(51184,5683),(51185,5683),(51186,5684),(51187,5684),(51188,5684),(51189,5684),(51190,5685),(51191,5685),(51192,5685),(51193,5685),(51194,5686),(51195,5686),(51196,5686),(51197,5686),(51198,5687),(51199,5687),(51200,5687),(51201,5688),(51202,5688),(51203,5688),(51204,5688),(51205,5689),(51206,5689),(51207,5690),(51208,5690),(51209,5690),(51210,5691),(51211,5691),(51212,5691),(51213,5692),(51214,5692),(51215,5692),(51216,5693),(51217,5693),(51218,5693),(51219,5694),(51220,5694),(51221,5694),(51222,5695),(51223,5695),(51224,5695),(51225,5696),(51226,5696),(51227,5697),(51228,5697),(51229,5697),(51230,5698),(51231,5698),(51232,5698),(51233,5699),(51234,5699),(51235,5699),(51236,5700),(51237,5700),(51238,5700),(51239,5701),(51240,5701),(51241,5701),(51242,5702),(51243,5702),(51244,5702),(51245,5703),(51246,5703),(51247,5703),(51248,5704),(51249,5704),(51250,5704),(51251,5705),(51252,5705),(51253,5705),(51254,5706),(51255,5706),(51256,5706),(51257,5707),(51258,5707),(51259,5707),(51260,5708),(51261,5708),(51262,5708),(51263,5709),(51264,5709),(51265,5709),(51266,5709),(51267,5710),(51268,5710),(51269,5710),(51270,5711),(51271,5711),(51272,5711),(51273,5711),(51274,5712),(51275,5712),(51276,5712),(51277,5713),(51278,5713),(51279,5713),(51280,5714),(51281,5714),(51282,5714),(51283,5715),(51284,5715),(51285,5715),(51286,5716),(51287,5716),(51288,5716),(51289,5717),(51290,5717),(51291,5717),(51292,5718),(51293,5718),(51294,5718),(51295,5719),(51296,5719),(51297,5719),(51298,5720),(51299,5720),(51300,5720),(51301,5721),(51302,5721),(51303,5721),(51304,5722),(51305,5722),(51306,5722),(51307,5723),(51308,5723),(51309,5723),(51310,5724),(51311,5724),(51312,5724),(51313,5725),(51314,5725),(51315,5725),(51316,5726),(51317,5726),(51318,5726),(51319,5727),(51320,5727),(51321,5727),(51322,5728),(51323,5728),(51324,5728),(51325,5729),(51326,5729),(51327,5729),(51328,5730),(51329,5730),(51330,5730),(51331,5731),(51332,5731),(51333,5731),(51334,5732),(51335,5732),(51336,5732),(51337,5733),(51338,5733),(51339,5733),(51340,5734),(51341,5734),(51342,5734),(51343,5735),(51344,5735),(51345,5735),(51346,5736),(51347,5736),(51348,5736),(51349,5737),(51350,5737),(51351,5737),(51352,5738),(51353,5738),(51354,5738),(51355,5739),(51356,5739),(51357,5739),(51358,5740),(51359,5740),(51360,5740),(51361,5741),(51362,5741),(51363,5741),(51364,5742),(51365,5742),(51366,5742),(51367,5743),(51368,5743),(51369,5743),(51370,5744),(51371,5744),(51372,5744),(51373,5745),(51374,5745),(51375,5745),(51376,5745),(51377,5746),(51378,5746),(51379,5746),(51380,5746),(51381,5747),(51382,5747),(51383,5747),(51384,5747),(51385,5748),(51386,5748),(51387,5748),(51388,5749),(51389,5749),(51390,5749),(51391,5749),(51392,5750),(51393,5750),(51394,5750),(51395,5751),(51396,5751),(51397,5751),(51398,5752),(51399,5752),(51400,5660),(51401,5660),(51402,5660),(51403,5660),(51404,5661),(51405,5661),(51406,5661),(51407,5661),(51408,5662),(51409,5662),(51410,5662),(51411,5662),(51412,5663),(51413,5663),(51414,5663),(51415,5663),(51416,5664),(51417,5664),(51418,5664),(51419,5664),(51420,5665),(51421,5665),(51422,5665),(51423,5665),(51424,5666),(51425,5666),(51426,5666),(51427,5666),(51428,5667),(51429,5667),(51430,5667),(51431,5667),(51432,5668),(51433,5668),(51434,5668),(51435,5668),(51436,5669),(51437,5669),(51438,5669),(51439,5669),(51440,5670),(51441,5670),(51442,5670),(51443,5670),(51444,5671),(51445,5671),(51446,5671),(51447,5671),(51448,5672),(51449,5672),(51450,5672),(51451,5672),(51452,5673),(51453,5673),(51454,5673),(51455,5673),(51456,5674),(51457,5674),(51458,5674),(51459,5674),(51460,5675),(51461,5675),(51462,5675),(51463,5675),(51464,5676),(51465,5676),(51466,5676),(51467,5676),(51468,5677),(51469,5677),(51470,5677),(51471,5677),(51472,5678),(51473,5678),(51474,5678),(51475,5678),(51476,5679),(51477,5679),(51478,5679),(51479,5679),(51480,5680),(51481,5680),(51482,5680),(51483,5680),(51484,5681),(51485,5681),(51486,5681),(51487,5681),(51488,5682),(51489,5682),(51490,5682),(51491,5682),(51492,5683),(51493,5683),(51494,5683),(51495,5683),(51496,5684),(51497,5684),(51498,5684),(51499,5684),(51500,5685),(51501,5685),(51502,5685),(51503,5685),(51504,5686),(51505,5686),(51506,5686),(51507,5686),(51508,5687),(51509,5687),(51510,5687),(51511,5687),(51512,5688),(51513,5688),(51514,5688),(51515,5688),(51516,5689),(51517,5689),(51518,5689),(51519,5689),(51520,5690),(51521,5690),(51522,5690),(51523,5690),(51524,5691),(51525,5691),(51526,5691),(51527,5691),(51528,5692),(51529,5692),(51530,5692),(51531,5692),(51532,5693),(51533,5693),(51534,5693),(51535,5693),(51536,5694),(51537,5694),(51538,5694),(51539,5694),(51540,5695),(51541,5695),(51542,5695),(51543,5695),(51544,5696),(51545,5696),(51546,5696),(51547,5696),(51548,5697),(51549,5697),(51550,5697),(51551,5697),(51552,5698),(51553,5698),(51554,5698),(51555,5698),(51556,5699),(51557,5699),(51558,5699),(51559,5699),(51560,5700),(51561,5700),(51562,5700),(51563,5700),(51564,5701),(51565,5701),(51566,5701),(51567,5701),(51568,5702),(51569,5702),(51570,5702),(51571,5702),(51572,5703),(51573,5703),(51574,5703),(51575,5703),(51576,5704),(51577,5704),(51578,5704),(51579,5704),(51580,5705),(51581,5705),(51582,5705),(51583,5705),(51584,5706),(51585,5706),(51586,5706),(51587,5706),(51588,5707),(51589,5707),(51590,5707),(51591,5707),(51592,5708),(51593,5708),(51594,5708),(51595,5708),(51596,5709),(51597,5709),(51598,5709),(51599,5709),(51600,5710),(51601,5710),(51602,5710),(51603,5710),(51604,5711),(51605,5711),(51606,5711),(51607,5711),(51608,5712),(51609,5712),(51610,5712),(51611,5712),(51612,5713),(51613,5713),(51614,5713),(51615,5713),(51616,5714),(51617,5714),(51618,5714),(51619,5714),(51620,5715),(51621,5715),(51622,5715),(51623,5715),(51624,5716),(51625,5716),(51626,5716),(51627,5716),(51628,5717),(51629,5717),(51630,5717),(51631,5717),(51632,5718),(51633,5718),(51634,5718),(51635,5718),(51636,5719),(51637,5719),(51638,5719),(51639,5719),(51640,5720),(51641,5720),(51642,5720),(51643,5720),(51644,5721),(51645,5721),(51646,5721),(51647,5721),(51648,5722),(51649,5722),(51650,5722),(51651,5722),(51652,5723),(51653,5723),(51654,5723),(51655,5723),(51656,5724),(51657,5724),(51658,5724),(51659,5724),(51660,5725),(51661,5725),(51662,5725),(51663,5725),(51664,5726),(51665,5726),(51666,5726),(51667,5726),(51668,5727),(51669,5727),(51670,5727),(51671,5727),(51672,5728),(51673,5728),(51674,5728),(51675,5728),(51676,5729),(51677,5729),(51678,5729),(51679,5729),(51680,5730),(51681,5730),(51682,5730),(51683,5730),(51684,5731),(51685,5731),(51686,5731),(51687,5731),(51688,5732),(51689,5732),(51690,5732),(51691,5732),(51692,5733),(51693,5733),(51694,5733),(51695,5733),(51696,5734),(51697,5734),(51698,5734),(51699,5734),(51700,5735),(51701,5735),(51702,5735),(51703,5735),(51704,5736),(51705,5736),(51706,5736),(51707,5736),(51708,5737),(51709,5737),(51710,5737),(51711,5737),(51712,5738),(51713,5738),(51714,5738),(51715,5738),(51716,5739),(51717,5739),(51718,5739),(51719,5739),(51720,5740),(51721,5740),(51722,5740),(51723,5740),(51724,5741),(51725,5741),(51726,5741),(51727,5741),(51728,5742),(51729,5742),(51730,5742),(51731,5742),(51732,5743),(51733,5743),(51734,5743),(51735,5743),(51736,5744),(51737,5744),(51738,5744),(51739,5744),(51740,5745),(51741,5745),(51742,5745),(51743,5745),(51744,5746),(51745,5746),(51746,5746),(51747,5746),(51748,5747),(51749,5747),(51750,5747),(51751,5747),(51752,5748),(51753,5748),(51754,5748),(51755,5748),(51756,5749),(51757,5749),(51758,5749),(51759,5749),(51760,5750),(51761,5750),(51762,5750),(51763,5750),(51764,5751),(51765,5751),(51766,5751),(51767,5751),(51768,5752),(51769,5752),(51770,5752),(51771,5752),(51772,1160),(51773,1160),(51774,1161),(51775,1161),(51776,1161),(51777,1162),(51778,1119),(51779,1119),(51780,1119),(51781,5752),(51782,5738),(51783,5738),(51784,5738),(51785,5738),(51786,4713),(51787,4713),(51788,5197),(51789,5197),(51790,5194),(51791,5194),(51792,5193),(51793,5193),(51794,5192),(51795,5192),(51796,5191),(51797,5191),(51798,5190),(51799,5190),(51800,4875),(51801,4875),(51802,4876),(51803,4876),(51804,4891),(51805,4891),(51806,4892),(51807,4892),(51808,4893),(51809,4893),(51810,4894),(51811,4894),(51812,1162),(51813,1162),(51814,1162),(51815,1165),(51816,1165),(51817,1165),(51818,2163),(51819,2163),(51820,2163),(51821,2163),(51822,2163),(51823,2163),(51824,2163),(51825,2163),(51826,2176),(51827,2176),(51828,2176),(51829,2176),(51830,2176),(51831,2176),(51832,2176),(51833,2176),(51834,1164),(51835,1164),(51836,1164),(51837,4894),(51838,4894),(51839,4894),(51840,4894),(51841,2163),(51842,1),(51843,1),(51844,1),(51845,1),(51846,1),(51847,1),(51848,1),(51849,1),(51850,1),(51851,1),(51852,1),(51853,1),(51854,1),(51855,1),(51856,1),(51857,1),(51858,1),(51859,1),(51860,1),(51861,1),(51862,1),(51863,1),(51864,1),(51865,1),(51866,1),(51867,1),(51868,1),(51869,1),(51870,1),(51871,1),(51872,5753),(51873,5753),(51874,5753),(51875,5753),(51876,5753),(51877,5753),(51878,5753),(51879,5753),(51880,5753),(51881,5753),(51882,5754),(51883,5754),(51884,5754),(51885,5754),(51886,5754),(51887,5754),(51888,5754),(51889,5754),(51890,5754),(51891,5754),(51892,5754),(51893,5755),(51894,5755),(51895,5755),(51896,5755),(51897,5755),(51898,5755),(51899,5755),(51900,5755),(51901,5755),(51902,5755),(51903,5755),(51904,5756),(51905,5756),(51906,5756),(51907,5756),(51908,5756),(51909,5756),(51910,5756),(51911,5756),(51912,5756),(51913,5756),(51914,5756),(51915,5753),(51916,5753),(51917,5753),(51918,5754),(51919,5755),(51920,5756),(51921,1162),(51922,1162),(51923,1162),(51924,4894),(51925,4894),(51926,4894),(51927,1164),(51928,1164),(51929,1164),(51930,2176),(51931,2176),(51932,2176),(51933,5753),(51934,5753),(51935,5753),(51936,5753),(51937,5753),(51938,5753),(51939,5753),(51940,1165),(51941,1165),(51942,1165),(51943,1165),(51944,1165),(51945,1165),(51946,5193),(51947,5193),(51948,5193),(51949,5193),(51950,5193),(51951,5193),(51952,5193),(51953,5192),(51954,5192),(51955,5192),(51956,5192),(51957,5192),(51958,5192),(51959,5192),(51960,5190),(51961,5190),(51962,5190),(51963,5190),(51964,5190),(51965,5190),(51966,5190),(51967,5753),(51968,5753),(51969,5753),(51970,5753),(51971,5753),(51972,5753),(51973,5753),(51974,5753),(51975,5753),(51976,5753),(51977,5753),(51978,5753),(51979,5753),(51980,5753),(51981,5753),(51982,5753),(51983,5753),(51984,5753),(51985,5753),(51986,5753),(51987,5753),(51988,5753),(51989,5753),(51990,5753),(51991,5753),(51992,5753),(51993,5753),(51994,5753),(51995,5753),(51996,5753),(51997,5753),(51998,5753),(51999,5753),(52000,5753),(52001,5753),(52002,5753),(52003,5753),(52004,5753),(52005,5753),(52006,5753),(52007,5753),(52008,5753),(52009,5753),(52010,5753),(52011,5753),(52012,5753),(52013,5753),(52014,5753),(52015,5753),(52016,5753),(52017,5753),(52018,5753),(52019,5753),(52020,5753),(52021,5753),(52022,5753),(52023,5753),(52024,5753),(52025,5753),(52026,5753),(52027,5753),(52028,5753),(52029,5753),(52030,5753),(52031,5753),(52032,5753),(52033,5753),(52034,5753),(52035,5753),(52036,5753),(52037,5753),(52038,5753),(52039,5753),(52040,5753),(52041,5753),(52042,5753),(52043,5753),(52044,5753),(52045,5753),(52046,5753),(52047,5753),(52048,5753),(52049,5753),(52050,5753),(52051,5753),(52052,5753),(52053,5753),(52054,5753),(52055,5753),(52056,5753),(52057,5753),(52058,5753),(52059,5753),(52060,5753),(52061,5753),(52062,48),(52063,48),(52064,48),(52065,48),(52066,48),(52067,48),(52068,48),(52069,48),(52070,48),(52071,4894),(52072,4894),(52073,4894),(52074,5753),(52075,5753),(52076,5753),(52077,5753),(52078,5753),(52079,5753),(52080,5753),(52081,5753),(52082,5753),(52083,5753),(52084,5753),(52085,5753),(52086,5753),(52087,2176),(52088,2176),(52089,2176),(52090,5753),(52091,5753),(52092,5753),(52093,5753),(52094,5753),(52095,5753),(52096,5753),(52097,5753),(52098,5753),(52099,5753),(52100,5753),(52101,7),(52102,7),(52103,7),(52104,7),(52105,7),(52106,7),(52107,7),(52108,7),(52109,7),(52110,7),(52111,7),(52112,7),(52113,7),(52114,7),(52115,7),(52116,7),(52117,7),(52118,7),(52119,7),(52120,7),(52121,7),(52122,7),(52123,5757),(52124,5757),(52125,5757),(52126,5757),(52127,5757),(52128,5757),(52129,5757),(52130,5757),(52131,5757),(52132,5757),(52133,5757),(52134,5757),(52135,5757),(52136,5757),(52137,5757),(52138,5758),(52139,5758),(52140,5758),(52141,5758),(52142,5758),(52143,5758),(52144,5758),(52145,5758),(52146,5758),(52147,5758),(52148,5758),(52149,5758),(52150,5758),(52151,5758),(52152,5758),(52153,5759),(52154,5759),(52155,5759),(52156,5759),(52157,5759),(52158,5759),(52159,5759),(52160,5759),(52161,5759),(52162,5759),(52163,5759),(52164,5759),(52165,5759),(52166,5759),(52167,5759),(52168,1165),(52169,1165),(52170,1165),(52171,1165),(52172,1165),(52173,7),(52174,7),(52175,7),(52176,7),(52177,7),(52178,7),(52179,7),(52180,7),(52181,7),(52182,7),(52183,7),(52184,7),(52185,7),(52186,7),(52187,7),(52188,7),(52189,7),(52190,7),(52191,7),(52192,7),(52193,7),(52194,7),(52195,7),(52196,7),(52197,7),(52198,7),(52199,7),(52200,7),(52201,7),(52202,7),(52203,7),(52204,7),(52205,7),(52206,7),(52207,7),(52208,7),(52209,7),(52210,7),(52211,7),(52212,7),(52213,7),(52214,7),(52215,7),(52216,7),(52217,7),(52218,7),(52219,7),(52220,7),(52221,7),(52222,7),(52223,7),(52224,7),(52225,7),(52226,7),(52227,7),(52228,7),(52229,7),(52230,7),(52231,7),(52232,7),(52233,7),(52234,7),(52235,7),(52236,7),(52237,7),(52238,7),(52239,7),(52240,7),(52241,7),(52242,7),(52243,7),(52244,7),(52245,51),(52246,51),(52247,51),(52248,51),(52249,51),(52250,51),(52251,51),(52252,51),(52253,51),(52254,51),(52255,221),(52256,221),(52257,221),(52258,221),(52259,221),(52260,221),(52261,221),(52262,221),(52263,221),(52264,221),(52265,221),(52266,221),(52267,112),(52268,112),(52269,112),(52270,112),(52271,112),(52272,112),(52273,112),(52274,112),(52275,112),(52276,112),(52277,18),(52278,18),(52279,18),(52280,18),(52281,18),(52282,18),(52283,18),(52284,18),(52285,18),(52286,18),(52287,18),(52288,1623),(52289,1623),(52290,1623),(52291,1623),(52292,1623),(52293,1623),(52294,1623),(52295,1623),(52296,1623),(52297,1623),(52298,1623),(52299,1623),(52300,2289),(52301,2289),(52302,2289),(52303,2289),(52304,2289),(52305,2289),(52306,2289),(52307,2289),(52308,2289),(52309,2289),(52310,2289),(52311,2289),(52312,2289),(52313,2289),(52314,2289),(52315,2289),(52316,1164),(52317,1164),(52318,1162),(52319,1162),(52320,5718),(52321,5718),(52322,5718),(52323,5718),(52324,5718),(52325,5718),(52326,5718),(52327,5718),(52328,5718),(52329,5718),(52330,5718),(52331,5718),(52332,1),(52333,2),(52334,3),(52335,4),(52336,5),(52337,6),(52338,7),(52339,8),(52340,9),(52341,10),(52342,11),(52343,12),(52344,13),(52345,14),(52346,15),(52347,16),(52348,17),(52349,18),(52350,19),(52351,20),(52352,21),(52353,22),(52354,23),(52355,24),(52356,25),(52357,26),(52358,27),(52359,28),(52360,29),(52361,30),(52362,31),(52363,32),(52364,33),(52365,34),(52366,35),(52367,36),(52368,37),(52369,38),(52370,39),(52371,40),(52372,41),(52373,42),(52374,43),(52375,44),(52376,45),(52377,46),(52378,47),(52379,48),(52380,49),(52381,50),(52382,51),(52383,52),(52384,53),(52385,54),(52386,55),(52387,56),(52388,57),(52389,58),(52390,59),(52391,60),(52392,61),(52393,62),(52394,63),(52395,64),(52396,65),(52397,66),(52398,67),(52399,68),(52400,69),(52401,70),(52402,71),(52403,72),(52404,73),(52405,74),(52406,75),(52407,76),(52408,77),(52409,78),(52410,79),(52411,80),(52412,81),(52413,82),(52414,83),(52415,84),(52416,85),(52417,86),(52418,87),(52419,88),(52420,89),(52421,90),(52422,91),(52423,92),(52424,93),(52425,94),(52426,95),(52427,96),(52428,97),(52429,98),(52430,99),(52431,100),(52432,101),(52433,102),(52434,103),(52435,104),(52436,105),(52437,106),(52438,107),(52439,108),(52440,109),(52441,110),(52442,111),(52443,112),(52444,113),(52445,114),(52446,115),(52447,116),(52448,117),(52449,118),(52450,119),(52451,120),(52452,121),(52453,122),(52454,123),(52455,124),(52456,125),(52457,126),(52458,127),(52459,128),(52460,129),(52461,130),(52462,131),(52463,132),(52464,133),(52465,134),(52466,135),(52467,136),(52468,137),(52469,138),(52470,139),(52471,140),(52472,141),(52473,142),(52474,143),(52475,144),(52476,145),(52477,146),(52478,147),(52479,148),(52480,149),(52481,150),(52482,151),(52483,152),(52484,153),(52485,154),(52486,155),(52487,156),(52488,157),(52489,158),(52490,159),(52491,160),(52492,161),(52493,162),(52494,163),(52495,164),(52496,165),(52497,166),(52498,167),(52499,168),(52500,169),(52501,170),(52502,171),(52503,172),(52504,173),(52505,174),(52506,175),(52507,176),(52508,177),(52509,178),(52510,179),(52511,180),(52512,181),(52513,182),(52514,183),(52515,184),(52516,185),(52517,186),(52518,187),(52519,188),(52520,189),(52521,190),(52522,191),(52523,192),(52524,193),(52525,194),(52526,195),(52527,196),(52528,197),(52529,198),(52530,199),(52531,200),(52532,201),(52533,202),(52534,203),(52535,204),(52536,205),(52537,206),(52538,207),(52539,208),(52540,209),(52541,210),(52542,211),(52543,212),(52544,213),(52545,214),(52546,215),(52547,216),(52548,217),(52549,218),(52550,219),(52551,220),(52552,221),(52553,222),(52554,223),(52555,224),(52556,225),(52557,226),(52558,227),(52559,228),(52560,229),(52561,230),(52562,231),(52563,232),(52564,233),(52565,234),(52566,235),(52567,236),(52568,237),(52569,238),(52570,239),(52571,240),(52572,241),(52573,242),(52574,243),(52575,244),(52576,245),(52577,246),(52578,247),(52579,248),(52580,249),(52581,250),(52582,251),(52583,252),(52584,253),(52585,254),(52586,255),(52587,256),(52588,257),(52589,258),(52590,259),(52591,260),(52592,261),(52593,262),(52594,263),(52595,264),(52596,265),(52597,266),(52598,267),(52599,268),(52600,269),(52601,270),(52602,271),(52603,272),(52604,273),(52605,274),(52606,275),(52607,276),(52608,277),(52609,278),(52610,279),(52611,280),(52612,281),(52613,282),(52614,283),(52615,284),(52616,285),(52617,286),(52618,287),(52619,288),(52620,289),(52621,290),(52622,291),(52623,292),(52624,293),(52625,294),(52626,295),(52627,296),(52628,297),(52629,298),(52630,299),(52631,300),(52632,301),(52633,302),(52634,303),(52635,304),(52636,305),(52637,306),(52638,307),(52639,308),(52640,309),(52641,310),(52642,311),(52643,312),(52644,313),(52645,314),(52646,315),(52647,316),(52648,317),(52649,318),(52650,319),(52651,320),(52652,321),(52653,322),(52654,323),(52655,324),(52656,325),(52657,326),(52658,327),(52659,328),(52660,329),(52661,330),(52662,331),(52663,332),(52664,333),(52665,334),(52666,335),(52667,336),(52668,337),(52669,338),(52670,339),(52671,340),(52672,341),(52673,342),(52674,343),(52675,344),(52676,345),(52677,346),(52678,347),(52679,348),(52680,349),(52681,350),(52682,351),(52683,352),(52684,353),(52685,354),(52686,355),(52687,356),(52688,357),(52689,358),(52690,359),(52691,360),(52692,361),(52693,362),(52694,363),(52695,364),(52696,365),(52697,366),(52698,367),(52699,368),(52700,369),(52701,370),(52702,371),(52703,372),(52704,373),(52705,374),(52706,375),(52707,376),(52708,377),(52709,378),(52710,379),(52711,380),(52712,381),(52713,382),(52714,383),(52715,384),(52716,385),(52717,386),(52718,387),(52719,388),(52720,389),(52721,390),(52722,391),(52723,392),(52724,393),(52725,394),(52726,395),(52727,396),(52728,397),(52729,398),(52730,399),(52731,400),(52732,401),(52733,402),(52734,403),(52735,404),(52736,405),(52737,406),(52738,407),(52739,408),(52740,409),(52741,410),(52742,411),(52743,412),(52744,413),(52745,414),(52746,415),(52747,416),(52748,417),(52749,418),(52750,419),(52751,420),(52752,421),(52753,422),(52754,423),(52755,424),(52756,425),(52757,426),(52758,427),(52759,428),(52760,429),(52761,430),(52762,431),(52763,432),(52764,433),(52765,434),(52766,435),(52767,436),(52768,437),(52769,438),(52770,439),(52771,440),(52772,441),(52773,442),(52774,443),(52775,444),(52776,445),(52777,446),(52778,447),(52779,448),(52780,449),(52781,450),(52782,451),(52783,452),(52784,453),(52785,454),(52786,455),(52787,456),(52788,457),(52789,458),(52790,459),(52791,460),(52792,461),(52793,462),(52794,463),(52795,464),(52796,465),(52797,466),(52798,467),(52799,468),(52800,469),(52801,470),(52802,471),(52803,472),(52804,473),(52805,474),(52806,475),(52807,476),(52808,477),(52809,478),(52810,479),(52811,480),(52812,481),(52813,482),(52814,483),(52815,484),(52816,485),(52817,486),(52818,487),(52819,488),(52820,489),(52821,490),(52822,491),(52823,492),(52824,493),(52825,494),(52826,495),(52827,496),(52828,497),(52829,498),(52830,499),(52831,500),(52832,501),(52833,502),(52834,503),(52835,504),(52836,505),(52837,506),(52838,507),(52839,508),(52840,509),(52841,510),(52842,511),(52843,512),(52844,513),(52845,514),(52846,515),(52847,516),(52848,517),(52849,518),(52850,519),(52851,520),(52852,521),(52853,522),(52854,523),(52855,524),(52856,525),(52857,526),(52858,527),(52859,528),(52860,529),(52861,530),(52862,531),(52863,532),(52864,533),(52865,534),(52866,535),(52867,536),(52868,537),(52869,538),(52870,539),(52871,540),(52872,541),(52873,542),(52874,543),(52875,544),(52876,545),(52877,546),(52878,547),(52879,548),(52880,549),(52881,550),(52882,551),(52883,552),(52884,553),(52885,554),(52886,555),(52887,556),(52888,557),(52889,558),(52890,559),(52891,560),(52892,561),(52893,562),(52894,563),(52895,564),(52896,565),(52897,566),(52898,567),(52899,568),(52900,569),(52901,570),(52902,571),(52903,572),(52904,573),(52905,574),(52906,575),(52907,576),(52908,577),(52909,578),(52910,579),(52911,580),(52912,581),(52913,582),(52914,583),(52915,584),(52916,585),(52917,586),(52918,587),(52919,588),(52920,589),(52921,590),(52922,591),(52923,592),(52924,593),(52925,594),(52926,595),(52927,596),(52928,597),(52929,598),(52930,599),(52931,600),(52932,601),(52933,602),(52934,603),(52935,604),(52936,605),(52937,606),(52938,607),(52939,608),(52940,609),(52941,610),(52942,611),(52943,612),(52944,613),(52945,614),(52946,615),(52947,616),(52948,617),(52949,618),(52950,619),(52951,620),(52952,621),(52953,622),(52954,623),(52955,624),(52956,625),(52957,626),(52958,627),(52959,628),(52960,629),(52961,630),(52962,631),(52963,632),(52964,633),(52965,634),(52966,635),(52967,636),(52968,637),(52969,638),(52970,639),(52971,640),(52972,641),(52973,642),(52974,643),(52975,644),(52976,645),(52977,646),(52978,647),(52979,648),(52980,649),(52981,650),(52982,651),(52983,652),(52984,653),(52985,654),(52986,655),(52987,656),(52988,657),(52989,658),(52990,659),(52991,660),(52992,661),(52993,662),(52994,663),(52995,664),(52996,665),(52997,666),(52998,667),(52999,668),(53000,669),(53001,670),(53002,671),(53003,672),(53004,673),(53005,674),(53006,675),(53007,676),(53008,677),(53009,678),(53010,679),(53011,680),(53012,681),(53013,682),(53014,683),(53015,684),(53016,685),(53017,686),(53018,687),(53019,688),(53020,689),(53021,690),(53022,691),(53023,692),(53024,693),(53025,694),(53026,695),(53027,696),(53028,697),(53029,698),(53030,699),(53031,700),(53032,701),(53033,702),(53034,703),(53035,704),(53036,705),(53037,706),(53038,707),(53039,708),(53040,709),(53041,710),(53042,711),(53043,712),(53044,713),(53045,714),(53046,715),(53047,716),(53048,717),(53049,718),(53050,719),(53051,720),(53052,721),(53053,722),(53054,723),(53055,724),(53056,725),(53057,726),(53058,727),(53059,728),(53060,729),(53061,730),(53062,731),(53063,732),(53064,733),(53065,734),(53066,735),(53067,736),(53068,737),(53069,738),(53070,739),(53071,740),(53072,741),(53073,742),(53074,743),(53075,744),(53076,745),(53077,746),(53078,747),(53079,748),(53080,749),(53081,750),(53082,751),(53083,752),(53084,753),(53085,754),(53086,755),(53087,756),(53088,757),(53089,758),(53090,759),(53091,760),(53092,761),(53093,762),(53094,763),(53095,764),(53096,765),(53097,766),(53098,767),(53099,768),(53100,769),(53101,770),(53102,771),(53103,772),(53104,773),(53105,774),(53106,775),(53107,776),(53108,777),(53109,778),(53110,779),(53111,780),(53112,781),(53113,782),(53114,783),(53115,784),(53116,785),(53117,786),(53118,787),(53119,788),(53120,789),(53121,790),(53122,791),(53123,792),(53124,793),(53125,794),(53126,795),(53127,796),(53128,797),(53129,798),(53130,799),(53131,800),(53132,801),(53133,802),(53134,803),(53135,804),(53136,805),(53137,806),(53138,807),(53139,808),(53140,809),(53141,810),(53142,811),(53143,812),(53144,813),(53145,814),(53146,815),(53147,816),(53148,817),(53149,818),(53150,819),(53151,820),(53152,821),(53153,822),(53154,823),(53155,824),(53156,825),(53157,826),(53158,827),(53159,828),(53160,829),(53161,830),(53162,831),(53163,832),(53164,833),(53165,834),(53166,835),(53167,836),(53168,837),(53169,838),(53170,839),(53171,840),(53172,841),(53173,842),(53174,843),(53175,844),(53176,845),(53177,846),(53178,847),(53179,848),(53180,849),(53181,850),(53182,851),(53183,852),(53184,853),(53185,854),(53186,855),(53187,856),(53188,857),(53189,858),(53190,859),(53191,860),(53192,861),(53193,862),(53194,863),(53195,864),(53196,865),(53197,866),(53198,867),(53199,868),(53200,869),(53201,870),(53202,871),(53203,872),(53204,873),(53205,874),(53206,875),(53207,876),(53208,877),(53209,878),(53210,879),(53211,880),(53212,881),(53213,882),(53214,883),(53215,884),(53216,885),(53217,886),(53218,887),(53219,888),(53220,889),(53221,890),(53222,891),(53223,892),(53224,893),(53225,894),(53226,895),(53227,896),(53228,897),(53229,898),(53230,899),(53231,900),(53232,901),(53233,902),(53234,903),(53235,904),(53236,905),(53237,906),(53238,907),(53239,908),(53240,909),(53241,910),(53242,911),(53243,912),(53244,913),(53245,914),(53246,915),(53247,916),(53248,917),(53249,918),(53250,919),(53251,920),(53252,921),(53253,922),(53254,923),(53255,924),(53256,925),(53257,926),(53258,927),(53259,928),(53260,929),(53261,930),(53262,931),(53263,932),(53264,933),(53265,934),(53266,935),(53267,936),(53268,937),(53269,938),(53270,939),(53271,940),(53272,941),(53273,942),(53274,943),(53275,944),(53276,945),(53277,946),(53278,947),(53279,948),(53280,949),(53281,950),(53282,951),(53283,952),(53284,953),(53285,954),(53286,955),(53287,956),(53288,957),(53289,958),(53290,959),(53291,960),(53292,961),(53293,962),(53294,963),(53295,964),(53296,965),(53297,966),(53298,967),(53299,968),(53300,969),(53301,970),(53302,971),(53303,972),(53304,973),(53305,974),(53306,975),(53307,976),(53308,977),(53309,978),(53310,979),(53311,980),(53312,981),(53313,982),(53314,983),(53315,984),(53316,985),(53317,986),(53318,987),(53319,988),(53320,989),(53321,990),(53322,991),(53323,992),(53324,993),(53325,994),(53326,995),(53327,996),(53328,997),(53329,998),(53330,999),(53331,1000),(53332,1001),(53333,1002),(53334,1003),(53335,1004),(53336,1005),(53337,1006),(53338,1007),(53339,1008),(53340,1009),(53341,1010),(53342,1011),(53343,1012),(53344,1013),(53345,1014),(53346,1015),(53347,1016),(53348,1017),(53349,1018),(53350,1019),(53351,1020),(53352,1021),(53353,1022),(53354,1023),(53355,1024),(53356,1025),(53357,1026),(53358,1027),(53359,1028),(53360,1029),(53361,1030),(53362,1031),(53363,1032),(53364,1033),(53365,1034),(53366,1035),(53367,1036),(53368,1037),(53369,1038),(53370,1039),(53371,1040),(53372,1041),(53373,1042),(53374,1043),(53375,1044),(53376,1045),(53377,1046),(53378,1047),(53379,1048),(53380,1049),(53381,1050),(53382,1051),(53383,1052),(53384,1053),(53385,1054),(53386,1055),(53387,1056),(53388,1057),(53389,1058),(53390,1059),(53391,1060),(53392,1061),(53393,1062),(53394,1063),(53395,1064),(53396,1065),(53397,1066),(53398,1067),(53399,1068),(53400,1069),(53401,1070),(53402,1071),(53403,1072),(53404,1073),(53405,1074),(53406,1075),(53407,1076),(53408,1077),(53409,1078),(53410,1079),(53411,1080),(53412,1081),(53413,1082),(53414,1083),(53415,1084),(53416,1085),(53417,1086),(53418,1087),(53419,1088),(53420,1089),(53421,1090),(53422,1091),(53423,1092),(53424,1093),(53425,1094),(53426,1095),(53427,1096),(53428,1097),(53429,1098),(53430,1099),(53431,1100),(53432,1101),(53433,1102),(53434,1103),(53435,1104),(53436,1105),(53437,1106),(53438,1107),(53439,1108),(53440,1109),(53441,1110),(53442,1111),(53443,1112),(53444,1113),(53445,1114),(53446,1115),(53447,1116),(53448,1117),(53449,1118),(53450,1119),(53451,1120),(53452,1121),(53453,1122),(53454,1123),(53455,1124),(53456,1125),(53457,1126),(53458,1127),(53459,1128),(53460,1129),(53461,1130),(53462,1131),(53463,1132),(53464,1133),(53465,1134),(53466,1135),(53467,1136),(53468,1137),(53469,1138),(53470,1139),(53471,1140),(53472,1141),(53473,1142),(53474,1143),(53475,1144),(53476,1145),(53477,1146),(53478,1147),(53479,1148),(53480,1149),(53481,1150),(53482,1151),(53483,1152),(53484,1153),(53485,1154),(53486,1155),(53487,1156),(53488,1157),(53489,1158),(53490,1159),(53491,1160),(53492,1161),(53493,1162),(53494,1163),(53495,1164),(53496,1165),(53497,1166),(53498,1167),(53499,1168),(53500,1169),(53501,1170),(53502,1171),(53503,1172),(53504,1173),(53505,1174),(53506,1175),(53507,1176),(53508,1177),(53509,1178),(53510,1179),(53511,1180),(53512,1181),(53513,1182),(53514,1183),(53515,1184),(53516,1185),(53517,1186),(53518,1187),(53519,1188),(53520,1189),(53521,1190),(53522,1191),(53523,1192),(53524,1193),(53525,1194),(53526,1195),(53527,1196),(53528,1197),(53529,1198),(53530,1199),(53531,1200),(53532,1201),(53533,1202),(53534,1203),(53535,1204),(53536,1205),(53537,1206),(53538,1207),(53539,1208),(53540,1209),(53541,1210),(53542,1211),(53543,1212),(53544,1213),(53545,1214),(53546,1215),(53547,1216),(53548,1217),(53549,1218),(53550,1219),(53551,1220),(53552,1221),(53553,1222),(53554,1223),(53555,1224),(53556,1225),(53557,1226),(53558,1227),(53559,1228),(53560,1229),(53561,1230),(53562,1231),(53563,1232),(53564,1233),(53565,1234),(53566,1235),(53567,1236),(53568,1237),(53569,1238),(53570,1239),(53571,1240),(53572,1241),(53573,1242),(53574,1243),(53575,1244),(53576,1245),(53577,1246),(53578,1247),(53579,1248),(53580,1249),(53581,1250),(53582,1251),(53583,1252),(53584,1253),(53585,1254),(53586,1255),(53587,1256),(53588,1257),(53589,1258),(53590,1259),(53591,1260),(53592,1261),(53593,1262),(53594,1263),(53595,1264),(53596,1265),(53597,1266),(53598,1267),(53599,1268),(53600,1269),(53601,1270),(53602,1271),(53603,1272),(53604,1273),(53605,1274),(53606,1275),(53607,1276),(53608,1277),(53609,1278),(53610,1279),(53611,1280),(53612,1281),(53613,1282),(53614,1283),(53615,1284),(53616,1285),(53617,1286),(53618,1287),(53619,1288),(53620,1289),(53621,1290),(53622,1291),(53623,1292),(53624,1293),(53625,1294),(53626,1295),(53627,1296),(53628,1297),(53629,1298),(53630,1299),(53631,1300),(53632,1301),(53633,1302),(53634,1303),(53635,1304),(53636,1305),(53637,1306),(53638,1307),(53639,1308),(53640,1309),(53641,1310),(53642,1311),(53643,1312),(53644,1313),(53645,1314),(53646,1315),(53647,1316),(53648,1317),(53649,1318),(53650,1319),(53651,1320),(53652,1321),(53653,1322),(53654,1323),(53655,1324),(53656,1325),(53657,1326),(53658,1327),(53659,1328),(53660,1329),(53661,1330),(53662,1331),(53663,1332),(53664,1333),(53665,1334),(53666,1335),(53667,1336),(53668,1337),(53669,1338),(53670,1339),(53671,1340),(53672,1341),(53673,1342),(53674,1343),(53675,1344),(53676,1345),(53677,1346),(53678,1347),(53679,1348),(53680,1349),(53681,1350),(53682,1351),(53683,1352),(53684,1353),(53685,1354),(53686,1355),(53687,1356),(53688,1357),(53689,1358),(53690,1359),(53691,1360),(53692,1361),(53693,1362),(53694,1363),(53695,1364),(53696,1365),(53697,1366),(53698,1367),(53699,1368),(53700,1369),(53701,1370),(53702,1371),(53703,1372),(53704,1373),(53705,1374),(53706,1375),(53707,1376),(53708,1377),(53709,1378),(53710,1379),(53711,1380),(53712,1381),(53713,1382),(53714,1383),(53715,1384),(53716,1385),(53717,1386),(53718,1387),(53719,1388),(53720,1389),(53721,1390),(53722,1391),(53723,1392),(53724,1393),(53725,1394),(53726,1395),(53727,1396),(53728,1397),(53729,1398),(53730,1399),(53731,1400),(53732,1401),(53733,1402),(53734,1403),(53735,1404),(53736,1405),(53737,1406),(53738,1407),(53739,1408),(53740,1409),(53741,1410),(53742,1411),(53743,1412),(53744,1413),(53745,1414),(53746,1415),(53747,1416),(53748,1417),(53749,1418),(53750,1419),(53751,1420),(53752,1421),(53753,1422),(53754,1423),(53755,1424),(53756,1425),(53757,1426),(53758,1427),(53759,1428),(53760,1429),(53761,1430),(53762,1431),(53763,1432),(53764,1433),(53765,1434),(53766,1435),(53767,1436),(53768,1437),(53769,1438),(53770,1439),(53771,1440),(53772,1441),(53773,1442),(53774,1443),(53775,1444),(53776,1445),(53777,1446),(53778,1447),(53779,1448),(53780,1449),(53781,1450),(53782,1451),(53783,1452),(53784,1453),(53785,1454),(53786,1455),(53787,1456),(53788,1457),(53789,1458),(53790,1459),(53791,1460),(53792,1461),(53793,1462),(53794,1463),(53795,1464),(53796,1465),(53797,1466),(53798,1467),(53799,1468),(53800,1469),(53801,1470),(53802,1471),(53803,1472),(53804,1473),(53805,1474),(53806,1475),(53807,1476),(53808,1477),(53809,1478),(53810,1479),(53811,1480),(53812,1481),(53813,1482),(53814,1483),(53815,1484),(53816,1485),(53817,1486),(53818,1487),(53819,1488),(53820,1489),(53821,1490),(53822,1491),(53823,1492),(53824,1493),(53825,1494),(53826,1495),(53827,1496),(53828,1497),(53829,1498),(53830,1499),(53831,1500),(53832,1501),(53833,1502),(53834,1503),(53835,1504),(53836,1505),(53837,1506),(53838,1507),(53839,1508),(53840,1509),(53841,1510),(53842,1511),(53843,1512),(53844,1513),(53845,1514),(53846,1515),(53847,1516),(53848,1517),(53849,1518),(53850,1519),(53851,1520),(53852,1521),(53853,1522),(53854,1523),(53855,1524),(53856,1525),(53857,1526),(53858,1527),(53859,1528),(53860,1529),(53861,1530),(53862,1531),(53863,1532),(53864,1533),(53865,1534),(53866,1535),(53867,1536),(53868,1537),(53869,1538),(53870,1539),(53871,1540),(53872,1541),(53873,1542),(53874,1543),(53875,1544),(53876,1545),(53877,1546),(53878,1547),(53879,1548),(53880,1549),(53881,1550),(53882,1551),(53883,1552),(53884,1553),(53885,1554),(53886,1555),(53887,1556),(53888,1557),(53889,1558),(53890,1559),(53891,1560),(53892,1561),(53893,1562),(53894,1563),(53895,1564),(53896,1565),(53897,1566),(53898,1567),(53899,1568),(53900,1569),(53901,1570),(53902,1571),(53903,1572),(53904,1573),(53905,1574),(53906,1575),(53907,1576),(53908,1577),(53909,1578),(53910,1579),(53911,1580),(53912,1581),(53913,1582),(53914,1583),(53915,1584),(53916,1585),(53917,1586),(53918,1587),(53919,1588),(53920,1589),(53921,1590),(53922,1591),(53923,1592),(53924,1593),(53925,1594),(53926,1595),(53927,1596),(53928,1597),(53929,1598),(53930,1599),(53931,1600),(53932,1601),(53933,1602),(53934,1603),(53935,1604),(53936,1605),(53937,1606),(53938,1607),(53939,1608),(53940,1609),(53941,1610),(53942,1611),(53943,1612),(53944,1613),(53945,1614),(53946,1615),(53947,1616),(53948,1617),(53949,1618),(53950,1619),(53951,1620),(53952,1621),(53953,1622),(53954,1623),(53955,1624),(53956,1625),(53957,1626),(53958,1627),(53959,1628),(53960,1629),(53961,1630),(53962,1631),(53963,1632),(53964,1633),(53965,1634),(53966,1635),(53967,1636),(53968,1637),(53969,1638),(53970,1639),(53971,1640),(53972,1641),(53973,1642),(53974,1643),(53975,1644),(53976,1645),(53977,1646),(53978,1647),(53979,1648),(53980,1649),(53981,1650),(53982,1651),(53983,1652),(53984,1653),(53985,1654),(53986,1655),(53987,1656),(53988,1657),(53989,1658),(53990,1659),(53991,1660),(53992,1661),(53993,1662),(53994,1663),(53995,1664),(53996,1665),(53997,1666),(53998,1667),(53999,1668),(54000,1669),(54001,1670),(54002,1671),(54003,1672),(54004,1673),(54005,1674),(54006,1675),(54007,1676),(54008,1677),(54009,1678),(54010,1679),(54011,1680),(54012,1681),(54013,1682),(54014,1683),(54015,1684),(54016,1685),(54017,1686),(54018,1687),(54019,1688),(54020,1689),(54021,1690),(54022,1691),(54023,1692),(54024,1693),(54025,1694),(54026,1695),(54027,1696),(54028,1697),(54029,1698),(54030,1699),(54031,1700),(54032,1701),(54033,1702),(54034,1703),(54035,1704),(54036,1705),(54037,1706),(54038,1707),(54039,1708),(54040,1709),(54041,1710),(54042,1711),(54043,1712),(54044,1713),(54045,1714),(54046,1715),(54047,1716),(54048,1717),(54049,1718),(54050,1719),(54051,1720),(54052,1721),(54053,1722),(54054,1723),(54055,1724),(54056,1725),(54057,1726),(54058,1727),(54059,1728),(54060,1729),(54061,1730),(54062,1731),(54063,1732),(54064,1733),(54065,1734),(54066,1735),(54067,1736),(54068,1737),(54069,1738),(54070,1739),(54071,1740),(54072,1741),(54073,1742),(54074,1743),(54075,1744),(54076,1745),(54077,1746),(54078,1747),(54079,1748),(54080,1749),(54081,1750),(54082,1751),(54083,1752),(54084,1753),(54085,1754),(54086,1755),(54087,1756),(54088,1757),(54089,1758),(54090,1759),(54091,1760),(54092,1761),(54093,1762),(54094,1763),(54095,1764),(54096,1765),(54097,1766),(54098,1767),(54099,1768),(54100,1769),(54101,1770),(54102,1771),(54103,1772),(54104,1773),(54105,1774),(54106,1775),(54107,1776),(54108,1777),(54109,1778),(54110,1779),(54111,1780),(54112,1781),(54113,1782),(54114,1783),(54115,1784),(54116,1785),(54117,1786),(54118,1787),(54119,1788),(54120,1789),(54121,1790),(54122,1791),(54123,1792),(54124,1793),(54125,1794),(54126,1795),(54127,1796),(54128,1797),(54129,1798),(54130,1799),(54131,1800),(54132,1801),(54133,1802),(54134,1803),(54135,1804),(54136,1805),(54137,1806),(54138,1807),(54139,1808),(54140,1809),(54141,1810),(54142,1811),(54143,1812),(54144,1813),(54145,1814),(54146,1815),(54147,1816),(54148,1817),(54149,1818),(54150,1819),(54151,1820),(54152,1821),(54153,1822),(54154,1823),(54155,1824),(54156,1825),(54157,1826),(54158,1827),(54159,1828),(54160,1829),(54161,1830),(54162,1831),(54163,1832),(54164,1833),(54165,1834),(54166,1835),(54167,1836),(54168,1837),(54169,1838),(54170,1839),(54171,1840),(54172,1841),(54173,1842),(54174,1843),(54175,1844),(54176,1845),(54177,1846),(54178,1847),(54179,1848),(54180,1849),(54181,1850),(54182,1851),(54183,1852),(54184,1853),(54185,1854),(54186,1855),(54187,1856),(54188,1857),(54189,1858),(54190,1859),(54191,1860),(54192,1861),(54193,1862),(54194,1863),(54195,1864),(54196,1865),(54197,1866),(54198,1867),(54199,1868),(54200,1869),(54201,1870),(54202,1871),(54203,1872),(54204,1873),(54205,1874),(54206,1875),(54207,1876),(54208,1877),(54209,1878),(54210,1879),(54211,1880),(54212,1881),(54213,1882),(54214,1883),(54215,1884),(54216,1885),(54217,1886),(54218,1887),(54219,1888),(54220,1889),(54221,1890),(54222,1891),(54223,1892),(54224,1893),(54225,1894),(54226,1895),(54227,1896),(54228,1897),(54229,1898),(54230,1899),(54231,1900),(54232,1901),(54233,1902),(54234,1903),(54235,1904),(54236,1905),(54237,1906),(54238,1907),(54239,1908),(54240,1909),(54241,1910),(54242,1911),(54243,1912),(54244,1913),(54245,1914),(54246,1915),(54247,1916),(54248,1917),(54249,1918),(54250,1919),(54251,1920),(54252,1921),(54253,1922),(54254,1923),(54255,1924),(54256,1925),(54257,1926),(54258,1927),(54259,1928),(54260,1929),(54261,1930),(54262,1931),(54263,1932),(54264,1933),(54265,1934),(54266,1935),(54267,1936),(54268,1937),(54269,1938),(54270,1939),(54271,1940),(54272,1941),(54273,1942),(54274,1943),(54275,1944),(54276,1945),(54277,1946),(54278,1947),(54279,1948),(54280,1949),(54281,1950),(54282,1951),(54283,1952),(54284,1953),(54285,1954),(54286,1955),(54287,1956),(54288,1957),(54289,1958),(54290,1959),(54291,1960),(54292,1961),(54293,1962),(54294,1963),(54295,1964),(54296,1965),(54297,1966),(54298,1967),(54299,1968),(54300,1969),(54301,1970),(54302,1971),(54303,1972),(54304,1973),(54305,1974),(54306,1975),(54307,1976),(54308,1977),(54309,1978),(54310,1979),(54311,1980),(54312,1981),(54313,1982),(54314,1983),(54315,1984),(54316,1985),(54317,1986),(54318,1987),(54319,1988),(54320,1989),(54321,1990),(54322,1991),(54323,1992),(54324,1993),(54325,1994),(54326,1995),(54327,1996),(54328,1997),(54329,1998),(54330,1999),(54331,2000),(54332,2001),(54333,2002),(54334,2003),(54335,2004),(54336,2005),(54337,2006),(54338,2007),(54339,2008),(54340,2009),(54341,2010),(54342,2011),(54343,2012),(54344,2013),(54345,2014),(54346,2015),(54347,2016),(54348,2017),(54349,2018),(54350,2019),(54351,2020),(54352,2021),(54353,2022),(54354,2023),(54355,2024),(54356,2025),(54357,2026),(54358,2027),(54359,2028),(54360,2029),(54361,2030),(54362,2031),(54363,2032),(54364,2033),(54365,2034),(54366,2035),(54367,2036),(54368,2037),(54369,2038),(54370,2039),(54371,2040),(54372,2041),(54373,2042),(54374,2043),(54375,2044),(54376,2045),(54377,2046),(54378,2047),(54379,2048),(54380,2049),(54381,2050),(54382,2051),(54383,2052),(54384,2053),(54385,2054),(54386,2055),(54387,2056),(54388,2057),(54389,2058),(54390,2059),(54391,2060),(54392,2061),(54393,2062),(54394,2063),(54395,2064),(54396,2065),(54397,2066),(54398,2067),(54399,2068),(54400,2069),(54401,2070),(54402,2071),(54403,2072),(54404,2073),(54405,2074),(54406,2075),(54407,2076),(54408,2077),(54409,2078),(54410,2079),(54411,2080),(54412,2081),(54413,2082),(54414,2083),(54415,2084),(54416,2085),(54417,2086),(54418,2087),(54419,2088),(54420,2089),(54421,2090),(54422,2091),(54423,2092),(54424,2093),(54425,2094),(54426,2095),(54427,2096),(54428,2097),(54429,2098),(54430,2099),(54431,2100),(54432,2101),(54433,2102),(54434,2103),(54435,2104),(54436,2105),(54437,2106),(54438,2107),(54439,2108),(54440,2109),(54441,2110),(54442,2111),(54443,2112),(54444,2113),(54445,2114),(54446,2115),(54447,2116),(54448,2117),(54449,2118),(54450,2119),(54451,2120),(54452,2121),(54453,2122),(54454,2123),(54455,2124),(54456,2125),(54457,2126),(54458,2127),(54459,2128),(54460,2129),(54461,2130),(54462,2131),(54463,2132),(54464,2133),(54465,2134),(54466,2135),(54467,2136),(54468,2137),(54469,2138),(54470,2139),(54471,2140),(54472,2141),(54473,2142),(54474,2143),(54475,2144),(54476,2145),(54477,2146),(54478,2147),(54479,2148),(54480,2149),(54481,2150),(54482,2151),(54483,2152),(54484,2153),(54485,2154),(54486,2155),(54487,2156),(54488,2157),(54489,2158),(54490,2159),(54491,2160),(54492,2161),(54493,2162),(54494,2163),(54495,2164),(54496,2165),(54497,2166),(54498,2167),(54499,2168),(54500,2169),(54501,2170),(54502,2171),(54503,2172),(54504,2173),(54505,2174),(54506,2175),(54507,2176),(54508,2177),(54509,2178),(54510,2179),(54511,2180),(54512,2181),(54513,2182),(54514,2183),(54515,2184),(54516,2185),(54517,2186),(54518,2187),(54519,2188),(54520,2189),(54521,2190),(54522,2191),(54523,2192),(54524,2193),(54525,2194),(54526,2195),(54527,2196),(54528,2197),(54529,2198),(54530,2199),(54531,2200),(54532,2201),(54533,2202),(54534,2203),(54535,2204),(54536,2205),(54537,2206),(54538,2207),(54539,2208),(54540,2209),(54541,2210),(54542,2211),(54543,2212),(54544,2213),(54545,2214),(54546,2215),(54547,2216),(54548,2217),(54549,2218),(54550,2219),(54551,2220),(54552,2221),(54553,2222),(54554,2223),(54555,2224),(54556,2225),(54557,2226),(54558,2227),(54559,2228),(54560,2229),(54561,2230),(54562,2231),(54563,2232),(54564,2233),(54565,2234),(54566,2235),(54567,2236),(54568,2237),(54569,2238),(54570,2239),(54571,2240),(54572,2241),(54573,2242),(54574,2243),(54575,2244),(54576,2245),(54577,2246),(54578,2247),(54579,2248),(54580,2249),(54581,2250),(54582,2251),(54583,2252),(54584,2253),(54585,2254),(54586,2255),(54587,2256),(54588,2257),(54589,2258),(54590,2259),(54591,2260),(54592,2261),(54593,2262),(54594,2263),(54595,2264),(54596,2265),(54597,2266),(54598,2267),(54599,2268),(54600,2269),(54601,2270),(54602,2271),(54603,2272),(54604,2273),(54605,2274),(54606,2275),(54607,2276),(54608,2277),(54609,2278),(54610,2279),(54611,2280),(54612,2281),(54613,2282),(54614,2283),(54615,2284),(54616,2285),(54617,2286),(54618,2287),(54619,2288),(54620,2289),(54621,2290),(54622,2291),(54623,2292),(54624,2293),(54625,2294),(54626,2295),(54627,2296),(54628,2297),(54629,2298),(54630,2299),(54631,2300),(54632,2301),(54633,2302),(54634,2303),(54635,2304),(54636,2305),(54637,2306),(54638,2307),(54639,2308),(54640,2309),(54641,2310),(54642,2311),(54643,2312),(54644,2313),(54645,2314),(54646,2315),(54647,2316),(54648,2317),(54649,2318),(54650,2319),(54651,2320),(54652,2321),(54653,2322),(54654,2323),(54655,2324),(54656,2325),(54657,2326),(54658,2327),(54659,2328),(54660,2329),(54661,2330),(54662,2331),(54663,2332),(54664,2333),(54665,2334),(54666,2335),(54667,2336),(54668,2337),(54669,2338),(54670,2339),(54671,2340),(54672,2341),(54673,2342),(54674,2343),(54675,2344),(54676,2345),(54677,2346),(54678,2347),(54679,2348),(54680,2349),(54681,2350),(54682,2351),(54683,2352),(54684,2353),(54685,2354),(54686,2355),(54687,2356),(54688,2357),(54689,2358),(54690,2359),(54691,2360),(54692,2361),(54693,2362),(54694,2363),(54695,2364),(54696,2365),(54697,2366),(54698,2367),(54699,2368),(54700,2369),(54701,2370),(54702,2371),(54703,2372),(54704,2373),(54705,2374),(54706,2375),(54707,2376),(54708,2377),(54709,2378),(54710,2379),(54711,2380),(54712,2381),(54713,2382),(54714,2383),(54715,2384),(54716,2385),(54717,2386),(54718,2387),(54719,2388),(54720,2389),(54721,2390),(54722,2391),(54723,2392),(54724,2393),(54725,2394),(54726,2395),(54727,2396),(54728,2397),(54729,2398),(54730,2399),(54731,2400),(54732,2401),(54733,2402),(54734,2403),(54735,2404),(54736,2405),(54737,2406),(54738,2407),(54739,2408),(54740,2409),(54741,2410),(54742,2411),(54743,2412),(54744,2413),(54745,2414),(54746,2415),(54747,2416),(54748,2417),(54749,2418),(54750,2419),(54751,2420),(54752,2421),(54753,2422),(54754,2423),(54755,2424),(54756,2425),(54757,2426),(54758,2427),(54759,2428),(54760,2429),(54761,2430),(54762,2431),(54763,2432),(54764,2433),(54765,2434),(54766,2435),(54767,2436),(54768,2437),(54769,2438),(54770,2439),(54771,2440),(54772,2441),(54773,2442),(54774,2443),(54775,2444),(54776,2445),(54777,2446),(54778,2447),(54779,2448),(54780,2449),(54781,2450),(54782,2451),(54783,2452),(54784,2453),(54785,2454),(54786,2455),(54787,2456),(54788,2457),(54789,2458),(54790,2459),(54791,2460),(54792,2461),(54793,2462),(54794,2463),(54795,2464),(54796,2465),(54797,2466),(54798,2467),(54799,2468),(54800,2469),(54801,2470),(54802,2471),(54803,2472),(54804,2473),(54805,2474),(54806,2475),(54807,2476),(54808,2477),(54809,2478),(54810,2479),(54811,2480),(54812,2481),(54813,2482),(54814,2483),(54815,2484),(54816,2485),(54817,2486),(54818,2487),(54819,2488),(54820,2489),(54821,2490),(54822,2491),(54823,2492),(54824,2493),(54825,2494),(54826,2495),(54827,2496),(54828,2497),(54829,2498),(54830,2499),(54831,2500),(54832,2501),(54833,2502),(54834,2503),(54835,2504),(54836,2505),(54837,2506),(54838,2507),(54839,2508),(54840,2509),(54841,2510),(54842,2511),(54843,2512),(54844,2513),(54845,2514),(54846,2515),(54847,2516),(54848,2517),(54849,2518),(54850,2519),(54851,2520),(54852,2521),(54853,2522),(54854,2523),(54855,2524),(54856,2525),(54857,2526),(54858,2527),(54859,2528),(54860,2529),(54861,2530),(54862,2531),(54863,2532),(54864,2533),(54865,2534),(54866,2535),(54867,2536),(54868,2537),(54869,2538),(54870,2539),(54871,2540),(54872,2541),(54873,2542),(54874,2543),(54875,2544),(54876,2545),(54877,2546),(54878,2547),(54879,2548),(54880,2549),(54881,2550),(54882,2551),(54883,2552),(54884,2553),(54885,2554),(54886,2555),(54887,2556),(54888,2557),(54889,2558),(54890,2559),(54891,2560),(54892,2561),(54893,2562),(54894,2563),(54895,2564),(54896,2565),(54897,2566),(54898,2567),(54899,2568),(54900,2569),(54901,2570),(54902,2571),(54903,2572),(54904,2573),(54905,2574),(54906,2575),(54907,2576),(54908,2577),(54909,2578),(54910,2579),(54911,2580),(54912,2581),(54913,2582),(54914,2583),(54915,2584),(54916,2585),(54917,2586),(54918,2587),(54919,2588),(54920,2589),(54921,2590),(54922,2591),(54923,2592),(54924,2593),(54925,2594),(54926,2595),(54927,2596),(54928,2597),(54929,2598),(54930,2599),(54931,2600),(54932,2601),(54933,2602),(54934,2603),(54935,2604),(54936,2605),(54937,2606),(54938,2607),(54939,2608),(54940,2609),(54941,2610),(54942,2611),(54943,2612),(54944,2613),(54945,2614),(54946,2615),(54947,2616),(54948,2617),(54949,2618),(54950,2619),(54951,2620),(54952,2621),(54953,2622),(54954,2623),(54955,2624),(54956,2625),(54957,2626),(54958,2627),(54959,2628),(54960,2629),(54961,2630),(54962,2631),(54963,2632),(54964,2633),(54965,2634),(54966,2635),(54967,2636),(54968,2637),(54969,2638),(54970,2639),(54971,2640),(54972,2641),(54973,2642),(54974,2643),(54975,2644),(54976,2645),(54977,2646),(54978,2647),(54979,2648),(54980,2649),(54981,2650),(54982,2651),(54983,2652),(54984,2653),(54985,2654),(54986,2655),(54987,2656),(54988,2657),(54989,2658),(54990,2659),(54991,2660),(54992,2661),(54993,2662),(54994,2663),(54995,2664),(54996,2665),(54997,2666),(54998,2667),(54999,2668),(55000,2669),(55001,2670),(55002,2671),(55003,2672),(55004,2673),(55005,2674),(55006,2675),(55007,2676),(55008,2677),(55009,2678),(55010,2679),(55011,2680),(55012,2681),(55013,2682),(55014,2683),(55015,2684),(55016,2685),(55017,2686),(55018,2687),(55019,2688),(55020,2689),(55021,2690),(55022,2691),(55023,2692),(55024,2693),(55025,2694),(55026,2695),(55027,2696),(55028,2697),(55029,2698),(55030,2699),(55031,2700),(55032,2701),(55033,2702),(55034,2703),(55035,2704),(55036,2705),(55037,2706),(55038,2707),(55039,2708),(55040,2709),(55041,2710),(55042,2711),(55043,2712),(55044,2713),(55045,2714),(55046,2715),(55047,2716),(55048,2717),(55049,2718),(55050,2719),(55051,2720),(55052,2721),(55053,2722),(55054,2723),(55055,2724),(55056,2725),(55057,2726),(55058,2727),(55059,2728),(55060,2729),(55061,2730),(55062,2731),(55063,2732),(55064,2733),(55065,2734),(55066,2735),(55067,2736),(55068,2737),(55069,2738),(55070,2739),(55071,2740),(55072,2741),(55073,2742),(55074,2743),(55075,2744),(55076,2745),(55077,2746),(55078,2747),(55079,2748),(55080,2749),(55081,2750),(55082,2751),(55083,2752),(55084,2753),(55085,2754),(55086,2755),(55087,2756),(55088,2757),(55089,2758),(55090,2759),(55091,2760),(55092,2761),(55093,2762),(55094,2763),(55095,2764),(55096,2765),(55097,2766),(55098,2767),(55099,2768),(55100,2769),(55101,2770),(55102,2771),(55103,2772),(55104,2773),(55105,2774),(55106,2775),(55107,2776),(55108,2777),(55109,2778),(55110,2779),(55111,2780),(55112,2781),(55113,2782),(55114,2783),(55115,2784),(55116,2785),(55117,2786),(55118,2787),(55119,2788),(55120,2789),(55121,2790),(55122,2791),(55123,2792),(55124,2793),(55125,2794),(55126,2795),(55127,2796),(55128,2797),(55129,2798),(55130,2799),(55131,2800),(55132,2801),(55133,2802),(55134,2803),(55135,2804),(55136,2805),(55137,2806),(55138,2807),(55139,2808),(55140,2809),(55141,2810),(55142,2811),(55143,2812),(55144,2813),(55145,2814),(55146,2815),(55147,2816),(55148,2817),(55149,2818),(55150,2819),(55151,2820),(55152,2821),(55153,2822),(55154,2823),(55155,2824),(55156,2825),(55157,2826),(55158,2827),(55159,2828),(55160,2829),(55161,2830),(55162,2831),(55163,2832),(55164,2833),(55165,2834),(55166,2835),(55167,2836),(55168,2837),(55169,2838),(55170,2839),(55171,2840),(55172,2841),(55173,2842),(55174,2843),(55175,2844),(55176,2845),(55177,2846),(55178,2847),(55179,2848),(55180,2849),(55181,2850),(55182,2851),(55183,2852),(55184,2853),(55185,2854),(55186,2855),(55187,2856),(55188,2857),(55189,2858),(55190,2859),(55191,2860),(55192,2861),(55193,2862),(55194,2863),(55195,2864),(55196,2865),(55197,2866),(55198,2867),(55199,2868),(55200,2869),(55201,2870),(55202,2871),(55203,2872),(55204,2873),(55205,2874),(55206,2875),(55207,2876),(55208,2877),(55209,2878),(55210,2879),(55211,2880),(55212,2881),(55213,2882),(55214,2883),(55215,2884),(55216,2885),(55217,2886),(55218,2887),(55219,2888),(55220,2889),(55221,2890),(55222,2891),(55223,2892),(55224,2893),(55225,2894),(55226,2895),(55227,2896),(55228,2897),(55229,2898),(55230,2899),(55231,2900),(55232,2901),(55233,2902),(55234,2903),(55235,2904),(55236,2905),(55237,2906),(55238,2907),(55239,2908),(55240,2909),(55241,2910),(55242,2911),(55243,2912),(55244,2913),(55245,2914),(55246,2915),(55247,2916),(55248,2917),(55249,2918),(55250,2919),(55251,2920),(55252,2921),(55253,2922),(55254,2923),(55255,2924),(55256,2925),(55257,2926),(55258,2927),(55259,2928),(55260,2929),(55261,2930),(55262,2931),(55263,2932),(55264,2933),(55265,2934),(55266,2935),(55267,2936),(55268,2937),(55269,2938),(55270,2939),(55271,2940),(55272,2941),(55273,2942),(55274,2943),(55275,2944),(55276,2945),(55277,2946),(55278,2947),(55279,2948),(55280,2949),(55281,2950),(55282,2951),(55283,2952),(55284,2953),(55285,2954),(55286,2955),(55287,2956),(55288,2957),(55289,2958),(55290,2959),(55291,2960),(55292,2961),(55293,2962),(55294,2963),(55295,2964),(55296,2965),(55297,2966),(55298,2967),(55299,2968),(55300,2969),(55301,2970),(55302,2971),(55303,2972),(55304,2973),(55305,2974),(55306,2975),(55307,2976),(55308,2977),(55309,2978),(55310,2979),(55311,2980),(55312,2981),(55313,2982),(55314,2983),(55315,2984),(55316,2985),(55317,2986),(55318,2987),(55319,2988),(55320,2989),(55321,2990),(55322,2991),(55323,2992),(55324,2993),(55325,2994),(55326,2995),(55327,2996),(55328,2997),(55329,2998),(55330,2999),(55331,3000),(55332,3001),(55333,3002),(55334,3003),(55335,3004),(55336,3005),(55337,3006),(55338,3007),(55339,3008),(55340,3009),(55341,3010),(55342,3011),(55343,3012),(55344,3013),(55345,3014),(55346,3015),(55347,3016),(55348,3017),(55349,3018),(55350,3019),(55351,3020),(55352,3021),(55353,3022),(55354,3023),(55355,3024),(55356,3025),(55357,3026),(55358,3027),(55359,3028),(55360,3029),(55361,3030),(55362,3031),(55363,3032),(55364,3033),(55365,3034),(55366,3035),(55367,3036),(55368,3037),(55369,3038),(55370,3039),(55371,3040),(55372,3041),(55373,3042),(55374,3043),(55375,3044),(55376,3045),(55377,3046),(55378,3047),(55379,3048),(55380,3049),(55381,3050),(55382,3051),(55383,3052),(55384,3053),(55385,3054),(55386,3055),(55387,3056),(55388,3057),(55389,3058),(55390,3059),(55391,3060),(55392,3061),(55393,3062),(55394,3063),(55395,3064),(55396,3065),(55397,3066),(55398,3067),(55399,3068),(55400,3069),(55401,3070),(55402,3071),(55403,3072),(55404,3073),(55405,3074),(55406,3075),(55407,3076),(55408,3077),(55409,3078),(55410,3079),(55411,3080),(55412,3081),(55413,3082),(55414,3083),(55415,3084),(55416,3085),(55417,3086),(55418,3087),(55419,3088),(55420,3089),(55421,3090),(55422,3091),(55423,3092),(55424,3093),(55425,3094),(55426,3095),(55427,3096),(55428,3097),(55429,3098),(55430,3099),(55431,3100),(55432,3101),(55433,3102),(55434,3103),(55435,3104),(55436,3105),(55437,3106),(55438,3107),(55439,3108),(55440,3109),(55441,3110),(55442,3111),(55443,3112),(55444,3113),(55445,3114),(55446,3115),(55447,3116),(55448,3117),(55449,3118),(55450,3119),(55451,3120),(55452,3121),(55453,3122),(55454,3123),(55455,3124),(55456,3125),(55457,3126),(55458,3127),(55459,3128),(55460,3129),(55461,3130),(55462,3131),(55463,3132),(55464,3133),(55465,3134),(55466,3135),(55467,3136),(55468,3137),(55469,3138),(55470,3139),(55471,3140),(55472,3141),(55473,3142),(55474,3143),(55475,3144),(55476,3145),(55477,3146),(55478,3147),(55479,3148),(55480,3149),(55481,3150),(55482,3151),(55483,3152),(55484,3153),(55485,3154),(55486,3155),(55487,3156),(55488,3157),(55489,3158),(55490,3159),(55491,3160),(55492,3161),(55493,3162),(55494,3163),(55495,3164),(55496,3165),(55497,3166),(55498,3167),(55499,3168),(55500,3169),(55501,3170),(55502,3171),(55503,3172),(55504,3173),(55505,3174),(55506,3175),(55507,3176),(55508,3177),(55509,3178),(55510,3179),(55511,3180),(55512,3181),(55513,3182),(55514,3183),(55515,3184),(55516,3185),(55517,3186),(55518,3187),(55519,3188),(55520,3189),(55521,3190),(55522,3191),(55523,3192),(55524,3193),(55525,3194),(55526,3195),(55527,3196),(55528,3197),(55529,3198),(55530,3199),(55531,3200),(55532,3201),(55533,3202),(55534,3203),(55535,3204),(55536,3205),(55537,3206),(55538,3207),(55539,3208),(55540,3209),(55541,3210),(55542,3211),(55543,3212),(55544,3213),(55545,3214),(55546,3215),(55547,3216),(55548,3217),(55549,3218),(55550,3219),(55551,3220),(55552,3221),(55553,3222),(55554,3223),(55555,3224),(55556,3225),(55557,3226),(55558,3227),(55559,3228),(55560,3229),(55561,3230),(55562,3231),(55563,3232),(55564,3233),(55565,3234),(55566,3235),(55567,3236),(55568,3237),(55569,3238),(55570,3239),(55571,3240),(55572,3241),(55573,3242),(55574,3243),(55575,3244),(55576,3245),(55577,3246),(55578,3247),(55579,3248),(55580,3249),(55581,3250),(55582,3251),(55583,3252),(55584,3253),(55585,3254),(55586,3255),(55587,3256),(55588,3257),(55589,3258),(55590,3259),(55591,3260),(55592,3261),(55593,3262),(55594,3263),(55595,3264),(55596,3265),(55597,3266),(55598,3267),(55599,3268),(55600,3269),(55601,3270),(55602,3271),(55603,3272),(55604,3273),(55605,3274),(55606,3275),(55607,3276),(55608,3277),(55609,3278),(55610,3279),(55611,3280),(55612,3281),(55613,3282),(55614,3283),(55615,3284),(55616,3285),(55617,3286),(55618,3287),(55619,3288),(55620,3289),(55621,3290),(55622,3291),(55623,3292),(55624,3293),(55625,3294),(55626,3295),(55627,3296),(55628,3297),(55629,3298),(55630,3299),(55631,3300),(55632,3301),(55633,3302),(55634,3303),(55635,3304),(55636,3305),(55637,3306),(55638,3307),(55639,3308),(55640,3309),(55641,3310),(55642,3311),(55643,3312),(55644,3313),(55645,3314),(55646,3315),(55647,3316),(55648,3317),(55649,3318),(55650,3319),(55651,3320),(55652,3321),(55653,3322),(55654,3323),(55655,3324),(55656,3325),(55657,3326),(55658,3327),(55659,3328),(55660,3329),(55661,3330),(55662,3331),(55663,3332),(55664,3333),(55665,3334),(55666,3335),(55667,3336),(55668,3337),(55669,3338),(55670,3339),(55671,3340),(55672,3341),(55673,3342),(55674,3343),(55675,3344),(55676,3345),(55677,3346),(55678,3347),(55679,3348),(55680,3349),(55681,3350),(55682,3351),(55683,3352),(55684,3353),(55685,3354),(55686,3355),(55687,3356),(55688,3357),(55689,3358),(55690,3359),(55691,3360),(55692,3361),(55693,3362),(55694,3363),(55695,3364),(55696,3365),(55697,3366),(55698,3367),(55699,3368),(55700,3369),(55701,3370),(55702,3371),(55703,3372),(55704,3373),(55705,3374),(55706,3375),(55707,3376),(55708,3377),(55709,3378),(55710,3379),(55711,3380),(55712,3381),(55713,3382),(55714,3383),(55715,3384),(55716,3385),(55717,3386),(55718,3387),(55719,3388),(55720,3389),(55721,3390),(55722,3391),(55723,3392),(55724,3393),(55725,3394),(55726,3395),(55727,3396),(55728,3397),(55729,3398),(55730,3399),(55731,3400),(55732,3401),(55733,3402),(55734,3403),(55735,3404),(55736,3405),(55737,3406),(55738,3407),(55739,3408),(55740,3409),(55741,3410),(55742,3411),(55743,3412),(55744,3413),(55745,3414),(55746,3415),(55747,3416),(55748,3417),(55749,3418),(55750,3419),(55751,3420),(55752,3421),(55753,3422),(55754,3423),(55755,3424),(55756,3425),(55757,3426),(55758,3427),(55759,3428),(55760,3429),(55761,3430),(55762,3431),(55763,3432),(55764,3433),(55765,3434),(55766,3435),(55767,3436),(55768,3437),(55769,3438),(55770,3439),(55771,3440),(55772,3441),(55773,3442),(55774,3443),(55775,3444),(55776,3445),(55777,3446),(55778,3447),(55779,3448),(55780,3449),(55781,3450),(55782,3451),(55783,3452),(55784,3453),(55785,3454),(55786,3455),(55787,3456),(55788,3457),(55789,3458),(55790,3459),(55791,3460),(55792,3461),(55793,3462),(55794,3463),(55795,3464),(55796,3465),(55797,3466),(55798,3467),(55799,3468),(55800,3469),(55801,3470),(55802,3471),(55803,3472),(55804,3473),(55805,3474),(55806,3475),(55807,3476),(55808,3477),(55809,3478),(55810,3479),(55811,3480),(55812,3481),(55813,3482),(55814,3483),(55815,3484),(55816,3485),(55817,3486),(55818,3487),(55819,3488),(55820,3489),(55821,3490),(55822,3491),(55823,3492),(55824,3493),(55825,3494),(55826,3495),(55827,3496),(55828,3497),(55829,3498),(55830,3499),(55831,3500),(55832,3501),(55833,3502),(55834,3503),(55835,3504),(55836,3505),(55837,3506),(55838,3507),(55839,3508),(55840,3509),(55841,3510),(55842,3511),(55843,3512),(55844,3513),(55845,3514),(55846,3515),(55847,3516),(55848,3517),(55849,3518),(55850,3519),(55851,3520),(55852,3521),(55853,3522),(55854,3523),(55855,3524),(55856,3525),(55857,3526),(55858,3527),(55859,3528),(55860,3529),(55861,3530),(55862,3531),(55863,3532),(55864,3533),(55865,3534),(55866,3535),(55867,3536),(55868,3537),(55869,3538),(55870,3539),(55871,3540),(55872,3541),(55873,3542),(55874,3543),(55875,3544),(55876,3545),(55877,3546),(55878,3547),(55879,3548),(55880,3549),(55881,3550),(55882,3551),(55883,3552),(55884,3553),(55885,3554),(55886,3555),(55887,3556),(55888,3557),(55889,3558),(55890,3559),(55891,3560),(55892,3561),(55893,3562),(55894,3563),(55895,3564),(55896,3565),(55897,3566),(55898,3567),(55899,3568),(55900,3569),(55901,3570),(55902,3571),(55903,3572),(55904,3573),(55905,3574),(55906,3575),(55907,3576),(55908,3577),(55909,3578),(55910,3579),(55911,3580),(55912,3581),(55913,3582),(55914,3583),(55915,3584),(55916,3585),(55917,3586),(55918,3587),(55919,3588),(55920,3589),(55921,3590),(55922,3591),(55923,3592),(55924,3593),(55925,3594),(55926,3595),(55927,3596),(55928,3597),(55929,3598),(55930,3599),(55931,3600),(55932,3601),(55933,3602),(55934,3603),(55935,3604),(55936,3605),(55937,3606),(55938,3607),(55939,3608),(55940,3609),(55941,3610),(55942,3611),(55943,3612),(55944,3613),(55945,3614),(55946,3615),(55947,3616),(55948,3617),(55949,3618),(55950,3619),(55951,3620),(55952,3621),(55953,3622),(55954,3623),(55955,3624),(55956,3625),(55957,3626),(55958,3627),(55959,3628),(55960,3629),(55961,3630),(55962,3631),(55963,3632),(55964,3633),(55965,3634),(55966,3635),(55967,3636),(55968,3637),(55969,3638),(55970,3639),(55971,3640),(55972,3641),(55973,3642),(55974,3643),(55975,3644),(55976,3645),(55977,3646),(55978,3647),(55979,3648),(55980,3649),(55981,3650),(55982,3651),(55983,3652),(55984,3653),(55985,3654),(55986,3655),(55987,3656),(55988,3657),(55989,3658),(55990,3659),(55991,3660),(55992,3661),(55993,3662),(55994,3663),(55995,3664),(55996,3665),(55997,3666),(55998,3667),(55999,3668),(56000,3669),(56001,3670),(56002,3671),(56003,3672),(56004,3673),(56005,3674),(56006,3675),(56007,3676),(56008,3677),(56009,3678),(56010,3679),(56011,3680),(56012,3681),(56013,3682),(56014,3683),(56015,3684),(56016,3685),(56017,3686),(56018,3687),(56019,3688),(56020,3689),(56021,3690),(56022,3691),(56023,3692),(56024,3693),(56025,3694),(56026,3695),(56027,3696),(56028,3697),(56029,3698),(56030,3699),(56031,3700),(56032,3701),(56033,3702),(56034,3703),(56035,3704),(56036,3705),(56037,3706),(56038,3707),(56039,3708),(56040,3709),(56041,3710),(56042,3711),(56043,3712),(56044,3713),(56045,3714),(56046,3715),(56047,3716),(56048,3717),(56049,3718),(56050,3719),(56051,3720),(56052,3721),(56053,3722),(56054,3723),(56055,3724),(56056,3725),(56057,3726),(56058,3727),(56059,3728),(56060,3729),(56061,3730),(56062,3731),(56063,3732),(56064,3733),(56065,3734),(56066,3735),(56067,3736),(56068,3737),(56069,3738),(56070,3739),(56071,3740),(56072,3741),(56073,3742),(56074,3743),(56075,3744),(56076,3745),(56077,3746),(56078,3747),(56079,3748),(56080,3749),(56081,3750),(56082,3751),(56083,3752),(56084,3753),(56085,3754),(56086,3755),(56087,3756),(56088,3757),(56089,3758),(56090,3759),(56091,3760),(56092,3761),(56093,3762),(56094,3763),(56095,3764),(56096,3765),(56097,3766),(56098,3767),(56099,3768),(56100,3769),(56101,3770),(56102,3771),(56103,3772),(56104,3773),(56105,3774),(56106,3775),(56107,3776),(56108,3777),(56109,3778),(56110,3779),(56111,3780),(56112,3781),(56113,3782),(56114,3783),(56115,3784),(56116,3785),(56117,3786),(56118,3787),(56119,3788),(56120,3789),(56121,3790),(56122,3791),(56123,3792),(56124,3793),(56125,3794),(56126,3795),(56127,3796),(56128,3797),(56129,3798),(56130,3799),(56131,3800),(56132,3801),(56133,3802),(56134,3803),(56135,3804),(56136,3805),(56137,3806),(56138,3807),(56139,3808),(56140,3809),(56141,3810),(56142,3811),(56143,3812),(56144,3813),(56145,3814),(56146,3815),(56147,3816),(56148,3817),(56149,3818),(56150,3819),(56151,3820),(56152,3821),(56153,3822),(56154,3823),(56155,3824),(56156,3825),(56157,3826),(56158,3827),(56159,3828),(56160,3829),(56161,3830),(56162,3831),(56163,3832),(56164,3833),(56165,3834),(56166,3835),(56167,3836),(56168,3837),(56169,3838),(56170,3839),(56171,3840),(56172,3841),(56173,3842),(56174,3843),(56175,3844),(56176,3845),(56177,3846),(56178,3847),(56179,3848),(56180,3849),(56181,3850),(56182,3851),(56183,3852),(56184,3853),(56185,3854),(56186,3855),(56187,3856),(56188,3857),(56189,3858),(56190,3859),(56191,3860),(56192,3861),(56193,3862),(56194,3863),(56195,3864),(56196,3865),(56197,3866),(56198,3867),(56199,3868),(56200,3869),(56201,3870),(56202,3871),(56203,3872),(56204,3873),(56205,3874),(56206,3875),(56207,3876),(56208,3877),(56209,3878),(56210,3879),(56211,3880),(56212,3881),(56213,3882),(56214,3883),(56215,3884),(56216,3885),(56217,3886),(56218,3887),(56219,3888),(56220,3889),(56221,3890),(56222,3891),(56223,3892),(56224,3893),(56225,3894),(56226,3895),(56227,3896),(56228,3897),(56229,3898),(56230,3899),(56231,3900),(56232,3901),(56233,3902),(56234,3903),(56235,3904),(56236,3905),(56237,3906),(56238,3907),(56239,3908),(56240,3909),(56241,3910),(56242,3911),(56243,3912),(56244,3913),(56245,3914),(56246,3915),(56247,3916),(56248,3917),(56249,3918),(56250,3919),(56251,3920),(56252,3921),(56253,3922),(56254,3923),(56255,3924),(56256,3925),(56257,3926),(56258,3927),(56259,3928),(56260,3929),(56261,3930),(56262,3931),(56263,3932),(56264,3933),(56265,3934),(56266,3935),(56267,3936),(56268,3937),(56269,3938),(56270,3939),(56271,3940),(56272,3941),(56273,3942),(56274,3943),(56275,3944),(56276,3945),(56277,3946),(56278,3947),(56279,3948),(56280,3949),(56281,3950),(56282,3951),(56283,3952),(56284,3953),(56285,3954),(56286,3955),(56287,3956),(56288,3957),(56289,3958),(56290,3959),(56291,3960),(56292,3961),(56293,3962),(56294,3963),(56295,3964),(56296,3965),(56297,3966),(56298,3967),(56299,3968),(56300,3969),(56301,3970),(56302,3971),(56303,3972),(56304,3973),(56305,3974),(56306,3975),(56307,3976),(56308,3977),(56309,3978),(56310,3979),(56311,3980),(56312,3981),(56313,3982),(56314,3983),(56315,3984),(56316,3985),(56317,3986),(56318,3987),(56319,3988),(56320,3989),(56321,3990),(56322,3991),(56323,3992),(56324,3993),(56325,3994),(56326,3995),(56327,3996),(56328,3997),(56329,3998),(56330,3999),(56331,4000),(56332,4001),(56333,4002),(56334,4003),(56335,4004),(56336,4005),(56337,4006),(56338,4007),(56339,4008),(56340,4009),(56341,4010),(56342,4011),(56343,4012),(56344,4013),(56345,4014),(56346,4015),(56347,4016),(56348,4017),(56349,4018),(56350,4019),(56351,4020),(56352,4021),(56353,4022),(56354,4023),(56355,4024),(56356,4025),(56357,4026),(56358,4027),(56359,4028),(56360,4029),(56361,4030),(56362,4031),(56363,4032),(56364,4033),(56365,4034),(56366,4035),(56367,4036),(56368,4037),(56369,4038),(56370,4039),(56371,4040),(56372,4041),(56373,4042),(56374,4043),(56375,4044),(56376,4045),(56377,4046),(56378,4047),(56379,4048),(56380,4049),(56381,4050),(56382,4051),(56383,4052),(56384,4053),(56385,4054),(56386,4055),(56387,4056),(56388,4057),(56389,4058),(56390,4059),(56391,4060),(56392,4061),(56393,4062),(56394,4063),(56395,4064),(56396,4065),(56397,4066),(56398,4067),(56399,4068),(56400,4069),(56401,4070),(56402,4071),(56403,4072),(56404,4073),(56405,4074),(56406,4075),(56407,4076),(56408,4077),(56409,4078),(56410,4079),(56411,4080),(56412,4081),(56413,4082),(56414,4083),(56415,4084),(56416,4085),(56417,4086),(56418,4087),(56419,4088),(56420,4089),(56421,4090),(56422,4091),(56423,4092),(56424,4093),(56425,4094),(56426,4095),(56427,4096),(56428,4097),(56429,4098),(56430,4099),(56431,4100),(56432,4101),(56433,4102),(56434,4103),(56435,4104),(56436,4105),(56437,4106),(56438,4107),(56439,4108),(56440,4109),(56441,4110),(56442,4111),(56443,4112),(56444,4113),(56445,4114),(56446,4115),(56447,4116),(56448,4117),(56449,4118),(56450,4119),(56451,4120),(56452,4121),(56453,4122),(56454,4123),(56455,4124),(56456,4125),(56457,4126),(56458,4127),(56459,4128),(56460,4129),(56461,4130),(56462,4131),(56463,4132),(56464,4133),(56465,4134),(56466,4135),(56467,4136),(56468,4137),(56469,4138),(56470,4139),(56471,4140),(56472,4141),(56473,4142),(56474,4143),(56475,4144),(56476,4145),(56477,4146),(56478,4147),(56479,4148),(56480,4149),(56481,4150),(56482,4151),(56483,4152),(56484,4153),(56485,4154),(56486,4155),(56487,4156),(56488,4157),(56489,4158),(56490,4159),(56491,4160),(56492,4161),(56493,4162),(56494,4163),(56495,4164),(56496,4165),(56497,4166),(56498,4167),(56499,4168),(56500,4169),(56501,4170),(56502,4171),(56503,4172),(56504,4173),(56505,4174),(56506,4175),(56507,4176),(56508,4177),(56509,4178),(56510,4179),(56511,4180),(56512,4181),(56513,4182),(56514,4183),(56515,4184),(56516,4185),(56517,4186),(56518,4187),(56519,4188),(56520,4189),(56521,4190),(56522,4191),(56523,4192),(56524,4193),(56525,4194),(56526,4195),(56527,4196),(56528,4197),(56529,4198),(56530,4199),(56531,4200),(56532,4201),(56533,4202),(56534,4203),(56535,4204),(56536,4205),(56537,4206),(56538,4207),(56539,4208),(56540,4209),(56541,4210),(56542,4211),(56543,4212),(56544,4213),(56545,4214),(56546,4215),(56547,4216),(56548,4217),(56549,4218),(56550,4219),(56551,4220),(56552,4221),(56553,4222),(56554,4223),(56555,4224),(56556,4225),(56557,4226),(56558,4227),(56559,4228),(56560,4229),(56561,4230),(56562,4231),(56563,4232),(56564,4233),(56565,4234),(56566,4235),(56567,4236),(56568,4237),(56569,4238),(56570,4239),(56571,4240),(56572,4241),(56573,4242),(56574,4243),(56575,4244),(56576,4245),(56577,4246),(56578,4247),(56579,4248),(56580,4249),(56581,4250),(56582,4251),(56583,4252),(56584,4253),(56585,4254),(56586,4255),(56587,4256),(56588,4257),(56589,4258),(56590,4259),(56591,4260),(56592,4261),(56593,4262),(56594,4263),(56595,4264),(56596,4265),(56597,4266),(56598,4267),(56599,4268),(56600,4269),(56601,4270),(56602,4271),(56603,4272),(56604,4273),(56605,4274),(56606,4275),(56607,4276),(56608,4277),(56609,4278),(56610,4279),(56611,4280),(56612,4281),(56613,4282),(56614,4283),(56615,4284),(56616,4285),(56617,4286),(56618,4287),(56619,4288),(56620,4289),(56621,4290),(56622,4291),(56623,4292),(56624,4293),(56625,4294),(56626,4295),(56627,4296),(56628,4297),(56629,4298),(56630,4299),(56631,4300),(56632,4301),(56633,4302),(56634,4303),(56635,4304),(56636,4305),(56637,4306),(56638,4307),(56639,4308),(56640,4309),(56641,4310),(56642,4311),(56643,4312),(56644,4313),(56645,4314),(56646,4315),(56647,4316),(56648,4317),(56649,4318),(56650,4319),(56651,4320),(56652,4321),(56653,4322),(56654,4323),(56655,4324),(56656,4325),(56657,4326),(56658,4327),(56659,4328),(56660,4329),(56661,4330),(56662,4331),(56663,4332),(56664,4333),(56665,4334),(56666,4335),(56667,4336),(56668,4337),(56669,4338),(56670,4339),(56671,4340),(56672,4341),(56673,4342),(56674,4343),(56675,4344),(56676,4345),(56677,4346),(56678,4347),(56679,4348),(56680,4349),(56681,4350),(56682,4351),(56683,4352),(56684,4353),(56685,4354),(56686,4355),(56687,4356),(56688,4357),(56689,4358),(56690,4359),(56691,4360),(56692,4361),(56693,4362),(56694,4363),(56695,4364),(56696,4365),(56697,4366),(56698,4367),(56699,4368),(56700,4369),(56701,4370),(56702,4371),(56703,4372),(56704,4373),(56705,4374),(56706,4375),(56707,4376),(56708,4377),(56709,4378),(56710,4379),(56711,4380),(56712,4381),(56713,4382),(56714,4383),(56715,4384),(56716,4385),(56717,4386),(56718,4387),(56719,4388),(56720,4389),(56721,4390),(56722,4391),(56723,4392),(56724,4393),(56725,4394),(56726,4395),(56727,4396),(56728,4397),(56729,4398),(56730,4399),(56731,4400),(56732,4401),(56733,4402),(56734,4403),(56735,4404),(56736,4405),(56737,4406),(56738,4407),(56739,4408),(56740,4409),(56741,4410),(56742,4411),(56743,4412),(56744,4413),(56745,4414),(56746,4415),(56747,4416),(56748,4417),(56749,4418),(56750,4419),(56751,4420),(56752,4421),(56753,4422),(56754,4423),(56755,4424),(56756,4425),(56757,4426),(56758,4427),(56759,4428),(56760,4429),(56761,4430),(56762,4431),(56763,4432),(56764,4433),(56765,4434),(56766,4435),(56767,4436),(56768,4437),(56769,4438),(56770,4439),(56771,4440),(56772,4441),(56773,4442),(56774,4443),(56775,4444),(56776,4445),(56777,4446),(56778,4447),(56779,4448),(56780,4449),(56781,4450),(56782,4451),(56783,4452),(56784,4453),(56785,4454),(56786,4455),(56787,4456),(56788,4457),(56789,4458),(56790,4459),(56791,4460),(56792,4461),(56793,4462),(56794,4463),(56795,4464),(56796,4465),(56797,4466),(56798,4467),(56799,4468),(56800,4469),(56801,4470),(56802,4471),(56803,4472),(56804,4473),(56805,4474),(56806,4475),(56807,4476),(56808,4477),(56809,4478),(56810,4479),(56811,4480),(56812,4481),(56813,4482),(56814,4483),(56815,4484),(56816,4485),(56817,4486),(56818,4487),(56819,4488),(56820,4489),(56821,4490),(56822,4491),(56823,4492),(56824,4493),(56825,4494),(56826,4495),(56827,4496),(56828,4497),(56829,4498),(56830,4499),(56831,4500),(56832,4501),(56833,4502),(56834,4503),(56835,4504),(56836,4505),(56837,4506),(56838,4507),(56839,4508),(56840,4509),(56841,4510),(56842,4511),(56843,4512),(56844,4513),(56845,4514),(56846,4515),(56847,4516),(56848,4517),(56849,4518),(56850,4519),(56851,4520),(56852,4521),(56853,4522),(56854,4523),(56855,4524),(56856,4525),(56857,4526),(56858,4527),(56859,4528),(56860,4529),(56861,4530),(56862,4531),(56863,4532),(56864,4533),(56865,4534),(56866,4535),(56867,4536),(56868,4537),(56869,4538),(56870,4539),(56871,4540),(56872,4541),(56873,4542),(56874,4543),(56875,4544),(56876,4545),(56877,4546),(56878,4547),(56879,4548),(56880,4549),(56881,4550),(56882,4551),(56883,4552),(56884,4553),(56885,4554),(56886,4555),(56887,4556),(56888,4557),(56889,4558),(56890,4559),(56891,4560),(56892,4561),(56893,4562),(56894,4563),(56895,4564),(56896,4565),(56897,4566),(56898,4567),(56899,4568),(56900,4569),(56901,4570),(56902,4571),(56903,4572),(56904,4573),(56905,4574),(56906,4575),(56907,4576),(56908,4577),(56909,4578),(56910,4579),(56911,4580),(56912,4581),(56913,4582),(56914,4583),(56915,4584),(56916,4585),(56917,4586),(56918,4587),(56919,4588),(56920,4589),(56921,4590),(56922,4591),(56923,4592),(56924,4593),(56925,4594),(56926,4595),(56927,4596),(56928,4597),(56929,4598),(56930,4599),(56931,4600),(56932,4601),(56933,4602),(56934,4603),(56935,4604),(56936,4605),(56937,4606),(56938,4607),(56939,4608),(56940,4609),(56941,4610),(56942,4611),(56943,4612),(56944,4613),(56945,4614),(56946,4615),(56947,4616),(56948,4617),(56949,4618),(56950,4619),(56951,4620),(56952,4621),(56953,4622),(56954,4623),(56955,4624),(56956,4625),(56957,4626),(56958,4627),(56959,4628),(56960,4629),(56961,4630),(56962,4631),(56963,4632),(56964,4633),(56965,4634),(56966,4635),(56967,4636),(56968,4637),(56969,4638),(56970,4639),(56971,4640),(56972,4641),(56973,4642),(56974,4643),(56975,4644),(56976,4645),(56977,4646),(56978,4647),(56979,4648),(56980,4649),(56981,4650),(56982,4651),(56983,4652),(56984,4653),(56985,4654),(56986,4655),(56987,4656),(56988,4657),(56989,4658),(56990,4659),(56991,4660),(56992,4661),(56993,4662),(56994,4663),(56995,4664),(56996,4665),(56997,4666),(56998,4667),(56999,4668),(57000,4669),(57001,4670),(57002,4671),(57003,4672),(57004,4673),(57005,4674),(57006,4675),(57007,4676),(57008,4677),(57009,4678),(57010,4679),(57011,4680),(57012,4681),(57013,4682),(57014,4683),(57015,4684),(57016,4685),(57017,4686),(57018,4687),(57019,4688),(57020,4689),(57021,4690),(57022,4691),(57023,4692),(57024,4693),(57025,4694),(57026,4695),(57027,4696),(57028,4697),(57029,4698),(57030,4699),(57031,4700),(57032,4701),(57033,4702),(57034,4703),(57035,4704),(57036,4705),(57037,4706),(57038,4707),(57039,4708),(57040,4709),(57041,4710),(57042,4711),(57043,4712),(57044,4713),(57045,4714),(57046,4715),(57047,4716),(57048,4717),(57049,4718),(57050,4719),(57051,4720),(57052,4721),(57053,4722),(57054,4723),(57055,4724),(57056,4725),(57057,4726),(57058,4727),(57059,4728),(57060,4729),(57061,4730),(57062,4731),(57063,4732),(57064,4733),(57065,4734),(57066,4735),(57067,4736),(57068,4737),(57069,4738),(57070,4739),(57071,4740),(57072,4741),(57073,4742),(57074,4743),(57075,4744),(57076,4745),(57077,4746),(57078,4747),(57079,4748),(57080,4749),(57081,4750),(57082,4751),(57083,4752),(57084,4753),(57085,4754),(57086,4755),(57087,4756),(57088,4757),(57089,4758),(57090,4759),(57091,4760),(57092,4761),(57093,4762),(57094,4763),(57095,4764),(57096,4765),(57097,4766),(57098,4767),(57099,4768),(57100,4769),(57101,4770),(57102,4771),(57103,4772),(57104,4773),(57105,4774),(57106,4775),(57107,4776),(57108,4777),(57109,4778),(57110,4779),(57111,4780),(57112,4781),(57113,4782),(57114,4783),(57115,4784),(57116,4785),(57117,4786),(57118,4787),(57119,4788),(57120,4789),(57121,4790),(57122,4791),(57123,4792),(57124,4793),(57125,4794),(57126,4795),(57127,4796),(57128,4797),(57129,4798),(57130,4799),(57131,4800),(57132,4801),(57133,4802),(57134,4803),(57135,4804),(57136,4805),(57137,4806),(57138,4807),(57139,4808),(57140,4809),(57141,4810),(57142,4811),(57143,4812),(57144,4813),(57145,4814),(57146,4815),(57147,4816),(57148,4817),(57149,4818),(57150,4819),(57151,4820),(57152,4821),(57153,4822),(57154,4823),(57155,4824),(57156,4825),(57157,4826),(57158,4827),(57159,4828),(57160,4829),(57161,4830),(57162,4831),(57163,4832),(57164,4833),(57165,4834),(57166,4835),(57167,4836),(57168,4837),(57169,4838),(57170,4839),(57171,4840),(57172,4841),(57173,4842),(57174,4843),(57175,4844),(57176,4845),(57177,4846),(57178,4847),(57179,4848),(57180,4849),(57181,4850),(57182,4851),(57183,4852),(57184,4853),(57185,4854),(57186,4855),(57187,4856),(57188,4857),(57189,4858),(57190,4859),(57191,4860),(57192,4861),(57193,4862),(57194,4863),(57195,4864),(57196,4865),(57197,4866),(57198,4867),(57199,4868),(57200,4869),(57201,4870),(57202,4871),(57203,4872),(57204,4873),(57205,4874),(57206,4875),(57207,4876),(57208,4877),(57209,4878),(57210,4879),(57211,4880),(57212,4881),(57213,4882),(57214,4883),(57215,4884),(57216,4885),(57217,4886),(57218,4887),(57219,4888),(57220,4889),(57221,4890),(57222,4891),(57223,4892),(57224,4893),(57225,4894),(57226,4895),(57227,4896),(57228,4897),(57229,4898),(57230,4899),(57231,4900),(57232,4901),(57233,4902),(57234,4903),(57235,4904),(57236,4905),(57237,4906),(57238,4907),(57239,4908),(57240,4909),(57241,4910),(57242,4911),(57243,4912),(57244,4913),(57245,4914),(57246,4915),(57247,4916),(57248,4917),(57249,4918),(57250,4919),(57251,4920),(57252,4921),(57253,4922),(57254,4923),(57255,4924),(57256,4925),(57257,4926),(57258,4927),(57259,4928),(57260,4929),(57261,4930),(57262,4931),(57263,4932),(57264,4933),(57265,4934),(57266,4935),(57267,4936),(57268,4937),(57269,4938),(57270,4939),(57271,4940),(57272,4941),(57273,4942),(57274,4943),(57275,4944),(57276,4945),(57277,4946),(57278,4947),(57279,4948),(57280,4949),(57281,4950),(57282,4951),(57283,4952),(57284,4953),(57285,4954),(57286,4955),(57287,4956),(57288,4957),(57289,4958),(57290,4959),(57291,4960),(57292,4961),(57293,4962),(57294,4963),(57295,4964),(57296,4965),(57297,4966),(57298,4967),(57299,4968),(57300,4969),(57301,4970),(57302,4971),(57303,4972),(57304,4973),(57305,4974),(57306,4975),(57307,4976),(57308,4977),(57309,4978),(57310,4979),(57311,4980),(57312,4981),(57313,4982),(57314,4983),(57315,4984),(57316,4985),(57317,4986),(57318,4987),(57319,4988),(57320,4989),(57321,4990),(57322,4991),(57323,4992),(57324,4993),(57325,4994),(57326,4995),(57327,4996),(57328,4997),(57329,4998),(57330,4999),(57331,5000),(57332,5001),(57333,5002),(57334,5003),(57335,5004),(57336,5005),(57337,5006),(57338,5007),(57339,5008),(57340,5009),(57341,5010),(57342,5011),(57343,5012),(57344,5013),(57345,5014),(57346,5015),(57347,5016),(57348,5017),(57349,5018),(57350,5019),(57351,5020),(57352,5021),(57353,5022),(57354,5023),(57355,5024),(57356,5025),(57357,5026),(57358,5027),(57359,5028),(57360,5029),(57361,5030),(57362,5031),(57363,5032),(57364,5033),(57365,5034),(57366,5035),(57367,5036),(57368,5037),(57369,5038),(57370,5039),(57371,5040),(57372,5041),(57373,5042),(57374,5043),(57375,5044),(57376,5045),(57377,5046),(57378,5047),(57379,5048),(57380,5049),(57381,5050),(57382,5051),(57383,5052),(57384,5053),(57385,5054),(57386,5055),(57387,5056),(57388,5057),(57389,5058),(57390,5059),(57391,5060),(57392,5061),(57393,5062),(57394,5063),(57395,5064),(57396,5065),(57397,5066),(57398,5067),(57399,5068),(57400,5069),(57401,5070),(57402,5071),(57403,5072),(57404,5073),(57405,5074),(57406,5075),(57407,5076),(57408,5077),(57409,5078),(57410,5079),(57411,5080),(57412,5081),(57413,5082),(57414,5083),(57415,5084),(57416,5085),(57417,5086),(57418,5087),(57419,5088),(57420,5089),(57421,5090),(57422,5091),(57423,5092),(57424,5093),(57425,5094),(57426,5095),(57427,5096),(57428,5097),(57429,5098),(57430,5099),(57431,5100),(57432,5101),(57433,5102),(57434,5103),(57435,5104),(57436,5105),(57437,5106),(57438,5107),(57439,5108),(57440,5109),(57441,5110),(57442,5111),(57443,5112),(57444,5113),(57445,5114),(57446,5115),(57447,5116),(57448,5117),(57449,5118),(57450,5119),(57451,5120),(57452,5121),(57453,5122),(57454,5123),(57455,5124),(57456,5125),(57457,5126),(57458,5127),(57459,5128),(57460,5129),(57461,5130),(57462,5131),(57463,5132),(57464,5133),(57465,5134),(57466,5135),(57467,5136),(57468,5137),(57469,5138),(57470,5139),(57471,5140),(57472,5141),(57473,5142),(57474,5143),(57475,5144),(57476,5145),(57477,5146),(57478,5147),(57479,5148),(57480,5149),(57481,5150),(57482,5151),(57483,5152),(57484,5153),(57485,5154),(57486,5155),(57487,5156),(57488,5157),(57489,5158),(57490,5159),(57491,5160),(57492,5161),(57493,5162),(57494,5163),(57495,5164),(57496,5165),(57497,5166),(57498,5167),(57499,5168),(57500,5169),(57501,5170),(57502,5171),(57503,5172),(57504,5173),(57505,5174),(57506,5175),(57507,5176),(57508,5177),(57509,5178),(57510,5179),(57511,5180),(57512,5181),(57513,5182),(57514,5183),(57515,5184),(57516,5185),(57517,5186),(57518,5187),(57519,5188),(57520,5189),(57521,5190),(57522,5191),(57523,5192),(57524,5193),(57525,5194),(57526,5195),(57527,5196),(57528,5197),(57529,5198),(57530,5199),(57531,5200),(57532,5201),(57533,5202),(57534,5203),(57535,5204),(57536,5205),(57537,5206),(57538,5207),(57539,5208),(57540,5209),(57541,5210),(57542,5211),(57543,5212),(57544,5213),(57545,5214),(57546,5215),(57547,5216),(57548,5217),(57549,5218),(57550,5219),(57551,5220),(57552,5221),(57553,5222),(57554,5223),(57555,5224),(57556,5225),(57557,5226),(57558,5227),(57559,5228),(57560,5229),(57561,5230),(57562,5231),(57563,5232),(57564,5233),(57565,5234),(57566,5235),(57567,5236),(57568,5237),(57569,5238),(57570,5239),(57571,5240),(57572,5241),(57573,5242),(57574,5243),(57575,5244),(57576,5245),(57577,5246),(57578,5247),(57579,5248),(57580,5249),(57581,5250),(57582,5251),(57583,5252),(57584,5253),(57585,5254),(57586,5255),(57587,5256),(57588,5257),(57589,5258),(57590,5259),(57591,5260),(57592,5261),(57593,5262),(57594,5263),(57595,5264),(57596,5265),(57597,5266),(57598,5267),(57599,5268),(57600,5269),(57601,5270),(57602,5271),(57603,5272),(57604,5273),(57605,5274),(57606,5275),(57607,5276),(57608,5277),(57609,5278),(57610,5279),(57611,5280),(57612,5281),(57613,5282),(57614,5283),(57615,5284),(57616,5285),(57617,5286),(57618,5287),(57619,5288),(57620,5289),(57621,5290),(57622,5291),(57623,5292),(57624,5293),(57625,5294),(57626,5295),(57627,5296),(57628,5297),(57629,5298),(57630,5299),(57631,5300),(57632,5301),(57633,5302),(57634,5303),(57635,5304),(57636,5305),(57637,5306),(57638,5307),(57639,5308),(57640,5309),(57641,5310),(57642,5311),(57643,5312),(57644,5313),(57645,5314),(57646,5315),(57647,5316),(57648,5317),(57649,5318),(57650,5319),(57651,5320),(57652,5321),(57653,5322),(57654,5323),(57655,5324),(57656,5325),(57657,5326),(57658,5327),(57659,5328),(57660,5329),(57661,5330),(57662,5331),(57663,5332),(57664,5333),(57665,5334),(57666,5335),(57667,5336),(57668,5337),(57669,5338),(57670,5339),(57671,5340),(57672,5341),(57673,5342),(57674,5343),(57675,5344),(57676,5345),(57677,5346),(57678,5347),(57679,5348),(57680,5349),(57681,5350),(57682,5351),(57683,5352),(57684,5353),(57685,5354),(57686,5355),(57687,5356),(57688,5357),(57689,5358),(57690,5359),(57691,5360),(57692,5361),(57693,5362),(57694,5363),(57695,5364),(57696,5365),(57697,5366),(57698,5367),(57699,5368),(57700,5369),(57701,5370),(57702,5371),(57703,5372),(57704,5373),(57705,5374),(57706,5375),(57707,5376),(57708,5377),(57709,5378),(57710,5379),(57711,5380),(57712,5381),(57713,5382),(57714,5383),(57715,5384),(57716,5385),(57717,5386),(57718,5387),(57719,5388),(57720,5389),(57721,5390),(57722,5391),(57723,5392),(57724,5393),(57725,5394),(57726,5395),(57727,5396),(57728,5397),(57729,5398),(57730,5399),(57731,5400),(57732,5401),(57733,5402),(57734,5403),(57735,5404),(57736,5405),(57737,5406),(57738,5407),(57739,5408),(57740,5409),(57741,5410),(57742,5411),(57743,5412),(57744,5413),(57745,5414),(57746,5415),(57747,5416),(57748,5417),(57749,5418),(57750,5419),(57751,5420),(57752,5421),(57753,5422),(57754,5423),(57755,5424),(57756,5425),(57757,5426),(57758,5427),(57759,5428),(57760,5429),(57761,5430),(57762,5431),(57763,5432),(57764,5433),(57765,5434),(57766,5435),(57767,5436),(57768,5437),(57769,5438),(57770,5439),(57771,5440),(57772,5441),(57773,5442),(57774,5443),(57775,5444),(57776,5445),(57777,5446),(57778,5447),(57779,5448),(57780,5449),(57781,5450),(57782,5451),(57783,5452),(57784,5453),(57785,5454),(57786,5455),(57787,5456),(57788,5457),(57789,5458),(57790,5459),(57791,5460),(57792,5461),(57793,5462),(57794,5463),(57795,5464),(57796,5465),(57797,5466),(57798,5467),(57799,5468),(57800,5469),(57801,5470),(57802,5471),(57803,5472),(57804,5473),(57805,5474),(57806,5475),(57807,5476),(57808,5477),(57809,5478),(57810,5479),(57811,5480),(57812,5481),(57813,5482),(57814,5483),(57815,5484),(57816,5485),(57817,5486),(57818,5487),(57819,5488),(57820,5489),(57821,5490),(57822,5491),(57823,5492),(57824,5493),(57825,5494),(57826,5495),(57827,5496),(57828,5497),(57829,5498),(57830,5499),(57831,5500),(57832,5501),(57833,5502),(57834,5503),(57835,5504),(57836,5505),(57837,5506),(57838,5507),(57839,5508),(57840,5509),(57841,5510),(57842,5511),(57843,5512),(57844,5513),(57845,5514),(57846,5515),(57847,5516),(57848,5517),(57849,5518),(57850,5519),(57851,5520),(57852,5521),(57853,5522),(57854,5523),(57855,5524),(57856,5525),(57857,5526),(57858,5527),(57859,5528),(57860,5529),(57861,5530),(57862,5531),(57863,5532),(57864,5533),(57865,5534),(57866,5535),(57867,5536),(57868,5537),(57869,5538),(57870,5539),(57871,5540),(57872,5541),(57873,5542),(57874,5543),(57875,5544),(57876,5545),(57877,5546),(57878,5547),(57879,5548),(57880,5549),(57881,5550),(57882,5551),(57883,5552),(57884,5553),(57885,5554),(57886,5555),(57887,5556),(57888,5557),(57889,5558),(57890,5559),(57891,5560),(57892,5561),(57893,5562),(57894,5563),(57895,5564),(57896,5565),(57897,5566),(57898,5567),(57899,5568),(57900,5569),(57901,5570),(57902,5571),(57903,5572),(57904,5573),(57905,5574),(57906,5575),(57907,5576),(57908,5577),(57909,5578),(57910,5579),(57911,5580),(57912,5581),(57913,5582),(57914,5583),(57915,5584),(57916,5585),(57917,5586),(57918,5587),(57919,5588),(57920,5589),(57921,5590),(57922,5591),(57923,5592),(57924,5593),(57925,5594),(57926,5595),(57927,5596),(57928,5597),(57929,5598),(57930,5599),(57931,5600),(57932,5601),(57933,5602),(57934,5603),(57935,5604),(57936,5605),(57937,5606),(57938,5607),(57939,5608),(57940,5609),(57941,5610),(57942,5611),(57943,5612),(57944,5613),(57945,5614),(57946,5615),(57947,5616),(57948,5617),(57949,5618),(57950,5619),(57951,5620),(57952,5621),(57953,5622),(57954,5623),(57955,5624),(57956,5625),(57957,5626),(57958,5627),(57959,5628),(57960,5629),(57961,5630),(57962,5631),(57963,5632),(57964,5633),(57965,5634),(57966,5635),(57967,5636),(57968,5637),(57969,5638),(57970,5639),(57971,5640),(57972,5641),(57973,5642),(57974,5643),(57975,5644),(57976,5645),(57977,5646),(57978,5647),(57979,5648),(57980,5649),(57981,5650),(57982,5651),(57983,5652),(57984,5653),(57985,5654),(57986,5655),(57987,5656),(57988,5657),(57989,5658),(57990,5659),(57991,5660),(57992,5661),(57993,5662),(57994,5663),(57995,5664),(57996,5665),(57997,5666),(57998,5667),(57999,5668),(58000,5669),(58001,5670),(58002,5671),(58003,5672),(58004,5673),(58005,5674),(58006,5675),(58007,5676),(58008,5677),(58009,5678),(58010,5679),(58011,5680),(58012,5681),(58013,5682),(58014,5683),(58015,5684),(58016,5685),(58017,5686),(58018,5687),(58019,5688),(58020,5689),(58021,5690),(58022,5691),(58023,5692),(58024,5693),(58025,5694),(58026,5695),(58027,5696),(58028,5697),(58029,5698),(58030,5699),(58031,5700),(58032,5701),(58033,5702),(58034,5703),(58035,5704),(58036,5705),(58037,5706),(58038,5707),(58039,5708),(58040,5709),(58041,5710),(58042,5711),(58043,5712),(58044,5713),(58045,5714),(58046,5715),(58047,5716),(58048,5717),(58049,5718),(58050,5719),(58051,5720),(58052,5721),(58053,5722),(58054,5723),(58055,5724),(58056,5725),(58057,5726),(58058,5727),(58059,5728),(58060,5729),(58061,5730),(58062,5731),(58063,5732),(58064,5733),(58065,5734),(58066,5735),(58067,5736),(58068,5737),(58069,5738),(58070,5739),(58071,5740),(58072,5741),(58073,5742),(58074,5743),(58075,5744),(58076,5745),(58077,5746),(58078,5747),(58079,5748),(58080,5749),(58081,5750),(58082,5751),(58083,5752),(58084,5753),(58085,5754),(58086,5755),(58087,5756),(58088,5757),(58089,5758),(58090,5759),(58091,5760),(58092,5760),(58093,5760),(58094,5760),(58095,5760),(58096,5760),(58097,5760),(58098,5760),(58099,5760),(58100,5760),(58101,5760),(58102,5760),(58103,5760),(58104,5760),(58105,5760),(58106,5761),(58107,5762),(58108,5763),(58109,5764),(58110,5765),(58111,5766),(58112,5767),(58113,5768),(58114,5769),(58115,5770),(58116,5771),(58117,5772),(58118,5773),(58119,5774),(58120,5775),(58121,5776),(58122,5777),(58123,5778),(58124,5779),(58125,5780),(58126,5781),(58127,5782),(58128,5783),(58129,5784),(58130,5785),(58131,5786),(58132,5787),(58133,5788),(58134,5789),(58135,5790),(58136,5791),(58137,5792),(58138,5793),(58139,5794),(58140,5795),(58141,5796),(58142,5797),(58143,5798),(58144,5799),(58145,5800),(58146,5801),(58147,5802),(58148,5803),(58149,5804),(58150,5805),(58151,5806),(58152,5807),(58153,5808),(58154,5809),(58155,5810),(58156,5811),(58157,5812),(58158,5813),(58159,5814),(58160,5815),(58161,5816),(58162,5817),(58163,5818),(58164,5819),(58165,5820),(58166,5821),(58167,5822),(58168,5823),(58169,5824),(58170,5825),(58171,5826),(58172,5827),(58173,5828),(58174,5829),(58175,5830),(58176,5831),(58177,5832),(58178,5833),(58179,5834),(58180,5835),(58181,5836),(58182,5837),(58183,5838),(58184,5839),(58185,5840),(58186,5841),(58187,5842),(58188,5843),(58189,5844),(58190,5845),(58191,5846),(58192,5847),(58193,5848),(58194,5849),(58195,5850),(58196,5851),(58197,5852),(58198,5853),(58199,5854),(58200,5855),(58201,5856),(58202,5857),(58203,5858),(58204,5859),(58205,5860),(58206,5761),(58207,5762),(58208,5763),(58209,5764),(58210,5765),(58211,5766),(58212,5767),(58213,5768),(58214,5769),(58215,5770),(58216,5771),(58217,5772),(58218,5773),(58219,5774),(58220,5775),(58221,5776),(58222,5777),(58223,5778),(58224,5779),(58225,5780),(58226,5781),(58227,5782),(58228,5783),(58229,5784),(58230,5785),(58231,5786),(58232,5787),(58233,5788),(58234,5789),(58235,5790),(58236,5791),(58237,5792),(58238,5793),(58239,5794),(58240,5795),(58241,5796),(58242,5797),(58243,5798),(58244,5799),(58245,5800),(58246,5801),(58247,5802),(58248,5803),(58249,5804),(58250,5805),(58251,5806),(58252,5807),(58253,5808),(58254,5809),(58255,5810),(58256,5811),(58257,5812),(58258,5813),(58259,5814),(58260,5815),(58261,5816),(58262,5817),(58263,5818),(58264,5819),(58265,5820),(58266,5821),(58267,5822),(58268,5823),(58269,5824),(58270,5825),(58271,5826),(58272,5827),(58273,5828),(58274,5829),(58275,5830),(58276,5831),(58277,5832),(58278,5833),(58279,5834),(58280,5835),(58281,5836),(58282,5837),(58283,5838),(58284,5839),(58285,5840),(58286,5841),(58287,5842),(58288,5843),(58289,5844),(58290,5845),(58291,5846),(58292,5847),(58293,5848),(58294,5849),(58295,5850),(58296,5851),(58297,5852),(58298,5853),(58299,5854),(58300,5855),(58301,5856),(58302,5857),(58303,5858),(58304,5859),(58305,5860),(58306,5761),(58307,5761),(58308,5761),(58309,5762),(58310,5762),(58311,5762),(58312,5763),(58313,5763),(58314,5763),(58315,5764),(58316,5764),(58317,5764),(58318,5765),(58319,5765),(58320,5765),(58321,5766),(58322,5766),(58323,5766),(58324,5767),(58325,5767),(58326,5767),(58327,5768),(58328,5768),(58329,5768),(58330,5769),(58331,5769),(58332,5769),(58333,5770),(58334,5770),(58335,5770),(58336,5771),(58337,5771),(58338,5771),(58339,5772),(58340,5772),(58341,5772),(58342,5773),(58343,5773),(58344,5773),(58345,5774),(58346,5774),(58347,5774),(58348,5775),(58349,5775),(58350,5775),(58351,5776),(58352,5776),(58353,5776),(58354,5777),(58355,5777),(58356,5777),(58357,5778),(58358,5778),(58359,5778),(58360,5779),(58361,5779),(58362,5779),(58363,5780),(58364,5780),(58365,5780),(58366,5781),(58367,5781),(58368,5781),(58369,5782),(58370,5782),(58371,5782),(58372,5783),(58373,5783),(58374,5783),(58375,5784),(58376,5784),(58377,5784),(58378,5785),(58379,5785),(58380,5785),(58381,5786),(58382,5786),(58383,5786),(58384,5787),(58385,5787),(58386,5787),(58387,5788),(58388,5788),(58389,5788),(58390,5789),(58391,5789),(58392,5789),(58393,5790),(58394,5790),(58395,5790),(58396,5791),(58397,5791),(58398,5791),(58399,5792),(58400,5792),(58401,5792),(58402,5793),(58403,5794),(58404,5794),(58405,5794),(58406,5795),(58407,5795),(58408,5795),(58409,5796),(58410,5796),(58411,5796),(58412,5797),(58413,5797),(58414,5797),(58415,5798),(58416,5798),(58417,5798),(58418,5799),(58419,5799),(58420,5799),(58421,5800),(58422,5800),(58423,5800),(58424,5801),(58425,5801),(58426,5801),(58427,5802),(58428,5802),(58429,5802),(58430,5803),(58431,5803),(58432,5803),(58433,5804),(58434,5804),(58435,5804),(58436,5805),(58437,5805),(58438,5805),(58439,5806),(58440,5806),(58441,5806),(58442,5807),(58443,5807),(58444,5807),(58445,5808),(58446,5808),(58447,5808),(58448,5809),(58449,5809),(58450,5809),(58451,5810),(58452,5810),(58453,5810),(58454,5811),(58455,5811),(58456,5811),(58457,5812),(58458,5812),(58459,5812),(58460,5813),(58461,5813),(58462,5813),(58463,5814),(58464,5814),(58465,5814),(58466,5815),(58467,5815),(58468,5815),(58469,5816),(58470,5816),(58471,5816),(58472,5817),(58473,5817),(58474,5817),(58475,5818),(58476,5818),(58477,5818),(58478,5819),(58479,5819),(58480,5819),(58481,5820),(58482,5820),(58483,5820),(58484,5821),(58485,5821),(58486,5821),(58487,5822),(58488,5822),(58489,5822),(58490,5823),(58491,5823),(58492,5823),(58493,5824),(58494,5824),(58495,5824),(58496,5825),(58497,5825),(58498,5825),(58499,5826),(58500,5826),(58501,5826),(58502,5827),(58503,5827),(58504,5827),(58505,5828),(58506,5828),(58507,5828),(58508,5829),(58509,5829),(58510,5829),(58511,5830),(58512,5830),(58513,5830),(58514,5831),(58515,5831),(58516,5831),(58517,5832),(58518,5832),(58519,5832),(58520,5833),(58521,5833),(58522,5833),(58523,5834),(58524,5834),(58525,5834),(58526,5835),(58527,5835),(58528,5835),(58529,5836),(58530,5836),(58531,5836),(58532,5837),(58533,5837),(58534,5837),(58535,5838),(58536,5838),(58537,5838),(58538,5839),(58539,5839),(58540,5839),(58541,5840),(58542,5840),(58543,5840),(58544,5841),(58545,5841),(58546,5841),(58547,5842),(58548,5842),(58549,5842),(58550,5843),(58551,5843),(58552,5843),(58553,5844),(58554,5844),(58555,5844),(58556,5845),(58557,5845),(58558,5845),(58559,5846),(58560,5846),(58561,5846),(58562,5847),(58563,5847),(58564,5847),(58565,5848),(58566,5848),(58567,5848),(58568,5849),(58569,5849),(58570,5849),(58571,5850),(58572,5850),(58573,5851),(58574,5851),(58575,5852),(58576,5852),(58577,5853),(58578,5853),(58579,5854),(58580,5854),(58581,5855),(58582,5855),(58583,5856),(58584,5856),(58585,5857),(58586,5857),(58587,5858),(58588,5858),(58589,5859),(58590,5859),(58591,5860),(58592,5860),(58593,5761),(58594,5761),(58595,5761),(58596,5761),(58597,5761),(58598,5761),(58599,5761),(58600,5761),(58601,5761),(58602,5761),(58603,5761),(58604,5762),(58605,5762),(58606,5762),(58607,5762),(58608,5762),(58609,5762),(58610,5762),(58611,5762),(58612,5762),(58613,5762),(58614,5762),(58615,5763),(58616,5763),(58617,5763),(58618,5763),(58619,5763),(58620,5763),(58621,5763),(58622,5763),(58623,5763),(58624,5763),(58625,5763),(58626,5764),(58627,5764),(58628,5764),(58629,5764),(58630,5764),(58631,5764),(58632,5764),(58633,5764),(58634,5764),(58635,5764),(58636,5764),(58637,5765),(58638,5765),(58639,5765),(58640,5765),(58641,5765),(58642,5765),(58643,5765),(58644,5765),(58645,5765),(58646,5765),(58647,5765),(58648,5766),(58649,5766),(58650,5766),(58651,5766),(58652,5766),(58653,5766),(58654,5766),(58655,5766),(58656,5766),(58657,5766),(58658,5766),(58659,5767),(58660,5767),(58661,5767),(58662,5767),(58663,5767),(58664,5767),(58665,5767),(58666,5767),(58667,5767),(58668,5767),(58669,5767),(58670,5768),(58671,5768),(58672,5768),(58673,5768),(58674,5768),(58675,5768),(58676,5768),(58677,5768),(58678,5768),(58679,5768),(58680,5768),(58681,5769),(58682,5769),(58683,5769),(58684,5769),(58685,5769),(58686,5769),(58687,5769),(58688,5769),(58689,5769),(58690,5769),(58691,5769),(58692,5770),(58693,5770),(58694,5770),(58695,5770),(58696,5770),(58697,5770),(58698,5770),(58699,5770),(58700,5770),(58701,5770),(58702,5770),(58703,5771),(58704,5771),(58705,5771),(58706,5771),(58707,5771),(58708,5771),(58709,5771),(58710,5771),(58711,5771),(58712,5771),(58713,5771),(58714,5772),(58715,5772),(58716,5772),(58717,5772),(58718,5772),(58719,5772),(58720,5772),(58721,5772),(58722,5772),(58723,5772),(58724,5772),(58725,5773),(58726,5773),(58727,5773),(58728,5773),(58729,5773),(58730,5773),(58731,5773),(58732,5773),(58733,5773),(58734,5773),(58735,5773),(58736,5774),(58737,5774),(58738,5774),(58739,5774),(58740,5774),(58741,5774),(58742,5774),(58743,5774),(58744,5774),(58745,5774),(58746,5774),(58747,5775),(58748,5775),(58749,5775),(58750,5775),(58751,5775),(58752,5775),(58753,5775),(58754,5775),(58755,5775),(58756,5775),(58757,5775),(58758,5776),(58759,5776),(58760,5776),(58761,5776),(58762,5776),(58763,5776),(58764,5776),(58765,5776),(58766,5776),(58767,5776),(58768,5776),(58769,5777),(58770,5777),(58771,5777),(58772,5777),(58773,5777),(58774,5777),(58775,5777),(58776,5777),(58777,5777),(58778,5777),(58779,5777),(58780,5778),(58781,5778),(58782,5778),(58783,5778),(58784,5778),(58785,5778),(58786,5778),(58787,5778),(58788,5778),(58789,5778),(58790,5778),(58791,5779),(58792,5779),(58793,5779),(58794,5779),(58795,5779),(58796,5779),(58797,5779),(58798,5779),(58799,5779),(58800,5779),(58801,5779),(58802,5780),(58803,5780),(58804,5780),(58805,5780),(58806,5780),(58807,5780),(58808,5780),(58809,5780),(58810,5780),(58811,5780),(58812,5780),(58813,5781),(58814,5781),(58815,5781),(58816,5781),(58817,5781),(58818,5781),(58819,5781),(58820,5781),(58821,5781),(58822,5781),(58823,5781),(58824,5782),(58825,5782),(58826,5782),(58827,5782),(58828,5782),(58829,5782),(58830,5782),(58831,5782),(58832,5782),(58833,5782),(58834,5782),(58835,5783),(58836,5783),(58837,5783),(58838,5783),(58839,5783),(58840,5783),(58841,5783),(58842,5783),(58843,5783),(58844,5783),(58845,5783),(58846,5784),(58847,5784),(58848,5784),(58849,5784),(58850,5784),(58851,5784),(58852,5784),(58853,5784),(58854,5784),(58855,5784),(58856,5784),(58857,5785),(58858,5785),(58859,5785),(58860,5785),(58861,5785),(58862,5785),(58863,5785),(58864,5785),(58865,5785),(58866,5785),(58867,5785),(58868,5786),(58869,5786),(58870,5786),(58871,5786),(58872,5786),(58873,5786),(58874,5786),(58875,5786),(58876,5786),(58877,5786),(58878,5786),(58879,5787),(58880,5787),(58881,5787),(58882,5787),(58883,5787),(58884,5787),(58885,5787),(58886,5787),(58887,5787),(58888,5787),(58889,5787),(58890,5788),(58891,5788),(58892,5788),(58893,5788),(58894,5788),(58895,5788),(58896,5788),(58897,5788),(58898,5788),(58899,5788),(58900,5788),(58901,5789),(58902,5789),(58903,5789),(58904,5789),(58905,5789),(58906,5789),(58907,5789),(58908,5789),(58909,5789),(58910,5789),(58911,5789),(58912,5790),(58913,5790),(58914,5790),(58915,5790),(58916,5790),(58917,5790),(58918,5790),(58919,5790),(58920,5790),(58921,5790),(58922,5790),(58923,5791),(58924,5791),(58925,5791),(58926,5791),(58927,5791),(58928,5791),(58929,5791),(58930,5791),(58931,5791),(58932,5791),(58933,5791),(58934,5792),(58935,5792),(58936,5792),(58937,5792),(58938,5792),(58939,5792),(58940,5792),(58941,5792),(58942,5792),(58943,5792),(58944,5792),(58945,5793),(58946,5793),(58947,5793),(58948,5793),(58949,5793),(58950,5793),(58951,5793),(58952,5793),(58953,5793),(58954,5793),(58955,5793),(58956,5794),(58957,5794),(58958,5794),(58959,5794),(58960,5794),(58961,5794),(58962,5794),(58963,5794),(58964,5794),(58965,5794),(58966,5794),(58967,5795),(58968,5795),(58969,5795),(58970,5795),(58971,5795),(58972,5795),(58973,5795),(58974,5795),(58975,5795),(58976,5795),(58977,5795),(58978,5796),(58979,5796),(58980,5796),(58981,5796),(58982,5796),(58983,5796),(58984,5796),(58985,5796),(58986,5796),(58987,5796),(58988,5796),(58989,5797),(58990,5797),(58991,5797),(58992,5797),(58993,5797),(58994,5797),(58995,5797),(58996,5797),(58997,5797),(58998,5797),(58999,5797),(59000,5798),(59001,5798),(59002,5798),(59003,5798),(59004,5798),(59005,5798),(59006,5798),(59007,5798),(59008,5798),(59009,5798),(59010,5798),(59011,5799),(59012,5799),(59013,5799),(59014,5799),(59015,5799),(59016,5799),(59017,5799),(59018,5799),(59019,5799),(59020,5799),(59021,5799),(59022,5800),(59023,5800),(59024,5800),(59025,5800),(59026,5800),(59027,5800),(59028,5800),(59029,5800),(59030,5800),(59031,5800),(59032,5800),(59033,5801),(59034,5801),(59035,5801),(59036,5801),(59037,5801),(59038,5801),(59039,5801),(59040,5801),(59041,5801),(59042,5801),(59043,5801),(59044,5802),(59045,5802),(59046,5802),(59047,5802),(59048,5802),(59049,5802),(59050,5802),(59051,5802),(59052,5802),(59053,5802),(59054,5802),(59055,5803),(59056,5803),(59057,5803),(59058,5803),(59059,5803),(59060,5803),(59061,5803),(59062,5803),(59063,5803),(59064,5803),(59065,5803),(59066,5804),(59067,5804),(59068,5804),(59069,5804),(59070,5804),(59071,5804),(59072,5804),(59073,5804),(59074,5804),(59075,5804),(59076,5804),(59077,5805),(59078,5805),(59079,5805),(59080,5805),(59081,5805),(59082,5805),(59083,5805),(59084,5805),(59085,5805),(59086,5805),(59087,5805),(59088,5806),(59089,5806),(59090,5806),(59091,5806),(59092,5806),(59093,5806),(59094,5806),(59095,5806),(59096,5806),(59097,5806),(59098,5806),(59099,5807),(59100,5807),(59101,5807),(59102,5807),(59103,5807),(59104,5807),(59105,5807),(59106,5807),(59107,5807),(59108,5807),(59109,5807),(59110,5808),(59111,5808),(59112,5808),(59113,5808),(59114,5808),(59115,5808),(59116,5808),(59117,5808),(59118,5808),(59119,5808),(59120,5808),(59121,5809),(59122,5809),(59123,5809),(59124,5809),(59125,5809),(59126,5809),(59127,5809),(59128,5809),(59129,5809),(59130,5809),(59131,5809),(59132,5810),(59133,5810),(59134,5810),(59135,5810),(59136,5810),(59137,5810),(59138,5810),(59139,5810),(59140,5810),(59141,5810),(59142,5810),(59143,5811),(59144,5811),(59145,5811),(59146,5811),(59147,5811),(59148,5811),(59149,5811),(59150,5811),(59151,5811),(59152,5811),(59153,5811),(59154,5812),(59155,5812),(59156,5812),(59157,5812),(59158,5812),(59159,5812),(59160,5812),(59161,5812),(59162,5812),(59163,5812),(59164,5812),(59165,5813),(59166,5813),(59167,5813),(59168,5813),(59169,5813),(59170,5813),(59171,5813),(59172,5813),(59173,5813),(59174,5813),(59175,5813),(59176,5814),(59177,5814),(59178,5814),(59179,5814),(59180,5814),(59181,5814),(59182,5814),(59183,5814),(59184,5814),(59185,5814),(59186,5814),(59187,5815),(59188,5815),(59189,5815),(59190,5815),(59191,5815),(59192,5815),(59193,5815),(59194,5815),(59195,5815),(59196,5815),(59197,5815),(59198,5816),(59199,5816),(59200,5816),(59201,5816),(59202,5816),(59203,5816),(59204,5816),(59205,5816),(59206,5816),(59207,5816),(59208,5816),(59209,5817),(59210,5817),(59211,5817),(59212,5817),(59213,5817),(59214,5817),(59215,5817),(59216,5817),(59217,5817),(59218,5817),(59219,5817),(59220,5818),(59221,5818),(59222,5818),(59223,5818),(59224,5818),(59225,5818),(59226,5818),(59227,5818),(59228,5818),(59229,5818),(59230,5818),(59231,5819),(59232,5819),(59233,5819),(59234,5819),(59235,5819),(59236,5819),(59237,5819),(59238,5819),(59239,5819),(59240,5819),(59241,5819),(59242,5820),(59243,5820),(59244,5820),(59245,5820),(59246,5820),(59247,5820),(59248,5820),(59249,5820),(59250,5820),(59251,5820),(59252,5820),(59253,5821),(59254,5821),(59255,5821),(59256,5821),(59257,5821),(59258,5821),(59259,5821),(59260,5821),(59261,5821),(59262,5821),(59263,5821),(59264,5822),(59265,5822),(59266,5822),(59267,5822),(59268,5822),(59269,5822),(59270,5822),(59271,5822),(59272,5822),(59273,5822),(59274,5822),(59275,5823),(59276,5823),(59277,5823),(59278,5823),(59279,5823),(59280,5823),(59281,5823),(59282,5823),(59283,5823),(59284,5823),(59285,5823),(59286,5824),(59287,5824),(59288,5824),(59289,5824),(59290,5824),(59291,5824),(59292,5824),(59293,5824),(59294,5824),(59295,5824),(59296,5824),(59297,5825),(59298,5825),(59299,5825),(59300,5825),(59301,5825),(59302,5825),(59303,5825),(59304,5825),(59305,5825),(59306,5825),(59307,5825),(59308,5826),(59309,5826),(59310,5826),(59311,5826),(59312,5826),(59313,5826),(59314,5826),(59315,5826),(59316,5826),(59317,5826),(59318,5826),(59319,5827),(59320,5827),(59321,5827),(59322,5827),(59323,5827),(59324,5827),(59325,5827),(59326,5827),(59327,5827),(59328,5827),(59329,5827),(59330,5828),(59331,5828),(59332,5828),(59333,5828),(59334,5828),(59335,5828),(59336,5828),(59337,5828),(59338,5828),(59339,5828),(59340,5828),(59341,5829),(59342,5829),(59343,5829),(59344,5829),(59345,5829),(59346,5829),(59347,5829),(59348,5829),(59349,5829),(59350,5829),(59351,5829),(59352,5830),(59353,5830),(59354,5830),(59355,5830),(59356,5830),(59357,5830),(59358,5830),(59359,5830),(59360,5830),(59361,5830),(59362,5830),(59363,5831),(59364,5831),(59365,5831),(59366,5831),(59367,5831),(59368,5831),(59369,5831),(59370,5831),(59371,5831),(59372,5831),(59373,5831),(59374,5832),(59375,5832),(59376,5832),(59377,5832),(59378,5832),(59379,5832),(59380,5832),(59381,5832),(59382,5832),(59383,5832),(59384,5832),(59385,5833),(59386,5833),(59387,5833),(59388,5833),(59389,5833),(59390,5833),(59391,5833),(59392,5833),(59393,5833),(59394,5833),(59395,5833),(59396,5834),(59397,5834),(59398,5834),(59399,5834),(59400,5834),(59401,5834),(59402,5834),(59403,5834),(59404,5834),(59405,5834),(59406,5834),(59407,5835),(59408,5835),(59409,5835),(59410,5835),(59411,5835),(59412,5835),(59413,5835),(59414,5835),(59415,5835),(59416,5835),(59417,5835),(59418,5836),(59419,5836),(59420,5836),(59421,5836),(59422,5836),(59423,5836),(59424,5836),(59425,5836),(59426,5836),(59427,5836),(59428,5836),(59429,5837),(59430,5837),(59431,5837),(59432,5837),(59433,5837),(59434,5837),(59435,5837),(59436,5837),(59437,5837),(59438,5837),(59439,5837),(59440,5838),(59441,5838),(59442,5838),(59443,5838),(59444,5838),(59445,5838),(59446,5838),(59447,5838),(59448,5838),(59449,5838),(59450,5838),(59451,5839),(59452,5839),(59453,5839),(59454,5839),(59455,5839),(59456,5839),(59457,5839),(59458,5839),(59459,5839),(59460,5839),(59461,5839),(59462,5840),(59463,5840),(59464,5840),(59465,5840),(59466,5840),(59467,5840),(59468,5840),(59469,5840),(59470,5840),(59471,5840),(59472,5840),(59473,5841),(59474,5841),(59475,5841),(59476,5841),(59477,5841),(59478,5841),(59479,5841),(59480,5841),(59481,5841),(59482,5841),(59483,5841),(59484,5842),(59485,5842),(59486,5842),(59487,5842),(59488,5842),(59489,5842),(59490,5842),(59491,5842),(59492,5842),(59493,5842),(59494,5842),(59495,5843),(59496,5843),(59497,5843),(59498,5843),(59499,5843),(59500,5843),(59501,5843),(59502,5843),(59503,5843),(59504,5843),(59505,5843),(59506,5844),(59507,5844),(59508,5844),(59509,5844),(59510,5844),(59511,5844),(59512,5844),(59513,5844),(59514,5844),(59515,5844),(59516,5844),(59517,5845),(59518,5845),(59519,5845),(59520,5845),(59521,5845),(59522,5845),(59523,5845),(59524,5845),(59525,5845),(59526,5845),(59527,5845),(59528,5846),(59529,5846),(59530,5846),(59531,5846),(59532,5846),(59533,5846),(59534,5846),(59535,5846),(59536,5846),(59537,5846),(59538,5846),(59539,5847),(59540,5847),(59541,5847),(59542,5847),(59543,5847),(59544,5847),(59545,5847),(59546,5847),(59547,5847),(59548,5847),(59549,5847),(59550,5848),(59551,5848),(59552,5848),(59553,5848),(59554,5848),(59555,5848),(59556,5848),(59557,5848),(59558,5848),(59559,5848),(59560,5848),(59561,5849),(59562,5849),(59563,5849),(59564,5849),(59565,5849),(59566,5849),(59567,5849),(59568,5849),(59569,5849),(59570,5849),(59571,5849),(59572,5850),(59573,5850),(59574,5850),(59575,5850),(59576,5850),(59577,5850),(59578,5850),(59579,5850),(59580,5850),(59581,5850),(59582,5850),(59583,5851),(59584,5851),(59585,5851),(59586,5851),(59587,5851),(59588,5851),(59589,5851),(59590,5851),(59591,5851),(59592,5851),(59593,5851),(59594,5852),(59595,5852),(59596,5852),(59597,5852),(59598,5852),(59599,5852),(59600,5852),(59601,5852),(59602,5852),(59603,5852),(59604,5852),(59605,5853),(59606,5853),(59607,5853),(59608,5853),(59609,5853),(59610,5853),(59611,5853),(59612,5853),(59613,5853),(59614,5853),(59615,5853),(59616,5854),(59617,5854),(59618,5854),(59619,5854),(59620,5854),(59621,5854),(59622,5854),(59623,5854),(59624,5854),(59625,5854),(59626,5854),(59627,5855),(59628,5855),(59629,5855),(59630,5855),(59631,5855),(59632,5855),(59633,5855),(59634,5855),(59635,5855),(59636,5855),(59637,5855),(59638,5856),(59639,5856),(59640,5856),(59641,5856),(59642,5856),(59643,5856),(59644,5856),(59645,5856),(59646,5856),(59647,5856),(59648,5856),(59649,5857),(59650,5857),(59651,5857),(59652,5857),(59653,5857),(59654,5857),(59655,5857),(59656,5857),(59657,5857),(59658,5857),(59659,5857),(59660,5858),(59661,5858),(59662,5858),(59663,5858),(59664,5858),(59665,5858),(59666,5858),(59667,5858),(59668,5858),(59669,5858),(59670,5858),(59671,5859),(59672,5859),(59673,5859),(59674,5859),(59675,5859),(59676,5859),(59677,5859),(59678,5859),(59679,5859),(59680,5859),(59681,5859),(59682,5860),(59683,5860),(59684,5860),(59685,5860),(59686,5860),(59687,5860),(59688,5860),(59689,5860),(59690,5860),(59691,5860),(59692,5860),(59693,5861),(59694,5862),(59695,5863),(59696,5864),(59697,5865),(59698,5866),(59699,5867),(59700,5868),(59701,5869),(59702,5870),(59703,5871),(59704,5872),(59705,5873),(59706,5874),(59707,5875),(59708,5876),(59709,5877),(59710,5878),(59711,5879),(59712,5880),(59713,5881),(59714,5882),(59715,5883),(59716,5884),(59717,5885),(59718,5886),(59719,5887),(59720,5888),(59721,5889),(59722,5890),(59723,5891),(59724,5892),(59725,5893),(59726,5894),(59727,5895),(59728,5896),(59729,5897),(59730,5898),(59731,5899),(59732,5900),(59733,5901),(59734,5902),(59735,5903),(59736,5904),(59737,5905),(59738,5906),(59739,5907),(59740,5908),(59741,5909),(59742,5910),(59743,5911),(59744,5912),(59745,5913),(59746,5914),(59747,5915),(59748,5916),(59749,5917),(59750,5918),(59751,5919),(59752,5920),(59753,5921),(59754,5922),(59755,5923),(59756,5924),(59757,5925),(59758,5926),(59759,5927),(59760,5928),(59761,5929),(59762,5930),(59763,5931),(59764,5932),(59765,5933),(59766,5934),(59767,5935),(59768,5936),(59769,5937),(59770,5938),(59771,5939),(59772,5940),(59773,5941),(59774,5942),(59775,5943),(59776,5944),(59777,5945),(59778,5946),(59779,5947),(59780,5948),(59781,5949),(59782,5950),(59783,5951),(59784,5952),(59785,5953),(59786,5954),(59787,5955),(59788,5956),(59789,5957),(59790,5958),(59791,5959),(59792,5960),(59793,5861),(59794,5862),(59795,5863),(59796,5864),(59797,5865),(59798,5866),(59799,5867),(59800,5868),(59801,5869),(59802,5870),(59803,5871),(59804,5872),(59805,5873),(59806,5874),(59807,5875),(59808,5876),(59809,5877),(59810,5878),(59811,5879),(59812,5880),(59813,5881),(59814,5882),(59815,5883),(59816,5884),(59817,5885),(59818,5886),(59819,5887),(59820,5888),(59821,5889),(59822,5890),(59823,5891),(59824,5892),(59825,5893),(59826,5894),(59827,5895),(59828,5896),(59829,5897),(59830,5898),(59831,5899),(59832,5900),(59833,5901),(59834,5902),(59835,5903),(59836,5904),(59837,5905),(59838,5906),(59839,5907),(59840,5908),(59841,5909),(59842,5910),(59843,5911),(59844,5912),(59845,5913),(59846,5914),(59847,5915),(59848,5916),(59849,5917),(59850,5918),(59851,5919),(59852,5920),(59853,5921),(59854,5922),(59855,5923),(59856,5924),(59857,5925),(59858,5926),(59859,5927),(59860,5928),(59861,5929),(59862,5930),(59863,5931),(59864,5932),(59865,5933),(59866,5934),(59867,5935),(59868,5936),(59869,5937),(59870,5938),(59871,5939),(59872,5940),(59873,5941),(59874,5942),(59875,5943),(59876,5944),(59877,5945),(59878,5946),(59879,5947),(59880,5948),(59881,5949),(59882,5950),(59883,5951),(59884,5952),(59885,5953),(59886,5954),(59887,5955),(59888,5956),(59889,5957),(59890,5958),(59891,5959),(59892,5960),(59893,5861),(59894,5861),(59895,5862),(59896,5862),(59897,5863),(59898,5863),(59899,5864),(59900,5864),(59901,5864),(59902,5865),(59903,5865),(59904,5865),(59905,5866),(59906,5866),(59907,5866),(59908,5867),(59909,5867),(59910,5867),(59911,5868),(59912,5868),(59913,5868),(59914,5869),(59915,5869),(59916,5869),(59917,5870),(59918,5870),(59919,5870),(59920,5871),(59921,5871),(59922,5871),(59923,5872),(59924,5872),(59925,5872),(59926,5873),(59927,5873),(59928,5873),(59929,5874),(59930,5874),(59931,5874),(59932,5875),(59933,5875),(59934,5875),(59935,5876),(59936,5876),(59937,5876),(59938,5877),(59939,5877),(59940,5877),(59941,5878),(59942,5878),(59943,5878),(59944,5879),(59945,5879),(59946,5879),(59947,5880),(59948,5880),(59949,5880),(59950,5881),(59951,5881),(59952,5881),(59953,5882),(59954,5882),(59955,5882),(59956,5883),(59957,5883),(59958,5883),(59959,5884),(59960,5884),(59961,5884),(59962,5885),(59963,5885),(59964,5885),(59965,5886),(59966,5886),(59967,5886),(59968,5887),(59969,5887),(59970,5887),(59971,5888),(59972,5888),(59973,5888),(59974,5889),(59975,5889),(59976,5889),(59977,5890),(59978,5890),(59979,5890),(59980,5891),(59981,5891),(59982,5891),(59983,5892),(59984,5892),(59985,5893),(59986,5893),(59987,5893),(59988,5894),(59989,5894),(59990,5894),(59991,5895),(59992,5895),(59993,5895),(59994,5896),(59995,5896),(59996,5896),(59997,5897),(59998,5897),(59999,5897),(60000,5898),(60001,5898),(60002,5898),(60003,5899),(60004,5899),(60005,5899),(60006,5900),(60007,5900),(60008,5900),(60009,5901),(60010,5901),(60011,5901),(60012,5902),(60013,5902),(60014,5902),(60015,5903),(60016,5903),(60017,5903),(60018,5904),(60019,5904),(60020,5904),(60021,5905),(60022,5905),(60023,5905),(60024,5906),(60025,5906),(60026,5906),(60027,5907),(60028,5907),(60029,5907),(60030,5908),(60031,5908),(60032,5908),(60033,5909),(60034,5909),(60035,5909),(60036,5910),(60037,5910),(60038,5910),(60039,5911),(60040,5911),(60041,5911),(60042,5912),(60043,5912),(60044,5912),(60045,5913),(60046,5913),(60047,5913),(60048,5914),(60049,5914),(60050,5914),(60051,5915),(60052,5915),(60053,5915),(60054,5916),(60055,5916),(60056,5916),(60057,5917),(60058,5917),(60059,5917),(60060,5918),(60061,5918),(60062,5918),(60063,5919),(60064,5919),(60065,5919),(60066,5920),(60067,5920),(60068,5920),(60069,5921),(60070,5921),(60071,5921),(60072,5922),(60073,5922),(60074,5922),(60075,5923),(60076,5923),(60077,5923),(60078,5924),(60079,5924),(60080,5924),(60081,5925),(60082,5925),(60083,5925),(60084,5926),(60085,5926),(60086,5926),(60087,5927),(60088,5927),(60089,5927),(60090,5928),(60091,5928),(60092,5928),(60093,5929),(60094,5929),(60095,5929),(60096,5930),(60097,5930),(60098,5930),(60099,5931),(60100,5931),(60101,5931),(60102,5932),(60103,5932),(60104,5932),(60105,5933),(60106,5933),(60107,5933),(60108,5934),(60109,5934),(60110,5934),(60111,5935),(60112,5935),(60113,5935),(60114,5936),(60115,5936),(60116,5936),(60117,5937),(60118,5937),(60119,5937),(60120,5938),(60121,5938),(60122,5938),(60123,5939),(60124,5939),(60125,5939),(60126,5940),(60127,5940),(60128,5940),(60129,5941),(60130,5941),(60131,5941),(60132,5942),(60133,5942),(60134,5942),(60135,5943),(60136,5943),(60137,5943),(60138,5944),(60139,5944),(60140,5944),(60141,5945),(60142,5945),(60143,5945),(60144,5946),(60145,5946),(60146,5946),(60147,5947),(60148,5947),(60149,5947),(60150,5948),(60151,5948),(60152,5948),(60153,5949),(60154,5949),(60155,5949),(60156,5950),(60157,5950),(60158,5950),(60159,5951),(60160,5951),(60161,5951),(60162,5952),(60163,5952),(60164,5952),(60165,5953),(60166,5953),(60167,5953),(60168,5954),(60169,5954),(60170,5954),(60171,5955),(60172,5955),(60173,5955),(60174,5956),(60175,5956),(60176,5956),(60177,5957),(60178,5957),(60179,5957),(60180,5958),(60181,5958),(60182,5958),(60183,5959),(60184,5959),(60185,5959),(60186,5960),(60187,5960),(60188,5960),(60189,5861),(60190,5861),(60191,5861),(60192,5861),(60193,5861),(60194,5861),(60195,5861),(60196,5861),(60197,5861),(60198,5861),(60199,5861),(60200,5862),(60201,5862),(60202,5862),(60203,5862),(60204,5862),(60205,5862),(60206,5862),(60207,5862),(60208,5862),(60209,5862),(60210,5862),(60211,5863),(60212,5863),(60213,5863),(60214,5863),(60215,5863),(60216,5863),(60217,5863),(60218,5863),(60219,5863),(60220,5863),(60221,5863),(60222,5864),(60223,5864),(60224,5864),(60225,5864),(60226,5864),(60227,5864),(60228,5864),(60229,5864),(60230,5864),(60231,5864),(60232,5864),(60233,5865),(60234,5865),(60235,5865),(60236,5865),(60237,5865),(60238,5865),(60239,5865),(60240,5865),(60241,5865),(60242,5865),(60243,5865),(60244,5866),(60245,5866),(60246,5866),(60247,5866),(60248,5866),(60249,5866),(60250,5866),(60251,5866),(60252,5866),(60253,5866),(60254,5866),(60255,5867),(60256,5867),(60257,5867),(60258,5867),(60259,5867),(60260,5867),(60261,5867),(60262,5867),(60263,5867),(60264,5867),(60265,5867),(60266,5868),(60267,5868),(60268,5868),(60269,5868),(60270,5868),(60271,5868),(60272,5868),(60273,5868),(60274,5868),(60275,5868),(60276,5868),(60277,5869),(60278,5869),(60279,5869),(60280,5869),(60281,5869),(60282,5869),(60283,5869),(60284,5869),(60285,5869),(60286,5869),(60287,5869),(60288,5870),(60289,5870),(60290,5870),(60291,5870),(60292,5870),(60293,5870),(60294,5870),(60295,5870),(60296,5870),(60297,5870),(60298,5870),(60299,5871),(60300,5871),(60301,5871),(60302,5871),(60303,5871),(60304,5871),(60305,5871),(60306,5871),(60307,5871),(60308,5871),(60309,5871),(60310,5872),(60311,5872),(60312,5872),(60313,5872),(60314,5872),(60315,5872),(60316,5872),(60317,5872),(60318,5872),(60319,5872),(60320,5872),(60321,5873),(60322,5873),(60323,5873),(60324,5873),(60325,5873),(60326,5873),(60327,5873),(60328,5873),(60329,5873),(60330,5873),(60331,5873),(60332,5874),(60333,5874),(60334,5874),(60335,5874),(60336,5874),(60337,5874),(60338,5874),(60339,5874),(60340,5874),(60341,5874),(60342,5874),(60343,5875),(60344,5875),(60345,5875),(60346,5875),(60347,5875),(60348,5875),(60349,5875),(60350,5875),(60351,5875),(60352,5875),(60353,5875),(60354,5876),(60355,5876),(60356,5876),(60357,5876),(60358,5876),(60359,5876),(60360,5876),(60361,5876),(60362,5876),(60363,5876),(60364,5876),(60365,5877),(60366,5877),(60367,5877),(60368,5877),(60369,5877),(60370,5877),(60371,5877),(60372,5877),(60373,5877),(60374,5877),(60375,5877),(60376,5878),(60377,5878),(60378,5878),(60379,5878),(60380,5878),(60381,5878),(60382,5878),(60383,5878),(60384,5878),(60385,5878),(60386,5878),(60387,5879),(60388,5879),(60389,5879),(60390,5879),(60391,5879),(60392,5879),(60393,5879),(60394,5879),(60395,5879),(60396,5879),(60397,5879),(60398,5880),(60399,5880),(60400,5880),(60401,5880),(60402,5880),(60403,5880),(60404,5880),(60405,5880),(60406,5880),(60407,5880),(60408,5880),(60409,5881),(60410,5881),(60411,5881),(60412,5881),(60413,5881),(60414,5881),(60415,5881),(60416,5881),(60417,5881),(60418,5881),(60419,5881),(60420,5882),(60421,5882),(60422,5882),(60423,5882),(60424,5882),(60425,5882),(60426,5882),(60427,5882),(60428,5882),(60429,5882),(60430,5882),(60431,5883),(60432,5883),(60433,5883),(60434,5883),(60435,5883),(60436,5883),(60437,5883),(60438,5883),(60439,5883),(60440,5883),(60441,5883),(60442,5884),(60443,5884),(60444,5884),(60445,5884),(60446,5884),(60447,5884),(60448,5884),(60449,5884),(60450,5884),(60451,5884),(60452,5884),(60453,5885),(60454,5885),(60455,5885),(60456,5885),(60457,5885),(60458,5885),(60459,5885),(60460,5885),(60461,5885),(60462,5885),(60463,5885),(60464,5886),(60465,5886),(60466,5886),(60467,5886),(60468,5886),(60469,5886),(60470,5886),(60471,5886),(60472,5886),(60473,5886),(60474,5886),(60475,5887),(60476,5887),(60477,5887),(60478,5887),(60479,5887),(60480,5887),(60481,5887),(60482,5887),(60483,5887),(60484,5887),(60485,5887),(60486,5888),(60487,5888),(60488,5888),(60489,5888),(60490,5888),(60491,5888),(60492,5888),(60493,5888),(60494,5888),(60495,5888),(60496,5888),(60497,5889),(60498,5889),(60499,5889),(60500,5889),(60501,5889),(60502,5889),(60503,5889),(60504,5889),(60505,5889),(60506,5889),(60507,5889),(60508,5890),(60509,5890),(60510,5890),(60511,5890),(60512,5890),(60513,5890),(60514,5890),(60515,5890),(60516,5890),(60517,5890),(60518,5890),(60519,5891),(60520,5891),(60521,5891),(60522,5891),(60523,5891),(60524,5891),(60525,5891),(60526,5891),(60527,5891),(60528,5891),(60529,5891),(60530,5892),(60531,5892),(60532,5892),(60533,5892),(60534,5892),(60535,5892),(60536,5892),(60537,5892),(60538,5892),(60539,5892),(60540,5892),(60541,5893),(60542,5893),(60543,5893),(60544,5893),(60545,5893),(60546,5893),(60547,5893),(60548,5893),(60549,5893),(60550,5893),(60551,5893),(60552,5894),(60553,5894),(60554,5894),(60555,5894),(60556,5894),(60557,5894),(60558,5894),(60559,5894),(60560,5894),(60561,5894),(60562,5894),(60563,5895),(60564,5895),(60565,5895),(60566,5895),(60567,5895),(60568,5895),(60569,5895),(60570,5895),(60571,5895),(60572,5895),(60573,5895),(60574,5896),(60575,5896),(60576,5896),(60577,5896),(60578,5896),(60579,5896),(60580,5896),(60581,5896),(60582,5896),(60583,5896),(60584,5896),(60585,5897),(60586,5897),(60587,5897),(60588,5897),(60589,5897),(60590,5897),(60591,5897),(60592,5897),(60593,5897),(60594,5897),(60595,5897),(60596,5898),(60597,5898),(60598,5898),(60599,5898),(60600,5898),(60601,5898),(60602,5898),(60603,5898),(60604,5898),(60605,5898),(60606,5898),(60607,5899),(60608,5899),(60609,5899),(60610,5899),(60611,5899),(60612,5899),(60613,5899),(60614,5899),(60615,5899),(60616,5899),(60617,5899),(60618,5900),(60619,5900),(60620,5900),(60621,5900),(60622,5900),(60623,5900),(60624,5900),(60625,5900),(60626,5900),(60627,5900),(60628,5900),(60629,5901),(60630,5901),(60631,5901),(60632,5901),(60633,5901),(60634,5901),(60635,5901),(60636,5901),(60637,5901),(60638,5901),(60639,5901),(60640,5902),(60641,5902),(60642,5902),(60643,5902),(60644,5902),(60645,5902),(60646,5902),(60647,5902),(60648,5902),(60649,5902),(60650,5902),(60651,5903),(60652,5903),(60653,5903),(60654,5903),(60655,5903),(60656,5903),(60657,5903),(60658,5903),(60659,5903),(60660,5903),(60661,5903),(60662,5904),(60663,5904),(60664,5904),(60665,5904),(60666,5904),(60667,5904),(60668,5904),(60669,5904),(60670,5904),(60671,5904),(60672,5904),(60673,5905),(60674,5905),(60675,5905),(60676,5905),(60677,5905),(60678,5905),(60679,5905),(60680,5905),(60681,5905),(60682,5905),(60683,5905),(60684,5906),(60685,5906),(60686,5906),(60687,5906),(60688,5906),(60689,5906),(60690,5906),(60691,5906),(60692,5906),(60693,5906),(60694,5906),(60695,5907),(60696,5907),(60697,5907),(60698,5907),(60699,5907),(60700,5907),(60701,5907),(60702,5907),(60703,5907),(60704,5907),(60705,5907),(60706,5908),(60707,5908),(60708,5908),(60709,5908),(60710,5908),(60711,5908),(60712,5908),(60713,5908),(60714,5908),(60715,5908),(60716,5908),(60717,5909),(60718,5909),(60719,5909),(60720,5909),(60721,5909),(60722,5909),(60723,5909),(60724,5909),(60725,5909),(60726,5909),(60727,5909),(60728,5910),(60729,5910),(60730,5910),(60731,5910),(60732,5910),(60733,5910),(60734,5910),(60735,5910),(60736,5910),(60737,5910),(60738,5910),(60739,5911),(60740,5911),(60741,5911),(60742,5911),(60743,5911),(60744,5911),(60745,5911),(60746,5911),(60747,5911),(60748,5911),(60749,5911),(60750,5912),(60751,5912),(60752,5912),(60753,5912),(60754,5912),(60755,5912),(60756,5912),(60757,5912),(60758,5912),(60759,5912),(60760,5912),(60761,5913),(60762,5913),(60763,5913),(60764,5913),(60765,5913),(60766,5913),(60767,5913),(60768,5913),(60769,5913),(60770,5913),(60771,5913),(60772,5914),(60773,5914),(60774,5914),(60775,5914),(60776,5914),(60777,5914),(60778,5914),(60779,5914),(60780,5914),(60781,5914),(60782,5914),(60783,5915),(60784,5915),(60785,5915),(60786,5915),(60787,5915),(60788,5915),(60789,5915),(60790,5915),(60791,5915),(60792,5915),(60793,5915),(60794,5916),(60795,5916),(60796,5916),(60797,5916),(60798,5916),(60799,5916),(60800,5916),(60801,5916),(60802,5916),(60803,5916),(60804,5916),(60805,5917),(60806,5917),(60807,5917),(60808,5917),(60809,5917),(60810,5917),(60811,5917),(60812,5917),(60813,5917),(60814,5917),(60815,5917),(60816,5918),(60817,5918),(60818,5918),(60819,5918),(60820,5918),(60821,5918),(60822,5918),(60823,5918),(60824,5918),(60825,5918),(60826,5918),(60827,5919),(60828,5919),(60829,5919),(60830,5919),(60831,5919),(60832,5919),(60833,5919),(60834,5919),(60835,5919),(60836,5919),(60837,5919),(60838,5920),(60839,5920),(60840,5920),(60841,5920),(60842,5920),(60843,5920),(60844,5920),(60845,5920),(60846,5920),(60847,5920),(60848,5920),(60849,5921),(60850,5921),(60851,5921),(60852,5921),(60853,5921),(60854,5921),(60855,5921),(60856,5921),(60857,5921),(60858,5921),(60859,5921),(60860,5922),(60861,5922),(60862,5922),(60863,5922),(60864,5922),(60865,5922),(60866,5922),(60867,5922),(60868,5922),(60869,5922),(60870,5922),(60871,5923),(60872,5923),(60873,5923),(60874,5923),(60875,5923),(60876,5923),(60877,5923),(60878,5923),(60879,5923),(60880,5923),(60881,5923),(60882,5924),(60883,5924),(60884,5924),(60885,5924),(60886,5924),(60887,5924),(60888,5924),(60889,5924),(60890,5924),(60891,5924),(60892,5924),(60893,5925),(60894,5925),(60895,5925),(60896,5925),(60897,5925),(60898,5925),(60899,5925),(60900,5925),(60901,5925),(60902,5925),(60903,5925),(60904,5926),(60905,5926),(60906,5926),(60907,5926),(60908,5926),(60909,5926),(60910,5926),(60911,5926),(60912,5926),(60913,5926),(60914,5926),(60915,5927),(60916,5927),(60917,5927),(60918,5927),(60919,5927),(60920,5927),(60921,5927),(60922,5927),(60923,5927),(60924,5927),(60925,5927),(60926,5928),(60927,5928),(60928,5928),(60929,5928),(60930,5928),(60931,5928),(60932,5928),(60933,5928),(60934,5928),(60935,5928),(60936,5928),(60937,5929),(60938,5929),(60939,5929),(60940,5929),(60941,5929),(60942,5929),(60943,5929),(60944,5929),(60945,5929),(60946,5929),(60947,5929),(60948,5930),(60949,5930),(60950,5930),(60951,5930),(60952,5930),(60953,5930),(60954,5930),(60955,5930),(60956,5930),(60957,5930),(60958,5930),(60959,5931),(60960,5931),(60961,5931),(60962,5931),(60963,5931),(60964,5931),(60965,5931),(60966,5931),(60967,5931),(60968,5931),(60969,5931),(60970,5932),(60971,5932),(60972,5932),(60973,5932),(60974,5932),(60975,5932),(60976,5932),(60977,5932),(60978,5932),(60979,5932),(60980,5932),(60981,5933),(60982,5933),(60983,5933),(60984,5933),(60985,5933),(60986,5933),(60987,5933),(60988,5933),(60989,5933),(60990,5933),(60991,5933),(60992,5934),(60993,5934),(60994,5934),(60995,5934),(60996,5934),(60997,5934),(60998,5934),(60999,5934),(61000,5934),(61001,5934),(61002,5934),(61003,5935),(61004,5935),(61005,5935),(61006,5935),(61007,5935),(61008,5935),(61009,5935),(61010,5935),(61011,5935),(61012,5935),(61013,5935),(61014,5936),(61015,5936),(61016,5936),(61017,5936),(61018,5936),(61019,5936),(61020,5936),(61021,5936),(61022,5936),(61023,5936),(61024,5936),(61025,5937),(61026,5937),(61027,5937),(61028,5937),(61029,5937),(61030,5937),(61031,5937),(61032,5937),(61033,5937),(61034,5937),(61035,5937),(61036,5938),(61037,5938),(61038,5938),(61039,5938),(61040,5938),(61041,5938),(61042,5938),(61043,5938),(61044,5938),(61045,5938),(61046,5938),(61047,5939),(61048,5939),(61049,5939),(61050,5939),(61051,5939),(61052,5939),(61053,5939),(61054,5939),(61055,5939),(61056,5939),(61057,5939),(61058,5940),(61059,5940),(61060,5940),(61061,5940),(61062,5940),(61063,5940),(61064,5940),(61065,5940),(61066,5940),(61067,5940),(61068,5940),(61069,5941),(61070,5941),(61071,5941),(61072,5941),(61073,5941),(61074,5941),(61075,5941),(61076,5941),(61077,5941),(61078,5941),(61079,5941),(61080,5942),(61081,5942),(61082,5942),(61083,5942),(61084,5942),(61085,5942),(61086,5942),(61087,5942),(61088,5942),(61089,5942),(61090,5942),(61091,5943),(61092,5943),(61093,5943),(61094,5943),(61095,5943),(61096,5943),(61097,5943),(61098,5943),(61099,5943),(61100,5943),(61101,5943),(61102,5944),(61103,5944),(61104,5944),(61105,5944),(61106,5944),(61107,5944),(61108,5944),(61109,5944),(61110,5944),(61111,5944),(61112,5944),(61113,5945),(61114,5945),(61115,5945),(61116,5945),(61117,5945),(61118,5945),(61119,5945),(61120,5945),(61121,5945),(61122,5945),(61123,5945),(61124,5946),(61125,5946),(61126,5946),(61127,5946),(61128,5946),(61129,5946),(61130,5946),(61131,5946),(61132,5946),(61133,5946),(61134,5946),(61135,5947),(61136,5947),(61137,5947),(61138,5947),(61139,5947),(61140,5947),(61141,5947),(61142,5947),(61143,5947),(61144,5947),(61145,5947),(61146,5948),(61147,5948),(61148,5948),(61149,5948),(61150,5948),(61151,5948),(61152,5948),(61153,5948),(61154,5948),(61155,5948),(61156,5948),(61157,5949),(61158,5949),(61159,5949),(61160,5949),(61161,5949),(61162,5949),(61163,5949),(61164,5949),(61165,5949),(61166,5949),(61167,5949),(61168,5950),(61169,5950),(61170,5950),(61171,5950),(61172,5950),(61173,5950),(61174,5950),(61175,5950),(61176,5950),(61177,5950),(61178,5950),(61179,5951),(61180,5951),(61181,5951),(61182,5951),(61183,5951),(61184,5951),(61185,5951),(61186,5951),(61187,5951),(61188,5951),(61189,5951),(61190,5952),(61191,5952),(61192,5952),(61193,5952),(61194,5952),(61195,5952),(61196,5952),(61197,5952),(61198,5952),(61199,5952),(61200,5952),(61201,5953),(61202,5953),(61203,5953),(61204,5953),(61205,5953),(61206,5953),(61207,5953),(61208,5953),(61209,5953),(61210,5953),(61211,5953),(61212,5954),(61213,5954),(61214,5954),(61215,5954),(61216,5954),(61217,5954),(61218,5954),(61219,5954),(61220,5954),(61221,5954),(61222,5954),(61223,5955),(61224,5955),(61225,5955),(61226,5955),(61227,5955),(61228,5955),(61229,5955),(61230,5955),(61231,5955),(61232,5955),(61233,5955),(61234,5956),(61235,5956),(61236,5956),(61237,5956),(61238,5956),(61239,5956),(61240,5956),(61241,5956),(61242,5956),(61243,5956),(61244,5956),(61245,5957),(61246,5957),(61247,5957),(61248,5957),(61249,5957),(61250,5957),(61251,5957),(61252,5957),(61253,5957),(61254,5957),(61255,5957),(61256,5958),(61257,5958),(61258,5958),(61259,5958),(61260,5958),(61261,5958),(61262,5958),(61263,5958),(61264,5958),(61265,5958),(61266,5958),(61267,5959),(61268,5959),(61269,5959),(61270,5959),(61271,5959),(61272,5959),(61273,5959),(61274,5959),(61275,5959),(61276,5959),(61277,5959),(61278,5960),(61279,5960),(61280,5960),(61281,5960),(61282,5960),(61283,5960),(61284,5960),(61285,5960),(61286,5960),(61287,5960),(61288,5960),(61289,5961),(61290,5962),(61291,5963),(61292,5964),(61293,5965),(61294,5966),(61295,5967),(61296,5968),(61297,5969),(61298,5970),(61299,5971),(61300,5972),(61301,5973),(61302,5974),(61303,5975),(61304,5976),(61305,5977),(61306,5978),(61307,5979),(61308,5980),(61309,5981),(61310,5982),(61311,5983),(61312,5984),(61313,5985),(61314,5986),(61315,5987),(61316,5988),(61317,5989),(61318,5990),(61319,5991),(61320,5992),(61321,5993),(61322,5994),(61323,5995),(61324,5996),(61325,5997),(61326,5998),(61327,5999),(61328,6000),(61329,6001),(61330,6002),(61331,6003),(61332,6004),(61333,6005),(61334,6006),(61335,6007),(61336,6008),(61337,6009),(61338,6010),(61339,6011),(61340,6012),(61341,6013),(61342,6014),(61343,6015),(61344,6016),(61345,6017),(61346,6018),(61347,6019),(61348,6020),(61349,6021),(61350,6022),(61351,6023),(61352,6024),(61353,6025),(61354,6026),(61355,6027),(61356,6028),(61357,6029),(61358,6030),(61359,6031),(61360,6032),(61361,6033),(61362,6034),(61363,5961),(61364,5962),(61365,5963),(61366,5964),(61367,5965),(61368,5966),(61369,5967),(61370,5968),(61371,5969),(61372,5970),(61373,5971),(61374,5972),(61375,5973),(61376,5974),(61377,5975),(61378,5976),(61379,5977),(61380,5978),(61381,5979),(61382,5980),(61383,5981),(61384,5982),(61385,5983),(61386,5984),(61387,5985),(61388,5986),(61389,5987),(61390,5988),(61391,5989),(61392,5990),(61393,5991),(61394,5992),(61395,5993),(61396,5994),(61397,5995),(61398,5996),(61399,5997),(61400,5998),(61401,5999),(61402,6000),(61403,6001),(61404,6002),(61405,6003),(61406,6004),(61407,6005),(61408,6006),(61409,6007),(61410,6008),(61411,6009),(61412,6010),(61413,6011),(61414,6012),(61415,6013),(61416,6014),(61417,6015),(61418,6016),(61419,6017),(61420,6018),(61421,6019),(61422,6020),(61423,6021),(61424,6022),(61425,6023),(61426,6024),(61427,6025),(61428,6026),(61429,6027),(61430,6028),(61431,6029),(61432,6030),(61433,6031),(61434,6032),(61435,6033),(61436,6034),(61437,5961),(61438,5961),(61439,5961),(61440,5962),(61441,5962),(61442,5962),(61443,5963),(61444,5963),(61445,5963),(61446,5964),(61447,5964),(61448,5964),(61449,5965),(61450,5965),(61451,5965),(61452,5966),(61453,5966),(61454,5966),(61455,5967),(61456,5967),(61457,5967),(61458,5968),(61459,5968),(61460,5968),(61461,5969),(61462,5969),(61463,5969),(61464,5970),(61465,5970),(61466,5970),(61467,5971),(61468,5971),(61469,5971),(61470,5972),(61471,5972),(61472,5972),(61473,5973),(61474,5973),(61475,5973),(61476,5974),(61477,5974),(61478,5974),(61479,5975),(61480,5975),(61481,5975),(61482,5976),(61483,5976),(61484,5976),(61485,5977),(61486,5977),(61487,5977),(61488,5978),(61489,5978),(61490,5978),(61491,5979),(61492,5979),(61493,5979),(61494,5980),(61495,5980),(61496,5980),(61497,5981),(61498,5981),(61499,5981),(61500,5982),(61501,5982),(61502,5982),(61503,5983),(61504,5983),(61505,5983),(61506,5984),(61507,5984),(61508,5984),(61509,5985),(61510,5985),(61511,5985),(61512,5986),(61513,5986),(61514,5986),(61515,5987),(61516,5987),(61517,5987),(61518,5988),(61519,5988),(61520,5988),(61521,5989),(61522,5989),(61523,5989),(61524,5990),(61525,5990),(61526,5990),(61527,5991),(61528,5991),(61529,5991),(61530,5992),(61531,5992),(61532,5992),(61533,5993),(61534,5993),(61535,5993),(61536,5994),(61537,5994),(61538,5994),(61539,5995),(61540,5995),(61541,5995),(61542,5996),(61543,5996),(61544,5996),(61545,5997),(61546,5997),(61547,5997),(61548,5998),(61549,5998),(61550,5999),(61551,5999),(61552,6000),(61553,6000),(61554,6000),(61555,6001),(61556,6001),(61557,6001),(61558,6002),(61559,6002),(61560,6002),(61561,6003),(61562,6003),(61563,6003),(61564,6004),(61565,6004),(61566,6004),(61567,6005),(61568,6005),(61569,6006),(61570,6006),(61571,6006),(61572,6007),(61573,6007),(61574,6007),(61575,6008),(61576,6008),(61577,6008),(61578,6009),(61579,6009),(61580,6009),(61581,6010),(61582,6010),(61583,6010),(61584,6011),(61585,6011),(61586,6011),(61587,6012),(61588,6012),(61589,6012),(61590,6013),(61591,6013),(61592,6013),(61593,6014),(61594,6014),(61595,6014),(61596,6015),(61597,6015),(61598,6015),(61599,6016),(61600,6016),(61601,6016),(61602,6017),(61603,6017),(61604,6017),(61605,6018),(61606,6018),(61607,6018),(61608,6019),(61609,6019),(61610,6019),(61611,6020),(61612,6020),(61613,6020),(61614,6021),(61615,6021),(61616,6021),(61617,6022),(61618,6022),(61619,6022),(61620,6023),(61621,6023),(61622,6023),(61623,6024),(61624,6024),(61625,6024),(61626,6025),(61627,6025),(61628,6025),(61629,6026),(61630,6026),(61631,6026),(61632,6027),(61633,6027),(61634,6027),(61635,6028),(61636,6028),(61637,6028),(61638,6029),(61639,6029),(61640,6029),(61641,6030),(61642,6030),(61643,6030),(61644,6031),(61645,6031),(61646,6031),(61647,6032),(61648,6032),(61649,6032),(61650,6033),(61651,6033),(61652,6033),(61653,6034),(61654,6034),(61655,6034),(61656,5961),(61657,5961),(61658,5961),(61659,5961),(61660,5961),(61661,5961),(61662,5961),(61663,5961),(61664,5961),(61665,5961),(61666,5961),(61667,5962),(61668,5962),(61669,5962),(61670,5962),(61671,5962),(61672,5962),(61673,5962),(61674,5962),(61675,5962),(61676,5962),(61677,5962),(61678,5963),(61679,5963),(61680,5963),(61681,5963),(61682,5963),(61683,5963),(61684,5963),(61685,5963),(61686,5963),(61687,5963),(61688,5963),(61689,5964),(61690,5964),(61691,5964),(61692,5964),(61693,5964),(61694,5964),(61695,5964),(61696,5964),(61697,5964),(61698,5964),(61699,5964),(61700,5965),(61701,5965),(61702,5965),(61703,5965),(61704,5965),(61705,5965),(61706,5965),(61707,5965),(61708,5965),(61709,5965),(61710,5965),(61711,5966),(61712,5966),(61713,5966),(61714,5966),(61715,5966),(61716,5966),(61717,5966),(61718,5966),(61719,5966),(61720,5966),(61721,5966),(61722,5967),(61723,5967),(61724,5967),(61725,5967),(61726,5967),(61727,5967),(61728,5967),(61729,5967),(61730,5967),(61731,5967),(61732,5967),(61733,5968),(61734,5968),(61735,5968),(61736,5968),(61737,5968),(61738,5968),(61739,5968),(61740,5968),(61741,5968),(61742,5968),(61743,5968),(61744,5969),(61745,5969),(61746,5969),(61747,5969),(61748,5969),(61749,5969),(61750,5969),(61751,5969),(61752,5969),(61753,5969),(61754,5969),(61755,5970),(61756,5970),(61757,5970),(61758,5970),(61759,5970),(61760,5970),(61761,5970),(61762,5970),(61763,5970),(61764,5970),(61765,5970),(61766,5971),(61767,5971),(61768,5971),(61769,5971),(61770,5971),(61771,5971),(61772,5971),(61773,5971),(61774,5971),(61775,5971),(61776,5971),(61777,5972),(61778,5972),(61779,5972),(61780,5972),(61781,5972),(61782,5972),(61783,5972),(61784,5972),(61785,5972),(61786,5972),(61787,5972),(61788,5973),(61789,5973),(61790,5973),(61791,5973),(61792,5973),(61793,5973),(61794,5973),(61795,5973),(61796,5973),(61797,5973),(61798,5973),(61799,5974),(61800,5974),(61801,5974),(61802,5974),(61803,5974),(61804,5974),(61805,5974),(61806,5974),(61807,5974),(61808,5974),(61809,5974),(61810,5975),(61811,5975),(61812,5975),(61813,5975),(61814,5975),(61815,5975),(61816,5975),(61817,5975),(61818,5975),(61819,5975),(61820,5975),(61821,5976),(61822,5976),(61823,5976),(61824,5976),(61825,5976),(61826,5976),(61827,5976),(61828,5976),(61829,5976),(61830,5976),(61831,5976),(61832,5977),(61833,5977),(61834,5977),(61835,5977),(61836,5977),(61837,5977),(61838,5977),(61839,5977),(61840,5977),(61841,5977),(61842,5977),(61843,5978),(61844,5978),(61845,5978),(61846,5978),(61847,5978),(61848,5978),(61849,5978),(61850,5978),(61851,5978),(61852,5978),(61853,5978),(61854,5979),(61855,5979),(61856,5979),(61857,5979),(61858,5979),(61859,5979),(61860,5979),(61861,5979),(61862,5979),(61863,5979),(61864,5979),(61865,5980),(61866,5980),(61867,5980),(61868,5980),(61869,5980),(61870,5980),(61871,5980),(61872,5980),(61873,5980),(61874,5980),(61875,5980),(61876,5981),(61877,5981),(61878,5981),(61879,5981),(61880,5981),(61881,5981),(61882,5981),(61883,5981),(61884,5981),(61885,5981),(61886,5981),(61887,5982),(61888,5982),(61889,5982),(61890,5982),(61891,5982),(61892,5982),(61893,5982),(61894,5982),(61895,5982),(61896,5982),(61897,5982),(61898,5983),(61899,5983),(61900,5983),(61901,5983),(61902,5983),(61903,5983),(61904,5983),(61905,5983),(61906,5983),(61907,5983),(61908,5983),(61909,5984),(61910,5984),(61911,5984),(61912,5984),(61913,5984),(61914,5984),(61915,5984),(61916,5984),(61917,5984),(61918,5984),(61919,5984),(61920,5985),(61921,5985),(61922,5985),(61923,5985),(61924,5985),(61925,5985),(61926,5985),(61927,5985),(61928,5985),(61929,5985),(61930,5985),(61931,5986),(61932,5986),(61933,5986),(61934,5986),(61935,5986),(61936,5986),(61937,5986),(61938,5986),(61939,5986),(61940,5986),(61941,5986),(61942,5987),(61943,5987),(61944,5987),(61945,5987),(61946,5987),(61947,5987),(61948,5987),(61949,5987),(61950,5987),(61951,5987),(61952,5987),(61953,5988),(61954,5988),(61955,5988),(61956,5988),(61957,5988),(61958,5988),(61959,5988),(61960,5988),(61961,5988),(61962,5988),(61963,5988),(61964,5989),(61965,5989),(61966,5989),(61967,5989),(61968,5989),(61969,5989),(61970,5989),(61971,5989),(61972,5989),(61973,5989),(61974,5989),(61975,5990),(61976,5990),(61977,5990),(61978,5990),(61979,5990),(61980,5990),(61981,5990),(61982,5990),(61983,5990),(61984,5990),(61985,5990),(61986,5991),(61987,5991),(61988,5991),(61989,5991),(61990,5991),(61991,5991),(61992,5991),(61993,5991),(61994,5991),(61995,5991),(61996,5991),(61997,5992),(61998,5992),(61999,5992),(62000,5992),(62001,5992),(62002,5992),(62003,5992),(62004,5992),(62005,5992),(62006,5992),(62007,5992),(62008,5993),(62009,5993),(62010,5993),(62011,5993),(62012,5993),(62013,5993),(62014,5993),(62015,5993),(62016,5993),(62017,5993),(62018,5993),(62019,5994),(62020,5994),(62021,5994),(62022,5994),(62023,5994),(62024,5994),(62025,5994),(62026,5994),(62027,5994),(62028,5994),(62029,5994),(62030,5995),(62031,5995),(62032,5995),(62033,5995),(62034,5995),(62035,5995),(62036,5995),(62037,5995),(62038,5995),(62039,5995),(62040,5995),(62041,5996),(62042,5996),(62043,5996),(62044,5996),(62045,5996),(62046,5996),(62047,5996),(62048,5996),(62049,5996),(62050,5996),(62051,5996),(62052,5997),(62053,5997),(62054,5997),(62055,5997),(62056,5997),(62057,5997),(62058,5997),(62059,5997),(62060,5997),(62061,5997),(62062,5997),(62063,5998),(62064,5998),(62065,5998),(62066,5998),(62067,5998),(62068,5998),(62069,5998),(62070,5998),(62071,5998),(62072,5998),(62073,5998),(62074,5999),(62075,5999),(62076,5999),(62077,5999),(62078,5999),(62079,5999),(62080,5999),(62081,5999),(62082,5999),(62083,5999),(62084,5999),(62085,6000),(62086,6000),(62087,6000),(62088,6000),(62089,6000),(62090,6000),(62091,6000),(62092,6000),(62093,6000),(62094,6000),(62095,6000),(62096,6001),(62097,6001),(62098,6001),(62099,6001),(62100,6001),(62101,6001),(62102,6001),(62103,6001),(62104,6001),(62105,6001),(62106,6001),(62107,6002),(62108,6002),(62109,6002),(62110,6002),(62111,6002),(62112,6002),(62113,6002),(62114,6002),(62115,6002),(62116,6002),(62117,6002),(62118,6003),(62119,6003),(62120,6003),(62121,6003),(62122,6003),(62123,6003),(62124,6003),(62125,6003),(62126,6003),(62127,6003),(62128,6003),(62129,6004),(62130,6004),(62131,6004),(62132,6004),(62133,6004),(62134,6004),(62135,6004),(62136,6004),(62137,6004),(62138,6004),(62139,6004),(62140,6005),(62141,6005),(62142,6005),(62143,6005),(62144,6005),(62145,6005),(62146,6005),(62147,6005),(62148,6005),(62149,6005),(62150,6005),(62151,6006),(62152,6006),(62153,6006),(62154,6006),(62155,6006),(62156,6006),(62157,6006),(62158,6006),(62159,6006),(62160,6006),(62161,6006),(62162,6007),(62163,6007),(62164,6007),(62165,6007),(62166,6007),(62167,6007),(62168,6007),(62169,6007),(62170,6007),(62171,6007),(62172,6007),(62173,6008),(62174,6008),(62175,6008),(62176,6008),(62177,6008),(62178,6008),(62179,6008),(62180,6008),(62181,6008),(62182,6008),(62183,6008),(62184,6009),(62185,6009),(62186,6009),(62187,6009),(62188,6009),(62189,6009),(62190,6009),(62191,6009),(62192,6009),(62193,6009),(62194,6009),(62195,6010),(62196,6010),(62197,6010),(62198,6010),(62199,6010),(62200,6010),(62201,6010),(62202,6010),(62203,6010),(62204,6010),(62205,6010),(62206,6011),(62207,6011),(62208,6011),(62209,6011),(62210,6011),(62211,6011),(62212,6011),(62213,6011),(62214,6011),(62215,6011),(62216,6011),(62217,6012),(62218,6012),(62219,6012),(62220,6012),(62221,6012),(62222,6012),(62223,6012),(62224,6012),(62225,6012),(62226,6012),(62227,6012),(62228,6013),(62229,6013),(62230,6013),(62231,6013),(62232,6013),(62233,6013),(62234,6013),(62235,6013),(62236,6013),(62237,6013),(62238,6013),(62239,6014),(62240,6014),(62241,6014),(62242,6014),(62243,6014),(62244,6014),(62245,6014),(62246,6014),(62247,6014),(62248,6014),(62249,6014),(62250,6015),(62251,6015),(62252,6015),(62253,6015),(62254,6015),(62255,6015),(62256,6015),(62257,6015),(62258,6015),(62259,6015),(62260,6015),(62261,6016),(62262,6016),(62263,6016),(62264,6016),(62265,6016),(62266,6016),(62267,6016),(62268,6016),(62269,6016),(62270,6016),(62271,6016),(62272,6017),(62273,6017),(62274,6017),(62275,6017),(62276,6017),(62277,6017),(62278,6017),(62279,6017),(62280,6017),(62281,6017),(62282,6017),(62283,6018),(62284,6018),(62285,6018),(62286,6018),(62287,6018),(62288,6018),(62289,6018),(62290,6018),(62291,6018),(62292,6018),(62293,6018),(62294,6019),(62295,6019),(62296,6019),(62297,6019),(62298,6019),(62299,6019),(62300,6019),(62301,6019),(62302,6019),(62303,6019),(62304,6019),(62305,6020),(62306,6020),(62307,6020),(62308,6020),(62309,6020),(62310,6020),(62311,6020),(62312,6020),(62313,6020),(62314,6020),(62315,6020),(62316,6021),(62317,6021),(62318,6021),(62319,6021),(62320,6021),(62321,6021),(62322,6021),(62323,6021),(62324,6021),(62325,6021),(62326,6021),(62327,6022),(62328,6022),(62329,6022),(62330,6022),(62331,6022),(62332,6022),(62333,6022),(62334,6022),(62335,6022),(62336,6022),(62337,6022),(62338,6023),(62339,6023),(62340,6023),(62341,6023),(62342,6023),(62343,6023),(62344,6023),(62345,6023),(62346,6023),(62347,6023),(62348,6023),(62349,6024),(62350,6024),(62351,6024),(62352,6024),(62353,6024),(62354,6024),(62355,6024),(62356,6024),(62357,6024),(62358,6024),(62359,6024),(62360,6025),(62361,6025),(62362,6025),(62363,6025),(62364,6025),(62365,6025),(62366,6025),(62367,6025),(62368,6025),(62369,6025),(62370,6025),(62371,6026),(62372,6026),(62373,6026),(62374,6026),(62375,6026),(62376,6026),(62377,6026),(62378,6026),(62379,6026),(62380,6026),(62381,6026),(62382,6027),(62383,6027),(62384,6027),(62385,6027),(62386,6027),(62387,6027),(62388,6027),(62389,6027),(62390,6027),(62391,6027),(62392,6027),(62393,6028),(62394,6028),(62395,6028),(62396,6028),(62397,6028),(62398,6028),(62399,6028),(62400,6028),(62401,6028),(62402,6028),(62403,6028),(62404,6029),(62405,6029),(62406,6029),(62407,6029),(62408,6029),(62409,6029),(62410,6029),(62411,6029),(62412,6029),(62413,6029),(62414,6029),(62415,6030),(62416,6030),(62417,6030),(62418,6030),(62419,6030),(62420,6030),(62421,6030),(62422,6030),(62423,6030),(62424,6030),(62425,6030),(62426,6031),(62427,6031),(62428,6031),(62429,6031),(62430,6031),(62431,6031),(62432,6031),(62433,6031),(62434,6031),(62435,6031),(62436,6031),(62437,6032),(62438,6032),(62439,6032),(62440,6032),(62441,6032),(62442,6032),(62443,6032),(62444,6032),(62445,6032),(62446,6032),(62447,6032),(62448,6033),(62449,6033),(62450,6033),(62451,6033),(62452,6033),(62453,6033),(62454,6033),(62455,6033),(62456,6033),(62457,6033),(62458,6033),(62459,6034),(62460,6034),(62461,6034),(62462,6034),(62463,6034),(62464,6034),(62465,6034),(62466,6034),(62467,6034),(62468,6034),(62469,6034),(62470,5761),(62471,5762),(62472,5763),(62473,5764),(62474,5765),(62475,5766),(62476,5767),(62477,5768),(62478,5769),(62479,5770),(62480,5771),(62481,5772),(62482,5773),(62483,5774),(62484,5775),(62485,5776),(62486,5777),(62487,5778),(62488,5779),(62489,5780),(62490,5781),(62491,5782),(62492,5783),(62493,5784),(62494,5785),(62495,5786),(62496,5787),(62497,5788),(62498,5789),(62499,5790),(62500,5791),(62501,5792),(62502,5793),(62503,5794),(62504,5795),(62505,5796),(62506,5797),(62507,5798),(62508,5799),(62509,5800),(62510,5801),(62511,5802),(62512,5803),(62513,5804),(62514,5805),(62515,5806),(62516,5807),(62517,5808),(62518,5809),(62519,5810),(62520,5811),(62521,5812),(62522,5813),(62523,5814),(62524,5815),(62525,5816),(62526,5817),(62527,5818),(62528,5819),(62529,5820),(62530,5821),(62531,5822),(62532,5823),(62533,5824),(62534,5825),(62535,5826),(62536,5827),(62537,5828),(62538,5829),(62539,5830),(62540,5831),(62541,5832),(62542,5833),(62543,5834),(62544,5835),(62545,5836),(62546,5837),(62547,5838),(62548,5839),(62549,5840),(62550,5841),(62551,5842),(62552,5843),(62553,5844),(62554,5845),(62555,5846),(62556,5847),(62557,5848),(62558,5849),(62559,5850),(62560,5851),(62561,5852),(62562,5853),(62563,5854),(62564,5855),(62565,5856),(62566,5857),(62567,5858),(62568,5859),(62569,5860),(62570,5861),(62571,5862),(62572,5863),(62573,5864),(62574,5865),(62575,5866),(62576,5867),(62577,5868),(62578,5869),(62579,5870),(62580,5871),(62581,5872),(62582,5873),(62583,5874),(62584,5875),(62585,5876),(62586,5877),(62587,5878),(62588,5879),(62589,5880),(62590,5881),(62591,5882),(62592,5883),(62593,5884),(62594,5885),(62595,5886),(62596,5887),(62597,5888),(62598,5889),(62599,5890),(62600,5891),(62601,5892),(62602,5893),(62603,5894),(62604,5895),(62605,5896),(62606,5897),(62607,5898),(62608,5899),(62609,5900),(62610,5901),(62611,5902),(62612,5903),(62613,5904),(62614,5905),(62615,5906),(62616,5907),(62617,5908),(62618,5909),(62619,5910),(62620,5911),(62621,5912),(62622,5913),(62623,5914),(62624,5915),(62625,5916),(62626,5917),(62627,5918),(62628,5919),(62629,5920),(62630,5921),(62631,5922),(62632,5923),(62633,5924),(62634,5925),(62635,5926),(62636,5927),(62637,5928),(62638,5929),(62639,5930),(62640,5931),(62641,5932),(62642,5933),(62643,5934),(62644,5935),(62645,5936),(62646,5937),(62647,5938),(62648,5939),(62649,5940),(62650,5941),(62651,5942),(62652,5943),(62653,5944),(62654,5945),(62655,5946),(62656,5947),(62657,5948),(62658,5949),(62659,5950),(62660,5951),(62661,5952),(62662,5953),(62663,5954),(62664,5955),(62665,5956),(62666,5957),(62667,5958),(62668,5959),(62669,5960),(62670,5961),(62671,5962),(62672,5963),(62673,5964),(62674,5965),(62675,5966),(62676,5967),(62677,5968),(62678,5969),(62679,5970),(62680,5971),(62681,5972),(62682,5973),(62683,5974),(62684,5975),(62685,5976),(62686,5977),(62687,5978),(62688,5979),(62689,5980),(62690,5981),(62691,5982),(62692,5983),(62693,5984),(62694,5985),(62695,5986),(62696,5987),(62697,5988),(62698,5989),(62699,5990),(62700,5991),(62701,5992),(62702,5993),(62703,5994),(62704,5995),(62705,5996),(62706,5997),(62707,5998),(62708,5999),(62709,6000),(62710,6001),(62711,6002),(62712,6003),(62713,6004),(62714,6005),(62715,6006),(62716,6007),(62717,6008),(62718,6009),(62719,6010),(62720,6011),(62721,6012),(62722,6013),(62723,6014),(62724,6015),(62725,6016),(62726,6017),(62727,6018),(62728,6019),(62729,6020),(62730,6021),(62731,6022),(62732,6023),(62733,6024),(62734,6025),(62735,6026),(62736,6027),(62737,6028),(62738,6029),(62739,6030),(62740,6031),(62741,6032),(62742,6033),(62743,6034),(62744,6035),(62745,6036),(62746,6037),(62747,6038),(62748,6039),(62749,6040),(62750,6041),(62751,6042),(62752,6043),(62753,6044),(62754,6045),(62755,6046),(62756,6047),(62757,6048),(62758,6049),(62759,6050),(62760,6051),(62761,6052),(62762,6053),(62763,6054),(62764,6055),(62765,6056),(62766,6057),(62767,6058),(62768,6059),(62769,6060),(62770,6061),(62771,6062),(62772,6063),(62773,6064),(62774,6065),(62775,6066),(62776,6067),(62777,6068),(62778,6069),(62779,6070),(62780,6071),(62781,6072),(62782,6073),(62783,6074),(62784,6075),(62785,6076),(62786,6077),(62787,6078),(62788,6079),(62789,6080),(62790,6081),(62791,6082),(62792,6083),(62793,6084),(62794,6085),(62795,6086),(62796,6087),(62797,6088),(62798,6089),(62799,6090),(62800,6091),(62801,6092),(62802,6093),(62803,6094),(62804,6095),(62805,6096),(62806,6097),(62807,6098),(62808,6099),(62809,6100),(62810,6101),(62811,6102),(62812,6103),(62813,6104),(62814,6105),(62815,6106),(62816,6107),(62817,6108),(62818,6109),(62819,6110),(62820,6111),(62821,6112),(62822,6113),(62823,6114),(62824,6115),(62825,6116),(62826,6117),(62827,6118),(62828,6119),(62829,6120),(62830,6121),(62831,6122),(62832,6123),(62833,6124),(62834,6125),(62835,6126),(62836,6127),(62837,6128),(62838,6129),(62839,6130),(62840,6131),(62841,6132),(62842,6133),(62843,6134),(62844,6035),(62845,6036),(62846,6037),(62847,6038),(62848,6039),(62849,6040),(62850,6041),(62851,6042),(62852,6043),(62853,6044),(62854,6045),(62855,6046),(62856,6047),(62857,6048),(62858,6049),(62859,6050),(62860,6051),(62861,6052),(62862,6053),(62863,6054),(62864,6055),(62865,6056),(62866,6057),(62867,6058),(62868,6059),(62869,6060),(62870,6061),(62871,6062),(62872,6063),(62873,6064),(62874,6065),(62875,6066),(62876,6067),(62877,6068),(62878,6069),(62879,6070),(62880,6071),(62881,6072),(62882,6073),(62883,6074),(62884,6075),(62885,6076),(62886,6077),(62887,6078),(62888,6079),(62889,6080),(62890,6081),(62891,6082),(62892,6083),(62893,6084),(62894,6085),(62895,6086),(62896,6087),(62897,6088),(62898,6089),(62899,6090),(62900,6091),(62901,6092),(62902,6093),(62903,6094),(62904,6095),(62905,6096),(62906,6097),(62907,6098),(62908,6099),(62909,6100),(62910,6101),(62911,6102),(62912,6103),(62913,6104),(62914,6105),(62915,6106),(62916,6107),(62917,6108),(62918,6109),(62919,6110),(62920,6111),(62921,6112),(62922,6113),(62923,6114),(62924,6115),(62925,6116),(62926,6117),(62927,6118),(62928,6119),(62929,6120),(62930,6121),(62931,6122),(62932,6123),(62933,6124),(62934,6125),(62935,6126),(62936,6127),(62937,6128),(62938,6129),(62939,6130),(62940,6131),(62941,6132),(62942,6133),(62943,6134),(62944,6035),(62945,6035),(62946,6035),(62947,6036),(62948,6036),(62949,6036),(62950,6037),(62951,6037),(62952,6037),(62953,6038),(62954,6038),(62955,6038),(62956,6039),(62957,6039),(62958,6039),(62959,6040),(62960,6040),(62961,6040),(62962,6041),(62963,6041),(62964,6041),(62965,6042),(62966,6042),(62967,6042),(62968,6043),(62969,6043),(62970,6043),(62971,6044),(62972,6044),(62973,6044),(62974,6045),(62975,6045),(62976,6045),(62977,6046),(62978,6046),(62979,6046),(62980,6047),(62981,6047),(62982,6047),(62983,6048),(62984,6048),(62985,6048),(62986,6049),(62987,6049),(62988,6049),(62989,6050),(62990,6050),(62991,6050),(62992,6051),(62993,6051),(62994,6051),(62995,6052),(62996,6052),(62997,6052),(62998,6053),(62999,6053),(63000,6053),(63001,6054),(63002,6054),(63003,6054),(63004,6055),(63005,6055),(63006,6055),(63007,6056),(63008,6056),(63009,6056),(63010,6057),(63011,6057),(63012,6057),(63013,6058),(63014,6058),(63015,6058),(63016,6059),(63017,6059),(63018,6059),(63019,6060),(63020,6060),(63021,6060),(63022,6061),(63023,6061),(63024,6061),(63025,6062),(63026,6062),(63027,6062),(63028,6063),(63029,6063),(63030,6063),(63031,6064),(63032,6064),(63033,6064),(63034,6065),(63035,6065),(63036,6065),(63037,6066),(63038,6066),(63039,6066),(63040,6067),(63041,6067),(63042,6067),(63043,6068),(63044,6068),(63045,6068),(63046,6069),(63047,6069),(63048,6069),(63049,6070),(63050,6070),(63051,6070),(63052,6071),(63053,6071),(63054,6071),(63055,6072),(63056,6072),(63057,6072),(63058,6073),(63059,6073),(63060,6073),(63061,6074),(63062,6074),(63063,6074),(63064,6075),(63065,6075),(63066,6075),(63067,6076),(63068,6076),(63069,6076),(63070,6077),(63071,6077),(63072,6077),(63073,6078),(63074,6078),(63075,6078),(63076,6079),(63077,6079),(63078,6079),(63079,6080),(63080,6080),(63081,6080),(63082,6081),(63083,6081),(63084,6081),(63085,6082),(63086,6082),(63087,6082),(63088,6083),(63089,6083),(63090,6083),(63091,6084),(63092,6084),(63093,6084),(63094,6085),(63095,6085),(63096,6085),(63097,6086),(63098,6086),(63099,6086),(63100,6087),(63101,6087),(63102,6087),(63103,6088),(63104,6088),(63105,6088),(63106,6089),(63107,6089),(63108,6089),(63109,6090),(63110,6090),(63111,6090),(63112,6091),(63113,6091),(63114,6091),(63115,6092),(63116,6092),(63117,6092),(63118,6093),(63119,6093),(63120,6093),(63121,6094),(63122,6094),(63123,6094),(63124,6095),(63125,6095),(63126,6095),(63127,6096),(63128,6096),(63129,6096),(63130,6097),(63131,6097),(63132,6097),(63133,6098),(63134,6098),(63135,6098),(63136,6099),(63137,6099),(63138,6099),(63139,6100),(63140,6100),(63141,6100),(63142,6101),(63143,6101),(63144,6101),(63145,6102),(63146,6102),(63147,6102),(63148,6103),(63149,6103),(63150,6103),(63151,6104),(63152,6104),(63153,6104),(63154,6105),(63155,6105),(63156,6105),(63157,6106),(63158,6106),(63159,6106),(63160,6107),(63161,6107),(63162,6107),(63163,6108),(63164,6108),(63165,6108),(63166,6109),(63167,6109),(63168,6109),(63169,6110),(63170,6110),(63171,6110),(63172,6111),(63173,6111),(63174,6111),(63175,6112),(63176,6112),(63177,6112),(63178,6113),(63179,6113),(63180,6113),(63181,6114),(63182,6114),(63183,6114),(63184,6115),(63185,6115),(63186,6115),(63187,6116),(63188,6116),(63189,6116),(63190,6117),(63191,6117),(63192,6117),(63193,6118),(63194,6118),(63195,6118),(63196,6119),(63197,6119),(63198,6119),(63199,6120),(63200,6120),(63201,6120),(63202,6121),(63203,6121),(63204,6121),(63205,6122),(63206,6122),(63207,6122),(63208,6123),(63209,6123),(63210,6123),(63211,6124),(63212,6124),(63213,6124),(63214,6125),(63215,6125),(63216,6125),(63217,6126),(63218,6126),(63219,6126),(63220,6127),(63221,6127),(63222,6127),(63223,6128),(63224,6128),(63225,6128),(63226,6129),(63227,6129),(63228,6129),(63229,6130),(63230,6130),(63231,6130),(63232,6131),(63233,6131),(63234,6131),(63235,6132),(63236,6132),(63237,6132),(63238,6133),(63239,6133),(63240,6133),(63241,6134),(63242,6134),(63243,6134),(63244,6035),(63245,6035),(63246,6035),(63247,6035),(63248,6035),(63249,6036),(63250,6036),(63251,6036),(63252,6036),(63253,6036),(63254,6037),(63255,6037),(63256,6037),(63257,6037),(63258,6037),(63259,6038),(63260,6038),(63261,6038),(63262,6038),(63263,6038),(63264,6039),(63265,6039),(63266,6039),(63267,6039),(63268,6039),(63269,6040),(63270,6040),(63271,6040),(63272,6040),(63273,6040),(63274,6041),(63275,6041),(63276,6041),(63277,6041),(63278,6041),(63279,6042),(63280,6042),(63281,6042),(63282,6042),(63283,6042),(63284,6043),(63285,6043),(63286,6043),(63287,6043),(63288,6043),(63289,6044),(63290,6044),(63291,6044),(63292,6044),(63293,6044),(63294,6045),(63295,6045),(63296,6045),(63297,6045),(63298,6045),(63299,6046),(63300,6046),(63301,6046),(63302,6046),(63303,6046),(63304,6047),(63305,6047),(63306,6047),(63307,6047),(63308,6047),(63309,6048),(63310,6048),(63311,6048),(63312,6048),(63313,6048),(63314,6049),(63315,6049),(63316,6049),(63317,6049),(63318,6049),(63319,6050),(63320,6050),(63321,6050),(63322,6050),(63323,6050),(63324,6051),(63325,6051),(63326,6051),(63327,6051),(63328,6051),(63329,6052),(63330,6052),(63331,6052),(63332,6052),(63333,6052),(63334,6053),(63335,6053),(63336,6053),(63337,6053),(63338,6053),(63339,6054),(63340,6054),(63341,6054),(63342,6054),(63343,6054),(63344,6055),(63345,6055),(63346,6055),(63347,6055),(63348,6055),(63349,6056),(63350,6056),(63351,6056),(63352,6056),(63353,6056),(63354,6057),(63355,6057),(63356,6057),(63357,6057),(63358,6057),(63359,6058),(63360,6058),(63361,6058),(63362,6058),(63363,6058),(63364,6059),(63365,6059),(63366,6059),(63367,6059),(63368,6059),(63369,6060),(63370,6060),(63371,6060),(63372,6060),(63373,6060),(63374,6061),(63375,6061),(63376,6061),(63377,6061),(63378,6061),(63379,6062),(63380,6062),(63381,6062),(63382,6062),(63383,6062),(63384,6063),(63385,6063),(63386,6063),(63387,6063),(63388,6063),(63389,6064),(63390,6064),(63391,6064),(63392,6064),(63393,6064),(63394,6065),(63395,6065),(63396,6065),(63397,6065),(63398,6065),(63399,6066),(63400,6066),(63401,6066),(63402,6066),(63403,6066),(63404,6067),(63405,6067),(63406,6067),(63407,6067),(63408,6067),(63409,6068),(63410,6068),(63411,6068),(63412,6068),(63413,6068),(63414,6069),(63415,6069),(63416,6069),(63417,6069),(63418,6069),(63419,6070),(63420,6070),(63421,6070),(63422,6070),(63423,6070),(63424,6071),(63425,6071),(63426,6071),(63427,6071),(63428,6071),(63429,6072),(63430,6072),(63431,6072),(63432,6072),(63433,6072),(63434,6073),(63435,6073),(63436,6073),(63437,6073),(63438,6073),(63439,6074),(63440,6074),(63441,6074),(63442,6074),(63443,6074),(63444,6075),(63445,6075),(63446,6075),(63447,6075),(63448,6075),(63449,6076),(63450,6076),(63451,6076),(63452,6076),(63453,6076),(63454,6077),(63455,6077),(63456,6077),(63457,6077),(63458,6077),(63459,6078),(63460,6078),(63461,6078),(63462,6078),(63463,6078),(63464,6079),(63465,6079),(63466,6079),(63467,6079),(63468,6079),(63469,6080),(63470,6080),(63471,6080),(63472,6080),(63473,6080),(63474,6081),(63475,6081),(63476,6081),(63477,6081),(63478,6081),(63479,6082),(63480,6082),(63481,6082),(63482,6082),(63483,6082),(63484,6083),(63485,6083),(63486,6083),(63487,6083),(63488,6083),(63489,6084),(63490,6084),(63491,6084),(63492,6084),(63493,6084),(63494,6085),(63495,6085),(63496,6085),(63497,6085),(63498,6085),(63499,6086),(63500,6086),(63501,6086),(63502,6086),(63503,6086),(63504,6087),(63505,6087),(63506,6087),(63507,6087),(63508,6087),(63509,6088),(63510,6088),(63511,6088),(63512,6088),(63513,6088),(63514,6089),(63515,6089),(63516,6089),(63517,6089),(63518,6089),(63519,6090),(63520,6090),(63521,6090),(63522,6090),(63523,6090),(63524,6091),(63525,6091),(63526,6091),(63527,6091),(63528,6091),(63529,6092),(63530,6092),(63531,6092),(63532,6092),(63533,6092),(63534,6093),(63535,6093),(63536,6093),(63537,6093),(63538,6093),(63539,6094),(63540,6094),(63541,6094),(63542,6094),(63543,6094),(63544,6095),(63545,6095),(63546,6095),(63547,6095),(63548,6095),(63549,6096),(63550,6096),(63551,6096),(63552,6096),(63553,6096),(63554,6097),(63555,6097),(63556,6097),(63557,6097),(63558,6097),(63559,6098),(63560,6098),(63561,6098),(63562,6098),(63563,6098),(63564,6099),(63565,6099),(63566,6099),(63567,6099),(63568,6099),(63569,6100),(63570,6100),(63571,6100),(63572,6100),(63573,6100),(63574,6101),(63575,6101),(63576,6101),(63577,6101),(63578,6101),(63579,6102),(63580,6102),(63581,6102),(63582,6102),(63583,6102),(63584,6103),(63585,6103),(63586,6103),(63587,6103),(63588,6103),(63589,6104),(63590,6104),(63591,6104),(63592,6104),(63593,6104),(63594,6105),(63595,6105),(63596,6105),(63597,6105),(63598,6105),(63599,6106),(63600,6106),(63601,6106),(63602,6106),(63603,6106),(63604,6107),(63605,6107),(63606,6107),(63607,6107),(63608,6107),(63609,6108),(63610,6108),(63611,6108),(63612,6108),(63613,6108),(63614,6109),(63615,6109),(63616,6109),(63617,6109),(63618,6109),(63619,6110),(63620,6110),(63621,6110),(63622,6110),(63623,6110),(63624,6111),(63625,6111),(63626,6111),(63627,6111),(63628,6111),(63629,6112),(63630,6112),(63631,6112),(63632,6112),(63633,6112),(63634,6113),(63635,6113),(63636,6113),(63637,6113),(63638,6113),(63639,6114),(63640,6114),(63641,6114),(63642,6114),(63643,6114),(63644,6115),(63645,6115),(63646,6115),(63647,6115),(63648,6115),(63649,6116),(63650,6116),(63651,6116),(63652,6116),(63653,6116),(63654,6117),(63655,6117),(63656,6117),(63657,6117),(63658,6117),(63659,6118),(63660,6118),(63661,6118),(63662,6118),(63663,6118),(63664,6119),(63665,6119),(63666,6119),(63667,6119),(63668,6119),(63669,6120),(63670,6120),(63671,6120),(63672,6120),(63673,6120),(63674,6121),(63675,6121),(63676,6121),(63677,6121),(63678,6121),(63679,6122),(63680,6122),(63681,6122),(63682,6122),(63683,6122),(63684,6123),(63685,6123),(63686,6123),(63687,6123),(63688,6123),(63689,6124),(63690,6124),(63691,6124),(63692,6124),(63693,6124),(63694,6125),(63695,6125),(63696,6125),(63697,6125),(63698,6125),(63699,6126),(63700,6126),(63701,6126),(63702,6126),(63703,6126),(63704,6127),(63705,6127),(63706,6127),(63707,6127),(63708,6127),(63709,6128),(63710,6128),(63711,6128),(63712,6128),(63713,6128),(63714,6129),(63715,6129),(63716,6129),(63717,6129),(63718,6129),(63719,6130),(63720,6130),(63721,6130),(63722,6130),(63723,6130),(63724,6131),(63725,6131),(63726,6131),(63727,6131),(63728,6131),(63729,6132),(63730,6132),(63731,6132),(63732,6132),(63733,6132),(63734,6133),(63735,6133),(63736,6133),(63737,6133),(63738,6133),(63739,6134),(63740,6134),(63741,6134),(63742,6134),(63743,6134),(63744,6135),(63745,6136),(63746,6137),(63747,6138),(63748,6139),(63749,6140),(63750,6141),(63751,6142),(63752,6143),(63753,6144),(63754,6145),(63755,6146),(63756,6147),(63757,6148),(63758,6149),(63759,6150),(63760,6151),(63761,6152),(63762,6153),(63763,6154),(63764,6155),(63765,6156),(63766,6157),(63767,6158),(63768,6159),(63769,6160),(63770,6161),(63771,6162),(63772,6163),(63773,6164),(63774,6165),(63775,6166),(63776,6167),(63777,6168),(63778,6169),(63779,6170),(63780,6171),(63781,6172),(63782,6173),(63783,6174),(63784,6175),(63785,6176),(63786,6177),(63787,6178),(63788,6179),(63789,6180),(63790,6181),(63791,6182),(63792,6183),(63793,6184),(63794,6185),(63795,6186),(63796,6187),(63797,6188),(63798,6189),(63799,6190),(63800,6191),(63801,6192),(63802,6193),(63803,6194),(63804,6195),(63805,6196),(63806,6197),(63807,6198),(63808,6199),(63809,6200),(63810,6201),(63811,6202),(63812,6203),(63813,6204),(63814,6205),(63815,6206),(63816,6207),(63817,6208),(63818,6209),(63819,6210),(63820,6211),(63821,6212),(63822,6213),(63823,6214),(63824,6215),(63825,6216),(63826,6217),(63827,6218),(63828,6219),(63829,6220),(63830,6221),(63831,6222),(63832,6223),(63833,6224),(63834,6225),(63835,6226),(63836,6227),(63837,6228),(63838,6229),(63839,6230),(63840,6231),(63841,6232),(63842,6233),(63843,6234),(63844,6135),(63845,6136),(63846,6137),(63847,6138),(63848,6139),(63849,6140),(63850,6141),(63851,6142),(63852,6143),(63853,6144),(63854,6145),(63855,6146),(63856,6147),(63857,6148),(63858,6149),(63859,6150),(63860,6151),(63861,6152),(63862,6153),(63863,6154),(63864,6155),(63865,6156),(63866,6157),(63867,6158),(63868,6159),(63869,6160),(63870,6161),(63871,6162),(63872,6163),(63873,6164),(63874,6165),(63875,6166),(63876,6167),(63877,6168),(63878,6169),(63879,6170),(63880,6171),(63881,6172),(63882,6173),(63883,6174),(63884,6175),(63885,6176),(63886,6177),(63887,6178),(63888,6179),(63889,6180),(63890,6181),(63891,6182),(63892,6183),(63893,6184),(63894,6185),(63895,6186),(63896,6187),(63897,6188),(63898,6189),(63899,6190),(63900,6191),(63901,6192),(63902,6193),(63903,6194),(63904,6195),(63905,6196),(63906,6197),(63907,6198),(63908,6199),(63909,6200),(63910,6201),(63911,6202),(63912,6203),(63913,6204),(63914,6205),(63915,6206),(63916,6207),(63917,6208),(63918,6209),(63919,6210),(63920,6211),(63921,6212),(63922,6213),(63923,6214),(63924,6215),(63925,6216),(63926,6217),(63927,6218),(63928,6219),(63929,6220),(63930,6221),(63931,6222),(63932,6223),(63933,6224),(63934,6225),(63935,6226),(63936,6227),(63937,6228),(63938,6229),(63939,6230),(63940,6231),(63941,6232),(63942,6233),(63943,6234),(63944,6135),(63945,6135),(63946,6135),(63947,6136),(63948,6136),(63949,6136),(63950,6137),(63951,6137),(63952,6137),(63953,6138),(63954,6138),(63955,6138),(63956,6139),(63957,6139),(63958,6139),(63959,6140),(63960,6140),(63961,6140),(63962,6141),(63963,6141),(63964,6141),(63965,6142),(63966,6142),(63967,6142),(63968,6143),(63969,6143),(63970,6143),(63971,6144),(63972,6144),(63973,6144),(63974,6145),(63975,6145),(63976,6145),(63977,6146),(63978,6146),(63979,6146),(63980,6147),(63981,6147),(63982,6147),(63983,6148),(63984,6148),(63985,6148),(63986,6149),(63987,6149),(63988,6149),(63989,6150),(63990,6150),(63991,6150),(63992,6151),(63993,6151),(63994,6151),(63995,6152),(63996,6152),(63997,6152),(63998,6153),(63999,6153),(64000,6153),(64001,6154),(64002,6154),(64003,6154),(64004,6155),(64005,6155),(64006,6155),(64007,6156),(64008,6156),(64009,6156),(64010,6157),(64011,6157),(64012,6157),(64013,6158),(64014,6158),(64015,6158),(64016,6159),(64017,6159),(64018,6159),(64019,6160),(64020,6160),(64021,6160),(64022,6161),(64023,6161),(64024,6161),(64025,6162),(64026,6162),(64027,6162),(64028,6163),(64029,6163),(64030,6163),(64031,6164),(64032,6164),(64033,6164),(64034,6165),(64035,6165),(64036,6165),(64037,6166),(64038,6166),(64039,6166),(64040,6167),(64041,6167),(64042,6167),(64043,6168),(64044,6168),(64045,6168),(64046,6169),(64047,6169),(64048,6169),(64049,6170),(64050,6170),(64051,6170),(64052,6171),(64053,6171),(64054,6171),(64055,6172),(64056,6172),(64057,6172),(64058,6173),(64059,6173),(64060,6173),(64061,6174),(64062,6174),(64063,6174),(64064,6175),(64065,6175),(64066,6175),(64067,6176),(64068,6176),(64069,6176),(64070,6177),(64071,6177),(64072,6177),(64073,6178),(64074,6178),(64075,6178),(64076,6179),(64077,6179),(64078,6179),(64079,6180),(64080,6180),(64081,6180),(64082,6181),(64083,6181),(64084,6181),(64085,6182),(64086,6182),(64087,6182),(64088,6183),(64089,6183),(64090,6183),(64091,6184),(64092,6184),(64093,6184),(64094,6185),(64095,6185),(64096,6185),(64097,6186),(64098,6186),(64099,6186),(64100,6187),(64101,6187),(64102,6187),(64103,6188),(64104,6188),(64105,6188),(64106,6189),(64107,6189),(64108,6189),(64109,6190),(64110,6190),(64111,6190),(64112,6191),(64113,6191),(64114,6191),(64115,6192),(64116,6192),(64117,6192),(64118,6193),(64119,6193),(64120,6193),(64121,6194),(64122,6194),(64123,6194),(64124,6195),(64125,6195),(64126,6195),(64127,6196),(64128,6196),(64129,6196),(64130,6197),(64131,6197),(64132,6197),(64133,6198),(64134,6198),(64135,6198),(64136,6199),(64137,6199),(64138,6199),(64139,6200),(64140,6200),(64141,6200),(64142,6201),(64143,6201),(64144,6201),(64145,6202),(64146,6202),(64147,6202),(64148,6203),(64149,6203),(64150,6203),(64151,6204),(64152,6204),(64153,6204),(64154,6205),(64155,6205),(64156,6205),(64157,6206),(64158,6206),(64159,6206),(64160,6207),(64161,6207),(64162,6207),(64163,6208),(64164,6208),(64165,6208),(64166,6209),(64167,6209),(64168,6209),(64169,6210),(64170,6210),(64171,6210),(64172,6211),(64173,6211),(64174,6211),(64175,6212),(64176,6212),(64177,6212),(64178,6213),(64179,6213),(64180,6213),(64181,6214),(64182,6214),(64183,6214),(64184,6215),(64185,6215),(64186,6215),(64187,6216),(64188,6216),(64189,6216),(64190,6217),(64191,6217),(64192,6217),(64193,6218),(64194,6218),(64195,6218),(64196,6219),(64197,6219),(64198,6219),(64199,6220),(64200,6220),(64201,6220),(64202,6221),(64203,6221),(64204,6221),(64205,6222),(64206,6222),(64207,6222),(64208,6223),(64209,6223),(64210,6223),(64211,6224),(64212,6224),(64213,6224),(64214,6225),(64215,6225),(64216,6225),(64217,6226),(64218,6226),(64219,6226),(64220,6227),(64221,6227),(64222,6227),(64223,6228),(64224,6228),(64225,6228),(64226,6229),(64227,6229),(64228,6229),(64229,6230),(64230,6230),(64231,6230),(64232,6231),(64233,6231),(64234,6231),(64235,6232),(64236,6232),(64237,6232),(64238,6233),(64239,6233),(64240,6233),(64241,6234),(64242,6234),(64243,6234),(64244,6135),(64245,6135),(64246,6135),(64247,6135),(64248,6135),(64249,6136),(64250,6136),(64251,6136),(64252,6136),(64253,6136),(64254,6137),(64255,6137),(64256,6137),(64257,6137),(64258,6137),(64259,6138),(64260,6138),(64261,6138),(64262,6138),(64263,6138),(64264,6139),(64265,6139),(64266,6139),(64267,6139),(64268,6139),(64269,6140),(64270,6140),(64271,6140),(64272,6140),(64273,6140),(64274,6141),(64275,6141),(64276,6141),(64277,6141),(64278,6141),(64279,6142),(64280,6142),(64281,6142),(64282,6142),(64283,6142),(64284,6143),(64285,6143),(64286,6143),(64287,6143),(64288,6143),(64289,6144),(64290,6144),(64291,6144),(64292,6144),(64293,6144),(64294,6145),(64295,6145),(64296,6145),(64297,6145),(64298,6145),(64299,6146),(64300,6146),(64301,6146),(64302,6146),(64303,6146),(64304,6147),(64305,6147),(64306,6147),(64307,6147),(64308,6147),(64309,6148),(64310,6148),(64311,6148),(64312,6148),(64313,6148),(64314,6149),(64315,6149),(64316,6149),(64317,6149),(64318,6149),(64319,6150),(64320,6150),(64321,6150),(64322,6150),(64323,6150),(64324,6151),(64325,6151),(64326,6151),(64327,6151),(64328,6151),(64329,6152),(64330,6152),(64331,6152),(64332,6152),(64333,6152),(64334,6153),(64335,6153),(64336,6153),(64337,6153),(64338,6153),(64339,6154),(64340,6154),(64341,6154),(64342,6154),(64343,6154),(64344,6155),(64345,6155),(64346,6155),(64347,6155),(64348,6155),(64349,6156),(64350,6156),(64351,6156),(64352,6156),(64353,6156),(64354,6157),(64355,6157),(64356,6157),(64357,6157),(64358,6157),(64359,6158),(64360,6158),(64361,6158),(64362,6158),(64363,6158),(64364,6159),(64365,6159),(64366,6159),(64367,6159),(64368,6159),(64369,6160),(64370,6160),(64371,6160),(64372,6160),(64373,6160),(64374,6161),(64375,6161),(64376,6161),(64377,6161),(64378,6161),(64379,6162),(64380,6162),(64381,6162),(64382,6162),(64383,6162),(64384,6163),(64385,6163),(64386,6163),(64387,6163),(64388,6163),(64389,6164),(64390,6164),(64391,6164),(64392,6164),(64393,6164),(64394,6165),(64395,6165),(64396,6165),(64397,6165),(64398,6165),(64399,6166),(64400,6166),(64401,6166),(64402,6166),(64403,6166),(64404,6167),(64405,6167),(64406,6167),(64407,6167),(64408,6167),(64409,6168),(64410,6168),(64411,6168),(64412,6168),(64413,6168),(64414,6169),(64415,6169),(64416,6169),(64417,6169),(64418,6169),(64419,6170),(64420,6170),(64421,6170),(64422,6170),(64423,6170),(64424,6171),(64425,6171),(64426,6171),(64427,6171),(64428,6171),(64429,6172),(64430,6172),(64431,6172),(64432,6172),(64433,6172),(64434,6173),(64435,6173),(64436,6173),(64437,6173),(64438,6173),(64439,6174),(64440,6174),(64441,6174),(64442,6174),(64443,6174),(64444,6175),(64445,6175),(64446,6175),(64447,6175),(64448,6175),(64449,6176),(64450,6176),(64451,6176),(64452,6176),(64453,6176),(64454,6177),(64455,6177),(64456,6177),(64457,6177),(64458,6177),(64459,6178),(64460,6178),(64461,6178),(64462,6178),(64463,6178),(64464,6179),(64465,6179),(64466,6179),(64467,6179),(64468,6179),(64469,6180),(64470,6180),(64471,6180),(64472,6180),(64473,6180),(64474,6181),(64475,6181),(64476,6181),(64477,6181),(64478,6181),(64479,6182),(64480,6182),(64481,6182),(64482,6182),(64483,6182),(64484,6183),(64485,6183),(64486,6183),(64487,6183),(64488,6183),(64489,6184),(64490,6184),(64491,6184),(64492,6184),(64493,6184),(64494,6185),(64495,6185),(64496,6185),(64497,6185),(64498,6185),(64499,6186),(64500,6186),(64501,6186),(64502,6186),(64503,6186),(64504,6187),(64505,6187),(64506,6187),(64507,6187),(64508,6187),(64509,6188),(64510,6188),(64511,6188),(64512,6188),(64513,6188),(64514,6189),(64515,6189),(64516,6189),(64517,6189),(64518,6189),(64519,6190),(64520,6190),(64521,6190),(64522,6190),(64523,6190),(64524,6191),(64525,6191),(64526,6191),(64527,6191),(64528,6191),(64529,6192),(64530,6192),(64531,6192),(64532,6192),(64533,6192),(64534,6193),(64535,6193),(64536,6193),(64537,6193),(64538,6193),(64539,6194),(64540,6194),(64541,6194),(64542,6194),(64543,6194),(64544,6195),(64545,6195),(64546,6195),(64547,6195),(64548,6195),(64549,6196),(64550,6196),(64551,6196),(64552,6196),(64553,6196),(64554,6197),(64555,6197),(64556,6197),(64557,6197),(64558,6197),(64559,6198),(64560,6198),(64561,6198),(64562,6198),(64563,6198),(64564,6199),(64565,6199),(64566,6199),(64567,6199),(64568,6199),(64569,6200),(64570,6200),(64571,6200),(64572,6200),(64573,6200),(64574,6201),(64575,6201),(64576,6201),(64577,6201),(64578,6201),(64579,6202),(64580,6202),(64581,6202),(64582,6202),(64583,6202),(64584,6203),(64585,6203),(64586,6203),(64587,6203),(64588,6203),(64589,6204),(64590,6204),(64591,6204),(64592,6204),(64593,6204),(64594,6205),(64595,6205),(64596,6205),(64597,6205),(64598,6205),(64599,6206),(64600,6206),(64601,6206),(64602,6206),(64603,6206),(64604,6207),(64605,6207),(64606,6207),(64607,6207),(64608,6207),(64609,6208),(64610,6208),(64611,6208),(64612,6208),(64613,6208),(64614,6209),(64615,6209),(64616,6209),(64617,6209),(64618,6209),(64619,6210),(64620,6210),(64621,6210),(64622,6210),(64623,6210),(64624,6211),(64625,6211),(64626,6211),(64627,6211),(64628,6211),(64629,6212),(64630,6212),(64631,6212),(64632,6212),(64633,6212),(64634,6213),(64635,6213),(64636,6213),(64637,6213),(64638,6213),(64639,6214),(64640,6214),(64641,6214),(64642,6214),(64643,6214),(64644,6215),(64645,6215),(64646,6215),(64647,6215),(64648,6215),(64649,6216),(64650,6216),(64651,6216),(64652,6216),(64653,6216),(64654,6217),(64655,6217),(64656,6217),(64657,6217),(64658,6217),(64659,6218),(64660,6218),(64661,6218),(64662,6218),(64663,6218),(64664,6219),(64665,6219),(64666,6219),(64667,6219),(64668,6219),(64669,6220),(64670,6220),(64671,6220),(64672,6220),(64673,6220),(64674,6221),(64675,6221),(64676,6221),(64677,6221),(64678,6221),(64679,6222),(64680,6222),(64681,6222),(64682,6222),(64683,6222),(64684,6223),(64685,6223),(64686,6223),(64687,6223),(64688,6223),(64689,6224),(64690,6224),(64691,6224),(64692,6224),(64693,6224),(64694,6225),(64695,6225),(64696,6225),(64697,6225),(64698,6225),(64699,6226),(64700,6226),(64701,6226),(64702,6226),(64703,6226),(64704,6227),(64705,6227),(64706,6227),(64707,6227),(64708,6227),(64709,6228),(64710,6228),(64711,6228),(64712,6228),(64713,6228),(64714,6229),(64715,6229),(64716,6229),(64717,6229),(64718,6229),(64719,6230),(64720,6230),(64721,6230),(64722,6230),(64723,6230),(64724,6231),(64725,6231),(64726,6231),(64727,6231),(64728,6231),(64729,6232),(64730,6232),(64731,6232),(64732,6232),(64733,6232),(64734,6233),(64735,6233),(64736,6233),(64737,6233),(64738,6233),(64739,6234),(64740,6234),(64741,6234),(64742,6234),(64743,6234),(64744,6235),(64745,6236),(64746,6237),(64747,6238),(64748,6239),(64749,6240),(64750,6241),(64751,6242),(64752,6243),(64753,6244),(64754,6245),(64755,6246),(64756,6247),(64757,6248),(64758,6249),(64759,6250),(64760,6251),(64761,6252),(64762,6253),(64763,6254),(64764,6255),(64765,6256),(64766,6257),(64767,6258),(64768,6259),(64769,6260),(64770,6261),(64771,6262),(64772,6263),(64773,6264),(64774,6265),(64775,6266),(64776,6267),(64777,6268),(64778,6269),(64779,6270),(64780,6271),(64781,6272),(64782,6273),(64783,6274),(64784,6275),(64785,6276),(64786,6277),(64787,6278),(64788,6279),(64789,6280),(64790,6281),(64791,6282),(64792,6283),(64793,6284),(64794,6285),(64795,6286),(64796,6287),(64797,6288),(64798,6289),(64799,6290),(64800,6291),(64801,6292),(64802,6293),(64803,6294),(64804,6295),(64805,6296),(64806,6297),(64807,6298),(64808,6299),(64809,6300),(64810,6301),(64811,6302),(64812,6303),(64813,6304),(64814,6305),(64815,6306),(64816,6307),(64817,6308),(64818,6309),(64819,6310),(64820,6311),(64821,6312),(64822,6313),(64823,6314),(64824,6315),(64825,6316),(64826,6317),(64827,6318),(64828,6319),(64829,6320),(64830,6321),(64831,6322),(64832,6323),(64833,6324),(64834,6325),(64835,6326),(64836,6327),(64837,6328),(64838,6329),(64839,6330),(64840,6331),(64841,6332),(64842,6333),(64843,6334),(64844,6235),(64845,6236),(64846,6237),(64847,6238),(64848,6239),(64849,6240),(64850,6241),(64851,6242),(64852,6243),(64853,6244),(64854,6245),(64855,6246),(64856,6247),(64857,6248),(64858,6249),(64859,6250),(64860,6251),(64861,6252),(64862,6253),(64863,6254),(64864,6255),(64865,6256),(64866,6257),(64867,6258),(64868,6259),(64869,6260),(64870,6261),(64871,6262),(64872,6263),(64873,6264),(64874,6265),(64875,6266),(64876,6267),(64877,6268),(64878,6269),(64879,6270),(64880,6271),(64881,6272),(64882,6273),(64883,6274),(64884,6275),(64885,6276),(64886,6277),(64887,6278),(64888,6279),(64889,6280),(64890,6281),(64891,6282),(64892,6283),(64893,6284),(64894,6285),(64895,6286),(64896,6287),(64897,6288),(64898,6289),(64899,6290),(64900,6291),(64901,6292),(64902,6293),(64903,6294),(64904,6295),(64905,6296),(64906,6297),(64907,6298),(64908,6299),(64909,6300),(64910,6301),(64911,6302),(64912,6303),(64913,6304),(64914,6305),(64915,6306),(64916,6307),(64917,6308),(64918,6309),(64919,6310),(64920,6311),(64921,6312),(64922,6313),(64923,6314),(64924,6315),(64925,6316),(64926,6317),(64927,6318),(64928,6319),(64929,6320),(64930,6321),(64931,6322),(64932,6323),(64933,6324),(64934,6325),(64935,6326),(64936,6327),(64937,6328),(64938,6329),(64939,6330),(64940,6331),(64941,6332),(64942,6333),(64943,6334),(64944,6235),(64945,6235),(64946,6235),(64947,6236),(64948,6236),(64949,6236),(64950,6237),(64951,6237),(64952,6237),(64953,6238),(64954,6238),(64955,6238),(64956,6239),(64957,6239),(64958,6239),(64959,6240),(64960,6240),(64961,6240),(64962,6241),(64963,6241),(64964,6241),(64965,6242),(64966,6242),(64967,6242),(64968,6243),(64969,6243),(64970,6243),(64971,6244),(64972,6244),(64973,6244),(64974,6245),(64975,6245),(64976,6245),(64977,6246),(64978,6246),(64979,6246),(64980,6247),(64981,6247),(64982,6247),(64983,6248),(64984,6248),(64985,6248),(64986,6249),(64987,6249),(64988,6249),(64989,6250),(64990,6250),(64991,6250),(64992,6251),(64993,6251),(64994,6251),(64995,6252),(64996,6252),(64997,6252),(64998,6253),(64999,6253),(65000,6253),(65001,6254),(65002,6254),(65003,6254),(65004,6255),(65005,6255),(65006,6255),(65007,6256),(65008,6256),(65009,6256),(65010,6257),(65011,6257),(65012,6257),(65013,6258),(65014,6258),(65015,6258),(65016,6259),(65017,6259),(65018,6259),(65019,6260),(65020,6260),(65021,6260),(65022,6261),(65023,6261),(65024,6261),(65025,6262),(65026,6262),(65027,6262),(65028,6263),(65029,6263),(65030,6263),(65031,6264),(65032,6264),(65033,6264),(65034,6265),(65035,6265),(65036,6265),(65037,6266),(65038,6266),(65039,6266),(65040,6267),(65041,6267),(65042,6267),(65043,6268),(65044,6268),(65045,6268),(65046,6269),(65047,6269),(65048,6269),(65049,6270),(65050,6270),(65051,6270),(65052,6271),(65053,6271),(65054,6271),(65055,6272),(65056,6272),(65057,6272),(65058,6273),(65059,6273),(65060,6273),(65061,6274),(65062,6274),(65063,6274),(65064,6275),(65065,6275),(65066,6275),(65067,6276),(65068,6276),(65069,6276),(65070,6277),(65071,6277),(65072,6277),(65073,6278),(65074,6278),(65075,6278),(65076,6279),(65077,6279),(65078,6279),(65079,6280),(65080,6280),(65081,6280),(65082,6281),(65083,6281),(65084,6281),(65085,6282),(65086,6282),(65087,6282),(65088,6283),(65089,6283),(65090,6283),(65091,6284),(65092,6284),(65093,6284),(65094,6285),(65095,6285),(65096,6285),(65097,6286),(65098,6286),(65099,6286),(65100,6287),(65101,6287),(65102,6287),(65103,6288),(65104,6288),(65105,6288),(65106,6289),(65107,6289),(65108,6289),(65109,6290),(65110,6290),(65111,6290),(65112,6291),(65113,6291),(65114,6291),(65115,6292),(65116,6292),(65117,6292),(65118,6293),(65119,6293),(65120,6293),(65121,6294),(65122,6294),(65123,6294),(65124,6295),(65125,6295),(65126,6295),(65127,6296),(65128,6296),(65129,6296),(65130,6297),(65131,6297),(65132,6297),(65133,6298),(65134,6298),(65135,6298),(65136,6299),(65137,6299),(65138,6299),(65139,6300),(65140,6300),(65141,6300),(65142,6301),(65143,6301),(65144,6301),(65145,6302),(65146,6302),(65147,6302),(65148,6303),(65149,6303),(65150,6303),(65151,6304),(65152,6304),(65153,6304),(65154,6305),(65155,6305),(65156,6305),(65157,6306),(65158,6306),(65159,6306),(65160,6307),(65161,6307),(65162,6307),(65163,6308),(65164,6308),(65165,6308),(65166,6309),(65167,6309),(65168,6309),(65169,6310),(65170,6310),(65171,6310),(65172,6311),(65173,6311),(65174,6311),(65175,6312),(65176,6312),(65177,6312),(65178,6313),(65179,6313),(65180,6313),(65181,6314),(65182,6314),(65183,6314),(65184,6315),(65185,6315),(65186,6315),(65187,6316),(65188,6316),(65189,6316),(65190,6317),(65191,6317),(65192,6317),(65193,6318),(65194,6318),(65195,6318),(65196,6319),(65197,6319),(65198,6319),(65199,6320),(65200,6320),(65201,6320),(65202,6321),(65203,6321),(65204,6321),(65205,6322),(65206,6322),(65207,6322),(65208,6323),(65209,6323),(65210,6323),(65211,6324),(65212,6324),(65213,6324),(65214,6325),(65215,6325),(65216,6325),(65217,6326),(65218,6326),(65219,6326),(65220,6327),(65221,6327),(65222,6327),(65223,6328),(65224,6328),(65225,6328),(65226,6329),(65227,6329),(65228,6329),(65229,6330),(65230,6330),(65231,6330),(65232,6331),(65233,6331),(65234,6331),(65235,6332),(65236,6332),(65237,6332),(65238,6333),(65239,6333),(65240,6333),(65241,6334),(65242,6334),(65243,6334),(65244,6235),(65245,6235),(65246,6235),(65247,6235),(65248,6235),(65249,6236),(65250,6236),(65251,6236),(65252,6236),(65253,6236),(65254,6237),(65255,6237),(65256,6237),(65257,6237),(65258,6237),(65259,6238),(65260,6238),(65261,6238),(65262,6238),(65263,6238),(65264,6239),(65265,6239),(65266,6239),(65267,6239),(65268,6239),(65269,6240),(65270,6240),(65271,6240),(65272,6240),(65273,6240),(65274,6241),(65275,6241),(65276,6241),(65277,6241),(65278,6241),(65279,6242),(65280,6242),(65281,6242),(65282,6242),(65283,6242),(65284,6243),(65285,6243),(65286,6243),(65287,6243),(65288,6243),(65289,6244),(65290,6244),(65291,6244),(65292,6244),(65293,6244),(65294,6245),(65295,6245),(65296,6245),(65297,6245),(65298,6245),(65299,6246),(65300,6246),(65301,6246),(65302,6246),(65303,6246),(65304,6247),(65305,6247),(65306,6247),(65307,6247),(65308,6247),(65309,6248),(65310,6248),(65311,6248),(65312,6248),(65313,6248),(65314,6249),(65315,6249),(65316,6249),(65317,6249),(65318,6249),(65319,6250),(65320,6250),(65321,6250),(65322,6250),(65323,6250),(65324,6251),(65325,6251),(65326,6251),(65327,6251),(65328,6251),(65329,6252),(65330,6252),(65331,6252),(65332,6252),(65333,6252),(65334,6253),(65335,6253),(65336,6253),(65337,6253),(65338,6253),(65339,6254),(65340,6254),(65341,6254),(65342,6254),(65343,6254),(65344,6255),(65345,6255),(65346,6255),(65347,6255),(65348,6255),(65349,6256),(65350,6256),(65351,6256),(65352,6256),(65353,6256),(65354,6257),(65355,6257),(65356,6257),(65357,6257),(65358,6257),(65359,6258),(65360,6258),(65361,6258),(65362,6258),(65363,6258),(65364,6259),(65365,6259),(65366,6259),(65367,6259),(65368,6259),(65369,6260),(65370,6260),(65371,6260),(65372,6260),(65373,6260),(65374,6261),(65375,6261),(65376,6261),(65377,6261),(65378,6261),(65379,6262),(65380,6262),(65381,6262),(65382,6262),(65383,6262),(65384,6263),(65385,6263),(65386,6263),(65387,6263),(65388,6263),(65389,6264),(65390,6264),(65391,6264),(65392,6264),(65393,6264),(65394,6265),(65395,6265),(65396,6265),(65397,6265),(65398,6265),(65399,6266),(65400,6266),(65401,6266),(65402,6266),(65403,6266),(65404,6267),(65405,6267),(65406,6267),(65407,6267),(65408,6267),(65409,6268),(65410,6268),(65411,6268),(65412,6268),(65413,6268),(65414,6269),(65415,6269),(65416,6269),(65417,6269),(65418,6269),(65419,6270),(65420,6270),(65421,6270),(65422,6270),(65423,6270),(65424,6271),(65425,6271),(65426,6271),(65427,6271),(65428,6271),(65429,6272),(65430,6272),(65431,6272),(65432,6272),(65433,6272),(65434,6273),(65435,6273),(65436,6273),(65437,6273),(65438,6273),(65439,6274),(65440,6274),(65441,6274),(65442,6274),(65443,6274),(65444,6275),(65445,6275),(65446,6275),(65447,6275),(65448,6275),(65449,6276),(65450,6276),(65451,6276),(65452,6276),(65453,6276),(65454,6277),(65455,6277),(65456,6277),(65457,6277),(65458,6277),(65459,6278),(65460,6278),(65461,6278),(65462,6278),(65463,6278),(65464,6279),(65465,6279),(65466,6279),(65467,6279),(65468,6279),(65469,6280),(65470,6280),(65471,6280),(65472,6280),(65473,6280),(65474,6281),(65475,6281),(65476,6281),(65477,6281),(65478,6281),(65479,6282),(65480,6282),(65481,6282),(65482,6282),(65483,6282),(65484,6283),(65485,6283),(65486,6283),(65487,6283),(65488,6283),(65489,6284),(65490,6284),(65491,6284),(65492,6284),(65493,6284),(65494,6285),(65495,6285),(65496,6285),(65497,6285),(65498,6285),(65499,6286),(65500,6286),(65501,6286),(65502,6286),(65503,6286),(65504,6287),(65505,6287),(65506,6287),(65507,6287),(65508,6287),(65509,6288),(65510,6288),(65511,6288),(65512,6288),(65513,6288),(65514,6289),(65515,6289),(65516,6289),(65517,6289),(65518,6289),(65519,6290),(65520,6290),(65521,6290),(65522,6290),(65523,6290),(65524,6291),(65525,6291),(65526,6291),(65527,6291),(65528,6291),(65529,6292),(65530,6292),(65531,6292),(65532,6292),(65533,6292),(65534,6293),(65535,6293),(65536,6293),(65537,6293),(65538,6293),(65539,6294),(65540,6294),(65541,6294),(65542,6294),(65543,6294),(65544,6295),(65545,6295),(65546,6295),(65547,6295),(65548,6295),(65549,6296),(65550,6296),(65551,6296),(65552,6296),(65553,6296),(65554,6297),(65555,6297),(65556,6297),(65557,6297),(65558,6297),(65559,6298),(65560,6298),(65561,6298),(65562,6298),(65563,6298),(65564,6299),(65565,6299),(65566,6299),(65567,6299),(65568,6299),(65569,6300),(65570,6300),(65571,6300),(65572,6300),(65573,6300),(65574,6301),(65575,6301),(65576,6301),(65577,6301),(65578,6301),(65579,6302),(65580,6302),(65581,6302),(65582,6302),(65583,6302),(65584,6303),(65585,6303),(65586,6303),(65587,6303),(65588,6303),(65589,6304),(65590,6304),(65591,6304),(65592,6304),(65593,6304),(65594,6305),(65595,6305),(65596,6305),(65597,6305),(65598,6305),(65599,6306),(65600,6306),(65601,6306),(65602,6306),(65603,6306),(65604,6307),(65605,6307),(65606,6307),(65607,6307),(65608,6307),(65609,6308),(65610,6308),(65611,6308),(65612,6308),(65613,6308),(65614,6309),(65615,6309),(65616,6309),(65617,6309),(65618,6309),(65619,6310),(65620,6310),(65621,6310),(65622,6310),(65623,6310),(65624,6311),(65625,6311),(65626,6311),(65627,6311),(65628,6311),(65629,6312),(65630,6312),(65631,6312),(65632,6312),(65633,6312),(65634,6313),(65635,6313),(65636,6313),(65637,6313),(65638,6313),(65639,6314),(65640,6314),(65641,6314),(65642,6314),(65643,6314),(65644,6315),(65645,6315),(65646,6315),(65647,6315),(65648,6315),(65649,6316),(65650,6316),(65651,6316),(65652,6316),(65653,6316),(65654,6317),(65655,6317),(65656,6317),(65657,6317),(65658,6317),(65659,6318),(65660,6318),(65661,6318),(65662,6318),(65663,6318),(65664,6319),(65665,6319),(65666,6319),(65667,6319),(65668,6319),(65669,6320),(65670,6320),(65671,6320),(65672,6320),(65673,6320),(65674,6321),(65675,6321),(65676,6321),(65677,6321),(65678,6321),(65679,6322),(65680,6322),(65681,6322),(65682,6322),(65683,6322),(65684,6323),(65685,6323),(65686,6323),(65687,6323),(65688,6323),(65689,6324),(65690,6324),(65691,6324),(65692,6324),(65693,6324),(65694,6325),(65695,6325),(65696,6325),(65697,6325),(65698,6325),(65699,6326),(65700,6326),(65701,6326),(65702,6326),(65703,6326),(65704,6327),(65705,6327),(65706,6327),(65707,6327),(65708,6327),(65709,6328),(65710,6328),(65711,6328),(65712,6328),(65713,6328),(65714,6329),(65715,6329),(65716,6329),(65717,6329),(65718,6329),(65719,6330),(65720,6330),(65721,6330),(65722,6330),(65723,6330),(65724,6331),(65725,6331),(65726,6331),(65727,6331),(65728,6331),(65729,6332),(65730,6332),(65731,6332),(65732,6332),(65733,6332),(65734,6333),(65735,6333),(65736,6333),(65737,6333),(65738,6333),(65739,6334),(65740,6334),(65741,6334),(65742,6334),(65743,6334),(65744,6335),(65745,6336),(65746,6337),(65747,6338),(65748,6339),(65749,6340),(65750,6341),(65751,6342),(65752,6343),(65753,6344),(65754,6345),(65755,6335),(65756,6336),(65757,6337),(65758,6338),(65759,6339),(65760,6340),(65761,6341),(65762,6342),(65763,6343),(65764,6344),(65765,6345),(65766,6335),(65767,6335),(65768,6335),(65769,6336),(65770,6336),(65771,6336),(65772,6337),(65773,6337),(65774,6337),(65775,6338),(65776,6338),(65777,6338),(65778,6339),(65779,6339),(65780,6339),(65781,6340),(65782,6340),(65783,6340),(65784,6341),(65785,6341),(65786,6341),(65787,6342),(65788,6342),(65789,6342),(65790,6343),(65791,6343),(65792,6343),(65793,6344),(65794,6344),(65795,6344),(65796,6345),(65797,6345),(65798,6345),(65799,6335),(65800,6335),(65801,6335),(65802,6335),(65803,6335),(65804,6336),(65805,6336),(65806,6336),(65807,6336),(65808,6336),(65809,6337),(65810,6337),(65811,6337),(65812,6337),(65813,6337),(65814,6338),(65815,6338),(65816,6338),(65817,6338),(65818,6338),(65819,6339),(65820,6339),(65821,6339),(65822,6339),(65823,6339),(65824,6340),(65825,6340),(65826,6340),(65827,6340),(65828,6340),(65829,6341),(65830,6341),(65831,6341),(65832,6341),(65833,6341),(65834,6342),(65835,6342),(65836,6342),(65837,6342),(65838,6342),(65839,6343),(65840,6343),(65841,6343),(65842,6343),(65843,6343),(65844,6344),(65845,6344),(65846,6344),(65847,6344),(65848,6344),(65849,6345),(65850,6345),(65851,6345),(65852,6345),(65853,6345),(65854,6035),(65855,6035),(65856,6035),(65857,6035),(65858,6035),(65859,6035),(65860,6035),(65861,6035),(65862,6035),(65863,6035),(65864,6035),(65865,6035),(65866,6035),(65867,6035),(65868,6035),(65869,6035),(65870,6035),(65871,6036),(65872,6036),(65873,6036),(65874,6036),(65875,6036),(65876,6036),(65877,6036),(65878,6036),(65879,6036),(65880,6036),(65881,6036),(65882,6036),(65883,6036),(65884,6036),(65885,6036),(65886,6036),(65887,6036),(65888,5760),(65889,6035),(65890,6036),(65891,6037),(65892,6038),(65893,6039),(65894,6040),(65895,6041),(65896,6042),(65897,6043),(65898,6044),(65899,6045),(65900,6046),(65901,6047),(65902,6048),(65903,6049),(65904,6050),(65905,6051),(65906,6052),(65907,6053),(65908,5760),(65909,6035),(65910,6036),(65911,6037),(65912,6038),(65913,6039),(65914,6040),(65915,6041),(65916,6042),(65917,6043),(65918,6044),(65919,6045),(65920,6046),(65921,6047),(65922,6048),(65923,6049),(65924,6050),(65925,6051),(65926,6052),(65927,6053),(65928,5760),(65929,6035),(65930,6036),(65931,6037),(65932,6038),(65933,6039),(65934,6040),(65935,6041),(65936,6042),(65937,6043),(65938,6044),(65939,6045),(65940,6046),(65941,6047),(65942,6048),(65943,6049),(65944,6050),(65945,6051),(65946,6052),(65947,6053),(65948,5760),(65949,6035),(65950,6036),(65951,6037),(65952,6038),(65953,6039),(65954,6040),(65955,6041),(65956,6042),(65957,6043),(65958,6044),(65959,6045),(65960,6046),(65961,6047),(65962,6048),(65963,6049),(65964,6050),(65965,6051),(65966,6052),(65967,6053),(65968,5760),(65969,6035),(65970,6036),(65971,6037),(65972,6038),(65973,6039),(65974,6040),(65975,6041),(65976,6042),(65977,6043),(65978,6044),(65979,6045),(65980,6046),(65981,6047),(65982,6048),(65983,6049),(65984,6050),(65985,6051),(65986,6052),(65987,6053),(65988,6035),(65989,6035),(65990,6035),(65991,6346),(65992,6347),(65993,6348),(65994,6349),(65995,6350),(65996,6351),(65997,6352),(65998,6353),(65999,6354),(66000,6355),(66001,6356),(66002,6346),(66003,6347),(66004,6348),(66005,6349),(66006,6350),(66007,6351),(66008,6352),(66009,6353),(66010,6354),(66011,6355),(66012,6356),(66013,6346),(66014,6346),(66015,6346),(66016,6347),(66017,6347),(66018,6347),(66019,6348),(66020,6348),(66021,6348),(66022,6349),(66023,6349),(66024,6349),(66025,6350),(66026,6350),(66027,6350),(66028,6351),(66029,6351),(66030,6351),(66031,6352),(66032,6352),(66033,6352),(66034,6353),(66035,6353),(66036,6353),(66037,6354),(66038,6354),(66039,6354),(66040,6355),(66041,6355),(66042,6355),(66043,6356),(66044,6356),(66045,6356),(66046,6346),(66047,6346),(66048,6346),(66049,6346),(66050,6346),(66051,6347),(66052,6347),(66053,6347),(66054,6347),(66055,6347),(66056,6348),(66057,6348),(66058,6348),(66059,6348),(66060,6348),(66061,6349),(66062,6349),(66063,6349),(66064,6349),(66065,6349),(66066,6350),(66067,6350),(66068,6350),(66069,6350),(66070,6350),(66071,6351),(66072,6351),(66073,6351),(66074,6351),(66075,6351),(66076,6352),(66077,6352),(66078,6352),(66079,6352),(66080,6352),(66081,6353),(66082,6353),(66083,6353),(66084,6353),(66085,6353),(66086,6354),(66087,6354),(66088,6354),(66089,6354),(66090,6354),(66091,6355),(66092,6355),(66093,6355),(66094,6355),(66095,6355),(66096,6356),(66097,6356),(66098,6356),(66099,6356),(66100,6356),(66101,6357),(66102,6358),(66103,6359),(66104,6360),(66105,6361),(66106,6362),(66107,6363),(66108,6364),(66109,6365),(66110,6366),(66111,6367),(66112,6368),(66113,6369),(66114,6370),(66115,6371),(66116,6372),(66117,6373),(66118,6374),(66119,6375),(66120,6376),(66121,6377),(66122,6378),(66123,6379),(66124,6380),(66125,6381),(66126,6382),(66127,6383),(66128,6384),(66129,6385),(66130,6386),(66131,6387),(66132,6388),(66133,6389),(66134,6390),(66135,6391),(66136,6392),(66137,6393),(66138,6394),(66139,6395),(66140,6396),(66141,6397),(66142,6398),(66143,6399),(66144,6400),(66145,6401),(66146,6402),(66147,6403),(66148,6404),(66149,6405),(66150,6406),(66151,6407),(66152,6408),(66153,6409),(66154,6410),(66155,6411),(66156,6412),(66157,6413),(66158,6414),(66159,6415),(66160,6416),(66161,6417),(66162,6418),(66163,6419),(66164,6420),(66165,6421),(66166,6422),(66167,6423),(66168,6424),(66169,6425),(66170,6426),(66171,6427),(66172,6428),(66173,6429),(66174,6430),(66175,6431),(66176,6432),(66177,6433),(66178,6434),(66179,6435),(66180,6436),(66181,6437),(66182,6438),(66183,6439),(66184,6440),(66185,6441),(66186,6442),(66187,6443),(66188,6444),(66189,6445),(66190,6357),(66191,6358),(66192,6359),(66193,6360),(66194,6361),(66195,6362),(66196,6363),(66197,6364),(66198,6365),(66199,6366),(66200,6367),(66201,6368),(66202,6369),(66203,6370),(66204,6371),(66205,6372),(66206,6373),(66207,6374),(66208,6375),(66209,6376),(66210,6377),(66211,6378),(66212,6379),(66213,6380),(66214,6381),(66215,6382),(66216,6383),(66217,6384),(66218,6385),(66219,6386),(66220,6387),(66221,6388),(66222,6389),(66223,6390),(66224,6391),(66225,6392),(66226,6393),(66227,6394),(66228,6395),(66229,6396),(66230,6397),(66231,6398),(66232,6399),(66233,6400),(66234,6401),(66235,6402),(66236,6403),(66237,6404),(66238,6405),(66239,6406),(66240,6407),(66241,6408),(66242,6409),(66243,6410),(66244,6411),(66245,6412),(66246,6413),(66247,6414),(66248,6415),(66249,6416),(66250,6417),(66251,6418),(66252,6419),(66253,6420),(66254,6421),(66255,6422),(66256,6423),(66257,6424),(66258,6425),(66259,6426),(66260,6427),(66261,6428),(66262,6429),(66263,6430),(66264,6431),(66265,6432),(66266,6433),(66267,6434),(66268,6435),(66269,6436),(66270,6437),(66271,6438),(66272,6439),(66273,6440),(66274,6441),(66275,6442),(66276,6443),(66277,6444),(66278,6445),(66279,6357),(66280,6357),(66281,6357),(66282,6358),(66283,6358),(66284,6358),(66285,6359),(66286,6359),(66287,6359),(66288,6360),(66289,6360),(66290,6360),(66291,6361),(66292,6361),(66293,6361),(66294,6362),(66295,6362),(66296,6362),(66297,6363),(66298,6363),(66299,6363),(66300,6364),(66301,6364),(66302,6364),(66303,6365),(66304,6365),(66305,6365),(66306,6366),(66307,6366),(66308,6366),(66309,6367),(66310,6367),(66311,6367),(66312,6368),(66313,6368),(66314,6368),(66315,6369),(66316,6369),(66317,6369),(66318,6370),(66319,6370),(66320,6370),(66321,6371),(66322,6371),(66323,6371),(66324,6372),(66325,6372),(66326,6372),(66327,6373),(66328,6373),(66329,6373),(66330,6374),(66331,6374),(66332,6374),(66333,6375),(66334,6375),(66335,6375),(66336,6376),(66337,6376),(66338,6376),(66339,6377),(66340,6377),(66341,6377),(66342,6378),(66343,6378),(66344,6378),(66345,6379),(66346,6379),(66347,6379),(66348,6380),(66349,6380),(66350,6380),(66351,6381),(66352,6381),(66353,6381),(66354,6382),(66355,6382),(66356,6382),(66357,6383),(66358,6383),(66359,6383),(66360,6384),(66361,6384),(66362,6384),(66363,6385),(66364,6385),(66365,6385),(66366,6386),(66367,6386),(66368,6386),(66369,6387),(66370,6387),(66371,6387),(66372,6388),(66373,6388),(66374,6388),(66375,6389),(66376,6389),(66377,6389),(66378,6390),(66379,6390),(66380,6390),(66381,6391),(66382,6391),(66383,6391),(66384,6392),(66385,6392),(66386,6392),(66387,6393),(66388,6393),(66389,6393),(66390,6394),(66391,6394),(66392,6394),(66393,6395),(66394,6395),(66395,6395),(66396,6396),(66397,6396),(66398,6396),(66399,6397),(66400,6397),(66401,6397),(66402,6398),(66403,6398),(66404,6398),(66405,6399),(66406,6399),(66407,6399),(66408,6400),(66409,6400),(66410,6400),(66411,6401),(66412,6401),(66413,6401),(66414,6402),(66415,6402),(66416,6402),(66417,6403),(66418,6404),(66419,6404),(66420,6404),(66421,6405),(66422,6405),(66423,6405),(66424,6406),(66425,6406),(66426,6406),(66427,6407),(66428,6407),(66429,6407),(66430,6408),(66431,6408),(66432,6408),(66433,6409),(66434,6409),(66435,6409),(66436,6410),(66437,6410),(66438,6410),(66439,6411),(66440,6411),(66441,6411),(66442,6412),(66443,6412),(66444,6412),(66445,6413),(66446,6413),(66447,6413),(66448,6414),(66449,6414),(66450,6414),(66451,6415),(66452,6415),(66453,6415),(66454,6416),(66455,6416),(66456,6416),(66457,6417),(66458,6417),(66459,6417),(66460,6418),(66461,6418),(66462,6418),(66463,6419),(66464,6419),(66465,6419),(66466,6420),(66467,6420),(66468,6420),(66469,6421),(66470,6421),(66471,6421),(66472,6422),(66473,6422),(66474,6422),(66475,6423),(66476,6423),(66477,6423),(66478,6424),(66479,6424),(66480,6424),(66481,6425),(66482,6425),(66483,6425),(66484,6426),(66485,6426),(66486,6426),(66487,6427),(66488,6427),(66489,6427),(66490,6428),(66491,6428),(66492,6428),(66493,6429),(66494,6429),(66495,6429),(66496,6430),(66497,6430),(66498,6430),(66499,6431),(66500,6431),(66501,6431),(66502,6432),(66503,6432),(66504,6432),(66505,6433),(66506,6433),(66507,6433),(66508,6434),(66509,6434),(66510,6434),(66511,6435),(66512,6435),(66513,6435),(66514,6436),(66515,6436),(66516,6436),(66517,6437),(66518,6437),(66519,6437),(66520,6438),(66521,6438),(66522,6438),(66523,6439),(66524,6439),(66525,6439),(66526,6440),(66527,6440),(66528,6440),(66529,6441),(66530,6441),(66531,6441),(66532,6442),(66533,6442),(66534,6442),(66535,6443),(66536,6443),(66537,6443),(66538,6444),(66539,6444),(66540,6444),(66541,6445),(66542,6445),(66543,6445),(66544,6357),(66545,6357),(66546,6357),(66547,6357),(66548,6357),(66549,6358),(66550,6358),(66551,6358),(66552,6358),(66553,6358),(66554,6359),(66555,6359),(66556,6359),(66557,6359),(66558,6359),(66559,6360),(66560,6360),(66561,6360),(66562,6360),(66563,6360),(66564,6361),(66565,6361),(66566,6361),(66567,6361),(66568,6361),(66569,6362),(66570,6362),(66571,6362),(66572,6362),(66573,6362),(66574,6363),(66575,6363),(66576,6363),(66577,6363),(66578,6363),(66579,6364),(66580,6364),(66581,6364),(66582,6364),(66583,6364),(66584,6365),(66585,6365),(66586,6365),(66587,6365),(66588,6365),(66589,6366),(66590,6366),(66591,6366),(66592,6366),(66593,6366),(66594,6367),(66595,6367),(66596,6367),(66597,6367),(66598,6367),(66599,6368),(66600,6368),(66601,6368),(66602,6368),(66603,6368),(66604,6369),(66605,6369),(66606,6369),(66607,6369),(66608,6369),(66609,6370),(66610,6370),(66611,6370),(66612,6370),(66613,6370),(66614,6371),(66615,6371),(66616,6371),(66617,6371),(66618,6371),(66619,6372),(66620,6372),(66621,6372),(66622,6372),(66623,6372),(66624,6373),(66625,6373),(66626,6373),(66627,6373),(66628,6373),(66629,6374),(66630,6374),(66631,6374),(66632,6374),(66633,6374),(66634,6375),(66635,6375),(66636,6375),(66637,6375),(66638,6375),(66639,6376),(66640,6376),(66641,6376),(66642,6376),(66643,6376),(66644,6377),(66645,6377),(66646,6377),(66647,6377),(66648,6377),(66649,6378),(66650,6378),(66651,6378),(66652,6378),(66653,6378),(66654,6379),(66655,6379),(66656,6379),(66657,6379),(66658,6379),(66659,6380),(66660,6380),(66661,6380),(66662,6380),(66663,6380),(66664,6381),(66665,6381),(66666,6381),(66667,6381),(66668,6381),(66669,6382),(66670,6382),(66671,6382),(66672,6382),(66673,6382),(66674,6383),(66675,6383),(66676,6383),(66677,6383),(66678,6383),(66679,6384),(66680,6384),(66681,6384),(66682,6384),(66683,6384),(66684,6385),(66685,6385),(66686,6385),(66687,6385),(66688,6385),(66689,6386),(66690,6386),(66691,6386),(66692,6386),(66693,6386),(66694,6387),(66695,6387),(66696,6387),(66697,6387),(66698,6387),(66699,6388),(66700,6388),(66701,6388),(66702,6388),(66703,6388),(66704,6389),(66705,6389),(66706,6389),(66707,6389),(66708,6389),(66709,6390),(66710,6390),(66711,6390),(66712,6390),(66713,6390),(66714,6391),(66715,6391),(66716,6391),(66717,6391),(66718,6391),(66719,6392),(66720,6392),(66721,6392),(66722,6392),(66723,6392),(66724,6393),(66725,6393),(66726,6393),(66727,6393),(66728,6393),(66729,6394),(66730,6394),(66731,6394),(66732,6394),(66733,6394),(66734,6395),(66735,6395),(66736,6395),(66737,6395),(66738,6395),(66739,6396),(66740,6396),(66741,6396),(66742,6396),(66743,6396),(66744,6397),(66745,6397),(66746,6397),(66747,6397),(66748,6397),(66749,6398),(66750,6398),(66751,6398),(66752,6398),(66753,6398),(66754,6399),(66755,6399),(66756,6399),(66757,6399),(66758,6399),(66759,6400),(66760,6400),(66761,6400),(66762,6400),(66763,6400),(66764,6401),(66765,6401),(66766,6401),(66767,6401),(66768,6401),(66769,6402),(66770,6402),(66771,6402),(66772,6402),(66773,6402),(66774,6403),(66775,6403),(66776,6403),(66777,6403),(66778,6403),(66779,6404),(66780,6404),(66781,6404),(66782,6404),(66783,6404),(66784,6405),(66785,6405),(66786,6405),(66787,6405),(66788,6405),(66789,6406),(66790,6406),(66791,6406),(66792,6406),(66793,6406),(66794,6407),(66795,6407),(66796,6407),(66797,6407),(66798,6407),(66799,6408),(66800,6408),(66801,6408),(66802,6408),(66803,6408),(66804,6409),(66805,6409),(66806,6409),(66807,6409),(66808,6409),(66809,6410),(66810,6410),(66811,6410),(66812,6410),(66813,6410),(66814,6411),(66815,6411),(66816,6411),(66817,6411),(66818,6411),(66819,6412),(66820,6412),(66821,6412),(66822,6412),(66823,6412),(66824,6413),(66825,6413),(66826,6413),(66827,6413),(66828,6413),(66829,6414),(66830,6414),(66831,6414),(66832,6414),(66833,6414),(66834,6415),(66835,6415),(66836,6415),(66837,6415),(66838,6415),(66839,6416),(66840,6416),(66841,6416),(66842,6416),(66843,6416),(66844,6417),(66845,6417),(66846,6417),(66847,6417),(66848,6417),(66849,6418),(66850,6418),(66851,6418),(66852,6418),(66853,6418),(66854,6419),(66855,6419),(66856,6419),(66857,6419),(66858,6419),(66859,6420),(66860,6420),(66861,6420),(66862,6420),(66863,6420),(66864,6421),(66865,6421),(66866,6421),(66867,6421),(66868,6421),(66869,6422),(66870,6422),(66871,6422),(66872,6422),(66873,6422),(66874,6423),(66875,6423),(66876,6423),(66877,6423),(66878,6423),(66879,6424),(66880,6424),(66881,6424),(66882,6424),(66883,6424),(66884,6425),(66885,6425),(66886,6425),(66887,6425),(66888,6425),(66889,6426),(66890,6426),(66891,6426),(66892,6426),(66893,6426),(66894,6427),(66895,6427),(66896,6427),(66897,6427),(66898,6427),(66899,6428),(66900,6428),(66901,6428),(66902,6428),(66903,6428),(66904,6429),(66905,6429),(66906,6429),(66907,6429),(66908,6429),(66909,6430),(66910,6430),(66911,6430),(66912,6430),(66913,6430),(66914,6431),(66915,6431),(66916,6431),(66917,6431),(66918,6431),(66919,6432),(66920,6432),(66921,6432),(66922,6432),(66923,6432),(66924,6433),(66925,6433),(66926,6433),(66927,6433),(66928,6433),(66929,6434),(66930,6434),(66931,6434),(66932,6434),(66933,6434),(66934,6435),(66935,6435),(66936,6435),(66937,6435),(66938,6435),(66939,6436),(66940,6436),(66941,6436),(66942,6436),(66943,6436),(66944,6437),(66945,6437),(66946,6437),(66947,6437),(66948,6437),(66949,6438),(66950,6438),(66951,6438),(66952,6438),(66953,6438),(66954,6439),(66955,6439),(66956,6439),(66957,6439),(66958,6439),(66959,6440),(66960,6440),(66961,6440),(66962,6440),(66963,6440),(66964,6441),(66965,6441),(66966,6441),(66967,6441),(66968,6441),(66969,6442),(66970,6442),(66971,6442),(66972,6442),(66973,6442),(66974,6443),(66975,6443),(66976,6443),(66977,6443),(66978,6443),(66979,6444),(66980,6444),(66981,6444),(66982,6444),(66983,6444),(66984,6445),(66985,6445),(66986,6445),(66987,6445),(66988,6445),(66989,6446),(66990,6447),(66991,6448),(66992,6449),(66993,6450),(66994,6451),(66995,6452),(66996,6453),(66997,6454),(66998,6455),(66999,6456),(67000,6457),(67001,6458),(67002,6459),(67003,6460),(67004,6461),(67005,6462),(67006,6463),(67007,6464),(67008,6465),(67009,6466),(67010,6467),(67011,6468),(67012,6469),(67013,6470),(67014,6471),(67015,6472),(67016,6473),(67017,6474),(67018,6475),(67019,6476),(67020,6477),(67021,6478),(67022,6479),(67023,6480),(67024,6481),(67025,6482),(67026,6483),(67027,6484),(67028,6485),(67029,6486),(67030,6487),(67031,6488),(67032,6489),(67033,6490),(67034,6491),(67035,6492),(67036,6493),(67037,6494),(67038,6495),(67039,6496),(67040,6497),(67041,6498),(67042,6499),(67043,6500),(67044,6501),(67045,6502),(67046,6503),(67047,6504),(67048,6505),(67049,6506),(67050,6507),(67051,6508),(67052,6509),(67053,6510),(67054,6511),(67055,6512),(67056,6513),(67057,6514),(67058,6515),(67059,6516),(67060,6517),(67061,6518),(67062,6519),(67063,6520),(67064,6521),(67065,6522),(67066,6523),(67067,6524),(67068,6525),(67069,6526),(67070,6527),(67071,6528),(67072,6529),(67073,6530),(67074,6531),(67075,6532),(67076,6533),(67077,6534),(67078,6535),(67079,6536),(67080,6537),(67081,6538),(67082,6539),(67083,6540),(67084,6541),(67085,6542),(67086,6543),(67087,6544),(67088,6545),(67089,6446),(67090,6447),(67091,6448),(67092,6449),(67093,6450),(67094,6451),(67095,6452),(67096,6453),(67097,6454),(67098,6455),(67099,6456),(67100,6457),(67101,6458),(67102,6459),(67103,6460),(67104,6461),(67105,6462),(67106,6463),(67107,6464),(67108,6465),(67109,6466),(67110,6467),(67111,6468),(67112,6469),(67113,6470),(67114,6471),(67115,6472),(67116,6473),(67117,6474),(67118,6475),(67119,6476),(67120,6477),(67121,6478),(67122,6479),(67123,6480),(67124,6481),(67125,6482),(67126,6483),(67127,6484),(67128,6485),(67129,6486),(67130,6487),(67131,6488),(67132,6489),(67133,6490),(67134,6491),(67135,6492),(67136,6493),(67137,6494),(67138,6495),(67139,6496),(67140,6497),(67141,6498),(67142,6499),(67143,6500),(67144,6501),(67145,6502),(67146,6503),(67147,6504),(67148,6505),(67149,6506),(67150,6507),(67151,6508),(67152,6509),(67153,6510),(67154,6511),(67155,6512),(67156,6513),(67157,6514),(67158,6515),(67159,6516),(67160,6517),(67161,6518),(67162,6519),(67163,6520),(67164,6521),(67165,6522),(67166,6523),(67167,6524),(67168,6525),(67169,6526),(67170,6527),(67171,6528),(67172,6529),(67173,6530),(67174,6531),(67175,6532),(67176,6533),(67177,6534),(67178,6535),(67179,6536),(67180,6537),(67181,6538),(67182,6539),(67183,6540),(67184,6541),(67185,6542),(67186,6543),(67187,6544),(67188,6545),(67189,6446),(67190,6446),(67191,6446),(67192,6447),(67193,6447),(67194,6447),(67195,6448),(67196,6448),(67197,6448),(67198,6449),(67199,6449),(67200,6449),(67201,6450),(67202,6450),(67203,6450),(67204,6451),(67205,6451),(67206,6451),(67207,6452),(67208,6452),(67209,6452),(67210,6453),(67211,6453),(67212,6453),(67213,6454),(67214,6454),(67215,6454),(67216,6455),(67217,6455),(67218,6455),(67219,6456),(67220,6456),(67221,6456),(67222,6457),(67223,6457),(67224,6457),(67225,6458),(67226,6458),(67227,6458),(67228,6459),(67229,6459),(67230,6459),(67231,6460),(67232,6460),(67233,6460),(67234,6461),(67235,6461),(67236,6461),(67237,6462),(67238,6462),(67239,6462),(67240,6463),(67241,6463),(67242,6463),(67243,6464),(67244,6464),(67245,6464),(67246,6465),(67247,6465),(67248,6465),(67249,6466),(67250,6466),(67251,6466),(67252,6467),(67253,6467),(67254,6467),(67255,6468),(67256,6468),(67257,6468),(67258,6469),(67259,6469),(67260,6469),(67261,6470),(67262,6470),(67263,6470),(67264,6471),(67265,6471),(67266,6471),(67267,6472),(67268,6472),(67269,6472),(67270,6473),(67271,6473),(67272,6473),(67273,6474),(67274,6474),(67275,6474),(67276,6475),(67277,6475),(67278,6475),(67279,6476),(67280,6476),(67281,6476),(67282,6477),(67283,6477),(67284,6477),(67285,6478),(67286,6478),(67287,6478),(67288,6479),(67289,6479),(67290,6479),(67291,6480),(67292,6480),(67293,6480),(67294,6481),(67295,6481),(67296,6481),(67297,6482),(67298,6482),(67299,6482),(67300,6483),(67301,6483),(67302,6483),(67303,6484),(67304,6484),(67305,6484),(67306,6485),(67307,6485),(67308,6485),(67309,6486),(67310,6486),(67311,6486),(67312,6487),(67313,6487),(67314,6487),(67315,6488),(67316,6488),(67317,6488),(67318,6489),(67319,6489),(67320,6489),(67321,6490),(67322,6490),(67323,6490),(67324,6491),(67325,6491),(67326,6491),(67327,6492),(67328,6492),(67329,6492),(67330,6493),(67331,6493),(67332,6493),(67333,6494),(67334,6494),(67335,6494),(67336,6495),(67337,6495),(67338,6495),(67339,6496),(67340,6496),(67341,6496),(67342,6497),(67343,6497),(67344,6497),(67345,6498),(67346,6498),(67347,6498),(67348,6499),(67349,6499),(67350,6499),(67351,6500),(67352,6500),(67353,6500),(67354,6501),(67355,6501),(67356,6501),(67357,6502),(67358,6502),(67359,6502),(67360,6503),(67361,6503),(67362,6503),(67363,6504),(67364,6504),(67365,6504),(67366,6505),(67367,6505),(67368,6505),(67369,6506),(67370,6506),(67371,6506),(67372,6507),(67373,6507),(67374,6507),(67375,6508),(67376,6508),(67377,6508),(67378,6509),(67379,6509),(67380,6509),(67381,6510),(67382,6510),(67383,6510),(67384,6511),(67385,6511),(67386,6511),(67387,6512),(67388,6512),(67389,6512),(67390,6513),(67391,6513),(67392,6513),(67393,6514),(67394,6514),(67395,6514),(67396,6515),(67397,6515),(67398,6515),(67399,6516),(67400,6516),(67401,6516),(67402,6517),(67403,6517),(67404,6517),(67405,6518),(67406,6518),(67407,6518),(67408,6519),(67409,6519),(67410,6519),(67411,6520),(67412,6520),(67413,6520),(67414,6521),(67415,6521),(67416,6521),(67417,6522),(67418,6522),(67419,6522),(67420,6523),(67421,6523),(67422,6523),(67423,6524),(67424,6524),(67425,6524),(67426,6525),(67427,6525),(67428,6525),(67429,6526),(67430,6526),(67431,6526),(67432,6527),(67433,6527),(67434,6527),(67435,6528),(67436,6528),(67437,6528),(67438,6529),(67439,6529),(67440,6529),(67441,6530),(67442,6530),(67443,6530),(67444,6531),(67445,6531),(67446,6531),(67447,6532),(67448,6532),(67449,6532),(67450,6533),(67451,6533),(67452,6533),(67453,6534),(67454,6534),(67455,6534),(67456,6535),(67457,6535),(67458,6535),(67459,6536),(67460,6536),(67461,6536),(67462,6537),(67463,6537),(67464,6537),(67465,6538),(67466,6538),(67467,6538),(67468,6539),(67469,6539),(67470,6539),(67471,6540),(67472,6540),(67473,6540),(67474,6541),(67475,6541),(67476,6541),(67477,6542),(67478,6542),(67479,6542),(67480,6543),(67481,6543),(67482,6543),(67483,6544),(67484,6544),(67485,6544),(67486,6545),(67487,6545),(67488,6545),(67489,6446),(67490,6446),(67491,6446),(67492,6446),(67493,6446),(67494,6447),(67495,6447),(67496,6447),(67497,6447),(67498,6447),(67499,6448),(67500,6448),(67501,6448),(67502,6448),(67503,6448),(67504,6449),(67505,6449),(67506,6449),(67507,6449),(67508,6449),(67509,6450),(67510,6450),(67511,6450),(67512,6450),(67513,6450),(67514,6451),(67515,6451),(67516,6451),(67517,6451),(67518,6451),(67519,6452),(67520,6452),(67521,6452),(67522,6452),(67523,6452),(67524,6453),(67525,6453),(67526,6453),(67527,6453),(67528,6453),(67529,6454),(67530,6454),(67531,6454),(67532,6454),(67533,6454),(67534,6455),(67535,6455),(67536,6455),(67537,6455),(67538,6455),(67539,6456),(67540,6456),(67541,6456),(67542,6456),(67543,6456),(67544,6457),(67545,6457),(67546,6457),(67547,6457),(67548,6457),(67549,6458),(67550,6458),(67551,6458),(67552,6458),(67553,6458),(67554,6459),(67555,6459),(67556,6459),(67557,6459),(67558,6459),(67559,6460),(67560,6460),(67561,6460),(67562,6460),(67563,6460),(67564,6461),(67565,6461),(67566,6461),(67567,6461),(67568,6461),(67569,6462),(67570,6462),(67571,6462),(67572,6462),(67573,6462),(67574,6463),(67575,6463),(67576,6463),(67577,6463),(67578,6463),(67579,6464),(67580,6464),(67581,6464),(67582,6464),(67583,6464),(67584,6465),(67585,6465),(67586,6465),(67587,6465),(67588,6465),(67589,6466),(67590,6466),(67591,6466),(67592,6466),(67593,6466),(67594,6467),(67595,6467),(67596,6467),(67597,6467),(67598,6467),(67599,6468),(67600,6468),(67601,6468),(67602,6468),(67603,6468),(67604,6469),(67605,6469),(67606,6469),(67607,6469),(67608,6469),(67609,6470),(67610,6470),(67611,6470),(67612,6470),(67613,6470),(67614,6471),(67615,6471),(67616,6471),(67617,6471),(67618,6471),(67619,6472),(67620,6472),(67621,6472),(67622,6472),(67623,6472),(67624,6473),(67625,6473),(67626,6473),(67627,6473),(67628,6473),(67629,6474),(67630,6474),(67631,6474),(67632,6474),(67633,6474),(67634,6475),(67635,6475),(67636,6475),(67637,6475),(67638,6475),(67639,6476),(67640,6476),(67641,6476),(67642,6476),(67643,6476),(67644,6477),(67645,6477),(67646,6477),(67647,6477),(67648,6477),(67649,6478),(67650,6478),(67651,6478),(67652,6478),(67653,6478),(67654,6479),(67655,6479),(67656,6479),(67657,6479),(67658,6479),(67659,6480),(67660,6480),(67661,6480),(67662,6480),(67663,6480),(67664,6481),(67665,6481),(67666,6481),(67667,6481),(67668,6481),(67669,6482),(67670,6482),(67671,6482),(67672,6482),(67673,6482),(67674,6483),(67675,6483),(67676,6483),(67677,6483),(67678,6483),(67679,6484),(67680,6484),(67681,6484),(67682,6484),(67683,6484),(67684,6485),(67685,6485),(67686,6485),(67687,6485),(67688,6485),(67689,6486),(67690,6486),(67691,6486),(67692,6486),(67693,6486),(67694,6487),(67695,6487),(67696,6487),(67697,6487),(67698,6487),(67699,6488),(67700,6488),(67701,6488),(67702,6488),(67703,6488),(67704,6489),(67705,6489),(67706,6489),(67707,6489),(67708,6489),(67709,6490),(67710,6490),(67711,6490),(67712,6490),(67713,6490),(67714,6491),(67715,6491),(67716,6491),(67717,6491),(67718,6491),(67719,6492),(67720,6492),(67721,6492),(67722,6492),(67723,6492),(67724,6493),(67725,6493),(67726,6493),(67727,6493),(67728,6493),(67729,6494),(67730,6494),(67731,6494),(67732,6494),(67733,6494),(67734,6495),(67735,6495),(67736,6495),(67737,6495),(67738,6495),(67739,6496),(67740,6496),(67741,6496),(67742,6496),(67743,6496),(67744,6497),(67745,6497),(67746,6497),(67747,6497),(67748,6497),(67749,6498),(67750,6498),(67751,6498),(67752,6498),(67753,6498),(67754,6499),(67755,6499),(67756,6499),(67757,6499),(67758,6499),(67759,6500),(67760,6500),(67761,6500),(67762,6500),(67763,6500),(67764,6501),(67765,6501),(67766,6501),(67767,6501),(67768,6501),(67769,6502),(67770,6502),(67771,6502),(67772,6502),(67773,6502),(67774,6503),(67775,6503),(67776,6503),(67777,6503),(67778,6503),(67779,6504),(67780,6504),(67781,6504),(67782,6504),(67783,6504),(67784,6505),(67785,6505),(67786,6505),(67787,6505),(67788,6505),(67789,6506),(67790,6506),(67791,6506),(67792,6506),(67793,6506),(67794,6507),(67795,6507),(67796,6507),(67797,6507),(67798,6507),(67799,6508),(67800,6508),(67801,6508),(67802,6508),(67803,6508),(67804,6509),(67805,6509),(67806,6509),(67807,6509),(67808,6509),(67809,6510),(67810,6510),(67811,6510),(67812,6510),(67813,6510),(67814,6511),(67815,6511),(67816,6511),(67817,6511),(67818,6511),(67819,6512),(67820,6512),(67821,6512),(67822,6512),(67823,6512),(67824,6513),(67825,6513),(67826,6513),(67827,6513),(67828,6513),(67829,6514),(67830,6514),(67831,6514),(67832,6514),(67833,6514),(67834,6515),(67835,6515),(67836,6515),(67837,6515),(67838,6515),(67839,6516),(67840,6516),(67841,6516),(67842,6516),(67843,6516),(67844,6517),(67845,6517),(67846,6517),(67847,6517),(67848,6517),(67849,6518),(67850,6518),(67851,6518),(67852,6518),(67853,6518),(67854,6519),(67855,6519),(67856,6519),(67857,6519),(67858,6519),(67859,6520),(67860,6520),(67861,6520),(67862,6520),(67863,6520),(67864,6521),(67865,6521),(67866,6521),(67867,6521),(67868,6521),(67869,6522),(67870,6522),(67871,6522),(67872,6522),(67873,6522),(67874,6523),(67875,6523),(67876,6523),(67877,6523),(67878,6523),(67879,6524),(67880,6524),(67881,6524),(67882,6524),(67883,6524),(67884,6525),(67885,6525),(67886,6525),(67887,6525),(67888,6525),(67889,6526),(67890,6526),(67891,6526),(67892,6526),(67893,6526),(67894,6527),(67895,6527),(67896,6527),(67897,6527),(67898,6527),(67899,6528),(67900,6528),(67901,6528),(67902,6528),(67903,6528),(67904,6529),(67905,6529),(67906,6529),(67907,6529),(67908,6529),(67909,6530),(67910,6530),(67911,6530),(67912,6530),(67913,6530),(67914,6531),(67915,6531),(67916,6531),(67917,6531),(67918,6531),(67919,6532),(67920,6532),(67921,6532),(67922,6532),(67923,6532),(67924,6533),(67925,6533),(67926,6533),(67927,6533),(67928,6533),(67929,6534),(67930,6534),(67931,6534),(67932,6534),(67933,6534),(67934,6535),(67935,6535),(67936,6535),(67937,6535),(67938,6535),(67939,6536),(67940,6536),(67941,6536),(67942,6536),(67943,6536),(67944,6537),(67945,6537),(67946,6537),(67947,6537),(67948,6537),(67949,6538),(67950,6538),(67951,6538),(67952,6538),(67953,6538),(67954,6539),(67955,6539),(67956,6539),(67957,6539),(67958,6539),(67959,6540),(67960,6540),(67961,6540),(67962,6540),(67963,6540),(67964,6541),(67965,6541),(67966,6541),(67967,6541),(67968,6541),(67969,6542),(67970,6542),(67971,6542),(67972,6542),(67973,6542),(67974,6543),(67975,6543),(67976,6543),(67977,6543),(67978,6543),(67979,6544),(67980,6544),(67981,6544),(67982,6544),(67983,6544),(67984,6545),(67985,6545),(67986,6545),(67987,6545),(67988,6545),(67989,6546),(67990,6547),(67991,6548),(67992,6549),(67993,6550),(67994,6551),(67995,6552),(67996,6553),(67997,6554),(67998,6555),(67999,6556),(68000,6557),(68001,6558),(68002,6559),(68003,6560),(68004,6561),(68005,6562),(68006,6563),(68007,6564),(68008,6565),(68009,6566),(68010,6567),(68011,6568),(68012,6569),(68013,6570),(68014,6571),(68015,6572),(68016,6546),(68017,6547),(68018,6548),(68019,6549),(68020,6550),(68021,6551),(68022,6552),(68023,6553),(68024,6554),(68025,6555),(68026,6556),(68027,6557),(68028,6558),(68029,6559),(68030,6560),(68031,6561),(68032,6562),(68033,6563),(68034,6564),(68035,6565),(68036,6566),(68037,6567),(68038,6568),(68039,6569),(68040,6570),(68041,6571),(68042,6572),(68043,6546),(68044,6546),(68045,6547),(68046,6547),(68047,6548),(68048,6548),(68049,6549),(68050,6549),(68051,6550),(68052,6550),(68053,6551),(68054,6551),(68055,6552),(68056,6552),(68057,6553),(68058,6553),(68059,6554),(68060,6554),(68061,6555),(68062,6555),(68063,6556),(68064,6556),(68065,6557),(68066,6557),(68067,6558),(68068,6558),(68069,6559),(68070,6559),(68071,6560),(68072,6560),(68073,6561),(68074,6561),(68075,6562),(68076,6562),(68077,6563),(68078,6563),(68079,6564),(68080,6564),(68081,6564),(68082,6565),(68083,6565),(68084,6565),(68085,6566),(68086,6566),(68087,6566),(68088,6567),(68089,6567),(68090,6567),(68091,6568),(68092,6568),(68093,6568),(68094,6569),(68095,6569),(68096,6569),(68097,6570),(68098,6570),(68099,6570),(68100,6571),(68101,6571),(68102,6571),(68103,6572),(68104,6572),(68105,6572),(68106,6546),(68107,6546),(68108,6546),(68109,6546),(68110,6546),(68111,6547),(68112,6547),(68113,6547),(68114,6547),(68115,6547),(68116,6548),(68117,6548),(68118,6548),(68119,6548),(68120,6548),(68121,6549),(68122,6549),(68123,6549),(68124,6549),(68125,6549),(68126,6550),(68127,6550),(68128,6550),(68129,6550),(68130,6550),(68131,6551),(68132,6551),(68133,6551),(68134,6551),(68135,6551),(68136,6552),(68137,6552),(68138,6552),(68139,6552),(68140,6552),(68141,6553),(68142,6553),(68143,6553),(68144,6553),(68145,6553),(68146,6554),(68147,6554),(68148,6554),(68149,6554),(68150,6554),(68151,6555),(68152,6555),(68153,6555),(68154,6555),(68155,6555),(68156,6556),(68157,6556),(68158,6556),(68159,6556),(68160,6556),(68161,6557),(68162,6557),(68163,6557),(68164,6557),(68165,6557),(68166,6558),(68167,6558),(68168,6558),(68169,6558),(68170,6558),(68171,6559),(68172,6559),(68173,6559),(68174,6559),(68175,6559),(68176,6560),(68177,6560),(68178,6560),(68179,6560),(68180,6560),(68181,6561),(68182,6561),(68183,6561),(68184,6561),(68185,6561),(68186,6562),(68187,6562),(68188,6562),(68189,6562),(68190,6562),(68191,6563),(68192,6563),(68193,6563),(68194,6563),(68195,6563),(68196,6564),(68197,6564),(68198,6564),(68199,6564),(68200,6564),(68201,6565),(68202,6565),(68203,6565),(68204,6565),(68205,6565),(68206,6566),(68207,6566),(68208,6566),(68209,6566),(68210,6566),(68211,6567),(68212,6567),(68213,6567),(68214,6567),(68215,6567),(68216,6568),(68217,6568),(68218,6568),(68219,6568),(68220,6568),(68221,6569),(68222,6569),(68223,6569),(68224,6569),(68225,6569),(68226,6570),(68227,6570),(68228,6570),(68229,6570),(68230,6570),(68231,6571),(68232,6571),(68233,6571),(68234,6571),(68235,6571),(68236,6572),(68237,6572),(68238,6572),(68239,6572),(68240,6572);
/*!40000 ALTER TABLE `catalog_product_price_cl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_relation`
--

DROP TABLE IF EXISTS `catalog_product_relation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_relation` (
  `parent_id` int unsigned NOT NULL COMMENT 'Parent ID',
  `child_id` int unsigned NOT NULL COMMENT 'Child ID',
  PRIMARY KEY (`parent_id`,`child_id`),
  KEY `CATALOG_PRODUCT_RELATION_CHILD_ID` (`child_id`),
  CONSTRAINT `CAT_PRD_RELATION_CHILD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`child_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_RELATION_PARENT_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`parent_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Relation Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_relation`
--

LOCK TABLES `catalog_product_relation` WRITE;
/*!40000 ALTER TABLE `catalog_product_relation` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_relation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_super_attribute`
--

DROP TABLE IF EXISTS `catalog_product_super_attribute`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_super_attribute` (
  `product_super_attribute_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Product Super Attribute ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `position` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Position',
  PRIMARY KEY (`product_super_attribute_id`),
  UNIQUE KEY `CATALOG_PRODUCT_SUPER_ATTRIBUTE_PRODUCT_ID_ATTRIBUTE_ID` (`product_id`,`attribute_id`),
  CONSTRAINT `CAT_PRD_SPR_ATTR_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Super Attribute Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_super_attribute`
--

LOCK TABLES `catalog_product_super_attribute` WRITE;
/*!40000 ALTER TABLE `catalog_product_super_attribute` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_super_attribute` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_super_attribute_label`
--

DROP TABLE IF EXISTS `catalog_product_super_attribute_label`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_super_attribute_label` (
  `value_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `product_super_attribute_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product Super Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `use_default` smallint unsigned DEFAULT '0' COMMENT 'Use Default Value',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CAT_PRD_SPR_ATTR_LBL_PRD_SPR_ATTR_ID_STORE_ID` (`product_super_attribute_id`,`store_id`),
  KEY `CATALOG_PRODUCT_SUPER_ATTRIBUTE_LABEL_STORE_ID` (`store_id`),
  CONSTRAINT `CATALOG_PRODUCT_SUPER_ATTRIBUTE_LABEL_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_309442281DF7784210ED82B2CC51E5D5` FOREIGN KEY (`product_super_attribute_id`) REFERENCES `catalog_product_super_attribute` (`product_super_attribute_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Super Attribute Label Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_super_attribute_label`
--

LOCK TABLES `catalog_product_super_attribute_label` WRITE;
/*!40000 ALTER TABLE `catalog_product_super_attribute_label` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_super_attribute_label` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalog_product_super_link`
--

DROP TABLE IF EXISTS `catalog_product_super_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_super_link` (
  `link_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Link ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `parent_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Parent ID',
  PRIMARY KEY (`link_id`),
  UNIQUE KEY `CATALOG_PRODUCT_SUPER_LINK_PRODUCT_ID_PARENT_ID` (`product_id`,`parent_id`),
  KEY `CATALOG_PRODUCT_SUPER_LINK_PARENT_ID` (`parent_id`),
  CONSTRAINT `CAT_PRD_SPR_LNK_PARENT_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`parent_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_PRD_SPR_LNK_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product Super Link Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_super_link`
--

LOCK TABLES `catalog_product_super_link` WRITE;
/*!40000 ALTER TABLE `catalog_product_super_link` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalog_product_super_link` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_super_link_after_insert` AFTER INSERT ON `catalog_product_super_link` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`product_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_super_link_after_update` AFTER UPDATE ON `catalog_product_super_link` FOR EACH ROW BEGIN
IF (NOT(NEW.`link_id` <=> OLD.`link_id`) OR NOT(NEW.`product_id` <=> OLD.`product_id`) OR NOT(NEW.`parent_id` <=> OLD.`parent_id`)) THEN INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`product_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_super_link_after_delete` AFTER DELETE ON `catalog_product_super_link` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (OLD.`product_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `catalog_product_website`
--

DROP TABLE IF EXISTS `catalog_product_website`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_product_website` (
  `product_id` int unsigned NOT NULL COMMENT 'Product ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  PRIMARY KEY (`product_id`,`website_id`),
  KEY `CATALOG_PRODUCT_WEBSITE_WEBSITE_ID` (`website_id`),
  CONSTRAINT `CAT_PRD_WS_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOG_PRODUCT_WEBSITE_WEBSITE_ID_STORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Product To Website Linkage Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_product_website`
--

LOCK TABLES `catalog_product_website` WRITE;
/*!40000 ALTER TABLE `catalog_product_website` DISABLE KEYS */;
INSERT INTO `catalog_product_website` VALUES (5760,1),(6035,1),(6036,1),(6037,1),(6038,1),(6039,1),(6040,1),(6041,1),(6042,1),(6043,1),(6044,1),(6045,1),(6046,1),(6047,1),(6048,1),(6049,1),(6050,1),(6051,1),(6052,1),(6053,1),(6054,1),(6055,1),(6056,1),(6057,1),(6058,1),(6059,1),(6060,1),(6061,1),(6062,1),(6063,1),(6064,1),(6065,1),(6066,1),(6067,1),(6068,1),(6069,1),(6070,1),(6071,1),(6072,1),(6073,1),(6074,1),(6075,1),(6076,1),(6077,1),(6078,1),(6079,1),(6080,1),(6081,1),(6082,1),(6083,1),(6084,1),(6085,1),(6086,1),(6087,1),(6088,1),(6089,1),(6090,1),(6091,1),(6092,1),(6093,1),(6094,1),(6095,1),(6096,1),(6097,1),(6098,1),(6099,1),(6100,1),(6101,1),(6102,1),(6103,1),(6104,1),(6105,1),(6106,1),(6107,1),(6108,1),(6109,1),(6110,1),(6111,1),(6112,1),(6113,1),(6114,1),(6115,1),(6116,1),(6117,1),(6118,1),(6119,1),(6120,1),(6121,1),(6122,1),(6123,1),(6124,1),(6125,1),(6126,1),(6127,1),(6128,1),(6129,1),(6130,1),(6131,1),(6132,1),(6133,1),(6134,1),(6135,1),(6136,1),(6137,1),(6138,1),(6139,1),(6140,1),(6141,1),(6142,1),(6143,1),(6144,1),(6145,1),(6146,1),(6147,1),(6148,1),(6149,1),(6150,1),(6151,1),(6152,1),(6153,1),(6154,1),(6155,1),(6156,1),(6157,1),(6158,1),(6159,1),(6160,1),(6161,1),(6162,1),(6163,1),(6164,1),(6165,1),(6166,1),(6167,1),(6168,1),(6169,1),(6170,1),(6171,1),(6172,1),(6173,1),(6174,1),(6175,1),(6176,1),(6177,1),(6178,1),(6179,1),(6180,1),(6181,1),(6182,1),(6183,1),(6184,1),(6185,1),(6186,1),(6187,1),(6188,1),(6189,1),(6190,1),(6191,1),(6192,1),(6193,1),(6194,1),(6195,1),(6196,1),(6197,1),(6198,1),(6199,1),(6200,1),(6201,1),(6202,1),(6203,1),(6204,1),(6205,1),(6206,1),(6207,1),(6208,1),(6209,1),(6210,1),(6211,1),(6212,1),(6213,1),(6214,1),(6215,1),(6216,1),(6217,1),(6218,1),(6219,1),(6220,1),(6221,1),(6222,1),(6223,1),(6224,1),(6225,1),(6226,1),(6227,1),(6228,1),(6229,1),(6230,1),(6231,1),(6232,1),(6233,1),(6234,1),(6235,1),(6236,1),(6237,1),(6238,1),(6239,1),(6240,1),(6241,1),(6242,1),(6243,1),(6244,1),(6245,1),(6246,1),(6247,1),(6248,1),(6249,1),(6250,1),(6251,1),(6252,1),(6253,1),(6254,1),(6255,1),(6256,1),(6257,1),(6258,1),(6259,1),(6260,1),(6261,1),(6262,1),(6263,1),(6264,1),(6265,1),(6266,1),(6267,1),(6268,1),(6269,1),(6270,1),(6271,1),(6272,1),(6273,1),(6274,1),(6275,1),(6276,1),(6277,1),(6278,1),(6279,1),(6280,1),(6281,1),(6282,1),(6283,1),(6284,1),(6285,1),(6286,1),(6287,1),(6288,1),(6289,1),(6290,1),(6291,1),(6292,1),(6293,1),(6294,1),(6295,1),(6296,1),(6297,1),(6298,1),(6299,1),(6300,1),(6301,1),(6302,1),(6303,1),(6304,1),(6305,1),(6306,1),(6307,1),(6308,1),(6309,1),(6310,1),(6311,1),(6312,1),(6313,1),(6314,1),(6315,1),(6316,1),(6317,1),(6318,1),(6319,1),(6320,1),(6321,1),(6322,1),(6323,1),(6324,1),(6325,1),(6326,1),(6327,1),(6328,1),(6329,1),(6330,1),(6331,1),(6332,1),(6333,1),(6334,1),(6335,1),(6336,1),(6337,1),(6338,1),(6339,1),(6340,1),(6341,1),(6342,1),(6343,1),(6344,1),(6345,1),(6346,1),(6347,1),(6348,1),(6349,1),(6350,1),(6351,1),(6352,1),(6353,1),(6354,1),(6355,1),(6356,1),(6357,1),(6358,1),(6359,1),(6360,1),(6361,1),(6362,1),(6363,1),(6364,1),(6365,1),(6366,1),(6367,1),(6368,1),(6369,1),(6370,1),(6371,1),(6372,1),(6373,1),(6374,1),(6375,1),(6376,1),(6377,1),(6378,1),(6379,1),(6380,1),(6381,1),(6382,1),(6383,1),(6384,1),(6385,1),(6386,1),(6387,1),(6388,1),(6389,1),(6390,1),(6391,1),(6392,1),(6393,1),(6394,1),(6395,1),(6396,1),(6397,1),(6398,1),(6399,1),(6400,1),(6401,1),(6402,1),(6403,1),(6404,1),(6405,1),(6406,1),(6407,1),(6408,1),(6409,1),(6410,1),(6411,1),(6412,1),(6413,1),(6414,1),(6415,1),(6416,1),(6417,1),(6418,1),(6419,1),(6420,1),(6421,1),(6422,1),(6423,1),(6424,1),(6425,1),(6426,1),(6427,1),(6428,1),(6429,1),(6430,1),(6431,1),(6432,1),(6433,1),(6434,1),(6435,1),(6436,1),(6437,1),(6438,1),(6439,1),(6440,1),(6441,1),(6442,1),(6443,1),(6444,1),(6445,1),(6446,1),(6447,1),(6448,1),(6449,1),(6450,1),(6451,1),(6452,1),(6453,1),(6454,1),(6455,1),(6456,1),(6457,1),(6458,1),(6459,1),(6460,1),(6461,1),(6462,1),(6463,1),(6464,1),(6465,1),(6466,1),(6467,1),(6468,1),(6469,1),(6470,1),(6471,1),(6472,1),(6473,1),(6474,1),(6475,1),(6476,1),(6477,1),(6478,1),(6479,1),(6480,1),(6481,1),(6482,1),(6483,1),(6484,1),(6485,1),(6486,1),(6487,1),(6488,1),(6489,1),(6490,1),(6491,1),(6492,1),(6493,1),(6494,1),(6495,1),(6496,1),(6497,1),(6498,1),(6499,1),(6500,1),(6501,1),(6502,1),(6503,1),(6504,1),(6505,1),(6506,1),(6507,1),(6508,1),(6509,1),(6510,1),(6511,1),(6512,1),(6513,1),(6514,1),(6515,1),(6516,1),(6517,1),(6518,1),(6519,1),(6520,1),(6521,1),(6522,1),(6523,1),(6524,1),(6525,1),(6526,1),(6527,1),(6528,1),(6529,1),(6530,1),(6531,1),(6532,1),(6533,1),(6534,1),(6535,1),(6536,1),(6537,1),(6538,1),(6539,1),(6540,1),(6541,1),(6542,1),(6543,1),(6544,1),(6545,1),(6546,1),(6547,1),(6548,1),(6549,1),(6550,1),(6551,1),(6552,1),(6553,1),(6554,1),(6555,1),(6556,1),(6557,1),(6558,1),(6559,1),(6560,1),(6561,1),(6562,1),(6563,1),(6564,1),(6565,1),(6566,1),(6567,1),(6568,1),(6569,1),(6570,1),(6571,1),(6572,1),(5760,2),(6035,2),(6036,2),(6037,2),(6038,2),(6039,2),(6040,2),(6041,2),(6042,2),(6043,2),(6044,2),(6045,2),(6046,2),(6047,2),(6048,2),(6049,2),(6050,2),(6051,2),(6052,2),(6053,2),(5760,3),(6035,3),(6036,3),(6037,3),(6038,3),(6039,3),(6040,3),(6041,3),(6042,3),(6043,3),(6044,3),(6045,3),(6046,3),(6047,3),(6048,3),(6049,3),(6050,3),(6051,3),(6052,3),(6053,3),(5760,4),(6035,4),(6036,4),(6037,4),(6038,4),(6039,4),(6040,4),(6041,4),(6042,4),(6043,4),(6044,4),(6045,4),(6046,4),(6047,4),(6048,4),(6049,4),(6050,4),(6051,4),(6052,4),(6053,4);
/*!40000 ALTER TABLE `catalog_product_website` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_website_after_insert` AFTER INSERT ON `catalog_product_website` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`product_id`);
INSERT IGNORE INTO `catalog_product_category_cl` (`entity_id`) VALUES (NEW.`product_id`);
INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (NEW.`product_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_website_after_update` AFTER UPDATE ON `catalog_product_website` FOR EACH ROW BEGIN
IF (NOT(NEW.`product_id` <=> OLD.`product_id`) OR NOT(NEW.`website_id` <=> OLD.`website_id`)) THEN INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (NEW.`product_id`); END IF;
IF (NOT(NEW.`product_id` <=> OLD.`product_id`) OR NOT(NEW.`website_id` <=> OLD.`website_id`)) THEN INSERT IGNORE INTO `catalog_product_category_cl` (`entity_id`) VALUES (NEW.`product_id`); END IF;
IF (NOT(NEW.`product_id` <=> OLD.`product_id`) OR NOT(NEW.`website_id` <=> OLD.`website_id`)) THEN INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (NEW.`product_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalog_product_website_after_delete` AFTER DELETE ON `catalog_product_website` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogsearch_fulltext_cl` (`entity_id`) VALUES (OLD.`product_id`);
INSERT IGNORE INTO `catalog_product_category_cl` (`entity_id`) VALUES (OLD.`product_id`);
INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (OLD.`product_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `catalog_url_rewrite_product_category`
--

DROP TABLE IF EXISTS `catalog_url_rewrite_product_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalog_url_rewrite_product_category` (
  `url_rewrite_id` int unsigned NOT NULL COMMENT 'url_rewrite_id',
  `category_id` int unsigned NOT NULL COMMENT 'category_id',
  `product_id` int unsigned NOT NULL COMMENT 'product_id',
  PRIMARY KEY (`url_rewrite_id`),
  KEY `CAT_URL_REWRITE_PRD_CTGR_PRD_ID_CAT_PRD_ENTT_ENTT_ID` (`product_id`),
  KEY `CATALOG_URL_REWRITE_PRODUCT_CATEGORY_CATEGORY_ID_PRODUCT_ID` (`category_id`,`product_id`),
  CONSTRAINT `CAT_URL_REWRITE_PRD_CTGR_CTGR_ID_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`category_id`) REFERENCES `catalog_category_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CAT_URL_REWRITE_PRD_CTGR_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_BB79E64705D7F17FE181F23144528FC8` FOREIGN KEY (`url_rewrite_id`) REFERENCES `url_rewrite` (`url_rewrite_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='url_rewrite_relation';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalog_url_rewrite_product_category`
--

LOCK TABLES `catalog_url_rewrite_product_category` WRITE;
/*!40000 ALTER TABLE `catalog_url_rewrite_product_category` DISABLE KEYS */;
INSERT INTO `catalog_url_rewrite_product_category` VALUES (9189,3,5760),(10944,3,5760),(10958,3,5760),(10972,3,5760),(10986,3,5760),(10502,3,6035),(10512,3,6035),(11000,3,6035),(11009,3,6035),(11018,3,6035),(9190,5,5760),(10945,5,5760),(10959,5,5760),(10973,5,5760),(10987,5,5760),(10503,5,6035),(10513,5,6035),(11001,5,6035),(11010,5,6035),(11019,5,6035),(9191,6,5760),(10946,6,5760),(10960,6,5760),(10974,6,5760),(10988,6,5760),(9192,7,5760),(10947,7,5760),(10961,7,5760),(10975,7,5760),(10989,7,5760),(10504,7,6035),(10514,7,6035),(11002,7,6035),(11011,7,6035),(11020,7,6035),(9193,10,5760),(10948,10,5760),(10962,10,5760),(10976,10,5760),(10990,10,5760),(10505,10,6035),(10515,10,6035),(11003,10,6035),(11012,10,6035),(11021,10,6035),(9194,11,5760),(10949,11,5760),(10963,11,5760),(10977,11,5760),(10991,11,5760),(10506,11,6035),(10516,11,6035),(11004,11,6035),(11013,11,6035),(11022,11,6035),(9195,12,5760),(10950,12,5760),(10964,12,5760),(10978,12,5760),(10992,12,5760),(10507,12,6035),(10517,12,6035),(11005,12,6035),(11014,12,6035),(11023,12,6035),(9196,145,5760),(10951,145,5760),(10965,145,5760),(10979,145,5760),(10993,145,5760),(9198,164,5760),(10952,164,5760),(10966,164,5760),(10980,164,5760),(10994,164,5760),(10509,164,6035),(10519,164,6035),(11006,164,6035),(11015,164,6035),(11024,164,6035),(9200,343,5760),(10953,343,5760),(10967,343,5760),(10981,343,5760),(10995,343,5760),(9201,356,5760),(10954,356,5760),(10968,356,5760),(10982,356,5760),(10996,356,5760),(9202,366,5760),(10955,366,5760),(10969,366,5760),(10983,366,5760),(10997,366,5760),(9203,449,5760),(10956,449,5760),(10970,449,5760),(10984,449,5760),(10998,449,5760),(10510,449,6035),(10520,449,6035),(11007,449,6035),(11016,449,6035),(11025,449,6035);
/*!40000 ALTER TABLE `catalog_url_rewrite_product_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cataloginventory_stock`
--

DROP TABLE IF EXISTS `cataloginventory_stock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cataloginventory_stock` (
  `stock_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Stock ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `stock_name` varchar(255) DEFAULT NULL COMMENT 'Stock Name',
  PRIMARY KEY (`stock_id`),
  KEY `CATALOGINVENTORY_STOCK_WEBSITE_ID` (`website_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COMMENT='Cataloginventory Stock';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cataloginventory_stock`
--

LOCK TABLES `cataloginventory_stock` WRITE;
/*!40000 ALTER TABLE `cataloginventory_stock` DISABLE KEYS */;
INSERT INTO `cataloginventory_stock` VALUES (1,0,'Default');
/*!40000 ALTER TABLE `cataloginventory_stock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cataloginventory_stock_cl`
--

DROP TABLE IF EXISTS `cataloginventory_stock_cl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cataloginventory_stock_cl` (
  `version_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Version ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  PRIMARY KEY (`version_id`)
) ENGINE=InnoDB AUTO_INCREMENT=35941 DEFAULT CHARSET=utf8mb3 COMMENT='cataloginventory_stock_cl';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cataloginventory_stock_cl`
--

LOCK TABLES `cataloginventory_stock_cl` WRITE;
/*!40000 ALTER TABLE `cataloginventory_stock_cl` DISABLE KEYS */;
INSERT INTO `cataloginventory_stock_cl` VALUES (1,1),(2,1),(3,1),(4,1),(5,2),(6,2),(7,2),(8,2),(9,3),(10,3),(11,3),(12,3),(13,4),(14,4),(15,4),(16,5),(17,5),(18,5),(19,5),(20,5),(21,5),(22,5),(23,5),(24,5),(25,6),(26,6),(27,6),(28,6),(29,6),(30,6),(31,6),(32,6),(33,6),(34,4),(35,4),(36,1),(37,1),(38,1),(39,1),(40,1),(41,1),(42,2),(43,2),(44,2),(45,3),(46,3),(47,3),(48,4),(49,4),(50,4),(51,4),(52,4),(53,4),(54,5),(55,5),(56,5),(57,5),(58,5),(59,5),(60,6),(61,6),(62,6),(63,6),(64,6),(65,6),(66,1),(67,2),(68,3),(69,4),(70,5),(71,6),(72,1),(73,1),(74,1),(75,1),(76,1),(77,1),(78,1),(79,1),(80,1),(81,1),(82,1),(83,1),(84,1),(85,2),(86,2),(87,2),(88,2),(89,2),(90,2),(91,2),(92,6),(93,6),(94,6),(95,6),(96,6),(97,6),(98,6),(99,6),(100,6),(101,6),(102,6),(103,6),(104,6),(105,5),(106,5),(107,5),(108,5),(109,5),(110,5),(111,5),(112,5),(113,5),(114,5),(115,5),(116,5),(117,5),(118,4),(119,4),(120,4),(121,4),(122,4),(123,4),(124,4),(125,4),(126,4),(127,4),(128,4),(129,4),(130,4),(131,4),(132,4),(133,4),(134,4),(135,3),(136,3),(137,3),(138,3),(139,3),(140,3),(141,3),(142,7),(143,7),(144,7),(145,7),(146,7),(147,7),(148,7),(149,7),(150,7),(151,7),(152,7),(153,8),(154,8),(155,8),(156,8),(157,9),(158,9),(159,9),(160,9),(161,10),(162,10),(163,10),(164,10),(165,11),(166,11),(167,11),(168,11),(169,12),(170,12),(171,12),(172,12),(173,13),(174,13),(175,13),(176,13),(177,14),(178,14),(179,14),(180,14),(181,15),(182,15),(183,15),(184,15),(185,16),(186,16),(187,16),(188,16),(189,17),(190,17),(191,17),(192,17),(193,18),(194,18),(195,18),(196,18),(197,19),(198,19),(199,19),(200,19),(201,20),(202,20),(203,20),(204,20),(205,21),(206,21),(207,21),(208,21),(209,22),(210,22),(211,22),(212,22),(213,23),(214,23),(215,23),(216,23),(217,24),(218,24),(219,24),(220,24),(221,25),(222,25),(223,25),(224,25),(225,26),(226,26),(227,26),(228,26),(229,27),(230,27),(231,27),(232,27),(233,28),(234,28),(235,28),(236,28),(237,29),(238,29),(239,29),(240,29),(241,30),(242,30),(243,30),(244,30),(245,31),(246,31),(247,31),(248,31),(249,32),(250,32),(251,32),(252,32),(253,33),(254,33),(255,33),(256,33),(257,34),(258,34),(259,34),(260,34),(261,35),(262,35),(263,35),(264,35),(265,36),(266,36),(267,36),(268,36),(269,37),(270,37),(271,37),(272,37),(273,38),(274,38),(275,38),(276,38),(277,39),(278,39),(279,39),(280,39),(281,40),(282,40),(283,40),(284,40),(285,41),(286,41),(287,41),(288,41),(289,42),(290,42),(291,42),(292,42),(293,43),(294,43),(295,43),(296,43),(297,44),(298,44),(299,44),(300,44),(301,45),(302,45),(303,45),(304,45),(305,46),(306,46),(307,46),(308,46),(309,47),(310,47),(311,47),(312,47),(313,48),(314,48),(315,48),(316,48),(317,49),(318,49),(319,49),(320,49),(321,50),(322,50),(323,50),(324,50),(325,51),(326,51),(327,51),(328,51),(329,52),(330,52),(331,52),(332,52),(333,53),(334,53),(335,53),(336,53),(337,54),(338,54),(339,54),(340,54),(341,55),(342,55),(343,55),(344,55),(345,56),(346,56),(347,56),(348,56),(349,57),(350,57),(351,57),(352,57),(353,58),(354,58),(355,58),(356,58),(357,59),(358,59),(359,59),(360,59),(361,60),(362,60),(363,60),(364,60),(365,61),(366,61),(367,61),(368,61),(369,62),(370,62),(371,62),(372,62),(373,63),(374,63),(375,63),(376,63),(377,64),(378,64),(379,64),(380,64),(381,65),(382,65),(383,65),(384,65),(385,66),(386,66),(387,66),(388,66),(389,67),(390,67),(391,67),(392,67),(393,68),(394,68),(395,68),(396,68),(397,69),(398,69),(399,69),(400,69),(401,70),(402,70),(403,70),(404,70),(405,71),(406,71),(407,71),(408,71),(409,72),(410,72),(411,72),(412,72),(413,73),(414,73),(415,73),(416,73),(417,74),(418,74),(419,74),(420,74),(421,75),(422,75),(423,75),(424,75),(425,76),(426,76),(427,76),(428,76),(429,77),(430,77),(431,77),(432,77),(433,78),(434,78),(435,78),(436,78),(437,79),(438,79),(439,79),(440,79),(441,80),(442,80),(443,80),(444,80),(445,81),(446,81),(447,81),(448,81),(449,82),(450,82),(451,82),(452,82),(453,83),(454,83),(455,83),(456,83),(457,84),(458,84),(459,84),(460,84),(461,85),(462,85),(463,85),(464,85),(465,86),(466,86),(467,86),(468,86),(469,87),(470,87),(471,87),(472,87),(473,88),(474,88),(475,88),(476,88),(477,89),(478,89),(479,89),(480,89),(481,90),(482,90),(483,90),(484,90),(485,91),(486,91),(487,91),(488,91),(489,92),(490,92),(491,92),(492,92),(493,93),(494,93),(495,93),(496,93),(497,94),(498,94),(499,94),(500,94),(501,95),(502,95),(503,95),(504,95),(505,96),(506,96),(507,96),(508,96),(509,97),(510,97),(511,97),(512,97),(513,98),(514,98),(515,98),(516,98),(517,99),(518,99),(519,99),(520,99),(521,100),(522,100),(523,100),(524,100),(525,101),(526,101),(527,101),(528,101),(529,102),(530,102),(531,102),(532,102),(533,103),(534,103),(535,103),(536,103),(537,104),(538,104),(539,104),(540,104),(541,105),(542,105),(543,105),(544,105),(545,106),(546,106),(547,106),(548,106),(549,107),(550,107),(551,107),(552,107),(553,108),(554,108),(555,108),(556,108),(557,109),(558,109),(559,109),(560,109),(561,110),(562,110),(563,110),(564,110),(565,111),(566,111),(567,111),(568,111),(569,112),(570,112),(571,112),(572,112),(573,113),(574,113),(575,113),(576,113),(577,114),(578,114),(579,114),(580,114),(581,115),(582,115),(583,115),(584,115),(585,116),(586,116),(587,116),(588,116),(589,117),(590,117),(591,117),(592,117),(593,118),(594,118),(595,118),(596,118),(597,119),(598,119),(599,119),(600,119),(601,120),(602,120),(603,120),(604,120),(605,121),(606,121),(607,121),(608,121),(609,122),(610,122),(611,122),(612,122),(613,123),(614,123),(615,123),(616,123),(617,124),(618,124),(619,124),(620,124),(621,125),(622,125),(623,125),(624,125),(625,126),(626,126),(627,126),(628,126),(629,127),(630,127),(631,127),(632,127),(633,128),(634,128),(635,128),(636,128),(637,129),(638,129),(639,129),(640,129),(641,130),(642,130),(643,130),(644,130),(645,131),(646,131),(647,131),(648,131),(649,132),(650,132),(651,132),(652,132),(653,133),(654,133),(655,133),(656,133),(657,134),(658,134),(659,134),(660,134),(661,135),(662,135),(663,135),(664,135),(665,136),(666,136),(667,136),(668,136),(669,137),(670,137),(671,137),(672,137),(673,138),(674,138),(675,138),(676,138),(677,139),(678,139),(679,139),(680,139),(681,140),(682,140),(683,140),(684,140),(685,141),(686,141),(687,141),(688,141),(689,142),(690,142),(691,142),(692,142),(693,143),(694,143),(695,143),(696,143),(697,144),(698,144),(699,144),(700,144),(701,145),(702,145),(703,145),(704,145),(705,146),(706,146),(707,146),(708,146),(709,147),(710,147),(711,147),(712,147),(713,148),(714,148),(715,148),(716,148),(717,149),(718,149),(719,149),(720,149),(721,150),(722,150),(723,150),(724,150),(725,151),(726,151),(727,151),(728,151),(729,152),(730,152),(731,152),(732,152),(733,153),(734,153),(735,153),(736,153),(737,154),(738,154),(739,154),(740,154),(741,155),(742,155),(743,155),(744,155),(745,156),(746,156),(747,156),(748,156),(749,157),(750,157),(751,157),(752,157),(753,158),(754,158),(755,158),(756,158),(757,159),(758,159),(759,159),(760,159),(761,160),(762,160),(763,160),(764,160),(765,161),(766,161),(767,161),(768,161),(769,162),(770,162),(771,162),(772,162),(773,163),(774,163),(775,163),(776,163),(777,164),(778,164),(779,164),(780,164),(781,165),(782,165),(783,165),(784,165),(785,166),(786,166),(787,166),(788,166),(789,167),(790,167),(791,167),(792,167),(793,168),(794,168),(795,168),(796,168),(797,169),(798,169),(799,169),(800,169),(801,170),(802,170),(803,170),(804,170),(805,171),(806,171),(807,171),(808,171),(809,172),(810,172),(811,172),(812,172),(813,173),(814,173),(815,173),(816,173),(817,174),(818,174),(819,174),(820,174),(821,175),(822,175),(823,175),(824,175),(825,176),(826,176),(827,176),(828,176),(829,177),(830,177),(831,177),(832,177),(833,178),(834,178),(835,178),(836,178),(837,179),(838,179),(839,179),(840,179),(841,180),(842,180),(843,180),(844,180),(845,181),(846,181),(847,181),(848,181),(849,182),(850,182),(851,182),(852,182),(853,183),(854,183),(855,183),(856,183),(857,184),(858,184),(859,184),(860,184),(861,185),(862,185),(863,185),(864,185),(865,186),(866,186),(867,186),(868,186),(869,187),(870,187),(871,187),(872,187),(873,188),(874,188),(875,188),(876,188),(877,189),(878,189),(879,189),(880,189),(881,190),(882,190),(883,190),(884,190),(885,191),(886,191),(887,191),(888,191),(889,192),(890,192),(891,192),(892,192),(893,193),(894,193),(895,193),(896,193),(897,194),(898,194),(899,194),(900,194),(901,195),(902,195),(903,195),(904,195),(905,196),(906,196),(907,196),(908,196),(909,197),(910,197),(911,197),(912,197),(913,198),(914,198),(915,198),(916,198),(917,199),(918,199),(919,199),(920,199),(921,200),(922,200),(923,200),(924,200),(925,201),(926,201),(927,201),(928,201),(929,202),(930,202),(931,202),(932,202),(933,203),(934,203),(935,203),(936,203),(937,204),(938,204),(939,204),(940,204),(941,205),(942,205),(943,205),(944,205),(945,206),(946,206),(947,206),(948,206),(949,207),(950,207),(951,207),(952,207),(953,208),(954,208),(955,208),(956,208),(957,209),(958,209),(959,209),(960,209),(961,210),(962,210),(963,210),(964,210),(965,211),(966,211),(967,211),(968,211),(969,212),(970,212),(971,212),(972,212),(973,213),(974,213),(975,213),(976,213),(977,214),(978,214),(979,214),(980,214),(981,215),(982,215),(983,215),(984,215),(985,216),(986,216),(987,216),(988,216),(989,217),(990,217),(991,217),(992,217),(993,218),(994,218),(995,218),(996,218),(997,219),(998,219),(999,219),(1000,219),(1001,220),(1002,220),(1003,220),(1004,220),(1005,221),(1006,221),(1007,221),(1008,221),(1009,222),(1010,222),(1011,222),(1012,222),(1013,223),(1014,223),(1015,223),(1016,223),(1017,224),(1018,224),(1019,224),(1020,224),(1021,225),(1022,225),(1023,225),(1024,225),(1025,226),(1026,226),(1027,226),(1028,226),(1029,227),(1030,227),(1031,227),(1032,227),(1033,228),(1034,228),(1035,228),(1036,228),(1037,229),(1038,229),(1039,229),(1040,229),(1041,230),(1042,230),(1043,230),(1044,230),(1045,231),(1046,231),(1047,231),(1048,231),(1049,232),(1050,232),(1051,232),(1052,232),(1053,233),(1054,233),(1055,233),(1056,233),(1057,234),(1058,234),(1059,234),(1060,234),(1061,235),(1062,235),(1063,235),(1064,235),(1065,236),(1066,236),(1067,236),(1068,236),(1069,237),(1070,237),(1071,237),(1072,237),(1073,238),(1074,238),(1075,238),(1076,238),(1077,239),(1078,239),(1079,239),(1080,239),(1081,240),(1082,240),(1083,240),(1084,240),(1085,241),(1086,241),(1087,241),(1088,241),(1089,242),(1090,242),(1091,242),(1092,242),(1093,243),(1094,243),(1095,243),(1096,243),(1097,244),(1098,244),(1099,244),(1100,244),(1101,245),(1102,245),(1103,245),(1104,245),(1105,246),(1106,246),(1107,246),(1108,246),(1109,247),(1110,247),(1111,247),(1112,247),(1113,248),(1114,248),(1115,248),(1116,248),(1117,249),(1118,249),(1119,249),(1120,249),(1121,250),(1122,250),(1123,250),(1124,250),(1125,251),(1126,251),(1127,251),(1128,251),(1129,252),(1130,252),(1131,252),(1132,252),(1133,253),(1134,253),(1135,253),(1136,253),(1137,254),(1138,254),(1139,254),(1140,254),(1141,255),(1142,255),(1143,255),(1144,255),(1145,256),(1146,256),(1147,256),(1148,256),(1149,257),(1150,257),(1151,257),(1152,257),(1153,258),(1154,258),(1155,258),(1156,258),(1157,259),(1158,259),(1159,259),(1160,259),(1161,260),(1162,260),(1163,260),(1164,260),(1165,261),(1166,261),(1167,261),(1168,261),(1169,262),(1170,262),(1171,262),(1172,262),(1173,263),(1174,263),(1175,263),(1176,263),(1177,264),(1178,264),(1179,264),(1180,264),(1181,265),(1182,265),(1183,265),(1184,265),(1185,266),(1186,266),(1187,266),(1188,266),(1189,267),(1190,267),(1191,267),(1192,267),(1193,268),(1194,268),(1195,268),(1196,268),(1197,269),(1198,269),(1199,269),(1200,269),(1201,270),(1202,270),(1203,270),(1204,270),(1205,271),(1206,271),(1207,271),(1208,271),(1209,272),(1210,272),(1211,272),(1212,272),(1213,273),(1214,273),(1215,273),(1216,273),(1217,274),(1218,274),(1219,274),(1220,274),(1221,275),(1222,275),(1223,275),(1224,275),(1225,276),(1226,276),(1227,276),(1228,276),(1229,277),(1230,277),(1231,277),(1232,277),(1233,278),(1234,278),(1235,278),(1236,278),(1237,279),(1238,279),(1239,279),(1240,279),(1241,280),(1242,280),(1243,280),(1244,280),(1245,8),(1246,9),(1247,10),(1248,11),(1249,12),(1250,13),(1251,14),(1252,15),(1253,16),(1254,17),(1255,18),(1256,19),(1257,20),(1258,21),(1259,22),(1260,23),(1261,24),(1262,25),(1263,26),(1264,27),(1265,28),(1266,29),(1267,30),(1268,31),(1269,32),(1270,33),(1271,34),(1272,35),(1273,36),(1274,37),(1275,38),(1276,39),(1277,40),(1278,41),(1279,42),(1280,43),(1281,44),(1282,45),(1283,46),(1284,47),(1285,48),(1286,49),(1287,50),(1288,51),(1289,52),(1290,53),(1291,54),(1292,55),(1293,56),(1294,57),(1295,58),(1296,59),(1297,60),(1298,61),(1299,62),(1300,63),(1301,64),(1302,65),(1303,66),(1304,67),(1305,68),(1306,69),(1307,70),(1308,71),(1309,72),(1310,73),(1311,74),(1312,75),(1313,76),(1314,77),(1315,78),(1316,79),(1317,80),(1318,81),(1319,82),(1320,83),(1321,84),(1322,85),(1323,86),(1324,87),(1325,88),(1326,89),(1327,90),(1328,91),(1329,92),(1330,93),(1331,94),(1332,95),(1333,96),(1334,97),(1335,98),(1336,99),(1337,100),(1338,101),(1339,102),(1340,103),(1341,104),(1342,105),(1343,106),(1344,107),(1345,108),(1346,109),(1347,110),(1348,111),(1349,112),(1350,113),(1351,114),(1352,115),(1353,116),(1354,117),(1355,118),(1356,119),(1357,120),(1358,121),(1359,122),(1360,123),(1361,124),(1362,125),(1363,126),(1364,127),(1365,128),(1366,129),(1367,130),(1368,131),(1369,132),(1370,133),(1371,134),(1372,135),(1373,136),(1374,137),(1375,138),(1376,139),(1377,140),(1378,141),(1379,142),(1380,143),(1381,144),(1382,145),(1383,146),(1384,147),(1385,148),(1386,149),(1387,150),(1388,151),(1389,152),(1390,153),(1391,154),(1392,155),(1393,156),(1394,157),(1395,158),(1396,159),(1397,160),(1398,161),(1399,162),(1400,163),(1401,164),(1402,165),(1403,166),(1404,167),(1405,168),(1406,169),(1407,170),(1408,171),(1409,172),(1410,173),(1411,174),(1412,175),(1413,176),(1414,177),(1415,178),(1416,179),(1417,180),(1418,181),(1419,182),(1420,183),(1421,184),(1422,185),(1423,186),(1424,187),(1425,188),(1426,189),(1427,190),(1428,191),(1429,192),(1430,193),(1431,194),(1432,195),(1433,196),(1434,197),(1435,198),(1436,199),(1437,200),(1438,201),(1439,202),(1440,203),(1441,204),(1442,205),(1443,206),(1444,207),(1445,208),(1446,209),(1447,210),(1448,211),(1449,212),(1450,213),(1451,214),(1452,215),(1453,216),(1454,217),(1455,218),(1456,219),(1457,220),(1458,221),(1459,222),(1460,223),(1461,224),(1462,225),(1463,226),(1464,227),(1465,228),(1466,229),(1467,230),(1468,231),(1469,232),(1470,233),(1471,234),(1472,235),(1473,236),(1474,237),(1475,238),(1476,239),(1477,240),(1478,241),(1479,242),(1480,243),(1481,244),(1482,245),(1483,246),(1484,247),(1485,248),(1486,249),(1487,250),(1488,251),(1489,252),(1490,253),(1491,254),(1492,255),(1493,256),(1494,257),(1495,258),(1496,259),(1497,260),(1498,261),(1499,262),(1500,263),(1501,264),(1502,265),(1503,266),(1504,267),(1505,268),(1506,269),(1507,270),(1508,271),(1509,272),(1510,273),(1511,274),(1512,275),(1513,276),(1514,277),(1515,278),(1516,279),(1517,280),(1518,281),(1519,281),(1520,281),(1521,281),(1522,282),(1523,282),(1524,282),(1525,282),(1526,283),(1527,283),(1528,283),(1529,283),(1530,284),(1531,284),(1532,284),(1533,284),(1534,285),(1535,285),(1536,285),(1537,285),(1538,286),(1539,286),(1540,286),(1541,286),(1542,287),(1543,287),(1544,287),(1545,287),(1546,288),(1547,288),(1548,288),(1549,288),(1550,289),(1551,289),(1552,289),(1553,289),(1554,290),(1555,290),(1556,290),(1557,290),(1558,291),(1559,291),(1560,291),(1561,291),(1562,292),(1563,292),(1564,292),(1565,292),(1566,293),(1567,293),(1568,293),(1569,293),(1570,294),(1571,294),(1572,294),(1573,294),(1574,295),(1575,295),(1576,295),(1577,295),(1578,296),(1579,296),(1580,296),(1581,296),(1582,297),(1583,297),(1584,297),(1585,297),(1586,298),(1587,298),(1588,298),(1589,298),(1590,299),(1591,299),(1592,299),(1593,299),(1594,300),(1595,300),(1596,300),(1597,300),(1598,301),(1599,301),(1600,301),(1601,301),(1602,302),(1603,302),(1604,302),(1605,302),(1606,303),(1607,303),(1608,303),(1609,303),(1610,304),(1611,304),(1612,304),(1613,304),(1614,305),(1615,305),(1616,305),(1617,305),(1618,306),(1619,306),(1620,306),(1621,306),(1622,307),(1623,307),(1624,307),(1625,307),(1626,308),(1627,308),(1628,308),(1629,308),(1630,309),(1631,309),(1632,309),(1633,309),(1634,310),(1635,310),(1636,310),(1637,310),(1638,311),(1639,311),(1640,311),(1641,311),(1642,312),(1643,312),(1644,312),(1645,312),(1646,313),(1647,313),(1648,313),(1649,313),(1650,314),(1651,314),(1652,314),(1653,314),(1654,315),(1655,315),(1656,315),(1657,315),(1658,316),(1659,316),(1660,316),(1661,316),(1662,317),(1663,317),(1664,317),(1665,317),(1666,318),(1667,318),(1668,318),(1669,318),(1670,319),(1671,319),(1672,319),(1673,319),(1674,320),(1675,320),(1676,320),(1677,320),(1678,321),(1679,321),(1680,321),(1681,321),(1682,322),(1683,322),(1684,322),(1685,322),(1686,323),(1687,323),(1688,323),(1689,323),(1690,324),(1691,324),(1692,324),(1693,324),(1694,325),(1695,325),(1696,325),(1697,325),(1698,326),(1699,326),(1700,326),(1701,326),(1702,327),(1703,327),(1704,327),(1705,327),(1706,328),(1707,328),(1708,328),(1709,328),(1710,329),(1711,329),(1712,329),(1713,329),(1714,330),(1715,330),(1716,330),(1717,330),(1718,331),(1719,331),(1720,331),(1721,331),(1722,332),(1723,332),(1724,332),(1725,332),(1726,333),(1727,333),(1728,333),(1729,333),(1730,334),(1731,334),(1732,334),(1733,334),(1734,335),(1735,335),(1736,335),(1737,335),(1738,336),(1739,336),(1740,336),(1741,336),(1742,337),(1743,337),(1744,337),(1745,337),(1746,338),(1747,338),(1748,338),(1749,338),(1750,339),(1751,339),(1752,339),(1753,339),(1754,340),(1755,340),(1756,340),(1757,340),(1758,341),(1759,341),(1760,341),(1761,341),(1762,342),(1763,342),(1764,342),(1765,342),(1766,343),(1767,343),(1768,343),(1769,343),(1770,344),(1771,344),(1772,344),(1773,344),(1774,345),(1775,345),(1776,345),(1777,345),(1778,346),(1779,346),(1780,346),(1781,346),(1782,347),(1783,347),(1784,347),(1785,347),(1786,348),(1787,348),(1788,348),(1789,348),(1790,349),(1791,349),(1792,349),(1793,349),(1794,350),(1795,350),(1796,350),(1797,350),(1798,351),(1799,351),(1800,351),(1801,351),(1802,352),(1803,352),(1804,352),(1805,352),(1806,353),(1807,353),(1808,353),(1809,353),(1810,354),(1811,354),(1812,354),(1813,354),(1814,355),(1815,355),(1816,355),(1817,355),(1818,356),(1819,356),(1820,356),(1821,356),(1822,357),(1823,357),(1824,357),(1825,357),(1826,358),(1827,358),(1828,358),(1829,358),(1830,359),(1831,359),(1832,359),(1833,359),(1834,360),(1835,360),(1836,360),(1837,360),(1838,361),(1839,361),(1840,361),(1841,361),(1842,362),(1843,362),(1844,362),(1845,362),(1846,363),(1847,363),(1848,363),(1849,363),(1850,364),(1851,364),(1852,364),(1853,364),(1854,365),(1855,365),(1856,365),(1857,365),(1858,366),(1859,366),(1860,366),(1861,366),(1862,367),(1863,367),(1864,367),(1865,367),(1866,368),(1867,368),(1868,368),(1869,368),(1870,369),(1871,369),(1872,369),(1873,369),(1874,370),(1875,370),(1876,370),(1877,370),(1878,371),(1879,371),(1880,371),(1881,371),(1882,372),(1883,372),(1884,372),(1885,372),(1886,373),(1887,373),(1888,373),(1889,373),(1890,374),(1891,374),(1892,374),(1893,374),(1894,375),(1895,375),(1896,375),(1897,375),(1898,376),(1899,376),(1900,376),(1901,376),(1902,377),(1903,377),(1904,377),(1905,377),(1906,378),(1907,378),(1908,378),(1909,378),(1910,379),(1911,379),(1912,379),(1913,379),(1914,380),(1915,380),(1916,380),(1917,380),(1918,381),(1919,381),(1920,381),(1921,381),(1922,382),(1923,382),(1924,382),(1925,382),(1926,383),(1927,383),(1928,383),(1929,383),(1930,384),(1931,384),(1932,384),(1933,384),(1934,385),(1935,385),(1936,385),(1937,385),(1938,386),(1939,386),(1940,386),(1941,386),(1942,387),(1943,387),(1944,387),(1945,387),(1946,388),(1947,388),(1948,388),(1949,388),(1950,389),(1951,389),(1952,389),(1953,389),(1954,390),(1955,390),(1956,390),(1957,390),(1958,391),(1959,391),(1960,391),(1961,391),(1962,392),(1963,392),(1964,392),(1965,392),(1966,393),(1967,393),(1968,393),(1969,393),(1970,394),(1971,394),(1972,394),(1973,394),(1974,395),(1975,395),(1976,395),(1977,395),(1978,396),(1979,396),(1980,396),(1981,396),(1982,397),(1983,397),(1984,397),(1985,397),(1986,398),(1987,398),(1988,398),(1989,398),(1990,399),(1991,399),(1992,399),(1993,399),(1994,400),(1995,400),(1996,400),(1997,400),(1998,401),(1999,401),(2000,401),(2001,401),(2002,402),(2003,402),(2004,402),(2005,402),(2006,403),(2007,403),(2008,403),(2009,403),(2010,404),(2011,404),(2012,404),(2013,404),(2014,405),(2015,405),(2016,405),(2017,405),(2018,406),(2019,406),(2020,406),(2021,406),(2022,407),(2023,407),(2024,407),(2025,407),(2026,408),(2027,408),(2028,408),(2029,408),(2030,409),(2031,409),(2032,409),(2033,409),(2034,410),(2035,410),(2036,410),(2037,410),(2038,411),(2039,411),(2040,411),(2041,411),(2042,412),(2043,412),(2044,412),(2045,412),(2046,413),(2047,413),(2048,413),(2049,413),(2050,414),(2051,414),(2052,414),(2053,414),(2054,415),(2055,415),(2056,415),(2057,415),(2058,416),(2059,416),(2060,416),(2061,416),(2062,417),(2063,417),(2064,417),(2065,417),(2066,418),(2067,418),(2068,418),(2069,418),(2070,419),(2071,419),(2072,419),(2073,419),(2074,420),(2075,420),(2076,420),(2077,420),(2078,421),(2079,421),(2080,421),(2081,421),(2082,422),(2083,422),(2084,422),(2085,422),(2086,423),(2087,423),(2088,423),(2089,423),(2090,424),(2091,424),(2092,424),(2093,424),(2094,425),(2095,425),(2096,425),(2097,425),(2098,426),(2099,426),(2100,426),(2101,426),(2102,427),(2103,427),(2104,427),(2105,427),(2106,428),(2107,428),(2108,428),(2109,428),(2110,429),(2111,429),(2112,429),(2113,429),(2114,430),(2115,430),(2116,430),(2117,430),(2118,431),(2119,431),(2120,431),(2121,431),(2122,432),(2123,432),(2124,432),(2125,432),(2126,433),(2127,433),(2128,433),(2129,433),(2130,434),(2131,434),(2132,434),(2133,434),(2134,435),(2135,435),(2136,435),(2137,435),(2138,436),(2139,436),(2140,436),(2141,436),(2142,437),(2143,437),(2144,437),(2145,437),(2146,438),(2147,438),(2148,438),(2149,438),(2150,439),(2151,439),(2152,439),(2153,439),(2154,440),(2155,440),(2156,440),(2157,440),(2158,441),(2159,441),(2160,441),(2161,441),(2162,442),(2163,442),(2164,442),(2165,442),(2166,443),(2167,443),(2168,443),(2169,443),(2170,444),(2171,444),(2172,444),(2173,444),(2174,445),(2175,445),(2176,445),(2177,445),(2178,446),(2179,446),(2180,446),(2181,446),(2182,447),(2183,447),(2184,447),(2185,447),(2186,448),(2187,448),(2188,448),(2189,448),(2190,449),(2191,449),(2192,449),(2193,449),(2194,450),(2195,450),(2196,450),(2197,450),(2198,451),(2199,451),(2200,451),(2201,451),(2202,452),(2203,452),(2204,452),(2205,452),(2206,453),(2207,453),(2208,453),(2209,453),(2210,454),(2211,454),(2212,454),(2213,454),(2214,455),(2215,455),(2216,455),(2217,455),(2218,456),(2219,456),(2220,456),(2221,456),(2222,457),(2223,457),(2224,457),(2225,457),(2226,458),(2227,458),(2228,458),(2229,458),(2230,459),(2231,459),(2232,459),(2233,459),(2234,460),(2235,460),(2236,460),(2237,460),(2238,461),(2239,461),(2240,461),(2241,461),(2242,462),(2243,462),(2244,462),(2245,462),(2246,463),(2247,463),(2248,463),(2249,463),(2250,464),(2251,464),(2252,464),(2253,464),(2254,465),(2255,465),(2256,465),(2257,465),(2258,466),(2259,466),(2260,466),(2261,466),(2262,467),(2263,467),(2264,467),(2265,467),(2266,468),(2267,468),(2268,468),(2269,468),(2270,469),(2271,469),(2272,469),(2273,469),(2274,470),(2275,470),(2276,470),(2277,470),(2278,471),(2279,471),(2280,471),(2281,471),(2282,472),(2283,472),(2284,472),(2285,472),(2286,473),(2287,473),(2288,473),(2289,473),(2290,474),(2291,474),(2292,474),(2293,474),(2294,475),(2295,475),(2296,475),(2297,475),(2298,476),(2299,476),(2300,476),(2301,476),(2302,477),(2303,477),(2304,477),(2305,477),(2306,478),(2307,478),(2308,478),(2309,478),(2310,479),(2311,479),(2312,479),(2313,479),(2314,480),(2315,480),(2316,480),(2317,480),(2318,481),(2319,481),(2320,481),(2321,481),(2322,482),(2323,482),(2324,482),(2325,482),(2326,483),(2327,483),(2328,483),(2329,483),(2330,484),(2331,484),(2332,484),(2333,484),(2334,485),(2335,485),(2336,485),(2337,485),(2338,486),(2339,486),(2340,486),(2341,486),(2342,487),(2343,487),(2344,487),(2345,487),(2346,488),(2347,488),(2348,488),(2349,488),(2350,489),(2351,489),(2352,489),(2353,489),(2354,490),(2355,490),(2356,490),(2357,490),(2358,491),(2359,491),(2360,491),(2361,491),(2362,492),(2363,492),(2364,492),(2365,492),(2366,493),(2367,493),(2368,493),(2369,493),(2370,494),(2371,494),(2372,494),(2373,494),(2374,495),(2375,495),(2376,495),(2377,495),(2378,496),(2379,496),(2380,496),(2381,496),(2382,497),(2383,497),(2384,497),(2385,497),(2386,498),(2387,498),(2388,498),(2389,498),(2390,499),(2391,499),(2392,499),(2393,499),(2394,500),(2395,500),(2396,500),(2397,500),(2398,501),(2399,501),(2400,501),(2401,501),(2402,502),(2403,502),(2404,502),(2405,502),(2406,503),(2407,503),(2408,503),(2409,503),(2410,504),(2411,504),(2412,504),(2413,504),(2414,505),(2415,505),(2416,505),(2417,505),(2418,506),(2419,506),(2420,506),(2421,506),(2422,507),(2423,507),(2424,507),(2425,507),(2426,508),(2427,508),(2428,508),(2429,508),(2430,509),(2431,509),(2432,509),(2433,509),(2434,510),(2435,510),(2436,510),(2437,510),(2438,511),(2439,511),(2440,511),(2441,511),(2442,512),(2443,512),(2444,512),(2445,512),(2446,513),(2447,513),(2448,513),(2449,513),(2450,514),(2451,514),(2452,514),(2453,514),(2454,515),(2455,515),(2456,515),(2457,515),(2458,516),(2459,516),(2460,516),(2461,516),(2462,517),(2463,517),(2464,517),(2465,517),(2466,518),(2467,518),(2468,518),(2469,518),(2470,519),(2471,519),(2472,519),(2473,519),(2474,520),(2475,520),(2476,520),(2477,520),(2478,521),(2479,521),(2480,521),(2481,521),(2482,522),(2483,522),(2484,522),(2485,522),(2486,523),(2487,523),(2488,523),(2489,523),(2490,524),(2491,524),(2492,524),(2493,524),(2494,525),(2495,525),(2496,525),(2497,525),(2498,526),(2499,526),(2500,526),(2501,526),(2502,527),(2503,527),(2504,527),(2505,527),(2506,528),(2507,528),(2508,528),(2509,528),(2510,529),(2511,529),(2512,529),(2513,529),(2514,530),(2515,530),(2516,530),(2517,530),(2518,531),(2519,531),(2520,531),(2521,531),(2522,532),(2523,532),(2524,532),(2525,532),(2526,533),(2527,533),(2528,533),(2529,533),(2530,534),(2531,534),(2532,534),(2533,534),(2534,535),(2535,535),(2536,535),(2537,535),(2538,536),(2539,536),(2540,536),(2541,536),(2542,537),(2543,537),(2544,537),(2545,537),(2546,538),(2547,538),(2548,538),(2549,538),(2550,539),(2551,539),(2552,539),(2553,539),(2554,540),(2555,540),(2556,540),(2557,540),(2558,541),(2559,541),(2560,541),(2561,541),(2562,542),(2563,542),(2564,542),(2565,542),(2566,543),(2567,543),(2568,543),(2569,543),(2570,544),(2571,544),(2572,544),(2573,544),(2574,545),(2575,545),(2576,545),(2577,545),(2578,546),(2579,546),(2580,546),(2581,546),(2582,547),(2583,547),(2584,547),(2585,547),(2586,548),(2587,548),(2588,548),(2589,548),(2590,549),(2591,549),(2592,549),(2593,549),(2594,550),(2595,550),(2596,550),(2597,550),(2598,551),(2599,551),(2600,551),(2601,551),(2602,552),(2603,552),(2604,552),(2605,552),(2606,553),(2607,553),(2608,553),(2609,553),(2610,554),(2611,554),(2612,554),(2613,554),(2614,555),(2615,555),(2616,555),(2617,555),(2618,556),(2619,556),(2620,556),(2621,556),(2622,557),(2623,557),(2624,557),(2625,557),(2626,558),(2627,558),(2628,558),(2629,558),(2630,559),(2631,559),(2632,559),(2633,559),(2634,560),(2635,560),(2636,560),(2637,560),(2638,561),(2639,561),(2640,561),(2641,561),(2642,562),(2643,562),(2644,562),(2645,562),(2646,563),(2647,563),(2648,563),(2649,563),(2650,564),(2651,564),(2652,564),(2653,564),(2654,565),(2655,565),(2656,565),(2657,565),(2658,566),(2659,566),(2660,566),(2661,566),(2662,567),(2663,567),(2664,567),(2665,567),(2666,568),(2667,568),(2668,568),(2669,568),(2670,569),(2671,569),(2672,569),(2673,569),(2674,570),(2675,570),(2676,570),(2677,570),(2678,571),(2679,571),(2680,571),(2681,571),(2682,572),(2683,572),(2684,572),(2685,572),(2686,573),(2687,573),(2688,573),(2689,573),(2690,574),(2691,574),(2692,574),(2693,574),(2694,575),(2695,575),(2696,575),(2697,575),(2698,576),(2699,576),(2700,576),(2701,576),(2702,577),(2703,577),(2704,577),(2705,577),(2706,578),(2707,578),(2708,578),(2709,578),(2710,579),(2711,579),(2712,579),(2713,579),(2714,580),(2715,580),(2716,580),(2717,580),(2718,581),(2719,581),(2720,581),(2721,581),(2722,582),(2723,582),(2724,582),(2725,582),(2726,583),(2727,583),(2728,583),(2729,583),(2730,584),(2731,584),(2732,584),(2733,584),(2734,585),(2735,585),(2736,585),(2737,585),(2738,586),(2739,586),(2740,586),(2741,586),(2742,587),(2743,587),(2744,587),(2745,587),(2746,588),(2747,588),(2748,588),(2749,588),(2750,589),(2751,589),(2752,589),(2753,589),(2754,590),(2755,590),(2756,590),(2757,590),(2758,591),(2759,591),(2760,591),(2761,591),(2762,592),(2763,592),(2764,592),(2765,592),(2766,593),(2767,593),(2768,593),(2769,593),(2770,594),(2771,594),(2772,594),(2773,594),(2774,595),(2775,595),(2776,595),(2777,595),(2778,596),(2779,596),(2780,596),(2781,596),(2782,597),(2783,597),(2784,597),(2785,597),(2786,598),(2787,598),(2788,598),(2789,598),(2790,599),(2791,599),(2792,599),(2793,599),(2794,600),(2795,600),(2796,600),(2797,600),(2798,601),(2799,601),(2800,601),(2801,601),(2802,602),(2803,602),(2804,602),(2805,602),(2806,603),(2807,603),(2808,603),(2809,603),(2810,604),(2811,604),(2812,604),(2813,604),(2814,605),(2815,605),(2816,605),(2817,605),(2818,606),(2819,606),(2820,606),(2821,606),(2822,607),(2823,607),(2824,607),(2825,607),(2826,608),(2827,608),(2828,608),(2829,608),(2830,609),(2831,609),(2832,609),(2833,609),(2834,610),(2835,610),(2836,610),(2837,610),(2838,611),(2839,611),(2840,611),(2841,611),(2842,612),(2843,612),(2844,612),(2845,612),(2846,613),(2847,613),(2848,613),(2849,613),(2850,614),(2851,614),(2852,614),(2853,614),(2854,615),(2855,615),(2856,615),(2857,615),(2858,616),(2859,616),(2860,616),(2861,616),(2862,617),(2863,617),(2864,617),(2865,617),(2866,618),(2867,618),(2868,618),(2869,618),(2870,619),(2871,619),(2872,619),(2873,619),(2874,620),(2875,620),(2876,620),(2877,620),(2878,621),(2879,621),(2880,621),(2881,621),(2882,622),(2883,622),(2884,622),(2885,622),(2886,623),(2887,623),(2888,623),(2889,623),(2890,624),(2891,624),(2892,624),(2893,624),(2894,625),(2895,625),(2896,625),(2897,625),(2898,626),(2899,626),(2900,626),(2901,626),(2902,627),(2903,627),(2904,627),(2905,627),(2906,628),(2907,628),(2908,628),(2909,628),(2910,629),(2911,629),(2912,629),(2913,629),(2914,630),(2915,630),(2916,630),(2917,630),(2918,631),(2919,631),(2920,631),(2921,631),(2922,632),(2923,632),(2924,632),(2925,632),(2926,633),(2927,633),(2928,633),(2929,633),(2930,634),(2931,634),(2932,634),(2933,634),(2934,635),(2935,635),(2936,635),(2937,635),(2938,636),(2939,636),(2940,636),(2941,636),(2942,637),(2943,637),(2944,637),(2945,637),(2946,638),(2947,638),(2948,638),(2949,638),(2950,639),(2951,639),(2952,639),(2953,639),(2954,640),(2955,640),(2956,640),(2957,640),(2958,641),(2959,641),(2960,641),(2961,641),(2962,642),(2963,642),(2964,642),(2965,642),(2966,643),(2967,643),(2968,643),(2969,643),(2970,644),(2971,644),(2972,644),(2973,644),(2974,645),(2975,645),(2976,645),(2977,645),(2978,646),(2979,646),(2980,646),(2981,646),(2982,647),(2983,647),(2984,647),(2985,647),(2986,648),(2987,648),(2988,648),(2989,648),(2990,649),(2991,649),(2992,649),(2993,649),(2994,650),(2995,650),(2996,650),(2997,650),(2998,651),(2999,651),(3000,651),(3001,651),(3002,652),(3003,652),(3004,652),(3005,652),(3006,653),(3007,653),(3008,653),(3009,653),(3010,654),(3011,654),(3012,654),(3013,654),(3014,655),(3015,655),(3016,655),(3017,655),(3018,656),(3019,656),(3020,656),(3021,656),(3022,657),(3023,657),(3024,657),(3025,657),(3026,658),(3027,658),(3028,658),(3029,658),(3030,659),(3031,659),(3032,659),(3033,659),(3034,660),(3035,660),(3036,660),(3037,660),(3038,661),(3039,661),(3040,661),(3041,661),(3042,662),(3043,662),(3044,662),(3045,662),(3046,663),(3047,663),(3048,663),(3049,663),(3050,664),(3051,664),(3052,664),(3053,664),(3054,665),(3055,665),(3056,665),(3057,665),(3058,666),(3059,666),(3060,666),(3061,666),(3062,667),(3063,667),(3064,667),(3065,667),(3066,668),(3067,668),(3068,668),(3069,668),(3070,669),(3071,669),(3072,669),(3073,669),(3074,670),(3075,670),(3076,670),(3077,670),(3078,671),(3079,671),(3080,671),(3081,671),(3082,672),(3083,672),(3084,672),(3085,672),(3086,673),(3087,673),(3088,673),(3089,673),(3090,674),(3091,674),(3092,674),(3093,674),(3094,675),(3095,675),(3096,675),(3097,675),(3098,676),(3099,676),(3100,676),(3101,676),(3102,677),(3103,677),(3104,677),(3105,677),(3106,678),(3107,678),(3108,678),(3109,678),(3110,679),(3111,679),(3112,679),(3113,679),(3114,680),(3115,680),(3116,680),(3117,680),(3118,681),(3119,681),(3120,681),(3121,681),(3122,682),(3123,682),(3124,682),(3125,682),(3126,683),(3127,683),(3128,683),(3129,683),(3130,684),(3131,684),(3132,684),(3133,684),(3134,685),(3135,685),(3136,685),(3137,685),(3138,686),(3139,686),(3140,686),(3141,686),(3142,687),(3143,687),(3144,687),(3145,687),(3146,688),(3147,688),(3148,688),(3149,688),(3150,689),(3151,689),(3152,689),(3153,689),(3154,690),(3155,690),(3156,690),(3157,690),(3158,691),(3159,691),(3160,691),(3161,691),(3162,692),(3163,692),(3164,692),(3165,692),(3166,693),(3167,693),(3168,693),(3169,693),(3170,694),(3171,694),(3172,694),(3173,694),(3174,695),(3175,695),(3176,695),(3177,695),(3178,696),(3179,696),(3180,696),(3181,696),(3182,697),(3183,697),(3184,697),(3185,697),(3186,698),(3187,698),(3188,698),(3189,698),(3190,699),(3191,699),(3192,699),(3193,699),(3194,700),(3195,700),(3196,700),(3197,700),(3198,701),(3199,701),(3200,701),(3201,701),(3202,702),(3203,702),(3204,702),(3205,702),(3206,703),(3207,703),(3208,703),(3209,703),(3210,704),(3211,704),(3212,704),(3213,704),(3214,705),(3215,705),(3216,705),(3217,705),(3218,706),(3219,706),(3220,706),(3221,706),(3222,707),(3223,707),(3224,707),(3225,707),(3226,708),(3227,708),(3228,708),(3229,708),(3230,709),(3231,709),(3232,709),(3233,709),(3234,710),(3235,710),(3236,710),(3237,710),(3238,711),(3239,711),(3240,711),(3241,711),(3242,712),(3243,712),(3244,712),(3245,712),(3246,713),(3247,713),(3248,713),(3249,713),(3250,714),(3251,714),(3252,714),(3253,714),(3254,715),(3255,715),(3256,715),(3257,715),(3258,716),(3259,716),(3260,716),(3261,716),(3262,717),(3263,717),(3264,717),(3265,717),(3266,718),(3267,718),(3268,718),(3269,718),(3270,719),(3271,719),(3272,719),(3273,719),(3274,720),(3275,720),(3276,720),(3277,720),(3278,721),(3279,721),(3280,721),(3281,721),(3282,722),(3283,722),(3284,722),(3285,722),(3286,723),(3287,723),(3288,723),(3289,723),(3290,724),(3291,724),(3292,724),(3293,724),(3294,725),(3295,725),(3296,725),(3297,725),(3298,726),(3299,726),(3300,726),(3301,726),(3302,727),(3303,727),(3304,727),(3305,727),(3306,728),(3307,728),(3308,728),(3309,728),(3310,729),(3311,729),(3312,729),(3313,729),(3314,730),(3315,730),(3316,730),(3317,730),(3318,731),(3319,731),(3320,731),(3321,731),(3322,732),(3323,732),(3324,732),(3325,732),(3326,733),(3327,733),(3328,733),(3329,733),(3330,734),(3331,734),(3332,734),(3333,734),(3334,735),(3335,735),(3336,735),(3337,735),(3338,736),(3339,736),(3340,736),(3341,736),(3342,737),(3343,737),(3344,737),(3345,737),(3346,738),(3347,738),(3348,738),(3349,738),(3350,739),(3351,739),(3352,739),(3353,739),(3354,740),(3355,740),(3356,740),(3357,740),(3358,741),(3359,741),(3360,741),(3361,741),(3362,742),(3363,742),(3364,742),(3365,742),(3366,743),(3367,743),(3368,743),(3369,743),(3370,744),(3371,744),(3372,744),(3373,744),(3374,745),(3375,745),(3376,745),(3377,745),(3378,746),(3379,746),(3380,746),(3381,746),(3382,747),(3383,747),(3384,747),(3385,747),(3386,748),(3387,748),(3388,748),(3389,748),(3390,749),(3391,749),(3392,749),(3393,749),(3394,750),(3395,750),(3396,750),(3397,750),(3398,751),(3399,751),(3400,751),(3401,751),(3402,752),(3403,752),(3404,752),(3405,752),(3406,753),(3407,753),(3408,753),(3409,753),(3410,754),(3411,754),(3412,754),(3413,754),(3414,755),(3415,755),(3416,755),(3417,755),(3418,756),(3419,756),(3420,756),(3421,756),(3422,757),(3423,757),(3424,757),(3425,757),(3426,758),(3427,758),(3428,758),(3429,758),(3430,759),(3431,759),(3432,759),(3433,759),(3434,760),(3435,760),(3436,760),(3437,760),(3438,761),(3439,761),(3440,761),(3441,761),(3442,762),(3443,762),(3444,762),(3445,762),(3446,763),(3447,763),(3448,763),(3449,763),(3450,764),(3451,764),(3452,764),(3453,764),(3454,765),(3455,765),(3456,765),(3457,765),(3458,766),(3459,766),(3460,766),(3461,766),(3462,767),(3463,767),(3464,767),(3465,767),(3466,768),(3467,768),(3468,768),(3469,768),(3470,769),(3471,769),(3472,769),(3473,769),(3474,770),(3475,770),(3476,770),(3477,770),(3478,771),(3479,771),(3480,771),(3481,771),(3482,772),(3483,772),(3484,772),(3485,772),(3486,773),(3487,773),(3488,773),(3489,773),(3490,774),(3491,774),(3492,774),(3493,774),(3494,775),(3495,775),(3496,775),(3497,775),(3498,776),(3499,776),(3500,776),(3501,776),(3502,777),(3503,777),(3504,777),(3505,777),(3506,778),(3507,778),(3508,778),(3509,778),(3510,779),(3511,779),(3512,779),(3513,779),(3514,780),(3515,780),(3516,780),(3517,780),(3518,781),(3519,781),(3520,781),(3521,781),(3522,782),(3523,782),(3524,782),(3525,782),(3526,783),(3527,783),(3528,783),(3529,783),(3530,784),(3531,784),(3532,784),(3533,784),(3534,785),(3535,785),(3536,785),(3537,785),(3538,786),(3539,786),(3540,786),(3541,786),(3542,787),(3543,787),(3544,787),(3545,787),(3546,788),(3547,788),(3548,788),(3549,788),(3550,789),(3551,789),(3552,789),(3553,789),(3554,790),(3555,790),(3556,790),(3557,790),(3558,791),(3559,791),(3560,791),(3561,791),(3562,792),(3563,792),(3564,792),(3565,792),(3566,793),(3567,793),(3568,793),(3569,793),(3570,794),(3571,794),(3572,794),(3573,794),(3574,795),(3575,795),(3576,795),(3577,795),(3578,796),(3579,796),(3580,796),(3581,796),(3582,797),(3583,797),(3584,797),(3585,797),(3586,798),(3587,798),(3588,798),(3589,798),(3590,799),(3591,799),(3592,799),(3593,799),(3594,800),(3595,800),(3596,800),(3597,800),(3598,801),(3599,801),(3600,801),(3601,801),(3602,802),(3603,802),(3604,802),(3605,802),(3606,803),(3607,803),(3608,803),(3609,803),(3610,804),(3611,804),(3612,804),(3613,804),(3614,805),(3615,805),(3616,805),(3617,805),(3618,806),(3619,806),(3620,806),(3621,806),(3622,807),(3623,807),(3624,807),(3625,807),(3626,808),(3627,808),(3628,808),(3629,808),(3630,809),(3631,809),(3632,809),(3633,809),(3634,810),(3635,810),(3636,810),(3637,810),(3638,811),(3639,811),(3640,811),(3641,811),(3642,812),(3643,812),(3644,812),(3645,812),(3646,813),(3647,813),(3648,813),(3649,813),(3650,814),(3651,814),(3652,814),(3653,814),(3654,815),(3655,815),(3656,815),(3657,815),(3658,816),(3659,816),(3660,816),(3661,816),(3662,817),(3663,817),(3664,817),(3665,817),(3666,818),(3667,818),(3668,818),(3669,818),(3670,819),(3671,819),(3672,819),(3673,819),(3674,820),(3675,820),(3676,820),(3677,820),(3678,821),(3679,821),(3680,821),(3681,821),(3682,822),(3683,822),(3684,822),(3685,822),(3686,823),(3687,823),(3688,823),(3689,823),(3690,824),(3691,824),(3692,824),(3693,824),(3694,825),(3695,825),(3696,825),(3697,825),(3698,826),(3699,826),(3700,826),(3701,826),(3702,827),(3703,827),(3704,827),(3705,827),(3706,828),(3707,828),(3708,828),(3709,828),(3710,829),(3711,829),(3712,829),(3713,829),(3714,830),(3715,830),(3716,830),(3717,830),(3718,831),(3719,831),(3720,831),(3721,831),(3722,832),(3723,832),(3724,832),(3725,832),(3726,833),(3727,833),(3728,833),(3729,833),(3730,834),(3731,834),(3732,834),(3733,834),(3734,835),(3735,835),(3736,835),(3737,835),(3738,836),(3739,836),(3740,836),(3741,836),(3742,837),(3743,837),(3744,837),(3745,837),(3746,838),(3747,838),(3748,838),(3749,838),(3750,839),(3751,839),(3752,839),(3753,839),(3754,840),(3755,840),(3756,840),(3757,840),(3758,841),(3759,841),(3760,841),(3761,841),(3762,842),(3763,842),(3764,842),(3765,842),(3766,843),(3767,843),(3768,843),(3769,843),(3770,844),(3771,844),(3772,844),(3773,844),(3774,845),(3775,845),(3776,845),(3777,845),(3778,846),(3779,846),(3780,846),(3781,846),(3782,847),(3783,847),(3784,847),(3785,847),(3786,848),(3787,848),(3788,848),(3789,848),(3790,849),(3791,849),(3792,849),(3793,849),(3794,850),(3795,850),(3796,850),(3797,850),(3798,851),(3799,851),(3800,851),(3801,851),(3802,852),(3803,852),(3804,852),(3805,852),(3806,853),(3807,853),(3808,853),(3809,853),(3810,854),(3811,854),(3812,854),(3813,854),(3814,855),(3815,855),(3816,855),(3817,855),(3818,856),(3819,856),(3820,856),(3821,856),(3822,857),(3823,857),(3824,857),(3825,857),(3826,858),(3827,858),(3828,858),(3829,858),(3830,859),(3831,859),(3832,859),(3833,859),(3834,860),(3835,860),(3836,860),(3837,860),(3838,861),(3839,861),(3840,861),(3841,861),(3842,862),(3843,862),(3844,862),(3845,862),(3846,863),(3847,863),(3848,863),(3849,863),(3850,864),(3851,864),(3852,864),(3853,864),(3854,865),(3855,865),(3856,865),(3857,865),(3858,866),(3859,866),(3860,866),(3861,866),(3862,867),(3863,867),(3864,867),(3865,867),(3866,868),(3867,868),(3868,868),(3869,868),(3870,869),(3871,869),(3872,869),(3873,869),(3874,870),(3875,870),(3876,870),(3877,870),(3878,871),(3879,871),(3880,871),(3881,871),(3882,872),(3883,872),(3884,872),(3885,872),(3886,873),(3887,873),(3888,873),(3889,873),(3890,874),(3891,874),(3892,874),(3893,874),(3894,875),(3895,875),(3896,875),(3897,875),(3898,876),(3899,876),(3900,876),(3901,876),(3902,877),(3903,877),(3904,877),(3905,877),(3906,878),(3907,878),(3908,878),(3909,878),(3910,879),(3911,879),(3912,879),(3913,879),(3914,880),(3915,880),(3916,880),(3917,880),(3918,881),(3919,881),(3920,881),(3921,881),(3922,882),(3923,882),(3924,882),(3925,882),(3926,883),(3927,883),(3928,883),(3929,883),(3930,884),(3931,884),(3932,884),(3933,884),(3934,885),(3935,885),(3936,885),(3937,885),(3938,886),(3939,886),(3940,886),(3941,886),(3942,887),(3943,887),(3944,887),(3945,887),(3946,888),(3947,888),(3948,888),(3949,888),(3950,889),(3951,889),(3952,889),(3953,889),(3954,890),(3955,890),(3956,890),(3957,890),(3958,891),(3959,891),(3960,891),(3961,891),(3962,892),(3963,892),(3964,892),(3965,892),(3966,893),(3967,893),(3968,893),(3969,893),(3970,894),(3971,894),(3972,894),(3973,894),(3974,895),(3975,895),(3976,895),(3977,895),(3978,896),(3979,896),(3980,896),(3981,896),(3982,897),(3983,897),(3984,897),(3985,897),(3986,898),(3987,898),(3988,898),(3989,898),(3990,899),(3991,899),(3992,899),(3993,899),(3994,900),(3995,900),(3996,900),(3997,900),(3998,901),(3999,901),(4000,901),(4001,901),(4002,902),(4003,902),(4004,902),(4005,902),(4006,903),(4007,903),(4008,903),(4009,903),(4010,904),(4011,904),(4012,904),(4013,904),(4014,905),(4015,905),(4016,905),(4017,905),(4018,906),(4019,906),(4020,906),(4021,906),(4022,907),(4023,907),(4024,907),(4025,907),(4026,908),(4027,908),(4028,908),(4029,908),(4030,909),(4031,909),(4032,909),(4033,909),(4034,910),(4035,910),(4036,910),(4037,910),(4038,911),(4039,911),(4040,911),(4041,911),(4042,912),(4043,912),(4044,912),(4045,912),(4046,913),(4047,913),(4048,913),(4049,913),(4050,914),(4051,914),(4052,914),(4053,914),(4054,915),(4055,915),(4056,915),(4057,915),(4058,916),(4059,916),(4060,916),(4061,916),(4062,917),(4063,917),(4064,917),(4065,917),(4066,918),(4067,918),(4068,918),(4069,918),(4070,919),(4071,919),(4072,919),(4073,919),(4074,920),(4075,920),(4076,920),(4077,920),(4078,921),(4079,921),(4080,921),(4081,921),(4082,922),(4083,922),(4084,922),(4085,922),(4086,923),(4087,923),(4088,923),(4089,923),(4090,924),(4091,924),(4092,924),(4093,924),(4094,925),(4095,925),(4096,925),(4097,925),(4098,926),(4099,926),(4100,926),(4101,926),(4102,927),(4103,927),(4104,927),(4105,927),(4106,928),(4107,928),(4108,928),(4109,928),(4110,929),(4111,929),(4112,929),(4113,929),(4114,930),(4115,930),(4116,930),(4117,930),(4118,931),(4119,931),(4120,931),(4121,931),(4122,932),(4123,932),(4124,932),(4125,932),(4126,933),(4127,933),(4128,933),(4129,933),(4130,934),(4131,934),(4132,934),(4133,934),(4134,935),(4135,935),(4136,935),(4137,935),(4138,936),(4139,936),(4140,936),(4141,936),(4142,937),(4143,937),(4144,937),(4145,937),(4146,938),(4147,938),(4148,938),(4149,938),(4150,939),(4151,939),(4152,939),(4153,939),(4154,940),(4155,940),(4156,940),(4157,940),(4158,941),(4159,941),(4160,941),(4161,941),(4162,942),(4163,942),(4164,942),(4165,942),(4166,943),(4167,943),(4168,943),(4169,943),(4170,944),(4171,944),(4172,944),(4173,944),(4174,945),(4175,945),(4176,945),(4177,945),(4178,946),(4179,946),(4180,946),(4181,946),(4182,947),(4183,947),(4184,947),(4185,947),(4186,948),(4187,948),(4188,948),(4189,948),(4190,949),(4191,949),(4192,949),(4193,949),(4194,950),(4195,950),(4196,950),(4197,950),(4198,951),(4199,951),(4200,951),(4201,951),(4202,952),(4203,952),(4204,952),(4205,952),(4206,953),(4207,953),(4208,953),(4209,953),(4210,954),(4211,954),(4212,954),(4213,954),(4214,955),(4215,955),(4216,955),(4217,955),(4218,956),(4219,956),(4220,956),(4221,956),(4222,957),(4223,957),(4224,957),(4225,957),(4226,958),(4227,958),(4228,958),(4229,958),(4230,959),(4231,959),(4232,959),(4233,959),(4234,960),(4235,960),(4236,960),(4237,960),(4238,961),(4239,961),(4240,961),(4241,961),(4242,962),(4243,962),(4244,962),(4245,962),(4246,963),(4247,963),(4248,963),(4249,963),(4250,964),(4251,964),(4252,964),(4253,964),(4254,965),(4255,965),(4256,965),(4257,965),(4258,966),(4259,966),(4260,966),(4261,966),(4262,967),(4263,967),(4264,967),(4265,967),(4266,968),(4267,968),(4268,968),(4269,968),(4270,969),(4271,969),(4272,969),(4273,969),(4274,970),(4275,970),(4276,970),(4277,970),(4278,971),(4279,971),(4280,971),(4281,971),(4282,972),(4283,972),(4284,972),(4285,972),(4286,973),(4287,973),(4288,973),(4289,973),(4290,974),(4291,974),(4292,974),(4293,974),(4294,975),(4295,975),(4296,975),(4297,975),(4298,976),(4299,976),(4300,976),(4301,976),(4302,977),(4303,977),(4304,977),(4305,977),(4306,978),(4307,978),(4308,978),(4309,978),(4310,979),(4311,979),(4312,979),(4313,979),(4314,980),(4315,980),(4316,980),(4317,980),(4318,981),(4319,981),(4320,981),(4321,981),(4322,982),(4323,982),(4324,982),(4325,982),(4326,983),(4327,983),(4328,983),(4329,983),(4330,984),(4331,984),(4332,984),(4333,984),(4334,985),(4335,985),(4336,985),(4337,985),(4338,986),(4339,986),(4340,986),(4341,986),(4342,987),(4343,987),(4344,987),(4345,987),(4346,988),(4347,988),(4348,988),(4349,988),(4350,989),(4351,989),(4352,989),(4353,989),(4354,990),(4355,990),(4356,990),(4357,990),(4358,991),(4359,991),(4360,991),(4361,991),(4362,992),(4363,992),(4364,992),(4365,992),(4366,993),(4367,993),(4368,993),(4369,993),(4370,994),(4371,994),(4372,994),(4373,994),(4374,995),(4375,995),(4376,995),(4377,995),(4378,996),(4379,996),(4380,996),(4381,996),(4382,997),(4383,997),(4384,997),(4385,997),(4386,998),(4387,998),(4388,998),(4389,998),(4390,999),(4391,999),(4392,999),(4393,999),(4394,1000),(4395,1000),(4396,1000),(4397,1000),(4398,1001),(4399,1001),(4400,1001),(4401,1001),(4402,1002),(4403,1002),(4404,1002),(4405,1002),(4406,1003),(4407,1003),(4408,1003),(4409,1003),(4410,1004),(4411,1004),(4412,1004),(4413,1004),(4414,1005),(4415,1005),(4416,1005),(4417,1005),(4418,1006),(4419,1006),(4420,1006),(4421,1006),(4422,1007),(4423,1007),(4424,1007),(4425,1007),(4426,1008),(4427,1008),(4428,1008),(4429,1008),(4430,1009),(4431,1009),(4432,1009),(4433,1009),(4434,1010),(4435,1010),(4436,1010),(4437,1010),(4438,1011),(4439,1011),(4440,1011),(4441,1011),(4442,1012),(4443,1012),(4444,1012),(4445,1012),(4446,1013),(4447,1013),(4448,1013),(4449,1013),(4450,1014),(4451,1014),(4452,1014),(4453,1014),(4454,1015),(4455,1015),(4456,1015),(4457,1015),(4458,1016),(4459,1016),(4460,1016),(4461,1016),(4462,1017),(4463,1017),(4464,1017),(4465,1017),(4466,1018),(4467,1018),(4468,1018),(4469,1018),(4470,1019),(4471,1019),(4472,1019),(4473,1019),(4474,1020),(4475,1020),(4476,1020),(4477,1020),(4478,1021),(4479,1021),(4480,1021),(4481,1021),(4482,1022),(4483,1022),(4484,1022),(4485,1022),(4486,1023),(4487,1023),(4488,1023),(4489,1023),(4490,1024),(4491,1024),(4492,1024),(4493,1024),(4494,1025),(4495,1025),(4496,1025),(4497,1025),(4498,1026),(4499,1026),(4500,1026),(4501,1026),(4502,1027),(4503,1027),(4504,1027),(4505,1027),(4506,1028),(4507,1028),(4508,1028),(4509,1028),(4510,1029),(4511,1029),(4512,1029),(4513,1029),(4514,1030),(4515,1030),(4516,1030),(4517,1030),(4518,1031),(4519,1031),(4520,1031),(4521,1031),(4522,1032),(4523,1032),(4524,1032),(4525,1032),(4526,1033),(4527,1033),(4528,1033),(4529,1033),(4530,1034),(4531,1034),(4532,1034),(4533,1034),(4534,1035),(4535,1035),(4536,1035),(4537,1035),(4538,1036),(4539,1036),(4540,1036),(4541,1036),(4542,1037),(4543,1037),(4544,1037),(4545,1037),(4546,1038),(4547,1038),(4548,1038),(4549,1038),(4550,1039),(4551,1039),(4552,1039),(4553,1039),(4554,1040),(4555,1040),(4556,1040),(4557,1040),(4558,1041),(4559,1041),(4560,1041),(4561,1041),(4562,1042),(4563,1042),(4564,1042),(4565,1042),(4566,1043),(4567,1043),(4568,1043),(4569,1043),(4570,1044),(4571,1044),(4572,1044),(4573,1044),(4574,1045),(4575,1045),(4576,1045),(4577,1045),(4578,1046),(4579,1046),(4580,1046),(4581,1046),(4582,1047),(4583,1047),(4584,1047),(4585,1047),(4586,1048),(4587,1048),(4588,1048),(4589,1048),(4590,1049),(4591,1049),(4592,1049),(4593,1049),(4594,1050),(4595,1050),(4596,1050),(4597,1050),(4598,1051),(4599,1051),(4600,1051),(4601,1051),(4602,1052),(4603,1052),(4604,1052),(4605,1052),(4606,1053),(4607,1053),(4608,1053),(4609,1053),(4610,1054),(4611,1054),(4612,1054),(4613,1054),(4614,1055),(4615,1055),(4616,1055),(4617,1055),(4618,1056),(4619,1056),(4620,1056),(4621,1056),(4622,1057),(4623,1057),(4624,1057),(4625,1057),(4626,1058),(4627,1058),(4628,1058),(4629,1058),(4630,1059),(4631,1059),(4632,1059),(4633,1059),(4634,1060),(4635,1060),(4636,1060),(4637,1060),(4638,1061),(4639,1061),(4640,1061),(4641,1061),(4642,1062),(4643,1062),(4644,1062),(4645,1062),(4646,1063),(4647,1063),(4648,1063),(4649,1063),(4650,1064),(4651,1064),(4652,1064),(4653,1064),(4654,1065),(4655,1065),(4656,1065),(4657,1065),(4658,1066),(4659,1066),(4660,1066),(4661,1066),(4662,1067),(4663,1067),(4664,1067),(4665,1067),(4666,1068),(4667,1068),(4668,1068),(4669,1068),(4670,1069),(4671,1069),(4672,1069),(4673,1069),(4674,1070),(4675,1070),(4676,1070),(4677,1070),(4678,1071),(4679,1071),(4680,1071),(4681,1071),(4682,1072),(4683,1072),(4684,1072),(4685,1072),(4686,1073),(4687,1073),(4688,1073),(4689,1073),(4690,1074),(4691,1074),(4692,1074),(4693,1074),(4694,1075),(4695,1075),(4696,1075),(4697,1075),(4698,1076),(4699,1076),(4700,1076),(4701,1076),(4702,1077),(4703,1077),(4704,1077),(4705,1077),(4706,1078),(4707,1078),(4708,1078),(4709,1078),(4710,1079),(4711,1079),(4712,1079),(4713,1079),(4714,1080),(4715,1080),(4716,1080),(4717,1080),(4718,1081),(4719,1081),(4720,1081),(4721,1081),(4722,1082),(4723,1082),(4724,1082),(4725,1082),(4726,1083),(4727,1083),(4728,1083),(4729,1083),(4730,1084),(4731,1084),(4732,1084),(4733,1084),(4734,1085),(4735,1085),(4736,1085),(4737,1085),(4738,1086),(4739,1086),(4740,1086),(4741,1086),(4742,1087),(4743,1087),(4744,1087),(4745,1087),(4746,1088),(4747,1088),(4748,1088),(4749,1088),(4750,1089),(4751,1089),(4752,1089),(4753,1089),(4754,1090),(4755,1090),(4756,1090),(4757,1090),(4758,1091),(4759,1091),(4760,1091),(4761,1091),(4762,1092),(4763,1092),(4764,1092),(4765,1092),(4766,1093),(4767,1093),(4768,1093),(4769,1093),(4770,1094),(4771,1094),(4772,1094),(4773,1094),(4774,1095),(4775,1095),(4776,1095),(4777,1095),(4778,1096),(4779,1096),(4780,1096),(4781,1096),(4782,1097),(4783,1097),(4784,1097),(4785,1097),(4786,1098),(4787,1098),(4788,1098),(4789,1098),(4790,1099),(4791,1099),(4792,1099),(4793,1099),(4794,1100),(4795,1100),(4796,1100),(4797,1100),(4798,1101),(4799,1101),(4800,1101),(4801,1101),(4802,1102),(4803,1102),(4804,1102),(4805,1102),(4806,1103),(4807,1103),(4808,1103),(4809,1103),(4810,1104),(4811,1104),(4812,1104),(4813,1104),(4814,1105),(4815,1105),(4816,1105),(4817,1105),(4818,1106),(4819,1106),(4820,1106),(4821,1106),(4822,1107),(4823,1107),(4824,1107),(4825,1107),(4826,1108),(4827,1108),(4828,1108),(4829,1108),(4830,1109),(4831,1109),(4832,1109),(4833,1109),(4834,1110),(4835,1110),(4836,1110),(4837,1110),(4838,1111),(4839,1111),(4840,1111),(4841,1111),(4842,1112),(4843,1112),(4844,1112),(4845,1112),(4846,1113),(4847,1113),(4848,1113),(4849,1113),(4850,1114),(4851,1114),(4852,1114),(4853,1114),(4854,1115),(4855,1115),(4856,1115),(4857,1115),(4858,1116),(4859,1116),(4860,1116),(4861,1116),(4862,1117),(4863,1117),(4864,1117),(4865,1117),(4866,1118),(4867,1118),(4868,1118),(4869,1118),(4870,1119),(4871,1119),(4872,1119),(4873,1119),(4874,1120),(4875,1120),(4876,1120),(4877,1120),(4878,1121),(4879,1121),(4880,1121),(4881,1121),(4882,1122),(4883,1122),(4884,1122),(4885,1122),(4886,1123),(4887,1123),(4888,1123),(4889,1123),(4890,1124),(4891,1124),(4892,1124),(4893,1124),(4894,1125),(4895,1125),(4896,1125),(4897,1125),(4898,1126),(4899,1126),(4900,1126),(4901,1126),(4902,1127),(4903,1127),(4904,1127),(4905,1127),(4906,1128),(4907,1128),(4908,1128),(4909,1128),(4910,1129),(4911,1129),(4912,1129),(4913,1129),(4914,1130),(4915,1130),(4916,1130),(4917,1130),(4918,1131),(4919,1131),(4920,1131),(4921,1131),(4922,1132),(4923,1132),(4924,1132),(4925,1132),(4926,1133),(4927,1133),(4928,1133),(4929,1133),(4930,1134),(4931,1134),(4932,1134),(4933,1134),(4934,1135),(4935,1135),(4936,1135),(4937,1135),(4938,1136),(4939,1136),(4940,1136),(4941,1136),(4942,1137),(4943,1137),(4944,1137),(4945,1137),(4946,1138),(4947,1138),(4948,1138),(4949,1138),(4950,1139),(4951,1139),(4952,1139),(4953,1139),(4954,281),(4955,282),(4956,283),(4957,284),(4958,285),(4959,286),(4960,287),(4961,288),(4962,289),(4963,290),(4964,291),(4965,292),(4966,293),(4967,294),(4968,295),(4969,296),(4970,297),(4971,298),(4972,299),(4973,300),(4974,301),(4975,302),(4976,303),(4977,304),(4978,305),(4979,306),(4980,307),(4981,308),(4982,309),(4983,310),(4984,311),(4985,312),(4986,313),(4987,314),(4988,315),(4989,316),(4990,317),(4991,318),(4992,319),(4993,320),(4994,321),(4995,322),(4996,323),(4997,324),(4998,325),(4999,326),(5000,327),(5001,328),(5002,329),(5003,330),(5004,331),(5005,332),(5006,333),(5007,334),(5008,335),(5009,336),(5010,337),(5011,338),(5012,339),(5013,340),(5014,341),(5015,342),(5016,343),(5017,344),(5018,345),(5019,346),(5020,347),(5021,348),(5022,349),(5023,350),(5024,351),(5025,352),(5026,353),(5027,354),(5028,355),(5029,356),(5030,357),(5031,358),(5032,359),(5033,360),(5034,361),(5035,362),(5036,363),(5037,364),(5038,365),(5039,366),(5040,367),(5041,368),(5042,369),(5043,370),(5044,371),(5045,372),(5046,373),(5047,374),(5048,375),(5049,376),(5050,377),(5051,378),(5052,379),(5053,380),(5054,381),(5055,382),(5056,383),(5057,384),(5058,385),(5059,386),(5060,387),(5061,388),(5062,389),(5063,390),(5064,391),(5065,392),(5066,393),(5067,394),(5068,395),(5069,396),(5070,397),(5071,398),(5072,399),(5073,400),(5074,401),(5075,402),(5076,403),(5077,404),(5078,405),(5079,406),(5080,407),(5081,408),(5082,409),(5083,410),(5084,411),(5085,412),(5086,413),(5087,414),(5088,415),(5089,416),(5090,417),(5091,418),(5092,419),(5093,420),(5094,421),(5095,422),(5096,423),(5097,424),(5098,425),(5099,426),(5100,427),(5101,428),(5102,429),(5103,430),(5104,431),(5105,432),(5106,433),(5107,434),(5108,435),(5109,436),(5110,437),(5111,438),(5112,439),(5113,440),(5114,441),(5115,442),(5116,443),(5117,444),(5118,445),(5119,446),(5120,447),(5121,448),(5122,449),(5123,450),(5124,451),(5125,452),(5126,453),(5127,454),(5128,455),(5129,456),(5130,457),(5131,458),(5132,459),(5133,460),(5134,461),(5135,462),(5136,463),(5137,464),(5138,465),(5139,466),(5140,467),(5141,468),(5142,469),(5143,470),(5144,471),(5145,472),(5146,473),(5147,474),(5148,475),(5149,476),(5150,477),(5151,478),(5152,479),(5153,480),(5154,481),(5155,482),(5156,483),(5157,484),(5158,485),(5159,486),(5160,487),(5161,488),(5162,489),(5163,490),(5164,491),(5165,492),(5166,493),(5167,494),(5168,495),(5169,496),(5170,497),(5171,498),(5172,499),(5173,500),(5174,501),(5175,502),(5176,503),(5177,504),(5178,505),(5179,506),(5180,507),(5181,508),(5182,509),(5183,510),(5184,511),(5185,512),(5186,513),(5187,514),(5188,515),(5189,516),(5190,517),(5191,518),(5192,519),(5193,520),(5194,521),(5195,522),(5196,523),(5197,524),(5198,525),(5199,526),(5200,527),(5201,528),(5202,529),(5203,530),(5204,531),(5205,532),(5206,533),(5207,534),(5208,535),(5209,536),(5210,537),(5211,538),(5212,539),(5213,540),(5214,541),(5215,542),(5216,543),(5217,544),(5218,545),(5219,546),(5220,547),(5221,548),(5222,549),(5223,550),(5224,551),(5225,552),(5226,553),(5227,554),(5228,555),(5229,556),(5230,557),(5231,558),(5232,559),(5233,560),(5234,561),(5235,562),(5236,563),(5237,564),(5238,565),(5239,566),(5240,567),(5241,568),(5242,569),(5243,570),(5244,571),(5245,572),(5246,573),(5247,574),(5248,575),(5249,576),(5250,577),(5251,578),(5252,579),(5253,580),(5254,581),(5255,582),(5256,583),(5257,584),(5258,585),(5259,586),(5260,587),(5261,588),(5262,589),(5263,590),(5264,591),(5265,592),(5266,593),(5267,594),(5268,595),(5269,596),(5270,597),(5271,598),(5272,599),(5273,600),(5274,601),(5275,602),(5276,603),(5277,604),(5278,605),(5279,606),(5280,607),(5281,608),(5282,609),(5283,610),(5284,611),(5285,612),(5286,613),(5287,614),(5288,615),(5289,616),(5290,617),(5291,618),(5292,619),(5293,620),(5294,621),(5295,622),(5296,623),(5297,624),(5298,625),(5299,626),(5300,627),(5301,628),(5302,629),(5303,630),(5304,631),(5305,632),(5306,633),(5307,634),(5308,635),(5309,636),(5310,637),(5311,638),(5312,639),(5313,640),(5314,641),(5315,642),(5316,643),(5317,644),(5318,645),(5319,646),(5320,647),(5321,648),(5322,649),(5323,650),(5324,651),(5325,652),(5326,653),(5327,654),(5328,655),(5329,656),(5330,657),(5331,658),(5332,659),(5333,660),(5334,661),(5335,662),(5336,663),(5337,664),(5338,665),(5339,666),(5340,667),(5341,668),(5342,669),(5343,670),(5344,671),(5345,672),(5346,673),(5347,674),(5348,675),(5349,676),(5350,677),(5351,678),(5352,679),(5353,680),(5354,681),(5355,682),(5356,683),(5357,684),(5358,685),(5359,686),(5360,687),(5361,688),(5362,689),(5363,690),(5364,691),(5365,692),(5366,693),(5367,694),(5368,695),(5369,696),(5370,697),(5371,698),(5372,699),(5373,700),(5374,701),(5375,702),(5376,703),(5377,704),(5378,705),(5379,706),(5380,707),(5381,708),(5382,709),(5383,710),(5384,711),(5385,712),(5386,713),(5387,714),(5388,715),(5389,716),(5390,717),(5391,718),(5392,719),(5393,720),(5394,721),(5395,722),(5396,723),(5397,724),(5398,725),(5399,726),(5400,727),(5401,728),(5402,729),(5403,730),(5404,731),(5405,732),(5406,733),(5407,734),(5408,735),(5409,736),(5410,737),(5411,738),(5412,739),(5413,740),(5414,741),(5415,742),(5416,743),(5417,744),(5418,745),(5419,746),(5420,747),(5421,748),(5422,749),(5423,750),(5424,751),(5425,752),(5426,753),(5427,754),(5428,755),(5429,756),(5430,757),(5431,758),(5432,759),(5433,760),(5434,761),(5435,762),(5436,763),(5437,764),(5438,765),(5439,766),(5440,767),(5441,768),(5442,769),(5443,770),(5444,771),(5445,772),(5446,773),(5447,774),(5448,775),(5449,776),(5450,777),(5451,778),(5452,779),(5453,780),(5454,781),(5455,782),(5456,783),(5457,784),(5458,785),(5459,786),(5460,787),(5461,788),(5462,789),(5463,790),(5464,791),(5465,792),(5466,793),(5467,794),(5468,795),(5469,796),(5470,797),(5471,798),(5472,799),(5473,800),(5474,801),(5475,802),(5476,803),(5477,804),(5478,805),(5479,806),(5480,807),(5481,808),(5482,809),(5483,810),(5484,811),(5485,812),(5486,813),(5487,814),(5488,815),(5489,816),(5490,817),(5491,818),(5492,819),(5493,820),(5494,821),(5495,822),(5496,823),(5497,824),(5498,825),(5499,826),(5500,827),(5501,828),(5502,829),(5503,830),(5504,831),(5505,832),(5506,833),(5507,834),(5508,835),(5509,836),(5510,837),(5511,838),(5512,839),(5513,840),(5514,841),(5515,842),(5516,843),(5517,844),(5518,845),(5519,846),(5520,847),(5521,848),(5522,849),(5523,850),(5524,851),(5525,852),(5526,853),(5527,854),(5528,855),(5529,856),(5530,857),(5531,858),(5532,859),(5533,860),(5534,861),(5535,862),(5536,863),(5537,864),(5538,865),(5539,866),(5540,867),(5541,868),(5542,869),(5543,870),(5544,871),(5545,872),(5546,873),(5547,874),(5548,875),(5549,876),(5550,877),(5551,878),(5552,879),(5553,880),(5554,881),(5555,882),(5556,883),(5557,884),(5558,885),(5559,886),(5560,887),(5561,888),(5562,889),(5563,890),(5564,891),(5565,892),(5566,893),(5567,894),(5568,895),(5569,896),(5570,897),(5571,898),(5572,899),(5573,900),(5574,901),(5575,902),(5576,903),(5577,904),(5578,905),(5579,906),(5580,907),(5581,908),(5582,909),(5583,910),(5584,911),(5585,912),(5586,913),(5587,914),(5588,915),(5589,916),(5590,917),(5591,918),(5592,919),(5593,920),(5594,921),(5595,922),(5596,923),(5597,924),(5598,925),(5599,926),(5600,927),(5601,928),(5602,929),(5603,930),(5604,931),(5605,932),(5606,933),(5607,934),(5608,935),(5609,936),(5610,937),(5611,938),(5612,939),(5613,940),(5614,941),(5615,942),(5616,943),(5617,944),(5618,945),(5619,946),(5620,947),(5621,948),(5622,949),(5623,950),(5624,951),(5625,952),(5626,953),(5627,954),(5628,955),(5629,956),(5630,957),(5631,958),(5632,959),(5633,960),(5634,961),(5635,962),(5636,963),(5637,964),(5638,965),(5639,966),(5640,967),(5641,968),(5642,969),(5643,970),(5644,971),(5645,972),(5646,973),(5647,974),(5648,975),(5649,976),(5650,977),(5651,978),(5652,979),(5653,980),(5654,981),(5655,982),(5656,983),(5657,984),(5658,985),(5659,986),(5660,987),(5661,988),(5662,989),(5663,990),(5664,991),(5665,992),(5666,993),(5667,994),(5668,995),(5669,996),(5670,997),(5671,998),(5672,999),(5673,1000),(5674,1001),(5675,1002),(5676,1003),(5677,1004),(5678,1005),(5679,1006),(5680,1007),(5681,1008),(5682,1009),(5683,1010),(5684,1011),(5685,1012),(5686,1013),(5687,1014),(5688,1015),(5689,1016),(5690,1017),(5691,1018),(5692,1019),(5693,1020),(5694,1021),(5695,1022),(5696,1023),(5697,1024),(5698,1025),(5699,1026),(5700,1027),(5701,1028),(5702,1029),(5703,1030),(5704,1031),(5705,1032),(5706,1033),(5707,1034),(5708,1035),(5709,1036),(5710,1037),(5711,1038),(5712,1039),(5713,1040),(5714,1041),(5715,1042),(5716,1043),(5717,1044),(5718,1045),(5719,1046),(5720,1047),(5721,1048),(5722,1049),(5723,1050),(5724,1051),(5725,1052),(5726,1053),(5727,1054),(5728,1055),(5729,1056),(5730,1057),(5731,1058),(5732,1059),(5733,1060),(5734,1061),(5735,1062),(5736,1063),(5737,1064),(5738,1065),(5739,1066),(5740,1067),(5741,1068),(5742,1069),(5743,1070),(5744,1071),(5745,1072),(5746,1073),(5747,1074),(5748,1075),(5749,1076),(5750,1077),(5751,1078),(5752,1079),(5753,1080),(5754,1081),(5755,1082),(5756,1083),(5757,1084),(5758,1085),(5759,1086),(5760,1087),(5761,1088),(5762,1089),(5763,1090),(5764,1091),(5765,1092),(5766,1093),(5767,1094),(5768,1095),(5769,1096),(5770,1097),(5771,1098),(5772,1099),(5773,1100),(5774,1101),(5775,1102),(5776,1103),(5777,1104),(5778,1105),(5779,1106),(5780,1107),(5781,1108),(5782,1109),(5783,1110),(5784,1111),(5785,1112),(5786,1113),(5787,1114),(5788,1115),(5789,1116),(5790,1117),(5791,1118),(5792,1119),(5793,1120),(5794,1121),(5795,1122),(5796,1123),(5797,1124),(5798,1125),(5799,1126),(5800,1127),(5801,1128),(5802,1129),(5803,1130),(5804,1131),(5805,1132),(5806,1133),(5807,1134),(5808,1135),(5809,1136),(5810,1137),(5811,1138),(5812,1139),(5813,1140),(5814,1140),(5815,1140),(5816,1140),(5817,1141),(5818,1141),(5819,1141),(5820,1141),(5821,1142),(5822,1142),(5823,1142),(5824,1142),(5825,1143),(5826,1143),(5827,1143),(5828,1143),(5829,1144),(5830,1144),(5831,1144),(5832,1144),(5833,1145),(5834,1145),(5835,1145),(5836,1145),(5837,1146),(5838,1146),(5839,1146),(5840,1146),(5841,1147),(5842,1147),(5843,1147),(5844,1147),(5845,1148),(5846,1148),(5847,1148),(5848,1148),(5849,1149),(5850,1149),(5851,1149),(5852,1149),(5853,1150),(5854,1150),(5855,1150),(5856,1150),(5857,1140),(5858,1141),(5859,1142),(5860,1143),(5861,1144),(5862,1145),(5863,1146),(5864,1147),(5865,1148),(5866,1149),(5867,1150),(5868,1151),(5869,1151),(5870,1151),(5871,1151),(5872,1152),(5873,1152),(5874,1152),(5875,1152),(5876,1153),(5877,1153),(5878,1153),(5879,1153),(5880,1154),(5881,1154),(5882,1154),(5883,1154),(5884,1155),(5885,1155),(5886,1155),(5887,1155),(5888,1156),(5889,1156),(5890,1156),(5891,1156),(5892,1157),(5893,1157),(5894,1157),(5895,1157),(5896,1158),(5897,1158),(5898,1158),(5899,1158),(5900,1159),(5901,1159),(5902,1159),(5903,1159),(5904,1160),(5905,1160),(5906,1160),(5907,1160),(5908,1161),(5909,1161),(5910,1161),(5911,1161),(5912,1151),(5913,1152),(5914,1153),(5915,1154),(5916,1155),(5917,1156),(5918,1157),(5919,1158),(5920,1159),(5921,1160),(5922,1161),(5923,1162),(5924,1162),(5925,1162),(5926,1162),(5927,1163),(5928,1163),(5929,1163),(5930,1163),(5931,1163),(5932,1163),(5933,1163),(5934,1163),(5935,1164),(5936,1164),(5937,1164),(5938,1164),(5939,1164),(5940,1164),(5941,1164),(5942,1164),(5943,1165),(5944,1165),(5945,1165),(5946,1165),(5947,1165),(5948,1165),(5949,1165),(5950,1165),(5951,1166),(5952,1166),(5953,1166),(5954,1166),(5955,1167),(5956,1167),(5957,1167),(5958,1167),(5959,1168),(5960,1168),(5961,1168),(5962,1168),(5963,1169),(5964,1169),(5965,1169),(5966,1169),(5967,1170),(5968,1170),(5969,1170),(5970,1170),(5971,1171),(5972,1171),(5973,1171),(5974,1171),(5975,1172),(5976,1172),(5977,1172),(5978,1172),(5979,1173),(5980,1173),(5981,1173),(5982,1173),(5983,1174),(5984,1174),(5985,1174),(5986,1174),(5987,1175),(5988,1175),(5989,1175),(5990,1175),(5991,1176),(5992,1176),(5993,1176),(5994,1176),(5995,1166),(5996,1167),(5997,1168),(5998,1169),(5999,1170),(6000,1171),(6001,1172),(6002,1173),(6003,1174),(6004,1175),(6005,1176),(6006,1177),(6007,1177),(6008,1177),(6009,1177),(6010,1178),(6011,1178),(6012,1178),(6013,1178),(6014,1179),(6015,1179),(6016,1179),(6017,1179),(6018,1180),(6019,1180),(6020,1180),(6021,1180),(6022,1181),(6023,1181),(6024,1181),(6025,1181),(6026,1182),(6027,1182),(6028,1182),(6029,1182),(6030,1183),(6031,1183),(6032,1183),(6033,1183),(6034,1184),(6035,1184),(6036,1184),(6037,1184),(6038,1185),(6039,1185),(6040,1185),(6041,1185),(6042,1186),(6043,1186),(6044,1186),(6045,1186),(6046,1187),(6047,1187),(6048,1187),(6049,1187),(6050,1188),(6051,1188),(6052,1188),(6053,1188),(6054,1189),(6055,1189),(6056,1189),(6057,1189),(6058,1190),(6059,1190),(6060,1190),(6061,1190),(6062,1191),(6063,1191),(6064,1191),(6065,1191),(6066,1192),(6067,1192),(6068,1192),(6069,1192),(6070,1193),(6071,1193),(6072,1193),(6073,1193),(6074,1194),(6075,1194),(6076,1194),(6077,1194),(6078,1195),(6079,1195),(6080,1195),(6081,1195),(6082,1196),(6083,1196),(6084,1196),(6085,1196),(6086,1197),(6087,1197),(6088,1197),(6089,1197),(6090,1198),(6091,1198),(6092,1198),(6093,1198),(6094,1199),(6095,1199),(6096,1199),(6097,1199),(6098,1200),(6099,1200),(6100,1200),(6101,1200),(6102,1201),(6103,1201),(6104,1201),(6105,1201),(6106,1202),(6107,1202),(6108,1202),(6109,1202),(6110,1203),(6111,1203),(6112,1203),(6113,1203),(6114,1204),(6115,1204),(6116,1204),(6117,1204),(6118,1205),(6119,1205),(6120,1205),(6121,1205),(6122,1206),(6123,1206),(6124,1206),(6125,1206),(6126,1207),(6127,1207),(6128,1207),(6129,1207),(6130,1208),(6131,1208),(6132,1208),(6133,1208),(6134,1209),(6135,1209),(6136,1209),(6137,1209),(6138,1210),(6139,1210),(6140,1210),(6141,1210),(6142,1211),(6143,1211),(6144,1211),(6145,1211),(6146,1212),(6147,1212),(6148,1212),(6149,1212),(6150,1213),(6151,1213),(6152,1213),(6153,1213),(6154,1214),(6155,1214),(6156,1214),(6157,1214),(6158,1215),(6159,1215),(6160,1215),(6161,1215),(6162,1216),(6163,1216),(6164,1216),(6165,1216),(6166,1217),(6167,1217),(6168,1217),(6169,1217),(6170,1218),(6171,1218),(6172,1218),(6173,1218),(6174,1219),(6175,1219),(6176,1219),(6177,1219),(6178,1220),(6179,1220),(6180,1220),(6181,1220),(6182,1221),(6183,1221),(6184,1221),(6185,1221),(6186,1222),(6187,1222),(6188,1222),(6189,1222),(6190,1223),(6191,1223),(6192,1223),(6193,1223),(6194,1224),(6195,1224),(6196,1224),(6197,1224),(6198,1225),(6199,1225),(6200,1225),(6201,1225),(6202,1226),(6203,1226),(6204,1226),(6205,1226),(6206,1227),(6207,1227),(6208,1227),(6209,1227),(6210,1228),(6211,1228),(6212,1228),(6213,1228),(6214,1229),(6215,1229),(6216,1229),(6217,1229),(6218,1230),(6219,1230),(6220,1230),(6221,1230),(6222,1231),(6223,1231),(6224,1231),(6225,1231),(6226,1232),(6227,1232),(6228,1232),(6229,1232),(6230,1233),(6231,1233),(6232,1233),(6233,1233),(6234,1234),(6235,1234),(6236,1234),(6237,1234),(6238,1235),(6239,1235),(6240,1235),(6241,1235),(6242,1236),(6243,1236),(6244,1236),(6245,1236),(6246,1237),(6247,1237),(6248,1237),(6249,1237),(6250,1238),(6251,1238),(6252,1238),(6253,1238),(6254,1239),(6255,1239),(6256,1239),(6257,1239),(6258,1240),(6259,1240),(6260,1240),(6261,1240),(6262,1241),(6263,1241),(6264,1241),(6265,1241),(6266,1242),(6267,1242),(6268,1242),(6269,1242),(6270,1243),(6271,1243),(6272,1243),(6273,1243),(6274,1244),(6275,1244),(6276,1244),(6277,1244),(6278,1245),(6279,1245),(6280,1245),(6281,1245),(6282,1246),(6283,1246),(6284,1246),(6285,1246),(6286,1247),(6287,1247),(6288,1247),(6289,1247),(6290,1248),(6291,1248),(6292,1248),(6293,1248),(6294,1249),(6295,1249),(6296,1249),(6297,1249),(6298,1250),(6299,1250),(6300,1250),(6301,1250),(6302,1251),(6303,1251),(6304,1251),(6305,1251),(6306,1252),(6307,1252),(6308,1252),(6309,1252),(6310,1253),(6311,1253),(6312,1253),(6313,1253),(6314,1254),(6315,1254),(6316,1254),(6317,1254),(6318,1255),(6319,1255),(6320,1255),(6321,1255),(6322,1256),(6323,1256),(6324,1256),(6325,1256),(6326,1257),(6327,1257),(6328,1257),(6329,1257),(6330,1258),(6331,1258),(6332,1258),(6333,1258),(6334,1259),(6335,1259),(6336,1259),(6337,1259),(6338,1260),(6339,1260),(6340,1260),(6341,1260),(6342,1261),(6343,1261),(6344,1261),(6345,1261),(6346,1262),(6347,1262),(6348,1262),(6349,1262),(6350,1263),(6351,1263),(6352,1263),(6353,1263),(6354,1264),(6355,1264),(6356,1264),(6357,1264),(6358,1265),(6359,1265),(6360,1265),(6361,1265),(6362,1266),(6363,1266),(6364,1266),(6365,1266),(6366,1267),(6367,1267),(6368,1267),(6369,1267),(6370,1268),(6371,1268),(6372,1268),(6373,1268),(6374,1269),(6375,1269),(6376,1269),(6377,1269),(6378,1270),(6379,1270),(6380,1270),(6381,1270),(6382,1271),(6383,1271),(6384,1271),(6385,1271),(6386,1272),(6387,1272),(6388,1272),(6389,1272),(6390,1273),(6391,1273),(6392,1273),(6393,1273),(6394,1274),(6395,1274),(6396,1274),(6397,1274),(6398,1275),(6399,1275),(6400,1275),(6401,1275),(6402,1276),(6403,1276),(6404,1276),(6405,1276),(6406,1277),(6407,1277),(6408,1277),(6409,1277),(6410,1278),(6411,1278),(6412,1278),(6413,1278),(6414,1279),(6415,1279),(6416,1279),(6417,1279),(6418,1280),(6419,1280),(6420,1280),(6421,1280),(6422,1281),(6423,1281),(6424,1281),(6425,1281),(6426,1282),(6427,1282),(6428,1282),(6429,1282),(6430,1283),(6431,1283),(6432,1283),(6433,1283),(6434,1284),(6435,1284),(6436,1284),(6437,1284),(6438,1285),(6439,1285),(6440,1285),(6441,1285),(6442,1286),(6443,1286),(6444,1286),(6445,1286),(6446,1287),(6447,1287),(6448,1287),(6449,1287),(6450,1288),(6451,1288),(6452,1288),(6453,1288),(6454,1289),(6455,1289),(6456,1289),(6457,1289),(6458,1290),(6459,1290),(6460,1290),(6461,1290),(6462,1291),(6463,1291),(6464,1291),(6465,1291),(6466,1292),(6467,1292),(6468,1292),(6469,1292),(6470,1293),(6471,1293),(6472,1293),(6473,1293),(6474,1294),(6475,1294),(6476,1294),(6477,1294),(6478,1295),(6479,1295),(6480,1295),(6481,1295),(6482,1296),(6483,1296),(6484,1296),(6485,1296),(6486,1297),(6487,1297),(6488,1297),(6489,1297),(6490,1298),(6491,1298),(6492,1298),(6493,1298),(6494,1299),(6495,1299),(6496,1299),(6497,1299),(6498,1300),(6499,1300),(6500,1300),(6501,1300),(6502,1301),(6503,1301),(6504,1301),(6505,1301),(6506,1302),(6507,1302),(6508,1302),(6509,1302),(6510,1303),(6511,1303),(6512,1303),(6513,1303),(6514,1304),(6515,1304),(6516,1304),(6517,1304),(6518,1305),(6519,1305),(6520,1305),(6521,1305),(6522,1306),(6523,1306),(6524,1306),(6525,1306),(6526,1307),(6527,1307),(6528,1307),(6529,1307),(6530,1308),(6531,1308),(6532,1308),(6533,1308),(6534,1309),(6535,1309),(6536,1309),(6537,1309),(6538,1310),(6539,1310),(6540,1310),(6541,1310),(6542,1311),(6543,1311),(6544,1311),(6545,1311),(6546,1312),(6547,1312),(6548,1312),(6549,1312),(6550,1313),(6551,1313),(6552,1313),(6553,1313),(6554,1314),(6555,1314),(6556,1314),(6557,1314),(6558,1315),(6559,1315),(6560,1315),(6561,1315),(6562,1316),(6563,1316),(6564,1316),(6565,1316),(6566,1317),(6567,1317),(6568,1317),(6569,1317),(6570,1318),(6571,1318),(6572,1318),(6573,1318),(6574,1319),(6575,1319),(6576,1319),(6577,1319),(6578,1320),(6579,1320),(6580,1320),(6581,1320),(6582,1321),(6583,1321),(6584,1321),(6585,1321),(6586,1322),(6587,1322),(6588,1322),(6589,1322),(6590,1323),(6591,1323),(6592,1323),(6593,1323),(6594,1324),(6595,1324),(6596,1324),(6597,1324),(6598,1325),(6599,1325),(6600,1325),(6601,1325),(6602,1326),(6603,1326),(6604,1326),(6605,1326),(6606,1327),(6607,1327),(6608,1327),(6609,1327),(6610,1328),(6611,1328),(6612,1328),(6613,1328),(6614,1329),(6615,1329),(6616,1329),(6617,1329),(6618,1330),(6619,1330),(6620,1330),(6621,1330),(6622,1331),(6623,1331),(6624,1331),(6625,1331),(6626,1332),(6627,1332),(6628,1332),(6629,1332),(6630,1333),(6631,1333),(6632,1333),(6633,1333),(6634,1334),(6635,1334),(6636,1334),(6637,1334),(6638,1335),(6639,1335),(6640,1335),(6641,1335),(6642,1336),(6643,1336),(6644,1336),(6645,1336),(6646,1337),(6647,1337),(6648,1337),(6649,1337),(6650,1338),(6651,1338),(6652,1338),(6653,1338),(6654,1339),(6655,1339),(6656,1339),(6657,1339),(6658,1340),(6659,1340),(6660,1340),(6661,1340),(6662,1341),(6663,1341),(6664,1341),(6665,1341),(6666,1342),(6667,1342),(6668,1342),(6669,1342),(6670,1343),(6671,1343),(6672,1343),(6673,1343),(6674,1344),(6675,1344),(6676,1344),(6677,1344),(6678,1345),(6679,1345),(6680,1345),(6681,1345),(6682,1346),(6683,1346),(6684,1346),(6685,1346),(6686,1347),(6687,1347),(6688,1347),(6689,1347),(6690,1348),(6691,1348),(6692,1348),(6693,1348),(6694,1349),(6695,1349),(6696,1349),(6697,1349),(6698,1350),(6699,1350),(6700,1350),(6701,1350),(6702,1351),(6703,1351),(6704,1351),(6705,1351),(6706,1352),(6707,1352),(6708,1352),(6709,1352),(6710,1353),(6711,1353),(6712,1353),(6713,1353),(6714,1354),(6715,1354),(6716,1354),(6717,1354),(6718,1355),(6719,1355),(6720,1355),(6721,1355),(6722,1356),(6723,1356),(6724,1356),(6725,1356),(6726,1357),(6727,1357),(6728,1357),(6729,1357),(6730,1358),(6731,1358),(6732,1358),(6733,1358),(6734,1359),(6735,1359),(6736,1359),(6737,1359),(6738,1360),(6739,1360),(6740,1360),(6741,1360),(6742,1361),(6743,1361),(6744,1361),(6745,1361),(6746,1362),(6747,1362),(6748,1362),(6749,1362),(6750,1363),(6751,1363),(6752,1363),(6753,1363),(6754,1364),(6755,1364),(6756,1364),(6757,1364),(6758,1365),(6759,1365),(6760,1365),(6761,1365),(6762,1366),(6763,1366),(6764,1366),(6765,1366),(6766,1367),(6767,1367),(6768,1367),(6769,1367),(6770,1368),(6771,1368),(6772,1368),(6773,1368),(6774,1369),(6775,1369),(6776,1369),(6777,1369),(6778,1370),(6779,1370),(6780,1370),(6781,1370),(6782,1371),(6783,1371),(6784,1371),(6785,1371),(6786,1372),(6787,1372),(6788,1372),(6789,1372),(6790,1373),(6791,1373),(6792,1373),(6793,1373),(6794,1374),(6795,1374),(6796,1374),(6797,1374),(6798,1375),(6799,1375),(6800,1375),(6801,1375),(6802,1376),(6803,1376),(6804,1376),(6805,1376),(6806,1377),(6807,1377),(6808,1377),(6809,1377),(6810,1378),(6811,1378),(6812,1378),(6813,1378),(6814,1379),(6815,1379),(6816,1379),(6817,1379),(6818,1380),(6819,1380),(6820,1380),(6821,1380),(6822,1381),(6823,1381),(6824,1381),(6825,1381),(6826,1382),(6827,1382),(6828,1382),(6829,1382),(6830,1383),(6831,1383),(6832,1383),(6833,1383),(6834,1384),(6835,1384),(6836,1384),(6837,1384),(6838,1385),(6839,1385),(6840,1385),(6841,1385),(6842,1386),(6843,1386),(6844,1386),(6845,1386),(6846,1387),(6847,1387),(6848,1387),(6849,1387),(6850,1388),(6851,1388),(6852,1388),(6853,1388),(6854,1389),(6855,1389),(6856,1389),(6857,1389),(6858,1390),(6859,1390),(6860,1390),(6861,1390),(6862,1391),(6863,1391),(6864,1391),(6865,1391),(6866,1392),(6867,1392),(6868,1392),(6869,1392),(6870,1393),(6871,1393),(6872,1393),(6873,1393),(6874,1394),(6875,1394),(6876,1394),(6877,1394),(6878,1395),(6879,1395),(6880,1395),(6881,1395),(6882,1396),(6883,1396),(6884,1396),(6885,1396),(6886,1397),(6887,1397),(6888,1397),(6889,1397),(6890,1398),(6891,1398),(6892,1398),(6893,1398),(6894,1399),(6895,1399),(6896,1399),(6897,1399),(6898,1400),(6899,1400),(6900,1400),(6901,1400),(6902,1401),(6903,1401),(6904,1401),(6905,1401),(6906,1402),(6907,1402),(6908,1402),(6909,1402),(6910,1403),(6911,1403),(6912,1403),(6913,1403),(6914,1404),(6915,1404),(6916,1404),(6917,1404),(6918,1405),(6919,1405),(6920,1405),(6921,1405),(6922,1406),(6923,1406),(6924,1406),(6925,1406),(6926,1407),(6927,1407),(6928,1407),(6929,1407),(6930,1408),(6931,1408),(6932,1408),(6933,1408),(6934,1409),(6935,1409),(6936,1409),(6937,1409),(6938,1410),(6939,1410),(6940,1410),(6941,1410),(6942,1411),(6943,1411),(6944,1411),(6945,1411),(6946,1412),(6947,1412),(6948,1412),(6949,1412),(6950,1413),(6951,1413),(6952,1413),(6953,1413),(6954,1414),(6955,1414),(6956,1414),(6957,1414),(6958,1415),(6959,1415),(6960,1415),(6961,1415),(6962,1416),(6963,1416),(6964,1416),(6965,1416),(6966,1417),(6967,1417),(6968,1417),(6969,1417),(6970,1418),(6971,1418),(6972,1418),(6973,1418),(6974,1419),(6975,1419),(6976,1419),(6977,1419),(6978,1420),(6979,1420),(6980,1420),(6981,1420),(6982,1421),(6983,1421),(6984,1421),(6985,1421),(6986,1422),(6987,1422),(6988,1422),(6989,1422),(6990,1423),(6991,1423),(6992,1423),(6993,1423),(6994,1424),(6995,1424),(6996,1424),(6997,1424),(6998,1425),(6999,1425),(7000,1425),(7001,1425),(7002,1426),(7003,1426),(7004,1426),(7005,1426),(7006,1427),(7007,1427),(7008,1427),(7009,1427),(7010,1428),(7011,1428),(7012,1428),(7013,1428),(7014,1429),(7015,1429),(7016,1429),(7017,1429),(7018,1430),(7019,1430),(7020,1430),(7021,1430),(7022,1431),(7023,1431),(7024,1431),(7025,1431),(7026,1432),(7027,1432),(7028,1432),(7029,1432),(7030,1433),(7031,1433),(7032,1433),(7033,1433),(7034,1434),(7035,1434),(7036,1434),(7037,1434),(7038,1435),(7039,1435),(7040,1435),(7041,1435),(7042,1436),(7043,1436),(7044,1436),(7045,1436),(7046,1437),(7047,1437),(7048,1437),(7049,1437),(7050,1438),(7051,1438),(7052,1438),(7053,1438),(7054,1439),(7055,1439),(7056,1439),(7057,1439),(7058,1440),(7059,1440),(7060,1440),(7061,1440),(7062,1441),(7063,1441),(7064,1441),(7065,1441),(7066,1442),(7067,1442),(7068,1442),(7069,1442),(7070,1443),(7071,1443),(7072,1443),(7073,1443),(7074,1444),(7075,1444),(7076,1444),(7077,1444),(7078,1445),(7079,1445),(7080,1445),(7081,1445),(7082,1446),(7083,1446),(7084,1446),(7085,1446),(7086,1447),(7087,1447),(7088,1447),(7089,1447),(7090,1448),(7091,1448),(7092,1448),(7093,1448),(7094,1449),(7095,1449),(7096,1449),(7097,1449),(7098,1450),(7099,1450),(7100,1450),(7101,1450),(7102,1451),(7103,1451),(7104,1451),(7105,1451),(7106,1452),(7107,1452),(7108,1452),(7109,1452),(7110,1453),(7111,1453),(7112,1453),(7113,1453),(7114,1454),(7115,1454),(7116,1454),(7117,1454),(7118,1455),(7119,1455),(7120,1455),(7121,1455),(7122,1456),(7123,1456),(7124,1456),(7125,1456),(7126,1457),(7127,1457),(7128,1457),(7129,1457),(7130,1458),(7131,1458),(7132,1458),(7133,1458),(7134,1459),(7135,1459),(7136,1459),(7137,1459),(7138,1460),(7139,1460),(7140,1460),(7141,1460),(7142,1461),(7143,1461),(7144,1461),(7145,1461),(7146,1462),(7147,1462),(7148,1462),(7149,1462),(7150,1463),(7151,1463),(7152,1463),(7153,1463),(7154,1464),(7155,1464),(7156,1464),(7157,1464),(7158,1465),(7159,1465),(7160,1465),(7161,1465),(7162,1466),(7163,1466),(7164,1466),(7165,1466),(7166,1467),(7167,1467),(7168,1467),(7169,1467),(7170,1468),(7171,1468),(7172,1468),(7173,1468),(7174,1469),(7175,1469),(7176,1469),(7177,1469),(7178,1470),(7179,1470),(7180,1470),(7181,1470),(7182,1471),(7183,1471),(7184,1471),(7185,1471),(7186,1472),(7187,1472),(7188,1472),(7189,1472),(7190,1473),(7191,1473),(7192,1473),(7193,1473),(7194,1474),(7195,1474),(7196,1474),(7197,1474),(7198,1475),(7199,1475),(7200,1475),(7201,1475),(7202,1476),(7203,1476),(7204,1476),(7205,1476),(7206,1477),(7207,1477),(7208,1477),(7209,1477),(7210,1478),(7211,1478),(7212,1478),(7213,1478),(7214,1479),(7215,1479),(7216,1479),(7217,1479),(7218,1480),(7219,1480),(7220,1480),(7221,1480),(7222,1481),(7223,1481),(7224,1481),(7225,1481),(7226,1482),(7227,1482),(7228,1482),(7229,1482),(7230,1483),(7231,1483),(7232,1483),(7233,1483),(7234,1484),(7235,1484),(7236,1484),(7237,1484),(7238,1485),(7239,1485),(7240,1485),(7241,1485),(7242,1486),(7243,1486),(7244,1486),(7245,1486),(7246,1487),(7247,1487),(7248,1487),(7249,1487),(7250,1488),(7251,1488),(7252,1488),(7253,1488),(7254,1489),(7255,1489),(7256,1489),(7257,1489),(7258,1490),(7259,1490),(7260,1490),(7261,1490),(7262,1491),(7263,1491),(7264,1491),(7265,1491),(7266,1492),(7267,1492),(7268,1492),(7269,1492),(7270,1493),(7271,1493),(7272,1493),(7273,1493),(7274,1494),(7275,1494),(7276,1494),(7277,1494),(7278,1495),(7279,1495),(7280,1495),(7281,1495),(7282,1496),(7283,1496),(7284,1496),(7285,1496),(7286,1497),(7287,1497),(7288,1497),(7289,1497),(7290,1498),(7291,1498),(7292,1498),(7293,1498),(7294,1499),(7295,1499),(7296,1499),(7297,1499),(7298,1500),(7299,1500),(7300,1500),(7301,1500),(7302,1501),(7303,1501),(7304,1501),(7305,1501),(7306,1502),(7307,1502),(7308,1502),(7309,1502),(7310,1503),(7311,1503),(7312,1503),(7313,1503),(7314,1504),(7315,1504),(7316,1504),(7317,1504),(7318,1505),(7319,1505),(7320,1505),(7321,1505),(7322,1506),(7323,1506),(7324,1506),(7325,1506),(7326,1507),(7327,1507),(7328,1507),(7329,1507),(7330,1508),(7331,1508),(7332,1508),(7333,1508),(7334,1509),(7335,1509),(7336,1509),(7337,1509),(7338,1510),(7339,1510),(7340,1510),(7341,1510),(7342,1511),(7343,1511),(7344,1511),(7345,1511),(7346,1512),(7347,1512),(7348,1512),(7349,1512),(7350,1513),(7351,1513),(7352,1513),(7353,1513),(7354,1514),(7355,1514),(7356,1514),(7357,1514),(7358,1515),(7359,1515),(7360,1515),(7361,1515),(7362,1516),(7363,1516),(7364,1516),(7365,1516),(7366,1517),(7367,1517),(7368,1517),(7369,1517),(7370,1518),(7371,1518),(7372,1518),(7373,1518),(7374,1519),(7375,1519),(7376,1519),(7377,1519),(7378,1520),(7379,1520),(7380,1520),(7381,1520),(7382,1521),(7383,1521),(7384,1521),(7385,1521),(7386,1522),(7387,1522),(7388,1522),(7389,1522),(7390,1523),(7391,1523),(7392,1523),(7393,1523),(7394,1524),(7395,1524),(7396,1524),(7397,1524),(7398,1525),(7399,1525),(7400,1525),(7401,1525),(7402,1526),(7403,1526),(7404,1526),(7405,1526),(7406,1527),(7407,1527),(7408,1527),(7409,1527),(7410,1528),(7411,1528),(7412,1528),(7413,1528),(7414,1529),(7415,1529),(7416,1529),(7417,1529),(7418,1530),(7419,1530),(7420,1530),(7421,1530),(7422,1531),(7423,1531),(7424,1531),(7425,1531),(7426,1532),(7427,1532),(7428,1532),(7429,1532),(7430,1533),(7431,1533),(7432,1533),(7433,1533),(7434,1534),(7435,1534),(7436,1534),(7437,1534),(7438,1535),(7439,1535),(7440,1535),(7441,1535),(7442,1536),(7443,1536),(7444,1536),(7445,1536),(7446,1537),(7447,1537),(7448,1537),(7449,1537),(7450,1538),(7451,1538),(7452,1538),(7453,1538),(7454,1539),(7455,1539),(7456,1539),(7457,1539),(7458,1540),(7459,1540),(7460,1540),(7461,1540),(7462,1541),(7463,1541),(7464,1541),(7465,1541),(7466,1542),(7467,1542),(7468,1542),(7469,1542),(7470,1543),(7471,1543),(7472,1543),(7473,1543),(7474,1544),(7475,1544),(7476,1544),(7477,1544),(7478,1545),(7479,1545),(7480,1545),(7481,1545),(7482,1546),(7483,1546),(7484,1546),(7485,1546),(7486,1547),(7487,1547),(7488,1547),(7489,1547),(7490,1548),(7491,1548),(7492,1548),(7493,1548),(7494,1549),(7495,1549),(7496,1549),(7497,1549),(7498,1550),(7499,1550),(7500,1550),(7501,1550),(7502,1551),(7503,1551),(7504,1551),(7505,1551),(7506,1552),(7507,1552),(7508,1552),(7509,1552),(7510,1553),(7511,1553),(7512,1553),(7513,1553),(7514,1554),(7515,1554),(7516,1554),(7517,1554),(7518,1555),(7519,1555),(7520,1555),(7521,1555),(7522,1556),(7523,1556),(7524,1556),(7525,1556),(7526,1557),(7527,1557),(7528,1557),(7529,1557),(7530,1558),(7531,1558),(7532,1558),(7533,1558),(7534,1559),(7535,1559),(7536,1559),(7537,1559),(7538,1560),(7539,1560),(7540,1560),(7541,1560),(7542,1561),(7543,1561),(7544,1561),(7545,1561),(7546,1562),(7547,1562),(7548,1562),(7549,1562),(7550,1563),(7551,1563),(7552,1563),(7553,1563),(7554,1564),(7555,1564),(7556,1564),(7557,1564),(7558,1565),(7559,1565),(7560,1565),(7561,1565),(7562,1566),(7563,1566),(7564,1566),(7565,1566),(7566,1567),(7567,1567),(7568,1567),(7569,1567),(7570,1568),(7571,1568),(7572,1568),(7573,1568),(7574,1569),(7575,1569),(7576,1569),(7577,1569),(7578,1570),(7579,1570),(7580,1570),(7581,1570),(7582,1571),(7583,1571),(7584,1571),(7585,1571),(7586,1572),(7587,1572),(7588,1572),(7589,1572),(7590,1573),(7591,1573),(7592,1573),(7593,1573),(7594,1574),(7595,1574),(7596,1574),(7597,1574),(7598,1575),(7599,1575),(7600,1575),(7601,1575),(7602,1576),(7603,1576),(7604,1576),(7605,1576),(7606,1577),(7607,1577),(7608,1577),(7609,1577),(7610,1578),(7611,1578),(7612,1578),(7613,1578),(7614,1579),(7615,1579),(7616,1579),(7617,1579),(7618,1580),(7619,1580),(7620,1580),(7621,1580),(7622,1581),(7623,1581),(7624,1581),(7625,1581),(7626,1582),(7627,1582),(7628,1582),(7629,1582),(7630,1583),(7631,1583),(7632,1583),(7633,1583),(7634,1584),(7635,1584),(7636,1584),(7637,1584),(7638,1585),(7639,1585),(7640,1585),(7641,1585),(7642,1586),(7643,1586),(7644,1586),(7645,1586),(7646,1587),(7647,1587),(7648,1587),(7649,1587),(7650,1588),(7651,1588),(7652,1588),(7653,1588),(7654,1589),(7655,1589),(7656,1589),(7657,1589),(7658,1590),(7659,1590),(7660,1590),(7661,1590),(7662,1591),(7663,1591),(7664,1591),(7665,1591),(7666,1592),(7667,1592),(7668,1592),(7669,1592),(7670,1593),(7671,1593),(7672,1593),(7673,1593),(7674,1594),(7675,1594),(7676,1594),(7677,1594),(7678,1595),(7679,1595),(7680,1595),(7681,1595),(7682,1596),(7683,1596),(7684,1596),(7685,1596),(7686,1597),(7687,1597),(7688,1597),(7689,1597),(7690,1598),(7691,1598),(7692,1598),(7693,1598),(7694,1599),(7695,1599),(7696,1599),(7697,1599),(7698,1600),(7699,1600),(7700,1600),(7701,1600),(7702,1601),(7703,1601),(7704,1601),(7705,1601),(7706,1602),(7707,1602),(7708,1602),(7709,1602),(7710,1603),(7711,1603),(7712,1603),(7713,1603),(7714,1604),(7715,1604),(7716,1604),(7717,1604),(7718,1605),(7719,1605),(7720,1605),(7721,1605),(7722,1606),(7723,1606),(7724,1606),(7725,1606),(7726,1607),(7727,1607),(7728,1607),(7729,1607),(7730,1608),(7731,1608),(7732,1608),(7733,1608),(7734,1609),(7735,1609),(7736,1609),(7737,1609),(7738,1610),(7739,1610),(7740,1610),(7741,1610),(7742,1611),(7743,1611),(7744,1611),(7745,1611),(7746,1612),(7747,1612),(7748,1612),(7749,1612),(7750,1613),(7751,1613),(7752,1613),(7753,1613),(7754,1614),(7755,1614),(7756,1614),(7757,1614),(7758,1615),(7759,1615),(7760,1615),(7761,1615),(7762,1616),(7763,1616),(7764,1616),(7765,1616),(7766,1617),(7767,1617),(7768,1617),(7769,1617),(7770,1618),(7771,1618),(7772,1618),(7773,1618),(7774,1619),(7775,1619),(7776,1619),(7777,1619),(7778,1620),(7779,1620),(7780,1620),(7781,1620),(7782,1621),(7783,1621),(7784,1621),(7785,1621),(7786,1622),(7787,1622),(7788,1622),(7789,1622),(7790,1623),(7791,1623),(7792,1623),(7793,1623),(7794,1624),(7795,1624),(7796,1624),(7797,1624),(7798,1625),(7799,1625),(7800,1625),(7801,1625),(7802,1626),(7803,1626),(7804,1626),(7805,1626),(7806,1627),(7807,1627),(7808,1627),(7809,1627),(7810,1628),(7811,1628),(7812,1628),(7813,1628),(7814,1629),(7815,1629),(7816,1629),(7817,1629),(7818,1630),(7819,1630),(7820,1630),(7821,1630),(7822,1631),(7823,1631),(7824,1631),(7825,1631),(7826,1632),(7827,1632),(7828,1632),(7829,1632),(7830,1633),(7831,1633),(7832,1633),(7833,1633),(7834,1634),(7835,1634),(7836,1634),(7837,1634),(7838,1635),(7839,1635),(7840,1635),(7841,1635),(7842,1636),(7843,1636),(7844,1636),(7845,1636),(7846,1637),(7847,1637),(7848,1637),(7849,1637),(7850,1638),(7851,1638),(7852,1638),(7853,1638),(7854,1639),(7855,1639),(7856,1639),(7857,1639),(7858,1640),(7859,1640),(7860,1640),(7861,1640),(7862,1641),(7863,1641),(7864,1641),(7865,1641),(7866,1642),(7867,1642),(7868,1642),(7869,1642),(7870,1643),(7871,1643),(7872,1643),(7873,1643),(7874,1644),(7875,1644),(7876,1644),(7877,1644),(7878,1645),(7879,1645),(7880,1645),(7881,1645),(7882,1646),(7883,1646),(7884,1646),(7885,1646),(7886,1647),(7887,1647),(7888,1647),(7889,1647),(7890,1648),(7891,1648),(7892,1648),(7893,1648),(7894,1649),(7895,1649),(7896,1649),(7897,1649),(7898,1650),(7899,1650),(7900,1650),(7901,1650),(7902,1651),(7903,1651),(7904,1651),(7905,1651),(7906,1652),(7907,1652),(7908,1652),(7909,1652),(7910,1653),(7911,1653),(7912,1653),(7913,1653),(7914,1654),(7915,1654),(7916,1654),(7917,1654),(7918,1655),(7919,1655),(7920,1655),(7921,1655),(7922,1656),(7923,1656),(7924,1656),(7925,1656),(7926,1657),(7927,1657),(7928,1657),(7929,1657),(7930,1658),(7931,1658),(7932,1658),(7933,1658),(7934,1659),(7935,1659),(7936,1659),(7937,1659),(7938,1660),(7939,1660),(7940,1660),(7941,1660),(7942,1661),(7943,1661),(7944,1661),(7945,1661),(7946,1662),(7947,1662),(7948,1662),(7949,1662),(7950,1663),(7951,1663),(7952,1663),(7953,1663),(7954,1664),(7955,1664),(7956,1664),(7957,1664),(7958,1665),(7959,1665),(7960,1665),(7961,1665),(7962,1666),(7963,1666),(7964,1666),(7965,1666),(7966,1667),(7967,1667),(7968,1667),(7969,1667),(7970,1668),(7971,1668),(7972,1668),(7973,1668),(7974,1669),(7975,1669),(7976,1669),(7977,1669),(7978,1670),(7979,1670),(7980,1670),(7981,1670),(7982,1671),(7983,1671),(7984,1671),(7985,1671),(7986,1672),(7987,1672),(7988,1672),(7989,1672),(7990,1673),(7991,1673),(7992,1673),(7993,1673),(7994,1674),(7995,1674),(7996,1674),(7997,1674),(7998,1675),(7999,1675),(8000,1675),(8001,1675),(8002,1676),(8003,1676),(8004,1676),(8005,1676),(8006,1677),(8007,1677),(8008,1677),(8009,1677),(8010,1678),(8011,1678),(8012,1678),(8013,1678),(8014,1679),(8015,1679),(8016,1679),(8017,1679),(8018,1680),(8019,1680),(8020,1680),(8021,1680),(8022,1681),(8023,1681),(8024,1681),(8025,1681),(8026,1682),(8027,1682),(8028,1682),(8029,1682),(8030,1683),(8031,1683),(8032,1683),(8033,1683),(8034,1684),(8035,1684),(8036,1684),(8037,1684),(8038,1685),(8039,1685),(8040,1685),(8041,1685),(8042,1686),(8043,1686),(8044,1686),(8045,1686),(8046,1687),(8047,1687),(8048,1687),(8049,1687),(8050,1688),(8051,1688),(8052,1688),(8053,1688),(8054,1689),(8055,1689),(8056,1689),(8057,1689),(8058,1690),(8059,1690),(8060,1690),(8061,1690),(8062,1691),(8063,1691),(8064,1691),(8065,1691),(8066,1692),(8067,1692),(8068,1692),(8069,1692),(8070,1693),(8071,1693),(8072,1693),(8073,1693),(8074,1694),(8075,1694),(8076,1694),(8077,1694),(8078,1695),(8079,1695),(8080,1695),(8081,1695),(8082,1696),(8083,1696),(8084,1696),(8085,1696),(8086,1697),(8087,1697),(8088,1697),(8089,1697),(8090,1698),(8091,1698),(8092,1698),(8093,1698),(8094,1699),(8095,1699),(8096,1699),(8097,1699),(8098,1700),(8099,1700),(8100,1700),(8101,1700),(8102,1701),(8103,1701),(8104,1701),(8105,1701),(8106,1702),(8107,1702),(8108,1702),(8109,1702),(8110,1703),(8111,1703),(8112,1703),(8113,1703),(8114,1704),(8115,1704),(8116,1704),(8117,1704),(8118,1705),(8119,1705),(8120,1705),(8121,1705),(8122,1706),(8123,1706),(8124,1706),(8125,1706),(8126,1707),(8127,1707),(8128,1707),(8129,1707),(8130,1708),(8131,1708),(8132,1708),(8133,1708),(8134,1709),(8135,1709),(8136,1709),(8137,1709),(8138,1710),(8139,1710),(8140,1710),(8141,1710),(8142,1711),(8143,1711),(8144,1711),(8145,1711),(8146,1712),(8147,1712),(8148,1712),(8149,1712),(8150,1713),(8151,1713),(8152,1713),(8153,1713),(8154,1714),(8155,1714),(8156,1714),(8157,1714),(8158,1715),(8159,1715),(8160,1715),(8161,1715),(8162,1716),(8163,1716),(8164,1716),(8165,1716),(8166,1717),(8167,1717),(8168,1717),(8169,1717),(8170,1718),(8171,1718),(8172,1718),(8173,1718),(8174,1719),(8175,1719),(8176,1719),(8177,1719),(8178,1720),(8179,1720),(8180,1720),(8181,1720),(8182,1721),(8183,1721),(8184,1721),(8185,1721),(8186,1722),(8187,1722),(8188,1722),(8189,1722),(8190,1723),(8191,1723),(8192,1723),(8193,1723),(8194,1724),(8195,1724),(8196,1724),(8197,1724),(8198,1725),(8199,1725),(8200,1725),(8201,1725),(8202,1726),(8203,1726),(8204,1726),(8205,1726),(8206,1727),(8207,1727),(8208,1727),(8209,1727),(8210,1728),(8211,1728),(8212,1728),(8213,1728),(8214,1729),(8215,1729),(8216,1729),(8217,1729),(8218,1730),(8219,1730),(8220,1730),(8221,1730),(8222,1731),(8223,1731),(8224,1731),(8225,1731),(8226,1732),(8227,1732),(8228,1732),(8229,1732),(8230,1733),(8231,1733),(8232,1733),(8233,1733),(8234,1734),(8235,1734),(8236,1734),(8237,1734),(8238,1735),(8239,1735),(8240,1735),(8241,1735),(8242,1736),(8243,1736),(8244,1736),(8245,1736),(8246,1737),(8247,1737),(8248,1737),(8249,1737),(8250,1738),(8251,1738),(8252,1738),(8253,1738),(8254,1739),(8255,1739),(8256,1739),(8257,1739),(8258,1740),(8259,1740),(8260,1740),(8261,1740),(8262,1741),(8263,1741),(8264,1741),(8265,1741),(8266,1742),(8267,1742),(8268,1742),(8269,1742),(8270,1743),(8271,1743),(8272,1743),(8273,1743),(8274,1744),(8275,1744),(8276,1744),(8277,1744),(8278,1745),(8279,1745),(8280,1745),(8281,1745),(8282,1746),(8283,1746),(8284,1746),(8285,1746),(8286,1747),(8287,1747),(8288,1747),(8289,1747),(8290,1748),(8291,1748),(8292,1748),(8293,1748),(8294,1749),(8295,1749),(8296,1749),(8297,1749),(8298,1750),(8299,1750),(8300,1750),(8301,1750),(8302,1751),(8303,1751),(8304,1751),(8305,1751),(8306,1752),(8307,1752),(8308,1752),(8309,1752),(8310,1753),(8311,1753),(8312,1753),(8313,1753),(8314,1754),(8315,1754),(8316,1754),(8317,1754),(8318,1755),(8319,1755),(8320,1755),(8321,1755),(8322,1756),(8323,1756),(8324,1756),(8325,1756),(8326,1757),(8327,1757),(8328,1757),(8329,1757),(8330,1758),(8331,1758),(8332,1758),(8333,1758),(8334,1759),(8335,1759),(8336,1759),(8337,1759),(8338,1760),(8339,1760),(8340,1760),(8341,1760),(8342,1761),(8343,1761),(8344,1761),(8345,1761),(8346,1762),(8347,1762),(8348,1762),(8349,1762),(8350,1763),(8351,1763),(8352,1763),(8353,1763),(8354,1764),(8355,1764),(8356,1764),(8357,1764),(8358,1765),(8359,1765),(8360,1765),(8361,1765),(8362,1766),(8363,1766),(8364,1766),(8365,1766),(8366,1767),(8367,1767),(8368,1767),(8369,1767),(8370,1768),(8371,1768),(8372,1768),(8373,1768),(8374,1769),(8375,1769),(8376,1769),(8377,1769),(8378,1770),(8379,1770),(8380,1770),(8381,1770),(8382,1771),(8383,1771),(8384,1771),(8385,1771),(8386,1772),(8387,1772),(8388,1772),(8389,1772),(8390,1773),(8391,1773),(8392,1773),(8393,1773),(8394,1774),(8395,1774),(8396,1774),(8397,1774),(8398,1775),(8399,1775),(8400,1775),(8401,1775),(8402,1776),(8403,1776),(8404,1776),(8405,1776),(8406,1777),(8407,1777),(8408,1777),(8409,1777),(8410,1778),(8411,1778),(8412,1778),(8413,1778),(8414,1779),(8415,1779),(8416,1779),(8417,1779),(8418,1780),(8419,1780),(8420,1780),(8421,1780),(8422,1781),(8423,1781),(8424,1781),(8425,1781),(8426,1782),(8427,1782),(8428,1782),(8429,1782),(8430,1783),(8431,1783),(8432,1783),(8433,1783),(8434,1784),(8435,1784),(8436,1784),(8437,1784),(8438,1785),(8439,1785),(8440,1785),(8441,1785),(8442,1786),(8443,1786),(8444,1786),(8445,1786),(8446,1787),(8447,1787),(8448,1787),(8449,1787),(8450,1788),(8451,1788),(8452,1788),(8453,1788),(8454,1789),(8455,1789),(8456,1789),(8457,1789),(8458,1790),(8459,1790),(8460,1790),(8461,1790),(8462,1791),(8463,1791),(8464,1791),(8465,1791),(8466,1792),(8467,1792),(8468,1792),(8469,1792),(8470,1793),(8471,1793),(8472,1793),(8473,1793),(8474,1794),(8475,1794),(8476,1794),(8477,1794),(8478,1795),(8479,1795),(8480,1795),(8481,1795),(8482,1796),(8483,1796),(8484,1796),(8485,1796),(8486,1797),(8487,1797),(8488,1797),(8489,1797),(8490,1798),(8491,1798),(8492,1798),(8493,1798),(8494,1799),(8495,1799),(8496,1799),(8497,1799),(8498,1800),(8499,1800),(8500,1800),(8501,1800),(8502,1801),(8503,1801),(8504,1801),(8505,1801),(8506,1802),(8507,1802),(8508,1802),(8509,1802),(8510,1803),(8511,1803),(8512,1803),(8513,1803),(8514,1804),(8515,1804),(8516,1804),(8517,1804),(8518,1805),(8519,1805),(8520,1805),(8521,1805),(8522,1806),(8523,1806),(8524,1806),(8525,1806),(8526,1807),(8527,1807),(8528,1807),(8529,1807),(8530,1808),(8531,1808),(8532,1808),(8533,1808),(8534,1809),(8535,1809),(8536,1809),(8537,1809),(8538,1810),(8539,1810),(8540,1810),(8541,1810),(8542,1811),(8543,1811),(8544,1811),(8545,1811),(8546,1812),(8547,1812),(8548,1812),(8549,1812),(8550,1177),(8551,1178),(8552,1179),(8553,1180),(8554,1181),(8555,1182),(8556,1183),(8557,1184),(8558,1185),(8559,1186),(8560,1187),(8561,1188),(8562,1189),(8563,1190),(8564,1191),(8565,1192),(8566,1193),(8567,1194),(8568,1195),(8569,1196),(8570,1197),(8571,1198),(8572,1199),(8573,1200),(8574,1201),(8575,1202),(8576,1203),(8577,1204),(8578,1205),(8579,1206),(8580,1207),(8581,1208),(8582,1209),(8583,1210),(8584,1211),(8585,1212),(8586,1213),(8587,1214),(8588,1215),(8589,1216),(8590,1217),(8591,1218),(8592,1219),(8593,1220),(8594,1221),(8595,1222),(8596,1223),(8597,1224),(8598,1225),(8599,1226),(8600,1227),(8601,1228),(8602,1229),(8603,1230),(8604,1231),(8605,1232),(8606,1233),(8607,1234),(8608,1235),(8609,1236),(8610,1237),(8611,1238),(8612,1239),(8613,1240),(8614,1241),(8615,1242),(8616,1243),(8617,1244),(8618,1245),(8619,1246),(8620,1247),(8621,1248),(8622,1249),(8623,1250),(8624,1251),(8625,1252),(8626,1253),(8627,1254),(8628,1255),(8629,1256),(8630,1257),(8631,1258),(8632,1259),(8633,1260),(8634,1261),(8635,1262),(8636,1263),(8637,1264),(8638,1265),(8639,1266),(8640,1267),(8641,1268),(8642,1269),(8643,1270),(8644,1271),(8645,1272),(8646,1273),(8647,1274),(8648,1275),(8649,1276),(8650,1277),(8651,1278),(8652,1279),(8653,1280),(8654,1281),(8655,1282),(8656,1283),(8657,1284),(8658,1285),(8659,1286),(8660,1287),(8661,1288),(8662,1289),(8663,1290),(8664,1291),(8665,1292),(8666,1293),(8667,1294),(8668,1295),(8669,1296),(8670,1297),(8671,1298),(8672,1299),(8673,1300),(8674,1301),(8675,1302),(8676,1303),(8677,1304),(8678,1305),(8679,1306),(8680,1307),(8681,1308),(8682,1309),(8683,1310),(8684,1311),(8685,1312),(8686,1313),(8687,1314),(8688,1315),(8689,1316),(8690,1317),(8691,1318),(8692,1319),(8693,1320),(8694,1321),(8695,1322),(8696,1323),(8697,1324),(8698,1325),(8699,1326),(8700,1327),(8701,1328),(8702,1329),(8703,1330),(8704,1331),(8705,1332),(8706,1333),(8707,1334),(8708,1335),(8709,1336),(8710,1337),(8711,1338),(8712,1339),(8713,1340),(8714,1341),(8715,1342),(8716,1343),(8717,1344),(8718,1345),(8719,1346),(8720,1347),(8721,1348),(8722,1349),(8723,1350),(8724,1351),(8725,1352),(8726,1353),(8727,1354),(8728,1355),(8729,1356),(8730,1357),(8731,1358),(8732,1359),(8733,1360),(8734,1361),(8735,1362),(8736,1363),(8737,1364),(8738,1365),(8739,1366),(8740,1367),(8741,1368),(8742,1369),(8743,1370),(8744,1371),(8745,1372),(8746,1373),(8747,1374),(8748,1375),(8749,1376),(8750,1377),(8751,1378),(8752,1379),(8753,1380),(8754,1381),(8755,1382),(8756,1383),(8757,1384),(8758,1385),(8759,1386),(8760,1387),(8761,1388),(8762,1389),(8763,1390),(8764,1391),(8765,1392),(8766,1393),(8767,1394),(8768,1395),(8769,1396),(8770,1397),(8771,1398),(8772,1399),(8773,1400),(8774,1401),(8775,1402),(8776,1403),(8777,1404),(8778,1405),(8779,1406),(8780,1407),(8781,1408),(8782,1409),(8783,1410),(8784,1411),(8785,1412),(8786,1413),(8787,1414),(8788,1415),(8789,1416),(8790,1417),(8791,1418),(8792,1419),(8793,1420),(8794,1421),(8795,1422),(8796,1423),(8797,1424),(8798,1425),(8799,1426),(8800,1427),(8801,1428),(8802,1429),(8803,1430),(8804,1431),(8805,1432),(8806,1433),(8807,1434),(8808,1435),(8809,1436),(8810,1437),(8811,1438),(8812,1439),(8813,1440),(8814,1441),(8815,1442),(8816,1443),(8817,1444),(8818,1445),(8819,1446),(8820,1447),(8821,1448),(8822,1449),(8823,1450),(8824,1451),(8825,1452),(8826,1453),(8827,1454),(8828,1455),(8829,1456),(8830,1457),(8831,1458),(8832,1459),(8833,1460),(8834,1461),(8835,1462),(8836,1463),(8837,1464),(8838,1465),(8839,1466),(8840,1467),(8841,1468),(8842,1469),(8843,1470),(8844,1471),(8845,1472),(8846,1473),(8847,1474),(8848,1475),(8849,1476),(8850,1477),(8851,1478),(8852,1479),(8853,1480),(8854,1481),(8855,1482),(8856,1483),(8857,1484),(8858,1485),(8859,1486),(8860,1487),(8861,1488),(8862,1489),(8863,1490),(8864,1491),(8865,1492),(8866,1493),(8867,1494),(8868,1495),(8869,1496),(8870,1497),(8871,1498),(8872,1499),(8873,1500),(8874,1501),(8875,1502),(8876,1503),(8877,1504),(8878,1505),(8879,1506),(8880,1507),(8881,1508),(8882,1509),(8883,1510),(8884,1511),(8885,1512),(8886,1513),(8887,1514),(8888,1515),(8889,1516),(8890,1517),(8891,1518),(8892,1519),(8893,1520),(8894,1521),(8895,1522),(8896,1523),(8897,1524),(8898,1525),(8899,1526),(8900,1527),(8901,1528),(8902,1529),(8903,1530),(8904,1531),(8905,1532),(8906,1533),(8907,1534),(8908,1535),(8909,1536),(8910,1537),(8911,1538),(8912,1539),(8913,1540),(8914,1541),(8915,1542),(8916,1543),(8917,1544),(8918,1545),(8919,1546),(8920,1547),(8921,1548),(8922,1549),(8923,1550),(8924,1551),(8925,1552),(8926,1553),(8927,1554),(8928,1555),(8929,1556),(8930,1557),(8931,1558),(8932,1559),(8933,1560),(8934,1561),(8935,1562),(8936,1563),(8937,1564),(8938,1565),(8939,1566),(8940,1567),(8941,1568),(8942,1569),(8943,1570),(8944,1571),(8945,1572),(8946,1573),(8947,1574),(8948,1575),(8949,1576),(8950,1577),(8951,1578),(8952,1579),(8953,1580),(8954,1581),(8955,1582),(8956,1583),(8957,1584),(8958,1585),(8959,1586),(8960,1587),(8961,1588),(8962,1589),(8963,1590),(8964,1591),(8965,1592),(8966,1593),(8967,1594),(8968,1595),(8969,1596),(8970,1597),(8971,1598),(8972,1599),(8973,1600),(8974,1601),(8975,1602),(8976,1603),(8977,1604),(8978,1605),(8979,1606),(8980,1607),(8981,1608),(8982,1609),(8983,1610),(8984,1611),(8985,1612),(8986,1613),(8987,1614),(8988,1615),(8989,1616),(8990,1617),(8991,1618),(8992,1619),(8993,1620),(8994,1621),(8995,1622),(8996,1623),(8997,1624),(8998,1625),(8999,1626),(9000,1627),(9001,1628),(9002,1629),(9003,1630),(9004,1631),(9005,1632),(9006,1633),(9007,1634),(9008,1635),(9009,1636),(9010,1637),(9011,1638),(9012,1639),(9013,1640),(9014,1641),(9015,1642),(9016,1643),(9017,1644),(9018,1645),(9019,1646),(9020,1647),(9021,1648),(9022,1649),(9023,1650),(9024,1651),(9025,1652),(9026,1653),(9027,1654),(9028,1655),(9029,1656),(9030,1657),(9031,1658),(9032,1659),(9033,1660),(9034,1661),(9035,1662),(9036,1663),(9037,1664),(9038,1665),(9039,1666),(9040,1667),(9041,1668),(9042,1669),(9043,1670),(9044,1671),(9045,1672),(9046,1673),(9047,1674),(9048,1675),(9049,1676),(9050,1677),(9051,1678),(9052,1679),(9053,1680),(9054,1681),(9055,1682),(9056,1683),(9057,1684),(9058,1685),(9059,1686),(9060,1687),(9061,1688),(9062,1689),(9063,1690),(9064,1691),(9065,1692),(9066,1693),(9067,1694),(9068,1695),(9069,1696),(9070,1697),(9071,1698),(9072,1699),(9073,1700),(9074,1701),(9075,1702),(9076,1703),(9077,1704),(9078,1705),(9079,1706),(9080,1707),(9081,1708),(9082,1709),(9083,1710),(9084,1711),(9085,1712),(9086,1713),(9087,1714),(9088,1715),(9089,1716),(9090,1717),(9091,1718),(9092,1719),(9093,1720),(9094,1721),(9095,1722),(9096,1723),(9097,1724),(9098,1725),(9099,1726),(9100,1727),(9101,1728),(9102,1729),(9103,1730),(9104,1731),(9105,1732),(9106,1733),(9107,1734),(9108,1735),(9109,1736),(9110,1737),(9111,1738),(9112,1739),(9113,1740),(9114,1741),(9115,1742),(9116,1743),(9117,1744),(9118,1745),(9119,1746),(9120,1747),(9121,1748),(9122,1749),(9123,1750),(9124,1751),(9125,1752),(9126,1753),(9127,1754),(9128,1755),(9129,1756),(9130,1757),(9131,1758),(9132,1759),(9133,1760),(9134,1761),(9135,1762),(9136,1763),(9137,1764),(9138,1765),(9139,1766),(9140,1767),(9141,1768),(9142,1769),(9143,1770),(9144,1771),(9145,1772),(9146,1773),(9147,1774),(9148,1775),(9149,1776),(9150,1777),(9151,1778),(9152,1779),(9153,1780),(9154,1781),(9155,1782),(9156,1783),(9157,1784),(9158,1785),(9159,1786),(9160,1787),(9161,1788),(9162,1789),(9163,1790),(9164,1791),(9165,1792),(9166,1793),(9167,1794),(9168,1795),(9169,1796),(9170,1797),(9171,1798),(9172,1799),(9173,1800),(9174,1801),(9175,1802),(9176,1803),(9177,1804),(9178,1805),(9179,1806),(9180,1807),(9181,1808),(9182,1809),(9183,1810),(9184,1811),(9185,1812),(9186,1813),(9187,1813),(9188,1813),(9189,1813),(9190,1814),(9191,1814),(9192,1814),(9193,1814),(9194,1815),(9195,1815),(9196,1815),(9197,1815),(9198,1816),(9199,1816),(9200,1816),(9201,1816),(9202,1817),(9203,1817),(9204,1817),(9205,1817),(9206,1818),(9207,1818),(9208,1818),(9209,1818),(9210,1819),(9211,1819),(9212,1819),(9213,1819),(9214,1820),(9215,1820),(9216,1820),(9217,1820),(9218,1821),(9219,1821),(9220,1821),(9221,1821),(9222,1822),(9223,1822),(9224,1822),(9225,1822),(9226,1823),(9227,1823),(9228,1823),(9229,1823),(9230,1813),(9231,1814),(9232,1815),(9233,1816),(9234,1817),(9235,1818),(9236,1819),(9237,1820),(9238,1821),(9239,1822),(9240,1823),(9241,1824),(9242,1824),(9243,1824),(9244,1824),(9245,1825),(9246,1825),(9247,1825),(9248,1825),(9249,1826),(9250,1826),(9251,1826),(9252,1826),(9253,1827),(9254,1827),(9255,1827),(9256,1827),(9257,1828),(9258,1828),(9259,1828),(9260,1828),(9261,1829),(9262,1829),(9263,1829),(9264,1829),(9265,1830),(9266,1830),(9267,1830),(9268,1830),(9269,1831),(9270,1831),(9271,1831),(9272,1831),(9273,1832),(9274,1832),(9275,1832),(9276,1832),(9277,1833),(9278,1833),(9279,1833),(9280,1833),(9281,1834),(9282,1834),(9283,1834),(9284,1834),(9285,1835),(9286,1835),(9287,1835),(9288,1835),(9289,1836),(9290,1836),(9291,1836),(9292,1836),(9293,1837),(9294,1837),(9295,1837),(9296,1837),(9297,1838),(9298,1838),(9299,1838),(9300,1838),(9301,1839),(9302,1839),(9303,1839),(9304,1839),(9305,1840),(9306,1840),(9307,1840),(9308,1840),(9309,1841),(9310,1841),(9311,1841),(9312,1841),(9313,1842),(9314,1842),(9315,1842),(9316,1842),(9317,1843),(9318,1843),(9319,1843),(9320,1843),(9321,1844),(9322,1844),(9323,1844),(9324,1844),(9325,1845),(9326,1845),(9327,1845),(9328,1845),(9329,1846),(9330,1846),(9331,1846),(9332,1846),(9333,1847),(9334,1847),(9335,1847),(9336,1847),(9337,1848),(9338,1848),(9339,1848),(9340,1848),(9341,1849),(9342,1849),(9343,1849),(9344,1849),(9345,1850),(9346,1850),(9347,1850),(9348,1850),(9349,1851),(9350,1851),(9351,1851),(9352,1851),(9353,1852),(9354,1852),(9355,1852),(9356,1852),(9357,1853),(9358,1853),(9359,1853),(9360,1853),(9361,1854),(9362,1854),(9363,1854),(9364,1854),(9365,1855),(9366,1855),(9367,1855),(9368,1855),(9369,1856),(9370,1856),(9371,1856),(9372,1856),(9373,1857),(9374,1857),(9375,1857),(9376,1857),(9377,1858),(9378,1858),(9379,1858),(9380,1858),(9381,1859),(9382,1859),(9383,1859),(9384,1859),(9385,1860),(9386,1860),(9387,1860),(9388,1860),(9389,1861),(9390,1861),(9391,1861),(9392,1861),(9393,1862),(9394,1862),(9395,1862),(9396,1862),(9397,1863),(9398,1863),(9399,1863),(9400,1863),(9401,1864),(9402,1864),(9403,1864),(9404,1864),(9405,1865),(9406,1865),(9407,1865),(9408,1865),(9409,1866),(9410,1866),(9411,1866),(9412,1866),(9413,1867),(9414,1867),(9415,1867),(9416,1867),(9417,1868),(9418,1868),(9419,1868),(9420,1868),(9421,1869),(9422,1869),(9423,1869),(9424,1869),(9425,1870),(9426,1870),(9427,1870),(9428,1870),(9429,1871),(9430,1871),(9431,1871),(9432,1871),(9433,1872),(9434,1872),(9435,1872),(9436,1872),(9437,1873),(9438,1873),(9439,1873),(9440,1873),(9441,1874),(9442,1874),(9443,1874),(9444,1874),(9445,1875),(9446,1875),(9447,1875),(9448,1875),(9449,1876),(9450,1876),(9451,1876),(9452,1876),(9453,1877),(9454,1877),(9455,1877),(9456,1877),(9457,1878),(9458,1878),(9459,1878),(9460,1878),(9461,1879),(9462,1879),(9463,1879),(9464,1879),(9465,1880),(9466,1880),(9467,1880),(9468,1880),(9469,1881),(9470,1881),(9471,1881),(9472,1881),(9473,1882),(9474,1882),(9475,1882),(9476,1882),(9477,1883),(9478,1883),(9479,1883),(9480,1883),(9481,1884),(9482,1884),(9483,1884),(9484,1884),(9485,1885),(9486,1885),(9487,1885),(9488,1885),(9489,1886),(9490,1886),(9491,1886),(9492,1886),(9493,1887),(9494,1887),(9495,1887),(9496,1887),(9497,1888),(9498,1888),(9499,1888),(9500,1888),(9501,1889),(9502,1889),(9503,1889),(9504,1889),(9505,1890),(9506,1890),(9507,1890),(9508,1890),(9509,1891),(9510,1891),(9511,1891),(9512,1891),(9513,1892),(9514,1892),(9515,1892),(9516,1892),(9517,1893),(9518,1893),(9519,1893),(9520,1893),(9521,1894),(9522,1894),(9523,1894),(9524,1894),(9525,1895),(9526,1895),(9527,1895),(9528,1895),(9529,1896),(9530,1896),(9531,1896),(9532,1896),(9533,1897),(9534,1897),(9535,1897),(9536,1897),(9537,1898),(9538,1898),(9539,1898),(9540,1898),(9541,1899),(9542,1899),(9543,1899),(9544,1899),(9545,1900),(9546,1900),(9547,1900),(9548,1900),(9549,1901),(9550,1901),(9551,1901),(9552,1901),(9553,1902),(9554,1902),(9555,1902),(9556,1902),(9557,1903),(9558,1903),(9559,1903),(9560,1903),(9561,1904),(9562,1904),(9563,1904),(9564,1904),(9565,1905),(9566,1905),(9567,1905),(9568,1905),(9569,1906),(9570,1906),(9571,1906),(9572,1906),(9573,1907),(9574,1907),(9575,1907),(9576,1907),(9577,1908),(9578,1908),(9579,1908),(9580,1908),(9581,1909),(9582,1909),(9583,1909),(9584,1909),(9585,1910),(9586,1910),(9587,1910),(9588,1910),(9589,1911),(9590,1911),(9591,1911),(9592,1911),(9593,1912),(9594,1912),(9595,1912),(9596,1912),(9597,1913),(9598,1913),(9599,1913),(9600,1913),(9601,1914),(9602,1914),(9603,1914),(9604,1914),(9605,1915),(9606,1915),(9607,1915),(9608,1915),(9609,1916),(9610,1916),(9611,1916),(9612,1916),(9613,1917),(9614,1917),(9615,1917),(9616,1917),(9617,1918),(9618,1918),(9619,1918),(9620,1918),(9621,1919),(9622,1919),(9623,1919),(9624,1919),(9625,1920),(9626,1920),(9627,1920),(9628,1920),(9629,1921),(9630,1921),(9631,1921),(9632,1921),(9633,1922),(9634,1922),(9635,1922),(9636,1922),(9637,1923),(9638,1923),(9639,1923),(9640,1923),(9641,1924),(9642,1924),(9643,1924),(9644,1924),(9645,1925),(9646,1925),(9647,1925),(9648,1925),(9649,1926),(9650,1926),(9651,1926),(9652,1926),(9653,1927),(9654,1927),(9655,1927),(9656,1927),(9657,1928),(9658,1928),(9659,1928),(9660,1928),(9661,1929),(9662,1929),(9663,1929),(9664,1929),(9665,1930),(9666,1930),(9667,1930),(9668,1930),(9669,1931),(9670,1931),(9671,1931),(9672,1931),(9673,1932),(9674,1932),(9675,1932),(9676,1932),(9677,1933),(9678,1933),(9679,1933),(9680,1933),(9681,1934),(9682,1934),(9683,1934),(9684,1934),(9685,1935),(9686,1935),(9687,1935),(9688,1935),(9689,1936),(9690,1936),(9691,1936),(9692,1936),(9693,1937),(9694,1937),(9695,1937),(9696,1937),(9697,1938),(9698,1938),(9699,1938),(9700,1938),(9701,1939),(9702,1939),(9703,1939),(9704,1939),(9705,1940),(9706,1940),(9707,1940),(9708,1940),(9709,1941),(9710,1941),(9711,1941),(9712,1941),(9713,1942),(9714,1942),(9715,1942),(9716,1942),(9717,1943),(9718,1943),(9719,1943),(9720,1943),(9721,1944),(9722,1944),(9723,1944),(9724,1944),(9725,1945),(9726,1945),(9727,1945),(9728,1945),(9729,1946),(9730,1946),(9731,1946),(9732,1946),(9733,1947),(9734,1947),(9735,1947),(9736,1947),(9737,1948),(9738,1948),(9739,1948),(9740,1948),(9741,1949),(9742,1949),(9743,1949),(9744,1949),(9745,1950),(9746,1950),(9747,1950),(9748,1950),(9749,1951),(9750,1951),(9751,1951),(9752,1951),(9753,1952),(9754,1952),(9755,1952),(9756,1952),(9757,1953),(9758,1953),(9759,1953),(9760,1953),(9761,1954),(9762,1954),(9763,1954),(9764,1954),(9765,1955),(9766,1955),(9767,1955),(9768,1955),(9769,1956),(9770,1956),(9771,1956),(9772,1956),(9773,1957),(9774,1957),(9775,1957),(9776,1957),(9777,1958),(9778,1958),(9779,1958),(9780,1958),(9781,1959),(9782,1959),(9783,1959),(9784,1959),(9785,1960),(9786,1960),(9787,1960),(9788,1960),(9789,1961),(9790,1961),(9791,1961),(9792,1961),(9793,1962),(9794,1962),(9795,1962),(9796,1962),(9797,1963),(9798,1963),(9799,1963),(9800,1963),(9801,1964),(9802,1964),(9803,1964),(9804,1964),(9805,1965),(9806,1965),(9807,1965),(9808,1965),(9809,1966),(9810,1966),(9811,1966),(9812,1966),(9813,1967),(9814,1967),(9815,1967),(9816,1967),(9817,1968),(9818,1968),(9819,1968),(9820,1968),(9821,1969),(9822,1969),(9823,1969),(9824,1969),(9825,1970),(9826,1970),(9827,1970),(9828,1970),(9829,1971),(9830,1971),(9831,1971),(9832,1971),(9833,1972),(9834,1972),(9835,1972),(9836,1972),(9837,1973),(9838,1973),(9839,1973),(9840,1973),(9841,1974),(9842,1974),(9843,1974),(9844,1974),(9845,1975),(9846,1975),(9847,1975),(9848,1975),(9849,1976),(9850,1976),(9851,1976),(9852,1976),(9853,1977),(9854,1977),(9855,1977),(9856,1977),(9857,1978),(9858,1978),(9859,1978),(9860,1978),(9861,1979),(9862,1979),(9863,1979),(9864,1979),(9865,1980),(9866,1980),(9867,1980),(9868,1980),(9869,1981),(9870,1981),(9871,1981),(9872,1981),(9873,1982),(9874,1982),(9875,1982),(9876,1982),(9877,1983),(9878,1983),(9879,1983),(9880,1983),(9881,1984),(9882,1984),(9883,1984),(9884,1984),(9885,1985),(9886,1985),(9887,1985),(9888,1985),(9889,1986),(9890,1986),(9891,1986),(9892,1986),(9893,1987),(9894,1987),(9895,1987),(9896,1987),(9897,1988),(9898,1988),(9899,1988),(9900,1988),(9901,1989),(9902,1989),(9903,1989),(9904,1989),(9905,1990),(9906,1990),(9907,1990),(9908,1990),(9909,1991),(9910,1991),(9911,1991),(9912,1991),(9913,1992),(9914,1992),(9915,1992),(9916,1992),(9917,1993),(9918,1993),(9919,1993),(9920,1993),(9921,1994),(9922,1994),(9923,1994),(9924,1994),(9925,1995),(9926,1995),(9927,1995),(9928,1995),(9929,1996),(9930,1996),(9931,1996),(9932,1996),(9933,1997),(9934,1997),(9935,1997),(9936,1997),(9937,1998),(9938,1998),(9939,1998),(9940,1998),(9941,1999),(9942,1999),(9943,1999),(9944,1999),(9945,2000),(9946,2000),(9947,2000),(9948,2000),(9949,2001),(9950,2001),(9951,2001),(9952,2001),(9953,2002),(9954,2002),(9955,2002),(9956,2002),(9957,2003),(9958,2003),(9959,2003),(9960,2003),(9961,2004),(9962,2004),(9963,2004),(9964,2004),(9965,2005),(9966,2005),(9967,2005),(9968,2005),(9969,2006),(9970,2006),(9971,2006),(9972,2006),(9973,2007),(9974,2007),(9975,2007),(9976,2007),(9977,2008),(9978,2008),(9979,2008),(9980,2008),(9981,2009),(9982,2009),(9983,2009),(9984,2009),(9985,2010),(9986,2010),(9987,2010),(9988,2010),(9989,2011),(9990,2011),(9991,2011),(9992,2011),(9993,2012),(9994,2012),(9995,2012),(9996,2012),(9997,2013),(9998,2013),(9999,2013),(10000,2013),(10001,2014),(10002,2014),(10003,2014),(10004,2014),(10005,2015),(10006,2015),(10007,2015),(10008,2015),(10009,2016),(10010,2016),(10011,2016),(10012,2016),(10013,2017),(10014,2017),(10015,2017),(10016,2017),(10017,2018),(10018,2018),(10019,2018),(10020,2018),(10021,2019),(10022,2019),(10023,2019),(10024,2019),(10025,2020),(10026,2020),(10027,2020),(10028,2020),(10029,2021),(10030,2021),(10031,2021),(10032,2021),(10033,2022),(10034,2022),(10035,2022),(10036,2022),(10037,2023),(10038,2023),(10039,2023),(10040,2023),(10041,2024),(10042,2024),(10043,2024),(10044,2024),(10045,2025),(10046,2025),(10047,2025),(10048,2025),(10049,2026),(10050,2026),(10051,2026),(10052,2026),(10053,2027),(10054,2027),(10055,2027),(10056,2027),(10057,2028),(10058,2028),(10059,2028),(10060,2028),(10061,2029),(10062,2029),(10063,2029),(10064,2029),(10065,2030),(10066,2030),(10067,2030),(10068,2030),(10069,2031),(10070,2031),(10071,2031),(10072,2031),(10073,2032),(10074,2032),(10075,2032),(10076,2032),(10077,2033),(10078,2033),(10079,2033),(10080,2033),(10081,2034),(10082,2034),(10083,2034),(10084,2034),(10085,2035),(10086,2035),(10087,2035),(10088,2035),(10089,2036),(10090,2036),(10091,2036),(10092,2036),(10093,2037),(10094,2037),(10095,2037),(10096,2037),(10097,2038),(10098,2038),(10099,2038),(10100,2038),(10101,2039),(10102,2039),(10103,2039),(10104,2039),(10105,2040),(10106,2040),(10107,2040),(10108,2040),(10109,2041),(10110,2041),(10111,2041),(10112,2041),(10113,2042),(10114,2042),(10115,2042),(10116,2042),(10117,2043),(10118,2043),(10119,2043),(10120,2043),(10121,2044),(10122,2044),(10123,2044),(10124,2044),(10125,2045),(10126,2045),(10127,2045),(10128,2045),(10129,2046),(10130,2046),(10131,2046),(10132,2046),(10133,2047),(10134,2047),(10135,2047),(10136,2047),(10137,2048),(10138,2048),(10139,2048),(10140,2048),(10141,2049),(10142,2049),(10143,2049),(10144,2049),(10145,2050),(10146,2050),(10147,2050),(10148,2050),(10149,2051),(10150,2051),(10151,2051),(10152,2051),(10153,2052),(10154,2052),(10155,2052),(10156,2052),(10157,2053),(10158,2053),(10159,2053),(10160,2053),(10161,2054),(10162,2054),(10163,2054),(10164,2054),(10165,2055),(10166,2055),(10167,2055),(10168,2055),(10169,2056),(10170,2056),(10171,2056),(10172,2056),(10173,2057),(10174,2057),(10175,2057),(10176,2057),(10177,2058),(10178,2058),(10179,2058),(10180,2058),(10181,2059),(10182,2059),(10183,2059),(10184,2059),(10185,2060),(10186,2060),(10187,2060),(10188,2060),(10189,2061),(10190,2061),(10191,2061),(10192,2061),(10193,2062),(10194,2062),(10195,2062),(10196,2062),(10197,2063),(10198,2063),(10199,2063),(10200,2063),(10201,2064),(10202,2064),(10203,2064),(10204,2064),(10205,2065),(10206,2065),(10207,2065),(10208,2065),(10209,2066),(10210,2066),(10211,2066),(10212,2066),(10213,2067),(10214,2067),(10215,2067),(10216,2067),(10217,2068),(10218,2068),(10219,2068),(10220,2068),(10221,2069),(10222,2069),(10223,2069),(10224,2069),(10225,2070),(10226,2070),(10227,2070),(10228,2070),(10229,2071),(10230,2071),(10231,2071),(10232,2071),(10233,2072),(10234,2072),(10235,2072),(10236,2072),(10237,2073),(10238,2073),(10239,2073),(10240,2073),(10241,2074),(10242,2074),(10243,2074),(10244,2074),(10245,2075),(10246,2075),(10247,2075),(10248,2075),(10249,2076),(10250,2076),(10251,2076),(10252,2076),(10253,2077),(10254,2077),(10255,2077),(10256,2077),(10257,2078),(10258,2078),(10259,2078),(10260,2078),(10261,2079),(10262,2079),(10263,2079),(10264,2079),(10265,2080),(10266,2080),(10267,2080),(10268,2080),(10269,2081),(10270,2081),(10271,2081),(10272,2081),(10273,2082),(10274,2082),(10275,2082),(10276,2082),(10277,2083),(10278,2083),(10279,2083),(10280,2083),(10281,2084),(10282,2084),(10283,2084),(10284,2084),(10285,2085),(10286,2085),(10287,2085),(10288,2085),(10289,2086),(10290,2086),(10291,2086),(10292,2086),(10293,2087),(10294,2087),(10295,2087),(10296,2087),(10297,2088),(10298,2088),(10299,2088),(10300,2088),(10301,2089),(10302,2089),(10303,2089),(10304,2089),(10305,2090),(10306,2090),(10307,2090),(10308,2090),(10309,2091),(10310,2091),(10311,2091),(10312,2091),(10313,2092),(10314,2092),(10315,2092),(10316,2092),(10317,2093),(10318,2093),(10319,2093),(10320,2093),(10321,2094),(10322,2094),(10323,2094),(10324,2094),(10325,2095),(10326,2095),(10327,2095),(10328,2095),(10329,2096),(10330,2096),(10331,2096),(10332,2096),(10333,2097),(10334,2097),(10335,2097),(10336,2097),(10337,2098),(10338,2098),(10339,2098),(10340,2098),(10341,2099),(10342,2099),(10343,2099),(10344,2099),(10345,2100),(10346,2100),(10347,2100),(10348,2100),(10349,2101),(10350,2101),(10351,2101),(10352,2101),(10353,2102),(10354,2102),(10355,2102),(10356,2102),(10357,2103),(10358,2103),(10359,2103),(10360,2103),(10361,2104),(10362,2104),(10363,2104),(10364,2104),(10365,2105),(10366,2105),(10367,2105),(10368,2105),(10369,2106),(10370,2106),(10371,2106),(10372,2106),(10373,2107),(10374,2107),(10375,2107),(10376,2107),(10377,2108),(10378,2108),(10379,2108),(10380,2108),(10381,2109),(10382,2109),(10383,2109),(10384,2109),(10385,2110),(10386,2110),(10387,2110),(10388,2110),(10389,2111),(10390,2111),(10391,2111),(10392,2111),(10393,2112),(10394,2112),(10395,2112),(10396,2112),(10397,2113),(10398,2113),(10399,2113),(10400,2113),(10401,2114),(10402,2114),(10403,2114),(10404,2114),(10405,2115),(10406,2115),(10407,2115),(10408,2115),(10409,2116),(10410,2116),(10411,2116),(10412,2116),(10413,2117),(10414,2117),(10415,2117),(10416,2117),(10417,2118),(10418,2118),(10419,2118),(10420,2118),(10421,2119),(10422,2119),(10423,2119),(10424,2119),(10425,2120),(10426,2120),(10427,2120),(10428,2120),(10429,2121),(10430,2121),(10431,2121),(10432,2121),(10433,2122),(10434,2122),(10435,2122),(10436,2122),(10437,2123),(10438,2123),(10439,2123),(10440,2123),(10441,2124),(10442,2124),(10443,2124),(10444,2124),(10445,2125),(10446,2125),(10447,2125),(10448,2125),(10449,2126),(10450,2126),(10451,2126),(10452,2126),(10453,2127),(10454,2127),(10455,2127),(10456,2127),(10457,2128),(10458,2128),(10459,2128),(10460,2128),(10461,2129),(10462,2129),(10463,2129),(10464,2129),(10465,2130),(10466,2130),(10467,2130),(10468,2130),(10469,2131),(10470,2131),(10471,2131),(10472,2131),(10473,2132),(10474,2132),(10475,2132),(10476,2132),(10477,2133),(10478,2133),(10479,2133),(10480,2133),(10481,2134),(10482,2134),(10483,2134),(10484,2134),(10485,2135),(10486,2135),(10487,2135),(10488,2135),(10489,2136),(10490,2136),(10491,2136),(10492,2136),(10493,2137),(10494,2137),(10495,2137),(10496,2137),(10497,2138),(10498,2138),(10499,2138),(10500,2138),(10501,2139),(10502,2139),(10503,2139),(10504,2139),(10505,2140),(10506,2140),(10507,2140),(10508,2140),(10509,2141),(10510,2141),(10511,2141),(10512,2141),(10513,2142),(10514,2142),(10515,2142),(10516,2142),(10517,2143),(10518,2143),(10519,2143),(10520,2143),(10521,2144),(10522,2144),(10523,2144),(10524,2144),(10525,2145),(10526,2145),(10527,2145),(10528,2145),(10529,2146),(10530,2146),(10531,2146),(10532,2146),(10533,2147),(10534,2147),(10535,2147),(10536,2147),(10537,2148),(10538,2148),(10539,2148),(10540,2148),(10541,2149),(10542,2149),(10543,2149),(10544,2149),(10545,2150),(10546,2150),(10547,2150),(10548,2150),(10549,2151),(10550,2151),(10551,2151),(10552,2151),(10553,2152),(10554,2152),(10555,2152),(10556,2152),(10557,2153),(10558,2153),(10559,2153),(10560,2153),(10561,2154),(10562,2154),(10563,2154),(10564,2154),(10565,2155),(10566,2155),(10567,2155),(10568,2155),(10569,2156),(10570,2156),(10571,2156),(10572,2156),(10573,2157),(10574,2157),(10575,2157),(10576,2157),(10577,2158),(10578,2158),(10579,2158),(10580,2158),(10581,2159),(10582,2159),(10583,2159),(10584,2159),(10585,2160),(10586,2160),(10587,2160),(10588,2160),(10589,2161),(10590,2161),(10591,2161),(10592,2161),(10593,2162),(10594,2162),(10595,2162),(10596,2162),(10597,2163),(10598,2163),(10599,2163),(10600,2163),(10601,2164),(10602,2164),(10603,2164),(10604,2164),(10605,2165),(10606,2165),(10607,2165),(10608,2165),(10609,2166),(10610,2166),(10611,2166),(10612,2166),(10613,2167),(10614,2167),(10615,2167),(10616,2167),(10617,2168),(10618,2168),(10619,2168),(10620,2168),(10621,2169),(10622,2169),(10623,2169),(10624,2169),(10625,2170),(10626,2170),(10627,2170),(10628,2170),(10629,2171),(10630,2171),(10631,2171),(10632,2171),(10633,2172),(10634,2172),(10635,2172),(10636,2172),(10637,2173),(10638,2173),(10639,2173),(10640,2173),(10641,2174),(10642,2174),(10643,2174),(10644,2174),(10645,2175),(10646,2175),(10647,2175),(10648,2175),(10649,2176),(10650,2176),(10651,2176),(10652,2176),(10653,2177),(10654,2177),(10655,2177),(10656,2177),(10657,2178),(10658,2178),(10659,2178),(10660,2178),(10661,2179),(10662,2179),(10663,2179),(10664,2179),(10665,2180),(10666,2180),(10667,2180),(10668,2180),(10669,2181),(10670,2181),(10671,2181),(10672,2181),(10673,2182),(10674,2182),(10675,2182),(10676,2182),(10677,2183),(10678,2183),(10679,2183),(10680,2183),(10681,2184),(10682,2184),(10683,2184),(10684,2184),(10685,2185),(10686,2185),(10687,2185),(10688,2185),(10689,2186),(10690,2186),(10691,2186),(10692,2186),(10693,2187),(10694,2187),(10695,2187),(10696,2187),(10697,2188),(10698,2188),(10699,2188),(10700,2188),(10701,2189),(10702,2189),(10703,2189),(10704,2189),(10705,2190),(10706,2190),(10707,2190),(10708,2190),(10709,2191),(10710,2191),(10711,2191),(10712,2191),(10713,2192),(10714,2192),(10715,2192),(10716,2192),(10717,2193),(10718,2193),(10719,2193),(10720,2193),(10721,2194),(10722,2194),(10723,2194),(10724,2194),(10725,2195),(10726,2195),(10727,2195),(10728,2195),(10729,2196),(10730,2196),(10731,2196),(10732,2196),(10733,2197),(10734,2197),(10735,2197),(10736,2197),(10737,2198),(10738,2198),(10739,2198),(10740,2198),(10741,2199),(10742,2199),(10743,2199),(10744,2199),(10745,2200),(10746,2200),(10747,2200),(10748,2200),(10749,2201),(10750,2201),(10751,2201),(10752,2201),(10753,2202),(10754,2202),(10755,2202),(10756,2202),(10757,2203),(10758,2203),(10759,2203),(10760,2203),(10761,2204),(10762,2204),(10763,2204),(10764,2204),(10765,2205),(10766,2205),(10767,2205),(10768,2205),(10769,2206),(10770,2206),(10771,2206),(10772,2206),(10773,2207),(10774,2207),(10775,2207),(10776,2207),(10777,2208),(10778,2208),(10779,2208),(10780,2208),(10781,2209),(10782,2209),(10783,2209),(10784,2209),(10785,2210),(10786,2210),(10787,2210),(10788,2210),(10789,2211),(10790,2211),(10791,2211),(10792,2211),(10793,2212),(10794,2212),(10795,2212),(10796,2212),(10797,2213),(10798,2213),(10799,2213),(10800,2213),(10801,2214),(10802,2214),(10803,2214),(10804,2214),(10805,2215),(10806,2215),(10807,2215),(10808,2215),(10809,2216),(10810,2216),(10811,2216),(10812,2216),(10813,2217),(10814,2217),(10815,2217),(10816,2217),(10817,2218),(10818,2218),(10819,2218),(10820,2218),(10821,2219),(10822,2219),(10823,2219),(10824,2219),(10825,2220),(10826,2220),(10827,2220),(10828,2220),(10829,2221),(10830,2221),(10831,2221),(10832,2221),(10833,2222),(10834,2222),(10835,2222),(10836,2222),(10837,2223),(10838,2223),(10839,2223),(10840,2223),(10841,2224),(10842,2224),(10843,2224),(10844,2224),(10845,2225),(10846,2225),(10847,2225),(10848,2225),(10849,2226),(10850,2226),(10851,2226),(10852,2226),(10853,2227),(10854,2227),(10855,2227),(10856,2227),(10857,2228),(10858,2228),(10859,2228),(10860,2228),(10861,2229),(10862,2229),(10863,2229),(10864,2229),(10865,2230),(10866,2230),(10867,2230),(10868,2230),(10869,2231),(10870,2231),(10871,2231),(10872,2231),(10873,2232),(10874,2232),(10875,2232),(10876,2232),(10877,2233),(10878,2233),(10879,2233),(10880,2233),(10881,2234),(10882,2234),(10883,2234),(10884,2234),(10885,2235),(10886,2235),(10887,2235),(10888,2235),(10889,2236),(10890,2236),(10891,2236),(10892,2236),(10893,2237),(10894,2237),(10895,2237),(10896,2237),(10897,2238),(10898,2238),(10899,2238),(10900,2238),(10901,2239),(10902,2239),(10903,2239),(10904,2239),(10905,2240),(10906,2240),(10907,2240),(10908,2240),(10909,2241),(10910,2241),(10911,2241),(10912,2241),(10913,2242),(10914,2242),(10915,2242),(10916,2242),(10917,2243),(10918,2243),(10919,2243),(10920,2243),(10921,2244),(10922,2244),(10923,2244),(10924,2244),(10925,2245),(10926,2245),(10927,2245),(10928,2245),(10929,2246),(10930,2246),(10931,2246),(10932,2246),(10933,2247),(10934,2247),(10935,2247),(10936,2247),(10937,2248),(10938,2248),(10939,2248),(10940,2248),(10941,2249),(10942,2249),(10943,2249),(10944,2249),(10945,2250),(10946,2250),(10947,2250),(10948,2250),(10949,2251),(10950,2251),(10951,2251),(10952,2251),(10953,2252),(10954,2252),(10955,2252),(10956,2252),(10957,2253),(10958,2253),(10959,2253),(10960,2253),(10961,2254),(10962,2254),(10963,2254),(10964,2254),(10965,2255),(10966,2255),(10967,2255),(10968,2255),(10969,2256),(10970,2256),(10971,2256),(10972,2256),(10973,2257),(10974,2257),(10975,2257),(10976,2257),(10977,2258),(10978,2258),(10979,2258),(10980,2258),(10981,2259),(10982,2259),(10983,2259),(10984,2259),(10985,2260),(10986,2260),(10987,2260),(10988,2260),(10989,2261),(10990,2261),(10991,2261),(10992,2261),(10993,2262),(10994,2262),(10995,2262),(10996,2262),(10997,2263),(10998,2263),(10999,2263),(11000,2263),(11001,2264),(11002,2264),(11003,2264),(11004,2264),(11005,2265),(11006,2265),(11007,2265),(11008,2265),(11009,2266),(11010,2266),(11011,2266),(11012,2266),(11013,2267),(11014,2267),(11015,2267),(11016,2267),(11017,2268),(11018,2268),(11019,2268),(11020,2268),(11021,2269),(11022,2269),(11023,2269),(11024,2269),(11025,2270),(11026,2270),(11027,2270),(11028,2270),(11029,2271),(11030,2271),(11031,2271),(11032,2271),(11033,2272),(11034,2272),(11035,2272),(11036,2272),(11037,2273),(11038,2273),(11039,2273),(11040,2273),(11041,2274),(11042,2274),(11043,2274),(11044,2274),(11045,2275),(11046,2275),(11047,2275),(11048,2275),(11049,2276),(11050,2276),(11051,2276),(11052,2276),(11053,2277),(11054,2277),(11055,2277),(11056,2277),(11057,2278),(11058,2278),(11059,2278),(11060,2278),(11061,2279),(11062,2279),(11063,2279),(11064,2279),(11065,2280),(11066,2280),(11067,2280),(11068,2280),(11069,2281),(11070,2281),(11071,2281),(11072,2281),(11073,2282),(11074,2282),(11075,2282),(11076,2282),(11077,2283),(11078,2283),(11079,2283),(11080,2283),(11081,2284),(11082,2284),(11083,2284),(11084,2284),(11085,2285),(11086,2285),(11087,2285),(11088,2285),(11089,2286),(11090,2286),(11091,2286),(11092,2286),(11093,2287),(11094,2287),(11095,2287),(11096,2287),(11097,2288),(11098,2288),(11099,2288),(11100,2288),(11101,2289),(11102,2289),(11103,2289),(11104,2289),(11105,2290),(11106,2290),(11107,2290),(11108,2290),(11109,2291),(11110,2291),(11111,2291),(11112,2291),(11113,2292),(11114,2292),(11115,2292),(11116,2292),(11117,2293),(11118,2293),(11119,2293),(11120,2293),(11121,2294),(11122,2294),(11123,2294),(11124,2294),(11125,2295),(11126,2295),(11127,2295),(11128,2295),(11129,2296),(11130,2296),(11131,2296),(11132,2296),(11133,2297),(11134,2297),(11135,2297),(11136,2297),(11137,2298),(11138,2298),(11139,2298),(11140,2298),(11141,2299),(11142,2299),(11143,2299),(11144,2299),(11145,2300),(11146,2300),(11147,2300),(11148,2300),(11149,2301),(11150,2301),(11151,2301),(11152,2301),(11153,2302),(11154,2302),(11155,2302),(11156,2302),(11157,2303),(11158,2303),(11159,2303),(11160,2303),(11161,2304),(11162,2304),(11163,2304),(11164,2304),(11165,2305),(11166,2305),(11167,2305),(11168,2305),(11169,2306),(11170,2306),(11171,2306),(11172,2306),(11173,2307),(11174,2307),(11175,2307),(11176,2307),(11177,2308),(11178,2308),(11179,2308),(11180,2308),(11181,2309),(11182,2309),(11183,2309),(11184,2309),(11185,2310),(11186,2310),(11187,2310),(11188,2310),(11189,1824),(11190,1825),(11191,1826),(11192,1827),(11193,1828),(11194,1829),(11195,1830),(11196,1831),(11197,1832),(11198,1833),(11199,1834),(11200,1835),(11201,1836),(11202,1837),(11203,1838),(11204,1839),(11205,1840),(11206,1841),(11207,1842),(11208,1843),(11209,1844),(11210,1845),(11211,1846),(11212,1847),(11213,1848),(11214,1849),(11215,1850),(11216,1851),(11217,1852),(11218,1853),(11219,1854),(11220,1855),(11221,1856),(11222,1857),(11223,1858),(11224,1859),(11225,1860),(11226,1861),(11227,1862),(11228,1863),(11229,1864),(11230,1865),(11231,1866),(11232,1867),(11233,1868),(11234,1869),(11235,1870),(11236,1871),(11237,1872),(11238,1873),(11239,1874),(11240,1875),(11241,1876),(11242,1877),(11243,1878),(11244,1879),(11245,1880),(11246,1881),(11247,1882),(11248,1883),(11249,1884),(11250,1885),(11251,1886),(11252,1887),(11253,1888),(11254,1889),(11255,1890),(11256,1891),(11257,1892),(11258,1893),(11259,1894),(11260,1895),(11261,1896),(11262,1897),(11263,1898),(11264,1899),(11265,1900),(11266,1901),(11267,1902),(11268,1903),(11269,1904),(11270,1905),(11271,1906),(11272,1907),(11273,1908),(11274,1909),(11275,1910),(11276,1911),(11277,1912),(11278,1913),(11279,1914),(11280,1915),(11281,1916),(11282,1917),(11283,1918),(11284,1919),(11285,1920),(11286,1921),(11287,1922),(11288,1923),(11289,1924),(11290,1925),(11291,1926),(11292,1927),(11293,1928),(11294,1929),(11295,1930),(11296,1931),(11297,1932),(11298,1933),(11299,1934),(11300,1935),(11301,1936),(11302,1937),(11303,1938),(11304,1939),(11305,1940),(11306,1941),(11307,1942),(11308,1943),(11309,1944),(11310,1945),(11311,1946),(11312,1947),(11313,1948),(11314,1949),(11315,1950),(11316,1951),(11317,1952),(11318,1953),(11319,1954),(11320,1955),(11321,1956),(11322,1957),(11323,1958),(11324,1959),(11325,1960),(11326,1961),(11327,1962),(11328,1963),(11329,1964),(11330,1965),(11331,1966),(11332,1967),(11333,1968),(11334,1969),(11335,1970),(11336,1971),(11337,1972),(11338,1973),(11339,1974),(11340,1975),(11341,1976),(11342,1977),(11343,1978),(11344,1979),(11345,1980),(11346,1981),(11347,1982),(11348,1983),(11349,1984),(11350,1985),(11351,1986),(11352,1987),(11353,1988),(11354,1989),(11355,1990),(11356,1991),(11357,1992),(11358,1993),(11359,1994),(11360,1995),(11361,1996),(11362,1997),(11363,1998),(11364,1999),(11365,2000),(11366,2001),(11367,2002),(11368,2003),(11369,2004),(11370,2005),(11371,2006),(11372,2007),(11373,2008),(11374,2009),(11375,2010),(11376,2011),(11377,2012),(11378,2013),(11379,2014),(11380,2015),(11381,2016),(11382,2017),(11383,2018),(11384,2019),(11385,2020),(11386,2021),(11387,2022),(11388,2023),(11389,2024),(11390,2025),(11391,2026),(11392,2027),(11393,2028),(11394,2029),(11395,2030),(11396,2031),(11397,2032),(11398,2033),(11399,2034),(11400,2035),(11401,2036),(11402,2037),(11403,2038),(11404,2039),(11405,2040),(11406,2041),(11407,2042),(11408,2043),(11409,2044),(11410,2045),(11411,2046),(11412,2047),(11413,2048),(11414,2049),(11415,2050),(11416,2051),(11417,2052),(11418,2053),(11419,2054),(11420,2055),(11421,2056),(11422,2057),(11423,2058),(11424,2059),(11425,2060),(11426,2061),(11427,2062),(11428,2063),(11429,2064),(11430,2065),(11431,2066),(11432,2067),(11433,2068),(11434,2069),(11435,2070),(11436,2071),(11437,2072),(11438,2073),(11439,2074),(11440,2075),(11441,2076),(11442,2077),(11443,2078),(11444,2079),(11445,2080),(11446,2081),(11447,2082),(11448,2083),(11449,2084),(11450,2085),(11451,2086),(11452,2087),(11453,2088),(11454,2089),(11455,2090),(11456,2091),(11457,2092),(11458,2093),(11459,2094),(11460,2095),(11461,2096),(11462,2097),(11463,2098),(11464,2099),(11465,2100),(11466,2101),(11467,2102),(11468,2103),(11469,2104),(11470,2105),(11471,2106),(11472,2107),(11473,2108),(11474,2109),(11475,2110),(11476,2111),(11477,2112),(11478,2113),(11479,2114),(11480,2115),(11481,2116),(11482,2117),(11483,2118),(11484,2119),(11485,2120),(11486,2121),(11487,2122),(11488,2123),(11489,2124),(11490,2125),(11491,2126),(11492,2127),(11493,2128),(11494,2129),(11495,2130),(11496,2131),(11497,2132),(11498,2133),(11499,2134),(11500,2135),(11501,2136),(11502,2137),(11503,2138),(11504,2139),(11505,2140),(11506,2141),(11507,2142),(11508,2143),(11509,2144),(11510,2145),(11511,2146),(11512,2147),(11513,2148),(11514,2149),(11515,2150),(11516,2151),(11517,2152),(11518,2153),(11519,2154),(11520,2155),(11521,2156),(11522,2157),(11523,2158),(11524,2159),(11525,2160),(11526,2161),(11527,2162),(11528,2163),(11529,2164),(11530,2165),(11531,2166),(11532,2167),(11533,2168),(11534,2169),(11535,2170),(11536,2171),(11537,2172),(11538,2173),(11539,2174),(11540,2175),(11541,2176),(11542,2177),(11543,2178),(11544,2179),(11545,2180),(11546,2181),(11547,2182),(11548,2183),(11549,2184),(11550,2185),(11551,2186),(11552,2187),(11553,2188),(11554,2189),(11555,2190),(11556,2191),(11557,2192),(11558,2193),(11559,2194),(11560,2195),(11561,2196),(11562,2197),(11563,2198),(11564,2199),(11565,2200),(11566,2201),(11567,2202),(11568,2203),(11569,2204),(11570,2205),(11571,2206),(11572,2207),(11573,2208),(11574,2209),(11575,2210),(11576,2211),(11577,2212),(11578,2213),(11579,2214),(11580,2215),(11581,2216),(11582,2217),(11583,2218),(11584,2219),(11585,2220),(11586,2221),(11587,2222),(11588,2223),(11589,2224),(11590,2225),(11591,2226),(11592,2227),(11593,2228),(11594,2229),(11595,2230),(11596,2231),(11597,2232),(11598,2233),(11599,2234),(11600,2235),(11601,2236),(11602,2237),(11603,2238),(11604,2239),(11605,2240),(11606,2241),(11607,2242),(11608,2243),(11609,2244),(11610,2245),(11611,2246),(11612,2247),(11613,2248),(11614,2249),(11615,2250),(11616,2251),(11617,2252),(11618,2253),(11619,2254),(11620,2255),(11621,2256),(11622,2257),(11623,2258),(11624,2259),(11625,2260),(11626,2261),(11627,2262),(11628,2263),(11629,2264),(11630,2265),(11631,2266),(11632,2267),(11633,2268),(11634,2269),(11635,2270),(11636,2271),(11637,2272),(11638,2273),(11639,2274),(11640,2275),(11641,2276),(11642,2277),(11643,2278),(11644,2279),(11645,2280),(11646,2281),(11647,2282),(11648,2283),(11649,2284),(11650,2285),(11651,2286),(11652,2287),(11653,2288),(11654,2289),(11655,2290),(11656,2291),(11657,2292),(11658,2293),(11659,2294),(11660,2295),(11661,2296),(11662,2297),(11663,2298),(11664,2299),(11665,2300),(11666,2301),(11667,2302),(11668,2303),(11669,2304),(11670,2305),(11671,2306),(11672,2307),(11673,2308),(11674,2309),(11675,2310),(11676,2311),(11677,2311),(11678,2311),(11679,2311),(11680,2312),(11681,2312),(11682,2312),(11683,2312),(11684,2313),(11685,2313),(11686,2313),(11687,2313),(11688,2314),(11689,2314),(11690,2314),(11691,2314),(11692,2315),(11693,2315),(11694,2315),(11695,2315),(11696,2316),(11697,2316),(11698,2316),(11699,2316),(11700,2317),(11701,2317),(11702,2317),(11703,2317),(11704,2318),(11705,2318),(11706,2318),(11707,2318),(11708,2319),(11709,2319),(11710,2319),(11711,2319),(11712,2320),(11713,2320),(11714,2320),(11715,2320),(11716,2321),(11717,2321),(11718,2321),(11719,2321),(11720,2311),(11721,2312),(11722,2313),(11723,2314),(11724,2315),(11725,2316),(11726,2317),(11727,2318),(11728,2319),(11729,2320),(11730,2321),(11731,2322),(11732,2322),(11733,2322),(11734,2322),(11735,2323),(11736,2323),(11737,2323),(11738,2323),(11739,2324),(11740,2324),(11741,2324),(11742,2324),(11743,2325),(11744,2325),(11745,2325),(11746,2325),(11747,2326),(11748,2326),(11749,2326),(11750,2326),(11751,2327),(11752,2327),(11753,2327),(11754,2327),(11755,2328),(11756,2328),(11757,2328),(11758,2328),(11759,2329),(11760,2329),(11761,2329),(11762,2329),(11763,2330),(11764,2330),(11765,2330),(11766,2330),(11767,2331),(11768,2331),(11769,2331),(11770,2331),(11771,2332),(11772,2332),(11773,2332),(11774,2332),(11775,2333),(11776,2333),(11777,2333),(11778,2333),(11779,2334),(11780,2334),(11781,2334),(11782,2334),(11783,2335),(11784,2335),(11785,2335),(11786,2335),(11787,2336),(11788,2336),(11789,2336),(11790,2336),(11791,2337),(11792,2337),(11793,2337),(11794,2337),(11795,2338),(11796,2338),(11797,2338),(11798,2338),(11799,2339),(11800,2339),(11801,2339),(11802,2339),(11803,2340),(11804,2340),(11805,2340),(11806,2340),(11807,2341),(11808,2341),(11809,2341),(11810,2341),(11811,2342),(11812,2342),(11813,2342),(11814,2342),(11815,2343),(11816,2343),(11817,2343),(11818,2343),(11819,2344),(11820,2344),(11821,2344),(11822,2344),(11823,2345),(11824,2345),(11825,2345),(11826,2345),(11827,2346),(11828,2346),(11829,2346),(11830,2346),(11831,2347),(11832,2347),(11833,2347),(11834,2347),(11835,2348),(11836,2348),(11837,2348),(11838,2348),(11839,2349),(11840,2349),(11841,2349),(11842,2349),(11843,2350),(11844,2350),(11845,2350),(11846,2350),(11847,2351),(11848,2351),(11849,2351),(11850,2351),(11851,2352),(11852,2352),(11853,2352),(11854,2352),(11855,2353),(11856,2353),(11857,2353),(11858,2353),(11859,2354),(11860,2354),(11861,2354),(11862,2354),(11863,2355),(11864,2355),(11865,2355),(11866,2355),(11867,2356),(11868,2356),(11869,2356),(11870,2356),(11871,2357),(11872,2357),(11873,2357),(11874,2357),(11875,2358),(11876,2358),(11877,2358),(11878,2358),(11879,2359),(11880,2359),(11881,2359),(11882,2359),(11883,2360),(11884,2360),(11885,2360),(11886,2360),(11887,2361),(11888,2361),(11889,2361),(11890,2361),(11891,2362),(11892,2362),(11893,2362),(11894,2362),(11895,2363),(11896,2363),(11897,2363),(11898,2363),(11899,2364),(11900,2364),(11901,2364),(11902,2364),(11903,2365),(11904,2365),(11905,2365),(11906,2365),(11907,2366),(11908,2366),(11909,2366),(11910,2366),(11911,2367),(11912,2367),(11913,2367),(11914,2367),(11915,2368),(11916,2368),(11917,2368),(11918,2368),(11919,2369),(11920,2369),(11921,2369),(11922,2369),(11923,2370),(11924,2370),(11925,2370),(11926,2370),(11927,2371),(11928,2371),(11929,2371),(11930,2371),(11931,2372),(11932,2372),(11933,2372),(11934,2372),(11935,2373),(11936,2373),(11937,2373),(11938,2373),(11939,2374),(11940,2374),(11941,2374),(11942,2374),(11943,2375),(11944,2375),(11945,2375),(11946,2375),(11947,2376),(11948,2376),(11949,2376),(11950,2376),(11951,2377),(11952,2377),(11953,2377),(11954,2377),(11955,2378),(11956,2378),(11957,2378),(11958,2378),(11959,2379),(11960,2379),(11961,2379),(11962,2379),(11963,2380),(11964,2380),(11965,2380),(11966,2380),(11967,2381),(11968,2381),(11969,2381),(11970,2381),(11971,2382),(11972,2382),(11973,2382),(11974,2382),(11975,2383),(11976,2383),(11977,2383),(11978,2383),(11979,2384),(11980,2384),(11981,2384),(11982,2384),(11983,2385),(11984,2385),(11985,2385),(11986,2385),(11987,2386),(11988,2386),(11989,2386),(11990,2386),(11991,2387),(11992,2387),(11993,2387),(11994,2387),(11995,2388),(11996,2388),(11997,2388),(11998,2388),(11999,2389),(12000,2389),(12001,2389),(12002,2389),(12003,2390),(12004,2390),(12005,2390),(12006,2390),(12007,2391),(12008,2391),(12009,2391),(12010,2391),(12011,2392),(12012,2392),(12013,2392),(12014,2392),(12015,2393),(12016,2393),(12017,2393),(12018,2393),(12019,2394),(12020,2394),(12021,2394),(12022,2394),(12023,2395),(12024,2395),(12025,2395),(12026,2395),(12027,2396),(12028,2396),(12029,2396),(12030,2396),(12031,2397),(12032,2397),(12033,2397),(12034,2397),(12035,2398),(12036,2398),(12037,2398),(12038,2398),(12039,2399),(12040,2399),(12041,2399),(12042,2399),(12043,2400),(12044,2400),(12045,2400),(12046,2400),(12047,2401),(12048,2401),(12049,2401),(12050,2401),(12051,2402),(12052,2402),(12053,2402),(12054,2402),(12055,2403),(12056,2403),(12057,2403),(12058,2403),(12059,2404),(12060,2404),(12061,2404),(12062,2404),(12063,2405),(12064,2405),(12065,2405),(12066,2405),(12067,2406),(12068,2406),(12069,2406),(12070,2406),(12071,2407),(12072,2407),(12073,2407),(12074,2407),(12075,2408),(12076,2408),(12077,2408),(12078,2408),(12079,2409),(12080,2409),(12081,2409),(12082,2409),(12083,2410),(12084,2410),(12085,2410),(12086,2410),(12087,2411),(12088,2411),(12089,2411),(12090,2411),(12091,2412),(12092,2412),(12093,2412),(12094,2412),(12095,2413),(12096,2413),(12097,2413),(12098,2413),(12099,2414),(12100,2414),(12101,2414),(12102,2414),(12103,2415),(12104,2415),(12105,2415),(12106,2415),(12107,2416),(12108,2416),(12109,2416),(12110,2416),(12111,2417),(12112,2417),(12113,2417),(12114,2417),(12115,2418),(12116,2418),(12117,2418),(12118,2418),(12119,2419),(12120,2419),(12121,2419),(12122,2419),(12123,2420),(12124,2420),(12125,2420),(12126,2420),(12127,2421),(12128,2421),(12129,2421),(12130,2421),(12131,2422),(12132,2422),(12133,2422),(12134,2422),(12135,2423),(12136,2423),(12137,2423),(12138,2423),(12139,2424),(12140,2424),(12141,2424),(12142,2424),(12143,2425),(12144,2425),(12145,2425),(12146,2425),(12147,2426),(12148,2426),(12149,2426),(12150,2426),(12151,2427),(12152,2427),(12153,2427),(12154,2427),(12155,2428),(12156,2428),(12157,2428),(12158,2428),(12159,2429),(12160,2429),(12161,2429),(12162,2429),(12163,2430),(12164,2430),(12165,2430),(12166,2430),(12167,2431),(12168,2431),(12169,2431),(12170,2431),(12171,2432),(12172,2432),(12173,2432),(12174,2432),(12175,2433),(12176,2433),(12177,2433),(12178,2433),(12179,2434),(12180,2434),(12181,2434),(12182,2434),(12183,2435),(12184,2435),(12185,2435),(12186,2435),(12187,2436),(12188,2436),(12189,2436),(12190,2436),(12191,2437),(12192,2437),(12193,2437),(12194,2437),(12195,2438),(12196,2438),(12197,2438),(12198,2438),(12199,2439),(12200,2439),(12201,2439),(12202,2439),(12203,2440),(12204,2440),(12205,2440),(12206,2440),(12207,2441),(12208,2441),(12209,2441),(12210,2441),(12211,2442),(12212,2442),(12213,2442),(12214,2442),(12215,2443),(12216,2443),(12217,2443),(12218,2443),(12219,2444),(12220,2444),(12221,2444),(12222,2444),(12223,2445),(12224,2445),(12225,2445),(12226,2445),(12227,2446),(12228,2446),(12229,2446),(12230,2446),(12231,2447),(12232,2447),(12233,2447),(12234,2447),(12235,2448),(12236,2448),(12237,2448),(12238,2448),(12239,2449),(12240,2449),(12241,2449),(12242,2449),(12243,2450),(12244,2450),(12245,2450),(12246,2450),(12247,2451),(12248,2451),(12249,2451),(12250,2451),(12251,2452),(12252,2452),(12253,2452),(12254,2452),(12255,2453),(12256,2453),(12257,2453),(12258,2453),(12259,2454),(12260,2454),(12261,2454),(12262,2454),(12263,2455),(12264,2455),(12265,2455),(12266,2455),(12267,2456),(12268,2456),(12269,2456),(12270,2456),(12271,2457),(12272,2457),(12273,2457),(12274,2457),(12275,2458),(12276,2458),(12277,2458),(12278,2458),(12279,2459),(12280,2459),(12281,2459),(12282,2459),(12283,2460),(12284,2460),(12285,2460),(12286,2460),(12287,2461),(12288,2461),(12289,2461),(12290,2461),(12291,2462),(12292,2462),(12293,2462),(12294,2462),(12295,2463),(12296,2463),(12297,2463),(12298,2463),(12299,2464),(12300,2464),(12301,2464),(12302,2464),(12303,2465),(12304,2465),(12305,2465),(12306,2465),(12307,2466),(12308,2466),(12309,2466),(12310,2466),(12311,2467),(12312,2467),(12313,2467),(12314,2467),(12315,2468),(12316,2468),(12317,2468),(12318,2468),(12319,2469),(12320,2469),(12321,2469),(12322,2469),(12323,2470),(12324,2470),(12325,2470),(12326,2470),(12327,2471),(12328,2471),(12329,2471),(12330,2471),(12331,2472),(12332,2472),(12333,2472),(12334,2472),(12335,2473),(12336,2473),(12337,2473),(12338,2473),(12339,2474),(12340,2474),(12341,2474),(12342,2474),(12343,2475),(12344,2475),(12345,2475),(12346,2475),(12347,2476),(12348,2476),(12349,2476),(12350,2476),(12351,2477),(12352,2477),(12353,2477),(12354,2477),(12355,2478),(12356,2478),(12357,2478),(12358,2478),(12359,2479),(12360,2479),(12361,2479),(12362,2479),(12363,2480),(12364,2480),(12365,2480),(12366,2480),(12367,2481),(12368,2481),(12369,2481),(12370,2481),(12371,2482),(12372,2482),(12373,2482),(12374,2482),(12375,2483),(12376,2483),(12377,2483),(12378,2483),(12379,2484),(12380,2484),(12381,2484),(12382,2484),(12383,2485),(12384,2485),(12385,2485),(12386,2485),(12387,2486),(12388,2486),(12389,2486),(12390,2486),(12391,2487),(12392,2487),(12393,2487),(12394,2487),(12395,2488),(12396,2488),(12397,2488),(12398,2488),(12399,2489),(12400,2489),(12401,2489),(12402,2489),(12403,2490),(12404,2490),(12405,2490),(12406,2490),(12407,2491),(12408,2491),(12409,2491),(12410,2491),(12411,2492),(12412,2492),(12413,2492),(12414,2492),(12415,2493),(12416,2493),(12417,2493),(12418,2493),(12419,2494),(12420,2494),(12421,2494),(12422,2494),(12423,2495),(12424,2495),(12425,2495),(12426,2495),(12427,2496),(12428,2496),(12429,2496),(12430,2496),(12431,2497),(12432,2497),(12433,2497),(12434,2497),(12435,2498),(12436,2498),(12437,2498),(12438,2498),(12439,2499),(12440,2499),(12441,2499),(12442,2499),(12443,2500),(12444,2500),(12445,2500),(12446,2500),(12447,2501),(12448,2501),(12449,2501),(12450,2501),(12451,2502),(12452,2502),(12453,2502),(12454,2502),(12455,2503),(12456,2503),(12457,2503),(12458,2503),(12459,2504),(12460,2504),(12461,2504),(12462,2504),(12463,2505),(12464,2505),(12465,2505),(12466,2505),(12467,2506),(12468,2506),(12469,2506),(12470,2506),(12471,2507),(12472,2507),(12473,2507),(12474,2507),(12475,2508),(12476,2508),(12477,2508),(12478,2508),(12479,2509),(12480,2509),(12481,2509),(12482,2509),(12483,2510),(12484,2510),(12485,2510),(12486,2510),(12487,2511),(12488,2511),(12489,2511),(12490,2511),(12491,2512),(12492,2512),(12493,2512),(12494,2512),(12495,2513),(12496,2513),(12497,2513),(12498,2513),(12499,2514),(12500,2514),(12501,2514),(12502,2514),(12503,2515),(12504,2515),(12505,2515),(12506,2515),(12507,2516),(12508,2516),(12509,2516),(12510,2516),(12511,2517),(12512,2517),(12513,2517),(12514,2517),(12515,2518),(12516,2518),(12517,2518),(12518,2518),(12519,2519),(12520,2519),(12521,2519),(12522,2519),(12523,2520),(12524,2520),(12525,2520),(12526,2520),(12527,2521),(12528,2521),(12529,2521),(12530,2521),(12531,2522),(12532,2522),(12533,2522),(12534,2522),(12535,2523),(12536,2523),(12537,2523),(12538,2523),(12539,2524),(12540,2524),(12541,2524),(12542,2524),(12543,2525),(12544,2525),(12545,2525),(12546,2525),(12547,2526),(12548,2526),(12549,2526),(12550,2526),(12551,2527),(12552,2527),(12553,2527),(12554,2527),(12555,2528),(12556,2528),(12557,2528),(12558,2528),(12559,2529),(12560,2529),(12561,2529),(12562,2529),(12563,2530),(12564,2530),(12565,2530),(12566,2530),(12567,2531),(12568,2531),(12569,2531),(12570,2531),(12571,2532),(12572,2532),(12573,2532),(12574,2532),(12575,2533),(12576,2533),(12577,2533),(12578,2533),(12579,2534),(12580,2534),(12581,2534),(12582,2534),(12583,2535),(12584,2535),(12585,2535),(12586,2535),(12587,2536),(12588,2536),(12589,2536),(12590,2536),(12591,2537),(12592,2537),(12593,2537),(12594,2537),(12595,2538),(12596,2538),(12597,2538),(12598,2538),(12599,2539),(12600,2539),(12601,2539),(12602,2539),(12603,2540),(12604,2540),(12605,2540),(12606,2540),(12607,2541),(12608,2541),(12609,2541),(12610,2541),(12611,2542),(12612,2542),(12613,2542),(12614,2542),(12615,2543),(12616,2543),(12617,2543),(12618,2543),(12619,2544),(12620,2544),(12621,2544),(12622,2544),(12623,2545),(12624,2545),(12625,2545),(12626,2545),(12627,2546),(12628,2546),(12629,2546),(12630,2546),(12631,2547),(12632,2547),(12633,2547),(12634,2547),(12635,2548),(12636,2548),(12637,2548),(12638,2548),(12639,2549),(12640,2549),(12641,2549),(12642,2549),(12643,2550),(12644,2550),(12645,2550),(12646,2550),(12647,2551),(12648,2551),(12649,2551),(12650,2551),(12651,2552),(12652,2552),(12653,2552),(12654,2552),(12655,2553),(12656,2553),(12657,2553),(12658,2553),(12659,2554),(12660,2554),(12661,2554),(12662,2554),(12663,2555),(12664,2555),(12665,2555),(12666,2555),(12667,2556),(12668,2556),(12669,2556),(12670,2556),(12671,2557),(12672,2557),(12673,2557),(12674,2557),(12675,2558),(12676,2558),(12677,2558),(12678,2558),(12679,2559),(12680,2559),(12681,2559),(12682,2559),(12683,2560),(12684,2560),(12685,2560),(12686,2560),(12687,2561),(12688,2561),(12689,2561),(12690,2561),(12691,2562),(12692,2562),(12693,2562),(12694,2562),(12695,2563),(12696,2563),(12697,2563),(12698,2563),(12699,2564),(12700,2564),(12701,2564),(12702,2564),(12703,2565),(12704,2565),(12705,2565),(12706,2565),(12707,2566),(12708,2566),(12709,2566),(12710,2566),(12711,2567),(12712,2567),(12713,2567),(12714,2567),(12715,2568),(12716,2568),(12717,2568),(12718,2568),(12719,2569),(12720,2569),(12721,2569),(12722,2569),(12723,2570),(12724,2570),(12725,2570),(12726,2570),(12727,2571),(12728,2571),(12729,2571),(12730,2571),(12731,2572),(12732,2572),(12733,2572),(12734,2572),(12735,2573),(12736,2573),(12737,2573),(12738,2573),(12739,2574),(12740,2574),(12741,2574),(12742,2574),(12743,2575),(12744,2575),(12745,2575),(12746,2575),(12747,2576),(12748,2576),(12749,2576),(12750,2576),(12751,2577),(12752,2577),(12753,2577),(12754,2577),(12755,2578),(12756,2578),(12757,2578),(12758,2578),(12759,2579),(12760,2579),(12761,2579),(12762,2579),(12763,2580),(12764,2580),(12765,2580),(12766,2580),(12767,2581),(12768,2581),(12769,2581),(12770,2581),(12771,2582),(12772,2582),(12773,2582),(12774,2582),(12775,2583),(12776,2583),(12777,2583),(12778,2583),(12779,2584),(12780,2584),(12781,2584),(12782,2584),(12783,2585),(12784,2585),(12785,2585),(12786,2585),(12787,2586),(12788,2586),(12789,2586),(12790,2586),(12791,2587),(12792,2587),(12793,2587),(12794,2587),(12795,2588),(12796,2588),(12797,2588),(12798,2588),(12799,2589),(12800,2589),(12801,2589),(12802,2589),(12803,2590),(12804,2590),(12805,2590),(12806,2590),(12807,2591),(12808,2591),(12809,2591),(12810,2591),(12811,2592),(12812,2592),(12813,2592),(12814,2592),(12815,2593),(12816,2593),(12817,2593),(12818,2593),(12819,2594),(12820,2594),(12821,2594),(12822,2594),(12823,2595),(12824,2595),(12825,2595),(12826,2595),(12827,2596),(12828,2596),(12829,2596),(12830,2596),(12831,2597),(12832,2597),(12833,2597),(12834,2597),(12835,2598),(12836,2598),(12837,2598),(12838,2598),(12839,2599),(12840,2599),(12841,2599),(12842,2599),(12843,2600),(12844,2600),(12845,2600),(12846,2600),(12847,2601),(12848,2601),(12849,2601),(12850,2601),(12851,2602),(12852,2602),(12853,2602),(12854,2602),(12855,2603),(12856,2603),(12857,2603),(12858,2603),(12859,2604),(12860,2604),(12861,2604),(12862,2604),(12863,2605),(12864,2605),(12865,2605),(12866,2605),(12867,2606),(12868,2606),(12869,2606),(12870,2606),(12871,2607),(12872,2607),(12873,2607),(12874,2607),(12875,2608),(12876,2608),(12877,2608),(12878,2608),(12879,2609),(12880,2609),(12881,2609),(12882,2609),(12883,2610),(12884,2610),(12885,2610),(12886,2610),(12887,2611),(12888,2611),(12889,2611),(12890,2611),(12891,2612),(12892,2612),(12893,2612),(12894,2612),(12895,2613),(12896,2613),(12897,2613),(12898,2613),(12899,2614),(12900,2614),(12901,2614),(12902,2614),(12903,2615),(12904,2615),(12905,2615),(12906,2615),(12907,2616),(12908,2616),(12909,2616),(12910,2616),(12911,2617),(12912,2617),(12913,2617),(12914,2617),(12915,2618),(12916,2618),(12917,2618),(12918,2618),(12919,2619),(12920,2619),(12921,2619),(12922,2619),(12923,2620),(12924,2620),(12925,2620),(12926,2620),(12927,2621),(12928,2621),(12929,2621),(12930,2621),(12931,2322),(12932,2323),(12933,2324),(12934,2325),(12935,2326),(12936,2327),(12937,2328),(12938,2329),(12939,2330),(12940,2331),(12941,2332),(12942,2333),(12943,2334),(12944,2335),(12945,2336),(12946,2337),(12947,2338),(12948,2339),(12949,2340),(12950,2341),(12951,2342),(12952,2343),(12953,2344),(12954,2345),(12955,2346),(12956,2347),(12957,2348),(12958,2349),(12959,2350),(12960,2351),(12961,2352),(12962,2353),(12963,2354),(12964,2355),(12965,2356),(12966,2357),(12967,2358),(12968,2359),(12969,2360),(12970,2361),(12971,2362),(12972,2363),(12973,2364),(12974,2365),(12975,2366),(12976,2367),(12977,2368),(12978,2369),(12979,2370),(12980,2371),(12981,2372),(12982,2373),(12983,2374),(12984,2375),(12985,2376),(12986,2377),(12987,2378),(12988,2379),(12989,2380),(12990,2381),(12991,2382),(12992,2383),(12993,2384),(12994,2385),(12995,2386),(12996,2387),(12997,2388),(12998,2389),(12999,2390),(13000,2391),(13001,2392),(13002,2393),(13003,2394),(13004,2395),(13005,2396),(13006,2397),(13007,2398),(13008,2399),(13009,2400),(13010,2401),(13011,2402),(13012,2403),(13013,2404),(13014,2405),(13015,2406),(13016,2407),(13017,2408),(13018,2409),(13019,2410),(13020,2411),(13021,2412),(13022,2413),(13023,2414),(13024,2415),(13025,2416),(13026,2417),(13027,2418),(13028,2419),(13029,2420),(13030,2421),(13031,2422),(13032,2423),(13033,2424),(13034,2425),(13035,2426),(13036,2427),(13037,2428),(13038,2429),(13039,2430),(13040,2431),(13041,2432),(13042,2433),(13043,2434),(13044,2435),(13045,2436),(13046,2437),(13047,2438),(13048,2439),(13049,2440),(13050,2441),(13051,2442),(13052,2443),(13053,2444),(13054,2445),(13055,2446),(13056,2447),(13057,2448),(13058,2449),(13059,2450),(13060,2451),(13061,2452),(13062,2453),(13063,2454),(13064,2455),(13065,2456),(13066,2457),(13067,2458),(13068,2459),(13069,2460),(13070,2461),(13071,2462),(13072,2463),(13073,2464),(13074,2465),(13075,2466),(13076,2467),(13077,2468),(13078,2469),(13079,2470),(13080,2471),(13081,2472),(13082,2473),(13083,2474),(13084,2475),(13085,2476),(13086,2477),(13087,2478),(13088,2479),(13089,2480),(13090,2481),(13091,2482),(13092,2483),(13093,2484),(13094,2485),(13095,2486),(13096,2487),(13097,2488),(13098,2489),(13099,2490),(13100,2491),(13101,2492),(13102,2493),(13103,2494),(13104,2495),(13105,2496),(13106,2497),(13107,2498),(13108,2499),(13109,2500),(13110,2501),(13111,2502),(13112,2503),(13113,2504),(13114,2505),(13115,2506),(13116,2507),(13117,2508),(13118,2509),(13119,2510),(13120,2511),(13121,2512),(13122,2513),(13123,2514),(13124,2515),(13125,2516),(13126,2517),(13127,2518),(13128,2519),(13129,2520),(13130,2521),(13131,2522),(13132,2523),(13133,2524),(13134,2525),(13135,2526),(13136,2527),(13137,2528),(13138,2529),(13139,2530),(13140,2531),(13141,2532),(13142,2533),(13143,2534),(13144,2535),(13145,2536),(13146,2537),(13147,2538),(13148,2539),(13149,2540),(13150,2541),(13151,2542),(13152,2543),(13153,2544),(13154,2545),(13155,2546),(13156,2547),(13157,2548),(13158,2549),(13159,2550),(13160,2551),(13161,2552),(13162,2553),(13163,2554),(13164,2555),(13165,2556),(13166,2557),(13167,2558),(13168,2559),(13169,2560),(13170,2561),(13171,2562),(13172,2563),(13173,2564),(13174,2565),(13175,2566),(13176,2567),(13177,2568),(13178,2569),(13179,2570),(13180,2571),(13181,2572),(13182,2573),(13183,2574),(13184,2575),(13185,2576),(13186,2577),(13187,2578),(13188,2579),(13189,2580),(13190,2581),(13191,2582),(13192,2583),(13193,2584),(13194,2585),(13195,2586),(13196,2587),(13197,2588),(13198,2589),(13199,2590),(13200,2591),(13201,2592),(13202,2593),(13203,2594),(13204,2595),(13205,2596),(13206,2597),(13207,2598),(13208,2599),(13209,2600),(13210,2601),(13211,2602),(13212,2603),(13213,2604),(13214,2605),(13215,2606),(13216,2607),(13217,2608),(13218,2609),(13219,2610),(13220,2611),(13221,2612),(13222,2613),(13223,2614),(13224,2615),(13225,2616),(13226,2617),(13227,2618),(13228,2619),(13229,2620),(13230,2621),(13231,2622),(13232,2622),(13233,2622),(13234,2622),(13235,2623),(13236,2623),(13237,2623),(13238,2623),(13239,2624),(13240,2624),(13241,2624),(13242,2624),(13243,2625),(13244,2625),(13245,2625),(13246,2625),(13247,2626),(13248,2626),(13249,2626),(13250,2626),(13251,2627),(13252,2627),(13253,2627),(13254,2627),(13255,2628),(13256,2628),(13257,2628),(13258,2628),(13259,2629),(13260,2629),(13261,2629),(13262,2629),(13263,2630),(13264,2630),(13265,2630),(13266,2630),(13267,2631),(13268,2631),(13269,2631),(13270,2631),(13271,2632),(13272,2632),(13273,2632),(13274,2632),(13275,2633),(13276,2633),(13277,2633),(13278,2633),(13279,2634),(13280,2634),(13281,2634),(13282,2634),(13283,2635),(13284,2635),(13285,2635),(13286,2635),(13287,2636),(13288,2636),(13289,2636),(13290,2636),(13291,2637),(13292,2637),(13293,2637),(13294,2637),(13295,2638),(13296,2638),(13297,2638),(13298,2638),(13299,2639),(13300,2639),(13301,2639),(13302,2639),(13303,2640),(13304,2640),(13305,2640),(13306,2640),(13307,2641),(13308,2641),(13309,2641),(13310,2641),(13311,2642),(13312,2642),(13313,2642),(13314,2642),(13315,2643),(13316,2643),(13317,2643),(13318,2643),(13319,2644),(13320,2644),(13321,2644),(13322,2644),(13323,2645),(13324,2645),(13325,2645),(13326,2645),(13327,2646),(13328,2646),(13329,2646),(13330,2646),(13331,2647),(13332,2647),(13333,2647),(13334,2647),(13335,2648),(13336,2648),(13337,2648),(13338,2648),(13339,2649),(13340,2649),(13341,2649),(13342,2649),(13343,2650),(13344,2650),(13345,2650),(13346,2650),(13347,2651),(13348,2651),(13349,2651),(13350,2651),(13351,2652),(13352,2652),(13353,2652),(13354,2652),(13355,2653),(13356,2653),(13357,2653),(13358,2653),(13359,2654),(13360,2654),(13361,2654),(13362,2654),(13363,2655),(13364,2655),(13365,2655),(13366,2655),(13367,2656),(13368,2656),(13369,2656),(13370,2656),(13371,2657),(13372,2657),(13373,2657),(13374,2657),(13375,2658),(13376,2658),(13377,2658),(13378,2658),(13379,2659),(13380,2659),(13381,2659),(13382,2659),(13383,2660),(13384,2660),(13385,2660),(13386,2660),(13387,2661),(13388,2661),(13389,2661),(13390,2661),(13391,2662),(13392,2662),(13393,2662),(13394,2662),(13395,2663),(13396,2663),(13397,2663),(13398,2663),(13399,2664),(13400,2664),(13401,2664),(13402,2664),(13403,2665),(13404,2665),(13405,2665),(13406,2665),(13407,2666),(13408,2666),(13409,2666),(13410,2666),(13411,2667),(13412,2667),(13413,2667),(13414,2667),(13415,2668),(13416,2668),(13417,2668),(13418,2668),(13419,2669),(13420,2669),(13421,2669),(13422,2669),(13423,2670),(13424,2670),(13425,2670),(13426,2670),(13427,2671),(13428,2671),(13429,2671),(13430,2671),(13431,2672),(13432,2672),(13433,2672),(13434,2672),(13435,2673),(13436,2673),(13437,2673),(13438,2673),(13439,2674),(13440,2674),(13441,2674),(13442,2674),(13443,2675),(13444,2675),(13445,2675),(13446,2675),(13447,2676),(13448,2676),(13449,2676),(13450,2676),(13451,2677),(13452,2677),(13453,2677),(13454,2677),(13455,2678),(13456,2678),(13457,2678),(13458,2678),(13459,2679),(13460,2679),(13461,2679),(13462,2679),(13463,2680),(13464,2680),(13465,2680),(13466,2680),(13467,2681),(13468,2681),(13469,2681),(13470,2681),(13471,2682),(13472,2682),(13473,2682),(13474,2682),(13475,2683),(13476,2683),(13477,2683),(13478,2683),(13479,2684),(13480,2684),(13481,2684),(13482,2684),(13483,2685),(13484,2685),(13485,2685),(13486,2685),(13487,2686),(13488,2686),(13489,2686),(13490,2686),(13491,2687),(13492,2687),(13493,2687),(13494,2687),(13495,2688),(13496,2688),(13497,2688),(13498,2688),(13499,2689),(13500,2689),(13501,2689),(13502,2689),(13503,2690),(13504,2690),(13505,2690),(13506,2690),(13507,2691),(13508,2691),(13509,2691),(13510,2691),(13511,2692),(13512,2692),(13513,2692),(13514,2692),(13515,2693),(13516,2693),(13517,2693),(13518,2693),(13519,2694),(13520,2694),(13521,2694),(13522,2694),(13523,2695),(13524,2695),(13525,2695),(13526,2695),(13527,2696),(13528,2696),(13529,2696),(13530,2696),(13531,2697),(13532,2697),(13533,2697),(13534,2697),(13535,2698),(13536,2698),(13537,2698),(13538,2698),(13539,2699),(13540,2699),(13541,2699),(13542,2699),(13543,2700),(13544,2700),(13545,2700),(13546,2700),(13547,2701),(13548,2701),(13549,2701),(13550,2701),(13551,2702),(13552,2702),(13553,2702),(13554,2702),(13555,2703),(13556,2703),(13557,2703),(13558,2703),(13559,2704),(13560,2704),(13561,2704),(13562,2704),(13563,2705),(13564,2705),(13565,2705),(13566,2705),(13567,2706),(13568,2706),(13569,2706),(13570,2706),(13571,2707),(13572,2707),(13573,2707),(13574,2707),(13575,2708),(13576,2708),(13577,2708),(13578,2708),(13579,2709),(13580,2709),(13581,2709),(13582,2709),(13583,2710),(13584,2710),(13585,2710),(13586,2710),(13587,2711),(13588,2711),(13589,2711),(13590,2711),(13591,2712),(13592,2712),(13593,2712),(13594,2712),(13595,2713),(13596,2713),(13597,2713),(13598,2713),(13599,2714),(13600,2714),(13601,2714),(13602,2714),(13603,2715),(13604,2715),(13605,2715),(13606,2715),(13607,2716),(13608,2716),(13609,2716),(13610,2716),(13611,2717),(13612,2717),(13613,2717),(13614,2717),(13615,2718),(13616,2718),(13617,2718),(13618,2718),(13619,2719),(13620,2719),(13621,2719),(13622,2719),(13623,2720),(13624,2720),(13625,2720),(13626,2720),(13627,2721),(13628,2721),(13629,2721),(13630,2721),(13631,2722),(13632,2722),(13633,2722),(13634,2722),(13635,2723),(13636,2723),(13637,2723),(13638,2723),(13639,2724),(13640,2724),(13641,2724),(13642,2724),(13643,2725),(13644,2725),(13645,2725),(13646,2725),(13647,2726),(13648,2726),(13649,2726),(13650,2726),(13651,2727),(13652,2727),(13653,2727),(13654,2727),(13655,2728),(13656,2728),(13657,2728),(13658,2728),(13659,2729),(13660,2729),(13661,2729),(13662,2729),(13663,2730),(13664,2730),(13665,2730),(13666,2730),(13667,2731),(13668,2731),(13669,2731),(13670,2731),(13671,2732),(13672,2732),(13673,2732),(13674,2732),(13675,2733),(13676,2733),(13677,2733),(13678,2733),(13679,2734),(13680,2734),(13681,2734),(13682,2734),(13683,2735),(13684,2735),(13685,2735),(13686,2735),(13687,2736),(13688,2736),(13689,2736),(13690,2736),(13691,2737),(13692,2737),(13693,2737),(13694,2737),(13695,2738),(13696,2738),(13697,2738),(13698,2738),(13699,2739),(13700,2739),(13701,2739),(13702,2739),(13703,2740),(13704,2740),(13705,2740),(13706,2740),(13707,2741),(13708,2741),(13709,2741),(13710,2741),(13711,2742),(13712,2742),(13713,2742),(13714,2742),(13715,2743),(13716,2743),(13717,2743),(13718,2743),(13719,2744),(13720,2744),(13721,2744),(13722,2744),(13723,2745),(13724,2745),(13725,2745),(13726,2745),(13727,2746),(13728,2746),(13729,2746),(13730,2746),(13731,2747),(13732,2747),(13733,2747),(13734,2747),(13735,2748),(13736,2748),(13737,2748),(13738,2748),(13739,2749),(13740,2749),(13741,2749),(13742,2749),(13743,2750),(13744,2750),(13745,2750),(13746,2750),(13747,2751),(13748,2751),(13749,2751),(13750,2751),(13751,2752),(13752,2752),(13753,2752),(13754,2752),(13755,2753),(13756,2753),(13757,2753),(13758,2753),(13759,2754),(13760,2754),(13761,2754),(13762,2754),(13763,2755),(13764,2755),(13765,2755),(13766,2755),(13767,2756),(13768,2756),(13769,2756),(13770,2756),(13771,2757),(13772,2757),(13773,2757),(13774,2757),(13775,2758),(13776,2758),(13777,2758),(13778,2758),(13779,2759),(13780,2759),(13781,2759),(13782,2759),(13783,2760),(13784,2760),(13785,2760),(13786,2760),(13787,2761),(13788,2761),(13789,2761),(13790,2761),(13791,2762),(13792,2762),(13793,2762),(13794,2762),(13795,2763),(13796,2763),(13797,2763),(13798,2763),(13799,2764),(13800,2764),(13801,2764),(13802,2764),(13803,2765),(13804,2765),(13805,2765),(13806,2765),(13807,2766),(13808,2766),(13809,2766),(13810,2766),(13811,2767),(13812,2767),(13813,2767),(13814,2767),(13815,2768),(13816,2768),(13817,2768),(13818,2768),(13819,2769),(13820,2769),(13821,2769),(13822,2769),(13823,2770),(13824,2770),(13825,2770),(13826,2770),(13827,2771),(13828,2771),(13829,2771),(13830,2771),(13831,2772),(13832,2772),(13833,2772),(13834,2772),(13835,2773),(13836,2773),(13837,2773),(13838,2773),(13839,2774),(13840,2774),(13841,2774),(13842,2774),(13843,2775),(13844,2775),(13845,2775),(13846,2775),(13847,2776),(13848,2776),(13849,2776),(13850,2776),(13851,2777),(13852,2777),(13853,2777),(13854,2777),(13855,2778),(13856,2778),(13857,2778),(13858,2778),(13859,2779),(13860,2779),(13861,2779),(13862,2779),(13863,2780),(13864,2780),(13865,2780),(13866,2780),(13867,2781),(13868,2781),(13869,2781),(13870,2781),(13871,2782),(13872,2782),(13873,2782),(13874,2782),(13875,2783),(13876,2783),(13877,2783),(13878,2783),(13879,2784),(13880,2784),(13881,2784),(13882,2784),(13883,2785),(13884,2785),(13885,2785),(13886,2785),(13887,2786),(13888,2786),(13889,2786),(13890,2786),(13891,2787),(13892,2787),(13893,2787),(13894,2787),(13895,2788),(13896,2788),(13897,2788),(13898,2788),(13899,2789),(13900,2789),(13901,2789),(13902,2789),(13903,2790),(13904,2790),(13905,2790),(13906,2790),(13907,2791),(13908,2791),(13909,2791),(13910,2791),(13911,2792),(13912,2792),(13913,2792),(13914,2792),(13915,2793),(13916,2793),(13917,2793),(13918,2793),(13919,2794),(13920,2794),(13921,2794),(13922,2794),(13923,2795),(13924,2795),(13925,2795),(13926,2795),(13927,2796),(13928,2796),(13929,2796),(13930,2796),(13931,2797),(13932,2797),(13933,2797),(13934,2797),(13935,2798),(13936,2798),(13937,2798),(13938,2798),(13939,2799),(13940,2799),(13941,2799),(13942,2799),(13943,2800),(13944,2800),(13945,2800),(13946,2800),(13947,2801),(13948,2801),(13949,2801),(13950,2801),(13951,2802),(13952,2802),(13953,2802),(13954,2802),(13955,2803),(13956,2803),(13957,2803),(13958,2803),(13959,2804),(13960,2804),(13961,2804),(13962,2804),(13963,2805),(13964,2805),(13965,2805),(13966,2805),(13967,2806),(13968,2806),(13969,2806),(13970,2806),(13971,2807),(13972,2807),(13973,2807),(13974,2807),(13975,2808),(13976,2808),(13977,2808),(13978,2808),(13979,2809),(13980,2809),(13981,2809),(13982,2809),(13983,2810),(13984,2810),(13985,2810),(13986,2810),(13987,2811),(13988,2811),(13989,2811),(13990,2811),(13991,2812),(13992,2812),(13993,2812),(13994,2812),(13995,2813),(13996,2813),(13997,2813),(13998,2813),(13999,2814),(14000,2814),(14001,2814),(14002,2814),(14003,2815),(14004,2815),(14005,2815),(14006,2815),(14007,2816),(14008,2816),(14009,2816),(14010,2816),(14011,2817),(14012,2817),(14013,2817),(14014,2817),(14015,2818),(14016,2818),(14017,2818),(14018,2818),(14019,2819),(14020,2819),(14021,2819),(14022,2819),(14023,2820),(14024,2820),(14025,2820),(14026,2820),(14027,2821),(14028,2821),(14029,2821),(14030,2821),(14031,2822),(14032,2822),(14033,2822),(14034,2822),(14035,2823),(14036,2823),(14037,2823),(14038,2823),(14039,2824),(14040,2824),(14041,2824),(14042,2824),(14043,2825),(14044,2825),(14045,2825),(14046,2825),(14047,2826),(14048,2826),(14049,2826),(14050,2826),(14051,2827),(14052,2827),(14053,2827),(14054,2827),(14055,2828),(14056,2828),(14057,2828),(14058,2828),(14059,2829),(14060,2829),(14061,2829),(14062,2829),(14063,2830),(14064,2830),(14065,2830),(14066,2830),(14067,2831),(14068,2831),(14069,2831),(14070,2831),(14071,2832),(14072,2832),(14073,2832),(14074,2832),(14075,2833),(14076,2833),(14077,2833),(14078,2833),(14079,2834),(14080,2834),(14081,2834),(14082,2834),(14083,2835),(14084,2835),(14085,2835),(14086,2835),(14087,2836),(14088,2836),(14089,2836),(14090,2836),(14091,2837),(14092,2837),(14093,2837),(14094,2837),(14095,2838),(14096,2838),(14097,2838),(14098,2838),(14099,2839),(14100,2839),(14101,2839),(14102,2839),(14103,2840),(14104,2840),(14105,2840),(14106,2840),(14107,2841),(14108,2841),(14109,2841),(14110,2841),(14111,2842),(14112,2842),(14113,2842),(14114,2842),(14115,2843),(14116,2843),(14117,2843),(14118,2843),(14119,2844),(14120,2844),(14121,2844),(14122,2844),(14123,2845),(14124,2845),(14125,2845),(14126,2845),(14127,2846),(14128,2846),(14129,2846),(14130,2846),(14131,2847),(14132,2847),(14133,2847),(14134,2847),(14135,2848),(14136,2848),(14137,2848),(14138,2848),(14139,2849),(14140,2849),(14141,2849),(14142,2849),(14143,2850),(14144,2850),(14145,2850),(14146,2850),(14147,2851),(14148,2851),(14149,2851),(14150,2851),(14151,2852),(14152,2852),(14153,2852),(14154,2852),(14155,2853),(14156,2853),(14157,2853),(14158,2853),(14159,2854),(14160,2854),(14161,2854),(14162,2854),(14163,2855),(14164,2855),(14165,2855),(14166,2855),(14167,2856),(14168,2856),(14169,2856),(14170,2856),(14171,2857),(14172,2857),(14173,2857),(14174,2857),(14175,2858),(14176,2858),(14177,2858),(14178,2858),(14179,2859),(14180,2859),(14181,2859),(14182,2859),(14183,2860),(14184,2860),(14185,2860),(14186,2860),(14187,2861),(14188,2861),(14189,2861),(14190,2861),(14191,2862),(14192,2862),(14193,2862),(14194,2862),(14195,2863),(14196,2863),(14197,2863),(14198,2863),(14199,2864),(14200,2864),(14201,2864),(14202,2864),(14203,2865),(14204,2865),(14205,2865),(14206,2865),(14207,2866),(14208,2866),(14209,2866),(14210,2866),(14211,2867),(14212,2867),(14213,2867),(14214,2867),(14215,2868),(14216,2868),(14217,2868),(14218,2868),(14219,2869),(14220,2869),(14221,2869),(14222,2869),(14223,2870),(14224,2870),(14225,2870),(14226,2870),(14227,2871),(14228,2871),(14229,2871),(14230,2871),(14231,2872),(14232,2872),(14233,2872),(14234,2872),(14235,2873),(14236,2873),(14237,2873),(14238,2873),(14239,2874),(14240,2874),(14241,2874),(14242,2874),(14243,2875),(14244,2875),(14245,2875),(14246,2875),(14247,2876),(14248,2876),(14249,2876),(14250,2876),(14251,2877),(14252,2877),(14253,2877),(14254,2877),(14255,2878),(14256,2878),(14257,2878),(14258,2878),(14259,2879),(14260,2879),(14261,2879),(14262,2879),(14263,2880),(14264,2880),(14265,2880),(14266,2880),(14267,2881),(14268,2881),(14269,2881),(14270,2881),(14271,2882),(14272,2882),(14273,2882),(14274,2882),(14275,2883),(14276,2883),(14277,2883),(14278,2883),(14279,2884),(14280,2884),(14281,2884),(14282,2884),(14283,2885),(14284,2885),(14285,2885),(14286,2885),(14287,2886),(14288,2886),(14289,2886),(14290,2886),(14291,2887),(14292,2887),(14293,2887),(14294,2887),(14295,2888),(14296,2888),(14297,2888),(14298,2888),(14299,2889),(14300,2889),(14301,2889),(14302,2889),(14303,2890),(14304,2890),(14305,2890),(14306,2890),(14307,2891),(14308,2891),(14309,2891),(14310,2891),(14311,2892),(14312,2892),(14313,2892),(14314,2892),(14315,2893),(14316,2893),(14317,2893),(14318,2893),(14319,2894),(14320,2894),(14321,2894),(14322,2894),(14323,2895),(14324,2895),(14325,2895),(14326,2895),(14327,2896),(14328,2896),(14329,2896),(14330,2896),(14331,2897),(14332,2897),(14333,2897),(14334,2897),(14335,2898),(14336,2898),(14337,2898),(14338,2898),(14339,2899),(14340,2899),(14341,2899),(14342,2899),(14343,2900),(14344,2900),(14345,2900),(14346,2900),(14347,2901),(14348,2901),(14349,2901),(14350,2901),(14351,2902),(14352,2902),(14353,2902),(14354,2902),(14355,2903),(14356,2903),(14357,2903),(14358,2903),(14359,2904),(14360,2904),(14361,2904),(14362,2904),(14363,2905),(14364,2905),(14365,2905),(14366,2905),(14367,2906),(14368,2906),(14369,2906),(14370,2906),(14371,2907),(14372,2907),(14373,2907),(14374,2907),(14375,2908),(14376,2908),(14377,2908),(14378,2908),(14379,2909),(14380,2909),(14381,2909),(14382,2909),(14383,2910),(14384,2910),(14385,2910),(14386,2910),(14387,2911),(14388,2911),(14389,2911),(14390,2911),(14391,2912),(14392,2912),(14393,2912),(14394,2912),(14395,2913),(14396,2913),(14397,2913),(14398,2913),(14399,2914),(14400,2914),(14401,2914),(14402,2914),(14403,2915),(14404,2915),(14405,2915),(14406,2915),(14407,2916),(14408,2916),(14409,2916),(14410,2916),(14411,2917),(14412,2917),(14413,2917),(14414,2917),(14415,2918),(14416,2918),(14417,2918),(14418,2918),(14419,2919),(14420,2919),(14421,2919),(14422,2919),(14423,2920),(14424,2920),(14425,2920),(14426,2920),(14427,2921),(14428,2921),(14429,2921),(14430,2921),(14431,2922),(14432,2922),(14433,2922),(14434,2922),(14435,2923),(14436,2923),(14437,2923),(14438,2923),(14439,2924),(14440,2924),(14441,2924),(14442,2924),(14443,2925),(14444,2925),(14445,2925),(14446,2925),(14447,2926),(14448,2926),(14449,2926),(14450,2926),(14451,2927),(14452,2927),(14453,2927),(14454,2927),(14455,2928),(14456,2928),(14457,2928),(14458,2928),(14459,2929),(14460,2929),(14461,2929),(14462,2929),(14463,2930),(14464,2930),(14465,2930),(14466,2930),(14467,2931),(14468,2931),(14469,2931),(14470,2931),(14471,2932),(14472,2932),(14473,2932),(14474,2932),(14475,2933),(14476,2933),(14477,2933),(14478,2933),(14479,2934),(14480,2934),(14481,2934),(14482,2934),(14483,2935),(14484,2935),(14485,2935),(14486,2935),(14487,2936),(14488,2936),(14489,2936),(14490,2936),(14491,2937),(14492,2937),(14493,2937),(14494,2937),(14495,2938),(14496,2938),(14497,2938),(14498,2938),(14499,2939),(14500,2939),(14501,2939),(14502,2939),(14503,2940),(14504,2940),(14505,2940),(14506,2940),(14507,2941),(14508,2941),(14509,2941),(14510,2941),(14511,2942),(14512,2942),(14513,2942),(14514,2942),(14515,2943),(14516,2943),(14517,2943),(14518,2943),(14519,2944),(14520,2944),(14521,2944),(14522,2944),(14523,2945),(14524,2945),(14525,2945),(14526,2945),(14527,2946),(14528,2946),(14529,2946),(14530,2946),(14531,2947),(14532,2947),(14533,2947),(14534,2947),(14535,2948),(14536,2948),(14537,2948),(14538,2948),(14539,2949),(14540,2949),(14541,2949),(14542,2949),(14543,2950),(14544,2950),(14545,2950),(14546,2950),(14547,2951),(14548,2951),(14549,2951),(14550,2951),(14551,2952),(14552,2952),(14553,2952),(14554,2952),(14555,2953),(14556,2953),(14557,2953),(14558,2953),(14559,2954),(14560,2954),(14561,2954),(14562,2954),(14563,2955),(14564,2955),(14565,2955),(14566,2955),(14567,2956),(14568,2956),(14569,2956),(14570,2956),(14571,2957),(14572,2957),(14573,2957),(14574,2957),(14575,2958),(14576,2958),(14577,2958),(14578,2958),(14579,2959),(14580,2959),(14581,2959),(14582,2959),(14583,2960),(14584,2960),(14585,2960),(14586,2960),(14587,2961),(14588,2961),(14589,2961),(14590,2961),(14591,2962),(14592,2962),(14593,2962),(14594,2962),(14595,2963),(14596,2963),(14597,2963),(14598,2963),(14599,2964),(14600,2964),(14601,2964),(14602,2964),(14603,2965),(14604,2965),(14605,2965),(14606,2965),(14607,2966),(14608,2966),(14609,2966),(14610,2966),(14611,2967),(14612,2967),(14613,2967),(14614,2967),(14615,2968),(14616,2968),(14617,2968),(14618,2968),(14619,2969),(14620,2969),(14621,2969),(14622,2969),(14623,2970),(14624,2970),(14625,2970),(14626,2970),(14627,2971),(14628,2971),(14629,2971),(14630,2971),(14631,2972),(14632,2972),(14633,2972),(14634,2972),(14635,2973),(14636,2973),(14637,2973),(14638,2973),(14639,2974),(14640,2974),(14641,2974),(14642,2974),(14643,2975),(14644,2975),(14645,2975),(14646,2975),(14647,2976),(14648,2976),(14649,2976),(14650,2976),(14651,2977),(14652,2977),(14653,2977),(14654,2977),(14655,2978),(14656,2978),(14657,2978),(14658,2978),(14659,2979),(14660,2979),(14661,2979),(14662,2979),(14663,2980),(14664,2980),(14665,2980),(14666,2980),(14667,2981),(14668,2981),(14669,2981),(14670,2981),(14671,2982),(14672,2982),(14673,2982),(14674,2982),(14675,2983),(14676,2983),(14677,2983),(14678,2983),(14679,2984),(14680,2984),(14681,2984),(14682,2984),(14683,2985),(14684,2985),(14685,2985),(14686,2985),(14687,2986),(14688,2986),(14689,2986),(14690,2986),(14691,2987),(14692,2987),(14693,2987),(14694,2987),(14695,2988),(14696,2988),(14697,2988),(14698,2988),(14699,2989),(14700,2989),(14701,2989),(14702,2989),(14703,2990),(14704,2990),(14705,2990),(14706,2990),(14707,2991),(14708,2991),(14709,2991),(14710,2991),(14711,2992),(14712,2992),(14713,2992),(14714,2992),(14715,2993),(14716,2993),(14717,2993),(14718,2993),(14719,2994),(14720,2994),(14721,2994),(14722,2994),(14723,2995),(14724,2995),(14725,2995),(14726,2995),(14727,2996),(14728,2996),(14729,2996),(14730,2996),(14731,2997),(14732,2997),(14733,2997),(14734,2997),(14735,2998),(14736,2998),(14737,2998),(14738,2998),(14739,2999),(14740,2999),(14741,2999),(14742,2999),(14743,3000),(14744,3000),(14745,3000),(14746,3000),(14747,3001),(14748,3001),(14749,3001),(14750,3001),(14751,3002),(14752,3002),(14753,3002),(14754,3002),(14755,3003),(14756,3003),(14757,3003),(14758,3003),(14759,3004),(14760,3004),(14761,3004),(14762,3004),(14763,3005),(14764,3005),(14765,3005),(14766,3005),(14767,3006),(14768,3006),(14769,3006),(14770,3006),(14771,3007),(14772,3007),(14773,3007),(14774,3007),(14775,3008),(14776,3008),(14777,3008),(14778,3008),(14779,3009),(14780,3009),(14781,3009),(14782,3009),(14783,3010),(14784,3010),(14785,3010),(14786,3010),(14787,3011),(14788,3011),(14789,3011),(14790,3011),(14791,3012),(14792,3012),(14793,3012),(14794,3012),(14795,3013),(14796,3013),(14797,3013),(14798,3013),(14799,3014),(14800,3014),(14801,3014),(14802,3014),(14803,3015),(14804,3015),(14805,3015),(14806,3015),(14807,3016),(14808,3016),(14809,3016),(14810,3016),(14811,3017),(14812,3017),(14813,3017),(14814,3017),(14815,3018),(14816,3018),(14817,3018),(14818,3018),(14819,3019),(14820,3019),(14821,3019),(14822,3019),(14823,3020),(14824,3020),(14825,3020),(14826,3020),(14827,3021),(14828,3021),(14829,3021),(14830,3021),(14831,3022),(14832,3022),(14833,3022),(14834,3022),(14835,3023),(14836,3023),(14837,3023),(14838,3023),(14839,3024),(14840,3024),(14841,3024),(14842,3024),(14843,3025),(14844,3025),(14845,3025),(14846,3025),(14847,3026),(14848,3026),(14849,3026),(14850,3026),(14851,3027),(14852,3027),(14853,3027),(14854,3027),(14855,3028),(14856,3028),(14857,3028),(14858,3028),(14859,3029),(14860,3029),(14861,3029),(14862,3029),(14863,3030),(14864,3030),(14865,3030),(14866,3030),(14867,3031),(14868,3031),(14869,3031),(14870,3031),(14871,3032),(14872,3032),(14873,3032),(14874,3032),(14875,3033),(14876,3033),(14877,3033),(14878,3033),(14879,3034),(14880,3034),(14881,3034),(14882,3034),(14883,3035),(14884,3035),(14885,3035),(14886,3035),(14887,3036),(14888,3036),(14889,3036),(14890,3036),(14891,3037),(14892,3037),(14893,3037),(14894,3037),(14895,3038),(14896,3038),(14897,3038),(14898,3038),(14899,3039),(14900,3039),(14901,3039),(14902,3039),(14903,3040),(14904,3040),(14905,3040),(14906,3040),(14907,3041),(14908,3041),(14909,3041),(14910,3041),(14911,3042),(14912,3042),(14913,3042),(14914,3042),(14915,3043),(14916,3043),(14917,3043),(14918,3043),(14919,3044),(14920,3044),(14921,3044),(14922,3044),(14923,3045),(14924,3045),(14925,3045),(14926,3045),(14927,3046),(14928,3046),(14929,3046),(14930,3046),(14931,3047),(14932,3047),(14933,3047),(14934,3047),(14935,3048),(14936,3048),(14937,3048),(14938,3048),(14939,3049),(14940,3049),(14941,3049),(14942,3049),(14943,3050),(14944,3050),(14945,3050),(14946,3050),(14947,3051),(14948,3051),(14949,3051),(14950,3051),(14951,3052),(14952,3052),(14953,3052),(14954,3052),(14955,3053),(14956,3053),(14957,3053),(14958,3053),(14959,3054),(14960,3054),(14961,3054),(14962,3054),(14963,3055),(14964,3055),(14965,3055),(14966,3055),(14967,3056),(14968,3056),(14969,3056),(14970,3056),(14971,3057),(14972,3057),(14973,3057),(14974,3057),(14975,3058),(14976,3058),(14977,3058),(14978,3058),(14979,3059),(14980,3059),(14981,3059),(14982,3059),(14983,3060),(14984,3060),(14985,3060),(14986,3060),(14987,3061),(14988,3061),(14989,3061),(14990,3061),(14991,3062),(14992,3062),(14993,3062),(14994,3062),(14995,3063),(14996,3063),(14997,3063),(14998,3063),(14999,3064),(15000,3064),(15001,3064),(15002,3064),(15003,3065),(15004,3065),(15005,3065),(15006,3065),(15007,3066),(15008,3066),(15009,3066),(15010,3066),(15011,3067),(15012,3067),(15013,3067),(15014,3067),(15015,3068),(15016,3068),(15017,3068),(15018,3068),(15019,3069),(15020,3069),(15021,3069),(15022,3069),(15023,3070),(15024,3070),(15025,3070),(15026,3070),(15027,3071),(15028,3071),(15029,3071),(15030,3071),(15031,3072),(15032,3072),(15033,3072),(15034,3072),(15035,3073),(15036,3073),(15037,3073),(15038,3073),(15039,3074),(15040,3074),(15041,3074),(15042,3074),(15043,3075),(15044,3075),(15045,3075),(15046,3075),(15047,3076),(15048,3076),(15049,3076),(15050,3076),(15051,3077),(15052,3077),(15053,3077),(15054,3077),(15055,3078),(15056,3078),(15057,3078),(15058,3078),(15059,3079),(15060,3079),(15061,3079),(15062,3079),(15063,3080),(15064,3080),(15065,3080),(15066,3080),(15067,3081),(15068,3081),(15069,3081),(15070,3081),(15071,3082),(15072,3082),(15073,3082),(15074,3082),(15075,3083),(15076,3083),(15077,3083),(15078,3083),(15079,3084),(15080,3084),(15081,3084),(15082,3084),(15083,3085),(15084,3085),(15085,3085),(15086,3085),(15087,3086),(15088,3086),(15089,3086),(15090,3086),(15091,3087),(15092,3087),(15093,3087),(15094,3087),(15095,3088),(15096,3088),(15097,3088),(15098,3088),(15099,3089),(15100,3089),(15101,3089),(15102,3089),(15103,3090),(15104,3090),(15105,3090),(15106,3090),(15107,3091),(15108,3091),(15109,3091),(15110,3091),(15111,3092),(15112,3092),(15113,3092),(15114,3092),(15115,3093),(15116,3093),(15117,3093),(15118,3093),(15119,3094),(15120,3094),(15121,3094),(15122,3094),(15123,3095),(15124,3095),(15125,3095),(15126,3095),(15127,3096),(15128,3096),(15129,3096),(15130,3096),(15131,3097),(15132,3097),(15133,3097),(15134,3097),(15135,3098),(15136,3098),(15137,3098),(15138,3098),(15139,3099),(15140,3099),(15141,3099),(15142,3099),(15143,3100),(15144,3100),(15145,3100),(15146,3100),(15147,3101),(15148,3101),(15149,3101),(15150,3101),(15151,3102),(15152,3102),(15153,3102),(15154,3102),(15155,3103),(15156,3103),(15157,3103),(15158,3103),(15159,3104),(15160,3104),(15161,3104),(15162,3104),(15163,3105),(15164,3105),(15165,3105),(15166,3105),(15167,3106),(15168,3106),(15169,3106),(15170,3106),(15171,3107),(15172,3107),(15173,3107),(15174,3107),(15175,3108),(15176,3108),(15177,3108),(15178,3108),(15179,3109),(15180,3109),(15181,3109),(15182,3109),(15183,3110),(15184,3110),(15185,3110),(15186,3110),(15187,3111),(15188,3111),(15189,3111),(15190,3111),(15191,3112),(15192,3112),(15193,3112),(15194,3112),(15195,3113),(15196,3113),(15197,3113),(15198,3113),(15199,3114),(15200,3114),(15201,3114),(15202,3114),(15203,3115),(15204,3115),(15205,3115),(15206,3115),(15207,3116),(15208,3116),(15209,3116),(15210,3116),(15211,3117),(15212,3117),(15213,3117),(15214,3117),(15215,3118),(15216,3118),(15217,3118),(15218,3118),(15219,3119),(15220,3119),(15221,3119),(15222,3119),(15223,3120),(15224,3120),(15225,3120),(15226,3120),(15227,3121),(15228,3121),(15229,3121),(15230,3121),(15231,3122),(15232,3122),(15233,3122),(15234,3122),(15235,3123),(15236,3123),(15237,3123),(15238,3123),(15239,3124),(15240,3124),(15241,3124),(15242,3124),(15243,3125),(15244,3125),(15245,3125),(15246,3125),(15247,3126),(15248,3126),(15249,3126),(15250,3126),(15251,3127),(15252,3127),(15253,3127),(15254,3127),(15255,3128),(15256,3128),(15257,3128),(15258,3128),(15259,3129),(15260,3129),(15261,3129),(15262,3129),(15263,3130),(15264,3130),(15265,3130),(15266,3130),(15267,3131),(15268,3131),(15269,3131),(15270,3131),(15271,3132),(15272,3132),(15273,3132),(15274,3132),(15275,3133),(15276,3133),(15277,3133),(15278,3133),(15279,3134),(15280,3134),(15281,3134),(15282,3134),(15283,3135),(15284,3135),(15285,3135),(15286,3135),(15287,3136),(15288,3136),(15289,3136),(15290,3136),(15291,3137),(15292,3137),(15293,3137),(15294,3137),(15295,3138),(15296,3138),(15297,3138),(15298,3138),(15299,3139),(15300,3139),(15301,3139),(15302,3139),(15303,3140),(15304,3140),(15305,3140),(15306,3140),(15307,3141),(15308,3141),(15309,3141),(15310,3141),(15311,3142),(15312,3142),(15313,3142),(15314,3142),(15315,3143),(15316,3143),(15317,3143),(15318,3143),(15319,3144),(15320,3144),(15321,3144),(15322,3144),(15323,3145),(15324,3145),(15325,3145),(15326,3145),(15327,3146),(15328,3146),(15329,3146),(15330,3146),(15331,3147),(15332,3147),(15333,3147),(15334,3147),(15335,3148),(15336,3148),(15337,3148),(15338,3148),(15339,3149),(15340,3149),(15341,3149),(15342,3149),(15343,3150),(15344,3150),(15345,3150),(15346,3150),(15347,3151),(15348,3151),(15349,3151),(15350,3151),(15351,3152),(15352,3152),(15353,3152),(15354,3152),(15355,3153),(15356,3153),(15357,3153),(15358,3153),(15359,3154),(15360,3154),(15361,3154),(15362,3154),(15363,3155),(15364,3155),(15365,3155),(15366,3155),(15367,3156),(15368,3156),(15369,3156),(15370,3156),(15371,3157),(15372,3157),(15373,3157),(15374,3157),(15375,3158),(15376,3158),(15377,3158),(15378,3158),(15379,3159),(15380,3159),(15381,3159),(15382,3159),(15383,3160),(15384,3160),(15385,3160),(15386,3160),(15387,3161),(15388,3161),(15389,3161),(15390,3161),(15391,3162),(15392,3162),(15393,3162),(15394,3162),(15395,3163),(15396,3163),(15397,3163),(15398,3163),(15399,3164),(15400,3164),(15401,3164),(15402,3164),(15403,3165),(15404,3165),(15405,3165),(15406,3165),(15407,3166),(15408,3166),(15409,3166),(15410,3166),(15411,3167),(15412,3167),(15413,3167),(15414,3167),(15415,3168),(15416,3168),(15417,3168),(15418,3168),(15419,2622),(15420,2623),(15421,2624),(15422,2625),(15423,2626),(15424,2627),(15425,2628),(15426,2629),(15427,2630),(15428,2631),(15429,2632),(15430,2633),(15431,2634),(15432,2635),(15433,2636),(15434,2637),(15435,2638),(15436,2639),(15437,2640),(15438,2641),(15439,2642),(15440,2643),(15441,2644),(15442,2645),(15443,2646),(15444,2647),(15445,2648),(15446,2649),(15447,2650),(15448,2651),(15449,2652),(15450,2653),(15451,2654),(15452,2655),(15453,2656),(15454,2657),(15455,2658),(15456,2659),(15457,2660),(15458,2661),(15459,2662),(15460,2663),(15461,2664),(15462,2665),(15463,2666),(15464,2667),(15465,2668),(15466,2669),(15467,2670),(15468,2671),(15469,2672),(15470,2673),(15471,2674),(15472,2675),(15473,2676),(15474,2677),(15475,2678),(15476,2679),(15477,2680),(15478,2681),(15479,2682),(15480,2683),(15481,2684),(15482,2685),(15483,2686),(15484,2687),(15485,2688),(15486,2689),(15487,2690),(15488,2691),(15489,2692),(15490,2693),(15491,2694),(15492,2695),(15493,2696),(15494,2697),(15495,2698),(15496,2699),(15497,2700),(15498,2701),(15499,2702),(15500,2703),(15501,2704),(15502,2705),(15503,2706),(15504,2707),(15505,2708),(15506,2709),(15507,2710),(15508,2711),(15509,2712),(15510,2713),(15511,2714),(15512,2715),(15513,2716),(15514,2717),(15515,2718),(15516,2719),(15517,2720),(15518,2721),(15519,2722),(15520,2723),(15521,2724),(15522,2725),(15523,2726),(15524,2727),(15525,2728),(15526,2729),(15527,2730),(15528,2731),(15529,2732),(15530,2733),(15531,2734),(15532,2735),(15533,2736),(15534,2737),(15535,2738),(15536,2739),(15537,2740),(15538,2741),(15539,2742),(15540,2743),(15541,2744),(15542,2745),(15543,2746),(15544,2747),(15545,2748),(15546,2749),(15547,2750),(15548,2751),(15549,2752),(15550,2753),(15551,2754),(15552,2755),(15553,2756),(15554,2757),(15555,2758),(15556,2759),(15557,2760),(15558,2761),(15559,2762),(15560,2763),(15561,2764),(15562,2765),(15563,2766),(15564,2767),(15565,2768),(15566,2769),(15567,2770),(15568,2771),(15569,2772),(15570,2773),(15571,2774),(15572,2775),(15573,2776),(15574,2777),(15575,2778),(15576,2779),(15577,2780),(15578,2781),(15579,2782),(15580,2783),(15581,2784),(15582,2785),(15583,2786),(15584,2787),(15585,2788),(15586,2789),(15587,2790),(15588,2791),(15589,2792),(15590,2793),(15591,2794),(15592,2795),(15593,2796),(15594,2797),(15595,2798),(15596,2799),(15597,2800),(15598,2801),(15599,2802),(15600,2803),(15601,2804),(15602,2805),(15603,2806),(15604,2807),(15605,2808),(15606,2809),(15607,2810),(15608,2811),(15609,2812),(15610,2813),(15611,2814),(15612,2815),(15613,2816),(15614,2817),(15615,2818),(15616,2819),(15617,2820),(15618,2821),(15619,2822),(15620,2823),(15621,2824),(15622,2825),(15623,2826),(15624,2827),(15625,2828),(15626,2829),(15627,2830),(15628,2831),(15629,2832),(15630,2833),(15631,2834),(15632,2835),(15633,2836),(15634,2837),(15635,2838),(15636,2839),(15637,2840),(15638,2841),(15639,2842),(15640,2843),(15641,2844),(15642,2845),(15643,2846),(15644,2847),(15645,2848),(15646,2849),(15647,2850),(15648,2851),(15649,2852),(15650,2853),(15651,2854),(15652,2855),(15653,2856),(15654,2857),(15655,2858),(15656,2859),(15657,2860),(15658,2861),(15659,2862),(15660,2863),(15661,2864),(15662,2865),(15663,2866),(15664,2867),(15665,2868),(15666,2869),(15667,2870),(15668,2871),(15669,2872),(15670,2873),(15671,2874),(15672,2875),(15673,2876),(15674,2877),(15675,2878),(15676,2879),(15677,2880),(15678,2881),(15679,2882),(15680,2883),(15681,2884),(15682,2885),(15683,2886),(15684,2887),(15685,2888),(15686,2889),(15687,2890),(15688,2891),(15689,2892),(15690,2893),(15691,2894),(15692,2895),(15693,2896),(15694,2897),(15695,2898),(15696,2899),(15697,2900),(15698,2901),(15699,2902),(15700,2903),(15701,2904),(15702,2905),(15703,2906),(15704,2907),(15705,2908),(15706,2909),(15707,2910),(15708,2911),(15709,2912),(15710,2913),(15711,2914),(15712,2915),(15713,2916),(15714,2917),(15715,2918),(15716,2919),(15717,2920),(15718,2921),(15719,2922),(15720,2923),(15721,2924),(15722,2925),(15723,2926),(15724,2927),(15725,2928),(15726,2929),(15727,2930),(15728,2931),(15729,2932),(15730,2933),(15731,2934),(15732,2935),(15733,2936),(15734,2937),(15735,2938),(15736,2939),(15737,2940),(15738,2941),(15739,2942),(15740,2943),(15741,2944),(15742,2945),(15743,2946),(15744,2947),(15745,2948),(15746,2949),(15747,2950),(15748,2951),(15749,2952),(15750,2953),(15751,2954),(15752,2955),(15753,2956),(15754,2957),(15755,2958),(15756,2959),(15757,2960),(15758,2961),(15759,2962),(15760,2963),(15761,2964),(15762,2965),(15763,2966),(15764,2967),(15765,2968),(15766,2969),(15767,2970),(15768,2971),(15769,2972),(15770,2973),(15771,2974),(15772,2975),(15773,2976),(15774,2977),(15775,2978),(15776,2979),(15777,2980),(15778,2981),(15779,2982),(15780,2983),(15781,2984),(15782,2985),(15783,2986),(15784,2987),(15785,2988),(15786,2989),(15787,2990),(15788,2991),(15789,2992),(15790,2993),(15791,2994),(15792,2995),(15793,2996),(15794,2997),(15795,2998),(15796,2999),(15797,3000),(15798,3001),(15799,3002),(15800,3003),(15801,3004),(15802,3005),(15803,3006),(15804,3007),(15805,3008),(15806,3009),(15807,3010),(15808,3011),(15809,3012),(15810,3013),(15811,3014),(15812,3015),(15813,3016),(15814,3017),(15815,3018),(15816,3019),(15817,3020),(15818,3021),(15819,3022),(15820,3023),(15821,3024),(15822,3025),(15823,3026),(15824,3027),(15825,3028),(15826,3029),(15827,3030),(15828,3031),(15829,3032),(15830,3033),(15831,3034),(15832,3035),(15833,3036),(15834,3037),(15835,3038),(15836,3039),(15837,3040),(15838,3041),(15839,3042),(15840,3043),(15841,3044),(15842,3045),(15843,3046),(15844,3047),(15845,3048),(15846,3049),(15847,3050),(15848,3051),(15849,3052),(15850,3053),(15851,3054),(15852,3055),(15853,3056),(15854,3057),(15855,3058),(15856,3059),(15857,3060),(15858,3061),(15859,3062),(15860,3063),(15861,3064),(15862,3065),(15863,3066),(15864,3067),(15865,3068),(15866,3069),(15867,3070),(15868,3071),(15869,3072),(15870,3073),(15871,3074),(15872,3075),(15873,3076),(15874,3077),(15875,3078),(15876,3079),(15877,3080),(15878,3081),(15879,3082),(15880,3083),(15881,3084),(15882,3085),(15883,3086),(15884,3087),(15885,3088),(15886,3089),(15887,3090),(15888,3091),(15889,3092),(15890,3093),(15891,3094),(15892,3095),(15893,3096),(15894,3097),(15895,3098),(15896,3099),(15897,3100),(15898,3101),(15899,3102),(15900,3103),(15901,3104),(15902,3105),(15903,3106),(15904,3107),(15905,3108),(15906,3109),(15907,3110),(15908,3111),(15909,3112),(15910,3113),(15911,3114),(15912,3115),(15913,3116),(15914,3117),(15915,3118),(15916,3119),(15917,3120),(15918,3121),(15919,3122),(15920,3123),(15921,3124),(15922,3125),(15923,3126),(15924,3127),(15925,3128),(15926,3129),(15927,3130),(15928,3131),(15929,3132),(15930,3133),(15931,3134),(15932,3135),(15933,3136),(15934,3137),(15935,3138),(15936,3139),(15937,3140),(15938,3141),(15939,3142),(15940,3143),(15941,3144),(15942,3145),(15943,3146),(15944,3147),(15945,3148),(15946,3149),(15947,3150),(15948,3151),(15949,3152),(15950,3153),(15951,3154),(15952,3155),(15953,3156),(15954,3157),(15955,3158),(15956,3159),(15957,3160),(15958,3161),(15959,3162),(15960,3163),(15961,3164),(15962,3165),(15963,3166),(15964,3167),(15965,3168),(15966,3169),(15967,3169),(15968,3169),(15969,3169),(15970,3170),(15971,3170),(15972,3170),(15973,3170),(15974,3171),(15975,3171),(15976,3171),(15977,3171),(15978,3172),(15979,3172),(15980,3172),(15981,3172),(15982,3173),(15983,3173),(15984,3173),(15985,3173),(15986,3174),(15987,3174),(15988,3174),(15989,3174),(15990,3175),(15991,3175),(15992,3175),(15993,3175),(15994,3176),(15995,3176),(15996,3176),(15997,3176),(15998,3177),(15999,3177),(16000,3177),(16001,3177),(16002,3178),(16003,3178),(16004,3178),(16005,3178),(16006,3179),(16007,3179),(16008,3179),(16009,3179),(16010,3180),(16011,3180),(16012,3180),(16013,3180),(16014,3181),(16015,3181),(16016,3181),(16017,3181),(16018,3182),(16019,3182),(16020,3182),(16021,3182),(16022,3183),(16023,3183),(16024,3183),(16025,3183),(16026,3184),(16027,3184),(16028,3184),(16029,3184),(16030,3185),(16031,3185),(16032,3185),(16033,3185),(16034,3186),(16035,3186),(16036,3186),(16037,3186),(16038,3187),(16039,3187),(16040,3187),(16041,3187),(16042,3188),(16043,3188),(16044,3188),(16045,3188),(16046,3189),(16047,3189),(16048,3189),(16049,3189),(16050,3190),(16051,3190),(16052,3190),(16053,3190),(16054,3191),(16055,3191),(16056,3191),(16057,3191),(16058,3192),(16059,3192),(16060,3192),(16061,3192),(16062,3193),(16063,3193),(16064,3193),(16065,3193),(16066,3194),(16067,3194),(16068,3194),(16069,3194),(16070,3195),(16071,3195),(16072,3195),(16073,3195),(16074,3196),(16075,3196),(16076,3196),(16077,3196),(16078,3197),(16079,3197),(16080,3197),(16081,3197),(16082,3198),(16083,3198),(16084,3198),(16085,3198),(16086,3199),(16087,3199),(16088,3199),(16089,3199),(16090,3200),(16091,3200),(16092,3200),(16093,3200),(16094,3201),(16095,3201),(16096,3201),(16097,3201),(16098,3202),(16099,3202),(16100,3202),(16101,3202),(16102,3203),(16103,3203),(16104,3203),(16105,3203),(16106,3204),(16107,3204),(16108,3204),(16109,3204),(16110,3205),(16111,3205),(16112,3205),(16113,3205),(16114,3206),(16115,3206),(16116,3206),(16117,3206),(16118,3207),(16119,3207),(16120,3207),(16121,3207),(16122,3208),(16123,3208),(16124,3208),(16125,3208),(16126,3209),(16127,3209),(16128,3209),(16129,3209),(16130,3210),(16131,3210),(16132,3210),(16133,3210),(16134,3211),(16135,3211),(16136,3211),(16137,3211),(16138,3212),(16139,3212),(16140,3212),(16141,3212),(16142,3213),(16143,3213),(16144,3213),(16145,3213),(16146,3214),(16147,3214),(16148,3214),(16149,3214),(16150,3215),(16151,3215),(16152,3215),(16153,3215),(16154,3216),(16155,3216),(16156,3216),(16157,3216),(16158,3217),(16159,3217),(16160,3217),(16161,3217),(16162,3218),(16163,3218),(16164,3218),(16165,3218),(16166,3219),(16167,3219),(16168,3219),(16169,3219),(16170,3220),(16171,3220),(16172,3220),(16173,3220),(16174,3221),(16175,3221),(16176,3221),(16177,3221),(16178,3222),(16179,3222),(16180,3222),(16181,3222),(16182,3223),(16183,3223),(16184,3223),(16185,3223),(16186,3224),(16187,3224),(16188,3224),(16189,3224),(16190,3225),(16191,3225),(16192,3225),(16193,3225),(16194,3226),(16195,3226),(16196,3226),(16197,3226),(16198,3227),(16199,3227),(16200,3227),(16201,3227),(16202,3228),(16203,3228),(16204,3228),(16205,3228),(16206,3229),(16207,3229),(16208,3229),(16209,3229),(16210,3230),(16211,3230),(16212,3230),(16213,3230),(16214,3231),(16215,3231),(16216,3231),(16217,3231),(16218,3232),(16219,3232),(16220,3232),(16221,3232),(16222,3233),(16223,3233),(16224,3233),(16225,3233),(16226,3234),(16227,3234),(16228,3234),(16229,3234),(16230,3235),(16231,3235),(16232,3235),(16233,3235),(16234,3236),(16235,3236),(16236,3236),(16237,3236),(16238,3237),(16239,3237),(16240,3237),(16241,3237),(16242,3238),(16243,3238),(16244,3238),(16245,3238),(16246,3239),(16247,3239),(16248,3239),(16249,3239),(16250,3240),(16251,3240),(16252,3240),(16253,3240),(16254,3241),(16255,3241),(16256,3241),(16257,3241),(16258,3242),(16259,3242),(16260,3242),(16261,3242),(16262,3243),(16263,3243),(16264,3243),(16265,3243),(16266,3244),(16267,3244),(16268,3244),(16269,3244),(16270,3245),(16271,3245),(16272,3245),(16273,3245),(16274,3246),(16275,3246),(16276,3246),(16277,3246),(16278,3247),(16279,3247),(16280,3247),(16281,3247),(16282,3248),(16283,3248),(16284,3248),(16285,3248),(16286,3249),(16287,3249),(16288,3249),(16289,3249),(16290,3250),(16291,3250),(16292,3250),(16293,3250),(16294,3251),(16295,3251),(16296,3251),(16297,3251),(16298,3252),(16299,3252),(16300,3252),(16301,3252),(16302,3253),(16303,3253),(16304,3253),(16305,3253),(16306,3254),(16307,3254),(16308,3254),(16309,3254),(16310,3255),(16311,3255),(16312,3255),(16313,3255),(16314,3256),(16315,3256),(16316,3256),(16317,3256),(16318,3257),(16319,3257),(16320,3257),(16321,3257),(16322,3258),(16323,3258),(16324,3258),(16325,3258),(16326,3259),(16327,3259),(16328,3259),(16329,3259),(16330,3260),(16331,3260),(16332,3260),(16333,3260),(16334,3261),(16335,3261),(16336,3261),(16337,3261),(16338,3262),(16339,3262),(16340,3262),(16341,3262),(16342,3263),(16343,3263),(16344,3263),(16345,3263),(16346,3264),(16347,3264),(16348,3264),(16349,3264),(16350,3265),(16351,3265),(16352,3265),(16353,3265),(16354,3266),(16355,3266),(16356,3266),(16357,3266),(16358,3267),(16359,3267),(16360,3267),(16361,3267),(16362,3268),(16363,3268),(16364,3268),(16365,3268),(16366,3269),(16367,3269),(16368,3269),(16369,3269),(16370,3270),(16371,3270),(16372,3270),(16373,3270),(16374,3271),(16375,3271),(16376,3271),(16377,3271),(16378,3272),(16379,3272),(16380,3272),(16381,3272),(16382,3273),(16383,3273),(16384,3273),(16385,3273),(16386,3274),(16387,3274),(16388,3274),(16389,3274),(16390,3275),(16391,3275),(16392,3275),(16393,3275),(16394,3276),(16395,3276),(16396,3276),(16397,3276),(16398,3277),(16399,3277),(16400,3277),(16401,3277),(16402,3278),(16403,3278),(16404,3278),(16405,3278),(16406,3279),(16407,3279),(16408,3279),(16409,3279),(16410,3280),(16411,3280),(16412,3280),(16413,3280),(16414,3281),(16415,3281),(16416,3281),(16417,3281),(16418,3282),(16419,3282),(16420,3282),(16421,3282),(16422,3283),(16423,3283),(16424,3283),(16425,3283),(16426,3284),(16427,3284),(16428,3284),(16429,3284),(16430,3285),(16431,3285),(16432,3285),(16433,3285),(16434,3286),(16435,3286),(16436,3286),(16437,3286),(16438,3287),(16439,3287),(16440,3287),(16441,3287),(16442,3288),(16443,3288),(16444,3288),(16445,3288),(16446,3289),(16447,3289),(16448,3289),(16449,3289),(16450,3290),(16451,3290),(16452,3290),(16453,3290),(16454,3291),(16455,3291),(16456,3291),(16457,3291),(16458,3292),(16459,3292),(16460,3292),(16461,3292),(16462,3293),(16463,3293),(16464,3293),(16465,3293),(16466,3294),(16467,3294),(16468,3294),(16469,3294),(16470,3295),(16471,3295),(16472,3295),(16473,3295),(16474,3296),(16475,3296),(16476,3296),(16477,3296),(16478,3297),(16479,3297),(16480,3297),(16481,3297),(16482,3298),(16483,3298),(16484,3298),(16485,3298),(16486,3299),(16487,3299),(16488,3299),(16489,3299),(16490,3300),(16491,3300),(16492,3300),(16493,3300),(16494,3301),(16495,3301),(16496,3301),(16497,3301),(16498,3302),(16499,3302),(16500,3302),(16501,3302),(16502,3303),(16503,3303),(16504,3303),(16505,3303),(16506,3304),(16507,3304),(16508,3304),(16509,3304),(16510,3305),(16511,3305),(16512,3305),(16513,3305),(16514,3306),(16515,3306),(16516,3306),(16517,3306),(16518,3307),(16519,3307),(16520,3307),(16521,3307),(16522,3308),(16523,3308),(16524,3308),(16525,3308),(16526,3309),(16527,3309),(16528,3309),(16529,3309),(16530,3310),(16531,3310),(16532,3310),(16533,3310),(16534,3311),(16535,3311),(16536,3311),(16537,3311),(16538,3312),(16539,3312),(16540,3312),(16541,3312),(16542,3313),(16543,3313),(16544,3313),(16545,3313),(16546,3314),(16547,3314),(16548,3314),(16549,3314),(16550,3315),(16551,3315),(16552,3315),(16553,3315),(16554,3316),(16555,3316),(16556,3316),(16557,3316),(16558,3317),(16559,3317),(16560,3317),(16561,3317),(16562,3318),(16563,3318),(16564,3318),(16565,3318),(16566,3319),(16567,3319),(16568,3319),(16569,3319),(16570,3320),(16571,3320),(16572,3320),(16573,3320),(16574,3321),(16575,3321),(16576,3321),(16577,3321),(16578,3322),(16579,3322),(16580,3322),(16581,3322),(16582,3323),(16583,3323),(16584,3323),(16585,3323),(16586,3324),(16587,3324),(16588,3324),(16589,3324),(16590,3325),(16591,3325),(16592,3325),(16593,3325),(16594,3326),(16595,3326),(16596,3326),(16597,3326),(16598,3327),(16599,3327),(16600,3327),(16601,3327),(16602,3328),(16603,3328),(16604,3328),(16605,3328),(16606,3329),(16607,3329),(16608,3329),(16609,3329),(16610,3330),(16611,3330),(16612,3330),(16613,3330),(16614,3331),(16615,3331),(16616,3331),(16617,3331),(16618,3332),(16619,3332),(16620,3332),(16621,3332),(16622,3333),(16623,3333),(16624,3333),(16625,3333),(16626,3334),(16627,3334),(16628,3334),(16629,3334),(16630,3335),(16631,3335),(16632,3335),(16633,3335),(16634,3336),(16635,3336),(16636,3336),(16637,3336),(16638,3337),(16639,3337),(16640,3337),(16641,3337),(16642,3338),(16643,3338),(16644,3338),(16645,3338),(16646,3339),(16647,3339),(16648,3339),(16649,3339),(16650,3340),(16651,3340),(16652,3340),(16653,3340),(16654,3341),(16655,3341),(16656,3341),(16657,3341),(16658,3342),(16659,3342),(16660,3342),(16661,3342),(16662,3343),(16663,3343),(16664,3343),(16665,3343),(16666,3344),(16667,3344),(16668,3344),(16669,3344),(16670,3345),(16671,3345),(16672,3345),(16673,3345),(16674,3346),(16675,3346),(16676,3346),(16677,3346),(16678,3347),(16679,3347),(16680,3347),(16681,3347),(16682,3348),(16683,3348),(16684,3348),(16685,3348),(16686,3349),(16687,3349),(16688,3349),(16689,3349),(16690,3350),(16691,3350),(16692,3350),(16693,3350),(16694,3351),(16695,3351),(16696,3351),(16697,3351),(16698,3352),(16699,3352),(16700,3352),(16701,3352),(16702,3353),(16703,3353),(16704,3353),(16705,3353),(16706,3354),(16707,3354),(16708,3354),(16709,3354),(16710,3355),(16711,3355),(16712,3355),(16713,3355),(16714,3356),(16715,3356),(16716,3356),(16717,3356),(16718,3357),(16719,3357),(16720,3357),(16721,3357),(16722,3358),(16723,3358),(16724,3358),(16725,3358),(16726,3359),(16727,3359),(16728,3359),(16729,3359),(16730,3360),(16731,3360),(16732,3360),(16733,3360),(16734,3361),(16735,3361),(16736,3361),(16737,3361),(16738,3362),(16739,3362),(16740,3362),(16741,3362),(16742,3363),(16743,3363),(16744,3363),(16745,3363),(16746,3364),(16747,3364),(16748,3364),(16749,3364),(16750,3365),(16751,3365),(16752,3365),(16753,3365),(16754,3366),(16755,3366),(16756,3366),(16757,3366),(16758,3367),(16759,3367),(16760,3367),(16761,3367),(16762,3368),(16763,3368),(16764,3368),(16765,3368),(16766,3369),(16767,3369),(16768,3369),(16769,3369),(16770,3370),(16771,3370),(16772,3370),(16773,3370),(16774,3371),(16775,3371),(16776,3371),(16777,3371),(16778,3372),(16779,3372),(16780,3372),(16781,3372),(16782,3373),(16783,3373),(16784,3373),(16785,3373),(16786,3374),(16787,3374),(16788,3374),(16789,3374),(16790,3375),(16791,3375),(16792,3375),(16793,3375),(16794,3376),(16795,3376),(16796,3376),(16797,3376),(16798,3377),(16799,3377),(16800,3377),(16801,3377),(16802,3378),(16803,3378),(16804,3378),(16805,3378),(16806,3379),(16807,3379),(16808,3379),(16809,3379),(16810,3380),(16811,3380),(16812,3380),(16813,3380),(16814,3381),(16815,3381),(16816,3381),(16817,3381),(16818,3382),(16819,3382),(16820,3382),(16821,3382),(16822,3383),(16823,3383),(16824,3383),(16825,3383),(16826,3384),(16827,3384),(16828,3384),(16829,3384),(16830,3385),(16831,3385),(16832,3385),(16833,3385),(16834,3386),(16835,3386),(16836,3386),(16837,3386),(16838,3387),(16839,3387),(16840,3387),(16841,3387),(16842,3388),(16843,3388),(16844,3388),(16845,3388),(16846,3389),(16847,3389),(16848,3389),(16849,3389),(16850,3390),(16851,3390),(16852,3390),(16853,3390),(16854,3391),(16855,3391),(16856,3391),(16857,3391),(16858,3392),(16859,3392),(16860,3392),(16861,3392),(16862,3393),(16863,3393),(16864,3393),(16865,3393),(16866,3394),(16867,3394),(16868,3394),(16869,3394),(16870,3395),(16871,3395),(16872,3395),(16873,3395),(16874,3396),(16875,3396),(16876,3396),(16877,3396),(16878,3397),(16879,3397),(16880,3397),(16881,3397),(16882,3398),(16883,3398),(16884,3398),(16885,3398),(16886,3399),(16887,3399),(16888,3399),(16889,3399),(16890,3400),(16891,3400),(16892,3400),(16893,3400),(16894,3401),(16895,3401),(16896,3401),(16897,3401),(16898,3402),(16899,3402),(16900,3402),(16901,3402),(16902,3403),(16903,3403),(16904,3403),(16905,3403),(16906,3404),(16907,3404),(16908,3404),(16909,3404),(16910,3405),(16911,3405),(16912,3405),(16913,3405),(16914,3406),(16915,3406),(16916,3406),(16917,3406),(16918,3407),(16919,3407),(16920,3407),(16921,3407),(16922,3408),(16923,3408),(16924,3408),(16925,3408),(16926,3409),(16927,3409),(16928,3409),(16929,3409),(16930,3410),(16931,3410),(16932,3410),(16933,3410),(16934,3411),(16935,3411),(16936,3411),(16937,3411),(16938,3412),(16939,3412),(16940,3412),(16941,3412),(16942,3413),(16943,3413),(16944,3413),(16945,3413),(16946,3414),(16947,3414),(16948,3414),(16949,3414),(16950,3415),(16951,3415),(16952,3415),(16953,3415),(16954,3416),(16955,3416),(16956,3416),(16957,3416),(16958,3417),(16959,3417),(16960,3417),(16961,3417),(16962,3418),(16963,3418),(16964,3418),(16965,3418),(16966,3419),(16967,3419),(16968,3419),(16969,3419),(16970,3420),(16971,3420),(16972,3420),(16973,3420),(16974,3421),(16975,3421),(16976,3421),(16977,3421),(16978,3422),(16979,3422),(16980,3422),(16981,3422),(16982,3423),(16983,3423),(16984,3423),(16985,3423),(16986,3424),(16987,3424),(16988,3424),(16989,3424),(16990,3425),(16991,3425),(16992,3425),(16993,3425),(16994,3426),(16995,3426),(16996,3426),(16997,3426),(16998,3427),(16999,3427),(17000,3427),(17001,3427),(17002,3428),(17003,3428),(17004,3428),(17005,3428),(17006,3429),(17007,3429),(17008,3429),(17009,3429),(17010,3430),(17011,3430),(17012,3430),(17013,3430),(17014,3431),(17015,3431),(17016,3431),(17017,3431),(17018,3432),(17019,3432),(17020,3432),(17021,3432),(17022,3433),(17023,3433),(17024,3433),(17025,3433),(17026,3434),(17027,3434),(17028,3434),(17029,3434),(17030,3435),(17031,3435),(17032,3435),(17033,3435),(17034,3436),(17035,3436),(17036,3436),(17037,3436),(17038,3437),(17039,3437),(17040,3437),(17041,3437),(17042,3438),(17043,3438),(17044,3438),(17045,3438),(17046,3439),(17047,3439),(17048,3439),(17049,3439),(17050,3440),(17051,3440),(17052,3440),(17053,3440),(17054,3441),(17055,3441),(17056,3441),(17057,3441),(17058,3442),(17059,3442),(17060,3442),(17061,3442),(17062,3443),(17063,3443),(17064,3443),(17065,3443),(17066,3444),(17067,3444),(17068,3444),(17069,3444),(17070,3445),(17071,3445),(17072,3445),(17073,3445),(17074,3446),(17075,3446),(17076,3446),(17077,3446),(17078,3447),(17079,3447),(17080,3447),(17081,3447),(17082,3448),(17083,3448),(17084,3448),(17085,3448),(17086,3449),(17087,3449),(17088,3449),(17089,3449),(17090,3450),(17091,3450),(17092,3450),(17093,3450),(17094,3451),(17095,3451),(17096,3451),(17097,3451),(17098,3452),(17099,3452),(17100,3452),(17101,3452),(17102,3453),(17103,3453),(17104,3453),(17105,3453),(17106,3454),(17107,3454),(17108,3454),(17109,3454),(17110,3455),(17111,3455),(17112,3455),(17113,3455),(17114,3456),(17115,3456),(17116,3456),(17117,3456),(17118,3457),(17119,3457),(17120,3457),(17121,3457),(17122,3458),(17123,3458),(17124,3458),(17125,3458),(17126,3459),(17127,3459),(17128,3459),(17129,3459),(17130,3460),(17131,3460),(17132,3460),(17133,3460),(17134,3461),(17135,3461),(17136,3461),(17137,3461),(17138,3462),(17139,3462),(17140,3462),(17141,3462),(17142,3463),(17143,3463),(17144,3463),(17145,3463),(17146,3464),(17147,3464),(17148,3464),(17149,3464),(17150,3465),(17151,3465),(17152,3465),(17153,3465),(17154,3466),(17155,3466),(17156,3466),(17157,3466),(17158,3467),(17159,3467),(17160,3467),(17161,3467),(17162,3468),(17163,3468),(17164,3468),(17165,3468),(17166,3469),(17167,3469),(17168,3469),(17169,3469),(17170,3470),(17171,3470),(17172,3470),(17173,3470),(17174,3471),(17175,3471),(17176,3471),(17177,3471),(17178,3472),(17179,3472),(17180,3472),(17181,3472),(17182,3473),(17183,3473),(17184,3473),(17185,3473),(17186,3474),(17187,3474),(17188,3474),(17189,3474),(17190,3475),(17191,3475),(17192,3475),(17193,3475),(17194,3476),(17195,3476),(17196,3476),(17197,3476),(17198,3477),(17199,3477),(17200,3477),(17201,3477),(17202,3478),(17203,3478),(17204,3478),(17205,3478),(17206,3479),(17207,3479),(17208,3479),(17209,3479),(17210,3480),(17211,3480),(17212,3480),(17213,3480),(17214,3481),(17215,3481),(17216,3481),(17217,3481),(17218,3482),(17219,3482),(17220,3482),(17221,3482),(17222,3483),(17223,3483),(17224,3483),(17225,3483),(17226,3484),(17227,3484),(17228,3484),(17229,3484),(17230,3485),(17231,3485),(17232,3485),(17233,3485),(17234,3486),(17235,3486),(17236,3486),(17237,3486),(17238,3487),(17239,3487),(17240,3487),(17241,3487),(17242,3488),(17243,3488),(17244,3488),(17245,3488),(17246,3489),(17247,3489),(17248,3489),(17249,3489),(17250,3490),(17251,3490),(17252,3490),(17253,3490),(17254,3491),(17255,3491),(17256,3491),(17257,3491),(17258,3492),(17259,3492),(17260,3492),(17261,3492),(17262,3493),(17263,3493),(17264,3493),(17265,3493),(17266,3494),(17267,3494),(17268,3494),(17269,3494),(17270,3495),(17271,3495),(17272,3495),(17273,3495),(17274,3496),(17275,3496),(17276,3496),(17277,3496),(17278,3497),(17279,3497),(17280,3497),(17281,3497),(17282,3498),(17283,3498),(17284,3498),(17285,3498),(17286,3499),(17287,3499),(17288,3499),(17289,3499),(17290,3500),(17291,3500),(17292,3500),(17293,3500),(17294,3501),(17295,3501),(17296,3501),(17297,3501),(17298,3502),(17299,3502),(17300,3502),(17301,3502),(17302,3503),(17303,3503),(17304,3503),(17305,3503),(17306,3504),(17307,3504),(17308,3504),(17309,3504),(17310,3505),(17311,3505),(17312,3505),(17313,3505),(17314,3506),(17315,3506),(17316,3506),(17317,3506),(17318,3507),(17319,3507),(17320,3507),(17321,3507),(17322,3508),(17323,3508),(17324,3508),(17325,3508),(17326,3509),(17327,3509),(17328,3509),(17329,3509),(17330,3510),(17331,3510),(17332,3510),(17333,3510),(17334,3511),(17335,3511),(17336,3511),(17337,3511),(17338,3512),(17339,3512),(17340,3512),(17341,3512),(17342,3513),(17343,3513),(17344,3513),(17345,3513),(17346,3514),(17347,3514),(17348,3514),(17349,3514),(17350,3515),(17351,3515),(17352,3515),(17353,3515),(17354,3516),(17355,3516),(17356,3516),(17357,3516),(17358,3517),(17359,3517),(17360,3517),(17361,3517),(17362,3518),(17363,3518),(17364,3518),(17365,3518),(17366,3519),(17367,3519),(17368,3519),(17369,3519),(17370,3520),(17371,3520),(17372,3520),(17373,3520),(17374,3521),(17375,3521),(17376,3521),(17377,3521),(17378,3522),(17379,3522),(17380,3522),(17381,3522),(17382,3523),(17383,3523),(17384,3523),(17385,3523),(17386,3524),(17387,3524),(17388,3524),(17389,3524),(17390,3525),(17391,3525),(17392,3525),(17393,3525),(17394,3526),(17395,3526),(17396,3526),(17397,3526),(17398,3527),(17399,3527),(17400,3527),(17401,3527),(17402,3528),(17403,3528),(17404,3528),(17405,3528),(17406,3529),(17407,3529),(17408,3529),(17409,3529),(17410,3530),(17411,3530),(17412,3530),(17413,3530),(17414,3531),(17415,3531),(17416,3531),(17417,3531),(17418,3532),(17419,3532),(17420,3532),(17421,3532),(17422,3533),(17423,3533),(17424,3533),(17425,3533),(17426,3534),(17427,3534),(17428,3534),(17429,3534),(17430,3535),(17431,3535),(17432,3535),(17433,3535),(17434,3536),(17435,3536),(17436,3536),(17437,3536),(17438,3537),(17439,3537),(17440,3537),(17441,3537),(17442,3538),(17443,3538),(17444,3538),(17445,3538),(17446,3539),(17447,3539),(17448,3539),(17449,3539),(17450,3540),(17451,3540),(17452,3540),(17453,3540),(17454,3541),(17455,3541),(17456,3541),(17457,3541),(17458,3542),(17459,3542),(17460,3542),(17461,3542),(17462,3543),(17463,3543),(17464,3543),(17465,3543),(17466,3544),(17467,3544),(17468,3544),(17469,3544),(17470,3545),(17471,3545),(17472,3545),(17473,3545),(17474,3546),(17475,3546),(17476,3546),(17477,3546),(17478,3547),(17479,3547),(17480,3547),(17481,3547),(17482,3548),(17483,3548),(17484,3548),(17485,3548),(17486,3549),(17487,3549),(17488,3549),(17489,3549),(17490,3550),(17491,3550),(17492,3550),(17493,3550),(17494,3551),(17495,3551),(17496,3551),(17497,3551),(17498,3552),(17499,3552),(17500,3552),(17501,3552),(17502,3553),(17503,3553),(17504,3553),(17505,3553),(17506,3554),(17507,3554),(17508,3554),(17509,3554),(17510,3555),(17511,3555),(17512,3555),(17513,3555),(17514,3556),(17515,3556),(17516,3556),(17517,3556),(17518,3557),(17519,3557),(17520,3557),(17521,3557),(17522,3558),(17523,3558),(17524,3558),(17525,3558),(17526,3559),(17527,3559),(17528,3559),(17529,3559),(17530,3560),(17531,3560),(17532,3560),(17533,3560),(17534,3561),(17535,3561),(17536,3561),(17537,3561),(17538,3562),(17539,3562),(17540,3562),(17541,3562),(17542,3563),(17543,3563),(17544,3563),(17545,3563),(17546,3564),(17547,3564),(17548,3564),(17549,3564),(17550,3565),(17551,3565),(17552,3565),(17553,3565),(17554,3566),(17555,3566),(17556,3566),(17557,3566),(17558,3567),(17559,3567),(17560,3567),(17561,3567),(17562,3568),(17563,3568),(17564,3568),(17565,3568),(17566,3569),(17567,3569),(17568,3569),(17569,3569),(17570,3570),(17571,3570),(17572,3570),(17573,3570),(17574,3571),(17575,3571),(17576,3571),(17577,3571),(17578,3572),(17579,3572),(17580,3572),(17581,3572),(17582,3573),(17583,3573),(17584,3573),(17585,3573),(17586,3574),(17587,3574),(17588,3574),(17589,3574),(17590,3575),(17591,3575),(17592,3575),(17593,3575),(17594,3576),(17595,3576),(17596,3576),(17597,3576),(17598,3577),(17599,3577),(17600,3577),(17601,3577),(17602,3578),(17603,3578),(17604,3578),(17605,3578),(17606,3579),(17607,3579),(17608,3579),(17609,3579),(17610,3580),(17611,3580),(17612,3580),(17613,3580),(17614,3581),(17615,3581),(17616,3581),(17617,3581),(17618,3582),(17619,3582),(17620,3582),(17621,3582),(17622,3583),(17623,3583),(17624,3583),(17625,3583),(17626,3584),(17627,3584),(17628,3584),(17629,3584),(17630,3585),(17631,3585),(17632,3585),(17633,3585),(17634,3586),(17635,3586),(17636,3586),(17637,3586),(17638,3587),(17639,3587),(17640,3587),(17641,3587),(17642,3588),(17643,3588),(17644,3588),(17645,3588),(17646,3589),(17647,3589),(17648,3589),(17649,3589),(17650,3590),(17651,3590),(17652,3590),(17653,3590),(17654,3591),(17655,3591),(17656,3591),(17657,3591),(17658,3592),(17659,3592),(17660,3592),(17661,3592),(17662,3593),(17663,3593),(17664,3593),(17665,3593),(17666,3594),(17667,3594),(17668,3594),(17669,3594),(17670,3595),(17671,3595),(17672,3595),(17673,3595),(17674,3596),(17675,3596),(17676,3596),(17677,3596),(17678,3597),(17679,3597),(17680,3597),(17681,3597),(17682,3598),(17683,3598),(17684,3598),(17685,3598),(17686,3599),(17687,3599),(17688,3599),(17689,3599),(17690,3600),(17691,3600),(17692,3600),(17693,3600),(17694,3601),(17695,3601),(17696,3601),(17697,3601),(17698,3602),(17699,3602),(17700,3602),(17701,3602),(17702,3603),(17703,3603),(17704,3603),(17705,3603),(17706,3604),(17707,3604),(17708,3604),(17709,3604),(17710,3605),(17711,3605),(17712,3605),(17713,3605),(17714,3606),(17715,3606),(17716,3606),(17717,3606),(17718,3607),(17719,3607),(17720,3607),(17721,3607),(17722,3608),(17723,3608),(17724,3608),(17725,3608),(17726,3609),(17727,3609),(17728,3609),(17729,3609),(17730,3610),(17731,3610),(17732,3610),(17733,3610),(17734,3611),(17735,3611),(17736,3611),(17737,3611),(17738,3612),(17739,3612),(17740,3612),(17741,3612),(17742,3613),(17743,3613),(17744,3613),(17745,3613),(17746,3614),(17747,3614),(17748,3614),(17749,3614),(17750,3615),(17751,3615),(17752,3615),(17753,3615),(17754,3616),(17755,3616),(17756,3616),(17757,3616),(17758,3617),(17759,3617),(17760,3617),(17761,3617),(17762,3618),(17763,3618),(17764,3618),(17765,3618),(17766,3619),(17767,3619),(17768,3619),(17769,3619),(17770,3620),(17771,3620),(17772,3620),(17773,3620),(17774,3621),(17775,3621),(17776,3621),(17777,3621),(17778,3622),(17779,3622),(17780,3622),(17781,3622),(17782,3623),(17783,3623),(17784,3623),(17785,3623),(17786,3624),(17787,3624),(17788,3624),(17789,3624),(17790,3625),(17791,3625),(17792,3625),(17793,3625),(17794,3626),(17795,3626),(17796,3626),(17797,3626),(17798,3627),(17799,3627),(17800,3627),(17801,3627),(17802,3628),(17803,3628),(17804,3628),(17805,3628),(17806,3629),(17807,3629),(17808,3629),(17809,3629),(17810,3630),(17811,3630),(17812,3630),(17813,3630),(17814,3631),(17815,3631),(17816,3631),(17817,3631),(17818,3632),(17819,3632),(17820,3632),(17821,3632),(17822,3633),(17823,3633),(17824,3633),(17825,3633),(17826,3634),(17827,3634),(17828,3634),(17829,3634),(17830,3635),(17831,3635),(17832,3635),(17833,3635),(17834,3636),(17835,3636),(17836,3636),(17837,3636),(17838,3637),(17839,3637),(17840,3637),(17841,3637),(17842,3638),(17843,3638),(17844,3638),(17845,3638),(17846,3639),(17847,3639),(17848,3639),(17849,3639),(17850,3640),(17851,3640),(17852,3640),(17853,3640),(17854,3641),(17855,3641),(17856,3641),(17857,3641),(17858,3642),(17859,3642),(17860,3642),(17861,3642),(17862,3643),(17863,3643),(17864,3643),(17865,3643),(17866,3644),(17867,3644),(17868,3644),(17869,3644),(17870,3645),(17871,3645),(17872,3645),(17873,3645),(17874,3646),(17875,3646),(17876,3646),(17877,3646),(17878,3647),(17879,3647),(17880,3647),(17881,3647),(17882,3648),(17883,3648),(17884,3648),(17885,3648),(17886,3649),(17887,3649),(17888,3649),(17889,3649),(17890,3650),(17891,3650),(17892,3650),(17893,3650),(17894,3651),(17895,3651),(17896,3651),(17897,3651),(17898,3652),(17899,3652),(17900,3652),(17901,3652),(17902,3653),(17903,3653),(17904,3653),(17905,3653),(17906,3654),(17907,3654),(17908,3654),(17909,3654),(17910,3655),(17911,3655),(17912,3655),(17913,3655),(17914,3656),(17915,3656),(17916,3656),(17917,3656),(17918,3657),(17919,3657),(17920,3657),(17921,3657),(17922,3658),(17923,3658),(17924,3658),(17925,3658),(17926,3659),(17927,3659),(17928,3659),(17929,3659),(17930,3660),(17931,3660),(17932,3660),(17933,3660),(17934,3661),(17935,3661),(17936,3661),(17937,3661),(17938,3662),(17939,3662),(17940,3662),(17941,3662),(17942,3663),(17943,3663),(17944,3663),(17945,3663),(17946,3664),(17947,3664),(17948,3664),(17949,3664),(17950,3665),(17951,3665),(17952,3665),(17953,3665),(17954,3666),(17955,3666),(17956,3666),(17957,3666),(17958,3667),(17959,3667),(17960,3667),(17961,3667),(17962,3668),(17963,3668),(17964,3668),(17965,3668),(17966,3669),(17967,3669),(17968,3669),(17969,3669),(17970,3670),(17971,3670),(17972,3670),(17973,3670),(17974,3671),(17975,3671),(17976,3671),(17977,3671),(17978,3672),(17979,3672),(17980,3672),(17981,3672),(17982,3673),(17983,3673),(17984,3673),(17985,3673),(17986,3674),(17987,3674),(17988,3674),(17989,3674),(17990,3675),(17991,3675),(17992,3675),(17993,3675),(17994,3676),(17995,3676),(17996,3676),(17997,3676),(17998,3677),(17999,3677),(18000,3677),(18001,3677),(18002,3678),(18003,3678),(18004,3678),(18005,3678),(18006,3679),(18007,3679),(18008,3679),(18009,3679),(18010,3680),(18011,3680),(18012,3680),(18013,3680),(18014,3681),(18015,3681),(18016,3681),(18017,3681),(18018,3682),(18019,3682),(18020,3682),(18021,3682),(18022,3683),(18023,3683),(18024,3683),(18025,3683),(18026,3684),(18027,3684),(18028,3684),(18029,3684),(18030,3685),(18031,3685),(18032,3685),(18033,3685),(18034,3686),(18035,3686),(18036,3686),(18037,3686),(18038,3687),(18039,3687),(18040,3687),(18041,3687),(18042,3688),(18043,3688),(18044,3688),(18045,3688),(18046,3689),(18047,3689),(18048,3689),(18049,3689),(18050,3690),(18051,3690),(18052,3690),(18053,3690),(18054,3691),(18055,3691),(18056,3691),(18057,3691),(18058,3692),(18059,3692),(18060,3692),(18061,3692),(18062,3693),(18063,3693),(18064,3693),(18065,3693),(18066,3694),(18067,3694),(18068,3694),(18069,3694),(18070,3695),(18071,3695),(18072,3695),(18073,3695),(18074,3696),(18075,3696),(18076,3696),(18077,3696),(18078,3697),(18079,3697),(18080,3697),(18081,3697),(18082,3698),(18083,3698),(18084,3698),(18085,3698),(18086,3699),(18087,3699),(18088,3699),(18089,3699),(18090,3700),(18091,3700),(18092,3700),(18093,3700),(18094,3701),(18095,3701),(18096,3701),(18097,3701),(18098,3702),(18099,3702),(18100,3702),(18101,3702),(18102,3703),(18103,3703),(18104,3703),(18105,3703),(18106,3704),(18107,3704),(18108,3704),(18109,3704),(18110,3705),(18111,3705),(18112,3705),(18113,3705),(18114,3706),(18115,3706),(18116,3706),(18117,3706),(18118,3707),(18119,3707),(18120,3707),(18121,3707),(18122,3708),(18123,3708),(18124,3708),(18125,3708),(18126,3709),(18127,3709),(18128,3709),(18129,3709),(18130,3710),(18131,3710),(18132,3710),(18133,3710),(18134,3711),(18135,3711),(18136,3711),(18137,3711),(18138,3712),(18139,3712),(18140,3712),(18141,3712),(18142,3713),(18143,3713),(18144,3713),(18145,3713),(18146,3714),(18147,3714),(18148,3714),(18149,3714),(18150,3169),(18151,3170),(18152,3171),(18153,3172),(18154,3173),(18155,3174),(18156,3175),(18157,3176),(18158,3177),(18159,3178),(18160,3179),(18161,3180),(18162,3181),(18163,3182),(18164,3183),(18165,3184),(18166,3185),(18167,3186),(18168,3187),(18169,3188),(18170,3189),(18171,3190),(18172,3191),(18173,3192),(18174,3193),(18175,3194),(18176,3195),(18177,3196),(18178,3197),(18179,3198),(18180,3199),(18181,3200),(18182,3201),(18183,3202),(18184,3203),(18185,3204),(18186,3205),(18187,3206),(18188,3207),(18189,3208),(18190,3209),(18191,3210),(18192,3211),(18193,3212),(18194,3213),(18195,3214),(18196,3215),(18197,3216),(18198,3217),(18199,3218),(18200,3219),(18201,3220),(18202,3221),(18203,3222),(18204,3223),(18205,3224),(18206,3225),(18207,3226),(18208,3227),(18209,3228),(18210,3229),(18211,3230),(18212,3231),(18213,3232),(18214,3233),(18215,3234),(18216,3235),(18217,3236),(18218,3237),(18219,3238),(18220,3239),(18221,3240),(18222,3241),(18223,3242),(18224,3243),(18225,3244),(18226,3245),(18227,3246),(18228,3247),(18229,3248),(18230,3249),(18231,3250),(18232,3251),(18233,3252),(18234,3253),(18235,3254),(18236,3255),(18237,3256),(18238,3257),(18239,3258),(18240,3259),(18241,3260),(18242,3261),(18243,3262),(18244,3263),(18245,3264),(18246,3265),(18247,3266),(18248,3267),(18249,3268),(18250,3269),(18251,3270),(18252,3271),(18253,3272),(18254,3273),(18255,3274),(18256,3275),(18257,3276),(18258,3277),(18259,3278),(18260,3279),(18261,3280),(18262,3281),(18263,3282),(18264,3283),(18265,3284),(18266,3285),(18267,3286),(18268,3287),(18269,3288),(18270,3289),(18271,3290),(18272,3291),(18273,3292),(18274,3293),(18275,3294),(18276,3295),(18277,3296),(18278,3297),(18279,3298),(18280,3299),(18281,3300),(18282,3301),(18283,3302),(18284,3303),(18285,3304),(18286,3305),(18287,3306),(18288,3307),(18289,3308),(18290,3309),(18291,3310),(18292,3311),(18293,3312),(18294,3313),(18295,3314),(18296,3315),(18297,3316),(18298,3317),(18299,3318),(18300,3319),(18301,3320),(18302,3321),(18303,3322),(18304,3323),(18305,3324),(18306,3325),(18307,3326),(18308,3327),(18309,3328),(18310,3329),(18311,3330),(18312,3331),(18313,3332),(18314,3333),(18315,3334),(18316,3335),(18317,3336),(18318,3337),(18319,3338),(18320,3339),(18321,3340),(18322,3341),(18323,3342),(18324,3343),(18325,3344),(18326,3345),(18327,3346),(18328,3347),(18329,3348),(18330,3349),(18331,3350),(18332,3351),(18333,3352),(18334,3353),(18335,3354),(18336,3355),(18337,3356),(18338,3357),(18339,3358),(18340,3359),(18341,3360),(18342,3361),(18343,3362),(18344,3363),(18345,3364),(18346,3365),(18347,3366),(18348,3367),(18349,3368),(18350,3369),(18351,3370),(18352,3371),(18353,3372),(18354,3373),(18355,3374),(18356,3375),(18357,3376),(18358,3377),(18359,3378),(18360,3379),(18361,3380),(18362,3381),(18363,3382),(18364,3383),(18365,3384),(18366,3385),(18367,3386),(18368,3387),(18369,3388),(18370,3389),(18371,3390),(18372,3391),(18373,3392),(18374,3393),(18375,3394),(18376,3395),(18377,3396),(18378,3397),(18379,3398),(18380,3399),(18381,3400),(18382,3401),(18383,3402),(18384,3403),(18385,3404),(18386,3405),(18387,3406),(18388,3407),(18389,3408),(18390,3409),(18391,3410),(18392,3411),(18393,3412),(18394,3413),(18395,3414),(18396,3415),(18397,3416),(18398,3417),(18399,3418),(18400,3419),(18401,3420),(18402,3421),(18403,3422),(18404,3423),(18405,3424),(18406,3425),(18407,3426),(18408,3427),(18409,3428),(18410,3429),(18411,3430),(18412,3431),(18413,3432),(18414,3433),(18415,3434),(18416,3435),(18417,3436),(18418,3437),(18419,3438),(18420,3439),(18421,3440),(18422,3441),(18423,3442),(18424,3443),(18425,3444),(18426,3445),(18427,3446),(18428,3447),(18429,3448),(18430,3449),(18431,3450),(18432,3451),(18433,3452),(18434,3453),(18435,3454),(18436,3455),(18437,3456),(18438,3457),(18439,3458),(18440,3459),(18441,3460),(18442,3461),(18443,3462),(18444,3463),(18445,3464),(18446,3465),(18447,3466),(18448,3467),(18449,3468),(18450,3469),(18451,3470),(18452,3471),(18453,3472),(18454,3473),(18455,3474),(18456,3475),(18457,3476),(18458,3477),(18459,3478),(18460,3479),(18461,3480),(18462,3481),(18463,3482),(18464,3483),(18465,3484),(18466,3485),(18467,3486),(18468,3487),(18469,3488),(18470,3489),(18471,3490),(18472,3491),(18473,3492),(18474,3493),(18475,3494),(18476,3495),(18477,3496),(18478,3497),(18479,3498),(18480,3499),(18481,3500),(18482,3501),(18483,3502),(18484,3503),(18485,3504),(18486,3505),(18487,3506),(18488,3507),(18489,3508),(18490,3509),(18491,3510),(18492,3511),(18493,3512),(18494,3513),(18495,3514),(18496,3515),(18497,3516),(18498,3517),(18499,3518),(18500,3519),(18501,3520),(18502,3521),(18503,3522),(18504,3523),(18505,3524),(18506,3525),(18507,3526),(18508,3527),(18509,3528),(18510,3529),(18511,3530),(18512,3531),(18513,3532),(18514,3533),(18515,3534),(18516,3535),(18517,3536),(18518,3537),(18519,3538),(18520,3539),(18521,3540),(18522,3541),(18523,3542),(18524,3543),(18525,3544),(18526,3545),(18527,3546),(18528,3547),(18529,3548),(18530,3549),(18531,3550),(18532,3551),(18533,3552),(18534,3553),(18535,3554),(18536,3555),(18537,3556),(18538,3557),(18539,3558),(18540,3559),(18541,3560),(18542,3561),(18543,3562),(18544,3563),(18545,3564),(18546,3565),(18547,3566),(18548,3567),(18549,3568),(18550,3569),(18551,3570),(18552,3571),(18553,3572),(18554,3573),(18555,3574),(18556,3575),(18557,3576),(18558,3577),(18559,3578),(18560,3579),(18561,3580),(18562,3581),(18563,3582),(18564,3583),(18565,3584),(18566,3585),(18567,3586),(18568,3587),(18569,3588),(18570,3589),(18571,3590),(18572,3591),(18573,3592),(18574,3593),(18575,3594),(18576,3595),(18577,3596),(18578,3597),(18579,3598),(18580,3599),(18581,3600),(18582,3601),(18583,3602),(18584,3603),(18585,3604),(18586,3605),(18587,3606),(18588,3607),(18589,3608),(18590,3609),(18591,3610),(18592,3611),(18593,3612),(18594,3613),(18595,3614),(18596,3615),(18597,3616),(18598,3617),(18599,3618),(18600,3619),(18601,3620),(18602,3621),(18603,3622),(18604,3623),(18605,3624),(18606,3625),(18607,3626),(18608,3627),(18609,3628),(18610,3629),(18611,3630),(18612,3631),(18613,3632),(18614,3633),(18615,3634),(18616,3635),(18617,3636),(18618,3637),(18619,3638),(18620,3639),(18621,3640),(18622,3641),(18623,3642),(18624,3643),(18625,3644),(18626,3645),(18627,3646),(18628,3647),(18629,3648),(18630,3649),(18631,3650),(18632,3651),(18633,3652),(18634,3653),(18635,3654),(18636,3655),(18637,3656),(18638,3657),(18639,3658),(18640,3659),(18641,3660),(18642,3661),(18643,3662),(18644,3663),(18645,3664),(18646,3665),(18647,3666),(18648,3667),(18649,3668),(18650,3669),(18651,3670),(18652,3671),(18653,3672),(18654,3673),(18655,3674),(18656,3675),(18657,3676),(18658,3677),(18659,3678),(18660,3679),(18661,3680),(18662,3681),(18663,3682),(18664,3683),(18665,3684),(18666,3685),(18667,3686),(18668,3687),(18669,3688),(18670,3689),(18671,3690),(18672,3691),(18673,3692),(18674,3693),(18675,3694),(18676,3695),(18677,3696),(18678,3697),(18679,3698),(18680,3699),(18681,3700),(18682,3701),(18683,3702),(18684,3703),(18685,3704),(18686,3705),(18687,3706),(18688,3707),(18689,3708),(18690,3709),(18691,3710),(18692,3711),(18693,3712),(18694,3713),(18695,3714),(18696,3715),(18697,3715),(18698,3715),(18699,3715),(18700,3716),(18701,3716),(18702,3716),(18703,3716),(18704,3717),(18705,3717),(18706,3717),(18707,3717),(18708,3718),(18709,3718),(18710,3718),(18711,3718),(18712,3719),(18713,3719),(18714,3719),(18715,3719),(18716,3720),(18717,3720),(18718,3720),(18719,3720),(18720,3721),(18721,3721),(18722,3721),(18723,3721),(18724,3722),(18725,3722),(18726,3722),(18727,3722),(18728,3723),(18729,3723),(18730,3723),(18731,3723),(18732,3724),(18733,3724),(18734,3724),(18735,3724),(18736,3725),(18737,3725),(18738,3725),(18739,3725),(18740,3726),(18741,3726),(18742,3726),(18743,3726),(18744,3727),(18745,3727),(18746,3727),(18747,3727),(18748,3728),(18749,3728),(18750,3728),(18751,3728),(18752,3729),(18753,3729),(18754,3729),(18755,3729),(18756,3730),(18757,3730),(18758,3730),(18759,3730),(18760,3731),(18761,3731),(18762,3731),(18763,3731),(18764,3732),(18765,3732),(18766,3732),(18767,3732),(18768,3733),(18769,3733),(18770,3733),(18771,3733),(18772,3734),(18773,3734),(18774,3734),(18775,3734),(18776,3735),(18777,3735),(18778,3735),(18779,3735),(18780,3736),(18781,3736),(18782,3736),(18783,3736),(18784,3737),(18785,3737),(18786,3737),(18787,3737),(18788,3738),(18789,3738),(18790,3738),(18791,3738),(18792,3739),(18793,3739),(18794,3739),(18795,3739),(18796,3740),(18797,3740),(18798,3740),(18799,3740),(18800,3741),(18801,3741),(18802,3741),(18803,3741),(18804,3742),(18805,3742),(18806,3742),(18807,3742),(18808,3743),(18809,3743),(18810,3743),(18811,3743),(18812,3744),(18813,3744),(18814,3744),(18815,3744),(18816,3745),(18817,3745),(18818,3745),(18819,3745),(18820,3746),(18821,3746),(18822,3746),(18823,3746),(18824,3747),(18825,3747),(18826,3747),(18827,3747),(18828,3748),(18829,3748),(18830,3748),(18831,3748),(18832,3749),(18833,3749),(18834,3749),(18835,3749),(18836,3750),(18837,3750),(18838,3750),(18839,3750),(18840,3751),(18841,3751),(18842,3751),(18843,3751),(18844,3752),(18845,3752),(18846,3752),(18847,3752),(18848,3753),(18849,3753),(18850,3753),(18851,3753),(18852,3754),(18853,3754),(18854,3754),(18855,3754),(18856,3755),(18857,3755),(18858,3755),(18859,3755),(18860,3756),(18861,3756),(18862,3756),(18863,3756),(18864,3757),(18865,3757),(18866,3757),(18867,3757),(18868,3758),(18869,3758),(18870,3758),(18871,3758),(18872,3759),(18873,3759),(18874,3759),(18875,3759),(18876,3760),(18877,3760),(18878,3760),(18879,3760),(18880,3761),(18881,3761),(18882,3761),(18883,3761),(18884,3762),(18885,3762),(18886,3762),(18887,3762),(18888,3763),(18889,3763),(18890,3763),(18891,3763),(18892,3764),(18893,3764),(18894,3764),(18895,3764),(18896,3765),(18897,3765),(18898,3765),(18899,3765),(18900,3766),(18901,3766),(18902,3766),(18903,3766),(18904,3767),(18905,3767),(18906,3767),(18907,3767),(18908,3768),(18909,3768),(18910,3768),(18911,3768),(18912,3769),(18913,3769),(18914,3769),(18915,3769),(18916,3770),(18917,3770),(18918,3770),(18919,3770),(18920,3771),(18921,3771),(18922,3771),(18923,3771),(18924,3772),(18925,3772),(18926,3772),(18927,3772),(18928,3773),(18929,3773),(18930,3773),(18931,3773),(18932,3774),(18933,3774),(18934,3774),(18935,3774),(18936,3775),(18937,3775),(18938,3775),(18939,3775),(18940,3776),(18941,3776),(18942,3776),(18943,3776),(18944,3777),(18945,3777),(18946,3777),(18947,3777),(18948,3778),(18949,3778),(18950,3778),(18951,3778),(18952,3779),(18953,3779),(18954,3779),(18955,3779),(18956,3780),(18957,3780),(18958,3780),(18959,3780),(18960,3781),(18961,3781),(18962,3781),(18963,3781),(18964,3782),(18965,3782),(18966,3782),(18967,3782),(18968,3783),(18969,3783),(18970,3783),(18971,3783),(18972,3784),(18973,3784),(18974,3784),(18975,3784),(18976,3785),(18977,3785),(18978,3785),(18979,3785),(18980,3786),(18981,3786),(18982,3786),(18983,3786),(18984,3787),(18985,3787),(18986,3787),(18987,3787),(18988,3788),(18989,3788),(18990,3788),(18991,3788),(18992,3789),(18993,3789),(18994,3789),(18995,3789),(18996,3790),(18997,3790),(18998,3790),(18999,3790),(19000,3791),(19001,3791),(19002,3791),(19003,3791),(19004,3792),(19005,3792),(19006,3792),(19007,3792),(19008,3793),(19009,3793),(19010,3793),(19011,3793),(19012,3794),(19013,3794),(19014,3794),(19015,3794),(19016,3795),(19017,3795),(19018,3795),(19019,3795),(19020,3796),(19021,3796),(19022,3796),(19023,3796),(19024,3797),(19025,3797),(19026,3797),(19027,3797),(19028,3798),(19029,3798),(19030,3798),(19031,3798),(19032,3799),(19033,3799),(19034,3799),(19035,3799),(19036,3800),(19037,3800),(19038,3800),(19039,3800),(19040,3801),(19041,3801),(19042,3801),(19043,3801),(19044,3802),(19045,3802),(19046,3802),(19047,3802),(19048,3803),(19049,3803),(19050,3803),(19051,3803),(19052,3804),(19053,3804),(19054,3804),(19055,3804),(19056,3805),(19057,3805),(19058,3805),(19059,3805),(19060,3806),(19061,3806),(19062,3806),(19063,3806),(19064,3807),(19065,3807),(19066,3807),(19067,3807),(19068,3808),(19069,3808),(19070,3808),(19071,3808),(19072,3809),(19073,3809),(19074,3809),(19075,3809),(19076,3810),(19077,3810),(19078,3810),(19079,3810),(19080,3811),(19081,3811),(19082,3811),(19083,3811),(19084,3812),(19085,3812),(19086,3812),(19087,3812),(19088,3813),(19089,3813),(19090,3813),(19091,3813),(19092,3814),(19093,3814),(19094,3814),(19095,3814),(19096,3815),(19097,3815),(19098,3815),(19099,3815),(19100,3816),(19101,3816),(19102,3816),(19103,3816),(19104,3817),(19105,3817),(19106,3817),(19107,3817),(19108,3818),(19109,3818),(19110,3818),(19111,3818),(19112,3819),(19113,3819),(19114,3819),(19115,3819),(19116,3820),(19117,3820),(19118,3820),(19119,3820),(19120,3821),(19121,3821),(19122,3821),(19123,3821),(19124,3822),(19125,3822),(19126,3822),(19127,3822),(19128,3823),(19129,3823),(19130,3823),(19131,3823),(19132,3824),(19133,3824),(19134,3824),(19135,3824),(19136,3825),(19137,3825),(19138,3825),(19139,3825),(19140,3826),(19141,3826),(19142,3826),(19143,3826),(19144,3827),(19145,3827),(19146,3827),(19147,3827),(19148,3828),(19149,3828),(19150,3828),(19151,3828),(19152,3829),(19153,3829),(19154,3829),(19155,3829),(19156,3830),(19157,3830),(19158,3830),(19159,3830),(19160,3831),(19161,3831),(19162,3831),(19163,3831),(19164,3832),(19165,3832),(19166,3832),(19167,3832),(19168,3833),(19169,3833),(19170,3833),(19171,3833),(19172,3834),(19173,3834),(19174,3834),(19175,3834),(19176,3835),(19177,3835),(19178,3835),(19179,3835),(19180,3836),(19181,3836),(19182,3836),(19183,3836),(19184,3837),(19185,3837),(19186,3837),(19187,3837),(19188,3838),(19189,3838),(19190,3838),(19191,3838),(19192,3839),(19193,3839),(19194,3839),(19195,3839),(19196,3840),(19197,3840),(19198,3840),(19199,3840),(19200,3841),(19201,3841),(19202,3841),(19203,3841),(19204,3842),(19205,3842),(19206,3842),(19207,3842),(19208,3843),(19209,3843),(19210,3843),(19211,3843),(19212,3844),(19213,3844),(19214,3844),(19215,3844),(19216,3845),(19217,3845),(19218,3845),(19219,3845),(19220,3846),(19221,3846),(19222,3846),(19223,3846),(19224,3847),(19225,3847),(19226,3847),(19227,3847),(19228,3848),(19229,3848),(19230,3848),(19231,3848),(19232,3849),(19233,3849),(19234,3849),(19235,3849),(19236,3850),(19237,3850),(19238,3850),(19239,3850),(19240,3851),(19241,3851),(19242,3851),(19243,3851),(19244,3852),(19245,3852),(19246,3852),(19247,3852),(19248,3853),(19249,3853),(19250,3853),(19251,3853),(19252,3854),(19253,3854),(19254,3854),(19255,3854),(19256,3855),(19257,3855),(19258,3855),(19259,3855),(19260,3856),(19261,3856),(19262,3856),(19263,3856),(19264,3857),(19265,3857),(19266,3857),(19267,3857),(19268,3858),(19269,3858),(19270,3858),(19271,3858),(19272,3859),(19273,3859),(19274,3859),(19275,3859),(19276,3860),(19277,3860),(19278,3860),(19279,3860),(19280,3861),(19281,3861),(19282,3861),(19283,3861),(19284,3862),(19285,3862),(19286,3862),(19287,3862),(19288,3863),(19289,3863),(19290,3863),(19291,3863),(19292,3864),(19293,3864),(19294,3864),(19295,3864),(19296,3865),(19297,3865),(19298,3865),(19299,3865),(19300,3866),(19301,3866),(19302,3866),(19303,3866),(19304,3867),(19305,3867),(19306,3867),(19307,3867),(19308,3868),(19309,3868),(19310,3868),(19311,3868),(19312,3869),(19313,3869),(19314,3869),(19315,3869),(19316,3870),(19317,3870),(19318,3870),(19319,3870),(19320,3871),(19321,3871),(19322,3871),(19323,3871),(19324,3872),(19325,3872),(19326,3872),(19327,3872),(19328,3873),(19329,3873),(19330,3873),(19331,3873),(19332,3874),(19333,3874),(19334,3874),(19335,3874),(19336,3875),(19337,3875),(19338,3875),(19339,3875),(19340,3876),(19341,3876),(19342,3876),(19343,3876),(19344,3877),(19345,3877),(19346,3877),(19347,3877),(19348,3878),(19349,3878),(19350,3878),(19351,3878),(19352,3879),(19353,3879),(19354,3879),(19355,3879),(19356,3880),(19357,3880),(19358,3880),(19359,3880),(19360,3881),(19361,3881),(19362,3881),(19363,3881),(19364,3882),(19365,3882),(19366,3882),(19367,3882),(19368,3883),(19369,3883),(19370,3883),(19371,3883),(19372,3884),(19373,3884),(19374,3884),(19375,3884),(19376,3885),(19377,3885),(19378,3885),(19379,3885),(19380,3886),(19381,3886),(19382,3886),(19383,3886),(19384,3887),(19385,3887),(19386,3887),(19387,3887),(19388,3888),(19389,3888),(19390,3888),(19391,3888),(19392,3889),(19393,3889),(19394,3889),(19395,3889),(19396,3890),(19397,3890),(19398,3890),(19399,3890),(19400,3891),(19401,3891),(19402,3891),(19403,3891),(19404,3892),(19405,3892),(19406,3892),(19407,3892),(19408,3893),(19409,3893),(19410,3893),(19411,3893),(19412,3894),(19413,3894),(19414,3894),(19415,3894),(19416,3895),(19417,3895),(19418,3895),(19419,3895),(19420,3896),(19421,3896),(19422,3896),(19423,3896),(19424,3897),(19425,3897),(19426,3897),(19427,3897),(19428,3898),(19429,3898),(19430,3898),(19431,3898),(19432,3899),(19433,3899),(19434,3899),(19435,3899),(19436,3900),(19437,3900),(19438,3900),(19439,3900),(19440,3901),(19441,3901),(19442,3901),(19443,3901),(19444,3902),(19445,3902),(19446,3902),(19447,3902),(19448,3903),(19449,3903),(19450,3903),(19451,3903),(19452,3904),(19453,3904),(19454,3904),(19455,3904),(19456,3905),(19457,3905),(19458,3905),(19459,3905),(19460,3906),(19461,3906),(19462,3906),(19463,3906),(19464,3907),(19465,3907),(19466,3907),(19467,3907),(19468,3908),(19469,3908),(19470,3908),(19471,3908),(19472,3909),(19473,3909),(19474,3909),(19475,3909),(19476,3910),(19477,3910),(19478,3910),(19479,3910),(19480,3911),(19481,3911),(19482,3911),(19483,3911),(19484,3912),(19485,3912),(19486,3912),(19487,3912),(19488,3913),(19489,3913),(19490,3913),(19491,3913),(19492,3914),(19493,3914),(19494,3914),(19495,3914),(19496,3915),(19497,3915),(19498,3915),(19499,3915),(19500,3916),(19501,3916),(19502,3916),(19503,3916),(19504,3917),(19505,3917),(19506,3917),(19507,3917),(19508,3918),(19509,3918),(19510,3918),(19511,3918),(19512,3919),(19513,3919),(19514,3919),(19515,3919),(19516,3920),(19517,3920),(19518,3920),(19519,3920),(19520,3921),(19521,3921),(19522,3921),(19523,3921),(19524,3922),(19525,3922),(19526,3922),(19527,3922),(19528,3923),(19529,3923),(19530,3923),(19531,3923),(19532,3924),(19533,3924),(19534,3924),(19535,3924),(19536,3925),(19537,3925),(19538,3925),(19539,3925),(19540,3926),(19541,3926),(19542,3926),(19543,3926),(19544,3927),(19545,3927),(19546,3927),(19547,3927),(19548,3928),(19549,3928),(19550,3928),(19551,3928),(19552,3929),(19553,3929),(19554,3929),(19555,3929),(19556,3930),(19557,3930),(19558,3930),(19559,3930),(19560,3931),(19561,3931),(19562,3931),(19563,3931),(19564,3932),(19565,3932),(19566,3932),(19567,3932),(19568,3933),(19569,3933),(19570,3933),(19571,3933),(19572,3934),(19573,3934),(19574,3934),(19575,3934),(19576,3935),(19577,3935),(19578,3935),(19579,3935),(19580,3936),(19581,3936),(19582,3936),(19583,3936),(19584,3937),(19585,3937),(19586,3937),(19587,3937),(19588,3938),(19589,3938),(19590,3938),(19591,3938),(19592,3939),(19593,3939),(19594,3939),(19595,3939),(19596,3940),(19597,3940),(19598,3940),(19599,3940),(19600,3941),(19601,3941),(19602,3941),(19603,3941),(19604,3942),(19605,3942),(19606,3942),(19607,3942),(19608,3943),(19609,3943),(19610,3943),(19611,3943),(19612,3944),(19613,3944),(19614,3944),(19615,3944),(19616,3945),(19617,3945),(19618,3945),(19619,3945),(19620,3946),(19621,3946),(19622,3946),(19623,3946),(19624,3947),(19625,3947),(19626,3947),(19627,3947),(19628,3948),(19629,3948),(19630,3948),(19631,3948),(19632,3949),(19633,3949),(19634,3949),(19635,3949),(19636,3950),(19637,3950),(19638,3950),(19639,3950),(19640,3951),(19641,3951),(19642,3951),(19643,3951),(19644,3952),(19645,3952),(19646,3952),(19647,3952),(19648,3953),(19649,3953),(19650,3953),(19651,3953),(19652,3954),(19653,3954),(19654,3954),(19655,3954),(19656,3955),(19657,3955),(19658,3955),(19659,3955),(19660,3956),(19661,3956),(19662,3956),(19663,3956),(19664,3957),(19665,3957),(19666,3957),(19667,3957),(19668,3958),(19669,3958),(19670,3958),(19671,3958),(19672,3959),(19673,3959),(19674,3959),(19675,3959),(19676,3960),(19677,3960),(19678,3960),(19679,3960),(19680,3961),(19681,3961),(19682,3961),(19683,3961),(19684,3962),(19685,3962),(19686,3962),(19687,3962),(19688,3963),(19689,3963),(19690,3963),(19691,3963),(19692,3964),(19693,3964),(19694,3964),(19695,3964),(19696,3965),(19697,3965),(19698,3965),(19699,3965),(19700,3966),(19701,3966),(19702,3966),(19703,3966),(19704,3967),(19705,3967),(19706,3967),(19707,3967),(19708,3968),(19709,3968),(19710,3968),(19711,3968),(19712,3969),(19713,3969),(19714,3969),(19715,3969),(19716,3970),(19717,3970),(19718,3970),(19719,3970),(19720,3971),(19721,3971),(19722,3971),(19723,3971),(19724,3972),(19725,3972),(19726,3972),(19727,3972),(19728,3973),(19729,3973),(19730,3973),(19731,3973),(19732,3974),(19733,3974),(19734,3974),(19735,3974),(19736,3975),(19737,3975),(19738,3975),(19739,3975),(19740,3976),(19741,3976),(19742,3976),(19743,3976),(19744,3977),(19745,3977),(19746,3977),(19747,3977),(19748,3978),(19749,3978),(19750,3978),(19751,3978),(19752,3979),(19753,3979),(19754,3979),(19755,3979),(19756,3980),(19757,3980),(19758,3980),(19759,3980),(19760,3981),(19761,3981),(19762,3981),(19763,3981),(19764,3982),(19765,3982),(19766,3982),(19767,3982),(19768,3983),(19769,3983),(19770,3983),(19771,3983),(19772,3984),(19773,3984),(19774,3984),(19775,3984),(19776,3985),(19777,3985),(19778,3985),(19779,3985),(19780,3986),(19781,3986),(19782,3986),(19783,3986),(19784,3987),(19785,3987),(19786,3987),(19787,3987),(19788,3988),(19789,3988),(19790,3988),(19791,3988),(19792,3989),(19793,3989),(19794,3989),(19795,3989),(19796,3990),(19797,3990),(19798,3990),(19799,3990),(19800,3991),(19801,3991),(19802,3991),(19803,3991),(19804,3992),(19805,3992),(19806,3992),(19807,3992),(19808,3993),(19809,3993),(19810,3993),(19811,3993),(19812,3994),(19813,3994),(19814,3994),(19815,3994),(19816,3995),(19817,3995),(19818,3995),(19819,3995),(19820,3996),(19821,3996),(19822,3996),(19823,3996),(19824,3997),(19825,3997),(19826,3997),(19827,3997),(19828,3998),(19829,3998),(19830,3998),(19831,3998),(19832,3999),(19833,3999),(19834,3999),(19835,3999),(19836,4000),(19837,4000),(19838,4000),(19839,4000),(19840,4001),(19841,4001),(19842,4001),(19843,4001),(19844,4002),(19845,4002),(19846,4002),(19847,4002),(19848,4003),(19849,4003),(19850,4003),(19851,4003),(19852,4004),(19853,4004),(19854,4004),(19855,4004),(19856,4005),(19857,4005),(19858,4005),(19859,4005),(19860,4006),(19861,4006),(19862,4006),(19863,4006),(19864,4007),(19865,4007),(19866,4007),(19867,4007),(19868,4008),(19869,4008),(19870,4008),(19871,4008),(19872,4009),(19873,4009),(19874,4009),(19875,4009),(19876,4010),(19877,4010),(19878,4010),(19879,4010),(19880,4011),(19881,4011),(19882,4011),(19883,4011),(19884,4012),(19885,4012),(19886,4012),(19887,4012),(19888,4013),(19889,4013),(19890,4013),(19891,4013),(19892,4014),(19893,4014),(19894,4014),(19895,4014),(19896,4015),(19897,4015),(19898,4015),(19899,4015),(19900,4016),(19901,4016),(19902,4016),(19903,4016),(19904,4017),(19905,4017),(19906,4017),(19907,4017),(19908,4018),(19909,4018),(19910,4018),(19911,4018),(19912,4019),(19913,4019),(19914,4019),(19915,4019),(19916,4020),(19917,4020),(19918,4020),(19919,4020),(19920,4021),(19921,4021),(19922,4021),(19923,4021),(19924,4022),(19925,4022),(19926,4022),(19927,4022),(19928,4023),(19929,4023),(19930,4023),(19931,4023),(19932,4024),(19933,4024),(19934,4024),(19935,4024),(19936,4025),(19937,4025),(19938,4025),(19939,4025),(19940,4026),(19941,4026),(19942,4026),(19943,4026),(19944,4027),(19945,4027),(19946,4027),(19947,4027),(19948,4028),(19949,4028),(19950,4028),(19951,4028),(19952,4029),(19953,4029),(19954,4029),(19955,4029),(19956,4030),(19957,4030),(19958,4030),(19959,4030),(19960,4031),(19961,4031),(19962,4031),(19963,4031),(19964,4032),(19965,4032),(19966,4032),(19967,4032),(19968,4033),(19969,4033),(19970,4033),(19971,4033),(19972,4034),(19973,4034),(19974,4034),(19975,4034),(19976,4035),(19977,4035),(19978,4035),(19979,4035),(19980,4036),(19981,4036),(19982,4036),(19983,4036),(19984,4037),(19985,4037),(19986,4037),(19987,4037),(19988,4038),(19989,4038),(19990,4038),(19991,4038),(19992,4039),(19993,4039),(19994,4039),(19995,4039),(19996,4040),(19997,4040),(19998,4040),(19999,4040),(20000,4041),(20001,4041),(20002,4041),(20003,4041),(20004,4042),(20005,4042),(20006,4042),(20007,4042),(20008,4043),(20009,4043),(20010,4043),(20011,4043),(20012,4044),(20013,4044),(20014,4044),(20015,4044),(20016,4045),(20017,4045),(20018,4045),(20019,4045),(20020,4046),(20021,4046),(20022,4046),(20023,4046),(20024,4047),(20025,4047),(20026,4047),(20027,4047),(20028,4048),(20029,4048),(20030,4048),(20031,4048),(20032,4049),(20033,4049),(20034,4049),(20035,4049),(20036,4050),(20037,4050),(20038,4050),(20039,4050),(20040,4051),(20041,4051),(20042,4051),(20043,4051),(20044,4052),(20045,4052),(20046,4052),(20047,4052),(20048,4053),(20049,4053),(20050,4053),(20051,4053),(20052,4054),(20053,4054),(20054,4054),(20055,4054),(20056,4055),(20057,4055),(20058,4055),(20059,4055),(20060,4056),(20061,4056),(20062,4056),(20063,4056),(20064,4057),(20065,4057),(20066,4057),(20067,4057),(20068,4058),(20069,4058),(20070,4058),(20071,4058),(20072,4059),(20073,4059),(20074,4059),(20075,4059),(20076,4060),(20077,4060),(20078,4060),(20079,4060),(20080,4061),(20081,4061),(20082,4061),(20083,4061),(20084,4062),(20085,4062),(20086,4062),(20087,4062),(20088,4063),(20089,4063),(20090,4063),(20091,4063),(20092,4064),(20093,4064),(20094,4064),(20095,4064),(20096,4065),(20097,4065),(20098,4065),(20099,4065),(20100,4066),(20101,4066),(20102,4066),(20103,4066),(20104,4067),(20105,4067),(20106,4067),(20107,4067),(20108,4068),(20109,4068),(20110,4068),(20111,4068),(20112,4069),(20113,4069),(20114,4069),(20115,4069),(20116,4070),(20117,4070),(20118,4070),(20119,4070),(20120,4071),(20121,4071),(20122,4071),(20123,4071),(20124,4072),(20125,4072),(20126,4072),(20127,4072),(20128,4073),(20129,4073),(20130,4073),(20131,4073),(20132,4074),(20133,4074),(20134,4074),(20135,4074),(20136,4075),(20137,4075),(20138,4075),(20139,4075),(20140,4076),(20141,4076),(20142,4076),(20143,4076),(20144,4077),(20145,4077),(20146,4077),(20147,4077),(20148,4078),(20149,4078),(20150,4078),(20151,4078),(20152,4079),(20153,4079),(20154,4079),(20155,4079),(20156,4080),(20157,4080),(20158,4080),(20159,4080),(20160,4081),(20161,4081),(20162,4081),(20163,4081),(20164,4082),(20165,4082),(20166,4082),(20167,4082),(20168,4083),(20169,4083),(20170,4083),(20171,4083),(20172,4084),(20173,4084),(20174,4084),(20175,4084),(20176,4085),(20177,4085),(20178,4085),(20179,4085),(20180,4086),(20181,4086),(20182,4086),(20183,4086),(20184,4087),(20185,4087),(20186,4087),(20187,4087),(20188,4088),(20189,4088),(20190,4088),(20191,4088),(20192,4089),(20193,4089),(20194,4089),(20195,4089),(20196,4090),(20197,4090),(20198,4090),(20199,4090),(20200,4091),(20201,4091),(20202,4091),(20203,4091),(20204,4092),(20205,4092),(20206,4092),(20207,4092),(20208,4093),(20209,4093),(20210,4093),(20211,4093),(20212,4094),(20213,4094),(20214,4094),(20215,4094),(20216,4095),(20217,4095),(20218,4095),(20219,4095),(20220,4096),(20221,4096),(20222,4096),(20223,4096),(20224,4097),(20225,4097),(20226,4097),(20227,4097),(20228,4098),(20229,4098),(20230,4098),(20231,4098),(20232,4099),(20233,4099),(20234,4099),(20235,4099),(20236,4100),(20237,4100),(20238,4100),(20239,4100),(20240,4101),(20241,4101),(20242,4101),(20243,4101),(20244,4102),(20245,4102),(20246,4102),(20247,4102),(20248,4103),(20249,4103),(20250,4103),(20251,4103),(20252,4104),(20253,4104),(20254,4104),(20255,4104),(20256,4105),(20257,4105),(20258,4105),(20259,4105),(20260,4106),(20261,4106),(20262,4106),(20263,4106),(20264,4107),(20265,4107),(20266,4107),(20267,4107),(20268,4108),(20269,4108),(20270,4108),(20271,4108),(20272,4109),(20273,4109),(20274,4109),(20275,4109),(20276,4110),(20277,4110),(20278,4110),(20279,4110),(20280,4111),(20281,4111),(20282,4111),(20283,4111),(20284,4112),(20285,4112),(20286,4112),(20287,4112),(20288,4113),(20289,4113),(20290,4113),(20291,4113),(20292,4114),(20293,4114),(20294,4114),(20295,4114),(20296,4115),(20297,4115),(20298,4115),(20299,4115),(20300,4116),(20301,4116),(20302,4116),(20303,4116),(20304,4117),(20305,4117),(20306,4117),(20307,4117),(20308,4118),(20309,4118),(20310,4118),(20311,4118),(20312,4119),(20313,4119),(20314,4119),(20315,4119),(20316,4120),(20317,4120),(20318,4120),(20319,4120),(20320,4121),(20321,4121),(20322,4121),(20323,4121),(20324,4122),(20325,4122),(20326,4122),(20327,4122),(20328,4123),(20329,4123),(20330,4123),(20331,4123),(20332,4124),(20333,4124),(20334,4124),(20335,4124),(20336,4125),(20337,4125),(20338,4125),(20339,4125),(20340,4126),(20341,4126),(20342,4126),(20343,4126),(20344,4127),(20345,4127),(20346,4127),(20347,4127),(20348,4128),(20349,4128),(20350,4128),(20351,4128),(20352,4129),(20353,4129),(20354,4129),(20355,4129),(20356,4130),(20357,4130),(20358,4130),(20359,4130),(20360,4131),(20361,4131),(20362,4131),(20363,4131),(20364,4132),(20365,4132),(20366,4132),(20367,4132),(20368,4133),(20369,4133),(20370,4133),(20371,4133),(20372,4134),(20373,4134),(20374,4134),(20375,4134),(20376,4135),(20377,4135),(20378,4135),(20379,4135),(20380,4136),(20381,4136),(20382,4136),(20383,4136),(20384,4137),(20385,4137),(20386,4137),(20387,4137),(20388,4138),(20389,4138),(20390,4138),(20391,4138),(20392,4139),(20393,4139),(20394,4139),(20395,4139),(20396,4140),(20397,4140),(20398,4140),(20399,4140),(20400,4141),(20401,4141),(20402,4141),(20403,4141),(20404,4142),(20405,4142),(20406,4142),(20407,4142),(20408,4143),(20409,4143),(20410,4143),(20411,4143),(20412,4144),(20413,4144),(20414,4144),(20415,4144),(20416,4145),(20417,4145),(20418,4145),(20419,4145),(20420,4146),(20421,4146),(20422,4146),(20423,4146),(20424,4147),(20425,4147),(20426,4147),(20427,4147),(20428,4148),(20429,4148),(20430,4148),(20431,4148),(20432,4149),(20433,4149),(20434,4149),(20435,4149),(20436,4150),(20437,4150),(20438,4150),(20439,4150),(20440,4151),(20441,4151),(20442,4151),(20443,4151),(20444,4152),(20445,4152),(20446,4152),(20447,4152),(20448,4153),(20449,4153),(20450,4153),(20451,4153),(20452,4154),(20453,4154),(20454,4154),(20455,4154),(20456,4155),(20457,4155),(20458,4155),(20459,4155),(20460,4156),(20461,4156),(20462,4156),(20463,4156),(20464,4157),(20465,4157),(20466,4157),(20467,4157),(20468,4158),(20469,4158),(20470,4158),(20471,4158),(20472,4159),(20473,4159),(20474,4159),(20475,4159),(20476,4160),(20477,4160),(20478,4160),(20479,4160),(20480,4161),(20481,4161),(20482,4161),(20483,4161),(20484,4162),(20485,4162),(20486,4162),(20487,4162),(20488,4163),(20489,4163),(20490,4163),(20491,4163),(20492,4164),(20493,4164),(20494,4164),(20495,4164),(20496,4165),(20497,4165),(20498,4165),(20499,4165),(20500,4166),(20501,4166),(20502,4166),(20503,4166),(20504,4167),(20505,4167),(20506,4167),(20507,4167),(20508,4168),(20509,4168),(20510,4168),(20511,4168),(20512,4169),(20513,4169),(20514,4169),(20515,4169),(20516,4170),(20517,4170),(20518,4170),(20519,4170),(20520,4171),(20521,4171),(20522,4171),(20523,4171),(20524,4172),(20525,4172),(20526,4172),(20527,4172),(20528,4173),(20529,4173),(20530,4173),(20531,4173),(20532,4174),(20533,4174),(20534,4174),(20535,4174),(20536,4175),(20537,4175),(20538,4175),(20539,4175),(20540,4176),(20541,4176),(20542,4176),(20543,4176),(20544,4177),(20545,4177),(20546,4177),(20547,4177),(20548,4178),(20549,4178),(20550,4178),(20551,4178),(20552,4179),(20553,4179),(20554,4179),(20555,4179),(20556,4180),(20557,4180),(20558,4180),(20559,4180),(20560,4181),(20561,4181),(20562,4181),(20563,4181),(20564,4182),(20565,4182),(20566,4182),(20567,4182),(20568,4183),(20569,4183),(20570,4183),(20571,4183),(20572,4184),(20573,4184),(20574,4184),(20575,4184),(20576,4185),(20577,4185),(20578,4185),(20579,4185),(20580,4186),(20581,4186),(20582,4186),(20583,4186),(20584,4187),(20585,4187),(20586,4187),(20587,4187),(20588,4188),(20589,4188),(20590,4188),(20591,4188),(20592,4189),(20593,4189),(20594,4189),(20595,4189),(20596,4190),(20597,4190),(20598,4190),(20599,4190),(20600,4191),(20601,4191),(20602,4191),(20603,4191),(20604,4192),(20605,4192),(20606,4192),(20607,4192),(20608,4193),(20609,4193),(20610,4193),(20611,4193),(20612,4194),(20613,4194),(20614,4194),(20615,4194),(20616,4195),(20617,4195),(20618,4195),(20619,4195),(20620,4196),(20621,4196),(20622,4196),(20623,4196),(20624,4197),(20625,4197),(20626,4197),(20627,4197),(20628,4198),(20629,4198),(20630,4198),(20631,4198),(20632,4199),(20633,4199),(20634,4199),(20635,4199),(20636,4200),(20637,4200),(20638,4200),(20639,4200),(20640,4201),(20641,4201),(20642,4201),(20643,4201),(20644,4202),(20645,4202),(20646,4202),(20647,4202),(20648,4203),(20649,4203),(20650,4203),(20651,4203),(20652,4204),(20653,4204),(20654,4204),(20655,4204),(20656,4205),(20657,4205),(20658,4205),(20659,4205),(20660,4206),(20661,4206),(20662,4206),(20663,4206),(20664,4207),(20665,4207),(20666,4207),(20667,4207),(20668,4208),(20669,4208),(20670,4208),(20671,4208),(20672,4209),(20673,4209),(20674,4209),(20675,4209),(20676,4210),(20677,4210),(20678,4210),(20679,4210),(20680,4211),(20681,4211),(20682,4211),(20683,4211),(20684,4212),(20685,4212),(20686,4212),(20687,4212),(20688,4213),(20689,4213),(20690,4213),(20691,4213),(20692,3715),(20693,3716),(20694,3717),(20695,3718),(20696,3719),(20697,3720),(20698,3721),(20699,3722),(20700,3723),(20701,3724),(20702,3725),(20703,3726),(20704,3727),(20705,3728),(20706,3729),(20707,3730),(20708,3731),(20709,3732),(20710,3733),(20711,3734),(20712,3735),(20713,3736),(20714,3737),(20715,3738),(20716,3739),(20717,3740),(20718,3741),(20719,3742),(20720,3743),(20721,3744),(20722,3745),(20723,3746),(20724,3747),(20725,3748),(20726,3749),(20727,3750),(20728,3751),(20729,3752),(20730,3753),(20731,3754),(20732,3755),(20733,3756),(20734,3757),(20735,3758),(20736,3759),(20737,3760),(20738,3761),(20739,3762),(20740,3763),(20741,3764),(20742,3765),(20743,3766),(20744,3767),(20745,3768),(20746,3769),(20747,3770),(20748,3771),(20749,3772),(20750,3773),(20751,3774),(20752,3775),(20753,3776),(20754,3777),(20755,3778),(20756,3779),(20757,3780),(20758,3781),(20759,3782),(20760,3783),(20761,3784),(20762,3785),(20763,3786),(20764,3787),(20765,3788),(20766,3789),(20767,3790),(20768,3791),(20769,3792),(20770,3793),(20771,3794),(20772,3795),(20773,3796),(20774,3797),(20775,3798),(20776,3799),(20777,3800),(20778,3801),(20779,3802),(20780,3803),(20781,3804),(20782,3805),(20783,3806),(20784,3807),(20785,3808),(20786,3809),(20787,3810),(20788,3811),(20789,3812),(20790,3813),(20791,3814),(20792,3815),(20793,3816),(20794,3817),(20795,3818),(20796,3819),(20797,3820),(20798,3821),(20799,3822),(20800,3823),(20801,3824),(20802,3825),(20803,3826),(20804,3827),(20805,3828),(20806,3829),(20807,3830),(20808,3831),(20809,3832),(20810,3833),(20811,3834),(20812,3835),(20813,3836),(20814,3837),(20815,3838),(20816,3839),(20817,3840),(20818,3841),(20819,3842),(20820,3843),(20821,3844),(20822,3845),(20823,3846),(20824,3847),(20825,3848),(20826,3849),(20827,3850),(20828,3851),(20829,3852),(20830,3853),(20831,3854),(20832,3855),(20833,3856),(20834,3857),(20835,3858),(20836,3859),(20837,3860),(20838,3861),(20839,3862),(20840,3863),(20841,3864),(20842,3865),(20843,3866),(20844,3867),(20845,3868),(20846,3869),(20847,3870),(20848,3871),(20849,3872),(20850,3873),(20851,3874),(20852,3875),(20853,3876),(20854,3877),(20855,3878),(20856,3879),(20857,3880),(20858,3881),(20859,3882),(20860,3883),(20861,3884),(20862,3885),(20863,3886),(20864,3887),(20865,3888),(20866,3889),(20867,3890),(20868,3891),(20869,3892),(20870,3893),(20871,3894),(20872,3895),(20873,3896),(20874,3897),(20875,3898),(20876,3899),(20877,3900),(20878,3901),(20879,3902),(20880,3903),(20881,3904),(20882,3905),(20883,3906),(20884,3907),(20885,3908),(20886,3909),(20887,3910),(20888,3911),(20889,3912),(20890,3913),(20891,3914),(20892,3915),(20893,3916),(20894,3917),(20895,3918),(20896,3919),(20897,3920),(20898,3921),(20899,3922),(20900,3923),(20901,3924),(20902,3925),(20903,3926),(20904,3927),(20905,3928),(20906,3929),(20907,3930),(20908,3931),(20909,3932),(20910,3933),(20911,3934),(20912,3935),(20913,3936),(20914,3937),(20915,3938),(20916,3939),(20917,3940),(20918,3941),(20919,3942),(20920,3943),(20921,3944),(20922,3945),(20923,3946),(20924,3947),(20925,3948),(20926,3949),(20927,3950),(20928,3951),(20929,3952),(20930,3953),(20931,3954),(20932,3955),(20933,3956),(20934,3957),(20935,3958),(20936,3959),(20937,3960),(20938,3961),(20939,3962),(20940,3963),(20941,3964),(20942,3965),(20943,3966),(20944,3967),(20945,3968),(20946,3969),(20947,3970),(20948,3971),(20949,3972),(20950,3973),(20951,3974),(20952,3975),(20953,3976),(20954,3977),(20955,3978),(20956,3979),(20957,3980),(20958,3981),(20959,3982),(20960,3983),(20961,3984),(20962,3985),(20963,3986),(20964,3987),(20965,3988),(20966,3989),(20967,3990),(20968,3991),(20969,3992),(20970,3993),(20971,3994),(20972,3995),(20973,3996),(20974,3997),(20975,3998),(20976,3999),(20977,4000),(20978,4001),(20979,4002),(20980,4003),(20981,4004),(20982,4005),(20983,4006),(20984,4007),(20985,4008),(20986,4009),(20987,4010),(20988,4011),(20989,4012),(20990,4013),(20991,4014),(20992,4015),(20993,4016),(20994,4017),(20995,4018),(20996,4019),(20997,4020),(20998,4021),(20999,4022),(21000,4023),(21001,4024),(21002,4025),(21003,4026),(21004,4027),(21005,4028),(21006,4029),(21007,4030),(21008,4031),(21009,4032),(21010,4033),(21011,4034),(21012,4035),(21013,4036),(21014,4037),(21015,4038),(21016,4039),(21017,4040),(21018,4041),(21019,4042),(21020,4043),(21021,4044),(21022,4045),(21023,4046),(21024,4047),(21025,4048),(21026,4049),(21027,4050),(21028,4051),(21029,4052),(21030,4053),(21031,4054),(21032,4055),(21033,4056),(21034,4057),(21035,4058),(21036,4059),(21037,4060),(21038,4061),(21039,4062),(21040,4063),(21041,4064),(21042,4065),(21043,4066),(21044,4067),(21045,4068),(21046,4069),(21047,4070),(21048,4071),(21049,4072),(21050,4073),(21051,4074),(21052,4075),(21053,4076),(21054,4077),(21055,4078),(21056,4079),(21057,4080),(21058,4081),(21059,4082),(21060,4083),(21061,4084),(21062,4085),(21063,4086),(21064,4087),(21065,4088),(21066,4089),(21067,4090),(21068,4091),(21069,4092),(21070,4093),(21071,4094),(21072,4095),(21073,4096),(21074,4097),(21075,4098),(21076,4099),(21077,4100),(21078,4101),(21079,4102),(21080,4103),(21081,4104),(21082,4105),(21083,4106),(21084,4107),(21085,4108),(21086,4109),(21087,4110),(21088,4111),(21089,4112),(21090,4113),(21091,4114),(21092,4115),(21093,4116),(21094,4117),(21095,4118),(21096,4119),(21097,4120),(21098,4121),(21099,4122),(21100,4123),(21101,4124),(21102,4125),(21103,4126),(21104,4127),(21105,4128),(21106,4129),(21107,4130),(21108,4131),(21109,4132),(21110,4133),(21111,4134),(21112,4135),(21113,4136),(21114,4137),(21115,4138),(21116,4139),(21117,4140),(21118,4141),(21119,4142),(21120,4143),(21121,4144),(21122,4145),(21123,4146),(21124,4147),(21125,4148),(21126,4149),(21127,4150),(21128,4151),(21129,4152),(21130,4153),(21131,4154),(21132,4155),(21133,4156),(21134,4157),(21135,4158),(21136,4159),(21137,4160),(21138,4161),(21139,4162),(21140,4163),(21141,4164),(21142,4165),(21143,4166),(21144,4167),(21145,4168),(21146,4169),(21147,4170),(21148,4171),(21149,4172),(21150,4173),(21151,4174),(21152,4175),(21153,4176),(21154,4177),(21155,4178),(21156,4179),(21157,4180),(21158,4181),(21159,4182),(21160,4183),(21161,4184),(21162,4185),(21163,4186),(21164,4187),(21165,4188),(21166,4189),(21167,4190),(21168,4191),(21169,4192),(21170,4193),(21171,4194),(21172,4195),(21173,4196),(21174,4197),(21175,4198),(21176,4199),(21177,4200),(21178,4201),(21179,4202),(21180,4203),(21181,4204),(21182,4205),(21183,4206),(21184,4207),(21185,4208),(21186,4209),(21187,4210),(21188,4211),(21189,4212),(21190,4213),(21191,4214),(21192,4214),(21193,4214),(21194,4214),(21195,4215),(21196,4215),(21197,4215),(21198,4215),(21199,4216),(21200,4216),(21201,4216),(21202,4216),(21203,4217),(21204,4217),(21205,4217),(21206,4217),(21207,4218),(21208,4218),(21209,4218),(21210,4218),(21211,4219),(21212,4219),(21213,4219),(21214,4219),(21215,4220),(21216,4220),(21217,4220),(21218,4220),(21219,4221),(21220,4221),(21221,4221),(21222,4221),(21223,4222),(21224,4222),(21225,4222),(21226,4222),(21227,4223),(21228,4223),(21229,4223),(21230,4223),(21231,4224),(21232,4224),(21233,4224),(21234,4224),(21235,4225),(21236,4225),(21237,4225),(21238,4225),(21239,4226),(21240,4226),(21241,4226),(21242,4226),(21243,4227),(21244,4227),(21245,4227),(21246,4227),(21247,4228),(21248,4228),(21249,4228),(21250,4228),(21251,4229),(21252,4229),(21253,4229),(21254,4229),(21255,4230),(21256,4230),(21257,4230),(21258,4230),(21259,4231),(21260,4231),(21261,4231),(21262,4231),(21263,4232),(21264,4232),(21265,4232),(21266,4232),(21267,4233),(21268,4233),(21269,4233),(21270,4233),(21271,4234),(21272,4234),(21273,4234),(21274,4234),(21275,4235),(21276,4235),(21277,4235),(21278,4235),(21279,4236),(21280,4236),(21281,4236),(21282,4236),(21283,4237),(21284,4237),(21285,4237),(21286,4237),(21287,4238),(21288,4238),(21289,4238),(21290,4238),(21291,4239),(21292,4239),(21293,4239),(21294,4239),(21295,4240),(21296,4240),(21297,4240),(21298,4240),(21299,4241),(21300,4241),(21301,4241),(21302,4241),(21303,4242),(21304,4242),(21305,4242),(21306,4242),(21307,4243),(21308,4243),(21309,4243),(21310,4243),(21311,4244),(21312,4244),(21313,4244),(21314,4244),(21315,4245),(21316,4245),(21317,4245),(21318,4245),(21319,4246),(21320,4246),(21321,4246),(21322,4246),(21323,4247),(21324,4247),(21325,4247),(21326,4247),(21327,4248),(21328,4248),(21329,4248),(21330,4248),(21331,4249),(21332,4249),(21333,4249),(21334,4249),(21335,4250),(21336,4250),(21337,4250),(21338,4250),(21339,4251),(21340,4251),(21341,4251),(21342,4251),(21343,4252),(21344,4252),(21345,4252),(21346,4252),(21347,4253),(21348,4253),(21349,4253),(21350,4253),(21351,4254),(21352,4254),(21353,4254),(21354,4254),(21355,4255),(21356,4255),(21357,4255),(21358,4255),(21359,4256),(21360,4256),(21361,4256),(21362,4256),(21363,4257),(21364,4257),(21365,4257),(21366,4257),(21367,4258),(21368,4258),(21369,4258),(21370,4258),(21371,4259),(21372,4259),(21373,4259),(21374,4259),(21375,4260),(21376,4260),(21377,4260),(21378,4260),(21379,4261),(21380,4261),(21381,4261),(21382,4261),(21383,4262),(21384,4262),(21385,4262),(21386,4262),(21387,4263),(21388,4263),(21389,4263),(21390,4263),(21391,4264),(21392,4264),(21393,4264),(21394,4264),(21395,4265),(21396,4265),(21397,4265),(21398,4265),(21399,4266),(21400,4266),(21401,4266),(21402,4266),(21403,4267),(21404,4267),(21405,4267),(21406,4267),(21407,4268),(21408,4268),(21409,4268),(21410,4268),(21411,4269),(21412,4269),(21413,4269),(21414,4269),(21415,4270),(21416,4270),(21417,4270),(21418,4270),(21419,4271),(21420,4271),(21421,4271),(21422,4271),(21423,4272),(21424,4272),(21425,4272),(21426,4272),(21427,4273),(21428,4273),(21429,4273),(21430,4273),(21431,4274),(21432,4274),(21433,4274),(21434,4274),(21435,4275),(21436,4275),(21437,4275),(21438,4275),(21439,4276),(21440,4276),(21441,4276),(21442,4276),(21443,4277),(21444,4277),(21445,4277),(21446,4277),(21447,4278),(21448,4278),(21449,4278),(21450,4278),(21451,4279),(21452,4279),(21453,4279),(21454,4279),(21455,4280),(21456,4280),(21457,4280),(21458,4280),(21459,4281),(21460,4281),(21461,4281),(21462,4281),(21463,4282),(21464,4282),(21465,4282),(21466,4282),(21467,4283),(21468,4283),(21469,4283),(21470,4283),(21471,4284),(21472,4284),(21473,4284),(21474,4284),(21475,4285),(21476,4285),(21477,4285),(21478,4285),(21479,4286),(21480,4286),(21481,4286),(21482,4286),(21483,4287),(21484,4287),(21485,4287),(21486,4287),(21487,4288),(21488,4288),(21489,4288),(21490,4288),(21491,4289),(21492,4289),(21493,4289),(21494,4289),(21495,4290),(21496,4290),(21497,4290),(21498,4290),(21499,4291),(21500,4291),(21501,4291),(21502,4291),(21503,4292),(21504,4292),(21505,4292),(21506,4292),(21507,4293),(21508,4293),(21509,4293),(21510,4293),(21511,4294),(21512,4294),(21513,4294),(21514,4294),(21515,4295),(21516,4295),(21517,4295),(21518,4295),(21519,4296),(21520,4296),(21521,4296),(21522,4296),(21523,4297),(21524,4297),(21525,4297),(21526,4297),(21527,4298),(21528,4298),(21529,4298),(21530,4298),(21531,4299),(21532,4299),(21533,4299),(21534,4299),(21535,4300),(21536,4300),(21537,4300),(21538,4300),(21539,4301),(21540,4301),(21541,4301),(21542,4301),(21543,4302),(21544,4302),(21545,4302),(21546,4302),(21547,4303),(21548,4303),(21549,4303),(21550,4303),(21551,4304),(21552,4304),(21553,4304),(21554,4304),(21555,4305),(21556,4305),(21557,4305),(21558,4305),(21559,4306),(21560,4306),(21561,4306),(21562,4306),(21563,4307),(21564,4307),(21565,4307),(21566,4307),(21567,4308),(21568,4308),(21569,4308),(21570,4308),(21571,4309),(21572,4309),(21573,4309),(21574,4309),(21575,4310),(21576,4310),(21577,4310),(21578,4310),(21579,4311),(21580,4311),(21581,4311),(21582,4311),(21583,4312),(21584,4312),(21585,4312),(21586,4312),(21587,4313),(21588,4313),(21589,4313),(21590,4313),(21591,4314),(21592,4314),(21593,4314),(21594,4314),(21595,4315),(21596,4315),(21597,4315),(21598,4315),(21599,4316),(21600,4316),(21601,4316),(21602,4316),(21603,4317),(21604,4317),(21605,4317),(21606,4317),(21607,4318),(21608,4318),(21609,4318),(21610,4318),(21611,4319),(21612,4319),(21613,4319),(21614,4319),(21615,4320),(21616,4320),(21617,4320),(21618,4320),(21619,4321),(21620,4321),(21621,4321),(21622,4321),(21623,4322),(21624,4322),(21625,4322),(21626,4322),(21627,4323),(21628,4323),(21629,4323),(21630,4323),(21631,4324),(21632,4324),(21633,4324),(21634,4324),(21635,4325),(21636,4325),(21637,4325),(21638,4325),(21639,4326),(21640,4326),(21641,4326),(21642,4326),(21643,4327),(21644,4327),(21645,4327),(21646,4327),(21647,4328),(21648,4328),(21649,4328),(21650,4328),(21651,4329),(21652,4329),(21653,4329),(21654,4329),(21655,4330),(21656,4330),(21657,4330),(21658,4330),(21659,4331),(21660,4331),(21661,4331),(21662,4331),(21663,4332),(21664,4332),(21665,4332),(21666,4332),(21667,4333),(21668,4333),(21669,4333),(21670,4333),(21671,4334),(21672,4334),(21673,4334),(21674,4334),(21675,4335),(21676,4335),(21677,4335),(21678,4335),(21679,4336),(21680,4336),(21681,4336),(21682,4336),(21683,4337),(21684,4337),(21685,4337),(21686,4337),(21687,4338),(21688,4338),(21689,4338),(21690,4338),(21691,4339),(21692,4339),(21693,4339),(21694,4339),(21695,4340),(21696,4340),(21697,4340),(21698,4340),(21699,4341),(21700,4341),(21701,4341),(21702,4341),(21703,4342),(21704,4342),(21705,4342),(21706,4342),(21707,4343),(21708,4343),(21709,4343),(21710,4343),(21711,4344),(21712,4344),(21713,4344),(21714,4344),(21715,4345),(21716,4345),(21717,4345),(21718,4345),(21719,4346),(21720,4346),(21721,4346),(21722,4346),(21723,4347),(21724,4347),(21725,4347),(21726,4347),(21727,4348),(21728,4348),(21729,4348),(21730,4348),(21731,4349),(21732,4349),(21733,4349),(21734,4349),(21735,4350),(21736,4350),(21737,4350),(21738,4350),(21739,4351),(21740,4351),(21741,4351),(21742,4351),(21743,4352),(21744,4352),(21745,4352),(21746,4352),(21747,4353),(21748,4353),(21749,4353),(21750,4353),(21751,4354),(21752,4354),(21753,4354),(21754,4354),(21755,4355),(21756,4355),(21757,4355),(21758,4355),(21759,4356),(21760,4356),(21761,4356),(21762,4356),(21763,4357),(21764,4357),(21765,4357),(21766,4357),(21767,4358),(21768,4358),(21769,4358),(21770,4358),(21771,4359),(21772,4359),(21773,4359),(21774,4359),(21775,4360),(21776,4360),(21777,4360),(21778,4360),(21779,4361),(21780,4361),(21781,4361),(21782,4361),(21783,4362),(21784,4362),(21785,4362),(21786,4362),(21787,4363),(21788,4363),(21789,4363),(21790,4363),(21791,4364),(21792,4364),(21793,4364),(21794,4364),(21795,4365),(21796,4365),(21797,4365),(21798,4365),(21799,4366),(21800,4366),(21801,4366),(21802,4366),(21803,4367),(21804,4367),(21805,4367),(21806,4367),(21807,4368),(21808,4368),(21809,4368),(21810,4368),(21811,4369),(21812,4369),(21813,4369),(21814,4369),(21815,4370),(21816,4370),(21817,4370),(21818,4370),(21819,4371),(21820,4371),(21821,4371),(21822,4371),(21823,4372),(21824,4372),(21825,4372),(21826,4372),(21827,4373),(21828,4373),(21829,4373),(21830,4373),(21831,4374),(21832,4374),(21833,4374),(21834,4374),(21835,4375),(21836,4375),(21837,4375),(21838,4375),(21839,4376),(21840,4376),(21841,4376),(21842,4376),(21843,4377),(21844,4377),(21845,4377),(21846,4377),(21847,4378),(21848,4378),(21849,4378),(21850,4378),(21851,4379),(21852,4379),(21853,4379),(21854,4379),(21855,4380),(21856,4380),(21857,4380),(21858,4380),(21859,4381),(21860,4381),(21861,4381),(21862,4381),(21863,4382),(21864,4382),(21865,4382),(21866,4382),(21867,4383),(21868,4383),(21869,4383),(21870,4383),(21871,4384),(21872,4384),(21873,4384),(21874,4384),(21875,4385),(21876,4385),(21877,4385),(21878,4385),(21879,4386),(21880,4386),(21881,4386),(21882,4386),(21883,4387),(21884,4387),(21885,4387),(21886,4387),(21887,4388),(21888,4388),(21889,4388),(21890,4388),(21891,4389),(21892,4389),(21893,4389),(21894,4389),(21895,4390),(21896,4390),(21897,4390),(21898,4390),(21899,4391),(21900,4391),(21901,4391),(21902,4391),(21903,4392),(21904,4392),(21905,4392),(21906,4392),(21907,4393),(21908,4393),(21909,4393),(21910,4393),(21911,4394),(21912,4394),(21913,4394),(21914,4394),(21915,4395),(21916,4395),(21917,4395),(21918,4395),(21919,4396),(21920,4396),(21921,4396),(21922,4396),(21923,4397),(21924,4397),(21925,4397),(21926,4397),(21927,4398),(21928,4398),(21929,4398),(21930,4398),(21931,4399),(21932,4399),(21933,4399),(21934,4399),(21935,4400),(21936,4400),(21937,4400),(21938,4400),(21939,4401),(21940,4401),(21941,4401),(21942,4401),(21943,4402),(21944,4402),(21945,4402),(21946,4402),(21947,4403),(21948,4403),(21949,4403),(21950,4403),(21951,4404),(21952,4404),(21953,4404),(21954,4404),(21955,4405),(21956,4405),(21957,4405),(21958,4405),(21959,4406),(21960,4406),(21961,4406),(21962,4406),(21963,4407),(21964,4407),(21965,4407),(21966,4407),(21967,4408),(21968,4408),(21969,4408),(21970,4408),(21971,4409),(21972,4409),(21973,4409),(21974,4409),(21975,4410),(21976,4410),(21977,4410),(21978,4410),(21979,4411),(21980,4411),(21981,4411),(21982,4411),(21983,4412),(21984,4412),(21985,4412),(21986,4412),(21987,4413),(21988,4413),(21989,4413),(21990,4413),(21991,4414),(21992,4414),(21993,4414),(21994,4414),(21995,4415),(21996,4415),(21997,4415),(21998,4415),(21999,4416),(22000,4416),(22001,4416),(22002,4416),(22003,4417),(22004,4417),(22005,4417),(22006,4417),(22007,4418),(22008,4418),(22009,4418),(22010,4418),(22011,4419),(22012,4419),(22013,4419),(22014,4419),(22015,4420),(22016,4420),(22017,4420),(22018,4420),(22019,4421),(22020,4421),(22021,4421),(22022,4421),(22023,4422),(22024,4422),(22025,4422),(22026,4422),(22027,4423),(22028,4423),(22029,4423),(22030,4423),(22031,4424),(22032,4424),(22033,4424),(22034,4424),(22035,4425),(22036,4425),(22037,4425),(22038,4425),(22039,4426),(22040,4426),(22041,4426),(22042,4426),(22043,4427),(22044,4427),(22045,4427),(22046,4427),(22047,4428),(22048,4428),(22049,4428),(22050,4428),(22051,4429),(22052,4429),(22053,4429),(22054,4429),(22055,4430),(22056,4430),(22057,4430),(22058,4430),(22059,4431),(22060,4431),(22061,4431),(22062,4431),(22063,4432),(22064,4432),(22065,4432),(22066,4432),(22067,4433),(22068,4433),(22069,4433),(22070,4433),(22071,4434),(22072,4434),(22073,4434),(22074,4434),(22075,4435),(22076,4435),(22077,4435),(22078,4435),(22079,4436),(22080,4436),(22081,4436),(22082,4436),(22083,4437),(22084,4437),(22085,4437),(22086,4437),(22087,4438),(22088,4438),(22089,4438),(22090,4438),(22091,4439),(22092,4439),(22093,4439),(22094,4439),(22095,4440),(22096,4440),(22097,4440),(22098,4440),(22099,4441),(22100,4441),(22101,4441),(22102,4441),(22103,4442),(22104,4442),(22105,4442),(22106,4442),(22107,4443),(22108,4443),(22109,4443),(22110,4443),(22111,4444),(22112,4444),(22113,4444),(22114,4444),(22115,4445),(22116,4445),(22117,4445),(22118,4445),(22119,4446),(22120,4446),(22121,4446),(22122,4446),(22123,4447),(22124,4447),(22125,4447),(22126,4447),(22127,4448),(22128,4448),(22129,4448),(22130,4448),(22131,4449),(22132,4449),(22133,4449),(22134,4449),(22135,4450),(22136,4450),(22137,4450),(22138,4450),(22139,4451),(22140,4451),(22141,4451),(22142,4451),(22143,4452),(22144,4452),(22145,4452),(22146,4452),(22147,4453),(22148,4453),(22149,4453),(22150,4453),(22151,4454),(22152,4454),(22153,4454),(22154,4454),(22155,4455),(22156,4455),(22157,4455),(22158,4455),(22159,4456),(22160,4456),(22161,4456),(22162,4456),(22163,4457),(22164,4457),(22165,4457),(22166,4457),(22167,4458),(22168,4458),(22169,4458),(22170,4458),(22171,4459),(22172,4459),(22173,4459),(22174,4459),(22175,4460),(22176,4460),(22177,4460),(22178,4460),(22179,4461),(22180,4461),(22181,4461),(22182,4461),(22183,4462),(22184,4462),(22185,4462),(22186,4462),(22187,4463),(22188,4463),(22189,4463),(22190,4463),(22191,4464),(22192,4464),(22193,4464),(22194,4464),(22195,4465),(22196,4465),(22197,4465),(22198,4465),(22199,4466),(22200,4466),(22201,4466),(22202,4466),(22203,4467),(22204,4467),(22205,4467),(22206,4467),(22207,4468),(22208,4468),(22209,4468),(22210,4468),(22211,4469),(22212,4469),(22213,4469),(22214,4469),(22215,4470),(22216,4470),(22217,4470),(22218,4470),(22219,4471),(22220,4471),(22221,4471),(22222,4471),(22223,4472),(22224,4472),(22225,4472),(22226,4472),(22227,4473),(22228,4473),(22229,4473),(22230,4473),(22231,4474),(22232,4474),(22233,4474),(22234,4474),(22235,4475),(22236,4475),(22237,4475),(22238,4475),(22239,4476),(22240,4476),(22241,4476),(22242,4476),(22243,4477),(22244,4477),(22245,4477),(22246,4477),(22247,4478),(22248,4478),(22249,4478),(22250,4478),(22251,4479),(22252,4479),(22253,4479),(22254,4479),(22255,4480),(22256,4480),(22257,4480),(22258,4480),(22259,4481),(22260,4481),(22261,4481),(22262,4481),(22263,4482),(22264,4482),(22265,4482),(22266,4482),(22267,4483),(22268,4483),(22269,4483),(22270,4483),(22271,4484),(22272,4484),(22273,4484),(22274,4484),(22275,4485),(22276,4485),(22277,4485),(22278,4485),(22279,4486),(22280,4486),(22281,4486),(22282,4486),(22283,4487),(22284,4487),(22285,4487),(22286,4487),(22287,4488),(22288,4488),(22289,4488),(22290,4488),(22291,4489),(22292,4489),(22293,4489),(22294,4489),(22295,4490),(22296,4490),(22297,4490),(22298,4490),(22299,4214),(22300,4215),(22301,4216),(22302,4217),(22303,4218),(22304,4219),(22305,4220),(22306,4221),(22307,4222),(22308,4223),(22309,4224),(22310,4225),(22311,4226),(22312,4227),(22313,4228),(22314,4229),(22315,4230),(22316,4231),(22317,4232),(22318,4233),(22319,4234),(22320,4235),(22321,4236),(22322,4237),(22323,4238),(22324,4239),(22325,4240),(22326,4241),(22327,4242),(22328,4243),(22329,4244),(22330,4245),(22331,4246),(22332,4247),(22333,4248),(22334,4249),(22335,4250),(22336,4251),(22337,4252),(22338,4253),(22339,4254),(22340,4255),(22341,4256),(22342,4257),(22343,4258),(22344,4259),(22345,4260),(22346,4261),(22347,4262),(22348,4263),(22349,4264),(22350,4265),(22351,4266),(22352,4267),(22353,4268),(22354,4269),(22355,4270),(22356,4271),(22357,4272),(22358,4273),(22359,4274),(22360,4275),(22361,4276),(22362,4277),(22363,4278),(22364,4279),(22365,4280),(22366,4281),(22367,4282),(22368,4283),(22369,4284),(22370,4285),(22371,4286),(22372,4287),(22373,4288),(22374,4289),(22375,4290),(22376,4291),(22377,4292),(22378,4293),(22379,4294),(22380,4295),(22381,4296),(22382,4297),(22383,4298),(22384,4299),(22385,4300),(22386,4301),(22387,4302),(22388,4303),(22389,4304),(22390,4305),(22391,4306),(22392,4307),(22393,4308),(22394,4309),(22395,4310),(22396,4311),(22397,4312),(22398,4313),(22399,4314),(22400,4315),(22401,4316),(22402,4317),(22403,4318),(22404,4319),(22405,4320),(22406,4321),(22407,4322),(22408,4323),(22409,4324),(22410,4325),(22411,4326),(22412,4327),(22413,4328),(22414,4329),(22415,4330),(22416,4331),(22417,4332),(22418,4333),(22419,4334),(22420,4335),(22421,4336),(22422,4337),(22423,4338),(22424,4339),(22425,4340),(22426,4341),(22427,4342),(22428,4343),(22429,4344),(22430,4345),(22431,4346),(22432,4347),(22433,4348),(22434,4349),(22435,4350),(22436,4351),(22437,4352),(22438,4353),(22439,4354),(22440,4355),(22441,4356),(22442,4357),(22443,4358),(22444,4359),(22445,4360),(22446,4361),(22447,4362),(22448,4363),(22449,4364),(22450,4365),(22451,4366),(22452,4367),(22453,4368),(22454,4369),(22455,4370),(22456,4371),(22457,4372),(22458,4373),(22459,4374),(22460,4375),(22461,4376),(22462,4377),(22463,4378),(22464,4379),(22465,4380),(22466,4381),(22467,4382),(22468,4383),(22469,4384),(22470,4385),(22471,4386),(22472,4387),(22473,4388),(22474,4389),(22475,4390),(22476,4391),(22477,4392),(22478,4393),(22479,4394),(22480,4395),(22481,4396),(22482,4397),(22483,4398),(22484,4399),(22485,4400),(22486,4401),(22487,4402),(22488,4403),(22489,4404),(22490,4405),(22491,4406),(22492,4407),(22493,4408),(22494,4409),(22495,4410),(22496,4411),(22497,4412),(22498,4413),(22499,4414),(22500,4415),(22501,4416),(22502,4417),(22503,4418),(22504,4419),(22505,4420),(22506,4421),(22507,4422),(22508,4423),(22509,4424),(22510,4425),(22511,4426),(22512,4427),(22513,4428),(22514,4429),(22515,4430),(22516,4431),(22517,4432),(22518,4433),(22519,4434),(22520,4435),(22521,4436),(22522,4437),(22523,4438),(22524,4439),(22525,4440),(22526,4441),(22527,4442),(22528,4443),(22529,4444),(22530,4445),(22531,4446),(22532,4447),(22533,4448),(22534,4449),(22535,4450),(22536,4451),(22537,4452),(22538,4453),(22539,4454),(22540,4455),(22541,4456),(22542,4457),(22543,4458),(22544,4459),(22545,4460),(22546,4461),(22547,4462),(22548,4463),(22549,4464),(22550,4465),(22551,4466),(22552,4467),(22553,4468),(22554,4469),(22555,4470),(22556,4471),(22557,4472),(22558,4473),(22559,4474),(22560,4475),(22561,4476),(22562,4477),(22563,4478),(22564,4479),(22565,4480),(22566,4481),(22567,4482),(22568,4483),(22569,4484),(22570,4485),(22571,4486),(22572,4487),(22573,4488),(22574,4489),(22575,4490),(22576,4491),(22577,4491),(22578,4491),(22579,4491),(22580,4492),(22581,4492),(22582,4492),(22583,4492),(22584,4493),(22585,4493),(22586,4493),(22587,4493),(22588,4494),(22589,4494),(22590,4494),(22591,4494),(22592,4495),(22593,4495),(22594,4495),(22595,4495),(22596,4496),(22597,4496),(22598,4496),(22599,4496),(22600,4497),(22601,4497),(22602,4497),(22603,4497),(22604,4498),(22605,4498),(22606,4498),(22607,4498),(22608,4499),(22609,4499),(22610,4499),(22611,4499),(22612,4500),(22613,4500),(22614,4500),(22615,4500),(22616,4501),(22617,4501),(22618,4501),(22619,4501),(22620,4502),(22621,4502),(22622,4502),(22623,4502),(22624,4503),(22625,4503),(22626,4503),(22627,4503),(22628,4504),(22629,4504),(22630,4504),(22631,4504),(22632,4505),(22633,4505),(22634,4505),(22635,4505),(22636,4506),(22637,4506),(22638,4506),(22639,4506),(22640,4507),(22641,4507),(22642,4507),(22643,4507),(22644,4508),(22645,4508),(22646,4508),(22647,4508),(22648,4509),(22649,4509),(22650,4509),(22651,4509),(22652,4510),(22653,4510),(22654,4510),(22655,4510),(22656,4511),(22657,4511),(22658,4511),(22659,4511),(22660,4512),(22661,4512),(22662,4512),(22663,4512),(22664,4513),(22665,4513),(22666,4513),(22667,4513),(22668,4514),(22669,4514),(22670,4514),(22671,4514),(22672,4515),(22673,4515),(22674,4515),(22675,4515),(22676,4516),(22677,4516),(22678,4516),(22679,4516),(22680,4517),(22681,4517),(22682,4517),(22683,4517),(22684,4518),(22685,4518),(22686,4518),(22687,4518),(22688,4519),(22689,4519),(22690,4519),(22691,4519),(22692,4520),(22693,4520),(22694,4520),(22695,4520),(22696,4521),(22697,4521),(22698,4521),(22699,4521),(22700,4522),(22701,4522),(22702,4522),(22703,4522),(22704,4523),(22705,4523),(22706,4523),(22707,4523),(22708,4524),(22709,4524),(22710,4524),(22711,4524),(22712,4525),(22713,4525),(22714,4525),(22715,4525),(22716,4526),(22717,4526),(22718,4526),(22719,4526),(22720,4527),(22721,4527),(22722,4527),(22723,4527),(22724,4528),(22725,4528),(22726,4528),(22727,4528),(22728,4529),(22729,4529),(22730,4529),(22731,4529),(22732,4530),(22733,4530),(22734,4530),(22735,4530),(22736,4531),(22737,4531),(22738,4531),(22739,4531),(22740,4532),(22741,4532),(22742,4532),(22743,4532),(22744,4533),(22745,4533),(22746,4533),(22747,4533),(22748,4534),(22749,4534),(22750,4534),(22751,4534),(22752,4535),(22753,4535),(22754,4535),(22755,4535),(22756,4536),(22757,4536),(22758,4536),(22759,4536),(22760,4537),(22761,4537),(22762,4537),(22763,4537),(22764,4538),(22765,4538),(22766,4538),(22767,4538),(22768,4539),(22769,4539),(22770,4539),(22771,4539),(22772,4540),(22773,4540),(22774,4540),(22775,4540),(22776,4541),(22777,4541),(22778,4541),(22779,4541),(22780,4542),(22781,4542),(22782,4542),(22783,4542),(22784,4543),(22785,4543),(22786,4543),(22787,4543),(22788,4544),(22789,4544),(22790,4544),(22791,4544),(22792,4545),(22793,4545),(22794,4545),(22795,4545),(22796,4546),(22797,4546),(22798,4546),(22799,4546),(22800,4547),(22801,4547),(22802,4547),(22803,4547),(22804,4548),(22805,4548),(22806,4548),(22807,4548),(22808,4549),(22809,4549),(22810,4549),(22811,4549),(22812,4550),(22813,4550),(22814,4550),(22815,4550),(22816,4551),(22817,4551),(22818,4551),(22819,4551),(22820,4552),(22821,4552),(22822,4552),(22823,4552),(22824,4553),(22825,4553),(22826,4553),(22827,4553),(22828,4554),(22829,4554),(22830,4554),(22831,4554),(22832,4555),(22833,4555),(22834,4555),(22835,4555),(22836,4556),(22837,4556),(22838,4556),(22839,4556),(22840,4557),(22841,4557),(22842,4557),(22843,4557),(22844,4558),(22845,4558),(22846,4558),(22847,4558),(22848,4559),(22849,4559),(22850,4559),(22851,4559),(22852,4560),(22853,4560),(22854,4560),(22855,4560),(22856,4561),(22857,4561),(22858,4561),(22859,4561),(22860,4562),(22861,4562),(22862,4562),(22863,4562),(22864,4563),(22865,4563),(22866,4563),(22867,4563),(22868,4564),(22869,4564),(22870,4564),(22871,4564),(22872,4565),(22873,4565),(22874,4565),(22875,4565),(22876,4566),(22877,4566),(22878,4566),(22879,4566),(22880,4567),(22881,4567),(22882,4567),(22883,4567),(22884,4568),(22885,4568),(22886,4568),(22887,4568),(22888,4569),(22889,4569),(22890,4569),(22891,4569),(22892,4570),(22893,4570),(22894,4570),(22895,4570),(22896,4571),(22897,4571),(22898,4571),(22899,4571),(22900,4572),(22901,4572),(22902,4572),(22903,4572),(22904,4573),(22905,4573),(22906,4573),(22907,4573),(22908,4574),(22909,4574),(22910,4574),(22911,4574),(22912,4575),(22913,4575),(22914,4575),(22915,4575),(22916,4576),(22917,4576),(22918,4576),(22919,4576),(22920,4577),(22921,4577),(22922,4577),(22923,4577),(22924,4578),(22925,4578),(22926,4578),(22927,4578),(22928,4579),(22929,4579),(22930,4579),(22931,4579),(22932,4580),(22933,4580),(22934,4580),(22935,4580),(22936,4581),(22937,4581),(22938,4581),(22939,4581),(22940,4582),(22941,4582),(22942,4582),(22943,4582),(22944,4583),(22945,4583),(22946,4583),(22947,4583),(22948,4584),(22949,4584),(22950,4584),(22951,4584),(22952,4585),(22953,4585),(22954,4585),(22955,4585),(22956,4586),(22957,4586),(22958,4586),(22959,4586),(22960,4587),(22961,4587),(22962,4587),(22963,4587),(22964,4588),(22965,4588),(22966,4588),(22967,4588),(22968,4589),(22969,4589),(22970,4589),(22971,4589),(22972,4590),(22973,4590),(22974,4590),(22975,4590),(22976,4591),(22977,4591),(22978,4591),(22979,4591),(22980,4592),(22981,4592),(22982,4592),(22983,4592),(22984,4593),(22985,4593),(22986,4593),(22987,4593),(22988,4594),(22989,4594),(22990,4594),(22991,4594),(22992,4595),(22993,4595),(22994,4595),(22995,4595),(22996,4596),(22997,4596),(22998,4596),(22999,4596),(23000,4597),(23001,4597),(23002,4597),(23003,4597),(23004,4598),(23005,4598),(23006,4598),(23007,4598),(23008,4599),(23009,4599),(23010,4599),(23011,4599),(23012,4600),(23013,4600),(23014,4600),(23015,4600),(23016,4601),(23017,4601),(23018,4601),(23019,4601),(23020,4602),(23021,4602),(23022,4602),(23023,4602),(23024,4603),(23025,4603),(23026,4603),(23027,4603),(23028,4604),(23029,4604),(23030,4604),(23031,4604),(23032,4605),(23033,4605),(23034,4605),(23035,4605),(23036,4606),(23037,4606),(23038,4606),(23039,4606),(23040,4607),(23041,4607),(23042,4607),(23043,4607),(23044,4608),(23045,4608),(23046,4608),(23047,4608),(23048,4609),(23049,4609),(23050,4609),(23051,4609),(23052,4610),(23053,4610),(23054,4610),(23055,4610),(23056,4611),(23057,4611),(23058,4611),(23059,4611),(23060,4612),(23061,4612),(23062,4612),(23063,4612),(23064,4613),(23065,4613),(23066,4613),(23067,4613),(23068,4614),(23069,4614),(23070,4614),(23071,4614),(23072,4615),(23073,4615),(23074,4615),(23075,4615),(23076,4616),(23077,4616),(23078,4616),(23079,4616),(23080,4617),(23081,4617),(23082,4617),(23083,4617),(23084,4618),(23085,4618),(23086,4618),(23087,4618),(23088,4619),(23089,4619),(23090,4619),(23091,4619),(23092,4620),(23093,4620),(23094,4620),(23095,4620),(23096,4621),(23097,4621),(23098,4621),(23099,4621),(23100,4622),(23101,4622),(23102,4622),(23103,4622),(23104,4623),(23105,4623),(23106,4623),(23107,4623),(23108,4624),(23109,4624),(23110,4624),(23111,4624),(23112,4625),(23113,4625),(23114,4625),(23115,4625),(23116,4626),(23117,4626),(23118,4626),(23119,4626),(23120,4627),(23121,4627),(23122,4627),(23123,4627),(23124,4628),(23125,4628),(23126,4628),(23127,4628),(23128,4629),(23129,4629),(23130,4629),(23131,4629),(23132,4630),(23133,4630),(23134,4630),(23135,4630),(23136,4631),(23137,4631),(23138,4631),(23139,4631),(23140,4632),(23141,4632),(23142,4632),(23143,4632),(23144,4633),(23145,4633),(23146,4633),(23147,4633),(23148,4634),(23149,4634),(23150,4634),(23151,4634),(23152,4635),(23153,4635),(23154,4635),(23155,4635),(23156,4636),(23157,4636),(23158,4636),(23159,4636),(23160,4637),(23161,4637),(23162,4637),(23163,4637),(23164,4638),(23165,4638),(23166,4638),(23167,4638),(23168,4639),(23169,4639),(23170,4639),(23171,4639),(23172,4640),(23173,4640),(23174,4640),(23175,4640),(23176,4641),(23177,4641),(23178,4641),(23179,4641),(23180,4642),(23181,4642),(23182,4642),(23183,4642),(23184,4643),(23185,4643),(23186,4643),(23187,4643),(23188,4644),(23189,4644),(23190,4644),(23191,4644),(23192,4645),(23193,4645),(23194,4645),(23195,4645),(23196,4646),(23197,4646),(23198,4646),(23199,4646),(23200,4647),(23201,4647),(23202,4647),(23203,4647),(23204,4648),(23205,4648),(23206,4648),(23207,4648),(23208,4649),(23209,4649),(23210,4649),(23211,4649),(23212,4650),(23213,4650),(23214,4650),(23215,4650),(23216,4651),(23217,4651),(23218,4651),(23219,4651),(23220,4652),(23221,4652),(23222,4652),(23223,4652),(23224,4653),(23225,4653),(23226,4653),(23227,4653),(23228,4654),(23229,4654),(23230,4654),(23231,4654),(23232,4655),(23233,4655),(23234,4655),(23235,4655),(23236,4656),(23237,4656),(23238,4656),(23239,4656),(23240,4657),(23241,4657),(23242,4657),(23243,4657),(23244,4658),(23245,4658),(23246,4658),(23247,4658),(23248,4659),(23249,4659),(23250,4659),(23251,4659),(23252,4660),(23253,4660),(23254,4660),(23255,4660),(23256,4661),(23257,4661),(23258,4661),(23259,4661),(23260,4662),(23261,4662),(23262,4662),(23263,4662),(23264,4663),(23265,4663),(23266,4663),(23267,4663),(23268,4664),(23269,4664),(23270,4664),(23271,4664),(23272,4665),(23273,4665),(23274,4665),(23275,4665),(23276,4666),(23277,4666),(23278,4666),(23279,4666),(23280,4667),(23281,4667),(23282,4667),(23283,4667),(23284,4668),(23285,4668),(23286,4668),(23287,4668),(23288,4669),(23289,4669),(23290,4669),(23291,4669),(23292,4670),(23293,4670),(23294,4670),(23295,4670),(23296,4671),(23297,4671),(23298,4671),(23299,4671),(23300,4672),(23301,4672),(23302,4672),(23303,4672),(23304,4673),(23305,4673),(23306,4673),(23307,4673),(23308,4674),(23309,4674),(23310,4674),(23311,4674),(23312,4675),(23313,4675),(23314,4675),(23315,4675),(23316,4676),(23317,4676),(23318,4676),(23319,4676),(23320,4677),(23321,4677),(23322,4677),(23323,4677),(23324,4678),(23325,4678),(23326,4678),(23327,4678),(23328,4679),(23329,4679),(23330,4679),(23331,4679),(23332,4680),(23333,4680),(23334,4680),(23335,4680),(23336,4681),(23337,4681),(23338,4681),(23339,4681),(23340,4682),(23341,4682),(23342,4682),(23343,4682),(23344,4683),(23345,4683),(23346,4683),(23347,4683),(23348,4684),(23349,4684),(23350,4684),(23351,4684),(23352,4685),(23353,4685),(23354,4685),(23355,4685),(23356,4686),(23357,4686),(23358,4686),(23359,4686),(23360,4687),(23361,4687),(23362,4687),(23363,4687),(23364,4688),(23365,4688),(23366,4688),(23367,4688),(23368,4689),(23369,4689),(23370,4689),(23371,4689),(23372,4690),(23373,4690),(23374,4690),(23375,4690),(23376,4691),(23377,4691),(23378,4691),(23379,4691),(23380,4692),(23381,4692),(23382,4692),(23383,4692),(23384,4693),(23385,4693),(23386,4693),(23387,4693),(23388,4694),(23389,4694),(23390,4694),(23391,4694),(23392,4695),(23393,4695),(23394,4695),(23395,4695),(23396,4696),(23397,4696),(23398,4696),(23399,4696),(23400,4697),(23401,4697),(23402,4697),(23403,4697),(23404,4698),(23405,4698),(23406,4698),(23407,4698),(23408,4699),(23409,4699),(23410,4699),(23411,4699),(23412,4700),(23413,4700),(23414,4700),(23415,4700),(23416,4701),(23417,4701),(23418,4701),(23419,4701),(23420,4702),(23421,4702),(23422,4702),(23423,4702),(23424,4703),(23425,4703),(23426,4703),(23427,4703),(23428,4704),(23429,4704),(23430,4704),(23431,4704),(23432,4705),(23433,4705),(23434,4705),(23435,4705),(23436,4706),(23437,4706),(23438,4706),(23439,4706),(23440,4707),(23441,4707),(23442,4707),(23443,4707),(23444,4708),(23445,4708),(23446,4708),(23447,4708),(23448,4709),(23449,4709),(23450,4709),(23451,4709),(23452,4710),(23453,4710),(23454,4710),(23455,4710),(23456,4711),(23457,4711),(23458,4711),(23459,4711),(23460,4712),(23461,4712),(23462,4712),(23463,4712),(23464,4713),(23465,4713),(23466,4713),(23467,4713),(23468,4714),(23469,4714),(23470,4714),(23471,4714),(23472,4715),(23473,4715),(23474,4715),(23475,4715),(23476,4716),(23477,4716),(23478,4716),(23479,4716),(23480,4717),(23481,4717),(23482,4717),(23483,4717),(23484,4718),(23485,4718),(23486,4718),(23487,4718),(23488,4719),(23489,4719),(23490,4719),(23491,4719),(23492,4720),(23493,4720),(23494,4720),(23495,4720),(23496,4721),(23497,4721),(23498,4721),(23499,4721),(23500,4722),(23501,4722),(23502,4722),(23503,4722),(23504,4723),(23505,4723),(23506,4723),(23507,4723),(23508,4724),(23509,4724),(23510,4724),(23511,4724),(23512,4725),(23513,4725),(23514,4725),(23515,4725),(23516,4726),(23517,4726),(23518,4726),(23519,4726),(23520,4727),(23521,4727),(23522,4727),(23523,4727),(23524,4728),(23525,4728),(23526,4728),(23527,4728),(23528,4729),(23529,4729),(23530,4729),(23531,4729),(23532,4730),(23533,4730),(23534,4730),(23535,4730),(23536,4731),(23537,4731),(23538,4731),(23539,4731),(23540,4732),(23541,4732),(23542,4732),(23543,4732),(23544,4733),(23545,4733),(23546,4733),(23547,4733),(23548,4734),(23549,4734),(23550,4734),(23551,4734),(23552,4735),(23553,4735),(23554,4735),(23555,4735),(23556,4736),(23557,4736),(23558,4736),(23559,4736),(23560,4737),(23561,4737),(23562,4737),(23563,4737),(23564,4738),(23565,4738),(23566,4738),(23567,4738),(23568,4739),(23569,4739),(23570,4739),(23571,4739),(23572,4740),(23573,4740),(23574,4740),(23575,4740),(23576,4741),(23577,4741),(23578,4741),(23579,4741),(23580,4742),(23581,4742),(23582,4742),(23583,4742),(23584,4743),(23585,4743),(23586,4743),(23587,4743),(23588,4744),(23589,4744),(23590,4744),(23591,4744),(23592,4745),(23593,4745),(23594,4745),(23595,4745),(23596,4746),(23597,4746),(23598,4746),(23599,4746),(23600,4747),(23601,4747),(23602,4747),(23603,4747),(23604,4748),(23605,4748),(23606,4748),(23607,4748),(23608,4749),(23609,4749),(23610,4749),(23611,4749),(23612,4750),(23613,4750),(23614,4750),(23615,4750),(23616,4751),(23617,4751),(23618,4751),(23619,4751),(23620,4752),(23621,4752),(23622,4752),(23623,4752),(23624,4753),(23625,4753),(23626,4753),(23627,4753),(23628,4754),(23629,4754),(23630,4754),(23631,4754),(23632,4755),(23633,4755),(23634,4755),(23635,4755),(23636,4756),(23637,4756),(23638,4756),(23639,4756),(23640,4757),(23641,4757),(23642,4757),(23643,4757),(23644,4758),(23645,4758),(23646,4758),(23647,4758),(23648,4759),(23649,4759),(23650,4759),(23651,4759),(23652,4760),(23653,4760),(23654,4760),(23655,4760),(23656,4761),(23657,4761),(23658,4761),(23659,4761),(23660,4762),(23661,4762),(23662,4762),(23663,4762),(23664,4763),(23665,4763),(23666,4763),(23667,4763),(23668,4764),(23669,4764),(23670,4764),(23671,4764),(23672,4765),(23673,4765),(23674,4765),(23675,4765),(23676,4766),(23677,4766),(23678,4766),(23679,4766),(23680,4767),(23681,4767),(23682,4767),(23683,4767),(23684,4768),(23685,4768),(23686,4768),(23687,4768),(23688,4769),(23689,4769),(23690,4769),(23691,4769),(23692,4770),(23693,4770),(23694,4770),(23695,4770),(23696,4771),(23697,4771),(23698,4771),(23699,4771),(23700,4772),(23701,4772),(23702,4772),(23703,4772),(23704,4773),(23705,4773),(23706,4773),(23707,4773),(23708,4774),(23709,4774),(23710,4774),(23711,4774),(23712,4775),(23713,4775),(23714,4775),(23715,4775),(23716,4776),(23717,4776),(23718,4776),(23719,4776),(23720,4777),(23721,4777),(23722,4777),(23723,4777),(23724,4778),(23725,4778),(23726,4778),(23727,4778),(23728,4779),(23729,4779),(23730,4779),(23731,4779),(23732,4780),(23733,4780),(23734,4780),(23735,4780),(23736,4781),(23737,4781),(23738,4781),(23739,4781),(23740,4782),(23741,4782),(23742,4782),(23743,4782),(23744,4783),(23745,4783),(23746,4783),(23747,4783),(23748,4784),(23749,4784),(23750,4784),(23751,4784),(23752,4785),(23753,4785),(23754,4785),(23755,4785),(23756,4786),(23757,4786),(23758,4786),(23759,4786),(23760,4787),(23761,4787),(23762,4787),(23763,4787),(23764,4788),(23765,4788),(23766,4788),(23767,4788),(23768,4789),(23769,4789),(23770,4789),(23771,4789),(23772,4790),(23773,4790),(23774,4790),(23775,4790),(23776,4791),(23777,4791),(23778,4791),(23779,4791),(23780,4792),(23781,4792),(23782,4792),(23783,4792),(23784,4793),(23785,4793),(23786,4793),(23787,4793),(23788,4794),(23789,4794),(23790,4794),(23791,4794),(23792,4795),(23793,4795),(23794,4795),(23795,4795),(23796,4796),(23797,4796),(23798,4796),(23799,4796),(23800,4797),(23801,4797),(23802,4797),(23803,4797),(23804,4798),(23805,4798),(23806,4798),(23807,4798),(23808,4799),(23809,4799),(23810,4799),(23811,4799),(23812,4800),(23813,4800),(23814,4800),(23815,4800),(23816,4801),(23817,4801),(23818,4801),(23819,4801),(23820,4802),(23821,4802),(23822,4802),(23823,4802),(23824,4803),(23825,4803),(23826,4803),(23827,4803),(23828,4804),(23829,4804),(23830,4804),(23831,4804),(23832,4805),(23833,4805),(23834,4805),(23835,4805),(23836,4806),(23837,4806),(23838,4806),(23839,4806),(23840,4807),(23841,4807),(23842,4807),(23843,4807),(23844,4808),(23845,4808),(23846,4808),(23847,4808),(23848,4809),(23849,4809),(23850,4809),(23851,4809),(23852,4810),(23853,4810),(23854,4810),(23855,4810),(23856,4811),(23857,4811),(23858,4811),(23859,4811),(23860,4812),(23861,4812),(23862,4812),(23863,4812),(23864,4813),(23865,4813),(23866,4813),(23867,4813),(23868,4814),(23869,4814),(23870,4814),(23871,4814),(23872,4815),(23873,4815),(23874,4815),(23875,4815),(23876,4816),(23877,4816),(23878,4816),(23879,4816),(23880,4817),(23881,4817),(23882,4817),(23883,4817),(23884,4818),(23885,4818),(23886,4818),(23887,4818),(23888,4819),(23889,4819),(23890,4819),(23891,4819),(23892,4820),(23893,4820),(23894,4820),(23895,4820),(23896,4821),(23897,4821),(23898,4821),(23899,4821),(23900,4822),(23901,4822),(23902,4822),(23903,4822),(23904,4823),(23905,4823),(23906,4823),(23907,4823),(23908,4824),(23909,4824),(23910,4824),(23911,4824),(23912,4825),(23913,4825),(23914,4825),(23915,4825),(23916,4826),(23917,4826),(23918,4826),(23919,4826),(23920,4827),(23921,4827),(23922,4827),(23923,4827),(23924,4828),(23925,4828),(23926,4828),(23927,4828),(23928,4829),(23929,4829),(23930,4829),(23931,4829),(23932,4830),(23933,4830),(23934,4830),(23935,4830),(23936,4831),(23937,4831),(23938,4831),(23939,4831),(23940,4832),(23941,4832),(23942,4832),(23943,4832),(23944,4833),(23945,4833),(23946,4833),(23947,4833),(23948,4834),(23949,4834),(23950,4834),(23951,4834),(23952,4835),(23953,4835),(23954,4835),(23955,4835),(23956,4836),(23957,4836),(23958,4836),(23959,4836),(23960,4837),(23961,4837),(23962,4837),(23963,4837),(23964,4838),(23965,4838),(23966,4838),(23967,4838),(23968,4839),(23969,4839),(23970,4839),(23971,4839),(23972,4840),(23973,4840),(23974,4840),(23975,4840),(23976,4841),(23977,4841),(23978,4841),(23979,4841),(23980,4842),(23981,4842),(23982,4842),(23983,4842),(23984,4843),(23985,4843),(23986,4843),(23987,4843),(23988,4844),(23989,4844),(23990,4844),(23991,4844),(23992,4845),(23993,4845),(23994,4845),(23995,4845),(23996,4846),(23997,4846),(23998,4846),(23999,4846),(24000,4847),(24001,4847),(24002,4847),(24003,4847),(24004,4848),(24005,4848),(24006,4848),(24007,4848),(24008,4849),(24009,4849),(24010,4849),(24011,4849),(24012,4850),(24013,4850),(24014,4850),(24015,4850),(24016,4851),(24017,4851),(24018,4851),(24019,4851),(24020,4852),(24021,4852),(24022,4852),(24023,4852),(24024,4853),(24025,4853),(24026,4853),(24027,4853),(24028,4854),(24029,4854),(24030,4854),(24031,4854),(24032,4855),(24033,4855),(24034,4855),(24035,4855),(24036,4856),(24037,4856),(24038,4856),(24039,4856),(24040,4857),(24041,4857),(24042,4857),(24043,4857),(24044,4858),(24045,4858),(24046,4858),(24047,4858),(24048,4859),(24049,4859),(24050,4859),(24051,4859),(24052,4860),(24053,4860),(24054,4860),(24055,4860),(24056,4861),(24057,4861),(24058,4861),(24059,4861),(24060,4862),(24061,4862),(24062,4862),(24063,4862),(24064,4863),(24065,4863),(24066,4863),(24067,4863),(24068,4864),(24069,4864),(24070,4864),(24071,4864),(24072,4865),(24073,4865),(24074,4865),(24075,4865),(24076,4866),(24077,4866),(24078,4866),(24079,4866),(24080,4867),(24081,4867),(24082,4867),(24083,4867),(24084,4868),(24085,4868),(24086,4868),(24087,4868),(24088,4869),(24089,4869),(24090,4869),(24091,4869),(24092,4870),(24093,4870),(24094,4870),(24095,4870),(24096,4871),(24097,4871),(24098,4871),(24099,4871),(24100,4872),(24101,4872),(24102,4872),(24103,4872),(24104,4873),(24105,4873),(24106,4873),(24107,4873),(24108,4874),(24109,4874),(24110,4874),(24111,4874),(24112,4875),(24113,4875),(24114,4875),(24115,4875),(24116,4876),(24117,4876),(24118,4876),(24119,4876),(24120,4877),(24121,4877),(24122,4877),(24123,4877),(24124,4878),(24125,4878),(24126,4878),(24127,4878),(24128,4879),(24129,4879),(24130,4879),(24131,4879),(24132,4880),(24133,4880),(24134,4880),(24135,4880),(24136,4881),(24137,4881),(24138,4881),(24139,4881),(24140,4882),(24141,4882),(24142,4882),(24143,4882),(24144,4883),(24145,4883),(24146,4883),(24147,4883),(24148,4884),(24149,4884),(24150,4884),(24151,4884),(24152,4885),(24153,4885),(24154,4885),(24155,4885),(24156,4886),(24157,4886),(24158,4886),(24159,4886),(24160,4887),(24161,4887),(24162,4887),(24163,4887),(24164,4888),(24165,4888),(24166,4888),(24167,4888),(24168,4889),(24169,4889),(24170,4889),(24171,4889),(24172,4890),(24173,4890),(24174,4890),(24175,4890),(24176,4891),(24177,4891),(24178,4891),(24179,4891),(24180,4892),(24181,4892),(24182,4892),(24183,4892),(24184,4893),(24185,4893),(24186,4893),(24187,4893),(24188,4894),(24189,4894),(24190,4894),(24191,4894),(24192,4895),(24193,4895),(24194,4895),(24195,4895),(24196,4896),(24197,4896),(24198,4896),(24199,4896),(24200,4897),(24201,4897),(24202,4897),(24203,4897),(24204,4898),(24205,4898),(24206,4898),(24207,4898),(24208,4899),(24209,4899),(24210,4899),(24211,4899),(24212,4900),(24213,4900),(24214,4900),(24215,4900),(24216,4901),(24217,4901),(24218,4901),(24219,4901),(24220,4902),(24221,4902),(24222,4902),(24223,4902),(24224,4903),(24225,4903),(24226,4903),(24227,4903),(24228,4904),(24229,4904),(24230,4904),(24231,4904),(24232,4905),(24233,4905),(24234,4905),(24235,4905),(24236,4906),(24237,4906),(24238,4906),(24239,4906),(24240,4907),(24241,4907),(24242,4907),(24243,4907),(24244,4908),(24245,4908),(24246,4908),(24247,4908),(24248,4909),(24249,4909),(24250,4909),(24251,4909),(24252,4910),(24253,4910),(24254,4910),(24255,4910),(24256,4911),(24257,4911),(24258,4911),(24259,4911),(24260,4912),(24261,4912),(24262,4912),(24263,4912),(24264,4913),(24265,4913),(24266,4913),(24267,4913),(24268,4914),(24269,4914),(24270,4914),(24271,4914),(24272,4915),(24273,4915),(24274,4915),(24275,4915),(24276,4916),(24277,4916),(24278,4916),(24279,4916),(24280,4917),(24281,4917),(24282,4917),(24283,4917),(24284,4918),(24285,4918),(24286,4918),(24287,4918),(24288,4919),(24289,4919),(24290,4919),(24291,4919),(24292,4920),(24293,4920),(24294,4920),(24295,4920),(24296,4921),(24297,4921),(24298,4921),(24299,4921),(24300,4922),(24301,4922),(24302,4922),(24303,4922),(24304,4923),(24305,4923),(24306,4923),(24307,4923),(24308,4924),(24309,4924),(24310,4924),(24311,4924),(24312,4925),(24313,4925),(24314,4925),(24315,4925),(24316,4926),(24317,4926),(24318,4926),(24319,4926),(24320,4927),(24321,4927),(24322,4927),(24323,4927),(24324,4928),(24325,4928),(24326,4928),(24327,4928),(24328,4929),(24329,4929),(24330,4929),(24331,4929),(24332,4930),(24333,4930),(24334,4930),(24335,4930),(24336,4931),(24337,4931),(24338,4931),(24339,4931),(24340,4932),(24341,4932),(24342,4932),(24343,4932),(24344,4933),(24345,4933),(24346,4933),(24347,4933),(24348,4934),(24349,4934),(24350,4934),(24351,4934),(24352,4935),(24353,4935),(24354,4935),(24355,4935),(24356,4936),(24357,4936),(24358,4936),(24359,4936),(24360,4937),(24361,4937),(24362,4937),(24363,4937),(24364,4938),(24365,4938),(24366,4938),(24367,4938),(24368,4939),(24369,4939),(24370,4939),(24371,4939),(24372,4940),(24373,4940),(24374,4940),(24375,4940),(24376,4941),(24377,4941),(24378,4941),(24379,4941),(24380,4942),(24381,4942),(24382,4942),(24383,4942),(24384,4943),(24385,4943),(24386,4943),(24387,4943),(24388,4944),(24389,4944),(24390,4944),(24391,4944),(24392,4945),(24393,4945),(24394,4945),(24395,4945),(24396,4946),(24397,4946),(24398,4946),(24399,4946),(24400,4947),(24401,4947),(24402,4947),(24403,4947),(24404,4948),(24405,4948),(24406,4948),(24407,4948),(24408,4949),(24409,4949),(24410,4949),(24411,4949),(24412,4950),(24413,4950),(24414,4950),(24415,4950),(24416,4951),(24417,4951),(24418,4951),(24419,4951),(24420,4952),(24421,4952),(24422,4952),(24423,4952),(24424,4953),(24425,4953),(24426,4953),(24427,4953),(24428,4954),(24429,4954),(24430,4954),(24431,4954),(24432,4955),(24433,4955),(24434,4955),(24435,4955),(24436,4956),(24437,4956),(24438,4956),(24439,4956),(24440,4957),(24441,4957),(24442,4957),(24443,4957),(24444,4958),(24445,4958),(24446,4958),(24447,4958),(24448,4959),(24449,4959),(24450,4959),(24451,4959),(24452,4960),(24453,4960),(24454,4960),(24455,4960),(24456,4961),(24457,4961),(24458,4961),(24459,4961),(24460,4962),(24461,4962),(24462,4962),(24463,4962),(24464,4963),(24465,4963),(24466,4963),(24467,4963),(24468,4964),(24469,4964),(24470,4964),(24471,4964),(24472,4965),(24473,4965),(24474,4965),(24475,4965),(24476,4966),(24477,4966),(24478,4966),(24479,4966),(24480,4967),(24481,4967),(24482,4967),(24483,4967),(24484,4968),(24485,4968),(24486,4968),(24487,4968),(24488,4969),(24489,4969),(24490,4969),(24491,4969),(24492,4970),(24493,4970),(24494,4970),(24495,4970),(24496,4971),(24497,4971),(24498,4971),(24499,4971),(24500,4972),(24501,4972),(24502,4972),(24503,4972),(24504,4973),(24505,4973),(24506,4973),(24507,4973),(24508,4974),(24509,4974),(24510,4974),(24511,4974),(24512,4975),(24513,4975),(24514,4975),(24515,4975),(24516,4976),(24517,4976),(24518,4976),(24519,4976),(24520,4977),(24521,4977),(24522,4977),(24523,4977),(24524,4978),(24525,4978),(24526,4978),(24527,4978),(24528,4979),(24529,4979),(24530,4979),(24531,4979),(24532,4980),(24533,4980),(24534,4980),(24535,4980),(24536,4981),(24537,4981),(24538,4981),(24539,4981),(24540,4982),(24541,4982),(24542,4982),(24543,4982),(24544,4983),(24545,4983),(24546,4983),(24547,4983),(24548,4984),(24549,4984),(24550,4984),(24551,4984),(24552,4985),(24553,4985),(24554,4985),(24555,4985),(24556,4986),(24557,4986),(24558,4986),(24559,4986),(24560,4987),(24561,4987),(24562,4987),(24563,4987),(24564,4988),(24565,4988),(24566,4988),(24567,4988),(24568,4989),(24569,4989),(24570,4989),(24571,4989),(24572,4990),(24573,4990),(24574,4990),(24575,4990),(24576,4991),(24577,4991),(24578,4991),(24579,4991),(24580,4992),(24581,4992),(24582,4992),(24583,4992),(24584,4993),(24585,4993),(24586,4993),(24587,4993),(24588,4994),(24589,4994),(24590,4994),(24591,4994),(24592,4995),(24593,4995),(24594,4995),(24595,4995),(24596,4996),(24597,4996),(24598,4996),(24599,4996),(24600,4997),(24601,4997),(24602,4997),(24603,4997),(24604,4998),(24605,4998),(24606,4998),(24607,4998),(24608,4999),(24609,4999),(24610,4999),(24611,4999),(24612,5000),(24613,5000),(24614,5000),(24615,5000),(24616,5001),(24617,5001),(24618,5001),(24619,5001),(24620,5002),(24621,5002),(24622,5002),(24623,5002),(24624,5003),(24625,5003),(24626,5003),(24627,5003),(24628,5004),(24629,5004),(24630,5004),(24631,5004),(24632,5005),(24633,5005),(24634,5005),(24635,5005),(24636,5006),(24637,5006),(24638,5006),(24639,5006),(24640,5007),(24641,5007),(24642,5007),(24643,5007),(24644,5008),(24645,5008),(24646,5008),(24647,5008),(24648,5009),(24649,5009),(24650,5009),(24651,5009),(24652,5010),(24653,5010),(24654,5010),(24655,5010),(24656,5011),(24657,5011),(24658,5011),(24659,5011),(24660,5012),(24661,5012),(24662,5012),(24663,5012),(24664,5013),(24665,5013),(24666,5013),(24667,5013),(24668,5014),(24669,5014),(24670,5014),(24671,5014),(24672,5015),(24673,5015),(24674,5015),(24675,5015),(24676,5016),(24677,5016),(24678,5016),(24679,5016),(24680,5017),(24681,5017),(24682,5017),(24683,5017),(24684,5018),(24685,5018),(24686,5018),(24687,5018),(24688,5019),(24689,5019),(24690,5019),(24691,5019),(24692,5020),(24693,5020),(24694,5020),(24695,5020),(24696,5021),(24697,5021),(24698,5021),(24699,5021),(24700,5022),(24701,5022),(24702,5022),(24703,5022),(24704,5023),(24705,5023),(24706,5023),(24707,5023),(24708,5024),(24709,5024),(24710,5024),(24711,5024),(24712,5025),(24713,5025),(24714,5025),(24715,5025),(24716,5026),(24717,5026),(24718,5026),(24719,5026),(24720,5027),(24721,5027),(24722,5027),(24723,5027),(24724,5028),(24725,5028),(24726,5028),(24727,5028),(24728,5029),(24729,5029),(24730,5029),(24731,5029),(24732,5030),(24733,5030),(24734,5030),(24735,5030),(24736,5031),(24737,5031),(24738,5031),(24739,5031),(24740,5032),(24741,5032),(24742,5032),(24743,5032),(24744,5033),(24745,5033),(24746,5033),(24747,5033),(24748,5034),(24749,5034),(24750,5034),(24751,5034),(24752,5035),(24753,5035),(24754,5035),(24755,5035),(24756,5036),(24757,5036),(24758,5036),(24759,5036),(24760,5037),(24761,5037),(24762,5037),(24763,5037),(24764,5038),(24765,5038),(24766,5038),(24767,5038),(24768,5039),(24769,5039),(24770,5039),(24771,5039),(24772,5040),(24773,5040),(24774,5040),(24775,5040),(24776,5041),(24777,5041),(24778,5041),(24779,5041),(24780,5042),(24781,5042),(24782,5042),(24783,5042),(24784,5043),(24785,5043),(24786,5043),(24787,5043),(24788,5044),(24789,5044),(24790,5044),(24791,5044),(24792,5045),(24793,5045),(24794,5045),(24795,5045),(24796,5046),(24797,5046),(24798,5046),(24799,5046),(24800,5047),(24801,5047),(24802,5047),(24803,5047),(24804,5048),(24805,5048),(24806,5048),(24807,5048),(24808,5049),(24809,5049),(24810,5049),(24811,5049),(24812,5050),(24813,5050),(24814,5050),(24815,5050),(24816,5051),(24817,5051),(24818,5051),(24819,5051),(24820,5052),(24821,5052),(24822,5052),(24823,5052),(24824,5053),(24825,5053),(24826,5053),(24827,5053),(24828,5054),(24829,5054),(24830,5054),(24831,5054),(24832,5055),(24833,5055),(24834,5055),(24835,5055),(24836,5056),(24837,5056),(24838,5056),(24839,5056),(24840,5057),(24841,5057),(24842,5057),(24843,5057),(24844,5058),(24845,5058),(24846,5058),(24847,5058),(24848,5059),(24849,5059),(24850,5059),(24851,5059),(24852,5060),(24853,5060),(24854,5060),(24855,5060),(24856,5061),(24857,5061),(24858,5061),(24859,5061),(24860,5062),(24861,5062),(24862,5062),(24863,5062),(24864,5063),(24865,5063),(24866,5063),(24867,5063),(24868,5064),(24869,5064),(24870,5064),(24871,5064),(24872,5065),(24873,5065),(24874,5065),(24875,5065),(24876,5066),(24877,5066),(24878,5066),(24879,5066),(24880,5067),(24881,5067),(24882,5067),(24883,5067),(24884,5068),(24885,5068),(24886,5068),(24887,5068),(24888,5069),(24889,5069),(24890,5069),(24891,5069),(24892,5070),(24893,5070),(24894,5070),(24895,5070),(24896,5071),(24897,5071),(24898,5071),(24899,5071),(24900,5072),(24901,5072),(24902,5072),(24903,5072),(24904,5073),(24905,5073),(24906,5073),(24907,5073),(24908,5074),(24909,5074),(24910,5074),(24911,5074),(24912,5075),(24913,5075),(24914,5075),(24915,5075),(24916,5076),(24917,5076),(24918,5076),(24919,5076),(24920,5077),(24921,5077),(24922,5077),(24923,5077),(24924,5078),(24925,5078),(24926,5078),(24927,5078),(24928,5079),(24929,5079),(24930,5079),(24931,5079),(24932,5080),(24933,5080),(24934,5080),(24935,5080),(24936,5081),(24937,5081),(24938,5081),(24939,5081),(24940,5082),(24941,5082),(24942,5082),(24943,5082),(24944,5083),(24945,5083),(24946,5083),(24947,5083),(24948,5084),(24949,5084),(24950,5084),(24951,5084),(24952,5085),(24953,5085),(24954,5085),(24955,5085),(24956,5086),(24957,5086),(24958,5086),(24959,5086),(24960,5087),(24961,5087),(24962,5087),(24963,5087),(24964,5088),(24965,5088),(24966,5088),(24967,5088),(24968,5089),(24969,5089),(24970,5089),(24971,5089),(24972,5090),(24973,5090),(24974,5090),(24975,5090),(24976,5091),(24977,5091),(24978,5091),(24979,5091),(24980,5092),(24981,5092),(24982,5092),(24983,5092),(24984,5093),(24985,5093),(24986,5093),(24987,5093),(24988,5094),(24989,5094),(24990,5094),(24991,5094),(24992,5095),(24993,5095),(24994,5095),(24995,5095),(24996,5096),(24997,5096),(24998,5096),(24999,5096),(25000,5097),(25001,5097),(25002,5097),(25003,5097),(25004,5098),(25005,5098),(25006,5098),(25007,5098),(25008,5099),(25009,5099),(25010,5099),(25011,5099),(25012,5100),(25013,5100),(25014,5100),(25015,5100),(25016,5101),(25017,5101),(25018,5101),(25019,5101),(25020,5102),(25021,5102),(25022,5102),(25023,5102),(25024,5103),(25025,5103),(25026,5103),(25027,5103),(25028,5104),(25029,5104),(25030,5104),(25031,5104),(25032,5105),(25033,5105),(25034,5105),(25035,5105),(25036,5106),(25037,5106),(25038,5106),(25039,5106),(25040,5107),(25041,5107),(25042,5107),(25043,5107),(25044,5108),(25045,5108),(25046,5108),(25047,5108),(25048,5109),(25049,5109),(25050,5109),(25051,5109),(25052,5110),(25053,5110),(25054,5110),(25055,5110),(25056,5111),(25057,5111),(25058,5111),(25059,5111),(25060,5112),(25061,5112),(25062,5112),(25063,5112),(25064,5113),(25065,5113),(25066,5113),(25067,5113),(25068,5114),(25069,5114),(25070,5114),(25071,5114),(25072,5115),(25073,5115),(25074,5115),(25075,5115),(25076,5116),(25077,5116),(25078,5116),(25079,5116),(25080,5117),(25081,5117),(25082,5117),(25083,5117),(25084,5118),(25085,5118),(25086,5118),(25087,5118),(25088,5119),(25089,5119),(25090,5119),(25091,5119),(25092,5120),(25093,5120),(25094,5120),(25095,5120),(25096,5121),(25097,5121),(25098,5121),(25099,5121),(25100,5122),(25101,5122),(25102,5122),(25103,5122),(25104,5123),(25105,5123),(25106,5123),(25107,5123),(25108,5124),(25109,5124),(25110,5124),(25111,5124),(25112,5125),(25113,5125),(25114,5125),(25115,5125),(25116,5126),(25117,5126),(25118,5126),(25119,5126),(25120,5127),(25121,5127),(25122,5127),(25123,5127),(25124,5128),(25125,5128),(25126,5128),(25127,5128),(25128,5129),(25129,5129),(25130,5129),(25131,5129),(25132,5130),(25133,5130),(25134,5130),(25135,5130),(25136,5131),(25137,5131),(25138,5131),(25139,5131),(25140,5132),(25141,5132),(25142,5132),(25143,5132),(25144,5133),(25145,5133),(25146,5133),(25147,5133),(25148,5134),(25149,5134),(25150,5134),(25151,5134),(25152,5135),(25153,5135),(25154,5135),(25155,5135),(25156,5136),(25157,5136),(25158,5136),(25159,5136),(25160,5137),(25161,5137),(25162,5137),(25163,5137),(25164,5138),(25165,5138),(25166,5138),(25167,5138),(25168,5139),(25169,5139),(25170,5139),(25171,5139),(25172,5140),(25173,5140),(25174,5140),(25175,5140),(25176,5141),(25177,5141),(25178,5141),(25179,5141),(25180,5142),(25181,5142),(25182,5142),(25183,5142),(25184,5143),(25185,5143),(25186,5143),(25187,5143),(25188,5144),(25189,5144),(25190,5144),(25191,5144),(25192,5145),(25193,5145),(25194,5145),(25195,5145),(25196,5146),(25197,5146),(25198,5146),(25199,5146),(25200,5147),(25201,5147),(25202,5147),(25203,5147),(25204,5148),(25205,5148),(25206,5148),(25207,5148),(25208,5149),(25209,5149),(25210,5149),(25211,5149),(25212,5150),(25213,5150),(25214,5150),(25215,5150),(25216,5151),(25217,5151),(25218,5151),(25219,5151),(25220,5152),(25221,5152),(25222,5152),(25223,5152),(25224,5153),(25225,5153),(25226,5153),(25227,5153),(25228,5154),(25229,5154),(25230,5154),(25231,5154),(25232,5155),(25233,5155),(25234,5155),(25235,5155),(25236,5156),(25237,5156),(25238,5156),(25239,5156),(25240,5157),(25241,5157),(25242,5157),(25243,5157),(25244,5158),(25245,5158),(25246,5158),(25247,5158),(25248,5159),(25249,5159),(25250,5159),(25251,5159),(25252,5160),(25253,5160),(25254,5160),(25255,5160),(25256,5161),(25257,5161),(25258,5161),(25259,5161),(25260,5162),(25261,5162),(25262,5162),(25263,5162),(25264,5163),(25265,5163),(25266,5163),(25267,5163),(25268,5164),(25269,5164),(25270,5164),(25271,5164),(25272,5165),(25273,5165),(25274,5165),(25275,5165),(25276,5166),(25277,5166),(25278,5166),(25279,5166),(25280,5167),(25281,5167),(25282,5167),(25283,5167),(25284,5168),(25285,5168),(25286,5168),(25287,5168),(25288,5169),(25289,5169),(25290,5169),(25291,5169),(25292,5170),(25293,5170),(25294,5170),(25295,5170),(25296,5171),(25297,5171),(25298,5171),(25299,5171),(25300,5172),(25301,5172),(25302,5172),(25303,5172),(25304,5173),(25305,5173),(25306,5173),(25307,5173),(25308,5174),(25309,5174),(25310,5174),(25311,5174),(25312,5175),(25313,5175),(25314,5175),(25315,5175),(25316,5176),(25317,5176),(25318,5176),(25319,5176),(25320,5177),(25321,5177),(25322,5177),(25323,5177),(25324,5178),(25325,5178),(25326,5178),(25327,5178),(25328,5179),(25329,5179),(25330,5179),(25331,5179),(25332,5180),(25333,5180),(25334,5180),(25335,5180),(25336,5181),(25337,5181),(25338,5181),(25339,5181),(25340,5182),(25341,5182),(25342,5182),(25343,5182),(25344,5183),(25345,5183),(25346,5183),(25347,5183),(25348,5184),(25349,5184),(25350,5184),(25351,5184),(25352,5185),(25353,5185),(25354,5185),(25355,5185),(25356,5186),(25357,5186),(25358,5186),(25359,5186),(25360,5187),(25361,5187),(25362,5187),(25363,5187),(25364,5188),(25365,5188),(25366,5188),(25367,5188),(25368,5189),(25369,5189),(25370,5189),(25371,5189),(25372,5190),(25373,5190),(25374,5190),(25375,5190),(25376,5191),(25377,5191),(25378,5191),(25379,5191),(25380,5192),(25381,5192),(25382,5192),(25383,5192),(25384,5193),(25385,5193),(25386,5193),(25387,5193),(25388,5194),(25389,5194),(25390,5194),(25391,5194),(25392,5195),(25393,5195),(25394,5195),(25395,5195),(25396,5196),(25397,5196),(25398,5196),(25399,5196),(25400,5197),(25401,5197),(25402,5197),(25403,5197),(25404,5198),(25405,5198),(25406,5198),(25407,5198),(25408,5199),(25409,5199),(25410,5199),(25411,5199),(25412,5200),(25413,5200),(25414,5200),(25415,5200),(25416,5201),(25417,5201),(25418,5201),(25419,5201),(25420,5202),(25421,5202),(25422,5202),(25423,5202),(25424,5203),(25425,5203),(25426,5203),(25427,5203),(25428,5204),(25429,5204),(25430,5204),(25431,5204),(25432,5205),(25433,5205),(25434,5205),(25435,5205),(25436,5206),(25437,5206),(25438,5206),(25439,5206),(25440,5207),(25441,5207),(25442,5207),(25443,5207),(25444,5208),(25445,5208),(25446,5208),(25447,5208),(25448,5209),(25449,5209),(25450,5209),(25451,5209),(25452,5210),(25453,5210),(25454,5210),(25455,5210),(25456,5211),(25457,5211),(25458,5211),(25459,5211),(25460,5212),(25461,5212),(25462,5212),(25463,5212),(25464,5213),(25465,5213),(25466,5213),(25467,5213),(25468,5214),(25469,5214),(25470,5214),(25471,5214),(25472,5215),(25473,5215),(25474,5215),(25475,5215),(25476,5216),(25477,5216),(25478,5216),(25479,5216),(25480,5217),(25481,5217),(25482,5217),(25483,5217),(25484,5218),(25485,5218),(25486,5218),(25487,5218),(25488,5219),(25489,5219),(25490,5219),(25491,5219),(25492,5220),(25493,5220),(25494,5220),(25495,5220),(25496,5221),(25497,5221),(25498,5221),(25499,5221),(25500,5222),(25501,5222),(25502,5222),(25503,5222),(25504,5223),(25505,5223),(25506,5223),(25507,5223),(25508,5224),(25509,5224),(25510,5224),(25511,5224),(25512,5225),(25513,5225),(25514,5225),(25515,5225),(25516,5226),(25517,5226),(25518,5226),(25519,5226),(25520,5227),(25521,5227),(25522,5227),(25523,5227),(25524,5228),(25525,5228),(25526,5228),(25527,5228),(25528,5229),(25529,5229),(25530,5229),(25531,5229),(25532,5230),(25533,5230),(25534,5230),(25535,5230),(25536,5231),(25537,5231),(25538,5231),(25539,5231),(25540,5232),(25541,5232),(25542,5232),(25543,5232),(25544,5233),(25545,5233),(25546,5233),(25547,5233),(25548,5234),(25549,5234),(25550,5234),(25551,5234),(25552,5235),(25553,5235),(25554,5235),(25555,5235),(25556,5236),(25557,5236),(25558,5236),(25559,5236),(25560,5237),(25561,5237),(25562,5237),(25563,5237),(25564,5238),(25565,5238),(25566,5238),(25567,5238),(25568,5239),(25569,5239),(25570,5239),(25571,5239),(25572,5240),(25573,5240),(25574,5240),(25575,5240),(25576,5241),(25577,5241),(25578,5241),(25579,5241),(25580,5242),(25581,5242),(25582,5242),(25583,5242),(25584,5243),(25585,5243),(25586,5243),(25587,5243),(25588,5244),(25589,5244),(25590,5244),(25591,5244),(25592,5245),(25593,5245),(25594,5245),(25595,5245),(25596,5246),(25597,5246),(25598,5246),(25599,5246),(25600,5247),(25601,5247),(25602,5247),(25603,5247),(25604,5248),(25605,5248),(25606,5248),(25607,5248),(25608,5249),(25609,5249),(25610,5249),(25611,5249),(25612,5250),(25613,5250),(25614,5250),(25615,5250),(25616,5251),(25617,5251),(25618,5251),(25619,5251),(25620,5252),(25621,5252),(25622,5252),(25623,5252),(25624,5253),(25625,5253),(25626,5253),(25627,5253),(25628,5254),(25629,5254),(25630,5254),(25631,5254),(25632,5255),(25633,5255),(25634,5255),(25635,5255),(25636,5256),(25637,5256),(25638,5256),(25639,5256),(25640,5257),(25641,5257),(25642,5257),(25643,5257),(25644,5258),(25645,5258),(25646,5258),(25647,5258),(25648,5259),(25649,5259),(25650,5259),(25651,5259),(25652,5260),(25653,5260),(25654,5260),(25655,5260),(25656,5261),(25657,5261),(25658,5261),(25659,5261),(25660,5262),(25661,5262),(25662,5262),(25663,5262),(25664,5263),(25665,5263),(25666,5263),(25667,5263),(25668,5264),(25669,5264),(25670,5264),(25671,5264),(25672,5265),(25673,5265),(25674,5265),(25675,5265),(25676,5266),(25677,5266),(25678,5266),(25679,5266),(25680,5267),(25681,5267),(25682,5267),(25683,5267),(25684,5268),(25685,5268),(25686,5268),(25687,5268),(25688,5269),(25689,5269),(25690,5269),(25691,5269),(25692,5270),(25693,5270),(25694,5270),(25695,5270),(25696,4491),(25697,4492),(25698,4493),(25699,4494),(25700,4495),(25701,4496),(25702,4497),(25703,4498),(25704,4499),(25705,4500),(25706,4501),(25707,4502),(25708,4503),(25709,4504),(25710,4505),(25711,4506),(25712,4507),(25713,4508),(25714,4509),(25715,4510),(25716,4511),(25717,4512),(25718,4513),(25719,4514),(25720,4515),(25721,4516),(25722,4517),(25723,4518),(25724,4519),(25725,4520),(25726,4521),(25727,4522),(25728,4523),(25729,4524),(25730,4525),(25731,4526),(25732,4527),(25733,4528),(25734,4529),(25735,4530),(25736,4531),(25737,4532),(25738,4533),(25739,4534),(25740,4535),(25741,4536),(25742,4537),(25743,4538),(25744,4539),(25745,4540),(25746,4541),(25747,4542),(25748,4543),(25749,4544),(25750,4545),(25751,4546),(25752,4547),(25753,4548),(25754,4549),(25755,4550),(25756,4551),(25757,4552),(25758,4553),(25759,4554),(25760,4555),(25761,4556),(25762,4557),(25763,4558),(25764,4559),(25765,4560),(25766,4561),(25767,4562),(25768,4563),(25769,4564),(25770,4565),(25771,4566),(25772,4567),(25773,4568),(25774,4569),(25775,4570),(25776,4571),(25777,4572),(25778,4573),(25779,4574),(25780,4575),(25781,4576),(25782,4577),(25783,4578),(25784,4579),(25785,4580),(25786,4581),(25787,4582),(25788,4583),(25789,4584),(25790,4585),(25791,4586),(25792,4587),(25793,4588),(25794,4589),(25795,4590),(25796,4591),(25797,4592),(25798,4593),(25799,4594),(25800,4595),(25801,4596),(25802,4597),(25803,4598),(25804,4599),(25805,4600),(25806,4601),(25807,4602),(25808,4603),(25809,4604),(25810,4605),(25811,4606),(25812,4607),(25813,4608),(25814,4609),(25815,4610),(25816,4611),(25817,4612),(25818,4613),(25819,4614),(25820,4615),(25821,4616),(25822,4617),(25823,4618),(25824,4619),(25825,4620),(25826,4621),(25827,4622),(25828,4623),(25829,4624),(25830,4625),(25831,4626),(25832,4627),(25833,4628),(25834,4629),(25835,4630),(25836,4631),(25837,4632),(25838,4633),(25839,4634),(25840,4635),(25841,4636),(25842,4637),(25843,4638),(25844,4639),(25845,4640),(25846,4641),(25847,4642),(25848,4643),(25849,4644),(25850,4645),(25851,4646),(25852,4647),(25853,4648),(25854,4649),(25855,4650),(25856,4651),(25857,4652),(25858,4653),(25859,4654),(25860,4655),(25861,4656),(25862,4657),(25863,4658),(25864,4659),(25865,4660),(25866,4661),(25867,4662),(25868,4663),(25869,4664),(25870,4665),(25871,4666),(25872,4667),(25873,4668),(25874,4669),(25875,4670),(25876,4671),(25877,4672),(25878,4673),(25879,4674),(25880,4675),(25881,4676),(25882,4677),(25883,4678),(25884,4679),(25885,4680),(25886,4681),(25887,4682),(25888,4683),(25889,4684),(25890,4685),(25891,4686),(25892,4687),(25893,4688),(25894,4689),(25895,4690),(25896,4691),(25897,4692),(25898,4693),(25899,4694),(25900,4695),(25901,4696),(25902,4697),(25903,4698),(25904,4699),(25905,4700),(25906,4701),(25907,4702),(25908,4703),(25909,4704),(25910,4705),(25911,4706),(25912,4707),(25913,4708),(25914,4709),(25915,4710),(25916,4711),(25917,4712),(25918,4713),(25919,4714),(25920,4715),(25921,4716),(25922,4717),(25923,4718),(25924,4719),(25925,4720),(25926,4721),(25927,4722),(25928,4723),(25929,4724),(25930,4725),(25931,4726),(25932,4727),(25933,4728),(25934,4729),(25935,4730),(25936,4731),(25937,4732),(25938,4733),(25939,4734),(25940,4735),(25941,4736),(25942,4737),(25943,4738),(25944,4739),(25945,4740),(25946,4741),(25947,4742),(25948,4743),(25949,4744),(25950,4745),(25951,4746),(25952,4747),(25953,4748),(25954,4749),(25955,4750),(25956,4751),(25957,4752),(25958,4753),(25959,4754),(25960,4755),(25961,4756),(25962,4757),(25963,4758),(25964,4759),(25965,4760),(25966,4761),(25967,4762),(25968,4763),(25969,4764),(25970,4765),(25971,4766),(25972,4767),(25973,4768),(25974,4769),(25975,4770),(25976,4771),(25977,4772),(25978,4773),(25979,4774),(25980,4775),(25981,4776),(25982,4777),(25983,4778),(25984,4779),(25985,4780),(25986,4781),(25987,4782),(25988,4783),(25989,4784),(25990,4785),(25991,4786),(25992,4787),(25993,4788),(25994,4789),(25995,4790),(25996,4791),(25997,4792),(25998,4793),(25999,4794),(26000,4795),(26001,4796),(26002,4797),(26003,4798),(26004,4799),(26005,4800),(26006,4801),(26007,4802),(26008,4803),(26009,4804),(26010,4805),(26011,4806),(26012,4807),(26013,4808),(26014,4809),(26015,4810),(26016,4811),(26017,4812),(26018,4813),(26019,4814),(26020,4815),(26021,4816),(26022,4817),(26023,4818),(26024,4819),(26025,4820),(26026,4821),(26027,4822),(26028,4823),(26029,4824),(26030,4825),(26031,4826),(26032,4827),(26033,4828),(26034,4829),(26035,4830),(26036,4831),(26037,4832),(26038,4833),(26039,4834),(26040,4835),(26041,4836),(26042,4837),(26043,4838),(26044,4839),(26045,4840),(26046,4841),(26047,4842),(26048,4843),(26049,4844),(26050,4845),(26051,4846),(26052,4847),(26053,4848),(26054,4849),(26055,4850),(26056,4851),(26057,4852),(26058,4853),(26059,4854),(26060,4855),(26061,4856),(26062,4857),(26063,4858),(26064,4859),(26065,4860),(26066,4861),(26067,4862),(26068,4863),(26069,4864),(26070,4865),(26071,4866),(26072,4867),(26073,4868),(26074,4869),(26075,4870),(26076,4871),(26077,4872),(26078,4873),(26079,4874),(26080,4875),(26081,4876),(26082,4877),(26083,4878),(26084,4879),(26085,4880),(26086,4881),(26087,4882),(26088,4883),(26089,4884),(26090,4885),(26091,4886),(26092,4887),(26093,4888),(26094,4889),(26095,4890),(26096,4891),(26097,4892),(26098,4893),(26099,4894),(26100,4895),(26101,4896),(26102,4897),(26103,4898),(26104,4899),(26105,4900),(26106,4901),(26107,4902),(26108,4903),(26109,4904),(26110,4905),(26111,4906),(26112,4907),(26113,4908),(26114,4909),(26115,4910),(26116,4911),(26117,4912),(26118,4913),(26119,4914),(26120,4915),(26121,4916),(26122,4917),(26123,4918),(26124,4919),(26125,4920),(26126,4921),(26127,4922),(26128,4923),(26129,4924),(26130,4925),(26131,4926),(26132,4927),(26133,4928),(26134,4929),(26135,4930),(26136,4931),(26137,4932),(26138,4933),(26139,4934),(26140,4935),(26141,4936),(26142,4937),(26143,4938),(26144,4939),(26145,4940),(26146,4941),(26147,4942),(26148,4943),(26149,4944),(26150,4945),(26151,4946),(26152,4947),(26153,4948),(26154,4949),(26155,4950),(26156,4951),(26157,4952),(26158,4953),(26159,4954),(26160,4955),(26161,4956),(26162,4957),(26163,4958),(26164,4959),(26165,4960),(26166,4961),(26167,4962),(26168,4963),(26169,4964),(26170,4965),(26171,4966),(26172,4967),(26173,4968),(26174,4969),(26175,4970),(26176,4971),(26177,4972),(26178,4973),(26179,4974),(26180,4975),(26181,4976),(26182,4977),(26183,4978),(26184,4979),(26185,4980),(26186,4981),(26187,4982),(26188,4983),(26189,4984),(26190,4985),(26191,4986),(26192,4987),(26193,4988),(26194,4989),(26195,4990),(26196,4991),(26197,4992),(26198,4993),(26199,4994),(26200,4995),(26201,4996),(26202,4997),(26203,4998),(26204,4999),(26205,5000),(26206,5001),(26207,5002),(26208,5003),(26209,5004),(26210,5005),(26211,5006),(26212,5007),(26213,5008),(26214,5009),(26215,5010),(26216,5011),(26217,5012),(26218,5013),(26219,5014),(26220,5015),(26221,5016),(26222,5017),(26223,5018),(26224,5019),(26225,5020),(26226,5021),(26227,5022),(26228,5023),(26229,5024),(26230,5025),(26231,5026),(26232,5027),(26233,5028),(26234,5029),(26235,5030),(26236,5031),(26237,5032),(26238,5033),(26239,5034),(26240,5035),(26241,5036),(26242,5037),(26243,5038),(26244,5039),(26245,5040),(26246,5041),(26247,5042),(26248,5043),(26249,5044),(26250,5045),(26251,5046),(26252,5047),(26253,5048),(26254,5049),(26255,5050),(26256,5051),(26257,5052),(26258,5053),(26259,5054),(26260,5055),(26261,5056),(26262,5057),(26263,5058),(26264,5059),(26265,5060),(26266,5061),(26267,5062),(26268,5063),(26269,5064),(26270,5065),(26271,5066),(26272,5067),(26273,5068),(26274,5069),(26275,5070),(26276,5071),(26277,5072),(26278,5073),(26279,5074),(26280,5075),(26281,5076),(26282,5077),(26283,5078),(26284,5079),(26285,5080),(26286,5081),(26287,5082),(26288,5083),(26289,5084),(26290,5085),(26291,5086),(26292,5087),(26293,5088),(26294,5089),(26295,5090),(26296,5091),(26297,5092),(26298,5093),(26299,5094),(26300,5095),(26301,5096),(26302,5097),(26303,5098),(26304,5099),(26305,5100),(26306,5101),(26307,5102),(26308,5103),(26309,5104),(26310,5105),(26311,5106),(26312,5107),(26313,5108),(26314,5109),(26315,5110),(26316,5111),(26317,5112),(26318,5113),(26319,5114),(26320,5115),(26321,5116),(26322,5117),(26323,5118),(26324,5119),(26325,5120),(26326,5121),(26327,5122),(26328,5123),(26329,5124),(26330,5125),(26331,5126),(26332,5127),(26333,5128),(26334,5129),(26335,5130),(26336,5131),(26337,5132),(26338,5133),(26339,5134),(26340,5135),(26341,5136),(26342,5137),(26343,5138),(26344,5139),(26345,5140),(26346,5141),(26347,5142),(26348,5143),(26349,5144),(26350,5145),(26351,5146),(26352,5147),(26353,5148),(26354,5149),(26355,5150),(26356,5151),(26357,5152),(26358,5153),(26359,5154),(26360,5155),(26361,5156),(26362,5157),(26363,5158),(26364,5159),(26365,5160),(26366,5161),(26367,5162),(26368,5163),(26369,5164),(26370,5165),(26371,5166),(26372,5167),(26373,5168),(26374,5169),(26375,5170),(26376,5171),(26377,5172),(26378,5173),(26379,5174),(26380,5175),(26381,5176),(26382,5177),(26383,5178),(26384,5179),(26385,5180),(26386,5181),(26387,5182),(26388,5183),(26389,5184),(26390,5185),(26391,5186),(26392,5187),(26393,5188),(26394,5189),(26395,5190),(26396,5191),(26397,5192),(26398,5193),(26399,5194),(26400,5195),(26401,5196),(26402,5197),(26403,5198),(26404,5199),(26405,5200),(26406,5201),(26407,5202),(26408,5203),(26409,5204),(26410,5205),(26411,5206),(26412,5207),(26413,5208),(26414,5209),(26415,5210),(26416,5211),(26417,5212),(26418,5213),(26419,5214),(26420,5215),(26421,5216),(26422,5217),(26423,5218),(26424,5219),(26425,5220),(26426,5221),(26427,5222),(26428,5223),(26429,5224),(26430,5225),(26431,5226),(26432,5227),(26433,5228),(26434,5229),(26435,5230),(26436,5231),(26437,5232),(26438,5233),(26439,5234),(26440,5235),(26441,5236),(26442,5237),(26443,5238),(26444,5239),(26445,5240),(26446,5241),(26447,5242),(26448,5243),(26449,5244),(26450,5245),(26451,5246),(26452,5247),(26453,5248),(26454,5249),(26455,5250),(26456,5251),(26457,5252),(26458,5253),(26459,5254),(26460,5255),(26461,5256),(26462,5257),(26463,5258),(26464,5259),(26465,5260),(26466,5261),(26467,5262),(26468,5263),(26469,5264),(26470,5265),(26471,5266),(26472,5267),(26473,5268),(26474,5269),(26475,5270),(26476,5271),(26477,5271),(26478,5271),(26479,5271),(26480,5272),(26481,5272),(26482,5272),(26483,5272),(26484,5273),(26485,5273),(26486,5273),(26487,5273),(26488,5274),(26489,5274),(26490,5274),(26491,5274),(26492,5275),(26493,5275),(26494,5275),(26495,5275),(26496,5276),(26497,5276),(26498,5276),(26499,5276),(26500,5277),(26501,5277),(26502,5277),(26503,5277),(26504,5278),(26505,5278),(26506,5278),(26507,5278),(26508,5279),(26509,5279),(26510,5279),(26511,5279),(26512,5280),(26513,5280),(26514,5280),(26515,5280),(26516,5281),(26517,5281),(26518,5281),(26519,5281),(26520,5282),(26521,5282),(26522,5282),(26523,5282),(26524,5283),(26525,5283),(26526,5283),(26527,5283),(26528,5284),(26529,5284),(26530,5284),(26531,5284),(26532,5285),(26533,5285),(26534,5285),(26535,5285),(26536,5286),(26537,5286),(26538,5286),(26539,5286),(26540,5287),(26541,5287),(26542,5287),(26543,5287),(26544,5288),(26545,5288),(26546,5288),(26547,5288),(26548,5289),(26549,5289),(26550,5289),(26551,5289),(26552,5290),(26553,5290),(26554,5290),(26555,5290),(26556,5291),(26557,5291),(26558,5291),(26559,5291),(26560,5292),(26561,5292),(26562,5292),(26563,5292),(26564,5293),(26565,5293),(26566,5293),(26567,5293),(26568,5294),(26569,5294),(26570,5294),(26571,5294),(26572,5295),(26573,5295),(26574,5295),(26575,5295),(26576,5296),(26577,5296),(26578,5296),(26579,5296),(26580,5297),(26581,5297),(26582,5297),(26583,5297),(26584,5298),(26585,5298),(26586,5298),(26587,5298),(26588,5299),(26589,5299),(26590,5299),(26591,5299),(26592,5300),(26593,5300),(26594,5300),(26595,5300),(26596,5301),(26597,5301),(26598,5301),(26599,5301),(26600,5302),(26601,5302),(26602,5302),(26603,5302),(26604,5303),(26605,5303),(26606,5303),(26607,5303),(26608,5304),(26609,5304),(26610,5304),(26611,5304),(26612,5305),(26613,5305),(26614,5305),(26615,5305),(26616,5306),(26617,5306),(26618,5306),(26619,5306),(26620,5307),(26621,5307),(26622,5307),(26623,5307),(26624,5308),(26625,5308),(26626,5308),(26627,5308),(26628,5309),(26629,5309),(26630,5309),(26631,5309),(26632,5310),(26633,5310),(26634,5310),(26635,5310),(26636,5311),(26637,5311),(26638,5311),(26639,5311),(26640,5312),(26641,5312),(26642,5312),(26643,5312),(26644,5313),(26645,5313),(26646,5313),(26647,5313),(26648,5314),(26649,5314),(26650,5314),(26651,5314),(26652,5315),(26653,5315),(26654,5315),(26655,5315),(26656,5316),(26657,5316),(26658,5316),(26659,5316),(26660,5317),(26661,5317),(26662,5317),(26663,5317),(26664,5318),(26665,5318),(26666,5318),(26667,5318),(26668,5319),(26669,5319),(26670,5319),(26671,5319),(26672,5320),(26673,5320),(26674,5320),(26675,5320),(26676,5321),(26677,5321),(26678,5321),(26679,5321),(26680,5322),(26681,5322),(26682,5322),(26683,5322),(26684,5323),(26685,5323),(26686,5323),(26687,5323),(26688,5324),(26689,5324),(26690,5324),(26691,5324),(26692,5325),(26693,5325),(26694,5325),(26695,5325),(26696,5326),(26697,5326),(26698,5326),(26699,5326),(26700,5327),(26701,5327),(26702,5327),(26703,5327),(26704,5328),(26705,5328),(26706,5328),(26707,5328),(26708,5329),(26709,5329),(26710,5329),(26711,5329),(26712,5330),(26713,5330),(26714,5330),(26715,5330),(26716,5331),(26717,5331),(26718,5331),(26719,5331),(26720,5332),(26721,5332),(26722,5332),(26723,5332),(26724,5333),(26725,5333),(26726,5333),(26727,5333),(26728,5334),(26729,5334),(26730,5334),(26731,5334),(26732,5335),(26733,5335),(26734,5335),(26735,5335),(26736,5336),(26737,5336),(26738,5336),(26739,5336),(26740,5337),(26741,5337),(26742,5337),(26743,5337),(26744,5338),(26745,5338),(26746,5338),(26747,5338),(26748,5339),(26749,5339),(26750,5339),(26751,5339),(26752,5340),(26753,5340),(26754,5340),(26755,5340),(26756,5341),(26757,5341),(26758,5341),(26759,5341),(26760,5342),(26761,5342),(26762,5342),(26763,5342),(26764,5343),(26765,5343),(26766,5343),(26767,5343),(26768,5344),(26769,5344),(26770,5344),(26771,5344),(26772,5345),(26773,5345),(26774,5345),(26775,5345),(26776,5346),(26777,5346),(26778,5346),(26779,5346),(26780,5347),(26781,5347),(26782,5347),(26783,5347),(26784,5348),(26785,5348),(26786,5348),(26787,5348),(26788,5349),(26789,5349),(26790,5349),(26791,5349),(26792,5350),(26793,5350),(26794,5350),(26795,5350),(26796,5351),(26797,5351),(26798,5351),(26799,5351),(26800,5352),(26801,5352),(26802,5352),(26803,5352),(26804,5353),(26805,5353),(26806,5353),(26807,5353),(26808,5354),(26809,5354),(26810,5354),(26811,5354),(26812,5355),(26813,5355),(26814,5355),(26815,5355),(26816,5356),(26817,5356),(26818,5356),(26819,5356),(26820,5357),(26821,5357),(26822,5357),(26823,5357),(26824,5358),(26825,5358),(26826,5358),(26827,5358),(26828,5359),(26829,5359),(26830,5359),(26831,5359),(26832,5360),(26833,5360),(26834,5360),(26835,5360),(26836,5361),(26837,5361),(26838,5361),(26839,5361),(26840,5362),(26841,5362),(26842,5362),(26843,5362),(26844,5363),(26845,5363),(26846,5363),(26847,5363),(26848,5364),(26849,5364),(26850,5364),(26851,5364),(26852,5365),(26853,5365),(26854,5365),(26855,5365),(26856,5366),(26857,5366),(26858,5366),(26859,5366),(26860,5367),(26861,5367),(26862,5367),(26863,5367),(26864,5368),(26865,5368),(26866,5368),(26867,5368),(26868,5369),(26869,5369),(26870,5369),(26871,5369),(26872,5370),(26873,5370),(26874,5370),(26875,5370),(26876,5371),(26877,5371),(26878,5371),(26879,5371),(26880,5372),(26881,5372),(26882,5372),(26883,5372),(26884,5373),(26885,5373),(26886,5373),(26887,5373),(26888,5374),(26889,5374),(26890,5374),(26891,5374),(26892,5375),(26893,5375),(26894,5375),(26895,5375),(26896,5376),(26897,5376),(26898,5376),(26899,5376),(26900,5377),(26901,5377),(26902,5377),(26903,5377),(26904,5378),(26905,5378),(26906,5378),(26907,5378),(26908,5379),(26909,5379),(26910,5379),(26911,5379),(26912,5380),(26913,5380),(26914,5380),(26915,5380),(26916,5381),(26917,5381),(26918,5381),(26919,5381),(26920,5382),(26921,5382),(26922,5382),(26923,5382),(26924,5383),(26925,5383),(26926,5383),(26927,5383),(26928,5384),(26929,5384),(26930,5384),(26931,5384),(26932,5385),(26933,5385),(26934,5385),(26935,5385),(26936,5386),(26937,5386),(26938,5386),(26939,5386),(26940,5387),(26941,5387),(26942,5387),(26943,5387),(26944,5388),(26945,5388),(26946,5388),(26947,5388),(26948,5389),(26949,5389),(26950,5389),(26951,5389),(26952,5390),(26953,5390),(26954,5390),(26955,5390),(26956,5391),(26957,5391),(26958,5391),(26959,5391),(26960,5392),(26961,5392),(26962,5392),(26963,5392),(26964,5393),(26965,5393),(26966,5393),(26967,5393),(26968,5394),(26969,5394),(26970,5394),(26971,5394),(26972,5395),(26973,5395),(26974,5395),(26975,5395),(26976,5396),(26977,5396),(26978,5396),(26979,5396),(26980,5397),(26981,5397),(26982,5397),(26983,5397),(26984,5398),(26985,5398),(26986,5398),(26987,5398),(26988,5399),(26989,5399),(26990,5399),(26991,5399),(26992,5400),(26993,5400),(26994,5400),(26995,5400),(26996,5401),(26997,5401),(26998,5401),(26999,5401),(27000,5402),(27001,5402),(27002,5402),(27003,5402),(27004,5403),(27005,5403),(27006,5403),(27007,5403),(27008,5404),(27009,5404),(27010,5404),(27011,5404),(27012,5405),(27013,5405),(27014,5405),(27015,5405),(27016,5406),(27017,5406),(27018,5406),(27019,5406),(27020,5407),(27021,5407),(27022,5407),(27023,5407),(27024,5408),(27025,5408),(27026,5408),(27027,5408),(27028,5409),(27029,5409),(27030,5409),(27031,5409),(27032,5410),(27033,5410),(27034,5410),(27035,5410),(27036,5411),(27037,5411),(27038,5411),(27039,5411),(27040,5412),(27041,5412),(27042,5412),(27043,5412),(27044,5413),(27045,5413),(27046,5413),(27047,5413),(27048,5414),(27049,5414),(27050,5414),(27051,5414),(27052,5415),(27053,5415),(27054,5415),(27055,5415),(27056,5416),(27057,5416),(27058,5416),(27059,5416),(27060,5417),(27061,5417),(27062,5417),(27063,5417),(27064,5418),(27065,5418),(27066,5418),(27067,5418),(27068,5419),(27069,5419),(27070,5419),(27071,5419),(27072,5420),(27073,5420),(27074,5420),(27075,5420),(27076,5421),(27077,5421),(27078,5421),(27079,5421),(27080,5422),(27081,5422),(27082,5422),(27083,5422),(27084,5423),(27085,5423),(27086,5423),(27087,5423),(27088,5424),(27089,5424),(27090,5424),(27091,5424),(27092,5425),(27093,5425),(27094,5425),(27095,5425),(27096,5426),(27097,5426),(27098,5426),(27099,5426),(27100,5427),(27101,5427),(27102,5427),(27103,5427),(27104,5428),(27105,5428),(27106,5428),(27107,5428),(27108,5429),(27109,5429),(27110,5429),(27111,5429),(27112,5430),(27113,5430),(27114,5430),(27115,5430),(27116,5431),(27117,5431),(27118,5431),(27119,5431),(27120,5432),(27121,5432),(27122,5432),(27123,5432),(27124,5433),(27125,5433),(27126,5433),(27127,5433),(27128,5434),(27129,5434),(27130,5434),(27131,5434),(27132,5435),(27133,5435),(27134,5435),(27135,5435),(27136,5436),(27137,5436),(27138,5436),(27139,5436),(27140,5437),(27141,5437),(27142,5437),(27143,5437),(27144,5438),(27145,5438),(27146,5438),(27147,5438),(27148,5439),(27149,5439),(27150,5439),(27151,5439),(27152,5440),(27153,5440),(27154,5440),(27155,5440),(27156,5441),(27157,5441),(27158,5441),(27159,5441),(27160,5442),(27161,5442),(27162,5442),(27163,5442),(27164,5443),(27165,5443),(27166,5443),(27167,5443),(27168,5444),(27169,5444),(27170,5444),(27171,5444),(27172,5445),(27173,5445),(27174,5445),(27175,5445),(27176,5446),(27177,5446),(27178,5446),(27179,5446),(27180,5447),(27181,5447),(27182,5447),(27183,5447),(27184,5448),(27185,5448),(27186,5448),(27187,5448),(27188,5449),(27189,5449),(27190,5449),(27191,5449),(27192,5450),(27193,5450),(27194,5450),(27195,5450),(27196,5451),(27197,5451),(27198,5451),(27199,5451),(27200,5452),(27201,5452),(27202,5452),(27203,5452),(27204,5453),(27205,5453),(27206,5453),(27207,5453),(27208,5454),(27209,5454),(27210,5454),(27211,5454),(27212,5455),(27213,5455),(27214,5455),(27215,5455),(27216,5456),(27217,5456),(27218,5456),(27219,5456),(27220,5457),(27221,5457),(27222,5457),(27223,5457),(27224,5458),(27225,5458),(27226,5458),(27227,5458),(27228,5459),(27229,5459),(27230,5459),(27231,5459),(27232,5460),(27233,5460),(27234,5460),(27235,5460),(27236,5461),(27237,5461),(27238,5461),(27239,5461),(27240,5462),(27241,5462),(27242,5462),(27243,5462),(27244,5463),(27245,5463),(27246,5463),(27247,5463),(27248,5464),(27249,5464),(27250,5464),(27251,5464),(27252,5465),(27253,5465),(27254,5465),(27255,5465),(27256,5466),(27257,5466),(27258,5466),(27259,5466),(27260,5467),(27261,5467),(27262,5467),(27263,5467),(27264,5468),(27265,5468),(27266,5468),(27267,5468),(27268,5469),(27269,5469),(27270,5469),(27271,5469),(27272,5470),(27273,5470),(27274,5470),(27275,5470),(27276,5471),(27277,5471),(27278,5471),(27279,5471),(27280,5472),(27281,5472),(27282,5472),(27283,5472),(27284,5473),(27285,5473),(27286,5473),(27287,5473),(27288,5474),(27289,5474),(27290,5474),(27291,5474),(27292,5475),(27293,5475),(27294,5475),(27295,5475),(27296,5476),(27297,5476),(27298,5476),(27299,5476),(27300,5477),(27301,5477),(27302,5477),(27303,5477),(27304,5478),(27305,5478),(27306,5478),(27307,5478),(27308,5479),(27309,5479),(27310,5479),(27311,5479),(27312,5480),(27313,5480),(27314,5480),(27315,5480),(27316,5481),(27317,5481),(27318,5481),(27319,5481),(27320,5482),(27321,5482),(27322,5482),(27323,5482),(27324,5483),(27325,5483),(27326,5483),(27327,5483),(27328,5484),(27329,5484),(27330,5484),(27331,5484),(27332,5485),(27333,5485),(27334,5485),(27335,5485),(27336,5486),(27337,5486),(27338,5486),(27339,5486),(27340,5487),(27341,5487),(27342,5487),(27343,5487),(27344,5488),(27345,5488),(27346,5488),(27347,5488),(27348,5489),(27349,5489),(27350,5489),(27351,5489),(27352,5490),(27353,5490),(27354,5490),(27355,5490),(27356,5491),(27357,5491),(27358,5491),(27359,5491),(27360,5492),(27361,5492),(27362,5492),(27363,5492),(27364,5493),(27365,5493),(27366,5493),(27367,5493),(27368,5494),(27369,5494),(27370,5494),(27371,5494),(27372,5495),(27373,5495),(27374,5495),(27375,5495),(27376,5496),(27377,5496),(27378,5496),(27379,5496),(27380,5497),(27381,5497),(27382,5497),(27383,5497),(27384,5498),(27385,5498),(27386,5498),(27387,5498),(27388,5499),(27389,5499),(27390,5499),(27391,5499),(27392,5500),(27393,5500),(27394,5500),(27395,5500),(27396,5501),(27397,5501),(27398,5501),(27399,5501),(27400,5502),(27401,5502),(27402,5502),(27403,5502),(27404,5503),(27405,5503),(27406,5503),(27407,5503),(27408,5504),(27409,5504),(27410,5504),(27411,5504),(27412,5505),(27413,5505),(27414,5505),(27415,5505),(27416,5506),(27417,5506),(27418,5506),(27419,5506),(27420,5507),(27421,5507),(27422,5507),(27423,5507),(27424,5508),(27425,5508),(27426,5508),(27427,5508),(27428,5509),(27429,5509),(27430,5509),(27431,5509),(27432,5510),(27433,5510),(27434,5510),(27435,5510),(27436,5511),(27437,5511),(27438,5511),(27439,5511),(27440,5512),(27441,5512),(27442,5512),(27443,5512),(27444,5513),(27445,5513),(27446,5513),(27447,5513),(27448,5514),(27449,5514),(27450,5514),(27451,5514),(27452,5515),(27453,5515),(27454,5515),(27455,5515),(27456,5516),(27457,5516),(27458,5516),(27459,5516),(27460,5517),(27461,5517),(27462,5517),(27463,5517),(27464,5518),(27465,5518),(27466,5518),(27467,5518),(27468,5519),(27469,5519),(27470,5519),(27471,5519),(27472,5520),(27473,5520),(27474,5520),(27475,5520),(27476,5521),(27477,5521),(27478,5521),(27479,5521),(27480,5522),(27481,5522),(27482,5522),(27483,5522),(27484,5523),(27485,5523),(27486,5523),(27487,5523),(27488,5524),(27489,5524),(27490,5524),(27491,5524),(27492,5525),(27493,5525),(27494,5525),(27495,5525),(27496,5526),(27497,5526),(27498,5526),(27499,5526),(27500,5527),(27501,5527),(27502,5527),(27503,5527),(27504,5528),(27505,5528),(27506,5528),(27507,5528),(27508,5529),(27509,5529),(27510,5529),(27511,5529),(27512,5530),(27513,5530),(27514,5530),(27515,5530),(27516,5531),(27517,5531),(27518,5531),(27519,5531),(27520,5532),(27521,5532),(27522,5532),(27523,5532),(27524,5533),(27525,5533),(27526,5533),(27527,5533),(27528,5534),(27529,5534),(27530,5534),(27531,5534),(27532,5535),(27533,5535),(27534,5535),(27535,5535),(27536,5536),(27537,5536),(27538,5536),(27539,5536),(27540,5537),(27541,5537),(27542,5537),(27543,5537),(27544,5538),(27545,5538),(27546,5538),(27547,5538),(27548,5539),(27549,5539),(27550,5539),(27551,5539),(27552,5540),(27553,5540),(27554,5540),(27555,5540),(27556,5541),(27557,5541),(27558,5541),(27559,5541),(27560,5542),(27561,5542),(27562,5542),(27563,5542),(27564,5543),(27565,5543),(27566,5543),(27567,5543),(27568,5544),(27569,5544),(27570,5544),(27571,5544),(27572,5545),(27573,5545),(27574,5545),(27575,5545),(27576,5546),(27577,5546),(27578,5546),(27579,5546),(27580,5547),(27581,5547),(27582,5547),(27583,5547),(27584,5548),(27585,5548),(27586,5548),(27587,5548),(27588,5549),(27589,5549),(27590,5549),(27591,5549),(27592,5550),(27593,5550),(27594,5550),(27595,5550),(27596,5551),(27597,5551),(27598,5551),(27599,5551),(27600,5552),(27601,5552),(27602,5552),(27603,5552),(27604,5553),(27605,5553),(27606,5553),(27607,5553),(27608,5554),(27609,5554),(27610,5554),(27611,5554),(27612,5555),(27613,5555),(27614,5555),(27615,5555),(27616,5556),(27617,5556),(27618,5556),(27619,5556),(27620,5557),(27621,5557),(27622,5557),(27623,5557),(27624,5558),(27625,5558),(27626,5558),(27627,5558),(27628,5559),(27629,5559),(27630,5559),(27631,5559),(27632,5560),(27633,5560),(27634,5560),(27635,5560),(27636,5561),(27637,5561),(27638,5561),(27639,5561),(27640,5562),(27641,5562),(27642,5562),(27643,5562),(27644,5563),(27645,5563),(27646,5563),(27647,5563),(27648,5564),(27649,5564),(27650,5564),(27651,5564),(27652,5565),(27653,5565),(27654,5565),(27655,5565),(27656,5566),(27657,5566),(27658,5566),(27659,5566),(27660,5567),(27661,5567),(27662,5567),(27663,5567),(27664,5568),(27665,5568),(27666,5568),(27667,5568),(27668,5569),(27669,5569),(27670,5569),(27671,5569),(27672,5570),(27673,5570),(27674,5570),(27675,5570),(27676,5571),(27677,5571),(27678,5571),(27679,5571),(27680,5572),(27681,5572),(27682,5572),(27683,5572),(27684,5573),(27685,5573),(27686,5573),(27687,5573),(27688,5574),(27689,5574),(27690,5574),(27691,5574),(27692,5575),(27693,5575),(27694,5575),(27695,5575),(27696,5576),(27697,5576),(27698,5576),(27699,5576),(27700,5577),(27701,5577),(27702,5577),(27703,5577),(27704,5578),(27705,5578),(27706,5578),(27707,5578),(27708,5579),(27709,5579),(27710,5579),(27711,5579),(27712,5580),(27713,5580),(27714,5580),(27715,5580),(27716,5581),(27717,5581),(27718,5581),(27719,5581),(27720,5582),(27721,5582),(27722,5582),(27723,5582),(27724,5583),(27725,5583),(27726,5583),(27727,5583),(27728,5584),(27729,5584),(27730,5584),(27731,5584),(27732,5585),(27733,5585),(27734,5585),(27735,5585),(27736,5586),(27737,5586),(27738,5586),(27739,5586),(27740,5587),(27741,5587),(27742,5587),(27743,5587),(27744,5588),(27745,5588),(27746,5588),(27747,5588),(27748,5589),(27749,5589),(27750,5589),(27751,5589),(27752,5590),(27753,5590),(27754,5590),(27755,5590),(27756,5591),(27757,5591),(27758,5591),(27759,5591),(27760,5592),(27761,5592),(27762,5592),(27763,5592),(27764,5593),(27765,5593),(27766,5593),(27767,5593),(27768,5594),(27769,5594),(27770,5594),(27771,5594),(27772,5595),(27773,5595),(27774,5595),(27775,5595),(27776,5596),(27777,5596),(27778,5596),(27779,5596),(27780,5597),(27781,5597),(27782,5597),(27783,5597),(27784,5598),(27785,5598),(27786,5598),(27787,5598),(27788,5599),(27789,5599),(27790,5599),(27791,5599),(27792,5600),(27793,5600),(27794,5600),(27795,5600),(27796,5601),(27797,5601),(27798,5601),(27799,5601),(27800,5602),(27801,5602),(27802,5602),(27803,5602),(27804,5603),(27805,5603),(27806,5603),(27807,5603),(27808,5604),(27809,5604),(27810,5604),(27811,5604),(27812,5605),(27813,5605),(27814,5605),(27815,5605),(27816,5606),(27817,5606),(27818,5606),(27819,5606),(27820,5607),(27821,5607),(27822,5607),(27823,5607),(27824,5608),(27825,5608),(27826,5608),(27827,5608),(27828,5609),(27829,5609),(27830,5609),(27831,5609),(27832,5610),(27833,5610),(27834,5610),(27835,5610),(27836,5611),(27837,5611),(27838,5611),(27839,5611),(27840,5612),(27841,5612),(27842,5612),(27843,5612),(27844,5613),(27845,5613),(27846,5613),(27847,5613),(27848,5614),(27849,5614),(27850,5614),(27851,5614),(27852,5615),(27853,5615),(27854,5615),(27855,5615),(27856,5616),(27857,5616),(27858,5616),(27859,5616),(27860,5617),(27861,5617),(27862,5617),(27863,5617),(27864,5618),(27865,5618),(27866,5618),(27867,5618),(27868,5619),(27869,5619),(27870,5619),(27871,5619),(27872,5620),(27873,5620),(27874,5620),(27875,5620),(27876,5621),(27877,5621),(27878,5621),(27879,5621),(27880,5622),(27881,5622),(27882,5622),(27883,5622),(27884,5623),(27885,5623),(27886,5623),(27887,5623),(27888,5624),(27889,5624),(27890,5624),(27891,5624),(27892,5625),(27893,5625),(27894,5625),(27895,5625),(27896,5626),(27897,5626),(27898,5626),(27899,5626),(27900,5627),(27901,5627),(27902,5627),(27903,5627),(27904,5628),(27905,5628),(27906,5628),(27907,5628),(27908,5629),(27909,5629),(27910,5629),(27911,5629),(27912,5630),(27913,5630),(27914,5630),(27915,5630),(27916,5631),(27917,5631),(27918,5631),(27919,5631),(27920,5632),(27921,5632),(27922,5632),(27923,5632),(27924,5633),(27925,5633),(27926,5633),(27927,5633),(27928,5634),(27929,5634),(27930,5634),(27931,5634),(27932,5635),(27933,5635),(27934,5635),(27935,5635),(27936,5636),(27937,5636),(27938,5636),(27939,5636),(27940,5637),(27941,5637),(27942,5637),(27943,5637),(27944,5638),(27945,5638),(27946,5638),(27947,5638),(27948,5639),(27949,5639),(27950,5639),(27951,5639),(27952,5640),(27953,5640),(27954,5640),(27955,5640),(27956,5641),(27957,5641),(27958,5641),(27959,5641),(27960,5642),(27961,5642),(27962,5642),(27963,5642),(27964,5643),(27965,5643),(27966,5643),(27967,5643),(27968,5644),(27969,5644),(27970,5644),(27971,5644),(27972,5645),(27973,5645),(27974,5645),(27975,5645),(27976,5646),(27977,5646),(27978,5646),(27979,5646),(27980,5647),(27981,5647),(27982,5647),(27983,5647),(27984,5648),(27985,5648),(27986,5648),(27987,5648),(27988,5649),(27989,5649),(27990,5649),(27991,5649),(27992,5650),(27993,5650),(27994,5650),(27995,5650),(27996,5651),(27997,5651),(27998,5651),(27999,5651),(28000,5652),(28001,5652),(28002,5652),(28003,5652),(28004,5653),(28005,5653),(28006,5653),(28007,5653),(28008,5654),(28009,5654),(28010,5654),(28011,5654),(28012,5655),(28013,5655),(28014,5655),(28015,5655),(28016,5656),(28017,5656),(28018,5656),(28019,5656),(28020,5657),(28021,5657),(28022,5657),(28023,5657),(28024,5658),(28025,5658),(28026,5658),(28027,5658),(28028,5659),(28029,5659),(28030,5659),(28031,5659),(28032,5660),(28033,5660),(28034,5660),(28035,5660),(28036,5661),(28037,5661),(28038,5661),(28039,5661),(28040,5662),(28041,5662),(28042,5662),(28043,5662),(28044,5663),(28045,5663),(28046,5663),(28047,5663),(28048,5664),(28049,5664),(28050,5664),(28051,5664),(28052,5665),(28053,5665),(28054,5665),(28055,5665),(28056,5666),(28057,5666),(28058,5666),(28059,5666),(28060,5667),(28061,5667),(28062,5667),(28063,5667),(28064,5668),(28065,5668),(28066,5668),(28067,5668),(28068,5669),(28069,5669),(28070,5669),(28071,5669),(28072,5670),(28073,5670),(28074,5670),(28075,5670),(28076,5671),(28077,5671),(28078,5671),(28079,5671),(28080,5672),(28081,5672),(28082,5672),(28083,5672),(28084,5673),(28085,5673),(28086,5673),(28087,5673),(28088,5674),(28089,5674),(28090,5674),(28091,5674),(28092,5675),(28093,5675),(28094,5675),(28095,5675),(28096,5676),(28097,5676),(28098,5676),(28099,5676),(28100,5677),(28101,5677),(28102,5677),(28103,5677),(28104,5678),(28105,5678),(28106,5678),(28107,5678),(28108,5679),(28109,5679),(28110,5679),(28111,5679),(28112,5680),(28113,5680),(28114,5680),(28115,5680),(28116,5681),(28117,5681),(28118,5681),(28119,5681),(28120,5682),(28121,5682),(28122,5682),(28123,5682),(28124,5683),(28125,5683),(28126,5683),(28127,5683),(28128,5684),(28129,5684),(28130,5684),(28131,5684),(28132,5685),(28133,5685),(28134,5685),(28135,5685),(28136,5686),(28137,5686),(28138,5686),(28139,5686),(28140,5687),(28141,5687),(28142,5687),(28143,5687),(28144,5688),(28145,5688),(28146,5688),(28147,5688),(28148,5689),(28149,5689),(28150,5689),(28151,5689),(28152,5690),(28153,5690),(28154,5690),(28155,5690),(28156,5691),(28157,5691),(28158,5691),(28159,5691),(28160,5692),(28161,5692),(28162,5692),(28163,5692),(28164,5693),(28165,5693),(28166,5693),(28167,5693),(28168,5694),(28169,5694),(28170,5694),(28171,5694),(28172,5695),(28173,5695),(28174,5695),(28175,5695),(28176,5696),(28177,5696),(28178,5696),(28179,5696),(28180,5697),(28181,5697),(28182,5697),(28183,5697),(28184,5698),(28185,5698),(28186,5698),(28187,5698),(28188,5699),(28189,5699),(28190,5699),(28191,5699),(28192,5700),(28193,5700),(28194,5700),(28195,5700),(28196,5701),(28197,5701),(28198,5701),(28199,5701),(28200,5702),(28201,5702),(28202,5702),(28203,5702),(28204,5703),(28205,5703),(28206,5703),(28207,5703),(28208,5704),(28209,5704),(28210,5704),(28211,5704),(28212,5705),(28213,5705),(28214,5705),(28215,5705),(28216,5706),(28217,5706),(28218,5706),(28219,5706),(28220,5707),(28221,5707),(28222,5707),(28223,5707),(28224,5708),(28225,5708),(28226,5708),(28227,5708),(28228,5709),(28229,5709),(28230,5709),(28231,5709),(28232,5710),(28233,5710),(28234,5710),(28235,5710),(28236,5711),(28237,5711),(28238,5711),(28239,5711),(28240,5712),(28241,5712),(28242,5712),(28243,5712),(28244,5713),(28245,5713),(28246,5713),(28247,5713),(28248,5714),(28249,5714),(28250,5714),(28251,5714),(28252,5715),(28253,5715),(28254,5715),(28255,5715),(28256,5716),(28257,5716),(28258,5716),(28259,5716),(28260,5717),(28261,5717),(28262,5717),(28263,5717),(28264,5718),(28265,5718),(28266,5718),(28267,5718),(28268,5719),(28269,5719),(28270,5719),(28271,5719),(28272,5720),(28273,5720),(28274,5720),(28275,5720),(28276,5721),(28277,5721),(28278,5721),(28279,5721),(28280,5722),(28281,5722),(28282,5722),(28283,5722),(28284,5723),(28285,5723),(28286,5723),(28287,5723),(28288,5724),(28289,5724),(28290,5724),(28291,5724),(28292,5725),(28293,5725),(28294,5725),(28295,5725),(28296,5726),(28297,5726),(28298,5726),(28299,5726),(28300,5727),(28301,5727),(28302,5727),(28303,5727),(28304,5728),(28305,5728),(28306,5728),(28307,5728),(28308,5729),(28309,5729),(28310,5729),(28311,5729),(28312,5730),(28313,5730),(28314,5730),(28315,5730),(28316,5731),(28317,5731),(28318,5731),(28319,5731),(28320,5732),(28321,5732),(28322,5732),(28323,5732),(28324,5733),(28325,5733),(28326,5733),(28327,5733),(28328,5734),(28329,5734),(28330,5734),(28331,5734),(28332,5735),(28333,5735),(28334,5735),(28335,5735),(28336,5736),(28337,5736),(28338,5736),(28339,5736),(28340,5737),(28341,5737),(28342,5737),(28343,5737),(28344,5738),(28345,5738),(28346,5738),(28347,5738),(28348,5739),(28349,5739),(28350,5739),(28351,5739),(28352,5740),(28353,5740),(28354,5740),(28355,5740),(28356,5741),(28357,5741),(28358,5741),(28359,5741),(28360,5742),(28361,5742),(28362,5742),(28363,5742),(28364,5743),(28365,5743),(28366,5743),(28367,5743),(28368,5744),(28369,5744),(28370,5744),(28371,5744),(28372,5745),(28373,5745),(28374,5745),(28375,5745),(28376,5746),(28377,5746),(28378,5746),(28379,5746),(28380,5747),(28381,5747),(28382,5747),(28383,5747),(28384,5748),(28385,5748),(28386,5748),(28387,5748),(28388,5749),(28389,5749),(28390,5749),(28391,5749),(28392,5750),(28393,5750),(28394,5750),(28395,5750),(28396,5751),(28397,5751),(28398,5751),(28399,5751),(28400,5752),(28401,5752),(28402,5752),(28403,5752),(28404,5271),(28405,5272),(28406,5273),(28407,5274),(28408,5275),(28409,5276),(28410,5277),(28411,5278),(28412,5279),(28413,5280),(28414,5281),(28415,5282),(28416,5283),(28417,5284),(28418,5285),(28419,5286),(28420,5287),(28421,5288),(28422,5289),(28423,5290),(28424,5291),(28425,5292),(28426,5293),(28427,5294),(28428,5295),(28429,5296),(28430,5297),(28431,5298),(28432,5299),(28433,5300),(28434,5301),(28435,5302),(28436,5303),(28437,5304),(28438,5305),(28439,5306),(28440,5307),(28441,5308),(28442,5309),(28443,5310),(28444,5311),(28445,5312),(28446,5313),(28447,5314),(28448,5315),(28449,5316),(28450,5317),(28451,5318),(28452,5319),(28453,5320),(28454,5321),(28455,5322),(28456,5323),(28457,5324),(28458,5325),(28459,5326),(28460,5327),(28461,5328),(28462,5329),(28463,5330),(28464,5331),(28465,5332),(28466,5333),(28467,5334),(28468,5335),(28469,5336),(28470,5337),(28471,5338),(28472,5339),(28473,5340),(28474,5341),(28475,5342),(28476,5343),(28477,5344),(28478,5345),(28479,5346),(28480,5347),(28481,5348),(28482,5349),(28483,5350),(28484,5351),(28485,5352),(28486,5353),(28487,5354),(28488,5355),(28489,5356),(28490,5357),(28491,5358),(28492,5359),(28493,5360),(28494,5361),(28495,5362),(28496,5363),(28497,5364),(28498,5365),(28499,5366),(28500,5367),(28501,5368),(28502,5369),(28503,5370),(28504,5371),(28505,5372),(28506,5373),(28507,5374),(28508,5375),(28509,5376),(28510,5377),(28511,5378),(28512,5379),(28513,5380),(28514,5381),(28515,5382),(28516,5383),(28517,5384),(28518,5385),(28519,5386),(28520,5387),(28521,5388),(28522,5389),(28523,5390),(28524,5391),(28525,5392),(28526,5393),(28527,5394),(28528,5395),(28529,5396),(28530,5397),(28531,5398),(28532,5399),(28533,5400),(28534,5401),(28535,5402),(28536,5403),(28537,5404),(28538,5405),(28539,5406),(28540,5407),(28541,5408),(28542,5409),(28543,5410),(28544,5411),(28545,5412),(28546,5413),(28547,5414),(28548,5415),(28549,5416),(28550,5417),(28551,5418),(28552,5419),(28553,5420),(28554,5421),(28555,5422),(28556,5423),(28557,5424),(28558,5425),(28559,5426),(28560,5427),(28561,5428),(28562,5429),(28563,5430),(28564,5431),(28565,5432),(28566,5433),(28567,5434),(28568,5435),(28569,5436),(28570,5437),(28571,5438),(28572,5439),(28573,5440),(28574,5441),(28575,5442),(28576,5443),(28577,5444),(28578,5445),(28579,5446),(28580,5447),(28581,5448),(28582,5449),(28583,5450),(28584,5451),(28585,5452),(28586,5453),(28587,5454),(28588,5455),(28589,5456),(28590,5457),(28591,5458),(28592,5459),(28593,5460),(28594,5461),(28595,5462),(28596,5463),(28597,5464),(28598,5465),(28599,5466),(28600,5467),(28601,5468),(28602,5469),(28603,5470),(28604,5471),(28605,5472),(28606,5473),(28607,5474),(28608,5475),(28609,5476),(28610,5477),(28611,5478),(28612,5479),(28613,5480),(28614,5481),(28615,5482),(28616,5483),(28617,5484),(28618,5485),(28619,5486),(28620,5487),(28621,5488),(28622,5489),(28623,5490),(28624,5491),(28625,5492),(28626,5493),(28627,5494),(28628,5495),(28629,5496),(28630,5497),(28631,5498),(28632,5499),(28633,5500),(28634,5501),(28635,5502),(28636,5503),(28637,5504),(28638,5505),(28639,5506),(28640,5507),(28641,5508),(28642,5509),(28643,5510),(28644,5511),(28645,5512),(28646,5513),(28647,5514),(28648,5515),(28649,5516),(28650,5517),(28651,5518),(28652,5519),(28653,5520),(28654,5521),(28655,5522),(28656,5523),(28657,5524),(28658,5525),(28659,5526),(28660,5527),(28661,5528),(28662,5529),(28663,5530),(28664,5531),(28665,5532),(28666,5533),(28667,5534),(28668,5535),(28669,5536),(28670,5537),(28671,5538),(28672,5539),(28673,5540),(28674,5541),(28675,5542),(28676,5543),(28677,5544),(28678,5545),(28679,5546),(28680,5547),(28681,5548),(28682,5549),(28683,5550),(28684,5551),(28685,5552),(28686,5553),(28687,5554),(28688,5555),(28689,5556),(28690,5557),(28691,5558),(28692,5559),(28693,5560),(28694,5561),(28695,5562),(28696,5563),(28697,5564),(28698,5565),(28699,5566),(28700,5567),(28701,5568),(28702,5569),(28703,5570),(28704,5571),(28705,5572),(28706,5573),(28707,5574),(28708,5575),(28709,5576),(28710,5577),(28711,5578),(28712,5579),(28713,5580),(28714,5581),(28715,5582),(28716,5583),(28717,5584),(28718,5585),(28719,5586),(28720,5587),(28721,5588),(28722,5589),(28723,5590),(28724,5591),(28725,5592),(28726,5593),(28727,5594),(28728,5595),(28729,5596),(28730,5597),(28731,5598),(28732,5599),(28733,5600),(28734,5601),(28735,5602),(28736,5603),(28737,5604),(28738,5605),(28739,5606),(28740,5607),(28741,5608),(28742,5609),(28743,5610),(28744,5611),(28745,5612),(28746,5613),(28747,5614),(28748,5615),(28749,5616),(28750,5617),(28751,5618),(28752,5619),(28753,5620),(28754,5621),(28755,5622),(28756,5623),(28757,5624),(28758,5625),(28759,5626),(28760,5627),(28761,5628),(28762,5629),(28763,5630),(28764,5631),(28765,5632),(28766,5633),(28767,5634),(28768,5635),(28769,5636),(28770,5637),(28771,5638),(28772,5639),(28773,5640),(28774,5641),(28775,5642),(28776,5643),(28777,5644),(28778,5645),(28779,5646),(28780,5647),(28781,5648),(28782,5649),(28783,5650),(28784,5651),(28785,5652),(28786,5653),(28787,5654),(28788,5655),(28789,5656),(28790,5657),(28791,5658),(28792,5659),(28793,5660),(28794,5661),(28795,5662),(28796,5663),(28797,5664),(28798,5665),(28799,5666),(28800,5667),(28801,5668),(28802,5669),(28803,5670),(28804,5671),(28805,5672),(28806,5673),(28807,5674),(28808,5675),(28809,5676),(28810,5677),(28811,5678),(28812,5679),(28813,5680),(28814,5681),(28815,5682),(28816,5683),(28817,5684),(28818,5685),(28819,5686),(28820,5687),(28821,5688),(28822,5689),(28823,5690),(28824,5691),(28825,5692),(28826,5693),(28827,5694),(28828,5695),(28829,5696),(28830,5697),(28831,5698),(28832,5699),(28833,5700),(28834,5701),(28835,5702),(28836,5703),(28837,5704),(28838,5705),(28839,5706),(28840,5707),(28841,5708),(28842,5709),(28843,5710),(28844,5711),(28845,5712),(28846,5713),(28847,5714),(28848,5715),(28849,5716),(28850,5717),(28851,5718),(28852,5719),(28853,5720),(28854,5721),(28855,5722),(28856,5723),(28857,5724),(28858,5725),(28859,5726),(28860,5727),(28861,5728),(28862,5729),(28863,5730),(28864,5731),(28865,5732),(28866,5733),(28867,5734),(28868,5735),(28869,5736),(28870,5737),(28871,5738),(28872,5739),(28873,5740),(28874,5741),(28875,5742),(28876,5743),(28877,5744),(28878,5745),(28879,5746),(28880,5747),(28881,5748),(28882,5749),(28883,5750),(28884,5751),(28885,5752),(28886,1160),(28887,1161),(28888,1119),(28889,5752),(28890,5738),(28891,4713),(28892,5197),(28893,5194),(28894,5193),(28895,5192),(28896,5191),(28897,5190),(28898,4875),(28899,4876),(28900,4891),(28901,4892),(28902,4893),(28903,4894),(28904,1162),(28905,1162),(28906,1162),(28907,1165),(28908,1165),(28909,1165),(28910,2163),(28911,2163),(28912,2163),(28913,2163),(28914,2176),(28915,2176),(28916,2176),(28917,2176),(28918,1164),(28919,1164),(28920,1164),(28921,4894),(28922,4894),(28923,4894),(28924,4894),(28925,2163),(28926,1),(28927,1),(28928,1),(28929,1),(28930,1),(28931,1),(28932,1),(28933,1),(28934,1),(28935,1),(28936,1),(28937,1),(28938,1),(28939,1),(28940,1),(28941,1),(28942,1),(28943,1),(28944,1),(28945,1),(28946,1),(28947,1),(28948,1),(28949,1),(28950,1),(28951,1),(28952,1),(28953,1),(28954,1),(28955,1),(28956,5753),(28957,5753),(28958,5753),(28959,5753),(28960,5753),(28961,5753),(28962,5753),(28963,5754),(28964,5754),(28965,5754),(28966,5754),(28967,5754),(28968,5754),(28969,5754),(28970,5754),(28971,5755),(28972,5755),(28973,5755),(28974,5755),(28975,5755),(28976,5755),(28977,5755),(28978,5755),(28979,5756),(28980,5756),(28981,5756),(28982,5756),(28983,5756),(28984,5756),(28985,5756),(28986,5756),(28987,5753),(28988,5754),(28989,5755),(28990,5756),(28991,1162),(28992,1162),(28993,1162),(28994,4894),(28995,4894),(28996,4894),(28997,1164),(28998,1164),(28999,1164),(29000,2176),(29001,2176),(29002,2176),(29003,5753),(29004,5753),(29005,5753),(29006,5753),(29007,5753),(29008,5753),(29009,5753),(29010,1165),(29011,1165),(29012,1165),(29013,1165),(29014,1165),(29015,1165),(29016,5193),(29017,5193),(29018,5193),(29019,5193),(29020,5193),(29021,5193),(29022,5193),(29023,5192),(29024,5192),(29025,5192),(29026,5192),(29027,5192),(29028,5192),(29029,5192),(29030,5190),(29031,5190),(29032,5190),(29033,5190),(29034,5190),(29035,5190),(29036,5190),(29037,5753),(29038,5753),(29039,5753),(29040,5753),(29041,5753),(29042,5753),(29043,5753),(29044,5753),(29045,5753),(29046,5753),(29047,5753),(29048,5753),(29049,5753),(29050,5753),(29051,5753),(29052,5753),(29053,5753),(29054,5753),(29055,5753),(29056,5753),(29057,5753),(29058,5753),(29059,5753),(29060,5753),(29061,5753),(29062,5753),(29063,5753),(29064,5753),(29065,5753),(29066,5753),(29067,5753),(29068,5753),(29069,5753),(29070,5753),(29071,5753),(29072,5753),(29073,5753),(29074,5753),(29075,5753),(29076,5753),(29077,5753),(29078,5753),(29079,5753),(29080,5753),(29081,5753),(29082,5753),(29083,5753),(29084,5753),(29085,5753),(29086,5753),(29087,5753),(29088,5753),(29089,5753),(29090,5753),(29091,5753),(29092,5753),(29093,5753),(29094,5753),(29095,5753),(29096,5753),(29097,5753),(29098,5753),(29099,5753),(29100,5753),(29101,5753),(29102,5753),(29103,5753),(29104,5753),(29105,5753),(29106,5753),(29107,5753),(29108,5753),(29109,5753),(29110,5753),(29111,5753),(29112,5753),(29113,5753),(29114,5753),(29115,5753),(29116,5753),(29117,5753),(29118,5753),(29119,5753),(29120,5753),(29121,5753),(29122,5753),(29123,5753),(29124,5753),(29125,5753),(29126,5753),(29127,5753),(29128,5753),(29129,5753),(29130,5753),(29131,48),(29132,48),(29133,48),(29134,48),(29135,48),(29136,48),(29137,48),(29138,48),(29139,4894),(29140,4894),(29141,4894),(29142,5753),(29143,5753),(29144,5753),(29145,5753),(29146,5753),(29147,5753),(29148,5753),(29149,5753),(29150,5753),(29151,5753),(29152,5753),(29153,5753),(29154,2176),(29155,2176),(29156,2176),(29157,5753),(29158,5753),(29159,5753),(29160,5753),(29161,5753),(29162,5753),(29163,5753),(29164,5753),(29165,5753),(29166,5753),(29167,5753),(29168,7),(29169,7),(29170,7),(29171,7),(29172,7),(29173,7),(29174,7),(29175,7),(29176,7),(29177,7),(29178,7),(29179,7),(29180,7),(29181,7),(29182,7),(29183,7),(29184,7),(29185,7),(29186,7),(29187,7),(29188,7),(29189,5757),(29190,5757),(29191,5757),(29192,5757),(29193,5757),(29194,5757),(29195,5757),(29196,5757),(29197,5757),(29198,5757),(29199,5757),(29200,5757),(29201,5758),(29202,5758),(29203,5758),(29204,5758),(29205,5758),(29206,5758),(29207,5758),(29208,5758),(29209,5758),(29210,5758),(29211,5758),(29212,5758),(29213,5759),(29214,5759),(29215,5759),(29216,5759),(29217,5759),(29218,5759),(29219,5759),(29220,5759),(29221,5759),(29222,5759),(29223,5759),(29224,5759),(29225,1165),(29226,1165),(29227,1165),(29228,7),(29229,7),(29230,7),(29231,7),(29232,7),(29233,7),(29234,7),(29235,7),(29236,7),(29237,7),(29238,7),(29239,7),(29240,7),(29241,7),(29242,7),(29243,7),(29244,7),(29245,7),(29246,7),(29247,7),(29248,7),(29249,7),(29250,7),(29251,7),(29252,7),(29253,7),(29254,7),(29255,7),(29256,7),(29257,7),(29258,7),(29259,7),(29260,7),(29261,7),(29262,7),(29263,7),(29264,7),(29265,7),(29266,7),(29267,7),(29268,7),(29269,7),(29270,7),(29271,7),(29272,7),(29273,7),(29274,7),(29275,7),(29276,7),(29277,7),(29278,7),(29279,7),(29280,7),(29281,7),(29282,7),(29283,7),(29284,7),(29285,7),(29286,7),(29287,7),(29288,7),(29289,7),(29290,7),(29291,7),(29292,7),(29293,7),(29294,7),(29295,7),(29296,7),(29297,7),(29298,7),(29299,7),(29300,51),(29301,51),(29302,51),(29303,51),(29304,51),(29305,51),(29306,51),(29307,51),(29308,51),(29309,221),(29310,221),(29311,221),(29312,221),(29313,221),(29314,221),(29315,221),(29316,221),(29317,221),(29318,112),(29319,112),(29320,112),(29321,112),(29322,112),(29323,112),(29324,112),(29325,112),(29326,112),(29327,18),(29328,18),(29329,18),(29330,18),(29331,18),(29332,18),(29333,18),(29334,18),(29335,18),(29336,1623),(29337,1623),(29338,1623),(29339,1623),(29340,1623),(29341,1623),(29342,1623),(29343,1623),(29344,1623),(29345,2289),(29346,2289),(29347,2289),(29348,2289),(29349,2289),(29350,2289),(29351,2289),(29352,2289),(29353,2289),(29354,2289),(29355,2289),(29356,2289),(29357,2289),(29358,2289),(29359,2289),(29360,1164),(29361,1164),(29362,1162),(29363,1162),(29364,4894),(29365,1162),(29366,5718),(29367,5718),(29368,5718),(29369,5718),(29370,5718),(29371,5718),(29372,5718),(29373,5718),(29374,5718),(29375,5718),(29376,5760),(29377,5760),(29378,5760),(29379,5760),(29380,5760),(29381,5760),(29382,5760),(29383,5760),(29384,5760),(29385,5760),(29386,5760),(29387,5760),(29388,5761),(29389,5761),(29390,5761),(29391,5761),(29392,5761),(29393,5761),(29394,5761),(29395,5761),(29396,5761),(29397,5761),(29398,5761),(29399,5762),(29400,5762),(29401,5762),(29402,5762),(29403,5762),(29404,5762),(29405,5762),(29406,5762),(29407,5762),(29408,5762),(29409,5762),(29410,5763),(29411,5763),(29412,5763),(29413,5763),(29414,5763),(29415,5763),(29416,5763),(29417,5763),(29418,5763),(29419,5763),(29420,5763),(29421,5764),(29422,5764),(29423,5764),(29424,5764),(29425,5764),(29426,5764),(29427,5764),(29428,5764),(29429,5764),(29430,5764),(29431,5764),(29432,5765),(29433,5765),(29434,5765),(29435,5765),(29436,5765),(29437,5765),(29438,5765),(29439,5765),(29440,5765),(29441,5765),(29442,5765),(29443,5766),(29444,5766),(29445,5766),(29446,5766),(29447,5766),(29448,5766),(29449,5766),(29450,5766),(29451,5766),(29452,5766),(29453,5766),(29454,5767),(29455,5767),(29456,5767),(29457,5767),(29458,5767),(29459,5767),(29460,5767),(29461,5767),(29462,5767),(29463,5767),(29464,5767),(29465,5768),(29466,5768),(29467,5768),(29468,5768),(29469,5768),(29470,5768),(29471,5768),(29472,5768),(29473,5768),(29474,5768),(29475,5768),(29476,5769),(29477,5769),(29478,5769),(29479,5769),(29480,5769),(29481,5769),(29482,5769),(29483,5769),(29484,5769),(29485,5769),(29486,5769),(29487,5770),(29488,5770),(29489,5770),(29490,5770),(29491,5770),(29492,5770),(29493,5770),(29494,5770),(29495,5770),(29496,5770),(29497,5770),(29498,5771),(29499,5771),(29500,5771),(29501,5771),(29502,5771),(29503,5771),(29504,5771),(29505,5771),(29506,5771),(29507,5771),(29508,5771),(29509,5772),(29510,5772),(29511,5772),(29512,5772),(29513,5772),(29514,5772),(29515,5772),(29516,5772),(29517,5772),(29518,5772),(29519,5772),(29520,5773),(29521,5773),(29522,5773),(29523,5773),(29524,5773),(29525,5773),(29526,5773),(29527,5773),(29528,5773),(29529,5773),(29530,5773),(29531,5774),(29532,5774),(29533,5774),(29534,5774),(29535,5774),(29536,5774),(29537,5774),(29538,5774),(29539,5774),(29540,5774),(29541,5774),(29542,5775),(29543,5775),(29544,5775),(29545,5775),(29546,5775),(29547,5775),(29548,5775),(29549,5775),(29550,5775),(29551,5775),(29552,5775),(29553,5776),(29554,5776),(29555,5776),(29556,5776),(29557,5776),(29558,5776),(29559,5776),(29560,5776),(29561,5776),(29562,5776),(29563,5776),(29564,5777),(29565,5777),(29566,5777),(29567,5777),(29568,5777),(29569,5777),(29570,5777),(29571,5777),(29572,5777),(29573,5777),(29574,5777),(29575,5778),(29576,5778),(29577,5778),(29578,5778),(29579,5778),(29580,5778),(29581,5778),(29582,5778),(29583,5778),(29584,5778),(29585,5778),(29586,5779),(29587,5779),(29588,5779),(29589,5779),(29590,5779),(29591,5779),(29592,5779),(29593,5779),(29594,5779),(29595,5779),(29596,5779),(29597,5780),(29598,5780),(29599,5780),(29600,5780),(29601,5780),(29602,5780),(29603,5780),(29604,5780),(29605,5780),(29606,5780),(29607,5780),(29608,5781),(29609,5781),(29610,5781),(29611,5781),(29612,5781),(29613,5781),(29614,5781),(29615,5781),(29616,5781),(29617,5781),(29618,5781),(29619,5782),(29620,5782),(29621,5782),(29622,5782),(29623,5782),(29624,5782),(29625,5782),(29626,5782),(29627,5782),(29628,5782),(29629,5782),(29630,5783),(29631,5783),(29632,5783),(29633,5783),(29634,5783),(29635,5783),(29636,5783),(29637,5783),(29638,5783),(29639,5783),(29640,5783),(29641,5784),(29642,5784),(29643,5784),(29644,5784),(29645,5784),(29646,5784),(29647,5784),(29648,5784),(29649,5784),(29650,5784),(29651,5784),(29652,5785),(29653,5785),(29654,5785),(29655,5785),(29656,5785),(29657,5785),(29658,5785),(29659,5785),(29660,5785),(29661,5785),(29662,5785),(29663,5786),(29664,5786),(29665,5786),(29666,5786),(29667,5786),(29668,5786),(29669,5786),(29670,5786),(29671,5786),(29672,5786),(29673,5786),(29674,5787),(29675,5787),(29676,5787),(29677,5787),(29678,5787),(29679,5787),(29680,5787),(29681,5787),(29682,5787),(29683,5787),(29684,5787),(29685,5788),(29686,5788),(29687,5788),(29688,5788),(29689,5788),(29690,5788),(29691,5788),(29692,5788),(29693,5788),(29694,5788),(29695,5788),(29696,5789),(29697,5789),(29698,5789),(29699,5789),(29700,5789),(29701,5789),(29702,5789),(29703,5789),(29704,5789),(29705,5789),(29706,5789),(29707,5790),(29708,5790),(29709,5790),(29710,5790),(29711,5790),(29712,5790),(29713,5790),(29714,5790),(29715,5790),(29716,5790),(29717,5790),(29718,5791),(29719,5791),(29720,5791),(29721,5791),(29722,5791),(29723,5791),(29724,5791),(29725,5791),(29726,5791),(29727,5791),(29728,5791),(29729,5792),(29730,5792),(29731,5792),(29732,5792),(29733,5792),(29734,5792),(29735,5792),(29736,5792),(29737,5792),(29738,5792),(29739,5792),(29740,5793),(29741,5793),(29742,5793),(29743,5793),(29744,5793),(29745,5793),(29746,5793),(29747,5793),(29748,5793),(29749,5793),(29750,5793),(29751,5794),(29752,5794),(29753,5794),(29754,5794),(29755,5794),(29756,5794),(29757,5794),(29758,5794),(29759,5794),(29760,5794),(29761,5794),(29762,5795),(29763,5795),(29764,5795),(29765,5795),(29766,5795),(29767,5795),(29768,5795),(29769,5795),(29770,5795),(29771,5795),(29772,5795),(29773,5796),(29774,5796),(29775,5796),(29776,5796),(29777,5796),(29778,5796),(29779,5796),(29780,5796),(29781,5796),(29782,5796),(29783,5796),(29784,5797),(29785,5797),(29786,5797),(29787,5797),(29788,5797),(29789,5797),(29790,5797),(29791,5797),(29792,5797),(29793,5797),(29794,5797),(29795,5798),(29796,5798),(29797,5798),(29798,5798),(29799,5798),(29800,5798),(29801,5798),(29802,5798),(29803,5798),(29804,5798),(29805,5798),(29806,5799),(29807,5799),(29808,5799),(29809,5799),(29810,5799),(29811,5799),(29812,5799),(29813,5799),(29814,5799),(29815,5799),(29816,5799),(29817,5800),(29818,5800),(29819,5800),(29820,5800),(29821,5800),(29822,5800),(29823,5800),(29824,5800),(29825,5800),(29826,5800),(29827,5800),(29828,5801),(29829,5801),(29830,5801),(29831,5801),(29832,5801),(29833,5801),(29834,5801),(29835,5801),(29836,5801),(29837,5801),(29838,5801),(29839,5802),(29840,5802),(29841,5802),(29842,5802),(29843,5802),(29844,5802),(29845,5802),(29846,5802),(29847,5802),(29848,5802),(29849,5802),(29850,5803),(29851,5803),(29852,5803),(29853,5803),(29854,5803),(29855,5803),(29856,5803),(29857,5803),(29858,5803),(29859,5803),(29860,5803),(29861,5804),(29862,5804),(29863,5804),(29864,5804),(29865,5804),(29866,5804),(29867,5804),(29868,5804),(29869,5804),(29870,5804),(29871,5804),(29872,5805),(29873,5805),(29874,5805),(29875,5805),(29876,5805),(29877,5805),(29878,5805),(29879,5805),(29880,5805),(29881,5805),(29882,5805),(29883,5806),(29884,5806),(29885,5806),(29886,5806),(29887,5806),(29888,5806),(29889,5806),(29890,5806),(29891,5806),(29892,5806),(29893,5806),(29894,5807),(29895,5807),(29896,5807),(29897,5807),(29898,5807),(29899,5807),(29900,5807),(29901,5807),(29902,5807),(29903,5807),(29904,5807),(29905,5808),(29906,5808),(29907,5808),(29908,5808),(29909,5808),(29910,5808),(29911,5808),(29912,5808),(29913,5808),(29914,5808),(29915,5808),(29916,5809),(29917,5809),(29918,5809),(29919,5809),(29920,5809),(29921,5809),(29922,5809),(29923,5809),(29924,5809),(29925,5809),(29926,5809),(29927,5810),(29928,5810),(29929,5810),(29930,5810),(29931,5810),(29932,5810),(29933,5810),(29934,5810),(29935,5810),(29936,5810),(29937,5810),(29938,5811),(29939,5811),(29940,5811),(29941,5811),(29942,5811),(29943,5811),(29944,5811),(29945,5811),(29946,5811),(29947,5811),(29948,5811),(29949,5812),(29950,5812),(29951,5812),(29952,5812),(29953,5812),(29954,5812),(29955,5812),(29956,5812),(29957,5812),(29958,5812),(29959,5812),(29960,5813),(29961,5813),(29962,5813),(29963,5813),(29964,5813),(29965,5813),(29966,5813),(29967,5813),(29968,5813),(29969,5813),(29970,5813),(29971,5814),(29972,5814),(29973,5814),(29974,5814),(29975,5814),(29976,5814),(29977,5814),(29978,5814),(29979,5814),(29980,5814),(29981,5814),(29982,5815),(29983,5815),(29984,5815),(29985,5815),(29986,5815),(29987,5815),(29988,5815),(29989,5815),(29990,5815),(29991,5815),(29992,5815),(29993,5816),(29994,5816),(29995,5816),(29996,5816),(29997,5816),(29998,5816),(29999,5816),(30000,5816),(30001,5816),(30002,5816),(30003,5816),(30004,5817),(30005,5817),(30006,5817),(30007,5817),(30008,5817),(30009,5817),(30010,5817),(30011,5817),(30012,5817),(30013,5817),(30014,5817),(30015,5818),(30016,5818),(30017,5818),(30018,5818),(30019,5818),(30020,5818),(30021,5818),(30022,5818),(30023,5818),(30024,5818),(30025,5818),(30026,5819),(30027,5819),(30028,5819),(30029,5819),(30030,5819),(30031,5819),(30032,5819),(30033,5819),(30034,5819),(30035,5819),(30036,5819),(30037,5820),(30038,5820),(30039,5820),(30040,5820),(30041,5820),(30042,5820),(30043,5820),(30044,5820),(30045,5820),(30046,5820),(30047,5820),(30048,5821),(30049,5821),(30050,5821),(30051,5821),(30052,5821),(30053,5821),(30054,5821),(30055,5821),(30056,5821),(30057,5821),(30058,5821),(30059,5822),(30060,5822),(30061,5822),(30062,5822),(30063,5822),(30064,5822),(30065,5822),(30066,5822),(30067,5822),(30068,5822),(30069,5822),(30070,5823),(30071,5823),(30072,5823),(30073,5823),(30074,5823),(30075,5823),(30076,5823),(30077,5823),(30078,5823),(30079,5823),(30080,5823),(30081,5824),(30082,5824),(30083,5824),(30084,5824),(30085,5824),(30086,5824),(30087,5824),(30088,5824),(30089,5824),(30090,5824),(30091,5824),(30092,5825),(30093,5825),(30094,5825),(30095,5825),(30096,5825),(30097,5825),(30098,5825),(30099,5825),(30100,5825),(30101,5825),(30102,5825),(30103,5826),(30104,5826),(30105,5826),(30106,5826),(30107,5826),(30108,5826),(30109,5826),(30110,5826),(30111,5826),(30112,5826),(30113,5826),(30114,5827),(30115,5827),(30116,5827),(30117,5827),(30118,5827),(30119,5827),(30120,5827),(30121,5827),(30122,5827),(30123,5827),(30124,5827),(30125,5828),(30126,5828),(30127,5828),(30128,5828),(30129,5828),(30130,5828),(30131,5828),(30132,5828),(30133,5828),(30134,5828),(30135,5828),(30136,5829),(30137,5829),(30138,5829),(30139,5829),(30140,5829),(30141,5829),(30142,5829),(30143,5829),(30144,5829),(30145,5829),(30146,5829),(30147,5830),(30148,5830),(30149,5830),(30150,5830),(30151,5830),(30152,5830),(30153,5830),(30154,5830),(30155,5830),(30156,5830),(30157,5830),(30158,5831),(30159,5831),(30160,5831),(30161,5831),(30162,5831),(30163,5831),(30164,5831),(30165,5831),(30166,5831),(30167,5831),(30168,5831),(30169,5832),(30170,5832),(30171,5832),(30172,5832),(30173,5832),(30174,5832),(30175,5832),(30176,5832),(30177,5832),(30178,5832),(30179,5832),(30180,5833),(30181,5833),(30182,5833),(30183,5833),(30184,5833),(30185,5833),(30186,5833),(30187,5833),(30188,5833),(30189,5833),(30190,5833),(30191,5834),(30192,5834),(30193,5834),(30194,5834),(30195,5834),(30196,5834),(30197,5834),(30198,5834),(30199,5834),(30200,5834),(30201,5834),(30202,5835),(30203,5835),(30204,5835),(30205,5835),(30206,5835),(30207,5835),(30208,5835),(30209,5835),(30210,5835),(30211,5835),(30212,5835),(30213,5836),(30214,5836),(30215,5836),(30216,5836),(30217,5836),(30218,5836),(30219,5836),(30220,5836),(30221,5836),(30222,5836),(30223,5836),(30224,5837),(30225,5837),(30226,5837),(30227,5837),(30228,5837),(30229,5837),(30230,5837),(30231,5837),(30232,5837),(30233,5837),(30234,5837),(30235,5838),(30236,5838),(30237,5838),(30238,5838),(30239,5838),(30240,5838),(30241,5838),(30242,5838),(30243,5838),(30244,5838),(30245,5838),(30246,5839),(30247,5839),(30248,5839),(30249,5839),(30250,5839),(30251,5839),(30252,5839),(30253,5839),(30254,5839),(30255,5839),(30256,5839),(30257,5840),(30258,5840),(30259,5840),(30260,5840),(30261,5840),(30262,5840),(30263,5840),(30264,5840),(30265,5840),(30266,5840),(30267,5840),(30268,5841),(30269,5841),(30270,5841),(30271,5841),(30272,5841),(30273,5841),(30274,5841),(30275,5841),(30276,5841),(30277,5841),(30278,5841),(30279,5842),(30280,5842),(30281,5842),(30282,5842),(30283,5842),(30284,5842),(30285,5842),(30286,5842),(30287,5842),(30288,5842),(30289,5842),(30290,5843),(30291,5843),(30292,5843),(30293,5843),(30294,5843),(30295,5843),(30296,5843),(30297,5843),(30298,5843),(30299,5843),(30300,5843),(30301,5844),(30302,5844),(30303,5844),(30304,5844),(30305,5844),(30306,5844),(30307,5844),(30308,5844),(30309,5844),(30310,5844),(30311,5844),(30312,5845),(30313,5845),(30314,5845),(30315,5845),(30316,5845),(30317,5845),(30318,5845),(30319,5845),(30320,5845),(30321,5845),(30322,5845),(30323,5846),(30324,5846),(30325,5846),(30326,5846),(30327,5846),(30328,5846),(30329,5846),(30330,5846),(30331,5846),(30332,5846),(30333,5846),(30334,5847),(30335,5847),(30336,5847),(30337,5847),(30338,5847),(30339,5847),(30340,5847),(30341,5847),(30342,5847),(30343,5847),(30344,5847),(30345,5848),(30346,5848),(30347,5848),(30348,5848),(30349,5848),(30350,5848),(30351,5848),(30352,5848),(30353,5848),(30354,5848),(30355,5848),(30356,5849),(30357,5849),(30358,5849),(30359,5849),(30360,5849),(30361,5849),(30362,5849),(30363,5849),(30364,5849),(30365,5849),(30366,5849),(30367,5850),(30368,5850),(30369,5850),(30370,5850),(30371,5850),(30372,5850),(30373,5850),(30374,5850),(30375,5850),(30376,5850),(30377,5850),(30378,5851),(30379,5851),(30380,5851),(30381,5851),(30382,5851),(30383,5851),(30384,5851),(30385,5851),(30386,5851),(30387,5851),(30388,5851),(30389,5852),(30390,5852),(30391,5852),(30392,5852),(30393,5852),(30394,5852),(30395,5852),(30396,5852),(30397,5852),(30398,5852),(30399,5852),(30400,5853),(30401,5853),(30402,5853),(30403,5853),(30404,5853),(30405,5853),(30406,5853),(30407,5853),(30408,5853),(30409,5853),(30410,5853),(30411,5854),(30412,5854),(30413,5854),(30414,5854),(30415,5854),(30416,5854),(30417,5854),(30418,5854),(30419,5854),(30420,5854),(30421,5854),(30422,5855),(30423,5855),(30424,5855),(30425,5855),(30426,5855),(30427,5855),(30428,5855),(30429,5855),(30430,5855),(30431,5855),(30432,5855),(30433,5856),(30434,5856),(30435,5856),(30436,5856),(30437,5856),(30438,5856),(30439,5856),(30440,5856),(30441,5856),(30442,5856),(30443,5856),(30444,5857),(30445,5857),(30446,5857),(30447,5857),(30448,5857),(30449,5857),(30450,5857),(30451,5857),(30452,5857),(30453,5857),(30454,5857),(30455,5858),(30456,5858),(30457,5858),(30458,5858),(30459,5858),(30460,5858),(30461,5858),(30462,5858),(30463,5858),(30464,5858),(30465,5858),(30466,5859),(30467,5859),(30468,5859),(30469,5859),(30470,5859),(30471,5859),(30472,5859),(30473,5859),(30474,5859),(30475,5859),(30476,5859),(30477,5860),(30478,5860),(30479,5860),(30480,5860),(30481,5860),(30482,5860),(30483,5860),(30484,5860),(30485,5860),(30486,5860),(30487,5860),(30488,5861),(30489,5861),(30490,5861),(30491,5861),(30492,5861),(30493,5861),(30494,5861),(30495,5861),(30496,5861),(30497,5861),(30498,5861),(30499,5862),(30500,5862),(30501,5862),(30502,5862),(30503,5862),(30504,5862),(30505,5862),(30506,5862),(30507,5862),(30508,5862),(30509,5862),(30510,5863),(30511,5863),(30512,5863),(30513,5863),(30514,5863),(30515,5863),(30516,5863),(30517,5863),(30518,5863),(30519,5863),(30520,5863),(30521,5864),(30522,5864),(30523,5864),(30524,5864),(30525,5864),(30526,5864),(30527,5864),(30528,5864),(30529,5864),(30530,5864),(30531,5864),(30532,5865),(30533,5865),(30534,5865),(30535,5865),(30536,5865),(30537,5865),(30538,5865),(30539,5865),(30540,5865),(30541,5865),(30542,5865),(30543,5866),(30544,5866),(30545,5866),(30546,5866),(30547,5866),(30548,5866),(30549,5866),(30550,5866),(30551,5866),(30552,5866),(30553,5866),(30554,5867),(30555,5867),(30556,5867),(30557,5867),(30558,5867),(30559,5867),(30560,5867),(30561,5867),(30562,5867),(30563,5867),(30564,5867),(30565,5868),(30566,5868),(30567,5868),(30568,5868),(30569,5868),(30570,5868),(30571,5868),(30572,5868),(30573,5868),(30574,5868),(30575,5868),(30576,5869),(30577,5869),(30578,5869),(30579,5869),(30580,5869),(30581,5869),(30582,5869),(30583,5869),(30584,5869),(30585,5869),(30586,5869),(30587,5870),(30588,5870),(30589,5870),(30590,5870),(30591,5870),(30592,5870),(30593,5870),(30594,5870),(30595,5870),(30596,5870),(30597,5870),(30598,5871),(30599,5871),(30600,5871),(30601,5871),(30602,5871),(30603,5871),(30604,5871),(30605,5871),(30606,5871),(30607,5871),(30608,5871),(30609,5872),(30610,5872),(30611,5872),(30612,5872),(30613,5872),(30614,5872),(30615,5872),(30616,5872),(30617,5872),(30618,5872),(30619,5872),(30620,5873),(30621,5873),(30622,5873),(30623,5873),(30624,5873),(30625,5873),(30626,5873),(30627,5873),(30628,5873),(30629,5873),(30630,5873),(30631,5874),(30632,5874),(30633,5874),(30634,5874),(30635,5874),(30636,5874),(30637,5874),(30638,5874),(30639,5874),(30640,5874),(30641,5874),(30642,5875),(30643,5875),(30644,5875),(30645,5875),(30646,5875),(30647,5875),(30648,5875),(30649,5875),(30650,5875),(30651,5875),(30652,5875),(30653,5876),(30654,5876),(30655,5876),(30656,5876),(30657,5876),(30658,5876),(30659,5876),(30660,5876),(30661,5876),(30662,5876),(30663,5876),(30664,5877),(30665,5877),(30666,5877),(30667,5877),(30668,5877),(30669,5877),(30670,5877),(30671,5877),(30672,5877),(30673,5877),(30674,5877),(30675,5878),(30676,5878),(30677,5878),(30678,5878),(30679,5878),(30680,5878),(30681,5878),(30682,5878),(30683,5878),(30684,5878),(30685,5878),(30686,5879),(30687,5879),(30688,5879),(30689,5879),(30690,5879),(30691,5879),(30692,5879),(30693,5879),(30694,5879),(30695,5879),(30696,5879),(30697,5880),(30698,5880),(30699,5880),(30700,5880),(30701,5880),(30702,5880),(30703,5880),(30704,5880),(30705,5880),(30706,5880),(30707,5880),(30708,5881),(30709,5881),(30710,5881),(30711,5881),(30712,5881),(30713,5881),(30714,5881),(30715,5881),(30716,5881),(30717,5881),(30718,5881),(30719,5882),(30720,5882),(30721,5882),(30722,5882),(30723,5882),(30724,5882),(30725,5882),(30726,5882),(30727,5882),(30728,5882),(30729,5882),(30730,5883),(30731,5883),(30732,5883),(30733,5883),(30734,5883),(30735,5883),(30736,5883),(30737,5883),(30738,5883),(30739,5883),(30740,5883),(30741,5884),(30742,5884),(30743,5884),(30744,5884),(30745,5884),(30746,5884),(30747,5884),(30748,5884),(30749,5884),(30750,5884),(30751,5884),(30752,5885),(30753,5885),(30754,5885),(30755,5885),(30756,5885),(30757,5885),(30758,5885),(30759,5885),(30760,5885),(30761,5885),(30762,5885),(30763,5886),(30764,5886),(30765,5886),(30766,5886),(30767,5886),(30768,5886),(30769,5886),(30770,5886),(30771,5886),(30772,5886),(30773,5886),(30774,5887),(30775,5887),(30776,5887),(30777,5887),(30778,5887),(30779,5887),(30780,5887),(30781,5887),(30782,5887),(30783,5887),(30784,5887),(30785,5888),(30786,5888),(30787,5888),(30788,5888),(30789,5888),(30790,5888),(30791,5888),(30792,5888),(30793,5888),(30794,5888),(30795,5888),(30796,5889),(30797,5889),(30798,5889),(30799,5889),(30800,5889),(30801,5889),(30802,5889),(30803,5889),(30804,5889),(30805,5889),(30806,5889),(30807,5890),(30808,5890),(30809,5890),(30810,5890),(30811,5890),(30812,5890),(30813,5890),(30814,5890),(30815,5890),(30816,5890),(30817,5890),(30818,5891),(30819,5891),(30820,5891),(30821,5891),(30822,5891),(30823,5891),(30824,5891),(30825,5891),(30826,5891),(30827,5891),(30828,5891),(30829,5892),(30830,5892),(30831,5892),(30832,5892),(30833,5892),(30834,5892),(30835,5892),(30836,5892),(30837,5892),(30838,5892),(30839,5892),(30840,5893),(30841,5893),(30842,5893),(30843,5893),(30844,5893),(30845,5893),(30846,5893),(30847,5893),(30848,5893),(30849,5893),(30850,5893),(30851,5894),(30852,5894),(30853,5894),(30854,5894),(30855,5894),(30856,5894),(30857,5894),(30858,5894),(30859,5894),(30860,5894),(30861,5894),(30862,5895),(30863,5895),(30864,5895),(30865,5895),(30866,5895),(30867,5895),(30868,5895),(30869,5895),(30870,5895),(30871,5895),(30872,5895),(30873,5896),(30874,5896),(30875,5896),(30876,5896),(30877,5896),(30878,5896),(30879,5896),(30880,5896),(30881,5896),(30882,5896),(30883,5896),(30884,5897),(30885,5897),(30886,5897),(30887,5897),(30888,5897),(30889,5897),(30890,5897),(30891,5897),(30892,5897),(30893,5897),(30894,5897),(30895,5898),(30896,5898),(30897,5898),(30898,5898),(30899,5898),(30900,5898),(30901,5898),(30902,5898),(30903,5898),(30904,5898),(30905,5898),(30906,5899),(30907,5899),(30908,5899),(30909,5899),(30910,5899),(30911,5899),(30912,5899),(30913,5899),(30914,5899),(30915,5899),(30916,5899),(30917,5900),(30918,5900),(30919,5900),(30920,5900),(30921,5900),(30922,5900),(30923,5900),(30924,5900),(30925,5900),(30926,5900),(30927,5900),(30928,5901),(30929,5901),(30930,5901),(30931,5901),(30932,5901),(30933,5901),(30934,5901),(30935,5901),(30936,5901),(30937,5901),(30938,5901),(30939,5902),(30940,5902),(30941,5902),(30942,5902),(30943,5902),(30944,5902),(30945,5902),(30946,5902),(30947,5902),(30948,5902),(30949,5902),(30950,5903),(30951,5903),(30952,5903),(30953,5903),(30954,5903),(30955,5903),(30956,5903),(30957,5903),(30958,5903),(30959,5903),(30960,5903),(30961,5904),(30962,5904),(30963,5904),(30964,5904),(30965,5904),(30966,5904),(30967,5904),(30968,5904),(30969,5904),(30970,5904),(30971,5904),(30972,5905),(30973,5905),(30974,5905),(30975,5905),(30976,5905),(30977,5905),(30978,5905),(30979,5905),(30980,5905),(30981,5905),(30982,5905),(30983,5906),(30984,5906),(30985,5906),(30986,5906),(30987,5906),(30988,5906),(30989,5906),(30990,5906),(30991,5906),(30992,5906),(30993,5906),(30994,5907),(30995,5907),(30996,5907),(30997,5907),(30998,5907),(30999,5907),(31000,5907),(31001,5907),(31002,5907),(31003,5907),(31004,5907),(31005,5908),(31006,5908),(31007,5908),(31008,5908),(31009,5908),(31010,5908),(31011,5908),(31012,5908),(31013,5908),(31014,5908),(31015,5908),(31016,5909),(31017,5909),(31018,5909),(31019,5909),(31020,5909),(31021,5909),(31022,5909),(31023,5909),(31024,5909),(31025,5909),(31026,5909),(31027,5910),(31028,5910),(31029,5910),(31030,5910),(31031,5910),(31032,5910),(31033,5910),(31034,5910),(31035,5910),(31036,5910),(31037,5910),(31038,5911),(31039,5911),(31040,5911),(31041,5911),(31042,5911),(31043,5911),(31044,5911),(31045,5911),(31046,5911),(31047,5911),(31048,5911),(31049,5912),(31050,5912),(31051,5912),(31052,5912),(31053,5912),(31054,5912),(31055,5912),(31056,5912),(31057,5912),(31058,5912),(31059,5912),(31060,5913),(31061,5913),(31062,5913),(31063,5913),(31064,5913),(31065,5913),(31066,5913),(31067,5913),(31068,5913),(31069,5913),(31070,5913),(31071,5914),(31072,5914),(31073,5914),(31074,5914),(31075,5914),(31076,5914),(31077,5914),(31078,5914),(31079,5914),(31080,5914),(31081,5914),(31082,5915),(31083,5915),(31084,5915),(31085,5915),(31086,5915),(31087,5915),(31088,5915),(31089,5915),(31090,5915),(31091,5915),(31092,5915),(31093,5916),(31094,5916),(31095,5916),(31096,5916),(31097,5916),(31098,5916),(31099,5916),(31100,5916),(31101,5916),(31102,5916),(31103,5916),(31104,5917),(31105,5917),(31106,5917),(31107,5917),(31108,5917),(31109,5917),(31110,5917),(31111,5917),(31112,5917),(31113,5917),(31114,5917),(31115,5918),(31116,5918),(31117,5918),(31118,5918),(31119,5918),(31120,5918),(31121,5918),(31122,5918),(31123,5918),(31124,5918),(31125,5918),(31126,5919),(31127,5919),(31128,5919),(31129,5919),(31130,5919),(31131,5919),(31132,5919),(31133,5919),(31134,5919),(31135,5919),(31136,5919),(31137,5920),(31138,5920),(31139,5920),(31140,5920),(31141,5920),(31142,5920),(31143,5920),(31144,5920),(31145,5920),(31146,5920),(31147,5920),(31148,5921),(31149,5921),(31150,5921),(31151,5921),(31152,5921),(31153,5921),(31154,5921),(31155,5921),(31156,5921),(31157,5921),(31158,5921),(31159,5922),(31160,5922),(31161,5922),(31162,5922),(31163,5922),(31164,5922),(31165,5922),(31166,5922),(31167,5922),(31168,5922),(31169,5922),(31170,5923),(31171,5923),(31172,5923),(31173,5923),(31174,5923),(31175,5923),(31176,5923),(31177,5923),(31178,5923),(31179,5923),(31180,5923),(31181,5924),(31182,5924),(31183,5924),(31184,5924),(31185,5924),(31186,5924),(31187,5924),(31188,5924),(31189,5924),(31190,5924),(31191,5924),(31192,5925),(31193,5925),(31194,5925),(31195,5925),(31196,5925),(31197,5925),(31198,5925),(31199,5925),(31200,5925),(31201,5925),(31202,5925),(31203,5926),(31204,5926),(31205,5926),(31206,5926),(31207,5926),(31208,5926),(31209,5926),(31210,5926),(31211,5926),(31212,5926),(31213,5926),(31214,5927),(31215,5927),(31216,5927),(31217,5927),(31218,5927),(31219,5927),(31220,5927),(31221,5927),(31222,5927),(31223,5927),(31224,5927),(31225,5928),(31226,5928),(31227,5928),(31228,5928),(31229,5928),(31230,5928),(31231,5928),(31232,5928),(31233,5928),(31234,5928),(31235,5928),(31236,5929),(31237,5929),(31238,5929),(31239,5929),(31240,5929),(31241,5929),(31242,5929),(31243,5929),(31244,5929),(31245,5929),(31246,5929),(31247,5930),(31248,5930),(31249,5930),(31250,5930),(31251,5930),(31252,5930),(31253,5930),(31254,5930),(31255,5930),(31256,5930),(31257,5930),(31258,5931),(31259,5931),(31260,5931),(31261,5931),(31262,5931),(31263,5931),(31264,5931),(31265,5931),(31266,5931),(31267,5931),(31268,5931),(31269,5932),(31270,5932),(31271,5932),(31272,5932),(31273,5932),(31274,5932),(31275,5932),(31276,5932),(31277,5932),(31278,5932),(31279,5932),(31280,5933),(31281,5933),(31282,5933),(31283,5933),(31284,5933),(31285,5933),(31286,5933),(31287,5933),(31288,5933),(31289,5933),(31290,5933),(31291,5934),(31292,5934),(31293,5934),(31294,5934),(31295,5934),(31296,5934),(31297,5934),(31298,5934),(31299,5934),(31300,5934),(31301,5934),(31302,5935),(31303,5935),(31304,5935),(31305,5935),(31306,5935),(31307,5935),(31308,5935),(31309,5935),(31310,5935),(31311,5935),(31312,5935),(31313,5936),(31314,5936),(31315,5936),(31316,5936),(31317,5936),(31318,5936),(31319,5936),(31320,5936),(31321,5936),(31322,5936),(31323,5936),(31324,5937),(31325,5937),(31326,5937),(31327,5937),(31328,5937),(31329,5937),(31330,5937),(31331,5937),(31332,5937),(31333,5937),(31334,5937),(31335,5938),(31336,5938),(31337,5938),(31338,5938),(31339,5938),(31340,5938),(31341,5938),(31342,5938),(31343,5938),(31344,5938),(31345,5938),(31346,5939),(31347,5939),(31348,5939),(31349,5939),(31350,5939),(31351,5939),(31352,5939),(31353,5939),(31354,5939),(31355,5939),(31356,5939),(31357,5940),(31358,5940),(31359,5940),(31360,5940),(31361,5940),(31362,5940),(31363,5940),(31364,5940),(31365,5940),(31366,5940),(31367,5940),(31368,5941),(31369,5941),(31370,5941),(31371,5941),(31372,5941),(31373,5941),(31374,5941),(31375,5941),(31376,5941),(31377,5941),(31378,5941),(31379,5942),(31380,5942),(31381,5942),(31382,5942),(31383,5942),(31384,5942),(31385,5942),(31386,5942),(31387,5942),(31388,5942),(31389,5942),(31390,5943),(31391,5943),(31392,5943),(31393,5943),(31394,5943),(31395,5943),(31396,5943),(31397,5943),(31398,5943),(31399,5943),(31400,5943),(31401,5944),(31402,5944),(31403,5944),(31404,5944),(31405,5944),(31406,5944),(31407,5944),(31408,5944),(31409,5944),(31410,5944),(31411,5944),(31412,5945),(31413,5945),(31414,5945),(31415,5945),(31416,5945),(31417,5945),(31418,5945),(31419,5945),(31420,5945),(31421,5945),(31422,5945),(31423,5946),(31424,5946),(31425,5946),(31426,5946),(31427,5946),(31428,5946),(31429,5946),(31430,5946),(31431,5946),(31432,5946),(31433,5946),(31434,5947),(31435,5947),(31436,5947),(31437,5947),(31438,5947),(31439,5947),(31440,5947),(31441,5947),(31442,5947),(31443,5947),(31444,5947),(31445,5948),(31446,5948),(31447,5948),(31448,5948),(31449,5948),(31450,5948),(31451,5948),(31452,5948),(31453,5948),(31454,5948),(31455,5948),(31456,5949),(31457,5949),(31458,5949),(31459,5949),(31460,5949),(31461,5949),(31462,5949),(31463,5949),(31464,5949),(31465,5949),(31466,5949),(31467,5950),(31468,5950),(31469,5950),(31470,5950),(31471,5950),(31472,5950),(31473,5950),(31474,5950),(31475,5950),(31476,5950),(31477,5950),(31478,5951),(31479,5951),(31480,5951),(31481,5951),(31482,5951),(31483,5951),(31484,5951),(31485,5951),(31486,5951),(31487,5951),(31488,5951),(31489,5952),(31490,5952),(31491,5952),(31492,5952),(31493,5952),(31494,5952),(31495,5952),(31496,5952),(31497,5952),(31498,5952),(31499,5952),(31500,5953),(31501,5953),(31502,5953),(31503,5953),(31504,5953),(31505,5953),(31506,5953),(31507,5953),(31508,5953),(31509,5953),(31510,5953),(31511,5954),(31512,5954),(31513,5954),(31514,5954),(31515,5954),(31516,5954),(31517,5954),(31518,5954),(31519,5954),(31520,5954),(31521,5954),(31522,5955),(31523,5955),(31524,5955),(31525,5955),(31526,5955),(31527,5955),(31528,5955),(31529,5955),(31530,5955),(31531,5955),(31532,5955),(31533,5956),(31534,5956),(31535,5956),(31536,5956),(31537,5956),(31538,5956),(31539,5956),(31540,5956),(31541,5956),(31542,5956),(31543,5956),(31544,5957),(31545,5957),(31546,5957),(31547,5957),(31548,5957),(31549,5957),(31550,5957),(31551,5957),(31552,5957),(31553,5957),(31554,5957),(31555,5958),(31556,5958),(31557,5958),(31558,5958),(31559,5958),(31560,5958),(31561,5958),(31562,5958),(31563,5958),(31564,5958),(31565,5958),(31566,5959),(31567,5959),(31568,5959),(31569,5959),(31570,5959),(31571,5959),(31572,5959),(31573,5959),(31574,5959),(31575,5959),(31576,5959),(31577,5960),(31578,5960),(31579,5960),(31580,5960),(31581,5960),(31582,5960),(31583,5960),(31584,5960),(31585,5960),(31586,5960),(31587,5960),(31588,5961),(31589,5961),(31590,5961),(31591,5961),(31592,5961),(31593,5961),(31594,5961),(31595,5961),(31596,5961),(31597,5961),(31598,5961),(31599,5962),(31600,5962),(31601,5962),(31602,5962),(31603,5962),(31604,5962),(31605,5962),(31606,5962),(31607,5962),(31608,5962),(31609,5962),(31610,5963),(31611,5963),(31612,5963),(31613,5963),(31614,5963),(31615,5963),(31616,5963),(31617,5963),(31618,5963),(31619,5963),(31620,5963),(31621,5964),(31622,5964),(31623,5964),(31624,5964),(31625,5964),(31626,5964),(31627,5964),(31628,5964),(31629,5964),(31630,5964),(31631,5964),(31632,5965),(31633,5965),(31634,5965),(31635,5965),(31636,5965),(31637,5965),(31638,5965),(31639,5965),(31640,5965),(31641,5965),(31642,5965),(31643,5966),(31644,5966),(31645,5966),(31646,5966),(31647,5966),(31648,5966),(31649,5966),(31650,5966),(31651,5966),(31652,5966),(31653,5966),(31654,5967),(31655,5967),(31656,5967),(31657,5967),(31658,5967),(31659,5967),(31660,5967),(31661,5967),(31662,5967),(31663,5967),(31664,5967),(31665,5968),(31666,5968),(31667,5968),(31668,5968),(31669,5968),(31670,5968),(31671,5968),(31672,5968),(31673,5968),(31674,5968),(31675,5968),(31676,5969),(31677,5969),(31678,5969),(31679,5969),(31680,5969),(31681,5969),(31682,5969),(31683,5969),(31684,5969),(31685,5969),(31686,5969),(31687,5970),(31688,5970),(31689,5970),(31690,5970),(31691,5970),(31692,5970),(31693,5970),(31694,5970),(31695,5970),(31696,5970),(31697,5970),(31698,5971),(31699,5971),(31700,5971),(31701,5971),(31702,5971),(31703,5971),(31704,5971),(31705,5971),(31706,5971),(31707,5971),(31708,5971),(31709,5972),(31710,5972),(31711,5972),(31712,5972),(31713,5972),(31714,5972),(31715,5972),(31716,5972),(31717,5972),(31718,5972),(31719,5972),(31720,5973),(31721,5973),(31722,5973),(31723,5973),(31724,5973),(31725,5973),(31726,5973),(31727,5973),(31728,5973),(31729,5973),(31730,5973),(31731,5974),(31732,5974),(31733,5974),(31734,5974),(31735,5974),(31736,5974),(31737,5974),(31738,5974),(31739,5974),(31740,5974),(31741,5974),(31742,5975),(31743,5975),(31744,5975),(31745,5975),(31746,5975),(31747,5975),(31748,5975),(31749,5975),(31750,5975),(31751,5975),(31752,5975),(31753,5976),(31754,5976),(31755,5976),(31756,5976),(31757,5976),(31758,5976),(31759,5976),(31760,5976),(31761,5976),(31762,5976),(31763,5976),(31764,5977),(31765,5977),(31766,5977),(31767,5977),(31768,5977),(31769,5977),(31770,5977),(31771,5977),(31772,5977),(31773,5977),(31774,5977),(31775,5978),(31776,5978),(31777,5978),(31778,5978),(31779,5978),(31780,5978),(31781,5978),(31782,5978),(31783,5978),(31784,5978),(31785,5978),(31786,5979),(31787,5979),(31788,5979),(31789,5979),(31790,5979),(31791,5979),(31792,5979),(31793,5979),(31794,5979),(31795,5979),(31796,5979),(31797,5980),(31798,5980),(31799,5980),(31800,5980),(31801,5980),(31802,5980),(31803,5980),(31804,5980),(31805,5980),(31806,5980),(31807,5980),(31808,5981),(31809,5981),(31810,5981),(31811,5981),(31812,5981),(31813,5981),(31814,5981),(31815,5981),(31816,5981),(31817,5981),(31818,5981),(31819,5982),(31820,5982),(31821,5982),(31822,5982),(31823,5982),(31824,5982),(31825,5982),(31826,5982),(31827,5982),(31828,5982),(31829,5982),(31830,5983),(31831,5983),(31832,5983),(31833,5983),(31834,5983),(31835,5983),(31836,5983),(31837,5983),(31838,5983),(31839,5983),(31840,5983),(31841,5984),(31842,5984),(31843,5984),(31844,5984),(31845,5984),(31846,5984),(31847,5984),(31848,5984),(31849,5984),(31850,5984),(31851,5984),(31852,5985),(31853,5985),(31854,5985),(31855,5985),(31856,5985),(31857,5985),(31858,5985),(31859,5985),(31860,5985),(31861,5985),(31862,5985),(31863,5986),(31864,5986),(31865,5986),(31866,5986),(31867,5986),(31868,5986),(31869,5986),(31870,5986),(31871,5986),(31872,5986),(31873,5986),(31874,5987),(31875,5987),(31876,5987),(31877,5987),(31878,5987),(31879,5987),(31880,5987),(31881,5987),(31882,5987),(31883,5987),(31884,5987),(31885,5988),(31886,5988),(31887,5988),(31888,5988),(31889,5988),(31890,5988),(31891,5988),(31892,5988),(31893,5988),(31894,5988),(31895,5988),(31896,5989),(31897,5989),(31898,5989),(31899,5989),(31900,5989),(31901,5989),(31902,5989),(31903,5989),(31904,5989),(31905,5989),(31906,5989),(31907,5990),(31908,5990),(31909,5990),(31910,5990),(31911,5990),(31912,5990),(31913,5990),(31914,5990),(31915,5990),(31916,5990),(31917,5990),(31918,5991),(31919,5991),(31920,5991),(31921,5991),(31922,5991),(31923,5991),(31924,5991),(31925,5991),(31926,5991),(31927,5991),(31928,5991),(31929,5992),(31930,5992),(31931,5992),(31932,5992),(31933,5992),(31934,5992),(31935,5992),(31936,5992),(31937,5992),(31938,5992),(31939,5992),(31940,5993),(31941,5993),(31942,5993),(31943,5993),(31944,5993),(31945,5993),(31946,5993),(31947,5993),(31948,5993),(31949,5993),(31950,5993),(31951,5994),(31952,5994),(31953,5994),(31954,5994),(31955,5994),(31956,5994),(31957,5994),(31958,5994),(31959,5994),(31960,5994),(31961,5994),(31962,5995),(31963,5995),(31964,5995),(31965,5995),(31966,5995),(31967,5995),(31968,5995),(31969,5995),(31970,5995),(31971,5995),(31972,5995),(31973,5996),(31974,5996),(31975,5996),(31976,5996),(31977,5996),(31978,5996),(31979,5996),(31980,5996),(31981,5996),(31982,5996),(31983,5996),(31984,5997),(31985,5997),(31986,5997),(31987,5997),(31988,5997),(31989,5997),(31990,5997),(31991,5997),(31992,5997),(31993,5997),(31994,5997),(31995,5998),(31996,5998),(31997,5998),(31998,5998),(31999,5998),(32000,5998),(32001,5998),(32002,5998),(32003,5998),(32004,5998),(32005,5998),(32006,5999),(32007,5999),(32008,5999),(32009,5999),(32010,5999),(32011,5999),(32012,5999),(32013,5999),(32014,5999),(32015,5999),(32016,5999),(32017,6000),(32018,6000),(32019,6000),(32020,6000),(32021,6000),(32022,6000),(32023,6000),(32024,6000),(32025,6000),(32026,6000),(32027,6000),(32028,6001),(32029,6001),(32030,6001),(32031,6001),(32032,6001),(32033,6001),(32034,6001),(32035,6001),(32036,6001),(32037,6001),(32038,6001),(32039,6002),(32040,6002),(32041,6002),(32042,6002),(32043,6002),(32044,6002),(32045,6002),(32046,6002),(32047,6002),(32048,6002),(32049,6002),(32050,6003),(32051,6003),(32052,6003),(32053,6003),(32054,6003),(32055,6003),(32056,6003),(32057,6003),(32058,6003),(32059,6003),(32060,6003),(32061,6004),(32062,6004),(32063,6004),(32064,6004),(32065,6004),(32066,6004),(32067,6004),(32068,6004),(32069,6004),(32070,6004),(32071,6004),(32072,6005),(32073,6005),(32074,6005),(32075,6005),(32076,6005),(32077,6005),(32078,6005),(32079,6005),(32080,6005),(32081,6005),(32082,6005),(32083,6006),(32084,6006),(32085,6006),(32086,6006),(32087,6006),(32088,6006),(32089,6006),(32090,6006),(32091,6006),(32092,6006),(32093,6006),(32094,6007),(32095,6007),(32096,6007),(32097,6007),(32098,6007),(32099,6007),(32100,6007),(32101,6007),(32102,6007),(32103,6007),(32104,6007),(32105,6008),(32106,6008),(32107,6008),(32108,6008),(32109,6008),(32110,6008),(32111,6008),(32112,6008),(32113,6008),(32114,6008),(32115,6008),(32116,6009),(32117,6009),(32118,6009),(32119,6009),(32120,6009),(32121,6009),(32122,6009),(32123,6009),(32124,6009),(32125,6009),(32126,6009),(32127,6010),(32128,6010),(32129,6010),(32130,6010),(32131,6010),(32132,6010),(32133,6010),(32134,6010),(32135,6010),(32136,6010),(32137,6010),(32138,6011),(32139,6011),(32140,6011),(32141,6011),(32142,6011),(32143,6011),(32144,6011),(32145,6011),(32146,6011),(32147,6011),(32148,6011),(32149,6012),(32150,6012),(32151,6012),(32152,6012),(32153,6012),(32154,6012),(32155,6012),(32156,6012),(32157,6012),(32158,6012),(32159,6012),(32160,6013),(32161,6013),(32162,6013),(32163,6013),(32164,6013),(32165,6013),(32166,6013),(32167,6013),(32168,6013),(32169,6013),(32170,6013),(32171,6014),(32172,6014),(32173,6014),(32174,6014),(32175,6014),(32176,6014),(32177,6014),(32178,6014),(32179,6014),(32180,6014),(32181,6014),(32182,6015),(32183,6015),(32184,6015),(32185,6015),(32186,6015),(32187,6015),(32188,6015),(32189,6015),(32190,6015),(32191,6015),(32192,6015),(32193,6016),(32194,6016),(32195,6016),(32196,6016),(32197,6016),(32198,6016),(32199,6016),(32200,6016),(32201,6016),(32202,6016),(32203,6016),(32204,6017),(32205,6017),(32206,6017),(32207,6017),(32208,6017),(32209,6017),(32210,6017),(32211,6017),(32212,6017),(32213,6017),(32214,6017),(32215,6018),(32216,6018),(32217,6018),(32218,6018),(32219,6018),(32220,6018),(32221,6018),(32222,6018),(32223,6018),(32224,6018),(32225,6018),(32226,6019),(32227,6019),(32228,6019),(32229,6019),(32230,6019),(32231,6019),(32232,6019),(32233,6019),(32234,6019),(32235,6019),(32236,6019),(32237,6020),(32238,6020),(32239,6020),(32240,6020),(32241,6020),(32242,6020),(32243,6020),(32244,6020),(32245,6020),(32246,6020),(32247,6020),(32248,6021),(32249,6021),(32250,6021),(32251,6021),(32252,6021),(32253,6021),(32254,6021),(32255,6021),(32256,6021),(32257,6021),(32258,6021),(32259,6022),(32260,6022),(32261,6022),(32262,6022),(32263,6022),(32264,6022),(32265,6022),(32266,6022),(32267,6022),(32268,6022),(32269,6022),(32270,6023),(32271,6023),(32272,6023),(32273,6023),(32274,6023),(32275,6023),(32276,6023),(32277,6023),(32278,6023),(32279,6023),(32280,6023),(32281,6024),(32282,6024),(32283,6024),(32284,6024),(32285,6024),(32286,6024),(32287,6024),(32288,6024),(32289,6024),(32290,6024),(32291,6024),(32292,6025),(32293,6025),(32294,6025),(32295,6025),(32296,6025),(32297,6025),(32298,6025),(32299,6025),(32300,6025),(32301,6025),(32302,6025),(32303,6026),(32304,6026),(32305,6026),(32306,6026),(32307,6026),(32308,6026),(32309,6026),(32310,6026),(32311,6026),(32312,6026),(32313,6026),(32314,6027),(32315,6027),(32316,6027),(32317,6027),(32318,6027),(32319,6027),(32320,6027),(32321,6027),(32322,6027),(32323,6027),(32324,6027),(32325,6028),(32326,6028),(32327,6028),(32328,6028),(32329,6028),(32330,6028),(32331,6028),(32332,6028),(32333,6028),(32334,6028),(32335,6028),(32336,6029),(32337,6029),(32338,6029),(32339,6029),(32340,6029),(32341,6029),(32342,6029),(32343,6029),(32344,6029),(32345,6029),(32346,6029),(32347,6030),(32348,6030),(32349,6030),(32350,6030),(32351,6030),(32352,6030),(32353,6030),(32354,6030),(32355,6030),(32356,6030),(32357,6030),(32358,6031),(32359,6031),(32360,6031),(32361,6031),(32362,6031),(32363,6031),(32364,6031),(32365,6031),(32366,6031),(32367,6031),(32368,6031),(32369,6032),(32370,6032),(32371,6032),(32372,6032),(32373,6032),(32374,6032),(32375,6032),(32376,6032),(32377,6032),(32378,6032),(32379,6032),(32380,6033),(32381,6033),(32382,6033),(32383,6033),(32384,6033),(32385,6033),(32386,6033),(32387,6033),(32388,6033),(32389,6033),(32390,6033),(32391,6034),(32392,6034),(32393,6034),(32394,6034),(32395,6034),(32396,6034),(32397,6034),(32398,6034),(32399,6034),(32400,6034),(32401,6034),(32402,5761),(32403,5762),(32404,5763),(32405,5764),(32406,5765),(32407,5766),(32408,5767),(32409,5768),(32410,5769),(32411,5770),(32412,5771),(32413,5772),(32414,5773),(32415,5774),(32416,5775),(32417,5776),(32418,5777),(32419,5778),(32420,5779),(32421,5780),(32422,5781),(32423,5782),(32424,5783),(32425,5784),(32426,5785),(32427,5786),(32428,5787),(32429,5788),(32430,5789),(32431,5790),(32432,5791),(32433,5792),(32434,5793),(32435,5794),(32436,5795),(32437,5796),(32438,5797),(32439,5798),(32440,5799),(32441,5800),(32442,5801),(32443,5802),(32444,5803),(32445,5804),(32446,5805),(32447,5806),(32448,5807),(32449,5808),(32450,5809),(32451,5810),(32452,5811),(32453,5812),(32454,5813),(32455,5814),(32456,5815),(32457,5816),(32458,5817),(32459,5818),(32460,5819),(32461,5820),(32462,5821),(32463,5822),(32464,5823),(32465,5824),(32466,5825),(32467,5826),(32468,5827),(32469,5828),(32470,5829),(32471,5830),(32472,5831),(32473,5832),(32474,5833),(32475,5834),(32476,5835),(32477,5836),(32478,5837),(32479,5838),(32480,5839),(32481,5840),(32482,5841),(32483,5842),(32484,5843),(32485,5844),(32486,5845),(32487,5846),(32488,5847),(32489,5848),(32490,5849),(32491,5850),(32492,5851),(32493,5852),(32494,5853),(32495,5854),(32496,5855),(32497,5856),(32498,5857),(32499,5858),(32500,5859),(32501,5860),(32502,5861),(32503,5862),(32504,5863),(32505,5864),(32506,5865),(32507,5866),(32508,5867),(32509,5868),(32510,5869),(32511,5870),(32512,5871),(32513,5872),(32514,5873),(32515,5874),(32516,5875),(32517,5876),(32518,5877),(32519,5878),(32520,5879),(32521,5880),(32522,5881),(32523,5882),(32524,5883),(32525,5884),(32526,5885),(32527,5886),(32528,5887),(32529,5888),(32530,5889),(32531,5890),(32532,5891),(32533,5892),(32534,5893),(32535,5894),(32536,5895),(32537,5896),(32538,5897),(32539,5898),(32540,5899),(32541,5900),(32542,5901),(32543,5902),(32544,5903),(32545,5904),(32546,5905),(32547,5906),(32548,5907),(32549,5908),(32550,5909),(32551,5910),(32552,5911),(32553,5912),(32554,5913),(32555,5914),(32556,5915),(32557,5916),(32558,5917),(32559,5918),(32560,5919),(32561,5920),(32562,5921),(32563,5922),(32564,5923),(32565,5924),(32566,5925),(32567,5926),(32568,5927),(32569,5928),(32570,5929),(32571,5930),(32572,5931),(32573,5932),(32574,5933),(32575,5934),(32576,5935),(32577,5936),(32578,5937),(32579,5938),(32580,5939),(32581,5940),(32582,5941),(32583,5942),(32584,5943),(32585,5944),(32586,5945),(32587,5946),(32588,5947),(32589,5948),(32590,5949),(32591,5950),(32592,5951),(32593,5952),(32594,5953),(32595,5954),(32596,5955),(32597,5956),(32598,5957),(32599,5958),(32600,5959),(32601,5960),(32602,5961),(32603,5962),(32604,5963),(32605,5964),(32606,5965),(32607,5966),(32608,5967),(32609,5968),(32610,5969),(32611,5970),(32612,5971),(32613,5972),(32614,5973),(32615,5974),(32616,5975),(32617,5976),(32618,5977),(32619,5978),(32620,5979),(32621,5980),(32622,5981),(32623,5982),(32624,5983),(32625,5984),(32626,5985),(32627,5986),(32628,5987),(32629,5988),(32630,5989),(32631,5990),(32632,5991),(32633,5992),(32634,5993),(32635,5994),(32636,5995),(32637,5996),(32638,5997),(32639,5998),(32640,5999),(32641,6000),(32642,6001),(32643,6002),(32644,6003),(32645,6004),(32646,6005),(32647,6006),(32648,6007),(32649,6008),(32650,6009),(32651,6010),(32652,6011),(32653,6012),(32654,6013),(32655,6014),(32656,6015),(32657,6016),(32658,6017),(32659,6018),(32660,6019),(32661,6020),(32662,6021),(32663,6022),(32664,6023),(32665,6024),(32666,6025),(32667,6026),(32668,6027),(32669,6028),(32670,6029),(32671,6030),(32672,6031),(32673,6032),(32674,6033),(32675,6034),(32676,6035),(32677,6035),(32678,6035),(32679,6035),(32680,6035),(32681,6036),(32682,6036),(32683,6036),(32684,6036),(32685,6036),(32686,6037),(32687,6037),(32688,6037),(32689,6037),(32690,6037),(32691,6038),(32692,6038),(32693,6038),(32694,6038),(32695,6038),(32696,6039),(32697,6039),(32698,6039),(32699,6039),(32700,6039),(32701,6040),(32702,6040),(32703,6040),(32704,6040),(32705,6040),(32706,6041),(32707,6041),(32708,6041),(32709,6041),(32710,6041),(32711,6042),(32712,6042),(32713,6042),(32714,6042),(32715,6042),(32716,6043),(32717,6043),(32718,6043),(32719,6043),(32720,6043),(32721,6044),(32722,6044),(32723,6044),(32724,6044),(32725,6044),(32726,6045),(32727,6045),(32728,6045),(32729,6045),(32730,6045),(32731,6046),(32732,6046),(32733,6046),(32734,6046),(32735,6046),(32736,6047),(32737,6047),(32738,6047),(32739,6047),(32740,6047),(32741,6048),(32742,6048),(32743,6048),(32744,6048),(32745,6048),(32746,6049),(32747,6049),(32748,6049),(32749,6049),(32750,6049),(32751,6050),(32752,6050),(32753,6050),(32754,6050),(32755,6050),(32756,6051),(32757,6051),(32758,6051),(32759,6051),(32760,6051),(32761,6052),(32762,6052),(32763,6052),(32764,6052),(32765,6052),(32766,6053),(32767,6053),(32768,6053),(32769,6053),(32770,6053),(32771,6054),(32772,6054),(32773,6054),(32774,6054),(32775,6054),(32776,6055),(32777,6055),(32778,6055),(32779,6055),(32780,6055),(32781,6056),(32782,6056),(32783,6056),(32784,6056),(32785,6056),(32786,6057),(32787,6057),(32788,6057),(32789,6057),(32790,6057),(32791,6058),(32792,6058),(32793,6058),(32794,6058),(32795,6058),(32796,6059),(32797,6059),(32798,6059),(32799,6059),(32800,6059),(32801,6060),(32802,6060),(32803,6060),(32804,6060),(32805,6060),(32806,6061),(32807,6061),(32808,6061),(32809,6061),(32810,6061),(32811,6062),(32812,6062),(32813,6062),(32814,6062),(32815,6062),(32816,6063),(32817,6063),(32818,6063),(32819,6063),(32820,6063),(32821,6064),(32822,6064),(32823,6064),(32824,6064),(32825,6064),(32826,6065),(32827,6065),(32828,6065),(32829,6065),(32830,6065),(32831,6066),(32832,6066),(32833,6066),(32834,6066),(32835,6066),(32836,6067),(32837,6067),(32838,6067),(32839,6067),(32840,6067),(32841,6068),(32842,6068),(32843,6068),(32844,6068),(32845,6068),(32846,6069),(32847,6069),(32848,6069),(32849,6069),(32850,6069),(32851,6070),(32852,6070),(32853,6070),(32854,6070),(32855,6070),(32856,6071),(32857,6071),(32858,6071),(32859,6071),(32860,6071),(32861,6072),(32862,6072),(32863,6072),(32864,6072),(32865,6072),(32866,6073),(32867,6073),(32868,6073),(32869,6073),(32870,6073),(32871,6074),(32872,6074),(32873,6074),(32874,6074),(32875,6074),(32876,6075),(32877,6075),(32878,6075),(32879,6075),(32880,6075),(32881,6076),(32882,6076),(32883,6076),(32884,6076),(32885,6076),(32886,6077),(32887,6077),(32888,6077),(32889,6077),(32890,6077),(32891,6078),(32892,6078),(32893,6078),(32894,6078),(32895,6078),(32896,6079),(32897,6079),(32898,6079),(32899,6079),(32900,6079),(32901,6080),(32902,6080),(32903,6080),(32904,6080),(32905,6080),(32906,6081),(32907,6081),(32908,6081),(32909,6081),(32910,6081),(32911,6082),(32912,6082),(32913,6082),(32914,6082),(32915,6082),(32916,6083),(32917,6083),(32918,6083),(32919,6083),(32920,6083),(32921,6084),(32922,6084),(32923,6084),(32924,6084),(32925,6084),(32926,6085),(32927,6085),(32928,6085),(32929,6085),(32930,6085),(32931,6086),(32932,6086),(32933,6086),(32934,6086),(32935,6086),(32936,6087),(32937,6087),(32938,6087),(32939,6087),(32940,6087),(32941,6088),(32942,6088),(32943,6088),(32944,6088),(32945,6088),(32946,6089),(32947,6089),(32948,6089),(32949,6089),(32950,6089),(32951,6090),(32952,6090),(32953,6090),(32954,6090),(32955,6090),(32956,6091),(32957,6091),(32958,6091),(32959,6091),(32960,6091),(32961,6092),(32962,6092),(32963,6092),(32964,6092),(32965,6092),(32966,6093),(32967,6093),(32968,6093),(32969,6093),(32970,6093),(32971,6094),(32972,6094),(32973,6094),(32974,6094),(32975,6094),(32976,6095),(32977,6095),(32978,6095),(32979,6095),(32980,6095),(32981,6096),(32982,6096),(32983,6096),(32984,6096),(32985,6096),(32986,6097),(32987,6097),(32988,6097),(32989,6097),(32990,6097),(32991,6098),(32992,6098),(32993,6098),(32994,6098),(32995,6098),(32996,6099),(32997,6099),(32998,6099),(32999,6099),(33000,6099),(33001,6100),(33002,6100),(33003,6100),(33004,6100),(33005,6100),(33006,6101),(33007,6101),(33008,6101),(33009,6101),(33010,6101),(33011,6102),(33012,6102),(33013,6102),(33014,6102),(33015,6102),(33016,6103),(33017,6103),(33018,6103),(33019,6103),(33020,6103),(33021,6104),(33022,6104),(33023,6104),(33024,6104),(33025,6104),(33026,6105),(33027,6105),(33028,6105),(33029,6105),(33030,6105),(33031,6106),(33032,6106),(33033,6106),(33034,6106),(33035,6106),(33036,6107),(33037,6107),(33038,6107),(33039,6107),(33040,6107),(33041,6108),(33042,6108),(33043,6108),(33044,6108),(33045,6108),(33046,6109),(33047,6109),(33048,6109),(33049,6109),(33050,6109),(33051,6110),(33052,6110),(33053,6110),(33054,6110),(33055,6110),(33056,6111),(33057,6111),(33058,6111),(33059,6111),(33060,6111),(33061,6112),(33062,6112),(33063,6112),(33064,6112),(33065,6112),(33066,6113),(33067,6113),(33068,6113),(33069,6113),(33070,6113),(33071,6114),(33072,6114),(33073,6114),(33074,6114),(33075,6114),(33076,6115),(33077,6115),(33078,6115),(33079,6115),(33080,6115),(33081,6116),(33082,6116),(33083,6116),(33084,6116),(33085,6116),(33086,6117),(33087,6117),(33088,6117),(33089,6117),(33090,6117),(33091,6118),(33092,6118),(33093,6118),(33094,6118),(33095,6118),(33096,6119),(33097,6119),(33098,6119),(33099,6119),(33100,6119),(33101,6120),(33102,6120),(33103,6120),(33104,6120),(33105,6120),(33106,6121),(33107,6121),(33108,6121),(33109,6121),(33110,6121),(33111,6122),(33112,6122),(33113,6122),(33114,6122),(33115,6122),(33116,6123),(33117,6123),(33118,6123),(33119,6123),(33120,6123),(33121,6124),(33122,6124),(33123,6124),(33124,6124),(33125,6124),(33126,6125),(33127,6125),(33128,6125),(33129,6125),(33130,6125),(33131,6126),(33132,6126),(33133,6126),(33134,6126),(33135,6126),(33136,6127),(33137,6127),(33138,6127),(33139,6127),(33140,6127),(33141,6128),(33142,6128),(33143,6128),(33144,6128),(33145,6128),(33146,6129),(33147,6129),(33148,6129),(33149,6129),(33150,6129),(33151,6130),(33152,6130),(33153,6130),(33154,6130),(33155,6130),(33156,6131),(33157,6131),(33158,6131),(33159,6131),(33160,6131),(33161,6132),(33162,6132),(33163,6132),(33164,6132),(33165,6132),(33166,6133),(33167,6133),(33168,6133),(33169,6133),(33170,6133),(33171,6134),(33172,6134),(33173,6134),(33174,6134),(33175,6134),(33176,6135),(33177,6135),(33178,6135),(33179,6135),(33180,6135),(33181,6136),(33182,6136),(33183,6136),(33184,6136),(33185,6136),(33186,6137),(33187,6137),(33188,6137),(33189,6137),(33190,6137),(33191,6138),(33192,6138),(33193,6138),(33194,6138),(33195,6138),(33196,6139),(33197,6139),(33198,6139),(33199,6139),(33200,6139),(33201,6140),(33202,6140),(33203,6140),(33204,6140),(33205,6140),(33206,6141),(33207,6141),(33208,6141),(33209,6141),(33210,6141),(33211,6142),(33212,6142),(33213,6142),(33214,6142),(33215,6142),(33216,6143),(33217,6143),(33218,6143),(33219,6143),(33220,6143),(33221,6144),(33222,6144),(33223,6144),(33224,6144),(33225,6144),(33226,6145),(33227,6145),(33228,6145),(33229,6145),(33230,6145),(33231,6146),(33232,6146),(33233,6146),(33234,6146),(33235,6146),(33236,6147),(33237,6147),(33238,6147),(33239,6147),(33240,6147),(33241,6148),(33242,6148),(33243,6148),(33244,6148),(33245,6148),(33246,6149),(33247,6149),(33248,6149),(33249,6149),(33250,6149),(33251,6150),(33252,6150),(33253,6150),(33254,6150),(33255,6150),(33256,6151),(33257,6151),(33258,6151),(33259,6151),(33260,6151),(33261,6152),(33262,6152),(33263,6152),(33264,6152),(33265,6152),(33266,6153),(33267,6153),(33268,6153),(33269,6153),(33270,6153),(33271,6154),(33272,6154),(33273,6154),(33274,6154),(33275,6154),(33276,6155),(33277,6155),(33278,6155),(33279,6155),(33280,6155),(33281,6156),(33282,6156),(33283,6156),(33284,6156),(33285,6156),(33286,6157),(33287,6157),(33288,6157),(33289,6157),(33290,6157),(33291,6158),(33292,6158),(33293,6158),(33294,6158),(33295,6158),(33296,6159),(33297,6159),(33298,6159),(33299,6159),(33300,6159),(33301,6160),(33302,6160),(33303,6160),(33304,6160),(33305,6160),(33306,6161),(33307,6161),(33308,6161),(33309,6161),(33310,6161),(33311,6162),(33312,6162),(33313,6162),(33314,6162),(33315,6162),(33316,6163),(33317,6163),(33318,6163),(33319,6163),(33320,6163),(33321,6164),(33322,6164),(33323,6164),(33324,6164),(33325,6164),(33326,6165),(33327,6165),(33328,6165),(33329,6165),(33330,6165),(33331,6166),(33332,6166),(33333,6166),(33334,6166),(33335,6166),(33336,6167),(33337,6167),(33338,6167),(33339,6167),(33340,6167),(33341,6168),(33342,6168),(33343,6168),(33344,6168),(33345,6168),(33346,6169),(33347,6169),(33348,6169),(33349,6169),(33350,6169),(33351,6170),(33352,6170),(33353,6170),(33354,6170),(33355,6170),(33356,6171),(33357,6171),(33358,6171),(33359,6171),(33360,6171),(33361,6172),(33362,6172),(33363,6172),(33364,6172),(33365,6172),(33366,6173),(33367,6173),(33368,6173),(33369,6173),(33370,6173),(33371,6174),(33372,6174),(33373,6174),(33374,6174),(33375,6174),(33376,6175),(33377,6175),(33378,6175),(33379,6175),(33380,6175),(33381,6176),(33382,6176),(33383,6176),(33384,6176),(33385,6176),(33386,6177),(33387,6177),(33388,6177),(33389,6177),(33390,6177),(33391,6178),(33392,6178),(33393,6178),(33394,6178),(33395,6178),(33396,6179),(33397,6179),(33398,6179),(33399,6179),(33400,6179),(33401,6180),(33402,6180),(33403,6180),(33404,6180),(33405,6180),(33406,6181),(33407,6181),(33408,6181),(33409,6181),(33410,6181),(33411,6182),(33412,6182),(33413,6182),(33414,6182),(33415,6182),(33416,6183),(33417,6183),(33418,6183),(33419,6183),(33420,6183),(33421,6184),(33422,6184),(33423,6184),(33424,6184),(33425,6184),(33426,6185),(33427,6185),(33428,6185),(33429,6185),(33430,6185),(33431,6186),(33432,6186),(33433,6186),(33434,6186),(33435,6186),(33436,6187),(33437,6187),(33438,6187),(33439,6187),(33440,6187),(33441,6188),(33442,6188),(33443,6188),(33444,6188),(33445,6188),(33446,6189),(33447,6189),(33448,6189),(33449,6189),(33450,6189),(33451,6190),(33452,6190),(33453,6190),(33454,6190),(33455,6190),(33456,6191),(33457,6191),(33458,6191),(33459,6191),(33460,6191),(33461,6192),(33462,6192),(33463,6192),(33464,6192),(33465,6192),(33466,6193),(33467,6193),(33468,6193),(33469,6193),(33470,6193),(33471,6194),(33472,6194),(33473,6194),(33474,6194),(33475,6194),(33476,6195),(33477,6195),(33478,6195),(33479,6195),(33480,6195),(33481,6196),(33482,6196),(33483,6196),(33484,6196),(33485,6196),(33486,6197),(33487,6197),(33488,6197),(33489,6197),(33490,6197),(33491,6198),(33492,6198),(33493,6198),(33494,6198),(33495,6198),(33496,6199),(33497,6199),(33498,6199),(33499,6199),(33500,6199),(33501,6200),(33502,6200),(33503,6200),(33504,6200),(33505,6200),(33506,6201),(33507,6201),(33508,6201),(33509,6201),(33510,6201),(33511,6202),(33512,6202),(33513,6202),(33514,6202),(33515,6202),(33516,6203),(33517,6203),(33518,6203),(33519,6203),(33520,6203),(33521,6204),(33522,6204),(33523,6204),(33524,6204),(33525,6204),(33526,6205),(33527,6205),(33528,6205),(33529,6205),(33530,6205),(33531,6206),(33532,6206),(33533,6206),(33534,6206),(33535,6206),(33536,6207),(33537,6207),(33538,6207),(33539,6207),(33540,6207),(33541,6208),(33542,6208),(33543,6208),(33544,6208),(33545,6208),(33546,6209),(33547,6209),(33548,6209),(33549,6209),(33550,6209),(33551,6210),(33552,6210),(33553,6210),(33554,6210),(33555,6210),(33556,6211),(33557,6211),(33558,6211),(33559,6211),(33560,6211),(33561,6212),(33562,6212),(33563,6212),(33564,6212),(33565,6212),(33566,6213),(33567,6213),(33568,6213),(33569,6213),(33570,6213),(33571,6214),(33572,6214),(33573,6214),(33574,6214),(33575,6214),(33576,6215),(33577,6215),(33578,6215),(33579,6215),(33580,6215),(33581,6216),(33582,6216),(33583,6216),(33584,6216),(33585,6216),(33586,6217),(33587,6217),(33588,6217),(33589,6217),(33590,6217),(33591,6218),(33592,6218),(33593,6218),(33594,6218),(33595,6218),(33596,6219),(33597,6219),(33598,6219),(33599,6219),(33600,6219),(33601,6220),(33602,6220),(33603,6220),(33604,6220),(33605,6220),(33606,6221),(33607,6221),(33608,6221),(33609,6221),(33610,6221),(33611,6222),(33612,6222),(33613,6222),(33614,6222),(33615,6222),(33616,6223),(33617,6223),(33618,6223),(33619,6223),(33620,6223),(33621,6224),(33622,6224),(33623,6224),(33624,6224),(33625,6224),(33626,6225),(33627,6225),(33628,6225),(33629,6225),(33630,6225),(33631,6226),(33632,6226),(33633,6226),(33634,6226),(33635,6226),(33636,6227),(33637,6227),(33638,6227),(33639,6227),(33640,6227),(33641,6228),(33642,6228),(33643,6228),(33644,6228),(33645,6228),(33646,6229),(33647,6229),(33648,6229),(33649,6229),(33650,6229),(33651,6230),(33652,6230),(33653,6230),(33654,6230),(33655,6230),(33656,6231),(33657,6231),(33658,6231),(33659,6231),(33660,6231),(33661,6232),(33662,6232),(33663,6232),(33664,6232),(33665,6232),(33666,6233),(33667,6233),(33668,6233),(33669,6233),(33670,6233),(33671,6234),(33672,6234),(33673,6234),(33674,6234),(33675,6234),(33676,6235),(33677,6235),(33678,6235),(33679,6235),(33680,6235),(33681,6236),(33682,6236),(33683,6236),(33684,6236),(33685,6236),(33686,6237),(33687,6237),(33688,6237),(33689,6237),(33690,6237),(33691,6238),(33692,6238),(33693,6238),(33694,6238),(33695,6238),(33696,6239),(33697,6239),(33698,6239),(33699,6239),(33700,6239),(33701,6240),(33702,6240),(33703,6240),(33704,6240),(33705,6240),(33706,6241),(33707,6241),(33708,6241),(33709,6241),(33710,6241),(33711,6242),(33712,6242),(33713,6242),(33714,6242),(33715,6242),(33716,6243),(33717,6243),(33718,6243),(33719,6243),(33720,6243),(33721,6244),(33722,6244),(33723,6244),(33724,6244),(33725,6244),(33726,6245),(33727,6245),(33728,6245),(33729,6245),(33730,6245),(33731,6246),(33732,6246),(33733,6246),(33734,6246),(33735,6246),(33736,6247),(33737,6247),(33738,6247),(33739,6247),(33740,6247),(33741,6248),(33742,6248),(33743,6248),(33744,6248),(33745,6248),(33746,6249),(33747,6249),(33748,6249),(33749,6249),(33750,6249),(33751,6250),(33752,6250),(33753,6250),(33754,6250),(33755,6250),(33756,6251),(33757,6251),(33758,6251),(33759,6251),(33760,6251),(33761,6252),(33762,6252),(33763,6252),(33764,6252),(33765,6252),(33766,6253),(33767,6253),(33768,6253),(33769,6253),(33770,6253),(33771,6254),(33772,6254),(33773,6254),(33774,6254),(33775,6254),(33776,6255),(33777,6255),(33778,6255),(33779,6255),(33780,6255),(33781,6256),(33782,6256),(33783,6256),(33784,6256),(33785,6256),(33786,6257),(33787,6257),(33788,6257),(33789,6257),(33790,6257),(33791,6258),(33792,6258),(33793,6258),(33794,6258),(33795,6258),(33796,6259),(33797,6259),(33798,6259),(33799,6259),(33800,6259),(33801,6260),(33802,6260),(33803,6260),(33804,6260),(33805,6260),(33806,6261),(33807,6261),(33808,6261),(33809,6261),(33810,6261),(33811,6262),(33812,6262),(33813,6262),(33814,6262),(33815,6262),(33816,6263),(33817,6263),(33818,6263),(33819,6263),(33820,6263),(33821,6264),(33822,6264),(33823,6264),(33824,6264),(33825,6264),(33826,6265),(33827,6265),(33828,6265),(33829,6265),(33830,6265),(33831,6266),(33832,6266),(33833,6266),(33834,6266),(33835,6266),(33836,6267),(33837,6267),(33838,6267),(33839,6267),(33840,6267),(33841,6268),(33842,6268),(33843,6268),(33844,6268),(33845,6268),(33846,6269),(33847,6269),(33848,6269),(33849,6269),(33850,6269),(33851,6270),(33852,6270),(33853,6270),(33854,6270),(33855,6270),(33856,6271),(33857,6271),(33858,6271),(33859,6271),(33860,6271),(33861,6272),(33862,6272),(33863,6272),(33864,6272),(33865,6272),(33866,6273),(33867,6273),(33868,6273),(33869,6273),(33870,6273),(33871,6274),(33872,6274),(33873,6274),(33874,6274),(33875,6274),(33876,6275),(33877,6275),(33878,6275),(33879,6275),(33880,6275),(33881,6276),(33882,6276),(33883,6276),(33884,6276),(33885,6276),(33886,6277),(33887,6277),(33888,6277),(33889,6277),(33890,6277),(33891,6278),(33892,6278),(33893,6278),(33894,6278),(33895,6278),(33896,6279),(33897,6279),(33898,6279),(33899,6279),(33900,6279),(33901,6280),(33902,6280),(33903,6280),(33904,6280),(33905,6280),(33906,6281),(33907,6281),(33908,6281),(33909,6281),(33910,6281),(33911,6282),(33912,6282),(33913,6282),(33914,6282),(33915,6282),(33916,6283),(33917,6283),(33918,6283),(33919,6283),(33920,6283),(33921,6284),(33922,6284),(33923,6284),(33924,6284),(33925,6284),(33926,6285),(33927,6285),(33928,6285),(33929,6285),(33930,6285),(33931,6286),(33932,6286),(33933,6286),(33934,6286),(33935,6286),(33936,6287),(33937,6287),(33938,6287),(33939,6287),(33940,6287),(33941,6288),(33942,6288),(33943,6288),(33944,6288),(33945,6288),(33946,6289),(33947,6289),(33948,6289),(33949,6289),(33950,6289),(33951,6290),(33952,6290),(33953,6290),(33954,6290),(33955,6290),(33956,6291),(33957,6291),(33958,6291),(33959,6291),(33960,6291),(33961,6292),(33962,6292),(33963,6292),(33964,6292),(33965,6292),(33966,6293),(33967,6293),(33968,6293),(33969,6293),(33970,6293),(33971,6294),(33972,6294),(33973,6294),(33974,6294),(33975,6294),(33976,6295),(33977,6295),(33978,6295),(33979,6295),(33980,6295),(33981,6296),(33982,6296),(33983,6296),(33984,6296),(33985,6296),(33986,6297),(33987,6297),(33988,6297),(33989,6297),(33990,6297),(33991,6298),(33992,6298),(33993,6298),(33994,6298),(33995,6298),(33996,6299),(33997,6299),(33998,6299),(33999,6299),(34000,6299),(34001,6300),(34002,6300),(34003,6300),(34004,6300),(34005,6300),(34006,6301),(34007,6301),(34008,6301),(34009,6301),(34010,6301),(34011,6302),(34012,6302),(34013,6302),(34014,6302),(34015,6302),(34016,6303),(34017,6303),(34018,6303),(34019,6303),(34020,6303),(34021,6304),(34022,6304),(34023,6304),(34024,6304),(34025,6304),(34026,6305),(34027,6305),(34028,6305),(34029,6305),(34030,6305),(34031,6306),(34032,6306),(34033,6306),(34034,6306),(34035,6306),(34036,6307),(34037,6307),(34038,6307),(34039,6307),(34040,6307),(34041,6308),(34042,6308),(34043,6308),(34044,6308),(34045,6308),(34046,6309),(34047,6309),(34048,6309),(34049,6309),(34050,6309),(34051,6310),(34052,6310),(34053,6310),(34054,6310),(34055,6310),(34056,6311),(34057,6311),(34058,6311),(34059,6311),(34060,6311),(34061,6312),(34062,6312),(34063,6312),(34064,6312),(34065,6312),(34066,6313),(34067,6313),(34068,6313),(34069,6313),(34070,6313),(34071,6314),(34072,6314),(34073,6314),(34074,6314),(34075,6314),(34076,6315),(34077,6315),(34078,6315),(34079,6315),(34080,6315),(34081,6316),(34082,6316),(34083,6316),(34084,6316),(34085,6316),(34086,6317),(34087,6317),(34088,6317),(34089,6317),(34090,6317),(34091,6318),(34092,6318),(34093,6318),(34094,6318),(34095,6318),(34096,6319),(34097,6319),(34098,6319),(34099,6319),(34100,6319),(34101,6320),(34102,6320),(34103,6320),(34104,6320),(34105,6320),(34106,6321),(34107,6321),(34108,6321),(34109,6321),(34110,6321),(34111,6322),(34112,6322),(34113,6322),(34114,6322),(34115,6322),(34116,6323),(34117,6323),(34118,6323),(34119,6323),(34120,6323),(34121,6324),(34122,6324),(34123,6324),(34124,6324),(34125,6324),(34126,6325),(34127,6325),(34128,6325),(34129,6325),(34130,6325),(34131,6326),(34132,6326),(34133,6326),(34134,6326),(34135,6326),(34136,6327),(34137,6327),(34138,6327),(34139,6327),(34140,6327),(34141,6328),(34142,6328),(34143,6328),(34144,6328),(34145,6328),(34146,6329),(34147,6329),(34148,6329),(34149,6329),(34150,6329),(34151,6330),(34152,6330),(34153,6330),(34154,6330),(34155,6330),(34156,6331),(34157,6331),(34158,6331),(34159,6331),(34160,6331),(34161,6332),(34162,6332),(34163,6332),(34164,6332),(34165,6332),(34166,6333),(34167,6333),(34168,6333),(34169,6333),(34170,6333),(34171,6334),(34172,6334),(34173,6334),(34174,6334),(34175,6334),(34176,6335),(34177,6335),(34178,6335),(34179,6335),(34180,6335),(34181,6336),(34182,6336),(34183,6336),(34184,6336),(34185,6336),(34186,6337),(34187,6337),(34188,6337),(34189,6337),(34190,6337),(34191,6338),(34192,6338),(34193,6338),(34194,6338),(34195,6338),(34196,6339),(34197,6339),(34198,6339),(34199,6339),(34200,6339),(34201,6340),(34202,6340),(34203,6340),(34204,6340),(34205,6340),(34206,6341),(34207,6341),(34208,6341),(34209,6341),(34210,6341),(34211,6342),(34212,6342),(34213,6342),(34214,6342),(34215,6342),(34216,6343),(34217,6343),(34218,6343),(34219,6343),(34220,6343),(34221,6344),(34222,6344),(34223,6344),(34224,6344),(34225,6344),(34226,6345),(34227,6345),(34228,6345),(34229,6345),(34230,6345),(34231,6035),(34232,6036),(34233,6037),(34234,6038),(34235,6039),(34236,6040),(34237,6041),(34238,6042),(34239,6043),(34240,6044),(34241,6045),(34242,6046),(34243,6047),(34244,6048),(34245,6049),(34246,6050),(34247,6051),(34248,6052),(34249,6053),(34250,6054),(34251,6055),(34252,6056),(34253,6057),(34254,6058),(34255,6059),(34256,6060),(34257,6061),(34258,6062),(34259,6063),(34260,6064),(34261,6065),(34262,6066),(34263,6067),(34264,6068),(34265,6069),(34266,6070),(34267,6071),(34268,6072),(34269,6073),(34270,6074),(34271,6075),(34272,6076),(34273,6077),(34274,6078),(34275,6079),(34276,6080),(34277,6081),(34278,6082),(34279,6083),(34280,6084),(34281,6085),(34282,6086),(34283,6087),(34284,6088),(34285,6089),(34286,6090),(34287,6091),(34288,6092),(34289,6093),(34290,6094),(34291,6095),(34292,6096),(34293,6097),(34294,6098),(34295,6099),(34296,6100),(34297,6101),(34298,6102),(34299,6103),(34300,6104),(34301,6105),(34302,6106),(34303,6107),(34304,6108),(34305,6109),(34306,6110),(34307,6111),(34308,6112),(34309,6113),(34310,6114),(34311,6115),(34312,6116),(34313,6117),(34314,6118),(34315,6119),(34316,6120),(34317,6121),(34318,6122),(34319,6123),(34320,6124),(34321,6125),(34322,6126),(34323,6127),(34324,6128),(34325,6129),(34326,6130),(34327,6131),(34328,6132),(34329,6133),(34330,6134),(34331,6135),(34332,6136),(34333,6137),(34334,6138),(34335,6139),(34336,6140),(34337,6141),(34338,6142),(34339,6143),(34340,6144),(34341,6145),(34342,6146),(34343,6147),(34344,6148),(34345,6149),(34346,6150),(34347,6151),(34348,6152),(34349,6153),(34350,6154),(34351,6155),(34352,6156),(34353,6157),(34354,6158),(34355,6159),(34356,6160),(34357,6161),(34358,6162),(34359,6163),(34360,6164),(34361,6165),(34362,6166),(34363,6167),(34364,6168),(34365,6169),(34366,6170),(34367,6171),(34368,6172),(34369,6173),(34370,6174),(34371,6175),(34372,6176),(34373,6177),(34374,6178),(34375,6179),(34376,6180),(34377,6181),(34378,6182),(34379,6183),(34380,6184),(34381,6185),(34382,6186),(34383,6187),(34384,6188),(34385,6189),(34386,6190),(34387,6191),(34388,6192),(34389,6193),(34390,6194),(34391,6195),(34392,6196),(34393,6197),(34394,6198),(34395,6199),(34396,6200),(34397,6201),(34398,6202),(34399,6203),(34400,6204),(34401,6205),(34402,6206),(34403,6207),(34404,6208),(34405,6209),(34406,6210),(34407,6211),(34408,6212),(34409,6213),(34410,6214),(34411,6215),(34412,6216),(34413,6217),(34414,6218),(34415,6219),(34416,6220),(34417,6221),(34418,6222),(34419,6223),(34420,6224),(34421,6225),(34422,6226),(34423,6227),(34424,6228),(34425,6229),(34426,6230),(34427,6231),(34428,6232),(34429,6233),(34430,6234),(34431,6235),(34432,6236),(34433,6237),(34434,6238),(34435,6239),(34436,6240),(34437,6241),(34438,6242),(34439,6243),(34440,6244),(34441,6245),(34442,6246),(34443,6247),(34444,6248),(34445,6249),(34446,6250),(34447,6251),(34448,6252),(34449,6253),(34450,6254),(34451,6255),(34452,6256),(34453,6257),(34454,6258),(34455,6259),(34456,6260),(34457,6261),(34458,6262),(34459,6263),(34460,6264),(34461,6265),(34462,6266),(34463,6267),(34464,6268),(34465,6269),(34466,6270),(34467,6271),(34468,6272),(34469,6273),(34470,6274),(34471,6275),(34472,6276),(34473,6277),(34474,6278),(34475,6279),(34476,6280),(34477,6281),(34478,6282),(34479,6283),(34480,6284),(34481,6285),(34482,6286),(34483,6287),(34484,6288),(34485,6289),(34486,6290),(34487,6291),(34488,6292),(34489,6293),(34490,6294),(34491,6295),(34492,6296),(34493,6297),(34494,6298),(34495,6299),(34496,6300),(34497,6301),(34498,6302),(34499,6303),(34500,6304),(34501,6305),(34502,6306),(34503,6307),(34504,6308),(34505,6309),(34506,6310),(34507,6311),(34508,6312),(34509,6313),(34510,6314),(34511,6315),(34512,6316),(34513,6317),(34514,6318),(34515,6319),(34516,6320),(34517,6321),(34518,6322),(34519,6323),(34520,6324),(34521,6325),(34522,6326),(34523,6327),(34524,6328),(34525,6329),(34526,6330),(34527,6331),(34528,6332),(34529,6333),(34530,6334),(34531,6335),(34532,6336),(34533,6337),(34534,6338),(34535,6339),(34536,6340),(34537,6341),(34538,6342),(34539,6343),(34540,6344),(34541,6345),(34542,6035),(34543,6035),(34544,6035),(34545,6035),(34546,6035),(34547,6035),(34548,6035),(34549,6035),(34550,6035),(34551,6035),(34552,6035),(34553,6035),(34554,6035),(34555,6035),(34556,6035),(34557,6035),(34558,6035),(34559,6036),(34560,6036),(34561,6036),(34562,6036),(34563,6036),(34564,6036),(34565,6036),(34566,6036),(34567,6036),(34568,6036),(34569,6036),(34570,6036),(34571,6036),(34572,6036),(34573,6036),(34574,6036),(34575,6036),(34576,6035),(34577,6035),(34578,6035),(34579,6346),(34580,6346),(34581,6346),(34582,6346),(34583,6346),(34584,6347),(34585,6347),(34586,6347),(34587,6347),(34588,6347),(34589,6348),(34590,6348),(34591,6348),(34592,6348),(34593,6348),(34594,6349),(34595,6349),(34596,6349),(34597,6349),(34598,6349),(34599,6350),(34600,6350),(34601,6350),(34602,6350),(34603,6350),(34604,6351),(34605,6351),(34606,6351),(34607,6351),(34608,6351),(34609,6352),(34610,6352),(34611,6352),(34612,6352),(34613,6352),(34614,6353),(34615,6353),(34616,6353),(34617,6353),(34618,6353),(34619,6354),(34620,6354),(34621,6354),(34622,6354),(34623,6354),(34624,6355),(34625,6355),(34626,6355),(34627,6355),(34628,6355),(34629,6356),(34630,6356),(34631,6356),(34632,6356),(34633,6356),(34634,6346),(34635,6347),(34636,6348),(34637,6349),(34638,6350),(34639,6351),(34640,6352),(34641,6353),(34642,6354),(34643,6355),(34644,6356),(34645,6357),(34646,6357),(34647,6357),(34648,6357),(34649,6357),(34650,6358),(34651,6358),(34652,6358),(34653,6358),(34654,6358),(34655,6359),(34656,6359),(34657,6359),(34658,6359),(34659,6359),(34660,6360),(34661,6360),(34662,6360),(34663,6360),(34664,6360),(34665,6361),(34666,6361),(34667,6361),(34668,6361),(34669,6361),(34670,6362),(34671,6362),(34672,6362),(34673,6362),(34674,6362),(34675,6363),(34676,6363),(34677,6363),(34678,6363),(34679,6363),(34680,6364),(34681,6364),(34682,6364),(34683,6364),(34684,6364),(34685,6365),(34686,6365),(34687,6365),(34688,6365),(34689,6365),(34690,6366),(34691,6366),(34692,6366),(34693,6366),(34694,6366),(34695,6367),(34696,6367),(34697,6367),(34698,6367),(34699,6367),(34700,6368),(34701,6368),(34702,6368),(34703,6368),(34704,6368),(34705,6369),(34706,6369),(34707,6369),(34708,6369),(34709,6369),(34710,6370),(34711,6370),(34712,6370),(34713,6370),(34714,6370),(34715,6371),(34716,6371),(34717,6371),(34718,6371),(34719,6371),(34720,6372),(34721,6372),(34722,6372),(34723,6372),(34724,6372),(34725,6373),(34726,6373),(34727,6373),(34728,6373),(34729,6373),(34730,6374),(34731,6374),(34732,6374),(34733,6374),(34734,6374),(34735,6375),(34736,6375),(34737,6375),(34738,6375),(34739,6375),(34740,6376),(34741,6376),(34742,6376),(34743,6376),(34744,6376),(34745,6377),(34746,6377),(34747,6377),(34748,6377),(34749,6377),(34750,6378),(34751,6378),(34752,6378),(34753,6378),(34754,6378),(34755,6379),(34756,6379),(34757,6379),(34758,6379),(34759,6379),(34760,6380),(34761,6380),(34762,6380),(34763,6380),(34764,6380),(34765,6381),(34766,6381),(34767,6381),(34768,6381),(34769,6381),(34770,6382),(34771,6382),(34772,6382),(34773,6382),(34774,6382),(34775,6383),(34776,6383),(34777,6383),(34778,6383),(34779,6383),(34780,6384),(34781,6384),(34782,6384),(34783,6384),(34784,6384),(34785,6385),(34786,6385),(34787,6385),(34788,6385),(34789,6385),(34790,6386),(34791,6386),(34792,6386),(34793,6386),(34794,6386),(34795,6387),(34796,6387),(34797,6387),(34798,6387),(34799,6387),(34800,6388),(34801,6388),(34802,6388),(34803,6388),(34804,6388),(34805,6389),(34806,6389),(34807,6389),(34808,6389),(34809,6389),(34810,6390),(34811,6390),(34812,6390),(34813,6390),(34814,6390),(34815,6391),(34816,6391),(34817,6391),(34818,6391),(34819,6391),(34820,6392),(34821,6392),(34822,6392),(34823,6392),(34824,6392),(34825,6393),(34826,6393),(34827,6393),(34828,6393),(34829,6393),(34830,6394),(34831,6394),(34832,6394),(34833,6394),(34834,6394),(34835,6395),(34836,6395),(34837,6395),(34838,6395),(34839,6395),(34840,6396),(34841,6396),(34842,6396),(34843,6396),(34844,6396),(34845,6397),(34846,6397),(34847,6397),(34848,6397),(34849,6397),(34850,6398),(34851,6398),(34852,6398),(34853,6398),(34854,6398),(34855,6399),(34856,6399),(34857,6399),(34858,6399),(34859,6399),(34860,6400),(34861,6400),(34862,6400),(34863,6400),(34864,6400),(34865,6401),(34866,6401),(34867,6401),(34868,6401),(34869,6401),(34870,6402),(34871,6402),(34872,6402),(34873,6402),(34874,6402),(34875,6403),(34876,6403),(34877,6403),(34878,6403),(34879,6403),(34880,6404),(34881,6404),(34882,6404),(34883,6404),(34884,6404),(34885,6405),(34886,6405),(34887,6405),(34888,6405),(34889,6405),(34890,6406),(34891,6406),(34892,6406),(34893,6406),(34894,6406),(34895,6407),(34896,6407),(34897,6407),(34898,6407),(34899,6407),(34900,6408),(34901,6408),(34902,6408),(34903,6408),(34904,6408),(34905,6409),(34906,6409),(34907,6409),(34908,6409),(34909,6409),(34910,6410),(34911,6410),(34912,6410),(34913,6410),(34914,6410),(34915,6411),(34916,6411),(34917,6411),(34918,6411),(34919,6411),(34920,6412),(34921,6412),(34922,6412),(34923,6412),(34924,6412),(34925,6413),(34926,6413),(34927,6413),(34928,6413),(34929,6413),(34930,6414),(34931,6414),(34932,6414),(34933,6414),(34934,6414),(34935,6415),(34936,6415),(34937,6415),(34938,6415),(34939,6415),(34940,6416),(34941,6416),(34942,6416),(34943,6416),(34944,6416),(34945,6417),(34946,6417),(34947,6417),(34948,6417),(34949,6417),(34950,6418),(34951,6418),(34952,6418),(34953,6418),(34954,6418),(34955,6419),(34956,6419),(34957,6419),(34958,6419),(34959,6419),(34960,6420),(34961,6420),(34962,6420),(34963,6420),(34964,6420),(34965,6421),(34966,6421),(34967,6421),(34968,6421),(34969,6421),(34970,6422),(34971,6422),(34972,6422),(34973,6422),(34974,6422),(34975,6423),(34976,6423),(34977,6423),(34978,6423),(34979,6423),(34980,6424),(34981,6424),(34982,6424),(34983,6424),(34984,6424),(34985,6425),(34986,6425),(34987,6425),(34988,6425),(34989,6425),(34990,6426),(34991,6426),(34992,6426),(34993,6426),(34994,6426),(34995,6427),(34996,6427),(34997,6427),(34998,6427),(34999,6427),(35000,6428),(35001,6428),(35002,6428),(35003,6428),(35004,6428),(35005,6429),(35006,6429),(35007,6429),(35008,6429),(35009,6429),(35010,6430),(35011,6430),(35012,6430),(35013,6430),(35014,6430),(35015,6431),(35016,6431),(35017,6431),(35018,6431),(35019,6431),(35020,6432),(35021,6432),(35022,6432),(35023,6432),(35024,6432),(35025,6433),(35026,6433),(35027,6433),(35028,6433),(35029,6433),(35030,6434),(35031,6434),(35032,6434),(35033,6434),(35034,6434),(35035,6435),(35036,6435),(35037,6435),(35038,6435),(35039,6435),(35040,6436),(35041,6436),(35042,6436),(35043,6436),(35044,6436),(35045,6437),(35046,6437),(35047,6437),(35048,6437),(35049,6437),(35050,6438),(35051,6438),(35052,6438),(35053,6438),(35054,6438),(35055,6439),(35056,6439),(35057,6439),(35058,6439),(35059,6439),(35060,6440),(35061,6440),(35062,6440),(35063,6440),(35064,6440),(35065,6441),(35066,6441),(35067,6441),(35068,6441),(35069,6441),(35070,6442),(35071,6442),(35072,6442),(35073,6442),(35074,6442),(35075,6443),(35076,6443),(35077,6443),(35078,6443),(35079,6443),(35080,6444),(35081,6444),(35082,6444),(35083,6444),(35084,6444),(35085,6445),(35086,6445),(35087,6445),(35088,6445),(35089,6445),(35090,6446),(35091,6446),(35092,6446),(35093,6446),(35094,6446),(35095,6447),(35096,6447),(35097,6447),(35098,6447),(35099,6447),(35100,6448),(35101,6448),(35102,6448),(35103,6448),(35104,6448),(35105,6449),(35106,6449),(35107,6449),(35108,6449),(35109,6449),(35110,6450),(35111,6450),(35112,6450),(35113,6450),(35114,6450),(35115,6451),(35116,6451),(35117,6451),(35118,6451),(35119,6451),(35120,6452),(35121,6452),(35122,6452),(35123,6452),(35124,6452),(35125,6453),(35126,6453),(35127,6453),(35128,6453),(35129,6453),(35130,6454),(35131,6454),(35132,6454),(35133,6454),(35134,6454),(35135,6455),(35136,6455),(35137,6455),(35138,6455),(35139,6455),(35140,6456),(35141,6456),(35142,6456),(35143,6456),(35144,6456),(35145,6457),(35146,6457),(35147,6457),(35148,6457),(35149,6457),(35150,6458),(35151,6458),(35152,6458),(35153,6458),(35154,6458),(35155,6459),(35156,6459),(35157,6459),(35158,6459),(35159,6459),(35160,6460),(35161,6460),(35162,6460),(35163,6460),(35164,6460),(35165,6461),(35166,6461),(35167,6461),(35168,6461),(35169,6461),(35170,6462),(35171,6462),(35172,6462),(35173,6462),(35174,6462),(35175,6463),(35176,6463),(35177,6463),(35178,6463),(35179,6463),(35180,6464),(35181,6464),(35182,6464),(35183,6464),(35184,6464),(35185,6465),(35186,6465),(35187,6465),(35188,6465),(35189,6465),(35190,6466),(35191,6466),(35192,6466),(35193,6466),(35194,6466),(35195,6467),(35196,6467),(35197,6467),(35198,6467),(35199,6467),(35200,6468),(35201,6468),(35202,6468),(35203,6468),(35204,6468),(35205,6469),(35206,6469),(35207,6469),(35208,6469),(35209,6469),(35210,6470),(35211,6470),(35212,6470),(35213,6470),(35214,6470),(35215,6471),(35216,6471),(35217,6471),(35218,6471),(35219,6471),(35220,6472),(35221,6472),(35222,6472),(35223,6472),(35224,6472),(35225,6473),(35226,6473),(35227,6473),(35228,6473),(35229,6473),(35230,6474),(35231,6474),(35232,6474),(35233,6474),(35234,6474),(35235,6475),(35236,6475),(35237,6475),(35238,6475),(35239,6475),(35240,6476),(35241,6476),(35242,6476),(35243,6476),(35244,6476),(35245,6477),(35246,6477),(35247,6477),(35248,6477),(35249,6477),(35250,6478),(35251,6478),(35252,6478),(35253,6478),(35254,6478),(35255,6479),(35256,6479),(35257,6479),(35258,6479),(35259,6479),(35260,6480),(35261,6480),(35262,6480),(35263,6480),(35264,6480),(35265,6481),(35266,6481),(35267,6481),(35268,6481),(35269,6481),(35270,6482),(35271,6482),(35272,6482),(35273,6482),(35274,6482),(35275,6483),(35276,6483),(35277,6483),(35278,6483),(35279,6483),(35280,6484),(35281,6484),(35282,6484),(35283,6484),(35284,6484),(35285,6485),(35286,6485),(35287,6485),(35288,6485),(35289,6485),(35290,6486),(35291,6486),(35292,6486),(35293,6486),(35294,6486),(35295,6487),(35296,6487),(35297,6487),(35298,6487),(35299,6487),(35300,6488),(35301,6488),(35302,6488),(35303,6488),(35304,6488),(35305,6489),(35306,6489),(35307,6489),(35308,6489),(35309,6489),(35310,6490),(35311,6490),(35312,6490),(35313,6490),(35314,6490),(35315,6491),(35316,6491),(35317,6491),(35318,6491),(35319,6491),(35320,6492),(35321,6492),(35322,6492),(35323,6492),(35324,6492),(35325,6493),(35326,6493),(35327,6493),(35328,6493),(35329,6493),(35330,6494),(35331,6494),(35332,6494),(35333,6494),(35334,6494),(35335,6495),(35336,6495),(35337,6495),(35338,6495),(35339,6495),(35340,6496),(35341,6496),(35342,6496),(35343,6496),(35344,6496),(35345,6497),(35346,6497),(35347,6497),(35348,6497),(35349,6497),(35350,6498),(35351,6498),(35352,6498),(35353,6498),(35354,6498),(35355,6499),(35356,6499),(35357,6499),(35358,6499),(35359,6499),(35360,6500),(35361,6500),(35362,6500),(35363,6500),(35364,6500),(35365,6501),(35366,6501),(35367,6501),(35368,6501),(35369,6501),(35370,6502),(35371,6502),(35372,6502),(35373,6502),(35374,6502),(35375,6503),(35376,6503),(35377,6503),(35378,6503),(35379,6503),(35380,6504),(35381,6504),(35382,6504),(35383,6504),(35384,6504),(35385,6505),(35386,6505),(35387,6505),(35388,6505),(35389,6505),(35390,6506),(35391,6506),(35392,6506),(35393,6506),(35394,6506),(35395,6507),(35396,6507),(35397,6507),(35398,6507),(35399,6507),(35400,6508),(35401,6508),(35402,6508),(35403,6508),(35404,6508),(35405,6509),(35406,6509),(35407,6509),(35408,6509),(35409,6509),(35410,6510),(35411,6510),(35412,6510),(35413,6510),(35414,6510),(35415,6511),(35416,6511),(35417,6511),(35418,6511),(35419,6511),(35420,6512),(35421,6512),(35422,6512),(35423,6512),(35424,6512),(35425,6513),(35426,6513),(35427,6513),(35428,6513),(35429,6513),(35430,6514),(35431,6514),(35432,6514),(35433,6514),(35434,6514),(35435,6515),(35436,6515),(35437,6515),(35438,6515),(35439,6515),(35440,6516),(35441,6516),(35442,6516),(35443,6516),(35444,6516),(35445,6517),(35446,6517),(35447,6517),(35448,6517),(35449,6517),(35450,6518),(35451,6518),(35452,6518),(35453,6518),(35454,6518),(35455,6519),(35456,6519),(35457,6519),(35458,6519),(35459,6519),(35460,6520),(35461,6520),(35462,6520),(35463,6520),(35464,6520),(35465,6521),(35466,6521),(35467,6521),(35468,6521),(35469,6521),(35470,6522),(35471,6522),(35472,6522),(35473,6522),(35474,6522),(35475,6523),(35476,6523),(35477,6523),(35478,6523),(35479,6523),(35480,6524),(35481,6524),(35482,6524),(35483,6524),(35484,6524),(35485,6525),(35486,6525),(35487,6525),(35488,6525),(35489,6525),(35490,6526),(35491,6526),(35492,6526),(35493,6526),(35494,6526),(35495,6527),(35496,6527),(35497,6527),(35498,6527),(35499,6527),(35500,6528),(35501,6528),(35502,6528),(35503,6528),(35504,6528),(35505,6529),(35506,6529),(35507,6529),(35508,6529),(35509,6529),(35510,6530),(35511,6530),(35512,6530),(35513,6530),(35514,6530),(35515,6531),(35516,6531),(35517,6531),(35518,6531),(35519,6531),(35520,6532),(35521,6532),(35522,6532),(35523,6532),(35524,6532),(35525,6533),(35526,6533),(35527,6533),(35528,6533),(35529,6533),(35530,6534),(35531,6534),(35532,6534),(35533,6534),(35534,6534),(35535,6535),(35536,6535),(35537,6535),(35538,6535),(35539,6535),(35540,6536),(35541,6536),(35542,6536),(35543,6536),(35544,6536),(35545,6537),(35546,6537),(35547,6537),(35548,6537),(35549,6537),(35550,6538),(35551,6538),(35552,6538),(35553,6538),(35554,6538),(35555,6539),(35556,6539),(35557,6539),(35558,6539),(35559,6539),(35560,6540),(35561,6540),(35562,6540),(35563,6540),(35564,6540),(35565,6541),(35566,6541),(35567,6541),(35568,6541),(35569,6541),(35570,6542),(35571,6542),(35572,6542),(35573,6542),(35574,6542),(35575,6543),(35576,6543),(35577,6543),(35578,6543),(35579,6543),(35580,6544),(35581,6544),(35582,6544),(35583,6544),(35584,6544),(35585,6545),(35586,6545),(35587,6545),(35588,6545),(35589,6545),(35590,6546),(35591,6546),(35592,6546),(35593,6546),(35594,6546),(35595,6547),(35596,6547),(35597,6547),(35598,6547),(35599,6547),(35600,6548),(35601,6548),(35602,6548),(35603,6548),(35604,6548),(35605,6549),(35606,6549),(35607,6549),(35608,6549),(35609,6549),(35610,6550),(35611,6550),(35612,6550),(35613,6550),(35614,6550),(35615,6551),(35616,6551),(35617,6551),(35618,6551),(35619,6551),(35620,6552),(35621,6552),(35622,6552),(35623,6552),(35624,6552),(35625,6553),(35626,6553),(35627,6553),(35628,6553),(35629,6553),(35630,6554),(35631,6554),(35632,6554),(35633,6554),(35634,6554),(35635,6555),(35636,6555),(35637,6555),(35638,6555),(35639,6555),(35640,6556),(35641,6556),(35642,6556),(35643,6556),(35644,6556),(35645,6557),(35646,6557),(35647,6557),(35648,6557),(35649,6557),(35650,6558),(35651,6558),(35652,6558),(35653,6558),(35654,6558),(35655,6559),(35656,6559),(35657,6559),(35658,6559),(35659,6559),(35660,6560),(35661,6560),(35662,6560),(35663,6560),(35664,6560),(35665,6561),(35666,6561),(35667,6561),(35668,6561),(35669,6561),(35670,6562),(35671,6562),(35672,6562),(35673,6562),(35674,6562),(35675,6563),(35676,6563),(35677,6563),(35678,6563),(35679,6563),(35680,6564),(35681,6564),(35682,6564),(35683,6564),(35684,6564),(35685,6565),(35686,6565),(35687,6565),(35688,6565),(35689,6565),(35690,6566),(35691,6566),(35692,6566),(35693,6566),(35694,6566),(35695,6567),(35696,6567),(35697,6567),(35698,6567),(35699,6567),(35700,6568),(35701,6568),(35702,6568),(35703,6568),(35704,6568),(35705,6569),(35706,6569),(35707,6569),(35708,6569),(35709,6569),(35710,6570),(35711,6570),(35712,6570),(35713,6570),(35714,6570),(35715,6571),(35716,6571),(35717,6571),(35718,6571),(35719,6571),(35720,6572),(35721,6572),(35722,6572),(35723,6572),(35724,6572),(35725,6357),(35726,6358),(35727,6359),(35728,6360),(35729,6361),(35730,6362),(35731,6363),(35732,6364),(35733,6365),(35734,6366),(35735,6367),(35736,6368),(35737,6369),(35738,6370),(35739,6371),(35740,6372),(35741,6373),(35742,6374),(35743,6375),(35744,6376),(35745,6377),(35746,6378),(35747,6379),(35748,6380),(35749,6381),(35750,6382),(35751,6383),(35752,6384),(35753,6385),(35754,6386),(35755,6387),(35756,6388),(35757,6389),(35758,6390),(35759,6391),(35760,6392),(35761,6393),(35762,6394),(35763,6395),(35764,6396),(35765,6397),(35766,6398),(35767,6399),(35768,6400),(35769,6401),(35770,6402),(35771,6403),(35772,6404),(35773,6405),(35774,6406),(35775,6407),(35776,6408),(35777,6409),(35778,6410),(35779,6411),(35780,6412),(35781,6413),(35782,6414),(35783,6415),(35784,6416),(35785,6417),(35786,6418),(35787,6419),(35788,6420),(35789,6421),(35790,6422),(35791,6423),(35792,6424),(35793,6425),(35794,6426),(35795,6427),(35796,6428),(35797,6429),(35798,6430),(35799,6431),(35800,6432),(35801,6433),(35802,6434),(35803,6435),(35804,6436),(35805,6437),(35806,6438),(35807,6439),(35808,6440),(35809,6441),(35810,6442),(35811,6443),(35812,6444),(35813,6445),(35814,6446),(35815,6447),(35816,6448),(35817,6449),(35818,6450),(35819,6451),(35820,6452),(35821,6453),(35822,6454),(35823,6455),(35824,6456),(35825,6457),(35826,6458),(35827,6459),(35828,6460),(35829,6461),(35830,6462),(35831,6463),(35832,6464),(35833,6465),(35834,6466),(35835,6467),(35836,6468),(35837,6469),(35838,6470),(35839,6471),(35840,6472),(35841,6473),(35842,6474),(35843,6475),(35844,6476),(35845,6477),(35846,6478),(35847,6479),(35848,6480),(35849,6481),(35850,6482),(35851,6483),(35852,6484),(35853,6485),(35854,6486),(35855,6487),(35856,6488),(35857,6489),(35858,6490),(35859,6491),(35860,6492),(35861,6493),(35862,6494),(35863,6495),(35864,6496),(35865,6497),(35866,6498),(35867,6499),(35868,6500),(35869,6501),(35870,6502),(35871,6503),(35872,6504),(35873,6505),(35874,6506),(35875,6507),(35876,6508),(35877,6509),(35878,6510),(35879,6511),(35880,6512),(35881,6513),(35882,6514),(35883,6515),(35884,6516),(35885,6517),(35886,6518),(35887,6519),(35888,6520),(35889,6521),(35890,6522),(35891,6523),(35892,6524),(35893,6525),(35894,6526),(35895,6527),(35896,6528),(35897,6529),(35898,6530),(35899,6531),(35900,6532),(35901,6533),(35902,6534),(35903,6535),(35904,6536),(35905,6537),(35906,6538),(35907,6539),(35908,6540),(35909,6541),(35910,6542),(35911,6543),(35912,6544),(35913,6545),(35914,6546),(35915,6547),(35916,6548),(35917,6549),(35918,6550),(35919,6551),(35920,6552),(35921,6553),(35922,6554),(35923,6555),(35924,6556),(35925,6557),(35926,6558),(35927,6559),(35928,6560),(35929,6561),(35930,6562),(35931,6563),(35932,6564),(35933,6565),(35934,6566),(35935,6567),(35936,6568),(35937,6569),(35938,6570),(35939,6571),(35940,6572);
/*!40000 ALTER TABLE `cataloginventory_stock_cl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cataloginventory_stock_item`
--

DROP TABLE IF EXISTS `cataloginventory_stock_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cataloginventory_stock_item` (
  `item_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Item ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `stock_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Stock ID',
  `qty` decimal(12,4) DEFAULT NULL COMMENT 'Qty',
  `min_qty` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Min Qty',
  `use_config_min_qty` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Use Config Min Qty',
  `is_qty_decimal` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Qty Decimal',
  `backorders` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Backorders',
  `use_config_backorders` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Use Config Backorders',
  `min_sale_qty` decimal(12,4) NOT NULL DEFAULT '1.0000' COMMENT 'Min Sale Qty',
  `use_config_min_sale_qty` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Use Config Min Sale Qty',
  `max_sale_qty` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Max Sale Qty',
  `use_config_max_sale_qty` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Use Config Max Sale Qty',
  `is_in_stock` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is In Stock',
  `low_stock_date` timestamp NULL DEFAULT NULL COMMENT 'Low Stock Date',
  `notify_stock_qty` decimal(12,4) DEFAULT NULL COMMENT 'Notify Stock Qty',
  `use_config_notify_stock_qty` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Use Config Notify Stock Qty',
  `manage_stock` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Manage Stock',
  `use_config_manage_stock` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Use Config Manage Stock',
  `stock_status_changed_auto` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Stock Status Changed Automatically',
  `use_config_qty_increments` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Use Config Qty Increments',
  `qty_increments` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty Increments',
  `use_config_enable_qty_inc` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Use Config Enable Qty Increments',
  `enable_qty_increments` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Enable Qty Increments',
  `is_decimal_divided` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Divided into Multiple Boxes for Shipping',
  `website_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID',
  PRIMARY KEY (`item_id`),
  UNIQUE KEY `CATALOGINVENTORY_STOCK_ITEM_PRODUCT_ID_STOCK_ID` (`product_id`,`stock_id`),
  KEY `CATALOGINVENTORY_STOCK_ITEM_WEBSITE_ID` (`website_id`),
  KEY `CATALOGINVENTORY_STOCK_ITEM_WEBSITE_ID_PRODUCT_ID` (`website_id`,`product_id`),
  KEY `CATALOGINVENTORY_STOCK_ITEM_STOCK_ID` (`stock_id`),
  CONSTRAINT `CATINV_STOCK_ITEM_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `CATINV_STOCK_ITEM_STOCK_ID_CATINV_STOCK_STOCK_ID` FOREIGN KEY (`stock_id`) REFERENCES `cataloginventory_stock` (`stock_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=7188 DEFAULT CHARSET=utf8mb3 COMMENT='Cataloginventory Stock Item';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cataloginventory_stock_item`
--

LOCK TABLES `cataloginventory_stock_item` WRITE;
/*!40000 ALTER TABLE `cataloginventory_stock_item` DISABLE KEYS */;
INSERT INTO `cataloginventory_stock_item` VALUES (6364,5760,1,10.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,1.0000,1,0,0,0),(6639,6035,1,472.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,1.0000,1,0,0,0),(6640,6036,1,438.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,1.0000,1,0,0,0),(6641,6037,1,402.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6642,6038,1,458.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6643,6039,1,474.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6644,6040,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6645,6041,1,50.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6646,6042,1,47.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6647,6043,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6648,6044,1,7.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6649,6045,1,11.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6650,6046,1,11.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6651,6047,1,17.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6652,6048,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6653,6049,1,16.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6654,6050,1,493.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6655,6051,1,496.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6656,6052,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6657,6053,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6658,6054,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6659,6055,1,482.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6660,6056,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6661,6057,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6662,6058,1,17.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6663,6059,1,17.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6664,6060,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6665,6061,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6666,6062,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6667,6063,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6668,6064,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6669,6065,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6670,6066,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6671,6067,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6672,6068,1,15.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6673,6069,1,16.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6674,6070,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6675,6071,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6676,6072,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6677,6073,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6678,6074,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6679,6075,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6680,6076,1,50.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6681,6077,1,50.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6682,6078,1,50.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6683,6079,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6684,6080,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6685,6081,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6686,6082,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6687,6083,1,17.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6688,6084,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6689,6085,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6690,6086,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6691,6087,1,15.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6692,6088,1,16.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6693,6089,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6694,6090,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6695,6091,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6696,6092,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6697,6093,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6698,6094,1,496.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6699,6095,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6700,6096,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6701,6097,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6702,6098,1,16.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6703,6099,1,17.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6704,6100,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6705,6101,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6706,6102,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6707,6103,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6708,6104,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6709,6105,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6710,6106,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6711,6107,1,17.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6712,6108,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6713,6109,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6714,6110,1,497.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6715,6111,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6716,6112,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6717,6113,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6718,6114,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6719,6115,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6720,6116,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6721,6117,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6722,6118,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6723,6119,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6724,6120,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6725,6121,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6726,6122,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6727,6123,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6728,6124,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6729,6125,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6730,6126,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6731,6127,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6732,6128,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6733,6129,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6734,6130,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6735,6131,1,478.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6736,6132,1,4.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6737,6133,1,478.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6738,6134,1,8.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6739,6135,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6740,6136,1,489.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6741,6137,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6742,6138,1,16.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6743,6139,1,9.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6744,6140,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6745,6141,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6746,6142,1,46.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6747,6143,1,49.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6748,6144,1,9.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6749,6145,1,9.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6750,6146,1,493.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6751,6147,1,17.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6752,6148,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6753,6149,1,8.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6754,6150,1,16.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6755,6151,1,7.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6756,6152,1,16.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6757,6153,1,493.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6758,6154,1,13.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6759,6155,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6760,6156,1,16.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6761,6157,1,15.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6762,6158,1,11.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6763,6159,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6764,6160,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6765,6161,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6766,6162,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6767,6163,1,497.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6768,6164,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6769,6165,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6770,6166,1,497.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6771,6167,1,497.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6772,6168,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6773,6169,1,17.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6774,6170,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6775,6171,1,7.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6776,6172,1,7.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6777,6173,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6778,6174,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6779,6175,1,6.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6780,6176,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6781,6177,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6782,6178,1,497.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6783,6179,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6784,6180,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6785,6181,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6786,6182,1,12.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6787,6183,1,49.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6788,6184,1,497.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6789,6185,1,496.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6790,6186,1,497.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6791,6187,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6792,6188,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6793,6189,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6794,6190,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6795,6191,1,496.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6796,6192,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6797,6193,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6798,6194,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6799,6195,1,7.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6800,6196,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6801,6197,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6802,6198,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6803,6199,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6804,6200,1,16.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6805,6201,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6806,6202,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6807,6203,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6808,6204,1,8.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6809,6205,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6810,6206,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6811,6207,1,487.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6812,6208,1,497.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6813,6209,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6814,6210,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6815,6211,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6816,6212,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6817,6213,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6818,6214,1,16.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6819,6215,1,6.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6820,6216,1,15.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6821,6217,1,40.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6822,6218,1,17.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6823,6219,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6824,6220,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6825,6221,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6826,6222,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6827,6223,1,471.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6828,6224,1,13.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6829,6225,1,2.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6830,6226,1,7.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6831,6227,1,487.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6832,6228,1,483.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6833,6229,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6834,6230,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6835,6231,1,496.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6836,6232,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6837,6233,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6838,6234,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6839,6235,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6840,6236,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6841,6237,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6842,6238,1,8.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6843,6239,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6844,6240,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6845,6241,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6846,6242,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6847,6243,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6848,6244,1,496.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6849,6245,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6850,6246,1,491.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6851,6247,1,491.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6852,6248,1,496.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6853,6249,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6854,6250,1,10.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6855,6251,1,33.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6856,6252,1,13.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6857,6253,1,17.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6858,6254,1,12.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6859,6255,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6860,6256,1,12.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6861,6257,1,1.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6862,6258,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6863,6259,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6864,6260,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6865,6261,1,422.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6866,6262,1,358.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6867,6263,1,491.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6868,6264,1,487.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6869,6265,1,486.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6870,6266,1,488.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6871,6267,1,484.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6872,6268,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6873,6269,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6874,6270,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6875,6271,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6876,6272,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6877,6273,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6878,6274,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6879,6275,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6880,6276,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6881,6277,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6882,6278,1,16.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6883,6279,1,12.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6884,6280,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6885,6281,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6886,6282,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6887,6283,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6888,6284,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6889,6285,1,496.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6890,6286,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6891,6287,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6892,6288,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6893,6289,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6894,6290,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6895,6291,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6896,6292,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6897,6293,1,15.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6898,6294,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6899,6295,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6900,6296,1,493.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6901,6297,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6902,6298,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6903,6299,1,47.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6904,6300,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6905,6301,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6906,6302,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6907,6303,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6908,6304,1,490.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6909,6305,1,497.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6910,6306,1,489.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6911,6307,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6912,6308,1,496.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6913,6309,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6914,6310,1,17.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6915,6311,1,7.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6916,6312,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6917,6313,1,17.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6918,6314,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6919,6315,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6920,6316,1,50.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6921,6317,1,50.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6922,6318,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6923,6319,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6924,6320,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6925,6321,1,16.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6926,6322,1,6.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6927,6323,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6928,6324,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6929,6325,1,20.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6930,6326,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6931,6327,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6932,6328,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6933,6329,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6934,6330,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6935,6331,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6936,6332,1,16.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6937,6333,1,14.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6938,6334,1,9.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6939,6335,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6940,6336,1,11.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6941,6337,1,9.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6942,6338,1,98.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6943,6339,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6944,6340,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6945,6341,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6946,6342,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6947,6343,1,18.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6948,6344,1,19.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6949,6345,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6950,6346,1,100.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6951,6347,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6952,6348,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6953,6349,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6954,6350,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6955,6351,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6956,6352,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6957,6353,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6958,6354,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6959,6355,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6960,6356,1,100.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6961,6357,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6962,6358,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6963,6359,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6964,6360,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6965,6361,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6966,6362,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6967,6363,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6968,6364,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6969,6365,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6970,6366,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6971,6367,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6972,6368,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6973,6369,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6974,6370,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6975,6371,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6976,6372,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6977,6373,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6978,6374,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6979,6375,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6980,6376,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6981,6377,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6982,6378,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6983,6379,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6984,6380,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6985,6381,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6986,6382,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6987,6383,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6988,6384,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6989,6385,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6990,6386,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6991,6387,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6992,6388,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6993,6389,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6994,6390,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6995,6391,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6996,6392,1,491.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6997,6393,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6998,6394,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(6999,6395,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7000,6396,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7001,6397,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7002,6398,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7003,6399,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7004,6400,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7005,6401,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7006,6402,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7007,6403,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7008,6404,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7009,6405,1,475.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7010,6406,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7011,6407,1,481.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7012,6408,1,483.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7013,6409,1,490.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7014,6410,1,497.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7015,6411,1,490.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7016,6412,1,493.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7017,6413,1,486.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7018,6414,1,478.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7019,6415,1,488.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7020,6416,1,474.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7021,6417,1,485.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7022,6418,1,493.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7023,6419,1,485.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7024,6420,1,482.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7025,6421,1,474.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7026,6422,1,497.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7027,6423,1,466.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7028,6424,1,493.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7029,6425,1,497.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7030,6426,1,485.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7031,6427,1,483.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7032,6428,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7033,6429,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7034,6430,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7035,6431,1,488.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7036,6432,1,493.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7037,6433,1,477.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7038,6434,1,496.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7039,6435,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7040,6436,1,496.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7041,6437,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7042,6438,1,493.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7043,6439,1,492.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7044,6440,1,485.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7045,6441,1,487.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7046,6442,1,485.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7047,6443,1,485.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7048,6444,1,487.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7049,6445,1,485.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7061,6446,1,453.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7062,6447,1,496.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7063,6448,1,496.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7064,6449,1,496.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7065,6450,1,477.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7066,6451,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7067,6452,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7068,6453,1,497.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7069,6454,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7070,6455,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7071,6456,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7072,6457,1,496.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7073,6458,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7074,6459,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7075,6460,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7076,6461,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7077,6462,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7078,6463,1,477.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7079,6464,1,454.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7080,6465,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7081,6466,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7082,6467,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7083,6468,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7084,6469,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7085,6470,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7086,6471,1,475.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7087,6472,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7088,6473,1,460.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7089,6474,1,479.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7090,6475,1,482.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7091,6476,1,458.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7092,6477,1,459.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7093,6478,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7094,6479,1,497.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7095,6480,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7096,6481,1,489.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7097,6482,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7098,6483,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7099,6484,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7100,6485,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7101,6486,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7102,6487,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7103,6488,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7104,6489,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7105,6490,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7106,6491,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7107,6492,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7108,6493,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7109,6494,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7110,6495,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7111,6496,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7112,6497,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7113,6498,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7114,6499,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7115,6500,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7116,6501,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7117,6502,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7118,6503,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7119,6504,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7120,6505,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7121,6506,1,499.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7122,6507,1,498.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7123,6508,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7124,6509,1,490.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7125,6510,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7126,6511,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7127,6512,1,487.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7128,6513,1,483.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7129,6514,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7130,6515,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7131,6516,1,492.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7132,6517,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7133,6518,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7134,6519,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7135,6520,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7136,6521,1,493.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7137,6522,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7138,6523,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7139,6524,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7140,6525,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7141,6526,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7142,6527,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7143,6528,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7144,6529,1,493.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7145,6530,1,486.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7146,6531,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7147,6532,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7148,6533,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7149,6534,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7150,6535,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7151,6536,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7152,6537,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7153,6538,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7154,6539,1,493.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7155,6540,1,493.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7156,6541,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7157,6542,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7158,6543,1,494.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7159,6544,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7160,6545,1,495.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7161,6546,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7162,6547,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7163,6548,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7164,6549,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7165,6550,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7166,6551,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7167,6552,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7168,6553,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7169,6554,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7170,6555,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7171,6556,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7172,6557,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7173,6558,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7174,6559,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7175,6560,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7176,6561,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7177,6562,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7178,6563,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7179,6564,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7180,6565,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7181,6566,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7182,6567,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7183,6568,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7184,6569,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7185,6570,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7186,6571,1,500.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0),(7187,6572,1,496.0000,0.0000,1,0,0,1,1.0000,1,10000.0000,1,1,NULL,1.0000,1,1,1,0,1,0.0000,1,0,0,0);
/*!40000 ALTER TABLE `cataloginventory_stock_item` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_cataloginventory_stock_item_after_insert` AFTER INSERT ON `cataloginventory_stock_item` FOR EACH ROW BEGIN
INSERT IGNORE INTO `cataloginventory_stock_cl` (`entity_id`) VALUES (NEW.`product_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_cataloginventory_stock_item_after_update` AFTER UPDATE ON `cataloginventory_stock_item` FOR EACH ROW BEGIN
IF (NOT(NEW.`item_id` <=> OLD.`item_id`) OR NOT(NEW.`product_id` <=> OLD.`product_id`) OR NOT(NEW.`stock_id` <=> OLD.`stock_id`) OR NOT(NEW.`qty` <=> OLD.`qty`) OR NOT(NEW.`min_qty` <=> OLD.`min_qty`) OR NOT(NEW.`use_config_min_qty` <=> OLD.`use_config_min_qty`) OR NOT(NEW.`is_qty_decimal` <=> OLD.`is_qty_decimal`) OR NOT(NEW.`backorders` <=> OLD.`backorders`) OR NOT(NEW.`use_config_backorders` <=> OLD.`use_config_backorders`) OR NOT(NEW.`min_sale_qty` <=> OLD.`min_sale_qty`) OR NOT(NEW.`use_config_min_sale_qty` <=> OLD.`use_config_min_sale_qty`) OR NOT(NEW.`max_sale_qty` <=> OLD.`max_sale_qty`) OR NOT(NEW.`use_config_max_sale_qty` <=> OLD.`use_config_max_sale_qty`) OR NOT(NEW.`is_in_stock` <=> OLD.`is_in_stock`) OR NOT(NEW.`low_stock_date` <=> OLD.`low_stock_date`) OR NOT(NEW.`notify_stock_qty` <=> OLD.`notify_stock_qty`) OR NOT(NEW.`use_config_notify_stock_qty` <=> OLD.`use_config_notify_stock_qty`) OR NOT(NEW.`manage_stock` <=> OLD.`manage_stock`) OR NOT(NEW.`use_config_manage_stock` <=> OLD.`use_config_manage_stock`) OR NOT(NEW.`stock_status_changed_auto` <=> OLD.`stock_status_changed_auto`) OR NOT(NEW.`use_config_qty_increments` <=> OLD.`use_config_qty_increments`) OR NOT(NEW.`qty_increments` <=> OLD.`qty_increments`) OR NOT(NEW.`use_config_enable_qty_inc` <=> OLD.`use_config_enable_qty_inc`) OR NOT(NEW.`enable_qty_increments` <=> OLD.`enable_qty_increments`) OR NOT(NEW.`is_decimal_divided` <=> OLD.`is_decimal_divided`) OR NOT(NEW.`website_id` <=> OLD.`website_id`)) THEN INSERT IGNORE INTO `cataloginventory_stock_cl` (`entity_id`) VALUES (NEW.`product_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_cataloginventory_stock_item_after_delete` AFTER DELETE ON `cataloginventory_stock_item` FOR EACH ROW BEGIN
INSERT IGNORE INTO `cataloginventory_stock_cl` (`entity_id`) VALUES (OLD.`product_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `cataloginventory_stock_status`
--

DROP TABLE IF EXISTS `cataloginventory_stock_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cataloginventory_stock_status` (
  `product_id` int unsigned NOT NULL COMMENT 'Product ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `stock_id` smallint unsigned NOT NULL COMMENT 'Stock ID',
  `qty` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty',
  `stock_status` smallint unsigned NOT NULL COMMENT 'Stock Status',
  PRIMARY KEY (`product_id`,`website_id`,`stock_id`),
  KEY `CATALOGINVENTORY_STOCK_STATUS_STOCK_ID` (`stock_id`),
  KEY `CATALOGINVENTORY_STOCK_STATUS_WEBSITE_ID` (`website_id`),
  KEY `CATALOGINVENTORY_STOCK_STATUS_STOCK_STATUS` (`stock_status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Cataloginventory Stock Status';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cataloginventory_stock_status`
--

LOCK TABLES `cataloginventory_stock_status` WRITE;
/*!40000 ALTER TABLE `cataloginventory_stock_status` DISABLE KEYS */;
INSERT INTO `cataloginventory_stock_status` VALUES (5760,0,1,10.0000,1),(6035,0,1,472.0000,1),(6036,0,1,438.0000,1),(6037,0,1,402.0000,1),(6038,0,1,458.0000,1),(6039,0,1,474.0000,1),(6040,0,1,495.0000,1),(6041,0,1,50.0000,1),(6042,0,1,47.0000,1),(6043,0,1,20.0000,1),(6044,0,1,7.0000,1),(6045,0,1,11.0000,1),(6046,0,1,11.0000,1),(6047,0,1,17.0000,1),(6048,0,1,20.0000,1),(6049,0,1,16.0000,1),(6050,0,1,493.0000,1),(6051,0,1,496.0000,1),(6052,0,1,499.0000,1),(6053,0,1,500.0000,1),(6054,0,1,500.0000,1),(6055,0,1,482.0000,1),(6056,0,1,499.0000,1),(6057,0,1,495.0000,1),(6058,0,1,17.0000,1),(6059,0,1,17.0000,1),(6060,0,1,20.0000,1),(6061,0,1,18.0000,1),(6062,0,1,18.0000,1),(6063,0,1,20.0000,1),(6064,0,1,20.0000,1),(6065,0,1,18.0000,1),(6066,0,1,18.0000,1),(6067,0,1,20.0000,1),(6068,0,1,15.0000,1),(6069,0,1,16.0000,1),(6070,0,1,498.0000,1),(6071,0,1,499.0000,1),(6072,0,1,20.0000,1),(6073,0,1,19.0000,1),(6074,0,1,500.0000,1),(6075,0,1,500.0000,1),(6076,0,1,50.0000,1),(6077,0,1,50.0000,1),(6078,0,1,50.0000,1),(6079,0,1,19.0000,1),(6080,0,1,20.0000,1),(6081,0,1,19.0000,1),(6082,0,1,18.0000,1),(6083,0,1,17.0000,1),(6084,0,1,20.0000,1),(6085,0,1,19.0000,1),(6086,0,1,19.0000,1),(6087,0,1,15.0000,1),(6088,0,1,16.0000,1),(6089,0,1,19.0000,1),(6090,0,1,19.0000,1),(6091,0,1,18.0000,1),(6092,0,1,499.0000,1),(6093,0,1,500.0000,1),(6094,0,1,496.0000,1),(6095,0,1,495.0000,1),(6096,0,1,498.0000,1),(6097,0,1,495.0000,1),(6098,0,1,16.0000,1),(6099,0,1,17.0000,1),(6100,0,1,495.0000,1),(6101,0,1,498.0000,1),(6102,0,1,499.0000,1),(6103,0,1,500.0000,1),(6104,0,1,499.0000,1),(6105,0,1,20.0000,1),(6106,0,1,19.0000,1),(6107,0,1,17.0000,1),(6108,0,1,19.0000,1),(6109,0,1,19.0000,1),(6110,0,1,497.0000,1),(6111,0,1,499.0000,1),(6112,0,1,499.0000,1),(6113,0,1,500.0000,1),(6114,0,1,499.0000,1),(6115,0,1,500.0000,1),(6116,0,1,500.0000,1),(6117,0,1,498.0000,1),(6118,0,1,498.0000,1),(6119,0,1,500.0000,1),(6120,0,1,495.0000,1),(6121,0,1,20.0000,1),(6122,0,1,20.0000,1),(6123,0,1,18.0000,1),(6124,0,1,19.0000,1),(6125,0,1,500.0000,1),(6126,0,1,499.0000,1),(6127,0,1,499.0000,1),(6128,0,1,495.0000,1),(6129,0,1,498.0000,1),(6130,0,1,500.0000,1),(6131,0,1,478.0000,1),(6132,0,1,4.0000,1),(6133,0,1,478.0000,1),(6134,0,1,8.0000,1),(6135,0,1,500.0000,1),(6136,0,1,489.0000,1),(6137,0,1,20.0000,1),(6138,0,1,16.0000,1),(6139,0,1,9.0000,1),(6140,0,1,19.0000,1),(6141,0,1,19.0000,1),(6142,0,1,46.0000,1),(6143,0,1,49.0000,1),(6144,0,1,9.0000,1),(6145,0,1,9.0000,1),(6146,0,1,493.0000,1),(6147,0,1,17.0000,1),(6148,0,1,499.0000,1),(6149,0,1,8.0000,1),(6150,0,1,16.0000,1),(6151,0,1,7.0000,1),(6152,0,1,16.0000,1),(6153,0,1,493.0000,1),(6154,0,1,13.0000,1),(6155,0,1,18.0000,1),(6156,0,1,16.0000,1),(6157,0,1,15.0000,1),(6158,0,1,11.0000,1),(6159,0,1,494.0000,1),(6160,0,1,499.0000,1),(6161,0,1,498.0000,1),(6162,0,1,500.0000,1),(6163,0,1,497.0000,1),(6164,0,1,500.0000,1),(6165,0,1,18.0000,1),(6166,0,1,497.0000,1),(6167,0,1,497.0000,1),(6168,0,1,499.0000,1),(6169,0,1,17.0000,1),(6170,0,1,500.0000,1),(6171,0,1,7.0000,1),(6172,0,1,7.0000,1),(6173,0,1,499.0000,1),(6174,0,1,499.0000,1),(6175,0,1,6.0000,1),(6176,0,1,499.0000,1),(6177,0,1,500.0000,1),(6178,0,1,497.0000,1),(6179,0,1,500.0000,1),(6180,0,1,500.0000,1),(6181,0,1,20.0000,1),(6182,0,1,12.0000,1),(6183,0,1,49.0000,1),(6184,0,1,497.0000,1),(6185,0,1,496.0000,1),(6186,0,1,497.0000,1),(6187,0,1,500.0000,1),(6188,0,1,500.0000,1),(6189,0,1,500.0000,1),(6190,0,1,498.0000,1),(6191,0,1,496.0000,1),(6192,0,1,500.0000,1),(6193,0,1,495.0000,1),(6194,0,1,500.0000,1),(6195,0,1,7.0000,1),(6196,0,1,500.0000,1),(6197,0,1,20.0000,1),(6198,0,1,19.0000,1),(6199,0,1,20.0000,1),(6200,0,1,16.0000,1),(6201,0,1,18.0000,1),(6202,0,1,19.0000,1),(6203,0,1,20.0000,1),(6204,0,1,8.0000,1),(6205,0,1,500.0000,1),(6206,0,1,18.0000,1),(6207,0,1,487.0000,1),(6208,0,1,497.0000,1),(6209,0,1,498.0000,1),(6210,0,1,499.0000,1),(6211,0,1,500.0000,1),(6212,0,1,499.0000,1),(6213,0,1,18.0000,1),(6214,0,1,16.0000,1),(6215,0,1,6.0000,1),(6216,0,1,15.0000,1),(6217,0,1,40.0000,1),(6218,0,1,17.0000,1),(6219,0,1,498.0000,1),(6220,0,1,500.0000,1),(6221,0,1,499.0000,1),(6222,0,1,500.0000,1),(6223,0,1,471.0000,1),(6224,0,1,13.0000,1),(6225,0,1,2.0000,1),(6226,0,1,7.0000,1),(6227,0,1,487.0000,1),(6228,0,1,483.0000,1),(6229,0,1,20.0000,1),(6230,0,1,20.0000,1),(6231,0,1,496.0000,1),(6232,0,1,18.0000,1),(6233,0,1,500.0000,1),(6234,0,1,20.0000,1),(6235,0,1,20.0000,1),(6236,0,1,19.0000,1),(6237,0,1,19.0000,1),(6238,0,1,8.0000,1),(6239,0,1,19.0000,1),(6240,0,1,500.0000,1),(6241,0,1,500.0000,1),(6242,0,1,498.0000,1),(6243,0,1,495.0000,1),(6244,0,1,496.0000,1),(6245,0,1,494.0000,1),(6246,0,1,491.0000,1),(6247,0,1,491.0000,1),(6248,0,1,496.0000,1),(6249,0,1,499.0000,1),(6250,0,1,10.0000,1),(6251,0,1,33.0000,1),(6252,0,1,13.0000,1),(6253,0,1,17.0000,1),(6254,0,1,12.0000,1),(6255,0,1,18.0000,1),(6256,0,1,12.0000,1),(6257,0,1,1.0000,1),(6258,0,1,499.0000,1),(6259,0,1,498.0000,1),(6260,0,1,498.0000,1),(6261,0,1,422.0000,1),(6262,0,1,358.0000,1),(6263,0,1,491.0000,1),(6264,0,1,487.0000,1),(6265,0,1,486.0000,1),(6266,0,1,488.0000,1),(6267,0,1,484.0000,1),(6268,0,1,499.0000,1),(6269,0,1,499.0000,1),(6270,0,1,498.0000,1),(6271,0,1,500.0000,1),(6272,0,1,500.0000,1),(6273,0,1,500.0000,1),(6274,0,1,500.0000,1),(6275,0,1,500.0000,1),(6276,0,1,499.0000,1),(6277,0,1,500.0000,1),(6278,0,1,16.0000,1),(6279,0,1,12.0000,1),(6280,0,1,499.0000,1),(6281,0,1,499.0000,1),(6282,0,1,500.0000,1),(6283,0,1,499.0000,1),(6284,0,1,500.0000,1),(6285,0,1,496.0000,1),(6286,0,1,500.0000,1),(6287,0,1,500.0000,1),(6288,0,1,499.0000,1),(6289,0,1,500.0000,1),(6290,0,1,500.0000,1),(6291,0,1,500.0000,1),(6292,0,1,19.0000,1),(6293,0,1,15.0000,1),(6294,0,1,500.0000,1),(6295,0,1,500.0000,1),(6296,0,1,493.0000,1),(6297,0,1,498.0000,1),(6298,0,1,498.0000,1),(6299,0,1,47.0000,1),(6300,0,1,500.0000,1),(6301,0,1,499.0000,1),(6302,0,1,499.0000,1),(6303,0,1,499.0000,1),(6304,0,1,490.0000,1),(6305,0,1,497.0000,1),(6306,0,1,489.0000,1),(6307,0,1,500.0000,1),(6308,0,1,496.0000,1),(6309,0,1,500.0000,1),(6310,0,1,17.0000,1),(6311,0,1,7.0000,1),(6312,0,1,498.0000,1),(6313,0,1,17.0000,1),(6314,0,1,18.0000,1),(6315,0,1,20.0000,1),(6316,0,1,50.0000,1),(6317,0,1,50.0000,1),(6318,0,1,19.0000,1),(6319,0,1,20.0000,1),(6320,0,1,18.0000,1),(6321,0,1,16.0000,1),(6322,0,1,6.0000,1),(6323,0,1,19.0000,1),(6324,0,1,20.0000,1),(6325,0,1,20.0000,1),(6326,0,1,19.0000,1),(6327,0,1,18.0000,1),(6328,0,1,500.0000,1),(6329,0,1,499.0000,1),(6330,0,1,500.0000,1),(6331,0,1,500.0000,1),(6332,0,1,16.0000,1),(6333,0,1,14.0000,1),(6334,0,1,9.0000,1),(6335,0,1,18.0000,1),(6336,0,1,11.0000,1),(6337,0,1,9.0000,1),(6338,0,1,98.0000,1),(6339,0,1,19.0000,1),(6340,0,1,19.0000,1),(6341,0,1,19.0000,1),(6342,0,1,18.0000,1),(6343,0,1,18.0000,1),(6344,0,1,19.0000,1),(6345,0,1,498.0000,1),(6346,0,1,100.0000,1),(6347,0,1,500.0000,1),(6348,0,1,498.0000,1),(6349,0,1,500.0000,1),(6350,0,1,500.0000,1),(6351,0,1,500.0000,1),(6352,0,1,500.0000,1),(6353,0,1,500.0000,1),(6354,0,1,498.0000,1),(6355,0,1,498.0000,1),(6356,0,1,100.0000,1),(6357,0,1,500.0000,1),(6358,0,1,500.0000,1),(6359,0,1,500.0000,1),(6360,0,1,500.0000,1),(6361,0,1,500.0000,1),(6362,0,1,500.0000,1),(6363,0,1,500.0000,1),(6364,0,1,500.0000,1),(6365,0,1,500.0000,1),(6366,0,1,500.0000,1),(6367,0,1,500.0000,1),(6368,0,1,500.0000,1),(6369,0,1,500.0000,1),(6370,0,1,500.0000,1),(6371,0,1,500.0000,1),(6372,0,1,500.0000,1),(6373,0,1,500.0000,1),(6374,0,1,500.0000,1),(6375,0,1,500.0000,1),(6376,0,1,500.0000,1),(6377,0,1,500.0000,1),(6378,0,1,500.0000,1),(6379,0,1,500.0000,1),(6380,0,1,500.0000,1),(6381,0,1,500.0000,1),(6382,0,1,500.0000,1),(6383,0,1,500.0000,1),(6384,0,1,500.0000,1),(6385,0,1,499.0000,1),(6386,0,1,500.0000,1),(6387,0,1,500.0000,1),(6388,0,1,500.0000,1),(6389,0,1,499.0000,1),(6390,0,1,500.0000,1),(6391,0,1,500.0000,1),(6392,0,1,491.0000,1),(6393,0,1,495.0000,1),(6394,0,1,500.0000,1),(6395,0,1,500.0000,1),(6396,0,1,500.0000,1),(6397,0,1,495.0000,1),(6398,0,1,498.0000,1),(6399,0,1,500.0000,1),(6400,0,1,500.0000,1),(6401,0,1,500.0000,1),(6402,0,1,500.0000,1),(6403,0,1,500.0000,1),(6404,0,1,499.0000,1),(6405,0,1,475.0000,1),(6406,0,1,494.0000,1),(6407,0,1,481.0000,1),(6408,0,1,483.0000,1),(6409,0,1,490.0000,1),(6410,0,1,497.0000,1),(6411,0,1,490.0000,1),(6412,0,1,493.0000,1),(6413,0,1,486.0000,1),(6414,0,1,478.0000,1),(6415,0,1,488.0000,1),(6416,0,1,474.0000,1),(6417,0,1,485.0000,1),(6418,0,1,493.0000,1),(6419,0,1,485.0000,1),(6420,0,1,482.0000,1),(6421,0,1,474.0000,1),(6422,0,1,497.0000,1),(6423,0,1,466.0000,1),(6424,0,1,493.0000,1),(6425,0,1,497.0000,1),(6426,0,1,485.0000,1),(6427,0,1,483.0000,1),(6428,0,1,498.0000,1),(6429,0,1,500.0000,1),(6430,0,1,498.0000,1),(6431,0,1,488.0000,1),(6432,0,1,493.0000,1),(6433,0,1,477.0000,1),(6434,0,1,496.0000,1),(6435,0,1,498.0000,1),(6436,0,1,496.0000,1),(6437,0,1,495.0000,1),(6438,0,1,493.0000,1),(6439,0,1,492.0000,1),(6440,0,1,485.0000,1),(6441,0,1,487.0000,1),(6442,0,1,485.0000,1),(6443,0,1,485.0000,1),(6444,0,1,487.0000,1),(6445,0,1,485.0000,1),(6446,0,1,453.0000,1),(6447,0,1,496.0000,1),(6448,0,1,496.0000,1),(6449,0,1,496.0000,1),(6450,0,1,477.0000,1),(6451,0,1,494.0000,1),(6452,0,1,494.0000,1),(6453,0,1,497.0000,1),(6454,0,1,499.0000,1),(6455,0,1,500.0000,1),(6456,0,1,498.0000,1),(6457,0,1,496.0000,1),(6458,0,1,500.0000,1),(6459,0,1,500.0000,1),(6460,0,1,499.0000,1),(6461,0,1,498.0000,1),(6462,0,1,500.0000,1),(6463,0,1,477.0000,1),(6464,0,1,454.0000,1),(6465,0,1,499.0000,1),(6466,0,1,500.0000,1),(6467,0,1,500.0000,1),(6468,0,1,500.0000,1),(6469,0,1,500.0000,1),(6470,0,1,500.0000,1),(6471,0,1,475.0000,1),(6472,0,1,498.0000,1),(6473,0,1,460.0000,1),(6474,0,1,479.0000,1),(6475,0,1,482.0000,1),(6476,0,1,458.0000,1),(6477,0,1,459.0000,1),(6478,0,1,498.0000,1),(6479,0,1,497.0000,1),(6480,0,1,495.0000,1),(6481,0,1,489.0000,1),(6482,0,1,498.0000,1),(6483,0,1,500.0000,1),(6484,0,1,499.0000,1),(6485,0,1,500.0000,1),(6486,0,1,500.0000,1),(6487,0,1,500.0000,1),(6488,0,1,500.0000,1),(6489,0,1,500.0000,1),(6490,0,1,500.0000,1),(6491,0,1,500.0000,1),(6492,0,1,500.0000,1),(6493,0,1,500.0000,1),(6494,0,1,500.0000,1),(6495,0,1,500.0000,1),(6496,0,1,500.0000,1),(6497,0,1,500.0000,1),(6498,0,1,500.0000,1),(6499,0,1,500.0000,1),(6500,0,1,500.0000,1),(6501,0,1,500.0000,1),(6502,0,1,500.0000,1),(6503,0,1,500.0000,1),(6504,0,1,500.0000,1),(6505,0,1,500.0000,1),(6506,0,1,499.0000,1),(6507,0,1,498.0000,1),(6508,0,1,500.0000,1),(6509,0,1,490.0000,1),(6510,0,1,494.0000,1),(6511,0,1,494.0000,1),(6512,0,1,487.0000,1),(6513,0,1,483.0000,1),(6514,0,1,494.0000,1),(6515,0,1,495.0000,1),(6516,0,1,492.0000,1),(6517,0,1,495.0000,1),(6518,0,1,494.0000,1),(6519,0,1,495.0000,1),(6520,0,1,495.0000,1),(6521,0,1,493.0000,1),(6522,0,1,495.0000,1),(6523,0,1,494.0000,1),(6524,0,1,495.0000,1),(6525,0,1,494.0000,1),(6526,0,1,494.0000,1),(6527,0,1,494.0000,1),(6528,0,1,495.0000,1),(6529,0,1,493.0000,1),(6530,0,1,486.0000,1),(6531,0,1,495.0000,1),(6532,0,1,495.0000,1),(6533,0,1,494.0000,1),(6534,0,1,494.0000,1),(6535,0,1,495.0000,1),(6536,0,1,495.0000,1),(6537,0,1,495.0000,1),(6538,0,1,495.0000,1),(6539,0,1,493.0000,1),(6540,0,1,493.0000,1),(6541,0,1,494.0000,1),(6542,0,1,494.0000,1),(6543,0,1,494.0000,1),(6544,0,1,495.0000,1),(6545,0,1,495.0000,1),(6546,0,1,500.0000,1),(6547,0,1,500.0000,1),(6548,0,1,500.0000,1),(6549,0,1,500.0000,1),(6550,0,1,500.0000,1),(6551,0,1,500.0000,1),(6552,0,1,500.0000,1),(6553,0,1,500.0000,1),(6554,0,1,500.0000,1),(6555,0,1,500.0000,1),(6556,0,1,500.0000,1),(6557,0,1,500.0000,1),(6558,0,1,500.0000,1),(6559,0,1,500.0000,1),(6560,0,1,500.0000,1),(6561,0,1,500.0000,1),(6562,0,1,500.0000,1),(6563,0,1,500.0000,1),(6564,0,1,500.0000,1),(6565,0,1,500.0000,1),(6566,0,1,500.0000,1),(6567,0,1,500.0000,1),(6568,0,1,500.0000,1),(6569,0,1,500.0000,1),(6570,0,1,500.0000,1),(6571,0,1,500.0000,1),(6572,0,1,496.0000,1);
/*!40000 ALTER TABLE `cataloginventory_stock_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cataloginventory_stock_status_idx`
--

DROP TABLE IF EXISTS `cataloginventory_stock_status_idx`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cataloginventory_stock_status_idx` (
  `product_id` int unsigned NOT NULL COMMENT 'Product ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `stock_id` smallint unsigned NOT NULL COMMENT 'Stock ID',
  `qty` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty',
  `stock_status` smallint unsigned NOT NULL COMMENT 'Stock Status',
  PRIMARY KEY (`product_id`,`website_id`,`stock_id`),
  KEY `CATALOGINVENTORY_STOCK_STATUS_IDX_STOCK_ID` (`stock_id`),
  KEY `CATALOGINVENTORY_STOCK_STATUS_IDX_WEBSITE_ID` (`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Cataloginventory Stock Status Indexer Idx';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cataloginventory_stock_status_idx`
--

LOCK TABLES `cataloginventory_stock_status_idx` WRITE;
/*!40000 ALTER TABLE `cataloginventory_stock_status_idx` DISABLE KEYS */;
/*!40000 ALTER TABLE `cataloginventory_stock_status_idx` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cataloginventory_stock_status_replica`
--

DROP TABLE IF EXISTS `cataloginventory_stock_status_replica`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cataloginventory_stock_status_replica` (
  `product_id` int unsigned NOT NULL COMMENT 'Product ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `stock_id` smallint unsigned NOT NULL COMMENT 'Stock ID',
  `qty` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty',
  `stock_status` smallint unsigned NOT NULL COMMENT 'Stock Status',
  PRIMARY KEY (`product_id`,`website_id`,`stock_id`),
  KEY `CATALOGINVENTORY_STOCK_STATUS_STOCK_ID` (`stock_id`),
  KEY `CATALOGINVENTORY_STOCK_STATUS_WEBSITE_ID` (`website_id`),
  KEY `CATALOGINVENTORY_STOCK_STATUS_STOCK_STATUS` (`stock_status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Cataloginventory Stock Status';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cataloginventory_stock_status_replica`
--

LOCK TABLES `cataloginventory_stock_status_replica` WRITE;
/*!40000 ALTER TABLE `cataloginventory_stock_status_replica` DISABLE KEYS */;
INSERT INTO `cataloginventory_stock_status_replica` VALUES (5760,0,1,10.0000,1),(6035,0,1,472.0000,1),(6036,0,1,438.0000,1),(6037,0,1,402.0000,1),(6038,0,1,458.0000,1),(6039,0,1,474.0000,1),(6040,0,1,495.0000,1),(6041,0,1,50.0000,1),(6042,0,1,47.0000,1),(6043,0,1,20.0000,1),(6044,0,1,7.0000,1),(6045,0,1,11.0000,1),(6046,0,1,11.0000,1),(6047,0,1,17.0000,1),(6048,0,1,20.0000,1),(6049,0,1,16.0000,1),(6050,0,1,493.0000,1),(6051,0,1,496.0000,1),(6052,0,1,499.0000,1),(6053,0,1,500.0000,1),(6054,0,1,500.0000,1),(6055,0,1,482.0000,1),(6056,0,1,499.0000,1),(6057,0,1,495.0000,1),(6058,0,1,17.0000,1),(6059,0,1,17.0000,1),(6060,0,1,20.0000,1),(6061,0,1,18.0000,1),(6062,0,1,18.0000,1),(6063,0,1,20.0000,1),(6064,0,1,20.0000,1),(6065,0,1,18.0000,1),(6066,0,1,18.0000,1),(6067,0,1,20.0000,1),(6068,0,1,15.0000,1),(6069,0,1,16.0000,1),(6070,0,1,498.0000,1),(6071,0,1,499.0000,1),(6072,0,1,20.0000,1),(6073,0,1,19.0000,1),(6074,0,1,500.0000,1),(6075,0,1,500.0000,1),(6076,0,1,50.0000,1),(6077,0,1,50.0000,1),(6078,0,1,50.0000,1),(6079,0,1,19.0000,1),(6080,0,1,20.0000,1),(6081,0,1,19.0000,1),(6082,0,1,18.0000,1),(6083,0,1,17.0000,1),(6084,0,1,20.0000,1),(6085,0,1,19.0000,1),(6086,0,1,19.0000,1),(6087,0,1,15.0000,1),(6088,0,1,16.0000,1),(6089,0,1,19.0000,1),(6090,0,1,19.0000,1),(6091,0,1,18.0000,1),(6092,0,1,499.0000,1),(6093,0,1,500.0000,1),(6094,0,1,496.0000,1),(6095,0,1,495.0000,1),(6096,0,1,498.0000,1),(6097,0,1,495.0000,1),(6098,0,1,16.0000,1),(6099,0,1,17.0000,1),(6100,0,1,495.0000,1),(6101,0,1,498.0000,1),(6102,0,1,499.0000,1),(6103,0,1,500.0000,1),(6104,0,1,499.0000,1),(6105,0,1,20.0000,1),(6106,0,1,19.0000,1),(6107,0,1,17.0000,1),(6108,0,1,19.0000,1),(6109,0,1,19.0000,1),(6110,0,1,497.0000,1),(6111,0,1,499.0000,1),(6112,0,1,499.0000,1),(6113,0,1,500.0000,1),(6114,0,1,499.0000,1),(6115,0,1,500.0000,1),(6116,0,1,500.0000,1),(6117,0,1,498.0000,1),(6118,0,1,498.0000,1),(6119,0,1,500.0000,1),(6120,0,1,495.0000,1),(6121,0,1,20.0000,1),(6122,0,1,20.0000,1),(6123,0,1,18.0000,1),(6124,0,1,19.0000,1),(6125,0,1,500.0000,1),(6126,0,1,499.0000,1),(6127,0,1,499.0000,1),(6128,0,1,495.0000,1),(6129,0,1,498.0000,1),(6130,0,1,500.0000,1),(6131,0,1,478.0000,1),(6132,0,1,4.0000,1),(6133,0,1,478.0000,1),(6134,0,1,8.0000,1),(6135,0,1,500.0000,1),(6136,0,1,489.0000,1),(6137,0,1,20.0000,1),(6138,0,1,16.0000,1),(6139,0,1,9.0000,1),(6140,0,1,19.0000,1),(6141,0,1,19.0000,1),(6142,0,1,46.0000,1),(6143,0,1,49.0000,1),(6144,0,1,9.0000,1),(6145,0,1,9.0000,1),(6146,0,1,493.0000,1),(6147,0,1,17.0000,1),(6148,0,1,499.0000,1),(6149,0,1,8.0000,1),(6150,0,1,16.0000,1),(6151,0,1,7.0000,1),(6152,0,1,16.0000,1),(6153,0,1,493.0000,1),(6154,0,1,13.0000,1),(6155,0,1,18.0000,1),(6156,0,1,16.0000,1),(6157,0,1,15.0000,1),(6158,0,1,11.0000,1),(6159,0,1,494.0000,1),(6160,0,1,499.0000,1),(6161,0,1,498.0000,1),(6162,0,1,500.0000,1),(6163,0,1,497.0000,1),(6164,0,1,500.0000,1),(6165,0,1,18.0000,1),(6166,0,1,497.0000,1),(6167,0,1,497.0000,1),(6168,0,1,499.0000,1),(6169,0,1,17.0000,1),(6170,0,1,500.0000,1),(6171,0,1,7.0000,1),(6172,0,1,7.0000,1),(6173,0,1,499.0000,1),(6174,0,1,499.0000,1),(6175,0,1,6.0000,1),(6176,0,1,499.0000,1),(6177,0,1,500.0000,1),(6178,0,1,497.0000,1),(6179,0,1,500.0000,1),(6180,0,1,500.0000,1),(6181,0,1,20.0000,1),(6182,0,1,12.0000,1),(6183,0,1,49.0000,1),(6184,0,1,497.0000,1),(6185,0,1,496.0000,1),(6186,0,1,497.0000,1),(6187,0,1,500.0000,1),(6188,0,1,500.0000,1),(6189,0,1,500.0000,1),(6190,0,1,498.0000,1),(6191,0,1,496.0000,1),(6192,0,1,500.0000,1),(6193,0,1,495.0000,1),(6194,0,1,500.0000,1),(6195,0,1,7.0000,1),(6196,0,1,500.0000,1),(6197,0,1,20.0000,1),(6198,0,1,19.0000,1),(6199,0,1,20.0000,1),(6200,0,1,16.0000,1),(6201,0,1,18.0000,1),(6202,0,1,19.0000,1),(6203,0,1,20.0000,1),(6204,0,1,8.0000,1),(6205,0,1,500.0000,1),(6206,0,1,18.0000,1),(6207,0,1,487.0000,1),(6208,0,1,497.0000,1),(6209,0,1,498.0000,1),(6210,0,1,499.0000,1),(6211,0,1,500.0000,1),(6212,0,1,499.0000,1),(6213,0,1,18.0000,1),(6214,0,1,16.0000,1),(6215,0,1,6.0000,1),(6216,0,1,15.0000,1),(6217,0,1,40.0000,1),(6218,0,1,17.0000,1),(6219,0,1,498.0000,1),(6220,0,1,500.0000,1),(6221,0,1,499.0000,1),(6222,0,1,500.0000,1),(6223,0,1,471.0000,1),(6224,0,1,13.0000,1),(6225,0,1,2.0000,1),(6226,0,1,7.0000,1),(6227,0,1,487.0000,1),(6228,0,1,483.0000,1),(6229,0,1,20.0000,1),(6230,0,1,20.0000,1),(6231,0,1,496.0000,1),(6232,0,1,18.0000,1),(6233,0,1,500.0000,1),(6234,0,1,20.0000,1),(6235,0,1,20.0000,1),(6236,0,1,19.0000,1),(6237,0,1,19.0000,1),(6238,0,1,8.0000,1),(6239,0,1,19.0000,1),(6240,0,1,500.0000,1),(6241,0,1,500.0000,1),(6242,0,1,498.0000,1),(6243,0,1,495.0000,1),(6244,0,1,496.0000,1),(6245,0,1,494.0000,1),(6246,0,1,491.0000,1),(6247,0,1,491.0000,1),(6248,0,1,496.0000,1),(6249,0,1,499.0000,1),(6250,0,1,10.0000,1),(6251,0,1,33.0000,1),(6252,0,1,13.0000,1),(6253,0,1,17.0000,1),(6254,0,1,12.0000,1),(6255,0,1,18.0000,1),(6256,0,1,12.0000,1),(6257,0,1,1.0000,1),(6258,0,1,499.0000,1),(6259,0,1,498.0000,1),(6260,0,1,498.0000,1),(6261,0,1,422.0000,1),(6262,0,1,358.0000,1),(6263,0,1,491.0000,1),(6264,0,1,487.0000,1),(6265,0,1,486.0000,1),(6266,0,1,488.0000,1),(6267,0,1,484.0000,1),(6268,0,1,499.0000,1),(6269,0,1,499.0000,1),(6270,0,1,498.0000,1),(6271,0,1,500.0000,1),(6272,0,1,500.0000,1),(6273,0,1,500.0000,1),(6274,0,1,500.0000,1),(6275,0,1,500.0000,1),(6276,0,1,499.0000,1),(6277,0,1,500.0000,1),(6278,0,1,16.0000,1),(6279,0,1,12.0000,1),(6280,0,1,499.0000,1),(6281,0,1,499.0000,1),(6282,0,1,500.0000,1),(6283,0,1,499.0000,1),(6284,0,1,500.0000,1),(6285,0,1,496.0000,1),(6286,0,1,500.0000,1),(6287,0,1,500.0000,1),(6288,0,1,499.0000,1),(6289,0,1,500.0000,1),(6290,0,1,500.0000,1),(6291,0,1,500.0000,1),(6292,0,1,19.0000,1),(6293,0,1,15.0000,1),(6294,0,1,500.0000,1),(6295,0,1,500.0000,1),(6296,0,1,493.0000,1),(6297,0,1,498.0000,1),(6298,0,1,498.0000,1),(6299,0,1,47.0000,1),(6300,0,1,500.0000,1),(6301,0,1,499.0000,1),(6302,0,1,499.0000,1),(6303,0,1,499.0000,1),(6304,0,1,490.0000,1),(6305,0,1,497.0000,1),(6306,0,1,489.0000,1),(6307,0,1,500.0000,1),(6308,0,1,496.0000,1),(6309,0,1,500.0000,1),(6310,0,1,17.0000,1),(6311,0,1,7.0000,1),(6312,0,1,498.0000,1),(6313,0,1,17.0000,1),(6314,0,1,18.0000,1),(6315,0,1,20.0000,1),(6316,0,1,50.0000,1),(6317,0,1,50.0000,1),(6318,0,1,19.0000,1),(6319,0,1,20.0000,1),(6320,0,1,18.0000,1),(6321,0,1,16.0000,1),(6322,0,1,6.0000,1),(6323,0,1,19.0000,1),(6324,0,1,20.0000,1),(6325,0,1,20.0000,1),(6326,0,1,19.0000,1),(6327,0,1,18.0000,1),(6328,0,1,500.0000,1),(6329,0,1,499.0000,1),(6330,0,1,500.0000,1),(6331,0,1,500.0000,1),(6332,0,1,16.0000,1),(6333,0,1,14.0000,1),(6334,0,1,9.0000,1),(6335,0,1,18.0000,1),(6336,0,1,11.0000,1),(6337,0,1,9.0000,1),(6338,0,1,98.0000,1),(6339,0,1,19.0000,1),(6340,0,1,19.0000,1),(6341,0,1,19.0000,1),(6342,0,1,18.0000,1),(6343,0,1,18.0000,1),(6344,0,1,19.0000,1),(6345,0,1,498.0000,1);
/*!40000 ALTER TABLE `cataloginventory_stock_status_replica` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cataloginventory_stock_status_tmp`
--

DROP TABLE IF EXISTS `cataloginventory_stock_status_tmp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cataloginventory_stock_status_tmp` (
  `product_id` int unsigned NOT NULL COMMENT 'Product ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `stock_id` smallint unsigned NOT NULL COMMENT 'Stock ID',
  `qty` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty',
  `stock_status` smallint unsigned NOT NULL COMMENT 'Stock Status',
  PRIMARY KEY (`product_id`,`website_id`,`stock_id`),
  KEY `CATALOGINVENTORY_STOCK_STATUS_TMP_STOCK_ID` (`stock_id`),
  KEY `CATALOGINVENTORY_STOCK_STATUS_TMP_WEBSITE_ID` (`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Cataloginventory Stock Status Indexer Tmp';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cataloginventory_stock_status_tmp`
--

LOCK TABLES `cataloginventory_stock_status_tmp` WRITE;
/*!40000 ALTER TABLE `cataloginventory_stock_status_tmp` DISABLE KEYS */;
/*!40000 ALTER TABLE `cataloginventory_stock_status_tmp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalogrule`
--

DROP TABLE IF EXISTS `catalogrule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalogrule` (
  `rule_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `description` text COMMENT 'Description',
  `from_date` date DEFAULT NULL COMMENT 'From',
  `to_date` date DEFAULT NULL COMMENT 'To',
  `is_active` smallint NOT NULL DEFAULT '0' COMMENT 'Is Active',
  `conditions_serialized` mediumtext COMMENT 'Conditions Serialized',
  `actions_serialized` mediumtext COMMENT 'Actions Serialized',
  `stop_rules_processing` smallint NOT NULL DEFAULT '1' COMMENT 'Stop Rules Processing',
  `sort_order` int unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `simple_action` varchar(32) DEFAULT NULL COMMENT 'Simple Action',
  `discount_amount` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Discount Amount',
  PRIMARY KEY (`rule_id`),
  KEY `CATALOGRULE_IS_ACTIVE_SORT_ORDER_TO_DATE_FROM_DATE` (`is_active`,`sort_order`,`to_date`,`from_date`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='CatalogRule';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalogrule`
--

LOCK TABLES `catalogrule` WRITE;
/*!40000 ALTER TABLE `catalogrule` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalogrule` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalogrule_after_insert` AFTER INSERT ON `catalogrule` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogrule_rule_cl` (`entity_id`) VALUES (NEW.`rule_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalogrule_after_update` AFTER UPDATE ON `catalogrule` FOR EACH ROW BEGIN
IF (NOT(NEW.`rule_id` <=> OLD.`rule_id`) OR NOT(NEW.`name` <=> OLD.`name`) OR NOT(NEW.`description` <=> OLD.`description`) OR NOT(NEW.`from_date` <=> OLD.`from_date`) OR NOT(NEW.`to_date` <=> OLD.`to_date`) OR NOT(NEW.`is_active` <=> OLD.`is_active`) OR NOT(NEW.`conditions_serialized` <=> OLD.`conditions_serialized`) OR NOT(NEW.`actions_serialized` <=> OLD.`actions_serialized`) OR NOT(NEW.`stop_rules_processing` <=> OLD.`stop_rules_processing`) OR NOT(NEW.`sort_order` <=> OLD.`sort_order`) OR NOT(NEW.`simple_action` <=> OLD.`simple_action`) OR NOT(NEW.`discount_amount` <=> OLD.`discount_amount`)) THEN INSERT IGNORE INTO `catalogrule_rule_cl` (`entity_id`) VALUES (NEW.`rule_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalogrule_after_delete` AFTER DELETE ON `catalogrule` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalogrule_rule_cl` (`entity_id`) VALUES (OLD.`rule_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `catalogrule_customer_group`
--

DROP TABLE IF EXISTS `catalogrule_customer_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalogrule_customer_group` (
  `rule_id` int unsigned NOT NULL COMMENT 'Rule ID',
  `customer_group_id` int unsigned NOT NULL COMMENT 'Customer Group ID',
  PRIMARY KEY (`rule_id`,`customer_group_id`),
  KEY `CATALOGRULE_CUSTOMER_GROUP_CUSTOMER_GROUP_ID` (`customer_group_id`),
  CONSTRAINT `CATALOGRULE_CUSTOMER_GROUP_RULE_ID_CATALOGRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `catalogrule` (`rule_id`) ON DELETE CASCADE,
  CONSTRAINT `CATRULE_CSTR_GROUP_CSTR_GROUP_ID_CSTR_GROUP_CSTR_GROUP_ID` FOREIGN KEY (`customer_group_id`) REFERENCES `customer_group` (`customer_group_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Rules To Customer Groups Relations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalogrule_customer_group`
--

LOCK TABLES `catalogrule_customer_group` WRITE;
/*!40000 ALTER TABLE `catalogrule_customer_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalogrule_customer_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalogrule_group_website`
--

DROP TABLE IF EXISTS `catalogrule_group_website`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalogrule_group_website` (
  `rule_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Rule ID',
  `customer_group_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID',
  PRIMARY KEY (`rule_id`,`customer_group_id`,`website_id`),
  KEY `CATALOGRULE_GROUP_WEBSITE_CUSTOMER_GROUP_ID` (`customer_group_id`),
  KEY `CATALOGRULE_GROUP_WEBSITE_WEBSITE_ID` (`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='CatalogRule Group Website';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalogrule_group_website`
--

LOCK TABLES `catalogrule_group_website` WRITE;
/*!40000 ALTER TABLE `catalogrule_group_website` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalogrule_group_website` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalogrule_group_website_replica`
--

DROP TABLE IF EXISTS `catalogrule_group_website_replica`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalogrule_group_website_replica` (
  `rule_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Rule ID',
  `customer_group_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID',
  PRIMARY KEY (`rule_id`,`customer_group_id`,`website_id`),
  KEY `CATALOGRULE_GROUP_WEBSITE_CUSTOMER_GROUP_ID` (`customer_group_id`),
  KEY `CATALOGRULE_GROUP_WEBSITE_WEBSITE_ID` (`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='CatalogRule Group Website';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalogrule_group_website_replica`
--

LOCK TABLES `catalogrule_group_website_replica` WRITE;
/*!40000 ALTER TABLE `catalogrule_group_website_replica` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalogrule_group_website_replica` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalogrule_product`
--

DROP TABLE IF EXISTS `catalogrule_product`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalogrule_product` (
  `rule_product_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rule Product ID',
  `rule_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Rule ID',
  `from_time` int unsigned NOT NULL DEFAULT '0' COMMENT 'From Time',
  `to_time` int unsigned NOT NULL DEFAULT '0' COMMENT 'To time',
  `customer_group_id` int DEFAULT NULL,
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `action_operator` varchar(10) DEFAULT 'to_fixed' COMMENT 'Action Operator',
  `action_amount` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Action Amount',
  `action_stop` smallint NOT NULL DEFAULT '0' COMMENT 'Action Stop',
  `sort_order` int unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  PRIMARY KEY (`rule_product_id`),
  UNIQUE KEY `UNQ_EAA51B56FF092A0DCB795D1CEF812B7B` (`rule_id`,`from_time`,`to_time`,`website_id`,`customer_group_id`,`product_id`,`sort_order`),
  KEY `CATALOGRULE_PRODUCT_CUSTOMER_GROUP_ID` (`customer_group_id`),
  KEY `CATALOGRULE_PRODUCT_WEBSITE_ID` (`website_id`),
  KEY `CATALOGRULE_PRODUCT_FROM_TIME` (`from_time`),
  KEY `CATALOGRULE_PRODUCT_TO_TIME` (`to_time`),
  KEY `CATALOGRULE_PRODUCT_PRODUCT_ID` (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='CatalogRule Product';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalogrule_product`
--

LOCK TABLES `catalogrule_product` WRITE;
/*!40000 ALTER TABLE `catalogrule_product` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalogrule_product` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalogrule_product_cl`
--

DROP TABLE IF EXISTS `catalogrule_product_cl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalogrule_product_cl` (
  `version_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Version ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  PRIMARY KEY (`version_id`)
) ENGINE=InnoDB AUTO_INCREMENT=151574 DEFAULT CHARSET=utf8mb3 COMMENT='catalogrule_product_cl';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalogrule_product_cl`
--

LOCK TABLES `catalogrule_product_cl` WRITE;
/*!40000 ALTER TABLE `catalogrule_product_cl` DISABLE KEYS */;
INSERT INTO `catalogrule_product_cl` VALUES (1,1),(2,2),(3,3),(4,4),(5,5),(6,6),(7,1),(8,1),(9,2),(10,2),(11,3),(12,3),(13,4),(14,4),(15,5),(16,5),(17,6),(18,6),(19,1),(20,1),(21,1),(22,1),(23,1),(24,1),(25,2),(26,2),(27,2),(28,2),(29,2),(30,2),(31,3),(32,3),(33,3),(34,3),(35,3),(36,3),(37,4),(38,4),(39,4),(40,4),(41,4),(42,5),(43,5),(44,5),(45,5),(46,5),(47,5),(48,6),(49,6),(50,6),(51,6),(52,6),(53,6),(54,1),(55,1),(56,2),(57,2),(58,3),(59,3),(60,4),(61,4),(62,5),(63,5),(64,6),(65,6),(66,1),(67,1),(68,2),(69,2),(70,3),(71,3),(72,5),(73,5),(74,6),(75,6),(76,1),(77,1),(78,1),(79,1),(80,2),(81,2),(82,2),(83,2),(84,3),(85,3),(86,3),(87,3),(88,4),(89,4),(90,4),(91,5),(92,5),(93,5),(94,5),(95,5),(96,5),(97,5),(98,5),(99,5),(100,6),(101,6),(102,6),(103,6),(104,6),(105,6),(106,6),(107,6),(108,6),(109,4),(110,4),(111,1),(112,1),(113,1),(114,1),(115,1),(116,1),(117,2),(118,2),(119,2),(120,3),(121,3),(122,3),(123,4),(124,4),(125,4),(126,4),(127,4),(128,4),(129,5),(130,5),(131,5),(132,5),(133,5),(134,5),(135,6),(136,6),(137,6),(138,6),(139,6),(140,6),(141,1),(142,1),(143,1),(144,1),(145,1),(146,1),(147,1),(148,1),(149,1),(150,1),(151,1),(152,1),(153,1),(154,1),(155,1),(156,1),(157,1),(158,1),(159,1),(160,1),(161,1),(162,1),(163,2),(164,2),(165,2),(166,2),(167,2),(168,2),(169,2),(170,2),(171,2),(172,2),(173,2),(174,2),(175,2),(176,2),(177,6),(178,6),(179,6),(180,6),(181,6),(182,6),(183,6),(184,6),(185,6),(186,6),(187,6),(188,6),(189,6),(190,6),(191,6),(192,6),(193,6),(194,6),(195,6),(196,6),(197,5),(198,5),(199,5),(200,5),(201,5),(202,5),(203,5),(204,5),(205,5),(206,5),(207,5),(208,5),(209,5),(210,5),(211,5),(212,5),(213,5),(214,5),(215,4),(216,4),(217,4),(218,4),(219,4),(220,4),(221,4),(222,4),(223,4),(224,4),(225,4),(226,4),(227,4),(228,4),(229,4),(230,4),(231,4),(232,4),(233,4),(234,4),(235,4),(236,4),(237,3),(238,3),(239,3),(240,3),(241,3),(242,3),(243,3),(244,3),(245,3),(246,3),(247,7),(248,7),(249,7),(250,7),(251,7),(252,7),(253,7),(254,7),(255,7),(256,7),(257,7),(258,7),(259,7),(260,7),(261,7),(262,7),(263,7),(264,7),(265,7),(266,7),(267,7),(268,7),(269,7),(270,8),(271,9),(272,10),(273,11),(274,12),(275,13),(276,14),(277,15),(278,16),(279,17),(280,18),(281,19),(282,20),(283,21),(284,22),(285,23),(286,24),(287,25),(288,26),(289,27),(290,28),(291,29),(292,30),(293,31),(294,32),(295,33),(296,34),(297,35),(298,36),(299,37),(300,38),(301,39),(302,40),(303,41),(304,42),(305,43),(306,44),(307,45),(308,46),(309,47),(310,48),(311,49),(312,50),(313,51),(314,52),(315,53),(316,54),(317,55),(318,56),(319,57),(320,58),(321,59),(322,60),(323,61),(324,62),(325,63),(326,64),(327,65),(328,66),(329,67),(330,68),(331,69),(332,70),(333,71),(334,72),(335,73),(336,74),(337,75),(338,76),(339,77),(340,78),(341,79),(342,80),(343,81),(344,82),(345,83),(346,84),(347,85),(348,86),(349,87),(350,88),(351,89),(352,90),(353,91),(354,92),(355,93),(356,94),(357,95),(358,96),(359,97),(360,98),(361,99),(362,100),(363,101),(364,102),(365,103),(366,104),(367,105),(368,106),(369,7),(370,7),(371,7),(372,8),(373,8),(374,8),(375,8),(376,8),(377,8),(378,8),(379,9),(380,9),(381,9),(382,9),(383,9),(384,9),(385,9),(386,10),(387,10),(388,10),(389,10),(390,10),(391,10),(392,10),(393,11),(394,11),(395,11),(396,11),(397,11),(398,11),(399,11),(400,12),(401,12),(402,12),(403,12),(404,12),(405,12),(406,12),(407,13),(408,13),(409,13),(410,13),(411,13),(412,13),(413,13),(414,14),(415,14),(416,14),(417,14),(418,14),(419,14),(420,14),(421,15),(422,15),(423,15),(424,15),(425,16),(426,16),(427,16),(428,16),(429,16),(430,16),(431,17),(432,17),(433,17),(434,17),(435,18),(436,18),(437,18),(438,18),(439,19),(440,19),(441,19),(442,19),(443,20),(444,20),(445,20),(446,20),(447,21),(448,21),(449,21),(450,21),(451,22),(452,22),(453,22),(454,22),(455,23),(456,23),(457,23),(458,23),(459,23),(460,23),(461,23),(462,24),(463,24),(464,24),(465,24),(466,24),(467,24),(468,24),(469,25),(470,25),(471,25),(472,25),(473,25),(474,25),(475,25),(476,26),(477,26),(478,26),(479,26),(480,27),(481,27),(482,27),(483,27),(484,27),(485,27),(486,27),(487,28),(488,28),(489,28),(490,28),(491,28),(492,28),(493,28),(494,29),(495,29),(496,29),(497,29),(498,29),(499,29),(500,29),(501,30),(502,30),(503,30),(504,30),(505,30),(506,30),(507,30),(508,31),(509,31),(510,31),(511,31),(512,31),(513,31),(514,31),(515,32),(516,32),(517,32),(518,32),(519,32),(520,32),(521,32),(522,33),(523,33),(524,33),(525,33),(526,34),(527,34),(528,34),(529,34),(530,34),(531,34),(532,34),(533,35),(534,35),(535,35),(536,35),(537,35),(538,35),(539,35),(540,36),(541,36),(542,36),(543,36),(544,36),(545,36),(546,36),(547,37),(548,37),(549,37),(550,37),(551,37),(552,37),(553,37),(554,38),(555,38),(556,38),(557,38),(558,38),(559,38),(560,38),(561,39),(562,39),(563,39),(564,39),(565,39),(566,39),(567,40),(568,40),(569,40),(570,40),(571,40),(572,40),(573,40),(574,41),(575,41),(576,41),(577,41),(578,41),(579,41),(580,41),(581,42),(582,42),(583,42),(584,42),(585,42),(586,42),(587,42),(588,43),(589,43),(590,43),(591,43),(592,43),(593,43),(594,43),(595,44),(596,44),(597,44),(598,44),(599,44),(600,44),(601,44),(602,45),(603,45),(604,45),(605,45),(606,45),(607,45),(608,45),(609,46),(610,46),(611,46),(612,46),(613,46),(614,46),(615,46),(616,47),(617,47),(618,47),(619,47),(620,47),(621,47),(622,47),(623,48),(624,48),(625,48),(626,48),(627,48),(628,48),(629,48),(630,49),(631,49),(632,49),(633,49),(634,49),(635,49),(636,49),(637,50),(638,50),(639,50),(640,50),(641,50),(642,50),(643,50),(644,51),(645,51),(646,51),(647,51),(648,51),(649,51),(650,51),(651,52),(652,52),(653,52),(654,52),(655,52),(656,52),(657,52),(658,53),(659,53),(660,53),(661,53),(662,53),(663,53),(664,53),(665,53),(666,53),(667,54),(668,54),(669,54),(670,54),(671,54),(672,54),(673,54),(674,54),(675,54),(676,55),(677,55),(678,55),(679,55),(680,55),(681,55),(682,55),(683,55),(684,55),(685,56),(686,56),(687,56),(688,56),(689,56),(690,56),(691,56),(692,56),(693,56),(694,57),(695,57),(696,57),(697,57),(698,57),(699,57),(700,57),(701,57),(702,57),(703,58),(704,58),(705,58),(706,58),(707,58),(708,58),(709,58),(710,58),(711,58),(712,59),(713,59),(714,59),(715,59),(716,59),(717,59),(718,59),(719,59),(720,59),(721,60),(722,60),(723,60),(724,60),(725,60),(726,60),(727,60),(728,60),(729,60),(730,61),(731,61),(732,61),(733,61),(734,61),(735,61),(736,61),(737,61),(738,61),(739,62),(740,62),(741,62),(742,62),(743,62),(744,62),(745,62),(746,62),(747,62),(748,63),(749,63),(750,63),(751,63),(752,63),(753,63),(754,63),(755,63),(756,63),(757,64),(758,64),(759,64),(760,64),(761,64),(762,64),(763,64),(764,64),(765,64),(766,65),(767,65),(768,65),(769,65),(770,65),(771,65),(772,65),(773,66),(774,66),(775,66),(776,66),(777,66),(778,66),(779,66),(780,67),(781,67),(782,67),(783,67),(784,67),(785,67),(786,67),(787,68),(788,68),(789,68),(790,68),(791,69),(792,69),(793,69),(794,69),(795,70),(796,70),(797,70),(798,70),(799,70),(800,70),(801,70),(802,71),(803,71),(804,71),(805,71),(806,72),(807,72),(808,72),(809,72),(810,73),(811,73),(812,73),(813,73),(814,74),(815,74),(816,74),(817,74),(818,75),(819,75),(820,75),(821,75),(822,76),(823,76),(824,76),(825,76),(826,77),(827,77),(828,77),(829,77),(830,78),(831,78),(832,78),(833,78),(834,78),(835,78),(836,78),(837,79),(838,79),(839,79),(840,79),(841,79),(842,79),(843,79),(844,80),(845,80),(846,80),(847,80),(848,80),(849,80),(850,80),(851,81),(852,81),(853,81),(854,81),(855,81),(856,81),(857,81),(858,82),(859,82),(860,82),(861,82),(862,82),(863,82),(864,82),(865,83),(866,83),(867,83),(868,83),(869,83),(870,83),(871,83),(872,84),(873,84),(874,84),(875,84),(876,84),(877,84),(878,84),(879,85),(880,85),(881,85),(882,85),(883,85),(884,85),(885,85),(886,86),(887,86),(888,86),(889,86),(890,86),(891,86),(892,86),(893,86),(894,86),(895,87),(896,87),(897,87),(898,87),(899,87),(900,87),(901,87),(902,88),(903,88),(904,88),(905,88),(906,88),(907,88),(908,88),(909,89),(910,89),(911,89),(912,89),(913,89),(914,89),(915,89),(916,89),(917,89),(918,90),(919,90),(920,90),(921,90),(922,90),(923,90),(924,90),(925,91),(926,91),(927,91),(928,91),(929,91),(930,91),(931,91),(932,92),(933,92),(934,92),(935,92),(936,92),(937,92),(938,92),(939,93),(940,93),(941,93),(942,93),(943,93),(944,93),(945,93),(946,94),(947,94),(948,94),(949,94),(950,94),(951,94),(952,94),(953,95),(954,95),(955,95),(956,95),(957,95),(958,95),(959,95),(960,96),(961,96),(962,96),(963,96),(964,96),(965,96),(966,96),(967,96),(968,96),(969,97),(970,97),(971,97),(972,97),(973,97),(974,97),(975,97),(976,97),(977,97),(978,98),(979,98),(980,98),(981,98),(982,98),(983,98),(984,98),(985,98),(986,98),(987,99),(988,99),(989,99),(990,99),(991,99),(992,99),(993,99),(994,99),(995,99),(996,100),(997,100),(998,100),(999,100),(1000,100),(1001,100),(1002,100),(1003,100),(1004,100),(1005,101),(1006,101),(1007,101),(1008,101),(1009,101),(1010,101),(1011,101),(1012,101),(1013,101),(1014,102),(1015,102),(1016,102),(1017,102),(1018,102),(1019,102),(1020,102),(1021,102),(1022,102),(1023,103),(1024,103),(1025,103),(1026,103),(1027,103),(1028,103),(1029,103),(1030,103),(1031,103),(1032,104),(1033,104),(1034,104),(1035,104),(1036,104),(1037,104),(1038,104),(1039,104),(1040,104),(1041,105),(1042,105),(1043,105),(1044,105),(1045,105),(1046,105),(1047,105),(1048,105),(1049,105),(1050,106),(1051,106),(1052,106),(1053,106),(1054,106),(1055,106),(1056,106),(1057,106),(1058,106),(1059,7),(1060,8),(1061,8),(1062,9),(1063,9),(1064,10),(1065,10),(1066,11),(1067,11),(1068,12),(1069,12),(1070,13),(1071,13),(1072,14),(1073,14),(1074,15),(1075,16),(1076,17),(1077,18),(1078,19),(1079,20),(1080,21),(1081,22),(1082,23),(1083,23),(1084,24),(1085,24),(1086,25),(1087,25),(1088,26),(1089,27),(1090,27),(1091,28),(1092,28),(1093,29),(1094,29),(1095,30),(1096,30),(1097,31),(1098,32),(1099,32),(1100,33),(1101,34),(1102,35),(1103,36),(1104,37),(1105,37),(1106,38),(1107,38),(1108,39),(1109,39),(1110,40),(1111,40),(1112,41),(1113,41),(1114,42),(1115,42),(1116,43),(1117,43),(1118,44),(1119,44),(1120,45),(1121,45),(1122,46),(1123,46),(1124,47),(1125,47),(1126,48),(1127,48),(1128,49),(1129,49),(1130,50),(1131,50),(1132,51),(1133,51),(1134,52),(1135,52),(1136,53),(1137,53),(1138,54),(1139,54),(1140,55),(1141,55),(1142,56),(1143,56),(1144,57),(1145,57),(1146,58),(1147,58),(1148,59),(1149,59),(1150,60),(1151,60),(1152,61),(1153,61),(1154,62),(1155,62),(1156,63),(1157,63),(1158,64),(1159,64),(1160,65),(1161,66),(1162,66),(1163,67),(1164,68),(1165,69),(1166,70),(1167,70),(1168,71),(1169,72),(1170,73),(1171,74),(1172,75),(1173,76),(1174,77),(1175,78),(1176,78),(1177,79),(1178,79),(1179,80),(1180,80),(1181,81),(1182,81),(1183,82),(1184,82),(1185,83),(1186,83),(1187,84),(1188,84),(1189,85),(1190,85),(1191,86),(1192,86),(1193,87),(1194,87),(1195,88),(1196,88),(1197,89),(1198,89),(1199,90),(1200,90),(1201,91),(1202,91),(1203,92),(1204,92),(1205,93),(1206,93),(1207,94),(1208,94),(1209,95),(1210,95),(1211,96),(1212,96),(1213,97),(1214,97),(1215,98),(1216,98),(1217,99),(1218,99),(1219,100),(1220,100),(1221,101),(1222,101),(1223,102),(1224,102),(1225,103),(1226,103),(1227,104),(1228,104),(1229,105),(1230,105),(1231,106),(1232,106),(1233,7),(1234,8),(1235,8),(1236,8),(1237,9),(1238,9),(1239,9),(1240,10),(1241,10),(1242,10),(1243,11),(1244,11),(1245,11),(1246,12),(1247,12),(1248,12),(1249,13),(1250,13),(1251,13),(1252,14),(1253,14),(1254,14),(1255,15),(1256,15),(1257,15),(1258,16),(1259,16),(1260,16),(1261,17),(1262,17),(1263,17),(1264,18),(1265,18),(1266,18),(1267,19),(1268,19),(1269,19),(1270,20),(1271,20),(1272,20),(1273,21),(1274,21),(1275,21),(1276,22),(1277,22),(1278,22),(1279,23),(1280,23),(1281,23),(1282,24),(1283,24),(1284,24),(1285,25),(1286,25),(1287,25),(1288,26),(1289,26),(1290,26),(1291,27),(1292,27),(1293,27),(1294,28),(1295,28),(1296,28),(1297,29),(1298,29),(1299,29),(1300,30),(1301,30),(1302,30),(1303,31),(1304,31),(1305,31),(1306,32),(1307,32),(1308,32),(1309,33),(1310,33),(1311,33),(1312,34),(1313,34),(1314,34),(1315,35),(1316,35),(1317,35),(1318,36),(1319,36),(1320,36),(1321,37),(1322,37),(1323,37),(1324,38),(1325,38),(1326,38),(1327,39),(1328,40),(1329,40),(1330,40),(1331,41),(1332,41),(1333,41),(1334,42),(1335,42),(1336,42),(1337,43),(1338,43),(1339,43),(1340,44),(1341,44),(1342,44),(1343,45),(1344,45),(1345,45),(1346,46),(1347,46),(1348,46),(1349,47),(1350,47),(1351,47),(1352,48),(1353,48),(1354,48),(1355,49),(1356,49),(1357,49),(1358,50),(1359,50),(1360,50),(1361,51),(1362,51),(1363,51),(1364,52),(1365,52),(1366,52),(1367,53),(1368,53),(1369,53),(1370,54),(1371,54),(1372,54),(1373,55),(1374,55),(1375,55),(1376,56),(1377,56),(1378,56),(1379,57),(1380,57),(1381,57),(1382,58),(1383,58),(1384,58),(1385,59),(1386,59),(1387,59),(1388,60),(1389,60),(1390,60),(1391,61),(1392,61),(1393,61),(1394,62),(1395,62),(1396,62),(1397,63),(1398,63),(1399,63),(1400,64),(1401,64),(1402,64),(1403,65),(1404,65),(1405,65),(1406,66),(1407,66),(1408,66),(1409,67),(1410,67),(1411,67),(1412,68),(1413,68),(1414,68),(1415,69),(1416,69),(1417,69),(1418,70),(1419,70),(1420,70),(1421,71),(1422,71),(1423,71),(1424,72),(1425,72),(1426,72),(1427,73),(1428,73),(1429,73),(1430,74),(1431,74),(1432,74),(1433,75),(1434,75),(1435,75),(1436,76),(1437,76),(1438,76),(1439,77),(1440,77),(1441,77),(1442,78),(1443,78),(1444,78),(1445,79),(1446,79),(1447,79),(1448,80),(1449,80),(1450,80),(1451,81),(1452,81),(1453,81),(1454,82),(1455,82),(1456,82),(1457,83),(1458,83),(1459,83),(1460,84),(1461,84),(1462,84),(1463,85),(1464,85),(1465,85),(1466,86),(1467,86),(1468,86),(1469,87),(1470,87),(1471,87),(1472,88),(1473,88),(1474,88),(1475,89),(1476,89),(1477,89),(1478,90),(1479,90),(1480,90),(1481,91),(1482,91),(1483,91),(1484,92),(1485,92),(1486,92),(1487,93),(1488,93),(1489,93),(1490,94),(1491,94),(1492,94),(1493,95),(1494,95),(1495,95),(1496,96),(1497,96),(1498,97),(1499,97),(1500,98),(1501,98),(1502,99),(1503,99),(1504,100),(1505,100),(1506,101),(1507,101),(1508,102),(1509,102),(1510,103),(1511,103),(1512,104),(1513,104),(1514,105),(1515,105),(1516,106),(1517,106),(1518,8),(1519,8),(1520,8),(1521,8),(1522,9),(1523,9),(1524,9),(1525,9),(1526,10),(1527,10),(1528,10),(1529,10),(1530,11),(1531,11),(1532,11),(1533,11),(1534,12),(1535,12),(1536,12),(1537,12),(1538,13),(1539,13),(1540,13),(1541,13),(1542,14),(1543,14),(1544,14),(1545,14),(1546,15),(1547,15),(1548,15),(1549,15),(1550,16),(1551,16),(1552,16),(1553,16),(1554,17),(1555,17),(1556,17),(1557,17),(1558,18),(1559,18),(1560,18),(1561,18),(1562,19),(1563,19),(1564,19),(1565,19),(1566,20),(1567,20),(1568,20),(1569,20),(1570,21),(1571,21),(1572,21),(1573,21),(1574,22),(1575,22),(1576,22),(1577,22),(1578,23),(1579,23),(1580,23),(1581,23),(1582,24),(1583,24),(1584,24),(1585,24),(1586,25),(1587,25),(1588,25),(1589,25),(1590,26),(1591,26),(1592,26),(1593,26),(1594,27),(1595,27),(1596,27),(1597,27),(1598,28),(1599,28),(1600,28),(1601,28),(1602,29),(1603,29),(1604,29),(1605,29),(1606,30),(1607,30),(1608,30),(1609,30),(1610,31),(1611,31),(1612,31),(1613,31),(1614,32),(1615,32),(1616,32),(1617,32),(1618,33),(1619,33),(1620,33),(1621,33),(1622,34),(1623,34),(1624,34),(1625,34),(1626,35),(1627,35),(1628,35),(1629,35),(1630,36),(1631,36),(1632,36),(1633,36),(1634,37),(1635,37),(1636,37),(1637,37),(1638,38),(1639,38),(1640,38),(1641,38),(1642,39),(1643,39),(1644,39),(1645,39),(1646,40),(1647,40),(1648,40),(1649,40),(1650,41),(1651,41),(1652,41),(1653,41),(1654,42),(1655,42),(1656,42),(1657,42),(1658,43),(1659,43),(1660,43),(1661,43),(1662,44),(1663,44),(1664,44),(1665,44),(1666,45),(1667,45),(1668,45),(1669,45),(1670,46),(1671,46),(1672,46),(1673,46),(1674,47),(1675,47),(1676,47),(1677,47),(1678,48),(1679,48),(1680,48),(1681,48),(1682,49),(1683,49),(1684,49),(1685,49),(1686,50),(1687,50),(1688,50),(1689,50),(1690,51),(1691,51),(1692,51),(1693,51),(1694,52),(1695,52),(1696,52),(1697,52),(1698,53),(1699,53),(1700,53),(1701,53),(1702,54),(1703,54),(1704,54),(1705,54),(1706,55),(1707,55),(1708,55),(1709,55),(1710,56),(1711,56),(1712,56),(1713,56),(1714,57),(1715,57),(1716,57),(1717,57),(1718,58),(1719,58),(1720,58),(1721,58),(1722,59),(1723,59),(1724,59),(1725,59),(1726,60),(1727,60),(1728,60),(1729,60),(1730,61),(1731,61),(1732,61),(1733,61),(1734,62),(1735,62),(1736,62),(1737,62),(1738,63),(1739,63),(1740,63),(1741,63),(1742,64),(1743,64),(1744,64),(1745,64),(1746,65),(1747,65),(1748,65),(1749,65),(1750,66),(1751,66),(1752,66),(1753,66),(1754,67),(1755,67),(1756,67),(1757,67),(1758,68),(1759,68),(1760,68),(1761,68),(1762,69),(1763,69),(1764,69),(1765,69),(1766,70),(1767,70),(1768,70),(1769,70),(1770,71),(1771,71),(1772,71),(1773,71),(1774,72),(1775,72),(1776,72),(1777,72),(1778,73),(1779,73),(1780,73),(1781,73),(1782,74),(1783,74),(1784,74),(1785,74),(1786,75),(1787,75),(1788,75),(1789,75),(1790,76),(1791,76),(1792,76),(1793,76),(1794,77),(1795,77),(1796,77),(1797,77),(1798,78),(1799,78),(1800,78),(1801,78),(1802,79),(1803,79),(1804,79),(1805,79),(1806,80),(1807,80),(1808,80),(1809,80),(1810,81),(1811,81),(1812,81),(1813,81),(1814,82),(1815,82),(1816,82),(1817,82),(1818,83),(1819,83),(1820,83),(1821,83),(1822,84),(1823,84),(1824,84),(1825,84),(1826,85),(1827,85),(1828,85),(1829,85),(1830,86),(1831,86),(1832,86),(1833,86),(1834,87),(1835,87),(1836,87),(1837,87),(1838,88),(1839,88),(1840,88),(1841,88),(1842,89),(1843,89),(1844,89),(1845,89),(1846,90),(1847,90),(1848,90),(1849,90),(1850,91),(1851,91),(1852,91),(1853,91),(1854,92),(1855,92),(1856,92),(1857,92),(1858,93),(1859,93),(1860,93),(1861,93),(1862,94),(1863,94),(1864,94),(1865,94),(1866,95),(1867,95),(1868,95),(1869,95),(1870,96),(1871,96),(1872,96),(1873,96),(1874,97),(1875,97),(1876,97),(1877,97),(1878,98),(1879,98),(1880,98),(1881,98),(1882,99),(1883,99),(1884,99),(1885,99),(1886,100),(1887,100),(1888,100),(1889,100),(1890,101),(1891,101),(1892,101),(1893,101),(1894,102),(1895,102),(1896,102),(1897,102),(1898,103),(1899,103),(1900,103),(1901,103),(1902,104),(1903,104),(1904,104),(1905,104),(1906,105),(1907,105),(1908,105),(1909,105),(1910,106),(1911,106),(1912,106),(1913,106),(1914,107),(1915,108),(1916,109),(1917,110),(1918,111),(1919,112),(1920,113),(1921,114),(1922,115),(1923,116),(1924,117),(1925,118),(1926,119),(1927,120),(1928,121),(1929,122),(1930,123),(1931,124),(1932,125),(1933,126),(1934,127),(1935,128),(1936,129),(1937,130),(1938,131),(1939,132),(1940,133),(1941,134),(1942,135),(1943,136),(1944,137),(1945,138),(1946,139),(1947,140),(1948,141),(1949,142),(1950,143),(1951,144),(1952,145),(1953,146),(1954,147),(1955,148),(1956,149),(1957,150),(1958,151),(1959,152),(1960,153),(1961,154),(1962,155),(1963,156),(1964,157),(1965,158),(1966,159),(1967,160),(1968,161),(1969,162),(1970,163),(1971,164),(1972,165),(1973,166),(1974,167),(1975,168),(1976,169),(1977,170),(1978,171),(1979,172),(1980,173),(1981,174),(1982,175),(1983,176),(1984,177),(1985,178),(1986,179),(1987,180),(1988,181),(1989,182),(1990,183),(1991,184),(1992,185),(1993,186),(1994,187),(1995,188),(1996,189),(1997,190),(1998,191),(1999,192),(2000,193),(2001,194),(2002,195),(2003,196),(2004,197),(2005,198),(2006,199),(2007,200),(2008,201),(2009,202),(2010,203),(2011,204),(2012,205),(2013,206),(2014,107),(2015,107),(2016,107),(2017,107),(2018,107),(2019,107),(2020,107),(2021,107),(2022,107),(2023,108),(2024,108),(2025,108),(2026,108),(2027,108),(2028,108),(2029,108),(2030,108),(2031,108),(2032,109),(2033,109),(2034,109),(2035,109),(2036,109),(2037,109),(2038,109),(2039,109),(2040,109),(2041,110),(2042,110),(2043,110),(2044,110),(2045,110),(2046,110),(2047,110),(2048,111),(2049,111),(2050,111),(2051,111),(2052,111),(2053,111),(2054,111),(2055,112),(2056,112),(2057,112),(2058,112),(2059,112),(2060,112),(2061,112),(2062,113),(2063,113),(2064,113),(2065,113),(2066,114),(2067,114),(2068,114),(2069,114),(2070,114),(2071,114),(2072,114),(2073,115),(2074,115),(2075,115),(2076,115),(2077,115),(2078,115),(2079,115),(2080,116),(2081,116),(2082,116),(2083,116),(2084,116),(2085,116),(2086,116),(2087,117),(2088,117),(2089,117),(2090,117),(2091,118),(2092,118),(2093,118),(2094,118),(2095,118),(2096,118),(2097,118),(2098,119),(2099,119),(2100,119),(2101,119),(2102,119),(2103,119),(2104,119),(2105,120),(2106,120),(2107,120),(2108,120),(2109,120),(2110,120),(2111,120),(2112,121),(2113,121),(2114,121),(2115,121),(2116,121),(2117,121),(2118,121),(2119,122),(2120,122),(2121,122),(2122,122),(2123,122),(2124,122),(2125,122),(2126,122),(2127,122),(2128,123),(2129,123),(2130,123),(2131,123),(2132,123),(2133,123),(2134,123),(2135,124),(2136,124),(2137,124),(2138,124),(2139,124),(2140,124),(2141,124),(2142,125),(2143,125),(2144,125),(2145,125),(2146,125),(2147,125),(2148,125),(2149,126),(2150,126),(2151,126),(2152,126),(2153,126),(2154,126),(2155,126),(2156,127),(2157,127),(2158,127),(2159,127),(2160,127),(2161,127),(2162,127),(2163,127),(2164,127),(2165,128),(2166,128),(2167,128),(2168,128),(2169,128),(2170,128),(2171,128),(2172,128),(2173,128),(2174,129),(2175,129),(2176,129),(2177,129),(2178,129),(2179,129),(2180,129),(2181,129),(2182,129),(2183,130),(2184,130),(2185,130),(2186,130),(2187,130),(2188,130),(2189,130),(2190,130),(2191,130),(2192,131),(2193,131),(2194,131),(2195,131),(2196,131),(2197,131),(2198,131),(2199,131),(2200,131),(2201,132),(2202,132),(2203,132),(2204,132),(2205,132),(2206,132),(2207,132),(2208,132),(2209,132),(2210,133),(2211,133),(2212,133),(2213,133),(2214,133),(2215,133),(2216,133),(2217,133),(2218,133),(2219,134),(2220,134),(2221,134),(2222,134),(2223,134),(2224,134),(2225,134),(2226,134),(2227,134),(2228,135),(2229,135),(2230,135),(2231,135),(2232,135),(2233,135),(2234,135),(2235,135),(2236,135),(2237,136),(2238,136),(2239,136),(2240,136),(2241,136),(2242,136),(2243,136),(2244,136),(2245,136),(2246,137),(2247,137),(2248,137),(2249,137),(2250,137),(2251,137),(2252,137),(2253,137),(2254,137),(2255,138),(2256,138),(2257,138),(2258,138),(2259,138),(2260,138),(2261,138),(2262,138),(2263,138),(2264,139),(2265,139),(2266,139),(2267,139),(2268,139),(2269,139),(2270,139),(2271,140),(2272,140),(2273,140),(2274,140),(2275,140),(2276,140),(2277,140),(2278,141),(2279,141),(2280,141),(2281,141),(2282,141),(2283,141),(2284,141),(2285,142),(2286,142),(2287,142),(2288,142),(2289,143),(2290,143),(2291,143),(2292,143),(2293,143),(2294,143),(2295,143),(2296,144),(2297,144),(2298,144),(2299,144),(2300,144),(2301,144),(2302,144),(2303,145),(2304,145),(2305,145),(2306,145),(2307,145),(2308,145),(2309,145),(2310,145),(2311,145),(2312,146),(2313,146),(2314,146),(2315,146),(2316,146),(2317,146),(2318,146),(2319,147),(2320,147),(2321,147),(2322,147),(2323,147),(2324,147),(2325,147),(2326,147),(2327,147),(2328,148),(2329,148),(2330,148),(2331,148),(2332,148),(2333,148),(2334,148),(2335,148),(2336,148),(2337,149),(2338,149),(2339,149),(2340,149),(2341,149),(2342,149),(2343,149),(2344,149),(2345,149),(2346,150),(2347,150),(2348,150),(2349,150),(2350,150),(2351,150),(2352,150),(2353,151),(2354,151),(2355,151),(2356,151),(2357,151),(2358,151),(2359,151),(2360,152),(2361,152),(2362,152),(2363,152),(2364,153),(2365,153),(2366,153),(2367,153),(2368,153),(2369,153),(2370,153),(2371,153),(2372,153),(2373,154),(2374,154),(2375,154),(2376,154),(2377,154),(2378,154),(2379,154),(2380,154),(2381,154),(2382,155),(2383,155),(2384,155),(2385,155),(2386,155),(2387,155),(2388,155),(2389,155),(2390,155),(2391,156),(2392,156),(2393,156),(2394,156),(2395,156),(2396,156),(2397,156),(2398,157),(2399,157),(2400,157),(2401,157),(2402,157),(2403,157),(2404,157),(2405,158),(2406,158),(2407,158),(2408,158),(2409,158),(2410,158),(2411,158),(2412,159),(2413,159),(2414,159),(2415,159),(2416,159),(2417,159),(2418,159),(2419,160),(2420,160),(2421,160),(2422,160),(2423,160),(2424,160),(2425,160),(2426,161),(2427,161),(2428,161),(2429,161),(2430,161),(2431,161),(2432,161),(2433,162),(2434,162),(2435,162),(2436,162),(2437,162),(2438,162),(2439,162),(2440,162),(2441,162),(2442,163),(2443,163),(2444,163),(2445,163),(2446,163),(2447,163),(2448,163),(2449,164),(2450,164),(2451,164),(2452,164),(2453,164),(2454,164),(2455,165),(2456,165),(2457,165),(2458,165),(2459,165),(2460,165),(2461,165),(2462,166),(2463,166),(2464,166),(2465,166),(2466,166),(2467,166),(2468,167),(2469,167),(2470,167),(2471,167),(2472,167),(2473,167),(2474,167),(2475,168),(2476,168),(2477,168),(2478,168),(2479,168),(2480,168),(2481,168),(2482,169),(2483,169),(2484,169),(2485,169),(2486,169),(2487,169),(2488,169),(2489,170),(2490,170),(2491,170),(2492,170),(2493,170),(2494,170),(2495,170),(2496,171),(2497,171),(2498,171),(2499,171),(2500,171),(2501,171),(2502,171),(2503,172),(2504,172),(2505,172),(2506,172),(2507,172),(2508,172),(2509,173),(2510,173),(2511,173),(2512,173),(2513,173),(2514,173),(2515,173),(2516,174),(2517,174),(2518,174),(2519,174),(2520,174),(2521,174),(2522,174),(2523,175),(2524,175),(2525,175),(2526,175),(2527,175),(2528,175),(2529,175),(2530,176),(2531,176),(2532,176),(2533,176),(2534,177),(2535,177),(2536,177),(2537,177),(2538,178),(2539,178),(2540,178),(2541,178),(2542,179),(2543,179),(2544,179),(2545,179),(2546,180),(2547,180),(2548,180),(2549,180),(2550,181),(2551,181),(2552,181),(2553,181),(2554,182),(2555,182),(2556,182),(2557,182),(2558,183),(2559,183),(2560,183),(2561,183),(2562,184),(2563,184),(2564,184),(2565,184),(2566,185),(2567,185),(2568,185),(2569,185),(2570,186),(2571,186),(2572,186),(2573,186),(2574,187),(2575,187),(2576,187),(2577,187),(2578,188),(2579,188),(2580,188),(2581,188),(2582,189),(2583,189),(2584,189),(2585,189),(2586,190),(2587,190),(2588,190),(2589,190),(2590,190),(2591,190),(2592,190),(2593,190),(2594,190),(2595,191),(2596,191),(2597,191),(2598,191),(2599,191),(2600,191),(2601,191),(2602,191),(2603,191),(2604,192),(2605,192),(2606,192),(2607,192),(2608,192),(2609,192),(2610,192),(2611,192),(2612,192),(2613,193),(2614,193),(2615,193),(2616,193),(2617,193),(2618,193),(2619,193),(2620,193),(2621,193),(2622,194),(2623,194),(2624,194),(2625,194),(2626,194),(2627,194),(2628,194),(2629,194),(2630,194),(2631,195),(2632,195),(2633,195),(2634,195),(2635,195),(2636,195),(2637,195),(2638,195),(2639,195),(2640,196),(2641,196),(2642,196),(2643,196),(2644,196),(2645,196),(2646,196),(2647,196),(2648,196),(2649,197),(2650,197),(2651,197),(2652,197),(2653,197),(2654,197),(2655,197),(2656,197),(2657,197),(2658,198),(2659,198),(2660,198),(2661,198),(2662,199),(2663,199),(2664,199),(2665,199),(2666,200),(2667,200),(2668,200),(2669,200),(2670,201),(2671,201),(2672,201),(2673,201),(2674,201),(2675,201),(2676,201),(2677,201),(2678,201),(2679,202),(2680,202),(2681,202),(2682,202),(2683,202),(2684,202),(2685,202),(2686,202),(2687,202),(2688,203),(2689,203),(2690,203),(2691,203),(2692,203),(2693,203),(2694,203),(2695,203),(2696,203),(2697,204),(2698,204),(2699,204),(2700,204),(2701,205),(2702,205),(2703,205),(2704,205),(2705,206),(2706,206),(2707,206),(2708,206),(2709,107),(2710,107),(2711,108),(2712,108),(2713,109),(2714,109),(2715,110),(2716,110),(2717,111),(2718,111),(2719,112),(2720,112),(2721,113),(2722,114),(2723,114),(2724,115),(2725,115),(2726,116),(2727,116),(2728,117),(2729,118),(2730,119),(2731,120),(2732,121),(2733,122),(2734,122),(2735,123),(2736,123),(2737,124),(2738,124),(2739,125),(2740,125),(2741,126),(2742,126),(2743,127),(2744,127),(2745,128),(2746,128),(2747,129),(2748,129),(2749,130),(2750,130),(2751,131),(2752,131),(2753,132),(2754,132),(2755,133),(2756,133),(2757,134),(2758,134),(2759,135),(2760,135),(2761,136),(2762,136),(2763,137),(2764,137),(2765,138),(2766,138),(2767,139),(2768,139),(2769,140),(2770,140),(2771,141),(2772,141),(2773,142),(2774,143),(2775,143),(2776,144),(2777,144),(2778,145),(2779,145),(2780,146),(2781,146),(2782,147),(2783,147),(2784,148),(2785,148),(2786,149),(2787,149),(2788,150),(2789,150),(2790,151),(2791,151),(2792,152),(2793,153),(2794,153),(2795,154),(2796,154),(2797,155),(2798,155),(2799,156),(2800,156),(2801,157),(2802,157),(2803,158),(2804,158),(2805,159),(2806,159),(2807,160),(2808,160),(2809,161),(2810,161),(2811,162),(2812,162),(2813,163),(2814,163),(2815,164),(2816,164),(2817,165),(2818,165),(2819,166),(2820,166),(2821,167),(2822,167),(2823,168),(2824,168),(2825,169),(2826,169),(2827,170),(2828,170),(2829,171),(2830,171),(2831,172),(2832,172),(2833,173),(2834,173),(2835,174),(2836,174),(2837,175),(2838,175),(2839,176),(2840,177),(2841,178),(2842,179),(2843,180),(2844,181),(2845,182),(2846,183),(2847,184),(2848,185),(2849,186),(2850,187),(2851,188),(2852,189),(2853,190),(2854,190),(2855,191),(2856,191),(2857,192),(2858,192),(2859,193),(2860,193),(2861,194),(2862,194),(2863,195),(2864,195),(2865,196),(2866,196),(2867,197),(2868,197),(2869,198),(2870,199),(2871,200),(2872,201),(2873,201),(2874,202),(2875,202),(2876,203),(2877,203),(2878,204),(2879,205),(2880,206),(2881,107),(2882,107),(2883,108),(2884,108),(2885,109),(2886,109),(2887,110),(2888,110),(2889,110),(2890,111),(2891,111),(2892,111),(2893,112),(2894,112),(2895,112),(2896,113),(2897,113),(2898,113),(2899,114),(2900,114),(2901,114),(2902,115),(2903,115),(2904,115),(2905,116),(2906,116),(2907,116),(2908,117),(2909,117),(2910,117),(2911,118),(2912,118),(2913,118),(2914,119),(2915,119),(2916,119),(2917,120),(2918,120),(2919,120),(2920,121),(2921,121),(2922,121),(2923,122),(2924,122),(2925,122),(2926,123),(2927,123),(2928,123),(2929,124),(2930,124),(2931,124),(2932,125),(2933,125),(2934,125),(2935,126),(2936,126),(2937,126),(2938,127),(2939,127),(2940,127),(2941,128),(2942,128),(2943,128),(2944,129),(2945,129),(2946,129),(2947,130),(2948,130),(2949,130),(2950,131),(2951,131),(2952,131),(2953,132),(2954,132),(2955,132),(2956,133),(2957,133),(2958,133),(2959,134),(2960,134),(2961,134),(2962,135),(2963,135),(2964,135),(2965,136),(2966,136),(2967,136),(2968,137),(2969,137),(2970,137),(2971,138),(2972,138),(2973,139),(2974,139),(2975,139),(2976,140),(2977,140),(2978,140),(2979,141),(2980,141),(2981,141),(2982,142),(2983,142),(2984,142),(2985,143),(2986,143),(2987,143),(2988,144),(2989,144),(2990,144),(2991,145),(2992,145),(2993,145),(2994,146),(2995,146),(2996,146),(2997,147),(2998,147),(2999,147),(3000,148),(3001,148),(3002,148),(3003,149),(3004,149),(3005,149),(3006,150),(3007,150),(3008,150),(3009,151),(3010,151),(3011,151),(3012,152),(3013,152),(3014,152),(3015,153),(3016,153),(3017,153),(3018,154),(3019,154),(3020,154),(3021,155),(3022,155),(3023,155),(3024,156),(3025,156),(3026,156),(3027,157),(3028,157),(3029,157),(3030,158),(3031,158),(3032,158),(3033,159),(3034,159),(3035,159),(3036,160),(3037,160),(3038,160),(3039,161),(3040,161),(3041,161),(3042,162),(3043,162),(3044,162),(3045,163),(3046,163),(3047,163),(3048,164),(3049,164),(3050,164),(3051,165),(3052,165),(3053,165),(3054,166),(3055,166),(3056,166),(3057,167),(3058,167),(3059,167),(3060,168),(3061,168),(3062,168),(3063,169),(3064,169),(3065,169),(3066,170),(3067,170),(3068,170),(3069,171),(3070,171),(3071,171),(3072,172),(3073,172),(3074,172),(3075,173),(3076,173),(3077,173),(3078,174),(3079,174),(3080,174),(3081,175),(3082,175),(3083,175),(3084,176),(3085,176),(3086,176),(3087,177),(3088,177),(3089,177),(3090,178),(3091,178),(3092,178),(3093,179),(3094,179),(3095,179),(3096,180),(3097,180),(3098,180),(3099,181),(3100,181),(3101,181),(3102,182),(3103,182),(3104,182),(3105,183),(3106,183),(3107,183),(3108,184),(3109,184),(3110,184),(3111,185),(3112,185),(3113,185),(3114,186),(3115,186),(3116,186),(3117,187),(3118,187),(3119,187),(3120,188),(3121,188),(3122,188),(3123,189),(3124,189),(3125,189),(3126,190),(3127,190),(3128,190),(3129,191),(3130,191),(3131,191),(3132,192),(3133,192),(3134,192),(3135,193),(3136,193),(3137,193),(3138,194),(3139,194),(3140,194),(3141,195),(3142,195),(3143,195),(3144,196),(3145,196),(3146,196),(3147,197),(3148,197),(3149,197),(3150,198),(3151,198),(3152,198),(3153,199),(3154,199),(3155,199),(3156,200),(3157,200),(3158,200),(3159,201),(3160,201),(3161,201),(3162,202),(3163,202),(3164,202),(3165,203),(3166,203),(3167,203),(3168,204),(3169,204),(3170,204),(3171,205),(3172,205),(3173,205),(3174,206),(3175,206),(3176,206),(3177,107),(3178,107),(3179,107),(3180,107),(3181,108),(3182,108),(3183,108),(3184,108),(3185,109),(3186,109),(3187,109),(3188,109),(3189,110),(3190,110),(3191,110),(3192,110),(3193,111),(3194,111),(3195,111),(3196,111),(3197,112),(3198,112),(3199,112),(3200,112),(3201,113),(3202,113),(3203,113),(3204,113),(3205,114),(3206,114),(3207,114),(3208,114),(3209,115),(3210,115),(3211,115),(3212,115),(3213,116),(3214,116),(3215,116),(3216,116),(3217,117),(3218,117),(3219,117),(3220,117),(3221,118),(3222,118),(3223,118),(3224,118),(3225,119),(3226,119),(3227,119),(3228,119),(3229,120),(3230,120),(3231,120),(3232,120),(3233,121),(3234,121),(3235,121),(3236,121),(3237,122),(3238,122),(3239,122),(3240,122),(3241,123),(3242,123),(3243,123),(3244,123),(3245,124),(3246,124),(3247,124),(3248,124),(3249,125),(3250,125),(3251,125),(3252,125),(3253,126),(3254,126),(3255,126),(3256,126),(3257,127),(3258,127),(3259,127),(3260,127),(3261,128),(3262,128),(3263,128),(3264,128),(3265,129),(3266,129),(3267,129),(3268,129),(3269,130),(3270,130),(3271,130),(3272,130),(3273,131),(3274,131),(3275,131),(3276,131),(3277,132),(3278,132),(3279,132),(3280,132),(3281,133),(3282,133),(3283,133),(3284,133),(3285,134),(3286,134),(3287,134),(3288,134),(3289,135),(3290,135),(3291,135),(3292,135),(3293,136),(3294,136),(3295,136),(3296,136),(3297,137),(3298,137),(3299,137),(3300,137),(3301,138),(3302,138),(3303,138),(3304,138),(3305,139),(3306,139),(3307,139),(3308,139),(3309,140),(3310,140),(3311,140),(3312,140),(3313,141),(3314,141),(3315,141),(3316,141),(3317,142),(3318,142),(3319,142),(3320,142),(3321,143),(3322,143),(3323,143),(3324,143),(3325,144),(3326,144),(3327,144),(3328,144),(3329,145),(3330,145),(3331,145),(3332,145),(3333,146),(3334,146),(3335,146),(3336,146),(3337,147),(3338,147),(3339,147),(3340,147),(3341,148),(3342,148),(3343,148),(3344,148),(3345,149),(3346,149),(3347,149),(3348,149),(3349,150),(3350,150),(3351,150),(3352,150),(3353,151),(3354,151),(3355,151),(3356,151),(3357,152),(3358,152),(3359,152),(3360,152),(3361,153),(3362,153),(3363,153),(3364,153),(3365,154),(3366,154),(3367,154),(3368,154),(3369,155),(3370,155),(3371,155),(3372,155),(3373,156),(3374,156),(3375,156),(3376,156),(3377,157),(3378,157),(3379,157),(3380,157),(3381,158),(3382,158),(3383,158),(3384,158),(3385,159),(3386,159),(3387,159),(3388,159),(3389,160),(3390,160),(3391,160),(3392,160),(3393,161),(3394,161),(3395,161),(3396,161),(3397,162),(3398,162),(3399,162),(3400,162),(3401,163),(3402,163),(3403,163),(3404,163),(3405,164),(3406,164),(3407,164),(3408,164),(3409,165),(3410,165),(3411,165),(3412,165),(3413,166),(3414,166),(3415,166),(3416,166),(3417,167),(3418,167),(3419,167),(3420,167),(3421,168),(3422,168),(3423,168),(3424,168),(3425,169),(3426,169),(3427,169),(3428,169),(3429,170),(3430,170),(3431,170),(3432,170),(3433,171),(3434,171),(3435,171),(3436,171),(3437,172),(3438,172),(3439,172),(3440,172),(3441,173),(3442,173),(3443,173),(3444,173),(3445,174),(3446,174),(3447,174),(3448,174),(3449,175),(3450,175),(3451,175),(3452,175),(3453,176),(3454,176),(3455,176),(3456,176),(3457,177),(3458,177),(3459,177),(3460,177),(3461,178),(3462,178),(3463,178),(3464,178),(3465,179),(3466,179),(3467,179),(3468,179),(3469,180),(3470,180),(3471,180),(3472,180),(3473,181),(3474,181),(3475,181),(3476,181),(3477,182),(3478,182),(3479,182),(3480,182),(3481,183),(3482,183),(3483,183),(3484,183),(3485,184),(3486,184),(3487,184),(3488,184),(3489,185),(3490,185),(3491,185),(3492,185),(3493,186),(3494,186),(3495,186),(3496,186),(3497,187),(3498,187),(3499,187),(3500,187),(3501,188),(3502,188),(3503,188),(3504,188),(3505,189),(3506,189),(3507,189),(3508,189),(3509,190),(3510,190),(3511,190),(3512,190),(3513,191),(3514,191),(3515,191),(3516,191),(3517,192),(3518,192),(3519,192),(3520,192),(3521,193),(3522,193),(3523,193),(3524,193),(3525,194),(3526,194),(3527,194),(3528,194),(3529,195),(3530,195),(3531,195),(3532,195),(3533,196),(3534,196),(3535,196),(3536,196),(3537,197),(3538,197),(3539,197),(3540,197),(3541,198),(3542,198),(3543,198),(3544,198),(3545,199),(3546,199),(3547,199),(3548,199),(3549,200),(3550,200),(3551,200),(3552,200),(3553,201),(3554,201),(3555,201),(3556,201),(3557,202),(3558,202),(3559,202),(3560,202),(3561,203),(3562,203),(3563,203),(3564,203),(3565,204),(3566,204),(3567,204),(3568,204),(3569,205),(3570,205),(3571,205),(3572,205),(3573,206),(3574,206),(3575,206),(3576,206),(3577,207),(3578,208),(3579,209),(3580,210),(3581,211),(3582,212),(3583,213),(3584,214),(3585,215),(3586,216),(3587,217),(3588,218),(3589,219),(3590,220),(3591,221),(3592,222),(3593,223),(3594,224),(3595,225),(3596,226),(3597,227),(3598,228),(3599,229),(3600,230),(3601,231),(3602,232),(3603,233),(3604,234),(3605,235),(3606,236),(3607,237),(3608,238),(3609,239),(3610,240),(3611,241),(3612,242),(3613,243),(3614,244),(3615,245),(3616,246),(3617,247),(3618,248),(3619,249),(3620,250),(3621,251),(3622,252),(3623,253),(3624,254),(3625,255),(3626,256),(3627,257),(3628,258),(3629,259),(3630,260),(3631,261),(3632,262),(3633,263),(3634,264),(3635,265),(3636,266),(3637,267),(3638,268),(3639,269),(3640,270),(3641,271),(3642,272),(3643,273),(3644,274),(3645,275),(3646,276),(3647,277),(3648,278),(3649,279),(3650,280),(3651,207),(3652,207),(3653,207),(3654,207),(3655,208),(3656,208),(3657,208),(3658,208),(3659,209),(3660,209),(3661,209),(3662,209),(3663,210),(3664,210),(3665,210),(3666,210),(3667,211),(3668,211),(3669,211),(3670,211),(3671,212),(3672,212),(3673,212),(3674,212),(3675,213),(3676,213),(3677,213),(3678,213),(3679,214),(3680,214),(3681,214),(3682,214),(3683,215),(3684,215),(3685,215),(3686,215),(3687,216),(3688,216),(3689,216),(3690,216),(3691,217),(3692,217),(3693,217),(3694,217),(3695,218),(3696,218),(3697,218),(3698,218),(3699,219),(3700,219),(3701,219),(3702,219),(3703,220),(3704,220),(3705,220),(3706,220),(3707,221),(3708,221),(3709,221),(3710,221),(3711,221),(3712,221),(3713,221),(3714,222),(3715,222),(3716,222),(3717,222),(3718,222),(3719,222),(3720,222),(3721,223),(3722,223),(3723,223),(3724,223),(3725,223),(3726,223),(3727,223),(3728,224),(3729,224),(3730,224),(3731,224),(3732,224),(3733,224),(3734,224),(3735,225),(3736,225),(3737,225),(3738,225),(3739,225),(3740,225),(3741,225),(3742,226),(3743,226),(3744,226),(3745,226),(3746,226),(3747,226),(3748,226),(3749,227),(3750,227),(3751,227),(3752,227),(3753,227),(3754,227),(3755,227),(3756,228),(3757,228),(3758,228),(3759,228),(3760,228),(3761,228),(3762,228),(3763,229),(3764,229),(3765,229),(3766,229),(3767,229),(3768,229),(3769,229),(3770,230),(3771,230),(3772,230),(3773,230),(3774,230),(3775,230),(3776,230),(3777,231),(3778,231),(3779,231),(3780,231),(3781,231),(3782,231),(3783,231),(3784,232),(3785,232),(3786,232),(3787,232),(3788,232),(3789,232),(3790,232),(3791,233),(3792,233),(3793,233),(3794,233),(3795,233),(3796,233),(3797,233),(3798,234),(3799,234),(3800,234),(3801,234),(3802,234),(3803,234),(3804,234),(3805,235),(3806,235),(3807,235),(3808,235),(3809,235),(3810,235),(3811,235),(3812,236),(3813,236),(3814,236),(3815,236),(3816,236),(3817,236),(3818,236),(3819,237),(3820,237),(3821,237),(3822,237),(3823,237),(3824,237),(3825,237),(3826,238),(3827,238),(3828,238),(3829,238),(3830,238),(3831,238),(3832,238),(3833,239),(3834,239),(3835,239),(3836,239),(3837,239),(3838,239),(3839,239),(3840,240),(3841,240),(3842,240),(3843,240),(3844,240),(3845,240),(3846,240),(3847,241),(3848,241),(3849,241),(3850,241),(3851,241),(3852,241),(3853,241),(3854,242),(3855,242),(3856,242),(3857,242),(3858,242),(3859,242),(3860,242),(3861,243),(3862,243),(3863,243),(3864,243),(3865,243),(3866,243),(3867,243),(3868,244),(3869,244),(3870,244),(3871,244),(3872,244),(3873,244),(3874,244),(3875,244),(3876,244),(3877,245),(3878,245),(3879,245),(3880,245),(3881,245),(3882,245),(3883,245),(3884,245),(3885,245),(3886,246),(3887,246),(3888,246),(3889,246),(3890,246),(3891,246),(3892,246),(3893,247),(3894,247),(3895,247),(3896,247),(3897,247),(3898,247),(3899,247),(3900,248),(3901,248),(3902,248),(3903,248),(3904,248),(3905,248),(3906,248),(3907,249),(3908,249),(3909,249),(3910,249),(3911,249),(3912,249),(3913,249),(3914,250),(3915,250),(3916,250),(3917,250),(3918,250),(3919,250),(3920,250),(3921,251),(3922,251),(3923,251),(3924,251),(3925,251),(3926,251),(3927,251),(3928,251),(3929,251),(3930,252),(3931,252),(3932,252),(3933,252),(3934,252),(3935,252),(3936,252),(3937,253),(3938,253),(3939,253),(3940,253),(3941,253),(3942,253),(3943,253),(3944,254),(3945,254),(3946,254),(3947,254),(3948,254),(3949,254),(3950,255),(3951,255),(3952,255),(3953,255),(3954,255),(3955,255),(3956,256),(3957,256),(3958,256),(3959,256),(3960,256),(3961,256),(3962,257),(3963,257),(3964,257),(3965,257),(3966,257),(3967,257),(3968,258),(3969,258),(3970,258),(3971,258),(3972,258),(3973,258),(3974,258),(3975,259),(3976,259),(3977,259),(3978,259),(3979,259),(3980,259),(3981,259),(3982,260),(3983,260),(3984,260),(3985,260),(3986,260),(3987,260),(3988,260),(3989,261),(3990,261),(3991,261),(3992,261),(3993,261),(3994,261),(3995,261),(3996,262),(3997,262),(3998,262),(3999,262),(4000,262),(4001,262),(4002,262),(4003,263),(4004,263),(4005,263),(4006,263),(4007,263),(4008,263),(4009,263),(4010,264),(4011,264),(4012,264),(4013,264),(4014,264),(4015,264),(4016,264),(4017,265),(4018,265),(4019,265),(4020,265),(4021,265),(4022,265),(4023,265),(4024,266),(4025,266),(4026,266),(4027,266),(4028,266),(4029,266),(4030,266),(4031,267),(4032,267),(4033,267),(4034,267),(4035,267),(4036,267),(4037,267),(4038,268),(4039,268),(4040,268),(4041,268),(4042,268),(4043,268),(4044,268),(4045,268),(4046,268),(4047,269),(4048,269),(4049,269),(4050,269),(4051,269),(4052,269),(4053,269),(4054,269),(4055,269),(4056,270),(4057,270),(4058,270),(4059,270),(4060,270),(4061,270),(4062,270),(4063,270),(4064,270),(4065,271),(4066,271),(4067,271),(4068,271),(4069,271),(4070,271),(4071,271),(4072,271),(4073,271),(4074,272),(4075,272),(4076,272),(4077,272),(4078,272),(4079,272),(4080,272),(4081,272),(4082,272),(4083,273),(4084,273),(4085,273),(4086,273),(4087,273),(4088,273),(4089,273),(4090,273),(4091,273),(4092,274),(4093,274),(4094,274),(4095,274),(4096,274),(4097,274),(4098,274),(4099,274),(4100,274),(4101,275),(4102,275),(4103,275),(4104,275),(4105,275),(4106,275),(4107,275),(4108,275),(4109,275),(4110,276),(4111,276),(4112,276),(4113,276),(4114,276),(4115,276),(4116,276),(4117,277),(4118,277),(4119,277),(4120,277),(4121,277),(4122,277),(4123,277),(4124,278),(4125,278),(4126,278),(4127,278),(4128,278),(4129,278),(4130,278),(4131,279),(4132,279),(4133,279),(4134,279),(4135,279),(4136,279),(4137,279),(4138,280),(4139,280),(4140,280),(4141,280),(4142,280),(4143,280),(4144,280),(4145,207),(4146,208),(4147,209),(4148,210),(4149,211),(4150,212),(4151,213),(4152,214),(4153,215),(4154,216),(4155,217),(4156,218),(4157,219),(4158,220),(4159,221),(4160,221),(4161,222),(4162,222),(4163,223),(4164,223),(4165,224),(4166,224),(4167,225),(4168,225),(4169,226),(4170,226),(4171,227),(4172,227),(4173,228),(4174,228),(4175,229),(4176,229),(4177,230),(4178,230),(4179,231),(4180,231),(4181,232),(4182,232),(4183,233),(4184,233),(4185,234),(4186,234),(4187,235),(4188,235),(4189,236),(4190,236),(4191,237),(4192,237),(4193,238),(4194,238),(4195,239),(4196,239),(4197,240),(4198,241),(4199,242),(4200,243),(4201,244),(4202,244),(4203,245),(4204,245),(4205,246),(4206,247),(4207,248),(4208,249),(4209,249),(4210,250),(4211,250),(4212,251),(4213,251),(4214,252),(4215,252),(4216,253),(4217,253),(4218,254),(4219,254),(4220,255),(4221,255),(4222,256),(4223,256),(4224,257),(4225,257),(4226,258),(4227,259),(4228,260),(4229,261),(4230,262),(4231,263),(4232,264),(4233,265),(4234,266),(4235,266),(4236,267),(4237,267),(4238,268),(4239,268),(4240,269),(4241,269),(4242,270),(4243,270),(4244,271),(4245,271),(4246,272),(4247,272),(4248,273),(4249,273),(4250,274),(4251,274),(4252,275),(4253,275),(4254,276),(4255,276),(4256,277),(4257,277),(4258,278),(4259,278),(4260,279),(4261,279),(4262,280),(4263,280),(4264,207),(4265,207),(4266,207),(4267,208),(4268,208),(4269,208),(4270,209),(4271,209),(4272,209),(4273,210),(4274,210),(4275,210),(4276,211),(4277,211),(4278,211),(4279,212),(4280,212),(4281,212),(4282,213),(4283,213),(4284,213),(4285,214),(4286,214),(4287,214),(4288,215),(4289,215),(4290,215),(4291,216),(4292,216),(4293,216),(4294,217),(4295,217),(4296,217),(4297,218),(4298,218),(4299,218),(4300,219),(4301,219),(4302,219),(4303,220),(4304,220),(4305,220),(4306,221),(4307,221),(4308,221),(4309,222),(4310,222),(4311,222),(4312,223),(4313,223),(4314,223),(4315,224),(4316,224),(4317,224),(4318,225),(4319,225),(4320,225),(4321,226),(4322,226),(4323,226),(4324,227),(4325,227),(4326,227),(4327,228),(4328,228),(4329,228),(4330,229),(4331,229),(4332,229),(4333,230),(4334,230),(4335,230),(4336,231),(4337,231),(4338,231),(4339,232),(4340,232),(4341,232),(4342,233),(4343,233),(4344,233),(4345,234),(4346,234),(4347,234),(4348,235),(4349,235),(4350,235),(4351,236),(4352,236),(4353,236),(4354,237),(4355,237),(4356,237),(4357,238),(4358,238),(4359,238),(4360,239),(4361,239),(4362,239),(4363,240),(4364,240),(4365,240),(4366,241),(4367,241),(4368,241),(4369,242),(4370,242),(4371,242),(4372,243),(4373,243),(4374,243),(4375,244),(4376,244),(4377,245),(4378,245),(4379,246),(4380,246),(4381,246),(4382,247),(4383,247),(4384,247),(4385,248),(4386,248),(4387,248),(4388,249),(4389,249),(4390,249),(4391,250),(4392,250),(4393,250),(4394,251),(4395,251),(4396,252),(4397,252),(4398,252),(4399,253),(4400,253),(4401,253),(4402,254),(4403,254),(4404,254),(4405,255),(4406,255),(4407,255),(4408,256),(4409,256),(4410,256),(4411,257),(4412,257),(4413,257),(4414,258),(4415,258),(4416,258),(4417,259),(4418,259),(4419,259),(4420,260),(4421,260),(4422,260),(4423,261),(4424,261),(4425,261),(4426,262),(4427,262),(4428,262),(4429,263),(4430,263),(4431,263),(4432,264),(4433,264),(4434,264),(4435,265),(4436,265),(4437,265),(4438,266),(4439,266),(4440,266),(4441,267),(4442,267),(4443,267),(4444,268),(4445,268),(4446,268),(4447,269),(4448,269),(4449,269),(4450,270),(4451,270),(4452,270),(4453,271),(4454,271),(4455,271),(4456,272),(4457,272),(4458,272),(4459,273),(4460,273),(4461,273),(4462,274),(4463,274),(4464,274),(4465,275),(4466,275),(4467,275),(4468,276),(4469,276),(4470,276),(4471,277),(4472,277),(4473,277),(4474,278),(4475,278),(4476,278),(4477,279),(4478,279),(4479,279),(4480,280),(4481,280),(4482,280),(4483,207),(4484,207),(4485,207),(4486,207),(4487,208),(4488,208),(4489,208),(4490,208),(4491,209),(4492,209),(4493,209),(4494,209),(4495,210),(4496,210),(4497,210),(4498,210),(4499,211),(4500,211),(4501,211),(4502,211),(4503,212),(4504,212),(4505,212),(4506,212),(4507,213),(4508,213),(4509,213),(4510,213),(4511,214),(4512,214),(4513,214),(4514,214),(4515,215),(4516,215),(4517,215),(4518,215),(4519,216),(4520,216),(4521,216),(4522,216),(4523,217),(4524,217),(4525,217),(4526,217),(4527,218),(4528,218),(4529,218),(4530,218),(4531,219),(4532,219),(4533,219),(4534,219),(4535,220),(4536,220),(4537,220),(4538,220),(4539,221),(4540,221),(4541,221),(4542,221),(4543,222),(4544,222),(4545,222),(4546,222),(4547,223),(4548,223),(4549,223),(4550,223),(4551,224),(4552,224),(4553,224),(4554,224),(4555,225),(4556,225),(4557,225),(4558,225),(4559,226),(4560,226),(4561,226),(4562,226),(4563,227),(4564,227),(4565,227),(4566,227),(4567,228),(4568,228),(4569,228),(4570,228),(4571,229),(4572,229),(4573,229),(4574,229),(4575,230),(4576,230),(4577,230),(4578,230),(4579,231),(4580,231),(4581,231),(4582,231),(4583,232),(4584,232),(4585,232),(4586,232),(4587,233),(4588,233),(4589,233),(4590,233),(4591,234),(4592,234),(4593,234),(4594,234),(4595,235),(4596,235),(4597,235),(4598,235),(4599,236),(4600,236),(4601,236),(4602,236),(4603,237),(4604,237),(4605,237),(4606,237),(4607,238),(4608,238),(4609,238),(4610,238),(4611,239),(4612,239),(4613,239),(4614,239),(4615,240),(4616,240),(4617,240),(4618,240),(4619,241),(4620,241),(4621,241),(4622,241),(4623,242),(4624,242),(4625,242),(4626,242),(4627,243),(4628,243),(4629,243),(4630,243),(4631,244),(4632,244),(4633,244),(4634,244),(4635,245),(4636,245),(4637,245),(4638,245),(4639,246),(4640,246),(4641,246),(4642,246),(4643,247),(4644,247),(4645,247),(4646,247),(4647,248),(4648,248),(4649,248),(4650,248),(4651,249),(4652,249),(4653,249),(4654,249),(4655,250),(4656,250),(4657,250),(4658,250),(4659,251),(4660,251),(4661,251),(4662,251),(4663,252),(4664,252),(4665,252),(4666,252),(4667,253),(4668,253),(4669,253),(4670,253),(4671,254),(4672,254),(4673,254),(4674,254),(4675,255),(4676,255),(4677,255),(4678,255),(4679,256),(4680,256),(4681,256),(4682,256),(4683,257),(4684,257),(4685,257),(4686,257),(4687,258),(4688,258),(4689,258),(4690,258),(4691,259),(4692,259),(4693,259),(4694,259),(4695,260),(4696,260),(4697,260),(4698,260),(4699,261),(4700,261),(4701,261),(4702,261),(4703,262),(4704,262),(4705,262),(4706,262),(4707,263),(4708,263),(4709,263),(4710,263),(4711,264),(4712,264),(4713,264),(4714,264),(4715,265),(4716,265),(4717,265),(4718,265),(4719,266),(4720,266),(4721,266),(4722,266),(4723,267),(4724,267),(4725,267),(4726,267),(4727,268),(4728,268),(4729,268),(4730,268),(4731,269),(4732,269),(4733,269),(4734,269),(4735,270),(4736,270),(4737,270),(4738,270),(4739,271),(4740,271),(4741,271),(4742,271),(4743,272),(4744,272),(4745,272),(4746,272),(4747,273),(4748,273),(4749,273),(4750,273),(4751,274),(4752,274),(4753,274),(4754,274),(4755,275),(4756,275),(4757,275),(4758,275),(4759,276),(4760,276),(4761,276),(4762,276),(4763,277),(4764,277),(4765,277),(4766,277),(4767,278),(4768,278),(4769,278),(4770,278),(4771,279),(4772,279),(4773,279),(4774,279),(4775,280),(4776,280),(4777,280),(4778,280),(4779,7),(4780,8),(4781,9),(4782,10),(4783,11),(4784,12),(4785,13),(4786,14),(4787,15),(4788,16),(4789,17),(4790,18),(4791,19),(4792,20),(4793,21),(4794,22),(4795,23),(4796,24),(4797,25),(4798,26),(4799,27),(4800,28),(4801,29),(4802,30),(4803,31),(4804,32),(4805,33),(4806,34),(4807,35),(4808,36),(4809,37),(4810,38),(4811,39),(4812,40),(4813,41),(4814,42),(4815,43),(4816,44),(4817,45),(4818,46),(4819,47),(4820,48),(4821,49),(4822,50),(4823,51),(4824,52),(4825,53),(4826,54),(4827,55),(4828,56),(4829,57),(4830,58),(4831,59),(4832,60),(4833,61),(4834,62),(4835,63),(4836,64),(4837,65),(4838,66),(4839,67),(4840,68),(4841,69),(4842,70),(4843,71),(4844,72),(4845,73),(4846,74),(4847,75),(4848,76),(4849,77),(4850,78),(4851,79),(4852,80),(4853,81),(4854,82),(4855,83),(4856,84),(4857,85),(4858,86),(4859,87),(4860,88),(4861,89),(4862,90),(4863,91),(4864,92),(4865,93),(4866,94),(4867,95),(4868,96),(4869,97),(4870,98),(4871,99),(4872,100),(4873,101),(4874,102),(4875,103),(4876,104),(4877,105),(4878,106),(4879,107),(4880,108),(4881,109),(4882,110),(4883,111),(4884,112),(4885,113),(4886,114),(4887,115),(4888,116),(4889,117),(4890,118),(4891,119),(4892,120),(4893,121),(4894,122),(4895,123),(4896,124),(4897,125),(4898,126),(4899,127),(4900,128),(4901,129),(4902,130),(4903,131),(4904,132),(4905,133),(4906,134),(4907,135),(4908,136),(4909,137),(4910,138),(4911,139),(4912,140),(4913,141),(4914,142),(4915,143),(4916,144),(4917,145),(4918,146),(4919,147),(4920,148),(4921,149),(4922,150),(4923,151),(4924,152),(4925,153),(4926,154),(4927,155),(4928,156),(4929,157),(4930,158),(4931,159),(4932,160),(4933,161),(4934,162),(4935,163),(4936,164),(4937,165),(4938,166),(4939,167),(4940,168),(4941,169),(4942,170),(4943,171),(4944,172),(4945,173),(4946,174),(4947,175),(4948,176),(4949,177),(4950,178),(4951,179),(4952,180),(4953,181),(4954,182),(4955,183),(4956,184),(4957,185),(4958,186),(4959,187),(4960,188),(4961,189),(4962,190),(4963,191),(4964,192),(4965,193),(4966,194),(4967,195),(4968,196),(4969,197),(4970,198),(4971,199),(4972,200),(4973,201),(4974,202),(4975,203),(4976,204),(4977,205),(4978,206),(4979,207),(4980,208),(4981,209),(4982,210),(4983,211),(4984,212),(4985,213),(4986,214),(4987,215),(4988,216),(4989,217),(4990,218),(4991,219),(4992,220),(4993,221),(4994,222),(4995,223),(4996,224),(4997,225),(4998,226),(4999,227),(5000,228),(5001,229),(5002,230),(5003,231),(5004,232),(5005,233),(5006,234),(5007,235),(5008,236),(5009,237),(5010,238),(5011,239),(5012,240),(5013,241),(5014,242),(5015,243),(5016,244),(5017,245),(5018,246),(5019,247),(5020,248),(5021,249),(5022,251),(5023,252),(5024,253),(5025,254),(5026,255),(5027,256),(5028,257),(5029,258),(5030,259),(5031,260),(5032,261),(5033,262),(5034,263),(5035,264),(5036,265),(5037,266),(5038,267),(5039,268),(5040,269),(5041,270),(5042,271),(5043,272),(5044,273),(5045,274),(5046,275),(5047,276),(5048,277),(5049,278),(5050,279),(5051,280),(5052,250),(5053,281),(5054,282),(5055,283),(5056,284),(5057,285),(5058,286),(5059,287),(5060,288),(5061,289),(5062,290),(5063,291),(5064,292),(5065,293),(5066,294),(5067,295),(5068,296),(5069,297),(5070,298),(5071,299),(5072,300),(5073,301),(5074,302),(5075,303),(5076,304),(5077,305),(5078,306),(5079,307),(5080,308),(5081,309),(5082,310),(5083,311),(5084,312),(5085,313),(5086,314),(5087,315),(5088,316),(5089,317),(5090,318),(5091,319),(5092,320),(5093,321),(5094,322),(5095,323),(5096,324),(5097,325),(5098,326),(5099,327),(5100,328),(5101,329),(5102,330),(5103,331),(5104,332),(5105,333),(5106,334),(5107,335),(5108,336),(5109,337),(5110,338),(5111,339),(5112,340),(5113,341),(5114,342),(5115,343),(5116,344),(5117,345),(5118,346),(5119,347),(5120,348),(5121,349),(5122,350),(5123,351),(5124,352),(5125,353),(5126,354),(5127,355),(5128,356),(5129,357),(5130,358),(5131,359),(5132,360),(5133,361),(5134,362),(5135,363),(5136,364),(5137,365),(5138,366),(5139,367),(5140,368),(5141,369),(5142,370),(5143,371),(5144,372),(5145,373),(5146,374),(5147,375),(5148,376),(5149,377),(5150,378),(5151,379),(5152,380),(5153,281),(5154,281),(5155,282),(5156,282),(5157,283),(5158,283),(5159,284),(5160,284),(5161,285),(5162,285),(5163,286),(5164,286),(5165,287),(5166,287),(5167,288),(5168,288),(5169,289),(5170,289),(5171,290),(5172,290),(5173,291),(5174,291),(5175,292),(5176,292),(5177,293),(5178,293),(5179,294),(5180,294),(5181,295),(5182,295),(5183,296),(5184,296),(5185,297),(5186,297),(5187,298),(5188,298),(5189,299),(5190,299),(5191,300),(5192,300),(5193,301),(5194,301),(5195,302),(5196,302),(5197,303),(5198,303),(5199,304),(5200,304),(5201,305),(5202,305),(5203,306),(5204,306),(5205,307),(5206,307),(5207,308),(5208,308),(5209,309),(5210,309),(5211,310),(5212,310),(5213,311),(5214,311),(5215,312),(5216,312),(5217,313),(5218,313),(5219,314),(5220,314),(5221,315),(5222,315),(5223,316),(5224,316),(5225,317),(5226,317),(5227,318),(5228,318),(5229,319),(5230,319),(5231,320),(5232,320),(5233,321),(5234,321),(5235,322),(5236,322),(5237,323),(5238,323),(5239,324),(5240,324),(5241,325),(5242,325),(5243,326),(5244,326),(5245,327),(5246,327),(5247,328),(5248,328),(5249,329),(5250,329),(5251,330),(5252,330),(5253,331),(5254,331),(5255,332),(5256,332),(5257,333),(5258,333),(5259,334),(5260,334),(5261,335),(5262,335),(5263,336),(5264,336),(5265,337),(5266,337),(5267,338),(5268,338),(5269,339),(5270,339),(5271,340),(5272,340),(5273,341),(5274,341),(5275,342),(5276,342),(5277,343),(5278,343),(5279,344),(5280,344),(5281,345),(5282,345),(5283,346),(5284,346),(5285,347),(5286,347),(5287,348),(5288,348),(5289,349),(5290,349),(5291,350),(5292,350),(5293,351),(5294,351),(5295,352),(5296,352),(5297,353),(5298,353),(5299,354),(5300,354),(5301,355),(5302,355),(5303,356),(5304,356),(5305,357),(5306,357),(5307,358),(5308,358),(5309,359),(5310,359),(5311,360),(5312,360),(5313,361),(5314,361),(5315,362),(5316,362),(5317,363),(5318,363),(5319,364),(5320,364),(5321,365),(5322,365),(5323,366),(5324,366),(5325,367),(5326,367),(5327,368),(5328,368),(5329,369),(5330,369),(5331,370),(5332,370),(5333,371),(5334,371),(5335,372),(5336,372),(5337,373),(5338,373),(5339,374),(5340,374),(5341,375),(5342,375),(5343,376),(5344,376),(5345,377),(5346,377),(5347,378),(5348,378),(5349,379),(5350,379),(5351,380),(5352,380),(5353,281),(5354,281),(5355,281),(5356,281),(5357,281),(5358,281),(5359,282),(5360,282),(5361,282),(5362,282),(5363,283),(5364,283),(5365,283),(5366,283),(5367,284),(5368,284),(5369,284),(5370,284),(5371,284),(5372,284),(5373,285),(5374,285),(5375,285),(5376,285),(5377,286),(5378,286),(5379,286),(5380,286),(5381,286),(5382,286),(5383,287),(5384,287),(5385,287),(5386,287),(5387,287),(5388,287),(5389,288),(5390,288),(5391,288),(5392,288),(5393,289),(5394,289),(5395,289),(5396,289),(5397,289),(5398,289),(5399,290),(5400,290),(5401,290),(5402,290),(5403,291),(5404,291),(5405,291),(5406,291),(5407,291),(5408,291),(5409,292),(5410,292),(5411,292),(5412,292),(5413,292),(5414,292),(5415,293),(5416,293),(5417,293),(5418,293),(5419,294),(5420,294),(5421,294),(5422,294),(5423,294),(5424,294),(5425,295),(5426,295),(5427,295),(5428,295),(5429,296),(5430,296),(5431,296),(5432,296),(5433,296),(5434,296),(5435,297),(5436,297),(5437,297),(5438,297),(5439,297),(5440,297),(5441,298),(5442,298),(5443,298),(5444,298),(5445,298),(5446,298),(5447,299),(5448,299),(5449,299),(5450,299),(5451,299),(5452,299),(5453,300),(5454,300),(5455,300),(5456,300),(5457,300),(5458,300),(5459,301),(5460,301),(5461,301),(5462,301),(5463,302),(5464,302),(5465,302),(5466,302),(5467,303),(5468,303),(5469,303),(5470,303),(5471,304),(5472,304),(5473,304),(5474,304),(5475,304),(5476,304),(5477,305),(5478,305),(5479,305),(5480,305),(5481,306),(5482,306),(5483,306),(5484,306),(5485,307),(5486,307),(5487,307),(5488,307),(5489,307),(5490,307),(5491,308),(5492,308),(5493,308),(5494,308),(5495,308),(5496,309),(5497,309),(5498,309),(5499,309),(5500,310),(5501,310),(5502,310),(5503,310),(5504,311),(5505,311),(5506,311),(5507,311),(5508,311),(5509,312),(5510,312),(5511,312),(5512,312),(5513,312),(5514,312),(5515,313),(5516,313),(5517,313),(5518,313),(5519,314),(5520,314),(5521,314),(5522,314),(5523,314),(5524,314),(5525,315),(5526,315),(5527,315),(5528,315),(5529,316),(5530,316),(5531,316),(5532,316),(5533,317),(5534,317),(5535,317),(5536,317),(5537,317),(5538,317),(5539,318),(5540,318),(5541,318),(5542,318),(5543,319),(5544,319),(5545,319),(5546,319),(5547,319),(5548,319),(5549,320),(5550,320),(5551,320),(5552,320),(5553,320),(5554,320),(5555,321),(5556,321),(5557,321),(5558,321),(5559,321),(5560,321),(5561,322),(5562,322),(5563,322),(5564,322),(5565,322),(5566,322),(5567,323),(5568,323),(5569,323),(5570,323),(5571,323),(5572,323),(5573,324),(5574,324),(5575,324),(5576,324),(5577,325),(5578,325),(5579,325),(5580,325),(5581,326),(5582,326),(5583,326),(5584,326),(5585,327),(5586,327),(5587,327),(5588,327),(5589,328),(5590,328),(5591,328),(5592,328),(5593,329),(5594,329),(5595,329),(5596,329),(5597,330),(5598,330),(5599,330),(5600,330),(5601,331),(5602,331),(5603,331),(5604,331),(5605,332),(5606,332),(5607,332),(5608,332),(5609,332),(5610,333),(5611,333),(5612,333),(5613,333),(5614,333),(5615,334),(5616,334),(5617,334),(5618,334),(5619,334),(5620,334),(5621,335),(5622,335),(5623,335),(5624,335),(5625,335),(5626,335),(5627,336),(5628,336),(5629,336),(5630,336),(5631,336),(5632,337),(5633,337),(5634,337),(5635,337),(5636,337),(5637,338),(5638,338),(5639,338),(5640,338),(5641,338),(5642,338),(5643,339),(5644,339),(5645,339),(5646,339),(5647,339),(5648,339),(5649,340),(5650,340),(5651,340),(5652,340),(5653,340),(5654,340),(5655,341),(5656,341),(5657,341),(5658,341),(5659,341),(5660,341),(5661,342),(5662,342),(5663,342),(5664,342),(5665,342),(5666,342),(5667,343),(5668,343),(5669,343),(5670,343),(5671,344),(5672,344),(5673,344),(5674,344),(5675,344),(5676,344),(5677,345),(5678,345),(5679,345),(5680,345),(5681,345),(5682,345),(5683,346),(5684,346),(5685,346),(5686,346),(5687,346),(5688,347),(5689,347),(5690,347),(5691,347),(5692,348),(5693,348),(5694,348),(5695,348),(5696,348),(5697,348),(5698,349),(5699,349),(5700,349),(5701,349),(5702,349),(5703,349),(5704,350),(5705,350),(5706,350),(5707,350),(5708,350),(5709,350),(5710,351),(5711,351),(5712,351),(5713,351),(5714,351),(5715,351),(5716,352),(5717,352),(5718,352),(5719,352),(5720,352),(5721,352),(5722,353),(5723,353),(5724,353),(5725,353),(5726,353),(5727,353),(5728,354),(5729,354),(5730,354),(5731,354),(5732,354),(5733,354),(5734,355),(5735,355),(5736,355),(5737,355),(5738,355),(5739,355),(5740,356),(5741,356),(5742,356),(5743,356),(5744,356),(5745,356),(5746,357),(5747,357),(5748,357),(5749,357),(5750,357),(5751,357),(5752,358),(5753,358),(5754,358),(5755,358),(5756,358),(5757,358),(5758,359),(5759,359),(5760,359),(5761,359),(5762,359),(5763,359),(5764,360),(5765,360),(5766,360),(5767,360),(5768,360),(5769,360),(5770,361),(5771,361),(5772,361),(5773,361),(5774,361),(5775,361),(5776,362),(5777,362),(5778,362),(5779,362),(5780,362),(5781,362),(5782,363),(5783,363),(5784,363),(5785,363),(5786,363),(5787,363),(5788,364),(5789,364),(5790,364),(5791,364),(5792,364),(5793,364),(5794,365),(5795,365),(5796,365),(5797,365),(5798,365),(5799,365),(5800,366),(5801,366),(5802,366),(5803,366),(5804,366),(5805,366),(5806,367),(5807,367),(5808,367),(5809,367),(5810,367),(5811,367),(5812,368),(5813,368),(5814,368),(5815,368),(5816,368),(5817,368),(5818,369),(5819,369),(5820,369),(5821,369),(5822,369),(5823,369),(5824,370),(5825,370),(5826,370),(5827,370),(5828,370),(5829,370),(5830,371),(5831,371),(5832,371),(5833,371),(5834,371),(5835,371),(5836,372),(5837,372),(5838,372),(5839,372),(5840,372),(5841,372),(5842,373),(5843,373),(5844,373),(5845,373),(5846,373),(5847,373),(5848,374),(5849,374),(5850,374),(5851,374),(5852,374),(5853,374),(5854,375),(5855,375),(5856,375),(5857,375),(5858,375),(5859,375),(5860,376),(5861,376),(5862,376),(5863,376),(5864,376),(5865,376),(5866,377),(5867,377),(5868,377),(5869,377),(5870,377),(5871,377),(5872,378),(5873,378),(5874,378),(5875,378),(5876,378),(5877,378),(5878,379),(5879,379),(5880,379),(5881,379),(5882,379),(5883,379),(5884,380),(5885,380),(5886,380),(5887,380),(5888,380),(5889,380),(5890,281),(5891,281),(5892,281),(5893,282),(5894,282),(5895,283),(5896,283),(5897,284),(5898,284),(5899,284),(5900,285),(5901,285),(5902,286),(5903,286),(5904,286),(5905,287),(5906,287),(5907,287),(5908,288),(5909,288),(5910,289),(5911,289),(5912,289),(5913,290),(5914,290),(5915,291),(5916,291),(5917,291),(5918,292),(5919,292),(5920,292),(5921,293),(5922,293),(5923,294),(5924,294),(5925,294),(5926,295),(5927,295),(5928,296),(5929,296),(5930,296),(5931,297),(5932,297),(5933,297),(5934,298),(5935,298),(5936,298),(5937,299),(5938,299),(5939,299),(5940,300),(5941,300),(5942,300),(5943,301),(5944,301),(5945,302),(5946,302),(5947,303),(5948,303),(5949,304),(5950,304),(5951,304),(5952,305),(5953,305),(5954,306),(5955,306),(5956,307),(5957,307),(5958,307),(5959,308),(5960,308),(5961,309),(5962,309),(5963,310),(5964,310),(5965,311),(5966,311),(5967,311),(5968,312),(5969,312),(5970,312),(5971,313),(5972,313),(5973,314),(5974,314),(5975,314),(5976,315),(5977,315),(5978,316),(5979,316),(5980,317),(5981,317),(5982,317),(5983,318),(5984,318),(5985,319),(5986,319),(5987,319),(5988,320),(5989,320),(5990,320),(5991,321),(5992,321),(5993,321),(5994,322),(5995,322),(5996,322),(5997,323),(5998,323),(5999,323),(6000,324),(6001,324),(6002,325),(6003,325),(6004,326),(6005,326),(6006,327),(6007,327),(6008,328),(6009,328),(6010,329),(6011,329),(6012,330),(6013,330),(6014,331),(6015,331),(6016,332),(6017,332),(6018,332),(6019,333),(6020,333),(6021,333),(6022,334),(6023,334),(6024,335),(6025,335),(6026,336),(6027,336),(6028,336),(6029,337),(6030,337),(6031,337),(6032,338),(6033,338),(6034,339),(6035,339),(6036,340),(6037,340),(6038,341),(6039,341),(6040,342),(6041,342),(6042,342),(6043,343),(6044,343),(6045,344),(6046,344),(6047,345),(6048,345),(6049,346),(6050,346),(6051,347),(6052,347),(6053,348),(6054,348),(6055,349),(6056,349),(6057,350),(6058,350),(6059,351),(6060,351),(6061,352),(6062,352),(6063,353),(6064,353),(6065,354),(6066,354),(6067,355),(6068,355),(6069,356),(6070,356),(6071,357),(6072,357),(6073,358),(6074,358),(6075,359),(6076,359),(6077,360),(6078,360),(6079,361),(6080,361),(6081,362),(6082,362),(6083,363),(6084,363),(6085,364),(6086,364),(6087,365),(6088,365),(6089,366),(6090,366),(6091,367),(6092,367),(6093,368),(6094,368),(6095,369),(6096,369),(6097,370),(6098,370),(6099,371),(6100,371),(6101,372),(6102,372),(6103,373),(6104,373),(6105,374),(6106,374),(6107,375),(6108,375),(6109,376),(6110,376),(6111,377),(6112,377),(6113,378),(6114,378),(6115,379),(6116,379),(6117,380),(6118,380),(6119,281),(6120,281),(6121,281),(6122,282),(6123,282),(6124,282),(6125,283),(6126,283),(6127,283),(6128,284),(6129,284),(6130,284),(6131,285),(6132,285),(6133,285),(6134,286),(6135,286),(6136,286),(6137,287),(6138,287),(6139,287),(6140,288),(6141,288),(6142,288),(6143,289),(6144,289),(6145,289),(6146,290),(6147,290),(6148,290),(6149,291),(6150,291),(6151,291),(6152,292),(6153,292),(6154,292),(6155,293),(6156,293),(6157,293),(6158,294),(6159,294),(6160,294),(6161,295),(6162,295),(6163,295),(6164,296),(6165,296),(6166,296),(6167,297),(6168,297),(6169,297),(6170,298),(6171,298),(6172,298),(6173,299),(6174,299),(6175,299),(6176,300),(6177,300),(6178,300),(6179,301),(6180,301),(6181,301),(6182,302),(6183,302),(6184,302),(6185,303),(6186,303),(6187,303),(6188,304),(6189,304),(6190,304),(6191,305),(6192,305),(6193,305),(6194,306),(6195,306),(6196,306),(6197,307),(6198,307),(6199,307),(6200,308),(6201,308),(6202,308),(6203,309),(6204,309),(6205,309),(6206,310),(6207,310),(6208,310),(6209,311),(6210,311),(6211,311),(6212,312),(6213,312),(6214,312),(6215,313),(6216,313),(6217,313),(6218,314),(6219,314),(6220,314),(6221,315),(6222,315),(6223,315),(6224,316),(6225,316),(6226,316),(6227,317),(6228,317),(6229,317),(6230,318),(6231,318),(6232,318),(6233,319),(6234,319),(6235,319),(6236,320),(6237,320),(6238,320),(6239,321),(6240,321),(6241,321),(6242,322),(6243,322),(6244,322),(6245,323),(6246,323),(6247,323),(6248,324),(6249,324),(6250,324),(6251,325),(6252,325),(6253,325),(6254,326),(6255,326),(6256,326),(6257,327),(6258,327),(6259,327),(6260,328),(6261,328),(6262,328),(6263,329),(6264,329),(6265,329),(6266,330),(6267,330),(6268,330),(6269,331),(6270,331),(6271,331),(6272,332),(6273,332),(6274,332),(6275,333),(6276,333),(6277,333),(6278,334),(6279,334),(6280,334),(6281,335),(6282,335),(6283,335),(6284,336),(6285,336),(6286,336),(6287,337),(6288,337),(6289,337),(6290,338),(6291,338),(6292,338),(6293,339),(6294,339),(6295,339),(6296,340),(6297,340),(6298,340),(6299,341),(6300,341),(6301,341),(6302,342),(6303,342),(6304,342),(6305,343),(6306,343),(6307,343),(6308,344),(6309,344),(6310,344),(6311,345),(6312,345),(6313,345),(6314,346),(6315,346),(6316,346),(6317,347),(6318,347),(6319,347),(6320,348),(6321,348),(6322,348),(6323,349),(6324,349),(6325,349),(6326,350),(6327,350),(6328,350),(6329,351),(6330,351),(6331,351),(6332,352),(6333,352),(6334,352),(6335,353),(6336,353),(6337,353),(6338,354),(6339,354),(6340,354),(6341,355),(6342,355),(6343,355),(6344,356),(6345,356),(6346,356),(6347,357),(6348,357),(6349,357),(6350,358),(6351,358),(6352,358),(6353,359),(6354,359),(6355,359),(6356,360),(6357,360),(6358,360),(6359,361),(6360,361),(6361,361),(6362,362),(6363,362),(6364,362),(6365,363),(6366,363),(6367,363),(6368,364),(6369,364),(6370,364),(6371,365),(6372,365),(6373,365),(6374,366),(6375,366),(6376,366),(6377,367),(6378,367),(6379,367),(6380,368),(6381,368),(6382,368),(6383,369),(6384,369),(6385,369),(6386,370),(6387,370),(6388,370),(6389,371),(6390,371),(6391,371),(6392,372),(6393,372),(6394,372),(6395,373),(6396,373),(6397,373),(6398,374),(6399,374),(6400,374),(6401,375),(6402,375),(6403,375),(6404,376),(6405,376),(6406,376),(6407,377),(6408,377),(6409,377),(6410,378),(6411,378),(6412,378),(6413,379),(6414,379),(6415,379),(6416,380),(6417,380),(6418,380),(6419,281),(6420,281),(6421,281),(6422,281),(6423,282),(6424,282),(6425,282),(6426,282),(6427,283),(6428,283),(6429,283),(6430,283),(6431,284),(6432,284),(6433,284),(6434,284),(6435,285),(6436,285),(6437,285),(6438,285),(6439,286),(6440,286),(6441,286),(6442,286),(6443,287),(6444,287),(6445,287),(6446,287),(6447,288),(6448,288),(6449,288),(6450,288),(6451,289),(6452,289),(6453,289),(6454,289),(6455,290),(6456,290),(6457,290),(6458,290),(6459,291),(6460,291),(6461,291),(6462,291),(6463,292),(6464,292),(6465,292),(6466,292),(6467,293),(6468,293),(6469,293),(6470,293),(6471,294),(6472,294),(6473,294),(6474,294),(6475,295),(6476,295),(6477,295),(6478,295),(6479,296),(6480,296),(6481,296),(6482,296),(6483,297),(6484,297),(6485,297),(6486,297),(6487,298),(6488,298),(6489,298),(6490,298),(6491,299),(6492,299),(6493,299),(6494,299),(6495,300),(6496,300),(6497,300),(6498,300),(6499,301),(6500,301),(6501,301),(6502,301),(6503,302),(6504,302),(6505,302),(6506,302),(6507,303),(6508,303),(6509,303),(6510,303),(6511,304),(6512,304),(6513,304),(6514,304),(6515,305),(6516,305),(6517,305),(6518,305),(6519,306),(6520,306),(6521,306),(6522,306),(6523,307),(6524,307),(6525,307),(6526,307),(6527,308),(6528,308),(6529,308),(6530,308),(6531,309),(6532,309),(6533,309),(6534,309),(6535,310),(6536,310),(6537,310),(6538,310),(6539,311),(6540,311),(6541,311),(6542,311),(6543,312),(6544,312),(6545,312),(6546,312),(6547,313),(6548,313),(6549,313),(6550,313),(6551,314),(6552,314),(6553,314),(6554,314),(6555,315),(6556,315),(6557,315),(6558,315),(6559,316),(6560,316),(6561,316),(6562,316),(6563,317),(6564,317),(6565,317),(6566,317),(6567,318),(6568,318),(6569,318),(6570,318),(6571,319),(6572,319),(6573,319),(6574,319),(6575,320),(6576,320),(6577,320),(6578,320),(6579,321),(6580,321),(6581,321),(6582,321),(6583,322),(6584,322),(6585,322),(6586,322),(6587,323),(6588,323),(6589,323),(6590,323),(6591,324),(6592,324),(6593,324),(6594,324),(6595,325),(6596,325),(6597,325),(6598,325),(6599,326),(6600,326),(6601,326),(6602,326),(6603,327),(6604,327),(6605,327),(6606,327),(6607,328),(6608,328),(6609,328),(6610,328),(6611,329),(6612,329),(6613,329),(6614,329),(6615,330),(6616,330),(6617,330),(6618,330),(6619,331),(6620,331),(6621,331),(6622,331),(6623,332),(6624,332),(6625,332),(6626,332),(6627,333),(6628,333),(6629,333),(6630,333),(6631,334),(6632,334),(6633,334),(6634,334),(6635,335),(6636,335),(6637,335),(6638,335),(6639,336),(6640,336),(6641,336),(6642,336),(6643,337),(6644,337),(6645,337),(6646,337),(6647,338),(6648,338),(6649,338),(6650,338),(6651,339),(6652,339),(6653,339),(6654,339),(6655,340),(6656,340),(6657,340),(6658,340),(6659,341),(6660,341),(6661,341),(6662,341),(6663,342),(6664,342),(6665,342),(6666,342),(6667,343),(6668,343),(6669,343),(6670,343),(6671,344),(6672,344),(6673,344),(6674,344),(6675,345),(6676,345),(6677,345),(6678,345),(6679,346),(6680,346),(6681,346),(6682,346),(6683,347),(6684,347),(6685,347),(6686,347),(6687,348),(6688,348),(6689,348),(6690,348),(6691,349),(6692,349),(6693,349),(6694,349),(6695,350),(6696,350),(6697,350),(6698,350),(6699,351),(6700,351),(6701,351),(6702,351),(6703,352),(6704,352),(6705,352),(6706,352),(6707,353),(6708,353),(6709,353),(6710,353),(6711,354),(6712,354),(6713,354),(6714,354),(6715,355),(6716,355),(6717,355),(6718,355),(6719,356),(6720,356),(6721,356),(6722,356),(6723,357),(6724,357),(6725,357),(6726,357),(6727,358),(6728,358),(6729,358),(6730,358),(6731,359),(6732,359),(6733,359),(6734,359),(6735,360),(6736,360),(6737,360),(6738,360),(6739,361),(6740,361),(6741,361),(6742,361),(6743,362),(6744,362),(6745,362),(6746,362),(6747,363),(6748,363),(6749,363),(6750,363),(6751,364),(6752,364),(6753,364),(6754,364),(6755,365),(6756,365),(6757,365),(6758,365),(6759,366),(6760,366),(6761,366),(6762,366),(6763,367),(6764,367),(6765,367),(6766,367),(6767,368),(6768,368),(6769,368),(6770,368),(6771,369),(6772,369),(6773,369),(6774,369),(6775,370),(6776,370),(6777,370),(6778,370),(6779,371),(6780,371),(6781,371),(6782,371),(6783,372),(6784,372),(6785,372),(6786,372),(6787,373),(6788,373),(6789,373),(6790,373),(6791,374),(6792,374),(6793,374),(6794,374),(6795,375),(6796,375),(6797,375),(6798,375),(6799,376),(6800,376),(6801,376),(6802,376),(6803,377),(6804,377),(6805,377),(6806,377),(6807,378),(6808,378),(6809,378),(6810,378),(6811,379),(6812,379),(6813,379),(6814,379),(6815,380),(6816,380),(6817,380),(6818,380),(6819,381),(6820,382),(6821,383),(6822,384),(6823,385),(6824,386),(6825,387),(6826,388),(6827,389),(6828,390),(6829,391),(6830,392),(6831,393),(6832,394),(6833,395),(6834,396),(6835,397),(6836,398),(6837,399),(6838,400),(6839,401),(6840,402),(6841,403),(6842,404),(6843,405),(6844,406),(6845,407),(6846,408),(6847,409),(6848,410),(6849,411),(6850,412),(6851,413),(6852,414),(6853,415),(6854,416),(6855,417),(6856,418),(6857,419),(6858,420),(6859,421),(6860,422),(6861,423),(6862,424),(6863,425),(6864,426),(6865,427),(6866,428),(6867,429),(6868,430),(6869,431),(6870,432),(6871,433),(6872,434),(6873,435),(6874,436),(6875,437),(6876,438),(6877,439),(6878,440),(6879,441),(6880,442),(6881,443),(6882,444),(6883,445),(6884,446),(6885,447),(6886,448),(6887,449),(6888,450),(6889,451),(6890,452),(6891,453),(6892,454),(6893,455),(6894,456),(6895,457),(6896,458),(6897,459),(6898,460),(6899,461),(6900,462),(6901,463),(6902,464),(6903,465),(6904,466),(6905,467),(6906,468),(6907,469),(6908,470),(6909,471),(6910,472),(6911,473),(6912,474),(6913,475),(6914,476),(6915,477),(6916,478),(6917,479),(6918,480),(6919,381),(6920,381),(6921,382),(6922,382),(6923,383),(6924,383),(6925,384),(6926,384),(6927,385),(6928,385),(6929,386),(6930,386),(6931,387),(6932,387),(6933,388),(6934,388),(6935,389),(6936,389),(6937,390),(6938,390),(6939,391),(6940,391),(6941,392),(6942,392),(6943,393),(6944,393),(6945,394),(6946,394),(6947,395),(6948,395),(6949,396),(6950,396),(6951,397),(6952,397),(6953,398),(6954,398),(6955,399),(6956,399),(6957,400),(6958,400),(6959,401),(6960,401),(6961,402),(6962,402),(6963,403),(6964,403),(6965,404),(6966,404),(6967,405),(6968,405),(6969,406),(6970,406),(6971,407),(6972,407),(6973,408),(6974,408),(6975,409),(6976,409),(6977,410),(6978,410),(6979,411),(6980,411),(6981,412),(6982,412),(6983,413),(6984,413),(6985,414),(6986,414),(6987,415),(6988,415),(6989,416),(6990,416),(6991,417),(6992,417),(6993,418),(6994,418),(6995,419),(6996,419),(6997,420),(6998,420),(6999,421),(7000,421),(7001,422),(7002,422),(7003,423),(7004,423),(7005,424),(7006,424),(7007,425),(7008,425),(7009,426),(7010,426),(7011,427),(7012,427),(7013,428),(7014,428),(7015,429),(7016,429),(7017,430),(7018,430),(7019,431),(7020,431),(7021,432),(7022,432),(7023,433),(7024,433),(7025,434),(7026,434),(7027,435),(7028,435),(7029,436),(7030,436),(7031,437),(7032,437),(7033,438),(7034,438),(7035,439),(7036,439),(7037,440),(7038,440),(7039,441),(7040,441),(7041,442),(7042,442),(7043,443),(7044,443),(7045,444),(7046,444),(7047,445),(7048,445),(7049,446),(7050,446),(7051,447),(7052,447),(7053,448),(7054,448),(7055,449),(7056,449),(7057,450),(7058,450),(7059,451),(7060,451),(7061,452),(7062,452),(7063,453),(7064,453),(7065,454),(7066,454),(7067,455),(7068,455),(7069,456),(7070,456),(7071,457),(7072,457),(7073,458),(7074,458),(7075,459),(7076,459),(7077,460),(7078,460),(7079,461),(7080,461),(7081,462),(7082,462),(7083,463),(7084,463),(7085,464),(7086,464),(7087,465),(7088,465),(7089,466),(7090,466),(7091,467),(7092,467),(7093,468),(7094,468),(7095,469),(7096,469),(7097,470),(7098,470),(7099,471),(7100,471),(7101,472),(7102,472),(7103,473),(7104,473),(7105,474),(7106,474),(7107,475),(7108,475),(7109,476),(7110,476),(7111,477),(7112,477),(7113,478),(7114,478),(7115,479),(7116,479),(7117,480),(7118,480),(7119,381),(7120,381),(7121,381),(7122,381),(7123,381),(7124,381),(7125,382),(7126,382),(7127,382),(7128,382),(7129,382),(7130,382),(7131,383),(7132,383),(7133,383),(7134,383),(7135,383),(7136,383),(7137,384),(7138,384),(7139,384),(7140,384),(7141,384),(7142,384),(7143,385),(7144,385),(7145,385),(7146,385),(7147,385),(7148,385),(7149,386),(7150,386),(7151,386),(7152,386),(7153,386),(7154,386),(7155,387),(7156,387),(7157,387),(7158,387),(7159,387),(7160,387),(7161,388),(7162,388),(7163,388),(7164,388),(7165,388),(7166,388),(7167,389),(7168,389),(7169,389),(7170,389),(7171,389),(7172,389),(7173,390),(7174,390),(7175,390),(7176,390),(7177,390),(7178,390),(7179,391),(7180,391),(7181,391),(7182,391),(7183,391),(7184,391),(7185,392),(7186,392),(7187,392),(7188,392),(7189,392),(7190,392),(7191,393),(7192,393),(7193,393),(7194,393),(7195,393),(7196,393),(7197,394),(7198,394),(7199,394),(7200,394),(7201,394),(7202,394),(7203,395),(7204,395),(7205,395),(7206,395),(7207,395),(7208,395),(7209,396),(7210,396),(7211,396),(7212,396),(7213,396),(7214,396),(7215,397),(7216,397),(7217,397),(7218,397),(7219,397),(7220,397),(7221,398),(7222,398),(7223,398),(7224,398),(7225,398),(7226,398),(7227,399),(7228,399),(7229,399),(7230,399),(7231,399),(7232,399),(7233,400),(7234,400),(7235,400),(7236,400),(7237,400),(7238,400),(7239,401),(7240,401),(7241,401),(7242,401),(7243,401),(7244,401),(7245,402),(7246,402),(7247,402),(7248,402),(7249,402),(7250,402),(7251,403),(7252,403),(7253,403),(7254,403),(7255,403),(7256,403),(7257,404),(7258,404),(7259,404),(7260,404),(7261,404),(7262,404),(7263,405),(7264,405),(7265,405),(7266,405),(7267,405),(7268,405),(7269,406),(7270,406),(7271,406),(7272,406),(7273,406),(7274,406),(7275,407),(7276,407),(7277,407),(7278,407),(7279,407),(7280,407),(7281,408),(7282,408),(7283,408),(7284,408),(7285,408),(7286,408),(7287,409),(7288,409),(7289,409),(7290,409),(7291,409),(7292,409),(7293,410),(7294,410),(7295,410),(7296,410),(7297,410),(7298,410),(7299,411),(7300,411),(7301,411),(7302,411),(7303,411),(7304,411),(7305,412),(7306,412),(7307,412),(7308,412),(7309,412),(7310,412),(7311,413),(7312,413),(7313,413),(7314,413),(7315,413),(7316,413),(7317,414),(7318,414),(7319,414),(7320,414),(7321,414),(7322,414),(7323,415),(7324,415),(7325,415),(7326,415),(7327,415),(7328,415),(7329,416),(7330,416),(7331,416),(7332,416),(7333,416),(7334,416),(7335,417),(7336,417),(7337,417),(7338,417),(7339,417),(7340,417),(7341,418),(7342,418),(7343,418),(7344,418),(7345,418),(7346,418),(7347,419),(7348,419),(7349,419),(7350,419),(7351,419),(7352,419),(7353,420),(7354,420),(7355,420),(7356,420),(7357,420),(7358,420),(7359,421),(7360,421),(7361,421),(7362,421),(7363,421),(7364,421),(7365,422),(7366,422),(7367,422),(7368,422),(7369,422),(7370,422),(7371,423),(7372,423),(7373,423),(7374,423),(7375,423),(7376,423),(7377,424),(7378,424),(7379,424),(7380,424),(7381,424),(7382,424),(7383,425),(7384,425),(7385,425),(7386,425),(7387,425),(7388,425),(7389,426),(7390,426),(7391,426),(7392,426),(7393,426),(7394,426),(7395,427),(7396,427),(7397,427),(7398,427),(7399,427),(7400,427),(7401,428),(7402,428),(7403,428),(7404,428),(7405,428),(7406,428),(7407,429),(7408,429),(7409,429),(7410,429),(7411,429),(7412,429),(7413,430),(7414,430),(7415,430),(7416,430),(7417,430),(7418,430),(7419,431),(7420,431),(7421,431),(7422,431),(7423,431),(7424,431),(7425,432),(7426,432),(7427,432),(7428,432),(7429,432),(7430,432),(7431,433),(7432,433),(7433,433),(7434,433),(7435,433),(7436,433),(7437,434),(7438,434),(7439,434),(7440,434),(7441,434),(7442,434),(7443,435),(7444,435),(7445,435),(7446,435),(7447,435),(7448,435),(7449,436),(7450,436),(7451,436),(7452,436),(7453,436),(7454,436),(7455,437),(7456,437),(7457,437),(7458,437),(7459,437),(7460,437),(7461,438),(7462,438),(7463,438),(7464,438),(7465,438),(7466,438),(7467,439),(7468,439),(7469,439),(7470,439),(7471,439),(7472,439),(7473,440),(7474,440),(7475,440),(7476,440),(7477,440),(7478,440),(7479,441),(7480,441),(7481,441),(7482,441),(7483,441),(7484,441),(7485,442),(7486,442),(7487,442),(7488,442),(7489,442),(7490,442),(7491,443),(7492,443),(7493,443),(7494,443),(7495,443),(7496,443),(7497,444),(7498,444),(7499,444),(7500,444),(7501,444),(7502,444),(7503,445),(7504,445),(7505,445),(7506,445),(7507,445),(7508,445),(7509,446),(7510,446),(7511,446),(7512,446),(7513,446),(7514,446),(7515,447),(7516,447),(7517,447),(7518,447),(7519,447),(7520,447),(7521,448),(7522,448),(7523,448),(7524,448),(7525,448),(7526,448),(7527,449),(7528,449),(7529,449),(7530,449),(7531,449),(7532,449),(7533,450),(7534,450),(7535,450),(7536,450),(7537,450),(7538,450),(7539,451),(7540,451),(7541,451),(7542,451),(7543,451),(7544,451),(7545,452),(7546,452),(7547,452),(7548,452),(7549,452),(7550,452),(7551,453),(7552,453),(7553,453),(7554,453),(7555,453),(7556,453),(7557,454),(7558,454),(7559,454),(7560,454),(7561,454),(7562,454),(7563,455),(7564,455),(7565,455),(7566,455),(7567,455),(7568,455),(7569,456),(7570,456),(7571,456),(7572,456),(7573,456),(7574,456),(7575,457),(7576,457),(7577,457),(7578,457),(7579,457),(7580,457),(7581,458),(7582,458),(7583,458),(7584,458),(7585,458),(7586,458),(7587,459),(7588,459),(7589,459),(7590,459),(7591,459),(7592,459),(7593,460),(7594,460),(7595,460),(7596,460),(7597,460),(7598,460),(7599,461),(7600,461),(7601,461),(7602,461),(7603,461),(7604,461),(7605,462),(7606,462),(7607,462),(7608,462),(7609,462),(7610,462),(7611,463),(7612,463),(7613,463),(7614,463),(7615,463),(7616,463),(7617,464),(7618,464),(7619,464),(7620,464),(7621,464),(7622,464),(7623,465),(7624,465),(7625,465),(7626,465),(7627,465),(7628,465),(7629,466),(7630,466),(7631,466),(7632,466),(7633,466),(7634,466),(7635,467),(7636,467),(7637,467),(7638,467),(7639,467),(7640,467),(7641,468),(7642,468),(7643,468),(7644,468),(7645,468),(7646,468),(7647,469),(7648,469),(7649,469),(7650,469),(7651,469),(7652,469),(7653,470),(7654,470),(7655,470),(7656,470),(7657,470),(7658,470),(7659,471),(7660,471),(7661,471),(7662,471),(7663,471),(7664,471),(7665,472),(7666,472),(7667,472),(7668,472),(7669,472),(7670,472),(7671,473),(7672,473),(7673,473),(7674,473),(7675,473),(7676,473),(7677,474),(7678,474),(7679,474),(7680,474),(7681,474),(7682,474),(7683,475),(7684,475),(7685,475),(7686,475),(7687,475),(7688,475),(7689,476),(7690,476),(7691,476),(7692,476),(7693,476),(7694,476),(7695,477),(7696,477),(7697,477),(7698,477),(7699,477),(7700,477),(7701,478),(7702,478),(7703,478),(7704,478),(7705,478),(7706,478),(7707,479),(7708,479),(7709,479),(7710,479),(7711,479),(7712,479),(7713,480),(7714,480),(7715,480),(7716,480),(7717,480),(7718,480),(7719,381),(7720,381),(7721,382),(7722,382),(7723,383),(7724,383),(7725,384),(7726,384),(7727,385),(7728,385),(7729,386),(7730,386),(7731,387),(7732,387),(7733,388),(7734,388),(7735,389),(7736,389),(7737,390),(7738,390),(7739,391),(7740,391),(7741,392),(7742,392),(7743,393),(7744,393),(7745,394),(7746,394),(7747,395),(7748,395),(7749,396),(7750,396),(7751,397),(7752,397),(7753,398),(7754,398),(7755,399),(7756,399),(7757,400),(7758,400),(7759,401),(7760,401),(7761,402),(7762,402),(7763,403),(7764,403),(7765,404),(7766,404),(7767,405),(7768,405),(7769,406),(7770,406),(7771,407),(7772,407),(7773,408),(7774,408),(7775,409),(7776,409),(7777,410),(7778,410),(7779,411),(7780,411),(7781,412),(7782,412),(7783,413),(7784,413),(7785,414),(7786,414),(7787,415),(7788,415),(7789,416),(7790,416),(7791,417),(7792,417),(7793,418),(7794,418),(7795,419),(7796,419),(7797,420),(7798,420),(7799,421),(7800,421),(7801,422),(7802,422),(7803,423),(7804,423),(7805,424),(7806,424),(7807,425),(7808,425),(7809,426),(7810,426),(7811,427),(7812,427),(7813,428),(7814,428),(7815,429),(7816,429),(7817,430),(7818,430),(7819,431),(7820,431),(7821,432),(7822,432),(7823,433),(7824,433),(7825,434),(7826,434),(7827,435),(7828,435),(7829,436),(7830,436),(7831,437),(7832,437),(7833,438),(7834,438),(7835,439),(7836,439),(7837,440),(7838,440),(7839,441),(7840,441),(7841,442),(7842,442),(7843,443),(7844,443),(7845,444),(7846,444),(7847,445),(7848,445),(7849,446),(7850,446),(7851,447),(7852,447),(7853,448),(7854,448),(7855,449),(7856,449),(7857,450),(7858,450),(7859,451),(7860,451),(7861,452),(7862,452),(7863,453),(7864,453),(7865,454),(7866,454),(7867,455),(7868,455),(7869,456),(7870,456),(7871,457),(7872,457),(7873,458),(7874,458),(7875,459),(7876,459),(7877,460),(7878,460),(7879,461),(7880,461),(7881,462),(7882,462),(7883,463),(7884,463),(7885,464),(7886,464),(7887,465),(7888,465),(7889,466),(7890,466),(7891,467),(7892,467),(7893,468),(7894,468),(7895,469),(7896,469),(7897,470),(7898,470),(7899,471),(7900,471),(7901,472),(7902,472),(7903,473),(7904,473),(7905,474),(7906,474),(7907,475),(7908,475),(7909,476),(7910,476),(7911,477),(7912,477),(7913,478),(7914,478),(7915,479),(7916,479),(7917,480),(7918,480),(7919,381),(7920,381),(7921,381),(7922,382),(7923,382),(7924,382),(7925,383),(7926,383),(7927,383),(7928,384),(7929,384),(7930,384),(7931,385),(7932,385),(7933,385),(7934,386),(7935,386),(7936,386),(7937,387),(7938,387),(7939,387),(7940,388),(7941,388),(7942,388),(7943,389),(7944,389),(7945,389),(7946,390),(7947,390),(7948,390),(7949,391),(7950,391),(7951,391),(7952,392),(7953,392),(7954,392),(7955,393),(7956,393),(7957,393),(7958,394),(7959,394),(7960,394),(7961,395),(7962,395),(7963,395),(7964,396),(7965,396),(7966,396),(7967,397),(7968,397),(7969,397),(7970,398),(7971,398),(7972,398),(7973,399),(7974,399),(7975,399),(7976,400),(7977,400),(7978,400),(7979,401),(7980,401),(7981,401),(7982,402),(7983,402),(7984,402),(7985,403),(7986,403),(7987,403),(7988,404),(7989,404),(7990,404),(7991,405),(7992,405),(7993,405),(7994,406),(7995,406),(7996,406),(7997,407),(7998,407),(7999,407),(8000,408),(8001,408),(8002,408),(8003,409),(8004,409),(8005,409),(8006,410),(8007,410),(8008,410),(8009,411),(8010,411),(8011,411),(8012,412),(8013,412),(8014,412),(8015,413),(8016,413),(8017,413),(8018,414),(8019,414),(8020,414),(8021,415),(8022,415),(8023,415),(8024,416),(8025,416),(8026,416),(8027,417),(8028,417),(8029,417),(8030,418),(8031,418),(8032,418),(8033,419),(8034,419),(8035,419),(8036,420),(8037,420),(8038,420),(8039,421),(8040,421),(8041,421),(8042,422),(8043,422),(8044,422),(8045,423),(8046,423),(8047,423),(8048,424),(8049,424),(8050,424),(8051,425),(8052,425),(8053,425),(8054,426),(8055,426),(8056,426),(8057,427),(8058,427),(8059,427),(8060,428),(8061,428),(8062,428),(8063,429),(8064,429),(8065,429),(8066,430),(8067,430),(8068,430),(8069,431),(8070,431),(8071,431),(8072,432),(8073,432),(8074,432),(8075,433),(8076,433),(8077,433),(8078,434),(8079,434),(8080,434),(8081,435),(8082,435),(8083,435),(8084,436),(8085,436),(8086,436),(8087,437),(8088,437),(8089,437),(8090,438),(8091,438),(8092,438),(8093,439),(8094,439),(8095,439),(8096,440),(8097,440),(8098,440),(8099,441),(8100,441),(8101,441),(8102,442),(8103,442),(8104,442),(8105,443),(8106,443),(8107,443),(8108,444),(8109,444),(8110,444),(8111,445),(8112,445),(8113,445),(8114,446),(8115,446),(8116,446),(8117,447),(8118,447),(8119,447),(8120,448),(8121,448),(8122,448),(8123,449),(8124,449),(8125,449),(8126,450),(8127,450),(8128,450),(8129,451),(8130,451),(8131,451),(8132,452),(8133,452),(8134,452),(8135,453),(8136,453),(8137,453),(8138,454),(8139,454),(8140,454),(8141,455),(8142,455),(8143,455),(8144,456),(8145,456),(8146,456),(8147,457),(8148,457),(8149,457),(8150,458),(8151,458),(8152,458),(8153,459),(8154,459),(8155,459),(8156,460),(8157,460),(8158,460),(8159,461),(8160,461),(8161,461),(8162,462),(8163,462),(8164,462),(8165,463),(8166,463),(8167,463),(8168,464),(8169,464),(8170,464),(8171,465),(8172,465),(8173,465),(8174,466),(8175,466),(8176,466),(8177,467),(8178,467),(8179,467),(8180,468),(8181,468),(8182,468),(8183,469),(8184,469),(8185,469),(8186,470),(8187,470),(8188,470),(8189,471),(8190,471),(8191,471),(8192,472),(8193,472),(8194,472),(8195,473),(8196,473),(8197,473),(8198,474),(8199,474),(8200,474),(8201,475),(8202,475),(8203,475),(8204,476),(8205,476),(8206,476),(8207,477),(8208,477),(8209,477),(8210,478),(8211,478),(8212,478),(8213,479),(8214,479),(8215,479),(8216,480),(8217,480),(8218,480),(8219,381),(8220,381),(8221,381),(8222,381),(8223,382),(8224,382),(8225,382),(8226,382),(8227,383),(8228,383),(8229,383),(8230,383),(8231,384),(8232,384),(8233,384),(8234,384),(8235,385),(8236,385),(8237,385),(8238,385),(8239,386),(8240,386),(8241,386),(8242,386),(8243,387),(8244,387),(8245,387),(8246,387),(8247,388),(8248,388),(8249,388),(8250,388),(8251,389),(8252,389),(8253,389),(8254,389),(8255,390),(8256,390),(8257,390),(8258,390),(8259,391),(8260,391),(8261,391),(8262,391),(8263,392),(8264,392),(8265,392),(8266,392),(8267,393),(8268,393),(8269,393),(8270,393),(8271,394),(8272,394),(8273,394),(8274,394),(8275,395),(8276,395),(8277,395),(8278,395),(8279,396),(8280,396),(8281,396),(8282,396),(8283,397),(8284,397),(8285,397),(8286,397),(8287,398),(8288,398),(8289,398),(8290,398),(8291,399),(8292,399),(8293,399),(8294,399),(8295,400),(8296,400),(8297,400),(8298,400),(8299,401),(8300,401),(8301,401),(8302,401),(8303,402),(8304,402),(8305,402),(8306,402),(8307,403),(8308,403),(8309,403),(8310,403),(8311,404),(8312,404),(8313,404),(8314,404),(8315,405),(8316,405),(8317,405),(8318,405),(8319,406),(8320,406),(8321,406),(8322,406),(8323,407),(8324,407),(8325,407),(8326,407),(8327,408),(8328,408),(8329,408),(8330,408),(8331,409),(8332,409),(8333,409),(8334,409),(8335,410),(8336,410),(8337,410),(8338,410),(8339,411),(8340,411),(8341,411),(8342,411),(8343,412),(8344,412),(8345,412),(8346,412),(8347,413),(8348,413),(8349,413),(8350,413),(8351,414),(8352,414),(8353,414),(8354,414),(8355,415),(8356,415),(8357,415),(8358,415),(8359,416),(8360,416),(8361,416),(8362,416),(8363,417),(8364,417),(8365,417),(8366,417),(8367,418),(8368,418),(8369,418),(8370,418),(8371,419),(8372,419),(8373,419),(8374,419),(8375,420),(8376,420),(8377,420),(8378,420),(8379,421),(8380,421),(8381,421),(8382,421),(8383,422),(8384,422),(8385,422),(8386,422),(8387,423),(8388,423),(8389,423),(8390,423),(8391,424),(8392,424),(8393,424),(8394,424),(8395,425),(8396,425),(8397,425),(8398,425),(8399,426),(8400,426),(8401,426),(8402,426),(8403,427),(8404,427),(8405,427),(8406,427),(8407,428),(8408,428),(8409,428),(8410,428),(8411,429),(8412,429),(8413,429),(8414,429),(8415,430),(8416,430),(8417,430),(8418,430),(8419,431),(8420,431),(8421,431),(8422,431),(8423,432),(8424,432),(8425,432),(8426,432),(8427,433),(8428,433),(8429,433),(8430,433),(8431,434),(8432,434),(8433,434),(8434,434),(8435,435),(8436,435),(8437,435),(8438,435),(8439,436),(8440,436),(8441,436),(8442,436),(8443,437),(8444,437),(8445,437),(8446,437),(8447,438),(8448,438),(8449,438),(8450,438),(8451,439),(8452,439),(8453,439),(8454,439),(8455,440),(8456,440),(8457,440),(8458,440),(8459,441),(8460,441),(8461,441),(8462,441),(8463,442),(8464,442),(8465,442),(8466,442),(8467,443),(8468,443),(8469,443),(8470,443),(8471,444),(8472,444),(8473,444),(8474,444),(8475,445),(8476,445),(8477,445),(8478,445),(8479,446),(8480,446),(8481,446),(8482,446),(8483,447),(8484,447),(8485,447),(8486,447),(8487,448),(8488,448),(8489,448),(8490,448),(8491,449),(8492,449),(8493,449),(8494,449),(8495,450),(8496,450),(8497,450),(8498,450),(8499,451),(8500,451),(8501,451),(8502,451),(8503,452),(8504,452),(8505,452),(8506,452),(8507,453),(8508,453),(8509,453),(8510,453),(8511,454),(8512,454),(8513,454),(8514,454),(8515,455),(8516,455),(8517,455),(8518,455),(8519,456),(8520,456),(8521,456),(8522,456),(8523,457),(8524,457),(8525,457),(8526,457),(8527,458),(8528,458),(8529,458),(8530,458),(8531,459),(8532,459),(8533,459),(8534,459),(8535,460),(8536,460),(8537,460),(8538,460),(8539,461),(8540,461),(8541,461),(8542,461),(8543,462),(8544,462),(8545,462),(8546,462),(8547,463),(8548,463),(8549,463),(8550,463),(8551,464),(8552,464),(8553,464),(8554,464),(8555,465),(8556,465),(8557,465),(8558,465),(8559,466),(8560,466),(8561,466),(8562,466),(8563,467),(8564,467),(8565,467),(8566,467),(8567,468),(8568,468),(8569,468),(8570,468),(8571,469),(8572,469),(8573,469),(8574,469),(8575,470),(8576,470),(8577,470),(8578,470),(8579,471),(8580,471),(8581,471),(8582,471),(8583,472),(8584,472),(8585,472),(8586,472),(8587,473),(8588,473),(8589,473),(8590,473),(8591,474),(8592,474),(8593,474),(8594,474),(8595,475),(8596,475),(8597,475),(8598,475),(8599,476),(8600,476),(8601,476),(8602,476),(8603,477),(8604,477),(8605,477),(8606,477),(8607,478),(8608,478),(8609,478),(8610,478),(8611,479),(8612,479),(8613,479),(8614,479),(8615,480),(8616,480),(8617,480),(8618,480),(8619,481),(8620,482),(8621,483),(8622,484),(8623,485),(8624,486),(8625,487),(8626,488),(8627,489),(8628,490),(8629,491),(8630,492),(8631,493),(8632,494),(8633,495),(8634,496),(8635,497),(8636,498),(8637,499),(8638,500),(8639,501),(8640,502),(8641,503),(8642,504),(8643,505),(8644,506),(8645,507),(8646,508),(8647,509),(8648,510),(8649,511),(8650,512),(8651,513),(8652,514),(8653,515),(8654,516),(8655,517),(8656,518),(8657,519),(8658,520),(8659,521),(8660,522),(8661,523),(8662,524),(8663,525),(8664,526),(8665,527),(8666,528),(8667,529),(8668,530),(8669,531),(8670,532),(8671,533),(8672,534),(8673,535),(8674,536),(8675,537),(8676,538),(8677,539),(8678,540),(8679,541),(8680,542),(8681,543),(8682,544),(8683,545),(8684,546),(8685,547),(8686,548),(8687,549),(8688,550),(8689,551),(8690,552),(8691,553),(8692,554),(8693,555),(8694,556),(8695,557),(8696,558),(8697,559),(8698,560),(8699,561),(8700,562),(8701,563),(8702,564),(8703,565),(8704,566),(8705,567),(8706,568),(8707,569),(8708,570),(8709,571),(8710,572),(8711,573),(8712,574),(8713,575),(8714,576),(8715,577),(8716,578),(8717,579),(8718,580),(8719,481),(8720,481),(8721,482),(8722,482),(8723,483),(8724,483),(8725,484),(8726,484),(8727,485),(8728,485),(8729,486),(8730,486),(8731,487),(8732,487),(8733,488),(8734,488),(8735,489),(8736,489),(8737,490),(8738,490),(8739,491),(8740,491),(8741,492),(8742,492),(8743,493),(8744,493),(8745,494),(8746,494),(8747,495),(8748,495),(8749,496),(8750,496),(8751,497),(8752,497),(8753,498),(8754,498),(8755,499),(8756,499),(8757,500),(8758,500),(8759,501),(8760,501),(8761,502),(8762,502),(8763,503),(8764,503),(8765,504),(8766,504),(8767,505),(8768,505),(8769,506),(8770,506),(8771,507),(8772,507),(8773,508),(8774,508),(8775,509),(8776,509),(8777,510),(8778,510),(8779,511),(8780,511),(8781,512),(8782,512),(8783,513),(8784,513),(8785,514),(8786,514),(8787,515),(8788,515),(8789,516),(8790,516),(8791,517),(8792,517),(8793,518),(8794,518),(8795,519),(8796,519),(8797,520),(8798,520),(8799,521),(8800,521),(8801,522),(8802,522),(8803,523),(8804,523),(8805,524),(8806,524),(8807,525),(8808,525),(8809,526),(8810,526),(8811,527),(8812,527),(8813,528),(8814,528),(8815,529),(8816,529),(8817,530),(8818,530),(8819,531),(8820,531),(8821,532),(8822,532),(8823,533),(8824,533),(8825,534),(8826,534),(8827,535),(8828,535),(8829,536),(8830,536),(8831,537),(8832,537),(8833,538),(8834,538),(8835,539),(8836,539),(8837,540),(8838,540),(8839,541),(8840,541),(8841,542),(8842,542),(8843,543),(8844,543),(8845,544),(8846,544),(8847,545),(8848,545),(8849,546),(8850,546),(8851,547),(8852,547),(8853,548),(8854,548),(8855,549),(8856,549),(8857,550),(8858,550),(8859,551),(8860,551),(8861,552),(8862,552),(8863,553),(8864,553),(8865,554),(8866,554),(8867,555),(8868,555),(8869,556),(8870,556),(8871,557),(8872,557),(8873,558),(8874,558),(8875,559),(8876,559),(8877,560),(8878,560),(8879,561),(8880,561),(8881,562),(8882,562),(8883,563),(8884,563),(8885,564),(8886,564),(8887,565),(8888,565),(8889,566),(8890,566),(8891,567),(8892,567),(8893,568),(8894,568),(8895,569),(8896,569),(8897,570),(8898,570),(8899,571),(8900,571),(8901,572),(8902,572),(8903,573),(8904,573),(8905,574),(8906,574),(8907,575),(8908,575),(8909,576),(8910,576),(8911,577),(8912,577),(8913,578),(8914,578),(8915,579),(8916,579),(8917,580),(8918,580),(8919,481),(8920,481),(8921,481),(8922,481),(8923,481),(8924,481),(8925,482),(8926,482),(8927,482),(8928,482),(8929,482),(8930,482),(8931,483),(8932,483),(8933,483),(8934,483),(8935,483),(8936,483),(8937,484),(8938,484),(8939,484),(8940,484),(8941,484),(8942,484),(8943,485),(8944,485),(8945,485),(8946,485),(8947,485),(8948,485),(8949,486),(8950,486),(8951,486),(8952,486),(8953,486),(8954,486),(8955,487),(8956,487),(8957,487),(8958,487),(8959,487),(8960,487),(8961,488),(8962,488),(8963,488),(8964,488),(8965,488),(8966,488),(8967,489),(8968,489),(8969,489),(8970,489),(8971,489),(8972,489),(8973,490),(8974,490),(8975,490),(8976,490),(8977,490),(8978,490),(8979,491),(8980,491),(8981,491),(8982,491),(8983,491),(8984,491),(8985,492),(8986,492),(8987,492),(8988,492),(8989,492),(8990,492),(8991,493),(8992,493),(8993,493),(8994,493),(8995,493),(8996,493),(8997,494),(8998,494),(8999,494),(9000,494),(9001,494),(9002,494),(9003,495),(9004,495),(9005,495),(9006,495),(9007,495),(9008,495),(9009,496),(9010,496),(9011,496),(9012,496),(9013,496),(9014,496),(9015,497),(9016,497),(9017,497),(9018,497),(9019,497),(9020,497),(9021,498),(9022,498),(9023,498),(9024,498),(9025,498),(9026,498),(9027,499),(9028,499),(9029,499),(9030,499),(9031,499),(9032,499),(9033,500),(9034,500),(9035,500),(9036,500),(9037,500),(9038,500),(9039,501),(9040,501),(9041,501),(9042,501),(9043,501),(9044,501),(9045,502),(9046,502),(9047,502),(9048,502),(9049,502),(9050,502),(9051,503),(9052,503),(9053,503),(9054,503),(9055,503),(9056,503),(9057,504),(9058,504),(9059,504),(9060,504),(9061,504),(9062,504),(9063,505),(9064,505),(9065,505),(9066,505),(9067,505),(9068,505),(9069,506),(9070,506),(9071,506),(9072,506),(9073,506),(9074,506),(9075,507),(9076,507),(9077,507),(9078,507),(9079,507),(9080,507),(9081,508),(9082,508),(9083,508),(9084,508),(9085,508),(9086,508),(9087,509),(9088,509),(9089,509),(9090,509),(9091,509),(9092,509),(9093,510),(9094,510),(9095,510),(9096,510),(9097,510),(9098,510),(9099,511),(9100,511),(9101,511),(9102,511),(9103,511),(9104,511),(9105,512),(9106,512),(9107,512),(9108,512),(9109,512),(9110,512),(9111,513),(9112,513),(9113,513),(9114,513),(9115,513),(9116,513),(9117,514),(9118,514),(9119,514),(9120,514),(9121,514),(9122,514),(9123,515),(9124,515),(9125,515),(9126,515),(9127,515),(9128,515),(9129,516),(9130,516),(9131,516),(9132,516),(9133,516),(9134,516),(9135,517),(9136,517),(9137,517),(9138,517),(9139,517),(9140,517),(9141,518),(9142,518),(9143,518),(9144,518),(9145,518),(9146,518),(9147,519),(9148,519),(9149,519),(9150,519),(9151,519),(9152,519),(9153,520),(9154,520),(9155,520),(9156,520),(9157,520),(9158,520),(9159,521),(9160,521),(9161,521),(9162,521),(9163,521),(9164,521),(9165,522),(9166,522),(9167,522),(9168,522),(9169,522),(9170,522),(9171,523),(9172,523),(9173,523),(9174,523),(9175,523),(9176,523),(9177,524),(9178,524),(9179,524),(9180,524),(9181,524),(9182,524),(9183,525),(9184,525),(9185,525),(9186,525),(9187,525),(9188,525),(9189,526),(9190,526),(9191,526),(9192,526),(9193,526),(9194,526),(9195,527),(9196,527),(9197,527),(9198,527),(9199,527),(9200,527),(9201,528),(9202,528),(9203,528),(9204,528),(9205,528),(9206,528),(9207,529),(9208,529),(9209,529),(9210,529),(9211,529),(9212,529),(9213,530),(9214,530),(9215,530),(9216,530),(9217,530),(9218,530),(9219,531),(9220,531),(9221,531),(9222,531),(9223,531),(9224,531),(9225,532),(9226,532),(9227,532),(9228,532),(9229,532),(9230,532),(9231,533),(9232,533),(9233,533),(9234,533),(9235,533),(9236,533),(9237,534),(9238,534),(9239,534),(9240,534),(9241,534),(9242,534),(9243,535),(9244,535),(9245,535),(9246,535),(9247,535),(9248,535),(9249,536),(9250,536),(9251,536),(9252,536),(9253,536),(9254,536),(9255,537),(9256,537),(9257,537),(9258,537),(9259,537),(9260,537),(9261,538),(9262,538),(9263,538),(9264,538),(9265,538),(9266,538),(9267,539),(9268,539),(9269,539),(9270,539),(9271,539),(9272,539),(9273,540),(9274,540),(9275,540),(9276,540),(9277,540),(9278,540),(9279,541),(9280,541),(9281,541),(9282,541),(9283,541),(9284,541),(9285,542),(9286,542),(9287,542),(9288,542),(9289,542),(9290,542),(9291,543),(9292,543),(9293,543),(9294,543),(9295,543),(9296,543),(9297,544),(9298,544),(9299,544),(9300,544),(9301,544),(9302,544),(9303,545),(9304,545),(9305,545),(9306,545),(9307,545),(9308,545),(9309,546),(9310,546),(9311,546),(9312,546),(9313,546),(9314,546),(9315,547),(9316,547),(9317,547),(9318,547),(9319,547),(9320,547),(9321,548),(9322,548),(9323,548),(9324,548),(9325,548),(9326,548),(9327,549),(9328,549),(9329,549),(9330,549),(9331,549),(9332,549),(9333,550),(9334,550),(9335,550),(9336,550),(9337,550),(9338,550),(9339,551),(9340,551),(9341,551),(9342,551),(9343,551),(9344,551),(9345,552),(9346,552),(9347,552),(9348,552),(9349,552),(9350,552),(9351,553),(9352,553),(9353,553),(9354,553),(9355,553),(9356,553),(9357,554),(9358,554),(9359,554),(9360,554),(9361,554),(9362,554),(9363,555),(9364,555),(9365,555),(9366,555),(9367,555),(9368,555),(9369,556),(9370,556),(9371,556),(9372,556),(9373,556),(9374,556),(9375,557),(9376,557),(9377,557),(9378,557),(9379,557),(9380,557),(9381,558),(9382,558),(9383,558),(9384,558),(9385,558),(9386,558),(9387,559),(9388,559),(9389,559),(9390,559),(9391,559),(9392,559),(9393,560),(9394,560),(9395,560),(9396,560),(9397,560),(9398,560),(9399,561),(9400,561),(9401,561),(9402,561),(9403,561),(9404,561),(9405,562),(9406,562),(9407,562),(9408,562),(9409,562),(9410,562),(9411,563),(9412,563),(9413,563),(9414,563),(9415,563),(9416,563),(9417,564),(9418,564),(9419,564),(9420,564),(9421,564),(9422,564),(9423,565),(9424,565),(9425,565),(9426,565),(9427,565),(9428,565),(9429,566),(9430,566),(9431,566),(9432,566),(9433,566),(9434,566),(9435,567),(9436,567),(9437,567),(9438,567),(9439,567),(9440,567),(9441,568),(9442,568),(9443,568),(9444,568),(9445,568),(9446,568),(9447,569),(9448,569),(9449,569),(9450,569),(9451,569),(9452,569),(9453,570),(9454,570),(9455,570),(9456,570),(9457,570),(9458,570),(9459,571),(9460,571),(9461,571),(9462,571),(9463,571),(9464,571),(9465,572),(9466,572),(9467,572),(9468,572),(9469,572),(9470,572),(9471,573),(9472,573),(9473,573),(9474,573),(9475,573),(9476,573),(9477,574),(9478,574),(9479,574),(9480,574),(9481,574),(9482,574),(9483,575),(9484,575),(9485,575),(9486,575),(9487,575),(9488,575),(9489,576),(9490,576),(9491,576),(9492,576),(9493,576),(9494,576),(9495,577),(9496,577),(9497,577),(9498,577),(9499,577),(9500,577),(9501,578),(9502,578),(9503,578),(9504,578),(9505,578),(9506,578),(9507,579),(9508,579),(9509,579),(9510,579),(9511,579),(9512,579),(9513,580),(9514,580),(9515,580),(9516,580),(9517,580),(9518,580),(9519,481),(9520,481),(9521,482),(9522,482),(9523,483),(9524,483),(9525,484),(9526,484),(9527,485),(9528,485),(9529,486),(9530,486),(9531,487),(9532,487),(9533,488),(9534,488),(9535,489),(9536,489),(9537,490),(9538,490),(9539,491),(9540,491),(9541,492),(9542,492),(9543,493),(9544,493),(9545,494),(9546,494),(9547,495),(9548,495),(9549,496),(9550,496),(9551,497),(9552,497),(9553,498),(9554,498),(9555,499),(9556,499),(9557,500),(9558,500),(9559,501),(9560,501),(9561,502),(9562,502),(9563,503),(9564,503),(9565,504),(9566,504),(9567,505),(9568,505),(9569,506),(9570,506),(9571,507),(9572,507),(9573,508),(9574,508),(9575,509),(9576,509),(9577,510),(9578,510),(9579,511),(9580,511),(9581,512),(9582,512),(9583,513),(9584,513),(9585,514),(9586,514),(9587,515),(9588,515),(9589,516),(9590,516),(9591,517),(9592,517),(9593,518),(9594,518),(9595,519),(9596,519),(9597,520),(9598,520),(9599,521),(9600,521),(9601,522),(9602,522),(9603,523),(9604,523),(9605,524),(9606,524),(9607,525),(9608,525),(9609,526),(9610,526),(9611,527),(9612,527),(9613,528),(9614,528),(9615,529),(9616,529),(9617,530),(9618,530),(9619,531),(9620,531),(9621,532),(9622,532),(9623,533),(9624,533),(9625,534),(9626,534),(9627,535),(9628,535),(9629,536),(9630,536),(9631,537),(9632,537),(9633,538),(9634,538),(9635,539),(9636,539),(9637,540),(9638,540),(9639,541),(9640,541),(9641,542),(9642,542),(9643,543),(9644,543),(9645,544),(9646,544),(9647,545),(9648,545),(9649,546),(9650,546),(9651,547),(9652,547),(9653,548),(9654,548),(9655,549),(9656,549),(9657,550),(9658,550),(9659,551),(9660,551),(9661,552),(9662,552),(9663,553),(9664,553),(9665,554),(9666,554),(9667,555),(9668,555),(9669,556),(9670,556),(9671,557),(9672,557),(9673,558),(9674,558),(9675,559),(9676,559),(9677,560),(9678,560),(9679,561),(9680,561),(9681,562),(9682,562),(9683,563),(9684,563),(9685,564),(9686,564),(9687,565),(9688,565),(9689,566),(9690,566),(9691,567),(9692,567),(9693,568),(9694,568),(9695,569),(9696,569),(9697,570),(9698,570),(9699,571),(9700,571),(9701,572),(9702,572),(9703,573),(9704,573),(9705,574),(9706,574),(9707,575),(9708,575),(9709,576),(9710,576),(9711,577),(9712,577),(9713,578),(9714,578),(9715,579),(9716,579),(9717,580),(9718,580),(9719,481),(9720,481),(9721,481),(9722,482),(9723,482),(9724,482),(9725,483),(9726,483),(9727,483),(9728,484),(9729,484),(9730,484),(9731,485),(9732,485),(9733,485),(9734,486),(9735,486),(9736,486),(9737,487),(9738,487),(9739,487),(9740,488),(9741,488),(9742,488),(9743,489),(9744,489),(9745,489),(9746,490),(9747,490),(9748,490),(9749,491),(9750,491),(9751,491),(9752,492),(9753,492),(9754,492),(9755,493),(9756,493),(9757,493),(9758,494),(9759,494),(9760,494),(9761,495),(9762,495),(9763,495),(9764,496),(9765,496),(9766,496),(9767,497),(9768,497),(9769,497),(9770,498),(9771,498),(9772,498),(9773,499),(9774,499),(9775,499),(9776,500),(9777,500),(9778,500),(9779,501),(9780,501),(9781,501),(9782,502),(9783,502),(9784,502),(9785,503),(9786,503),(9787,503),(9788,504),(9789,504),(9790,504),(9791,505),(9792,505),(9793,505),(9794,506),(9795,506),(9796,506),(9797,507),(9798,507),(9799,507),(9800,508),(9801,508),(9802,508),(9803,509),(9804,509),(9805,509),(9806,510),(9807,510),(9808,510),(9809,511),(9810,511),(9811,511),(9812,512),(9813,512),(9814,512),(9815,513),(9816,513),(9817,513),(9818,514),(9819,514),(9820,514),(9821,515),(9822,515),(9823,515),(9824,516),(9825,516),(9826,516),(9827,517),(9828,517),(9829,517),(9830,518),(9831,518),(9832,518),(9833,519),(9834,519),(9835,519),(9836,520),(9837,520),(9838,520),(9839,521),(9840,521),(9841,521),(9842,522),(9843,522),(9844,522),(9845,523),(9846,523),(9847,523),(9848,524),(9849,524),(9850,524),(9851,525),(9852,525),(9853,525),(9854,526),(9855,526),(9856,526),(9857,527),(9858,527),(9859,527),(9860,528),(9861,528),(9862,528),(9863,529),(9864,529),(9865,529),(9866,530),(9867,530),(9868,530),(9869,531),(9870,531),(9871,531),(9872,532),(9873,532),(9874,532),(9875,533),(9876,533),(9877,533),(9878,534),(9879,534),(9880,534),(9881,535),(9882,535),(9883,535),(9884,536),(9885,536),(9886,536),(9887,537),(9888,537),(9889,537),(9890,538),(9891,538),(9892,538),(9893,539),(9894,539),(9895,539),(9896,540),(9897,540),(9898,540),(9899,541),(9900,541),(9901,541),(9902,542),(9903,542),(9904,542),(9905,543),(9906,543),(9907,543),(9908,544),(9909,544),(9910,544),(9911,545),(9912,545),(9913,545),(9914,546),(9915,546),(9916,546),(9917,547),(9918,547),(9919,547),(9920,548),(9921,548),(9922,548),(9923,549),(9924,549),(9925,549),(9926,550),(9927,550),(9928,550),(9929,551),(9930,551),(9931,551),(9932,552),(9933,552),(9934,552),(9935,553),(9936,553),(9937,553),(9938,554),(9939,554),(9940,554),(9941,555),(9942,555),(9943,555),(9944,556),(9945,556),(9946,556),(9947,557),(9948,557),(9949,557),(9950,558),(9951,558),(9952,558),(9953,559),(9954,559),(9955,559),(9956,560),(9957,560),(9958,560),(9959,561),(9960,561),(9961,561),(9962,562),(9963,562),(9964,562),(9965,563),(9966,563),(9967,563),(9968,564),(9969,564),(9970,564),(9971,565),(9972,565),(9973,565),(9974,566),(9975,566),(9976,566),(9977,567),(9978,567),(9979,567),(9980,568),(9981,568),(9982,568),(9983,569),(9984,569),(9985,569),(9986,570),(9987,570),(9988,570),(9989,571),(9990,571),(9991,571),(9992,572),(9993,572),(9994,572),(9995,573),(9996,573),(9997,573),(9998,574),(9999,574),(10000,574),(10001,575),(10002,575),(10003,575),(10004,576),(10005,576),(10006,576),(10007,577),(10008,577),(10009,577),(10010,578),(10011,578),(10012,578),(10013,579),(10014,579),(10015,579),(10016,580),(10017,580),(10018,580),(10019,481),(10020,481),(10021,481),(10022,481),(10023,482),(10024,482),(10025,482),(10026,482),(10027,483),(10028,483),(10029,483),(10030,483),(10031,484),(10032,484),(10033,484),(10034,484),(10035,485),(10036,485),(10037,485),(10038,485),(10039,486),(10040,486),(10041,486),(10042,486),(10043,487),(10044,487),(10045,487),(10046,487),(10047,488),(10048,488),(10049,488),(10050,488),(10051,489),(10052,489),(10053,489),(10054,489),(10055,490),(10056,490),(10057,490),(10058,490),(10059,491),(10060,491),(10061,491),(10062,491),(10063,492),(10064,492),(10065,492),(10066,492),(10067,493),(10068,493),(10069,493),(10070,493),(10071,494),(10072,494),(10073,494),(10074,494),(10075,495),(10076,495),(10077,495),(10078,495),(10079,496),(10080,496),(10081,496),(10082,496),(10083,497),(10084,497),(10085,497),(10086,497),(10087,498),(10088,498),(10089,498),(10090,498),(10091,499),(10092,499),(10093,499),(10094,499),(10095,500),(10096,500),(10097,500),(10098,500),(10099,501),(10100,501),(10101,501),(10102,501),(10103,502),(10104,502),(10105,502),(10106,502),(10107,503),(10108,503),(10109,503),(10110,503),(10111,504),(10112,504),(10113,504),(10114,504),(10115,505),(10116,505),(10117,505),(10118,505),(10119,506),(10120,506),(10121,506),(10122,506),(10123,507),(10124,507),(10125,507),(10126,507),(10127,508),(10128,508),(10129,508),(10130,508),(10131,509),(10132,509),(10133,509),(10134,509),(10135,510),(10136,510),(10137,510),(10138,510),(10139,511),(10140,511),(10141,511),(10142,511),(10143,512),(10144,512),(10145,512),(10146,512),(10147,513),(10148,513),(10149,513),(10150,513),(10151,514),(10152,514),(10153,514),(10154,514),(10155,515),(10156,515),(10157,515),(10158,515),(10159,516),(10160,516),(10161,516),(10162,516),(10163,517),(10164,517),(10165,517),(10166,517),(10167,518),(10168,518),(10169,518),(10170,518),(10171,519),(10172,519),(10173,519),(10174,519),(10175,520),(10176,520),(10177,520),(10178,520),(10179,521),(10180,521),(10181,521),(10182,521),(10183,522),(10184,522),(10185,522),(10186,522),(10187,523),(10188,523),(10189,523),(10190,523),(10191,524),(10192,524),(10193,524),(10194,524),(10195,525),(10196,525),(10197,525),(10198,525),(10199,526),(10200,526),(10201,526),(10202,526),(10203,527),(10204,527),(10205,527),(10206,527),(10207,528),(10208,528),(10209,528),(10210,528),(10211,529),(10212,529),(10213,529),(10214,529),(10215,530),(10216,530),(10217,530),(10218,530),(10219,531),(10220,531),(10221,531),(10222,531),(10223,532),(10224,532),(10225,532),(10226,532),(10227,533),(10228,533),(10229,533),(10230,533),(10231,534),(10232,534),(10233,534),(10234,534),(10235,535),(10236,535),(10237,535),(10238,535),(10239,536),(10240,536),(10241,536),(10242,536),(10243,537),(10244,537),(10245,537),(10246,537),(10247,538),(10248,538),(10249,538),(10250,538),(10251,539),(10252,539),(10253,539),(10254,539),(10255,540),(10256,540),(10257,540),(10258,540),(10259,541),(10260,541),(10261,541),(10262,541),(10263,542),(10264,542),(10265,542),(10266,542),(10267,543),(10268,543),(10269,543),(10270,543),(10271,544),(10272,544),(10273,544),(10274,544),(10275,545),(10276,545),(10277,545),(10278,545),(10279,546),(10280,546),(10281,546),(10282,546),(10283,547),(10284,547),(10285,547),(10286,547),(10287,548),(10288,548),(10289,548),(10290,548),(10291,549),(10292,549),(10293,549),(10294,549),(10295,550),(10296,550),(10297,550),(10298,550),(10299,551),(10300,551),(10301,551),(10302,551),(10303,552),(10304,552),(10305,552),(10306,552),(10307,553),(10308,553),(10309,553),(10310,553),(10311,554),(10312,554),(10313,554),(10314,554),(10315,555),(10316,555),(10317,555),(10318,555),(10319,556),(10320,556),(10321,556),(10322,556),(10323,557),(10324,557),(10325,557),(10326,557),(10327,558),(10328,558),(10329,558),(10330,558),(10331,559),(10332,559),(10333,559),(10334,559),(10335,560),(10336,560),(10337,560),(10338,560),(10339,561),(10340,561),(10341,561),(10342,561),(10343,562),(10344,562),(10345,562),(10346,562),(10347,563),(10348,563),(10349,563),(10350,563),(10351,564),(10352,564),(10353,564),(10354,564),(10355,565),(10356,565),(10357,565),(10358,565),(10359,566),(10360,566),(10361,566),(10362,566),(10363,567),(10364,567),(10365,567),(10366,567),(10367,568),(10368,568),(10369,568),(10370,568),(10371,569),(10372,569),(10373,569),(10374,569),(10375,570),(10376,570),(10377,570),(10378,570),(10379,571),(10380,571),(10381,571),(10382,571),(10383,572),(10384,572),(10385,572),(10386,572),(10387,573),(10388,573),(10389,573),(10390,573),(10391,574),(10392,574),(10393,574),(10394,574),(10395,575),(10396,575),(10397,575),(10398,575),(10399,576),(10400,576),(10401,576),(10402,576),(10403,577),(10404,577),(10405,577),(10406,577),(10407,578),(10408,578),(10409,578),(10410,578),(10411,579),(10412,579),(10413,579),(10414,579),(10415,580),(10416,580),(10417,580),(10418,580),(10419,581),(10420,582),(10421,583),(10422,584),(10423,585),(10424,586),(10425,587),(10426,588),(10427,589),(10428,590),(10429,591),(10430,592),(10431,593),(10432,594),(10433,595),(10434,596),(10435,597),(10436,598),(10437,599),(10438,600),(10439,601),(10440,602),(10441,603),(10442,604),(10443,605),(10444,606),(10445,607),(10446,608),(10447,609),(10448,610),(10449,611),(10450,612),(10451,613),(10452,614),(10453,615),(10454,616),(10455,617),(10456,618),(10457,619),(10458,620),(10459,621),(10460,622),(10461,623),(10462,624),(10463,625),(10464,626),(10465,627),(10466,628),(10467,629),(10468,630),(10469,631),(10470,632),(10471,633),(10472,634),(10473,635),(10474,636),(10475,637),(10476,638),(10477,639),(10478,640),(10479,641),(10480,642),(10481,643),(10482,644),(10483,645),(10484,646),(10485,647),(10486,648),(10487,649),(10488,650),(10489,651),(10490,652),(10491,653),(10492,654),(10493,655),(10494,656),(10495,657),(10496,658),(10497,659),(10498,660),(10499,661),(10500,662),(10501,663),(10502,664),(10503,665),(10504,666),(10505,667),(10506,668),(10507,669),(10508,670),(10509,671),(10510,672),(10511,673),(10512,674),(10513,675),(10514,676),(10515,677),(10516,678),(10517,679),(10518,680),(10519,581),(10520,581),(10521,582),(10522,582),(10523,583),(10524,583),(10525,584),(10526,584),(10527,585),(10528,585),(10529,586),(10530,586),(10531,587),(10532,587),(10533,588),(10534,588),(10535,589),(10536,589),(10537,590),(10538,590),(10539,591),(10540,591),(10541,592),(10542,592),(10543,593),(10544,593),(10545,594),(10546,594),(10547,595),(10548,595),(10549,596),(10550,596),(10551,597),(10552,597),(10553,598),(10554,598),(10555,599),(10556,599),(10557,600),(10558,600),(10559,601),(10560,601),(10561,602),(10562,602),(10563,603),(10564,603),(10565,604),(10566,604),(10567,605),(10568,605),(10569,606),(10570,606),(10571,607),(10572,607),(10573,608),(10574,608),(10575,609),(10576,609),(10577,610),(10578,610),(10579,611),(10580,611),(10581,612),(10582,612),(10583,613),(10584,613),(10585,614),(10586,614),(10587,615),(10588,615),(10589,616),(10590,616),(10591,617),(10592,617),(10593,618),(10594,618),(10595,619),(10596,619),(10597,620),(10598,620),(10599,621),(10600,621),(10601,622),(10602,622),(10603,623),(10604,623),(10605,624),(10606,624),(10607,625),(10608,625),(10609,626),(10610,626),(10611,627),(10612,627),(10613,628),(10614,628),(10615,629),(10616,629),(10617,630),(10618,630),(10619,631),(10620,631),(10621,632),(10622,632),(10623,633),(10624,633),(10625,634),(10626,634),(10627,635),(10628,635),(10629,636),(10630,636),(10631,637),(10632,637),(10633,638),(10634,638),(10635,639),(10636,639),(10637,640),(10638,640),(10639,641),(10640,641),(10641,642),(10642,642),(10643,643),(10644,643),(10645,644),(10646,644),(10647,645),(10648,645),(10649,646),(10650,646),(10651,647),(10652,647),(10653,648),(10654,648),(10655,649),(10656,649),(10657,650),(10658,650),(10659,651),(10660,651),(10661,652),(10662,652),(10663,653),(10664,653),(10665,654),(10666,654),(10667,655),(10668,655),(10669,656),(10670,656),(10671,657),(10672,657),(10673,658),(10674,658),(10675,659),(10676,659),(10677,660),(10678,660),(10679,661),(10680,661),(10681,662),(10682,662),(10683,663),(10684,663),(10685,664),(10686,664),(10687,665),(10688,665),(10689,666),(10690,666),(10691,667),(10692,667),(10693,668),(10694,668),(10695,669),(10696,669),(10697,670),(10698,670),(10699,671),(10700,671),(10701,672),(10702,672),(10703,673),(10704,673),(10705,674),(10706,674),(10707,675),(10708,675),(10709,676),(10710,676),(10711,677),(10712,677),(10713,678),(10714,678),(10715,679),(10716,679),(10717,680),(10718,680),(10719,581),(10720,581),(10721,581),(10722,581),(10723,581),(10724,581),(10725,582),(10726,582),(10727,582),(10728,582),(10729,582),(10730,582),(10731,583),(10732,583),(10733,583),(10734,583),(10735,583),(10736,583),(10737,584),(10738,584),(10739,584),(10740,584),(10741,584),(10742,584),(10743,585),(10744,585),(10745,585),(10746,585),(10747,585),(10748,585),(10749,586),(10750,586),(10751,586),(10752,586),(10753,586),(10754,586),(10755,587),(10756,587),(10757,587),(10758,587),(10759,587),(10760,587),(10761,588),(10762,588),(10763,588),(10764,588),(10765,588),(10766,588),(10767,589),(10768,589),(10769,589),(10770,589),(10771,589),(10772,589),(10773,590),(10774,590),(10775,590),(10776,590),(10777,590),(10778,590),(10779,591),(10780,591),(10781,591),(10782,591),(10783,591),(10784,591),(10785,592),(10786,592),(10787,592),(10788,592),(10789,592),(10790,592),(10791,593),(10792,593),(10793,593),(10794,593),(10795,593),(10796,593),(10797,594),(10798,594),(10799,594),(10800,594),(10801,594),(10802,594),(10803,595),(10804,595),(10805,595),(10806,595),(10807,595),(10808,595),(10809,596),(10810,596),(10811,596),(10812,596),(10813,596),(10814,596),(10815,597),(10816,597),(10817,597),(10818,597),(10819,597),(10820,597),(10821,598),(10822,598),(10823,598),(10824,598),(10825,598),(10826,598),(10827,599),(10828,599),(10829,599),(10830,599),(10831,599),(10832,599),(10833,600),(10834,600),(10835,600),(10836,600),(10837,600),(10838,600),(10839,601),(10840,601),(10841,601),(10842,601),(10843,601),(10844,601),(10845,602),(10846,602),(10847,602),(10848,602),(10849,602),(10850,602),(10851,603),(10852,603),(10853,603),(10854,603),(10855,603),(10856,603),(10857,604),(10858,604),(10859,604),(10860,604),(10861,604),(10862,604),(10863,605),(10864,605),(10865,605),(10866,605),(10867,605),(10868,605),(10869,606),(10870,606),(10871,606),(10872,606),(10873,606),(10874,606),(10875,607),(10876,607),(10877,607),(10878,607),(10879,607),(10880,607),(10881,608),(10882,608),(10883,608),(10884,608),(10885,608),(10886,608),(10887,609),(10888,609),(10889,609),(10890,609),(10891,609),(10892,609),(10893,610),(10894,610),(10895,610),(10896,610),(10897,610),(10898,610),(10899,611),(10900,611),(10901,611),(10902,611),(10903,611),(10904,611),(10905,612),(10906,612),(10907,612),(10908,612),(10909,612),(10910,612),(10911,613),(10912,613),(10913,613),(10914,613),(10915,613),(10916,613),(10917,614),(10918,614),(10919,614),(10920,614),(10921,614),(10922,614),(10923,615),(10924,615),(10925,615),(10926,615),(10927,615),(10928,615),(10929,616),(10930,616),(10931,616),(10932,616),(10933,616),(10934,616),(10935,617),(10936,617),(10937,617),(10938,617),(10939,617),(10940,617),(10941,618),(10942,618),(10943,618),(10944,618),(10945,618),(10946,618),(10947,619),(10948,619),(10949,619),(10950,619),(10951,619),(10952,619),(10953,620),(10954,620),(10955,620),(10956,620),(10957,620),(10958,620),(10959,621),(10960,621),(10961,621),(10962,621),(10963,621),(10964,621),(10965,622),(10966,622),(10967,622),(10968,622),(10969,622),(10970,622),(10971,623),(10972,623),(10973,623),(10974,623),(10975,623),(10976,623),(10977,624),(10978,624),(10979,624),(10980,624),(10981,624),(10982,624),(10983,625),(10984,625),(10985,625),(10986,625),(10987,625),(10988,625),(10989,626),(10990,626),(10991,626),(10992,626),(10993,626),(10994,626),(10995,627),(10996,627),(10997,627),(10998,627),(10999,627),(11000,627),(11001,628),(11002,628),(11003,628),(11004,628),(11005,628),(11006,628),(11007,629),(11008,629),(11009,629),(11010,629),(11011,629),(11012,629),(11013,630),(11014,630),(11015,630),(11016,630),(11017,630),(11018,630),(11019,631),(11020,631),(11021,631),(11022,631),(11023,631),(11024,631),(11025,632),(11026,632),(11027,632),(11028,632),(11029,632),(11030,632),(11031,633),(11032,633),(11033,633),(11034,633),(11035,633),(11036,633),(11037,634),(11038,634),(11039,634),(11040,634),(11041,634),(11042,634),(11043,635),(11044,635),(11045,635),(11046,635),(11047,635),(11048,635),(11049,636),(11050,636),(11051,636),(11052,636),(11053,636),(11054,636),(11055,637),(11056,637),(11057,637),(11058,637),(11059,637),(11060,637),(11061,638),(11062,638),(11063,638),(11064,638),(11065,638),(11066,638),(11067,639),(11068,639),(11069,639),(11070,639),(11071,639),(11072,639),(11073,640),(11074,640),(11075,640),(11076,640),(11077,640),(11078,640),(11079,641),(11080,641),(11081,641),(11082,641),(11083,641),(11084,641),(11085,642),(11086,642),(11087,642),(11088,642),(11089,642),(11090,642),(11091,643),(11092,643),(11093,643),(11094,643),(11095,643),(11096,643),(11097,644),(11098,644),(11099,644),(11100,644),(11101,644),(11102,644),(11103,645),(11104,645),(11105,645),(11106,645),(11107,645),(11108,645),(11109,646),(11110,646),(11111,646),(11112,646),(11113,646),(11114,646),(11115,647),(11116,647),(11117,647),(11118,647),(11119,647),(11120,647),(11121,648),(11122,648),(11123,648),(11124,648),(11125,648),(11126,648),(11127,649),(11128,649),(11129,649),(11130,649),(11131,649),(11132,649),(11133,650),(11134,650),(11135,650),(11136,650),(11137,650),(11138,650),(11139,651),(11140,651),(11141,651),(11142,651),(11143,651),(11144,651),(11145,652),(11146,652),(11147,652),(11148,652),(11149,652),(11150,652),(11151,653),(11152,653),(11153,653),(11154,653),(11155,653),(11156,653),(11157,654),(11158,654),(11159,654),(11160,654),(11161,654),(11162,654),(11163,655),(11164,655),(11165,655),(11166,655),(11167,655),(11168,655),(11169,656),(11170,656),(11171,656),(11172,656),(11173,656),(11174,656),(11175,657),(11176,657),(11177,657),(11178,657),(11179,657),(11180,657),(11181,658),(11182,658),(11183,658),(11184,658),(11185,658),(11186,658),(11187,659),(11188,659),(11189,659),(11190,659),(11191,659),(11192,659),(11193,660),(11194,660),(11195,660),(11196,660),(11197,660),(11198,660),(11199,661),(11200,661),(11201,661),(11202,661),(11203,661),(11204,661),(11205,662),(11206,662),(11207,662),(11208,662),(11209,662),(11210,662),(11211,663),(11212,663),(11213,663),(11214,663),(11215,663),(11216,663),(11217,664),(11218,664),(11219,664),(11220,664),(11221,664),(11222,664),(11223,665),(11224,665),(11225,665),(11226,665),(11227,665),(11228,665),(11229,666),(11230,666),(11231,666),(11232,666),(11233,666),(11234,666),(11235,667),(11236,667),(11237,667),(11238,667),(11239,667),(11240,667),(11241,668),(11242,668),(11243,668),(11244,668),(11245,668),(11246,668),(11247,669),(11248,669),(11249,669),(11250,669),(11251,669),(11252,669),(11253,670),(11254,670),(11255,670),(11256,670),(11257,670),(11258,670),(11259,671),(11260,671),(11261,671),(11262,671),(11263,671),(11264,671),(11265,672),(11266,672),(11267,672),(11268,672),(11269,672),(11270,672),(11271,673),(11272,673),(11273,673),(11274,673),(11275,673),(11276,673),(11277,674),(11278,674),(11279,674),(11280,674),(11281,674),(11282,674),(11283,675),(11284,675),(11285,675),(11286,675),(11287,675),(11288,675),(11289,676),(11290,676),(11291,676),(11292,676),(11293,676),(11294,676),(11295,677),(11296,677),(11297,677),(11298,677),(11299,677),(11300,677),(11301,678),(11302,678),(11303,678),(11304,678),(11305,678),(11306,678),(11307,679),(11308,679),(11309,679),(11310,679),(11311,679),(11312,679),(11313,680),(11314,680),(11315,680),(11316,680),(11317,680),(11318,680),(11319,581),(11320,581),(11321,582),(11322,582),(11323,583),(11324,583),(11325,584),(11326,584),(11327,585),(11328,585),(11329,586),(11330,586),(11331,587),(11332,587),(11333,588),(11334,588),(11335,589),(11336,589),(11337,590),(11338,590),(11339,591),(11340,591),(11341,592),(11342,592),(11343,593),(11344,593),(11345,594),(11346,594),(11347,595),(11348,595),(11349,596),(11350,596),(11351,597),(11352,597),(11353,598),(11354,598),(11355,599),(11356,599),(11357,600),(11358,600),(11359,601),(11360,601),(11361,602),(11362,602),(11363,603),(11364,603),(11365,604),(11366,604),(11367,605),(11368,605),(11369,606),(11370,606),(11371,607),(11372,607),(11373,608),(11374,608),(11375,609),(11376,609),(11377,610),(11378,610),(11379,611),(11380,611),(11381,612),(11382,612),(11383,613),(11384,613),(11385,614),(11386,614),(11387,615),(11388,615),(11389,616),(11390,616),(11391,617),(11392,617),(11393,618),(11394,618),(11395,619),(11396,619),(11397,620),(11398,620),(11399,621),(11400,621),(11401,622),(11402,622),(11403,623),(11404,623),(11405,624),(11406,624),(11407,625),(11408,625),(11409,626),(11410,626),(11411,627),(11412,627),(11413,628),(11414,628),(11415,629),(11416,629),(11417,630),(11418,630),(11419,631),(11420,631),(11421,632),(11422,632),(11423,633),(11424,633),(11425,634),(11426,634),(11427,635),(11428,635),(11429,636),(11430,636),(11431,637),(11432,637),(11433,638),(11434,638),(11435,639),(11436,639),(11437,640),(11438,640),(11439,641),(11440,641),(11441,642),(11442,642),(11443,643),(11444,643),(11445,644),(11446,644),(11447,645),(11448,645),(11449,646),(11450,646),(11451,647),(11452,647),(11453,648),(11454,648),(11455,649),(11456,649),(11457,650),(11458,650),(11459,651),(11460,651),(11461,652),(11462,652),(11463,653),(11464,653),(11465,654),(11466,654),(11467,655),(11468,655),(11469,656),(11470,656),(11471,657),(11472,657),(11473,658),(11474,658),(11475,659),(11476,659),(11477,660),(11478,660),(11479,661),(11480,661),(11481,662),(11482,662),(11483,663),(11484,663),(11485,664),(11486,664),(11487,665),(11488,665),(11489,666),(11490,666),(11491,667),(11492,667),(11493,668),(11494,668),(11495,669),(11496,669),(11497,670),(11498,670),(11499,671),(11500,671),(11501,672),(11502,672),(11503,673),(11504,673),(11505,674),(11506,674),(11507,675),(11508,675),(11509,676),(11510,676),(11511,677),(11512,677),(11513,678),(11514,678),(11515,679),(11516,679),(11517,680),(11518,680),(11519,581),(11520,581),(11521,581),(11522,582),(11523,582),(11524,582),(11525,583),(11526,583),(11527,583),(11528,584),(11529,584),(11530,584),(11531,585),(11532,585),(11533,585),(11534,586),(11535,586),(11536,586),(11537,587),(11538,587),(11539,587),(11540,588),(11541,588),(11542,588),(11543,589),(11544,589),(11545,589),(11546,590),(11547,590),(11548,590),(11549,591),(11550,591),(11551,591),(11552,592),(11553,592),(11554,592),(11555,593),(11556,593),(11557,593),(11558,594),(11559,594),(11560,594),(11561,595),(11562,595),(11563,595),(11564,596),(11565,596),(11566,596),(11567,597),(11568,597),(11569,597),(11570,598),(11571,598),(11572,598),(11573,599),(11574,599),(11575,599),(11576,600),(11577,600),(11578,600),(11579,601),(11580,601),(11581,601),(11582,602),(11583,602),(11584,602),(11585,603),(11586,603),(11587,603),(11588,604),(11589,604),(11590,604),(11591,605),(11592,605),(11593,605),(11594,606),(11595,606),(11596,606),(11597,607),(11598,607),(11599,607),(11600,608),(11601,608),(11602,608),(11603,609),(11604,609),(11605,609),(11606,610),(11607,610),(11608,610),(11609,611),(11610,611),(11611,611),(11612,612),(11613,612),(11614,612),(11615,613),(11616,613),(11617,613),(11618,614),(11619,614),(11620,614),(11621,615),(11622,615),(11623,615),(11624,616),(11625,616),(11626,616),(11627,617),(11628,617),(11629,617),(11630,618),(11631,618),(11632,618),(11633,619),(11634,619),(11635,619),(11636,620),(11637,620),(11638,620),(11639,621),(11640,621),(11641,621),(11642,622),(11643,622),(11644,622),(11645,623),(11646,623),(11647,623),(11648,624),(11649,624),(11650,624),(11651,625),(11652,625),(11653,625),(11654,626),(11655,626),(11656,626),(11657,627),(11658,627),(11659,627),(11660,628),(11661,628),(11662,628),(11663,629),(11664,629),(11665,629),(11666,630),(11667,630),(11668,630),(11669,631),(11670,631),(11671,631),(11672,632),(11673,632),(11674,632),(11675,633),(11676,633),(11677,633),(11678,634),(11679,634),(11680,634),(11681,635),(11682,635),(11683,635),(11684,636),(11685,636),(11686,636),(11687,637),(11688,637),(11689,637),(11690,638),(11691,638),(11692,638),(11693,639),(11694,639),(11695,639),(11696,640),(11697,640),(11698,640),(11699,641),(11700,641),(11701,641),(11702,642),(11703,642),(11704,642),(11705,643),(11706,643),(11707,643),(11708,644),(11709,644),(11710,644),(11711,645),(11712,645),(11713,645),(11714,646),(11715,646),(11716,646),(11717,647),(11718,647),(11719,647),(11720,648),(11721,648),(11722,648),(11723,649),(11724,649),(11725,649),(11726,650),(11727,650),(11728,650),(11729,651),(11730,651),(11731,651),(11732,652),(11733,652),(11734,652),(11735,653),(11736,653),(11737,653),(11738,654),(11739,654),(11740,654),(11741,655),(11742,655),(11743,655),(11744,656),(11745,656),(11746,656),(11747,657),(11748,657),(11749,657),(11750,658),(11751,658),(11752,658),(11753,659),(11754,659),(11755,659),(11756,660),(11757,660),(11758,660),(11759,661),(11760,661),(11761,661),(11762,662),(11763,662),(11764,662),(11765,663),(11766,663),(11767,663),(11768,664),(11769,664),(11770,664),(11771,665),(11772,665),(11773,665),(11774,666),(11775,666),(11776,666),(11777,667),(11778,667),(11779,667),(11780,668),(11781,668),(11782,668),(11783,669),(11784,669),(11785,669),(11786,670),(11787,670),(11788,670),(11789,671),(11790,671),(11791,671),(11792,672),(11793,672),(11794,672),(11795,673),(11796,673),(11797,673),(11798,674),(11799,674),(11800,674),(11801,675),(11802,675),(11803,675),(11804,676),(11805,676),(11806,676),(11807,677),(11808,677),(11809,677),(11810,678),(11811,678),(11812,678),(11813,679),(11814,679),(11815,679),(11816,680),(11817,680),(11818,680),(11819,581),(11820,581),(11821,581),(11822,581),(11823,582),(11824,582),(11825,582),(11826,582),(11827,583),(11828,583),(11829,583),(11830,583),(11831,584),(11832,584),(11833,584),(11834,584),(11835,585),(11836,585),(11837,585),(11838,585),(11839,586),(11840,586),(11841,586),(11842,586),(11843,587),(11844,587),(11845,587),(11846,587),(11847,588),(11848,588),(11849,588),(11850,588),(11851,589),(11852,589),(11853,589),(11854,589),(11855,590),(11856,590),(11857,590),(11858,590),(11859,591),(11860,591),(11861,591),(11862,591),(11863,592),(11864,592),(11865,592),(11866,592),(11867,593),(11868,593),(11869,593),(11870,593),(11871,594),(11872,594),(11873,594),(11874,594),(11875,595),(11876,595),(11877,595),(11878,595),(11879,596),(11880,596),(11881,596),(11882,596),(11883,597),(11884,597),(11885,597),(11886,597),(11887,598),(11888,598),(11889,598),(11890,598),(11891,599),(11892,599),(11893,599),(11894,599),(11895,600),(11896,600),(11897,600),(11898,600),(11899,601),(11900,601),(11901,601),(11902,601),(11903,602),(11904,602),(11905,602),(11906,602),(11907,603),(11908,603),(11909,603),(11910,603),(11911,604),(11912,604),(11913,604),(11914,604),(11915,605),(11916,605),(11917,605),(11918,605),(11919,606),(11920,606),(11921,606),(11922,606),(11923,607),(11924,607),(11925,607),(11926,607),(11927,608),(11928,608),(11929,608),(11930,608),(11931,609),(11932,609),(11933,609),(11934,609),(11935,610),(11936,610),(11937,610),(11938,610),(11939,611),(11940,611),(11941,611),(11942,611),(11943,612),(11944,612),(11945,612),(11946,612),(11947,613),(11948,613),(11949,613),(11950,613),(11951,614),(11952,614),(11953,614),(11954,614),(11955,615),(11956,615),(11957,615),(11958,615),(11959,616),(11960,616),(11961,616),(11962,616),(11963,617),(11964,617),(11965,617),(11966,617),(11967,618),(11968,618),(11969,618),(11970,618),(11971,619),(11972,619),(11973,619),(11974,619),(11975,620),(11976,620),(11977,620),(11978,620),(11979,621),(11980,621),(11981,621),(11982,621),(11983,622),(11984,622),(11985,622),(11986,622),(11987,623),(11988,623),(11989,623),(11990,623),(11991,624),(11992,624),(11993,624),(11994,624),(11995,625),(11996,625),(11997,625),(11998,625),(11999,626),(12000,626),(12001,626),(12002,626),(12003,627),(12004,627),(12005,627),(12006,627),(12007,628),(12008,628),(12009,628),(12010,628),(12011,629),(12012,629),(12013,629),(12014,629),(12015,630),(12016,630),(12017,630),(12018,630),(12019,631),(12020,631),(12021,631),(12022,631),(12023,632),(12024,632),(12025,632),(12026,632),(12027,633),(12028,633),(12029,633),(12030,633),(12031,634),(12032,634),(12033,634),(12034,634),(12035,635),(12036,635),(12037,635),(12038,635),(12039,636),(12040,636),(12041,636),(12042,636),(12043,637),(12044,637),(12045,637),(12046,637),(12047,638),(12048,638),(12049,638),(12050,638),(12051,639),(12052,639),(12053,639),(12054,639),(12055,640),(12056,640),(12057,640),(12058,640),(12059,641),(12060,641),(12061,641),(12062,641),(12063,642),(12064,642),(12065,642),(12066,642),(12067,643),(12068,643),(12069,643),(12070,643),(12071,644),(12072,644),(12073,644),(12074,644),(12075,645),(12076,645),(12077,645),(12078,645),(12079,646),(12080,646),(12081,646),(12082,646),(12083,647),(12084,647),(12085,647),(12086,647),(12087,648),(12088,648),(12089,648),(12090,648),(12091,649),(12092,649),(12093,649),(12094,649),(12095,650),(12096,650),(12097,650),(12098,650),(12099,651),(12100,651),(12101,651),(12102,651),(12103,652),(12104,652),(12105,652),(12106,652),(12107,653),(12108,653),(12109,653),(12110,653),(12111,654),(12112,654),(12113,654),(12114,654),(12115,655),(12116,655),(12117,655),(12118,655),(12119,656),(12120,656),(12121,656),(12122,656),(12123,657),(12124,657),(12125,657),(12126,657),(12127,658),(12128,658),(12129,658),(12130,658),(12131,659),(12132,659),(12133,659),(12134,659),(12135,660),(12136,660),(12137,660),(12138,660),(12139,661),(12140,661),(12141,661),(12142,661),(12143,662),(12144,662),(12145,662),(12146,662),(12147,663),(12148,663),(12149,663),(12150,663),(12151,664),(12152,664),(12153,664),(12154,664),(12155,665),(12156,665),(12157,665),(12158,665),(12159,666),(12160,666),(12161,666),(12162,666),(12163,667),(12164,667),(12165,667),(12166,667),(12167,668),(12168,668),(12169,668),(12170,668),(12171,669),(12172,669),(12173,669),(12174,669),(12175,670),(12176,670),(12177,670),(12178,670),(12179,671),(12180,671),(12181,671),(12182,671),(12183,672),(12184,672),(12185,672),(12186,672),(12187,673),(12188,673),(12189,673),(12190,673),(12191,674),(12192,674),(12193,674),(12194,674),(12195,675),(12196,675),(12197,675),(12198,675),(12199,676),(12200,676),(12201,676),(12202,676),(12203,677),(12204,677),(12205,677),(12206,677),(12207,678),(12208,678),(12209,678),(12210,678),(12211,679),(12212,679),(12213,679),(12214,679),(12215,680),(12216,680),(12217,680),(12218,680),(12219,681),(12220,682),(12221,683),(12222,684),(12223,685),(12224,686),(12225,687),(12226,688),(12227,689),(12228,690),(12229,691),(12230,692),(12231,693),(12232,694),(12233,695),(12234,696),(12235,697),(12236,698),(12237,699),(12238,700),(12239,701),(12240,702),(12241,703),(12242,704),(12243,705),(12244,706),(12245,707),(12246,708),(12247,709),(12248,710),(12249,711),(12250,712),(12251,713),(12252,714),(12253,715),(12254,716),(12255,717),(12256,718),(12257,719),(12258,720),(12259,721),(12260,722),(12261,723),(12262,724),(12263,725),(12264,726),(12265,727),(12266,728),(12267,729),(12268,730),(12269,731),(12270,732),(12271,733),(12272,734),(12273,735),(12274,736),(12275,737),(12276,738),(12277,739),(12278,740),(12279,741),(12280,742),(12281,743),(12282,744),(12283,745),(12284,746),(12285,747),(12286,748),(12287,749),(12288,750),(12289,751),(12290,752),(12291,753),(12292,754),(12293,755),(12294,756),(12295,757),(12296,758),(12297,759),(12298,760),(12299,761),(12300,762),(12301,763),(12302,764),(12303,765),(12304,766),(12305,767),(12306,768),(12307,769),(12308,770),(12309,771),(12310,772),(12311,773),(12312,774),(12313,775),(12314,776),(12315,777),(12316,778),(12317,779),(12318,780),(12319,681),(12320,681),(12321,682),(12322,682),(12323,683),(12324,683),(12325,684),(12326,684),(12327,685),(12328,685),(12329,686),(12330,686),(12331,687),(12332,687),(12333,688),(12334,688),(12335,689),(12336,689),(12337,690),(12338,690),(12339,691),(12340,691),(12341,692),(12342,692),(12343,693),(12344,693),(12345,694),(12346,694),(12347,695),(12348,695),(12349,696),(12350,696),(12351,697),(12352,697),(12353,698),(12354,698),(12355,699),(12356,699),(12357,700),(12358,700),(12359,701),(12360,701),(12361,702),(12362,702),(12363,703),(12364,703),(12365,704),(12366,704),(12367,705),(12368,705),(12369,706),(12370,706),(12371,707),(12372,707),(12373,708),(12374,708),(12375,709),(12376,709),(12377,710),(12378,710),(12379,711),(12380,711),(12381,712),(12382,712),(12383,713),(12384,713),(12385,714),(12386,714),(12387,715),(12388,715),(12389,716),(12390,716),(12391,717),(12392,717),(12393,718),(12394,718),(12395,719),(12396,719),(12397,720),(12398,720),(12399,721),(12400,721),(12401,722),(12402,722),(12403,723),(12404,723),(12405,724),(12406,724),(12407,725),(12408,725),(12409,726),(12410,726),(12411,727),(12412,727),(12413,728),(12414,728),(12415,729),(12416,729),(12417,730),(12418,730),(12419,731),(12420,731),(12421,732),(12422,732),(12423,733),(12424,733),(12425,734),(12426,734),(12427,735),(12428,735),(12429,736),(12430,736),(12431,737),(12432,737),(12433,738),(12434,738),(12435,739),(12436,739),(12437,740),(12438,740),(12439,741),(12440,741),(12441,742),(12442,742),(12443,743),(12444,743),(12445,744),(12446,744),(12447,745),(12448,745),(12449,746),(12450,746),(12451,747),(12452,747),(12453,748),(12454,748),(12455,749),(12456,749),(12457,750),(12458,750),(12459,751),(12460,751),(12461,752),(12462,752),(12463,753),(12464,753),(12465,754),(12466,754),(12467,755),(12468,755),(12469,756),(12470,756),(12471,757),(12472,757),(12473,758),(12474,758),(12475,759),(12476,759),(12477,760),(12478,760),(12479,761),(12480,761),(12481,762),(12482,762),(12483,763),(12484,763),(12485,764),(12486,764),(12487,765),(12488,765),(12489,766),(12490,766),(12491,767),(12492,767),(12493,768),(12494,768),(12495,769),(12496,769),(12497,770),(12498,770),(12499,771),(12500,771),(12501,772),(12502,772),(12503,773),(12504,773),(12505,774),(12506,774),(12507,775),(12508,775),(12509,776),(12510,776),(12511,777),(12512,777),(12513,778),(12514,778),(12515,779),(12516,779),(12517,780),(12518,780),(12519,681),(12520,681),(12521,681),(12522,681),(12523,682),(12524,682),(12525,682),(12526,682),(12527,682),(12528,682),(12529,683),(12530,683),(12531,683),(12532,683),(12533,684),(12534,684),(12535,684),(12536,684),(12537,685),(12538,685),(12539,685),(12540,685),(12541,686),(12542,686),(12543,686),(12544,686),(12545,687),(12546,687),(12547,687),(12548,687),(12549,687),(12550,687),(12551,688),(12552,688),(12553,688),(12554,688),(12555,688),(12556,688),(12557,689),(12558,689),(12559,689),(12560,689),(12561,690),(12562,690),(12563,690),(12564,690),(12565,690),(12566,690),(12567,691),(12568,691),(12569,691),(12570,691),(12571,691),(12572,691),(12573,692),(12574,692),(12575,692),(12576,692),(12577,692),(12578,692),(12579,693),(12580,693),(12581,693),(12582,693),(12583,693),(12584,693),(12585,694),(12586,694),(12587,694),(12588,694),(12589,694),(12590,694),(12591,695),(12592,695),(12593,695),(12594,695),(12595,695),(12596,695),(12597,696),(12598,696),(12599,696),(12600,696),(12601,696),(12602,696),(12603,697),(12604,697),(12605,697),(12606,697),(12607,697),(12608,697),(12609,698),(12610,698),(12611,698),(12612,698),(12613,698),(12614,698),(12615,699),(12616,699),(12617,699),(12618,699),(12619,700),(12620,700),(12621,700),(12622,700),(12623,700),(12624,700),(12625,701),(12626,701),(12627,701),(12628,701),(12629,701),(12630,701),(12631,702),(12632,702),(12633,702),(12634,702),(12635,702),(12636,702),(12637,703),(12638,703),(12639,703),(12640,703),(12641,703),(12642,703),(12643,704),(12644,704),(12645,704),(12646,704),(12647,704),(12648,704),(12649,705),(12650,705),(12651,705),(12652,705),(12653,705),(12654,705),(12655,706),(12656,706),(12657,706),(12658,706),(12659,706),(12660,706),(12661,707),(12662,707),(12663,707),(12664,707),(12665,707),(12666,707),(12667,708),(12668,708),(12669,708),(12670,708),(12671,708),(12672,708),(12673,709),(12674,709),(12675,709),(12676,709),(12677,710),(12678,710),(12679,710),(12680,710),(12681,711),(12682,711),(12683,711),(12684,711),(12685,711),(12686,711),(12687,712),(12688,712),(12689,712),(12690,712),(12691,713),(12692,713),(12693,713),(12694,713),(12695,713),(12696,713),(12697,714),(12698,714),(12699,714),(12700,714),(12701,714),(12702,714),(12703,715),(12704,715),(12705,715),(12706,715),(12707,716),(12708,716),(12709,716),(12710,716),(12711,717),(12712,717),(12713,717),(12714,717),(12715,718),(12716,718),(12717,718),(12718,718),(12719,719),(12720,719),(12721,719),(12722,719),(12723,720),(12724,720),(12725,720),(12726,720),(12727,721),(12728,721),(12729,721),(12730,721),(12731,721),(12732,721),(12733,722),(12734,722),(12735,722),(12736,722),(12737,723),(12738,723),(12739,723),(12740,723),(12741,724),(12742,724),(12743,724),(12744,724),(12745,725),(12746,725),(12747,725),(12748,725),(12749,725),(12750,726),(12751,726),(12752,726),(12753,726),(12754,727),(12755,727),(12756,727),(12757,727),(12758,728),(12759,728),(12760,728),(12761,728),(12762,729),(12763,729),(12764,729),(12765,729),(12766,730),(12767,730),(12768,730),(12769,730),(12770,731),(12771,731),(12772,731),(12773,731),(12774,732),(12775,732),(12776,732),(12777,732),(12778,732),(12779,732),(12780,733),(12781,733),(12782,733),(12783,733),(12784,733),(12785,733),(12786,734),(12787,734),(12788,734),(12789,734),(12790,734),(12791,734),(12792,735),(12793,735),(12794,735),(12795,735),(12796,736),(12797,736),(12798,736),(12799,736),(12800,737),(12801,737),(12802,737),(12803,737),(12804,737),(12805,737),(12806,738),(12807,738),(12808,738),(12809,738),(12810,739),(12811,739),(12812,739),(12813,739),(12814,740),(12815,740),(12816,740),(12817,740),(12818,741),(12819,741),(12820,741),(12821,741),(12822,741),(12823,741),(12824,742),(12825,742),(12826,742),(12827,742),(12828,742),(12829,742),(12830,743),(12831,743),(12832,743),(12833,743),(12834,743),(12835,743),(12836,744),(12837,744),(12838,744),(12839,744),(12840,744),(12841,744),(12842,745),(12843,745),(12844,745),(12845,745),(12846,745),(12847,745),(12848,746),(12849,746),(12850,746),(12851,746),(12852,746),(12853,746),(12854,747),(12855,747),(12856,747),(12857,747),(12858,747),(12859,747),(12860,748),(12861,748),(12862,748),(12863,748),(12864,748),(12865,748),(12866,749),(12867,749),(12868,749),(12869,749),(12870,749),(12871,749),(12872,750),(12873,750),(12874,750),(12875,750),(12876,750),(12877,750),(12878,751),(12879,751),(12880,751),(12881,751),(12882,751),(12883,751),(12884,752),(12885,752),(12886,752),(12887,752),(12888,752),(12889,752),(12890,753),(12891,753),(12892,753),(12893,753),(12894,753),(12895,753),(12896,754),(12897,754),(12898,754),(12899,754),(12900,754),(12901,754),(12902,755),(12903,755),(12904,755),(12905,755),(12906,755),(12907,755),(12908,756),(12909,756),(12910,756),(12911,756),(12912,756),(12913,756),(12914,757),(12915,757),(12916,757),(12917,757),(12918,757),(12919,757),(12920,758),(12921,758),(12922,758),(12923,758),(12924,758),(12925,758),(12926,759),(12927,759),(12928,759),(12929,759),(12930,759),(12931,759),(12932,760),(12933,760),(12934,760),(12935,760),(12936,760),(12937,760),(12938,761),(12939,761),(12940,761),(12941,761),(12942,761),(12943,761),(12944,762),(12945,762),(12946,762),(12947,762),(12948,762),(12949,762),(12950,763),(12951,763),(12952,763),(12953,763),(12954,763),(12955,763),(12956,764),(12957,764),(12958,764),(12959,764),(12960,764),(12961,764),(12962,765),(12963,765),(12964,765),(12965,765),(12966,765),(12967,765),(12968,766),(12969,766),(12970,766),(12971,766),(12972,766),(12973,766),(12974,767),(12975,767),(12976,767),(12977,767),(12978,767),(12979,767),(12980,768),(12981,768),(12982,768),(12983,768),(12984,768),(12985,768),(12986,769),(12987,769),(12988,769),(12989,769),(12990,769),(12991,769),(12992,770),(12993,770),(12994,770),(12995,770),(12996,770),(12997,770),(12998,771),(12999,771),(13000,771),(13001,771),(13002,771),(13003,771),(13004,772),(13005,772),(13006,772),(13007,772),(13008,772),(13009,772),(13010,773),(13011,773),(13012,773),(13013,773),(13014,773),(13015,773),(13016,774),(13017,774),(13018,774),(13019,774),(13020,774),(13021,774),(13022,775),(13023,775),(13024,775),(13025,775),(13026,775),(13027,775),(13028,776),(13029,776),(13030,776),(13031,776),(13032,776),(13033,776),(13034,777),(13035,777),(13036,777),(13037,777),(13038,777),(13039,777),(13040,778),(13041,778),(13042,778),(13043,778),(13044,778),(13045,778),(13046,779),(13047,779),(13048,779),(13049,779),(13050,779),(13051,779),(13052,780),(13053,780),(13054,780),(13055,780),(13056,780),(13057,780),(13058,681),(13059,682),(13060,682),(13061,683),(13062,684),(13063,685),(13064,686),(13065,687),(13066,687),(13067,688),(13068,688),(13069,689),(13070,690),(13071,690),(13072,691),(13073,691),(13074,692),(13075,692),(13076,693),(13077,693),(13078,694),(13079,694),(13080,695),(13081,695),(13082,696),(13083,696),(13084,697),(13085,697),(13086,698),(13087,698),(13088,699),(13089,700),(13090,700),(13091,701),(13092,701),(13093,702),(13094,702),(13095,703),(13096,703),(13097,704),(13098,704),(13099,705),(13100,705),(13101,706),(13102,706),(13103,707),(13104,707),(13105,708),(13106,708),(13107,709),(13108,710),(13109,711),(13110,711),(13111,712),(13112,713),(13113,713),(13114,714),(13115,714),(13116,715),(13117,716),(13118,717),(13119,718),(13120,719),(13121,720),(13122,721),(13123,721),(13124,722),(13125,723),(13126,724),(13127,725),(13128,725),(13129,726),(13130,727),(13131,728),(13132,729),(13133,730),(13134,731),(13135,732),(13136,732),(13137,733),(13138,733),(13139,734),(13140,734),(13141,735),(13142,736),(13143,737),(13144,737),(13145,738),(13146,739),(13147,740),(13148,741),(13149,741),(13150,742),(13151,742),(13152,743),(13153,743),(13154,744),(13155,744),(13156,745),(13157,745),(13158,746),(13159,746),(13160,747),(13161,747),(13162,748),(13163,748),(13164,749),(13165,749),(13166,750),(13167,750),(13168,751),(13169,751),(13170,752),(13171,752),(13172,753),(13173,753),(13174,754),(13175,754),(13176,755),(13177,755),(13178,756),(13179,756),(13180,757),(13181,757),(13182,758),(13183,758),(13184,759),(13185,759),(13186,760),(13187,760),(13188,761),(13189,761),(13190,762),(13191,762),(13192,763),(13193,763),(13194,764),(13195,764),(13196,765),(13197,765),(13198,766),(13199,766),(13200,767),(13201,767),(13202,768),(13203,768),(13204,769),(13205,769),(13206,770),(13207,770),(13208,771),(13209,771),(13210,772),(13211,772),(13212,773),(13213,773),(13214,774),(13215,774),(13216,775),(13217,775),(13218,776),(13219,776),(13220,777),(13221,777),(13222,778),(13223,778),(13224,779),(13225,779),(13226,780),(13227,780),(13228,681),(13229,681),(13230,681),(13231,682),(13232,682),(13233,682),(13234,683),(13235,683),(13236,683),(13237,684),(13238,684),(13239,684),(13240,685),(13241,685),(13242,685),(13243,686),(13244,686),(13245,686),(13246,687),(13247,687),(13248,687),(13249,688),(13250,688),(13251,688),(13252,689),(13253,689),(13254,689),(13255,690),(13256,690),(13257,690),(13258,691),(13259,691),(13260,691),(13261,692),(13262,692),(13263,692),(13264,693),(13265,693),(13266,693),(13267,694),(13268,694),(13269,694),(13270,695),(13271,695),(13272,695),(13273,696),(13274,696),(13275,696),(13276,697),(13277,697),(13278,697),(13279,698),(13280,698),(13281,698),(13282,699),(13283,699),(13284,699),(13285,700),(13286,700),(13287,700),(13288,701),(13289,701),(13290,701),(13291,702),(13292,702),(13293,702),(13294,703),(13295,703),(13296,703),(13297,704),(13298,704),(13299,704),(13300,705),(13301,705),(13302,705),(13303,706),(13304,706),(13305,706),(13306,707),(13307,707),(13308,707),(13309,708),(13310,708),(13311,708),(13312,709),(13313,709),(13314,709),(13315,710),(13316,710),(13317,710),(13318,711),(13319,711),(13320,711),(13321,712),(13322,712),(13323,712),(13324,713),(13325,713),(13326,713),(13327,714),(13328,714),(13329,714),(13330,715),(13331,715),(13332,715),(13333,716),(13334,716),(13335,716),(13336,717),(13337,717),(13338,717),(13339,718),(13340,718),(13341,718),(13342,719),(13343,719),(13344,719),(13345,720),(13346,720),(13347,720),(13348,721),(13349,721),(13350,721),(13351,722),(13352,722),(13353,722),(13354,723),(13355,723),(13356,723),(13357,724),(13358,724),(13359,724),(13360,725),(13361,725),(13362,725),(13363,726),(13364,726),(13365,726),(13366,727),(13367,727),(13368,727),(13369,728),(13370,728),(13371,728),(13372,729),(13373,729),(13374,729),(13375,730),(13376,730),(13377,730),(13378,731),(13379,731),(13380,731),(13381,732),(13382,732),(13383,732),(13384,733),(13385,733),(13386,733),(13387,734),(13388,734),(13389,734),(13390,735),(13391,735),(13392,735),(13393,736),(13394,736),(13395,736),(13396,737),(13397,737),(13398,737),(13399,738),(13400,738),(13401,738),(13402,739),(13403,739),(13404,739),(13405,740),(13406,740),(13407,740),(13408,741),(13409,741),(13410,741),(13411,742),(13412,742),(13413,742),(13414,743),(13415,743),(13416,743),(13417,744),(13418,744),(13419,744),(13420,745),(13421,745),(13422,745),(13423,746),(13424,746),(13425,746),(13426,747),(13427,747),(13428,747),(13429,748),(13430,748),(13431,748),(13432,749),(13433,749),(13434,749),(13435,750),(13436,750),(13437,750),(13438,751),(13439,751),(13440,751),(13441,752),(13442,752),(13443,752),(13444,753),(13445,753),(13446,753),(13447,754),(13448,754),(13449,754),(13450,755),(13451,755),(13452,755),(13453,756),(13454,756),(13455,756),(13456,757),(13457,757),(13458,757),(13459,758),(13460,758),(13461,758),(13462,759),(13463,759),(13464,759),(13465,760),(13466,760),(13467,760),(13468,761),(13469,761),(13470,761),(13471,762),(13472,762),(13473,762),(13474,763),(13475,763),(13476,763),(13477,764),(13478,764),(13479,764),(13480,765),(13481,765),(13482,765),(13483,766),(13484,766),(13485,766),(13486,767),(13487,767),(13488,767),(13489,768),(13490,768),(13491,768),(13492,769),(13493,769),(13494,769),(13495,770),(13496,770),(13497,770),(13498,771),(13499,771),(13500,771),(13501,772),(13502,772),(13503,772),(13504,773),(13505,773),(13506,773),(13507,774),(13508,774),(13509,774),(13510,775),(13511,775),(13512,775),(13513,776),(13514,776),(13515,776),(13516,777),(13517,777),(13518,777),(13519,778),(13520,778),(13521,778),(13522,779),(13523,779),(13524,779),(13525,780),(13526,780),(13527,780),(13528,681),(13529,681),(13530,681),(13531,681),(13532,682),(13533,682),(13534,682),(13535,682),(13536,683),(13537,683),(13538,683),(13539,683),(13540,684),(13541,684),(13542,684),(13543,684),(13544,685),(13545,685),(13546,685),(13547,685),(13548,686),(13549,686),(13550,686),(13551,686),(13552,687),(13553,687),(13554,687),(13555,687),(13556,688),(13557,688),(13558,688),(13559,688),(13560,689),(13561,689),(13562,689),(13563,689),(13564,690),(13565,690),(13566,690),(13567,690),(13568,691),(13569,691),(13570,691),(13571,691),(13572,692),(13573,692),(13574,692),(13575,692),(13576,693),(13577,693),(13578,693),(13579,693),(13580,694),(13581,694),(13582,694),(13583,694),(13584,695),(13585,695),(13586,695),(13587,695),(13588,696),(13589,696),(13590,696),(13591,696),(13592,697),(13593,697),(13594,697),(13595,697),(13596,698),(13597,698),(13598,698),(13599,698),(13600,699),(13601,699),(13602,699),(13603,699),(13604,700),(13605,700),(13606,700),(13607,700),(13608,701),(13609,701),(13610,701),(13611,701),(13612,702),(13613,702),(13614,702),(13615,702),(13616,703),(13617,703),(13618,703),(13619,703),(13620,704),(13621,704),(13622,704),(13623,704),(13624,705),(13625,705),(13626,705),(13627,705),(13628,706),(13629,706),(13630,706),(13631,706),(13632,707),(13633,707),(13634,707),(13635,707),(13636,708),(13637,708),(13638,708),(13639,708),(13640,709),(13641,709),(13642,709),(13643,709),(13644,710),(13645,710),(13646,710),(13647,710),(13648,711),(13649,711),(13650,711),(13651,711),(13652,712),(13653,712),(13654,712),(13655,712),(13656,713),(13657,713),(13658,713),(13659,713),(13660,714),(13661,714),(13662,714),(13663,714),(13664,715),(13665,715),(13666,715),(13667,715),(13668,716),(13669,716),(13670,716),(13671,716),(13672,717),(13673,717),(13674,717),(13675,717),(13676,718),(13677,718),(13678,718),(13679,718),(13680,719),(13681,719),(13682,719),(13683,719),(13684,720),(13685,720),(13686,720),(13687,720),(13688,721),(13689,721),(13690,721),(13691,721),(13692,722),(13693,722),(13694,722),(13695,722),(13696,723),(13697,723),(13698,723),(13699,723),(13700,724),(13701,724),(13702,724),(13703,724),(13704,725),(13705,725),(13706,725),(13707,725),(13708,726),(13709,726),(13710,726),(13711,726),(13712,727),(13713,727),(13714,727),(13715,727),(13716,728),(13717,728),(13718,728),(13719,728),(13720,729),(13721,729),(13722,729),(13723,729),(13724,730),(13725,730),(13726,730),(13727,730),(13728,731),(13729,731),(13730,731),(13731,731),(13732,732),(13733,732),(13734,732),(13735,732),(13736,733),(13737,733),(13738,733),(13739,733),(13740,734),(13741,734),(13742,734),(13743,734),(13744,735),(13745,735),(13746,735),(13747,735),(13748,736),(13749,736),(13750,736),(13751,736),(13752,737),(13753,737),(13754,737),(13755,737),(13756,738),(13757,738),(13758,738),(13759,738),(13760,739),(13761,739),(13762,739),(13763,739),(13764,740),(13765,740),(13766,740),(13767,740),(13768,741),(13769,741),(13770,741),(13771,741),(13772,742),(13773,742),(13774,742),(13775,742),(13776,743),(13777,743),(13778,743),(13779,743),(13780,744),(13781,744),(13782,744),(13783,744),(13784,745),(13785,745),(13786,745),(13787,745),(13788,746),(13789,746),(13790,746),(13791,746),(13792,747),(13793,747),(13794,747),(13795,747),(13796,748),(13797,748),(13798,748),(13799,748),(13800,749),(13801,749),(13802,749),(13803,749),(13804,750),(13805,750),(13806,750),(13807,750),(13808,751),(13809,751),(13810,751),(13811,751),(13812,752),(13813,752),(13814,752),(13815,752),(13816,753),(13817,753),(13818,753),(13819,753),(13820,754),(13821,754),(13822,754),(13823,754),(13824,755),(13825,755),(13826,755),(13827,755),(13828,756),(13829,756),(13830,756),(13831,756),(13832,757),(13833,757),(13834,757),(13835,757),(13836,758),(13837,758),(13838,758),(13839,758),(13840,759),(13841,759),(13842,759),(13843,759),(13844,760),(13845,760),(13846,760),(13847,760),(13848,761),(13849,761),(13850,761),(13851,761),(13852,762),(13853,762),(13854,762),(13855,762),(13856,763),(13857,763),(13858,763),(13859,763),(13860,764),(13861,764),(13862,764),(13863,764),(13864,765),(13865,765),(13866,765),(13867,765),(13868,766),(13869,766),(13870,766),(13871,766),(13872,767),(13873,767),(13874,767),(13875,767),(13876,768),(13877,768),(13878,768),(13879,768),(13880,769),(13881,769),(13882,769),(13883,769),(13884,770),(13885,770),(13886,770),(13887,770),(13888,771),(13889,771),(13890,771),(13891,771),(13892,772),(13893,772),(13894,772),(13895,772),(13896,773),(13897,773),(13898,773),(13899,773),(13900,774),(13901,774),(13902,774),(13903,774),(13904,775),(13905,775),(13906,775),(13907,775),(13908,776),(13909,776),(13910,776),(13911,776),(13912,777),(13913,777),(13914,777),(13915,777),(13916,778),(13917,778),(13918,778),(13919,778),(13920,779),(13921,779),(13922,779),(13923,779),(13924,780),(13925,780),(13926,780),(13927,780),(13928,781),(13929,782),(13930,783),(13931,784),(13932,785),(13933,786),(13934,787),(13935,788),(13936,789),(13937,790),(13938,791),(13939,792),(13940,793),(13941,794),(13942,795),(13943,796),(13944,797),(13945,798),(13946,799),(13947,800),(13948,801),(13949,802),(13950,803),(13951,804),(13952,805),(13953,806),(13954,807),(13955,808),(13956,809),(13957,810),(13958,811),(13959,812),(13960,813),(13961,814),(13962,815),(13963,816),(13964,817),(13965,818),(13966,819),(13967,820),(13968,821),(13969,822),(13970,823),(13971,824),(13972,825),(13973,826),(13974,827),(13975,828),(13976,829),(13977,830),(13978,831),(13979,832),(13980,833),(13981,834),(13982,835),(13983,836),(13984,837),(13985,838),(13986,839),(13987,840),(13988,841),(13989,842),(13990,843),(13991,844),(13992,845),(13993,846),(13994,847),(13995,848),(13996,849),(13997,850),(13998,851),(13999,852),(14000,853),(14001,854),(14002,855),(14003,856),(14004,857),(14005,858),(14006,859),(14007,860),(14008,861),(14009,862),(14010,863),(14011,864),(14012,865),(14013,866),(14014,867),(14015,868),(14016,869),(14017,870),(14018,871),(14019,872),(14020,873),(14021,874),(14022,875),(14023,876),(14024,877),(14025,878),(14026,879),(14027,880),(14028,781),(14029,781),(14030,782),(14031,782),(14032,783),(14033,783),(14034,784),(14035,784),(14036,785),(14037,785),(14038,786),(14039,786),(14040,787),(14041,787),(14042,788),(14043,788),(14044,789),(14045,789),(14046,790),(14047,790),(14048,791),(14049,791),(14050,792),(14051,792),(14052,793),(14053,793),(14054,794),(14055,794),(14056,795),(14057,795),(14058,796),(14059,796),(14060,797),(14061,797),(14062,798),(14063,798),(14064,799),(14065,799),(14066,800),(14067,800),(14068,801),(14069,801),(14070,802),(14071,802),(14072,803),(14073,803),(14074,804),(14075,804),(14076,805),(14077,805),(14078,806),(14079,806),(14080,807),(14081,807),(14082,808),(14083,808),(14084,809),(14085,809),(14086,810),(14087,810),(14088,811),(14089,811),(14090,812),(14091,812),(14092,813),(14093,813),(14094,814),(14095,814),(14096,815),(14097,815),(14098,816),(14099,816),(14100,817),(14101,817),(14102,818),(14103,818),(14104,819),(14105,819),(14106,820),(14107,820),(14108,821),(14109,821),(14110,822),(14111,822),(14112,823),(14113,823),(14114,824),(14115,824),(14116,825),(14117,825),(14118,826),(14119,826),(14120,827),(14121,827),(14122,828),(14123,828),(14124,829),(14125,829),(14126,830),(14127,830),(14128,831),(14129,831),(14130,832),(14131,832),(14132,833),(14133,833),(14134,834),(14135,834),(14136,835),(14137,835),(14138,836),(14139,836),(14140,837),(14141,837),(14142,838),(14143,838),(14144,839),(14145,839),(14146,840),(14147,840),(14148,841),(14149,841),(14150,842),(14151,842),(14152,843),(14153,843),(14154,844),(14155,844),(14156,845),(14157,845),(14158,846),(14159,846),(14160,847),(14161,847),(14162,848),(14163,848),(14164,849),(14165,849),(14166,850),(14167,850),(14168,851),(14169,851),(14170,852),(14171,852),(14172,853),(14173,853),(14174,854),(14175,854),(14176,855),(14177,855),(14178,856),(14179,856),(14180,857),(14181,857),(14182,858),(14183,858),(14184,859),(14185,859),(14186,860),(14187,860),(14188,861),(14189,861),(14190,862),(14191,862),(14192,863),(14193,863),(14194,864),(14195,864),(14196,865),(14197,865),(14198,866),(14199,866),(14200,867),(14201,867),(14202,868),(14203,868),(14204,869),(14205,869),(14206,870),(14207,870),(14208,871),(14209,871),(14210,872),(14211,872),(14212,873),(14213,873),(14214,874),(14215,874),(14216,875),(14217,875),(14218,876),(14219,876),(14220,877),(14221,877),(14222,878),(14223,878),(14224,879),(14225,879),(14226,880),(14227,880),(14228,781),(14229,781),(14230,781),(14231,781),(14232,781),(14233,781),(14234,782),(14235,782),(14236,782),(14237,782),(14238,782),(14239,782),(14240,783),(14241,783),(14242,783),(14243,783),(14244,783),(14245,783),(14246,784),(14247,784),(14248,784),(14249,784),(14250,784),(14251,784),(14252,785),(14253,785),(14254,785),(14255,785),(14256,785),(14257,785),(14258,786),(14259,786),(14260,786),(14261,786),(14262,786),(14263,786),(14264,787),(14265,787),(14266,787),(14267,787),(14268,787),(14269,787),(14270,788),(14271,788),(14272,788),(14273,788),(14274,788),(14275,788),(14276,789),(14277,789),(14278,789),(14279,789),(14280,789),(14281,789),(14282,790),(14283,790),(14284,790),(14285,790),(14286,790),(14287,790),(14288,791),(14289,791),(14290,791),(14291,791),(14292,791),(14293,791),(14294,792),(14295,792),(14296,792),(14297,792),(14298,792),(14299,792),(14300,793),(14301,793),(14302,793),(14303,793),(14304,793),(14305,793),(14306,794),(14307,794),(14308,794),(14309,794),(14310,794),(14311,794),(14312,795),(14313,795),(14314,795),(14315,795),(14316,795),(14317,795),(14318,796),(14319,796),(14320,796),(14321,796),(14322,796),(14323,796),(14324,797),(14325,797),(14326,797),(14327,797),(14328,797),(14329,797),(14330,798),(14331,798),(14332,798),(14333,798),(14334,798),(14335,798),(14336,799),(14337,799),(14338,799),(14339,799),(14340,799),(14341,799),(14342,800),(14343,800),(14344,800),(14345,800),(14346,800),(14347,800),(14348,801),(14349,801),(14350,801),(14351,801),(14352,801),(14353,801),(14354,802),(14355,802),(14356,802),(14357,802),(14358,802),(14359,802),(14360,803),(14361,803),(14362,803),(14363,803),(14364,803),(14365,803),(14366,804),(14367,804),(14368,804),(14369,804),(14370,804),(14371,804),(14372,805),(14373,805),(14374,805),(14375,805),(14376,805),(14377,805),(14378,806),(14379,806),(14380,806),(14381,806),(14382,806),(14383,806),(14384,807),(14385,807),(14386,807),(14387,807),(14388,807),(14389,807),(14390,808),(14391,808),(14392,808),(14393,808),(14394,808),(14395,808),(14396,809),(14397,809),(14398,809),(14399,809),(14400,809),(14401,809),(14402,810),(14403,810),(14404,810),(14405,810),(14406,810),(14407,810),(14408,811),(14409,811),(14410,811),(14411,811),(14412,811),(14413,811),(14414,812),(14415,812),(14416,812),(14417,812),(14418,812),(14419,812),(14420,813),(14421,813),(14422,813),(14423,813),(14424,813),(14425,813),(14426,814),(14427,814),(14428,814),(14429,814),(14430,814),(14431,814),(14432,815),(14433,815),(14434,815),(14435,815),(14436,815),(14437,815),(14438,816),(14439,816),(14440,816),(14441,816),(14442,816),(14443,816),(14444,817),(14445,817),(14446,817),(14447,817),(14448,817),(14449,817),(14450,818),(14451,818),(14452,818),(14453,818),(14454,818),(14455,818),(14456,819),(14457,819),(14458,819),(14459,819),(14460,819),(14461,819),(14462,820),(14463,820),(14464,820),(14465,820),(14466,820),(14467,820),(14468,821),(14469,821),(14470,821),(14471,821),(14472,821),(14473,821),(14474,822),(14475,822),(14476,822),(14477,822),(14478,822),(14479,822),(14480,823),(14481,823),(14482,823),(14483,823),(14484,823),(14485,823),(14486,824),(14487,824),(14488,824),(14489,824),(14490,824),(14491,824),(14492,825),(14493,825),(14494,825),(14495,825),(14496,825),(14497,825),(14498,826),(14499,826),(14500,826),(14501,826),(14502,826),(14503,826),(14504,827),(14505,827),(14506,827),(14507,827),(14508,827),(14509,827),(14510,828),(14511,828),(14512,828),(14513,828),(14514,828),(14515,828),(14516,829),(14517,829),(14518,829),(14519,829),(14520,829),(14521,829),(14522,830),(14523,830),(14524,830),(14525,830),(14526,830),(14527,830),(14528,831),(14529,831),(14530,831),(14531,831),(14532,831),(14533,831),(14534,832),(14535,832),(14536,832),(14537,832),(14538,832),(14539,832),(14540,833),(14541,833),(14542,833),(14543,833),(14544,833),(14545,833),(14546,834),(14547,834),(14548,834),(14549,834),(14550,834),(14551,834),(14552,835),(14553,835),(14554,835),(14555,835),(14556,835),(14557,835),(14558,836),(14559,836),(14560,836),(14561,836),(14562,836),(14563,836),(14564,837),(14565,837),(14566,837),(14567,837),(14568,837),(14569,837),(14570,838),(14571,838),(14572,838),(14573,838),(14574,838),(14575,838),(14576,839),(14577,839),(14578,839),(14579,839),(14580,839),(14581,839),(14582,840),(14583,840),(14584,840),(14585,840),(14586,840),(14587,840),(14588,841),(14589,841),(14590,841),(14591,841),(14592,841),(14593,841),(14594,842),(14595,842),(14596,842),(14597,842),(14598,842),(14599,842),(14600,843),(14601,843),(14602,843),(14603,843),(14604,843),(14605,843),(14606,844),(14607,844),(14608,844),(14609,844),(14610,844),(14611,844),(14612,845),(14613,845),(14614,845),(14615,845),(14616,845),(14617,845),(14618,846),(14619,846),(14620,846),(14621,846),(14622,846),(14623,846),(14624,847),(14625,847),(14626,847),(14627,847),(14628,847),(14629,847),(14630,848),(14631,848),(14632,848),(14633,848),(14634,848),(14635,848),(14636,849),(14637,849),(14638,849),(14639,849),(14640,849),(14641,849),(14642,850),(14643,850),(14644,850),(14645,850),(14646,850),(14647,850),(14648,851),(14649,851),(14650,851),(14651,851),(14652,851),(14653,851),(14654,852),(14655,852),(14656,852),(14657,852),(14658,852),(14659,852),(14660,853),(14661,853),(14662,853),(14663,853),(14664,853),(14665,853),(14666,854),(14667,854),(14668,854),(14669,854),(14670,854),(14671,854),(14672,855),(14673,855),(14674,855),(14675,855),(14676,855),(14677,855),(14678,856),(14679,856),(14680,856),(14681,856),(14682,856),(14683,856),(14684,857),(14685,857),(14686,857),(14687,857),(14688,857),(14689,857),(14690,858),(14691,858),(14692,858),(14693,858),(14694,858),(14695,858),(14696,859),(14697,859),(14698,859),(14699,859),(14700,859),(14701,859),(14702,860),(14703,860),(14704,860),(14705,860),(14706,860),(14707,860),(14708,861),(14709,861),(14710,861),(14711,861),(14712,861),(14713,861),(14714,862),(14715,862),(14716,862),(14717,862),(14718,862),(14719,862),(14720,863),(14721,863),(14722,863),(14723,863),(14724,863),(14725,863),(14726,864),(14727,864),(14728,864),(14729,864),(14730,864),(14731,864),(14732,865),(14733,865),(14734,865),(14735,865),(14736,865),(14737,865),(14738,866),(14739,866),(14740,866),(14741,866),(14742,866),(14743,866),(14744,867),(14745,867),(14746,867),(14747,867),(14748,867),(14749,867),(14750,868),(14751,868),(14752,868),(14753,868),(14754,868),(14755,868),(14756,869),(14757,869),(14758,869),(14759,869),(14760,869),(14761,869),(14762,870),(14763,870),(14764,870),(14765,870),(14766,870),(14767,870),(14768,871),(14769,871),(14770,871),(14771,871),(14772,871),(14773,871),(14774,872),(14775,872),(14776,872),(14777,872),(14778,872),(14779,872),(14780,873),(14781,873),(14782,873),(14783,873),(14784,873),(14785,873),(14786,874),(14787,874),(14788,874),(14789,874),(14790,874),(14791,874),(14792,875),(14793,875),(14794,875),(14795,875),(14796,875),(14797,875),(14798,876),(14799,876),(14800,876),(14801,876),(14802,876),(14803,876),(14804,877),(14805,877),(14806,877),(14807,877),(14808,877),(14809,877),(14810,878),(14811,878),(14812,878),(14813,878),(14814,878),(14815,878),(14816,879),(14817,879),(14818,879),(14819,879),(14820,879),(14821,879),(14822,880),(14823,880),(14824,880),(14825,880),(14826,880),(14827,880),(14828,781),(14829,781),(14830,782),(14831,782),(14832,783),(14833,783),(14834,784),(14835,784),(14836,785),(14837,785),(14838,786),(14839,786),(14840,787),(14841,787),(14842,788),(14843,788),(14844,789),(14845,789),(14846,790),(14847,790),(14848,791),(14849,791),(14850,792),(14851,792),(14852,793),(14853,793),(14854,794),(14855,794),(14856,795),(14857,795),(14858,796),(14859,796),(14860,797),(14861,797),(14862,798),(14863,798),(14864,799),(14865,799),(14866,800),(14867,800),(14868,801),(14869,801),(14870,802),(14871,802),(14872,803),(14873,803),(14874,804),(14875,804),(14876,805),(14877,805),(14878,806),(14879,806),(14880,807),(14881,807),(14882,808),(14883,808),(14884,809),(14885,809),(14886,810),(14887,810),(14888,811),(14889,811),(14890,812),(14891,812),(14892,813),(14893,813),(14894,814),(14895,814),(14896,815),(14897,815),(14898,816),(14899,816),(14900,817),(14901,817),(14902,818),(14903,818),(14904,819),(14905,819),(14906,820),(14907,820),(14908,821),(14909,821),(14910,822),(14911,822),(14912,823),(14913,823),(14914,824),(14915,824),(14916,825),(14917,825),(14918,826),(14919,826),(14920,827),(14921,827),(14922,828),(14923,828),(14924,829),(14925,829),(14926,830),(14927,830),(14928,831),(14929,831),(14930,832),(14931,832),(14932,833),(14933,833),(14934,834),(14935,834),(14936,835),(14937,835),(14938,836),(14939,836),(14940,837),(14941,837),(14942,838),(14943,838),(14944,839),(14945,839),(14946,840),(14947,840),(14948,841),(14949,841),(14950,842),(14951,842),(14952,843),(14953,843),(14954,844),(14955,844),(14956,845),(14957,845),(14958,846),(14959,846),(14960,847),(14961,847),(14962,848),(14963,848),(14964,849),(14965,849),(14966,850),(14967,850),(14968,851),(14969,851),(14970,852),(14971,852),(14972,853),(14973,853),(14974,854),(14975,854),(14976,855),(14977,855),(14978,856),(14979,856),(14980,857),(14981,857),(14982,858),(14983,858),(14984,859),(14985,859),(14986,860),(14987,860),(14988,861),(14989,861),(14990,862),(14991,862),(14992,863),(14993,863),(14994,864),(14995,864),(14996,865),(14997,865),(14998,866),(14999,866),(15000,867),(15001,867),(15002,868),(15003,868),(15004,869),(15005,869),(15006,870),(15007,870),(15008,871),(15009,871),(15010,872),(15011,872),(15012,873),(15013,873),(15014,873),(15015,874),(15016,874),(15017,874),(15018,875),(15019,875),(15020,875),(15021,876),(15022,876),(15023,876),(15024,877),(15025,877),(15026,877),(15027,878),(15028,878),(15029,879),(15030,879),(15031,880),(15032,880),(15033,880),(15034,781),(15035,781),(15036,781),(15037,782),(15038,782),(15039,782),(15040,783),(15041,783),(15042,783),(15043,784),(15044,784),(15045,784),(15046,785),(15047,785),(15048,785),(15049,786),(15050,786),(15051,786),(15052,787),(15053,787),(15054,787),(15055,788),(15056,788),(15057,788),(15058,789),(15059,789),(15060,789),(15061,790),(15062,790),(15063,790),(15064,791),(15065,791),(15066,791),(15067,792),(15068,792),(15069,792),(15070,793),(15071,793),(15072,793),(15073,794),(15074,794),(15075,794),(15076,795),(15077,795),(15078,795),(15079,796),(15080,796),(15081,796),(15082,797),(15083,797),(15084,797),(15085,798),(15086,798),(15087,798),(15088,799),(15089,799),(15090,799),(15091,800),(15092,800),(15093,800),(15094,801),(15095,801),(15096,801),(15097,802),(15098,802),(15099,802),(15100,803),(15101,803),(15102,803),(15103,804),(15104,804),(15105,804),(15106,805),(15107,805),(15108,805),(15109,806),(15110,806),(15111,806),(15112,807),(15113,807),(15114,807),(15115,808),(15116,808),(15117,808),(15118,809),(15119,809),(15120,809),(15121,810),(15122,810),(15123,810),(15124,811),(15125,811),(15126,811),(15127,812),(15128,812),(15129,812),(15130,813),(15131,813),(15132,813),(15133,814),(15134,814),(15135,814),(15136,815),(15137,815),(15138,815),(15139,816),(15140,816),(15141,816),(15142,817),(15143,817),(15144,817),(15145,818),(15146,818),(15147,818),(15148,819),(15149,819),(15150,819),(15151,820),(15152,820),(15153,820),(15154,821),(15155,821),(15156,821),(15157,822),(15158,822),(15159,822),(15160,823),(15161,823),(15162,823),(15163,824),(15164,824),(15165,824),(15166,825),(15167,825),(15168,825),(15169,826),(15170,826),(15171,826),(15172,827),(15173,827),(15174,827),(15175,828),(15176,828),(15177,828),(15178,829),(15179,829),(15180,829),(15181,830),(15182,830),(15183,830),(15184,831),(15185,831),(15186,831),(15187,832),(15188,832),(15189,832),(15190,833),(15191,833),(15192,833),(15193,834),(15194,834),(15195,834),(15196,835),(15197,835),(15198,835),(15199,836),(15200,836),(15201,836),(15202,837),(15203,837),(15204,837),(15205,838),(15206,838),(15207,838),(15208,839),(15209,839),(15210,839),(15211,840),(15212,840),(15213,840),(15214,841),(15215,841),(15216,841),(15217,842),(15218,842),(15219,842),(15220,843),(15221,843),(15222,843),(15223,844),(15224,844),(15225,844),(15226,845),(15227,845),(15228,845),(15229,846),(15230,846),(15231,846),(15232,847),(15233,847),(15234,847),(15235,848),(15236,848),(15237,848),(15238,849),(15239,849),(15240,849),(15241,850),(15242,850),(15243,850),(15244,851),(15245,851),(15246,851),(15247,852),(15248,852),(15249,852),(15250,853),(15251,853),(15252,853),(15253,854),(15254,854),(15255,854),(15256,855),(15257,855),(15258,855),(15259,856),(15260,856),(15261,856),(15262,857),(15263,857),(15264,857),(15265,858),(15266,858),(15267,858),(15268,859),(15269,859),(15270,859),(15271,860),(15272,860),(15273,860),(15274,861),(15275,861),(15276,861),(15277,862),(15278,862),(15279,862),(15280,863),(15281,863),(15282,863),(15283,864),(15284,864),(15285,864),(15286,865),(15287,865),(15288,865),(15289,866),(15290,866),(15291,866),(15292,867),(15293,867),(15294,867),(15295,868),(15296,868),(15297,868),(15298,869),(15299,869),(15300,869),(15301,870),(15302,870),(15303,870),(15304,871),(15305,871),(15306,871),(15307,872),(15308,872),(15309,872),(15310,873),(15311,873),(15312,874),(15313,874),(15314,875),(15315,875),(15316,876),(15317,876),(15318,877),(15319,877),(15320,878),(15321,878),(15322,879),(15323,879),(15324,880),(15325,880),(15326,781),(15327,781),(15328,781),(15329,781),(15330,782),(15331,782),(15332,782),(15333,782),(15334,783),(15335,783),(15336,783),(15337,783),(15338,784),(15339,784),(15340,784),(15341,784),(15342,785),(15343,785),(15344,785),(15345,785),(15346,786),(15347,786),(15348,786),(15349,786),(15350,787),(15351,787),(15352,787),(15353,787),(15354,788),(15355,788),(15356,788),(15357,788),(15358,789),(15359,789),(15360,789),(15361,789),(15362,790),(15363,790),(15364,790),(15365,790),(15366,791),(15367,791),(15368,791),(15369,791),(15370,792),(15371,792),(15372,792),(15373,792),(15374,793),(15375,793),(15376,793),(15377,793),(15378,794),(15379,794),(15380,794),(15381,794),(15382,795),(15383,795),(15384,795),(15385,795),(15386,796),(15387,796),(15388,796),(15389,796),(15390,797),(15391,797),(15392,797),(15393,797),(15394,798),(15395,798),(15396,798),(15397,798),(15398,799),(15399,799),(15400,799),(15401,799),(15402,800),(15403,800),(15404,800),(15405,800),(15406,801),(15407,801),(15408,801),(15409,801),(15410,802),(15411,802),(15412,802),(15413,802),(15414,803),(15415,803),(15416,803),(15417,803),(15418,804),(15419,804),(15420,804),(15421,804),(15422,805),(15423,805),(15424,805),(15425,805),(15426,806),(15427,806),(15428,806),(15429,806),(15430,807),(15431,807),(15432,807),(15433,807),(15434,808),(15435,808),(15436,808),(15437,808),(15438,809),(15439,809),(15440,809),(15441,809),(15442,810),(15443,810),(15444,810),(15445,810),(15446,811),(15447,811),(15448,811),(15449,811),(15450,812),(15451,812),(15452,812),(15453,812),(15454,813),(15455,813),(15456,813),(15457,813),(15458,814),(15459,814),(15460,814),(15461,814),(15462,815),(15463,815),(15464,815),(15465,815),(15466,816),(15467,816),(15468,816),(15469,816),(15470,817),(15471,817),(15472,817),(15473,817),(15474,818),(15475,818),(15476,818),(15477,818),(15478,819),(15479,819),(15480,819),(15481,819),(15482,820),(15483,820),(15484,820),(15485,820),(15486,821),(15487,821),(15488,821),(15489,821),(15490,822),(15491,822),(15492,822),(15493,822),(15494,823),(15495,823),(15496,823),(15497,823),(15498,824),(15499,824),(15500,824),(15501,824),(15502,825),(15503,825),(15504,825),(15505,825),(15506,826),(15507,826),(15508,826),(15509,826),(15510,827),(15511,827),(15512,827),(15513,827),(15514,828),(15515,828),(15516,828),(15517,828),(15518,829),(15519,829),(15520,829),(15521,829),(15522,830),(15523,830),(15524,830),(15525,830),(15526,831),(15527,831),(15528,831),(15529,831),(15530,832),(15531,832),(15532,832),(15533,832),(15534,833),(15535,833),(15536,833),(15537,833),(15538,834),(15539,834),(15540,834),(15541,834),(15542,835),(15543,835),(15544,835),(15545,835),(15546,836),(15547,836),(15548,836),(15549,836),(15550,837),(15551,837),(15552,837),(15553,837),(15554,838),(15555,838),(15556,838),(15557,838),(15558,839),(15559,839),(15560,839),(15561,839),(15562,840),(15563,840),(15564,840),(15565,840),(15566,841),(15567,841),(15568,841),(15569,841),(15570,842),(15571,842),(15572,842),(15573,842),(15574,843),(15575,843),(15576,843),(15577,843),(15578,844),(15579,844),(15580,844),(15581,844),(15582,845),(15583,845),(15584,845),(15585,845),(15586,846),(15587,846),(15588,846),(15589,846),(15590,847),(15591,847),(15592,847),(15593,847),(15594,848),(15595,848),(15596,848),(15597,848),(15598,849),(15599,849),(15600,849),(15601,849),(15602,850),(15603,850),(15604,850),(15605,850),(15606,851),(15607,851),(15608,851),(15609,851),(15610,852),(15611,852),(15612,852),(15613,852),(15614,853),(15615,853),(15616,853),(15617,853),(15618,854),(15619,854),(15620,854),(15621,854),(15622,855),(15623,855),(15624,855),(15625,855),(15626,856),(15627,856),(15628,856),(15629,856),(15630,857),(15631,857),(15632,857),(15633,857),(15634,858),(15635,858),(15636,858),(15637,858),(15638,859),(15639,859),(15640,859),(15641,859),(15642,860),(15643,860),(15644,860),(15645,860),(15646,861),(15647,861),(15648,861),(15649,861),(15650,862),(15651,862),(15652,862),(15653,862),(15654,863),(15655,863),(15656,863),(15657,863),(15658,864),(15659,864),(15660,864),(15661,864),(15662,865),(15663,865),(15664,865),(15665,865),(15666,866),(15667,866),(15668,866),(15669,866),(15670,867),(15671,867),(15672,867),(15673,867),(15674,868),(15675,868),(15676,868),(15677,868),(15678,869),(15679,869),(15680,869),(15681,869),(15682,870),(15683,870),(15684,870),(15685,870),(15686,871),(15687,871),(15688,871),(15689,871),(15690,872),(15691,872),(15692,872),(15693,872),(15694,873),(15695,873),(15696,873),(15697,873),(15698,874),(15699,874),(15700,874),(15701,874),(15702,875),(15703,875),(15704,875),(15705,875),(15706,876),(15707,876),(15708,876),(15709,876),(15710,877),(15711,877),(15712,877),(15713,877),(15714,878),(15715,878),(15716,878),(15717,878),(15718,879),(15719,879),(15720,879),(15721,879),(15722,880),(15723,880),(15724,880),(15725,880),(15726,881),(15727,882),(15728,883),(15729,884),(15730,885),(15731,886),(15732,887),(15733,888),(15734,889),(15735,890),(15736,891),(15737,892),(15738,893),(15739,894),(15740,895),(15741,896),(15742,897),(15743,898),(15744,899),(15745,900),(15746,901),(15747,902),(15748,903),(15749,904),(15750,905),(15751,906),(15752,907),(15753,908),(15754,909),(15755,910),(15756,911),(15757,912),(15758,913),(15759,914),(15760,915),(15761,916),(15762,917),(15763,918),(15764,919),(15765,920),(15766,921),(15767,922),(15768,923),(15769,924),(15770,925),(15771,926),(15772,927),(15773,928),(15774,929),(15775,930),(15776,931),(15777,932),(15778,933),(15779,934),(15780,935),(15781,936),(15782,937),(15783,938),(15784,939),(15785,940),(15786,941),(15787,942),(15788,943),(15789,944),(15790,945),(15791,946),(15792,947),(15793,948),(15794,949),(15795,950),(15796,951),(15797,952),(15798,953),(15799,954),(15800,955),(15801,956),(15802,957),(15803,958),(15804,959),(15805,960),(15806,961),(15807,962),(15808,963),(15809,964),(15810,965),(15811,966),(15812,967),(15813,968),(15814,969),(15815,970),(15816,971),(15817,972),(15818,973),(15819,974),(15820,975),(15821,976),(15822,977),(15823,978),(15824,979),(15825,980),(15826,881),(15827,881),(15828,882),(15829,882),(15830,883),(15831,883),(15832,884),(15833,884),(15834,885),(15835,885),(15836,886),(15837,886),(15838,887),(15839,887),(15840,888),(15841,888),(15842,889),(15843,889),(15844,890),(15845,890),(15846,891),(15847,891),(15848,892),(15849,892),(15850,893),(15851,893),(15852,894),(15853,894),(15854,895),(15855,895),(15856,896),(15857,896),(15858,897),(15859,897),(15860,898),(15861,898),(15862,899),(15863,899),(15864,900),(15865,900),(15866,901),(15867,901),(15868,902),(15869,902),(15870,903),(15871,903),(15872,904),(15873,904),(15874,905),(15875,905),(15876,906),(15877,906),(15878,907),(15879,907),(15880,908),(15881,908),(15882,909),(15883,909),(15884,910),(15885,910),(15886,911),(15887,911),(15888,912),(15889,912),(15890,913),(15891,913),(15892,914),(15893,914),(15894,915),(15895,915),(15896,916),(15897,916),(15898,917),(15899,917),(15900,918),(15901,918),(15902,919),(15903,919),(15904,920),(15905,920),(15906,921),(15907,921),(15908,922),(15909,922),(15910,923),(15911,923),(15912,924),(15913,924),(15914,925),(15915,925),(15916,926),(15917,926),(15918,927),(15919,927),(15920,928),(15921,928),(15922,929),(15923,929),(15924,930),(15925,930),(15926,931),(15927,931),(15928,932),(15929,932),(15930,933),(15931,933),(15932,934),(15933,934),(15934,935),(15935,935),(15936,936),(15937,936),(15938,937),(15939,937),(15940,938),(15941,938),(15942,939),(15943,939),(15944,940),(15945,940),(15946,941),(15947,941),(15948,942),(15949,942),(15950,943),(15951,943),(15952,944),(15953,944),(15954,945),(15955,945),(15956,946),(15957,946),(15958,947),(15959,947),(15960,948),(15961,948),(15962,949),(15963,949),(15964,950),(15965,950),(15966,951),(15967,951),(15968,952),(15969,952),(15970,953),(15971,953),(15972,954),(15973,954),(15974,955),(15975,955),(15976,956),(15977,956),(15978,957),(15979,957),(15980,958),(15981,958),(15982,959),(15983,959),(15984,960),(15985,960),(15986,961),(15987,961),(15988,962),(15989,962),(15990,963),(15991,963),(15992,964),(15993,964),(15994,965),(15995,965),(15996,966),(15997,966),(15998,967),(15999,967),(16000,968),(16001,968),(16002,969),(16003,969),(16004,970),(16005,970),(16006,971),(16007,971),(16008,972),(16009,972),(16010,973),(16011,973),(16012,974),(16013,974),(16014,975),(16015,975),(16016,976),(16017,976),(16018,977),(16019,977),(16020,978),(16021,978),(16022,979),(16023,979),(16024,980),(16025,980),(16026,881),(16027,881),(16028,881),(16029,881),(16030,881),(16031,881),(16032,882),(16033,882),(16034,882),(16035,882),(16036,882),(16037,882),(16038,883),(16039,883),(16040,883),(16041,883),(16042,883),(16043,883),(16044,884),(16045,884),(16046,884),(16047,884),(16048,884),(16049,884),(16050,885),(16051,885),(16052,885),(16053,885),(16054,885),(16055,885),(16056,886),(16057,886),(16058,886),(16059,886),(16060,886),(16061,886),(16062,887),(16063,887),(16064,887),(16065,887),(16066,887),(16067,887),(16068,888),(16069,888),(16070,888),(16071,888),(16072,888),(16073,888),(16074,889),(16075,889),(16076,889),(16077,889),(16078,889),(16079,889),(16080,890),(16081,890),(16082,890),(16083,890),(16084,890),(16085,890),(16086,891),(16087,891),(16088,891),(16089,891),(16090,891),(16091,891),(16092,892),(16093,892),(16094,892),(16095,892),(16096,892),(16097,892),(16098,893),(16099,893),(16100,893),(16101,893),(16102,893),(16103,893),(16104,894),(16105,894),(16106,894),(16107,894),(16108,894),(16109,894),(16110,895),(16111,895),(16112,895),(16113,895),(16114,895),(16115,895),(16116,896),(16117,896),(16118,896),(16119,896),(16120,896),(16121,896),(16122,897),(16123,897),(16124,897),(16125,897),(16126,897),(16127,897),(16128,898),(16129,898),(16130,898),(16131,898),(16132,898),(16133,898),(16134,899),(16135,899),(16136,899),(16137,899),(16138,899),(16139,899),(16140,900),(16141,900),(16142,900),(16143,900),(16144,900),(16145,900),(16146,901),(16147,901),(16148,901),(16149,901),(16150,901),(16151,901),(16152,902),(16153,902),(16154,902),(16155,902),(16156,902),(16157,902),(16158,903),(16159,903),(16160,903),(16161,903),(16162,903),(16163,903),(16164,904),(16165,904),(16166,904),(16167,904),(16168,904),(16169,904),(16170,905),(16171,905),(16172,905),(16173,905),(16174,905),(16175,905),(16176,906),(16177,906),(16178,906),(16179,906),(16180,906),(16181,906),(16182,907),(16183,907),(16184,907),(16185,907),(16186,907),(16187,907),(16188,908),(16189,908),(16190,908),(16191,908),(16192,908),(16193,908),(16194,909),(16195,909),(16196,909),(16197,909),(16198,909),(16199,909),(16200,910),(16201,910),(16202,910),(16203,910),(16204,910),(16205,910),(16206,911),(16207,911),(16208,911),(16209,911),(16210,911),(16211,911),(16212,912),(16213,912),(16214,912),(16215,912),(16216,912),(16217,912),(16218,913),(16219,913),(16220,913),(16221,913),(16222,913),(16223,913),(16224,914),(16225,914),(16226,914),(16227,914),(16228,914),(16229,914),(16230,915),(16231,915),(16232,915),(16233,915),(16234,915),(16235,915),(16236,916),(16237,916),(16238,916),(16239,916),(16240,916),(16241,916),(16242,917),(16243,917),(16244,917),(16245,917),(16246,917),(16247,917),(16248,918),(16249,918),(16250,918),(16251,918),(16252,918),(16253,918),(16254,919),(16255,919),(16256,919),(16257,919),(16258,919),(16259,919),(16260,920),(16261,920),(16262,920),(16263,920),(16264,920),(16265,920),(16266,921),(16267,921),(16268,921),(16269,921),(16270,921),(16271,921),(16272,922),(16273,922),(16274,922),(16275,922),(16276,922),(16277,922),(16278,923),(16279,923),(16280,923),(16281,923),(16282,923),(16283,923),(16284,924),(16285,924),(16286,924),(16287,924),(16288,924),(16289,924),(16290,925),(16291,925),(16292,925),(16293,925),(16294,925),(16295,925),(16296,926),(16297,926),(16298,926),(16299,926),(16300,926),(16301,926),(16302,927),(16303,927),(16304,927),(16305,927),(16306,927),(16307,927),(16308,928),(16309,928),(16310,928),(16311,928),(16312,928),(16313,928),(16314,929),(16315,929),(16316,929),(16317,929),(16318,929),(16319,929),(16320,930),(16321,930),(16322,930),(16323,930),(16324,930),(16325,930),(16326,931),(16327,931),(16328,931),(16329,931),(16330,931),(16331,931),(16332,932),(16333,932),(16334,932),(16335,932),(16336,932),(16337,932),(16338,933),(16339,933),(16340,933),(16341,933),(16342,933),(16343,933),(16344,934),(16345,934),(16346,934),(16347,934),(16348,934),(16349,934),(16350,935),(16351,935),(16352,935),(16353,935),(16354,935),(16355,935),(16356,936),(16357,936),(16358,936),(16359,936),(16360,936),(16361,936),(16362,937),(16363,937),(16364,937),(16365,937),(16366,937),(16367,937),(16368,938),(16369,938),(16370,938),(16371,938),(16372,938),(16373,938),(16374,939),(16375,939),(16376,939),(16377,939),(16378,939),(16379,939),(16380,940),(16381,940),(16382,940),(16383,940),(16384,940),(16385,940),(16386,941),(16387,941),(16388,941),(16389,941),(16390,941),(16391,941),(16392,942),(16393,942),(16394,942),(16395,942),(16396,942),(16397,942),(16398,943),(16399,943),(16400,943),(16401,943),(16402,943),(16403,943),(16404,944),(16405,944),(16406,944),(16407,944),(16408,944),(16409,944),(16410,945),(16411,945),(16412,945),(16413,945),(16414,945),(16415,945),(16416,946),(16417,946),(16418,946),(16419,946),(16420,946),(16421,946),(16422,947),(16423,947),(16424,947),(16425,947),(16426,947),(16427,947),(16428,948),(16429,948),(16430,948),(16431,948),(16432,948),(16433,948),(16434,949),(16435,949),(16436,949),(16437,949),(16438,949),(16439,949),(16440,950),(16441,950),(16442,950),(16443,950),(16444,950),(16445,950),(16446,951),(16447,951),(16448,951),(16449,951),(16450,951),(16451,951),(16452,952),(16453,952),(16454,952),(16455,952),(16456,952),(16457,952),(16458,953),(16459,953),(16460,953),(16461,953),(16462,953),(16463,953),(16464,954),(16465,954),(16466,954),(16467,954),(16468,954),(16469,954),(16470,955),(16471,955),(16472,955),(16473,955),(16474,955),(16475,955),(16476,956),(16477,956),(16478,956),(16479,956),(16480,956),(16481,956),(16482,957),(16483,957),(16484,957),(16485,957),(16486,957),(16487,957),(16488,958),(16489,958),(16490,958),(16491,958),(16492,958),(16493,958),(16494,959),(16495,959),(16496,959),(16497,959),(16498,959),(16499,959),(16500,960),(16501,960),(16502,960),(16503,960),(16504,960),(16505,960),(16506,961),(16507,961),(16508,961),(16509,961),(16510,961),(16511,961),(16512,962),(16513,962),(16514,962),(16515,962),(16516,962),(16517,962),(16518,963),(16519,963),(16520,963),(16521,963),(16522,963),(16523,963),(16524,964),(16525,964),(16526,964),(16527,964),(16528,964),(16529,964),(16530,965),(16531,965),(16532,965),(16533,965),(16534,965),(16535,965),(16536,966),(16537,966),(16538,966),(16539,966),(16540,966),(16541,966),(16542,967),(16543,967),(16544,967),(16545,967),(16546,967),(16547,967),(16548,968),(16549,968),(16550,968),(16551,968),(16552,968),(16553,968),(16554,969),(16555,969),(16556,969),(16557,969),(16558,969),(16559,969),(16560,970),(16561,970),(16562,970),(16563,970),(16564,970),(16565,970),(16566,971),(16567,971),(16568,971),(16569,971),(16570,971),(16571,971),(16572,972),(16573,972),(16574,972),(16575,972),(16576,972),(16577,972),(16578,973),(16579,973),(16580,973),(16581,973),(16582,973),(16583,973),(16584,974),(16585,974),(16586,974),(16587,974),(16588,974),(16589,974),(16590,975),(16591,975),(16592,975),(16593,975),(16594,975),(16595,975),(16596,976),(16597,976),(16598,976),(16599,976),(16600,976),(16601,976),(16602,977),(16603,977),(16604,977),(16605,977),(16606,977),(16607,977),(16608,978),(16609,978),(16610,978),(16611,978),(16612,978),(16613,978),(16614,979),(16615,979),(16616,979),(16617,979),(16618,979),(16619,979),(16620,980),(16621,980),(16622,980),(16623,980),(16624,980),(16625,980),(16626,881),(16627,881),(16628,881),(16629,882),(16630,882),(16631,883),(16632,883),(16633,884),(16634,884),(16635,885),(16636,885),(16637,886),(16638,886),(16639,887),(16640,887),(16641,888),(16642,888),(16643,889),(16644,889),(16645,890),(16646,890),(16647,891),(16648,891),(16649,892),(16650,892),(16651,893),(16652,893),(16653,894),(16654,894),(16655,895),(16656,895),(16657,896),(16658,896),(16659,897),(16660,897),(16661,898),(16662,898),(16663,899),(16664,899),(16665,900),(16666,900),(16667,901),(16668,901),(16669,902),(16670,902),(16671,903),(16672,903),(16673,904),(16674,904),(16675,905),(16676,905),(16677,906),(16678,906),(16679,906),(16680,907),(16681,907),(16682,907),(16683,908),(16684,908),(16685,909),(16686,909),(16687,910),(16688,910),(16689,911),(16690,911),(16691,912),(16692,912),(16693,913),(16694,913),(16695,914),(16696,914),(16697,915),(16698,915),(16699,916),(16700,916),(16701,917),(16702,917),(16703,918),(16704,918),(16705,919),(16706,919),(16707,920),(16708,920),(16709,921),(16710,921),(16711,922),(16712,922),(16713,923),(16714,923),(16715,924),(16716,924),(16717,925),(16718,925),(16719,926),(16720,926),(16721,927),(16722,927),(16723,928),(16724,928),(16725,929),(16726,929),(16727,930),(16728,930),(16729,931),(16730,931),(16731,932),(16732,932),(16733,933),(16734,933),(16735,934),(16736,934),(16737,935),(16738,935),(16739,936),(16740,936),(16741,937),(16742,937),(16743,938),(16744,938),(16745,939),(16746,939),(16747,940),(16748,940),(16749,941),(16750,941),(16751,942),(16752,942),(16753,943),(16754,943),(16755,944),(16756,944),(16757,945),(16758,945),(16759,946),(16760,946),(16761,947),(16762,947),(16763,948),(16764,948),(16765,949),(16766,949),(16767,950),(16768,950),(16769,951),(16770,951),(16771,952),(16772,952),(16773,953),(16774,953),(16775,954),(16776,954),(16777,955),(16778,955),(16779,956),(16780,956),(16781,957),(16782,957),(16783,958),(16784,958),(16785,959),(16786,959),(16787,960),(16788,960),(16789,961),(16790,961),(16791,962),(16792,962),(16793,963),(16794,963),(16795,964),(16796,964),(16797,965),(16798,965),(16799,966),(16800,966),(16801,967),(16802,967),(16803,968),(16804,968),(16805,969),(16806,969),(16807,970),(16808,970),(16809,971),(16810,971),(16811,972),(16812,972),(16813,973),(16814,973),(16815,974),(16816,974),(16817,975),(16818,975),(16819,976),(16820,976),(16821,977),(16822,977),(16823,978),(16824,978),(16825,979),(16826,979),(16827,980),(16828,980),(16829,881),(16830,881),(16831,882),(16832,882),(16833,882),(16834,883),(16835,884),(16836,884),(16837,884),(16838,885),(16839,885),(16840,885),(16841,886),(16842,886),(16843,886),(16844,887),(16845,887),(16846,887),(16847,888),(16848,888),(16849,888),(16850,889),(16851,889),(16852,889),(16853,890),(16854,890),(16855,890),(16856,891),(16857,891),(16858,891),(16859,892),(16860,892),(16861,892),(16862,893),(16863,893),(16864,893),(16865,894),(16866,894),(16867,894),(16868,895),(16869,895),(16870,895),(16871,896),(16872,896),(16873,896),(16874,897),(16875,897),(16876,897),(16877,898),(16878,898),(16879,898),(16880,899),(16881,899),(16882,899),(16883,900),(16884,900),(16885,900),(16886,901),(16887,901),(16888,901),(16889,902),(16890,902),(16891,902),(16892,903),(16893,903),(16894,903),(16895,904),(16896,904),(16897,904),(16898,905),(16899,905),(16900,905),(16901,906),(16902,906),(16903,906),(16904,907),(16905,907),(16906,907),(16907,908),(16908,908),(16909,908),(16910,909),(16911,909),(16912,909),(16913,910),(16914,910),(16915,910),(16916,911),(16917,911),(16918,911),(16919,912),(16920,912),(16921,912),(16922,913),(16923,913),(16924,913),(16925,914),(16926,914),(16927,914),(16928,915),(16929,915),(16930,915),(16931,916),(16932,916),(16933,916),(16934,917),(16935,917),(16936,917),(16937,918),(16938,918),(16939,918),(16940,919),(16941,919),(16942,919),(16943,920),(16944,920),(16945,920),(16946,921),(16947,921),(16948,921),(16949,922),(16950,922),(16951,922),(16952,923),(16953,923),(16954,923),(16955,924),(16956,924),(16957,924),(16958,925),(16959,925),(16960,925),(16961,926),(16962,926),(16963,926),(16964,927),(16965,927),(16966,927),(16967,928),(16968,928),(16969,928),(16970,929),(16971,929),(16972,929),(16973,930),(16974,930),(16975,930),(16976,931),(16977,931),(16978,931),(16979,932),(16980,932),(16981,932),(16982,933),(16983,933),(16984,933),(16985,934),(16986,934),(16987,934),(16988,935),(16989,935),(16990,935),(16991,936),(16992,936),(16993,936),(16994,937),(16995,937),(16996,937),(16997,938),(16998,938),(16999,938),(17000,939),(17001,939),(17002,939),(17003,940),(17004,940),(17005,940),(17006,941),(17007,941),(17008,941),(17009,942),(17010,942),(17011,942),(17012,943),(17013,943),(17014,943),(17015,944),(17016,944),(17017,944),(17018,945),(17019,945),(17020,945),(17021,946),(17022,946),(17023,946),(17024,947),(17025,947),(17026,947),(17027,948),(17028,948),(17029,948),(17030,949),(17031,949),(17032,949),(17033,950),(17034,950),(17035,950),(17036,951),(17037,951),(17038,951),(17039,952),(17040,952),(17041,952),(17042,953),(17043,953),(17044,953),(17045,954),(17046,954),(17047,954),(17048,955),(17049,955),(17050,955),(17051,956),(17052,956),(17053,956),(17054,957),(17055,957),(17056,957),(17057,958),(17058,958),(17059,958),(17060,959),(17061,959),(17062,959),(17063,960),(17064,960),(17065,960),(17066,961),(17067,961),(17068,961),(17069,962),(17070,962),(17071,962),(17072,963),(17073,963),(17074,963),(17075,964),(17076,964),(17077,964),(17078,965),(17079,965),(17080,965),(17081,966),(17082,966),(17083,966),(17084,967),(17085,967),(17086,967),(17087,968),(17088,968),(17089,968),(17090,969),(17091,969),(17092,969),(17093,970),(17094,970),(17095,970),(17096,971),(17097,971),(17098,971),(17099,972),(17100,972),(17101,972),(17102,973),(17103,973),(17104,973),(17105,974),(17106,974),(17107,974),(17108,975),(17109,975),(17110,975),(17111,976),(17112,976),(17113,976),(17114,977),(17115,977),(17116,977),(17117,978),(17118,978),(17119,978),(17120,979),(17121,979),(17122,979),(17123,980),(17124,980),(17125,980),(17126,881),(17127,881),(17128,881),(17129,881),(17130,882),(17131,882),(17132,882),(17133,882),(17134,883),(17135,883),(17136,883),(17137,883),(17138,884),(17139,884),(17140,884),(17141,884),(17142,885),(17143,885),(17144,885),(17145,885),(17146,886),(17147,886),(17148,886),(17149,886),(17150,887),(17151,887),(17152,887),(17153,887),(17154,888),(17155,888),(17156,888),(17157,888),(17158,889),(17159,889),(17160,889),(17161,889),(17162,890),(17163,890),(17164,890),(17165,890),(17166,891),(17167,891),(17168,891),(17169,891),(17170,892),(17171,892),(17172,892),(17173,892),(17174,893),(17175,893),(17176,893),(17177,893),(17178,894),(17179,894),(17180,894),(17181,894),(17182,895),(17183,895),(17184,895),(17185,895),(17186,896),(17187,896),(17188,896),(17189,896),(17190,897),(17191,897),(17192,897),(17193,897),(17194,898),(17195,898),(17196,898),(17197,898),(17198,899),(17199,899),(17200,899),(17201,899),(17202,900),(17203,900),(17204,900),(17205,900),(17206,901),(17207,901),(17208,901),(17209,901),(17210,902),(17211,902),(17212,902),(17213,902),(17214,903),(17215,903),(17216,903),(17217,903),(17218,904),(17219,904),(17220,904),(17221,904),(17222,905),(17223,905),(17224,905),(17225,905),(17226,906),(17227,906),(17228,906),(17229,906),(17230,907),(17231,907),(17232,907),(17233,907),(17234,908),(17235,908),(17236,908),(17237,908),(17238,909),(17239,909),(17240,909),(17241,909),(17242,910),(17243,910),(17244,910),(17245,910),(17246,911),(17247,911),(17248,911),(17249,911),(17250,912),(17251,912),(17252,912),(17253,912),(17254,913),(17255,913),(17256,913),(17257,913),(17258,914),(17259,914),(17260,914),(17261,914),(17262,915),(17263,915),(17264,915),(17265,915),(17266,916),(17267,916),(17268,916),(17269,916),(17270,917),(17271,917),(17272,917),(17273,917),(17274,918),(17275,918),(17276,918),(17277,918),(17278,919),(17279,919),(17280,919),(17281,919),(17282,920),(17283,920),(17284,920),(17285,920),(17286,921),(17287,921),(17288,921),(17289,921),(17290,922),(17291,922),(17292,922),(17293,922),(17294,923),(17295,923),(17296,923),(17297,923),(17298,924),(17299,924),(17300,924),(17301,924),(17302,925),(17303,925),(17304,925),(17305,925),(17306,926),(17307,926),(17308,926),(17309,926),(17310,927),(17311,927),(17312,927),(17313,927),(17314,928),(17315,928),(17316,928),(17317,928),(17318,929),(17319,929),(17320,929),(17321,929),(17322,930),(17323,930),(17324,930),(17325,930),(17326,931),(17327,931),(17328,931),(17329,931),(17330,932),(17331,932),(17332,932),(17333,932),(17334,933),(17335,933),(17336,933),(17337,933),(17338,934),(17339,934),(17340,934),(17341,934),(17342,935),(17343,935),(17344,935),(17345,935),(17346,936),(17347,936),(17348,936),(17349,936),(17350,937),(17351,937),(17352,937),(17353,937),(17354,938),(17355,938),(17356,938),(17357,938),(17358,939),(17359,939),(17360,939),(17361,939),(17362,940),(17363,940),(17364,940),(17365,940),(17366,941),(17367,941),(17368,941),(17369,941),(17370,942),(17371,942),(17372,942),(17373,942),(17374,943),(17375,943),(17376,943),(17377,943),(17378,944),(17379,944),(17380,944),(17381,944),(17382,945),(17383,945),(17384,945),(17385,945),(17386,946),(17387,946),(17388,946),(17389,946),(17390,947),(17391,947),(17392,947),(17393,947),(17394,948),(17395,948),(17396,948),(17397,948),(17398,949),(17399,949),(17400,949),(17401,949),(17402,950),(17403,950),(17404,950),(17405,950),(17406,951),(17407,951),(17408,951),(17409,951),(17410,952),(17411,952),(17412,952),(17413,952),(17414,953),(17415,953),(17416,953),(17417,953),(17418,954),(17419,954),(17420,954),(17421,954),(17422,955),(17423,955),(17424,955),(17425,955),(17426,956),(17427,956),(17428,956),(17429,956),(17430,957),(17431,957),(17432,957),(17433,957),(17434,958),(17435,958),(17436,958),(17437,958),(17438,959),(17439,959),(17440,959),(17441,959),(17442,960),(17443,960),(17444,960),(17445,960),(17446,961),(17447,961),(17448,961),(17449,961),(17450,962),(17451,962),(17452,962),(17453,962),(17454,963),(17455,963),(17456,963),(17457,963),(17458,964),(17459,964),(17460,964),(17461,964),(17462,965),(17463,965),(17464,965),(17465,965),(17466,966),(17467,966),(17468,966),(17469,966),(17470,967),(17471,967),(17472,967),(17473,967),(17474,968),(17475,968),(17476,968),(17477,968),(17478,969),(17479,969),(17480,969),(17481,969),(17482,970),(17483,970),(17484,970),(17485,970),(17486,971),(17487,971),(17488,971),(17489,971),(17490,972),(17491,972),(17492,972),(17493,972),(17494,973),(17495,973),(17496,973),(17497,973),(17498,974),(17499,974),(17500,974),(17501,974),(17502,975),(17503,975),(17504,975),(17505,975),(17506,976),(17507,976),(17508,976),(17509,976),(17510,977),(17511,977),(17512,977),(17513,977),(17514,978),(17515,978),(17516,978),(17517,978),(17518,979),(17519,979),(17520,979),(17521,979),(17522,980),(17523,980),(17524,980),(17525,980),(17526,981),(17527,982),(17528,983),(17529,984),(17530,985),(17531,986),(17532,987),(17533,988),(17534,989),(17535,990),(17536,991),(17537,992),(17538,993),(17539,994),(17540,995),(17541,996),(17542,997),(17543,998),(17544,999),(17545,1000),(17546,1001),(17547,1002),(17548,1003),(17549,1004),(17550,1005),(17551,1006),(17552,1007),(17553,1008),(17554,1009),(17555,1010),(17556,1011),(17557,1012),(17558,1013),(17559,1014),(17560,1015),(17561,1016),(17562,1017),(17563,1018),(17564,1019),(17565,1020),(17566,1021),(17567,1022),(17568,1023),(17569,1024),(17570,1025),(17571,1026),(17572,1027),(17573,1028),(17574,1029),(17575,1030),(17576,1031),(17577,1032),(17578,1033),(17579,1034),(17580,1035),(17581,1036),(17582,1037),(17583,1038),(17584,1039),(17585,1040),(17586,1041),(17587,1042),(17588,1043),(17589,1044),(17590,1045),(17591,1046),(17592,1047),(17593,1048),(17594,1049),(17595,1050),(17596,1051),(17597,1052),(17598,1053),(17599,1054),(17600,1055),(17601,1056),(17602,1057),(17603,1058),(17604,1059),(17605,1060),(17606,1061),(17607,1062),(17608,1063),(17609,1064),(17610,1065),(17611,1066),(17612,1067),(17613,1068),(17614,1069),(17615,1070),(17616,1071),(17617,1072),(17618,1073),(17619,1074),(17620,1075),(17621,1076),(17622,1077),(17623,1078),(17624,1079),(17625,1080),(17626,981),(17627,981),(17628,982),(17629,982),(17630,983),(17631,983),(17632,984),(17633,984),(17634,985),(17635,985),(17636,986),(17637,986),(17638,987),(17639,987),(17640,988),(17641,988),(17642,989),(17643,989),(17644,990),(17645,990),(17646,991),(17647,991),(17648,992),(17649,992),(17650,993),(17651,993),(17652,994),(17653,994),(17654,995),(17655,995),(17656,996),(17657,996),(17658,997),(17659,997),(17660,998),(17661,998),(17662,999),(17663,999),(17664,1000),(17665,1000),(17666,1001),(17667,1001),(17668,1002),(17669,1002),(17670,1003),(17671,1003),(17672,1004),(17673,1004),(17674,1005),(17675,1005),(17676,1006),(17677,1006),(17678,1007),(17679,1007),(17680,1008),(17681,1008),(17682,1009),(17683,1009),(17684,1010),(17685,1010),(17686,1011),(17687,1011),(17688,1012),(17689,1012),(17690,1013),(17691,1013),(17692,1014),(17693,1014),(17694,1015),(17695,1015),(17696,1016),(17697,1016),(17698,1017),(17699,1017),(17700,1018),(17701,1018),(17702,1019),(17703,1019),(17704,1020),(17705,1020),(17706,1021),(17707,1021),(17708,1022),(17709,1022),(17710,1023),(17711,1023),(17712,1024),(17713,1024),(17714,1025),(17715,1025),(17716,1026),(17717,1026),(17718,1027),(17719,1027),(17720,1028),(17721,1028),(17722,1029),(17723,1029),(17724,1030),(17725,1030),(17726,1031),(17727,1031),(17728,1032),(17729,1032),(17730,1033),(17731,1033),(17732,1034),(17733,1034),(17734,1035),(17735,1035),(17736,1036),(17737,1036),(17738,1037),(17739,1037),(17740,1038),(17741,1038),(17742,1039),(17743,1039),(17744,1040),(17745,1040),(17746,1041),(17747,1041),(17748,1042),(17749,1042),(17750,1043),(17751,1043),(17752,1044),(17753,1044),(17754,1045),(17755,1045),(17756,1046),(17757,1046),(17758,1047),(17759,1047),(17760,1048),(17761,1048),(17762,1049),(17763,1049),(17764,1050),(17765,1050),(17766,1051),(17767,1051),(17768,1052),(17769,1052),(17770,1053),(17771,1053),(17772,1054),(17773,1054),(17774,1055),(17775,1055),(17776,1056),(17777,1056),(17778,1057),(17779,1057),(17780,1058),(17781,1058),(17782,1059),(17783,1059),(17784,1060),(17785,1060),(17786,1061),(17787,1061),(17788,1062),(17789,1062),(17790,1063),(17791,1063),(17792,1064),(17793,1064),(17794,1065),(17795,1065),(17796,1066),(17797,1066),(17798,1067),(17799,1067),(17800,1068),(17801,1068),(17802,1069),(17803,1069),(17804,1070),(17805,1070),(17806,1071),(17807,1071),(17808,1072),(17809,1072),(17810,1073),(17811,1073),(17812,1074),(17813,1074),(17814,1075),(17815,1075),(17816,1076),(17817,1076),(17818,1077),(17819,1077),(17820,1078),(17821,1078),(17822,1079),(17823,1079),(17824,1080),(17825,1080),(17826,981),(17827,981),(17828,981),(17829,981),(17830,981),(17831,981),(17832,982),(17833,982),(17834,982),(17835,982),(17836,982),(17837,982),(17838,983),(17839,983),(17840,983),(17841,983),(17842,983),(17843,983),(17844,984),(17845,984),(17846,984),(17847,984),(17848,984),(17849,984),(17850,985),(17851,985),(17852,985),(17853,985),(17854,985),(17855,985),(17856,986),(17857,986),(17858,986),(17859,986),(17860,986),(17861,986),(17862,987),(17863,987),(17864,987),(17865,987),(17866,987),(17867,987),(17868,988),(17869,988),(17870,988),(17871,988),(17872,988),(17873,988),(17874,989),(17875,989),(17876,989),(17877,989),(17878,989),(17879,989),(17880,990),(17881,990),(17882,990),(17883,990),(17884,990),(17885,990),(17886,991),(17887,991),(17888,991),(17889,991),(17890,991),(17891,991),(17892,992),(17893,992),(17894,992),(17895,992),(17896,992),(17897,992),(17898,993),(17899,993),(17900,993),(17901,993),(17902,993),(17903,993),(17904,994),(17905,994),(17906,994),(17907,994),(17908,994),(17909,994),(17910,995),(17911,995),(17912,995),(17913,995),(17914,995),(17915,995),(17916,996),(17917,996),(17918,996),(17919,996),(17920,996),(17921,996),(17922,997),(17923,997),(17924,997),(17925,997),(17926,997),(17927,997),(17928,998),(17929,998),(17930,998),(17931,998),(17932,998),(17933,998),(17934,999),(17935,999),(17936,999),(17937,999),(17938,999),(17939,999),(17940,1000),(17941,1000),(17942,1000),(17943,1000),(17944,1000),(17945,1000),(17946,1001),(17947,1001),(17948,1001),(17949,1001),(17950,1001),(17951,1001),(17952,1002),(17953,1002),(17954,1002),(17955,1002),(17956,1002),(17957,1002),(17958,1003),(17959,1003),(17960,1003),(17961,1003),(17962,1004),(17963,1004),(17964,1004),(17965,1004),(17966,1004),(17967,1004),(17968,1005),(17969,1005),(17970,1005),(17971,1005),(17972,1006),(17973,1006),(17974,1006),(17975,1006),(17976,1006),(17977,1006),(17978,1007),(17979,1007),(17980,1007),(17981,1007),(17982,1007),(17983,1007),(17984,1008),(17985,1008),(17986,1008),(17987,1008),(17988,1008),(17989,1008),(17990,1009),(17991,1009),(17992,1009),(17993,1009),(17994,1009),(17995,1009),(17996,1010),(17997,1010),(17998,1010),(17999,1010),(18000,1010),(18001,1010),(18002,1011),(18003,1011),(18004,1011),(18005,1011),(18006,1011),(18007,1011),(18008,1012),(18009,1012),(18010,1012),(18011,1012),(18012,1012),(18013,1012),(18014,1013),(18015,1013),(18016,1013),(18017,1013),(18018,1013),(18019,1013),(18020,1014),(18021,1014),(18022,1014),(18023,1014),(18024,1014),(18025,1014),(18026,1015),(18027,1015),(18028,1015),(18029,1015),(18030,1015),(18031,1015),(18032,1016),(18033,1016),(18034,1016),(18035,1016),(18036,1016),(18037,1016),(18038,1017),(18039,1017),(18040,1017),(18041,1017),(18042,1017),(18043,1017),(18044,1018),(18045,1018),(18046,1018),(18047,1018),(18048,1018),(18049,1018),(18050,1019),(18051,1019),(18052,1019),(18053,1019),(18054,1019),(18055,1019),(18056,1020),(18057,1020),(18058,1020),(18059,1020),(18060,1020),(18061,1020),(18062,1021),(18063,1021),(18064,1021),(18065,1021),(18066,1021),(18067,1021),(18068,1022),(18069,1022),(18070,1022),(18071,1022),(18072,1022),(18073,1022),(18074,1023),(18075,1023),(18076,1023),(18077,1023),(18078,1023),(18079,1023),(18080,1024),(18081,1024),(18082,1024),(18083,1024),(18084,1024),(18085,1024),(18086,1025),(18087,1025),(18088,1025),(18089,1025),(18090,1025),(18091,1025),(18092,1026),(18093,1026),(18094,1026),(18095,1026),(18096,1026),(18097,1026),(18098,1027),(18099,1027),(18100,1027),(18101,1027),(18102,1027),(18103,1027),(18104,1028),(18105,1028),(18106,1028),(18107,1028),(18108,1028),(18109,1028),(18110,1029),(18111,1029),(18112,1029),(18113,1029),(18114,1029),(18115,1029),(18116,1030),(18117,1030),(18118,1030),(18119,1030),(18120,1030),(18121,1030),(18122,1031),(18123,1031),(18124,1031),(18125,1031),(18126,1031),(18127,1031),(18128,1032),(18129,1032),(18130,1032),(18131,1032),(18132,1032),(18133,1032),(18134,1033),(18135,1033),(18136,1033),(18137,1033),(18138,1033),(18139,1033),(18140,1034),(18141,1034),(18142,1034),(18143,1034),(18144,1034),(18145,1034),(18146,1035),(18147,1035),(18148,1035),(18149,1035),(18150,1036),(18151,1036),(18152,1036),(18153,1036),(18154,1036),(18155,1036),(18156,1037),(18157,1037),(18158,1037),(18159,1037),(18160,1037),(18161,1037),(18162,1038),(18163,1038),(18164,1038),(18165,1038),(18166,1038),(18167,1038),(18168,1039),(18169,1039),(18170,1039),(18171,1039),(18172,1039),(18173,1039),(18174,1040),(18175,1040),(18176,1040),(18177,1040),(18178,1040),(18179,1040),(18180,1041),(18181,1041),(18182,1041),(18183,1041),(18184,1041),(18185,1041),(18186,1042),(18187,1042),(18188,1042),(18189,1042),(18190,1042),(18191,1042),(18192,1043),(18193,1043),(18194,1043),(18195,1043),(18196,1043),(18197,1043),(18198,1044),(18199,1044),(18200,1044),(18201,1044),(18202,1044),(18203,1044),(18204,1045),(18205,1045),(18206,1045),(18207,1045),(18208,1045),(18209,1045),(18210,1046),(18211,1046),(18212,1046),(18213,1046),(18214,1046),(18215,1046),(18216,1047),(18217,1047),(18218,1047),(18219,1047),(18220,1047),(18221,1047),(18222,1048),(18223,1048),(18224,1048),(18225,1048),(18226,1048),(18227,1048),(18228,1049),(18229,1049),(18230,1049),(18231,1049),(18232,1049),(18233,1049),(18234,1050),(18235,1050),(18236,1050),(18237,1050),(18238,1050),(18239,1050),(18240,1051),(18241,1051),(18242,1051),(18243,1051),(18244,1051),(18245,1051),(18246,1052),(18247,1052),(18248,1052),(18249,1052),(18250,1052),(18251,1052),(18252,1053),(18253,1053),(18254,1053),(18255,1053),(18256,1053),(18257,1053),(18258,1054),(18259,1054),(18260,1054),(18261,1054),(18262,1054),(18263,1054),(18264,1055),(18265,1055),(18266,1055),(18267,1055),(18268,1055),(18269,1055),(18270,1056),(18271,1056),(18272,1056),(18273,1056),(18274,1056),(18275,1056),(18276,1057),(18277,1057),(18278,1057),(18279,1057),(18280,1057),(18281,1057),(18282,1058),(18283,1058),(18284,1058),(18285,1058),(18286,1058),(18287,1058),(18288,1059),(18289,1059),(18290,1059),(18291,1059),(18292,1059),(18293,1059),(18294,1060),(18295,1060),(18296,1060),(18297,1060),(18298,1060),(18299,1060),(18300,1061),(18301,1061),(18302,1061),(18303,1061),(18304,1061),(18305,1061),(18306,1062),(18307,1062),(18308,1062),(18309,1062),(18310,1062),(18311,1062),(18312,1063),(18313,1063),(18314,1063),(18315,1063),(18316,1063),(18317,1063),(18318,1064),(18319,1064),(18320,1064),(18321,1064),(18322,1064),(18323,1064),(18324,1065),(18325,1065),(18326,1065),(18327,1065),(18328,1065),(18329,1065),(18330,1066),(18331,1066),(18332,1066),(18333,1066),(18334,1066),(18335,1066),(18336,1067),(18337,1067),(18338,1067),(18339,1067),(18340,1067),(18341,1067),(18342,1068),(18343,1068),(18344,1068),(18345,1068),(18346,1068),(18347,1068),(18348,1069),(18349,1069),(18350,1069),(18351,1069),(18352,1069),(18353,1069),(18354,1070),(18355,1070),(18356,1070),(18357,1070),(18358,1070),(18359,1070),(18360,1071),(18361,1071),(18362,1071),(18363,1071),(18364,1071),(18365,1071),(18366,1072),(18367,1072),(18368,1072),(18369,1072),(18370,1072),(18371,1072),(18372,1073),(18373,1073),(18374,1073),(18375,1073),(18376,1073),(18377,1073),(18378,1074),(18379,1074),(18380,1074),(18381,1074),(18382,1074),(18383,1074),(18384,1075),(18385,1075),(18386,1075),(18387,1075),(18388,1075),(18389,1075),(18390,1076),(18391,1076),(18392,1076),(18393,1076),(18394,1076),(18395,1076),(18396,1077),(18397,1077),(18398,1077),(18399,1077),(18400,1077),(18401,1077),(18402,1078),(18403,1078),(18404,1078),(18405,1078),(18406,1078),(18407,1078),(18408,1079),(18409,1079),(18410,1079),(18411,1079),(18412,1079),(18413,1079),(18414,1080),(18415,1080),(18416,1080),(18417,1080),(18418,1080),(18419,1080),(18420,981),(18421,981),(18422,982),(18423,982),(18424,983),(18425,983),(18426,984),(18427,984),(18428,985),(18429,985),(18430,986),(18431,986),(18432,987),(18433,987),(18434,988),(18435,988),(18436,989),(18437,989),(18438,990),(18439,990),(18440,991),(18441,991),(18442,992),(18443,992),(18444,993),(18445,993),(18446,994),(18447,994),(18448,995),(18449,995),(18450,996),(18451,996),(18452,997),(18453,997),(18454,998),(18455,998),(18456,999),(18457,999),(18458,1000),(18459,1000),(18460,1001),(18461,1001),(18462,1002),(18463,1002),(18464,1003),(18465,1004),(18466,1004),(18467,1004),(18468,1005),(18469,1006),(18470,1006),(18471,1007),(18472,1007),(18473,1008),(18474,1008),(18475,1009),(18476,1009),(18477,1010),(18478,1010),(18479,1011),(18480,1011),(18481,1012),(18482,1012),(18483,1012),(18484,1013),(18485,1013),(18486,1014),(18487,1014),(18488,1015),(18489,1015),(18490,1016),(18491,1016),(18492,1017),(18493,1017),(18494,1018),(18495,1018),(18496,1019),(18497,1019),(18498,1019),(18499,1020),(18500,1020),(18501,1021),(18502,1021),(18503,1022),(18504,1022),(18505,1023),(18506,1023),(18507,1024),(18508,1024),(18509,1025),(18510,1025),(18511,1026),(18512,1026),(18513,1027),(18514,1027),(18515,1028),(18516,1028),(18517,1029),(18518,1029),(18519,1030),(18520,1030),(18521,1031),(18522,1031),(18523,1032),(18524,1032),(18525,1033),(18526,1033),(18527,1034),(18528,1034),(18529,1035),(18530,1036),(18531,1036),(18532,1037),(18533,1037),(18534,1038),(18535,1038),(18536,1039),(18537,1039),(18538,1039),(18539,1040),(18540,1040),(18541,1041),(18542,1041),(18543,1042),(18544,1042),(18545,1043),(18546,1043),(18547,1044),(18548,1044),(18549,1045),(18550,1045),(18551,1046),(18552,1046),(18553,1047),(18554,1047),(18555,1048),(18556,1048),(18557,1049),(18558,1049),(18559,1049),(18560,1050),(18561,1050),(18562,1050),(18563,1051),(18564,1051),(18565,1051),(18566,1052),(18567,1052),(18568,1052),(18569,1053),(18570,1053),(18571,1053),(18572,1054),(18573,1054),(18574,1054),(18575,1055),(18576,1055),(18577,1055),(18578,1056),(18579,1056),(18580,1056),(18581,1057),(18582,1057),(18583,1057),(18584,1058),(18585,1058),(18586,1058),(18587,1059),(18588,1059),(18589,1059),(18590,1060),(18591,1060),(18592,1060),(18593,1061),(18594,1061),(18595,1061),(18596,1062),(18597,1062),(18598,1062),(18599,1063),(18600,1063),(18601,1063),(18602,1064),(18603,1064),(18604,1064),(18605,1065),(18606,1065),(18607,1065),(18608,1066),(18609,1066),(18610,1066),(18611,1067),(18612,1067),(18613,1067),(18614,1068),(18615,1068),(18616,1068),(18617,1069),(18618,1069),(18619,1069),(18620,1070),(18621,1070),(18622,1070),(18623,1071),(18624,1071),(18625,1071),(18626,1072),(18627,1072),(18628,1072),(18629,1073),(18630,1073),(18631,1073),(18632,1074),(18633,1074),(18634,1074),(18635,1075),(18636,1075),(18637,1075),(18638,1076),(18639,1076),(18640,1076),(18641,1077),(18642,1077),(18643,1077),(18644,1078),(18645,1078),(18646,1078),(18647,1079),(18648,1079),(18649,1079),(18650,1080),(18651,1080),(18652,1080),(18653,981),(18654,981),(18655,981),(18656,982),(18657,982),(18658,982),(18659,983),(18660,983),(18661,983),(18662,984),(18663,984),(18664,984),(18665,985),(18666,985),(18667,985),(18668,986),(18669,986),(18670,986),(18671,987),(18672,987),(18673,987),(18674,988),(18675,988),(18676,988),(18677,989),(18678,989),(18679,989),(18680,990),(18681,990),(18682,990),(18683,991),(18684,991),(18685,991),(18686,992),(18687,992),(18688,992),(18689,993),(18690,993),(18691,993),(18692,994),(18693,994),(18694,994),(18695,995),(18696,995),(18697,995),(18698,996),(18699,996),(18700,996),(18701,997),(18702,997),(18703,997),(18704,998),(18705,998),(18706,998),(18707,999),(18708,999),(18709,999),(18710,1000),(18711,1000),(18712,1000),(18713,1001),(18714,1001),(18715,1001),(18716,1002),(18717,1002),(18718,1002),(18719,1003),(18720,1003),(18721,1003),(18722,1004),(18723,1004),(18724,1004),(18725,1005),(18726,1005),(18727,1005),(18728,1006),(18729,1006),(18730,1006),(18731,1007),(18732,1007),(18733,1007),(18734,1008),(18735,1008),(18736,1008),(18737,1009),(18738,1009),(18739,1009),(18740,1010),(18741,1010),(18742,1010),(18743,1011),(18744,1011),(18745,1011),(18746,1012),(18747,1012),(18748,1012),(18749,1013),(18750,1013),(18751,1013),(18752,1014),(18753,1014),(18754,1014),(18755,1015),(18756,1015),(18757,1015),(18758,1016),(18759,1016),(18760,1016),(18761,1017),(18762,1017),(18763,1017),(18764,1018),(18765,1018),(18766,1018),(18767,1019),(18768,1019),(18769,1019),(18770,1020),(18771,1020),(18772,1020),(18773,1021),(18774,1021),(18775,1021),(18776,1022),(18777,1022),(18778,1022),(18779,1023),(18780,1023),(18781,1023),(18782,1024),(18783,1024),(18784,1024),(18785,1025),(18786,1025),(18787,1025),(18788,1026),(18789,1026),(18790,1026),(18791,1027),(18792,1027),(18793,1027),(18794,1028),(18795,1028),(18796,1028),(18797,1029),(18798,1029),(18799,1029),(18800,1030),(18801,1030),(18802,1030),(18803,1031),(18804,1031),(18805,1031),(18806,1032),(18807,1032),(18808,1032),(18809,1033),(18810,1033),(18811,1033),(18812,1034),(18813,1034),(18814,1034),(18815,1035),(18816,1035),(18817,1035),(18818,1036),(18819,1036),(18820,1036),(18821,1037),(18822,1037),(18823,1037),(18824,1038),(18825,1038),(18826,1038),(18827,1039),(18828,1039),(18829,1040),(18830,1040),(18831,1040),(18832,1041),(18833,1041),(18834,1041),(18835,1042),(18836,1042),(18837,1042),(18838,1043),(18839,1043),(18840,1043),(18841,1044),(18842,1044),(18843,1044),(18844,1045),(18845,1045),(18846,1045),(18847,1046),(18848,1046),(18849,1046),(18850,1047),(18851,1047),(18852,1047),(18853,1048),(18854,1048),(18855,1048),(18856,1049),(18857,1049),(18858,1049),(18859,1050),(18860,1050),(18861,1050),(18862,1051),(18863,1051),(18864,1051),(18865,1052),(18866,1052),(18867,1052),(18868,1053),(18869,1053),(18870,1053),(18871,1054),(18872,1054),(18873,1054),(18874,1055),(18875,1055),(18876,1055),(18877,1056),(18878,1056),(18879,1056),(18880,1057),(18881,1057),(18882,1057),(18883,1058),(18884,1058),(18885,1058),(18886,1059),(18887,1059),(18888,1059),(18889,1060),(18890,1060),(18891,1060),(18892,1061),(18893,1061),(18894,1061),(18895,1062),(18896,1062),(18897,1062),(18898,1063),(18899,1063),(18900,1063),(18901,1064),(18902,1064),(18903,1064),(18904,1065),(18905,1065),(18906,1065),(18907,1066),(18908,1066),(18909,1066),(18910,1067),(18911,1067),(18912,1067),(18913,1068),(18914,1068),(18915,1068),(18916,1069),(18917,1069),(18918,1069),(18919,1070),(18920,1070),(18921,1070),(18922,1071),(18923,1071),(18924,1071),(18925,1072),(18926,1072),(18927,1072),(18928,1073),(18929,1073),(18930,1073),(18931,1074),(18932,1074),(18933,1074),(18934,1075),(18935,1075),(18936,1075),(18937,1076),(18938,1076),(18939,1076),(18940,1077),(18941,1077),(18942,1077),(18943,1078),(18944,1078),(18945,1078),(18946,1079),(18947,1079),(18948,1079),(18949,1080),(18950,1080),(18951,1080),(18952,981),(18953,981),(18954,981),(18955,981),(18956,982),(18957,982),(18958,982),(18959,982),(18960,983),(18961,983),(18962,983),(18963,983),(18964,984),(18965,984),(18966,984),(18967,984),(18968,985),(18969,985),(18970,985),(18971,985),(18972,986),(18973,986),(18974,986),(18975,986),(18976,987),(18977,987),(18978,987),(18979,987),(18980,988),(18981,988),(18982,988),(18983,988),(18984,989),(18985,989),(18986,989),(18987,989),(18988,990),(18989,990),(18990,990),(18991,990),(18992,991),(18993,991),(18994,991),(18995,991),(18996,992),(18997,992),(18998,992),(18999,992),(19000,993),(19001,993),(19002,993),(19003,993),(19004,994),(19005,994),(19006,994),(19007,994),(19008,995),(19009,995),(19010,995),(19011,995),(19012,996),(19013,996),(19014,996),(19015,996),(19016,997),(19017,997),(19018,997),(19019,997),(19020,998),(19021,998),(19022,998),(19023,998),(19024,999),(19025,999),(19026,999),(19027,999),(19028,1000),(19029,1000),(19030,1000),(19031,1000),(19032,1001),(19033,1001),(19034,1001),(19035,1001),(19036,1002),(19037,1002),(19038,1002),(19039,1002),(19040,1003),(19041,1003),(19042,1003),(19043,1003),(19044,1004),(19045,1004),(19046,1004),(19047,1004),(19048,1005),(19049,1005),(19050,1005),(19051,1005),(19052,1006),(19053,1006),(19054,1006),(19055,1006),(19056,1007),(19057,1007),(19058,1007),(19059,1007),(19060,1008),(19061,1008),(19062,1008),(19063,1008),(19064,1009),(19065,1009),(19066,1009),(19067,1009),(19068,1010),(19069,1010),(19070,1010),(19071,1010),(19072,1011),(19073,1011),(19074,1011),(19075,1011),(19076,1012),(19077,1012),(19078,1012),(19079,1012),(19080,1013),(19081,1013),(19082,1013),(19083,1013),(19084,1014),(19085,1014),(19086,1014),(19087,1014),(19088,1015),(19089,1015),(19090,1015),(19091,1015),(19092,1016),(19093,1016),(19094,1016),(19095,1016),(19096,1017),(19097,1017),(19098,1017),(19099,1017),(19100,1018),(19101,1018),(19102,1018),(19103,1018),(19104,1019),(19105,1019),(19106,1019),(19107,1019),(19108,1020),(19109,1020),(19110,1020),(19111,1020),(19112,1021),(19113,1021),(19114,1021),(19115,1021),(19116,1022),(19117,1022),(19118,1022),(19119,1022),(19120,1023),(19121,1023),(19122,1023),(19123,1023),(19124,1024),(19125,1024),(19126,1024),(19127,1024),(19128,1025),(19129,1025),(19130,1025),(19131,1025),(19132,1026),(19133,1026),(19134,1026),(19135,1026),(19136,1027),(19137,1027),(19138,1027),(19139,1027),(19140,1028),(19141,1028),(19142,1028),(19143,1028),(19144,1029),(19145,1029),(19146,1029),(19147,1029),(19148,1030),(19149,1030),(19150,1030),(19151,1030),(19152,1031),(19153,1031),(19154,1031),(19155,1031),(19156,1032),(19157,1032),(19158,1032),(19159,1032),(19160,1033),(19161,1033),(19162,1033),(19163,1033),(19164,1034),(19165,1034),(19166,1034),(19167,1034),(19168,1035),(19169,1035),(19170,1035),(19171,1035),(19172,1036),(19173,1036),(19174,1036),(19175,1036),(19176,1037),(19177,1037),(19178,1037),(19179,1037),(19180,1038),(19181,1038),(19182,1038),(19183,1038),(19184,1039),(19185,1039),(19186,1039),(19187,1039),(19188,1040),(19189,1040),(19190,1040),(19191,1040),(19192,1041),(19193,1041),(19194,1041),(19195,1041),(19196,1042),(19197,1042),(19198,1042),(19199,1042),(19200,1043),(19201,1043),(19202,1043),(19203,1043),(19204,1044),(19205,1044),(19206,1044),(19207,1044),(19208,1045),(19209,1045),(19210,1045),(19211,1045),(19212,1046),(19213,1046),(19214,1046),(19215,1046),(19216,1047),(19217,1047),(19218,1047),(19219,1047),(19220,1048),(19221,1048),(19222,1048),(19223,1048),(19224,1049),(19225,1049),(19226,1049),(19227,1049),(19228,1050),(19229,1050),(19230,1050),(19231,1050),(19232,1051),(19233,1051),(19234,1051),(19235,1051),(19236,1052),(19237,1052),(19238,1052),(19239,1052),(19240,1053),(19241,1053),(19242,1053),(19243,1053),(19244,1054),(19245,1054),(19246,1054),(19247,1054),(19248,1055),(19249,1055),(19250,1055),(19251,1055),(19252,1056),(19253,1056),(19254,1056),(19255,1056),(19256,1057),(19257,1057),(19258,1057),(19259,1057),(19260,1058),(19261,1058),(19262,1058),(19263,1058),(19264,1059),(19265,1059),(19266,1059),(19267,1059),(19268,1060),(19269,1060),(19270,1060),(19271,1060),(19272,1061),(19273,1061),(19274,1061),(19275,1061),(19276,1062),(19277,1062),(19278,1062),(19279,1062),(19280,1063),(19281,1063),(19282,1063),(19283,1063),(19284,1064),(19285,1064),(19286,1064),(19287,1064),(19288,1065),(19289,1065),(19290,1065),(19291,1065),(19292,1066),(19293,1066),(19294,1066),(19295,1066),(19296,1067),(19297,1067),(19298,1067),(19299,1067),(19300,1068),(19301,1068),(19302,1068),(19303,1068),(19304,1069),(19305,1069),(19306,1069),(19307,1069),(19308,1070),(19309,1070),(19310,1070),(19311,1070),(19312,1071),(19313,1071),(19314,1071),(19315,1071),(19316,1072),(19317,1072),(19318,1072),(19319,1072),(19320,1073),(19321,1073),(19322,1073),(19323,1073),(19324,1074),(19325,1074),(19326,1074),(19327,1074),(19328,1075),(19329,1075),(19330,1075),(19331,1075),(19332,1076),(19333,1076),(19334,1076),(19335,1076),(19336,1077),(19337,1077),(19338,1077),(19339,1077),(19340,1078),(19341,1078),(19342,1078),(19343,1078),(19344,1079),(19345,1079),(19346,1079),(19347,1079),(19348,1080),(19349,1080),(19350,1080),(19351,1080),(19352,1081),(19353,1082),(19354,1083),(19355,1084),(19356,1085),(19357,1086),(19358,1087),(19359,1088),(19360,1089),(19361,1090),(19362,1091),(19363,1092),(19364,1093),(19365,1094),(19366,1095),(19367,1096),(19368,1097),(19369,1098),(19370,1099),(19371,1100),(19372,1101),(19373,1102),(19374,1103),(19375,1104),(19376,1105),(19377,1106),(19378,1107),(19379,1108),(19380,1109),(19381,1110),(19382,1111),(19383,1112),(19384,1113),(19385,1114),(19386,1115),(19387,1116),(19388,1117),(19389,1118),(19390,1119),(19391,1120),(19392,1121),(19393,1122),(19394,1123),(19395,1124),(19396,1125),(19397,1126),(19398,1127),(19399,1128),(19400,1129),(19401,1130),(19402,1131),(19403,1132),(19404,1133),(19405,1134),(19406,1135),(19407,1136),(19408,1137),(19409,1138),(19410,1139),(19411,1081),(19412,1081),(19413,1082),(19414,1082),(19415,1083),(19416,1083),(19417,1084),(19418,1084),(19419,1085),(19420,1085),(19421,1086),(19422,1086),(19423,1087),(19424,1087),(19425,1088),(19426,1088),(19427,1089),(19428,1089),(19429,1090),(19430,1090),(19431,1091),(19432,1091),(19433,1092),(19434,1092),(19435,1093),(19436,1093),(19437,1094),(19438,1094),(19439,1095),(19440,1095),(19441,1096),(19442,1096),(19443,1097),(19444,1097),(19445,1098),(19446,1098),(19447,1099),(19448,1099),(19449,1100),(19450,1100),(19451,1101),(19452,1101),(19453,1102),(19454,1102),(19455,1103),(19456,1103),(19457,1104),(19458,1104),(19459,1105),(19460,1105),(19461,1106),(19462,1106),(19463,1107),(19464,1107),(19465,1108),(19466,1108),(19467,1109),(19468,1109),(19469,1110),(19470,1110),(19471,1111),(19472,1111),(19473,1112),(19474,1112),(19475,1113),(19476,1113),(19477,1114),(19478,1114),(19479,1115),(19480,1115),(19481,1116),(19482,1116),(19483,1117),(19484,1117),(19485,1118),(19486,1118),(19487,1119),(19488,1119),(19489,1120),(19490,1120),(19491,1121),(19492,1121),(19493,1122),(19494,1122),(19495,1123),(19496,1123),(19497,1124),(19498,1124),(19499,1125),(19500,1125),(19501,1126),(19502,1126),(19503,1127),(19504,1127),(19505,1128),(19506,1128),(19507,1129),(19508,1129),(19509,1130),(19510,1130),(19511,1131),(19512,1131),(19513,1132),(19514,1132),(19515,1133),(19516,1133),(19517,1134),(19518,1134),(19519,1135),(19520,1135),(19521,1136),(19522,1136),(19523,1137),(19524,1137),(19525,1138),(19526,1138),(19527,1139),(19528,1139),(19529,1081),(19530,1081),(19531,1081),(19532,1081),(19533,1081),(19534,1081),(19535,1082),(19536,1082),(19537,1082),(19538,1082),(19539,1082),(19540,1082),(19541,1083),(19542,1083),(19543,1083),(19544,1083),(19545,1083),(19546,1083),(19547,1084),(19548,1084),(19549,1084),(19550,1084),(19551,1084),(19552,1084),(19553,1085),(19554,1085),(19555,1085),(19556,1085),(19557,1085),(19558,1085),(19559,1086),(19560,1086),(19561,1086),(19562,1086),(19563,1086),(19564,1086),(19565,1087),(19566,1087),(19567,1087),(19568,1087),(19569,1087),(19570,1087),(19571,1088),(19572,1088),(19573,1088),(19574,1088),(19575,1088),(19576,1088),(19577,1089),(19578,1089),(19579,1089),(19580,1089),(19581,1089),(19582,1089),(19583,1090),(19584,1090),(19585,1090),(19586,1090),(19587,1090),(19588,1090),(19589,1091),(19590,1091),(19591,1091),(19592,1091),(19593,1091),(19594,1091),(19595,1092),(19596,1092),(19597,1092),(19598,1092),(19599,1092),(19600,1092),(19601,1093),(19602,1093),(19603,1093),(19604,1093),(19605,1093),(19606,1093),(19607,1094),(19608,1094),(19609,1094),(19610,1094),(19611,1094),(19612,1094),(19613,1095),(19614,1095),(19615,1095),(19616,1095),(19617,1095),(19618,1095),(19619,1096),(19620,1096),(19621,1096),(19622,1096),(19623,1096),(19624,1096),(19625,1097),(19626,1097),(19627,1097),(19628,1097),(19629,1097),(19630,1097),(19631,1098),(19632,1098),(19633,1098),(19634,1098),(19635,1098),(19636,1098),(19637,1099),(19638,1099),(19639,1099),(19640,1099),(19641,1099),(19642,1099),(19643,1100),(19644,1100),(19645,1100),(19646,1100),(19647,1100),(19648,1100),(19649,1101),(19650,1101),(19651,1101),(19652,1101),(19653,1101),(19654,1101),(19655,1102),(19656,1102),(19657,1102),(19658,1102),(19659,1102),(19660,1102),(19661,1103),(19662,1103),(19663,1103),(19664,1103),(19665,1103),(19666,1103),(19667,1104),(19668,1104),(19669,1104),(19670,1104),(19671,1104),(19672,1104),(19673,1105),(19674,1105),(19675,1105),(19676,1105),(19677,1105),(19678,1105),(19679,1106),(19680,1106),(19681,1106),(19682,1106),(19683,1106),(19684,1106),(19685,1107),(19686,1107),(19687,1107),(19688,1107),(19689,1107),(19690,1107),(19691,1108),(19692,1108),(19693,1108),(19694,1108),(19695,1108),(19696,1108),(19697,1109),(19698,1109),(19699,1109),(19700,1109),(19701,1109),(19702,1109),(19703,1110),(19704,1110),(19705,1110),(19706,1110),(19707,1110),(19708,1110),(19709,1111),(19710,1111),(19711,1111),(19712,1111),(19713,1111),(19714,1111),(19715,1112),(19716,1112),(19717,1112),(19718,1112),(19719,1112),(19720,1112),(19721,1113),(19722,1113),(19723,1113),(19724,1113),(19725,1113),(19726,1113),(19727,1114),(19728,1114),(19729,1114),(19730,1114),(19731,1114),(19732,1114),(19733,1115),(19734,1115),(19735,1115),(19736,1115),(19737,1115),(19738,1115),(19739,1116),(19740,1116),(19741,1116),(19742,1116),(19743,1116),(19744,1116),(19745,1117),(19746,1117),(19747,1117),(19748,1117),(19749,1117),(19750,1117),(19751,1118),(19752,1118),(19753,1118),(19754,1118),(19755,1118),(19756,1118),(19757,1119),(19758,1119),(19759,1119),(19760,1119),(19761,1119),(19762,1119),(19763,1120),(19764,1120),(19765,1120),(19766,1120),(19767,1120),(19768,1120),(19769,1121),(19770,1121),(19771,1121),(19772,1121),(19773,1121),(19774,1121),(19775,1122),(19776,1122),(19777,1122),(19778,1122),(19779,1122),(19780,1122),(19781,1123),(19782,1123),(19783,1123),(19784,1123),(19785,1123),(19786,1123),(19787,1124),(19788,1124),(19789,1124),(19790,1124),(19791,1124),(19792,1124),(19793,1125),(19794,1125),(19795,1125),(19796,1125),(19797,1125),(19798,1125),(19799,1126),(19800,1126),(19801,1126),(19802,1126),(19803,1126),(19804,1126),(19805,1127),(19806,1127),(19807,1127),(19808,1127),(19809,1127),(19810,1127),(19811,1128),(19812,1128),(19813,1128),(19814,1128),(19815,1128),(19816,1128),(19817,1129),(19818,1129),(19819,1129),(19820,1129),(19821,1129),(19822,1129),(19823,1130),(19824,1130),(19825,1130),(19826,1130),(19827,1130),(19828,1130),(19829,1131),(19830,1131),(19831,1131),(19832,1131),(19833,1131),(19834,1131),(19835,1132),(19836,1132),(19837,1132),(19838,1132),(19839,1132),(19840,1132),(19841,1133),(19842,1133),(19843,1133),(19844,1133),(19845,1133),(19846,1133),(19847,1134),(19848,1134),(19849,1134),(19850,1134),(19851,1134),(19852,1134),(19853,1135),(19854,1135),(19855,1135),(19856,1135),(19857,1135),(19858,1135),(19859,1136),(19860,1136),(19861,1136),(19862,1136),(19863,1136),(19864,1136),(19865,1137),(19866,1137),(19867,1137),(19868,1137),(19869,1137),(19870,1137),(19871,1138),(19872,1138),(19873,1138),(19874,1138),(19875,1138),(19876,1138),(19877,1139),(19878,1139),(19879,1139),(19880,1139),(19881,1139),(19882,1139),(19883,1081),(19884,1081),(19885,1081),(19886,1082),(19887,1082),(19888,1082),(19889,1083),(19890,1083),(19891,1083),(19892,1084),(19893,1084),(19894,1084),(19895,1085),(19896,1085),(19897,1085),(19898,1086),(19899,1086),(19900,1086),(19901,1087),(19902,1087),(19903,1087),(19904,1088),(19905,1088),(19906,1088),(19907,1089),(19908,1089),(19909,1089),(19910,1090),(19911,1090),(19912,1090),(19913,1091),(19914,1091),(19915,1091),(19916,1092),(19917,1092),(19918,1092),(19919,1093),(19920,1093),(19921,1094),(19922,1094),(19923,1095),(19924,1095),(19925,1096),(19926,1096),(19927,1097),(19928,1097),(19929,1098),(19930,1098),(19931,1099),(19932,1099),(19933,1099),(19934,1100),(19935,1100),(19936,1101),(19937,1101),(19938,1102),(19939,1102),(19940,1103),(19941,1103),(19942,1104),(19943,1104),(19944,1105),(19945,1105),(19946,1106),(19947,1106),(19948,1107),(19949,1107),(19950,1108),(19951,1108),(19952,1109),(19953,1109),(19954,1110),(19955,1110),(19956,1111),(19957,1111),(19958,1112),(19959,1112),(19960,1113),(19961,1113),(19962,1114),(19963,1114),(19964,1115),(19965,1115),(19966,1116),(19967,1116),(19968,1117),(19969,1117),(19970,1118),(19971,1118),(19972,1119),(19973,1119),(19974,1119),(19975,1120),(19976,1120),(19977,1121),(19978,1121),(19979,1122),(19980,1122),(19981,1123),(19982,1123),(19983,1124),(19984,1124),(19985,1125),(19986,1125),(19987,1126),(19988,1126),(19989,1127),(19990,1127),(19991,1128),(19992,1128),(19993,1129),(19994,1129),(19995,1130),(19996,1130),(19997,1131),(19998,1131),(19999,1132),(20000,1132),(20001,1133),(20002,1133),(20003,1134),(20004,1134),(20005,1135),(20006,1135),(20007,1136),(20008,1136),(20009,1137),(20010,1137),(20011,1138),(20012,1138),(20013,1139),(20014,1139),(20015,1081),(20016,1081),(20017,1081),(20018,1082),(20019,1082),(20020,1082),(20021,1083),(20022,1083),(20023,1083),(20024,1084),(20025,1084),(20026,1084),(20027,1085),(20028,1085),(20029,1085),(20030,1086),(20031,1086),(20032,1086),(20033,1087),(20034,1087),(20035,1087),(20036,1088),(20037,1088),(20038,1088),(20039,1089),(20040,1089),(20041,1089),(20042,1090),(20043,1090),(20044,1090),(20045,1091),(20046,1091),(20047,1091),(20048,1092),(20049,1092),(20050,1092),(20051,1093),(20052,1093),(20053,1093),(20054,1094),(20055,1094),(20056,1094),(20057,1095),(20058,1095),(20059,1095),(20060,1096),(20061,1096),(20062,1096),(20063,1097),(20064,1097),(20065,1097),(20066,1098),(20067,1098),(20068,1098),(20069,1099),(20070,1099),(20071,1100),(20072,1100),(20073,1100),(20074,1101),(20075,1101),(20076,1101),(20077,1102),(20078,1102),(20079,1102),(20080,1103),(20081,1103),(20082,1103),(20083,1104),(20084,1104),(20085,1104),(20086,1105),(20087,1105),(20088,1105),(20089,1106),(20090,1106),(20091,1106),(20092,1107),(20093,1107),(20094,1107),(20095,1108),(20096,1108),(20097,1108),(20098,1109),(20099,1109),(20100,1109),(20101,1110),(20102,1110),(20103,1110),(20104,1111),(20105,1111),(20106,1111),(20107,1112),(20108,1112),(20109,1112),(20110,1113),(20111,1113),(20112,1113),(20113,1114),(20114,1114),(20115,1114),(20116,1115),(20117,1115),(20118,1115),(20119,1116),(20120,1116),(20121,1116),(20122,1117),(20123,1117),(20124,1117),(20125,1118),(20126,1118),(20127,1118),(20128,1119),(20129,1119),(20130,1119),(20131,1120),(20132,1120),(20133,1120),(20134,1121),(20135,1121),(20136,1121),(20137,1122),(20138,1122),(20139,1122),(20140,1123),(20141,1123),(20142,1123),(20143,1124),(20144,1124),(20145,1124),(20146,1125),(20147,1125),(20148,1125),(20149,1126),(20150,1126),(20151,1126),(20152,1127),(20153,1127),(20154,1127),(20155,1128),(20156,1128),(20157,1128),(20158,1129),(20159,1129),(20160,1129),(20161,1130),(20162,1130),(20163,1130),(20164,1131),(20165,1131),(20166,1131),(20167,1132),(20168,1132),(20169,1132),(20170,1133),(20171,1133),(20172,1133),(20173,1134),(20174,1134),(20175,1134),(20176,1135),(20177,1135),(20178,1135),(20179,1136),(20180,1136),(20181,1136),(20182,1137),(20183,1137),(20184,1137),(20185,1138),(20186,1138),(20187,1138),(20188,1139),(20189,1139),(20190,1139),(20191,1081),(20192,1081),(20193,1081),(20194,1081),(20195,1082),(20196,1082),(20197,1082),(20198,1082),(20199,1083),(20200,1083),(20201,1083),(20202,1083),(20203,1084),(20204,1084),(20205,1084),(20206,1084),(20207,1085),(20208,1085),(20209,1085),(20210,1085),(20211,1086),(20212,1086),(20213,1086),(20214,1086),(20215,1087),(20216,1087),(20217,1087),(20218,1087),(20219,1088),(20220,1088),(20221,1088),(20222,1088),(20223,1089),(20224,1089),(20225,1089),(20226,1089),(20227,1090),(20228,1090),(20229,1090),(20230,1090),(20231,1091),(20232,1091),(20233,1091),(20234,1091),(20235,1092),(20236,1092),(20237,1092),(20238,1092),(20239,1093),(20240,1093),(20241,1093),(20242,1093),(20243,1094),(20244,1094),(20245,1094),(20246,1094),(20247,1095),(20248,1095),(20249,1095),(20250,1095),(20251,1096),(20252,1096),(20253,1096),(20254,1096),(20255,1097),(20256,1097),(20257,1097),(20258,1097),(20259,1098),(20260,1098),(20261,1098),(20262,1098),(20263,1099),(20264,1099),(20265,1099),(20266,1099),(20267,1100),(20268,1100),(20269,1100),(20270,1100),(20271,1101),(20272,1101),(20273,1101),(20274,1101),(20275,1102),(20276,1102),(20277,1102),(20278,1102),(20279,1103),(20280,1103),(20281,1103),(20282,1103),(20283,1104),(20284,1104),(20285,1104),(20286,1104),(20287,1105),(20288,1105),(20289,1105),(20290,1105),(20291,1106),(20292,1106),(20293,1106),(20294,1106),(20295,1107),(20296,1107),(20297,1107),(20298,1107),(20299,1108),(20300,1108),(20301,1108),(20302,1108),(20303,1109),(20304,1109),(20305,1109),(20306,1109),(20307,1110),(20308,1110),(20309,1110),(20310,1110),(20311,1111),(20312,1111),(20313,1111),(20314,1111),(20315,1112),(20316,1112),(20317,1112),(20318,1112),(20319,1113),(20320,1113),(20321,1113),(20322,1113),(20323,1114),(20324,1114),(20325,1114),(20326,1114),(20327,1115),(20328,1115),(20329,1115),(20330,1115),(20331,1116),(20332,1116),(20333,1116),(20334,1116),(20335,1117),(20336,1117),(20337,1117),(20338,1117),(20339,1118),(20340,1118),(20341,1118),(20342,1118),(20343,1119),(20344,1119),(20345,1119),(20346,1119),(20347,1120),(20348,1120),(20349,1120),(20350,1120),(20351,1121),(20352,1121),(20353,1121),(20354,1121),(20355,1122),(20356,1122),(20357,1122),(20358,1122),(20359,1123),(20360,1123),(20361,1123),(20362,1123),(20363,1124),(20364,1124),(20365,1124),(20366,1124),(20367,1125),(20368,1125),(20369,1125),(20370,1125),(20371,1126),(20372,1126),(20373,1126),(20374,1126),(20375,1127),(20376,1127),(20377,1127),(20378,1127),(20379,1128),(20380,1128),(20381,1128),(20382,1128),(20383,1129),(20384,1129),(20385,1129),(20386,1129),(20387,1130),(20388,1130),(20389,1130),(20390,1130),(20391,1131),(20392,1131),(20393,1131),(20394,1131),(20395,1132),(20396,1132),(20397,1132),(20398,1132),(20399,1133),(20400,1133),(20401,1133),(20402,1133),(20403,1134),(20404,1134),(20405,1134),(20406,1134),(20407,1135),(20408,1135),(20409,1135),(20410,1135),(20411,1136),(20412,1136),(20413,1136),(20414,1136),(20415,1137),(20416,1137),(20417,1137),(20418,1137),(20419,1138),(20420,1138),(20421,1138),(20422,1138),(20423,1139),(20424,1139),(20425,1139),(20426,1139),(20427,1140),(20428,1141),(20429,1142),(20430,1143),(20431,1144),(20432,1145),(20433,1146),(20434,1147),(20435,1148),(20436,1149),(20437,1150),(20438,1140),(20439,1140),(20440,1141),(20441,1141),(20442,1142),(20443,1142),(20444,1143),(20445,1143),(20446,1144),(20447,1144),(20448,1145),(20449,1145),(20450,1146),(20451,1146),(20452,1147),(20453,1147),(20454,1148),(20455,1148),(20456,1149),(20457,1149),(20458,1150),(20459,1150),(20460,1140),(20461,1140),(20462,1140),(20463,1140),(20464,1140),(20465,1140),(20466,1140),(20467,1140),(20468,1140),(20469,1141),(20470,1141),(20471,1141),(20472,1141),(20473,1141),(20474,1141),(20475,1141),(20476,1141),(20477,1141),(20478,1142),(20479,1142),(20480,1142),(20481,1142),(20482,1142),(20483,1142),(20484,1142),(20485,1142),(20486,1142),(20487,1143),(20488,1143),(20489,1143),(20490,1143),(20491,1143),(20492,1143),(20493,1143),(20494,1143),(20495,1143),(20496,1144),(20497,1144),(20498,1144),(20499,1144),(20500,1144),(20501,1144),(20502,1144),(20503,1144),(20504,1144),(20505,1145),(20506,1145),(20507,1145),(20508,1145),(20509,1145),(20510,1145),(20511,1145),(20512,1145),(20513,1145),(20514,1146),(20515,1146),(20516,1146),(20517,1146),(20518,1146),(20519,1146),(20520,1146),(20521,1147),(20522,1147),(20523,1147),(20524,1147),(20525,1147),(20526,1147),(20527,1147),(20528,1148),(20529,1148),(20530,1148),(20531,1148),(20532,1148),(20533,1148),(20534,1148),(20535,1149),(20536,1149),(20537,1149),(20538,1149),(20539,1149),(20540,1149),(20541,1149),(20542,1149),(20543,1149),(20544,1150),(20545,1150),(20546,1150),(20547,1150),(20548,1150),(20549,1150),(20550,1150),(20551,1150),(20552,1150),(20553,1140),(20554,1140),(20555,1140),(20556,1141),(20557,1141),(20558,1141),(20559,1142),(20560,1142),(20561,1142),(20562,1143),(20563,1143),(20564,1143),(20565,1144),(20566,1144),(20567,1145),(20568,1146),(20569,1147),(20570,1148),(20571,1148),(20572,1149),(20573,1149),(20574,1149),(20575,1150),(20576,1150),(20577,1150),(20578,1140),(20579,1140),(20580,1141),(20581,1141),(20582,1142),(20583,1142),(20584,1143),(20585,1143),(20586,1144),(20587,1144),(20588,1144),(20589,1145),(20590,1145),(20591,1145),(20592,1146),(20593,1146),(20594,1146),(20595,1147),(20596,1147),(20597,1147),(20598,1148),(20599,1148),(20600,1148),(20601,1149),(20602,1149),(20603,1150),(20604,1150),(20605,1140),(20606,1140),(20607,1140),(20608,1140),(20609,1141),(20610,1141),(20611,1141),(20612,1141),(20613,1142),(20614,1142),(20615,1142),(20616,1142),(20617,1143),(20618,1143),(20619,1143),(20620,1143),(20621,1144),(20622,1144),(20623,1144),(20624,1144),(20625,1145),(20626,1145),(20627,1145),(20628,1145),(20629,1146),(20630,1146),(20631,1146),(20632,1146),(20633,1147),(20634,1147),(20635,1147),(20636,1147),(20637,1148),(20638,1148),(20639,1148),(20640,1148),(20641,1149),(20642,1149),(20643,1149),(20644,1149),(20645,1150),(20646,1150),(20647,1150),(20648,1150),(20649,1151),(20650,1152),(20651,1153),(20652,1154),(20653,1155),(20654,1156),(20655,1157),(20656,1158),(20657,1159),(20658,1160),(20659,1161),(20660,1151),(20661,1151),(20662,1151),(20663,1151),(20664,1151),(20665,1151),(20666,1152),(20667,1152),(20668,1152),(20669,1152),(20670,1152),(20671,1152),(20672,1152),(20673,1152),(20674,1152),(20675,1153),(20676,1153),(20677,1153),(20678,1153),(20679,1153),(20680,1153),(20681,1153),(20682,1153),(20683,1153),(20684,1154),(20685,1154),(20686,1154),(20687,1154),(20688,1154),(20689,1154),(20690,1154),(20691,1154),(20692,1154),(20693,1155),(20694,1155),(20695,1155),(20696,1155),(20697,1155),(20698,1155),(20699,1155),(20700,1155),(20701,1155),(20702,1156),(20703,1156),(20704,1156),(20705,1156),(20706,1156),(20707,1156),(20708,1156),(20709,1156),(20710,1156),(20711,1157),(20712,1157),(20713,1157),(20714,1157),(20715,1157),(20716,1157),(20717,1157),(20718,1157),(20719,1157),(20720,1158),(20721,1158),(20722,1158),(20723,1158),(20724,1158),(20725,1158),(20726,1158),(20727,1158),(20728,1158),(20729,1159),(20730,1159),(20731,1159),(20732,1159),(20733,1159),(20734,1159),(20735,1159),(20736,1160),(20737,1160),(20738,1160),(20739,1160),(20740,1160),(20741,1160),(20742,1160),(20743,1161),(20744,1161),(20745,1161),(20746,1161),(20747,1161),(20748,1161),(20749,1161),(20750,1151),(20751,1151),(20752,1151),(20753,1152),(20754,1152),(20755,1153),(20756,1153),(20757,1154),(20758,1154),(20759,1155),(20760,1155),(20761,1156),(20762,1156),(20763,1157),(20764,1157),(20765,1158),(20766,1158),(20767,1159),(20768,1159),(20769,1160),(20770,1160),(20771,1161),(20772,1161),(20773,1151),(20774,1151),(20775,1151),(20776,1152),(20777,1152),(20778,1152),(20779,1153),(20780,1153),(20781,1153),(20782,1154),(20783,1154),(20784,1154),(20785,1155),(20786,1155),(20787,1155),(20788,1156),(20789,1156),(20790,1156),(20791,1157),(20792,1157),(20793,1157),(20794,1158),(20795,1158),(20796,1158),(20797,1159),(20798,1159),(20799,1159),(20800,1160),(20801,1160),(20802,1160),(20803,1161),(20804,1161),(20805,1161),(20806,1151),(20807,1151),(20808,1151),(20809,1151),(20810,1152),(20811,1152),(20812,1152),(20813,1152),(20814,1153),(20815,1153),(20816,1153),(20817,1153),(20818,1154),(20819,1154),(20820,1154),(20821,1154),(20822,1155),(20823,1155),(20824,1155),(20825,1155),(20826,1156),(20827,1156),(20828,1156),(20829,1156),(20830,1157),(20831,1157),(20832,1157),(20833,1157),(20834,1158),(20835,1158),(20836,1158),(20837,1158),(20838,1159),(20839,1159),(20840,1159),(20841,1159),(20842,1160),(20843,1160),(20844,1160),(20845,1160),(20846,1161),(20847,1161),(20848,1161),(20849,1161),(20850,1142),(20851,1143),(20852,1144),(20853,1145),(20854,1146),(20855,1147),(20856,1148),(20857,1149),(20858,1150),(20859,1151),(20860,1152),(20861,1153),(20862,1154),(20863,1155),(20864,1156),(20865,1157),(20866,1158),(20867,1159),(20868,1160),(20869,1161),(20870,1162),(20871,1162),(20872,1162),(20873,1162),(20874,1162),(20875,1162),(20876,1162),(20877,1162),(20878,1162),(20879,1162),(20880,1162),(20881,1162),(20882,1162),(20883,1162),(20884,1162),(20885,1162),(20886,1162),(20887,1162),(20888,1162),(20889,1162),(20890,1162),(20891,1162),(20892,1162),(20893,1162),(20894,1162),(20895,1162),(20896,1163),(20897,1163),(20898,1163),(20899,1163),(20900,1163),(20901,1163),(20902,1163),(20903,1163),(20904,1163),(20905,1163),(20906,1163),(20907,1163),(20908,1163),(20909,1163),(20910,1163),(20911,1163),(20912,1163),(20913,1163),(20914,1163),(20915,1163),(20916,1163),(20917,1163),(20918,1163),(20919,1163),(20920,1163),(20921,1163),(20922,1163),(20923,1163),(20924,1163),(20925,1163),(20926,1163),(20927,1163),(20928,1163),(20929,1163),(20930,1164),(20931,1164),(20932,1164),(20933,1164),(20934,1164),(20935,1164),(20936,1164),(20937,1164),(20938,1164),(20939,1164),(20940,1164),(20941,1164),(20942,1164),(20943,1164),(20944,1164),(20945,1164),(20946,1164),(20947,1164),(20948,1164),(20949,1164),(20950,1164),(20951,1164),(20952,1164),(20953,1164),(20954,1164),(20955,1164),(20956,1164),(20957,1164),(20958,1164),(20959,1164),(20960,1164),(20961,1164),(20962,1164),(20963,1164),(20964,1165),(20965,1165),(20966,1165),(20967,1165),(20968,1165),(20969,1165),(20970,1165),(20971,1165),(20972,1165),(20973,1165),(20974,1165),(20975,1165),(20976,1165),(20977,1165),(20978,1165),(20979,1165),(20980,1165),(20981,1165),(20982,1165),(20983,1165),(20984,1165),(20985,1165),(20986,1165),(20987,1165),(20988,1165),(20989,1165),(20990,1165),(20991,1165),(20992,1165),(20993,1165),(20994,1165),(20995,1165),(20996,1165),(20997,1165),(20998,1154),(20999,1155),(21000,1156),(21001,1157),(21002,1142),(21003,1143),(21004,1144),(21005,1145),(21006,1146),(21007,1147),(21008,1148),(21009,1149),(21010,1150),(21011,1151),(21012,1152),(21013,1153),(21014,1158),(21015,1159),(21016,1159),(21017,1160),(21018,1161),(21019,1162),(21020,1163),(21021,1164),(21022,1165),(21023,1166),(21024,1167),(21025,1168),(21026,1169),(21027,1170),(21028,1171),(21029,1172),(21030,1173),(21031,1174),(21032,1175),(21033,1176),(21034,1166),(21035,1166),(21036,1166),(21037,1166),(21038,1166),(21039,1166),(21040,1166),(21041,1167),(21042,1167),(21043,1167),(21044,1167),(21045,1167),(21046,1167),(21047,1167),(21048,1168),(21049,1168),(21050,1168),(21051,1168),(21052,1168),(21053,1168),(21054,1168),(21055,1169),(21056,1169),(21057,1169),(21058,1169),(21059,1169),(21060,1169),(21061,1169),(21062,1170),(21063,1170),(21064,1170),(21065,1170),(21066,1170),(21067,1170),(21068,1170),(21069,1171),(21070,1171),(21071,1171),(21072,1171),(21073,1171),(21074,1171),(21075,1171),(21076,1172),(21077,1172),(21078,1172),(21079,1172),(21080,1172),(21081,1172),(21082,1172),(21083,1173),(21084,1173),(21085,1173),(21086,1173),(21087,1173),(21088,1173),(21089,1173),(21090,1174),(21091,1174),(21092,1174),(21093,1174),(21094,1174),(21095,1174),(21096,1174),(21097,1175),(21098,1175),(21099,1175),(21100,1175),(21101,1175),(21102,1175),(21103,1175),(21104,1176),(21105,1176),(21106,1176),(21107,1176),(21108,1176),(21109,1176),(21110,1176),(21111,1166),(21112,1166),(21113,1167),(21114,1167),(21115,1168),(21116,1168),(21117,1169),(21118,1169),(21119,1170),(21120,1170),(21121,1171),(21122,1171),(21123,1172),(21124,1172),(21125,1173),(21126,1173),(21127,1174),(21128,1174),(21129,1175),(21130,1175),(21131,1176),(21132,1176),(21133,1166),(21134,1166),(21135,1166),(21136,1167),(21137,1167),(21138,1167),(21139,1168),(21140,1168),(21141,1168),(21142,1169),(21143,1169),(21144,1169),(21145,1170),(21146,1170),(21147,1170),(21148,1171),(21149,1171),(21150,1171),(21151,1172),(21152,1172),(21153,1172),(21154,1173),(21155,1173),(21156,1173),(21157,1174),(21158,1174),(21159,1174),(21160,1175),(21161,1175),(21162,1175),(21163,1176),(21164,1176),(21165,1176),(21166,1166),(21167,1166),(21168,1166),(21169,1166),(21170,1167),(21171,1167),(21172,1167),(21173,1167),(21174,1168),(21175,1168),(21176,1168),(21177,1168),(21178,1169),(21179,1169),(21180,1169),(21181,1169),(21182,1170),(21183,1170),(21184,1170),(21185,1170),(21186,1171),(21187,1171),(21188,1171),(21189,1171),(21190,1172),(21191,1172),(21192,1172),(21193,1172),(21194,1173),(21195,1173),(21196,1173),(21197,1173),(21198,1174),(21199,1174),(21200,1174),(21201,1174),(21202,1175),(21203,1175),(21204,1175),(21205,1175),(21206,1176),(21207,1176),(21208,1176),(21209,1176),(21210,1177),(21211,1178),(21212,1179),(21213,1180),(21214,1181),(21215,1182),(21216,1183),(21217,1184),(21218,1185),(21219,1186),(21220,1187),(21221,1188),(21222,1189),(21223,1190),(21224,1191),(21225,1192),(21226,1193),(21227,1194),(21228,1195),(21229,1196),(21230,1197),(21231,1198),(21232,1199),(21233,1200),(21234,1201),(21235,1202),(21236,1203),(21237,1204),(21238,1205),(21239,1206),(21240,1207),(21241,1208),(21242,1209),(21243,1210),(21244,1211),(21245,1212),(21246,1213),(21247,1214),(21248,1215),(21249,1216),(21250,1217),(21251,1218),(21252,1219),(21253,1220),(21254,1221),(21255,1222),(21256,1223),(21257,1224),(21258,1225),(21259,1226),(21260,1227),(21261,1228),(21262,1229),(21263,1230),(21264,1231),(21265,1232),(21266,1233),(21267,1234),(21268,1235),(21269,1236),(21270,1237),(21271,1238),(21272,1239),(21273,1240),(21274,1241),(21275,1242),(21276,1243),(21277,1244),(21278,1245),(21279,1246),(21280,1247),(21281,1248),(21282,1249),(21283,1250),(21284,1251),(21285,1252),(21286,1253),(21287,1254),(21288,1255),(21289,1256),(21290,1257),(21291,1258),(21292,1259),(21293,1260),(21294,1261),(21295,1262),(21296,1263),(21297,1264),(21298,1265),(21299,1177),(21300,1177),(21301,1177),(21302,1177),(21303,1177),(21304,1177),(21305,1177),(21306,1178),(21307,1178),(21308,1178),(21309,1178),(21310,1178),(21311,1178),(21312,1178),(21313,1179),(21314,1179),(21315,1179),(21316,1179),(21317,1179),(21318,1179),(21319,1179),(21320,1180),(21321,1180),(21322,1180),(21323,1180),(21324,1180),(21325,1180),(21326,1180),(21327,1181),(21328,1181),(21329,1181),(21330,1181),(21331,1181),(21332,1181),(21333,1181),(21334,1182),(21335,1182),(21336,1182),(21337,1182),(21338,1182),(21339,1182),(21340,1183),(21341,1183),(21342,1183),(21343,1183),(21344,1183),(21345,1183),(21346,1184),(21347,1184),(21348,1184),(21349,1184),(21350,1184),(21351,1184),(21352,1184),(21353,1185),(21354,1185),(21355,1185),(21356,1185),(21357,1185),(21358,1185),(21359,1185),(21360,1186),(21361,1186),(21362,1186),(21363,1186),(21364,1186),(21365,1186),(21366,1186),(21367,1187),(21368,1187),(21369,1187),(21370,1187),(21371,1187),(21372,1187),(21373,1187),(21374,1188),(21375,1188),(21376,1188),(21377,1188),(21378,1188),(21379,1188),(21380,1188),(21381,1189),(21382,1189),(21383,1189),(21384,1189),(21385,1189),(21386,1189),(21387,1189),(21388,1190),(21389,1190),(21390,1190),(21391,1190),(21392,1190),(21393,1190),(21394,1190),(21395,1191),(21396,1191),(21397,1191),(21398,1191),(21399,1191),(21400,1191),(21401,1191),(21402,1192),(21403,1192),(21404,1192),(21405,1192),(21406,1192),(21407,1192),(21408,1192),(21409,1193),(21410,1193),(21411,1193),(21412,1193),(21413,1193),(21414,1193),(21415,1193),(21416,1194),(21417,1194),(21418,1194),(21419,1194),(21420,1194),(21421,1194),(21422,1194),(21423,1195),(21424,1195),(21425,1195),(21426,1195),(21427,1195),(21428,1195),(21429,1195),(21430,1196),(21431,1196),(21432,1196),(21433,1196),(21434,1196),(21435,1196),(21436,1196),(21437,1197),(21438,1197),(21439,1197),(21440,1197),(21441,1197),(21442,1197),(21443,1197),(21444,1198),(21445,1198),(21446,1198),(21447,1198),(21448,1198),(21449,1198),(21450,1198),(21451,1199),(21452,1199),(21453,1199),(21454,1199),(21455,1199),(21456,1199),(21457,1199),(21458,1200),(21459,1200),(21460,1200),(21461,1200),(21462,1200),(21463,1200),(21464,1200),(21465,1201),(21466,1201),(21467,1201),(21468,1201),(21469,1201),(21470,1201),(21471,1201),(21472,1202),(21473,1202),(21474,1202),(21475,1202),(21476,1202),(21477,1202),(21478,1202),(21479,1203),(21480,1203),(21481,1203),(21482,1203),(21483,1203),(21484,1203),(21485,1203),(21486,1204),(21487,1204),(21488,1204),(21489,1204),(21490,1204),(21491,1204),(21492,1204),(21493,1205),(21494,1205),(21495,1205),(21496,1205),(21497,1205),(21498,1205),(21499,1205),(21500,1206),(21501,1206),(21502,1206),(21503,1206),(21504,1206),(21505,1206),(21506,1206),(21507,1207),(21508,1207),(21509,1207),(21510,1207),(21511,1207),(21512,1207),(21513,1207),(21514,1208),(21515,1208),(21516,1208),(21517,1208),(21518,1208),(21519,1208),(21520,1208),(21521,1209),(21522,1209),(21523,1209),(21524,1209),(21525,1209),(21526,1209),(21527,1209),(21528,1210),(21529,1210),(21530,1210),(21531,1210),(21532,1210),(21533,1210),(21534,1210),(21535,1210),(21536,1210),(21537,1211),(21538,1211),(21539,1211),(21540,1211),(21541,1211),(21542,1211),(21543,1211),(21544,1212),(21545,1212),(21546,1212),(21547,1212),(21548,1212),(21549,1212),(21550,1212),(21551,1213),(21552,1213),(21553,1213),(21554,1213),(21555,1213),(21556,1213),(21557,1213),(21558,1214),(21559,1214),(21560,1214),(21561,1214),(21562,1214),(21563,1214),(21564,1214),(21565,1215),(21566,1215),(21567,1215),(21568,1215),(21569,1215),(21570,1215),(21571,1215),(21572,1216),(21573,1216),(21574,1216),(21575,1216),(21576,1216),(21577,1216),(21578,1217),(21579,1217),(21580,1217),(21581,1217),(21582,1217),(21583,1217),(21584,1217),(21585,1218),(21586,1218),(21587,1218),(21588,1218),(21589,1218),(21590,1218),(21591,1218),(21592,1219),(21593,1219),(21594,1219),(21595,1219),(21596,1219),(21597,1219),(21598,1219),(21599,1220),(21600,1220),(21601,1220),(21602,1220),(21603,1220),(21604,1220),(21605,1220),(21606,1221),(21607,1221),(21608,1221),(21609,1221),(21610,1221),(21611,1221),(21612,1221),(21613,1222),(21614,1222),(21615,1222),(21616,1222),(21617,1222),(21618,1222),(21619,1222),(21620,1223),(21621,1223),(21622,1223),(21623,1223),(21624,1223),(21625,1223),(21626,1223),(21627,1224),(21628,1224),(21629,1224),(21630,1224),(21631,1224),(21632,1224),(21633,1224),(21634,1225),(21635,1225),(21636,1225),(21637,1225),(21638,1225),(21639,1225),(21640,1225),(21641,1226),(21642,1226),(21643,1226),(21644,1226),(21645,1226),(21646,1226),(21647,1226),(21648,1227),(21649,1227),(21650,1227),(21651,1227),(21652,1227),(21653,1227),(21654,1227),(21655,1228),(21656,1228),(21657,1228),(21658,1228),(21659,1228),(21660,1228),(21661,1228),(21662,1229),(21663,1229),(21664,1229),(21665,1229),(21666,1229),(21667,1229),(21668,1229),(21669,1230),(21670,1230),(21671,1230),(21672,1230),(21673,1230),(21674,1230),(21675,1230),(21676,1231),(21677,1231),(21678,1231),(21679,1231),(21680,1231),(21681,1231),(21682,1231),(21683,1232),(21684,1232),(21685,1232),(21686,1232),(21687,1232),(21688,1232),(21689,1232),(21690,1233),(21691,1233),(21692,1233),(21693,1233),(21694,1233),(21695,1233),(21696,1233),(21697,1234),(21698,1234),(21699,1234),(21700,1234),(21701,1234),(21702,1234),(21703,1234),(21704,1235),(21705,1235),(21706,1235),(21707,1235),(21708,1235),(21709,1235),(21710,1235),(21711,1236),(21712,1236),(21713,1236),(21714,1236),(21715,1236),(21716,1236),(21717,1236),(21718,1237),(21719,1237),(21720,1237),(21721,1237),(21722,1237),(21723,1237),(21724,1237),(21725,1238),(21726,1238),(21727,1238),(21728,1238),(21729,1238),(21730,1238),(21731,1238),(21732,1239),(21733,1239),(21734,1239),(21735,1239),(21736,1239),(21737,1239),(21738,1239),(21739,1240),(21740,1240),(21741,1240),(21742,1240),(21743,1240),(21744,1240),(21745,1240),(21746,1241),(21747,1241),(21748,1241),(21749,1241),(21750,1241),(21751,1241),(21752,1241),(21753,1242),(21754,1242),(21755,1242),(21756,1242),(21757,1242),(21758,1242),(21759,1242),(21760,1243),(21761,1243),(21762,1243),(21763,1243),(21764,1243),(21765,1243),(21766,1243),(21767,1244),(21768,1244),(21769,1244),(21770,1244),(21771,1244),(21772,1244),(21773,1244),(21774,1245),(21775,1245),(21776,1245),(21777,1245),(21778,1245),(21779,1245),(21780,1245),(21781,1246),(21782,1246),(21783,1246),(21784,1246),(21785,1246),(21786,1246),(21787,1246),(21788,1247),(21789,1247),(21790,1247),(21791,1247),(21792,1247),(21793,1247),(21794,1247),(21795,1248),(21796,1248),(21797,1248),(21798,1248),(21799,1248),(21800,1248),(21801,1248),(21802,1249),(21803,1249),(21804,1249),(21805,1249),(21806,1249),(21807,1249),(21808,1249),(21809,1250),(21810,1250),(21811,1250),(21812,1250),(21813,1250),(21814,1250),(21815,1250),(21816,1251),(21817,1251),(21818,1251),(21819,1251),(21820,1251),(21821,1251),(21822,1251),(21823,1252),(21824,1252),(21825,1252),(21826,1252),(21827,1252),(21828,1252),(21829,1252),(21830,1253),(21831,1253),(21832,1253),(21833,1253),(21834,1253),(21835,1253),(21836,1253),(21837,1254),(21838,1254),(21839,1254),(21840,1254),(21841,1254),(21842,1254),(21843,1254),(21844,1255),(21845,1255),(21846,1255),(21847,1255),(21848,1255),(21849,1255),(21850,1255),(21851,1256),(21852,1256),(21853,1256),(21854,1256),(21855,1256),(21856,1256),(21857,1256),(21858,1257),(21859,1257),(21860,1257),(21861,1257),(21862,1257),(21863,1257),(21864,1257),(21865,1258),(21866,1258),(21867,1258),(21868,1258),(21869,1258),(21870,1258),(21871,1258),(21872,1259),(21873,1259),(21874,1259),(21875,1259),(21876,1259),(21877,1259),(21878,1259),(21879,1260),(21880,1260),(21881,1260),(21882,1260),(21883,1260),(21884,1260),(21885,1260),(21886,1261),(21887,1261),(21888,1261),(21889,1261),(21890,1261),(21891,1261),(21892,1261),(21893,1262),(21894,1262),(21895,1262),(21896,1262),(21897,1262),(21898,1262),(21899,1262),(21900,1263),(21901,1263),(21902,1263),(21903,1263),(21904,1263),(21905,1263),(21906,1263),(21907,1264),(21908,1264),(21909,1264),(21910,1264),(21911,1264),(21912,1264),(21913,1264),(21914,1265),(21915,1265),(21916,1265),(21917,1265),(21918,1265),(21919,1265),(21920,1265),(21921,1177),(21922,1177),(21923,1178),(21924,1178),(21925,1179),(21926,1179),(21927,1180),(21928,1180),(21929,1181),(21930,1181),(21931,1182),(21932,1183),(21933,1184),(21934,1184),(21935,1185),(21936,1185),(21937,1186),(21938,1186),(21939,1187),(21940,1187),(21941,1188),(21942,1188),(21943,1189),(21944,1189),(21945,1190),(21946,1190),(21947,1191),(21948,1191),(21949,1192),(21950,1192),(21951,1193),(21952,1193),(21953,1194),(21954,1194),(21955,1195),(21956,1195),(21957,1196),(21958,1196),(21959,1197),(21960,1197),(21961,1198),(21962,1198),(21963,1199),(21964,1199),(21965,1200),(21966,1200),(21967,1201),(21968,1201),(21969,1202),(21970,1202),(21971,1203),(21972,1203),(21973,1204),(21974,1204),(21975,1205),(21976,1205),(21977,1206),(21978,1206),(21979,1207),(21980,1207),(21981,1208),(21982,1208),(21983,1209),(21984,1209),(21985,1210),(21986,1210),(21987,1211),(21988,1211),(21989,1212),(21990,1212),(21991,1213),(21992,1213),(21993,1214),(21994,1214),(21995,1215),(21996,1215),(21997,1216),(21998,1216),(21999,1217),(22000,1217),(22001,1218),(22002,1218),(22003,1219),(22004,1219),(22005,1220),(22006,1220),(22007,1221),(22008,1221),(22009,1222),(22010,1222),(22011,1223),(22012,1223),(22013,1224),(22014,1224),(22015,1225),(22016,1225),(22017,1226),(22018,1226),(22019,1227),(22020,1227),(22021,1228),(22022,1228),(22023,1229),(22024,1229),(22025,1230),(22026,1230),(22027,1231),(22028,1231),(22029,1232),(22030,1232),(22031,1233),(22032,1233),(22033,1234),(22034,1234),(22035,1235),(22036,1235),(22037,1236),(22038,1236),(22039,1237),(22040,1237),(22041,1238),(22042,1238),(22043,1239),(22044,1239),(22045,1240),(22046,1240),(22047,1241),(22048,1241),(22049,1242),(22050,1242),(22051,1243),(22052,1243),(22053,1244),(22054,1244),(22055,1245),(22056,1245),(22057,1246),(22058,1246),(22059,1247),(22060,1247),(22061,1248),(22062,1248),(22063,1249),(22064,1249),(22065,1250),(22066,1250),(22067,1251),(22068,1251),(22069,1252),(22070,1252),(22071,1253),(22072,1253),(22073,1254),(22074,1254),(22075,1255),(22076,1255),(22077,1256),(22078,1256),(22079,1257),(22080,1257),(22081,1258),(22082,1258),(22083,1259),(22084,1259),(22085,1260),(22086,1260),(22087,1261),(22088,1261),(22089,1262),(22090,1262),(22091,1263),(22092,1263),(22093,1264),(22094,1264),(22095,1265),(22096,1265),(22097,1177),(22098,1177),(22099,1177),(22100,1178),(22101,1178),(22102,1178),(22103,1179),(22104,1179),(22105,1179),(22106,1180),(22107,1180),(22108,1180),(22109,1181),(22110,1181),(22111,1181),(22112,1182),(22113,1182),(22114,1182),(22115,1183),(22116,1183),(22117,1183),(22118,1184),(22119,1184),(22120,1184),(22121,1185),(22122,1185),(22123,1185),(22124,1186),(22125,1186),(22126,1186),(22127,1187),(22128,1187),(22129,1187),(22130,1188),(22131,1188),(22132,1188),(22133,1189),(22134,1189),(22135,1189),(22136,1190),(22137,1190),(22138,1190),(22139,1191),(22140,1191),(22141,1191),(22142,1192),(22143,1192),(22144,1192),(22145,1193),(22146,1193),(22147,1193),(22148,1194),(22149,1194),(22150,1194),(22151,1195),(22152,1195),(22153,1195),(22154,1196),(22155,1196),(22156,1196),(22157,1197),(22158,1197),(22159,1197),(22160,1198),(22161,1198),(22162,1198),(22163,1199),(22164,1199),(22165,1199),(22166,1200),(22167,1200),(22168,1200),(22169,1201),(22170,1201),(22171,1201),(22172,1202),(22173,1202),(22174,1202),(22175,1203),(22176,1203),(22177,1203),(22178,1204),(22179,1204),(22180,1204),(22181,1205),(22182,1205),(22183,1205),(22184,1206),(22185,1206),(22186,1206),(22187,1207),(22188,1207),(22189,1207),(22190,1208),(22191,1208),(22192,1208),(22193,1209),(22194,1209),(22195,1209),(22196,1210),(22197,1210),(22198,1210),(22199,1211),(22200,1211),(22201,1211),(22202,1212),(22203,1212),(22204,1212),(22205,1213),(22206,1213),(22207,1213),(22208,1214),(22209,1214),(22210,1214),(22211,1215),(22212,1215),(22213,1215),(22214,1216),(22215,1216),(22216,1216),(22217,1217),(22218,1217),(22219,1217),(22220,1218),(22221,1218),(22222,1218),(22223,1219),(22224,1219),(22225,1219),(22226,1220),(22227,1220),(22228,1220),(22229,1221),(22230,1221),(22231,1221),(22232,1222),(22233,1222),(22234,1222),(22235,1223),(22236,1223),(22237,1223),(22238,1224),(22239,1224),(22240,1224),(22241,1225),(22242,1225),(22243,1225),(22244,1226),(22245,1226),(22246,1226),(22247,1227),(22248,1227),(22249,1227),(22250,1228),(22251,1228),(22252,1228),(22253,1229),(22254,1229),(22255,1229),(22256,1230),(22257,1230),(22258,1230),(22259,1231),(22260,1231),(22261,1231),(22262,1232),(22263,1232),(22264,1232),(22265,1233),(22266,1233),(22267,1233),(22268,1234),(22269,1234),(22270,1234),(22271,1235),(22272,1235),(22273,1235),(22274,1236),(22275,1236),(22276,1236),(22277,1237),(22278,1237),(22279,1237),(22280,1238),(22281,1238),(22282,1238),(22283,1239),(22284,1239),(22285,1239),(22286,1240),(22287,1240),(22288,1240),(22289,1241),(22290,1241),(22291,1241),(22292,1242),(22293,1242),(22294,1242),(22295,1243),(22296,1243),(22297,1243),(22298,1244),(22299,1244),(22300,1244),(22301,1245),(22302,1245),(22303,1245),(22304,1246),(22305,1246),(22306,1246),(22307,1247),(22308,1247),(22309,1247),(22310,1248),(22311,1248),(22312,1248),(22313,1249),(22314,1249),(22315,1249),(22316,1250),(22317,1250),(22318,1250),(22319,1251),(22320,1251),(22321,1251),(22322,1252),(22323,1252),(22324,1252),(22325,1253),(22326,1253),(22327,1253),(22328,1254),(22329,1254),(22330,1254),(22331,1255),(22332,1255),(22333,1255),(22334,1256),(22335,1256),(22336,1256),(22337,1257),(22338,1257),(22339,1257),(22340,1258),(22341,1258),(22342,1258),(22343,1259),(22344,1259),(22345,1259),(22346,1260),(22347,1260),(22348,1260),(22349,1261),(22350,1261),(22351,1261),(22352,1262),(22353,1262),(22354,1262),(22355,1263),(22356,1263),(22357,1263),(22358,1264),(22359,1264),(22360,1264),(22361,1265),(22362,1265),(22363,1265),(22364,1177),(22365,1177),(22366,1177),(22367,1177),(22368,1178),(22369,1178),(22370,1178),(22371,1178),(22372,1179),(22373,1179),(22374,1179),(22375,1179),(22376,1180),(22377,1180),(22378,1180),(22379,1180),(22380,1181),(22381,1181),(22382,1181),(22383,1181),(22384,1182),(22385,1182),(22386,1182),(22387,1182),(22388,1183),(22389,1183),(22390,1183),(22391,1183),(22392,1184),(22393,1184),(22394,1184),(22395,1184),(22396,1185),(22397,1185),(22398,1185),(22399,1185),(22400,1186),(22401,1186),(22402,1186),(22403,1186),(22404,1187),(22405,1187),(22406,1187),(22407,1187),(22408,1188),(22409,1188),(22410,1188),(22411,1188),(22412,1189),(22413,1189),(22414,1189),(22415,1189),(22416,1190),(22417,1190),(22418,1190),(22419,1190),(22420,1191),(22421,1191),(22422,1191),(22423,1191),(22424,1192),(22425,1192),(22426,1192),(22427,1192),(22428,1193),(22429,1193),(22430,1193),(22431,1193),(22432,1194),(22433,1194),(22434,1194),(22435,1194),(22436,1195),(22437,1195),(22438,1195),(22439,1195),(22440,1196),(22441,1196),(22442,1196),(22443,1196),(22444,1197),(22445,1197),(22446,1197),(22447,1197),(22448,1198),(22449,1198),(22450,1198),(22451,1198),(22452,1199),(22453,1199),(22454,1199),(22455,1199),(22456,1200),(22457,1200),(22458,1200),(22459,1200),(22460,1201),(22461,1201),(22462,1201),(22463,1201),(22464,1202),(22465,1202),(22466,1202),(22467,1202),(22468,1203),(22469,1203),(22470,1203),(22471,1203),(22472,1204),(22473,1204),(22474,1204),(22475,1204),(22476,1205),(22477,1205),(22478,1205),(22479,1205),(22480,1206),(22481,1206),(22482,1206),(22483,1206),(22484,1207),(22485,1207),(22486,1207),(22487,1207),(22488,1208),(22489,1208),(22490,1208),(22491,1208),(22492,1209),(22493,1209),(22494,1209),(22495,1209),(22496,1210),(22497,1210),(22498,1210),(22499,1210),(22500,1211),(22501,1211),(22502,1211),(22503,1211),(22504,1212),(22505,1212),(22506,1212),(22507,1212),(22508,1213),(22509,1213),(22510,1213),(22511,1213),(22512,1214),(22513,1214),(22514,1214),(22515,1214),(22516,1215),(22517,1215),(22518,1215),(22519,1215),(22520,1216),(22521,1216),(22522,1216),(22523,1216),(22524,1217),(22525,1217),(22526,1217),(22527,1217),(22528,1218),(22529,1218),(22530,1218),(22531,1218),(22532,1219),(22533,1219),(22534,1219),(22535,1219),(22536,1220),(22537,1220),(22538,1220),(22539,1220),(22540,1221),(22541,1221),(22542,1221),(22543,1221),(22544,1222),(22545,1222),(22546,1222),(22547,1222),(22548,1223),(22549,1223),(22550,1223),(22551,1223),(22552,1224),(22553,1224),(22554,1224),(22555,1224),(22556,1225),(22557,1225),(22558,1225),(22559,1225),(22560,1226),(22561,1226),(22562,1226),(22563,1226),(22564,1227),(22565,1227),(22566,1227),(22567,1227),(22568,1228),(22569,1228),(22570,1228),(22571,1228),(22572,1229),(22573,1229),(22574,1229),(22575,1229),(22576,1230),(22577,1230),(22578,1230),(22579,1230),(22580,1231),(22581,1231),(22582,1231),(22583,1231),(22584,1232),(22585,1232),(22586,1232),(22587,1232),(22588,1233),(22589,1233),(22590,1233),(22591,1233),(22592,1234),(22593,1234),(22594,1234),(22595,1234),(22596,1235),(22597,1235),(22598,1235),(22599,1235),(22600,1236),(22601,1236),(22602,1236),(22603,1236),(22604,1237),(22605,1237),(22606,1237),(22607,1237),(22608,1238),(22609,1238),(22610,1238),(22611,1238),(22612,1239),(22613,1239),(22614,1239),(22615,1239),(22616,1240),(22617,1240),(22618,1240),(22619,1240),(22620,1241),(22621,1241),(22622,1241),(22623,1241),(22624,1242),(22625,1242),(22626,1242),(22627,1242),(22628,1243),(22629,1243),(22630,1243),(22631,1243),(22632,1244),(22633,1244),(22634,1244),(22635,1244),(22636,1245),(22637,1245),(22638,1245),(22639,1245),(22640,1246),(22641,1246),(22642,1246),(22643,1246),(22644,1247),(22645,1247),(22646,1247),(22647,1247),(22648,1248),(22649,1248),(22650,1248),(22651,1248),(22652,1249),(22653,1249),(22654,1249),(22655,1249),(22656,1250),(22657,1250),(22658,1250),(22659,1250),(22660,1251),(22661,1251),(22662,1251),(22663,1251),(22664,1252),(22665,1252),(22666,1252),(22667,1252),(22668,1253),(22669,1253),(22670,1253),(22671,1253),(22672,1254),(22673,1254),(22674,1254),(22675,1254),(22676,1255),(22677,1255),(22678,1255),(22679,1255),(22680,1256),(22681,1256),(22682,1256),(22683,1256),(22684,1257),(22685,1257),(22686,1257),(22687,1257),(22688,1258),(22689,1258),(22690,1258),(22691,1258),(22692,1259),(22693,1259),(22694,1259),(22695,1259),(22696,1260),(22697,1260),(22698,1260),(22699,1260),(22700,1261),(22701,1261),(22702,1261),(22703,1261),(22704,1262),(22705,1262),(22706,1262),(22707,1262),(22708,1263),(22709,1263),(22710,1263),(22711,1263),(22712,1264),(22713,1264),(22714,1264),(22715,1264),(22716,1265),(22717,1265),(22718,1265),(22719,1265),(22720,1266),(22721,1267),(22722,1268),(22723,1269),(22724,1270),(22725,1271),(22726,1272),(22727,1273),(22728,1274),(22729,1275),(22730,1276),(22731,1277),(22732,1278),(22733,1279),(22734,1280),(22735,1281),(22736,1282),(22737,1283),(22738,1284),(22739,1285),(22740,1286),(22741,1287),(22742,1288),(22743,1289),(22744,1290),(22745,1291),(22746,1292),(22747,1293),(22748,1294),(22749,1295),(22750,1296),(22751,1297),(22752,1298),(22753,1299),(22754,1300),(22755,1301),(22756,1302),(22757,1303),(22758,1304),(22759,1305),(22760,1306),(22761,1307),(22762,1308),(22763,1309),(22764,1310),(22765,1311),(22766,1312),(22767,1313),(22768,1314),(22769,1315),(22770,1316),(22771,1317),(22772,1318),(22773,1319),(22774,1320),(22775,1321),(22776,1322),(22777,1323),(22778,1324),(22779,1325),(22780,1326),(22781,1327),(22782,1328),(22783,1329),(22784,1330),(22785,1331),(22786,1332),(22787,1333),(22788,1334),(22789,1335),(22790,1336),(22791,1337),(22792,1338),(22793,1339),(22794,1340),(22795,1341),(22796,1342),(22797,1343),(22798,1344),(22799,1345),(22800,1346),(22801,1347),(22802,1348),(22803,1349),(22804,1350),(22805,1351),(22806,1352),(22807,1353),(22808,1354),(22809,1355),(22810,1356),(22811,1357),(22812,1358),(22813,1359),(22814,1360),(22815,1361),(22816,1362),(22817,1363),(22818,1364),(22819,1365),(22820,1266),(22821,1266),(22822,1266),(22823,1266),(22824,1266),(22825,1266),(22826,1266),(22827,1267),(22828,1267),(22829,1267),(22830,1267),(22831,1267),(22832,1267),(22833,1267),(22834,1268),(22835,1268),(22836,1268),(22837,1268),(22838,1268),(22839,1268),(22840,1268),(22841,1269),(22842,1269),(22843,1269),(22844,1269),(22845,1269),(22846,1269),(22847,1269),(22848,1270),(22849,1270),(22850,1270),(22851,1270),(22852,1270),(22853,1270),(22854,1270),(22855,1271),(22856,1271),(22857,1271),(22858,1271),(22859,1271),(22860,1271),(22861,1271),(22862,1272),(22863,1272),(22864,1272),(22865,1272),(22866,1272),(22867,1272),(22868,1272),(22869,1273),(22870,1273),(22871,1273),(22872,1273),(22873,1273),(22874,1273),(22875,1273),(22876,1274),(22877,1274),(22878,1274),(22879,1274),(22880,1274),(22881,1274),(22882,1274),(22883,1275),(22884,1275),(22885,1275),(22886,1275),(22887,1275),(22888,1275),(22889,1275),(22890,1276),(22891,1276),(22892,1276),(22893,1276),(22894,1276),(22895,1276),(22896,1276),(22897,1277),(22898,1277),(22899,1277),(22900,1277),(22901,1277),(22902,1277),(22903,1277),(22904,1278),(22905,1278),(22906,1278),(22907,1278),(22908,1278),(22909,1278),(22910,1278),(22911,1279),(22912,1279),(22913,1279),(22914,1279),(22915,1279),(22916,1279),(22917,1279),(22918,1280),(22919,1280),(22920,1280),(22921,1280),(22922,1280),(22923,1280),(22924,1280),(22925,1281),(22926,1281),(22927,1281),(22928,1281),(22929,1281),(22930,1281),(22931,1281),(22932,1282),(22933,1282),(22934,1282),(22935,1282),(22936,1282),(22937,1282),(22938,1282),(22939,1283),(22940,1283),(22941,1283),(22942,1283),(22943,1283),(22944,1283),(22945,1283),(22946,1284),(22947,1284),(22948,1284),(22949,1284),(22950,1284),(22951,1284),(22952,1284),(22953,1285),(22954,1285),(22955,1285),(22956,1285),(22957,1285),(22958,1285),(22959,1285),(22960,1286),(22961,1286),(22962,1286),(22963,1286),(22964,1286),(22965,1286),(22966,1286),(22967,1287),(22968,1287),(22969,1287),(22970,1287),(22971,1287),(22972,1287),(22973,1287),(22974,1288),(22975,1288),(22976,1288),(22977,1288),(22978,1288),(22979,1288),(22980,1288),(22981,1289),(22982,1289),(22983,1289),(22984,1289),(22985,1289),(22986,1289),(22987,1289),(22988,1290),(22989,1290),(22990,1290),(22991,1290),(22992,1290),(22993,1290),(22994,1290),(22995,1291),(22996,1291),(22997,1291),(22998,1291),(22999,1291),(23000,1291),(23001,1291),(23002,1292),(23003,1292),(23004,1292),(23005,1292),(23006,1292),(23007,1292),(23008,1292),(23009,1293),(23010,1293),(23011,1293),(23012,1293),(23013,1293),(23014,1293),(23015,1293),(23016,1294),(23017,1294),(23018,1294),(23019,1294),(23020,1294),(23021,1294),(23022,1294),(23023,1295),(23024,1295),(23025,1295),(23026,1295),(23027,1295),(23028,1295),(23029,1295),(23030,1296),(23031,1296),(23032,1296),(23033,1296),(23034,1296),(23035,1296),(23036,1296),(23037,1297),(23038,1297),(23039,1297),(23040,1297),(23041,1297),(23042,1297),(23043,1297),(23044,1298),(23045,1298),(23046,1298),(23047,1298),(23048,1298),(23049,1298),(23050,1298),(23051,1299),(23052,1299),(23053,1299),(23054,1299),(23055,1299),(23056,1299),(23057,1299),(23058,1300),(23059,1300),(23060,1300),(23061,1300),(23062,1300),(23063,1300),(23064,1300),(23065,1301),(23066,1301),(23067,1301),(23068,1301),(23069,1301),(23070,1301),(23071,1301),(23072,1302),(23073,1302),(23074,1302),(23075,1302),(23076,1302),(23077,1302),(23078,1302),(23079,1303),(23080,1303),(23081,1303),(23082,1303),(23083,1303),(23084,1303),(23085,1303),(23086,1304),(23087,1304),(23088,1304),(23089,1304),(23090,1304),(23091,1304),(23092,1304),(23093,1305),(23094,1305),(23095,1305),(23096,1305),(23097,1305),(23098,1305),(23099,1305),(23100,1306),(23101,1306),(23102,1306),(23103,1306),(23104,1306),(23105,1306),(23106,1306),(23107,1307),(23108,1307),(23109,1307),(23110,1307),(23111,1307),(23112,1307),(23113,1307),(23114,1308),(23115,1308),(23116,1308),(23117,1308),(23118,1308),(23119,1308),(23120,1308),(23121,1309),(23122,1309),(23123,1309),(23124,1309),(23125,1309),(23126,1309),(23127,1309),(23128,1310),(23129,1310),(23130,1310),(23131,1310),(23132,1310),(23133,1310),(23134,1310),(23135,1311),(23136,1311),(23137,1311),(23138,1311),(23139,1311),(23140,1311),(23141,1311),(23142,1312),(23143,1312),(23144,1312),(23145,1312),(23146,1312),(23147,1312),(23148,1312),(23149,1313),(23150,1313),(23151,1313),(23152,1313),(23153,1313),(23154,1313),(23155,1313),(23156,1314),(23157,1314),(23158,1314),(23159,1314),(23160,1314),(23161,1314),(23162,1314),(23163,1315),(23164,1315),(23165,1315),(23166,1315),(23167,1315),(23168,1315),(23169,1315),(23170,1316),(23171,1316),(23172,1316),(23173,1316),(23174,1316),(23175,1316),(23176,1316),(23177,1317),(23178,1317),(23179,1317),(23180,1317),(23181,1317),(23182,1317),(23183,1317),(23184,1318),(23185,1318),(23186,1318),(23187,1318),(23188,1318),(23189,1318),(23190,1318),(23191,1319),(23192,1319),(23193,1319),(23194,1319),(23195,1319),(23196,1319),(23197,1319),(23198,1320),(23199,1320),(23200,1320),(23201,1320),(23202,1320),(23203,1320),(23204,1320),(23205,1321),(23206,1321),(23207,1321),(23208,1321),(23209,1321),(23210,1321),(23211,1321),(23212,1322),(23213,1322),(23214,1322),(23215,1322),(23216,1322),(23217,1322),(23218,1322),(23219,1323),(23220,1323),(23221,1323),(23222,1323),(23223,1323),(23224,1323),(23225,1323),(23226,1324),(23227,1324),(23228,1324),(23229,1324),(23230,1324),(23231,1324),(23232,1324),(23233,1325),(23234,1325),(23235,1325),(23236,1325),(23237,1325),(23238,1325),(23239,1325),(23240,1326),(23241,1326),(23242,1326),(23243,1326),(23244,1326),(23245,1326),(23246,1326),(23247,1327),(23248,1327),(23249,1327),(23250,1327),(23251,1327),(23252,1327),(23253,1327),(23254,1328),(23255,1328),(23256,1328),(23257,1328),(23258,1328),(23259,1328),(23260,1328),(23261,1329),(23262,1329),(23263,1329),(23264,1329),(23265,1329),(23266,1329),(23267,1329),(23268,1330),(23269,1330),(23270,1330),(23271,1330),(23272,1330),(23273,1330),(23274,1330),(23275,1331),(23276,1331),(23277,1331),(23278,1331),(23279,1331),(23280,1331),(23281,1331),(23282,1332),(23283,1332),(23284,1332),(23285,1332),(23286,1332),(23287,1332),(23288,1332),(23289,1333),(23290,1333),(23291,1333),(23292,1333),(23293,1333),(23294,1333),(23295,1333),(23296,1334),(23297,1334),(23298,1334),(23299,1334),(23300,1334),(23301,1334),(23302,1334),(23303,1335),(23304,1335),(23305,1335),(23306,1335),(23307,1335),(23308,1335),(23309,1335),(23310,1336),(23311,1336),(23312,1336),(23313,1336),(23314,1336),(23315,1336),(23316,1336),(23317,1337),(23318,1337),(23319,1337),(23320,1337),(23321,1337),(23322,1337),(23323,1337),(23324,1338),(23325,1338),(23326,1338),(23327,1338),(23328,1338),(23329,1338),(23330,1338),(23331,1339),(23332,1339),(23333,1339),(23334,1339),(23335,1339),(23336,1339),(23337,1339),(23338,1340),(23339,1340),(23340,1340),(23341,1340),(23342,1340),(23343,1340),(23344,1340),(23345,1341),(23346,1341),(23347,1341),(23348,1341),(23349,1341),(23350,1341),(23351,1341),(23352,1342),(23353,1342),(23354,1342),(23355,1342),(23356,1342),(23357,1342),(23358,1342),(23359,1343),(23360,1343),(23361,1343),(23362,1343),(23363,1343),(23364,1343),(23365,1343),(23366,1344),(23367,1344),(23368,1344),(23369,1344),(23370,1344),(23371,1344),(23372,1344),(23373,1345),(23374,1345),(23375,1345),(23376,1345),(23377,1345),(23378,1345),(23379,1345),(23380,1346),(23381,1346),(23382,1346),(23383,1346),(23384,1346),(23385,1346),(23386,1346),(23387,1347),(23388,1347),(23389,1347),(23390,1347),(23391,1347),(23392,1347),(23393,1347),(23394,1348),(23395,1348),(23396,1348),(23397,1348),(23398,1348),(23399,1348),(23400,1348),(23401,1349),(23402,1349),(23403,1349),(23404,1349),(23405,1349),(23406,1349),(23407,1349),(23408,1350),(23409,1350),(23410,1350),(23411,1350),(23412,1350),(23413,1350),(23414,1350),(23415,1351),(23416,1351),(23417,1351),(23418,1351),(23419,1351),(23420,1351),(23421,1351),(23422,1352),(23423,1352),(23424,1352),(23425,1352),(23426,1352),(23427,1352),(23428,1352),(23429,1353),(23430,1353),(23431,1353),(23432,1353),(23433,1353),(23434,1353),(23435,1353),(23436,1354),(23437,1354),(23438,1354),(23439,1354),(23440,1354),(23441,1354),(23442,1354),(23443,1355),(23444,1355),(23445,1355),(23446,1355),(23447,1355),(23448,1355),(23449,1355),(23450,1356),(23451,1356),(23452,1356),(23453,1356),(23454,1356),(23455,1356),(23456,1356),(23457,1357),(23458,1357),(23459,1357),(23460,1357),(23461,1357),(23462,1357),(23463,1357),(23464,1358),(23465,1358),(23466,1358),(23467,1358),(23468,1358),(23469,1358),(23470,1358),(23471,1359),(23472,1359),(23473,1359),(23474,1359),(23475,1359),(23476,1359),(23477,1359),(23478,1360),(23479,1360),(23480,1360),(23481,1360),(23482,1360),(23483,1360),(23484,1360),(23485,1361),(23486,1361),(23487,1361),(23488,1361),(23489,1361),(23490,1361),(23491,1361),(23492,1362),(23493,1362),(23494,1362),(23495,1362),(23496,1362),(23497,1362),(23498,1362),(23499,1363),(23500,1363),(23501,1363),(23502,1363),(23503,1363),(23504,1363),(23505,1363),(23506,1364),(23507,1364),(23508,1364),(23509,1364),(23510,1364),(23511,1364),(23512,1364),(23513,1365),(23514,1365),(23515,1365),(23516,1365),(23517,1365),(23518,1365),(23519,1365),(23520,1266),(23521,1266),(23522,1267),(23523,1267),(23524,1268),(23525,1268),(23526,1269),(23527,1269),(23528,1270),(23529,1270),(23530,1271),(23531,1271),(23532,1272),(23533,1272),(23534,1273),(23535,1273),(23536,1274),(23537,1274),(23538,1275),(23539,1275),(23540,1276),(23541,1276),(23542,1277),(23543,1277),(23544,1278),(23545,1278),(23546,1279),(23547,1279),(23548,1280),(23549,1280),(23550,1281),(23551,1281),(23552,1282),(23553,1282),(23554,1283),(23555,1283),(23556,1284),(23557,1284),(23558,1285),(23559,1285),(23560,1286),(23561,1286),(23562,1287),(23563,1287),(23564,1288),(23565,1288),(23566,1289),(23567,1289),(23568,1290),(23569,1290),(23570,1291),(23571,1291),(23572,1292),(23573,1292),(23574,1293),(23575,1293),(23576,1294),(23577,1294),(23578,1295),(23579,1295),(23580,1296),(23581,1296),(23582,1297),(23583,1297),(23584,1298),(23585,1298),(23586,1299),(23587,1299),(23588,1300),(23589,1300),(23590,1301),(23591,1301),(23592,1302),(23593,1302),(23594,1303),(23595,1303),(23596,1304),(23597,1304),(23598,1305),(23599,1305),(23600,1306),(23601,1306),(23602,1307),(23603,1307),(23604,1308),(23605,1308),(23606,1309),(23607,1309),(23608,1310),(23609,1310),(23610,1311),(23611,1311),(23612,1312),(23613,1312),(23614,1313),(23615,1313),(23616,1314),(23617,1314),(23618,1315),(23619,1315),(23620,1316),(23621,1316),(23622,1317),(23623,1317),(23624,1318),(23625,1318),(23626,1319),(23627,1319),(23628,1320),(23629,1320),(23630,1321),(23631,1321),(23632,1322),(23633,1322),(23634,1323),(23635,1323),(23636,1324),(23637,1324),(23638,1325),(23639,1325),(23640,1326),(23641,1326),(23642,1327),(23643,1327),(23644,1328),(23645,1328),(23646,1329),(23647,1329),(23648,1330),(23649,1330),(23650,1331),(23651,1331),(23652,1332),(23653,1332),(23654,1333),(23655,1333),(23656,1334),(23657,1334),(23658,1335),(23659,1335),(23660,1336),(23661,1336),(23662,1337),(23663,1337),(23664,1338),(23665,1338),(23666,1339),(23667,1339),(23668,1340),(23669,1340),(23670,1341),(23671,1341),(23672,1342),(23673,1342),(23674,1343),(23675,1344),(23676,1344),(23677,1345),(23678,1345),(23679,1346),(23680,1346),(23681,1347),(23682,1347),(23683,1348),(23684,1348),(23685,1349),(23686,1349),(23687,1350),(23688,1350),(23689,1351),(23690,1351),(23691,1352),(23692,1352),(23693,1353),(23694,1353),(23695,1354),(23696,1354),(23697,1355),(23698,1355),(23699,1356),(23700,1356),(23701,1357),(23702,1357),(23703,1358),(23704,1358),(23705,1359),(23706,1359),(23707,1360),(23708,1360),(23709,1361),(23710,1361),(23711,1362),(23712,1362),(23713,1363),(23714,1363),(23715,1364),(23716,1364),(23717,1365),(23718,1365),(23719,1266),(23720,1266),(23721,1266),(23722,1267),(23723,1267),(23724,1267),(23725,1268),(23726,1268),(23727,1268),(23728,1269),(23729,1269),(23730,1269),(23731,1270),(23732,1270),(23733,1270),(23734,1271),(23735,1271),(23736,1271),(23737,1272),(23738,1272),(23739,1272),(23740,1273),(23741,1273),(23742,1273),(23743,1274),(23744,1274),(23745,1274),(23746,1275),(23747,1275),(23748,1275),(23749,1276),(23750,1276),(23751,1276),(23752,1277),(23753,1277),(23754,1277),(23755,1278),(23756,1278),(23757,1278),(23758,1279),(23759,1279),(23760,1279),(23761,1280),(23762,1280),(23763,1280),(23764,1281),(23765,1281),(23766,1281),(23767,1282),(23768,1282),(23769,1282),(23770,1283),(23771,1283),(23772,1283),(23773,1284),(23774,1284),(23775,1284),(23776,1285),(23777,1285),(23778,1285),(23779,1286),(23780,1286),(23781,1286),(23782,1287),(23783,1287),(23784,1287),(23785,1288),(23786,1288),(23787,1288),(23788,1289),(23789,1289),(23790,1289),(23791,1290),(23792,1290),(23793,1290),(23794,1291),(23795,1291),(23796,1291),(23797,1292),(23798,1292),(23799,1292),(23800,1293),(23801,1293),(23802,1293),(23803,1294),(23804,1294),(23805,1294),(23806,1295),(23807,1295),(23808,1295),(23809,1296),(23810,1296),(23811,1296),(23812,1297),(23813,1297),(23814,1297),(23815,1298),(23816,1298),(23817,1298),(23818,1299),(23819,1299),(23820,1299),(23821,1300),(23822,1300),(23823,1300),(23824,1301),(23825,1301),(23826,1301),(23827,1302),(23828,1302),(23829,1302),(23830,1303),(23831,1303),(23832,1303),(23833,1304),(23834,1304),(23835,1304),(23836,1305),(23837,1305),(23838,1305),(23839,1306),(23840,1306),(23841,1306),(23842,1307),(23843,1307),(23844,1307),(23845,1308),(23846,1308),(23847,1308),(23848,1309),(23849,1309),(23850,1309),(23851,1310),(23852,1310),(23853,1310),(23854,1311),(23855,1311),(23856,1311),(23857,1312),(23858,1312),(23859,1312),(23860,1313),(23861,1313),(23862,1313),(23863,1314),(23864,1314),(23865,1314),(23866,1315),(23867,1315),(23868,1315),(23869,1316),(23870,1316),(23871,1316),(23872,1317),(23873,1317),(23874,1317),(23875,1318),(23876,1318),(23877,1318),(23878,1319),(23879,1319),(23880,1319),(23881,1320),(23882,1320),(23883,1320),(23884,1321),(23885,1321),(23886,1321),(23887,1322),(23888,1322),(23889,1322),(23890,1323),(23891,1323),(23892,1323),(23893,1324),(23894,1324),(23895,1324),(23896,1325),(23897,1325),(23898,1325),(23899,1326),(23900,1326),(23901,1326),(23902,1327),(23903,1327),(23904,1327),(23905,1328),(23906,1328),(23907,1328),(23908,1329),(23909,1329),(23910,1329),(23911,1330),(23912,1330),(23913,1330),(23914,1331),(23915,1331),(23916,1331),(23917,1332),(23918,1332),(23919,1332),(23920,1333),(23921,1333),(23922,1333),(23923,1334),(23924,1334),(23925,1334),(23926,1335),(23927,1335),(23928,1335),(23929,1336),(23930,1336),(23931,1336),(23932,1337),(23933,1337),(23934,1337),(23935,1338),(23936,1338),(23937,1338),(23938,1339),(23939,1339),(23940,1339),(23941,1340),(23942,1340),(23943,1340),(23944,1341),(23945,1341),(23946,1341),(23947,1342),(23948,1342),(23949,1342),(23950,1343),(23951,1343),(23952,1343),(23953,1344),(23954,1344),(23955,1344),(23956,1345),(23957,1345),(23958,1345),(23959,1346),(23960,1346),(23961,1346),(23962,1347),(23963,1347),(23964,1347),(23965,1348),(23966,1348),(23967,1348),(23968,1349),(23969,1349),(23970,1349),(23971,1350),(23972,1350),(23973,1350),(23974,1351),(23975,1351),(23976,1351),(23977,1352),(23978,1352),(23979,1352),(23980,1353),(23981,1353),(23982,1353),(23983,1354),(23984,1354),(23985,1354),(23986,1355),(23987,1355),(23988,1355),(23989,1356),(23990,1356),(23991,1356),(23992,1357),(23993,1357),(23994,1357),(23995,1358),(23996,1358),(23997,1358),(23998,1359),(23999,1359),(24000,1359),(24001,1360),(24002,1360),(24003,1360),(24004,1361),(24005,1361),(24006,1361),(24007,1362),(24008,1362),(24009,1362),(24010,1363),(24011,1363),(24012,1363),(24013,1364),(24014,1364),(24015,1364),(24016,1365),(24017,1365),(24018,1365),(24019,1266),(24020,1266),(24021,1266),(24022,1266),(24023,1267),(24024,1267),(24025,1267),(24026,1267),(24027,1268),(24028,1268),(24029,1268),(24030,1268),(24031,1269),(24032,1269),(24033,1269),(24034,1269),(24035,1270),(24036,1270),(24037,1270),(24038,1270),(24039,1271),(24040,1271),(24041,1271),(24042,1271),(24043,1272),(24044,1272),(24045,1272),(24046,1272),(24047,1273),(24048,1273),(24049,1273),(24050,1273),(24051,1274),(24052,1274),(24053,1274),(24054,1274),(24055,1275),(24056,1275),(24057,1275),(24058,1275),(24059,1276),(24060,1276),(24061,1276),(24062,1276),(24063,1277),(24064,1277),(24065,1277),(24066,1277),(24067,1278),(24068,1278),(24069,1278),(24070,1278),(24071,1279),(24072,1279),(24073,1279),(24074,1279),(24075,1280),(24076,1280),(24077,1280),(24078,1280),(24079,1281),(24080,1281),(24081,1281),(24082,1281),(24083,1282),(24084,1282),(24085,1282),(24086,1282),(24087,1283),(24088,1283),(24089,1283),(24090,1283),(24091,1284),(24092,1284),(24093,1284),(24094,1284),(24095,1285),(24096,1285),(24097,1285),(24098,1285),(24099,1286),(24100,1286),(24101,1286),(24102,1286),(24103,1287),(24104,1287),(24105,1287),(24106,1287),(24107,1288),(24108,1288),(24109,1288),(24110,1288),(24111,1289),(24112,1289),(24113,1289),(24114,1289),(24115,1290),(24116,1290),(24117,1290),(24118,1290),(24119,1291),(24120,1291),(24121,1291),(24122,1291),(24123,1292),(24124,1292),(24125,1292),(24126,1292),(24127,1293),(24128,1293),(24129,1293),(24130,1293),(24131,1294),(24132,1294),(24133,1294),(24134,1294),(24135,1295),(24136,1295),(24137,1295),(24138,1295),(24139,1296),(24140,1296),(24141,1296),(24142,1296),(24143,1297),(24144,1297),(24145,1297),(24146,1297),(24147,1298),(24148,1298),(24149,1298),(24150,1298),(24151,1299),(24152,1299),(24153,1299),(24154,1299),(24155,1300),(24156,1300),(24157,1300),(24158,1300),(24159,1301),(24160,1301),(24161,1301),(24162,1301),(24163,1302),(24164,1302),(24165,1302),(24166,1302),(24167,1303),(24168,1303),(24169,1303),(24170,1303),(24171,1304),(24172,1304),(24173,1304),(24174,1304),(24175,1305),(24176,1305),(24177,1305),(24178,1305),(24179,1306),(24180,1306),(24181,1306),(24182,1306),(24183,1307),(24184,1307),(24185,1307),(24186,1307),(24187,1308),(24188,1308),(24189,1308),(24190,1308),(24191,1309),(24192,1309),(24193,1309),(24194,1309),(24195,1310),(24196,1310),(24197,1310),(24198,1310),(24199,1311),(24200,1311),(24201,1311),(24202,1311),(24203,1312),(24204,1312),(24205,1312),(24206,1312),(24207,1313),(24208,1313),(24209,1313),(24210,1313),(24211,1314),(24212,1314),(24213,1314),(24214,1314),(24215,1315),(24216,1315),(24217,1315),(24218,1315),(24219,1316),(24220,1316),(24221,1316),(24222,1316),(24223,1317),(24224,1317),(24225,1317),(24226,1317),(24227,1318),(24228,1318),(24229,1318),(24230,1318),(24231,1319),(24232,1319),(24233,1319),(24234,1319),(24235,1320),(24236,1320),(24237,1320),(24238,1320),(24239,1321),(24240,1321),(24241,1321),(24242,1321),(24243,1322),(24244,1322),(24245,1322),(24246,1322),(24247,1323),(24248,1323),(24249,1323),(24250,1323),(24251,1324),(24252,1324),(24253,1324),(24254,1324),(24255,1325),(24256,1325),(24257,1325),(24258,1325),(24259,1326),(24260,1326),(24261,1326),(24262,1326),(24263,1327),(24264,1327),(24265,1327),(24266,1327),(24267,1328),(24268,1328),(24269,1328),(24270,1328),(24271,1329),(24272,1329),(24273,1329),(24274,1329),(24275,1330),(24276,1330),(24277,1330),(24278,1330),(24279,1331),(24280,1331),(24281,1331),(24282,1331),(24283,1332),(24284,1332),(24285,1332),(24286,1332),(24287,1333),(24288,1333),(24289,1333),(24290,1333),(24291,1334),(24292,1334),(24293,1334),(24294,1334),(24295,1335),(24296,1335),(24297,1335),(24298,1335),(24299,1336),(24300,1336),(24301,1336),(24302,1336),(24303,1337),(24304,1337),(24305,1337),(24306,1337),(24307,1338),(24308,1338),(24309,1338),(24310,1338),(24311,1339),(24312,1339),(24313,1339),(24314,1339),(24315,1340),(24316,1340),(24317,1340),(24318,1340),(24319,1341),(24320,1341),(24321,1341),(24322,1341),(24323,1342),(24324,1342),(24325,1342),(24326,1342),(24327,1343),(24328,1343),(24329,1343),(24330,1343),(24331,1344),(24332,1344),(24333,1344),(24334,1344),(24335,1345),(24336,1345),(24337,1345),(24338,1345),(24339,1346),(24340,1346),(24341,1346),(24342,1346),(24343,1347),(24344,1347),(24345,1347),(24346,1347),(24347,1348),(24348,1348),(24349,1348),(24350,1348),(24351,1349),(24352,1349),(24353,1349),(24354,1349),(24355,1350),(24356,1350),(24357,1350),(24358,1350),(24359,1351),(24360,1351),(24361,1351),(24362,1351),(24363,1352),(24364,1352),(24365,1352),(24366,1352),(24367,1353),(24368,1353),(24369,1353),(24370,1353),(24371,1354),(24372,1354),(24373,1354),(24374,1354),(24375,1355),(24376,1355),(24377,1355),(24378,1355),(24379,1356),(24380,1356),(24381,1356),(24382,1356),(24383,1357),(24384,1357),(24385,1357),(24386,1357),(24387,1358),(24388,1358),(24389,1358),(24390,1358),(24391,1359),(24392,1359),(24393,1359),(24394,1359),(24395,1360),(24396,1360),(24397,1360),(24398,1360),(24399,1361),(24400,1361),(24401,1361),(24402,1361),(24403,1362),(24404,1362),(24405,1362),(24406,1362),(24407,1363),(24408,1363),(24409,1363),(24410,1363),(24411,1364),(24412,1364),(24413,1364),(24414,1364),(24415,1365),(24416,1365),(24417,1365),(24418,1365),(24419,1366),(24420,1367),(24421,1368),(24422,1369),(24423,1370),(24424,1371),(24425,1372),(24426,1373),(24427,1374),(24428,1375),(24429,1376),(24430,1377),(24431,1378),(24432,1379),(24433,1380),(24434,1381),(24435,1382),(24436,1383),(24437,1384),(24438,1385),(24439,1386),(24440,1387),(24441,1388),(24442,1389),(24443,1390),(24444,1391),(24445,1392),(24446,1393),(24447,1394),(24448,1395),(24449,1396),(24450,1397),(24451,1398),(24452,1399),(24453,1400),(24454,1401),(24455,1402),(24456,1403),(24457,1404),(24458,1405),(24459,1406),(24460,1407),(24461,1408),(24462,1409),(24463,1410),(24464,1411),(24465,1412),(24466,1413),(24467,1414),(24468,1415),(24469,1416),(24470,1417),(24471,1418),(24472,1419),(24473,1420),(24474,1421),(24475,1422),(24476,1423),(24477,1424),(24478,1425),(24479,1426),(24480,1427),(24481,1428),(24482,1429),(24483,1430),(24484,1431),(24485,1432),(24486,1433),(24487,1434),(24488,1435),(24489,1436),(24490,1437),(24491,1438),(24492,1439),(24493,1440),(24494,1441),(24495,1442),(24496,1443),(24497,1444),(24498,1445),(24499,1446),(24500,1447),(24501,1448),(24502,1449),(24503,1450),(24504,1451),(24505,1452),(24506,1453),(24507,1454),(24508,1455),(24509,1456),(24510,1457),(24511,1458),(24512,1459),(24513,1460),(24514,1461),(24515,1462),(24516,1463),(24517,1464),(24518,1465),(24519,1366),(24520,1366),(24521,1366),(24522,1366),(24523,1366),(24524,1366),(24525,1366),(24526,1367),(24527,1367),(24528,1367),(24529,1367),(24530,1367),(24531,1367),(24532,1367),(24533,1368),(24534,1368),(24535,1368),(24536,1368),(24537,1368),(24538,1368),(24539,1368),(24540,1369),(24541,1369),(24542,1369),(24543,1369),(24544,1369),(24545,1369),(24546,1369),(24547,1370),(24548,1370),(24549,1370),(24550,1370),(24551,1370),(24552,1370),(24553,1370),(24554,1371),(24555,1371),(24556,1371),(24557,1371),(24558,1371),(24559,1371),(24560,1371),(24561,1372),(24562,1372),(24563,1372),(24564,1372),(24565,1372),(24566,1372),(24567,1372),(24568,1373),(24569,1373),(24570,1373),(24571,1373),(24572,1373),(24573,1373),(24574,1373),(24575,1374),(24576,1374),(24577,1374),(24578,1374),(24579,1374),(24580,1374),(24581,1374),(24582,1375),(24583,1375),(24584,1375),(24585,1375),(24586,1375),(24587,1375),(24588,1375),(24589,1376),(24590,1376),(24591,1376),(24592,1376),(24593,1376),(24594,1376),(24595,1376),(24596,1377),(24597,1377),(24598,1377),(24599,1377),(24600,1377),(24601,1377),(24602,1377),(24603,1378),(24604,1378),(24605,1378),(24606,1378),(24607,1378),(24608,1378),(24609,1378),(24610,1379),(24611,1379),(24612,1379),(24613,1379),(24614,1379),(24615,1379),(24616,1379),(24617,1380),(24618,1380),(24619,1380),(24620,1380),(24621,1380),(24622,1380),(24623,1380),(24624,1381),(24625,1381),(24626,1381),(24627,1381),(24628,1381),(24629,1381),(24630,1381),(24631,1382),(24632,1382),(24633,1382),(24634,1382),(24635,1382),(24636,1382),(24637,1382),(24638,1383),(24639,1383),(24640,1383),(24641,1383),(24642,1383),(24643,1383),(24644,1383),(24645,1384),(24646,1384),(24647,1384),(24648,1384),(24649,1384),(24650,1384),(24651,1384),(24652,1385),(24653,1385),(24654,1385),(24655,1385),(24656,1385),(24657,1385),(24658,1385),(24659,1386),(24660,1386),(24661,1386),(24662,1386),(24663,1386),(24664,1386),(24665,1386),(24666,1387),(24667,1387),(24668,1387),(24669,1387),(24670,1387),(24671,1387),(24672,1387),(24673,1388),(24674,1388),(24675,1388),(24676,1388),(24677,1388),(24678,1388),(24679,1388),(24680,1389),(24681,1389),(24682,1389),(24683,1389),(24684,1389),(24685,1389),(24686,1389),(24687,1390),(24688,1390),(24689,1390),(24690,1390),(24691,1390),(24692,1390),(24693,1390),(24694,1391),(24695,1391),(24696,1391),(24697,1391),(24698,1391),(24699,1391),(24700,1391),(24701,1392),(24702,1392),(24703,1392),(24704,1392),(24705,1392),(24706,1392),(24707,1392),(24708,1393),(24709,1393),(24710,1393),(24711,1393),(24712,1393),(24713,1393),(24714,1393),(24715,1394),(24716,1394),(24717,1394),(24718,1394),(24719,1394),(24720,1394),(24721,1394),(24722,1395),(24723,1395),(24724,1395),(24725,1395),(24726,1395),(24727,1395),(24728,1395),(24729,1396),(24730,1396),(24731,1396),(24732,1396),(24733,1396),(24734,1396),(24735,1396),(24736,1397),(24737,1397),(24738,1397),(24739,1397),(24740,1397),(24741,1397),(24742,1397),(24743,1398),(24744,1398),(24745,1398),(24746,1398),(24747,1398),(24748,1398),(24749,1398),(24750,1399),(24751,1399),(24752,1399),(24753,1399),(24754,1399),(24755,1399),(24756,1399),(24757,1400),(24758,1400),(24759,1400),(24760,1400),(24761,1400),(24762,1400),(24763,1400),(24764,1401),(24765,1401),(24766,1401),(24767,1401),(24768,1401),(24769,1401),(24770,1401),(24771,1402),(24772,1402),(24773,1402),(24774,1402),(24775,1402),(24776,1402),(24777,1402),(24778,1403),(24779,1403),(24780,1403),(24781,1403),(24782,1403),(24783,1403),(24784,1403),(24785,1404),(24786,1404),(24787,1404),(24788,1404),(24789,1404),(24790,1404),(24791,1404),(24792,1405),(24793,1405),(24794,1405),(24795,1405),(24796,1405),(24797,1405),(24798,1405),(24799,1406),(24800,1406),(24801,1406),(24802,1406),(24803,1406),(24804,1406),(24805,1406),(24806,1407),(24807,1407),(24808,1407),(24809,1407),(24810,1407),(24811,1407),(24812,1407),(24813,1408),(24814,1408),(24815,1408),(24816,1408),(24817,1408),(24818,1408),(24819,1408),(24820,1409),(24821,1409),(24822,1409),(24823,1409),(24824,1409),(24825,1409),(24826,1409),(24827,1410),(24828,1410),(24829,1410),(24830,1410),(24831,1410),(24832,1410),(24833,1410),(24834,1411),(24835,1411),(24836,1411),(24837,1411),(24838,1411),(24839,1411),(24840,1411),(24841,1412),(24842,1412),(24843,1412),(24844,1412),(24845,1412),(24846,1412),(24847,1412),(24848,1413),(24849,1413),(24850,1413),(24851,1413),(24852,1413),(24853,1413),(24854,1413),(24855,1414),(24856,1414),(24857,1414),(24858,1414),(24859,1414),(24860,1414),(24861,1414),(24862,1415),(24863,1415),(24864,1415),(24865,1415),(24866,1415),(24867,1415),(24868,1415),(24869,1416),(24870,1416),(24871,1416),(24872,1416),(24873,1416),(24874,1416),(24875,1416),(24876,1417),(24877,1417),(24878,1417),(24879,1417),(24880,1417),(24881,1417),(24882,1417),(24883,1418),(24884,1418),(24885,1418),(24886,1418),(24887,1418),(24888,1418),(24889,1418),(24890,1419),(24891,1419),(24892,1419),(24893,1419),(24894,1419),(24895,1419),(24896,1419),(24897,1420),(24898,1420),(24899,1420),(24900,1420),(24901,1420),(24902,1420),(24903,1420),(24904,1421),(24905,1421),(24906,1421),(24907,1421),(24908,1421),(24909,1421),(24910,1421),(24911,1422),(24912,1422),(24913,1422),(24914,1422),(24915,1422),(24916,1422),(24917,1422),(24918,1423),(24919,1423),(24920,1423),(24921,1423),(24922,1423),(24923,1423),(24924,1423),(24925,1424),(24926,1424),(24927,1424),(24928,1424),(24929,1424),(24930,1424),(24931,1424),(24932,1425),(24933,1425),(24934,1425),(24935,1425),(24936,1425),(24937,1425),(24938,1425),(24939,1426),(24940,1426),(24941,1426),(24942,1426),(24943,1426),(24944,1426),(24945,1426),(24946,1427),(24947,1427),(24948,1427),(24949,1427),(24950,1427),(24951,1427),(24952,1427),(24953,1428),(24954,1428),(24955,1428),(24956,1428),(24957,1428),(24958,1428),(24959,1428),(24960,1429),(24961,1429),(24962,1429),(24963,1429),(24964,1429),(24965,1429),(24966,1429),(24967,1430),(24968,1430),(24969,1430),(24970,1430),(24971,1430),(24972,1430),(24973,1430),(24974,1431),(24975,1431),(24976,1431),(24977,1431),(24978,1431),(24979,1431),(24980,1431),(24981,1432),(24982,1432),(24983,1432),(24984,1432),(24985,1432),(24986,1432),(24987,1432),(24988,1433),(24989,1433),(24990,1433),(24991,1433),(24992,1433),(24993,1433),(24994,1433),(24995,1434),(24996,1434),(24997,1434),(24998,1434),(24999,1434),(25000,1434),(25001,1434),(25002,1435),(25003,1435),(25004,1435),(25005,1435),(25006,1435),(25007,1435),(25008,1435),(25009,1436),(25010,1436),(25011,1436),(25012,1436),(25013,1436),(25014,1436),(25015,1436),(25016,1437),(25017,1437),(25018,1437),(25019,1437),(25020,1437),(25021,1437),(25022,1437),(25023,1438),(25024,1438),(25025,1438),(25026,1438),(25027,1438),(25028,1438),(25029,1438),(25030,1439),(25031,1439),(25032,1439),(25033,1439),(25034,1439),(25035,1439),(25036,1439),(25037,1440),(25038,1440),(25039,1440),(25040,1440),(25041,1440),(25042,1440),(25043,1440),(25044,1441),(25045,1441),(25046,1441),(25047,1441),(25048,1441),(25049,1441),(25050,1441),(25051,1442),(25052,1442),(25053,1442),(25054,1442),(25055,1442),(25056,1442),(25057,1442),(25058,1443),(25059,1443),(25060,1443),(25061,1443),(25062,1443),(25063,1443),(25064,1443),(25065,1444),(25066,1444),(25067,1444),(25068,1444),(25069,1444),(25070,1444),(25071,1444),(25072,1445),(25073,1445),(25074,1445),(25075,1445),(25076,1445),(25077,1445),(25078,1445),(25079,1446),(25080,1446),(25081,1446),(25082,1446),(25083,1446),(25084,1446),(25085,1446),(25086,1447),(25087,1447),(25088,1447),(25089,1447),(25090,1447),(25091,1447),(25092,1447),(25093,1448),(25094,1448),(25095,1448),(25096,1448),(25097,1448),(25098,1448),(25099,1448),(25100,1449),(25101,1449),(25102,1449),(25103,1449),(25104,1449),(25105,1449),(25106,1449),(25107,1450),(25108,1450),(25109,1450),(25110,1450),(25111,1450),(25112,1450),(25113,1450),(25114,1451),(25115,1451),(25116,1451),(25117,1451),(25118,1451),(25119,1451),(25120,1451),(25121,1452),(25122,1452),(25123,1452),(25124,1452),(25125,1452),(25126,1452),(25127,1452),(25128,1453),(25129,1453),(25130,1453),(25131,1453),(25132,1453),(25133,1453),(25134,1453),(25135,1454),(25136,1454),(25137,1454),(25138,1454),(25139,1454),(25140,1454),(25141,1454),(25142,1455),(25143,1455),(25144,1455),(25145,1455),(25146,1455),(25147,1455),(25148,1455),(25149,1456),(25150,1456),(25151,1456),(25152,1456),(25153,1456),(25154,1456),(25155,1456),(25156,1457),(25157,1457),(25158,1457),(25159,1457),(25160,1457),(25161,1457),(25162,1457),(25163,1458),(25164,1458),(25165,1458),(25166,1458),(25167,1458),(25168,1458),(25169,1458),(25170,1459),(25171,1459),(25172,1459),(25173,1459),(25174,1459),(25175,1459),(25176,1459),(25177,1460),(25178,1460),(25179,1460),(25180,1460),(25181,1460),(25182,1460),(25183,1460),(25184,1461),(25185,1461),(25186,1461),(25187,1461),(25188,1461),(25189,1461),(25190,1461),(25191,1462),(25192,1462),(25193,1462),(25194,1462),(25195,1462),(25196,1462),(25197,1462),(25198,1463),(25199,1463),(25200,1463),(25201,1463),(25202,1463),(25203,1463),(25204,1463),(25205,1464),(25206,1464),(25207,1464),(25208,1464),(25209,1464),(25210,1464),(25211,1464),(25212,1465),(25213,1465),(25214,1465),(25215,1465),(25216,1465),(25217,1465),(25218,1465),(25219,1366),(25220,1366),(25221,1367),(25222,1367),(25223,1368),(25224,1368),(25225,1369),(25226,1369),(25227,1370),(25228,1370),(25229,1371),(25230,1371),(25231,1372),(25232,1372),(25233,1373),(25234,1373),(25235,1374),(25236,1374),(25237,1375),(25238,1375),(25239,1376),(25240,1376),(25241,1377),(25242,1377),(25243,1378),(25244,1378),(25245,1379),(25246,1379),(25247,1380),(25248,1380),(25249,1381),(25250,1381),(25251,1382),(25252,1382),(25253,1383),(25254,1383),(25255,1384),(25256,1384),(25257,1385),(25258,1385),(25259,1386),(25260,1386),(25261,1387),(25262,1387),(25263,1388),(25264,1388),(25265,1389),(25266,1389),(25267,1390),(25268,1390),(25269,1391),(25270,1391),(25271,1392),(25272,1392),(25273,1393),(25274,1393),(25275,1394),(25276,1394),(25277,1395),(25278,1395),(25279,1396),(25280,1396),(25281,1397),(25282,1397),(25283,1398),(25284,1398),(25285,1399),(25286,1399),(25287,1400),(25288,1400),(25289,1401),(25290,1401),(25291,1402),(25292,1402),(25293,1403),(25294,1403),(25295,1404),(25296,1404),(25297,1405),(25298,1405),(25299,1406),(25300,1406),(25301,1407),(25302,1407),(25303,1408),(25304,1408),(25305,1409),(25306,1409),(25307,1410),(25308,1410),(25309,1411),(25310,1411),(25311,1412),(25312,1412),(25313,1413),(25314,1413),(25315,1414),(25316,1414),(25317,1415),(25318,1415),(25319,1416),(25320,1416),(25321,1417),(25322,1417),(25323,1418),(25324,1418),(25325,1419),(25326,1419),(25327,1420),(25328,1420),(25329,1421),(25330,1421),(25331,1422),(25332,1422),(25333,1423),(25334,1423),(25335,1424),(25336,1424),(25337,1425),(25338,1425),(25339,1426),(25340,1426),(25341,1427),(25342,1427),(25343,1428),(25344,1428),(25345,1429),(25346,1429),(25347,1430),(25348,1430),(25349,1431),(25350,1431),(25351,1432),(25352,1432),(25353,1433),(25354,1433),(25355,1434),(25356,1434),(25357,1435),(25358,1435),(25359,1436),(25360,1436),(25361,1437),(25362,1437),(25363,1438),(25364,1438),(25365,1439),(25366,1439),(25367,1440),(25368,1440),(25369,1441),(25370,1441),(25371,1442),(25372,1442),(25373,1443),(25374,1443),(25375,1444),(25376,1444),(25377,1445),(25378,1445),(25379,1446),(25380,1446),(25381,1447),(25382,1447),(25383,1448),(25384,1448),(25385,1449),(25386,1449),(25387,1450),(25388,1450),(25389,1451),(25390,1451),(25391,1452),(25392,1452),(25393,1453),(25394,1453),(25395,1454),(25396,1454),(25397,1455),(25398,1455),(25399,1456),(25400,1456),(25401,1457),(25402,1457),(25403,1458),(25404,1458),(25405,1459),(25406,1459),(25407,1460),(25408,1460),(25409,1461),(25410,1461),(25411,1462),(25412,1462),(25413,1463),(25414,1463),(25415,1464),(25416,1464),(25417,1465),(25418,1465),(25419,1366),(25420,1366),(25421,1366),(25422,1367),(25423,1367),(25424,1367),(25425,1368),(25426,1368),(25427,1368),(25428,1369),(25429,1369),(25430,1369),(25431,1370),(25432,1370),(25433,1370),(25434,1371),(25435,1371),(25436,1371),(25437,1372),(25438,1372),(25439,1372),(25440,1373),(25441,1373),(25442,1373),(25443,1374),(25444,1374),(25445,1374),(25446,1375),(25447,1375),(25448,1375),(25449,1376),(25450,1376),(25451,1376),(25452,1377),(25453,1377),(25454,1377),(25455,1378),(25456,1378),(25457,1378),(25458,1379),(25459,1379),(25460,1379),(25461,1380),(25462,1380),(25463,1380),(25464,1381),(25465,1381),(25466,1381),(25467,1382),(25468,1382),(25469,1382),(25470,1383),(25471,1383),(25472,1383),(25473,1384),(25474,1384),(25475,1384),(25476,1385),(25477,1385),(25478,1385),(25479,1386),(25480,1386),(25481,1386),(25482,1387),(25483,1387),(25484,1387),(25485,1388),(25486,1388),(25487,1388),(25488,1389),(25489,1389),(25490,1389),(25491,1390),(25492,1390),(25493,1390),(25494,1391),(25495,1391),(25496,1391),(25497,1392),(25498,1392),(25499,1392),(25500,1393),(25501,1393),(25502,1393),(25503,1394),(25504,1394),(25505,1394),(25506,1395),(25507,1395),(25508,1395),(25509,1396),(25510,1396),(25511,1396),(25512,1397),(25513,1397),(25514,1397),(25515,1398),(25516,1398),(25517,1398),(25518,1399),(25519,1399),(25520,1399),(25521,1400),(25522,1400),(25523,1400),(25524,1401),(25525,1401),(25526,1401),(25527,1402),(25528,1402),(25529,1402),(25530,1403),(25531,1403),(25532,1403),(25533,1404),(25534,1404),(25535,1404),(25536,1405),(25537,1405),(25538,1405),(25539,1406),(25540,1406),(25541,1406),(25542,1407),(25543,1407),(25544,1407),(25545,1408),(25546,1408),(25547,1408),(25548,1409),(25549,1409),(25550,1409),(25551,1410),(25552,1410),(25553,1410),(25554,1411),(25555,1411),(25556,1411),(25557,1412),(25558,1412),(25559,1412),(25560,1413),(25561,1413),(25562,1413),(25563,1414),(25564,1414),(25565,1414),(25566,1415),(25567,1415),(25568,1415),(25569,1416),(25570,1416),(25571,1416),(25572,1417),(25573,1417),(25574,1417),(25575,1418),(25576,1418),(25577,1418),(25578,1419),(25579,1419),(25580,1419),(25581,1420),(25582,1420),(25583,1420),(25584,1421),(25585,1421),(25586,1421),(25587,1422),(25588,1422),(25589,1422),(25590,1423),(25591,1423),(25592,1423),(25593,1424),(25594,1424),(25595,1424),(25596,1425),(25597,1425),(25598,1425),(25599,1426),(25600,1426),(25601,1426),(25602,1427),(25603,1427),(25604,1427),(25605,1428),(25606,1428),(25607,1428),(25608,1429),(25609,1429),(25610,1429),(25611,1430),(25612,1430),(25613,1430),(25614,1431),(25615,1431),(25616,1431),(25617,1432),(25618,1432),(25619,1432),(25620,1433),(25621,1433),(25622,1433),(25623,1434),(25624,1434),(25625,1434),(25626,1435),(25627,1435),(25628,1435),(25629,1436),(25630,1436),(25631,1436),(25632,1437),(25633,1437),(25634,1437),(25635,1438),(25636,1438),(25637,1438),(25638,1439),(25639,1439),(25640,1439),(25641,1440),(25642,1440),(25643,1440),(25644,1441),(25645,1441),(25646,1441),(25647,1442),(25648,1442),(25649,1442),(25650,1443),(25651,1443),(25652,1443),(25653,1444),(25654,1444),(25655,1444),(25656,1445),(25657,1445),(25658,1445),(25659,1446),(25660,1446),(25661,1446),(25662,1447),(25663,1447),(25664,1447),(25665,1448),(25666,1448),(25667,1448),(25668,1449),(25669,1449),(25670,1449),(25671,1450),(25672,1450),(25673,1450),(25674,1451),(25675,1451),(25676,1451),(25677,1452),(25678,1452),(25679,1452),(25680,1453),(25681,1453),(25682,1453),(25683,1454),(25684,1454),(25685,1454),(25686,1455),(25687,1455),(25688,1455),(25689,1456),(25690,1456),(25691,1456),(25692,1457),(25693,1457),(25694,1457),(25695,1458),(25696,1458),(25697,1458),(25698,1459),(25699,1459),(25700,1459),(25701,1460),(25702,1460),(25703,1460),(25704,1461),(25705,1461),(25706,1461),(25707,1462),(25708,1462),(25709,1462),(25710,1463),(25711,1463),(25712,1463),(25713,1464),(25714,1464),(25715,1464),(25716,1465),(25717,1465),(25718,1465),(25719,1366),(25720,1366),(25721,1366),(25722,1366),(25723,1367),(25724,1367),(25725,1367),(25726,1367),(25727,1368),(25728,1368),(25729,1368),(25730,1368),(25731,1369),(25732,1369),(25733,1369),(25734,1369),(25735,1370),(25736,1370),(25737,1370),(25738,1370),(25739,1371),(25740,1371),(25741,1371),(25742,1371),(25743,1372),(25744,1372),(25745,1372),(25746,1372),(25747,1373),(25748,1373),(25749,1373),(25750,1373),(25751,1374),(25752,1374),(25753,1374),(25754,1374),(25755,1375),(25756,1375),(25757,1375),(25758,1375),(25759,1376),(25760,1376),(25761,1376),(25762,1376),(25763,1377),(25764,1377),(25765,1377),(25766,1377),(25767,1378),(25768,1378),(25769,1378),(25770,1378),(25771,1379),(25772,1379),(25773,1379),(25774,1379),(25775,1380),(25776,1380),(25777,1380),(25778,1380),(25779,1381),(25780,1381),(25781,1381),(25782,1381),(25783,1382),(25784,1382),(25785,1382),(25786,1382),(25787,1383),(25788,1383),(25789,1383),(25790,1383),(25791,1384),(25792,1384),(25793,1384),(25794,1384),(25795,1385),(25796,1385),(25797,1385),(25798,1385),(25799,1386),(25800,1386),(25801,1386),(25802,1386),(25803,1387),(25804,1387),(25805,1387),(25806,1387),(25807,1388),(25808,1388),(25809,1388),(25810,1388),(25811,1389),(25812,1389),(25813,1389),(25814,1389),(25815,1390),(25816,1390),(25817,1390),(25818,1390),(25819,1391),(25820,1391),(25821,1391),(25822,1391),(25823,1392),(25824,1392),(25825,1392),(25826,1392),(25827,1393),(25828,1393),(25829,1393),(25830,1393),(25831,1394),(25832,1394),(25833,1394),(25834,1394),(25835,1395),(25836,1395),(25837,1395),(25838,1395),(25839,1396),(25840,1396),(25841,1396),(25842,1396),(25843,1397),(25844,1397),(25845,1397),(25846,1397),(25847,1398),(25848,1398),(25849,1398),(25850,1398),(25851,1399),(25852,1399),(25853,1399),(25854,1399),(25855,1400),(25856,1400),(25857,1400),(25858,1400),(25859,1401),(25860,1401),(25861,1401),(25862,1401),(25863,1402),(25864,1402),(25865,1402),(25866,1402),(25867,1403),(25868,1403),(25869,1403),(25870,1403),(25871,1404),(25872,1404),(25873,1404),(25874,1404),(25875,1405),(25876,1405),(25877,1405),(25878,1405),(25879,1406),(25880,1406),(25881,1406),(25882,1406),(25883,1407),(25884,1407),(25885,1407),(25886,1407),(25887,1408),(25888,1408),(25889,1408),(25890,1408),(25891,1409),(25892,1409),(25893,1409),(25894,1409),(25895,1410),(25896,1410),(25897,1410),(25898,1410),(25899,1411),(25900,1411),(25901,1411),(25902,1411),(25903,1412),(25904,1412),(25905,1412),(25906,1412),(25907,1413),(25908,1413),(25909,1413),(25910,1413),(25911,1414),(25912,1414),(25913,1414),(25914,1414),(25915,1415),(25916,1415),(25917,1415),(25918,1415),(25919,1416),(25920,1416),(25921,1416),(25922,1416),(25923,1417),(25924,1417),(25925,1417),(25926,1417),(25927,1418),(25928,1418),(25929,1418),(25930,1418),(25931,1419),(25932,1419),(25933,1419),(25934,1419),(25935,1420),(25936,1420),(25937,1420),(25938,1420),(25939,1421),(25940,1421),(25941,1421),(25942,1421),(25943,1422),(25944,1422),(25945,1422),(25946,1422),(25947,1423),(25948,1423),(25949,1423),(25950,1423),(25951,1424),(25952,1424),(25953,1424),(25954,1424),(25955,1425),(25956,1425),(25957,1425),(25958,1425),(25959,1426),(25960,1426),(25961,1426),(25962,1426),(25963,1427),(25964,1427),(25965,1427),(25966,1427),(25967,1428),(25968,1428),(25969,1428),(25970,1428),(25971,1429),(25972,1429),(25973,1429),(25974,1429),(25975,1430),(25976,1430),(25977,1430),(25978,1430),(25979,1431),(25980,1431),(25981,1431),(25982,1431),(25983,1432),(25984,1432),(25985,1432),(25986,1432),(25987,1433),(25988,1433),(25989,1433),(25990,1433),(25991,1434),(25992,1434),(25993,1434),(25994,1434),(25995,1435),(25996,1435),(25997,1435),(25998,1435),(25999,1436),(26000,1436),(26001,1436),(26002,1436),(26003,1437),(26004,1437),(26005,1437),(26006,1437),(26007,1438),(26008,1438),(26009,1438),(26010,1438),(26011,1439),(26012,1439),(26013,1439),(26014,1439),(26015,1440),(26016,1440),(26017,1440),(26018,1440),(26019,1441),(26020,1441),(26021,1441),(26022,1441),(26023,1442),(26024,1442),(26025,1442),(26026,1442),(26027,1443),(26028,1443),(26029,1443),(26030,1443),(26031,1444),(26032,1444),(26033,1444),(26034,1444),(26035,1445),(26036,1445),(26037,1445),(26038,1445),(26039,1446),(26040,1446),(26041,1446),(26042,1446),(26043,1447),(26044,1447),(26045,1447),(26046,1447),(26047,1448),(26048,1448),(26049,1448),(26050,1448),(26051,1449),(26052,1449),(26053,1449),(26054,1449),(26055,1450),(26056,1450),(26057,1450),(26058,1450),(26059,1451),(26060,1451),(26061,1451),(26062,1451),(26063,1452),(26064,1452),(26065,1452),(26066,1452),(26067,1453),(26068,1453),(26069,1453),(26070,1453),(26071,1454),(26072,1454),(26073,1454),(26074,1454),(26075,1455),(26076,1455),(26077,1455),(26078,1455),(26079,1456),(26080,1456),(26081,1456),(26082,1456),(26083,1457),(26084,1457),(26085,1457),(26086,1457),(26087,1458),(26088,1458),(26089,1458),(26090,1458),(26091,1459),(26092,1459),(26093,1459),(26094,1459),(26095,1460),(26096,1460),(26097,1460),(26098,1460),(26099,1461),(26100,1461),(26101,1461),(26102,1461),(26103,1462),(26104,1462),(26105,1462),(26106,1462),(26107,1463),(26108,1463),(26109,1463),(26110,1463),(26111,1464),(26112,1464),(26113,1464),(26114,1464),(26115,1465),(26116,1465),(26117,1465),(26118,1465),(26119,1466),(26120,1467),(26121,1468),(26122,1469),(26123,1470),(26124,1471),(26125,1472),(26126,1473),(26127,1474),(26128,1475),(26129,1476),(26130,1477),(26131,1478),(26132,1479),(26133,1480),(26134,1481),(26135,1482),(26136,1483),(26137,1484),(26138,1485),(26139,1486),(26140,1487),(26141,1488),(26142,1489),(26143,1490),(26144,1491),(26145,1492),(26146,1493),(26147,1494),(26148,1495),(26149,1496),(26150,1497),(26151,1498),(26152,1499),(26153,1500),(26154,1501),(26155,1502),(26156,1503),(26157,1504),(26158,1505),(26159,1506),(26160,1507),(26161,1508),(26162,1509),(26163,1510),(26164,1511),(26165,1512),(26166,1513),(26167,1514),(26168,1515),(26169,1516),(26170,1517),(26171,1518),(26172,1519),(26173,1520),(26174,1521),(26175,1522),(26176,1523),(26177,1524),(26178,1525),(26179,1526),(26180,1527),(26181,1528),(26182,1529),(26183,1530),(26184,1531),(26185,1532),(26186,1533),(26187,1534),(26188,1535),(26189,1536),(26190,1537),(26191,1538),(26192,1539),(26193,1540),(26194,1541),(26195,1542),(26196,1543),(26197,1544),(26198,1545),(26199,1546),(26200,1547),(26201,1548),(26202,1549),(26203,1550),(26204,1551),(26205,1552),(26206,1553),(26207,1554),(26208,1555),(26209,1556),(26210,1557),(26211,1558),(26212,1559),(26213,1560),(26214,1561),(26215,1562),(26216,1563),(26217,1564),(26218,1565),(26219,1466),(26220,1466),(26221,1466),(26222,1466),(26223,1466),(26224,1466),(26225,1466),(26226,1467),(26227,1467),(26228,1467),(26229,1467),(26230,1467),(26231,1467),(26232,1467),(26233,1468),(26234,1468),(26235,1468),(26236,1468),(26237,1468),(26238,1468),(26239,1468),(26240,1469),(26241,1469),(26242,1469),(26243,1469),(26244,1469),(26245,1469),(26246,1469),(26247,1470),(26248,1470),(26249,1470),(26250,1470),(26251,1470),(26252,1470),(26253,1470),(26254,1471),(26255,1471),(26256,1471),(26257,1471),(26258,1471),(26259,1471),(26260,1471),(26261,1472),(26262,1472),(26263,1472),(26264,1472),(26265,1472),(26266,1472),(26267,1472),(26268,1473),(26269,1473),(26270,1473),(26271,1473),(26272,1473),(26273,1473),(26274,1473),(26275,1474),(26276,1474),(26277,1474),(26278,1474),(26279,1474),(26280,1474),(26281,1474),(26282,1475),(26283,1475),(26284,1475),(26285,1475),(26286,1475),(26287,1475),(26288,1475),(26289,1476),(26290,1476),(26291,1476),(26292,1476),(26293,1476),(26294,1476),(26295,1476),(26296,1477),(26297,1477),(26298,1477),(26299,1477),(26300,1477),(26301,1477),(26302,1477),(26303,1478),(26304,1478),(26305,1478),(26306,1478),(26307,1478),(26308,1478),(26309,1478),(26310,1479),(26311,1479),(26312,1479),(26313,1479),(26314,1479),(26315,1479),(26316,1479),(26317,1480),(26318,1480),(26319,1480),(26320,1480),(26321,1480),(26322,1480),(26323,1480),(26324,1481),(26325,1481),(26326,1481),(26327,1481),(26328,1481),(26329,1481),(26330,1481),(26331,1482),(26332,1482),(26333,1482),(26334,1482),(26335,1482),(26336,1482),(26337,1482),(26338,1483),(26339,1483),(26340,1483),(26341,1483),(26342,1483),(26343,1483),(26344,1483),(26345,1484),(26346,1484),(26347,1484),(26348,1484),(26349,1484),(26350,1484),(26351,1484),(26352,1485),(26353,1485),(26354,1485),(26355,1485),(26356,1485),(26357,1485),(26358,1485),(26359,1486),(26360,1486),(26361,1486),(26362,1486),(26363,1486),(26364,1486),(26365,1486),(26366,1487),(26367,1487),(26368,1487),(26369,1487),(26370,1487),(26371,1487),(26372,1487),(26373,1488),(26374,1488),(26375,1488),(26376,1488),(26377,1488),(26378,1488),(26379,1488),(26380,1489),(26381,1489),(26382,1489),(26383,1489),(26384,1489),(26385,1489),(26386,1489),(26387,1490),(26388,1490),(26389,1490),(26390,1490),(26391,1490),(26392,1490),(26393,1490),(26394,1491),(26395,1491),(26396,1491),(26397,1491),(26398,1491),(26399,1491),(26400,1491),(26401,1492),(26402,1492),(26403,1492),(26404,1492),(26405,1492),(26406,1492),(26407,1492),(26408,1493),(26409,1493),(26410,1493),(26411,1493),(26412,1493),(26413,1493),(26414,1493),(26415,1494),(26416,1494),(26417,1494),(26418,1494),(26419,1494),(26420,1494),(26421,1494),(26422,1495),(26423,1495),(26424,1495),(26425,1495),(26426,1495),(26427,1495),(26428,1495),(26429,1496),(26430,1496),(26431,1496),(26432,1496),(26433,1496),(26434,1496),(26435,1496),(26436,1496),(26437,1496),(26438,1497),(26439,1497),(26440,1497),(26441,1497),(26442,1497),(26443,1497),(26444,1497),(26445,1497),(26446,1497),(26447,1498),(26448,1498),(26449,1498),(26450,1498),(26451,1498),(26452,1498),(26453,1498),(26454,1498),(26455,1498),(26456,1499),(26457,1499),(26458,1499),(26459,1499),(26460,1499),(26461,1499),(26462,1499),(26463,1499),(26464,1499),(26465,1500),(26466,1500),(26467,1500),(26468,1500),(26469,1500),(26470,1500),(26471,1500),(26472,1501),(26473,1501),(26474,1501),(26475,1501),(26476,1501),(26477,1501),(26478,1501),(26479,1502),(26480,1502),(26481,1502),(26482,1502),(26483,1502),(26484,1502),(26485,1502),(26486,1503),(26487,1503),(26488,1503),(26489,1503),(26490,1503),(26491,1503),(26492,1503),(26493,1503),(26494,1503),(26495,1504),(26496,1504),(26497,1504),(26498,1504),(26499,1504),(26500,1504),(26501,1504),(26502,1505),(26503,1505),(26504,1505),(26505,1505),(26506,1505),(26507,1505),(26508,1505),(26509,1506),(26510,1506),(26511,1506),(26512,1506),(26513,1506),(26514,1506),(26515,1506),(26516,1506),(26517,1506),(26518,1507),(26519,1507),(26520,1507),(26521,1507),(26522,1507),(26523,1507),(26524,1507),(26525,1508),(26526,1508),(26527,1508),(26528,1508),(26529,1508),(26530,1508),(26531,1508),(26532,1509),(26533,1509),(26534,1509),(26535,1509),(26536,1509),(26537,1509),(26538,1509),(26539,1509),(26540,1509),(26541,1510),(26542,1510),(26543,1510),(26544,1510),(26545,1510),(26546,1510),(26547,1510),(26548,1511),(26549,1511),(26550,1511),(26551,1511),(26552,1511),(26553,1511),(26554,1511),(26555,1511),(26556,1511),(26557,1512),(26558,1512),(26559,1512),(26560,1512),(26561,1512),(26562,1512),(26563,1512),(26564,1512),(26565,1512),(26566,1513),(26567,1513),(26568,1513),(26569,1513),(26570,1513),(26571,1513),(26572,1513),(26573,1514),(26574,1514),(26575,1514),(26576,1514),(26577,1514),(26578,1514),(26579,1514),(26580,1514),(26581,1514),(26582,1515),(26583,1515),(26584,1515),(26585,1515),(26586,1515),(26587,1515),(26588,1515),(26589,1516),(26590,1516),(26591,1516),(26592,1516),(26593,1516),(26594,1516),(26595,1516),(26596,1517),(26597,1517),(26598,1517),(26599,1517),(26600,1517),(26601,1517),(26602,1517),(26603,1518),(26604,1518),(26605,1518),(26606,1518),(26607,1518),(26608,1518),(26609,1518),(26610,1519),(26611,1519),(26612,1519),(26613,1519),(26614,1519),(26615,1519),(26616,1519),(26617,1520),(26618,1520),(26619,1520),(26620,1520),(26621,1520),(26622,1520),(26623,1520),(26624,1521),(26625,1521),(26626,1521),(26627,1521),(26628,1521),(26629,1521),(26630,1521),(26631,1522),(26632,1522),(26633,1522),(26634,1522),(26635,1522),(26636,1522),(26637,1522),(26638,1523),(26639,1523),(26640,1523),(26641,1523),(26642,1523),(26643,1523),(26644,1523),(26645,1524),(26646,1524),(26647,1524),(26648,1524),(26649,1524),(26650,1524),(26651,1524),(26652,1525),(26653,1525),(26654,1525),(26655,1525),(26656,1525),(26657,1525),(26658,1525),(26659,1526),(26660,1526),(26661,1526),(26662,1526),(26663,1526),(26664,1526),(26665,1526),(26666,1527),(26667,1527),(26668,1527),(26669,1527),(26670,1527),(26671,1527),(26672,1527),(26673,1528),(26674,1528),(26675,1528),(26676,1528),(26677,1528),(26678,1528),(26679,1528),(26680,1529),(26681,1529),(26682,1529),(26683,1529),(26684,1529),(26685,1529),(26686,1529),(26687,1530),(26688,1530),(26689,1530),(26690,1530),(26691,1530),(26692,1530),(26693,1530),(26694,1531),(26695,1531),(26696,1531),(26697,1531),(26698,1531),(26699,1531),(26700,1531),(26701,1532),(26702,1532),(26703,1532),(26704,1532),(26705,1532),(26706,1532),(26707,1532),(26708,1533),(26709,1533),(26710,1533),(26711,1533),(26712,1533),(26713,1533),(26714,1533),(26715,1533),(26716,1533),(26717,1534),(26718,1534),(26719,1534),(26720,1534),(26721,1534),(26722,1534),(26723,1534),(26724,1535),(26725,1535),(26726,1535),(26727,1535),(26728,1535),(26729,1535),(26730,1535),(26731,1536),(26732,1536),(26733,1536),(26734,1536),(26735,1536),(26736,1536),(26737,1536),(26738,1537),(26739,1537),(26740,1537),(26741,1537),(26742,1537),(26743,1537),(26744,1537),(26745,1538),(26746,1538),(26747,1538),(26748,1538),(26749,1538),(26750,1538),(26751,1538),(26752,1539),(26753,1539),(26754,1539),(26755,1539),(26756,1539),(26757,1539),(26758,1539),(26759,1540),(26760,1540),(26761,1540),(26762,1540),(26763,1540),(26764,1540),(26765,1540),(26766,1541),(26767,1541),(26768,1541),(26769,1541),(26770,1541),(26771,1541),(26772,1541),(26773,1542),(26774,1542),(26775,1542),(26776,1542),(26777,1542),(26778,1542),(26779,1543),(26780,1543),(26781,1543),(26782,1543),(26783,1543),(26784,1543),(26785,1544),(26786,1544),(26787,1544),(26788,1544),(26789,1544),(26790,1544),(26791,1544),(26792,1545),(26793,1545),(26794,1545),(26795,1545),(26796,1545),(26797,1545),(26798,1546),(26799,1546),(26800,1546),(26801,1546),(26802,1546),(26803,1546),(26804,1546),(26805,1547),(26806,1547),(26807,1547),(26808,1547),(26809,1547),(26810,1547),(26811,1547),(26812,1548),(26813,1548),(26814,1548),(26815,1548),(26816,1548),(26817,1548),(26818,1548),(26819,1549),(26820,1549),(26821,1549),(26822,1549),(26823,1549),(26824,1549),(26825,1549),(26826,1550),(26827,1550),(26828,1550),(26829,1550),(26830,1550),(26831,1550),(26832,1550),(26833,1551),(26834,1551),(26835,1551),(26836,1551),(26837,1551),(26838,1551),(26839,1551),(26840,1552),(26841,1552),(26842,1552),(26843,1552),(26844,1552),(26845,1552),(26846,1552),(26847,1553),(26848,1553),(26849,1553),(26850,1553),(26851,1553),(26852,1553),(26853,1553),(26854,1554),(26855,1554),(26856,1554),(26857,1554),(26858,1554),(26859,1554),(26860,1554),(26861,1554),(26862,1554),(26863,1555),(26864,1555),(26865,1555),(26866,1555),(26867,1555),(26868,1555),(26869,1555),(26870,1556),(26871,1556),(26872,1556),(26873,1556),(26874,1556),(26875,1556),(26876,1556),(26877,1557),(26878,1557),(26879,1557),(26880,1557),(26881,1557),(26882,1557),(26883,1557),(26884,1558),(26885,1558),(26886,1558),(26887,1558),(26888,1558),(26889,1558),(26890,1558),(26891,1559),(26892,1559),(26893,1559),(26894,1559),(26895,1559),(26896,1559),(26897,1559),(26898,1560),(26899,1560),(26900,1560),(26901,1560),(26902,1560),(26903,1560),(26904,1560),(26905,1561),(26906,1561),(26907,1561),(26908,1561),(26909,1561),(26910,1561),(26911,1561),(26912,1562),(26913,1562),(26914,1562),(26915,1562),(26916,1562),(26917,1562),(26918,1562),(26919,1563),(26920,1563),(26921,1563),(26922,1563),(26923,1563),(26924,1563),(26925,1563),(26926,1564),(26927,1564),(26928,1564),(26929,1564),(26930,1564),(26931,1564),(26932,1564),(26933,1564),(26934,1564),(26935,1565),(26936,1565),(26937,1565),(26938,1565),(26939,1565),(26940,1565),(26941,1565),(26942,1565),(26943,1565),(26944,1466),(26945,1466),(26946,1467),(26947,1467),(26948,1468),(26949,1468),(26950,1469),(26951,1469),(26952,1470),(26953,1470),(26954,1471),(26955,1471),(26956,1472),(26957,1472),(26958,1473),(26959,1473),(26960,1474),(26961,1474),(26962,1475),(26963,1475),(26964,1476),(26965,1476),(26966,1477),(26967,1477),(26968,1478),(26969,1478),(26970,1479),(26971,1479),(26972,1480),(26973,1480),(26974,1481),(26975,1481),(26976,1482),(26977,1482),(26978,1483),(26979,1483),(26980,1484),(26981,1484),(26982,1485),(26983,1485),(26984,1486),(26985,1486),(26986,1487),(26987,1487),(26988,1488),(26989,1488),(26990,1489),(26991,1489),(26992,1490),(26993,1490),(26994,1491),(26995,1491),(26996,1492),(26997,1492),(26998,1493),(26999,1493),(27000,1494),(27001,1494),(27002,1495),(27003,1495),(27004,1495),(27005,1496),(27006,1496),(27007,1497),(27008,1497),(27009,1497),(27010,1498),(27011,1498),(27012,1498),(27013,1499),(27014,1499),(27015,1499),(27016,1500),(27017,1500),(27018,1500),(27019,1501),(27020,1501),(27021,1501),(27022,1502),(27023,1502),(27024,1502),(27025,1503),(27026,1503),(27027,1503),(27028,1504),(27029,1504),(27030,1504),(27031,1505),(27032,1505),(27033,1505),(27034,1506),(27035,1506),(27036,1506),(27037,1507),(27038,1507),(27039,1507),(27040,1508),(27041,1508),(27042,1508),(27043,1509),(27044,1509),(27045,1509),(27046,1510),(27047,1510),(27048,1510),(27049,1511),(27050,1511),(27051,1511),(27052,1512),(27053,1512),(27054,1512),(27055,1513),(27056,1513),(27057,1513),(27058,1514),(27059,1514),(27060,1514),(27061,1515),(27062,1515),(27063,1516),(27064,1516),(27065,1517),(27066,1517),(27067,1518),(27068,1518),(27069,1519),(27070,1519),(27071,1520),(27072,1520),(27073,1521),(27074,1521),(27075,1522),(27076,1522),(27077,1523),(27078,1523),(27079,1524),(27080,1524),(27081,1525),(27082,1525),(27083,1526),(27084,1526),(27085,1527),(27086,1527),(27087,1528),(27088,1528),(27089,1529),(27090,1529),(27091,1530),(27092,1530),(27093,1531),(27094,1531),(27095,1532),(27096,1532),(27097,1533),(27098,1533),(27099,1534),(27100,1534),(27101,1535),(27102,1535),(27103,1536),(27104,1536),(27105,1537),(27106,1537),(27107,1538),(27108,1538),(27109,1539),(27110,1539),(27111,1540),(27112,1540),(27113,1541),(27114,1541),(27115,1542),(27116,1542),(27117,1543),(27118,1543),(27119,1544),(27120,1544),(27121,1545),(27122,1545),(27123,1546),(27124,1546),(27125,1547),(27126,1547),(27127,1548),(27128,1548),(27129,1549),(27130,1549),(27131,1550),(27132,1550),(27133,1551),(27134,1551),(27135,1552),(27136,1552),(27137,1553),(27138,1553),(27139,1554),(27140,1554),(27141,1555),(27142,1555),(27143,1556),(27144,1556),(27145,1557),(27146,1557),(27147,1558),(27148,1558),(27149,1559),(27150,1559),(27151,1560),(27152,1560),(27153,1561),(27154,1561),(27155,1562),(27156,1562),(27157,1563),(27158,1563),(27159,1564),(27160,1564),(27161,1565),(27162,1565),(27163,1466),(27164,1466),(27165,1466),(27166,1467),(27167,1467),(27168,1467),(27169,1468),(27170,1468),(27171,1468),(27172,1469),(27173,1469),(27174,1469),(27175,1470),(27176,1470),(27177,1470),(27178,1471),(27179,1471),(27180,1471),(27181,1472),(27182,1472),(27183,1472),(27184,1473),(27185,1473),(27186,1473),(27187,1474),(27188,1474),(27189,1474),(27190,1475),(27191,1475),(27192,1475),(27193,1476),(27194,1476),(27195,1476),(27196,1477),(27197,1477),(27198,1477),(27199,1478),(27200,1478),(27201,1478),(27202,1479),(27203,1479),(27204,1479),(27205,1480),(27206,1480),(27207,1480),(27208,1481),(27209,1481),(27210,1481),(27211,1482),(27212,1482),(27213,1482),(27214,1483),(27215,1483),(27216,1483),(27217,1484),(27218,1484),(27219,1484),(27220,1485),(27221,1485),(27222,1485),(27223,1486),(27224,1486),(27225,1486),(27226,1487),(27227,1487),(27228,1487),(27229,1488),(27230,1488),(27231,1488),(27232,1489),(27233,1489),(27234,1489),(27235,1490),(27236,1490),(27237,1490),(27238,1491),(27239,1491),(27240,1491),(27241,1492),(27242,1492),(27243,1492),(27244,1493),(27245,1493),(27246,1493),(27247,1494),(27248,1494),(27249,1494),(27250,1495),(27251,1495),(27252,1496),(27253,1496),(27254,1496),(27255,1497),(27256,1497),(27257,1498),(27258,1498),(27259,1499),(27260,1499),(27261,1500),(27262,1500),(27263,1501),(27264,1501),(27265,1502),(27266,1502),(27267,1503),(27268,1503),(27269,1504),(27270,1504),(27271,1505),(27272,1505),(27273,1506),(27274,1506),(27275,1507),(27276,1507),(27277,1508),(27278,1508),(27279,1509),(27280,1509),(27281,1510),(27282,1510),(27283,1511),(27284,1511),(27285,1512),(27286,1512),(27287,1513),(27288,1513),(27289,1514),(27290,1514),(27291,1515),(27292,1515),(27293,1515),(27294,1516),(27295,1516),(27296,1516),(27297,1517),(27298,1517),(27299,1517),(27300,1518),(27301,1518),(27302,1518),(27303,1519),(27304,1519),(27305,1519),(27306,1520),(27307,1520),(27308,1520),(27309,1521),(27310,1521),(27311,1521),(27312,1522),(27313,1522),(27314,1522),(27315,1523),(27316,1523),(27317,1523),(27318,1524),(27319,1524),(27320,1524),(27321,1525),(27322,1525),(27323,1525),(27324,1526),(27325,1526),(27326,1526),(27327,1527),(27328,1527),(27329,1527),(27330,1528),(27331,1528),(27332,1528),(27333,1529),(27334,1529),(27335,1529),(27336,1530),(27337,1530),(27338,1530),(27339,1531),(27340,1531),(27341,1531),(27342,1532),(27343,1532),(27344,1532),(27345,1533),(27346,1533),(27347,1533),(27348,1534),(27349,1534),(27350,1534),(27351,1535),(27352,1535),(27353,1535),(27354,1536),(27355,1536),(27356,1536),(27357,1537),(27358,1537),(27359,1537),(27360,1538),(27361,1538),(27362,1538),(27363,1539),(27364,1539),(27365,1539),(27366,1540),(27367,1540),(27368,1540),(27369,1541),(27370,1541),(27371,1541),(27372,1542),(27373,1542),(27374,1542),(27375,1543),(27376,1543),(27377,1543),(27378,1544),(27379,1544),(27380,1544),(27381,1545),(27382,1545),(27383,1545),(27384,1546),(27385,1546),(27386,1546),(27387,1547),(27388,1547),(27389,1547),(27390,1548),(27391,1548),(27392,1548),(27393,1549),(27394,1549),(27395,1549),(27396,1550),(27397,1550),(27398,1550),(27399,1551),(27400,1551),(27401,1551),(27402,1552),(27403,1552),(27404,1552),(27405,1553),(27406,1553),(27407,1553),(27408,1554),(27409,1554),(27410,1554),(27411,1555),(27412,1555),(27413,1555),(27414,1556),(27415,1556),(27416,1556),(27417,1557),(27418,1557),(27419,1557),(27420,1558),(27421,1558),(27422,1558),(27423,1559),(27424,1559),(27425,1559),(27426,1560),(27427,1560),(27428,1560),(27429,1561),(27430,1561),(27431,1561),(27432,1562),(27433,1562),(27434,1562),(27435,1563),(27436,1563),(27437,1563),(27438,1564),(27439,1564),(27440,1564),(27441,1565),(27442,1565),(27443,1565),(27444,1466),(27445,1466),(27446,1466),(27447,1466),(27448,1467),(27449,1467),(27450,1467),(27451,1467),(27452,1468),(27453,1468),(27454,1468),(27455,1468),(27456,1469),(27457,1469),(27458,1469),(27459,1469),(27460,1470),(27461,1470),(27462,1470),(27463,1470),(27464,1471),(27465,1471),(27466,1471),(27467,1471),(27468,1472),(27469,1472),(27470,1472),(27471,1472),(27472,1473),(27473,1473),(27474,1473),(27475,1473),(27476,1474),(27477,1474),(27478,1474),(27479,1474),(27480,1475),(27481,1475),(27482,1475),(27483,1475),(27484,1476),(27485,1476),(27486,1476),(27487,1476),(27488,1477),(27489,1477),(27490,1477),(27491,1477),(27492,1478),(27493,1478),(27494,1478),(27495,1478),(27496,1479),(27497,1479),(27498,1479),(27499,1479),(27500,1480),(27501,1480),(27502,1480),(27503,1480),(27504,1481),(27505,1481),(27506,1481),(27507,1481),(27508,1482),(27509,1482),(27510,1482),(27511,1482),(27512,1483),(27513,1483),(27514,1483),(27515,1483),(27516,1484),(27517,1484),(27518,1484),(27519,1484),(27520,1485),(27521,1485),(27522,1485),(27523,1485),(27524,1486),(27525,1486),(27526,1486),(27527,1486),(27528,1487),(27529,1487),(27530,1487),(27531,1487),(27532,1488),(27533,1488),(27534,1488),(27535,1488),(27536,1489),(27537,1489),(27538,1489),(27539,1489),(27540,1490),(27541,1490),(27542,1490),(27543,1490),(27544,1491),(27545,1491),(27546,1491),(27547,1491),(27548,1492),(27549,1492),(27550,1492),(27551,1492),(27552,1493),(27553,1493),(27554,1493),(27555,1493),(27556,1494),(27557,1494),(27558,1494),(27559,1494),(27560,1495),(27561,1495),(27562,1495),(27563,1495),(27564,1496),(27565,1496),(27566,1496),(27567,1496),(27568,1497),(27569,1497),(27570,1497),(27571,1497),(27572,1498),(27573,1498),(27574,1498),(27575,1498),(27576,1499),(27577,1499),(27578,1499),(27579,1499),(27580,1500),(27581,1500),(27582,1500),(27583,1500),(27584,1501),(27585,1501),(27586,1501),(27587,1501),(27588,1502),(27589,1502),(27590,1502),(27591,1502),(27592,1503),(27593,1503),(27594,1503),(27595,1503),(27596,1504),(27597,1504),(27598,1504),(27599,1504),(27600,1505),(27601,1505),(27602,1505),(27603,1505),(27604,1506),(27605,1506),(27606,1506),(27607,1506),(27608,1507),(27609,1507),(27610,1507),(27611,1507),(27612,1508),(27613,1508),(27614,1508),(27615,1508),(27616,1509),(27617,1509),(27618,1509),(27619,1509),(27620,1510),(27621,1510),(27622,1510),(27623,1510),(27624,1511),(27625,1511),(27626,1511),(27627,1511),(27628,1512),(27629,1512),(27630,1512),(27631,1512),(27632,1513),(27633,1513),(27634,1513),(27635,1513),(27636,1514),(27637,1514),(27638,1514),(27639,1514),(27640,1515),(27641,1515),(27642,1515),(27643,1515),(27644,1516),(27645,1516),(27646,1516),(27647,1516),(27648,1517),(27649,1517),(27650,1517),(27651,1517),(27652,1518),(27653,1518),(27654,1518),(27655,1518),(27656,1519),(27657,1519),(27658,1519),(27659,1519),(27660,1520),(27661,1520),(27662,1520),(27663,1520),(27664,1521),(27665,1521),(27666,1521),(27667,1521),(27668,1522),(27669,1522),(27670,1522),(27671,1522),(27672,1523),(27673,1523),(27674,1523),(27675,1523),(27676,1524),(27677,1524),(27678,1524),(27679,1524),(27680,1525),(27681,1525),(27682,1525),(27683,1525),(27684,1526),(27685,1526),(27686,1526),(27687,1526),(27688,1527),(27689,1527),(27690,1527),(27691,1527),(27692,1528),(27693,1528),(27694,1528),(27695,1528),(27696,1529),(27697,1529),(27698,1529),(27699,1529),(27700,1530),(27701,1530),(27702,1530),(27703,1530),(27704,1531),(27705,1531),(27706,1531),(27707,1531),(27708,1532),(27709,1532),(27710,1532),(27711,1532),(27712,1533),(27713,1533),(27714,1533),(27715,1533),(27716,1534),(27717,1534),(27718,1534),(27719,1534),(27720,1535),(27721,1535),(27722,1535),(27723,1535),(27724,1536),(27725,1536),(27726,1536),(27727,1536),(27728,1537),(27729,1537),(27730,1537),(27731,1537),(27732,1538),(27733,1538),(27734,1538),(27735,1538),(27736,1539),(27737,1539),(27738,1539),(27739,1539),(27740,1540),(27741,1540),(27742,1540),(27743,1540),(27744,1541),(27745,1541),(27746,1541),(27747,1541),(27748,1542),(27749,1542),(27750,1542),(27751,1542),(27752,1543),(27753,1543),(27754,1543),(27755,1543),(27756,1544),(27757,1544),(27758,1544),(27759,1544),(27760,1545),(27761,1545),(27762,1545),(27763,1545),(27764,1546),(27765,1546),(27766,1546),(27767,1546),(27768,1547),(27769,1547),(27770,1547),(27771,1547),(27772,1548),(27773,1548),(27774,1548),(27775,1548),(27776,1549),(27777,1549),(27778,1549),(27779,1549),(27780,1550),(27781,1550),(27782,1550),(27783,1550),(27784,1551),(27785,1551),(27786,1551),(27787,1551),(27788,1552),(27789,1552),(27790,1552),(27791,1552),(27792,1553),(27793,1553),(27794,1553),(27795,1553),(27796,1554),(27797,1554),(27798,1554),(27799,1554),(27800,1555),(27801,1555),(27802,1555),(27803,1555),(27804,1556),(27805,1556),(27806,1556),(27807,1556),(27808,1557),(27809,1557),(27810,1557),(27811,1557),(27812,1558),(27813,1558),(27814,1558),(27815,1558),(27816,1559),(27817,1559),(27818,1559),(27819,1559),(27820,1560),(27821,1560),(27822,1560),(27823,1560),(27824,1561),(27825,1561),(27826,1561),(27827,1561),(27828,1562),(27829,1562),(27830,1562),(27831,1562),(27832,1563),(27833,1563),(27834,1563),(27835,1563),(27836,1564),(27837,1564),(27838,1564),(27839,1564),(27840,1565),(27841,1565),(27842,1565),(27843,1565),(27844,1566),(27845,1567),(27846,1568),(27847,1569),(27848,1570),(27849,1571),(27850,1572),(27851,1573),(27852,1574),(27853,1575),(27854,1576),(27855,1577),(27856,1578),(27857,1579),(27858,1580),(27859,1581),(27860,1582),(27861,1583),(27862,1584),(27863,1585),(27864,1586),(27865,1587),(27866,1588),(27867,1589),(27868,1590),(27869,1591),(27870,1592),(27871,1593),(27872,1594),(27873,1595),(27874,1596),(27875,1597),(27876,1598),(27877,1599),(27878,1600),(27879,1601),(27880,1602),(27881,1603),(27882,1604),(27883,1605),(27884,1606),(27885,1607),(27886,1608),(27887,1609),(27888,1610),(27889,1611),(27890,1612),(27891,1613),(27892,1614),(27893,1615),(27894,1616),(27895,1617),(27896,1618),(27897,1619),(27898,1620),(27899,1621),(27900,1622),(27901,1623),(27902,1624),(27903,1625),(27904,1626),(27905,1627),(27906,1628),(27907,1629),(27908,1630),(27909,1631),(27910,1632),(27911,1633),(27912,1634),(27913,1635),(27914,1636),(27915,1637),(27916,1638),(27917,1639),(27918,1640),(27919,1641),(27920,1642),(27921,1643),(27922,1644),(27923,1645),(27924,1646),(27925,1647),(27926,1648),(27927,1649),(27928,1650),(27929,1651),(27930,1652),(27931,1653),(27932,1654),(27933,1655),(27934,1656),(27935,1657),(27936,1658),(27937,1659),(27938,1660),(27939,1661),(27940,1662),(27941,1663),(27942,1664),(27943,1665),(27944,1566),(27945,1566),(27946,1566),(27947,1566),(27948,1566),(27949,1566),(27950,1566),(27951,1566),(27952,1566),(27953,1567),(27954,1567),(27955,1567),(27956,1567),(27957,1567),(27958,1567),(27959,1567),(27960,1567),(27961,1568),(27962,1568),(27963,1568),(27964,1568),(27965,1568),(27966,1568),(27967,1568),(27968,1568),(27969,1568),(27970,1569),(27971,1569),(27972,1569),(27973,1569),(27974,1569),(27975,1569),(27976,1569),(27977,1569),(27978,1569),(27979,1570),(27980,1570),(27981,1570),(27982,1570),(27983,1570),(27984,1570),(27985,1570),(27986,1570),(27987,1570),(27988,1571),(27989,1571),(27990,1571),(27991,1571),(27992,1571),(27993,1571),(27994,1571),(27995,1571),(27996,1571),(27997,1572),(27998,1572),(27999,1572),(28000,1572),(28001,1572),(28002,1572),(28003,1572),(28004,1572),(28005,1572),(28006,1573),(28007,1573),(28008,1573),(28009,1573),(28010,1573),(28011,1573),(28012,1573),(28013,1573),(28014,1573),(28015,1574),(28016,1574),(28017,1574),(28018,1574),(28019,1574),(28020,1574),(28021,1574),(28022,1574),(28023,1574),(28024,1575),(28025,1575),(28026,1575),(28027,1575),(28028,1575),(28029,1575),(28030,1575),(28031,1576),(28032,1576),(28033,1576),(28034,1576),(28035,1576),(28036,1576),(28037,1576),(28038,1577),(28039,1577),(28040,1577),(28041,1577),(28042,1577),(28043,1577),(28044,1577),(28045,1578),(28046,1578),(28047,1578),(28048,1578),(28049,1578),(28050,1578),(28051,1578),(28052,1578),(28053,1578),(28054,1579),(28055,1579),(28056,1579),(28057,1579),(28058,1580),(28059,1580),(28060,1580),(28061,1580),(28062,1580),(28063,1580),(28064,1580),(28065,1581),(28066,1581),(28067,1581),(28068,1581),(28069,1581),(28070,1581),(28071,1581),(28072,1582),(28073,1582),(28074,1582),(28075,1582),(28076,1582),(28077,1582),(28078,1582),(28079,1583),(28080,1583),(28081,1583),(28082,1583),(28083,1583),(28084,1583),(28085,1583),(28086,1584),(28087,1584),(28088,1584),(28089,1584),(28090,1584),(28091,1584),(28092,1584),(28093,1584),(28094,1585),(28095,1585),(28096,1585),(28097,1585),(28098,1585),(28099,1585),(28100,1585),(28101,1585),(28102,1586),(28103,1586),(28104,1586),(28105,1586),(28106,1586),(28107,1586),(28108,1586),(28109,1586),(28110,1587),(28111,1587),(28112,1587),(28113,1587),(28114,1587),(28115,1587),(28116,1587),(28117,1588),(28118,1588),(28119,1588),(28120,1588),(28121,1588),(28122,1588),(28123,1588),(28124,1588),(28125,1588),(28126,1589),(28127,1589),(28128,1589),(28129,1589),(28130,1589),(28131,1589),(28132,1589),(28133,1589),(28134,1589),(28135,1590),(28136,1590),(28137,1590),(28138,1590),(28139,1590),(28140,1590),(28141,1590),(28142,1590),(28143,1590),(28144,1591),(28145,1591),(28146,1591),(28147,1591),(28148,1591),(28149,1591),(28150,1591),(28151,1591),(28152,1591),(28153,1592),(28154,1592),(28155,1592),(28156,1592),(28157,1592),(28158,1592),(28159,1592),(28160,1592),(28161,1592),(28162,1593),(28163,1593),(28164,1593),(28165,1593),(28166,1593),(28167,1593),(28168,1593),(28169,1593),(28170,1593),(28171,1594),(28172,1594),(28173,1594),(28174,1594),(28175,1594),(28176,1594),(28177,1594),(28178,1594),(28179,1594),(28180,1595),(28181,1595),(28182,1595),(28183,1595),(28184,1595),(28185,1595),(28186,1595),(28187,1595),(28188,1595),(28189,1596),(28190,1596),(28191,1596),(28192,1596),(28193,1596),(28194,1596),(28195,1596),(28196,1596),(28197,1596),(28198,1597),(28199,1597),(28200,1597),(28201,1597),(28202,1597),(28203,1597),(28204,1597),(28205,1597),(28206,1597),(28207,1598),(28208,1598),(28209,1598),(28210,1598),(28211,1598),(28212,1598),(28213,1598),(28214,1598),(28215,1598),(28216,1599),(28217,1599),(28218,1599),(28219,1599),(28220,1599),(28221,1599),(28222,1599),(28223,1599),(28224,1599),(28225,1600),(28226,1600),(28227,1600),(28228,1600),(28229,1600),(28230,1600),(28231,1600),(28232,1600),(28233,1601),(28234,1601),(28235,1601),(28236,1601),(28237,1601),(28238,1601),(28239,1601),(28240,1601),(28241,1602),(28242,1602),(28243,1602),(28244,1602),(28245,1602),(28246,1602),(28247,1602),(28248,1602),(28249,1603),(28250,1603),(28251,1603),(28252,1603),(28253,1603),(28254,1603),(28255,1603),(28256,1603),(28257,1603),(28258,1604),(28259,1604),(28260,1604),(28261,1604),(28262,1604),(28263,1604),(28264,1604),(28265,1604),(28266,1604),(28267,1605),(28268,1605),(28269,1605),(28270,1605),(28271,1605),(28272,1605),(28273,1605),(28274,1605),(28275,1606),(28276,1606),(28277,1606),(28278,1606),(28279,1606),(28280,1606),(28281,1606),(28282,1606),(28283,1607),(28284,1607),(28285,1607),(28286,1607),(28287,1607),(28288,1607),(28289,1607),(28290,1607),(28291,1607),(28292,1608),(28293,1608),(28294,1608),(28295,1608),(28296,1608),(28297,1608),(28298,1608),(28299,1608),(28300,1609),(28301,1609),(28302,1609),(28303,1609),(28304,1609),(28305,1609),(28306,1609),(28307,1609),(28308,1610),(28309,1610),(28310,1610),(28311,1610),(28312,1610),(28313,1610),(28314,1610),(28315,1610),(28316,1610),(28317,1611),(28318,1611),(28319,1611),(28320,1611),(28321,1611),(28322,1611),(28323,1611),(28324,1612),(28325,1612),(28326,1612),(28327,1612),(28328,1612),(28329,1612),(28330,1613),(28331,1613),(28332,1613),(28333,1613),(28334,1613),(28335,1613),(28336,1613),(28337,1614),(28338,1614),(28339,1614),(28340,1614),(28341,1614),(28342,1614),(28343,1615),(28344,1615),(28345,1615),(28346,1615),(28347,1615),(28348,1615),(28349,1615),(28350,1616),(28351,1616),(28352,1616),(28353,1616),(28354,1616),(28355,1616),(28356,1616),(28357,1617),(28358,1617),(28359,1617),(28360,1617),(28361,1617),(28362,1617),(28363,1617),(28364,1618),(28365,1618),(28366,1618),(28367,1618),(28368,1618),(28369,1618),(28370,1618),(28371,1618),(28372,1618),(28373,1619),(28374,1619),(28375,1619),(28376,1619),(28377,1619),(28378,1619),(28379,1619),(28380,1619),(28381,1619),(28382,1620),(28383,1620),(28384,1620),(28385,1620),(28386,1620),(28387,1620),(28388,1620),(28389,1620),(28390,1620),(28391,1621),(28392,1621),(28393,1621),(28394,1621),(28395,1621),(28396,1621),(28397,1621),(28398,1621),(28399,1621),(28400,1622),(28401,1622),(28402,1622),(28403,1622),(28404,1622),(28405,1622),(28406,1622),(28407,1622),(28408,1623),(28409,1623),(28410,1623),(28411,1623),(28412,1623),(28413,1623),(28414,1623),(28415,1623),(28416,1623),(28417,1624),(28418,1624),(28419,1624),(28420,1624),(28421,1624),(28422,1624),(28423,1624),(28424,1624),(28425,1625),(28426,1625),(28427,1625),(28428,1625),(28429,1625),(28430,1625),(28431,1625),(28432,1625),(28433,1626),(28434,1626),(28435,1626),(28436,1626),(28437,1626),(28438,1626),(28439,1626),(28440,1626),(28441,1626),(28442,1627),(28443,1627),(28444,1627),(28445,1627),(28446,1627),(28447,1627),(28448,1627),(28449,1627),(28450,1627),(28451,1628),(28452,1628),(28453,1628),(28454,1628),(28455,1628),(28456,1628),(28457,1628),(28458,1628),(28459,1629),(28460,1629),(28461,1629),(28462,1629),(28463,1629),(28464,1629),(28465,1629),(28466,1629),(28467,1629),(28468,1630),(28469,1630),(28470,1630),(28471,1630),(28472,1630),(28473,1630),(28474,1631),(28475,1631),(28476,1631),(28477,1631),(28478,1631),(28479,1631),(28480,1631),(28481,1631),(28482,1631),(28483,1632),(28484,1632),(28485,1632),(28486,1632),(28487,1632),(28488,1632),(28489,1632),(28490,1632),(28491,1632),(28492,1633),(28493,1633),(28494,1633),(28495,1633),(28496,1633),(28497,1633),(28498,1634),(28499,1634),(28500,1634),(28501,1634),(28502,1634),(28503,1634),(28504,1634),(28505,1634),(28506,1634),(28507,1635),(28508,1635),(28509,1635),(28510,1635),(28511,1635),(28512,1635),(28513,1635),(28514,1635),(28515,1635),(28516,1636),(28517,1636),(28518,1636),(28519,1636),(28520,1636),(28521,1636),(28522,1636),(28523,1636),(28524,1636),(28525,1637),(28526,1637),(28527,1637),(28528,1637),(28529,1637),(28530,1637),(28531,1637),(28532,1637),(28533,1637),(28534,1638),(28535,1638),(28536,1638),(28537,1638),(28538,1638),(28539,1638),(28540,1638),(28541,1638),(28542,1638),(28543,1639),(28544,1639),(28545,1639),(28546,1639),(28547,1639),(28548,1639),(28549,1639),(28550,1639),(28551,1639),(28552,1640),(28553,1640),(28554,1640),(28555,1640),(28556,1640),(28557,1640),(28558,1640),(28559,1640),(28560,1640),(28561,1641),(28562,1641),(28563,1641),(28564,1641),(28565,1641),(28566,1641),(28567,1642),(28568,1642),(28569,1642),(28570,1642),(28571,1642),(28572,1642),(28573,1643),(28574,1643),(28575,1643),(28576,1643),(28577,1643),(28578,1643),(28579,1643),(28580,1643),(28581,1643),(28582,1644),(28583,1644),(28584,1644),(28585,1644),(28586,1644),(28587,1644),(28588,1644),(28589,1644),(28590,1644),(28591,1645),(28592,1645),(28593,1645),(28594,1645),(28595,1645),(28596,1645),(28597,1645),(28598,1645),(28599,1645),(28600,1646),(28601,1646),(28602,1646),(28603,1646),(28604,1646),(28605,1646),(28606,1646),(28607,1646),(28608,1646),(28609,1647),(28610,1647),(28611,1647),(28612,1647),(28613,1647),(28614,1647),(28615,1647),(28616,1647),(28617,1647),(28618,1648),(28619,1648),(28620,1648),(28621,1648),(28622,1648),(28623,1648),(28624,1648),(28625,1648),(28626,1648),(28627,1649),(28628,1649),(28629,1649),(28630,1649),(28631,1649),(28632,1649),(28633,1649),(28634,1649),(28635,1649),(28636,1650),(28637,1650),(28638,1650),(28639,1650),(28640,1650),(28641,1650),(28642,1650),(28643,1651),(28644,1651),(28645,1651),(28646,1651),(28647,1651),(28648,1651),(28649,1651),(28650,1651),(28651,1651),(28652,1652),(28653,1652),(28654,1652),(28655,1652),(28656,1652),(28657,1652),(28658,1652),(28659,1653),(28660,1653),(28661,1653),(28662,1653),(28663,1653),(28664,1653),(28665,1653),(28666,1653),(28667,1653),(28668,1654),(28669,1654),(28670,1654),(28671,1654),(28672,1654),(28673,1654),(28674,1655),(28675,1655),(28676,1655),(28677,1655),(28678,1655),(28679,1655),(28680,1655),(28681,1656),(28682,1656),(28683,1656),(28684,1656),(28685,1656),(28686,1656),(28687,1656),(28688,1657),(28689,1657),(28690,1657),(28691,1657),(28692,1657),(28693,1657),(28694,1658),(28695,1658),(28696,1658),(28697,1658),(28698,1658),(28699,1658),(28700,1658),(28701,1658),(28702,1658),(28703,1659),(28704,1659),(28705,1659),(28706,1659),(28707,1659),(28708,1659),(28709,1659),(28710,1659),(28711,1659),(28712,1660),(28713,1660),(28714,1660),(28715,1660),(28716,1660),(28717,1660),(28718,1660),(28719,1660),(28720,1660),(28721,1661),(28722,1661),(28723,1661),(28724,1661),(28725,1661),(28726,1661),(28727,1661),(28728,1662),(28729,1662),(28730,1662),(28731,1662),(28732,1662),(28733,1662),(28734,1662),(28735,1663),(28736,1663),(28737,1663),(28738,1663),(28739,1663),(28740,1663),(28741,1663),(28742,1664),(28743,1664),(28744,1664),(28745,1664),(28746,1664),(28747,1664),(28748,1664),(28749,1665),(28750,1665),(28751,1665),(28752,1665),(28753,1665),(28754,1665),(28755,1665),(28756,1566),(28757,1566),(28758,1567),(28759,1567),(28760,1568),(28761,1568),(28762,1569),(28763,1569),(28764,1570),(28765,1570),(28766,1571),(28767,1571),(28768,1572),(28769,1572),(28770,1573),(28771,1573),(28772,1574),(28773,1574),(28774,1575),(28775,1575),(28776,1576),(28777,1576),(28778,1577),(28779,1577),(28780,1578),(28781,1578),(28782,1579),(28783,1580),(28784,1580),(28785,1581),(28786,1581),(28787,1582),(28788,1582),(28789,1583),(28790,1583),(28791,1584),(28792,1584),(28793,1585),(28794,1585),(28795,1586),(28796,1586),(28797,1587),(28798,1587),(28799,1588),(28800,1588),(28801,1589),(28802,1589),(28803,1590),(28804,1590),(28805,1591),(28806,1591),(28807,1592),(28808,1592),(28809,1593),(28810,1593),(28811,1594),(28812,1594),(28813,1595),(28814,1595),(28815,1596),(28816,1596),(28817,1597),(28818,1597),(28819,1598),(28820,1598),(28821,1599),(28822,1599),(28823,1600),(28824,1600),(28825,1601),(28826,1601),(28827,1602),(28828,1602),(28829,1603),(28830,1603),(28831,1604),(28832,1604),(28833,1605),(28834,1605),(28835,1606),(28836,1606),(28837,1607),(28838,1607),(28839,1608),(28840,1608),(28841,1609),(28842,1609),(28843,1610),(28844,1610),(28845,1611),(28846,1611),(28847,1611),(28848,1612),(28849,1612),(28850,1612),(28851,1613),(28852,1613),(28853,1613),(28854,1614),(28855,1614),(28856,1614),(28857,1615),(28858,1615),(28859,1616),(28860,1616),(28861,1616),(28862,1617),(28863,1617),(28864,1617),(28865,1618),(28866,1618),(28867,1619),(28868,1619),(28869,1620),(28870,1620),(28871,1621),(28872,1621),(28873,1622),(28874,1622),(28875,1623),(28876,1623),(28877,1624),(28878,1624),(28879,1625),(28880,1625),(28881,1626),(28882,1626),(28883,1627),(28884,1627),(28885,1628),(28886,1628),(28887,1629),(28888,1629),(28889,1630),(28890,1630),(28891,1631),(28892,1631),(28893,1632),(28894,1632),(28895,1633),(28896,1633),(28897,1634),(28898,1634),(28899,1635),(28900,1635),(28901,1636),(28902,1636),(28903,1637),(28904,1637),(28905,1638),(28906,1638),(28907,1639),(28908,1639),(28909,1640),(28910,1640),(28911,1641),(28912,1641),(28913,1642),(28914,1642),(28915,1643),(28916,1643),(28917,1644),(28918,1644),(28919,1645),(28920,1645),(28921,1646),(28922,1646),(28923,1646),(28924,1647),(28925,1647),(28926,1647),(28927,1648),(28928,1648),(28929,1649),(28930,1649),(28931,1650),(28932,1650),(28933,1650),(28934,1651),(28935,1651),(28936,1651),(28937,1652),(28938,1652),(28939,1652),(28940,1653),(28941,1653),(28942,1653),(28943,1654),(28944,1654),(28945,1654),(28946,1655),(28947,1655),(28948,1655),(28949,1656),(28950,1656),(28951,1656),(28952,1657),(28953,1657),(28954,1657),(28955,1658),(28956,1658),(28957,1659),(28958,1659),(28959,1660),(28960,1660),(28961,1661),(28962,1661),(28963,1662),(28964,1662),(28965,1663),(28966,1663),(28967,1664),(28968,1664),(28969,1665),(28970,1665),(28971,1566),(28972,1566),(28973,1566),(28974,1567),(28975,1567),(28976,1567),(28977,1568),(28978,1568),(28979,1568),(28980,1569),(28981,1569),(28982,1569),(28983,1570),(28984,1570),(28985,1570),(28986,1571),(28987,1571),(28988,1571),(28989,1572),(28990,1572),(28991,1572),(28992,1573),(28993,1573),(28994,1573),(28995,1574),(28996,1574),(28997,1574),(28998,1575),(28999,1575),(29000,1575),(29001,1576),(29002,1576),(29003,1576),(29004,1577),(29005,1577),(29006,1577),(29007,1578),(29008,1578),(29009,1578),(29010,1579),(29011,1579),(29012,1579),(29013,1580),(29014,1580),(29015,1580),(29016,1581),(29017,1581),(29018,1581),(29019,1582),(29020,1582),(29021,1582),(29022,1583),(29023,1583),(29024,1583),(29025,1584),(29026,1584),(29027,1584),(29028,1585),(29029,1585),(29030,1585),(29031,1586),(29032,1586),(29033,1586),(29034,1587),(29035,1587),(29036,1587),(29037,1588),(29038,1588),(29039,1588),(29040,1589),(29041,1589),(29042,1589),(29043,1590),(29044,1590),(29045,1590),(29046,1591),(29047,1591),(29048,1591),(29049,1592),(29050,1592),(29051,1592),(29052,1593),(29053,1593),(29054,1593),(29055,1594),(29056,1594),(29057,1594),(29058,1595),(29059,1595),(29060,1595),(29061,1596),(29062,1596),(29063,1596),(29064,1597),(29065,1597),(29066,1597),(29067,1598),(29068,1598),(29069,1598),(29070,1599),(29071,1599),(29072,1599),(29073,1600),(29074,1600),(29075,1600),(29076,1601),(29077,1601),(29078,1601),(29079,1602),(29080,1602),(29081,1602),(29082,1603),(29083,1603),(29084,1603),(29085,1604),(29086,1604),(29087,1604),(29088,1605),(29089,1605),(29090,1605),(29091,1606),(29092,1606),(29093,1606),(29094,1607),(29095,1607),(29096,1607),(29097,1608),(29098,1608),(29099,1608),(29100,1609),(29101,1609),(29102,1609),(29103,1610),(29104,1610),(29105,1610),(29106,1611),(29107,1611),(29108,1611),(29109,1612),(29110,1612),(29111,1612),(29112,1613),(29113,1613),(29114,1613),(29115,1614),(29116,1614),(29117,1614),(29118,1615),(29119,1615),(29120,1615),(29121,1616),(29122,1616),(29123,1616),(29124,1617),(29125,1617),(29126,1617),(29127,1618),(29128,1618),(29129,1618),(29130,1619),(29131,1619),(29132,1619),(29133,1620),(29134,1620),(29135,1620),(29136,1621),(29137,1621),(29138,1621),(29139,1622),(29140,1622),(29141,1622),(29142,1623),(29143,1623),(29144,1623),(29145,1624),(29146,1624),(29147,1624),(29148,1625),(29149,1625),(29150,1625),(29151,1626),(29152,1626),(29153,1626),(29154,1627),(29155,1627),(29156,1627),(29157,1628),(29158,1628),(29159,1628),(29160,1629),(29161,1629),(29162,1629),(29163,1629),(29164,1630),(29165,1630),(29166,1630),(29167,1631),(29168,1631),(29169,1631),(29170,1632),(29171,1632),(29172,1632),(29173,1633),(29174,1633),(29175,1633),(29176,1634),(29177,1634),(29178,1634),(29179,1635),(29180,1635),(29181,1635),(29182,1636),(29183,1636),(29184,1636),(29185,1637),(29186,1637),(29187,1637),(29188,1638),(29189,1638),(29190,1638),(29191,1639),(29192,1639),(29193,1639),(29194,1640),(29195,1640),(29196,1640),(29197,1640),(29198,1641),(29199,1641),(29200,1641),(29201,1641),(29202,1642),(29203,1642),(29204,1642),(29205,1642),(29206,1643),(29207,1643),(29208,1643),(29209,1644),(29210,1644),(29211,1644),(29212,1645),(29213,1645),(29214,1645),(29215,1646),(29216,1646),(29217,1646),(29218,1647),(29219,1647),(29220,1647),(29221,1648),(29222,1648),(29223,1648),(29224,1649),(29225,1649),(29226,1649),(29227,1650),(29228,1650),(29229,1650),(29230,1651),(29231,1651),(29232,1651),(29233,1652),(29234,1652),(29235,1652),(29236,1653),(29237,1653),(29238,1653),(29239,1654),(29240,1654),(29241,1654),(29242,1655),(29243,1655),(29244,1655),(29245,1656),(29246,1656),(29247,1656),(29248,1657),(29249,1657),(29250,1657),(29251,1658),(29252,1658),(29253,1658),(29254,1659),(29255,1659),(29256,1659),(29257,1660),(29258,1660),(29259,1660),(29260,1661),(29261,1661),(29262,1661),(29263,1662),(29264,1662),(29265,1662),(29266,1663),(29267,1663),(29268,1663),(29269,1664),(29270,1664),(29271,1664),(29272,1665),(29273,1665),(29274,1665),(29275,1566),(29276,1566),(29277,1566),(29278,1566),(29279,1567),(29280,1567),(29281,1567),(29282,1567),(29283,1568),(29284,1568),(29285,1568),(29286,1568),(29287,1569),(29288,1569),(29289,1569),(29290,1569),(29291,1570),(29292,1570),(29293,1570),(29294,1570),(29295,1571),(29296,1571),(29297,1571),(29298,1571),(29299,1572),(29300,1572),(29301,1572),(29302,1572),(29303,1573),(29304,1573),(29305,1573),(29306,1573),(29307,1574),(29308,1574),(29309,1574),(29310,1574),(29311,1575),(29312,1575),(29313,1575),(29314,1575),(29315,1576),(29316,1576),(29317,1576),(29318,1576),(29319,1577),(29320,1577),(29321,1577),(29322,1577),(29323,1578),(29324,1578),(29325,1578),(29326,1578),(29327,1579),(29328,1579),(29329,1579),(29330,1579),(29331,1580),(29332,1580),(29333,1580),(29334,1580),(29335,1581),(29336,1581),(29337,1581),(29338,1581),(29339,1582),(29340,1582),(29341,1582),(29342,1582),(29343,1583),(29344,1583),(29345,1583),(29346,1583),(29347,1584),(29348,1584),(29349,1584),(29350,1584),(29351,1585),(29352,1585),(29353,1585),(29354,1585),(29355,1586),(29356,1586),(29357,1586),(29358,1586),(29359,1587),(29360,1587),(29361,1587),(29362,1587),(29363,1588),(29364,1588),(29365,1588),(29366,1588),(29367,1589),(29368,1589),(29369,1589),(29370,1589),(29371,1590),(29372,1590),(29373,1590),(29374,1590),(29375,1591),(29376,1591),(29377,1591),(29378,1591),(29379,1592),(29380,1592),(29381,1592),(29382,1592),(29383,1593),(29384,1593),(29385,1593),(29386,1593),(29387,1594),(29388,1594),(29389,1594),(29390,1594),(29391,1595),(29392,1595),(29393,1595),(29394,1595),(29395,1596),(29396,1596),(29397,1596),(29398,1596),(29399,1597),(29400,1597),(29401,1597),(29402,1597),(29403,1598),(29404,1598),(29405,1598),(29406,1598),(29407,1599),(29408,1599),(29409,1599),(29410,1599),(29411,1600),(29412,1600),(29413,1600),(29414,1600),(29415,1601),(29416,1601),(29417,1601),(29418,1601),(29419,1602),(29420,1602),(29421,1602),(29422,1602),(29423,1603),(29424,1603),(29425,1603),(29426,1603),(29427,1604),(29428,1604),(29429,1604),(29430,1604),(29431,1605),(29432,1605),(29433,1605),(29434,1605),(29435,1606),(29436,1606),(29437,1606),(29438,1606),(29439,1607),(29440,1607),(29441,1607),(29442,1607),(29443,1608),(29444,1608),(29445,1608),(29446,1608),(29447,1609),(29448,1609),(29449,1609),(29450,1609),(29451,1610),(29452,1610),(29453,1610),(29454,1610),(29455,1611),(29456,1611),(29457,1611),(29458,1611),(29459,1612),(29460,1612),(29461,1612),(29462,1612),(29463,1613),(29464,1613),(29465,1613),(29466,1613),(29467,1614),(29468,1614),(29469,1614),(29470,1614),(29471,1615),(29472,1615),(29473,1615),(29474,1615),(29475,1616),(29476,1616),(29477,1616),(29478,1616),(29479,1617),(29480,1617),(29481,1617),(29482,1617),(29483,1618),(29484,1618),(29485,1618),(29486,1618),(29487,1619),(29488,1619),(29489,1619),(29490,1619),(29491,1620),(29492,1620),(29493,1620),(29494,1620),(29495,1621),(29496,1621),(29497,1621),(29498,1621),(29499,1622),(29500,1622),(29501,1622),(29502,1622),(29503,1623),(29504,1623),(29505,1623),(29506,1623),(29507,1624),(29508,1624),(29509,1624),(29510,1624),(29511,1625),(29512,1625),(29513,1625),(29514,1625),(29515,1626),(29516,1626),(29517,1626),(29518,1626),(29519,1627),(29520,1627),(29521,1627),(29522,1627),(29523,1628),(29524,1628),(29525,1628),(29526,1628),(29527,1629),(29528,1629),(29529,1629),(29530,1629),(29531,1630),(29532,1630),(29533,1630),(29534,1630),(29535,1631),(29536,1631),(29537,1631),(29538,1631),(29539,1632),(29540,1632),(29541,1632),(29542,1632),(29543,1633),(29544,1633),(29545,1633),(29546,1633),(29547,1634),(29548,1634),(29549,1634),(29550,1634),(29551,1635),(29552,1635),(29553,1635),(29554,1635),(29555,1636),(29556,1636),(29557,1636),(29558,1636),(29559,1637),(29560,1637),(29561,1637),(29562,1637),(29563,1638),(29564,1638),(29565,1638),(29566,1638),(29567,1639),(29568,1639),(29569,1639),(29570,1639),(29571,1640),(29572,1640),(29573,1640),(29574,1640),(29575,1641),(29576,1641),(29577,1641),(29578,1641),(29579,1642),(29580,1642),(29581,1642),(29582,1642),(29583,1643),(29584,1643),(29585,1643),(29586,1643),(29587,1644),(29588,1644),(29589,1644),(29590,1644),(29591,1645),(29592,1645),(29593,1645),(29594,1645),(29595,1646),(29596,1646),(29597,1646),(29598,1646),(29599,1647),(29600,1647),(29601,1647),(29602,1647),(29603,1648),(29604,1648),(29605,1648),(29606,1648),(29607,1649),(29608,1649),(29609,1649),(29610,1649),(29611,1650),(29612,1650),(29613,1650),(29614,1650),(29615,1651),(29616,1651),(29617,1651),(29618,1651),(29619,1652),(29620,1652),(29621,1652),(29622,1652),(29623,1653),(29624,1653),(29625,1653),(29626,1653),(29627,1654),(29628,1654),(29629,1654),(29630,1654),(29631,1655),(29632,1655),(29633,1655),(29634,1655),(29635,1656),(29636,1656),(29637,1656),(29638,1656),(29639,1657),(29640,1657),(29641,1657),(29642,1657),(29643,1658),(29644,1658),(29645,1658),(29646,1658),(29647,1659),(29648,1659),(29649,1659),(29650,1659),(29651,1660),(29652,1660),(29653,1660),(29654,1660),(29655,1661),(29656,1661),(29657,1661),(29658,1661),(29659,1662),(29660,1662),(29661,1662),(29662,1662),(29663,1663),(29664,1663),(29665,1663),(29666,1663),(29667,1664),(29668,1664),(29669,1664),(29670,1664),(29671,1665),(29672,1665),(29673,1665),(29674,1665),(29675,1666),(29676,1667),(29677,1668),(29678,1669),(29679,1670),(29680,1671),(29681,1672),(29682,1673),(29683,1674),(29684,1675),(29685,1676),(29686,1677),(29687,1678),(29688,1679),(29689,1680),(29690,1681),(29691,1682),(29692,1683),(29693,1684),(29694,1685),(29695,1686),(29696,1687),(29697,1688),(29698,1689),(29699,1690),(29700,1691),(29701,1692),(29702,1693),(29703,1694),(29704,1695),(29705,1696),(29706,1697),(29707,1698),(29708,1699),(29709,1700),(29710,1701),(29711,1702),(29712,1703),(29713,1704),(29714,1705),(29715,1706),(29716,1707),(29717,1708),(29718,1709),(29719,1710),(29720,1711),(29721,1712),(29722,1713),(29723,1714),(29724,1715),(29725,1716),(29726,1717),(29727,1718),(29728,1719),(29729,1720),(29730,1721),(29731,1722),(29732,1723),(29733,1724),(29734,1725),(29735,1726),(29736,1727),(29737,1728),(29738,1729),(29739,1730),(29740,1731),(29741,1732),(29742,1733),(29743,1734),(29744,1735),(29745,1736),(29746,1737),(29747,1738),(29748,1739),(29749,1740),(29750,1741),(29751,1742),(29752,1743),(29753,1744),(29754,1745),(29755,1746),(29756,1747),(29757,1748),(29758,1749),(29759,1750),(29760,1751),(29761,1752),(29762,1753),(29763,1754),(29764,1755),(29765,1756),(29766,1757),(29767,1758),(29768,1759),(29769,1760),(29770,1761),(29771,1762),(29772,1763),(29773,1764),(29774,1765),(29775,1666),(29776,1666),(29777,1666),(29778,1666),(29779,1666),(29780,1666),(29781,1666),(29782,1667),(29783,1667),(29784,1667),(29785,1667),(29786,1667),(29787,1667),(29788,1667),(29789,1668),(29790,1668),(29791,1668),(29792,1668),(29793,1668),(29794,1668),(29795,1668),(29796,1669),(29797,1669),(29798,1669),(29799,1669),(29800,1669),(29801,1669),(29802,1669),(29803,1670),(29804,1670),(29805,1670),(29806,1670),(29807,1670),(29808,1670),(29809,1670),(29810,1671),(29811,1671),(29812,1671),(29813,1671),(29814,1671),(29815,1671),(29816,1671),(29817,1672),(29818,1672),(29819,1672),(29820,1672),(29821,1672),(29822,1672),(29823,1672),(29824,1673),(29825,1673),(29826,1673),(29827,1673),(29828,1673),(29829,1673),(29830,1673),(29831,1674),(29832,1674),(29833,1674),(29834,1674),(29835,1674),(29836,1674),(29837,1674),(29838,1675),(29839,1675),(29840,1675),(29841,1675),(29842,1675),(29843,1675),(29844,1675),(29845,1676),(29846,1676),(29847,1676),(29848,1676),(29849,1676),(29850,1676),(29851,1676),(29852,1677),(29853,1677),(29854,1677),(29855,1677),(29856,1677),(29857,1677),(29858,1677),(29859,1678),(29860,1678),(29861,1678),(29862,1678),(29863,1678),(29864,1678),(29865,1678),(29866,1679),(29867,1679),(29868,1679),(29869,1679),(29870,1679),(29871,1679),(29872,1679),(29873,1679),(29874,1679),(29875,1680),(29876,1680),(29877,1680),(29878,1680),(29879,1680),(29880,1680),(29881,1680),(29882,1680),(29883,1680),(29884,1681),(29885,1681),(29886,1681),(29887,1681),(29888,1681),(29889,1681),(29890,1681),(29891,1681),(29892,1681),(29893,1682),(29894,1682),(29895,1682),(29896,1682),(29897,1682),(29898,1682),(29899,1682),(29900,1682),(29901,1682),(29902,1683),(29903,1683),(29904,1683),(29905,1683),(29906,1683),(29907,1683),(29908,1684),(29909,1684),(29910,1684),(29911,1684),(29912,1684),(29913,1684),(29914,1685),(29915,1685),(29916,1685),(29917,1685),(29918,1685),(29919,1685),(29920,1685),(29921,1685),(29922,1685),(29923,1686),(29924,1686),(29925,1686),(29926,1686),(29927,1686),(29928,1686),(29929,1687),(29930,1687),(29931,1687),(29932,1687),(29933,1687),(29934,1687),(29935,1687),(29936,1688),(29937,1688),(29938,1688),(29939,1688),(29940,1688),(29941,1688),(29942,1688),(29943,1689),(29944,1689),(29945,1689),(29946,1689),(29947,1689),(29948,1689),(29949,1689),(29950,1689),(29951,1689),(29952,1690),(29953,1690),(29954,1690),(29955,1690),(29956,1690),(29957,1690),(29958,1690),(29959,1691),(29960,1691),(29961,1691),(29962,1691),(29963,1691),(29964,1691),(29965,1691),(29966,1692),(29967,1692),(29968,1692),(29969,1692),(29970,1692),(29971,1692),(29972,1692),(29973,1693),(29974,1693),(29975,1693),(29976,1693),(29977,1693),(29978,1693),(29979,1693),(29980,1694),(29981,1694),(29982,1694),(29983,1694),(29984,1694),(29985,1694),(29986,1694),(29987,1695),(29988,1695),(29989,1695),(29990,1695),(29991,1695),(29992,1695),(29993,1695),(29994,1696),(29995,1696),(29996,1696),(29997,1696),(29998,1696),(29999,1696),(30000,1696),(30001,1697),(30002,1697),(30003,1697),(30004,1697),(30005,1697),(30006,1697),(30007,1697),(30008,1698),(30009,1698),(30010,1698),(30011,1698),(30012,1698),(30013,1698),(30014,1698),(30015,1699),(30016,1699),(30017,1699),(30018,1699),(30019,1699),(30020,1699),(30021,1699),(30022,1700),(30023,1700),(30024,1700),(30025,1700),(30026,1700),(30027,1700),(30028,1700),(30029,1700),(30030,1700),(30031,1701),(30032,1701),(30033,1701),(30034,1701),(30035,1701),(30036,1701),(30037,1701),(30038,1701),(30039,1701),(30040,1702),(30041,1702),(30042,1702),(30043,1702),(30044,1702),(30045,1702),(30046,1702),(30047,1702),(30048,1702),(30049,1703),(30050,1703),(30051,1703),(30052,1703),(30053,1703),(30054,1703),(30055,1703),(30056,1703),(30057,1704),(30058,1704),(30059,1704),(30060,1704),(30061,1704),(30062,1704),(30063,1705),(30064,1705),(30065,1705),(30066,1705),(30067,1705),(30068,1705),(30069,1705),(30070,1706),(30071,1706),(30072,1706),(30073,1706),(30074,1706),(30075,1706),(30076,1706),(30077,1707),(30078,1707),(30079,1707),(30080,1707),(30081,1707),(30082,1707),(30083,1707),(30084,1708),(30085,1708),(30086,1708),(30087,1708),(30088,1708),(30089,1708),(30090,1708),(30091,1709),(30092,1709),(30093,1709),(30094,1709),(30095,1709),(30096,1709),(30097,1709),(30098,1710),(30099,1710),(30100,1710),(30101,1710),(30102,1710),(30103,1710),(30104,1710),(30105,1711),(30106,1711),(30107,1711),(30108,1711),(30109,1711),(30110,1711),(30111,1712),(30112,1712),(30113,1712),(30114,1712),(30115,1712),(30116,1712),(30117,1712),(30118,1713),(30119,1713),(30120,1713),(30121,1713),(30122,1713),(30123,1713),(30124,1714),(30125,1714),(30126,1714),(30127,1714),(30128,1714),(30129,1714),(30130,1714),(30131,1715),(30132,1715),(30133,1715),(30134,1715),(30135,1715),(30136,1715),(30137,1715),(30138,1715),(30139,1716),(30140,1716),(30141,1716),(30142,1716),(30143,1716),(30144,1716),(30145,1716),(30146,1716),(30147,1716),(30148,1717),(30149,1717),(30150,1717),(30151,1717),(30152,1717),(30153,1717),(30154,1717),(30155,1717),(30156,1718),(30157,1718),(30158,1718),(30159,1718),(30160,1718),(30161,1718),(30162,1718),(30163,1718),(30164,1718),(30165,1719),(30166,1719),(30167,1719),(30168,1719),(30169,1719),(30170,1719),(30171,1719),(30172,1719),(30173,1719),(30174,1720),(30175,1720),(30176,1720),(30177,1720),(30178,1720),(30179,1720),(30180,1720),(30181,1720),(30182,1720),(30183,1721),(30184,1721),(30185,1721),(30186,1721),(30187,1721),(30188,1721),(30189,1721),(30190,1721),(30191,1721),(30192,1722),(30193,1722),(30194,1722),(30195,1722),(30196,1722),(30197,1722),(30198,1722),(30199,1722),(30200,1722),(30201,1723),(30202,1723),(30203,1723),(30204,1723),(30205,1723),(30206,1723),(30207,1723),(30208,1723),(30209,1723),(30210,1724),(30211,1724),(30212,1724),(30213,1724),(30214,1724),(30215,1724),(30216,1724),(30217,1724),(30218,1724),(30219,1725),(30220,1725),(30221,1725),(30222,1725),(30223,1725),(30224,1725),(30225,1725),(30226,1725),(30227,1725),(30228,1726),(30229,1726),(30230,1726),(30231,1726),(30232,1726),(30233,1726),(30234,1726),(30235,1726),(30236,1727),(30237,1727),(30238,1727),(30239,1727),(30240,1727),(30241,1727),(30242,1727),(30243,1727),(30244,1728),(30245,1728),(30246,1728),(30247,1728),(30248,1728),(30249,1728),(30250,1728),(30251,1728),(30252,1729),(30253,1729),(30254,1729),(30255,1729),(30256,1729),(30257,1729),(30258,1729),(30259,1729),(30260,1730),(30261,1730),(30262,1730),(30263,1730),(30264,1730),(30265,1730),(30266,1730),(30267,1730),(30268,1731),(30269,1731),(30270,1731),(30271,1731),(30272,1731),(30273,1731),(30274,1731),(30275,1731),(30276,1732),(30277,1732),(30278,1732),(30279,1732),(30280,1732),(30281,1732),(30282,1732),(30283,1732),(30284,1733),(30285,1733),(30286,1733),(30287,1733),(30288,1733),(30289,1733),(30290,1733),(30291,1733),(30292,1733),(30293,1734),(30294,1734),(30295,1734),(30296,1734),(30297,1734),(30298,1734),(30299,1734),(30300,1734),(30301,1734),(30302,1735),(30303,1735),(30304,1735),(30305,1735),(30306,1735),(30307,1735),(30308,1735),(30309,1735),(30310,1735),(30311,1736),(30312,1736),(30313,1736),(30314,1736),(30315,1736),(30316,1736),(30317,1736),(30318,1736),(30319,1737),(30320,1737),(30321,1737),(30322,1737),(30323,1737),(30324,1737),(30325,1737),(30326,1737),(30327,1738),(30328,1738),(30329,1738),(30330,1738),(30331,1738),(30332,1738),(30333,1738),(30334,1738),(30335,1739),(30336,1739),(30337,1739),(30338,1739),(30339,1739),(30340,1739),(30341,1739),(30342,1740),(30343,1740),(30344,1740),(30345,1740),(30346,1740),(30347,1740),(30348,1740),(30349,1741),(30350,1741),(30351,1741),(30352,1741),(30353,1741),(30354,1741),(30355,1741),(30356,1742),(30357,1742),(30358,1742),(30359,1742),(30360,1742),(30361,1742),(30362,1742),(30363,1743),(30364,1743),(30365,1743),(30366,1743),(30367,1743),(30368,1743),(30369,1743),(30370,1744),(30371,1744),(30372,1744),(30373,1744),(30374,1744),(30375,1744),(30376,1744),(30377,1745),(30378,1745),(30379,1745),(30380,1745),(30381,1745),(30382,1745),(30383,1745),(30384,1746),(30385,1746),(30386,1746),(30387,1746),(30388,1746),(30389,1746),(30390,1746),(30391,1747),(30392,1747),(30393,1747),(30394,1747),(30395,1747),(30396,1747),(30397,1747),(30398,1748),(30399,1748),(30400,1748),(30401,1748),(30402,1748),(30403,1748),(30404,1748),(30405,1749),(30406,1749),(30407,1749),(30408,1749),(30409,1749),(30410,1749),(30411,1749),(30412,1750),(30413,1750),(30414,1750),(30415,1750),(30416,1750),(30417,1750),(30418,1750),(30419,1751),(30420,1751),(30421,1751),(30422,1751),(30423,1751),(30424,1751),(30425,1751),(30426,1752),(30427,1752),(30428,1752),(30429,1752),(30430,1752),(30431,1752),(30432,1752),(30433,1753),(30434,1753),(30435,1753),(30436,1753),(30437,1753),(30438,1753),(30439,1753),(30440,1754),(30441,1754),(30442,1754),(30443,1754),(30444,1754),(30445,1754),(30446,1754),(30447,1755),(30448,1755),(30449,1755),(30450,1755),(30451,1755),(30452,1755),(30453,1755),(30454,1756),(30455,1756),(30456,1756),(30457,1756),(30458,1756),(30459,1756),(30460,1756),(30461,1757),(30462,1757),(30463,1757),(30464,1757),(30465,1757),(30466,1757),(30467,1757),(30468,1758),(30469,1758),(30470,1758),(30471,1758),(30472,1758),(30473,1758),(30474,1758),(30475,1759),(30476,1759),(30477,1759),(30478,1759),(30479,1759),(30480,1759),(30481,1759),(30482,1760),(30483,1760),(30484,1760),(30485,1760),(30486,1760),(30487,1760),(30488,1760),(30489,1761),(30490,1761),(30491,1761),(30492,1761),(30493,1761),(30494,1761),(30495,1761),(30496,1762),(30497,1762),(30498,1762),(30499,1762),(30500,1762),(30501,1762),(30502,1762),(30503,1763),(30504,1763),(30505,1763),(30506,1763),(30507,1763),(30508,1763),(30509,1763),(30510,1763),(30511,1763),(30512,1764),(30513,1764),(30514,1764),(30515,1764),(30516,1764),(30517,1764),(30518,1764),(30519,1765),(30520,1765),(30521,1765),(30522,1765),(30523,1765),(30524,1765),(30525,1765),(30526,1666),(30527,1666),(30528,1667),(30529,1667),(30530,1668),(30531,1668),(30532,1669),(30533,1669),(30534,1670),(30535,1670),(30536,1671),(30537,1671),(30538,1672),(30539,1672),(30540,1673),(30541,1673),(30542,1674),(30543,1674),(30544,1675),(30545,1675),(30546,1676),(30547,1676),(30548,1677),(30549,1677),(30550,1678),(30551,1678),(30552,1679),(30553,1679),(30554,1680),(30555,1680),(30556,1681),(30557,1681),(30558,1682),(30559,1682),(30560,1683),(30561,1683),(30562,1684),(30563,1684),(30564,1685),(30565,1685),(30566,1686),(30567,1686),(30568,1687),(30569,1687),(30570,1688),(30571,1688),(30572,1689),(30573,1689),(30574,1690),(30575,1690),(30576,1691),(30577,1691),(30578,1692),(30579,1692),(30580,1693),(30581,1693),(30582,1694),(30583,1694),(30584,1695),(30585,1695),(30586,1696),(30587,1696),(30588,1697),(30589,1697),(30590,1698),(30591,1698),(30592,1699),(30593,1699),(30594,1700),(30595,1700),(30596,1701),(30597,1701),(30598,1701),(30599,1702),(30600,1702),(30601,1703),(30602,1703),(30603,1703),(30604,1704),(30605,1704),(30606,1705),(30607,1705),(30608,1705),(30609,1706),(30610,1706),(30611,1706),(30612,1707),(30613,1707),(30614,1707),(30615,1708),(30616,1708),(30617,1709),(30618,1709),(30619,1710),(30620,1710),(30621,1711),(30622,1711),(30623,1712),(30624,1712),(30625,1713),(30626,1713),(30627,1714),(30628,1714),(30629,1715),(30630,1715),(30631,1716),(30632,1716),(30633,1717),(30634,1717),(30635,1718),(30636,1718),(30637,1719),(30638,1719),(30639,1720),(30640,1720),(30641,1721),(30642,1721),(30643,1722),(30644,1722),(30645,1723),(30646,1723),(30647,1724),(30648,1724),(30649,1725),(30650,1725),(30651,1726),(30652,1726),(30653,1727),(30654,1727),(30655,1728),(30656,1728),(30657,1729),(30658,1729),(30659,1730),(30660,1730),(30661,1731),(30662,1731),(30663,1732),(30664,1732),(30665,1733),(30666,1733),(30667,1734),(30668,1734),(30669,1735),(30670,1735),(30671,1736),(30672,1736),(30673,1737),(30674,1737),(30675,1737),(30676,1738),(30677,1738),(30678,1738),(30679,1739),(30680,1739),(30681,1739),(30682,1740),(30683,1740),(30684,1741),(30685,1741),(30686,1741),(30687,1742),(30688,1742),(30689,1742),(30690,1743),(30691,1743),(30692,1744),(30693,1744),(30694,1745),(30695,1745),(30696,1746),(30697,1746),(30698,1747),(30699,1747),(30700,1748),(30701,1748),(30702,1749),(30703,1749),(30704,1750),(30705,1750),(30706,1751),(30707,1751),(30708,1752),(30709,1752),(30710,1753),(30711,1753),(30712,1754),(30713,1754),(30714,1755),(30715,1755),(30716,1756),(30717,1756),(30718,1757),(30719,1757),(30720,1758),(30721,1758),(30722,1759),(30723,1759),(30724,1759),(30725,1760),(30726,1760),(30727,1760),(30728,1761),(30729,1761),(30730,1762),(30731,1762),(30732,1763),(30733,1763),(30734,1764),(30735,1764),(30736,1764),(30737,1765),(30738,1765),(30739,1765),(30740,1666),(30741,1666),(30742,1666),(30743,1667),(30744,1667),(30745,1667),(30746,1668),(30747,1668),(30748,1668),(30749,1669),(30750,1669),(30751,1669),(30752,1670),(30753,1670),(30754,1670),(30755,1671),(30756,1671),(30757,1671),(30758,1672),(30759,1672),(30760,1672),(30761,1673),(30762,1673),(30763,1673),(30764,1674),(30765,1674),(30766,1674),(30767,1675),(30768,1675),(30769,1675),(30770,1676),(30771,1676),(30772,1676),(30773,1677),(30774,1677),(30775,1677),(30776,1678),(30777,1678),(30778,1678),(30779,1679),(30780,1679),(30781,1679),(30782,1680),(30783,1680),(30784,1680),(30785,1681),(30786,1681),(30787,1681),(30788,1682),(30789,1682),(30790,1682),(30791,1683),(30792,1683),(30793,1683),(30794,1684),(30795,1684),(30796,1684),(30797,1685),(30798,1685),(30799,1685),(30800,1686),(30801,1686),(30802,1686),(30803,1687),(30804,1687),(30805,1687),(30806,1688),(30807,1688),(30808,1688),(30809,1689),(30810,1689),(30811,1689),(30812,1690),(30813,1690),(30814,1690),(30815,1691),(30816,1691),(30817,1691),(30818,1692),(30819,1692),(30820,1692),(30821,1693),(30822,1693),(30823,1693),(30824,1694),(30825,1694),(30826,1694),(30827,1695),(30828,1695),(30829,1695),(30830,1696),(30831,1696),(30832,1696),(30833,1697),(30834,1697),(30835,1697),(30836,1698),(30837,1698),(30838,1698),(30839,1699),(30840,1699),(30841,1699),(30842,1700),(30843,1700),(30844,1700),(30845,1701),(30846,1701),(30847,1701),(30848,1702),(30849,1702),(30850,1702),(30851,1703),(30852,1703),(30853,1703),(30854,1704),(30855,1704),(30856,1704),(30857,1705),(30858,1705),(30859,1705),(30860,1706),(30861,1706),(30862,1706),(30863,1707),(30864,1707),(30865,1707),(30866,1708),(30867,1708),(30868,1708),(30869,1709),(30870,1709),(30871,1709),(30872,1710),(30873,1710),(30874,1710),(30875,1711),(30876,1711),(30877,1711),(30878,1711),(30879,1712),(30880,1712),(30881,1712),(30882,1713),(30883,1713),(30884,1713),(30885,1713),(30886,1714),(30887,1714),(30888,1714),(30889,1715),(30890,1715),(30891,1715),(30892,1716),(30893,1716),(30894,1716),(30895,1717),(30896,1717),(30897,1717),(30898,1718),(30899,1718),(30900,1718),(30901,1719),(30902,1719),(30903,1719),(30904,1720),(30905,1720),(30906,1720),(30907,1721),(30908,1721),(30909,1721),(30910,1722),(30911,1722),(30912,1722),(30913,1723),(30914,1723),(30915,1723),(30916,1724),(30917,1724),(30918,1724),(30919,1725),(30920,1725),(30921,1725),(30922,1726),(30923,1726),(30924,1726),(30925,1727),(30926,1727),(30927,1727),(30928,1728),(30929,1728),(30930,1728),(30931,1729),(30932,1729),(30933,1729),(30934,1730),(30935,1730),(30936,1730),(30937,1731),(30938,1731),(30939,1731),(30940,1732),(30941,1732),(30942,1732),(30943,1733),(30944,1733),(30945,1733),(30946,1734),(30947,1734),(30948,1734),(30949,1735),(30950,1735),(30951,1735),(30952,1736),(30953,1736),(30954,1736),(30955,1737),(30956,1737),(30957,1737),(30958,1738),(30959,1738),(30960,1738),(30961,1739),(30962,1739),(30963,1739),(30964,1740),(30965,1740),(30966,1740),(30967,1741),(30968,1741),(30969,1741),(30970,1742),(30971,1742),(30972,1742),(30973,1743),(30974,1743),(30975,1743),(30976,1744),(30977,1744),(30978,1744),(30979,1745),(30980,1745),(30981,1745),(30982,1746),(30983,1746),(30984,1746),(30985,1747),(30986,1747),(30987,1747),(30988,1748),(30989,1748),(30990,1748),(30991,1749),(30992,1749),(30993,1749),(30994,1750),(30995,1750),(30996,1750),(30997,1751),(30998,1751),(30999,1751),(31000,1752),(31001,1752),(31002,1752),(31003,1753),(31004,1753),(31005,1753),(31006,1754),(31007,1754),(31008,1754),(31009,1755),(31010,1755),(31011,1755),(31012,1756),(31013,1756),(31014,1756),(31015,1757),(31016,1757),(31017,1757),(31018,1758),(31019,1758),(31020,1758),(31021,1759),(31022,1759),(31023,1759),(31024,1760),(31025,1760),(31026,1760),(31027,1761),(31028,1761),(31029,1761),(31030,1762),(31031,1762),(31032,1762),(31033,1763),(31034,1763),(31035,1763),(31036,1764),(31037,1764),(31038,1764),(31039,1765),(31040,1765),(31041,1765),(31042,1666),(31043,1666),(31044,1666),(31045,1666),(31046,1667),(31047,1667),(31048,1667),(31049,1667),(31050,1668),(31051,1668),(31052,1668),(31053,1668),(31054,1669),(31055,1669),(31056,1669),(31057,1669),(31058,1670),(31059,1670),(31060,1670),(31061,1670),(31062,1671),(31063,1671),(31064,1671),(31065,1671),(31066,1672),(31067,1672),(31068,1672),(31069,1672),(31070,1673),(31071,1673),(31072,1673),(31073,1673),(31074,1674),(31075,1674),(31076,1674),(31077,1674),(31078,1675),(31079,1675),(31080,1675),(31081,1675),(31082,1676),(31083,1676),(31084,1676),(31085,1676),(31086,1677),(31087,1677),(31088,1677),(31089,1677),(31090,1678),(31091,1678),(31092,1678),(31093,1678),(31094,1679),(31095,1679),(31096,1679),(31097,1679),(31098,1680),(31099,1680),(31100,1680),(31101,1680),(31102,1681),(31103,1681),(31104,1681),(31105,1681),(31106,1682),(31107,1682),(31108,1682),(31109,1682),(31110,1683),(31111,1683),(31112,1683),(31113,1683),(31114,1684),(31115,1684),(31116,1684),(31117,1684),(31118,1685),(31119,1685),(31120,1685),(31121,1685),(31122,1686),(31123,1686),(31124,1686),(31125,1686),(31126,1687),(31127,1687),(31128,1687),(31129,1687),(31130,1688),(31131,1688),(31132,1688),(31133,1688),(31134,1689),(31135,1689),(31136,1689),(31137,1689),(31138,1690),(31139,1690),(31140,1690),(31141,1690),(31142,1691),(31143,1691),(31144,1691),(31145,1691),(31146,1692),(31147,1692),(31148,1692),(31149,1692),(31150,1693),(31151,1693),(31152,1693),(31153,1693),(31154,1694),(31155,1694),(31156,1694),(31157,1694),(31158,1695),(31159,1695),(31160,1695),(31161,1695),(31162,1696),(31163,1696),(31164,1696),(31165,1696),(31166,1697),(31167,1697),(31168,1697),(31169,1697),(31170,1698),(31171,1698),(31172,1698),(31173,1698),(31174,1699),(31175,1699),(31176,1699),(31177,1699),(31178,1700),(31179,1700),(31180,1700),(31181,1700),(31182,1701),(31183,1701),(31184,1701),(31185,1701),(31186,1702),(31187,1702),(31188,1702),(31189,1702),(31190,1703),(31191,1703),(31192,1703),(31193,1703),(31194,1704),(31195,1704),(31196,1704),(31197,1704),(31198,1705),(31199,1705),(31200,1705),(31201,1705),(31202,1706),(31203,1706),(31204,1706),(31205,1706),(31206,1707),(31207,1707),(31208,1707),(31209,1707),(31210,1708),(31211,1708),(31212,1708),(31213,1708),(31214,1709),(31215,1709),(31216,1709),(31217,1709),(31218,1710),(31219,1710),(31220,1710),(31221,1710),(31222,1711),(31223,1711),(31224,1711),(31225,1711),(31226,1712),(31227,1712),(31228,1712),(31229,1712),(31230,1713),(31231,1713),(31232,1713),(31233,1713),(31234,1714),(31235,1714),(31236,1714),(31237,1714),(31238,1715),(31239,1715),(31240,1715),(31241,1715),(31242,1716),(31243,1716),(31244,1716),(31245,1716),(31246,1717),(31247,1717),(31248,1717),(31249,1717),(31250,1718),(31251,1718),(31252,1718),(31253,1718),(31254,1719),(31255,1719),(31256,1719),(31257,1719),(31258,1720),(31259,1720),(31260,1720),(31261,1720),(31262,1721),(31263,1721),(31264,1721),(31265,1721),(31266,1722),(31267,1722),(31268,1722),(31269,1722),(31270,1723),(31271,1723),(31272,1723),(31273,1723),(31274,1724),(31275,1724),(31276,1724),(31277,1724),(31278,1725),(31279,1725),(31280,1725),(31281,1725),(31282,1726),(31283,1726),(31284,1726),(31285,1726),(31286,1727),(31287,1727),(31288,1727),(31289,1727),(31290,1728),(31291,1728),(31292,1728),(31293,1728),(31294,1729),(31295,1729),(31296,1729),(31297,1729),(31298,1730),(31299,1730),(31300,1730),(31301,1730),(31302,1731),(31303,1731),(31304,1731),(31305,1731),(31306,1732),(31307,1732),(31308,1732),(31309,1732),(31310,1733),(31311,1733),(31312,1733),(31313,1733),(31314,1734),(31315,1734),(31316,1734),(31317,1734),(31318,1735),(31319,1735),(31320,1735),(31321,1735),(31322,1736),(31323,1736),(31324,1736),(31325,1736),(31326,1737),(31327,1737),(31328,1737),(31329,1737),(31330,1738),(31331,1738),(31332,1738),(31333,1738),(31334,1739),(31335,1739),(31336,1739),(31337,1739),(31338,1740),(31339,1740),(31340,1740),(31341,1740),(31342,1741),(31343,1741),(31344,1741),(31345,1741),(31346,1742),(31347,1742),(31348,1742),(31349,1742),(31350,1743),(31351,1743),(31352,1743),(31353,1743),(31354,1744),(31355,1744),(31356,1744),(31357,1744),(31358,1745),(31359,1745),(31360,1745),(31361,1745),(31362,1746),(31363,1746),(31364,1746),(31365,1746),(31366,1747),(31367,1747),(31368,1747),(31369,1747),(31370,1748),(31371,1748),(31372,1748),(31373,1748),(31374,1749),(31375,1749),(31376,1749),(31377,1749),(31378,1750),(31379,1750),(31380,1750),(31381,1750),(31382,1751),(31383,1751),(31384,1751),(31385,1751),(31386,1752),(31387,1752),(31388,1752),(31389,1752),(31390,1753),(31391,1753),(31392,1753),(31393,1753),(31394,1754),(31395,1754),(31396,1754),(31397,1754),(31398,1755),(31399,1755),(31400,1755),(31401,1755),(31402,1756),(31403,1756),(31404,1756),(31405,1756),(31406,1757),(31407,1757),(31408,1757),(31409,1757),(31410,1758),(31411,1758),(31412,1758),(31413,1758),(31414,1759),(31415,1759),(31416,1759),(31417,1759),(31418,1760),(31419,1760),(31420,1760),(31421,1760),(31422,1761),(31423,1761),(31424,1761),(31425,1761),(31426,1762),(31427,1762),(31428,1762),(31429,1762),(31430,1763),(31431,1763),(31432,1763),(31433,1763),(31434,1764),(31435,1764),(31436,1764),(31437,1764),(31438,1765),(31439,1765),(31440,1765),(31441,1765),(31442,1766),(31443,1767),(31444,1768),(31445,1769),(31446,1770),(31447,1771),(31448,1772),(31449,1773),(31450,1774),(31451,1775),(31452,1776),(31453,1777),(31454,1778),(31455,1779),(31456,1780),(31457,1781),(31458,1782),(31459,1783),(31460,1784),(31461,1785),(31462,1786),(31463,1787),(31464,1788),(31465,1789),(31466,1790),(31467,1791),(31468,1792),(31469,1793),(31470,1794),(31471,1795),(31472,1796),(31473,1797),(31474,1798),(31475,1799),(31476,1800),(31477,1801),(31478,1802),(31479,1803),(31480,1804),(31481,1805),(31482,1806),(31483,1807),(31484,1808),(31485,1809),(31486,1810),(31487,1811),(31488,1812),(31489,1766),(31490,1766),(31491,1766),(31492,1766),(31493,1766),(31494,1766),(31495,1767),(31496,1767),(31497,1767),(31498,1767),(31499,1767),(31500,1767),(31501,1768),(31502,1768),(31503,1768),(31504,1768),(31505,1768),(31506,1768),(31507,1769),(31508,1769),(31509,1769),(31510,1769),(31511,1769),(31512,1769),(31513,1769),(31514,1770),(31515,1770),(31516,1770),(31517,1770),(31518,1770),(31519,1770),(31520,1771),(31521,1771),(31522,1771),(31523,1771),(31524,1771),(31525,1771),(31526,1772),(31527,1772),(31528,1772),(31529,1772),(31530,1772),(31531,1772),(31532,1772),(31533,1773),(31534,1773),(31535,1773),(31536,1773),(31537,1773),(31538,1773),(31539,1773),(31540,1773),(31541,1773),(31542,1774),(31543,1774),(31544,1774),(31545,1774),(31546,1774),(31547,1774),(31548,1774),(31549,1775),(31550,1775),(31551,1775),(31552,1775),(31553,1775),(31554,1775),(31555,1775),(31556,1776),(31557,1776),(31558,1776),(31559,1776),(31560,1776),(31561,1776),(31562,1776),(31563,1777),(31564,1777),(31565,1777),(31566,1777),(31567,1777),(31568,1777),(31569,1778),(31570,1778),(31571,1778),(31572,1778),(31573,1778),(31574,1778),(31575,1778),(31576,1779),(31577,1779),(31578,1779),(31579,1779),(31580,1779),(31581,1779),(31582,1779),(31583,1780),(31584,1780),(31585,1780),(31586,1780),(31587,1780),(31588,1780),(31589,1780),(31590,1781),(31591,1781),(31592,1781),(31593,1781),(31594,1781),(31595,1781),(31596,1781),(31597,1782),(31598,1782),(31599,1782),(31600,1782),(31601,1782),(31602,1782),(31603,1782),(31604,1783),(31605,1783),(31606,1783),(31607,1783),(31608,1783),(31609,1783),(31610,1783),(31611,1784),(31612,1784),(31613,1784),(31614,1784),(31615,1784),(31616,1784),(31617,1784),(31618,1785),(31619,1785),(31620,1785),(31621,1785),(31622,1785),(31623,1785),(31624,1786),(31625,1786),(31626,1786),(31627,1786),(31628,1786),(31629,1786),(31630,1786),(31631,1787),(31632,1787),(31633,1787),(31634,1787),(31635,1787),(31636,1787),(31637,1787),(31638,1788),(31639,1788),(31640,1788),(31641,1788),(31642,1788),(31643,1788),(31644,1788),(31645,1789),(31646,1789),(31647,1789),(31648,1789),(31649,1789),(31650,1789),(31651,1789),(31652,1790),(31653,1790),(31654,1790),(31655,1790),(31656,1790),(31657,1790),(31658,1790),(31659,1791),(31660,1791),(31661,1791),(31662,1791),(31663,1791),(31664,1791),(31665,1791),(31666,1791),(31667,1791),(31668,1792),(31669,1792),(31670,1792),(31671,1792),(31672,1792),(31673,1792),(31674,1792),(31675,1792),(31676,1792),(31677,1793),(31678,1793),(31679,1793),(31680,1793),(31681,1793),(31682,1793),(31683,1793),(31684,1794),(31685,1794),(31686,1794),(31687,1794),(31688,1794),(31689,1794),(31690,1794),(31691,1795),(31692,1795),(31693,1795),(31694,1795),(31695,1795),(31696,1795),(31697,1795),(31698,1796),(31699,1796),(31700,1796),(31701,1796),(31702,1796),(31703,1796),(31704,1796),(31705,1796),(31706,1796),(31707,1797),(31708,1797),(31709,1797),(31710,1797),(31711,1797),(31712,1797),(31713,1797),(31714,1797),(31715,1797),(31716,1798),(31717,1798),(31718,1798),(31719,1798),(31720,1798),(31721,1798),(31722,1798),(31723,1798),(31724,1798),(31725,1799),(31726,1799),(31727,1799),(31728,1799),(31729,1799),(31730,1799),(31731,1799),(31732,1800),(31733,1800),(31734,1800),(31735,1800),(31736,1800),(31737,1800),(31738,1800),(31739,1801),(31740,1801),(31741,1801),(31742,1801),(31743,1801),(31744,1801),(31745,1801),(31746,1802),(31747,1802),(31748,1802),(31749,1802),(31750,1802),(31751,1802),(31752,1802),(31753,1803),(31754,1803),(31755,1803),(31756,1803),(31757,1803),(31758,1803),(31759,1803),(31760,1803),(31761,1803),(31762,1804),(31763,1804),(31764,1804),(31765,1804),(31766,1804),(31767,1804),(31768,1804),(31769,1804),(31770,1804),(31771,1805),(31772,1805),(31773,1805),(31774,1805),(31775,1805),(31776,1805),(31777,1805),(31778,1805),(31779,1805),(31780,1806),(31781,1806),(31782,1806),(31783,1806),(31784,1806),(31785,1806),(31786,1806),(31787,1806),(31788,1806),(31789,1807),(31790,1807),(31791,1807),(31792,1807),(31793,1807),(31794,1807),(31795,1807),(31796,1807),(31797,1807),(31798,1808),(31799,1808),(31800,1808),(31801,1808),(31802,1808),(31803,1808),(31804,1808),(31805,1808),(31806,1808),(31807,1809),(31808,1809),(31809,1809),(31810,1809),(31811,1809),(31812,1809),(31813,1809),(31814,1809),(31815,1809),(31816,1810),(31817,1810),(31818,1810),(31819,1810),(31820,1810),(31821,1810),(31822,1810),(31823,1810),(31824,1810),(31825,1811),(31826,1811),(31827,1811),(31828,1811),(31829,1811),(31830,1811),(31831,1811),(31832,1811),(31833,1811),(31834,1812),(31835,1812),(31836,1812),(31837,1812),(31838,1812),(31839,1812),(31840,1766),(31841,1766),(31842,1766),(31843,1767),(31844,1767),(31845,1767),(31846,1768),(31847,1768),(31848,1768),(31849,1769),(31850,1769),(31851,1769),(31852,1770),(31853,1770),(31854,1770),(31855,1771),(31856,1771),(31857,1771),(31858,1772),(31859,1772),(31860,1772),(31861,1773),(31862,1773),(31863,1774),(31864,1774),(31865,1774),(31866,1775),(31867,1775),(31868,1776),(31869,1776),(31870,1776),(31871,1777),(31872,1777),(31873,1777),(31874,1778),(31875,1778),(31876,1779),(31877,1779),(31878,1780),(31879,1780),(31880,1781),(31881,1781),(31882,1782),(31883,1782),(31884,1783),(31885,1783),(31886,1783),(31887,1784),(31888,1784),(31889,1784),(31890,1785),(31891,1785),(31892,1786),(31893,1786),(31894,1787),(31895,1787),(31896,1788),(31897,1788),(31898,1789),(31899,1789),(31900,1790),(31901,1790),(31902,1791),(31903,1791),(31904,1792),(31905,1792),(31906,1793),(31907,1793),(31908,1794),(31909,1794),(31910,1795),(31911,1795),(31912,1796),(31913,1796),(31914,1796),(31915,1797),(31916,1797),(31917,1797),(31918,1798),(31919,1798),(31920,1799),(31921,1799),(31922,1800),(31923,1800),(31924,1801),(31925,1801),(31926,1802),(31927,1802),(31928,1803),(31929,1803),(31930,1804),(31931,1804),(31932,1805),(31933,1805),(31934,1806),(31935,1806),(31936,1807),(31937,1807),(31938,1808),(31939,1808),(31940,1809),(31941,1809),(31942,1810),(31943,1810),(31944,1811),(31945,1811),(31946,1812),(31947,1812),(31948,1812),(31949,1766),(31950,1766),(31951,1766),(31952,1767),(31953,1767),(31954,1767),(31955,1768),(31956,1768),(31957,1768),(31958,1769),(31959,1769),(31960,1769),(31961,1770),(31962,1770),(31963,1770),(31964,1771),(31965,1771),(31966,1771),(31967,1772),(31968,1772),(31969,1772),(31970,1773),(31971,1773),(31972,1773),(31973,1774),(31974,1774),(31975,1774),(31976,1775),(31977,1775),(31978,1775),(31979,1776),(31980,1776),(31981,1776),(31982,1777),(31983,1777),(31984,1777),(31985,1778),(31986,1778),(31987,1778),(31988,1779),(31989,1779),(31990,1779),(31991,1780),(31992,1780),(31993,1780),(31994,1781),(31995,1781),(31996,1781),(31997,1782),(31998,1782),(31999,1782),(32000,1783),(32001,1783),(32002,1783),(32003,1784),(32004,1784),(32005,1784),(32006,1785),(32007,1785),(32008,1785),(32009,1786),(32010,1786),(32011,1786),(32012,1787),(32013,1787),(32014,1787),(32015,1788),(32016,1788),(32017,1788),(32018,1789),(32019,1789),(32020,1789),(32021,1790),(32022,1790),(32023,1790),(32024,1791),(32025,1791),(32026,1791),(32027,1792),(32028,1792),(32029,1792),(32030,1793),(32031,1793),(32032,1793),(32033,1794),(32034,1794),(32035,1794),(32036,1795),(32037,1795),(32038,1795),(32039,1796),(32040,1796),(32041,1797),(32042,1797),(32043,1798),(32044,1798),(32045,1798),(32046,1799),(32047,1799),(32048,1799),(32049,1800),(32050,1800),(32051,1800),(32052,1801),(32053,1801),(32054,1801),(32055,1802),(32056,1802),(32057,1802),(32058,1803),(32059,1803),(32060,1803),(32061,1803),(32062,1804),(32063,1804),(32064,1804),(32065,1805),(32066,1805),(32067,1805),(32068,1806),(32069,1806),(32070,1806),(32071,1807),(32072,1807),(32073,1807),(32074,1808),(32075,1808),(32076,1808),(32077,1809),(32078,1809),(32079,1809),(32080,1810),(32081,1810),(32082,1810),(32083,1811),(32084,1811),(32085,1811),(32086,1812),(32087,1812),(32088,1812),(32089,1766),(32090,1766),(32091,1766),(32092,1766),(32093,1767),(32094,1767),(32095,1767),(32096,1767),(32097,1768),(32098,1768),(32099,1768),(32100,1768),(32101,1769),(32102,1769),(32103,1769),(32104,1769),(32105,1770),(32106,1770),(32107,1770),(32108,1770),(32109,1771),(32110,1771),(32111,1771),(32112,1771),(32113,1772),(32114,1772),(32115,1772),(32116,1772),(32117,1773),(32118,1773),(32119,1773),(32120,1773),(32121,1774),(32122,1774),(32123,1774),(32124,1774),(32125,1775),(32126,1775),(32127,1775),(32128,1775),(32129,1776),(32130,1776),(32131,1776),(32132,1776),(32133,1777),(32134,1777),(32135,1777),(32136,1777),(32137,1778),(32138,1778),(32139,1778),(32140,1778),(32141,1779),(32142,1779),(32143,1779),(32144,1779),(32145,1780),(32146,1780),(32147,1780),(32148,1780),(32149,1781),(32150,1781),(32151,1781),(32152,1781),(32153,1782),(32154,1782),(32155,1782),(32156,1782),(32157,1783),(32158,1783),(32159,1783),(32160,1783),(32161,1784),(32162,1784),(32163,1784),(32164,1784),(32165,1785),(32166,1785),(32167,1785),(32168,1785),(32169,1786),(32170,1786),(32171,1786),(32172,1786),(32173,1787),(32174,1787),(32175,1787),(32176,1787),(32177,1788),(32178,1788),(32179,1788),(32180,1788),(32181,1789),(32182,1789),(32183,1789),(32184,1789),(32185,1790),(32186,1790),(32187,1790),(32188,1790),(32189,1791),(32190,1791),(32191,1791),(32192,1791),(32193,1792),(32194,1792),(32195,1792),(32196,1792),(32197,1793),(32198,1793),(32199,1793),(32200,1793),(32201,1794),(32202,1794),(32203,1794),(32204,1794),(32205,1795),(32206,1795),(32207,1795),(32208,1795),(32209,1796),(32210,1796),(32211,1796),(32212,1796),(32213,1797),(32214,1797),(32215,1797),(32216,1797),(32217,1798),(32218,1798),(32219,1798),(32220,1798),(32221,1799),(32222,1799),(32223,1799),(32224,1799),(32225,1800),(32226,1800),(32227,1800),(32228,1800),(32229,1801),(32230,1801),(32231,1801),(32232,1801),(32233,1802),(32234,1802),(32235,1802),(32236,1802),(32237,1803),(32238,1803),(32239,1803),(32240,1803),(32241,1804),(32242,1804),(32243,1804),(32244,1804),(32245,1805),(32246,1805),(32247,1805),(32248,1805),(32249,1806),(32250,1806),(32251,1806),(32252,1806),(32253,1807),(32254,1807),(32255,1807),(32256,1807),(32257,1808),(32258,1808),(32259,1808),(32260,1808),(32261,1809),(32262,1809),(32263,1809),(32264,1809),(32265,1810),(32266,1810),(32267,1810),(32268,1810),(32269,1811),(32270,1811),(32271,1811),(32272,1811),(32273,1812),(32274,1812),(32275,1812),(32276,1812),(32277,1813),(32278,1814),(32279,1815),(32280,1816),(32281,1817),(32282,1818),(32283,1819),(32284,1820),(32285,1821),(32286,1822),(32287,1823),(32288,1813),(32289,1813),(32290,1813),(32291,1813),(32292,1813),(32293,1813),(32294,1813),(32295,1814),(32296,1814),(32297,1814),(32298,1814),(32299,1814),(32300,1814),(32301,1814),(32302,1815),(32303,1815),(32304,1815),(32305,1815),(32306,1815),(32307,1815),(32308,1815),(32309,1816),(32310,1816),(32311,1816),(32312,1816),(32313,1816),(32314,1816),(32315,1816),(32316,1817),(32317,1817),(32318,1817),(32319,1817),(32320,1817),(32321,1817),(32322,1817),(32323,1818),(32324,1818),(32325,1818),(32326,1818),(32327,1818),(32328,1818),(32329,1818),(32330,1819),(32331,1819),(32332,1819),(32333,1819),(32334,1819),(32335,1819),(32336,1819),(32337,1820),(32338,1820),(32339,1820),(32340,1820),(32341,1820),(32342,1820),(32343,1820),(32344,1821),(32345,1821),(32346,1821),(32347,1821),(32348,1821),(32349,1821),(32350,1821),(32351,1822),(32352,1822),(32353,1822),(32354,1822),(32355,1822),(32356,1822),(32357,1822),(32358,1823),(32359,1823),(32360,1823),(32361,1823),(32362,1823),(32363,1823),(32364,1823),(32365,1813),(32366,1813),(32367,1813),(32368,1814),(32369,1814),(32370,1815),(32371,1815),(32372,1815),(32373,1816),(32374,1816),(32375,1816),(32376,1817),(32377,1817),(32378,1818),(32379,1818),(32380,1818),(32381,1819),(32382,1819),(32383,1819),(32384,1820),(32385,1820),(32386,1820),(32387,1821),(32388,1821),(32389,1822),(32390,1822),(32391,1822),(32392,1823),(32393,1823),(32394,1823),(32395,1813),(32396,1813),(32397,1813),(32398,1814),(32399,1814),(32400,1814),(32401,1815),(32402,1815),(32403,1815),(32404,1816),(32405,1816),(32406,1816),(32407,1817),(32408,1817),(32409,1817),(32410,1818),(32411,1818),(32412,1818),(32413,1819),(32414,1819),(32415,1819),(32416,1820),(32417,1820),(32418,1820),(32419,1821),(32420,1821),(32421,1821),(32422,1822),(32423,1822),(32424,1822),(32425,1823),(32426,1823),(32427,1823),(32428,1813),(32429,1813),(32430,1813),(32431,1813),(32432,1814),(32433,1814),(32434,1814),(32435,1814),(32436,1815),(32437,1815),(32438,1815),(32439,1815),(32440,1816),(32441,1816),(32442,1816),(32443,1816),(32444,1817),(32445,1817),(32446,1817),(32447,1817),(32448,1818),(32449,1818),(32450,1818),(32451,1818),(32452,1819),(32453,1819),(32454,1819),(32455,1819),(32456,1820),(32457,1820),(32458,1820),(32459,1820),(32460,1821),(32461,1821),(32462,1821),(32463,1821),(32464,1822),(32465,1822),(32466,1822),(32467,1822),(32468,1823),(32469,1823),(32470,1823),(32471,1823),(32472,1824),(32473,1825),(32474,1826),(32475,1827),(32476,1828),(32477,1829),(32478,1830),(32479,1831),(32480,1832),(32481,1833),(32482,1834),(32483,1835),(32484,1836),(32485,1837),(32486,1838),(32487,1839),(32488,1840),(32489,1841),(32490,1842),(32491,1843),(32492,1844),(32493,1845),(32494,1846),(32495,1847),(32496,1848),(32497,1849),(32498,1850),(32499,1851),(32500,1852),(32501,1853),(32502,1854),(32503,1855),(32504,1856),(32505,1857),(32506,1858),(32507,1859),(32508,1860),(32509,1861),(32510,1862),(32511,1863),(32512,1864),(32513,1865),(32514,1866),(32515,1867),(32516,1868),(32517,1869),(32518,1870),(32519,1871),(32520,1872),(32521,1873),(32522,1874),(32523,1875),(32524,1876),(32525,1877),(32526,1878),(32527,1879),(32528,1880),(32529,1881),(32530,1882),(32531,1883),(32532,1884),(32533,1885),(32534,1886),(32535,1887),(32536,1888),(32537,1889),(32538,1890),(32539,1891),(32540,1892),(32541,1893),(32542,1894),(32543,1895),(32544,1896),(32545,1897),(32546,1898),(32547,1899),(32548,1900),(32549,1901),(32550,1902),(32551,1903),(32552,1904),(32553,1905),(32554,1906),(32555,1907),(32556,1908),(32557,1909),(32558,1910),(32559,1911),(32560,1912),(32561,1824),(32562,1824),(32563,1824),(32564,1824),(32565,1824),(32566,1824),(32567,1824),(32568,1824),(32569,1824),(32570,1825),(32571,1825),(32572,1825),(32573,1825),(32574,1825),(32575,1825),(32576,1825),(32577,1826),(32578,1826),(32579,1826),(32580,1826),(32581,1826),(32582,1826),(32583,1826),(32584,1827),(32585,1827),(32586,1827),(32587,1827),(32588,1827),(32589,1827),(32590,1827),(32591,1828),(32592,1828),(32593,1828),(32594,1828),(32595,1828),(32596,1828),(32597,1828),(32598,1829),(32599,1829),(32600,1829),(32601,1829),(32602,1829),(32603,1829),(32604,1829),(32605,1830),(32606,1830),(32607,1830),(32608,1830),(32609,1830),(32610,1830),(32611,1830),(32612,1831),(32613,1831),(32614,1831),(32615,1831),(32616,1831),(32617,1831),(32618,1831),(32619,1832),(32620,1832),(32621,1832),(32622,1832),(32623,1832),(32624,1832),(32625,1832),(32626,1833),(32627,1833),(32628,1833),(32629,1833),(32630,1833),(32631,1833),(32632,1833),(32633,1834),(32634,1834),(32635,1834),(32636,1834),(32637,1834),(32638,1834),(32639,1835),(32640,1835),(32641,1835),(32642,1835),(32643,1836),(32644,1836),(32645,1836),(32646,1836),(32647,1836),(32648,1836),(32649,1836),(32650,1836),(32651,1836),(32652,1837),(32653,1837),(32654,1837),(32655,1837),(32656,1837),(32657,1837),(32658,1837),(32659,1837),(32660,1837),(32661,1838),(32662,1838),(32663,1838),(32664,1838),(32665,1838),(32666,1838),(32667,1838),(32668,1838),(32669,1838),(32670,1839),(32671,1839),(32672,1839),(32673,1839),(32674,1839),(32675,1839),(32676,1839),(32677,1839),(32678,1839),(32679,1840),(32680,1840),(32681,1840),(32682,1840),(32683,1840),(32684,1840),(32685,1840),(32686,1840),(32687,1840),(32688,1841),(32689,1841),(32690,1841),(32691,1841),(32692,1841),(32693,1841),(32694,1841),(32695,1841),(32696,1841),(32697,1842),(32698,1842),(32699,1842),(32700,1842),(32701,1842),(32702,1842),(32703,1842),(32704,1842),(32705,1842),(32706,1843),(32707,1843),(32708,1843),(32709,1843),(32710,1843),(32711,1843),(32712,1843),(32713,1843),(32714,1843),(32715,1844),(32716,1844),(32717,1844),(32718,1844),(32719,1844),(32720,1844),(32721,1844),(32722,1844),(32723,1844),(32724,1845),(32725,1845),(32726,1845),(32727,1845),(32728,1845),(32729,1845),(32730,1845),(32731,1845),(32732,1845),(32733,1846),(32734,1846),(32735,1846),(32736,1846),(32737,1846),(32738,1846),(32739,1846),(32740,1846),(32741,1846),(32742,1847),(32743,1847),(32744,1847),(32745,1847),(32746,1847),(32747,1847),(32748,1847),(32749,1847),(32750,1847),(32751,1848),(32752,1848),(32753,1848),(32754,1848),(32755,1848),(32756,1848),(32757,1848),(32758,1848),(32759,1848),(32760,1849),(32761,1849),(32762,1849),(32763,1849),(32764,1849),(32765,1849),(32766,1849),(32767,1849),(32768,1849),(32769,1850),(32770,1850),(32771,1850),(32772,1850),(32773,1850),(32774,1850),(32775,1850),(32776,1850),(32777,1850),(32778,1851),(32779,1851),(32780,1851),(32781,1851),(32782,1851),(32783,1851),(32784,1851),(32785,1851),(32786,1851),(32787,1852),(32788,1852),(32789,1852),(32790,1852),(32791,1852),(32792,1852),(32793,1852),(32794,1852),(32795,1852),(32796,1853),(32797,1853),(32798,1853),(32799,1853),(32800,1853),(32801,1853),(32802,1853),(32803,1853),(32804,1853),(32805,1854),(32806,1854),(32807,1854),(32808,1854),(32809,1854),(32810,1854),(32811,1854),(32812,1854),(32813,1854),(32814,1855),(32815,1855),(32816,1855),(32817,1855),(32818,1855),(32819,1855),(32820,1855),(32821,1855),(32822,1855),(32823,1856),(32824,1856),(32825,1856),(32826,1856),(32827,1856),(32828,1856),(32829,1856),(32830,1856),(32831,1856),(32832,1857),(32833,1857),(32834,1857),(32835,1857),(32836,1857),(32837,1857),(32838,1857),(32839,1857),(32840,1857),(32841,1858),(32842,1858),(32843,1858),(32844,1858),(32845,1858),(32846,1858),(32847,1858),(32848,1858),(32849,1858),(32850,1859),(32851,1859),(32852,1859),(32853,1859),(32854,1859),(32855,1859),(32856,1859),(32857,1859),(32858,1859),(32859,1860),(32860,1860),(32861,1860),(32862,1860),(32863,1860),(32864,1860),(32865,1860),(32866,1860),(32867,1860),(32868,1861),(32869,1861),(32870,1861),(32871,1861),(32872,1861),(32873,1861),(32874,1861),(32875,1861),(32876,1861),(32877,1862),(32878,1862),(32879,1862),(32880,1862),(32881,1862),(32882,1862),(32883,1862),(32884,1862),(32885,1862),(32886,1863),(32887,1863),(32888,1863),(32889,1863),(32890,1863),(32891,1863),(32892,1863),(32893,1863),(32894,1863),(32895,1864),(32896,1864),(32897,1864),(32898,1864),(32899,1864),(32900,1864),(32901,1864),(32902,1864),(32903,1864),(32904,1865),(32905,1865),(32906,1865),(32907,1865),(32908,1865),(32909,1865),(32910,1865),(32911,1865),(32912,1865),(32913,1866),(32914,1866),(32915,1866),(32916,1866),(32917,1866),(32918,1866),(32919,1866),(32920,1867),(32921,1867),(32922,1867),(32923,1867),(32924,1867),(32925,1867),(32926,1867),(32927,1867),(32928,1867),(32929,1868),(32930,1868),(32931,1868),(32932,1868),(32933,1868),(32934,1868),(32935,1868),(32936,1869),(32937,1869),(32938,1869),(32939,1869),(32940,1869),(32941,1869),(32942,1869),(32943,1869),(32944,1869),(32945,1870),(32946,1870),(32947,1870),(32948,1870),(32949,1870),(32950,1870),(32951,1870),(32952,1870),(32953,1870),(32954,1871),(32955,1871),(32956,1871),(32957,1871),(32958,1871),(32959,1871),(32960,1871),(32961,1871),(32962,1871),(32963,1872),(32964,1872),(32965,1872),(32966,1872),(32967,1872),(32968,1872),(32969,1872),(32970,1872),(32971,1872),(32972,1873),(32973,1873),(32974,1873),(32975,1873),(32976,1873),(32977,1873),(32978,1873),(32979,1873),(32980,1873),(32981,1874),(32982,1874),(32983,1874),(32984,1874),(32985,1874),(32986,1874),(32987,1874),(32988,1874),(32989,1874),(32990,1875),(32991,1875),(32992,1875),(32993,1875),(32994,1875),(32995,1875),(32996,1875),(32997,1875),(32998,1875),(32999,1876),(33000,1876),(33001,1876),(33002,1876),(33003,1876),(33004,1876),(33005,1876),(33006,1876),(33007,1876),(33008,1877),(33009,1877),(33010,1877),(33011,1877),(33012,1877),(33013,1877),(33014,1877),(33015,1878),(33016,1878),(33017,1878),(33018,1878),(33019,1878),(33020,1878),(33021,1878),(33022,1879),(33023,1879),(33024,1879),(33025,1879),(33026,1879),(33027,1879),(33028,1879),(33029,1879),(33030,1879),(33031,1880),(33032,1880),(33033,1880),(33034,1880),(33035,1880),(33036,1880),(33037,1880),(33038,1881),(33039,1881),(33040,1881),(33041,1881),(33042,1881),(33043,1881),(33044,1881),(33045,1882),(33046,1882),(33047,1882),(33048,1882),(33049,1882),(33050,1882),(33051,1882),(33052,1882),(33053,1882),(33054,1883),(33055,1883),(33056,1883),(33057,1883),(33058,1883),(33059,1883),(33060,1883),(33061,1883),(33062,1883),(33063,1884),(33064,1884),(33065,1884),(33066,1884),(33067,1884),(33068,1884),(33069,1884),(33070,1884),(33071,1884),(33072,1885),(33073,1885),(33074,1885),(33075,1885),(33076,1885),(33077,1885),(33078,1885),(33079,1885),(33080,1885),(33081,1886),(33082,1886),(33083,1886),(33084,1886),(33085,1886),(33086,1886),(33087,1886),(33088,1886),(33089,1886),(33090,1887),(33091,1887),(33092,1887),(33093,1887),(33094,1887),(33095,1887),(33096,1887),(33097,1887),(33098,1887),(33099,1888),(33100,1888),(33101,1888),(33102,1888),(33103,1888),(33104,1888),(33105,1888),(33106,1888),(33107,1888),(33108,1889),(33109,1889),(33110,1889),(33111,1889),(33112,1889),(33113,1889),(33114,1889),(33115,1889),(33116,1889),(33117,1890),(33118,1890),(33119,1890),(33120,1890),(33121,1890),(33122,1890),(33123,1890),(33124,1890),(33125,1890),(33126,1891),(33127,1891),(33128,1891),(33129,1891),(33130,1891),(33131,1891),(33132,1891),(33133,1891),(33134,1891),(33135,1892),(33136,1892),(33137,1892),(33138,1892),(33139,1892),(33140,1892),(33141,1892),(33142,1892),(33143,1892),(33144,1893),(33145,1893),(33146,1893),(33147,1893),(33148,1893),(33149,1893),(33150,1893),(33151,1893),(33152,1893),(33153,1894),(33154,1894),(33155,1894),(33156,1894),(33157,1894),(33158,1894),(33159,1894),(33160,1894),(33161,1894),(33162,1895),(33163,1895),(33164,1895),(33165,1895),(33166,1895),(33167,1895),(33168,1895),(33169,1895),(33170,1895),(33171,1896),(33172,1896),(33173,1896),(33174,1896),(33175,1896),(33176,1896),(33177,1896),(33178,1896),(33179,1896),(33180,1897),(33181,1897),(33182,1897),(33183,1897),(33184,1897),(33185,1897),(33186,1897),(33187,1897),(33188,1897),(33189,1898),(33190,1898),(33191,1898),(33192,1898),(33193,1898),(33194,1898),(33195,1898),(33196,1898),(33197,1898),(33198,1899),(33199,1899),(33200,1899),(33201,1899),(33202,1899),(33203,1899),(33204,1899),(33205,1899),(33206,1899),(33207,1900),(33208,1900),(33209,1900),(33210,1900),(33211,1900),(33212,1900),(33213,1900),(33214,1900),(33215,1900),(33216,1901),(33217,1901),(33218,1901),(33219,1901),(33220,1901),(33221,1901),(33222,1901),(33223,1901),(33224,1901),(33225,1902),(33226,1902),(33227,1902),(33228,1902),(33229,1902),(33230,1902),(33231,1902),(33232,1902),(33233,1902),(33234,1903),(33235,1903),(33236,1903),(33237,1903),(33238,1903),(33239,1903),(33240,1903),(33241,1903),(33242,1903),(33243,1904),(33244,1904),(33245,1904),(33246,1904),(33247,1904),(33248,1904),(33249,1904),(33250,1904),(33251,1904),(33252,1905),(33253,1905),(33254,1905),(33255,1905),(33256,1905),(33257,1905),(33258,1905),(33259,1905),(33260,1905),(33261,1906),(33262,1906),(33263,1906),(33264,1906),(33265,1906),(33266,1906),(33267,1906),(33268,1906),(33269,1906),(33270,1907),(33271,1907),(33272,1907),(33273,1907),(33274,1907),(33275,1907),(33276,1907),(33277,1907),(33278,1907),(33279,1908),(33280,1908),(33281,1908),(33282,1908),(33283,1908),(33284,1908),(33285,1908),(33286,1908),(33287,1908),(33288,1909),(33289,1909),(33290,1909),(33291,1909),(33292,1909),(33293,1909),(33294,1909),(33295,1909),(33296,1909),(33297,1910),(33298,1910),(33299,1910),(33300,1910),(33301,1910),(33302,1910),(33303,1910),(33304,1910),(33305,1910),(33306,1911),(33307,1911),(33308,1911),(33309,1911),(33310,1911),(33311,1911),(33312,1911),(33313,1911),(33314,1911),(33315,1912),(33316,1912),(33317,1912),(33318,1912),(33319,1912),(33320,1912),(33321,1912),(33322,1912),(33323,1912),(33324,1824),(33325,1824),(33326,1824),(33327,1825),(33328,1825),(33329,1825),(33330,1826),(33331,1826),(33332,1826),(33333,1827),(33334,1827),(33335,1828),(33336,1828),(33337,1829),(33338,1829),(33339,1830),(33340,1830),(33341,1831),(33342,1831),(33343,1832),(33344,1832),(33345,1832),(33346,1833),(33347,1833),(33348,1833),(33349,1834),(33350,1834),(33351,1834),(33352,1835),(33353,1835),(33354,1836),(33355,1836),(33356,1837),(33357,1837),(33358,1838),(33359,1838),(33360,1839),(33361,1839),(33362,1840),(33363,1840),(33364,1841),(33365,1841),(33366,1842),(33367,1842),(33368,1843),(33369,1843),(33370,1844),(33371,1844),(33372,1845),(33373,1845),(33374,1846),(33375,1846),(33376,1847),(33377,1847),(33378,1848),(33379,1848),(33380,1849),(33381,1849),(33382,1850),(33383,1850),(33384,1851),(33385,1851),(33386,1852),(33387,1852),(33388,1853),(33389,1853),(33390,1854),(33391,1854),(33392,1855),(33393,1855),(33394,1856),(33395,1856),(33396,1857),(33397,1857),(33398,1858),(33399,1858),(33400,1859),(33401,1859),(33402,1860),(33403,1860),(33404,1861),(33405,1861),(33406,1862),(33407,1862),(33408,1863),(33409,1863),(33410,1864),(33411,1864),(33412,1865),(33413,1865),(33414,1866),(33415,1866),(33416,1867),(33417,1867),(33418,1868),(33419,1868),(33420,1869),(33421,1869),(33422,1870),(33423,1870),(33424,1871),(33425,1871),(33426,1872),(33427,1872),(33428,1873),(33429,1873),(33430,1874),(33431,1874),(33432,1875),(33433,1875),(33434,1876),(33435,1876),(33436,1877),(33437,1877),(33438,1878),(33439,1878),(33440,1879),(33441,1879),(33442,1880),(33443,1880),(33444,1881),(33445,1881),(33446,1882),(33447,1882),(33448,1883),(33449,1883),(33450,1884),(33451,1884),(33452,1885),(33453,1885),(33454,1886),(33455,1886),(33456,1887),(33457,1887),(33458,1888),(33459,1888),(33460,1889),(33461,1889),(33462,1890),(33463,1890),(33464,1891),(33465,1891),(33466,1892),(33467,1892),(33468,1893),(33469,1893),(33470,1894),(33471,1894),(33472,1895),(33473,1895),(33474,1896),(33475,1896),(33476,1897),(33477,1897),(33478,1898),(33479,1898),(33480,1899),(33481,1899),(33482,1900),(33483,1900),(33484,1901),(33485,1901),(33486,1902),(33487,1902),(33488,1903),(33489,1903),(33490,1904),(33491,1904),(33492,1905),(33493,1905),(33494,1906),(33495,1906),(33496,1907),(33497,1907),(33498,1908),(33499,1908),(33500,1909),(33501,1909),(33502,1910),(33503,1910),(33504,1911),(33505,1911),(33506,1912),(33507,1912),(33508,1824),(33509,1824),(33510,1824),(33511,1825),(33512,1825),(33513,1825),(33514,1826),(33515,1826),(33516,1826),(33517,1827),(33518,1827),(33519,1827),(33520,1828),(33521,1828),(33522,1828),(33523,1829),(33524,1829),(33525,1829),(33526,1830),(33527,1830),(33528,1830),(33529,1831),(33530,1831),(33531,1831),(33532,1832),(33533,1832),(33534,1832),(33535,1833),(33536,1833),(33537,1833),(33538,1834),(33539,1834),(33540,1834),(33541,1835),(33542,1835),(33543,1835),(33544,1836),(33545,1836),(33546,1836),(33547,1837),(33548,1837),(33549,1837),(33550,1838),(33551,1838),(33552,1838),(33553,1839),(33554,1839),(33555,1839),(33556,1840),(33557,1840),(33558,1840),(33559,1841),(33560,1841),(33561,1841),(33562,1842),(33563,1842),(33564,1842),(33565,1843),(33566,1843),(33567,1843),(33568,1844),(33569,1844),(33570,1844),(33571,1845),(33572,1845),(33573,1845),(33574,1846),(33575,1846),(33576,1846),(33577,1847),(33578,1847),(33579,1847),(33580,1848),(33581,1848),(33582,1848),(33583,1849),(33584,1849),(33585,1849),(33586,1850),(33587,1850),(33588,1850),(33589,1851),(33590,1851),(33591,1851),(33592,1852),(33593,1852),(33594,1852),(33595,1853),(33596,1853),(33597,1853),(33598,1854),(33599,1854),(33600,1854),(33601,1855),(33602,1855),(33603,1855),(33604,1856),(33605,1856),(33606,1856),(33607,1857),(33608,1857),(33609,1857),(33610,1858),(33611,1858),(33612,1858),(33613,1859),(33614,1859),(33615,1859),(33616,1860),(33617,1860),(33618,1860),(33619,1861),(33620,1861),(33621,1861),(33622,1862),(33623,1862),(33624,1862),(33625,1863),(33626,1863),(33627,1863),(33628,1864),(33629,1864),(33630,1864),(33631,1865),(33632,1865),(33633,1865),(33634,1866),(33635,1866),(33636,1866),(33637,1867),(33638,1867),(33639,1867),(33640,1868),(33641,1868),(33642,1868),(33643,1869),(33644,1869),(33645,1869),(33646,1870),(33647,1870),(33648,1870),(33649,1871),(33650,1871),(33651,1871),(33652,1872),(33653,1872),(33654,1872),(33655,1873),(33656,1873),(33657,1873),(33658,1874),(33659,1874),(33660,1874),(33661,1875),(33662,1875),(33663,1875),(33664,1876),(33665,1876),(33666,1876),(33667,1877),(33668,1877),(33669,1877),(33670,1878),(33671,1878),(33672,1878),(33673,1879),(33674,1879),(33675,1879),(33676,1880),(33677,1880),(33678,1880),(33679,1881),(33680,1881),(33681,1881),(33682,1882),(33683,1882),(33684,1882),(33685,1883),(33686,1883),(33687,1883),(33688,1884),(33689,1884),(33690,1884),(33691,1885),(33692,1885),(33693,1885),(33694,1886),(33695,1886),(33696,1886),(33697,1887),(33698,1887),(33699,1887),(33700,1888),(33701,1888),(33702,1888),(33703,1889),(33704,1889),(33705,1889),(33706,1890),(33707,1890),(33708,1890),(33709,1891),(33710,1891),(33711,1891),(33712,1892),(33713,1892),(33714,1892),(33715,1893),(33716,1893),(33717,1893),(33718,1894),(33719,1894),(33720,1894),(33721,1895),(33722,1895),(33723,1895),(33724,1896),(33725,1896),(33726,1896),(33727,1897),(33728,1897),(33729,1897),(33730,1898),(33731,1898),(33732,1898),(33733,1899),(33734,1899),(33735,1899),(33736,1900),(33737,1900),(33738,1900),(33739,1901),(33740,1901),(33741,1901),(33742,1902),(33743,1902),(33744,1902),(33745,1903),(33746,1903),(33747,1903),(33748,1904),(33749,1904),(33750,1904),(33751,1905),(33752,1905),(33753,1905),(33754,1906),(33755,1906),(33756,1906),(33757,1907),(33758,1907),(33759,1907),(33760,1908),(33761,1908),(33762,1908),(33763,1909),(33764,1909),(33765,1909),(33766,1910),(33767,1910),(33768,1910),(33769,1911),(33770,1911),(33771,1911),(33772,1912),(33773,1912),(33774,1912),(33775,1824),(33776,1824),(33777,1824),(33778,1824),(33779,1825),(33780,1825),(33781,1825),(33782,1825),(33783,1826),(33784,1826),(33785,1826),(33786,1826),(33787,1827),(33788,1827),(33789,1827),(33790,1827),(33791,1828),(33792,1828),(33793,1828),(33794,1828),(33795,1829),(33796,1829),(33797,1829),(33798,1829),(33799,1830),(33800,1830),(33801,1830),(33802,1830),(33803,1831),(33804,1831),(33805,1831),(33806,1831),(33807,1832),(33808,1832),(33809,1832),(33810,1832),(33811,1833),(33812,1833),(33813,1833),(33814,1833),(33815,1834),(33816,1834),(33817,1834),(33818,1834),(33819,1835),(33820,1835),(33821,1835),(33822,1835),(33823,1836),(33824,1836),(33825,1836),(33826,1836),(33827,1837),(33828,1837),(33829,1837),(33830,1837),(33831,1838),(33832,1838),(33833,1838),(33834,1838),(33835,1839),(33836,1839),(33837,1839),(33838,1839),(33839,1840),(33840,1840),(33841,1840),(33842,1840),(33843,1841),(33844,1841),(33845,1841),(33846,1841),(33847,1842),(33848,1842),(33849,1842),(33850,1842),(33851,1843),(33852,1843),(33853,1843),(33854,1843),(33855,1844),(33856,1844),(33857,1844),(33858,1844),(33859,1845),(33860,1845),(33861,1845),(33862,1845),(33863,1846),(33864,1846),(33865,1846),(33866,1846),(33867,1847),(33868,1847),(33869,1847),(33870,1847),(33871,1848),(33872,1848),(33873,1848),(33874,1848),(33875,1849),(33876,1849),(33877,1849),(33878,1849),(33879,1850),(33880,1850),(33881,1850),(33882,1850),(33883,1851),(33884,1851),(33885,1851),(33886,1851),(33887,1852),(33888,1852),(33889,1852),(33890,1852),(33891,1853),(33892,1853),(33893,1853),(33894,1853),(33895,1854),(33896,1854),(33897,1854),(33898,1854),(33899,1855),(33900,1855),(33901,1855),(33902,1855),(33903,1856),(33904,1856),(33905,1856),(33906,1856),(33907,1857),(33908,1857),(33909,1857),(33910,1857),(33911,1858),(33912,1858),(33913,1858),(33914,1858),(33915,1859),(33916,1859),(33917,1859),(33918,1859),(33919,1860),(33920,1860),(33921,1860),(33922,1860),(33923,1861),(33924,1861),(33925,1861),(33926,1861),(33927,1862),(33928,1862),(33929,1862),(33930,1862),(33931,1863),(33932,1863),(33933,1863),(33934,1863),(33935,1864),(33936,1864),(33937,1864),(33938,1864),(33939,1865),(33940,1865),(33941,1865),(33942,1865),(33943,1866),(33944,1866),(33945,1866),(33946,1866),(33947,1867),(33948,1867),(33949,1867),(33950,1867),(33951,1868),(33952,1868),(33953,1868),(33954,1868),(33955,1869),(33956,1869),(33957,1869),(33958,1869),(33959,1870),(33960,1870),(33961,1870),(33962,1870),(33963,1871),(33964,1871),(33965,1871),(33966,1871),(33967,1872),(33968,1872),(33969,1872),(33970,1872),(33971,1873),(33972,1873),(33973,1873),(33974,1873),(33975,1874),(33976,1874),(33977,1874),(33978,1874),(33979,1875),(33980,1875),(33981,1875),(33982,1875),(33983,1876),(33984,1876),(33985,1876),(33986,1876),(33987,1877),(33988,1877),(33989,1877),(33990,1877),(33991,1878),(33992,1878),(33993,1878),(33994,1878),(33995,1879),(33996,1879),(33997,1879),(33998,1879),(33999,1880),(34000,1880),(34001,1880),(34002,1880),(34003,1881),(34004,1881),(34005,1881),(34006,1881),(34007,1882),(34008,1882),(34009,1882),(34010,1882),(34011,1883),(34012,1883),(34013,1883),(34014,1883),(34015,1884),(34016,1884),(34017,1884),(34018,1884),(34019,1885),(34020,1885),(34021,1885),(34022,1885),(34023,1886),(34024,1886),(34025,1886),(34026,1886),(34027,1887),(34028,1887),(34029,1887),(34030,1887),(34031,1888),(34032,1888),(34033,1888),(34034,1888),(34035,1889),(34036,1889),(34037,1889),(34038,1889),(34039,1890),(34040,1890),(34041,1890),(34042,1890),(34043,1891),(34044,1891),(34045,1891),(34046,1891),(34047,1892),(34048,1892),(34049,1892),(34050,1892),(34051,1893),(34052,1893),(34053,1893),(34054,1893),(34055,1894),(34056,1894),(34057,1894),(34058,1894),(34059,1895),(34060,1895),(34061,1895),(34062,1895),(34063,1896),(34064,1896),(34065,1896),(34066,1896),(34067,1897),(34068,1897),(34069,1897),(34070,1897),(34071,1898),(34072,1898),(34073,1898),(34074,1898),(34075,1899),(34076,1899),(34077,1899),(34078,1899),(34079,1900),(34080,1900),(34081,1900),(34082,1900),(34083,1901),(34084,1901),(34085,1901),(34086,1901),(34087,1902),(34088,1902),(34089,1902),(34090,1902),(34091,1903),(34092,1903),(34093,1903),(34094,1903),(34095,1904),(34096,1904),(34097,1904),(34098,1904),(34099,1905),(34100,1905),(34101,1905),(34102,1905),(34103,1906),(34104,1906),(34105,1906),(34106,1906),(34107,1907),(34108,1907),(34109,1907),(34110,1907),(34111,1908),(34112,1908),(34113,1908),(34114,1908),(34115,1909),(34116,1909),(34117,1909),(34118,1909),(34119,1910),(34120,1910),(34121,1910),(34122,1910),(34123,1911),(34124,1911),(34125,1911),(34126,1911),(34127,1912),(34128,1912),(34129,1912),(34130,1912),(34131,1913),(34132,1914),(34133,1915),(34134,1916),(34135,1917),(34136,1918),(34137,1919),(34138,1920),(34139,1921),(34140,1922),(34141,1923),(34142,1924),(34143,1925),(34144,1926),(34145,1927),(34146,1928),(34147,1929),(34148,1930),(34149,1931),(34150,1932),(34151,1933),(34152,1934),(34153,1935),(34154,1936),(34155,1937),(34156,1938),(34157,1939),(34158,1940),(34159,1941),(34160,1942),(34161,1943),(34162,1944),(34163,1945),(34164,1946),(34165,1947),(34166,1948),(34167,1949),(34168,1950),(34169,1951),(34170,1952),(34171,1953),(34172,1954),(34173,1955),(34174,1956),(34175,1957),(34176,1958),(34177,1959),(34178,1960),(34179,1961),(34180,1962),(34181,1963),(34182,1964),(34183,1965),(34184,1966),(34185,1967),(34186,1968),(34187,1969),(34188,1970),(34189,1971),(34190,1972),(34191,1973),(34192,1974),(34193,1975),(34194,1976),(34195,1977),(34196,1978),(34197,1979),(34198,1980),(34199,1981),(34200,1982),(34201,1983),(34202,1984),(34203,1985),(34204,1986),(34205,1987),(34206,1988),(34207,1989),(34208,1990),(34209,1991),(34210,1992),(34211,1993),(34212,1994),(34213,1995),(34214,1996),(34215,1997),(34216,1998),(34217,1999),(34218,2000),(34219,2001),(34220,2002),(34221,2003),(34222,2004),(34223,2005),(34224,2006),(34225,2007),(34226,2008),(34227,2009),(34228,2010),(34229,2011),(34230,2012),(34231,1913),(34232,1913),(34233,1913),(34234,1913),(34235,1913),(34236,1913),(34237,1913),(34238,1913),(34239,1913),(34240,1914),(34241,1914),(34242,1914),(34243,1914),(34244,1914),(34245,1914),(34246,1914),(34247,1914),(34248,1914),(34249,1915),(34250,1915),(34251,1915),(34252,1915),(34253,1915),(34254,1915),(34255,1915),(34256,1915),(34257,1915),(34258,1916),(34259,1916),(34260,1916),(34261,1916),(34262,1916),(34263,1916),(34264,1916),(34265,1916),(34266,1916),(34267,1917),(34268,1917),(34269,1917),(34270,1917),(34271,1917),(34272,1917),(34273,1917),(34274,1917),(34275,1917),(34276,1918),(34277,1918),(34278,1918),(34279,1918),(34280,1918),(34281,1918),(34282,1918),(34283,1918),(34284,1918),(34285,1919),(34286,1919),(34287,1919),(34288,1919),(34289,1919),(34290,1919),(34291,1919),(34292,1919),(34293,1919),(34294,1920),(34295,1920),(34296,1920),(34297,1920),(34298,1920),(34299,1920),(34300,1920),(34301,1920),(34302,1920),(34303,1921),(34304,1921),(34305,1921),(34306,1921),(34307,1921),(34308,1921),(34309,1921),(34310,1921),(34311,1921),(34312,1922),(34313,1922),(34314,1922),(34315,1922),(34316,1922),(34317,1922),(34318,1922),(34319,1922),(34320,1922),(34321,1923),(34322,1923),(34323,1923),(34324,1923),(34325,1923),(34326,1923),(34327,1923),(34328,1923),(34329,1923),(34330,1924),(34331,1924),(34332,1924),(34333,1924),(34334,1924),(34335,1924),(34336,1924),(34337,1924),(34338,1924),(34339,1925),(34340,1925),(34341,1925),(34342,1925),(34343,1925),(34344,1925),(34345,1925),(34346,1925),(34347,1925),(34348,1926),(34349,1926),(34350,1926),(34351,1926),(34352,1926),(34353,1926),(34354,1926),(34355,1926),(34356,1926),(34357,1927),(34358,1927),(34359,1927),(34360,1927),(34361,1927),(34362,1927),(34363,1927),(34364,1927),(34365,1927),(34366,1928),(34367,1928),(34368,1928),(34369,1928),(34370,1928),(34371,1928),(34372,1928),(34373,1928),(34374,1928),(34375,1929),(34376,1929),(34377,1929),(34378,1929),(34379,1929),(34380,1929),(34381,1929),(34382,1929),(34383,1929),(34384,1930),(34385,1930),(34386,1930),(34387,1930),(34388,1930),(34389,1930),(34390,1930),(34391,1930),(34392,1930),(34393,1931),(34394,1931),(34395,1931),(34396,1931),(34397,1931),(34398,1931),(34399,1931),(34400,1931),(34401,1931),(34402,1932),(34403,1932),(34404,1932),(34405,1932),(34406,1932),(34407,1932),(34408,1932),(34409,1932),(34410,1932),(34411,1933),(34412,1933),(34413,1933),(34414,1933),(34415,1933),(34416,1933),(34417,1933),(34418,1933),(34419,1933),(34420,1934),(34421,1934),(34422,1934),(34423,1934),(34424,1934),(34425,1934),(34426,1934),(34427,1934),(34428,1934),(34429,1935),(34430,1935),(34431,1935),(34432,1935),(34433,1935),(34434,1935),(34435,1935),(34436,1935),(34437,1935),(34438,1936),(34439,1936),(34440,1936),(34441,1936),(34442,1936),(34443,1936),(34444,1936),(34445,1936),(34446,1936),(34447,1937),(34448,1937),(34449,1937),(34450,1937),(34451,1937),(34452,1937),(34453,1937),(34454,1938),(34455,1938),(34456,1938),(34457,1938),(34458,1938),(34459,1938),(34460,1938),(34461,1939),(34462,1939),(34463,1939),(34464,1939),(34465,1939),(34466,1939),(34467,1939),(34468,1939),(34469,1939),(34470,1940),(34471,1940),(34472,1940),(34473,1940),(34474,1940),(34475,1940),(34476,1940),(34477,1940),(34478,1940),(34479,1941),(34480,1941),(34481,1941),(34482,1941),(34483,1941),(34484,1941),(34485,1941),(34486,1941),(34487,1941),(34488,1942),(34489,1942),(34490,1942),(34491,1942),(34492,1942),(34493,1942),(34494,1942),(34495,1942),(34496,1942),(34497,1943),(34498,1943),(34499,1943),(34500,1943),(34501,1943),(34502,1943),(34503,1943),(34504,1943),(34505,1943),(34506,1944),(34507,1944),(34508,1944),(34509,1944),(34510,1944),(34511,1944),(34512,1944),(34513,1944),(34514,1944),(34515,1945),(34516,1945),(34517,1945),(34518,1945),(34519,1945),(34520,1945),(34521,1945),(34522,1945),(34523,1945),(34524,1946),(34525,1946),(34526,1946),(34527,1946),(34528,1946),(34529,1946),(34530,1946),(34531,1946),(34532,1946),(34533,1947),(34534,1947),(34535,1947),(34536,1947),(34537,1947),(34538,1947),(34539,1947),(34540,1947),(34541,1947),(34542,1948),(34543,1948),(34544,1948),(34545,1948),(34546,1948),(34547,1948),(34548,1948),(34549,1948),(34550,1948),(34551,1949),(34552,1949),(34553,1949),(34554,1949),(34555,1949),(34556,1949),(34557,1949),(34558,1949),(34559,1949),(34560,1950),(34561,1950),(34562,1950),(34563,1950),(34564,1950),(34565,1950),(34566,1950),(34567,1951),(34568,1951),(34569,1951),(34570,1951),(34571,1951),(34572,1951),(34573,1951),(34574,1952),(34575,1952),(34576,1952),(34577,1952),(34578,1952),(34579,1952),(34580,1952),(34581,1953),(34582,1953),(34583,1953),(34584,1953),(34585,1953),(34586,1953),(34587,1954),(34588,1954),(34589,1954),(34590,1954),(34591,1954),(34592,1954),(34593,1955),(34594,1955),(34595,1955),(34596,1955),(34597,1955),(34598,1955),(34599,1956),(34600,1956),(34601,1956),(34602,1956),(34603,1956),(34604,1956),(34605,1957),(34606,1957),(34607,1957),(34608,1957),(34609,1957),(34610,1957),(34611,1958),(34612,1958),(34613,1958),(34614,1958),(34615,1958),(34616,1958),(34617,1959),(34618,1959),(34619,1959),(34620,1959),(34621,1959),(34622,1959),(34623,1959),(34624,1960),(34625,1960),(34626,1960),(34627,1960),(34628,1960),(34629,1960),(34630,1960),(34631,1961),(34632,1961),(34633,1961),(34634,1961),(34635,1961),(34636,1961),(34637,1961),(34638,1962),(34639,1962),(34640,1962),(34641,1962),(34642,1962),(34643,1962),(34644,1962),(34645,1963),(34646,1963),(34647,1963),(34648,1963),(34649,1963),(34650,1963),(34651,1963),(34652,1964),(34653,1964),(34654,1964),(34655,1964),(34656,1964),(34657,1964),(34658,1964),(34659,1965),(34660,1965),(34661,1965),(34662,1965),(34663,1965),(34664,1965),(34665,1965),(34666,1966),(34667,1966),(34668,1966),(34669,1966),(34670,1966),(34671,1966),(34672,1966),(34673,1967),(34674,1967),(34675,1967),(34676,1967),(34677,1967),(34678,1967),(34679,1967),(34680,1968),(34681,1968),(34682,1968),(34683,1968),(34684,1968),(34685,1968),(34686,1968),(34687,1969),(34688,1969),(34689,1969),(34690,1969),(34691,1969),(34692,1969),(34693,1969),(34694,1970),(34695,1970),(34696,1970),(34697,1970),(34698,1970),(34699,1970),(34700,1970),(34701,1971),(34702,1971),(34703,1971),(34704,1971),(34705,1971),(34706,1971),(34707,1971),(34708,1972),(34709,1972),(34710,1972),(34711,1972),(34712,1972),(34713,1973),(34714,1973),(34715,1973),(34716,1973),(34717,1973),(34718,1973),(34719,1973),(34720,1974),(34721,1974),(34722,1974),(34723,1974),(34724,1974),(34725,1974),(34726,1974),(34727,1975),(34728,1975),(34729,1975),(34730,1975),(34731,1975),(34732,1975),(34733,1975),(34734,1976),(34735,1976),(34736,1976),(34737,1976),(34738,1976),(34739,1976),(34740,1976),(34741,1977),(34742,1977),(34743,1977),(34744,1977),(34745,1977),(34746,1977),(34747,1977),(34748,1978),(34749,1978),(34750,1978),(34751,1978),(34752,1978),(34753,1978),(34754,1978),(34755,1979),(34756,1979),(34757,1979),(34758,1979),(34759,1979),(34760,1979),(34761,1979),(34762,1980),(34763,1980),(34764,1980),(34765,1980),(34766,1980),(34767,1980),(34768,1980),(34769,1981),(34770,1981),(34771,1981),(34772,1981),(34773,1981),(34774,1981),(34775,1981),(34776,1982),(34777,1982),(34778,1982),(34779,1982),(34780,1982),(34781,1982),(34782,1982),(34783,1983),(34784,1983),(34785,1983),(34786,1983),(34787,1983),(34788,1983),(34789,1983),(34790,1984),(34791,1984),(34792,1984),(34793,1984),(34794,1984),(34795,1984),(34796,1984),(34797,1985),(34798,1985),(34799,1985),(34800,1985),(34801,1985),(34802,1985),(34803,1985),(34804,1986),(34805,1986),(34806,1986),(34807,1986),(34808,1986),(34809,1986),(34810,1986),(34811,1987),(34812,1987),(34813,1987),(34814,1987),(34815,1987),(34816,1987),(34817,1987),(34818,1988),(34819,1988),(34820,1988),(34821,1988),(34822,1988),(34823,1988),(34824,1988),(34825,1989),(34826,1989),(34827,1989),(34828,1989),(34829,1989),(34830,1989),(34831,1989),(34832,1990),(34833,1990),(34834,1990),(34835,1990),(34836,1990),(34837,1990),(34838,1990),(34839,1991),(34840,1991),(34841,1991),(34842,1991),(34843,1991),(34844,1991),(34845,1991),(34846,1991),(34847,1991),(34848,1992),(34849,1992),(34850,1992),(34851,1992),(34852,1992),(34853,1992),(34854,1992),(34855,1993),(34856,1993),(34857,1993),(34858,1993),(34859,1993),(34860,1993),(34861,1993),(34862,1994),(34863,1994),(34864,1994),(34865,1994),(34866,1994),(34867,1994),(34868,1994),(34869,1995),(34870,1995),(34871,1995),(34872,1995),(34873,1995),(34874,1995),(34875,1995),(34876,1996),(34877,1996),(34878,1996),(34879,1996),(34880,1996),(34881,1996),(34882,1996),(34883,1997),(34884,1997),(34885,1997),(34886,1997),(34887,1997),(34888,1997),(34889,1997),(34890,1998),(34891,1998),(34892,1998),(34893,1998),(34894,1998),(34895,1998),(34896,1998),(34897,1999),(34898,1999),(34899,1999),(34900,1999),(34901,1999),(34902,1999),(34903,1999),(34904,2000),(34905,2000),(34906,2000),(34907,2000),(34908,2000),(34909,2000),(34910,2000),(34911,2001),(34912,2001),(34913,2001),(34914,2001),(34915,2001),(34916,2001),(34917,2001),(34918,2002),(34919,2002),(34920,2002),(34921,2002),(34922,2002),(34923,2002),(34924,2002),(34925,2003),(34926,2003),(34927,2003),(34928,2003),(34929,2003),(34930,2003),(34931,2003),(34932,2004),(34933,2004),(34934,2004),(34935,2004),(34936,2004),(34937,2004),(34938,2004),(34939,2005),(34940,2005),(34941,2005),(34942,2005),(34943,2005),(34944,2005),(34945,2005),(34946,2006),(34947,2006),(34948,2006),(34949,2006),(34950,2006),(34951,2006),(34952,2006),(34953,2007),(34954,2007),(34955,2007),(34956,2007),(34957,2007),(34958,2007),(34959,2007),(34960,2008),(34961,2008),(34962,2008),(34963,2008),(34964,2008),(34965,2008),(34966,2008),(34967,2009),(34968,2009),(34969,2009),(34970,2009),(34971,2009),(34972,2009),(34973,2009),(34974,2010),(34975,2010),(34976,2010),(34977,2010),(34978,2010),(34979,2010),(34980,2010),(34981,2011),(34982,2011),(34983,2011),(34984,2011),(34985,2011),(34986,2011),(34987,2011),(34988,2012),(34989,2012),(34990,2012),(34991,2012),(34992,2012),(34993,2012),(34994,2012),(34995,1913),(34996,1913),(34997,1914),(34998,1914),(34999,1915),(35000,1915),(35001,1916),(35002,1916),(35003,1917),(35004,1917),(35005,1918),(35006,1918),(35007,1919),(35008,1919),(35009,1920),(35010,1920),(35011,1921),(35012,1921),(35013,1922),(35014,1922),(35015,1923),(35016,1923),(35017,1924),(35018,1924),(35019,1925),(35020,1925),(35021,1926),(35022,1926),(35023,1927),(35024,1927),(35025,1928),(35026,1928),(35027,1929),(35028,1929),(35029,1930),(35030,1930),(35031,1931),(35032,1931),(35033,1932),(35034,1932),(35035,1933),(35036,1933),(35037,1934),(35038,1934),(35039,1935),(35040,1935),(35041,1936),(35042,1936),(35043,1937),(35044,1937),(35045,1938),(35046,1938),(35047,1939),(35048,1939),(35049,1940),(35050,1940),(35051,1941),(35052,1941),(35053,1942),(35054,1942),(35055,1943),(35056,1943),(35057,1944),(35058,1944),(35059,1945),(35060,1945),(35061,1946),(35062,1946),(35063,1947),(35064,1947),(35065,1948),(35066,1948),(35067,1949),(35068,1949),(35069,1950),(35070,1950),(35071,1950),(35072,1951),(35073,1951),(35074,1951),(35075,1952),(35076,1952),(35077,1952),(35078,1953),(35079,1953),(35080,1953),(35081,1954),(35082,1954),(35083,1954),(35084,1955),(35085,1955),(35086,1955),(35087,1956),(35088,1956),(35089,1956),(35090,1957),(35091,1957),(35092,1957),(35093,1958),(35094,1958),(35095,1958),(35096,1959),(35097,1959),(35098,1959),(35099,1960),(35100,1960),(35101,1960),(35102,1961),(35103,1961),(35104,1961),(35105,1962),(35106,1962),(35107,1962),(35108,1963),(35109,1963),(35110,1963),(35111,1964),(35112,1964),(35113,1964),(35114,1965),(35115,1965),(35116,1965),(35117,1966),(35118,1966),(35119,1966),(35120,1967),(35121,1967),(35122,1967),(35123,1968),(35124,1968),(35125,1968),(35126,1969),(35127,1969),(35128,1969),(35129,1970),(35130,1970),(35131,1970),(35132,1971),(35133,1971),(35134,1971),(35135,1972),(35136,1973),(35137,1973),(35138,1974),(35139,1974),(35140,1975),(35141,1975),(35142,1976),(35143,1976),(35144,1977),(35145,1977),(35146,1978),(35147,1978),(35148,1979),(35149,1979),(35150,1980),(35151,1980),(35152,1981),(35153,1981),(35154,1982),(35155,1982),(35156,1983),(35157,1983),(35158,1984),(35159,1984),(35160,1985),(35161,1985),(35162,1986),(35163,1986),(35164,1987),(35165,1987),(35166,1988),(35167,1988),(35168,1989),(35169,1989),(35170,1990),(35171,1990),(35172,1991),(35173,1991),(35174,1992),(35175,1992),(35176,1993),(35177,1993),(35178,1994),(35179,1994),(35180,1995),(35181,1995),(35182,1996),(35183,1996),(35184,1997),(35185,1997),(35186,1998),(35187,1998),(35188,1999),(35189,1999),(35190,2000),(35191,2000),(35192,2001),(35193,2001),(35194,2002),(35195,2002),(35196,2003),(35197,2003),(35198,2003),(35199,2004),(35200,2004),(35201,2004),(35202,2005),(35203,2005),(35204,2005),(35205,2006),(35206,2006),(35207,2006),(35208,2007),(35209,2007),(35210,2007),(35211,2008),(35212,2008),(35213,2009),(35214,2009),(35215,2009),(35216,2010),(35217,2010),(35218,2010),(35219,2011),(35220,2011),(35221,2011),(35222,2012),(35223,2012),(35224,2012),(35225,1913),(35226,1913),(35227,1913),(35228,1914),(35229,1914),(35230,1914),(35231,1915),(35232,1915),(35233,1915),(35234,1916),(35235,1916),(35236,1916),(35237,1917),(35238,1917),(35239,1917),(35240,1918),(35241,1918),(35242,1918),(35243,1919),(35244,1919),(35245,1919),(35246,1920),(35247,1920),(35248,1920),(35249,1921),(35250,1921),(35251,1921),(35252,1922),(35253,1922),(35254,1922),(35255,1923),(35256,1923),(35257,1923),(35258,1924),(35259,1924),(35260,1924),(35261,1925),(35262,1925),(35263,1925),(35264,1926),(35265,1926),(35266,1926),(35267,1927),(35268,1927),(35269,1927),(35270,1928),(35271,1928),(35272,1928),(35273,1929),(35274,1929),(35275,1929),(35276,1930),(35277,1930),(35278,1930),(35279,1931),(35280,1931),(35281,1931),(35282,1932),(35283,1932),(35284,1932),(35285,1933),(35286,1933),(35287,1933),(35288,1934),(35289,1934),(35290,1934),(35291,1935),(35292,1935),(35293,1935),(35294,1936),(35295,1936),(35296,1936),(35297,1937),(35298,1937),(35299,1937),(35300,1938),(35301,1938),(35302,1938),(35303,1939),(35304,1939),(35305,1939),(35306,1940),(35307,1940),(35308,1940),(35309,1941),(35310,1941),(35311,1941),(35312,1942),(35313,1942),(35314,1942),(35315,1943),(35316,1943),(35317,1943),(35318,1944),(35319,1944),(35320,1944),(35321,1945),(35322,1945),(35323,1945),(35324,1946),(35325,1946),(35326,1946),(35327,1947),(35328,1947),(35329,1947),(35330,1948),(35331,1948),(35332,1948),(35333,1949),(35334,1949),(35335,1949),(35336,1950),(35337,1950),(35338,1950),(35339,1951),(35340,1951),(35341,1951),(35342,1952),(35343,1952),(35344,1952),(35345,1953),(35346,1953),(35347,1953),(35348,1954),(35349,1954),(35350,1954),(35351,1955),(35352,1955),(35353,1955),(35354,1956),(35355,1956),(35356,1956),(35357,1957),(35358,1957),(35359,1957),(35360,1958),(35361,1958),(35362,1958),(35363,1959),(35364,1959),(35365,1959),(35366,1960),(35367,1960),(35368,1960),(35369,1961),(35370,1961),(35371,1961),(35372,1962),(35373,1962),(35374,1962),(35375,1963),(35376,1963),(35377,1963),(35378,1964),(35379,1964),(35380,1964),(35381,1965),(35382,1965),(35383,1965),(35384,1966),(35385,1966),(35386,1966),(35387,1967),(35388,1967),(35389,1967),(35390,1968),(35391,1968),(35392,1968),(35393,1969),(35394,1969),(35395,1969),(35396,1970),(35397,1970),(35398,1970),(35399,1971),(35400,1971),(35401,1971),(35402,1972),(35403,1972),(35404,1972),(35405,1973),(35406,1973),(35407,1973),(35408,1974),(35409,1974),(35410,1974),(35411,1975),(35412,1975),(35413,1975),(35414,1976),(35415,1976),(35416,1976),(35417,1977),(35418,1977),(35419,1977),(35420,1978),(35421,1978),(35422,1978),(35423,1979),(35424,1979),(35425,1979),(35426,1980),(35427,1980),(35428,1980),(35429,1981),(35430,1981),(35431,1981),(35432,1982),(35433,1982),(35434,1982),(35435,1983),(35436,1983),(35437,1983),(35438,1984),(35439,1984),(35440,1984),(35441,1985),(35442,1985),(35443,1985),(35444,1986),(35445,1986),(35446,1986),(35447,1987),(35448,1987),(35449,1987),(35450,1988),(35451,1988),(35452,1988),(35453,1989),(35454,1989),(35455,1989),(35456,1990),(35457,1990),(35458,1990),(35459,1991),(35460,1991),(35461,1991),(35462,1992),(35463,1992),(35464,1992),(35465,1993),(35466,1993),(35467,1993),(35468,1994),(35469,1994),(35470,1994),(35471,1995),(35472,1995),(35473,1995),(35474,1996),(35475,1996),(35476,1996),(35477,1997),(35478,1997),(35479,1997),(35480,1998),(35481,1998),(35482,1998),(35483,1999),(35484,1999),(35485,1999),(35486,2000),(35487,2000),(35488,2000),(35489,2001),(35490,2001),(35491,2001),(35492,2002),(35493,2002),(35494,2002),(35495,2003),(35496,2003),(35497,2003),(35498,2004),(35499,2004),(35500,2004),(35501,2005),(35502,2005),(35503,2005),(35504,2006),(35505,2006),(35506,2006),(35507,2007),(35508,2007),(35509,2007),(35510,2008),(35511,2008),(35512,2008),(35513,2009),(35514,2009),(35515,2009),(35516,2010),(35517,2010),(35518,2010),(35519,2011),(35520,2011),(35521,2011),(35522,2012),(35523,2012),(35524,2012),(35525,1913),(35526,1913),(35527,1913),(35528,1913),(35529,1914),(35530,1914),(35531,1914),(35532,1914),(35533,1915),(35534,1915),(35535,1915),(35536,1915),(35537,1916),(35538,1916),(35539,1916),(35540,1916),(35541,1917),(35542,1917),(35543,1917),(35544,1917),(35545,1918),(35546,1918),(35547,1918),(35548,1918),(35549,1919),(35550,1919),(35551,1919),(35552,1919),(35553,1920),(35554,1920),(35555,1920),(35556,1920),(35557,1921),(35558,1921),(35559,1921),(35560,1921),(35561,1922),(35562,1922),(35563,1922),(35564,1922),(35565,1923),(35566,1923),(35567,1923),(35568,1923),(35569,1924),(35570,1924),(35571,1924),(35572,1924),(35573,1925),(35574,1925),(35575,1925),(35576,1925),(35577,1926),(35578,1926),(35579,1926),(35580,1926),(35581,1927),(35582,1927),(35583,1927),(35584,1927),(35585,1928),(35586,1928),(35587,1928),(35588,1928),(35589,1929),(35590,1929),(35591,1929),(35592,1929),(35593,1930),(35594,1930),(35595,1930),(35596,1930),(35597,1931),(35598,1931),(35599,1931),(35600,1931),(35601,1932),(35602,1932),(35603,1932),(35604,1932),(35605,1933),(35606,1933),(35607,1933),(35608,1933),(35609,1934),(35610,1934),(35611,1934),(35612,1934),(35613,1935),(35614,1935),(35615,1935),(35616,1935),(35617,1936),(35618,1936),(35619,1936),(35620,1936),(35621,1937),(35622,1937),(35623,1937),(35624,1937),(35625,1938),(35626,1938),(35627,1938),(35628,1938),(35629,1939),(35630,1939),(35631,1939),(35632,1939),(35633,1940),(35634,1940),(35635,1940),(35636,1940),(35637,1941),(35638,1941),(35639,1941),(35640,1941),(35641,1942),(35642,1942),(35643,1942),(35644,1942),(35645,1943),(35646,1943),(35647,1943),(35648,1943),(35649,1944),(35650,1944),(35651,1944),(35652,1944),(35653,1945),(35654,1945),(35655,1945),(35656,1945),(35657,1946),(35658,1946),(35659,1946),(35660,1946),(35661,1947),(35662,1947),(35663,1947),(35664,1947),(35665,1948),(35666,1948),(35667,1948),(35668,1948),(35669,1949),(35670,1949),(35671,1949),(35672,1949),(35673,1950),(35674,1950),(35675,1950),(35676,1950),(35677,1951),(35678,1951),(35679,1951),(35680,1951),(35681,1952),(35682,1952),(35683,1952),(35684,1952),(35685,1953),(35686,1953),(35687,1953),(35688,1953),(35689,1954),(35690,1954),(35691,1954),(35692,1954),(35693,1955),(35694,1955),(35695,1955),(35696,1955),(35697,1956),(35698,1956),(35699,1956),(35700,1956),(35701,1957),(35702,1957),(35703,1957),(35704,1957),(35705,1958),(35706,1958),(35707,1958),(35708,1958),(35709,1959),(35710,1959),(35711,1959),(35712,1959),(35713,1960),(35714,1960),(35715,1960),(35716,1960),(35717,1961),(35718,1961),(35719,1961),(35720,1961),(35721,1962),(35722,1962),(35723,1962),(35724,1962),(35725,1963),(35726,1963),(35727,1963),(35728,1963),(35729,1964),(35730,1964),(35731,1964),(35732,1964),(35733,1965),(35734,1965),(35735,1965),(35736,1965),(35737,1966),(35738,1966),(35739,1966),(35740,1966),(35741,1967),(35742,1967),(35743,1967),(35744,1967),(35745,1968),(35746,1968),(35747,1968),(35748,1968),(35749,1969),(35750,1969),(35751,1969),(35752,1969),(35753,1970),(35754,1970),(35755,1970),(35756,1970),(35757,1971),(35758,1971),(35759,1971),(35760,1971),(35761,1972),(35762,1972),(35763,1972),(35764,1972),(35765,1973),(35766,1973),(35767,1973),(35768,1973),(35769,1974),(35770,1974),(35771,1974),(35772,1974),(35773,1975),(35774,1975),(35775,1975),(35776,1975),(35777,1976),(35778,1976),(35779,1976),(35780,1976),(35781,1977),(35782,1977),(35783,1977),(35784,1977),(35785,1978),(35786,1978),(35787,1978),(35788,1978),(35789,1979),(35790,1979),(35791,1979),(35792,1979),(35793,1980),(35794,1980),(35795,1980),(35796,1980),(35797,1981),(35798,1981),(35799,1981),(35800,1981),(35801,1982),(35802,1982),(35803,1982),(35804,1982),(35805,1983),(35806,1983),(35807,1983),(35808,1983),(35809,1984),(35810,1984),(35811,1984),(35812,1984),(35813,1985),(35814,1985),(35815,1985),(35816,1985),(35817,1986),(35818,1986),(35819,1986),(35820,1986),(35821,1987),(35822,1987),(35823,1987),(35824,1987),(35825,1988),(35826,1988),(35827,1988),(35828,1988),(35829,1989),(35830,1989),(35831,1989),(35832,1989),(35833,1990),(35834,1990),(35835,1990),(35836,1990),(35837,1991),(35838,1991),(35839,1991),(35840,1991),(35841,1992),(35842,1992),(35843,1992),(35844,1992),(35845,1993),(35846,1993),(35847,1993),(35848,1993),(35849,1994),(35850,1994),(35851,1994),(35852,1994),(35853,1995),(35854,1995),(35855,1995),(35856,1995),(35857,1996),(35858,1996),(35859,1996),(35860,1996),(35861,1997),(35862,1997),(35863,1997),(35864,1997),(35865,1998),(35866,1998),(35867,1998),(35868,1998),(35869,1999),(35870,1999),(35871,1999),(35872,1999),(35873,2000),(35874,2000),(35875,2000),(35876,2000),(35877,2001),(35878,2001),(35879,2001),(35880,2001),(35881,2002),(35882,2002),(35883,2002),(35884,2002),(35885,2003),(35886,2003),(35887,2003),(35888,2003),(35889,2004),(35890,2004),(35891,2004),(35892,2004),(35893,2005),(35894,2005),(35895,2005),(35896,2005),(35897,2006),(35898,2006),(35899,2006),(35900,2006),(35901,2007),(35902,2007),(35903,2007),(35904,2007),(35905,2008),(35906,2008),(35907,2008),(35908,2008),(35909,2009),(35910,2009),(35911,2009),(35912,2009),(35913,2010),(35914,2010),(35915,2010),(35916,2010),(35917,2011),(35918,2011),(35919,2011),(35920,2011),(35921,2012),(35922,2012),(35923,2012),(35924,2012),(35925,2013),(35926,2014),(35927,2015),(35928,2016),(35929,2017),(35930,2018),(35931,2019),(35932,2020),(35933,2021),(35934,2022),(35935,2023),(35936,2024),(35937,2025),(35938,2026),(35939,2027),(35940,2028),(35941,2029),(35942,2030),(35943,2031),(35944,2032),(35945,2033),(35946,2034),(35947,2035),(35948,2036),(35949,2037),(35950,2038),(35951,2039),(35952,2040),(35953,2041),(35954,2042),(35955,2043),(35956,2044),(35957,2045),(35958,2046),(35959,2047),(35960,2048),(35961,2049),(35962,2050),(35963,2051),(35964,2052),(35965,2053),(35966,2054),(35967,2055),(35968,2056),(35969,2057),(35970,2058),(35971,2059),(35972,2060),(35973,2061),(35974,2062),(35975,2063),(35976,2064),(35977,2065),(35978,2066),(35979,2067),(35980,2068),(35981,2069),(35982,2070),(35983,2071),(35984,2072),(35985,2073),(35986,2074),(35987,2075),(35988,2076),(35989,2077),(35990,2078),(35991,2079),(35992,2080),(35993,2081),(35994,2082),(35995,2083),(35996,2084),(35997,2085),(35998,2086),(35999,2087),(36000,2088),(36001,2089),(36002,2090),(36003,2091),(36004,2092),(36005,2093),(36006,2094),(36007,2095),(36008,2096),(36009,2097),(36010,2098),(36011,2099),(36012,2100),(36013,2101),(36014,2102),(36015,2103),(36016,2104),(36017,2105),(36018,2106),(36019,2107),(36020,2108),(36021,2109),(36022,2110),(36023,2111),(36024,2112),(36025,2013),(36026,2013),(36027,2013),(36028,2013),(36029,2013),(36030,2013),(36031,2013),(36032,2014),(36033,2014),(36034,2014),(36035,2014),(36036,2014),(36037,2014),(36038,2014),(36039,2015),(36040,2015),(36041,2015),(36042,2015),(36043,2015),(36044,2015),(36045,2015),(36046,2016),(36047,2016),(36048,2016),(36049,2016),(36050,2016),(36051,2016),(36052,2016),(36053,2017),(36054,2017),(36055,2017),(36056,2017),(36057,2017),(36058,2017),(36059,2017),(36060,2018),(36061,2018),(36062,2018),(36063,2018),(36064,2018),(36065,2018),(36066,2018),(36067,2019),(36068,2019),(36069,2019),(36070,2019),(36071,2019),(36072,2019),(36073,2019),(36074,2020),(36075,2020),(36076,2020),(36077,2020),(36078,2020),(36079,2020),(36080,2020),(36081,2021),(36082,2021),(36083,2021),(36084,2021),(36085,2021),(36086,2021),(36087,2021),(36088,2022),(36089,2022),(36090,2022),(36091,2022),(36092,2022),(36093,2022),(36094,2022),(36095,2023),(36096,2023),(36097,2023),(36098,2023),(36099,2023),(36100,2023),(36101,2023),(36102,2024),(36103,2024),(36104,2024),(36105,2024),(36106,2024),(36107,2024),(36108,2024),(36109,2024),(36110,2024),(36111,2025),(36112,2025),(36113,2025),(36114,2025),(36115,2025),(36116,2025),(36117,2025),(36118,2025),(36119,2025),(36120,2026),(36121,2026),(36122,2026),(36123,2026),(36124,2026),(36125,2026),(36126,2026),(36127,2026),(36128,2026),(36129,2027),(36130,2027),(36131,2027),(36132,2027),(36133,2027),(36134,2027),(36135,2027),(36136,2027),(36137,2027),(36138,2028),(36139,2028),(36140,2028),(36141,2028),(36142,2028),(36143,2028),(36144,2028),(36145,2028),(36146,2028),(36147,2029),(36148,2029),(36149,2029),(36150,2029),(36151,2029),(36152,2029),(36153,2029),(36154,2029),(36155,2029),(36156,2030),(36157,2030),(36158,2030),(36159,2030),(36160,2030),(36161,2030),(36162,2030),(36163,2030),(36164,2030),(36165,2031),(36166,2031),(36167,2031),(36168,2031),(36169,2031),(36170,2031),(36171,2031),(36172,2031),(36173,2031),(36174,2032),(36175,2032),(36176,2032),(36177,2032),(36178,2032),(36179,2032),(36180,2032),(36181,2032),(36182,2032),(36183,2033),(36184,2033),(36185,2033),(36186,2033),(36187,2033),(36188,2033),(36189,2033),(36190,2033),(36191,2033),(36192,2034),(36193,2034),(36194,2034),(36195,2034),(36196,2034),(36197,2034),(36198,2034),(36199,2034),(36200,2034),(36201,2035),(36202,2035),(36203,2035),(36204,2035),(36205,2035),(36206,2035),(36207,2035),(36208,2036),(36209,2036),(36210,2036),(36211,2036),(36212,2036),(36213,2036),(36214,2036),(36215,2037),(36216,2037),(36217,2037),(36218,2037),(36219,2037),(36220,2037),(36221,2037),(36222,2038),(36223,2038),(36224,2038),(36225,2038),(36226,2038),(36227,2038),(36228,2038),(36229,2039),(36230,2039),(36231,2039),(36232,2039),(36233,2039),(36234,2039),(36235,2039),(36236,2039),(36237,2039),(36238,2040),(36239,2040),(36240,2040),(36241,2040),(36242,2040),(36243,2040),(36244,2040),(36245,2040),(36246,2040),(36247,2041),(36248,2041),(36249,2041),(36250,2041),(36251,2041),(36252,2041),(36253,2041),(36254,2042),(36255,2042),(36256,2042),(36257,2042),(36258,2042),(36259,2042),(36260,2042),(36261,2042),(36262,2042),(36263,2043),(36264,2043),(36265,2043),(36266,2043),(36267,2043),(36268,2043),(36269,2043),(36270,2044),(36271,2044),(36272,2044),(36273,2044),(36274,2044),(36275,2044),(36276,2044),(36277,2044),(36278,2044),(36279,2045),(36280,2045),(36281,2045),(36282,2045),(36283,2045),(36284,2045),(36285,2045),(36286,2045),(36287,2045),(36288,2046),(36289,2046),(36290,2046),(36291,2046),(36292,2046),(36293,2046),(36294,2046),(36295,2046),(36296,2046),(36297,2047),(36298,2047),(36299,2047),(36300,2047),(36301,2047),(36302,2047),(36303,2047),(36304,2048),(36305,2048),(36306,2048),(36307,2048),(36308,2048),(36309,2048),(36310,2048),(36311,2049),(36312,2049),(36313,2049),(36314,2049),(36315,2049),(36316,2049),(36317,2049),(36318,2050),(36319,2050),(36320,2050),(36321,2050),(36322,2050),(36323,2050),(36324,2050),(36325,2051),(36326,2051),(36327,2051),(36328,2051),(36329,2051),(36330,2051),(36331,2051),(36332,2052),(36333,2052),(36334,2052),(36335,2052),(36336,2052),(36337,2052),(36338,2052),(36339,2053),(36340,2053),(36341,2053),(36342,2053),(36343,2053),(36344,2053),(36345,2053),(36346,2054),(36347,2054),(36348,2054),(36349,2054),(36350,2054),(36351,2054),(36352,2054),(36353,2055),(36354,2055),(36355,2055),(36356,2055),(36357,2055),(36358,2055),(36359,2055),(36360,2056),(36361,2056),(36362,2056),(36363,2056),(36364,2056),(36365,2056),(36366,2056),(36367,2057),(36368,2057),(36369,2057),(36370,2057),(36371,2057),(36372,2057),(36373,2057),(36374,2058),(36375,2058),(36376,2058),(36377,2058),(36378,2058),(36379,2058),(36380,2058),(36381,2059),(36382,2059),(36383,2059),(36384,2059),(36385,2059),(36386,2059),(36387,2059),(36388,2060),(36389,2060),(36390,2060),(36391,2060),(36392,2060),(36393,2060),(36394,2060),(36395,2061),(36396,2061),(36397,2061),(36398,2061),(36399,2061),(36400,2061),(36401,2061),(36402,2061),(36403,2061),(36404,2062),(36405,2062),(36406,2062),(36407,2062),(36408,2062),(36409,2062),(36410,2062),(36411,2063),(36412,2063),(36413,2063),(36414,2063),(36415,2063),(36416,2063),(36417,2063),(36418,2064),(36419,2064),(36420,2064),(36421,2064),(36422,2064),(36423,2064),(36424,2064),(36425,2065),(36426,2065),(36427,2065),(36428,2065),(36429,2065),(36430,2065),(36431,2065),(36432,2066),(36433,2066),(36434,2066),(36435,2066),(36436,2066),(36437,2066),(36438,2066),(36439,2067),(36440,2067),(36441,2067),(36442,2067),(36443,2067),(36444,2067),(36445,2067),(36446,2068),(36447,2068),(36448,2068),(36449,2068),(36450,2068),(36451,2068),(36452,2068),(36453,2069),(36454,2069),(36455,2069),(36456,2069),(36457,2069),(36458,2069),(36459,2069),(36460,2070),(36461,2070),(36462,2070),(36463,2070),(36464,2070),(36465,2070),(36466,2070),(36467,2071),(36468,2071),(36469,2071),(36470,2071),(36471,2071),(36472,2071),(36473,2071),(36474,2072),(36475,2072),(36476,2072),(36477,2072),(36478,2072),(36479,2072),(36480,2072),(36481,2073),(36482,2073),(36483,2073),(36484,2073),(36485,2073),(36486,2073),(36487,2073),(36488,2074),(36489,2074),(36490,2074),(36491,2074),(36492,2074),(36493,2074),(36494,2074),(36495,2075),(36496,2075),(36497,2075),(36498,2075),(36499,2075),(36500,2075),(36501,2075),(36502,2076),(36503,2076),(36504,2076),(36505,2076),(36506,2076),(36507,2076),(36508,2076),(36509,2077),(36510,2077),(36511,2077),(36512,2077),(36513,2077),(36514,2077),(36515,2077),(36516,2078),(36517,2078),(36518,2078),(36519,2078),(36520,2078),(36521,2078),(36522,2078),(36523,2078),(36524,2078),(36525,2079),(36526,2079),(36527,2079),(36528,2079),(36529,2079),(36530,2079),(36531,2079),(36532,2080),(36533,2080),(36534,2080),(36535,2080),(36536,2080),(36537,2080),(36538,2080),(36539,2081),(36540,2081),(36541,2081),(36542,2081),(36543,2081),(36544,2081),(36545,2081),(36546,2082),(36547,2082),(36548,2082),(36549,2082),(36550,2082),(36551,2082),(36552,2082),(36553,2083),(36554,2083),(36555,2083),(36556,2083),(36557,2083),(36558,2083),(36559,2083),(36560,2084),(36561,2084),(36562,2084),(36563,2084),(36564,2084),(36565,2084),(36566,2084),(36567,2084),(36568,2084),(36569,2085),(36570,2085),(36571,2085),(36572,2085),(36573,2085),(36574,2085),(36575,2085),(36576,2086),(36577,2086),(36578,2086),(36579,2086),(36580,2086),(36581,2086),(36582,2086),(36583,2087),(36584,2087),(36585,2087),(36586,2087),(36587,2087),(36588,2087),(36589,2087),(36590,2088),(36591,2088),(36592,2088),(36593,2088),(36594,2088),(36595,2088),(36596,2088),(36597,2088),(36598,2088),(36599,2089),(36600,2089),(36601,2089),(36602,2089),(36603,2089),(36604,2089),(36605,2089),(36606,2090),(36607,2090),(36608,2090),(36609,2090),(36610,2090),(36611,2090),(36612,2090),(36613,2091),(36614,2091),(36615,2091),(36616,2091),(36617,2091),(36618,2091),(36619,2091),(36620,2092),(36621,2092),(36622,2092),(36623,2092),(36624,2092),(36625,2092),(36626,2092),(36627,2093),(36628,2093),(36629,2093),(36630,2093),(36631,2093),(36632,2093),(36633,2093),(36634,2094),(36635,2094),(36636,2094),(36637,2094),(36638,2094),(36639,2094),(36640,2094),(36641,2095),(36642,2095),(36643,2095),(36644,2095),(36645,2095),(36646,2095),(36647,2095),(36648,2096),(36649,2096),(36650,2096),(36651,2096),(36652,2096),(36653,2096),(36654,2096),(36655,2097),(36656,2097),(36657,2097),(36658,2097),(36659,2097),(36660,2097),(36661,2097),(36662,2097),(36663,2097),(36664,2098),(36665,2098),(36666,2098),(36667,2098),(36668,2098),(36669,2098),(36670,2098),(36671,2099),(36672,2099),(36673,2099),(36674,2099),(36675,2099),(36676,2099),(36677,2099),(36678,2100),(36679,2100),(36680,2100),(36681,2100),(36682,2100),(36683,2100),(36684,2100),(36685,2101),(36686,2101),(36687,2101),(36688,2101),(36689,2101),(36690,2101),(36691,2101),(36692,2101),(36693,2101),(36694,2102),(36695,2102),(36696,2102),(36697,2102),(36698,2102),(36699,2102),(36700,2102),(36701,2103),(36702,2103),(36703,2103),(36704,2103),(36705,2103),(36706,2103),(36707,2103),(36708,2104),(36709,2104),(36710,2104),(36711,2104),(36712,2104),(36713,2104),(36714,2104),(36715,2105),(36716,2105),(36717,2105),(36718,2105),(36719,2105),(36720,2105),(36721,2105),(36722,2105),(36723,2105),(36724,2106),(36725,2106),(36726,2106),(36727,2106),(36728,2106),(36729,2106),(36730,2106),(36731,2107),(36732,2107),(36733,2107),(36734,2107),(36735,2107),(36736,2107),(36737,2107),(36738,2108),(36739,2108),(36740,2108),(36741,2108),(36742,2108),(36743,2108),(36744,2108),(36745,2109),(36746,2109),(36747,2109),(36748,2109),(36749,2109),(36750,2109),(36751,2109),(36752,2110),(36753,2110),(36754,2110),(36755,2110),(36756,2110),(36757,2110),(36758,2110),(36759,2111),(36760,2111),(36761,2111),(36762,2111),(36763,2111),(36764,2111),(36765,2111),(36766,2112),(36767,2112),(36768,2112),(36769,2112),(36770,2112),(36771,2112),(36772,2112),(36773,2013),(36774,2013),(36775,2014),(36776,2014),(36777,2015),(36778,2015),(36779,2015),(36780,2016),(36781,2016),(36782,2016),(36783,2017),(36784,2017),(36785,2017),(36786,2018),(36787,2018),(36788,2018),(36789,2019),(36790,2019),(36791,2019),(36792,2020),(36793,2020),(36794,2020),(36795,2021),(36796,2022),(36797,2023),(36798,2024),(36799,2024),(36800,2025),(36801,2025),(36802,2026),(36803,2026),(36804,2027),(36805,2027),(36806,2028),(36807,2028),(36808,2029),(36809,2029),(36810,2030),(36811,2030),(36812,2031),(36813,2031),(36814,2032),(36815,2032),(36816,2033),(36817,2033),(36818,2034),(36819,2034),(36820,2035),(36821,2035),(36822,2036),(36823,2036),(36824,2036),(36825,2037),(36826,2037),(36827,2038),(36828,2038),(36829,2038),(36830,2039),(36831,2039),(36832,2040),(36833,2040),(36834,2041),(36835,2041),(36836,2042),(36837,2042),(36838,2043),(36839,2043),(36840,2043),(36841,2044),(36842,2044),(36843,2045),(36844,2045),(36845,2046),(36846,2046),(36847,2047),(36848,2047),(36849,2047),(36850,2048),(36851,2048),(36852,2048),(36853,2049),(36854,2049),(36855,2049),(36856,2050),(36857,2050),(36858,2050),(36859,2051),(36860,2051),(36861,2051),(36862,2052),(36863,2052),(36864,2052),(36865,2053),(36866,2053),(36867,2053),(36868,2054),(36869,2054),(36870,2054),(36871,2055),(36872,2055),(36873,2055),(36874,2056),(36875,2056),(36876,2056),(36877,2057),(36878,2057),(36879,2057),(36880,2058),(36881,2058),(36882,2058),(36883,2059),(36884,2059),(36885,2060),(36886,2060),(36887,2060),(36888,2061),(36889,2061),(36890,2062),(36891,2062),(36892,2062),(36893,2063),(36894,2063),(36895,2063),(36896,2064),(36897,2064),(36898,2065),(36899,2065),(36900,2065),(36901,2066),(36902,2066),(36903,2066),(36904,2067),(36905,2067),(36906,2067),(36907,2068),(36908,2068),(36909,2068),(36910,2069),(36911,2069),(36912,2069),(36913,2070),(36914,2070),(36915,2070),(36916,2071),(36917,2071),(36918,2071),(36919,2072),(36920,2072),(36921,2072),(36922,2073),(36923,2073),(36924,2073),(36925,2074),(36926,2074),(36927,2074),(36928,2075),(36929,2075),(36930,2075),(36931,2076),(36932,2076),(36933,2076),(36934,2077),(36935,2077),(36936,2077),(36937,2078),(36938,2078),(36939,2078),(36940,2079),(36941,2079),(36942,2079),(36943,2080),(36944,2080),(36945,2080),(36946,2081),(36947,2081),(36948,2081),(36949,2082),(36950,2082),(36951,2082),(36952,2083),(36953,2083),(36954,2083),(36955,2084),(36956,2084),(36957,2085),(36958,2085),(36959,2086),(36960,2086),(36961,2086),(36962,2087),(36963,2087),(36964,2087),(36965,2088),(36966,2088),(36967,2088),(36968,2089),(36969,2089),(36970,2090),(36971,2090),(36972,2090),(36973,2091),(36974,2091),(36975,2091),(36976,2092),(36977,2092),(36978,2092),(36979,2093),(36980,2093),(36981,2093),(36982,2094),(36983,2094),(36984,2094),(36985,2095),(36986,2095),(36987,2096),(36988,2096),(36989,2096),(36990,2097),(36991,2097),(36992,2097),(36993,2098),(36994,2098),(36995,2098),(36996,2099),(36997,2099),(36998,2099),(36999,2100),(37000,2100),(37001,2100),(37002,2101),(37003,2101),(37004,2101),(37005,2102),(37006,2102),(37007,2103),(37008,2103),(37009,2104),(37010,2104),(37011,2105),(37012,2105),(37013,2106),(37014,2106),(37015,2107),(37016,2107),(37017,2108),(37018,2108),(37019,2109),(37020,2109),(37021,2110),(37022,2110),(37023,2111),(37024,2111),(37025,2112),(37026,2112),(37027,2013),(37028,2013),(37029,2013),(37030,2014),(37031,2014),(37032,2014),(37033,2015),(37034,2015),(37035,2015),(37036,2016),(37037,2016),(37038,2016),(37039,2017),(37040,2017),(37041,2017),(37042,2018),(37043,2018),(37044,2018),(37045,2019),(37046,2019),(37047,2019),(37048,2020),(37049,2020),(37050,2020),(37051,2021),(37052,2021),(37053,2021),(37054,2022),(37055,2022),(37056,2022),(37057,2023),(37058,2023),(37059,2023),(37060,2024),(37061,2024),(37062,2024),(37063,2025),(37064,2025),(37065,2025),(37066,2026),(37067,2026),(37068,2026),(37069,2027),(37070,2027),(37071,2027),(37072,2028),(37073,2028),(37074,2028),(37075,2029),(37076,2029),(37077,2029),(37078,2030),(37079,2030),(37080,2030),(37081,2031),(37082,2031),(37083,2031),(37084,2032),(37085,2032),(37086,2032),(37087,2033),(37088,2033),(37089,2033),(37090,2034),(37091,2034),(37092,2034),(37093,2035),(37094,2035),(37095,2035),(37096,2036),(37097,2036),(37098,2036),(37099,2037),(37100,2037),(37101,2037),(37102,2038),(37103,2038),(37104,2038),(37105,2039),(37106,2039),(37107,2039),(37108,2040),(37109,2040),(37110,2040),(37111,2041),(37112,2041),(37113,2041),(37114,2042),(37115,2042),(37116,2042),(37117,2043),(37118,2043),(37119,2043),(37120,2044),(37121,2044),(37122,2044),(37123,2045),(37124,2045),(37125,2045),(37126,2046),(37127,2046),(37128,2046),(37129,2047),(37130,2047),(37131,2047),(37132,2048),(37133,2048),(37134,2048),(37135,2049),(37136,2049),(37137,2049),(37138,2050),(37139,2050),(37140,2050),(37141,2051),(37142,2051),(37143,2051),(37144,2052),(37145,2052),(37146,2052),(37147,2053),(37148,2053),(37149,2053),(37150,2054),(37151,2054),(37152,2054),(37153,2055),(37154,2055),(37155,2055),(37156,2056),(37157,2056),(37158,2056),(37159,2057),(37160,2057),(37161,2057),(37162,2058),(37163,2058),(37164,2058),(37165,2059),(37166,2059),(37167,2059),(37168,2060),(37169,2060),(37170,2060),(37171,2061),(37172,2061),(37173,2061),(37174,2062),(37175,2062),(37176,2062),(37177,2063),(37178,2063),(37179,2063),(37180,2064),(37181,2064),(37182,2064),(37183,2065),(37184,2065),(37185,2065),(37186,2066),(37187,2066),(37188,2066),(37189,2067),(37190,2067),(37191,2067),(37192,2068),(37193,2068),(37194,2068),(37195,2069),(37196,2069),(37197,2069),(37198,2070),(37199,2070),(37200,2070),(37201,2071),(37202,2071),(37203,2071),(37204,2072),(37205,2072),(37206,2072),(37207,2073),(37208,2073),(37209,2073),(37210,2074),(37211,2074),(37212,2074),(37213,2075),(37214,2075),(37215,2075),(37216,2076),(37217,2076),(37218,2076),(37219,2077),(37220,2077),(37221,2077),(37222,2078),(37223,2078),(37224,2078),(37225,2079),(37226,2079),(37227,2079),(37228,2080),(37229,2080),(37230,2080),(37231,2081),(37232,2081),(37233,2081),(37234,2082),(37235,2082),(37236,2082),(37237,2083),(37238,2083),(37239,2083),(37240,2084),(37241,2084),(37242,2084),(37243,2085),(37244,2085),(37245,2085),(37246,2086),(37247,2086),(37248,2086),(37249,2087),(37250,2087),(37251,2087),(37252,2088),(37253,2088),(37254,2088),(37255,2089),(37256,2089),(37257,2089),(37258,2090),(37259,2090),(37260,2090),(37261,2091),(37262,2091),(37263,2091),(37264,2092),(37265,2092),(37266,2092),(37267,2093),(37268,2093),(37269,2093),(37270,2094),(37271,2094),(37272,2094),(37273,2095),(37274,2095),(37275,2095),(37276,2096),(37277,2096),(37278,2096),(37279,2097),(37280,2097),(37281,2097),(37282,2098),(37283,2098),(37284,2098),(37285,2099),(37286,2099),(37287,2099),(37288,2100),(37289,2100),(37290,2100),(37291,2101),(37292,2101),(37293,2101),(37294,2102),(37295,2102),(37296,2102),(37297,2103),(37298,2103),(37299,2103),(37300,2104),(37301,2104),(37302,2104),(37303,2105),(37304,2105),(37305,2105),(37306,2106),(37307,2106),(37308,2106),(37309,2107),(37310,2107),(37311,2107),(37312,2108),(37313,2108),(37314,2108),(37315,2109),(37316,2109),(37317,2109),(37318,2110),(37319,2110),(37320,2110),(37321,2111),(37322,2111),(37323,2111),(37324,2112),(37325,2112),(37326,2112),(37327,2013),(37328,2013),(37329,2013),(37330,2013),(37331,2014),(37332,2014),(37333,2014),(37334,2014),(37335,2015),(37336,2015),(37337,2015),(37338,2015),(37339,2016),(37340,2016),(37341,2016),(37342,2016),(37343,2017),(37344,2017),(37345,2017),(37346,2017),(37347,2018),(37348,2018),(37349,2018),(37350,2018),(37351,2019),(37352,2019),(37353,2019),(37354,2019),(37355,2020),(37356,2020),(37357,2020),(37358,2020),(37359,2021),(37360,2021),(37361,2021),(37362,2021),(37363,2022),(37364,2022),(37365,2022),(37366,2022),(37367,2023),(37368,2023),(37369,2023),(37370,2023),(37371,2024),(37372,2024),(37373,2024),(37374,2024),(37375,2025),(37376,2025),(37377,2025),(37378,2025),(37379,2026),(37380,2026),(37381,2026),(37382,2026),(37383,2027),(37384,2027),(37385,2027),(37386,2027),(37387,2028),(37388,2028),(37389,2028),(37390,2028),(37391,2029),(37392,2029),(37393,2029),(37394,2029),(37395,2030),(37396,2030),(37397,2030),(37398,2030),(37399,2031),(37400,2031),(37401,2031),(37402,2031),(37403,2032),(37404,2032),(37405,2032),(37406,2032),(37407,2033),(37408,2033),(37409,2033),(37410,2033),(37411,2034),(37412,2034),(37413,2034),(37414,2034),(37415,2035),(37416,2035),(37417,2035),(37418,2035),(37419,2036),(37420,2036),(37421,2036),(37422,2036),(37423,2037),(37424,2037),(37425,2037),(37426,2037),(37427,2038),(37428,2038),(37429,2038),(37430,2038),(37431,2039),(37432,2039),(37433,2039),(37434,2039),(37435,2040),(37436,2040),(37437,2040),(37438,2040),(37439,2041),(37440,2041),(37441,2041),(37442,2041),(37443,2042),(37444,2042),(37445,2042),(37446,2042),(37447,2043),(37448,2043),(37449,2043),(37450,2043),(37451,2044),(37452,2044),(37453,2044),(37454,2044),(37455,2045),(37456,2045),(37457,2045),(37458,2045),(37459,2046),(37460,2046),(37461,2046),(37462,2046),(37463,2047),(37464,2047),(37465,2047),(37466,2047),(37467,2048),(37468,2048),(37469,2048),(37470,2048),(37471,2049),(37472,2049),(37473,2049),(37474,2049),(37475,2050),(37476,2050),(37477,2050),(37478,2050),(37479,2051),(37480,2051),(37481,2051),(37482,2051),(37483,2052),(37484,2052),(37485,2052),(37486,2052),(37487,2053),(37488,2053),(37489,2053),(37490,2053),(37491,2054),(37492,2054),(37493,2054),(37494,2054),(37495,2055),(37496,2055),(37497,2055),(37498,2055),(37499,2056),(37500,2056),(37501,2056),(37502,2056),(37503,2057),(37504,2057),(37505,2057),(37506,2057),(37507,2058),(37508,2058),(37509,2058),(37510,2058),(37511,2059),(37512,2059),(37513,2059),(37514,2059),(37515,2060),(37516,2060),(37517,2060),(37518,2060),(37519,2061),(37520,2061),(37521,2061),(37522,2061),(37523,2062),(37524,2062),(37525,2062),(37526,2062),(37527,2063),(37528,2063),(37529,2063),(37530,2063),(37531,2064),(37532,2064),(37533,2064),(37534,2064),(37535,2065),(37536,2065),(37537,2065),(37538,2065),(37539,2066),(37540,2066),(37541,2066),(37542,2066),(37543,2067),(37544,2067),(37545,2067),(37546,2067),(37547,2068),(37548,2068),(37549,2068),(37550,2068),(37551,2069),(37552,2069),(37553,2069),(37554,2069),(37555,2070),(37556,2070),(37557,2070),(37558,2070),(37559,2071),(37560,2071),(37561,2071),(37562,2071),(37563,2072),(37564,2072),(37565,2072),(37566,2072),(37567,2073),(37568,2073),(37569,2073),(37570,2073),(37571,2074),(37572,2074),(37573,2074),(37574,2074),(37575,2075),(37576,2075),(37577,2075),(37578,2075),(37579,2076),(37580,2076),(37581,2076),(37582,2076),(37583,2077),(37584,2077),(37585,2077),(37586,2077),(37587,2078),(37588,2078),(37589,2078),(37590,2078),(37591,2079),(37592,2079),(37593,2079),(37594,2079),(37595,2080),(37596,2080),(37597,2080),(37598,2080),(37599,2081),(37600,2081),(37601,2081),(37602,2081),(37603,2082),(37604,2082),(37605,2082),(37606,2082),(37607,2083),(37608,2083),(37609,2083),(37610,2083),(37611,2084),(37612,2084),(37613,2084),(37614,2084),(37615,2085),(37616,2085),(37617,2085),(37618,2085),(37619,2086),(37620,2086),(37621,2086),(37622,2086),(37623,2087),(37624,2087),(37625,2087),(37626,2087),(37627,2088),(37628,2088),(37629,2088),(37630,2088),(37631,2089),(37632,2089),(37633,2089),(37634,2089),(37635,2090),(37636,2090),(37637,2090),(37638,2090),(37639,2091),(37640,2091),(37641,2091),(37642,2091),(37643,2092),(37644,2092),(37645,2092),(37646,2092),(37647,2093),(37648,2093),(37649,2093),(37650,2093),(37651,2094),(37652,2094),(37653,2094),(37654,2094),(37655,2095),(37656,2095),(37657,2095),(37658,2095),(37659,2096),(37660,2096),(37661,2096),(37662,2096),(37663,2097),(37664,2097),(37665,2097),(37666,2097),(37667,2098),(37668,2098),(37669,2098),(37670,2098),(37671,2099),(37672,2099),(37673,2099),(37674,2099),(37675,2100),(37676,2100),(37677,2100),(37678,2100),(37679,2101),(37680,2101),(37681,2101),(37682,2101),(37683,2102),(37684,2102),(37685,2102),(37686,2102),(37687,2103),(37688,2103),(37689,2103),(37690,2103),(37691,2104),(37692,2104),(37693,2104),(37694,2104),(37695,2105),(37696,2105),(37697,2105),(37698,2105),(37699,2106),(37700,2106),(37701,2106),(37702,2106),(37703,2107),(37704,2107),(37705,2107),(37706,2107),(37707,2108),(37708,2108),(37709,2108),(37710,2108),(37711,2109),(37712,2109),(37713,2109),(37714,2109),(37715,2110),(37716,2110),(37717,2110),(37718,2110),(37719,2111),(37720,2111),(37721,2111),(37722,2111),(37723,2112),(37724,2112),(37725,2112),(37726,2112),(37727,2113),(37728,2114),(37729,2115),(37730,2116),(37731,2117),(37732,2118),(37733,2119),(37734,2120),(37735,2121),(37736,2122),(37737,2123),(37738,2124),(37739,2125),(37740,2126),(37741,2127),(37742,2128),(37743,2129),(37744,2130),(37745,2131),(37746,2132),(37747,2133),(37748,2134),(37749,2135),(37750,2136),(37751,2137),(37752,2138),(37753,2139),(37754,2140),(37755,2141),(37756,2142),(37757,2143),(37758,2144),(37759,2145),(37760,2146),(37761,2147),(37762,2148),(37763,2149),(37764,2150),(37765,2151),(37766,2152),(37767,2153),(37768,2154),(37769,2155),(37770,2156),(37771,2157),(37772,2158),(37773,2159),(37774,2160),(37775,2161),(37776,2162),(37777,2163),(37778,2164),(37779,2165),(37780,2166),(37781,2167),(37782,2168),(37783,2169),(37784,2170),(37785,2171),(37786,2172),(37787,2173),(37788,2174),(37789,2175),(37790,2176),(37791,2177),(37792,2178),(37793,2179),(37794,2180),(37795,2181),(37796,2182),(37797,2183),(37798,2184),(37799,2185),(37800,2186),(37801,2187),(37802,2188),(37803,2189),(37804,2190),(37805,2191),(37806,2192),(37807,2193),(37808,2194),(37809,2195),(37810,2196),(37811,2197),(37812,2198),(37813,2199),(37814,2200),(37815,2201),(37816,2202),(37817,2203),(37818,2204),(37819,2205),(37820,2206),(37821,2207),(37822,2208),(37823,2209),(37824,2210),(37825,2211),(37826,2212),(37827,2113),(37828,2113),(37829,2113),(37830,2113),(37831,2113),(37832,2113),(37833,2114),(37834,2114),(37835,2114),(37836,2114),(37837,2114),(37838,2114),(37839,2115),(37840,2115),(37841,2115),(37842,2115),(37843,2115),(37844,2115),(37845,2115),(37846,2116),(37847,2116),(37848,2116),(37849,2116),(37850,2116),(37851,2116),(37852,2116),(37853,2117),(37854,2117),(37855,2117),(37856,2117),(37857,2117),(37858,2117),(37859,2117),(37860,2118),(37861,2118),(37862,2118),(37863,2118),(37864,2118),(37865,2118),(37866,2118),(37867,2119),(37868,2119),(37869,2119),(37870,2119),(37871,2119),(37872,2119),(37873,2119),(37874,2120),(37875,2120),(37876,2120),(37877,2120),(37878,2120),(37879,2120),(37880,2120),(37881,2120),(37882,2120),(37883,2121),(37884,2121),(37885,2121),(37886,2121),(37887,2121),(37888,2121),(37889,2121),(37890,2121),(37891,2121),(37892,2122),(37893,2122),(37894,2122),(37895,2122),(37896,2122),(37897,2122),(37898,2122),(37899,2122),(37900,2122),(37901,2123),(37902,2123),(37903,2123),(37904,2123),(37905,2123),(37906,2123),(37907,2123),(37908,2123),(37909,2123),(37910,2124),(37911,2124),(37912,2124),(37913,2124),(37914,2124),(37915,2124),(37916,2124),(37917,2124),(37918,2124),(37919,2125),(37920,2125),(37921,2125),(37922,2125),(37923,2125),(37924,2125),(37925,2125),(37926,2125),(37927,2125),(37928,2126),(37929,2126),(37930,2126),(37931,2126),(37932,2126),(37933,2126),(37934,2126),(37935,2126),(37936,2126),(37937,2127),(37938,2127),(37939,2127),(37940,2127),(37941,2127),(37942,2127),(37943,2127),(37944,2127),(37945,2127),(37946,2128),(37947,2128),(37948,2128),(37949,2128),(37950,2128),(37951,2128),(37952,2128),(37953,2128),(37954,2128),(37955,2129),(37956,2129),(37957,2129),(37958,2129),(37959,2129),(37960,2129),(37961,2129),(37962,2129),(37963,2129),(37964,2130),(37965,2130),(37966,2130),(37967,2130),(37968,2130),(37969,2130),(37970,2130),(37971,2130),(37972,2130),(37973,2131),(37974,2131),(37975,2131),(37976,2131),(37977,2131),(37978,2131),(37979,2131),(37980,2131),(37981,2131),(37982,2132),(37983,2132),(37984,2132),(37985,2132),(37986,2132),(37987,2132),(37988,2132),(37989,2132),(37990,2132),(37991,2133),(37992,2133),(37993,2133),(37994,2133),(37995,2133),(37996,2133),(37997,2133),(37998,2134),(37999,2134),(38000,2134),(38001,2134),(38002,2134),(38003,2134),(38004,2134),(38005,2135),(38006,2135),(38007,2135),(38008,2135),(38009,2135),(38010,2135),(38011,2135),(38012,2135),(38013,2136),(38014,2136),(38015,2136),(38016,2136),(38017,2136),(38018,2136),(38019,2136),(38020,2136),(38021,2136),(38022,2137),(38023,2137),(38024,2137),(38025,2137),(38026,2137),(38027,2137),(38028,2137),(38029,2137),(38030,2137),(38031,2138),(38032,2138),(38033,2138),(38034,2138),(38035,2138),(38036,2138),(38037,2138),(38038,2138),(38039,2138),(38040,2139),(38041,2139),(38042,2139),(38043,2139),(38044,2139),(38045,2139),(38046,2139),(38047,2140),(38048,2140),(38049,2140),(38050,2140),(38051,2140),(38052,2140),(38053,2140),(38054,2141),(38055,2141),(38056,2141),(38057,2141),(38058,2141),(38059,2141),(38060,2141),(38061,2142),(38062,2142),(38063,2142),(38064,2142),(38065,2142),(38066,2142),(38067,2142),(38068,2143),(38069,2143),(38070,2143),(38071,2143),(38072,2143),(38073,2143),(38074,2143),(38075,2144),(38076,2144),(38077,2144),(38078,2144),(38079,2144),(38080,2144),(38081,2144),(38082,2145),(38083,2145),(38084,2145),(38085,2145),(38086,2145),(38087,2145),(38088,2145),(38089,2146),(38090,2146),(38091,2146),(38092,2146),(38093,2146),(38094,2146),(38095,2146),(38096,2147),(38097,2147),(38098,2147),(38099,2147),(38100,2147),(38101,2147),(38102,2147),(38103,2148),(38104,2148),(38105,2148),(38106,2148),(38107,2148),(38108,2148),(38109,2148),(38110,2149),(38111,2149),(38112,2149),(38113,2149),(38114,2149),(38115,2149),(38116,2149),(38117,2150),(38118,2150),(38119,2150),(38120,2150),(38121,2150),(38122,2150),(38123,2150),(38124,2151),(38125,2151),(38126,2151),(38127,2151),(38128,2151),(38129,2151),(38130,2151),(38131,2152),(38132,2152),(38133,2152),(38134,2152),(38135,2152),(38136,2152),(38137,2152),(38138,2153),(38139,2153),(38140,2153),(38141,2153),(38142,2153),(38143,2153),(38144,2153),(38145,2154),(38146,2154),(38147,2154),(38148,2154),(38149,2154),(38150,2154),(38151,2154),(38152,2154),(38153,2154),(38154,2155),(38155,2155),(38156,2155),(38157,2155),(38158,2155),(38159,2155),(38160,2155),(38161,2155),(38162,2155),(38163,2156),(38164,2156),(38165,2156),(38166,2156),(38167,2156),(38168,2156),(38169,2156),(38170,2156),(38171,2156),(38172,2157),(38173,2157),(38174,2157),(38175,2157),(38176,2157),(38177,2157),(38178,2157),(38179,2157),(38180,2157),(38181,2158),(38182,2158),(38183,2158),(38184,2158),(38185,2158),(38186,2158),(38187,2158),(38188,2159),(38189,2159),(38190,2159),(38191,2159),(38192,2159),(38193,2159),(38194,2159),(38195,2159),(38196,2159),(38197,2160),(38198,2160),(38199,2160),(38200,2160),(38201,2160),(38202,2160),(38203,2160),(38204,2161),(38205,2161),(38206,2161),(38207,2161),(38208,2161),(38209,2161),(38210,2161),(38211,2162),(38212,2162),(38213,2162),(38214,2162),(38215,2162),(38216,2162),(38217,2162),(38218,2163),(38219,2163),(38220,2163),(38221,2163),(38222,2163),(38223,2163),(38224,2163),(38225,2163),(38226,2163),(38227,2164),(38228,2164),(38229,2164),(38230,2164),(38231,2164),(38232,2164),(38233,2164),(38234,2165),(38235,2165),(38236,2165),(38237,2165),(38238,2165),(38239,2165),(38240,2165),(38241,2166),(38242,2166),(38243,2166),(38244,2166),(38245,2166),(38246,2166),(38247,2166),(38248,2167),(38249,2167),(38250,2167),(38251,2167),(38252,2167),(38253,2167),(38254,2167),(38255,2168),(38256,2168),(38257,2168),(38258,2168),(38259,2168),(38260,2168),(38261,2168),(38262,2169),(38263,2169),(38264,2169),(38265,2169),(38266,2169),(38267,2169),(38268,2169),(38269,2170),(38270,2170),(38271,2170),(38272,2170),(38273,2170),(38274,2170),(38275,2170),(38276,2171),(38277,2171),(38278,2171),(38279,2171),(38280,2171),(38281,2171),(38282,2171),(38283,2172),(38284,2172),(38285,2172),(38286,2172),(38287,2172),(38288,2172),(38289,2172),(38290,2173),(38291,2173),(38292,2173),(38293,2173),(38294,2173),(38295,2173),(38296,2173),(38297,2174),(38298,2174),(38299,2174),(38300,2174),(38301,2174),(38302,2174),(38303,2174),(38304,2175),(38305,2175),(38306,2175),(38307,2175),(38308,2175),(38309,2175),(38310,2175),(38311,2176),(38312,2176),(38313,2176),(38314,2176),(38315,2176),(38316,2176),(38317,2176),(38318,2177),(38319,2177),(38320,2177),(38321,2177),(38322,2177),(38323,2177),(38324,2177),(38325,2177),(38326,2177),(38327,2178),(38328,2178),(38329,2178),(38330,2178),(38331,2178),(38332,2178),(38333,2178),(38334,2179),(38335,2179),(38336,2179),(38337,2179),(38338,2179),(38339,2179),(38340,2179),(38341,2180),(38342,2180),(38343,2180),(38344,2180),(38345,2180),(38346,2180),(38347,2180),(38348,2181),(38349,2181),(38350,2181),(38351,2181),(38352,2181),(38353,2181),(38354,2181),(38355,2182),(38356,2182),(38357,2182),(38358,2182),(38359,2182),(38360,2182),(38361,2182),(38362,2183),(38363,2183),(38364,2183),(38365,2183),(38366,2183),(38367,2183),(38368,2183),(38369,2184),(38370,2184),(38371,2184),(38372,2184),(38373,2184),(38374,2184),(38375,2184),(38376,2185),(38377,2185),(38378,2185),(38379,2185),(38380,2185),(38381,2185),(38382,2185),(38383,2186),(38384,2186),(38385,2186),(38386,2186),(38387,2186),(38388,2186),(38389,2186),(38390,2187),(38391,2187),(38392,2187),(38393,2187),(38394,2187),(38395,2187),(38396,2187),(38397,2188),(38398,2188),(38399,2188),(38400,2188),(38401,2188),(38402,2188),(38403,2188),(38404,2189),(38405,2189),(38406,2189),(38407,2189),(38408,2189),(38409,2189),(38410,2189),(38411,2190),(38412,2190),(38413,2190),(38414,2190),(38415,2190),(38416,2190),(38417,2190),(38418,2191),(38419,2191),(38420,2191),(38421,2191),(38422,2192),(38423,2192),(38424,2192),(38425,2192),(38426,2192),(38427,2192),(38428,2192),(38429,2193),(38430,2193),(38431,2193),(38432,2193),(38433,2194),(38434,2194),(38435,2194),(38436,2194),(38437,2194),(38438,2194),(38439,2194),(38440,2195),(38441,2195),(38442,2195),(38443,2195),(38444,2196),(38445,2196),(38446,2196),(38447,2196),(38448,2196),(38449,2196),(38450,2197),(38451,2197),(38452,2197),(38453,2197),(38454,2197),(38455,2197),(38456,2197),(38457,2198),(38458,2198),(38459,2198),(38460,2198),(38461,2199),(38462,2199),(38463,2199),(38464,2199),(38465,2199),(38466,2199),(38467,2199),(38468,2200),(38469,2200),(38470,2200),(38471,2200),(38472,2200),(38473,2200),(38474,2200),(38475,2201),(38476,2201),(38477,2201),(38478,2201),(38479,2201),(38480,2201),(38481,2201),(38482,2202),(38483,2202),(38484,2202),(38485,2202),(38486,2202),(38487,2202),(38488,2202),(38489,2203),(38490,2203),(38491,2203),(38492,2203),(38493,2203),(38494,2203),(38495,2203),(38496,2204),(38497,2204),(38498,2204),(38499,2204),(38500,2204),(38501,2204),(38502,2204),(38503,2205),(38504,2205),(38505,2205),(38506,2205),(38507,2205),(38508,2205),(38509,2205),(38510,2206),(38511,2206),(38512,2206),(38513,2206),(38514,2206),(38515,2206),(38516,2206),(38517,2207),(38518,2207),(38519,2207),(38520,2207),(38521,2207),(38522,2207),(38523,2207),(38524,2208),(38525,2208),(38526,2208),(38527,2208),(38528,2208),(38529,2208),(38530,2208),(38531,2209),(38532,2209),(38533,2209),(38534,2209),(38535,2209),(38536,2209),(38537,2209),(38538,2210),(38539,2210),(38540,2210),(38541,2210),(38542,2210),(38543,2210),(38544,2210),(38545,2211),(38546,2211),(38547,2211),(38548,2211),(38549,2211),(38550,2211),(38551,2211),(38552,2211),(38553,2211),(38554,2212),(38555,2212),(38556,2212),(38557,2212),(38558,2212),(38559,2212),(38560,2212),(38561,2113),(38562,2113),(38563,2114),(38564,2114),(38565,2115),(38566,2116),(38567,2116),(38568,2116),(38569,2117),(38570,2117),(38571,2117),(38572,2118),(38573,2118),(38574,2118),(38575,2119),(38576,2119),(38577,2119),(38578,2120),(38579,2120),(38580,2121),(38581,2121),(38582,2122),(38583,2122),(38584,2123),(38585,2123),(38586,2124),(38587,2124),(38588,2125),(38589,2125),(38590,2126),(38591,2126),(38592,2127),(38593,2127),(38594,2128),(38595,2128),(38596,2129),(38597,2129),(38598,2130),(38599,2130),(38600,2131),(38601,2131),(38602,2132),(38603,2132),(38604,2133),(38605,2133),(38606,2133),(38607,2134),(38608,2134),(38609,2134),(38610,2135),(38611,2135),(38612,2136),(38613,2136),(38614,2137),(38615,2137),(38616,2138),(38617,2138),(38618,2139),(38619,2139),(38620,2139),(38621,2140),(38622,2140),(38623,2140),(38624,2141),(38625,2141),(38626,2141),(38627,2142),(38628,2142),(38629,2142),(38630,2143),(38631,2143),(38632,2143),(38633,2144),(38634,2144),(38635,2144),(38636,2145),(38637,2145),(38638,2145),(38639,2146),(38640,2146),(38641,2146),(38642,2147),(38643,2147),(38644,2147),(38645,2148),(38646,2148),(38647,2148),(38648,2149),(38649,2149),(38650,2149),(38651,2150),(38652,2150),(38653,2150),(38654,2151),(38655,2151),(38656,2151),(38657,2152),(38658,2152),(38659,2152),(38660,2153),(38661,2153),(38662,2153),(38663,2154),(38664,2154),(38665,2154),(38666,2155),(38667,2155),(38668,2156),(38669,2156),(38670,2157),(38671,2157),(38672,2158),(38673,2158),(38674,2158),(38675,2159),(38676,2159),(38677,2159),(38678,2160),(38679,2160),(38680,2160),(38681,2161),(38682,2161),(38683,2161),(38684,2162),(38685,2162),(38686,2162),(38687,2163),(38688,2163),(38689,2164),(38690,2164),(38691,2164),(38692,2165),(38693,2165),(38694,2165),(38695,2166),(38696,2166),(38697,2166),(38698,2167),(38699,2167),(38700,2167),(38701,2168),(38702,2168),(38703,2168),(38704,2169),(38705,2169),(38706,2169),(38707,2170),(38708,2170),(38709,2170),(38710,2171),(38711,2171),(38712,2171),(38713,2172),(38714,2172),(38715,2172),(38716,2173),(38717,2173),(38718,2173),(38719,2174),(38720,2174),(38721,2174),(38722,2175),(38723,2175),(38724,2175),(38725,2176),(38726,2176),(38727,2176),(38728,2177),(38729,2177),(38730,2177),(38731,2178),(38732,2178),(38733,2178),(38734,2179),(38735,2179),(38736,2179),(38737,2180),(38738,2180),(38739,2180),(38740,2181),(38741,2181),(38742,2181),(38743,2182),(38744,2182),(38745,2182),(38746,2183),(38747,2183),(38748,2183),(38749,2184),(38750,2184),(38751,2184),(38752,2185),(38753,2185),(38754,2185),(38755,2186),(38756,2186),(38757,2186),(38758,2187),(38759,2187),(38760,2187),(38761,2188),(38762,2188),(38763,2188),(38764,2189),(38765,2189),(38766,2189),(38767,2190),(38768,2190),(38769,2190),(38770,2191),(38771,2192),(38772,2192),(38773,2192),(38774,2193),(38775,2194),(38776,2194),(38777,2194),(38778,2195),(38779,2196),(38780,2196),(38781,2196),(38782,2197),(38783,2197),(38784,2197),(38785,2198),(38786,2199),(38787,2199),(38788,2199),(38789,2200),(38790,2200),(38791,2200),(38792,2201),(38793,2201),(38794,2201),(38795,2202),(38796,2202),(38797,2202),(38798,2203),(38799,2203),(38800,2203),(38801,2204),(38802,2204),(38803,2204),(38804,2205),(38805,2205),(38806,2205),(38807,2206),(38808,2206),(38809,2206),(38810,2207),(38811,2207),(38812,2207),(38813,2208),(38814,2208),(38815,2208),(38816,2209),(38817,2209),(38818,2209),(38819,2210),(38820,2210),(38821,2210),(38822,2211),(38823,2211),(38824,2211),(38825,2212),(38826,2212),(38827,2212),(38828,2113),(38829,2113),(38830,2113),(38831,2114),(38832,2114),(38833,2114),(38834,2115),(38835,2115),(38836,2115),(38837,2116),(38838,2116),(38839,2116),(38840,2117),(38841,2117),(38842,2117),(38843,2118),(38844,2118),(38845,2118),(38846,2119),(38847,2119),(38848,2119),(38849,2120),(38850,2120),(38851,2120),(38852,2121),(38853,2121),(38854,2121),(38855,2122),(38856,2122),(38857,2122),(38858,2123),(38859,2123),(38860,2123),(38861,2124),(38862,2124),(38863,2124),(38864,2125),(38865,2125),(38866,2125),(38867,2126),(38868,2126),(38869,2126),(38870,2127),(38871,2127),(38872,2127),(38873,2128),(38874,2128),(38875,2128),(38876,2129),(38877,2129),(38878,2129),(38879,2130),(38880,2130),(38881,2130),(38882,2131),(38883,2131),(38884,2131),(38885,2132),(38886,2132),(38887,2132),(38888,2133),(38889,2133),(38890,2133),(38891,2134),(38892,2134),(38893,2134),(38894,2135),(38895,2135),(38896,2135),(38897,2136),(38898,2136),(38899,2136),(38900,2137),(38901,2137),(38902,2137),(38903,2138),(38904,2138),(38905,2138),(38906,2139),(38907,2139),(38908,2139),(38909,2140),(38910,2140),(38911,2140),(38912,2141),(38913,2141),(38914,2141),(38915,2142),(38916,2142),(38917,2142),(38918,2143),(38919,2143),(38920,2143),(38921,2144),(38922,2144),(38923,2144),(38924,2145),(38925,2145),(38926,2145),(38927,2146),(38928,2146),(38929,2146),(38930,2147),(38931,2147),(38932,2147),(38933,2148),(38934,2148),(38935,2148),(38936,2149),(38937,2149),(38938,2149),(38939,2150),(38940,2150),(38941,2150),(38942,2151),(38943,2151),(38944,2151),(38945,2152),(38946,2152),(38947,2152),(38948,2153),(38949,2153),(38950,2153),(38951,2154),(38952,2154),(38953,2154),(38954,2155),(38955,2155),(38956,2155),(38957,2156),(38958,2156),(38959,2156),(38960,2157),(38961,2157),(38962,2157),(38963,2158),(38964,2158),(38965,2158),(38966,2159),(38967,2159),(38968,2159),(38969,2160),(38970,2160),(38971,2160),(38972,2161),(38973,2161),(38974,2161),(38975,2162),(38976,2162),(38977,2162),(38978,2163),(38979,2163),(38980,2163),(38981,2164),(38982,2164),(38983,2164),(38984,2165),(38985,2165),(38986,2165),(38987,2166),(38988,2166),(38989,2166),(38990,2167),(38991,2167),(38992,2167),(38993,2168),(38994,2168),(38995,2168),(38996,2169),(38997,2169),(38998,2169),(38999,2169),(39000,2170),(39001,2170),(39002,2170),(39003,2171),(39004,2171),(39005,2171),(39006,2172),(39007,2172),(39008,2172),(39009,2173),(39010,2173),(39011,2173),(39012,2174),(39013,2174),(39014,2174),(39015,2175),(39016,2175),(39017,2175),(39018,2176),(39019,2176),(39020,2176),(39021,2177),(39022,2177),(39023,2177),(39024,2178),(39025,2178),(39026,2178),(39027,2179),(39028,2179),(39029,2179),(39030,2180),(39031,2180),(39032,2180),(39033,2181),(39034,2181),(39035,2181),(39036,2182),(39037,2182),(39038,2182),(39039,2183),(39040,2183),(39041,2183),(39042,2184),(39043,2184),(39044,2184),(39045,2185),(39046,2185),(39047,2185),(39048,2186),(39049,2186),(39050,2186),(39051,2187),(39052,2187),(39053,2187),(39054,2188),(39055,2188),(39056,2188),(39057,2189),(39058,2189),(39059,2189),(39060,2190),(39061,2190),(39062,2190),(39063,2191),(39064,2191),(39065,2191),(39066,2192),(39067,2192),(39068,2192),(39069,2193),(39070,2193),(39071,2193),(39072,2194),(39073,2194),(39074,2194),(39075,2195),(39076,2195),(39077,2195),(39078,2196),(39079,2196),(39080,2196),(39081,2197),(39082,2197),(39083,2197),(39084,2198),(39085,2198),(39086,2198),(39087,2199),(39088,2199),(39089,2199),(39090,2200),(39091,2200),(39092,2200),(39093,2201),(39094,2201),(39095,2201),(39096,2202),(39097,2202),(39098,2202),(39099,2203),(39100,2203),(39101,2203),(39102,2204),(39103,2204),(39104,2204),(39105,2205),(39106,2205),(39107,2205),(39108,2206),(39109,2206),(39110,2206),(39111,2207),(39112,2207),(39113,2207),(39114,2208),(39115,2208),(39116,2208),(39117,2209),(39118,2209),(39119,2209),(39120,2210),(39121,2210),(39122,2210),(39123,2211),(39124,2211),(39125,2211),(39126,2212),(39127,2212),(39128,2212),(39129,2113),(39130,2113),(39131,2113),(39132,2113),(39133,2114),(39134,2114),(39135,2114),(39136,2114),(39137,2115),(39138,2115),(39139,2115),(39140,2115),(39141,2116),(39142,2116),(39143,2116),(39144,2116),(39145,2117),(39146,2117),(39147,2117),(39148,2117),(39149,2118),(39150,2118),(39151,2118),(39152,2118),(39153,2119),(39154,2119),(39155,2119),(39156,2119),(39157,2120),(39158,2120),(39159,2120),(39160,2120),(39161,2121),(39162,2121),(39163,2121),(39164,2121),(39165,2122),(39166,2122),(39167,2122),(39168,2122),(39169,2123),(39170,2123),(39171,2123),(39172,2123),(39173,2124),(39174,2124),(39175,2124),(39176,2124),(39177,2125),(39178,2125),(39179,2125),(39180,2125),(39181,2126),(39182,2126),(39183,2126),(39184,2126),(39185,2127),(39186,2127),(39187,2127),(39188,2127),(39189,2128),(39190,2128),(39191,2128),(39192,2128),(39193,2129),(39194,2129),(39195,2129),(39196,2129),(39197,2130),(39198,2130),(39199,2130),(39200,2130),(39201,2131),(39202,2131),(39203,2131),(39204,2131),(39205,2132),(39206,2132),(39207,2132),(39208,2132),(39209,2133),(39210,2133),(39211,2133),(39212,2133),(39213,2134),(39214,2134),(39215,2134),(39216,2134),(39217,2135),(39218,2135),(39219,2135),(39220,2135),(39221,2136),(39222,2136),(39223,2136),(39224,2136),(39225,2137),(39226,2137),(39227,2137),(39228,2137),(39229,2138),(39230,2138),(39231,2138),(39232,2138),(39233,2139),(39234,2139),(39235,2139),(39236,2139),(39237,2140),(39238,2140),(39239,2140),(39240,2140),(39241,2141),(39242,2141),(39243,2141),(39244,2141),(39245,2142),(39246,2142),(39247,2142),(39248,2142),(39249,2143),(39250,2143),(39251,2143),(39252,2143),(39253,2144),(39254,2144),(39255,2144),(39256,2144),(39257,2145),(39258,2145),(39259,2145),(39260,2145),(39261,2146),(39262,2146),(39263,2146),(39264,2146),(39265,2147),(39266,2147),(39267,2147),(39268,2147),(39269,2148),(39270,2148),(39271,2148),(39272,2148),(39273,2149),(39274,2149),(39275,2149),(39276,2149),(39277,2150),(39278,2150),(39279,2150),(39280,2150),(39281,2151),(39282,2151),(39283,2151),(39284,2151),(39285,2152),(39286,2152),(39287,2152),(39288,2152),(39289,2153),(39290,2153),(39291,2153),(39292,2153),(39293,2154),(39294,2154),(39295,2154),(39296,2154),(39297,2155),(39298,2155),(39299,2155),(39300,2155),(39301,2156),(39302,2156),(39303,2156),(39304,2156),(39305,2157),(39306,2157),(39307,2157),(39308,2157),(39309,2158),(39310,2158),(39311,2158),(39312,2158),(39313,2159),(39314,2159),(39315,2159),(39316,2159),(39317,2160),(39318,2160),(39319,2160),(39320,2160),(39321,2161),(39322,2161),(39323,2161),(39324,2161),(39325,2162),(39326,2162),(39327,2162),(39328,2162),(39329,2163),(39330,2163),(39331,2163),(39332,2163),(39333,2164),(39334,2164),(39335,2164),(39336,2164),(39337,2165),(39338,2165),(39339,2165),(39340,2165),(39341,2166),(39342,2166),(39343,2166),(39344,2166),(39345,2167),(39346,2167),(39347,2167),(39348,2167),(39349,2168),(39350,2168),(39351,2168),(39352,2168),(39353,2169),(39354,2169),(39355,2169),(39356,2169),(39357,2170),(39358,2170),(39359,2170),(39360,2170),(39361,2171),(39362,2171),(39363,2171),(39364,2171),(39365,2172),(39366,2172),(39367,2172),(39368,2172),(39369,2173),(39370,2173),(39371,2173),(39372,2173),(39373,2174),(39374,2174),(39375,2174),(39376,2174),(39377,2175),(39378,2175),(39379,2175),(39380,2175),(39381,2176),(39382,2176),(39383,2176),(39384,2176),(39385,2177),(39386,2177),(39387,2177),(39388,2177),(39389,2178),(39390,2178),(39391,2178),(39392,2178),(39393,2179),(39394,2179),(39395,2179),(39396,2179),(39397,2180),(39398,2180),(39399,2180),(39400,2180),(39401,2181),(39402,2181),(39403,2181),(39404,2181),(39405,2182),(39406,2182),(39407,2182),(39408,2182),(39409,2183),(39410,2183),(39411,2183),(39412,2183),(39413,2184),(39414,2184),(39415,2184),(39416,2184),(39417,2185),(39418,2185),(39419,2185),(39420,2185),(39421,2186),(39422,2186),(39423,2186),(39424,2186),(39425,2187),(39426,2187),(39427,2187),(39428,2187),(39429,2188),(39430,2188),(39431,2188),(39432,2188),(39433,2189),(39434,2189),(39435,2189),(39436,2189),(39437,2190),(39438,2190),(39439,2190),(39440,2190),(39441,2191),(39442,2191),(39443,2191),(39444,2191),(39445,2192),(39446,2192),(39447,2192),(39448,2192),(39449,2193),(39450,2193),(39451,2193),(39452,2193),(39453,2194),(39454,2194),(39455,2194),(39456,2194),(39457,2195),(39458,2195),(39459,2195),(39460,2195),(39461,2196),(39462,2196),(39463,2196),(39464,2196),(39465,2197),(39466,2197),(39467,2197),(39468,2197),(39469,2198),(39470,2198),(39471,2198),(39472,2198),(39473,2199),(39474,2199),(39475,2199),(39476,2199),(39477,2200),(39478,2200),(39479,2200),(39480,2200),(39481,2201),(39482,2201),(39483,2201),(39484,2201),(39485,2202),(39486,2202),(39487,2202),(39488,2202),(39489,2203),(39490,2203),(39491,2203),(39492,2203),(39493,2204),(39494,2204),(39495,2204),(39496,2204),(39497,2205),(39498,2205),(39499,2205),(39500,2205),(39501,2206),(39502,2206),(39503,2206),(39504,2206),(39505,2207),(39506,2207),(39507,2207),(39508,2207),(39509,2208),(39510,2208),(39511,2208),(39512,2208),(39513,2209),(39514,2209),(39515,2209),(39516,2209),(39517,2210),(39518,2210),(39519,2210),(39520,2210),(39521,2211),(39522,2211),(39523,2211),(39524,2211),(39525,2212),(39526,2212),(39527,2212),(39528,2212),(39529,2213),(39530,2214),(39531,2215),(39532,2216),(39533,2217),(39534,2218),(39535,2219),(39536,2220),(39537,2221),(39538,2222),(39539,2223),(39540,2224),(39541,2225),(39542,2226),(39543,2227),(39544,2228),(39545,2229),(39546,2230),(39547,2231),(39548,2232),(39549,2233),(39550,2234),(39551,2235),(39552,2236),(39553,2237),(39554,2238),(39555,2239),(39556,2240),(39557,2241),(39558,2242),(39559,2243),(39560,2244),(39561,2245),(39562,2246),(39563,2247),(39564,2248),(39565,2249),(39566,2250),(39567,2251),(39568,2252),(39569,2253),(39570,2254),(39571,2255),(39572,2256),(39573,2257),(39574,2258),(39575,2259),(39576,2260),(39577,2261),(39578,2262),(39579,2263),(39580,2264),(39581,2265),(39582,2266),(39583,2267),(39584,2268),(39585,2269),(39586,2270),(39587,2271),(39588,2272),(39589,2273),(39590,2274),(39591,2275),(39592,2276),(39593,2277),(39594,2278),(39595,2279),(39596,2280),(39597,2281),(39598,2282),(39599,2283),(39600,2284),(39601,2285),(39602,2286),(39603,2287),(39604,2288),(39605,2289),(39606,2290),(39607,2291),(39608,2292),(39609,2293),(39610,2294),(39611,2295),(39612,2296),(39613,2297),(39614,2298),(39615,2299),(39616,2300),(39617,2301),(39618,2302),(39619,2303),(39620,2304),(39621,2305),(39622,2306),(39623,2307),(39624,2308),(39625,2309),(39626,2310),(39627,2213),(39628,2213),(39629,2213),(39630,2213),(39631,2213),(39632,2213),(39633,2213),(39634,2214),(39635,2214),(39636,2214),(39637,2214),(39638,2214),(39639,2214),(39640,2214),(39641,2215),(39642,2215),(39643,2215),(39644,2215),(39645,2215),(39646,2215),(39647,2215),(39648,2216),(39649,2216),(39650,2216),(39651,2216),(39652,2216),(39653,2216),(39654,2216),(39655,2217),(39656,2217),(39657,2217),(39658,2217),(39659,2217),(39660,2217),(39661,2217),(39662,2218),(39663,2218),(39664,2218),(39665,2218),(39666,2218),(39667,2218),(39668,2218),(39669,2219),(39670,2219),(39671,2219),(39672,2219),(39673,2219),(39674,2219),(39675,2219),(39676,2220),(39677,2220),(39678,2220),(39679,2220),(39680,2220),(39681,2220),(39682,2220),(39683,2221),(39684,2221),(39685,2221),(39686,2221),(39687,2221),(39688,2221),(39689,2222),(39690,2222),(39691,2222),(39692,2222),(39693,2222),(39694,2222),(39695,2223),(39696,2223),(39697,2223),(39698,2223),(39699,2223),(39700,2223),(39701,2224),(39702,2224),(39703,2224),(39704,2224),(39705,2224),(39706,2224),(39707,2225),(39708,2225),(39709,2225),(39710,2225),(39711,2225),(39712,2225),(39713,2225),(39714,2226),(39715,2226),(39716,2226),(39717,2226),(39718,2226),(39719,2226),(39720,2226),(39721,2226),(39722,2226),(39723,2227),(39724,2227),(39725,2227),(39726,2227),(39727,2227),(39728,2227),(39729,2227),(39730,2228),(39731,2228),(39732,2228),(39733,2228),(39734,2228),(39735,2228),(39736,2228),(39737,2229),(39738,2229),(39739,2229),(39740,2229),(39741,2229),(39742,2229),(39743,2229),(39744,2230),(39745,2230),(39746,2230),(39747,2230),(39748,2230),(39749,2230),(39750,2230),(39751,2230),(39752,2230),(39753,2231),(39754,2231),(39755,2231),(39756,2231),(39757,2231),(39758,2231),(39759,2231),(39760,2232),(39761,2232),(39762,2232),(39763,2232),(39764,2232),(39765,2232),(39766,2232),(39767,2233),(39768,2233),(39769,2233),(39770,2233),(39771,2233),(39772,2233),(39773,2233),(39774,2234),(39775,2234),(39776,2234),(39777,2234),(39778,2234),(39779,2234),(39780,2234),(39781,2235),(39782,2235),(39783,2235),(39784,2235),(39785,2236),(39786,2236),(39787,2236),(39788,2236),(39789,2236),(39790,2236),(39791,2236),(39792,2237),(39793,2237),(39794,2237),(39795,2237),(39796,2237),(39797,2237),(39798,2237),(39799,2238),(39800,2238),(39801,2238),(39802,2238),(39803,2238),(39804,2238),(39805,2238),(39806,2239),(39807,2239),(39808,2239),(39809,2239),(39810,2239),(39811,2239),(39812,2240),(39813,2240),(39814,2240),(39815,2240),(39816,2241),(39817,2241),(39818,2241),(39819,2241),(39820,2241),(39821,2241),(39822,2242),(39823,2242),(39824,2242),(39825,2242),(39826,2242),(39827,2242),(39828,2243),(39829,2243),(39830,2243),(39831,2243),(39832,2243),(39833,2243),(39834,2244),(39835,2244),(39836,2244),(39837,2244),(39838,2244),(39839,2244),(39840,2245),(39841,2245),(39842,2245),(39843,2245),(39844,2245),(39845,2245),(39846,2246),(39847,2246),(39848,2246),(39849,2246),(39850,2246),(39851,2246),(39852,2246),(39853,2246),(39854,2246),(39855,2247),(39856,2247),(39857,2247),(39858,2247),(39859,2247),(39860,2247),(39861,2247),(39862,2248),(39863,2248),(39864,2248),(39865,2248),(39866,2248),(39867,2248),(39868,2248),(39869,2248),(39870,2248),(39871,2249),(39872,2249),(39873,2249),(39874,2249),(39875,2249),(39876,2249),(39877,2249),(39878,2250),(39879,2250),(39880,2250),(39881,2250),(39882,2250),(39883,2250),(39884,2250),(39885,2251),(39886,2251),(39887,2251),(39888,2251),(39889,2251),(39890,2251),(39891,2251),(39892,2252),(39893,2252),(39894,2252),(39895,2252),(39896,2252),(39897,2252),(39898,2252),(39899,2252),(39900,2252),(39901,2253),(39902,2253),(39903,2253),(39904,2253),(39905,2253),(39906,2253),(39907,2253),(39908,2254),(39909,2254),(39910,2254),(39911,2254),(39912,2254),(39913,2254),(39914,2254),(39915,2255),(39916,2255),(39917,2255),(39918,2255),(39919,2255),(39920,2255),(39921,2255),(39922,2256),(39923,2256),(39924,2256),(39925,2256),(39926,2256),(39927,2256),(39928,2256),(39929,2257),(39930,2257),(39931,2257),(39932,2257),(39933,2258),(39934,2258),(39935,2258),(39936,2258),(39937,2259),(39938,2259),(39939,2259),(39940,2259),(39941,2259),(39942,2259),(39943,2259),(39944,2260),(39945,2260),(39946,2260),(39947,2260),(39948,2260),(39949,2260),(39950,2260),(39951,2261),(39952,2261),(39953,2261),(39954,2261),(39955,2261),(39956,2261),(39957,2261),(39958,2262),(39959,2262),(39960,2262),(39961,2262),(39962,2262),(39963,2262),(39964,2262),(39965,2262),(39966,2263),(39967,2263),(39968,2263),(39969,2263),(39970,2263),(39971,2263),(39972,2263),(39973,2264),(39974,2264),(39975,2264),(39976,2264),(39977,2264),(39978,2264),(39979,2264),(39980,2265),(39981,2265),(39982,2265),(39983,2265),(39984,2265),(39985,2265),(39986,2265),(39987,2266),(39988,2266),(39989,2266),(39990,2266),(39991,2266),(39992,2266),(39993,2266),(39994,2267),(39995,2267),(39996,2267),(39997,2267),(39998,2267),(39999,2267),(40000,2267),(40001,2268),(40002,2268),(40003,2268),(40004,2268),(40005,2268),(40006,2268),(40007,2268),(40008,2269),(40009,2269),(40010,2269),(40011,2269),(40012,2269),(40013,2269),(40014,2269),(40015,2270),(40016,2270),(40017,2270),(40018,2270),(40019,2270),(40020,2270),(40021,2270),(40022,2270),(40023,2270),(40024,2271),(40025,2271),(40026,2271),(40027,2271),(40028,2271),(40029,2271),(40030,2271),(40031,2271),(40032,2271),(40033,2272),(40034,2272),(40035,2272),(40036,2272),(40037,2272),(40038,2272),(40039,2272),(40040,2273),(40041,2273),(40042,2273),(40043,2273),(40044,2273),(40045,2273),(40046,2273),(40047,2274),(40048,2274),(40049,2274),(40050,2274),(40051,2274),(40052,2274),(40053,2274),(40054,2275),(40055,2275),(40056,2275),(40057,2275),(40058,2275),(40059,2275),(40060,2276),(40061,2276),(40062,2276),(40063,2276),(40064,2276),(40065,2276),(40066,2276),(40067,2277),(40068,2277),(40069,2277),(40070,2277),(40071,2277),(40072,2277),(40073,2277),(40074,2277),(40075,2277),(40076,2278),(40077,2278),(40078,2278),(40079,2278),(40080,2278),(40081,2278),(40082,2278),(40083,2279),(40084,2279),(40085,2279),(40086,2279),(40087,2279),(40088,2279),(40089,2279),(40090,2280),(40091,2280),(40092,2280),(40093,2280),(40094,2280),(40095,2280),(40096,2280),(40097,2281),(40098,2281),(40099,2281),(40100,2281),(40101,2281),(40102,2281),(40103,2281),(40104,2282),(40105,2282),(40106,2282),(40107,2282),(40108,2282),(40109,2282),(40110,2282),(40111,2283),(40112,2283),(40113,2283),(40114,2283),(40115,2283),(40116,2283),(40117,2283),(40118,2284),(40119,2284),(40120,2284),(40121,2284),(40122,2284),(40123,2284),(40124,2284),(40125,2285),(40126,2285),(40127,2285),(40128,2285),(40129,2285),(40130,2285),(40131,2285),(40132,2286),(40133,2286),(40134,2286),(40135,2286),(40136,2286),(40137,2286),(40138,2286),(40139,2286),(40140,2286),(40141,2287),(40142,2287),(40143,2287),(40144,2287),(40145,2287),(40146,2287),(40147,2287),(40148,2288),(40149,2288),(40150,2288),(40151,2288),(40152,2288),(40153,2288),(40154,2288),(40155,2289),(40156,2289),(40157,2289),(40158,2289),(40159,2289),(40160,2289),(40161,2290),(40162,2290),(40163,2290),(40164,2290),(40165,2290),(40166,2290),(40167,2291),(40168,2291),(40169,2291),(40170,2291),(40171,2291),(40172,2291),(40173,2292),(40174,2292),(40175,2292),(40176,2292),(40177,2292),(40178,2292),(40179,2292),(40180,2293),(40181,2293),(40182,2293),(40183,2293),(40184,2293),(40185,2293),(40186,2294),(40187,2294),(40188,2294),(40189,2294),(40190,2294),(40191,2294),(40192,2294),(40193,2295),(40194,2295),(40195,2295),(40196,2295),(40197,2295),(40198,2295),(40199,2295),(40200,2296),(40201,2296),(40202,2296),(40203,2296),(40204,2296),(40205,2296),(40206,2296),(40207,2297),(40208,2297),(40209,2297),(40210,2297),(40211,2297),(40212,2297),(40213,2297),(40214,2297),(40215,2297),(40216,2298),(40217,2298),(40218,2298),(40219,2298),(40220,2298),(40221,2298),(40222,2298),(40223,2298),(40224,2298),(40225,2299),(40226,2299),(40227,2299),(40228,2299),(40229,2299),(40230,2299),(40231,2299),(40232,2300),(40233,2300),(40234,2300),(40235,2300),(40236,2300),(40237,2300),(40238,2300),(40239,2300),(40240,2301),(40241,2301),(40242,2301),(40243,2301),(40244,2301),(40245,2301),(40246,2301),(40247,2301),(40248,2302),(40249,2302),(40250,2302),(40251,2302),(40252,2303),(40253,2303),(40254,2303),(40255,2303),(40256,2304),(40257,2304),(40258,2304),(40259,2304),(40260,2304),(40261,2304),(40262,2304),(40263,2305),(40264,2305),(40265,2305),(40266,2305),(40267,2305),(40268,2305),(40269,2305),(40270,2306),(40271,2306),(40272,2306),(40273,2306),(40274,2306),(40275,2306),(40276,2306),(40277,2307),(40278,2307),(40279,2307),(40280,2307),(40281,2307),(40282,2307),(40283,2307),(40284,2308),(40285,2308),(40286,2308),(40287,2308),(40288,2308),(40289,2308),(40290,2308),(40291,2309),(40292,2309),(40293,2309),(40294,2309),(40295,2309),(40296,2309),(40297,2309),(40298,2310),(40299,2310),(40300,2310),(40301,2310),(40302,2310),(40303,2310),(40304,2310),(40305,2213),(40306,2213),(40307,2213),(40308,2214),(40309,2214),(40310,2214),(40311,2215),(40312,2215),(40313,2215),(40314,2216),(40315,2216),(40316,2216),(40317,2217),(40318,2217),(40319,2217),(40320,2218),(40321,2218),(40322,2218),(40323,2219),(40324,2219),(40325,2219),(40326,2220),(40327,2220),(40328,2220),(40329,2221),(40330,2221),(40331,2222),(40332,2222),(40333,2223),(40334,2223),(40335,2223),(40336,2224),(40337,2224),(40338,2224),(40339,2225),(40340,2225),(40341,2225),(40342,2226),(40343,2226),(40344,2227),(40345,2227),(40346,2227),(40347,2228),(40348,2228),(40349,2228),(40350,2229),(40351,2229),(40352,2229),(40353,2230),(40354,2230),(40355,2231),(40356,2231),(40357,2231),(40358,2232),(40359,2232),(40360,2232),(40361,2233),(40362,2233),(40363,2233),(40364,2234),(40365,2234),(40366,2234),(40367,2235),(40368,2236),(40369,2236),(40370,2236),(40371,2237),(40372,2237),(40373,2237),(40374,2238),(40375,2238),(40376,2238),(40377,2239),(40378,2239),(40379,2239),(40380,2240),(40381,2241),(40382,2241),(40383,2242),(40384,2242),(40385,2243),(40386,2243),(40387,2244),(40388,2244),(40389,2245),(40390,2245),(40391,2245),(40392,2246),(40393,2246),(40394,2247),(40395,2247),(40396,2247),(40397,2248),(40398,2248),(40399,2249),(40400,2249),(40401,2249),(40402,2250),(40403,2250),(40404,2250),(40405,2251),(40406,2251),(40407,2251),(40408,2252),(40409,2252),(40410,2252),(40411,2253),(40412,2253),(40413,2253),(40414,2254),(40415,2254),(40416,2254),(40417,2255),(40418,2255),(40419,2255),(40420,2256),(40421,2256),(40422,2256),(40423,2257),(40424,2258),(40425,2258),(40426,2259),(40427,2259),(40428,2259),(40429,2260),(40430,2260),(40431,2260),(40432,2261),(40433,2261),(40434,2261),(40435,2262),(40436,2262),(40437,2263),(40438,2263),(40439,2263),(40440,2264),(40441,2264),(40442,2264),(40443,2265),(40444,2265),(40445,2266),(40446,2266),(40447,2267),(40448,2267),(40449,2268),(40450,2268),(40451,2269),(40452,2269),(40453,2270),(40454,2270),(40455,2271),(40456,2271),(40457,2272),(40458,2272),(40459,2272),(40460,2273),(40461,2273),(40462,2273),(40463,2274),(40464,2274),(40465,2274),(40466,2275),(40467,2275),(40468,2275),(40469,2276),(40470,2276),(40471,2277),(40472,2277),(40473,2277),(40474,2278),(40475,2278),(40476,2278),(40477,2279),(40478,2279),(40479,2279),(40480,2280),(40481,2280),(40482,2280),(40483,2281),(40484,2281),(40485,2281),(40486,2282),(40487,2282),(40488,2282),(40489,2283),(40490,2283),(40491,2283),(40492,2284),(40493,2284),(40494,2284),(40495,2285),(40496,2285),(40497,2285),(40498,2286),(40499,2286),(40500,2286),(40501,2287),(40502,2287),(40503,2287),(40504,2288),(40505,2288),(40506,2288),(40507,2289),(40508,2289),(40509,2289),(40510,2290),(40511,2290),(40512,2290),(40513,2291),(40514,2291),(40515,2291),(40516,2292),(40517,2292),(40518,2292),(40519,2293),(40520,2293),(40521,2293),(40522,2294),(40523,2294),(40524,2294),(40525,2295),(40526,2295),(40527,2295),(40528,2296),(40529,2296),(40530,2296),(40531,2297),(40532,2297),(40533,2297),(40534,2298),(40535,2298),(40536,2298),(40537,2299),(40538,2299),(40539,2300),(40540,2300),(40541,2301),(40542,2301),(40543,2302),(40544,2303),(40545,2304),(40546,2304),(40547,2304),(40548,2305),(40549,2305),(40550,2305),(40551,2306),(40552,2306),(40553,2306),(40554,2307),(40555,2307),(40556,2307),(40557,2308),(40558,2308),(40559,2308),(40560,2309),(40561,2309),(40562,2309),(40563,2310),(40564,2310),(40565,2310),(40566,2213),(40567,2213),(40568,2213),(40569,2214),(40570,2214),(40571,2214),(40572,2215),(40573,2215),(40574,2215),(40575,2216),(40576,2216),(40577,2216),(40578,2217),(40579,2217),(40580,2217),(40581,2218),(40582,2218),(40583,2218),(40584,2219),(40585,2219),(40586,2219),(40587,2220),(40588,2220),(40589,2220),(40590,2221),(40591,2221),(40592,2221),(40593,2222),(40594,2222),(40595,2222),(40596,2223),(40597,2223),(40598,2223),(40599,2224),(40600,2224),(40601,2224),(40602,2225),(40603,2225),(40604,2225),(40605,2226),(40606,2226),(40607,2226),(40608,2227),(40609,2227),(40610,2227),(40611,2228),(40612,2228),(40613,2228),(40614,2229),(40615,2229),(40616,2229),(40617,2230),(40618,2230),(40619,2230),(40620,2231),(40621,2231),(40622,2231),(40623,2232),(40624,2232),(40625,2232),(40626,2233),(40627,2233),(40628,2233),(40629,2234),(40630,2234),(40631,2234),(40632,2235),(40633,2235),(40634,2235),(40635,2236),(40636,2236),(40637,2236),(40638,2237),(40639,2237),(40640,2237),(40641,2238),(40642,2238),(40643,2238),(40644,2239),(40645,2239),(40646,2239),(40647,2239),(40648,2240),(40649,2240),(40650,2240),(40651,2241),(40652,2242),(40653,2243),(40654,2244),(40655,2245),(40656,2245),(40657,2245),(40658,2245),(40659,2246),(40660,2246),(40661,2246),(40662,2247),(40663,2247),(40664,2247),(40665,2248),(40666,2248),(40667,2248),(40668,2249),(40669,2249),(40670,2249),(40671,2250),(40672,2250),(40673,2250),(40674,2251),(40675,2251),(40676,2251),(40677,2252),(40678,2252),(40679,2252),(40680,2253),(40681,2253),(40682,2253),(40683,2254),(40684,2254),(40685,2254),(40686,2255),(40687,2255),(40688,2255),(40689,2256),(40690,2256),(40691,2256),(40692,2257),(40693,2257),(40694,2257),(40695,2258),(40696,2258),(40697,2258),(40698,2259),(40699,2259),(40700,2259),(40701,2260),(40702,2260),(40703,2260),(40704,2261),(40705,2261),(40706,2261),(40707,2262),(40708,2262),(40709,2262),(40710,2263),(40711,2263),(40712,2263),(40713,2264),(40714,2264),(40715,2264),(40716,2265),(40717,2265),(40718,2265),(40719,2266),(40720,2266),(40721,2266),(40722,2267),(40723,2267),(40724,2267),(40725,2268),(40726,2268),(40727,2268),(40728,2269),(40729,2269),(40730,2269),(40731,2270),(40732,2270),(40733,2270),(40734,2271),(40735,2271),(40736,2271),(40737,2272),(40738,2272),(40739,2272),(40740,2273),(40741,2273),(40742,2273),(40743,2274),(40744,2274),(40745,2274),(40746,2275),(40747,2275),(40748,2275),(40749,2276),(40750,2276),(40751,2276),(40752,2277),(40753,2277),(40754,2277),(40755,2278),(40756,2278),(40757,2278),(40758,2279),(40759,2279),(40760,2279),(40761,2280),(40762,2280),(40763,2280),(40764,2281),(40765,2281),(40766,2281),(40767,2282),(40768,2282),(40769,2282),(40770,2283),(40771,2283),(40772,2283),(40773,2284),(40774,2284),(40775,2284),(40776,2285),(40777,2285),(40778,2285),(40779,2286),(40780,2286),(40781,2286),(40782,2287),(40783,2287),(40784,2287),(40785,2288),(40786,2288),(40787,2288),(40788,2289),(40789,2289),(40790,2289),(40791,2290),(40792,2290),(40793,2290),(40794,2291),(40795,2291),(40796,2291),(40797,2292),(40798,2292),(40799,2292),(40800,2293),(40801,2293),(40802,2293),(40803,2294),(40804,2294),(40805,2294),(40806,2295),(40807,2295),(40808,2295),(40809,2296),(40810,2296),(40811,2296),(40812,2297),(40813,2297),(40814,2297),(40815,2298),(40816,2298),(40817,2298),(40818,2299),(40819,2299),(40820,2299),(40821,2300),(40822,2300),(40823,2300),(40824,2301),(40825,2301),(40826,2301),(40827,2302),(40828,2302),(40829,2302),(40830,2303),(40831,2303),(40832,2303),(40833,2304),(40834,2304),(40835,2304),(40836,2305),(40837,2305),(40838,2305),(40839,2306),(40840,2306),(40841,2306),(40842,2307),(40843,2307),(40844,2307),(40845,2308),(40846,2308),(40847,2308),(40848,2309),(40849,2309),(40850,2309),(40851,2310),(40852,2310),(40853,2310),(40854,2213),(40855,2213),(40856,2213),(40857,2213),(40858,2214),(40859,2214),(40860,2214),(40861,2214),(40862,2215),(40863,2215),(40864,2215),(40865,2215),(40866,2216),(40867,2216),(40868,2216),(40869,2216),(40870,2217),(40871,2217),(40872,2217),(40873,2217),(40874,2218),(40875,2218),(40876,2218),(40877,2218),(40878,2219),(40879,2219),(40880,2219),(40881,2219),(40882,2220),(40883,2220),(40884,2220),(40885,2220),(40886,2221),(40887,2221),(40888,2221),(40889,2221),(40890,2222),(40891,2222),(40892,2222),(40893,2222),(40894,2223),(40895,2223),(40896,2223),(40897,2223),(40898,2224),(40899,2224),(40900,2224),(40901,2224),(40902,2225),(40903,2225),(40904,2225),(40905,2225),(40906,2226),(40907,2226),(40908,2226),(40909,2226),(40910,2227),(40911,2227),(40912,2227),(40913,2227),(40914,2228),(40915,2228),(40916,2228),(40917,2228),(40918,2229),(40919,2229),(40920,2229),(40921,2229),(40922,2230),(40923,2230),(40924,2230),(40925,2230),(40926,2231),(40927,2231),(40928,2231),(40929,2231),(40930,2232),(40931,2232),(40932,2232),(40933,2232),(40934,2233),(40935,2233),(40936,2233),(40937,2233),(40938,2234),(40939,2234),(40940,2234),(40941,2234),(40942,2235),(40943,2235),(40944,2235),(40945,2235),(40946,2236),(40947,2236),(40948,2236),(40949,2236),(40950,2237),(40951,2237),(40952,2237),(40953,2237),(40954,2238),(40955,2238),(40956,2238),(40957,2238),(40958,2239),(40959,2239),(40960,2239),(40961,2239),(40962,2240),(40963,2240),(40964,2240),(40965,2240),(40966,2241),(40967,2241),(40968,2241),(40969,2241),(40970,2242),(40971,2242),(40972,2242),(40973,2242),(40974,2243),(40975,2243),(40976,2243),(40977,2243),(40978,2244),(40979,2244),(40980,2244),(40981,2244),(40982,2245),(40983,2245),(40984,2245),(40985,2245),(40986,2246),(40987,2246),(40988,2246),(40989,2246),(40990,2247),(40991,2247),(40992,2247),(40993,2247),(40994,2248),(40995,2248),(40996,2248),(40997,2248),(40998,2249),(40999,2249),(41000,2249),(41001,2249),(41002,2250),(41003,2250),(41004,2250),(41005,2250),(41006,2251),(41007,2251),(41008,2251),(41009,2251),(41010,2252),(41011,2252),(41012,2252),(41013,2252),(41014,2253),(41015,2253),(41016,2253),(41017,2253),(41018,2254),(41019,2254),(41020,2254),(41021,2254),(41022,2255),(41023,2255),(41024,2255),(41025,2255),(41026,2256),(41027,2256),(41028,2256),(41029,2256),(41030,2257),(41031,2257),(41032,2257),(41033,2257),(41034,2258),(41035,2258),(41036,2258),(41037,2258),(41038,2259),(41039,2259),(41040,2259),(41041,2259),(41042,2260),(41043,2260),(41044,2260),(41045,2260),(41046,2261),(41047,2261),(41048,2261),(41049,2261),(41050,2262),(41051,2262),(41052,2262),(41053,2262),(41054,2263),(41055,2263),(41056,2263),(41057,2263),(41058,2264),(41059,2264),(41060,2264),(41061,2264),(41062,2265),(41063,2265),(41064,2265),(41065,2265),(41066,2266),(41067,2266),(41068,2266),(41069,2266),(41070,2267),(41071,2267),(41072,2267),(41073,2267),(41074,2268),(41075,2268),(41076,2268),(41077,2268),(41078,2269),(41079,2269),(41080,2269),(41081,2269),(41082,2270),(41083,2270),(41084,2270),(41085,2270),(41086,2271),(41087,2271),(41088,2271),(41089,2271),(41090,2272),(41091,2272),(41092,2272),(41093,2272),(41094,2273),(41095,2273),(41096,2273),(41097,2273),(41098,2274),(41099,2274),(41100,2274),(41101,2274),(41102,2275),(41103,2275),(41104,2275),(41105,2275),(41106,2276),(41107,2276),(41108,2276),(41109,2276),(41110,2277),(41111,2277),(41112,2277),(41113,2277),(41114,2278),(41115,2278),(41116,2278),(41117,2278),(41118,2279),(41119,2279),(41120,2279),(41121,2279),(41122,2280),(41123,2280),(41124,2280),(41125,2280),(41126,2281),(41127,2281),(41128,2281),(41129,2281),(41130,2282),(41131,2282),(41132,2282),(41133,2282),(41134,2283),(41135,2283),(41136,2283),(41137,2283),(41138,2284),(41139,2284),(41140,2284),(41141,2284),(41142,2285),(41143,2285),(41144,2285),(41145,2285),(41146,2286),(41147,2286),(41148,2286),(41149,2286),(41150,2287),(41151,2287),(41152,2287),(41153,2287),(41154,2288),(41155,2288),(41156,2288),(41157,2288),(41158,2289),(41159,2289),(41160,2289),(41161,2289),(41162,2290),(41163,2290),(41164,2290),(41165,2290),(41166,2291),(41167,2291),(41168,2291),(41169,2291),(41170,2292),(41171,2292),(41172,2292),(41173,2292),(41174,2293),(41175,2293),(41176,2293),(41177,2293),(41178,2294),(41179,2294),(41180,2294),(41181,2294),(41182,2295),(41183,2295),(41184,2295),(41185,2295),(41186,2296),(41187,2296),(41188,2296),(41189,2296),(41190,2297),(41191,2297),(41192,2297),(41193,2297),(41194,2298),(41195,2298),(41196,2298),(41197,2298),(41198,2299),(41199,2299),(41200,2299),(41201,2299),(41202,2300),(41203,2300),(41204,2300),(41205,2300),(41206,2301),(41207,2301),(41208,2301),(41209,2301),(41210,2302),(41211,2302),(41212,2302),(41213,2302),(41214,2303),(41215,2303),(41216,2303),(41217,2303),(41218,2304),(41219,2304),(41220,2304),(41221,2304),(41222,2305),(41223,2305),(41224,2305),(41225,2305),(41226,2306),(41227,2306),(41228,2306),(41229,2306),(41230,2307),(41231,2307),(41232,2307),(41233,2307),(41234,2308),(41235,2308),(41236,2308),(41237,2308),(41238,2309),(41239,2309),(41240,2309),(41241,2309),(41242,2310),(41243,2310),(41244,2310),(41245,2310),(41246,2311),(41247,2312),(41248,2313),(41249,2314),(41250,2315),(41251,2316),(41252,2317),(41253,2318),(41254,2319),(41255,2320),(41256,2321),(41257,2311),(41258,2311),(41259,2311),(41260,2311),(41261,2312),(41262,2312),(41263,2312),(41264,2312),(41265,2312),(41266,2312),(41267,2312),(41268,2313),(41269,2313),(41270,2313),(41271,2313),(41272,2313),(41273,2313),(41274,2313),(41275,2314),(41276,2314),(41277,2314),(41278,2314),(41279,2314),(41280,2314),(41281,2314),(41282,2315),(41283,2315),(41284,2315),(41285,2315),(41286,2316),(41287,2316),(41288,2316),(41289,2316),(41290,2316),(41291,2316),(41292,2316),(41293,2317),(41294,2317),(41295,2317),(41296,2317),(41297,2317),(41298,2317),(41299,2317),(41300,2318),(41301,2318),(41302,2318),(41303,2318),(41304,2318),(41305,2318),(41306,2318),(41307,2319),(41308,2319),(41309,2319),(41310,2319),(41311,2319),(41312,2319),(41313,2319),(41314,2320),(41315,2320),(41316,2320),(41317,2320),(41318,2320),(41319,2320),(41320,2320),(41321,2321),(41322,2321),(41323,2321),(41324,2321),(41325,2321),(41326,2321),(41327,2321),(41328,2311),(41329,2312),(41330,2312),(41331,2312),(41332,2313),(41333,2313),(41334,2313),(41335,2314),(41336,2314),(41337,2314),(41338,2315),(41339,2315),(41340,2316),(41341,2316),(41342,2316),(41343,2317),(41344,2317),(41345,2318),(41346,2318),(41347,2319),(41348,2319),(41349,2320),(41350,2320),(41351,2321),(41352,2321),(41353,2311),(41354,2311),(41355,2311),(41356,2312),(41357,2312),(41358,2312),(41359,2313),(41360,2313),(41361,2313),(41362,2314),(41363,2314),(41364,2314),(41365,2315),(41366,2315),(41367,2315),(41368,2316),(41369,2316),(41370,2316),(41371,2317),(41372,2317),(41373,2317),(41374,2318),(41375,2318),(41376,2318),(41377,2319),(41378,2319),(41379,2319),(41380,2320),(41381,2320),(41382,2320),(41383,2321),(41384,2321),(41385,2321),(41386,2311),(41387,2311),(41388,2311),(41389,2311),(41390,2312),(41391,2312),(41392,2312),(41393,2312),(41394,2313),(41395,2313),(41396,2313),(41397,2313),(41398,2314),(41399,2314),(41400,2314),(41401,2314),(41402,2315),(41403,2315),(41404,2315),(41405,2315),(41406,2316),(41407,2316),(41408,2316),(41409,2316),(41410,2317),(41411,2317),(41412,2317),(41413,2317),(41414,2318),(41415,2318),(41416,2318),(41417,2318),(41418,2319),(41419,2319),(41420,2319),(41421,2319),(41422,2320),(41423,2320),(41424,2320),(41425,2320),(41426,2321),(41427,2321),(41428,2321),(41429,2321),(41430,2322),(41431,2323),(41432,2324),(41433,2325),(41434,2326),(41435,2327),(41436,2328),(41437,2329),(41438,2330),(41439,2331),(41440,2332),(41441,2333),(41442,2334),(41443,2335),(41444,2336),(41445,2337),(41446,2338),(41447,2339),(41448,2340),(41449,2341),(41450,2342),(41451,2343),(41452,2344),(41453,2345),(41454,2346),(41455,2347),(41456,2348),(41457,2349),(41458,2350),(41459,2351),(41460,2352),(41461,2353),(41462,2354),(41463,2355),(41464,2356),(41465,2357),(41466,2358),(41467,2359),(41468,2360),(41469,2361),(41470,2362),(41471,2363),(41472,2364),(41473,2365),(41474,2366),(41475,2367),(41476,2368),(41477,2369),(41478,2370),(41479,2371),(41480,2372),(41481,2373),(41482,2374),(41483,2375),(41484,2376),(41485,2377),(41486,2378),(41487,2379),(41488,2380),(41489,2381),(41490,2382),(41491,2383),(41492,2384),(41493,2385),(41494,2386),(41495,2387),(41496,2388),(41497,2389),(41498,2390),(41499,2391),(41500,2392),(41501,2393),(41502,2394),(41503,2395),(41504,2396),(41505,2397),(41506,2398),(41507,2399),(41508,2400),(41509,2401),(41510,2402),(41511,2403),(41512,2404),(41513,2405),(41514,2406),(41515,2407),(41516,2408),(41517,2409),(41518,2410),(41519,2322),(41520,2322),(41521,2322),(41522,2322),(41523,2322),(41524,2322),(41525,2322),(41526,2323),(41527,2323),(41528,2323),(41529,2323),(41530,2323),(41531,2323),(41532,2323),(41533,2324),(41534,2324),(41535,2324),(41536,2324),(41537,2324),(41538,2324),(41539,2324),(41540,2325),(41541,2325),(41542,2325),(41543,2325),(41544,2325),(41545,2325),(41546,2325),(41547,2326),(41548,2326),(41549,2326),(41550,2326),(41551,2326),(41552,2326),(41553,2326),(41554,2327),(41555,2327),(41556,2327),(41557,2327),(41558,2327),(41559,2327),(41560,2327),(41561,2328),(41562,2328),(41563,2328),(41564,2328),(41565,2328),(41566,2328),(41567,2328),(41568,2329),(41569,2329),(41570,2329),(41571,2329),(41572,2329),(41573,2329),(41574,2329),(41575,2330),(41576,2330),(41577,2330),(41578,2330),(41579,2330),(41580,2330),(41581,2330),(41582,2331),(41583,2331),(41584,2331),(41585,2331),(41586,2331),(41587,2331),(41588,2331),(41589,2332),(41590,2332),(41591,2332),(41592,2332),(41593,2332),(41594,2332),(41595,2332),(41596,2333),(41597,2333),(41598,2333),(41599,2333),(41600,2333),(41601,2333),(41602,2333),(41603,2334),(41604,2334),(41605,2334),(41606,2334),(41607,2334),(41608,2334),(41609,2334),(41610,2335),(41611,2335),(41612,2335),(41613,2335),(41614,2335),(41615,2335),(41616,2335),(41617,2336),(41618,2336),(41619,2336),(41620,2336),(41621,2336),(41622,2336),(41623,2336),(41624,2337),(41625,2337),(41626,2337),(41627,2337),(41628,2337),(41629,2337),(41630,2337),(41631,2338),(41632,2338),(41633,2338),(41634,2338),(41635,2338),(41636,2338),(41637,2338),(41638,2339),(41639,2339),(41640,2339),(41641,2339),(41642,2339),(41643,2339),(41644,2339),(41645,2340),(41646,2340),(41647,2340),(41648,2340),(41649,2340),(41650,2340),(41651,2340),(41652,2341),(41653,2341),(41654,2341),(41655,2341),(41656,2341),(41657,2341),(41658,2341),(41659,2342),(41660,2342),(41661,2342),(41662,2342),(41663,2342),(41664,2342),(41665,2342),(41666,2343),(41667,2343),(41668,2343),(41669,2343),(41670,2343),(41671,2343),(41672,2343),(41673,2344),(41674,2344),(41675,2344),(41676,2344),(41677,2344),(41678,2344),(41679,2344),(41680,2345),(41681,2345),(41682,2345),(41683,2345),(41684,2345),(41685,2345),(41686,2345),(41687,2346),(41688,2346),(41689,2346),(41690,2346),(41691,2346),(41692,2346),(41693,2346),(41694,2347),(41695,2347),(41696,2347),(41697,2347),(41698,2347),(41699,2347),(41700,2347),(41701,2348),(41702,2348),(41703,2348),(41704,2348),(41705,2348),(41706,2348),(41707,2348),(41708,2349),(41709,2349),(41710,2349),(41711,2349),(41712,2349),(41713,2349),(41714,2349),(41715,2350),(41716,2350),(41717,2350),(41718,2350),(41719,2350),(41720,2350),(41721,2350),(41722,2351),(41723,2351),(41724,2351),(41725,2351),(41726,2351),(41727,2351),(41728,2351),(41729,2352),(41730,2352),(41731,2352),(41732,2352),(41733,2352),(41734,2352),(41735,2352),(41736,2353),(41737,2353),(41738,2353),(41739,2353),(41740,2353),(41741,2353),(41742,2353),(41743,2354),(41744,2354),(41745,2354),(41746,2354),(41747,2354),(41748,2354),(41749,2354),(41750,2355),(41751,2355),(41752,2355),(41753,2355),(41754,2355),(41755,2355),(41756,2355),(41757,2356),(41758,2356),(41759,2356),(41760,2356),(41761,2356),(41762,2356),(41763,2356),(41764,2357),(41765,2357),(41766,2357),(41767,2357),(41768,2357),(41769,2357),(41770,2357),(41771,2358),(41772,2358),(41773,2358),(41774,2358),(41775,2358),(41776,2358),(41777,2358),(41778,2359),(41779,2359),(41780,2359),(41781,2359),(41782,2359),(41783,2359),(41784,2359),(41785,2360),(41786,2360),(41787,2360),(41788,2360),(41789,2360),(41790,2360),(41791,2360),(41792,2361),(41793,2361),(41794,2361),(41795,2361),(41796,2361),(41797,2361),(41798,2361),(41799,2362),(41800,2362),(41801,2362),(41802,2362),(41803,2362),(41804,2362),(41805,2362),(41806,2363),(41807,2363),(41808,2363),(41809,2363),(41810,2363),(41811,2363),(41812,2363),(41813,2364),(41814,2364),(41815,2364),(41816,2364),(41817,2364),(41818,2364),(41819,2364),(41820,2365),(41821,2365),(41822,2365),(41823,2365),(41824,2365),(41825,2365),(41826,2365),(41827,2366),(41828,2366),(41829,2366),(41830,2366),(41831,2366),(41832,2366),(41833,2366),(41834,2367),(41835,2367),(41836,2367),(41837,2367),(41838,2367),(41839,2367),(41840,2367),(41841,2368),(41842,2368),(41843,2368),(41844,2368),(41845,2368),(41846,2368),(41847,2368),(41848,2369),(41849,2369),(41850,2369),(41851,2369),(41852,2369),(41853,2369),(41854,2369),(41855,2370),(41856,2370),(41857,2370),(41858,2370),(41859,2370),(41860,2370),(41861,2370),(41862,2371),(41863,2371),(41864,2371),(41865,2371),(41866,2371),(41867,2371),(41868,2371),(41869,2372),(41870,2372),(41871,2372),(41872,2372),(41873,2372),(41874,2372),(41875,2372),(41876,2373),(41877,2373),(41878,2373),(41879,2373),(41880,2373),(41881,2373),(41882,2373),(41883,2374),(41884,2374),(41885,2374),(41886,2374),(41887,2374),(41888,2374),(41889,2374),(41890,2375),(41891,2375),(41892,2375),(41893,2375),(41894,2375),(41895,2375),(41896,2376),(41897,2376),(41898,2376),(41899,2376),(41900,2376),(41901,2376),(41902,2377),(41903,2377),(41904,2377),(41905,2377),(41906,2377),(41907,2377),(41908,2377),(41909,2377),(41910,2377),(41911,2378),(41912,2378),(41913,2378),(41914,2378),(41915,2378),(41916,2378),(41917,2378),(41918,2378),(41919,2378),(41920,2379),(41921,2379),(41922,2379),(41923,2379),(41924,2379),(41925,2379),(41926,2380),(41927,2380),(41928,2380),(41929,2380),(41930,2380),(41931,2380),(41932,2381),(41933,2381),(41934,2381),(41935,2381),(41936,2381),(41937,2381),(41938,2382),(41939,2382),(41940,2382),(41941,2382),(41942,2382),(41943,2382),(41944,2382),(41945,2382),(41946,2382),(41947,2383),(41948,2383),(41949,2383),(41950,2383),(41951,2383),(41952,2383),(41953,2384),(41954,2384),(41955,2384),(41956,2384),(41957,2384),(41958,2384),(41959,2385),(41960,2385),(41961,2385),(41962,2385),(41963,2385),(41964,2385),(41965,2385),(41966,2385),(41967,2385),(41968,2386),(41969,2386),(41970,2386),(41971,2386),(41972,2386),(41973,2386),(41974,2386),(41975,2386),(41976,2386),(41977,2387),(41978,2387),(41979,2387),(41980,2387),(41981,2387),(41982,2387),(41983,2388),(41984,2388),(41985,2388),(41986,2388),(41987,2388),(41988,2388),(41989,2388),(41990,2388),(41991,2388),(41992,2389),(41993,2389),(41994,2389),(41995,2389),(41996,2389),(41997,2389),(41998,2389),(41999,2389),(42000,2389),(42001,2390),(42002,2390),(42003,2390),(42004,2390),(42005,2390),(42006,2390),(42007,2391),(42008,2391),(42009,2391),(42010,2391),(42011,2391),(42012,2391),(42013,2391),(42014,2391),(42015,2391),(42016,2392),(42017,2392),(42018,2392),(42019,2392),(42020,2392),(42021,2392),(42022,2392),(42023,2393),(42024,2393),(42025,2393),(42026,2393),(42027,2393),(42028,2393),(42029,2393),(42030,2394),(42031,2394),(42032,2394),(42033,2394),(42034,2394),(42035,2394),(42036,2394),(42037,2395),(42038,2395),(42039,2395),(42040,2395),(42041,2395),(42042,2395),(42043,2395),(42044,2396),(42045,2396),(42046,2396),(42047,2396),(42048,2396),(42049,2396),(42050,2396),(42051,2397),(42052,2397),(42053,2397),(42054,2397),(42055,2397),(42056,2397),(42057,2397),(42058,2398),(42059,2398),(42060,2398),(42061,2398),(42062,2398),(42063,2398),(42064,2398),(42065,2399),(42066,2399),(42067,2399),(42068,2399),(42069,2399),(42070,2399),(42071,2399),(42072,2400),(42073,2400),(42074,2400),(42075,2400),(42076,2400),(42077,2400),(42078,2400),(42079,2401),(42080,2401),(42081,2401),(42082,2401),(42083,2401),(42084,2401),(42085,2401),(42086,2402),(42087,2402),(42088,2402),(42089,2402),(42090,2402),(42091,2402),(42092,2402),(42093,2403),(42094,2403),(42095,2403),(42096,2403),(42097,2403),(42098,2403),(42099,2403),(42100,2404),(42101,2404),(42102,2404),(42103,2404),(42104,2404),(42105,2404),(42106,2404),(42107,2405),(42108,2405),(42109,2405),(42110,2405),(42111,2405),(42112,2405),(42113,2405),(42114,2406),(42115,2406),(42116,2406),(42117,2406),(42118,2406),(42119,2406),(42120,2406),(42121,2407),(42122,2407),(42123,2407),(42124,2407),(42125,2407),(42126,2407),(42127,2407),(42128,2408),(42129,2408),(42130,2408),(42131,2408),(42132,2408),(42133,2408),(42134,2408),(42135,2409),(42136,2409),(42137,2409),(42138,2409),(42139,2409),(42140,2409),(42141,2409),(42142,2410),(42143,2410),(42144,2410),(42145,2410),(42146,2410),(42147,2410),(42148,2410),(42149,2322),(42150,2322),(42151,2323),(42152,2323),(42153,2323),(42154,2324),(42155,2324),(42156,2324),(42157,2325),(42158,2325),(42159,2325),(42160,2326),(42161,2326),(42162,2326),(42163,2327),(42164,2327),(42165,2327),(42166,2328),(42167,2328),(42168,2328),(42169,2329),(42170,2329),(42171,2329),(42172,2330),(42173,2330),(42174,2330),(42175,2331),(42176,2331),(42177,2331),(42178,2332),(42179,2332),(42180,2332),(42181,2333),(42182,2333),(42183,2333),(42184,2334),(42185,2334),(42186,2334),(42187,2335),(42188,2335),(42189,2335),(42190,2336),(42191,2336),(42192,2336),(42193,2337),(42194,2337),(42195,2337),(42196,2338),(42197,2338),(42198,2338),(42199,2339),(42200,2339),(42201,2339),(42202,2340),(42203,2340),(42204,2340),(42205,2341),(42206,2341),(42207,2341),(42208,2342),(42209,2342),(42210,2342),(42211,2343),(42212,2343),(42213,2343),(42214,2344),(42215,2344),(42216,2344),(42217,2345),(42218,2345),(42219,2345),(42220,2346),(42221,2346),(42222,2346),(42223,2347),(42224,2347),(42225,2347),(42226,2348),(42227,2348),(42228,2348),(42229,2349),(42230,2349),(42231,2349),(42232,2350),(42233,2350),(42234,2350),(42235,2351),(42236,2351),(42237,2351),(42238,2352),(42239,2352),(42240,2352),(42241,2353),(42242,2353),(42243,2353),(42244,2354),(42245,2354),(42246,2354),(42247,2355),(42248,2355),(42249,2355),(42250,2356),(42251,2356),(42252,2356),(42253,2357),(42254,2357),(42255,2357),(42256,2358),(42257,2358),(42258,2358),(42259,2359),(42260,2359),(42261,2359),(42262,2360),(42263,2360),(42264,2360),(42265,2361),(42266,2361),(42267,2361),(42268,2362),(42269,2362),(42270,2362),(42271,2363),(42272,2363),(42273,2363),(42274,2364),(42275,2364),(42276,2364),(42277,2365),(42278,2365),(42279,2365),(42280,2366),(42281,2366),(42282,2366),(42283,2367),(42284,2367),(42285,2367),(42286,2368),(42287,2368),(42288,2368),(42289,2369),(42290,2369),(42291,2369),(42292,2370),(42293,2370),(42294,2370),(42295,2371),(42296,2371),(42297,2371),(42298,2372),(42299,2372),(42300,2372),(42301,2373),(42302,2373),(42303,2373),(42304,2374),(42305,2374),(42306,2374),(42307,2375),(42308,2375),(42309,2375),(42310,2376),(42311,2376),(42312,2376),(42313,2377),(42314,2377),(42315,2378),(42316,2378),(42317,2379),(42318,2379),(42319,2379),(42320,2380),(42321,2380),(42322,2380),(42323,2381),(42324,2381),(42325,2381),(42326,2382),(42327,2382),(42328,2382),(42329,2383),(42330,2383),(42331,2383),(42332,2384),(42333,2384),(42334,2384),(42335,2385),(42336,2385),(42337,2386),(42338,2386),(42339,2387),(42340,2387),(42341,2387),(42342,2388),(42343,2388),(42344,2389),(42345,2389),(42346,2390),(42347,2390),(42348,2390),(42349,2391),(42350,2391),(42351,2392),(42352,2392),(42353,2392),(42354,2393),(42355,2393),(42356,2393),(42357,2394),(42358,2394),(42359,2394),(42360,2395),(42361,2395),(42362,2395),(42363,2396),(42364,2396),(42365,2396),(42366,2397),(42367,2397),(42368,2398),(42369,2398),(42370,2399),(42371,2399),(42372,2400),(42373,2400),(42374,2401),(42375,2401),(42376,2402),(42377,2402),(42378,2403),(42379,2403),(42380,2404),(42381,2404),(42382,2405),(42383,2405),(42384,2406),(42385,2406),(42386,2407),(42387,2407),(42388,2408),(42389,2408),(42390,2409),(42391,2409),(42392,2410),(42393,2410),(42394,2322),(42395,2322),(42396,2322),(42397,2323),(42398,2323),(42399,2323),(42400,2324),(42401,2324),(42402,2324),(42403,2325),(42404,2325),(42405,2325),(42406,2326),(42407,2326),(42408,2326),(42409,2327),(42410,2327),(42411,2327),(42412,2328),(42413,2328),(42414,2328),(42415,2329),(42416,2329),(42417,2329),(42418,2330),(42419,2330),(42420,2330),(42421,2331),(42422,2331),(42423,2331),(42424,2332),(42425,2332),(42426,2332),(42427,2333),(42428,2333),(42429,2333),(42430,2334),(42431,2334),(42432,2334),(42433,2335),(42434,2335),(42435,2335),(42436,2336),(42437,2336),(42438,2336),(42439,2337),(42440,2337),(42441,2337),(42442,2338),(42443,2338),(42444,2338),(42445,2339),(42446,2339),(42447,2339),(42448,2340),(42449,2340),(42450,2340),(42451,2341),(42452,2341),(42453,2341),(42454,2342),(42455,2342),(42456,2342),(42457,2343),(42458,2343),(42459,2343),(42460,2344),(42461,2344),(42462,2344),(42463,2345),(42464,2345),(42465,2345),(42466,2346),(42467,2346),(42468,2346),(42469,2347),(42470,2347),(42471,2347),(42472,2348),(42473,2348),(42474,2348),(42475,2349),(42476,2349),(42477,2349),(42478,2350),(42479,2350),(42480,2350),(42481,2351),(42482,2351),(42483,2351),(42484,2352),(42485,2352),(42486,2352),(42487,2353),(42488,2353),(42489,2353),(42490,2354),(42491,2354),(42492,2354),(42493,2355),(42494,2355),(42495,2355),(42496,2356),(42497,2356),(42498,2356),(42499,2357),(42500,2357),(42501,2357),(42502,2358),(42503,2358),(42504,2358),(42505,2359),(42506,2359),(42507,2359),(42508,2360),(42509,2360),(42510,2360),(42511,2361),(42512,2361),(42513,2361),(42514,2362),(42515,2362),(42516,2362),(42517,2363),(42518,2363),(42519,2363),(42520,2364),(42521,2364),(42522,2364),(42523,2365),(42524,2365),(42525,2365),(42526,2366),(42527,2366),(42528,2366),(42529,2367),(42530,2367),(42531,2367),(42532,2368),(42533,2368),(42534,2368),(42535,2369),(42536,2369),(42537,2369),(42538,2370),(42539,2370),(42540,2370),(42541,2371),(42542,2371),(42543,2371),(42544,2372),(42545,2372),(42546,2372),(42547,2373),(42548,2373),(42549,2373),(42550,2374),(42551,2374),(42552,2374),(42553,2375),(42554,2375),(42555,2375),(42556,2376),(42557,2376),(42558,2376),(42559,2377),(42560,2377),(42561,2377),(42562,2378),(42563,2378),(42564,2378),(42565,2379),(42566,2379),(42567,2379),(42568,2380),(42569,2380),(42570,2380),(42571,2381),(42572,2381),(42573,2381),(42574,2382),(42575,2382),(42576,2382),(42577,2383),(42578,2383),(42579,2383),(42580,2384),(42581,2384),(42582,2384),(42583,2385),(42584,2385),(42585,2385),(42586,2386),(42587,2386),(42588,2386),(42589,2387),(42590,2387),(42591,2387),(42592,2388),(42593,2388),(42594,2388),(42595,2389),(42596,2389),(42597,2389),(42598,2390),(42599,2390),(42600,2390),(42601,2391),(42602,2391),(42603,2391),(42604,2392),(42605,2392),(42606,2392),(42607,2393),(42608,2393),(42609,2393),(42610,2394),(42611,2394),(42612,2394),(42613,2395),(42614,2395),(42615,2395),(42616,2396),(42617,2396),(42618,2396),(42619,2397),(42620,2397),(42621,2397),(42622,2398),(42623,2398),(42624,2398),(42625,2399),(42626,2399),(42627,2399),(42628,2400),(42629,2400),(42630,2400),(42631,2401),(42632,2401),(42633,2401),(42634,2402),(42635,2402),(42636,2402),(42637,2403),(42638,2403),(42639,2403),(42640,2404),(42641,2404),(42642,2404),(42643,2405),(42644,2405),(42645,2405),(42646,2406),(42647,2406),(42648,2406),(42649,2407),(42650,2407),(42651,2407),(42652,2408),(42653,2408),(42654,2408),(42655,2409),(42656,2409),(42657,2409),(42658,2410),(42659,2410),(42660,2410),(42661,2322),(42662,2322),(42663,2322),(42664,2322),(42665,2323),(42666,2323),(42667,2323),(42668,2323),(42669,2324),(42670,2324),(42671,2324),(42672,2324),(42673,2325),(42674,2325),(42675,2325),(42676,2325),(42677,2326),(42678,2326),(42679,2326),(42680,2326),(42681,2327),(42682,2327),(42683,2327),(42684,2327),(42685,2328),(42686,2328),(42687,2328),(42688,2328),(42689,2329),(42690,2329),(42691,2329),(42692,2329),(42693,2330),(42694,2330),(42695,2330),(42696,2330),(42697,2331),(42698,2331),(42699,2331),(42700,2331),(42701,2332),(42702,2332),(42703,2332),(42704,2332),(42705,2333),(42706,2333),(42707,2333),(42708,2333),(42709,2334),(42710,2334),(42711,2334),(42712,2334),(42713,2335),(42714,2335),(42715,2335),(42716,2335),(42717,2336),(42718,2336),(42719,2336),(42720,2336),(42721,2337),(42722,2337),(42723,2337),(42724,2337),(42725,2338),(42726,2338),(42727,2338),(42728,2338),(42729,2339),(42730,2339),(42731,2339),(42732,2339),(42733,2340),(42734,2340),(42735,2340),(42736,2340),(42737,2341),(42738,2341),(42739,2341),(42740,2341),(42741,2342),(42742,2342),(42743,2342),(42744,2342),(42745,2343),(42746,2343),(42747,2343),(42748,2343),(42749,2344),(42750,2344),(42751,2344),(42752,2344),(42753,2345),(42754,2345),(42755,2345),(42756,2345),(42757,2346),(42758,2346),(42759,2346),(42760,2346),(42761,2347),(42762,2347),(42763,2347),(42764,2347),(42765,2348),(42766,2348),(42767,2348),(42768,2348),(42769,2349),(42770,2349),(42771,2349),(42772,2349),(42773,2350),(42774,2350),(42775,2350),(42776,2350),(42777,2351),(42778,2351),(42779,2351),(42780,2351),(42781,2352),(42782,2352),(42783,2352),(42784,2352),(42785,2353),(42786,2353),(42787,2353),(42788,2353),(42789,2354),(42790,2354),(42791,2354),(42792,2354),(42793,2355),(42794,2355),(42795,2355),(42796,2355),(42797,2356),(42798,2356),(42799,2356),(42800,2356),(42801,2357),(42802,2357),(42803,2357),(42804,2357),(42805,2358),(42806,2358),(42807,2358),(42808,2358),(42809,2359),(42810,2359),(42811,2359),(42812,2359),(42813,2360),(42814,2360),(42815,2360),(42816,2360),(42817,2361),(42818,2361),(42819,2361),(42820,2361),(42821,2362),(42822,2362),(42823,2362),(42824,2362),(42825,2363),(42826,2363),(42827,2363),(42828,2363),(42829,2364),(42830,2364),(42831,2364),(42832,2364),(42833,2365),(42834,2365),(42835,2365),(42836,2365),(42837,2366),(42838,2366),(42839,2366),(42840,2366),(42841,2367),(42842,2367),(42843,2367),(42844,2367),(42845,2368),(42846,2368),(42847,2368),(42848,2368),(42849,2369),(42850,2369),(42851,2369),(42852,2369),(42853,2370),(42854,2370),(42855,2370),(42856,2370),(42857,2371),(42858,2371),(42859,2371),(42860,2371),(42861,2372),(42862,2372),(42863,2372),(42864,2372),(42865,2373),(42866,2373),(42867,2373),(42868,2373),(42869,2374),(42870,2374),(42871,2374),(42872,2374),(42873,2375),(42874,2375),(42875,2375),(42876,2375),(42877,2376),(42878,2376),(42879,2376),(42880,2376),(42881,2377),(42882,2377),(42883,2377),(42884,2377),(42885,2378),(42886,2378),(42887,2378),(42888,2378),(42889,2379),(42890,2379),(42891,2379),(42892,2379),(42893,2380),(42894,2380),(42895,2380),(42896,2380),(42897,2381),(42898,2381),(42899,2381),(42900,2381),(42901,2382),(42902,2382),(42903,2382),(42904,2382),(42905,2383),(42906,2383),(42907,2383),(42908,2383),(42909,2384),(42910,2384),(42911,2384),(42912,2384),(42913,2385),(42914,2385),(42915,2385),(42916,2385),(42917,2386),(42918,2386),(42919,2386),(42920,2386),(42921,2387),(42922,2387),(42923,2387),(42924,2387),(42925,2388),(42926,2388),(42927,2388),(42928,2388),(42929,2389),(42930,2389),(42931,2389),(42932,2389),(42933,2390),(42934,2390),(42935,2390),(42936,2390),(42937,2391),(42938,2391),(42939,2391),(42940,2391),(42941,2392),(42942,2392),(42943,2392),(42944,2392),(42945,2393),(42946,2393),(42947,2393),(42948,2393),(42949,2394),(42950,2394),(42951,2394),(42952,2394),(42953,2395),(42954,2395),(42955,2395),(42956,2395),(42957,2396),(42958,2396),(42959,2396),(42960,2396),(42961,2397),(42962,2397),(42963,2397),(42964,2397),(42965,2398),(42966,2398),(42967,2398),(42968,2398),(42969,2399),(42970,2399),(42971,2399),(42972,2399),(42973,2400),(42974,2400),(42975,2400),(42976,2400),(42977,2401),(42978,2401),(42979,2401),(42980,2401),(42981,2402),(42982,2402),(42983,2402),(42984,2402),(42985,2403),(42986,2403),(42987,2403),(42988,2403),(42989,2404),(42990,2404),(42991,2404),(42992,2404),(42993,2405),(42994,2405),(42995,2405),(42996,2405),(42997,2406),(42998,2406),(42999,2406),(43000,2406),(43001,2407),(43002,2407),(43003,2407),(43004,2407),(43005,2408),(43006,2408),(43007,2408),(43008,2408),(43009,2409),(43010,2409),(43011,2409),(43012,2409),(43013,2410),(43014,2410),(43015,2410),(43016,2410),(43017,2411),(43018,2412),(43019,2413),(43020,2414),(43021,2415),(43022,2416),(43023,2417),(43024,2418),(43025,2419),(43026,2420),(43027,2421),(43028,2422),(43029,2423),(43030,2424),(43031,2425),(43032,2426),(43033,2427),(43034,2428),(43035,2429),(43036,2430),(43037,2431),(43038,2432),(43039,2433),(43040,2434),(43041,2435),(43042,2436),(43043,2437),(43044,2438),(43045,2439),(43046,2440),(43047,2441),(43048,2442),(43049,2443),(43050,2444),(43051,2445),(43052,2446),(43053,2447),(43054,2448),(43055,2449),(43056,2450),(43057,2451),(43058,2452),(43059,2453),(43060,2454),(43061,2455),(43062,2456),(43063,2457),(43064,2458),(43065,2459),(43066,2460),(43067,2461),(43068,2462),(43069,2463),(43070,2464),(43071,2465),(43072,2466),(43073,2467),(43074,2468),(43075,2469),(43076,2470),(43077,2471),(43078,2472),(43079,2473),(43080,2474),(43081,2475),(43082,2476),(43083,2477),(43084,2478),(43085,2479),(43086,2480),(43087,2481),(43088,2482),(43089,2483),(43090,2484),(43091,2485),(43092,2486),(43093,2487),(43094,2488),(43095,2489),(43096,2490),(43097,2491),(43098,2492),(43099,2493),(43100,2494),(43101,2495),(43102,2496),(43103,2497),(43104,2498),(43105,2499),(43106,2500),(43107,2501),(43108,2502),(43109,2503),(43110,2504),(43111,2505),(43112,2506),(43113,2507),(43114,2508),(43115,2509),(43116,2510),(43117,2411),(43118,2411),(43119,2411),(43120,2411),(43121,2411),(43122,2411),(43123,2411),(43124,2412),(43125,2412),(43126,2412),(43127,2412),(43128,2412),(43129,2412),(43130,2412),(43131,2413),(43132,2413),(43133,2413),(43134,2413),(43135,2413),(43136,2413),(43137,2413),(43138,2414),(43139,2414),(43140,2414),(43141,2414),(43142,2414),(43143,2414),(43144,2414),(43145,2415),(43146,2415),(43147,2415),(43148,2415),(43149,2415),(43150,2415),(43151,2415),(43152,2416),(43153,2416),(43154,2416),(43155,2416),(43156,2416),(43157,2416),(43158,2416),(43159,2417),(43160,2417),(43161,2417),(43162,2417),(43163,2417),(43164,2417),(43165,2417),(43166,2418),(43167,2418),(43168,2418),(43169,2418),(43170,2418),(43171,2418),(43172,2418),(43173,2419),(43174,2419),(43175,2419),(43176,2419),(43177,2419),(43178,2419),(43179,2419),(43180,2420),(43181,2420),(43182,2420),(43183,2420),(43184,2420),(43185,2420),(43186,2420),(43187,2421),(43188,2421),(43189,2421),(43190,2421),(43191,2421),(43192,2421),(43193,2421),(43194,2422),(43195,2422),(43196,2422),(43197,2422),(43198,2422),(43199,2422),(43200,2422),(43201,2423),(43202,2423),(43203,2423),(43204,2423),(43205,2423),(43206,2423),(43207,2423),(43208,2424),(43209,2424),(43210,2424),(43211,2424),(43212,2424),(43213,2424),(43214,2424),(43215,2425),(43216,2425),(43217,2425),(43218,2425),(43219,2425),(43220,2425),(43221,2425),(43222,2426),(43223,2426),(43224,2426),(43225,2426),(43226,2426),(43227,2426),(43228,2426),(43229,2427),(43230,2427),(43231,2427),(43232,2427),(43233,2427),(43234,2427),(43235,2427),(43236,2428),(43237,2428),(43238,2428),(43239,2428),(43240,2428),(43241,2428),(43242,2428),(43243,2429),(43244,2429),(43245,2429),(43246,2429),(43247,2429),(43248,2429),(43249,2429),(43250,2430),(43251,2430),(43252,2430),(43253,2430),(43254,2430),(43255,2430),(43256,2430),(43257,2431),(43258,2431),(43259,2431),(43260,2431),(43261,2431),(43262,2431),(43263,2431),(43264,2432),(43265,2432),(43266,2432),(43267,2432),(43268,2432),(43269,2432),(43270,2432),(43271,2433),(43272,2433),(43273,2433),(43274,2433),(43275,2433),(43276,2433),(43277,2433),(43278,2434),(43279,2434),(43280,2434),(43281,2434),(43282,2434),(43283,2434),(43284,2434),(43285,2435),(43286,2435),(43287,2435),(43288,2435),(43289,2435),(43290,2435),(43291,2435),(43292,2435),(43293,2436),(43294,2436),(43295,2436),(43296,2436),(43297,2436),(43298,2436),(43299,2436),(43300,2437),(43301,2437),(43302,2437),(43303,2437),(43304,2437),(43305,2437),(43306,2437),(43307,2438),(43308,2438),(43309,2438),(43310,2438),(43311,2438),(43312,2438),(43313,2438),(43314,2439),(43315,2439),(43316,2439),(43317,2439),(43318,2439),(43319,2439),(43320,2439),(43321,2440),(43322,2440),(43323,2440),(43324,2440),(43325,2440),(43326,2440),(43327,2440),(43328,2440),(43329,2440),(43330,2441),(43331,2441),(43332,2441),(43333,2441),(43334,2441),(43335,2441),(43336,2441),(43337,2441),(43338,2441),(43339,2442),(43340,2442),(43341,2442),(43342,2442),(43343,2442),(43344,2442),(43345,2442),(43346,2442),(43347,2442),(43348,2443),(43349,2443),(43350,2443),(43351,2443),(43352,2443),(43353,2443),(43354,2443),(43355,2444),(43356,2444),(43357,2444),(43358,2444),(43359,2444),(43360,2444),(43361,2444),(43362,2445),(43363,2445),(43364,2445),(43365,2445),(43366,2445),(43367,2445),(43368,2445),(43369,2446),(43370,2446),(43371,2446),(43372,2446),(43373,2446),(43374,2446),(43375,2446),(43376,2447),(43377,2447),(43378,2447),(43379,2447),(43380,2447),(43381,2447),(43382,2447),(43383,2448),(43384,2448),(43385,2448),(43386,2448),(43387,2448),(43388,2448),(43389,2448),(43390,2449),(43391,2449),(43392,2449),(43393,2449),(43394,2449),(43395,2449),(43396,2450),(43397,2450),(43398,2450),(43399,2450),(43400,2450),(43401,2450),(43402,2450),(43403,2451),(43404,2451),(43405,2451),(43406,2451),(43407,2451),(43408,2451),(43409,2451),(43410,2452),(43411,2452),(43412,2452),(43413,2452),(43414,2453),(43415,2453),(43416,2453),(43417,2453),(43418,2453),(43419,2453),(43420,2453),(43421,2454),(43422,2454),(43423,2454),(43424,2454),(43425,2454),(43426,2454),(43427,2454),(43428,2454),(43429,2454),(43430,2455),(43431,2455),(43432,2455),(43433,2455),(43434,2455),(43435,2455),(43436,2455),(43437,2455),(43438,2455),(43439,2456),(43440,2456),(43441,2456),(43442,2456),(43443,2456),(43444,2456),(43445,2456),(43446,2456),(43447,2456),(43448,2457),(43449,2457),(43450,2457),(43451,2457),(43452,2457),(43453,2457),(43454,2457),(43455,2457),(43456,2458),(43457,2458),(43458,2458),(43459,2458),(43460,2458),(43461,2458),(43462,2458),(43463,2459),(43464,2459),(43465,2459),(43466,2459),(43467,2459),(43468,2459),(43469,2459),(43470,2460),(43471,2460),(43472,2460),(43473,2460),(43474,2460),(43475,2460),(43476,2460),(43477,2461),(43478,2461),(43479,2461),(43480,2461),(43481,2461),(43482,2461),(43483,2461),(43484,2462),(43485,2462),(43486,2462),(43487,2462),(43488,2462),(43489,2462),(43490,2462),(43491,2463),(43492,2463),(43493,2463),(43494,2463),(43495,2463),(43496,2463),(43497,2463),(43498,2464),(43499,2464),(43500,2464),(43501,2464),(43502,2464),(43503,2464),(43504,2464),(43505,2465),(43506,2465),(43507,2465),(43508,2465),(43509,2465),(43510,2465),(43511,2465),(43512,2466),(43513,2466),(43514,2466),(43515,2466),(43516,2466),(43517,2466),(43518,2466),(43519,2467),(43520,2467),(43521,2467),(43522,2467),(43523,2467),(43524,2467),(43525,2467),(43526,2468),(43527,2468),(43528,2468),(43529,2468),(43530,2468),(43531,2468),(43532,2468),(43533,2469),(43534,2469),(43535,2469),(43536,2469),(43537,2469),(43538,2469),(43539,2469),(43540,2470),(43541,2470),(43542,2470),(43543,2470),(43544,2470),(43545,2470),(43546,2470),(43547,2471),(43548,2471),(43549,2471),(43550,2471),(43551,2471),(43552,2471),(43553,2471),(43554,2472),(43555,2472),(43556,2472),(43557,2472),(43558,2472),(43559,2472),(43560,2472),(43561,2472),(43562,2473),(43563,2473),(43564,2473),(43565,2473),(43566,2473),(43567,2473),(43568,2473),(43569,2473),(43570,2474),(43571,2474),(43572,2474),(43573,2474),(43574,2474),(43575,2474),(43576,2474),(43577,2475),(43578,2475),(43579,2475),(43580,2475),(43581,2475),(43582,2475),(43583,2475),(43584,2475),(43585,2475),(43586,2476),(43587,2476),(43588,2476),(43589,2476),(43590,2476),(43591,2476),(43592,2476),(43593,2476),(43594,2476),(43595,2477),(43596,2477),(43597,2477),(43598,2477),(43599,2477),(43600,2477),(43601,2477),(43602,2478),(43603,2478),(43604,2478),(43605,2478),(43606,2478),(43607,2478),(43608,2478),(43609,2479),(43610,2479),(43611,2479),(43612,2479),(43613,2479),(43614,2479),(43615,2479),(43616,2480),(43617,2480),(43618,2480),(43619,2480),(43620,2480),(43621,2480),(43622,2480),(43623,2481),(43624,2481),(43625,2481),(43626,2481),(43627,2481),(43628,2481),(43629,2481),(43630,2482),(43631,2482),(43632,2482),(43633,2482),(43634,2482),(43635,2482),(43636,2482),(43637,2483),(43638,2483),(43639,2483),(43640,2483),(43641,2483),(43642,2483),(43643,2483),(43644,2483),(43645,2483),(43646,2484),(43647,2484),(43648,2484),(43649,2484),(43650,2484),(43651,2484),(43652,2484),(43653,2485),(43654,2485),(43655,2485),(43656,2485),(43657,2485),(43658,2485),(43659,2485),(43660,2486),(43661,2486),(43662,2486),(43663,2486),(43664,2486),(43665,2486),(43666,2486),(43667,2487),(43668,2487),(43669,2487),(43670,2487),(43671,2487),(43672,2487),(43673,2487),(43674,2487),(43675,2487),(43676,2488),(43677,2488),(43678,2488),(43679,2488),(43680,2488),(43681,2488),(43682,2488),(43683,2489),(43684,2489),(43685,2489),(43686,2489),(43687,2489),(43688,2489),(43689,2489),(43690,2489),(43691,2490),(43692,2490),(43693,2490),(43694,2490),(43695,2490),(43696,2490),(43697,2490),(43698,2490),(43699,2491),(43700,2491),(43701,2491),(43702,2491),(43703,2491),(43704,2491),(43705,2491),(43706,2491),(43707,2492),(43708,2492),(43709,2492),(43710,2492),(43711,2492),(43712,2492),(43713,2493),(43714,2493),(43715,2493),(43716,2493),(43717,2493),(43718,2493),(43719,2494),(43720,2494),(43721,2494),(43722,2494),(43723,2494),(43724,2494),(43725,2495),(43726,2495),(43727,2495),(43728,2495),(43729,2495),(43730,2495),(43731,2496),(43732,2496),(43733,2496),(43734,2496),(43735,2496),(43736,2496),(43737,2497),(43738,2497),(43739,2497),(43740,2497),(43741,2497),(43742,2497),(43743,2498),(43744,2498),(43745,2498),(43746,2498),(43747,2498),(43748,2498),(43749,2498),(43750,2498),(43751,2498),(43752,2499),(43753,2499),(43754,2499),(43755,2499),(43756,2499),(43757,2499),(43758,2499),(43759,2499),(43760,2499),(43761,2500),(43762,2500),(43763,2500),(43764,2500),(43765,2500),(43766,2500),(43767,2500),(43768,2500),(43769,2500),(43770,2501),(43771,2501),(43772,2501),(43773,2501),(43774,2501),(43775,2501),(43776,2501),(43777,2502),(43778,2502),(43779,2502),(43780,2502),(43781,2502),(43782,2502),(43783,2502),(43784,2503),(43785,2503),(43786,2503),(43787,2503),(43788,2503),(43789,2503),(43790,2503),(43791,2504),(43792,2504),(43793,2504),(43794,2504),(43795,2504),(43796,2504),(43797,2504),(43798,2505),(43799,2505),(43800,2505),(43801,2505),(43802,2505),(43803,2505),(43804,2505),(43805,2506),(43806,2506),(43807,2506),(43808,2506),(43809,2506),(43810,2506),(43811,2506),(43812,2506),(43813,2506),(43814,2507),(43815,2507),(43816,2507),(43817,2507),(43818,2507),(43819,2507),(43820,2507),(43821,2507),(43822,2507),(43823,2508),(43824,2508),(43825,2508),(43826,2508),(43827,2508),(43828,2508),(43829,2508),(43830,2508),(43831,2508),(43832,2509),(43833,2509),(43834,2509),(43835,2509),(43836,2509),(43837,2509),(43838,2509),(43839,2509),(43840,2509),(43841,2510),(43842,2510),(43843,2510),(43844,2510),(43845,2510),(43846,2510),(43847,2510),(43848,2411),(43849,2411),(43850,2411),(43851,2412),(43852,2412),(43853,2412),(43854,2413),(43855,2413),(43856,2413),(43857,2414),(43858,2414),(43859,2414),(43860,2415),(43861,2415),(43862,2415),(43863,2416),(43864,2416),(43865,2416),(43866,2417),(43867,2417),(43868,2417),(43869,2418),(43870,2418),(43871,2418),(43872,2419),(43873,2419),(43874,2419),(43875,2420),(43876,2420),(43877,2420),(43878,2421),(43879,2421),(43880,2421),(43881,2422),(43882,2422),(43883,2422),(43884,2423),(43885,2423),(43886,2423),(43887,2424),(43888,2424),(43889,2424),(43890,2425),(43891,2425),(43892,2425),(43893,2426),(43894,2426),(43895,2426),(43896,2427),(43897,2427),(43898,2427),(43899,2428),(43900,2428),(43901,2428),(43902,2429),(43903,2429),(43904,2429),(43905,2430),(43906,2430),(43907,2430),(43908,2431),(43909,2431),(43910,2431),(43911,2432),(43912,2432),(43913,2432),(43914,2433),(43915,2433),(43916,2433),(43917,2434),(43918,2434),(43919,2434),(43920,2435),(43921,2435),(43922,2436),(43923,2436),(43924,2436),(43925,2437),(43926,2437),(43927,2437),(43928,2438),(43929,2438),(43930,2438),(43931,2439),(43932,2439),(43933,2439),(43934,2440),(43935,2440),(43936,2441),(43937,2441),(43938,2442),(43939,2442),(43940,2443),(43941,2443),(43942,2443),(43943,2444),(43944,2444),(43945,2444),(43946,2445),(43947,2445),(43948,2445),(43949,2446),(43950,2446),(43951,2446),(43952,2447),(43953,2447),(43954,2447),(43955,2448),(43956,2448),(43957,2448),(43958,2449),(43959,2449),(43960,2450),(43961,2450),(43962,2450),(43963,2451),(43964,2451),(43965,2451),(43966,2452),(43967,2452),(43968,2453),(43969,2453),(43970,2453),(43971,2454),(43972,2454),(43973,2455),(43974,2455),(43975,2456),(43976,2456),(43977,2457),(43978,2457),(43979,2458),(43980,2458),(43981,2458),(43982,2459),(43983,2459),(43984,2459),(43985,2460),(43986,2460),(43987,2460),(43988,2461),(43989,2461),(43990,2461),(43991,2462),(43992,2462),(43993,2462),(43994,2463),(43995,2463),(43996,2463),(43997,2464),(43998,2464),(43999,2464),(44000,2465),(44001,2465),(44002,2465),(44003,2466),(44004,2466),(44005,2466),(44006,2467),(44007,2467),(44008,2467),(44009,2468),(44010,2468),(44011,2468),(44012,2469),(44013,2469),(44014,2469),(44015,2470),(44016,2470),(44017,2470),(44018,2471),(44019,2471),(44020,2471),(44021,2472),(44022,2472),(44023,2473),(44024,2473),(44025,2474),(44026,2474),(44027,2474),(44028,2475),(44029,2475),(44030,2476),(44031,2476),(44032,2477),(44033,2477),(44034,2478),(44035,2478),(44036,2479),(44037,2479),(44038,2480),(44039,2480),(44040,2481),(44041,2481),(44042,2481),(44043,2482),(44044,2482),(44045,2482),(44046,2483),(44047,2483),(44048,2483),(44049,2484),(44050,2484),(44051,2484),(44052,2485),(44053,2485),(44054,2485),(44055,2486),(44056,2486),(44057,2486),(44058,2487),(44059,2487),(44060,2487),(44061,2488),(44062,2488),(44063,2488),(44064,2489),(44065,2489),(44066,2490),(44067,2490),(44068,2491),(44069,2491),(44070,2492),(44071,2492),(44072,2492),(44073,2493),(44074,2493),(44075,2493),(44076,2494),(44077,2494),(44078,2494),(44079,2495),(44080,2495),(44081,2495),(44082,2496),(44083,2496),(44084,2496),(44085,2497),(44086,2497),(44087,2497),(44088,2498),(44089,2498),(44090,2498),(44091,2499),(44092,2499),(44093,2499),(44094,2500),(44095,2500),(44096,2500),(44097,2501),(44098,2501),(44099,2501),(44100,2502),(44101,2502),(44102,2502),(44103,2503),(44104,2503),(44105,2503),(44106,2504),(44107,2504),(44108,2504),(44109,2505),(44110,2505),(44111,2505),(44112,2506),(44113,2506),(44114,2507),(44115,2507),(44116,2508),(44117,2508),(44118,2509),(44119,2509),(44120,2510),(44121,2510),(44122,2510),(44123,2411),(44124,2411),(44125,2411),(44126,2412),(44127,2412),(44128,2412),(44129,2413),(44130,2413),(44131,2413),(44132,2414),(44133,2414),(44134,2414),(44135,2415),(44136,2415),(44137,2415),(44138,2416),(44139,2416),(44140,2416),(44141,2417),(44142,2417),(44143,2417),(44144,2418),(44145,2418),(44146,2418),(44147,2419),(44148,2419),(44149,2419),(44150,2420),(44151,2420),(44152,2420),(44153,2421),(44154,2421),(44155,2421),(44156,2422),(44157,2422),(44158,2422),(44159,2423),(44160,2423),(44161,2423),(44162,2424),(44163,2424),(44164,2424),(44165,2425),(44166,2425),(44167,2425),(44168,2426),(44169,2426),(44170,2426),(44171,2426),(44172,2427),(44173,2427),(44174,2427),(44175,2428),(44176,2428),(44177,2428),(44178,2429),(44179,2429),(44180,2429),(44181,2430),(44182,2430),(44183,2430),(44184,2431),(44185,2431),(44186,2431),(44187,2432),(44188,2432),(44189,2432),(44190,2433),(44191,2433),(44192,2433),(44193,2434),(44194,2434),(44195,2434),(44196,2435),(44197,2435),(44198,2435),(44199,2436),(44200,2436),(44201,2436),(44202,2437),(44203,2437),(44204,2437),(44205,2438),(44206,2438),(44207,2438),(44208,2439),(44209,2439),(44210,2439),(44211,2440),(44212,2440),(44213,2440),(44214,2441),(44215,2441),(44216,2441),(44217,2442),(44218,2442),(44219,2442),(44220,2443),(44221,2443),(44222,2443),(44223,2444),(44224,2444),(44225,2444),(44226,2445),(44227,2445),(44228,2445),(44229,2446),(44230,2446),(44231,2446),(44232,2447),(44233,2447),(44234,2447),(44235,2448),(44236,2448),(44237,2448),(44238,2449),(44239,2450),(44240,2450),(44241,2450),(44242,2451),(44243,2451),(44244,2451),(44245,2452),(44246,2452),(44247,2452),(44248,2453),(44249,2453),(44250,2453),(44251,2454),(44252,2454),(44253,2454),(44254,2455),(44255,2455),(44256,2455),(44257,2456),(44258,2456),(44259,2456),(44260,2457),(44261,2457),(44262,2457),(44263,2458),(44264,2458),(44265,2458),(44266,2459),(44267,2459),(44268,2459),(44269,2460),(44270,2460),(44271,2460),(44272,2461),(44273,2461),(44274,2461),(44275,2462),(44276,2462),(44277,2462),(44278,2463),(44279,2463),(44280,2463),(44281,2464),(44282,2464),(44283,2464),(44284,2465),(44285,2465),(44286,2465),(44287,2466),(44288,2466),(44289,2466),(44290,2467),(44291,2467),(44292,2467),(44293,2468),(44294,2468),(44295,2468),(44296,2469),(44297,2469),(44298,2469),(44299,2470),(44300,2470),(44301,2470),(44302,2471),(44303,2471),(44304,2471),(44305,2472),(44306,2472),(44307,2472),(44308,2473),(44309,2473),(44310,2473),(44311,2474),(44312,2474),(44313,2474),(44314,2475),(44315,2475),(44316,2475),(44317,2476),(44318,2476),(44319,2476),(44320,2477),(44321,2477),(44322,2477),(44323,2478),(44324,2478),(44325,2478),(44326,2479),(44327,2479),(44328,2479),(44329,2480),(44330,2480),(44331,2480),(44332,2481),(44333,2481),(44334,2481),(44335,2482),(44336,2482),(44337,2482),(44338,2483),(44339,2483),(44340,2483),(44341,2484),(44342,2484),(44343,2484),(44344,2485),(44345,2485),(44346,2485),(44347,2486),(44348,2486),(44349,2486),(44350,2487),(44351,2487),(44352,2487),(44353,2488),(44354,2488),(44355,2488),(44356,2489),(44357,2489),(44358,2489),(44359,2490),(44360,2490),(44361,2490),(44362,2491),(44363,2491),(44364,2491),(44365,2492),(44366,2492),(44367,2492),(44368,2493),(44369,2493),(44370,2493),(44371,2494),(44372,2494),(44373,2494),(44374,2495),(44375,2495),(44376,2495),(44377,2496),(44378,2496),(44379,2496),(44380,2497),(44381,2497),(44382,2497),(44383,2498),(44384,2498),(44385,2498),(44386,2499),(44387,2499),(44388,2499),(44389,2500),(44390,2500),(44391,2500),(44392,2501),(44393,2501),(44394,2501),(44395,2502),(44396,2502),(44397,2502),(44398,2503),(44399,2503),(44400,2503),(44401,2504),(44402,2504),(44403,2504),(44404,2505),(44405,2505),(44406,2505),(44407,2506),(44408,2506),(44409,2506),(44410,2507),(44411,2507),(44412,2507),(44413,2508),(44414,2508),(44415,2508),(44416,2509),(44417,2509),(44418,2509),(44419,2510),(44420,2510),(44421,2510),(44422,2411),(44423,2411),(44424,2411),(44425,2411),(44426,2412),(44427,2412),(44428,2412),(44429,2412),(44430,2413),(44431,2413),(44432,2413),(44433,2413),(44434,2414),(44435,2414),(44436,2414),(44437,2414),(44438,2415),(44439,2415),(44440,2415),(44441,2415),(44442,2416),(44443,2416),(44444,2416),(44445,2416),(44446,2417),(44447,2417),(44448,2417),(44449,2417),(44450,2418),(44451,2418),(44452,2418),(44453,2418),(44454,2419),(44455,2419),(44456,2419),(44457,2419),(44458,2420),(44459,2420),(44460,2420),(44461,2420),(44462,2421),(44463,2421),(44464,2421),(44465,2421),(44466,2422),(44467,2422),(44468,2422),(44469,2422),(44470,2423),(44471,2423),(44472,2423),(44473,2423),(44474,2424),(44475,2424),(44476,2424),(44477,2424),(44478,2425),(44479,2425),(44480,2425),(44481,2425),(44482,2426),(44483,2426),(44484,2426),(44485,2426),(44486,2427),(44487,2427),(44488,2427),(44489,2427),(44490,2428),(44491,2428),(44492,2428),(44493,2428),(44494,2429),(44495,2429),(44496,2429),(44497,2429),(44498,2430),(44499,2430),(44500,2430),(44501,2430),(44502,2431),(44503,2431),(44504,2431),(44505,2431),(44506,2432),(44507,2432),(44508,2432),(44509,2432),(44510,2433),(44511,2433),(44512,2433),(44513,2433),(44514,2434),(44515,2434),(44516,2434),(44517,2434),(44518,2435),(44519,2435),(44520,2435),(44521,2435),(44522,2436),(44523,2436),(44524,2436),(44525,2436),(44526,2437),(44527,2437),(44528,2437),(44529,2437),(44530,2438),(44531,2438),(44532,2438),(44533,2438),(44534,2439),(44535,2439),(44536,2439),(44537,2439),(44538,2440),(44539,2440),(44540,2440),(44541,2440),(44542,2441),(44543,2441),(44544,2441),(44545,2441),(44546,2442),(44547,2442),(44548,2442),(44549,2442),(44550,2443),(44551,2443),(44552,2443),(44553,2443),(44554,2444),(44555,2444),(44556,2444),(44557,2444),(44558,2445),(44559,2445),(44560,2445),(44561,2445),(44562,2446),(44563,2446),(44564,2446),(44565,2446),(44566,2447),(44567,2447),(44568,2447),(44569,2447),(44570,2448),(44571,2448),(44572,2448),(44573,2448),(44574,2449),(44575,2449),(44576,2449),(44577,2449),(44578,2450),(44579,2450),(44580,2450),(44581,2450),(44582,2451),(44583,2451),(44584,2451),(44585,2451),(44586,2452),(44587,2452),(44588,2452),(44589,2452),(44590,2453),(44591,2453),(44592,2453),(44593,2453),(44594,2454),(44595,2454),(44596,2454),(44597,2454),(44598,2455),(44599,2455),(44600,2455),(44601,2455),(44602,2456),(44603,2456),(44604,2456),(44605,2456),(44606,2457),(44607,2457),(44608,2457),(44609,2457),(44610,2458),(44611,2458),(44612,2458),(44613,2458),(44614,2459),(44615,2459),(44616,2459),(44617,2459),(44618,2460),(44619,2460),(44620,2460),(44621,2460),(44622,2461),(44623,2461),(44624,2461),(44625,2461),(44626,2462),(44627,2462),(44628,2462),(44629,2462),(44630,2463),(44631,2463),(44632,2463),(44633,2463),(44634,2464),(44635,2464),(44636,2464),(44637,2464),(44638,2465),(44639,2465),(44640,2465),(44641,2465),(44642,2466),(44643,2466),(44644,2466),(44645,2466),(44646,2467),(44647,2467),(44648,2467),(44649,2467),(44650,2468),(44651,2468),(44652,2468),(44653,2468),(44654,2469),(44655,2469),(44656,2469),(44657,2469),(44658,2470),(44659,2470),(44660,2470),(44661,2470),(44662,2471),(44663,2471),(44664,2471),(44665,2471),(44666,2472),(44667,2472),(44668,2472),(44669,2472),(44670,2473),(44671,2473),(44672,2473),(44673,2473),(44674,2474),(44675,2474),(44676,2474),(44677,2474),(44678,2475),(44679,2475),(44680,2475),(44681,2475),(44682,2476),(44683,2476),(44684,2476),(44685,2476),(44686,2477),(44687,2477),(44688,2477),(44689,2477),(44690,2478),(44691,2478),(44692,2478),(44693,2478),(44694,2479),(44695,2479),(44696,2479),(44697,2479),(44698,2480),(44699,2480),(44700,2480),(44701,2480),(44702,2481),(44703,2481),(44704,2481),(44705,2481),(44706,2482),(44707,2482),(44708,2482),(44709,2482),(44710,2483),(44711,2483),(44712,2483),(44713,2483),(44714,2484),(44715,2484),(44716,2484),(44717,2484),(44718,2485),(44719,2485),(44720,2485),(44721,2485),(44722,2486),(44723,2486),(44724,2486),(44725,2486),(44726,2487),(44727,2487),(44728,2487),(44729,2487),(44730,2488),(44731,2488),(44732,2488),(44733,2488),(44734,2489),(44735,2489),(44736,2489),(44737,2489),(44738,2490),(44739,2490),(44740,2490),(44741,2490),(44742,2491),(44743,2491),(44744,2491),(44745,2491),(44746,2492),(44747,2492),(44748,2492),(44749,2492),(44750,2493),(44751,2493),(44752,2493),(44753,2493),(44754,2494),(44755,2494),(44756,2494),(44757,2494),(44758,2495),(44759,2495),(44760,2495),(44761,2495),(44762,2496),(44763,2496),(44764,2496),(44765,2496),(44766,2497),(44767,2497),(44768,2497),(44769,2497),(44770,2498),(44771,2498),(44772,2498),(44773,2498),(44774,2499),(44775,2499),(44776,2499),(44777,2499),(44778,2500),(44779,2500),(44780,2500),(44781,2500),(44782,2501),(44783,2501),(44784,2501),(44785,2501),(44786,2502),(44787,2502),(44788,2502),(44789,2502),(44790,2503),(44791,2503),(44792,2503),(44793,2503),(44794,2504),(44795,2504),(44796,2504),(44797,2504),(44798,2505),(44799,2505),(44800,2505),(44801,2505),(44802,2506),(44803,2506),(44804,2506),(44805,2506),(44806,2507),(44807,2507),(44808,2507),(44809,2507),(44810,2508),(44811,2508),(44812,2508),(44813,2508),(44814,2509),(44815,2509),(44816,2509),(44817,2509),(44818,2510),(44819,2510),(44820,2510),(44821,2510),(44822,2511),(44823,2512),(44824,2513),(44825,2514),(44826,2515),(44827,2516),(44828,2517),(44829,2518),(44830,2519),(44831,2520),(44832,2521),(44833,2522),(44834,2523),(44835,2524),(44836,2525),(44837,2526),(44838,2527),(44839,2528),(44840,2529),(44841,2530),(44842,2531),(44843,2532),(44844,2533),(44845,2534),(44846,2535),(44847,2536),(44848,2537),(44849,2538),(44850,2539),(44851,2540),(44852,2541),(44853,2542),(44854,2543),(44855,2544),(44856,2545),(44857,2546),(44858,2547),(44859,2548),(44860,2549),(44861,2550),(44862,2551),(44863,2552),(44864,2553),(44865,2554),(44866,2555),(44867,2556),(44868,2557),(44869,2558),(44870,2559),(44871,2560),(44872,2561),(44873,2562),(44874,2563),(44875,2564),(44876,2565),(44877,2566),(44878,2567),(44879,2568),(44880,2569),(44881,2570),(44882,2571),(44883,2572),(44884,2573),(44885,2574),(44886,2575),(44887,2576),(44888,2577),(44889,2578),(44890,2579),(44891,2580),(44892,2581),(44893,2582),(44894,2583),(44895,2584),(44896,2585),(44897,2586),(44898,2587),(44899,2588),(44900,2589),(44901,2590),(44902,2591),(44903,2592),(44904,2593),(44905,2594),(44906,2595),(44907,2596),(44908,2597),(44909,2598),(44910,2599),(44911,2600),(44912,2601),(44913,2602),(44914,2603),(44915,2604),(44916,2605),(44917,2606),(44918,2607),(44919,2608),(44920,2609),(44921,2610),(44922,2511),(44923,2511),(44924,2511),(44925,2511),(44926,2511),(44927,2511),(44928,2511),(44929,2511),(44930,2511),(44931,2512),(44932,2512),(44933,2512),(44934,2512),(44935,2512),(44936,2512),(44937,2512),(44938,2512),(44939,2512),(44940,2513),(44941,2513),(44942,2513),(44943,2513),(44944,2513),(44945,2513),(44946,2513),(44947,2513),(44948,2513),(44949,2514),(44950,2514),(44951,2514),(44952,2514),(44953,2514),(44954,2514),(44955,2514),(44956,2514),(44957,2514),(44958,2515),(44959,2515),(44960,2515),(44961,2515),(44962,2515),(44963,2515),(44964,2515),(44965,2516),(44966,2516),(44967,2516),(44968,2516),(44969,2516),(44970,2516),(44971,2516),(44972,2517),(44973,2517),(44974,2517),(44975,2517),(44976,2517),(44977,2517),(44978,2517),(44979,2518),(44980,2518),(44981,2518),(44982,2518),(44983,2518),(44984,2518),(44985,2518),(44986,2519),(44987,2519),(44988,2519),(44989,2519),(44990,2519),(44991,2519),(44992,2519),(44993,2520),(44994,2520),(44995,2520),(44996,2520),(44997,2520),(44998,2520),(44999,2520),(45000,2521),(45001,2521),(45002,2521),(45003,2521),(45004,2521),(45005,2521),(45006,2521),(45007,2522),(45008,2522),(45009,2522),(45010,2522),(45011,2522),(45012,2522),(45013,2522),(45014,2523),(45015,2523),(45016,2523),(45017,2523),(45018,2523),(45019,2523),(45020,2523),(45021,2524),(45022,2524),(45023,2524),(45024,2524),(45025,2524),(45026,2524),(45027,2524),(45028,2525),(45029,2525),(45030,2525),(45031,2525),(45032,2525),(45033,2525),(45034,2525),(45035,2526),(45036,2526),(45037,2526),(45038,2526),(45039,2526),(45040,2526),(45041,2526),(45042,2527),(45043,2527),(45044,2527),(45045,2527),(45046,2527),(45047,2527),(45048,2527),(45049,2528),(45050,2528),(45051,2528),(45052,2528),(45053,2528),(45054,2528),(45055,2528),(45056,2529),(45057,2529),(45058,2529),(45059,2529),(45060,2529),(45061,2529),(45062,2529),(45063,2530),(45064,2530),(45065,2530),(45066,2530),(45067,2530),(45068,2530),(45069,2530),(45070,2531),(45071,2531),(45072,2531),(45073,2531),(45074,2531),(45075,2531),(45076,2531),(45077,2532),(45078,2532),(45079,2532),(45080,2532),(45081,2532),(45082,2532),(45083,2532),(45084,2533),(45085,2533),(45086,2533),(45087,2533),(45088,2533),(45089,2533),(45090,2533),(45091,2534),(45092,2534),(45093,2534),(45094,2534),(45095,2534),(45096,2534),(45097,2534),(45098,2535),(45099,2535),(45100,2535),(45101,2535),(45102,2535),(45103,2535),(45104,2535),(45105,2536),(45106,2536),(45107,2536),(45108,2536),(45109,2536),(45110,2536),(45111,2536),(45112,2536),(45113,2536),(45114,2537),(45115,2537),(45116,2537),(45117,2537),(45118,2537),(45119,2537),(45120,2537),(45121,2538),(45122,2538),(45123,2538),(45124,2538),(45125,2538),(45126,2538),(45127,2538),(45128,2539),(45129,2539),(45130,2539),(45131,2539),(45132,2539),(45133,2539),(45134,2539),(45135,2539),(45136,2539),(45137,2540),(45138,2540),(45139,2540),(45140,2540),(45141,2540),(45142,2540),(45143,2541),(45144,2541),(45145,2541),(45146,2541),(45147,2541),(45148,2541),(45149,2541),(45150,2541),(45151,2541),(45152,2542),(45153,2542),(45154,2542),(45155,2542),(45156,2542),(45157,2542),(45158,2542),(45159,2542),(45160,2542),(45161,2543),(45162,2543),(45163,2543),(45164,2543),(45165,2543),(45166,2543),(45167,2543),(45168,2544),(45169,2544),(45170,2544),(45171,2544),(45172,2544),(45173,2544),(45174,2544),(45175,2545),(45176,2545),(45177,2545),(45178,2545),(45179,2545),(45180,2545),(45181,2545),(45182,2546),(45183,2546),(45184,2546),(45185,2546),(45186,2546),(45187,2546),(45188,2546),(45189,2547),(45190,2547),(45191,2547),(45192,2547),(45193,2547),(45194,2547),(45195,2547),(45196,2548),(45197,2548),(45198,2548),(45199,2548),(45200,2548),(45201,2548),(45202,2548),(45203,2549),(45204,2549),(45205,2549),(45206,2549),(45207,2549),(45208,2549),(45209,2549),(45210,2550),(45211,2550),(45212,2550),(45213,2550),(45214,2550),(45215,2550),(45216,2550),(45217,2551),(45218,2551),(45219,2551),(45220,2551),(45221,2551),(45222,2551),(45223,2551),(45224,2552),(45225,2552),(45226,2552),(45227,2552),(45228,2552),(45229,2552),(45230,2552),(45231,2553),(45232,2553),(45233,2553),(45234,2553),(45235,2553),(45236,2553),(45237,2553),(45238,2554),(45239,2554),(45240,2554),(45241,2554),(45242,2554),(45243,2554),(45244,2554),(45245,2555),(45246,2555),(45247,2555),(45248,2555),(45249,2555),(45250,2555),(45251,2555),(45252,2556),(45253,2556),(45254,2556),(45255,2556),(45256,2556),(45257,2556),(45258,2556),(45259,2557),(45260,2557),(45261,2557),(45262,2557),(45263,2557),(45264,2557),(45265,2557),(45266,2558),(45267,2558),(45268,2558),(45269,2558),(45270,2558),(45271,2558),(45272,2558),(45273,2559),(45274,2559),(45275,2559),(45276,2559),(45277,2559),(45278,2559),(45279,2560),(45280,2560),(45281,2560),(45282,2560),(45283,2560),(45284,2560),(45285,2560),(45286,2561),(45287,2561),(45288,2561),(45289,2561),(45290,2561),(45291,2561),(45292,2561),(45293,2562),(45294,2562),(45295,2562),(45296,2562),(45297,2562),(45298,2562),(45299,2562),(45300,2563),(45301,2563),(45302,2563),(45303,2563),(45304,2563),(45305,2563),(45306,2563),(45307,2564),(45308,2564),(45309,2564),(45310,2564),(45311,2564),(45312,2564),(45313,2564),(45314,2565),(45315,2565),(45316,2565),(45317,2565),(45318,2565),(45319,2565),(45320,2565),(45321,2566),(45322,2566),(45323,2566),(45324,2566),(45325,2566),(45326,2566),(45327,2566),(45328,2567),(45329,2567),(45330,2567),(45331,2567),(45332,2567),(45333,2567),(45334,2567),(45335,2568),(45336,2568),(45337,2568),(45338,2568),(45339,2568),(45340,2568),(45341,2568),(45342,2569),(45343,2569),(45344,2569),(45345,2569),(45346,2569),(45347,2569),(45348,2569),(45349,2570),(45350,2570),(45351,2570),(45352,2570),(45353,2570),(45354,2570),(45355,2570),(45356,2571),(45357,2571),(45358,2571),(45359,2571),(45360,2571),(45361,2571),(45362,2571),(45363,2572),(45364,2572),(45365,2572),(45366,2572),(45367,2572),(45368,2572),(45369,2572),(45370,2573),(45371,2573),(45372,2573),(45373,2573),(45374,2573),(45375,2573),(45376,2573),(45377,2574),(45378,2574),(45379,2574),(45380,2574),(45381,2574),(45382,2574),(45383,2574),(45384,2575),(45385,2575),(45386,2575),(45387,2575),(45388,2575),(45389,2575),(45390,2575),(45391,2576),(45392,2576),(45393,2576),(45394,2576),(45395,2576),(45396,2576),(45397,2576),(45398,2577),(45399,2577),(45400,2577),(45401,2577),(45402,2577),(45403,2577),(45404,2577),(45405,2578),(45406,2578),(45407,2578),(45408,2578),(45409,2578),(45410,2578),(45411,2578),(45412,2579),(45413,2579),(45414,2579),(45415,2579),(45416,2579),(45417,2579),(45418,2579),(45419,2580),(45420,2580),(45421,2580),(45422,2580),(45423,2580),(45424,2580),(45425,2580),(45426,2581),(45427,2581),(45428,2581),(45429,2581),(45430,2582),(45431,2582),(45432,2582),(45433,2582),(45434,2582),(45435,2582),(45436,2582),(45437,2583),(45438,2583),(45439,2583),(45440,2583),(45441,2583),(45442,2583),(45443,2583),(45444,2584),(45445,2584),(45446,2584),(45447,2584),(45448,2584),(45449,2584),(45450,2584),(45451,2585),(45452,2585),(45453,2585),(45454,2585),(45455,2585),(45456,2585),(45457,2585),(45458,2586),(45459,2586),(45460,2586),(45461,2586),(45462,2586),(45463,2586),(45464,2586),(45465,2587),(45466,2587),(45467,2587),(45468,2587),(45469,2587),(45470,2587),(45471,2587),(45472,2588),(45473,2588),(45474,2588),(45475,2588),(45476,2588),(45477,2588),(45478,2588),(45479,2589),(45480,2589),(45481,2589),(45482,2589),(45483,2589),(45484,2589),(45485,2589),(45486,2590),(45487,2590),(45488,2590),(45489,2590),(45490,2590),(45491,2590),(45492,2590),(45493,2591),(45494,2591),(45495,2591),(45496,2591),(45497,2591),(45498,2591),(45499,2591),(45500,2592),(45501,2592),(45502,2592),(45503,2592),(45504,2592),(45505,2592),(45506,2592),(45507,2593),(45508,2593),(45509,2593),(45510,2593),(45511,2593),(45512,2593),(45513,2593),(45514,2594),(45515,2594),(45516,2594),(45517,2594),(45518,2594),(45519,2594),(45520,2594),(45521,2595),(45522,2595),(45523,2595),(45524,2595),(45525,2595),(45526,2595),(45527,2595),(45528,2596),(45529,2596),(45530,2596),(45531,2596),(45532,2596),(45533,2596),(45534,2596),(45535,2597),(45536,2597),(45537,2597),(45538,2597),(45539,2597),(45540,2597),(45541,2597),(45542,2598),(45543,2598),(45544,2598),(45545,2598),(45546,2598),(45547,2598),(45548,2598),(45549,2599),(45550,2599),(45551,2599),(45552,2599),(45553,2599),(45554,2599),(45555,2599),(45556,2600),(45557,2600),(45558,2600),(45559,2600),(45560,2600),(45561,2600),(45562,2600),(45563,2601),(45564,2601),(45565,2601),(45566,2601),(45567,2601),(45568,2601),(45569,2601),(45570,2602),(45571,2602),(45572,2602),(45573,2602),(45574,2602),(45575,2602),(45576,2602),(45577,2603),(45578,2603),(45579,2603),(45580,2603),(45581,2603),(45582,2603),(45583,2603),(45584,2604),(45585,2604),(45586,2604),(45587,2604),(45588,2604),(45589,2604),(45590,2604),(45591,2605),(45592,2605),(45593,2605),(45594,2605),(45595,2605),(45596,2605),(45597,2605),(45598,2606),(45599,2606),(45600,2606),(45601,2606),(45602,2606),(45603,2606),(45604,2606),(45605,2607),(45606,2607),(45607,2607),(45608,2607),(45609,2607),(45610,2607),(45611,2607),(45612,2608),(45613,2608),(45614,2608),(45615,2608),(45616,2608),(45617,2608),(45618,2608),(45619,2609),(45620,2609),(45621,2609),(45622,2609),(45623,2609),(45624,2609),(45625,2609),(45626,2609),(45627,2609),(45628,2610),(45629,2610),(45630,2610),(45631,2610),(45632,2610),(45633,2610),(45634,2610),(45635,2511),(45636,2511),(45637,2512),(45638,2512),(45639,2513),(45640,2513),(45641,2513),(45642,2514),(45643,2514),(45644,2514),(45645,2515),(45646,2515),(45647,2516),(45648,2516),(45649,2517),(45650,2517),(45651,2517),(45652,2518),(45653,2518),(45654,2518),(45655,2519),(45656,2519),(45657,2519),(45658,2520),(45659,2520),(45660,2520),(45661,2521),(45662,2521),(45663,2521),(45664,2522),(45665,2522),(45666,2522),(45667,2523),(45668,2523),(45669,2523),(45670,2524),(45671,2524),(45672,2524),(45673,2525),(45674,2525),(45675,2525),(45676,2526),(45677,2526),(45678,2526),(45679,2527),(45680,2527),(45681,2527),(45682,2528),(45683,2528),(45684,2528),(45685,2529),(45686,2529),(45687,2529),(45688,2530),(45689,2530),(45690,2530),(45691,2531),(45692,2531),(45693,2532),(45694,2532),(45695,2532),(45696,2533),(45697,2533),(45698,2533),(45699,2534),(45700,2534),(45701,2534),(45702,2535),(45703,2535),(45704,2535),(45705,2536),(45706,2536),(45707,2537),(45708,2537),(45709,2537),(45710,2538),(45711,2538),(45712,2538),(45713,2539),(45714,2539),(45715,2539),(45716,2540),(45717,2540),(45718,2541),(45719,2541),(45720,2542),(45721,2542),(45722,2543),(45723,2543),(45724,2543),(45725,2544),(45726,2544),(45727,2544),(45728,2545),(45729,2545),(45730,2545),(45731,2546),(45732,2546),(45733,2546),(45734,2547),(45735,2547),(45736,2547),(45737,2548),(45738,2548),(45739,2548),(45740,2549),(45741,2549),(45742,2549),(45743,2550),(45744,2550),(45745,2550),(45746,2551),(45747,2551),(45748,2551),(45749,2552),(45750,2552),(45751,2552),(45752,2553),(45753,2553),(45754,2553),(45755,2554),(45756,2554),(45757,2554),(45758,2555),(45759,2555),(45760,2556),(45761,2556),(45762,2556),(45763,2557),(45764,2557),(45765,2557),(45766,2558),(45767,2558),(45768,2558),(45769,2559),(45770,2559),(45771,2559),(45772,2560),(45773,2560),(45774,2560),(45775,2561),(45776,2561),(45777,2561),(45778,2562),(45779,2562),(45780,2562),(45781,2563),(45782,2563),(45783,2563),(45784,2564),(45785,2564),(45786,2564),(45787,2565),(45788,2565),(45789,2565),(45790,2566),(45791,2566),(45792,2566),(45793,2567),(45794,2567),(45795,2567),(45796,2568),(45797,2568),(45798,2568),(45799,2569),(45800,2569),(45801,2569),(45802,2570),(45803,2570),(45804,2570),(45805,2571),(45806,2571),(45807,2571),(45808,2572),(45809,2572),(45810,2572),(45811,2573),(45812,2573),(45813,2573),(45814,2574),(45815,2574),(45816,2574),(45817,2575),(45818,2575),(45819,2575),(45820,2576),(45821,2576),(45822,2576),(45823,2577),(45824,2577),(45825,2577),(45826,2578),(45827,2578),(45828,2578),(45829,2579),(45830,2579),(45831,2579),(45832,2580),(45833,2580),(45834,2580),(45835,2581),(45836,2582),(45837,2582),(45838,2582),(45839,2583),(45840,2583),(45841,2583),(45842,2584),(45843,2584),(45844,2584),(45845,2585),(45846,2585),(45847,2585),(45848,2586),(45849,2586),(45850,2586),(45851,2587),(45852,2587),(45853,2587),(45854,2588),(45855,2588),(45856,2589),(45857,2589),(45858,2590),(45859,2590),(45860,2591),(45861,2591),(45862,2592),(45863,2592),(45864,2593),(45865,2593),(45866,2594),(45867,2594),(45868,2595),(45869,2595),(45870,2596),(45871,2596),(45872,2597),(45873,2597),(45874,2598),(45875,2598),(45876,2599),(45877,2599),(45878,2600),(45879,2600),(45880,2601),(45881,2601),(45882,2602),(45883,2602),(45884,2603),(45885,2603),(45886,2604),(45887,2604),(45888,2605),(45889,2605),(45890,2606),(45891,2606),(45892,2607),(45893,2607),(45894,2608),(45895,2608),(45896,2609),(45897,2609),(45898,2610),(45899,2610),(45900,2511),(45901,2511),(45902,2511),(45903,2512),(45904,2512),(45905,2512),(45906,2513),(45907,2513),(45908,2513),(45909,2514),(45910,2514),(45911,2514),(45912,2515),(45913,2515),(45914,2515),(45915,2516),(45916,2516),(45917,2516),(45918,2517),(45919,2517),(45920,2517),(45921,2518),(45922,2518),(45923,2518),(45924,2519),(45925,2519),(45926,2519),(45927,2520),(45928,2520),(45929,2520),(45930,2521),(45931,2521),(45932,2521),(45933,2522),(45934,2522),(45935,2522),(45936,2523),(45937,2523),(45938,2523),(45939,2524),(45940,2524),(45941,2524),(45942,2525),(45943,2525),(45944,2525),(45945,2526),(45946,2526),(45947,2526),(45948,2527),(45949,2527),(45950,2527),(45951,2528),(45952,2528),(45953,2528),(45954,2529),(45955,2529),(45956,2529),(45957,2530),(45958,2530),(45959,2530),(45960,2531),(45961,2531),(45962,2531),(45963,2532),(45964,2532),(45965,2532),(45966,2533),(45967,2533),(45968,2533),(45969,2534),(45970,2534),(45971,2534),(45972,2535),(45973,2535),(45974,2535),(45975,2536),(45976,2536),(45977,2536),(45978,2537),(45979,2537),(45980,2537),(45981,2538),(45982,2538),(45983,2538),(45984,2539),(45985,2539),(45986,2539),(45987,2540),(45988,2540),(45989,2540),(45990,2541),(45991,2541),(45992,2541),(45993,2542),(45994,2542),(45995,2542),(45996,2543),(45997,2543),(45998,2543),(45999,2544),(46000,2544),(46001,2544),(46002,2545),(46003,2545),(46004,2545),(46005,2546),(46006,2546),(46007,2546),(46008,2547),(46009,2547),(46010,2547),(46011,2548),(46012,2548),(46013,2548),(46014,2549),(46015,2549),(46016,2549),(46017,2550),(46018,2550),(46019,2550),(46020,2551),(46021,2551),(46022,2551),(46023,2552),(46024,2552),(46025,2552),(46026,2553),(46027,2553),(46028,2553),(46029,2554),(46030,2554),(46031,2554),(46032,2555),(46033,2555),(46034,2555),(46035,2556),(46036,2556),(46037,2556),(46038,2557),(46039,2557),(46040,2557),(46041,2558),(46042,2558),(46043,2558),(46044,2559),(46045,2559),(46046,2559),(46047,2560),(46048,2560),(46049,2560),(46050,2561),(46051,2561),(46052,2561),(46053,2562),(46054,2562),(46055,2562),(46056,2563),(46057,2563),(46058,2563),(46059,2564),(46060,2564),(46061,2564),(46062,2565),(46063,2565),(46064,2565),(46065,2566),(46066,2566),(46067,2566),(46068,2567),(46069,2567),(46070,2567),(46071,2568),(46072,2568),(46073,2568),(46074,2569),(46075,2569),(46076,2569),(46077,2570),(46078,2570),(46079,2570),(46080,2571),(46081,2571),(46082,2571),(46083,2572),(46084,2572),(46085,2572),(46086,2573),(46087,2573),(46088,2573),(46089,2574),(46090,2574),(46091,2574),(46092,2575),(46093,2575),(46094,2575),(46095,2576),(46096,2576),(46097,2576),(46098,2577),(46099,2577),(46100,2577),(46101,2578),(46102,2578),(46103,2578),(46104,2579),(46105,2579),(46106,2579),(46107,2580),(46108,2580),(46109,2580),(46110,2581),(46111,2581),(46112,2581),(46113,2582),(46114,2582),(46115,2582),(46116,2583),(46117,2583),(46118,2583),(46119,2584),(46120,2584),(46121,2584),(46122,2585),(46123,2585),(46124,2585),(46125,2586),(46126,2586),(46127,2586),(46128,2587),(46129,2587),(46130,2587),(46131,2588),(46132,2588),(46133,2588),(46134,2589),(46135,2589),(46136,2589),(46137,2590),(46138,2590),(46139,2590),(46140,2591),(46141,2591),(46142,2591),(46143,2592),(46144,2592),(46145,2592),(46146,2593),(46147,2593),(46148,2593),(46149,2594),(46150,2594),(46151,2594),(46152,2595),(46153,2595),(46154,2595),(46155,2596),(46156,2596),(46157,2596),(46158,2597),(46159,2597),(46160,2597),(46161,2598),(46162,2598),(46163,2598),(46164,2599),(46165,2599),(46166,2599),(46167,2600),(46168,2600),(46169,2600),(46170,2601),(46171,2601),(46172,2601),(46173,2602),(46174,2602),(46175,2602),(46176,2603),(46177,2603),(46178,2603),(46179,2604),(46180,2604),(46181,2604),(46182,2605),(46183,2605),(46184,2605),(46185,2606),(46186,2606),(46187,2606),(46188,2607),(46189,2607),(46190,2607),(46191,2608),(46192,2608),(46193,2608),(46194,2609),(46195,2609),(46196,2609),(46197,2610),(46198,2610),(46199,2610),(46200,2511),(46201,2511),(46202,2511),(46203,2511),(46204,2512),(46205,2512),(46206,2512),(46207,2512),(46208,2513),(46209,2513),(46210,2513),(46211,2513),(46212,2514),(46213,2514),(46214,2514),(46215,2514),(46216,2515),(46217,2515),(46218,2515),(46219,2515),(46220,2516),(46221,2516),(46222,2516),(46223,2516),(46224,2517),(46225,2517),(46226,2517),(46227,2517),(46228,2518),(46229,2518),(46230,2518),(46231,2518),(46232,2519),(46233,2519),(46234,2519),(46235,2519),(46236,2520),(46237,2520),(46238,2520),(46239,2520),(46240,2521),(46241,2521),(46242,2521),(46243,2521),(46244,2522),(46245,2522),(46246,2522),(46247,2522),(46248,2523),(46249,2523),(46250,2523),(46251,2523),(46252,2524),(46253,2524),(46254,2524),(46255,2524),(46256,2525),(46257,2525),(46258,2525),(46259,2525),(46260,2526),(46261,2526),(46262,2526),(46263,2526),(46264,2527),(46265,2527),(46266,2527),(46267,2527),(46268,2528),(46269,2528),(46270,2528),(46271,2528),(46272,2529),(46273,2529),(46274,2529),(46275,2529),(46276,2530),(46277,2530),(46278,2530),(46279,2530),(46280,2531),(46281,2531),(46282,2531),(46283,2531),(46284,2532),(46285,2532),(46286,2532),(46287,2532),(46288,2533),(46289,2533),(46290,2533),(46291,2533),(46292,2534),(46293,2534),(46294,2534),(46295,2534),(46296,2535),(46297,2535),(46298,2535),(46299,2535),(46300,2536),(46301,2536),(46302,2536),(46303,2536),(46304,2537),(46305,2537),(46306,2537),(46307,2537),(46308,2538),(46309,2538),(46310,2538),(46311,2538),(46312,2539),(46313,2539),(46314,2539),(46315,2539),(46316,2540),(46317,2540),(46318,2540),(46319,2540),(46320,2541),(46321,2541),(46322,2541),(46323,2541),(46324,2542),(46325,2542),(46326,2542),(46327,2542),(46328,2543),(46329,2543),(46330,2543),(46331,2543),(46332,2544),(46333,2544),(46334,2544),(46335,2544),(46336,2545),(46337,2545),(46338,2545),(46339,2545),(46340,2546),(46341,2546),(46342,2546),(46343,2546),(46344,2547),(46345,2547),(46346,2547),(46347,2547),(46348,2548),(46349,2548),(46350,2548),(46351,2548),(46352,2549),(46353,2549),(46354,2549),(46355,2549),(46356,2550),(46357,2550),(46358,2550),(46359,2550),(46360,2551),(46361,2551),(46362,2551),(46363,2551),(46364,2552),(46365,2552),(46366,2552),(46367,2552),(46368,2553),(46369,2553),(46370,2553),(46371,2553),(46372,2554),(46373,2554),(46374,2554),(46375,2554),(46376,2555),(46377,2555),(46378,2555),(46379,2555),(46380,2556),(46381,2556),(46382,2556),(46383,2556),(46384,2557),(46385,2557),(46386,2557),(46387,2557),(46388,2558),(46389,2558),(46390,2558),(46391,2558),(46392,2559),(46393,2559),(46394,2559),(46395,2559),(46396,2560),(46397,2560),(46398,2560),(46399,2560),(46400,2561),(46401,2561),(46402,2561),(46403,2561),(46404,2562),(46405,2562),(46406,2562),(46407,2562),(46408,2563),(46409,2563),(46410,2563),(46411,2563),(46412,2564),(46413,2564),(46414,2564),(46415,2564),(46416,2565),(46417,2565),(46418,2565),(46419,2565),(46420,2566),(46421,2566),(46422,2566),(46423,2566),(46424,2567),(46425,2567),(46426,2567),(46427,2567),(46428,2568),(46429,2568),(46430,2568),(46431,2568),(46432,2569),(46433,2569),(46434,2569),(46435,2569),(46436,2570),(46437,2570),(46438,2570),(46439,2570),(46440,2571),(46441,2571),(46442,2571),(46443,2571),(46444,2572),(46445,2572),(46446,2572),(46447,2572),(46448,2573),(46449,2573),(46450,2573),(46451,2573),(46452,2574),(46453,2574),(46454,2574),(46455,2574),(46456,2575),(46457,2575),(46458,2575),(46459,2575),(46460,2576),(46461,2576),(46462,2576),(46463,2576),(46464,2577),(46465,2577),(46466,2577),(46467,2577),(46468,2578),(46469,2578),(46470,2578),(46471,2578),(46472,2579),(46473,2579),(46474,2579),(46475,2579),(46476,2580),(46477,2580),(46478,2580),(46479,2580),(46480,2581),(46481,2581),(46482,2581),(46483,2581),(46484,2582),(46485,2582),(46486,2582),(46487,2582),(46488,2583),(46489,2583),(46490,2583),(46491,2583),(46492,2584),(46493,2584),(46494,2584),(46495,2584),(46496,2585),(46497,2585),(46498,2585),(46499,2585),(46500,2586),(46501,2586),(46502,2586),(46503,2586),(46504,2587),(46505,2587),(46506,2587),(46507,2587),(46508,2588),(46509,2588),(46510,2588),(46511,2588),(46512,2589),(46513,2589),(46514,2589),(46515,2589),(46516,2590),(46517,2590),(46518,2590),(46519,2590),(46520,2591),(46521,2591),(46522,2591),(46523,2591),(46524,2592),(46525,2592),(46526,2592),(46527,2592),(46528,2593),(46529,2593),(46530,2593),(46531,2593),(46532,2594),(46533,2594),(46534,2594),(46535,2594),(46536,2595),(46537,2595),(46538,2595),(46539,2595),(46540,2596),(46541,2596),(46542,2596),(46543,2596),(46544,2597),(46545,2597),(46546,2597),(46547,2597),(46548,2598),(46549,2598),(46550,2598),(46551,2598),(46552,2599),(46553,2599),(46554,2599),(46555,2599),(46556,2600),(46557,2600),(46558,2600),(46559,2600),(46560,2601),(46561,2601),(46562,2601),(46563,2601),(46564,2602),(46565,2602),(46566,2602),(46567,2602),(46568,2603),(46569,2603),(46570,2603),(46571,2603),(46572,2604),(46573,2604),(46574,2604),(46575,2604),(46576,2605),(46577,2605),(46578,2605),(46579,2605),(46580,2606),(46581,2606),(46582,2606),(46583,2606),(46584,2607),(46585,2607),(46586,2607),(46587,2607),(46588,2608),(46589,2608),(46590,2608),(46591,2608),(46592,2609),(46593,2609),(46594,2609),(46595,2609),(46596,2610),(46597,2610),(46598,2610),(46599,2610),(46600,2611),(46601,2612),(46602,2613),(46603,2614),(46604,2615),(46605,2616),(46606,2617),(46607,2618),(46608,2619),(46609,2620),(46610,2621),(46611,2611),(46612,2611),(46613,2611),(46614,2611),(46615,2611),(46616,2611),(46617,2611),(46618,2612),(46619,2612),(46620,2612),(46621,2612),(46622,2612),(46623,2612),(46624,2612),(46625,2613),(46626,2613),(46627,2613),(46628,2613),(46629,2613),(46630,2613),(46631,2613),(46632,2614),(46633,2614),(46634,2614),(46635,2614),(46636,2614),(46637,2614),(46638,2614),(46639,2615),(46640,2615),(46641,2615),(46642,2615),(46643,2615),(46644,2615),(46645,2615),(46646,2616),(46647,2616),(46648,2616),(46649,2616),(46650,2616),(46651,2616),(46652,2616),(46653,2617),(46654,2617),(46655,2617),(46656,2617),(46657,2617),(46658,2617),(46659,2617),(46660,2618),(46661,2618),(46662,2618),(46663,2618),(46664,2618),(46665,2618),(46666,2618),(46667,2619),(46668,2619),(46669,2619),(46670,2619),(46671,2619),(46672,2619),(46673,2619),(46674,2620),(46675,2620),(46676,2620),(46677,2620),(46678,2620),(46679,2620),(46680,2620),(46681,2621),(46682,2621),(46683,2621),(46684,2621),(46685,2621),(46686,2621),(46687,2621),(46688,2611),(46689,2611),(46690,2612),(46691,2612),(46692,2613),(46693,2613),(46694,2614),(46695,2614),(46696,2615),(46697,2615),(46698,2615),(46699,2616),(46700,2616),(46701,2616),(46702,2617),(46703,2617),(46704,2617),(46705,2618),(46706,2618),(46707,2618),(46708,2619),(46709,2619),(46710,2619),(46711,2620),(46712,2620),(46713,2620),(46714,2621),(46715,2621),(46716,2611),(46717,2611),(46718,2611),(46719,2612),(46720,2612),(46721,2612),(46722,2613),(46723,2613),(46724,2613),(46725,2614),(46726,2614),(46727,2614),(46728,2615),(46729,2615),(46730,2615),(46731,2616),(46732,2616),(46733,2616),(46734,2617),(46735,2617),(46736,2617),(46737,2618),(46738,2618),(46739,2618),(46740,2619),(46741,2619),(46742,2619),(46743,2620),(46744,2620),(46745,2620),(46746,2621),(46747,2621),(46748,2621),(46749,2611),(46750,2611),(46751,2611),(46752,2611),(46753,2612),(46754,2612),(46755,2612),(46756,2612),(46757,2613),(46758,2613),(46759,2613),(46760,2613),(46761,2614),(46762,2614),(46763,2614),(46764,2614),(46765,2615),(46766,2615),(46767,2615),(46768,2615),(46769,2616),(46770,2616),(46771,2616),(46772,2616),(46773,2617),(46774,2617),(46775,2617),(46776,2617),(46777,2618),(46778,2618),(46779,2618),(46780,2618),(46781,2619),(46782,2619),(46783,2619),(46784,2619),(46785,2620),(46786,2620),(46787,2620),(46788,2620),(46789,2621),(46790,2621),(46791,2621),(46792,2621),(46793,2622),(46794,2623),(46795,2624),(46796,2625),(46797,2626),(46798,2627),(46799,2628),(46800,2629),(46801,2630),(46802,2631),(46803,2632),(46804,2633),(46805,2634),(46806,2635),(46807,2636),(46808,2637),(46809,2638),(46810,2639),(46811,2640),(46812,2641),(46813,2642),(46814,2643),(46815,2644),(46816,2645),(46817,2646),(46818,2647),(46819,2648),(46820,2649),(46821,2650),(46822,2651),(46823,2652),(46824,2653),(46825,2654),(46826,2655),(46827,2656),(46828,2657),(46829,2658),(46830,2659),(46831,2660),(46832,2661),(46833,2662),(46834,2663),(46835,2664),(46836,2665),(46837,2666),(46838,2667),(46839,2668),(46840,2669),(46841,2670),(46842,2671),(46843,2672),(46844,2673),(46845,2674),(46846,2675),(46847,2676),(46848,2677),(46849,2678),(46850,2679),(46851,2680),(46852,2681),(46853,2682),(46854,2683),(46855,2684),(46856,2685),(46857,2686),(46858,2687),(46859,2688),(46860,2689),(46861,2690),(46862,2691),(46863,2692),(46864,2693),(46865,2694),(46866,2695),(46867,2696),(46868,2697),(46869,2698),(46870,2699),(46871,2700),(46872,2701),(46873,2702),(46874,2703),(46875,2704),(46876,2705),(46877,2706),(46878,2707),(46879,2708),(46880,2709),(46881,2710),(46882,2711),(46883,2712),(46884,2713),(46885,2714),(46886,2715),(46887,2716),(46888,2717),(46889,2718),(46890,2719),(46891,2720),(46892,2721),(46893,2622),(46894,2622),(46895,2622),(46896,2622),(46897,2622),(46898,2622),(46899,2623),(46900,2623),(46901,2623),(46902,2623),(46903,2623),(46904,2623),(46905,2624),(46906,2624),(46907,2624),(46908,2624),(46909,2624),(46910,2624),(46911,2625),(46912,2625),(46913,2625),(46914,2625),(46915,2625),(46916,2625),(46917,2626),(46918,2626),(46919,2626),(46920,2626),(46921,2626),(46922,2626),(46923,2627),(46924,2627),(46925,2627),(46926,2627),(46927,2627),(46928,2627),(46929,2628),(46930,2628),(46931,2628),(46932,2628),(46933,2628),(46934,2628),(46935,2629),(46936,2629),(46937,2629),(46938,2629),(46939,2629),(46940,2629),(46941,2630),(46942,2630),(46943,2630),(46944,2630),(46945,2630),(46946,2630),(46947,2631),(46948,2631),(46949,2631),(46950,2631),(46951,2631),(46952,2631),(46953,2632),(46954,2632),(46955,2632),(46956,2632),(46957,2632),(46958,2632),(46959,2633),(46960,2633),(46961,2633),(46962,2633),(46963,2633),(46964,2633),(46965,2634),(46966,2634),(46967,2634),(46968,2634),(46969,2634),(46970,2634),(46971,2635),(46972,2635),(46973,2635),(46974,2635),(46975,2635),(46976,2635),(46977,2636),(46978,2636),(46979,2636),(46980,2636),(46981,2636),(46982,2636),(46983,2637),(46984,2637),(46985,2637),(46986,2637),(46987,2637),(46988,2637),(46989,2638),(46990,2638),(46991,2638),(46992,2638),(46993,2638),(46994,2638),(46995,2639),(46996,2639),(46997,2639),(46998,2639),(46999,2639),(47000,2639),(47001,2640),(47002,2640),(47003,2640),(47004,2640),(47005,2640),(47006,2640),(47007,2641),(47008,2641),(47009,2641),(47010,2641),(47011,2641),(47012,2641),(47013,2642),(47014,2642),(47015,2642),(47016,2642),(47017,2642),(47018,2642),(47019,2643),(47020,2643),(47021,2643),(47022,2643),(47023,2643),(47024,2643),(47025,2644),(47026,2644),(47027,2644),(47028,2644),(47029,2644),(47030,2644),(47031,2645),(47032,2645),(47033,2645),(47034,2645),(47035,2645),(47036,2645),(47037,2646),(47038,2646),(47039,2646),(47040,2646),(47041,2646),(47042,2646),(47043,2647),(47044,2647),(47045,2647),(47046,2647),(47047,2647),(47048,2647),(47049,2648),(47050,2648),(47051,2648),(47052,2648),(47053,2648),(47054,2648),(47055,2649),(47056,2649),(47057,2649),(47058,2649),(47059,2649),(47060,2649),(47061,2650),(47062,2650),(47063,2650),(47064,2650),(47065,2650),(47066,2650),(47067,2651),(47068,2651),(47069,2651),(47070,2651),(47071,2651),(47072,2651),(47073,2652),(47074,2652),(47075,2652),(47076,2652),(47077,2652),(47078,2652),(47079,2653),(47080,2653),(47081,2653),(47082,2653),(47083,2653),(47084,2653),(47085,2654),(47086,2654),(47087,2654),(47088,2654),(47089,2654),(47090,2654),(47091,2655),(47092,2655),(47093,2655),(47094,2655),(47095,2655),(47096,2655),(47097,2656),(47098,2656),(47099,2656),(47100,2656),(47101,2656),(47102,2656),(47103,2657),(47104,2657),(47105,2657),(47106,2657),(47107,2657),(47108,2657),(47109,2658),(47110,2658),(47111,2658),(47112,2658),(47113,2658),(47114,2658),(47115,2659),(47116,2659),(47117,2659),(47118,2659),(47119,2659),(47120,2659),(47121,2660),(47122,2660),(47123,2660),(47124,2660),(47125,2660),(47126,2660),(47127,2661),(47128,2661),(47129,2661),(47130,2661),(47131,2661),(47132,2661),(47133,2662),(47134,2662),(47135,2662),(47136,2662),(47137,2662),(47138,2662),(47139,2663),(47140,2663),(47141,2663),(47142,2663),(47143,2663),(47144,2663),(47145,2664),(47146,2664),(47147,2664),(47148,2664),(47149,2664),(47150,2664),(47151,2665),(47152,2665),(47153,2665),(47154,2665),(47155,2665),(47156,2665),(47157,2666),(47158,2666),(47159,2666),(47160,2666),(47161,2666),(47162,2666),(47163,2667),(47164,2667),(47165,2667),(47166,2667),(47167,2667),(47168,2667),(47169,2668),(47170,2668),(47171,2668),(47172,2668),(47173,2668),(47174,2668),(47175,2669),(47176,2669),(47177,2669),(47178,2669),(47179,2669),(47180,2669),(47181,2670),(47182,2670),(47183,2670),(47184,2670),(47185,2670),(47186,2670),(47187,2671),(47188,2671),(47189,2671),(47190,2671),(47191,2671),(47192,2671),(47193,2672),(47194,2672),(47195,2672),(47196,2672),(47197,2672),(47198,2672),(47199,2673),(47200,2673),(47201,2673),(47202,2673),(47203,2673),(47204,2673),(47205,2674),(47206,2674),(47207,2674),(47208,2674),(47209,2674),(47210,2674),(47211,2675),(47212,2675),(47213,2675),(47214,2675),(47215,2675),(47216,2675),(47217,2676),(47218,2676),(47219,2676),(47220,2676),(47221,2676),(47222,2676),(47223,2677),(47224,2677),(47225,2677),(47226,2677),(47227,2677),(47228,2677),(47229,2678),(47230,2678),(47231,2678),(47232,2678),(47233,2678),(47234,2678),(47235,2679),(47236,2679),(47237,2679),(47238,2679),(47239,2679),(47240,2679),(47241,2680),(47242,2680),(47243,2680),(47244,2680),(47245,2680),(47246,2680),(47247,2681),(47248,2681),(47249,2681),(47250,2681),(47251,2681),(47252,2681),(47253,2682),(47254,2682),(47255,2682),(47256,2682),(47257,2682),(47258,2682),(47259,2683),(47260,2683),(47261,2683),(47262,2683),(47263,2683),(47264,2683),(47265,2684),(47266,2684),(47267,2684),(47268,2684),(47269,2684),(47270,2684),(47271,2685),(47272,2685),(47273,2685),(47274,2685),(47275,2685),(47276,2685),(47277,2686),(47278,2686),(47279,2686),(47280,2686),(47281,2686),(47282,2686),(47283,2687),(47284,2687),(47285,2687),(47286,2687),(47287,2687),(47288,2687),(47289,2688),(47290,2688),(47291,2688),(47292,2688),(47293,2688),(47294,2688),(47295,2689),(47296,2689),(47297,2689),(47298,2689),(47299,2689),(47300,2689),(47301,2690),(47302,2690),(47303,2690),(47304,2690),(47305,2690),(47306,2690),(47307,2691),(47308,2691),(47309,2691),(47310,2691),(47311,2691),(47312,2691),(47313,2692),(47314,2692),(47315,2692),(47316,2692),(47317,2692),(47318,2692),(47319,2693),(47320,2693),(47321,2693),(47322,2693),(47323,2693),(47324,2693),(47325,2694),(47326,2694),(47327,2694),(47328,2694),(47329,2694),(47330,2694),(47331,2695),(47332,2695),(47333,2695),(47334,2695),(47335,2695),(47336,2695),(47337,2696),(47338,2696),(47339,2696),(47340,2696),(47341,2696),(47342,2696),(47343,2697),(47344,2697),(47345,2697),(47346,2697),(47347,2697),(47348,2697),(47349,2698),(47350,2698),(47351,2698),(47352,2698),(47353,2698),(47354,2698),(47355,2699),(47356,2699),(47357,2699),(47358,2699),(47359,2699),(47360,2699),(47361,2700),(47362,2700),(47363,2700),(47364,2700),(47365,2700),(47366,2700),(47367,2701),(47368,2701),(47369,2701),(47370,2701),(47371,2701),(47372,2701),(47373,2702),(47374,2702),(47375,2702),(47376,2702),(47377,2702),(47378,2702),(47379,2703),(47380,2703),(47381,2703),(47382,2703),(47383,2703),(47384,2703),(47385,2704),(47386,2704),(47387,2704),(47388,2704),(47389,2704),(47390,2704),(47391,2705),(47392,2705),(47393,2705),(47394,2705),(47395,2705),(47396,2705),(47397,2706),(47398,2706),(47399,2706),(47400,2706),(47401,2706),(47402,2706),(47403,2707),(47404,2707),(47405,2707),(47406,2707),(47407,2707),(47408,2707),(47409,2708),(47410,2708),(47411,2708),(47412,2708),(47413,2708),(47414,2708),(47415,2709),(47416,2709),(47417,2709),(47418,2709),(47419,2709),(47420,2709),(47421,2710),(47422,2710),(47423,2710),(47424,2710),(47425,2710),(47426,2710),(47427,2711),(47428,2711),(47429,2711),(47430,2711),(47431,2711),(47432,2711),(47433,2712),(47434,2712),(47435,2712),(47436,2712),(47437,2712),(47438,2712),(47439,2713),(47440,2713),(47441,2713),(47442,2713),(47443,2713),(47444,2713),(47445,2714),(47446,2714),(47447,2714),(47448,2714),(47449,2714),(47450,2714),(47451,2715),(47452,2715),(47453,2715),(47454,2715),(47455,2715),(47456,2715),(47457,2716),(47458,2716),(47459,2716),(47460,2716),(47461,2716),(47462,2716),(47463,2717),(47464,2717),(47465,2717),(47466,2717),(47467,2717),(47468,2717),(47469,2718),(47470,2718),(47471,2718),(47472,2718),(47473,2718),(47474,2718),(47475,2719),(47476,2719),(47477,2719),(47478,2719),(47479,2719),(47480,2719),(47481,2720),(47482,2720),(47483,2720),(47484,2720),(47485,2720),(47486,2720),(47487,2721),(47488,2721),(47489,2721),(47490,2721),(47491,2721),(47492,2721),(47493,2622),(47494,2622),(47495,2623),(47496,2623),(47497,2624),(47498,2624),(47499,2625),(47500,2625),(47501,2626),(47502,2626),(47503,2627),(47504,2627),(47505,2628),(47506,2628),(47507,2629),(47508,2629),(47509,2630),(47510,2630),(47511,2631),(47512,2631),(47513,2632),(47514,2632),(47515,2633),(47516,2633),(47517,2634),(47518,2634),(47519,2635),(47520,2635),(47521,2636),(47522,2636),(47523,2637),(47524,2637),(47525,2638),(47526,2638),(47527,2639),(47528,2639),(47529,2640),(47530,2640),(47531,2641),(47532,2641),(47533,2642),(47534,2642),(47535,2643),(47536,2643),(47537,2644),(47538,2644),(47539,2645),(47540,2645),(47541,2646),(47542,2646),(47543,2647),(47544,2647),(47545,2648),(47546,2648),(47547,2649),(47548,2649),(47549,2650),(47550,2650),(47551,2651),(47552,2651),(47553,2652),(47554,2652),(47555,2653),(47556,2653),(47557,2654),(47558,2654),(47559,2655),(47560,2655),(47561,2656),(47562,2656),(47563,2657),(47564,2657),(47565,2658),(47566,2658),(47567,2659),(47568,2659),(47569,2660),(47570,2660),(47571,2661),(47572,2661),(47573,2662),(47574,2662),(47575,2663),(47576,2663),(47577,2664),(47578,2664),(47579,2665),(47580,2665),(47581,2666),(47582,2666),(47583,2667),(47584,2667),(47585,2668),(47586,2668),(47587,2669),(47588,2669),(47589,2670),(47590,2670),(47591,2671),(47592,2671),(47593,2672),(47594,2672),(47595,2673),(47596,2673),(47597,2674),(47598,2674),(47599,2675),(47600,2675),(47601,2676),(47602,2676),(47603,2677),(47604,2677),(47605,2678),(47606,2678),(47607,2679),(47608,2679),(47609,2680),(47610,2680),(47611,2681),(47612,2681),(47613,2682),(47614,2682),(47615,2683),(47616,2683),(47617,2684),(47618,2684),(47619,2685),(47620,2685),(47621,2686),(47622,2686),(47623,2687),(47624,2687),(47625,2688),(47626,2688),(47627,2689),(47628,2689),(47629,2690),(47630,2690),(47631,2691),(47632,2691),(47633,2692),(47634,2692),(47635,2693),(47636,2693),(47637,2694),(47638,2694),(47639,2695),(47640,2695),(47641,2696),(47642,2696),(47643,2697),(47644,2697),(47645,2698),(47646,2698),(47647,2699),(47648,2699),(47649,2700),(47650,2700),(47651,2701),(47652,2701),(47653,2701),(47654,2702),(47655,2702),(47656,2702),(47657,2703),(47658,2703),(47659,2704),(47660,2704),(47661,2705),(47662,2705),(47663,2706),(47664,2706),(47665,2707),(47666,2707),(47667,2708),(47668,2708),(47669,2709),(47670,2709),(47671,2710),(47672,2710),(47673,2711),(47674,2711),(47675,2712),(47676,2712),(47677,2713),(47678,2713),(47679,2714),(47680,2714),(47681,2715),(47682,2715),(47683,2716),(47684,2716),(47685,2717),(47686,2717),(47687,2718),(47688,2718),(47689,2719),(47690,2719),(47691,2720),(47692,2720),(47693,2721),(47694,2721),(47695,2622),(47696,2622),(47697,2622),(47698,2623),(47699,2623),(47700,2623),(47701,2624),(47702,2624),(47703,2624),(47704,2625),(47705,2625),(47706,2625),(47707,2626),(47708,2626),(47709,2626),(47710,2627),(47711,2627),(47712,2627),(47713,2628),(47714,2628),(47715,2628),(47716,2629),(47717,2629),(47718,2629),(47719,2630),(47720,2630),(47721,2630),(47722,2631),(47723,2631),(47724,2631),(47725,2632),(47726,2632),(47727,2632),(47728,2633),(47729,2633),(47730,2633),(47731,2634),(47732,2634),(47733,2634),(47734,2635),(47735,2635),(47736,2635),(47737,2636),(47738,2636),(47739,2636),(47740,2637),(47741,2637),(47742,2637),(47743,2638),(47744,2638),(47745,2638),(47746,2639),(47747,2639),(47748,2639),(47749,2640),(47750,2640),(47751,2640),(47752,2641),(47753,2641),(47754,2641),(47755,2642),(47756,2642),(47757,2642),(47758,2643),(47759,2643),(47760,2643),(47761,2644),(47762,2644),(47763,2644),(47764,2645),(47765,2645),(47766,2645),(47767,2646),(47768,2646),(47769,2646),(47770,2647),(47771,2647),(47772,2647),(47773,2648),(47774,2648),(47775,2648),(47776,2649),(47777,2649),(47778,2649),(47779,2650),(47780,2650),(47781,2650),(47782,2651),(47783,2651),(47784,2651),(47785,2652),(47786,2652),(47787,2652),(47788,2653),(47789,2653),(47790,2653),(47791,2654),(47792,2654),(47793,2654),(47794,2655),(47795,2655),(47796,2655),(47797,2656),(47798,2656),(47799,2656),(47800,2657),(47801,2657),(47802,2657),(47803,2658),(47804,2658),(47805,2658),(47806,2659),(47807,2659),(47808,2659),(47809,2660),(47810,2660),(47811,2660),(47812,2661),(47813,2661),(47814,2661),(47815,2662),(47816,2662),(47817,2662),(47818,2663),(47819,2663),(47820,2663),(47821,2664),(47822,2664),(47823,2664),(47824,2665),(47825,2665),(47826,2665),(47827,2666),(47828,2666),(47829,2666),(47830,2667),(47831,2667),(47832,2667),(47833,2668),(47834,2668),(47835,2668),(47836,2669),(47837,2669),(47838,2669),(47839,2670),(47840,2670),(47841,2670),(47842,2671),(47843,2671),(47844,2671),(47845,2672),(47846,2672),(47847,2672),(47848,2673),(47849,2673),(47850,2673),(47851,2674),(47852,2674),(47853,2674),(47854,2675),(47855,2675),(47856,2675),(47857,2676),(47858,2676),(47859,2676),(47860,2677),(47861,2677),(47862,2677),(47863,2678),(47864,2678),(47865,2678),(47866,2679),(47867,2679),(47868,2679),(47869,2680),(47870,2680),(47871,2680),(47872,2681),(47873,2681),(47874,2681),(47875,2682),(47876,2682),(47877,2682),(47878,2683),(47879,2683),(47880,2683),(47881,2684),(47882,2684),(47883,2684),(47884,2685),(47885,2685),(47886,2685),(47887,2686),(47888,2686),(47889,2686),(47890,2687),(47891,2687),(47892,2687),(47893,2688),(47894,2688),(47895,2688),(47896,2689),(47897,2689),(47898,2689),(47899,2690),(47900,2690),(47901,2690),(47902,2691),(47903,2691),(47904,2691),(47905,2692),(47906,2692),(47907,2692),(47908,2693),(47909,2693),(47910,2693),(47911,2694),(47912,2694),(47913,2694),(47914,2695),(47915,2695),(47916,2695),(47917,2696),(47918,2696),(47919,2696),(47920,2697),(47921,2697),(47922,2697),(47923,2698),(47924,2698),(47925,2698),(47926,2699),(47927,2699),(47928,2699),(47929,2700),(47930,2700),(47931,2700),(47932,2701),(47933,2701),(47934,2701),(47935,2702),(47936,2702),(47937,2702),(47938,2703),(47939,2703),(47940,2703),(47941,2704),(47942,2704),(47943,2704),(47944,2705),(47945,2705),(47946,2705),(47947,2706),(47948,2706),(47949,2706),(47950,2707),(47951,2707),(47952,2708),(47953,2708),(47954,2708),(47955,2709),(47956,2709),(47957,2709),(47958,2710),(47959,2710),(47960,2710),(47961,2711),(47962,2711),(47963,2711),(47964,2712),(47965,2712),(47966,2712),(47967,2713),(47968,2713),(47969,2713),(47970,2714),(47971,2714),(47972,2714),(47973,2715),(47974,2715),(47975,2715),(47976,2716),(47977,2716),(47978,2716),(47979,2717),(47980,2717),(47981,2717),(47982,2718),(47983,2718),(47984,2718),(47985,2719),(47986,2719),(47987,2719),(47988,2720),(47989,2720),(47990,2720),(47991,2721),(47992,2721),(47993,2721),(47994,2622),(47995,2622),(47996,2622),(47997,2622),(47998,2623),(47999,2623),(48000,2623),(48001,2623),(48002,2624),(48003,2624),(48004,2624),(48005,2624),(48006,2625),(48007,2625),(48008,2625),(48009,2625),(48010,2626),(48011,2626),(48012,2626),(48013,2626),(48014,2627),(48015,2627),(48016,2627),(48017,2627),(48018,2628),(48019,2628),(48020,2628),(48021,2628),(48022,2629),(48023,2629),(48024,2629),(48025,2629),(48026,2630),(48027,2630),(48028,2630),(48029,2630),(48030,2631),(48031,2631),(48032,2631),(48033,2631),(48034,2632),(48035,2632),(48036,2632),(48037,2632),(48038,2633),(48039,2633),(48040,2633),(48041,2633),(48042,2634),(48043,2634),(48044,2634),(48045,2634),(48046,2635),(48047,2635),(48048,2635),(48049,2635),(48050,2636),(48051,2636),(48052,2636),(48053,2636),(48054,2637),(48055,2637),(48056,2637),(48057,2637),(48058,2638),(48059,2638),(48060,2638),(48061,2638),(48062,2639),(48063,2639),(48064,2639),(48065,2639),(48066,2640),(48067,2640),(48068,2640),(48069,2640),(48070,2641),(48071,2641),(48072,2641),(48073,2641),(48074,2642),(48075,2642),(48076,2642),(48077,2642),(48078,2643),(48079,2643),(48080,2643),(48081,2643),(48082,2644),(48083,2644),(48084,2644),(48085,2644),(48086,2645),(48087,2645),(48088,2645),(48089,2645),(48090,2646),(48091,2646),(48092,2646),(48093,2646),(48094,2647),(48095,2647),(48096,2647),(48097,2647),(48098,2648),(48099,2648),(48100,2648),(48101,2648),(48102,2649),(48103,2649),(48104,2649),(48105,2649),(48106,2650),(48107,2650),(48108,2650),(48109,2650),(48110,2651),(48111,2651),(48112,2651),(48113,2651),(48114,2652),(48115,2652),(48116,2652),(48117,2652),(48118,2653),(48119,2653),(48120,2653),(48121,2653),(48122,2654),(48123,2654),(48124,2654),(48125,2654),(48126,2655),(48127,2655),(48128,2655),(48129,2655),(48130,2656),(48131,2656),(48132,2656),(48133,2656),(48134,2657),(48135,2657),(48136,2657),(48137,2657),(48138,2658),(48139,2658),(48140,2658),(48141,2658),(48142,2659),(48143,2659),(48144,2659),(48145,2659),(48146,2660),(48147,2660),(48148,2660),(48149,2660),(48150,2661),(48151,2661),(48152,2661),(48153,2661),(48154,2662),(48155,2662),(48156,2662),(48157,2662),(48158,2663),(48159,2663),(48160,2663),(48161,2663),(48162,2664),(48163,2664),(48164,2664),(48165,2664),(48166,2665),(48167,2665),(48168,2665),(48169,2665),(48170,2666),(48171,2666),(48172,2666),(48173,2666),(48174,2667),(48175,2667),(48176,2667),(48177,2667),(48178,2668),(48179,2668),(48180,2668),(48181,2668),(48182,2669),(48183,2669),(48184,2669),(48185,2669),(48186,2670),(48187,2670),(48188,2670),(48189,2670),(48190,2671),(48191,2671),(48192,2671),(48193,2671),(48194,2672),(48195,2672),(48196,2672),(48197,2672),(48198,2673),(48199,2673),(48200,2673),(48201,2673),(48202,2674),(48203,2674),(48204,2674),(48205,2674),(48206,2675),(48207,2675),(48208,2675),(48209,2675),(48210,2676),(48211,2676),(48212,2676),(48213,2676),(48214,2677),(48215,2677),(48216,2677),(48217,2677),(48218,2678),(48219,2678),(48220,2678),(48221,2678),(48222,2679),(48223,2679),(48224,2679),(48225,2679),(48226,2680),(48227,2680),(48228,2680),(48229,2680),(48230,2681),(48231,2681),(48232,2681),(48233,2681),(48234,2682),(48235,2682),(48236,2682),(48237,2682),(48238,2683),(48239,2683),(48240,2683),(48241,2683),(48242,2684),(48243,2684),(48244,2684),(48245,2684),(48246,2685),(48247,2685),(48248,2685),(48249,2685),(48250,2686),(48251,2686),(48252,2686),(48253,2686),(48254,2687),(48255,2687),(48256,2687),(48257,2687),(48258,2688),(48259,2688),(48260,2688),(48261,2688),(48262,2689),(48263,2689),(48264,2689),(48265,2689),(48266,2690),(48267,2690),(48268,2690),(48269,2690),(48270,2691),(48271,2691),(48272,2691),(48273,2691),(48274,2692),(48275,2692),(48276,2692),(48277,2692),(48278,2693),(48279,2693),(48280,2693),(48281,2693),(48282,2694),(48283,2694),(48284,2694),(48285,2694),(48286,2695),(48287,2695),(48288,2695),(48289,2695),(48290,2696),(48291,2696),(48292,2696),(48293,2696),(48294,2697),(48295,2697),(48296,2697),(48297,2697),(48298,2698),(48299,2698),(48300,2698),(48301,2698),(48302,2699),(48303,2699),(48304,2699),(48305,2699),(48306,2700),(48307,2700),(48308,2700),(48309,2700),(48310,2701),(48311,2701),(48312,2701),(48313,2701),(48314,2702),(48315,2702),(48316,2702),(48317,2702),(48318,2703),(48319,2703),(48320,2703),(48321,2703),(48322,2704),(48323,2704),(48324,2704),(48325,2704),(48326,2705),(48327,2705),(48328,2705),(48329,2705),(48330,2706),(48331,2706),(48332,2706),(48333,2706),(48334,2707),(48335,2707),(48336,2707),(48337,2707),(48338,2708),(48339,2708),(48340,2708),(48341,2708),(48342,2709),(48343,2709),(48344,2709),(48345,2709),(48346,2710),(48347,2710),(48348,2710),(48349,2710),(48350,2711),(48351,2711),(48352,2711),(48353,2711),(48354,2712),(48355,2712),(48356,2712),(48357,2712),(48358,2713),(48359,2713),(48360,2713),(48361,2713),(48362,2714),(48363,2714),(48364,2714),(48365,2714),(48366,2715),(48367,2715),(48368,2715),(48369,2715),(48370,2716),(48371,2716),(48372,2716),(48373,2716),(48374,2717),(48375,2717),(48376,2717),(48377,2717),(48378,2718),(48379,2718),(48380,2718),(48381,2718),(48382,2719),(48383,2719),(48384,2719),(48385,2719),(48386,2720),(48387,2720),(48388,2720),(48389,2720),(48390,2721),(48391,2721),(48392,2721),(48393,2721),(48394,2722),(48395,2723),(48396,2724),(48397,2725),(48398,2726),(48399,2727),(48400,2728),(48401,2729),(48402,2730),(48403,2731),(48404,2732),(48405,2733),(48406,2734),(48407,2735),(48408,2736),(48409,2737),(48410,2738),(48411,2739),(48412,2740),(48413,2741),(48414,2742),(48415,2743),(48416,2744),(48417,2745),(48418,2746),(48419,2747),(48420,2748),(48421,2749),(48422,2750),(48423,2751),(48424,2752),(48425,2753),(48426,2754),(48427,2755),(48428,2756),(48429,2757),(48430,2758),(48431,2759),(48432,2760),(48433,2761),(48434,2762),(48435,2763),(48436,2764),(48437,2765),(48438,2766),(48439,2767),(48440,2768),(48441,2769),(48442,2770),(48443,2771),(48444,2772),(48445,2773),(48446,2774),(48447,2775),(48448,2776),(48449,2777),(48450,2778),(48451,2779),(48452,2780),(48453,2781),(48454,2782),(48455,2783),(48456,2784),(48457,2785),(48458,2786),(48459,2787),(48460,2788),(48461,2789),(48462,2790),(48463,2791),(48464,2792),(48465,2793),(48466,2794),(48467,2795),(48468,2796),(48469,2797),(48470,2798),(48471,2799),(48472,2800),(48473,2801),(48474,2802),(48475,2803),(48476,2804),(48477,2805),(48478,2806),(48479,2807),(48480,2808),(48481,2809),(48482,2810),(48483,2811),(48484,2812),(48485,2813),(48486,2814),(48487,2815),(48488,2816),(48489,2817),(48490,2818),(48491,2819),(48492,2820),(48493,2821),(48494,2722),(48495,2722),(48496,2722),(48497,2722),(48498,2722),(48499,2722),(48500,2723),(48501,2723),(48502,2723),(48503,2723),(48504,2723),(48505,2723),(48506,2724),(48507,2724),(48508,2724),(48509,2724),(48510,2724),(48511,2724),(48512,2725),(48513,2725),(48514,2725),(48515,2725),(48516,2725),(48517,2725),(48518,2726),(48519,2726),(48520,2726),(48521,2726),(48522,2726),(48523,2726),(48524,2727),(48525,2727),(48526,2727),(48527,2727),(48528,2727),(48529,2727),(48530,2728),(48531,2728),(48532,2728),(48533,2728),(48534,2728),(48535,2728),(48536,2729),(48537,2729),(48538,2729),(48539,2729),(48540,2729),(48541,2729),(48542,2730),(48543,2730),(48544,2730),(48545,2730),(48546,2730),(48547,2730),(48548,2731),(48549,2731),(48550,2731),(48551,2731),(48552,2731),(48553,2731),(48554,2732),(48555,2732),(48556,2732),(48557,2732),(48558,2732),(48559,2732),(48560,2733),(48561,2733),(48562,2733),(48563,2733),(48564,2733),(48565,2733),(48566,2734),(48567,2734),(48568,2734),(48569,2734),(48570,2734),(48571,2734),(48572,2735),(48573,2735),(48574,2735),(48575,2735),(48576,2735),(48577,2735),(48578,2736),(48579,2736),(48580,2736),(48581,2736),(48582,2736),(48583,2736),(48584,2737),(48585,2737),(48586,2737),(48587,2737),(48588,2737),(48589,2737),(48590,2738),(48591,2738),(48592,2738),(48593,2738),(48594,2738),(48595,2738),(48596,2739),(48597,2739),(48598,2739),(48599,2739),(48600,2739),(48601,2739),(48602,2740),(48603,2740),(48604,2740),(48605,2740),(48606,2740),(48607,2740),(48608,2741),(48609,2741),(48610,2741),(48611,2741),(48612,2741),(48613,2741),(48614,2742),(48615,2742),(48616,2742),(48617,2742),(48618,2742),(48619,2742),(48620,2743),(48621,2743),(48622,2743),(48623,2743),(48624,2743),(48625,2743),(48626,2744),(48627,2744),(48628,2744),(48629,2744),(48630,2744),(48631,2744),(48632,2745),(48633,2745),(48634,2745),(48635,2745),(48636,2745),(48637,2745),(48638,2746),(48639,2746),(48640,2746),(48641,2746),(48642,2746),(48643,2746),(48644,2747),(48645,2747),(48646,2747),(48647,2747),(48648,2747),(48649,2747),(48650,2748),(48651,2748),(48652,2748),(48653,2748),(48654,2748),(48655,2748),(48656,2749),(48657,2749),(48658,2749),(48659,2749),(48660,2749),(48661,2749),(48662,2750),(48663,2750),(48664,2750),(48665,2750),(48666,2750),(48667,2750),(48668,2751),(48669,2751),(48670,2751),(48671,2751),(48672,2751),(48673,2751),(48674,2752),(48675,2752),(48676,2752),(48677,2752),(48678,2752),(48679,2752),(48680,2753),(48681,2753),(48682,2753),(48683,2753),(48684,2753),(48685,2753),(48686,2754),(48687,2754),(48688,2754),(48689,2754),(48690,2754),(48691,2754),(48692,2755),(48693,2755),(48694,2755),(48695,2755),(48696,2755),(48697,2755),(48698,2756),(48699,2756),(48700,2756),(48701,2756),(48702,2756),(48703,2756),(48704,2757),(48705,2757),(48706,2757),(48707,2757),(48708,2757),(48709,2757),(48710,2758),(48711,2758),(48712,2758),(48713,2758),(48714,2758),(48715,2758),(48716,2759),(48717,2759),(48718,2759),(48719,2759),(48720,2759),(48721,2759),(48722,2760),(48723,2760),(48724,2760),(48725,2760),(48726,2760),(48727,2760),(48728,2761),(48729,2761),(48730,2761),(48731,2761),(48732,2761),(48733,2761),(48734,2762),(48735,2762),(48736,2762),(48737,2762),(48738,2762),(48739,2762),(48740,2763),(48741,2763),(48742,2763),(48743,2763),(48744,2763),(48745,2763),(48746,2764),(48747,2764),(48748,2764),(48749,2764),(48750,2764),(48751,2764),(48752,2765),(48753,2765),(48754,2765),(48755,2765),(48756,2765),(48757,2765),(48758,2766),(48759,2766),(48760,2766),(48761,2766),(48762,2766),(48763,2766),(48764,2767),(48765,2767),(48766,2767),(48767,2767),(48768,2767),(48769,2767),(48770,2768),(48771,2768),(48772,2768),(48773,2768),(48774,2768),(48775,2768),(48776,2769),(48777,2769),(48778,2769),(48779,2769),(48780,2769),(48781,2769),(48782,2770),(48783,2770),(48784,2770),(48785,2770),(48786,2770),(48787,2770),(48788,2771),(48789,2771),(48790,2771),(48791,2771),(48792,2771),(48793,2771),(48794,2772),(48795,2772),(48796,2772),(48797,2772),(48798,2772),(48799,2772),(48800,2773),(48801,2773),(48802,2773),(48803,2773),(48804,2773),(48805,2773),(48806,2774),(48807,2774),(48808,2774),(48809,2774),(48810,2775),(48811,2775),(48812,2775),(48813,2775),(48814,2776),(48815,2776),(48816,2776),(48817,2776),(48818,2777),(48819,2777),(48820,2777),(48821,2777),(48822,2778),(48823,2778),(48824,2778),(48825,2778),(48826,2779),(48827,2779),(48828,2779),(48829,2779),(48830,2780),(48831,2780),(48832,2780),(48833,2780),(48834,2780),(48835,2780),(48836,2781),(48837,2781),(48838,2781),(48839,2781),(48840,2781),(48841,2781),(48842,2782),(48843,2782),(48844,2782),(48845,2782),(48846,2782),(48847,2782),(48848,2783),(48849,2783),(48850,2783),(48851,2783),(48852,2784),(48853,2784),(48854,2784),(48855,2784),(48856,2785),(48857,2785),(48858,2785),(48859,2785),(48860,2786),(48861,2786),(48862,2786),(48863,2786),(48864,2787),(48865,2787),(48866,2787),(48867,2787),(48868,2788),(48869,2788),(48870,2788),(48871,2788),(48872,2789),(48873,2789),(48874,2789),(48875,2789),(48876,2790),(48877,2790),(48878,2790),(48879,2790),(48880,2791),(48881,2791),(48882,2791),(48883,2791),(48884,2792),(48885,2792),(48886,2792),(48887,2792),(48888,2793),(48889,2793),(48890,2793),(48891,2793),(48892,2793),(48893,2793),(48894,2794),(48895,2794),(48896,2794),(48897,2794),(48898,2794),(48899,2794),(48900,2795),(48901,2795),(48902,2795),(48903,2795),(48904,2795),(48905,2795),(48906,2796),(48907,2796),(48908,2796),(48909,2796),(48910,2796),(48911,2796),(48912,2797),(48913,2797),(48914,2797),(48915,2797),(48916,2797),(48917,2797),(48918,2798),(48919,2798),(48920,2798),(48921,2798),(48922,2798),(48923,2798),(48924,2799),(48925,2799),(48926,2799),(48927,2799),(48928,2799),(48929,2799),(48930,2800),(48931,2800),(48932,2800),(48933,2800),(48934,2800),(48935,2800),(48936,2801),(48937,2801),(48938,2801),(48939,2801),(48940,2801),(48941,2801),(48942,2802),(48943,2802),(48944,2802),(48945,2802),(48946,2802),(48947,2802),(48948,2803),(48949,2803),(48950,2803),(48951,2803),(48952,2803),(48953,2803),(48954,2804),(48955,2804),(48956,2804),(48957,2804),(48958,2804),(48959,2804),(48960,2805),(48961,2805),(48962,2805),(48963,2805),(48964,2805),(48965,2805),(48966,2806),(48967,2806),(48968,2806),(48969,2806),(48970,2806),(48971,2806),(48972,2807),(48973,2807),(48974,2807),(48975,2807),(48976,2807),(48977,2807),(48978,2808),(48979,2808),(48980,2808),(48981,2808),(48982,2808),(48983,2808),(48984,2809),(48985,2809),(48986,2809),(48987,2809),(48988,2809),(48989,2809),(48990,2810),(48991,2810),(48992,2810),(48993,2810),(48994,2810),(48995,2810),(48996,2811),(48997,2811),(48998,2811),(48999,2811),(49000,2811),(49001,2811),(49002,2812),(49003,2812),(49004,2812),(49005,2812),(49006,2812),(49007,2812),(49008,2813),(49009,2813),(49010,2813),(49011,2813),(49012,2813),(49013,2813),(49014,2814),(49015,2814),(49016,2814),(49017,2814),(49018,2814),(49019,2814),(49020,2815),(49021,2815),(49022,2815),(49023,2815),(49024,2815),(49025,2815),(49026,2816),(49027,2816),(49028,2816),(49029,2816),(49030,2816),(49031,2816),(49032,2817),(49033,2817),(49034,2817),(49035,2817),(49036,2817),(49037,2817),(49038,2818),(49039,2818),(49040,2818),(49041,2818),(49042,2818),(49043,2818),(49044,2819),(49045,2819),(49046,2819),(49047,2819),(49048,2819),(49049,2819),(49050,2820),(49051,2820),(49052,2820),(49053,2820),(49054,2820),(49055,2820),(49056,2821),(49057,2821),(49058,2821),(49059,2821),(49060,2821),(49061,2821),(49062,2722),(49063,2722),(49064,2723),(49065,2723),(49066,2724),(49067,2724),(49068,2725),(49069,2725),(49070,2726),(49071,2726),(49072,2727),(49073,2727),(49074,2728),(49075,2728),(49076,2729),(49077,2729),(49078,2730),(49079,2730),(49080,2731),(49081,2731),(49082,2732),(49083,2732),(49084,2733),(49085,2733),(49086,2734),(49087,2734),(49088,2735),(49089,2735),(49090,2736),(49091,2736),(49092,2737),(49093,2737),(49094,2738),(49095,2738),(49096,2739),(49097,2739),(49098,2740),(49099,2740),(49100,2741),(49101,2741),(49102,2742),(49103,2742),(49104,2743),(49105,2743),(49106,2744),(49107,2744),(49108,2745),(49109,2745),(49110,2746),(49111,2746),(49112,2747),(49113,2747),(49114,2748),(49115,2748),(49116,2749),(49117,2749),(49118,2750),(49119,2750),(49120,2751),(49121,2751),(49122,2752),(49123,2752),(49124,2753),(49125,2753),(49126,2754),(49127,2754),(49128,2755),(49129,2755),(49130,2756),(49131,2756),(49132,2757),(49133,2757),(49134,2758),(49135,2758),(49136,2759),(49137,2759),(49138,2760),(49139,2760),(49140,2760),(49141,2761),(49142,2761),(49143,2761),(49144,2762),(49145,2762),(49146,2762),(49147,2763),(49148,2763),(49149,2763),(49150,2764),(49151,2764),(49152,2764),(49153,2765),(49154,2765),(49155,2765),(49156,2766),(49157,2766),(49158,2767),(49159,2767),(49160,2768),(49161,2768),(49162,2769),(49163,2769),(49164,2770),(49165,2770),(49166,2771),(49167,2771),(49168,2772),(49169,2772),(49170,2772),(49171,2773),(49172,2773),(49173,2774),(49174,2774),(49175,2775),(49176,2775),(49177,2776),(49178,2776),(49179,2777),(49180,2777),(49181,2778),(49182,2778),(49183,2779),(49184,2779),(49185,2780),(49186,2780),(49187,2780),(49188,2781),(49189,2781),(49190,2782),(49191,2782),(49192,2783),(49193,2783),(49194,2784),(49195,2784),(49196,2785),(49197,2785),(49198,2786),(49199,2786),(49200,2787),(49201,2787),(49202,2788),(49203,2788),(49204,2789),(49205,2789),(49206,2790),(49207,2790),(49208,2791),(49209,2791),(49210,2792),(49211,2792),(49212,2793),(49213,2793),(49214,2794),(49215,2794),(49216,2795),(49217,2795),(49218,2796),(49219,2796),(49220,2797),(49221,2797),(49222,2798),(49223,2798),(49224,2799),(49225,2799),(49226,2799),(49227,2800),(49228,2800),(49229,2800),(49230,2801),(49231,2801),(49232,2801),(49233,2802),(49234,2802),(49235,2802),(49236,2803),(49237,2803),(49238,2803),(49239,2804),(49240,2804),(49241,2804),(49242,2805),(49243,2805),(49244,2805),(49245,2806),(49246,2806),(49247,2806),(49248,2807),(49249,2807),(49250,2807),(49251,2808),(49252,2808),(49253,2808),(49254,2809),(49255,2809),(49256,2809),(49257,2810),(49258,2810),(49259,2810),(49260,2811),(49261,2811),(49262,2811),(49263,2812),(49264,2812),(49265,2812),(49266,2813),(49267,2813),(49268,2813),(49269,2814),(49270,2814),(49271,2814),(49272,2815),(49273,2815),(49274,2815),(49275,2816),(49276,2816),(49277,2816),(49278,2817),(49279,2817),(49280,2817),(49281,2818),(49282,2818),(49283,2818),(49284,2819),(49285,2819),(49286,2819),(49287,2820),(49288,2820),(49289,2820),(49290,2821),(49291,2821),(49292,2722),(49293,2722),(49294,2722),(49295,2723),(49296,2723),(49297,2723),(49298,2724),(49299,2724),(49300,2724),(49301,2725),(49302,2725),(49303,2725),(49304,2726),(49305,2726),(49306,2726),(49307,2727),(49308,2727),(49309,2727),(49310,2728),(49311,2728),(49312,2728),(49313,2729),(49314,2729),(49315,2729),(49316,2730),(49317,2730),(49318,2730),(49319,2731),(49320,2731),(49321,2731),(49322,2732),(49323,2732),(49324,2732),(49325,2733),(49326,2733),(49327,2733),(49328,2734),(49329,2734),(49330,2734),(49331,2735),(49332,2735),(49333,2735),(49334,2736),(49335,2736),(49336,2736),(49337,2737),(49338,2737),(49339,2737),(49340,2738),(49341,2738),(49342,2738),(49343,2739),(49344,2739),(49345,2739),(49346,2740),(49347,2740),(49348,2740),(49349,2741),(49350,2741),(49351,2741),(49352,2742),(49353,2742),(49354,2742),(49355,2743),(49356,2743),(49357,2743),(49358,2744),(49359,2744),(49360,2744),(49361,2745),(49362,2745),(49363,2745),(49364,2746),(49365,2746),(49366,2746),(49367,2747),(49368,2747),(49369,2747),(49370,2748),(49371,2748),(49372,2748),(49373,2749),(49374,2749),(49375,2749),(49376,2750),(49377,2750),(49378,2750),(49379,2751),(49380,2751),(49381,2751),(49382,2752),(49383,2752),(49384,2752),(49385,2753),(49386,2753),(49387,2753),(49388,2754),(49389,2754),(49390,2754),(49391,2755),(49392,2755),(49393,2755),(49394,2756),(49395,2756),(49396,2756),(49397,2757),(49398,2757),(49399,2757),(49400,2758),(49401,2758),(49402,2758),(49403,2759),(49404,2759),(49405,2759),(49406,2760),(49407,2760),(49408,2760),(49409,2761),(49410,2761),(49411,2761),(49412,2762),(49413,2762),(49414,2762),(49415,2763),(49416,2763),(49417,2763),(49418,2764),(49419,2764),(49420,2764),(49421,2765),(49422,2765),(49423,2765),(49424,2766),(49425,2766),(49426,2766),(49427,2767),(49428,2767),(49429,2767),(49430,2768),(49431,2768),(49432,2768),(49433,2769),(49434,2769),(49435,2769),(49436,2770),(49437,2770),(49438,2770),(49439,2771),(49440,2771),(49441,2771),(49442,2772),(49443,2772),(49444,2772),(49445,2773),(49446,2773),(49447,2773),(49448,2774),(49449,2774),(49450,2774),(49451,2775),(49452,2775),(49453,2775),(49454,2776),(49455,2776),(49456,2776),(49457,2777),(49458,2777),(49459,2777),(49460,2778),(49461,2778),(49462,2778),(49463,2779),(49464,2779),(49465,2779),(49466,2780),(49467,2780),(49468,2780),(49469,2781),(49470,2781),(49471,2781),(49472,2782),(49473,2782),(49474,2782),(49475,2783),(49476,2783),(49477,2783),(49478,2784),(49479,2784),(49480,2784),(49481,2785),(49482,2785),(49483,2785),(49484,2786),(49485,2786),(49486,2786),(49487,2787),(49488,2787),(49489,2787),(49490,2788),(49491,2788),(49492,2788),(49493,2789),(49494,2789),(49495,2789),(49496,2790),(49497,2790),(49498,2790),(49499,2791),(49500,2791),(49501,2791),(49502,2792),(49503,2792),(49504,2792),(49505,2793),(49506,2793),(49507,2793),(49508,2794),(49509,2794),(49510,2794),(49511,2795),(49512,2795),(49513,2795),(49514,2796),(49515,2796),(49516,2796),(49517,2797),(49518,2797),(49519,2797),(49520,2798),(49521,2798),(49522,2798),(49523,2799),(49524,2799),(49525,2799),(49526,2800),(49527,2800),(49528,2800),(49529,2801),(49530,2801),(49531,2801),(49532,2802),(49533,2802),(49534,2802),(49535,2803),(49536,2803),(49537,2803),(49538,2804),(49539,2804),(49540,2804),(49541,2805),(49542,2805),(49543,2805),(49544,2806),(49545,2806),(49546,2806),(49547,2807),(49548,2807),(49549,2807),(49550,2808),(49551,2808),(49552,2808),(49553,2809),(49554,2809),(49555,2809),(49556,2810),(49557,2810),(49558,2810),(49559,2811),(49560,2811),(49561,2811),(49562,2812),(49563,2812),(49564,2812),(49565,2813),(49566,2813),(49567,2813),(49568,2814),(49569,2814),(49570,2814),(49571,2815),(49572,2815),(49573,2815),(49574,2816),(49575,2816),(49576,2816),(49577,2817),(49578,2817),(49579,2817),(49580,2818),(49581,2818),(49582,2818),(49583,2819),(49584,2819),(49585,2819),(49586,2820),(49587,2820),(49588,2820),(49589,2821),(49590,2821),(49591,2821),(49592,2722),(49593,2722),(49594,2722),(49595,2722),(49596,2723),(49597,2723),(49598,2723),(49599,2723),(49600,2724),(49601,2724),(49602,2724),(49603,2724),(49604,2725),(49605,2725),(49606,2725),(49607,2725),(49608,2726),(49609,2726),(49610,2726),(49611,2726),(49612,2727),(49613,2727),(49614,2727),(49615,2727),(49616,2728),(49617,2728),(49618,2728),(49619,2728),(49620,2729),(49621,2729),(49622,2729),(49623,2729),(49624,2730),(49625,2730),(49626,2730),(49627,2730),(49628,2731),(49629,2731),(49630,2731),(49631,2731),(49632,2732),(49633,2732),(49634,2732),(49635,2732),(49636,2733),(49637,2733),(49638,2733),(49639,2733),(49640,2734),(49641,2734),(49642,2734),(49643,2734),(49644,2735),(49645,2735),(49646,2735),(49647,2735),(49648,2736),(49649,2736),(49650,2736),(49651,2736),(49652,2737),(49653,2737),(49654,2737),(49655,2737),(49656,2738),(49657,2738),(49658,2738),(49659,2738),(49660,2739),(49661,2739),(49662,2739),(49663,2739),(49664,2740),(49665,2740),(49666,2740),(49667,2740),(49668,2741),(49669,2741),(49670,2741),(49671,2741),(49672,2742),(49673,2742),(49674,2742),(49675,2742),(49676,2743),(49677,2743),(49678,2743),(49679,2743),(49680,2744),(49681,2744),(49682,2744),(49683,2744),(49684,2745),(49685,2745),(49686,2745),(49687,2745),(49688,2746),(49689,2746),(49690,2746),(49691,2746),(49692,2747),(49693,2747),(49694,2747),(49695,2747),(49696,2748),(49697,2748),(49698,2748),(49699,2748),(49700,2749),(49701,2749),(49702,2749),(49703,2749),(49704,2750),(49705,2750),(49706,2750),(49707,2750),(49708,2751),(49709,2751),(49710,2751),(49711,2751),(49712,2752),(49713,2752),(49714,2752),(49715,2752),(49716,2753),(49717,2753),(49718,2753),(49719,2753),(49720,2754),(49721,2754),(49722,2754),(49723,2754),(49724,2755),(49725,2755),(49726,2755),(49727,2755),(49728,2756),(49729,2756),(49730,2756),(49731,2756),(49732,2757),(49733,2757),(49734,2757),(49735,2757),(49736,2758),(49737,2758),(49738,2758),(49739,2758),(49740,2759),(49741,2759),(49742,2759),(49743,2759),(49744,2760),(49745,2760),(49746,2760),(49747,2760),(49748,2761),(49749,2761),(49750,2761),(49751,2761),(49752,2762),(49753,2762),(49754,2762),(49755,2762),(49756,2763),(49757,2763),(49758,2763),(49759,2763),(49760,2764),(49761,2764),(49762,2764),(49763,2764),(49764,2765),(49765,2765),(49766,2765),(49767,2765),(49768,2766),(49769,2766),(49770,2766),(49771,2766),(49772,2767),(49773,2767),(49774,2767),(49775,2767),(49776,2768),(49777,2768),(49778,2768),(49779,2768),(49780,2769),(49781,2769),(49782,2769),(49783,2769),(49784,2770),(49785,2770),(49786,2770),(49787,2770),(49788,2771),(49789,2771),(49790,2771),(49791,2771),(49792,2772),(49793,2772),(49794,2772),(49795,2772),(49796,2773),(49797,2773),(49798,2773),(49799,2773),(49800,2774),(49801,2774),(49802,2774),(49803,2774),(49804,2775),(49805,2775),(49806,2775),(49807,2775),(49808,2776),(49809,2776),(49810,2776),(49811,2776),(49812,2777),(49813,2777),(49814,2777),(49815,2777),(49816,2778),(49817,2778),(49818,2778),(49819,2778),(49820,2779),(49821,2779),(49822,2779),(49823,2779),(49824,2780),(49825,2780),(49826,2780),(49827,2780),(49828,2781),(49829,2781),(49830,2781),(49831,2781),(49832,2782),(49833,2782),(49834,2782),(49835,2782),(49836,2783),(49837,2783),(49838,2783),(49839,2783),(49840,2784),(49841,2784),(49842,2784),(49843,2784),(49844,2785),(49845,2785),(49846,2785),(49847,2785),(49848,2786),(49849,2786),(49850,2786),(49851,2786),(49852,2787),(49853,2787),(49854,2787),(49855,2787),(49856,2788),(49857,2788),(49858,2788),(49859,2788),(49860,2789),(49861,2789),(49862,2789),(49863,2789),(49864,2790),(49865,2790),(49866,2790),(49867,2790),(49868,2791),(49869,2791),(49870,2791),(49871,2791),(49872,2792),(49873,2792),(49874,2792),(49875,2792),(49876,2793),(49877,2793),(49878,2793),(49879,2793),(49880,2794),(49881,2794),(49882,2794),(49883,2794),(49884,2795),(49885,2795),(49886,2795),(49887,2795),(49888,2796),(49889,2796),(49890,2796),(49891,2796),(49892,2797),(49893,2797),(49894,2797),(49895,2797),(49896,2798),(49897,2798),(49898,2798),(49899,2798),(49900,2799),(49901,2799),(49902,2799),(49903,2799),(49904,2800),(49905,2800),(49906,2800),(49907,2800),(49908,2801),(49909,2801),(49910,2801),(49911,2801),(49912,2802),(49913,2802),(49914,2802),(49915,2802),(49916,2803),(49917,2803),(49918,2803),(49919,2803),(49920,2804),(49921,2804),(49922,2804),(49923,2804),(49924,2805),(49925,2805),(49926,2805),(49927,2805),(49928,2806),(49929,2806),(49930,2806),(49931,2806),(49932,2807),(49933,2807),(49934,2807),(49935,2807),(49936,2808),(49937,2808),(49938,2808),(49939,2808),(49940,2809),(49941,2809),(49942,2809),(49943,2809),(49944,2810),(49945,2810),(49946,2810),(49947,2810),(49948,2811),(49949,2811),(49950,2811),(49951,2811),(49952,2812),(49953,2812),(49954,2812),(49955,2812),(49956,2813),(49957,2813),(49958,2813),(49959,2813),(49960,2814),(49961,2814),(49962,2814),(49963,2814),(49964,2815),(49965,2815),(49966,2815),(49967,2815),(49968,2816),(49969,2816),(49970,2816),(49971,2816),(49972,2817),(49973,2817),(49974,2817),(49975,2817),(49976,2818),(49977,2818),(49978,2818),(49979,2818),(49980,2819),(49981,2819),(49982,2819),(49983,2819),(49984,2820),(49985,2820),(49986,2820),(49987,2820),(49988,2821),(49989,2821),(49990,2821),(49991,2821),(49992,2822),(49993,2823),(49994,2824),(49995,2825),(49996,2826),(49997,2827),(49998,2828),(49999,2829),(50000,2830),(50001,2831),(50002,2832),(50003,2833),(50004,2834),(50005,2835),(50006,2836),(50007,2837),(50008,2838),(50009,2839),(50010,2840),(50011,2841),(50012,2842),(50013,2843),(50014,2844),(50015,2845),(50016,2846),(50017,2847),(50018,2848),(50019,2849),(50020,2850),(50021,2851),(50022,2852),(50023,2853),(50024,2854),(50025,2855),(50026,2856),(50027,2857),(50028,2858),(50029,2859),(50030,2860),(50031,2861),(50032,2862),(50033,2863),(50034,2864),(50035,2865),(50036,2866),(50037,2867),(50038,2868),(50039,2869),(50040,2870),(50041,2871),(50042,2872),(50043,2873),(50044,2874),(50045,2875),(50046,2876),(50047,2877),(50048,2878),(50049,2879),(50050,2880),(50051,2881),(50052,2882),(50053,2883),(50054,2884),(50055,2885),(50056,2886),(50057,2887),(50058,2888),(50059,2889),(50060,2890),(50061,2891),(50062,2892),(50063,2893),(50064,2894),(50065,2895),(50066,2896),(50067,2897),(50068,2898),(50069,2899),(50070,2900),(50071,2901),(50072,2902),(50073,2903),(50074,2904),(50075,2905),(50076,2906),(50077,2907),(50078,2908),(50079,2909),(50080,2910),(50081,2911),(50082,2912),(50083,2913),(50084,2914),(50085,2915),(50086,2916),(50087,2917),(50088,2918),(50089,2919),(50090,2920),(50091,2921),(50092,2822),(50093,2822),(50094,2822),(50095,2822),(50096,2823),(50097,2823),(50098,2823),(50099,2823),(50100,2824),(50101,2824),(50102,2824),(50103,2824),(50104,2825),(50105,2825),(50106,2825),(50107,2825),(50108,2826),(50109,2826),(50110,2826),(50111,2826),(50112,2827),(50113,2827),(50114,2827),(50115,2827),(50116,2828),(50117,2828),(50118,2828),(50119,2828),(50120,2828),(50121,2828),(50122,2829),(50123,2829),(50124,2829),(50125,2829),(50126,2829),(50127,2829),(50128,2830),(50129,2830),(50130,2830),(50131,2830),(50132,2830),(50133,2830),(50134,2831),(50135,2831),(50136,2831),(50137,2831),(50138,2832),(50139,2832),(50140,2832),(50141,2832),(50142,2833),(50143,2833),(50144,2833),(50145,2833),(50146,2833),(50147,2833),(50148,2834),(50149,2834),(50150,2834),(50151,2834),(50152,2834),(50153,2834),(50154,2835),(50155,2835),(50156,2835),(50157,2835),(50158,2835),(50159,2835),(50160,2836),(50161,2836),(50162,2836),(50163,2836),(50164,2836),(50165,2836),(50166,2837),(50167,2837),(50168,2837),(50169,2837),(50170,2837),(50171,2837),(50172,2838),(50173,2838),(50174,2838),(50175,2838),(50176,2838),(50177,2838),(50178,2839),(50179,2839),(50180,2839),(50181,2839),(50182,2839),(50183,2839),(50184,2840),(50185,2840),(50186,2840),(50187,2840),(50188,2840),(50189,2840),(50190,2841),(50191,2841),(50192,2841),(50193,2841),(50194,2841),(50195,2841),(50196,2842),(50197,2842),(50198,2842),(50199,2842),(50200,2842),(50201,2842),(50202,2843),(50203,2843),(50204,2843),(50205,2843),(50206,2843),(50207,2843),(50208,2844),(50209,2844),(50210,2844),(50211,2844),(50212,2845),(50213,2845),(50214,2845),(50215,2845),(50216,2846),(50217,2846),(50218,2846),(50219,2846),(50220,2847),(50221,2847),(50222,2847),(50223,2847),(50224,2848),(50225,2848),(50226,2848),(50227,2848),(50228,2849),(50229,2849),(50230,2849),(50231,2849),(50232,2850),(50233,2850),(50234,2850),(50235,2850),(50236,2851),(50237,2851),(50238,2851),(50239,2851),(50240,2852),(50241,2852),(50242,2852),(50243,2852),(50244,2852),(50245,2852),(50246,2853),(50247,2853),(50248,2853),(50249,2853),(50250,2853),(50251,2853),(50252,2854),(50253,2854),(50254,2854),(50255,2854),(50256,2854),(50257,2854),(50258,2855),(50259,2855),(50260,2855),(50261,2855),(50262,2855),(50263,2855),(50264,2856),(50265,2856),(50266,2856),(50267,2856),(50268,2856),(50269,2856),(50270,2857),(50271,2857),(50272,2857),(50273,2857),(50274,2857),(50275,2857),(50276,2858),(50277,2858),(50278,2858),(50279,2858),(50280,2858),(50281,2858),(50282,2859),(50283,2859),(50284,2859),(50285,2859),(50286,2859),(50287,2859),(50288,2860),(50289,2860),(50290,2860),(50291,2860),(50292,2860),(50293,2860),(50294,2861),(50295,2861),(50296,2861),(50297,2861),(50298,2861),(50299,2861),(50300,2862),(50301,2862),(50302,2862),(50303,2862),(50304,2862),(50305,2862),(50306,2863),(50307,2863),(50308,2863),(50309,2863),(50310,2863),(50311,2863),(50312,2864),(50313,2864),(50314,2864),(50315,2864),(50316,2864),(50317,2864),(50318,2865),(50319,2865),(50320,2865),(50321,2865),(50322,2865),(50323,2865),(50324,2866),(50325,2866),(50326,2866),(50327,2866),(50328,2866),(50329,2866),(50330,2867),(50331,2867),(50332,2867),(50333,2867),(50334,2867),(50335,2867),(50336,2868),(50337,2868),(50338,2868),(50339,2868),(50340,2868),(50341,2868),(50342,2869),(50343,2869),(50344,2869),(50345,2869),(50346,2869),(50347,2869),(50348,2870),(50349,2870),(50350,2870),(50351,2870),(50352,2870),(50353,2870),(50354,2871),(50355,2871),(50356,2871),(50357,2871),(50358,2871),(50359,2871),(50360,2872),(50361,2872),(50362,2872),(50363,2872),(50364,2872),(50365,2872),(50366,2873),(50367,2873),(50368,2873),(50369,2873),(50370,2873),(50371,2873),(50372,2874),(50373,2874),(50374,2874),(50375,2874),(50376,2874),(50377,2874),(50378,2875),(50379,2875),(50380,2875),(50381,2875),(50382,2875),(50383,2875),(50384,2876),(50385,2876),(50386,2876),(50387,2876),(50388,2876),(50389,2876),(50390,2877),(50391,2877),(50392,2877),(50393,2877),(50394,2877),(50395,2877),(50396,2878),(50397,2878),(50398,2878),(50399,2878),(50400,2878),(50401,2878),(50402,2879),(50403,2879),(50404,2879),(50405,2879),(50406,2879),(50407,2879),(50408,2880),(50409,2880),(50410,2880),(50411,2880),(50412,2880),(50413,2880),(50414,2881),(50415,2881),(50416,2881),(50417,2881),(50418,2881),(50419,2881),(50420,2882),(50421,2882),(50422,2882),(50423,2882),(50424,2882),(50425,2882),(50426,2883),(50427,2883),(50428,2883),(50429,2883),(50430,2883),(50431,2883),(50432,2884),(50433,2884),(50434,2884),(50435,2884),(50436,2884),(50437,2884),(50438,2885),(50439,2885),(50440,2885),(50441,2885),(50442,2885),(50443,2885),(50444,2886),(50445,2886),(50446,2886),(50447,2886),(50448,2886),(50449,2886),(50450,2887),(50451,2887),(50452,2887),(50453,2887),(50454,2887),(50455,2887),(50456,2888),(50457,2888),(50458,2888),(50459,2888),(50460,2888),(50461,2888),(50462,2889),(50463,2889),(50464,2889),(50465,2889),(50466,2889),(50467,2889),(50468,2890),(50469,2890),(50470,2890),(50471,2890),(50472,2890),(50473,2890),(50474,2891),(50475,2891),(50476,2891),(50477,2891),(50478,2891),(50479,2891),(50480,2892),(50481,2892),(50482,2892),(50483,2892),(50484,2892),(50485,2892),(50486,2893),(50487,2893),(50488,2893),(50489,2893),(50490,2893),(50491,2893),(50492,2894),(50493,2894),(50494,2894),(50495,2894),(50496,2894),(50497,2894),(50498,2895),(50499,2895),(50500,2895),(50501,2895),(50502,2895),(50503,2895),(50504,2896),(50505,2896),(50506,2896),(50507,2896),(50508,2896),(50509,2896),(50510,2897),(50511,2897),(50512,2897),(50513,2897),(50514,2897),(50515,2897),(50516,2898),(50517,2898),(50518,2898),(50519,2898),(50520,2898),(50521,2898),(50522,2899),(50523,2899),(50524,2899),(50525,2899),(50526,2899),(50527,2899),(50528,2900),(50529,2900),(50530,2900),(50531,2900),(50532,2900),(50533,2900),(50534,2901),(50535,2901),(50536,2901),(50537,2901),(50538,2901),(50539,2901),(50540,2902),(50541,2902),(50542,2902),(50543,2902),(50544,2902),(50545,2902),(50546,2903),(50547,2903),(50548,2903),(50549,2903),(50550,2903),(50551,2903),(50552,2904),(50553,2904),(50554,2904),(50555,2904),(50556,2904),(50557,2904),(50558,2905),(50559,2905),(50560,2905),(50561,2905),(50562,2905),(50563,2905),(50564,2906),(50565,2906),(50566,2906),(50567,2906),(50568,2906),(50569,2906),(50570,2907),(50571,2907),(50572,2907),(50573,2907),(50574,2907),(50575,2907),(50576,2908),(50577,2908),(50578,2908),(50579,2908),(50580,2908),(50581,2908),(50582,2909),(50583,2909),(50584,2909),(50585,2909),(50586,2909),(50587,2909),(50588,2910),(50589,2910),(50590,2910),(50591,2910),(50592,2910),(50593,2910),(50594,2911),(50595,2911),(50596,2911),(50597,2911),(50598,2911),(50599,2911),(50600,2912),(50601,2912),(50602,2912),(50603,2912),(50604,2912),(50605,2912),(50606,2913),(50607,2913),(50608,2913),(50609,2913),(50610,2914),(50611,2914),(50612,2914),(50613,2914),(50614,2915),(50615,2915),(50616,2915),(50617,2915),(50618,2916),(50619,2916),(50620,2916),(50621,2916),(50622,2917),(50623,2917),(50624,2917),(50625,2917),(50626,2917),(50627,2917),(50628,2918),(50629,2918),(50630,2918),(50631,2918),(50632,2918),(50633,2918),(50634,2919),(50635,2919),(50636,2919),(50637,2919),(50638,2919),(50639,2919),(50640,2920),(50641,2920),(50642,2920),(50643,2920),(50644,2920),(50645,2920),(50646,2921),(50647,2921),(50648,2921),(50649,2921),(50650,2921),(50651,2921),(50652,2822),(50653,2822),(50654,2823),(50655,2823),(50656,2824),(50657,2824),(50658,2825),(50659,2825),(50660,2826),(50661,2826),(50662,2827),(50663,2827),(50664,2828),(50665,2828),(50666,2829),(50667,2829),(50668,2830),(50669,2830),(50670,2831),(50671,2831),(50672,2832),(50673,2832),(50674,2833),(50675,2833),(50676,2834),(50677,2834),(50678,2835),(50679,2835),(50680,2836),(50681,2836),(50682,2837),(50683,2837),(50684,2838),(50685,2838),(50686,2839),(50687,2839),(50688,2840),(50689,2840),(50690,2841),(50691,2841),(50692,2842),(50693,2842),(50694,2843),(50695,2843),(50696,2844),(50697,2844),(50698,2845),(50699,2845),(50700,2846),(50701,2846),(50702,2847),(50703,2847),(50704,2848),(50705,2848),(50706,2849),(50707,2849),(50708,2850),(50709,2850),(50710,2851),(50711,2851),(50712,2852),(50713,2852),(50714,2852),(50715,2853),(50716,2853),(50717,2853),(50718,2854),(50719,2854),(50720,2854),(50721,2855),(50722,2855),(50723,2855),(50724,2856),(50725,2856),(50726,2856),(50727,2857),(50728,2857),(50729,2858),(50730,2858),(50731,2859),(50732,2859),(50733,2859),(50734,2860),(50735,2860),(50736,2860),(50737,2861),(50738,2861),(50739,2861),(50740,2862),(50741,2862),(50742,2862),(50743,2863),(50744,2863),(50745,2864),(50746,2864),(50747,2864),(50748,2865),(50749,2865),(50750,2865),(50751,2866),(50752,2866),(50753,2867),(50754,2867),(50755,2868),(50756,2868),(50757,2868),(50758,2869),(50759,2869),(50760,2869),(50761,2870),(50762,2870),(50763,2870),(50764,2871),(50765,2871),(50766,2871),(50767,2872),(50768,2872),(50769,2872),(50770,2873),(50771,2873),(50772,2873),(50773,2874),(50774,2874),(50775,2874),(50776,2875),(50777,2875),(50778,2875),(50779,2876),(50780,2876),(50781,2876),(50782,2877),(50783,2877),(50784,2877),(50785,2878),(50786,2878),(50787,2878),(50788,2879),(50789,2879),(50790,2879),(50791,2880),(50792,2880),(50793,2880),(50794,2881),(50795,2881),(50796,2881),(50797,2882),(50798,2882),(50799,2882),(50800,2883),(50801,2883),(50802,2883),(50803,2884),(50804,2884),(50805,2884),(50806,2885),(50807,2885),(50808,2885),(50809,2886),(50810,2886),(50811,2886),(50812,2887),(50813,2887),(50814,2887),(50815,2888),(50816,2888),(50817,2888),(50818,2889),(50819,2889),(50820,2889),(50821,2890),(50822,2890),(50823,2891),(50824,2891),(50825,2892),(50826,2892),(50827,2892),(50828,2893),(50829,2893),(50830,2893),(50831,2894),(50832,2894),(50833,2895),(50834,2895),(50835,2896),(50836,2896),(50837,2897),(50838,2897),(50839,2898),(50840,2898),(50841,2899),(50842,2899),(50843,2900),(50844,2900),(50845,2900),(50846,2901),(50847,2901),(50848,2901),(50849,2902),(50850,2902),(50851,2902),(50852,2903),(50853,2903),(50854,2903),(50855,2904),(50856,2904),(50857,2905),(50858,2905),(50859,2905),(50860,2906),(50861,2906),(50862,2906),(50863,2907),(50864,2907),(50865,2907),(50866,2908),(50867,2908),(50868,2908),(50869,2909),(50870,2909),(50871,2909),(50872,2910),(50873,2910),(50874,2910),(50875,2911),(50876,2911),(50877,2911),(50878,2912),(50879,2912),(50880,2912),(50881,2913),(50882,2913),(50883,2914),(50884,2914),(50885,2915),(50886,2915),(50887,2916),(50888,2916),(50889,2917),(50890,2917),(50891,2918),(50892,2918),(50893,2919),(50894,2919),(50895,2920),(50896,2920),(50897,2921),(50898,2921),(50899,2822),(50900,2822),(50901,2822),(50902,2823),(50903,2823),(50904,2823),(50905,2824),(50906,2824),(50907,2824),(50908,2825),(50909,2825),(50910,2825),(50911,2826),(50912,2826),(50913,2826),(50914,2827),(50915,2827),(50916,2827),(50917,2828),(50918,2828),(50919,2828),(50920,2829),(50921,2829),(50922,2829),(50923,2830),(50924,2830),(50925,2830),(50926,2831),(50927,2831),(50928,2831),(50929,2832),(50930,2832),(50931,2832),(50932,2833),(50933,2833),(50934,2833),(50935,2834),(50936,2834),(50937,2834),(50938,2835),(50939,2835),(50940,2835),(50941,2836),(50942,2836),(50943,2836),(50944,2837),(50945,2837),(50946,2837),(50947,2838),(50948,2838),(50949,2838),(50950,2839),(50951,2839),(50952,2839),(50953,2840),(50954,2840),(50955,2840),(50956,2841),(50957,2841),(50958,2841),(50959,2842),(50960,2842),(50961,2842),(50962,2843),(50963,2843),(50964,2843),(50965,2844),(50966,2844),(50967,2844),(50968,2845),(50969,2845),(50970,2845),(50971,2846),(50972,2846),(50973,2846),(50974,2847),(50975,2847),(50976,2847),(50977,2848),(50978,2848),(50979,2848),(50980,2849),(50981,2849),(50982,2849),(50983,2850),(50984,2850),(50985,2850),(50986,2851),(50987,2851),(50988,2851),(50989,2852),(50990,2852),(50991,2852),(50992,2853),(50993,2853),(50994,2853),(50995,2854),(50996,2854),(50997,2854),(50998,2855),(50999,2855),(51000,2855),(51001,2856),(51002,2856),(51003,2856),(51004,2857),(51005,2857),(51006,2857),(51007,2858),(51008,2858),(51009,2858),(51010,2859),(51011,2859),(51012,2859),(51013,2860),(51014,2860),(51015,2860),(51016,2861),(51017,2861),(51018,2861),(51019,2862),(51020,2862),(51021,2862),(51022,2863),(51023,2863),(51024,2863),(51025,2864),(51026,2864),(51027,2864),(51028,2865),(51029,2865),(51030,2865),(51031,2866),(51032,2866),(51033,2866),(51034,2867),(51035,2867),(51036,2867),(51037,2868),(51038,2868),(51039,2868),(51040,2869),(51041,2869),(51042,2869),(51043,2870),(51044,2870),(51045,2870),(51046,2871),(51047,2871),(51048,2871),(51049,2872),(51050,2872),(51051,2872),(51052,2873),(51053,2873),(51054,2873),(51055,2874),(51056,2874),(51057,2874),(51058,2875),(51059,2875),(51060,2875),(51061,2876),(51062,2876),(51063,2876),(51064,2877),(51065,2877),(51066,2877),(51067,2878),(51068,2878),(51069,2878),(51070,2879),(51071,2879),(51072,2879),(51073,2880),(51074,2880),(51075,2880),(51076,2881),(51077,2881),(51078,2881),(51079,2882),(51080,2882),(51081,2882),(51082,2883),(51083,2883),(51084,2883),(51085,2884),(51086,2884),(51087,2884),(51088,2885),(51089,2885),(51090,2885),(51091,2886),(51092,2886),(51093,2886),(51094,2887),(51095,2887),(51096,2887),(51097,2888),(51098,2888),(51099,2888),(51100,2889),(51101,2889),(51102,2889),(51103,2890),(51104,2890),(51105,2890),(51106,2891),(51107,2891),(51108,2891),(51109,2892),(51110,2892),(51111,2892),(51112,2893),(51113,2893),(51114,2893),(51115,2894),(51116,2894),(51117,2894),(51118,2895),(51119,2895),(51120,2895),(51121,2896),(51122,2896),(51123,2896),(51124,2897),(51125,2897),(51126,2897),(51127,2898),(51128,2898),(51129,2898),(51130,2899),(51131,2899),(51132,2899),(51133,2900),(51134,2900),(51135,2900),(51136,2901),(51137,2901),(51138,2901),(51139,2902),(51140,2902),(51141,2902),(51142,2903),(51143,2903),(51144,2903),(51145,2904),(51146,2904),(51147,2904),(51148,2905),(51149,2905),(51150,2905),(51151,2906),(51152,2906),(51153,2906),(51154,2907),(51155,2907),(51156,2907),(51157,2908),(51158,2908),(51159,2908),(51160,2909),(51161,2909),(51162,2909),(51163,2910),(51164,2910),(51165,2910),(51166,2911),(51167,2911),(51168,2911),(51169,2912),(51170,2912),(51171,2912),(51172,2913),(51173,2913),(51174,2913),(51175,2914),(51176,2914),(51177,2914),(51178,2915),(51179,2915),(51180,2915),(51181,2916),(51182,2916),(51183,2916),(51184,2917),(51185,2917),(51186,2917),(51187,2918),(51188,2918),(51189,2918),(51190,2919),(51191,2919),(51192,2919),(51193,2920),(51194,2920),(51195,2920),(51196,2921),(51197,2921),(51198,2921),(51199,2822),(51200,2822),(51201,2822),(51202,2822),(51203,2823),(51204,2823),(51205,2823),(51206,2823),(51207,2824),(51208,2824),(51209,2824),(51210,2824),(51211,2825),(51212,2825),(51213,2825),(51214,2825),(51215,2826),(51216,2826),(51217,2826),(51218,2826),(51219,2827),(51220,2827),(51221,2827),(51222,2827),(51223,2828),(51224,2828),(51225,2828),(51226,2828),(51227,2829),(51228,2829),(51229,2829),(51230,2829),(51231,2830),(51232,2830),(51233,2830),(51234,2830),(51235,2831),(51236,2831),(51237,2831),(51238,2831),(51239,2832),(51240,2832),(51241,2832),(51242,2832),(51243,2833),(51244,2833),(51245,2833),(51246,2833),(51247,2834),(51248,2834),(51249,2834),(51250,2834),(51251,2835),(51252,2835),(51253,2835),(51254,2835),(51255,2836),(51256,2836),(51257,2836),(51258,2836),(51259,2837),(51260,2837),(51261,2837),(51262,2837),(51263,2838),(51264,2838),(51265,2838),(51266,2838),(51267,2839),(51268,2839),(51269,2839),(51270,2839),(51271,2840),(51272,2840),(51273,2840),(51274,2840),(51275,2841),(51276,2841),(51277,2841),(51278,2841),(51279,2842),(51280,2842),(51281,2842),(51282,2842),(51283,2843),(51284,2843),(51285,2843),(51286,2843),(51287,2844),(51288,2844),(51289,2844),(51290,2844),(51291,2845),(51292,2845),(51293,2845),(51294,2845),(51295,2846),(51296,2846),(51297,2846),(51298,2846),(51299,2847),(51300,2847),(51301,2847),(51302,2847),(51303,2848),(51304,2848),(51305,2848),(51306,2848),(51307,2849),(51308,2849),(51309,2849),(51310,2849),(51311,2850),(51312,2850),(51313,2850),(51314,2850),(51315,2851),(51316,2851),(51317,2851),(51318,2851),(51319,2852),(51320,2852),(51321,2852),(51322,2852),(51323,2853),(51324,2853),(51325,2853),(51326,2853),(51327,2854),(51328,2854),(51329,2854),(51330,2854),(51331,2855),(51332,2855),(51333,2855),(51334,2855),(51335,2856),(51336,2856),(51337,2856),(51338,2856),(51339,2857),(51340,2857),(51341,2857),(51342,2857),(51343,2858),(51344,2858),(51345,2858),(51346,2858),(51347,2859),(51348,2859),(51349,2859),(51350,2859),(51351,2860),(51352,2860),(51353,2860),(51354,2860),(51355,2861),(51356,2861),(51357,2861),(51358,2861),(51359,2862),(51360,2862),(51361,2862),(51362,2862),(51363,2863),(51364,2863),(51365,2863),(51366,2863),(51367,2864),(51368,2864),(51369,2864),(51370,2864),(51371,2865),(51372,2865),(51373,2865),(51374,2865),(51375,2866),(51376,2866),(51377,2866),(51378,2866),(51379,2867),(51380,2867),(51381,2867),(51382,2867),(51383,2868),(51384,2868),(51385,2868),(51386,2868),(51387,2869),(51388,2869),(51389,2869),(51390,2869),(51391,2870),(51392,2870),(51393,2870),(51394,2870),(51395,2871),(51396,2871),(51397,2871),(51398,2871),(51399,2872),(51400,2872),(51401,2872),(51402,2872),(51403,2873),(51404,2873),(51405,2873),(51406,2873),(51407,2874),(51408,2874),(51409,2874),(51410,2874),(51411,2875),(51412,2875),(51413,2875),(51414,2875),(51415,2876),(51416,2876),(51417,2876),(51418,2876),(51419,2877),(51420,2877),(51421,2877),(51422,2877),(51423,2878),(51424,2878),(51425,2878),(51426,2878),(51427,2879),(51428,2879),(51429,2879),(51430,2879),(51431,2880),(51432,2880),(51433,2880),(51434,2880),(51435,2881),(51436,2881),(51437,2881),(51438,2881),(51439,2882),(51440,2882),(51441,2882),(51442,2882),(51443,2883),(51444,2883),(51445,2883),(51446,2883),(51447,2884),(51448,2884),(51449,2884),(51450,2884),(51451,2885),(51452,2885),(51453,2885),(51454,2885),(51455,2886),(51456,2886),(51457,2886),(51458,2886),(51459,2887),(51460,2887),(51461,2887),(51462,2887),(51463,2888),(51464,2888),(51465,2888),(51466,2888),(51467,2889),(51468,2889),(51469,2889),(51470,2889),(51471,2890),(51472,2890),(51473,2890),(51474,2890),(51475,2891),(51476,2891),(51477,2891),(51478,2891),(51479,2892),(51480,2892),(51481,2892),(51482,2892),(51483,2893),(51484,2893),(51485,2893),(51486,2893),(51487,2894),(51488,2894),(51489,2894),(51490,2894),(51491,2895),(51492,2895),(51493,2895),(51494,2895),(51495,2896),(51496,2896),(51497,2896),(51498,2896),(51499,2897),(51500,2897),(51501,2897),(51502,2897),(51503,2898),(51504,2898),(51505,2898),(51506,2898),(51507,2899),(51508,2899),(51509,2899),(51510,2899),(51511,2900),(51512,2900),(51513,2900),(51514,2900),(51515,2901),(51516,2901),(51517,2901),(51518,2901),(51519,2902),(51520,2902),(51521,2902),(51522,2902),(51523,2903),(51524,2903),(51525,2903),(51526,2903),(51527,2904),(51528,2904),(51529,2904),(51530,2904),(51531,2905),(51532,2905),(51533,2905),(51534,2905),(51535,2906),(51536,2906),(51537,2906),(51538,2906),(51539,2907),(51540,2907),(51541,2907),(51542,2907),(51543,2908),(51544,2908),(51545,2908),(51546,2908),(51547,2909),(51548,2909),(51549,2909),(51550,2909),(51551,2910),(51552,2910),(51553,2910),(51554,2910),(51555,2911),(51556,2911),(51557,2911),(51558,2911),(51559,2912),(51560,2912),(51561,2912),(51562,2912),(51563,2913),(51564,2913),(51565,2913),(51566,2913),(51567,2914),(51568,2914),(51569,2914),(51570,2914),(51571,2915),(51572,2915),(51573,2915),(51574,2915),(51575,2916),(51576,2916),(51577,2916),(51578,2916),(51579,2917),(51580,2917),(51581,2917),(51582,2917),(51583,2918),(51584,2918),(51585,2918),(51586,2918),(51587,2919),(51588,2919),(51589,2919),(51590,2919),(51591,2920),(51592,2920),(51593,2920),(51594,2920),(51595,2921),(51596,2921),(51597,2921),(51598,2921),(51599,2922),(51600,2923),(51601,2924),(51602,2925),(51603,2926),(51604,2927),(51605,2928),(51606,2929),(51607,2930),(51608,2931),(51609,2932),(51610,2933),(51611,2934),(51612,2935),(51613,2936),(51614,2937),(51615,2938),(51616,2939),(51617,2940),(51618,2941),(51619,2942),(51620,2943),(51621,2944),(51622,2945),(51623,2946),(51624,2947),(51625,2948),(51626,2949),(51627,2950),(51628,2951),(51629,2952),(51630,2953),(51631,2954),(51632,2955),(51633,2956),(51634,2957),(51635,2958),(51636,2959),(51637,2960),(51638,2961),(51639,2962),(51640,2963),(51641,2964),(51642,2965),(51643,2966),(51644,2967),(51645,2968),(51646,2969),(51647,2970),(51648,2971),(51649,2972),(51650,2973),(51651,2974),(51652,2975),(51653,2976),(51654,2977),(51655,2978),(51656,2979),(51657,2980),(51658,2981),(51659,2982),(51660,2983),(51661,2984),(51662,2985),(51663,2986),(51664,2987),(51665,2988),(51666,2989),(51667,2990),(51668,2991),(51669,2992),(51670,2993),(51671,2994),(51672,2995),(51673,2996),(51674,2997),(51675,2998),(51676,2999),(51677,3000),(51678,3001),(51679,3002),(51680,3003),(51681,3004),(51682,3005),(51683,3006),(51684,3007),(51685,3008),(51686,3009),(51687,3010),(51688,3011),(51689,3012),(51690,3013),(51691,3014),(51692,3015),(51693,3016),(51694,3017),(51695,3018),(51696,3019),(51697,3020),(51698,3021),(51699,2922),(51700,2922),(51701,2922),(51702,2922),(51703,2922),(51704,2922),(51705,2923),(51706,2923),(51707,2923),(51708,2923),(51709,2923),(51710,2923),(51711,2924),(51712,2924),(51713,2924),(51714,2924),(51715,2924),(51716,2924),(51717,2925),(51718,2925),(51719,2925),(51720,2925),(51721,2925),(51722,2925),(51723,2926),(51724,2926),(51725,2926),(51726,2926),(51727,2926),(51728,2926),(51729,2927),(51730,2927),(51731,2927),(51732,2927),(51733,2927),(51734,2927),(51735,2928),(51736,2928),(51737,2928),(51738,2928),(51739,2928),(51740,2928),(51741,2929),(51742,2929),(51743,2929),(51744,2929),(51745,2929),(51746,2929),(51747,2930),(51748,2930),(51749,2930),(51750,2930),(51751,2930),(51752,2930),(51753,2931),(51754,2931),(51755,2931),(51756,2931),(51757,2931),(51758,2931),(51759,2932),(51760,2932),(51761,2932),(51762,2932),(51763,2932),(51764,2932),(51765,2933),(51766,2933),(51767,2933),(51768,2933),(51769,2933),(51770,2933),(51771,2934),(51772,2934),(51773,2934),(51774,2934),(51775,2934),(51776,2934),(51777,2935),(51778,2935),(51779,2935),(51780,2935),(51781,2935),(51782,2935),(51783,2936),(51784,2936),(51785,2936),(51786,2936),(51787,2936),(51788,2936),(51789,2937),(51790,2937),(51791,2937),(51792,2937),(51793,2937),(51794,2937),(51795,2938),(51796,2938),(51797,2938),(51798,2938),(51799,2938),(51800,2938),(51801,2939),(51802,2939),(51803,2939),(51804,2939),(51805,2939),(51806,2939),(51807,2940),(51808,2940),(51809,2940),(51810,2940),(51811,2940),(51812,2940),(51813,2941),(51814,2941),(51815,2941),(51816,2941),(51817,2941),(51818,2941),(51819,2942),(51820,2942),(51821,2942),(51822,2942),(51823,2942),(51824,2942),(51825,2943),(51826,2943),(51827,2943),(51828,2943),(51829,2943),(51830,2943),(51831,2944),(51832,2944),(51833,2944),(51834,2944),(51835,2944),(51836,2944),(51837,2945),(51838,2945),(51839,2945),(51840,2945),(51841,2945),(51842,2945),(51843,2946),(51844,2946),(51845,2946),(51846,2946),(51847,2946),(51848,2946),(51849,2947),(51850,2947),(51851,2947),(51852,2947),(51853,2947),(51854,2947),(51855,2948),(51856,2948),(51857,2948),(51858,2948),(51859,2948),(51860,2948),(51861,2949),(51862,2949),(51863,2949),(51864,2949),(51865,2949),(51866,2949),(51867,2950),(51868,2950),(51869,2950),(51870,2950),(51871,2950),(51872,2950),(51873,2951),(51874,2951),(51875,2951),(51876,2951),(51877,2951),(51878,2951),(51879,2952),(51880,2952),(51881,2952),(51882,2952),(51883,2952),(51884,2952),(51885,2953),(51886,2953),(51887,2953),(51888,2953),(51889,2953),(51890,2953),(51891,2954),(51892,2954),(51893,2954),(51894,2954),(51895,2954),(51896,2954),(51897,2955),(51898,2955),(51899,2955),(51900,2955),(51901,2955),(51902,2955),(51903,2956),(51904,2956),(51905,2956),(51906,2956),(51907,2956),(51908,2956),(51909,2957),(51910,2957),(51911,2957),(51912,2957),(51913,2957),(51914,2957),(51915,2958),(51916,2958),(51917,2958),(51918,2958),(51919,2958),(51920,2958),(51921,2959),(51922,2959),(51923,2959),(51924,2959),(51925,2959),(51926,2959),(51927,2960),(51928,2960),(51929,2960),(51930,2960),(51931,2960),(51932,2960),(51933,2961),(51934,2961),(51935,2961),(51936,2961),(51937,2961),(51938,2961),(51939,2962),(51940,2962),(51941,2962),(51942,2962),(51943,2962),(51944,2962),(51945,2963),(51946,2963),(51947,2963),(51948,2963),(51949,2964),(51950,2964),(51951,2964),(51952,2964),(51953,2965),(51954,2965),(51955,2965),(51956,2965),(51957,2966),(51958,2966),(51959,2966),(51960,2966),(51961,2967),(51962,2967),(51963,2967),(51964,2967),(51965,2968),(51966,2968),(51967,2968),(51968,2968),(51969,2969),(51970,2969),(51971,2969),(51972,2969),(51973,2969),(51974,2969),(51975,2970),(51976,2970),(51977,2970),(51978,2970),(51979,2970),(51980,2970),(51981,2971),(51982,2971),(51983,2971),(51984,2971),(51985,2971),(51986,2971),(51987,2972),(51988,2972),(51989,2972),(51990,2972),(51991,2972),(51992,2972),(51993,2973),(51994,2973),(51995,2973),(51996,2973),(51997,2973),(51998,2973),(51999,2974),(52000,2974),(52001,2974),(52002,2974),(52003,2974),(52004,2974),(52005,2975),(52006,2975),(52007,2975),(52008,2975),(52009,2975),(52010,2975),(52011,2976),(52012,2976),(52013,2976),(52014,2976),(52015,2976),(52016,2976),(52017,2977),(52018,2977),(52019,2977),(52020,2977),(52021,2977),(52022,2977),(52023,2978),(52024,2978),(52025,2978),(52026,2978),(52027,2978),(52028,2978),(52029,2979),(52030,2979),(52031,2979),(52032,2979),(52033,2979),(52034,2979),(52035,2980),(52036,2980),(52037,2980),(52038,2980),(52039,2980),(52040,2980),(52041,2981),(52042,2981),(52043,2981),(52044,2981),(52045,2982),(52046,2982),(52047,2982),(52048,2982),(52049,2983),(52050,2983),(52051,2983),(52052,2983),(52053,2984),(52054,2984),(52055,2984),(52056,2984),(52057,2985),(52058,2985),(52059,2985),(52060,2985),(52061,2986),(52062,2986),(52063,2986),(52064,2986),(52065,2987),(52066,2987),(52067,2987),(52068,2987),(52069,2987),(52070,2987),(52071,2988),(52072,2988),(52073,2988),(52074,2988),(52075,2988),(52076,2988),(52077,2989),(52078,2989),(52079,2989),(52080,2989),(52081,2989),(52082,2989),(52083,2990),(52084,2990),(52085,2990),(52086,2990),(52087,2990),(52088,2990),(52089,2991),(52090,2991),(52091,2991),(52092,2991),(52093,2991),(52094,2991),(52095,2992),(52096,2992),(52097,2992),(52098,2992),(52099,2992),(52100,2992),(52101,2993),(52102,2993),(52103,2993),(52104,2993),(52105,2993),(52106,2993),(52107,2994),(52108,2994),(52109,2994),(52110,2994),(52111,2994),(52112,2994),(52113,2995),(52114,2995),(52115,2995),(52116,2995),(52117,2995),(52118,2995),(52119,2996),(52120,2996),(52121,2996),(52122,2996),(52123,2996),(52124,2996),(52125,2997),(52126,2997),(52127,2997),(52128,2997),(52129,2997),(52130,2997),(52131,2998),(52132,2998),(52133,2998),(52134,2998),(52135,2998),(52136,2998),(52137,2999),(52138,2999),(52139,2999),(52140,2999),(52141,2999),(52142,2999),(52143,3000),(52144,3000),(52145,3000),(52146,3000),(52147,3000),(52148,3000),(52149,3001),(52150,3001),(52151,3001),(52152,3001),(52153,3001),(52154,3001),(52155,3002),(52156,3002),(52157,3002),(52158,3002),(52159,3002),(52160,3002),(52161,3003),(52162,3003),(52163,3003),(52164,3003),(52165,3003),(52166,3003),(52167,3004),(52168,3004),(52169,3004),(52170,3004),(52171,3004),(52172,3004),(52173,3005),(52174,3005),(52175,3005),(52176,3005),(52177,3005),(52178,3005),(52179,3006),(52180,3006),(52181,3006),(52182,3006),(52183,3006),(52184,3006),(52185,3007),(52186,3007),(52187,3007),(52188,3007),(52189,3007),(52190,3007),(52191,3008),(52192,3008),(52193,3008),(52194,3008),(52195,3008),(52196,3008),(52197,3009),(52198,3009),(52199,3009),(52200,3009),(52201,3009),(52202,3009),(52203,3010),(52204,3010),(52205,3010),(52206,3010),(52207,3010),(52208,3010),(52209,3011),(52210,3011),(52211,3011),(52212,3011),(52213,3011),(52214,3011),(52215,3012),(52216,3012),(52217,3012),(52218,3012),(52219,3012),(52220,3012),(52221,3013),(52222,3013),(52223,3013),(52224,3013),(52225,3013),(52226,3013),(52227,3014),(52228,3014),(52229,3014),(52230,3014),(52231,3014),(52232,3014),(52233,3015),(52234,3015),(52235,3015),(52236,3015),(52237,3015),(52238,3015),(52239,3016),(52240,3016),(52241,3016),(52242,3016),(52243,3016),(52244,3016),(52245,3017),(52246,3017),(52247,3017),(52248,3017),(52249,3017),(52250,3017),(52251,3018),(52252,3018),(52253,3018),(52254,3018),(52255,3018),(52256,3018),(52257,3019),(52258,3019),(52259,3019),(52260,3019),(52261,3019),(52262,3019),(52263,3020),(52264,3020),(52265,3020),(52266,3020),(52267,3020),(52268,3020),(52269,3021),(52270,3021),(52271,3021),(52272,3021),(52273,3021),(52274,3021),(52275,2922),(52276,2922),(52277,2923),(52278,2923),(52279,2924),(52280,2924),(52281,2925),(52282,2925),(52283,2926),(52284,2926),(52285,2927),(52286,2927),(52287,2928),(52288,2928),(52289,2929),(52290,2929),(52291,2930),(52292,2930),(52293,2931),(52294,2931),(52295,2932),(52296,2932),(52297,2933),(52298,2933),(52299,2934),(52300,2934),(52301,2935),(52302,2935),(52303,2936),(52304,2936),(52305,2937),(52306,2937),(52307,2938),(52308,2938),(52309,2939),(52310,2939),(52311,2940),(52312,2940),(52313,2941),(52314,2941),(52315,2942),(52316,2942),(52317,2943),(52318,2943),(52319,2944),(52320,2944),(52321,2945),(52322,2945),(52323,2946),(52324,2946),(52325,2947),(52326,2947),(52327,2948),(52328,2948),(52329,2949),(52330,2949),(52331,2950),(52332,2950),(52333,2951),(52334,2951),(52335,2952),(52336,2952),(52337,2953),(52338,2953),(52339,2954),(52340,2954),(52341,2955),(52342,2955),(52343,2955),(52344,2956),(52345,2956),(52346,2956),(52347,2957),(52348,2957),(52349,2957),(52350,2958),(52351,2958),(52352,2958),(52353,2959),(52354,2959),(52355,2959),(52356,2960),(52357,2960),(52358,2960),(52359,2961),(52360,2961),(52361,2961),(52362,2962),(52363,2962),(52364,2962),(52365,2963),(52366,2963),(52367,2964),(52368,2964),(52369,2965),(52370,2965),(52371,2966),(52372,2966),(52373,2967),(52374,2967),(52375,2968),(52376,2968),(52377,2969),(52378,2969),(52379,2970),(52380,2970),(52381,2971),(52382,2971),(52383,2972),(52384,2972),(52385,2973),(52386,2973),(52387,2974),(52388,2974),(52389,2975),(52390,2975),(52391,2976),(52392,2976),(52393,2977),(52394,2977),(52395,2978),(52396,2978),(52397,2979),(52398,2979),(52399,2980),(52400,2980),(52401,2981),(52402,2981),(52403,2982),(52404,2982),(52405,2983),(52406,2983),(52407,2984),(52408,2984),(52409,2985),(52410,2985),(52411,2986),(52412,2986),(52413,2987),(52414,2987),(52415,2988),(52416,2988),(52417,2989),(52418,2989),(52419,2990),(52420,2990),(52421,2991),(52422,2991),(52423,2991),(52424,2992),(52425,2992),(52426,2992),(52427,2993),(52428,2993),(52429,2994),(52430,2994),(52431,2995),(52432,2995),(52433,2996),(52434,2996),(52435,2997),(52436,2997),(52437,2998),(52438,2998),(52439,2999),(52440,2999),(52441,3000),(52442,3000),(52443,3001),(52444,3001),(52445,3002),(52446,3002),(52447,3003),(52448,3003),(52449,3004),(52450,3004),(52451,3005),(52452,3005),(52453,3006),(52454,3006),(52455,3007),(52456,3007),(52457,3008),(52458,3008),(52459,3009),(52460,3009),(52461,3010),(52462,3010),(52463,3011),(52464,3011),(52465,3012),(52466,3012),(52467,3013),(52468,3013),(52469,3013),(52470,3014),(52471,3014),(52472,3014),(52473,3015),(52474,3015),(52475,3015),(52476,3016),(52477,3016),(52478,3016),(52479,3017),(52480,3017),(52481,3017),(52482,3018),(52483,3018),(52484,3018),(52485,3019),(52486,3019),(52487,3019),(52488,3020),(52489,3020),(52490,3020),(52491,3021),(52492,3021),(52493,3021),(52494,2922),(52495,2922),(52496,2922),(52497,2923),(52498,2923),(52499,2923),(52500,2924),(52501,2924),(52502,2924),(52503,2925),(52504,2925),(52505,2925),(52506,2926),(52507,2926),(52508,2926),(52509,2927),(52510,2927),(52511,2927),(52512,2928),(52513,2928),(52514,2928),(52515,2929),(52516,2929),(52517,2929),(52518,2930),(52519,2930),(52520,2930),(52521,2931),(52522,2931),(52523,2931),(52524,2932),(52525,2932),(52526,2932),(52527,2933),(52528,2933),(52529,2933),(52530,2934),(52531,2934),(52532,2934),(52533,2935),(52534,2935),(52535,2935),(52536,2936),(52537,2936),(52538,2936),(52539,2937),(52540,2937),(52541,2937),(52542,2938),(52543,2938),(52544,2938),(52545,2939),(52546,2939),(52547,2939),(52548,2940),(52549,2940),(52550,2940),(52551,2941),(52552,2941),(52553,2941),(52554,2942),(52555,2942),(52556,2942),(52557,2943),(52558,2943),(52559,2943),(52560,2944),(52561,2944),(52562,2944),(52563,2945),(52564,2945),(52565,2945),(52566,2946),(52567,2946),(52568,2946),(52569,2947),(52570,2947),(52571,2947),(52572,2948),(52573,2948),(52574,2948),(52575,2949),(52576,2949),(52577,2949),(52578,2950),(52579,2950),(52580,2950),(52581,2951),(52582,2951),(52583,2951),(52584,2952),(52585,2952),(52586,2952),(52587,2953),(52588,2953),(52589,2953),(52590,2954),(52591,2954),(52592,2954),(52593,2955),(52594,2955),(52595,2955),(52596,2956),(52597,2956),(52598,2956),(52599,2957),(52600,2957),(52601,2957),(52602,2958),(52603,2958),(52604,2958),(52605,2959),(52606,2959),(52607,2959),(52608,2960),(52609,2960),(52610,2960),(52611,2961),(52612,2961),(52613,2961),(52614,2962),(52615,2962),(52616,2962),(52617,2963),(52618,2963),(52619,2963),(52620,2964),(52621,2964),(52622,2964),(52623,2965),(52624,2965),(52625,2965),(52626,2966),(52627,2966),(52628,2966),(52629,2967),(52630,2967),(52631,2967),(52632,2968),(52633,2968),(52634,2968),(52635,2969),(52636,2969),(52637,2969),(52638,2970),(52639,2970),(52640,2970),(52641,2971),(52642,2971),(52643,2971),(52644,2972),(52645,2972),(52646,2972),(52647,2973),(52648,2973),(52649,2973),(52650,2974),(52651,2974),(52652,2974),(52653,2975),(52654,2975),(52655,2975),(52656,2976),(52657,2976),(52658,2976),(52659,2977),(52660,2977),(52661,2977),(52662,2978),(52663,2978),(52664,2978),(52665,2979),(52666,2979),(52667,2979),(52668,2980),(52669,2980),(52670,2980),(52671,2981),(52672,2981),(52673,2981),(52674,2982),(52675,2982),(52676,2982),(52677,2983),(52678,2983),(52679,2983),(52680,2984),(52681,2984),(52682,2984),(52683,2985),(52684,2985),(52685,2985),(52686,2986),(52687,2986),(52688,2986),(52689,2987),(52690,2987),(52691,2987),(52692,2988),(52693,2988),(52694,2988),(52695,2989),(52696,2989),(52697,2989),(52698,2990),(52699,2990),(52700,2990),(52701,2991),(52702,2991),(52703,2991),(52704,2992),(52705,2992),(52706,2992),(52707,2993),(52708,2993),(52709,2993),(52710,2994),(52711,2994),(52712,2994),(52713,2995),(52714,2995),(52715,2995),(52716,2996),(52717,2996),(52718,2996),(52719,2997),(52720,2997),(52721,2997),(52722,2998),(52723,2998),(52724,2998),(52725,2999),(52726,2999),(52727,2999),(52728,3000),(52729,3000),(52730,3000),(52731,3001),(52732,3001),(52733,3001),(52734,3002),(52735,3002),(52736,3002),(52737,3003),(52738,3003),(52739,3003),(52740,3004),(52741,3004),(52742,3004),(52743,3005),(52744,3005),(52745,3005),(52746,3006),(52747,3006),(52748,3006),(52749,3007),(52750,3007),(52751,3007),(52752,3008),(52753,3008),(52754,3008),(52755,3009),(52756,3009),(52757,3009),(52758,3010),(52759,3010),(52760,3010),(52761,3011),(52762,3011),(52763,3011),(52764,3012),(52765,3012),(52766,3012),(52767,3013),(52768,3013),(52769,3013),(52770,3014),(52771,3014),(52772,3014),(52773,3015),(52774,3015),(52775,3015),(52776,3016),(52777,3016),(52778,3016),(52779,3017),(52780,3017),(52781,3017),(52782,3018),(52783,3018),(52784,3018),(52785,3019),(52786,3019),(52787,3019),(52788,3020),(52789,3020),(52790,3020),(52791,3021),(52792,3021),(52793,3021),(52794,2922),(52795,2922),(52796,2922),(52797,2922),(52798,2923),(52799,2923),(52800,2923),(52801,2923),(52802,2924),(52803,2924),(52804,2924),(52805,2924),(52806,2925),(52807,2925),(52808,2925),(52809,2925),(52810,2926),(52811,2926),(52812,2926),(52813,2926),(52814,2927),(52815,2927),(52816,2927),(52817,2927),(52818,2928),(52819,2928),(52820,2928),(52821,2928),(52822,2929),(52823,2929),(52824,2929),(52825,2929),(52826,2930),(52827,2930),(52828,2930),(52829,2930),(52830,2931),(52831,2931),(52832,2931),(52833,2931),(52834,2932),(52835,2932),(52836,2932),(52837,2932),(52838,2933),(52839,2933),(52840,2933),(52841,2933),(52842,2934),(52843,2934),(52844,2934),(52845,2934),(52846,2935),(52847,2935),(52848,2935),(52849,2935),(52850,2936),(52851,2936),(52852,2936),(52853,2936),(52854,2937),(52855,2937),(52856,2937),(52857,2937),(52858,2938),(52859,2938),(52860,2938),(52861,2938),(52862,2939),(52863,2939),(52864,2939),(52865,2939),(52866,2940),(52867,2940),(52868,2940),(52869,2940),(52870,2941),(52871,2941),(52872,2941),(52873,2941),(52874,2942),(52875,2942),(52876,2942),(52877,2942),(52878,2943),(52879,2943),(52880,2943),(52881,2943),(52882,2944),(52883,2944),(52884,2944),(52885,2944),(52886,2945),(52887,2945),(52888,2945),(52889,2945),(52890,2946),(52891,2946),(52892,2946),(52893,2946),(52894,2947),(52895,2947),(52896,2947),(52897,2947),(52898,2948),(52899,2948),(52900,2948),(52901,2948),(52902,2949),(52903,2949),(52904,2949),(52905,2949),(52906,2950),(52907,2950),(52908,2950),(52909,2950),(52910,2951),(52911,2951),(52912,2951),(52913,2951),(52914,2952),(52915,2952),(52916,2952),(52917,2952),(52918,2953),(52919,2953),(52920,2953),(52921,2953),(52922,2954),(52923,2954),(52924,2954),(52925,2954),(52926,2955),(52927,2955),(52928,2955),(52929,2955),(52930,2956),(52931,2956),(52932,2956),(52933,2956),(52934,2957),(52935,2957),(52936,2957),(52937,2957),(52938,2958),(52939,2958),(52940,2958),(52941,2958),(52942,2959),(52943,2959),(52944,2959),(52945,2959),(52946,2960),(52947,2960),(52948,2960),(52949,2960),(52950,2961),(52951,2961),(52952,2961),(52953,2961),(52954,2962),(52955,2962),(52956,2962),(52957,2962),(52958,2963),(52959,2963),(52960,2963),(52961,2963),(52962,2964),(52963,2964),(52964,2964),(52965,2964),(52966,2965),(52967,2965),(52968,2965),(52969,2965),(52970,2966),(52971,2966),(52972,2966),(52973,2966),(52974,2967),(52975,2967),(52976,2967),(52977,2967),(52978,2968),(52979,2968),(52980,2968),(52981,2968),(52982,2969),(52983,2969),(52984,2969),(52985,2969),(52986,2970),(52987,2970),(52988,2970),(52989,2970),(52990,2971),(52991,2971),(52992,2971),(52993,2971),(52994,2972),(52995,2972),(52996,2972),(52997,2972),(52998,2973),(52999,2973),(53000,2973),(53001,2973),(53002,2974),(53003,2974),(53004,2974),(53005,2974),(53006,2975),(53007,2975),(53008,2975),(53009,2975),(53010,2976),(53011,2976),(53012,2976),(53013,2976),(53014,2977),(53015,2977),(53016,2977),(53017,2977),(53018,2978),(53019,2978),(53020,2978),(53021,2978),(53022,2979),(53023,2979),(53024,2979),(53025,2979),(53026,2980),(53027,2980),(53028,2980),(53029,2980),(53030,2981),(53031,2981),(53032,2981),(53033,2981),(53034,2982),(53035,2982),(53036,2982),(53037,2982),(53038,2983),(53039,2983),(53040,2983),(53041,2983),(53042,2984),(53043,2984),(53044,2984),(53045,2984),(53046,2985),(53047,2985),(53048,2985),(53049,2985),(53050,2986),(53051,2986),(53052,2986),(53053,2986),(53054,2987),(53055,2987),(53056,2987),(53057,2987),(53058,2988),(53059,2988),(53060,2988),(53061,2988),(53062,2989),(53063,2989),(53064,2989),(53065,2989),(53066,2990),(53067,2990),(53068,2990),(53069,2990),(53070,2991),(53071,2991),(53072,2991),(53073,2991),(53074,2992),(53075,2992),(53076,2992),(53077,2992),(53078,2993),(53079,2993),(53080,2993),(53081,2993),(53082,2994),(53083,2994),(53084,2994),(53085,2994),(53086,2995),(53087,2995),(53088,2995),(53089,2995),(53090,2996),(53091,2996),(53092,2996),(53093,2996),(53094,2997),(53095,2997),(53096,2997),(53097,2997),(53098,2998),(53099,2998),(53100,2998),(53101,2998),(53102,2999),(53103,2999),(53104,2999),(53105,2999),(53106,3000),(53107,3000),(53108,3000),(53109,3000),(53110,3001),(53111,3001),(53112,3001),(53113,3001),(53114,3002),(53115,3002),(53116,3002),(53117,3002),(53118,3003),(53119,3003),(53120,3003),(53121,3003),(53122,3004),(53123,3004),(53124,3004),(53125,3004),(53126,3005),(53127,3005),(53128,3005),(53129,3005),(53130,3006),(53131,3006),(53132,3006),(53133,3006),(53134,3007),(53135,3007),(53136,3007),(53137,3007),(53138,3008),(53139,3008),(53140,3008),(53141,3008),(53142,3009),(53143,3009),(53144,3009),(53145,3009),(53146,3010),(53147,3010),(53148,3010),(53149,3010),(53150,3011),(53151,3011),(53152,3011),(53153,3011),(53154,3012),(53155,3012),(53156,3012),(53157,3012),(53158,3013),(53159,3013),(53160,3013),(53161,3013),(53162,3014),(53163,3014),(53164,3014),(53165,3014),(53166,3015),(53167,3015),(53168,3015),(53169,3015),(53170,3016),(53171,3016),(53172,3016),(53173,3016),(53174,3017),(53175,3017),(53176,3017),(53177,3017),(53178,3018),(53179,3018),(53180,3018),(53181,3018),(53182,3019),(53183,3019),(53184,3019),(53185,3019),(53186,3020),(53187,3020),(53188,3020),(53189,3020),(53190,3021),(53191,3021),(53192,3021),(53193,3021),(53194,3022),(53195,3023),(53196,3024),(53197,3025),(53198,3026),(53199,3027),(53200,3028),(53201,3029),(53202,3030),(53203,3031),(53204,3032),(53205,3033),(53206,3034),(53207,3035),(53208,3036),(53209,3037),(53210,3038),(53211,3039),(53212,3040),(53213,3041),(53214,3042),(53215,3043),(53216,3044),(53217,3045),(53218,3046),(53219,3047),(53220,3048),(53221,3049),(53222,3050),(53223,3051),(53224,3052),(53225,3053),(53226,3054),(53227,3055),(53228,3056),(53229,3057),(53230,3058),(53231,3059),(53232,3060),(53233,3061),(53234,3062),(53235,3063),(53236,3064),(53237,3065),(53238,3066),(53239,3067),(53240,3068),(53241,3069),(53242,3070),(53243,3071),(53244,3072),(53245,3073),(53246,3074),(53247,3075),(53248,3076),(53249,3077),(53250,3078),(53251,3079),(53252,3080),(53253,3081),(53254,3082),(53255,3083),(53256,3084),(53257,3085),(53258,3086),(53259,3087),(53260,3088),(53261,3089),(53262,3090),(53263,3091),(53264,3092),(53265,3093),(53266,3094),(53267,3095),(53268,3096),(53269,3097),(53270,3098),(53271,3099),(53272,3100),(53273,3101),(53274,3102),(53275,3103),(53276,3104),(53277,3105),(53278,3106),(53279,3107),(53280,3108),(53281,3109),(53282,3110),(53283,3111),(53284,3112),(53285,3113),(53286,3114),(53287,3115),(53288,3116),(53289,3117),(53290,3118),(53291,3119),(53292,3120),(53293,3121),(53294,3022),(53295,3022),(53296,3022),(53297,3022),(53298,3022),(53299,3022),(53300,3023),(53301,3023),(53302,3023),(53303,3023),(53304,3023),(53305,3023),(53306,3024),(53307,3024),(53308,3024),(53309,3024),(53310,3024),(53311,3024),(53312,3025),(53313,3025),(53314,3025),(53315,3025),(53316,3025),(53317,3025),(53318,3026),(53319,3026),(53320,3026),(53321,3026),(53322,3026),(53323,3026),(53324,3027),(53325,3027),(53326,3027),(53327,3027),(53328,3027),(53329,3027),(53330,3028),(53331,3028),(53332,3028),(53333,3028),(53334,3028),(53335,3028),(53336,3029),(53337,3029),(53338,3029),(53339,3029),(53340,3029),(53341,3029),(53342,3030),(53343,3030),(53344,3030),(53345,3030),(53346,3030),(53347,3030),(53348,3031),(53349,3031),(53350,3031),(53351,3031),(53352,3031),(53353,3031),(53354,3032),(53355,3032),(53356,3032),(53357,3032),(53358,3032),(53359,3032),(53360,3033),(53361,3033),(53362,3033),(53363,3033),(53364,3033),(53365,3033),(53366,3034),(53367,3034),(53368,3034),(53369,3034),(53370,3034),(53371,3034),(53372,3035),(53373,3035),(53374,3035),(53375,3035),(53376,3035),(53377,3035),(53378,3036),(53379,3036),(53380,3036),(53381,3036),(53382,3036),(53383,3036),(53384,3037),(53385,3037),(53386,3037),(53387,3037),(53388,3037),(53389,3037),(53390,3038),(53391,3038),(53392,3038),(53393,3038),(53394,3039),(53395,3039),(53396,3039),(53397,3039),(53398,3040),(53399,3040),(53400,3040),(53401,3040),(53402,3041),(53403,3041),(53404,3041),(53405,3041),(53406,3042),(53407,3042),(53408,3042),(53409,3042),(53410,3042),(53411,3042),(53412,3043),(53413,3043),(53414,3043),(53415,3043),(53416,3043),(53417,3043),(53418,3044),(53419,3044),(53420,3044),(53421,3044),(53422,3045),(53423,3045),(53424,3045),(53425,3045),(53426,3046),(53427,3046),(53428,3046),(53429,3046),(53430,3047),(53431,3047),(53432,3047),(53433,3047),(53434,3048),(53435,3048),(53436,3048),(53437,3048),(53438,3048),(53439,3048),(53440,3049),(53441,3049),(53442,3049),(53443,3049),(53444,3049),(53445,3049),(53446,3050),(53447,3050),(53448,3050),(53449,3050),(53450,3050),(53451,3050),(53452,3051),(53453,3051),(53454,3051),(53455,3051),(53456,3051),(53457,3051),(53458,3052),(53459,3052),(53460,3052),(53461,3052),(53462,3052),(53463,3052),(53464,3053),(53465,3053),(53466,3053),(53467,3053),(53468,3053),(53469,3053),(53470,3054),(53471,3054),(53472,3054),(53473,3054),(53474,3054),(53475,3054),(53476,3055),(53477,3055),(53478,3055),(53479,3055),(53480,3055),(53481,3055),(53482,3056),(53483,3056),(53484,3056),(53485,3056),(53486,3057),(53487,3057),(53488,3057),(53489,3057),(53490,3058),(53491,3058),(53492,3058),(53493,3058),(53494,3059),(53495,3059),(53496,3059),(53497,3059),(53498,3060),(53499,3060),(53500,3060),(53501,3060),(53502,3061),(53503,3061),(53504,3061),(53505,3061),(53506,3062),(53507,3062),(53508,3062),(53509,3062),(53510,3063),(53511,3063),(53512,3063),(53513,3063),(53514,3064),(53515,3064),(53516,3064),(53517,3064),(53518,3065),(53519,3065),(53520,3065),(53521,3065),(53522,3065),(53523,3065),(53524,3066),(53525,3066),(53526,3066),(53527,3066),(53528,3066),(53529,3066),(53530,3067),(53531,3067),(53532,3067),(53533,3067),(53534,3067),(53535,3067),(53536,3068),(53537,3068),(53538,3068),(53539,3068),(53540,3068),(53541,3068),(53542,3069),(53543,3069),(53544,3069),(53545,3069),(53546,3069),(53547,3069),(53548,3070),(53549,3070),(53550,3070),(53551,3070),(53552,3070),(53553,3070),(53554,3071),(53555,3071),(53556,3071),(53557,3071),(53558,3071),(53559,3071),(53560,3072),(53561,3072),(53562,3072),(53563,3072),(53564,3072),(53565,3072),(53566,3073),(53567,3073),(53568,3073),(53569,3073),(53570,3073),(53571,3073),(53572,3074),(53573,3074),(53574,3074),(53575,3074),(53576,3074),(53577,3074),(53578,3075),(53579,3075),(53580,3075),(53581,3075),(53582,3075),(53583,3075),(53584,3076),(53585,3076),(53586,3076),(53587,3076),(53588,3076),(53589,3076),(53590,3077),(53591,3077),(53592,3077),(53593,3077),(53594,3077),(53595,3077),(53596,3078),(53597,3078),(53598,3078),(53599,3078),(53600,3078),(53601,3078),(53602,3079),(53603,3079),(53604,3079),(53605,3079),(53606,3079),(53607,3079),(53608,3080),(53609,3080),(53610,3080),(53611,3080),(53612,3080),(53613,3080),(53614,3081),(53615,3081),(53616,3081),(53617,3081),(53618,3081),(53619,3081),(53620,3082),(53621,3082),(53622,3082),(53623,3082),(53624,3082),(53625,3082),(53626,3083),(53627,3083),(53628,3083),(53629,3083),(53630,3083),(53631,3083),(53632,3084),(53633,3084),(53634,3084),(53635,3084),(53636,3084),(53637,3084),(53638,3085),(53639,3085),(53640,3085),(53641,3085),(53642,3085),(53643,3085),(53644,3086),(53645,3086),(53646,3086),(53647,3086),(53648,3086),(53649,3086),(53650,3087),(53651,3087),(53652,3087),(53653,3087),(53654,3087),(53655,3087),(53656,3088),(53657,3088),(53658,3088),(53659,3088),(53660,3088),(53661,3088),(53662,3089),(53663,3089),(53664,3089),(53665,3089),(53666,3089),(53667,3089),(53668,3090),(53669,3090),(53670,3090),(53671,3090),(53672,3090),(53673,3090),(53674,3091),(53675,3091),(53676,3091),(53677,3091),(53678,3091),(53679,3091),(53680,3092),(53681,3092),(53682,3092),(53683,3092),(53684,3092),(53685,3092),(53686,3093),(53687,3093),(53688,3093),(53689,3093),(53690,3093),(53691,3093),(53692,3094),(53693,3094),(53694,3094),(53695,3094),(53696,3094),(53697,3094),(53698,3095),(53699,3095),(53700,3095),(53701,3095),(53702,3095),(53703,3095),(53704,3096),(53705,3096),(53706,3096),(53707,3096),(53708,3096),(53709,3096),(53710,3097),(53711,3097),(53712,3097),(53713,3097),(53714,3097),(53715,3097),(53716,3098),(53717,3098),(53718,3098),(53719,3098),(53720,3098),(53721,3098),(53722,3099),(53723,3099),(53724,3099),(53725,3099),(53726,3099),(53727,3099),(53728,3100),(53729,3100),(53730,3100),(53731,3100),(53732,3100),(53733,3100),(53734,3101),(53735,3101),(53736,3101),(53737,3101),(53738,3101),(53739,3101),(53740,3102),(53741,3102),(53742,3102),(53743,3102),(53744,3102),(53745,3102),(53746,3103),(53747,3103),(53748,3103),(53749,3103),(53750,3103),(53751,3103),(53752,3104),(53753,3104),(53754,3104),(53755,3104),(53756,3104),(53757,3104),(53758,3105),(53759,3105),(53760,3105),(53761,3105),(53762,3105),(53763,3105),(53764,3106),(53765,3106),(53766,3106),(53767,3106),(53768,3106),(53769,3106),(53770,3107),(53771,3107),(53772,3107),(53773,3107),(53774,3107),(53775,3107),(53776,3108),(53777,3108),(53778,3108),(53779,3108),(53780,3108),(53781,3108),(53782,3109),(53783,3109),(53784,3109),(53785,3109),(53786,3109),(53787,3109),(53788,3110),(53789,3110),(53790,3110),(53791,3110),(53792,3111),(53793,3111),(53794,3111),(53795,3111),(53796,3112),(53797,3112),(53798,3112),(53799,3112),(53800,3113),(53801,3113),(53802,3113),(53803,3113),(53804,3114),(53805,3114),(53806,3114),(53807,3114),(53808,3115),(53809,3115),(53810,3115),(53811,3115),(53812,3116),(53813,3116),(53814,3116),(53815,3116),(53816,3117),(53817,3117),(53818,3117),(53819,3117),(53820,3118),(53821,3118),(53822,3118),(53823,3118),(53824,3118),(53825,3118),(53826,3119),(53827,3119),(53828,3119),(53829,3119),(53830,3120),(53831,3120),(53832,3120),(53833,3120),(53834,3121),(53835,3121),(53836,3121),(53837,3121),(53838,3022),(53839,3022),(53840,3022),(53841,3023),(53842,3023),(53843,3023),(53844,3024),(53845,3024),(53846,3024),(53847,3025),(53848,3025),(53849,3025),(53850,3026),(53851,3026),(53852,3026),(53853,3027),(53854,3027),(53855,3027),(53856,3028),(53857,3028),(53858,3028),(53859,3029),(53860,3029),(53861,3029),(53862,3030),(53863,3030),(53864,3030),(53865,3031),(53866,3031),(53867,3031),(53868,3032),(53869,3032),(53870,3032),(53871,3033),(53872,3033),(53873,3033),(53874,3034),(53875,3034),(53876,3034),(53877,3035),(53878,3035),(53879,3035),(53880,3036),(53881,3036),(53882,3036),(53883,3037),(53884,3037),(53885,3037),(53886,3038),(53887,3038),(53888,3039),(53889,3039),(53890,3040),(53891,3040),(53892,3041),(53893,3041),(53894,3042),(53895,3042),(53896,3043),(53897,3043),(53898,3044),(53899,3044),(53900,3045),(53901,3045),(53902,3046),(53903,3046),(53904,3047),(53905,3047),(53906,3048),(53907,3048),(53908,3048),(53909,3049),(53910,3049),(53911,3049),(53912,3050),(53913,3050),(53914,3051),(53915,3051),(53916,3052),(53917,3052),(53918,3053),(53919,3053),(53920,3054),(53921,3054),(53922,3055),(53923,3055),(53924,3056),(53925,3056),(53926,3057),(53927,3057),(53928,3058),(53929,3058),(53930,3059),(53931,3059),(53932,3060),(53933,3060),(53934,3061),(53935,3061),(53936,3062),(53937,3062),(53938,3063),(53939,3063),(53940,3064),(53941,3064),(53942,3065),(53943,3065),(53944,3065),(53945,3066),(53946,3066),(53947,3066),(53948,3067),(53949,3067),(53950,3067),(53951,3068),(53952,3068),(53953,3068),(53954,3069),(53955,3069),(53956,3069),(53957,3070),(53958,3070),(53959,3070),(53960,3071),(53961,3071),(53962,3071),(53963,3072),(53964,3072),(53965,3072),(53966,3073),(53967,3073),(53968,3073),(53969,3074),(53970,3074),(53971,3074),(53972,3075),(53973,3075),(53974,3075),(53975,3076),(53976,3076),(53977,3076),(53978,3077),(53979,3077),(53980,3077),(53981,3078),(53982,3078),(53983,3078),(53984,3079),(53985,3079),(53986,3079),(53987,3080),(53988,3080),(53989,3080),(53990,3081),(53991,3081),(53992,3081),(53993,3082),(53994,3082),(53995,3082),(53996,3083),(53997,3083),(53998,3083),(53999,3084),(54000,3084),(54001,3084),(54002,3085),(54003,3085),(54004,3085),(54005,3086),(54006,3086),(54007,3086),(54008,3087),(54009,3087),(54010,3087),(54011,3088),(54012,3088),(54013,3088),(54014,3089),(54015,3089),(54016,3089),(54017,3090),(54018,3090),(54019,3090),(54020,3091),(54021,3091),(54022,3091),(54023,3092),(54024,3092),(54025,3092),(54026,3093),(54027,3093),(54028,3093),(54029,3094),(54030,3094),(54031,3094),(54032,3095),(54033,3095),(54034,3095),(54035,3096),(54036,3096),(54037,3096),(54038,3097),(54039,3097),(54040,3097),(54041,3098),(54042,3098),(54043,3098),(54044,3099),(54045,3099),(54046,3099),(54047,3100),(54048,3100),(54049,3100),(54050,3101),(54051,3101),(54052,3101),(54053,3102),(54054,3102),(54055,3103),(54056,3103),(54057,3103),(54058,3104),(54059,3104),(54060,3104),(54061,3105),(54062,3105),(54063,3105),(54064,3106),(54065,3106),(54066,3106),(54067,3107),(54068,3107),(54069,3107),(54070,3108),(54071,3108),(54072,3108),(54073,3109),(54074,3109),(54075,3109),(54076,3110),(54077,3110),(54078,3111),(54079,3111),(54080,3112),(54081,3112),(54082,3113),(54083,3113),(54084,3114),(54085,3114),(54086,3115),(54087,3115),(54088,3116),(54089,3116),(54090,3117),(54091,3117),(54092,3118),(54093,3118),(54094,3119),(54095,3119),(54096,3120),(54097,3120),(54098,3121),(54099,3121),(54100,3022),(54101,3022),(54102,3022),(54103,3023),(54104,3023),(54105,3023),(54106,3024),(54107,3024),(54108,3024),(54109,3025),(54110,3025),(54111,3025),(54112,3026),(54113,3026),(54114,3026),(54115,3027),(54116,3027),(54117,3027),(54118,3028),(54119,3028),(54120,3028),(54121,3029),(54122,3029),(54123,3029),(54124,3030),(54125,3030),(54126,3030),(54127,3031),(54128,3031),(54129,3031),(54130,3032),(54131,3032),(54132,3032),(54133,3033),(54134,3033),(54135,3033),(54136,3034),(54137,3034),(54138,3034),(54139,3035),(54140,3035),(54141,3035),(54142,3036),(54143,3036),(54144,3036),(54145,3037),(54146,3037),(54147,3037),(54148,3038),(54149,3038),(54150,3038),(54151,3039),(54152,3039),(54153,3039),(54154,3040),(54155,3040),(54156,3040),(54157,3041),(54158,3041),(54159,3041),(54160,3042),(54161,3042),(54162,3042),(54163,3043),(54164,3043),(54165,3043),(54166,3044),(54167,3044),(54168,3044),(54169,3045),(54170,3045),(54171,3045),(54172,3046),(54173,3046),(54174,3046),(54175,3047),(54176,3047),(54177,3047),(54178,3048),(54179,3048),(54180,3048),(54181,3049),(54182,3049),(54183,3049),(54184,3050),(54185,3050),(54186,3050),(54187,3051),(54188,3051),(54189,3051),(54190,3052),(54191,3052),(54192,3052),(54193,3053),(54194,3053),(54195,3053),(54196,3054),(54197,3054),(54198,3054),(54199,3055),(54200,3055),(54201,3055),(54202,3056),(54203,3056),(54204,3056),(54205,3057),(54206,3057),(54207,3057),(54208,3058),(54209,3058),(54210,3058),(54211,3059),(54212,3059),(54213,3059),(54214,3060),(54215,3060),(54216,3060),(54217,3061),(54218,3061),(54219,3061),(54220,3062),(54221,3062),(54222,3062),(54223,3063),(54224,3063),(54225,3063),(54226,3064),(54227,3064),(54228,3064),(54229,3065),(54230,3065),(54231,3065),(54232,3066),(54233,3066),(54234,3066),(54235,3067),(54236,3067),(54237,3067),(54238,3068),(54239,3068),(54240,3068),(54241,3069),(54242,3069),(54243,3069),(54244,3070),(54245,3070),(54246,3070),(54247,3071),(54248,3071),(54249,3071),(54250,3072),(54251,3072),(54252,3072),(54253,3073),(54254,3073),(54255,3073),(54256,3074),(54257,3074),(54258,3074),(54259,3075),(54260,3075),(54261,3075),(54262,3076),(54263,3076),(54264,3076),(54265,3077),(54266,3077),(54267,3077),(54268,3078),(54269,3078),(54270,3078),(54271,3079),(54272,3079),(54273,3079),(54274,3080),(54275,3080),(54276,3080),(54277,3081),(54278,3081),(54279,3081),(54280,3082),(54281,3082),(54282,3082),(54283,3083),(54284,3083),(54285,3083),(54286,3084),(54287,3084),(54288,3084),(54289,3085),(54290,3085),(54291,3085),(54292,3086),(54293,3086),(54294,3086),(54295,3087),(54296,3087),(54297,3087),(54298,3088),(54299,3088),(54300,3088),(54301,3089),(54302,3089),(54303,3089),(54304,3090),(54305,3090),(54306,3090),(54307,3091),(54308,3091),(54309,3091),(54310,3092),(54311,3092),(54312,3092),(54313,3093),(54314,3093),(54315,3093),(54316,3094),(54317,3094),(54318,3094),(54319,3095),(54320,3095),(54321,3095),(54322,3096),(54323,3096),(54324,3096),(54325,3097),(54326,3097),(54327,3097),(54328,3098),(54329,3098),(54330,3098),(54331,3099),(54332,3099),(54333,3099),(54334,3100),(54335,3100),(54336,3100),(54337,3101),(54338,3101),(54339,3101),(54340,3102),(54341,3102),(54342,3102),(54343,3103),(54344,3103),(54345,3103),(54346,3104),(54347,3104),(54348,3104),(54349,3105),(54350,3105),(54351,3105),(54352,3106),(54353,3106),(54354,3106),(54355,3107),(54356,3107),(54357,3107),(54358,3108),(54359,3108),(54360,3108),(54361,3109),(54362,3109),(54363,3109),(54364,3110),(54365,3110),(54366,3110),(54367,3111),(54368,3111),(54369,3111),(54370,3112),(54371,3112),(54372,3112),(54373,3113),(54374,3113),(54375,3113),(54376,3114),(54377,3114),(54378,3114),(54379,3115),(54380,3115),(54381,3115),(54382,3116),(54383,3116),(54384,3116),(54385,3117),(54386,3117),(54387,3117),(54388,3118),(54389,3118),(54390,3118),(54391,3119),(54392,3119),(54393,3119),(54394,3120),(54395,3120),(54396,3120),(54397,3121),(54398,3121),(54399,3121),(54400,3022),(54401,3022),(54402,3022),(54403,3022),(54404,3023),(54405,3023),(54406,3023),(54407,3023),(54408,3024),(54409,3024),(54410,3024),(54411,3024),(54412,3025),(54413,3025),(54414,3025),(54415,3025),(54416,3026),(54417,3026),(54418,3026),(54419,3026),(54420,3027),(54421,3027),(54422,3027),(54423,3027),(54424,3028),(54425,3028),(54426,3028),(54427,3028),(54428,3029),(54429,3029),(54430,3029),(54431,3029),(54432,3030),(54433,3030),(54434,3030),(54435,3030),(54436,3031),(54437,3031),(54438,3031),(54439,3031),(54440,3032),(54441,3032),(54442,3032),(54443,3032),(54444,3033),(54445,3033),(54446,3033),(54447,3033),(54448,3034),(54449,3034),(54450,3034),(54451,3034),(54452,3035),(54453,3035),(54454,3035),(54455,3035),(54456,3036),(54457,3036),(54458,3036),(54459,3036),(54460,3037),(54461,3037),(54462,3037),(54463,3037),(54464,3038),(54465,3038),(54466,3038),(54467,3038),(54468,3039),(54469,3039),(54470,3039),(54471,3039),(54472,3040),(54473,3040),(54474,3040),(54475,3040),(54476,3041),(54477,3041),(54478,3041),(54479,3041),(54480,3042),(54481,3042),(54482,3042),(54483,3042),(54484,3043),(54485,3043),(54486,3043),(54487,3043),(54488,3044),(54489,3044),(54490,3044),(54491,3044),(54492,3045),(54493,3045),(54494,3045),(54495,3045),(54496,3046),(54497,3046),(54498,3046),(54499,3046),(54500,3047),(54501,3047),(54502,3047),(54503,3047),(54504,3048),(54505,3048),(54506,3048),(54507,3048),(54508,3049),(54509,3049),(54510,3049),(54511,3049),(54512,3050),(54513,3050),(54514,3050),(54515,3050),(54516,3051),(54517,3051),(54518,3051),(54519,3051),(54520,3052),(54521,3052),(54522,3052),(54523,3052),(54524,3053),(54525,3053),(54526,3053),(54527,3053),(54528,3054),(54529,3054),(54530,3054),(54531,3054),(54532,3055),(54533,3055),(54534,3055),(54535,3055),(54536,3056),(54537,3056),(54538,3056),(54539,3056),(54540,3057),(54541,3057),(54542,3057),(54543,3057),(54544,3058),(54545,3058),(54546,3058),(54547,3058),(54548,3059),(54549,3059),(54550,3059),(54551,3059),(54552,3060),(54553,3060),(54554,3060),(54555,3060),(54556,3061),(54557,3061),(54558,3061),(54559,3061),(54560,3062),(54561,3062),(54562,3062),(54563,3062),(54564,3063),(54565,3063),(54566,3063),(54567,3063),(54568,3064),(54569,3064),(54570,3064),(54571,3064),(54572,3065),(54573,3065),(54574,3065),(54575,3065),(54576,3066),(54577,3066),(54578,3066),(54579,3066),(54580,3067),(54581,3067),(54582,3067),(54583,3067),(54584,3068),(54585,3068),(54586,3068),(54587,3068),(54588,3069),(54589,3069),(54590,3069),(54591,3069),(54592,3070),(54593,3070),(54594,3070),(54595,3070),(54596,3071),(54597,3071),(54598,3071),(54599,3071),(54600,3072),(54601,3072),(54602,3072),(54603,3072),(54604,3073),(54605,3073),(54606,3073),(54607,3073),(54608,3074),(54609,3074),(54610,3074),(54611,3074),(54612,3075),(54613,3075),(54614,3075),(54615,3075),(54616,3076),(54617,3076),(54618,3076),(54619,3076),(54620,3077),(54621,3077),(54622,3077),(54623,3077),(54624,3078),(54625,3078),(54626,3078),(54627,3078),(54628,3079),(54629,3079),(54630,3079),(54631,3079),(54632,3080),(54633,3080),(54634,3080),(54635,3080),(54636,3081),(54637,3081),(54638,3081),(54639,3081),(54640,3082),(54641,3082),(54642,3082),(54643,3082),(54644,3083),(54645,3083),(54646,3083),(54647,3083),(54648,3084),(54649,3084),(54650,3084),(54651,3084),(54652,3085),(54653,3085),(54654,3085),(54655,3085),(54656,3086),(54657,3086),(54658,3086),(54659,3086),(54660,3087),(54661,3087),(54662,3087),(54663,3087),(54664,3088),(54665,3088),(54666,3088),(54667,3088),(54668,3089),(54669,3089),(54670,3089),(54671,3089),(54672,3090),(54673,3090),(54674,3090),(54675,3090),(54676,3091),(54677,3091),(54678,3091),(54679,3091),(54680,3092),(54681,3092),(54682,3092),(54683,3092),(54684,3093),(54685,3093),(54686,3093),(54687,3093),(54688,3094),(54689,3094),(54690,3094),(54691,3094),(54692,3095),(54693,3095),(54694,3095),(54695,3095),(54696,3096),(54697,3096),(54698,3096),(54699,3096),(54700,3097),(54701,3097),(54702,3097),(54703,3097),(54704,3098),(54705,3098),(54706,3098),(54707,3098),(54708,3099),(54709,3099),(54710,3099),(54711,3099),(54712,3100),(54713,3100),(54714,3100),(54715,3100),(54716,3101),(54717,3101),(54718,3101),(54719,3101),(54720,3102),(54721,3102),(54722,3102),(54723,3102),(54724,3103),(54725,3103),(54726,3103),(54727,3103),(54728,3104),(54729,3104),(54730,3104),(54731,3104),(54732,3105),(54733,3105),(54734,3105),(54735,3105),(54736,3106),(54737,3106),(54738,3106),(54739,3106),(54740,3107),(54741,3107),(54742,3107),(54743,3107),(54744,3108),(54745,3108),(54746,3108),(54747,3108),(54748,3109),(54749,3109),(54750,3109),(54751,3109),(54752,3110),(54753,3110),(54754,3110),(54755,3110),(54756,3111),(54757,3111),(54758,3111),(54759,3111),(54760,3112),(54761,3112),(54762,3112),(54763,3112),(54764,3113),(54765,3113),(54766,3113),(54767,3113),(54768,3114),(54769,3114),(54770,3114),(54771,3114),(54772,3115),(54773,3115),(54774,3115),(54775,3115),(54776,3116),(54777,3116),(54778,3116),(54779,3116),(54780,3117),(54781,3117),(54782,3117),(54783,3117),(54784,3118),(54785,3118),(54786,3118),(54787,3118),(54788,3119),(54789,3119),(54790,3119),(54791,3119),(54792,3120),(54793,3120),(54794,3120),(54795,3120),(54796,3121),(54797,3121),(54798,3121),(54799,3121),(54800,3122),(54801,3123),(54802,3124),(54803,3125),(54804,3126),(54805,3127),(54806,3128),(54807,3129),(54808,3130),(54809,3131),(54810,3132),(54811,3133),(54812,3134),(54813,3135),(54814,3136),(54815,3137),(54816,3138),(54817,3139),(54818,3140),(54819,3141),(54820,3142),(54821,3143),(54822,3144),(54823,3145),(54824,3146),(54825,3147),(54826,3148),(54827,3149),(54828,3150),(54829,3151),(54830,3152),(54831,3153),(54832,3154),(54833,3155),(54834,3156),(54835,3157),(54836,3158),(54837,3159),(54838,3160),(54839,3161),(54840,3162),(54841,3163),(54842,3164),(54843,3165),(54844,3166),(54845,3167),(54846,3168),(54847,3122),(54848,3122),(54849,3122),(54850,3122),(54851,3123),(54852,3123),(54853,3123),(54854,3123),(54855,3124),(54856,3124),(54857,3124),(54858,3124),(54859,3125),(54860,3125),(54861,3125),(54862,3125),(54863,3125),(54864,3125),(54865,3126),(54866,3126),(54867,3126),(54868,3126),(54869,3126),(54870,3126),(54871,3127),(54872,3127),(54873,3127),(54874,3127),(54875,3127),(54876,3127),(54877,3128),(54878,3128),(54879,3128),(54880,3128),(54881,3128),(54882,3128),(54883,3129),(54884,3129),(54885,3129),(54886,3129),(54887,3129),(54888,3129),(54889,3130),(54890,3130),(54891,3130),(54892,3130),(54893,3130),(54894,3130),(54895,3131),(54896,3131),(54897,3131),(54898,3131),(54899,3131),(54900,3131),(54901,3132),(54902,3132),(54903,3132),(54904,3132),(54905,3132),(54906,3132),(54907,3133),(54908,3133),(54909,3133),(54910,3133),(54911,3133),(54912,3133),(54913,3134),(54914,3134),(54915,3134),(54916,3134),(54917,3134),(54918,3134),(54919,3135),(54920,3135),(54921,3135),(54922,3135),(54923,3135),(54924,3135),(54925,3136),(54926,3136),(54927,3136),(54928,3136),(54929,3136),(54930,3136),(54931,3137),(54932,3137),(54933,3137),(54934,3137),(54935,3137),(54936,3137),(54937,3138),(54938,3138),(54939,3138),(54940,3138),(54941,3138),(54942,3138),(54943,3139),(54944,3139),(54945,3139),(54946,3139),(54947,3139),(54948,3139),(54949,3140),(54950,3140),(54951,3140),(54952,3140),(54953,3140),(54954,3140),(54955,3141),(54956,3141),(54957,3141),(54958,3141),(54959,3141),(54960,3141),(54961,3142),(54962,3142),(54963,3142),(54964,3142),(54965,3142),(54966,3142),(54967,3143),(54968,3143),(54969,3143),(54970,3143),(54971,3143),(54972,3143),(54973,3144),(54974,3144),(54975,3144),(54976,3144),(54977,3144),(54978,3144),(54979,3145),(54980,3145),(54981,3145),(54982,3145),(54983,3145),(54984,3145),(54985,3146),(54986,3146),(54987,3146),(54988,3146),(54989,3146),(54990,3146),(54991,3147),(54992,3147),(54993,3147),(54994,3147),(54995,3147),(54996,3147),(54997,3148),(54998,3148),(54999,3148),(55000,3148),(55001,3148),(55002,3148),(55003,3149),(55004,3149),(55005,3149),(55006,3149),(55007,3149),(55008,3149),(55009,3150),(55010,3150),(55011,3150),(55012,3150),(55013,3150),(55014,3150),(55015,3151),(55016,3151),(55017,3151),(55018,3151),(55019,3151),(55020,3151),(55021,3152),(55022,3152),(55023,3152),(55024,3152),(55025,3152),(55026,3152),(55027,3153),(55028,3153),(55029,3153),(55030,3153),(55031,3153),(55032,3153),(55033,3154),(55034,3154),(55035,3154),(55036,3154),(55037,3154),(55038,3154),(55039,3155),(55040,3155),(55041,3155),(55042,3155),(55043,3155),(55044,3155),(55045,3156),(55046,3156),(55047,3156),(55048,3156),(55049,3156),(55050,3156),(55051,3157),(55052,3157),(55053,3157),(55054,3157),(55055,3157),(55056,3157),(55057,3158),(55058,3158),(55059,3158),(55060,3158),(55061,3158),(55062,3158),(55063,3159),(55064,3159),(55065,3159),(55066,3159),(55067,3159),(55068,3159),(55069,3160),(55070,3160),(55071,3160),(55072,3160),(55073,3160),(55074,3160),(55075,3161),(55076,3161),(55077,3161),(55078,3161),(55079,3161),(55080,3161),(55081,3162),(55082,3162),(55083,3162),(55084,3162),(55085,3162),(55086,3162),(55087,3163),(55088,3163),(55089,3163),(55090,3163),(55091,3163),(55092,3163),(55093,3164),(55094,3164),(55095,3164),(55096,3164),(55097,3164),(55098,3164),(55099,3165),(55100,3165),(55101,3165),(55102,3165),(55103,3165),(55104,3165),(55105,3166),(55106,3166),(55107,3166),(55108,3166),(55109,3166),(55110,3166),(55111,3167),(55112,3167),(55113,3167),(55114,3167),(55115,3167),(55116,3167),(55117,3168),(55118,3168),(55119,3168),(55120,3168),(55121,3168),(55122,3168),(55123,3122),(55124,3122),(55125,3123),(55126,3123),(55127,3124),(55128,3124),(55129,3125),(55130,3125),(55131,3126),(55132,3126),(55133,3127),(55134,3127),(55135,3128),(55136,3128),(55137,3129),(55138,3129),(55139,3130),(55140,3130),(55141,3131),(55142,3131),(55143,3132),(55144,3132),(55145,3133),(55146,3133),(55147,3134),(55148,3134),(55149,3135),(55150,3135),(55151,3136),(55152,3136),(55153,3137),(55154,3137),(55155,3138),(55156,3138),(55157,3139),(55158,3139),(55159,3140),(55160,3140),(55161,3141),(55162,3141),(55163,3142),(55164,3142),(55165,3143),(55166,3143),(55167,3144),(55168,3144),(55169,3145),(55170,3145),(55171,3146),(55172,3146),(55173,3147),(55174,3147),(55175,3148),(55176,3148),(55177,3149),(55178,3149),(55179,3150),(55180,3150),(55181,3151),(55182,3151),(55183,3152),(55184,3152),(55185,3153),(55186,3153),(55187,3154),(55188,3154),(55189,3155),(55190,3155),(55191,3156),(55192,3156),(55193,3157),(55194,3157),(55195,3158),(55196,3158),(55197,3159),(55198,3159),(55199,3160),(55200,3160),(55201,3161),(55202,3161),(55203,3162),(55204,3162),(55205,3163),(55206,3163),(55207,3164),(55208,3164),(55209,3165),(55210,3165),(55211,3166),(55212,3166),(55213,3167),(55214,3167),(55215,3168),(55216,3168),(55217,3122),(55218,3122),(55219,3122),(55220,3123),(55221,3123),(55222,3123),(55223,3124),(55224,3124),(55225,3124),(55226,3125),(55227,3125),(55228,3125),(55229,3126),(55230,3126),(55231,3126),(55232,3127),(55233,3127),(55234,3127),(55235,3128),(55236,3128),(55237,3128),(55238,3129),(55239,3129),(55240,3129),(55241,3130),(55242,3130),(55243,3130),(55244,3131),(55245,3131),(55246,3131),(55247,3132),(55248,3132),(55249,3132),(55250,3133),(55251,3133),(55252,3133),(55253,3134),(55254,3134),(55255,3134),(55256,3135),(55257,3135),(55258,3135),(55259,3136),(55260,3136),(55261,3136),(55262,3137),(55263,3137),(55264,3137),(55265,3138),(55266,3138),(55267,3138),(55268,3139),(55269,3139),(55270,3139),(55271,3140),(55272,3140),(55273,3140),(55274,3141),(55275,3141),(55276,3141),(55277,3142),(55278,3142),(55279,3142),(55280,3143),(55281,3143),(55282,3143),(55283,3144),(55284,3144),(55285,3144),(55286,3145),(55287,3145),(55288,3145),(55289,3146),(55290,3146),(55291,3146),(55292,3147),(55293,3147),(55294,3147),(55295,3148),(55296,3148),(55297,3148),(55298,3149),(55299,3149),(55300,3149),(55301,3150),(55302,3150),(55303,3150),(55304,3151),(55305,3151),(55306,3151),(55307,3152),(55308,3152),(55309,3152),(55310,3153),(55311,3153),(55312,3153),(55313,3154),(55314,3154),(55315,3154),(55316,3155),(55317,3155),(55318,3155),(55319,3156),(55320,3156),(55321,3156),(55322,3157),(55323,3157),(55324,3157),(55325,3158),(55326,3158),(55327,3158),(55328,3159),(55329,3159),(55330,3159),(55331,3160),(55332,3160),(55333,3160),(55334,3161),(55335,3161),(55336,3161),(55337,3162),(55338,3162),(55339,3162),(55340,3163),(55341,3163),(55342,3163),(55343,3164),(55344,3164),(55345,3164),(55346,3165),(55347,3165),(55348,3165),(55349,3166),(55350,3166),(55351,3166),(55352,3167),(55353,3167),(55354,3167),(55355,3168),(55356,3168),(55357,3168),(55358,3122),(55359,3122),(55360,3122),(55361,3122),(55362,3123),(55363,3123),(55364,3123),(55365,3123),(55366,3124),(55367,3124),(55368,3124),(55369,3124),(55370,3125),(55371,3125),(55372,3125),(55373,3125),(55374,3126),(55375,3126),(55376,3126),(55377,3126),(55378,3127),(55379,3127),(55380,3127),(55381,3127),(55382,3128),(55383,3128),(55384,3128),(55385,3128),(55386,3129),(55387,3129),(55388,3129),(55389,3129),(55390,3130),(55391,3130),(55392,3130),(55393,3130),(55394,3131),(55395,3131),(55396,3131),(55397,3131),(55398,3132),(55399,3132),(55400,3132),(55401,3132),(55402,3133),(55403,3133),(55404,3133),(55405,3133),(55406,3134),(55407,3134),(55408,3134),(55409,3134),(55410,3135),(55411,3135),(55412,3135),(55413,3135),(55414,3136),(55415,3136),(55416,3136),(55417,3136),(55418,3137),(55419,3137),(55420,3137),(55421,3137),(55422,3138),(55423,3138),(55424,3138),(55425,3138),(55426,3139),(55427,3139),(55428,3139),(55429,3139),(55430,3140),(55431,3140),(55432,3140),(55433,3140),(55434,3141),(55435,3141),(55436,3141),(55437,3141),(55438,3142),(55439,3142),(55440,3142),(55441,3142),(55442,3143),(55443,3143),(55444,3143),(55445,3143),(55446,3144),(55447,3144),(55448,3144),(55449,3144),(55450,3145),(55451,3145),(55452,3145),(55453,3145),(55454,3146),(55455,3146),(55456,3146),(55457,3146),(55458,3147),(55459,3147),(55460,3147),(55461,3147),(55462,3148),(55463,3148),(55464,3148),(55465,3148),(55466,3149),(55467,3149),(55468,3149),(55469,3149),(55470,3150),(55471,3150),(55472,3150),(55473,3150),(55474,3151),(55475,3151),(55476,3151),(55477,3151),(55478,3152),(55479,3152),(55480,3152),(55481,3152),(55482,3153),(55483,3153),(55484,3153),(55485,3153),(55486,3154),(55487,3154),(55488,3154),(55489,3154),(55490,3155),(55491,3155),(55492,3155),(55493,3155),(55494,3156),(55495,3156),(55496,3156),(55497,3156),(55498,3157),(55499,3157),(55500,3157),(55501,3157),(55502,3158),(55503,3158),(55504,3158),(55505,3158),(55506,3159),(55507,3159),(55508,3159),(55509,3159),(55510,3160),(55511,3160),(55512,3160),(55513,3160),(55514,3161),(55515,3161),(55516,3161),(55517,3161),(55518,3162),(55519,3162),(55520,3162),(55521,3162),(55522,3163),(55523,3163),(55524,3163),(55525,3163),(55526,3164),(55527,3164),(55528,3164),(55529,3164),(55530,3165),(55531,3165),(55532,3165),(55533,3165),(55534,3166),(55535,3166),(55536,3166),(55537,3166),(55538,3167),(55539,3167),(55540,3167),(55541,3167),(55542,3168),(55543,3168),(55544,3168),(55545,3168),(55546,3169),(55547,3170),(55548,3171),(55549,3172),(55550,3173),(55551,3174),(55552,3175),(55553,3176),(55554,3177),(55555,3178),(55556,3179),(55557,3180),(55558,3181),(55559,3182),(55560,3183),(55561,3184),(55562,3185),(55563,3186),(55564,3187),(55565,3188),(55566,3189),(55567,3190),(55568,3191),(55569,3192),(55570,3193),(55571,3194),(55572,3195),(55573,3196),(55574,3197),(55575,3198),(55576,3199),(55577,3200),(55578,3201),(55579,3202),(55580,3203),(55581,3204),(55582,3205),(55583,3206),(55584,3207),(55585,3208),(55586,3209),(55587,3210),(55588,3211),(55589,3212),(55590,3213),(55591,3214),(55592,3215),(55593,3216),(55594,3217),(55595,3218),(55596,3219),(55597,3220),(55598,3221),(55599,3222),(55600,3223),(55601,3224),(55602,3225),(55603,3226),(55604,3227),(55605,3228),(55606,3229),(55607,3230),(55608,3231),(55609,3232),(55610,3233),(55611,3234),(55612,3235),(55613,3236),(55614,3237),(55615,3238),(55616,3239),(55617,3240),(55618,3241),(55619,3242),(55620,3243),(55621,3244),(55622,3245),(55623,3246),(55624,3247),(55625,3248),(55626,3249),(55627,3250),(55628,3251),(55629,3252),(55630,3253),(55631,3254),(55632,3255),(55633,3256),(55634,3257),(55635,3258),(55636,3259),(55637,3260),(55638,3261),(55639,3262),(55640,3263),(55641,3264),(55642,3265),(55643,3266),(55644,3267),(55645,3268),(55646,3169),(55647,3169),(55648,3169),(55649,3169),(55650,3169),(55651,3169),(55652,3170),(55653,3170),(55654,3170),(55655,3170),(55656,3170),(55657,3170),(55658,3171),(55659,3171),(55660,3171),(55661,3171),(55662,3171),(55663,3171),(55664,3172),(55665,3172),(55666,3172),(55667,3172),(55668,3172),(55669,3172),(55670,3173),(55671,3173),(55672,3173),(55673,3173),(55674,3173),(55675,3173),(55676,3174),(55677,3174),(55678,3174),(55679,3174),(55680,3174),(55681,3174),(55682,3175),(55683,3175),(55684,3175),(55685,3175),(55686,3175),(55687,3175),(55688,3176),(55689,3176),(55690,3176),(55691,3176),(55692,3176),(55693,3176),(55694,3177),(55695,3177),(55696,3177),(55697,3177),(55698,3177),(55699,3177),(55700,3178),(55701,3178),(55702,3178),(55703,3178),(55704,3178),(55705,3178),(55706,3179),(55707,3179),(55708,3179),(55709,3179),(55710,3179),(55711,3179),(55712,3180),(55713,3180),(55714,3180),(55715,3180),(55716,3180),(55717,3180),(55718,3181),(55719,3181),(55720,3181),(55721,3181),(55722,3181),(55723,3181),(55724,3182),(55725,3182),(55726,3182),(55727,3182),(55728,3182),(55729,3182),(55730,3183),(55731,3183),(55732,3183),(55733,3183),(55734,3183),(55735,3183),(55736,3184),(55737,3184),(55738,3184),(55739,3184),(55740,3184),(55741,3184),(55742,3185),(55743,3185),(55744,3185),(55745,3185),(55746,3185),(55747,3185),(55748,3186),(55749,3186),(55750,3186),(55751,3186),(55752,3186),(55753,3186),(55754,3187),(55755,3187),(55756,3187),(55757,3187),(55758,3187),(55759,3187),(55760,3188),(55761,3188),(55762,3188),(55763,3188),(55764,3188),(55765,3188),(55766,3189),(55767,3189),(55768,3189),(55769,3189),(55770,3189),(55771,3189),(55772,3190),(55773,3190),(55774,3190),(55775,3190),(55776,3190),(55777,3190),(55778,3191),(55779,3191),(55780,3191),(55781,3191),(55782,3191),(55783,3191),(55784,3192),(55785,3192),(55786,3192),(55787,3192),(55788,3192),(55789,3192),(55790,3193),(55791,3193),(55792,3193),(55793,3193),(55794,3193),(55795,3193),(55796,3194),(55797,3194),(55798,3194),(55799,3194),(55800,3194),(55801,3194),(55802,3195),(55803,3195),(55804,3195),(55805,3195),(55806,3195),(55807,3195),(55808,3196),(55809,3196),(55810,3196),(55811,3196),(55812,3196),(55813,3196),(55814,3197),(55815,3197),(55816,3197),(55817,3197),(55818,3197),(55819,3197),(55820,3198),(55821,3198),(55822,3198),(55823,3198),(55824,3198),(55825,3198),(55826,3199),(55827,3199),(55828,3199),(55829,3199),(55830,3199),(55831,3199),(55832,3200),(55833,3200),(55834,3200),(55835,3200),(55836,3200),(55837,3200),(55838,3201),(55839,3201),(55840,3201),(55841,3201),(55842,3201),(55843,3201),(55844,3202),(55845,3202),(55846,3202),(55847,3202),(55848,3202),(55849,3202),(55850,3203),(55851,3203),(55852,3203),(55853,3203),(55854,3203),(55855,3203),(55856,3204),(55857,3204),(55858,3204),(55859,3204),(55860,3204),(55861,3204),(55862,3205),(55863,3205),(55864,3205),(55865,3205),(55866,3205),(55867,3205),(55868,3206),(55869,3206),(55870,3206),(55871,3206),(55872,3206),(55873,3206),(55874,3207),(55875,3207),(55876,3207),(55877,3207),(55878,3207),(55879,3207),(55880,3208),(55881,3208),(55882,3208),(55883,3208),(55884,3208),(55885,3208),(55886,3209),(55887,3209),(55888,3209),(55889,3209),(55890,3209),(55891,3209),(55892,3210),(55893,3210),(55894,3210),(55895,3210),(55896,3210),(55897,3210),(55898,3211),(55899,3211),(55900,3211),(55901,3211),(55902,3211),(55903,3211),(55904,3212),(55905,3212),(55906,3212),(55907,3212),(55908,3212),(55909,3212),(55910,3213),(55911,3213),(55912,3213),(55913,3213),(55914,3213),(55915,3213),(55916,3214),(55917,3214),(55918,3214),(55919,3214),(55920,3214),(55921,3214),(55922,3215),(55923,3215),(55924,3215),(55925,3215),(55926,3215),(55927,3215),(55928,3216),(55929,3216),(55930,3216),(55931,3216),(55932,3216),(55933,3216),(55934,3217),(55935,3217),(55936,3217),(55937,3217),(55938,3217),(55939,3217),(55940,3218),(55941,3218),(55942,3218),(55943,3218),(55944,3218),(55945,3218),(55946,3219),(55947,3219),(55948,3219),(55949,3219),(55950,3219),(55951,3219),(55952,3220),(55953,3220),(55954,3220),(55955,3220),(55956,3220),(55957,3220),(55958,3221),(55959,3221),(55960,3221),(55961,3221),(55962,3221),(55963,3221),(55964,3222),(55965,3222),(55966,3222),(55967,3222),(55968,3222),(55969,3222),(55970,3223),(55971,3223),(55972,3223),(55973,3223),(55974,3223),(55975,3223),(55976,3224),(55977,3224),(55978,3224),(55979,3224),(55980,3224),(55981,3224),(55982,3225),(55983,3225),(55984,3225),(55985,3225),(55986,3225),(55987,3225),(55988,3226),(55989,3226),(55990,3226),(55991,3226),(55992,3226),(55993,3226),(55994,3227),(55995,3227),(55996,3227),(55997,3227),(55998,3227),(55999,3227),(56000,3228),(56001,3228),(56002,3228),(56003,3228),(56004,3228),(56005,3228),(56006,3229),(56007,3229),(56008,3229),(56009,3229),(56010,3229),(56011,3229),(56012,3230),(56013,3230),(56014,3230),(56015,3230),(56016,3230),(56017,3230),(56018,3231),(56019,3231),(56020,3231),(56021,3231),(56022,3231),(56023,3231),(56024,3232),(56025,3232),(56026,3232),(56027,3232),(56028,3232),(56029,3232),(56030,3233),(56031,3233),(56032,3233),(56033,3233),(56034,3233),(56035,3233),(56036,3234),(56037,3234),(56038,3234),(56039,3234),(56040,3234),(56041,3234),(56042,3235),(56043,3235),(56044,3235),(56045,3235),(56046,3235),(56047,3235),(56048,3236),(56049,3236),(56050,3236),(56051,3236),(56052,3236),(56053,3236),(56054,3237),(56055,3237),(56056,3237),(56057,3237),(56058,3237),(56059,3237),(56060,3238),(56061,3238),(56062,3238),(56063,3238),(56064,3238),(56065,3238),(56066,3239),(56067,3239),(56068,3239),(56069,3239),(56070,3239),(56071,3239),(56072,3240),(56073,3240),(56074,3240),(56075,3240),(56076,3240),(56077,3240),(56078,3241),(56079,3241),(56080,3241),(56081,3241),(56082,3241),(56083,3241),(56084,3242),(56085,3242),(56086,3242),(56087,3242),(56088,3242),(56089,3242),(56090,3243),(56091,3243),(56092,3243),(56093,3243),(56094,3243),(56095,3243),(56096,3244),(56097,3244),(56098,3244),(56099,3244),(56100,3244),(56101,3244),(56102,3245),(56103,3245),(56104,3245),(56105,3245),(56106,3245),(56107,3245),(56108,3246),(56109,3246),(56110,3246),(56111,3246),(56112,3246),(56113,3246),(56114,3247),(56115,3247),(56116,3247),(56117,3247),(56118,3247),(56119,3247),(56120,3248),(56121,3248),(56122,3248),(56123,3248),(56124,3248),(56125,3248),(56126,3249),(56127,3249),(56128,3249),(56129,3249),(56130,3249),(56131,3249),(56132,3250),(56133,3250),(56134,3250),(56135,3250),(56136,3250),(56137,3250),(56138,3251),(56139,3251),(56140,3251),(56141,3251),(56142,3251),(56143,3251),(56144,3252),(56145,3252),(56146,3252),(56147,3252),(56148,3252),(56149,3252),(56150,3253),(56151,3253),(56152,3253),(56153,3253),(56154,3253),(56155,3253),(56156,3254),(56157,3254),(56158,3254),(56159,3254),(56160,3254),(56161,3254),(56162,3255),(56163,3255),(56164,3255),(56165,3255),(56166,3255),(56167,3255),(56168,3256),(56169,3256),(56170,3256),(56171,3256),(56172,3256),(56173,3256),(56174,3257),(56175,3257),(56176,3257),(56177,3257),(56178,3257),(56179,3257),(56180,3258),(56181,3258),(56182,3258),(56183,3258),(56184,3258),(56185,3258),(56186,3259),(56187,3259),(56188,3259),(56189,3259),(56190,3259),(56191,3259),(56192,3260),(56193,3260),(56194,3260),(56195,3260),(56196,3260),(56197,3260),(56198,3261),(56199,3261),(56200,3261),(56201,3261),(56202,3261),(56203,3261),(56204,3262),(56205,3262),(56206,3262),(56207,3262),(56208,3262),(56209,3262),(56210,3263),(56211,3263),(56212,3263),(56213,3263),(56214,3263),(56215,3263),(56216,3264),(56217,3264),(56218,3264),(56219,3264),(56220,3264),(56221,3264),(56222,3265),(56223,3265),(56224,3265),(56225,3265),(56226,3265),(56227,3265),(56228,3266),(56229,3266),(56230,3266),(56231,3266),(56232,3266),(56233,3266),(56234,3267),(56235,3267),(56236,3267),(56237,3267),(56238,3267),(56239,3267),(56240,3268),(56241,3268),(56242,3268),(56243,3268),(56244,3268),(56245,3268),(56246,3169),(56247,3169),(56248,3170),(56249,3170),(56250,3171),(56251,3171),(56252,3172),(56253,3172),(56254,3173),(56255,3173),(56256,3174),(56257,3174),(56258,3175),(56259,3175),(56260,3176),(56261,3176),(56262,3177),(56263,3177),(56264,3178),(56265,3178),(56266,3179),(56267,3179),(56268,3180),(56269,3180),(56270,3181),(56271,3181),(56272,3182),(56273,3182),(56274,3183),(56275,3183),(56276,3184),(56277,3184),(56278,3185),(56279,3185),(56280,3186),(56281,3186),(56282,3187),(56283,3187),(56284,3188),(56285,3188),(56286,3189),(56287,3189),(56288,3190),(56289,3190),(56290,3191),(56291,3191),(56292,3192),(56293,3192),(56294,3193),(56295,3193),(56296,3194),(56297,3194),(56298,3195),(56299,3195),(56300,3196),(56301,3196),(56302,3197),(56303,3197),(56304,3198),(56305,3198),(56306,3199),(56307,3199),(56308,3200),(56309,3200),(56310,3201),(56311,3201),(56312,3202),(56313,3202),(56314,3203),(56315,3203),(56316,3204),(56317,3204),(56318,3205),(56319,3205),(56320,3206),(56321,3206),(56322,3207),(56323,3207),(56324,3208),(56325,3208),(56326,3209),(56327,3209),(56328,3210),(56329,3210),(56330,3211),(56331,3211),(56332,3212),(56333,3212),(56334,3213),(56335,3213),(56336,3214),(56337,3214),(56338,3215),(56339,3215),(56340,3216),(56341,3216),(56342,3217),(56343,3217),(56344,3218),(56345,3218),(56346,3219),(56347,3219),(56348,3220),(56349,3220),(56350,3221),(56351,3221),(56352,3222),(56353,3222),(56354,3223),(56355,3223),(56356,3224),(56357,3224),(56358,3225),(56359,3225),(56360,3226),(56361,3226),(56362,3227),(56363,3227),(56364,3228),(56365,3228),(56366,3229),(56367,3229),(56368,3230),(56369,3230),(56370,3231),(56371,3231),(56372,3232),(56373,3232),(56374,3233),(56375,3233),(56376,3234),(56377,3234),(56378,3235),(56379,3235),(56380,3236),(56381,3236),(56382,3237),(56383,3237),(56384,3238),(56385,3238),(56386,3239),(56387,3239),(56388,3240),(56389,3240),(56390,3241),(56391,3241),(56392,3242),(56393,3242),(56394,3243),(56395,3243),(56396,3244),(56397,3244),(56398,3245),(56399,3245),(56400,3246),(56401,3246),(56402,3247),(56403,3247),(56404,3248),(56405,3248),(56406,3249),(56407,3249),(56408,3250),(56409,3250),(56410,3251),(56411,3251),(56412,3252),(56413,3252),(56414,3253),(56415,3253),(56416,3254),(56417,3254),(56418,3255),(56419,3255),(56420,3256),(56421,3256),(56422,3257),(56423,3257),(56424,3258),(56425,3258),(56426,3259),(56427,3259),(56428,3260),(56429,3260),(56430,3261),(56431,3261),(56432,3262),(56433,3262),(56434,3263),(56435,3263),(56436,3264),(56437,3264),(56438,3265),(56439,3265),(56440,3266),(56441,3266),(56442,3267),(56443,3267),(56444,3268),(56445,3268),(56446,3169),(56447,3169),(56448,3169),(56449,3170),(56450,3170),(56451,3170),(56452,3171),(56453,3171),(56454,3171),(56455,3172),(56456,3172),(56457,3172),(56458,3173),(56459,3173),(56460,3173),(56461,3174),(56462,3174),(56463,3174),(56464,3175),(56465,3175),(56466,3175),(56467,3176),(56468,3176),(56469,3176),(56470,3177),(56471,3177),(56472,3177),(56473,3178),(56474,3178),(56475,3178),(56476,3179),(56477,3179),(56478,3179),(56479,3180),(56480,3180),(56481,3180),(56482,3181),(56483,3181),(56484,3181),(56485,3182),(56486,3182),(56487,3182),(56488,3183),(56489,3183),(56490,3183),(56491,3184),(56492,3184),(56493,3184),(56494,3185),(56495,3185),(56496,3185),(56497,3186),(56498,3186),(56499,3186),(56500,3187),(56501,3187),(56502,3187),(56503,3188),(56504,3188),(56505,3188),(56506,3189),(56507,3189),(56508,3189),(56509,3190),(56510,3190),(56511,3190),(56512,3191),(56513,3191),(56514,3191),(56515,3192),(56516,3192),(56517,3192),(56518,3193),(56519,3193),(56520,3193),(56521,3194),(56522,3194),(56523,3194),(56524,3195),(56525,3195),(56526,3195),(56527,3196),(56528,3196),(56529,3196),(56530,3197),(56531,3197),(56532,3197),(56533,3198),(56534,3198),(56535,3198),(56536,3199),(56537,3199),(56538,3199),(56539,3200),(56540,3200),(56541,3200),(56542,3201),(56543,3201),(56544,3201),(56545,3202),(56546,3202),(56547,3202),(56548,3203),(56549,3203),(56550,3203),(56551,3204),(56552,3204),(56553,3204),(56554,3205),(56555,3205),(56556,3205),(56557,3206),(56558,3206),(56559,3206),(56560,3207),(56561,3207),(56562,3207),(56563,3208),(56564,3208),(56565,3208),(56566,3209),(56567,3209),(56568,3209),(56569,3210),(56570,3210),(56571,3210),(56572,3211),(56573,3211),(56574,3211),(56575,3212),(56576,3212),(56577,3212),(56578,3213),(56579,3213),(56580,3213),(56581,3214),(56582,3214),(56583,3214),(56584,3215),(56585,3215),(56586,3215),(56587,3216),(56588,3216),(56589,3216),(56590,3217),(56591,3217),(56592,3217),(56593,3218),(56594,3218),(56595,3218),(56596,3219),(56597,3219),(56598,3219),(56599,3220),(56600,3220),(56601,3220),(56602,3221),(56603,3221),(56604,3221),(56605,3222),(56606,3222),(56607,3222),(56608,3223),(56609,3223),(56610,3223),(56611,3224),(56612,3224),(56613,3224),(56614,3225),(56615,3225),(56616,3225),(56617,3226),(56618,3226),(56619,3226),(56620,3227),(56621,3227),(56622,3227),(56623,3228),(56624,3228),(56625,3228),(56626,3229),(56627,3229),(56628,3229),(56629,3230),(56630,3230),(56631,3230),(56632,3231),(56633,3231),(56634,3231),(56635,3232),(56636,3232),(56637,3232),(56638,3233),(56639,3233),(56640,3233),(56641,3234),(56642,3234),(56643,3234),(56644,3235),(56645,3235),(56646,3235),(56647,3236),(56648,3236),(56649,3236),(56650,3237),(56651,3237),(56652,3237),(56653,3238),(56654,3238),(56655,3238),(56656,3239),(56657,3239),(56658,3239),(56659,3240),(56660,3240),(56661,3240),(56662,3241),(56663,3241),(56664,3241),(56665,3242),(56666,3242),(56667,3242),(56668,3243),(56669,3243),(56670,3243),(56671,3244),(56672,3244),(56673,3244),(56674,3245),(56675,3245),(56676,3245),(56677,3246),(56678,3246),(56679,3246),(56680,3247),(56681,3247),(56682,3247),(56683,3248),(56684,3248),(56685,3248),(56686,3249),(56687,3249),(56688,3249),(56689,3250),(56690,3250),(56691,3250),(56692,3251),(56693,3251),(56694,3251),(56695,3252),(56696,3252),(56697,3252),(56698,3253),(56699,3253),(56700,3253),(56701,3254),(56702,3254),(56703,3254),(56704,3255),(56705,3255),(56706,3255),(56707,3256),(56708,3256),(56709,3256),(56710,3257),(56711,3257),(56712,3257),(56713,3258),(56714,3258),(56715,3258),(56716,3259),(56717,3259),(56718,3259),(56719,3260),(56720,3260),(56721,3260),(56722,3261),(56723,3261),(56724,3261),(56725,3262),(56726,3262),(56727,3262),(56728,3263),(56729,3263),(56730,3263),(56731,3264),(56732,3264),(56733,3264),(56734,3265),(56735,3265),(56736,3265),(56737,3266),(56738,3266),(56739,3266),(56740,3267),(56741,3267),(56742,3267),(56743,3268),(56744,3268),(56745,3268),(56746,3169),(56747,3169),(56748,3169),(56749,3169),(56750,3170),(56751,3170),(56752,3170),(56753,3170),(56754,3171),(56755,3171),(56756,3171),(56757,3171),(56758,3172),(56759,3172),(56760,3172),(56761,3172),(56762,3173),(56763,3173),(56764,3173),(56765,3173),(56766,3174),(56767,3174),(56768,3174),(56769,3174),(56770,3175),(56771,3175),(56772,3175),(56773,3175),(56774,3176),(56775,3176),(56776,3176),(56777,3176),(56778,3177),(56779,3177),(56780,3177),(56781,3177),(56782,3178),(56783,3178),(56784,3178),(56785,3178),(56786,3179),(56787,3179),(56788,3179),(56789,3179),(56790,3180),(56791,3180),(56792,3180),(56793,3180),(56794,3181),(56795,3181),(56796,3181),(56797,3181),(56798,3182),(56799,3182),(56800,3182),(56801,3182),(56802,3183),(56803,3183),(56804,3183),(56805,3183),(56806,3184),(56807,3184),(56808,3184),(56809,3184),(56810,3185),(56811,3185),(56812,3185),(56813,3185),(56814,3186),(56815,3186),(56816,3186),(56817,3186),(56818,3187),(56819,3187),(56820,3187),(56821,3187),(56822,3188),(56823,3188),(56824,3188),(56825,3188),(56826,3189),(56827,3189),(56828,3189),(56829,3189),(56830,3190),(56831,3190),(56832,3190),(56833,3190),(56834,3191),(56835,3191),(56836,3191),(56837,3191),(56838,3192),(56839,3192),(56840,3192),(56841,3192),(56842,3193),(56843,3193),(56844,3193),(56845,3193),(56846,3194),(56847,3194),(56848,3194),(56849,3194),(56850,3195),(56851,3195),(56852,3195),(56853,3195),(56854,3196),(56855,3196),(56856,3196),(56857,3196),(56858,3197),(56859,3197),(56860,3197),(56861,3197),(56862,3198),(56863,3198),(56864,3198),(56865,3198),(56866,3199),(56867,3199),(56868,3199),(56869,3199),(56870,3200),(56871,3200),(56872,3200),(56873,3200),(56874,3201),(56875,3201),(56876,3201),(56877,3201),(56878,3202),(56879,3202),(56880,3202),(56881,3202),(56882,3203),(56883,3203),(56884,3203),(56885,3203),(56886,3204),(56887,3204),(56888,3204),(56889,3204),(56890,3205),(56891,3205),(56892,3205),(56893,3205),(56894,3206),(56895,3206),(56896,3206),(56897,3206),(56898,3207),(56899,3207),(56900,3207),(56901,3207),(56902,3208),(56903,3208),(56904,3208),(56905,3208),(56906,3209),(56907,3209),(56908,3209),(56909,3209),(56910,3210),(56911,3210),(56912,3210),(56913,3210),(56914,3211),(56915,3211),(56916,3211),(56917,3211),(56918,3212),(56919,3212),(56920,3212),(56921,3212),(56922,3213),(56923,3213),(56924,3213),(56925,3213),(56926,3214),(56927,3214),(56928,3214),(56929,3214),(56930,3215),(56931,3215),(56932,3215),(56933,3215),(56934,3216),(56935,3216),(56936,3216),(56937,3216),(56938,3217),(56939,3217),(56940,3217),(56941,3217),(56942,3218),(56943,3218),(56944,3218),(56945,3218),(56946,3219),(56947,3219),(56948,3219),(56949,3219),(56950,3220),(56951,3220),(56952,3220),(56953,3220),(56954,3221),(56955,3221),(56956,3221),(56957,3221),(56958,3222),(56959,3222),(56960,3222),(56961,3222),(56962,3223),(56963,3223),(56964,3223),(56965,3223),(56966,3224),(56967,3224),(56968,3224),(56969,3224),(56970,3225),(56971,3225),(56972,3225),(56973,3225),(56974,3226),(56975,3226),(56976,3226),(56977,3226),(56978,3227),(56979,3227),(56980,3227),(56981,3227),(56982,3228),(56983,3228),(56984,3228),(56985,3228),(56986,3229),(56987,3229),(56988,3229),(56989,3229),(56990,3230),(56991,3230),(56992,3230),(56993,3230),(56994,3231),(56995,3231),(56996,3231),(56997,3231),(56998,3232),(56999,3232),(57000,3232),(57001,3232),(57002,3233),(57003,3233),(57004,3233),(57005,3233),(57006,3234),(57007,3234),(57008,3234),(57009,3234),(57010,3235),(57011,3235),(57012,3235),(57013,3235),(57014,3236),(57015,3236),(57016,3236),(57017,3236),(57018,3237),(57019,3237),(57020,3237),(57021,3237),(57022,3238),(57023,3238),(57024,3238),(57025,3238),(57026,3239),(57027,3239),(57028,3239),(57029,3239),(57030,3240),(57031,3240),(57032,3240),(57033,3240),(57034,3241),(57035,3241),(57036,3241),(57037,3241),(57038,3242),(57039,3242),(57040,3242),(57041,3242),(57042,3243),(57043,3243),(57044,3243),(57045,3243),(57046,3244),(57047,3244),(57048,3244),(57049,3244),(57050,3245),(57051,3245),(57052,3245),(57053,3245),(57054,3246),(57055,3246),(57056,3246),(57057,3246),(57058,3247),(57059,3247),(57060,3247),(57061,3247),(57062,3248),(57063,3248),(57064,3248),(57065,3248),(57066,3249),(57067,3249),(57068,3249),(57069,3249),(57070,3250),(57071,3250),(57072,3250),(57073,3250),(57074,3251),(57075,3251),(57076,3251),(57077,3251),(57078,3252),(57079,3252),(57080,3252),(57081,3252),(57082,3253),(57083,3253),(57084,3253),(57085,3253),(57086,3254),(57087,3254),(57088,3254),(57089,3254),(57090,3255),(57091,3255),(57092,3255),(57093,3255),(57094,3256),(57095,3256),(57096,3256),(57097,3256),(57098,3257),(57099,3257),(57100,3257),(57101,3257),(57102,3258),(57103,3258),(57104,3258),(57105,3258),(57106,3259),(57107,3259),(57108,3259),(57109,3259),(57110,3260),(57111,3260),(57112,3260),(57113,3260),(57114,3261),(57115,3261),(57116,3261),(57117,3261),(57118,3262),(57119,3262),(57120,3262),(57121,3262),(57122,3263),(57123,3263),(57124,3263),(57125,3263),(57126,3264),(57127,3264),(57128,3264),(57129,3264),(57130,3265),(57131,3265),(57132,3265),(57133,3265),(57134,3266),(57135,3266),(57136,3266),(57137,3266),(57138,3267),(57139,3267),(57140,3267),(57141,3267),(57142,3268),(57143,3268),(57144,3268),(57145,3268),(57146,3269),(57147,3270),(57148,3271),(57149,3272),(57150,3273),(57151,3274),(57152,3275),(57153,3276),(57154,3277),(57155,3278),(57156,3279),(57157,3280),(57158,3281),(57159,3282),(57160,3283),(57161,3284),(57162,3285),(57163,3286),(57164,3287),(57165,3288),(57166,3289),(57167,3290),(57168,3291),(57169,3292),(57170,3293),(57171,3294),(57172,3295),(57173,3296),(57174,3297),(57175,3298),(57176,3299),(57177,3300),(57178,3301),(57179,3302),(57180,3303),(57181,3304),(57182,3305),(57183,3306),(57184,3307),(57185,3308),(57186,3309),(57187,3310),(57188,3311),(57189,3312),(57190,3313),(57191,3314),(57192,3315),(57193,3316),(57194,3317),(57195,3318),(57196,3319),(57197,3320),(57198,3321),(57199,3322),(57200,3323),(57201,3324),(57202,3325),(57203,3326),(57204,3327),(57205,3328),(57206,3329),(57207,3330),(57208,3331),(57209,3332),(57210,3333),(57211,3334),(57212,3335),(57213,3336),(57214,3337),(57215,3338),(57216,3339),(57217,3340),(57218,3341),(57219,3342),(57220,3343),(57221,3344),(57222,3345),(57223,3346),(57224,3347),(57225,3348),(57226,3349),(57227,3350),(57228,3351),(57229,3352),(57230,3353),(57231,3354),(57232,3355),(57233,3356),(57234,3357),(57235,3358),(57236,3359),(57237,3360),(57238,3361),(57239,3362),(57240,3363),(57241,3364),(57242,3365),(57243,3366),(57244,3367),(57245,3368),(57246,3269),(57247,3269),(57248,3269),(57249,3269),(57250,3269),(57251,3269),(57252,3270),(57253,3270),(57254,3270),(57255,3270),(57256,3270),(57257,3270),(57258,3271),(57259,3271),(57260,3271),(57261,3271),(57262,3271),(57263,3271),(57264,3272),(57265,3272),(57266,3272),(57267,3272),(57268,3272),(57269,3272),(57270,3273),(57271,3273),(57272,3273),(57273,3273),(57274,3273),(57275,3273),(57276,3274),(57277,3274),(57278,3274),(57279,3274),(57280,3274),(57281,3274),(57282,3275),(57283,3275),(57284,3275),(57285,3275),(57286,3275),(57287,3275),(57288,3276),(57289,3276),(57290,3276),(57291,3276),(57292,3276),(57293,3276),(57294,3277),(57295,3277),(57296,3277),(57297,3277),(57298,3277),(57299,3277),(57300,3278),(57301,3278),(57302,3278),(57303,3278),(57304,3278),(57305,3278),(57306,3279),(57307,3279),(57308,3279),(57309,3279),(57310,3279),(57311,3279),(57312,3280),(57313,3280),(57314,3280),(57315,3280),(57316,3280),(57317,3280),(57318,3281),(57319,3281),(57320,3281),(57321,3281),(57322,3281),(57323,3281),(57324,3282),(57325,3282),(57326,3282),(57327,3282),(57328,3282),(57329,3282),(57330,3283),(57331,3283),(57332,3283),(57333,3283),(57334,3283),(57335,3283),(57336,3284),(57337,3284),(57338,3284),(57339,3284),(57340,3284),(57341,3284),(57342,3285),(57343,3285),(57344,3285),(57345,3285),(57346,3285),(57347,3285),(57348,3286),(57349,3286),(57350,3286),(57351,3286),(57352,3286),(57353,3286),(57354,3287),(57355,3287),(57356,3287),(57357,3287),(57358,3287),(57359,3287),(57360,3288),(57361,3288),(57362,3288),(57363,3288),(57364,3288),(57365,3288),(57366,3289),(57367,3289),(57368,3289),(57369,3289),(57370,3289),(57371,3289),(57372,3290),(57373,3290),(57374,3290),(57375,3290),(57376,3290),(57377,3290),(57378,3291),(57379,3291),(57380,3291),(57381,3291),(57382,3291),(57383,3291),(57384,3292),(57385,3292),(57386,3292),(57387,3292),(57388,3292),(57389,3292),(57390,3293),(57391,3293),(57392,3293),(57393,3293),(57394,3293),(57395,3293),(57396,3294),(57397,3294),(57398,3294),(57399,3294),(57400,3294),(57401,3294),(57402,3295),(57403,3295),(57404,3295),(57405,3295),(57406,3295),(57407,3295),(57408,3296),(57409,3296),(57410,3296),(57411,3296),(57412,3296),(57413,3296),(57414,3297),(57415,3297),(57416,3297),(57417,3297),(57418,3297),(57419,3297),(57420,3298),(57421,3298),(57422,3298),(57423,3298),(57424,3298),(57425,3298),(57426,3299),(57427,3299),(57428,3299),(57429,3299),(57430,3299),(57431,3299),(57432,3300),(57433,3300),(57434,3300),(57435,3300),(57436,3300),(57437,3300),(57438,3301),(57439,3301),(57440,3301),(57441,3301),(57442,3301),(57443,3301),(57444,3302),(57445,3302),(57446,3302),(57447,3302),(57448,3302),(57449,3302),(57450,3303),(57451,3303),(57452,3303),(57453,3303),(57454,3303),(57455,3303),(57456,3304),(57457,3304),(57458,3304),(57459,3304),(57460,3304),(57461,3304),(57462,3305),(57463,3305),(57464,3305),(57465,3305),(57466,3305),(57467,3305),(57468,3306),(57469,3306),(57470,3306),(57471,3306),(57472,3306),(57473,3306),(57474,3307),(57475,3307),(57476,3307),(57477,3307),(57478,3307),(57479,3307),(57480,3308),(57481,3308),(57482,3308),(57483,3308),(57484,3308),(57485,3308),(57486,3309),(57487,3309),(57488,3309),(57489,3309),(57490,3309),(57491,3309),(57492,3310),(57493,3310),(57494,3310),(57495,3310),(57496,3310),(57497,3310),(57498,3311),(57499,3311),(57500,3311),(57501,3311),(57502,3311),(57503,3311),(57504,3312),(57505,3312),(57506,3312),(57507,3312),(57508,3312),(57509,3312),(57510,3313),(57511,3313),(57512,3313),(57513,3313),(57514,3313),(57515,3313),(57516,3314),(57517,3314),(57518,3314),(57519,3314),(57520,3314),(57521,3314),(57522,3315),(57523,3315),(57524,3315),(57525,3315),(57526,3315),(57527,3315),(57528,3316),(57529,3316),(57530,3316),(57531,3316),(57532,3316),(57533,3316),(57534,3317),(57535,3317),(57536,3317),(57537,3317),(57538,3317),(57539,3317),(57540,3318),(57541,3318),(57542,3318),(57543,3318),(57544,3318),(57545,3318),(57546,3319),(57547,3319),(57548,3319),(57549,3319),(57550,3319),(57551,3319),(57552,3320),(57553,3320),(57554,3320),(57555,3320),(57556,3320),(57557,3320),(57558,3321),(57559,3321),(57560,3321),(57561,3321),(57562,3321),(57563,3321),(57564,3322),(57565,3322),(57566,3322),(57567,3322),(57568,3322),(57569,3322),(57570,3323),(57571,3323),(57572,3323),(57573,3323),(57574,3323),(57575,3323),(57576,3324),(57577,3324),(57578,3324),(57579,3324),(57580,3324),(57581,3324),(57582,3325),(57583,3325),(57584,3325),(57585,3325),(57586,3325),(57587,3325),(57588,3326),(57589,3326),(57590,3326),(57591,3326),(57592,3326),(57593,3326),(57594,3327),(57595,3327),(57596,3327),(57597,3327),(57598,3327),(57599,3327),(57600,3328),(57601,3328),(57602,3328),(57603,3328),(57604,3328),(57605,3328),(57606,3329),(57607,3329),(57608,3329),(57609,3329),(57610,3329),(57611,3329),(57612,3330),(57613,3330),(57614,3330),(57615,3330),(57616,3330),(57617,3330),(57618,3331),(57619,3331),(57620,3331),(57621,3331),(57622,3331),(57623,3331),(57624,3332),(57625,3332),(57626,3332),(57627,3332),(57628,3332),(57629,3332),(57630,3333),(57631,3333),(57632,3333),(57633,3333),(57634,3333),(57635,3333),(57636,3334),(57637,3334),(57638,3334),(57639,3334),(57640,3334),(57641,3334),(57642,3335),(57643,3335),(57644,3335),(57645,3335),(57646,3335),(57647,3335),(57648,3336),(57649,3336),(57650,3336),(57651,3336),(57652,3336),(57653,3336),(57654,3337),(57655,3337),(57656,3337),(57657,3337),(57658,3337),(57659,3337),(57660,3338),(57661,3338),(57662,3338),(57663,3338),(57664,3338),(57665,3338),(57666,3339),(57667,3339),(57668,3339),(57669,3339),(57670,3339),(57671,3339),(57672,3340),(57673,3340),(57674,3340),(57675,3340),(57676,3340),(57677,3340),(57678,3341),(57679,3341),(57680,3341),(57681,3341),(57682,3341),(57683,3341),(57684,3342),(57685,3342),(57686,3342),(57687,3342),(57688,3342),(57689,3342),(57690,3343),(57691,3343),(57692,3343),(57693,3343),(57694,3343),(57695,3343),(57696,3344),(57697,3344),(57698,3344),(57699,3344),(57700,3344),(57701,3344),(57702,3345),(57703,3345),(57704,3345),(57705,3345),(57706,3345),(57707,3345),(57708,3346),(57709,3346),(57710,3346),(57711,3346),(57712,3346),(57713,3346),(57714,3347),(57715,3347),(57716,3347),(57717,3347),(57718,3347),(57719,3347),(57720,3348),(57721,3348),(57722,3348),(57723,3348),(57724,3348),(57725,3348),(57726,3349),(57727,3349),(57728,3349),(57729,3349),(57730,3349),(57731,3349),(57732,3350),(57733,3350),(57734,3350),(57735,3350),(57736,3350),(57737,3350),(57738,3351),(57739,3351),(57740,3351),(57741,3351),(57742,3351),(57743,3351),(57744,3352),(57745,3352),(57746,3352),(57747,3352),(57748,3352),(57749,3352),(57750,3353),(57751,3353),(57752,3353),(57753,3353),(57754,3353),(57755,3353),(57756,3354),(57757,3354),(57758,3354),(57759,3354),(57760,3354),(57761,3354),(57762,3355),(57763,3355),(57764,3355),(57765,3355),(57766,3355),(57767,3355),(57768,3356),(57769,3356),(57770,3356),(57771,3356),(57772,3356),(57773,3356),(57774,3357),(57775,3357),(57776,3357),(57777,3357),(57778,3357),(57779,3357),(57780,3358),(57781,3358),(57782,3358),(57783,3358),(57784,3358),(57785,3358),(57786,3359),(57787,3359),(57788,3359),(57789,3359),(57790,3359),(57791,3359),(57792,3360),(57793,3360),(57794,3360),(57795,3360),(57796,3360),(57797,3360),(57798,3361),(57799,3361),(57800,3361),(57801,3361),(57802,3361),(57803,3361),(57804,3362),(57805,3362),(57806,3362),(57807,3362),(57808,3362),(57809,3362),(57810,3363),(57811,3363),(57812,3363),(57813,3363),(57814,3363),(57815,3363),(57816,3364),(57817,3364),(57818,3364),(57819,3364),(57820,3364),(57821,3364),(57822,3365),(57823,3365),(57824,3365),(57825,3365),(57826,3365),(57827,3365),(57828,3366),(57829,3366),(57830,3366),(57831,3366),(57832,3366),(57833,3366),(57834,3367),(57835,3367),(57836,3367),(57837,3367),(57838,3367),(57839,3367),(57840,3368),(57841,3368),(57842,3368),(57843,3368),(57844,3368),(57845,3368),(57846,3269),(57847,3269),(57848,3270),(57849,3270),(57850,3271),(57851,3271),(57852,3272),(57853,3272),(57854,3273),(57855,3273),(57856,3274),(57857,3274),(57858,3275),(57859,3275),(57860,3276),(57861,3276),(57862,3277),(57863,3277),(57864,3278),(57865,3278),(57866,3279),(57867,3279),(57868,3280),(57869,3280),(57870,3281),(57871,3281),(57872,3282),(57873,3282),(57874,3283),(57875,3283),(57876,3284),(57877,3284),(57878,3285),(57879,3285),(57880,3286),(57881,3286),(57882,3287),(57883,3287),(57884,3288),(57885,3288),(57886,3289),(57887,3289),(57888,3290),(57889,3290),(57890,3291),(57891,3291),(57892,3292),(57893,3292),(57894,3293),(57895,3293),(57896,3294),(57897,3294),(57898,3295),(57899,3295),(57900,3296),(57901,3296),(57902,3297),(57903,3297),(57904,3298),(57905,3298),(57906,3299),(57907,3299),(57908,3300),(57909,3300),(57910,3301),(57911,3301),(57912,3302),(57913,3302),(57914,3303),(57915,3303),(57916,3304),(57917,3304),(57918,3305),(57919,3305),(57920,3306),(57921,3306),(57922,3307),(57923,3307),(57924,3308),(57925,3308),(57926,3309),(57927,3309),(57928,3310),(57929,3310),(57930,3311),(57931,3311),(57932,3312),(57933,3312),(57934,3313),(57935,3313),(57936,3314),(57937,3314),(57938,3315),(57939,3315),(57940,3316),(57941,3316),(57942,3317),(57943,3317),(57944,3318),(57945,3318),(57946,3319),(57947,3319),(57948,3320),(57949,3320),(57950,3321),(57951,3321),(57952,3322),(57953,3322),(57954,3323),(57955,3323),(57956,3324),(57957,3324),(57958,3325),(57959,3325),(57960,3326),(57961,3326),(57962,3327),(57963,3327),(57964,3328),(57965,3328),(57966,3329),(57967,3329),(57968,3330),(57969,3330),(57970,3331),(57971,3331),(57972,3332),(57973,3332),(57974,3333),(57975,3333),(57976,3334),(57977,3334),(57978,3335),(57979,3335),(57980,3336),(57981,3336),(57982,3337),(57983,3337),(57984,3338),(57985,3338),(57986,3339),(57987,3339),(57988,3340),(57989,3340),(57990,3341),(57991,3341),(57992,3342),(57993,3342),(57994,3343),(57995,3343),(57996,3344),(57997,3344),(57998,3345),(57999,3345),(58000,3346),(58001,3346),(58002,3347),(58003,3347),(58004,3348),(58005,3348),(58006,3349),(58007,3349),(58008,3350),(58009,3350),(58010,3351),(58011,3351),(58012,3352),(58013,3352),(58014,3353),(58015,3353),(58016,3354),(58017,3354),(58018,3355),(58019,3355),(58020,3356),(58021,3356),(58022,3357),(58023,3357),(58024,3358),(58025,3358),(58026,3359),(58027,3359),(58028,3360),(58029,3360),(58030,3361),(58031,3361),(58032,3362),(58033,3362),(58034,3363),(58035,3363),(58036,3364),(58037,3364),(58038,3365),(58039,3365),(58040,3366),(58041,3366),(58042,3367),(58043,3367),(58044,3368),(58045,3368),(58046,3269),(58047,3269),(58048,3269),(58049,3270),(58050,3270),(58051,3270),(58052,3271),(58053,3271),(58054,3271),(58055,3272),(58056,3272),(58057,3272),(58058,3273),(58059,3273),(58060,3273),(58061,3274),(58062,3274),(58063,3274),(58064,3275),(58065,3275),(58066,3275),(58067,3276),(58068,3276),(58069,3276),(58070,3277),(58071,3277),(58072,3277),(58073,3278),(58074,3278),(58075,3278),(58076,3279),(58077,3279),(58078,3279),(58079,3280),(58080,3280),(58081,3280),(58082,3281),(58083,3281),(58084,3281),(58085,3282),(58086,3282),(58087,3282),(58088,3283),(58089,3283),(58090,3283),(58091,3284),(58092,3284),(58093,3284),(58094,3285),(58095,3285),(58096,3285),(58097,3286),(58098,3286),(58099,3286),(58100,3287),(58101,3287),(58102,3287),(58103,3288),(58104,3288),(58105,3288),(58106,3289),(58107,3289),(58108,3289),(58109,3290),(58110,3290),(58111,3290),(58112,3291),(58113,3291),(58114,3291),(58115,3292),(58116,3292),(58117,3292),(58118,3293),(58119,3293),(58120,3293),(58121,3294),(58122,3294),(58123,3294),(58124,3295),(58125,3295),(58126,3295),(58127,3296),(58128,3296),(58129,3296),(58130,3297),(58131,3297),(58132,3297),(58133,3298),(58134,3298),(58135,3298),(58136,3299),(58137,3299),(58138,3299),(58139,3300),(58140,3300),(58141,3300),(58142,3301),(58143,3301),(58144,3301),(58145,3302),(58146,3302),(58147,3302),(58148,3303),(58149,3303),(58150,3303),(58151,3304),(58152,3304),(58153,3304),(58154,3305),(58155,3305),(58156,3305),(58157,3306),(58158,3306),(58159,3306),(58160,3307),(58161,3307),(58162,3307),(58163,3308),(58164,3308),(58165,3308),(58166,3309),(58167,3309),(58168,3309),(58169,3310),(58170,3310),(58171,3310),(58172,3311),(58173,3311),(58174,3311),(58175,3312),(58176,3312),(58177,3312),(58178,3313),(58179,3313),(58180,3313),(58181,3314),(58182,3314),(58183,3314),(58184,3315),(58185,3315),(58186,3315),(58187,3316),(58188,3316),(58189,3316),(58190,3317),(58191,3317),(58192,3317),(58193,3318),(58194,3318),(58195,3318),(58196,3319),(58197,3319),(58198,3319),(58199,3320),(58200,3320),(58201,3320),(58202,3321),(58203,3321),(58204,3321),(58205,3322),(58206,3322),(58207,3322),(58208,3323),(58209,3323),(58210,3323),(58211,3324),(58212,3324),(58213,3324),(58214,3325),(58215,3325),(58216,3325),(58217,3326),(58218,3326),(58219,3326),(58220,3327),(58221,3327),(58222,3327),(58223,3328),(58224,3328),(58225,3328),(58226,3329),(58227,3329),(58228,3329),(58229,3330),(58230,3330),(58231,3330),(58232,3331),(58233,3331),(58234,3331),(58235,3332),(58236,3332),(58237,3332),(58238,3333),(58239,3333),(58240,3333),(58241,3334),(58242,3334),(58243,3334),(58244,3335),(58245,3335),(58246,3335),(58247,3336),(58248,3336),(58249,3336),(58250,3337),(58251,3337),(58252,3337),(58253,3338),(58254,3338),(58255,3338),(58256,3339),(58257,3339),(58258,3339),(58259,3340),(58260,3340),(58261,3340),(58262,3341),(58263,3341),(58264,3341),(58265,3342),(58266,3342),(58267,3342),(58268,3343),(58269,3343),(58270,3343),(58271,3344),(58272,3344),(58273,3344),(58274,3345),(58275,3345),(58276,3345),(58277,3346),(58278,3346),(58279,3346),(58280,3347),(58281,3347),(58282,3347),(58283,3348),(58284,3348),(58285,3348),(58286,3349),(58287,3349),(58288,3349),(58289,3350),(58290,3350),(58291,3350),(58292,3351),(58293,3351),(58294,3351),(58295,3352),(58296,3352),(58297,3352),(58298,3353),(58299,3353),(58300,3353),(58301,3354),(58302,3354),(58303,3354),(58304,3355),(58305,3355),(58306,3355),(58307,3356),(58308,3356),(58309,3356),(58310,3357),(58311,3357),(58312,3357),(58313,3358),(58314,3358),(58315,3358),(58316,3359),(58317,3359),(58318,3359),(58319,3360),(58320,3360),(58321,3360),(58322,3361),(58323,3361),(58324,3361),(58325,3362),(58326,3362),(58327,3362),(58328,3363),(58329,3363),(58330,3363),(58331,3364),(58332,3364),(58333,3364),(58334,3365),(58335,3365),(58336,3365),(58337,3366),(58338,3366),(58339,3366),(58340,3367),(58341,3367),(58342,3367),(58343,3368),(58344,3368),(58345,3368),(58346,3269),(58347,3269),(58348,3269),(58349,3269),(58350,3270),(58351,3270),(58352,3270),(58353,3270),(58354,3271),(58355,3271),(58356,3271),(58357,3271),(58358,3272),(58359,3272),(58360,3272),(58361,3272),(58362,3273),(58363,3273),(58364,3273),(58365,3273),(58366,3274),(58367,3274),(58368,3274),(58369,3274),(58370,3275),(58371,3275),(58372,3275),(58373,3275),(58374,3276),(58375,3276),(58376,3276),(58377,3276),(58378,3277),(58379,3277),(58380,3277),(58381,3277),(58382,3278),(58383,3278),(58384,3278),(58385,3278),(58386,3279),(58387,3279),(58388,3279),(58389,3279),(58390,3280),(58391,3280),(58392,3280),(58393,3280),(58394,3281),(58395,3281),(58396,3281),(58397,3281),(58398,3282),(58399,3282),(58400,3282),(58401,3282),(58402,3283),(58403,3283),(58404,3283),(58405,3283),(58406,3284),(58407,3284),(58408,3284),(58409,3284),(58410,3285),(58411,3285),(58412,3285),(58413,3285),(58414,3286),(58415,3286),(58416,3286),(58417,3286),(58418,3287),(58419,3287),(58420,3287),(58421,3287),(58422,3288),(58423,3288),(58424,3288),(58425,3288),(58426,3289),(58427,3289),(58428,3289),(58429,3289),(58430,3290),(58431,3290),(58432,3290),(58433,3290),(58434,3291),(58435,3291),(58436,3291),(58437,3291),(58438,3292),(58439,3292),(58440,3292),(58441,3292),(58442,3293),(58443,3293),(58444,3293),(58445,3293),(58446,3294),(58447,3294),(58448,3294),(58449,3294),(58450,3295),(58451,3295),(58452,3295),(58453,3295),(58454,3296),(58455,3296),(58456,3296),(58457,3296),(58458,3297),(58459,3297),(58460,3297),(58461,3297),(58462,3298),(58463,3298),(58464,3298),(58465,3298),(58466,3299),(58467,3299),(58468,3299),(58469,3299),(58470,3300),(58471,3300),(58472,3300),(58473,3300),(58474,3301),(58475,3301),(58476,3301),(58477,3301),(58478,3302),(58479,3302),(58480,3302),(58481,3302),(58482,3303),(58483,3303),(58484,3303),(58485,3303),(58486,3304),(58487,3304),(58488,3304),(58489,3304),(58490,3305),(58491,3305),(58492,3305),(58493,3305),(58494,3306),(58495,3306),(58496,3306),(58497,3306),(58498,3307),(58499,3307),(58500,3307),(58501,3307),(58502,3308),(58503,3308),(58504,3308),(58505,3308),(58506,3309),(58507,3309),(58508,3309),(58509,3309),(58510,3310),(58511,3310),(58512,3310),(58513,3310),(58514,3311),(58515,3311),(58516,3311),(58517,3311),(58518,3312),(58519,3312),(58520,3312),(58521,3312),(58522,3313),(58523,3313),(58524,3313),(58525,3313),(58526,3314),(58527,3314),(58528,3314),(58529,3314),(58530,3315),(58531,3315),(58532,3315),(58533,3315),(58534,3316),(58535,3316),(58536,3316),(58537,3316),(58538,3317),(58539,3317),(58540,3317),(58541,3317),(58542,3318),(58543,3318),(58544,3318),(58545,3318),(58546,3319),(58547,3319),(58548,3319),(58549,3319),(58550,3320),(58551,3320),(58552,3320),(58553,3320),(58554,3321),(58555,3321),(58556,3321),(58557,3321),(58558,3322),(58559,3322),(58560,3322),(58561,3322),(58562,3323),(58563,3323),(58564,3323),(58565,3323),(58566,3324),(58567,3324),(58568,3324),(58569,3324),(58570,3325),(58571,3325),(58572,3325),(58573,3325),(58574,3326),(58575,3326),(58576,3326),(58577,3326),(58578,3327),(58579,3327),(58580,3327),(58581,3327),(58582,3328),(58583,3328),(58584,3328),(58585,3328),(58586,3329),(58587,3329),(58588,3329),(58589,3329),(58590,3330),(58591,3330),(58592,3330),(58593,3330),(58594,3331),(58595,3331),(58596,3331),(58597,3331),(58598,3332),(58599,3332),(58600,3332),(58601,3332),(58602,3333),(58603,3333),(58604,3333),(58605,3333),(58606,3334),(58607,3334),(58608,3334),(58609,3334),(58610,3335),(58611,3335),(58612,3335),(58613,3335),(58614,3336),(58615,3336),(58616,3336),(58617,3336),(58618,3337),(58619,3337),(58620,3337),(58621,3337),(58622,3338),(58623,3338),(58624,3338),(58625,3338),(58626,3339),(58627,3339),(58628,3339),(58629,3339),(58630,3340),(58631,3340),(58632,3340),(58633,3340),(58634,3341),(58635,3341),(58636,3341),(58637,3341),(58638,3342),(58639,3342),(58640,3342),(58641,3342),(58642,3343),(58643,3343),(58644,3343),(58645,3343),(58646,3344),(58647,3344),(58648,3344),(58649,3344),(58650,3345),(58651,3345),(58652,3345),(58653,3345),(58654,3346),(58655,3346),(58656,3346),(58657,3346),(58658,3347),(58659,3347),(58660,3347),(58661,3347),(58662,3348),(58663,3348),(58664,3348),(58665,3348),(58666,3349),(58667,3349),(58668,3349),(58669,3349),(58670,3350),(58671,3350),(58672,3350),(58673,3350),(58674,3351),(58675,3351),(58676,3351),(58677,3351),(58678,3352),(58679,3352),(58680,3352),(58681,3352),(58682,3353),(58683,3353),(58684,3353),(58685,3353),(58686,3354),(58687,3354),(58688,3354),(58689,3354),(58690,3355),(58691,3355),(58692,3355),(58693,3355),(58694,3356),(58695,3356),(58696,3356),(58697,3356),(58698,3357),(58699,3357),(58700,3357),(58701,3357),(58702,3358),(58703,3358),(58704,3358),(58705,3358),(58706,3359),(58707,3359),(58708,3359),(58709,3359),(58710,3360),(58711,3360),(58712,3360),(58713,3360),(58714,3361),(58715,3361),(58716,3361),(58717,3361),(58718,3362),(58719,3362),(58720,3362),(58721,3362),(58722,3363),(58723,3363),(58724,3363),(58725,3363),(58726,3364),(58727,3364),(58728,3364),(58729,3364),(58730,3365),(58731,3365),(58732,3365),(58733,3365),(58734,3366),(58735,3366),(58736,3366),(58737,3366),(58738,3367),(58739,3367),(58740,3367),(58741,3367),(58742,3368),(58743,3368),(58744,3368),(58745,3368),(58746,3369),(58747,3370),(58748,3371),(58749,3372),(58750,3373),(58751,3374),(58752,3375),(58753,3376),(58754,3377),(58755,3378),(58756,3379),(58757,3380),(58758,3381),(58759,3382),(58760,3383),(58761,3384),(58762,3385),(58763,3386),(58764,3387),(58765,3388),(58766,3389),(58767,3390),(58768,3391),(58769,3392),(58770,3393),(58771,3394),(58772,3395),(58773,3396),(58774,3397),(58775,3398),(58776,3399),(58777,3400),(58778,3401),(58779,3402),(58780,3403),(58781,3404),(58782,3405),(58783,3406),(58784,3407),(58785,3408),(58786,3409),(58787,3410),(58788,3411),(58789,3412),(58790,3413),(58791,3414),(58792,3415),(58793,3416),(58794,3417),(58795,3418),(58796,3419),(58797,3420),(58798,3421),(58799,3422),(58800,3423),(58801,3424),(58802,3425),(58803,3426),(58804,3427),(58805,3428),(58806,3429),(58807,3430),(58808,3431),(58809,3432),(58810,3433),(58811,3434),(58812,3435),(58813,3436),(58814,3437),(58815,3438),(58816,3439),(58817,3440),(58818,3441),(58819,3442),(58820,3443),(58821,3444),(58822,3445),(58823,3446),(58824,3447),(58825,3448),(58826,3449),(58827,3450),(58828,3451),(58829,3452),(58830,3453),(58831,3454),(58832,3455),(58833,3456),(58834,3457),(58835,3458),(58836,3459),(58837,3460),(58838,3461),(58839,3462),(58840,3463),(58841,3464),(58842,3465),(58843,3466),(58844,3467),(58845,3468),(58846,3369),(58847,3369),(58848,3369),(58849,3369),(58850,3369),(58851,3369),(58852,3370),(58853,3370),(58854,3370),(58855,3370),(58856,3370),(58857,3370),(58858,3371),(58859,3371),(58860,3371),(58861,3371),(58862,3371),(58863,3371),(58864,3372),(58865,3372),(58866,3372),(58867,3372),(58868,3372),(58869,3372),(58870,3373),(58871,3373),(58872,3373),(58873,3373),(58874,3373),(58875,3373),(58876,3374),(58877,3374),(58878,3374),(58879,3374),(58880,3374),(58881,3374),(58882,3375),(58883,3375),(58884,3375),(58885,3375),(58886,3375),(58887,3375),(58888,3376),(58889,3376),(58890,3376),(58891,3376),(58892,3376),(58893,3376),(58894,3377),(58895,3377),(58896,3377),(58897,3377),(58898,3377),(58899,3377),(58900,3378),(58901,3378),(58902,3378),(58903,3378),(58904,3378),(58905,3378),(58906,3379),(58907,3379),(58908,3379),(58909,3379),(58910,3379),(58911,3379),(58912,3380),(58913,3380),(58914,3380),(58915,3380),(58916,3380),(58917,3380),(58918,3381),(58919,3381),(58920,3381),(58921,3381),(58922,3381),(58923,3381),(58924,3382),(58925,3382),(58926,3382),(58927,3382),(58928,3382),(58929,3382),(58930,3383),(58931,3383),(58932,3383),(58933,3383),(58934,3383),(58935,3383),(58936,3384),(58937,3384),(58938,3384),(58939,3384),(58940,3384),(58941,3384),(58942,3385),(58943,3385),(58944,3385),(58945,3385),(58946,3385),(58947,3385),(58948,3386),(58949,3386),(58950,3386),(58951,3386),(58952,3386),(58953,3386),(58954,3387),(58955,3387),(58956,3387),(58957,3387),(58958,3387),(58959,3387),(58960,3388),(58961,3388),(58962,3388),(58963,3388),(58964,3388),(58965,3388),(58966,3389),(58967,3389),(58968,3389),(58969,3389),(58970,3389),(58971,3389),(58972,3390),(58973,3390),(58974,3390),(58975,3390),(58976,3390),(58977,3390),(58978,3391),(58979,3391),(58980,3391),(58981,3391),(58982,3391),(58983,3391),(58984,3392),(58985,3392),(58986,3392),(58987,3392),(58988,3392),(58989,3392),(58990,3393),(58991,3393),(58992,3393),(58993,3393),(58994,3393),(58995,3393),(58996,3394),(58997,3394),(58998,3394),(58999,3394),(59000,3394),(59001,3394),(59002,3395),(59003,3395),(59004,3395),(59005,3395),(59006,3395),(59007,3395),(59008,3396),(59009,3396),(59010,3396),(59011,3396),(59012,3396),(59013,3396),(59014,3397),(59015,3397),(59016,3397),(59017,3397),(59018,3397),(59019,3397),(59020,3398),(59021,3398),(59022,3398),(59023,3398),(59024,3398),(59025,3398),(59026,3399),(59027,3399),(59028,3399),(59029,3399),(59030,3399),(59031,3399),(59032,3400),(59033,3400),(59034,3400),(59035,3400),(59036,3400),(59037,3400),(59038,3401),(59039,3401),(59040,3401),(59041,3401),(59042,3401),(59043,3401),(59044,3402),(59045,3402),(59046,3402),(59047,3402),(59048,3402),(59049,3402),(59050,3403),(59051,3403),(59052,3403),(59053,3403),(59054,3403),(59055,3403),(59056,3404),(59057,3404),(59058,3404),(59059,3404),(59060,3404),(59061,3404),(59062,3405),(59063,3405),(59064,3405),(59065,3405),(59066,3405),(59067,3405),(59068,3406),(59069,3406),(59070,3406),(59071,3406),(59072,3406),(59073,3406),(59074,3407),(59075,3407),(59076,3407),(59077,3407),(59078,3407),(59079,3407),(59080,3408),(59081,3408),(59082,3408),(59083,3408),(59084,3408),(59085,3408),(59086,3409),(59087,3409),(59088,3409),(59089,3409),(59090,3409),(59091,3409),(59092,3410),(59093,3410),(59094,3410),(59095,3410),(59096,3410),(59097,3410),(59098,3411),(59099,3411),(59100,3411),(59101,3411),(59102,3411),(59103,3411),(59104,3412),(59105,3412),(59106,3412),(59107,3412),(59108,3412),(59109,3412),(59110,3413),(59111,3413),(59112,3413),(59113,3413),(59114,3413),(59115,3413),(59116,3414),(59117,3414),(59118,3414),(59119,3414),(59120,3414),(59121,3414),(59122,3415),(59123,3415),(59124,3415),(59125,3415),(59126,3415),(59127,3415),(59128,3416),(59129,3416),(59130,3416),(59131,3416),(59132,3416),(59133,3416),(59134,3417),(59135,3417),(59136,3417),(59137,3417),(59138,3417),(59139,3417),(59140,3418),(59141,3418),(59142,3418),(59143,3418),(59144,3418),(59145,3418),(59146,3419),(59147,3419),(59148,3419),(59149,3419),(59150,3419),(59151,3419),(59152,3420),(59153,3420),(59154,3420),(59155,3420),(59156,3420),(59157,3420),(59158,3421),(59159,3421),(59160,3421),(59161,3421),(59162,3421),(59163,3421),(59164,3422),(59165,3422),(59166,3422),(59167,3422),(59168,3422),(59169,3422),(59170,3423),(59171,3423),(59172,3423),(59173,3423),(59174,3423),(59175,3423),(59176,3424),(59177,3424),(59178,3424),(59179,3424),(59180,3424),(59181,3424),(59182,3425),(59183,3425),(59184,3425),(59185,3425),(59186,3425),(59187,3425),(59188,3426),(59189,3426),(59190,3426),(59191,3426),(59192,3426),(59193,3426),(59194,3427),(59195,3427),(59196,3427),(59197,3427),(59198,3427),(59199,3427),(59200,3428),(59201,3428),(59202,3428),(59203,3428),(59204,3428),(59205,3428),(59206,3429),(59207,3429),(59208,3429),(59209,3429),(59210,3429),(59211,3429),(59212,3430),(59213,3430),(59214,3430),(59215,3430),(59216,3430),(59217,3430),(59218,3431),(59219,3431),(59220,3431),(59221,3431),(59222,3431),(59223,3431),(59224,3432),(59225,3432),(59226,3432),(59227,3432),(59228,3432),(59229,3432),(59230,3433),(59231,3433),(59232,3433),(59233,3433),(59234,3433),(59235,3433),(59236,3434),(59237,3434),(59238,3434),(59239,3434),(59240,3434),(59241,3434),(59242,3435),(59243,3435),(59244,3435),(59245,3435),(59246,3435),(59247,3435),(59248,3436),(59249,3436),(59250,3436),(59251,3436),(59252,3436),(59253,3436),(59254,3437),(59255,3437),(59256,3437),(59257,3437),(59258,3437),(59259,3437),(59260,3438),(59261,3438),(59262,3438),(59263,3438),(59264,3438),(59265,3438),(59266,3439),(59267,3439),(59268,3439),(59269,3439),(59270,3439),(59271,3439),(59272,3440),(59273,3440),(59274,3440),(59275,3440),(59276,3440),(59277,3440),(59278,3441),(59279,3441),(59280,3441),(59281,3441),(59282,3441),(59283,3441),(59284,3442),(59285,3442),(59286,3442),(59287,3442),(59288,3442),(59289,3442),(59290,3443),(59291,3443),(59292,3443),(59293,3443),(59294,3443),(59295,3443),(59296,3444),(59297,3444),(59298,3444),(59299,3444),(59300,3444),(59301,3444),(59302,3445),(59303,3445),(59304,3445),(59305,3445),(59306,3445),(59307,3445),(59308,3446),(59309,3446),(59310,3446),(59311,3446),(59312,3446),(59313,3446),(59314,3447),(59315,3447),(59316,3447),(59317,3447),(59318,3447),(59319,3447),(59320,3448),(59321,3448),(59322,3448),(59323,3448),(59324,3448),(59325,3448),(59326,3449),(59327,3449),(59328,3449),(59329,3449),(59330,3449),(59331,3449),(59332,3450),(59333,3450),(59334,3450),(59335,3450),(59336,3450),(59337,3450),(59338,3451),(59339,3451),(59340,3451),(59341,3451),(59342,3451),(59343,3451),(59344,3452),(59345,3452),(59346,3452),(59347,3452),(59348,3452),(59349,3452),(59350,3453),(59351,3453),(59352,3453),(59353,3453),(59354,3453),(59355,3453),(59356,3454),(59357,3454),(59358,3454),(59359,3454),(59360,3454),(59361,3454),(59362,3455),(59363,3455),(59364,3455),(59365,3455),(59366,3455),(59367,3455),(59368,3456),(59369,3456),(59370,3456),(59371,3456),(59372,3456),(59373,3456),(59374,3457),(59375,3457),(59376,3457),(59377,3457),(59378,3457),(59379,3457),(59380,3458),(59381,3458),(59382,3458),(59383,3458),(59384,3458),(59385,3458),(59386,3459),(59387,3459),(59388,3459),(59389,3459),(59390,3459),(59391,3459),(59392,3460),(59393,3460),(59394,3460),(59395,3460),(59396,3460),(59397,3460),(59398,3461),(59399,3461),(59400,3461),(59401,3461),(59402,3461),(59403,3461),(59404,3462),(59405,3462),(59406,3462),(59407,3462),(59408,3462),(59409,3462),(59410,3463),(59411,3463),(59412,3463),(59413,3463),(59414,3463),(59415,3463),(59416,3464),(59417,3464),(59418,3464),(59419,3464),(59420,3464),(59421,3464),(59422,3465),(59423,3465),(59424,3465),(59425,3465),(59426,3465),(59427,3465),(59428,3466),(59429,3466),(59430,3466),(59431,3466),(59432,3466),(59433,3466),(59434,3467),(59435,3467),(59436,3467),(59437,3467),(59438,3467),(59439,3467),(59440,3468),(59441,3468),(59442,3468),(59443,3468),(59444,3468),(59445,3468),(59446,3369),(59447,3369),(59448,3370),(59449,3370),(59450,3371),(59451,3371),(59452,3372),(59453,3372),(59454,3373),(59455,3373),(59456,3374),(59457,3374),(59458,3375),(59459,3375),(59460,3376),(59461,3376),(59462,3377),(59463,3377),(59464,3378),(59465,3378),(59466,3379),(59467,3379),(59468,3380),(59469,3380),(59470,3381),(59471,3381),(59472,3382),(59473,3382),(59474,3383),(59475,3383),(59476,3384),(59477,3384),(59478,3385),(59479,3385),(59480,3386),(59481,3386),(59482,3387),(59483,3387),(59484,3388),(59485,3388),(59486,3389),(59487,3389),(59488,3390),(59489,3390),(59490,3391),(59491,3391),(59492,3392),(59493,3392),(59494,3393),(59495,3393),(59496,3394),(59497,3394),(59498,3395),(59499,3395),(59500,3396),(59501,3396),(59502,3397),(59503,3397),(59504,3398),(59505,3398),(59506,3399),(59507,3399),(59508,3400),(59509,3400),(59510,3401),(59511,3401),(59512,3402),(59513,3402),(59514,3403),(59515,3403),(59516,3404),(59517,3404),(59518,3405),(59519,3405),(59520,3406),(59521,3406),(59522,3407),(59523,3407),(59524,3408),(59525,3408),(59526,3409),(59527,3409),(59528,3410),(59529,3410),(59530,3411),(59531,3411),(59532,3412),(59533,3412),(59534,3413),(59535,3413),(59536,3414),(59537,3414),(59538,3415),(59539,3415),(59540,3416),(59541,3416),(59542,3417),(59543,3417),(59544,3418),(59545,3418),(59546,3419),(59547,3419),(59548,3420),(59549,3420),(59550,3421),(59551,3421),(59552,3422),(59553,3422),(59554,3423),(59555,3423),(59556,3424),(59557,3424),(59558,3425),(59559,3425),(59560,3426),(59561,3426),(59562,3427),(59563,3427),(59564,3428),(59565,3428),(59566,3429),(59567,3429),(59568,3430),(59569,3430),(59570,3431),(59571,3431),(59572,3432),(59573,3432),(59574,3433),(59575,3433),(59576,3434),(59577,3434),(59578,3435),(59579,3435),(59580,3436),(59581,3436),(59582,3437),(59583,3437),(59584,3438),(59585,3438),(59586,3439),(59587,3439),(59588,3440),(59589,3440),(59590,3441),(59591,3441),(59592,3442),(59593,3442),(59594,3443),(59595,3443),(59596,3444),(59597,3444),(59598,3445),(59599,3445),(59600,3446),(59601,3446),(59602,3447),(59603,3447),(59604,3448),(59605,3448),(59606,3449),(59607,3449),(59608,3450),(59609,3450),(59610,3451),(59611,3451),(59612,3452),(59613,3452),(59614,3453),(59615,3453),(59616,3454),(59617,3454),(59618,3455),(59619,3455),(59620,3456),(59621,3456),(59622,3457),(59623,3457),(59624,3458),(59625,3458),(59626,3459),(59627,3459),(59628,3460),(59629,3460),(59630,3461),(59631,3461),(59632,3462),(59633,3462),(59634,3463),(59635,3463),(59636,3464),(59637,3464),(59638,3465),(59639,3465),(59640,3466),(59641,3466),(59642,3467),(59643,3467),(59644,3468),(59645,3468),(59646,3369),(59647,3369),(59648,3369),(59649,3370),(59650,3370),(59651,3370),(59652,3371),(59653,3371),(59654,3371),(59655,3372),(59656,3372),(59657,3372),(59658,3373),(59659,3373),(59660,3373),(59661,3374),(59662,3374),(59663,3374),(59664,3375),(59665,3375),(59666,3375),(59667,3376),(59668,3376),(59669,3376),(59670,3377),(59671,3377),(59672,3377),(59673,3378),(59674,3378),(59675,3378),(59676,3379),(59677,3379),(59678,3379),(59679,3380),(59680,3380),(59681,3380),(59682,3381),(59683,3381),(59684,3381),(59685,3382),(59686,3382),(59687,3382),(59688,3383),(59689,3383),(59690,3383),(59691,3384),(59692,3384),(59693,3384),(59694,3385),(59695,3385),(59696,3385),(59697,3386),(59698,3386),(59699,3386),(59700,3387),(59701,3387),(59702,3387),(59703,3388),(59704,3388),(59705,3388),(59706,3389),(59707,3389),(59708,3389),(59709,3390),(59710,3390),(59711,3390),(59712,3391),(59713,3391),(59714,3391),(59715,3392),(59716,3392),(59717,3392),(59718,3393),(59719,3393),(59720,3393),(59721,3394),(59722,3394),(59723,3394),(59724,3395),(59725,3395),(59726,3395),(59727,3396),(59728,3396),(59729,3396),(59730,3397),(59731,3397),(59732,3397),(59733,3398),(59734,3398),(59735,3398),(59736,3399),(59737,3399),(59738,3399),(59739,3400),(59740,3400),(59741,3400),(59742,3401),(59743,3401),(59744,3401),(59745,3402),(59746,3402),(59747,3402),(59748,3403),(59749,3403),(59750,3403),(59751,3404),(59752,3404),(59753,3404),(59754,3405),(59755,3405),(59756,3405),(59757,3406),(59758,3406),(59759,3406),(59760,3407),(59761,3407),(59762,3407),(59763,3408),(59764,3408),(59765,3408),(59766,3409),(59767,3409),(59768,3409),(59769,3410),(59770,3410),(59771,3410),(59772,3411),(59773,3411),(59774,3411),(59775,3412),(59776,3412),(59777,3412),(59778,3413),(59779,3413),(59780,3413),(59781,3414),(59782,3414),(59783,3414),(59784,3415),(59785,3415),(59786,3415),(59787,3416),(59788,3416),(59789,3416),(59790,3417),(59791,3417),(59792,3417),(59793,3418),(59794,3418),(59795,3418),(59796,3419),(59797,3419),(59798,3419),(59799,3420),(59800,3420),(59801,3420),(59802,3421),(59803,3421),(59804,3421),(59805,3422),(59806,3422),(59807,3422),(59808,3423),(59809,3423),(59810,3423),(59811,3424),(59812,3424),(59813,3424),(59814,3425),(59815,3425),(59816,3425),(59817,3426),(59818,3426),(59819,3426),(59820,3427),(59821,3427),(59822,3427),(59823,3428),(59824,3428),(59825,3428),(59826,3429),(59827,3429),(59828,3429),(59829,3430),(59830,3430),(59831,3430),(59832,3431),(59833,3431),(59834,3431),(59835,3432),(59836,3432),(59837,3432),(59838,3433),(59839,3433),(59840,3433),(59841,3434),(59842,3434),(59843,3434),(59844,3435),(59845,3435),(59846,3435),(59847,3436),(59848,3436),(59849,3436),(59850,3437),(59851,3437),(59852,3437),(59853,3438),(59854,3438),(59855,3438),(59856,3439),(59857,3439),(59858,3439),(59859,3440),(59860,3440),(59861,3440),(59862,3441),(59863,3441),(59864,3441),(59865,3442),(59866,3442),(59867,3442),(59868,3443),(59869,3443),(59870,3443),(59871,3444),(59872,3444),(59873,3444),(59874,3445),(59875,3445),(59876,3445),(59877,3446),(59878,3446),(59879,3446),(59880,3447),(59881,3447),(59882,3447),(59883,3448),(59884,3448),(59885,3448),(59886,3449),(59887,3449),(59888,3449),(59889,3450),(59890,3450),(59891,3450),(59892,3451),(59893,3451),(59894,3451),(59895,3452),(59896,3452),(59897,3452),(59898,3453),(59899,3453),(59900,3453),(59901,3454),(59902,3454),(59903,3454),(59904,3455),(59905,3455),(59906,3455),(59907,3456),(59908,3456),(59909,3456),(59910,3457),(59911,3457),(59912,3457),(59913,3458),(59914,3458),(59915,3458),(59916,3459),(59917,3459),(59918,3459),(59919,3460),(59920,3460),(59921,3460),(59922,3461),(59923,3461),(59924,3461),(59925,3462),(59926,3462),(59927,3462),(59928,3463),(59929,3463),(59930,3463),(59931,3464),(59932,3464),(59933,3464),(59934,3465),(59935,3465),(59936,3465),(59937,3466),(59938,3466),(59939,3466),(59940,3467),(59941,3467),(59942,3467),(59943,3468),(59944,3468),(59945,3468),(59946,3369),(59947,3369),(59948,3369),(59949,3369),(59950,3370),(59951,3370),(59952,3370),(59953,3370),(59954,3371),(59955,3371),(59956,3371),(59957,3371),(59958,3372),(59959,3372),(59960,3372),(59961,3372),(59962,3373),(59963,3373),(59964,3373),(59965,3373),(59966,3374),(59967,3374),(59968,3374),(59969,3374),(59970,3375),(59971,3375),(59972,3375),(59973,3375),(59974,3376),(59975,3376),(59976,3376),(59977,3376),(59978,3377),(59979,3377),(59980,3377),(59981,3377),(59982,3378),(59983,3378),(59984,3378),(59985,3378),(59986,3379),(59987,3379),(59988,3379),(59989,3379),(59990,3380),(59991,3380),(59992,3380),(59993,3380),(59994,3381),(59995,3381),(59996,3381),(59997,3381),(59998,3382),(59999,3382),(60000,3382),(60001,3382),(60002,3383),(60003,3383),(60004,3383),(60005,3383),(60006,3384),(60007,3384),(60008,3384),(60009,3384),(60010,3385),(60011,3385),(60012,3385),(60013,3385),(60014,3386),(60015,3386),(60016,3386),(60017,3386),(60018,3387),(60019,3387),(60020,3387),(60021,3387),(60022,3388),(60023,3388),(60024,3388),(60025,3388),(60026,3389),(60027,3389),(60028,3389),(60029,3389),(60030,3390),(60031,3390),(60032,3390),(60033,3390),(60034,3391),(60035,3391),(60036,3391),(60037,3391),(60038,3392),(60039,3392),(60040,3392),(60041,3392),(60042,3393),(60043,3393),(60044,3393),(60045,3393),(60046,3394),(60047,3394),(60048,3394),(60049,3394),(60050,3395),(60051,3395),(60052,3395),(60053,3395),(60054,3396),(60055,3396),(60056,3396),(60057,3396),(60058,3397),(60059,3397),(60060,3397),(60061,3397),(60062,3398),(60063,3398),(60064,3398),(60065,3398),(60066,3399),(60067,3399),(60068,3399),(60069,3399),(60070,3400),(60071,3400),(60072,3400),(60073,3400),(60074,3401),(60075,3401),(60076,3401),(60077,3401),(60078,3402),(60079,3402),(60080,3402),(60081,3402),(60082,3403),(60083,3403),(60084,3403),(60085,3403),(60086,3404),(60087,3404),(60088,3404),(60089,3404),(60090,3405),(60091,3405),(60092,3405),(60093,3405),(60094,3406),(60095,3406),(60096,3406),(60097,3406),(60098,3407),(60099,3407),(60100,3407),(60101,3407),(60102,3408),(60103,3408),(60104,3408),(60105,3408),(60106,3409),(60107,3409),(60108,3409),(60109,3409),(60110,3410),(60111,3410),(60112,3410),(60113,3410),(60114,3411),(60115,3411),(60116,3411),(60117,3411),(60118,3412),(60119,3412),(60120,3412),(60121,3412),(60122,3413),(60123,3413),(60124,3413),(60125,3413),(60126,3414),(60127,3414),(60128,3414),(60129,3414),(60130,3415),(60131,3415),(60132,3415),(60133,3415),(60134,3416),(60135,3416),(60136,3416),(60137,3416),(60138,3417),(60139,3417),(60140,3417),(60141,3417),(60142,3418),(60143,3418),(60144,3418),(60145,3418),(60146,3419),(60147,3419),(60148,3419),(60149,3419),(60150,3420),(60151,3420),(60152,3420),(60153,3420),(60154,3421),(60155,3421),(60156,3421),(60157,3421),(60158,3422),(60159,3422),(60160,3422),(60161,3422),(60162,3423),(60163,3423),(60164,3423),(60165,3423),(60166,3424),(60167,3424),(60168,3424),(60169,3424),(60170,3425),(60171,3425),(60172,3425),(60173,3425),(60174,3426),(60175,3426),(60176,3426),(60177,3426),(60178,3427),(60179,3427),(60180,3427),(60181,3427),(60182,3428),(60183,3428),(60184,3428),(60185,3428),(60186,3429),(60187,3429),(60188,3429),(60189,3429),(60190,3430),(60191,3430),(60192,3430),(60193,3430),(60194,3431),(60195,3431),(60196,3431),(60197,3431),(60198,3432),(60199,3432),(60200,3432),(60201,3432),(60202,3433),(60203,3433),(60204,3433),(60205,3433),(60206,3434),(60207,3434),(60208,3434),(60209,3434),(60210,3435),(60211,3435),(60212,3435),(60213,3435),(60214,3436),(60215,3436),(60216,3436),(60217,3436),(60218,3437),(60219,3437),(60220,3437),(60221,3437),(60222,3438),(60223,3438),(60224,3438),(60225,3438),(60226,3439),(60227,3439),(60228,3439),(60229,3439),(60230,3440),(60231,3440),(60232,3440),(60233,3440),(60234,3441),(60235,3441),(60236,3441),(60237,3441),(60238,3442),(60239,3442),(60240,3442),(60241,3442),(60242,3443),(60243,3443),(60244,3443),(60245,3443),(60246,3444),(60247,3444),(60248,3444),(60249,3444),(60250,3445),(60251,3445),(60252,3445),(60253,3445),(60254,3446),(60255,3446),(60256,3446),(60257,3446),(60258,3447),(60259,3447),(60260,3447),(60261,3447),(60262,3448),(60263,3448),(60264,3448),(60265,3448),(60266,3449),(60267,3449),(60268,3449),(60269,3449),(60270,3450),(60271,3450),(60272,3450),(60273,3450),(60274,3451),(60275,3451),(60276,3451),(60277,3451),(60278,3452),(60279,3452),(60280,3452),(60281,3452),(60282,3453),(60283,3453),(60284,3453),(60285,3453),(60286,3454),(60287,3454),(60288,3454),(60289,3454),(60290,3455),(60291,3455),(60292,3455),(60293,3455),(60294,3456),(60295,3456),(60296,3456),(60297,3456),(60298,3457),(60299,3457),(60300,3457),(60301,3457),(60302,3458),(60303,3458),(60304,3458),(60305,3458),(60306,3459),(60307,3459),(60308,3459),(60309,3459),(60310,3460),(60311,3460),(60312,3460),(60313,3460),(60314,3461),(60315,3461),(60316,3461),(60317,3461),(60318,3462),(60319,3462),(60320,3462),(60321,3462),(60322,3463),(60323,3463),(60324,3463),(60325,3463),(60326,3464),(60327,3464),(60328,3464),(60329,3464),(60330,3465),(60331,3465),(60332,3465),(60333,3465),(60334,3466),(60335,3466),(60336,3466),(60337,3466),(60338,3467),(60339,3467),(60340,3467),(60341,3467),(60342,3468),(60343,3468),(60344,3468),(60345,3468),(60346,3469),(60347,3470),(60348,3471),(60349,3472),(60350,3473),(60351,3474),(60352,3475),(60353,3476),(60354,3477),(60355,3478),(60356,3479),(60357,3480),(60358,3481),(60359,3482),(60360,3483),(60361,3484),(60362,3485),(60363,3486),(60364,3487),(60365,3488),(60366,3489),(60367,3490),(60368,3491),(60369,3492),(60370,3493),(60371,3494),(60372,3495),(60373,3496),(60374,3497),(60375,3498),(60376,3499),(60377,3500),(60378,3501),(60379,3502),(60380,3503),(60381,3504),(60382,3505),(60383,3506),(60384,3507),(60385,3508),(60386,3509),(60387,3510),(60388,3511),(60389,3512),(60390,3513),(60391,3514),(60392,3515),(60393,3516),(60394,3517),(60395,3518),(60396,3519),(60397,3520),(60398,3521),(60399,3522),(60400,3523),(60401,3524),(60402,3525),(60403,3526),(60404,3527),(60405,3528),(60406,3529),(60407,3530),(60408,3531),(60409,3532),(60410,3533),(60411,3534),(60412,3535),(60413,3536),(60414,3537),(60415,3538),(60416,3539),(60417,3540),(60418,3541),(60419,3542),(60420,3543),(60421,3544),(60422,3545),(60423,3546),(60424,3547),(60425,3548),(60426,3549),(60427,3550),(60428,3551),(60429,3552),(60430,3553),(60431,3554),(60432,3555),(60433,3556),(60434,3557),(60435,3558),(60436,3559),(60437,3560),(60438,3561),(60439,3562),(60440,3563),(60441,3564),(60442,3565),(60443,3566),(60444,3567),(60445,3568),(60446,3469),(60447,3469),(60448,3469),(60449,3469),(60450,3469),(60451,3469),(60452,3470),(60453,3470),(60454,3470),(60455,3470),(60456,3470),(60457,3470),(60458,3471),(60459,3471),(60460,3471),(60461,3471),(60462,3471),(60463,3471),(60464,3472),(60465,3472),(60466,3472),(60467,3472),(60468,3472),(60469,3472),(60470,3473),(60471,3473),(60472,3473),(60473,3473),(60474,3473),(60475,3473),(60476,3474),(60477,3474),(60478,3474),(60479,3474),(60480,3474),(60481,3474),(60482,3475),(60483,3475),(60484,3475),(60485,3475),(60486,3475),(60487,3475),(60488,3476),(60489,3476),(60490,3476),(60491,3476),(60492,3476),(60493,3476),(60494,3477),(60495,3477),(60496,3477),(60497,3477),(60498,3477),(60499,3477),(60500,3478),(60501,3478),(60502,3478),(60503,3478),(60504,3478),(60505,3478),(60506,3479),(60507,3479),(60508,3479),(60509,3479),(60510,3479),(60511,3479),(60512,3480),(60513,3480),(60514,3480),(60515,3480),(60516,3480),(60517,3480),(60518,3481),(60519,3481),(60520,3481),(60521,3481),(60522,3481),(60523,3481),(60524,3482),(60525,3482),(60526,3482),(60527,3482),(60528,3482),(60529,3482),(60530,3483),(60531,3483),(60532,3483),(60533,3483),(60534,3483),(60535,3483),(60536,3484),(60537,3484),(60538,3484),(60539,3484),(60540,3484),(60541,3484),(60542,3485),(60543,3485),(60544,3485),(60545,3485),(60546,3485),(60547,3485),(60548,3486),(60549,3486),(60550,3486),(60551,3486),(60552,3486),(60553,3486),(60554,3487),(60555,3487),(60556,3487),(60557,3487),(60558,3487),(60559,3487),(60560,3488),(60561,3488),(60562,3488),(60563,3488),(60564,3488),(60565,3488),(60566,3489),(60567,3489),(60568,3489),(60569,3489),(60570,3489),(60571,3489),(60572,3490),(60573,3490),(60574,3490),(60575,3490),(60576,3490),(60577,3490),(60578,3491),(60579,3491),(60580,3491),(60581,3491),(60582,3491),(60583,3491),(60584,3492),(60585,3492),(60586,3492),(60587,3492),(60588,3492),(60589,3492),(60590,3493),(60591,3493),(60592,3493),(60593,3493),(60594,3493),(60595,3493),(60596,3494),(60597,3494),(60598,3494),(60599,3494),(60600,3494),(60601,3494),(60602,3495),(60603,3495),(60604,3495),(60605,3495),(60606,3495),(60607,3495),(60608,3496),(60609,3496),(60610,3496),(60611,3496),(60612,3496),(60613,3496),(60614,3497),(60615,3497),(60616,3497),(60617,3497),(60618,3497),(60619,3497),(60620,3498),(60621,3498),(60622,3498),(60623,3498),(60624,3498),(60625,3498),(60626,3499),(60627,3499),(60628,3499),(60629,3499),(60630,3499),(60631,3499),(60632,3500),(60633,3500),(60634,3500),(60635,3500),(60636,3500),(60637,3500),(60638,3501),(60639,3501),(60640,3501),(60641,3501),(60642,3501),(60643,3501),(60644,3502),(60645,3502),(60646,3502),(60647,3502),(60648,3502),(60649,3502),(60650,3503),(60651,3503),(60652,3503),(60653,3503),(60654,3503),(60655,3503),(60656,3504),(60657,3504),(60658,3504),(60659,3504),(60660,3504),(60661,3504),(60662,3505),(60663,3505),(60664,3505),(60665,3505),(60666,3505),(60667,3505),(60668,3506),(60669,3506),(60670,3506),(60671,3506),(60672,3506),(60673,3506),(60674,3507),(60675,3507),(60676,3507),(60677,3507),(60678,3507),(60679,3507),(60680,3508),(60681,3508),(60682,3508),(60683,3508),(60684,3508),(60685,3508),(60686,3509),(60687,3509),(60688,3509),(60689,3509),(60690,3509),(60691,3509),(60692,3510),(60693,3510),(60694,3510),(60695,3510),(60696,3510),(60697,3510),(60698,3511),(60699,3511),(60700,3511),(60701,3511),(60702,3511),(60703,3511),(60704,3512),(60705,3512),(60706,3512),(60707,3512),(60708,3512),(60709,3512),(60710,3513),(60711,3513),(60712,3513),(60713,3513),(60714,3513),(60715,3513),(60716,3514),(60717,3514),(60718,3514),(60719,3514),(60720,3514),(60721,3514),(60722,3515),(60723,3515),(60724,3515),(60725,3515),(60726,3515),(60727,3515),(60728,3516),(60729,3516),(60730,3516),(60731,3516),(60732,3516),(60733,3516),(60734,3517),(60735,3517),(60736,3517),(60737,3517),(60738,3517),(60739,3517),(60740,3518),(60741,3518),(60742,3518),(60743,3518),(60744,3518),(60745,3518),(60746,3519),(60747,3519),(60748,3519),(60749,3519),(60750,3519),(60751,3519),(60752,3520),(60753,3520),(60754,3520),(60755,3520),(60756,3520),(60757,3520),(60758,3521),(60759,3521),(60760,3521),(60761,3521),(60762,3521),(60763,3521),(60764,3522),(60765,3522),(60766,3522),(60767,3522),(60768,3522),(60769,3522),(60770,3523),(60771,3523),(60772,3523),(60773,3523),(60774,3523),(60775,3523),(60776,3524),(60777,3524),(60778,3524),(60779,3524),(60780,3524),(60781,3524),(60782,3525),(60783,3525),(60784,3525),(60785,3525),(60786,3525),(60787,3525),(60788,3526),(60789,3526),(60790,3526),(60791,3526),(60792,3526),(60793,3526),(60794,3527),(60795,3527),(60796,3527),(60797,3527),(60798,3527),(60799,3527),(60800,3528),(60801,3528),(60802,3528),(60803,3528),(60804,3529),(60805,3529),(60806,3529),(60807,3529),(60808,3530),(60809,3530),(60810,3530),(60811,3530),(60812,3531),(60813,3531),(60814,3531),(60815,3531),(60816,3532),(60817,3532),(60818,3532),(60819,3532),(60820,3533),(60821,3533),(60822,3533),(60823,3533),(60824,3534),(60825,3534),(60826,3534),(60827,3534),(60828,3534),(60829,3534),(60830,3535),(60831,3535),(60832,3535),(60833,3535),(60834,3535),(60835,3535),(60836,3536),(60837,3536),(60838,3536),(60839,3536),(60840,3536),(60841,3536),(60842,3537),(60843,3537),(60844,3537),(60845,3537),(60846,3537),(60847,3537),(60848,3538),(60849,3538),(60850,3538),(60851,3538),(60852,3538),(60853,3538),(60854,3539),(60855,3539),(60856,3539),(60857,3539),(60858,3539),(60859,3539),(60860,3540),(60861,3540),(60862,3540),(60863,3540),(60864,3540),(60865,3540),(60866,3541),(60867,3541),(60868,3541),(60869,3541),(60870,3541),(60871,3541),(60872,3542),(60873,3542),(60874,3542),(60875,3542),(60876,3542),(60877,3542),(60878,3543),(60879,3543),(60880,3543),(60881,3543),(60882,3543),(60883,3543),(60884,3544),(60885,3544),(60886,3544),(60887,3544),(60888,3544),(60889,3544),(60890,3545),(60891,3545),(60892,3545),(60893,3545),(60894,3545),(60895,3545),(60896,3546),(60897,3546),(60898,3546),(60899,3546),(60900,3546),(60901,3546),(60902,3547),(60903,3547),(60904,3547),(60905,3547),(60906,3547),(60907,3547),(60908,3548),(60909,3548),(60910,3548),(60911,3548),(60912,3548),(60913,3548),(60914,3549),(60915,3549),(60916,3549),(60917,3549),(60918,3550),(60919,3550),(60920,3550),(60921,3550),(60922,3551),(60923,3551),(60924,3551),(60925,3551),(60926,3551),(60927,3551),(60928,3552),(60929,3552),(60930,3552),(60931,3552),(60932,3552),(60933,3552),(60934,3553),(60935,3553),(60936,3553),(60937,3553),(60938,3553),(60939,3553),(60940,3554),(60941,3554),(60942,3554),(60943,3554),(60944,3554),(60945,3554),(60946,3555),(60947,3555),(60948,3555),(60949,3555),(60950,3555),(60951,3555),(60952,3556),(60953,3556),(60954,3556),(60955,3556),(60956,3556),(60957,3556),(60958,3557),(60959,3557),(60960,3557),(60961,3557),(60962,3557),(60963,3557),(60964,3558),(60965,3558),(60966,3558),(60967,3558),(60968,3558),(60969,3558),(60970,3559),(60971,3559),(60972,3559),(60973,3559),(60974,3559),(60975,3559),(60976,3560),(60977,3560),(60978,3560),(60979,3560),(60980,3560),(60981,3560),(60982,3561),(60983,3561),(60984,3561),(60985,3561),(60986,3561),(60987,3561),(60988,3562),(60989,3562),(60990,3562),(60991,3562),(60992,3562),(60993,3562),(60994,3563),(60995,3563),(60996,3563),(60997,3563),(60998,3563),(60999,3563),(61000,3564),(61001,3564),(61002,3564),(61003,3564),(61004,3564),(61005,3564),(61006,3565),(61007,3565),(61008,3565),(61009,3565),(61010,3565),(61011,3565),(61012,3566),(61013,3566),(61014,3566),(61015,3566),(61016,3566),(61017,3566),(61018,3567),(61019,3567),(61020,3567),(61021,3567),(61022,3567),(61023,3567),(61024,3568),(61025,3568),(61026,3568),(61027,3568),(61028,3568),(61029,3568),(61030,3469),(61031,3469),(61032,3470),(61033,3470),(61034,3471),(61035,3471),(61036,3472),(61037,3472),(61038,3473),(61039,3473),(61040,3474),(61041,3474),(61042,3475),(61043,3475),(61044,3476),(61045,3476),(61046,3477),(61047,3477),(61048,3478),(61049,3478),(61050,3479),(61051,3479),(61052,3480),(61053,3480),(61054,3481),(61055,3481),(61056,3482),(61057,3482),(61058,3483),(61059,3483),(61060,3484),(61061,3484),(61062,3485),(61063,3485),(61064,3486),(61065,3486),(61066,3487),(61067,3487),(61068,3488),(61069,3488),(61070,3489),(61071,3489),(61072,3490),(61073,3490),(61074,3491),(61075,3491),(61076,3492),(61077,3492),(61078,3493),(61079,3493),(61080,3494),(61081,3494),(61082,3495),(61083,3495),(61084,3496),(61085,3496),(61086,3497),(61087,3497),(61088,3498),(61089,3498),(61090,3499),(61091,3499),(61092,3500),(61093,3500),(61094,3501),(61095,3501),(61096,3502),(61097,3502),(61098,3503),(61099,3503),(61100,3504),(61101,3504),(61102,3505),(61103,3505),(61104,3506),(61105,3506),(61106,3507),(61107,3507),(61108,3508),(61109,3508),(61110,3509),(61111,3509),(61112,3510),(61113,3510),(61114,3511),(61115,3511),(61116,3512),(61117,3512),(61118,3513),(61119,3513),(61120,3514),(61121,3514),(61122,3515),(61123,3515),(61124,3516),(61125,3516),(61126,3517),(61127,3517),(61128,3518),(61129,3518),(61130,3519),(61131,3519),(61132,3520),(61133,3520),(61134,3521),(61135,3521),(61136,3522),(61137,3522),(61138,3523),(61139,3523),(61140,3524),(61141,3524),(61142,3525),(61143,3525),(61144,3526),(61145,3526),(61146,3527),(61147,3527),(61148,3528),(61149,3528),(61150,3529),(61151,3529),(61152,3530),(61153,3530),(61154,3531),(61155,3531),(61156,3532),(61157,3532),(61158,3533),(61159,3533),(61160,3534),(61161,3534),(61162,3535),(61163,3535),(61164,3536),(61165,3536),(61166,3537),(61167,3537),(61168,3537),(61169,3538),(61170,3538),(61171,3538),(61172,3539),(61173,3539),(61174,3540),(61175,3540),(61176,3541),(61177,3541),(61178,3542),(61179,3542),(61180,3543),(61181,3543),(61182,3543),(61183,3544),(61184,3544),(61185,3544),(61186,3545),(61187,3545),(61188,3545),(61189,3546),(61190,3546),(61191,3546),(61192,3547),(61193,3547),(61194,3547),(61195,3548),(61196,3548),(61197,3548),(61198,3549),(61199,3549),(61200,3550),(61201,3550),(61202,3551),(61203,3551),(61204,3551),(61205,3552),(61206,3552),(61207,3552),(61208,3553),(61209,3553),(61210,3553),(61211,3554),(61212,3554),(61213,3554),(61214,3555),(61215,3555),(61216,3555),(61217,3556),(61218,3556),(61219,3556),(61220,3557),(61221,3557),(61222,3557),(61223,3558),(61224,3558),(61225,3558),(61226,3559),(61227,3559),(61228,3559),(61229,3560),(61230,3560),(61231,3560),(61232,3561),(61233,3561),(61234,3561),(61235,3562),(61236,3562),(61237,3562),(61238,3563),(61239,3563),(61240,3563),(61241,3564),(61242,3564),(61243,3564),(61244,3565),(61245,3565),(61246,3565),(61247,3566),(61248,3566),(61249,3566),(61250,3567),(61251,3567),(61252,3567),(61253,3568),(61254,3568),(61255,3568),(61256,3469),(61257,3469),(61258,3469),(61259,3470),(61260,3470),(61261,3470),(61262,3471),(61263,3471),(61264,3471),(61265,3472),(61266,3472),(61267,3472),(61268,3473),(61269,3473),(61270,3473),(61271,3474),(61272,3474),(61273,3474),(61274,3475),(61275,3475),(61276,3475),(61277,3476),(61278,3476),(61279,3476),(61280,3477),(61281,3477),(61282,3477),(61283,3478),(61284,3478),(61285,3478),(61286,3479),(61287,3479),(61288,3479),(61289,3480),(61290,3480),(61291,3480),(61292,3481),(61293,3481),(61294,3481),(61295,3482),(61296,3482),(61297,3482),(61298,3483),(61299,3483),(61300,3483),(61301,3484),(61302,3484),(61303,3484),(61304,3485),(61305,3485),(61306,3485),(61307,3486),(61308,3486),(61309,3486),(61310,3487),(61311,3487),(61312,3487),(61313,3488),(61314,3488),(61315,3488),(61316,3489),(61317,3489),(61318,3489),(61319,3490),(61320,3490),(61321,3490),(61322,3491),(61323,3491),(61324,3491),(61325,3492),(61326,3492),(61327,3492),(61328,3493),(61329,3493),(61330,3493),(61331,3494),(61332,3494),(61333,3494),(61334,3495),(61335,3495),(61336,3495),(61337,3496),(61338,3496),(61339,3496),(61340,3497),(61341,3497),(61342,3497),(61343,3498),(61344,3498),(61345,3498),(61346,3499),(61347,3499),(61348,3499),(61349,3500),(61350,3500),(61351,3500),(61352,3501),(61353,3501),(61354,3501),(61355,3502),(61356,3502),(61357,3502),(61358,3503),(61359,3503),(61360,3503),(61361,3504),(61362,3504),(61363,3504),(61364,3505),(61365,3505),(61366,3505),(61367,3506),(61368,3506),(61369,3506),(61370,3507),(61371,3507),(61372,3507),(61373,3508),(61374,3508),(61375,3508),(61376,3509),(61377,3509),(61378,3509),(61379,3510),(61380,3510),(61381,3510),(61382,3511),(61383,3511),(61384,3511),(61385,3512),(61386,3512),(61387,3512),(61388,3513),(61389,3513),(61390,3513),(61391,3514),(61392,3514),(61393,3514),(61394,3515),(61395,3515),(61396,3515),(61397,3516),(61398,3516),(61399,3516),(61400,3517),(61401,3517),(61402,3517),(61403,3518),(61404,3518),(61405,3518),(61406,3519),(61407,3519),(61408,3519),(61409,3520),(61410,3520),(61411,3520),(61412,3521),(61413,3521),(61414,3521),(61415,3522),(61416,3522),(61417,3522),(61418,3523),(61419,3523),(61420,3523),(61421,3524),(61422,3524),(61423,3524),(61424,3525),(61425,3525),(61426,3525),(61427,3526),(61428,3526),(61429,3526),(61430,3527),(61431,3527),(61432,3527),(61433,3528),(61434,3528),(61435,3528),(61436,3529),(61437,3529),(61438,3529),(61439,3530),(61440,3530),(61441,3530),(61442,3531),(61443,3531),(61444,3531),(61445,3532),(61446,3532),(61447,3532),(61448,3533),(61449,3533),(61450,3533),(61451,3534),(61452,3534),(61453,3534),(61454,3535),(61455,3535),(61456,3535),(61457,3536),(61458,3536),(61459,3536),(61460,3537),(61461,3537),(61462,3537),(61463,3538),(61464,3538),(61465,3538),(61466,3539),(61467,3539),(61468,3539),(61469,3540),(61470,3540),(61471,3540),(61472,3541),(61473,3541),(61474,3541),(61475,3542),(61476,3542),(61477,3542),(61478,3543),(61479,3543),(61480,3543),(61481,3544),(61482,3544),(61483,3544),(61484,3545),(61485,3545),(61486,3545),(61487,3546),(61488,3546),(61489,3546),(61490,3547),(61491,3547),(61492,3547),(61493,3548),(61494,3548),(61495,3548),(61496,3549),(61497,3549),(61498,3549),(61499,3550),(61500,3550),(61501,3550),(61502,3551),(61503,3551),(61504,3551),(61505,3552),(61506,3552),(61507,3552),(61508,3553),(61509,3553),(61510,3553),(61511,3554),(61512,3554),(61513,3554),(61514,3555),(61515,3555),(61516,3555),(61517,3556),(61518,3556),(61519,3556),(61520,3557),(61521,3557),(61522,3557),(61523,3558),(61524,3558),(61525,3558),(61526,3559),(61527,3559),(61528,3559),(61529,3560),(61530,3560),(61531,3560),(61532,3561),(61533,3561),(61534,3561),(61535,3562),(61536,3562),(61537,3562),(61538,3563),(61539,3563),(61540,3563),(61541,3564),(61542,3564),(61543,3564),(61544,3565),(61545,3565),(61546,3565),(61547,3566),(61548,3566),(61549,3566),(61550,3567),(61551,3567),(61552,3567),(61553,3568),(61554,3568),(61555,3568),(61556,3469),(61557,3469),(61558,3469),(61559,3469),(61560,3470),(61561,3470),(61562,3470),(61563,3470),(61564,3471),(61565,3471),(61566,3471),(61567,3471),(61568,3472),(61569,3472),(61570,3472),(61571,3472),(61572,3473),(61573,3473),(61574,3473),(61575,3473),(61576,3474),(61577,3474),(61578,3474),(61579,3474),(61580,3475),(61581,3475),(61582,3475),(61583,3475),(61584,3476),(61585,3476),(61586,3476),(61587,3476),(61588,3477),(61589,3477),(61590,3477),(61591,3477),(61592,3478),(61593,3478),(61594,3478),(61595,3478),(61596,3479),(61597,3479),(61598,3479),(61599,3479),(61600,3480),(61601,3480),(61602,3480),(61603,3480),(61604,3481),(61605,3481),(61606,3481),(61607,3481),(61608,3482),(61609,3482),(61610,3482),(61611,3482),(61612,3483),(61613,3483),(61614,3483),(61615,3483),(61616,3484),(61617,3484),(61618,3484),(61619,3484),(61620,3485),(61621,3485),(61622,3485),(61623,3485),(61624,3486),(61625,3486),(61626,3486),(61627,3486),(61628,3487),(61629,3487),(61630,3487),(61631,3487),(61632,3488),(61633,3488),(61634,3488),(61635,3488),(61636,3489),(61637,3489),(61638,3489),(61639,3489),(61640,3490),(61641,3490),(61642,3490),(61643,3490),(61644,3491),(61645,3491),(61646,3491),(61647,3491),(61648,3492),(61649,3492),(61650,3492),(61651,3492),(61652,3493),(61653,3493),(61654,3493),(61655,3493),(61656,3494),(61657,3494),(61658,3494),(61659,3494),(61660,3495),(61661,3495),(61662,3495),(61663,3495),(61664,3496),(61665,3496),(61666,3496),(61667,3496),(61668,3497),(61669,3497),(61670,3497),(61671,3497),(61672,3498),(61673,3498),(61674,3498),(61675,3498),(61676,3499),(61677,3499),(61678,3499),(61679,3499),(61680,3500),(61681,3500),(61682,3500),(61683,3500),(61684,3501),(61685,3501),(61686,3501),(61687,3501),(61688,3502),(61689,3502),(61690,3502),(61691,3502),(61692,3503),(61693,3503),(61694,3503),(61695,3503),(61696,3504),(61697,3504),(61698,3504),(61699,3504),(61700,3505),(61701,3505),(61702,3505),(61703,3505),(61704,3506),(61705,3506),(61706,3506),(61707,3506),(61708,3507),(61709,3507),(61710,3507),(61711,3507),(61712,3508),(61713,3508),(61714,3508),(61715,3508),(61716,3509),(61717,3509),(61718,3509),(61719,3509),(61720,3510),(61721,3510),(61722,3510),(61723,3510),(61724,3511),(61725,3511),(61726,3511),(61727,3511),(61728,3512),(61729,3512),(61730,3512),(61731,3512),(61732,3513),(61733,3513),(61734,3513),(61735,3513),(61736,3514),(61737,3514),(61738,3514),(61739,3514),(61740,3515),(61741,3515),(61742,3515),(61743,3515),(61744,3516),(61745,3516),(61746,3516),(61747,3516),(61748,3517),(61749,3517),(61750,3517),(61751,3517),(61752,3518),(61753,3518),(61754,3518),(61755,3518),(61756,3519),(61757,3519),(61758,3519),(61759,3519),(61760,3520),(61761,3520),(61762,3520),(61763,3520),(61764,3521),(61765,3521),(61766,3521),(61767,3521),(61768,3522),(61769,3522),(61770,3522),(61771,3522),(61772,3523),(61773,3523),(61774,3523),(61775,3523),(61776,3524),(61777,3524),(61778,3524),(61779,3524),(61780,3525),(61781,3525),(61782,3525),(61783,3525),(61784,3526),(61785,3526),(61786,3526),(61787,3526),(61788,3527),(61789,3527),(61790,3527),(61791,3527),(61792,3528),(61793,3528),(61794,3528),(61795,3528),(61796,3529),(61797,3529),(61798,3529),(61799,3529),(61800,3530),(61801,3530),(61802,3530),(61803,3530),(61804,3531),(61805,3531),(61806,3531),(61807,3531),(61808,3532),(61809,3532),(61810,3532),(61811,3532),(61812,3533),(61813,3533),(61814,3533),(61815,3533),(61816,3534),(61817,3534),(61818,3534),(61819,3534),(61820,3535),(61821,3535),(61822,3535),(61823,3535),(61824,3536),(61825,3536),(61826,3536),(61827,3536),(61828,3537),(61829,3537),(61830,3537),(61831,3537),(61832,3538),(61833,3538),(61834,3538),(61835,3538),(61836,3539),(61837,3539),(61838,3539),(61839,3539),(61840,3540),(61841,3540),(61842,3540),(61843,3540),(61844,3541),(61845,3541),(61846,3541),(61847,3541),(61848,3542),(61849,3542),(61850,3542),(61851,3542),(61852,3543),(61853,3543),(61854,3543),(61855,3543),(61856,3544),(61857,3544),(61858,3544),(61859,3544),(61860,3545),(61861,3545),(61862,3545),(61863,3545),(61864,3546),(61865,3546),(61866,3546),(61867,3546),(61868,3547),(61869,3547),(61870,3547),(61871,3547),(61872,3548),(61873,3548),(61874,3548),(61875,3548),(61876,3549),(61877,3549),(61878,3549),(61879,3549),(61880,3550),(61881,3550),(61882,3550),(61883,3550),(61884,3551),(61885,3551),(61886,3551),(61887,3551),(61888,3552),(61889,3552),(61890,3552),(61891,3552),(61892,3553),(61893,3553),(61894,3553),(61895,3553),(61896,3554),(61897,3554),(61898,3554),(61899,3554),(61900,3555),(61901,3555),(61902,3555),(61903,3555),(61904,3556),(61905,3556),(61906,3556),(61907,3556),(61908,3557),(61909,3557),(61910,3557),(61911,3557),(61912,3558),(61913,3558),(61914,3558),(61915,3558),(61916,3559),(61917,3559),(61918,3559),(61919,3559),(61920,3560),(61921,3560),(61922,3560),(61923,3560),(61924,3561),(61925,3561),(61926,3561),(61927,3561),(61928,3562),(61929,3562),(61930,3562),(61931,3562),(61932,3563),(61933,3563),(61934,3563),(61935,3563),(61936,3564),(61937,3564),(61938,3564),(61939,3564),(61940,3565),(61941,3565),(61942,3565),(61943,3565),(61944,3566),(61945,3566),(61946,3566),(61947,3566),(61948,3567),(61949,3567),(61950,3567),(61951,3567),(61952,3568),(61953,3568),(61954,3568),(61955,3568),(61956,3569),(61957,3570),(61958,3571),(61959,3572),(61960,3573),(61961,3574),(61962,3575),(61963,3576),(61964,3577),(61965,3578),(61966,3579),(61967,3580),(61968,3581),(61969,3582),(61970,3583),(61971,3584),(61972,3585),(61973,3586),(61974,3587),(61975,3588),(61976,3589),(61977,3590),(61978,3591),(61979,3592),(61980,3593),(61981,3594),(61982,3595),(61983,3596),(61984,3597),(61985,3598),(61986,3599),(61987,3600),(61988,3601),(61989,3602),(61990,3603),(61991,3604),(61992,3605),(61993,3606),(61994,3607),(61995,3608),(61996,3609),(61997,3610),(61998,3611),(61999,3612),(62000,3613),(62001,3614),(62002,3615),(62003,3616),(62004,3617),(62005,3618),(62006,3619),(62007,3620),(62008,3621),(62009,3622),(62010,3623),(62011,3624),(62012,3625),(62013,3626),(62014,3627),(62015,3628),(62016,3629),(62017,3630),(62018,3631),(62019,3632),(62020,3633),(62021,3634),(62022,3635),(62023,3636),(62024,3637),(62025,3638),(62026,3639),(62027,3640),(62028,3641),(62029,3642),(62030,3643),(62031,3644),(62032,3645),(62033,3646),(62034,3647),(62035,3648),(62036,3649),(62037,3650),(62038,3651),(62039,3652),(62040,3653),(62041,3654),(62042,3655),(62043,3656),(62044,3657),(62045,3658),(62046,3659),(62047,3660),(62048,3661),(62049,3662),(62050,3663),(62051,3664),(62052,3665),(62053,3666),(62054,3667),(62055,3668),(62056,3569),(62057,3569),(62058,3569),(62059,3569),(62060,3569),(62061,3569),(62062,3570),(62063,3570),(62064,3570),(62065,3570),(62066,3570),(62067,3570),(62068,3571),(62069,3571),(62070,3571),(62071,3571),(62072,3571),(62073,3571),(62074,3572),(62075,3572),(62076,3572),(62077,3572),(62078,3572),(62079,3572),(62080,3573),(62081,3573),(62082,3573),(62083,3573),(62084,3573),(62085,3573),(62086,3574),(62087,3574),(62088,3574),(62089,3574),(62090,3574),(62091,3574),(62092,3575),(62093,3575),(62094,3575),(62095,3575),(62096,3575),(62097,3575),(62098,3576),(62099,3576),(62100,3576),(62101,3576),(62102,3576),(62103,3576),(62104,3577),(62105,3577),(62106,3577),(62107,3577),(62108,3577),(62109,3577),(62110,3578),(62111,3578),(62112,3578),(62113,3578),(62114,3578),(62115,3578),(62116,3579),(62117,3579),(62118,3579),(62119,3579),(62120,3579),(62121,3579),(62122,3580),(62123,3580),(62124,3580),(62125,3580),(62126,3580),(62127,3580),(62128,3581),(62129,3581),(62130,3581),(62131,3581),(62132,3581),(62133,3581),(62134,3582),(62135,3582),(62136,3582),(62137,3582),(62138,3582),(62139,3582),(62140,3583),(62141,3583),(62142,3583),(62143,3583),(62144,3583),(62145,3583),(62146,3584),(62147,3584),(62148,3584),(62149,3584),(62150,3584),(62151,3584),(62152,3585),(62153,3585),(62154,3585),(62155,3585),(62156,3585),(62157,3585),(62158,3586),(62159,3586),(62160,3586),(62161,3586),(62162,3586),(62163,3586),(62164,3587),(62165,3587),(62166,3587),(62167,3587),(62168,3587),(62169,3587),(62170,3588),(62171,3588),(62172,3588),(62173,3588),(62174,3588),(62175,3588),(62176,3589),(62177,3589),(62178,3589),(62179,3589),(62180,3589),(62181,3589),(62182,3590),(62183,3590),(62184,3590),(62185,3590),(62186,3590),(62187,3590),(62188,3591),(62189,3591),(62190,3591),(62191,3591),(62192,3591),(62193,3591),(62194,3592),(62195,3592),(62196,3592),(62197,3592),(62198,3592),(62199,3592),(62200,3593),(62201,3593),(62202,3593),(62203,3593),(62204,3593),(62205,3593),(62206,3594),(62207,3594),(62208,3594),(62209,3594),(62210,3594),(62211,3594),(62212,3595),(62213,3595),(62214,3595),(62215,3595),(62216,3595),(62217,3595),(62218,3596),(62219,3596),(62220,3596),(62221,3596),(62222,3596),(62223,3596),(62224,3597),(62225,3597),(62226,3597),(62227,3597),(62228,3597),(62229,3597),(62230,3598),(62231,3598),(62232,3598),(62233,3598),(62234,3598),(62235,3598),(62236,3599),(62237,3599),(62238,3599),(62239,3599),(62240,3599),(62241,3599),(62242,3600),(62243,3600),(62244,3600),(62245,3600),(62246,3600),(62247,3600),(62248,3601),(62249,3601),(62250,3601),(62251,3601),(62252,3601),(62253,3601),(62254,3602),(62255,3602),(62256,3602),(62257,3602),(62258,3602),(62259,3602),(62260,3603),(62261,3603),(62262,3603),(62263,3603),(62264,3603),(62265,3603),(62266,3604),(62267,3604),(62268,3604),(62269,3604),(62270,3604),(62271,3604),(62272,3605),(62273,3605),(62274,3605),(62275,3605),(62276,3605),(62277,3605),(62278,3606),(62279,3606),(62280,3606),(62281,3606),(62282,3606),(62283,3606),(62284,3607),(62285,3607),(62286,3607),(62287,3607),(62288,3607),(62289,3607),(62290,3608),(62291,3608),(62292,3608),(62293,3608),(62294,3608),(62295,3608),(62296,3609),(62297,3609),(62298,3609),(62299,3609),(62300,3609),(62301,3609),(62302,3610),(62303,3610),(62304,3610),(62305,3610),(62306,3611),(62307,3611),(62308,3611),(62309,3611),(62310,3612),(62311,3612),(62312,3612),(62313,3612),(62314,3613),(62315,3613),(62316,3613),(62317,3613),(62318,3614),(62319,3614),(62320,3614),(62321,3614),(62322,3614),(62323,3614),(62324,3615),(62325,3615),(62326,3615),(62327,3615),(62328,3615),(62329,3615),(62330,3616),(62331,3616),(62332,3616),(62333,3616),(62334,3616),(62335,3616),(62336,3617),(62337,3617),(62338,3617),(62339,3617),(62340,3617),(62341,3617),(62342,3618),(62343,3618),(62344,3618),(62345,3618),(62346,3618),(62347,3618),(62348,3619),(62349,3619),(62350,3619),(62351,3619),(62352,3619),(62353,3619),(62354,3620),(62355,3620),(62356,3620),(62357,3620),(62358,3620),(62359,3620),(62360,3621),(62361,3621),(62362,3621),(62363,3621),(62364,3621),(62365,3621),(62366,3622),(62367,3622),(62368,3622),(62369,3622),(62370,3622),(62371,3622),(62372,3623),(62373,3623),(62374,3623),(62375,3623),(62376,3623),(62377,3623),(62378,3624),(62379,3624),(62380,3624),(62381,3624),(62382,3624),(62383,3624),(62384,3625),(62385,3625),(62386,3625),(62387,3625),(62388,3625),(62389,3625),(62390,3626),(62391,3626),(62392,3626),(62393,3626),(62394,3626),(62395,3626),(62396,3627),(62397,3627),(62398,3627),(62399,3627),(62400,3627),(62401,3627),(62402,3628),(62403,3628),(62404,3628),(62405,3628),(62406,3628),(62407,3628),(62408,3629),(62409,3629),(62410,3629),(62411,3629),(62412,3629),(62413,3629),(62414,3630),(62415,3630),(62416,3630),(62417,3630),(62418,3630),(62419,3630),(62420,3631),(62421,3631),(62422,3631),(62423,3631),(62424,3631),(62425,3631),(62426,3632),(62427,3632),(62428,3632),(62429,3632),(62430,3632),(62431,3632),(62432,3633),(62433,3633),(62434,3633),(62435,3633),(62436,3633),(62437,3633),(62438,3634),(62439,3634),(62440,3634),(62441,3634),(62442,3634),(62443,3634),(62444,3635),(62445,3635),(62446,3635),(62447,3635),(62448,3635),(62449,3635),(62450,3636),(62451,3636),(62452,3636),(62453,3636),(62454,3636),(62455,3636),(62456,3637),(62457,3637),(62458,3637),(62459,3637),(62460,3637),(62461,3637),(62462,3638),(62463,3638),(62464,3638),(62465,3638),(62466,3638),(62467,3638),(62468,3639),(62469,3639),(62470,3639),(62471,3639),(62472,3639),(62473,3639),(62474,3640),(62475,3640),(62476,3640),(62477,3640),(62478,3640),(62479,3640),(62480,3641),(62481,3641),(62482,3641),(62483,3641),(62484,3641),(62485,3641),(62486,3642),(62487,3642),(62488,3642),(62489,3642),(62490,3642),(62491,3642),(62492,3643),(62493,3643),(62494,3643),(62495,3643),(62496,3643),(62497,3643),(62498,3644),(62499,3644),(62500,3644),(62501,3644),(62502,3645),(62503,3645),(62504,3645),(62505,3645),(62506,3646),(62507,3646),(62508,3646),(62509,3646),(62510,3647),(62511,3647),(62512,3647),(62513,3647),(62514,3648),(62515,3648),(62516,3648),(62517,3648),(62518,3648),(62519,3648),(62520,3649),(62521,3649),(62522,3649),(62523,3649),(62524,3650),(62525,3650),(62526,3650),(62527,3650),(62528,3651),(62529,3651),(62530,3651),(62531,3651),(62532,3652),(62533,3652),(62534,3652),(62535,3652),(62536,3653),(62537,3653),(62538,3653),(62539,3653),(62540,3654),(62541,3654),(62542,3654),(62543,3654),(62544,3655),(62545,3655),(62546,3655),(62547,3655),(62548,3656),(62549,3656),(62550,3656),(62551,3656),(62552,3657),(62553,3657),(62554,3657),(62555,3657),(62556,3658),(62557,3658),(62558,3658),(62559,3658),(62560,3659),(62561,3659),(62562,3659),(62563,3659),(62564,3659),(62565,3659),(62566,3660),(62567,3660),(62568,3660),(62569,3660),(62570,3660),(62571,3660),(62572,3661),(62573,3661),(62574,3661),(62575,3661),(62576,3661),(62577,3661),(62578,3662),(62579,3662),(62580,3662),(62581,3662),(62582,3662),(62583,3662),(62584,3663),(62585,3663),(62586,3663),(62587,3663),(62588,3663),(62589,3663),(62590,3664),(62591,3664),(62592,3664),(62593,3664),(62594,3664),(62595,3664),(62596,3665),(62597,3665),(62598,3665),(62599,3665),(62600,3665),(62601,3665),(62602,3666),(62603,3666),(62604,3666),(62605,3666),(62606,3666),(62607,3666),(62608,3667),(62609,3667),(62610,3667),(62611,3667),(62612,3667),(62613,3667),(62614,3668),(62615,3668),(62616,3668),(62617,3668),(62618,3668),(62619,3668),(62620,3569),(62621,3569),(62622,3569),(62623,3570),(62624,3570),(62625,3570),(62626,3571),(62627,3571),(62628,3571),(62629,3572),(62630,3572),(62631,3572),(62632,3573),(62633,3573),(62634,3574),(62635,3574),(62636,3575),(62637,3575),(62638,3576),(62639,3576),(62640,3577),(62641,3577),(62642,3578),(62643,3578),(62644,3579),(62645,3579),(62646,3580),(62647,3580),(62648,3581),(62649,3581),(62650,3581),(62651,3582),(62652,3582),(62653,3582),(62654,3583),(62655,3583),(62656,3584),(62657,3584),(62658,3584),(62659,3585),(62660,3585),(62661,3585),(62662,3586),(62663,3586),(62664,3586),(62665,3587),(62666,3587),(62667,3587),(62668,3588),(62669,3588),(62670,3588),(62671,3589),(62672,3589),(62673,3589),(62674,3590),(62675,3590),(62676,3590),(62677,3591),(62678,3591),(62679,3591),(62680,3592),(62681,3592),(62682,3593),(62683,3593),(62684,3594),(62685,3594),(62686,3595),(62687,3595),(62688,3596),(62689,3596),(62690,3597),(62691,3597),(62692,3598),(62693,3598),(62694,3599),(62695,3599),(62696,3600),(62697,3600),(62698,3601),(62699,3601),(62700,3602),(62701,3602),(62702,3603),(62703,3603),(62704,3604),(62705,3604),(62706,3605),(62707,3605),(62708,3606),(62709,3606),(62710,3607),(62711,3607),(62712,3608),(62713,3608),(62714,3609),(62715,3609),(62716,3610),(62717,3610),(62718,3611),(62719,3611),(62720,3612),(62721,3612),(62722,3613),(62723,3613),(62724,3614),(62725,3614),(62726,3614),(62727,3615),(62728,3615),(62729,3615),(62730,3616),(62731,3616),(62732,3616),(62733,3617),(62734,3617),(62735,3617),(62736,3618),(62737,3618),(62738,3618),(62739,3619),(62740,3619),(62741,3619),(62742,3620),(62743,3620),(62744,3620),(62745,3621),(62746,3621),(62747,3621),(62748,3622),(62749,3622),(62750,3622),(62751,3623),(62752,3623),(62753,3624),(62754,3624),(62755,3624),(62756,3625),(62757,3625),(62758,3625),(62759,3626),(62760,3626),(62761,3626),(62762,3627),(62763,3627),(62764,3627),(62765,3628),(62766,3628),(62767,3628),(62768,3629),(62769,3629),(62770,3629),(62771,3630),(62772,3630),(62773,3630),(62774,3631),(62775,3631),(62776,3631),(62777,3632),(62778,3632),(62779,3632),(62780,3633),(62781,3633),(62782,3633),(62783,3634),(62784,3634),(62785,3634),(62786,3635),(62787,3635),(62788,3635),(62789,3636),(62790,3636),(62791,3636),(62792,3637),(62793,3637),(62794,3637),(62795,3638),(62796,3638),(62797,3638),(62798,3639),(62799,3639),(62800,3639),(62801,3640),(62802,3640),(62803,3640),(62804,3641),(62805,3641),(62806,3641),(62807,3642),(62808,3642),(62809,3642),(62810,3643),(62811,3643),(62812,3643),(62813,3644),(62814,3644),(62815,3645),(62816,3645),(62817,3646),(62818,3646),(62819,3647),(62820,3647),(62821,3648),(62822,3648),(62823,3649),(62824,3649),(62825,3650),(62826,3650),(62827,3651),(62828,3651),(62829,3652),(62830,3652),(62831,3653),(62832,3653),(62833,3654),(62834,3654),(62835,3655),(62836,3655),(62837,3656),(62838,3656),(62839,3657),(62840,3657),(62841,3658),(62842,3658),(62843,3659),(62844,3659),(62845,3659),(62846,3660),(62847,3660),(62848,3660),(62849,3661),(62850,3661),(62851,3661),(62852,3662),(62853,3662),(62854,3662),(62855,3663),(62856,3663),(62857,3663),(62858,3664),(62859,3664),(62860,3664),(62861,3665),(62862,3665),(62863,3665),(62864,3666),(62865,3666),(62866,3666),(62867,3667),(62868,3667),(62869,3667),(62870,3668),(62871,3668),(62872,3668),(62873,3569),(62874,3569),(62875,3569),(62876,3570),(62877,3570),(62878,3570),(62879,3571),(62880,3571),(62881,3571),(62882,3572),(62883,3572),(62884,3572),(62885,3573),(62886,3573),(62887,3573),(62888,3574),(62889,3574),(62890,3574),(62891,3575),(62892,3575),(62893,3575),(62894,3576),(62895,3576),(62896,3576),(62897,3577),(62898,3577),(62899,3577),(62900,3578),(62901,3578),(62902,3578),(62903,3579),(62904,3579),(62905,3579),(62906,3580),(62907,3580),(62908,3580),(62909,3581),(62910,3581),(62911,3581),(62912,3582),(62913,3582),(62914,3582),(62915,3583),(62916,3583),(62917,3583),(62918,3584),(62919,3584),(62920,3584),(62921,3585),(62922,3585),(62923,3585),(62924,3586),(62925,3586),(62926,3586),(62927,3587),(62928,3587),(62929,3587),(62930,3588),(62931,3588),(62932,3588),(62933,3589),(62934,3589),(62935,3589),(62936,3590),(62937,3590),(62938,3590),(62939,3591),(62940,3591),(62941,3591),(62942,3592),(62943,3592),(62944,3592),(62945,3593),(62946,3593),(62947,3593),(62948,3594),(62949,3594),(62950,3594),(62951,3595),(62952,3595),(62953,3595),(62954,3596),(62955,3596),(62956,3596),(62957,3597),(62958,3597),(62959,3597),(62960,3598),(62961,3598),(62962,3598),(62963,3599),(62964,3599),(62965,3599),(62966,3600),(62967,3600),(62968,3600),(62969,3601),(62970,3601),(62971,3601),(62972,3602),(62973,3602),(62974,3602),(62975,3603),(62976,3603),(62977,3603),(62978,3604),(62979,3604),(62980,3604),(62981,3605),(62982,3605),(62983,3605),(62984,3606),(62985,3606),(62986,3606),(62987,3607),(62988,3607),(62989,3607),(62990,3608),(62991,3608),(62992,3608),(62993,3609),(62994,3609),(62995,3609),(62996,3610),(62997,3610),(62998,3610),(62999,3611),(63000,3611),(63001,3611),(63002,3612),(63003,3612),(63004,3612),(63005,3613),(63006,3613),(63007,3613),(63008,3614),(63009,3614),(63010,3614),(63011,3615),(63012,3615),(63013,3615),(63014,3616),(63015,3616),(63016,3616),(63017,3617),(63018,3617),(63019,3617),(63020,3618),(63021,3618),(63022,3618),(63023,3619),(63024,3619),(63025,3619),(63026,3620),(63027,3620),(63028,3620),(63029,3621),(63030,3621),(63031,3621),(63032,3622),(63033,3622),(63034,3622),(63035,3623),(63036,3623),(63037,3623),(63038,3624),(63039,3624),(63040,3624),(63041,3625),(63042,3625),(63043,3625),(63044,3626),(63045,3626),(63046,3626),(63047,3627),(63048,3627),(63049,3627),(63050,3628),(63051,3628),(63052,3628),(63053,3629),(63054,3629),(63055,3629),(63056,3630),(63057,3630),(63058,3630),(63059,3631),(63060,3631),(63061,3631),(63062,3632),(63063,3632),(63064,3632),(63065,3633),(63066,3633),(63067,3633),(63068,3634),(63069,3634),(63070,3634),(63071,3635),(63072,3635),(63073,3635),(63074,3636),(63075,3636),(63076,3636),(63077,3637),(63078,3637),(63079,3637),(63080,3638),(63081,3638),(63082,3638),(63083,3639),(63084,3639),(63085,3639),(63086,3640),(63087,3640),(63088,3640),(63089,3641),(63090,3641),(63091,3641),(63092,3642),(63093,3642),(63094,3642),(63095,3643),(63096,3643),(63097,3643),(63098,3644),(63099,3644),(63100,3644),(63101,3645),(63102,3645),(63103,3645),(63104,3646),(63105,3646),(63106,3646),(63107,3647),(63108,3647),(63109,3647),(63110,3648),(63111,3648),(63112,3648),(63113,3649),(63114,3649),(63115,3649),(63116,3650),(63117,3650),(63118,3650),(63119,3651),(63120,3651),(63121,3651),(63122,3652),(63123,3652),(63124,3652),(63125,3653),(63126,3653),(63127,3653),(63128,3654),(63129,3654),(63130,3654),(63131,3655),(63132,3655),(63133,3655),(63134,3656),(63135,3656),(63136,3656),(63137,3657),(63138,3657),(63139,3657),(63140,3658),(63141,3658),(63142,3658),(63143,3659),(63144,3659),(63145,3659),(63146,3660),(63147,3660),(63148,3660),(63149,3661),(63150,3661),(63151,3661),(63152,3662),(63153,3662),(63154,3662),(63155,3663),(63156,3663),(63157,3663),(63158,3664),(63159,3664),(63160,3664),(63161,3665),(63162,3665),(63163,3665),(63164,3666),(63165,3666),(63166,3666),(63167,3667),(63168,3667),(63169,3667),(63170,3668),(63171,3668),(63172,3668),(63173,3569),(63174,3569),(63175,3569),(63176,3569),(63177,3570),(63178,3570),(63179,3570),(63180,3570),(63181,3571),(63182,3571),(63183,3571),(63184,3571),(63185,3572),(63186,3572),(63187,3572),(63188,3572),(63189,3573),(63190,3573),(63191,3573),(63192,3573),(63193,3574),(63194,3574),(63195,3574),(63196,3574),(63197,3575),(63198,3575),(63199,3575),(63200,3575),(63201,3576),(63202,3576),(63203,3576),(63204,3576),(63205,3577),(63206,3577),(63207,3577),(63208,3577),(63209,3578),(63210,3578),(63211,3578),(63212,3578),(63213,3579),(63214,3579),(63215,3579),(63216,3579),(63217,3580),(63218,3580),(63219,3580),(63220,3580),(63221,3581),(63222,3581),(63223,3581),(63224,3581),(63225,3582),(63226,3582),(63227,3582),(63228,3582),(63229,3583),(63230,3583),(63231,3583),(63232,3583),(63233,3584),(63234,3584),(63235,3584),(63236,3584),(63237,3585),(63238,3585),(63239,3585),(63240,3585),(63241,3586),(63242,3586),(63243,3586),(63244,3586),(63245,3587),(63246,3587),(63247,3587),(63248,3587),(63249,3588),(63250,3588),(63251,3588),(63252,3588),(63253,3589),(63254,3589),(63255,3589),(63256,3589),(63257,3590),(63258,3590),(63259,3590),(63260,3590),(63261,3591),(63262,3591),(63263,3591),(63264,3591),(63265,3592),(63266,3592),(63267,3592),(63268,3592),(63269,3593),(63270,3593),(63271,3593),(63272,3593),(63273,3594),(63274,3594),(63275,3594),(63276,3594),(63277,3595),(63278,3595),(63279,3595),(63280,3595),(63281,3596),(63282,3596),(63283,3596),(63284,3596),(63285,3597),(63286,3597),(63287,3597),(63288,3597),(63289,3598),(63290,3598),(63291,3598),(63292,3598),(63293,3599),(63294,3599),(63295,3599),(63296,3599),(63297,3600),(63298,3600),(63299,3600),(63300,3600),(63301,3601),(63302,3601),(63303,3601),(63304,3601),(63305,3602),(63306,3602),(63307,3602),(63308,3602),(63309,3603),(63310,3603),(63311,3603),(63312,3603),(63313,3604),(63314,3604),(63315,3604),(63316,3604),(63317,3605),(63318,3605),(63319,3605),(63320,3605),(63321,3606),(63322,3606),(63323,3606),(63324,3606),(63325,3607),(63326,3607),(63327,3607),(63328,3607),(63329,3608),(63330,3608),(63331,3608),(63332,3608),(63333,3609),(63334,3609),(63335,3609),(63336,3609),(63337,3610),(63338,3610),(63339,3610),(63340,3610),(63341,3611),(63342,3611),(63343,3611),(63344,3611),(63345,3612),(63346,3612),(63347,3612),(63348,3612),(63349,3613),(63350,3613),(63351,3613),(63352,3613),(63353,3614),(63354,3614),(63355,3614),(63356,3614),(63357,3615),(63358,3615),(63359,3615),(63360,3615),(63361,3616),(63362,3616),(63363,3616),(63364,3616),(63365,3617),(63366,3617),(63367,3617),(63368,3617),(63369,3618),(63370,3618),(63371,3618),(63372,3618),(63373,3619),(63374,3619),(63375,3619),(63376,3619),(63377,3620),(63378,3620),(63379,3620),(63380,3620),(63381,3621),(63382,3621),(63383,3621),(63384,3621),(63385,3622),(63386,3622),(63387,3622),(63388,3622),(63389,3623),(63390,3623),(63391,3623),(63392,3623),(63393,3624),(63394,3624),(63395,3624),(63396,3624),(63397,3625),(63398,3625),(63399,3625),(63400,3625),(63401,3626),(63402,3626),(63403,3626),(63404,3626),(63405,3627),(63406,3627),(63407,3627),(63408,3627),(63409,3628),(63410,3628),(63411,3628),(63412,3628),(63413,3629),(63414,3629),(63415,3629),(63416,3629),(63417,3630),(63418,3630),(63419,3630),(63420,3630),(63421,3631),(63422,3631),(63423,3631),(63424,3631),(63425,3632),(63426,3632),(63427,3632),(63428,3632),(63429,3633),(63430,3633),(63431,3633),(63432,3633),(63433,3634),(63434,3634),(63435,3634),(63436,3634),(63437,3635),(63438,3635),(63439,3635),(63440,3635),(63441,3636),(63442,3636),(63443,3636),(63444,3636),(63445,3637),(63446,3637),(63447,3637),(63448,3637),(63449,3638),(63450,3638),(63451,3638),(63452,3638),(63453,3639),(63454,3639),(63455,3639),(63456,3639),(63457,3640),(63458,3640),(63459,3640),(63460,3640),(63461,3641),(63462,3641),(63463,3641),(63464,3641),(63465,3642),(63466,3642),(63467,3642),(63468,3642),(63469,3643),(63470,3643),(63471,3643),(63472,3643),(63473,3644),(63474,3644),(63475,3644),(63476,3644),(63477,3645),(63478,3645),(63479,3645),(63480,3645),(63481,3646),(63482,3646),(63483,3646),(63484,3646),(63485,3647),(63486,3647),(63487,3647),(63488,3647),(63489,3648),(63490,3648),(63491,3648),(63492,3648),(63493,3649),(63494,3649),(63495,3649),(63496,3649),(63497,3650),(63498,3650),(63499,3650),(63500,3650),(63501,3651),(63502,3651),(63503,3651),(63504,3651),(63505,3652),(63506,3652),(63507,3652),(63508,3652),(63509,3653),(63510,3653),(63511,3653),(63512,3653),(63513,3654),(63514,3654),(63515,3654),(63516,3654),(63517,3655),(63518,3655),(63519,3655),(63520,3655),(63521,3656),(63522,3656),(63523,3656),(63524,3656),(63525,3657),(63526,3657),(63527,3657),(63528,3657),(63529,3658),(63530,3658),(63531,3658),(63532,3658),(63533,3659),(63534,3659),(63535,3659),(63536,3659),(63537,3660),(63538,3660),(63539,3660),(63540,3660),(63541,3661),(63542,3661),(63543,3661),(63544,3661),(63545,3662),(63546,3662),(63547,3662),(63548,3662),(63549,3663),(63550,3663),(63551,3663),(63552,3663),(63553,3664),(63554,3664),(63555,3664),(63556,3664),(63557,3665),(63558,3665),(63559,3665),(63560,3665),(63561,3666),(63562,3666),(63563,3666),(63564,3666),(63565,3667),(63566,3667),(63567,3667),(63568,3667),(63569,3668),(63570,3668),(63571,3668),(63572,3668),(63573,3669),(63574,3670),(63575,3671),(63576,3672),(63577,3673),(63578,3674),(63579,3675),(63580,3676),(63581,3677),(63582,3678),(63583,3679),(63584,3680),(63585,3681),(63586,3682),(63587,3683),(63588,3684),(63589,3685),(63590,3686),(63591,3687),(63592,3688),(63593,3689),(63594,3690),(63595,3691),(63596,3692),(63597,3693),(63598,3694),(63599,3695),(63600,3696),(63601,3697),(63602,3698),(63603,3699),(63604,3700),(63605,3701),(63606,3702),(63607,3703),(63608,3704),(63609,3705),(63610,3706),(63611,3707),(63612,3708),(63613,3709),(63614,3710),(63615,3711),(63616,3712),(63617,3713),(63618,3714),(63619,3669),(63620,3669),(63621,3669),(63622,3669),(63623,3669),(63624,3669),(63625,3670),(63626,3670),(63627,3670),(63628,3670),(63629,3670),(63630,3670),(63631,3671),(63632,3671),(63633,3671),(63634,3671),(63635,3671),(63636,3671),(63637,3672),(63638,3672),(63639,3672),(63640,3672),(63641,3672),(63642,3672),(63643,3673),(63644,3673),(63645,3673),(63646,3673),(63647,3673),(63648,3673),(63649,3674),(63650,3674),(63651,3674),(63652,3674),(63653,3674),(63654,3674),(63655,3675),(63656,3675),(63657,3675),(63658,3675),(63659,3675),(63660,3675),(63661,3676),(63662,3676),(63663,3676),(63664,3676),(63665,3676),(63666,3676),(63667,3677),(63668,3677),(63669,3677),(63670,3677),(63671,3677),(63672,3677),(63673,3678),(63674,3678),(63675,3678),(63676,3678),(63677,3678),(63678,3678),(63679,3679),(63680,3679),(63681,3679),(63682,3679),(63683,3679),(63684,3679),(63685,3680),(63686,3680),(63687,3680),(63688,3680),(63689,3680),(63690,3680),(63691,3681),(63692,3681),(63693,3681),(63694,3681),(63695,3681),(63696,3681),(63697,3682),(63698,3682),(63699,3682),(63700,3682),(63701,3682),(63702,3682),(63703,3683),(63704,3683),(63705,3683),(63706,3683),(63707,3683),(63708,3683),(63709,3684),(63710,3684),(63711,3684),(63712,3684),(63713,3685),(63714,3685),(63715,3685),(63716,3685),(63717,3686),(63718,3686),(63719,3686),(63720,3686),(63721,3686),(63722,3686),(63723,3687),(63724,3687),(63725,3687),(63726,3687),(63727,3687),(63728,3687),(63729,3688),(63730,3688),(63731,3688),(63732,3688),(63733,3688),(63734,3688),(63735,3689),(63736,3689),(63737,3689),(63738,3689),(63739,3689),(63740,3689),(63741,3690),(63742,3690),(63743,3690),(63744,3690),(63745,3690),(63746,3690),(63747,3691),(63748,3691),(63749,3691),(63750,3691),(63751,3691),(63752,3691),(63753,3692),(63754,3692),(63755,3692),(63756,3692),(63757,3692),(63758,3692),(63759,3693),(63760,3693),(63761,3693),(63762,3693),(63763,3693),(63764,3693),(63765,3694),(63766,3694),(63767,3694),(63768,3694),(63769,3694),(63770,3694),(63771,3695),(63772,3695),(63773,3695),(63774,3695),(63775,3695),(63776,3695),(63777,3696),(63778,3696),(63779,3696),(63780,3696),(63781,3696),(63782,3696),(63783,3697),(63784,3697),(63785,3697),(63786,3697),(63787,3697),(63788,3697),(63789,3698),(63790,3698),(63791,3698),(63792,3698),(63793,3698),(63794,3698),(63795,3699),(63796,3699),(63797,3699),(63798,3699),(63799,3699),(63800,3699),(63801,3700),(63802,3700),(63803,3700),(63804,3700),(63805,3700),(63806,3700),(63807,3701),(63808,3701),(63809,3701),(63810,3701),(63811,3701),(63812,3701),(63813,3702),(63814,3702),(63815,3702),(63816,3702),(63817,3702),(63818,3702),(63819,3703),(63820,3703),(63821,3703),(63822,3703),(63823,3703),(63824,3703),(63825,3704),(63826,3704),(63827,3704),(63828,3704),(63829,3704),(63830,3704),(63831,3705),(63832,3705),(63833,3705),(63834,3705),(63835,3705),(63836,3705),(63837,3706),(63838,3706),(63839,3706),(63840,3706),(63841,3706),(63842,3706),(63843,3707),(63844,3707),(63845,3707),(63846,3707),(63847,3707),(63848,3707),(63849,3708),(63850,3708),(63851,3708),(63852,3708),(63853,3708),(63854,3708),(63855,3709),(63856,3709),(63857,3709),(63858,3709),(63859,3709),(63860,3709),(63861,3710),(63862,3710),(63863,3710),(63864,3710),(63865,3710),(63866,3710),(63867,3711),(63868,3711),(63869,3711),(63870,3711),(63871,3711),(63872,3711),(63873,3712),(63874,3712),(63875,3712),(63876,3712),(63877,3712),(63878,3712),(63879,3713),(63880,3713),(63881,3713),(63882,3713),(63883,3713),(63884,3713),(63885,3714),(63886,3714),(63887,3714),(63888,3714),(63889,3714),(63890,3714),(63891,3669),(63892,3669),(63893,3669),(63894,3670),(63895,3670),(63896,3670),(63897,3671),(63898,3671),(63899,3671),(63900,3672),(63901,3672),(63902,3672),(63903,3673),(63904,3673),(63905,3673),(63906,3674),(63907,3674),(63908,3674),(63909,3675),(63910,3675),(63911,3676),(63912,3676),(63913,3677),(63914,3677),(63915,3678),(63916,3678),(63917,3679),(63918,3679),(63919,3680),(63920,3680),(63921,3681),(63922,3681),(63923,3682),(63924,3682),(63925,3683),(63926,3683),(63927,3684),(63928,3684),(63929,3685),(63930,3685),(63931,3686),(63932,3686),(63933,3687),(63934,3687),(63935,3688),(63936,3688),(63937,3689),(63938,3689),(63939,3690),(63940,3690),(63941,3691),(63942,3691),(63943,3692),(63944,3692),(63945,3693),(63946,3693),(63947,3694),(63948,3694),(63949,3695),(63950,3695),(63951,3696),(63952,3696),(63953,3697),(63954,3697),(63955,3698),(63956,3698),(63957,3699),(63958,3699),(63959,3700),(63960,3700),(63961,3701),(63962,3701),(63963,3702),(63964,3702),(63965,3703),(63966,3703),(63967,3704),(63968,3704),(63969,3705),(63970,3705),(63971,3706),(63972,3706),(63973,3707),(63974,3707),(63975,3708),(63976,3708),(63977,3709),(63978,3709),(63979,3710),(63980,3710),(63981,3711),(63982,3711),(63983,3712),(63984,3712),(63985,3713),(63986,3713),(63987,3714),(63988,3714),(63989,3669),(63990,3669),(63991,3669),(63992,3670),(63993,3670),(63994,3670),(63995,3671),(63996,3671),(63997,3671),(63998,3672),(63999,3672),(64000,3672),(64001,3673),(64002,3673),(64003,3673),(64004,3674),(64005,3674),(64006,3674),(64007,3675),(64008,3675),(64009,3675),(64010,3676),(64011,3676),(64012,3676),(64013,3677),(64014,3677),(64015,3677),(64016,3678),(64017,3678),(64018,3678),(64019,3679),(64020,3679),(64021,3679),(64022,3680),(64023,3680),(64024,3680),(64025,3681),(64026,3681),(64027,3681),(64028,3682),(64029,3682),(64030,3682),(64031,3683),(64032,3683),(64033,3683),(64034,3684),(64035,3684),(64036,3684),(64037,3685),(64038,3685),(64039,3685),(64040,3686),(64041,3686),(64042,3686),(64043,3687),(64044,3687),(64045,3687),(64046,3688),(64047,3688),(64048,3688),(64049,3689),(64050,3689),(64051,3689),(64052,3690),(64053,3690),(64054,3690),(64055,3691),(64056,3691),(64057,3691),(64058,3692),(64059,3692),(64060,3692),(64061,3693),(64062,3693),(64063,3693),(64064,3694),(64065,3694),(64066,3694),(64067,3695),(64068,3695),(64069,3695),(64070,3696),(64071,3696),(64072,3696),(64073,3697),(64074,3697),(64075,3697),(64076,3698),(64077,3698),(64078,3698),(64079,3699),(64080,3699),(64081,3699),(64082,3700),(64083,3700),(64084,3700),(64085,3701),(64086,3701),(64087,3701),(64088,3702),(64089,3702),(64090,3702),(64091,3703),(64092,3703),(64093,3703),(64094,3704),(64095,3704),(64096,3704),(64097,3705),(64098,3705),(64099,3705),(64100,3706),(64101,3706),(64102,3706),(64103,3707),(64104,3707),(64105,3707),(64106,3708),(64107,3708),(64108,3708),(64109,3709),(64110,3709),(64111,3709),(64112,3710),(64113,3710),(64114,3710),(64115,3711),(64116,3711),(64117,3711),(64118,3712),(64119,3712),(64120,3712),(64121,3713),(64122,3713),(64123,3713),(64124,3714),(64125,3714),(64126,3714),(64127,3669),(64128,3669),(64129,3669),(64130,3669),(64131,3670),(64132,3670),(64133,3670),(64134,3670),(64135,3671),(64136,3671),(64137,3671),(64138,3671),(64139,3672),(64140,3672),(64141,3672),(64142,3672),(64143,3673),(64144,3673),(64145,3673),(64146,3673),(64147,3674),(64148,3674),(64149,3674),(64150,3674),(64151,3675),(64152,3675),(64153,3675),(64154,3675),(64155,3676),(64156,3676),(64157,3676),(64158,3676),(64159,3677),(64160,3677),(64161,3677),(64162,3677),(64163,3678),(64164,3678),(64165,3678),(64166,3678),(64167,3679),(64168,3679),(64169,3679),(64170,3679),(64171,3680),(64172,3680),(64173,3680),(64174,3680),(64175,3681),(64176,3681),(64177,3681),(64178,3681),(64179,3682),(64180,3682),(64181,3682),(64182,3682),(64183,3683),(64184,3683),(64185,3683),(64186,3683),(64187,3684),(64188,3684),(64189,3684),(64190,3684),(64191,3685),(64192,3685),(64193,3685),(64194,3685),(64195,3686),(64196,3686),(64197,3686),(64198,3686),(64199,3687),(64200,3687),(64201,3687),(64202,3687),(64203,3688),(64204,3688),(64205,3688),(64206,3688),(64207,3689),(64208,3689),(64209,3689),(64210,3689),(64211,3690),(64212,3690),(64213,3690),(64214,3690),(64215,3691),(64216,3691),(64217,3691),(64218,3691),(64219,3692),(64220,3692),(64221,3692),(64222,3692),(64223,3693),(64224,3693),(64225,3693),(64226,3693),(64227,3694),(64228,3694),(64229,3694),(64230,3694),(64231,3695),(64232,3695),(64233,3695),(64234,3695),(64235,3696),(64236,3696),(64237,3696),(64238,3696),(64239,3697),(64240,3697),(64241,3697),(64242,3697),(64243,3698),(64244,3698),(64245,3698),(64246,3698),(64247,3699),(64248,3699),(64249,3699),(64250,3699),(64251,3700),(64252,3700),(64253,3700),(64254,3700),(64255,3701),(64256,3701),(64257,3701),(64258,3701),(64259,3702),(64260,3702),(64261,3702),(64262,3702),(64263,3703),(64264,3703),(64265,3703),(64266,3703),(64267,3704),(64268,3704),(64269,3704),(64270,3704),(64271,3705),(64272,3705),(64273,3705),(64274,3705),(64275,3706),(64276,3706),(64277,3706),(64278,3706),(64279,3707),(64280,3707),(64281,3707),(64282,3707),(64283,3708),(64284,3708),(64285,3708),(64286,3708),(64287,3709),(64288,3709),(64289,3709),(64290,3709),(64291,3710),(64292,3710),(64293,3710),(64294,3710),(64295,3711),(64296,3711),(64297,3711),(64298,3711),(64299,3712),(64300,3712),(64301,3712),(64302,3712),(64303,3713),(64304,3713),(64305,3713),(64306,3713),(64307,3714),(64308,3714),(64309,3714),(64310,3714),(64311,3715),(64312,3716),(64313,3717),(64314,3718),(64315,3719),(64316,3720),(64317,3721),(64318,3722),(64319,3723),(64320,3724),(64321,3725),(64322,3726),(64323,3727),(64324,3728),(64325,3729),(64326,3730),(64327,3731),(64328,3732),(64329,3733),(64330,3734),(64331,3735),(64332,3736),(64333,3737),(64334,3738),(64335,3739),(64336,3740),(64337,3741),(64338,3742),(64339,3743),(64340,3744),(64341,3745),(64342,3746),(64343,3747),(64344,3748),(64345,3749),(64346,3750),(64347,3751),(64348,3752),(64349,3753),(64350,3754),(64351,3755),(64352,3756),(64353,3757),(64354,3758),(64355,3759),(64356,3760),(64357,3761),(64358,3762),(64359,3763),(64360,3764),(64361,3765),(64362,3766),(64363,3767),(64364,3768),(64365,3769),(64366,3770),(64367,3771),(64368,3772),(64369,3773),(64370,3774),(64371,3775),(64372,3776),(64373,3777),(64374,3778),(64375,3779),(64376,3780),(64377,3781),(64378,3782),(64379,3783),(64380,3784),(64381,3785),(64382,3786),(64383,3787),(64384,3788),(64385,3789),(64386,3790),(64387,3791),(64388,3792),(64389,3793),(64390,3794),(64391,3795),(64392,3796),(64393,3797),(64394,3798),(64395,3799),(64396,3800),(64397,3801),(64398,3802),(64399,3803),(64400,3804),(64401,3805),(64402,3806),(64403,3807),(64404,3808),(64405,3809),(64406,3810),(64407,3811),(64408,3812),(64409,3813),(64410,3814),(64411,3715),(64412,3715),(64413,3715),(64414,3715),(64415,3715),(64416,3715),(64417,3716),(64418,3716),(64419,3716),(64420,3716),(64421,3716),(64422,3716),(64423,3717),(64424,3717),(64425,3717),(64426,3717),(64427,3717),(64428,3717),(64429,3718),(64430,3718),(64431,3718),(64432,3718),(64433,3718),(64434,3718),(64435,3719),(64436,3719),(64437,3719),(64438,3719),(64439,3719),(64440,3719),(64441,3720),(64442,3720),(64443,3720),(64444,3720),(64445,3720),(64446,3720),(64447,3721),(64448,3721),(64449,3721),(64450,3721),(64451,3721),(64452,3721),(64453,3722),(64454,3722),(64455,3722),(64456,3722),(64457,3722),(64458,3722),(64459,3723),(64460,3723),(64461,3723),(64462,3723),(64463,3723),(64464,3723),(64465,3724),(64466,3724),(64467,3724),(64468,3724),(64469,3724),(64470,3724),(64471,3725),(64472,3725),(64473,3725),(64474,3725),(64475,3725),(64476,3725),(64477,3726),(64478,3726),(64479,3726),(64480,3726),(64481,3726),(64482,3726),(64483,3727),(64484,3727),(64485,3727),(64486,3727),(64487,3727),(64488,3727),(64489,3728),(64490,3728),(64491,3728),(64492,3728),(64493,3728),(64494,3728),(64495,3729),(64496,3729),(64497,3729),(64498,3729),(64499,3729),(64500,3729),(64501,3730),(64502,3730),(64503,3730),(64504,3730),(64505,3730),(64506,3730),(64507,3731),(64508,3731),(64509,3731),(64510,3731),(64511,3731),(64512,3731),(64513,3732),(64514,3732),(64515,3732),(64516,3732),(64517,3732),(64518,3732),(64519,3733),(64520,3733),(64521,3733),(64522,3733),(64523,3733),(64524,3733),(64525,3734),(64526,3734),(64527,3734),(64528,3734),(64529,3734),(64530,3734),(64531,3735),(64532,3735),(64533,3735),(64534,3735),(64535,3735),(64536,3735),(64537,3736),(64538,3736),(64539,3736),(64540,3736),(64541,3736),(64542,3736),(64543,3737),(64544,3737),(64545,3737),(64546,3737),(64547,3737),(64548,3737),(64549,3738),(64550,3738),(64551,3738),(64552,3738),(64553,3738),(64554,3738),(64555,3739),(64556,3739),(64557,3739),(64558,3739),(64559,3739),(64560,3739),(64561,3740),(64562,3740),(64563,3740),(64564,3740),(64565,3740),(64566,3740),(64567,3741),(64568,3741),(64569,3741),(64570,3741),(64571,3741),(64572,3741),(64573,3742),(64574,3742),(64575,3742),(64576,3742),(64577,3742),(64578,3742),(64579,3743),(64580,3743),(64581,3743),(64582,3743),(64583,3743),(64584,3743),(64585,3744),(64586,3744),(64587,3744),(64588,3744),(64589,3744),(64590,3744),(64591,3745),(64592,3745),(64593,3745),(64594,3745),(64595,3745),(64596,3745),(64597,3746),(64598,3746),(64599,3746),(64600,3746),(64601,3746),(64602,3746),(64603,3747),(64604,3747),(64605,3747),(64606,3747),(64607,3747),(64608,3747),(64609,3748),(64610,3748),(64611,3748),(64612,3748),(64613,3748),(64614,3748),(64615,3749),(64616,3749),(64617,3749),(64618,3749),(64619,3749),(64620,3749),(64621,3750),(64622,3750),(64623,3750),(64624,3750),(64625,3750),(64626,3750),(64627,3751),(64628,3751),(64629,3751),(64630,3751),(64631,3751),(64632,3751),(64633,3752),(64634,3752),(64635,3752),(64636,3752),(64637,3752),(64638,3752),(64639,3753),(64640,3753),(64641,3753),(64642,3753),(64643,3753),(64644,3753),(64645,3754),(64646,3754),(64647,3754),(64648,3754),(64649,3754),(64650,3754),(64651,3755),(64652,3755),(64653,3755),(64654,3755),(64655,3755),(64656,3755),(64657,3756),(64658,3756),(64659,3756),(64660,3756),(64661,3756),(64662,3756),(64663,3757),(64664,3757),(64665,3757),(64666,3757),(64667,3757),(64668,3757),(64669,3758),(64670,3758),(64671,3758),(64672,3758),(64673,3758),(64674,3758),(64675,3759),(64676,3759),(64677,3759),(64678,3759),(64679,3759),(64680,3759),(64681,3760),(64682,3760),(64683,3760),(64684,3760),(64685,3760),(64686,3760),(64687,3761),(64688,3761),(64689,3761),(64690,3761),(64691,3761),(64692,3761),(64693,3762),(64694,3762),(64695,3762),(64696,3762),(64697,3762),(64698,3762),(64699,3763),(64700,3763),(64701,3763),(64702,3763),(64703,3763),(64704,3763),(64705,3764),(64706,3764),(64707,3764),(64708,3764),(64709,3764),(64710,3764),(64711,3765),(64712,3765),(64713,3765),(64714,3765),(64715,3765),(64716,3765),(64717,3766),(64718,3766),(64719,3766),(64720,3766),(64721,3766),(64722,3766),(64723,3767),(64724,3767),(64725,3767),(64726,3767),(64727,3767),(64728,3767),(64729,3768),(64730,3768),(64731,3768),(64732,3768),(64733,3768),(64734,3768),(64735,3769),(64736,3769),(64737,3769),(64738,3769),(64739,3769),(64740,3769),(64741,3770),(64742,3770),(64743,3770),(64744,3770),(64745,3770),(64746,3770),(64747,3771),(64748,3771),(64749,3771),(64750,3771),(64751,3771),(64752,3771),(64753,3772),(64754,3772),(64755,3772),(64756,3772),(64757,3772),(64758,3772),(64759,3773),(64760,3773),(64761,3773),(64762,3773),(64763,3773),(64764,3773),(64765,3774),(64766,3774),(64767,3774),(64768,3774),(64769,3774),(64770,3774),(64771,3775),(64772,3775),(64773,3775),(64774,3775),(64775,3775),(64776,3775),(64777,3776),(64778,3776),(64779,3776),(64780,3776),(64781,3776),(64782,3776),(64783,3777),(64784,3777),(64785,3777),(64786,3777),(64787,3777),(64788,3777),(64789,3778),(64790,3778),(64791,3778),(64792,3778),(64793,3778),(64794,3778),(64795,3779),(64796,3779),(64797,3779),(64798,3779),(64799,3779),(64800,3779),(64801,3780),(64802,3780),(64803,3780),(64804,3780),(64805,3780),(64806,3780),(64807,3781),(64808,3781),(64809,3781),(64810,3781),(64811,3781),(64812,3781),(64813,3782),(64814,3782),(64815,3782),(64816,3782),(64817,3782),(64818,3782),(64819,3783),(64820,3783),(64821,3783),(64822,3783),(64823,3783),(64824,3783),(64825,3784),(64826,3784),(64827,3784),(64828,3784),(64829,3784),(64830,3784),(64831,3785),(64832,3785),(64833,3785),(64834,3785),(64835,3785),(64836,3785),(64837,3786),(64838,3786),(64839,3786),(64840,3786),(64841,3786),(64842,3786),(64843,3787),(64844,3787),(64845,3787),(64846,3787),(64847,3787),(64848,3787),(64849,3788),(64850,3788),(64851,3788),(64852,3788),(64853,3788),(64854,3788),(64855,3789),(64856,3789),(64857,3789),(64858,3789),(64859,3789),(64860,3789),(64861,3790),(64862,3790),(64863,3790),(64864,3790),(64865,3790),(64866,3790),(64867,3791),(64868,3791),(64869,3791),(64870,3791),(64871,3791),(64872,3791),(64873,3792),(64874,3792),(64875,3792),(64876,3792),(64877,3792),(64878,3792),(64879,3793),(64880,3793),(64881,3793),(64882,3793),(64883,3793),(64884,3793),(64885,3794),(64886,3794),(64887,3794),(64888,3794),(64889,3794),(64890,3794),(64891,3795),(64892,3795),(64893,3795),(64894,3795),(64895,3795),(64896,3795),(64897,3796),(64898,3796),(64899,3796),(64900,3796),(64901,3796),(64902,3796),(64903,3797),(64904,3797),(64905,3797),(64906,3797),(64907,3797),(64908,3797),(64909,3798),(64910,3798),(64911,3798),(64912,3798),(64913,3798),(64914,3798),(64915,3799),(64916,3799),(64917,3799),(64918,3799),(64919,3799),(64920,3799),(64921,3800),(64922,3800),(64923,3800),(64924,3800),(64925,3800),(64926,3800),(64927,3801),(64928,3801),(64929,3801),(64930,3801),(64931,3801),(64932,3801),(64933,3802),(64934,3802),(64935,3802),(64936,3802),(64937,3802),(64938,3802),(64939,3803),(64940,3803),(64941,3803),(64942,3803),(64943,3803),(64944,3803),(64945,3804),(64946,3804),(64947,3804),(64948,3804),(64949,3804),(64950,3804),(64951,3805),(64952,3805),(64953,3805),(64954,3805),(64955,3805),(64956,3805),(64957,3806),(64958,3806),(64959,3806),(64960,3806),(64961,3806),(64962,3806),(64963,3807),(64964,3807),(64965,3807),(64966,3807),(64967,3807),(64968,3807),(64969,3808),(64970,3808),(64971,3808),(64972,3808),(64973,3808),(64974,3808),(64975,3809),(64976,3809),(64977,3809),(64978,3809),(64979,3809),(64980,3809),(64981,3810),(64982,3810),(64983,3810),(64984,3810),(64985,3810),(64986,3810),(64987,3811),(64988,3811),(64989,3811),(64990,3811),(64991,3811),(64992,3811),(64993,3812),(64994,3812),(64995,3812),(64996,3812),(64997,3812),(64998,3812),(64999,3813),(65000,3813),(65001,3813),(65002,3813),(65003,3813),(65004,3813),(65005,3814),(65006,3814),(65007,3814),(65008,3814),(65009,3814),(65010,3814),(65011,3715),(65012,3715),(65013,3716),(65014,3716),(65015,3717),(65016,3717),(65017,3718),(65018,3718),(65019,3719),(65020,3719),(65021,3720),(65022,3720),(65023,3721),(65024,3721),(65025,3722),(65026,3722),(65027,3723),(65028,3723),(65029,3724),(65030,3724),(65031,3725),(65032,3725),(65033,3726),(65034,3726),(65035,3727),(65036,3727),(65037,3728),(65038,3728),(65039,3729),(65040,3729),(65041,3730),(65042,3730),(65043,3731),(65044,3731),(65045,3732),(65046,3732),(65047,3733),(65048,3733),(65049,3734),(65050,3734),(65051,3735),(65052,3735),(65053,3736),(65054,3736),(65055,3737),(65056,3737),(65057,3738),(65058,3738),(65059,3739),(65060,3739),(65061,3740),(65062,3740),(65063,3741),(65064,3741),(65065,3742),(65066,3742),(65067,3743),(65068,3743),(65069,3744),(65070,3744),(65071,3745),(65072,3745),(65073,3746),(65074,3746),(65075,3747),(65076,3747),(65077,3748),(65078,3748),(65079,3749),(65080,3749),(65081,3750),(65082,3750),(65083,3751),(65084,3751),(65085,3752),(65086,3752),(65087,3753),(65088,3753),(65089,3754),(65090,3754),(65091,3755),(65092,3755),(65093,3756),(65094,3756),(65095,3757),(65096,3757),(65097,3758),(65098,3758),(65099,3759),(65100,3759),(65101,3760),(65102,3760),(65103,3761),(65104,3761),(65105,3762),(65106,3762),(65107,3763),(65108,3763),(65109,3764),(65110,3764),(65111,3765),(65112,3765),(65113,3765),(65114,3766),(65115,3766),(65116,3767),(65117,3767),(65118,3768),(65119,3768),(65120,3769),(65121,3769),(65122,3770),(65123,3770),(65124,3771),(65125,3771),(65126,3772),(65127,3772),(65128,3773),(65129,3773),(65130,3774),(65131,3774),(65132,3775),(65133,3775),(65134,3776),(65135,3776),(65136,3777),(65137,3777),(65138,3778),(65139,3778),(65140,3779),(65141,3779),(65142,3780),(65143,3780),(65144,3781),(65145,3781),(65146,3782),(65147,3782),(65148,3783),(65149,3783),(65150,3784),(65151,3784),(65152,3785),(65153,3785),(65154,3786),(65155,3786),(65156,3787),(65157,3787),(65158,3788),(65159,3788),(65160,3789),(65161,3789),(65162,3790),(65163,3790),(65164,3791),(65165,3791),(65166,3792),(65167,3792),(65168,3793),(65169,3793),(65170,3794),(65171,3794),(65172,3795),(65173,3795),(65174,3796),(65175,3796),(65176,3797),(65177,3797),(65178,3798),(65179,3798),(65180,3799),(65181,3799),(65182,3800),(65183,3800),(65184,3801),(65185,3801),(65186,3802),(65187,3802),(65188,3803),(65189,3803),(65190,3804),(65191,3804),(65192,3805),(65193,3805),(65194,3806),(65195,3806),(65196,3807),(65197,3807),(65198,3808),(65199,3808),(65200,3809),(65201,3809),(65202,3810),(65203,3810),(65204,3811),(65205,3811),(65206,3812),(65207,3812),(65208,3813),(65209,3813),(65210,3814),(65211,3814),(65212,3715),(65213,3715),(65214,3715),(65215,3716),(65216,3716),(65217,3716),(65218,3717),(65219,3717),(65220,3717),(65221,3718),(65222,3718),(65223,3718),(65224,3719),(65225,3719),(65226,3719),(65227,3720),(65228,3720),(65229,3720),(65230,3721),(65231,3721),(65232,3721),(65233,3722),(65234,3722),(65235,3722),(65236,3723),(65237,3723),(65238,3723),(65239,3724),(65240,3724),(65241,3724),(65242,3725),(65243,3725),(65244,3725),(65245,3726),(65246,3726),(65247,3726),(65248,3727),(65249,3727),(65250,3727),(65251,3728),(65252,3728),(65253,3728),(65254,3729),(65255,3729),(65256,3729),(65257,3730),(65258,3730),(65259,3730),(65260,3731),(65261,3731),(65262,3731),(65263,3732),(65264,3732),(65265,3732),(65266,3733),(65267,3733),(65268,3733),(65269,3734),(65270,3734),(65271,3734),(65272,3735),(65273,3735),(65274,3735),(65275,3736),(65276,3736),(65277,3736),(65278,3737),(65279,3737),(65280,3737),(65281,3738),(65282,3738),(65283,3738),(65284,3739),(65285,3739),(65286,3739),(65287,3740),(65288,3740),(65289,3740),(65290,3741),(65291,3741),(65292,3741),(65293,3742),(65294,3742),(65295,3742),(65296,3743),(65297,3743),(65298,3743),(65299,3744),(65300,3744),(65301,3744),(65302,3745),(65303,3745),(65304,3745),(65305,3746),(65306,3746),(65307,3746),(65308,3747),(65309,3747),(65310,3747),(65311,3748),(65312,3748),(65313,3748),(65314,3749),(65315,3749),(65316,3749),(65317,3750),(65318,3750),(65319,3750),(65320,3751),(65321,3751),(65322,3751),(65323,3752),(65324,3752),(65325,3752),(65326,3753),(65327,3753),(65328,3753),(65329,3754),(65330,3754),(65331,3754),(65332,3755),(65333,3755),(65334,3755),(65335,3756),(65336,3756),(65337,3756),(65338,3757),(65339,3757),(65340,3757),(65341,3758),(65342,3758),(65343,3758),(65344,3759),(65345,3759),(65346,3759),(65347,3760),(65348,3760),(65349,3760),(65350,3761),(65351,3761),(65352,3761),(65353,3762),(65354,3762),(65355,3762),(65356,3763),(65357,3763),(65358,3763),(65359,3764),(65360,3764),(65361,3764),(65362,3765),(65363,3765),(65364,3765),(65365,3766),(65366,3766),(65367,3766),(65368,3767),(65369,3767),(65370,3767),(65371,3768),(65372,3768),(65373,3768),(65374,3769),(65375,3769),(65376,3769),(65377,3770),(65378,3770),(65379,3770),(65380,3771),(65381,3771),(65382,3771),(65383,3772),(65384,3772),(65385,3772),(65386,3773),(65387,3773),(65388,3773),(65389,3774),(65390,3774),(65391,3774),(65392,3775),(65393,3775),(65394,3775),(65395,3776),(65396,3776),(65397,3776),(65398,3777),(65399,3777),(65400,3777),(65401,3778),(65402,3778),(65403,3778),(65404,3779),(65405,3779),(65406,3779),(65407,3780),(65408,3780),(65409,3780),(65410,3781),(65411,3781),(65412,3781),(65413,3782),(65414,3782),(65415,3782),(65416,3783),(65417,3783),(65418,3783),(65419,3784),(65420,3784),(65421,3784),(65422,3785),(65423,3785),(65424,3785),(65425,3786),(65426,3786),(65427,3786),(65428,3787),(65429,3787),(65430,3787),(65431,3788),(65432,3788),(65433,3788),(65434,3789),(65435,3789),(65436,3789),(65437,3790),(65438,3790),(65439,3790),(65440,3791),(65441,3791),(65442,3791),(65443,3792),(65444,3792),(65445,3792),(65446,3793),(65447,3793),(65448,3793),(65449,3794),(65450,3794),(65451,3794),(65452,3795),(65453,3795),(65454,3795),(65455,3796),(65456,3796),(65457,3796),(65458,3797),(65459,3797),(65460,3797),(65461,3798),(65462,3798),(65463,3798),(65464,3799),(65465,3799),(65466,3799),(65467,3800),(65468,3800),(65469,3800),(65470,3801),(65471,3801),(65472,3801),(65473,3802),(65474,3802),(65475,3802),(65476,3803),(65477,3803),(65478,3803),(65479,3804),(65480,3804),(65481,3804),(65482,3805),(65483,3805),(65484,3805),(65485,3806),(65486,3806),(65487,3806),(65488,3807),(65489,3807),(65490,3807),(65491,3808),(65492,3808),(65493,3808),(65494,3809),(65495,3809),(65496,3809),(65497,3810),(65498,3810),(65499,3810),(65500,3811),(65501,3811),(65502,3811),(65503,3812),(65504,3812),(65505,3812),(65506,3813),(65507,3813),(65508,3813),(65509,3814),(65510,3814),(65511,3814),(65512,3715),(65513,3715),(65514,3715),(65515,3715),(65516,3716),(65517,3716),(65518,3716),(65519,3716),(65520,3717),(65521,3717),(65522,3717),(65523,3717),(65524,3718),(65525,3718),(65526,3718),(65527,3718),(65528,3719),(65529,3719),(65530,3719),(65531,3719),(65532,3720),(65533,3720),(65534,3720),(65535,3720),(65536,3721),(65537,3721),(65538,3721),(65539,3721),(65540,3722),(65541,3722),(65542,3722),(65543,3722),(65544,3723),(65545,3723),(65546,3723),(65547,3723),(65548,3724),(65549,3724),(65550,3724),(65551,3724),(65552,3725),(65553,3725),(65554,3725),(65555,3725),(65556,3726),(65557,3726),(65558,3726),(65559,3726),(65560,3727),(65561,3727),(65562,3727),(65563,3727),(65564,3728),(65565,3728),(65566,3728),(65567,3728),(65568,3729),(65569,3729),(65570,3729),(65571,3729),(65572,3730),(65573,3730),(65574,3730),(65575,3730),(65576,3731),(65577,3731),(65578,3731),(65579,3731),(65580,3732),(65581,3732),(65582,3732),(65583,3732),(65584,3733),(65585,3733),(65586,3733),(65587,3733),(65588,3734),(65589,3734),(65590,3734),(65591,3734),(65592,3735),(65593,3735),(65594,3735),(65595,3735),(65596,3736),(65597,3736),(65598,3736),(65599,3736),(65600,3737),(65601,3737),(65602,3737),(65603,3737),(65604,3738),(65605,3738),(65606,3738),(65607,3738),(65608,3739),(65609,3739),(65610,3739),(65611,3739),(65612,3740),(65613,3740),(65614,3740),(65615,3740),(65616,3741),(65617,3741),(65618,3741),(65619,3741),(65620,3742),(65621,3742),(65622,3742),(65623,3742),(65624,3743),(65625,3743),(65626,3743),(65627,3743),(65628,3744),(65629,3744),(65630,3744),(65631,3744),(65632,3745),(65633,3745),(65634,3745),(65635,3745),(65636,3746),(65637,3746),(65638,3746),(65639,3746),(65640,3747),(65641,3747),(65642,3747),(65643,3747),(65644,3748),(65645,3748),(65646,3748),(65647,3748),(65648,3749),(65649,3749),(65650,3749),(65651,3749),(65652,3750),(65653,3750),(65654,3750),(65655,3750),(65656,3751),(65657,3751),(65658,3751),(65659,3751),(65660,3752),(65661,3752),(65662,3752),(65663,3752),(65664,3753),(65665,3753),(65666,3753),(65667,3753),(65668,3754),(65669,3754),(65670,3754),(65671,3754),(65672,3755),(65673,3755),(65674,3755),(65675,3755),(65676,3756),(65677,3756),(65678,3756),(65679,3756),(65680,3757),(65681,3757),(65682,3757),(65683,3757),(65684,3758),(65685,3758),(65686,3758),(65687,3758),(65688,3759),(65689,3759),(65690,3759),(65691,3759),(65692,3760),(65693,3760),(65694,3760),(65695,3760),(65696,3761),(65697,3761),(65698,3761),(65699,3761),(65700,3762),(65701,3762),(65702,3762),(65703,3762),(65704,3763),(65705,3763),(65706,3763),(65707,3763),(65708,3764),(65709,3764),(65710,3764),(65711,3764),(65712,3765),(65713,3765),(65714,3765),(65715,3765),(65716,3766),(65717,3766),(65718,3766),(65719,3766),(65720,3767),(65721,3767),(65722,3767),(65723,3767),(65724,3768),(65725,3768),(65726,3768),(65727,3768),(65728,3769),(65729,3769),(65730,3769),(65731,3769),(65732,3770),(65733,3770),(65734,3770),(65735,3770),(65736,3771),(65737,3771),(65738,3771),(65739,3771),(65740,3772),(65741,3772),(65742,3772),(65743,3772),(65744,3773),(65745,3773),(65746,3773),(65747,3773),(65748,3774),(65749,3774),(65750,3774),(65751,3774),(65752,3775),(65753,3775),(65754,3775),(65755,3775),(65756,3776),(65757,3776),(65758,3776),(65759,3776),(65760,3777),(65761,3777),(65762,3777),(65763,3777),(65764,3778),(65765,3778),(65766,3778),(65767,3778),(65768,3779),(65769,3779),(65770,3779),(65771,3779),(65772,3780),(65773,3780),(65774,3780),(65775,3780),(65776,3781),(65777,3781),(65778,3781),(65779,3781),(65780,3782),(65781,3782),(65782,3782),(65783,3782),(65784,3783),(65785,3783),(65786,3783),(65787,3783),(65788,3784),(65789,3784),(65790,3784),(65791,3784),(65792,3785),(65793,3785),(65794,3785),(65795,3785),(65796,3786),(65797,3786),(65798,3786),(65799,3786),(65800,3787),(65801,3787),(65802,3787),(65803,3787),(65804,3788),(65805,3788),(65806,3788),(65807,3788),(65808,3789),(65809,3789),(65810,3789),(65811,3789),(65812,3790),(65813,3790),(65814,3790),(65815,3790),(65816,3791),(65817,3791),(65818,3791),(65819,3791),(65820,3792),(65821,3792),(65822,3792),(65823,3792),(65824,3793),(65825,3793),(65826,3793),(65827,3793),(65828,3794),(65829,3794),(65830,3794),(65831,3794),(65832,3795),(65833,3795),(65834,3795),(65835,3795),(65836,3796),(65837,3796),(65838,3796),(65839,3796),(65840,3797),(65841,3797),(65842,3797),(65843,3797),(65844,3798),(65845,3798),(65846,3798),(65847,3798),(65848,3799),(65849,3799),(65850,3799),(65851,3799),(65852,3800),(65853,3800),(65854,3800),(65855,3800),(65856,3801),(65857,3801),(65858,3801),(65859,3801),(65860,3802),(65861,3802),(65862,3802),(65863,3802),(65864,3803),(65865,3803),(65866,3803),(65867,3803),(65868,3804),(65869,3804),(65870,3804),(65871,3804),(65872,3805),(65873,3805),(65874,3805),(65875,3805),(65876,3806),(65877,3806),(65878,3806),(65879,3806),(65880,3807),(65881,3807),(65882,3807),(65883,3807),(65884,3808),(65885,3808),(65886,3808),(65887,3808),(65888,3809),(65889,3809),(65890,3809),(65891,3809),(65892,3810),(65893,3810),(65894,3810),(65895,3810),(65896,3811),(65897,3811),(65898,3811),(65899,3811),(65900,3812),(65901,3812),(65902,3812),(65903,3812),(65904,3813),(65905,3813),(65906,3813),(65907,3813),(65908,3814),(65909,3814),(65910,3814),(65911,3814),(65912,3815),(65913,3816),(65914,3817),(65915,3818),(65916,3819),(65917,3820),(65918,3821),(65919,3822),(65920,3823),(65921,3824),(65922,3825),(65923,3826),(65924,3827),(65925,3828),(65926,3829),(65927,3830),(65928,3831),(65929,3832),(65930,3833),(65931,3834),(65932,3835),(65933,3836),(65934,3837),(65935,3838),(65936,3839),(65937,3840),(65938,3841),(65939,3842),(65940,3843),(65941,3844),(65942,3845),(65943,3846),(65944,3847),(65945,3848),(65946,3849),(65947,3850),(65948,3851),(65949,3852),(65950,3853),(65951,3854),(65952,3855),(65953,3856),(65954,3857),(65955,3858),(65956,3859),(65957,3860),(65958,3861),(65959,3862),(65960,3863),(65961,3864),(65962,3865),(65963,3866),(65964,3867),(65965,3868),(65966,3869),(65967,3870),(65968,3871),(65969,3872),(65970,3873),(65971,3874),(65972,3875),(65973,3876),(65974,3877),(65975,3878),(65976,3879),(65977,3880),(65978,3881),(65979,3882),(65980,3883),(65981,3884),(65982,3885),(65983,3886),(65984,3887),(65985,3888),(65986,3889),(65987,3890),(65988,3891),(65989,3892),(65990,3893),(65991,3894),(65992,3895),(65993,3896),(65994,3897),(65995,3898),(65996,3899),(65997,3900),(65998,3901),(65999,3902),(66000,3903),(66001,3904),(66002,3905),(66003,3906),(66004,3907),(66005,3908),(66006,3909),(66007,3910),(66008,3911),(66009,3912),(66010,3913),(66011,3914),(66012,3815),(66013,3815),(66014,3815),(66015,3815),(66016,3815),(66017,3815),(66018,3816),(66019,3816),(66020,3816),(66021,3816),(66022,3816),(66023,3816),(66024,3817),(66025,3817),(66026,3817),(66027,3817),(66028,3817),(66029,3817),(66030,3818),(66031,3818),(66032,3818),(66033,3818),(66034,3818),(66035,3818),(66036,3819),(66037,3819),(66038,3819),(66039,3819),(66040,3820),(66041,3820),(66042,3820),(66043,3820),(66044,3820),(66045,3820),(66046,3821),(66047,3821),(66048,3821),(66049,3821),(66050,3821),(66051,3821),(66052,3822),(66053,3822),(66054,3822),(66055,3822),(66056,3822),(66057,3822),(66058,3823),(66059,3823),(66060,3823),(66061,3823),(66062,3823),(66063,3823),(66064,3824),(66065,3824),(66066,3824),(66067,3824),(66068,3824),(66069,3824),(66070,3825),(66071,3825),(66072,3825),(66073,3825),(66074,3825),(66075,3825),(66076,3826),(66077,3826),(66078,3826),(66079,3826),(66080,3826),(66081,3826),(66082,3827),(66083,3827),(66084,3827),(66085,3827),(66086,3827),(66087,3827),(66088,3828),(66089,3828),(66090,3828),(66091,3828),(66092,3828),(66093,3828),(66094,3829),(66095,3829),(66096,3829),(66097,3829),(66098,3829),(66099,3829),(66100,3830),(66101,3830),(66102,3830),(66103,3830),(66104,3830),(66105,3830),(66106,3831),(66107,3831),(66108,3831),(66109,3831),(66110,3831),(66111,3831),(66112,3832),(66113,3832),(66114,3832),(66115,3832),(66116,3832),(66117,3832),(66118,3833),(66119,3833),(66120,3833),(66121,3833),(66122,3833),(66123,3833),(66124,3834),(66125,3834),(66126,3834),(66127,3834),(66128,3834),(66129,3834),(66130,3835),(66131,3835),(66132,3835),(66133,3835),(66134,3835),(66135,3835),(66136,3836),(66137,3836),(66138,3836),(66139,3836),(66140,3836),(66141,3836),(66142,3837),(66143,3837),(66144,3837),(66145,3837),(66146,3837),(66147,3837),(66148,3838),(66149,3838),(66150,3838),(66151,3838),(66152,3838),(66153,3838),(66154,3839),(66155,3839),(66156,3839),(66157,3839),(66158,3839),(66159,3839),(66160,3840),(66161,3840),(66162,3840),(66163,3840),(66164,3840),(66165,3840),(66166,3841),(66167,3841),(66168,3841),(66169,3841),(66170,3841),(66171,3841),(66172,3842),(66173,3842),(66174,3842),(66175,3842),(66176,3842),(66177,3842),(66178,3843),(66179,3843),(66180,3843),(66181,3843),(66182,3843),(66183,3843),(66184,3844),(66185,3844),(66186,3844),(66187,3844),(66188,3844),(66189,3844),(66190,3845),(66191,3845),(66192,3845),(66193,3845),(66194,3845),(66195,3845),(66196,3846),(66197,3846),(66198,3846),(66199,3846),(66200,3846),(66201,3846),(66202,3847),(66203,3847),(66204,3847),(66205,3847),(66206,3847),(66207,3847),(66208,3848),(66209,3848),(66210,3848),(66211,3848),(66212,3848),(66213,3848),(66214,3849),(66215,3849),(66216,3849),(66217,3849),(66218,3849),(66219,3849),(66220,3850),(66221,3850),(66222,3850),(66223,3850),(66224,3850),(66225,3850),(66226,3851),(66227,3851),(66228,3851),(66229,3851),(66230,3851),(66231,3851),(66232,3852),(66233,3852),(66234,3852),(66235,3852),(66236,3852),(66237,3852),(66238,3853),(66239,3853),(66240,3853),(66241,3853),(66242,3853),(66243,3853),(66244,3854),(66245,3854),(66246,3854),(66247,3854),(66248,3854),(66249,3854),(66250,3855),(66251,3855),(66252,3855),(66253,3855),(66254,3855),(66255,3855),(66256,3856),(66257,3856),(66258,3856),(66259,3856),(66260,3856),(66261,3856),(66262,3857),(66263,3857),(66264,3857),(66265,3857),(66266,3857),(66267,3857),(66268,3858),(66269,3858),(66270,3858),(66271,3858),(66272,3858),(66273,3858),(66274,3859),(66275,3859),(66276,3859),(66277,3859),(66278,3859),(66279,3859),(66280,3860),(66281,3860),(66282,3860),(66283,3860),(66284,3860),(66285,3860),(66286,3861),(66287,3861),(66288,3861),(66289,3861),(66290,3861),(66291,3861),(66292,3862),(66293,3862),(66294,3862),(66295,3862),(66296,3862),(66297,3862),(66298,3863),(66299,3863),(66300,3863),(66301,3863),(66302,3863),(66303,3863),(66304,3864),(66305,3864),(66306,3864),(66307,3864),(66308,3864),(66309,3864),(66310,3865),(66311,3865),(66312,3865),(66313,3865),(66314,3865),(66315,3865),(66316,3866),(66317,3866),(66318,3866),(66319,3866),(66320,3866),(66321,3866),(66322,3867),(66323,3867),(66324,3867),(66325,3867),(66326,3867),(66327,3867),(66328,3868),(66329,3868),(66330,3868),(66331,3868),(66332,3868),(66333,3868),(66334,3869),(66335,3869),(66336,3869),(66337,3869),(66338,3869),(66339,3869),(66340,3870),(66341,3870),(66342,3870),(66343,3870),(66344,3870),(66345,3870),(66346,3871),(66347,3871),(66348,3871),(66349,3871),(66350,3871),(66351,3871),(66352,3872),(66353,3872),(66354,3872),(66355,3872),(66356,3872),(66357,3872),(66358,3873),(66359,3873),(66360,3873),(66361,3873),(66362,3873),(66363,3873),(66364,3874),(66365,3874),(66366,3874),(66367,3874),(66368,3874),(66369,3874),(66370,3875),(66371,3875),(66372,3875),(66373,3875),(66374,3875),(66375,3875),(66376,3876),(66377,3876),(66378,3876),(66379,3876),(66380,3876),(66381,3876),(66382,3877),(66383,3877),(66384,3877),(66385,3877),(66386,3877),(66387,3877),(66388,3878),(66389,3878),(66390,3878),(66391,3878),(66392,3878),(66393,3878),(66394,3879),(66395,3879),(66396,3879),(66397,3879),(66398,3879),(66399,3879),(66400,3880),(66401,3880),(66402,3880),(66403,3880),(66404,3880),(66405,3880),(66406,3881),(66407,3881),(66408,3881),(66409,3881),(66410,3881),(66411,3881),(66412,3882),(66413,3882),(66414,3882),(66415,3882),(66416,3882),(66417,3882),(66418,3883),(66419,3883),(66420,3883),(66421,3883),(66422,3883),(66423,3883),(66424,3884),(66425,3884),(66426,3884),(66427,3884),(66428,3884),(66429,3884),(66430,3885),(66431,3885),(66432,3885),(66433,3885),(66434,3885),(66435,3885),(66436,3886),(66437,3886),(66438,3886),(66439,3886),(66440,3886),(66441,3886),(66442,3887),(66443,3887),(66444,3887),(66445,3887),(66446,3887),(66447,3887),(66448,3888),(66449,3888),(66450,3888),(66451,3888),(66452,3888),(66453,3888),(66454,3889),(66455,3889),(66456,3889),(66457,3889),(66458,3889),(66459,3889),(66460,3890),(66461,3890),(66462,3890),(66463,3890),(66464,3890),(66465,3890),(66466,3891),(66467,3891),(66468,3891),(66469,3891),(66470,3891),(66471,3891),(66472,3892),(66473,3892),(66474,3892),(66475,3892),(66476,3892),(66477,3892),(66478,3893),(66479,3893),(66480,3893),(66481,3893),(66482,3893),(66483,3893),(66484,3894),(66485,3894),(66486,3894),(66487,3894),(66488,3894),(66489,3894),(66490,3895),(66491,3895),(66492,3895),(66493,3895),(66494,3895),(66495,3895),(66496,3896),(66497,3896),(66498,3896),(66499,3896),(66500,3896),(66501,3897),(66502,3897),(66503,3897),(66504,3897),(66505,3897),(66506,3898),(66507,3898),(66508,3898),(66509,3898),(66510,3898),(66511,3898),(66512,3899),(66513,3899),(66514,3899),(66515,3899),(66516,3899),(66517,3899),(66518,3900),(66519,3900),(66520,3900),(66521,3900),(66522,3900),(66523,3900),(66524,3901),(66525,3901),(66526,3901),(66527,3901),(66528,3901),(66529,3901),(66530,3902),(66531,3902),(66532,3902),(66533,3902),(66534,3902),(66535,3902),(66536,3903),(66537,3903),(66538,3903),(66539,3903),(66540,3903),(66541,3903),(66542,3904),(66543,3904),(66544,3904),(66545,3904),(66546,3904),(66547,3904),(66548,3905),(66549,3905),(66550,3905),(66551,3905),(66552,3905),(66553,3905),(66554,3906),(66555,3906),(66556,3906),(66557,3906),(66558,3906),(66559,3906),(66560,3907),(66561,3907),(66562,3907),(66563,3907),(66564,3907),(66565,3907),(66566,3908),(66567,3908),(66568,3908),(66569,3908),(66570,3908),(66571,3908),(66572,3909),(66573,3909),(66574,3909),(66575,3909),(66576,3909),(66577,3909),(66578,3910),(66579,3910),(66580,3910),(66581,3910),(66582,3910),(66583,3910),(66584,3911),(66585,3911),(66586,3911),(66587,3911),(66588,3911),(66589,3911),(66590,3912),(66591,3912),(66592,3912),(66593,3912),(66594,3912),(66595,3912),(66596,3913),(66597,3913),(66598,3913),(66599,3913),(66600,3913),(66601,3913),(66602,3914),(66603,3914),(66604,3914),(66605,3914),(66606,3914),(66607,3914),(66608,3815),(66609,3815),(66610,3816),(66611,3816),(66612,3817),(66613,3817),(66614,3818),(66615,3818),(66616,3819),(66617,3820),(66618,3820),(66619,3821),(66620,3821),(66621,3822),(66622,3822),(66623,3823),(66624,3823),(66625,3824),(66626,3824),(66627,3825),(66628,3825),(66629,3826),(66630,3826),(66631,3827),(66632,3827),(66633,3828),(66634,3828),(66635,3829),(66636,3829),(66637,3830),(66638,3830),(66639,3831),(66640,3831),(66641,3832),(66642,3832),(66643,3833),(66644,3833),(66645,3834),(66646,3834),(66647,3835),(66648,3835),(66649,3836),(66650,3836),(66651,3837),(66652,3837),(66653,3838),(66654,3838),(66655,3839),(66656,3839),(66657,3840),(66658,3840),(66659,3841),(66660,3841),(66661,3842),(66662,3842),(66663,3843),(66664,3843),(66665,3844),(66666,3844),(66667,3845),(66668,3845),(66669,3846),(66670,3846),(66671,3847),(66672,3847),(66673,3848),(66674,3848),(66675,3849),(66676,3849),(66677,3850),(66678,3850),(66679,3851),(66680,3851),(66681,3852),(66682,3852),(66683,3853),(66684,3853),(66685,3854),(66686,3854),(66687,3855),(66688,3855),(66689,3856),(66690,3856),(66691,3857),(66692,3857),(66693,3858),(66694,3858),(66695,3859),(66696,3859),(66697,3860),(66698,3860),(66699,3861),(66700,3861),(66701,3862),(66702,3862),(66703,3863),(66704,3863),(66705,3864),(66706,3864),(66707,3865),(66708,3865),(66709,3866),(66710,3866),(66711,3867),(66712,3867),(66713,3868),(66714,3868),(66715,3869),(66716,3869),(66717,3870),(66718,3870),(66719,3871),(66720,3871),(66721,3872),(66722,3872),(66723,3873),(66724,3873),(66725,3874),(66726,3874),(66727,3875),(66728,3875),(66729,3876),(66730,3876),(66731,3877),(66732,3877),(66733,3878),(66734,3878),(66735,3879),(66736,3879),(66737,3880),(66738,3880),(66739,3881),(66740,3881),(66741,3882),(66742,3882),(66743,3883),(66744,3883),(66745,3884),(66746,3884),(66747,3884),(66748,3885),(66749,3885),(66750,3886),(66751,3886),(66752,3887),(66753,3887),(66754,3888),(66755,3888),(66756,3889),(66757,3889),(66758,3890),(66759,3890),(66760,3891),(66761,3891),(66762,3892),(66763,3892),(66764,3893),(66765,3893),(66766,3894),(66767,3894),(66768,3895),(66769,3895),(66770,3896),(66771,3896),(66772,3897),(66773,3897),(66774,3898),(66775,3898),(66776,3899),(66777,3899),(66778,3900),(66779,3900),(66780,3901),(66781,3901),(66782,3902),(66783,3902),(66784,3903),(66785,3903),(66786,3904),(66787,3904),(66788,3905),(66789,3905),(66790,3906),(66791,3906),(66792,3907),(66793,3907),(66794,3908),(66795,3908),(66796,3909),(66797,3909),(66798,3910),(66799,3910),(66800,3911),(66801,3911),(66802,3912),(66803,3912),(66804,3913),(66805,3913),(66806,3914),(66807,3914),(66808,3914),(66809,3815),(66810,3815),(66811,3815),(66812,3816),(66813,3816),(66814,3816),(66815,3817),(66816,3817),(66817,3817),(66818,3818),(66819,3818),(66820,3818),(66821,3819),(66822,3819),(66823,3819),(66824,3820),(66825,3820),(66826,3820),(66827,3821),(66828,3821),(66829,3821),(66830,3822),(66831,3822),(66832,3822),(66833,3823),(66834,3823),(66835,3823),(66836,3824),(66837,3824),(66838,3824),(66839,3825),(66840,3825),(66841,3825),(66842,3826),(66843,3826),(66844,3826),(66845,3827),(66846,3827),(66847,3827),(66848,3828),(66849,3828),(66850,3828),(66851,3829),(66852,3829),(66853,3829),(66854,3830),(66855,3830),(66856,3830),(66857,3831),(66858,3831),(66859,3831),(66860,3832),(66861,3832),(66862,3832),(66863,3833),(66864,3833),(66865,3833),(66866,3834),(66867,3834),(66868,3834),(66869,3835),(66870,3835),(66871,3835),(66872,3836),(66873,3836),(66874,3836),(66875,3837),(66876,3837),(66877,3837),(66878,3838),(66879,3838),(66880,3838),(66881,3839),(66882,3839),(66883,3839),(66884,3840),(66885,3840),(66886,3840),(66887,3841),(66888,3841),(66889,3841),(66890,3842),(66891,3842),(66892,3842),(66893,3843),(66894,3843),(66895,3843),(66896,3844),(66897,3844),(66898,3844),(66899,3845),(66900,3845),(66901,3845),(66902,3846),(66903,3846),(66904,3846),(66905,3847),(66906,3847),(66907,3847),(66908,3848),(66909,3848),(66910,3848),(66911,3849),(66912,3849),(66913,3849),(66914,3850),(66915,3850),(66916,3850),(66917,3851),(66918,3851),(66919,3851),(66920,3852),(66921,3852),(66922,3852),(66923,3853),(66924,3853),(66925,3853),(66926,3854),(66927,3854),(66928,3854),(66929,3855),(66930,3855),(66931,3855),(66932,3856),(66933,3856),(66934,3856),(66935,3857),(66936,3857),(66937,3857),(66938,3858),(66939,3858),(66940,3858),(66941,3859),(66942,3859),(66943,3859),(66944,3860),(66945,3860),(66946,3860),(66947,3861),(66948,3861),(66949,3861),(66950,3862),(66951,3862),(66952,3862),(66953,3863),(66954,3863),(66955,3863),(66956,3864),(66957,3864),(66958,3864),(66959,3865),(66960,3865),(66961,3865),(66962,3866),(66963,3866),(66964,3866),(66965,3867),(66966,3867),(66967,3867),(66968,3868),(66969,3868),(66970,3868),(66971,3869),(66972,3869),(66973,3869),(66974,3870),(66975,3870),(66976,3870),(66977,3871),(66978,3871),(66979,3871),(66980,3872),(66981,3872),(66982,3873),(66983,3873),(66984,3874),(66985,3874),(66986,3874),(66987,3875),(66988,3875),(66989,3875),(66990,3876),(66991,3876),(66992,3876),(66993,3877),(66994,3877),(66995,3877),(66996,3878),(66997,3878),(66998,3878),(66999,3879),(67000,3879),(67001,3879),(67002,3880),(67003,3880),(67004,3880),(67005,3881),(67006,3881),(67007,3881),(67008,3882),(67009,3882),(67010,3882),(67011,3883),(67012,3883),(67013,3883),(67014,3884),(67015,3884),(67016,3884),(67017,3885),(67018,3885),(67019,3886),(67020,3886),(67021,3886),(67022,3887),(67023,3887),(67024,3887),(67025,3888),(67026,3888),(67027,3888),(67028,3889),(67029,3889),(67030,3889),(67031,3890),(67032,3890),(67033,3890),(67034,3891),(67035,3891),(67036,3891),(67037,3892),(67038,3892),(67039,3892),(67040,3893),(67041,3893),(67042,3893),(67043,3894),(67044,3894),(67045,3894),(67046,3895),(67047,3895),(67048,3895),(67049,3896),(67050,3896),(67051,3896),(67052,3897),(67053,3897),(67054,3897),(67055,3898),(67056,3898),(67057,3898),(67058,3899),(67059,3899),(67060,3899),(67061,3900),(67062,3900),(67063,3900),(67064,3901),(67065,3901),(67066,3901),(67067,3902),(67068,3902),(67069,3902),(67070,3903),(67071,3903),(67072,3903),(67073,3904),(67074,3904),(67075,3904),(67076,3905),(67077,3905),(67078,3905),(67079,3906),(67080,3906),(67081,3906),(67082,3907),(67083,3907),(67084,3907),(67085,3908),(67086,3908),(67087,3908),(67088,3909),(67089,3909),(67090,3909),(67091,3910),(67092,3910),(67093,3910),(67094,3911),(67095,3911),(67096,3911),(67097,3912),(67098,3912),(67099,3912),(67100,3913),(67101,3913),(67102,3913),(67103,3914),(67104,3914),(67105,3914),(67106,3815),(67107,3815),(67108,3815),(67109,3815),(67110,3816),(67111,3816),(67112,3816),(67113,3816),(67114,3817),(67115,3817),(67116,3817),(67117,3817),(67118,3818),(67119,3818),(67120,3818),(67121,3818),(67122,3819),(67123,3819),(67124,3819),(67125,3819),(67126,3820),(67127,3820),(67128,3820),(67129,3820),(67130,3821),(67131,3821),(67132,3821),(67133,3821),(67134,3822),(67135,3822),(67136,3822),(67137,3822),(67138,3823),(67139,3823),(67140,3823),(67141,3823),(67142,3824),(67143,3824),(67144,3824),(67145,3824),(67146,3825),(67147,3825),(67148,3825),(67149,3825),(67150,3826),(67151,3826),(67152,3826),(67153,3826),(67154,3827),(67155,3827),(67156,3827),(67157,3827),(67158,3828),(67159,3828),(67160,3828),(67161,3828),(67162,3829),(67163,3829),(67164,3829),(67165,3829),(67166,3830),(67167,3830),(67168,3830),(67169,3830),(67170,3831),(67171,3831),(67172,3831),(67173,3831),(67174,3832),(67175,3832),(67176,3832),(67177,3832),(67178,3833),(67179,3833),(67180,3833),(67181,3833),(67182,3834),(67183,3834),(67184,3834),(67185,3834),(67186,3835),(67187,3835),(67188,3835),(67189,3835),(67190,3836),(67191,3836),(67192,3836),(67193,3836),(67194,3837),(67195,3837),(67196,3837),(67197,3837),(67198,3838),(67199,3838),(67200,3838),(67201,3838),(67202,3839),(67203,3839),(67204,3839),(67205,3839),(67206,3840),(67207,3840),(67208,3840),(67209,3840),(67210,3841),(67211,3841),(67212,3841),(67213,3841),(67214,3842),(67215,3842),(67216,3842),(67217,3842),(67218,3843),(67219,3843),(67220,3843),(67221,3843),(67222,3844),(67223,3844),(67224,3844),(67225,3844),(67226,3845),(67227,3845),(67228,3845),(67229,3845),(67230,3846),(67231,3846),(67232,3846),(67233,3846),(67234,3847),(67235,3847),(67236,3847),(67237,3847),(67238,3848),(67239,3848),(67240,3848),(67241,3848),(67242,3849),(67243,3849),(67244,3849),(67245,3849),(67246,3850),(67247,3850),(67248,3850),(67249,3850),(67250,3851),(67251,3851),(67252,3851),(67253,3851),(67254,3852),(67255,3852),(67256,3852),(67257,3852),(67258,3853),(67259,3853),(67260,3853),(67261,3853),(67262,3854),(67263,3854),(67264,3854),(67265,3854),(67266,3855),(67267,3855),(67268,3855),(67269,3855),(67270,3856),(67271,3856),(67272,3856),(67273,3856),(67274,3857),(67275,3857),(67276,3857),(67277,3857),(67278,3858),(67279,3858),(67280,3858),(67281,3858),(67282,3859),(67283,3859),(67284,3859),(67285,3859),(67286,3860),(67287,3860),(67288,3860),(67289,3860),(67290,3861),(67291,3861),(67292,3861),(67293,3861),(67294,3862),(67295,3862),(67296,3862),(67297,3862),(67298,3863),(67299,3863),(67300,3863),(67301,3863),(67302,3864),(67303,3864),(67304,3864),(67305,3864),(67306,3865),(67307,3865),(67308,3865),(67309,3865),(67310,3866),(67311,3866),(67312,3866),(67313,3866),(67314,3867),(67315,3867),(67316,3867),(67317,3867),(67318,3868),(67319,3868),(67320,3868),(67321,3868),(67322,3869),(67323,3869),(67324,3869),(67325,3869),(67326,3870),(67327,3870),(67328,3870),(67329,3870),(67330,3871),(67331,3871),(67332,3871),(67333,3871),(67334,3872),(67335,3872),(67336,3872),(67337,3872),(67338,3873),(67339,3873),(67340,3873),(67341,3873),(67342,3874),(67343,3874),(67344,3874),(67345,3874),(67346,3875),(67347,3875),(67348,3875),(67349,3875),(67350,3876),(67351,3876),(67352,3876),(67353,3876),(67354,3877),(67355,3877),(67356,3877),(67357,3877),(67358,3878),(67359,3878),(67360,3878),(67361,3878),(67362,3879),(67363,3879),(67364,3879),(67365,3879),(67366,3880),(67367,3880),(67368,3880),(67369,3880),(67370,3881),(67371,3881),(67372,3881),(67373,3881),(67374,3882),(67375,3882),(67376,3882),(67377,3882),(67378,3883),(67379,3883),(67380,3883),(67381,3883),(67382,3884),(67383,3884),(67384,3884),(67385,3884),(67386,3885),(67387,3885),(67388,3885),(67389,3885),(67390,3886),(67391,3886),(67392,3886),(67393,3886),(67394,3887),(67395,3887),(67396,3887),(67397,3887),(67398,3888),(67399,3888),(67400,3888),(67401,3888),(67402,3889),(67403,3889),(67404,3889),(67405,3889),(67406,3890),(67407,3890),(67408,3890),(67409,3890),(67410,3891),(67411,3891),(67412,3891),(67413,3891),(67414,3892),(67415,3892),(67416,3892),(67417,3892),(67418,3893),(67419,3893),(67420,3893),(67421,3893),(67422,3894),(67423,3894),(67424,3894),(67425,3894),(67426,3895),(67427,3895),(67428,3895),(67429,3895),(67430,3896),(67431,3896),(67432,3896),(67433,3896),(67434,3897),(67435,3897),(67436,3897),(67437,3897),(67438,3898),(67439,3898),(67440,3898),(67441,3898),(67442,3899),(67443,3899),(67444,3899),(67445,3899),(67446,3900),(67447,3900),(67448,3900),(67449,3900),(67450,3901),(67451,3901),(67452,3901),(67453,3901),(67454,3902),(67455,3902),(67456,3902),(67457,3902),(67458,3903),(67459,3903),(67460,3903),(67461,3903),(67462,3904),(67463,3904),(67464,3904),(67465,3904),(67466,3905),(67467,3905),(67468,3905),(67469,3905),(67470,3906),(67471,3906),(67472,3906),(67473,3906),(67474,3907),(67475,3907),(67476,3907),(67477,3907),(67478,3908),(67479,3908),(67480,3908),(67481,3908),(67482,3909),(67483,3909),(67484,3909),(67485,3909),(67486,3910),(67487,3910),(67488,3910),(67489,3910),(67490,3911),(67491,3911),(67492,3911),(67493,3911),(67494,3912),(67495,3912),(67496,3912),(67497,3912),(67498,3913),(67499,3913),(67500,3913),(67501,3913),(67502,3914),(67503,3914),(67504,3914),(67505,3914),(67506,3915),(67507,3916),(67508,3917),(67509,3918),(67510,3919),(67511,3920),(67512,3921),(67513,3922),(67514,3923),(67515,3924),(67516,3925),(67517,3926),(67518,3927),(67519,3928),(67520,3929),(67521,3930),(67522,3931),(67523,3932),(67524,3933),(67525,3934),(67526,3935),(67527,3936),(67528,3937),(67529,3938),(67530,3939),(67531,3940),(67532,3941),(67533,3942),(67534,3943),(67535,3944),(67536,3945),(67537,3946),(67538,3947),(67539,3948),(67540,3949),(67541,3950),(67542,3951),(67543,3952),(67544,3953),(67545,3954),(67546,3955),(67547,3956),(67548,3957),(67549,3958),(67550,3959),(67551,3960),(67552,3961),(67553,3962),(67554,3963),(67555,3964),(67556,3965),(67557,3966),(67558,3967),(67559,3968),(67560,3969),(67561,3970),(67562,3971),(67563,3972),(67564,3973),(67565,3974),(67566,3975),(67567,3976),(67568,3977),(67569,3978),(67570,3979),(67571,3980),(67572,3981),(67573,3982),(67574,3983),(67575,3984),(67576,3985),(67577,3986),(67578,3987),(67579,3988),(67580,3989),(67581,3990),(67582,3991),(67583,3992),(67584,3993),(67585,3994),(67586,3995),(67587,3996),(67588,3997),(67589,3998),(67590,3999),(67591,4000),(67592,4001),(67593,4002),(67594,4003),(67595,4004),(67596,4005),(67597,4006),(67598,4007),(67599,4008),(67600,4009),(67601,4010),(67602,4011),(67603,4012),(67604,4013),(67605,4014),(67606,3915),(67607,3915),(67608,3915),(67609,3915),(67610,3915),(67611,3915),(67612,3916),(67613,3916),(67614,3916),(67615,3916),(67616,3916),(67617,3916),(67618,3917),(67619,3917),(67620,3917),(67621,3917),(67622,3917),(67623,3917),(67624,3918),(67625,3918),(67626,3918),(67627,3918),(67628,3918),(67629,3918),(67630,3919),(67631,3919),(67632,3919),(67633,3919),(67634,3919),(67635,3919),(67636,3920),(67637,3920),(67638,3920),(67639,3920),(67640,3920),(67641,3920),(67642,3921),(67643,3921),(67644,3921),(67645,3921),(67646,3921),(67647,3921),(67648,3922),(67649,3922),(67650,3922),(67651,3922),(67652,3922),(67653,3922),(67654,3923),(67655,3923),(67656,3923),(67657,3923),(67658,3923),(67659,3923),(67660,3924),(67661,3924),(67662,3924),(67663,3924),(67664,3924),(67665,3924),(67666,3925),(67667,3925),(67668,3925),(67669,3925),(67670,3925),(67671,3925),(67672,3926),(67673,3926),(67674,3926),(67675,3926),(67676,3926),(67677,3926),(67678,3927),(67679,3927),(67680,3927),(67681,3927),(67682,3927),(67683,3927),(67684,3928),(67685,3928),(67686,3928),(67687,3928),(67688,3928),(67689,3928),(67690,3929),(67691,3929),(67692,3929),(67693,3929),(67694,3929),(67695,3929),(67696,3930),(67697,3930),(67698,3930),(67699,3930),(67700,3930),(67701,3930),(67702,3931),(67703,3931),(67704,3931),(67705,3931),(67706,3931),(67707,3931),(67708,3932),(67709,3932),(67710,3932),(67711,3932),(67712,3932),(67713,3932),(67714,3933),(67715,3933),(67716,3933),(67717,3933),(67718,3933),(67719,3933),(67720,3934),(67721,3934),(67722,3934),(67723,3934),(67724,3934),(67725,3934),(67726,3935),(67727,3935),(67728,3935),(67729,3935),(67730,3935),(67731,3935),(67732,3936),(67733,3936),(67734,3936),(67735,3936),(67736,3936),(67737,3936),(67738,3937),(67739,3937),(67740,3937),(67741,3937),(67742,3937),(67743,3937),(67744,3938),(67745,3938),(67746,3938),(67747,3938),(67748,3938),(67749,3938),(67750,3939),(67751,3939),(67752,3939),(67753,3939),(67754,3939),(67755,3939),(67756,3940),(67757,3940),(67758,3940),(67759,3940),(67760,3940),(67761,3940),(67762,3941),(67763,3941),(67764,3941),(67765,3941),(67766,3941),(67767,3941),(67768,3942),(67769,3942),(67770,3942),(67771,3942),(67772,3942),(67773,3942),(67774,3943),(67775,3943),(67776,3943),(67777,3943),(67778,3943),(67779,3943),(67780,3944),(67781,3944),(67782,3944),(67783,3944),(67784,3944),(67785,3944),(67786,3945),(67787,3945),(67788,3945),(67789,3945),(67790,3945),(67791,3945),(67792,3946),(67793,3946),(67794,3946),(67795,3946),(67796,3946),(67797,3946),(67798,3947),(67799,3947),(67800,3947),(67801,3947),(67802,3947),(67803,3947),(67804,3948),(67805,3948),(67806,3948),(67807,3948),(67808,3948),(67809,3948),(67810,3949),(67811,3949),(67812,3949),(67813,3949),(67814,3949),(67815,3949),(67816,3950),(67817,3950),(67818,3950),(67819,3950),(67820,3950),(67821,3950),(67822,3951),(67823,3951),(67824,3951),(67825,3951),(67826,3951),(67827,3951),(67828,3952),(67829,3952),(67830,3952),(67831,3952),(67832,3952),(67833,3952),(67834,3953),(67835,3953),(67836,3953),(67837,3953),(67838,3953),(67839,3953),(67840,3954),(67841,3954),(67842,3954),(67843,3954),(67844,3954),(67845,3954),(67846,3955),(67847,3955),(67848,3955),(67849,3955),(67850,3955),(67851,3955),(67852,3956),(67853,3956),(67854,3956),(67855,3956),(67856,3956),(67857,3956),(67858,3957),(67859,3957),(67860,3957),(67861,3957),(67862,3957),(67863,3957),(67864,3958),(67865,3958),(67866,3958),(67867,3958),(67868,3958),(67869,3958),(67870,3959),(67871,3959),(67872,3959),(67873,3959),(67874,3959),(67875,3959),(67876,3960),(67877,3960),(67878,3960),(67879,3960),(67880,3960),(67881,3960),(67882,3961),(67883,3961),(67884,3961),(67885,3961),(67886,3961),(67887,3961),(67888,3962),(67889,3962),(67890,3962),(67891,3962),(67892,3962),(67893,3962),(67894,3963),(67895,3963),(67896,3963),(67897,3963),(67898,3963),(67899,3963),(67900,3964),(67901,3964),(67902,3964),(67903,3964),(67904,3964),(67905,3964),(67906,3965),(67907,3965),(67908,3965),(67909,3965),(67910,3965),(67911,3965),(67912,3966),(67913,3966),(67914,3966),(67915,3966),(67916,3966),(67917,3966),(67918,3967),(67919,3967),(67920,3967),(67921,3967),(67922,3967),(67923,3967),(67924,3968),(67925,3968),(67926,3968),(67927,3968),(67928,3968),(67929,3968),(67930,3969),(67931,3969),(67932,3969),(67933,3969),(67934,3969),(67935,3969),(67936,3970),(67937,3970),(67938,3970),(67939,3970),(67940,3970),(67941,3970),(67942,3971),(67943,3971),(67944,3971),(67945,3971),(67946,3971),(67947,3971),(67948,3972),(67949,3972),(67950,3972),(67951,3972),(67952,3972),(67953,3972),(67954,3973),(67955,3973),(67956,3973),(67957,3973),(67958,3973),(67959,3973),(67960,3974),(67961,3974),(67962,3974),(67963,3974),(67964,3974),(67965,3974),(67966,3975),(67967,3975),(67968,3975),(67969,3975),(67970,3975),(67971,3975),(67972,3976),(67973,3976),(67974,3976),(67975,3976),(67976,3976),(67977,3976),(67978,3977),(67979,3977),(67980,3977),(67981,3977),(67982,3977),(67983,3977),(67984,3978),(67985,3978),(67986,3978),(67987,3978),(67988,3978),(67989,3978),(67990,3979),(67991,3979),(67992,3979),(67993,3979),(67994,3979),(67995,3979),(67996,3980),(67997,3980),(67998,3980),(67999,3980),(68000,3980),(68001,3980),(68002,3981),(68003,3981),(68004,3981),(68005,3981),(68006,3981),(68007,3981),(68008,3982),(68009,3982),(68010,3982),(68011,3982),(68012,3983),(68013,3983),(68014,3983),(68015,3983),(68016,3984),(68017,3984),(68018,3984),(68019,3984),(68020,3985),(68021,3985),(68022,3985),(68023,3985),(68024,3986),(68025,3986),(68026,3986),(68027,3986),(68028,3987),(68029,3987),(68030,3987),(68031,3987),(68032,3988),(68033,3988),(68034,3988),(68035,3988),(68036,3989),(68037,3989),(68038,3989),(68039,3989),(68040,3989),(68041,3989),(68042,3990),(68043,3990),(68044,3990),(68045,3990),(68046,3990),(68047,3990),(68048,3991),(68049,3991),(68050,3991),(68051,3991),(68052,3991),(68053,3991),(68054,3992),(68055,3992),(68056,3992),(68057,3992),(68058,3992),(68059,3992),(68060,3993),(68061,3993),(68062,3993),(68063,3993),(68064,3993),(68065,3993),(68066,3994),(68067,3994),(68068,3994),(68069,3994),(68070,3994),(68071,3994),(68072,3995),(68073,3995),(68074,3995),(68075,3995),(68076,3995),(68077,3995),(68078,3996),(68079,3996),(68080,3996),(68081,3996),(68082,3996),(68083,3996),(68084,3997),(68085,3997),(68086,3997),(68087,3997),(68088,3997),(68089,3997),(68090,3998),(68091,3998),(68092,3998),(68093,3998),(68094,3998),(68095,3998),(68096,3999),(68097,3999),(68098,3999),(68099,3999),(68100,3999),(68101,3999),(68102,4000),(68103,4000),(68104,4000),(68105,4000),(68106,4000),(68107,4000),(68108,4001),(68109,4001),(68110,4001),(68111,4001),(68112,4001),(68113,4001),(68114,4002),(68115,4002),(68116,4002),(68117,4002),(68118,4002),(68119,4002),(68120,4003),(68121,4003),(68122,4003),(68123,4003),(68124,4003),(68125,4003),(68126,4004),(68127,4004),(68128,4004),(68129,4004),(68130,4004),(68131,4004),(68132,4005),(68133,4005),(68134,4005),(68135,4005),(68136,4005),(68137,4005),(68138,4006),(68139,4006),(68140,4006),(68141,4006),(68142,4006),(68143,4006),(68144,4007),(68145,4007),(68146,4007),(68147,4007),(68148,4007),(68149,4007),(68150,4008),(68151,4008),(68152,4008),(68153,4008),(68154,4008),(68155,4008),(68156,4009),(68157,4009),(68158,4009),(68159,4009),(68160,4009),(68161,4009),(68162,4010),(68163,4010),(68164,4010),(68165,4010),(68166,4010),(68167,4010),(68168,4011),(68169,4011),(68170,4011),(68171,4011),(68172,4011),(68173,4011),(68174,4012),(68175,4012),(68176,4012),(68177,4012),(68178,4012),(68179,4012),(68180,4013),(68181,4013),(68182,4013),(68183,4013),(68184,4013),(68185,4013),(68186,4014),(68187,4014),(68188,4014),(68189,4014),(68190,4014),(68191,4014),(68192,3915),(68193,3915),(68194,3916),(68195,3916),(68196,3917),(68197,3917),(68198,3918),(68199,3918),(68200,3919),(68201,3919),(68202,3920),(68203,3920),(68204,3921),(68205,3921),(68206,3922),(68207,3922),(68208,3923),(68209,3923),(68210,3924),(68211,3924),(68212,3925),(68213,3925),(68214,3926),(68215,3926),(68216,3927),(68217,3927),(68218,3928),(68219,3928),(68220,3929),(68221,3929),(68222,3930),(68223,3930),(68224,3931),(68225,3931),(68226,3932),(68227,3932),(68228,3933),(68229,3933),(68230,3934),(68231,3934),(68232,3935),(68233,3935),(68234,3936),(68235,3936),(68236,3937),(68237,3937),(68238,3938),(68239,3938),(68240,3939),(68241,3939),(68242,3940),(68243,3940),(68244,3941),(68245,3941),(68246,3942),(68247,3942),(68248,3943),(68249,3943),(68250,3944),(68251,3944),(68252,3945),(68253,3945),(68254,3946),(68255,3946),(68256,3947),(68257,3947),(68258,3948),(68259,3948),(68260,3949),(68261,3949),(68262,3950),(68263,3950),(68264,3951),(68265,3951),(68266,3952),(68267,3952),(68268,3953),(68269,3953),(68270,3954),(68271,3954),(68272,3955),(68273,3955),(68274,3956),(68275,3956),(68276,3957),(68277,3957),(68278,3958),(68279,3958),(68280,3959),(68281,3959),(68282,3960),(68283,3960),(68284,3961),(68285,3961),(68286,3962),(68287,3962),(68288,3963),(68289,3963),(68290,3964),(68291,3964),(68292,3965),(68293,3965),(68294,3966),(68295,3966),(68296,3967),(68297,3967),(68298,3968),(68299,3968),(68300,3969),(68301,3969),(68302,3970),(68303,3970),(68304,3971),(68305,3971),(68306,3972),(68307,3972),(68308,3973),(68309,3973),(68310,3974),(68311,3974),(68312,3975),(68313,3975),(68314,3976),(68315,3976),(68316,3977),(68317,3977),(68318,3978),(68319,3978),(68320,3979),(68321,3979),(68322,3980),(68323,3980),(68324,3981),(68325,3981),(68326,3982),(68327,3983),(68328,3984),(68329,3985),(68330,3986),(68331,3987),(68332,3988),(68333,3989),(68334,3989),(68335,3990),(68336,3990),(68337,3991),(68338,3991),(68339,3992),(68340,3992),(68341,3993),(68342,3993),(68343,3994),(68344,3994),(68345,3995),(68346,3995),(68347,3996),(68348,3996),(68349,3997),(68350,3997),(68351,3998),(68352,3998),(68353,3999),(68354,3999),(68355,4000),(68356,4000),(68357,4001),(68358,4001),(68359,4002),(68360,4002),(68361,4003),(68362,4003),(68363,4004),(68364,4004),(68365,4005),(68366,4005),(68367,4006),(68368,4006),(68369,4007),(68370,4007),(68371,4008),(68372,4008),(68373,4009),(68374,4009),(68375,4010),(68376,4010),(68377,4011),(68378,4011),(68379,4012),(68380,4012),(68381,4013),(68382,4013),(68383,4014),(68384,4014),(68385,3915),(68386,3915),(68387,3915),(68388,3916),(68389,3916),(68390,3916),(68391,3917),(68392,3917),(68393,3917),(68394,3918),(68395,3918),(68396,3918),(68397,3919),(68398,3919),(68399,3920),(68400,3920),(68401,3921),(68402,3921),(68403,3922),(68404,3922),(68405,3923),(68406,3923),(68407,3923),(68408,3924),(68409,3924),(68410,3924),(68411,3925),(68412,3925),(68413,3925),(68414,3926),(68415,3926),(68416,3926),(68417,3927),(68418,3927),(68419,3927),(68420,3928),(68421,3928),(68422,3928),(68423,3929),(68424,3929),(68425,3929),(68426,3930),(68427,3930),(68428,3930),(68429,3931),(68430,3931),(68431,3931),(68432,3932),(68433,3932),(68434,3932),(68435,3933),(68436,3933),(68437,3933),(68438,3934),(68439,3934),(68440,3934),(68441,3935),(68442,3935),(68443,3935),(68444,3936),(68445,3936),(68446,3936),(68447,3937),(68448,3937),(68449,3937),(68450,3938),(68451,3938),(68452,3938),(68453,3939),(68454,3939),(68455,3939),(68456,3940),(68457,3940),(68458,3940),(68459,3941),(68460,3941),(68461,3941),(68462,3942),(68463,3942),(68464,3942),(68465,3943),(68466,3943),(68467,3943),(68468,3944),(68469,3944),(68470,3944),(68471,3945),(68472,3945),(68473,3945),(68474,3946),(68475,3946),(68476,3946),(68477,3947),(68478,3947),(68479,3947),(68480,3948),(68481,3948),(68482,3948),(68483,3949),(68484,3949),(68485,3949),(68486,3950),(68487,3950),(68488,3950),(68489,3951),(68490,3951),(68491,3951),(68492,3952),(68493,3952),(68494,3952),(68495,3953),(68496,3953),(68497,3953),(68498,3954),(68499,3954),(68500,3954),(68501,3955),(68502,3955),(68503,3955),(68504,3956),(68505,3956),(68506,3956),(68507,3957),(68508,3957),(68509,3957),(68510,3958),(68511,3958),(68512,3958),(68513,3959),(68514,3959),(68515,3959),(68516,3960),(68517,3960),(68518,3960),(68519,3961),(68520,3961),(68521,3961),(68522,3962),(68523,3962),(68524,3962),(68525,3963),(68526,3963),(68527,3963),(68528,3964),(68529,3964),(68530,3964),(68531,3965),(68532,3965),(68533,3965),(68534,3966),(68535,3966),(68536,3966),(68537,3967),(68538,3967),(68539,3967),(68540,3968),(68541,3968),(68542,3968),(68543,3969),(68544,3969),(68545,3969),(68546,3970),(68547,3970),(68548,3970),(68549,3971),(68550,3971),(68551,3971),(68552,3972),(68553,3972),(68554,3972),(68555,3973),(68556,3973),(68557,3973),(68558,3974),(68559,3974),(68560,3974),(68561,3975),(68562,3975),(68563,3975),(68564,3976),(68565,3976),(68566,3976),(68567,3977),(68568,3977),(68569,3977),(68570,3978),(68571,3978),(68572,3978),(68573,3979),(68574,3979),(68575,3979),(68576,3980),(68577,3980),(68578,3980),(68579,3981),(68580,3981),(68581,3981),(68582,3982),(68583,3982),(68584,3982),(68585,3983),(68586,3983),(68587,3983),(68588,3984),(68589,3984),(68590,3984),(68591,3985),(68592,3985),(68593,3985),(68594,3986),(68595,3986),(68596,3986),(68597,3987),(68598,3987),(68599,3987),(68600,3988),(68601,3988),(68602,3988),(68603,3989),(68604,3989),(68605,3989),(68606,3990),(68607,3990),(68608,3990),(68609,3991),(68610,3991),(68611,3991),(68612,3992),(68613,3992),(68614,3992),(68615,3993),(68616,3993),(68617,3993),(68618,3994),(68619,3994),(68620,3994),(68621,3995),(68622,3995),(68623,3995),(68624,3996),(68625,3996),(68626,3996),(68627,3997),(68628,3997),(68629,3997),(68630,3998),(68631,3998),(68632,3998),(68633,3999),(68634,3999),(68635,3999),(68636,4000),(68637,4000),(68638,4000),(68639,4001),(68640,4001),(68641,4001),(68642,4002),(68643,4002),(68644,4002),(68645,4003),(68646,4003),(68647,4003),(68648,4004),(68649,4004),(68650,4004),(68651,4005),(68652,4005),(68653,4005),(68654,4006),(68655,4006),(68656,4006),(68657,4007),(68658,4007),(68659,4007),(68660,4008),(68661,4008),(68662,4008),(68663,4009),(68664,4009),(68665,4009),(68666,4010),(68667,4010),(68668,4010),(68669,4011),(68670,4011),(68671,4011),(68672,4012),(68673,4012),(68674,4012),(68675,4013),(68676,4013),(68677,4013),(68678,4014),(68679,4014),(68680,4014),(68681,3915),(68682,3915),(68683,3915),(68684,3915),(68685,3916),(68686,3916),(68687,3916),(68688,3916),(68689,3917),(68690,3917),(68691,3917),(68692,3917),(68693,3918),(68694,3918),(68695,3918),(68696,3918),(68697,3919),(68698,3919),(68699,3919),(68700,3919),(68701,3920),(68702,3920),(68703,3920),(68704,3920),(68705,3921),(68706,3921),(68707,3921),(68708,3921),(68709,3922),(68710,3922),(68711,3922),(68712,3922),(68713,3923),(68714,3923),(68715,3923),(68716,3923),(68717,3924),(68718,3924),(68719,3924),(68720,3924),(68721,3925),(68722,3925),(68723,3925),(68724,3925),(68725,3926),(68726,3926),(68727,3926),(68728,3926),(68729,3927),(68730,3927),(68731,3927),(68732,3927),(68733,3928),(68734,3928),(68735,3928),(68736,3928),(68737,3929),(68738,3929),(68739,3929),(68740,3929),(68741,3930),(68742,3930),(68743,3930),(68744,3930),(68745,3931),(68746,3931),(68747,3931),(68748,3931),(68749,3932),(68750,3932),(68751,3932),(68752,3932),(68753,3933),(68754,3933),(68755,3933),(68756,3933),(68757,3934),(68758,3934),(68759,3934),(68760,3934),(68761,3935),(68762,3935),(68763,3935),(68764,3935),(68765,3936),(68766,3936),(68767,3936),(68768,3936),(68769,3937),(68770,3937),(68771,3937),(68772,3937),(68773,3938),(68774,3938),(68775,3938),(68776,3938),(68777,3939),(68778,3939),(68779,3939),(68780,3939),(68781,3940),(68782,3940),(68783,3940),(68784,3940),(68785,3941),(68786,3941),(68787,3941),(68788,3941),(68789,3942),(68790,3942),(68791,3942),(68792,3942),(68793,3943),(68794,3943),(68795,3943),(68796,3943),(68797,3944),(68798,3944),(68799,3944),(68800,3944),(68801,3945),(68802,3945),(68803,3945),(68804,3945),(68805,3946),(68806,3946),(68807,3946),(68808,3946),(68809,3947),(68810,3947),(68811,3947),(68812,3947),(68813,3948),(68814,3948),(68815,3948),(68816,3948),(68817,3949),(68818,3949),(68819,3949),(68820,3949),(68821,3950),(68822,3950),(68823,3950),(68824,3950),(68825,3951),(68826,3951),(68827,3951),(68828,3951),(68829,3952),(68830,3952),(68831,3952),(68832,3952),(68833,3953),(68834,3953),(68835,3953),(68836,3953),(68837,3954),(68838,3954),(68839,3954),(68840,3954),(68841,3955),(68842,3955),(68843,3955),(68844,3955),(68845,3956),(68846,3956),(68847,3956),(68848,3956),(68849,3957),(68850,3957),(68851,3957),(68852,3957),(68853,3958),(68854,3958),(68855,3958),(68856,3958),(68857,3959),(68858,3959),(68859,3959),(68860,3959),(68861,3960),(68862,3960),(68863,3960),(68864,3960),(68865,3961),(68866,3961),(68867,3961),(68868,3961),(68869,3962),(68870,3962),(68871,3962),(68872,3962),(68873,3963),(68874,3963),(68875,3963),(68876,3963),(68877,3964),(68878,3964),(68879,3964),(68880,3964),(68881,3965),(68882,3965),(68883,3965),(68884,3965),(68885,3966),(68886,3966),(68887,3966),(68888,3966),(68889,3967),(68890,3967),(68891,3967),(68892,3967),(68893,3968),(68894,3968),(68895,3968),(68896,3968),(68897,3969),(68898,3969),(68899,3969),(68900,3969),(68901,3970),(68902,3970),(68903,3970),(68904,3970),(68905,3971),(68906,3971),(68907,3971),(68908,3971),(68909,3972),(68910,3972),(68911,3972),(68912,3972),(68913,3973),(68914,3973),(68915,3973),(68916,3973),(68917,3974),(68918,3974),(68919,3974),(68920,3974),(68921,3975),(68922,3975),(68923,3975),(68924,3975),(68925,3976),(68926,3976),(68927,3976),(68928,3976),(68929,3977),(68930,3977),(68931,3977),(68932,3977),(68933,3978),(68934,3978),(68935,3978),(68936,3978),(68937,3979),(68938,3979),(68939,3979),(68940,3979),(68941,3980),(68942,3980),(68943,3980),(68944,3980),(68945,3981),(68946,3981),(68947,3981),(68948,3981),(68949,3982),(68950,3982),(68951,3982),(68952,3982),(68953,3983),(68954,3983),(68955,3983),(68956,3983),(68957,3984),(68958,3984),(68959,3984),(68960,3984),(68961,3985),(68962,3985),(68963,3985),(68964,3985),(68965,3986),(68966,3986),(68967,3986),(68968,3986),(68969,3987),(68970,3987),(68971,3987),(68972,3987),(68973,3988),(68974,3988),(68975,3988),(68976,3988),(68977,3989),(68978,3989),(68979,3989),(68980,3989),(68981,3990),(68982,3990),(68983,3990),(68984,3990),(68985,3991),(68986,3991),(68987,3991),(68988,3991),(68989,3992),(68990,3992),(68991,3992),(68992,3992),(68993,3993),(68994,3993),(68995,3993),(68996,3993),(68997,3994),(68998,3994),(68999,3994),(69000,3994),(69001,3995),(69002,3995),(69003,3995),(69004,3995),(69005,3996),(69006,3996),(69007,3996),(69008,3996),(69009,3997),(69010,3997),(69011,3997),(69012,3997),(69013,3998),(69014,3998),(69015,3998),(69016,3998),(69017,3999),(69018,3999),(69019,3999),(69020,3999),(69021,4000),(69022,4000),(69023,4000),(69024,4000),(69025,4001),(69026,4001),(69027,4001),(69028,4001),(69029,4002),(69030,4002),(69031,4002),(69032,4002),(69033,4003),(69034,4003),(69035,4003),(69036,4003),(69037,4004),(69038,4004),(69039,4004),(69040,4004),(69041,4005),(69042,4005),(69043,4005),(69044,4005),(69045,4006),(69046,4006),(69047,4006),(69048,4006),(69049,4007),(69050,4007),(69051,4007),(69052,4007),(69053,4008),(69054,4008),(69055,4008),(69056,4008),(69057,4009),(69058,4009),(69059,4009),(69060,4009),(69061,4010),(69062,4010),(69063,4010),(69064,4010),(69065,4011),(69066,4011),(69067,4011),(69068,4011),(69069,4012),(69070,4012),(69071,4012),(69072,4012),(69073,4013),(69074,4013),(69075,4013),(69076,4013),(69077,4014),(69078,4014),(69079,4014),(69080,4014),(69081,4015),(69082,4016),(69083,4017),(69084,4018),(69085,4019),(69086,4020),(69087,4021),(69088,4022),(69089,4023),(69090,4024),(69091,4025),(69092,4026),(69093,4027),(69094,4028),(69095,4029),(69096,4030),(69097,4031),(69098,4032),(69099,4033),(69100,4034),(69101,4035),(69102,4036),(69103,4037),(69104,4038),(69105,4039),(69106,4040),(69107,4041),(69108,4042),(69109,4043),(69110,4044),(69111,4045),(69112,4046),(69113,4047),(69114,4048),(69115,4049),(69116,4050),(69117,4051),(69118,4052),(69119,4053),(69120,4054),(69121,4055),(69122,4056),(69123,4057),(69124,4058),(69125,4059),(69126,4060),(69127,4061),(69128,4062),(69129,4063),(69130,4064),(69131,4065),(69132,4066),(69133,4067),(69134,4068),(69135,4069),(69136,4070),(69137,4071),(69138,4072),(69139,4073),(69140,4074),(69141,4075),(69142,4076),(69143,4077),(69144,4078),(69145,4079),(69146,4080),(69147,4081),(69148,4082),(69149,4083),(69150,4084),(69151,4085),(69152,4086),(69153,4087),(69154,4088),(69155,4089),(69156,4090),(69157,4091),(69158,4092),(69159,4093),(69160,4094),(69161,4095),(69162,4096),(69163,4097),(69164,4098),(69165,4099),(69166,4100),(69167,4101),(69168,4102),(69169,4103),(69170,4104),(69171,4105),(69172,4106),(69173,4107),(69174,4108),(69175,4109),(69176,4110),(69177,4111),(69178,4112),(69179,4113),(69180,4114),(69181,4015),(69182,4015),(69183,4015),(69184,4015),(69185,4015),(69186,4015),(69187,4016),(69188,4016),(69189,4016),(69190,4016),(69191,4016),(69192,4016),(69193,4017),(69194,4017),(69195,4017),(69196,4017),(69197,4017),(69198,4017),(69199,4018),(69200,4018),(69201,4018),(69202,4018),(69203,4018),(69204,4018),(69205,4019),(69206,4019),(69207,4019),(69208,4019),(69209,4019),(69210,4019),(69211,4020),(69212,4020),(69213,4020),(69214,4020),(69215,4020),(69216,4020),(69217,4021),(69218,4021),(69219,4021),(69220,4021),(69221,4021),(69222,4021),(69223,4022),(69224,4022),(69225,4022),(69226,4022),(69227,4022),(69228,4022),(69229,4023),(69230,4023),(69231,4023),(69232,4023),(69233,4023),(69234,4023),(69235,4024),(69236,4024),(69237,4024),(69238,4024),(69239,4024),(69240,4024),(69241,4025),(69242,4025),(69243,4025),(69244,4025),(69245,4025),(69246,4025),(69247,4026),(69248,4026),(69249,4026),(69250,4026),(69251,4026),(69252,4026),(69253,4027),(69254,4027),(69255,4027),(69256,4027),(69257,4027),(69258,4027),(69259,4028),(69260,4028),(69261,4028),(69262,4028),(69263,4028),(69264,4028),(69265,4029),(69266,4029),(69267,4029),(69268,4029),(69269,4029),(69270,4029),(69271,4030),(69272,4030),(69273,4030),(69274,4030),(69275,4030),(69276,4030),(69277,4031),(69278,4031),(69279,4031),(69280,4031),(69281,4031),(69282,4031),(69283,4032),(69284,4032),(69285,4032),(69286,4032),(69287,4032),(69288,4032),(69289,4033),(69290,4033),(69291,4033),(69292,4033),(69293,4033),(69294,4033),(69295,4034),(69296,4034),(69297,4034),(69298,4034),(69299,4034),(69300,4034),(69301,4035),(69302,4035),(69303,4035),(69304,4035),(69305,4035),(69306,4035),(69307,4036),(69308,4036),(69309,4036),(69310,4036),(69311,4036),(69312,4036),(69313,4037),(69314,4037),(69315,4037),(69316,4037),(69317,4037),(69318,4037),(69319,4038),(69320,4038),(69321,4038),(69322,4038),(69323,4038),(69324,4038),(69325,4039),(69326,4039),(69327,4039),(69328,4039),(69329,4039),(69330,4039),(69331,4040),(69332,4040),(69333,4040),(69334,4040),(69335,4040),(69336,4040),(69337,4041),(69338,4041),(69339,4041),(69340,4041),(69341,4041),(69342,4041),(69343,4042),(69344,4042),(69345,4042),(69346,4042),(69347,4042),(69348,4042),(69349,4043),(69350,4043),(69351,4043),(69352,4043),(69353,4043),(69354,4043),(69355,4044),(69356,4044),(69357,4044),(69358,4044),(69359,4044),(69360,4044),(69361,4045),(69362,4045),(69363,4045),(69364,4045),(69365,4045),(69366,4045),(69367,4046),(69368,4046),(69369,4046),(69370,4046),(69371,4046),(69372,4046),(69373,4047),(69374,4047),(69375,4047),(69376,4047),(69377,4047),(69378,4047),(69379,4048),(69380,4048),(69381,4048),(69382,4048),(69383,4048),(69384,4048),(69385,4049),(69386,4049),(69387,4049),(69388,4049),(69389,4049),(69390,4049),(69391,4050),(69392,4050),(69393,4050),(69394,4050),(69395,4050),(69396,4050),(69397,4051),(69398,4051),(69399,4051),(69400,4051),(69401,4051),(69402,4051),(69403,4052),(69404,4052),(69405,4052),(69406,4052),(69407,4052),(69408,4052),(69409,4053),(69410,4053),(69411,4053),(69412,4053),(69413,4053),(69414,4053),(69415,4054),(69416,4054),(69417,4054),(69418,4054),(69419,4054),(69420,4054),(69421,4055),(69422,4055),(69423,4055),(69424,4055),(69425,4055),(69426,4055),(69427,4056),(69428,4056),(69429,4056),(69430,4056),(69431,4056),(69432,4056),(69433,4057),(69434,4057),(69435,4057),(69436,4057),(69437,4057),(69438,4057),(69439,4058),(69440,4058),(69441,4058),(69442,4058),(69443,4058),(69444,4058),(69445,4059),(69446,4059),(69447,4059),(69448,4059),(69449,4059),(69450,4059),(69451,4060),(69452,4060),(69453,4060),(69454,4060),(69455,4060),(69456,4060),(69457,4061),(69458,4061),(69459,4061),(69460,4061),(69461,4061),(69462,4061),(69463,4062),(69464,4062),(69465,4062),(69466,4062),(69467,4062),(69468,4062),(69469,4063),(69470,4063),(69471,4063),(69472,4063),(69473,4063),(69474,4063),(69475,4064),(69476,4064),(69477,4064),(69478,4064),(69479,4064),(69480,4064),(69481,4065),(69482,4065),(69483,4065),(69484,4065),(69485,4065),(69486,4065),(69487,4066),(69488,4066),(69489,4066),(69490,4066),(69491,4066),(69492,4066),(69493,4067),(69494,4067),(69495,4067),(69496,4067),(69497,4067),(69498,4067),(69499,4068),(69500,4068),(69501,4068),(69502,4068),(69503,4068),(69504,4068),(69505,4069),(69506,4069),(69507,4069),(69508,4069),(69509,4069),(69510,4069),(69511,4070),(69512,4070),(69513,4070),(69514,4070),(69515,4070),(69516,4070),(69517,4071),(69518,4071),(69519,4071),(69520,4071),(69521,4071),(69522,4071),(69523,4072),(69524,4072),(69525,4072),(69526,4072),(69527,4072),(69528,4072),(69529,4073),(69530,4073),(69531,4073),(69532,4073),(69533,4073),(69534,4073),(69535,4074),(69536,4074),(69537,4074),(69538,4074),(69539,4074),(69540,4074),(69541,4075),(69542,4075),(69543,4075),(69544,4075),(69545,4075),(69546,4075),(69547,4076),(69548,4076),(69549,4076),(69550,4076),(69551,4076),(69552,4076),(69553,4077),(69554,4077),(69555,4077),(69556,4077),(69557,4077),(69558,4077),(69559,4078),(69560,4078),(69561,4078),(69562,4078),(69563,4078),(69564,4078),(69565,4079),(69566,4079),(69567,4079),(69568,4079),(69569,4079),(69570,4079),(69571,4080),(69572,4080),(69573,4080),(69574,4080),(69575,4080),(69576,4080),(69577,4081),(69578,4081),(69579,4081),(69580,4081),(69581,4081),(69582,4081),(69583,4082),(69584,4082),(69585,4082),(69586,4082),(69587,4082),(69588,4082),(69589,4083),(69590,4083),(69591,4083),(69592,4083),(69593,4083),(69594,4083),(69595,4084),(69596,4084),(69597,4084),(69598,4084),(69599,4084),(69600,4084),(69601,4085),(69602,4085),(69603,4085),(69604,4085),(69605,4085),(69606,4085),(69607,4086),(69608,4086),(69609,4086),(69610,4086),(69611,4086),(69612,4086),(69613,4087),(69614,4087),(69615,4087),(69616,4087),(69617,4087),(69618,4087),(69619,4088),(69620,4088),(69621,4088),(69622,4088),(69623,4088),(69624,4088),(69625,4089),(69626,4089),(69627,4089),(69628,4089),(69629,4089),(69630,4089),(69631,4090),(69632,4090),(69633,4090),(69634,4090),(69635,4090),(69636,4090),(69637,4091),(69638,4091),(69639,4091),(69640,4091),(69641,4091),(69642,4091),(69643,4092),(69644,4092),(69645,4092),(69646,4092),(69647,4092),(69648,4092),(69649,4093),(69650,4093),(69651,4093),(69652,4093),(69653,4093),(69654,4093),(69655,4094),(69656,4094),(69657,4094),(69658,4094),(69659,4094),(69660,4094),(69661,4095),(69662,4095),(69663,4095),(69664,4095),(69665,4095),(69666,4095),(69667,4096),(69668,4096),(69669,4096),(69670,4096),(69671,4096),(69672,4096),(69673,4097),(69674,4097),(69675,4097),(69676,4097),(69677,4097),(69678,4097),(69679,4098),(69680,4098),(69681,4098),(69682,4098),(69683,4098),(69684,4098),(69685,4099),(69686,4099),(69687,4099),(69688,4099),(69689,4099),(69690,4099),(69691,4100),(69692,4100),(69693,4100),(69694,4100),(69695,4100),(69696,4100),(69697,4101),(69698,4101),(69699,4101),(69700,4101),(69701,4101),(69702,4101),(69703,4102),(69704,4102),(69705,4102),(69706,4102),(69707,4102),(69708,4102),(69709,4103),(69710,4103),(69711,4103),(69712,4103),(69713,4103),(69714,4103),(69715,4104),(69716,4104),(69717,4104),(69718,4104),(69719,4104),(69720,4104),(69721,4105),(69722,4105),(69723,4105),(69724,4105),(69725,4105),(69726,4105),(69727,4106),(69728,4106),(69729,4106),(69730,4106),(69731,4106),(69732,4106),(69733,4107),(69734,4107),(69735,4107),(69736,4107),(69737,4107),(69738,4107),(69739,4108),(69740,4108),(69741,4108),(69742,4108),(69743,4108),(69744,4108),(69745,4109),(69746,4109),(69747,4109),(69748,4109),(69749,4109),(69750,4109),(69751,4110),(69752,4110),(69753,4110),(69754,4110),(69755,4110),(69756,4110),(69757,4111),(69758,4111),(69759,4111),(69760,4111),(69761,4111),(69762,4111),(69763,4112),(69764,4112),(69765,4112),(69766,4112),(69767,4112),(69768,4112),(69769,4113),(69770,4113),(69771,4113),(69772,4113),(69773,4113),(69774,4113),(69775,4114),(69776,4114),(69777,4114),(69778,4114),(69779,4114),(69780,4114),(69781,4015),(69782,4015),(69783,4016),(69784,4016),(69785,4017),(69786,4017),(69787,4018),(69788,4018),(69789,4019),(69790,4019),(69791,4020),(69792,4020),(69793,4021),(69794,4021),(69795,4022),(69796,4022),(69797,4023),(69798,4023),(69799,4024),(69800,4024),(69801,4025),(69802,4025),(69803,4026),(69804,4026),(69805,4027),(69806,4027),(69807,4028),(69808,4028),(69809,4029),(69810,4029),(69811,4030),(69812,4030),(69813,4031),(69814,4031),(69815,4032),(69816,4032),(69817,4033),(69818,4033),(69819,4034),(69820,4034),(69821,4035),(69822,4035),(69823,4036),(69824,4036),(69825,4037),(69826,4037),(69827,4038),(69828,4038),(69829,4039),(69830,4039),(69831,4040),(69832,4040),(69833,4041),(69834,4041),(69835,4042),(69836,4042),(69837,4043),(69838,4043),(69839,4044),(69840,4044),(69841,4045),(69842,4045),(69843,4046),(69844,4046),(69845,4047),(69846,4047),(69847,4048),(69848,4048),(69849,4049),(69850,4049),(69851,4050),(69852,4050),(69853,4051),(69854,4051),(69855,4052),(69856,4052),(69857,4053),(69858,4053),(69859,4054),(69860,4054),(69861,4055),(69862,4055),(69863,4056),(69864,4056),(69865,4057),(69866,4057),(69867,4058),(69868,4058),(69869,4059),(69870,4059),(69871,4060),(69872,4060),(69873,4061),(69874,4061),(69875,4062),(69876,4062),(69877,4063),(69878,4063),(69879,4064),(69880,4064),(69881,4065),(69882,4065),(69883,4066),(69884,4066),(69885,4067),(69886,4067),(69887,4068),(69888,4068),(69889,4069),(69890,4069),(69891,4070),(69892,4070),(69893,4071),(69894,4071),(69895,4072),(69896,4072),(69897,4073),(69898,4073),(69899,4074),(69900,4074),(69901,4075),(69902,4075),(69903,4076),(69904,4076),(69905,4077),(69906,4077),(69907,4078),(69908,4078),(69909,4079),(69910,4079),(69911,4080),(69912,4080),(69913,4081),(69914,4081),(69915,4082),(69916,4082),(69917,4083),(69918,4083),(69919,4084),(69920,4084),(69921,4085),(69922,4085),(69923,4086),(69924,4086),(69925,4087),(69926,4087),(69927,4088),(69928,4088),(69929,4089),(69930,4089),(69931,4090),(69932,4090),(69933,4091),(69934,4091),(69935,4091),(69936,4092),(69937,4092),(69938,4093),(69939,4093),(69940,4094),(69941,4094),(69942,4095),(69943,4095),(69944,4096),(69945,4096),(69946,4097),(69947,4097),(69948,4098),(69949,4098),(69950,4099),(69951,4099),(69952,4100),(69953,4100),(69954,4101),(69955,4101),(69956,4102),(69957,4102),(69958,4103),(69959,4103),(69960,4104),(69961,4104),(69962,4105),(69963,4105),(69964,4106),(69965,4106),(69966,4107),(69967,4107),(69968,4108),(69969,4108),(69970,4109),(69971,4109),(69972,4110),(69973,4110),(69974,4111),(69975,4111),(69976,4112),(69977,4112),(69978,4113),(69979,4113),(69980,4114),(69981,4114),(69982,4015),(69983,4015),(69984,4015),(69985,4016),(69986,4016),(69987,4016),(69988,4017),(69989,4017),(69990,4017),(69991,4018),(69992,4018),(69993,4018),(69994,4019),(69995,4019),(69996,4019),(69997,4020),(69998,4020),(69999,4020),(70000,4021),(70001,4021),(70002,4021),(70003,4022),(70004,4022),(70005,4022),(70006,4023),(70007,4023),(70008,4023),(70009,4024),(70010,4024),(70011,4024),(70012,4025),(70013,4025),(70014,4025),(70015,4026),(70016,4026),(70017,4026),(70018,4027),(70019,4027),(70020,4027),(70021,4028),(70022,4028),(70023,4028),(70024,4029),(70025,4029),(70026,4029),(70027,4030),(70028,4030),(70029,4030),(70030,4031),(70031,4031),(70032,4031),(70033,4032),(70034,4032),(70035,4032),(70036,4033),(70037,4033),(70038,4033),(70039,4034),(70040,4034),(70041,4034),(70042,4035),(70043,4035),(70044,4035),(70045,4036),(70046,4036),(70047,4036),(70048,4037),(70049,4037),(70050,4037),(70051,4038),(70052,4038),(70053,4038),(70054,4039),(70055,4039),(70056,4039),(70057,4040),(70058,4040),(70059,4040),(70060,4041),(70061,4041),(70062,4041),(70063,4042),(70064,4042),(70065,4042),(70066,4043),(70067,4043),(70068,4044),(70069,4044),(70070,4044),(70071,4045),(70072,4045),(70073,4045),(70074,4046),(70075,4046),(70076,4046),(70077,4047),(70078,4047),(70079,4047),(70080,4048),(70081,4048),(70082,4048),(70083,4049),(70084,4049),(70085,4049),(70086,4050),(70087,4050),(70088,4050),(70089,4051),(70090,4051),(70091,4051),(70092,4052),(70093,4052),(70094,4052),(70095,4053),(70096,4053),(70097,4053),(70098,4054),(70099,4054),(70100,4055),(70101,4055),(70102,4056),(70103,4056),(70104,4056),(70105,4057),(70106,4057),(70107,4057),(70108,4058),(70109,4058),(70110,4058),(70111,4059),(70112,4059),(70113,4059),(70114,4060),(70115,4060),(70116,4060),(70117,4061),(70118,4061),(70119,4061),(70120,4062),(70121,4062),(70122,4062),(70123,4063),(70124,4063),(70125,4063),(70126,4064),(70127,4064),(70128,4064),(70129,4065),(70130,4065),(70131,4065),(70132,4066),(70133,4066),(70134,4066),(70135,4067),(70136,4067),(70137,4067),(70138,4068),(70139,4068),(70140,4068),(70141,4069),(70142,4069),(70143,4069),(70144,4070),(70145,4070),(70146,4070),(70147,4071),(70148,4071),(70149,4071),(70150,4072),(70151,4072),(70152,4072),(70153,4073),(70154,4073),(70155,4073),(70156,4074),(70157,4074),(70158,4074),(70159,4075),(70160,4075),(70161,4076),(70162,4076),(70163,4077),(70164,4077),(70165,4078),(70166,4078),(70167,4079),(70168,4079),(70169,4079),(70170,4080),(70171,4080),(70172,4080),(70173,4081),(70174,4081),(70175,4081),(70176,4082),(70177,4082),(70178,4082),(70179,4083),(70180,4083),(70181,4083),(70182,4084),(70183,4084),(70184,4084),(70185,4085),(70186,4085),(70187,4085),(70188,4086),(70189,4086),(70190,4086),(70191,4087),(70192,4087),(70193,4087),(70194,4088),(70195,4088),(70196,4088),(70197,4089),(70198,4089),(70199,4089),(70200,4090),(70201,4090),(70202,4090),(70203,4091),(70204,4091),(70205,4091),(70206,4092),(70207,4092),(70208,4093),(70209,4093),(70210,4094),(70211,4094),(70212,4095),(70213,4095),(70214,4096),(70215,4096),(70216,4097),(70217,4097),(70218,4098),(70219,4098),(70220,4098),(70221,4099),(70222,4099),(70223,4099),(70224,4100),(70225,4100),(70226,4100),(70227,4101),(70228,4101),(70229,4101),(70230,4102),(70231,4102),(70232,4102),(70233,4103),(70234,4103),(70235,4103),(70236,4104),(70237,4104),(70238,4104),(70239,4105),(70240,4105),(70241,4105),(70242,4106),(70243,4106),(70244,4106),(70245,4107),(70246,4107),(70247,4107),(70248,4108),(70249,4108),(70250,4108),(70251,4109),(70252,4109),(70253,4109),(70254,4110),(70255,4110),(70256,4110),(70257,4111),(70258,4111),(70259,4111),(70260,4112),(70261,4112),(70262,4112),(70263,4113),(70264,4113),(70265,4113),(70266,4114),(70267,4114),(70268,4114),(70269,4015),(70270,4015),(70271,4015),(70272,4015),(70273,4016),(70274,4016),(70275,4016),(70276,4016),(70277,4017),(70278,4017),(70279,4017),(70280,4017),(70281,4018),(70282,4018),(70283,4018),(70284,4018),(70285,4019),(70286,4019),(70287,4019),(70288,4019),(70289,4020),(70290,4020),(70291,4020),(70292,4020),(70293,4021),(70294,4021),(70295,4021),(70296,4021),(70297,4022),(70298,4022),(70299,4022),(70300,4022),(70301,4023),(70302,4023),(70303,4023),(70304,4023),(70305,4024),(70306,4024),(70307,4024),(70308,4024),(70309,4025),(70310,4025),(70311,4025),(70312,4025),(70313,4026),(70314,4026),(70315,4026),(70316,4026),(70317,4027),(70318,4027),(70319,4027),(70320,4027),(70321,4028),(70322,4028),(70323,4028),(70324,4028),(70325,4029),(70326,4029),(70327,4029),(70328,4029),(70329,4030),(70330,4030),(70331,4030),(70332,4030),(70333,4031),(70334,4031),(70335,4031),(70336,4031),(70337,4032),(70338,4032),(70339,4032),(70340,4032),(70341,4033),(70342,4033),(70343,4033),(70344,4033),(70345,4034),(70346,4034),(70347,4034),(70348,4034),(70349,4035),(70350,4035),(70351,4035),(70352,4035),(70353,4036),(70354,4036),(70355,4036),(70356,4036),(70357,4037),(70358,4037),(70359,4037),(70360,4037),(70361,4038),(70362,4038),(70363,4038),(70364,4038),(70365,4039),(70366,4039),(70367,4039),(70368,4039),(70369,4040),(70370,4040),(70371,4040),(70372,4040),(70373,4041),(70374,4041),(70375,4041),(70376,4041),(70377,4042),(70378,4042),(70379,4042),(70380,4042),(70381,4043),(70382,4043),(70383,4043),(70384,4043),(70385,4044),(70386,4044),(70387,4044),(70388,4044),(70389,4045),(70390,4045),(70391,4045),(70392,4045),(70393,4046),(70394,4046),(70395,4046),(70396,4046),(70397,4047),(70398,4047),(70399,4047),(70400,4047),(70401,4048),(70402,4048),(70403,4048),(70404,4048),(70405,4049),(70406,4049),(70407,4049),(70408,4049),(70409,4050),(70410,4050),(70411,4050),(70412,4050),(70413,4051),(70414,4051),(70415,4051),(70416,4051),(70417,4052),(70418,4052),(70419,4052),(70420,4052),(70421,4053),(70422,4053),(70423,4053),(70424,4053),(70425,4054),(70426,4054),(70427,4054),(70428,4054),(70429,4055),(70430,4055),(70431,4055),(70432,4055),(70433,4056),(70434,4056),(70435,4056),(70436,4056),(70437,4057),(70438,4057),(70439,4057),(70440,4057),(70441,4058),(70442,4058),(70443,4058),(70444,4058),(70445,4059),(70446,4059),(70447,4059),(70448,4059),(70449,4060),(70450,4060),(70451,4060),(70452,4060),(70453,4061),(70454,4061),(70455,4061),(70456,4061),(70457,4062),(70458,4062),(70459,4062),(70460,4062),(70461,4063),(70462,4063),(70463,4063),(70464,4063),(70465,4064),(70466,4064),(70467,4064),(70468,4064),(70469,4065),(70470,4065),(70471,4065),(70472,4065),(70473,4066),(70474,4066),(70475,4066),(70476,4066),(70477,4067),(70478,4067),(70479,4067),(70480,4067),(70481,4068),(70482,4068),(70483,4068),(70484,4068),(70485,4069),(70486,4069),(70487,4069),(70488,4069),(70489,4070),(70490,4070),(70491,4070),(70492,4070),(70493,4071),(70494,4071),(70495,4071),(70496,4071),(70497,4072),(70498,4072),(70499,4072),(70500,4072),(70501,4073),(70502,4073),(70503,4073),(70504,4073),(70505,4074),(70506,4074),(70507,4074),(70508,4074),(70509,4075),(70510,4075),(70511,4075),(70512,4075),(70513,4076),(70514,4076),(70515,4076),(70516,4076),(70517,4077),(70518,4077),(70519,4077),(70520,4077),(70521,4078),(70522,4078),(70523,4078),(70524,4078),(70525,4079),(70526,4079),(70527,4079),(70528,4079),(70529,4080),(70530,4080),(70531,4080),(70532,4080),(70533,4081),(70534,4081),(70535,4081),(70536,4081),(70537,4082),(70538,4082),(70539,4082),(70540,4082),(70541,4083),(70542,4083),(70543,4083),(70544,4083),(70545,4084),(70546,4084),(70547,4084),(70548,4084),(70549,4085),(70550,4085),(70551,4085),(70552,4085),(70553,4086),(70554,4086),(70555,4086),(70556,4086),(70557,4087),(70558,4087),(70559,4087),(70560,4087),(70561,4088),(70562,4088),(70563,4088),(70564,4088),(70565,4089),(70566,4089),(70567,4089),(70568,4089),(70569,4090),(70570,4090),(70571,4090),(70572,4090),(70573,4091),(70574,4091),(70575,4091),(70576,4091),(70577,4092),(70578,4092),(70579,4092),(70580,4092),(70581,4093),(70582,4093),(70583,4093),(70584,4093),(70585,4094),(70586,4094),(70587,4094),(70588,4094),(70589,4095),(70590,4095),(70591,4095),(70592,4095),(70593,4096),(70594,4096),(70595,4096),(70596,4096),(70597,4097),(70598,4097),(70599,4097),(70600,4097),(70601,4098),(70602,4098),(70603,4098),(70604,4098),(70605,4099),(70606,4099),(70607,4099),(70608,4099),(70609,4100),(70610,4100),(70611,4100),(70612,4100),(70613,4101),(70614,4101),(70615,4101),(70616,4101),(70617,4102),(70618,4102),(70619,4102),(70620,4102),(70621,4103),(70622,4103),(70623,4103),(70624,4103),(70625,4104),(70626,4104),(70627,4104),(70628,4104),(70629,4105),(70630,4105),(70631,4105),(70632,4105),(70633,4106),(70634,4106),(70635,4106),(70636,4106),(70637,4107),(70638,4107),(70639,4107),(70640,4107),(70641,4108),(70642,4108),(70643,4108),(70644,4108),(70645,4109),(70646,4109),(70647,4109),(70648,4109),(70649,4110),(70650,4110),(70651,4110),(70652,4110),(70653,4111),(70654,4111),(70655,4111),(70656,4111),(70657,4112),(70658,4112),(70659,4112),(70660,4112),(70661,4113),(70662,4113),(70663,4113),(70664,4113),(70665,4114),(70666,4114),(70667,4114),(70668,4114),(70669,4115),(70670,4116),(70671,4117),(70672,4118),(70673,4119),(70674,4120),(70675,4121),(70676,4122),(70677,4123),(70678,4124),(70679,4125),(70680,4126),(70681,4127),(70682,4128),(70683,4129),(70684,4130),(70685,4131),(70686,4132),(70687,4133),(70688,4134),(70689,4135),(70690,4136),(70691,4137),(70692,4138),(70693,4139),(70694,4140),(70695,4141),(70696,4142),(70697,4143),(70698,4144),(70699,4145),(70700,4146),(70701,4147),(70702,4148),(70703,4149),(70704,4150),(70705,4151),(70706,4152),(70707,4153),(70708,4154),(70709,4155),(70710,4156),(70711,4157),(70712,4158),(70713,4159),(70714,4160),(70715,4161),(70716,4162),(70717,4163),(70718,4164),(70719,4165),(70720,4166),(70721,4167),(70722,4168),(70723,4169),(70724,4170),(70725,4171),(70726,4172),(70727,4173),(70728,4174),(70729,4175),(70730,4176),(70731,4177),(70732,4178),(70733,4179),(70734,4180),(70735,4181),(70736,4182),(70737,4183),(70738,4184),(70739,4185),(70740,4186),(70741,4187),(70742,4188),(70743,4189),(70744,4190),(70745,4191),(70746,4192),(70747,4193),(70748,4194),(70749,4195),(70750,4196),(70751,4197),(70752,4198),(70753,4199),(70754,4200),(70755,4201),(70756,4202),(70757,4203),(70758,4204),(70759,4205),(70760,4206),(70761,4207),(70762,4208),(70763,4209),(70764,4210),(70765,4211),(70766,4212),(70767,4213),(70768,4115),(70769,4115),(70770,4115),(70771,4115),(70772,4115),(70773,4115),(70774,4116),(70775,4116),(70776,4116),(70777,4116),(70778,4116),(70779,4116),(70780,4117),(70781,4117),(70782,4117),(70783,4117),(70784,4117),(70785,4117),(70786,4118),(70787,4118),(70788,4118),(70789,4118),(70790,4118),(70791,4118),(70792,4119),(70793,4119),(70794,4119),(70795,4119),(70796,4119),(70797,4119),(70798,4120),(70799,4120),(70800,4120),(70801,4120),(70802,4120),(70803,4120),(70804,4121),(70805,4121),(70806,4121),(70807,4121),(70808,4121),(70809,4121),(70810,4122),(70811,4122),(70812,4122),(70813,4122),(70814,4122),(70815,4122),(70816,4123),(70817,4123),(70818,4123),(70819,4123),(70820,4123),(70821,4123),(70822,4124),(70823,4124),(70824,4124),(70825,4124),(70826,4124),(70827,4124),(70828,4125),(70829,4125),(70830,4125),(70831,4125),(70832,4125),(70833,4125),(70834,4126),(70835,4126),(70836,4126),(70837,4126),(70838,4126),(70839,4126),(70840,4127),(70841,4127),(70842,4127),(70843,4127),(70844,4127),(70845,4127),(70846,4128),(70847,4128),(70848,4128),(70849,4128),(70850,4128),(70851,4128),(70852,4129),(70853,4129),(70854,4129),(70855,4129),(70856,4129),(70857,4129),(70858,4130),(70859,4130),(70860,4130),(70861,4130),(70862,4130),(70863,4130),(70864,4131),(70865,4131),(70866,4131),(70867,4131),(70868,4131),(70869,4131),(70870,4132),(70871,4132),(70872,4132),(70873,4132),(70874,4132),(70875,4132),(70876,4133),(70877,4133),(70878,4133),(70879,4133),(70880,4133),(70881,4133),(70882,4134),(70883,4134),(70884,4134),(70885,4134),(70886,4134),(70887,4134),(70888,4135),(70889,4135),(70890,4135),(70891,4135),(70892,4135),(70893,4135),(70894,4136),(70895,4136),(70896,4136),(70897,4136),(70898,4136),(70899,4136),(70900,4137),(70901,4137),(70902,4137),(70903,4137),(70904,4137),(70905,4137),(70906,4138),(70907,4138),(70908,4138),(70909,4138),(70910,4138),(70911,4138),(70912,4139),(70913,4139),(70914,4139),(70915,4139),(70916,4139),(70917,4139),(70918,4140),(70919,4140),(70920,4140),(70921,4140),(70922,4140),(70923,4140),(70924,4141),(70925,4141),(70926,4141),(70927,4141),(70928,4141),(70929,4141),(70930,4142),(70931,4142),(70932,4142),(70933,4142),(70934,4142),(70935,4142),(70936,4143),(70937,4143),(70938,4143),(70939,4143),(70940,4143),(70941,4143),(70942,4144),(70943,4144),(70944,4144),(70945,4144),(70946,4144),(70947,4144),(70948,4145),(70949,4145),(70950,4145),(70951,4145),(70952,4145),(70953,4145),(70954,4146),(70955,4146),(70956,4146),(70957,4146),(70958,4146),(70959,4146),(70960,4147),(70961,4147),(70962,4147),(70963,4147),(70964,4147),(70965,4147),(70966,4148),(70967,4148),(70968,4148),(70969,4148),(70970,4148),(70971,4148),(70972,4149),(70973,4149),(70974,4149),(70975,4149),(70976,4149),(70977,4149),(70978,4150),(70979,4150),(70980,4150),(70981,4150),(70982,4150),(70983,4150),(70984,4151),(70985,4151),(70986,4151),(70987,4151),(70988,4151),(70989,4151),(70990,4152),(70991,4152),(70992,4152),(70993,4152),(70994,4152),(70995,4152),(70996,4153),(70997,4153),(70998,4153),(70999,4153),(71000,4153),(71001,4153),(71002,4154),(71003,4154),(71004,4154),(71005,4154),(71006,4154),(71007,4154),(71008,4155),(71009,4155),(71010,4155),(71011,4155),(71012,4155),(71013,4155),(71014,4156),(71015,4156),(71016,4156),(71017,4156),(71018,4156),(71019,4156),(71020,4157),(71021,4157),(71022,4157),(71023,4157),(71024,4157),(71025,4157),(71026,4158),(71027,4158),(71028,4158),(71029,4158),(71030,4158),(71031,4158),(71032,4159),(71033,4159),(71034,4159),(71035,4159),(71036,4159),(71037,4159),(71038,4160),(71039,4160),(71040,4160),(71041,4160),(71042,4160),(71043,4160),(71044,4161),(71045,4161),(71046,4161),(71047,4161),(71048,4161),(71049,4161),(71050,4162),(71051,4162),(71052,4162),(71053,4162),(71054,4162),(71055,4162),(71056,4163),(71057,4163),(71058,4163),(71059,4163),(71060,4163),(71061,4163),(71062,4164),(71063,4164),(71064,4164),(71065,4164),(71066,4164),(71067,4164),(71068,4165),(71069,4165),(71070,4165),(71071,4165),(71072,4165),(71073,4165),(71074,4166),(71075,4166),(71076,4166),(71077,4166),(71078,4166),(71079,4166),(71080,4167),(71081,4167),(71082,4167),(71083,4167),(71084,4167),(71085,4167),(71086,4168),(71087,4168),(71088,4168),(71089,4168),(71090,4168),(71091,4168),(71092,4169),(71093,4169),(71094,4169),(71095,4169),(71096,4169),(71097,4169),(71098,4170),(71099,4170),(71100,4170),(71101,4170),(71102,4170),(71103,4170),(71104,4171),(71105,4171),(71106,4171),(71107,4171),(71108,4171),(71109,4171),(71110,4172),(71111,4172),(71112,4172),(71113,4172),(71114,4172),(71115,4172),(71116,4173),(71117,4173),(71118,4173),(71119,4173),(71120,4173),(71121,4173),(71122,4174),(71123,4174),(71124,4174),(71125,4174),(71126,4174),(71127,4174),(71128,4175),(71129,4175),(71130,4175),(71131,4175),(71132,4175),(71133,4175),(71134,4176),(71135,4176),(71136,4176),(71137,4176),(71138,4176),(71139,4176),(71140,4177),(71141,4177),(71142,4177),(71143,4177),(71144,4177),(71145,4177),(71146,4178),(71147,4178),(71148,4178),(71149,4178),(71150,4178),(71151,4178),(71152,4179),(71153,4179),(71154,4179),(71155,4179),(71156,4179),(71157,4179),(71158,4180),(71159,4180),(71160,4180),(71161,4180),(71162,4180),(71163,4180),(71164,4181),(71165,4181),(71166,4181),(71167,4181),(71168,4181),(71169,4181),(71170,4182),(71171,4182),(71172,4182),(71173,4182),(71174,4182),(71175,4182),(71176,4183),(71177,4183),(71178,4183),(71179,4183),(71180,4183),(71181,4183),(71182,4184),(71183,4184),(71184,4184),(71185,4184),(71186,4184),(71187,4184),(71188,4185),(71189,4185),(71190,4185),(71191,4185),(71192,4185),(71193,4185),(71194,4186),(71195,4186),(71196,4186),(71197,4186),(71198,4186),(71199,4186),(71200,4187),(71201,4187),(71202,4187),(71203,4187),(71204,4187),(71205,4187),(71206,4188),(71207,4188),(71208,4188),(71209,4188),(71210,4188),(71211,4188),(71212,4189),(71213,4189),(71214,4189),(71215,4189),(71216,4189),(71217,4189),(71218,4190),(71219,4190),(71220,4190),(71221,4190),(71222,4190),(71223,4190),(71224,4191),(71225,4191),(71226,4191),(71227,4191),(71228,4191),(71229,4191),(71230,4192),(71231,4192),(71232,4192),(71233,4192),(71234,4192),(71235,4192),(71236,4193),(71237,4193),(71238,4193),(71239,4193),(71240,4193),(71241,4193),(71242,4194),(71243,4194),(71244,4194),(71245,4194),(71246,4194),(71247,4194),(71248,4195),(71249,4195),(71250,4195),(71251,4195),(71252,4195),(71253,4195),(71254,4196),(71255,4196),(71256,4196),(71257,4196),(71258,4196),(71259,4196),(71260,4197),(71261,4197),(71262,4197),(71263,4197),(71264,4197),(71265,4197),(71266,4198),(71267,4198),(71268,4198),(71269,4198),(71270,4198),(71271,4198),(71272,4199),(71273,4199),(71274,4199),(71275,4199),(71276,4199),(71277,4199),(71278,4200),(71279,4200),(71280,4200),(71281,4200),(71282,4200),(71283,4200),(71284,4201),(71285,4201),(71286,4201),(71287,4201),(71288,4201),(71289,4201),(71290,4202),(71291,4202),(71292,4202),(71293,4202),(71294,4202),(71295,4202),(71296,4203),(71297,4203),(71298,4203),(71299,4203),(71300,4203),(71301,4203),(71302,4204),(71303,4204),(71304,4204),(71305,4204),(71306,4204),(71307,4204),(71308,4205),(71309,4205),(71310,4205),(71311,4205),(71312,4205),(71313,4205),(71314,4206),(71315,4206),(71316,4206),(71317,4206),(71318,4206),(71319,4206),(71320,4207),(71321,4207),(71322,4207),(71323,4207),(71324,4207),(71325,4207),(71326,4208),(71327,4208),(71328,4208),(71329,4208),(71330,4208),(71331,4208),(71332,4209),(71333,4209),(71334,4209),(71335,4209),(71336,4209),(71337,4209),(71338,4210),(71339,4210),(71340,4210),(71341,4210),(71342,4210),(71343,4210),(71344,4211),(71345,4211),(71346,4211),(71347,4211),(71348,4211),(71349,4211),(71350,4212),(71351,4212),(71352,4212),(71353,4212),(71354,4212),(71355,4212),(71356,4213),(71357,4213),(71358,4213),(71359,4213),(71360,4213),(71361,4213),(71362,4115),(71363,4115),(71364,4116),(71365,4116),(71366,4117),(71367,4117),(71368,4118),(71369,4118),(71370,4119),(71371,4119),(71372,4120),(71373,4120),(71374,4121),(71375,4121),(71376,4122),(71377,4122),(71378,4123),(71379,4123),(71380,4124),(71381,4124),(71382,4125),(71383,4125),(71384,4126),(71385,4126),(71386,4127),(71387,4127),(71388,4128),(71389,4128),(71390,4129),(71391,4129),(71392,4130),(71393,4130),(71394,4131),(71395,4131),(71396,4132),(71397,4132),(71398,4133),(71399,4133),(71400,4134),(71401,4134),(71402,4135),(71403,4135),(71404,4136),(71405,4136),(71406,4137),(71407,4137),(71408,4138),(71409,4138),(71410,4139),(71411,4139),(71412,4140),(71413,4140),(71414,4141),(71415,4141),(71416,4142),(71417,4142),(71418,4143),(71419,4143),(71420,4144),(71421,4144),(71422,4145),(71423,4145),(71424,4146),(71425,4146),(71426,4147),(71427,4147),(71428,4148),(71429,4148),(71430,4149),(71431,4149),(71432,4150),(71433,4150),(71434,4151),(71435,4151),(71436,4152),(71437,4152),(71438,4153),(71439,4153),(71440,4154),(71441,4154),(71442,4155),(71443,4155),(71444,4156),(71445,4156),(71446,4157),(71447,4157),(71448,4158),(71449,4158),(71450,4159),(71451,4159),(71452,4160),(71453,4160),(71454,4161),(71455,4161),(71456,4162),(71457,4162),(71458,4163),(71459,4163),(71460,4164),(71461,4164),(71462,4165),(71463,4165),(71464,4166),(71465,4166),(71466,4167),(71467,4167),(71468,4168),(71469,4168),(71470,4169),(71471,4169),(71472,4170),(71473,4170),(71474,4171),(71475,4171),(71476,4172),(71477,4172),(71478,4173),(71479,4173),(71480,4174),(71481,4174),(71482,4175),(71483,4175),(71484,4176),(71485,4176),(71486,4177),(71487,4177),(71488,4178),(71489,4178),(71490,4179),(71491,4179),(71492,4180),(71493,4180),(71494,4181),(71495,4181),(71496,4182),(71497,4182),(71498,4183),(71499,4183),(71500,4184),(71501,4184),(71502,4185),(71503,4185),(71504,4186),(71505,4186),(71506,4187),(71507,4187),(71508,4188),(71509,4188),(71510,4189),(71511,4189),(71512,4190),(71513,4190),(71514,4191),(71515,4191),(71516,4192),(71517,4192),(71518,4193),(71519,4193),(71520,4194),(71521,4194),(71522,4195),(71523,4195),(71524,4196),(71525,4196),(71526,4197),(71527,4197),(71528,4198),(71529,4198),(71530,4199),(71531,4199),(71532,4200),(71533,4200),(71534,4201),(71535,4201),(71536,4202),(71537,4202),(71538,4203),(71539,4203),(71540,4204),(71541,4204),(71542,4205),(71543,4205),(71544,4206),(71545,4206),(71546,4207),(71547,4207),(71548,4208),(71549,4208),(71550,4209),(71551,4209),(71552,4210),(71553,4210),(71554,4211),(71555,4211),(71556,4212),(71557,4212),(71558,4213),(71559,4213),(71560,4115),(71561,4115),(71562,4115),(71563,4116),(71564,4116),(71565,4116),(71566,4117),(71567,4117),(71568,4117),(71569,4118),(71570,4118),(71571,4118),(71572,4119),(71573,4119),(71574,4119),(71575,4120),(71576,4120),(71577,4121),(71578,4121),(71579,4121),(71580,4122),(71581,4122),(71582,4122),(71583,4123),(71584,4123),(71585,4123),(71586,4124),(71587,4124),(71588,4124),(71589,4125),(71590,4125),(71591,4125),(71592,4126),(71593,4126),(71594,4126),(71595,4127),(71596,4127),(71597,4127),(71598,4128),(71599,4128),(71600,4128),(71601,4129),(71602,4129),(71603,4129),(71604,4130),(71605,4130),(71606,4130),(71607,4131),(71608,4131),(71609,4131),(71610,4132),(71611,4132),(71612,4132),(71613,4133),(71614,4133),(71615,4133),(71616,4134),(71617,4134),(71618,4134),(71619,4135),(71620,4135),(71621,4135),(71622,4136),(71623,4136),(71624,4136),(71625,4137),(71626,4137),(71627,4137),(71628,4138),(71629,4138),(71630,4138),(71631,4139),(71632,4139),(71633,4139),(71634,4140),(71635,4140),(71636,4140),(71637,4141),(71638,4141),(71639,4141),(71640,4142),(71641,4142),(71642,4143),(71643,4143),(71644,4144),(71645,4144),(71646,4144),(71647,4145),(71648,4145),(71649,4145),(71650,4146),(71651,4146),(71652,4146),(71653,4147),(71654,4147),(71655,4147),(71656,4148),(71657,4148),(71658,4148),(71659,4149),(71660,4149),(71661,4149),(71662,4150),(71663,4150),(71664,4151),(71665,4151),(71666,4152),(71667,4152),(71668,4152),(71669,4153),(71670,4153),(71671,4153),(71672,4154),(71673,4154),(71674,4154),(71675,4155),(71676,4155),(71677,4155),(71678,4156),(71679,4156),(71680,4156),(71681,4157),(71682,4157),(71683,4157),(71684,4158),(71685,4158),(71686,4158),(71687,4159),(71688,4159),(71689,4159),(71690,4160),(71691,4160),(71692,4160),(71693,4161),(71694,4161),(71695,4161),(71696,4162),(71697,4162),(71698,4163),(71699,4163),(71700,4163),(71701,4164),(71702,4164),(71703,4164),(71704,4165),(71705,4165),(71706,4165),(71707,4166),(71708,4166),(71709,4166),(71710,4167),(71711,4167),(71712,4167),(71713,4168),(71714,4168),(71715,4168),(71716,4169),(71717,4169),(71718,4169),(71719,4170),(71720,4170),(71721,4170),(71722,4171),(71723,4171),(71724,4171),(71725,4172),(71726,4172),(71727,4172),(71728,4173),(71729,4173),(71730,4173),(71731,4174),(71732,4174),(71733,4174),(71734,4175),(71735,4175),(71736,4175),(71737,4176),(71738,4176),(71739,4176),(71740,4177),(71741,4177),(71742,4177),(71743,4178),(71744,4178),(71745,4178),(71746,4179),(71747,4179),(71748,4179),(71749,4180),(71750,4180),(71751,4180),(71752,4181),(71753,4181),(71754,4181),(71755,4182),(71756,4182),(71757,4182),(71758,4183),(71759,4183),(71760,4183),(71761,4184),(71762,4184),(71763,4184),(71764,4185),(71765,4185),(71766,4185),(71767,4186),(71768,4186),(71769,4186),(71770,4187),(71771,4187),(71772,4187),(71773,4188),(71774,4188),(71775,4188),(71776,4189),(71777,4189),(71778,4189),(71779,4190),(71780,4190),(71781,4190),(71782,4191),(71783,4191),(71784,4191),(71785,4192),(71786,4192),(71787,4192),(71788,4193),(71789,4193),(71790,4193),(71791,4194),(71792,4194),(71793,4194),(71794,4195),(71795,4195),(71796,4195),(71797,4196),(71798,4196),(71799,4196),(71800,4197),(71801,4197),(71802,4197),(71803,4198),(71804,4198),(71805,4198),(71806,4199),(71807,4199),(71808,4200),(71809,4200),(71810,4201),(71811,4201),(71812,4202),(71813,4202),(71814,4202),(71815,4203),(71816,4203),(71817,4203),(71818,4204),(71819,4204),(71820,4204),(71821,4205),(71822,4205),(71823,4205),(71824,4206),(71825,4206),(71826,4206),(71827,4207),(71828,4207),(71829,4207),(71830,4208),(71831,4208),(71832,4208),(71833,4209),(71834,4209),(71835,4209),(71836,4210),(71837,4210),(71838,4210),(71839,4211),(71840,4211),(71841,4211),(71842,4212),(71843,4212),(71844,4212),(71845,4213),(71846,4213),(71847,4213),(71848,4115),(71849,4115),(71850,4115),(71851,4115),(71852,4116),(71853,4116),(71854,4116),(71855,4116),(71856,4117),(71857,4117),(71858,4117),(71859,4117),(71860,4118),(71861,4118),(71862,4118),(71863,4118),(71864,4119),(71865,4119),(71866,4119),(71867,4119),(71868,4120),(71869,4120),(71870,4120),(71871,4120),(71872,4121),(71873,4121),(71874,4121),(71875,4121),(71876,4122),(71877,4122),(71878,4122),(71879,4122),(71880,4123),(71881,4123),(71882,4123),(71883,4123),(71884,4124),(71885,4124),(71886,4124),(71887,4124),(71888,4125),(71889,4125),(71890,4125),(71891,4125),(71892,4126),(71893,4126),(71894,4126),(71895,4126),(71896,4127),(71897,4127),(71898,4127),(71899,4127),(71900,4128),(71901,4128),(71902,4128),(71903,4128),(71904,4129),(71905,4129),(71906,4129),(71907,4129),(71908,4130),(71909,4130),(71910,4130),(71911,4130),(71912,4131),(71913,4131),(71914,4131),(71915,4131),(71916,4132),(71917,4132),(71918,4132),(71919,4132),(71920,4133),(71921,4133),(71922,4133),(71923,4133),(71924,4134),(71925,4134),(71926,4134),(71927,4134),(71928,4135),(71929,4135),(71930,4135),(71931,4135),(71932,4136),(71933,4136),(71934,4136),(71935,4136),(71936,4137),(71937,4137),(71938,4137),(71939,4137),(71940,4138),(71941,4138),(71942,4138),(71943,4138),(71944,4139),(71945,4139),(71946,4139),(71947,4139),(71948,4140),(71949,4140),(71950,4140),(71951,4140),(71952,4141),(71953,4141),(71954,4141),(71955,4141),(71956,4142),(71957,4142),(71958,4142),(71959,4142),(71960,4143),(71961,4143),(71962,4143),(71963,4143),(71964,4144),(71965,4144),(71966,4144),(71967,4144),(71968,4145),(71969,4145),(71970,4145),(71971,4145),(71972,4146),(71973,4146),(71974,4146),(71975,4146),(71976,4147),(71977,4147),(71978,4147),(71979,4147),(71980,4148),(71981,4148),(71982,4148),(71983,4148),(71984,4149),(71985,4149),(71986,4149),(71987,4149),(71988,4150),(71989,4150),(71990,4150),(71991,4150),(71992,4151),(71993,4151),(71994,4151),(71995,4151),(71996,4152),(71997,4152),(71998,4152),(71999,4152),(72000,4153),(72001,4153),(72002,4153),(72003,4153),(72004,4154),(72005,4154),(72006,4154),(72007,4154),(72008,4155),(72009,4155),(72010,4155),(72011,4155),(72012,4156),(72013,4156),(72014,4156),(72015,4156),(72016,4157),(72017,4157),(72018,4157),(72019,4157),(72020,4158),(72021,4158),(72022,4158),(72023,4158),(72024,4159),(72025,4159),(72026,4159),(72027,4159),(72028,4160),(72029,4160),(72030,4160),(72031,4160),(72032,4161),(72033,4161),(72034,4161),(72035,4161),(72036,4162),(72037,4162),(72038,4162),(72039,4162),(72040,4163),(72041,4163),(72042,4163),(72043,4163),(72044,4164),(72045,4164),(72046,4164),(72047,4164),(72048,4165),(72049,4165),(72050,4165),(72051,4165),(72052,4166),(72053,4166),(72054,4166),(72055,4166),(72056,4167),(72057,4167),(72058,4167),(72059,4167),(72060,4168),(72061,4168),(72062,4168),(72063,4168),(72064,4169),(72065,4169),(72066,4169),(72067,4169),(72068,4170),(72069,4170),(72070,4170),(72071,4170),(72072,4171),(72073,4171),(72074,4171),(72075,4171),(72076,4172),(72077,4172),(72078,4172),(72079,4172),(72080,4173),(72081,4173),(72082,4173),(72083,4173),(72084,4174),(72085,4174),(72086,4174),(72087,4174),(72088,4175),(72089,4175),(72090,4175),(72091,4175),(72092,4176),(72093,4176),(72094,4176),(72095,4176),(72096,4177),(72097,4177),(72098,4177),(72099,4177),(72100,4178),(72101,4178),(72102,4178),(72103,4178),(72104,4179),(72105,4179),(72106,4179),(72107,4179),(72108,4180),(72109,4180),(72110,4180),(72111,4180),(72112,4181),(72113,4181),(72114,4181),(72115,4181),(72116,4182),(72117,4182),(72118,4182),(72119,4182),(72120,4183),(72121,4183),(72122,4183),(72123,4183),(72124,4184),(72125,4184),(72126,4184),(72127,4184),(72128,4185),(72129,4185),(72130,4185),(72131,4185),(72132,4186),(72133,4186),(72134,4186),(72135,4186),(72136,4187),(72137,4187),(72138,4187),(72139,4187),(72140,4188),(72141,4188),(72142,4188),(72143,4188),(72144,4189),(72145,4189),(72146,4189),(72147,4189),(72148,4190),(72149,4190),(72150,4190),(72151,4190),(72152,4191),(72153,4191),(72154,4191),(72155,4191),(72156,4192),(72157,4192),(72158,4192),(72159,4192),(72160,4193),(72161,4193),(72162,4193),(72163,4193),(72164,4194),(72165,4194),(72166,4194),(72167,4194),(72168,4195),(72169,4195),(72170,4195),(72171,4195),(72172,4196),(72173,4196),(72174,4196),(72175,4196),(72176,4197),(72177,4197),(72178,4197),(72179,4197),(72180,4198),(72181,4198),(72182,4198),(72183,4198),(72184,4199),(72185,4199),(72186,4199),(72187,4199),(72188,4200),(72189,4200),(72190,4200),(72191,4200),(72192,4201),(72193,4201),(72194,4201),(72195,4201),(72196,4202),(72197,4202),(72198,4202),(72199,4202),(72200,4203),(72201,4203),(72202,4203),(72203,4203),(72204,4204),(72205,4204),(72206,4204),(72207,4204),(72208,4205),(72209,4205),(72210,4205),(72211,4205),(72212,4206),(72213,4206),(72214,4206),(72215,4206),(72216,4207),(72217,4207),(72218,4207),(72219,4207),(72220,4208),(72221,4208),(72222,4208),(72223,4208),(72224,4209),(72225,4209),(72226,4209),(72227,4209),(72228,4210),(72229,4210),(72230,4210),(72231,4210),(72232,4211),(72233,4211),(72234,4211),(72235,4211),(72236,4212),(72237,4212),(72238,4212),(72239,4212),(72240,4213),(72241,4213),(72242,4213),(72243,4213),(72244,4214),(72245,4215),(72246,4216),(72247,4217),(72248,4218),(72249,4219),(72250,4220),(72251,4221),(72252,4222),(72253,4223),(72254,4224),(72255,4225),(72256,4226),(72257,4227),(72258,4228),(72259,4229),(72260,4230),(72261,4231),(72262,4232),(72263,4233),(72264,4234),(72265,4235),(72266,4236),(72267,4237),(72268,4238),(72269,4239),(72270,4240),(72271,4241),(72272,4242),(72273,4243),(72274,4244),(72275,4245),(72276,4246),(72277,4247),(72278,4248),(72279,4249),(72280,4250),(72281,4251),(72282,4252),(72283,4253),(72284,4254),(72285,4255),(72286,4256),(72287,4257),(72288,4258),(72289,4259),(72290,4260),(72291,4261),(72292,4262),(72293,4263),(72294,4264),(72295,4265),(72296,4266),(72297,4267),(72298,4268),(72299,4269),(72300,4270),(72301,4271),(72302,4272),(72303,4273),(72304,4274),(72305,4275),(72306,4276),(72307,4277),(72308,4278),(72309,4279),(72310,4280),(72311,4281),(72312,4282),(72313,4283),(72314,4284),(72315,4285),(72316,4286),(72317,4287),(72318,4288),(72319,4289),(72320,4290),(72321,4291),(72322,4292),(72323,4293),(72324,4294),(72325,4295),(72326,4296),(72327,4297),(72328,4298),(72329,4299),(72330,4300),(72331,4301),(72332,4302),(72333,4303),(72334,4304),(72335,4305),(72336,4306),(72337,4307),(72338,4308),(72339,4309),(72340,4310),(72341,4311),(72342,4312),(72343,4313),(72344,4214),(72345,4214),(72346,4214),(72347,4214),(72348,4214),(72349,4214),(72350,4215),(72351,4215),(72352,4215),(72353,4215),(72354,4215),(72355,4215),(72356,4216),(72357,4216),(72358,4216),(72359,4216),(72360,4216),(72361,4216),(72362,4217),(72363,4217),(72364,4217),(72365,4217),(72366,4217),(72367,4217),(72368,4218),(72369,4218),(72370,4218),(72371,4218),(72372,4218),(72373,4218),(72374,4219),(72375,4219),(72376,4219),(72377,4219),(72378,4219),(72379,4219),(72380,4220),(72381,4220),(72382,4220),(72383,4220),(72384,4220),(72385,4220),(72386,4221),(72387,4221),(72388,4221),(72389,4221),(72390,4221),(72391,4221),(72392,4222),(72393,4222),(72394,4222),(72395,4222),(72396,4222),(72397,4222),(72398,4223),(72399,4223),(72400,4223),(72401,4223),(72402,4223),(72403,4223),(72404,4224),(72405,4224),(72406,4224),(72407,4224),(72408,4224),(72409,4224),(72410,4225),(72411,4225),(72412,4225),(72413,4225),(72414,4225),(72415,4225),(72416,4226),(72417,4226),(72418,4226),(72419,4226),(72420,4226),(72421,4226),(72422,4227),(72423,4227),(72424,4227),(72425,4227),(72426,4227),(72427,4227),(72428,4228),(72429,4228),(72430,4228),(72431,4228),(72432,4228),(72433,4228),(72434,4229),(72435,4229),(72436,4229),(72437,4229),(72438,4229),(72439,4229),(72440,4230),(72441,4230),(72442,4230),(72443,4230),(72444,4230),(72445,4230),(72446,4231),(72447,4231),(72448,4231),(72449,4231),(72450,4231),(72451,4231),(72452,4232),(72453,4232),(72454,4232),(72455,4232),(72456,4232),(72457,4232),(72458,4233),(72459,4233),(72460,4233),(72461,4233),(72462,4233),(72463,4233),(72464,4234),(72465,4234),(72466,4234),(72467,4234),(72468,4234),(72469,4234),(72470,4235),(72471,4235),(72472,4235),(72473,4235),(72474,4235),(72475,4235),(72476,4236),(72477,4236),(72478,4236),(72479,4236),(72480,4236),(72481,4236),(72482,4237),(72483,4237),(72484,4237),(72485,4237),(72486,4237),(72487,4237),(72488,4238),(72489,4238),(72490,4238),(72491,4238),(72492,4238),(72493,4238),(72494,4239),(72495,4239),(72496,4239),(72497,4239),(72498,4239),(72499,4239),(72500,4240),(72501,4240),(72502,4240),(72503,4240),(72504,4240),(72505,4240),(72506,4241),(72507,4241),(72508,4241),(72509,4241),(72510,4241),(72511,4241),(72512,4242),(72513,4242),(72514,4242),(72515,4242),(72516,4242),(72517,4242),(72518,4243),(72519,4243),(72520,4243),(72521,4243),(72522,4243),(72523,4243),(72524,4244),(72525,4244),(72526,4244),(72527,4244),(72528,4244),(72529,4244),(72530,4245),(72531,4245),(72532,4245),(72533,4245),(72534,4245),(72535,4245),(72536,4246),(72537,4246),(72538,4246),(72539,4246),(72540,4246),(72541,4246),(72542,4247),(72543,4247),(72544,4247),(72545,4247),(72546,4247),(72547,4247),(72548,4248),(72549,4248),(72550,4248),(72551,4248),(72552,4248),(72553,4248),(72554,4249),(72555,4249),(72556,4249),(72557,4249),(72558,4249),(72559,4249),(72560,4250),(72561,4250),(72562,4250),(72563,4250),(72564,4250),(72565,4250),(72566,4251),(72567,4251),(72568,4251),(72569,4251),(72570,4251),(72571,4251),(72572,4252),(72573,4252),(72574,4252),(72575,4252),(72576,4252),(72577,4252),(72578,4253),(72579,4253),(72580,4253),(72581,4253),(72582,4253),(72583,4253),(72584,4254),(72585,4254),(72586,4254),(72587,4254),(72588,4254),(72589,4254),(72590,4255),(72591,4255),(72592,4255),(72593,4255),(72594,4255),(72595,4255),(72596,4256),(72597,4256),(72598,4256),(72599,4256),(72600,4256),(72601,4256),(72602,4257),(72603,4257),(72604,4257),(72605,4257),(72606,4257),(72607,4257),(72608,4258),(72609,4258),(72610,4258),(72611,4258),(72612,4258),(72613,4258),(72614,4259),(72615,4259),(72616,4259),(72617,4259),(72618,4259),(72619,4259),(72620,4260),(72621,4260),(72622,4260),(72623,4260),(72624,4260),(72625,4260),(72626,4261),(72627,4261),(72628,4261),(72629,4261),(72630,4261),(72631,4261),(72632,4262),(72633,4262),(72634,4262),(72635,4262),(72636,4262),(72637,4262),(72638,4263),(72639,4263),(72640,4263),(72641,4263),(72642,4263),(72643,4263),(72644,4264),(72645,4264),(72646,4264),(72647,4264),(72648,4264),(72649,4264),(72650,4265),(72651,4265),(72652,4265),(72653,4265),(72654,4265),(72655,4265),(72656,4266),(72657,4266),(72658,4266),(72659,4266),(72660,4266),(72661,4266),(72662,4267),(72663,4267),(72664,4267),(72665,4267),(72666,4267),(72667,4267),(72668,4268),(72669,4268),(72670,4268),(72671,4268),(72672,4268),(72673,4268),(72674,4269),(72675,4269),(72676,4269),(72677,4269),(72678,4269),(72679,4269),(72680,4270),(72681,4270),(72682,4270),(72683,4270),(72684,4270),(72685,4270),(72686,4271),(72687,4271),(72688,4271),(72689,4271),(72690,4271),(72691,4271),(72692,4272),(72693,4272),(72694,4272),(72695,4272),(72696,4272),(72697,4272),(72698,4273),(72699,4273),(72700,4273),(72701,4273),(72702,4273),(72703,4273),(72704,4274),(72705,4274),(72706,4274),(72707,4274),(72708,4274),(72709,4274),(72710,4275),(72711,4275),(72712,4275),(72713,4275),(72714,4275),(72715,4275),(72716,4276),(72717,4276),(72718,4276),(72719,4276),(72720,4276),(72721,4276),(72722,4277),(72723,4277),(72724,4277),(72725,4277),(72726,4277),(72727,4277),(72728,4278),(72729,4278),(72730,4278),(72731,4278),(72732,4278),(72733,4278),(72734,4279),(72735,4279),(72736,4279),(72737,4279),(72738,4279),(72739,4279),(72740,4280),(72741,4280),(72742,4280),(72743,4280),(72744,4280),(72745,4280),(72746,4281),(72747,4281),(72748,4281),(72749,4281),(72750,4281),(72751,4281),(72752,4282),(72753,4282),(72754,4282),(72755,4282),(72756,4282),(72757,4282),(72758,4283),(72759,4283),(72760,4283),(72761,4283),(72762,4283),(72763,4283),(72764,4284),(72765,4284),(72766,4284),(72767,4284),(72768,4284),(72769,4284),(72770,4285),(72771,4285),(72772,4285),(72773,4285),(72774,4285),(72775,4285),(72776,4286),(72777,4286),(72778,4286),(72779,4286),(72780,4286),(72781,4286),(72782,4287),(72783,4287),(72784,4287),(72785,4287),(72786,4287),(72787,4287),(72788,4288),(72789,4288),(72790,4288),(72791,4288),(72792,4288),(72793,4288),(72794,4289),(72795,4289),(72796,4289),(72797,4289),(72798,4289),(72799,4289),(72800,4290),(72801,4290),(72802,4290),(72803,4290),(72804,4290),(72805,4290),(72806,4291),(72807,4291),(72808,4291),(72809,4291),(72810,4291),(72811,4291),(72812,4292),(72813,4292),(72814,4292),(72815,4292),(72816,4292),(72817,4292),(72818,4293),(72819,4293),(72820,4293),(72821,4293),(72822,4293),(72823,4293),(72824,4294),(72825,4294),(72826,4294),(72827,4294),(72828,4294),(72829,4294),(72830,4295),(72831,4295),(72832,4295),(72833,4295),(72834,4295),(72835,4295),(72836,4296),(72837,4296),(72838,4296),(72839,4296),(72840,4296),(72841,4296),(72842,4297),(72843,4297),(72844,4297),(72845,4297),(72846,4297),(72847,4297),(72848,4298),(72849,4298),(72850,4298),(72851,4298),(72852,4298),(72853,4298),(72854,4299),(72855,4299),(72856,4299),(72857,4299),(72858,4299),(72859,4299),(72860,4300),(72861,4300),(72862,4300),(72863,4300),(72864,4300),(72865,4300),(72866,4301),(72867,4301),(72868,4301),(72869,4301),(72870,4301),(72871,4301),(72872,4302),(72873,4302),(72874,4302),(72875,4302),(72876,4302),(72877,4302),(72878,4303),(72879,4303),(72880,4303),(72881,4303),(72882,4303),(72883,4303),(72884,4304),(72885,4304),(72886,4304),(72887,4304),(72888,4304),(72889,4304),(72890,4305),(72891,4305),(72892,4305),(72893,4305),(72894,4305),(72895,4305),(72896,4306),(72897,4306),(72898,4306),(72899,4306),(72900,4306),(72901,4306),(72902,4307),(72903,4307),(72904,4307),(72905,4307),(72906,4307),(72907,4307),(72908,4308),(72909,4308),(72910,4308),(72911,4308),(72912,4308),(72913,4308),(72914,4309),(72915,4309),(72916,4309),(72917,4309),(72918,4309),(72919,4309),(72920,4310),(72921,4310),(72922,4310),(72923,4310),(72924,4310),(72925,4310),(72926,4311),(72927,4311),(72928,4311),(72929,4311),(72930,4311),(72931,4311),(72932,4312),(72933,4312),(72934,4312),(72935,4312),(72936,4312),(72937,4312),(72938,4313),(72939,4313),(72940,4313),(72941,4313),(72942,4313),(72943,4313),(72944,4214),(72945,4214),(72946,4215),(72947,4215),(72948,4216),(72949,4216),(72950,4217),(72951,4217),(72952,4218),(72953,4218),(72954,4219),(72955,4219),(72956,4220),(72957,4220),(72958,4221),(72959,4221),(72960,4222),(72961,4222),(72962,4223),(72963,4223),(72964,4224),(72965,4224),(72966,4225),(72967,4225),(72968,4226),(72969,4226),(72970,4227),(72971,4227),(72972,4228),(72973,4228),(72974,4229),(72975,4229),(72976,4230),(72977,4230),(72978,4231),(72979,4231),(72980,4232),(72981,4232),(72982,4233),(72983,4233),(72984,4234),(72985,4234),(72986,4235),(72987,4235),(72988,4236),(72989,4236),(72990,4237),(72991,4237),(72992,4238),(72993,4238),(72994,4239),(72995,4239),(72996,4240),(72997,4240),(72998,4241),(72999,4241),(73000,4242),(73001,4242),(73002,4243),(73003,4243),(73004,4244),(73005,4244),(73006,4245),(73007,4245),(73008,4246),(73009,4246),(73010,4247),(73011,4247),(73012,4248),(73013,4248),(73014,4249),(73015,4249),(73016,4250),(73017,4250),(73018,4251),(73019,4251),(73020,4252),(73021,4252),(73022,4253),(73023,4253),(73024,4254),(73025,4254),(73026,4255),(73027,4255),(73028,4256),(73029,4256),(73030,4257),(73031,4257),(73032,4258),(73033,4258),(73034,4259),(73035,4259),(73036,4260),(73037,4260),(73038,4261),(73039,4261),(73040,4262),(73041,4262),(73042,4263),(73043,4263),(73044,4264),(73045,4264),(73046,4265),(73047,4265),(73048,4266),(73049,4266),(73050,4267),(73051,4267),(73052,4268),(73053,4268),(73054,4269),(73055,4269),(73056,4270),(73057,4270),(73058,4271),(73059,4271),(73060,4272),(73061,4272),(73062,4273),(73063,4273),(73064,4274),(73065,4274),(73066,4275),(73067,4275),(73068,4276),(73069,4276),(73070,4277),(73071,4277),(73072,4278),(73073,4278),(73074,4279),(73075,4279),(73076,4280),(73077,4280),(73078,4281),(73079,4281),(73080,4282),(73081,4282),(73082,4283),(73083,4283),(73084,4284),(73085,4284),(73086,4285),(73087,4285),(73088,4286),(73089,4286),(73090,4287),(73091,4287),(73092,4288),(73093,4288),(73094,4289),(73095,4289),(73096,4290),(73097,4290),(73098,4291),(73099,4291),(73100,4292),(73101,4292),(73102,4293),(73103,4293),(73104,4294),(73105,4294),(73106,4295),(73107,4295),(73108,4296),(73109,4296),(73110,4297),(73111,4297),(73112,4298),(73113,4298),(73114,4299),(73115,4299),(73116,4300),(73117,4300),(73118,4301),(73119,4301),(73120,4302),(73121,4302),(73122,4303),(73123,4303),(73124,4304),(73125,4304),(73126,4305),(73127,4305),(73128,4306),(73129,4306),(73130,4307),(73131,4307),(73132,4308),(73133,4308),(73134,4309),(73135,4309),(73136,4310),(73137,4310),(73138,4311),(73139,4311),(73140,4312),(73141,4312),(73142,4313),(73143,4313),(73144,4214),(73145,4214),(73146,4215),(73147,4215),(73148,4215),(73149,4216),(73150,4216),(73151,4216),(73152,4217),(73153,4217),(73154,4217),(73155,4218),(73156,4218),(73157,4218),(73158,4219),(73159,4219),(73160,4219),(73161,4220),(73162,4220),(73163,4220),(73164,4221),(73165,4221),(73166,4221),(73167,4222),(73168,4222),(73169,4222),(73170,4223),(73171,4223),(73172,4223),(73173,4224),(73174,4224),(73175,4224),(73176,4225),(73177,4225),(73178,4225),(73179,4226),(73180,4226),(73181,4226),(73182,4227),(73183,4227),(73184,4227),(73185,4228),(73186,4228),(73187,4228),(73188,4229),(73189,4229),(73190,4229),(73191,4230),(73192,4230),(73193,4230),(73194,4231),(73195,4231),(73196,4231),(73197,4232),(73198,4232),(73199,4232),(73200,4233),(73201,4233),(73202,4233),(73203,4234),(73204,4234),(73205,4234),(73206,4235),(73207,4235),(73208,4235),(73209,4236),(73210,4236),(73211,4236),(73212,4237),(73213,4237),(73214,4237),(73215,4238),(73216,4238),(73217,4238),(73218,4239),(73219,4239),(73220,4239),(73221,4240),(73222,4240),(73223,4240),(73224,4241),(73225,4241),(73226,4241),(73227,4242),(73228,4242),(73229,4242),(73230,4243),(73231,4243),(73232,4243),(73233,4244),(73234,4244),(73235,4244),(73236,4245),(73237,4245),(73238,4245),(73239,4246),(73240,4246),(73241,4246),(73242,4247),(73243,4247),(73244,4247),(73245,4248),(73246,4248),(73247,4248),(73248,4249),(73249,4249),(73250,4249),(73251,4250),(73252,4250),(73253,4250),(73254,4251),(73255,4251),(73256,4251),(73257,4252),(73258,4252),(73259,4252),(73260,4253),(73261,4253),(73262,4253),(73263,4254),(73264,4254),(73265,4254),(73266,4255),(73267,4255),(73268,4255),(73269,4256),(73270,4256),(73271,4256),(73272,4257),(73273,4257),(73274,4257),(73275,4258),(73276,4258),(73277,4258),(73278,4259),(73279,4259),(73280,4259),(73281,4260),(73282,4260),(73283,4260),(73284,4261),(73285,4261),(73286,4261),(73287,4262),(73288,4262),(73289,4262),(73290,4263),(73291,4263),(73292,4263),(73293,4264),(73294,4264),(73295,4264),(73296,4265),(73297,4265),(73298,4265),(73299,4266),(73300,4266),(73301,4266),(73302,4267),(73303,4267),(73304,4267),(73305,4268),(73306,4268),(73307,4268),(73308,4269),(73309,4269),(73310,4269),(73311,4270),(73312,4270),(73313,4270),(73314,4271),(73315,4271),(73316,4272),(73317,4272),(73318,4273),(73319,4273),(73320,4274),(73321,4274),(73322,4274),(73323,4275),(73324,4275),(73325,4275),(73326,4276),(73327,4276),(73328,4276),(73329,4277),(73330,4277),(73331,4277),(73332,4278),(73333,4278),(73334,4278),(73335,4279),(73336,4279),(73337,4279),(73338,4280),(73339,4280),(73340,4280),(73341,4281),(73342,4281),(73343,4281),(73344,4282),(73345,4282),(73346,4282),(73347,4283),(73348,4283),(73349,4283),(73350,4284),(73351,4284),(73352,4284),(73353,4285),(73354,4285),(73355,4285),(73356,4286),(73357,4286),(73358,4286),(73359,4287),(73360,4287),(73361,4287),(73362,4288),(73363,4288),(73364,4288),(73365,4289),(73366,4289),(73367,4289),(73368,4290),(73369,4290),(73370,4290),(73371,4291),(73372,4291),(73373,4291),(73374,4292),(73375,4292),(73376,4292),(73377,4293),(73378,4293),(73379,4293),(73380,4294),(73381,4294),(73382,4294),(73383,4295),(73384,4295),(73385,4295),(73386,4296),(73387,4296),(73388,4296),(73389,4297),(73390,4297),(73391,4297),(73392,4298),(73393,4298),(73394,4298),(73395,4299),(73396,4299),(73397,4299),(73398,4300),(73399,4300),(73400,4300),(73401,4301),(73402,4301),(73403,4301),(73404,4302),(73405,4302),(73406,4302),(73407,4303),(73408,4303),(73409,4303),(73410,4304),(73411,4304),(73412,4304),(73413,4305),(73414,4305),(73415,4305),(73416,4306),(73417,4306),(73418,4307),(73419,4307),(73420,4307),(73421,4308),(73422,4308),(73423,4308),(73424,4309),(73425,4309),(73426,4309),(73427,4310),(73428,4310),(73429,4310),(73430,4311),(73431,4311),(73432,4311),(73433,4312),(73434,4312),(73435,4312),(73436,4313),(73437,4313),(73438,4214),(73439,4214),(73440,4214),(73441,4214),(73442,4215),(73443,4215),(73444,4215),(73445,4215),(73446,4216),(73447,4216),(73448,4216),(73449,4216),(73450,4217),(73451,4217),(73452,4217),(73453,4217),(73454,4218),(73455,4218),(73456,4218),(73457,4218),(73458,4219),(73459,4219),(73460,4219),(73461,4219),(73462,4220),(73463,4220),(73464,4220),(73465,4220),(73466,4221),(73467,4221),(73468,4221),(73469,4221),(73470,4222),(73471,4222),(73472,4222),(73473,4222),(73474,4223),(73475,4223),(73476,4223),(73477,4223),(73478,4224),(73479,4224),(73480,4224),(73481,4224),(73482,4225),(73483,4225),(73484,4225),(73485,4225),(73486,4226),(73487,4226),(73488,4226),(73489,4226),(73490,4227),(73491,4227),(73492,4227),(73493,4227),(73494,4228),(73495,4228),(73496,4228),(73497,4228),(73498,4229),(73499,4229),(73500,4229),(73501,4229),(73502,4230),(73503,4230),(73504,4230),(73505,4230),(73506,4231),(73507,4231),(73508,4231),(73509,4231),(73510,4232),(73511,4232),(73512,4232),(73513,4232),(73514,4233),(73515,4233),(73516,4233),(73517,4233),(73518,4234),(73519,4234),(73520,4234),(73521,4234),(73522,4235),(73523,4235),(73524,4235),(73525,4235),(73526,4236),(73527,4236),(73528,4236),(73529,4236),(73530,4237),(73531,4237),(73532,4237),(73533,4237),(73534,4238),(73535,4238),(73536,4238),(73537,4238),(73538,4239),(73539,4239),(73540,4239),(73541,4239),(73542,4240),(73543,4240),(73544,4240),(73545,4240),(73546,4241),(73547,4241),(73548,4241),(73549,4241),(73550,4242),(73551,4242),(73552,4242),(73553,4242),(73554,4243),(73555,4243),(73556,4243),(73557,4243),(73558,4244),(73559,4244),(73560,4244),(73561,4244),(73562,4245),(73563,4245),(73564,4245),(73565,4245),(73566,4246),(73567,4246),(73568,4246),(73569,4246),(73570,4247),(73571,4247),(73572,4247),(73573,4247),(73574,4248),(73575,4248),(73576,4248),(73577,4248),(73578,4249),(73579,4249),(73580,4249),(73581,4249),(73582,4250),(73583,4250),(73584,4250),(73585,4250),(73586,4251),(73587,4251),(73588,4251),(73589,4251),(73590,4252),(73591,4252),(73592,4252),(73593,4252),(73594,4253),(73595,4253),(73596,4253),(73597,4253),(73598,4254),(73599,4254),(73600,4254),(73601,4254),(73602,4255),(73603,4255),(73604,4255),(73605,4255),(73606,4256),(73607,4256),(73608,4256),(73609,4256),(73610,4257),(73611,4257),(73612,4257),(73613,4257),(73614,4258),(73615,4258),(73616,4258),(73617,4258),(73618,4259),(73619,4259),(73620,4259),(73621,4259),(73622,4260),(73623,4260),(73624,4260),(73625,4260),(73626,4261),(73627,4261),(73628,4261),(73629,4261),(73630,4262),(73631,4262),(73632,4262),(73633,4262),(73634,4263),(73635,4263),(73636,4263),(73637,4263),(73638,4264),(73639,4264),(73640,4264),(73641,4264),(73642,4265),(73643,4265),(73644,4265),(73645,4265),(73646,4266),(73647,4266),(73648,4266),(73649,4266),(73650,4267),(73651,4267),(73652,4267),(73653,4267),(73654,4268),(73655,4268),(73656,4268),(73657,4268),(73658,4269),(73659,4269),(73660,4269),(73661,4269),(73662,4270),(73663,4270),(73664,4270),(73665,4270),(73666,4271),(73667,4271),(73668,4271),(73669,4271),(73670,4272),(73671,4272),(73672,4272),(73673,4272),(73674,4273),(73675,4273),(73676,4273),(73677,4273),(73678,4274),(73679,4274),(73680,4274),(73681,4274),(73682,4275),(73683,4275),(73684,4275),(73685,4275),(73686,4276),(73687,4276),(73688,4276),(73689,4276),(73690,4277),(73691,4277),(73692,4277),(73693,4277),(73694,4278),(73695,4278),(73696,4278),(73697,4278),(73698,4279),(73699,4279),(73700,4279),(73701,4279),(73702,4280),(73703,4280),(73704,4280),(73705,4280),(73706,4281),(73707,4281),(73708,4281),(73709,4281),(73710,4282),(73711,4282),(73712,4282),(73713,4282),(73714,4283),(73715,4283),(73716,4283),(73717,4283),(73718,4284),(73719,4284),(73720,4284),(73721,4284),(73722,4285),(73723,4285),(73724,4285),(73725,4285),(73726,4286),(73727,4286),(73728,4286),(73729,4286),(73730,4287),(73731,4287),(73732,4287),(73733,4287),(73734,4288),(73735,4288),(73736,4288),(73737,4288),(73738,4289),(73739,4289),(73740,4289),(73741,4289),(73742,4290),(73743,4290),(73744,4290),(73745,4290),(73746,4291),(73747,4291),(73748,4291),(73749,4291),(73750,4292),(73751,4292),(73752,4292),(73753,4292),(73754,4293),(73755,4293),(73756,4293),(73757,4293),(73758,4294),(73759,4294),(73760,4294),(73761,4294),(73762,4295),(73763,4295),(73764,4295),(73765,4295),(73766,4296),(73767,4296),(73768,4296),(73769,4296),(73770,4297),(73771,4297),(73772,4297),(73773,4297),(73774,4298),(73775,4298),(73776,4298),(73777,4298),(73778,4299),(73779,4299),(73780,4299),(73781,4299),(73782,4300),(73783,4300),(73784,4300),(73785,4300),(73786,4301),(73787,4301),(73788,4301),(73789,4301),(73790,4302),(73791,4302),(73792,4302),(73793,4302),(73794,4303),(73795,4303),(73796,4303),(73797,4303),(73798,4304),(73799,4304),(73800,4304),(73801,4304),(73802,4305),(73803,4305),(73804,4305),(73805,4305),(73806,4306),(73807,4306),(73808,4306),(73809,4306),(73810,4307),(73811,4307),(73812,4307),(73813,4307),(73814,4308),(73815,4308),(73816,4308),(73817,4308),(73818,4309),(73819,4309),(73820,4309),(73821,4309),(73822,4310),(73823,4310),(73824,4310),(73825,4310),(73826,4311),(73827,4311),(73828,4311),(73829,4311),(73830,4312),(73831,4312),(73832,4312),(73833,4312),(73834,4313),(73835,4313),(73836,4313),(73837,4313),(73838,4314),(73839,4315),(73840,4316),(73841,4317),(73842,4318),(73843,4319),(73844,4320),(73845,4321),(73846,4322),(73847,4323),(73848,4324),(73849,4325),(73850,4326),(73851,4327),(73852,4328),(73853,4329),(73854,4330),(73855,4331),(73856,4332),(73857,4333),(73858,4334),(73859,4335),(73860,4336),(73861,4337),(73862,4338),(73863,4339),(73864,4340),(73865,4341),(73866,4342),(73867,4343),(73868,4344),(73869,4345),(73870,4346),(73871,4347),(73872,4348),(73873,4349),(73874,4350),(73875,4351),(73876,4352),(73877,4353),(73878,4354),(73879,4355),(73880,4356),(73881,4357),(73882,4358),(73883,4359),(73884,4360),(73885,4361),(73886,4362),(73887,4363),(73888,4364),(73889,4365),(73890,4366),(73891,4367),(73892,4368),(73893,4369),(73894,4370),(73895,4371),(73896,4372),(73897,4373),(73898,4374),(73899,4375),(73900,4376),(73901,4377),(73902,4378),(73903,4379),(73904,4380),(73905,4381),(73906,4382),(73907,4383),(73908,4384),(73909,4385),(73910,4386),(73911,4387),(73912,4388),(73913,4389),(73914,4390),(73915,4391),(73916,4392),(73917,4393),(73918,4394),(73919,4395),(73920,4396),(73921,4397),(73922,4398),(73923,4399),(73924,4400),(73925,4401),(73926,4402),(73927,4403),(73928,4404),(73929,4405),(73930,4406),(73931,4407),(73932,4408),(73933,4409),(73934,4410),(73935,4411),(73936,4412),(73937,4413),(73938,4314),(73939,4314),(73940,4314),(73941,4314),(73942,4314),(73943,4314),(73944,4315),(73945,4315),(73946,4315),(73947,4315),(73948,4315),(73949,4315),(73950,4316),(73951,4316),(73952,4316),(73953,4316),(73954,4316),(73955,4316),(73956,4317),(73957,4317),(73958,4317),(73959,4317),(73960,4317),(73961,4317),(73962,4318),(73963,4318),(73964,4318),(73965,4318),(73966,4318),(73967,4318),(73968,4319),(73969,4319),(73970,4319),(73971,4319),(73972,4319),(73973,4319),(73974,4320),(73975,4320),(73976,4320),(73977,4320),(73978,4320),(73979,4320),(73980,4321),(73981,4321),(73982,4321),(73983,4321),(73984,4321),(73985,4321),(73986,4322),(73987,4322),(73988,4322),(73989,4322),(73990,4322),(73991,4322),(73992,4323),(73993,4323),(73994,4323),(73995,4323),(73996,4323),(73997,4323),(73998,4324),(73999,4324),(74000,4324),(74001,4324),(74002,4324),(74003,4324),(74004,4325),(74005,4325),(74006,4325),(74007,4325),(74008,4325),(74009,4325),(74010,4326),(74011,4326),(74012,4326),(74013,4326),(74014,4326),(74015,4326),(74016,4327),(74017,4327),(74018,4327),(74019,4327),(74020,4327),(74021,4327),(74022,4328),(74023,4328),(74024,4328),(74025,4328),(74026,4328),(74027,4328),(74028,4329),(74029,4329),(74030,4329),(74031,4329),(74032,4329),(74033,4329),(74034,4330),(74035,4330),(74036,4330),(74037,4330),(74038,4330),(74039,4330),(74040,4331),(74041,4331),(74042,4331),(74043,4331),(74044,4331),(74045,4331),(74046,4332),(74047,4332),(74048,4332),(74049,4332),(74050,4332),(74051,4332),(74052,4333),(74053,4333),(74054,4333),(74055,4333),(74056,4333),(74057,4333),(74058,4334),(74059,4334),(74060,4334),(74061,4334),(74062,4334),(74063,4334),(74064,4335),(74065,4335),(74066,4335),(74067,4335),(74068,4335),(74069,4335),(74070,4336),(74071,4336),(74072,4336),(74073,4336),(74074,4336),(74075,4336),(74076,4337),(74077,4337),(74078,4337),(74079,4337),(74080,4337),(74081,4337),(74082,4338),(74083,4338),(74084,4338),(74085,4338),(74086,4338),(74087,4338),(74088,4339),(74089,4339),(74090,4339),(74091,4339),(74092,4339),(74093,4339),(74094,4340),(74095,4340),(74096,4340),(74097,4340),(74098,4340),(74099,4340),(74100,4341),(74101,4341),(74102,4341),(74103,4341),(74104,4341),(74105,4341),(74106,4342),(74107,4342),(74108,4342),(74109,4342),(74110,4342),(74111,4342),(74112,4343),(74113,4343),(74114,4343),(74115,4343),(74116,4343),(74117,4343),(74118,4344),(74119,4344),(74120,4344),(74121,4344),(74122,4344),(74123,4344),(74124,4345),(74125,4345),(74126,4345),(74127,4345),(74128,4345),(74129,4345),(74130,4346),(74131,4346),(74132,4346),(74133,4346),(74134,4346),(74135,4346),(74136,4347),(74137,4347),(74138,4347),(74139,4347),(74140,4347),(74141,4347),(74142,4348),(74143,4348),(74144,4348),(74145,4348),(74146,4348),(74147,4348),(74148,4349),(74149,4349),(74150,4349),(74151,4349),(74152,4349),(74153,4349),(74154,4350),(74155,4350),(74156,4350),(74157,4350),(74158,4350),(74159,4350),(74160,4351),(74161,4351),(74162,4351),(74163,4351),(74164,4351),(74165,4351),(74166,4352),(74167,4352),(74168,4352),(74169,4352),(74170,4352),(74171,4352),(74172,4353),(74173,4353),(74174,4353),(74175,4353),(74176,4353),(74177,4353),(74178,4354),(74179,4354),(74180,4354),(74181,4354),(74182,4354),(74183,4354),(74184,4355),(74185,4355),(74186,4355),(74187,4355),(74188,4355),(74189,4355),(74190,4356),(74191,4356),(74192,4356),(74193,4356),(74194,4356),(74195,4356),(74196,4357),(74197,4357),(74198,4357),(74199,4357),(74200,4357),(74201,4357),(74202,4358),(74203,4358),(74204,4358),(74205,4358),(74206,4358),(74207,4358),(74208,4359),(74209,4359),(74210,4359),(74211,4359),(74212,4359),(74213,4359),(74214,4360),(74215,4360),(74216,4360),(74217,4360),(74218,4360),(74219,4360),(74220,4361),(74221,4361),(74222,4361),(74223,4361),(74224,4361),(74225,4361),(74226,4362),(74227,4362),(74228,4362),(74229,4362),(74230,4362),(74231,4362),(74232,4363),(74233,4363),(74234,4363),(74235,4363),(74236,4363),(74237,4363),(74238,4364),(74239,4364),(74240,4364),(74241,4364),(74242,4364),(74243,4364),(74244,4365),(74245,4365),(74246,4365),(74247,4365),(74248,4365),(74249,4365),(74250,4366),(74251,4366),(74252,4366),(74253,4366),(74254,4366),(74255,4366),(74256,4367),(74257,4367),(74258,4367),(74259,4367),(74260,4367),(74261,4367),(74262,4368),(74263,4368),(74264,4368),(74265,4368),(74266,4368),(74267,4368),(74268,4369),(74269,4369),(74270,4369),(74271,4369),(74272,4369),(74273,4369),(74274,4370),(74275,4370),(74276,4370),(74277,4370),(74278,4370),(74279,4370),(74280,4371),(74281,4371),(74282,4371),(74283,4371),(74284,4371),(74285,4371),(74286,4372),(74287,4372),(74288,4372),(74289,4372),(74290,4372),(74291,4372),(74292,4373),(74293,4373),(74294,4373),(74295,4373),(74296,4373),(74297,4373),(74298,4374),(74299,4374),(74300,4374),(74301,4374),(74302,4374),(74303,4374),(74304,4375),(74305,4375),(74306,4375),(74307,4375),(74308,4375),(74309,4375),(74310,4376),(74311,4376),(74312,4376),(74313,4376),(74314,4376),(74315,4376),(74316,4377),(74317,4377),(74318,4377),(74319,4377),(74320,4377),(74321,4377),(74322,4378),(74323,4378),(74324,4378),(74325,4378),(74326,4378),(74327,4378),(74328,4379),(74329,4379),(74330,4379),(74331,4379),(74332,4379),(74333,4379),(74334,4380),(74335,4380),(74336,4380),(74337,4380),(74338,4380),(74339,4380),(74340,4381),(74341,4381),(74342,4381),(74343,4381),(74344,4381),(74345,4381),(74346,4382),(74347,4382),(74348,4382),(74349,4382),(74350,4382),(74351,4382),(74352,4383),(74353,4383),(74354,4383),(74355,4383),(74356,4383),(74357,4383),(74358,4384),(74359,4384),(74360,4384),(74361,4384),(74362,4384),(74363,4384),(74364,4385),(74365,4385),(74366,4385),(74367,4385),(74368,4385),(74369,4385),(74370,4386),(74371,4386),(74372,4386),(74373,4386),(74374,4386),(74375,4386),(74376,4387),(74377,4387),(74378,4387),(74379,4387),(74380,4387),(74381,4387),(74382,4388),(74383,4388),(74384,4388),(74385,4388),(74386,4388),(74387,4388),(74388,4389),(74389,4389),(74390,4389),(74391,4389),(74392,4389),(74393,4389),(74394,4390),(74395,4390),(74396,4390),(74397,4390),(74398,4390),(74399,4390),(74400,4391),(74401,4391),(74402,4391),(74403,4391),(74404,4391),(74405,4391),(74406,4392),(74407,4392),(74408,4392),(74409,4392),(74410,4392),(74411,4392),(74412,4393),(74413,4393),(74414,4393),(74415,4393),(74416,4393),(74417,4393),(74418,4394),(74419,4394),(74420,4394),(74421,4394),(74422,4394),(74423,4394),(74424,4395),(74425,4395),(74426,4395),(74427,4395),(74428,4395),(74429,4395),(74430,4396),(74431,4396),(74432,4396),(74433,4396),(74434,4396),(74435,4396),(74436,4397),(74437,4397),(74438,4397),(74439,4397),(74440,4397),(74441,4397),(74442,4398),(74443,4398),(74444,4398),(74445,4398),(74446,4398),(74447,4398),(74448,4399),(74449,4399),(74450,4399),(74451,4399),(74452,4399),(74453,4399),(74454,4400),(74455,4400),(74456,4400),(74457,4400),(74458,4400),(74459,4400),(74460,4401),(74461,4401),(74462,4401),(74463,4401),(74464,4401),(74465,4401),(74466,4402),(74467,4402),(74468,4402),(74469,4402),(74470,4402),(74471,4402),(74472,4403),(74473,4403),(74474,4403),(74475,4403),(74476,4403),(74477,4403),(74478,4404),(74479,4404),(74480,4404),(74481,4404),(74482,4404),(74483,4404),(74484,4405),(74485,4405),(74486,4405),(74487,4405),(74488,4405),(74489,4405),(74490,4406),(74491,4406),(74492,4406),(74493,4406),(74494,4406),(74495,4406),(74496,4407),(74497,4407),(74498,4407),(74499,4407),(74500,4407),(74501,4407),(74502,4408),(74503,4408),(74504,4408),(74505,4408),(74506,4408),(74507,4408),(74508,4409),(74509,4409),(74510,4409),(74511,4409),(74512,4409),(74513,4409),(74514,4410),(74515,4410),(74516,4410),(74517,4410),(74518,4410),(74519,4410),(74520,4411),(74521,4411),(74522,4411),(74523,4411),(74524,4411),(74525,4411),(74526,4412),(74527,4412),(74528,4412),(74529,4412),(74530,4412),(74531,4412),(74532,4413),(74533,4413),(74534,4413),(74535,4413),(74536,4413),(74537,4413),(74538,4314),(74539,4314),(74540,4315),(74541,4315),(74542,4316),(74543,4316),(74544,4317),(74545,4317),(74546,4318),(74547,4318),(74548,4319),(74549,4319),(74550,4320),(74551,4320),(74552,4321),(74553,4321),(74554,4322),(74555,4322),(74556,4323),(74557,4323),(74558,4324),(74559,4324),(74560,4325),(74561,4325),(74562,4326),(74563,4326),(74564,4327),(74565,4327),(74566,4328),(74567,4328),(74568,4329),(74569,4329),(74570,4330),(74571,4330),(74572,4331),(74573,4331),(74574,4332),(74575,4332),(74576,4333),(74577,4333),(74578,4334),(74579,4334),(74580,4335),(74581,4335),(74582,4336),(74583,4336),(74584,4337),(74585,4337),(74586,4338),(74587,4338),(74588,4339),(74589,4339),(74590,4340),(74591,4340),(74592,4341),(74593,4341),(74594,4342),(74595,4342),(74596,4343),(74597,4343),(74598,4344),(74599,4344),(74600,4345),(74601,4345),(74602,4346),(74603,4346),(74604,4347),(74605,4347),(74606,4348),(74607,4348),(74608,4349),(74609,4349),(74610,4350),(74611,4350),(74612,4351),(74613,4351),(74614,4352),(74615,4352),(74616,4353),(74617,4353),(74618,4354),(74619,4354),(74620,4355),(74621,4355),(74622,4356),(74623,4356),(74624,4357),(74625,4357),(74626,4357),(74627,4358),(74628,4358),(74629,4359),(74630,4359),(74631,4360),(74632,4360),(74633,4361),(74634,4361),(74635,4362),(74636,4362),(74637,4363),(74638,4363),(74639,4364),(74640,4364),(74641,4365),(74642,4365),(74643,4366),(74644,4366),(74645,4367),(74646,4367),(74647,4368),(74648,4368),(74649,4369),(74650,4369),(74651,4370),(74652,4370),(74653,4371),(74654,4371),(74655,4372),(74656,4372),(74657,4373),(74658,4373),(74659,4374),(74660,4374),(74661,4375),(74662,4375),(74663,4376),(74664,4376),(74665,4377),(74666,4377),(74667,4378),(74668,4378),(74669,4379),(74670,4379),(74671,4380),(74672,4380),(74673,4381),(74674,4381),(74675,4382),(74676,4382),(74677,4383),(74678,4383),(74679,4384),(74680,4384),(74681,4385),(74682,4385),(74683,4386),(74684,4386),(74685,4387),(74686,4387),(74687,4388),(74688,4388),(74689,4389),(74690,4389),(74691,4390),(74692,4390),(74693,4391),(74694,4391),(74695,4392),(74696,4392),(74697,4393),(74698,4393),(74699,4394),(74700,4394),(74701,4395),(74702,4395),(74703,4396),(74704,4396),(74705,4397),(74706,4397),(74707,4398),(74708,4398),(74709,4399),(74710,4399),(74711,4400),(74712,4400),(74713,4401),(74714,4401),(74715,4402),(74716,4402),(74717,4402),(74718,4403),(74719,4403),(74720,4404),(74721,4404),(74722,4405),(74723,4405),(74724,4406),(74725,4406),(74726,4407),(74727,4407),(74728,4408),(74729,4408),(74730,4409),(74731,4409),(74732,4410),(74733,4410),(74734,4411),(74735,4411),(74736,4412),(74737,4412),(74738,4413),(74739,4413),(74740,4314),(74741,4314),(74742,4315),(74743,4315),(74744,4315),(74745,4316),(74746,4316),(74747,4316),(74748,4317),(74749,4317),(74750,4317),(74751,4318),(74752,4318),(74753,4318),(74754,4319),(74755,4319),(74756,4319),(74757,4320),(74758,4320),(74759,4320),(74760,4321),(74761,4321),(74762,4321),(74763,4322),(74764,4322),(74765,4322),(74766,4323),(74767,4323),(74768,4323),(74769,4324),(74770,4324),(74771,4324),(74772,4325),(74773,4325),(74774,4325),(74775,4326),(74776,4326),(74777,4326),(74778,4327),(74779,4327),(74780,4327),(74781,4328),(74782,4328),(74783,4328),(74784,4329),(74785,4329),(74786,4329),(74787,4330),(74788,4330),(74789,4330),(74790,4331),(74791,4331),(74792,4331),(74793,4332),(74794,4332),(74795,4332),(74796,4333),(74797,4333),(74798,4333),(74799,4334),(74800,4334),(74801,4334),(74802,4335),(74803,4335),(74804,4335),(74805,4336),(74806,4336),(74807,4336),(74808,4337),(74809,4337),(74810,4337),(74811,4338),(74812,4338),(74813,4338),(74814,4339),(74815,4339),(74816,4339),(74817,4340),(74818,4340),(74819,4340),(74820,4341),(74821,4341),(74822,4342),(74823,4342),(74824,4342),(74825,4343),(74826,4343),(74827,4343),(74828,4344),(74829,4344),(74830,4344),(74831,4345),(74832,4345),(74833,4345),(74834,4346),(74835,4346),(74836,4346),(74837,4347),(74838,4347),(74839,4347),(74840,4348),(74841,4348),(74842,4348),(74843,4349),(74844,4349),(74845,4349),(74846,4350),(74847,4350),(74848,4350),(74849,4351),(74850,4351),(74851,4351),(74852,4352),(74853,4352),(74854,4352),(74855,4353),(74856,4353),(74857,4353),(74858,4354),(74859,4354),(74860,4354),(74861,4355),(74862,4355),(74863,4355),(74864,4356),(74865,4356),(74866,4356),(74867,4357),(74868,4357),(74869,4357),(74870,4358),(74871,4358),(74872,4359),(74873,4359),(74874,4359),(74875,4360),(74876,4360),(74877,4360),(74878,4361),(74879,4361),(74880,4361),(74881,4362),(74882,4362),(74883,4362),(74884,4363),(74885,4363),(74886,4363),(74887,4364),(74888,4364),(74889,4364),(74890,4365),(74891,4365),(74892,4365),(74893,4366),(74894,4366),(74895,4366),(74896,4367),(74897,4367),(74898,4367),(74899,4368),(74900,4368),(74901,4368),(74902,4369),(74903,4369),(74904,4369),(74905,4370),(74906,4370),(74907,4370),(74908,4371),(74909,4371),(74910,4371),(74911,4372),(74912,4372),(74913,4372),(74914,4373),(74915,4373),(74916,4373),(74917,4374),(74918,4374),(74919,4374),(74920,4375),(74921,4375),(74922,4375),(74923,4376),(74924,4376),(74925,4376),(74926,4377),(74927,4377),(74928,4377),(74929,4378),(74930,4378),(74931,4378),(74932,4379),(74933,4379),(74934,4379),(74935,4380),(74936,4380),(74937,4380),(74938,4381),(74939,4381),(74940,4381),(74941,4382),(74942,4382),(74943,4382),(74944,4383),(74945,4383),(74946,4383),(74947,4384),(74948,4384),(74949,4384),(74950,4385),(74951,4385),(74952,4385),(74953,4386),(74954,4386),(74955,4386),(74956,4387),(74957,4387),(74958,4387),(74959,4388),(74960,4388),(74961,4388),(74962,4389),(74963,4389),(74964,4389),(74965,4390),(74966,4390),(74967,4390),(74968,4391),(74969,4391),(74970,4391),(74971,4392),(74972,4392),(74973,4392),(74974,4393),(74975,4393),(74976,4393),(74977,4394),(74978,4394),(74979,4394),(74980,4395),(74981,4395),(74982,4395),(74983,4396),(74984,4396),(74985,4396),(74986,4397),(74987,4397),(74988,4397),(74989,4398),(74990,4398),(74991,4398),(74992,4399),(74993,4399),(74994,4399),(74995,4400),(74996,4400),(74997,4400),(74998,4401),(74999,4401),(75000,4401),(75001,4402),(75002,4402),(75003,4402),(75004,4403),(75005,4403),(75006,4403),(75007,4404),(75008,4404),(75009,4404),(75010,4405),(75011,4405),(75012,4405),(75013,4406),(75014,4406),(75015,4406),(75016,4407),(75017,4407),(75018,4407),(75019,4408),(75020,4408),(75021,4408),(75022,4409),(75023,4409),(75024,4409),(75025,4410),(75026,4410),(75027,4410),(75028,4411),(75029,4411),(75030,4411),(75031,4412),(75032,4412),(75033,4412),(75034,4413),(75035,4413),(75036,4413),(75037,4314),(75038,4314),(75039,4314),(75040,4314),(75041,4315),(75042,4315),(75043,4315),(75044,4315),(75045,4316),(75046,4316),(75047,4316),(75048,4316),(75049,4317),(75050,4317),(75051,4317),(75052,4317),(75053,4318),(75054,4318),(75055,4318),(75056,4318),(75057,4319),(75058,4319),(75059,4319),(75060,4319),(75061,4320),(75062,4320),(75063,4320),(75064,4320),(75065,4321),(75066,4321),(75067,4321),(75068,4321),(75069,4322),(75070,4322),(75071,4322),(75072,4322),(75073,4323),(75074,4323),(75075,4323),(75076,4323),(75077,4324),(75078,4324),(75079,4324),(75080,4324),(75081,4325),(75082,4325),(75083,4325),(75084,4325),(75085,4326),(75086,4326),(75087,4326),(75088,4326),(75089,4327),(75090,4327),(75091,4327),(75092,4327),(75093,4328),(75094,4328),(75095,4328),(75096,4328),(75097,4329),(75098,4329),(75099,4329),(75100,4329),(75101,4330),(75102,4330),(75103,4330),(75104,4330),(75105,4331),(75106,4331),(75107,4331),(75108,4331),(75109,4332),(75110,4332),(75111,4332),(75112,4332),(75113,4333),(75114,4333),(75115,4333),(75116,4333),(75117,4334),(75118,4334),(75119,4334),(75120,4334),(75121,4335),(75122,4335),(75123,4335),(75124,4335),(75125,4336),(75126,4336),(75127,4336),(75128,4336),(75129,4337),(75130,4337),(75131,4337),(75132,4337),(75133,4338),(75134,4338),(75135,4338),(75136,4338),(75137,4339),(75138,4339),(75139,4339),(75140,4339),(75141,4340),(75142,4340),(75143,4340),(75144,4340),(75145,4341),(75146,4341),(75147,4341),(75148,4341),(75149,4342),(75150,4342),(75151,4342),(75152,4342),(75153,4343),(75154,4343),(75155,4343),(75156,4343),(75157,4344),(75158,4344),(75159,4344),(75160,4344),(75161,4345),(75162,4345),(75163,4345),(75164,4345),(75165,4346),(75166,4346),(75167,4346),(75168,4346),(75169,4347),(75170,4347),(75171,4347),(75172,4347),(75173,4348),(75174,4348),(75175,4348),(75176,4348),(75177,4349),(75178,4349),(75179,4349),(75180,4349),(75181,4350),(75182,4350),(75183,4350),(75184,4350),(75185,4351),(75186,4351),(75187,4351),(75188,4351),(75189,4352),(75190,4352),(75191,4352),(75192,4352),(75193,4353),(75194,4353),(75195,4353),(75196,4353),(75197,4354),(75198,4354),(75199,4354),(75200,4354),(75201,4355),(75202,4355),(75203,4355),(75204,4355),(75205,4356),(75206,4356),(75207,4356),(75208,4356),(75209,4357),(75210,4357),(75211,4357),(75212,4357),(75213,4358),(75214,4358),(75215,4358),(75216,4358),(75217,4359),(75218,4359),(75219,4359),(75220,4359),(75221,4360),(75222,4360),(75223,4360),(75224,4360),(75225,4361),(75226,4361),(75227,4361),(75228,4361),(75229,4362),(75230,4362),(75231,4362),(75232,4362),(75233,4363),(75234,4363),(75235,4363),(75236,4363),(75237,4364),(75238,4364),(75239,4364),(75240,4364),(75241,4365),(75242,4365),(75243,4365),(75244,4365),(75245,4366),(75246,4366),(75247,4366),(75248,4366),(75249,4367),(75250,4367),(75251,4367),(75252,4367),(75253,4368),(75254,4368),(75255,4368),(75256,4368),(75257,4369),(75258,4369),(75259,4369),(75260,4369),(75261,4370),(75262,4370),(75263,4370),(75264,4370),(75265,4371),(75266,4371),(75267,4371),(75268,4371),(75269,4372),(75270,4372),(75271,4372),(75272,4372),(75273,4373),(75274,4373),(75275,4373),(75276,4373),(75277,4374),(75278,4374),(75279,4374),(75280,4374),(75281,4375),(75282,4375),(75283,4375),(75284,4375),(75285,4376),(75286,4376),(75287,4376),(75288,4376),(75289,4377),(75290,4377),(75291,4377),(75292,4377),(75293,4378),(75294,4378),(75295,4378),(75296,4378),(75297,4379),(75298,4379),(75299,4379),(75300,4379),(75301,4380),(75302,4380),(75303,4380),(75304,4380),(75305,4381),(75306,4381),(75307,4381),(75308,4381),(75309,4382),(75310,4382),(75311,4382),(75312,4382),(75313,4383),(75314,4383),(75315,4383),(75316,4383),(75317,4384),(75318,4384),(75319,4384),(75320,4384),(75321,4385),(75322,4385),(75323,4385),(75324,4385),(75325,4386),(75326,4386),(75327,4386),(75328,4386),(75329,4387),(75330,4387),(75331,4387),(75332,4387),(75333,4388),(75334,4388),(75335,4388),(75336,4388),(75337,4389),(75338,4389),(75339,4389),(75340,4389),(75341,4390),(75342,4390),(75343,4390),(75344,4390),(75345,4391),(75346,4391),(75347,4391),(75348,4391),(75349,4392),(75350,4392),(75351,4392),(75352,4392),(75353,4393),(75354,4393),(75355,4393),(75356,4393),(75357,4394),(75358,4394),(75359,4394),(75360,4394),(75361,4395),(75362,4395),(75363,4395),(75364,4395),(75365,4396),(75366,4396),(75367,4396),(75368,4396),(75369,4397),(75370,4397),(75371,4397),(75372,4397),(75373,4398),(75374,4398),(75375,4398),(75376,4398),(75377,4399),(75378,4399),(75379,4399),(75380,4399),(75381,4400),(75382,4400),(75383,4400),(75384,4400),(75385,4401),(75386,4401),(75387,4401),(75388,4401),(75389,4402),(75390,4402),(75391,4402),(75392,4402),(75393,4403),(75394,4403),(75395,4403),(75396,4403),(75397,4404),(75398,4404),(75399,4404),(75400,4404),(75401,4405),(75402,4405),(75403,4405),(75404,4405),(75405,4406),(75406,4406),(75407,4406),(75408,4406),(75409,4407),(75410,4407),(75411,4407),(75412,4407),(75413,4408),(75414,4408),(75415,4408),(75416,4408),(75417,4409),(75418,4409),(75419,4409),(75420,4409),(75421,4410),(75422,4410),(75423,4410),(75424,4410),(75425,4411),(75426,4411),(75427,4411),(75428,4411),(75429,4412),(75430,4412),(75431,4412),(75432,4412),(75433,4413),(75434,4413),(75435,4413),(75436,4413),(75437,4414),(75438,4415),(75439,4416),(75440,4417),(75441,4418),(75442,4419),(75443,4420),(75444,4421),(75445,4422),(75446,4423),(75447,4424),(75448,4425),(75449,4426),(75450,4427),(75451,4428),(75452,4429),(75453,4430),(75454,4431),(75455,4432),(75456,4433),(75457,4434),(75458,4435),(75459,4436),(75460,4437),(75461,4438),(75462,4439),(75463,4440),(75464,4441),(75465,4442),(75466,4443),(75467,4444),(75468,4445),(75469,4446),(75470,4447),(75471,4448),(75472,4449),(75473,4450),(75474,4451),(75475,4452),(75476,4453),(75477,4454),(75478,4455),(75479,4456),(75480,4457),(75481,4458),(75482,4459),(75483,4460),(75484,4461),(75485,4462),(75486,4463),(75487,4464),(75488,4465),(75489,4466),(75490,4467),(75491,4468),(75492,4469),(75493,4470),(75494,4471),(75495,4472),(75496,4473),(75497,4474),(75498,4475),(75499,4476),(75500,4477),(75501,4478),(75502,4479),(75503,4480),(75504,4481),(75505,4482),(75506,4483),(75507,4484),(75508,4485),(75509,4486),(75510,4487),(75511,4488),(75512,4489),(75513,4490),(75514,4414),(75515,4414),(75516,4414),(75517,4414),(75518,4414),(75519,4414),(75520,4415),(75521,4415),(75522,4415),(75523,4415),(75524,4415),(75525,4415),(75526,4416),(75527,4416),(75528,4416),(75529,4416),(75530,4416),(75531,4416),(75532,4417),(75533,4417),(75534,4417),(75535,4417),(75536,4417),(75537,4417),(75538,4418),(75539,4418),(75540,4418),(75541,4418),(75542,4418),(75543,4418),(75544,4419),(75545,4419),(75546,4419),(75547,4419),(75548,4419),(75549,4419),(75550,4420),(75551,4420),(75552,4420),(75553,4420),(75554,4420),(75555,4420),(75556,4421),(75557,4421),(75558,4421),(75559,4421),(75560,4421),(75561,4421),(75562,4422),(75563,4422),(75564,4422),(75565,4422),(75566,4422),(75567,4422),(75568,4423),(75569,4423),(75570,4423),(75571,4423),(75572,4423),(75573,4423),(75574,4424),(75575,4424),(75576,4424),(75577,4424),(75578,4424),(75579,4424),(75580,4425),(75581,4425),(75582,4425),(75583,4425),(75584,4425),(75585,4425),(75586,4426),(75587,4426),(75588,4426),(75589,4426),(75590,4426),(75591,4426),(75592,4427),(75593,4427),(75594,4427),(75595,4427),(75596,4427),(75597,4427),(75598,4428),(75599,4428),(75600,4428),(75601,4428),(75602,4428),(75603,4428),(75604,4429),(75605,4429),(75606,4429),(75607,4429),(75608,4429),(75609,4429),(75610,4430),(75611,4430),(75612,4430),(75613,4430),(75614,4430),(75615,4430),(75616,4431),(75617,4431),(75618,4431),(75619,4431),(75620,4431),(75621,4431),(75622,4432),(75623,4432),(75624,4432),(75625,4432),(75626,4433),(75627,4433),(75628,4433),(75629,4433),(75630,4434),(75631,4434),(75632,4434),(75633,4434),(75634,4434),(75635,4434),(75636,4435),(75637,4435),(75638,4435),(75639,4435),(75640,4435),(75641,4435),(75642,4436),(75643,4436),(75644,4436),(75645,4436),(75646,4436),(75647,4436),(75648,4437),(75649,4437),(75650,4437),(75651,4437),(75652,4437),(75653,4437),(75654,4438),(75655,4438),(75656,4438),(75657,4438),(75658,4438),(75659,4438),(75660,4439),(75661,4439),(75662,4439),(75663,4439),(75664,4439),(75665,4439),(75666,4440),(75667,4440),(75668,4440),(75669,4440),(75670,4440),(75671,4440),(75672,4441),(75673,4441),(75674,4441),(75675,4441),(75676,4441),(75677,4441),(75678,4442),(75679,4442),(75680,4442),(75681,4442),(75682,4442),(75683,4442),(75684,4443),(75685,4443),(75686,4443),(75687,4443),(75688,4443),(75689,4443),(75690,4444),(75691,4444),(75692,4444),(75693,4444),(75694,4444),(75695,4444),(75696,4445),(75697,4445),(75698,4445),(75699,4445),(75700,4445),(75701,4445),(75702,4446),(75703,4446),(75704,4446),(75705,4446),(75706,4446),(75707,4446),(75708,4447),(75709,4447),(75710,4447),(75711,4447),(75712,4447),(75713,4447),(75714,4448),(75715,4448),(75716,4448),(75717,4448),(75718,4448),(75719,4448),(75720,4449),(75721,4449),(75722,4449),(75723,4449),(75724,4449),(75725,4449),(75726,4450),(75727,4450),(75728,4450),(75729,4450),(75730,4450),(75731,4450),(75732,4451),(75733,4451),(75734,4451),(75735,4451),(75736,4451),(75737,4451),(75738,4452),(75739,4452),(75740,4452),(75741,4452),(75742,4452),(75743,4452),(75744,4453),(75745,4453),(75746,4453),(75747,4453),(75748,4453),(75749,4453),(75750,4454),(75751,4454),(75752,4454),(75753,4454),(75754,4454),(75755,4454),(75756,4455),(75757,4455),(75758,4455),(75759,4455),(75760,4455),(75761,4455),(75762,4456),(75763,4456),(75764,4456),(75765,4456),(75766,4456),(75767,4456),(75768,4457),(75769,4457),(75770,4457),(75771,4457),(75772,4457),(75773,4457),(75774,4458),(75775,4458),(75776,4458),(75777,4458),(75778,4458),(75779,4458),(75780,4459),(75781,4459),(75782,4459),(75783,4459),(75784,4459),(75785,4459),(75786,4460),(75787,4460),(75788,4460),(75789,4460),(75790,4460),(75791,4460),(75792,4461),(75793,4461),(75794,4461),(75795,4461),(75796,4461),(75797,4461),(75798,4462),(75799,4462),(75800,4462),(75801,4462),(75802,4462),(75803,4462),(75804,4463),(75805,4463),(75806,4463),(75807,4463),(75808,4463),(75809,4463),(75810,4464),(75811,4464),(75812,4464),(75813,4464),(75814,4464),(75815,4464),(75816,4465),(75817,4465),(75818,4465),(75819,4465),(75820,4465),(75821,4465),(75822,4466),(75823,4466),(75824,4466),(75825,4466),(75826,4466),(75827,4466),(75828,4467),(75829,4467),(75830,4467),(75831,4467),(75832,4467),(75833,4467),(75834,4468),(75835,4468),(75836,4468),(75837,4468),(75838,4468),(75839,4468),(75840,4469),(75841,4469),(75842,4469),(75843,4469),(75844,4469),(75845,4469),(75846,4470),(75847,4470),(75848,4470),(75849,4470),(75850,4470),(75851,4470),(75852,4471),(75853,4471),(75854,4471),(75855,4471),(75856,4471),(75857,4471),(75858,4472),(75859,4472),(75860,4472),(75861,4472),(75862,4472),(75863,4472),(75864,4473),(75865,4473),(75866,4473),(75867,4473),(75868,4473),(75869,4473),(75870,4474),(75871,4474),(75872,4474),(75873,4474),(75874,4474),(75875,4474),(75876,4475),(75877,4475),(75878,4475),(75879,4475),(75880,4475),(75881,4475),(75882,4476),(75883,4476),(75884,4476),(75885,4476),(75886,4476),(75887,4476),(75888,4477),(75889,4477),(75890,4477),(75891,4477),(75892,4477),(75893,4477),(75894,4478),(75895,4478),(75896,4478),(75897,4478),(75898,4478),(75899,4478),(75900,4479),(75901,4479),(75902,4479),(75903,4479),(75904,4479),(75905,4479),(75906,4480),(75907,4480),(75908,4480),(75909,4480),(75910,4480),(75911,4481),(75912,4481),(75913,4481),(75914,4481),(75915,4481),(75916,4481),(75917,4482),(75918,4482),(75919,4482),(75920,4482),(75921,4482),(75922,4482),(75923,4483),(75924,4483),(75925,4483),(75926,4483),(75927,4483),(75928,4483),(75929,4484),(75930,4484),(75931,4484),(75932,4484),(75933,4484),(75934,4484),(75935,4485),(75936,4485),(75937,4485),(75938,4485),(75939,4485),(75940,4485),(75941,4486),(75942,4486),(75943,4486),(75944,4486),(75945,4486),(75946,4486),(75947,4487),(75948,4487),(75949,4487),(75950,4487),(75951,4487),(75952,4487),(75953,4488),(75954,4488),(75955,4488),(75956,4488),(75957,4488),(75958,4488),(75959,4489),(75960,4489),(75961,4489),(75962,4489),(75963,4489),(75964,4489),(75965,4490),(75966,4490),(75967,4490),(75968,4490),(75969,4490),(75970,4490),(75971,4414),(75972,4414),(75973,4415),(75974,4415),(75975,4416),(75976,4416),(75977,4417),(75978,4417),(75979,4418),(75980,4418),(75981,4419),(75982,4419),(75983,4420),(75984,4420),(75985,4421),(75986,4421),(75987,4422),(75988,4422),(75989,4423),(75990,4423),(75991,4424),(75992,4424),(75993,4425),(75994,4425),(75995,4426),(75996,4426),(75997,4427),(75998,4427),(75999,4428),(76000,4428),(76001,4429),(76002,4429),(76003,4430),(76004,4430),(76005,4431),(76006,4431),(76007,4432),(76008,4433),(76009,4434),(76010,4434),(76011,4435),(76012,4435),(76013,4436),(76014,4436),(76015,4437),(76016,4437),(76017,4437),(76018,4438),(76019,4438),(76020,4439),(76021,4439),(76022,4440),(76023,4440),(76024,4441),(76025,4441),(76026,4442),(76027,4442),(76028,4443),(76029,4443),(76030,4444),(76031,4444),(76032,4445),(76033,4445),(76034,4446),(76035,4446),(76036,4447),(76037,4447),(76038,4448),(76039,4448),(76040,4449),(76041,4449),(76042,4450),(76043,4450),(76044,4451),(76045,4451),(76046,4452),(76047,4452),(76048,4453),(76049,4453),(76050,4454),(76051,4454),(76052,4455),(76053,4455),(76054,4456),(76055,4456),(76056,4457),(76057,4457),(76058,4458),(76059,4458),(76060,4459),(76061,4459),(76062,4460),(76063,4460),(76064,4461),(76065,4461),(76066,4462),(76067,4462),(76068,4463),(76069,4463),(76070,4464),(76071,4464),(76072,4465),(76073,4465),(76074,4466),(76075,4466),(76076,4467),(76077,4467),(76078,4468),(76079,4468),(76080,4469),(76081,4469),(76082,4470),(76083,4470),(76084,4471),(76085,4471),(76086,4472),(76087,4472),(76088,4473),(76089,4473),(76090,4474),(76091,4474),(76092,4475),(76093,4475),(76094,4476),(76095,4476),(76096,4477),(76097,4477),(76098,4478),(76099,4478),(76100,4479),(76101,4479),(76102,4480),(76103,4481),(76104,4481),(76105,4482),(76106,4482),(76107,4483),(76108,4483),(76109,4484),(76110,4484),(76111,4485),(76112,4485),(76113,4486),(76114,4486),(76115,4487),(76116,4487),(76117,4488),(76118,4488),(76119,4489),(76120,4489),(76121,4490),(76122,4490),(76123,4414),(76124,4414),(76125,4414),(76126,4415),(76127,4415),(76128,4415),(76129,4416),(76130,4416),(76131,4417),(76132,4417),(76133,4417),(76134,4418),(76135,4418),(76136,4418),(76137,4419),(76138,4419),(76139,4419),(76140,4420),(76141,4420),(76142,4420),(76143,4421),(76144,4421),(76145,4421),(76146,4422),(76147,4422),(76148,4422),(76149,4423),(76150,4423),(76151,4423),(76152,4424),(76153,4424),(76154,4424),(76155,4425),(76156,4425),(76157,4425),(76158,4426),(76159,4426),(76160,4426),(76161,4427),(76162,4427),(76163,4427),(76164,4428),(76165,4428),(76166,4428),(76167,4429),(76168,4429),(76169,4429),(76170,4430),(76171,4430),(76172,4431),(76173,4431),(76174,4432),(76175,4432),(76176,4432),(76177,4433),(76178,4433),(76179,4433),(76180,4434),(76181,4434),(76182,4434),(76183,4435),(76184,4435),(76185,4435),(76186,4436),(76187,4436),(76188,4436),(76189,4437),(76190,4437),(76191,4437),(76192,4438),(76193,4438),(76194,4438),(76195,4439),(76196,4439),(76197,4439),(76198,4440),(76199,4440),(76200,4440),(76201,4441),(76202,4441),(76203,4441),(76204,4442),(76205,4442),(76206,4442),(76207,4443),(76208,4443),(76209,4443),(76210,4444),(76211,4444),(76212,4444),(76213,4445),(76214,4445),(76215,4445),(76216,4446),(76217,4446),(76218,4446),(76219,4447),(76220,4447),(76221,4447),(76222,4448),(76223,4448),(76224,4448),(76225,4449),(76226,4449),(76227,4449),(76228,4450),(76229,4450),(76230,4450),(76231,4451),(76232,4451),(76233,4451),(76234,4452),(76235,4452),(76236,4452),(76237,4453),(76238,4453),(76239,4453),(76240,4454),(76241,4454),(76242,4454),(76243,4455),(76244,4455),(76245,4455),(76246,4456),(76247,4456),(76248,4456),(76249,4457),(76250,4457),(76251,4458),(76252,4458),(76253,4458),(76254,4459),(76255,4459),(76256,4459),(76257,4460),(76258,4460),(76259,4460),(76260,4461),(76261,4461),(76262,4461),(76263,4462),(76264,4462),(76265,4462),(76266,4463),(76267,4463),(76268,4463),(76269,4464),(76270,4464),(76271,4464),(76272,4465),(76273,4465),(76274,4465),(76275,4466),(76276,4466),(76277,4466),(76278,4467),(76279,4467),(76280,4467),(76281,4468),(76282,4468),(76283,4468),(76284,4469),(76285,4469),(76286,4469),(76287,4470),(76288,4470),(76289,4470),(76290,4471),(76291,4471),(76292,4471),(76293,4472),(76294,4472),(76295,4472),(76296,4473),(76297,4473),(76298,4473),(76299,4474),(76300,4474),(76301,4474),(76302,4475),(76303,4475),(76304,4475),(76305,4476),(76306,4476),(76307,4476),(76308,4477),(76309,4477),(76310,4477),(76311,4478),(76312,4478),(76313,4478),(76314,4479),(76315,4479),(76316,4479),(76317,4480),(76318,4480),(76319,4480),(76320,4481),(76321,4481),(76322,4481),(76323,4482),(76324,4482),(76325,4482),(76326,4483),(76327,4483),(76328,4483),(76329,4484),(76330,4484),(76331,4484),(76332,4485),(76333,4485),(76334,4485),(76335,4486),(76336,4486),(76337,4486),(76338,4487),(76339,4487),(76340,4487),(76341,4488),(76342,4488),(76343,4488),(76344,4489),(76345,4489),(76346,4489),(76347,4490),(76348,4490),(76349,4490),(76350,4414),(76351,4414),(76352,4414),(76353,4414),(76354,4415),(76355,4415),(76356,4415),(76357,4415),(76358,4416),(76359,4416),(76360,4416),(76361,4416),(76362,4417),(76363,4417),(76364,4417),(76365,4417),(76366,4418),(76367,4418),(76368,4418),(76369,4418),(76370,4419),(76371,4419),(76372,4419),(76373,4419),(76374,4420),(76375,4420),(76376,4420),(76377,4420),(76378,4421),(76379,4421),(76380,4421),(76381,4421),(76382,4422),(76383,4422),(76384,4422),(76385,4422),(76386,4423),(76387,4423),(76388,4423),(76389,4423),(76390,4424),(76391,4424),(76392,4424),(76393,4424),(76394,4425),(76395,4425),(76396,4425),(76397,4425),(76398,4426),(76399,4426),(76400,4426),(76401,4426),(76402,4427),(76403,4427),(76404,4427),(76405,4427),(76406,4428),(76407,4428),(76408,4428),(76409,4428),(76410,4429),(76411,4429),(76412,4429),(76413,4429),(76414,4430),(76415,4430),(76416,4430),(76417,4430),(76418,4431),(76419,4431),(76420,4431),(76421,4431),(76422,4432),(76423,4432),(76424,4432),(76425,4432),(76426,4433),(76427,4433),(76428,4433),(76429,4433),(76430,4434),(76431,4434),(76432,4434),(76433,4434),(76434,4435),(76435,4435),(76436,4435),(76437,4435),(76438,4436),(76439,4436),(76440,4436),(76441,4436),(76442,4437),(76443,4437),(76444,4437),(76445,4437),(76446,4438),(76447,4438),(76448,4438),(76449,4438),(76450,4439),(76451,4439),(76452,4439),(76453,4439),(76454,4440),(76455,4440),(76456,4440),(76457,4440),(76458,4441),(76459,4441),(76460,4441),(76461,4441),(76462,4442),(76463,4442),(76464,4442),(76465,4442),(76466,4443),(76467,4443),(76468,4443),(76469,4443),(76470,4444),(76471,4444),(76472,4444),(76473,4444),(76474,4445),(76475,4445),(76476,4445),(76477,4445),(76478,4446),(76479,4446),(76480,4446),(76481,4446),(76482,4447),(76483,4447),(76484,4447),(76485,4447),(76486,4448),(76487,4448),(76488,4448),(76489,4448),(76490,4449),(76491,4449),(76492,4449),(76493,4449),(76494,4450),(76495,4450),(76496,4450),(76497,4450),(76498,4451),(76499,4451),(76500,4451),(76501,4451),(76502,4452),(76503,4452),(76504,4452),(76505,4452),(76506,4453),(76507,4453),(76508,4453),(76509,4453),(76510,4454),(76511,4454),(76512,4454),(76513,4454),(76514,4455),(76515,4455),(76516,4455),(76517,4455),(76518,4456),(76519,4456),(76520,4456),(76521,4456),(76522,4457),(76523,4457),(76524,4457),(76525,4457),(76526,4458),(76527,4458),(76528,4458),(76529,4458),(76530,4459),(76531,4459),(76532,4459),(76533,4459),(76534,4460),(76535,4460),(76536,4460),(76537,4460),(76538,4461),(76539,4461),(76540,4461),(76541,4461),(76542,4462),(76543,4462),(76544,4462),(76545,4462),(76546,4463),(76547,4463),(76548,4463),(76549,4463),(76550,4464),(76551,4464),(76552,4464),(76553,4464),(76554,4465),(76555,4465),(76556,4465),(76557,4465),(76558,4466),(76559,4466),(76560,4466),(76561,4466),(76562,4467),(76563,4467),(76564,4467),(76565,4467),(76566,4468),(76567,4468),(76568,4468),(76569,4468),(76570,4469),(76571,4469),(76572,4469),(76573,4469),(76574,4470),(76575,4470),(76576,4470),(76577,4470),(76578,4471),(76579,4471),(76580,4471),(76581,4471),(76582,4472),(76583,4472),(76584,4472),(76585,4472),(76586,4473),(76587,4473),(76588,4473),(76589,4473),(76590,4474),(76591,4474),(76592,4474),(76593,4474),(76594,4475),(76595,4475),(76596,4475),(76597,4475),(76598,4476),(76599,4476),(76600,4476),(76601,4476),(76602,4477),(76603,4477),(76604,4477),(76605,4477),(76606,4478),(76607,4478),(76608,4478),(76609,4478),(76610,4479),(76611,4479),(76612,4479),(76613,4479),(76614,4480),(76615,4480),(76616,4480),(76617,4480),(76618,4481),(76619,4481),(76620,4481),(76621,4481),(76622,4482),(76623,4482),(76624,4482),(76625,4482),(76626,4483),(76627,4483),(76628,4483),(76629,4483),(76630,4484),(76631,4484),(76632,4484),(76633,4484),(76634,4485),(76635,4485),(76636,4485),(76637,4485),(76638,4486),(76639,4486),(76640,4486),(76641,4486),(76642,4487),(76643,4487),(76644,4487),(76645,4487),(76646,4488),(76647,4488),(76648,4488),(76649,4488),(76650,4489),(76651,4489),(76652,4489),(76653,4489),(76654,4490),(76655,4490),(76656,4490),(76657,4490),(76658,4491),(76659,4492),(76660,4493),(76661,4494),(76662,4495),(76663,4496),(76664,4497),(76665,4498),(76666,4499),(76667,4500),(76668,4501),(76669,4502),(76670,4503),(76671,4504),(76672,4505),(76673,4506),(76674,4507),(76675,4508),(76676,4509),(76677,4510),(76678,4511),(76679,4512),(76680,4513),(76681,4514),(76682,4515),(76683,4516),(76684,4517),(76685,4518),(76686,4519),(76687,4520),(76688,4521),(76689,4522),(76690,4523),(76691,4524),(76692,4525),(76693,4526),(76694,4527),(76695,4528),(76696,4529),(76697,4530),(76698,4531),(76699,4532),(76700,4533),(76701,4534),(76702,4535),(76703,4536),(76704,4537),(76705,4538),(76706,4539),(76707,4540),(76708,4541),(76709,4542),(76710,4543),(76711,4544),(76712,4545),(76713,4546),(76714,4547),(76715,4548),(76716,4549),(76717,4550),(76718,4551),(76719,4552),(76720,4553),(76721,4554),(76722,4555),(76723,4556),(76724,4557),(76725,4558),(76726,4559),(76727,4560),(76728,4561),(76729,4562),(76730,4563),(76731,4564),(76732,4565),(76733,4566),(76734,4567),(76735,4568),(76736,4569),(76737,4570),(76738,4571),(76739,4572),(76740,4573),(76741,4574),(76742,4575),(76743,4576),(76744,4577),(76745,4578),(76746,4579),(76747,4491),(76748,4491),(76749,4491),(76750,4491),(76751,4491),(76752,4491),(76753,4492),(76754,4492),(76755,4492),(76756,4492),(76757,4492),(76758,4492),(76759,4493),(76760,4493),(76761,4493),(76762,4493),(76763,4493),(76764,4493),(76765,4494),(76766,4494),(76767,4494),(76768,4494),(76769,4494),(76770,4494),(76771,4495),(76772,4495),(76773,4495),(76774,4495),(76775,4495),(76776,4495),(76777,4496),(76778,4496),(76779,4496),(76780,4496),(76781,4496),(76782,4496),(76783,4497),(76784,4497),(76785,4497),(76786,4497),(76787,4497),(76788,4497),(76789,4498),(76790,4498),(76791,4498),(76792,4498),(76793,4498),(76794,4498),(76795,4499),(76796,4499),(76797,4499),(76798,4499),(76799,4499),(76800,4499),(76801,4500),(76802,4500),(76803,4500),(76804,4500),(76805,4500),(76806,4500),(76807,4501),(76808,4501),(76809,4501),(76810,4501),(76811,4501),(76812,4501),(76813,4502),(76814,4502),(76815,4502),(76816,4502),(76817,4502),(76818,4502),(76819,4503),(76820,4503),(76821,4503),(76822,4503),(76823,4503),(76824,4503),(76825,4504),(76826,4504),(76827,4504),(76828,4504),(76829,4504),(76830,4504),(76831,4505),(76832,4505),(76833,4505),(76834,4505),(76835,4505),(76836,4505),(76837,4506),(76838,4506),(76839,4506),(76840,4506),(76841,4506),(76842,4506),(76843,4507),(76844,4507),(76845,4507),(76846,4507),(76847,4507),(76848,4507),(76849,4508),(76850,4508),(76851,4508),(76852,4508),(76853,4508),(76854,4508),(76855,4509),(76856,4509),(76857,4509),(76858,4509),(76859,4509),(76860,4509),(76861,4510),(76862,4510),(76863,4510),(76864,4510),(76865,4510),(76866,4510),(76867,4511),(76868,4511),(76869,4511),(76870,4511),(76871,4511),(76872,4511),(76873,4512),(76874,4512),(76875,4512),(76876,4512),(76877,4512),(76878,4512),(76879,4513),(76880,4513),(76881,4513),(76882,4513),(76883,4513),(76884,4513),(76885,4514),(76886,4514),(76887,4514),(76888,4514),(76889,4514),(76890,4514),(76891,4515),(76892,4515),(76893,4515),(76894,4515),(76895,4515),(76896,4515),(76897,4516),(76898,4516),(76899,4516),(76900,4516),(76901,4516),(76902,4516),(76903,4517),(76904,4517),(76905,4517),(76906,4517),(76907,4517),(76908,4517),(76909,4518),(76910,4518),(76911,4518),(76912,4518),(76913,4518),(76914,4518),(76915,4519),(76916,4519),(76917,4519),(76918,4519),(76919,4519),(76920,4519),(76921,4520),(76922,4520),(76923,4520),(76924,4520),(76925,4520),(76926,4520),(76927,4521),(76928,4521),(76929,4521),(76930,4521),(76931,4521),(76932,4521),(76933,4522),(76934,4522),(76935,4522),(76936,4522),(76937,4522),(76938,4522),(76939,4523),(76940,4523),(76941,4523),(76942,4523),(76943,4523),(76944,4523),(76945,4524),(76946,4524),(76947,4524),(76948,4524),(76949,4524),(76950,4524),(76951,4525),(76952,4525),(76953,4525),(76954,4525),(76955,4525),(76956,4525),(76957,4526),(76958,4526),(76959,4526),(76960,4526),(76961,4526),(76962,4526),(76963,4527),(76964,4527),(76965,4527),(76966,4527),(76967,4527),(76968,4527),(76969,4528),(76970,4528),(76971,4528),(76972,4528),(76973,4528),(76974,4528);
INSERT INTO `catalogrule_product_cl` VALUES (76975,4529),(76976,4529),(76977,4529),(76978,4529),(76979,4529),(76980,4529),(76981,4530),(76982,4530),(76983,4530),(76984,4530),(76985,4530),(76986,4530),(76987,4531),(76988,4531),(76989,4531),(76990,4531),(76991,4531),(76992,4531),(76993,4532),(76994,4532),(76995,4532),(76996,4532),(76997,4532),(76998,4532),(76999,4533),(77000,4533),(77001,4533),(77002,4533),(77003,4533),(77004,4533),(77005,4534),(77006,4534),(77007,4534),(77008,4534),(77009,4534),(77010,4534),(77011,4535),(77012,4535),(77013,4535),(77014,4535),(77015,4535),(77016,4535),(77017,4536),(77018,4536),(77019,4536),(77020,4536),(77021,4536),(77022,4536),(77023,4537),(77024,4537),(77025,4537),(77026,4537),(77027,4537),(77028,4537),(77029,4538),(77030,4538),(77031,4538),(77032,4538),(77033,4538),(77034,4538),(77035,4539),(77036,4539),(77037,4539),(77038,4539),(77039,4539),(77040,4539),(77041,4540),(77042,4540),(77043,4540),(77044,4540),(77045,4540),(77046,4540),(77047,4541),(77048,4541),(77049,4541),(77050,4541),(77051,4541),(77052,4541),(77053,4542),(77054,4542),(77055,4542),(77056,4542),(77057,4542),(77058,4542),(77059,4543),(77060,4543),(77061,4543),(77062,4543),(77063,4543),(77064,4543),(77065,4544),(77066,4544),(77067,4544),(77068,4544),(77069,4544),(77070,4544),(77071,4545),(77072,4545),(77073,4545),(77074,4545),(77075,4545),(77076,4545),(77077,4546),(77078,4546),(77079,4546),(77080,4546),(77081,4546),(77082,4546),(77083,4547),(77084,4547),(77085,4547),(77086,4547),(77087,4547),(77088,4547),(77089,4548),(77090,4548),(77091,4548),(77092,4548),(77093,4548),(77094,4548),(77095,4549),(77096,4549),(77097,4549),(77098,4549),(77099,4549),(77100,4549),(77101,4550),(77102,4550),(77103,4550),(77104,4550),(77105,4550),(77106,4550),(77107,4551),(77108,4551),(77109,4551),(77110,4551),(77111,4551),(77112,4551),(77113,4552),(77114,4552),(77115,4552),(77116,4552),(77117,4552),(77118,4552),(77119,4553),(77120,4553),(77121,4553),(77122,4553),(77123,4553),(77124,4553),(77125,4554),(77126,4554),(77127,4554),(77128,4554),(77129,4554),(77130,4554),(77131,4555),(77132,4555),(77133,4555),(77134,4555),(77135,4555),(77136,4555),(77137,4556),(77138,4556),(77139,4556),(77140,4556),(77141,4556),(77142,4556),(77143,4557),(77144,4557),(77145,4557),(77146,4557),(77147,4557),(77148,4557),(77149,4558),(77150,4558),(77151,4558),(77152,4558),(77153,4558),(77154,4558),(77155,4559),(77156,4559),(77157,4559),(77158,4559),(77159,4559),(77160,4559),(77161,4560),(77162,4560),(77163,4560),(77164,4560),(77165,4560),(77166,4560),(77167,4561),(77168,4561),(77169,4561),(77170,4561),(77171,4561),(77172,4561),(77173,4562),(77174,4562),(77175,4562),(77176,4562),(77177,4562),(77178,4562),(77179,4563),(77180,4563),(77181,4563),(77182,4563),(77183,4563),(77184,4563),(77185,4564),(77186,4564),(77187,4564),(77188,4564),(77189,4564),(77190,4564),(77191,4565),(77192,4565),(77193,4565),(77194,4565),(77195,4565),(77196,4565),(77197,4566),(77198,4566),(77199,4566),(77200,4566),(77201,4566),(77202,4566),(77203,4567),(77204,4567),(77205,4567),(77206,4567),(77207,4567),(77208,4567),(77209,4568),(77210,4568),(77211,4568),(77212,4568),(77213,4569),(77214,4569),(77215,4569),(77216,4569),(77217,4570),(77218,4570),(77219,4570),(77220,4570),(77221,4571),(77222,4571),(77223,4571),(77224,4571),(77225,4572),(77226,4572),(77227,4572),(77228,4572),(77229,4572),(77230,4572),(77231,4573),(77232,4573),(77233,4573),(77234,4573),(77235,4573),(77236,4573),(77237,4574),(77238,4574),(77239,4574),(77240,4574),(77241,4574),(77242,4574),(77243,4575),(77244,4575),(77245,4575),(77246,4575),(77247,4576),(77248,4576),(77249,4576),(77250,4576),(77251,4577),(77252,4577),(77253,4577),(77254,4577),(77255,4577),(77256,4577),(77257,4578),(77258,4578),(77259,4578),(77260,4578),(77261,4578),(77262,4579),(77263,4579),(77264,4579),(77265,4579),(77266,4579),(77267,4491),(77268,4491),(77269,4492),(77270,4492),(77271,4493),(77272,4493),(77273,4494),(77274,4494),(77275,4495),(77276,4495),(77277,4496),(77278,4496),(77279,4497),(77280,4497),(77281,4498),(77282,4498),(77283,4499),(77284,4499),(77285,4500),(77286,4500),(77287,4501),(77288,4501),(77289,4502),(77290,4502),(77291,4503),(77292,4503),(77293,4504),(77294,4504),(77295,4505),(77296,4505),(77297,4506),(77298,4506),(77299,4507),(77300,4507),(77301,4508),(77302,4508),(77303,4509),(77304,4509),(77305,4510),(77306,4510),(77307,4511),(77308,4511),(77309,4512),(77310,4512),(77311,4513),(77312,4513),(77313,4514),(77314,4514),(77315,4515),(77316,4515),(77317,4516),(77318,4516),(77319,4517),(77320,4517),(77321,4518),(77322,4518),(77323,4519),(77324,4519),(77325,4520),(77326,4520),(77327,4521),(77328,4521),(77329,4522),(77330,4522),(77331,4523),(77332,4523),(77333,4524),(77334,4524),(77335,4525),(77336,4525),(77337,4526),(77338,4526),(77339,4527),(77340,4527),(77341,4528),(77342,4528),(77343,4529),(77344,4529),(77345,4530),(77346,4530),(77347,4531),(77348,4531),(77349,4532),(77350,4532),(77351,4533),(77352,4533),(77353,4534),(77354,4534),(77355,4535),(77356,4535),(77357,4536),(77358,4536),(77359,4537),(77360,4537),(77361,4538),(77362,4538),(77363,4539),(77364,4539),(77365,4540),(77366,4540),(77367,4541),(77368,4541),(77369,4542),(77370,4542),(77371,4543),(77372,4543),(77373,4544),(77374,4544),(77375,4545),(77376,4545),(77377,4546),(77378,4546),(77379,4547),(77380,4547),(77381,4548),(77382,4548),(77383,4549),(77384,4549),(77385,4550),(77386,4550),(77387,4551),(77388,4551),(77389,4552),(77390,4552),(77391,4553),(77392,4553),(77393,4554),(77394,4554),(77395,4555),(77396,4555),(77397,4556),(77398,4556),(77399,4557),(77400,4557),(77401,4558),(77402,4558),(77403,4559),(77404,4559),(77405,4560),(77406,4560),(77407,4561),(77408,4561),(77409,4562),(77410,4562),(77411,4563),(77412,4563),(77413,4564),(77414,4564),(77415,4565),(77416,4565),(77417,4566),(77418,4566),(77419,4567),(77420,4567),(77421,4568),(77422,4569),(77423,4570),(77424,4571),(77425,4572),(77426,4572),(77427,4573),(77428,4573),(77429,4573),(77430,4574),(77431,4574),(77432,4574),(77433,4575),(77434,4575),(77435,4576),(77436,4576),(77437,4577),(77438,4577),(77439,4578),(77440,4578),(77441,4578),(77442,4579),(77443,4579),(77444,4579),(77445,4491),(77446,4491),(77447,4491),(77448,4492),(77449,4492),(77450,4492),(77451,4493),(77452,4493),(77453,4493),(77454,4494),(77455,4494),(77456,4494),(77457,4495),(77458,4495),(77459,4495),(77460,4496),(77461,4496),(77462,4496),(77463,4497),(77464,4497),(77465,4497),(77466,4498),(77467,4498),(77468,4498),(77469,4499),(77470,4499),(77471,4499),(77472,4500),(77473,4500),(77474,4500),(77475,4501),(77476,4501),(77477,4501),(77478,4502),(77479,4502),(77480,4502),(77481,4503),(77482,4503),(77483,4503),(77484,4504),(77485,4504),(77486,4504),(77487,4505),(77488,4505),(77489,4505),(77490,4506),(77491,4506),(77492,4506),(77493,4507),(77494,4507),(77495,4507),(77496,4508),(77497,4508),(77498,4508),(77499,4509),(77500,4509),(77501,4509),(77502,4510),(77503,4510),(77504,4510),(77505,4511),(77506,4511),(77507,4511),(77508,4512),(77509,4512),(77510,4512),(77511,4513),(77512,4513),(77513,4513),(77514,4514),(77515,4514),(77516,4514),(77517,4515),(77518,4515),(77519,4515),(77520,4516),(77521,4516),(77522,4516),(77523,4517),(77524,4517),(77525,4517),(77526,4518),(77527,4518),(77528,4518),(77529,4519),(77530,4519),(77531,4519),(77532,4520),(77533,4520),(77534,4520),(77535,4521),(77536,4521),(77537,4521),(77538,4522),(77539,4522),(77540,4522),(77541,4523),(77542,4523),(77543,4523),(77544,4524),(77545,4524),(77546,4524),(77547,4525),(77548,4525),(77549,4525),(77550,4526),(77551,4526),(77552,4526),(77553,4527),(77554,4527),(77555,4527),(77556,4528),(77557,4528),(77558,4528),(77559,4529),(77560,4529),(77561,4529),(77562,4530),(77563,4530),(77564,4530),(77565,4531),(77566,4531),(77567,4531),(77568,4532),(77569,4532),(77570,4532),(77571,4533),(77572,4533),(77573,4533),(77574,4534),(77575,4534),(77576,4534),(77577,4535),(77578,4535),(77579,4535),(77580,4536),(77581,4536),(77582,4536),(77583,4537),(77584,4537),(77585,4537),(77586,4538),(77587,4538),(77588,4539),(77589,4539),(77590,4539),(77591,4540),(77592,4540),(77593,4540),(77594,4541),(77595,4541),(77596,4541),(77597,4542),(77598,4542),(77599,4542),(77600,4543),(77601,4543),(77602,4543),(77603,4544),(77604,4544),(77605,4544),(77606,4545),(77607,4545),(77608,4545),(77609,4546),(77610,4546),(77611,4546),(77612,4547),(77613,4547),(77614,4547),(77615,4548),(77616,4548),(77617,4548),(77618,4549),(77619,4549),(77620,4549),(77621,4550),(77622,4550),(77623,4550),(77624,4551),(77625,4551),(77626,4551),(77627,4552),(77628,4552),(77629,4552),(77630,4553),(77631,4553),(77632,4553),(77633,4554),(77634,4554),(77635,4554),(77636,4555),(77637,4555),(77638,4555),(77639,4556),(77640,4556),(77641,4556),(77642,4557),(77643,4557),(77644,4557),(77645,4558),(77646,4558),(77647,4558),(77648,4559),(77649,4559),(77650,4559),(77651,4560),(77652,4560),(77653,4560),(77654,4561),(77655,4561),(77656,4561),(77657,4562),(77658,4562),(77659,4562),(77660,4563),(77661,4563),(77662,4563),(77663,4564),(77664,4564),(77665,4564),(77666,4565),(77667,4565),(77668,4565),(77669,4566),(77670,4566),(77671,4566),(77672,4567),(77673,4567),(77674,4567),(77675,4568),(77676,4568),(77677,4568),(77678,4569),(77679,4569),(77680,4569),(77681,4570),(77682,4570),(77683,4570),(77684,4571),(77685,4571),(77686,4571),(77687,4572),(77688,4572),(77689,4572),(77690,4573),(77691,4573),(77692,4573),(77693,4574),(77694,4574),(77695,4574),(77696,4575),(77697,4575),(77698,4575),(77699,4576),(77700,4576),(77701,4576),(77702,4577),(77703,4577),(77704,4577),(77705,4578),(77706,4578),(77707,4578),(77708,4579),(77709,4579),(77710,4579),(77711,4491),(77712,4491),(77713,4491),(77714,4491),(77715,4492),(77716,4492),(77717,4492),(77718,4492),(77719,4493),(77720,4493),(77721,4493),(77722,4493),(77723,4494),(77724,4494),(77725,4494),(77726,4494),(77727,4495),(77728,4495),(77729,4495),(77730,4495),(77731,4496),(77732,4496),(77733,4496),(77734,4496),(77735,4497),(77736,4497),(77737,4497),(77738,4497),(77739,4498),(77740,4498),(77741,4498),(77742,4498),(77743,4499),(77744,4499),(77745,4499),(77746,4499),(77747,4500),(77748,4500),(77749,4500),(77750,4500),(77751,4501),(77752,4501),(77753,4501),(77754,4501),(77755,4502),(77756,4502),(77757,4502),(77758,4502),(77759,4503),(77760,4503),(77761,4503),(77762,4503),(77763,4504),(77764,4504),(77765,4504),(77766,4504),(77767,4505),(77768,4505),(77769,4505),(77770,4505),(77771,4506),(77772,4506),(77773,4506),(77774,4506),(77775,4507),(77776,4507),(77777,4507),(77778,4507),(77779,4508),(77780,4508),(77781,4508),(77782,4508),(77783,4509),(77784,4509),(77785,4509),(77786,4509),(77787,4510),(77788,4510),(77789,4510),(77790,4510),(77791,4511),(77792,4511),(77793,4511),(77794,4511),(77795,4512),(77796,4512),(77797,4512),(77798,4512),(77799,4513),(77800,4513),(77801,4513),(77802,4513),(77803,4514),(77804,4514),(77805,4514),(77806,4514),(77807,4515),(77808,4515),(77809,4515),(77810,4515),(77811,4516),(77812,4516),(77813,4516),(77814,4516),(77815,4517),(77816,4517),(77817,4517),(77818,4517),(77819,4518),(77820,4518),(77821,4518),(77822,4518),(77823,4519),(77824,4519),(77825,4519),(77826,4519),(77827,4520),(77828,4520),(77829,4520),(77830,4520),(77831,4521),(77832,4521),(77833,4521),(77834,4521),(77835,4522),(77836,4522),(77837,4522),(77838,4522),(77839,4523),(77840,4523),(77841,4523),(77842,4523),(77843,4524),(77844,4524),(77845,4524),(77846,4524),(77847,4525),(77848,4525),(77849,4525),(77850,4525),(77851,4526),(77852,4526),(77853,4526),(77854,4526),(77855,4527),(77856,4527),(77857,4527),(77858,4527),(77859,4528),(77860,4528),(77861,4528),(77862,4528),(77863,4529),(77864,4529),(77865,4529),(77866,4529),(77867,4530),(77868,4530),(77869,4530),(77870,4530),(77871,4531),(77872,4531),(77873,4531),(77874,4531),(77875,4532),(77876,4532),(77877,4532),(77878,4532),(77879,4533),(77880,4533),(77881,4533),(77882,4533),(77883,4534),(77884,4534),(77885,4534),(77886,4534),(77887,4535),(77888,4535),(77889,4535),(77890,4535),(77891,4536),(77892,4536),(77893,4536),(77894,4536),(77895,4537),(77896,4537),(77897,4537),(77898,4537),(77899,4538),(77900,4538),(77901,4538),(77902,4538),(77903,4539),(77904,4539),(77905,4539),(77906,4539),(77907,4540),(77908,4540),(77909,4540),(77910,4540),(77911,4541),(77912,4541),(77913,4541),(77914,4541),(77915,4542),(77916,4542),(77917,4542),(77918,4542),(77919,4543),(77920,4543),(77921,4543),(77922,4543),(77923,4544),(77924,4544),(77925,4544),(77926,4544),(77927,4545),(77928,4545),(77929,4545),(77930,4545),(77931,4546),(77932,4546),(77933,4546),(77934,4546),(77935,4547),(77936,4547),(77937,4547),(77938,4547),(77939,4548),(77940,4548),(77941,4548),(77942,4548),(77943,4549),(77944,4549),(77945,4549),(77946,4549),(77947,4550),(77948,4550),(77949,4550),(77950,4550),(77951,4551),(77952,4551),(77953,4551),(77954,4551),(77955,4552),(77956,4552),(77957,4552),(77958,4552),(77959,4553),(77960,4553),(77961,4553),(77962,4553),(77963,4554),(77964,4554),(77965,4554),(77966,4554),(77967,4555),(77968,4555),(77969,4555),(77970,4555),(77971,4556),(77972,4556),(77973,4556),(77974,4556),(77975,4557),(77976,4557),(77977,4557),(77978,4557),(77979,4558),(77980,4558),(77981,4558),(77982,4558),(77983,4559),(77984,4559),(77985,4559),(77986,4559),(77987,4560),(77988,4560),(77989,4560),(77990,4560),(77991,4561),(77992,4561),(77993,4561),(77994,4561),(77995,4562),(77996,4562),(77997,4562),(77998,4562),(77999,4563),(78000,4563),(78001,4563),(78002,4563),(78003,4564),(78004,4564),(78005,4564),(78006,4564),(78007,4565),(78008,4565),(78009,4565),(78010,4565),(78011,4566),(78012,4566),(78013,4566),(78014,4566),(78015,4567),(78016,4567),(78017,4567),(78018,4567),(78019,4568),(78020,4568),(78021,4568),(78022,4568),(78023,4569),(78024,4569),(78025,4569),(78026,4569),(78027,4570),(78028,4570),(78029,4570),(78030,4570),(78031,4571),(78032,4571),(78033,4571),(78034,4571),(78035,4572),(78036,4572),(78037,4572),(78038,4572),(78039,4573),(78040,4573),(78041,4573),(78042,4573),(78043,4574),(78044,4574),(78045,4574),(78046,4574),(78047,4575),(78048,4575),(78049,4575),(78050,4575),(78051,4576),(78052,4576),(78053,4576),(78054,4576),(78055,4577),(78056,4577),(78057,4577),(78058,4577),(78059,4578),(78060,4578),(78061,4578),(78062,4578),(78063,4579),(78064,4579),(78065,4579),(78066,4579),(78067,4580),(78068,4581),(78069,4582),(78070,4583),(78071,4584),(78072,4585),(78073,4586),(78074,4587),(78075,4588),(78076,4589),(78077,4590),(78078,4591),(78079,4592),(78080,4593),(78081,4594),(78082,4595),(78083,4596),(78084,4597),(78085,4598),(78086,4599),(78087,4600),(78088,4601),(78089,4602),(78090,4603),(78091,4604),(78092,4605),(78093,4606),(78094,4607),(78095,4608),(78096,4609),(78097,4610),(78098,4611),(78099,4612),(78100,4613),(78101,4614),(78102,4615),(78103,4616),(78104,4617),(78105,4618),(78106,4619),(78107,4620),(78108,4621),(78109,4622),(78110,4623),(78111,4624),(78112,4625),(78113,4626),(78114,4627),(78115,4628),(78116,4629),(78117,4630),(78118,4631),(78119,4632),(78120,4633),(78121,4634),(78122,4635),(78123,4636),(78124,4637),(78125,4638),(78126,4639),(78127,4640),(78128,4641),(78129,4642),(78130,4643),(78131,4644),(78132,4645),(78133,4646),(78134,4647),(78135,4648),(78136,4649),(78137,4650),(78138,4651),(78139,4652),(78140,4653),(78141,4654),(78142,4655),(78143,4656),(78144,4657),(78145,4658),(78146,4659),(78147,4660),(78148,4661),(78149,4662),(78150,4663),(78151,4664),(78152,4665),(78153,4666),(78154,4667),(78155,4668),(78156,4669),(78157,4670),(78158,4671),(78159,4672),(78160,4673),(78161,4674),(78162,4675),(78163,4676),(78164,4677),(78165,4678),(78166,4679),(78167,4580),(78168,4580),(78169,4580),(78170,4580),(78171,4580),(78172,4581),(78173,4581),(78174,4581),(78175,4581),(78176,4581),(78177,4582),(78178,4582),(78179,4582),(78180,4582),(78181,4582),(78182,4582),(78183,4583),(78184,4583),(78185,4583),(78186,4583),(78187,4583),(78188,4583),(78189,4584),(78190,4584),(78191,4584),(78192,4584),(78193,4584),(78194,4584),(78195,4585),(78196,4585),(78197,4585),(78198,4585),(78199,4585),(78200,4585),(78201,4586),(78202,4586),(78203,4586),(78204,4586),(78205,4586),(78206,4586),(78207,4587),(78208,4587),(78209,4587),(78210,4587),(78211,4587),(78212,4587),(78213,4588),(78214,4588),(78215,4588),(78216,4588),(78217,4588),(78218,4588),(78219,4589),(78220,4589),(78221,4589),(78222,4589),(78223,4589),(78224,4589),(78225,4590),(78226,4590),(78227,4590),(78228,4590),(78229,4590),(78230,4590),(78231,4591),(78232,4591),(78233,4591),(78234,4591),(78235,4591),(78236,4591),(78237,4592),(78238,4592),(78239,4592),(78240,4592),(78241,4592),(78242,4592),(78243,4593),(78244,4593),(78245,4593),(78246,4593),(78247,4593),(78248,4593),(78249,4594),(78250,4594),(78251,4594),(78252,4594),(78253,4594),(78254,4594),(78255,4595),(78256,4595),(78257,4595),(78258,4595),(78259,4595),(78260,4595),(78261,4596),(78262,4596),(78263,4596),(78264,4596),(78265,4596),(78266,4596),(78267,4597),(78268,4597),(78269,4597),(78270,4597),(78271,4597),(78272,4597),(78273,4598),(78274,4598),(78275,4598),(78276,4598),(78277,4598),(78278,4598),(78279,4599),(78280,4599),(78281,4599),(78282,4599),(78283,4599),(78284,4599),(78285,4600),(78286,4600),(78287,4600),(78288,4600),(78289,4600),(78290,4600),(78291,4601),(78292,4601),(78293,4601),(78294,4601),(78295,4601),(78296,4601),(78297,4602),(78298,4602),(78299,4602),(78300,4602),(78301,4602),(78302,4602),(78303,4603),(78304,4603),(78305,4603),(78306,4603),(78307,4603),(78308,4603),(78309,4604),(78310,4604),(78311,4604),(78312,4604),(78313,4604),(78314,4604),(78315,4605),(78316,4605),(78317,4605),(78318,4605),(78319,4605),(78320,4606),(78321,4606),(78322,4606),(78323,4606),(78324,4606),(78325,4607),(78326,4607),(78327,4607),(78328,4607),(78329,4607),(78330,4608),(78331,4608),(78332,4608),(78333,4608),(78334,4608),(78335,4608),(78336,4609),(78337,4609),(78338,4609),(78339,4609),(78340,4610),(78341,4610),(78342,4610),(78343,4610),(78344,4611),(78345,4611),(78346,4611),(78347,4611),(78348,4612),(78349,4612),(78350,4612),(78351,4612),(78352,4612),(78353,4612),(78354,4613),(78355,4613),(78356,4613),(78357,4613),(78358,4613),(78359,4613),(78360,4614),(78361,4614),(78362,4614),(78363,4614),(78364,4614),(78365,4614),(78366,4615),(78367,4615),(78368,4615),(78369,4615),(78370,4616),(78371,4616),(78372,4616),(78373,4616),(78374,4617),(78375,4617),(78376,4617),(78377,4617),(78378,4618),(78379,4618),(78380,4618),(78381,4618),(78382,4619),(78383,4619),(78384,4619),(78385,4619),(78386,4620),(78387,4620),(78388,4620),(78389,4620),(78390,4621),(78391,4621),(78392,4621),(78393,4621),(78394,4621),(78395,4621),(78396,4622),(78397,4622),(78398,4622),(78399,4622),(78400,4622),(78401,4622),(78402,4623),(78403,4623),(78404,4623),(78405,4623),(78406,4623),(78407,4623),(78408,4624),(78409,4624),(78410,4624),(78411,4624),(78412,4624),(78413,4624),(78414,4625),(78415,4625),(78416,4625),(78417,4625),(78418,4625),(78419,4626),(78420,4626),(78421,4626),(78422,4626),(78423,4626),(78424,4627),(78425,4627),(78426,4627),(78427,4627),(78428,4627),(78429,4627),(78430,4628),(78431,4628),(78432,4628),(78433,4628),(78434,4628),(78435,4628),(78436,4629),(78437,4629),(78438,4629),(78439,4629),(78440,4629),(78441,4629),(78442,4630),(78443,4630),(78444,4630),(78445,4630),(78446,4630),(78447,4630),(78448,4631),(78449,4631),(78450,4631),(78451,4631),(78452,4631),(78453,4631),(78454,4632),(78455,4632),(78456,4632),(78457,4632),(78458,4632),(78459,4632),(78460,4633),(78461,4633),(78462,4633),(78463,4633),(78464,4633),(78465,4633),(78466,4634),(78467,4634),(78468,4634),(78469,4634),(78470,4634),(78471,4634),(78472,4635),(78473,4635),(78474,4635),(78475,4635),(78476,4635),(78477,4635),(78478,4636),(78479,4636),(78480,4636),(78481,4636),(78482,4636),(78483,4636),(78484,4637),(78485,4637),(78486,4637),(78487,4637),(78488,4637),(78489,4637),(78490,4638),(78491,4638),(78492,4638),(78493,4638),(78494,4638),(78495,4638),(78496,4639),(78497,4639),(78498,4639),(78499,4639),(78500,4639),(78501,4639),(78502,4640),(78503,4640),(78504,4640),(78505,4640),(78506,4640),(78507,4640),(78508,4641),(78509,4641),(78510,4641),(78511,4641),(78512,4641),(78513,4641),(78514,4642),(78515,4642),(78516,4642),(78517,4642),(78518,4642),(78519,4642),(78520,4643),(78521,4643),(78522,4643),(78523,4643),(78524,4643),(78525,4643),(78526,4644),(78527,4644),(78528,4644),(78529,4644),(78530,4644),(78531,4644),(78532,4645),(78533,4645),(78534,4645),(78535,4645),(78536,4645),(78537,4645),(78538,4646),(78539,4646),(78540,4646),(78541,4646),(78542,4646),(78543,4646),(78544,4647),(78545,4647),(78546,4647),(78547,4647),(78548,4647),(78549,4647),(78550,4648),(78551,4648),(78552,4648),(78553,4648),(78554,4648),(78555,4648),(78556,4649),(78557,4649),(78558,4649),(78559,4649),(78560,4649),(78561,4649),(78562,4650),(78563,4650),(78564,4650),(78565,4650),(78566,4650),(78567,4650),(78568,4651),(78569,4651),(78570,4651),(78571,4651),(78572,4651),(78573,4651),(78574,4652),(78575,4652),(78576,4652),(78577,4652),(78578,4652),(78579,4652),(78580,4653),(78581,4653),(78582,4653),(78583,4653),(78584,4653),(78585,4653),(78586,4654),(78587,4654),(78588,4654),(78589,4654),(78590,4654),(78591,4654),(78592,4655),(78593,4655),(78594,4655),(78595,4655),(78596,4655),(78597,4655),(78598,4656),(78599,4656),(78600,4656),(78601,4656),(78602,4656),(78603,4656),(78604,4657),(78605,4657),(78606,4657),(78607,4657),(78608,4657),(78609,4657),(78610,4658),(78611,4658),(78612,4658),(78613,4658),(78614,4658),(78615,4658),(78616,4659),(78617,4659),(78618,4659),(78619,4659),(78620,4659),(78621,4659),(78622,4660),(78623,4660),(78624,4660),(78625,4660),(78626,4660),(78627,4660),(78628,4661),(78629,4661),(78630,4661),(78631,4661),(78632,4661),(78633,4661),(78634,4662),(78635,4662),(78636,4662),(78637,4662),(78638,4662),(78639,4662),(78640,4663),(78641,4663),(78642,4663),(78643,4663),(78644,4663),(78645,4663),(78646,4664),(78647,4664),(78648,4664),(78649,4664),(78650,4664),(78651,4664),(78652,4665),(78653,4665),(78654,4665),(78655,4665),(78656,4665),(78657,4665),(78658,4666),(78659,4666),(78660,4666),(78661,4666),(78662,4666),(78663,4666),(78664,4667),(78665,4667),(78666,4667),(78667,4667),(78668,4667),(78669,4667),(78670,4668),(78671,4668),(78672,4668),(78673,4668),(78674,4668),(78675,4668),(78676,4669),(78677,4669),(78678,4669),(78679,4669),(78680,4669),(78681,4669),(78682,4670),(78683,4670),(78684,4670),(78685,4670),(78686,4671),(78687,4671),(78688,4671),(78689,4671),(78690,4671),(78691,4671),(78692,4672),(78693,4672),(78694,4672),(78695,4672),(78696,4673),(78697,4673),(78698,4673),(78699,4673),(78700,4673),(78701,4673),(78702,4674),(78703,4674),(78704,4674),(78705,4674),(78706,4674),(78707,4674),(78708,4675),(78709,4675),(78710,4675),(78711,4675),(78712,4675),(78713,4675),(78714,4676),(78715,4676),(78716,4676),(78717,4676),(78718,4676),(78719,4676),(78720,4677),(78721,4677),(78722,4677),(78723,4677),(78724,4678),(78725,4678),(78726,4678),(78727,4678),(78728,4679),(78729,4679),(78730,4679),(78731,4679),(78732,4580),(78733,4580),(78734,4580),(78735,4581),(78736,4581),(78737,4581),(78738,4582),(78739,4582),(78740,4583),(78741,4583),(78742,4584),(78743,4584),(78744,4585),(78745,4585),(78746,4586),(78747,4586),(78748,4587),(78749,4587),(78750,4588),(78751,4588),(78752,4589),(78753,4589),(78754,4590),(78755,4590),(78756,4591),(78757,4591),(78758,4592),(78759,4592),(78760,4593),(78761,4593),(78762,4594),(78763,4594),(78764,4595),(78765,4595),(78766,4596),(78767,4596),(78768,4597),(78769,4597),(78770,4598),(78771,4598),(78772,4599),(78773,4599),(78774,4600),(78775,4600),(78776,4601),(78777,4601),(78778,4602),(78779,4602),(78780,4603),(78781,4603),(78782,4604),(78783,4604),(78784,4605),(78785,4605),(78786,4605),(78787,4606),(78788,4606),(78789,4606),(78790,4607),(78791,4607),(78792,4607),(78793,4608),(78794,4608),(78795,4609),(78796,4609),(78797,4610),(78798,4610),(78799,4611),(78800,4611),(78801,4612),(78802,4612),(78803,4612),(78804,4613),(78805,4613),(78806,4613),(78807,4614),(78808,4614),(78809,4614),(78810,4615),(78811,4615),(78812,4616),(78813,4616),(78814,4617),(78815,4617),(78816,4618),(78817,4618),(78818,4619),(78819,4619),(78820,4620),(78821,4620),(78822,4621),(78823,4621),(78824,4622),(78825,4622),(78826,4622),(78827,4623),(78828,4623),(78829,4623),(78830,4624),(78831,4624),(78832,4624),(78833,4625),(78834,4625),(78835,4625),(78836,4626),(78837,4626),(78838,4626),(78839,4627),(78840,4627),(78841,4628),(78842,4628),(78843,4629),(78844,4629),(78845,4629),(78846,4630),(78847,4630),(78848,4630),(78849,4631),(78850,4631),(78851,4631),(78852,4632),(78853,4632),(78854,4632),(78855,4633),(78856,4633),(78857,4633),(78858,4634),(78859,4634),(78860,4634),(78861,4635),(78862,4635),(78863,4635),(78864,4636),(78865,4636),(78866,4636),(78867,4637),(78868,4637),(78869,4637),(78870,4638),(78871,4638),(78872,4638),(78873,4639),(78874,4639),(78875,4639),(78876,4640),(78877,4640),(78878,4640),(78879,4641),(78880,4641),(78881,4641),(78882,4642),(78883,4642),(78884,4642),(78885,4643),(78886,4643),(78887,4643),(78888,4644),(78889,4644),(78890,4644),(78891,4645),(78892,4645),(78893,4645),(78894,4646),(78895,4646),(78896,4646),(78897,4647),(78898,4647),(78899,4647),(78900,4648),(78901,4648),(78902,4648),(78903,4649),(78904,4649),(78905,4649),(78906,4650),(78907,4650),(78908,4650),(78909,4651),(78910,4651),(78911,4651),(78912,4652),(78913,4652),(78914,4652),(78915,4653),(78916,4653),(78917,4653),(78918,4654),(78919,4654),(78920,4654),(78921,4655),(78922,4655),(78923,4655),(78924,4656),(78925,4656),(78926,4656),(78927,4657),(78928,4657),(78929,4657),(78930,4658),(78931,4658),(78932,4658),(78933,4659),(78934,4659),(78935,4659),(78936,4660),(78937,4660),(78938,4660),(78939,4661),(78940,4661),(78941,4661),(78942,4662),(78943,4662),(78944,4662),(78945,4663),(78946,4663),(78947,4663),(78948,4664),(78949,4664),(78950,4664),(78951,4665),(78952,4665),(78953,4665),(78954,4666),(78955,4666),(78956,4666),(78957,4667),(78958,4667),(78959,4667),(78960,4668),(78961,4668),(78962,4668),(78963,4669),(78964,4669),(78965,4670),(78966,4670),(78967,4671),(78968,4671),(78969,4671),(78970,4672),(78971,4672),(78972,4673),(78973,4673),(78974,4673),(78975,4674),(78976,4674),(78977,4674),(78978,4675),(78979,4675),(78980,4675),(78981,4676),(78982,4676),(78983,4676),(78984,4677),(78985,4677),(78986,4678),(78987,4678),(78988,4679),(78989,4679),(78990,4580),(78991,4580),(78992,4580),(78993,4581),(78994,4581),(78995,4581),(78996,4582),(78997,4582),(78998,4582),(78999,4583),(79000,4583),(79001,4583),(79002,4584),(79003,4584),(79004,4584),(79005,4585),(79006,4585),(79007,4585),(79008,4586),(79009,4586),(79010,4586),(79011,4587),(79012,4587),(79013,4587),(79014,4588),(79015,4588),(79016,4588),(79017,4589),(79018,4589),(79019,4589),(79020,4590),(79021,4590),(79022,4590),(79023,4591),(79024,4591),(79025,4591),(79026,4592),(79027,4592),(79028,4592),(79029,4593),(79030,4593),(79031,4593),(79032,4594),(79033,4594),(79034,4594),(79035,4595),(79036,4595),(79037,4595),(79038,4596),(79039,4596),(79040,4596),(79041,4597),(79042,4597),(79043,4597),(79044,4598),(79045,4598),(79046,4598),(79047,4599),(79048,4599),(79049,4599),(79050,4600),(79051,4600),(79052,4600),(79053,4601),(79054,4601),(79055,4601),(79056,4602),(79057,4602),(79058,4602),(79059,4603),(79060,4603),(79061,4603),(79062,4604),(79063,4604),(79064,4604),(79065,4605),(79066,4605),(79067,4605),(79068,4606),(79069,4606),(79070,4606),(79071,4607),(79072,4607),(79073,4607),(79074,4608),(79075,4608),(79076,4608),(79077,4609),(79078,4609),(79079,4609),(79080,4610),(79081,4610),(79082,4610),(79083,4611),(79084,4611),(79085,4611),(79086,4612),(79087,4612),(79088,4612),(79089,4613),(79090,4613),(79091,4613),(79092,4614),(79093,4614),(79094,4614),(79095,4615),(79096,4615),(79097,4615),(79098,4616),(79099,4616),(79100,4616),(79101,4617),(79102,4617),(79103,4617),(79104,4618),(79105,4618),(79106,4618),(79107,4619),(79108,4619),(79109,4619),(79110,4620),(79111,4620),(79112,4620),(79113,4621),(79114,4621),(79115,4621),(79116,4622),(79117,4622),(79118,4622),(79119,4623),(79120,4623),(79121,4623),(79122,4624),(79123,4624),(79124,4624),(79125,4625),(79126,4625),(79127,4625),(79128,4626),(79129,4626),(79130,4626),(79131,4627),(79132,4627),(79133,4627),(79134,4628),(79135,4628),(79136,4628),(79137,4629),(79138,4629),(79139,4629),(79140,4630),(79141,4630),(79142,4630),(79143,4631),(79144,4631),(79145,4631),(79146,4632),(79147,4632),(79148,4632),(79149,4633),(79150,4633),(79151,4633),(79152,4634),(79153,4634),(79154,4634),(79155,4635),(79156,4635),(79157,4635),(79158,4636),(79159,4636),(79160,4636),(79161,4637),(79162,4637),(79163,4637),(79164,4638),(79165,4638),(79166,4638),(79167,4639),(79168,4639),(79169,4639),(79170,4640),(79171,4640),(79172,4640),(79173,4641),(79174,4641),(79175,4641),(79176,4642),(79177,4642),(79178,4642),(79179,4643),(79180,4643),(79181,4643),(79182,4644),(79183,4644),(79184,4644),(79185,4645),(79186,4645),(79187,4645),(79188,4646),(79189,4646),(79190,4646),(79191,4647),(79192,4647),(79193,4647),(79194,4648),(79195,4648),(79196,4648),(79197,4649),(79198,4649),(79199,4649),(79200,4650),(79201,4650),(79202,4650),(79203,4651),(79204,4651),(79205,4651),(79206,4652),(79207,4652),(79208,4652),(79209,4653),(79210,4653),(79211,4653),(79212,4654),(79213,4654),(79214,4654),(79215,4655),(79216,4655),(79217,4655),(79218,4656),(79219,4656),(79220,4656),(79221,4657),(79222,4657),(79223,4657),(79224,4658),(79225,4658),(79226,4658),(79227,4659),(79228,4659),(79229,4659),(79230,4660),(79231,4660),(79232,4660),(79233,4661),(79234,4661),(79235,4661),(79236,4662),(79237,4662),(79238,4662),(79239,4663),(79240,4663),(79241,4663),(79242,4664),(79243,4664),(79244,4664),(79245,4665),(79246,4665),(79247,4665),(79248,4666),(79249,4666),(79250,4666),(79251,4667),(79252,4667),(79253,4667),(79254,4668),(79255,4668),(79256,4668),(79257,4669),(79258,4669),(79259,4669),(79260,4670),(79261,4670),(79262,4670),(79263,4671),(79264,4671),(79265,4671),(79266,4672),(79267,4672),(79268,4672),(79269,4673),(79270,4673),(79271,4673),(79272,4674),(79273,4674),(79274,4674),(79275,4675),(79276,4675),(79277,4675),(79278,4676),(79279,4676),(79280,4676),(79281,4677),(79282,4677),(79283,4677),(79284,4678),(79285,4678),(79286,4678),(79287,4679),(79288,4679),(79289,4679),(79290,4580),(79291,4580),(79292,4580),(79293,4580),(79294,4581),(79295,4581),(79296,4581),(79297,4581),(79298,4582),(79299,4582),(79300,4582),(79301,4582),(79302,4583),(79303,4583),(79304,4583),(79305,4583),(79306,4584),(79307,4584),(79308,4584),(79309,4584),(79310,4585),(79311,4585),(79312,4585),(79313,4585),(79314,4586),(79315,4586),(79316,4586),(79317,4586),(79318,4587),(79319,4587),(79320,4587),(79321,4587),(79322,4588),(79323,4588),(79324,4588),(79325,4588),(79326,4589),(79327,4589),(79328,4589),(79329,4589),(79330,4590),(79331,4590),(79332,4590),(79333,4590),(79334,4591),(79335,4591),(79336,4591),(79337,4591),(79338,4592),(79339,4592),(79340,4592),(79341,4592),(79342,4593),(79343,4593),(79344,4593),(79345,4593),(79346,4594),(79347,4594),(79348,4594),(79349,4594),(79350,4595),(79351,4595),(79352,4595),(79353,4595),(79354,4596),(79355,4596),(79356,4596),(79357,4596),(79358,4597),(79359,4597),(79360,4597),(79361,4597),(79362,4598),(79363,4598),(79364,4598),(79365,4598),(79366,4599),(79367,4599),(79368,4599),(79369,4599),(79370,4600),(79371,4600),(79372,4600),(79373,4600),(79374,4601),(79375,4601),(79376,4601),(79377,4601),(79378,4602),(79379,4602),(79380,4602),(79381,4602),(79382,4603),(79383,4603),(79384,4603),(79385,4603),(79386,4604),(79387,4604),(79388,4604),(79389,4604),(79390,4605),(79391,4605),(79392,4605),(79393,4605),(79394,4606),(79395,4606),(79396,4606),(79397,4606),(79398,4607),(79399,4607),(79400,4607),(79401,4607),(79402,4608),(79403,4608),(79404,4608),(79405,4608),(79406,4609),(79407,4609),(79408,4609),(79409,4609),(79410,4610),(79411,4610),(79412,4610),(79413,4610),(79414,4611),(79415,4611),(79416,4611),(79417,4611),(79418,4612),(79419,4612),(79420,4612),(79421,4612),(79422,4613),(79423,4613),(79424,4613),(79425,4613),(79426,4614),(79427,4614),(79428,4614),(79429,4614),(79430,4615),(79431,4615),(79432,4615),(79433,4615),(79434,4616),(79435,4616),(79436,4616),(79437,4616),(79438,4617),(79439,4617),(79440,4617),(79441,4617),(79442,4618),(79443,4618),(79444,4618),(79445,4618),(79446,4619),(79447,4619),(79448,4619),(79449,4619),(79450,4620),(79451,4620),(79452,4620),(79453,4620),(79454,4621),(79455,4621),(79456,4621),(79457,4621),(79458,4622),(79459,4622),(79460,4622),(79461,4622),(79462,4623),(79463,4623),(79464,4623),(79465,4623),(79466,4624),(79467,4624),(79468,4624),(79469,4624),(79470,4625),(79471,4625),(79472,4625),(79473,4625),(79474,4626),(79475,4626),(79476,4626),(79477,4626),(79478,4627),(79479,4627),(79480,4627),(79481,4627),(79482,4628),(79483,4628),(79484,4628),(79485,4628),(79486,4629),(79487,4629),(79488,4629),(79489,4629),(79490,4630),(79491,4630),(79492,4630),(79493,4630),(79494,4631),(79495,4631),(79496,4631),(79497,4631),(79498,4632),(79499,4632),(79500,4632),(79501,4632),(79502,4633),(79503,4633),(79504,4633),(79505,4633),(79506,4634),(79507,4634),(79508,4634),(79509,4634),(79510,4635),(79511,4635),(79512,4635),(79513,4635),(79514,4636),(79515,4636),(79516,4636),(79517,4636),(79518,4637),(79519,4637),(79520,4637),(79521,4637),(79522,4638),(79523,4638),(79524,4638),(79525,4638),(79526,4639),(79527,4639),(79528,4639),(79529,4639),(79530,4640),(79531,4640),(79532,4640),(79533,4640),(79534,4641),(79535,4641),(79536,4641),(79537,4641),(79538,4642),(79539,4642),(79540,4642),(79541,4642),(79542,4643),(79543,4643),(79544,4643),(79545,4643),(79546,4644),(79547,4644),(79548,4644),(79549,4644),(79550,4645),(79551,4645),(79552,4645),(79553,4645),(79554,4646),(79555,4646),(79556,4646),(79557,4646),(79558,4647),(79559,4647),(79560,4647),(79561,4647),(79562,4648),(79563,4648),(79564,4648),(79565,4648),(79566,4649),(79567,4649),(79568,4649),(79569,4649),(79570,4650),(79571,4650),(79572,4650),(79573,4650),(79574,4651),(79575,4651),(79576,4651),(79577,4651),(79578,4652),(79579,4652),(79580,4652),(79581,4652),(79582,4653),(79583,4653),(79584,4653),(79585,4653),(79586,4654),(79587,4654),(79588,4654),(79589,4654),(79590,4655),(79591,4655),(79592,4655),(79593,4655),(79594,4656),(79595,4656),(79596,4656),(79597,4656),(79598,4657),(79599,4657),(79600,4657),(79601,4657),(79602,4658),(79603,4658),(79604,4658),(79605,4658),(79606,4659),(79607,4659),(79608,4659),(79609,4659),(79610,4660),(79611,4660),(79612,4660),(79613,4660),(79614,4661),(79615,4661),(79616,4661),(79617,4661),(79618,4662),(79619,4662),(79620,4662),(79621,4662),(79622,4663),(79623,4663),(79624,4663),(79625,4663),(79626,4664),(79627,4664),(79628,4664),(79629,4664),(79630,4665),(79631,4665),(79632,4665),(79633,4665),(79634,4666),(79635,4666),(79636,4666),(79637,4666),(79638,4667),(79639,4667),(79640,4667),(79641,4667),(79642,4668),(79643,4668),(79644,4668),(79645,4668),(79646,4669),(79647,4669),(79648,4669),(79649,4669),(79650,4670),(79651,4670),(79652,4670),(79653,4670),(79654,4671),(79655,4671),(79656,4671),(79657,4671),(79658,4672),(79659,4672),(79660,4672),(79661,4672),(79662,4673),(79663,4673),(79664,4673),(79665,4673),(79666,4674),(79667,4674),(79668,4674),(79669,4674),(79670,4675),(79671,4675),(79672,4675),(79673,4675),(79674,4676),(79675,4676),(79676,4676),(79677,4676),(79678,4677),(79679,4677),(79680,4677),(79681,4677),(79682,4678),(79683,4678),(79684,4678),(79685,4678),(79686,4679),(79687,4679),(79688,4679),(79689,4679),(79690,4680),(79691,4681),(79692,4682),(79693,4683),(79694,4684),(79695,4685),(79696,4686),(79697,4687),(79698,4688),(79699,4689),(79700,4690),(79701,4691),(79702,4692),(79703,4693),(79704,4694),(79705,4695),(79706,4696),(79707,4697),(79708,4698),(79709,4699),(79710,4700),(79711,4701),(79712,4702),(79713,4703),(79714,4704),(79715,4705),(79716,4706),(79717,4707),(79718,4708),(79719,4709),(79720,4710),(79721,4711),(79722,4712),(79723,4713),(79724,4714),(79725,4715),(79726,4716),(79727,4717),(79728,4718),(79729,4719),(79730,4720),(79731,4721),(79732,4722),(79733,4723),(79734,4724),(79735,4725),(79736,4726),(79737,4727),(79738,4728),(79739,4729),(79740,4730),(79741,4731),(79742,4732),(79743,4733),(79744,4734),(79745,4735),(79746,4736),(79747,4737),(79748,4738),(79749,4739),(79750,4740),(79751,4741),(79752,4742),(79753,4743),(79754,4744),(79755,4745),(79756,4746),(79757,4747),(79758,4748),(79759,4749),(79760,4750),(79761,4751),(79762,4752),(79763,4753),(79764,4754),(79765,4755),(79766,4756),(79767,4757),(79768,4758),(79769,4759),(79770,4760),(79771,4761),(79772,4762),(79773,4763),(79774,4764),(79775,4765),(79776,4766),(79777,4767),(79778,4768),(79779,4769),(79780,4770),(79781,4771),(79782,4772),(79783,4773),(79784,4774),(79785,4775),(79786,4776),(79787,4777),(79788,4778),(79789,4779),(79790,4680),(79791,4680),(79792,4680),(79793,4680),(79794,4680),(79795,4680),(79796,4681),(79797,4681),(79798,4681),(79799,4681),(79800,4681),(79801,4681),(79802,4682),(79803,4682),(79804,4682),(79805,4682),(79806,4682),(79807,4682),(79808,4683),(79809,4683),(79810,4683),(79811,4683),(79812,4683),(79813,4683),(79814,4684),(79815,4684),(79816,4684),(79817,4684),(79818,4684),(79819,4684),(79820,4685),(79821,4685),(79822,4685),(79823,4685),(79824,4685),(79825,4685),(79826,4686),(79827,4686),(79828,4686),(79829,4686),(79830,4686),(79831,4686),(79832,4687),(79833,4687),(79834,4687),(79835,4687),(79836,4687),(79837,4687),(79838,4688),(79839,4688),(79840,4688),(79841,4688),(79842,4688),(79843,4688),(79844,4689),(79845,4689),(79846,4689),(79847,4689),(79848,4689),(79849,4689),(79850,4690),(79851,4690),(79852,4690),(79853,4690),(79854,4690),(79855,4690),(79856,4691),(79857,4691),(79858,4691),(79859,4691),(79860,4691),(79861,4691),(79862,4692),(79863,4692),(79864,4692),(79865,4692),(79866,4692),(79867,4692),(79868,4693),(79869,4693),(79870,4693),(79871,4693),(79872,4693),(79873,4693),(79874,4694),(79875,4694),(79876,4694),(79877,4694),(79878,4694),(79879,4694),(79880,4695),(79881,4695),(79882,4695),(79883,4695),(79884,4695),(79885,4695),(79886,4696),(79887,4696),(79888,4696),(79889,4696),(79890,4696),(79891,4696),(79892,4697),(79893,4697),(79894,4697),(79895,4697),(79896,4697),(79897,4697),(79898,4698),(79899,4698),(79900,4698),(79901,4698),(79902,4698),(79903,4698),(79904,4699),(79905,4699),(79906,4699),(79907,4699),(79908,4699),(79909,4699),(79910,4700),(79911,4700),(79912,4700),(79913,4700),(79914,4700),(79915,4700),(79916,4701),(79917,4701),(79918,4701),(79919,4701),(79920,4701),(79921,4701),(79922,4702),(79923,4702),(79924,4702),(79925,4702),(79926,4702),(79927,4702),(79928,4703),(79929,4703),(79930,4703),(79931,4703),(79932,4703),(79933,4703),(79934,4704),(79935,4704),(79936,4704),(79937,4704),(79938,4704),(79939,4704),(79940,4705),(79941,4705),(79942,4705),(79943,4705),(79944,4705),(79945,4705),(79946,4706),(79947,4706),(79948,4706),(79949,4706),(79950,4706),(79951,4706),(79952,4707),(79953,4707),(79954,4707),(79955,4707),(79956,4707),(79957,4707),(79958,4708),(79959,4708),(79960,4708),(79961,4708),(79962,4708),(79963,4708),(79964,4709),(79965,4709),(79966,4709),(79967,4709),(79968,4709),(79969,4709),(79970,4710),(79971,4710),(79972,4710),(79973,4710),(79974,4710),(79975,4710),(79976,4711),(79977,4711),(79978,4711),(79979,4711),(79980,4711),(79981,4711),(79982,4712),(79983,4712),(79984,4712),(79985,4712),(79986,4712),(79987,4712),(79988,4713),(79989,4713),(79990,4713),(79991,4713),(79992,4713),(79993,4713),(79994,4714),(79995,4714),(79996,4714),(79997,4714),(79998,4714),(79999,4714),(80000,4715),(80001,4715),(80002,4715),(80003,4715),(80004,4715),(80005,4715),(80006,4716),(80007,4716),(80008,4716),(80009,4716),(80010,4716),(80011,4716),(80012,4717),(80013,4717),(80014,4717),(80015,4717),(80016,4717),(80017,4717),(80018,4718),(80019,4718),(80020,4718),(80021,4718),(80022,4718),(80023,4718),(80024,4719),(80025,4719),(80026,4719),(80027,4719),(80028,4719),(80029,4719),(80030,4720),(80031,4720),(80032,4720),(80033,4720),(80034,4720),(80035,4720),(80036,4721),(80037,4721),(80038,4721),(80039,4721),(80040,4722),(80041,4722),(80042,4722),(80043,4722),(80044,4722),(80045,4722),(80046,4723),(80047,4723),(80048,4723),(80049,4723),(80050,4723),(80051,4723),(80052,4724),(80053,4724),(80054,4724),(80055,4724),(80056,4724),(80057,4724),(80058,4725),(80059,4725),(80060,4725),(80061,4725),(80062,4726),(80063,4726),(80064,4726),(80065,4726),(80066,4727),(80067,4727),(80068,4727),(80069,4727),(80070,4728),(80071,4728),(80072,4728),(80073,4728),(80074,4729),(80075,4729),(80076,4729),(80077,4729),(80078,4730),(80079,4730),(80080,4730),(80081,4730),(80082,4730),(80083,4730),(80084,4731),(80085,4731),(80086,4731),(80087,4731),(80088,4731),(80089,4731),(80090,4732),(80091,4732),(80092,4732),(80093,4732),(80094,4732),(80095,4732),(80096,4733),(80097,4733),(80098,4733),(80099,4733),(80100,4733),(80101,4733),(80102,4734),(80103,4734),(80104,4734),(80105,4734),(80106,4734),(80107,4734),(80108,4735),(80109,4735),(80110,4735),(80111,4735),(80112,4735),(80113,4735),(80114,4736),(80115,4736),(80116,4736),(80117,4736),(80118,4736),(80119,4736),(80120,4737),(80121,4737),(80122,4737),(80123,4737),(80124,4737),(80125,4737),(80126,4738),(80127,4738),(80128,4738),(80129,4738),(80130,4738),(80131,4738),(80132,4739),(80133,4739),(80134,4739),(80135,4739),(80136,4739),(80137,4739),(80138,4740),(80139,4740),(80140,4740),(80141,4740),(80142,4740),(80143,4740),(80144,4741),(80145,4741),(80146,4741),(80147,4741),(80148,4741),(80149,4741),(80150,4742),(80151,4742),(80152,4742),(80153,4742),(80154,4742),(80155,4742),(80156,4743),(80157,4743),(80158,4743),(80159,4743),(80160,4743),(80161,4743),(80162,4744),(80163,4744),(80164,4744),(80165,4744),(80166,4744),(80167,4744),(80168,4745),(80169,4745),(80170,4745),(80171,4745),(80172,4746),(80173,4746),(80174,4746),(80175,4746),(80176,4746),(80177,4746),(80178,4747),(80179,4747),(80180,4747),(80181,4747),(80182,4747),(80183,4747),(80184,4748),(80185,4748),(80186,4748),(80187,4748),(80188,4748),(80189,4748),(80190,4749),(80191,4749),(80192,4749),(80193,4749),(80194,4749),(80195,4749),(80196,4750),(80197,4750),(80198,4750),(80199,4750),(80200,4750),(80201,4750),(80202,4751),(80203,4751),(80204,4751),(80205,4751),(80206,4751),(80207,4751),(80208,4752),(80209,4752),(80210,4752),(80211,4752),(80212,4752),(80213,4752),(80214,4753),(80215,4753),(80216,4753),(80217,4753),(80218,4753),(80219,4753),(80220,4754),(80221,4754),(80222,4754),(80223,4754),(80224,4754),(80225,4754),(80226,4755),(80227,4755),(80228,4755),(80229,4755),(80230,4755),(80231,4755),(80232,4756),(80233,4756),(80234,4756),(80235,4756),(80236,4756),(80237,4756),(80238,4757),(80239,4757),(80240,4757),(80241,4757),(80242,4757),(80243,4757),(80244,4758),(80245,4758),(80246,4758),(80247,4758),(80248,4758),(80249,4758),(80250,4759),(80251,4759),(80252,4759),(80253,4759),(80254,4759),(80255,4759),(80256,4760),(80257,4760),(80258,4760),(80259,4760),(80260,4760),(80261,4760),(80262,4761),(80263,4761),(80264,4761),(80265,4761),(80266,4761),(80267,4761),(80268,4762),(80269,4762),(80270,4762),(80271,4762),(80272,4762),(80273,4762),(80274,4763),(80275,4763),(80276,4763),(80277,4763),(80278,4763),(80279,4763),(80280,4764),(80281,4764),(80282,4764),(80283,4764),(80284,4764),(80285,4764),(80286,4765),(80287,4765),(80288,4765),(80289,4765),(80290,4766),(80291,4766),(80292,4766),(80293,4766),(80294,4766),(80295,4766),(80296,4767),(80297,4767),(80298,4767),(80299,4767),(80300,4767),(80301,4767),(80302,4768),(80303,4768),(80304,4768),(80305,4768),(80306,4768),(80307,4768),(80308,4769),(80309,4769),(80310,4769),(80311,4769),(80312,4769),(80313,4769),(80314,4770),(80315,4770),(80316,4770),(80317,4770),(80318,4770),(80319,4770),(80320,4771),(80321,4771),(80322,4771),(80323,4771),(80324,4771),(80325,4771),(80326,4772),(80327,4772),(80328,4772),(80329,4772),(80330,4772),(80331,4772),(80332,4773),(80333,4773),(80334,4773),(80335,4773),(80336,4773),(80337,4773),(80338,4774),(80339,4774),(80340,4774),(80341,4774),(80342,4774),(80343,4774),(80344,4775),(80345,4775),(80346,4775),(80347,4775),(80348,4775),(80349,4775),(80350,4776),(80351,4776),(80352,4776),(80353,4776),(80354,4776),(80355,4776),(80356,4777),(80357,4777),(80358,4777),(80359,4777),(80360,4777),(80361,4777),(80362,4778),(80363,4778),(80364,4778),(80365,4778),(80366,4778),(80367,4778),(80368,4779),(80369,4779),(80370,4779),(80371,4779),(80372,4779),(80373,4779),(80374,4680),(80375,4680),(80376,4680),(80377,4681),(80378,4681),(80379,4681),(80380,4682),(80381,4682),(80382,4682),(80383,4683),(80384,4683),(80385,4683),(80386,4684),(80387,4684),(80388,4684),(80389,4685),(80390,4685),(80391,4685),(80392,4686),(80393,4686),(80394,4686),(80395,4687),(80396,4687),(80397,4687),(80398,4688),(80399,4688),(80400,4688),(80401,4689),(80402,4689),(80403,4689),(80404,4690),(80405,4690),(80406,4690),(80407,4691),(80408,4691),(80409,4691),(80410,4692),(80411,4692),(80412,4692),(80413,4693),(80414,4693),(80415,4693),(80416,4694),(80417,4694),(80418,4694),(80419,4695),(80420,4695),(80421,4695),(80422,4696),(80423,4696),(80424,4696),(80425,4697),(80426,4697),(80427,4697),(80428,4698),(80429,4698),(80430,4698),(80431,4699),(80432,4699),(80433,4699),(80434,4700),(80435,4700),(80436,4700),(80437,4701),(80438,4701),(80439,4701),(80440,4702),(80441,4702),(80442,4702),(80443,4703),(80444,4703),(80445,4703),(80446,4704),(80447,4704),(80448,4704),(80449,4705),(80450,4705),(80451,4705),(80452,4706),(80453,4706),(80454,4706),(80455,4707),(80456,4707),(80457,4707),(80458,4708),(80459,4708),(80460,4708),(80461,4709),(80462,4709),(80463,4709),(80464,4710),(80465,4710),(80466,4710),(80467,4711),(80468,4711),(80469,4711),(80470,4712),(80471,4712),(80472,4712),(80473,4713),(80474,4713),(80475,4713),(80476,4714),(80477,4714),(80478,4714),(80479,4715),(80480,4715),(80481,4715),(80482,4716),(80483,4716),(80484,4716),(80485,4717),(80486,4717),(80487,4717),(80488,4718),(80489,4718),(80490,4718),(80491,4719),(80492,4719),(80493,4719),(80494,4720),(80495,4720),(80496,4720),(80497,4721),(80498,4721),(80499,4722),(80500,4722),(80501,4722),(80502,4723),(80503,4723),(80504,4723),(80505,4724),(80506,4724),(80507,4724),(80508,4725),(80509,4725),(80510,4726),(80511,4726),(80512,4727),(80513,4727),(80514,4728),(80515,4728),(80516,4729),(80517,4729),(80518,4730),(80519,4730),(80520,4730),(80521,4731),(80522,4731),(80523,4731),(80524,4732),(80525,4732),(80526,4732),(80527,4733),(80528,4733),(80529,4733),(80530,4734),(80531,4734),(80532,4734),(80533,4735),(80534,4735),(80535,4735),(80536,4736),(80537,4736),(80538,4736),(80539,4737),(80540,4737),(80541,4737),(80542,4738),(80543,4738),(80544,4738),(80545,4739),(80546,4739),(80547,4739),(80548,4740),(80549,4740),(80550,4740),(80551,4741),(80552,4741),(80553,4741),(80554,4742),(80555,4742),(80556,4742),(80557,4743),(80558,4743),(80559,4743),(80560,4744),(80561,4744),(80562,4744),(80563,4745),(80564,4745),(80565,4746),(80566,4746),(80567,4746),(80568,4747),(80569,4747),(80570,4747),(80571,4748),(80572,4748),(80573,4748),(80574,4749),(80575,4749),(80576,4749),(80577,4750),(80578,4750),(80579,4750),(80580,4751),(80581,4751),(80582,4751),(80583,4752),(80584,4752),(80585,4752),(80586,4753),(80587,4753),(80588,4753),(80589,4754),(80590,4754),(80591,4754),(80592,4755),(80593,4755),(80594,4756),(80595,4756),(80596,4757),(80597,4757),(80598,4757),(80599,4758),(80600,4758),(80601,4758),(80602,4759),(80603,4759),(80604,4759),(80605,4760),(80606,4760),(80607,4760),(80608,4761),(80609,4761),(80610,4761),(80611,4762),(80612,4762),(80613,4762),(80614,4763),(80615,4763),(80616,4763),(80617,4764),(80618,4764),(80619,4764),(80620,4765),(80621,4765),(80622,4766),(80623,4766),(80624,4766),(80625,4767),(80626,4767),(80627,4767),(80628,4768),(80629,4768),(80630,4768),(80631,4769),(80632,4769),(80633,4769),(80634,4770),(80635,4770),(80636,4770),(80637,4771),(80638,4771),(80639,4771),(80640,4772),(80641,4772),(80642,4772),(80643,4773),(80644,4773),(80645,4773),(80646,4774),(80647,4774),(80648,4774),(80649,4775),(80650,4775),(80651,4775),(80652,4776),(80653,4776),(80654,4776),(80655,4777),(80656,4777),(80657,4777),(80658,4778),(80659,4778),(80660,4778),(80661,4779),(80662,4779),(80663,4779),(80664,4680),(80665,4680),(80666,4680),(80667,4681),(80668,4681),(80669,4681),(80670,4682),(80671,4682),(80672,4682),(80673,4683),(80674,4683),(80675,4683),(80676,4684),(80677,4684),(80678,4684),(80679,4685),(80680,4685),(80681,4685),(80682,4686),(80683,4686),(80684,4686),(80685,4687),(80686,4687),(80687,4687),(80688,4688),(80689,4688),(80690,4688),(80691,4689),(80692,4689),(80693,4689),(80694,4690),(80695,4690),(80696,4690),(80697,4691),(80698,4691),(80699,4691),(80700,4692),(80701,4692),(80702,4692),(80703,4693),(80704,4693),(80705,4693),(80706,4694),(80707,4694),(80708,4694),(80709,4695),(80710,4695),(80711,4695),(80712,4696),(80713,4696),(80714,4696),(80715,4697),(80716,4697),(80717,4697),(80718,4698),(80719,4698),(80720,4698),(80721,4699),(80722,4699),(80723,4699),(80724,4700),(80725,4700),(80726,4700),(80727,4701),(80728,4701),(80729,4701),(80730,4702),(80731,4702),(80732,4702),(80733,4703),(80734,4703),(80735,4703),(80736,4704),(80737,4704),(80738,4704),(80739,4705),(80740,4705),(80741,4705),(80742,4706),(80743,4706),(80744,4706),(80745,4707),(80746,4707),(80747,4707),(80748,4708),(80749,4708),(80750,4708),(80751,4709),(80752,4709),(80753,4709),(80754,4710),(80755,4710),(80756,4710),(80757,4711),(80758,4711),(80759,4711),(80760,4712),(80761,4712),(80762,4712),(80763,4713),(80764,4713),(80765,4713),(80766,4714),(80767,4714),(80768,4714),(80769,4715),(80770,4715),(80771,4715),(80772,4716),(80773,4716),(80774,4716),(80775,4717),(80776,4717),(80777,4717),(80778,4718),(80779,4718),(80780,4718),(80781,4719),(80782,4719),(80783,4719),(80784,4720),(80785,4720),(80786,4720),(80787,4721),(80788,4721),(80789,4721),(80790,4722),(80791,4722),(80792,4722),(80793,4723),(80794,4723),(80795,4723),(80796,4724),(80797,4724),(80798,4724),(80799,4725),(80800,4725),(80801,4725),(80802,4726),(80803,4726),(80804,4726),(80805,4727),(80806,4727),(80807,4727),(80808,4728),(80809,4728),(80810,4728),(80811,4729),(80812,4729),(80813,4729),(80814,4730),(80815,4730),(80816,4730),(80817,4731),(80818,4731),(80819,4731),(80820,4732),(80821,4732),(80822,4732),(80823,4733),(80824,4733),(80825,4733),(80826,4734),(80827,4734),(80828,4734),(80829,4735),(80830,4735),(80831,4735),(80832,4736),(80833,4736),(80834,4736),(80835,4737),(80836,4737),(80837,4737),(80838,4738),(80839,4738),(80840,4738),(80841,4739),(80842,4739),(80843,4739),(80844,4740),(80845,4740),(80846,4740),(80847,4741),(80848,4741),(80849,4741),(80850,4742),(80851,4742),(80852,4742),(80853,4743),(80854,4743),(80855,4743),(80856,4744),(80857,4744),(80858,4744),(80859,4745),(80860,4745),(80861,4745),(80862,4746),(80863,4746),(80864,4746),(80865,4747),(80866,4747),(80867,4747),(80868,4748),(80869,4748),(80870,4748),(80871,4749),(80872,4749),(80873,4749),(80874,4750),(80875,4750),(80876,4750),(80877,4751),(80878,4751),(80879,4751),(80880,4752),(80881,4752),(80882,4752),(80883,4753),(80884,4753),(80885,4753),(80886,4754),(80887,4754),(80888,4754),(80889,4755),(80890,4755),(80891,4755),(80892,4756),(80893,4756),(80894,4756),(80895,4757),(80896,4757),(80897,4757),(80898,4758),(80899,4758),(80900,4758),(80901,4759),(80902,4759),(80903,4759),(80904,4760),(80905,4760),(80906,4760),(80907,4761),(80908,4761),(80909,4761),(80910,4762),(80911,4762),(80912,4762),(80913,4763),(80914,4763),(80915,4763),(80916,4764),(80917,4764),(80918,4764),(80919,4765),(80920,4765),(80921,4765),(80922,4766),(80923,4766),(80924,4766),(80925,4767),(80926,4767),(80927,4767),(80928,4768),(80929,4768),(80930,4768),(80931,4769),(80932,4769),(80933,4769),(80934,4770),(80935,4770),(80936,4770),(80937,4771),(80938,4771),(80939,4771),(80940,4772),(80941,4772),(80942,4772),(80943,4773),(80944,4773),(80945,4773),(80946,4774),(80947,4774),(80948,4774),(80949,4775),(80950,4775),(80951,4775),(80952,4776),(80953,4776),(80954,4776),(80955,4777),(80956,4777),(80957,4777),(80958,4778),(80959,4778),(80960,4778),(80961,4779),(80962,4779),(80963,4779),(80964,4680),(80965,4680),(80966,4680),(80967,4680),(80968,4681),(80969,4681),(80970,4681),(80971,4681),(80972,4682),(80973,4682),(80974,4682),(80975,4682),(80976,4683),(80977,4683),(80978,4683),(80979,4683),(80980,4684),(80981,4684),(80982,4684),(80983,4684),(80984,4685),(80985,4685),(80986,4685),(80987,4685),(80988,4686),(80989,4686),(80990,4686),(80991,4686),(80992,4687),(80993,4687),(80994,4687),(80995,4687),(80996,4688),(80997,4688),(80998,4688),(80999,4688),(81000,4689),(81001,4689),(81002,4689),(81003,4689),(81004,4690),(81005,4690),(81006,4690),(81007,4690),(81008,4691),(81009,4691),(81010,4691),(81011,4691),(81012,4692),(81013,4692),(81014,4692),(81015,4692),(81016,4693),(81017,4693),(81018,4693),(81019,4693),(81020,4694),(81021,4694),(81022,4694),(81023,4694),(81024,4695),(81025,4695),(81026,4695),(81027,4695),(81028,4696),(81029,4696),(81030,4696),(81031,4696),(81032,4697),(81033,4697),(81034,4697),(81035,4697),(81036,4698),(81037,4698),(81038,4698),(81039,4698),(81040,4699),(81041,4699),(81042,4699),(81043,4699),(81044,4700),(81045,4700),(81046,4700),(81047,4700),(81048,4701),(81049,4701),(81050,4701),(81051,4701),(81052,4702),(81053,4702),(81054,4702),(81055,4702),(81056,4703),(81057,4703),(81058,4703),(81059,4703),(81060,4704),(81061,4704),(81062,4704),(81063,4704),(81064,4705),(81065,4705),(81066,4705),(81067,4705),(81068,4706),(81069,4706),(81070,4706),(81071,4706),(81072,4707),(81073,4707),(81074,4707),(81075,4707),(81076,4708),(81077,4708),(81078,4708),(81079,4708),(81080,4709),(81081,4709),(81082,4709),(81083,4709),(81084,4710),(81085,4710),(81086,4710),(81087,4710),(81088,4711),(81089,4711),(81090,4711),(81091,4711),(81092,4712),(81093,4712),(81094,4712),(81095,4712),(81096,4713),(81097,4713),(81098,4713),(81099,4713),(81100,4714),(81101,4714),(81102,4714),(81103,4714),(81104,4715),(81105,4715),(81106,4715),(81107,4715),(81108,4716),(81109,4716),(81110,4716),(81111,4716),(81112,4717),(81113,4717),(81114,4717),(81115,4717),(81116,4718),(81117,4718),(81118,4718),(81119,4718),(81120,4719),(81121,4719),(81122,4719),(81123,4719),(81124,4720),(81125,4720),(81126,4720),(81127,4720),(81128,4721),(81129,4721),(81130,4721),(81131,4721),(81132,4722),(81133,4722),(81134,4722),(81135,4722),(81136,4723),(81137,4723),(81138,4723),(81139,4723),(81140,4724),(81141,4724),(81142,4724),(81143,4724),(81144,4725),(81145,4725),(81146,4725),(81147,4725),(81148,4726),(81149,4726),(81150,4726),(81151,4726),(81152,4727),(81153,4727),(81154,4727),(81155,4727),(81156,4728),(81157,4728),(81158,4728),(81159,4728),(81160,4729),(81161,4729),(81162,4729),(81163,4729),(81164,4730),(81165,4730),(81166,4730),(81167,4730),(81168,4731),(81169,4731),(81170,4731),(81171,4731),(81172,4732),(81173,4732),(81174,4732),(81175,4732),(81176,4733),(81177,4733),(81178,4733),(81179,4733),(81180,4734),(81181,4734),(81182,4734),(81183,4734),(81184,4735),(81185,4735),(81186,4735),(81187,4735),(81188,4736),(81189,4736),(81190,4736),(81191,4736),(81192,4737),(81193,4737),(81194,4737),(81195,4737),(81196,4738),(81197,4738),(81198,4738),(81199,4738),(81200,4739),(81201,4739),(81202,4739),(81203,4739),(81204,4740),(81205,4740),(81206,4740),(81207,4740),(81208,4741),(81209,4741),(81210,4741),(81211,4741),(81212,4742),(81213,4742),(81214,4742),(81215,4742),(81216,4743),(81217,4743),(81218,4743),(81219,4743),(81220,4744),(81221,4744),(81222,4744),(81223,4744),(81224,4745),(81225,4745),(81226,4745),(81227,4745),(81228,4746),(81229,4746),(81230,4746),(81231,4746),(81232,4747),(81233,4747),(81234,4747),(81235,4747),(81236,4748),(81237,4748),(81238,4748),(81239,4748),(81240,4749),(81241,4749),(81242,4749),(81243,4749),(81244,4750),(81245,4750),(81246,4750),(81247,4750),(81248,4751),(81249,4751),(81250,4751),(81251,4751),(81252,4752),(81253,4752),(81254,4752),(81255,4752),(81256,4753),(81257,4753),(81258,4753),(81259,4753),(81260,4754),(81261,4754),(81262,4754),(81263,4754),(81264,4755),(81265,4755),(81266,4755),(81267,4755),(81268,4756),(81269,4756),(81270,4756),(81271,4756),(81272,4757),(81273,4757),(81274,4757),(81275,4757),(81276,4758),(81277,4758),(81278,4758),(81279,4758),(81280,4759),(81281,4759),(81282,4759),(81283,4759),(81284,4760),(81285,4760),(81286,4760),(81287,4760),(81288,4761),(81289,4761),(81290,4761),(81291,4761),(81292,4762),(81293,4762),(81294,4762),(81295,4762),(81296,4763),(81297,4763),(81298,4763),(81299,4763),(81300,4764),(81301,4764),(81302,4764),(81303,4764),(81304,4765),(81305,4765),(81306,4765),(81307,4765),(81308,4766),(81309,4766),(81310,4766),(81311,4766),(81312,4767),(81313,4767),(81314,4767),(81315,4767),(81316,4768),(81317,4768),(81318,4768),(81319,4768),(81320,4769),(81321,4769),(81322,4769),(81323,4769),(81324,4770),(81325,4770),(81326,4770),(81327,4770),(81328,4771),(81329,4771),(81330,4771),(81331,4771),(81332,4772),(81333,4772),(81334,4772),(81335,4772),(81336,4773),(81337,4773),(81338,4773),(81339,4773),(81340,4774),(81341,4774),(81342,4774),(81343,4774),(81344,4775),(81345,4775),(81346,4775),(81347,4775),(81348,4776),(81349,4776),(81350,4776),(81351,4776),(81352,4777),(81353,4777),(81354,4777),(81355,4777),(81356,4778),(81357,4778),(81358,4778),(81359,4778),(81360,4779),(81361,4779),(81362,4779),(81363,4779),(81364,4780),(81365,4781),(81366,4782),(81367,4783),(81368,4784),(81369,4785),(81370,4786),(81371,4787),(81372,4788),(81373,4789),(81374,4790),(81375,4791),(81376,4792),(81377,4793),(81378,4794),(81379,4795),(81380,4796),(81381,4797),(81382,4798),(81383,4799),(81384,4800),(81385,4801),(81386,4802),(81387,4803),(81388,4804),(81389,4805),(81390,4806),(81391,4807),(81392,4808),(81393,4809),(81394,4810),(81395,4811),(81396,4812),(81397,4813),(81398,4814),(81399,4815),(81400,4816),(81401,4817),(81402,4818),(81403,4819),(81404,4820),(81405,4821),(81406,4822),(81407,4823),(81408,4824),(81409,4825),(81410,4826),(81411,4827),(81412,4828),(81413,4829),(81414,4830),(81415,4831),(81416,4832),(81417,4833),(81418,4834),(81419,4835),(81420,4836),(81421,4837),(81422,4838),(81423,4839),(81424,4840),(81425,4841),(81426,4842),(81427,4843),(81428,4844),(81429,4845),(81430,4846),(81431,4847),(81432,4848),(81433,4849),(81434,4850),(81435,4851),(81436,4852),(81437,4853),(81438,4854),(81439,4855),(81440,4856),(81441,4857),(81442,4858),(81443,4859),(81444,4860),(81445,4861),(81446,4862),(81447,4863),(81448,4864),(81449,4865),(81450,4866),(81451,4867),(81452,4868),(81453,4869),(81454,4870),(81455,4871),(81456,4872),(81457,4873),(81458,4874),(81459,4875),(81460,4876),(81461,4877),(81462,4878),(81463,4879),(81464,4780),(81465,4780),(81466,4780),(81467,4780),(81468,4780),(81469,4780),(81470,4781),(81471,4781),(81472,4781),(81473,4781),(81474,4781),(81475,4781),(81476,4782),(81477,4782),(81478,4782),(81479,4782),(81480,4782),(81481,4782),(81482,4783),(81483,4783),(81484,4783),(81485,4783),(81486,4783),(81487,4783),(81488,4784),(81489,4784),(81490,4784),(81491,4784),(81492,4784),(81493,4784),(81494,4785),(81495,4785),(81496,4785),(81497,4785),(81498,4785),(81499,4785),(81500,4786),(81501,4786),(81502,4786),(81503,4786),(81504,4786),(81505,4786),(81506,4787),(81507,4787),(81508,4787),(81509,4787),(81510,4787),(81511,4787),(81512,4788),(81513,4788),(81514,4788),(81515,4788),(81516,4788),(81517,4788),(81518,4789),(81519,4789),(81520,4789),(81521,4789),(81522,4789),(81523,4789),(81524,4790),(81525,4790),(81526,4790),(81527,4790),(81528,4790),(81529,4790),(81530,4791),(81531,4791),(81532,4791),(81533,4791),(81534,4791),(81535,4791),(81536,4792),(81537,4792),(81538,4792),(81539,4792),(81540,4792),(81541,4792),(81542,4793),(81543,4793),(81544,4793),(81545,4793),(81546,4793),(81547,4793),(81548,4794),(81549,4794),(81550,4794),(81551,4794),(81552,4794),(81553,4794),(81554,4795),(81555,4795),(81556,4795),(81557,4795),(81558,4795),(81559,4795),(81560,4796),(81561,4796),(81562,4796),(81563,4796),(81564,4796),(81565,4796),(81566,4797),(81567,4797),(81568,4797),(81569,4797),(81570,4797),(81571,4797),(81572,4798),(81573,4798),(81574,4798),(81575,4798),(81576,4798),(81577,4798),(81578,4799),(81579,4799),(81580,4799),(81581,4799),(81582,4799),(81583,4799),(81584,4800),(81585,4800),(81586,4800),(81587,4800),(81588,4800),(81589,4800),(81590,4801),(81591,4801),(81592,4801),(81593,4801),(81594,4801),(81595,4801),(81596,4802),(81597,4802),(81598,4802),(81599,4802),(81600,4802),(81601,4802),(81602,4803),(81603,4803),(81604,4803),(81605,4803),(81606,4803),(81607,4803),(81608,4804),(81609,4804),(81610,4804),(81611,4804),(81612,4804),(81613,4804),(81614,4805),(81615,4805),(81616,4805),(81617,4805),(81618,4806),(81619,4806),(81620,4806),(81621,4806),(81622,4807),(81623,4807),(81624,4807),(81625,4807),(81626,4808),(81627,4808),(81628,4808),(81629,4808),(81630,4809),(81631,4809),(81632,4809),(81633,4809),(81634,4809),(81635,4809),(81636,4810),(81637,4810),(81638,4810),(81639,4810),(81640,4810),(81641,4810),(81642,4811),(81643,4811),(81644,4811),(81645,4811),(81646,4811),(81647,4811),(81648,4812),(81649,4812),(81650,4812),(81651,4812),(81652,4812),(81653,4812),(81654,4813),(81655,4813),(81656,4813),(81657,4813),(81658,4813),(81659,4813),(81660,4814),(81661,4814),(81662,4814),(81663,4814),(81664,4814),(81665,4814),(81666,4815),(81667,4815),(81668,4815),(81669,4815),(81670,4815),(81671,4815),(81672,4816),(81673,4816),(81674,4816),(81675,4816),(81676,4816),(81677,4816),(81678,4817),(81679,4817),(81680,4817),(81681,4817),(81682,4817),(81683,4817),(81684,4818),(81685,4818),(81686,4818),(81687,4818),(81688,4818),(81689,4818),(81690,4819),(81691,4819),(81692,4819),(81693,4819),(81694,4819),(81695,4819),(81696,4820),(81697,4820),(81698,4820),(81699,4820),(81700,4820),(81701,4820),(81702,4821),(81703,4821),(81704,4821),(81705,4821),(81706,4821),(81707,4821),(81708,4822),(81709,4822),(81710,4822),(81711,4822),(81712,4822),(81713,4822),(81714,4823),(81715,4823),(81716,4823),(81717,4823),(81718,4823),(81719,4823),(81720,4824),(81721,4824),(81722,4824),(81723,4824),(81724,4825),(81725,4825),(81726,4825),(81727,4825),(81728,4826),(81729,4826),(81730,4826),(81731,4826),(81732,4827),(81733,4827),(81734,4827),(81735,4827),(81736,4828),(81737,4828),(81738,4828),(81739,4828),(81740,4829),(81741,4829),(81742,4829),(81743,4829),(81744,4830),(81745,4830),(81746,4830),(81747,4830),(81748,4831),(81749,4831),(81750,4831),(81751,4831),(81752,4832),(81753,4832),(81754,4832),(81755,4832),(81756,4833),(81757,4833),(81758,4833),(81759,4833),(81760,4834),(81761,4834),(81762,4834),(81763,4834),(81764,4834),(81765,4834),(81766,4835),(81767,4835),(81768,4835),(81769,4835),(81770,4835),(81771,4835),(81772,4836),(81773,4836),(81774,4836),(81775,4836),(81776,4836),(81777,4836),(81778,4837),(81779,4837),(81780,4837),(81781,4837),(81782,4837),(81783,4837),(81784,4838),(81785,4838),(81786,4838),(81787,4838),(81788,4838),(81789,4838),(81790,4839),(81791,4839),(81792,4839),(81793,4839),(81794,4839),(81795,4839),(81796,4840),(81797,4840),(81798,4840),(81799,4840),(81800,4840),(81801,4840),(81802,4841),(81803,4841),(81804,4841),(81805,4841),(81806,4841),(81807,4841),(81808,4842),(81809,4842),(81810,4842),(81811,4842),(81812,4842),(81813,4842),(81814,4843),(81815,4843),(81816,4843),(81817,4843),(81818,4843),(81819,4843),(81820,4844),(81821,4844),(81822,4844),(81823,4844),(81824,4845),(81825,4845),(81826,4845),(81827,4845),(81828,4845),(81829,4845),(81830,4846),(81831,4846),(81832,4846),(81833,4846),(81834,4846),(81835,4846),(81836,4847),(81837,4847),(81838,4847),(81839,4847),(81840,4847),(81841,4847),(81842,4848),(81843,4848),(81844,4848),(81845,4848),(81846,4848),(81847,4848),(81848,4849),(81849,4849),(81850,4849),(81851,4849),(81852,4849),(81853,4849),(81854,4850),(81855,4850),(81856,4850),(81857,4850),(81858,4850),(81859,4850),(81860,4851),(81861,4851),(81862,4851),(81863,4851),(81864,4851),(81865,4851),(81866,4852),(81867,4852),(81868,4852),(81869,4852),(81870,4852),(81871,4852),(81872,4853),(81873,4853),(81874,4853),(81875,4853),(81876,4853),(81877,4853),(81878,4854),(81879,4854),(81880,4854),(81881,4854),(81882,4854),(81883,4854),(81884,4855),(81885,4855),(81886,4855),(81887,4855),(81888,4855),(81889,4855),(81890,4856),(81891,4856),(81892,4856),(81893,4856),(81894,4856),(81895,4856),(81896,4857),(81897,4857),(81898,4857),(81899,4857),(81900,4857),(81901,4857),(81902,4858),(81903,4858),(81904,4858),(81905,4858),(81906,4858),(81907,4858),(81908,4859),(81909,4859),(81910,4859),(81911,4859),(81912,4859),(81913,4859),(81914,4860),(81915,4860),(81916,4860),(81917,4860),(81918,4860),(81919,4860),(81920,4861),(81921,4861),(81922,4861),(81923,4861),(81924,4861),(81925,4861),(81926,4862),(81927,4862),(81928,4862),(81929,4862),(81930,4862),(81931,4862),(81932,4863),(81933,4863),(81934,4863),(81935,4863),(81936,4863),(81937,4863),(81938,4864),(81939,4864),(81940,4864),(81941,4864),(81942,4864),(81943,4864),(81944,4865),(81945,4865),(81946,4865),(81947,4865),(81948,4865),(81949,4865),(81950,4866),(81951,4866),(81952,4866),(81953,4866),(81954,4866),(81955,4866),(81956,4867),(81957,4867),(81958,4867),(81959,4867),(81960,4867),(81961,4867),(81962,4868),(81963,4868),(81964,4868),(81965,4868),(81966,4868),(81967,4868),(81968,4869),(81969,4869),(81970,4869),(81971,4869),(81972,4869),(81973,4869),(81974,4870),(81975,4870),(81976,4870),(81977,4870),(81978,4870),(81979,4870),(81980,4871),(81981,4871),(81982,4871),(81983,4871),(81984,4871),(81985,4871),(81986,4872),(81987,4872),(81988,4872),(81989,4872),(81990,4872),(81991,4872),(81992,4873),(81993,4873),(81994,4873),(81995,4873),(81996,4873),(81997,4873),(81998,4874),(81999,4874),(82000,4874),(82001,4874),(82002,4874),(82003,4874),(82004,4875),(82005,4875),(82006,4875),(82007,4875),(82008,4875),(82009,4875),(82010,4876),(82011,4876),(82012,4876),(82013,4876),(82014,4876),(82015,4876),(82016,4877),(82017,4877),(82018,4877),(82019,4877),(82020,4877),(82021,4877),(82022,4878),(82023,4878),(82024,4878),(82025,4878),(82026,4878),(82027,4878),(82028,4879),(82029,4879),(82030,4879),(82031,4879),(82032,4879),(82033,4879),(82034,4780),(82035,4780),(82036,4780),(82037,4781),(82038,4781),(82039,4781),(82040,4782),(82041,4782),(82042,4782),(82043,4783),(82044,4783),(82045,4783),(82046,4784),(82047,4784),(82048,4784),(82049,4785),(82050,4785),(82051,4785),(82052,4786),(82053,4786),(82054,4786),(82055,4787),(82056,4787),(82057,4787),(82058,4788),(82059,4788),(82060,4788),(82061,4789),(82062,4789),(82063,4789),(82064,4790),(82065,4790),(82066,4790),(82067,4791),(82068,4791),(82069,4792),(82070,4792),(82071,4792),(82072,4793),(82073,4793),(82074,4793),(82075,4794),(82076,4794),(82077,4794),(82078,4795),(82079,4795),(82080,4795),(82081,4796),(82082,4796),(82083,4796),(82084,4797),(82085,4797),(82086,4797),(82087,4798),(82088,4798),(82089,4798),(82090,4799),(82091,4799),(82092,4799),(82093,4800),(82094,4800),(82095,4800),(82096,4801),(82097,4801),(82098,4801),(82099,4802),(82100,4802),(82101,4802),(82102,4803),(82103,4803),(82104,4803),(82105,4804),(82106,4804),(82107,4804),(82108,4805),(82109,4805),(82110,4806),(82111,4806),(82112,4807),(82113,4807),(82114,4808),(82115,4808),(82116,4809),(82117,4809),(82118,4809),(82119,4810),(82120,4810),(82121,4810),(82122,4811),(82123,4811),(82124,4811),(82125,4812),(82126,4812),(82127,4812),(82128,4813),(82129,4813),(82130,4813),(82131,4814),(82132,4814),(82133,4814),(82134,4815),(82135,4815),(82136,4815),(82137,4816),(82138,4816),(82139,4816),(82140,4817),(82141,4817),(82142,4817),(82143,4818),(82144,4818),(82145,4818),(82146,4819),(82147,4819),(82148,4819),(82149,4820),(82150,4820),(82151,4820),(82152,4821),(82153,4821),(82154,4821),(82155,4822),(82156,4822),(82157,4822),(82158,4823),(82159,4823),(82160,4824),(82161,4824),(82162,4825),(82163,4825),(82164,4826),(82165,4826),(82166,4827),(82167,4827),(82168,4828),(82169,4828),(82170,4829),(82171,4829),(82172,4830),(82173,4830),(82174,4831),(82175,4831),(82176,4832),(82177,4832),(82178,4833),(82179,4833),(82180,4834),(82181,4834),(82182,4835),(82183,4835),(82184,4836),(82185,4836),(82186,4837),(82187,4837),(82188,4838),(82189,4838),(82190,4839),(82191,4839),(82192,4840),(82193,4840),(82194,4841),(82195,4841),(82196,4842),(82197,4842),(82198,4843),(82199,4843),(82200,4843),(82201,4844),(82202,4844),(82203,4845),(82204,4845),(82205,4845),(82206,4846),(82207,4846),(82208,4846),(82209,4847),(82210,4847),(82211,4847),(82212,4848),(82213,4848),(82214,4848),(82215,4849),(82216,4849),(82217,4849),(82218,4850),(82219,4850),(82220,4850),(82221,4851),(82222,4851),(82223,4851),(82224,4852),(82225,4852),(82226,4852),(82227,4853),(82228,4853),(82229,4853),(82230,4854),(82231,4854),(82232,4854),(82233,4855),(82234,4855),(82235,4855),(82236,4856),(82237,4856),(82238,4856),(82239,4857),(82240,4857),(82241,4857),(82242,4858),(82243,4858),(82244,4858),(82245,4859),(82246,4859),(82247,4859),(82248,4860),(82249,4860),(82250,4860),(82251,4861),(82252,4861),(82253,4861),(82254,4862),(82255,4862),(82256,4862),(82257,4863),(82258,4863),(82259,4863),(82260,4864),(82261,4864),(82262,4864),(82263,4865),(82264,4865),(82265,4865),(82266,4866),(82267,4866),(82268,4866),(82269,4867),(82270,4867),(82271,4867),(82272,4868),(82273,4868),(82274,4868),(82275,4869),(82276,4869),(82277,4870),(82278,4870),(82279,4871),(82280,4871),(82281,4872),(82282,4872),(82283,4873),(82284,4873),(82285,4873),(82286,4874),(82287,4874),(82288,4875),(82289,4875),(82290,4876),(82291,4876),(82292,4876),(82293,4877),(82294,4877),(82295,4877),(82296,4878),(82297,4878),(82298,4878),(82299,4879),(82300,4879),(82301,4879),(82302,4780),(82303,4780),(82304,4780),(82305,4781),(82306,4781),(82307,4781),(82308,4782),(82309,4782),(82310,4782),(82311,4783),(82312,4783),(82313,4783),(82314,4784),(82315,4784),(82316,4784),(82317,4785),(82318,4785),(82319,4785),(82320,4786),(82321,4786),(82322,4786),(82323,4787),(82324,4787),(82325,4787),(82326,4788),(82327,4788),(82328,4788),(82329,4789),(82330,4789),(82331,4789),(82332,4790),(82333,4790),(82334,4790),(82335,4791),(82336,4791),(82337,4791),(82338,4792),(82339,4792),(82340,4792),(82341,4793),(82342,4793),(82343,4793),(82344,4794),(82345,4794),(82346,4794),(82347,4795),(82348,4795),(82349,4795),(82350,4796),(82351,4796),(82352,4796),(82353,4797),(82354,4797),(82355,4797),(82356,4798),(82357,4798),(82358,4798),(82359,4799),(82360,4799),(82361,4799),(82362,4800),(82363,4800),(82364,4800),(82365,4801),(82366,4801),(82367,4801),(82368,4802),(82369,4802),(82370,4802),(82371,4803),(82372,4803),(82373,4803),(82374,4804),(82375,4804),(82376,4804),(82377,4805),(82378,4805),(82379,4805),(82380,4806),(82381,4806),(82382,4806),(82383,4807),(82384,4807),(82385,4807),(82386,4808),(82387,4808),(82388,4808),(82389,4809),(82390,4809),(82391,4809),(82392,4810),(82393,4810),(82394,4810),(82395,4811),(82396,4811),(82397,4811),(82398,4812),(82399,4812),(82400,4812),(82401,4813),(82402,4813),(82403,4813),(82404,4814),(82405,4814),(82406,4814),(82407,4815),(82408,4815),(82409,4815),(82410,4816),(82411,4816),(82412,4816),(82413,4817),(82414,4817),(82415,4817),(82416,4818),(82417,4818),(82418,4818),(82419,4819),(82420,4819),(82421,4819),(82422,4820),(82423,4820),(82424,4820),(82425,4821),(82426,4821),(82427,4821),(82428,4822),(82429,4822),(82430,4822),(82431,4823),(82432,4823),(82433,4823),(82434,4824),(82435,4824),(82436,4824),(82437,4825),(82438,4825),(82439,4825),(82440,4826),(82441,4826),(82442,4826),(82443,4827),(82444,4827),(82445,4827),(82446,4828),(82447,4828),(82448,4828),(82449,4829),(82450,4829),(82451,4829),(82452,4830),(82453,4830),(82454,4830),(82455,4831),(82456,4831),(82457,4831),(82458,4832),(82459,4832),(82460,4832),(82461,4833),(82462,4833),(82463,4833),(82464,4834),(82465,4834),(82466,4834),(82467,4835),(82468,4835),(82469,4835),(82470,4836),(82471,4836),(82472,4836),(82473,4837),(82474,4837),(82475,4837),(82476,4838),(82477,4838),(82478,4838),(82479,4839),(82480,4839),(82481,4839),(82482,4840),(82483,4840),(82484,4840),(82485,4841),(82486,4841),(82487,4841),(82488,4842),(82489,4842),(82490,4842),(82491,4843),(82492,4843),(82493,4843),(82494,4844),(82495,4844),(82496,4844),(82497,4845),(82498,4845),(82499,4845),(82500,4846),(82501,4846),(82502,4846),(82503,4847),(82504,4847),(82505,4847),(82506,4848),(82507,4848),(82508,4848),(82509,4849),(82510,4849),(82511,4849),(82512,4850),(82513,4850),(82514,4850),(82515,4851),(82516,4851),(82517,4851),(82518,4852),(82519,4852),(82520,4852),(82521,4853),(82522,4853),(82523,4853),(82524,4854),(82525,4854),(82526,4854),(82527,4855),(82528,4855),(82529,4855),(82530,4856),(82531,4856),(82532,4856),(82533,4857),(82534,4857),(82535,4857),(82536,4858),(82537,4858),(82538,4858),(82539,4859),(82540,4859),(82541,4859),(82542,4860),(82543,4860),(82544,4860),(82545,4861),(82546,4861),(82547,4861),(82548,4862),(82549,4862),(82550,4862),(82551,4863),(82552,4863),(82553,4863),(82554,4864),(82555,4864),(82556,4864),(82557,4865),(82558,4865),(82559,4865),(82560,4866),(82561,4866),(82562,4866),(82563,4867),(82564,4867),(82565,4867),(82566,4868),(82567,4868),(82568,4868),(82569,4869),(82570,4869),(82571,4869),(82572,4870),(82573,4870),(82574,4870),(82575,4871),(82576,4871),(82577,4871),(82578,4872),(82579,4872),(82580,4872),(82581,4873),(82582,4873),(82583,4873),(82584,4874),(82585,4874),(82586,4874),(82587,4875),(82588,4875),(82589,4875),(82590,4876),(82591,4876),(82592,4876),(82593,4877),(82594,4877),(82595,4877),(82596,4878),(82597,4878),(82598,4878),(82599,4879),(82600,4879),(82601,4879),(82602,4780),(82603,4780),(82604,4780),(82605,4780),(82606,4781),(82607,4781),(82608,4781),(82609,4781),(82610,4782),(82611,4782),(82612,4782),(82613,4782),(82614,4783),(82615,4783),(82616,4783),(82617,4783),(82618,4784),(82619,4784),(82620,4784),(82621,4784),(82622,4785),(82623,4785),(82624,4785),(82625,4785),(82626,4786),(82627,4786),(82628,4786),(82629,4786),(82630,4787),(82631,4787),(82632,4787),(82633,4787),(82634,4788),(82635,4788),(82636,4788),(82637,4788),(82638,4789),(82639,4789),(82640,4789),(82641,4789),(82642,4790),(82643,4790),(82644,4790),(82645,4790),(82646,4791),(82647,4791),(82648,4791),(82649,4791),(82650,4792),(82651,4792),(82652,4792),(82653,4792),(82654,4793),(82655,4793),(82656,4793),(82657,4793),(82658,4794),(82659,4794),(82660,4794),(82661,4794),(82662,4795),(82663,4795),(82664,4795),(82665,4795),(82666,4796),(82667,4796),(82668,4796),(82669,4796),(82670,4797),(82671,4797),(82672,4797),(82673,4797),(82674,4798),(82675,4798),(82676,4798),(82677,4798),(82678,4799),(82679,4799),(82680,4799),(82681,4799),(82682,4800),(82683,4800),(82684,4800),(82685,4800),(82686,4801),(82687,4801),(82688,4801),(82689,4801),(82690,4802),(82691,4802),(82692,4802),(82693,4802),(82694,4803),(82695,4803),(82696,4803),(82697,4803),(82698,4804),(82699,4804),(82700,4804),(82701,4804),(82702,4805),(82703,4805),(82704,4805),(82705,4805),(82706,4806),(82707,4806),(82708,4806),(82709,4806),(82710,4807),(82711,4807),(82712,4807),(82713,4807),(82714,4808),(82715,4808),(82716,4808),(82717,4808),(82718,4809),(82719,4809),(82720,4809),(82721,4809),(82722,4810),(82723,4810),(82724,4810),(82725,4810),(82726,4811),(82727,4811),(82728,4811),(82729,4811),(82730,4812),(82731,4812),(82732,4812),(82733,4812),(82734,4813),(82735,4813),(82736,4813),(82737,4813),(82738,4814),(82739,4814),(82740,4814),(82741,4814),(82742,4815),(82743,4815),(82744,4815),(82745,4815),(82746,4816),(82747,4816),(82748,4816),(82749,4816),(82750,4817),(82751,4817),(82752,4817),(82753,4817),(82754,4818),(82755,4818),(82756,4818),(82757,4818),(82758,4819),(82759,4819),(82760,4819),(82761,4819),(82762,4820),(82763,4820),(82764,4820),(82765,4820),(82766,4821),(82767,4821),(82768,4821),(82769,4821),(82770,4822),(82771,4822),(82772,4822),(82773,4822),(82774,4823),(82775,4823),(82776,4823),(82777,4823),(82778,4824),(82779,4824),(82780,4824),(82781,4824),(82782,4825),(82783,4825),(82784,4825),(82785,4825),(82786,4826),(82787,4826),(82788,4826),(82789,4826),(82790,4827),(82791,4827),(82792,4827),(82793,4827),(82794,4828),(82795,4828),(82796,4828),(82797,4828),(82798,4829),(82799,4829),(82800,4829),(82801,4829),(82802,4830),(82803,4830),(82804,4830),(82805,4830),(82806,4831),(82807,4831),(82808,4831),(82809,4831),(82810,4832),(82811,4832),(82812,4832),(82813,4832),(82814,4833),(82815,4833),(82816,4833),(82817,4833),(82818,4834),(82819,4834),(82820,4834),(82821,4834),(82822,4835),(82823,4835),(82824,4835),(82825,4835),(82826,4836),(82827,4836),(82828,4836),(82829,4836),(82830,4837),(82831,4837),(82832,4837),(82833,4837),(82834,4838),(82835,4838),(82836,4838),(82837,4838),(82838,4839),(82839,4839),(82840,4839),(82841,4839),(82842,4840),(82843,4840),(82844,4840),(82845,4840),(82846,4841),(82847,4841),(82848,4841),(82849,4841),(82850,4842),(82851,4842),(82852,4842),(82853,4842),(82854,4843),(82855,4843),(82856,4843),(82857,4843),(82858,4844),(82859,4844),(82860,4844),(82861,4844),(82862,4845),(82863,4845),(82864,4845),(82865,4845),(82866,4846),(82867,4846),(82868,4846),(82869,4846),(82870,4847),(82871,4847),(82872,4847),(82873,4847),(82874,4848),(82875,4848),(82876,4848),(82877,4848),(82878,4849),(82879,4849),(82880,4849),(82881,4849),(82882,4850),(82883,4850),(82884,4850),(82885,4850),(82886,4851),(82887,4851),(82888,4851),(82889,4851),(82890,4852),(82891,4852),(82892,4852),(82893,4852),(82894,4853),(82895,4853),(82896,4853),(82897,4853),(82898,4854),(82899,4854),(82900,4854),(82901,4854),(82902,4855),(82903,4855),(82904,4855),(82905,4855),(82906,4856),(82907,4856),(82908,4856),(82909,4856),(82910,4857),(82911,4857),(82912,4857),(82913,4857),(82914,4858),(82915,4858),(82916,4858),(82917,4858),(82918,4859),(82919,4859),(82920,4859),(82921,4859),(82922,4860),(82923,4860),(82924,4860),(82925,4860),(82926,4861),(82927,4861),(82928,4861),(82929,4861),(82930,4862),(82931,4862),(82932,4862),(82933,4862),(82934,4863),(82935,4863),(82936,4863),(82937,4863),(82938,4864),(82939,4864),(82940,4864),(82941,4864),(82942,4865),(82943,4865),(82944,4865),(82945,4865),(82946,4866),(82947,4866),(82948,4866),(82949,4866),(82950,4867),(82951,4867),(82952,4867),(82953,4867),(82954,4868),(82955,4868),(82956,4868),(82957,4868),(82958,4869),(82959,4869),(82960,4869),(82961,4869),(82962,4870),(82963,4870),(82964,4870),(82965,4870),(82966,4871),(82967,4871),(82968,4871),(82969,4871),(82970,4872),(82971,4872),(82972,4872),(82973,4872),(82974,4873),(82975,4873),(82976,4873),(82977,4873),(82978,4874),(82979,4874),(82980,4874),(82981,4874),(82982,4875),(82983,4875),(82984,4875),(82985,4875),(82986,4876),(82987,4876),(82988,4876),(82989,4876),(82990,4877),(82991,4877),(82992,4877),(82993,4877),(82994,4878),(82995,4878),(82996,4878),(82997,4878),(82998,4879),(82999,4879),(83000,4879),(83001,4879),(83002,4880),(83003,4881),(83004,4882),(83005,4883),(83006,4884),(83007,4885),(83008,4886),(83009,4887),(83010,4888),(83011,4889),(83012,4890),(83013,4891),(83014,4892),(83015,4893),(83016,4894),(83017,4895),(83018,4896),(83019,4897),(83020,4898),(83021,4899),(83022,4900),(83023,4901),(83024,4902),(83025,4903),(83026,4904),(83027,4905),(83028,4906),(83029,4907),(83030,4908),(83031,4909),(83032,4910),(83033,4911),(83034,4912),(83035,4913),(83036,4914),(83037,4915),(83038,4916),(83039,4917),(83040,4918),(83041,4919),(83042,4920),(83043,4921),(83044,4922),(83045,4923),(83046,4924),(83047,4925),(83048,4926),(83049,4927),(83050,4928),(83051,4929),(83052,4930),(83053,4931),(83054,4932),(83055,4933),(83056,4934),(83057,4935),(83058,4936),(83059,4937),(83060,4938),(83061,4939),(83062,4940),(83063,4941),(83064,4942),(83065,4943),(83066,4944),(83067,4945),(83068,4946),(83069,4947),(83070,4948),(83071,4949),(83072,4950),(83073,4951),(83074,4952),(83075,4953),(83076,4954),(83077,4955),(83078,4956),(83079,4957),(83080,4958),(83081,4959),(83082,4960),(83083,4961),(83084,4962),(83085,4963),(83086,4964),(83087,4965),(83088,4966),(83089,4967),(83090,4968),(83091,4969),(83092,4970),(83093,4971),(83094,4972),(83095,4973),(83096,4974),(83097,4975),(83098,4976),(83099,4977),(83100,4978),(83101,4979),(83102,4880),(83103,4880),(83104,4880),(83105,4880),(83106,4880),(83107,4880),(83108,4881),(83109,4881),(83110,4881),(83111,4881),(83112,4881),(83113,4881),(83114,4882),(83115,4882),(83116,4882),(83117,4882),(83118,4882),(83119,4882),(83120,4883),(83121,4883),(83122,4883),(83123,4883),(83124,4883),(83125,4883),(83126,4884),(83127,4884),(83128,4884),(83129,4884),(83130,4884),(83131,4884),(83132,4885),(83133,4885),(83134,4885),(83135,4885),(83136,4885),(83137,4885),(83138,4886),(83139,4886),(83140,4886),(83141,4886),(83142,4886),(83143,4886),(83144,4887),(83145,4887),(83146,4887),(83147,4887),(83148,4887),(83149,4887),(83150,4888),(83151,4888),(83152,4888),(83153,4888),(83154,4888),(83155,4888),(83156,4889),(83157,4889),(83158,4889),(83159,4889),(83160,4889),(83161,4889),(83162,4890),(83163,4890),(83164,4890),(83165,4890),(83166,4890),(83167,4890),(83168,4891),(83169,4891),(83170,4891),(83171,4891),(83172,4891),(83173,4891),(83174,4892),(83175,4892),(83176,4892),(83177,4892),(83178,4892),(83179,4892),(83180,4893),(83181,4893),(83182,4893),(83183,4893),(83184,4893),(83185,4893),(83186,4894),(83187,4894),(83188,4894),(83189,4894),(83190,4894),(83191,4894),(83192,4895),(83193,4895),(83194,4895),(83195,4895),(83196,4895),(83197,4895),(83198,4896),(83199,4896),(83200,4896),(83201,4896),(83202,4896),(83203,4896),(83204,4897),(83205,4897),(83206,4897),(83207,4897),(83208,4897),(83209,4897),(83210,4898),(83211,4898),(83212,4898),(83213,4898),(83214,4898),(83215,4898),(83216,4899),(83217,4899),(83218,4899),(83219,4899),(83220,4899),(83221,4899),(83222,4900),(83223,4900),(83224,4900),(83225,4900),(83226,4900),(83227,4900),(83228,4901),(83229,4901),(83230,4901),(83231,4901),(83232,4901),(83233,4901),(83234,4902),(83235,4902),(83236,4902),(83237,4902),(83238,4902),(83239,4902),(83240,4903),(83241,4903),(83242,4903),(83243,4903),(83244,4903),(83245,4903),(83246,4904),(83247,4904),(83248,4904),(83249,4904),(83250,4904),(83251,4904),(83252,4905),(83253,4905),(83254,4905),(83255,4905),(83256,4905),(83257,4905),(83258,4906),(83259,4906),(83260,4906),(83261,4906),(83262,4906),(83263,4906),(83264,4907),(83265,4907),(83266,4907),(83267,4907),(83268,4907),(83269,4907),(83270,4908),(83271,4908),(83272,4908),(83273,4908),(83274,4908),(83275,4908),(83276,4909),(83277,4909),(83278,4909),(83279,4909),(83280,4909),(83281,4909),(83282,4910),(83283,4910),(83284,4910),(83285,4910),(83286,4910),(83287,4910),(83288,4911),(83289,4911),(83290,4911),(83291,4911),(83292,4911),(83293,4911),(83294,4912),(83295,4912),(83296,4912),(83297,4912),(83298,4912),(83299,4912),(83300,4913),(83301,4913),(83302,4913),(83303,4913),(83304,4913),(83305,4913),(83306,4914),(83307,4914),(83308,4914),(83309,4914),(83310,4914),(83311,4914),(83312,4915),(83313,4915),(83314,4915),(83315,4915),(83316,4915),(83317,4915),(83318,4916),(83319,4916),(83320,4916),(83321,4916),(83322,4916),(83323,4916),(83324,4917),(83325,4917),(83326,4917),(83327,4917),(83328,4917),(83329,4917),(83330,4918),(83331,4918),(83332,4918),(83333,4918),(83334,4918),(83335,4918),(83336,4919),(83337,4919),(83338,4919),(83339,4919),(83340,4919),(83341,4919),(83342,4920),(83343,4920),(83344,4920),(83345,4920),(83346,4920),(83347,4920),(83348,4921),(83349,4921),(83350,4921),(83351,4921),(83352,4921),(83353,4921),(83354,4922),(83355,4922),(83356,4922),(83357,4922),(83358,4922),(83359,4922),(83360,4923),(83361,4923),(83362,4923),(83363,4923),(83364,4923),(83365,4923),(83366,4924),(83367,4924),(83368,4924),(83369,4924),(83370,4925),(83371,4925),(83372,4925),(83373,4925),(83374,4926),(83375,4926),(83376,4926),(83377,4926),(83378,4927),(83379,4927),(83380,4927),(83381,4927),(83382,4928),(83383,4928),(83384,4928),(83385,4928),(83386,4929),(83387,4929),(83388,4929),(83389,4929),(83390,4930),(83391,4930),(83392,4930),(83393,4930),(83394,4931),(83395,4931),(83396,4931),(83397,4931),(83398,4932),(83399,4932),(83400,4932),(83401,4932),(83402,4933),(83403,4933),(83404,4933),(83405,4933),(83406,4933),(83407,4933),(83408,4934),(83409,4934),(83410,4934),(83411,4934),(83412,4935),(83413,4935),(83414,4935),(83415,4935),(83416,4936),(83417,4936),(83418,4936),(83419,4936),(83420,4937),(83421,4937),(83422,4937),(83423,4937),(83424,4938),(83425,4938),(83426,4938),(83427,4938),(83428,4939),(83429,4939),(83430,4939),(83431,4939),(83432,4940),(83433,4940),(83434,4940),(83435,4940),(83436,4941),(83437,4941),(83438,4941),(83439,4941),(83440,4942),(83441,4942),(83442,4942),(83443,4942),(83444,4942),(83445,4942),(83446,4943),(83447,4943),(83448,4943),(83449,4943),(83450,4943),(83451,4943),(83452,4944),(83453,4944),(83454,4944),(83455,4944),(83456,4944),(83457,4944),(83458,4945),(83459,4945),(83460,4945),(83461,4945),(83462,4945),(83463,4945),(83464,4946),(83465,4946),(83466,4946),(83467,4946),(83468,4946),(83469,4946),(83470,4947),(83471,4947),(83472,4947),(83473,4947),(83474,4947),(83475,4947),(83476,4948),(83477,4948),(83478,4948),(83479,4948),(83480,4948),(83481,4948),(83482,4949),(83483,4949),(83484,4949),(83485,4949),(83486,4949),(83487,4949),(83488,4950),(83489,4950),(83490,4950),(83491,4950),(83492,4950),(83493,4950),(83494,4951),(83495,4951),(83496,4951),(83497,4951),(83498,4951),(83499,4951),(83500,4952),(83501,4952),(83502,4952),(83503,4952),(83504,4952),(83505,4952),(83506,4953),(83507,4953),(83508,4953),(83509,4953),(83510,4953),(83511,4953),(83512,4954),(83513,4954),(83514,4954),(83515,4954),(83516,4954),(83517,4955),(83518,4955),(83519,4955),(83520,4955),(83521,4955),(83522,4955),(83523,4956),(83524,4956),(83525,4956),(83526,4956),(83527,4956),(83528,4956),(83529,4957),(83530,4957),(83531,4957),(83532,4957),(83533,4957),(83534,4957),(83535,4958),(83536,4958),(83537,4958),(83538,4958),(83539,4958),(83540,4958),(83541,4959),(83542,4959),(83543,4959),(83544,4959),(83545,4959),(83546,4959),(83547,4960),(83548,4960),(83549,4960),(83550,4960),(83551,4960),(83552,4960),(83553,4961),(83554,4961),(83555,4961),(83556,4961),(83557,4961),(83558,4961),(83559,4962),(83560,4962),(83561,4962),(83562,4962),(83563,4962),(83564,4962),(83565,4963),(83566,4963),(83567,4963),(83568,4963),(83569,4964),(83570,4964),(83571,4964),(83572,4964),(83573,4965),(83574,4965),(83575,4965),(83576,4965),(83577,4965),(83578,4965),(83579,4966),(83580,4966),(83581,4966),(83582,4966),(83583,4966),(83584,4966),(83585,4967),(83586,4967),(83587,4967),(83588,4967),(83589,4967),(83590,4967),(83591,4968),(83592,4968),(83593,4968),(83594,4968),(83595,4968),(83596,4968),(83597,4969),(83598,4969),(83599,4969),(83600,4969),(83601,4969),(83602,4969),(83603,4970),(83604,4970),(83605,4970),(83606,4970),(83607,4970),(83608,4970),(83609,4971),(83610,4971),(83611,4971),(83612,4971),(83613,4971),(83614,4971),(83615,4972),(83616,4972),(83617,4972),(83618,4972),(83619,4972),(83620,4972),(83621,4973),(83622,4973),(83623,4973),(83624,4973),(83625,4973),(83626,4973),(83627,4974),(83628,4974),(83629,4974),(83630,4974),(83631,4974),(83632,4974),(83633,4975),(83634,4975),(83635,4975),(83636,4975),(83637,4975),(83638,4975),(83639,4976),(83640,4976),(83641,4976),(83642,4976),(83643,4976),(83644,4976),(83645,4977),(83646,4977),(83647,4977),(83648,4977),(83649,4977),(83650,4977),(83651,4978),(83652,4978),(83653,4978),(83654,4978),(83655,4978),(83656,4978),(83657,4979),(83658,4979),(83659,4979),(83660,4979),(83661,4979),(83662,4979),(83663,4880),(83664,4880),(83665,4880),(83666,4881),(83667,4881),(83668,4881),(83669,4882),(83670,4882),(83671,4882),(83672,4883),(83673,4883),(83674,4883),(83675,4884),(83676,4884),(83677,4884),(83678,4885),(83679,4885),(83680,4885),(83681,4886),(83682,4886),(83683,4886),(83684,4887),(83685,4887),(83686,4887),(83687,4888),(83688,4888),(83689,4888),(83690,4889),(83691,4889),(83692,4889),(83693,4890),(83694,4890),(83695,4890),(83696,4891),(83697,4891),(83698,4892),(83699,4892),(83700,4893),(83701,4893),(83702,4894),(83703,4894),(83704,4895),(83705,4895),(83706,4896),(83707,4896),(83708,4896),(83709,4897),(83710,4897),(83711,4898),(83712,4898),(83713,4898),(83714,4899),(83715,4899),(83716,4899),(83717,4900),(83718,4900),(83719,4900),(83720,4901),(83721,4901),(83722,4901),(83723,4902),(83724,4902),(83725,4902),(83726,4903),(83727,4903),(83728,4903),(83729,4904),(83730,4904),(83731,4904),(83732,4905),(83733,4905),(83734,4905),(83735,4906),(83736,4906),(83737,4906),(83738,4907),(83739,4907),(83740,4907),(83741,4908),(83742,4908),(83743,4908),(83744,4909),(83745,4909),(83746,4909),(83747,4910),(83748,4910),(83749,4910),(83750,4911),(83751,4911),(83752,4911),(83753,4912),(83754,4912),(83755,4912),(83756,4913),(83757,4913),(83758,4913),(83759,4914),(83760,4914),(83761,4914),(83762,4915),(83763,4915),(83764,4915),(83765,4916),(83766,4916),(83767,4916),(83768,4917),(83769,4917),(83770,4917),(83771,4918),(83772,4918),(83773,4918),(83774,4919),(83775,4919),(83776,4919),(83777,4920),(83778,4920),(83779,4920),(83780,4921),(83781,4921),(83782,4921),(83783,4922),(83784,4922),(83785,4922),(83786,4923),(83787,4923),(83788,4923),(83789,4924),(83790,4924),(83791,4925),(83792,4925),(83793,4926),(83794,4926),(83795,4927),(83796,4927),(83797,4928),(83798,4928),(83799,4929),(83800,4929),(83801,4930),(83802,4930),(83803,4931),(83804,4931),(83805,4932),(83806,4932),(83807,4933),(83808,4933),(83809,4934),(83810,4934),(83811,4935),(83812,4935),(83813,4936),(83814,4936),(83815,4937),(83816,4937),(83817,4938),(83818,4938),(83819,4939),(83820,4939),(83821,4940),(83822,4940),(83823,4941),(83824,4941),(83825,4942),(83826,4942),(83827,4943),(83828,4943),(83829,4943),(83830,4944),(83831,4944),(83832,4944),(83833,4945),(83834,4945),(83835,4945),(83836,4946),(83837,4946),(83838,4946),(83839,4947),(83840,4947),(83841,4947),(83842,4948),(83843,4948),(83844,4948),(83845,4949),(83846,4949),(83847,4949),(83848,4950),(83849,4950),(83850,4950),(83851,4951),(83852,4951),(83853,4951),(83854,4952),(83855,4952),(83856,4952),(83857,4953),(83858,4953),(83859,4953),(83860,4954),(83861,4954),(83862,4955),(83863,4955),(83864,4955),(83865,4956),(83866,4956),(83867,4956),(83868,4957),(83869,4957),(83870,4957),(83871,4958),(83872,4958),(83873,4958),(83874,4959),(83875,4959),(83876,4959),(83877,4960),(83878,4960),(83879,4960),(83880,4961),(83881,4961),(83882,4961),(83883,4962),(83884,4962),(83885,4962),(83886,4963),(83887,4963),(83888,4964),(83889,4964),(83890,4965),(83891,4965),(83892,4965),(83893,4966),(83894,4966),(83895,4966),(83896,4967),(83897,4967),(83898,4967),(83899,4968),(83900,4968),(83901,4968),(83902,4969),(83903,4969),(83904,4969),(83905,4970),(83906,4970),(83907,4971),(83908,4971),(83909,4971),(83910,4972),(83911,4972),(83912,4972),(83913,4973),(83914,4973),(83915,4973),(83916,4974),(83917,4974),(83918,4974),(83919,4975),(83920,4975),(83921,4975),(83922,4976),(83923,4976),(83924,4976),(83925,4977),(83926,4977),(83927,4977),(83928,4978),(83929,4978),(83930,4978),(83931,4979),(83932,4979),(83933,4979),(83934,4880),(83935,4880),(83936,4880),(83937,4881),(83938,4881),(83939,4881),(83940,4882),(83941,4882),(83942,4882),(83943,4883),(83944,4883),(83945,4883),(83946,4884),(83947,4884),(83948,4884),(83949,4885),(83950,4885),(83951,4885),(83952,4886),(83953,4886),(83954,4886),(83955,4887),(83956,4887),(83957,4887),(83958,4888),(83959,4888),(83960,4888),(83961,4889),(83962,4889),(83963,4889),(83964,4890),(83965,4890),(83966,4890),(83967,4891),(83968,4891),(83969,4891),(83970,4892),(83971,4892),(83972,4892),(83973,4893),(83974,4893),(83975,4893),(83976,4894),(83977,4894),(83978,4894),(83979,4895),(83980,4895),(83981,4895),(83982,4896),(83983,4896),(83984,4896),(83985,4897),(83986,4897),(83987,4897),(83988,4898),(83989,4898),(83990,4898),(83991,4899),(83992,4899),(83993,4899),(83994,4900),(83995,4900),(83996,4900),(83997,4901),(83998,4901),(83999,4901),(84000,4902),(84001,4902),(84002,4902),(84003,4903),(84004,4903),(84005,4903),(84006,4904),(84007,4904),(84008,4904),(84009,4905),(84010,4905),(84011,4905),(84012,4906),(84013,4906),(84014,4906),(84015,4907),(84016,4907),(84017,4907),(84018,4908),(84019,4908),(84020,4908),(84021,4909),(84022,4909),(84023,4909),(84024,4910),(84025,4910),(84026,4910),(84027,4911),(84028,4911),(84029,4911),(84030,4912),(84031,4912),(84032,4912),(84033,4913),(84034,4913),(84035,4913),(84036,4914),(84037,4914),(84038,4914),(84039,4915),(84040,4915),(84041,4915),(84042,4916),(84043,4916),(84044,4916),(84045,4917),(84046,4917),(84047,4917),(84048,4918),(84049,4918),(84050,4918),(84051,4919),(84052,4919),(84053,4919),(84054,4920),(84055,4920),(84056,4920),(84057,4921),(84058,4921),(84059,4921),(84060,4922),(84061,4922),(84062,4922),(84063,4923),(84064,4923),(84065,4923),(84066,4924),(84067,4924),(84068,4924),(84069,4925),(84070,4925),(84071,4925),(84072,4926),(84073,4926),(84074,4926),(84075,4927),(84076,4927),(84077,4927),(84078,4928),(84079,4928),(84080,4928),(84081,4929),(84082,4929),(84083,4929),(84084,4930),(84085,4930),(84086,4930),(84087,4931),(84088,4931),(84089,4931),(84090,4932),(84091,4932),(84092,4932),(84093,4933),(84094,4933),(84095,4933),(84096,4934),(84097,4934),(84098,4934),(84099,4935),(84100,4935),(84101,4935),(84102,4936),(84103,4936),(84104,4936),(84105,4937),(84106,4937),(84107,4937),(84108,4938),(84109,4938),(84110,4938),(84111,4939),(84112,4939),(84113,4939),(84114,4940),(84115,4940),(84116,4940),(84117,4941),(84118,4941),(84119,4941),(84120,4942),(84121,4942),(84122,4942),(84123,4943),(84124,4943),(84125,4943),(84126,4944),(84127,4944),(84128,4944),(84129,4945),(84130,4945),(84131,4945),(84132,4946),(84133,4946),(84134,4946),(84135,4947),(84136,4947),(84137,4947),(84138,4948),(84139,4948),(84140,4948),(84141,4949),(84142,4949),(84143,4949),(84144,4950),(84145,4950),(84146,4950),(84147,4951),(84148,4951),(84149,4951),(84150,4952),(84151,4952),(84152,4952),(84153,4953),(84154,4953),(84155,4953),(84156,4954),(84157,4954),(84158,4954),(84159,4955),(84160,4955),(84161,4955),(84162,4956),(84163,4956),(84164,4956),(84165,4957),(84166,4957),(84167,4957),(84168,4958),(84169,4958),(84170,4958),(84171,4959),(84172,4959),(84173,4959),(84174,4960),(84175,4960),(84176,4960),(84177,4961),(84178,4961),(84179,4961),(84180,4962),(84181,4962),(84182,4962),(84183,4963),(84184,4963),(84185,4963),(84186,4964),(84187,4964),(84188,4964),(84189,4965),(84190,4965),(84191,4965),(84192,4966),(84193,4966),(84194,4966),(84195,4967),(84196,4967),(84197,4967),(84198,4968),(84199,4968),(84200,4968),(84201,4969),(84202,4969),(84203,4969),(84204,4970),(84205,4970),(84206,4970),(84207,4971),(84208,4971),(84209,4971),(84210,4972),(84211,4972),(84212,4972),(84213,4973),(84214,4973),(84215,4973),(84216,4974),(84217,4974),(84218,4974),(84219,4975),(84220,4975),(84221,4975),(84222,4976),(84223,4976),(84224,4976),(84225,4977),(84226,4977),(84227,4977),(84228,4978),(84229,4978),(84230,4978),(84231,4979),(84232,4979),(84233,4979),(84234,4880),(84235,4880),(84236,4880),(84237,4880),(84238,4881),(84239,4881),(84240,4881),(84241,4881),(84242,4882),(84243,4882),(84244,4882),(84245,4882),(84246,4883),(84247,4883),(84248,4883),(84249,4883),(84250,4884),(84251,4884),(84252,4884),(84253,4884),(84254,4885),(84255,4885),(84256,4885),(84257,4885),(84258,4886),(84259,4886),(84260,4886),(84261,4886),(84262,4887),(84263,4887),(84264,4887),(84265,4887),(84266,4888),(84267,4888),(84268,4888),(84269,4888),(84270,4889),(84271,4889),(84272,4889),(84273,4889),(84274,4890),(84275,4890),(84276,4890),(84277,4890),(84278,4891),(84279,4891),(84280,4891),(84281,4891),(84282,4892),(84283,4892),(84284,4892),(84285,4892),(84286,4893),(84287,4893),(84288,4893),(84289,4893),(84290,4894),(84291,4894),(84292,4894),(84293,4894),(84294,4895),(84295,4895),(84296,4895),(84297,4895),(84298,4896),(84299,4896),(84300,4896),(84301,4896),(84302,4897),(84303,4897),(84304,4897),(84305,4897),(84306,4898),(84307,4898),(84308,4898),(84309,4898),(84310,4899),(84311,4899),(84312,4899),(84313,4899),(84314,4900),(84315,4900),(84316,4900),(84317,4900),(84318,4901),(84319,4901),(84320,4901),(84321,4901),(84322,4902),(84323,4902),(84324,4902),(84325,4902),(84326,4903),(84327,4903),(84328,4903),(84329,4903),(84330,4904),(84331,4904),(84332,4904),(84333,4904),(84334,4905),(84335,4905),(84336,4905),(84337,4905),(84338,4906),(84339,4906),(84340,4906),(84341,4906),(84342,4907),(84343,4907),(84344,4907),(84345,4907),(84346,4908),(84347,4908),(84348,4908),(84349,4908),(84350,4909),(84351,4909),(84352,4909),(84353,4909),(84354,4910),(84355,4910),(84356,4910),(84357,4910),(84358,4911),(84359,4911),(84360,4911),(84361,4911),(84362,4912),(84363,4912),(84364,4912),(84365,4912),(84366,4913),(84367,4913),(84368,4913),(84369,4913),(84370,4914),(84371,4914),(84372,4914),(84373,4914),(84374,4915),(84375,4915),(84376,4915),(84377,4915),(84378,4916),(84379,4916),(84380,4916),(84381,4916),(84382,4917),(84383,4917),(84384,4917),(84385,4917),(84386,4918),(84387,4918),(84388,4918),(84389,4918),(84390,4919),(84391,4919),(84392,4919),(84393,4919),(84394,4920),(84395,4920),(84396,4920),(84397,4920),(84398,4921),(84399,4921),(84400,4921),(84401,4921),(84402,4922),(84403,4922),(84404,4922),(84405,4922),(84406,4923),(84407,4923),(84408,4923),(84409,4923),(84410,4924),(84411,4924),(84412,4924),(84413,4924),(84414,4925),(84415,4925),(84416,4925),(84417,4925),(84418,4926),(84419,4926),(84420,4926),(84421,4926),(84422,4927),(84423,4927),(84424,4927),(84425,4927),(84426,4928),(84427,4928),(84428,4928),(84429,4928),(84430,4929),(84431,4929),(84432,4929),(84433,4929),(84434,4930),(84435,4930),(84436,4930),(84437,4930),(84438,4931),(84439,4931),(84440,4931),(84441,4931),(84442,4932),(84443,4932),(84444,4932),(84445,4932),(84446,4933),(84447,4933),(84448,4933),(84449,4933),(84450,4934),(84451,4934),(84452,4934),(84453,4934),(84454,4935),(84455,4935),(84456,4935),(84457,4935),(84458,4936),(84459,4936),(84460,4936),(84461,4936),(84462,4937),(84463,4937),(84464,4937),(84465,4937),(84466,4938),(84467,4938),(84468,4938),(84469,4938),(84470,4939),(84471,4939),(84472,4939),(84473,4939),(84474,4940),(84475,4940),(84476,4940),(84477,4940),(84478,4941),(84479,4941),(84480,4941),(84481,4941),(84482,4942),(84483,4942),(84484,4942),(84485,4942),(84486,4943),(84487,4943),(84488,4943),(84489,4943),(84490,4944),(84491,4944),(84492,4944),(84493,4944),(84494,4945),(84495,4945),(84496,4945),(84497,4945),(84498,4946),(84499,4946),(84500,4946),(84501,4946),(84502,4947),(84503,4947),(84504,4947),(84505,4947),(84506,4948),(84507,4948),(84508,4948),(84509,4948),(84510,4949),(84511,4949),(84512,4949),(84513,4949),(84514,4950),(84515,4950),(84516,4950),(84517,4950),(84518,4951),(84519,4951),(84520,4951),(84521,4951),(84522,4952),(84523,4952),(84524,4952),(84525,4952),(84526,4953),(84527,4953),(84528,4953),(84529,4953),(84530,4954),(84531,4954),(84532,4954),(84533,4954),(84534,4955),(84535,4955),(84536,4955),(84537,4955),(84538,4956),(84539,4956),(84540,4956),(84541,4956),(84542,4957),(84543,4957),(84544,4957),(84545,4957),(84546,4958),(84547,4958),(84548,4958),(84549,4958),(84550,4959),(84551,4959),(84552,4959),(84553,4959),(84554,4960),(84555,4960),(84556,4960),(84557,4960),(84558,4961),(84559,4961),(84560,4961),(84561,4961),(84562,4962),(84563,4962),(84564,4962),(84565,4962),(84566,4963),(84567,4963),(84568,4963),(84569,4963),(84570,4964),(84571,4964),(84572,4964),(84573,4964),(84574,4965),(84575,4965),(84576,4965),(84577,4965),(84578,4966),(84579,4966),(84580,4966),(84581,4966),(84582,4967),(84583,4967),(84584,4967),(84585,4967),(84586,4968),(84587,4968),(84588,4968),(84589,4968),(84590,4969),(84591,4969),(84592,4969),(84593,4969),(84594,4970),(84595,4970),(84596,4970),(84597,4970),(84598,4971),(84599,4971),(84600,4971),(84601,4971),(84602,4972),(84603,4972),(84604,4972),(84605,4972),(84606,4973),(84607,4973),(84608,4973),(84609,4973),(84610,4974),(84611,4974),(84612,4974),(84613,4974),(84614,4975),(84615,4975),(84616,4975),(84617,4975),(84618,4976),(84619,4976),(84620,4976),(84621,4976),(84622,4977),(84623,4977),(84624,4977),(84625,4977),(84626,4978),(84627,4978),(84628,4978),(84629,4978),(84630,4979),(84631,4979),(84632,4979),(84633,4979),(84634,4980),(84635,4981),(84636,4982),(84637,4983),(84638,4984),(84639,4985),(84640,4986),(84641,4987),(84642,4988),(84643,4989),(84644,4990),(84645,4991),(84646,4992),(84647,4993),(84648,4994),(84649,4995),(84650,4996),(84651,4997),(84652,4998),(84653,4999),(84654,5000),(84655,5001),(84656,5002),(84657,5003),(84658,5004),(84659,5005),(84660,5006),(84661,5007),(84662,5008),(84663,5009),(84664,5010),(84665,5011),(84666,5012),(84667,5013),(84668,5014),(84669,5015),(84670,5016),(84671,5017),(84672,5018),(84673,5019),(84674,5020),(84675,5021),(84676,5022),(84677,5023),(84678,5024),(84679,5025),(84680,5026),(84681,5027),(84682,5028),(84683,5029),(84684,5030),(84685,5031),(84686,5032),(84687,5033),(84688,5034),(84689,5035),(84690,5036),(84691,5037),(84692,5038),(84693,5039),(84694,5040),(84695,5041),(84696,5042),(84697,5043),(84698,5044),(84699,5045),(84700,5046),(84701,5047),(84702,5048),(84703,5049),(84704,5050),(84705,5051),(84706,5052),(84707,5053),(84708,5054),(84709,5055),(84710,5056),(84711,5057),(84712,5058),(84713,5059),(84714,5060),(84715,5061),(84716,5062),(84717,5063),(84718,5064),(84719,5065),(84720,5066),(84721,5067),(84722,5068),(84723,5069),(84724,5070),(84725,5071),(84726,5072),(84727,5073),(84728,5074),(84729,5075),(84730,5076),(84731,5077),(84732,5078),(84733,5079),(84734,4980),(84735,4980),(84736,4980),(84737,4980),(84738,4980),(84739,4980),(84740,4981),(84741,4981),(84742,4981),(84743,4981),(84744,4981),(84745,4981),(84746,4982),(84747,4982),(84748,4982),(84749,4982),(84750,4982),(84751,4982),(84752,4983),(84753,4983),(84754,4983),(84755,4983),(84756,4983),(84757,4983),(84758,4984),(84759,4984),(84760,4984),(84761,4984),(84762,4984),(84763,4984),(84764,4985),(84765,4985),(84766,4985),(84767,4985),(84768,4985),(84769,4985),(84770,4986),(84771,4986),(84772,4986),(84773,4986),(84774,4986),(84775,4986),(84776,4987),(84777,4987),(84778,4987),(84779,4987),(84780,4987),(84781,4987),(84782,4988),(84783,4988),(84784,4988),(84785,4988),(84786,4988),(84787,4988),(84788,4989),(84789,4989),(84790,4989),(84791,4989),(84792,4989),(84793,4989),(84794,4990),(84795,4990),(84796,4990),(84797,4990),(84798,4990),(84799,4990),(84800,4991),(84801,4991),(84802,4991),(84803,4991),(84804,4991),(84805,4991),(84806,4992),(84807,4992),(84808,4992),(84809,4992),(84810,4992),(84811,4992),(84812,4993),(84813,4993),(84814,4993),(84815,4993),(84816,4993),(84817,4993),(84818,4994),(84819,4994),(84820,4994),(84821,4994),(84822,4994),(84823,4994),(84824,4995),(84825,4995),(84826,4995),(84827,4995),(84828,4995),(84829,4995),(84830,4996),(84831,4996),(84832,4996),(84833,4996),(84834,4996),(84835,4996),(84836,4997),(84837,4997),(84838,4997),(84839,4997),(84840,4997),(84841,4997),(84842,4998),(84843,4998),(84844,4998),(84845,4998),(84846,4998),(84847,4998),(84848,4999),(84849,4999),(84850,4999),(84851,4999),(84852,4999),(84853,4999),(84854,5000),(84855,5000),(84856,5000),(84857,5000),(84858,5000),(84859,5000),(84860,5001),(84861,5001),(84862,5001),(84863,5001),(84864,5001),(84865,5001),(84866,5002),(84867,5002),(84868,5002),(84869,5002),(84870,5002),(84871,5002),(84872,5003),(84873,5003),(84874,5003),(84875,5003),(84876,5003),(84877,5003),(84878,5004),(84879,5004),(84880,5004),(84881,5004),(84882,5004),(84883,5004),(84884,5005),(84885,5005),(84886,5005),(84887,5005),(84888,5005),(84889,5005),(84890,5006),(84891,5006),(84892,5006),(84893,5006),(84894,5006),(84895,5006),(84896,5007),(84897,5007),(84898,5007),(84899,5007),(84900,5007),(84901,5007),(84902,5008),(84903,5008),(84904,5008),(84905,5008),(84906,5008),(84907,5008),(84908,5009),(84909,5009),(84910,5009),(84911,5009),(84912,5009),(84913,5009),(84914,5010),(84915,5010),(84916,5010),(84917,5010),(84918,5010),(84919,5010),(84920,5011),(84921,5011),(84922,5011),(84923,5011),(84924,5011),(84925,5011),(84926,5012),(84927,5012),(84928,5012),(84929,5012),(84930,5012),(84931,5012),(84932,5013),(84933,5013),(84934,5013),(84935,5013),(84936,5013),(84937,5013),(84938,5014),(84939,5014),(84940,5014),(84941,5014),(84942,5014),(84943,5014),(84944,5015),(84945,5015),(84946,5015),(84947,5015),(84948,5015),(84949,5015),(84950,5016),(84951,5016),(84952,5016),(84953,5016),(84954,5016),(84955,5016),(84956,5017),(84957,5017),(84958,5017),(84959,5017),(84960,5017),(84961,5017),(84962,5018),(84963,5018),(84964,5018),(84965,5018),(84966,5018),(84967,5018),(84968,5019),(84969,5019),(84970,5019),(84971,5019),(84972,5019),(84973,5019),(84974,5020),(84975,5020),(84976,5020),(84977,5020),(84978,5020),(84979,5020),(84980,5021),(84981,5021),(84982,5021),(84983,5021),(84984,5021),(84985,5021),(84986,5022),(84987,5022),(84988,5022),(84989,5022),(84990,5022),(84991,5022),(84992,5023),(84993,5023),(84994,5023),(84995,5023),(84996,5023),(84997,5023),(84998,5024),(84999,5024),(85000,5024),(85001,5024),(85002,5024),(85003,5024),(85004,5025),(85005,5025),(85006,5025),(85007,5025),(85008,5025),(85009,5025),(85010,5026),(85011,5026),(85012,5026),(85013,5026),(85014,5026),(85015,5026),(85016,5027),(85017,5027),(85018,5027),(85019,5027),(85020,5027),(85021,5027),(85022,5028),(85023,5028),(85024,5028),(85025,5028),(85026,5028),(85027,5028),(85028,5029),(85029,5029),(85030,5029),(85031,5029),(85032,5029),(85033,5029),(85034,5030),(85035,5030),(85036,5030),(85037,5030),(85038,5030),(85039,5030),(85040,5031),(85041,5031),(85042,5031),(85043,5031),(85044,5031),(85045,5031),(85046,5032),(85047,5032),(85048,5032),(85049,5032),(85050,5032),(85051,5032),(85052,5033),(85053,5033),(85054,5033),(85055,5033),(85056,5033),(85057,5033),(85058,5034),(85059,5034),(85060,5034),(85061,5034),(85062,5034),(85063,5034),(85064,5035),(85065,5035),(85066,5035),(85067,5035),(85068,5035),(85069,5035),(85070,5036),(85071,5036),(85072,5036),(85073,5036),(85074,5036),(85075,5036),(85076,5037),(85077,5037),(85078,5037),(85079,5037),(85080,5038),(85081,5038),(85082,5038),(85083,5038),(85084,5039),(85085,5039),(85086,5039),(85087,5039),(85088,5039),(85089,5039),(85090,5040),(85091,5040),(85092,5040),(85093,5040),(85094,5040),(85095,5040),(85096,5041),(85097,5041),(85098,5041),(85099,5041),(85100,5041),(85101,5041),(85102,5042),(85103,5042),(85104,5042),(85105,5042),(85106,5042),(85107,5042),(85108,5043),(85109,5043),(85110,5043),(85111,5043),(85112,5043),(85113,5043),(85114,5044),(85115,5044),(85116,5044),(85117,5044),(85118,5044),(85119,5044),(85120,5045),(85121,5045),(85122,5045),(85123,5045),(85124,5045),(85125,5045),(85126,5046),(85127,5046),(85128,5046),(85129,5046),(85130,5046),(85131,5046),(85132,5047),(85133,5047),(85134,5047),(85135,5047),(85136,5047),(85137,5047),(85138,5048),(85139,5048),(85140,5048),(85141,5048),(85142,5048),(85143,5048),(85144,5049),(85145,5049),(85146,5049),(85147,5049),(85148,5049),(85149,5049),(85150,5050),(85151,5050),(85152,5050),(85153,5050),(85154,5050),(85155,5050),(85156,5051),(85157,5051),(85158,5051),(85159,5051),(85160,5051),(85161,5051),(85162,5052),(85163,5052),(85164,5052),(85165,5052),(85166,5052),(85167,5052),(85168,5053),(85169,5053),(85170,5053),(85171,5053),(85172,5053),(85173,5053),(85174,5054),(85175,5054),(85176,5054),(85177,5054),(85178,5054),(85179,5054),(85180,5055),(85181,5055),(85182,5055),(85183,5055),(85184,5055),(85185,5055),(85186,5056),(85187,5056),(85188,5056),(85189,5056),(85190,5056),(85191,5056),(85192,5057),(85193,5057),(85194,5057),(85195,5057),(85196,5057),(85197,5057),(85198,5058),(85199,5058),(85200,5058),(85201,5058),(85202,5058),(85203,5058),(85204,5059),(85205,5059),(85206,5059),(85207,5059),(85208,5059),(85209,5059),(85210,5060),(85211,5060),(85212,5060),(85213,5060),(85214,5060),(85215,5060),(85216,5061),(85217,5061),(85218,5061),(85219,5061),(85220,5061),(85221,5061),(85222,5062),(85223,5062),(85224,5062),(85225,5062),(85226,5063),(85227,5063),(85228,5063),(85229,5063),(85230,5064),(85231,5064),(85232,5064),(85233,5064),(85234,5065),(85235,5065),(85236,5065),(85237,5065),(85238,5065),(85239,5065),(85240,5066),(85241,5066),(85242,5066),(85243,5066),(85244,5066),(85245,5066),(85246,5067),(85247,5067),(85248,5067),(85249,5067),(85250,5068),(85251,5068),(85252,5068),(85253,5068),(85254,5069),(85255,5069),(85256,5069),(85257,5069),(85258,5070),(85259,5070),(85260,5070),(85261,5070),(85262,5070),(85263,5070),(85264,5071),(85265,5071),(85266,5071),(85267,5071),(85268,5071),(85269,5071),(85270,5072),(85271,5072),(85272,5072),(85273,5072),(85274,5072),(85275,5072),(85276,5073),(85277,5073),(85278,5073),(85279,5073),(85280,5074),(85281,5074),(85282,5074),(85283,5074),(85284,5075),(85285,5075),(85286,5075),(85287,5075),(85288,5076),(85289,5076),(85290,5076),(85291,5076),(85292,5077),(85293,5077),(85294,5077),(85295,5077),(85296,5077),(85297,5077),(85298,5078),(85299,5078),(85300,5078),(85301,5078),(85302,5078),(85303,5078),(85304,5079),(85305,5079),(85306,5079),(85307,5079),(85308,5079),(85309,5079),(85310,4980),(85311,4980),(85312,4980),(85313,4981),(85314,4981),(85315,4981),(85316,4982),(85317,4982),(85318,4982),(85319,4983),(85320,4983),(85321,4983),(85322,4984),(85323,4984),(85324,4984),(85325,4985),(85326,4985),(85327,4985),(85328,4986),(85329,4986),(85330,4986),(85331,4987),(85332,4987),(85333,4987),(85334,4988),(85335,4988),(85336,4988),(85337,4989),(85338,4989),(85339,4989),(85340,4990),(85341,4990),(85342,4990),(85343,4991),(85344,4991),(85345,4991),(85346,4992),(85347,4992),(85348,4992),(85349,4993),(85350,4993),(85351,4993),(85352,4994),(85353,4994),(85354,4994),(85355,4995),(85356,4995),(85357,4995),(85358,4996),(85359,4996),(85360,4996),(85361,4997),(85362,4997),(85363,4997),(85364,4998),(85365,4998),(85366,4998),(85367,4999),(85368,4999),(85369,4999),(85370,5000),(85371,5000),(85372,5000),(85373,5001),(85374,5001),(85375,5001),(85376,5002),(85377,5002),(85378,5002),(85379,5003),(85380,5003),(85381,5003),(85382,5004),(85383,5004),(85384,5004),(85385,5005),(85386,5005),(85387,5005),(85388,5006),(85389,5006),(85390,5006),(85391,5007),(85392,5007),(85393,5007),(85394,5008),(85395,5008),(85396,5008),(85397,5009),(85398,5009),(85399,5009),(85400,5010),(85401,5010),(85402,5010),(85403,5011),(85404,5011),(85405,5011),(85406,5012),(85407,5012),(85408,5012),(85409,5013),(85410,5013),(85411,5013),(85412,5014),(85413,5014),(85414,5014),(85415,5015),(85416,5015),(85417,5015),(85418,5016),(85419,5016),(85420,5016),(85421,5017),(85422,5017),(85423,5017),(85424,5018),(85425,5018),(85426,5018),(85427,5019),(85428,5019),(85429,5019),(85430,5020),(85431,5020),(85432,5020),(85433,5021),(85434,5021),(85435,5022),(85436,5022),(85437,5023),(85438,5023),(85439,5024),(85440,5024),(85441,5024),(85442,5025),(85443,5025),(85444,5025),(85445,5026),(85446,5026),(85447,5027),(85448,5027),(85449,5028),(85450,5028),(85451,5029),(85452,5029),(85453,5030),(85454,5030),(85455,5031),(85456,5031),(85457,5032),(85458,5032),(85459,5033),(85460,5033),(85461,5034),(85462,5034),(85463,5035),(85464,5035),(85465,5036),(85466,5036),(85467,5037),(85468,5037),(85469,5038),(85470,5038),(85471,5039),(85472,5039),(85473,5039),(85474,5040),(85475,5040),(85476,5040),(85477,5041),(85478,5041),(85479,5041),(85480,5042),(85481,5042),(85482,5042),(85483,5043),(85484,5043),(85485,5043),(85486,5044),(85487,5044),(85488,5044),(85489,5045),(85490,5045),(85491,5045),(85492,5046),(85493,5046),(85494,5046),(85495,5047),(85496,5047),(85497,5047),(85498,5048),(85499,5048),(85500,5048),(85501,5049),(85502,5049),(85503,5049),(85504,5050),(85505,5050),(85506,5050),(85507,5051),(85508,5051),(85509,5051),(85510,5052),(85511,5052),(85512,5052),(85513,5053),(85514,5053),(85515,5053),(85516,5054),(85517,5054),(85518,5054),(85519,5055),(85520,5055),(85521,5055),(85522,5056),(85523,5056),(85524,5056),(85525,5057),(85526,5057),(85527,5057),(85528,5058),(85529,5058),(85530,5058),(85531,5059),(85532,5059),(85533,5059),(85534,5060),(85535,5060),(85536,5060),(85537,5061),(85538,5061),(85539,5061),(85540,5062),(85541,5062),(85542,5063),(85543,5063),(85544,5064),(85545,5064),(85546,5065),(85547,5065),(85548,5065),(85549,5066),(85550,5066),(85551,5066),(85552,5067),(85553,5067),(85554,5068),(85555,5068),(85556,5069),(85557,5069),(85558,5070),(85559,5070),(85560,5070),(85561,5071),(85562,5071),(85563,5071),(85564,5072),(85565,5072),(85566,5072),(85567,5073),(85568,5073),(85569,5074),(85570,5074),(85571,5075),(85572,5075),(85573,5076),(85574,5076),(85575,5077),(85576,5077),(85577,5078),(85578,5078),(85579,5079),(85580,5079),(85581,4980),(85582,4980),(85583,4980),(85584,4981),(85585,4981),(85586,4981),(85587,4982),(85588,4982),(85589,4982),(85590,4983),(85591,4983),(85592,4983),(85593,4984),(85594,4984),(85595,4984),(85596,4985),(85597,4985),(85598,4985),(85599,4986),(85600,4986),(85601,4986),(85602,4987),(85603,4987),(85604,4987),(85605,4988),(85606,4988),(85607,4988),(85608,4989),(85609,4989),(85610,4989),(85611,4990),(85612,4990),(85613,4990),(85614,4991),(85615,4991),(85616,4991),(85617,4992),(85618,4992),(85619,4992),(85620,4993),(85621,4993),(85622,4993),(85623,4994),(85624,4994),(85625,4994),(85626,4995),(85627,4995),(85628,4995),(85629,4996),(85630,4996),(85631,4996),(85632,4997),(85633,4997),(85634,4997),(85635,4998),(85636,4998),(85637,4998),(85638,4999),(85639,4999),(85640,4999),(85641,5000),(85642,5000),(85643,5000),(85644,5001),(85645,5001),(85646,5001),(85647,5002),(85648,5002),(85649,5002),(85650,5003),(85651,5003),(85652,5003),(85653,5004),(85654,5004),(85655,5004),(85656,5005),(85657,5005),(85658,5005),(85659,5006),(85660,5006),(85661,5006),(85662,5007),(85663,5007),(85664,5007),(85665,5008),(85666,5008),(85667,5008),(85668,5009),(85669,5009),(85670,5009),(85671,5010),(85672,5010),(85673,5010),(85674,5011),(85675,5011),(85676,5011),(85677,5012),(85678,5012),(85679,5012),(85680,5013),(85681,5013),(85682,5013),(85683,5014),(85684,5014),(85685,5014),(85686,5015),(85687,5015),(85688,5015),(85689,5016),(85690,5016),(85691,5016),(85692,5017),(85693,5017),(85694,5017),(85695,5018),(85696,5018),(85697,5018),(85698,5019),(85699,5019),(85700,5019),(85701,5020),(85702,5020),(85703,5020),(85704,5021),(85705,5021),(85706,5021),(85707,5022),(85708,5022),(85709,5023),(85710,5023),(85711,5023),(85712,5024),(85713,5024),(85714,5024),(85715,5025),(85716,5025),(85717,5025),(85718,5026),(85719,5026),(85720,5026),(85721,5027),(85722,5027),(85723,5027),(85724,5028),(85725,5028),(85726,5028),(85727,5029),(85728,5029),(85729,5029),(85730,5030),(85731,5030),(85732,5030),(85733,5031),(85734,5031),(85735,5031),(85736,5032),(85737,5032),(85738,5032),(85739,5033),(85740,5033),(85741,5033),(85742,5034),(85743,5034),(85744,5034),(85745,5035),(85746,5035),(85747,5035),(85748,5036),(85749,5036),(85750,5036),(85751,5037),(85752,5037),(85753,5037),(85754,5038),(85755,5038),(85756,5038),(85757,5039),(85758,5039),(85759,5039),(85760,5040),(85761,5040),(85762,5040),(85763,5041),(85764,5041),(85765,5041),(85766,5042),(85767,5042),(85768,5042),(85769,5043),(85770,5043),(85771,5043),(85772,5044),(85773,5044),(85774,5044),(85775,5045),(85776,5045),(85777,5045),(85778,5046),(85779,5046),(85780,5046),(85781,5047),(85782,5047),(85783,5047),(85784,5048),(85785,5048),(85786,5048),(85787,5049),(85788,5049),(85789,5049),(85790,5050),(85791,5050),(85792,5050),(85793,5051),(85794,5051),(85795,5051),(85796,5052),(85797,5052),(85798,5052),(85799,5053),(85800,5053),(85801,5053),(85802,5054),(85803,5054),(85804,5054),(85805,5055),(85806,5055),(85807,5055),(85808,5056),(85809,5056),(85810,5056),(85811,5057),(85812,5057),(85813,5057),(85814,5058),(85815,5058),(85816,5058),(85817,5059),(85818,5059),(85819,5059),(85820,5060),(85821,5060),(85822,5060),(85823,5061),(85824,5061),(85825,5061),(85826,5062),(85827,5062),(85828,5062),(85829,5063),(85830,5063),(85831,5063),(85832,5064),(85833,5064),(85834,5064),(85835,5065),(85836,5065),(85837,5065),(85838,5066),(85839,5066),(85840,5066),(85841,5067),(85842,5067),(85843,5067),(85844,5068),(85845,5068),(85846,5068),(85847,5069),(85848,5069),(85849,5069),(85850,5070),(85851,5070),(85852,5070),(85853,5071),(85854,5071),(85855,5071),(85856,5072),(85857,5072),(85858,5072),(85859,5073),(85860,5073),(85861,5073),(85862,5074),(85863,5074),(85864,5074),(85865,5075),(85866,5075),(85867,5075),(85868,5076),(85869,5076),(85870,5076),(85871,5077),(85872,5077),(85873,5077),(85874,5078),(85875,5078),(85876,5078),(85877,5079),(85878,5079),(85879,5079),(85880,4980),(85881,4980),(85882,4980),(85883,4980),(85884,4981),(85885,4981),(85886,4981),(85887,4981),(85888,4982),(85889,4982),(85890,4982),(85891,4982),(85892,4983),(85893,4983),(85894,4983),(85895,4983),(85896,4984),(85897,4984),(85898,4984),(85899,4984),(85900,4985),(85901,4985),(85902,4985),(85903,4985),(85904,4986),(85905,4986),(85906,4986),(85907,4986),(85908,4987),(85909,4987),(85910,4987),(85911,4987),(85912,4988),(85913,4988),(85914,4988),(85915,4988),(85916,4989),(85917,4989),(85918,4989),(85919,4989),(85920,4990),(85921,4990),(85922,4990),(85923,4990),(85924,4991),(85925,4991),(85926,4991),(85927,4991),(85928,4992),(85929,4992),(85930,4992),(85931,4992),(85932,4993),(85933,4993),(85934,4993),(85935,4993),(85936,4994),(85937,4994),(85938,4994),(85939,4994),(85940,4995),(85941,4995),(85942,4995),(85943,4995),(85944,4996),(85945,4996),(85946,4996),(85947,4996),(85948,4997),(85949,4997),(85950,4997),(85951,4997),(85952,4998),(85953,4998),(85954,4998),(85955,4998),(85956,4999),(85957,4999),(85958,4999),(85959,4999),(85960,5000),(85961,5000),(85962,5000),(85963,5000),(85964,5001),(85965,5001),(85966,5001),(85967,5001),(85968,5002),(85969,5002),(85970,5002),(85971,5002),(85972,5003),(85973,5003),(85974,5003),(85975,5003),(85976,5004),(85977,5004),(85978,5004),(85979,5004),(85980,5005),(85981,5005),(85982,5005),(85983,5005),(85984,5006),(85985,5006),(85986,5006),(85987,5006),(85988,5007),(85989,5007),(85990,5007),(85991,5007),(85992,5008),(85993,5008),(85994,5008),(85995,5008),(85996,5009),(85997,5009),(85998,5009),(85999,5009),(86000,5010),(86001,5010),(86002,5010),(86003,5010),(86004,5011),(86005,5011),(86006,5011),(86007,5011),(86008,5012),(86009,5012),(86010,5012),(86011,5012),(86012,5013),(86013,5013),(86014,5013),(86015,5013),(86016,5014),(86017,5014),(86018,5014),(86019,5014),(86020,5015),(86021,5015),(86022,5015),(86023,5015),(86024,5016),(86025,5016),(86026,5016),(86027,5016),(86028,5017),(86029,5017),(86030,5017),(86031,5017),(86032,5018),(86033,5018),(86034,5018),(86035,5018),(86036,5019),(86037,5019),(86038,5019),(86039,5019),(86040,5020),(86041,5020),(86042,5020),(86043,5020),(86044,5021),(86045,5021),(86046,5021),(86047,5021),(86048,5022),(86049,5022),(86050,5022),(86051,5022),(86052,5023),(86053,5023),(86054,5023),(86055,5023),(86056,5024),(86057,5024),(86058,5024),(86059,5024),(86060,5025),(86061,5025),(86062,5025),(86063,5025),(86064,5026),(86065,5026),(86066,5026),(86067,5026),(86068,5027),(86069,5027),(86070,5027),(86071,5027),(86072,5028),(86073,5028),(86074,5028),(86075,5028),(86076,5029),(86077,5029),(86078,5029),(86079,5029),(86080,5030),(86081,5030),(86082,5030),(86083,5030),(86084,5031),(86085,5031),(86086,5031),(86087,5031),(86088,5032),(86089,5032),(86090,5032),(86091,5032),(86092,5033),(86093,5033),(86094,5033),(86095,5033),(86096,5034),(86097,5034),(86098,5034),(86099,5034),(86100,5035),(86101,5035),(86102,5035),(86103,5035),(86104,5036),(86105,5036),(86106,5036),(86107,5036),(86108,5037),(86109,5037),(86110,5037),(86111,5037),(86112,5038),(86113,5038),(86114,5038),(86115,5038),(86116,5039),(86117,5039),(86118,5039),(86119,5039),(86120,5040),(86121,5040),(86122,5040),(86123,5040),(86124,5041),(86125,5041),(86126,5041),(86127,5041),(86128,5042),(86129,5042),(86130,5042),(86131,5042),(86132,5043),(86133,5043),(86134,5043),(86135,5043),(86136,5044),(86137,5044),(86138,5044),(86139,5044),(86140,5045),(86141,5045),(86142,5045),(86143,5045),(86144,5046),(86145,5046),(86146,5046),(86147,5046),(86148,5047),(86149,5047),(86150,5047),(86151,5047),(86152,5048),(86153,5048),(86154,5048),(86155,5048),(86156,5049),(86157,5049),(86158,5049),(86159,5049),(86160,5050),(86161,5050),(86162,5050),(86163,5050),(86164,5051),(86165,5051),(86166,5051),(86167,5051),(86168,5052),(86169,5052),(86170,5052),(86171,5052),(86172,5053),(86173,5053),(86174,5053),(86175,5053),(86176,5054),(86177,5054),(86178,5054),(86179,5054),(86180,5055),(86181,5055),(86182,5055),(86183,5055),(86184,5056),(86185,5056),(86186,5056),(86187,5056),(86188,5057),(86189,5057),(86190,5057),(86191,5057),(86192,5058),(86193,5058),(86194,5058),(86195,5058),(86196,5059),(86197,5059),(86198,5059),(86199,5059),(86200,5060),(86201,5060),(86202,5060),(86203,5060),(86204,5061),(86205,5061),(86206,5061),(86207,5061),(86208,5062),(86209,5062),(86210,5062),(86211,5062),(86212,5063),(86213,5063),(86214,5063),(86215,5063),(86216,5064),(86217,5064),(86218,5064),(86219,5064),(86220,5065),(86221,5065),(86222,5065),(86223,5065),(86224,5066),(86225,5066),(86226,5066),(86227,5066),(86228,5067),(86229,5067),(86230,5067),(86231,5067),(86232,5068),(86233,5068),(86234,5068),(86235,5068),(86236,5069),(86237,5069),(86238,5069),(86239,5069),(86240,5070),(86241,5070),(86242,5070),(86243,5070),(86244,5071),(86245,5071),(86246,5071),(86247,5071),(86248,5072),(86249,5072),(86250,5072),(86251,5072),(86252,5073),(86253,5073),(86254,5073),(86255,5073),(86256,5074),(86257,5074),(86258,5074),(86259,5074),(86260,5075),(86261,5075),(86262,5075),(86263,5075),(86264,5076),(86265,5076),(86266,5076),(86267,5076),(86268,5077),(86269,5077),(86270,5077),(86271,5077),(86272,5078),(86273,5078),(86274,5078),(86275,5078),(86276,5079),(86277,5079),(86278,5079),(86279,5079),(86280,5080),(86281,5081),(86282,5082),(86283,5083),(86284,5084),(86285,5085),(86286,5086),(86287,5087),(86288,5088),(86289,5089),(86290,5090),(86291,5091),(86292,5092),(86293,5093),(86294,5094),(86295,5095),(86296,5096),(86297,5097),(86298,5098),(86299,5099),(86300,5100),(86301,5101),(86302,5102),(86303,5103),(86304,5104),(86305,5105),(86306,5106),(86307,5107),(86308,5108),(86309,5109),(86310,5110),(86311,5111),(86312,5112),(86313,5113),(86314,5114),(86315,5115),(86316,5116),(86317,5117),(86318,5118),(86319,5119),(86320,5120),(86321,5121),(86322,5122),(86323,5123),(86324,5124),(86325,5125),(86326,5126),(86327,5127),(86328,5128),(86329,5129),(86330,5130),(86331,5131),(86332,5132),(86333,5133),(86334,5134),(86335,5135),(86336,5136),(86337,5137),(86338,5138),(86339,5139),(86340,5140),(86341,5141),(86342,5142),(86343,5143),(86344,5144),(86345,5145),(86346,5146),(86347,5147),(86348,5148),(86349,5149),(86350,5150),(86351,5151),(86352,5152),(86353,5153),(86354,5154),(86355,5155),(86356,5156),(86357,5157),(86358,5158),(86359,5159),(86360,5160),(86361,5161),(86362,5162),(86363,5163),(86364,5164),(86365,5165),(86366,5166),(86367,5167),(86368,5168),(86369,5169),(86370,5170),(86371,5171),(86372,5172),(86373,5173),(86374,5174),(86375,5175),(86376,5176),(86377,5177),(86378,5178),(86379,5179),(86380,5080),(86381,5080),(86382,5080),(86383,5080),(86384,5080),(86385,5080),(86386,5081),(86387,5081),(86388,5081),(86389,5081),(86390,5081),(86391,5081),(86392,5082),(86393,5082),(86394,5082),(86395,5082),(86396,5082),(86397,5082),(86398,5083),(86399,5083),(86400,5083),(86401,5083),(86402,5083),(86403,5083),(86404,5084),(86405,5084),(86406,5084),(86407,5084),(86408,5084),(86409,5084),(86410,5085),(86411,5085),(86412,5085),(86413,5085),(86414,5085),(86415,5085),(86416,5086),(86417,5086),(86418,5086),(86419,5086),(86420,5086),(86421,5086),(86422,5087),(86423,5087),(86424,5087),(86425,5087),(86426,5087),(86427,5087),(86428,5088),(86429,5088),(86430,5088),(86431,5088),(86432,5089),(86433,5089),(86434,5089),(86435,5089),(86436,5090),(86437,5090),(86438,5090),(86439,5090),(86440,5090),(86441,5090),(86442,5091),(86443,5091),(86444,5091),(86445,5091),(86446,5091),(86447,5091),(86448,5092),(86449,5092),(86450,5092),(86451,5092),(86452,5092),(86453,5092),(86454,5093),(86455,5093),(86456,5093),(86457,5093),(86458,5093),(86459,5093),(86460,5094),(86461,5094),(86462,5094),(86463,5094),(86464,5094),(86465,5094),(86466,5095),(86467,5095),(86468,5095),(86469,5095),(86470,5095),(86471,5095),(86472,5096),(86473,5096),(86474,5096),(86475,5096),(86476,5096),(86477,5096),(86478,5097),(86479,5097),(86480,5097),(86481,5097),(86482,5097),(86483,5097),(86484,5098),(86485,5098),(86486,5098),(86487,5098),(86488,5098),(86489,5098),(86490,5099),(86491,5099),(86492,5099),(86493,5099),(86494,5099),(86495,5099),(86496,5100),(86497,5100),(86498,5100),(86499,5100),(86500,5100),(86501,5100),(86502,5101),(86503,5101),(86504,5101),(86505,5101),(86506,5101),(86507,5101),(86508,5102),(86509,5102),(86510,5102),(86511,5102),(86512,5102),(86513,5102),(86514,5103),(86515,5103),(86516,5103),(86517,5103),(86518,5103),(86519,5103),(86520,5104),(86521,5104),(86522,5104),(86523,5104),(86524,5104),(86525,5104),(86526,5105),(86527,5105),(86528,5105),(86529,5105),(86530,5105),(86531,5105),(86532,5106),(86533,5106),(86534,5106),(86535,5106),(86536,5107),(86537,5107),(86538,5107),(86539,5107),(86540,5108),(86541,5108),(86542,5108),(86543,5108),(86544,5109),(86545,5109),(86546,5109),(86547,5109),(86548,5110),(86549,5110),(86550,5110),(86551,5110),(86552,5110),(86553,5110),(86554,5111),(86555,5111),(86556,5111),(86557,5111),(86558,5111),(86559,5111),(86560,5112),(86561,5112),(86562,5112),(86563,5112),(86564,5112),(86565,5112),(86566,5113),(86567,5113),(86568,5113),(86569,5113),(86570,5113),(86571,5113),(86572,5114),(86573,5114),(86574,5114),(86575,5114),(86576,5114),(86577,5114),(86578,5115),(86579,5115),(86580,5115),(86581,5115),(86582,5115),(86583,5115),(86584,5116),(86585,5116),(86586,5116),(86587,5116),(86588,5116),(86589,5116),(86590,5117),(86591,5117),(86592,5117),(86593,5117),(86594,5117),(86595,5117),(86596,5118),(86597,5118),(86598,5118),(86599,5118),(86600,5118),(86601,5118),(86602,5119),(86603,5119),(86604,5119),(86605,5119),(86606,5119),(86607,5119),(86608,5120),(86609,5120),(86610,5120),(86611,5120),(86612,5120),(86613,5120),(86614,5121),(86615,5121),(86616,5121),(86617,5121),(86618,5121),(86619,5121),(86620,5122),(86621,5122),(86622,5122),(86623,5122),(86624,5122),(86625,5122),(86626,5123),(86627,5123),(86628,5123),(86629,5123),(86630,5123),(86631,5123),(86632,5124),(86633,5124),(86634,5124),(86635,5124),(86636,5124),(86637,5124),(86638,5125),(86639,5125),(86640,5125),(86641,5125),(86642,5125),(86643,5125),(86644,5126),(86645,5126),(86646,5126),(86647,5126),(86648,5126),(86649,5126),(86650,5127),(86651,5127),(86652,5127),(86653,5127),(86654,5127),(86655,5127),(86656,5128),(86657,5128),(86658,5128),(86659,5128),(86660,5128),(86661,5128),(86662,5129),(86663,5129),(86664,5129),(86665,5129),(86666,5129),(86667,5129),(86668,5130),(86669,5130),(86670,5130),(86671,5130),(86672,5130),(86673,5130),(86674,5131),(86675,5131),(86676,5131),(86677,5131),(86678,5131),(86679,5131),(86680,5132),(86681,5132),(86682,5132),(86683,5132),(86684,5133),(86685,5133),(86686,5133),(86687,5133),(86688,5134),(86689,5134),(86690,5134),(86691,5134),(86692,5135),(86693,5135),(86694,5135),(86695,5135),(86696,5136),(86697,5136),(86698,5136),(86699,5136),(86700,5136),(86701,5136),(86702,5137),(86703,5137),(86704,5137),(86705,5137),(86706,5137),(86707,5137),(86708,5138),(86709,5138),(86710,5138),(86711,5138),(86712,5138),(86713,5138),(86714,5139),(86715,5139),(86716,5139),(86717,5139),(86718,5139),(86719,5139),(86720,5140),(86721,5140),(86722,5140),(86723,5140),(86724,5141),(86725,5141),(86726,5141),(86727,5141),(86728,5142),(86729,5142),(86730,5142),(86731,5142),(86732,5142),(86733,5142),(86734,5143),(86735,5143),(86736,5143),(86737,5143),(86738,5144),(86739,5144),(86740,5144),(86741,5144),(86742,5145),(86743,5145),(86744,5145),(86745,5145),(86746,5146),(86747,5146),(86748,5146),(86749,5146),(86750,5147),(86751,5147),(86752,5147),(86753,5147),(86754,5147),(86755,5147),(86756,5148),(86757,5148),(86758,5148),(86759,5148),(86760,5148),(86761,5148),(86762,5149),(86763,5149),(86764,5149),(86765,5149),(86766,5149),(86767,5149),(86768,5150),(86769,5150),(86770,5150),(86771,5150),(86772,5150),(86773,5150),(86774,5151),(86775,5151),(86776,5151),(86777,5151),(86778,5151),(86779,5151),(86780,5152),(86781,5152),(86782,5152),(86783,5152),(86784,5152),(86785,5152),(86786,5153),(86787,5153),(86788,5153),(86789,5153),(86790,5153),(86791,5153),(86792,5154),(86793,5154),(86794,5154),(86795,5154),(86796,5154),(86797,5154),(86798,5155),(86799,5155),(86800,5155),(86801,5155),(86802,5155),(86803,5155),(86804,5156),(86805,5156),(86806,5156),(86807,5156),(86808,5156),(86809,5156),(86810,5157),(86811,5157),(86812,5157),(86813,5157),(86814,5157),(86815,5157),(86816,5158),(86817,5158),(86818,5158),(86819,5158),(86820,5158),(86821,5158),(86822,5159),(86823,5159),(86824,5159),(86825,5159),(86826,5159),(86827,5159),(86828,5160),(86829,5160),(86830,5160),(86831,5160),(86832,5160),(86833,5160),(86834,5161),(86835,5161),(86836,5161),(86837,5161),(86838,5161),(86839,5161),(86840,5162),(86841,5162),(86842,5162),(86843,5162),(86844,5163),(86845,5163),(86846,5163),(86847,5163),(86848,5163),(86849,5163),(86850,5164),(86851,5164),(86852,5164),(86853,5164),(86854,5164),(86855,5164),(86856,5165),(86857,5165),(86858,5165),(86859,5165),(86860,5166),(86861,5166),(86862,5166),(86863,5166),(86864,5166),(86865,5166),(86866,5167),(86867,5167),(86868,5167),(86869,5167),(86870,5167),(86871,5167),(86872,5168),(86873,5168),(86874,5168),(86875,5168),(86876,5168),(86877,5168),(86878,5169),(86879,5169),(86880,5169),(86881,5169),(86882,5170),(86883,5170),(86884,5170),(86885,5170),(86886,5171),(86887,5171),(86888,5171),(86889,5171),(86890,5171),(86891,5171),(86892,5172),(86893,5172),(86894,5172),(86895,5172),(86896,5172),(86897,5172),(86898,5173),(86899,5173),(86900,5173),(86901,5173),(86902,5173),(86903,5173),(86904,5174),(86905,5174),(86906,5174),(86907,5174),(86908,5174),(86909,5174),(86910,5175),(86911,5175),(86912,5175),(86913,5175),(86914,5175),(86915,5175),(86916,5176),(86917,5176),(86918,5176),(86919,5176),(86920,5176),(86921,5176),(86922,5177),(86923,5177),(86924,5177),(86925,5177),(86926,5177),(86927,5177),(86928,5178),(86929,5178),(86930,5178),(86931,5178),(86932,5178),(86933,5178),(86934,5179),(86935,5179),(86936,5179),(86937,5179),(86938,5179),(86939,5179),(86940,5080),(86941,5080),(86942,5081),(86943,5081),(86944,5082),(86945,5082),(86946,5083),(86947,5083),(86948,5084),(86949,5084),(86950,5085),(86951,5085),(86952,5086),(86953,5086),(86954,5087),(86955,5087),(86956,5088),(86957,5088),(86958,5089),(86959,5089),(86960,5090),(86961,5090),(86962,5091),(86963,5091),(86964,5091),(86965,5092),(86966,5092),(86967,5092),(86968,5093),(86969,5093),(86970,5094),(86971,5094),(86972,5095),(86973,5095),(86974,5096),(86975,5096),(86976,5097),(86977,5097),(86978,5097),(86979,5098),(86980,5098),(86981,5098),(86982,5099),(86983,5099),(86984,5099),(86985,5100),(86986,5100),(86987,5100),(86988,5101),(86989,5101),(86990,5101),(86991,5102),(86992,5102),(86993,5102),(86994,5103),(86995,5103),(86996,5103),(86997,5104),(86998,5104),(86999,5104),(87000,5105),(87001,5105),(87002,5105),(87003,5106),(87004,5106),(87005,5107),(87006,5107),(87007,5108),(87008,5108),(87009,5109),(87010,5109),(87011,5110),(87012,5110),(87013,5110),(87014,5111),(87015,5111),(87016,5111),(87017,5112),(87018,5112),(87019,5112),(87020,5113),(87021,5113),(87022,5113),(87023,5114),(87024,5114),(87025,5114),(87026,5115),(87027,5115),(87028,5115),(87029,5116),(87030,5116),(87031,5116),(87032,5117),(87033,5117),(87034,5117),(87035,5118),(87036,5118),(87037,5119),(87038,5119),(87039,5119),(87040,5120),(87041,5120),(87042,5120),(87043,5121),(87044,5121),(87045,5122),(87046,5122),(87047,5122),(87048,5123),(87049,5123),(87050,5123),(87051,5124),(87052,5124),(87053,5124),(87054,5125),(87055,5125),(87056,5125),(87057,5126),(87058,5126),(87059,5126),(87060,5127),(87061,5127),(87062,5127),(87063,5128),(87064,5128),(87065,5128),(87066,5129),(87067,5129),(87068,5129),(87069,5130),(87070,5130),(87071,5130),(87072,5131),(87073,5131),(87074,5131),(87075,5132),(87076,5132),(87077,5133),(87078,5133),(87079,5134),(87080,5134),(87081,5135),(87082,5135),(87083,5136),(87084,5136),(87085,5136),(87086,5137),(87087,5137),(87088,5137),(87089,5138),(87090,5138),(87091,5138),(87092,5139),(87093,5139),(87094,5139),(87095,5140),(87096,5140),(87097,5141),(87098,5141),(87099,5142),(87100,5142),(87101,5142),(87102,5143),(87103,5143),(87104,5144),(87105,5144),(87106,5145),(87107,5145),(87108,5146),(87109,5146),(87110,5147),(87111,5147),(87112,5147),(87113,5148),(87114,5148),(87115,5148),(87116,5149),(87117,5149),(87118,5149),(87119,5150),(87120,5150),(87121,5150),(87122,5151),(87123,5151),(87124,5152),(87125,5152),(87126,5153),(87127,5153),(87128,5154),(87129,5154),(87130,5155),(87131,5155),(87132,5156),(87133,5156),(87134,5157),(87135,5157),(87136,5158),(87137,5158),(87138,5159),(87139,5159),(87140,5159),(87141,5160),(87142,5160),(87143,5160),(87144,5161),(87145,5161),(87146,5161),(87147,5162),(87148,5162),(87149,5163),(87150,5163),(87151,5163),(87152,5164),(87153,5164),(87154,5164),(87155,5165),(87156,5165),(87157,5166),(87158,5166),(87159,5166),(87160,5167),(87161,5167),(87162,5167),(87163,5168),(87164,5168),(87165,5168),(87166,5169),(87167,5169),(87168,5170),(87169,5170),(87170,5171),(87171,5171),(87172,5171),(87173,5172),(87174,5172),(87175,5172),(87176,5173),(87177,5173),(87178,5173),(87179,5174),(87180,5174),(87181,5174),(87182,5175),(87183,5175),(87184,5175),(87185,5176),(87186,5176),(87187,5176),(87188,5177),(87189,5177),(87190,5177),(87191,5178),(87192,5178),(87193,5178),(87194,5179),(87195,5179),(87196,5179),(87197,5080),(87198,5080),(87199,5080),(87200,5081),(87201,5081),(87202,5081),(87203,5082),(87204,5082),(87205,5082),(87206,5083),(87207,5083),(87208,5083),(87209,5084),(87210,5084),(87211,5084),(87212,5085),(87213,5085),(87214,5085),(87215,5086),(87216,5086),(87217,5086),(87218,5087),(87219,5087),(87220,5087),(87221,5088),(87222,5088),(87223,5088),(87224,5089),(87225,5089),(87226,5089),(87227,5090),(87228,5090),(87229,5090),(87230,5091),(87231,5091),(87232,5091),(87233,5092),(87234,5092),(87235,5092),(87236,5093),(87237,5093),(87238,5093),(87239,5094),(87240,5094),(87241,5094),(87242,5095),(87243,5095),(87244,5095),(87245,5096),(87246,5096),(87247,5096),(87248,5097),(87249,5097),(87250,5097),(87251,5098),(87252,5098),(87253,5098),(87254,5099),(87255,5099),(87256,5099),(87257,5100),(87258,5100),(87259,5100),(87260,5101),(87261,5101),(87262,5101),(87263,5102),(87264,5102),(87265,5102),(87266,5103),(87267,5103),(87268,5103),(87269,5104),(87270,5104),(87271,5104),(87272,5105),(87273,5105),(87274,5105),(87275,5106),(87276,5106),(87277,5106),(87278,5107),(87279,5107),(87280,5107),(87281,5108),(87282,5108),(87283,5108),(87284,5109),(87285,5109),(87286,5109),(87287,5110),(87288,5110),(87289,5110),(87290,5111),(87291,5111),(87292,5111),(87293,5112),(87294,5112),(87295,5112),(87296,5113),(87297,5113),(87298,5113),(87299,5114),(87300,5114),(87301,5114),(87302,5115),(87303,5115),(87304,5115),(87305,5116),(87306,5116),(87307,5116),(87308,5117),(87309,5117),(87310,5117),(87311,5118),(87312,5118),(87313,5118),(87314,5119),(87315,5119),(87316,5119),(87317,5120),(87318,5120),(87319,5120),(87320,5121),(87321,5121),(87322,5121),(87323,5122),(87324,5122),(87325,5122),(87326,5123),(87327,5123),(87328,5123),(87329,5124),(87330,5124),(87331,5124),(87332,5125),(87333,5125),(87334,5125),(87335,5126),(87336,5126),(87337,5126),(87338,5127),(87339,5127),(87340,5127),(87341,5128),(87342,5128),(87343,5128),(87344,5129),(87345,5129),(87346,5129),(87347,5130),(87348,5130),(87349,5130),(87350,5131),(87351,5131),(87352,5131),(87353,5132),(87354,5132),(87355,5132),(87356,5133),(87357,5133),(87358,5133),(87359,5134),(87360,5134),(87361,5134),(87362,5135),(87363,5135),(87364,5135),(87365,5136),(87366,5136),(87367,5136),(87368,5137),(87369,5137),(87370,5137),(87371,5138),(87372,5138),(87373,5138),(87374,5139),(87375,5139),(87376,5139),(87377,5140),(87378,5140),(87379,5140),(87380,5141),(87381,5141),(87382,5141),(87383,5142),(87384,5142),(87385,5142),(87386,5143),(87387,5143),(87388,5143),(87389,5144),(87390,5144),(87391,5144),(87392,5145),(87393,5145),(87394,5145),(87395,5146),(87396,5146),(87397,5146),(87398,5147),(87399,5147),(87400,5147),(87401,5148),(87402,5148),(87403,5148),(87404,5149),(87405,5149),(87406,5149),(87407,5150),(87408,5150),(87409,5150),(87410,5151),(87411,5151),(87412,5151),(87413,5152),(87414,5152),(87415,5152),(87416,5153),(87417,5153),(87418,5153),(87419,5154),(87420,5154),(87421,5154),(87422,5155),(87423,5155),(87424,5155),(87425,5156),(87426,5156),(87427,5156),(87428,5157),(87429,5157),(87430,5157),(87431,5158),(87432,5158),(87433,5158),(87434,5159),(87435,5159),(87436,5159),(87437,5160),(87438,5160),(87439,5160),(87440,5161),(87441,5161),(87442,5161),(87443,5162),(87444,5162),(87445,5162),(87446,5163),(87447,5163),(87448,5163),(87449,5164),(87450,5164),(87451,5164),(87452,5165),(87453,5165),(87454,5165),(87455,5166),(87456,5166),(87457,5166),(87458,5167),(87459,5167),(87460,5167),(87461,5168),(87462,5168),(87463,5168),(87464,5169),(87465,5169),(87466,5169),(87467,5170),(87468,5170),(87469,5170),(87470,5171),(87471,5171),(87472,5172),(87473,5172),(87474,5172),(87475,5173),(87476,5173),(87477,5173),(87478,5174),(87479,5174),(87480,5174),(87481,5175),(87482,5175),(87483,5175),(87484,5176),(87485,5176),(87486,5176),(87487,5177),(87488,5177),(87489,5177),(87490,5178),(87491,5178),(87492,5178),(87493,5179),(87494,5179),(87495,5179),(87496,5080),(87497,5080),(87498,5080),(87499,5080),(87500,5081),(87501,5081),(87502,5081),(87503,5081),(87504,5082),(87505,5082),(87506,5082),(87507,5082),(87508,5083),(87509,5083),(87510,5083),(87511,5083),(87512,5084),(87513,5084),(87514,5084),(87515,5084),(87516,5085),(87517,5085),(87518,5085),(87519,5085),(87520,5086),(87521,5086),(87522,5086),(87523,5086),(87524,5087),(87525,5087),(87526,5087),(87527,5087),(87528,5088),(87529,5088),(87530,5088),(87531,5088),(87532,5089),(87533,5089),(87534,5089),(87535,5089),(87536,5090),(87537,5090),(87538,5090),(87539,5090),(87540,5091),(87541,5091),(87542,5091),(87543,5091),(87544,5092),(87545,5092),(87546,5092),(87547,5092),(87548,5093),(87549,5093),(87550,5093),(87551,5093),(87552,5094),(87553,5094),(87554,5094),(87555,5094),(87556,5095),(87557,5095),(87558,5095),(87559,5095),(87560,5096),(87561,5096),(87562,5096),(87563,5096),(87564,5097),(87565,5097),(87566,5097),(87567,5097),(87568,5098),(87569,5098),(87570,5098),(87571,5098),(87572,5099),(87573,5099),(87574,5099),(87575,5099),(87576,5100),(87577,5100),(87578,5100),(87579,5100),(87580,5101),(87581,5101),(87582,5101),(87583,5101),(87584,5102),(87585,5102),(87586,5102),(87587,5102),(87588,5103),(87589,5103),(87590,5103),(87591,5103),(87592,5104),(87593,5104),(87594,5104),(87595,5104),(87596,5105),(87597,5105),(87598,5105),(87599,5105),(87600,5106),(87601,5106),(87602,5106),(87603,5106),(87604,5107),(87605,5107),(87606,5107),(87607,5107),(87608,5108),(87609,5108),(87610,5108),(87611,5108),(87612,5109),(87613,5109),(87614,5109),(87615,5109),(87616,5110),(87617,5110),(87618,5110),(87619,5110),(87620,5111),(87621,5111),(87622,5111),(87623,5111),(87624,5112),(87625,5112),(87626,5112),(87627,5112),(87628,5113),(87629,5113),(87630,5113),(87631,5113),(87632,5114),(87633,5114),(87634,5114),(87635,5114),(87636,5115),(87637,5115),(87638,5115),(87639,5115),(87640,5116),(87641,5116),(87642,5116),(87643,5116),(87644,5117),(87645,5117),(87646,5117),(87647,5117),(87648,5118),(87649,5118),(87650,5118),(87651,5118),(87652,5119),(87653,5119),(87654,5119),(87655,5119),(87656,5120),(87657,5120),(87658,5120),(87659,5120),(87660,5121),(87661,5121),(87662,5121),(87663,5121),(87664,5122),(87665,5122),(87666,5122),(87667,5122),(87668,5123),(87669,5123),(87670,5123),(87671,5123),(87672,5124),(87673,5124),(87674,5124),(87675,5124),(87676,5125),(87677,5125),(87678,5125),(87679,5125),(87680,5126),(87681,5126),(87682,5126),(87683,5126),(87684,5127),(87685,5127),(87686,5127),(87687,5127),(87688,5128),(87689,5128),(87690,5128),(87691,5128),(87692,5129),(87693,5129),(87694,5129),(87695,5129),(87696,5130),(87697,5130),(87698,5130),(87699,5130),(87700,5131),(87701,5131),(87702,5131),(87703,5131),(87704,5132),(87705,5132),(87706,5132),(87707,5132),(87708,5133),(87709,5133),(87710,5133),(87711,5133),(87712,5134),(87713,5134),(87714,5134),(87715,5134),(87716,5135),(87717,5135),(87718,5135),(87719,5135),(87720,5136),(87721,5136),(87722,5136),(87723,5136),(87724,5137),(87725,5137),(87726,5137),(87727,5137),(87728,5138),(87729,5138),(87730,5138),(87731,5138),(87732,5139),(87733,5139),(87734,5139),(87735,5139),(87736,5140),(87737,5140),(87738,5140),(87739,5140),(87740,5141),(87741,5141),(87742,5141),(87743,5141),(87744,5142),(87745,5142),(87746,5142),(87747,5142),(87748,5143),(87749,5143),(87750,5143),(87751,5143),(87752,5144),(87753,5144),(87754,5144),(87755,5144),(87756,5145),(87757,5145),(87758,5145),(87759,5145),(87760,5146),(87761,5146),(87762,5146),(87763,5146),(87764,5147),(87765,5147),(87766,5147),(87767,5147),(87768,5148),(87769,5148),(87770,5148),(87771,5148),(87772,5149),(87773,5149),(87774,5149),(87775,5149),(87776,5150),(87777,5150),(87778,5150),(87779,5150),(87780,5151),(87781,5151),(87782,5151),(87783,5151),(87784,5152),(87785,5152),(87786,5152),(87787,5152),(87788,5153),(87789,5153),(87790,5153),(87791,5153),(87792,5154),(87793,5154),(87794,5154),(87795,5154),(87796,5155),(87797,5155),(87798,5155),(87799,5155),(87800,5156),(87801,5156),(87802,5156),(87803,5156),(87804,5157),(87805,5157),(87806,5157),(87807,5157),(87808,5158),(87809,5158),(87810,5158),(87811,5158),(87812,5159),(87813,5159),(87814,5159),(87815,5159),(87816,5160),(87817,5160),(87818,5160),(87819,5160),(87820,5161),(87821,5161),(87822,5161),(87823,5161),(87824,5162),(87825,5162),(87826,5162),(87827,5162),(87828,5163),(87829,5163),(87830,5163),(87831,5163),(87832,5164),(87833,5164),(87834,5164),(87835,5164),(87836,5165),(87837,5165),(87838,5165),(87839,5165),(87840,5166),(87841,5166),(87842,5166),(87843,5166),(87844,5167),(87845,5167),(87846,5167),(87847,5167),(87848,5168),(87849,5168),(87850,5168),(87851,5168),(87852,5169),(87853,5169),(87854,5169),(87855,5169),(87856,5170),(87857,5170),(87858,5170),(87859,5170),(87860,5171),(87861,5171),(87862,5171),(87863,5171),(87864,5172),(87865,5172),(87866,5172),(87867,5172),(87868,5173),(87869,5173),(87870,5173),(87871,5173),(87872,5174),(87873,5174),(87874,5174),(87875,5174),(87876,5175),(87877,5175),(87878,5175),(87879,5175),(87880,5176),(87881,5176),(87882,5176),(87883,5176),(87884,5177),(87885,5177),(87886,5177),(87887,5177),(87888,5178),(87889,5178),(87890,5178),(87891,5178),(87892,5179),(87893,5179),(87894,5179),(87895,5179),(87896,5180),(87897,5181),(87898,5182),(87899,5183),(87900,5184),(87901,5185),(87902,5186),(87903,5187),(87904,5188),(87905,5189),(87906,5190),(87907,5191),(87908,5192),(87909,5193),(87910,5194),(87911,5195),(87912,5196),(87913,5197),(87914,5198),(87915,5199),(87916,5200),(87917,5201),(87918,5202),(87919,5203),(87920,5204),(87921,5205),(87922,5206),(87923,5207),(87924,5208),(87925,5209),(87926,5210),(87927,5211),(87928,5212),(87929,5213),(87930,5214),(87931,5215),(87932,5216),(87933,5217),(87934,5218),(87935,5219),(87936,5220),(87937,5221),(87938,5222),(87939,5223),(87940,5224),(87941,5225),(87942,5226),(87943,5227),(87944,5228),(87945,5229),(87946,5230),(87947,5231),(87948,5232),(87949,5233),(87950,5234),(87951,5235),(87952,5236),(87953,5237),(87954,5238),(87955,5239),(87956,5240),(87957,5241),(87958,5242),(87959,5243),(87960,5244),(87961,5245),(87962,5246),(87963,5247),(87964,5248),(87965,5249),(87966,5250),(87967,5251),(87968,5252),(87969,5253),(87970,5254),(87971,5255),(87972,5256),(87973,5257),(87974,5258),(87975,5259),(87976,5260),(87977,5261),(87978,5262),(87979,5263),(87980,5264),(87981,5265),(87982,5266),(87983,5267),(87984,5268),(87985,5269),(87986,5270),(87987,5180),(87988,5180),(87989,5180),(87990,5180),(87991,5180),(87992,5180),(87993,5181),(87994,5181),(87995,5181),(87996,5181),(87997,5182),(87998,5182),(87999,5182),(88000,5182),(88001,5182),(88002,5182),(88003,5183),(88004,5183),(88005,5183),(88006,5183),(88007,5183),(88008,5183),(88009,5184),(88010,5184),(88011,5184),(88012,5184),(88013,5185),(88014,5185),(88015,5185),(88016,5185),(88017,5186),(88018,5186),(88019,5186),(88020,5186),(88021,5186),(88022,5186),(88023,5187),(88024,5187),(88025,5187),(88026,5187),(88027,5187),(88028,5187),(88029,5188),(88030,5188),(88031,5188),(88032,5188),(88033,5188),(88034,5188),(88035,5189),(88036,5189),(88037,5189),(88038,5189),(88039,5189),(88040,5189),(88041,5190),(88042,5190),(88043,5190),(88044,5190),(88045,5190),(88046,5190),(88047,5191),(88048,5191),(88049,5191),(88050,5191),(88051,5191),(88052,5191),(88053,5192),(88054,5192),(88055,5192),(88056,5192),(88057,5192),(88058,5192),(88059,5193),(88060,5193),(88061,5193),(88062,5193),(88063,5193),(88064,5193),(88065,5194),(88066,5194),(88067,5194),(88068,5194),(88069,5194),(88070,5194),(88071,5195),(88072,5195),(88073,5195),(88074,5195),(88075,5195),(88076,5195),(88077,5196),(88078,5196),(88079,5196),(88080,5196),(88081,5196),(88082,5196),(88083,5197),(88084,5197),(88085,5197),(88086,5197),(88087,5197),(88088,5197),(88089,5198),(88090,5198),(88091,5198),(88092,5198),(88093,5198),(88094,5198),(88095,5199),(88096,5199),(88097,5199),(88098,5199),(88099,5199),(88100,5199),(88101,5200),(88102,5200),(88103,5200),(88104,5200),(88105,5201),(88106,5201),(88107,5201),(88108,5201),(88109,5202),(88110,5202),(88111,5202),(88112,5202),(88113,5202),(88114,5202),(88115,5203),(88116,5203),(88117,5203),(88118,5203),(88119,5203),(88120,5203),(88121,5204),(88122,5204),(88123,5204),(88124,5204),(88125,5204),(88126,5204),(88127,5205),(88128,5205),(88129,5205),(88130,5205),(88131,5205),(88132,5205),(88133,5206),(88134,5206),(88135,5206),(88136,5206),(88137,5206),(88138,5206),(88139,5207),(88140,5207),(88141,5207),(88142,5207),(88143,5207),(88144,5207),(88145,5208),(88146,5208),(88147,5208),(88148,5208),(88149,5208),(88150,5208),(88151,5209),(88152,5209),(88153,5209),(88154,5209),(88155,5209),(88156,5209),(88157,5210),(88158,5210),(88159,5210),(88160,5210),(88161,5210),(88162,5210),(88163,5211),(88164,5211),(88165,5211),(88166,5211),(88167,5211),(88168,5211),(88169,5212),(88170,5212),(88171,5212),(88172,5212),(88173,5212),(88174,5212),(88175,5213),(88176,5213),(88177,5213),(88178,5213),(88179,5213),(88180,5213),(88181,5214),(88182,5214),(88183,5214),(88184,5214),(88185,5214),(88186,5214),(88187,5215),(88188,5215),(88189,5215),(88190,5215),(88191,5215),(88192,5215),(88193,5216),(88194,5216),(88195,5216),(88196,5216),(88197,5216),(88198,5216),(88199,5217),(88200,5217),(88201,5217),(88202,5217),(88203,5217),(88204,5217),(88205,5218),(88206,5218),(88207,5218),(88208,5218),(88209,5218),(88210,5218),(88211,5219),(88212,5219),(88213,5219),(88214,5219),(88215,5219),(88216,5219),(88217,5220),(88218,5220),(88219,5220),(88220,5220),(88221,5220),(88222,5220),(88223,5221),(88224,5221),(88225,5221),(88226,5221),(88227,5221),(88228,5221),(88229,5222),(88230,5222),(88231,5222),(88232,5222),(88233,5222),(88234,5222),(88235,5223),(88236,5223),(88237,5223),(88238,5223),(88239,5223),(88240,5223),(88241,5224),(88242,5224),(88243,5224),(88244,5224),(88245,5224),(88246,5224),(88247,5225),(88248,5225),(88249,5225),(88250,5225),(88251,5225),(88252,5225),(88253,5226),(88254,5226),(88255,5226),(88256,5226),(88257,5226),(88258,5226),(88259,5227),(88260,5227),(88261,5227),(88262,5227),(88263,5227),(88264,5227),(88265,5228),(88266,5228),(88267,5228),(88268,5228),(88269,5228),(88270,5228),(88271,5229),(88272,5229),(88273,5229),(88274,5229),(88275,5229),(88276,5229),(88277,5230),(88278,5230),(88279,5230),(88280,5230),(88281,5230),(88282,5230),(88283,5231),(88284,5231),(88285,5231),(88286,5231),(88287,5231),(88288,5231),(88289,5232),(88290,5232),(88291,5232),(88292,5232),(88293,5232),(88294,5232),(88295,5233),(88296,5233),(88297,5233),(88298,5233),(88299,5233),(88300,5233),(88301,5234),(88302,5234),(88303,5234),(88304,5234),(88305,5234),(88306,5234),(88307,5235),(88308,5235),(88309,5235),(88310,5235),(88311,5235),(88312,5235),(88313,5236),(88314,5236),(88315,5236),(88316,5236),(88317,5236),(88318,5236),(88319,5237),(88320,5237),(88321,5237),(88322,5237),(88323,5237),(88324,5237),(88325,5238),(88326,5238),(88327,5238),(88328,5238),(88329,5239),(88330,5239),(88331,5239),(88332,5239),(88333,5240),(88334,5240),(88335,5240),(88336,5240),(88337,5241),(88338,5241),(88339,5241),(88340,5241),(88341,5242),(88342,5242),(88343,5242),(88344,5242),(88345,5243),(88346,5243),(88347,5243),(88348,5243),(88349,5244),(88350,5244),(88351,5244),(88352,5244),(88353,5245),(88354,5245),(88355,5245),(88356,5245),(88357,5246),(88358,5246),(88359,5246),(88360,5246),(88361,5247),(88362,5247),(88363,5247),(88364,5247),(88365,5248),(88366,5248),(88367,5248),(88368,5248),(88369,5248),(88370,5248),(88371,5249),(88372,5249),(88373,5249),(88374,5249),(88375,5249),(88376,5249),(88377,5250),(88378,5250),(88379,5250),(88380,5250),(88381,5250),(88382,5250),(88383,5251),(88384,5251),(88385,5251),(88386,5251),(88387,5251),(88388,5251),(88389,5252),(88390,5252),(88391,5252),(88392,5252),(88393,5252),(88394,5252),(88395,5253),(88396,5253),(88397,5253),(88398,5253),(88399,5253),(88400,5253),(88401,5254),(88402,5254),(88403,5254),(88404,5254),(88405,5254),(88406,5254),(88407,5255),(88408,5255),(88409,5255),(88410,5255),(88411,5255),(88412,5255),(88413,5256),(88414,5256),(88415,5256),(88416,5256),(88417,5256),(88418,5256),(88419,5257),(88420,5257),(88421,5257),(88422,5257),(88423,5257),(88424,5257),(88425,5258),(88426,5258),(88427,5258),(88428,5258),(88429,5258),(88430,5259),(88431,5259),(88432,5259),(88433,5259),(88434,5259),(88435,5260),(88436,5260),(88437,5260),(88438,5260),(88439,5260),(88440,5261),(88441,5261),(88442,5261),(88443,5261),(88444,5261),(88445,5262),(88446,5262),(88447,5262),(88448,5262),(88449,5262),(88450,5263),(88451,5263),(88452,5263),(88453,5263),(88454,5264),(88455,5264),(88456,5264),(88457,5264),(88458,5265),(88459,5265),(88460,5265),(88461,5265),(88462,5266),(88463,5266),(88464,5266),(88465,5266),(88466,5266),(88467,5267),(88468,5267),(88469,5267),(88470,5267),(88471,5267),(88472,5268),(88473,5268),(88474,5268),(88475,5268),(88476,5268),(88477,5269),(88478,5269),(88479,5269),(88480,5269),(88481,5270),(88482,5270),(88483,5270),(88484,5270),(88485,5180),(88486,5180),(88487,5180),(88488,5181),(88489,5181),(88490,5182),(88491,5182),(88492,5182),(88493,5183),(88494,5183),(88495,5184),(88496,5184),(88497,5185),(88498,5185),(88499,5186),(88500,5186),(88501,5186),(88502,5187),(88503,5187),(88504,5187),(88505,5188),(88506,5188),(88507,5188),(88508,5189),(88509,5189),(88510,5189),(88511,5190),(88512,5190),(88513,5190),(88514,5191),(88515,5191),(88516,5191),(88517,5192),(88518,5192),(88519,5192),(88520,5193),(88521,5193),(88522,5194),(88523,5194),(88524,5194),(88525,5195),(88526,5195),(88527,5195),(88528,5196),(88529,5196),(88530,5196),(88531,5197),(88532,5197),(88533,5197),(88534,5198),(88535,5198),(88536,5198),(88537,5199),(88538,5199),(88539,5200),(88540,5200),(88541,5201),(88542,5201),(88543,5202),(88544,5202),(88545,5202),(88546,5203),(88547,5203),(88548,5203),(88549,5204),(88550,5204),(88551,5204),(88552,5205),(88553,5205),(88554,5205),(88555,5206),(88556,5206),(88557,5206),(88558,5207),(88559,5207),(88560,5207),(88561,5208),(88562,5208),(88563,5208),(88564,5209),(88565,5209),(88566,5209),(88567,5210),(88568,5210),(88569,5210),(88570,5211),(88571,5211),(88572,5211),(88573,5212),(88574,5212),(88575,5212),(88576,5213),(88577,5213),(88578,5213),(88579,5214),(88580,5214),(88581,5214),(88582,5215),(88583,5215),(88584,5215),(88585,5216),(88586,5216),(88587,5216),(88588,5217),(88589,5217),(88590,5217),(88591,5218),(88592,5218),(88593,5218),(88594,5219),(88595,5219),(88596,5219),(88597,5220),(88598,5220),(88599,5220),(88600,5221),(88601,5221),(88602,5221),(88603,5222),(88604,5222),(88605,5222),(88606,5223),(88607,5223),(88608,5223),(88609,5224),(88610,5224),(88611,5224),(88612,5225),(88613,5225),(88614,5225),(88615,5226),(88616,5226),(88617,5226),(88618,5227),(88619,5227),(88620,5227),(88621,5228),(88622,5228),(88623,5228),(88624,5229),(88625,5229),(88626,5229),(88627,5230),(88628,5230),(88629,5230),(88630,5231),(88631,5231),(88632,5231),(88633,5232),(88634,5232),(88635,5232),(88636,5233),(88637,5233),(88638,5233),(88639,5234),(88640,5234),(88641,5234),(88642,5235),(88643,5235),(88644,5235),(88645,5236),(88646,5236),(88647,5236),(88648,5237),(88649,5237),(88650,5237),(88651,5238),(88652,5238),(88653,5239),(88654,5239),(88655,5240),(88656,5240),(88657,5241),(88658,5241),(88659,5242),(88660,5242),(88661,5243),(88662,5243),(88663,5244),(88664,5244),(88665,5245),(88666,5245),(88667,5246),(88668,5246),(88669,5247),(88670,5247),(88671,5248),(88672,5248),(88673,5249),(88674,5249),(88675,5250),(88676,5250),(88677,5251),(88678,5251),(88679,5252),(88680,5252),(88681,5253),(88682,5253),(88683,5254),(88684,5254),(88685,5255),(88686,5255),(88687,5256),(88688,5256),(88689,5257),(88690,5257),(88691,5258),(88692,5258),(88693,5259),(88694,5260),(88695,5261),(88696,5262),(88697,5263),(88698,5264),(88699,5265),(88700,5266),(88701,5267),(88702,5268),(88703,5269),(88704,5270),(88705,5180),(88706,5180),(88707,5180),(88708,5181),(88709,5181),(88710,5181),(88711,5182),(88712,5182),(88713,5182),(88714,5183),(88715,5183),(88716,5183),(88717,5184),(88718,5184),(88719,5184),(88720,5185),(88721,5185),(88722,5185),(88723,5186),(88724,5186),(88725,5186),(88726,5187),(88727,5187),(88728,5187),(88729,5188),(88730,5188),(88731,5188),(88732,5189),(88733,5189),(88734,5189),(88735,5190),(88736,5190),(88737,5190),(88738,5191),(88739,5191),(88740,5191),(88741,5192),(88742,5192),(88743,5192),(88744,5193),(88745,5193),(88746,5193),(88747,5194),(88748,5194),(88749,5194),(88750,5195),(88751,5195),(88752,5195),(88753,5196),(88754,5196),(88755,5196),(88756,5197),(88757,5197),(88758,5197),(88759,5198),(88760,5198),(88761,5198),(88762,5199),(88763,5199),(88764,5200),(88765,5200),(88766,5200),(88767,5201),(88768,5201),(88769,5201),(88770,5202),(88771,5202),(88772,5202),(88773,5203),(88774,5203),(88775,5203),(88776,5204),(88777,5204),(88778,5204),(88779,5205),(88780,5205),(88781,5205),(88782,5206),(88783,5206),(88784,5206),(88785,5207),(88786,5207),(88787,5207),(88788,5208),(88789,5208),(88790,5208),(88791,5209),(88792,5209),(88793,5209),(88794,5210),(88795,5210),(88796,5210),(88797,5211),(88798,5211),(88799,5211),(88800,5212),(88801,5212),(88802,5212),(88803,5213),(88804,5213),(88805,5213),(88806,5214),(88807,5214),(88808,5214),(88809,5215),(88810,5215),(88811,5215),(88812,5216),(88813,5216),(88814,5216),(88815,5217),(88816,5217),(88817,5217),(88818,5218),(88819,5218),(88820,5218),(88821,5219),(88822,5219),(88823,5219),(88824,5220),(88825,5220),(88826,5220),(88827,5221),(88828,5221),(88829,5221),(88830,5222),(88831,5222),(88832,5222),(88833,5223),(88834,5223),(88835,5223),(88836,5224),(88837,5224),(88838,5224),(88839,5225),(88840,5225),(88841,5225),(88842,5226),(88843,5226),(88844,5226),(88845,5227),(88846,5227),(88847,5227),(88848,5228),(88849,5228),(88850,5228),(88851,5229),(88852,5229),(88853,5229),(88854,5230),(88855,5230),(88856,5230),(88857,5231),(88858,5231),(88859,5231),(88860,5232),(88861,5232),(88862,5232),(88863,5233),(88864,5233),(88865,5233),(88866,5234),(88867,5234),(88868,5234),(88869,5235),(88870,5235),(88871,5235),(88872,5236),(88873,5236),(88874,5236),(88875,5237),(88876,5237),(88877,5237),(88878,5238),(88879,5238),(88880,5238),(88881,5239),(88882,5239),(88883,5239),(88884,5240),(88885,5240),(88886,5240),(88887,5241),(88888,5241),(88889,5241),(88890,5242),(88891,5242),(88892,5242),(88893,5243),(88894,5243),(88895,5243),(88896,5244),(88897,5244),(88898,5244),(88899,5245),(88900,5245),(88901,5245),(88902,5246),(88903,5246),(88904,5246),(88905,5247),(88906,5247),(88907,5247),(88908,5248),(88909,5248),(88910,5248),(88911,5249),(88912,5249),(88913,5249),(88914,5250),(88915,5250),(88916,5250),(88917,5251),(88918,5251),(88919,5251),(88920,5252),(88921,5252),(88922,5252),(88923,5253),(88924,5253),(88925,5253),(88926,5254),(88927,5254),(88928,5254),(88929,5255),(88930,5255),(88931,5255),(88932,5256),(88933,5256),(88934,5256),(88935,5257),(88936,5257),(88937,5257),(88938,5258),(88939,5258),(88940,5258),(88941,5259),(88942,5259),(88943,5259),(88944,5260),(88945,5260),(88946,5260),(88947,5261),(88948,5261),(88949,5261),(88950,5262),(88951,5262),(88952,5262),(88953,5263),(88954,5263),(88955,5263),(88956,5264),(88957,5264),(88958,5264),(88959,5265),(88960,5265),(88961,5265),(88962,5266),(88963,5266),(88964,5266),(88965,5267),(88966,5267),(88967,5267),(88968,5268),(88969,5268),(88970,5268),(88971,5269),(88972,5269),(88973,5269),(88974,5270),(88975,5270),(88976,5270),(88977,5180),(88978,5180),(88979,5180),(88980,5180),(88981,5181),(88982,5181),(88983,5181),(88984,5181),(88985,5182),(88986,5182),(88987,5182),(88988,5182),(88989,5183),(88990,5183),(88991,5183),(88992,5183),(88993,5184),(88994,5184),(88995,5184),(88996,5184),(88997,5185),(88998,5185),(88999,5185),(89000,5185),(89001,5186),(89002,5186),(89003,5186),(89004,5186),(89005,5187),(89006,5187),(89007,5187),(89008,5187),(89009,5188),(89010,5188),(89011,5188),(89012,5188),(89013,5189),(89014,5189),(89015,5189),(89016,5189),(89017,5190),(89018,5190),(89019,5190),(89020,5190),(89021,5191),(89022,5191),(89023,5191),(89024,5191),(89025,5192),(89026,5192),(89027,5192),(89028,5192),(89029,5193),(89030,5193),(89031,5193),(89032,5193),(89033,5194),(89034,5194),(89035,5194),(89036,5194),(89037,5195),(89038,5195),(89039,5195),(89040,5195),(89041,5196),(89042,5196),(89043,5196),(89044,5196),(89045,5197),(89046,5197),(89047,5197),(89048,5197),(89049,5198),(89050,5198),(89051,5198),(89052,5198),(89053,5199),(89054,5199),(89055,5199),(89056,5199),(89057,5200),(89058,5200),(89059,5200),(89060,5200),(89061,5201),(89062,5201),(89063,5201),(89064,5201),(89065,5202),(89066,5202),(89067,5202),(89068,5202),(89069,5203),(89070,5203),(89071,5203),(89072,5203),(89073,5204),(89074,5204),(89075,5204),(89076,5204),(89077,5205),(89078,5205),(89079,5205),(89080,5205),(89081,5206),(89082,5206),(89083,5206),(89084,5206),(89085,5207),(89086,5207),(89087,5207),(89088,5207),(89089,5208),(89090,5208),(89091,5208),(89092,5208),(89093,5209),(89094,5209),(89095,5209),(89096,5209),(89097,5210),(89098,5210),(89099,5210),(89100,5210),(89101,5211),(89102,5211),(89103,5211),(89104,5211),(89105,5212),(89106,5212),(89107,5212),(89108,5212),(89109,5213),(89110,5213),(89111,5213),(89112,5213),(89113,5214),(89114,5214),(89115,5214),(89116,5214),(89117,5215),(89118,5215),(89119,5215),(89120,5215),(89121,5216),(89122,5216),(89123,5216),(89124,5216),(89125,5217),(89126,5217),(89127,5217),(89128,5217),(89129,5218),(89130,5218),(89131,5218),(89132,5218),(89133,5219),(89134,5219),(89135,5219),(89136,5219),(89137,5220),(89138,5220),(89139,5220),(89140,5220),(89141,5221),(89142,5221),(89143,5221),(89144,5221),(89145,5222),(89146,5222),(89147,5222),(89148,5222),(89149,5223),(89150,5223),(89151,5223),(89152,5223),(89153,5224),(89154,5224),(89155,5224),(89156,5224),(89157,5225),(89158,5225),(89159,5225),(89160,5225),(89161,5226),(89162,5226),(89163,5226),(89164,5226),(89165,5227),(89166,5227),(89167,5227),(89168,5227),(89169,5228),(89170,5228),(89171,5228),(89172,5228),(89173,5229),(89174,5229),(89175,5229),(89176,5229),(89177,5230),(89178,5230),(89179,5230),(89180,5230),(89181,5231),(89182,5231),(89183,5231),(89184,5231),(89185,5232),(89186,5232),(89187,5232),(89188,5232),(89189,5233),(89190,5233),(89191,5233),(89192,5233),(89193,5234),(89194,5234),(89195,5234),(89196,5234),(89197,5235),(89198,5235),(89199,5235),(89200,5235),(89201,5236),(89202,5236),(89203,5236),(89204,5236),(89205,5237),(89206,5237),(89207,5237),(89208,5237),(89209,5238),(89210,5238),(89211,5238),(89212,5238),(89213,5239),(89214,5239),(89215,5239),(89216,5239),(89217,5240),(89218,5240),(89219,5240),(89220,5240),(89221,5241),(89222,5241),(89223,5241),(89224,5241),(89225,5242),(89226,5242),(89227,5242),(89228,5242),(89229,5243),(89230,5243),(89231,5243),(89232,5243),(89233,5244),(89234,5244),(89235,5244),(89236,5244),(89237,5245),(89238,5245),(89239,5245),(89240,5245),(89241,5246),(89242,5246),(89243,5246),(89244,5246),(89245,5247),(89246,5247),(89247,5247),(89248,5247),(89249,5248),(89250,5248),(89251,5248),(89252,5248),(89253,5249),(89254,5249),(89255,5249),(89256,5249),(89257,5250),(89258,5250),(89259,5250),(89260,5250),(89261,5251),(89262,5251),(89263,5251),(89264,5251),(89265,5252),(89266,5252),(89267,5252),(89268,5252),(89269,5253),(89270,5253),(89271,5253),(89272,5253),(89273,5254),(89274,5254),(89275,5254),(89276,5254),(89277,5255),(89278,5255),(89279,5255),(89280,5255),(89281,5256),(89282,5256),(89283,5256),(89284,5256),(89285,5257),(89286,5257),(89287,5257),(89288,5257),(89289,5258),(89290,5258),(89291,5258),(89292,5258),(89293,5259),(89294,5259),(89295,5259),(89296,5259),(89297,5260),(89298,5260),(89299,5260),(89300,5260),(89301,5261),(89302,5261),(89303,5261),(89304,5261),(89305,5262),(89306,5262),(89307,5262),(89308,5262),(89309,5263),(89310,5263),(89311,5263),(89312,5263),(89313,5264),(89314,5264),(89315,5264),(89316,5264),(89317,5265),(89318,5265),(89319,5265),(89320,5265),(89321,5266),(89322,5266),(89323,5266),(89324,5266),(89325,5267),(89326,5267),(89327,5267),(89328,5267),(89329,5268),(89330,5268),(89331,5268),(89332,5268),(89333,5269),(89334,5269),(89335,5269),(89336,5269),(89337,5270),(89338,5270),(89339,5270),(89340,5270),(89341,5271),(89342,5272),(89343,5273),(89344,5274),(89345,5275),(89346,5276),(89347,5277),(89348,5278),(89349,5279),(89350,5280),(89351,5281),(89352,5282),(89353,5283),(89354,5284),(89355,5285),(89356,5286),(89357,5287),(89358,5288),(89359,5289),(89360,5290),(89361,5291),(89362,5292),(89363,5293),(89364,5294),(89365,5295),(89366,5296),(89367,5297),(89368,5298),(89369,5299),(89370,5300),(89371,5301),(89372,5302),(89373,5303),(89374,5304),(89375,5305),(89376,5306),(89377,5307),(89378,5308),(89379,5309),(89380,5310),(89381,5311),(89382,5312),(89383,5313),(89384,5314),(89385,5315),(89386,5316),(89387,5317),(89388,5318),(89389,5319),(89390,5320),(89391,5321),(89392,5322),(89393,5323),(89394,5324),(89395,5325),(89396,5326),(89397,5327),(89398,5328),(89399,5329),(89400,5330),(89401,5331),(89402,5332),(89403,5333),(89404,5334),(89405,5335),(89406,5336),(89407,5337),(89408,5338),(89409,5339),(89410,5340),(89411,5341),(89412,5342),(89413,5343),(89414,5344),(89415,5345),(89416,5346),(89417,5347),(89418,5348),(89419,5349),(89420,5350),(89421,5351),(89422,5352),(89423,5353),(89424,5354),(89425,5355),(89426,5356),(89427,5357),(89428,5358),(89429,5359),(89430,5271),(89431,5271),(89432,5271),(89433,5271),(89434,5271),(89435,5271),(89436,5272),(89437,5272),(89438,5272),(89439,5272),(89440,5272),(89441,5272),(89442,5273),(89443,5273),(89444,5273),(89445,5273),(89446,5273),(89447,5273),(89448,5274),(89449,5274),(89450,5274),(89451,5274),(89452,5274),(89453,5274),(89454,5275),(89455,5275),(89456,5275),(89457,5275),(89458,5275),(89459,5275),(89460,5276),(89461,5276),(89462,5276),(89463,5276),(89464,5276),(89465,5276),(89466,5277),(89467,5277),(89468,5277),(89469,5277),(89470,5277),(89471,5277),(89472,5278),(89473,5278),(89474,5278),(89475,5278),(89476,5278),(89477,5278),(89478,5279),(89479,5279),(89480,5279),(89481,5279),(89482,5279),(89483,5279),(89484,5280),(89485,5280),(89486,5280),(89487,5280),(89488,5280),(89489,5280),(89490,5281),(89491,5281),(89492,5281),(89493,5281),(89494,5281),(89495,5281),(89496,5282),(89497,5282),(89498,5282),(89499,5282),(89500,5282),(89501,5282),(89502,5283),(89503,5283),(89504,5283),(89505,5283),(89506,5283),(89507,5283),(89508,5284),(89509,5284),(89510,5284),(89511,5284),(89512,5284),(89513,5284),(89514,5285),(89515,5285),(89516,5285),(89517,5285),(89518,5285),(89519,5285),(89520,5286),(89521,5286),(89522,5286),(89523,5286),(89524,5286),(89525,5286),(89526,5287),(89527,5287),(89528,5287),(89529,5287),(89530,5287),(89531,5287),(89532,5288),(89533,5288),(89534,5288),(89535,5288),(89536,5288),(89537,5288),(89538,5289),(89539,5289),(89540,5289),(89541,5289),(89542,5289),(89543,5289),(89544,5290),(89545,5290),(89546,5290),(89547,5290),(89548,5290),(89549,5290),(89550,5291),(89551,5291),(89552,5291),(89553,5291),(89554,5291),(89555,5291),(89556,5292),(89557,5292),(89558,5292),(89559,5292),(89560,5292),(89561,5292),(89562,5293),(89563,5293),(89564,5293),(89565,5293),(89566,5293),(89567,5293),(89568,5294),(89569,5294),(89570,5294),(89571,5294),(89572,5294),(89573,5294),(89574,5295),(89575,5295),(89576,5295),(89577,5295),(89578,5295),(89579,5295),(89580,5296),(89581,5296),(89582,5296),(89583,5296),(89584,5296),(89585,5296),(89586,5297),(89587,5297),(89588,5297),(89589,5297),(89590,5297),(89591,5297),(89592,5298),(89593,5298),(89594,5298),(89595,5298),(89596,5298),(89597,5298),(89598,5299),(89599,5299),(89600,5299),(89601,5299),(89602,5299),(89603,5299),(89604,5300),(89605,5300),(89606,5300),(89607,5300),(89608,5300),(89609,5300),(89610,5301),(89611,5301),(89612,5301),(89613,5301),(89614,5301),(89615,5301),(89616,5302),(89617,5302),(89618,5302),(89619,5302),(89620,5302),(89621,5302),(89622,5303),(89623,5303),(89624,5303),(89625,5303),(89626,5303),(89627,5303),(89628,5304),(89629,5304),(89630,5304),(89631,5304),(89632,5304),(89633,5304),(89634,5305),(89635,5305),(89636,5305),(89637,5305),(89638,5305),(89639,5305),(89640,5306),(89641,5306),(89642,5306),(89643,5306),(89644,5306),(89645,5306),(89646,5307),(89647,5307),(89648,5307),(89649,5307),(89650,5307),(89651,5307),(89652,5308),(89653,5308),(89654,5308),(89655,5308),(89656,5308),(89657,5308),(89658,5309),(89659,5309),(89660,5309),(89661,5309),(89662,5309),(89663,5309),(89664,5310),(89665,5310),(89666,5310),(89667,5310),(89668,5310),(89669,5310),(89670,5311),(89671,5311),(89672,5311),(89673,5311),(89674,5311),(89675,5311),(89676,5312),(89677,5312),(89678,5312),(89679,5312),(89680,5312),(89681,5312),(89682,5313),(89683,5313),(89684,5313),(89685,5313),(89686,5313),(89687,5313),(89688,5314),(89689,5314),(89690,5314),(89691,5314),(89692,5314),(89693,5314),(89694,5315),(89695,5315),(89696,5315),(89697,5315),(89698,5315),(89699,5315),(89700,5316),(89701,5316),(89702,5316),(89703,5316),(89704,5316),(89705,5316),(89706,5317),(89707,5317),(89708,5317),(89709,5317),(89710,5317),(89711,5317),(89712,5318),(89713,5318),(89714,5318),(89715,5318),(89716,5318),(89717,5318),(89718,5319),(89719,5319),(89720,5319),(89721,5319),(89722,5319),(89723,5319),(89724,5320),(89725,5320),(89726,5320),(89727,5320),(89728,5320),(89729,5320),(89730,5321),(89731,5321),(89732,5321),(89733,5321),(89734,5321),(89735,5321),(89736,5322),(89737,5322),(89738,5322),(89739,5322),(89740,5322),(89741,5322),(89742,5323),(89743,5323),(89744,5323),(89745,5323),(89746,5323),(89747,5323),(89748,5324),(89749,5324),(89750,5324),(89751,5324),(89752,5324),(89753,5324),(89754,5325),(89755,5325),(89756,5325),(89757,5325),(89758,5325),(89759,5325),(89760,5326),(89761,5326),(89762,5326),(89763,5326),(89764,5326),(89765,5326),(89766,5327),(89767,5327),(89768,5327),(89769,5327),(89770,5327),(89771,5327),(89772,5328),(89773,5328),(89774,5328),(89775,5328),(89776,5328),(89777,5328),(89778,5329),(89779,5329),(89780,5329),(89781,5329),(89782,5329),(89783,5329),(89784,5330),(89785,5330),(89786,5330),(89787,5330),(89788,5330),(89789,5330),(89790,5331),(89791,5331),(89792,5331),(89793,5331),(89794,5331),(89795,5331),(89796,5332),(89797,5332),(89798,5332),(89799,5332),(89800,5332),(89801,5332),(89802,5333),(89803,5333),(89804,5333),(89805,5333),(89806,5333),(89807,5333),(89808,5334),(89809,5334),(89810,5334),(89811,5334),(89812,5334),(89813,5335),(89814,5335),(89815,5335),(89816,5335),(89817,5335),(89818,5335),(89819,5336),(89820,5336),(89821,5336),(89822,5336),(89823,5336),(89824,5336),(89825,5337),(89826,5337),(89827,5337),(89828,5337),(89829,5337),(89830,5337),(89831,5338),(89832,5338),(89833,5338),(89834,5338),(89835,5338),(89836,5338),(89837,5339),(89838,5339),(89839,5339),(89840,5339),(89841,5339),(89842,5339),(89843,5340),(89844,5340),(89845,5340),(89846,5340),(89847,5340),(89848,5340),(89849,5341),(89850,5341),(89851,5341),(89852,5341),(89853,5341),(89854,5341),(89855,5342),(89856,5342),(89857,5342),(89858,5342),(89859,5342),(89860,5342),(89861,5343),(89862,5343),(89863,5343),(89864,5343),(89865,5343),(89866,5343),(89867,5344),(89868,5344),(89869,5344),(89870,5344),(89871,5344),(89872,5344),(89873,5345),(89874,5345),(89875,5345),(89876,5345),(89877,5345),(89878,5345),(89879,5346),(89880,5346),(89881,5346),(89882,5346),(89883,5346),(89884,5346),(89885,5347),(89886,5347),(89887,5347),(89888,5347),(89889,5347),(89890,5347),(89891,5348),(89892,5348),(89893,5348),(89894,5348),(89895,5348),(89896,5348),(89897,5349),(89898,5349),(89899,5349),(89900,5349),(89901,5349),(89902,5349),(89903,5350),(89904,5350),(89905,5350),(89906,5350),(89907,5350),(89908,5350),(89909,5351),(89910,5351),(89911,5351),(89912,5351),(89913,5351),(89914,5351),(89915,5352),(89916,5352),(89917,5352),(89918,5352),(89919,5352),(89920,5352),(89921,5353),(89922,5353),(89923,5353),(89924,5353),(89925,5353),(89926,5353),(89927,5354),(89928,5354),(89929,5354),(89930,5354),(89931,5354),(89932,5354),(89933,5355),(89934,5355),(89935,5355),(89936,5355),(89937,5355),(89938,5355),(89939,5356),(89940,5356),(89941,5356),(89942,5356),(89943,5356),(89944,5356),(89945,5357),(89946,5357),(89947,5357),(89948,5357),(89949,5357),(89950,5357),(89951,5358),(89952,5358),(89953,5358),(89954,5358),(89955,5358),(89956,5358),(89957,5359),(89958,5359),(89959,5359),(89960,5359),(89961,5359),(89962,5359),(89963,5271),(89964,5271),(89965,5272),(89966,5272),(89967,5273),(89968,5273),(89969,5274),(89970,5274),(89971,5275),(89972,5275),(89973,5276),(89974,5276),(89975,5277),(89976,5277),(89977,5278),(89978,5278),(89979,5279),(89980,5279),(89981,5280),(89982,5280),(89983,5281),(89984,5281),(89985,5282),(89986,5282),(89987,5283),(89988,5283),(89989,5284),(89990,5284),(89991,5285),(89992,5285),(89993,5285),(89994,5286),(89995,5286),(89996,5287),(89997,5287),(89998,5287),(89999,5288),(90000,5288),(90001,5288),(90002,5289),(90003,5289),(90004,5289),(90005,5290),(90006,5290),(90007,5290),(90008,5291),(90009,5291),(90010,5291),(90011,5292),(90012,5292),(90013,5292),(90014,5293),(90015,5293),(90016,5293),(90017,5294),(90018,5294),(90019,5294),(90020,5295),(90021,5295),(90022,5295),(90023,5296),(90024,5296),(90025,5296),(90026,5297),(90027,5297),(90028,5297),(90029,5298),(90030,5298),(90031,5298),(90032,5299),(90033,5299),(90034,5299),(90035,5300),(90036,5300),(90037,5300),(90038,5301),(90039,5301),(90040,5302),(90041,5302),(90042,5302),(90043,5303),(90044,5303),(90045,5303),(90046,5304),(90047,5304),(90048,5304),(90049,5305),(90050,5305),(90051,5305),(90052,5306),(90053,5306),(90054,5306),(90055,5307),(90056,5307),(90057,5307),(90058,5308),(90059,5308),(90060,5308),(90061,5309),(90062,5309),(90063,5310),(90064,5310),(90065,5311),(90066,5311),(90067,5312),(90068,5312),(90069,5313),(90070,5313),(90071,5314),(90072,5314),(90073,5315),(90074,5315),(90075,5316),(90076,5316),(90077,5317),(90078,5317),(90079,5318),(90080,5318),(90081,5319),(90082,5319),(90083,5320),(90084,5320),(90085,5321),(90086,5321),(90087,5321),(90088,5322),(90089,5322),(90090,5322),(90091,5323),(90092,5323),(90093,5324),(90094,5324),(90095,5325),(90096,5325),(90097,5326),(90098,5326),(90099,5327),(90100,5327),(90101,5328),(90102,5328),(90103,5329),(90104,5329),(90105,5330),(90106,5330),(90107,5331),(90108,5331),(90109,5332),(90110,5332),(90111,5333),(90112,5333),(90113,5334),(90114,5334),(90115,5335),(90116,5335),(90117,5336),(90118,5336),(90119,5337),(90120,5337),(90121,5338),(90122,5338),(90123,5339),(90124,5339),(90125,5340),(90126,5340),(90127,5341),(90128,5341),(90129,5342),(90130,5342),(90131,5343),(90132,5343),(90133,5344),(90134,5344),(90135,5345),(90136,5345),(90137,5346),(90138,5346),(90139,5347),(90140,5347),(90141,5348),(90142,5348),(90143,5349),(90144,5349),(90145,5350),(90146,5350),(90147,5351),(90148,5351),(90149,5352),(90150,5352),(90151,5353),(90152,5353),(90153,5354),(90154,5354),(90155,5355),(90156,5355),(90157,5356),(90158,5356),(90159,5357),(90160,5357),(90161,5358),(90162,5358),(90163,5359),(90164,5359),(90165,5271),(90166,5271),(90167,5271),(90168,5272),(90169,5272),(90170,5272),(90171,5273),(90172,5273),(90173,5273),(90174,5274),(90175,5274),(90176,5274),(90177,5275),(90178,5275),(90179,5275),(90180,5276),(90181,5276),(90182,5276),(90183,5277),(90184,5277),(90185,5277),(90186,5278),(90187,5278),(90188,5278),(90189,5279),(90190,5279),(90191,5279),(90192,5280),(90193,5280),(90194,5280),(90195,5281),(90196,5281),(90197,5281),(90198,5282),(90199,5282),(90200,5282),(90201,5283),(90202,5283),(90203,5283),(90204,5284),(90205,5284),(90206,5284),(90207,5285),(90208,5285),(90209,5286),(90210,5286),(90211,5286),(90212,5287),(90213,5287),(90214,5288),(90215,5288),(90216,5289),(90217,5289),(90218,5290),(90219,5290),(90220,5291),(90221,5291),(90222,5292),(90223,5292),(90224,5293),(90225,5293),(90226,5294),(90227,5294),(90228,5295),(90229,5295),(90230,5296),(90231,5296),(90232,5297),(90233,5297),(90234,5298),(90235,5298),(90236,5299),(90237,5299),(90238,5300),(90239,5300),(90240,5301),(90241,5301),(90242,5301),(90243,5302),(90244,5302),(90245,5303),(90246,5303),(90247,5304),(90248,5304),(90249,5305),(90250,5305),(90251,5306),(90252,5306),(90253,5307),(90254,5307),(90255,5308),(90256,5308),(90257,5309),(90258,5309),(90259,5309),(90260,5310),(90261,5310),(90262,5310),(90263,5311),(90264,5311),(90265,5311),(90266,5312),(90267,5312),(90268,5312),(90269,5313),(90270,5313),(90271,5313),(90272,5314),(90273,5314),(90274,5314),(90275,5315),(90276,5315),(90277,5315),(90278,5316),(90279,5316),(90280,5316),(90281,5317),(90282,5317),(90283,5317),(90284,5318),(90285,5318),(90286,5318),(90287,5319),(90288,5319),(90289,5319),(90290,5320),(90291,5320),(90292,5320),(90293,5321),(90294,5321),(90295,5322),(90296,5322),(90297,5323),(90298,5323),(90299,5323),(90300,5324),(90301,5324),(90302,5324),(90303,5325),(90304,5325),(90305,5325),(90306,5326),(90307,5326),(90308,5326),(90309,5327),(90310,5327),(90311,5327),(90312,5328),(90313,5328),(90314,5328),(90315,5329),(90316,5329),(90317,5329),(90318,5330),(90319,5330),(90320,5330),(90321,5331),(90322,5331),(90323,5331),(90324,5332),(90325,5332),(90326,5332),(90327,5333),(90328,5333),(90329,5333),(90330,5334),(90331,5334),(90332,5334),(90333,5335),(90334,5335),(90335,5335),(90336,5336),(90337,5336),(90338,5336),(90339,5337),(90340,5337),(90341,5337),(90342,5338),(90343,5338),(90344,5338),(90345,5339),(90346,5339),(90347,5339),(90348,5340),(90349,5340),(90350,5340),(90351,5341),(90352,5341),(90353,5341),(90354,5342),(90355,5342),(90356,5342),(90357,5343),(90358,5343),(90359,5343),(90360,5344),(90361,5344),(90362,5344),(90363,5345),(90364,5345),(90365,5345),(90366,5346),(90367,5346),(90368,5346),(90369,5347),(90370,5347),(90371,5347),(90372,5348),(90373,5348),(90374,5348),(90375,5349),(90376,5349),(90377,5349),(90378,5350),(90379,5350),(90380,5350),(90381,5351),(90382,5351),(90383,5351),(90384,5352),(90385,5352),(90386,5352),(90387,5353),(90388,5353),(90389,5353),(90390,5354),(90391,5354),(90392,5354),(90393,5355),(90394,5355),(90395,5355),(90396,5356),(90397,5356),(90398,5356),(90399,5357),(90400,5357),(90401,5357),(90402,5358),(90403,5358),(90404,5358),(90405,5359),(90406,5359),(90407,5359),(90408,5271),(90409,5271),(90410,5271),(90411,5271),(90412,5272),(90413,5272),(90414,5272),(90415,5272),(90416,5273),(90417,5273),(90418,5273),(90419,5273),(90420,5274),(90421,5274),(90422,5274),(90423,5274),(90424,5275),(90425,5275),(90426,5275),(90427,5275),(90428,5276),(90429,5276),(90430,5276),(90431,5276),(90432,5277),(90433,5277),(90434,5277),(90435,5277),(90436,5278),(90437,5278),(90438,5278),(90439,5278),(90440,5279),(90441,5279),(90442,5279),(90443,5279),(90444,5280),(90445,5280),(90446,5280),(90447,5280),(90448,5281),(90449,5281),(90450,5281),(90451,5281),(90452,5282),(90453,5282),(90454,5282),(90455,5282),(90456,5283),(90457,5283),(90458,5283),(90459,5283),(90460,5284),(90461,5284),(90462,5284),(90463,5284),(90464,5285),(90465,5285),(90466,5285),(90467,5285),(90468,5286),(90469,5286),(90470,5286),(90471,5286),(90472,5287),(90473,5287),(90474,5287),(90475,5287),(90476,5288),(90477,5288),(90478,5288),(90479,5288),(90480,5289),(90481,5289),(90482,5289),(90483,5289),(90484,5290),(90485,5290),(90486,5290),(90487,5290),(90488,5291),(90489,5291),(90490,5291),(90491,5291),(90492,5292),(90493,5292),(90494,5292),(90495,5292),(90496,5293),(90497,5293),(90498,5293),(90499,5293),(90500,5294),(90501,5294),(90502,5294),(90503,5294),(90504,5295),(90505,5295),(90506,5295),(90507,5295),(90508,5296),(90509,5296),(90510,5296),(90511,5296),(90512,5297),(90513,5297),(90514,5297),(90515,5297),(90516,5298),(90517,5298),(90518,5298),(90519,5298),(90520,5299),(90521,5299),(90522,5299),(90523,5299),(90524,5300),(90525,5300),(90526,5300),(90527,5300),(90528,5301),(90529,5301),(90530,5301),(90531,5301),(90532,5302),(90533,5302),(90534,5302),(90535,5302),(90536,5303),(90537,5303),(90538,5303),(90539,5303),(90540,5304),(90541,5304),(90542,5304),(90543,5304),(90544,5305),(90545,5305),(90546,5305),(90547,5305),(90548,5306),(90549,5306),(90550,5306),(90551,5306),(90552,5307),(90553,5307),(90554,5307),(90555,5307),(90556,5308),(90557,5308),(90558,5308),(90559,5308),(90560,5309),(90561,5309),(90562,5309),(90563,5309),(90564,5310),(90565,5310),(90566,5310),(90567,5310),(90568,5311),(90569,5311),(90570,5311),(90571,5311),(90572,5312),(90573,5312),(90574,5312),(90575,5312),(90576,5313),(90577,5313),(90578,5313),(90579,5313),(90580,5314),(90581,5314),(90582,5314),(90583,5314),(90584,5315),(90585,5315),(90586,5315),(90587,5315),(90588,5316),(90589,5316),(90590,5316),(90591,5316),(90592,5317),(90593,5317),(90594,5317),(90595,5317),(90596,5318),(90597,5318),(90598,5318),(90599,5318),(90600,5319),(90601,5319),(90602,5319),(90603,5319),(90604,5320),(90605,5320),(90606,5320),(90607,5320),(90608,5321),(90609,5321),(90610,5321),(90611,5321),(90612,5322),(90613,5322),(90614,5322),(90615,5322),(90616,5323),(90617,5323),(90618,5323),(90619,5323),(90620,5324),(90621,5324),(90622,5324),(90623,5324),(90624,5325),(90625,5325),(90626,5325),(90627,5325),(90628,5326),(90629,5326),(90630,5326),(90631,5326),(90632,5327),(90633,5327),(90634,5327),(90635,5327),(90636,5328),(90637,5328),(90638,5328),(90639,5328),(90640,5329),(90641,5329),(90642,5329),(90643,5329),(90644,5330),(90645,5330),(90646,5330),(90647,5330),(90648,5331),(90649,5331),(90650,5331),(90651,5331),(90652,5332),(90653,5332),(90654,5332),(90655,5332),(90656,5333),(90657,5333),(90658,5333),(90659,5333),(90660,5334),(90661,5334),(90662,5334),(90663,5334),(90664,5335),(90665,5335),(90666,5335),(90667,5335),(90668,5336),(90669,5336),(90670,5336),(90671,5336),(90672,5337),(90673,5337),(90674,5337),(90675,5337),(90676,5338),(90677,5338),(90678,5338),(90679,5338),(90680,5339),(90681,5339),(90682,5339),(90683,5339),(90684,5340),(90685,5340),(90686,5340),(90687,5340),(90688,5341),(90689,5341),(90690,5341),(90691,5341),(90692,5342),(90693,5342),(90694,5342),(90695,5342),(90696,5343),(90697,5343),(90698,5343),(90699,5343),(90700,5344),(90701,5344),(90702,5344),(90703,5344),(90704,5345),(90705,5345),(90706,5345),(90707,5345),(90708,5346),(90709,5346),(90710,5346),(90711,5346),(90712,5347),(90713,5347),(90714,5347),(90715,5347),(90716,5348),(90717,5348),(90718,5348),(90719,5348),(90720,5349),(90721,5349),(90722,5349),(90723,5349),(90724,5350),(90725,5350),(90726,5350),(90727,5350),(90728,5351),(90729,5351),(90730,5351),(90731,5351),(90732,5352),(90733,5352),(90734,5352),(90735,5352),(90736,5353),(90737,5353),(90738,5353),(90739,5353),(90740,5354),(90741,5354),(90742,5354),(90743,5354),(90744,5355),(90745,5355),(90746,5355),(90747,5355),(90748,5356),(90749,5356),(90750,5356),(90751,5356),(90752,5357),(90753,5357),(90754,5357),(90755,5357),(90756,5358),(90757,5358),(90758,5358),(90759,5358),(90760,5359),(90761,5359),(90762,5359),(90763,5359),(90764,5360),(90765,5361),(90766,5362),(90767,5363),(90768,5364),(90769,5365),(90770,5366),(90771,5367),(90772,5368),(90773,5369),(90774,5370),(90775,5371),(90776,5372),(90777,5373),(90778,5374),(90779,5375),(90780,5376),(90781,5377),(90782,5378),(90783,5379),(90784,5380),(90785,5381),(90786,5382),(90787,5383),(90788,5384),(90789,5385),(90790,5386),(90791,5387),(90792,5388),(90793,5389),(90794,5390),(90795,5391),(90796,5392),(90797,5393),(90798,5394),(90799,5395),(90800,5396),(90801,5397),(90802,5398),(90803,5399),(90804,5400),(90805,5401),(90806,5402),(90807,5403),(90808,5404),(90809,5405),(90810,5406),(90811,5407),(90812,5408),(90813,5409),(90814,5410),(90815,5411),(90816,5412),(90817,5413),(90818,5414),(90819,5415),(90820,5416),(90821,5417),(90822,5418),(90823,5419),(90824,5420),(90825,5421),(90826,5422),(90827,5423),(90828,5424),(90829,5425),(90830,5426),(90831,5427),(90832,5428),(90833,5429),(90834,5430),(90835,5431),(90836,5432),(90837,5433),(90838,5434),(90839,5435),(90840,5436),(90841,5437),(90842,5438),(90843,5439),(90844,5440),(90845,5441),(90846,5442),(90847,5443),(90848,5444),(90849,5445),(90850,5446),(90851,5447),(90852,5448),(90853,5449),(90854,5450),(90855,5451),(90856,5452),(90857,5453),(90858,5454),(90859,5455),(90860,5456),(90861,5457),(90862,5458),(90863,5459),(90864,5360),(90865,5360),(90866,5360),(90867,5360),(90868,5360),(90869,5360),(90870,5361),(90871,5361),(90872,5361),(90873,5361),(90874,5361),(90875,5361),(90876,5362),(90877,5362),(90878,5362),(90879,5362),(90880,5362),(90881,5362),(90882,5363),(90883,5363),(90884,5363),(90885,5363),(90886,5363),(90887,5363),(90888,5364),(90889,5364),(90890,5364),(90891,5364),(90892,5364),(90893,5364),(90894,5365),(90895,5365),(90896,5365),(90897,5365),(90898,5365),(90899,5365),(90900,5366),(90901,5366),(90902,5366),(90903,5366),(90904,5366),(90905,5366),(90906,5367),(90907,5367),(90908,5367),(90909,5367),(90910,5367),(90911,5367),(90912,5368),(90913,5368),(90914,5368),(90915,5368),(90916,5368),(90917,5368),(90918,5369),(90919,5369),(90920,5369),(90921,5369),(90922,5369),(90923,5369),(90924,5370),(90925,5370),(90926,5370),(90927,5370),(90928,5370),(90929,5370),(90930,5371),(90931,5371),(90932,5371),(90933,5371),(90934,5371),(90935,5371),(90936,5372),(90937,5372),(90938,5372),(90939,5372),(90940,5372),(90941,5372),(90942,5373),(90943,5373),(90944,5373),(90945,5373),(90946,5373),(90947,5373),(90948,5374),(90949,5374),(90950,5374),(90951,5374),(90952,5374),(90953,5374),(90954,5375),(90955,5375),(90956,5375),(90957,5375),(90958,5375),(90959,5375),(90960,5376),(90961,5376),(90962,5376),(90963,5376),(90964,5376),(90965,5376),(90966,5377),(90967,5377),(90968,5377),(90969,5377),(90970,5377),(90971,5377),(90972,5378),(90973,5378),(90974,5378),(90975,5378),(90976,5378),(90977,5378),(90978,5379),(90979,5379),(90980,5379),(90981,5379),(90982,5379),(90983,5379),(90984,5380),(90985,5380),(90986,5380),(90987,5380),(90988,5380),(90989,5380),(90990,5381),(90991,5381),(90992,5381),(90993,5381),(90994,5381),(90995,5381),(90996,5382),(90997,5382),(90998,5382),(90999,5382),(91000,5382),(91001,5382),(91002,5383),(91003,5383),(91004,5383),(91005,5383),(91006,5384),(91007,5384),(91008,5384),(91009,5384),(91010,5385),(91011,5385),(91012,5385),(91013,5385),(91014,5385),(91015,5385),(91016,5386),(91017,5386),(91018,5386),(91019,5386),(91020,5386),(91021,5386),(91022,5387),(91023,5387),(91024,5387),(91025,5387),(91026,5387),(91027,5387),(91028,5388),(91029,5388),(91030,5388),(91031,5388),(91032,5388),(91033,5388),(91034,5389),(91035,5389),(91036,5389),(91037,5389),(91038,5389),(91039,5389),(91040,5390),(91041,5390),(91042,5390),(91043,5390),(91044,5390),(91045,5390),(91046,5391),(91047,5391),(91048,5391),(91049,5391),(91050,5391),(91051,5391),(91052,5392),(91053,5392),(91054,5392),(91055,5392),(91056,5392),(91057,5392),(91058,5393),(91059,5393),(91060,5393),(91061,5393),(91062,5394),(91063,5394),(91064,5394),(91065,5394),(91066,5395),(91067,5395),(91068,5395),(91069,5395),(91070,5396),(91071,5396),(91072,5396),(91073,5396),(91074,5397),(91075,5397),(91076,5397),(91077,5397),(91078,5398),(91079,5398),(91080,5398),(91081,5398),(91082,5399),(91083,5399),(91084,5399),(91085,5399),(91086,5400),(91087,5400),(91088,5400),(91089,5400),(91090,5401),(91091,5401),(91092,5401),(91093,5401),(91094,5401),(91095,5401),(91096,5402),(91097,5402),(91098,5402),(91099,5402),(91100,5402),(91101,5402),(91102,5403),(91103,5403),(91104,5403),(91105,5403),(91106,5403),(91107,5403),(91108,5404),(91109,5404),(91110,5404),(91111,5404),(91112,5404),(91113,5404),(91114,5405),(91115,5405),(91116,5405),(91117,5405),(91118,5405),(91119,5405),(91120,5406),(91121,5406),(91122,5406),(91123,5406),(91124,5406),(91125,5406),(91126,5407),(91127,5407),(91128,5407),(91129,5407),(91130,5407),(91131,5407),(91132,5408),(91133,5408),(91134,5408),(91135,5408),(91136,5408),(91137,5408),(91138,5409),(91139,5409),(91140,5409),(91141,5409),(91142,5409),(91143,5409),(91144,5410),(91145,5410),(91146,5410),(91147,5410),(91148,5410),(91149,5410),(91150,5411),(91151,5411),(91152,5411),(91153,5411),(91154,5411),(91155,5411),(91156,5412),(91157,5412),(91158,5412),(91159,5412),(91160,5412),(91161,5412),(91162,5413),(91163,5413),(91164,5413),(91165,5413),(91166,5413),(91167,5413),(91168,5414),(91169,5414),(91170,5414),(91171,5414),(91172,5414),(91173,5414),(91174,5415),(91175,5415),(91176,5415),(91177,5415),(91178,5415),(91179,5415),(91180,5416),(91181,5416),(91182,5416),(91183,5416),(91184,5416),(91185,5416),(91186,5417),(91187,5417),(91188,5417),(91189,5417),(91190,5417),(91191,5417),(91192,5418),(91193,5418),(91194,5418),(91195,5418),(91196,5418),(91197,5418),(91198,5419),(91199,5419),(91200,5419),(91201,5419),(91202,5419),(91203,5419),(91204,5420),(91205,5420),(91206,5420),(91207,5420),(91208,5420),(91209,5420),(91210,5421),(91211,5421),(91212,5421),(91213,5421),(91214,5421),(91215,5421),(91216,5422),(91217,5422),(91218,5422),(91219,5422),(91220,5422),(91221,5422),(91222,5423),(91223,5423),(91224,5423),(91225,5423),(91226,5423),(91227,5423),(91228,5424),(91229,5424),(91230,5424),(91231,5424),(91232,5424),(91233,5424),(91234,5425),(91235,5425),(91236,5425),(91237,5425),(91238,5425),(91239,5425),(91240,5426),(91241,5426),(91242,5426),(91243,5426),(91244,5426),(91245,5426),(91246,5427),(91247,5427),(91248,5427),(91249,5427),(91250,5427),(91251,5427),(91252,5428),(91253,5428),(91254,5428),(91255,5428),(91256,5428),(91257,5428),(91258,5429),(91259,5429),(91260,5429),(91261,5429),(91262,5429),(91263,5429),(91264,5430),(91265,5430),(91266,5430),(91267,5430),(91268,5430),(91269,5431),(91270,5431),(91271,5431),(91272,5431),(91273,5431),(91274,5431),(91275,5432),(91276,5432),(91277,5432),(91278,5432),(91279,5432),(91280,5433),(91281,5433),(91282,5433),(91283,5433),(91284,5433),(91285,5433),(91286,5434),(91287,5434),(91288,5434),(91289,5434),(91290,5434),(91291,5435),(91292,5435),(91293,5435),(91294,5435),(91295,5435),(91296,5435),(91297,5436),(91298,5436),(91299,5436),(91300,5436),(91301,5436),(91302,5436),(91303,5437),(91304,5437),(91305,5437),(91306,5437),(91307,5437),(91308,5437),(91309,5438),(91310,5438),(91311,5438),(91312,5438),(91313,5438),(91314,5438),(91315,5439),(91316,5439),(91317,5439),(91318,5439),(91319,5439),(91320,5439),(91321,5440),(91322,5440),(91323,5440),(91324,5440),(91325,5440),(91326,5440),(91327,5441),(91328,5441),(91329,5441),(91330,5441),(91331,5441),(91332,5441),(91333,5442),(91334,5442),(91335,5442),(91336,5442),(91337,5442),(91338,5442),(91339,5443),(91340,5443),(91341,5443),(91342,5443),(91343,5443),(91344,5443),(91345,5444),(91346,5444),(91347,5444),(91348,5444),(91349,5444),(91350,5444),(91351,5445),(91352,5445),(91353,5445),(91354,5445),(91355,5445),(91356,5445),(91357,5446),(91358,5446),(91359,5446),(91360,5446),(91361,5446),(91362,5446),(91363,5447),(91364,5447),(91365,5447),(91366,5447),(91367,5447),(91368,5447),(91369,5448),(91370,5448),(91371,5448),(91372,5448),(91373,5448),(91374,5448),(91375,5449),(91376,5449),(91377,5449),(91378,5449),(91379,5449),(91380,5449),(91381,5450),(91382,5450),(91383,5450),(91384,5450),(91385,5450),(91386,5450),(91387,5451),(91388,5451),(91389,5451),(91390,5451),(91391,5451),(91392,5451),(91393,5452),(91394,5452),(91395,5452),(91396,5452),(91397,5452),(91398,5452),(91399,5453),(91400,5453),(91401,5453),(91402,5453),(91403,5453),(91404,5453),(91405,5454),(91406,5454),(91407,5454),(91408,5454),(91409,5454),(91410,5454),(91411,5455),(91412,5455),(91413,5455),(91414,5455),(91415,5455),(91416,5455),(91417,5456),(91418,5456),(91419,5456),(91420,5456),(91421,5456),(91422,5456),(91423,5457),(91424,5457),(91425,5457),(91426,5457),(91427,5457),(91428,5457),(91429,5458),(91430,5458),(91431,5458),(91432,5458),(91433,5458),(91434,5458),(91435,5459),(91436,5459),(91437,5459),(91438,5459),(91439,5459),(91440,5459),(91441,5360),(91442,5360),(91443,5361),(91444,5361),(91445,5362),(91446,5362),(91447,5363),(91448,5363),(91449,5364),(91450,5364),(91451,5365),(91452,5365),(91453,5366),(91454,5366),(91455,5367),(91456,5367),(91457,5368),(91458,5368),(91459,5368),(91460,5369),(91461,5369),(91462,5370),(91463,5370),(91464,5371),(91465,5371),(91466,5372),(91467,5372),(91468,5373),(91469,5373),(91470,5374),(91471,5374),(91472,5375),(91473,5375),(91474,5376),(91475,5376),(91476,5377),(91477,5377),(91478,5378),(91479,5378),(91480,5379),(91481,5379),(91482,5380),(91483,5380),(91484,5381),(91485,5381),(91486,5382),(91487,5382),(91488,5383),(91489,5384),(91490,5385),(91491,5385),(91492,5386),(91493,5386),(91494,5387),(91495,5387),(91496,5388),(91497,5388),(91498,5389),(91499,5389),(91500,5390),(91501,5390),(91502,5391),(91503,5391),(91504,5392),(91505,5392),(91506,5393),(91507,5394),(91508,5395),(91509,5396),(91510,5397),(91511,5398),(91512,5399),(91513,5400),(91514,5401),(91515,5401),(91516,5402),(91517,5402),(91518,5403),(91519,5403),(91520,5404),(91521,5404),(91522,5405),(91523,5405),(91524,5406),(91525,5406),(91526,5407),(91527,5407),(91528,5408),(91529,5408),(91530,5408),(91531,5409),(91532,5409),(91533,5410),(91534,5410),(91535,5410),(91536,5411),(91537,5411),(91538,5411),(91539,5412),(91540,5412),(91541,5412),(91542,5413),(91543,5413),(91544,5413),(91545,5414),(91546,5414),(91547,5414),(91548,5415),(91549,5415),(91550,5415),(91551,5416),(91552,5416),(91553,5416),(91554,5417),(91555,5417),(91556,5417),(91557,5418),(91558,5418),(91559,5418),(91560,5419),(91561,5419),(91562,5419),(91563,5420),(91564,5420),(91565,5421),(91566,5421),(91567,5422),(91568,5422),(91569,5423),(91570,5423),(91571,5424),(91572,5424),(91573,5425),(91574,5425),(91575,5426),(91576,5426),(91577,5427),(91578,5427),(91579,5428),(91580,5428),(91581,5428),(91582,5429),(91583,5429),(91584,5430),(91585,5430),(91586,5431),(91587,5431),(91588,5432),(91589,5432),(91590,5433),(91591,5433),(91592,5434),(91593,5434),(91594,5435),(91595,5435),(91596,5436),(91597,5436),(91598,5437),(91599,5437),(91600,5438),(91601,5438),(91602,5439),(91603,5439),(91604,5440),(91605,5440),(91606,5441),(91607,5441),(91608,5442),(91609,5442),(91610,5443),(91611,5443),(91612,5444),(91613,5444),(91614,5445),(91615,5445),(91616,5446),(91617,5446),(91618,5447),(91619,5447),(91620,5448),(91621,5448),(91622,5449),(91623,5449),(91624,5450),(91625,5450),(91626,5451),(91627,5451),(91628,5452),(91629,5452),(91630,5453),(91631,5453),(91632,5454),(91633,5454),(91634,5455),(91635,5455),(91636,5456),(91637,5456),(91638,5456),(91639,5457),(91640,5457),(91641,5458),(91642,5458),(91643,5459),(91644,5459),(91645,5459),(91646,5360),(91647,5360),(91648,5360),(91649,5361),(91650,5361),(91651,5361),(91652,5362),(91653,5362),(91654,5362),(91655,5363),(91656,5363),(91657,5363),(91658,5364),(91659,5364),(91660,5364),(91661,5365),(91662,5365),(91663,5365),(91664,5366),(91665,5366),(91666,5366),(91667,5367),(91668,5367),(91669,5367),(91670,5368),(91671,5368),(91672,5368),(91673,5369),(91674,5369),(91675,5369),(91676,5370),(91677,5370),(91678,5370),(91679,5371),(91680,5371),(91681,5371),(91682,5372),(91683,5372),(91684,5372),(91685,5373),(91686,5373),(91687,5373),(91688,5374),(91689,5374),(91690,5374),(91691,5375),(91692,5375),(91693,5375),(91694,5376),(91695,5376),(91696,5376),(91697,5377),(91698,5377),(91699,5377),(91700,5378),(91701,5378),(91702,5378),(91703,5379),(91704,5379),(91705,5379),(91706,5380),(91707,5380),(91708,5380),(91709,5381),(91710,5381),(91711,5381),(91712,5382),(91713,5382),(91714,5382),(91715,5383),(91716,5383),(91717,5383),(91718,5384),(91719,5384),(91720,5384),(91721,5385),(91722,5385),(91723,5385),(91724,5386),(91725,5386),(91726,5386),(91727,5387),(91728,5387),(91729,5387),(91730,5388),(91731,5388),(91732,5388),(91733,5389),(91734,5389),(91735,5389),(91736,5390),(91737,5390),(91738,5390),(91739,5391),(91740,5391),(91741,5391),(91742,5392),(91743,5392),(91744,5392),(91745,5393),(91746,5393),(91747,5393),(91748,5394),(91749,5394),(91750,5394),(91751,5395),(91752,5395),(91753,5395),(91754,5396),(91755,5396),(91756,5396),(91757,5397),(91758,5397),(91759,5397),(91760,5398),(91761,5398),(91762,5398),(91763,5399),(91764,5399),(91765,5399),(91766,5400),(91767,5400),(91768,5400),(91769,5401),(91770,5401),(91771,5401),(91772,5402),(91773,5402),(91774,5402),(91775,5403),(91776,5403),(91777,5403),(91778,5404),(91779,5404),(91780,5404),(91781,5405),(91782,5405),(91783,5405),(91784,5406),(91785,5406),(91786,5406),(91787,5407),(91788,5407),(91789,5407),(91790,5408),(91791,5408),(91792,5408),(91793,5409),(91794,5409),(91795,5409),(91796,5410),(91797,5410),(91798,5410),(91799,5411),(91800,5411),(91801,5411),(91802,5411),(91803,5412),(91804,5412),(91805,5412),(91806,5413),(91807,5413),(91808,5413),(91809,5414),(91810,5414),(91811,5414),(91812,5415),(91813,5415),(91814,5415),(91815,5416),(91816,5416),(91817,5416),(91818,5417),(91819,5417),(91820,5417),(91821,5418),(91822,5418),(91823,5418),(91824,5419),(91825,5419),(91826,5419),(91827,5420),(91828,5420),(91829,5420),(91830,5421),(91831,5421),(91832,5421),(91833,5422),(91834,5422),(91835,5422),(91836,5423),(91837,5423),(91838,5423),(91839,5424),(91840,5424),(91841,5424),(91842,5425),(91843,5425),(91844,5425),(91845,5426),(91846,5426),(91847,5426),(91848,5427),(91849,5427),(91850,5427),(91851,5428),(91852,5428),(91853,5428),(91854,5429),(91855,5429),(91856,5429),(91857,5430),(91858,5430),(91859,5430),(91860,5431),(91861,5431),(91862,5431),(91863,5432),(91864,5432),(91865,5432),(91866,5433),(91867,5433),(91868,5433),(91869,5434),(91870,5434),(91871,5434),(91872,5435),(91873,5435),(91874,5435),(91875,5436),(91876,5436),(91877,5436),(91878,5437),(91879,5437),(91880,5437),(91881,5438),(91882,5438),(91883,5438),(91884,5439),(91885,5439),(91886,5439),(91887,5440),(91888,5440),(91889,5440),(91890,5441),(91891,5441),(91892,5441),(91893,5442),(91894,5442),(91895,5442),(91896,5443),(91897,5443),(91898,5443),(91899,5444),(91900,5444),(91901,5444),(91902,5445),(91903,5445),(91904,5445),(91905,5446),(91906,5446),(91907,5446),(91908,5447),(91909,5447),(91910,5447),(91911,5448),(91912,5448),(91913,5448),(91914,5449),(91915,5449),(91916,5449),(91917,5450),(91918,5450),(91919,5450),(91920,5451),(91921,5451),(91922,5451),(91923,5452),(91924,5452),(91925,5452),(91926,5453),(91927,5453),(91928,5453),(91929,5454),(91930,5454),(91931,5454),(91932,5455),(91933,5455),(91934,5455),(91935,5456),(91936,5456),(91937,5456),(91938,5457),(91939,5457),(91940,5457),(91941,5458),(91942,5458),(91943,5458),(91944,5459),(91945,5459),(91946,5459),(91947,5360),(91948,5360),(91949,5360),(91950,5360),(91951,5361),(91952,5361),(91953,5361),(91954,5361),(91955,5362),(91956,5362),(91957,5362),(91958,5362),(91959,5363),(91960,5363),(91961,5363),(91962,5363),(91963,5364),(91964,5364),(91965,5364),(91966,5364),(91967,5365),(91968,5365),(91969,5365),(91970,5365),(91971,5366),(91972,5366),(91973,5366),(91974,5366),(91975,5367),(91976,5367),(91977,5367),(91978,5367),(91979,5368),(91980,5368),(91981,5368),(91982,5368),(91983,5369),(91984,5369),(91985,5369),(91986,5369),(91987,5370),(91988,5370),(91989,5370),(91990,5370),(91991,5371),(91992,5371),(91993,5371),(91994,5371),(91995,5372),(91996,5372),(91997,5372),(91998,5372),(91999,5373),(92000,5373),(92001,5373),(92002,5373),(92003,5374),(92004,5374),(92005,5374),(92006,5374),(92007,5375),(92008,5375),(92009,5375),(92010,5375),(92011,5376),(92012,5376),(92013,5376),(92014,5376),(92015,5377),(92016,5377),(92017,5377),(92018,5377),(92019,5378),(92020,5378),(92021,5378),(92022,5378),(92023,5379),(92024,5379),(92025,5379),(92026,5379),(92027,5380),(92028,5380),(92029,5380),(92030,5380),(92031,5381),(92032,5381),(92033,5381),(92034,5381),(92035,5382),(92036,5382),(92037,5382),(92038,5382),(92039,5383),(92040,5383),(92041,5383),(92042,5383),(92043,5384),(92044,5384),(92045,5384),(92046,5384),(92047,5385),(92048,5385),(92049,5385),(92050,5385),(92051,5386),(92052,5386),(92053,5386),(92054,5386),(92055,5387),(92056,5387),(92057,5387),(92058,5387),(92059,5388),(92060,5388),(92061,5388),(92062,5388),(92063,5389),(92064,5389),(92065,5389),(92066,5389),(92067,5390),(92068,5390),(92069,5390),(92070,5390),(92071,5391),(92072,5391),(92073,5391),(92074,5391),(92075,5392),(92076,5392),(92077,5392),(92078,5392),(92079,5393),(92080,5393),(92081,5393),(92082,5393),(92083,5394),(92084,5394),(92085,5394),(92086,5394),(92087,5395),(92088,5395),(92089,5395),(92090,5395),(92091,5396),(92092,5396),(92093,5396),(92094,5396),(92095,5397),(92096,5397),(92097,5397),(92098,5397),(92099,5398),(92100,5398),(92101,5398),(92102,5398),(92103,5399),(92104,5399),(92105,5399),(92106,5399),(92107,5400),(92108,5400),(92109,5400),(92110,5400),(92111,5401),(92112,5401),(92113,5401),(92114,5401),(92115,5402),(92116,5402),(92117,5402),(92118,5402),(92119,5403),(92120,5403),(92121,5403),(92122,5403),(92123,5404),(92124,5404),(92125,5404),(92126,5404),(92127,5405),(92128,5405),(92129,5405),(92130,5405),(92131,5406),(92132,5406),(92133,5406),(92134,5406),(92135,5407),(92136,5407),(92137,5407),(92138,5407),(92139,5408),(92140,5408),(92141,5408),(92142,5408),(92143,5409),(92144,5409),(92145,5409),(92146,5409),(92147,5410),(92148,5410),(92149,5410),(92150,5410),(92151,5411),(92152,5411),(92153,5411),(92154,5411),(92155,5412),(92156,5412),(92157,5412),(92158,5412),(92159,5413),(92160,5413),(92161,5413),(92162,5413),(92163,5414),(92164,5414),(92165,5414),(92166,5414),(92167,5415),(92168,5415),(92169,5415),(92170,5415),(92171,5416),(92172,5416),(92173,5416),(92174,5416),(92175,5417),(92176,5417),(92177,5417),(92178,5417),(92179,5418),(92180,5418),(92181,5418),(92182,5418),(92183,5419),(92184,5419),(92185,5419),(92186,5419),(92187,5420),(92188,5420),(92189,5420),(92190,5420),(92191,5421),(92192,5421),(92193,5421),(92194,5421),(92195,5422),(92196,5422),(92197,5422),(92198,5422),(92199,5423),(92200,5423),(92201,5423),(92202,5423),(92203,5424),(92204,5424),(92205,5424),(92206,5424),(92207,5425),(92208,5425),(92209,5425),(92210,5425),(92211,5426),(92212,5426),(92213,5426),(92214,5426),(92215,5427),(92216,5427),(92217,5427),(92218,5427),(92219,5428),(92220,5428),(92221,5428),(92222,5428),(92223,5429),(92224,5429),(92225,5429),(92226,5429),(92227,5430),(92228,5430),(92229,5430),(92230,5430),(92231,5431),(92232,5431),(92233,5431),(92234,5431),(92235,5432),(92236,5432),(92237,5432),(92238,5432),(92239,5433),(92240,5433),(92241,5433),(92242,5433),(92243,5434),(92244,5434),(92245,5434),(92246,5434),(92247,5435),(92248,5435),(92249,5435),(92250,5435),(92251,5436),(92252,5436),(92253,5436),(92254,5436),(92255,5437),(92256,5437),(92257,5437),(92258,5437),(92259,5438),(92260,5438),(92261,5438),(92262,5438),(92263,5439),(92264,5439),(92265,5439),(92266,5439),(92267,5440),(92268,5440),(92269,5440),(92270,5440),(92271,5441),(92272,5441),(92273,5441),(92274,5441),(92275,5442),(92276,5442),(92277,5442),(92278,5442),(92279,5443),(92280,5443),(92281,5443),(92282,5443),(92283,5444),(92284,5444),(92285,5444),(92286,5444),(92287,5445),(92288,5445),(92289,5445),(92290,5445),(92291,5446),(92292,5446),(92293,5446),(92294,5446),(92295,5447),(92296,5447),(92297,5447),(92298,5447),(92299,5448),(92300,5448),(92301,5448),(92302,5448),(92303,5449),(92304,5449),(92305,5449),(92306,5449),(92307,5450),(92308,5450),(92309,5450),(92310,5450),(92311,5451),(92312,5451),(92313,5451),(92314,5451),(92315,5452),(92316,5452),(92317,5452),(92318,5452),(92319,5453),(92320,5453),(92321,5453),(92322,5453),(92323,5454),(92324,5454),(92325,5454),(92326,5454),(92327,5455),(92328,5455),(92329,5455),(92330,5455),(92331,5456),(92332,5456),(92333,5456),(92334,5456),(92335,5457),(92336,5457),(92337,5457),(92338,5457),(92339,5458),(92340,5458),(92341,5458),(92342,5458),(92343,5459),(92344,5459),(92345,5459),(92346,5459),(92347,5460),(92348,5461),(92349,5462),(92350,5463),(92351,5464),(92352,5465),(92353,5466),(92354,5467),(92355,5468),(92356,5469),(92357,5470),(92358,5471),(92359,5472),(92360,5473),(92361,5474),(92362,5475),(92363,5476),(92364,5477),(92365,5478),(92366,5479),(92367,5480),(92368,5481),(92369,5482),(92370,5483),(92371,5484),(92372,5485),(92373,5486),(92374,5487),(92375,5488),(92376,5489),(92377,5490),(92378,5491),(92379,5492),(92380,5493),(92381,5494),(92382,5495),(92383,5496),(92384,5497),(92385,5498),(92386,5499),(92387,5500),(92388,5501),(92389,5502),(92390,5503),(92391,5504),(92392,5505),(92393,5506),(92394,5507),(92395,5508),(92396,5509),(92397,5510),(92398,5511),(92399,5512),(92400,5513),(92401,5514),(92402,5515),(92403,5516),(92404,5517),(92405,5518),(92406,5519),(92407,5520),(92408,5521),(92409,5522),(92410,5523),(92411,5524),(92412,5525),(92413,5526),(92414,5527),(92415,5528),(92416,5529),(92417,5530),(92418,5531),(92419,5532),(92420,5533),(92421,5534),(92422,5535),(92423,5536),(92424,5537),(92425,5538),(92426,5539),(92427,5540),(92428,5541),(92429,5542),(92430,5543),(92431,5544),(92432,5545),(92433,5546),(92434,5547),(92435,5548),(92436,5549),(92437,5550),(92438,5551),(92439,5552),(92440,5553),(92441,5554),(92442,5555),(92443,5556),(92444,5557),(92445,5558),(92446,5559),(92447,5460),(92448,5460),(92449,5460),(92450,5460),(92451,5460),(92452,5460),(92453,5461),(92454,5461),(92455,5461),(92456,5461),(92457,5461),(92458,5461),(92459,5462),(92460,5462),(92461,5462),(92462,5462),(92463,5462),(92464,5462),(92465,5463),(92466,5463),(92467,5463),(92468,5463),(92469,5463),(92470,5463),(92471,5464),(92472,5464),(92473,5464),(92474,5464),(92475,5464),(92476,5464),(92477,5465),(92478,5465),(92479,5465),(92480,5465),(92481,5465),(92482,5465),(92483,5466),(92484,5466),(92485,5466),(92486,5466),(92487,5466),(92488,5466),(92489,5467),(92490,5467),(92491,5467),(92492,5467),(92493,5467),(92494,5467),(92495,5468),(92496,5468),(92497,5468),(92498,5468),(92499,5468),(92500,5468),(92501,5469),(92502,5469),(92503,5469),(92504,5469),(92505,5469),(92506,5469),(92507,5470),(92508,5470),(92509,5470),(92510,5470),(92511,5470),(92512,5470),(92513,5471),(92514,5471),(92515,5471),(92516,5471),(92517,5471),(92518,5471),(92519,5472),(92520,5472),(92521,5472),(92522,5472),(92523,5472),(92524,5472),(92525,5473),(92526,5473),(92527,5473),(92528,5473),(92529,5473),(92530,5473),(92531,5474),(92532,5474),(92533,5474),(92534,5474),(92535,5474),(92536,5474),(92537,5475),(92538,5475),(92539,5475),(92540,5475),(92541,5475),(92542,5475),(92543,5476),(92544,5476),(92545,5476),(92546,5476),(92547,5476),(92548,5476),(92549,5477),(92550,5477),(92551,5477),(92552,5477),(92553,5477),(92554,5477),(92555,5478),(92556,5478),(92557,5478),(92558,5478),(92559,5478),(92560,5478),(92561,5479),(92562,5479),(92563,5479),(92564,5479),(92565,5479),(92566,5479),(92567,5480),(92568,5480),(92569,5480),(92570,5480),(92571,5480),(92572,5480),(92573,5481),(92574,5481),(92575,5481),(92576,5481),(92577,5481),(92578,5481),(92579,5482),(92580,5482),(92581,5482),(92582,5482),(92583,5482),(92584,5482),(92585,5483),(92586,5483),(92587,5483),(92588,5483),(92589,5483),(92590,5483),(92591,5484),(92592,5484),(92593,5484),(92594,5484),(92595,5484),(92596,5484),(92597,5485),(92598,5485),(92599,5485),(92600,5485),(92601,5485),(92602,5485),(92603,5486),(92604,5486),(92605,5486),(92606,5486),(92607,5486),(92608,5486),(92609,5487),(92610,5487),(92611,5487),(92612,5487),(92613,5487),(92614,5487),(92615,5488),(92616,5488),(92617,5488),(92618,5488),(92619,5488),(92620,5488),(92621,5489),(92622,5489),(92623,5489),(92624,5489),(92625,5489),(92626,5489),(92627,5490),(92628,5490),(92629,5490),(92630,5490),(92631,5490),(92632,5490),(92633,5491),(92634,5491),(92635,5491),(92636,5491),(92637,5491),(92638,5491),(92639,5492),(92640,5492),(92641,5492),(92642,5492),(92643,5492),(92644,5492),(92645,5493),(92646,5493),(92647,5493),(92648,5493),(92649,5493),(92650,5493),(92651,5494),(92652,5494),(92653,5494),(92654,5494),(92655,5494),(92656,5494),(92657,5495),(92658,5495),(92659,5495),(92660,5495),(92661,5495),(92662,5495),(92663,5496),(92664,5496),(92665,5496),(92666,5496),(92667,5496),(92668,5496),(92669,5497),(92670,5497),(92671,5497),(92672,5497),(92673,5497),(92674,5497),(92675,5498),(92676,5498),(92677,5498),(92678,5498),(92679,5498),(92680,5498),(92681,5499),(92682,5499),(92683,5499),(92684,5499),(92685,5499),(92686,5499),(92687,5500),(92688,5500),(92689,5500),(92690,5500),(92691,5500),(92692,5500),(92693,5501),(92694,5501),(92695,5501),(92696,5501),(92697,5501),(92698,5501),(92699,5502),(92700,5502),(92701,5502),(92702,5502),(92703,5502),(92704,5502),(92705,5503),(92706,5503),(92707,5503),(92708,5503),(92709,5503),(92710,5503),(92711,5504),(92712,5504),(92713,5504),(92714,5504),(92715,5504),(92716,5504),(92717,5505),(92718,5505),(92719,5505),(92720,5505),(92721,5505),(92722,5505),(92723,5506),(92724,5506),(92725,5506),(92726,5506),(92727,5506),(92728,5506),(92729,5507),(92730,5507),(92731,5507),(92732,5507),(92733,5507),(92734,5507),(92735,5508),(92736,5508),(92737,5508),(92738,5508),(92739,5508),(92740,5508),(92741,5509),(92742,5509),(92743,5509),(92744,5509),(92745,5509),(92746,5509),(92747,5510),(92748,5510),(92749,5510),(92750,5510),(92751,5510),(92752,5510),(92753,5511),(92754,5511),(92755,5511),(92756,5511),(92757,5511),(92758,5511),(92759,5512),(92760,5512),(92761,5512),(92762,5512),(92763,5512),(92764,5512),(92765,5513),(92766,5513),(92767,5513),(92768,5513),(92769,5513),(92770,5513),(92771,5514),(92772,5514),(92773,5514),(92774,5514),(92775,5514),(92776,5514),(92777,5515),(92778,5515),(92779,5515),(92780,5515),(92781,5515),(92782,5515),(92783,5516),(92784,5516),(92785,5516),(92786,5516),(92787,5516),(92788,5516),(92789,5517),(92790,5517),(92791,5517),(92792,5517),(92793,5517),(92794,5517),(92795,5518),(92796,5518),(92797,5518),(92798,5518),(92799,5518),(92800,5518),(92801,5519),(92802,5519),(92803,5519),(92804,5519),(92805,5519),(92806,5519),(92807,5520),(92808,5520),(92809,5520),(92810,5520),(92811,5520),(92812,5520),(92813,5521),(92814,5521),(92815,5521),(92816,5521),(92817,5521),(92818,5521),(92819,5522),(92820,5522),(92821,5522),(92822,5522),(92823,5522),(92824,5522),(92825,5523),(92826,5523),(92827,5523),(92828,5523),(92829,5523),(92830,5523),(92831,5524),(92832,5524),(92833,5524),(92834,5524),(92835,5524),(92836,5525),(92837,5525),(92838,5525),(92839,5525),(92840,5525),(92841,5525),(92842,5526),(92843,5526),(92844,5526),(92845,5526),(92846,5526),(92847,5526),(92848,5527),(92849,5527),(92850,5527),(92851,5527),(92852,5527),(92853,5527),(92854,5528),(92855,5528),(92856,5528),(92857,5528),(92858,5528),(92859,5528),(92860,5529),(92861,5529),(92862,5529),(92863,5529),(92864,5529),(92865,5529),(92866,5530),(92867,5530),(92868,5530),(92869,5530),(92870,5530),(92871,5530),(92872,5531),(92873,5531),(92874,5531),(92875,5531),(92876,5531),(92877,5531),(92878,5532),(92879,5532),(92880,5532),(92881,5532),(92882,5532),(92883,5532),(92884,5533),(92885,5533),(92886,5533),(92887,5533),(92888,5533),(92889,5533),(92890,5534),(92891,5534),(92892,5534),(92893,5534),(92894,5534),(92895,5534),(92896,5535),(92897,5535),(92898,5535),(92899,5535),(92900,5535),(92901,5535),(92902,5536),(92903,5536),(92904,5536),(92905,5536),(92906,5536),(92907,5536),(92908,5537),(92909,5537),(92910,5537),(92911,5537),(92912,5537),(92913,5537),(92914,5538),(92915,5538),(92916,5538),(92917,5538),(92918,5538),(92919,5538),(92920,5539),(92921,5539),(92922,5539),(92923,5539),(92924,5539),(92925,5539),(92926,5540),(92927,5540),(92928,5540),(92929,5540),(92930,5540),(92931,5540),(92932,5541),(92933,5541),(92934,5541),(92935,5541),(92936,5541),(92937,5541),(92938,5542),(92939,5542),(92940,5542),(92941,5542),(92942,5542),(92943,5542),(92944,5543),(92945,5543),(92946,5543),(92947,5543),(92948,5543),(92949,5543),(92950,5544),(92951,5544),(92952,5544),(92953,5544),(92954,5544),(92955,5544),(92956,5545),(92957,5545),(92958,5545),(92959,5545),(92960,5545),(92961,5545),(92962,5546),(92963,5546),(92964,5546),(92965,5546),(92966,5546),(92967,5546),(92968,5547),(92969,5547),(92970,5547),(92971,5547),(92972,5547),(92973,5547),(92974,5548),(92975,5548),(92976,5548),(92977,5548),(92978,5548),(92979,5548),(92980,5549),(92981,5549),(92982,5549),(92983,5549),(92984,5549),(92985,5549),(92986,5550),(92987,5550),(92988,5550),(92989,5550),(92990,5550),(92991,5550),(92992,5551),(92993,5551),(92994,5551),(92995,5551),(92996,5551),(92997,5551),(92998,5552),(92999,5552),(93000,5552),(93001,5552),(93002,5552),(93003,5552),(93004,5553),(93005,5553),(93006,5553),(93007,5553),(93008,5553),(93009,5553),(93010,5554),(93011,5554),(93012,5554),(93013,5554),(93014,5554),(93015,5554),(93016,5555),(93017,5555),(93018,5555),(93019,5555),(93020,5555),(93021,5555),(93022,5556),(93023,5556),(93024,5556),(93025,5556),(93026,5556),(93027,5556),(93028,5557),(93029,5557),(93030,5557),(93031,5557),(93032,5557),(93033,5557),(93034,5558),(93035,5558),(93036,5558),(93037,5558),(93038,5558),(93039,5558),(93040,5559),(93041,5559),(93042,5559),(93043,5559),(93044,5559),(93045,5559),(93046,5460),(93047,5460),(93048,5460),(93049,5461),(93050,5461),(93051,5461),(93052,5462),(93053,5462),(93054,5462),(93055,5463),(93056,5463),(93057,5464),(93058,5464),(93059,5465),(93060,5465),(93061,5466),(93062,5466),(93063,5467),(93064,5467),(93065,5468),(93066,5468),(93067,5469),(93068,5469),(93069,5469),(93070,5470),(93071,5470),(93072,5470),(93073,5471),(93074,5471),(93075,5471),(93076,5472),(93077,5472),(93078,5472),(93079,5473),(93080,5473),(93081,5473),(93082,5474),(93083,5474),(93084,5475),(93085,5475),(93086,5476),(93087,5476),(93088,5477),(93089,5477),(93090,5478),(93091,5478),(93092,5479),(93093,5479),(93094,5480),(93095,5480),(93096,5481),(93097,5481),(93098,5482),(93099,5482),(93100,5483),(93101,5483),(93102,5484),(93103,5484),(93104,5485),(93105,5485),(93106,5486),(93107,5486),(93108,5487),(93109,5487),(93110,5488),(93111,5488),(93112,5489),(93113,5489),(93114,5490),(93115,5490),(93116,5490),(93117,5491),(93118,5491),(93119,5491),(93120,5492),(93121,5492),(93122,5492),(93123,5493),(93124,5493),(93125,5493),(93126,5494),(93127,5494),(93128,5494),(93129,5495),(93130,5495),(93131,5495),(93132,5496),(93133,5496),(93134,5496),(93135,5497),(93136,5497),(93137,5497),(93138,5498),(93139,5498),(93140,5498),(93141,5499),(93142,5499),(93143,5499),(93144,5500),(93145,5500),(93146,5500),(93147,5501),(93148,5501),(93149,5501),(93150,5502),(93151,5502),(93152,5502),(93153,5503),(93154,5503),(93155,5503),(93156,5504),(93157,5504),(93158,5504),(93159,5505),(93160,5505),(93161,5505),(93162,5506),(93163,5506),(93164,5506),(93165,5507),(93166,5507),(93167,5507),(93168,5508),(93169,5508),(93170,5508),(93171,5509),(93172,5509),(93173,5509),(93174,5510),(93175,5510),(93176,5510),(93177,5511),(93178,5511),(93179,5511),(93180,5512),(93181,5512),(93182,5512),(93183,5513),(93184,5513),(93185,5513),(93186,5514),(93187,5514),(93188,5514),(93189,5515),(93190,5515),(93191,5515),(93192,5516),(93193,5516),(93194,5516),(93195,5517),(93196,5517),(93197,5517),(93198,5518),(93199,5518),(93200,5519),(93201,5519),(93202,5520),(93203,5520),(93204,5521),(93205,5521),(93206,5522),(93207,5522),(93208,5523),(93209,5523),(93210,5524),(93211,5524),(93212,5525),(93213,5525),(93214,5526),(93215,5526),(93216,5527),(93217,5527),(93218,5528),(93219,5528),(93220,5529),(93221,5529),(93222,5530),(93223,5530),(93224,5531),(93225,5531),(93226,5532),(93227,5532),(93228,5533),(93229,5533),(93230,5534),(93231,5534),(93232,5535),(93233,5535),(93234,5536),(93235,5536),(93236,5536),(93237,5537),(93238,5537),(93239,5537),(93240,5538),(93241,5538),(93242,5538),(93243,5539),(93244,5539),(93245,5539),(93246,5540),(93247,5540),(93248,5540),(93249,5541),(93250,5541),(93251,5541),(93252,5542),(93253,5542),(93254,5542),(93255,5543),(93256,5543),(93257,5543),(93258,5544),(93259,5544),(93260,5544),(93261,5545),(93262,5545),(93263,5545),(93264,5546),(93265,5546),(93266,5546),(93267,5547),(93268,5547),(93269,5547),(93270,5548),(93271,5548),(93272,5548),(93273,5549),(93274,5549),(93275,5549),(93276,5550),(93277,5550),(93278,5550),(93279,5551),(93280,5551),(93281,5552),(93282,5552),(93283,5553),(93284,5553),(93285,5554),(93286,5554),(93287,5555),(93288,5555),(93289,5556),(93290,5556),(93291,5557),(93292,5557),(93293,5558),(93294,5558),(93295,5559),(93296,5559),(93297,5460),(93298,5460),(93299,5460),(93300,5461),(93301,5461),(93302,5461),(93303,5462),(93304,5462),(93305,5462),(93306,5463),(93307,5463),(93308,5463),(93309,5464),(93310,5464),(93311,5464),(93312,5465),(93313,5465),(93314,5465),(93315,5466),(93316,5466),(93317,5466),(93318,5467),(93319,5467),(93320,5467),(93321,5468),(93322,5468),(93323,5468),(93324,5469),(93325,5469),(93326,5469),(93327,5470),(93328,5470),(93329,5470),(93330,5471),(93331,5471),(93332,5471),(93333,5471),(93334,5472),(93335,5472),(93336,5472),(93337,5472),(93338,5473),(93339,5473),(93340,5473),(93341,5474),(93342,5474),(93343,5474),(93344,5475),(93345,5475),(93346,5475),(93347,5476),(93348,5476),(93349,5476),(93350,5477),(93351,5477),(93352,5477),(93353,5478),(93354,5478),(93355,5478),(93356,5479),(93357,5479),(93358,5479),(93359,5480),(93360,5480),(93361,5480),(93362,5481),(93363,5481),(93364,5481),(93365,5482),(93366,5482),(93367,5482),(93368,5483),(93369,5483),(93370,5483),(93371,5484),(93372,5484),(93373,5484),(93374,5485),(93375,5485),(93376,5485),(93377,5486),(93378,5486),(93379,5486),(93380,5487),(93381,5487),(93382,5487),(93383,5488),(93384,5488),(93385,5488),(93386,5489),(93387,5489),(93388,5489),(93389,5490),(93390,5490),(93391,5490),(93392,5491),(93393,5491),(93394,5491),(93395,5492),(93396,5492),(93397,5492),(93398,5493),(93399,5493),(93400,5493),(93401,5494),(93402,5494),(93403,5494),(93404,5495),(93405,5495),(93406,5495),(93407,5496),(93408,5496),(93409,5496),(93410,5497),(93411,5497),(93412,5497),(93413,5498),(93414,5498),(93415,5498),(93416,5499),(93417,5499),(93418,5499),(93419,5500),(93420,5500),(93421,5500),(93422,5501),(93423,5501),(93424,5501),(93425,5502),(93426,5502),(93427,5502),(93428,5503),(93429,5503),(93430,5503),(93431,5504),(93432,5504),(93433,5504),(93434,5505),(93435,5505),(93436,5505),(93437,5506),(93438,5506),(93439,5506),(93440,5507),(93441,5507),(93442,5507),(93443,5508),(93444,5508),(93445,5508),(93446,5509),(93447,5509),(93448,5509),(93449,5510),(93450,5510),(93451,5510),(93452,5511),(93453,5511),(93454,5511),(93455,5512),(93456,5512),(93457,5512),(93458,5513),(93459,5513),(93460,5513),(93461,5514),(93462,5514),(93463,5514),(93464,5515),(93465,5515),(93466,5515),(93467,5516),(93468,5516),(93469,5516),(93470,5517),(93471,5517),(93472,5517),(93473,5518),(93474,5518),(93475,5518),(93476,5519),(93477,5519),(93478,5519),(93479,5520),(93480,5520),(93481,5520),(93482,5521),(93483,5521),(93484,5521),(93485,5522),(93486,5522),(93487,5522),(93488,5523),(93489,5523),(93490,5523),(93491,5524),(93492,5524),(93493,5524),(93494,5525),(93495,5525),(93496,5525),(93497,5526),(93498,5526),(93499,5526),(93500,5527),(93501,5527),(93502,5527),(93503,5528),(93504,5528),(93505,5528),(93506,5529),(93507,5529),(93508,5529),(93509,5530),(93510,5530),(93511,5530),(93512,5531),(93513,5531),(93514,5531),(93515,5532),(93516,5532),(93517,5532),(93518,5533),(93519,5533),(93520,5533),(93521,5534),(93522,5534),(93523,5534),(93524,5535),(93525,5535),(93526,5535),(93527,5536),(93528,5536),(93529,5537),(93530,5537),(93531,5538),(93532,5538),(93533,5538),(93534,5539),(93535,5539),(93536,5539),(93537,5540),(93538,5540),(93539,5540),(93540,5540),(93541,5541),(93542,5541),(93543,5541),(93544,5541),(93545,5542),(93546,5542),(93547,5542),(93548,5542),(93549,5543),(93550,5543),(93551,5543),(93552,5543),(93553,5544),(93554,5544),(93555,5544),(93556,5544),(93557,5545),(93558,5545),(93559,5545),(93560,5545),(93561,5546),(93562,5546),(93563,5546),(93564,5547),(93565,5547),(93566,5547),(93567,5548),(93568,5548),(93569,5548),(93570,5549),(93571,5549),(93572,5549),(93573,5550),(93574,5550),(93575,5550),(93576,5551),(93577,5551),(93578,5551),(93579,5552),(93580,5552),(93581,5552),(93582,5553),(93583,5553),(93584,5553),(93585,5554),(93586,5554),(93587,5554),(93588,5555),(93589,5555),(93590,5555),(93591,5556),(93592,5556),(93593,5556),(93594,5557),(93595,5557),(93596,5557),(93597,5558),(93598,5558),(93599,5558),(93600,5559),(93601,5559),(93602,5559),(93603,5460),(93604,5460),(93605,5460),(93606,5460),(93607,5461),(93608,5461),(93609,5461),(93610,5461),(93611,5462),(93612,5462),(93613,5462),(93614,5462),(93615,5463),(93616,5463),(93617,5463),(93618,5463),(93619,5464),(93620,5464),(93621,5464),(93622,5464),(93623,5465),(93624,5465),(93625,5465),(93626,5465),(93627,5466),(93628,5466),(93629,5466),(93630,5466),(93631,5467),(93632,5467),(93633,5467),(93634,5467),(93635,5468),(93636,5468),(93637,5468),(93638,5468),(93639,5469),(93640,5469),(93641,5469),(93642,5469),(93643,5470),(93644,5470),(93645,5470),(93646,5470),(93647,5471),(93648,5471),(93649,5471),(93650,5471),(93651,5472),(93652,5472),(93653,5472),(93654,5472),(93655,5473),(93656,5473),(93657,5473),(93658,5473),(93659,5474),(93660,5474),(93661,5474),(93662,5474),(93663,5475),(93664,5475),(93665,5475),(93666,5475),(93667,5476),(93668,5476),(93669,5476),(93670,5476),(93671,5477),(93672,5477),(93673,5477),(93674,5477),(93675,5478),(93676,5478),(93677,5478),(93678,5478),(93679,5479),(93680,5479),(93681,5479),(93682,5479),(93683,5480),(93684,5480),(93685,5480),(93686,5480),(93687,5481),(93688,5481),(93689,5481),(93690,5481),(93691,5482),(93692,5482),(93693,5482),(93694,5482),(93695,5483),(93696,5483),(93697,5483),(93698,5483),(93699,5484),(93700,5484),(93701,5484),(93702,5484),(93703,5485),(93704,5485),(93705,5485),(93706,5485),(93707,5486),(93708,5486),(93709,5486),(93710,5486),(93711,5487),(93712,5487),(93713,5487),(93714,5487),(93715,5488),(93716,5488),(93717,5488),(93718,5488),(93719,5489),(93720,5489),(93721,5489),(93722,5489),(93723,5490),(93724,5490),(93725,5490),(93726,5490),(93727,5491),(93728,5491),(93729,5491),(93730,5491),(93731,5492),(93732,5492),(93733,5492),(93734,5492),(93735,5493),(93736,5493),(93737,5493),(93738,5493),(93739,5494),(93740,5494),(93741,5494),(93742,5494),(93743,5495),(93744,5495),(93745,5495),(93746,5495),(93747,5496),(93748,5496),(93749,5496),(93750,5496),(93751,5497),(93752,5497),(93753,5497),(93754,5497),(93755,5498),(93756,5498),(93757,5498),(93758,5498),(93759,5499),(93760,5499),(93761,5499),(93762,5499),(93763,5500),(93764,5500),(93765,5500),(93766,5500),(93767,5501),(93768,5501),(93769,5501),(93770,5501),(93771,5502),(93772,5502),(93773,5502),(93774,5502),(93775,5503),(93776,5503),(93777,5503),(93778,5503),(93779,5504),(93780,5504),(93781,5504),(93782,5504),(93783,5505),(93784,5505),(93785,5505),(93786,5505),(93787,5506),(93788,5506),(93789,5506),(93790,5506),(93791,5507),(93792,5507),(93793,5507),(93794,5507),(93795,5508),(93796,5508),(93797,5508),(93798,5508),(93799,5509),(93800,5509),(93801,5509),(93802,5509),(93803,5510),(93804,5510),(93805,5510),(93806,5510),(93807,5511),(93808,5511),(93809,5511),(93810,5511),(93811,5512),(93812,5512),(93813,5512),(93814,5512),(93815,5513),(93816,5513),(93817,5513),(93818,5513),(93819,5514),(93820,5514),(93821,5514),(93822,5514),(93823,5515),(93824,5515),(93825,5515),(93826,5515),(93827,5516),(93828,5516),(93829,5516),(93830,5516),(93831,5517),(93832,5517),(93833,5517),(93834,5517),(93835,5518),(93836,5518),(93837,5518),(93838,5518),(93839,5519),(93840,5519),(93841,5519),(93842,5519),(93843,5520),(93844,5520),(93845,5520),(93846,5520),(93847,5521),(93848,5521),(93849,5521),(93850,5521),(93851,5522),(93852,5522),(93853,5522),(93854,5522),(93855,5523),(93856,5523),(93857,5523),(93858,5523),(93859,5524),(93860,5524),(93861,5524),(93862,5524),(93863,5525),(93864,5525),(93865,5525),(93866,5525),(93867,5526),(93868,5526),(93869,5526),(93870,5526),(93871,5527),(93872,5527),(93873,5527),(93874,5527),(93875,5528),(93876,5528),(93877,5528),(93878,5528),(93879,5529),(93880,5529),(93881,5529),(93882,5529),(93883,5530),(93884,5530),(93885,5530),(93886,5530),(93887,5531),(93888,5531),(93889,5531),(93890,5531),(93891,5532),(93892,5532),(93893,5532),(93894,5532),(93895,5533),(93896,5533),(93897,5533),(93898,5533),(93899,5534),(93900,5534),(93901,5534),(93902,5534),(93903,5535),(93904,5535),(93905,5535),(93906,5535),(93907,5536),(93908,5536),(93909,5536),(93910,5536),(93911,5537),(93912,5537),(93913,5537),(93914,5537),(93915,5538),(93916,5538),(93917,5538),(93918,5538),(93919,5539),(93920,5539),(93921,5539),(93922,5539),(93923,5540),(93924,5540),(93925,5540),(93926,5540),(93927,5541),(93928,5541),(93929,5541),(93930,5541),(93931,5542),(93932,5542),(93933,5542),(93934,5542),(93935,5543),(93936,5543),(93937,5543),(93938,5543),(93939,5544),(93940,5544),(93941,5544),(93942,5544),(93943,5545),(93944,5545),(93945,5545),(93946,5545),(93947,5546),(93948,5546),(93949,5546),(93950,5546),(93951,5547),(93952,5547),(93953,5547),(93954,5547),(93955,5548),(93956,5548),(93957,5548),(93958,5548),(93959,5549),(93960,5549),(93961,5549),(93962,5549),(93963,5550),(93964,5550),(93965,5550),(93966,5550),(93967,5551),(93968,5551),(93969,5551),(93970,5551),(93971,5552),(93972,5552),(93973,5552),(93974,5552),(93975,5553),(93976,5553),(93977,5553),(93978,5553),(93979,5554),(93980,5554),(93981,5554),(93982,5554),(93983,5555),(93984,5555),(93985,5555),(93986,5555),(93987,5556),(93988,5556),(93989,5556),(93990,5556),(93991,5557),(93992,5557),(93993,5557),(93994,5557),(93995,5558),(93996,5558),(93997,5558),(93998,5558),(93999,5559),(94000,5559),(94001,5559),(94002,5559),(94003,5560),(94004,5561),(94005,5562),(94006,5563),(94007,5564),(94008,5565),(94009,5566),(94010,5567),(94011,5568),(94012,5569),(94013,5570),(94014,5571),(94015,5572),(94016,5573),(94017,5574),(94018,5575),(94019,5576),(94020,5577),(94021,5578),(94022,5579),(94023,5580),(94024,5581),(94025,5582),(94026,5583),(94027,5584),(94028,5585),(94029,5586),(94030,5587),(94031,5588),(94032,5589),(94033,5590),(94034,5591),(94035,5592),(94036,5593),(94037,5594),(94038,5595),(94039,5596),(94040,5597),(94041,5598),(94042,5599),(94043,5600),(94044,5601),(94045,5602),(94046,5603),(94047,5604),(94048,5605),(94049,5606),(94050,5607),(94051,5608),(94052,5609),(94053,5610),(94054,5611),(94055,5612),(94056,5613),(94057,5614),(94058,5615),(94059,5616),(94060,5617),(94061,5618),(94062,5619),(94063,5620),(94064,5621),(94065,5622),(94066,5623),(94067,5624),(94068,5625),(94069,5626),(94070,5627),(94071,5628),(94072,5629),(94073,5630),(94074,5631),(94075,5632),(94076,5633),(94077,5634),(94078,5635),(94079,5636),(94080,5637),(94081,5638),(94082,5639),(94083,5640),(94084,5641),(94085,5642),(94086,5643),(94087,5644),(94088,5645),(94089,5646),(94090,5647),(94091,5648),(94092,5649),(94093,5650),(94094,5651),(94095,5652),(94096,5653),(94097,5654),(94098,5655),(94099,5656),(94100,5657),(94101,5658),(94102,5659),(94103,5560),(94104,5560),(94105,5560),(94106,5560),(94107,5560),(94108,5560),(94109,5561),(94110,5561),(94111,5561),(94112,5561),(94113,5561),(94114,5561),(94115,5562),(94116,5562),(94117,5562),(94118,5562),(94119,5562),(94120,5562),(94121,5563),(94122,5563),(94123,5563),(94124,5563),(94125,5563),(94126,5563),(94127,5564),(94128,5564),(94129,5564),(94130,5564),(94131,5564),(94132,5564),(94133,5565),(94134,5565),(94135,5565),(94136,5565),(94137,5565),(94138,5565),(94139,5566),(94140,5566),(94141,5566),(94142,5566),(94143,5566),(94144,5566),(94145,5567),(94146,5567),(94147,5567),(94148,5567),(94149,5567),(94150,5567),(94151,5568),(94152,5568),(94153,5568),(94154,5568),(94155,5568),(94156,5568),(94157,5569),(94158,5569),(94159,5569),(94160,5569),(94161,5569),(94162,5569),(94163,5570),(94164,5570),(94165,5570),(94166,5570),(94167,5570),(94168,5571),(94169,5571),(94170,5571),(94171,5571),(94172,5571),(94173,5571),(94174,5572),(94175,5572),(94176,5572),(94177,5572),(94178,5572),(94179,5572),(94180,5573),(94181,5573),(94182,5573),(94183,5573),(94184,5573),(94185,5573),(94186,5574),(94187,5574),(94188,5574),(94189,5574),(94190,5574),(94191,5574),(94192,5575),(94193,5575),(94194,5575),(94195,5575),(94196,5575),(94197,5575),(94198,5576),(94199,5576),(94200,5576),(94201,5576),(94202,5576),(94203,5576),(94204,5577),(94205,5577),(94206,5577),(94207,5577),(94208,5578),(94209,5578),(94210,5578),(94211,5578),(94212,5578),(94213,5578),(94214,5579),(94215,5579),(94216,5579),(94217,5579),(94218,5579),(94219,5579),(94220,5580),(94221,5580),(94222,5580),(94223,5580),(94224,5581),(94225,5581),(94226,5581),(94227,5581),(94228,5582),(94229,5582),(94230,5582),(94231,5582),(94232,5582),(94233,5582),(94234,5583),(94235,5583),(94236,5583),(94237,5583),(94238,5583),(94239,5583),(94240,5584),(94241,5584),(94242,5584),(94243,5584),(94244,5584),(94245,5584),(94246,5585),(94247,5585),(94248,5585),(94249,5585),(94250,5585),(94251,5585),(94252,5586),(94253,5586),(94254,5586),(94255,5586),(94256,5586),(94257,5587),(94258,5587),(94259,5587),(94260,5587),(94261,5587),(94262,5588),(94263,5588),(94264,5588),(94265,5588),(94266,5588),(94267,5589),(94268,5589),(94269,5589),(94270,5589),(94271,5589),(94272,5590),(94273,5590),(94274,5590),(94275,5590),(94276,5590),(94277,5590),(94278,5591),(94279,5591),(94280,5591),(94281,5591),(94282,5591),(94283,5591),(94284,5592),(94285,5592),(94286,5592),(94287,5592),(94288,5592),(94289,5592),(94290,5593),(94291,5593),(94292,5593),(94293,5593),(94294,5593),(94295,5593),(94296,5594),(94297,5594),(94298,5594),(94299,5594),(94300,5594),(94301,5594),(94302,5595),(94303,5595),(94304,5595),(94305,5595),(94306,5595),(94307,5595),(94308,5596),(94309,5596),(94310,5596),(94311,5596),(94312,5596),(94313,5596),(94314,5597),(94315,5597),(94316,5597),(94317,5597),(94318,5597),(94319,5597),(94320,5598),(94321,5598),(94322,5598),(94323,5598),(94324,5598),(94325,5598),(94326,5599),(94327,5599),(94328,5599),(94329,5599),(94330,5599),(94331,5599),(94332,5600),(94333,5600),(94334,5600),(94335,5600),(94336,5600),(94337,5600),(94338,5601),(94339,5601),(94340,5601),(94341,5601),(94342,5601),(94343,5601),(94344,5602),(94345,5602),(94346,5602),(94347,5602),(94348,5602),(94349,5602),(94350,5603),(94351,5603),(94352,5603),(94353,5603),(94354,5603),(94355,5603),(94356,5604),(94357,5604),(94358,5604),(94359,5604),(94360,5604),(94361,5604),(94362,5605),(94363,5605),(94364,5605),(94365,5605),(94366,5605),(94367,5605),(94368,5606),(94369,5606),(94370,5606),(94371,5606),(94372,5606),(94373,5606),(94374,5607),(94375,5607),(94376,5607),(94377,5607),(94378,5607),(94379,5607),(94380,5608),(94381,5608),(94382,5608),(94383,5608),(94384,5608),(94385,5608),(94386,5609),(94387,5609),(94388,5609),(94389,5609),(94390,5609),(94391,5609),(94392,5610),(94393,5610),(94394,5610),(94395,5610),(94396,5610),(94397,5610),(94398,5611),(94399,5611),(94400,5611),(94401,5611),(94402,5611),(94403,5611),(94404,5612),(94405,5612),(94406,5612),(94407,5612),(94408,5612),(94409,5612),(94410,5613),(94411,5613),(94412,5613),(94413,5613),(94414,5613),(94415,5613),(94416,5614),(94417,5614),(94418,5614),(94419,5614),(94420,5614),(94421,5614),(94422,5615),(94423,5615),(94424,5615),(94425,5615),(94426,5615),(94427,5615),(94428,5616),(94429,5616),(94430,5616),(94431,5616),(94432,5616),(94433,5616),(94434,5617),(94435,5617),(94436,5617),(94437,5617),(94438,5617),(94439,5617),(94440,5618),(94441,5618),(94442,5618),(94443,5618),(94444,5618),(94445,5618),(94446,5619),(94447,5619),(94448,5619),(94449,5619),(94450,5619),(94451,5619),(94452,5620),(94453,5620),(94454,5620),(94455,5620),(94456,5620),(94457,5620),(94458,5621),(94459,5621),(94460,5621),(94461,5621),(94462,5621),(94463,5621),(94464,5622),(94465,5622),(94466,5622),(94467,5622),(94468,5622),(94469,5622),(94470,5623),(94471,5623),(94472,5623),(94473,5623),(94474,5623),(94475,5623),(94476,5624),(94477,5624),(94478,5624),(94479,5624),(94480,5624),(94481,5624),(94482,5625),(94483,5625),(94484,5625),(94485,5625),(94486,5625),(94487,5625),(94488,5626),(94489,5626),(94490,5626),(94491,5626),(94492,5626),(94493,5626),(94494,5627),(94495,5627),(94496,5627),(94497,5627),(94498,5627),(94499,5627),(94500,5628),(94501,5628),(94502,5628),(94503,5628),(94504,5628),(94505,5628),(94506,5629),(94507,5629),(94508,5629),(94509,5629),(94510,5629),(94511,5629),(94512,5630),(94513,5630),(94514,5630),(94515,5630),(94516,5630),(94517,5630),(94518,5631),(94519,5631),(94520,5631),(94521,5631),(94522,5631),(94523,5631),(94524,5632),(94525,5632),(94526,5632),(94527,5632),(94528,5632),(94529,5632),(94530,5633),(94531,5633),(94532,5633),(94533,5633),(94534,5633),(94535,5633),(94536,5634),(94537,5634),(94538,5634),(94539,5634),(94540,5634),(94541,5634),(94542,5635),(94543,5635),(94544,5635),(94545,5635),(94546,5635),(94547,5635),(94548,5636),(94549,5636),(94550,5636),(94551,5636),(94552,5636),(94553,5636),(94554,5637),(94555,5637),(94556,5637),(94557,5637),(94558,5637),(94559,5637),(94560,5638),(94561,5638),(94562,5638),(94563,5638),(94564,5638),(94565,5638),(94566,5639),(94567,5639),(94568,5639),(94569,5639),(94570,5639),(94571,5639),(94572,5640),(94573,5640),(94574,5640),(94575,5640),(94576,5640),(94577,5640),(94578,5641),(94579,5641),(94580,5641),(94581,5641),(94582,5641),(94583,5641),(94584,5642),(94585,5642),(94586,5642),(94587,5642),(94588,5642),(94589,5642),(94590,5643),(94591,5643),(94592,5643),(94593,5643),(94594,5643),(94595,5643),(94596,5644),(94597,5644),(94598,5644),(94599,5644),(94600,5644),(94601,5644),(94602,5645),(94603,5645),(94604,5645),(94605,5645),(94606,5645),(94607,5645),(94608,5646),(94609,5646),(94610,5646),(94611,5646),(94612,5646),(94613,5646),(94614,5647),(94615,5647),(94616,5647),(94617,5647),(94618,5647),(94619,5647),(94620,5648),(94621,5648),(94622,5648),(94623,5648),(94624,5648),(94625,5648),(94626,5649),(94627,5649),(94628,5649),(94629,5649),(94630,5649),(94631,5649),(94632,5650),(94633,5650),(94634,5650),(94635,5650),(94636,5650),(94637,5650),(94638,5651),(94639,5651),(94640,5651),(94641,5651),(94642,5651),(94643,5651),(94644,5652),(94645,5652),(94646,5652),(94647,5652),(94648,5652),(94649,5652),(94650,5653),(94651,5653),(94652,5653),(94653,5653),(94654,5653),(94655,5653),(94656,5654),(94657,5654),(94658,5654),(94659,5654),(94660,5654),(94661,5654),(94662,5655),(94663,5655),(94664,5655),(94665,5655),(94666,5655),(94667,5655),(94668,5656),(94669,5656),(94670,5656),(94671,5656),(94672,5656),(94673,5656),(94674,5657),(94675,5657),(94676,5657),(94677,5657),(94678,5657),(94679,5657),(94680,5658),(94681,5658),(94682,5658),(94683,5658),(94684,5658),(94685,5658),(94686,5659),(94687,5659),(94688,5659),(94689,5659),(94690,5659),(94691,5659),(94692,5560),(94693,5560),(94694,5561),(94695,5561),(94696,5562),(94697,5562),(94698,5563),(94699,5563),(94700,5564),(94701,5564),(94702,5565),(94703,5565),(94704,5566),(94705,5566),(94706,5567),(94707,5567),(94708,5568),(94709,5568),(94710,5569),(94711,5569),(94712,5570),(94713,5570),(94714,5571),(94715,5571),(94716,5571),(94717,5572),(94718,5572),(94719,5573),(94720,5573),(94721,5574),(94722,5574),(94723,5575),(94724,5575),(94725,5576),(94726,5576),(94727,5577),(94728,5578),(94729,5578),(94730,5579),(94731,5579),(94732,5580),(94733,5581),(94734,5582),(94735,5582),(94736,5583),(94737,5583),(94738,5584),(94739,5584),(94740,5585),(94741,5585),(94742,5586),(94743,5586),(94744,5587),(94745,5587),(94746,5588),(94747,5588),(94748,5589),(94749,5589),(94750,5590),(94751,5590),(94752,5591),(94753,5591),(94754,5591),(94755,5592),(94756,5592),(94757,5592),(94758,5593),(94759,5593),(94760,5593),(94761,5594),(94762,5594),(94763,5594),(94764,5595),(94765,5595),(94766,5595),(94767,5596),(94768,5596),(94769,5596),(94770,5597),(94771,5597),(94772,5597),(94773,5598),(94774,5598),(94775,5599),(94776,5599),(94777,5599),(94778,5600),(94779,5600),(94780,5600),(94781,5601),(94782,5601),(94783,5601),(94784,5602),(94785,5602),(94786,5602),(94787,5603),(94788,5603),(94789,5603),(94790,5604),(94791,5604),(94792,5604),(94793,5605),(94794,5605),(94795,5605),(94796,5606),(94797,5606),(94798,5606),(94799,5607),(94800,5607),(94801,5607),(94802,5608),(94803,5608),(94804,5608),(94805,5609),(94806,5609),(94807,5609),(94808,5610),(94809,5610),(94810,5610),(94811,5611),(94812,5611),(94813,5611),(94814,5612),(94815,5612),(94816,5612),(94817,5613),(94818,5613),(94819,5613),(94820,5614),(94821,5614),(94822,5614),(94823,5615),(94824,5615),(94825,5615),(94826,5616),(94827,5616),(94828,5617),(94829,5617),(94830,5618),(94831,5618),(94832,5619),(94833,5619),(94834,5620),(94835,5620),(94836,5620),(94837,5621),(94838,5621),(94839,5622),(94840,5622),(94841,5623),(94842,5623),(94843,5624),(94844,5624),(94845,5625),(94846,5625),(94847,5626),(94848,5626),(94849,5627),(94850,5627),(94851,5628),(94852,5628),(94853,5629),(94854,5629),(94855,5630),(94856,5630),(94857,5631),(94858,5631),(94859,5632),(94860,5632),(94861,5633),(94862,5633),(94863,5634),(94864,5634),(94865,5635),(94866,5635),(94867,5636),(94868,5636),(94869,5637),(94870,5637),(94871,5638),(94872,5638),(94873,5639),(94874,5639),(94875,5640),(94876,5640),(94877,5641),(94878,5641),(94879,5642),(94880,5642),(94881,5643),(94882,5643),(94883,5644),(94884,5644),(94885,5645),(94886,5645),(94887,5646),(94888,5646),(94889,5647),(94890,5647),(94891,5648),(94892,5648),(94893,5649),(94894,5649),(94895,5650),(94896,5650),(94897,5651),(94898,5651),(94899,5652),(94900,5652),(94901,5653),(94902,5653),(94903,5654),(94904,5654),(94905,5655),(94906,5655),(94907,5656),(94908,5656),(94909,5657),(94910,5657),(94911,5658),(94912,5658),(94913,5659),(94914,5659),(94915,5560),(94916,5560),(94917,5560),(94918,5561),(94919,5561),(94920,5561),(94921,5562),(94922,5562),(94923,5562),(94924,5563),(94925,5563),(94926,5563),(94927,5564),(94928,5564),(94929,5564),(94930,5565),(94931,5565),(94932,5565),(94933,5566),(94934,5566),(94935,5566),(94936,5567),(94937,5567),(94938,5567),(94939,5568),(94940,5568),(94941,5568),(94942,5569),(94943,5569),(94944,5569),(94945,5570),(94946,5570),(94947,5570),(94948,5571),(94949,5571),(94950,5571),(94951,5572),(94952,5572),(94953,5572),(94954,5573),(94955,5573),(94956,5573),(94957,5574),(94958,5574),(94959,5574),(94960,5575),(94961,5575),(94962,5575),(94963,5576),(94964,5576),(94965,5576),(94966,5577),(94967,5577),(94968,5577),(94969,5578),(94970,5578),(94971,5578),(94972,5579),(94973,5579),(94974,5579),(94975,5580),(94976,5580),(94977,5580),(94978,5581),(94979,5581),(94980,5581),(94981,5582),(94982,5582),(94983,5582),(94984,5583),(94985,5583),(94986,5583),(94987,5584),(94988,5584),(94989,5584),(94990,5585),(94991,5585),(94992,5585),(94993,5586),(94994,5586),(94995,5586),(94996,5587),(94997,5587),(94998,5587),(94999,5588),(95000,5588),(95001,5588),(95002,5589),(95003,5589),(95004,5589),(95005,5590),(95006,5590),(95007,5590),(95008,5591),(95009,5591),(95010,5591),(95011,5592),(95012,5592),(95013,5592),(95014,5592),(95015,5593),(95016,5593),(95017,5593),(95018,5594),(95019,5594),(95020,5594),(95021,5595),(95022,5595),(95023,5595),(95024,5596),(95025,5596),(95026,5596),(95027,5597),(95028,5597),(95029,5597),(95030,5598),(95031,5598),(95032,5598),(95033,5599),(95034,5599),(95035,5599),(95036,5600),(95037,5600),(95038,5600),(95039,5601),(95040,5601),(95041,5601),(95042,5602),(95043,5602),(95044,5602),(95045,5602),(95046,5603),(95047,5603),(95048,5603),(95049,5603),(95050,5604),(95051,5604),(95052,5604),(95053,5605),(95054,5605),(95055,5605),(95056,5605),(95057,5606),(95058,5606),(95059,5606),(95060,5607),(95061,5607),(95062,5607),(95063,5608),(95064,5608),(95065,5608),(95066,5608),(95067,5609),(95068,5609),(95069,5609),(95070,5609),(95071,5610),(95072,5610),(95073,5610),(95074,5610),(95075,5611),(95076,5611),(95077,5611),(95078,5611),(95079,5612),(95080,5612),(95081,5612),(95082,5612),(95083,5613),(95084,5613),(95085,5613),(95086,5613),(95087,5614),(95088,5614),(95089,5614),(95090,5614),(95091,5615),(95092,5615),(95093,5615),(95094,5616),(95095,5616),(95096,5616),(95097,5617),(95098,5617),(95099,5617),(95100,5618),(95101,5618),(95102,5618),(95103,5619),(95104,5619),(95105,5619),(95106,5620),(95107,5620),(95108,5620),(95109,5620),(95110,5621),(95111,5621),(95112,5621),(95113,5622),(95114,5622),(95115,5622),(95116,5623),(95117,5623),(95118,5623),(95119,5624),(95120,5624),(95121,5624),(95122,5625),(95123,5625),(95124,5625),(95125,5626),(95126,5626),(95127,5626),(95128,5627),(95129,5627),(95130,5627),(95131,5628),(95132,5628),(95133,5628),(95134,5629),(95135,5629),(95136,5629),(95137,5630),(95138,5630),(95139,5630),(95140,5631),(95141,5631),(95142,5631),(95143,5632),(95144,5632),(95145,5632),(95146,5633),(95147,5633),(95148,5633),(95149,5634),(95150,5634),(95151,5634),(95152,5635),(95153,5635),(95154,5635),(95155,5636),(95156,5636),(95157,5636),(95158,5637),(95159,5637),(95160,5637),(95161,5638),(95162,5638),(95163,5638),(95164,5639),(95165,5639),(95166,5639),(95167,5640),(95168,5640),(95169,5640),(95170,5641),(95171,5641),(95172,5641),(95173,5642),(95174,5642),(95175,5642),(95176,5643),(95177,5643),(95178,5643),(95179,5644),(95180,5644),(95181,5644),(95182,5645),(95183,5645),(95184,5645),(95185,5646),(95186,5646),(95187,5646),(95188,5647),(95189,5647),(95190,5647),(95191,5648),(95192,5648),(95193,5648),(95194,5649),(95195,5649),(95196,5649),(95197,5650),(95198,5650),(95199,5650),(95200,5651),(95201,5651),(95202,5651),(95203,5652),(95204,5652),(95205,5652),(95206,5653),(95207,5653),(95208,5653),(95209,5654),(95210,5654),(95211,5654),(95212,5655),(95213,5655),(95214,5655),(95215,5656),(95216,5656),(95217,5656),(95218,5657),(95219,5657),(95220,5657),(95221,5658),(95222,5658),(95223,5658),(95224,5659),(95225,5659),(95226,5659),(95227,5560),(95228,5560),(95229,5560),(95230,5560),(95231,5561),(95232,5561),(95233,5561),(95234,5561),(95235,5562),(95236,5562),(95237,5562),(95238,5562),(95239,5563),(95240,5563),(95241,5563),(95242,5563),(95243,5564),(95244,5564),(95245,5564),(95246,5564),(95247,5565),(95248,5565),(95249,5565),(95250,5565),(95251,5566),(95252,5566),(95253,5566),(95254,5566),(95255,5567),(95256,5567),(95257,5567),(95258,5567),(95259,5568),(95260,5568),(95261,5568),(95262,5568),(95263,5569),(95264,5569),(95265,5569),(95266,5569),(95267,5570),(95268,5570),(95269,5570),(95270,5570),(95271,5571),(95272,5571),(95273,5571),(95274,5571),(95275,5572),(95276,5572),(95277,5572),(95278,5572),(95279,5573),(95280,5573),(95281,5573),(95282,5573),(95283,5574),(95284,5574),(95285,5574),(95286,5574),(95287,5575),(95288,5575),(95289,5575),(95290,5575),(95291,5576),(95292,5576),(95293,5576),(95294,5576),(95295,5577),(95296,5577),(95297,5577),(95298,5577),(95299,5578),(95300,5578),(95301,5578),(95302,5578),(95303,5579),(95304,5579),(95305,5579),(95306,5579),(95307,5580),(95308,5580),(95309,5580),(95310,5580),(95311,5581),(95312,5581),(95313,5581),(95314,5581),(95315,5582),(95316,5582),(95317,5582),(95318,5582),(95319,5583),(95320,5583),(95321,5583),(95322,5583),(95323,5584),(95324,5584),(95325,5584),(95326,5584),(95327,5585),(95328,5585),(95329,5585),(95330,5585),(95331,5586),(95332,5586),(95333,5586),(95334,5586),(95335,5587),(95336,5587),(95337,5587),(95338,5587),(95339,5588),(95340,5588),(95341,5588),(95342,5588),(95343,5589),(95344,5589),(95345,5589),(95346,5589),(95347,5590),(95348,5590),(95349,5590),(95350,5590),(95351,5591),(95352,5591),(95353,5591),(95354,5591),(95355,5592),(95356,5592),(95357,5592),(95358,5592),(95359,5593),(95360,5593),(95361,5593),(95362,5593),(95363,5594),(95364,5594),(95365,5594),(95366,5594),(95367,5595),(95368,5595),(95369,5595),(95370,5595),(95371,5596),(95372,5596),(95373,5596),(95374,5596),(95375,5597),(95376,5597),(95377,5597),(95378,5597),(95379,5598),(95380,5598),(95381,5598),(95382,5598),(95383,5599),(95384,5599),(95385,5599),(95386,5599),(95387,5600),(95388,5600),(95389,5600),(95390,5600),(95391,5601),(95392,5601),(95393,5601),(95394,5601),(95395,5602),(95396,5602),(95397,5602),(95398,5602),(95399,5603),(95400,5603),(95401,5603),(95402,5603),(95403,5604),(95404,5604),(95405,5604),(95406,5604),(95407,5605),(95408,5605),(95409,5605),(95410,5605),(95411,5606),(95412,5606),(95413,5606),(95414,5606),(95415,5607),(95416,5607),(95417,5607),(95418,5607),(95419,5608),(95420,5608),(95421,5608),(95422,5608),(95423,5609),(95424,5609),(95425,5609),(95426,5609),(95427,5610),(95428,5610),(95429,5610),(95430,5610),(95431,5611),(95432,5611),(95433,5611),(95434,5611),(95435,5612),(95436,5612),(95437,5612),(95438,5612),(95439,5613),(95440,5613),(95441,5613),(95442,5613),(95443,5614),(95444,5614),(95445,5614),(95446,5614),(95447,5615),(95448,5615),(95449,5615),(95450,5615),(95451,5616),(95452,5616),(95453,5616),(95454,5616),(95455,5617),(95456,5617),(95457,5617),(95458,5617),(95459,5618),(95460,5618),(95461,5618),(95462,5618),(95463,5619),(95464,5619),(95465,5619),(95466,5619),(95467,5620),(95468,5620),(95469,5620),(95470,5620),(95471,5621),(95472,5621),(95473,5621),(95474,5621),(95475,5622),(95476,5622),(95477,5622),(95478,5622),(95479,5623),(95480,5623),(95481,5623),(95482,5623),(95483,5624),(95484,5624),(95485,5624),(95486,5624),(95487,5625),(95488,5625),(95489,5625),(95490,5625),(95491,5626),(95492,5626),(95493,5626),(95494,5626),(95495,5627),(95496,5627),(95497,5627),(95498,5627),(95499,5628),(95500,5628),(95501,5628),(95502,5628),(95503,5629),(95504,5629),(95505,5629),(95506,5629),(95507,5630),(95508,5630),(95509,5630),(95510,5630),(95511,5631),(95512,5631),(95513,5631),(95514,5631),(95515,5632),(95516,5632),(95517,5632),(95518,5632),(95519,5633),(95520,5633),(95521,5633),(95522,5633),(95523,5634),(95524,5634),(95525,5634),(95526,5634),(95527,5635),(95528,5635),(95529,5635),(95530,5635),(95531,5636),(95532,5636),(95533,5636),(95534,5636),(95535,5637),(95536,5637),(95537,5637),(95538,5637),(95539,5638),(95540,5638),(95541,5638),(95542,5638),(95543,5639),(95544,5639),(95545,5639),(95546,5639),(95547,5640),(95548,5640),(95549,5640),(95550,5640),(95551,5641),(95552,5641),(95553,5641),(95554,5641),(95555,5642),(95556,5642),(95557,5642),(95558,5642),(95559,5643),(95560,5643),(95561,5643),(95562,5643),(95563,5644),(95564,5644),(95565,5644),(95566,5644),(95567,5645),(95568,5645),(95569,5645),(95570,5645),(95571,5646),(95572,5646),(95573,5646),(95574,5646),(95575,5647),(95576,5647),(95577,5647),(95578,5647),(95579,5648),(95580,5648),(95581,5648),(95582,5648),(95583,5649),(95584,5649),(95585,5649),(95586,5649),(95587,5650),(95588,5650),(95589,5650),(95590,5650),(95591,5651),(95592,5651),(95593,5651),(95594,5651),(95595,5652),(95596,5652),(95597,5652),(95598,5652),(95599,5653),(95600,5653),(95601,5653),(95602,5653),(95603,5654),(95604,5654),(95605,5654),(95606,5654),(95607,5655),(95608,5655),(95609,5655),(95610,5655),(95611,5656),(95612,5656),(95613,5656),(95614,5656),(95615,5657),(95616,5657),(95617,5657),(95618,5657),(95619,5658),(95620,5658),(95621,5658),(95622,5658),(95623,5659),(95624,5659),(95625,5659),(95626,5659),(95627,5660),(95628,5661),(95629,5662),(95630,5663),(95631,5664),(95632,5665),(95633,5666),(95634,5667),(95635,5668),(95636,5669),(95637,5670),(95638,5671),(95639,5672),(95640,5673),(95641,5674),(95642,5675),(95643,5676),(95644,5677),(95645,5678),(95646,5679),(95647,5680),(95648,5681),(95649,5682),(95650,5683),(95651,5684),(95652,5685),(95653,5686),(95654,5687),(95655,5688),(95656,5689),(95657,5690),(95658,5691),(95659,5692),(95660,5693),(95661,5694),(95662,5695),(95663,5696),(95664,5697),(95665,5698),(95666,5699),(95667,5700),(95668,5701),(95669,5702),(95670,5703),(95671,5704),(95672,5705),(95673,5706),(95674,5707),(95675,5708),(95676,5709),(95677,5710),(95678,5711),(95679,5712),(95680,5713),(95681,5714),(95682,5715),(95683,5716),(95684,5717),(95685,5718),(95686,5719),(95687,5720),(95688,5721),(95689,5722),(95690,5723),(95691,5724),(95692,5725),(95693,5726),(95694,5727),(95695,5728),(95696,5729),(95697,5730),(95698,5731),(95699,5732),(95700,5733),(95701,5734),(95702,5735),(95703,5736),(95704,5737),(95705,5738),(95706,5739),(95707,5740),(95708,5741),(95709,5742),(95710,5743),(95711,5744),(95712,5745),(95713,5746),(95714,5747),(95715,5748),(95716,5749),(95717,5750),(95718,5751),(95719,5752),(95720,5660),(95721,5660),(95722,5660),(95723,5660),(95724,5660),(95725,5660),(95726,5661),(95727,5661),(95728,5661),(95729,5661),(95730,5661),(95731,5661),(95732,5662),(95733,5662),(95734,5662),(95735,5662),(95736,5662),(95737,5662),(95738,5663),(95739,5663),(95740,5663),(95741,5663),(95742,5663),(95743,5663),(95744,5664),(95745,5664),(95746,5664),(95747,5664),(95748,5664),(95749,5664),(95750,5665),(95751,5665),(95752,5665),(95753,5665),(95754,5665),(95755,5665),(95756,5666),(95757,5666),(95758,5666),(95759,5666),(95760,5666),(95761,5666),(95762,5667),(95763,5667),(95764,5667),(95765,5667),(95766,5667),(95767,5667),(95768,5668),(95769,5668),(95770,5668),(95771,5668),(95772,5668),(95773,5668),(95774,5669),(95775,5669),(95776,5669),(95777,5669),(95778,5669),(95779,5669),(95780,5670),(95781,5670),(95782,5670),(95783,5670),(95784,5670),(95785,5670),(95786,5671),(95787,5671),(95788,5671),(95789,5671),(95790,5671),(95791,5671),(95792,5672),(95793,5672),(95794,5672),(95795,5672),(95796,5672),(95797,5672),(95798,5673),(95799,5673),(95800,5673),(95801,5673),(95802,5673),(95803,5673),(95804,5674),(95805,5674),(95806,5674),(95807,5674),(95808,5674),(95809,5674),(95810,5675),(95811,5675),(95812,5675),(95813,5675),(95814,5675),(95815,5675),(95816,5676),(95817,5676),(95818,5676),(95819,5676),(95820,5676),(95821,5676),(95822,5677),(95823,5677),(95824,5677),(95825,5677),(95826,5677),(95827,5677),(95828,5678),(95829,5678),(95830,5678),(95831,5678),(95832,5678),(95833,5678),(95834,5679),(95835,5679),(95836,5679),(95837,5679),(95838,5679),(95839,5679),(95840,5680),(95841,5680),(95842,5680),(95843,5680),(95844,5680),(95845,5680),(95846,5681),(95847,5681),(95848,5681),(95849,5681),(95850,5681),(95851,5681),(95852,5682),(95853,5682),(95854,5682),(95855,5682),(95856,5682),(95857,5682),(95858,5683),(95859,5683),(95860,5683),(95861,5683),(95862,5683),(95863,5683),(95864,5684),(95865,5684),(95866,5684),(95867,5684),(95868,5684),(95869,5684),(95870,5685),(95871,5685),(95872,5685),(95873,5685),(95874,5685),(95875,5685),(95876,5686),(95877,5686),(95878,5686),(95879,5686),(95880,5686),(95881,5686),(95882,5687),(95883,5687),(95884,5687),(95885,5687),(95886,5687),(95887,5687),(95888,5688),(95889,5688),(95890,5688),(95891,5688),(95892,5688),(95893,5688),(95894,5689),(95895,5689),(95896,5689),(95897,5689),(95898,5689),(95899,5689),(95900,5690),(95901,5690),(95902,5690),(95903,5690),(95904,5690),(95905,5690),(95906,5691),(95907,5691),(95908,5691),(95909,5691),(95910,5691),(95911,5691),(95912,5692),(95913,5692),(95914,5692),(95915,5692),(95916,5692),(95917,5692),(95918,5693),(95919,5693),(95920,5693),(95921,5693),(95922,5693),(95923,5693),(95924,5694),(95925,5694),(95926,5694),(95927,5694),(95928,5694),(95929,5694),(95930,5695),(95931,5695),(95932,5695),(95933,5695),(95934,5695),(95935,5695),(95936,5696),(95937,5696),(95938,5696),(95939,5696),(95940,5696),(95941,5696),(95942,5697),(95943,5697),(95944,5697),(95945,5697),(95946,5697),(95947,5697),(95948,5698),(95949,5698),(95950,5698),(95951,5698),(95952,5698),(95953,5698),(95954,5699),(95955,5699),(95956,5699),(95957,5699),(95958,5699),(95959,5699),(95960,5700),(95961,5700),(95962,5700),(95963,5700),(95964,5700),(95965,5700),(95966,5701),(95967,5701),(95968,5701),(95969,5701),(95970,5701),(95971,5701),(95972,5702),(95973,5702),(95974,5702),(95975,5702),(95976,5702),(95977,5702),(95978,5703),(95979,5703),(95980,5703),(95981,5703),(95982,5703),(95983,5703),(95984,5704),(95985,5704),(95986,5704),(95987,5704),(95988,5704),(95989,5704),(95990,5705),(95991,5705),(95992,5705),(95993,5705),(95994,5705),(95995,5705),(95996,5706),(95997,5706),(95998,5706),(95999,5706),(96000,5706),(96001,5706),(96002,5707),(96003,5707),(96004,5707),(96005,5707),(96006,5707),(96007,5707),(96008,5708),(96009,5708),(96010,5708),(96011,5708),(96012,5708),(96013,5708),(96014,5709),(96015,5709),(96016,5709),(96017,5709),(96018,5709),(96019,5709),(96020,5710),(96021,5710),(96022,5710),(96023,5710),(96024,5710),(96025,5710),(96026,5711),(96027,5711),(96028,5711),(96029,5711),(96030,5711),(96031,5711),(96032,5712),(96033,5712),(96034,5712),(96035,5712),(96036,5712),(96037,5712),(96038,5713),(96039,5713),(96040,5713),(96041,5713),(96042,5713),(96043,5713),(96044,5714),(96045,5714),(96046,5714),(96047,5714),(96048,5714),(96049,5714),(96050,5715),(96051,5715),(96052,5715),(96053,5715),(96054,5715),(96055,5715),(96056,5716),(96057,5716),(96058,5716),(96059,5716),(96060,5716),(96061,5716),(96062,5717),(96063,5717),(96064,5717),(96065,5717),(96066,5717),(96067,5717),(96068,5718),(96069,5718),(96070,5718),(96071,5718),(96072,5718),(96073,5718),(96074,5719),(96075,5719),(96076,5719),(96077,5719),(96078,5719),(96079,5719),(96080,5720),(96081,5720),(96082,5720),(96083,5720),(96084,5720),(96085,5720),(96086,5721),(96087,5721),(96088,5721),(96089,5721),(96090,5721),(96091,5721),(96092,5722),(96093,5722),(96094,5722),(96095,5722),(96096,5722),(96097,5722),(96098,5723),(96099,5723),(96100,5723),(96101,5723),(96102,5723),(96103,5723),(96104,5724),(96105,5724),(96106,5724),(96107,5724),(96108,5724),(96109,5724),(96110,5725),(96111,5725),(96112,5725),(96113,5725),(96114,5725),(96115,5725),(96116,5726),(96117,5726),(96118,5726),(96119,5726),(96120,5726),(96121,5726),(96122,5727),(96123,5727),(96124,5727),(96125,5727),(96126,5727),(96127,5727),(96128,5728),(96129,5728),(96130,5728),(96131,5728),(96132,5728),(96133,5728),(96134,5729),(96135,5729),(96136,5729),(96137,5729),(96138,5729),(96139,5729),(96140,5730),(96141,5730),(96142,5730),(96143,5730),(96144,5730),(96145,5730),(96146,5731),(96147,5731),(96148,5731),(96149,5731),(96150,5731),(96151,5731),(96152,5732),(96153,5732),(96154,5732),(96155,5732),(96156,5732),(96157,5732),(96158,5733),(96159,5733),(96160,5733),(96161,5733),(96162,5733),(96163,5733),(96164,5734),(96165,5734),(96166,5734),(96167,5734),(96168,5734),(96169,5734),(96170,5735),(96171,5735),(96172,5735),(96173,5735),(96174,5735),(96175,5735),(96176,5736),(96177,5736),(96178,5736),(96179,5736),(96180,5736),(96181,5736),(96182,5737),(96183,5737),(96184,5737),(96185,5737),(96186,5737),(96187,5737),(96188,5738),(96189,5738),(96190,5738),(96191,5738),(96192,5738),(96193,5738),(96194,5739),(96195,5739),(96196,5739),(96197,5739),(96198,5739),(96199,5739),(96200,5740),(96201,5740),(96202,5740),(96203,5740),(96204,5740),(96205,5740),(96206,5741),(96207,5741),(96208,5741),(96209,5741),(96210,5741),(96211,5741),(96212,5742),(96213,5742),(96214,5742),(96215,5742),(96216,5742),(96217,5742),(96218,5743),(96219,5743),(96220,5743),(96221,5743),(96222,5743),(96223,5743),(96224,5744),(96225,5744),(96226,5744),(96227,5744),(96228,5744),(96229,5744),(96230,5745),(96231,5745),(96232,5745),(96233,5745),(96234,5745),(96235,5745),(96236,5746),(96237,5746),(96238,5746),(96239,5746),(96240,5746),(96241,5746),(96242,5747),(96243,5747),(96244,5747),(96245,5747),(96246,5747),(96247,5747),(96248,5748),(96249,5748),(96250,5748),(96251,5748),(96252,5748),(96253,5748),(96254,5749),(96255,5749),(96256,5749),(96257,5749),(96258,5749),(96259,5749),(96260,5750),(96261,5750),(96262,5750),(96263,5750),(96264,5751),(96265,5751),(96266,5751),(96267,5751),(96268,5751),(96269,5751),(96270,5752),(96271,5752),(96272,5752),(96273,5752),(96274,5752),(96275,5752),(96276,5660),(96277,5660),(96278,5661),(96279,5661),(96280,5662),(96281,5662),(96282,5663),(96283,5663),(96284,5664),(96285,5664),(96286,5665),(96287,5665),(96288,5666),(96289,5666),(96290,5667),(96291,5667),(96292,5668),(96293,5668),(96294,5669),(96295,5669),(96296,5670),(96297,5670),(96298,5671),(96299,5671),(96300,5672),(96301,5672),(96302,5673),(96303,5673),(96304,5674),(96305,5674),(96306,5675),(96307,5675),(96308,5676),(96309,5676),(96310,5677),(96311,5677),(96312,5678),(96313,5678),(96314,5679),(96315,5679),(96316,5680),(96317,5680),(96318,5681),(96319,5681),(96320,5682),(96321,5682),(96322,5682),(96323,5683),(96324,5683),(96325,5683),(96326,5684),(96327,5684),(96328,5684),(96329,5685),(96330,5685),(96331,5685),(96332,5686),(96333,5686),(96334,5686),(96335,5687),(96336,5687),(96337,5687),(96338,5688),(96339,5688),(96340,5688),(96341,5689),(96342,5689),(96343,5689),(96344,5690),(96345,5690),(96346,5690),(96347,5691),(96348,5691),(96349,5691),(96350,5692),(96351,5692),(96352,5692),(96353,5693),(96354,5693),(96355,5693),(96356,5694),(96357,5694),(96358,5694),(96359,5695),(96360,5695),(96361,5696),(96362,5696),(96363,5696),(96364,5697),(96365,5697),(96366,5697),(96367,5698),(96368,5698),(96369,5698),(96370,5699),(96371,5699),(96372,5699),(96373,5700),(96374,5700),(96375,5700),(96376,5701),(96377,5701),(96378,5701),(96379,5702),(96380,5702),(96381,5702),(96382,5703),(96383,5703),(96384,5703),(96385,5704),(96386,5704),(96387,5705),(96388,5705),(96389,5706),(96390,5706),(96391,5707),(96392,5707),(96393,5708),(96394,5708),(96395,5709),(96396,5709),(96397,5709),(96398,5710),(96399,5710),(96400,5710),(96401,5711),(96402,5711),(96403,5711),(96404,5712),(96405,5712),(96406,5712),(96407,5713),(96408,5713),(96409,5714),(96410,5714),(96411,5715),(96412,5715),(96413,5716),(96414,5716),(96415,5717),(96416,5717),(96417,5718),(96418,5718),(96419,5719),(96420,5719),(96421,5720),(96422,5720),(96423,5721),(96424,5721),(96425,5722),(96426,5722),(96427,5723),(96428,5723),(96429,5724),(96430,5724),(96431,5725),(96432,5725),(96433,5726),(96434,5726),(96435,5727),(96436,5727),(96437,5728),(96438,5728),(96439,5729),(96440,5729),(96441,5730),(96442,5730),(96443,5731),(96444,5731),(96445,5732),(96446,5732),(96447,5733),(96448,5733),(96449,5734),(96450,5734),(96451,5735),(96452,5735),(96453,5736),(96454,5736),(96455,5737),(96456,5737),(96457,5738),(96458,5738),(96459,5739),(96460,5739),(96461,5740),(96462,5740),(96463,5741),(96464,5741),(96465,5742),(96466,5742),(96467,5743),(96468,5743),(96469,5744),(96470,5744),(96471,5745),(96472,5745),(96473,5745),(96474,5746),(96475,5746),(96476,5746),(96477,5747),(96478,5747),(96479,5747),(96480,5748),(96481,5748),(96482,5748),(96483,5749),(96484,5749),(96485,5749),(96486,5750),(96487,5751),(96488,5751),(96489,5752),(96490,5752),(96491,5752),(96492,5660),(96493,5660),(96494,5660),(96495,5661),(96496,5661),(96497,5661),(96498,5662),(96499,5662),(96500,5662),(96501,5663),(96502,5663),(96503,5663),(96504,5664),(96505,5664),(96506,5664),(96507,5665),(96508,5665),(96509,5665),(96510,5666),(96511,5666),(96512,5666),(96513,5667),(96514,5667),(96515,5667),(96516,5668),(96517,5668),(96518,5668),(96519,5669),(96520,5669),(96521,5669),(96522,5670),(96523,5670),(96524,5670),(96525,5671),(96526,5671),(96527,5671),(96528,5672),(96529,5672),(96530,5672),(96531,5673),(96532,5673),(96533,5673),(96534,5674),(96535,5674),(96536,5674),(96537,5675),(96538,5675),(96539,5675),(96540,5676),(96541,5676),(96542,5676),(96543,5677),(96544,5677),(96545,5677),(96546,5678),(96547,5678),(96548,5678),(96549,5679),(96550,5679),(96551,5679),(96552,5680),(96553,5680),(96554,5680),(96555,5681),(96556,5681),(96557,5681),(96558,5682),(96559,5682),(96560,5682),(96561,5682),(96562,5683),(96563,5683),(96564,5683),(96565,5683),(96566,5684),(96567,5684),(96568,5684),(96569,5684),(96570,5685),(96571,5685),(96572,5685),(96573,5685),(96574,5686),(96575,5686),(96576,5686),(96577,5686),(96578,5687),(96579,5687),(96580,5687),(96581,5688),(96582,5688),(96583,5688),(96584,5688),(96585,5689),(96586,5689),(96587,5690),(96588,5690),(96589,5690),(96590,5691),(96591,5691),(96592,5691),(96593,5692),(96594,5692),(96595,5692),(96596,5693),(96597,5693),(96598,5693),(96599,5694),(96600,5694),(96601,5694),(96602,5695),(96603,5695),(96604,5695),(96605,5696),(96606,5696),(96607,5697),(96608,5697),(96609,5697),(96610,5698),(96611,5698),(96612,5698),(96613,5699),(96614,5699),(96615,5699),(96616,5700),(96617,5700),(96618,5700),(96619,5701),(96620,5701),(96621,5701),(96622,5702),(96623,5702),(96624,5702),(96625,5703),(96626,5703),(96627,5703),(96628,5704),(96629,5704),(96630,5704),(96631,5705),(96632,5705),(96633,5705),(96634,5706),(96635,5706),(96636,5706),(96637,5707),(96638,5707),(96639,5707),(96640,5708),(96641,5708),(96642,5708),(96643,5709),(96644,5709),(96645,5709),(96646,5709),(96647,5710),(96648,5710),(96649,5710),(96650,5711),(96651,5711),(96652,5711),(96653,5711),(96654,5712),(96655,5712),(96656,5712),(96657,5713),(96658,5713),(96659,5713),(96660,5714),(96661,5714),(96662,5714),(96663,5715),(96664,5715),(96665,5715),(96666,5716),(96667,5716),(96668,5716),(96669,5717),(96670,5717),(96671,5717),(96672,5718),(96673,5718),(96674,5718),(96675,5719),(96676,5719),(96677,5719),(96678,5720),(96679,5720),(96680,5720),(96681,5721),(96682,5721),(96683,5721),(96684,5722),(96685,5722),(96686,5722),(96687,5723),(96688,5723),(96689,5723),(96690,5724),(96691,5724),(96692,5724),(96693,5725),(96694,5725),(96695,5725),(96696,5726),(96697,5726),(96698,5726),(96699,5727),(96700,5727),(96701,5727),(96702,5728),(96703,5728),(96704,5728),(96705,5729),(96706,5729),(96707,5729),(96708,5730),(96709,5730),(96710,5730),(96711,5731),(96712,5731),(96713,5731),(96714,5732),(96715,5732),(96716,5732),(96717,5733),(96718,5733),(96719,5733),(96720,5734),(96721,5734),(96722,5734),(96723,5735),(96724,5735),(96725,5735),(96726,5736),(96727,5736),(96728,5736),(96729,5737),(96730,5737),(96731,5737),(96732,5738),(96733,5738),(96734,5738),(96735,5739),(96736,5739),(96737,5739),(96738,5740),(96739,5740),(96740,5740),(96741,5741),(96742,5741),(96743,5741),(96744,5742),(96745,5742),(96746,5742),(96747,5743),(96748,5743),(96749,5743),(96750,5744),(96751,5744),(96752,5744),(96753,5745),(96754,5745),(96755,5745),(96756,5745),(96757,5746),(96758,5746),(96759,5746),(96760,5746),(96761,5747),(96762,5747),(96763,5747),(96764,5747),(96765,5748),(96766,5748),(96767,5748),(96768,5749),(96769,5749),(96770,5749),(96771,5749),(96772,5750),(96773,5750),(96774,5750),(96775,5751),(96776,5751),(96777,5751),(96778,5752),(96779,5752),(96780,5660),(96781,5660),(96782,5660),(96783,5660),(96784,5661),(96785,5661),(96786,5661),(96787,5661),(96788,5662),(96789,5662),(96790,5662),(96791,5662),(96792,5663),(96793,5663),(96794,5663),(96795,5663),(96796,5664),(96797,5664),(96798,5664),(96799,5664),(96800,5665),(96801,5665),(96802,5665),(96803,5665),(96804,5666),(96805,5666),(96806,5666),(96807,5666),(96808,5667),(96809,5667),(96810,5667),(96811,5667),(96812,5668),(96813,5668),(96814,5668),(96815,5668),(96816,5669),(96817,5669),(96818,5669),(96819,5669),(96820,5670),(96821,5670),(96822,5670),(96823,5670),(96824,5671),(96825,5671),(96826,5671),(96827,5671),(96828,5672),(96829,5672),(96830,5672),(96831,5672),(96832,5673),(96833,5673),(96834,5673),(96835,5673),(96836,5674),(96837,5674),(96838,5674),(96839,5674),(96840,5675),(96841,5675),(96842,5675),(96843,5675),(96844,5676),(96845,5676),(96846,5676),(96847,5676),(96848,5677),(96849,5677),(96850,5677),(96851,5677),(96852,5678),(96853,5678),(96854,5678),(96855,5678),(96856,5679),(96857,5679),(96858,5679),(96859,5679),(96860,5680),(96861,5680),(96862,5680),(96863,5680),(96864,5681),(96865,5681),(96866,5681),(96867,5681),(96868,5682),(96869,5682),(96870,5682),(96871,5682),(96872,5683),(96873,5683),(96874,5683),(96875,5683),(96876,5684),(96877,5684),(96878,5684),(96879,5684),(96880,5685),(96881,5685),(96882,5685),(96883,5685),(96884,5686),(96885,5686),(96886,5686),(96887,5686),(96888,5687),(96889,5687),(96890,5687),(96891,5687),(96892,5688),(96893,5688),(96894,5688),(96895,5688),(96896,5689),(96897,5689),(96898,5689),(96899,5689),(96900,5690),(96901,5690),(96902,5690),(96903,5690),(96904,5691),(96905,5691),(96906,5691),(96907,5691),(96908,5692),(96909,5692),(96910,5692),(96911,5692),(96912,5693),(96913,5693),(96914,5693),(96915,5693),(96916,5694),(96917,5694),(96918,5694),(96919,5694),(96920,5695),(96921,5695),(96922,5695),(96923,5695),(96924,5696),(96925,5696),(96926,5696),(96927,5696),(96928,5697),(96929,5697),(96930,5697),(96931,5697),(96932,5698),(96933,5698),(96934,5698),(96935,5698),(96936,5699),(96937,5699),(96938,5699),(96939,5699),(96940,5700),(96941,5700),(96942,5700),(96943,5700),(96944,5701),(96945,5701),(96946,5701),(96947,5701),(96948,5702),(96949,5702),(96950,5702),(96951,5702),(96952,5703),(96953,5703),(96954,5703),(96955,5703),(96956,5704),(96957,5704),(96958,5704),(96959,5704),(96960,5705),(96961,5705),(96962,5705),(96963,5705),(96964,5706),(96965,5706),(96966,5706),(96967,5706),(96968,5707),(96969,5707),(96970,5707),(96971,5707),(96972,5708),(96973,5708),(96974,5708),(96975,5708),(96976,5709),(96977,5709),(96978,5709),(96979,5709),(96980,5710),(96981,5710),(96982,5710),(96983,5710),(96984,5711),(96985,5711),(96986,5711),(96987,5711),(96988,5712),(96989,5712),(96990,5712),(96991,5712),(96992,5713),(96993,5713),(96994,5713),(96995,5713),(96996,5714),(96997,5714),(96998,5714),(96999,5714),(97000,5715),(97001,5715),(97002,5715),(97003,5715),(97004,5716),(97005,5716),(97006,5716),(97007,5716),(97008,5717),(97009,5717),(97010,5717),(97011,5717),(97012,5718),(97013,5718),(97014,5718),(97015,5718),(97016,5719),(97017,5719),(97018,5719),(97019,5719),(97020,5720),(97021,5720),(97022,5720),(97023,5720),(97024,5721),(97025,5721),(97026,5721),(97027,5721),(97028,5722),(97029,5722),(97030,5722),(97031,5722),(97032,5723),(97033,5723),(97034,5723),(97035,5723),(97036,5724),(97037,5724),(97038,5724),(97039,5724),(97040,5725),(97041,5725),(97042,5725),(97043,5725),(97044,5726),(97045,5726),(97046,5726),(97047,5726),(97048,5727),(97049,5727),(97050,5727),(97051,5727),(97052,5728),(97053,5728),(97054,5728),(97055,5728),(97056,5729),(97057,5729),(97058,5729),(97059,5729),(97060,5730),(97061,5730),(97062,5730),(97063,5730),(97064,5731),(97065,5731),(97066,5731),(97067,5731),(97068,5732),(97069,5732),(97070,5732),(97071,5732),(97072,5733),(97073,5733),(97074,5733),(97075,5733),(97076,5734),(97077,5734),(97078,5734),(97079,5734),(97080,5735),(97081,5735),(97082,5735),(97083,5735),(97084,5736),(97085,5736),(97086,5736),(97087,5736),(97088,5737),(97089,5737),(97090,5737),(97091,5737),(97092,5738),(97093,5738),(97094,5738),(97095,5738),(97096,5739),(97097,5739),(97098,5739),(97099,5739),(97100,5740),(97101,5740),(97102,5740),(97103,5740),(97104,5741),(97105,5741),(97106,5741),(97107,5741),(97108,5742),(97109,5742),(97110,5742),(97111,5742),(97112,5743),(97113,5743),(97114,5743),(97115,5743),(97116,5744),(97117,5744),(97118,5744),(97119,5744),(97120,5745),(97121,5745),(97122,5745),(97123,5745),(97124,5746),(97125,5746),(97126,5746),(97127,5746),(97128,5747),(97129,5747),(97130,5747),(97131,5747),(97132,5748),(97133,5748),(97134,5748),(97135,5748),(97136,5749),(97137,5749),(97138,5749),(97139,5749),(97140,5750),(97141,5750),(97142,5750),(97143,5750),(97144,5751),(97145,5751),(97146,5751),(97147,5751),(97148,5752),(97149,5752),(97150,5752),(97151,5752),(97152,1475),(97153,1476),(97154,1497),(97155,1498),(97156,1501),(97157,1503),(97158,1504),(97159,1506),(97160,1507),(97161,1508),(97162,1509),(97163,1510),(97164,1511),(97165,1512),(97166,1513),(97167,1514),(97168,1515),(97169,1545),(97170,1588),(97171,1589),(97172,1590),(97173,1591),(97174,1592),(97175,1593),(97176,1594),(97177,1595),(97178,1596),(97179,1597),(97180,1598),(97181,1599),(97182,1600),(97183,1601),(97184,1602),(97185,1603),(97186,1604),(97187,1605),(97188,1606),(97189,1607),(97190,1608),(97191,1609),(97192,1610),(97193,1613),(97194,1615),(97195,1618),(97196,1619),(97197,1620),(97198,1621),(97199,1622),(97200,1623),(97201,1624),(97202,1625),(97203,1626),(97204,1627),(97205,1628),(97206,1654),(97207,1657),(97208,1715),(97209,1717),(97210,1718),(97211,1719),(97212,1720),(97213,1721),(97214,1722),(97215,1723),(97216,1724),(97217,1725),(97218,1727),(97219,1728),(97220,1729),(97221,1732),(97222,1733),(97223,1734),(97224,1735),(97225,1766),(97226,1767),(97227,1768),(97228,1770),(97229,1771),(97230,1774),(97231,1775),(97232,1784),(97233,1785),(97234,1797),(97235,1812),(97236,2289),(97237,4881),(97238,4889),(97239,5363),(97240,5366),(97241,5623),(97242,5629),(97243,5636),(97244,5642),(97245,5651),(97246,5662),(97247,5668),(97248,1497),(97249,1503),(97250,1504),(97251,1507),(97252,1508),(97253,1510),(97254,1512),(97255,1592),(97256,1595),(97257,1600),(97258,1601),(97259,1602),(97260,1603),(97261,1605),(97262,1606),(97263,1608),(97264,1609),(97265,1622),(97266,1624),(97267,1625),(97268,1626),(97269,1627),(97270,1628),(97271,1717),(97272,1720),(97273,1723),(97274,1724),(97275,1725),(97276,1727),(97277,1728),(97278,1729),(97279,1732),(97280,1797),(97281,1498),(97282,1503),(97283,1513),(97284,1588),(97285,1589),(97286,1590),(97287,1604),(97288,1613),(97289,1615),(97290,1619),(97291,1715),(97292,1718),(97293,1721),(97294,1723),(97295,1724),(97296,1733),(97297,1734),(97298,1770),(97299,1771),(97300,1774),(97301,1775),(97302,1784),(97303,1785),(97304,4889),(97305,1501),(97306,1506),(97307,1509),(97308,1511),(97309,1514),(97310,1607),(97311,1615),(97312,1618),(97313,1620),(97314,1654),(97315,1657),(97316,1719),(97317,1722),(97318,1735),(97319,1766),(97320,1767),(97321,1768),(97322,1812),(97323,4881),(97324,1160),(97325,1160),(97326,1160),(97327,1160),(97328,1160),(97329,1160),(97330,1160),(97331,1160),(97332,1160),(97333,1160),(97334,1160),(97335,1160),(97336,1161),(97337,1161),(97338,1161),(97339,1161),(97340,1161),(97341,1161),(97342,1161),(97343,1161),(97344,1161),(97345,1161),(97346,1161),(97347,1161),(97348,1161),(97349,1159),(97350,1162),(97351,1162),(97352,1162),(97353,1162),(97354,1162),(97355,1162),(97356,1162),(97357,1162),(97358,1162),(97359,1164),(97360,1165),(97361,1164),(97362,1165),(97363,1119),(97364,1119),(97365,1119),(97366,1119),(97367,1119),(97368,1119),(97369,4711),(97370,4713),(97371,5738),(97372,5752),(97373,1162),(97374,1163),(97375,1164),(97376,1165),(97377,5752),(97378,5752),(97379,5752),(97380,5752),(97381,5752),(97382,5752),(97383,5752),(97384,5752),(97385,5752),(97386,5752),(97387,5752),(97388,5752),(97389,5738),(97390,5738),(97391,5738),(97392,5738),(97393,5738),(97394,5738),(97395,5738),(97396,5738),(97397,5738),(97398,5738),(97399,5738),(97400,5738),(97401,5738),(97402,4713),(97403,4713),(97404,4713),(97405,4713),(97406,4713),(97407,4713),(97408,4713),(97409,4713),(97410,4713),(97411,4713),(97412,4713),(97413,4875),(97414,4876),(97415,4891),(97416,4892),(97417,4893),(97418,4894),(97419,1160),(97420,1161),(97421,1162),(97422,1163),(97423,1164),(97424,1165),(97425,4711),(97426,4713),(97427,5738),(97428,5752),(97429,5191),(97430,5192),(97431,5193),(97432,5194),(97433,5197),(97434,1160),(97435,1161),(97436,5190),(97437,5190),(97438,4713),(97439,5197),(97440,5197),(97441,5197),(97442,5197),(97443,5197),(97444,5197),(97445,5197),(97446,5197),(97447,5197),(97448,5197),(97449,5197),(97450,5194),(97451,5194),(97452,5194),(97453,5194),(97454,5194),(97455,5194),(97456,5194),(97457,5194),(97458,5194),(97459,5194),(97460,5194),(97461,5193),(97462,5193),(97463,5193),(97464,5193),(97465,5193),(97466,5193),(97467,5193),(97468,5193),(97469,5193),(97470,5193),(97471,5193),(97472,5192),(97473,5192),(97474,5192),(97475,5192),(97476,5192),(97477,5192),(97478,5192),(97479,5192),(97480,5192),(97481,5192),(97482,5192),(97483,5191),(97484,5191),(97485,5191),(97486,5191),(97487,5191),(97488,5191),(97489,5191),(97490,5191),(97491,5191),(97492,5191),(97493,5191),(97494,4713),(97495,5190),(97496,5190),(97497,5190),(97498,5190),(97499,5190),(97500,5190),(97501,5190),(97502,5190),(97503,5190),(97504,5190),(97505,5190),(97506,5190),(97507,5190),(97508,4875),(97509,4875),(97510,4875),(97511,4876),(97512,4876),(97513,4876),(97514,4876),(97515,4876),(97516,4876),(97517,4876),(97518,4876),(97519,4876),(97520,4876),(97521,4876),(97522,4876),(97523,4876),(97524,4891),(97525,4891),(97526,4891),(97527,4891),(97528,4892),(97529,4892),(97530,4892),(97531,4893),(97532,4893),(97533,4893),(97534,4893),(97535,4893),(97536,4893),(97537,4893),(97538,4893),(97539,4893),(97540,4893),(97541,4893),(97542,4894),(97543,4894),(97544,4894),(97545,4894),(97546,4894),(97547,4894),(97548,4894),(97549,4894),(97550,4894),(97551,4894),(97552,4894),(97553,4894),(97554,4892),(97555,4892),(97556,4892),(97557,4892),(97558,4892),(97559,4892),(97560,4892),(97561,4892),(97562,4875),(97563,4875),(97564,4875),(97565,4875),(97566,4875),(97567,4875),(97568,4875),(97569,4875),(97570,4892),(97571,4892),(97572,4892),(97573,4892),(97574,4892),(97575,4892),(97576,4892),(97577,4892),(97578,4891),(97579,4891),(97580,4891),(97581,4891),(97582,4891),(97583,4891),(97584,4891),(97585,4891),(97586,4891),(97587,4891),(97588,1162),(97589,1162),(97590,1162),(97591,1165),(97592,1165),(97593,1165),(97594,2163),(97595,2163),(97596,2163),(97597,2163),(97598,2163),(97599,2163),(97600,2163),(97601,2163),(97602,2163),(97603,2176),(97604,2176),(97605,2176),(97606,2176),(97607,2176),(97608,2176),(97609,2176),(97610,2176),(97611,2176),(97612,2176),(97613,2176),(97614,1164),(97615,1164),(97616,1164),(97617,4894),(97618,4894),(97619,4894),(97620,4894),(97621,2163),(97622,1),(97623,1),(97624,1),(97625,1),(97626,1),(97627,1),(97628,1),(97629,1),(97630,1),(97631,1),(97632,1),(97633,1),(97634,1),(97635,1),(97636,1),(97637,1),(97638,1),(97639,1),(97640,1),(97641,1),(97642,1),(97643,1),(97644,1),(97645,1),(97646,1),(97647,1),(97648,1),(97649,1),(97650,1),(97651,1),(97652,42),(97653,141),(97654,143),(97655,163),(97656,165),(97657,145),(97658,148),(97659,180),(97660,186),(97661,1509),(97662,1775),(97663,1785),(97664,2375),(97665,2390),(97666,176),(97667,177),(97668,178),(97669,179),(97670,183),(97671,184),(97672,185),(97673,187),(97674,162),(97675,181),(97676,188),(97677,189),(97678,190),(97679,191),(97680,201),(97681,203),(97682,206),(97683,207),(97684,208),(97685,209),(97686,210),(97687,192),(97688,193),(97689,194),(97690,196),(97691,1480),(97692,1483),(97693,1486),(97694,1487),(97695,1495),(97696,1502),(97697,1611),(97698,1705),(97699,1707),(97700,1769),(97701,1505),(97702,1616),(97703,1617),(97704,1655),(97705,1656),(97706,1706),(97707,1742),(97708,1776),(97709,1539),(97710,1540),(97711,1541),(97712,1548),(97713,1549),(97714,1560),(97715,1561),(97716,1741),(97717,1764),(97718,1765),(97719,1783),(97720,1477),(97721,1537),(97722,1538),(97723,1544),(97724,1546),(97725,1547),(97726,1550),(97727,1551),(97728,1552),(97729,1554),(97730,1555),(97731,1556),(97732,1496),(97733,1553),(97734,1612),(97735,1614),(97736,1777),(97737,1473),(97738,1474),(97739,1475),(97740,1476),(97741,1477),(97742,1500),(97743,1537),(97744,1538),(97745,1539),(97746,1540),(97747,1541),(97748,1542),(97749,1543),(97750,1544),(97751,1545),(97752,1561),(97753,1591),(97754,1593),(97755,1594),(97756,1596),(97757,1597),(97758,1610),(97759,1598),(97760,1599),(97761,1621),(97762,1623),(97763,4538),(97764,1485),(97765,1611),(97766,1707),(97767,1769),(97768,1486),(97769,1487),(97770,1495),(97771,1505),(97772,1517),(97773,1776),(97774,1546),(97775,1553),(97776,1554),(97777,1555),(97778,1556),(97779,1612),(97780,1655),(97781,1656),(97782,1764),(97783,1777),(97784,1584),(97785,1585),(97786,1586),(97787,1730),(97788,1731),(97789,1796),(97790,1478),(97791,1481),(97792,1482),(97793,1484),(97794,1516),(97795,1705),(97796,5753),(97797,5753),(97798,5753),(97799,5753),(97800,5753),(97801,5753),(97802,5753),(97803,5753),(97804,5753),(97805,5753),(97806,5753),(97807,5753),(97808,5753),(97809,5753),(97810,5753),(97811,5753),(97812,5753),(97813,5753),(97814,5753),(97815,5754),(97816,5754),(97817,5754),(97818,5754),(97819,5754),(97820,5754),(97821,5754),(97822,5754),(97823,5754),(97824,5754),(97825,5754),(97826,5754),(97827,5754),(97828,5754),(97829,5754),(97830,5754),(97831,5754),(97832,5754),(97833,5754),(97834,5754),(97835,5755),(97836,5755),(97837,5755),(97838,5755),(97839,5755),(97840,5755),(97841,5755),(97842,5755),(97843,5755),(97844,5755),(97845,5755),(97846,5755),(97847,5755),(97848,5755),(97849,5755),(97850,5755),(97851,5755),(97852,5755),(97853,5755),(97854,5755),(97855,5756),(97856,5756),(97857,5756),(97858,5756),(97859,5756),(97860,5756),(97861,5756),(97862,5756),(97863,5756),(97864,5756),(97865,5756),(97866,5756),(97867,5756),(97868,5756),(97869,5756),(97870,5756),(97871,5756),(97872,5756),(97873,5756),(97874,5756),(97875,5753),(97876,5753),(97877,5753),(97878,5753),(97879,5754),(97880,5755),(97881,5756),(97882,1479),(97883,1480),(97884,1483),(97885,1502),(97886,1515),(97887,1616),(97888,1617),(97889,1548),(97890,1549),(97891,1551),(97892,1552),(97893,1560),(97894,1706),(97895,1741),(97896,1765),(97897,1783),(97898,1496),(97899,1547),(97900,1550),(97901,1614),(97902,1716),(97903,1726),(97904,1736),(97905,5278),(97906,5279),(97907,5280),(97908,5281),(97909,5295),(97910,5470),(97911,5473),(97912,5538),(97913,5539),(97914,5549),(97915,5550),(97916,5607),(97917,5701),(97918,5353),(97919,5469),(97920,5687),(97921,5712),(97922,5748),(97923,1739),(97924,1772),(97925,5310),(97926,5311),(97927,5312),(97928,5315),(97929,5318),(97930,5321),(97931,5322),(97932,5309),(97933,5313),(97934,5314),(97935,5316),(97936,5317),(97937,5319),(97938,1140),(97939,5689),(97940,5696),(97941,1154),(97942,4530),(97943,4535),(97944,4536),(97945,5256),(97946,5257),(97947,5284),(97948,5320),(97949,4622),(97950,4623),(97951,4624),(97952,4853),(97953,4854),(97954,4855),(97955,4881),(97956,4889),(97957,5282),(97958,5283),(97959,4526),(97960,4527),(97961,4531),(97962,4533),(97963,4534),(97964,4877),(97965,4878),(97966,4879),(97967,4886),(97968,4887),(97969,4888),(97970,5259),(97971,5260),(97972,5261),(97973,5262),(97974,5263),(97975,4882),(97976,4883),(97977,5264),(97978,5265),(97979,5266),(97980,5267),(97981,5268),(97982,5269),(97983,5270),(97984,1151),(97985,1152),(97986,1153),(97987,1155),(97988,1156),(97989,4890),(97990,4897),(97991,5171),(97992,5258),(97993,5435),(97994,5436),(97995,5437),(97996,5438),(97997,5439),(97998,5440),(97999,5441),(98000,5443),(98001,5444),(98002,5285),(98003,5296),(98004,5297),(98005,5338),(98006,5339),(98007,5340),(98008,5431),(98009,5442),(98010,5341),(98011,5342),(98012,5345),(98013,5346),(98014,5347),(98015,5348),(98016,5349),(98017,5350),(98018,5535),(98019,5674),(98020,5675),(98021,5676),(98022,5677),(98023,5679),(98024,5369),(98025,5402),(98026,5531),(98027,5532),(98028,5537),(98029,5615),(98030,5752),(98031,5403),(98032,5412),(98033,5423),(98034,5445),(98035,5446),(98036,5447),(98037,5448),(98038,5450),(98039,5546),(98040,5547),(98041,5606),(98042,5690),(98043,5288),(98044,5290),(98045,5292),(98046,5293),(98047,5680),(98048,5681),(98049,5697),(98050,5698),(98051,5710),(98052,5294),(98053,5411),(98054,5611),(98055,5614),(98056,5620),(98057,5683),(98058,5709),(98059,5747),(98060,5749),(98061,5471),(98062,5472),(98063,5533),(98064,5534),(98065,5535),(98066,5609),(98067,5682),(98068,5685),(98069,5745),(98070,5746),(98071,5674),(98072,5675),(98073,5676),(98074,5677),(98075,5678),(98076,5679),(98077,5369),(98078,5402),(98079,5531),(98080,5532),(98081,5537),(98082,5752),(98083,5277),(98084,5415),(98085,5416),(98086,5417),(98087,5547),(98088,5567),(98089,5680),(98090,5681),(98091,5691),(98092,5699),(98093,5275),(98094,5276),(98095,5542),(98096,5543),(98097,5608),(98098,5610),(98099,5612),(98100,5684),(98101,5686),(98102,5338),(98103,5339),(98104,5340),(98105,5341),(98106,5342),(98107,5410),(98108,5544),(98109,5545),(98110,5688),(98111,5345),(98112,5346),(98113,5347),(98114,5348),(98115,5349),(98116,5350),(98117,5369),(98118,5531),(98119,5532),(98120,5535),(98121,5738),(98122,5417),(98123,5567),(98124,1615),(98125,5563),(98126,5688),(98127,5608),(98128,5291),(98129,5558),(98130,5564),(98131,5566),(98132,5605),(98133,5608),(98134,5612),(98135,5684),(98136,5686),(98137,5688),(98138,5691),(98139,5290),(98140,5345),(98141,5346),(98142,5347),(98143,5348),(98144,5349),(98145,5350),(98146,5594),(98147,5599),(98148,5600),(98149,5601),(98150,5604),(98151,5693),(98152,5285),(98153,5413),(98154,5414),(98155,5418),(98156,5419),(98157,5548),(98158,5593),(98159,5692),(98160,5694),(98161,5700),(98162,5286),(98163,5296),(98164,5297),(98165,5298),(98166,5541),(98167,5711),(98168,5443),(98169,5289),(98170,5302),(98171,5442),(98172,5591),(98173,5595),(98174,5602),(98175,5603),(98176,5613),(98177,5618),(98178,5733),(98179,5431),(98180,5435),(98181,5436),(98182,5437),(98183,5438),(98184,5439),(98185,5440),(98186,5441),(98187,5444),(98188,5408),(98189,5420),(98190,5553),(98191,5554),(98192,5555),(98193,5556),(98194,5557),(98195,5599),(98196,5600),(98197,5601),(98198,5615),(98199,5618),(98200,5540),(98201,5553),(98202,5554),(98203,5555),(98204,5556),(98205,5557),(98206,5571),(98207,5592),(98208,5596),(98209,5597),(98210,1148),(98211,5452),(98212,5659),(98213,5661),(98214,2540),(98215,2541),(98216,2542),(98217,5357),(98218,5630),(98219,5631),(98220,5632),(98221,5633),(98222,5634),(98223,1162),(98224,1162),(98225,1162),(98226,4894),(98227,4894),(98228,4894),(98229,1164),(98230,1164),(98231,1164),(98232,2176),(98233,2176),(98234,2176),(98235,224),(98236,225),(98237,226),(98238,227),(98239,228),(98240,235),(98241,236),(98242,237),(98243,238),(98244,239),(98245,163),(98246,165),(98247,167),(98248,168),(98249,229),(98250,230),(98251,231),(98252,232),(98253,233),(98254,234),(98255,7),(98256,39),(98257,40),(98258,41),(98259,42),(98260,43),(98261,44),(98262,141),(98263,143),(98264,144),(98265,146),(98266,150),(98267,151),(98268,8),(98269,9),(98270,10),(98271,11),(98272,12),(98273,13),(98274,14),(98275,23),(98276,24),(98277,25),(98278,27),(98279,28),(98280,29),(98281,30),(98282,32),(98283,37),(98284,38),(98285,45),(98286,46),(98287,47),(98288,53),(98289,66),(98290,70),(98291,78),(98292,79),(98293,80),(98294,81),(98295,54),(98296,55),(98297,61),(98298,62),(98299,82),(98300,83),(98301,84),(98302,85),(98303,86),(98304,87),(98305,88),(98306,90),(98307,56),(98308,57),(98309,59),(98310,60),(98311,91),(98312,92),(98313,58),(98314,93),(98315,95),(98316,122),(98317,133),(98318,134),(98319,135),(98320,136),(98321,137),(98322,16),(98323,94),(98324,145),(98325,147),(98326,148),(98327,153),(98328,164),(98329,166),(98330,172),(98331,256),(98332,257),(98333,100),(98334,104),(98335,138),(98336,154),(98337,155),(98338,244),(98339,251),(98340,139),(98341,160),(98342,161),(98343,169),(98344,171),(98345,173),(98346,175),(98347,221),(98348,222),(98349,223),(98350,276),(98351,277),(98352,278),(98353,279),(98354,240),(98355,241),(98356,242),(98357,243),(98358,254),(98359,255),(98360,258),(98361,259),(98362,260),(98363,261),(98364,280),(98365,106),(98366,162),(98367,262),(98368,263),(98369,264),(98370,265),(98371,110),(98372,111),(98373,112),(98374,114),(98375,115),(98376,116),(98377,157),(98378,159),(98379,188),(98380,189),(98381,48),(98382,49),(98383,50),(98384,51),(98385,52),(98386,106),(98387,123),(98388,124),(98389,125),(98390,126),(98391,140),(98392,156),(98393,158),(98394,255),(98395,245),(98396,268),(98397,269),(98398,270),(98399,271),(98400,272),(98401,273),(98402,274),(98403,275),(98404,4524),(98405,176),(98406,177),(98407,178),(98408,180),(98409,183),(98410,184),(98411,185),(98412,186),(98413,179),(98414,181),(98415,187),(98416,188),(98417,189),(98418,206),(98419,207),(98420,208),(98421,162),(98422,190),(98423,193),(98424,194),(98425,195),(98426,196),(98427,197),(98428,202),(98429,209),(98430,210),(98431,139),(98432,169),(98433,173),(98434,175),(98435,221),(98436,222),(98437,223),(98438,5465),(98439,5466),(98440,5467),(98441,5525),(98442,5551),(98443,5552),(98444,5561),(98445,5562),(98446,5565),(98447,5572),(98448,5573),(98449,5574),(98450,5575),(98451,5576),(98452,5578),(98453,5579),(98454,5582),(98455,5583),(98456,5584),(98457,5456),(98458,5459),(98459,5460),(98460,5462),(98461,5577),(98462,5580),(98463,5581),(98464,5585),(98465,5702),(98466,5703),(98467,5707),(98468,5708),(98469,1145),(98470,1146),(98471,1147),(98472,5271),(98473,5272),(98474,5273),(98475,5655),(98476,5656),(98477,5657),(98478,5385),(98479,5433),(98480,5451),(98481,5453),(98482,5454),(98483,5455),(98484,5468),(98485,5301),(98486,2276),(98487,4552),(98488,4561),(98489,4564),(98490,4565),(98491,5155),(98492,5248),(98493,5249),(98494,5154),(98495,4545),(98496,4562),(98497,5151),(98498,5152),(98499,4539),(98500,4543),(98501,4544),(98502,4546),(98503,4970),(98504,5153),(98505,5157),(98506,5158),(98507,5183),(98508,2389),(98509,4540),(98510,4541),(98511,4542),(98512,4547),(98513,4548),(98514,4549),(98515,4550),(98516,4551),(98517,4553),(98518,4554),(98519,4555),(98520,4556),(98521,4557),(98522,4558),(98523,4559),(98524,4560),(98525,4539),(98526,4545),(98527,4547),(98528,4548),(98529,4549),(98530,4552),(98531,4553),(98532,4563),(98533,5151),(98534,5152),(98535,5153),(98536,5156),(98537,5157),(98538,5158),(98539,5248),(98540,4539),(98541,4545),(98542,4552),(98543,4561),(98544,4562),(98545,4564),(98546,4565),(98547,4970),(98548,5249),(98549,4543),(98550,4544),(98551,4546),(98552,4547),(98553,4548),(98554,4549),(98555,4550),(98556,4551),(98557,4553),(98558,4554),(98559,4555),(98560,4540),(98561,4541),(98562,4542),(98563,4556),(98564,4557),(98565,4558),(98566,4559),(98567,4560),(98568,5183),(98569,5154),(98570,5155),(98571,1615),(98572,1775),(98573,1615),(98574,1775),(98575,1615),(98576,1775),(98577,2289),(98578,4492),(98579,4493),(98580,4494),(98581,4529),(98582,4884),(98583,4885),(98584,1158),(98585,1159),(98586,4495),(98587,4496),(98588,4497),(98589,4498),(98590,4499),(98591,4532),(98592,4537),(98593,4877),(98594,4878),(98595,4879),(98596,4880),(98597,5257),(98598,1160),(98599,1161),(98600,4491),(98601,4528),(98602,1866),(98603,1867),(98604,1868),(98605,1875),(98606,1876),(98607,1877),(98608,1878),(98609,1879),(98610,1880),(98611,1881),(98612,1882),(98613,1883),(98614,1884),(98615,1936),(98616,1937),(98617,1938),(98618,1992),(98619,1993),(98620,1493),(98621,1994),(98622,1995),(98623,1996),(98624,1997),(98625,1998),(98626,1999),(98627,2000),(98628,2001),(98629,2002),(98630,2289),(98631,2290),(98632,1836),(98633,1843),(98634,1848),(98635,1856),(98636,1860),(98637,1862),(98638,1869),(98639,1885),(98640,2291),(98641,2293),(98642,1886),(98643,1898),(98644,1913),(98645,1930),(98646,1939),(98647,1940),(98648,1945),(98649,5524),(98650,2330),(98651,2331),(98652,2332),(98653,2333),(98654,2334),(98655,2335),(98656,2336),(98657,2341),(98658,2342),(98659,2343),(98660,2133),(98661,2134),(98662,2139),(98663,2140),(98664,2141),(98665,2142),(98666,2337),(98667,2338),(98668,2339),(98669,2340),(98670,3515),(98671,4552),(98672,2143),(98673,2144),(98674,2145),(98675,2146),(98676,2147),(98677,2148),(98678,2149),(98679,2150),(98680,2151),(98681,2152),(98682,2153),(98683,2325),(98684,2326),(98685,2327),(98686,2328),(98687,2329),(98688,2344),(98689,2345),(98690,2346),(98691,2347),(98692,2348),(98693,2349),(98694,2350),(98695,2351),(98696,2352),(98697,2353),(98698,2354),(98699,2355),(98700,2356),(98701,2357),(98702,2358),(98703,2359),(98704,2360),(98705,2361),(98706,2362),(98707,2363),(98708,2364),(98709,2365),(98710,2366),(98711,2367),(98712,2368),(98713,2369),(98714,2370),(98715,2371),(98716,2372),(98717,2373),(98718,2374),(98719,2515),(98720,2516),(98721,1959),(98722,1960),(98723,1961),(98724,1963),(98725,1964),(98726,2413),(98727,2414),(98728,2415),(98729,2416),(98730,2417),(98731,2418),(98732,2419),(98733,2420),(98734,2421),(98735,2422),(98736,2423),(98737,2424),(98738,2425),(98739,2426),(98740,2537),(98741,2538),(98742,2816),(98743,2818),(98744,4550),(98745,4551),(98746,4553),(98747,4554),(98748,4555),(98749,4558),(98750,2002),(98751,2275),(98752,2379),(98753,2383),(98754,2384),(98755,2390),(98756,2559),(98757,4559),(98758,2375),(98759,2376),(98760,2380),(98761,2381),(98762,2387),(98763,2454),(98764,2455),(98765,2456),(98766,2135),(98767,2136),(98768,2137),(98769,2138),(98770,2382),(98771,3549),(98772,3550),(98773,3581),(98774,3582),(98775,2026),(98776,2027),(98777,2028),(98778,2029),(98779,2034),(98780,2039),(98781,2040),(98782,2030),(98783,2031),(98784,2032),(98785,2042),(98786,2044),(98787,2045),(98788,2046),(98789,2122),(98790,2123),(98791,2124),(98792,2125),(98793,2377),(98794,2378),(98795,2385),(98796,2386),(98797,2388),(98798,2389),(98799,2391),(98800,2133),(98801,2134),(98802,2139),(98803,2140),(98804,2141),(98805,2142),(98806,2143),(98807,2144),(98808,2145),(98809,2146),(98810,2147),(98811,2148),(98812,2149),(98813,2150),(98814,2151),(98815,2152),(98816,2153),(98817,2325),(98818,2326),(98819,2327),(98820,2328),(98821,2329),(98822,2355),(98823,2356),(98824,2357),(98825,2358),(98826,2359),(98827,2360),(98828,2361),(98829,2362),(98830,2363),(98831,2364),(98832,2365),(98833,2366),(98834,2367),(98835,2368),(98836,2369),(98837,2370),(98838,2371),(98839,2372),(98840,2275),(98841,2373),(98842,2374),(98843,2417),(98844,2418),(98845,2419),(98846,2420),(98847,2421),(98848,2422),(98849,2423),(98850,2424),(98851,2425),(98852,2426),(98853,2537),(98854,2538),(98855,2135),(98856,2375),(98857,2376),(98858,2379),(98859,2380),(98860,2381),(98861,2383),(98862,2384),(98863,2387),(98864,2390),(98865,2456),(98866,2559),(98867,2136),(98868,2137),(98869,2138),(98870,2377),(98871,2378),(98872,2385),(98873,2386),(98874,2388),(98875,2391),(98876,2330),(98877,2331),(98878,2332),(98879,2333),(98880,2334),(98881,2335),(98882,2336),(98883,2340),(98884,2341),(98885,2342),(98886,2343),(98887,2337),(98888,2338),(98889,2339),(98890,2344),(98891,2345),(98892,2346),(98893,2347),(98894,2348),(98895,2349),(98896,1959),(98897,1960),(98898,1961),(98899,1963),(98900,1964),(98901,2350),(98902,2351),(98903,2352),(98904,2353),(98905,2354),(98906,2413),(98907,2414),(98908,2515),(98909,2516),(98910,2026),(98911,2027),(98912,2028),(98913,2029),(98914,2034),(98915,2039),(98916,2382),(98917,2415),(98918,2416),(98919,2454),(98920,2455),(98921,2030),(98922,2031),(98923,2040),(98924,2042),(98925,2044),(98926,2045),(98927,2046),(98928,2032),(98929,2122),(98930,2123),(98931,2124),(98932,2125),(98933,2389),(98934,4608),(98935,4837),(98936,4942),(98937,5029),(98938,5030),(98939,5031),(98940,5032),(98941,5033),(98942,4955),(98943,4956),(98944,4967),(98945,5097),(98946,5100),(98947,5111),(98948,5116),(98949,5117),(98950,5119),(98951,5120),(98952,5121),(98953,1658),(98954,1659),(98955,1660),(98956,4818),(98957,4820),(98958,5118),(98959,4718),(98960,4838),(98961,5028),(98962,4730),(98963,4812),(98964,4813),(98965,4815),(98966,4822),(98967,4845),(98968,4942),(98969,4589),(98970,4590),(98971,4591),(98972,4592),(98973,4593),(98974,4594),(98975,4595),(98976,4596),(98977,4597),(98978,4598),(98979,4599),(98980,4818),(98981,4820),(98982,4841),(98983,4842),(98984,5101),(98985,5113),(98986,4582),(98987,4583),(98988,4584),(98989,4585),(98990,4586),(98991,4587),(98992,4834),(98993,4835),(98994,4836),(98995,4608),(98996,5116),(98997,5117),(98998,5118),(98999,5119),(99000,5120),(99001,4588),(99002,4600),(99003,4601),(99004,4602),(99005,4603),(99006,5029),(99007,5030),(99008,5031),(99009,5032),(99010,5033),(99011,4604),(99012,4608),(99013,4718),(99014,4839),(99015,4840),(99016,5097),(99017,5110),(99018,5111),(99019,4816),(99020,4967),(99021,5100),(99022,5250),(99023,5739),(99024,5740),(99025,5741),(99026,5742),(99027,5743),(99028,5744),(99029,1651),(99030,1652),(99031,1653),(99032,5103),(99033,5104),(99034,5251),(99035,5252),(99036,5253),(99037,5255),(99038,1650),(99039,1703),(99040,1704),(99041,1737),(99042,1738),(99043,4612),(99044,5254),(99045,4813),(99046,4837),(99047,4955),(99048,4956),(99049,5097),(99050,5098),(99051,5101),(99052,5110),(99053,5111),(99054,5116),(99055,4730),(99056,4812),(99057,4818),(99058,4822),(99059,4845),(99060,5117),(99061,5118),(99062,1687),(99063,1780),(99064,1660),(99065,1689),(99066,1692),(99067,1695),(99068,5090),(99069,1691),(99070,1687),(99071,1689),(99072,1691),(99073,1692),(99074,1695),(99075,1696),(99076,1750),(99077,1759),(99078,1760),(99079,5090),(99080,1659),(99081,1688),(99082,1740),(99083,1743),(99084,1690),(99085,4838),(99086,5028),(99087,5098),(99088,5099),(99089,5121),(99090,4812),(99091,4813),(99092,4814),(99093,4815),(99094,4817),(99095,4942),(99096,4969),(99097,5461),(99098,4821),(99099,4822),(99100,5093),(99101,5094),(99102,5095),(99103,5096),(99104,4589),(99105,4590),(99106,4591),(99107,4592),(99108,4593),(99109,4594),(99110,5034),(99111,5035),(99112,5036),(99113,4595),(99114,4596),(99115,4597),(99116,4598),(99117,4599),(99118,4718),(99119,4841),(99120,4842),(99121,5101),(99122,4819),(99123,5078),(99124,5080),(99125,5081),(99126,5084),(99127,5102),(99128,5112),(99129,4582),(99130,4583),(99131,4584),(99132,4585),(99133,4586),(99134,4587),(99135,4834),(99136,4835),(99137,4836),(99138,2219),(99139,2220),(99140,2261),(99141,2307),(99142,2308),(99143,2310),(99144,2251),(99145,2260),(99146,2309),(99147,2312),(99148,2313),(99149,2314),(99150,2316),(99151,2461),(99152,2259),(99153,2460),(99154,2462),(99155,2463),(99156,2504),(99157,2505),(99158,2201),(99159,2202),(99160,2214),(99161,2215),(99162,2216),(99163,2217),(99164,2218),(99165,2187),(99166,2188),(99167,2190),(99168,2192),(99169,2194),(99170,2197),(99171,2232),(99172,2233),(99173,2234),(99174,2237),(99175,2238),(99176,2236),(99177,2392),(99178,2393),(99179,2394),(99180,2395),(99181,2411),(99182,2412),(99183,2577),(99184,2578),(99185,2579),(99186,2580),(99187,5123),(99188,5124),(99189,5125),(99190,5126),(99191,5127),(99192,5129),(99193,5130),(99194,5131),(99195,5148),(99196,5149),(99197,5150),(99198,2256),(99199,2305),(99200,5128),(99201,5136),(99202,5167),(99203,2208),(99204,2209),(99205,2304),(99206,2458),(99207,2459),(99208,2503),(99209,4860),(99210,5203),(99211,5204),(99212,5205),(99213,5230),(99214,5105),(99215,5207),(99216,5208),(99217,5209),(99218,5210),(99219,5212),(99220,5213),(99221,5214),(99222,5215),(99223,5216),(99224,5217),(99225,5218),(99226,5229),(99227,5234),(99228,5235),(99229,5236),(99230,4714),(99231,4715),(99232,4716),(99233,4717),(99234,4724),(99235,4809),(99236,4810),(99237,4811),(99238,4843),(99239,4851),(99240,5237),(99241,4668),(99242,4669),(99243,4688),(99244,4689),(99245,4691),(99246,4693),(99247,4696),(99248,4698),(99249,4699),(99250,4700),(99251,4705),(99252,4706),(99253,4707),(99254,4708),(99255,4709),(99256,4636),(99257,4638),(99258,4641),(99259,4642),(99260,4643),(99261,4644),(99262,4674),(99263,4675),(99264,4690),(99265,4692),(99266,4694),(99267,4697),(99268,4710),(99269,4712),(99270,4645),(99271,4646),(99272,4647),(99273,4648),(99274,4649),(99275,4652),(99276,4654),(99277,4656),(99278,4657),(99279,4658),(99280,4659),(99281,4660),(99282,4661),(99283,4662),(99284,4663),(99285,4665),(99286,4667),(99287,5045),(99288,5046),(99289,5055),(99290,5056),(99291,5060),(99292,5061),(99293,5041),(99294,5043),(99295,5047),(99296,5048),(99297,5049),(99298,5050),(99299,5051),(99300,5052),(99301,5054),(99302,5057),(99303,5058),(99304,5059),(99305,2399),(99306,2400),(99307,2401),(99308,2403),(99309,2591),(99310,2592),(99311,2605),(99312,4628),(99313,4731),(99314,4734),(99315,4739),(99316,4744),(99317,4747),(99318,4748),(99319,4757),(99320,4766),(99321,4767),(99322,4768),(99323,4773),(99324,4774),(99325,4775),(99326,4776),(99327,4781),(99328,2204),(99329,2205),(99330,2206),(99331,2318),(99332,2321),(99333,2322),(99334,4613),(99335,4614),(99336,4769),(99337,4782),(99338,4783),(99339,4784),(99340,4790),(99341,4792),(99342,4794),(99343,4796),(99344,4802),(99345,4873),(99346,2200),(99347,2210),(99348,2614),(99349,4639),(99350,4664),(99351,4680),(99352,4719),(99353,4952),(99354,5202),(99355,5211),(99356,5220),(99357,5224),(99358,5225),(99359,2163),(99360,2248),(99361,2270),(99362,2271),(99363,2300),(99364,2301),(99365,2311),(99366,2440),(99367,2441),(99368,2442),(99369,2489),(99370,2497),(99371,2506),(99372,2507),(99373,2508),(99374,2509),(99375,2511),(99376,2512),(99377,2609),(99378,4722),(99379,4740),(99380,4770),(99381,5044),(99382,5053),(99383,5065),(99384,5066),(99385,5072),(99386,2024),(99387,2226),(99388,2472),(99389,2473),(99390,2475),(99391,2476),(99392,2490),(99393,2491),(99394,4764),(99395,4872),(99396,4957),(99397,4958),(99398,4959),(99399,4960),(99400,4961),(99401,4962),(99402,1711),(99403,4777),(99404,4778),(99405,4779),(99406,4780),(99407,2311),(99408,4764),(99409,4957),(99410,4958),(99411,4959),(99412,4960),(99413,4961),(99414,4962),(99415,5106),(99416,5107),(99417,5108),(99418,5109),(99419,2251),(99420,2260),(99421,2307),(99422,2308),(99423,2309),(99424,2310),(99425,2312),(99426,2313),(99427,2314),(99428,2316),(99429,2188),(99430,2190),(99431,2192),(99432,2194),(99433,2197),(99434,2460),(99435,2461),(99436,2462),(99437,2463),(99438,2504),(99439,2505),(99440,2187),(99441,2245),(99442,2256),(99443,2304),(99444,2305),(99445,2306),(99446,2315),(99447,2396),(99448,2411),(99449,2412),(99450,2458),(99451,2459),(99452,2503),(99453,2577),(99454,2578),(99455,2579),(99456,2580),(99457,2191),(99458,2193),(99459,2195),(99460,2198),(99461,2235),(99462,2240),(99463,2246),(99464,2257),(99465,2302),(99466,2303),(99467,2311),(99468,2581),(99469,5123),(99470,5124),(99471,5130),(99472,5131),(99473,5148),(99474,5149),(99475,5150),(99476,5125),(99477,5126),(99478,5127),(99479,5128),(99480,5129),(99481,5136),(99482,5167),(99483,5203),(99484,5204),(99485,5205),(99486,5217),(99487,5229),(99488,5230),(99489,5105),(99490,5207),(99491,5208),(99492,5209),(99493,5210),(99494,5212),(99495,5213),(99496,5214),(99497,5215),(99498,5216),(99499,5218),(99500,5234),(99501,5235),(99502,4714),(99503,4715),(99504,4716),(99505,4717),(99506,4724),(99507,4809),(99508,4810),(99509,4811),(99510,5236),(99511,5237),(99512,4719),(99513,4722),(99514,4843),(99515,4851),(99516,4873),(99517,5166),(99518,5202),(99519,5211),(99520,5220),(99521,5224),(99522,5225),(99523,5122),(99524,5137),(99525,5138),(99526,5139),(99527,5142),(99528,5147),(99529,5159),(99530,5160),(99531,5161),(99532,5163),(99533,5164),(99534,5168),(99535,5222),(99536,5231),(99537,5232),(99538,5233),(99539,4720),(99540,4723),(99541,4846),(99542,4847),(99543,4848),(99544,4849),(99545,4850),(99546,4852),(99547,4856),(99548,5141),(99549,5206),(99550,5219),(99551,5221),(99552,5223),(99553,5226),(99554,5227),(99555,5228),(99556,4721),(99557,4725),(99558,4726),(99559,4727),(99560,4728),(99561,4729),(99562,4777),(99563,4844),(99564,5140),(99565,5162),(99566,5165),(99567,4778),(99568,4779),(99569,4780),(99570,4823),(99571,4872),(99572,5106),(99573,5107),(99574,5108),(99575,5109),(99576,2245),(99577,2201),(99578,2202),(99579,2214),(99580,2215),(99581,2216),(99582,2217),(99583,2218),(99584,2219),(99585,2220),(99586,2232),(99587,2233),(99588,2234),(99589,2236),(99590,2237),(99591,2238),(99592,2251),(99593,2259),(99594,2260),(99595,2261),(99596,2200),(99597,2208),(99598,2209),(99599,2210),(99600,2246),(99601,2256),(99602,2258),(99603,2392),(99604,2393),(99605,2394),(99606,2395),(99607,2396),(99608,2459),(99609,4621),(99610,4627),(99611,4628),(99612,1575),(99613,1576),(99614,1577),(99615,1580),(99616,1581),(99617,1582),(99618,1583),(99619,1708),(99620,1709),(99621,1710),(99622,1711),(99623,1712),(99624,1714),(99625,1578),(99626,1579),(99627,1713),(99628,2265),(99629,2266),(99630,2267),(99631,2268),(99632,2269),(99633,2276),(99634,2320),(99635,2397),(99636,2398),(99637,2400),(99638,2401),(99639,2403),(99640,2405),(99641,2406),(99642,2407),(99643,2408),(99644,2409),(99645,2410),(99646,2589),(99647,2590),(99648,2591),(99649,2592),(99650,2593),(99651,2594),(99652,2595),(99653,2598),(99654,2599),(99655,2600),(99656,2601),(99657,2602),(99658,2603),(99659,2604),(99660,2605),(99661,2606),(99662,2607),(99663,2318),(99664,2319),(99665,2321),(99666,2322),(99667,2608),(99668,2610),(99669,2611),(99670,2612),(99671,2613),(99672,2317),(99673,2596),(99674,2597),(99675,2609),(99676,2614),(99677,2399),(99678,4860),(99679,4668),(99680,4688),(99681,4689),(99682,4691),(99683,4693),(99684,4696),(99685,4698),(99686,4699),(99687,4700),(99688,4705),(99689,4706),(99690,4669),(99691,4690),(99692,4694),(99693,4697),(99694,4707),(99695,4708),(99696,4709),(99697,4710),(99698,4712),(99699,4636),(99700,4638),(99701,4641),(99702,4642),(99703,4643),(99704,4644),(99705,4645),(99706,4646),(99707,4647),(99708,4648),(99709,4674),(99710,4675),(99711,4692),(99712,4649),(99713,4652),(99714,4654),(99715,4656),(99716,4657),(99717,4658),(99718,4659),(99719,4660),(99720,4661),(99721,4662),(99722,4663),(99723,4665),(99724,4667),(99725,5045),(99726,5046),(99727,5047),(99728,5048),(99729,5049),(99730,5051),(99731,5052),(99732,5055),(99733,5056),(99734,5057),(99735,5058),(99736,5060),(99737,5061),(99738,2605),(99739,4731),(99740,4734),(99741,4739),(99742,4744),(99743,4747),(99744,4748),(99745,4757),(99746,5041),(99747,5043),(99748,5050),(99749,5054),(99750,5059),(99751,4613),(99752,4614),(99753,4639),(99754,4664),(99755,4680),(99756,4766),(99757,4767),(99758,4768),(99759,4769),(99760,4773),(99761,4774),(99762,4775),(99763,4776),(99764,4781),(99765,4782),(99766,4783),(99767,4784),(99768,4790),(99769,4792),(99770,4794),(99771,4796),(99772,4802),(99773,4804),(99774,4952),(99775,4676),(99776,4687),(99777,4695),(99778,4701),(99779,4702),(99780,4703),(99781,4704),(99782,4740),(99783,5044),(99784,5053),(99785,5065),(99786,5066),(99787,5072),(99788,4673),(99789,4711),(99790,4713),(99791,4944),(99792,4949),(99793,4953),(99794,4637),(99795,4640),(99796,4650),(99797,4651),(99798,4655),(99799,4666),(99800,4943),(99801,4945),(99802,4946),(99803,4947),(99804,4948),(99805,4950),(99806,4951),(99807,4635),(99808,4653),(99809,4671),(99810,4735),(99811,4741),(99812,4742),(99813,4754),(99814,4759),(99815,4762),(99816,4763),(99817,4771),(99818,4786),(99819,4795),(99820,4857),(99821,4858),(99822,4859),(99823,4861),(99824,4867),(99825,4868),(99826,5039),(99827,5040),(99828,5042),(99829,5070),(99830,5071),(99831,4629),(99832,4630),(99833,4631),(99834,4632),(99835,4633),(99836,4634),(99837,4670),(99838,4672),(99839,4770),(99840,4862),(99841,4863),(99842,4864),(99843,4865),(99844,4866),(99845,4876),(99846,5069),(99847,4732),(99848,4736),(99849,4746),(99850,4758),(99851,4760),(99852,4787),(99853,4789),(99854,4797),(99855,4799),(99856,5067),(99857,5068),(99858,4743),(99859,4749),(99860,4750),(99861,4751),(99862,4752),(99863,4753),(99864,4761),(99865,4772),(99866,4785),(99867,4788),(99868,4798),(99869,4800),(99870,4801),(99871,4803),(99872,4733),(99873,4737),(99874,4738),(99875,4745),(99876,4755),(99877,4764),(99878,4765),(99879,4791),(99880,4793),(99881,4954),(99882,4957),(99883,4958),(99884,4959),(99885,4960),(99886,4961),(99887,4962),(99888,4756),(99889,4869),(99890,4870),(99891,4871),(99892,4874),(99893,4875),(99894,4891),(99895,4892),(99896,4893),(99897,4894),(99898,4895),(99899,1791),(99900,1792),(99901,1798),(99902,1803),(99903,1805),(99904,1806),(99905,1807),(99906,1808),(99907,1809),(99908,1810),(99909,1811),(99910,1748),(99911,1791),(99912,1792),(99913,1798),(99914,1803),(99915,1804),(99916,1805),(99917,1809),(99918,1806),(99919,1807),(99920,1808),(99921,1810),(99922,1811),(99923,5178),(99924,5180),(99925,5181),(99926,5191),(99927,5192),(99928,5193),(99929,5178),(99930,5179),(99931,5180),(99932,5182),(99933,5190),(99934,5192),(99935,5194),(99936,5197),(99937,5181),(99938,5191),(99939,5193),(99940,5195),(99941,5196),(99942,5199),(99943,4971),(99944,4973),(99945,4974),(99946,4976),(99947,4977),(99948,4982),(99949,4992),(99950,4993),(99951,4994),(99952,5009),(99953,5025),(99954,4972),(99955,4979),(99956,4980),(99957,4981),(99958,4983),(99959,4984),(99960,4985),(99961,4986),(99962,4987),(99963,4988),(99964,4989),(99965,4990),(99966,4991),(99967,5001),(99968,5002),(99969,4995),(99970,4996),(99971,4997),(99972,4998),(99973,4999),(99974,5000),(99975,5005),(99976,5008),(99977,5011),(99978,5012),(99979,5019),(99980,4975),(99981,4978),(99982,5003),(99983,5004),(99984,5006),(99985,5007),(99986,5010),(99987,5013),(99988,5014),(99989,5015),(99990,5016),(99991,5022),(99992,5024),(99993,4972),(99994,4973),(99995,4976),(99996,4977),(99997,4983),(99998,4984),(99999,4985),(100000,4986),(100001,4987),(100002,4988),(100003,4989),(100004,4990),(100005,4991),(100006,4996),(100007,4998),(100008,5002),(100009,4997),(100010,4999),(100011,5000),(100012,5005),(100013,5008),(100014,5011),(100015,5012),(100016,5013),(100017,5014),(100018,5015),(100019,5016),(100020,4971),(100021,4981),(100022,4982),(100023,4992),(100024,4993),(100025,4994),(100026,5001),(100027,5009),(100028,5025),(100029,4979),(100030,4980),(100031,4995),(100032,5003),(100033,5004),(100034,5006),(100035,5007),(100036,5010),(100037,5019),(100038,5022),(100039,5024),(100040,4896),(100041,4898),(100042,4899),(100043,4900),(100044,4901),(100045,4902),(100046,4903),(100047,4904),(100048,4905),(100049,4906),(100050,4907),(100051,4908),(100052,4909),(100053,4910),(100054,4911),(100055,4972),(100056,1679),(100057,1680),(100058,5021),(100059,5023),(100060,5026),(100061,5027),(100062,4973),(100063,4975),(100064,4976),(100065,4977),(100066,4978),(100067,2036),(100068,2086),(100069,2088),(100070,2174),(100071,2204),(100072,2252),(100073,2087),(100074,2094),(100075,2095),(100076,2096),(100077,2205),(100078,2206),(100079,2296),(100080,2510),(100081,2543),(100082,1953),(100083,1954),(100084,1955),(100085,2064),(100086,2089),(100087,2159),(100088,2494),(100089,2495),(100090,2497),(100091,2059),(100092,2103),(100093,2106),(100094,2107),(100095,2108),(100096,2109),(100097,2110),(100098,2111),(100099,2112),(100100,2452),(100101,2555),(100102,2621),(100103,2104),(100104,2163),(100105,2248),(100106,2270),(100107,2271),(100108,2441),(100109,2442),(100110,2477),(100111,2478),(100112,2479),(100113,2507),(100114,2508),(100115,2509),(100116,2025),(100117,2226),(100118,2230),(100119,2300),(100120,2301),(100121,2472),(100122,2473),(100123,2475),(100124,2476),(100125,2489),(100126,2490),(100127,2491),(100128,2511),(100129,2512),(100130,1816),(100131,1818),(100132,1822),(100133,1827),(100134,1965),(100135,1966),(100136,2008),(100137,2013),(100138,2014),(100139,1972),(100140,1973),(100141,1974),(100142,1977),(100143,1978),(100144,1983),(100145,1984),(100146,1986),(100147,1988),(100148,2035),(100149,2037),(100150,2041),(100151,1975),(100152,1976),(100153,1979),(100154,1980),(100155,1982),(100156,1985),(100157,1987),(100158,1989),(100159,1990),(100160,1813),(100161,1814),(100162,1815),(100163,1820),(100164,1821),(100165,1824),(100166,1825),(100167,1826),(100168,1817),(100169,1819),(100170,1823),(100171,1828),(100172,1981),(100173,2021),(100174,2022),(100175,2154),(100176,2177),(100177,2221),(100178,2222),(100179,2299),(100180,2435),(100181,2531),(100182,2540),(100183,2541),(100184,2542),(100185,2066),(100186,2067),(100187,2068),(100188,2069),(100189,2078),(100190,2100),(100191,2165),(100192,2166),(100193,2169),(100194,2070),(100195,2071),(100196,2072),(100197,2073),(100198,2074),(100199,2075),(100200,2076),(100201,2077),(100202,2079),(100203,2097),(100204,2098),(100205,2099),(100206,2101),(100207,2167),(100208,2049),(100209,2050),(100210,2051),(100211,2052),(100212,2053),(100213,2054),(100214,2055),(100215,2056),(100216,2060),(100217,2085),(100218,2168),(100219,2252),(100220,2253),(100221,2254),(100222,2255),(100223,2003),(100224,2004),(100225,2005),(100226,2006),(100227,2012),(100228,2015),(100229,2016),(100230,2038),(100231,2272),(100232,2273),(100233,2274),(100234,2009),(100235,2010),(100236,2011),(100237,2057),(100238,2058),(100239,2170),(100240,2171),(100241,2172),(100242,2173),(100243,2174),(100244,2175),(100245,2297),(100246,2298),(100247,2444),(100248,2445),(100249,2446),(100250,2447),(100251,2448),(100252,2485),(100253,2487),(100254,2615),(100255,2247),(100256,2429),(100257,2430),(100258,2431),(100259,2513),(100260,2514),(100261,2521),(100262,2522),(100263,2523),(100264,2524),(100265,2525),(100266,2526),(100267,2527),(100268,2528),(100269,2539),(100270,2573),(100271,2574),(100272,2575),(100273,2576),(100274,2017),(100275,2018),(100276,2019),(100277,2020),(100278,2062),(100279,2063),(100280,2080),(100281,2158),(100282,2160),(100283,2161),(100284,2164),(100285,2176),(100286,2180),(100287,2207),(100288,2249),(100289,2250),(100290,2474),(100291,2482),(100292,2484),(100293,2486),(100294,2543),(100295,2544),(100296,2545),(100297,2546),(100298,2047),(100299,2048),(100300,2116),(100301,2117),(100302,2118),(100303,2119),(100304,2184),(100305,2185),(100306,2186),(100307,2225),(100308,2227),(100309,2228),(100310,2229),(100311,2231),(100312,2483),(100313,2488),(100314,2553),(100315,2554),(100316,1955),(100317,2007),(100318,2065),(100319,2081),(100320,2082),(100321,2083),(100322,2090),(100323,2091),(100324,2159),(100325,2223),(100326,2296),(100327,2494),(100328,2495),(100329,2496),(100330,2497),(100331,2510),(100332,1953),(100333,1954),(100334,1956),(100335,1957),(100336,2059),(100337,2064),(100338,2089),(100339,2103),(100340,2106),(100341,2107),(100342,2108),(100343,2109),(100344,2110),(100345,2111),(100346,2112),(100347,2492),(100348,2493),(100349,2498),(100350,2499),(100351,2555),(100352,1991),(100353,2024),(100354,2025),(100355,2033),(100356,2061),(100357,2084),(100358,2102),(100359,2104),(100360,2105),(100361,2120),(100362,2121),(100363,2163),(100364,2226),(100365,2248),(100366,2270),(100367,2271),(100368,2441),(100369,2472),(100370,2473),(100371,2506),(100372,2507),(100373,2508),(100374,2509),(100375,2511),(100376,2536),(100377,2512),(100378,2066),(100379,2067),(100380,2068),(100381,2069),(100382,2070),(100383,2078),(100384,2079),(100385,2100),(100386,2101),(100387,2165),(100388,2166),(100389,2169),(100390,2616),(100391,2617),(100392,2618),(100393,2049),(100394,2050),(100395,2051),(100396,2052),(100397,2053),(100398,2056),(100399,2071),(100400,2072),(100401,2073),(100402,2074),(100403,2075),(100404,2076),(100405,2077),(100406,2097),(100407,2098),(100408,2099),(100409,2167),(100410,2168),(100411,2253),(100412,2254),(100413,2005),(100414,2006),(100415,2012),(100416,2015),(100417,2016),(100418,2054),(100419,2055),(100420,2060),(100421,2085),(100422,2255),(100423,2264),(100424,2272),(100425,2273),(100426,2274),(100427,2283),(100428,2284),(100429,2465),(100430,2003),(100431,2004),(100432,2009),(100433,2010),(100434,2011),(100435,2057),(100436,2058),(100437,2170),(100438,2171),(100439,2172),(100440,2173),(100441,2175),(100442,2199),(100443,2281),(100444,2294),(100445,2297),(100446,2298),(100447,2444),(100448,2445),(100449,2466),(100450,2467),(100451,2468),(100452,2469),(100453,2470),(100454,2471),(100455,2552),(100456,2556),(100457,2557),(100458,2558),(100459,2562),(100460,2563),(100461,2566),(100462,2567),(100463,2568),(100464,2569),(100465,2570),(100466,2571),(100467,2615),(100468,2247),(100469,2429),(100470,2446),(100471,2447),(100472,2448),(100473,2485),(100474,2487),(100475,2513),(100476,2514),(100477,2521),(100478,2523),(100479,2529),(100480,2530),(100481,2539),(100482,2584),(100483,2586),(100484,2587),(100485,2522),(100486,2524),(100487,2525),(100488,2526),(100489,2527),(100490,2528),(100491,2573),(100492,2574),(100493,2575),(100494,2576),(100495,2164),(100496,2176),(100497,2203),(100498,2205),(100499,2206),(100500,2207),(100501,2249),(100502,2250),(100503,2277),(100504,2278),(100505,2279),(100506,2280),(100507,2430),(100508,2431),(100509,2532),(100510,2533),(100511,2534),(100512,2535),(100513,2547),(100514,2548),(100515,2549),(100516,2550),(100517,2551),(100518,2158),(100519,2160),(100520,2161),(100521,2162),(100522,2181),(100523,2183),(100524,2292),(100525,2295),(100526,2432),(100527,2474),(100528,2543),(100529,2544),(100530,2545),(100531,2546),(100532,2017),(100533,2062),(100534,2063),(100535,2080),(100536,2178),(100537,2179),(100538,2180),(100539,2263),(100540,2285),(100541,2433),(100542,2434),(100543,2436),(100544,2437),(100545,2438),(100546,2450),(100547,2482),(100548,2484),(100549,2486),(100550,2018),(100551,2019),(100552,2020),(100553,2047),(100554,2048),(100555,2116),(100556,2117),(100557,2118),(100558,2119),(100559,2451),(100560,2453),(100561,2501),(100562,2502),(100563,2560),(100564,2561),(100565,2565),(100566,2184),(100567,2185),(100568,2186),(100569,2212),(100570,2225),(100571,2227),(100572,2228),(100573,2229),(100574,2231),(100575,2282),(100576,2483),(100577,2517),(100578,2518),(100579,2519),(100580,2520),(100581,2619),(100582,2620),(100583,2296),(100584,2488),(100585,2553),(100586,2554),(100587,2582),(100588,2583),(100589,2585),(100590,1955),(100591,2007),(100592,2065),(100593,2081),(100594,2082),(100595,2083),(100596,2090),(100597,2091),(100598,2092),(100599,2093),(100600,2286),(100601,2287),(100602,2288),(100603,2496),(100604,2497),(100605,2510),(100606,2564),(100607,2572),(100608,1953),(100609,1954),(100610,1956),(100611,1957),(100612,1958),(100613,2059),(100614,2064),(100615,2089),(100616,2110),(100617,2111),(100618,2112),(100619,2159),(100620,2223),(100621,2492),(100622,2493),(100623,2494),(100624,2495),(100625,2498),(100626,2499),(100627,2555),(100628,2102),(100629,2103),(100630,2104),(100631,2106),(100632,2107),(100633,2108),(100634,2109),(100635,2163),(100636,2270),(100637,2271),(100638,2441),(100639,2452),(100640,2478),(100641,2480),(100642,2621),(100643,2248),(100644,2457),(100645,2506),(100646,2507),(100647,2508),(100648,2509),(100649,2511),(100650,2512),(100651,2536),(100652,2038),(100653,1),(100654,4),(100655,5),(100656,6),(100657,1162),(100658,1163),(100659,1164),(100660,1165),(100661,3835),(100662,4013),(100663,4014),(100664,4015),(100665,4016),(100666,4017),(100667,4018),(100668,4019),(100669,4020),(100670,4021),(100671,4022),(100672,4023),(100673,4024),(100674,4025),(100675,4026),(100676,4027),(100677,4028),(100678,4029),(100679,4030),(100680,4031),(100681,4032),(100682,4033),(100683,4034),(100684,4035),(100685,4036),(100686,4037),(100687,4127),(100688,4128),(100689,4129),(100690,4130),(100691,4132),(100692,4133),(100693,4211),(100694,3724),(100695,3733),(100696,3734),(100697,3735),(100698,3736),(100699,3737),(100700,3740),(100701,3746),(100702,4135),(100703,4156),(100704,4297),(100705,4298),(100706,4300),(100707,4301),(100708,4302),(100709,4303),(100710,4304),(100711,4458),(100712,4459),(100713,3719),(100714,3720),(100715,3723),(100716,3725),(100717,3726),(100718,3728),(100719,3731),(100720,3748),(100721,3751),(100722,3752),(100723,3753),(100724,3754),(100725,3755),(100726,3757),(100727,3758),(100728,3759),(100729,3760),(100730,3909),(100731,3721),(100732,3727),(100733,3732),(100734,3741),(100735,3743),(100736,3744),(100737,3749),(100738,3761),(100739,3762),(100740,3765),(100741,3942),(100742,3972),(100743,3978),(100744,3980),(100745,4080),(100746,4081),(100747,4082),(100748,4083),(100749,4084),(100750,4085),(100751,4088),(100752,4089),(100753,4196),(100754,4197),(100755,4198),(100756,4204),(100757,4205),(100758,4206),(100759,4207),(100760,3884),(100761,3889),(100762,3905),(100763,3917),(100764,3974),(100765,4208),(100766,4209),(100767,4210),(100768,4222),(100769,4226),(100770,4227),(100771,4228),(100772,4230),(100773,4231),(100774,4232),(100775,4233),(100776,4235),(100777,4237),(100778,4238),(100779,4247),(100780,4259),(100781,4275),(100782,4292),(100783,4425),(100784,3885),(100785,3894),(100786,3919),(100787,3920),(100788,3921),(100789,3922),(100790,3966),(100791,3968),(100792,4062),(100793,4121),(100794,4122),(100795,4249),(100796,4250),(100797,4252),(100798,4253),(100799,4255),(100800,4270),(100801,4336),(100802,4360),(100803,4418),(100804,4427),(100805,4063),(100806,4123),(100807,4124),(100808,4179),(100809,4180),(100810,4181),(100811,4182),(100812,4183),(100813,4184),(100814,4185),(100815,4187),(100816,4188),(100817,4189),(100818,4190),(100819,4191),(100820,3785),(100821,3786),(100822,4192),(100823,4215),(100824,4305),(100825,4309),(100826,4310),(100827,4316),(100828,4317),(100829,4070),(100830,4318),(100831,4319),(100832,4364),(100833,4366),(100834,4390),(100835,4391),(100836,4393),(100837,4394),(100838,4395),(100839,4396),(100840,4397),(100841,4398),(100842,4399),(100843,3715),(100844,3716),(100845,3750),(100846,3827),(100847,3828),(100848,3829),(100849,3830),(100850,3832),(100851,3833),(100852,3834),(100853,4092),(100854,4093),(100855,4096),(100856,4097),(100857,4400),(100858,4401),(100859,4460),(100860,4461),(100861,4462),(100862,4467),(100863,4469),(100864,4470),(100865,4474),(100866,4475),(100867,4120),(100868,4151),(100869,4162),(100870,4199),(100871,4200),(100872,4201),(100873,4271),(100874,4272),(100875,4273),(100876,4313),(100877,4430),(100878,4431),(100879,4457),(100880,3874),(100881,3918),(100882,3941),(100883,3963),(100884,4012),(100885,4043),(100886,4087),(100887,4090),(100888,4091),(100889,4095),(100890,4195),(100891,4214),(100892,4224),(100893,4225),(100894,4234),(100895,4236),(100896,4291),(100897,4306),(100898,4358),(100899,1641),(100900,1642),(100901,3722),(100902,3875),(100903,3876),(100904,3877),(100905,3878),(100906,3880),(100907,3892),(100908,4243),(100909,4244),(100910,4245),(100911,4294),(100912,4295),(100913,4436),(100914,4444),(100915,4446),(100916,4447),(100917,4448),(100918,4449),(100919,4450),(100920,4451),(100921,4452),(100922,4454),(100923,4455),(100924,4456),(100925,3729),(100926,3893),(100927,3895),(100928,3924),(100929,3925),(100930,3926),(100931,3927),(100932,3928),(100933,3931),(100934,3933),(100935,3934),(100936,3935),(100937,4086),(100938,4194),(100939,4229),(100940,4251),(100941,4254),(100942,4402),(100943,4403),(100944,4404),(100945,4413),(100946,4414),(100947,4415),(100948,3730),(100949,3738),(100950,3739),(100951,3742),(100952,3747),(100953,3763),(100954,3764),(100955,3831),(100956,3861),(100957,3964),(100958,3965),(100959,3975),(100960,3976),(100961,4052),(100962,4053),(100963,4219),(100964,4276),(100965,4417),(100966,4419),(100967,4065),(100968,4066),(100969,4069),(100970,4170),(100971,4171),(100972,4172),(100973,4173),(100974,4174),(100975,4175),(100976,4186),(100977,4202),(100978,4203),(100979,4212),(100980,5753),(100981,5753),(100982,5753),(100983,5753),(100984,5753),(100985,5753),(100986,5753),(100987,5753),(100988,5753),(100989,5753),(100990,4216),(100991,4217),(100992,4218),(100993,4220),(100994,4257),(100995,4277),(100996,4278),(100997,4279),(100998,4280),(100999,4282),(101000,4283),(101001,4287),(101002,4288),(101003,4289),(101004,4290),(101005,4315),(101006,4340),(101007,4342),(101008,4343),(101009,4392),(101010,3981),(101011,4054),(101012,4075),(101013,4077),(101014,4142),(101015,4150),(101016,4223),(101017,4434),(101018,4435),(101019,4437),(101020,4438),(101021,4439),(101022,4441),(101023,4442),(101024,4443),(101025,4445),(101026,3756),(101027,3982),(101028,3983),(101029,3984),(101030,3985),(101031,3986),(101032,3987),(101033,3988),(101034,4067),(101035,4068),(101036,4078),(101037,4261),(101038,4262),(101039,4308),(101040,4311),(101041,4312),(101042,4480),(101043,3923),(101044,3929),(101045,3936),(101046,3967),(101047,3969),(101048,4239),(101049,4240),(101050,4241),(101051,4256),(101052,4307),(101053,4346),(101054,4405),(101055,4407),(101056,4408),(101057,4410),(101058,4426),(101059,4473),(101060,4476),(101061,1630),(101062,1631),(101063,1632),(101064,1633),(101065,1634),(101066,1635),(101067,1682),(101068,1683),(101069,1686),(101070,4347),(101071,4349),(101072,4351),(101073,4353),(101074,4355),(101075,1681),(101076,1684),(101077,1685),(101078,3767),(101079,3882),(101080,3903),(101081,3973),(101082,4055),(101083,4059),(101084,4060),(101085,4094),(101086,4143),(101087,4152),(101088,4154),(101089,4168),(101090,3747),(101091,3718),(101092,3745),(101093,3769),(101094,3770),(101095,3772),(101096,3773),(101097,3774),(101098,3904),(101099,3989),(101100,4039),(101101,4041),(101102,4079),(101103,4293),(101104,4370),(101105,4373),(101106,4375),(101107,4378),(101108,4381),(101109,4383),(101110,4384),(101111,4385),(101112,4424),(101113,3787),(101114,3930),(101115,4368),(101116,4369),(101117,4371),(101118,4372),(101119,4374),(101120,4376),(101121,4377),(101122,4379),(101123,4380),(101124,4382),(101125,4386),(101126,4387),(101127,4388),(101128,4389),(101129,3932),(101130,3937),(101131,3938),(101132,3943),(101133,3944),(101134,3945),(101135,3946),(101136,3947),(101137,3948),(101138,3949),(101139,3950),(101140,3951),(101141,3952),(101142,3953),(101143,3954),(101144,3955),(101145,3956),(101146,3957),(101147,3958),(101148,3959),(101149,3960),(101150,3961),(101151,4108),(101152,4140),(101153,4411),(101154,4412),(101155,4131),(101156,4134),(101157,4136),(101158,4138),(101159,4139),(101160,4145),(101161,4146),(101162,4148),(101163,4149),(101164,4248),(101165,4359),(101166,3747),(101167,4021),(101168,4022),(101169,4023),(101170,4024),(101171,4025),(101172,4026),(101173,4027),(101174,4028),(101175,4029),(101176,4030),(101177,4031),(101178,4032),(101179,4033),(101180,4034),(101181,3724),(101182,3733),(101183,3734),(101184,3735),(101185,3736),(101186,3737),(101187,3740),(101188,4035),(101189,4036),(101190,4037),(101191,4211),(101192,3719),(101193,3720),(101194,3723),(101195,3725),(101196,3726),(101197,3728),(101198,3731),(101199,3746),(101200,3751),(101201,3752),(101202,3753),(101203,3754),(101204,3755),(101205,3757),(101206,3758),(101207,3759),(101208,3760),(101209,3909),(101210,3721),(101211,3727),(101212,3732),(101213,3741),(101214,3743),(101215,3744),(101216,3748),(101217,3749),(101218,3761),(101219,3762),(101220,3765),(101221,3942),(101222,3972),(101223,4080),(101224,4081),(101225,4082),(101226,4083),(101227,4084),(101228,4085),(101229,4089),(101230,4196),(101231,4197),(101232,4198),(101233,4204),(101234,4205),(101235,4206),(101236,4207),(101237,4208),(101238,4209),(101239,4210),(101240,4222),(101241,3894),(101242,3966),(101243,3968),(101244,4187),(101245,4188),(101246,4226),(101247,4227),(101248,4228),(101249,4230),(101250,4231),(101251,4232),(101252,4233),(101253,4235),(101254,4237),(101255,4238),(101256,4250),(101257,4252),(101258,4253),(101259,4275),(101260,4292),(101261,4418),(101262,4425),(101263,4427),(101264,4179),(101265,4180),(101266,4181),(101267,4182),(101268,4183),(101269,4184),(101270,4185),(101271,4189),(101272,4309),(101273,4310),(101274,4316),(101275,4317),(101276,4318),(101277,4319),(101278,4390),(101279,4391),(101280,4393),(101281,4394),(101282,4395),(101283,4396),(101284,4397),(101285,4398),(101286,4399),(101287,4400),(101288,4401),(101289,3715),(101290,3716),(101291,3750),(101292,3827),(101293,3828),(101294,3829),(101295,3830),(101296,3832),(101297,3833),(101298,3834),(101299,3918),(101300,3941),(101301,4087),(101302,4090),(101303,4091),(101304,4195),(101305,4224),(101306,4225),(101307,4236),(101308,3722),(101309,3729),(101310,3893),(101311,3895),(101312,3924),(101313,3925),(101314,3926),(101315,3927),(101316,3928),(101317,3931),(101318,3933),(101319,3934),(101320,3935),(101321,4194),(101322,4251),(101323,4254),(101324,4402),(101325,4403),(101326,4404),(101327,3730),(101328,3738),(101329,3739),(101330,3742),(101331,3747),(101332,3763),(101333,3764),(101334,3831),(101335,3975),(101336,3976),(101337,4052),(101338,4053),(101339,4065),(101340,4086),(101341,4219),(101342,4229),(101343,4276),(101344,4413),(101345,4414),(101346,4415),(101347,4417),(101348,4419),(101349,3981),(101350,3982),(101351,3983),(101352,3984),(101353,3985),(101354,4066),(101355,4069),(101356,4186),(101357,4212),(101358,4218),(101359,4220),(101360,4223),(101361,4282),(101362,4283),(101363,4392),(101364,4437),(101365,4438),(101366,4439),(101367,3756),(101368,4067),(101369,4068),(101370,4307),(101371,4308),(101372,4311),(101373,4312),(101374,3745),(101375,3903),(101376,3967),(101377,3969),(101378,4059),(101379,4060),(101380,4346),(101381,4347),(101382,4349),(101383,4351),(101384,4353),(101385,4355),(101386,4405),(101387,4407),(101388,4408),(101389,4410),(101390,4426),(101391,3718),(101392,3871),(101393,4041),(101394,4167),(101395,4274),(101396,4348),(101397,4350),(101398,4352),(101399,4354),(101400,4356),(101401,4406),(101402,4409),(101403,4411),(101404,4412),(101405,4021),(101406,4022),(101407,4023),(101408,4024),(101409,4025),(101410,4026),(101411,4027),(101412,4028),(101413,4029),(101414,4030),(101415,4031),(101416,4032),(101417,4033),(101418,4034),(101419,4035),(101420,3724),(101421,3733),(101422,3735),(101423,3736),(101424,3740),(101425,3746),(101426,3751),(101427,3755),(101428,3757),(101429,3758),(101430,3759),(101431,3760),(101432,3909),(101433,4036),(101434,4037),(101435,3719),(101436,3720),(101437,3723),(101438,3725),(101439,3726),(101440,3727),(101441,3728),(101442,3731),(101443,3748),(101444,3752),(101445,3753),(101446,3754),(101447,3721),(101448,3732),(101449,3741),(101450,3743),(101451,3744),(101452,3749),(101453,3761),(101454,3762),(101455,3765),(101456,3966),(101457,3968),(101458,4083),(101459,4088),(101460,4204),(101461,4207),(101462,4235),(101463,4237),(101464,4249),(101465,4179),(101466,4180),(101467,4181),(101468,4182),(101469,4183),(101470,4184),(101471,4185),(101472,4187),(101473,4188),(101474,4189),(101475,4250),(101476,4252),(101477,4253),(101478,4255),(101479,4309),(101480,4310),(101481,4316),(101482,4317),(101483,3827),(101484,3828),(101485,3829),(101486,4318),(101487,4390),(101488,4391),(101489,4393),(101490,4394),(101491,4396),(101492,4397),(101493,4398),(101494,4399),(101495,4400),(101496,4401),(101497,3715),(101498,3716),(101499,3722),(101500,3729),(101501,3750),(101502,3830),(101503,3833),(101504,3834),(101505,3925),(101506,3926),(101507,3927),(101508,3928),(101509,3941),(101510,4087),(101511,4090),(101512,4091),(101513,3730),(101514,3738),(101515,3739),(101516,3742),(101517,3747),(101518,3763),(101519,3764),(101520,3831),(101521,3931),(101522,3933),(101523,3934),(101524,3935),(101525,3975),(101526,3976),(101527,4086),(101528,4219),(101529,4229),(101530,4251),(101531,4254),(101532,4404),(101533,4415),(101534,4052),(101535,4053),(101536,4065),(101537,4066),(101538,4069),(101539,4186),(101540,4218),(101541,4220),(101542,4282),(101543,4283),(101544,4392),(101545,4437),(101546,4438),(101547,4439),(101548,3787),(101549,3893),(101550,3894),(101551,3895),(101552,3903),(101553,3925),(101554,3932),(101555,3981),(101556,4081),(101557,4084),(101558,4089),(101559,4195),(101560,4197),(101561,4205),(101562,4210),(101563,4224),(101564,4225),(101565,4230),(101566,4275),(101567,4403),(101568,4407),(101569,4411),(101570,4414),(101571,3972),(101572,4082),(101573,4085),(101574,4196),(101575,4198),(101576,4206),(101577,4209),(101578,4211),(101579,4226),(101580,4227),(101581,4231),(101582,4232),(101583,3918),(101584,3924),(101585,4193),(101586,4194),(101587,4225),(101588,4276),(101589,4292),(101590,4312),(101591,4402),(101592,4405),(101593,4425),(101594,4426),(101595,4427),(101596,3927),(101597,3942),(101598,3985),(101599,4141),(101600,4208),(101601,4222),(101602,4228),(101603,4234),(101604,4236),(101605,4238),(101606,4347),(101607,4348),(101608,4351),(101609,4352),(101610,4355),(101611,4356),(101612,4395),(101613,4410),(101614,4417),(101615,4418),(101616,4419),(101617,4481),(101618,4482),(101619,4483),(101620,4484),(101621,4485),(101622,4486),(101623,4487),(101624,4488),(101625,4489),(101626,4490),(101627,3721),(101628,3723),(101629,3732),(101630,3733),(101631,3746),(101632,3765),(101633,3889),(101634,3966),(101635,3968),(101636,4020),(101637,4080),(101638,4083),(101639,4204),(101640,4207),(101641,4233),(101642,4235),(101643,4237),(101644,4249),(101645,4250),(101646,4252),(101647,4253),(101648,4275),(101649,3785),(101650,3786),(101651,4181),(101652,4255),(101653,4305),(101654,4309),(101655,4310),(101656,4316),(101657,4317),(101658,4318),(101659,4319),(101660,4393),(101661,4394),(101662,4398),(101663,4399),(101664,4400),(101665,4401),(101666,3924),(101667,3941),(101668,4087),(101669,4090),(101670,4091),(101671,4092),(101672,4093),(101673,4095),(101674,4096),(101675,4097),(101676,4162),(101677,4271),(101678,4272),(101679,3739),(101680,3747),(101681,3764),(101682,3861),(101683,3925),(101684,3926),(101685,4065),(101686,4066),(101687,4069),(101688,4086),(101689,4229),(101690,4251),(101691,4254),(101692,4404),(101693,4414),(101694,4415),(101695,4067),(101696,4068),(101697,4075),(101698,4150),(101699,4170),(101700,4171),(101701,4174),(101702,4175),(101703,4203),(101704,4223),(101705,4340),(101706,4392),(101707,4434),(101708,3718),(101709,3967),(101710,3969),(101711,4094),(101712,4256),(101713,4346),(101714,4349),(101715,4353),(101716,4375),(101717,4377),(101718,4385),(101719,4386),(101720,4408),(101721,3930),(101722,4354),(101723,4368),(101724,4369),(101725,4372),(101726,4376),(101727,4379),(101728,4380),(101729,4382),(101730,4387),(101731,4388),(101732,4389),(101733,3719),(101734,3723),(101735,3735),(101736,3736),(101737,3740),(101738,3744),(101739,3746),(101740,3942),(101741,3972),(101742,4035),(101743,4037),(101744,4081),(101745,4082),(101746,4083),(101747,4084),(101748,4085),(101749,4089),(101750,4196),(101751,4197),(101752,4198),(101753,4204),(101754,4205),(101755,4206),(101756,4207),(101757,4208),(101758,4209),(101759,4210),(101760,4222),(101761,4226),(101762,4227),(101763,4228),(101764,4231),(101765,4232),(101766,4233),(101767,4235),(101768,4237),(101769,4238),(101770,4275),(101771,3894),(101772,3966),(101773,3968),(101774,4249),(101775,4250),(101776,4252),(101777,4253),(101778,4255),(101779,4292),(101780,4425),(101781,4179),(101782,4180),(101783,4181),(101784,4182),(101785,4183),(101786,4184),(101787,4309),(101788,4316),(101789,4318),(101790,4390),(101791,4391),(101792,4394),(101793,4418),(101794,4427),(101795,3715),(101796,3750),(101797,3828),(101798,3829),(101799,3830),(101800,3918),(101801,3941),(101802,4090),(101803,4395),(101804,4396),(101805,4398),(101806,4399),(101807,4400),(101808,4401),(101809,3722),(101810,3729),(101811,3893),(101812,3895),(101813,3924),(101814,3925),(101815,3926),(101816,3927),(101817,3928),(101818,3931),(101819,3933),(101820,3934),(101821,3935),(101822,4194),(101823,4195),(101824,4224),(101825,4225),(101826,4234),(101827,4236),(101828,4251),(101829,4254),(101830,3742),(101831,3747),(101832,3831),(101833,3975),(101834,4052),(101835,4053),(101836,4086),(101837,4193),(101838,4229),(101839,4276),(101840,4402),(101841,4403),(101842,4404),(101843,4415),(101844,4417),(101845,4419),(101846,3756),(101847,3981),(101848,4065),(101849,4218),(101850,4220),(101851,4223),(101852,4346),(101853,4347),(101854,4349),(101855,4351),(101856,4353),(101857,4355),(101858,4405),(101859,4407),(101860,4408),(101861,4410),(101862,4438),(101863,4439),(101864,4230),(101865,4021),(101866,4022),(101867,4023),(101868,4024),(101869,4025),(101870,4026),(101871,4027),(101872,4028),(101873,4029),(101874,4030),(101875,4031),(101876,4032),(101877,4033),(101878,4034),(101879,4035),(101880,4036),(101881,4037),(101882,3721),(101883,3723),(101884,3732),(101885,3733),(101886,3746),(101887,3765),(101888,3942),(101889,3972),(101890,4034),(101891,4035),(101892,4036),(101893,4080),(101894,4081),(101895,4083),(101896,4084),(101897,4089),(101898,4181),(101899,4237),(101900,4275),(101901,4292),(101902,4316),(101903,3718),(101904,3739),(101905,3747),(101906,3764),(101907,3871),(101908,3976),(101909,4065),(101910,4066),(101911,4069),(101912,4186),(101913,4282),(101914,4283),(101915,4317),(101916,4350),(101917,4354),(101918,4392),(101919,4393),(101920,4394),(101921,4398),(101922,4399),(101923,4400),(101924,4401),(101925,4406),(101926,4412),(101927,3733),(101928,3746),(101929,3942),(101930,3972),(101931,4080),(101932,4081),(101933,4082),(101934,4083),(101935,4084),(101936,4085),(101937,4089),(101938,4196),(101939,4197),(101940,4198),(101941,4204),(101942,4205),(101943,4206),(101944,4207),(101945,4208),(101946,4209),(101947,4210),(101948,4211),(101949,4222),(101950,3894),(101951,3966),(101952,4226),(101953,4227),(101954,4228),(101955,4230),(101956,4231),(101957,4232),(101958,4233),(101959,4235),(101960,4237),(101961,4238),(101962,4275),(101963,4292),(101964,4425),(101965,3750),(101966,3918),(101967,3941),(101968,3968),(101969,4087),(101970,4090),(101971,4179),(101972,4181),(101973,4183),(101974,4249),(101975,4250),(101976,4252),(101977,4253),(101978,4255),(101979,4309),(101980,4316),(101981,4317),(101982,4318),(101983,4390),(101984,4394),(101985,4395),(101986,4396),(101987,4398),(101988,4400),(101989,4401),(101990,4418),(101991,4427),(101992,3722),(101993,3729),(101994,3831),(101995,3895),(101996,4065),(101997,4066),(101998,4069),(101999,4086),(102000,4193),(102001,4195),(102002,4223),(102003,4224),(102004,4225),(102005,4229),(102006,4234),(102007,4236),(102008,4254),(102009,4276),(102010,4311),(102011,4392),(102012,4402),(102013,4312),(102014,3734),(102015,3735),(102016,3736),(102017,3740),(102018,3751),(102019,3758),(102020,4021),(102021,4022),(102022,4023),(102023,4024),(102024,4025),(102025,4026),(102026,4027),(102027,4028),(102028,4029),(102029,4030),(102030,4031),(102031,4032),(102032,4033),(102033,4037),(102034,3728),(102035,3731),(102036,3741),(102037,3743),(102038,3744),(102039,3752),(102040,3753),(102041,3754),(102042,3755),(102043,3757),(102044,3759),(102045,3760),(102046,3761),(102047,3762),(102048,3909),(102049,3750),(102050,3827),(102051,3828),(102052,3829),(102053,3830),(102054,4179),(102055,4180),(102056,4182),(102057,4183),(102058,4184),(102059,4185),(102060,4187),(102061,4188),(102062,4189),(102063,3715),(102064,3722),(102065,3729),(102066,3730),(102067,3738),(102068,3742),(102069,3763),(102070,3764),(102071,3831),(102072,3832),(102073,3833),(102074,3834),(102075,3975),(102076,3976),(102077,4052),(102078,4053),(102079,4186),(102080,4212),(102081,4219),(102082,4220),(102083,3745),(102084,3756),(102085,4218),(102086,4282),(102087,4283),(102088,4437),(102089,4438),(102090,4439),(102091,3765),(102092,3942),(102093,3972),(102094,4032),(102095,4033),(102096,4035),(102097,4036),(102098,4037),(102099,4081),(102100,4082),(102101,4083),(102102,4084),(102103,4211),(102104,4085),(102105,4089),(102106,4196),(102107,4197),(102108,4198),(102109,4204),(102110,4205),(102111,4206),(102112,4207),(102113,4208),(102114,4209),(102115,4210),(102116,4222),(102117,4226),(102118,4227),(102119,4228),(102120,4230),(102121,4231),(102122,4232),(102123,4233),(102124,4235),(102125,4237),(102126,4238),(102127,4275),(102128,4179),(102129,4180),(102130,4181),(102131,4182),(102132,4187),(102133,4188),(102134,4189),(102135,4292),(102136,4425),(102137,4183),(102138,4184),(102139,4185),(102140,4316),(102141,4317),(102142,4390),(102143,4391),(102144,4393),(102145,4394),(102146,4395),(102147,4396),(102148,4397),(102149,4398),(102150,4399),(102151,4400),(102152,4401),(102153,3918),(102154,3941),(102155,4086),(102156,4087),(102157,4090),(102158,4091),(102159,4195),(102160,4224),(102161,4225),(102162,4229),(102163,4234),(102164,4236),(102165,4065),(102166,3967),(102167,3981),(102168,4066),(102169,4069),(102170,4186),(102171,4392),(102172,4408),(102173,4410),(102174,4426),(102175,4438),(102176,3718),(102177,3969),(102178,4256),(102179,4346),(102180,4347),(102181,4351),(102182,4353),(102183,4355),(102184,4356),(102185,5753),(102186,5753),(102187,5753),(102188,5753),(102189,5753),(102190,5753),(102191,5753),(102192,1165),(102193,1165),(102194,1165),(102195,1165),(102196,1165),(102197,1165),(102198,1165),(102199,1165),(102200,5193),(102201,5193),(102202,5193),(102203,5193),(102204,5193),(102205,5193),(102206,5193),(102207,5193),(102208,5193),(102209,5192),(102210,5192),(102211,5192),(102212,5192),(102213,5192),(102214,5192),(102215,5192),(102216,5192),(102217,5192),(102218,5190),(102219,5190),(102220,5190),(102221,5190),(102222,5190),(102223,5190),(102224,5190),(102225,5190),(102226,5190),(102227,5753),(102228,5753),(102229,5753),(102230,5753),(102231,5753),(102232,5753),(102233,5753),(102234,5753),(102235,5753),(102236,5753),(102237,5753),(102238,5753),(102239,5753),(102240,5753),(102241,5753),(102242,5753),(102243,5753),(102244,5753),(102245,5753),(102246,5753),(102247,5753),(102248,5753),(102249,5753),(102250,5753),(102251,5753),(102252,5753),(102253,5753),(102254,5753),(102255,5753),(102256,5753),(102257,5753),(102258,5753),(102259,5753),(102260,5753),(102261,5753),(102262,5753),(102263,5753),(102264,5753),(102265,5753),(102266,5753),(102267,5753),(102268,5753),(102269,5753),(102270,5753),(102271,5753),(102272,5753),(102273,5753),(102274,5753),(102275,5753),(102276,5753),(102277,5753),(102278,5753),(102279,5753),(102280,5753),(102281,5753),(102282,5753),(102283,5753),(102284,5753),(102285,5753),(102286,5753),(102287,5753),(102288,5753),(102289,5753),(102290,5753),(102291,5753),(102292,5753),(102293,5753),(102294,5753),(102295,5753),(102296,5753),(102297,5753),(102298,5753),(102299,5753),(102300,5753),(102301,5753),(102302,5753),(102303,5753),(102304,5753),(102305,5753),(102306,5753),(102307,5753),(102308,5753),(102309,5753),(102310,5753),(102311,5753),(102312,5753),(102313,5753),(102314,5753),(102315,5753),(102316,5753),(102317,5753),(102318,5753),(102319,5753),(102320,5753),(102321,5753),(102322,5753),(102323,5753),(102324,5753),(102325,5753),(102326,5753),(102327,4127),(102328,4128),(102329,4129),(102330,4130),(102331,4132),(102332,4133),(102333,4135),(102334,4137),(102335,4156),(102336,4297),(102337,4298),(102338,4299),(102339,4300),(102340,4301),(102341,4302),(102342,4303),(102343,4304),(102344,4458),(102345,4459),(102346,1629),(102347,3884),(102348,3905),(102349,3970),(102350,3980),(102351,4062),(102352,4121),(102353,4122),(102354,4123),(102355,4259),(102356,4270),(102357,4063),(102358,4070),(102359,4124),(102360,4215),(102361,4364),(102362,4366),(102363,4460),(102364,4461),(102365,4462),(102366,4467),(102367,4470),(102368,1640),(102369,1641),(102370,1642),(102371,3875),(102372,3876),(102373,3877),(102374,3878),(102375,3880),(102376,3977),(102377,4469),(102378,4474),(102379,4475),(102380,4243),(102381,4244),(102382,4245),(102383,4294),(102384,4295),(102385,4296),(102386,4436),(102387,4444),(102388,4446),(102389,4447),(102390,4448),(102391,4449),(102392,4450),(102393,3870),(102394,3892),(102395,3964),(102396,3965),(102397,3979),(102398,4172),(102399,4173),(102400,4451),(102401,4452),(102402,4453),(102403,4454),(102404,4455),(102405,4456),(102406,4202),(102407,4216),(102408,4217),(102409,4257),(102410,4277),(102411,4278),(102412,4279),(102413,4280),(102414,4281),(102415,4287),(102416,4288),(102417,4289),(102418,4290),(102419,4315),(102420,4342),(102421,4343),(102422,4441),(102423,1632),(102424,4239),(102425,4240),(102426,4241),(102427,4442),(102428,4443),(102429,4445),(102430,4473),(102431,4476),(102432,4480),(102433,1630),(102434,1631),(102435,1633),(102436,1634),(102437,1635),(102438,1681),(102439,1682),(102440,1683),(102441,1684),(102442,1685),(102443,1686),(102444,3903),(102445,1638),(102446,1639),(102447,1645),(102448,3768),(102449,3771),(102450,3882),(102451,3973),(102452,4152),(102453,4153),(102454,4154),(102455,4168),(102456,4337),(102457,4338),(102458,4339),(102459,1568),(102460,1569),(102461,1570),(102462,1571),(102463,1572),(102464,1573),(102465,1636),(102466,1637),(102467,1643),(102468,1644),(102469,1574),(102470,1646),(102471,1647),(102472,1648),(102473,1649),(102474,4145),(102475,4146),(102476,4148),(102477,4149),(102478,4248),(102479,4359),(102480,4127),(102481,4128),(102482,4129),(102483,4130),(102484,4132),(102485,4133),(102486,4135),(102487,4137),(102488,4156),(102489,4297),(102490,4298),(102491,4299),(102492,4300),(102493,4301),(102494,1640),(102495,1641),(102496,3977),(102497,3978),(102498,4302),(102499,4303),(102500,4304),(102501,4458),(102502,4459),(102503,1642),(102504,3875),(102505,3876),(102506,3877),(102507,3878),(102508,3879),(102509,3880),(102510,4243),(102511,4244),(102512,4245),(102513,4294),(102514,4295),(102515,4296),(102516,4436),(102517,4444),(102518,4446),(102519,4447),(102520,3892),(102521,4448),(102522,4449),(102523,4450),(102524,4451),(102525,4452),(102526,4453),(102527,4454),(102528,4455),(102529,4456),(102530,3870),(102531,3964),(102532,3965),(102533,4172),(102534,4173),(102535,4202),(102536,4257),(102537,4277),(102538,4278),(102539,4279),(102540,4280),(102541,4281),(102542,4287),(102543,1632),(102544,1635),(102545,1683),(102546,1686),(102547,4288),(102548,4289),(102549,4290),(102550,4342),(102551,4343),(102552,4441),(102553,4442),(102554,4443),(102555,4445),(102556,1568),(102557,1569),(102558,1570),(102559,1571),(102560,1572),(102561,3882),(102562,3903),(102563,3973),(102564,4152),(102565,1573),(102566,1574),(102567,4145),(102568,4146),(102569,4148),(102570,4149),(102571,3884),(102572,3905),(102573,3970),(102574,4062),(102575,4121),(102576,4259),(102577,4270),(102578,4422),(102579,1630),(102580,1633),(102581,4063),(102582,4070),(102583,4215),(102584,4239),(102585,4241),(102586,4460),(102587,4473),(102588,4476),(102589,4480),(102590,1681),(102591,1684),(102592,3768),(102593,3771),(102594,4127),(102595,4128),(102596,4129),(102597,4130),(102598,4132),(102599,4133),(102600,4135),(102601,4137),(102602,4156),(102603,4297),(102604,4298),(102605,4299),(102606,4300),(102607,4301),(102608,1640),(102609,1641),(102610,1642),(102611,3875),(102612,3876),(102613,3877),(102614,3878),(102615,3879),(102616,3880),(102617,3978),(102618,4243),(102619,4244),(102620,4245),(102621,4294),(102622,4295),(102623,4296),(102624,4302),(102625,4303),(102626,4304),(102627,4436),(102628,4444),(102629,4446),(102630,4458),(102631,4459),(102632,3870),(102633,3892),(102634,3964),(102635,3965),(102636,4170),(102637,4171),(102638,4447),(102639,4448),(102640,4449),(102641,4450),(102642,4451),(102643,4452),(102644,4453),(102645,4454),(102646,4455),(102647,4456),(102648,4172),(102649,4173),(102650,4174),(102651,4202),(102652,4257),(102653,4277),(102654,4278),(102655,4279),(102656,4280),(102657,4281),(102658,4287),(102659,4288),(102660,4289),(102661,4290),(102662,4342),(102663,4343),(102664,1568),(102665,1569),(102666,1570),(102667,1636),(102668,1637),(102669,1638),(102670,1639),(102671,1643),(102672,1644),(102673,1645),(102674,3903),(102675,3973),(102676,4153),(102677,4154),(102678,4168),(102679,4337),(102680,4338),(102681,4339),(102682,4441),(102683,4442),(102684,4443),(102685,4445),(102686,1571),(102687,1572),(102688,1573),(102689,1574),(102690,1646),(102691,1647),(102692,1648),(102693,1649),(102694,4141),(102695,4146),(102696,4148),(102697,4149),(102698,1631),(102699,1634),(102700,1682),(102701,1685),(102702,4122),(102703,4123),(102704,4124),(102705,4216),(102706,4217),(102707,4315),(102708,4364),(102709,4366),(102710,4461),(102711,4462),(102712,4467),(102713,4469),(102714,4470),(102715,4474),(102716,4475),(102717,3889),(102718,4013),(102719,4014),(102720,4015),(102721,4016),(102722,4017),(102723,4018),(102724,4019),(102725,4020),(102726,3917),(102727,3974),(102728,4247),(102729,4336),(102730,3885),(102731,3919),(102732,4360),(102733,3785),(102734,3786),(102735,3920),(102736,3921),(102737,3922),(102738,4062),(102739,4092),(102740,4093),(102741,4096),(102742,4097),(102743,4120),(102744,4151),(102745,4305),(102746,4460),(102747,4043),(102748,4095),(102749,4162),(102750,4199),(102751,4200),(102752,4271),(102753,4272),(102754,4273),(102755,4313),(102756,4314),(102757,4430),(102758,4431),(102759,4457),(102760,4214),(102761,4306),(102762,4358),(102763,3874),(102764,3963),(102765,3986),(102766,3987),(102767,3988),(102768,4012),(102769,4291),(102770,3767),(102771,3773),(102772,3774),(102773,3868),(102774,3904),(102775,3923),(102776,3929),(102777,3936),(102778,4039),(102779,4094),(102780,4143),(102781,4293),(102782,4385),(102783,4468),(102784,3908),(102785,3930),(102786,3932),(102787,3937),(102788,3938),(102789,4040),(102790,4044),(102791,4125),(102792,4178),(102793,4213),(102794,4320),(102795,4322),(102796,4323),(102797,4324),(102798,4325),(102799,4345),(102800,4368),(102801,4372),(102802,4375),(102803,4376),(102804,4379),(102805,4382),(102806,4383),(102807,4384),(102808,4386),(102809,3872),(102810,3873),(102811,3944),(102812,3946),(102813,3948),(102814,3949),(102815,3951),(102816,3952),(102817,3953),(102818,3954),(102819,3960),(102820,4076),(102821,4341),(102822,4416),(102823,3943),(102824,3945),(102825,3947),(102826,3950),(102827,3955),(102828,3956),(102829,3957),(102830,3958),(102831,3959),(102832,3961),(102833,4108),(102834,3885),(102835,3919),(102836,3920),(102837,3921),(102838,3922),(102839,3974),(102840,4013),(102841,4014),(102842,4015),(102843,4016),(102844,4191),(102845,4192),(102846,4215),(102847,4336),(102848,3767),(102849,3923),(102850,3936),(102851,4043),(102852,4094),(102853,4120),(102854,4162),(102855,4271),(102856,4272),(102857,4291),(102858,4305),(102859,4306),(102860,4313),(102861,4314),(102862,4358),(102863,4430),(102864,4431),(102865,3773),(102866,3774),(102867,3872),(102868,3873),(102869,3904),(102870,3930),(102871,3989),(102872,4039),(102873,4079),(102874,4293),(102875,4341),(102876,4416),(102877,4424),(102878,4468),(102879,3943),(102880,3944),(102881,3946),(102882,3947),(102883,3948),(102884,3949),(102885,3950),(102886,3951),(102887,3952),(102888,3953),(102889,3954),(102890,3955),(102891,3956),(102892,3957),(102893,3958),(102894,3959),(102895,3960),(102896,4108),(102897,3768),(102898,3771),(102899,3884),(102900,3905),(102901,3970),(102902,4062),(102903,4063),(102904,4070),(102905,4121),(102906,4215),(102907,4239),(102908,4241),(102909,4259),(102910,4270),(102911,4422),(102912,4460),(102913,4473),(102914,4476),(102915,3769),(102916,3874),(102917,4012),(102918,4054),(102919,4055),(102920,4075),(102921,4077),(102922,4078),(102923,4094),(102924,4097),(102925,4142),(102926,4143),(102927,4150),(102928,4151),(102929,4199),(102930,4200),(102931,4201),(102932,3770),(102933,3787),(102934,3932),(102935,3944),(102936,3946),(102937,3948),(102938,3949),(102939,3951),(102940,3952),(102941,3953),(102942,3954),(102943,3960),(102944,4076),(102945,4341),(102946,4375),(102947,4385),(102948,4386),(102949,4388),(102950,4468),(102951,3943),(102952,3945),(102953,3947),(102954,3950),(102955,3955),(102956,3958),(102957,3961),(102958,4108),(102959,3986),(102960,3987),(102961,3988),(102962,4012),(102963,4013),(102964,4014),(102965,4015),(102966,4016),(102967,4017),(102968,4018),(102969,4019),(102970,4020),(102971,4097),(102972,4341),(102973,4416),(102974,3776),(102975,3777),(102976,3778),(102977,3779),(102978,3780),(102979,3781),(102980,3782),(102981,3783),(102982,3788),(102983,3789),(102984,3790),(102985,3791),(102986,3792),(102987,3793),(102988,3794),(102989,3795),(102990,3796),(102991,3797),(102992,3798),(102993,3799),(102994,3800),(102995,3801),(102996,3802),(102997,3803),(102998,3804),(102999,3805),(103000,3806),(103001,3807),(103002,3808),(103003,3809),(103004,3810),(103005,3811),(103006,3812),(103007,3813),(103008,3814),(103009,3815),(103010,3816),(103011,3817),(103012,3818),(103013,3820),(103014,3821),(103015,3822),(103016,3823),(103017,3824),(103018,3825),(103019,3826),(103020,3836),(103021,3837),(103022,3838),(103023,3839),(103024,3840),(103025,3841),(103026,3847),(103027,3852),(103028,3853),(103029,3854),(103030,3857),(103031,3890),(103032,3849),(103033,3855),(103034,3856),(103035,3858),(103036,3859),(103037,4326),(103038,4327),(103039,4328),(103040,4330),(103041,4331),(103042,4332),(103043,4333),(103044,4335),(103045,3842),(103046,3846),(103047,3848),(103048,3850),(103049,3851),(103050,3887),(103051,3910),(103052,3911),(103053,3912),(103054,4057),(103055,4064),(103056,4329),(103057,4334),(103058,1),(103059,2),(103060,5),(103061,6),(103062,1162),(103063,1163),(103064,1164),(103065,1165),(103066,3128),(103067,3130),(103068,3133),(103069,3172),(103070,3134),(103071,3136),(103072,3137),(103073,3138),(103074,3139),(103075,3145),(103076,3150),(103077,3151),(103078,3155),(103079,3407),(103080,2704),(103081,2705),(103082,2731),(103083,3153),(103084,3160),(103085,3161),(103086,3162),(103087,3163),(103088,3713),(103089,2924),(103090,2927),(103091,2928),(103092,2931),(103093,2932),(103094,2933),(103095,2934),(103096,2935),(103097,2936),(103098,2937),(103099,2988),(103100,3164),(103101,3165),(103102,2938),(103103,2939),(103104,2940),(103105,2941),(103106,3102),(103107,3133),(103108,3134),(103109,3136),(103110,3137),(103111,3138),(103112,3139),(103113,3145),(103114,3150),(103115,3151),(103116,3157),(103117,3166),(103118,2704),(103119,2705),(103120,2731),(103121,2732),(103122,2733),(103123,2734),(103124,2735),(103125,2736),(103126,2737),(103127,2738),(103128,2739),(103129,3160),(103130,3161),(103131,3162),(103132,3163),(103133,2740),(103134,2741),(103135,2742),(103136,2743),(103137,2744),(103138,2745),(103139,2746),(103140,2747),(103141,2748),(103142,2749),(103143,2750),(103144,2751),(103145,2752),(103146,2753),(103147,2754),(103148,2755),(103149,2756),(103150,2757),(103151,2758),(103152,2759),(103153,3118),(103154,3131),(103155,3153),(103156,3623),(103157,3713),(103158,2942),(103159,2944),(103160,3153),(103161,3534),(103162,3535),(103163,3536),(103164,3675),(103165,3676),(103166,3677),(103167,3678),(103168,3679),(103169,3680),(103170,3681),(103171,3682),(103172,3683),(103173,2700),(103174,2866),(103175,2867),(103176,2919),(103177,2920),(103178,2655),(103179,2656),(103180,2657),(103181,2759),(103182,2766),(103183,2767),(103184,2768),(103185,2769),(103186,2770),(103187,2771),(103188,2970),(103189,3131),(103190,2796),(103191,3042),(103192,3169),(103193,3336),(103194,3391),(103195,2864),(103196,2887),(103197,2888),(103198,2911),(103199,3036),(103200,3048),(103201,3078),(103202,3108),(103203,3537),(103204,3543),(103205,3561),(103206,3621),(103207,3671),(103208,2655),(103209,2656),(103210,2657),(103211,2767),(103212,2768),(103213,2781),(103214,2794),(103215,2833),(103216,2835),(103217,2837),(103218,2838),(103219,2894),(103220,2895),(103221,2896),(103222,2978),(103223,2991),(103224,3052),(103225,3167),(103226,3168),(103227,2771),(103228,2971),(103229,2972),(103230,2973),(103231,2974),(103232,2975),(103233,2993),(103234,2994),(103235,2995),(103236,2996),(103237,3504),(103238,3505),(103239,3507),(103240,3508),(103241,2932),(103242,2939),(103243,2947),(103244,2948),(103245,2949),(103246,2950),(103247,3407),(103248,3509),(103249,3510),(103250,3511),(103251,3512),(103252,3513),(103253,3514),(103254,3711),(103255,2724),(103256,2748),(103257,2755),(103258,2782),(103259,2793),(103260,2807),(103261,2809),(103262,2811),(103263,2813),(103264,2817),(103265,2819),(103266,3136),(103267,3137),(103268,3150),(103269,3151),(103270,3156),(103271,3160),(103272,3161),(103273,3184),(103274,3214),(103275,3488),(103276,3623),(103277,2699),(103278,2925),(103279,2926),(103280,2929),(103281,2930),(103282,2943),(103283,2945),(103284,2979),(103285,2980),(103286,3042),(103287,3128),(103288,3172),(103289,2740),(103290,2741),(103291,2742),(103292,2743),(103293,2749),(103294,2750),(103295,2751),(103296,2753),(103297,2754),(103298,2757),(103299,2758),(103300,2800),(103301,2812),(103302,3118),(103303,3130),(103304,3131),(103305,3157),(103306,3407),(103307,3623),(103308,3714),(103309,2765),(103310,2798),(103311,2821),(103312,2856),(103313,2886),(103314,2893),(103315,2900),(103316,2904),(103317,2955),(103318,3543),(103319,3548),(103320,3620),(103321,3673),(103322,3674),(103323,2828),(103324,2829),(103325,2843),(103326,2858),(103327,2863),(103328,2891),(103329,2978),(103330,2987),(103331,2989),(103332,2990),(103333,2998),(103334,3539),(103335,3540),(103336,2999),(103337,3000),(103338,3001),(103339,3002),(103340,3003),(103341,3004),(103342,3005),(103343,3006),(103344,3007),(103345,3490),(103346,3491),(103347,3492),(103348,3493),(103349,3494),(103350,3495),(103351,3496),(103352,3497),(103353,3498),(103354,3499),(103355,3500),(103356,3501),(103357,3502),(103358,3503),(103359,3573),(103360,3574),(103361,3575),(103362,3576),(103363,3577),(103364,3578),(103365,3579),(103366,3580),(103367,3583),(103368,3592),(103369,3593),(103370,3594),(103371,3595),(103372,3596),(103373,3597),(103374,3598),(103375,3599),(103376,3600),(103377,3601),(103378,3602),(103379,3603),(103380,3604),(103381,3605),(103382,3606),(103383,3607),(103384,3608),(103385,3609),(103386,3686),(103387,3687),(103388,3688),(103389,3689),(103390,3690),(103391,3691),(103392,3692),(103393,3693),(103394,3694),(103395,3695),(103396,3696),(103397,3697),(103398,3698),(103399,3699),(103400,3700),(103401,3701),(103402,3702),(103403,3703),(103404,2699),(103405,2923),(103406,2925),(103407,2926),(103408,2929),(103409,2930),(103410,2943),(103411,2945),(103412,2979),(103413,3704),(103414,3705),(103415,3706),(103416,3707),(103417,3708),(103418,3709),(103419,3710),(103420,2703),(103421,2980),(103422,3042),(103423,2890),(103424,2899),(103425,2917),(103426,2976),(103427,3012),(103428,3128),(103429,3130),(103430,3142),(103431,3146),(103432,3149),(103433,3152),(103434,3154),(103435,3155),(103436,3156),(103437,3172),(103438,3184),(103439,3214),(103440,3407),(103441,3479),(103442,3480),(103443,3488),(103444,2708),(103445,2711),(103446,2712),(103447,2713),(103448,2714),(103449,2717),(103450,2721),(103451,2722),(103452,2723),(103453,2730),(103454,2799),(103455,2800),(103456,2801),(103457,2802),(103458,2918),(103459,3043),(103460,3489),(103461,2677),(103462,2803),(103463,2804),(103464,2810),(103465,2812),(103466,2815),(103467,3126),(103468,3132),(103469,3135),(103470,3140),(103471,3143),(103472,3144),(103473,3147),(103474,3148),(103475,3159),(103476,3421),(103477,3714),(103478,2828),(103479,2842),(103480,2843),(103481,2987),(103482,3479),(103483,3539),(103484,2856),(103485,2893),(103486,2912),(103487,2955),(103488,3037),(103489,3049),(103490,3077),(103491,3079),(103492,3109),(103493,3538),(103494,3543),(103495,3548),(103496,3571),(103497,3620),(103498,3674),(103499,2765),(103500,2796),(103501,2797),(103502,2798),(103503,2857),(103504,2865),(103505,2886),(103506,2889),(103507,2894),(103508,2900),(103509,2988),(103510,2992),(103511,3019),(103512,3562),(103513,3622),(103514,3672),(103515,3673),(103516,2828),(103517,2829),(103518,2834),(103519,2836),(103520,2839),(103521,2843),(103522,2858),(103523,2863),(103524,2897),(103525,2898),(103526,2978),(103527,2987),(103528,2989),(103529,2990),(103530,2997),(103531,3008),(103532,3053),(103533,3054),(103534,3539),(103535,3540),(103536,3541),(103537,3542),(103538,3648),(103539,3009),(103540,3010),(103541,3011),(103542,3490),(103543,3491),(103544,3492),(103545,3493),(103546,3494),(103547,3495),(103548,3496),(103549,3497),(103550,3498),(103551,3499),(103552,3500),(103553,3501),(103554,3502),(103555,3503),(103556,3515),(103557,3516),(103558,3517),(103559,3518),(103560,3519),(103561,3520),(103562,3521),(103563,3522),(103564,3523),(103565,3524),(103566,3525),(103567,3526),(103568,3527),(103569,3573),(103570,2924),(103571,2927),(103572,2928),(103573,2931),(103574,2933),(103575,2934),(103576,2935),(103577,2936),(103578,3164),(103579,3165),(103580,3574),(103581,3575),(103582,3576),(103583,3577),(103584,3578),(103585,3579),(103586,3580),(103587,3583),(103588,3701),(103589,3712),(103590,2703),(103591,2937),(103592,2938),(103593,2940),(103594,2941),(103595,2948),(103596,2949),(103597,2951),(103598,2952),(103599,2953),(103600,2954),(103601,3166),(103602,2795),(103603,2830),(103604,2890),(103605,2899),(103606,2917),(103607,2976),(103608,3012),(103609,3102),(103610,3127),(103611,3128),(103612,3130),(103613,3133),(103614,3134),(103615,3138),(103616,3139),(103617,3141),(103618,3142),(103619,3145),(103620,3146),(103621,3172),(103622,3149),(103623,3152),(103624,3154),(103625,3155),(103626,3156),(103627,3157),(103628,3162),(103629,3163),(103630,3169),(103631,3214),(103632,3336),(103633,3342),(103634,3388),(103635,3488),(103636,2704),(103637,2705),(103638,2706),(103639,2707),(103640,2708),(103641,2709),(103642,2710),(103643,2711),(103644,2712),(103645,2713),(103646,2714),(103647,2715),(103648,2716),(103649,2717),(103650,2718),(103651,2719),(103652,2720),(103653,2721),(103654,2722),(103655,2723),(103656,2725),(103657,3158),(103658,3277),(103659,3479),(103660,3480),(103661,2726),(103662,2727),(103663,2728),(103664,2729),(103665,2730),(103666,2731),(103667,2732),(103668,2733),(103669,2734),(103670,2735),(103671,2736),(103672,2737),(103673,2738),(103674,2739),(103675,2744),(103676,2745),(103677,2746),(103678,2747),(103679,2740),(103680,2750),(103681,2752),(103682,2753),(103683,2754),(103684,2756),(103685,2757),(103686,2758),(103687,2759),(103688,2799),(103689,2800),(103690,2801),(103691,2802),(103692,2803),(103693,2804),(103694,2805),(103695,2806),(103696,2807),(103697,2808),(103698,2809),(103699,2810),(103700,2812),(103701,2814),(103702,2815),(103703,2816),(103704,2818),(103705,2820),(103706,2970),(103707,2977),(103708,3050),(103709,3051),(103710,3055),(103711,3125),(103712,3140),(103713,3144),(103714,3147),(103715,3148),(103716,3713),(103717,3714),(103718,2),(103719,4),(103720,1162),(103721,1163),(103722,1164),(103723,1165),(103724,400),(103725,480),(103726,482),(103727,515),(103728,48),(103729,48),(103730,48),(103731,48),(103732,48),(103733,48),(103734,48),(103735,48),(103736,48),(103737,48),(103738,48),(103739,48),(103740,48),(103741,48),(103742,48),(103743,48),(103744,48),(103745,48),(103746,48),(103747,48),(103748,48),(103749,499),(103750,659),(103751,687),(103752,695),(103753,697),(103754,906),(103755,913),(103756,914),(103757,1004),(103758,1019),(103759,1038),(103760,1092),(103761,1119),(103762,882),(103763,884),(103764,885),(103765,886),(103766,887),(103767,888),(103768,889),(103769,890),(103770,891),(103771,892),(103772,893),(103773,894),(103774,895),(103775,896),(103776,897),(103777,898),(103778,899),(103779,900),(103780,901),(103781,915),(103782,1166),(103783,1167),(103784,321),(103785,342),(103786,418),(103787,436),(103788,542),(103789,543),(103790,553),(103791,766),(103792,809),(103793,843),(103794,1169),(103795,312),(103796,314),(103797,317),(103798,319),(103799,320),(103800,322),(103801,323),(103802,701),(103803,707),(103804,708),(103805,907),(103806,911),(103807,916),(103808,996),(103809,1002),(103810,1034),(103811,917),(103812,918),(103813,919),(103814,920),(103815,921),(103816,922),(103817,923),(103818,928),(103819,929),(103820,931),(103821,934),(103822,936),(103823,937),(103824,938),(103825,939),(103826,942),(103827,948),(103828,949),(103829,950),(103830,951),(103831,952),(103832,953),(103833,954),(103834,955),(103835,956),(103836,957),(103837,958),(103838,959),(103839,960),(103840,961),(103841,962),(103842,963),(103843,964),(103844,965),(103845,966),(103846,967),(103847,973),(103848,974),(103849,975),(103850,976),(103851,977),(103852,978),(103853,979),(103854,980),(103855,981),(103856,982),(103857,983),(103858,984),(103859,985),(103860,986),(103861,987),(103862,992),(103863,993),(103864,994),(103865,995),(103866,1007),(103867,1109),(103868,1115),(103869,1122),(103870,1123),(103871,1136),(103872,1137),(103873,1138),(103874,308),(103875,346),(103876,699),(103877,718),(103878,719),(103879,720),(103880,722),(103881,723),(103882,724),(103883,738),(103884,739),(103885,740),(103886,1003),(103887,1005),(103888,1035),(103889,1039),(103890,1139),(103891,5752),(103892,301),(103893,311),(103894,324),(103895,326),(103896,328),(103897,330),(103898,332),(103899,333),(103900,336),(103901,337),(103902,636),(103903,743),(103904,744),(103905,745),(103906,746),(103907,869),(103908,875),(103909,878),(103910,879),(103911,883),(103912,334),(103913,335),(103914,338),(103915,344),(103916,692),(103917,702),(103918,703),(103919,704),(103920,706),(103921,711),(103922,713),(103923,714),(103924,732),(103925,733),(103926,734),(103927,737),(103928,741),(103929,742),(103930,748),(103931,749),(103932,747),(103933,1021),(103934,1037),(103935,48),(103936,48),(103937,48),(103938,48),(103939,48),(103940,294),(103941,659),(103942,1004),(103943,319),(103944,320),(103945,687),(103946,707),(103947,1012),(103948,1019),(103949,1092),(103950,312),(103951,314),(103952,322),(103953,323),(103954,618),(103955,907),(103956,308),(103957,346),(103958,632),(103959,699),(103960,718),(103961,719),(103962,720),(103963,722),(103964,723),(103965,724),(103966,738),(103967,739),(103968,740),(103969,1003),(103970,1005),(103971,1035),(103972,301),(103973,311),(103974,332),(103975,333),(103976,336),(103977,337),(103978,347),(103979,636),(103980,743),(103981,334),(103982,335),(103983,338),(103984,339),(103985,340),(103986,344),(103987,345),(103988,744),(103989,745),(103990,746),(103991,903),(103992,904),(103993,905),(103994,692),(103995,702),(103996,703),(103997,704),(103998,706),(103999,711),(104000,713),(104001,714),(104002,732),(104003,733),(104004,734),(104005,737),(104006,741),(104007,742),(104008,748),(104009,749),(104010,721),(104011,725),(104012,747),(104013,1037),(104014,296),(104015,374),(104016,375),(104017,376),(104018,527),(104019,528),(104020,529),(104021,531),(104022,557),(104023,560),(104024,587),(104025,646),(104026,588),(104027,589),(104028,590),(104029,591),(104030,592),(104031,611),(104032,613),(104033,617),(104034,619),(104035,624),(104036,637),(104037,639),(104038,639),(104039,648),(104040,652),(104041,670),(104042,672),(104043,778),(104044,779),(104045,834),(104046,835),(104047,836),(104048,837),(104049,838),(104050,839),(104051,639),(104052,648),(104053,652),(104054,670),(104055,672),(104056,778),(104057,779),(104058,834),(104059,835),(104060,836),(104061,837),(104062,838),(104063,839),(104064,281),(104065,284),(104066,648),(104067,652),(104068,670),(104069,672),(104070,778),(104071,779),(104072,834),(104073,835),(104074,836),(104075,837),(104076,838),(104077,839),(104078,840),(104079,286),(104080,287),(104081,289),(104082,291),(104083,292),(104084,294),(104085,297),(104086,530),(104087,532),(104088,625),(104089,660),(104090,691),(104091,693),(104092,694),(104093,906),(104094,997),(104095,998),(104096,999),(104097,1001),(104098,1036),(104099,299),(104100,304),(104101,307),(104102,682),(104103,688),(104104,690),(104105,696),(104106,1000),(104107,1067),(104108,1068),(104109,1069),(104110,1070),(104111,1072),(104112,1073),(104113,1074),(104114,1075),(104115,1133),(104116,298),(104117,300),(104118,321),(104119,342),(104120,687),(104121,695),(104122,697),(104123,698),(104124,700),(104125,705),(104126,1004),(104127,1012),(104128,1019),(104129,1038),(104130,1092),(104131,1119),(104132,317),(104133,319),(104134,320),(104135,322),(104136,323),(104137,701),(104138,707),(104139,708),(104140,907),(104141,996),(104142,1034),(104143,308),(104144,312),(104145,314),(104146,346),(104147,618),(104148,632),(104149,699),(104150,718),(104151,722),(104152,724),(104153,738),(104154,739),(104155,301),(104156,332),(104157,336),(104158,347),(104159,636),(104160,719),(104161,720),(104162,723),(104163,740),(104164,1003),(104165,1005),(104166,1035),(104167,311),(104168,333),(104169,334),(104170,335),(104171,337),(104172,338),(104173,339),(104174,340),(104175,743),(104176,744),(104177,745),(104178,746),(104179,903),(104180,904),(104181,905),(104182,344),(104183,345),(104184,702),(104185,704),(104186,706),(104187,711),(104188,732),(104189,733),(104190,734),(104191,737),(104192,741),(104193,742),(104194,748),(104195,749),(104196,692),(104197,703),(104198,713),(104199,714),(104200,725),(104201,747),(104202,1037),(104203,718),(104204,721),(104205,725),(104206,747),(104207,319),(104208,1060),(104209,1062),(104210,1064),(104211,1061),(104212,469),(104213,558),(104214,559),(104215,596),(104216,597),(104217,600),(104218,601),(104219,614),(104220,615),(104221,645),(104222,650),(104223,651),(104224,656),(104225,664),(104226,771),(104227,772),(104228,780),(104229,815),(104230,855),(104231,856),(104232,470),(104233,518),(104234,599),(104235,753),(104236,814),(104237,875),(104238,902),(104239,936),(104240,937),(104241,938),(104242,939),(104243,980),(104244,981),(104245,982),(104246,983),(104247,1028),(104248,1050),(104249,878),(104250,879),(104251,1021),(104252,553),(104253,913),(104254,914),(104255,915),(104256,957),(104257,958),(104258,959),(104259,1021),(104260,1089),(104261,399),(104262,400),(104263,402),(104264,403),(104265,421),(104266,460),(104267,461),(104268,462),(104269,480),(104270,481),(104271,482),(104272,499),(104273,514),(104274,515),(104275,521),(104276,526),(104277,662),(104278,665),(104279,668),(104280,669),(104281,407),(104282,411),(104283,412),(104284,413),(104285,414),(104286,422),(104287,423),(104288,425),(104289,430),(104290,472),(104291,473),(104292,500),(104293,501),(104294,502),(104295,517),(104296,524),(104297,661),(104298,663),(104299,666),(104300,667),(104301,348),(104302,349),(104303,350),(104304,353),(104305,354),(104306,355),(104307,359),(104308,522),(104309,602),(104310,603),(104311,604),(104312,605),(104313,606),(104314,607),(104315,608),(104316,609),(104317,776),(104318,777),(104319,781),(104320,785),(104321,788),(104322,791),(104323,561),(104324,564),(104325,569),(104326,584),(104327,782),(104328,783),(104329,784),(104330,786),(104331,787),(104332,789),(104333,790),(104334,794),(104335,798),(104336,799),(104337,800),(104338,801),(104339,802),(104340,803),(104341,804),(104342,360),(104343,389),(104344,390),(104345,396),(104346,397),(104347,562),(104348,563),(104349,565),(104350,566),(104351,567),(104352,568),(104353,583),(104354,816),(104355,817),(104356,821),(104357,822),(104358,823),(104359,824),(104360,830),(104361,831),(104362,832),(104363,833),(104364,858),(104365,859),(104366,860),(104367,863),(104368,864),(104369,865),(104370,867),(104371,857),(104372,862),(104373,866),(104374,868),(104375,924),(104376,926),(104377,930),(104378,1006),(104379,1015),(104380,1025),(104381,1026),(104382,1053),(104383,1057),(104384,1112),(104385,1118),(104386,1127),(104387,418),(104388,436),(104389,553),(104390,928),(104391,929),(104392,931),(104393,946),(104394,957),(104395,958),(104396,959),(104397,960),(104398,961),(104399,962),(104400,963),(104401,964),(104402,965),(104403,966),(104404,967),(104405,1059),(104406,1079),(104407,1081),(104408,1083),(104409,1084),(104410,1087),(104411,1089),(104412,311),(104413,332),(104414,333),(104415,336),(104416,337),(104417,878),(104418,879),(104419,970),(104420,971),(104421,973),(104422,974),(104423,975),(104424,988),(104425,1008),(104426,1021),(104427,1094),(104428,1101),(104429,1109),(104430,1115),(104431,1122),(104432,1135),(104433,435),(104434,437),(104435,447),(104436,460),(104437,461),(104438,472),(104439,502),(104440,504),(104441,507),(104442,537),(104443,538),(104444,598),(104445,616),(104446,643),(104447,644),(104448,661),(104449,662),(104450,665),(104451,667),(104452,668),(104453,669),(104454,774),(104455,775),(104456,1040),(104457,351),(104458,352),(104459,356),(104460,357),(104461,361),(104462,471),(104463,473),(104464,605),(104465,609),(104466,635),(104467,671),(104468,675),(104469,676),(104470,678),(104471,679),(104472,776),(104473,777),(104474,788),(104475,358),(104476,565),(104477,566),(104478,750),(104479,787),(104480,794),(104481,798),(104482,799),(104483,803),(104484,804),(104485,821),(104486,822),(104487,830),(104488,857),(104489,858),(104490,866),(104491,1041),(104492,751),(104493,917),(104494,919),(104495,921),(104496,923),(104497,925),(104498,927),(104499,929),(104500,931),(104501,969),(104502,971),(104503,973),(104504,975),(104505,1043),(104506,474),(104507,475),(104508,514),(104509,564),(104510,862),(104511,1044),(104512,1045),(104513,362),(104514,363),(104515,364),(104516,365),(104517,366),(104518,367),(104519,368),(104520,369),(104521,370),(104522,371),(104523,372),(104524,373),(104525,570),(104526,793),(104527,861),(104528,944),(104529,945),(104530,947),(104531,1112),(104532,1118),(104533,626),(104534,629),(104535,630),(104536,946),(104537,988),(104538,989),(104539,990),(104540,991),(104541,519),(104542,520),(104543,523),(104544,525),(104545,916),(104546,1014),(104547,1032),(104548,1040),(104549,1043),(104550,1052),(104551,1056),(104552,1058),(104553,1078),(104554,1080),(104555,1086),(104556,1111),(104557,1117),(104558,1126),(104559,917),(104560,918),(104561,919),(104562,920),(104563,921),(104564,922),(104565,923),(104566,960),(104567,961),(104568,962),(104569,963),(104570,964),(104571,965),(104572,966),(104573,967),(104574,1007),(104575,1093),(104576,1100),(104577,1124),(104578,1134),(104579,400),(104580,480),(104581,482),(104582,499),(104583,515),(104584,882),(104585,884),(104586,885),(104587,886),(104588,887),(104589,890),(104590,892),(104591,894),(104592,895),(104593,898),(104594,899),(104595,1022),(104596,1023),(104597,1106),(104598,458),(104599,883),(104600,888),(104601,889),(104602,891),(104603,893),(104604,896),(104605,897),(104606,900),(104607,901),(104608,1039),(104609,1099),(104610,544),(104611,545),(104612,546),(104613,547),(104614,1060),(104615,1061),(104616,401),(104617,405),(104618,408),(104619,409),(104620,410),(104621,415),(104622,416),(104623,417),(104624,419),(104625,426),(104626,428),(104627,432),(104628,433),(104629,437),(104630,444),(104631,447),(104632,504),(104633,507),(104634,537),(104635,538),(104636,556),(104637,594),(104638,427),(104639,429),(104640,434),(104641,435),(104642,448),(104643,449),(104644,598),(104645,752),(104646,774),(104647,775),(104648,818),(104649,820),(104650,852),(104651,853),(104652,892),(104653,893),(104654,900),(104655,948),(104656,949),(104657,950),(104658,951),(104659,992),(104660,993),(104661,1040),(104662,1047),(104663,1060),(104664,1108),(104665,1114),(104666,994),(104667,995),(104668,1010),(104669,1096),(104670,1103),(104671,1121),(104672,1137),(104673,400),(104674,401),(104675,405),(104676,408),(104677,409),(104678,410),(104679,415),(104680,416),(104681,417),(104682,419),(104683,426),(104684,428),(104685,432),(104686,433),(104687,437),(104688,438),(104689,439),(104690,440),(104691,559),(104692,600),(104693,780),(104694,856),(104695,441),(104696,442),(104697,443),(104698,444),(104699,445),(104700,446),(104701,447),(104702,450),(104703,452),(104704,453),(104705,454),(104706,455),(104707,456),(104708,457),(104709,459),(104710,463),(104711,464),(104712,465),(104713,467),(104714,476),(104715,477),(104716,478),(104717,479),(104718,480),(104719,482),(104720,485),(104721,495),(104722,496),(104723,497),(104724,498),(104725,503),(104726,504),(104727,505),(104728,506),(104729,507),(104730,508),(104731,509),(104732,510),(104733,511),(104734,512),(104735,513),(104736,515),(104737,516),(104738,534),(104739,535),(104740,536),(104741,537),(104742,538),(104743,539),(104744,540),(104745,541),(104746,544),(104747,545),(104748,546),(104749,547),(104750,548),(104751,549),(104752,550),(104753,551),(104754,552),(104755,554),(104756,555),(104757,556),(104758,571),(104759,572),(104760,573),(104761,574),(104762,575),(104763,576),(104764,577),(104765,578),(104766,579),(104767,580),(104768,581),(104769,582),(104770,586),(104771,594),(104772,595),(104773,598),(104774,610),(104775,612),(104776,621),(104777,633),(104778,634),(104779,638),(104780,647),(104781,649),(104782,653),(104783,654),(104784,657),(104785,674),(104786,755),(104787,757),(104788,758),(104789,760),(104790,763),(104791,764),(104792,765),(104793,768),(104794,769),(104795,427),(104796,429),(104797,434),(104798,435),(104799,448),(104800,449),(104801,451),(104802,770),(104803,774),(104804,775),(104805,805),(104806,808),(104807,810),(104808,813),(104809,818),(104810,819),(104811,820),(104812,826),(104813,827),(104814,828),(104815,841),(104816,850),(104817,852),(104818,853),(104819,466),(104820,468),(104821,483),(104822,484),(104823,486),(104824,487),(104825,488),(104826,489),(104827,490),(104828,491),(104829,492),(104830,493),(104831,494),(104832,499),(104833,533),(104834,585),(104835,593),(104836,620),(104837,622),(104838,623),(104839,640),(104840,641),(104841,642),(104842,655),(104843,658),(104844,752),(104845,754),(104846,1020),(104847,756),(104848,759),(104849,761),(104850,762),(104851,767),(104852,773),(104853,806),(104854,807),(104855,811),(104856,812),(104857,829),(104858,842),(104859,844),(104860,845),(104861,846),(104862,847),(104863,848),(104864,849),(104865,851),(104866,854),(104867,909),(104868,910),(104869,912),(104870,932),(104871,933),(104872,935),(104873,940),(104874,941),(104875,943),(104876,1023),(104877,1106),(104878,1013),(104879,1016),(104880,1017),(104881,1027),(104882,1029),(104883,1030),(104884,1031),(104885,1033),(104886,1042),(104887,1046),(104888,1047),(104889,1048),(104890,1107),(104891,1108),(104892,1110),(104893,1113),(104894,1114),(104895,1116),(104896,1128),(104897,882),(104898,884),(104899,885),(104900,886),(104901,887),(104902,890),(104903,892),(104904,894),(104905,895),(104906,897),(104907,898),(104908,899),(104909,900),(104910,1018),(104911,1049),(104912,1051),(104913,1054),(104914,1055),(104915,1065),(104916,1076),(104917,1077),(104918,1082),(104919,1085),(104920,1088),(104921,1090),(104922,1091),(104923,1129),(104924,1130),(104925,1131),(104926,1132),(104927,542),(104928,543),(104929,766),(104930,809),(104931,843),(104932,888),(104933,889),(104934,891),(104935,893),(104936,896),(104937,901),(104938,934),(104939,942),(104940,948),(104941,949),(104942,950),(104943,951),(104944,952),(104945,953),(104946,954),(104947,955),(104948,956),(104949,976),(104950,977),(104951,978),(104952,979),(104953,984),(104954,985),(104955,986),(104956,987),(104957,992),(104958,993),(104959,994),(104960,995),(104961,1009),(104962,1010),(104963,1011),(104964,1095),(104965,1096),(104966,1097),(104967,1098),(104968,1102),(104969,458),(104970,869),(104971,883),(104972,1039),(104973,1099),(104974,1103),(104975,1104),(104976,1105),(104977,1120),(104978,1121),(104979,1123),(104980,1136),(104981,1137),(104982,1138),(104983,1139),(104984,1021),(104985,1022),(104986,2),(104987,1162),(104988,1163),(104989,1164),(104990,1165),(104991,1761),(104992,1762),(104993,1779),(104994,4524),(104995,4524),(104996,1673),(104997,1674),(104998,1790),(104999,4506),(105000,4507),(105001,4508),(105002,4511),(105003,4512),(105004,4513),(105005,4514),(105006,4566),(105007,4567),(105008,4577),(105009,5336),(105010,1332),(105011,4500),(105012,4501),(105013,4502),(105014,4503),(105015,4504),(105016,4505),(105017,4509),(105018,4510),(105019,4515),(105020,4516),(105021,4521),(105022,4522),(105023,4523),(105024,4525),(105025,1210),(105026,4517),(105027,4518),(105028,4519),(105029,4520),(105030,4568),(105031,4569),(105032,4570),(105033,4571),(105034,1749),(105035,1396),(105036,1406),(105037,1427),(105038,5323),(105039,5487),(105040,1208),(105041,1217),(105042,1218),(105043,1219),(105044,1220),(105045,1221),(105046,1222),(105047,1223),(105048,1224),(105049,1225),(105050,1226),(105051,1227),(105052,5330),(105053,5335),(105054,5355),(105055,5520),(105056,5521),(105057,5522),(105058,5523),(105059,1228),(105060,1240),(105061,1241),(105062,1246),(105063,1247),(105064,1310),(105065,1311),(105066,1312),(105067,1313),(105068,1314),(105069,1315),(105070,1316),(105071,1317),(105072,1318),(105073,1319),(105074,1320),(105075,1321),(105076,1322),(105077,1323),(105078,1330),(105079,1331),(105080,1336),(105081,1340),(105082,1344),(105083,1345),(105084,1348),(105085,1352),(105086,1375),(105087,1376),(105088,1377),(105089,1380),(105090,1209),(105091,1239),(105092,1248),(105093,1257),(105094,1258),(105095,1302),(105096,1303),(105097,1381),(105098,1382),(105099,1384),(105100,1385),(105101,1402),(105102,1403),(105103,1404),(105104,1419),(105105,1436),(105106,1450),(105107,1451),(105108,1452),(105109,1454),(105110,1455),(105111,1456),(105112,1457),(105113,1467),(105114,1249),(105115,1250),(105116,1251),(105117,1523),(105118,1533),(105119,1536),(105120,1664),(105121,1667),(105122,1781),(105123,1782),(105124,4572),(105125,5325),(105126,5326),(105127,5327),(105128,5331),(105129,5333),(105130,1252),(105131,1253),(105132,1254),(105133,1255),(105134,1256),(105135,1259),(105136,1260),(105137,1261),(105138,1262),(105139,1263),(105140,1264),(105141,1265),(105142,1266),(105143,1267),(105144,1268),(105145,1269),(105146,1270),(105147,1271),(105148,1272),(105149,1273),(105150,1274),(105151,1275),(105152,1276),(105153,1277),(105154,1278),(105155,1279),(105156,1280),(105157,1281),(105158,1282),(105159,1283),(105160,1284),(105161,1285),(105162,1286),(105163,1287),(105164,1329),(105165,1333),(105166,1334),(105167,1335),(105168,1337),(105169,1339),(105170,1369),(105171,1213),(105172,1214),(105173,1215),(105174,1216),(105175,1293),(105176,1294),(105177,1295),(105178,1296),(105179,1297),(105180,1298),(105181,1299),(105182,1300),(105183,1301),(105184,1370),(105185,1372),(105186,1373),(105187,1374),(105188,1379),(105189,1383),(105190,1389),(105191,1390),(105192,1391),(105193,1392),(105194,1393),(105195,1394),(105196,1395),(105197,1397),(105198,1398),(105199,1399),(105200,1400),(105201,1405),(105202,1465),(105203,5323),(105204,5324),(105205,5328),(105206,5329),(105207,5390),(105208,5474),(105209,5475),(105210,5476),(105211,5477),(105212,5478),(105213,5479),(105214,5480),(105215,5481),(105216,5482),(105217,5483),(105218,5484),(105219,5485),(105220,5486),(105221,5704),(105222,5705),(105223,5706),(105224,1195),(105225,1196),(105226,1197),(105227,1198),(105228,1199),(105229,1200),(105230,1201),(105231,1202),(105232,1203),(105233,1204),(105234,1205),(105235,1206),(105236,1207),(105237,1211),(105238,1212),(105239,1229),(105240,1230),(105241,1233),(105242,1236),(105243,5487),(105244,5488),(105245,1237),(105246,1288),(105247,1289),(105248,1290),(105249,1291),(105250,1292),(105251,1304),(105252,1305),(105253,1306),(105254,1307),(105255,1308),(105256,1309),(105257,1325),(105258,1328),(105259,1338),(105260,1341),(105261,1346),(105262,1347),(105263,1350),(105264,1351),(105265,1359),(105266,1360),(105267,1361),(105268,1362),(105269,1363),(105270,1364),(105271,1365),(105272,1366),(105273,1367),(105274,1368),(105275,1387),(105276,1401),(105277,1410),(105278,1426),(105279,1438),(105280,1439),(105281,1443),(105282,1444),(105283,1445),(105284,1231),(105285,1232),(105286,1234),(105287,1242),(105288,1243),(105289,1244),(105290,1245),(105291,1342),(105292,1349),(105293,1411),(105294,1446),(105295,1448),(105296,1466),(105297,1353),(105298,1354),(105299,1355),(105300,1356),(105301,1357),(105302,1358),(105303,1412),(105304,1413),(105305,1414),(105306,1415),(105307,1416),(105308,1437),(105309,1440),(105310,1449),(105311,1453),(105312,1464),(105313,1468),(105314,5327),(105315,5334),(105316,5370),(105317,5371),(105318,5372),(105319,5373),(105320,5374),(105321,5375),(105322,5376),(105323,5377),(105324,1447),(105325,5351),(105326,5352),(105327,5356),(105328,5390),(105329,1420),(105330,1421),(105331,1422),(105332,1423),(105333,1424),(105334,1425),(105335,1427),(105336,1428),(105337,1429),(105338,1430),(105339,1431),(105340,1432),(105341,1433),(105342,1434),(105343,1558),(105344,1559),(105345,5332),(105346,1168),(105347,1170),(105348,1171),(105349,1172),(105350,1173),(105351,1182),(105352,1183),(105353,1235),(105354,1324),(105355,1326),(105356,1327),(105357,1329),(105358,1343),(105359,1371),(105360,1532),(105361,5332),(105362,5337),(105363,5343),(105364,5344),(105365,5351),(105366,5352),(105367,5354),(105368,5474),(105369,5476),(105370,5526),(105371,1386),(105372,1388),(105373,1407),(105374,1408),(105375,1409),(105376,1417),(105377,1418),(105378,1435),(105379,1441),(105380,1442),(105381,1458),(105382,1459),(105383,1461),(105384,1469),(105385,1488),(105386,1489),(105387,1491),(105388,1492),(105389,1494),(105390,5489),(105391,1188),(105392,1524),(105393,1526),(105394,1528),(105395,1666),(105396,1529),(105397,1534),(105398,1535),(105399,1557),(105400,1799),(105401,1800),(105402,1175),(105403,1176),(105404,1177),(105405,1178),(105406,1179),(105407,1180),(105408,1181),(105409,1185),(105410,1186),(105411,1187),(105412,1190),(105413,1192),(105414,1193),(105415,1518),(105416,1519),(105417,1520),(105418,1521),(105419,1563),(105420,1564),(105421,1565),(105422,1665),(105423,1675),(105424,1676),(105425,1677),(105426,1678),(105427,1751),(105428,1752),(105429,1753),(105430,1761),(105431,1762),(105432,1778),(105433,1779),(105434,377),(105435,378),(105436,379),(105437,380),(105438,381),(105439,382),(105440,383),(105441,384),(105442,385),(105443,386),(105444,387),(105445,388),(105446,391),(105447,392),(105448,394),(105449,395),(105450,1527),(105451,1522),(105452,1525),(105453,1530),(105454,1534),(105455,1535),(105456,1661),(105457,1662),(105458,1663),(105459,1668),(105460,1669),(105461,1670),(105462,1671),(105463,1745),(105464,1747),(105465,1794),(105466,1801),(105467,1802),(105468,1191),(105469,1522),(105470,1524),(105471,1525),(105472,1526),(105473,1528),(105474,1529),(105475,1530),(105476,1531),(105477,1535),(105478,1661),(105479,1662),(105480,1663),(105481,1177),(105482,1178),(105483,1179),(105484,1180),(105485,1181),(105486,1563),(105487,1564),(105488,1565),(105489,1566),(105490,1675),(105491,1676),(105492,1677),(105493,1678),(105494,1761),(105495,1762),(105496,1778),(105497,1779),(105498,356),(105499,607),(105500,608),(105501,1518),(105502,1519),(105503,1520),(105504,1521),(105505,1665),(105506,1666),(105507,1751),(105508,1752),(105509,1753),(105510,1754),(105511,1755),(105512,1756),(105513,1757),(105514,1758),(105515,1786),(105516,1787),(105517,1788),(105518,1789),(105519,1790),(105520,389),(105521,390),(105522,396),(105523,397),(105524,563),(105525,606),(105526,777),(105527,789),(105528,795),(105529,798),(105530,799),(105531,800),(105532,801),(105533,802),(105534,803),(105535,804),(105536,823),(105537,832),(105538,833),(105539,830),(105540,831),(105541,859),(105542,860),(105543,866),(105544,867),(105545,868),(105546,1189),(105547,1522),(105548,1524),(105549,1525),(105550,1526),(105551,1527),(105552,1528),(105553,1669),(105554,1671),(105555,1745),(105556,1422),(105557,1529),(105558,1530),(105559,1531),(105560,1534),(105561,1535),(105562,1587),(105563,1661),(105564,1662),(105565,1663),(105566,1668),(105567,1670),(105568,1672),(105569,1744),(105570,1746),(105571,1793),(105572,1794),(105573,1795),(105574,1799),(105575,1800),(105576,1801),(105577,1802),(105578,2),(105579,4),(105580,1162),(105581,1163),(105582,1164),(105583,1165),(105584,2449),(105585,5394),(105586,5489),(105587,1471),(105588,1567),(105589,5282),(105590,5283),(105591,5284),(105592,5301),(105593,5389),(105594,5393),(105595,5394),(105596,5395),(105597,5468),(105598,5489),(105599,5598),(105600,5650),(105601,5673),(105602,1700),(105603,2699),(105604,5365),(105605,5527),(105606,5528),(105607,5621),(105608,5627),(105609,5637),(105610,5644),(105611,5645),(105612,5646),(105613,5652),(105614,5654),(105615,5663),(105616,5670),(105617,5671),(105618,5672),(105619,5490),(105620,5491),(105621,5492),(105622,5493),(105623,5494),(105624,5495),(105625,5496),(105626,5497),(105627,5498),(105628,5499),(105629,5500),(105630,5501),(105631,5502),(105632,5503),(105633,5504),(105634,5505),(105635,5506),(105636,5507),(105637,5508),(105638,5509),(105639,5510),(105640,5511),(105641,5512),(105642,5513),(105643,5514),(105644,5515),(105645,5516),(105646,5517),(105647,2921),(105648,5359),(105649,5360),(105650,5367),(105651,5529),(105652,5530),(105653,5363),(105654,5366),(105655,5636),(105656,5651),(105657,5662),(105658,4622),(105659,4623),(105660,4624),(105661,4853),(105662,4854),(105663,4855),(105664,4888),(105665,5598),(105666,5660),(105667,5695),(105668,1184),(105669,1238),(105670,1378),(105671,1462),(105672,5361),(105673,5362),(105674,5364),(105675,5626),(105676,5639),(105677,5640),(105678,5648),(105679,5665),(105680,5666),(105681,5628),(105682,5646),(105683,5672),(105684,2126),(105685,2127),(105686,2128),(105687,2129),(105688,2130),(105689,2131),(105690,2132),(105691,2323),(105692,2324),(105693,2449),(105694,2427),(105695,2126),(105696,2127),(105697,2128),(105698,2129),(105699,2130),(105700,2131),(105701,2132),(105702,2323),(105703,2324),(105704,2449),(105705,1816),(105706,1818),(105707,1822),(105708,1827),(105709,1965),(105710,1966),(105711,1972),(105712,1983),(105713,1984),(105714,1986),(105715,2008),(105716,2013),(105717,2014),(105718,2035),(105719,2037),(105720,2041),(105721,1813),(105722,1815),(105723,1820),(105724,1973),(105725,1974),(105726,1975),(105727,1976),(105728,1977),(105729,1978),(105730,1979),(105731,1980),(105732,1982),(105733,1985),(105734,1987),(105735,1988),(105736,1989),(105737,1990),(105738,1814),(105739,1817),(105740,1819),(105741,1821),(105742,1823),(105743,1824),(105744,1825),(105745,1826),(105746,1967),(105747,1968),(105748,1971),(105749,1981),(105750,2299),(105751,2404),(105752,2531),(105753,5622),(105754,5641),(105755,5667),(105756,1828),(105757,1829),(105758,1830),(105759,1831),(105760,1832),(105761,1833),(105762,1950),(105763,1952),(105764,1969),(105765,1970),(105766,2021),(105767,2022),(105768,2154),(105769,2177),(105770,2221),(105771,2222),(105772,2435),(105773,2540),(105774,2541),(105775,2542),(105776,2265),(105777,2266),(105778,2267),(105779,2268),(105780,2269),(105781,2276),(105782,2317),(105783,2318),(105784,2319),(105785,2320),(105786,2321),(105787,2322),(105788,2397),(105789,2398),(105790,2399),(105791,2400),(105792,2401),(105793,2403),(105794,2405),(105795,2406),(105796,2407),(105797,2408),(105798,2409),(105799,2410),(105800,2589),(105801,2590),(105802,2591),(105803,2592),(105804,2593),(105805,2594),(105806,2595),(105807,2598),(105808,2599),(105809,2600),(105810,2601),(105811,2602),(105812,2603),(105813,2604),(105814,2605),(105815,2606),(105816,2607),(105817,2596),(105818,2597),(105819,2608),(105820,2609),(105821,2610),(105822,2611),(105823,2612),(105824,2613),(105825,2614),(105826,4894),(105827,4894),(105828,4894),(105829,4894),(105830,4894),(105831,5753),(105832,5753),(105833,5753),(105834,5753),(105835,5753),(105836,5753),(105837,5753),(105838,5753),(105839,5753),(105840,5753),(105841,5753),(105842,5753),(105843,5753),(105844,2176),(105845,2176),(105846,2176),(105847,2176),(105848,2176),(105849,5753),(105850,5753),(105851,5753),(105852,5753),(105853,5753),(105854,5753),(105855,5753),(105856,5753),(105857,5753),(105858,5753),(105859,5753),(105860,7),(105861,7),(105862,7),(105863,7),(105864,7),(105865,7),(105866,7),(105867,7),(105868,7),(105869,7),(105870,7),(105871,7),(105872,7),(105873,7),(105874,7),(105875,7),(105876,7),(105877,7),(105878,7),(105879,7),(105880,7),(105881,7),(105882,7),(105883,7),(105884,7),(105885,7),(105886,5757),(105887,5757),(105888,5757),(105889,5757),(105890,5757),(105891,5757),(105892,5757),(105893,5757),(105894,5757),(105895,5757),(105896,5757),(105897,5757),(105898,5757),(105899,5757),(105900,5757),(105901,5757),(105902,5757),(105903,5757),(105904,5757),(105905,5757),(105906,5757),(105907,5757),(105908,5757),(105909,5757),(105910,5757),(105911,5758),(105912,5758),(105913,5758),(105914,5758),(105915,5758),(105916,5758),(105917,5758),(105918,5758),(105919,5758),(105920,5758),(105921,5758),(105922,5758),(105923,5758),(105924,5758),(105925,5758),(105926,5758),(105927,5758),(105928,5758),(105929,5758),(105930,5758),(105931,5758),(105932,5758),(105933,5758),(105934,5758),(105935,5758),(105936,5759),(105937,5759),(105938,5759),(105939,5759),(105940,5759),(105941,5759),(105942,5759),(105943,5759),(105944,5759),(105945,5759),(105946,5759),(105947,5759),(105948,5759),(105949,5759),(105950,5759),(105951,5759),(105952,5759),(105953,5759),(105954,5759),(105955,5759),(105956,5759),(105957,5759),(105958,5759),(105959,5759),(105960,5759),(105961,1165),(105962,1165),(105963,1165),(105964,1165),(105965,1165),(105966,1165),(105967,1165),(105968,7),(105969,7),(105970,7),(105971,7),(105972,7),(105973,7),(105974,7),(105975,7),(105976,7),(105977,7),(105978,7),(105979,7),(105980,7),(105981,7),(105982,7),(105983,7),(105984,7),(105985,7),(105986,7),(105987,7),(105988,7),(105989,7),(105990,7),(105991,7),(105992,7),(105993,7),(105994,2026),(105995,2027),(105996,2028),(105997,2029),(105998,2030),(105999,2031),(106000,2032),(106001,2034),(106002,2039),(106003,2040),(106004,2042),(106005,2044),(106006,2045),(106007,2046),(106008,2122),(106009,2123),(106010,2124),(106011,2125),(106012,2133),(106013,2134),(106014,2135),(106015,2136),(106016,2137),(106017,2138),(106018,2139),(106019,2140),(106020,2141),(106021,2142),(106022,2143),(106023,2144),(106024,2145),(106025,2146),(106026,2147),(106027,2148),(106028,2149),(106029,2150),(106030,2151),(106031,2152),(106032,2153),(106033,2275),(106034,2325),(106035,2326),(106036,2327),(106037,2328),(106038,2329),(106039,2330),(106040,2331),(106041,2332),(106042,2333),(106043,2334),(106044,2335),(106045,2336),(106046,2337),(106047,2338),(106048,2339),(106049,2340),(106050,2341),(106051,2342),(106052,2343),(106053,2344),(106054,2345),(106055,2346),(106056,2347),(106057,2348),(106058,2349),(106059,2350),(106060,2351),(106061,2352),(106062,2353),(106063,2354),(106064,2355),(106065,2356),(106066,2357),(106067,2358),(106068,2359),(106069,2360),(106070,2361),(106071,2362),(106072,2363),(106073,2364),(106074,2365),(106075,2366),(106076,2367),(106077,2368),(106078,2369),(106079,2370),(106080,2371),(106081,2372),(106082,2373),(106083,2374),(106084,2375),(106085,2376),(106086,2377),(106087,2378),(106088,2379),(106089,2380),(106090,2381),(106091,2382),(106092,2383),(106093,2384),(106094,2385),(106095,2386),(106096,2387),(106097,2388),(106098,2389),(106099,2390),(106100,2391),(106101,2559),(106102,7),(106103,7),(106104,7),(106105,7),(106106,7),(106107,7),(106108,7),(106109,7),(106110,7),(106111,7),(106112,7),(106113,7),(106114,7),(106115,7),(106116,7),(106117,7),(106118,7),(106119,7),(106120,7),(106121,7),(106122,7),(106123,7),(106124,7),(106125,7),(106126,7),(106127,7),(106128,7),(106129,7),(106130,7),(106131,7),(106132,7),(106133,7),(106134,7),(106135,7),(106136,7),(106137,7),(106138,7),(106139,7),(106140,7),(106141,7),(106142,7),(106143,7),(106144,7),(106145,7),(106146,7),(106147,7),(106148,7),(106149,7),(106150,7),(106151,7),(106152,7),(106153,7),(106154,7),(106155,7),(106156,7),(106157,7),(106158,7),(106159,7),(106160,51),(106161,51),(106162,51),(106163,51),(106164,51),(106165,51),(106166,51),(106167,51),(106168,51),(106169,51),(106170,51),(106171,51),(106172,51),(106173,51),(106174,51),(106175,51),(106176,51),(106177,51),(106178,51),(106179,51),(106180,51),(106181,51),(106182,51),(106183,221),(106184,221),(106185,221),(106186,221),(106187,221),(106188,221),(106189,221),(106190,221),(106191,221),(106192,221),(106193,221),(106194,221),(106195,221),(106196,221),(106197,221),(106198,221),(106199,112),(106200,112),(106201,112),(106202,112),(106203,112),(106204,112),(106205,112),(106206,112),(106207,112),(106208,112),(106209,112),(106210,112),(106211,112),(106212,112),(106213,112),(106214,18),(106215,18),(106216,18),(106217,18),(106218,18),(106219,18),(106220,18),(106221,18),(106222,18),(106223,18),(106224,18),(106225,18),(106226,18),(106227,18),(106228,18),(106229,1623),(106230,1623),(106231,1623),(106232,1623),(106233,1623),(106234,1623),(106235,1623),(106236,1623),(106237,1623),(106238,1623),(106239,1623),(106240,1623),(106241,1623),(106242,1623),(106243,1623),(106244,1623),(106245,2289),(106246,2289),(106247,2289),(106248,2289),(106249,2289),(106250,2289),(106251,2289),(106252,2289),(106253,2289),(106254,2289),(106255,2289),(106256,2289),(106257,2289),(106258,2289),(106259,2289),(106260,2289),(106261,2289),(106262,2289),(106263,2289),(106264,2289),(106265,2289),(106266,1165),(106267,1164),(106268,1164),(106269,1164),(106270,1164),(106271,1164),(106272,1162),(106273,1162),(106274,1162),(106275,1162),(106276,1162),(106277,1165),(106278,4370),(106279,4371),(106280,4372),(106281,4373),(106282,4374),(106283,4375),(106284,4376),(106285,4377),(106286,4378),(106287,4379),(106288,4380),(106289,4381),(106290,4382),(106291,4383),(106292,4384),(106293,4385),(106294,4386),(106295,4387),(106296,4388),(106297,4389),(106298,1629),(106299,1630),(106300,1631),(106301,1632),(106302,1633),(106303,1634),(106304,1635),(106305,1681),(106306,1682),(106307,1683),(106308,1684),(106309,1685),(106310,1686),(106311,4368),(106312,4369),(106313,2704),(106314,2705),(106315,2706),(106316,2707),(106317,2708),(106318,2709),(106319,2710),(106320,2711),(106321,2712),(106322,2713),(106323,2714),(106324,2715),(106325,2716),(106326,2717),(106327,2718),(106328,2719),(106329,2720),(106330,2721),(106331,2722),(106332,2723),(106333,2724),(106334,2725),(106335,2726),(106336,2727),(106337,2728),(106338,2729),(106339,2730),(106340,2731),(106341,2732),(106342,2733),(106343,2734),(106344,2735),(106345,2736),(106346,2737),(106347,2738),(106348,2739),(106349,2740),(106350,2741),(106351,2742),(106352,2743),(106353,2744),(106354,2745),(106355,2746),(106356,2747),(106357,2748),(106358,2749),(106359,2750),(106360,2751),(106361,2752),(106362,2753),(106363,2754),(106364,2755),(106365,2756),(106366,2757),(106367,2758),(106368,2759),(106369,2797),(106370,2857),(106371,2894),(106372,2904),(106373,2977),(106374,2988),(106375,3118),(106376,3623),(106377,7),(106378,8),(106379,9),(106380,10),(106381,11),(106382,12),(106383,13),(106384,14),(106385,15),(106386,16),(106387,17),(106388,18),(106389,19),(106390,20),(106391,21),(106392,22),(106393,23),(106394,24),(106395,25),(106396,26),(106397,27),(106398,28),(106399,29),(106400,30),(106401,31),(106402,32),(106403,33),(106404,34),(106405,35),(106406,36),(106407,37),(106408,38),(106409,45),(106410,46),(106411,47),(106412,48),(106413,49),(106414,50),(106415,51),(106416,52),(106417,53),(106418,54),(106419,55),(106420,56),(106421,57),(106422,58),(106423,59),(106424,60),(106425,61),(106426,62),(106427,63),(106428,64),(106429,65),(106430,66),(106431,67),(106432,68),(106433,69),(106434,70),(106435,71),(106436,72),(106437,73),(106438,74),(106439,75),(106440,76),(106441,77),(106442,78),(106443,79),(106444,80),(106445,81),(106446,82),(106447,83),(106448,84),(106449,85),(106450,86),(106451,87),(106452,88),(106453,89),(106454,90),(106455,91),(106456,92),(106457,93),(106458,94),(106459,95),(106460,110),(106461,111),(106462,112),(106463,113),(106464,114),(106465,115),(106466,116),(106467,117),(106468,118),(106469,119),(106470,120),(106471,121),(106472,122),(106473,123),(106474,124),(106475,125),(106476,126),(106477,127),(106478,128),(106479,129),(106480,130),(106481,131),(106482,132),(106483,133),(106484,134),(106485,135),(106486,136),(106487,137),(106488,140),(106489,141),(106490,142),(106491,143),(106492,144),(106493,145),(106494,146),(106495,147),(106496,148),(106497,149),(106498,150),(106499,151),(106500,152),(106501,153),(106502,154),(106503,155),(106504,156),(106505,157),(106506,158),(106507,159),(106508,1567),(106509,5378),(106510,5379),(106511,5380),(106512,5381),(106513,5382),(106514,5383),(106515,5384),(106516,5385),(106517,5386),(106518,5387),(106519,5388),(106520,5389),(106521,5391),(106522,5392),(106523,5673),(106524,5750),(106525,5751),(106526,1002),(106527,1003),(106528,1005),(106529,1034),(106530,1035),(106531,1036),(106532,1038),(106533,1133),(106534,1972),(106535,1973),(106536,1974),(106537,1975),(106538,1976),(106539,1977),(106540,1978),(106541,1979),(106542,1980),(106543,1981),(106544,1982),(106545,1983),(106546,1984),(106547,1985),(106548,1986),(106549,1987),(106550,1988),(106551,1989),(106552,1990),(106553,1991),(106554,2003),(106555,2004),(106556,2005),(106557,2006),(106558,2007),(106559,2008),(106560,2009),(106561,2010),(106562,2011),(106563,2012),(106564,2013),(106565,2014),(106566,2015),(106567,2016),(106568,2017),(106569,2018),(106570,2019),(106571,2020),(106572,2021),(106573,2022),(106574,2023),(106575,2024),(106576,2025),(106577,2033),(106578,2035),(106579,2036),(106580,2037),(106581,2038),(106582,2041),(106583,2043),(106584,2047),(106585,2048),(106586,2049),(106587,2050),(106588,2051),(106589,2052),(106590,2053),(106591,2054),(106592,2055),(106593,2056),(106594,2057),(106595,2058),(106596,2059),(106597,2060),(106598,2061),(106599,2062),(106600,2063),(106601,2064),(106602,2065),(106603,2066),(106604,2067),(106605,2068),(106606,2069),(106607,2070),(106608,2071),(106609,2072),(106610,2073),(106611,2074),(106612,2075),(106613,2076),(106614,2077),(106615,2078),(106616,2079),(106617,2080),(106618,2081),(106619,2082),(106620,2083),(106621,2084),(106622,2085),(106623,2086),(106624,2087),(106625,2088),(106626,2089),(106627,2090),(106628,2091),(106629,2092),(106630,2093),(106631,2094),(106632,2095),(106633,2096),(106634,2097),(106635,2098),(106636,2099),(106637,2100),(106638,2101),(106639,2102),(106640,2103),(106641,2104),(106642,2105),(106643,2106),(106644,2107),(106645,2108),(106646,2109),(106647,2110),(106648,2111),(106649,2112),(106650,2113),(106651,2114),(106652,2115),(106653,2116),(106654,2117),(106655,2118),(106656,2119),(106657,2120),(106658,2121),(106659,2155),(106660,2156),(106661,2157),(106662,2165),(106663,2166),(106664,2167),(106665,2168),(106666,2169),(106667,2178),(106668,2179),(106669,2180),(106670,2221),(106671,2222),(106672,2252),(106673,2253),(106674,2254),(106675,2255),(106676,2263),(106677,2264),(106678,2272),(106679,2273),(106680,2274),(106681,2283),(106682,2284),(106683,2285),(106684,2286),(106685,2287),(106686,2288),(106687,2450),(106688,2451),(106689,2452),(106690,2453),(106691,2465),(106692,2466),(106693,2467),(106694,2468),(106695,2469),(106696,2470),(106697,2471),(106698,2501),(106699,2502),(106700,2552),(106701,2555),(106702,2556),(106703,2557),(106704,2558),(106705,2560),(106706,2561),(106707,2562),(106708,2563),(106709,2564),(106710,2565),(106711,2566),(106712,2567),(106713,2568),(106714,2569),(106715,2570),(106716,2571),(106717,2572),(106718,2588),(106719,2615),(106720,2616),(106721,2617),(106722,2618),(106723,2619),(106724,2620),(106725,2621),(106726,681),(106727,682),(106728,687),(106729,688),(106730,690),(106731,691),(106732,692),(106733,693),(106734,694),(106735,695),(106736,696),(106737,697),(106738,698),(106739,699),(106740,700),(106741,701),(106742,702),(106743,703),(106744,704),(106745,705),(106746,706),(106747,707),(106748,708),(106749,711),(106750,713),(106751,714),(106752,718),(106753,719),(106754,720),(106755,721),(106756,722),(106757,723),(106758,724),(106759,725),(106760,732),(106761,733),(106762,734),(106763,737),(106764,738),(106765,739),(106766,740),(106767,741),(106768,742),(106769,743),(106770,744),(106771,745),(106772,746),(106773,747),(106774,748),(106775,749),(106776,996),(106777,997),(106778,998),(106779,999),(106780,1000),(106781,1001),(106782,683),(106783,684),(106784,685),(106785,686),(106786,689),(106787,709),(106788,710),(106789,712),(106790,715),(106791,716),(106792,717),(106793,726),(106794,727),(106795,728),(106796,729),(106797,730),(106798,731),(106799,735),(106800,736),(106801,3028),(106802,3029),(106803,3030),(106804,3031),(106805,3032),(106806,3033),(106807,3034),(106808,3035),(106809,3036),(106810,3037),(106811,3038),(106812,3039),(106813,3040),(106814,3041),(106815,3044),(106816,3045),(106817,3046),(106818,3047),(106819,3048),(106820,3049),(106821,3056),(106822,3057),(106823,3058),(106824,3059),(106825,3060),(106826,3061),(106827,3062),(106828,3063),(106829,3064),(106830,3065),(106831,3066),(106832,3067),(106833,3068),(106834,3069),(106835,3070),(106836,3071),(106837,3072),(106838,3073),(106839,3074),(106840,3075),(106841,3076),(106842,3077),(106843,3078),(106844,3079),(106845,3080),(106846,3081),(106847,3082),(106848,3083),(106849,3084),(106850,3085),(106851,3086),(106852,3087),(106853,3088),(106854,3089),(106855,3090),(106856,3091),(106857,3092),(106858,3093),(106859,3094),(106860,3095),(106861,3096),(106862,3097),(106863,3098),(106864,3099),(106865,3100),(106866,3101),(106867,3103),(106868,3104),(106869,3105),(106870,3106),(106871,3107),(106872,3108),(106873,3109),(106874,3110),(106875,3111),(106876,3112),(106877,3113),(106878,3114),(106879,3115),(106880,3116),(106881,3117),(106882,3119),(106883,3120),(106884,3121),(106885,3122),(106886,3123),(106887,3124),(106888,3528),(106889,3529),(106890,3530),(106891,3531),(106892,3532),(106893,3533),(106894,3537),(106895,3538),(106896,3543),(106897,3544),(106898,3545),(106899,3546),(106900,3547),(106901,3548),(106902,3549),(106903,3550),(106904,3551),(106905,3552),(106906,3553),(106907,3554),(106908,3555),(106909,3556),(106910,3557),(106911,3558),(106912,3559),(106913,3560),(106914,3561),(106915,3562),(106916,3563),(106917,3564),(106918,3565),(106919,3566),(106920,3567),(106921,3568),(106922,3569),(106923,3570),(106924,3571),(106925,3572),(106926,3581),(106927,3582),(106928,3584),(106929,3585),(106930,3586),(106931,3587),(106932,3588),(106933,3589),(106934,3590),(106935,3591),(106936,3610),(106937,3611),(106938,3612),(106939,3613),(106940,3614),(106941,3615),(106942,3616),(106943,3617),(106944,3618),(106945,3619),(106946,3620),(106947,3621),(106948,3622),(106949,3624),(106950,3625),(106951,3626),(106952,3627),(106953,3628),(106954,3629),(106955,3630),(106956,3631),(106957,3632),(106958,3633),(106959,3634),(106960,3635),(106961,3636),(106962,3637),(106963,3638),(106964,3639),(106965,3640),(106966,3641),(106967,3642),(106968,3643),(106969,3644),(106970,3645),(106971,3646),(106972,3647),(106973,3649),(106974,3650),(106975,3651),(106976,3652),(106977,3653),(106978,3654),(106979,3655),(106980,3656),(106981,3657),(106982,3658),(106983,3659),(106984,3660),(106985,3661),(106986,3662),(106987,3663),(106988,3664),(106989,3665),(106990,3666),(106991,3667),(106992,3668),(106993,3669),(106994,3670),(106995,3671),(106996,3672),(106997,3673),(106998,3674),(106999,3684),(107000,3685),(107001,2701),(107002,2702),(107003,2760),(107004,2761),(107005,2762),(107006,2763),(107007,2764),(107008,2765),(107009,2772),(107010,2774),(107011,2775),(107012,2776),(107013,2777),(107014,2778),(107015,2779),(107016,2780),(107017,2783),(107018,2784),(107019,2785),(107020,2786),(107021,2787),(107022,2788),(107023,2789),(107024,2790),(107025,2791),(107026,2792),(107027,2799),(107028,2800),(107029,2801),(107030,2802),(107031,2803),(107032,2804),(107033,2805),(107034,2806),(107035,2807),(107036,2808),(107037,2809),(107038,2810),(107039,2811),(107040,2812),(107041,2813),(107042,2814),(107043,2815),(107044,2816),(107045,2817),(107046,2818),(107047,2819),(107048,2820),(107049,2822),(107050,2823),(107051,2824),(107052,2825),(107053,2826),(107054,2827),(107055,2831),(107056,2832),(107057,2844),(107058,2845),(107059,2846),(107060,2847),(107061,2848),(107062,2849),(107063,2850),(107064,2851),(107065,2852),(107066,2853),(107067,2854),(107068,2855),(107069,2856),(107070,2859),(107071,2860),(107072,2861),(107073,2862),(107074,2864),(107075,2865),(107076,2868),(107077,2869),(107078,2870),(107079,2871),(107080,2872),(107081,2873),(107082,2874),(107083,2875),(107084,2876),(107085,2877),(107086,2878),(107087,2879),(107088,2880),(107089,2881),(107090,2882),(107091,2883),(107092,2884),(107093,2885),(107094,2886),(107095,2887),(107096,2888),(107097,2889),(107098,2892),(107099,2893),(107100,2900),(107101,2901),(107102,2902),(107103,2903),(107104,2905),(107105,2906),(107106,2907),(107107,2908),(107108,2909),(107109,2910),(107110,2911),(107111,2912),(107112,2913),(107113,2914),(107114,2915),(107115,2916),(107116,2955),(107117,2956),(107118,2957),(107119,2958),(107120,2959),(107121,2960),(107122,2961),(107123,2962),(107124,2963),(107125,2964),(107126,2965),(107127,2966),(107128,2967),(107129,2968),(107130,2981),(107131,2982),(107132,2983),(107133,2984),(107134,2985),(107135,2986),(107136,2991),(107137,2992),(107138,3013),(107139,3014),(107140,3015),(107141,3016),(107142,3017),(107143,3018),(107144,3019),(107145,3020),(107146,3021),(107147,3022),(107148,3023),(107149,3024),(107150,3025),(107151,3026),(107152,3027),(107153,4147),(107154,4148),(107155,4149),(107156,4152),(107157,4153),(107158,4154),(107159,4156),(107160,4168),(107161,4248),(107162,4297),(107163,4298),(107164,4299),(107165,4300),(107166,4301),(107167,4302),(107168,4303),(107169,4304),(107170,4359),(107171,4458),(107172,4459),(107173,3842),(107174,3846),(107175,3882),(107176,3903),(107177,3973),(107178,4057),(107179,4127),(107180,4128),(107181,4129),(107182,4130),(107183,4131),(107184,4132),(107185,4133),(107186,4134),(107187,4135),(107188,4136),(107189,4137),(107190,4138),(107191,4139),(107192,4140),(107193,4141),(107194,4145),(107195,4146),(107196,3767),(107197,3768),(107198,3769),(107199,3770),(107200,3771),(107201,3772),(107202,3773),(107203,3775),(107204,3868),(107205,3874),(107206,3884),(107207,3889),(107208,3904),(107209,3905),(107210,3913),(107211,3914),(107212,3915),(107213,3916),(107214,3917),(107215,3963),(107216,3970),(107217,3974),(107218,3989),(107219,4039),(107220,4079),(107221,4119),(107222,4247),(107223,4259),(107224,4261),(107225,4262),(107226,4270),(107227,4284),(107228,4285),(107229,4291),(107230,4293),(107231,4336),(107232,4357),(107233,4360),(107234,4422),(107235,4424),(107236,4468),(107237,4480),(107238,3776),(107239,3777),(107240,3778),(107241,3779),(107242,3780),(107243,3781),(107244,3782),(107245,3783),(107246,3788),(107247,3789),(107248,3790),(107249,3791),(107250,3792),(107251,3793),(107252,3794),(107253,3795),(107254,3796),(107255,3797),(107256,3798),(107257,3799),(107258,3800),(107259,3801),(107260,3802),(107261,3803),(107262,3804),(107263,3805),(107264,3806),(107265,3807),(107266,3808),(107267,3809),(107268,3810),(107269,3811),(107270,3812),(107271,3813),(107272,3814),(107273,3815),(107274,3816),(107275,3817),(107276,3818),(107277,3819),(107278,3820),(107279,3821),(107280,3822),(107281,3823),(107282,3824),(107283,3825),(107284,3826),(107285,3836),(107286,3837),(107287,3838),(107288,3839),(107289,3840),(107290,3841),(107291,3918),(107292,3941),(107293,3942),(107294,3972),(107295,3977),(107296,3978),(107297,3979),(107298,3980),(107299,3981),(107300,3982),(107301,3983),(107302,3984),(107303,3985),(107304,3986),(107305,3987),(107306,3988),(107307,4080),(107308,4081),(107309,4082),(107310,4083),(107311,4084),(107312,4085),(107313,4086),(107314,4087),(107315,4088),(107316,4089),(107317,4090),(107318,4091),(107319,4195),(107320,4196),(107321,4197),(107322,4198),(107323,4204),(107324,4205),(107325,4206),(107326,4207),(107327,4208),(107328,4209),(107329,4210),(107330,4211),(107331,4222),(107332,4223),(107333,4224),(107334,4225),(107335,4226),(107336,4227),(107337,4228),(107338,4229),(107339,4230),(107340,4231),(107341,4232),(107342,4233),(107343,4234),(107344,4235),(107345,4236),(107346,4237),(107347,4238),(107348,4275),(107349,4276),(107350,4292),(107351,4425),(107352,4432),(107353,4433),(107354,4481),(107355,4482),(107356,4483),(107357,4484),(107358,4485),(107359,4486),(107360,4487),(107361,4488),(107362,4489),(107363,4490),(107364,3835),(107365,4012),(107366,4013),(107367,4014),(107368,4015),(107369,4016),(107370,4017),(107371,4018),(107372,4019),(107373,4020),(107374,4021),(107375,4022),(107376,4023),(107377,4024),(107378,4025),(107379,4026),(107380,4027),(107381,4028),(107382,4029),(107383,4030),(107384,4031),(107385,4032),(107386,4033),(107387,4034),(107388,4035),(107389,4036),(107390,4037),(107391,4356),(107392,4402),(107393,4403),(107394,4404),(107395,4405),(107396,4406),(107397,4407),(107398,4408),(107399,4409),(107400,4410),(107401,4411),(107402,4412),(107403,4413),(107404,4414),(107405,4415),(107406,4417),(107407,4418),(107408,4419),(107409,4426),(107410,4427),(107411,3787),(107412,3871),(107413,3893),(107414,3894),(107415,3895),(107416,3923),(107417,3924),(107418,3925),(107419,3926),(107420,3927),(107421,3928),(107422,3929),(107423,3930),(107424,3931),(107425,3932),(107426,3933),(107427,3934),(107428,3935),(107429,3936),(107430,3937),(107431,3938),(107432,3966),(107433,3967),(107434,3968),(107435,3969),(107436,4167),(107437,4193),(107438,4194),(107439,4249),(107440,4250),(107441,4251),(107442,4252),(107443,4253),(107444,4254),(107445,4255),(107446,4256),(107447,4274),(107448,4346),(107449,4347),(107450,4348),(107451,4349),(107452,4350),(107453,4351),(107454,4352),(107455,4353),(107456,4354),(107457,4355),(107458,4611),(107459,4615),(107460,4616),(107461,4617),(107462,4618),(107463,4619),(107464,4620),(107465,4625),(107466,4626),(107467,4677),(107468,4678),(107469,4679),(107470,4681),(107471,4682),(107472,4683),(107473,4684),(107474,4685),(107475,4686),(107476,4731),(107477,4732),(107478,4733),(107479,4734),(107480,4735),(107481,4736),(107482,4737),(107483,4738),(107484,4739),(107485,4740),(107486,4741),(107487,4742),(107488,4743),(107489,4744),(107490,4745),(107491,4746),(107492,4747),(107493,4748),(107494,4749),(107495,4750),(107496,4751),(107497,4752),(107498,4753),(107499,4754),(107500,4755),(107501,4756),(107502,4757),(107503,4758),(107504,4759),(107505,4760),(107506,4761),(107507,4762),(107508,4763),(107509,4764),(107510,4765),(107511,4766),(107512,4767),(107513,4768),(107514,4769),(107515,4770),(107516,4771),(107517,4772),(107518,4773),(107519,4774),(107520,4775),(107521,4776),(107522,4777),(107523,4778),(107524,4779),(107525,4780),(107526,4781),(107527,4782),(107528,4783),(107529,4784),(107530,4785),(107531,4786),(107532,4787),(107533,4788),(107534,4789),(107535,4790),(107536,4791),(107537,4792),(107538,4793),(107539,4794),(107540,4795),(107541,4796),(107542,4797),(107543,4798),(107544,4799),(107545,4800),(107546,4801),(107547,4802),(107548,4803),(107549,4804),(107550,4805),(107551,4806),(107552,4807),(107553,4808),(107554,4824),(107555,4825),(107556,4826),(107557,4827),(107558,4828),(107559,4829),(107560,4830),(107561,4831),(107562,4832),(107563,4833),(107564,4912),(107565,4913),(107566,4914),(107567,4915),(107568,4916),(107569,4917),(107570,4918),(107571,4919),(107572,4920),(107573,4921),(107574,4922),(107575,4923),(107576,4924),(107577,4925),(107578,4926),(107579,4927),(107580,4928),(107581,4929),(107582,4930),(107583,4931),(107584,4932),(107585,4934),(107586,4935),(107587,4936),(107588,4937),(107589,4938),(107590,4939),(107591,4940),(107592,4941),(107593,4957),(107594,4958),(107595,4959),(107596,4960),(107597,4961),(107598,4962),(107599,4963),(107600,4964),(107601,4965),(107602,4966),(107603,5017),(107604,5018),(107605,5037),(107606,5038),(107607,5062),(107608,5063),(107609,5064),(107610,5073),(107611,5074),(107612,5075),(107613,5076),(107614,5088),(107615,5089),(107616,5091),(107617,5092),(107618,5106),(107619,5107),(107620,5108),(107621,5109),(107622,5114),(107623,5115),(107624,5132),(107625,5133),(107626,5134),(107627,5135),(107628,5143),(107629,5144),(107630,5145),(107631,5146),(107632,5169),(107633,5170),(107634,5172),(107635,5173),(107636,5174),(107637,5175),(107638,5176),(107639,5177),(107640,5184),(107641,5185),(107642,5186),(107643,5187),(107644,5188),(107645,5189),(107646,5200),(107647,5201),(107648,5238),(107649,5239),(107650,5240),(107651,5241),(107652,5242),(107653,5243),(107654,5244),(107655,5245),(107656,5246),(107657,5247),(107658,2435),(107659,4573),(107660,4574),(107661,4575),(107662,4576),(107663,4578),(107664,4579),(107665,4580),(107666,4581),(107667,4605),(107668,4606),(107669,4607),(107670,4609),(107671,4610),(107672,398),(107673,399),(107674,410),(107675,418),(107676,432),(107677,436),(107678,441),(107679,442),(107680,485),(107681,512),(107682,513),(107683,514),(107684,516),(107685,529),(107686,530),(107687,531),(107688,532),(107689,647),(107690,651),(107691,668),(107692,669),(107693,674),(107694,1636),(107695,1637),(107696,1638),(107697,1639),(107698,1640),(107699,1641),(107700,1642),(107701,1643),(107702,1644),(107703,1645),(107704,1646),(107705,1647),(107706,1648),(107707,1649),(107708,2017),(107709,2351),(107710,3732),(107711,4816),(107712,4967),(107713,5100),(107714,5285),(107715,5286),(107716,5296),(107717,5297),(107718,5298),(107719,5413),(107720,5414),(107721,5418),(107722,5419),(107723,5541),(107724,5548),(107725,5593),(107726,5692),(107727,5694),(107728,5700),(107729,5711),(107730,5738),(107731,3860),(107732,3862),(107733,3863),(107734,3864),(107735,3865),(107736,3866),(107737,3867),(107738,3869),(107739,3881),(107740,3883),(107741,3886),(107742,3888),(107743,3891),(107744,3900),(107745,3901),(107746,3902),(107747,3906),(107748,3907),(107749,3908),(107750,3939),(107751,3940),(107752,3943),(107753,3944),(107754,3945),(107755,3946),(107756,3947),(107757,3948),(107758,3949),(107759,3950),(107760,3951),(107761,3952),(107762,3953),(107763,3954),(107764,3955),(107765,3956),(107766,3957),(107767,3958),(107768,3959),(107769,3960),(107770,3961),(107771,3962),(107772,3971),(107773,3990),(107774,3991),(107775,3992),(107776,3993),(107777,3994),(107778,3995),(107779,3996),(107780,3997),(107781,3998),(107782,3999),(107783,4000),(107784,4001),(107785,4002),(107786,4003),(107787,4004),(107788,4005),(107789,4006),(107790,4007),(107791,4008),(107792,4009),(107793,4010),(107794,4011),(107795,4038),(107796,4040),(107797,4042),(107798,4044),(107799,4045),(107800,4046),(107801,4047),(107802,4048),(107803,4049),(107804,4050),(107805,4051),(107806,4056),(107807,4061),(107808,4071),(107809,4072),(107810,4073),(107811,4074),(107812,4098),(107813,4099),(107814,4100),(107815,4101),(107816,4102),(107817,4103),(107818,4104),(107819,4105),(107820,4106),(107821,4107),(107822,4108),(107823,4109),(107824,4110),(107825,4111),(107826,4112),(107827,4113),(107828,4114),(107829,4115),(107830,4116),(107831,4117),(107832,4118),(107833,4125),(107834,4126),(107835,4144),(107836,4155),(107837,4157),(107838,4158),(107839,4159),(107840,4160),(107841,4161),(107842,4163),(107843,4164),(107844,4165),(107845,4166),(107846,4169),(107847,4176),(107848,4177),(107849,4178),(107850,4213),(107851,4221),(107852,4242),(107853,4246),(107854,4258),(107855,4260),(107856,4263),(107857,4264),(107858,4265),(107859,4266),(107860,4267),(107861,4268),(107862,4269),(107863,4286),(107864,4320),(107865,4321),(107866,4322),(107867,4323),(107868,4324),(107869,4325),(107870,4344),(107871,4345),(107872,4361),(107873,4367),(107874,4421),(107875,4423),(107876,4428),(107877,4429),(107878,4440),(107879,4479),(107880,3872),(107881,3873),(107882,3885),(107883,3919),(107884,3920),(107885,3921),(107886,3922),(107887,4043),(107888,4054),(107889,4055),(107890,4075),(107891,4076),(107892,4077),(107893,4078),(107894,4092),(107895,4093),(107896,4094),(107897,4095),(107898,4096),(107899,4097),(107900,4120),(107901,4142),(107902,4143),(107903,4150),(107904,4151),(107905,4162),(107906,4199),(107907,4200),(107908,4201),(107909,4214),(107910,4271),(107911,4272),(107912,4273),(107913,4306),(107914,4313),(107915,4314),(107916,4341),(107917,4358),(107918,4416),(107919,4430),(107920,4431),(107921,4457),(107922,3719),(107923,3720),(107924,3721),(107925,3722),(107926,3723),(107927,3724),(107928,3725),(107929,3726),(107930,3727),(107931,3728),(107932,3729),(107933,3730),(107934,3731),(107935,3732),(107936,3733),(107937,3734),(107938,3735),(107939,3736),(107940,3737),(107941,3738),(107942,3739),(107943,3740),(107944,3741),(107945,3742),(107946,3743),(107947,3744),(107948,3745),(107949,3746),(107950,3747),(107951,3748),(107952,3749),(107953,3751),(107954,3752),(107955,3753),(107956,3754),(107957,3755),(107958,3756),(107959,3757),(107960,3758),(107961,3759),(107962,3760),(107963,3761),(107964,3762),(107965,3763),(107966,3764),(107967,3765),(107968,3909),(107969,4041),(107970,305),(107971,306),(107972,307),(107973,308),(107974,309),(107975,310),(107976,311),(107977,312),(107978,313),(107979,314),(107980,315),(107981,316),(107982,317),(107983,318),(107984,319),(107985,320),(107986,321),(107987,322),(107988,323),(107989,324),(107990,325),(107991,326),(107992,327),(107993,328),(107994,329),(107995,330),(107996,331),(107997,332),(107998,333),(107999,334),(108000,335),(108001,336),(108002,337),(108003,338),(108004,339),(108005,340),(108006,341),(108007,342),(108008,343),(108009,344),(108010,345),(108011,346),(108012,347),(108013,903),(108014,904),(108015,905),(108016,907),(108017,1813),(108018,1814),(108019,1815),(108020,1816),(108021,1817),(108022,1818),(108023,1819),(108024,1820),(108025,1821),(108026,1822),(108027,1823),(108028,1824),(108029,1825),(108030,1826),(108031,1827),(108032,1828),(108033,1829),(108034,1830),(108035,1831),(108036,1832),(108037,1833),(108038,1834),(108039,1835),(108040,1950),(108041,1951),(108042,1952),(108043,1953),(108044,1954),(108045,1955),(108046,1956),(108047,1957),(108048,1958),(108049,1965),(108050,1966),(108051,1967),(108052,1968),(108053,1969),(108054,1970),(108055,1971),(108056,2154),(108057,2158),(108058,2159),(108059,2160),(108060,2161),(108061,2162),(108062,2170),(108063,2171),(108064,2172),(108065,2173),(108066,2174),(108067,2175),(108068,2177),(108069,2181),(108070,2182),(108071,2183),(108072,2184),(108073,2185),(108074,2186),(108075,2199),(108076,2211),(108077,2212),(108078,2213),(108079,2223),(108080,2224),(108081,2225),(108082,2226),(108083,2227),(108084,2228),(108085,2229),(108086,2230),(108087,2231),(108088,2281),(108089,2282),(108090,2292),(108091,2294),(108092,2295),(108093,2297),(108094,2298),(108095,2432),(108096,2433),(108097,2434),(108098,2436),(108099,2437),(108100,2438),(108101,2439),(108102,2443),(108103,2444),(108104,2445),(108105,2446),(108106,2447),(108107,2448),(108108,2475),(108109,2476),(108110,2477),(108111,2478),(108112,2479),(108113,2480),(108114,2481),(108115,2482),(108116,2483),(108117,2484),(108118,2485),(108119,2486),(108120,2487),(108121,2488),(108122,2492),(108123,2493),(108124,2494),(108125,2495),(108126,2496),(108127,2497),(108128,2498),(108129,2499),(108130,2500),(108131,2513),(108132,2514),(108133,2529),(108134,2530),(108135,2539),(108136,2553),(108137,2554),(108138,2582),(108139,2583),(108140,2584),(108141,2585),(108142,2586),(108143,2587),(108144,4613),(108145,4614),(108146,4857),(108147,4858),(108148,4859),(108149,4860),(108150,4861),(108151,4862),(108152,4863),(108153,4864),(108154,4865),(108155,4866),(108156,4867),(108157,4868),(108158,4869),(108159,4870),(108160,4871),(108161,4872),(108162,4873),(108163,4874),(108164,4875),(108165,4876),(108166,4891),(108167,4892),(108168,4893),(108169,4894),(108170,281),(108171,282),(108172,283),(108173,284),(108174,285),(108175,286),(108176,287),(108177,288),(108178,289),(108179,290),(108180,291),(108181,292),(108182,293),(108183,294),(108184,295),(108185,296),(108186,297),(108187,298),(108188,299),(108189,300),(108190,301),(108191,302),(108192,303),(108193,304),(108194,1144),(108195,1145),(108196,1146),(108197,1147),(108198,1148),(108199,1151),(108200,1152),(108201,1153),(108202,1154),(108203,1155),(108204,1156),(108205,1157),(108206,1158),(108207,1159),(108208,1160),(108209,1161),(108210,1496),(108211,1836),(108212,1837),(108213,1838),(108214,1839),(108215,1840),(108216,1841),(108217,1842),(108218,1843),(108219,1844),(108220,1845),(108221,1846),(108222,1847),(108223,1848),(108224,1849),(108225,1850),(108226,1851),(108227,1852),(108228,1853),(108229,1854),(108230,1855),(108231,1856),(108232,1857),(108233,1858),(108234,1859),(108235,1860),(108236,1861),(108237,1862),(108238,1863),(108239,1864),(108240,1865),(108241,1866),(108242,1867),(108243,1868),(108244,1869),(108245,1870),(108246,1871),(108247,1872),(108248,1873),(108249,1874),(108250,1875),(108251,1876),(108252,1877),(108253,1878),(108254,1879),(108255,1880),(108256,1881),(108257,1882),(108258,1883),(108259,1884),(108260,1885),(108261,1886),(108262,1887),(108263,1888),(108264,1889),(108265,1890),(108266,1891),(108267,1892),(108268,1893),(108269,1894),(108270,1895),(108271,1896),(108272,1897),(108273,1898),(108274,1899),(108275,1900),(108276,1901),(108277,1902),(108278,1903),(108279,1904),(108280,1905),(108281,1906),(108282,1907),(108283,1908),(108284,1909),(108285,1910),(108286,1911),(108287,1912),(108288,1913),(108289,1914),(108290,1915),(108291,1916),(108292,1917),(108293,1918),(108294,1919),(108295,1920),(108296,1921),(108297,1922),(108298,1923),(108299,1924),(108300,1925),(108301,1926),(108302,1927),(108303,1928),(108304,1929),(108305,1930),(108306,1931),(108307,1932),(108308,1933),(108309,1934),(108310,1935),(108311,1936),(108312,1937),(108313,1938),(108314,1939),(108315,1940),(108316,1941),(108317,1942),(108318,1943),(108319,1944),(108320,1945),(108321,1946),(108322,1947),(108323,1948),(108324,1949),(108325,4491),(108326,4492),(108327,4493),(108328,4494),(108329,4495),(108330,4496),(108331,4497),(108332,4498),(108333,4499),(108334,4537),(108335,4897),(108336,5286),(108337,1219),(108338,1220),(108339,1221),(108340,1222),(108341,1223),(108342,1224),(108343,1225),(108344,1226),(108345,1227),(108346,1228),(108347,1229),(108348,1230),(108349,1231),(108350,1232),(108351,1233),(108352,1234),(108353,1235),(108354,1236),(108355,1237),(108356,1238),(108357,1239),(108358,1240),(108359,1241),(108360,1242),(108361,1243),(108362,1244),(108363,1245),(108364,1246),(108365,1247),(108366,1248),(108367,1249),(108368,1250),(108369,1251),(108370,1252),(108371,1253),(108372,1254),(108373,1255),(108374,1256),(108375,1257),(108376,1258),(108377,1259),(108378,1260),(108379,1261),(108380,1262),(108381,1263),(108382,1264),(108383,1265),(108384,1266),(108385,1267),(108386,1268),(108387,1269),(108388,1270),(108389,1271),(108390,1272),(108391,1273),(108392,1274),(108393,1275),(108394,1276),(108395,1277),(108396,1278),(108397,1279),(108398,1280),(108399,1281),(108400,1282),(108401,1283),(108402,1284),(108403,1285),(108404,1286),(108405,1287),(108406,1288),(108407,1289),(108408,1290),(108409,1291),(108410,1292),(108411,1293),(108412,1294),(108413,1295),(108414,1296),(108415,1297),(108416,1298),(108417,1299),(108418,1300),(108419,1301),(108420,1302),(108421,1303),(108422,1304),(108423,1305),(108424,1306),(108425,1307),(108426,1308),(108427,1309),(108428,1310),(108429,1311),(108430,1312),(108431,1313),(108432,1314),(108433,1315),(108434,1316),(108435,1317),(108436,1318),(108437,1319),(108438,1320),(108439,1321),(108440,1322),(108441,1323),(108442,1332),(108443,1342),(108444,1346),(108445,1347),(108446,1349),(108447,1350),(108448,1351),(108449,1353),(108450,1354),(108451,1355),(108452,1356),(108453,1357),(108454,1358),(108455,1359),(108456,1360),(108457,1361),(108458,1362),(108459,1363),(108460,1364),(108461,1366),(108462,1367),(108463,1368),(108464,1371),(108465,1375),(108466,1376),(108467,1377),(108468,1379),(108469,1389),(108470,1390),(108471,1391),(108472,1392),(108473,1393),(108474,1394),(108475,1395),(108476,1397),(108477,1398),(108478,1400),(108479,1420),(108480,1421),(108481,1422),(108482,1423),(108483,1424),(108484,1425),(108485,1427),(108486,1428),(108487,1429),(108488,1430),(108489,1431),(108490,1432),(108491,1433),(108492,1434),(108493,1435),(108494,1442),(108495,1443),(108496,1444),(108497,1445),(108498,1446),(108499,1447),(108500,1448),(108501,1450),(108502,1451),(108503,1452),(108504,1454),(108505,1455),(108506,1456),(108507,1457),(108508,1462),(108509,1469),(108510,1749),(108511,4500),(108512,4501),(108513,4502),(108514,4503),(108515,4504),(108516,4505),(108517,4506),(108518,4507),(108519,4508),(108520,4509),(108521,4510),(108522,4511),(108523,4512),(108524,4513),(108525,4514),(108526,4515),(108527,4516),(108528,4517),(108529,4518),(108530,4519),(108531,4520),(108532,4522),(108533,4523),(108534,5301),(108535,5468),(108536,5489),(108537,582),(108538,583),(108539,584),(108540,585),(108541,586),(108542,587),(108543,588),(108544,589),(108545,590),(108546,591),(108547,592),(108548,593),(108549,594),(108550,595),(108551,596),(108552,597),(108553,598),(108554,599),(108555,600),(108556,601),(108557,602),(108558,603),(108559,604),(108560,605),(108561,606),(108562,607),(108563,608),(108564,609),(108565,610),(108566,612),(108567,626),(108568,627),(108569,628),(108570,629),(108571,630),(108572,631),(108573,754),(108574,755),(108575,756),(108576,757),(108577,758),(108578,759),(108579,760),(108580,761),(108581,762),(108582,763),(108583,764),(108584,765),(108585,766),(108586,767),(108587,768),(108588,769),(108589,770),(108590,771),(108591,772),(108592,773),(108593,774),(108594,775),(108595,776),(108596,777),(108597,778),(108598,779),(108599,780),(108600,781),(108601,782),(108602,783),(108603,784),(108604,785),(108605,786),(108606,787),(108607,788),(108608,789),(108609,790),(108610,791),(108611,792),(108612,793),(108613,794),(108614,795),(108615,796),(108616,797),(108617,798),(108618,799),(108619,800),(108620,801),(108621,802),(108622,803),(108623,804),(108624,805),(108625,806),(108626,807),(108627,808),(108628,809),(108629,810),(108630,811),(108631,812),(108632,813),(108633,814),(108634,815),(108635,816),(108636,817),(108637,818),(108638,819),(108639,820),(108640,821),(108641,822),(108642,823),(108643,824),(108644,825),(108645,826),(108646,827),(108647,828),(108648,829),(108649,830),(108650,831),(108651,832),(108652,833),(108653,834),(108654,835),(108655,836),(108656,837),(108657,838),(108658,839),(108659,840),(108660,841),(108661,842),(108662,843),(108663,844),(108664,845),(108665,846),(108666,847),(108667,848),(108668,849),(108669,850),(108670,851),(108671,852),(108672,853),(108673,854),(108674,855),(108675,856),(108676,857),(108677,858),(108678,859),(108679,860),(108680,861),(108681,862),(108682,863),(108683,864),(108684,865),(108685,866),(108686,867),(108687,868),(108688,869),(108689,870),(108690,871),(108691,872),(108692,1020),(108693,1021),(108694,1022),(108695,1023),(108696,1106),(108697,1166),(108698,1167),(108699,1168),(108700,1169),(108701,1170),(108702,1171),(108703,1172),(108704,1173),(108705,1174),(108706,1175),(108707,1176),(108708,1177),(108709,1178),(108710,1179),(108711,1180),(108712,1181),(108713,1182),(108714,1183),(108715,1195),(108716,1196),(108717,1197),(108718,1198),(108719,1199),(108720,1200),(108721,1201),(108722,1202),(108723,1203),(108724,1204),(108725,1205),(108726,1206),(108727,1207),(108728,1210),(108729,1211),(108730,1212),(108731,1213),(108732,1214),(108733,1215),(108734,1216),(108735,1217),(108736,1218),(108737,348),(108738,349),(108739,350),(108740,351),(108741,352),(108742,353),(108743,354),(108744,355),(108745,356),(108746,357),(108747,358),(108748,359),(108749,360),(108750,361),(108751,370),(108752,371),(108753,372),(108754,373),(108755,374),(108756,375),(108757,376),(108758,377),(108759,378),(108760,379),(108761,380),(108762,381),(108763,382),(108764,383),(108765,384),(108766,385),(108767,386),(108768,387),(108769,388),(108770,389),(108771,390),(108772,391),(108773,392),(108774,393),(108775,394),(108776,395),(108777,396),(108778,397),(108779,533),(108780,534),(108781,535),(108782,536),(108783,537),(108784,538),(108785,539),(108786,540),(108787,541),(108788,542),(108789,543),(108790,544),(108791,545),(108792,546),(108793,547),(108794,548),(108795,549),(108796,550),(108797,551),(108798,552),(108799,553),(108800,554),(108801,555),(108802,556),(108803,558),(108804,559),(108805,561),(108806,562),(108807,563),(108808,564),(108809,565),(108810,566),(108811,567),(108812,568),(108813,569),(108814,570),(108815,571),(108816,572),(108817,573),(108818,574),(108819,575),(108820,576),(108821,577),(108822,578),(108823,579),(108824,580),(108825,581),(108826,5500),(108827,5501),(108828,5502),(108829,5503),(108830,5504),(108831,5505),(108832,5506),(108833,5507),(108834,5508),(108835,5509),(108836,5510),(108837,5511),(108838,5512),(108839,5513),(108840,5514),(108841,5515),(108842,5516),(108843,5517),(108844,5518),(108845,5519),(108846,1024),(108847,2026),(108848,2027),(108849,2028),(108850,2029),(108851,2030),(108852,2031),(108853,2032),(108854,2034),(108855,2039),(108856,2040),(108857,2042),(108858,2044),(108859,2045),(108860,2046),(108861,2122),(108862,2123),(108863,2124),(108864,2125),(108865,2126),(108866,2127),(108867,2128),(108868,2129),(108869,2130),(108870,2131),(108871,2132),(108872,2133),(108873,2134),(108874,2135),(108875,2136),(108876,2137),(108877,2138),(108878,2139),(108879,2140),(108880,2141),(108881,2142),(108882,2143),(108883,2144),(108884,2145),(108885,2146),(108886,2147),(108887,2148),(108888,2149),(108889,2150),(108890,2151),(108891,2152),(108892,2153),(108893,2275),(108894,2323),(108895,2324),(108896,2325),(108897,2326),(108898,2327),(108899,2328),(108900,2329),(108901,2330),(108902,2331),(108903,2332),(108904,2333),(108905,2334),(108906,2335),(108907,2336),(108908,2337),(108909,2338),(108910,2339),(108911,2340),(108912,2341),(108913,2342),(108914,2343),(108915,2344),(108916,2345),(108917,2346),(108918,2347),(108919,2348),(108920,2349),(108921,2350),(108922,2351),(108923,2352),(108924,2353),(108925,2354),(108926,2355),(108927,2356),(108928,2357),(108929,2358),(108930,2359),(108931,2360),(108932,2361),(108933,2362),(108934,2363),(108935,2364),(108936,2365),(108937,2366),(108938,2367),(108939,2368),(108940,2369),(108941,2370),(108942,2371),(108943,2372),(108944,2373),(108945,2374),(108946,2375),(108947,2376),(108948,2377),(108949,2378),(108950,2379),(108951,2380),(108952,2381),(108953,2382),(108954,2383),(108955,2384),(108956,2385),(108957,2386),(108958,2387),(108959,2388),(108960,2389),(108961,2390),(108962,2391),(108963,2559),(108964,4933),(108965,5490),(108966,5491),(108967,5492),(108968,5493),(108969,5494),(108970,5495),(108971,5496),(108972,5497),(108973,5498),(108974,5499),(108975,240),(108976,241),(108977,242),(108978,243),(108979,246),(108980,247),(108981,248),(108982,258),(108983,259),(108984,260),(108985,261),(108986,262),(108987,263),(108988,264),(108989,265),(108990,909),(108991,910),(108992,911),(108993,912),(108994,913),(108995,914),(108996,915),(108997,916),(108998,917),(108999,918),(109000,919),(109001,920),(109002,921),(109003,922),(109004,923),(109005,924),(109006,925),(109007,926),(109008,927),(109009,928),(109010,929),(109011,930),(109012,931),(109013,932),(109014,933),(109015,934),(109016,935),(109017,936),(109018,937),(109019,938),(109020,939),(109021,940),(109022,941),(109023,942),(109024,943),(109025,944),(109026,945),(109027,946),(109028,947),(109029,948),(109030,949),(109031,950),(109032,951),(109033,952),(109034,953),(109035,954),(109036,955),(109037,956),(109038,957),(109039,958),(109040,959),(109041,960),(109042,961),(109043,962),(109044,963),(109045,964),(109046,965),(109047,966),(109048,967),(109049,968),(109050,969),(109051,970),(109052,971),(109053,972),(109054,973),(109055,974),(109056,975),(109057,976),(109058,977),(109059,978),(109060,979),(109061,980),(109062,981),(109063,982),(109064,983),(109065,984),(109066,985),(109067,986),(109068,987),(109069,988),(109070,989),(109071,990),(109072,991),(109073,992),(109074,993),(109075,994),(109076,995),(109077,1007),(109078,1008),(109079,1009),(109080,1010),(109081,1011),(109082,1040),(109083,1041),(109084,1042),(109085,1043),(109086,1044),(109087,1045),(109088,1046),(109089,1047),(109090,1048),(109091,1093),(109092,1094),(109093,1095),(109094,1096),(109095,1097),(109096,1098),(109097,1100),(109098,1101),(109099,1102),(109100,1103),(109101,1104),(109102,1105),(109103,1107),(109104,1108),(109105,1109),(109106,1110),(109107,1111),(109108,1112),(109109,1113),(109110,1114),(109111,1115),(109112,1116),(109113,1117),(109114,1118),(109115,1120),(109116,1121),(109117,1122),(109118,1123),(109119,1124),(109120,1125),(109121,1134),(109122,1135),(109123,1136),(109124,1137),(109125,1138),(109126,1139),(109127,1518),(109128,1519),(109129,1520),(109130,1521),(109131,1533),(109132,1563),(109133,1564),(109134,1565),(109135,1566),(109136,1588),(109137,1589),(109138,1590),(109139,1591),(109140,1592),(109141,1593),(109142,1594),(109143,1595),(109144,1596),(109145,1597),(109146,1598),(109147,1599),(109148,1604),(109149,1607),(109150,1610),(109151,1618),(109152,1619),(109153,1620),(109154,1621),(109155,1623),(109156,1626),(109157,1658),(109158,1659),(109159,1660),(109160,1665),(109161,1666),(109162,1675),(109163,1676),(109164,1677),(109165,1678),(109166,1733),(109167,1734),(109168,1735),(109169,1751),(109170,1752),(109171,1753),(109172,1754),(109173,1755),(109174,1756),(109175,1757),(109176,1758),(109177,1761),(109178,1762),(109179,1778),(109180,1779),(109181,1786),(109182,1787),(109183,1788),(109184,1789),(109185,1790),(109186,2454),(109187,2455),(109188,2456),(109189,2699),(109190,2919),(109191,2920),(109192,2921),(109193,2922),(109194,2923),(109195,2924),(109196,2925),(109197,2926),(109198,2927),(109199,2928),(109200,2929),(109201,2930),(109202,2931),(109203,2932),(109204,2933),(109205,2934),(109206,2935),(109207,2936),(109208,2937),(109209,2938),(109210,2939),(109211,2940),(109212,2941),(109213,2942),(109214,2943),(109215,2944),(109216,2945),(109217,2946),(109218,2947),(109219,2948),(109220,2949),(109221,2950),(109222,2951),(109223,2952),(109224,2953),(109225,2954),(109226,2979),(109227,2980),(109228,3042),(109229,3164),(109230,3165),(109231,3166),(109232,3534),(109233,3535),(109234,3536),(109235,4566),(109236,4567),(109237,4568),(109238,4569),(109239,4570),(109240,4571),(109241,4572),(109242,4577),(109243,5077),(109244,5078),(109245,5079),(109246,5080),(109247,5081),(109248,5082),(109249,5083),(109250,5084),(109251,5085),(109252,5086),(109253,5087),(109254,5093),(109255,5094),(109256,5095),(109257,5096),(109258,5250),(109259,5251),(109260,5252),(109261,5253),(109262,5254),(109263,5255),(109264,5258),(109265,5259),(109266,5260),(109267,5261),(109268,5262),(109269,5263),(109270,5264),(109271,5265),(109272,5266),(109273,5267),(109274,5268),(109275,5269),(109276,5270),(109277,5323),(109278,5324),(109279,5325),(109280,5326),(109281,5327),(109282,5328),(109283,5329),(109284,5330),(109285,5331),(109286,5332),(109287,5333),(109288,5334),(109289,5335),(109290,5336),(109291,5337),(109292,5343),(109293,5344),(109294,5351),(109295,5352),(109296,5354),(109297,5356),(109298,5367),(109299,5369),(109300,5372),(109301,5373),(109302,5374),(109303,5375),(109304,5376),(109305,5377),(109306,5390),(109307,5402),(109308,5433),(109309,5434),(109310,5451),(109311,5452),(109312,5453),(109313,5454),(109314,5455),(109315,5474),(109316,5475),(109317,5476),(109318,5477),(109319,5478),(109320,5479),(109321,5480),(109322,5481),(109323,5484),(109324,5485),(109325,5486),(109326,5487),(109327,5488),(109328,5524),(109329,5526),(109330,5527),(109331,5528),(109332,5529),(109333,5530),(109334,5531),(109335,5532),(109336,5533),(109337,5534),(109338,5535),(109339,5558),(109340,5563),(109341,5564),(109342,5566),(109343,5570),(109344,5577),(109345,5578),(109346,5580),(109347,5581),(109348,5588),(109349,5674),(109350,5675),(109351,5676),(109352,5677),(109353,5678),(109354,5679),(109355,5738),(109356,5028),(109357,5029),(109358,5030),(109359,5031),(109360,5032),(109361,5033),(109362,5034),(109363,5035),(109364,5036),(109365,5359),(109366,5360),(109367,5361),(109368,5362),(109369,5363),(109370,5364),(109371,5365),(109372,5366),(109373,5420),(109374,5431),(109375,5435),(109376,5436),(109377,5437),(109378,5438),(109379,5439),(109380,5440),(109381,5441),(109382,5442),(109383,5443),(109384,5444),(109385,5445),(109386,5446),(109387,5447),(109388,5448),(109389,5449),(109390,5450),(109391,5525),(109392,5707),(109393,5708),(109394,162),(109395,176),(109396,177),(109397,178),(109398,179),(109399,180),(109400,181),(109401,182),(109402,183),(109403,184),(109404,185),(109405,186),(109406,187),(109407,188),(109408,189),(109409,190),(109410,191),(109411,192),(109412,193),(109413,194),(109414,195),(109415,196),(109416,197),(109417,198),(109418,199),(109419,200),(109420,201),(109421,202),(109422,203),(109423,204),(109424,205),(109425,206),(109426,207),(109427,208),(109428,209),(109429,210),(109430,211),(109431,212),(109432,213),(109433,214),(109434,215),(109435,216),(109436,217),(109437,218),(109438,219),(109439,220),(109440,5393),(109441,5394),(109442,5395),(109443,5396),(109444,5397),(109445,5398),(109446,5399),(109447,5400),(109448,1650),(109449,1651),(109450,1652),(109451,1653),(109452,1687),(109453,1688),(109454,1689),(109455,1690),(109456,1691),(109457,1692),(109458,1693),(109459,1694),(109460,1695),(109461,1696),(109462,1697),(109463,1698),(109464,1699),(109465,1700),(109466,1701),(109467,1702),(109468,1703),(109469,1704),(109470,1737),(109471,1738),(109472,1773),(109473,4612),(109474,4718),(109475,4730),(109476,4812),(109477,4813),(109478,4814),(109479,4815),(109480,4816),(109481,4817),(109482,4818),(109483,4819),(109484,4820),(109485,4821),(109486,4822),(109487,4845),(109488,4955),(109489,4956),(109490,4967),(109491,4968),(109492,4969),(109493,5090),(109494,5097),(109495,5098),(109496,5099),(109497,5100),(109498,5101),(109499,5102),(109500,5103),(109501,5104),(109502,5110),(109503,5111),(109504,5112),(109505,5113),(109506,5116),(109507,5117),(109508,5118),(109509,5119),(109510,5120),(109511,5456),(109512,5457),(109513,5459),(109514,5460),(109515,5461),(109516,5462),(109517,5702),(109518,5703),(109519,1679),(109520,1680),(109521,1708),(109522,1709),(109523,1710),(109524,1711),(109525,1712),(109526,1713),(109527,1714),(109528,1748),(109529,1791),(109530,1792),(109531,1798),(109532,2187),(109533,2188),(109534,2189),(109535,2190),(109536,2191),(109537,2192),(109538,2193),(109539,2194),(109540,2195),(109541,2196),(109542,2197),(109543,2198),(109544,2232),(109545,2233),(109546,2234),(109547,2235),(109548,2236),(109549,2237),(109550,2238),(109551,2239),(109552,2240),(109553,2392),(109554,2393),(109555,2394),(109556,2395),(109557,2411),(109558,2412),(109559,2577),(109560,2578),(109561,2579),(109562,2580),(109563,2581),(109564,2589),(109565,2590),(109566,2591),(109567,2592),(109568,2593),(109569,2594),(109570,2595),(109571,2596),(109572,2597),(109573,2598),(109574,2599),(109575,2600),(109576,2601),(109577,2602),(109578,2603),(109579,2604),(109580,2605),(109581,2606),(109582,2607),(109583,2608),(109584,2609),(109585,2610),(109586,2611),(109587,2612),(109588,2613),(109589,2614),(109590,4621),(109591,4629),(109592,4630),(109593,4631),(109594,4632),(109595,4633),(109596,4634),(109597,4635),(109598,4636),(109599,4637),(109600,4638),(109601,4639),(109602,4640),(109603,4641),(109604,4642),(109605,4643),(109606,4644),(109607,4645),(109608,4646),(109609,4647),(109610,4648),(109611,4649),(109612,4650),(109613,4651),(109614,4652),(109615,4653),(109616,4654),(109617,4655),(109618,4656),(109619,4657),(109620,4658),(109621,4659),(109622,4660),(109623,4661),(109624,4662),(109625,4663),(109626,4664),(109627,4665),(109628,4666),(109629,4667),(109630,4896),(109631,4898),(109632,4900),(109633,4902),(109634,4903),(109635,4904),(109636,4943),(109637,4944),(109638,4945),(109639,4946),(109640,4947),(109641,4948),(109642,4949),(109643,4950),(109644,4951),(109645,4952),(109646,4953),(109647,4954),(109648,4971),(109649,4972),(109650,4973),(109651,4979),(109652,4980),(109653,4981),(109654,4982),(109655,4983),(109656,4984),(109657,4985),(109658,4986),(109659,4987),(109660,4988),(109661,4989),(109662,4990),(109663,4991),(109664,5001),(109665,5002),(109666,5105),(109667,5178),(109668,5179),(109669,5180),(109670,5181),(109671,5182),(109672,5202),(109673,5203),(109674,5204),(109675,5205),(109676,5206),(109677,5207),(109678,5208),(109679,5209),(109680,5210),(109681,5211),(109682,5212),(109683,5213),(109684,5214),(109685,5215),(109686,5216),(109687,5217),(109688,5218),(109689,5219),(109690,5220),(109691,5221),(109692,5222),(109693,5223),(109694,5224),(109695,5225),(109696,5226),(109697,5227),(109698,5228),(109699,5229),(109700,5230),(109701,5231),(109702,5232),(109703,5233),(109704,5234),(109705,5235),(109706,5236),(109707,5237),(109708,1527),(109709,1528),(109710,1529),(109711,1530),(109712,1531),(109713,1532),(109714,1534),(109715,1535),(109716,1536),(109717,1557),(109718,1558),(109719,1559),(109720,1562),(109721,1584),(109722,1585),(109723,1586),(109724,1587),(109725,1600),(109726,1601),(109727,1602),(109728,1603),(109729,1605),(109730,1606),(109731,1608),(109732,1609),(109733,1622),(109734,1624),(109735,1625),(109736,1627),(109737,1628),(109738,1661),(109739,1662),(109740,1663),(109741,1664),(109742,1667),(109743,1668),(109744,1669),(109745,1670),(109746,1671),(109747,1672),(109748,1673),(109749,1674),(109750,1715),(109751,1716),(109752,1717),(109753,1718),(109754,1719),(109755,1720),(109756,1721),(109757,1722),(109758,1723),(109759,1724),(109760,1725),(109761,1726),(109762,1727),(109763,1728),(109764,1729),(109765,1730),(109766,1731),(109767,1732),(109768,1736),(109769,1740),(109770,1743),(109771,1744),(109772,1745),(109773,1746),(109774,1747),(109775,1750),(109776,1780),(109777,1781),(109778,1782),(109779,1793),(109780,1794),(109781,1795),(109782,1799),(109783,1800),(109784,1801),(109785,1802),(109786,2515),(109787,2516),(109788,2918),(109789,3043),(109790,4582),(109791,4583),(109792,4584),(109793,4585),(109794,4586),(109795,4587),(109796,4588),(109797,4589),(109798,4590),(109799,4591),(109800,4592),(109801,4593),(109802,4594),(109803,4595),(109804,4596),(109805,4597),(109806,4598),(109807,4599),(109808,4600),(109809,4601),(109810,4602),(109811,4603),(109812,4604),(109813,4608),(109814,4834),(109815,4835),(109816,4836),(109817,4837),(109818,4838),(109819,4839),(109820,4840),(109821,4841),(109822,4842),(109823,4942),(109824,5121),(109825,5151),(109826,5152),(109827,5153),(109828,5154),(109829,5155),(109830,5156),(109831,5157),(109832,5158),(109833,5183),(109834,5248),(109835,5249),(109836,5256),(109837,5257),(109838,5355),(109839,5370),(109840,5371),(109841,5401),(109842,5403),(109843,5404),(109844,5405),(109845,5406),(109846,5407),(109847,5409),(109848,5421),(109849,5422),(109850,5423),(109851,5424),(109852,5425),(109853,5426),(109854,5427),(109855,5429),(109856,5430),(109857,5432),(109858,5458),(109859,5463),(109860,5464),(109861,5465),(109862,5466),(109863,5467),(109864,5482),(109865,5483),(109866,5520),(109867,5521),(109868,5522),(109869,5523),(109870,5551),(109871,5552),(109872,5553),(109873,5554),(109874,5555),(109875,5556),(109876,5557),(109877,5559),(109878,5560),(109879,5561),(109880,5562),(109881,5565),(109882,5567),(109883,5568),(109884,5569),(109885,5572),(109886,5573),(109887,5574),(109888,5575),(109889,5576),(109890,5579),(109891,5582),(109892,5583),(109893,5584),(109894,5585),(109895,5586),(109896,5587),(109897,5589),(109898,5590),(109899,5704),(109900,5705),(109901,5706),(109902,5739),(109903,5740),(109904,5741),(109905,5742),(109906,5743),(109907,5744),(109908,224),(109909,225),(109910,226),(109911,227),(109912,228),(109913,229),(109914,230),(109915,231),(109916,232),(109917,233),(109918,234),(109919,235),(109920,236),(109921,237),(109922,238),(109923,239),(109924,268),(109925,269),(109926,270),(109927,271),(109928,272),(109929,273),(109930,274),(109931,275),(109932,1006),(109933,1013),(109934,1014),(109935,1015),(109936,1016),(109937,1017),(109938,1018),(109939,1025),(109940,1026),(109941,1027),(109942,1028),(109943,1029),(109944,1030),(109945,1031),(109946,1032),(109947,1033),(109948,1126),(109949,1127),(109950,1128),(109951,1129),(109952,1130),(109953,1131),(109954,1132),(109955,1522),(109956,1523),(109957,1524),(109958,1525),(109959,1526),(109960,2422),(109961,2423),(109962,2424),(109963,2425),(109964,2426),(109965,2427),(109966,2428),(109967,2517),(109968,2518),(109969,2519),(109970,2520),(109971,2537),(109972,2538),(109973,4622),(109974,4623),(109975,4624),(109976,4853),(109977,4854),(109978,4855),(109979,4877),(109980,4878),(109981,4879),(109982,4880),(109983,4881),(109984,4882),(109985,4883),(109986,4884),(109987,4885),(109988,4886),(109989,4887),(109990,4888),(109991,4889),(109992,4890),(109993,4970),(109994,5368),(109995,5408),(109996,5410),(109997,5411),(109998,5412),(109999,5413),(110000,5414),(110001,5415),(110002,5416),(110003,5417),(110004,5418),(110005,5419),(110006,5428),(110007,5469),(110008,5470),(110009,5471),(110010,5472),(110011,5473),(110012,5538),(110013,5539),(110014,5540),(110015,5541),(110016,5542),(110017,5543),(110018,5544),(110019,5545),(110020,5546),(110021,5547),(110022,5548),(110023,5549),(110024,5550),(110025,5571),(110026,5591),(110027,5592),(110028,5593),(110029,5594),(110030,5595),(110031,5596),(110032,5597),(110033,5598),(110034,5599),(110035,5600),(110036,5601),(110037,5602),(110038,5603),(110039,5604),(110040,5605),(110041,5606),(110042,5607),(110043,5608),(110044,5609),(110045,5610),(110046,5611),(110047,5612),(110048,5613),(110049,5614),(110050,5615),(110051,5616),(110052,5617),(110053,5618),(110054,5619),(110055,5620),(110056,5621),(110057,5622),(110058,5623),(110059,5624),(110060,5625),(110061,5626),(110062,5627),(110063,5628),(110064,5629),(110065,5630),(110066,5631),(110067,5632),(110068,5633),(110069,5634),(110070,5635),(110071,5636),(110072,5637),(110073,5638),(110074,5639),(110075,5640),(110076,5641),(110077,5642),(110078,5643),(110079,5644),(110080,5645),(110081,5646),(110082,5647),(110083,5648),(110084,5649),(110085,5650),(110086,5651),(110087,5652),(110088,5653),(110089,5654),(110090,5655),(110091,5656),(110092,5657),(110093,5658),(110094,5659),(110095,5660),(110096,5661),(110097,5662),(110098,5663),(110099,5664),(110100,5665),(110101,5666),(110102,5667),(110103,5668),(110104,5669),(110105,5670),(110106,5671),(110107,5672),(110108,5682),(110109,5683),(110110,5684),(110111,5685),(110112,5686),(110113,5687),(110114,5688),(110115,5690),(110116,5691),(110117,5692),(110118,5693),(110119,5694),(110120,5695),(110121,5697),(110122,5698),(110123,5699),(110124,5700),(110125,5701),(110126,5709),(110127,5710),(110128,5711),(110129,5712),(110130,5713),(110131,5714),(110132,5715),(110133,5716),(110134,5717),(110135,5718),(110136,5719),(110137,5720),(110138,5721),(110139,5722),(110140,5723),(110141,5724),(110142,5725),(110143,5726),(110144,5727),(110145,5728),(110146,5729),(110147,5730),(110148,5731),(110149,5732),(110150,5733),(110151,5734),(110152,5735),(110153,5736),(110154,5737),(110155,5745),(110156,5746),(110157,5747),(110158,5748),(110159,5749),(110160,163),(110161,164),(110162,165),(110163,166),(110164,167),(110165,168),(110166,172),(110167,254),(110168,255),(110169,256),(110170,257),(110171,1049),(110172,1050),(110173,1051),(110174,1052),(110175,1053),(110176,1054),(110177,1055),(110178,1056),(110179,1057),(110180,1058),(110181,1059),(110182,1060),(110183,1061),(110184,1062),(110185,1063),(110186,1064),(110187,1065),(110188,1066),(110189,1067),(110190,1068),(110191,1069),(110192,1070),(110193,1071),(110194,1072),(110195,1073),(110196,1074),(110197,1075),(110198,1076),(110199,1077),(110200,1078),(110201,1079),(110202,1080),(110203,1081),(110204,1082),(110205,1083),(110206,1084),(110207,1085),(110208,1086),(110209,1087),(110210,1088),(110211,1089),(110212,1090),(110213,1091),(110214,1611),(110215,1612),(110216,1613),(110217,1614),(110218,1615),(110219,1616),(110220,1617),(110221,1654),(110222,1655),(110223,1656),(110224,1657),(110225,1705),(110226,1706),(110227,1707),(110228,1739),(110229,1741),(110230,1742),(110231,1759),(110232,1760),(110233,1764),(110234,1765),(110235,1766),(110236,1767),(110237,1768),(110238,1769),(110239,1770),(110240,1771),(110241,1772),(110242,1774),(110243,1775),(110244,1776),(110245,1777),(110246,1783),(110247,1784),(110248,1785),(110249,1812),(110250,1959),(110251,1960),(110252,1961),(110253,1962),(110254,1963),(110255,1964),(110256,2289),(110257,2290),(110258,2291),(110259,2293),(110260,2413),(110261,2414),(110262,2415),(110263,2416),(110264,2417),(110265,2418),(110266,2419),(110267,2420),(110268,2421),(110269,906),(110270,908),(110271,1004),(110272,1012),(110273,1019),(110274,1037),(110275,1092),(110276,1119),(110277,1162),(110278,1163),(110279,1164),(110280,1165),(110281,2163),(110282,2164),(110283,2176),(110284,2203),(110285,2204),(110286,2205),(110287,2206),(110288,2207),(110289,2247),(110290,2248),(110291,2249),(110292,2250),(110293,2270),(110294,2271),(110295,2277),(110296,2278),(110297,2279),(110298,2280),(110299,2296),(110300,2299),(110301,2300),(110302,2301),(110303,2429),(110304,2430),(110305,2431),(110306,2440),(110307,2441),(110308,2442),(110309,2457),(110310,2472),(110311,2473),(110312,2474),(110313,2489),(110314,2490),(110315,2491),(110316,2506),(110317,2507),(110318,2508),(110319,2509),(110320,2510),(110321,2511),(110322,2512),(110323,2521),(110324,2522),(110325,2523),(110326,2524),(110327,2525),(110328,2526),(110329,2527),(110330,2528),(110331,2531),(110332,2532),(110333,2533),(110334,2534),(110335,2535),(110336,2536),(110337,2540),(110338,2541),(110339,2542),(110340,2543),(110341,2544),(110342,2545),(110343,2546),(110344,2547),(110345,2548),(110346,2549),(110347,2550),(110348,2551),(110349,2573),(110350,2574),(110351,2575),(110352,2576),(110353,5757),(110354,5758),(110355,5759),(110356,3304),(110357,3305),(110358,3306),(110359,3307),(110360,3308),(110361,3309),(110362,3310),(110363,3311),(110364,3312),(110365,3313),(110366,3314),(110367,3315),(110368,3316),(110369,3317),(110370,3318),(110371,3319),(110372,3320),(110373,3321),(110374,3322),(110375,3323),(110376,3324),(110377,3325),(110378,3326),(110379,3327),(110380,3328),(110381,3329),(110382,3330),(110383,3331),(110384,3332),(110385,3333),(110386,3334),(110387,3335),(110388,3336),(110389,3337),(110390,3338),(110391,3339),(110392,3340),(110393,3341),(110394,3342),(110395,3343),(110396,3344),(110397,3345),(110398,3346),(110399,3347),(110400,3348),(110401,3349),(110402,3350),(110403,3351),(110404,3352),(110405,3353),(110406,3354),(110407,3355),(110408,3356),(110409,3357),(110410,3358),(110411,3359),(110412,3360),(110413,3361),(110414,3362),(110415,3363),(110416,3364),(110417,3365),(110418,3366),(110419,3367),(110420,3368),(110421,3369),(110422,3370),(110423,3371),(110424,3372),(110425,3373),(110426,3374),(110427,3375),(110428,3376),(110429,3377),(110430,3378),(110431,3379),(110432,3380),(110433,3381),(110434,3382),(110435,3383),(110436,3384),(110437,3385),(110438,3386),(110439,3387),(110440,3388),(110441,3389),(110442,3390),(110443,3391),(110444,3392),(110445,3393),(110446,3394),(110447,3395),(110448,3396),(110449,3397),(110450,3398),(110451,3399),(110452,3400),(110453,3401),(110454,3402),(110455,3403),(110456,3404),(110457,3405),(110458,3406),(110459,3407),(110460,3408),(110461,3409),(110462,3410),(110463,3411),(110464,3412),(110465,3413),(110466,3414),(110467,3415),(110468,3416),(110469,3417),(110470,3418),(110471,3419),(110472,3420),(110473,3421),(110474,3422),(110475,3423),(110476,3424),(110477,3425),(110478,3426),(110479,3427),(110480,3428),(110481,3429),(110482,3430),(110483,3431),(110484,3432),(110485,3433),(110486,3434),(110487,3435),(110488,3436),(110489,3437),(110490,3438),(110491,3439),(110492,3440),(110493,3441),(110494,3442),(110495,3443),(110496,3444),(110497,3445),(110498,3446),(110499,3447),(110500,3448),(110501,3449),(110502,3450),(110503,3451),(110504,3452),(110505,3453),(110506,3454),(110507,3455),(110508,3456),(110509,3457),(110510,3458),(110511,3459),(110512,3460),(110513,3461),(110514,3462),(110515,3463),(110516,3464),(110517,3465),(110518,3466),(110519,3467),(110520,3468),(110521,3469),(110522,3470),(110523,3471),(110524,3472),(110525,3473),(110526,3474),(110527,3475),(110528,3476),(110529,3477),(110530,3478),(110531,3479),(110532,3480),(110533,3481),(110534,3482),(110535,3483),(110536,3484),(110537,3485),(110538,3486),(110539,3487),(110540,3488),(110541,3489),(110542,3539),(110543,3540),(110544,3541),(110545,3542),(110546,3648),(110547,3675),(110548,3676),(110549,3677),(110550,3678),(110551,3679),(110552,3680),(110553,3681),(110554,3682),(110555,3683),(110556,2858),(110557,2863),(110558,2866),(110559,2867),(110560,2890),(110561,2891),(110562,2895),(110563,2896),(110564,2897),(110565,2898),(110566,2899),(110567,2917),(110568,2976),(110569,2978),(110570,2987),(110571,2989),(110572,2990),(110573,3012),(110574,3050),(110575,3051),(110576,3052),(110577,3053),(110578,3054),(110579,3055),(110580,3102),(110581,3126),(110582,3127),(110583,3128),(110584,3129),(110585,3130),(110586,3131),(110587,3132),(110588,3133),(110589,3134),(110590,3135),(110591,3136),(110592,3137),(110593,3138),(110594,3139),(110595,3140),(110596,3141),(110597,3142),(110598,3143),(110599,3144),(110600,3145),(110601,3146),(110602,3147),(110603,3148),(110604,3149),(110605,3150),(110606,3151),(110607,3152),(110608,3153),(110609,3154),(110610,3155),(110611,3156),(110612,3157),(110613,3158),(110614,3159),(110615,3160),(110616,3161),(110617,3162),(110618,3163),(110619,3167),(110620,3168),(110621,3169),(110622,3170),(110623,3171),(110624,3172),(110625,3173),(110626,3174),(110627,3175),(110628,3176),(110629,3177),(110630,3178),(110631,3179),(110632,3180),(110633,3181),(110634,3182),(110635,3183),(110636,3184),(110637,3185),(110638,3186),(110639,3187),(110640,3188),(110641,3189),(110642,3190),(110643,3191),(110644,3192),(110645,3193),(110646,3194),(110647,3195),(110648,3196),(110649,3197),(110650,3198),(110651,3199),(110652,3200),(110653,3201),(110654,3202),(110655,3203),(110656,3204),(110657,3205),(110658,3206),(110659,3207),(110660,3208),(110661,3209),(110662,3210),(110663,3211),(110664,3212),(110665,3213),(110666,3214),(110667,3215),(110668,3216),(110669,3217),(110670,3218),(110671,3219),(110672,3220),(110673,3221),(110674,3222),(110675,3223),(110676,3224),(110677,3225),(110678,3226),(110679,3227),(110680,3228),(110681,3229),(110682,3230),(110683,3231),(110684,3232),(110685,3233),(110686,3234),(110687,3235),(110688,3236),(110689,3237),(110690,3238),(110691,3239),(110692,3240),(110693,3241),(110694,3242),(110695,3243),(110696,3244),(110697,3245),(110698,3246),(110699,3247),(110700,3248),(110701,3249),(110702,3250),(110703,3251),(110704,3252),(110705,3253),(110706,3254),(110707,3255),(110708,3256),(110709,3257),(110710,3258),(110711,3259),(110712,3260),(110713,3261),(110714,3262),(110715,3263),(110716,3264),(110717,3265),(110718,3266),(110719,3267),(110720,3268),(110721,3269),(110722,3270),(110723,3271),(110724,3272),(110725,3273),(110726,3274),(110727,3275),(110728,3276),(110729,3277),(110730,3278),(110731,3279),(110732,3280),(110733,3281),(110734,3282),(110735,3283),(110736,3284),(110737,3285),(110738,3286),(110739,3287),(110740,3288),(110741,3289),(110742,3290),(110743,3291),(110744,3292),(110745,3293),(110746,3294),(110747,3295),(110748,3296),(110749,3297),(110750,3298),(110751,3299),(110752,3300),(110753,3301),(110754,3302),(110755,3303),(110756,2622),(110757,2623),(110758,2624),(110759,2625),(110760,2626),(110761,2627),(110762,2628),(110763,2629),(110764,2630),(110765,2631),(110766,2632),(110767,2633),(110768,2634),(110769,2635),(110770,2636),(110771,2637),(110772,2638),(110773,2639),(110774,2640),(110775,2641),(110776,2642),(110777,2643),(110778,2644),(110779,2645),(110780,2646),(110781,2647),(110782,2648),(110783,2649),(110784,2650),(110785,2651),(110786,2652),(110787,2653),(110788,2654),(110789,2658),(110790,2659),(110791,2660),(110792,2661),(110793,2662),(110794,2663),(110795,2664),(110796,2665),(110797,2666),(110798,2667),(110799,2668),(110800,2669),(110801,2670),(110802,2671),(110803,2672),(110804,2673),(110805,2674),(110806,2675),(110807,2676),(110808,2677),(110809,2678),(110810,2679),(110811,2680),(110812,2681),(110813,2682),(110814,2683),(110815,2684),(110816,2685),(110817,2686),(110818,2687),(110819,2688),(110820,2689),(110821,2690),(110822,2691),(110823,2692),(110824,2693),(110825,2694),(110826,2695),(110827,2696),(110828,2697),(110829,2698),(110830,2700),(110831,2703),(110832,2781),(110833,2794),(110834,2795),(110835,2796),(110836,2798),(110837,2821),(110838,2828),(110839,2829),(110840,2830),(110841,2833),(110842,2834),(110843,2835),(110844,2836),(110845,2837),(110846,2838),(110847,2839),(110848,2840),(110849,2841),(110850,2842),(110851,2843),(110852,39),(110853,40),(110854,41),(110855,42),(110856,43),(110857,44),(110858,750),(110859,751),(110860,752),(110861,753),(110862,882),(110863,883),(110864,884),(110865,885),(110866,886),(110867,887),(110868,888),(110869,889),(110870,890),(110871,891),(110872,892),(110873,893),(110874,894),(110875,895),(110876,896),(110877,897),(110878,898),(110879,899),(110880,900),(110881,901),(110882,902),(110883,1473),(110884,1474),(110885,1475),(110886,1476),(110887,1477),(110888,1478),(110889,1479),(110890,1480),(110891,1481),(110892,1482),(110893,1483),(110894,1484),(110895,1485),(110896,1486),(110897,1487),(110898,1515),(110899,1516),(110900,1517),(110901,1537),(110902,1538),(110903,1539),(110904,1540),(110905,1541),(110906,1542),(110907,1543),(110908,1544),(110909,1545),(110910,1546),(110911,1547),(110912,1548),(110913,1549),(110914,1550),(110915,1551),(110916,1552),(110917,1553),(110918,1554),(110919,1555),(110920,1556),(110921,1560),(110922,1561),(110923,1763),(110924,4539),(110925,4540),(110926,4541),(110927,4542),(110928,4543),(110929,4544),(110930,4545),(110931,4546),(110932,4547),(110933,4548),(110934,4549),(110935,4550),(110936,4551),(110937,4552),(110938,4553),(110939,4554),(110940,4555),(110941,4556),(110942,4557),(110943,4558),(110944,4559),(110945,4560),(110946,4561),(110947,4562),(110948,4563),(110949,4564),(110950,4565),(110951,5275),(110952,5276),(110953,5277),(110954,5278),(110955,5279),(110956,5280),(110957,5281),(110958,5309),(110959,5310),(110960,5311),(110961,5312),(110962,5313),(110963,5314),(110964,5315),(110965,5316),(110966,5317),(110967,5318),(110968,5319),(110969,5320),(110970,5338),(110971,5339),(110972,5340),(110973,5341),(110974,5342),(110975,5345),(110976,5346),(110977,5347),(110978,5348),(110979,5349),(110980,5350),(110981,5353),(110982,5357),(110983,5358),(110984,5680),(110985,5681),(110986,139),(110987,160),(110988,161),(110989,169),(110990,170),(110991,171),(110992,173),(110993,174),(110994,175),(110995,221),(110996,222),(110997,223),(110998,249),(110999,250),(111000,252),(111001,253),(111002,266),(111003,267),(111004,276),(111005,277),(111006,278),(111007,279),(111008,280),(111009,1575),(111010,1576),(111011,1577),(111012,1578),(111013,1805),(111014,1806),(111015,2200),(111016,2208),(111017,2209),(111018,2210),(111019,2245),(111020,2246),(111021,2256),(111022,2257),(111023,2302),(111024,2303),(111025,2304),(111026,2305),(111027,2306),(111028,2396),(111029,2397),(111030,2398),(111031,2399),(111032,2400),(111033,2401),(111034,2402),(111035,2403),(111036,2404),(111037,2405),(111038,2406),(111039,2407),(111040,2408),(111041,2409),(111042,2410),(111043,2458),(111044,2459),(111045,2503),(111046,4627),(111047,4714),(111048,4715),(111049,4716),(111050,4717),(111051,4719),(111052,4720),(111053,4721),(111054,4722),(111055,4723),(111056,4724),(111057,4725),(111058,4726),(111059,4727),(111060,4728),(111061,4729),(111062,4809),(111063,4810),(111064,4811),(111065,4823),(111066,4843),(111067,4844),(111068,4846),(111069,4847),(111070,4848),(111071,4849),(111072,4850),(111073,4851),(111074,4852),(111075,4856),(111076,4899),(111077,4901),(111078,4905),(111079,4906),(111080,4910),(111081,4992),(111082,4993),(111083,4994),(111084,4995),(111085,4996),(111086,4997),(111087,4998),(111088,4999),(111089,5000),(111090,5019),(111091,5020),(111092,5021),(111093,5022),(111094,5023),(111095,5039),(111096,5040),(111097,5041),(111098,5042),(111099,5043),(111100,5044),(111101,5045),(111102,5046),(111103,5047),(111104,5048),(111105,5049),(111106,5050),(111107,5051),(111108,5052),(111109,5053),(111110,5054),(111111,5055),(111112,5056),(111113,5057),(111114,5058),(111115,5059),(111116,5060),(111117,5061),(111118,5065),(111119,5066),(111120,5067),(111121,5068),(111122,5069),(111123,5070),(111124,5071),(111125,5072),(111126,5195),(111127,5196),(111128,5198),(111129,5199),(111130,3829),(111131,3830),(111132,3831),(111133,3832),(111134,3833),(111135,3834),(111136,3975),(111137,3976),(111138,4052),(111139,4053),(111140,4212),(111141,4218),(111142,4219),(111143,4220),(111144,4282),(111145,4283),(111146,4315),(111147,4437),(111148,4438),(111149,4439),(111150,3715),(111151,3716),(111152,3718),(111153,3750),(111154,3774),(111155,3827),(111156,3828),(111157,96),(111158,97),(111159,98),(111160,99),(111161,100),(111162,101),(111163,102),(111164,103),(111165,104),(111166,105),(111167,106),(111168,107),(111169,108),(111170,109),(111171,138),(111172,244),(111173,245),(111174,251),(111175,873),(111176,874),(111177,875),(111178,876),(111179,877),(111180,878),(111181,879),(111182,880),(111183,881),(111184,1039),(111185,1099),(111186,1140),(111187,1141),(111188,1142),(111189,1143),(111190,1149),(111191,1150),(111192,1495),(111193,1497),(111194,1498),(111195,1499),(111196,1500),(111197,1501),(111198,1502),(111199,1503),(111200,1504),(111201,1505),(111202,1506),(111203,1507),(111204,1508),(111205,1509),(111206,1510),(111207,1511),(111208,1512),(111209,1513),(111210,1514),(111211,1796),(111212,1797),(111213,4538),(111214,5171),(111215,5285),(111216,5287),(111217,5288),(111218,5289),(111219,5290),(111220,5291),(111221,5292),(111222,5293),(111223,5294),(111224,5295),(111225,5296),(111226,5297),(111227,5298),(111228,5299),(111229,5300),(111230,5302),(111231,5303),(111232,5304),(111233,5305),(111234,5306),(111235,5307),(111236,5308),(111237,5321),(111238,5322),(111239,5536),(111240,5537),(111241,5689),(111242,5696),(111243,5752),(111244,2655),(111245,2656),(111246,2657),(111247,2766),(111248,2767),(111249,2768),(111250,2769),(111251,2770),(111252,2771),(111253,2773),(111254,2782),(111255,2793),(111256,2969),(111257,2970),(111258,2971),(111259,2972),(111260,2973),(111261,2974),(111262,2975),(111263,2993),(111264,2994),(111265,2995),(111266,2996),(111267,2997),(111268,2998),(111269,2999),(111270,3000),(111271,3001),(111272,3002),(111273,3003),(111274,3004),(111275,3005),(111276,3006),(111277,3007),(111278,3008),(111279,3009),(111280,3010),(111281,3011),(111282,3125),(111283,3490),(111284,3491),(111285,3492),(111286,3493),(111287,3494),(111288,3495),(111289,3496),(111290,3497),(111291,3498),(111292,3499),(111293,3500),(111294,3501),(111295,3502),(111296,3503),(111297,3504),(111298,3505),(111299,3506),(111300,3507),(111301,3508),(111302,3509),(111303,3510),(111304,3511),(111305,3512),(111306,3513),(111307,3514),(111308,3515),(111309,3516),(111310,3517),(111311,3518),(111312,3519),(111313,3520),(111314,3521),(111315,3522),(111316,3523),(111317,3524),(111318,3525),(111319,3526),(111320,3527),(111321,3573),(111322,3574),(111323,3575),(111324,3576),(111325,3577),(111326,3578),(111327,3579),(111328,3580),(111329,3583),(111330,3592),(111331,3593),(111332,3594),(111333,3595),(111334,3596),(111335,3597),(111336,3598),(111337,3599),(111338,3600),(111339,3601),(111340,3602),(111341,3603),(111342,3604),(111343,3605),(111344,3606),(111345,3607),(111346,3608),(111347,3609),(111348,3686),(111349,3687),(111350,3688),(111351,3689),(111352,3690),(111353,3691),(111354,3692),(111355,3693),(111356,3694),(111357,3695),(111358,3696),(111359,3697),(111360,3698),(111361,3699),(111362,3700),(111363,3701),(111364,3702),(111365,3703),(111366,3704),(111367,3705),(111368,3706),(111369,3707),(111370,3708),(111371,3709),(111372,3710),(111373,3711),(111374,3712),(111375,3713),(111376,3714),(111377,3861),(111378,3870),(111379,3875),(111380,3876),(111381,3877),(111382,3878),(111383,3879),(111384,3880),(111385,3892),(111386,3964),(111387,3965),(111388,4059),(111389,4060),(111390,4170),(111391,4171),(111392,4172),(111393,4173),(111394,4174),(111395,4175),(111396,4202),(111397,4203),(111398,4243),(111399,4244),(111400,4245),(111401,4257),(111402,4277),(111403,4278),(111404,4279),(111405,4280),(111406,4281),(111407,4287),(111408,4288),(111409,4289),(111410,4290),(111411,4294),(111412,4295),(111413,4296),(111414,4337),(111415,4338),(111416,4339),(111417,4340),(111418,4342),(111419,4343),(111420,4434),(111421,4435),(111422,4436),(111423,4441),(111424,4442),(111425,4443),(111426,4444),(111427,4445),(111428,4446),(111429,4447),(111430,4448),(111431,4449),(111432,4450),(111433,4451),(111434,4452),(111435,4453),(111436,4454),(111437,4455),(111438,4456),(111439,2667),(111440,2668),(111441,2669),(111442,2670),(111443,2833),(111444,2834),(111445,2835),(111446,2836),(111447,2837),(111448,2861),(111449,2862),(111450,2887),(111451,2699),(111452,2703),(111453,2708),(111454,2711),(111455,2712),(111456,2713),(111457,2714),(111458,2717),(111459,2721),(111460,2722),(111461,2723),(111462,2730),(111463,2765),(111464,2798),(111465,2799),(111466,2800),(111467,2801),(111468,2802),(111469,2803),(111470,2804),(111471,2810),(111472,2812),(111473,2815),(111474,2821),(111475,2828),(111476,2829),(111477,2843),(111478,2856),(111479,2858),(111480,2863),(111481,2886),(111482,2890),(111483,2891),(111484,2893),(111485,2899),(111486,2900),(111487,2904),(111488,2917),(111489,2918),(111490,2923),(111491,2925),(111492,2926),(111493,2929),(111494,2930),(111495,2943),(111496,2945),(111497,2955),(111498,2976),(111499,2978),(111500,2979),(111501,2980),(111502,2987),(111503,2989),(111504,2990),(111505,2998),(111506,2999),(111507,3000),(111508,3001),(111509,3002),(111510,3003),(111511,3004),(111512,3005),(111513,3006),(111514,3007),(111515,3012),(111516,3042),(111517,3043),(111518,3126),(111519,3128),(111520,3130),(111521,3132),(111522,3135),(111523,3140),(111524,3142),(111525,3143),(111526,3146),(111527,3147),(111528,3148),(111529,3149),(111530,3152),(111531,3154),(111532,3155),(111533,3156),(111534,3159),(111535,3172),(111536,3184),(111537,3214),(111538,3407),(111539,3421),(111540,3479),(111541,3480),(111542,3488),(111543,3489),(111544,3490),(111545,3491),(111546,3492),(111547,3493),(111548,3494),(111549,3495),(111550,3496),(111551,3497),(111552,3498),(111553,3499),(111554,3500),(111555,3501),(111556,3502),(111557,3503),(111558,3539),(111559,3540),(111560,3543),(111561,3548),(111562,3573),(111563,3574),(111564,3575),(111565,3576),(111566,3577),(111567,3578),(111568,3579),(111569,3580),(111570,3583),(111571,3592),(111572,3593),(111573,3594),(111574,3595),(111575,3596),(111576,3597),(111577,3598),(111578,3599),(111579,3600),(111580,3601),(111581,3602),(111582,3603),(111583,3604),(111584,3605),(111585,3606),(111586,3607),(111587,3608),(111588,3609),(111589,3620),(111590,3673),(111591,3674),(111592,3686),(111593,3687),(111594,3688),(111595,3689),(111596,3690),(111597,3691),(111598,3692),(111599,3693),(111600,3694),(111601,3695),(111602,3696),(111603,3697),(111604,3698),(111605,3699),(111606,3700),(111607,3701),(111608,3702),(111609,3703),(111610,3704),(111611,3705),(111612,3706),(111613,3707),(111614,3708),(111615,3709),(111616,3710),(111617,3714),(111618,1700),(111619,2696),(111620,2697),(111621,2698),(111622,2699),(111623,2821),(111624,2840),(111625,2841),(111626,2842),(111627,2891),(111628,2904),(111629,2918),(111630,2922),(111631,2923),(111632,2925),(111633,2926),(111634,2929),(111635,2930),(111636,2943),(111637,2945),(111638,2979),(111639,2980),(111640,2998),(111641,2999),(111642,3000),(111643,3001),(111644,3002),(111645,3003),(111646,3004),(111647,3005),(111648,3006),(111649,3007),(111650,3042),(111651,3043),(111652,3118),(111653,3126),(111654,3132),(111655,3135),(111656,3143),(111657,3147),(111658,3148),(111659,3159),(111660,3170),(111661,3171),(111662,3173),(111663,3174),(111664,3175),(111665,3176),(111666,3177),(111667,3178),(111668,3179),(111669,3180),(111670,3181),(111671,3185),(111672,3186),(111673,3187),(111674,3188),(111675,3189),(111676,3190),(111677,3191),(111678,3192),(111679,3193),(111680,3194),(111681,3195),(111682,3204),(111683,3205),(111684,3206),(111685,3207),(111686,3208),(111687,3212),(111688,3213),(111689,3245),(111690,3246),(111691,3247),(111692,3248),(111693,3249),(111694,3250),(111695,3251),(111696,3252),(111697,3253),(111698,3254),(111699,3255),(111700,3256),(111701,3278),(111702,3279),(111703,3280),(111704,3281),(111705,3282),(111706,3283),(111707,3284),(111708,3285),(111709,3286),(111710,3287),(111711,3288),(111712,3289),(111713,3290),(111714,3291),(111715,3292),(111716,3381),(111717,3382),(111718,3383),(111719,3384),(111720,3385),(111721,3386),(111722,3387),(111723,3389),(111724,3390),(111725,3392),(111726,3393),(111727,3394),(111728,3395),(111729,3396),(111730,3397),(111731,3398),(111732,3399),(111733,3400),(111734,3401),(111735,3404),(111736,3405),(111737,3406),(111738,3408),(111739,3409),(111740,3410),(111741,3411),(111742,3412),(111743,3413),(111744,3414),(111745,3415),(111746,3416),(111747,3417),(111748,3418),(111749,3419),(111750,3420),(111751,3421),(111752,3422),(111753,3423),(111754,3424),(111755,3425),(111756,3426),(111757,3427),(111758,3428),(111759,3429),(111760,3430),(111761,3431),(111762,3432),(111763,3433),(111764,3434),(111765,3435),(111766,3436),(111767,3437),(111768,3438),(111769,3439),(111770,3440),(111771,3441),(111772,3442),(111773,3443),(111774,3444),(111775,3445),(111776,3446),(111777,3447),(111778,3448),(111779,3449),(111780,3450),(111781,3451),(111782,3452),(111783,3453),(111784,3454),(111785,3455),(111786,3456),(111787,3457),(111788,3458),(111789,3481),(111790,3482),(111791,3483),(111792,3484),(111793,3485),(111794,3486),(111795,3487),(111796,3489),(111797,3592),(111798,3595),(111799,3596),(111800,3597),(111801,3598),(111802,3599),(111803,3600),(111804,3601),(111805,3602),(111806,3603),(111807,3604),(111808,3605),(111809,3606),(111810,3607),(111811,3608),(111812,3609),(111813,3623),(111814,3686),(111815,3687),(111816,3688),(111817,3689),(111818,3690),(111819,3691),(111820,3692),(111821,3693),(111822,3694),(111823,3695),(111824,3696),(111825,3697),(111826,3698),(111827,3699),(111828,3700),(111829,3701),(111830,3702),(111831,3703),(111832,3704),(111833,3705),(111834,3706),(111835,3707),(111836,3708),(111837,3709),(111838,3710),(111839,3714),(111840,4563),(111841,4563),(111842,3714),(111843,326),(111844,327),(111845,330),(111846,331),(111847,904),(111848,1153),(111849,1154),(111850,1473),(111851,1475),(111852,1486),(111853,1487),(111854,1529),(111855,1530),(111856,1542),(111857,1543),(111858,1545),(111859,1665),(111860,1666),(111861,1836),(111862,1837),(111863,1838),(111864,1839),(111865,1840),(111866,1841),(111867,1842),(111868,1843),(111869,1844),(111870,1845),(111871,1846),(111872,1847),(111873,1848),(111874,1849),(111875,1850),(111876,1851),(111877,1852),(111878,1853),(111879,1854),(111880,1855),(111881,1856),(111882,1857),(111883,1858),(111884,1859),(111885,1860),(111886,1861),(111887,1862),(111888,1863),(111889,1864),(111890,1865),(111891,1866),(111892,1867),(111893,1868),(111894,1869),(111895,1870),(111896,1871),(111897,1872),(111898,1873),(111899,1874),(111900,1875),(111901,1876),(111902,1880),(111903,1881),(111904,1882),(111905,1883),(111906,1884),(111907,1886),(111908,1887),(111909,1888),(111910,1889),(111911,1890),(111912,1891),(111913,1892),(111914,1893),(111915,1894),(111916,1895),(111917,1896),(111918,1897),(111919,1898),(111920,1899),(111921,1900),(111922,1901),(111923,1902),(111924,1903),(111925,1904),(111926,1905),(111927,1906),(111928,1907),(111929,1908),(111930,1909),(111931,1910),(111932,1911),(111933,1912),(111934,1913),(111935,1914),(111936,1915),(111937,1916),(111938,1917),(111939,1918),(111940,1919),(111941,1920),(111942,1921),(111943,1922),(111944,1923),(111945,1924),(111946,1925),(111947,1926),(111948,1927),(111949,1928),(111950,1929),(111951,1930),(111952,1936),(111953,1937),(111954,1938),(111955,2221),(111956,2290),(111957,2291),(111958,2293),(111959,2700),(111960,4530),(111961,4536),(111962,4897),(111963,5171),(111964,5524),(111965,326),(111966,327),(111967,330),(111968,331),(111969,904),(111970,1153),(111971,1154),(111972,1473),(111973,1475),(111974,1486),(111975,1487),(111976,1529),(111977,1530),(111978,1542),(111979,1543),(111980,1545),(111981,1665),(111982,1666),(111983,1836),(111984,1837),(111985,1838),(111986,1839),(111987,1840),(111988,1841),(111989,1842),(111990,1843),(111991,1844),(111992,1845),(111993,1846),(111994,1847),(111995,1848),(111996,1849),(111997,1850),(111998,1851),(111999,1852),(112000,1853),(112001,1854),(112002,1855),(112003,1856),(112004,1857),(112005,1858),(112006,1859),(112007,1860),(112008,1861),(112009,1862),(112010,1863),(112011,1864),(112012,1865),(112013,1866),(112014,1867),(112015,1868),(112016,1869),(112017,1870),(112018,1871),(112019,1872),(112020,1873),(112021,1874),(112022,1875),(112023,1876),(112024,1880),(112025,1881),(112026,1882),(112027,1883),(112028,1884),(112029,1886),(112030,1887),(112031,1888),(112032,1889),(112033,1890),(112034,1891),(112035,1892),(112036,1893),(112037,1894),(112038,1895),(112039,1896),(112040,1897),(112041,1898),(112042,1899),(112043,1900),(112044,1901),(112045,1902),(112046,1903),(112047,1904),(112048,1905),(112049,1906),(112050,1907),(112051,1908),(112052,1909),(112053,1910),(112054,1911),(112055,1912),(112056,1913),(112057,1914),(112058,1915),(112059,1916),(112060,1917),(112061,1918),(112062,1919),(112063,1920),(112064,1921),(112065,1922),(112066,1923),(112067,1924),(112068,1925),(112069,1926),(112070,1927),(112071,1928),(112072,1929),(112073,1930),(112074,1936),(112075,1937),(112076,1938),(112077,2221),(112078,2290),(112079,2291),(112080,2293),(112081,4530),(112082,4536),(112083,4897),(112084,5171),(112085,5524),(112086,2700),(112087,2918),(112088,3043),(112089,5584),(112090,5585),(112091,2921),(112092,2922),(112093,2924),(112094,2927),(112095,2928),(112096,2929),(112097,2930),(112098,2931),(112099,2932),(112100,2933),(112101,2934),(112102,2935),(112103,2936),(112104,2937),(112105,2938),(112106,2939),(112107,2940),(112108,2941),(112109,2942),(112110,2944),(112111,2945),(112112,2946),(112113,2947),(112114,2948),(112115,2949),(112116,2950),(112117,2951),(112118,2952),(112119,2953),(112120,2954),(112121,3164),(112122,3165),(112123,3166),(112124,3534),(112125,3535),(112126,3536),(112127,2699),(112128,2923),(112129,2925),(112130,2926),(112131,2943),(112132,2979),(112133,2980),(112134,3042),(112135,2701),(112136,2702),(112137,2760),(112138,2761),(112139,2762),(112140,2763),(112141,2764),(112142,2765),(112143,2772),(112144,2774),(112145,2775),(112146,2776),(112147,2777),(112148,2778),(112149,2779),(112150,2780),(112151,2783),(112152,2784),(112153,2785),(112154,2786),(112155,2787),(112156,2788),(112157,2789),(112158,2790),(112159,2791),(112160,2792),(112161,2799),(112162,2800),(112163,2801),(112164,2802),(112165,2803),(112166,2804),(112167,2805),(112168,2806),(112169,2807),(112170,2808),(112171,2809),(112172,2810),(112173,2811),(112174,2812),(112175,2813),(112176,2814),(112177,2815),(112178,2816),(112179,2817),(112180,2818),(112181,2819),(112182,2820),(112183,2822),(112184,2823),(112185,2824),(112186,2825),(112187,2826),(112188,2827),(112189,2831),(112190,2832),(112191,2844),(112192,2845),(112193,2846),(112194,2847),(112195,2848),(112196,2849),(112197,2850),(112198,2851),(112199,2852),(112200,2853),(112201,2854),(112202,2855),(112203,2856),(112204,2859),(112205,2860),(112206,2861),(112207,2862),(112208,2864),(112209,2865),(112210,2868),(112211,2869),(112212,2870),(112213,2871),(112214,2872),(112215,2873),(112216,2874),(112217,2875),(112218,2876),(112219,2877),(112220,2878),(112221,2879),(112222,2880),(112223,2881),(112224,2882),(112225,2883),(112226,2884),(112227,2885),(112228,2886),(112229,2887),(112230,2888),(112231,2889),(112232,2892),(112233,2893),(112234,2900),(112235,2901),(112236,2902),(112237,2903),(112238,2905),(112239,2906),(112240,2907),(112241,2908),(112242,2909),(112243,2910),(112244,2911),(112245,2912),(112246,2913),(112247,2914),(112248,2915),(112249,2916),(112250,2955),(112251,2956),(112252,2957),(112253,2958),(112254,2959),(112255,2960),(112256,2961),(112257,2962),(112258,2963),(112259,2964),(112260,2965),(112261,2966),(112262,2967),(112263,2968),(112264,2981),(112265,2982),(112266,2983),(112267,2984),(112268,2985),(112269,2986),(112270,2991),(112271,2992),(112272,3013),(112273,3014),(112274,3015),(112275,3016),(112276,3017),(112277,3018),(112278,3019),(112279,3020),(112280,3021),(112281,3022),(112282,3023),(112283,3024),(112284,3025),(112285,3026),(112286,3027),(112287,3028),(112288,3029),(112289,3030),(112290,3031),(112291,3032),(112292,3033),(112293,3034),(112294,3035),(112295,3036),(112296,3037),(112297,3038),(112298,3039),(112299,3040),(112300,3041),(112301,3044),(112302,3045),(112303,3046),(112304,3047),(112305,3048),(112306,3049),(112307,3056),(112308,3057),(112309,3058),(112310,3059),(112311,3060),(112312,3061),(112313,3062),(112314,3063),(112315,3064),(112316,3065),(112317,3066),(112318,3067),(112319,3068),(112320,3069),(112321,3070),(112322,3071),(112323,3072),(112324,3073),(112325,3074),(112326,3075),(112327,3076),(112328,3077),(112329,3078),(112330,3079),(112331,3080),(112332,3081),(112333,3082),(112334,3083),(112335,3084),(112336,3085),(112337,3086),(112338,3087),(112339,3088),(112340,3089),(112341,3090),(112342,3091),(112343,3092),(112344,3093),(112345,3094),(112346,3095),(112347,3096),(112348,3097),(112349,3098),(112350,3099),(112351,3100),(112352,3101),(112353,3103),(112354,3104),(112355,3105),(112356,3106),(112357,3107),(112358,3108),(112359,3109),(112360,3110),(112361,3111),(112362,3112),(112363,3113),(112364,3114),(112365,3115),(112366,3116),(112367,3117),(112368,3119),(112369,3120),(112370,3121),(112371,3122),(112372,3123),(112373,3124),(112374,3528),(112375,3529),(112376,3530),(112377,3531),(112378,3532),(112379,3533),(112380,3537),(112381,3538),(112382,3543),(112383,3544),(112384,3545),(112385,3546),(112386,3547),(112387,3548),(112388,3549),(112389,3550),(112390,3551),(112391,3552),(112392,3553),(112393,3554),(112394,3555),(112395,3556),(112396,3557),(112397,3558),(112398,3559),(112399,3560),(112400,3561),(112401,3562),(112402,3563),(112403,3564),(112404,3565),(112405,3566),(112406,3567),(112407,3568),(112408,3569),(112409,3570),(112410,3571),(112411,3572),(112412,3581),(112413,3582),(112414,3584),(112415,3585),(112416,3586),(112417,3587),(112418,3588),(112419,3589),(112420,3590),(112421,3591),(112422,3610),(112423,3611),(112424,3612),(112425,3613),(112426,3614),(112427,3615),(112428,3616),(112429,3617),(112430,3618),(112431,3619),(112432,3620),(112433,3621),(112434,3622),(112435,3624),(112436,3625),(112437,3626),(112438,3627),(112439,3628),(112440,3629),(112441,3630),(112442,3631),(112443,3632),(112444,3633),(112445,3634),(112446,3635),(112447,3636),(112448,3637),(112449,3638),(112450,3639),(112451,3640),(112452,3641),(112453,3642),(112454,3643),(112455,3644),(112456,3645),(112457,3646),(112458,3647),(112459,3649),(112460,3650),(112461,3651),(112462,3652),(112463,3653),(112464,3654),(112465,3655),(112466,3656),(112467,3657),(112468,3658),(112469,3659),(112470,3661),(112471,3662),(112472,3663),(112473,3664),(112474,3665),(112475,3666),(112476,3667),(112477,3668),(112478,3669),(112479,3670),(112480,3671),(112481,3672),(112482,3673),(112483,3674),(112484,3684),(112485,3685),(112486,3660),(112487,2655),(112488,2656),(112489,2657),(112490,2766),(112491,2767),(112492,2768),(112493,2769),(112494,2770),(112495,2771),(112496,2773),(112497,2782),(112498,2793),(112499,2969),(112500,2970),(112501,2971),(112502,2972),(112503,2973),(112504,2974),(112505,2975),(112506,2993),(112507,2994),(112508,2995),(112509,2996),(112510,2997),(112511,2998),(112512,2999),(112513,3000),(112514,3001),(112515,3002),(112516,3003),(112517,3004),(112518,3005),(112519,3006),(112520,3007),(112521,3008),(112522,3009),(112523,3010),(112524,3011),(112525,3125),(112526,3490),(112527,3491),(112528,3492),(112529,3493),(112530,3494),(112531,3495),(112532,3496),(112533,3497),(112534,3498),(112535,3499),(112536,3500),(112537,3501),(112538,3502),(112539,3503),(112540,3504),(112541,3505),(112542,3506),(112543,3507),(112544,3508),(112545,3509),(112546,3510),(112547,3511),(112548,3512),(112549,3513),(112550,3514),(112551,3515),(112552,3516),(112553,3517),(112554,3518),(112555,3519),(112556,3520),(112557,3521),(112558,3522),(112559,3523),(112560,3524),(112561,3525),(112562,3526),(112563,3527),(112564,3573),(112565,3574),(112566,3575),(112567,3576),(112568,3577),(112569,3578),(112570,3579),(112571,3580),(112572,3583),(112573,3592),(112574,3593),(112575,3594),(112576,3595),(112577,3596),(112578,3597),(112579,3598),(112580,3599),(112581,3600),(112582,3601),(112583,3602),(112584,3603),(112585,3604),(112586,3605),(112587,3606),(112588,3607),(112589,3608),(112590,3609),(112591,3686),(112592,3687),(112593,3688),(112594,3689),(112595,3690),(112596,3691),(112597,3692),(112598,3693),(112599,3694),(112600,3695),(112601,3696),(112602,3697),(112603,3698),(112604,3699),(112605,3700),(112606,3701),(112607,3702),(112608,3703),(112609,3704),(112610,3705),(112611,3706),(112612,3707),(112613,3708),(112614,3709),(112615,3710),(112616,3711),(112617,3712),(112618,3713),(112619,3714),(112620,2622),(112621,2623),(112622,2624),(112623,2625),(112624,2626),(112625,2627),(112626,2628),(112627,2629),(112628,2630),(112629,2631),(112630,2632),(112631,2633),(112632,2634),(112633,2635),(112634,2636),(112635,2637),(112636,2638),(112637,2639),(112638,2640),(112639,2641),(112640,2642),(112641,2643),(112642,2644),(112643,2645),(112644,2646),(112645,2647),(112646,2648),(112647,2649),(112648,2650),(112649,2651),(112650,2652),(112651,2653),(112652,2654),(112653,2658),(112654,2659),(112655,2660),(112656,2661),(112657,2662),(112658,2663),(112659,2664),(112660,2665),(112661,2666),(112662,2667),(112663,2668),(112664,2669),(112665,2670),(112666,2671),(112667,2672),(112668,2673),(112669,2674),(112670,2675),(112671,2676),(112672,2677),(112673,2678),(112674,2679),(112675,2680),(112676,2681),(112677,2682),(112678,2683),(112679,2684),(112680,2685),(112681,2686),(112682,2687),(112683,2688),(112684,2689),(112685,2690),(112686,2691),(112687,2692),(112688,2693),(112689,2694),(112690,2695),(112691,2696),(112692,2697),(112693,2698),(112694,2700),(112695,2703),(112696,2781),(112697,2794),(112698,2795),(112699,2796),(112700,2798),(112701,2821),(112702,2828),(112703,2829),(112704,2830),(112705,2833),(112706,2834),(112707,2835),(112708,2836),(112709,2837),(112710,2838),(112711,2839),(112712,2840),(112713,2841),(112714,2842),(112715,2843),(112716,2858),(112717,2863),(112718,2866),(112719,2867),(112720,2890),(112721,2891),(112722,2895),(112723,2896),(112724,2897),(112725,2898),(112726,2899),(112727,2917),(112728,2976),(112729,2978),(112730,2987),(112731,2989),(112732,2990),(112733,3012),(112734,3050),(112735,3051),(112736,3052),(112737,3053),(112738,3054),(112739,3055),(112740,3102),(112741,3126),(112742,3127),(112743,3128),(112744,3129),(112745,3130),(112746,3131),(112747,3132),(112748,3133),(112749,3134),(112750,3135),(112751,3136),(112752,3137),(112753,3138),(112754,3139),(112755,3140),(112756,3141),(112757,3142),(112758,3143),(112759,3144),(112760,3145),(112761,3146),(112762,3147),(112763,3148),(112764,3149),(112765,3150),(112766,3151),(112767,3152),(112768,3153),(112769,3154),(112770,3155),(112771,3156),(112772,3157),(112773,3158),(112774,3159),(112775,3160),(112776,3161),(112777,3162),(112778,3163),(112779,3167),(112780,3168),(112781,3169),(112782,3170),(112783,3171),(112784,3172),(112785,3173),(112786,3174),(112787,3175),(112788,3176),(112789,3177),(112790,3178),(112791,3179),(112792,3180),(112793,3181),(112794,3182),(112795,3183),(112796,3184),(112797,3185),(112798,3186),(112799,3187),(112800,3188),(112801,3189),(112802,3190),(112803,3191),(112804,3192),(112805,3193),(112806,3194),(112807,3195),(112808,3196),(112809,3197),(112810,3198),(112811,3199),(112812,3200),(112813,3201),(112814,3202),(112815,3203),(112816,3204),(112817,3205),(112818,3206),(112819,3207),(112820,3208),(112821,3209),(112822,3210),(112823,3211),(112824,3212),(112825,3213),(112826,3214),(112827,3215),(112828,3216),(112829,3217),(112830,3218),(112831,3219),(112832,3220),(112833,3221),(112834,3222),(112835,3223),(112836,3224),(112837,3225),(112838,3226),(112839,3227),(112840,3228),(112841,3229),(112842,3230),(112843,3231),(112844,3232),(112845,3233),(112846,3234),(112847,3235),(112848,3236),(112849,3237),(112850,3238),(112851,3239),(112852,3240),(112853,3241),(112854,3242),(112855,3243),(112856,3244),(112857,3245),(112858,3246),(112859,3247),(112860,3248),(112861,3249),(112862,3250),(112863,3251),(112864,3252),(112865,3253),(112866,3254),(112867,3255),(112868,3256),(112869,3257),(112870,3258),(112871,3259),(112872,3260),(112873,3261),(112874,3262),(112875,3263),(112876,3264),(112877,3265),(112878,3266),(112879,3267),(112880,3268),(112881,3269),(112882,3270),(112883,3271),(112884,3272),(112885,3273),(112886,3274),(112887,3275),(112888,3276),(112889,3277),(112890,3278),(112891,3279),(112892,3280),(112893,3281),(112894,3282),(112895,3283),(112896,3284),(112897,3285),(112898,3286),(112899,3287),(112900,3288),(112901,3289),(112902,3290),(112903,3291),(112904,3292),(112905,3293),(112906,3294),(112907,3295),(112908,3296),(112909,3297),(112910,3298),(112911,3299),(112912,3300),(112913,3301),(112914,3302),(112915,3303),(112916,3304),(112917,3305),(112918,3306),(112919,3307),(112920,3308),(112921,3309),(112922,3310),(112923,3311),(112924,3312),(112925,3313),(112926,3314),(112927,3315),(112928,3316),(112929,3317),(112930,3318),(112931,3319),(112932,3320),(112933,3321),(112934,3322),(112935,3323),(112936,3324),(112937,3325),(112938,3326),(112939,3327),(112940,3328),(112941,3329),(112942,3330),(112943,3331),(112944,3332),(112945,3333),(112946,3334),(112947,3335),(112948,3336),(112949,3337),(112950,3338),(112951,3339),(112952,3340),(112953,3341),(112954,3342),(112955,3343),(112956,3344),(112957,3345),(112958,3346),(112959,3347),(112960,3348),(112961,3349),(112962,3350),(112963,3351),(112964,3352),(112965,3353),(112966,3354),(112967,3355),(112968,3356),(112969,3357),(112970,3358),(112971,3359),(112972,3360),(112973,3361),(112974,3362),(112975,3363),(112976,3364),(112977,3365),(112978,3366),(112979,3367),(112980,3368),(112981,3369),(112982,3370),(112983,3371),(112984,3372),(112985,3373),(112986,3374),(112987,3375),(112988,3376),(112989,3377),(112990,3378),(112991,3379),(112992,3380),(112993,3381),(112994,3382),(112995,3383),(112996,3384),(112997,3385),(112998,3386),(112999,3387),(113000,3388),(113001,3389),(113002,3390),(113003,3391),(113004,3392),(113005,3393),(113006,3394),(113007,3395),(113008,3396),(113009,3397),(113010,3398),(113011,3399),(113012,3400),(113013,3401),(113014,3402),(113015,3403),(113016,3404),(113017,3405),(113018,3406),(113019,3407),(113020,3408),(113021,3409),(113022,3410),(113023,3411),(113024,3412),(113025,3413),(113026,3414),(113027,3415),(113028,3416),(113029,3417),(113030,3418),(113031,3419),(113032,3420),(113033,3421),(113034,3422),(113035,3423),(113036,3424),(113037,3425),(113038,3426),(113039,3427),(113040,3428),(113041,3429),(113042,3430),(113043,3431),(113044,3432),(113045,3433),(113046,3434),(113047,3435),(113048,3436),(113049,3437),(113050,3438),(113051,3439),(113052,3440),(113053,3441),(113054,3442),(113055,3443),(113056,3444),(113057,3445),(113058,3446),(113059,3447),(113060,3448),(113061,3449),(113062,3450),(113063,3451),(113064,3452),(113065,3453),(113066,3454),(113067,3455),(113068,3456),(113069,3457),(113070,3458),(113071,3459),(113072,3460),(113073,3461),(113074,3462),(113075,3463),(113076,3464),(113077,3465),(113078,3466),(113079,3467),(113080,3468),(113081,3469),(113082,3470),(113083,3471),(113084,3472),(113085,3473),(113086,3474),(113087,3475),(113088,3476),(113089,3477),(113090,3478),(113091,3479),(113092,3480),(113093,3481),(113094,3482),(113095,3483),(113096,3484),(113097,3485),(113098,3486),(113099,3487),(113100,3488),(113101,3489),(113102,3539),(113103,3540),(113104,3541),(113105,3542),(113106,3648),(113107,3675),(113108,3676),(113109,3677),(113110,3678),(113111,3679),(113112,3680),(113113,3681),(113114,3682),(113115,3683),(113116,2700),(113117,2866),(113118,2867),(113119,3153),(113120,3675),(113121,3676),(113122,3677),(113123,3678),(113124,3679),(113125,3680),(113126,3681),(113127,3682),(113128,3683),(113129,2821),(113130,2842),(113131,2891),(113132,2918),(113133,2922),(113134,3043),(113135,3143),(113136,3170),(113137,3173),(113138,3175),(113139,3176),(113140,3178),(113141,3181),(113142,3185),(113143,3187),(113144,3204),(113145,3206),(113146,3208),(113147,3246),(113148,3251),(113149,3253),(113150,3254),(113151,3256),(113152,3278),(113153,3279),(113154,3284),(113155,3286),(113156,3382),(113157,3415),(113158,3425),(113159,3429),(113160,3439),(113161,3440),(113162,3443),(113163,3447),(113164,3686),(113165,3687),(113166,3701),(113167,5621),(113168,1700),(113169,2677),(113170,2696),(113171,2697),(113172,2698),(113173,2702),(113174,2703),(113175,2708),(113176,2711),(113177,2712),(113178,2713),(113179,2714),(113180,2717),(113181,2721),(113182,2722),(113183,2723),(113184,2730),(113185,2760),(113186,2761),(113187,2762),(113188,2763),(113189,2764),(113190,2765),(113191,2772),(113192,2774),(113193,2775),(113194,2776),(113195,2777),(113196,2778),(113197,2779),(113198,2780),(113199,2783),(113200,2784),(113201,2785),(113202,2786),(113203,2787),(113204,2788),(113205,2789),(113206,2790),(113207,2791),(113208,2792),(113209,2799),(113210,2801),(113211,2802),(113212,2803),(113213,2804),(113214,2810),(113215,2815),(113216,2822),(113217,2823),(113218,2824),(113219,2825),(113220,2826),(113221,2827),(113222,2831),(113223,2832),(113224,2840),(113225,2841),(113226,2844),(113227,2845),(113228,2852),(113229,2853),(113230,2854),(113231,2855),(113232,2856),(113233,2859),(113234,2860),(113235,2863),(113236,2886),(113237,2890),(113238,2892),(113239,2893),(113240,2899),(113241,2900),(113242,2901),(113243,2902),(113244,2903),(113245,2904),(113246,2917),(113247,2923),(113248,2955),(113249,2956),(113250,2957),(113251,2958),(113252,2959),(113253,2960),(113254,2961),(113255,2962),(113256,2976),(113257,2978),(113258,2989),(113259,2990),(113260,2998),(113261,2999),(113262,3000),(113263,3001),(113264,3002),(113265,3003),(113266,3004),(113267,3005),(113268,3006),(113269,3007),(113270,3012),(113271,3126),(113272,3129),(113273,3132),(113274,3135),(113275,3140),(113276,3142),(113277,3144),(113278,3146),(113279,3147),(113280,3148),(113281,3149),(113282,3152),(113283,3154),(113284,3155),(113285,3156),(113286,3159),(113287,3171),(113288,3174),(113289,3177),(113290,3179),(113291,3180),(113292,3184),(113293,3186),(113294,3188),(113295,3189),(113296,3190),(113297,3191),(113298,3192),(113299,3193),(113300,3194),(113301,3195),(113302,3205),(113303,3207),(113304,3212),(113305,3213),(113306,3214),(113307,3245),(113308,3247),(113309,3248),(113310,3249),(113311,3250),(113312,3252),(113313,3255),(113314,3280),(113315,3281),(113316,3282),(113317,3283),(113318,3285),(113319,3287),(113320,3288),(113321,3289),(113322,3290),(113323,3291),(113324,3292),(113325,3376),(113326,3377),(113327,3378),(113328,3379),(113329,3380),(113330,3381),(113331,3383),(113332,3384),(113333,3385),(113334,3386),(113335,3387),(113336,3389),(113337,3390),(113338,3392),(113339,3393),(113340,3394),(113341,3395),(113342,3396),(113343,3397),(113344,3398),(113345,3399),(113346,3400),(113347,3401),(113348,3404),(113349,3405),(113350,3406),(113351,3408),(113352,3409),(113353,3410),(113354,3411),(113355,3412),(113356,3413),(113357,3414),(113358,3416),(113359,3417),(113360,3418),(113361,3419),(113362,3420),(113363,3421),(113364,3422),(113365,3423),(113366,3424),(113367,3426),(113368,3427),(113369,3428),(113370,3430),(113371,3431),(113372,3432),(113373,3433),(113374,3434),(113375,3435),(113376,3436),(113377,3437),(113378,3438),(113379,3441),(113380,3442),(113381,3444),(113382,3445),(113383,3446),(113384,3448),(113385,3449),(113386,3450),(113387,3451),(113388,3452),(113389,3453),(113390,3454),(113391,3455),(113392,3456),(113393,3457),(113394,3458),(113395,3480),(113396,3481),(113397,3482),(113398,3483),(113399,3484),(113400,3485),(113401,3486),(113402,3487),(113403,3488),(113404,3489),(113405,3490),(113406,3491),(113407,3492),(113408,3493),(113409,3494),(113410,3495),(113411,3496),(113412,3497),(113413,3498),(113414,3499),(113415,3500),(113416,3501),(113417,3502),(113418,3503),(113419,3540),(113420,3543),(113421,3544),(113422,3545),(113423,3546),(113424,3547),(113425,3548),(113426,3573),(113427,3574),(113428,3575),(113429,3576),(113430,3577),(113431,3578),(113432,3579),(113433,3580),(113434,3583),(113435,3592),(113436,3593),(113437,3594),(113438,3595),(113439,3596),(113440,3597),(113441,3598),(113442,3599),(113443,3600),(113444,3601),(113445,3602),(113446,3603),(113447,3604),(113448,3605),(113449,3606),(113450,3607),(113451,3608),(113452,3609),(113453,3614),(113454,3615),(113455,3616),(113456,3617),(113457,3618),(113458,3619),(113459,3620),(113460,3649),(113461,3650),(113462,3673),(113463,3674),(113464,3684),(113465,3685),(113466,3688),(113467,3689),(113468,3690),(113469,3691),(113470,3692),(113471,3693),(113472,3694),(113473,3695),(113474,3696),(113475,3697),(113476,3698),(113477,3699),(113478,3700),(113479,3702),(113480,3703),(113481,3704),(113482,3705),(113483,3706),(113484,3707),(113485,3708),(113486,3709),(113487,3710),(113488,4563),(113489,5365),(113490,5527),(113491,5584),(113492,5585),(113493,5627),(113494,5637),(113495,5644),(113496,5645),(113497,5646),(113498,5652),(113499,5654),(113500,5663),(113501,5670),(113502,5671),(113503,5672),(113504,2622),(113505,2623),(113506,2624),(113507,2625),(113508,2626),(113509,2627),(113510,2628),(113511,2629),(113512,2630),(113513,2631),(113514,2632),(113515,2633),(113516,2634),(113517,2635),(113518,2636),(113519,2637),(113520,2638),(113521,2639),(113522,2640),(113523,2641),(113524,2642),(113525,2643),(113526,2644),(113527,2645),(113528,2646),(113529,2647),(113530,2648),(113531,2649),(113532,2650),(113533,2651),(113534,2652),(113535,2653),(113536,2654),(113537,2655),(113538,2656),(113539,2657),(113540,2658),(113541,2659),(113542,2660),(113543,2661),(113544,2662),(113545,2663),(113546,2664),(113547,2665),(113548,2666),(113549,2667),(113550,2668),(113551,2669),(113552,2670),(113553,2671),(113554,2672),(113555,2673),(113556,2674),(113557,2675),(113558,2676),(113559,2678),(113560,2679),(113561,2680),(113562,2681),(113563,2682),(113564,2683),(113565,2684),(113566,2685),(113567,2686),(113568,2687),(113569,2688),(113570,2689),(113571,2690),(113572,2691),(113573,2692),(113574,2693),(113575,2694),(113576,2695),(113577,2701),(113578,2702),(113579,2703),(113580,2704),(113581,2705),(113582,2706),(113583,2707),(113584,2708),(113585,2709),(113586,2710),(113587,2711),(113588,2712),(113589,2713),(113590,2714),(113591,2715),(113592,2716),(113593,2717),(113594,2718),(113595,2719),(113596,2720),(113597,2721),(113598,2722),(113599,2723),(113600,2724),(113601,2725),(113602,2726),(113603,2727),(113604,2728),(113605,2729),(113606,2730),(113607,2731),(113608,2732),(113609,2733),(113610,2734),(113611,2735),(113612,2736),(113613,2737),(113614,2738),(113615,2739),(113616,2740),(113617,2741),(113618,2742),(113619,2743),(113620,2744),(113621,2745),(113622,2746),(113623,2747),(113624,2748),(113625,2749),(113626,2750),(113627,2751),(113628,2752),(113629,2753),(113630,2754),(113631,2755),(113632,2756),(113633,2757),(113634,2758),(113635,2759),(113636,2760),(113637,2761),(113638,2762),(113639,2763),(113640,2764),(113641,2765),(113642,2766),(113643,2767),(113644,2768),(113645,2769),(113646,2770),(113647,2771),(113648,2772),(113649,2773),(113650,2774),(113651,2775),(113652,2776),(113653,2777),(113654,2778),(113655,2779),(113656,2780),(113657,2781),(113658,2782),(113659,2783),(113660,2784),(113661,2785),(113662,2786),(113663,2787),(113664,2788),(113665,2789),(113666,2790),(113667,2791),(113668,2792),(113669,2793),(113670,2794),(113671,2795),(113672,2796),(113673,2797),(113674,2798),(113675,2799),(113676,2800),(113677,2801),(113678,2802),(113679,2803),(113680,2804),(113681,2805),(113682,2806),(113683,2807),(113684,2808),(113685,2809),(113686,2810),(113687,2811),(113688,2812),(113689,2813),(113690,2814),(113691,2815),(113692,2816),(113693,2817),(113694,2818),(113695,2819),(113696,2820),(113697,2822),(113698,2823),(113699,2824),(113700,2825),(113701,2826),(113702,2827),(113703,2828),(113704,2829),(113705,2830),(113706,2831),(113707,2832),(113708,2833),(113709,2834),(113710,2835),(113711,2836),(113712,2837),(113713,2838),(113714,2839),(113715,2843),(113716,2844),(113717,2845),(113718,2846),(113719,2847),(113720,2848),(113721,2849),(113722,2850),(113723,2851),(113724,2852),(113725,2853),(113726,2854),(113727,2855),(113728,2856),(113729,2857),(113730,2858),(113731,2859),(113732,2860),(113733,2861),(113734,2862),(113735,2863),(113736,2864),(113737,2865),(113738,2868),(113739,2869),(113740,2870),(113741,2871),(113742,2872),(113743,2873),(113744,2874),(113745,2875),(113746,2876),(113747,2877),(113748,2878),(113749,2879),(113750,2880),(113751,2881),(113752,2882),(113753,2883),(113754,2884),(113755,2885),(113756,2886),(113757,2887),(113758,2888),(113759,2889),(113760,2890),(113761,2892),(113762,2893),(113763,2894),(113764,2895),(113765,2896),(113766,2897),(113767,2898),(113768,2899),(113769,2900),(113770,2901),(113771,2902),(113772,2903),(113773,2905),(113774,2906),(113775,2907),(113776,2908),(113777,2909),(113778,2910),(113779,2911),(113780,2912),(113781,2913),(113782,2914),(113783,2915),(113784,2916),(113785,2917),(113786,2921),(113787,2922),(113788,2924),(113789,2927),(113790,2928),(113791,2931),(113792,2932),(113793,2933),(113794,2934),(113795,2935),(113796,2936),(113797,2937),(113798,2938),(113799,2939),(113800,2940),(113801,2941),(113802,2942),(113803,2944),(113804,2946),(113805,2947),(113806,2948),(113807,2949),(113808,2950),(113809,2951),(113810,2952),(113811,2953),(113812,2954),(113813,2955),(113814,2956),(113815,2957),(113816,2958),(113817,2959),(113818,2960),(113819,2961),(113820,2962),(113821,2963),(113822,2964),(113823,2965),(113824,2966),(113825,2967),(113826,2968),(113827,2969),(113828,2970),(113829,2971),(113830,2972),(113831,2973),(113832,2974),(113833,2975),(113834,2976),(113835,2977),(113836,2978),(113837,2981),(113838,2982),(113839,2983),(113840,2984),(113841,2985),(113842,2986),(113843,2987),(113844,2988),(113845,2989),(113846,2990),(113847,2991),(113848,2992),(113849,2993),(113850,2994),(113851,2995),(113852,2996),(113853,2997),(113854,3008),(113855,3009),(113856,3010),(113857,3011),(113858,3012),(113859,3013),(113860,3014),(113861,3015),(113862,3016),(113863,3017),(113864,3018),(113865,3019),(113866,3020),(113867,3021),(113868,3022),(113869,3023),(113870,3024),(113871,3025),(113872,3026),(113873,3027),(113874,3028),(113875,3029),(113876,3030),(113877,3031),(113878,3032),(113879,3033),(113880,3034),(113881,3035),(113882,3036),(113883,3037),(113884,3038),(113885,3039),(113886,3040),(113887,3041),(113888,3044),(113889,3045),(113890,3046),(113891,3047),(113892,3048),(113893,3049),(113894,3050),(113895,3051),(113896,3052),(113897,3053),(113898,3054),(113899,3055),(113900,3056),(113901,3057),(113902,3058),(113903,3059),(113904,3060),(113905,3061),(113906,3062),(113907,3063),(113908,3064),(113909,3065),(113910,3066),(113911,3067),(113912,3068),(113913,3069),(113914,3070),(113915,3071),(113916,3072),(113917,3073),(113918,3074),(113919,3075),(113920,3076),(113921,3077),(113922,3078),(113923,3079),(113924,3080),(113925,3081),(113926,3082),(113927,3083),(113928,3084),(113929,3085),(113930,3086),(113931,3087),(113932,3088),(113933,3089),(113934,3090),(113935,3091),(113936,3092),(113937,3093),(113938,3094),(113939,3095),(113940,3096),(113941,3097),(113942,3098),(113943,3099),(113944,3100),(113945,3101),(113946,3102),(113947,3103),(113948,3104),(113949,3105),(113950,3106),(113951,3107),(113952,3108),(113953,3109),(113954,3110),(113955,3111),(113956,3112),(113957,3113),(113958,3114),(113959,3115),(113960,3116),(113961,3117),(113962,3119),(113963,3120),(113964,3121),(113965,3122),(113966,3123),(113967,3124),(113968,3125),(113969,3127),(113970,3128),(113971,3129),(113972,3130),(113973,3131),(113974,3133),(113975,3134),(113976,3136),(113977,3137),(113978,3138),(113979,3139),(113980,3140),(113981,3141),(113982,3142),(113983,3144),(113984,3145),(113985,3146),(113986,3147),(113987,3148),(113988,3149),(113989,3150),(113990,3151),(113991,3152),(113992,3153),(113993,3154),(113994,3155),(113995,3156),(113996,3157),(113997,3158),(113998,3160),(113999,3161),(114000,3162),(114001,3163),(114002,3164),(114003,3165),(114004,3166),(114005,3167),(114006,3168),(114007,3169),(114008,3172),(114009,3182),(114010,3183),(114011,3184),(114012,3196),(114013,3197),(114014,3198),(114015,3199),(114016,3200),(114017,3201),(114018,3202),(114019,3203),(114020,3209),(114021,3210),(114022,3211),(114023,3214),(114024,3215),(114025,3216),(114026,3217),(114027,3218),(114028,3219),(114029,3220),(114030,3221),(114031,3222),(114032,3223),(114033,3224),(114034,3225),(114035,3226),(114036,3227),(114037,3228),(114038,3229),(114039,3230),(114040,3231),(114041,3232),(114042,3233),(114043,3234),(114044,3235),(114045,3236),(114046,3237),(114047,3238),(114048,3239),(114049,3240),(114050,3241),(114051,3242),(114052,3243),(114053,3244),(114054,3257),(114055,3258),(114056,3259),(114057,3260),(114058,3261),(114059,3262),(114060,3263),(114061,3264),(114062,3265),(114063,3266),(114064,3267),(114065,3268),(114066,3269),(114067,3270),(114068,3271),(114069,3272),(114070,3273),(114071,3274),(114072,3275),(114073,3276),(114074,3277),(114075,3293),(114076,3294),(114077,3295),(114078,3296),(114079,3297),(114080,3298),(114081,3299),(114082,3300),(114083,3301),(114084,3302),(114085,3303),(114086,3304),(114087,3305),(114088,3306),(114089,3307),(114090,3308),(114091,3309),(114092,3310),(114093,3311),(114094,3312),(114095,3313),(114096,3314),(114097,3315),(114098,3316),(114099,3317),(114100,3318),(114101,3319),(114102,3320),(114103,3321),(114104,3322),(114105,3323),(114106,3324),(114107,3325),(114108,3326),(114109,3327),(114110,3328),(114111,3329),(114112,3330),(114113,3331),(114114,3332),(114115,3333),(114116,3334),(114117,3335),(114118,3336),(114119,3337),(114120,3338),(114121,3339),(114122,3340),(114123,3341),(114124,3342),(114125,3343),(114126,3344),(114127,3345),(114128,3346),(114129,3347),(114130,3348),(114131,3349),(114132,3350),(114133,3351),(114134,3352),(114135,3353),(114136,3354),(114137,3355),(114138,3356),(114139,3357),(114140,3358),(114141,3359),(114142,3360),(114143,3361),(114144,3362),(114145,3363),(114146,3364),(114147,3365),(114148,3366),(114149,3367),(114150,3368),(114151,3369),(114152,3370),(114153,3371),(114154,3372),(114155,3373),(114156,3374),(114157,3375),(114158,3376),(114159,3377),(114160,3378),(114161,3379),(114162,3380),(114163,3388),(114164,3391),(114165,3402),(114166,3403),(114167,3407),(114168,3459),(114169,3460),(114170,3461),(114171,3462),(114172,3463),(114173,3464),(114174,3465),(114175,3466),(114176,3467),(114177,3468),(114178,3469),(114179,3470),(114180,3471),(114181,3472),(114182,3473),(114183,3474),(114184,3475),(114185,3476),(114186,3477),(114187,3478),(114188,3479),(114189,3480),(114190,3488),(114191,3490),(114192,3491),(114193,3492),(114194,3493),(114195,3494),(114196,3495),(114197,3496),(114198,3497),(114199,3498),(114200,3499),(114201,3500),(114202,3501),(114203,3502),(114204,3503),(114205,3504),(114206,3505),(114207,3506),(114208,3507),(114209,3508),(114210,3509),(114211,3510),(114212,3511),(114213,3512),(114214,3513),(114215,3514),(114216,3515),(114217,3516),(114218,3517),(114219,3518),(114220,3519),(114221,3520),(114222,3521),(114223,3522),(114224,3523),(114225,3524),(114226,3525),(114227,3526),(114228,3527),(114229,3528),(114230,3529),(114231,3530),(114232,3531),(114233,3532),(114234,3533),(114235,3534),(114236,3535),(114237,3536),(114238,3537),(114239,3538),(114240,3539),(114241,3540),(114242,3541),(114243,3542),(114244,3543),(114245,3544),(114246,3545),(114247,3546),(114248,3547),(114249,3548),(114250,3549),(114251,3550),(114252,3551),(114253,3552),(114254,3553),(114255,3554),(114256,3555),(114257,3556),(114258,3557),(114259,3558),(114260,3559),(114261,3560),(114262,3561),(114263,3562),(114264,3563),(114265,3564),(114266,3565),(114267,3566),(114268,3567),(114269,3568),(114270,3569),(114271,3570),(114272,3571),(114273,3572),(114274,3573),(114275,3574),(114276,3575),(114277,3576),(114278,3577),(114279,3578),(114280,3579),(114281,3580),(114282,3581),(114283,3582),(114284,3583),(114285,3584),(114286,3585),(114287,3586),(114288,3587),(114289,3588),(114290,3589),(114291,3590),(114292,3591),(114293,3593),(114294,3594),(114295,3610),(114296,3611),(114297,3612),(114298,3613),(114299,3614),(114300,3615),(114301,3616),(114302,3617),(114303,3618),(114304,3619),(114305,3620),(114306,3621),(114307,3622),(114308,3624),(114309,3625),(114310,3626),(114311,3627),(114312,3628),(114313,3629),(114314,3630),(114315,3631),(114316,3632),(114317,3633),(114318,3634),(114319,3635),(114320,3636),(114321,3637),(114322,3638),(114323,3639),(114324,3640),(114325,3641),(114326,3642),(114327,3643),(114328,3644),(114329,3645),(114330,3646),(114331,3647),(114332,3648),(114333,3649),(114334,3650),(114335,3651),(114336,3652),(114337,3653),(114338,3654),(114339,3655),(114340,3656),(114341,3657),(114342,3658),(114343,3659),(114344,3660),(114345,3661),(114346,3662),(114347,3663),(114348,3664),(114349,3665),(114350,3666),(114351,3667),(114352,3668),(114353,3669),(114354,3670),(114355,3671),(114356,3672),(114357,3673),(114358,3674),(114359,3675),(114360,3676),(114361,3677),(114362,3678),(114363,3679),(114364,3680),(114365,3681),(114366,3682),(114367,3683),(114368,3684),(114369,3685),(114370,3701),(114371,3711),(114372,3712),(114373,3713),(114374,3714),(114375,2921),(114376,2922),(114377,2942),(114378,2944),(114379,3153),(114380,3675),(114381,3676),(114382,3677),(114383,3678),(114384,3679),(114385,3680),(114386,3681),(114387,3682),(114388,3683),(114389,1953),(114390,1954),(114391,1955),(114392,1956),(114393,1957),(114394,2003),(114395,2004),(114396,2009),(114397,2010),(114398,2011),(114399,2017),(114400,2043),(114401,2047),(114402,2048),(114403,2049),(114404,2050),(114405,2051),(114406,2052),(114407,2054),(114408,2056),(114409,2057),(114410,2058),(114411,2059),(114412,2060),(114413,2061),(114414,2064),(114415,2067),(114416,2069),(114417,2071),(114418,2073),(114419,2075),(114420,2077),(114421,2078),(114422,2080),(114423,2083),(114424,2084),(114425,2086),(114426,2087),(114427,2088),(114428,2089),(114429,2092),(114430,2105),(114431,2106),(114432,2107),(114433,2108),(114434,2109),(114435,2110),(114436,2111),(114437,2112),(114438,2120),(114439,2121),(114440,2166),(114441,2167),(114442,2170),(114443,2171),(114444,2172),(114445,2173),(114446,2174),(114447,2175),(114448,2227),(114449,2228),(114450,2229),(114451,2230),(114452,2231),(114453,2253),(114454,2254),(114455,2285),(114456,2287),(114457,2292),(114458,2432),(114459,2433),(114460,2434),(114461,2436),(114462,2437),(114463,2438),(114464,2439),(114465,2443),(114466,2444),(114467,2445),(114468,2446),(114469,2447),(114470,2448),(114471,2457),(114472,2475),(114473,2476),(114474,2492),(114475,2493),(114476,2532),(114477,2533),(114478,2534),(114479,2535),(114480,2555),(114481,2560),(114482,2561),(114483,2562),(114484,2563),(114485,2564),(114486,2565),(114487,2566),(114488,2569),(114489,2570),(114490,2571),(114491,2572),(114492,2582),(114493,2583),(114494,2585),(114495,2588),(114496,2615),(114497,3737),(114498,3832),(114499,4021),(114500,4022),(114501,4023),(114502,4024),(114503,4025),(114504,4026),(114505,4027),(114506,4028),(114507,4029),(114508,4030),(114509,4031),(114510,4032),(114511,4033),(114512,4032),(114513,4033),(114514,3731),(114515,3735),(114516,3736),(114517,3744),(114518,3753),(114519,3755),(114520,3760),(114521,4022),(114522,4024),(114523,4026),(114524,4029),(114525,4031),(114526,4033),(114527,4183),(114528,4184),(114529,4189),(114530,3719),(114531,3724),(114532,4138),(114533,4139),(114534,4409),(114535,4413),(114536,3940),(114537,3962),(114538,3992),(114539,3999),(114540,4006),(114541,4008),(114542,4038),(114543,4044),(114544,4092),(114545,4093),(114546,4095),(114547,4125),(114548,4126),(114549,4178),(114550,4246),(114551,4271),(114552,4272),(114553,4273),(114554,4284),(114555,4285),(114556,4320),(114557,4321),(114558,4322),(114559,4323),(114560,4324),(114561,4360),(114562,4457),(114563,3889),(114564,3908),(114565,4094),(114566,4162),(114567,4271),(114568,4272),(114569,4341),(114570,4416),(114571,3971),(114572,3990),(114573,3991),(114574,4000),(114575,4001),(114576,4004),(114577,4005),(114578,4045),(114579,4046),(114580,4047),(114581,4048),(114582,4050),(114583,4051),(114584,4097),(114585,4100),(114586,4101),(114587,4103),(114588,4104),(114589,4105),(114590,4106),(114591,4107),(114592,4109),(114593,4110),(114594,4111),(114595,4112),(114596,4113),(114597,4114),(114598,4115),(114599,4116),(114600,4117),(114601,4144),(114602,4160),(114603,4163),(114604,4166),(114605,4176),(114606,4221),(114607,4284),(114608,4285),(114609,4286),(114610,4361),(114611,4368),(114612,4369),(114613,4372),(114614,4375),(114615,4376),(114616,4377),(114617,4380),(114618,4385),(114619,4386),(114620,4387),(114621,4388),(114622,4389),(114623,4423),(114624,4429),(114625,4440),(114626,3869),(114627,3907),(114628,4096),(114629,4162),(114630,3723),(114631,3732),(114632,3739),(114633,3746),(114634,3835),(114635,3896),(114636,3897),(114637,3898),(114638,3899),(114639,4362),(114640,4363),(114641,4365),(114642,4463),(114643,4464),(114644,4465),(114645,4466),(114646,4471),(114647,4472),(114648,4477),(114649,4478),(114650,3835),(114651,3896),(114652,3897),(114653,3898),(114654,3899),(114655,4240),(114656,4362),(114657,4363),(114658,4365),(114659,4463),(114660,4464),(114661,4465),(114662,4466),(114663,4471),(114664,4472),(114665,4477),(114666,4478),(114667,3843),(114668,3844),(114669,3845),(114670,3879),(114671,3888),(114672,3978),(114673,4049),(114674,4098),(114675,4099),(114676,4141),(114677,4147),(114678,4329),(114679,4357),(114680,4422),(114681,4428),(114682,1629),(114683,1636),(114684,1637),(114685,1638),(114686,1639),(114687,1643),(114688,1644),(114689,1645),(114690,1646),(114691,1647),(114692,1648),(114693,1649),(114694,3979),(114695,3980),(114696,4141),(114697,4147),(114698,4153),(114699,4154),(114700,4168),(114701,4248),(114702,4337),(114703,4338),(114704,4339),(114705,4359),(114706,3835),(114707,3843),(114708,3844),(114709,3845),(114710,3888),(114711,4098),(114712,4099),(114713,4357),(114714,4428),(114715,3772),(114716,3773),(114717,3775),(114718,3860),(114719,3868),(114720,3891),(114721,3900),(114722,3901),(114723,3902),(114724,3906),(114725,3917),(114726,3939),(114727,3940),(114728,4042),(114729,4061),(114730,4071),(114731,4072),(114732,4073),(114733,4074),(114734,4096),(114735,4150),(114736,4157),(114737,4158),(114738,4159),(114739,4164),(114740,4165),(114741,4199),(114742,4200),(114743,4201),(114744,4242),(114745,4247),(114746,4261),(114747,4262),(114748,4263),(114749,4268),(114750,4341),(114751,4368),(114752,4369),(114753,4370),(114754,4371),(114755,4372),(114756,4373),(114757,4374),(114758,4375),(114759,4384),(114760,4387),(114761,4389),(114762,4416),(114763,4479),(114764,3772),(114765,3773),(114766,3775),(114767,3860),(114768,3868),(114769,3891),(114770,3900),(114771,3901),(114772,3902),(114773,3906),(114774,3917),(114775,3939),(114776,3940),(114777,4042),(114778,4061),(114779,4071),(114780,4072),(114781,4073),(114782,4074),(114783,4096),(114784,4150),(114785,4157),(114786,4158),(114787,4159),(114788,4164),(114789,4165),(114790,4199),(114791,4200),(114792,4201),(114793,4242),(114794,4247),(114795,4261),(114796,4262),(114797,4263),(114798,4268),(114799,4341),(114800,4368),(114801,4369),(114802,4370),(114803,4371),(114804,4372),(114805,4373),(114806,4374),(114807,4375),(114808,4384),(114809,4387),(114810,4389),(114811,4416),(114812,4479),(114813,3772),(114814,3773),(114815,3775),(114816,3860),(114817,3868),(114818,3891),(114819,3900),(114820,3901),(114821,3902),(114822,3906),(114823,3917),(114824,3939),(114825,3940),(114826,4042),(114827,4061),(114828,4071),(114829,4072),(114830,4073),(114831,4074),(114832,4096),(114833,4150),(114834,4157),(114835,4158),(114836,4159),(114837,4164),(114838,4165),(114839,4199),(114840,4200),(114841,4201),(114842,4242),(114843,4247),(114844,4261),(114845,4262),(114846,4263),(114847,4268),(114848,4341),(114849,4368),(114850,4369),(114851,4370),(114852,4371),(114853,4372),(114854,4373),(114855,4374),(114856,4375),(114857,4384),(114858,4387),(114859,4389),(114860,4479),(114861,3861),(114862,4170),(114863,4171),(114864,4174),(114865,4175),(114866,4203),(114867,4340),(114868,4434),(114869,4435),(114870,4416),(114871,3772),(114872,3773),(114873,3775),(114874,3860),(114875,3868),(114876,3891),(114877,3900),(114878,3901),(114879,3902),(114880,3906),(114881,3917),(114882,3939),(114883,3940),(114884,4042),(114885,4061),(114886,4071),(114887,4072),(114888,4073),(114889,4074),(114890,4096),(114891,4150),(114892,4157),(114893,4158),(114894,4159),(114895,4164),(114896,4165),(114897,4199),(114898,4200),(114899,4201),(114900,4242),(114901,4247),(114902,4261),(114903,4262),(114904,4263),(114905,4268),(114906,4341),(114907,4368),(114908,4369),(114909,4370),(114910,4371),(114911,4372),(114912,4373),(114913,4374),(114914,4375),(114915,4384),(114916,4387),(114917,4389),(114918,4416),(114919,4479),(114920,3861),(114921,4170),(114922,4171),(114923,4174),(114924,4175),(114925,4203),(114926,4340),(114927,4434),(114928,4435),(114929,2181),(114930,2182),(114931,2183),(114932,2184),(114933,2185),(114934,2186),(114935,2203),(114936,2204),(114937,2205),(114938,2206),(114939,2207),(114940,2212),(114941,2213),(114942,2223),(114943,2224),(114944,2225),(114945,2252),(114946,2255),(114947,2263),(114948,2264),(114949,2272),(114950,2273),(114951,2274),(114952,2277),(114953,2278),(114954,2279),(114955,2280),(114956,2281),(114957,2282),(114958,2283),(114959,2284),(114960,2286),(114961,2288),(114962,2294),(114963,2297),(114964,2298),(114965,2300),(114966,2301),(114967,2429),(114968,2450),(114969,2451),(114970,2452),(114971,2453),(114972,2465),(114973,2466),(114974,2467),(114975,2468),(114976,2469),(114977,2470),(114978,2471),(114979,2474),(114980,2481),(114981,2482),(114982,2483),(114983,2484),(114984,2485),(114985,2487),(114986,2488),(114987,2489),(114988,2490),(114989,2491),(114990,2494),(114991,2495),(114992,2496),(114993,2497),(114994,2501),(114995,2502),(114996,2513),(114997,2514),(114998,2529),(114999,2536),(115000,2543),(115001,2544),(115002,2547),(115003,2548),(115004,2549),(115005,2550),(115006,2551),(115007,2552),(115008,2553),(115009,2554),(115010,2556),(115011,2557),(115012,2558),(115013,2616),(115014,2617),(115015,2618),(115016,2619),(115017,2620),(115018,2621),(115019,1958),(115020,2005),(115021,2006),(115022,2007),(115023,2012),(115024,2015),(115025,2016),(115026,2018),(115027,2019),(115028,2020),(115029,2024),(115030,2025),(115031,2033),(115032,2036),(115033,2038),(115034,2053),(115035,2055),(115036,2062),(115037,2063),(115038,2065),(115039,2066),(115040,2068),(115041,2070),(115042,2072),(115043,2074),(115044,2076),(115045,2079),(115046,2081),(115047,2082),(115048,2085),(115049,2090),(115050,2091),(115051,2093),(115052,2094),(115053,2095),(115054,2096),(115055,2097),(115056,2098),(115057,2099),(115058,2100),(115059,2101),(115060,2102),(115061,2103),(115062,2104),(115063,2116),(115064,2117),(115065,2118),(115066,2119),(115067,2158),(115068,2159),(115069,2160),(115070,2161),(115071,2164),(115072,2165),(115073,2168),(115074,2169),(115075,2178),(115076,2179),(115077,2180),(115078,281),(115079,284),(115080,286),(115081,287),(115082,289),(115083,291),(115084,292),(115085,294),(115086,296),(115087,297),(115088,301),(115089,304),(115090,305),(115091,307),(115092,316),(115093,332),(115094,333),(115095,337),(115096,527),(115097,528),(115098,529),(115099,557),(115100,588),(115101,590),(115102,592),(115103,611),(115104,613),(115105,617),(115106,618),(115107,619),(115108,624),(115109,625),(115110,636),(115111,637),(115112,639),(115113,646),(115114,648),(115115,659),(115116,660),(115117,670),(115118,690),(115119,691),(115120,693),(115121,695),(115122,697),(115123,698),(115124,700),(115125,702),(115126,706),(115127,728),(115128,778),(115129,779),(115130,834),(115131,835),(115132,836),(115133,837),(115134,838),(115135,839),(115136,840),(115137,906),(115138,997),(115139,1001),(115140,1037),(115141,1038),(115142,1064),(115143,1066),(115144,1067),(115145,1068),(115146,1069),(115147,1070),(115148,1071),(115149,1072),(115150,1073),(115151,1074),(115152,1075),(115153,1133),(115154,1165),(115155,1813),(115156,1815),(115157,1816),(115158,1818),(115159,1820),(115160,1821),(115161,1822),(115162,1827),(115163,2003),(115164,2004),(115165,2005),(115166,2006),(115167,2007),(115168,2008),(115169,2009),(115170,2010),(115171,2011),(115172,2012),(115173,2014),(115174,2016),(115175,2017),(115176,2020),(115177,2024),(115178,2033),(115179,2038),(115180,2043),(115181,2067),(115182,2105),(115183,2116),(115184,2117),(115185,2158),(115186,2160),(115187,2161),(115188,2164),(115189,2170),(115190,2171),(115191,2172),(115192,2173),(115193,2176),(115194,2181),(115195,2184),(115196,2185),(115197,2186),(115198,2199),(115199,2203),(115200,2207),(115201,2227),(115202,2247),(115203,2249),(115204,2250),(115205,2277),(115206,2278),(115207,2279),(115208,2280),(115209,2297),(115210,2429),(115211,2430),(115212,2431),(115213,2440),(115214,2443),(115215,2444),(115216,2457),(115217,2474),(115218,2481),(115219,2482),(115220,2483),(115221,2485),(115222,2506),(115223,2517),(115224,2518),(115225,2520),(115226,2521),(115227,2523),(115228,2524),(115229,2525),(115230,2526),(115231,2528),(115232,2529),(115233,2530),(115234,2532),(115235,2533),(115236,2534),(115237,2535),(115238,2536),(115239,2539),(115240,2544),(115241,2545),(115242,2546),(115243,2547),(115244,2548),(115245,2549),(115246,2550),(115247,2551),(115248,2553),(115249,2554),(115250,2560),(115251,2573),(115252,2574),(115253,2575),(115254,2576),(115255,2182),(115256,2183),(115257,2211),(115258,2212),(115259,2213),(115260,2223),(115261,2224),(115262,2225),(115263,2228),(115264,2229),(115265,2231),(115266,2253),(115267,2254),(115268,2255),(115269,2263),(115270,2264),(115271,2272),(115272,2273),(115273,2274),(115274,2281),(115275,2282),(115276,2283),(115277,2284),(115278,2285),(115279,2286),(115280,2287),(115281,2288),(115282,2292),(115283,2294),(115284,2295),(115285,2298),(115286,2432),(115287,2433),(115288,2434),(115289,2436),(115290,2437),(115291,2438),(115292,2439),(115293,2445),(115294,2446),(115295,2447),(115296,2448),(115297,2450),(115298,2451),(115299,2453),(115300,2465),(115301,2466),(115302,2467),(115303,2468),(115304,2469),(115305,2470),(115306,2471),(115307,2480),(115308,2484),(115309,2486),(115310,2487),(115311,2488),(115312,2492),(115313,2493),(115314,2496),(115315,2498),(115316,2499),(115317,2500),(115318,2501),(115319,2502),(115320,2513),(115321,2514),(115322,2519),(115323,2522),(115324,2527),(115325,2552),(115326,2556),(115327,2557),(115328,2558),(115329,2561),(115330,2562),(115331,2563),(115332,2564),(115333,2565),(115334,2566),(115335,2567),(115336,2568),(115337,2569),(115338,2570),(115339,2571),(115340,2572),(115341,2582),(115342,2583),(115343,2584),(115344,2585),(115345,2586),(115346,2587),(115347,2588),(115348,2615),(115349,2616),(115350,2617),(115351,2618),(115352,2619),(115353,2620),(115354,5757),(115355,5758),(115356,5759),(115357,298),(115358,299),(115359,300),(115360,302),(115361,303),(115362,306),(115363,341),(115364,342),(115365,343),(115366,374),(115367,375),(115368,376),(115369,530),(115370,531),(115371,532),(115372,560),(115373,587),(115374,589),(115375,591),(115376,632),(115377,652),(115378,682),(115379,683),(115380,684),(115381,685),(115382,686),(115383,687),(115384,688),(115385,689),(115386,694),(115387,696),(115388,705),(115389,711),(115390,712),(115391,715),(115392,716),(115393,717),(115394,735),(115395,736),(115396,742),(115397,998),(115398,999),(115399,1000),(115400,1036),(115401,1162),(115402,1163),(115403,1164),(115404,1956),(115405,1957),(115406,1958),(115407,2015),(115408,2018),(115409,2019),(115410,2047),(115411,2048),(115412,2049),(115413,2050),(115414,2051),(115415,2052),(115416,2053),(115417,2054),(115418,2055),(115419,2056),(115420,2057),(115421,2058),(115422,2060),(115423,2061),(115424,2062),(115425,2063),(115426,2065),(115427,2066),(115428,2068),(115429,2069),(115430,2070),(115431,2071),(115432,2072),(115433,2073),(115434,2074),(115435,2075),(115436,2076),(115437,2077),(115438,2078),(115439,2079),(115440,2080),(115441,2081),(115442,2082),(115443,2083),(115444,2084),(115445,2085),(115446,2090),(115447,2091),(115448,2092),(115449,2093),(115450,2097),(115451,2098),(115452,2099),(115453,2100),(115454,2101),(115455,2102),(115456,2118),(115457,2119),(115458,2120),(115459,2121),(115460,2155),(115461,2156),(115462,2157),(115463,2162),(115464,2165),(115465,2166),(115466,2167),(115467,2168),(115468,2169),(115469,2175),(115470,2178),(115471,2179),(115472,2180),(115473,1162),(115474,1163),(115475,1164),(115476,1165),(115477,1818),(115478,1953),(115479,1954),(115480,1955),(115481,1956),(115482,2013),(115483,2159),(115484,2164),(115485,2176),(115486,2184),(115487,2185),(115488,2203),(115489,2206),(115490,2212),(115491,2227),(115492,2228),(115493,2229),(115494,2230),(115495,2248),(115496,2271),(115497,2278),(115498,2280),(115499,2300),(115500,2429),(115501,2430),(115502,2431),(115503,2440),(115504,2441),(115505,2472),(115506,2473),(115507,2474),(115508,2475),(115509,2476),(115510,2483),(115511,2489),(115512,2490),(115513,2491),(115514,2494),(115515,2495),(115516,2496),(115517,2497),(115518,2506),(115519,2508),(115520,2511),(115521,2517),(115522,2518),(115523,2519),(115524,2520),(115525,2523),(115526,2524),(115527,2525),(115528,2526),(115529,2528),(115530,2532),(115531,2533),(115532,2534),(115533,2536),(115534,2543),(115535,2544),(115536,2545),(115537,2546),(115538,2548),(115539,2551),(115540,2553),(115541,2574),(115542,2575),(115543,2576),(115544,2583),(115545,5757),(115546,5758),(115547,5759),(115548,1816),(115549,1958),(115550,2014),(115551,2096),(115552,2161),(115553,2163),(115554,2174),(115555,2175),(115556,2183),(115557,2186),(115558,2205),(115559,2213),(115560,2223),(115561,2224),(115562,2225),(115563,2231),(115564,2247),(115565,2270),(115566,2277),(115567,2279),(115568,2282),(115569,2295),(115570,2298),(115571,2301),(115572,2434),(115573,2439),(115574,2448),(115575,2487),(115576,2488),(115577,2492),(115578,2493),(115579,2507),(115580,2509),(115581,2512),(115582,2514),(115583,2522),(115584,2527),(115585,2530),(115586,2547),(115587,2549),(115588,2550),(115589,2554),(115590,2585),(115591,2008),(115592,2182),(115593,2204),(115594,2207),(115595,2249),(115596,2250),(115597,2446),(115598,2587),(115599,1957),(115600,2486),(115601,2043),(115602,2199),(115603,2203),(115604,2586),(115605,2587),(115606,2181),(115607,2182),(115608,2183),(115609,2184),(115610,2185),(115611,2186),(115612,2199),(115613,2203),(115614,2204),(115615,2205),(115616,2206),(115617,2207),(115618,2211),(115619,2212),(115620,2213),(115621,2223),(115622,2224),(115623,2225),(115624,2226),(115625,2227),(115626,2228),(115627,2229),(115628,2230),(115629,2231),(115630,2247),(115631,2248),(115632,2249),(115633,2250),(115634,2252),(115635,2253),(115636,2254),(115637,2255),(115638,2263),(115639,2264),(115640,2270),(115641,2271),(115642,2272),(115643,2273),(115644,2274),(115645,2277),(115646,2278),(115647,2279),(115648,2280),(115649,2281),(115650,2282),(115651,2283),(115652,2284),(115653,2285),(115654,2286),(115655,2287),(115656,2288),(115657,2292),(115658,2294),(115659,2295),(115660,2296),(115661,2297),(115662,2298),(115663,2300),(115664,2301),(115665,2429),(115666,2430),(115667,2431),(115668,2432),(115669,2433),(115670,2434),(115671,2436),(115672,2437),(115673,2438),(115674,2439),(115675,2440),(115676,2441),(115677,2442),(115678,2443),(115679,2444),(115680,2445),(115681,2446),(115682,2447),(115683,2448),(115684,2450),(115685,2451),(115686,2452),(115687,2453),(115688,2457),(115689,2465),(115690,2466),(115691,2467),(115692,2468),(115693,2469),(115694,2470),(115695,2471),(115696,2472),(115697,2473),(115698,2474),(115699,2475),(115700,2476),(115701,2477),(115702,2478),(115703,2479),(115704,2480),(115705,2481),(115706,2482),(115707,2483),(115708,2484),(115709,2485),(115710,2486),(115711,2487),(115712,2488),(115713,2489),(115714,2490),(115715,2491),(115716,2492),(115717,2493),(115718,2494),(115719,2495),(115720,2496),(115721,2497),(115722,2498),(115723,2499),(115724,2500),(115725,2501),(115726,2502),(115727,2506),(115728,2507),(115729,2508),(115730,2509),(115731,2510),(115732,2511),(115733,2512),(115734,2513),(115735,2514),(115736,2517),(115737,2518),(115738,2519),(115739,2520),(115740,2521),(115741,2522),(115742,2523),(115743,2524),(115744,2525),(115745,2526),(115746,2527),(115747,2528),(115748,2529),(115749,2530),(115750,2532),(115751,2533),(115752,2534),(115753,2535),(115754,2536),(115755,2539),(115756,2543),(115757,2544),(115758,2545),(115759,2546),(115760,2547),(115761,2548),(115762,2549),(115763,2550),(115764,2551),(115765,2552),(115766,2553),(115767,2554),(115768,2555),(115769,2556),(115770,2557),(115771,2558),(115772,2560),(115773,2561),(115774,2562),(115775,2563),(115776,2564),(115777,2565),(115778,2566),(115779,2567),(115780,2568),(115781,2569),(115782,2570),(115783,2571),(115784,2572),(115785,2573),(115786,2574),(115787,2575),(115788,2576),(115789,2582),(115790,2583),(115791,2584),(115792,2585),(115793,2586),(115794,2587),(115795,2588),(115796,2615),(115797,2616),(115798,2617),(115799,2618),(115800,2619),(115801,2620),(115802,2621),(115803,5757),(115804,5758),(115805,5759),(115806,281),(115807,284),(115808,286),(115809,287),(115810,289),(115811,291),(115812,292),(115813,294),(115814,296),(115815,297),(115816,298),(115817,299),(115818,300),(115819,301),(115820,302),(115821,303),(115822,304),(115823,305),(115824,306),(115825,307),(115826,316),(115827,332),(115828,333),(115829,337),(115830,341),(115831,342),(115832,343),(115833,374),(115834,375),(115835,376),(115836,527),(115837,528),(115838,529),(115839,530),(115840,531),(115841,532),(115842,557),(115843,560),(115844,587),(115845,588),(115846,589),(115847,590),(115848,591),(115849,592),(115850,611),(115851,613),(115852,617),(115853,618),(115854,619),(115855,624),(115856,625),(115857,632),(115858,636),(115859,637),(115860,639),(115861,646),(115862,648),(115863,652),(115864,659),(115865,660),(115866,670),(115867,682),(115868,683),(115869,684),(115870,685),(115871,686),(115872,687),(115873,688),(115874,689),(115875,690),(115876,691),(115877,693),(115878,694),(115879,695),(115880,696),(115881,697),(115882,698),(115883,700),(115884,702),(115885,705),(115886,706),(115887,711),(115888,712),(115889,715),(115890,716),(115891,717),(115892,728),(115893,735),(115894,736),(115895,742),(115896,778),(115897,779),(115898,834),(115899,835),(115900,836),(115901,837),(115902,838),(115903,839),(115904,840),(115905,906),(115906,997),(115907,998),(115908,999),(115909,1000),(115910,1001),(115911,1036),(115912,1037),(115913,1038),(115914,1064),(115915,1066),(115916,1067),(115917,1068),(115918,1069),(115919,1070),(115920,1071),(115921,1072),(115922,1073),(115923,1074),(115924,1075),(115925,1133),(115926,1162),(115927,1163),(115928,1164),(115929,1165),(115930,1813),(115931,1815),(115932,1816),(115933,1818),(115934,1820),(115935,1821),(115936,1822),(115937,1827),(115938,1953),(115939,1954),(115940,1955),(115941,1956),(115942,1957),(115943,1958),(115944,2003),(115945,2004),(115946,2005),(115947,2006),(115948,2007),(115949,2008),(115950,2009),(115951,2010),(115952,2011),(115953,2012),(115954,2014),(115955,2015),(115956,2016),(115957,2017),(115958,2018),(115959,2019),(115960,2020),(115961,2024),(115962,2025),(115963,2033),(115964,2036),(115965,2038),(115966,2043),(115967,2047),(115968,2048),(115969,2049),(115970,2050),(115971,2051),(115972,2052),(115973,2053),(115974,2054),(115975,2055),(115976,2056),(115977,2057),(115978,2058),(115979,2059),(115980,2060),(115981,2061),(115982,2062),(115983,2063),(115984,2064),(115985,2065),(115986,2066),(115987,2067),(115988,2068),(115989,2069),(115990,2070),(115991,2071),(115992,2072),(115993,2073),(115994,2074),(115995,2075),(115996,2076),(115997,2077),(115998,2078),(115999,2079),(116000,2080),(116001,2081),(116002,2082),(116003,2083),(116004,2084),(116005,2085),(116006,2086),(116007,2087),(116008,2088),(116009,2089),(116010,2090),(116011,2091),(116012,2092),(116013,2093),(116014,2094),(116015,2095),(116016,2096),(116017,2097),(116018,2098),(116019,2099),(116020,2100),(116021,2101),(116022,2102),(116023,2103),(116024,2104),(116025,2105),(116026,2106),(116027,2107),(116028,2108),(116029,2109),(116030,2110),(116031,2111),(116032,2112),(116033,2116),(116034,2117),(116035,2118),(116036,2119),(116037,2120),(116038,2121),(116039,2155),(116040,2156),(116041,2157),(116042,2158),(116043,2159),(116044,2160),(116045,2161),(116046,2162),(116047,2163),(116048,2164),(116049,2165),(116050,2166),(116051,2167),(116052,2168),(116053,2169),(116054,2170),(116055,2171),(116056,2172),(116057,2173),(116058,2174),(116059,2175),(116060,2176),(116061,2178),(116062,2179),(116063,2180),(116064,716),(116065,717),(116066,2199),(116067,2203),(116068,2281),(116069,2282),(116070,2294),(116071,2295),(116072,2457),(116073,2517),(116074,2518),(116075,2519),(116076,2520),(116077,2547),(116078,2548),(116079,2549),(116080,2550),(116081,2551),(116082,2582),(116083,2583),(116084,2584),(116085,2585),(116086,2586),(116087,2587),(116088,1070),(116089,1958),(116090,2036),(116091,2043),(116092,2086),(116093,2087),(116094,2088),(116095,2092),(116096,2093),(116097,2094),(116098,2095),(116099,2096),(116100,2162),(116101,2204),(116102,2205),(116103,2206),(116104,2212),(116105,2213),(116106,2277),(116107,2278),(116108,2279),(116109,2280),(116110,2300),(116111,2301),(116112,2489),(116113,2490),(116114,2491),(116115,2532),(116116,2533),(116117,2534),(116118,2535),(116119,1816),(116120,1818),(116121,1822),(116122,2013),(116123,4861),(116124,4862),(116125,4863),(116126,4864),(116127,4865),(116128,4866),(116129,4867),(116130,4868),(116131,4869),(116132,4870),(116133,4871),(116134,4872),(116135,4873),(116136,4874),(116137,4875),(116138,4876),(116139,4891),(116140,4892),(116141,4893),(116142,4894),(116143,281),(116144,282),(116145,283),(116146,284),(116147,285),(116148,286),(116149,287),(116150,288),(116151,289),(116152,290),(116153,291),(116154,292),(116155,293),(116156,294),(116157,295),(116158,296),(116159,297),(116160,298),(116161,299),(116162,300),(116163,301),(116164,302),(116165,303),(116166,304),(116167,305),(116168,306),(116169,307),(116170,308),(116171,309),(116172,310),(116173,311),(116174,312),(116175,313),(116176,314),(116177,315),(116178,316),(116179,317),(116180,318),(116181,319),(116182,320),(116183,321),(116184,322),(116185,323),(116186,324),(116187,325),(116188,326),(116189,327),(116190,328),(116191,329),(116192,330),(116193,331),(116194,332),(116195,333),(116196,334),(116197,335),(116198,336),(116199,337),(116200,338),(116201,339),(116202,340),(116203,341),(116204,342),(116205,343),(116206,344),(116207,345),(116208,346),(116209,347),(116210,903),(116211,904),(116212,905),(116213,907),(116214,1813),(116215,1814),(116216,1815),(116217,1816),(116218,1817),(116219,1818),(116220,1819),(116221,1820),(116222,1821),(116223,1822),(116224,1823),(116225,1824),(116226,1825),(116227,1826),(116228,1827),(116229,1828),(116230,1829),(116231,1830),(116232,1831),(116233,1832),(116234,1833),(116235,1834),(116236,1835),(116237,1950),(116238,1951),(116239,1952),(116240,1953),(116241,1954),(116242,1955),(116243,1956),(116244,1957),(116245,1958),(116246,1965),(116247,1966),(116248,1967),(116249,1968),(116250,1969),(116251,1970),(116252,1971),(116253,2154),(116254,2158),(116255,2159),(116256,2160),(116257,2161),(116258,2162),(116259,2170),(116260,2171),(116261,2172),(116262,2173),(116263,2174),(116264,2175),(116265,2177),(116266,2181),(116267,2182),(116268,2183),(116269,2184),(116270,2185),(116271,2186),(116272,2199),(116273,2211),(116274,2212),(116275,2213),(116276,2223),(116277,2224),(116278,2225),(116279,2226),(116280,2227),(116281,2228),(116282,2229),(116283,2230),(116284,2231),(116285,2281),(116286,2282),(116287,2292),(116288,2294),(116289,2295),(116290,2297),(116291,2298),(116292,2432),(116293,2433),(116294,2434),(116295,2436),(116296,2437),(116297,2438),(116298,2439),(116299,2443),(116300,2444),(116301,2445),(116302,2446),(116303,2447),(116304,2448),(116305,2475),(116306,2476),(116307,2477),(116308,2478),(116309,2479),(116310,2480),(116311,2481),(116312,2482),(116313,2483),(116314,2484),(116315,2485),(116316,2486),(116317,2487),(116318,2488),(116319,2492),(116320,2493),(116321,2494),(116322,2495),(116323,2496),(116324,2497),(116325,2498),(116326,2499),(116327,2500),(116328,2513),(116329,2514),(116330,2529),(116331,2530),(116332,2539),(116333,2553),(116334,2554),(116335,2582),(116336,2583),(116337,2584),(116338,2585),(116339,2586),(116340,2587),(116341,4613),(116342,4614),(116343,4857),(116344,4858),(116345,4859),(116346,4860),(116347,906),(116348,908),(116349,1004),(116350,1012),(116351,1019),(116352,1037),(116353,1092),(116354,1119),(116355,1162),(116356,1163),(116357,1164),(116358,1165),(116359,2163),(116360,2164),(116361,2176),(116362,2203),(116363,2204),(116364,2205),(116365,2206),(116366,2207),(116367,2247),(116368,2248),(116369,2249),(116370,2250),(116371,2270),(116372,2271),(116373,2277),(116374,2278),(116375,2279),(116376,2280),(116377,2296),(116378,2299),(116379,2300),(116380,2301),(116381,2429),(116382,2430),(116383,2431),(116384,2440),(116385,2441),(116386,2442),(116387,2457),(116388,2472),(116389,2473),(116390,2474),(116391,2489),(116392,2490),(116393,2491),(116394,2506),(116395,2507),(116396,2508),(116397,2509),(116398,2510),(116399,2511),(116400,2512),(116401,2521),(116402,2522),(116403,2523),(116404,2524),(116405,2525),(116406,2526),(116407,2527),(116408,2528),(116409,2531),(116410,2532),(116411,2533),(116412,2534),(116413,2535),(116414,2536),(116415,2540),(116416,2541),(116417,2542),(116418,2543),(116419,2544),(116420,2545),(116421,2546),(116422,2547),(116423,2548),(116424,2549),(116425,2550),(116426,2551),(116427,2573),(116428,2574),(116429,2575),(116430,2576),(116431,5757),(116432,5758),(116433,5759),(116434,681),(116435,682),(116436,683),(116437,684),(116438,685),(116439,686),(116440,687),(116441,688),(116442,689),(116443,690),(116444,691),(116445,692),(116446,693),(116447,694),(116448,695),(116449,696),(116450,697),(116451,698),(116452,699),(116453,700),(116454,701),(116455,702),(116456,703),(116457,704),(116458,705),(116459,706),(116460,707),(116461,708),(116462,709),(116463,710),(116464,711),(116465,712),(116466,713),(116467,714),(116468,715),(116469,716),(116470,717),(116471,718),(116472,719),(116473,720),(116474,721),(116475,722),(116476,723),(116477,724),(116478,725),(116479,726),(116480,727),(116481,728),(116482,729),(116483,730),(116484,731),(116485,732),(116486,733),(116487,734),(116488,735),(116489,736),(116490,737),(116491,738),(116492,739),(116493,740),(116494,741),(116495,742),(116496,743),(116497,744),(116498,745),(116499,746),(116500,747),(116501,748),(116502,749),(116503,996),(116504,997),(116505,998),(116506,999),(116507,1000),(116508,1001),(116509,1002),(116510,1003),(116511,1005),(116512,1034),(116513,1035),(116514,1036),(116515,1038),(116516,1133),(116517,1972),(116518,1973),(116519,1974),(116520,1975),(116521,1976),(116522,1977),(116523,1978),(116524,1979),(116525,1980),(116526,1981),(116527,1982),(116528,1983),(116529,1984),(116530,1985),(116531,1986),(116532,1987),(116533,1988),(116534,1989),(116535,1990),(116536,1991),(116537,2003),(116538,2004),(116539,2005),(116540,2006),(116541,2007),(116542,2008),(116543,2009),(116544,2010),(116545,2011),(116546,2012),(116547,2013),(116548,2014),(116549,2015),(116550,2016),(116551,2017),(116552,2018),(116553,2019),(116554,2020),(116555,2021),(116556,2022),(116557,2023),(116558,2024),(116559,2025),(116560,2033),(116561,2035),(116562,2036),(116563,2037),(116564,2038),(116565,2041),(116566,2043),(116567,2047),(116568,2048),(116569,2049),(116570,2050),(116571,2051),(116572,2052),(116573,2053),(116574,2054),(116575,2055),(116576,2056),(116577,2057),(116578,2058),(116579,2059),(116580,2060),(116581,2061),(116582,2062),(116583,2063),(116584,2064),(116585,2065),(116586,2066),(116587,2067),(116588,2068),(116589,2069),(116590,2070),(116591,2071),(116592,2072),(116593,2073),(116594,2074),(116595,2075),(116596,2076),(116597,2077),(116598,2078),(116599,2079),(116600,2080),(116601,2081),(116602,2082),(116603,2083),(116604,2084),(116605,2085),(116606,2086),(116607,2087),(116608,2088),(116609,2089),(116610,2090),(116611,2091),(116612,2092),(116613,2093),(116614,2094),(116615,2095),(116616,2096),(116617,2097),(116618,2098),(116619,2099),(116620,2100),(116621,2101),(116622,2102),(116623,2103),(116624,2104),(116625,2105),(116626,2106),(116627,2107),(116628,2108),(116629,2109),(116630,2110),(116631,2111),(116632,2112),(116633,2113),(116634,2114),(116635,2115),(116636,2116),(116637,2117),(116638,2118),(116639,2119),(116640,2120),(116641,2121),(116642,2155),(116643,2156),(116644,2157),(116645,2165),(116646,2166),(116647,2167),(116648,2168),(116649,2169),(116650,2178),(116651,2179),(116652,2180),(116653,2221),(116654,2222),(116655,2252),(116656,2253),(116657,2254),(116658,2255),(116659,2263),(116660,2264),(116661,2272),(116662,2273),(116663,2274),(116664,2283),(116665,2284),(116666,2285),(116667,2286),(116668,2287),(116669,2288),(116670,2450),(116671,2451),(116672,2452),(116673,2453),(116674,2465),(116675,2466),(116676,2467),(116677,2468),(116678,2469),(116679,2470),(116680,2471),(116681,2501),(116682,2502),(116683,2552),(116684,2555),(116685,2556),(116686,2557),(116687,2558),(116688,2560),(116689,2561),(116690,2562),(116691,2563),(116692,2564),(116693,2565),(116694,2566),(116695,2567),(116696,2568),(116697,2569),(116698,2570),(116699,2571),(116700,2572),(116701,2588),(116702,2615),(116703,2616),(116704,2617),(116705,2618),(116706,2619),(116707,2620),(116708,2621),(116709,348),(116710,349),(116711,350),(116712,351),(116713,352),(116714,353),(116715,354),(116716,355),(116717,356),(116718,357),(116719,358),(116720,359),(116721,360),(116722,361),(116723,370),(116724,371),(116725,372),(116726,373),(116727,374),(116728,375),(116729,376),(116730,377),(116731,378),(116732,379),(116733,380),(116734,381),(116735,382),(116736,383),(116737,384),(116738,385),(116739,386),(116740,387),(116741,388),(116742,389),(116743,390),(116744,391),(116745,392),(116746,393),(116747,394),(116748,395),(116749,396),(116750,397),(116751,533),(116752,534),(116753,535),(116754,536),(116755,537),(116756,538),(116757,539),(116758,540),(116759,541),(116760,542),(116761,543),(116762,544),(116763,545),(116764,546),(116765,547),(116766,548),(116767,549),(116768,550),(116769,551),(116770,552),(116771,553),(116772,554),(116773,555),(116774,556),(116775,558),(116776,559),(116777,561),(116778,562),(116779,563),(116780,564),(116781,565),(116782,566),(116783,567),(116784,568),(116785,569),(116786,570),(116787,571),(116788,572),(116789,573),(116790,574),(116791,575),(116792,576),(116793,577),(116794,578),(116795,579),(116796,580),(116797,581),(116798,582),(116799,583),(116800,584),(116801,585),(116802,586),(116803,587),(116804,588),(116805,589),(116806,590),(116807,591),(116808,592),(116809,593),(116810,594),(116811,595),(116812,596),(116813,597),(116814,598),(116815,599),(116816,600),(116817,601),(116818,602),(116819,603),(116820,604),(116821,605),(116822,606),(116823,607),(116824,608),(116825,609),(116826,610),(116827,612),(116828,626),(116829,627),(116830,628),(116831,629),(116832,630),(116833,631),(116834,754),(116835,755),(116836,756),(116837,757),(116838,758),(116839,759),(116840,760),(116841,761),(116842,762),(116843,763),(116844,764),(116845,765),(116846,766),(116847,767),(116848,768),(116849,769),(116850,770),(116851,771),(116852,772),(116853,773),(116854,774),(116855,775),(116856,776),(116857,777),(116858,778),(116859,779),(116860,780),(116861,781),(116862,782),(116863,783),(116864,784),(116865,785),(116866,786),(116867,787),(116868,788),(116869,789),(116870,790),(116871,791),(116872,792),(116873,793),(116874,794),(116875,795),(116876,796),(116877,797),(116878,798),(116879,799),(116880,800),(116881,801),(116882,802),(116883,803),(116884,804),(116885,805),(116886,806),(116887,807),(116888,808),(116889,809),(116890,810),(116891,811),(116892,812),(116893,813),(116894,814),(116895,815),(116896,816),(116897,817),(116898,818),(116899,819),(116900,820),(116901,821),(116902,822),(116903,823),(116904,824),(116905,825),(116906,826),(116907,827),(116908,828),(116909,829),(116910,830),(116911,831),(116912,832),(116913,833),(116914,834),(116915,835),(116916,836),(116917,837),(116918,838),(116919,839),(116920,840),(116921,841),(116922,842),(116923,843),(116924,844),(116925,845),(116926,846),(116927,847),(116928,848),(116929,849),(116930,850),(116931,851),(116932,852),(116933,853),(116934,854),(116935,855),(116936,856),(116937,857),(116938,858),(116939,859),(116940,860),(116941,861),(116942,862),(116943,863),(116944,864),(116945,865),(116946,866),(116947,867),(116948,868),(116949,869),(116950,870),(116951,871),(116952,872),(116953,1020),(116954,1021),(116955,1022),(116956,1023),(116957,1106),(116958,1166),(116959,1167),(116960,1168),(116961,1169),(116962,1170),(116963,1171),(116964,1172),(116965,1173),(116966,1174),(116967,1175),(116968,1176),(116969,1177),(116970,1178),(116971,1179),(116972,1180),(116973,1181),(116974,1182),(116975,1183),(116976,1195),(116977,1196),(116978,1197),(116979,1198),(116980,1199),(116981,1200),(116982,1201),(116983,1202),(116984,1203),(116985,1204),(116986,1205),(116987,1206),(116988,1207),(116989,1210),(116990,1211),(116991,1212),(116992,1213),(116993,1214),(116994,1215),(116995,1216),(116996,1217),(116997,1218),(116998,1219),(116999,1220),(117000,1221),(117001,1222),(117002,1223),(117003,1224),(117004,1225),(117005,1226),(117006,1227),(117007,1228),(117008,1229),(117009,1230),(117010,1231),(117011,1232),(117012,1233),(117013,1234),(117014,1235),(117015,1236),(117016,1237),(117017,1238),(117018,1239),(117019,1240),(117020,1241),(117021,1242),(117022,1243),(117023,1244),(117024,1245),(117025,1246),(117026,1247),(117027,1248),(117028,1249),(117029,1250),(117030,1251),(117031,1252),(117032,1253),(117033,1254),(117034,1255),(117035,1256),(117036,1257),(117037,1258),(117038,1259),(117039,1260),(117040,1261),(117041,1262),(117042,1263),(117043,1264),(117044,1265),(117045,1266),(117046,1267),(117047,1268),(117048,1269),(117049,1270),(117050,1271),(117051,1272),(117052,1273),(117053,1274),(117054,1275),(117055,1276),(117056,1277),(117057,1278),(117058,1279),(117059,1280),(117060,1281),(117061,1282),(117062,1283),(117063,1284),(117064,1285),(117065,1286),(117066,1287),(117067,1288),(117068,1289),(117069,1290),(117070,1291),(117071,1292),(117072,1293),(117073,1294),(117074,1295),(117075,1296),(117076,1297),(117077,1298),(117078,1299),(117079,1300),(117080,1301),(117081,1302),(117082,1303),(117083,1304),(117084,1305),(117085,1306),(117086,1307),(117087,1308),(117088,1309),(117089,1310),(117090,1311),(117091,1312),(117092,1313),(117093,1314),(117094,1315),(117095,1316),(117096,1317),(117097,1318),(117098,1319),(117099,1320),(117100,1321),(117101,1322),(117102,1323),(117103,1332),(117104,1342),(117105,1346),(117106,1347),(117107,1349),(117108,1350),(117109,1351),(117110,1353),(117111,1354),(117112,1355),(117113,1356),(117114,1357),(117115,1358),(117116,1359),(117117,1360),(117118,1361),(117119,1362),(117120,1363),(117121,1364),(117122,1366),(117123,1367),(117124,1368),(117125,1371),(117126,1375),(117127,1376),(117128,1377),(117129,1379),(117130,1389),(117131,1390),(117132,1391),(117133,1392),(117134,1393),(117135,1394),(117136,1395),(117137,1397),(117138,1398),(117139,1400),(117140,1420),(117141,1421),(117142,1422),(117143,1423),(117144,1424),(117145,1425),(117146,1427),(117147,1428),(117148,1429),(117149,1430),(117150,1431),(117151,1432),(117152,1433),(117153,1434),(117154,1435),(117155,1442),(117156,1443),(117157,1444),(117158,1445),(117159,1446),(117160,1447),(117161,1448),(117162,1450),(117163,1451),(117164,1452),(117165,1454),(117166,1455),(117167,1456),(117168,1457),(117169,1462),(117170,1469),(117171,1749),(117172,4500),(117173,4501),(117174,4502),(117175,4503),(117176,4504),(117177,4505),(117178,4506),(117179,4507),(117180,4508),(117181,4509),(117182,4510),(117183,4511),(117184,4512),(117185,4513),(117186,4514),(117187,4515),(117188,4516),(117189,4517),(117190,4518),(117191,4519),(117192,4520),(117193,4522),(117194,4523),(117195,5301),(117196,5468),(117197,5489),(117198,348),(117199,349),(117200,350),(117201,351),(117202,352),(117203,353),(117204,354),(117205,355),(117206,356),(117207,357),(117208,358),(117209,359),(117210,360),(117211,361),(117212,362),(117213,363),(117214,364),(117215,365),(117216,366),(117217,367),(117218,368),(117219,369),(117220,370),(117221,371),(117222,372),(117223,373),(117224,374),(117225,375),(117226,376),(117227,377),(117228,378),(117229,379),(117230,380),(117231,381),(117232,382),(117233,383),(117234,384),(117235,385),(117236,386),(117237,387),(117238,388),(117239,389),(117240,390),(117241,391),(117242,392),(117243,393),(117244,394),(117245,395),(117246,396),(117247,397),(117248,398),(117249,399),(117250,400),(117251,401),(117252,402),(117253,403),(117254,404),(117255,405),(117256,406),(117257,407),(117258,408),(117259,409),(117260,410),(117261,411),(117262,412),(117263,413),(117264,414),(117265,415),(117266,416),(117267,417),(117268,418),(117269,419),(117270,420),(117271,421),(117272,422),(117273,423),(117274,424),(117275,425),(117276,426),(117277,427),(117278,428),(117279,429),(117280,430),(117281,431),(117282,432),(117283,433),(117284,434),(117285,435),(117286,436),(117287,437),(117288,438),(117289,439),(117290,440),(117291,441),(117292,442),(117293,443),(117294,444),(117295,445),(117296,446),(117297,447),(117298,448),(117299,449),(117300,450),(117301,451),(117302,452),(117303,453),(117304,454),(117305,455),(117306,456),(117307,457),(117308,458),(117309,459),(117310,460),(117311,461),(117312,462),(117313,463),(117314,464),(117315,465),(117316,466),(117317,467),(117318,468),(117319,469),(117320,470),(117321,471),(117322,472),(117323,473),(117324,474),(117325,475),(117326,476),(117327,477),(117328,478),(117329,479),(117330,480),(117331,481),(117332,482),(117333,483),(117334,484),(117335,485),(117336,486),(117337,487),(117338,488),(117339,489),(117340,490),(117341,491),(117342,492),(117343,493),(117344,494),(117345,495),(117346,496),(117347,497),(117348,498),(117349,499),(117350,500),(117351,501),(117352,502),(117353,503),(117354,504),(117355,505),(117356,506),(117357,507),(117358,508),(117359,509),(117360,510),(117361,511),(117362,512),(117363,513),(117364,514),(117365,515),(117366,516),(117367,517),(117368,518),(117369,519),(117370,520),(117371,521),(117372,522),(117373,523),(117374,524),(117375,525),(117376,526),(117377,527),(117378,528),(117379,529),(117380,530),(117381,531),(117382,532),(117383,533),(117384,534),(117385,535),(117386,536),(117387,537),(117388,538),(117389,539),(117390,540),(117391,541),(117392,542),(117393,543),(117394,544),(117395,545),(117396,546),(117397,547),(117398,548),(117399,549),(117400,550),(117401,551),(117402,552),(117403,553),(117404,554),(117405,555),(117406,556),(117407,557),(117408,558),(117409,559),(117410,560),(117411,561),(117412,562),(117413,563),(117414,564),(117415,565),(117416,566),(117417,567),(117418,568),(117419,569),(117420,570),(117421,571),(117422,572),(117423,573),(117424,574),(117425,575),(117426,576),(117427,577),(117428,578),(117429,579),(117430,580),(117431,581),(117432,582),(117433,583),(117434,584),(117435,585),(117436,586),(117437,587),(117438,588),(117439,589),(117440,590),(117441,591),(117442,592),(117443,593),(117444,594),(117445,595),(117446,596),(117447,597),(117448,598),(117449,599),(117450,600),(117451,601),(117452,602),(117453,603),(117454,604),(117455,605),(117456,606),(117457,607),(117458,608),(117459,609),(117460,610),(117461,611),(117462,612),(117463,613),(117464,614),(117465,615),(117466,616),(117467,617),(117468,618),(117469,619),(117470,620),(117471,621),(117472,622),(117473,623),(117474,624),(117475,625),(117476,626),(117477,627),(117478,628),(117479,629),(117480,630),(117481,631),(117482,632),(117483,633),(117484,634),(117485,635),(117486,636),(117487,637),(117488,638),(117489,639),(117490,640),(117491,641),(117492,642),(117493,643),(117494,644),(117495,645),(117496,646),(117497,647),(117498,648),(117499,649),(117500,650),(117501,651),(117502,652),(117503,653),(117504,654),(117505,655),(117506,656),(117507,657),(117508,658),(117509,659),(117510,660),(117511,661),(117512,662),(117513,663),(117514,664),(117515,665),(117516,666),(117517,667),(117518,668),(117519,669),(117520,670),(117521,671),(117522,672),(117523,673),(117524,674),(117525,675),(117526,676),(117527,677),(117528,678),(117529,679),(117530,680),(117531,754),(117532,755),(117533,756),(117534,757),(117535,758),(117536,759),(117537,760),(117538,761),(117539,762),(117540,763),(117541,764),(117542,765),(117543,766),(117544,767),(117545,768),(117546,769),(117547,770),(117548,771),(117549,772),(117550,773),(117551,774),(117552,775),(117553,776),(117554,777),(117555,778),(117556,779),(117557,780),(117558,781),(117559,782),(117560,783),(117561,784),(117562,785),(117563,786),(117564,787),(117565,788),(117566,789),(117567,790),(117568,791),(117569,792),(117570,793),(117571,794),(117572,795),(117573,796),(117574,797),(117575,798),(117576,799),(117577,800),(117578,801),(117579,802),(117580,803),(117581,804),(117582,805),(117583,806),(117584,807),(117585,808),(117586,809),(117587,810),(117588,811),(117589,812),(117590,813),(117591,814),(117592,815),(117593,816),(117594,817),(117595,818),(117596,819),(117597,820),(117598,821),(117599,822),(117600,823),(117601,824),(117602,825),(117603,826),(117604,827),(117605,828),(117606,829),(117607,830),(117608,831),(117609,832),(117610,833),(117611,834),(117612,835),(117613,836),(117614,837),(117615,838),(117616,839),(117617,840),(117618,841),(117619,842),(117620,843),(117621,844),(117622,845),(117623,846),(117624,847),(117625,848),(117626,849),(117627,850),(117628,851),(117629,852),(117630,853),(117631,854),(117632,855),(117633,856),(117634,857),(117635,858),(117636,859),(117637,860),(117638,861),(117639,862),(117640,863),(117641,864),(117642,865),(117643,866),(117644,867),(117645,868),(117646,869),(117647,870),(117648,871),(117649,872),(117650,1020),(117651,1021),(117652,1022),(117653,1023),(117654,1106),(117655,1166),(117656,1167),(117657,1168),(117658,1169),(117659,1170),(117660,1171),(117661,1172),(117662,1173),(117663,1174),(117664,1175),(117665,1176),(117666,1177),(117667,1178),(117668,1179),(117669,1180),(117670,1181),(117671,1182),(117672,1183),(117673,1184),(117674,1185),(117675,1186),(117676,1187),(117677,1188),(117678,1189),(117679,1190),(117680,1191),(117681,1192),(117682,1193),(117683,1194),(117684,1195),(117685,1196),(117686,1197),(117687,1198),(117688,1199),(117689,1200),(117690,1201),(117691,1202),(117692,1203),(117693,1204),(117694,1205),(117695,1206),(117696,1207),(117697,1208),(117698,1209),(117699,1210),(117700,1211),(117701,1212),(117702,1213),(117703,1214),(117704,1215),(117705,1216),(117706,1217),(117707,1218),(117708,1219),(117709,1220),(117710,1221),(117711,1222),(117712,1223),(117713,1224),(117714,1225),(117715,1226),(117716,1227),(117717,1228),(117718,1229),(117719,1230),(117720,1231),(117721,1232),(117722,1233),(117723,1234),(117724,1235),(117725,1236),(117726,1237),(117727,1238),(117728,1239),(117729,1240),(117730,1241),(117731,1242),(117732,1243),(117733,1244),(117734,1245),(117735,1246),(117736,1247),(117737,1248),(117738,1249),(117739,1250),(117740,1251),(117741,1252),(117742,1253),(117743,1254),(117744,1255),(117745,1256),(117746,1257),(117747,1258),(117748,1259),(117749,1260),(117750,1261),(117751,1262),(117752,1263),(117753,1264),(117754,1265),(117755,1266),(117756,1267),(117757,1268),(117758,1269),(117759,1270),(117760,1271),(117761,1272),(117762,1273),(117763,1274),(117764,1275),(117765,1276),(117766,1277),(117767,1278),(117768,1279),(117769,1280),(117770,1281),(117771,1282),(117772,1283),(117773,1284),(117774,1285),(117775,1286),(117776,1287),(117777,1288),(117778,1289),(117779,1290),(117780,1291),(117781,1292),(117782,1293),(117783,1294),(117784,1295),(117785,1296),(117786,1297),(117787,1298),(117788,1299),(117789,1300),(117790,1301),(117791,1302),(117792,1303),(117793,1304),(117794,1305),(117795,1306),(117796,1307),(117797,1308),(117798,1309),(117799,1310),(117800,1311),(117801,1312),(117802,1313),(117803,1314),(117804,1315),(117805,1316),(117806,1317),(117807,1318),(117808,1319),(117809,1320),(117810,1321),(117811,1322),(117812,1323),(117813,1324),(117814,1325),(117815,1326),(117816,1327),(117817,1328),(117818,1329),(117819,1330),(117820,1331),(117821,1332),(117822,1333),(117823,1334),(117824,1335),(117825,1336),(117826,1337),(117827,1338),(117828,1339),(117829,1340),(117830,1341),(117831,1342),(117832,1343),(117833,1344),(117834,1345),(117835,1346),(117836,1347),(117837,1348),(117838,1349),(117839,1350),(117840,1351),(117841,1352),(117842,1353),(117843,1354),(117844,1355),(117845,1356),(117846,1357),(117847,1358),(117848,1359),(117849,1360),(117850,1361),(117851,1362),(117852,1363),(117853,1364),(117854,1365),(117855,1366),(117856,1367),(117857,1368),(117858,1369),(117859,1370),(117860,1371),(117861,1372),(117862,1373),(117863,1374),(117864,1375),(117865,1376),(117866,1377),(117867,1378),(117868,1379),(117869,1380),(117870,1381),(117871,1382),(117872,1383),(117873,1384),(117874,1385),(117875,1386),(117876,1387),(117877,1388),(117878,1389),(117879,1390),(117880,1391),(117881,1392),(117882,1393),(117883,1394),(117884,1395),(117885,1396),(117886,1397),(117887,1398),(117888,1399),(117889,1400),(117890,1401),(117891,1402),(117892,1403),(117893,1404),(117894,1405),(117895,1406),(117896,1407),(117897,1408),(117898,1409),(117899,1410),(117900,1411),(117901,1412),(117902,1413),(117903,1414),(117904,1415),(117905,1416),(117906,1417),(117907,1418),(117908,1419),(117909,1420),(117910,1421),(117911,1422),(117912,1423),(117913,1424),(117914,1425),(117915,1426),(117916,1427),(117917,1428),(117918,1429),(117919,1430),(117920,1431),(117921,1432),(117922,1433),(117923,1434),(117924,1435),(117925,1436),(117926,1437),(117927,1438),(117928,1439),(117929,1440),(117930,1441),(117931,1442),(117932,1443),(117933,1444),(117934,1445),(117935,1446),(117936,1447),(117937,1448),(117938,1449),(117939,1450),(117940,1451),(117941,1452),(117942,1453),(117943,1454),(117944,1455),(117945,1456),(117946,1457),(117947,1458),(117948,1459),(117949,1460),(117950,1461),(117951,1462),(117952,1463),(117953,1464),(117954,1465),(117955,1466),(117956,1467),(117957,1468),(117958,1469),(117959,1470),(117960,1471),(117961,1472),(117962,1488),(117963,1489),(117964,1490),(117965,1491),(117966,1492),(117967,1493),(117968,1494),(117969,1749),(117970,1992),(117971,1993),(117972,1994),(117973,1995),(117974,1996),(117975,1997),(117976,1998),(117977,1999),(117978,2000),(117979,2001),(117980,2002),(117981,4500),(117982,4501),(117983,4502),(117984,4503),(117985,4504),(117986,4505),(117987,4506),(117988,4507),(117989,4508),(117990,4509),(117991,4510),(117992,4511),(117993,4512),(117994,4513),(117995,4514),(117996,4515),(117997,4516),(117998,4517),(117999,4518),(118000,4519),(118001,4520),(118002,4521),(118003,4522),(118004,4523),(118005,4524),(118006,4525),(118007,4526),(118008,4527),(118009,4528),(118010,4529),(118011,4530),(118012,4531),(118013,4532),(118014,4533),(118015,4534),(118016,4535),(118017,4536),(118018,5271),(118019,5272),(118020,5273),(118021,5274),(118022,5282),(118023,5283),(118024,5284),(118025,5301),(118026,5468),(118027,5489),(118028,348),(118029,349),(118030,350),(118031,351),(118032,352),(118033,353),(118034,354),(118035,355),(118036,356),(118037,357),(118038,358),(118039,359),(118040,360),(118041,361),(118042,370),(118043,371),(118044,372),(118045,373),(118046,374),(118047,375),(118048,376),(118049,377),(118050,378),(118051,379),(118052,380),(118053,381),(118054,382),(118055,383),(118056,384),(118057,385),(118058,386),(118059,387),(118060,388),(118061,389),(118062,390),(118063,391),(118064,392),(118065,393),(118066,394),(118067,395),(118068,396),(118069,397),(118070,533),(118071,534),(118072,535),(118073,536),(118074,537),(118075,538),(118076,539),(118077,540),(118078,541),(118079,542),(118080,543),(118081,544),(118082,545),(118083,546),(118084,547),(118085,548),(118086,549),(118087,550),(118088,551),(118089,552),(118090,553),(118091,554),(118092,555),(118093,556),(118094,558),(118095,559),(118096,561),(118097,562),(118098,563),(118099,564),(118100,565),(118101,566),(118102,567),(118103,568),(118104,569),(118105,570),(118106,571),(118107,572),(118108,573),(118109,574),(118110,575),(118111,576),(118112,577),(118113,578),(118114,579),(118115,580),(118116,581),(118117,582),(118118,583),(118119,584),(118120,585),(118121,586),(118122,587),(118123,588),(118124,589),(118125,590),(118126,591),(118127,592),(118128,593),(118129,594),(118130,595),(118131,596),(118132,597),(118133,598),(118134,599),(118135,600),(118136,601),(118137,602),(118138,603),(118139,604),(118140,605),(118141,606),(118142,607),(118143,608),(118144,609),(118145,610),(118146,612),(118147,626),(118148,627),(118149,628),(118150,629),(118151,630),(118152,631),(118153,754),(118154,755),(118155,756),(118156,757),(118157,758),(118158,759),(118159,760),(118160,761),(118161,762),(118162,763),(118163,764),(118164,765),(118165,766),(118166,767),(118167,768),(118168,769),(118169,770),(118170,771),(118171,772),(118172,773),(118173,774),(118174,775),(118175,776),(118176,777),(118177,778),(118178,779),(118179,780),(118180,781),(118181,782),(118182,783),(118183,784),(118184,785),(118185,786),(118186,787),(118187,788),(118188,789),(118189,790),(118190,791),(118191,792),(118192,793),(118193,794),(118194,795),(118195,796),(118196,797),(118197,798),(118198,799),(118199,800),(118200,801),(118201,802),(118202,803),(118203,804),(118204,805),(118205,806),(118206,807),(118207,808),(118208,809),(118209,810),(118210,811),(118211,812),(118212,813),(118213,814),(118214,815),(118215,816),(118216,817),(118217,818),(118218,819),(118219,820),(118220,821),(118221,822),(118222,823),(118223,824),(118224,825),(118225,826),(118226,827),(118227,828),(118228,829),(118229,830),(118230,831),(118231,832),(118232,833),(118233,834),(118234,835),(118235,836),(118236,837),(118237,838),(118238,839),(118239,840),(118240,841),(118241,842),(118242,843),(118243,844),(118244,845),(118245,846),(118246,847),(118247,848),(118248,849),(118249,850),(118250,851),(118251,852),(118252,853),(118253,854),(118254,855),(118255,856),(118256,857),(118257,858),(118258,859),(118259,860),(118260,861),(118261,862),(118262,863),(118263,864),(118264,865),(118265,866),(118266,867),(118267,868),(118268,869),(118269,870),(118270,871),(118271,872),(118272,1020),(118273,1021),(118274,1022),(118275,1023),(118276,1106),(118277,1166),(118278,1167),(118279,1168),(118280,1169),(118281,1170),(118282,1171),(118283,1172),(118284,1173),(118285,1174),(118286,1175),(118287,1176),(118288,1177),(118289,1178),(118290,1179),(118291,1180),(118292,1181),(118293,1182),(118294,1183),(118295,1195),(118296,1196),(118297,1197),(118298,1198),(118299,1199),(118300,1200),(118301,1201),(118302,1202),(118303,1203),(118304,1204),(118305,1205),(118306,1206),(118307,1207),(118308,1210),(118309,1211),(118310,1212),(118311,1213),(118312,1214),(118313,1215),(118314,1216),(118315,1217),(118316,1218),(118317,1219),(118318,1220),(118319,1221),(118320,1222),(118321,1223),(118322,1224),(118323,1225),(118324,1226),(118325,1227),(118326,1228),(118327,1229),(118328,1230),(118329,1231),(118330,1232),(118331,1233),(118332,1234),(118333,1235),(118334,1236),(118335,1237),(118336,1238),(118337,1239),(118338,1240),(118339,1241),(118340,1242),(118341,1243),(118342,1244),(118343,1245),(118344,1246),(118345,1247),(118346,1248),(118347,1249),(118348,1250),(118349,1251),(118350,1252),(118351,1253),(118352,1254),(118353,1255),(118354,1256),(118355,1257),(118356,1258),(118357,1259),(118358,1260),(118359,1261),(118360,1262),(118361,1263),(118362,1264),(118363,1265),(118364,1266),(118365,1267),(118366,1268),(118367,1269),(118368,1270),(118369,1271),(118370,1272),(118371,1273),(118372,1274),(118373,1275),(118374,1276),(118375,1277),(118376,1278),(118377,1279),(118378,1280),(118379,1281),(118380,1282),(118381,1283),(118382,1284),(118383,1285),(118384,1286),(118385,1287),(118386,1288),(118387,1289),(118388,1290),(118389,1291),(118390,1292),(118391,1293),(118392,1294),(118393,1295),(118394,1296),(118395,1297),(118396,1298),(118397,1299),(118398,1300),(118399,1301),(118400,1302),(118401,1303),(118402,1304),(118403,1305),(118404,1306),(118405,1307),(118406,1308),(118407,1309),(118408,1310),(118409,1311),(118410,1312),(118411,1313),(118412,1314),(118413,1315),(118414,1316),(118415,1317),(118416,1318),(118417,1319),(118418,1320),(118419,1321),(118420,1322),(118421,1323),(118422,1332),(118423,1342),(118424,1346),(118425,1347),(118426,1349),(118427,1350),(118428,1351),(118429,1353),(118430,1354),(118431,1355),(118432,1356),(118433,1357),(118434,1358),(118435,1359),(118436,1360),(118437,1361),(118438,1362),(118439,1363),(118440,1364),(118441,1366),(118442,1367),(118443,1368),(118444,1371),(118445,1375),(118446,1376),(118447,1377),(118448,1379),(118449,1389),(118450,1390),(118451,1391),(118452,1392),(118453,1393),(118454,1394),(118455,1395),(118456,1397),(118457,1398),(118458,1400),(118459,1420),(118460,1421),(118461,1422),(118462,1423),(118463,1424),(118464,1425),(118465,1427),(118466,1428),(118467,1429),(118468,1430),(118469,1431),(118470,1432),(118471,1433),(118472,1434),(118473,1435),(118474,1442),(118475,1443),(118476,1444),(118477,1445),(118478,1446),(118479,1447),(118480,1448),(118481,1450),(118482,1451),(118483,1452),(118484,1454),(118485,1455),(118486,1456),(118487,1457),(118488,1462),(118489,1469),(118490,1749),(118491,4500),(118492,4501),(118493,4502),(118494,4503),(118495,4504),(118496,4505),(118497,4506),(118498,4507),(118499,4508),(118500,4509),(118501,4510),(118502,4511),(118503,4512),(118504,4513),(118505,4514),(118506,4515),(118507,4516),(118508,4517),(118509,4518),(118510,4519),(118511,4520),(118512,4522),(118513,4523),(118514,5301),(118515,5468),(118516,5489),(118517,283),(118518,285),(118519,288),(118520,290),(118521,293),(118522,295),(118523,315),(118524,321),(118525,672),(118526,681),(118527,709),(118528,710),(118529,726),(118530,727),(118531,729),(118532,908),(118533,1002),(118534,1119),(118535,636),(118536,281),(118537,282),(118538,284),(118539,286),(118540,287),(118541,289),(118542,291),(118543,292),(118544,296),(118545,297),(118546,298),(118547,299),(118548,300),(118549,302),(118550,303),(118551,304),(118552,305),(118553,306),(118554,307),(118555,309),(118556,310),(118557,313),(118558,316),(118559,317),(118560,318),(118561,341),(118562,342),(118563,343),(118564,374),(118565,375),(118566,376),(118567,527),(118568,529),(118569,530),(118570,531),(118571,532),(118572,557),(118573,560),(118574,587),(118575,588),(118576,589),(118577,590),(118578,591),(118579,592),(118580,611),(118581,613),(118582,617),(118583,619),(118584,624),(118585,625),(118586,637),(118587,639),(118588,648),(118589,652),(118590,660),(118591,670),(118592,682),(118593,683),(118594,684),(118595,685),(118596,686),(118597,688),(118598,689),(118599,690),(118600,691),(118601,693),(118602,694),(118603,695),(118604,696),(118605,697),(118606,698),(118607,700),(118608,701),(118609,705),(118610,708),(118611,712),(118612,715),(118613,716),(118614,717),(118615,728),(118616,730),(118617,731),(118618,735),(118619,736),(118620,778),(118621,779),(118622,834),(118623,835),(118624,836),(118625,837),(118626,838),(118627,839),(118628,840),(118629,906),(118630,996),(118631,997),(118632,998),(118633,999),(118634,1000),(118635,1034),(118636,1036),(118637,1038),(118638,1062),(118639,1063),(118640,1064),(118641,1066),(118642,1067),(118643,1068),(118644,1069),(118645,1070),(118646,1071),(118647,1072),(118648,1073),(118649,1074),(118650,1075),(118651,1133),(118652,2524),(118653,2526),(118654,281),(118655,284),(118656,286),(118657,287),(118658,289),(118659,291),(118660,292),(118661,294),(118662,296),(118663,297),(118664,298),(118665,299),(118666,300),(118667,301),(118668,302),(118669,303),(118670,304),(118671,305),(118672,306),(118673,307),(118674,316),(118675,332),(118676,333),(118677,337),(118678,341),(118679,342),(118680,343),(118681,374),(118682,375),(118683,376),(118684,527),(118685,528),(118686,529),(118687,530),(118688,531),(118689,532),(118690,557),(118691,560),(118692,587),(118693,588),(118694,589),(118695,590),(118696,591),(118697,592),(118698,611),(118699,613),(118700,617),(118701,618),(118702,619),(118703,624),(118704,625),(118705,632),(118706,636),(118707,637),(118708,639),(118709,646),(118710,648),(118711,652),(118712,659),(118713,660),(118714,670),(118715,682),(118716,683),(118717,684),(118718,685),(118719,686),(118720,687),(118721,688),(118722,689),(118723,690),(118724,691),(118725,693),(118726,694),(118727,695),(118728,696),(118729,697),(118730,698),(118731,700),(118732,702),(118733,705),(118734,706),(118735,711),(118736,712),(118737,715),(118738,716),(118739,717),(118740,728),(118741,735),(118742,736),(118743,742),(118744,778),(118745,779),(118746,834),(118747,835),(118748,836),(118749,837),(118750,838),(118751,839),(118752,840),(118753,906),(118754,997),(118755,998),(118756,999),(118757,1000),(118758,1001),(118759,1036),(118760,1037),(118761,1038),(118762,1064),(118763,1066),(118764,1067),(118765,1068),(118766,1069),(118767,1070),(118768,1071),(118769,1072),(118770,1073),(118771,1074),(118772,1075),(118773,1133),(118774,2524),(118775,2526),(118776,282),(118777,283),(118778,285),(118779,288),(118780,290),(118781,293),(118782,295),(118783,308),(118784,309),(118785,310),(118786,311),(118787,312),(118788,313),(118789,314),(118790,315),(118791,317),(118792,318),(118793,319),(118794,320),(118795,321),(118796,322),(118797,323),(118798,334),(118799,335),(118800,336),(118801,338),(118802,339),(118803,345),(118804,672),(118805,681),(118806,692),(118807,699),(118808,701),(118809,703),(118810,704),(118811,707),(118812,708),(118813,709),(118814,710),(118815,713),(118816,718),(118817,719),(118818,720),(118819,721),(118820,722),(118821,723),(118822,724),(118823,725),(118824,726),(118825,727),(118826,729),(118827,730),(118828,731),(118829,737),(118830,738),(118831,739),(118832,740),(118833,741),(118834,743),(118835,744),(118836,745),(118837,746),(118838,748),(118839,749),(118840,903),(118841,907),(118842,908),(118843,996),(118844,1002),(118845,1003),(118846,1004),(118847,1005),(118848,1012),(118849,1019),(118850,1034),(118851,1035),(118852,1062),(118853,1063),(118854,1092),(118855,1119),(118856,528),(118857,636),(118858,646),(118859,1001),(118860,340),(118861,344),(118862,346),(118863,347),(118864,714),(118865,732),(118866,733),(118867,734),(118868,747),(118869,904),(118870,905),(118871,281),(118872,282),(118873,284),(118874,286),(118875,287),(118876,289),(118877,291),(118878,292),(118879,294),(118880,296),(118881,297),(118882,298),(118883,299),(118884,300),(118885,301),(118886,302),(118887,303),(118888,304),(118889,305),(118890,306),(118891,307),(118892,308),(118893,309),(118894,310),(118895,311),(118896,312),(118897,313),(118898,316),(118899,317),(118900,318),(118901,332),(118902,333),(118903,334),(118904,335),(118905,336),(118906,337),(118907,338),(118908,339),(118909,341),(118910,342),(118911,343),(118912,374),(118913,375),(118914,376),(118915,527),(118916,529),(118917,530),(118918,531),(118919,532),(118920,557),(118921,560),(118922,587),(118923,588),(118924,589),(118925,590),(118926,591),(118927,592),(118928,611),(118929,613),(118930,617),(118931,619),(118932,624),(118933,625),(118934,637),(118935,639),(118936,648),(118937,652),(118938,659),(118939,660),(118940,670),(118941,682),(118942,683),(118943,684),(118944,685),(118945,686),(118946,687),(118947,688),(118948,689),(118949,690),(118950,691),(118951,693),(118952,694),(118953,695),(118954,696),(118955,697),(118956,698),(118957,700),(118958,701),(118959,702),(118960,703),(118961,705),(118962,706),(118963,707),(118964,708),(118965,711),(118966,712),(118967,713),(118968,715),(118969,716),(118970,717),(118971,728),(118972,730),(118973,731),(118974,735),(118975,736),(118976,742),(118977,778),(118978,779),(118979,834),(118980,835),(118981,836),(118982,837),(118983,838),(118984,839),(118985,840),(118986,903),(118987,996),(118988,997),(118989,998),(118990,999),(118991,1000),(118992,1001),(118993,1034),(118994,1035),(118995,1036),(118996,1038),(118997,1062),(118998,1063),(118999,1064),(119000,1066),(119001,1067),(119002,1068),(119003,1069),(119004,1070),(119005,1071),(119006,1072),(119007,1073),(119008,1074),(119009,1075),(119010,1133),(119011,659),(119012,683),(119013,684),(119014,685),(119015,686),(119016,689),(119017,709),(119018,710),(119019,712),(119020,715),(119021,716),(119022,717),(119023,726),(119024,727),(119025,728),(119026,729),(119027,730),(119028,731),(119029,735),(119030,736),(119031,659),(119032,683),(119033,684),(119034,685),(119035,686),(119036,689),(119037,709),(119038,710),(119039,712),(119040,715),(119041,716),(119042,717),(119043,726),(119044,727),(119045,728),(119046,729),(119047,730),(119048,731),(119049,735),(119050,736),(119051,659),(119052,683),(119053,684),(119054,685),(119055,686),(119056,689),(119057,712),(119058,715),(119059,716),(119060,717),(119061,728),(119062,730),(119063,731),(119064,735),(119065,736),(119066,292),(119067,293),(119068,302),(119069,303),(119070,314),(119071,315),(119072,320),(119073,321),(119074,326),(119075,327),(119076,335),(119077,338),(119078,346),(119079,347),(119080,699),(119081,722),(119082,729),(119083,730),(119084,903),(119085,1035),(119086,1073),(119087,1074),(119088,1075),(119089,297),(119090,438),(119091,476),(119092,477),(119093,478),(119094,479),(119095,484),(119096,493),(119097,494),(119098,515),(119099,523),(119100,524),(119101,528),(119102,620),(119103,640),(119104,641),(119105,642),(119106,646),(119107,649),(119108,654),(119109,657),(119110,658),(119111,659),(119112,660),(119113,1184),(119114,1238),(119115,1268),(119116,1294),(119117,1378),(119118,1389),(119119,1462),(119120,2154),(119121,2177),(119122,2221),(119123,2222),(119124,2299),(119125,5361),(119126,5362),(119127,5364),(119128,5622),(119129,5626),(119130,5639),(119131,5640),(119132,5641),(119133,5648),(119134,5665),(119135,5666),(119136,5667),(119137,2265),(119138,2269),(119139,281),(119140,282),(119141,283),(119142,284),(119143,285),(119144,286),(119145,287),(119146,288),(119147,289),(119148,290),(119149,291),(119150,292),(119151,293),(119152,294),(119153,295),(119154,296),(119155,297),(119156,298),(119157,299),(119158,300),(119159,301),(119160,302),(119161,303),(119162,304),(119163,305),(119164,306),(119165,307),(119166,308),(119167,309),(119168,310),(119169,311),(119170,312),(119171,313),(119172,314),(119173,315),(119174,316),(119175,317),(119176,318),(119177,319),(119178,320),(119179,321),(119180,322),(119181,323),(119182,324),(119183,325),(119184,326),(119185,327),(119186,328),(119187,329),(119188,330),(119189,331),(119190,332),(119191,333),(119192,334),(119193,335),(119194,336),(119195,337),(119196,338),(119197,339),(119198,340),(119199,341),(119200,342),(119201,343),(119202,344),(119203,345),(119204,346),(119205,347),(119206,903),(119207,904),(119208,905),(119209,907),(119210,1965),(119211,2439),(119212,2494),(119213,2495),(119214,2496),(119215,2497),(119216,2498),(119217,2499),(119218,2500),(119219,2513),(119220,2514),(119221,2529),(119222,2530),(119223,2539),(119224,2553),(119225,2554),(119226,2582),(119227,2583),(119228,2584),(119229,2585),(119230,2586),(119231,2587),(119232,4859),(119233,4860),(119234,4861),(119235,4862),(119236,4863),(119237,4864),(119238,4865),(119239,4866),(119240,4867),(119241,4868),(119242,4869),(119243,4870),(119244,4871),(119245,4874),(119246,4875),(119247,4876),(119248,4891),(119249,4892),(119250,4893),(119251,4894),(119252,281),(119253,282),(119254,283),(119255,284),(119256,285),(119257,286),(119258,287),(119259,288),(119260,289),(119261,290),(119262,291),(119263,292),(119264,293),(119265,294),(119266,295),(119267,296),(119268,297),(119269,298),(119270,299),(119271,300),(119272,301),(119273,302),(119274,303),(119275,304),(119276,305),(119277,306),(119278,307),(119279,308),(119280,309),(119281,310),(119282,311),(119283,312),(119284,313),(119285,314),(119286,315),(119287,316),(119288,317),(119289,318),(119290,319),(119291,320),(119292,321),(119293,322),(119294,323),(119295,324),(119296,325),(119297,326),(119298,327),(119299,328),(119300,329),(119301,330),(119302,331),(119303,332),(119304,333),(119305,334),(119306,335),(119307,336),(119308,337),(119309,338),(119310,339),(119311,340),(119312,341),(119313,342),(119314,343),(119315,344),(119316,345),(119317,346),(119318,347),(119319,903),(119320,904),(119321,905),(119322,907),(119323,1965),(119324,4613),(119325,4614),(119326,4857),(119327,4858),(119328,4872),(119329,4873),(119330,906),(119331,908),(119332,1004),(119333,1012),(119334,1019),(119335,1037),(119336,1092),(119337,1119),(119338,2524),(119339,2526),(119340,681),(119341,682),(119342,683),(119343,684),(119344,685),(119345,686),(119346,687),(119347,688),(119348,689),(119349,690),(119350,691),(119351,692),(119352,693),(119353,694),(119354,695),(119355,696),(119356,697),(119357,698),(119358,699),(119359,700),(119360,701),(119361,702),(119362,703),(119363,704),(119364,705),(119365,706),(119366,707),(119367,708),(119368,709),(119369,710),(119370,711),(119371,712),(119372,713),(119373,714),(119374,715),(119375,716),(119376,717),(119377,718),(119378,719),(119379,720),(119380,721),(119381,722),(119382,723),(119383,724),(119384,725),(119385,726),(119386,727),(119387,728),(119388,729),(119389,730),(119390,731),(119391,732),(119392,733),(119393,734),(119394,735),(119395,736),(119396,737),(119397,738),(119398,739),(119399,740),(119400,741),(119401,742),(119402,743),(119403,744),(119404,745),(119405,746),(119406,747),(119407,748),(119408,749),(119409,996),(119410,997),(119411,998),(119412,999),(119413,1000),(119414,1001),(119415,1002),(119416,1003),(119417,1005),(119418,1034),(119419,1035),(119420,1036),(119421,1038),(119422,1133),(119423,2221),(119424,2222),(119425,362),(119426,363),(119427,364),(119428,365),(119429,366),(119430,367),(119431,368),(119432,369),(119433,398),(119434,399),(119435,400),(119436,401),(119437,402),(119438,403),(119439,404),(119440,405),(119441,406),(119442,407),(119443,408),(119444,409),(119445,410),(119446,411),(119447,412),(119448,413),(119449,414),(119450,415),(119451,416),(119452,417),(119453,418),(119454,419),(119455,420),(119456,421),(119457,422),(119458,423),(119459,424),(119460,425),(119461,426),(119462,427),(119463,428),(119464,429),(119465,430),(119466,431),(119467,432),(119468,433),(119469,434),(119470,435),(119471,436),(119472,437),(119473,438),(119474,439),(119475,440),(119476,441),(119477,442),(119478,443),(119479,444),(119480,445),(119481,446),(119482,447),(119483,448),(119484,449),(119485,450),(119486,451),(119487,452),(119488,453),(119489,454),(119490,455),(119491,456),(119492,457),(119493,458),(119494,459),(119495,460),(119496,461),(119497,462),(119498,463),(119499,464),(119500,465),(119501,466),(119502,467),(119503,468),(119504,469),(119505,470),(119506,471),(119507,472),(119508,473),(119509,474),(119510,475),(119511,476),(119512,477),(119513,478),(119514,479),(119515,480),(119516,481),(119517,482),(119518,483),(119519,484),(119520,485),(119521,486),(119522,487),(119523,488),(119524,489),(119525,490),(119526,491),(119527,492),(119528,493),(119529,494),(119530,495),(119531,496),(119532,497),(119533,498),(119534,499),(119535,500),(119536,501),(119537,502),(119538,503),(119539,504),(119540,505),(119541,506),(119542,507),(119543,508),(119544,509),(119545,510),(119546,511),(119547,512),(119548,513),(119549,514),(119550,515),(119551,516),(119552,517),(119553,518),(119554,519),(119555,520),(119556,521),(119557,522),(119558,523),(119559,524),(119560,525),(119561,526),(119562,527),(119563,528),(119564,529),(119565,530),(119566,531),(119567,532),(119568,557),(119569,560),(119570,611),(119571,613),(119572,614),(119573,615),(119574,616),(119575,617),(119576,619),(119577,620),(119578,621),(119579,622),(119580,623),(119581,624),(119582,625),(119583,633),(119584,634),(119585,635),(119586,636),(119587,637),(119588,638),(119589,639),(119590,640),(119591,641),(119592,642),(119593,643),(119594,644),(119595,645),(119596,646),(119597,647),(119598,648),(119599,649),(119600,650),(119601,651),(119602,652),(119603,653),(119604,654),(119605,655),(119606,656),(119607,657),(119608,658),(119609,659),(119610,660),(119611,661),(119612,662),(119613,663),(119614,664),(119615,665),(119616,666),(119617,667),(119618,668),(119619,669),(119620,670),(119621,671),(119622,672),(119623,673),(119624,674),(119625,675),(119626,676),(119627,677),(119628,678),(119629,679),(119630,680),(119631,1184),(119632,1185),(119633,1186),(119634,1187),(119635,1188),(119636,1189),(119637,1190),(119638,1191),(119639,1192),(119640,1193),(119641,1194),(119642,1208),(119643,1209),(119644,1324),(119645,1325),(119646,1326),(119647,1327),(119648,1328),(119649,1329),(119650,1330),(119651,1331),(119652,1333),(119653,1334),(119654,1335),(119655,1336),(119656,1337),(119657,1338),(119658,1339),(119659,1340),(119660,1341),(119661,1343),(119662,1344),(119663,1345),(119664,1348),(119665,1352),(119666,1365),(119667,1369),(119668,1370),(119669,1372),(119670,1373),(119671,1374),(119672,1378),(119673,1380),(119674,1381),(119675,1382),(119676,1383),(119677,1384),(119678,1385),(119679,1386),(119680,1387),(119681,1388),(119682,1396),(119683,1399),(119684,1401),(119685,1402),(119686,1403),(119687,1404),(119688,1405),(119689,1406),(119690,1407),(119691,1408),(119692,1409),(119693,1410),(119694,1411),(119695,1412),(119696,1413),(119697,1414),(119698,1415),(119699,1416),(119700,1417),(119701,1418),(119702,1419),(119703,1426),(119704,1436),(119705,1437),(119706,1438),(119707,1439),(119708,1440),(119709,1441),(119710,1449),(119711,1453),(119712,1458),(119713,1459),(119714,1460),(119715,1461),(119716,1463),(119717,1464),(119718,1465),(119719,1466),(119720,1467),(119721,1468),(119722,1470),(119723,1471),(119724,1472),(119725,1488),(119726,1489),(119727,1490),(119728,1491),(119729,1492),(119730,1493),(119731,1494),(119732,1992),(119733,1993),(119734,1994),(119735,1995),(119736,1996),(119737,1997),(119738,1998),(119739,1999),(119740,2000),(119741,2001),(119742,2002),(119743,4521),(119744,4524),(119745,4525),(119746,4526),(119747,4527),(119748,4528),(119749,4529),(119750,4530),(119751,4531),(119752,4532),(119753,4533),(119754,4534),(119755,4535),(119756,4536),(119757,5271),(119758,5272),(119759,5273),(119760,5274),(119761,5282),(119762,5283),(119763,5284),(119764,348),(119765,349),(119766,350),(119767,351),(119768,352),(119769,353),(119770,354),(119771,355),(119772,356),(119773,357),(119774,358),(119775,359),(119776,360),(119777,361),(119778,370),(119779,371),(119780,372),(119781,373),(119782,374),(119783,375),(119784,376),(119785,377),(119786,378),(119787,379),(119788,380),(119789,381),(119790,382),(119791,383),(119792,384),(119793,385),(119794,386),(119795,387),(119796,388),(119797,389),(119798,390),(119799,391),(119800,392),(119801,393),(119802,394),(119803,395),(119804,396),(119805,397),(119806,533),(119807,534),(119808,535),(119809,536),(119810,537),(119811,538),(119812,539),(119813,540),(119814,541),(119815,542),(119816,543),(119817,544),(119818,545),(119819,546),(119820,547),(119821,548),(119822,549),(119823,550),(119824,551),(119825,552),(119826,553),(119827,554),(119828,555),(119829,556),(119830,558),(119831,559),(119832,561),(119833,562),(119834,563),(119835,564),(119836,565),(119837,566),(119838,567),(119839,568),(119840,569),(119841,570),(119842,571),(119843,572),(119844,573),(119845,574),(119846,575),(119847,576),(119848,577),(119849,578),(119850,579),(119851,580),(119852,581),(119853,582),(119854,583),(119855,584),(119856,585),(119857,586),(119858,587),(119859,588),(119860,589),(119861,590),(119862,591),(119863,592),(119864,593),(119865,594),(119866,595),(119867,596),(119868,597),(119869,598),(119870,599),(119871,600),(119872,601),(119873,602),(119874,603),(119875,604),(119876,605),(119877,606),(119878,607),(119879,608),(119880,609),(119881,610),(119882,612),(119883,626),(119884,627),(119885,628),(119886,629),(119887,630),(119888,631),(119889,754),(119890,755),(119891,756),(119892,757),(119893,758),(119894,759),(119895,760),(119896,761),(119897,762),(119898,763),(119899,764),(119900,765),(119901,766),(119902,767),(119903,768),(119904,769),(119905,770),(119906,771),(119907,772),(119908,773),(119909,774),(119910,775),(119911,776),(119912,777),(119913,778),(119914,779),(119915,780),(119916,781),(119917,782),(119918,783),(119919,784),(119920,785),(119921,786),(119922,787),(119923,788),(119924,789),(119925,790),(119926,791),(119927,792),(119928,793),(119929,794),(119930,795),(119931,796),(119932,797),(119933,798),(119934,799),(119935,800),(119936,801),(119937,802),(119938,803),(119939,804),(119940,805),(119941,806),(119942,807),(119943,808),(119944,809),(119945,810),(119946,811),(119947,812),(119948,813),(119949,814),(119950,815),(119951,816),(119952,817),(119953,818),(119954,819),(119955,820),(119956,821),(119957,822),(119958,823),(119959,824),(119960,825),(119961,826),(119962,827),(119963,828),(119964,829),(119965,830),(119966,831),(119967,832),(119968,833),(119969,834),(119970,835),(119971,836),(119972,837),(119973,838),(119974,839),(119975,840),(119976,841),(119977,842),(119978,843),(119979,844),(119980,845),(119981,846),(119982,847),(119983,848),(119984,849),(119985,850),(119986,851),(119987,852),(119988,853),(119989,854),(119990,855),(119991,856),(119992,857),(119993,858),(119994,859),(119995,860),(119996,861),(119997,862),(119998,863),(119999,864),(120000,865),(120001,866),(120002,867),(120003,868),(120004,869),(120005,870),(120006,871),(120007,872),(120008,1020),(120009,1021),(120010,1022),(120011,1023),(120012,1106),(120013,1166),(120014,1167),(120015,1168),(120016,1169),(120017,1170),(120018,1171),(120019,1172),(120020,1173),(120021,1174),(120022,1175),(120023,1176),(120024,1177),(120025,1178),(120026,1179),(120027,1180),(120028,1181),(120029,1182),(120030,1183),(120031,1195),(120032,1196),(120033,1197),(120034,1198),(120035,1199),(120036,1200),(120037,1201),(120038,1202),(120039,1203),(120040,1204),(120041,1205),(120042,1206),(120043,1207),(120044,1210),(120045,1211),(120046,1212),(120047,1213),(120048,1214),(120049,1215),(120050,1216),(120051,1217),(120052,1218),(120053,1219),(120054,1220),(120055,1221),(120056,1222),(120057,1223),(120058,1224),(120059,1225),(120060,1226),(120061,1227),(120062,1228),(120063,1229),(120064,1230),(120065,1231),(120066,1232),(120067,1233),(120068,1234),(120069,1235),(120070,1236),(120071,1237),(120072,1238),(120073,1239),(120074,1240),(120075,1241),(120076,1242),(120077,1243),(120078,1244),(120079,1245),(120080,1246),(120081,1247),(120082,1248),(120083,1249),(120084,1250),(120085,1251),(120086,1252),(120087,1253),(120088,1254),(120089,1255),(120090,1256),(120091,1257),(120092,1258),(120093,1259),(120094,1260),(120095,1261),(120096,1262),(120097,1263),(120098,1264),(120099,1265),(120100,1266),(120101,1267),(120102,1268),(120103,1269),(120104,1270),(120105,1271),(120106,1272),(120107,1273),(120108,1274),(120109,1275),(120110,1276),(120111,1277),(120112,1278),(120113,1279),(120114,1280),(120115,1281),(120116,1282),(120117,1283),(120118,1284),(120119,1285),(120120,1286),(120121,1287),(120122,1288),(120123,1289),(120124,1290),(120125,1291),(120126,1292),(120127,1293),(120128,1294),(120129,1295),(120130,1296),(120131,1297),(120132,1298),(120133,1299),(120134,1300),(120135,1301),(120136,1302),(120137,1303),(120138,1304),(120139,1305),(120140,1306),(120141,1307),(120142,1308),(120143,1309),(120144,1310),(120145,1311),(120146,1312),(120147,1313),(120148,1314),(120149,1315),(120150,1316),(120151,1317),(120152,1318),(120153,1319),(120154,1320),(120155,1321),(120156,1322),(120157,1323),(120158,1332),(120159,1342),(120160,1346),(120161,1347),(120162,1349),(120163,1350),(120164,1351),(120165,1353),(120166,1354),(120167,1355),(120168,1356),(120169,1357),(120170,1358),(120171,1359),(120172,1360),(120173,1361),(120174,1362),(120175,1363),(120176,1364),(120177,1366),(120178,1367),(120179,1368),(120180,1371),(120181,1375),(120182,1376),(120183,1377),(120184,1379),(120185,1389),(120186,1390),(120187,1391),(120188,1392),(120189,1393),(120190,1394),(120191,1395),(120192,1397),(120193,1398),(120194,1400),(120195,1420),(120196,1421),(120197,1422),(120198,1423),(120199,1424),(120200,1425),(120201,1427),(120202,1428),(120203,1429),(120204,1430),(120205,1431),(120206,1432),(120207,1433),(120208,1434),(120209,1435),(120210,1442),(120211,1443),(120212,1444),(120213,1445),(120214,1446),(120215,1447),(120216,1448),(120217,1450),(120218,1451),(120219,1452),(120220,1454),(120221,1455),(120222,1456),(120223,1457),(120224,1462),(120225,1469),(120226,1749),(120227,4500),(120228,4501),(120229,4502),(120230,4503),(120231,4504),(120232,4505),(120233,4506),(120234,4507),(120235,4508),(120236,4509),(120237,4510),(120238,4511),(120239,4512),(120240,4513),(120241,4514),(120242,4515),(120243,4516),(120244,4517),(120245,4518),(120246,4519),(120247,4520),(120248,4522),(120249,4523),(120250,5301),(120251,5468),(120252,5489),(120253,2154),(120254,2177),(120255,681),(120256,682),(120257,683),(120258,684),(120259,685),(120260,686),(120261,687),(120262,688),(120263,689),(120264,690),(120265,691),(120266,692),(120267,693),(120268,694),(120269,695),(120270,696),(120271,697),(120272,698),(120273,699),(120274,700),(120275,701),(120276,702),(120277,703),(120278,704),(120279,705),(120280,706),(120281,707),(120282,708),(120283,709),(120284,710),(120285,711),(120286,712),(120287,713),(120288,714),(120289,715),(120290,716),(120291,717),(120292,718),(120293,719),(120294,720),(120295,721),(120296,722),(120297,723),(120298,724),(120299,725),(120300,726),(120301,727),(120302,728),(120303,729),(120304,730),(120305,731),(120306,732),(120307,733),(120308,734),(120309,735),(120310,736),(120311,737),(120312,738),(120313,739),(120314,740),(120315,741),(120316,742),(120317,743),(120318,744),(120319,745),(120320,746),(120321,747),(120322,748),(120323,749),(120324,996),(120325,997),(120326,998),(120327,999),(120328,1000),(120329,1001),(120330,1002),(120331,1003),(120332,1005),(120333,1034),(120334,1035),(120335,1036),(120336,1038),(120337,1133),(120338,683),(120339,684),(120340,685),(120341,686),(120342,689),(120343,709),(120344,710),(120345,712),(120346,715),(120347,716),(120348,717),(120349,726),(120350,727),(120351,728),(120352,729),(120353,730),(120354,731),(120355,735),(120356,736),(120357,2221),(120358,2222),(120359,2221),(120360,2222),(120361,2221),(120362,2222),(120363,906),(120364,908),(120365,1004),(120366,1012),(120367,1019),(120368,1037),(120369,1092),(120370,1119),(120371,2524),(120372,2526),(120373,2299),(120374,2299),(120375,5757),(120376,5758),(120377,5759),(120378,362),(120379,363),(120380,364),(120381,365),(120382,366),(120383,367),(120384,368),(120385,369),(120386,398),(120387,399),(120388,400),(120389,401),(120390,402),(120391,403),(120392,404),(120393,405),(120394,406),(120395,407),(120396,408),(120397,409),(120398,410),(120399,411),(120400,412),(120401,413),(120402,414),(120403,415),(120404,416),(120405,417),(120406,418),(120407,419),(120408,420),(120409,421),(120410,422),(120411,423),(120412,424),(120413,425),(120414,426),(120415,427),(120416,428),(120417,429),(120418,430),(120419,431),(120420,432),(120421,433),(120422,434),(120423,435),(120424,436),(120425,437),(120426,438),(120427,439),(120428,440),(120429,441),(120430,442),(120431,443),(120432,444),(120433,445),(120434,446),(120435,447),(120436,448),(120437,449),(120438,450),(120439,451),(120440,452),(120441,453),(120442,454),(120443,455),(120444,456),(120445,457),(120446,458),(120447,459),(120448,460),(120449,461),(120450,462),(120451,463),(120452,464),(120453,465),(120454,466),(120455,467),(120456,468),(120457,469),(120458,470),(120459,471),(120460,472),(120461,473),(120462,474),(120463,475),(120464,476),(120465,477),(120466,478),(120467,479),(120468,480),(120469,481),(120470,482),(120471,483),(120472,484),(120473,485),(120474,486),(120475,487),(120476,488),(120477,489),(120478,490),(120479,491),(120480,492),(120481,493),(120482,494),(120483,495),(120484,496),(120485,497),(120486,498),(120487,499),(120488,500),(120489,501),(120490,502),(120491,503),(120492,504),(120493,505),(120494,506),(120495,507),(120496,508),(120497,509),(120498,510),(120499,511),(120500,512),(120501,513),(120502,514),(120503,515),(120504,516),(120505,517),(120506,518),(120507,519),(120508,520),(120509,521),(120510,522),(120511,523),(120512,524),(120513,525),(120514,526),(120515,527),(120516,528),(120517,529),(120518,530),(120519,531),(120520,532),(120521,560),(120522,611),(120523,613),(120524,614),(120525,615),(120526,616),(120527,617),(120528,618),(120529,619),(120530,620),(120531,621),(120532,622),(120533,623),(120534,624),(120535,625),(120536,632),(120537,633),(120538,634),(120539,635),(120540,636),(120541,637),(120542,638),(120543,639),(120544,640),(120545,641),(120546,642),(120547,643),(120548,644),(120549,645),(120550,646),(120551,647),(120552,648),(120553,649),(120554,650),(120555,651),(120556,652),(120557,653),(120558,655),(120559,656),(120560,657),(120561,658),(120562,659),(120563,660),(120564,661),(120565,662),(120566,663),(120567,664),(120568,665),(120569,666),(120570,667),(120571,669),(120572,670),(120573,671),(120574,672),(120575,673),(120576,674),(120577,675),(120578,676),(120579,677),(120580,678),(120581,679),(120582,680),(120583,1184),(120584,1185),(120585,1186),(120586,1187),(120587,1188),(120588,1189),(120589,1190),(120590,1191),(120591,1192),(120592,1193),(120593,1194),(120594,1208),(120595,1209),(120596,1324),(120597,1325),(120598,1326),(120599,1327),(120600,1328),(120601,1329),(120602,1330),(120603,1331),(120604,1333),(120605,1334),(120606,1335),(120607,1336),(120608,1337),(120609,1338),(120610,1339),(120611,1340),(120612,1341),(120613,1343),(120614,1344),(120615,1345),(120616,1348),(120617,1352),(120618,1365),(120619,1369),(120620,1370),(120621,1372),(120622,1373),(120623,1374),(120624,1378),(120625,1379),(120626,1380),(120627,1381),(120628,1382),(120629,1383),(120630,1384),(120631,1385),(120632,1386),(120633,1387),(120634,1388),(120635,1396),(120636,1399),(120637,1401),(120638,1402),(120639,1403),(120640,1404),(120641,1405),(120642,1406),(120643,1407),(120644,1408),(120645,1409),(120646,1410),(120647,1411),(120648,1412),(120649,1413),(120650,1414),(120651,1415),(120652,1416),(120653,1417),(120654,1418),(120655,1419),(120656,1426),(120657,1436),(120658,1437),(120659,1438),(120660,1439),(120661,1440),(120662,1441),(120663,1449),(120664,1453),(120665,1458),(120666,1459),(120667,1460),(120668,1461),(120669,1463),(120670,1464),(120671,1465),(120672,1466),(120673,1467),(120674,1468),(120675,1470),(120676,1471),(120677,1472),(120678,1488),(120679,1489),(120680,1490),(120681,1491),(120682,1492),(120683,1493),(120684,1494),(120685,1992),(120686,1993),(120687,1994),(120688,1995),(120689,1996),(120690,1997),(120691,1998),(120692,1999),(120693,2000),(120694,2001),(120695,2002),(120696,4521),(120697,4524),(120698,4525),(120699,4526),(120700,4527),(120701,4528),(120702,4529),(120703,4530),(120704,4531),(120705,4532),(120706,4533),(120707,4534),(120708,4535),(120709,4536),(120710,5271),(120711,5272),(120712,5273),(120713,5274),(120714,5282),(120715,5283),(120716,5284),(120717,527),(120718,528),(120719,529),(120720,530),(120721,531),(120722,532),(120723,560),(120724,611),(120725,613),(120726,617),(120727,618),(120728,619),(120729,624),(120730,625),(120731,632),(120732,636),(120733,637),(120734,639),(120735,646),(120736,648),(120737,652),(120738,659),(120739,660),(120740,670),(120741,362),(120742,363),(120743,364),(120744,365),(120745,366),(120746,367),(120747,368),(120748,369),(120749,398),(120750,399),(120751,403),(120752,404),(120753,405),(120754,406),(120755,407),(120756,411),(120757,412),(120758,413),(120759,414),(120760,420),(120761,421),(120762,424),(120763,425),(120764,431),(120765,458),(120766,462),(120767,469),(120768,470),(120769,471),(120770,475),(120771,481),(120772,500),(120773,517),(120774,519),(120775,520),(120776,614),(120777,616),(120778,635),(120779,643),(120780,644),(120781,645),(120782,650),(120783,656),(120784,661),(120785,663),(120786,665),(120787,666),(120788,669),(120789,671),(120790,673),(120791,675),(120792,676),(120793,677),(120794,678),(120795,679),(120796,680),(120797,1184),(120798,1185),(120799,1186),(120800,1187),(120801,1188),(120802,1189),(120803,1190),(120804,1191),(120805,1192),(120806,1193),(120807,1194),(120808,1208),(120809,1209),(120810,1324),(120811,1325),(120812,1326),(120813,1327),(120814,1328),(120815,1329),(120816,1330),(120817,1331),(120818,1333),(120819,1334),(120820,1335),(120821,1336),(120822,1337),(120823,1338),(120824,1339),(120825,1340),(120826,1341),(120827,1343),(120828,1344),(120829,1345),(120830,1348),(120831,1352),(120832,1365),(120833,1369),(120834,1370),(120835,1372),(120836,1373),(120837,1374),(120838,1378),(120839,1379),(120840,1380),(120841,1381),(120842,1382),(120843,1383),(120844,1384),(120845,1385),(120846,1386),(120847,1387),(120848,1388),(120849,1396),(120850,1399),(120851,1401),(120852,1402),(120853,1403),(120854,1404),(120855,1405),(120856,1406),(120857,1407),(120858,1408),(120859,1409),(120860,1410),(120861,1411),(120862,1412),(120863,1413),(120864,1414),(120865,1415),(120866,1416),(120867,1417),(120868,1418),(120869,1419),(120870,1426),(120871,1436),(120872,1437),(120873,1438),(120874,1439),(120875,1440),(120876,1441),(120877,1449),(120878,1453),(120879,1458),(120880,1459),(120881,1460),(120882,1461),(120883,1463),(120884,1464),(120885,1465),(120886,1466),(120887,1467),(120888,1468),(120889,1470),(120890,1471),(120891,1472),(120892,1488),(120893,1489),(120894,1490),(120895,1491),(120896,1492),(120897,1493),(120898,1494),(120899,1992),(120900,1993),(120901,1994),(120902,1995),(120903,1996),(120904,1997),(120905,1998),(120906,1999),(120907,2000),(120908,2001),(120909,2002),(120910,4521),(120911,4524),(120912,4525),(120913,4526),(120914,4527),(120915,4528),(120916,4529),(120917,4530),(120918,4531),(120919,4532),(120920,4533),(120921,4534),(120922,4535),(120923,4536),(120924,5271),(120925,5272),(120926,5273),(120927,5274),(120928,5282),(120929,5283),(120930,5284),(120931,374),(120932,375),(120933,376),(120934,533),(120935,534),(120936,535),(120937,536),(120938,537),(120939,538),(120940,539),(120941,540),(120942,541),(120943,542),(120944,543),(120945,544),(120946,545),(120947,546),(120948,547),(120949,548),(120950,549),(120951,550),(120952,551),(120953,552),(120954,553),(120955,554),(120956,555),(120957,558),(120958,559),(120959,561),(120960,562),(120961,564),(120962,566),(120963,571),(120964,572),(120965,573),(120966,574),(120967,575),(120968,576),(120969,577),(120970,578),(120971,579),(120972,580),(120973,581),(120974,582),(120975,585),(120976,586),(120977,587),(120978,588),(120979,589),(120980,590),(120981,591),(120982,592),(120983,593),(120984,594),(120985,595),(120986,596),(120987,598),(120988,600),(120989,601),(120990,602),(120991,603),(120992,604),(120993,605),(120994,609),(120995,610),(120996,612),(120997,754),(120998,755),(120999,756),(121000,757),(121001,758),(121002,759),(121003,760),(121004,761),(121005,762),(121006,763),(121007,764),(121008,765),(121009,766),(121010,767),(121011,768),(121012,769),(121013,770),(121014,771),(121015,772),(121016,773),(121017,774),(121018,775),(121019,776),(121020,778),(121021,779),(121022,780),(121023,781),(121024,782),(121025,783),(121026,784),(121027,785),(121028,786),(121029,787),(121030,788),(121031,790),(121032,791),(121033,794),(121034,796),(121035,797),(121036,805),(121037,806),(121038,807),(121039,808),(121040,809),(121041,810),(121042,811),(121043,812),(121044,813),(121045,814),(121046,816),(121047,817),(121048,818),(121049,819),(121050,820),(121051,821),(121052,822),(121053,824),(121054,826),(121055,827),(121056,828),(121057,829),(121058,834),(121059,835),(121060,836),(121061,837),(121062,838),(121063,839),(121064,840),(121065,841),(121066,842),(121067,843),(121068,844),(121069,845),(121070,846),(121071,847),(121072,848),(121073,849),(121074,850),(121075,851),(121076,852),(121077,853),(121078,854),(121079,855),(121080,856),(121081,857),(121082,858),(121083,862),(121084,864),(121085,865),(121086,1020),(121087,1021),(121088,1022),(121089,1023),(121090,1106),(121091,1166),(121092,1167),(121093,1169),(121094,1184),(121095,1238),(121096,1268),(121097,1294),(121098,1378),(121099,1389),(121100,1462),(121101,2154),(121102,2177),(121103,2221),(121104,2222),(121105,2299),(121106,5361),(121107,5362),(121108,5364),(121109,5622),(121110,5626),(121111,5639),(121112,5640),(121113,5641),(121114,5648),(121115,5665),(121116,5666),(121117,5667),(121118,1972),(121119,1973),(121120,1978),(121121,1981),(121122,1982),(121123,1983),(121124,1988),(121125,2037),(121126,1814),(121127,1817),(121128,1819),(121129,1823),(121130,1826),(121131,1830),(121132,1832),(121133,1835),(121134,1975),(121135,1977),(121136,1979),(121137,1980),(121138,1985),(121139,1987),(121140,1991),(121141,2189),(121142,2196),(121143,2201),(121144,2202),(121145,2208),(121146,2209),(121147,2214),(121148,2215),(121149,2216),(121150,2217),(121151,2218),(121152,2219),(121153,2220),(121154,2232),(121155,2233),(121156,2234),(121157,2236),(121158,2237),(121159,2238),(121160,2239),(121161,2258),(121162,2259),(121163,2261),(121164,2262),(121165,2321),(121166,2322),(121167,2392),(121168,2393),(121169,2394),(121170,2395),(121171,2464),(121172,2589),(121173,2591),(121174,2592),(121175,2318),(121176,2399),(121177,2400),(121178,2401),(121179,2614),(121180,2060),(121181,2139),(121182,2140),(121183,2141),(121184,2142),(121185,2143),(121186,2317),(121187,2398),(121188,2409),(121189,2611),(121190,4613),(121191,4614),(121192,2460),(121193,2461),(121194,2462),(121195,2463),(121196,2464),(121197,2504),(121198,2505),(121199,4573),(121200,4574),(121201,4575),(121202,4576),(121203,4605),(121204,4606),(121205,4607),(121206,4609),(121207,4610),(121208,4611),(121209,4625),(121210,4626),(121211,4805),(121212,4806),(121213,4807),(121214,4808),(121215,4824),(121216,4825),(121217,4826),(121218,4827),(121219,4828),(121220,4829),(121221,4830),(121222,4831),(121223,4832),(121224,4833),(121225,4912),(121226,4913),(121227,4914),(121228,4915),(121229,4916),(121230,4917),(121231,4918),(121232,4919),(121233,4920),(121234,4921),(121235,4922),(121236,4923),(121237,4924),(121238,4925),(121239,4926),(121240,4927),(121241,4928),(121242,4929),(121243,4930),(121244,4931),(121245,4932),(121246,4963),(121247,4964),(121248,4965),(121249,4966),(121250,5017),(121251,5018),(121252,5073),(121253,5074),(121254,5075),(121255,5076),(121256,5091),(121257,5092),(121258,5132),(121259,5133),(121260,5134),(121261,5135),(121262,5143),(121263,5144),(121264,5145),(121265,5146),(121266,5169),(121267,5170),(121268,5172),(121269,5173),(121270,5174),(121271,5175),(121272,5176),(121273,5177),(121274,5184),(121275,5185),(121276,5200),(121277,5201),(121278,5238),(121279,5239),(121280,5240),(121281,5241),(121282,5242),(121283,5243),(121284,5244),(121285,5245),(121286,5246),(121287,5247),(121288,4573),(121289,4574),(121290,4575),(121291,4576),(121292,4605),(121293,4606),(121294,4607),(121295,4609),(121296,4610),(121297,4611),(121298,4625),(121299,4626),(121300,4805),(121301,4806),(121302,4807),(121303,4808),(121304,4824),(121305,4825),(121306,4826),(121307,4827),(121308,4828),(121309,4829),(121310,4830),(121311,4831),(121312,4832),(121313,4833),(121314,4912),(121315,4913),(121316,4914),(121317,4915),(121318,4916),(121319,4917),(121320,4918),(121321,4919),(121322,4920),(121323,4921),(121324,4922),(121325,4923),(121326,4924),(121327,4925),(121328,4926),(121329,4927),(121330,4928),(121331,4929),(121332,4930),(121333,4931),(121334,4932),(121335,4959),(121336,4963),(121337,4964),(121338,4965),(121339,4966),(121340,5017),(121341,5018),(121342,5073),(121343,5074),(121344,5075),(121345,5076),(121346,5091),(121347,5092),(121348,5132),(121349,5133),(121350,5134),(121351,5135),(121352,5143),(121353,5144),(121354,5145),(121355,5146),(121356,5169),(121357,5170),(121358,5172),(121359,5173),(121360,5174),(121361,5175),(121362,5176),(121363,5177),(121364,5184),(121365,5185),(121366,5200),(121367,5201),(121368,5238),(121369,5239),(121370,5240),(121371,5241),(121372,5242),(121373,5243),(121374,5244),(121375,5245),(121376,5246),(121377,5247),(121378,4721),(121379,4725),(121380,4728),(121381,5140),(121382,5141),(121383,2591),(121384,2592),(121385,1828),(121386,1829),(121387,1831),(121388,1950),(121389,1951),(121390,1952),(121391,4896),(121392,4898),(121393,4899),(121394,4900),(121395,4901),(121396,4902),(121397,4903),(121398,4904),(121399,4905),(121400,4906),(121401,4907),(121402,4908),(121403,4909),(121404,4910),(121405,4911),(121406,5020),(121407,1679),(121408,1680),(121409,5021),(121410,5023),(121411,5026),(121412,5027),(121413,4972),(121414,4973),(121415,4974),(121416,4975),(121417,4976),(121418,4977),(121419,4978),(121420,4983),(121421,4984),(121422,4985),(121423,4986),(121424,4987),(121425,4988),(121426,4989),(121427,4990),(121428,4991),(121429,4996),(121430,4997),(121431,4998),(121432,4999),(121433,5000),(121434,5002),(121435,5005),(121436,5008),(121437,5011),(121438,5012),(121439,5013),(121440,5014),(121441,5015),(121442,5016),(121443,5020),(121444,4972),(121445,4973),(121446,4974),(121447,4975),(121448,4976),(121449,4977),(121450,4978),(121451,4983),(121452,4984),(121453,4985),(121454,4986),(121455,4987),(121456,4988),(121457,4989),(121458,4990),(121459,4991),(121460,4996),(121461,4997),(121462,4998),(121463,5000),(121464,5002),(121465,5004),(121466,5005),(121467,5008),(121468,5011),(121469,5012),(121470,5013),(121471,5014),(121472,5015),(121473,5016),(121474,4973),(121475,4974),(121476,4975),(121477,4976),(121478,4977),(121479,4978),(121480,4983),(121481,4984),(121482,4985),(121483,4986),(121484,4987),(121485,4988),(121486,4989),(121487,4990),(121488,4991),(121489,4996),(121490,4997),(121491,4998),(121492,4999),(121493,5000),(121494,5002),(121495,5004),(121496,5005),(121497,5008),(121498,5011),(121499,5012),(121500,5013),(121501,5014),(121502,5015),(121503,5016),(121504,4972),(121505,4973),(121506,4974),(121507,4975),(121508,4976),(121509,4977),(121510,4978),(121511,4983),(121512,4984),(121513,4985),(121514,4986),(121515,4987),(121516,4988),(121517,4989),(121518,4990),(121519,4991),(121520,4996),(121521,4997),(121522,4998),(121523,4999),(121524,5000),(121525,5002),(121526,5004),(121527,5005),(121528,5008),(121529,5011),(121530,5012),(121531,5013),(121532,5014),(121533,5015),(121534,5016),(121535,4896),(121536,4898),(121537,4899),(121538,4900),(121539,4901),(121540,4902),(121541,4903),(121542,4904),(121543,4905),(121544,4906),(121545,4907),(121546,4908),(121547,4909),(121548,4910),(121549,4911),(121550,4971),(121551,4974),(121552,4975),(121553,4978),(121554,4979),(121555,4980),(121556,4981),(121557,4982),(121558,4992),(121559,4993),(121560,4994),(121561,4995),(121562,5001),(121563,5003),(121564,5004),(121565,5006),(121566,5007),(121567,5009),(121568,5010),(121569,5019),(121570,5020),(121571,5022),(121572,5024),(121573,5025),(121574,4974),(121575,1748),(121576,255),(121577,256),(121578,257),(121579,1812),(121580,5620),(121581,5745),(121582,5746),(121583,5747),(121584,5748),(121585,5749),(121586,5179),(121587,5182),(121588,5190),(121589,5194),(121590,5195),(121591,5196),(121592,5197),(121593,5198),(121594,5199),(121595,5198),(121596,1579),(121597,1580),(121598,1581),(121599,1582),(121600,1583),(121601,1803),(121602,1804),(121603,1807),(121604,1808),(121605,1809),(121606,1810),(121607,1811),(121608,2201),(121609,2202),(121610,2214),(121611,2215),(121612,2216),(121613,2217),(121614,2218),(121615,2219),(121616,2220),(121617,2251),(121618,2258),(121619,2259),(121620,2260),(121621,2261),(121622,2262),(121623,2265),(121624,2266),(121625,2267),(121626,2268),(121627,2269),(121628,2276),(121629,2307),(121630,2308),(121631,2309),(121632,2310),(121633,2311),(121634,2312),(121635,2313),(121636,2314),(121637,2315),(121638,2316),(121639,2317),(121640,2318),(121641,2319),(121642,2320),(121643,2321),(121644,2322),(121645,2460),(121646,2461),(121647,2462),(121648,2463),(121649,2464),(121650,2504),(121651,2505),(121652,4628),(121653,4668),(121654,4669),(121655,4670),(121656,4671),(121657,4672),(121658,4673),(121659,4674),(121660,4675),(121661,4676),(121662,4680),(121663,4687),(121664,4688),(121665,4689),(121666,4690),(121667,4691),(121668,4692),(121669,4693),(121670,4694),(121671,4695),(121672,4696),(121673,4697),(121674,4698),(121675,4699),(121676,4700),(121677,4701),(121678,4702),(121679,4703),(121680,4704),(121681,4705),(121682,4706),(121683,4707),(121684,4708),(121685,4709),(121686,4710),(121687,4711),(121688,4712),(121689,4713),(121690,4907),(121691,4908),(121692,4909),(121693,4911),(121694,4974),(121695,4975),(121696,4976),(121697,4977),(121698,4978),(121699,5003),(121700,5004),(121701,5005),(121702,5006),(121703,5007),(121704,5008),(121705,5009),(121706,5010),(121707,5011),(121708,5012),(121709,5013),(121710,5014),(121711,5015),(121712,5016),(121713,5024),(121714,5025),(121715,5026),(121716,5027),(121717,5122),(121718,5123),(121719,5124),(121720,5125),(121721,5126),(121722,5127),(121723,5128),(121724,5129),(121725,5130),(121726,5131),(121727,5136),(121728,5137),(121729,5138),(121730,5139),(121731,5140),(121732,5141),(121733,5142),(121734,5147),(121735,5148),(121736,5149),(121737,5150),(121738,5159),(121739,5160),(121740,5161),(121741,5162),(121742,5163),(121743,5164),(121744,5165),(121745,5166),(121746,5167),(121747,5168),(121748,5190),(121749,5191),(121750,5192),(121751,5193),(121752,5194),(121753,5197),(121754,4974),(121755,5026),(121756,5166),(121757,1679),(121758,1680),(121759,1708),(121760,1709),(121761,1710),(121762,1711),(121763,1712),(121764,1713),(121765,1714),(121766,1748),(121767,1791),(121768,1792),(121769,1798),(121770,2187),(121771,2188),(121772,2189),(121773,2190),(121774,2191),(121775,2192),(121776,2193),(121777,2194),(121778,2195),(121779,2196),(121780,2197),(121781,2198),(121782,2232),(121783,2233),(121784,2234),(121785,2235),(121786,2236),(121787,2237),(121788,2238),(121789,2239),(121790,2240),(121791,2392),(121792,2393),(121793,2394),(121794,2395),(121795,2411),(121796,2412),(121797,2577),(121798,2578),(121799,2579),(121800,2580),(121801,2581),(121802,2589),(121803,2590),(121804,2591),(121805,2592),(121806,2593),(121807,2594),(121808,2595),(121809,2596),(121810,2597),(121811,2598),(121812,2599),(121813,2600),(121814,2601),(121815,2602),(121816,2603),(121817,2604),(121818,2605),(121819,2606),(121820,2607),(121821,2608),(121822,2609),(121823,2610),(121824,2611),(121825,2612),(121826,2613),(121827,2614),(121828,4621),(121829,4629),(121830,4630),(121831,4631),(121832,4632),(121833,4633),(121834,4634),(121835,4635),(121836,4636),(121837,4637),(121838,4638),(121839,4639),(121840,4640),(121841,4641),(121842,4642),(121843,4643),(121844,4644),(121845,4645),(121846,4646),(121847,4647),(121848,4648),(121849,4649),(121850,4650),(121851,4651),(121852,4652),(121853,4653),(121854,4654),(121855,4655),(121856,4656),(121857,4657),(121858,4658),(121859,4659),(121860,4660),(121861,4661),(121862,4662),(121863,4663),(121864,4664),(121865,4665),(121866,4666),(121867,4667),(121868,4896),(121869,4898),(121870,4900),(121871,4902),(121872,4903),(121873,4904),(121874,4943),(121875,4944),(121876,4945),(121877,4946),(121878,4947),(121879,4948),(121880,4949),(121881,4950),(121882,4951),(121883,4952),(121884,4953),(121885,4954),(121886,4971),(121887,4972),(121888,4973),(121889,4979),(121890,4980),(121891,4981),(121892,4982),(121893,4983),(121894,4984),(121895,4985),(121896,4986),(121897,4987),(121898,4988),(121899,4989),(121900,4990),(121901,4991),(121902,5001),(121903,5002),(121904,5105),(121905,5178),(121906,5179),(121907,5180),(121908,5181),(121909,5182),(121910,5202),(121911,5203),(121912,5204),(121913,5205),(121914,5206),(121915,5207),(121916,5208),(121917,5209),(121918,5210),(121919,5211),(121920,5212),(121921,5213),(121922,5214),(121923,5215),(121924,5216),(121925,5217),(121926,5218),(121927,5219),(121928,5220),(121929,5221),(121930,5222),(121931,5223),(121932,5224),(121933,5225),(121934,5226),(121935,5227),(121936,5228),(121937,5229),(121938,5230),(121939,5231),(121940,5232),(121941,5233),(121942,5234),(121943,5235),(121944,5236),(121945,5237),(121946,1575),(121947,1576),(121948,1577),(121949,1578),(121950,1805),(121951,1806),(121952,2200),(121953,2208),(121954,2209),(121955,2210),(121956,2245),(121957,2246),(121958,2256),(121959,2257),(121960,2302),(121961,2303),(121962,2304),(121963,2305),(121964,2306),(121965,2396),(121966,2397),(121967,2398),(121968,2399),(121969,2400),(121970,2401),(121971,2402),(121972,2403),(121973,2404),(121974,2405),(121975,2406),(121976,2407),(121977,2408),(121978,2409),(121979,2410),(121980,2458),(121981,2459),(121982,2503),(121983,4627),(121984,4714),(121985,4715),(121986,4716),(121987,4717),(121988,4719),(121989,4720),(121990,4721),(121991,4722),(121992,4723),(121993,4724),(121994,4725),(121995,4726),(121996,4727),(121997,4728),(121998,4729),(121999,4809),(122000,4810),(122001,4811),(122002,4823),(122003,4843),(122004,4844),(122005,4846),(122006,4847),(122007,4848),(122008,4849),(122009,4850),(122010,4851),(122011,4852),(122012,4856),(122013,4899),(122014,4901),(122015,4905),(122016,4906),(122017,4910),(122018,4992),(122019,4993),(122020,4994),(122021,4995),(122022,4996),(122023,4997),(122024,4998),(122025,4999),(122026,5000),(122027,5019),(122028,5020),(122029,5021),(122030,5022),(122031,5023),(122032,5039),(122033,5040),(122034,5041),(122035,5042),(122036,5043),(122037,5044),(122038,5045),(122039,5046),(122040,5047),(122041,5048),(122042,5049),(122043,5050),(122044,5051),(122045,5052),(122046,5053),(122047,5054),(122048,5055),(122049,5056),(122050,5057),(122051,5058),(122052,5059),(122053,5060),(122054,5061),(122055,5065),(122056,5066),(122057,5067),(122058,5068),(122059,5069),(122060,5070),(122061,5071),(122062,5072),(122063,5195),(122064,5196),(122065,5198),(122066,5199),(122067,4613),(122068,4614),(122069,4857),(122070,4858),(122071,4859),(122072,4860),(122073,4861),(122074,4862),(122075,4863),(122076,4864),(122077,4865),(122078,4866),(122079,4867),(122080,4868),(122081,4869),(122082,4870),(122083,4871),(122084,4874),(122085,4875),(122086,4876),(122087,4891),(122088,4892),(122089,4893),(122090,4894),(122091,2435),(122092,4731),(122093,4732),(122094,4733),(122095,4734),(122096,4735),(122097,4736),(122098,4737),(122099,4738),(122100,4739),(122101,4740),(122102,4741),(122103,4742),(122104,4743),(122105,4744),(122106,4745),(122107,4746),(122108,4747),(122109,4748),(122110,4749),(122111,4750),(122112,4751),(122113,4752),(122114,4753),(122115,4754),(122116,4755),(122117,4756),(122118,4757),(122119,4758),(122120,4759),(122121,4760),(122122,4761),(122123,4762),(122124,4763),(122125,4764),(122126,4765),(122127,4766),(122128,4767),(122129,4768),(122130,4769),(122131,4770),(122132,4771),(122133,4772),(122134,4773),(122135,4774),(122136,4775),(122137,4776),(122138,4777),(122139,4778),(122140,4779),(122141,4780),(122142,4781),(122143,4782),(122144,4783),(122145,4784),(122146,4785),(122147,4786),(122148,4787),(122149,4788),(122150,4789),(122151,4790),(122152,4791),(122153,4792),(122154,4793),(122155,4794),(122156,4795),(122157,4796),(122158,4797),(122159,4798),(122160,4799),(122161,4800),(122162,4801),(122163,4802),(122164,4803),(122165,4804),(122166,4957),(122167,4958),(122168,4960),(122169,4961),(122170,4962),(122171,5106),(122172,5107),(122173,5108),(122174,5109),(122175,2435),(122176,1538),(122177,1539),(122178,1543),(122179,1544),(122180,1561),(122181,5154),(122182,5155),(122183,1763),(122184,1497),(122185,1512),(122186,1590),(122187,1595),(122188,1596),(122189,1597),(122190,1599),(122191,1729),(122192,1732),(122193,1734),(122194,1149),(122195,1150),(122196,1475),(122197,1476),(122198,1480),(122199,1481),(122200,1482),(122201,1483),(122202,1510),(122203,1537),(122204,1538),(122205,1539),(122206,1540),(122207,1542),(122208,1543),(122209,1545),(122210,1546),(122211,1547),(122212,1548),(122213,1549),(122214,1550),(122215,1551),(122216,1552),(122217,1553),(122218,1554),(122219,1555),(122220,1560),(122221,1613),(122222,1616),(122223,1617),(122224,1655),(122225,1657),(122226,1706),(122227,1715),(122228,1716),(122229,1717),(122230,1718),(122231,1719),(122232,1720),(122233,1722),(122234,1723),(122235,1724),(122236,1725),(122237,1735),(122238,1765),(122239,1766),(122240,1767),(122241,1768),(122242,1770),(122243,1771),(122244,1776),(122245,1777),(122246,1783),(122247,1812),(122248,1149),(122249,1150),(122250,1477),(122251,1480),(122252,1483),(122253,1486),(122254,1487),(122255,1495),(122256,1496),(122257,1499),(122258,1500),(122259,1502),(122260,1505),(122261,1509),(122262,1537),(122263,1538),(122264,1539),(122265,1540),(122266,1541),(122267,1544),(122268,1546),(122269,1547),(122270,1548),(122271,1549),(122272,1550),(122273,1551),(122274,1552),(122275,1553),(122276,1554),(122277,1555),(122278,1556),(122279,1560),(122280,1561),(122281,1612),(122282,1614),(122283,1705),(122284,1776),(122285,1777),(122286,1796),(122287,5154),(122288,5155),(122289,377),(122290,378),(122291,380),(122292,382),(122293,385),(122294,386),(122295,387),(122296,389),(122297,391),(122298,397),(122299,569),(122300,584),(122301,607),(122302,608),(122303,774),(122304,791),(122305,792),(122306,795),(122307,800),(122308,801),(122309,818),(122310,823),(122311,831),(122312,860),(122313,867),(122314,868),(122315,893),(122316,1174),(122317,1175),(122318,1176),(122319,1177),(122320,1178),(122321,1179),(122322,1180),(122323,1185),(122324,1186),(122325,1187),(122326,1190),(122327,1192),(122328,1193),(122329,1194),(122330,1470),(122331,1471),(122332,1472),(122333,1494),(122334,1518),(122335,1519),(122336,1520),(122337,1521),(122338,1563),(122339,1564),(122340,1565),(122341,1665),(122342,1675),(122343,1676),(122344,1677),(122345,1678),(122346,1747),(122347,1751),(122348,1752),(122349,1753),(122350,1761),(122351,1762),(122352,1772),(122353,1778),(122354,1779),(122355,4880),(122356,4884),(122357,4885),(122358,5274),(122359,5336),(122360,5524),(122361,4536),(122362,904),(122363,905),(122364,1816),(122365,1818),(122366,1822),(122367,1966),(122368,1967),(122369,1968),(122370,1969),(122371,1970),(122372,1971),(122373,2013),(122374,2265),(122375,2266),(122376,2267),(122377,2268),(122378,2269),(122379,2276),(122380,2319),(122381,2320),(122382,2397),(122383,2400),(122384,2401),(122385,2409),(122386,2410),(122387,2589),(122388,2590),(122389,2591),(122390,2593),(122391,2597),(122392,2599),(122393,2601),(122394,2602),(122395,2603),(122396,2604),(122397,2605),(122398,2606),(122399,2607),(122400,2608),(122401,2609),(122402,2610),(122403,2612),(122404,1813),(122405,1814),(122406,1815),(122407,1816),(122408,1817),(122409,1818),(122410,1819),(122411,1820),(122412,1821),(122413,1822),(122414,1823),(122415,1824),(122416,1825),(122417,1826),(122418,1950),(122419,1951),(122420,1952),(122421,2435),(122422,4539),(122423,4540),(122424,4541),(122425,4542),(122426,4543),(122427,4544),(122428,4545),(122429,4546),(122430,4547),(122431,4548),(122432,4549),(122433,4550),(122434,4551),(122435,4552),(122436,4553),(122437,4554),(122438,4555),(122439,4556),(122440,4557),(122441,4558),(122442,4559),(122443,4560),(122444,4561),(122445,4562),(122446,4563),(122447,4564),(122448,4565),(122449,4933),(122450,4970),(122451,5151),(122452,5152),(122453,5153),(122454,5154),(122455,5155),(122456,5156),(122457,5157),(122458,5158),(122459,5183),(122460,5248),(122461,5249),(122462,4559),(122463,4560),(122464,4561),(122465,4562),(122466,4563),(122467,4564),(122468,4565),(122469,4933),(122470,5151),(122471,5152),(122472,5153),(122473,5154),(122474,5155),(122475,5156),(122476,5157),(122477,5158),(122478,5183),(122479,5248),(122480,5249),(122481,163),(122482,164),(122483,165),(122484,166),(122485,167),(122486,168),(122487,172),(122488,254),(122489,255),(122490,256),(122491,257),(122492,1049),(122493,1050),(122494,1051),(122495,1052),(122496,1053),(122497,1054),(122498,1055),(122499,1056),(122500,1057),(122501,1058),(122502,1059),(122503,1060),(122504,1061),(122505,1062),(122506,1063),(122507,1064),(122508,1065),(122509,1066),(122510,1067),(122511,1068),(122512,1069),(122513,1070),(122514,1071),(122515,1072),(122516,1073),(122517,1074),(122518,1075),(122519,1076),(122520,1077),(122521,1078),(122522,1079),(122523,1080),(122524,1081),(122525,1082),(122526,1083),(122527,1084),(122528,1085),(122529,1086),(122530,1087),(122531,1088),(122532,1089),(122533,1090),(122534,1091),(122535,1611),(122536,1612),(122537,1613),(122538,1614),(122539,1615),(122540,1616),(122541,1617),(122542,1654),(122543,1655),(122544,1656),(122545,1657),(122546,1705),(122547,1706),(122548,1707),(122549,1739),(122550,1741),(122551,1742),(122552,1759),(122553,1760),(122554,1764),(122555,1765),(122556,1766),(122557,1767),(122558,1768),(122559,1769),(122560,1770),(122561,1771),(122562,1772),(122563,1774),(122564,1775),(122565,1776),(122566,1777),(122567,1783),(122568,1784),(122569,1785),(122570,1812),(122571,1959),(122572,1960),(122573,1961),(122574,1962),(122575,1963),(122576,1964),(122577,2289),(122578,2290),(122579,2291),(122580,2293),(122581,2413),(122582,2414),(122583,2415),(122584,2416),(122585,2417),(122586,2418),(122587,2419),(122588,2420),(122589,2421),(122590,2422),(122591,2423),(122592,2424),(122593,2425),(122594,2426),(122595,2427),(122596,2428),(122597,2517),(122598,2518),(122599,2519),(122600,2520),(122601,2537),(122602,2538),(122603,4622),(122604,4623),(122605,4624),(122606,4853),(122607,4854),(122608,4855),(122609,4877),(122610,4878),(122611,4879),(122612,4880),(122613,4881),(122614,4882),(122615,4883),(122616,4884),(122617,4885),(122618,4886),(122619,4887),(122620,4888),(122621,4889),(122622,4890),(122623,5368),(122624,5408),(122625,5410),(122626,5411),(122627,5412),(122628,5413),(122629,5414),(122630,5415),(122631,5416),(122632,5417),(122633,5418),(122634,5419),(122635,5428),(122636,5469),(122637,5470),(122638,5471),(122639,5472),(122640,5473),(122641,5538),(122642,5539),(122643,5540),(122644,5541),(122645,5542),(122646,5543),(122647,5544),(122648,5545),(122649,5546),(122650,5547),(122651,5548),(122652,5549),(122653,5550),(122654,5571),(122655,5591),(122656,5592),(122657,5593),(122658,5594),(122659,5595),(122660,5596),(122661,5597),(122662,5598),(122663,5599),(122664,5600),(122665,5601),(122666,5602),(122667,5603),(122668,5604),(122669,5605),(122670,5606),(122671,5607),(122672,5608),(122673,5609),(122674,5610),(122675,5611),(122676,5612),(122677,5613),(122678,5614),(122679,5615),(122680,5616),(122681,5617),(122682,5618),(122683,5619),(122684,5620),(122685,5621),(122686,5622),(122687,5623),(122688,5624),(122689,5625),(122690,5626),(122691,5627),(122692,5628),(122693,5629),(122694,5630),(122695,5631),(122696,5632),(122697,5633),(122698,5634),(122699,5635),(122700,5636),(122701,5637),(122702,5638),(122703,5639),(122704,5640),(122705,5641),(122706,5642),(122707,5643),(122708,5644),(122709,5645),(122710,5646),(122711,5647),(122712,5648),(122713,5649),(122714,5650),(122715,5651),(122716,5652),(122717,5653),(122718,5654),(122719,5655),(122720,5656),(122721,5657),(122722,5658),(122723,5659),(122724,5660),(122725,5661),(122726,5662),(122727,5663),(122728,5664),(122729,5665),(122730,5666),(122731,5667),(122732,5668),(122733,5669),(122734,5670),(122735,5671),(122736,5672),(122737,5682),(122738,5683),(122739,5684),(122740,5685),(122741,5686),(122742,5687),(122743,5688),(122744,5690),(122745,5691),(122746,5692),(122747,5693),(122748,5694),(122749,5695),(122750,5697),(122751,5698),(122752,5699),(122753,5700),(122754,5701),(122755,5709),(122756,5710),(122757,5711),(122758,5712),(122759,5713),(122760,5714),(122761,5715),(122762,5716),(122763,5717),(122764,5718),(122765,5719),(122766,5720),(122767,5721),(122768,5722),(122769,5723),(122770,5724),(122771,5725),(122772,5726),(122773,5727),(122774,5728),(122775,5729),(122776,5730),(122777,5731),(122778,5732),(122779,5733),(122780,5734),(122781,5735),(122782,5736),(122783,5737),(122784,5745),(122785,5746),(122786,5747),(122787,5748),(122788,5749),(122789,163),(122790,164),(122791,165),(122792,166),(122793,167),(122794,168),(122795,172),(122796,254),(122797,255),(122798,256),(122799,257),(122800,1049),(122801,1050),(122802,1051),(122803,1052),(122804,1053),(122805,1054),(122806,1055),(122807,1056),(122808,1057),(122809,1058),(122810,1059),(122811,1060),(122812,1061),(122813,1062),(122814,1063),(122815,1064),(122816,1065),(122817,1066),(122818,1067),(122819,1068),(122820,1069),(122821,1070),(122822,1071),(122823,1072),(122824,1073),(122825,1074),(122826,1075),(122827,1076),(122828,1077),(122829,1078),(122830,1079),(122831,1080),(122832,1081),(122833,1082),(122834,1083),(122835,1084),(122836,1085),(122837,1086),(122838,1087),(122839,1088),(122840,1089),(122841,1090),(122842,1091),(122843,1611),(122844,1612),(122845,1614),(122846,1616),(122847,1617),(122848,1655),(122849,1656),(122850,1705),(122851,1706),(122852,1707),(122853,1739),(122854,1741),(122855,1742),(122856,1759),(122857,1760),(122858,1764),(122859,1765),(122860,1769),(122861,1772),(122862,1776),(122863,1777),(122864,1783),(122865,1959),(122866,1960),(122867,1961),(122868,1962),(122869,1963),(122870,1964),(122871,2290),(122872,2291),(122873,2293),(122874,2413),(122875,2414),(122876,2415),(122877,2416),(122878,2417),(122879,2418),(122880,2419),(122881,2420),(122882,2421),(122883,2422),(122884,2423),(122885,2424),(122886,2425),(122887,2426),(122888,2427),(122889,2428),(122890,2517),(122891,2518),(122892,2519),(122893,2520),(122894,2537),(122895,2538),(122896,4539),(122897,4540),(122898,4541),(122899,4542),(122900,4543),(122901,4544),(122902,4545),(122903,4546),(122904,4547),(122905,4548),(122906,4549),(122907,4550),(122908,4551),(122909,4552),(122910,4553),(122911,4554),(122912,4555),(122913,4556),(122914,4557),(122915,4558),(122916,4622),(122917,4623),(122918,4624),(122919,4853),(122920,4854),(122921,4855),(122922,4877),(122923,4878),(122924,4879),(122925,4880),(122926,4882),(122927,4883),(122928,4884),(122929,4885),(122930,4886),(122931,4887),(122932,4888),(122933,4890),(122934,4970),(122935,5368),(122936,5408),(122937,5410),(122938,5411),(122939,5412),(122940,5413),(122941,5414),(122942,5415),(122943,5416),(122944,5417),(122945,5418),(122946,5419),(122947,5428),(122948,5469),(122949,5470),(122950,5471),(122951,5472),(122952,5473),(122953,5538),(122954,5539),(122955,5540),(122956,5541),(122957,5542),(122958,5543),(122959,5544),(122960,5545),(122961,5546),(122962,5547),(122963,5548),(122964,5549),(122965,5550),(122966,5571),(122967,5591),(122968,5592),(122969,5593),(122970,5594),(122971,5595),(122972,5596),(122973,5597),(122974,5598),(122975,5599),(122976,5600),(122977,5601),(122978,5602),(122979,5603),(122980,5604),(122981,5605),(122982,5606),(122983,5607),(122984,5608),(122985,5609),(122986,5610),(122987,5611),(122988,5612),(122989,5613),(122990,5614),(122991,5615),(122992,5616),(122993,5617),(122994,5618),(122995,5619),(122996,5620),(122997,5621),(122998,5622),(122999,5624),(123000,5625),(123001,5626),(123002,5627),(123003,5628),(123004,5630),(123005,5631),(123006,5632),(123007,5633),(123008,5634),(123009,5635),(123010,5637),(123011,5638),(123012,5639),(123013,5640),(123014,5641),(123015,5643),(123016,5644),(123017,5645),(123018,5646),(123019,5647),(123020,5648),(123021,5649),(123022,5650),(123023,5652),(123024,5653),(123025,5654),(123026,5655),(123027,5656),(123028,5657),(123029,5658),(123030,5659),(123031,5660),(123032,5661),(123033,5663),(123034,5664),(123035,5665),(123036,5666),(123037,5667),(123038,5669),(123039,5670),(123040,5671),(123041,5672),(123042,5682),(123043,5683),(123044,5684),(123045,5685),(123046,5686),(123047,5687),(123048,5688),(123049,5690),(123050,5691),(123051,5692),(123052,5693),(123053,5694),(123054,5695),(123055,5697),(123056,5698),(123057,5699),(123058,5700),(123059,5701),(123060,5709),(123061,5710),(123062,5711),(123063,5712),(123064,5713),(123065,5714),(123066,5715),(123067,5716),(123068,5717),(123069,5718),(123070,5719),(123071,5720),(123072,5721),(123073,5722),(123074,5723),(123075,5724),(123076,5725),(123077,5726),(123078,5727),(123079,5728),(123080,5729),(123081,5730),(123082,5731),(123083,5732),(123084,5733),(123085,5734),(123086,5735),(123087,5736),(123088,5737),(123089,5745),(123090,5746),(123091,5747),(123092,5748),(123093,5749),(123094,1081),(123095,1611),(123096,1612),(123097,1614),(123098,1616),(123099,1617),(123100,1655),(123101,1656),(123102,1705),(123103,1706),(123104,1707),(123105,1739),(123106,1741),(123107,1742),(123108,1764),(123109,1765),(123110,1769),(123111,1772),(123112,1776),(123113,1777),(123114,1783),(123115,2290),(123116,2291),(123117,2293),(123118,4622),(123119,4623),(123120,4624),(123121,4853),(123122,4854),(123123,4855),(123124,4877),(123125,4878),(123126,4879),(123127,4880),(123128,4882),(123129,4883),(123130,4884),(123131,4885),(123132,4886),(123133,4887),(123134,4888),(123135,5598),(123136,5622),(123137,5625),(123138,5626),(123139,5627),(123140,5638),(123141,5641),(123142,5650),(123143,5660),(123144,5664),(123145,5667),(123146,5695),(123147,1081),(123148,1496),(123149,1992),(123150,1993),(123151,1994),(123152,1995),(123153,1997),(123154,1998),(123155,1999),(123156,2000),(123157,2001),(123158,2002),(123159,4526),(123160,4527),(123161,4530),(123162,4531),(123163,4532),(123164,4533),(123165,4534),(123166,4536),(123167,5274),(123168,5282),(123169,5283),(123170,5284),(123171,1996),(123172,4535),(123173,1588),(123174,1589),(123175,1590),(123176,1591),(123177,1592),(123178,1593),(123179,1594),(123180,1595),(123181,1596),(123182,1597),(123183,1598),(123184,1599),(123185,1604),(123186,1607),(123187,1610),(123188,1618),(123189,1619),(123190,1620),(123191,1621),(123192,1623),(123193,1626),(123194,1733),(123195,1734),(123196,1735),(123197,5258),(123198,5259),(123199,5260),(123200,5261),(123201,5262),(123202,5263),(123203,5264),(123204,5265),(123205,5266),(123206,5267),(123207,5268),(123208,5269),(123209,5270),(123210,5524),(123211,5526),(123212,5570),(123213,5588),(123214,1473),(123215,1474),(123216,1475),(123217,1476),(123218,1477),(123219,1478),(123220,1479),(123221,1480),(123222,1483),(123223,1484),(123224,1485),(123225,1486),(123226,1487),(123227,1515),(123228,1516),(123229,1517),(123230,1537),(123231,1538),(123232,1539),(123233,1540),(123234,1541),(123235,1544),(123236,1545),(123237,1546),(123238,1547),(123239,1548),(123240,1549),(123241,1550),(123242,1551),(123243,1552),(123244,1553),(123245,1554),(123246,1555),(123247,1556),(123248,1560),(123249,1561),(123250,1763),(123251,5309),(123252,5310),(123253,5311),(123254,5312),(123255,5313),(123256,5314),(123257,5315),(123258,5316),(123259,5317),(123260,5318),(123261,5319),(123262,5320),(123263,1481),(123264,1482),(123265,1542),(123266,1543),(123267,1140),(123268,1141),(123269,1142),(123270,1143),(123271,1149),(123272,1150),(123273,1497),(123274,1498),(123275,1501),(123276,1502),(123277,1503),(123278,1504),(123279,1506),(123280,1507),(123281,1508),(123282,1509),(123283,1510),(123284,1511),(123285,1512),(123286,1513),(123287,1514),(123288,1797),(123289,5171),(123290,5307),(123291,5308),(123292,5321),(123293,5322),(123294,5536),(123295,5689),(123296,5696),(123297,1141),(123298,1142),(123299,1143),(123300,1149),(123301,1150),(123302,1497),(123303,1498),(123304,1512),(123305,5307),(123306,5308),(123307,1495),(123308,1500),(123309,1796),(123310,1584),(123311,1585),(123312,1586),(123313,1600),(123314,1601),(123315,1602),(123316,1603),(123317,1605),(123318,1606),(123319,1608),(123320,1609),(123321,1622),(123322,1624),(123323,1625),(123324,1627),(123325,1628),(123326,1715),(123327,1716),(123328,1717),(123329,1718),(123330,1719),(123331,1720),(123332,1721),(123333,1722),(123334,1723),(123335,1724),(123336,1725),(123337,1726),(123338,1727),(123339,1728),(123340,1729),(123341,1730),(123342,1731),(123343,1732),(123344,5256),(123345,5257),(123346,5586),(123347,5587),(123348,5589),(123349,4532),(123350,5282),(123351,5283),(123352,5284),(123353,1497),(123354,1498),(123355,1512),(123356,1498),(123357,1499),(123358,5282),(123359,5283),(123360,5284),(123361,400),(123362,401),(123363,405),(123364,408),(123365,409),(123366,410),(123367,415),(123368,416),(123369,417),(123370,419),(123371,426),(123372,427),(123373,428),(123374,429),(123375,432),(123376,433),(123377,434),(123378,435),(123379,437),(123380,438),(123381,439),(123382,440),(123383,441),(123384,442),(123385,443),(123386,444),(123387,445),(123388,446),(123389,447),(123390,448),(123391,449),(123392,450),(123393,451),(123394,452),(123395,453),(123396,454),(123397,455),(123398,456),(123399,457),(123400,458),(123401,459),(123402,463),(123403,464),(123404,465),(123405,466),(123406,467),(123407,468),(123408,476),(123409,477),(123410,478),(123411,479),(123412,480),(123413,482),(123414,483),(123415,484),(123416,485),(123417,486),(123418,487),(123419,488),(123420,489),(123421,490),(123422,491),(123423,492),(123424,493),(123425,494),(123426,495),(123427,496),(123428,497),(123429,498),(123430,499),(123431,503),(123432,504),(123433,505),(123434,506),(123435,507),(123436,508),(123437,509),(123438,510),(123439,511),(123440,512),(123441,513),(123442,515),(123443,516),(123444,533),(123445,534),(123446,535),(123447,536),(123448,537),(123449,538),(123450,539),(123451,540),(123452,541),(123453,544),(123454,545),(123455,546),(123456,547),(123457,548),(123458,549),(123459,550),(123460,551),(123461,552),(123462,554),(123463,555),(123464,556),(123465,559),(123466,571),(123467,572),(123468,573),(123469,574),(123470,575),(123471,576),(123472,577),(123473,578),(123474,579),(123475,580),(123476,581),(123477,582),(123478,585),(123479,586),(123480,593),(123481,594),(123482,595),(123483,598),(123484,600),(123485,610),(123486,612),(123487,620),(123488,621),(123489,622),(123490,623),(123491,633),(123492,634),(123493,638),(123494,640),(123495,641),(123496,642),(123497,647),(123498,649),(123499,653),(123500,654),(123501,655),(123502,657),(123503,658),(123504,674),(123505,752),(123506,754),(123507,755),(123508,756),(123509,757),(123510,758),(123511,759),(123512,760),(123513,761),(123514,762),(123515,763),(123516,764),(123517,765),(123518,766),(123519,767),(123520,768),(123521,769),(123522,770),(123523,773),(123524,774),(123525,775),(123526,780),(123527,796),(123528,797),(123529,805),(123530,806),(123531,807),(123532,808),(123533,809),(123534,810),(123535,811),(123536,812),(123537,813),(123538,818),(123539,819),(123540,820),(123541,826),(123542,827),(123543,828),(123544,829),(123545,841),(123546,842),(123547,843),(123548,844),(123549,845),(123550,846),(123551,847),(123552,848),(123553,849),(123554,850),(123555,851),(123556,852),(123557,853),(123558,854),(123559,856),(123560,869),(123561,873),(123562,874),(123563,876),(123564,877),(123565,880),(123566,881),(123567,882),(123568,883),(123569,884),(123570,885),(123571,886),(123572,887),(123573,888),(123574,889),(123575,890),(123576,891),(123577,892),(123578,893),(123579,894),(123580,895),(123581,896),(123582,897),(123583,898),(123584,899),(123585,900),(123586,901),(123587,909),(123588,910),(123589,911),(123590,912),(123591,932),(123592,933),(123593,934),(123594,935),(123595,940),(123596,941),(123597,942),(123598,943),(123599,948),(123600,949),(123601,950),(123602,951),(123603,952),(123604,953),(123605,954),(123606,955),(123607,956),(123608,976),(123609,977),(123610,978),(123611,979),(123612,984),(123613,985),(123614,986),(123615,987),(123616,992),(123617,993),(123618,994),(123619,995),(123620,1009),(123621,1010),(123622,1011),(123623,1013),(123624,1016),(123625,1017),(123626,1018),(123627,1020),(123628,1022),(123629,1023),(123630,1024),(123631,1027),(123632,1029),(123633,1030),(123634,1031),(123635,1033),(123636,1039),(123637,1040),(123638,1042),(123639,1046),(123640,1047),(123641,1048),(123642,1049),(123643,1051),(123644,1054),(123645,1055),(123646,1065),(123647,1076),(123648,1077),(123649,1082),(123650,1085),(123651,1088),(123652,1090),(123653,1091),(123654,1095),(123655,1096),(123656,1097),(123657,1098),(123658,1099),(123659,1102),(123660,1103),(123661,1104),(123662,1105),(123663,1106),(123664,1107),(123665,1108),(123666,1110),(123667,1113),(123668,1114),(123669,1116),(123670,1120),(123671,1121),(123672,1123),(123673,1128),(123674,1129),(123675,1130),(123676,1131),(123677,1132),(123678,1136),(123679,1137),(123680,1138),(123681,1139),(123682,1148),(123683,1160),(123684,1161),(123685,1174),(123686,1471),(123687,1615),(123688,1775),(123689,1785),(123690,4491),(123691,4528),(123692,4539),(123693,4540),(123694,4541),(123695,4542),(123696,4543),(123697,4544),(123698,4545),(123699,4546),(123700,4547),(123701,4548),(123702,4549),(123703,4550),(123704,4551),(123705,4552),(123706,4553),(123707,4554),(123708,4555),(123709,4556),(123710,4557),(123711,4558),(123712,4559),(123713,4560),(123714,4563),(123715,4564),(123716,4565),(123717,5248),(123718,5249),(123719,5275),(123720,5276),(123721,5277),(123722,5285),(123723,5286),(123724,5287),(123725,5288),(123726,5289),(123727,5290),(123728,5291),(123729,5292),(123730,5293),(123731,5294),(123732,5296),(123733,5297),(123734,5298),(123735,5299),(123736,5300),(123737,5302),(123738,5303),(123739,5304),(123740,5305),(123741,5306),(123742,5338),(123743,5339),(123744,5340),(123745,5341),(123746,5342),(123747,5345),(123748,5346),(123749,5347),(123750,5348),(123751,5349),(123752,5350),(123753,5357),(123754,5358),(123755,5368),(123756,5369),(123757,5401),(123758,5402),(123759,5403),(123760,5404),(123761,5405),(123762,5406),(123763,5407),(123764,5408),(123765,5409),(123766,5410),(123767,5411),(123768,5412),(123769,5413),(123770,5414),(123771,5415),(123772,5416),(123773,5417),(123774,5418),(123775,5419),(123776,5420),(123777,5421),(123778,5422),(123779,5423),(123780,5424),(123781,5425),(123782,5426),(123783,5427),(123784,5428),(123785,5429),(123786,5431),(123787,5434),(123788,5435),(123789,5436),(123790,5437),(123791,5438),(123792,5439),(123793,5440),(123794,5441),(123795,5442),(123796,5443),(123797,5444),(123798,5445),(123799,5446),(123800,5447),(123801,5448),(123802,5449),(123803,5450),(123804,5458),(123805,5463),(123806,5464),(123807,5471),(123808,5472),(123809,5518),(123810,5519),(123811,5531),(123812,5532),(123813,5533),(123814,5534),(123815,5535),(123816,5537),(123817,5541),(123818,5542),(123819,5543),(123820,5544),(123821,5545),(123822,5546),(123823,5547),(123824,5548),(123825,5553),(123826,5554),(123827,5555),(123828,5556),(123829,5557),(123830,5558),(123831,5559),(123832,5560),(123833,5563),(123834,5564),(123835,5566),(123836,5567),(123837,5568),(123838,5569),(123839,5571),(123840,5590),(123841,5591),(123842,5592),(123843,5593),(123844,5595),(123845,5596),(123846,5597),(123847,5602),(123848,5603),(123849,5605),(123850,5606),(123851,5608),(123852,5609),(123853,5610),(123854,5611),(123855,5612),(123856,5613),(123857,5614),(123858,5615),(123859,5616),(123860,5617),(123861,5618),(123862,5619),(123863,5620),(123864,5630),(123865,5631),(123866,5632),(123867,5633),(123868,5634),(123869,5674),(123870,5675),(123871,5676),(123872,5677),(123873,5678),(123874,5679),(123875,5680),(123876,5681),(123877,5682),(123878,5683),(123879,5684),(123880,5685),(123881,5686),(123882,5688),(123883,5690),(123884,5691),(123885,5692),(123886,5693),(123887,5694),(123888,5697),(123889,5698),(123890,5699),(123891,5700),(123892,5709),(123893,5710),(123894,5711),(123895,5713),(123896,5714),(123897,5715),(123898,5716),(123899,5717),(123900,5718),(123901,5719),(123902,5720),(123903,5721),(123904,5722),(123905,5723),(123906,5724),(123907,5725),(123908,5726),(123909,5727),(123910,5728),(123911,5729),(123912,5730),(123913,5731),(123914,5732),(123915,5733),(123916,5734),(123917,5735),(123918,5736),(123919,5737),(123920,5738),(123921,5745),(123922,5746),(123923,5747),(123924,5749),(123925,5752),(123926,5404),(123927,5425),(123928,5427),(123929,5406),(123930,5407),(123931,5426),(123932,5559),(123933,5560),(123934,5401),(123935,1615),(123936,4539),(123937,4540),(123938,4541),(123939,4542),(123940,4543),(123941,4544),(123942,4546),(123943,4547),(123944,4548),(123945,4549),(123946,4556),(123947,4557),(123948,4558),(123949,4559),(123950,4560),(123951,5249),(123952,5568),(123953,5569),(123954,5443),(123955,5540),(123956,5592),(123957,5594),(123958,5604),(123959,5693),(123960,5596),(123961,5597),(123962,5734),(123963,5735),(123964,5736),(123965,5737),(123966,400),(123967,480),(123968,482),(123969,499),(123970,515),(123971,873),(123972,874),(123973,876),(123974,877),(123975,880),(123976,881),(123977,1024),(123978,5299),(123979,5300),(123980,5303),(123981,5304),(123982,5305),(123983,5306),(123984,5449),(123985,5518),(123986,5519),(123987,5713),(123988,5714),(123989,5715),(123990,5716),(123991,5717),(123992,5718),(123993,5719),(123994,5720),(123995,5721),(123996,5722),(123997,5723),(123998,5724),(123999,5725),(124000,5726),(124001,5727),(124002,5728),(124003,5729),(124004,5730),(124005,5731),(124006,5732),(124007,5733),(124008,5734),(124009,5735),(124010,5736),(124011,5737),(124012,5733),(124013,5734),(124014,5735),(124015,5736),(124016,5737),(124017,4540),(124018,4541),(124019,4542),(124020,5248),(124021,5249),(124022,5629),(124023,5642),(124024,5668),(124025,2540),(124026,2541),(124027,2542),(124028,5357),(124029,5429),(124030,5434),(124031,5458),(124032,5463),(124033,5464),(124034,5518),(124035,2154),(124036,2177),(124037,2221),(124038,2222),(124039,2299),(124040,5622),(124041,5641),(124042,5667),(124043,1184),(124044,5527),(124045,5621),(124046,5644),(124047,5645),(124048,5654),(124049,5670),(124050,5671),(124051,1054),(124052,1055),(124053,1066),(124054,2289),(124055,2290),(124056,2291),(124057,2293),(124058,2428),(124059,5621),(124060,5622),(124061,5623),(124062,5624),(124063,5625),(124064,5626),(124065,5627),(124066,5629),(124067,5630),(124068,5631),(124069,5632),(124070,5633),(124071,5634),(124072,5636),(124073,5637),(124074,5638),(124075,5639),(124076,5640),(124077,5641),(124078,5642),(124079,5643),(124080,5644),(124081,5645),(124082,5647),(124083,5648),(124084,5649),(124085,5650),(124086,5651),(124087,5652),(124088,5653),(124089,5655),(124090,5656),(124091,5658),(124092,5659),(124093,5660),(124094,5662),(124095,5663),(124096,5664),(124097,5665),(124098,5666),(124099,5667),(124100,5668),(124101,5669),(124102,5670),(124103,5671),(124104,5731),(124105,5732),(124106,5733),(124107,5734),(124108,5735),(124109,5736),(124110,5737),(124111,5745),(124112,5746),(124113,5747),(124114,5749),(124115,1054),(124116,1055),(124117,1066),(124118,2289),(124119,2290),(124120,2291),(124121,2293),(124122,2428),(124123,5655),(124124,5656),(124125,5732),(124126,5745),(124127,5746),(124128,5747),(124129,5749),(124130,165),(124131,1082),(124132,1088),(124133,1611),(124134,1612),(124135,1614),(124136,1616),(124137,1617),(124138,1655),(124139,1656),(124140,1705),(124141,1706),(124142,1707),(124143,1739),(124144,1741),(124145,1742),(124146,1764),(124147,1765),(124148,1769),(124149,1776),(124150,1777),(124151,1783),(124152,1962),(124153,2517),(124154,2518),(124155,2519),(124156,2520),(124157,4853),(124158,4854),(124159,4855),(124160,4883),(124161,4970),(124162,5368),(124163,5408),(124164,5410),(124165,5411),(124166,5412),(124167,5413),(124168,5415),(124169,5416),(124170,5417),(124171,5428),(124172,5540),(124173,5546),(124174,5547),(124175,5548),(124176,5571),(124177,5591),(124178,5592),(124179,5593),(124180,5594),(124181,5595),(124182,5596),(124183,5597),(124184,5598),(124185,5599),(124186,5600),(124187,5601),(124188,5602),(124189,5603),(124190,5604),(124191,5613),(124192,5615),(124193,5616),(124194,5617),(124195,5618),(124196,5619),(124197,5628),(124198,5646),(124199,5654),(124200,5661),(124201,5672),(124202,5690),(124203,5691),(124204,5692),(124205,5693),(124206,5694),(124207,5695),(124208,5713),(124209,5715),(124210,5717),(124211,5719),(124212,5721),(124213,5723),(124214,5725),(124215,5727),(124216,5729),(124217,165),(124218,1082),(124219,1088),(124220,1611),(124221,1612),(124222,1614),(124223,1616),(124224,1617),(124225,1655),(124226,1656),(124227,1705),(124228,1706),(124229,1707),(124230,1739),(124231,1741),(124232,1742),(124233,1764),(124234,1765),(124235,1769),(124236,1776),(124237,1777),(124238,1783),(124239,1962),(124240,2517),(124241,2518),(124242,2519),(124243,2520),(124244,4853),(124245,4854),(124246,4855),(124247,4883),(124248,4970),(124249,5598),(124250,5624),(124251,5628),(124252,5643),(124253,5653),(124254,5660),(124255,5669),(124256,5695),(124257,1615),(124258,1775),(124259,1785),(124260,5414),(124261,5418),(124262,5419),(124263,5471),(124264,5472),(124265,5541),(124266,5542),(124267,5543),(124268,5544),(124269,5545),(124270,5605),(124271,5606),(124272,5608),(124273,5609),(124274,5610),(124275,5611),(124276,5614),(124277,5620),(124278,5682),(124279,5683),(124280,5684),(124281,5685),(124282,5686),(124283,5688),(124284,5697),(124285,5698),(124286,5699),(124287,5700),(124288,5709),(124289,5710),(124290,5711),(124291,5714),(124292,5716),(124293,5718),(124294,5720),(124295,5722),(124296,5724),(124297,5726),(124298,5728),(124299,5730),(124300,5732),(124301,5745),(124302,5746),(124303,5747),(124304,5749),(124305,5612),(124306,1148),(124307,5286),(124308,5274),(124309,5282),(124310,5283),(124311,5284),(124312,5369),(124313,5402),(124314,5531),(124315,5532),(124316,5533),(124317,5534),(124318,5535),(124319,5558),(124320,5563),(124321,5564),(124322,5566),(124323,5674),(124324,5675),(124325,5676),(124326,5677),(124327,5678),(124328,5679),(124329,5738),(124330,5434),(124331,5275),(124332,5276),(124333,5277),(124334,5338),(124335,5339),(124336,5340),(124337,5341),(124338,5342),(124339,5345),(124340,5346),(124341,5347),(124342,5348),(124343,5349),(124344,5350),(124345,5357),(124346,5358),(124347,5680),(124348,5681),(124349,5285),(124350,5287),(124351,5288),(124352,5289),(124353,5290),(124354,5291),(124355,5292),(124356,5293),(124357,5294),(124358,5296),(124359,5297),(124360,5298),(124361,5299),(124362,5300),(124363,5302),(124364,5303),(124365,5304),(124366,5305),(124367,5306),(124368,5537),(124369,5752),(124370,5401),(124371,5403),(124372,5404),(124373,5405),(124374,5406),(124375,5407),(124376,5409),(124377,5421),(124378,5422),(124379,5423),(124380,5424),(124381,5425),(124382,5426),(124383,5427),(124384,5429),(124385,5458),(124386,5463),(124387,5464),(124388,5553),(124389,5554),(124390,5555),(124391,5556),(124392,5557),(124393,5559),(124394,5560),(124395,5567),(124396,5568),(124397,5569),(124398,5590),(124399,4524),(124400,4572),(124401,1081),(124402,1196),(124403,1197),(124404,1198),(124405,1199),(124406,1201),(124407,1202),(124408,1203),(124409,1204),(124410,1205),(124411,1206),(124412,1207),(124413,1232),(124414,1243),(124415,1245),(124416,1289),(124417,1332),(124418,1346),(124419,1347),(124420,1349),(124421,1353),(124422,1354),(124423,1355),(124424,1356),(124425,1357),(124426,1358),(124427,1359),(124428,1360),(124429,1361),(124430,1362),(124431,1363),(124432,1364),(124433,1366),(124434,1367),(124435,1368),(124436,1387),(124437,1410),(124438,1411),(124439,1412),(124440,1413),(124441,1414),(124442,1415),(124443,1416),(124444,1437),(124445,1440),(124446,1443),(124447,1444),(124448,1453),(124449,1464),(124450,1468),(124451,5324),(124452,5328),(124453,5329),(124454,5370),(124455,5371),(124456,5372),(124457,5373),(124458,5374),(124459,5375),(124460,5477),(124461,5478),(124462,5479),(124463,5480),(124464,5481),(124465,5484),(124466,5485),(124467,5486),(124468,5487),(124469,5488),(124470,5704),(124471,5705),(124472,5706),(124473,1329),(124474,1333),(124475,1334),(124476,1335),(124477,1337),(124478,1339),(124479,1369),(124480,1370),(124481,1372),(124482,1373),(124483,1374),(124484,5103),(124485,5104),(124486,5274),(124487,1524),(124488,1672),(124489,1673),(124490,1674),(124491,1793),(124492,1794),(124493,1795),(124494,1081),(124495,5370),(124496,5332),(124497,1197),(124498,1332),(124499,1362),(124500,1367),(124501,51),(124502,51),(124503,51),(124504,51),(124505,51),(124506,51),(124507,51),(124508,51),(124509,583),(124510,584),(124511,600),(124512,602),(124513,605),(124514,606),(124515,608),(124516,777),(124517,778),(124518,779),(124519,780),(124520,783),(124521,787),(124522,789),(124523,798),(124524,799),(124525,800),(124526,801),(124527,802),(124528,803),(124529,804),(124530,821),(124531,822),(124532,823),(124533,830),(124534,831),(124535,832),(124536,833),(124537,856),(124538,866),(124539,867),(124540,868),(124541,1173),(124542,1175),(124543,1176),(124544,1177),(124545,1178),(124546,1179),(124547,1180),(124548,1181),(124549,1182),(124550,1183),(124551,1195),(124552,1196),(124553,1197),(124554,1198),(124555,1199),(124556,1200),(124557,1201),(124558,1202),(124559,1203),(124560,1204),(124561,1205),(124562,1206),(124563,1207),(124564,1210),(124565,1211),(124566,1212),(124567,1213),(124568,1214),(124569,1215),(124570,1216),(124571,1217),(124572,1218),(124573,1219),(124574,1220),(124575,1221),(124576,1222),(124577,1223),(124578,1224),(124579,1225),(124580,1226),(124581,1227),(124582,1228),(124583,1229),(124584,1230),(124585,1231),(124586,1232),(124587,1233),(124588,1234),(124589,1235),(124590,1236),(124591,1237),(124592,1238),(124593,1239),(124594,1240),(124595,1241),(124596,1242),(124597,1243),(124598,1244),(124599,1245),(124600,1246),(124601,1247),(124602,1248),(124603,1249),(124604,1250),(124605,1251),(124606,1252),(124607,1253),(124608,1254),(124609,1255),(124610,1256),(124611,1257),(124612,1258),(124613,1259),(124614,1260),(124615,1261),(124616,1262),(124617,1263),(124618,1264),(124619,1265),(124620,1266),(124621,1267),(124622,1268),(124623,1269),(124624,1270),(124625,1271),(124626,1272),(124627,1273),(124628,1274),(124629,1275),(124630,1276),(124631,1277),(124632,1278),(124633,1279),(124634,1280),(124635,1281),(124636,1282),(124637,1283),(124638,1284),(124639,1285),(124640,1286),(124641,1287),(124642,1288),(124643,1289),(124644,1290),(124645,1291),(124646,1292),(124647,1293),(124648,1294),(124649,1295),(124650,1296),(124651,1297),(124652,1298),(124653,1299),(124654,1300),(124655,1301),(124656,1302),(124657,1303),(124658,1304),(124659,1305),(124660,1306),(124661,1307),(124662,1308),(124663,1309),(124664,1310),(124665,1311),(124666,1312),(124667,1313),(124668,1314),(124669,1315),(124670,1316),(124671,1317),(124672,1318),(124673,1319),(124674,1320),(124675,1321),(124676,1322),(124677,1323),(124678,1332),(124679,1342),(124680,1346),(124681,1347),(124682,1349),(124683,1350),(124684,1351),(124685,1353),(124686,1354),(124687,1355),(124688,1356),(124689,1357),(124690,1358),(124691,1359),(124692,1360),(124693,1361),(124694,1362),(124695,1363),(124696,1364),(124697,1366),(124698,1367),(124699,1368),(124700,1371),(124701,1375),(124702,1376),(124703,1377),(124704,1379),(124705,1389),(124706,1390),(124707,1391),(124708,1392),(124709,1393),(124710,1394),(124711,1395),(124712,1397),(124713,1398),(124714,1400),(124715,1420),(124716,1421),(124717,1422),(124718,1423),(124719,1424),(124720,1425),(124721,1427),(124722,1428),(124723,1429),(124724,1430),(124725,1431),(124726,1432),(124727,1433),(124728,1434),(124729,1435),(124730,1442),(124731,1443),(124732,1444),(124733,1445),(124734,1446),(124735,1447),(124736,1448),(124737,1450),(124738,1451),(124739,1452),(124740,1454),(124741,1455),(124742,1456),(124743,1457),(124744,1462),(124745,1469),(124746,1749),(124747,4500),(124748,4501),(124749,4502),(124750,4503),(124751,4504),(124752,4505),(124753,4506),(124754,4507),(124755,4508),(124756,4509),(124757,4510),(124758,4511),(124759,4512),(124760,4513),(124761,4514),(124762,4515),(124763,4516),(124764,4517),(124765,4518),(124766,4519),(124767,4520),(124768,4522),(124769,4523),(124770,583),(124771,602),(124772,605),(124773,778),(124774,779),(124775,780),(124776,783),(124777,787),(124778,821),(124779,822),(124780,856),(124781,1166),(124782,1171),(124783,1172),(124784,1174),(124785,600),(124786,1166),(124787,1184),(124788,1185),(124789,1186),(124790,1187),(124791,1188),(124792,1189),(124793,1190),(124794,1191),(124795,1192),(124796,1193),(124797,1194),(124798,1208),(124799,1209),(124800,1324),(124801,1325),(124802,1326),(124803,1327),(124804,1328),(124805,1329),(124806,1330),(124807,1331),(124808,1333),(124809,1334),(124810,1335),(124811,4521),(124812,4524),(124813,4525),(124814,1185),(124815,1186),(124816,1187),(124817,1188),(124818,1189),(124819,1190),(124820,1192),(124821,1193),(124822,1194),(124823,398),(124824,399),(124825,403),(124826,404),(124827,406),(124828,407),(124829,411),(124830,412),(124831,413),(124832,414),(124833,420),(124834,421),(124835,424),(124836,425),(124837,431),(124838,462),(124839,471),(124840,481),(124841,500),(124842,501),(124843,517),(124844,616),(124845,635),(124846,643),(124847,644),(124848,661),(124849,663),(124850,665),(124851,666),(124852,669),(124853,671),(124854,673),(124855,675),(124856,676),(124857,677),(124858,678),(124859,679),(124860,680),(124861,1336),(124862,1337),(124863,1338),(124864,1339),(124865,1340),(124866,1341),(124867,1344),(124868,1345),(124869,1348),(124870,1352),(124871,1365),(124872,1369),(124873,1370),(124874,1372),(124875,1373),(124876,1374),(124877,1378),(124878,1380),(124879,1381),(124880,1382),(124881,1383),(124882,1384),(124883,1385),(124884,1386),(124885,1387),(124886,1388),(124887,1396),(124888,1399),(124889,1401),(124890,1402),(124891,1403),(124892,1404),(124893,1405),(124894,1406),(124895,1407),(124896,1408),(124897,1409),(124898,1410),(124899,1411),(124900,1412),(124901,1413),(124902,1414),(124903,1415),(124904,1416),(124905,1426),(124906,1436),(124907,1437),(124908,1438),(124909,1439),(124910,1440),(124911,1449),(124912,1453),(124913,1458),(124914,1459),(124915,1460),(124916,1461),(124917,1463),(124918,1464),(124919,1465),(124920,1466),(124921,1467),(124922,1468),(124923,1522),(124924,1523),(124925,1524),(124926,1525),(124927,1526),(124928,1527),(124929,1528),(124930,1529),(124931,1530),(124932,1531),(124933,1532),(124934,1534),(124935,1535),(124936,1536),(124937,1557),(124938,1558),(124939,1559),(124940,1562),(124941,1587),(124942,1661),(124943,1662),(124944,1663),(124945,1664),(124946,1667),(124947,1668),(124948,1669),(124949,1670),(124950,1671),(124951,1672),(124952,1673),(124953,1674),(124954,1740),(124955,1743),(124956,1744),(124957,1745),(124958,1746),(124959,1747),(124960,1750),(124961,1780),(124962,1781),(124963,1782),(124964,1793),(124965,1794),(124966,1795),(124967,1799),(124968,1800),(124969,1801),(124970,1802),(124971,5355),(124972,5370),(124973,5371),(124974,5482),(124975,5483),(124976,5520),(124977,5521),(124978,5522),(124979,5523),(124980,5704),(124981,5705),(124982,5706),(124983,1518),(124984,1519),(124985,1520),(124986,1521),(124987,1533),(124988,1563),(124989,1564),(124990,1565),(124991,1566),(124992,1658),(124993,1659),(124994,1660),(124995,1665),(124996,1666),(124997,1675),(124998,1676),(124999,1677),(125000,1678),(125001,1751),(125002,1752),(125003,1753),(125004,1754),(125005,1756),(125006,1757),(125007,1758),(125008,1761),(125009,1762),(125010,1778),(125011,1779),(125012,1786),(125013,1787),(125014,1788),(125015,1789),(125016,1790),(125017,5323),(125018,5324),(125019,5325),(125020,5326),(125021,5327),(125022,5328),(125023,5329),(125024,5330),(125025,5331),(125026,5332),(125027,5333),(125028,5334),(125029,5335),(125030,5336),(125031,5337),(125032,5351),(125033,5352),(125034,5354),(125035,5356),(125036,5372),(125037,5373),(125038,5374),(125039,5375),(125040,5376),(125041,5377),(125042,5390),(125043,5474),(125044,5475),(125045,5476),(125046,5477),(125047,5478),(125048,5479),(125049,5480),(125050,5481),(125051,5484),(125052,5485),(125053,5486),(125054,5487),(125055,5488),(125056,5726),(125057,5726),(125058,5726),(125059,5726),(125060,5718),(125061,5718),(125062,5718),(125063,5718),(125064,5718),(125065,5718),(125066,5718),(125067,5718),(125068,5718),(125069,5718),(125070,5718),(125071,5718),(125072,5718),(125073,5718),(125074,5718),(125075,5718),(125076,5718),(125077,5718),(125078,5718),(125079,1),(125080,2),(125081,3),(125082,4),(125083,5),(125084,6),(125085,7),(125086,8),(125087,9),(125088,10),(125089,11),(125090,12),(125091,13),(125092,14),(125093,15),(125094,16),(125095,17),(125096,18),(125097,19),(125098,20),(125099,21),(125100,22),(125101,23),(125102,24),(125103,25),(125104,26),(125105,27),(125106,28),(125107,29),(125108,30),(125109,31),(125110,32),(125111,33),(125112,34),(125113,35),(125114,36),(125115,37),(125116,38),(125117,39),(125118,40),(125119,41),(125120,42),(125121,43),(125122,44),(125123,45),(125124,46),(125125,47),(125126,48),(125127,49),(125128,50),(125129,51),(125130,52),(125131,53),(125132,54),(125133,55),(125134,56),(125135,57),(125136,58),(125137,59),(125138,60),(125139,61),(125140,62),(125141,63),(125142,64),(125143,65),(125144,66),(125145,67),(125146,68),(125147,69),(125148,70),(125149,71),(125150,72),(125151,73),(125152,74),(125153,75),(125154,76),(125155,77),(125156,78),(125157,79),(125158,80),(125159,81),(125160,82),(125161,83),(125162,84),(125163,85),(125164,86),(125165,87),(125166,88),(125167,89),(125168,90),(125169,91),(125170,92),(125171,93),(125172,94),(125173,95),(125174,96),(125175,97),(125176,98),(125177,99),(125178,100),(125179,101),(125180,102),(125181,103),(125182,104),(125183,105),(125184,106),(125185,107),(125186,108),(125187,109),(125188,110),(125189,111),(125190,112),(125191,113),(125192,114),(125193,115),(125194,116),(125195,117),(125196,118),(125197,119),(125198,120),(125199,121),(125200,122),(125201,123),(125202,124),(125203,125),(125204,126),(125205,127),(125206,128),(125207,129),(125208,130),(125209,131),(125210,132),(125211,133),(125212,134),(125213,135),(125214,136),(125215,137),(125216,138),(125217,139),(125218,140),(125219,141),(125220,142),(125221,143),(125222,144),(125223,145),(125224,146),(125225,147),(125226,148),(125227,149),(125228,150),(125229,151),(125230,152),(125231,153),(125232,154),(125233,155),(125234,156),(125235,157),(125236,158),(125237,159),(125238,160),(125239,161),(125240,162),(125241,163),(125242,164),(125243,165),(125244,166),(125245,167),(125246,168),(125247,169),(125248,170),(125249,171),(125250,172),(125251,173),(125252,174),(125253,175),(125254,176),(125255,177),(125256,178),(125257,179),(125258,180),(125259,181),(125260,182),(125261,183),(125262,184),(125263,185),(125264,186),(125265,187),(125266,188),(125267,189),(125268,190),(125269,191),(125270,192),(125271,193),(125272,194),(125273,195),(125274,196),(125275,197),(125276,198),(125277,199),(125278,200),(125279,201),(125280,202),(125281,203),(125282,204),(125283,205),(125284,206),(125285,207),(125286,208),(125287,209),(125288,210),(125289,211),(125290,212),(125291,213),(125292,214),(125293,215),(125294,216),(125295,217),(125296,218),(125297,219),(125298,220),(125299,221),(125300,222),(125301,223),(125302,224),(125303,225),(125304,226),(125305,227),(125306,228),(125307,229),(125308,230),(125309,231),(125310,232),(125311,233),(125312,234),(125313,235),(125314,236),(125315,237),(125316,238),(125317,239),(125318,240),(125319,241),(125320,242),(125321,243),(125322,244),(125323,245),(125324,246),(125325,247),(125326,248),(125327,249),(125328,250),(125329,251),(125330,252),(125331,253),(125332,254),(125333,255),(125334,256),(125335,257),(125336,258),(125337,259),(125338,260),(125339,261),(125340,262),(125341,263),(125342,264),(125343,265),(125344,266),(125345,267),(125346,268),(125347,269),(125348,270),(125349,271),(125350,272),(125351,273),(125352,274),(125353,275),(125354,276),(125355,277),(125356,278),(125357,279),(125358,280),(125359,281),(125360,282),(125361,283),(125362,284),(125363,285),(125364,286),(125365,287),(125366,288),(125367,289),(125368,290),(125369,291),(125370,292),(125371,293),(125372,294),(125373,295),(125374,296),(125375,297),(125376,298),(125377,299),(125378,300),(125379,301),(125380,302),(125381,303),(125382,304),(125383,305),(125384,306),(125385,307),(125386,308),(125387,309),(125388,310),(125389,311),(125390,312),(125391,313),(125392,314),(125393,315),(125394,316),(125395,317),(125396,318),(125397,319),(125398,320),(125399,321),(125400,322),(125401,323),(125402,324),(125403,325),(125404,326),(125405,327),(125406,328),(125407,329),(125408,330),(125409,331),(125410,332),(125411,333),(125412,334),(125413,335),(125414,336),(125415,337),(125416,338),(125417,339),(125418,340),(125419,341),(125420,342),(125421,343),(125422,344),(125423,345),(125424,346),(125425,347),(125426,348),(125427,349),(125428,350),(125429,351),(125430,352),(125431,353),(125432,354),(125433,355),(125434,356),(125435,357),(125436,358),(125437,359),(125438,360),(125439,361),(125440,362),(125441,363),(125442,364),(125443,365),(125444,366),(125445,367),(125446,368),(125447,369),(125448,370),(125449,371),(125450,372),(125451,373),(125452,374),(125453,375),(125454,376),(125455,377),(125456,378),(125457,379),(125458,380),(125459,381),(125460,382),(125461,383),(125462,384),(125463,385),(125464,386),(125465,387),(125466,388),(125467,389),(125468,390),(125469,391),(125470,392),(125471,393),(125472,394),(125473,395),(125474,396),(125475,397),(125476,398),(125477,399),(125478,400),(125479,401),(125480,402),(125481,403),(125482,404),(125483,405),(125484,406),(125485,407),(125486,408),(125487,409),(125488,410),(125489,411),(125490,412),(125491,413),(125492,414),(125493,415),(125494,416),(125495,417),(125496,418),(125497,419),(125498,420),(125499,421),(125500,422),(125501,423),(125502,424),(125503,425),(125504,426),(125505,427),(125506,428),(125507,429),(125508,430),(125509,431),(125510,432),(125511,433),(125512,434),(125513,435),(125514,436),(125515,437),(125516,438),(125517,439),(125518,440),(125519,441),(125520,442),(125521,443),(125522,444),(125523,445),(125524,446),(125525,447),(125526,448),(125527,449),(125528,450),(125529,451),(125530,452),(125531,453),(125532,454),(125533,455),(125534,456),(125535,457),(125536,458),(125537,459),(125538,460),(125539,461),(125540,462),(125541,463),(125542,464),(125543,465),(125544,466),(125545,467),(125546,468),(125547,469),(125548,470),(125549,471),(125550,472),(125551,473),(125552,474),(125553,475),(125554,476),(125555,477),(125556,478),(125557,479),(125558,480),(125559,481),(125560,482),(125561,483),(125562,484),(125563,485),(125564,486),(125565,487),(125566,488),(125567,489),(125568,490),(125569,491),(125570,492),(125571,493),(125572,494),(125573,495),(125574,496),(125575,497),(125576,498),(125577,499),(125578,500),(125579,501),(125580,502),(125581,503),(125582,504),(125583,505),(125584,506),(125585,507),(125586,508),(125587,509),(125588,510),(125589,511),(125590,512),(125591,513),(125592,514),(125593,515),(125594,516),(125595,517),(125596,518),(125597,519),(125598,520),(125599,521),(125600,522),(125601,523),(125602,524),(125603,525),(125604,526),(125605,527),(125606,528),(125607,529),(125608,530),(125609,531),(125610,532),(125611,533),(125612,534),(125613,535),(125614,536),(125615,537),(125616,538),(125617,539),(125618,540),(125619,541),(125620,542),(125621,543),(125622,544),(125623,545),(125624,546),(125625,547),(125626,548),(125627,549),(125628,550),(125629,551),(125630,552),(125631,553),(125632,554),(125633,555),(125634,556),(125635,557),(125636,558),(125637,559),(125638,560),(125639,561),(125640,562),(125641,563),(125642,564),(125643,565),(125644,566),(125645,567),(125646,568),(125647,569),(125648,570),(125649,571),(125650,572),(125651,573),(125652,574),(125653,575),(125654,576),(125655,577),(125656,578),(125657,579),(125658,580),(125659,581),(125660,582),(125661,583),(125662,584),(125663,585),(125664,586),(125665,587),(125666,588),(125667,589),(125668,590),(125669,591),(125670,592),(125671,593),(125672,594),(125673,595),(125674,596),(125675,597),(125676,598),(125677,599),(125678,600),(125679,601),(125680,602),(125681,603),(125682,604),(125683,605),(125684,606),(125685,607),(125686,608),(125687,609),(125688,610),(125689,611),(125690,612),(125691,613),(125692,614),(125693,615),(125694,616),(125695,617),(125696,618),(125697,619),(125698,620),(125699,621),(125700,622),(125701,623),(125702,624),(125703,625),(125704,626),(125705,627),(125706,628),(125707,629),(125708,630),(125709,631),(125710,632),(125711,633),(125712,634),(125713,635),(125714,636),(125715,637),(125716,638),(125717,639),(125718,640),(125719,641),(125720,642),(125721,643),(125722,644),(125723,645),(125724,646),(125725,647),(125726,648),(125727,649),(125728,650),(125729,651),(125730,652),(125731,653),(125732,654),(125733,655),(125734,656),(125735,657),(125736,658),(125737,659),(125738,660),(125739,661),(125740,662),(125741,663),(125742,664),(125743,665),(125744,666),(125745,667),(125746,668),(125747,669),(125748,670),(125749,671),(125750,672),(125751,673),(125752,674),(125753,675),(125754,676),(125755,677),(125756,678),(125757,679),(125758,680),(125759,681),(125760,682),(125761,683),(125762,684),(125763,685),(125764,686),(125765,687),(125766,688),(125767,689),(125768,690),(125769,691),(125770,692),(125771,693),(125772,694),(125773,695),(125774,696),(125775,697),(125776,698),(125777,699),(125778,700),(125779,701),(125780,702),(125781,703),(125782,704),(125783,705),(125784,706),(125785,707),(125786,708),(125787,709),(125788,710),(125789,711),(125790,712),(125791,713),(125792,714),(125793,715),(125794,716),(125795,717),(125796,718),(125797,719),(125798,720),(125799,721),(125800,722),(125801,723),(125802,724),(125803,725),(125804,726),(125805,727),(125806,728),(125807,729),(125808,730),(125809,731),(125810,732),(125811,733),(125812,734),(125813,735),(125814,736),(125815,737),(125816,738),(125817,739),(125818,740),(125819,741),(125820,742),(125821,743),(125822,744),(125823,745),(125824,746),(125825,747),(125826,748),(125827,749),(125828,750),(125829,751),(125830,752),(125831,753),(125832,754),(125833,755),(125834,756),(125835,757),(125836,758),(125837,759),(125838,760),(125839,761),(125840,762),(125841,763),(125842,764),(125843,765),(125844,766),(125845,767),(125846,768),(125847,769),(125848,770),(125849,771),(125850,772),(125851,773),(125852,774),(125853,775),(125854,776),(125855,777),(125856,778),(125857,779),(125858,780),(125859,781),(125860,782),(125861,783),(125862,784),(125863,785),(125864,786),(125865,787),(125866,788),(125867,789),(125868,790),(125869,791),(125870,792),(125871,793),(125872,794),(125873,795),(125874,796),(125875,797),(125876,798),(125877,799),(125878,800),(125879,801),(125880,802),(125881,803),(125882,804),(125883,805),(125884,806),(125885,807),(125886,808),(125887,809),(125888,810),(125889,811),(125890,812),(125891,813),(125892,814),(125893,815),(125894,816),(125895,817),(125896,818),(125897,819),(125898,820),(125899,821),(125900,822),(125901,823),(125902,824),(125903,825),(125904,826),(125905,827),(125906,828),(125907,829),(125908,830),(125909,831),(125910,832),(125911,833),(125912,834),(125913,835),(125914,836),(125915,837),(125916,838),(125917,839),(125918,840),(125919,841),(125920,842),(125921,843),(125922,844),(125923,845),(125924,846),(125925,847),(125926,848),(125927,849),(125928,850),(125929,851),(125930,852),(125931,853),(125932,854),(125933,855),(125934,856),(125935,857),(125936,858),(125937,859),(125938,860),(125939,861),(125940,862),(125941,863),(125942,864),(125943,865),(125944,866),(125945,867),(125946,868),(125947,869),(125948,870),(125949,871),(125950,872),(125951,873),(125952,874),(125953,875),(125954,876),(125955,877),(125956,878),(125957,879),(125958,880),(125959,881),(125960,882),(125961,883),(125962,884),(125963,885),(125964,886),(125965,887),(125966,888),(125967,889),(125968,890),(125969,891),(125970,892),(125971,893),(125972,894),(125973,895),(125974,896),(125975,897),(125976,898),(125977,899),(125978,900),(125979,901),(125980,902),(125981,903),(125982,904),(125983,905),(125984,906),(125985,907),(125986,908),(125987,909),(125988,910),(125989,911),(125990,912),(125991,913),(125992,914),(125993,915),(125994,916),(125995,917),(125996,918),(125997,919),(125998,920),(125999,921),(126000,922),(126001,923),(126002,924),(126003,925),(126004,926),(126005,927),(126006,928),(126007,929),(126008,930),(126009,931),(126010,932),(126011,933),(126012,934),(126013,935),(126014,936),(126015,937),(126016,938),(126017,939),(126018,940),(126019,941),(126020,942),(126021,943),(126022,944),(126023,945),(126024,946),(126025,947),(126026,948),(126027,949),(126028,950),(126029,951),(126030,952),(126031,953),(126032,954),(126033,955),(126034,956),(126035,957),(126036,958),(126037,959),(126038,960),(126039,961),(126040,962),(126041,963),(126042,964),(126043,965),(126044,966),(126045,967),(126046,968),(126047,969),(126048,970),(126049,971),(126050,972),(126051,973),(126052,974),(126053,975),(126054,976),(126055,977),(126056,978),(126057,979),(126058,980),(126059,981),(126060,982),(126061,983),(126062,984),(126063,985),(126064,986),(126065,987),(126066,988),(126067,989),(126068,990),(126069,991),(126070,992),(126071,993),(126072,994),(126073,995),(126074,996),(126075,997),(126076,998),(126077,999),(126078,1000),(126079,1001),(126080,1002),(126081,1003),(126082,1004),(126083,1005),(126084,1006),(126085,1007),(126086,1008),(126087,1009),(126088,1010),(126089,1011),(126090,1012),(126091,1013),(126092,1014),(126093,1015),(126094,1016),(126095,1017),(126096,1018),(126097,1019),(126098,1020),(126099,1021),(126100,1022),(126101,1023),(126102,1024),(126103,1025),(126104,1026),(126105,1027),(126106,1028),(126107,1029),(126108,1030),(126109,1031),(126110,1032),(126111,1033),(126112,1034),(126113,1035),(126114,1036),(126115,1037),(126116,1038),(126117,1039),(126118,1040),(126119,1041),(126120,1042),(126121,1043),(126122,1044),(126123,1045),(126124,1046),(126125,1047),(126126,1048),(126127,1049),(126128,1050),(126129,1051),(126130,1052),(126131,1053),(126132,1054),(126133,1055),(126134,1056),(126135,1057),(126136,1058),(126137,1059),(126138,1060),(126139,1061),(126140,1062),(126141,1063),(126142,1064),(126143,1065),(126144,1066),(126145,1067),(126146,1068),(126147,1069),(126148,1070),(126149,1071),(126150,1072),(126151,1073),(126152,1074),(126153,1075),(126154,1076),(126155,1077),(126156,1078),(126157,1079),(126158,1080),(126159,1081),(126160,1082),(126161,1083),(126162,1084),(126163,1085),(126164,1086),(126165,1087),(126166,1088),(126167,1089),(126168,1090),(126169,1091),(126170,1092),(126171,1093),(126172,1094),(126173,1095),(126174,1096),(126175,1097),(126176,1098),(126177,1099),(126178,1100),(126179,1101),(126180,1102),(126181,1103),(126182,1104),(126183,1105),(126184,1106),(126185,1107),(126186,1108),(126187,1109),(126188,1110),(126189,1111),(126190,1112),(126191,1113),(126192,1114),(126193,1115),(126194,1116),(126195,1117),(126196,1118),(126197,1119),(126198,1120),(126199,1121),(126200,1122),(126201,1123),(126202,1124),(126203,1125),(126204,1126),(126205,1127),(126206,1128),(126207,1129),(126208,1130),(126209,1131),(126210,1132),(126211,1133),(126212,1134),(126213,1135),(126214,1136),(126215,1137),(126216,1138),(126217,1139),(126218,1140),(126219,1141),(126220,1142),(126221,1143),(126222,1144),(126223,1145),(126224,1146),(126225,1147),(126226,1148),(126227,1149),(126228,1150),(126229,1151),(126230,1152),(126231,1153),(126232,1154),(126233,1155),(126234,1156),(126235,1157),(126236,1158),(126237,1159),(126238,1160),(126239,1161),(126240,1162),(126241,1163),(126242,1164),(126243,1165),(126244,1166),(126245,1167),(126246,1168),(126247,1169),(126248,1170),(126249,1171),(126250,1172),(126251,1173),(126252,1174),(126253,1175),(126254,1176),(126255,1177),(126256,1178),(126257,1179),(126258,1180),(126259,1181),(126260,1182),(126261,1183),(126262,1184),(126263,1185),(126264,1186),(126265,1187),(126266,1188),(126267,1189),(126268,1190),(126269,1191),(126270,1192),(126271,1193),(126272,1194),(126273,1195),(126274,1196),(126275,1197),(126276,1198),(126277,1199),(126278,1200),(126279,1201),(126280,1202),(126281,1203),(126282,1204),(126283,1205),(126284,1206),(126285,1207),(126286,1208),(126287,1209),(126288,1210),(126289,1211),(126290,1212),(126291,1213),(126292,1214),(126293,1215),(126294,1216),(126295,1217),(126296,1218),(126297,1219),(126298,1220),(126299,1221),(126300,1222),(126301,1223),(126302,1224),(126303,1225),(126304,1226),(126305,1227),(126306,1228),(126307,1229),(126308,1230),(126309,1231),(126310,1232),(126311,1233),(126312,1234),(126313,1235),(126314,1236),(126315,1237),(126316,1238),(126317,1239),(126318,1240),(126319,1241),(126320,1242),(126321,1243),(126322,1244),(126323,1245),(126324,1246),(126325,1247),(126326,1248),(126327,1249),(126328,1250),(126329,1251),(126330,1252),(126331,1253),(126332,1254),(126333,1255),(126334,1256),(126335,1257),(126336,1258),(126337,1259),(126338,1260),(126339,1261),(126340,1262),(126341,1263),(126342,1264),(126343,1265),(126344,1266),(126345,1267),(126346,1268),(126347,1269),(126348,1270),(126349,1271),(126350,1272),(126351,1273),(126352,1274),(126353,1275),(126354,1276),(126355,1277),(126356,1278),(126357,1279),(126358,1280),(126359,1281),(126360,1282),(126361,1283),(126362,1284),(126363,1285),(126364,1286),(126365,1287),(126366,1288),(126367,1289),(126368,1290),(126369,1291),(126370,1292),(126371,1293),(126372,1294),(126373,1295),(126374,1296),(126375,1297),(126376,1298),(126377,1299),(126378,1300),(126379,1301),(126380,1302),(126381,1303),(126382,1304),(126383,1305),(126384,1306),(126385,1307),(126386,1308),(126387,1309),(126388,1310),(126389,1311),(126390,1312),(126391,1313),(126392,1314),(126393,1315),(126394,1316),(126395,1317),(126396,1318),(126397,1319),(126398,1320),(126399,1321),(126400,1322),(126401,1323),(126402,1324),(126403,1325),(126404,1326),(126405,1327),(126406,1328),(126407,1329),(126408,1330),(126409,1331),(126410,1332),(126411,1333),(126412,1334),(126413,1335),(126414,1336),(126415,1337),(126416,1338),(126417,1339),(126418,1340),(126419,1341),(126420,1342),(126421,1343),(126422,1344),(126423,1345),(126424,1346),(126425,1347),(126426,1348),(126427,1349),(126428,1350),(126429,1351),(126430,1352),(126431,1353),(126432,1354),(126433,1355),(126434,1356),(126435,1357),(126436,1358),(126437,1359),(126438,1360),(126439,1361),(126440,1362),(126441,1363),(126442,1364),(126443,1365),(126444,1366),(126445,1367),(126446,1368),(126447,1369),(126448,1370),(126449,1371),(126450,1372),(126451,1373),(126452,1374),(126453,1375),(126454,1376),(126455,1377),(126456,1378),(126457,1379),(126458,1380),(126459,1381),(126460,1382),(126461,1383),(126462,1384),(126463,1385),(126464,1386),(126465,1387),(126466,1388),(126467,1389),(126468,1390),(126469,1391),(126470,1392),(126471,1393),(126472,1394),(126473,1395),(126474,1396),(126475,1397),(126476,1398),(126477,1399),(126478,1400),(126479,1401),(126480,1402),(126481,1403),(126482,1404),(126483,1405),(126484,1406),(126485,1407),(126486,1408),(126487,1409),(126488,1410),(126489,1411),(126490,1412),(126491,1413),(126492,1414),(126493,1415),(126494,1416),(126495,1417),(126496,1418),(126497,1419),(126498,1420),(126499,1421),(126500,1422),(126501,1423),(126502,1424),(126503,1425),(126504,1426),(126505,1427),(126506,1428),(126507,1429),(126508,1430),(126509,1431),(126510,1432),(126511,1433),(126512,1434),(126513,1435),(126514,1436),(126515,1437),(126516,1438),(126517,1439),(126518,1440),(126519,1441),(126520,1442),(126521,1443),(126522,1444),(126523,1445),(126524,1446),(126525,1447),(126526,1448),(126527,1449),(126528,1450),(126529,1451),(126530,1452),(126531,1453),(126532,1454),(126533,1455),(126534,1456),(126535,1457),(126536,1458),(126537,1459),(126538,1460),(126539,1461),(126540,1462),(126541,1463),(126542,1464),(126543,1465),(126544,1466),(126545,1467),(126546,1468),(126547,1469),(126548,1470),(126549,1471),(126550,1472),(126551,1473),(126552,1474),(126553,1475),(126554,1476),(126555,1477),(126556,1478),(126557,1479),(126558,1480),(126559,1481),(126560,1482),(126561,1483),(126562,1484),(126563,1485),(126564,1486),(126565,1487),(126566,1488),(126567,1489),(126568,1490),(126569,1491),(126570,1492),(126571,1493),(126572,1494),(126573,1495),(126574,1496),(126575,1497),(126576,1498),(126577,1499),(126578,1500),(126579,1501),(126580,1502),(126581,1503),(126582,1504),(126583,1505),(126584,1506),(126585,1507),(126586,1508),(126587,1509),(126588,1510),(126589,1511),(126590,1512),(126591,1513),(126592,1514),(126593,1515),(126594,1516),(126595,1517),(126596,1518),(126597,1519),(126598,1520),(126599,1521),(126600,1522),(126601,1523),(126602,1524),(126603,1525),(126604,1526),(126605,1527),(126606,1528),(126607,1529),(126608,1530),(126609,1531),(126610,1532),(126611,1533),(126612,1534),(126613,1535),(126614,1536),(126615,1537),(126616,1538),(126617,1539),(126618,1540),(126619,1541),(126620,1542),(126621,1543),(126622,1544),(126623,1545),(126624,1546),(126625,1547),(126626,1548),(126627,1549),(126628,1550),(126629,1551),(126630,1552),(126631,1553),(126632,1554),(126633,1555),(126634,1556),(126635,1557),(126636,1558),(126637,1559),(126638,1560),(126639,1561),(126640,1562),(126641,1563),(126642,1564),(126643,1565),(126644,1566),(126645,1567),(126646,1568),(126647,1569),(126648,1570),(126649,1571),(126650,1572),(126651,1573),(126652,1574),(126653,1575),(126654,1576),(126655,1577),(126656,1578),(126657,1579),(126658,1580),(126659,1581),(126660,1582),(126661,1583),(126662,1584),(126663,1585),(126664,1586),(126665,1587),(126666,1588),(126667,1589),(126668,1590),(126669,1591),(126670,1592),(126671,1593),(126672,1594),(126673,1595),(126674,1596),(126675,1597),(126676,1598),(126677,1599),(126678,1600),(126679,1601),(126680,1602),(126681,1603),(126682,1604),(126683,1605),(126684,1606),(126685,1607),(126686,1608),(126687,1609),(126688,1610),(126689,1611),(126690,1612),(126691,1613),(126692,1614),(126693,1615),(126694,1616),(126695,1617),(126696,1618),(126697,1619),(126698,1620),(126699,1621),(126700,1622),(126701,1623),(126702,1624),(126703,1625),(126704,1626),(126705,1627),(126706,1628),(126707,1629),(126708,1630),(126709,1631),(126710,1632),(126711,1633),(126712,1634),(126713,1635),(126714,1636),(126715,1637),(126716,1638),(126717,1639),(126718,1640),(126719,1641),(126720,1642),(126721,1643),(126722,1644),(126723,1645),(126724,1646),(126725,1647),(126726,1648),(126727,1649),(126728,1650),(126729,1651),(126730,1652),(126731,1653),(126732,1654),(126733,1655),(126734,1656),(126735,1657),(126736,1658),(126737,1659),(126738,1660),(126739,1661),(126740,1662),(126741,1663),(126742,1664),(126743,1665),(126744,1666),(126745,1667),(126746,1668),(126747,1669),(126748,1670),(126749,1671),(126750,1672),(126751,1673),(126752,1674),(126753,1675),(126754,1676),(126755,1677),(126756,1678),(126757,1679),(126758,1680),(126759,1681),(126760,1682),(126761,1683),(126762,1684),(126763,1685),(126764,1686),(126765,1687),(126766,1688),(126767,1689),(126768,1690),(126769,1691),(126770,1692),(126771,1693),(126772,1694),(126773,1695),(126774,1696),(126775,1697),(126776,1698),(126777,1699),(126778,1700),(126779,1701),(126780,1702),(126781,1703),(126782,1704),(126783,1705),(126784,1706),(126785,1707),(126786,1708),(126787,1709),(126788,1710),(126789,1711),(126790,1712),(126791,1713),(126792,1714),(126793,1715),(126794,1716),(126795,1717),(126796,1718),(126797,1719),(126798,1720),(126799,1721),(126800,1722),(126801,1723),(126802,1724),(126803,1725),(126804,1726),(126805,1727),(126806,1728),(126807,1729),(126808,1730),(126809,1731),(126810,1732),(126811,1733),(126812,1734),(126813,1735),(126814,1736),(126815,1737),(126816,1738),(126817,1739),(126818,1740),(126819,1741),(126820,1742),(126821,1743),(126822,1744),(126823,1745),(126824,1746),(126825,1747),(126826,1748),(126827,1749),(126828,1750),(126829,1751),(126830,1752),(126831,1753),(126832,1754),(126833,1755),(126834,1756),(126835,1757),(126836,1758),(126837,1759),(126838,1760),(126839,1761),(126840,1762),(126841,1763),(126842,1764),(126843,1765),(126844,1766),(126845,1767),(126846,1768),(126847,1769),(126848,1770),(126849,1771),(126850,1772),(126851,1773),(126852,1774),(126853,1775),(126854,1776),(126855,1777),(126856,1778),(126857,1779),(126858,1780),(126859,1781),(126860,1782),(126861,1783),(126862,1784),(126863,1785),(126864,1786),(126865,1787),(126866,1788),(126867,1789),(126868,1790),(126869,1791),(126870,1792),(126871,1793),(126872,1794),(126873,1795),(126874,1796),(126875,1797),(126876,1798),(126877,1799),(126878,1800),(126879,1801),(126880,1802),(126881,1803),(126882,1804),(126883,1805),(126884,1806),(126885,1807),(126886,1808),(126887,1809),(126888,1810),(126889,1811),(126890,1812),(126891,1813),(126892,1814),(126893,1815),(126894,1816),(126895,1817),(126896,1818),(126897,1819),(126898,1820),(126899,1821),(126900,1822),(126901,1823),(126902,1824),(126903,1825),(126904,1826),(126905,1827),(126906,1828),(126907,1829),(126908,1830),(126909,1831),(126910,1832),(126911,1833),(126912,1834),(126913,1835),(126914,1836),(126915,1837),(126916,1838),(126917,1839),(126918,1840),(126919,1841),(126920,1842),(126921,1843),(126922,1844),(126923,1845),(126924,1846),(126925,1847),(126926,1848),(126927,1849),(126928,1850),(126929,1851),(126930,1852),(126931,1853),(126932,1854),(126933,1855),(126934,1856),(126935,1857),(126936,1858),(126937,1859),(126938,1860),(126939,1861),(126940,1862),(126941,1863),(126942,1864),(126943,1865),(126944,1866),(126945,1867),(126946,1868),(126947,1869),(126948,1870),(126949,1871),(126950,1872),(126951,1873),(126952,1874),(126953,1875),(126954,1876),(126955,1877),(126956,1878),(126957,1879),(126958,1880),(126959,1881),(126960,1882),(126961,1883),(126962,1884),(126963,1885),(126964,1886),(126965,1887),(126966,1888),(126967,1889),(126968,1890),(126969,1891),(126970,1892),(126971,1893),(126972,1894),(126973,1895),(126974,1896),(126975,1897),(126976,1898),(126977,1899),(126978,1900),(126979,1901),(126980,1902),(126981,1903),(126982,1904),(126983,1905),(126984,1906),(126985,1907),(126986,1908),(126987,1909),(126988,1910),(126989,1911),(126990,1912),(126991,1913),(126992,1914),(126993,1915),(126994,1916),(126995,1917),(126996,1918),(126997,1919),(126998,1920),(126999,1921),(127000,1922),(127001,1923),(127002,1924),(127003,1925),(127004,1926),(127005,1927),(127006,1928),(127007,1929),(127008,1930),(127009,1931),(127010,1932),(127011,1933),(127012,1934),(127013,1935),(127014,1936),(127015,1937),(127016,1938),(127017,1939),(127018,1940),(127019,1941),(127020,1942),(127021,1943),(127022,1944),(127023,1945),(127024,1946),(127025,1947),(127026,1948),(127027,1949),(127028,1950),(127029,1951),(127030,1952),(127031,1953),(127032,1954),(127033,1955),(127034,1956),(127035,1957),(127036,1958),(127037,1959),(127038,1960),(127039,1961),(127040,1962),(127041,1963),(127042,1964),(127043,1965),(127044,1966),(127045,1967),(127046,1968),(127047,1969),(127048,1970),(127049,1971),(127050,1972),(127051,1973),(127052,1974),(127053,1975),(127054,1976),(127055,1977),(127056,1978),(127057,1979),(127058,1980),(127059,1981),(127060,1982),(127061,1983),(127062,1984),(127063,1985),(127064,1986),(127065,1987),(127066,1988),(127067,1989),(127068,1990),(127069,1991),(127070,1992),(127071,1993),(127072,1994),(127073,1995),(127074,1996),(127075,1997),(127076,1998),(127077,1999),(127078,2000),(127079,2001),(127080,2002),(127081,2003),(127082,2004),(127083,2005),(127084,2006),(127085,2007),(127086,2008),(127087,2009),(127088,2010),(127089,2011),(127090,2012),(127091,2013),(127092,2014),(127093,2015),(127094,2016),(127095,2017),(127096,2018),(127097,2019),(127098,2020),(127099,2021),(127100,2022),(127101,2023),(127102,2024),(127103,2025),(127104,2026),(127105,2027),(127106,2028),(127107,2029),(127108,2030),(127109,2031),(127110,2032),(127111,2033),(127112,2034),(127113,2035),(127114,2036),(127115,2037),(127116,2038),(127117,2039),(127118,2040),(127119,2041),(127120,2042),(127121,2043),(127122,2044),(127123,2045),(127124,2046),(127125,2047),(127126,2048),(127127,2049),(127128,2050),(127129,2051),(127130,2052),(127131,2053),(127132,2054),(127133,2055),(127134,2056),(127135,2057),(127136,2058),(127137,2059),(127138,2060),(127139,2061),(127140,2062),(127141,2063),(127142,2064),(127143,2065),(127144,2066),(127145,2067),(127146,2068),(127147,2069),(127148,2070),(127149,2071),(127150,2072),(127151,2073),(127152,2074),(127153,2075),(127154,2076),(127155,2077),(127156,2078),(127157,2079),(127158,2080),(127159,2081),(127160,2082),(127161,2083),(127162,2084),(127163,2085),(127164,2086),(127165,2087),(127166,2088),(127167,2089),(127168,2090),(127169,2091),(127170,2092),(127171,2093),(127172,2094),(127173,2095),(127174,2096),(127175,2097),(127176,2098),(127177,2099),(127178,2100),(127179,2101),(127180,2102),(127181,2103),(127182,2104),(127183,2105),(127184,2106),(127185,2107),(127186,2108),(127187,2109),(127188,2110),(127189,2111),(127190,2112),(127191,2113),(127192,2114),(127193,2115),(127194,2116),(127195,2117),(127196,2118),(127197,2119),(127198,2120),(127199,2121),(127200,2122),(127201,2123),(127202,2124),(127203,2125),(127204,2126),(127205,2127),(127206,2128),(127207,2129),(127208,2130),(127209,2131),(127210,2132),(127211,2133),(127212,2134),(127213,2135),(127214,2136),(127215,2137),(127216,2138),(127217,2139),(127218,2140),(127219,2141),(127220,2142),(127221,2143),(127222,2144),(127223,2145),(127224,2146),(127225,2147),(127226,2148),(127227,2149),(127228,2150),(127229,2151),(127230,2152),(127231,2153),(127232,2154),(127233,2155),(127234,2156),(127235,2157),(127236,2158),(127237,2159),(127238,2160),(127239,2161),(127240,2162),(127241,2163),(127242,2164),(127243,2165),(127244,2166),(127245,2167),(127246,2168),(127247,2169),(127248,2170),(127249,2171),(127250,2172),(127251,2173),(127252,2174),(127253,2175),(127254,2176),(127255,2177),(127256,2178),(127257,2179),(127258,2180),(127259,2181),(127260,2182),(127261,2183),(127262,2184),(127263,2185),(127264,2186),(127265,2187),(127266,2188),(127267,2189),(127268,2190),(127269,2191),(127270,2192),(127271,2193),(127272,2194),(127273,2195),(127274,2196),(127275,2197),(127276,2198),(127277,2199),(127278,2200),(127279,2201),(127280,2202),(127281,2203),(127282,2204),(127283,2205),(127284,2206),(127285,2207),(127286,2208),(127287,2209),(127288,2210),(127289,2211),(127290,2212),(127291,2213),(127292,2214),(127293,2215),(127294,2216),(127295,2217),(127296,2218),(127297,2219),(127298,2220),(127299,2221),(127300,2222),(127301,2223),(127302,2224),(127303,2225),(127304,2226),(127305,2227),(127306,2228),(127307,2229),(127308,2230),(127309,2231),(127310,2232),(127311,2233),(127312,2234),(127313,2235),(127314,2236),(127315,2237),(127316,2238),(127317,2239),(127318,2240),(127319,2241),(127320,2242),(127321,2243),(127322,2244),(127323,2245),(127324,2246),(127325,2247),(127326,2248),(127327,2249),(127328,2250),(127329,2251),(127330,2252),(127331,2253),(127332,2254),(127333,2255),(127334,2256),(127335,2257),(127336,2258),(127337,2259),(127338,2260),(127339,2261),(127340,2262),(127341,2263),(127342,2264),(127343,2265),(127344,2266),(127345,2267),(127346,2268),(127347,2269),(127348,2270),(127349,2271),(127350,2272),(127351,2273),(127352,2274),(127353,2275),(127354,2276),(127355,2277),(127356,2278),(127357,2279),(127358,2280),(127359,2281),(127360,2282),(127361,2283),(127362,2284),(127363,2285),(127364,2286),(127365,2287),(127366,2288),(127367,2289),(127368,2290),(127369,2291),(127370,2292),(127371,2293),(127372,2294),(127373,2295),(127374,2296),(127375,2297),(127376,2298),(127377,2299),(127378,2300),(127379,2301),(127380,2302),(127381,2303),(127382,2304),(127383,2305),(127384,2306),(127385,2307),(127386,2308),(127387,2309),(127388,2310),(127389,2311),(127390,2312),(127391,2313),(127392,2314),(127393,2315),(127394,2316),(127395,2317),(127396,2318),(127397,2319),(127398,2320),(127399,2321),(127400,2322),(127401,2323),(127402,2324),(127403,2325),(127404,2326),(127405,2327),(127406,2328),(127407,2329),(127408,2330),(127409,2331),(127410,2332),(127411,2333),(127412,2334),(127413,2335),(127414,2336),(127415,2337),(127416,2338),(127417,2339),(127418,2340),(127419,2341),(127420,2342),(127421,2343),(127422,2344),(127423,2345),(127424,2346),(127425,2347),(127426,2348),(127427,2349),(127428,2350),(127429,2351),(127430,2352),(127431,2353),(127432,2354),(127433,2355),(127434,2356),(127435,2357),(127436,2358),(127437,2359),(127438,2360),(127439,2361),(127440,2362),(127441,2363),(127442,2364),(127443,2365),(127444,2366),(127445,2367),(127446,2368),(127447,2369),(127448,2370),(127449,2371),(127450,2372),(127451,2373),(127452,2374),(127453,2375),(127454,2376),(127455,2377),(127456,2378),(127457,2379),(127458,2380),(127459,2381),(127460,2382),(127461,2383),(127462,2384),(127463,2385),(127464,2386),(127465,2387),(127466,2388),(127467,2389),(127468,2390),(127469,2391),(127470,2392),(127471,2393),(127472,2394),(127473,2395),(127474,2396),(127475,2397),(127476,2398),(127477,2399),(127478,2400),(127479,2401),(127480,2402),(127481,2403),(127482,2404),(127483,2405),(127484,2406),(127485,2407),(127486,2408),(127487,2409),(127488,2410),(127489,2411),(127490,2412),(127491,2413),(127492,2414),(127493,2415),(127494,2416),(127495,2417),(127496,2418),(127497,2419),(127498,2420),(127499,2421),(127500,2422),(127501,2423),(127502,2424),(127503,2425),(127504,2426),(127505,2427),(127506,2428),(127507,2429),(127508,2430),(127509,2431),(127510,2432),(127511,2433),(127512,2434),(127513,2435),(127514,2436),(127515,2437),(127516,2438),(127517,2439),(127518,2440),(127519,2441),(127520,2442),(127521,2443),(127522,2444),(127523,2445),(127524,2446),(127525,2447),(127526,2448),(127527,2449),(127528,2450),(127529,2451),(127530,2452),(127531,2453),(127532,2454),(127533,2455),(127534,2456),(127535,2457),(127536,2458),(127537,2459),(127538,2460),(127539,2461),(127540,2462),(127541,2463),(127542,2464),(127543,2465),(127544,2466),(127545,2467),(127546,2468),(127547,2469),(127548,2470),(127549,2471),(127550,2472),(127551,2473),(127552,2474),(127553,2475),(127554,2476),(127555,2477),(127556,2478),(127557,2479),(127558,2480),(127559,2481),(127560,2482),(127561,2483),(127562,2484),(127563,2485),(127564,2486),(127565,2487),(127566,2488),(127567,2489),(127568,2490),(127569,2491),(127570,2492),(127571,2493),(127572,2494),(127573,2495),(127574,2496),(127575,2497),(127576,2498),(127577,2499),(127578,2500),(127579,2501),(127580,2502),(127581,2503),(127582,2504),(127583,2505),(127584,2506),(127585,2507),(127586,2508),(127587,2509),(127588,2510),(127589,2511),(127590,2512),(127591,2513),(127592,2514),(127593,2515),(127594,2516),(127595,2517),(127596,2518),(127597,2519),(127598,2520),(127599,2521),(127600,2522),(127601,2523),(127602,2524),(127603,2525),(127604,2526),(127605,2527),(127606,2528),(127607,2529),(127608,2530),(127609,2531),(127610,2532),(127611,2533),(127612,2534),(127613,2535),(127614,2536),(127615,2537),(127616,2538),(127617,2539),(127618,2540),(127619,2541),(127620,2542),(127621,2543),(127622,2544),(127623,2545),(127624,2546),(127625,2547),(127626,2548),(127627,2549),(127628,2550),(127629,2551),(127630,2552),(127631,2553),(127632,2554),(127633,2555),(127634,2556),(127635,2557),(127636,2558),(127637,2559),(127638,2560),(127639,2561),(127640,2562),(127641,2563),(127642,2564),(127643,2565),(127644,2566),(127645,2567),(127646,2568),(127647,2569),(127648,2570),(127649,2571),(127650,2572),(127651,2573),(127652,2574),(127653,2575),(127654,2576),(127655,2577),(127656,2578),(127657,2579),(127658,2580),(127659,2581),(127660,2582),(127661,2583),(127662,2584),(127663,2585),(127664,2586),(127665,2587),(127666,2588),(127667,2589),(127668,2590),(127669,2591),(127670,2592),(127671,2593),(127672,2594),(127673,2595),(127674,2596),(127675,2597),(127676,2598),(127677,2599),(127678,2600),(127679,2601),(127680,2602),(127681,2603),(127682,2604),(127683,2605),(127684,2606),(127685,2607),(127686,2608),(127687,2609),(127688,2610),(127689,2611),(127690,2612),(127691,2613),(127692,2614),(127693,2615),(127694,2616),(127695,2617),(127696,2618),(127697,2619),(127698,2620),(127699,2621),(127700,2622),(127701,2623),(127702,2624),(127703,2625),(127704,2626),(127705,2627),(127706,2628),(127707,2629),(127708,2630),(127709,2631),(127710,2632),(127711,2633),(127712,2634),(127713,2635),(127714,2636),(127715,2637),(127716,2638),(127717,2639),(127718,2640),(127719,2641),(127720,2642),(127721,2643),(127722,2644),(127723,2645),(127724,2646),(127725,2647),(127726,2648),(127727,2649),(127728,2650),(127729,2651),(127730,2652),(127731,2653),(127732,2654),(127733,2655),(127734,2656),(127735,2657),(127736,2658),(127737,2659),(127738,2660),(127739,2661),(127740,2662),(127741,2663),(127742,2664),(127743,2665),(127744,2666),(127745,2667),(127746,2668),(127747,2669),(127748,2670),(127749,2671),(127750,2672),(127751,2673),(127752,2674),(127753,2675),(127754,2676),(127755,2677),(127756,2678),(127757,2679),(127758,2680),(127759,2681),(127760,2682),(127761,2683),(127762,2684),(127763,2685),(127764,2686),(127765,2687),(127766,2688),(127767,2689),(127768,2690),(127769,2691),(127770,2692),(127771,2693),(127772,2694),(127773,2695),(127774,2696),(127775,2697),(127776,2698),(127777,2699),(127778,2700),(127779,2701),(127780,2702),(127781,2703),(127782,2704),(127783,2705),(127784,2706),(127785,2707),(127786,2708),(127787,2709),(127788,2710),(127789,2711),(127790,2712),(127791,2713),(127792,2714),(127793,2715),(127794,2716),(127795,2717),(127796,2718),(127797,2719),(127798,2720),(127799,2721),(127800,2722),(127801,2723),(127802,2724),(127803,2725),(127804,2726),(127805,2727),(127806,2728),(127807,2729),(127808,2730),(127809,2731),(127810,2732),(127811,2733),(127812,2734),(127813,2735),(127814,2736),(127815,2737),(127816,2738),(127817,2739),(127818,2740),(127819,2741),(127820,2742),(127821,2743),(127822,2744),(127823,2745),(127824,2746),(127825,2747),(127826,2748),(127827,2749),(127828,2750),(127829,2751),(127830,2752),(127831,2753),(127832,2754),(127833,2755),(127834,2756),(127835,2757),(127836,2758),(127837,2759),(127838,2760),(127839,2761),(127840,2762),(127841,2763),(127842,2764),(127843,2765),(127844,2766),(127845,2767),(127846,2768),(127847,2769),(127848,2770),(127849,2771),(127850,2772),(127851,2773),(127852,2774),(127853,2775),(127854,2776),(127855,2777),(127856,2778),(127857,2779),(127858,2780),(127859,2781),(127860,2782),(127861,2783),(127862,2784),(127863,2785),(127864,2786),(127865,2787),(127866,2788),(127867,2789),(127868,2790),(127869,2791),(127870,2792),(127871,2793),(127872,2794),(127873,2795),(127874,2796),(127875,2797),(127876,2798),(127877,2799),(127878,2800),(127879,2801),(127880,2802),(127881,2803),(127882,2804),(127883,2805),(127884,2806),(127885,2807),(127886,2808),(127887,2809),(127888,2810),(127889,2811),(127890,2812),(127891,2813),(127892,2814),(127893,2815),(127894,2816),(127895,2817),(127896,2818),(127897,2819),(127898,2820),(127899,2821),(127900,2822),(127901,2823),(127902,2824),(127903,2825),(127904,2826),(127905,2827),(127906,2828),(127907,2829),(127908,2830),(127909,2831),(127910,2832),(127911,2833),(127912,2834),(127913,2835),(127914,2836),(127915,2837),(127916,2838),(127917,2839),(127918,2840),(127919,2841),(127920,2842),(127921,2843),(127922,2844),(127923,2845),(127924,2846),(127925,2847),(127926,2848),(127927,2849),(127928,2850),(127929,2851),(127930,2852),(127931,2853),(127932,2854),(127933,2855),(127934,2856),(127935,2857),(127936,2858),(127937,2859),(127938,2860),(127939,2861),(127940,2862),(127941,2863),(127942,2864),(127943,2865),(127944,2866),(127945,2867),(127946,2868),(127947,2869),(127948,2870),(127949,2871),(127950,2872),(127951,2873),(127952,2874),(127953,2875),(127954,2876),(127955,2877),(127956,2878),(127957,2879),(127958,2880),(127959,2881),(127960,2882),(127961,2883),(127962,2884),(127963,2885),(127964,2886),(127965,2887),(127966,2888),(127967,2889),(127968,2890),(127969,2891),(127970,2892),(127971,2893),(127972,2894),(127973,2895),(127974,2896),(127975,2897),(127976,2898),(127977,2899),(127978,2900),(127979,2901),(127980,2902),(127981,2903),(127982,2904),(127983,2905),(127984,2906),(127985,2907),(127986,2908),(127987,2909),(127988,2910),(127989,2911),(127990,2912),(127991,2913),(127992,2914),(127993,2915),(127994,2916),(127995,2917),(127996,2918),(127997,2919),(127998,2920),(127999,2921),(128000,2922),(128001,2923),(128002,2924),(128003,2925),(128004,2926),(128005,2927),(128006,2928),(128007,2929),(128008,2930),(128009,2931),(128010,2932),(128011,2933),(128012,2934),(128013,2935),(128014,2936),(128015,2937),(128016,2938),(128017,2939),(128018,2940),(128019,2941),(128020,2942),(128021,2943),(128022,2944),(128023,2945),(128024,2946),(128025,2947),(128026,2948),(128027,2949),(128028,2950),(128029,2951),(128030,2952),(128031,2953),(128032,2954),(128033,2955),(128034,2956),(128035,2957),(128036,2958),(128037,2959),(128038,2960),(128039,2961),(128040,2962),(128041,2963),(128042,2964),(128043,2965),(128044,2966),(128045,2967),(128046,2968),(128047,2969),(128048,2970),(128049,2971),(128050,2972),(128051,2973),(128052,2974),(128053,2975),(128054,2976),(128055,2977),(128056,2978),(128057,2979),(128058,2980),(128059,2981),(128060,2982),(128061,2983),(128062,2984),(128063,2985),(128064,2986),(128065,2987),(128066,2988),(128067,2989),(128068,2990),(128069,2991),(128070,2992),(128071,2993),(128072,2994),(128073,2995),(128074,2996),(128075,2997),(128076,2998),(128077,2999),(128078,3000),(128079,3001),(128080,3002),(128081,3003),(128082,3004),(128083,3005),(128084,3006),(128085,3007),(128086,3008),(128087,3009),(128088,3010),(128089,3011),(128090,3012),(128091,3013),(128092,3014),(128093,3015),(128094,3016),(128095,3017),(128096,3018),(128097,3019),(128098,3020),(128099,3021),(128100,3022),(128101,3023),(128102,3024),(128103,3025),(128104,3026),(128105,3027),(128106,3028),(128107,3029),(128108,3030),(128109,3031),(128110,3032),(128111,3033),(128112,3034),(128113,3035),(128114,3036),(128115,3037),(128116,3038),(128117,3039),(128118,3040),(128119,3041),(128120,3042),(128121,3043),(128122,3044),(128123,3045),(128124,3046),(128125,3047),(128126,3048),(128127,3049),(128128,3050),(128129,3051),(128130,3052),(128131,3053),(128132,3054),(128133,3055),(128134,3056),(128135,3057),(128136,3058),(128137,3059),(128138,3060),(128139,3061),(128140,3062),(128141,3063),(128142,3064),(128143,3065),(128144,3066),(128145,3067),(128146,3068),(128147,3069),(128148,3070),(128149,3071),(128150,3072),(128151,3073),(128152,3074),(128153,3075),(128154,3076),(128155,3077),(128156,3078),(128157,3079),(128158,3080),(128159,3081),(128160,3082),(128161,3083),(128162,3084),(128163,3085),(128164,3086),(128165,3087),(128166,3088),(128167,3089),(128168,3090),(128169,3091),(128170,3092),(128171,3093),(128172,3094),(128173,3095),(128174,3096),(128175,3097),(128176,3098),(128177,3099),(128178,3100),(128179,3101),(128180,3102),(128181,3103),(128182,3104),(128183,3105),(128184,3106),(128185,3107),(128186,3108),(128187,3109),(128188,3110),(128189,3111),(128190,3112),(128191,3113),(128192,3114),(128193,3115),(128194,3116),(128195,3117),(128196,3118),(128197,3119),(128198,3120),(128199,3121),(128200,3122),(128201,3123),(128202,3124),(128203,3125),(128204,3126),(128205,3127),(128206,3128),(128207,3129),(128208,3130),(128209,3131),(128210,3132),(128211,3133),(128212,3134),(128213,3135),(128214,3136),(128215,3137),(128216,3138),(128217,3139),(128218,3140),(128219,3141),(128220,3142),(128221,3143),(128222,3144),(128223,3145),(128224,3146),(128225,3147),(128226,3148),(128227,3149),(128228,3150),(128229,3151),(128230,3152),(128231,3153),(128232,3154),(128233,3155),(128234,3156),(128235,3157),(128236,3158),(128237,3159),(128238,3160),(128239,3161),(128240,3162),(128241,3163),(128242,3164),(128243,3165),(128244,3166),(128245,3167),(128246,3168),(128247,3169),(128248,3170),(128249,3171),(128250,3172),(128251,3173),(128252,3174),(128253,3175),(128254,3176),(128255,3177),(128256,3178),(128257,3179),(128258,3180),(128259,3181),(128260,3182),(128261,3183),(128262,3184),(128263,3185),(128264,3186),(128265,3187),(128266,3188),(128267,3189),(128268,3190),(128269,3191),(128270,3192),(128271,3193),(128272,3194),(128273,3195),(128274,3196),(128275,3197),(128276,3198),(128277,3199),(128278,3200),(128279,3201),(128280,3202),(128281,3203),(128282,3204),(128283,3205),(128284,3206),(128285,3207),(128286,3208),(128287,3209),(128288,3210),(128289,3211),(128290,3212),(128291,3213),(128292,3214),(128293,3215),(128294,3216),(128295,3217),(128296,3218),(128297,3219),(128298,3220),(128299,3221),(128300,3222),(128301,3223),(128302,3224),(128303,3225),(128304,3226),(128305,3227),(128306,3228),(128307,3229),(128308,3230),(128309,3231),(128310,3232),(128311,3233),(128312,3234),(128313,3235),(128314,3236),(128315,3237),(128316,3238),(128317,3239),(128318,3240),(128319,3241),(128320,3242),(128321,3243),(128322,3244),(128323,3245),(128324,3246),(128325,3247),(128326,3248),(128327,3249),(128328,3250),(128329,3251),(128330,3252),(128331,3253),(128332,3254),(128333,3255),(128334,3256),(128335,3257),(128336,3258),(128337,3259),(128338,3260),(128339,3261),(128340,3262),(128341,3263),(128342,3264),(128343,3265),(128344,3266),(128345,3267),(128346,3268),(128347,3269),(128348,3270),(128349,3271),(128350,3272),(128351,3273),(128352,3274),(128353,3275),(128354,3276),(128355,3277),(128356,3278),(128357,3279),(128358,3280),(128359,3281),(128360,3282),(128361,3283),(128362,3284),(128363,3285),(128364,3286),(128365,3287),(128366,3288),(128367,3289),(128368,3290),(128369,3291),(128370,3292),(128371,3293),(128372,3294),(128373,3295),(128374,3296),(128375,3297),(128376,3298),(128377,3299),(128378,3300),(128379,3301),(128380,3302),(128381,3303),(128382,3304),(128383,3305),(128384,3306),(128385,3307),(128386,3308),(128387,3309),(128388,3310),(128389,3311),(128390,3312),(128391,3313),(128392,3314),(128393,3315),(128394,3316),(128395,3317),(128396,3318),(128397,3319),(128398,3320),(128399,3321),(128400,3322),(128401,3323),(128402,3324),(128403,3325),(128404,3326),(128405,3327),(128406,3328),(128407,3329),(128408,3330),(128409,3331),(128410,3332),(128411,3333),(128412,3334),(128413,3335),(128414,3336),(128415,3337),(128416,3338),(128417,3339),(128418,3340),(128419,3341),(128420,3342),(128421,3343),(128422,3344),(128423,3345),(128424,3346),(128425,3347),(128426,3348),(128427,3349),(128428,3350),(128429,3351),(128430,3352),(128431,3353),(128432,3354),(128433,3355),(128434,3356),(128435,3357),(128436,3358),(128437,3359),(128438,3360),(128439,3361),(128440,3362),(128441,3363),(128442,3364),(128443,3365),(128444,3366),(128445,3367),(128446,3368),(128447,3369),(128448,3370),(128449,3371),(128450,3372),(128451,3373),(128452,3374),(128453,3375),(128454,3376),(128455,3377),(128456,3378),(128457,3379),(128458,3380),(128459,3381),(128460,3382),(128461,3383),(128462,3384),(128463,3385),(128464,3386),(128465,3387),(128466,3388),(128467,3389),(128468,3390),(128469,3391),(128470,3392),(128471,3393),(128472,3394),(128473,3395),(128474,3396),(128475,3397),(128476,3398),(128477,3399),(128478,3400),(128479,3401),(128480,3402),(128481,3403),(128482,3404),(128483,3405),(128484,3406),(128485,3407),(128486,3408),(128487,3409),(128488,3410),(128489,3411),(128490,3412),(128491,3413),(128492,3414),(128493,3415),(128494,3416),(128495,3417),(128496,3418),(128497,3419),(128498,3420),(128499,3421),(128500,3422),(128501,3423),(128502,3424),(128503,3425),(128504,3426),(128505,3427),(128506,3428),(128507,3429),(128508,3430),(128509,3431),(128510,3432),(128511,3433),(128512,3434),(128513,3435),(128514,3436),(128515,3437),(128516,3438),(128517,3439),(128518,3440),(128519,3441),(128520,3442),(128521,3443),(128522,3444),(128523,3445),(128524,3446),(128525,3447),(128526,3448),(128527,3449),(128528,3450),(128529,3451),(128530,3452),(128531,3453),(128532,3454),(128533,3455),(128534,3456),(128535,3457),(128536,3458),(128537,3459),(128538,3460),(128539,3461),(128540,3462),(128541,3463),(128542,3464),(128543,3465),(128544,3466),(128545,3467),(128546,3468),(128547,3469),(128548,3470),(128549,3471),(128550,3472),(128551,3473),(128552,3474),(128553,3475),(128554,3476),(128555,3477),(128556,3478),(128557,3479),(128558,3480),(128559,3481),(128560,3482),(128561,3483),(128562,3484),(128563,3485),(128564,3486),(128565,3487),(128566,3488),(128567,3489),(128568,3490),(128569,3491),(128570,3492),(128571,3493),(128572,3494),(128573,3495),(128574,3496),(128575,3497),(128576,3498),(128577,3499),(128578,3500),(128579,3501),(128580,3502),(128581,3503),(128582,3504),(128583,3505),(128584,3506),(128585,3507),(128586,3508),(128587,3509),(128588,3510),(128589,3511),(128590,3512),(128591,3513),(128592,3514),(128593,3515),(128594,3516),(128595,3517),(128596,3518),(128597,3519),(128598,3520),(128599,3521),(128600,3522),(128601,3523),(128602,3524),(128603,3525),(128604,3526),(128605,3527),(128606,3528),(128607,3529),(128608,3530),(128609,3531),(128610,3532),(128611,3533),(128612,3534),(128613,3535),(128614,3536),(128615,3537),(128616,3538),(128617,3539),(128618,3540),(128619,3541),(128620,3542),(128621,3543),(128622,3544),(128623,3545),(128624,3546),(128625,3547),(128626,3548),(128627,3549),(128628,3550),(128629,3551),(128630,3552),(128631,3553),(128632,3554),(128633,3555),(128634,3556),(128635,3557),(128636,3558),(128637,3559),(128638,3560),(128639,3561),(128640,3562),(128641,3563),(128642,3564),(128643,3565),(128644,3566),(128645,3567),(128646,3568),(128647,3569),(128648,3570),(128649,3571),(128650,3572),(128651,3573),(128652,3574),(128653,3575),(128654,3576),(128655,3577),(128656,3578),(128657,3579),(128658,3580),(128659,3581),(128660,3582),(128661,3583),(128662,3584),(128663,3585),(128664,3586),(128665,3587),(128666,3588),(128667,3589),(128668,3590),(128669,3591),(128670,3592),(128671,3593),(128672,3594),(128673,3595),(128674,3596),(128675,3597),(128676,3598),(128677,3599),(128678,3600),(128679,3601),(128680,3602),(128681,3603),(128682,3604),(128683,3605),(128684,3606),(128685,3607),(128686,3608),(128687,3609),(128688,3610),(128689,3611),(128690,3612),(128691,3613),(128692,3614),(128693,3615),(128694,3616),(128695,3617),(128696,3618),(128697,3619),(128698,3620),(128699,3621),(128700,3622),(128701,3623),(128702,3624),(128703,3625),(128704,3626),(128705,3627),(128706,3628),(128707,3629),(128708,3630),(128709,3631),(128710,3632),(128711,3633),(128712,3634),(128713,3635),(128714,3636),(128715,3637),(128716,3638),(128717,3639),(128718,3640),(128719,3641),(128720,3642),(128721,3643),(128722,3644),(128723,3645),(128724,3646),(128725,3647),(128726,3648),(128727,3649),(128728,3650),(128729,3651),(128730,3652),(128731,3653),(128732,3654),(128733,3655),(128734,3656),(128735,3657),(128736,3658),(128737,3659),(128738,3660),(128739,3661),(128740,3662),(128741,3663),(128742,3664),(128743,3665),(128744,3666),(128745,3667),(128746,3668),(128747,3669),(128748,3670),(128749,3671),(128750,3672),(128751,3673),(128752,3674),(128753,3675),(128754,3676),(128755,3677),(128756,3678),(128757,3679),(128758,3680),(128759,3681),(128760,3682),(128761,3683),(128762,3684),(128763,3685),(128764,3686),(128765,3687),(128766,3688),(128767,3689),(128768,3690),(128769,3691),(128770,3692),(128771,3693),(128772,3694),(128773,3695),(128774,3696),(128775,3697),(128776,3698),(128777,3699),(128778,3700),(128779,3701),(128780,3702),(128781,3703),(128782,3704),(128783,3705),(128784,3706),(128785,3707),(128786,3708),(128787,3709),(128788,3710),(128789,3711),(128790,3712),(128791,3713),(128792,3714),(128793,3715),(128794,3716),(128795,3717),(128796,3718),(128797,3719),(128798,3720),(128799,3721),(128800,3722),(128801,3723),(128802,3724),(128803,3725),(128804,3726),(128805,3727),(128806,3728),(128807,3729),(128808,3730),(128809,3731),(128810,3732),(128811,3733),(128812,3734),(128813,3735),(128814,3736),(128815,3737),(128816,3738),(128817,3739),(128818,3740),(128819,3741),(128820,3742),(128821,3743),(128822,3744),(128823,3745),(128824,3746),(128825,3747),(128826,3748),(128827,3749),(128828,3750),(128829,3751),(128830,3752),(128831,3753),(128832,3754),(128833,3755),(128834,3756),(128835,3757),(128836,3758),(128837,3759),(128838,3760),(128839,3761),(128840,3762),(128841,3763),(128842,3764),(128843,3765),(128844,3766),(128845,3767),(128846,3768),(128847,3769),(128848,3770),(128849,3771),(128850,3772),(128851,3773),(128852,3774),(128853,3775),(128854,3776),(128855,3777),(128856,3778),(128857,3779),(128858,3780),(128859,3781),(128860,3782),(128861,3783),(128862,3784),(128863,3785),(128864,3786),(128865,3787),(128866,3788),(128867,3789),(128868,3790),(128869,3791),(128870,3792),(128871,3793),(128872,3794),(128873,3795),(128874,3796),(128875,3797),(128876,3798),(128877,3799),(128878,3800),(128879,3801),(128880,3802),(128881,3803),(128882,3804),(128883,3805),(128884,3806),(128885,3807),(128886,3808),(128887,3809),(128888,3810),(128889,3811),(128890,3812),(128891,3813),(128892,3814),(128893,3815),(128894,3816),(128895,3817),(128896,3818),(128897,3819),(128898,3820),(128899,3821),(128900,3822),(128901,3823),(128902,3824),(128903,3825),(128904,3826),(128905,3827),(128906,3828),(128907,3829),(128908,3830),(128909,3831),(128910,3832),(128911,3833),(128912,3834),(128913,3835),(128914,3836),(128915,3837),(128916,3838),(128917,3839),(128918,3840),(128919,3841),(128920,3842),(128921,3843),(128922,3844),(128923,3845),(128924,3846),(128925,3847),(128926,3848),(128927,3849),(128928,3850),(128929,3851),(128930,3852),(128931,3853),(128932,3854),(128933,3855),(128934,3856),(128935,3857),(128936,3858),(128937,3859),(128938,3860),(128939,3861),(128940,3862),(128941,3863),(128942,3864),(128943,3865),(128944,3866),(128945,3867),(128946,3868),(128947,3869),(128948,3870),(128949,3871),(128950,3872),(128951,3873),(128952,3874),(128953,3875),(128954,3876),(128955,3877),(128956,3878),(128957,3879),(128958,3880),(128959,3881),(128960,3882),(128961,3883),(128962,3884),(128963,3885),(128964,3886),(128965,3887),(128966,3888),(128967,3889),(128968,3890),(128969,3891),(128970,3892),(128971,3893),(128972,3894),(128973,3895),(128974,3896),(128975,3897),(128976,3898),(128977,3899),(128978,3900),(128979,3901),(128980,3902),(128981,3903),(128982,3904),(128983,3905),(128984,3906),(128985,3907),(128986,3908),(128987,3909),(128988,3910),(128989,3911),(128990,3912),(128991,3913),(128992,3914),(128993,3915),(128994,3916),(128995,3917),(128996,3918),(128997,3919),(128998,3920),(128999,3921),(129000,3922),(129001,3923),(129002,3924),(129003,3925),(129004,3926),(129005,3927),(129006,3928),(129007,3929),(129008,3930),(129009,3931),(129010,3932),(129011,3933),(129012,3934),(129013,3935),(129014,3936),(129015,3937),(129016,3938),(129017,3939),(129018,3940),(129019,3941),(129020,3942),(129021,3943),(129022,3944),(129023,3945),(129024,3946),(129025,3947),(129026,3948),(129027,3949),(129028,3950),(129029,3951),(129030,3952),(129031,3953),(129032,3954),(129033,3955),(129034,3956),(129035,3957),(129036,3958),(129037,3959),(129038,3960),(129039,3961),(129040,3962),(129041,3963),(129042,3964),(129043,3965),(129044,3966),(129045,3967),(129046,3968),(129047,3969),(129048,3970),(129049,3971),(129050,3972),(129051,3973),(129052,3974),(129053,3975),(129054,3976),(129055,3977),(129056,3978),(129057,3979),(129058,3980),(129059,3981),(129060,3982),(129061,3983),(129062,3984),(129063,3985),(129064,3986),(129065,3987),(129066,3988),(129067,3989),(129068,3990),(129069,3991),(129070,3992),(129071,3993),(129072,3994),(129073,3995),(129074,3996),(129075,3997),(129076,3998),(129077,3999),(129078,4000),(129079,4001),(129080,4002),(129081,4003),(129082,4004),(129083,4005),(129084,4006),(129085,4007),(129086,4008),(129087,4009),(129088,4010),(129089,4011),(129090,4012),(129091,4013),(129092,4014),(129093,4015),(129094,4016),(129095,4017),(129096,4018),(129097,4019),(129098,4020),(129099,4021),(129100,4022),(129101,4023),(129102,4024),(129103,4025),(129104,4026),(129105,4027),(129106,4028),(129107,4029),(129108,4030),(129109,4031),(129110,4032),(129111,4033),(129112,4034),(129113,4035),(129114,4036),(129115,4037),(129116,4038),(129117,4039),(129118,4040),(129119,4041),(129120,4042),(129121,4043),(129122,4044),(129123,4045),(129124,4046),(129125,4047),(129126,4048),(129127,4049),(129128,4050),(129129,4051),(129130,4052),(129131,4053),(129132,4054),(129133,4055),(129134,4056),(129135,4057),(129136,4058),(129137,4059),(129138,4060),(129139,4061),(129140,4062),(129141,4063),(129142,4064),(129143,4065),(129144,4066),(129145,4067),(129146,4068),(129147,4069),(129148,4070),(129149,4071),(129150,4072),(129151,4073),(129152,4074),(129153,4075),(129154,4076),(129155,4077),(129156,4078),(129157,4079),(129158,4080),(129159,4081),(129160,4082),(129161,4083),(129162,4084),(129163,4085),(129164,4086),(129165,4087),(129166,4088),(129167,4089),(129168,4090),(129169,4091),(129170,4092),(129171,4093),(129172,4094),(129173,4095),(129174,4096),(129175,4097),(129176,4098),(129177,4099),(129178,4100),(129179,4101),(129180,4102),(129181,4103),(129182,4104),(129183,4105),(129184,4106),(129185,4107),(129186,4108),(129187,4109),(129188,4110),(129189,4111),(129190,4112),(129191,4113),(129192,4114),(129193,4115),(129194,4116),(129195,4117),(129196,4118),(129197,4119),(129198,4120),(129199,4121),(129200,4122),(129201,4123),(129202,4124),(129203,4125),(129204,4126),(129205,4127),(129206,4128),(129207,4129),(129208,4130),(129209,4131),(129210,4132),(129211,4133),(129212,4134),(129213,4135),(129214,4136),(129215,4137),(129216,4138),(129217,4139),(129218,4140),(129219,4141),(129220,4142),(129221,4143),(129222,4144),(129223,4145),(129224,4146),(129225,4147),(129226,4148),(129227,4149),(129228,4150),(129229,4151),(129230,4152),(129231,4153),(129232,4154),(129233,4155),(129234,4156),(129235,4157),(129236,4158),(129237,4159),(129238,4160),(129239,4161),(129240,4162),(129241,4163),(129242,4164),(129243,4165),(129244,4166),(129245,4167),(129246,4168),(129247,4169),(129248,4170),(129249,4171),(129250,4172),(129251,4173),(129252,4174),(129253,4175),(129254,4176),(129255,4177),(129256,4178),(129257,4179),(129258,4180),(129259,4181),(129260,4182),(129261,4183),(129262,4184),(129263,4185),(129264,4186),(129265,4187),(129266,4188),(129267,4189),(129268,4190),(129269,4191),(129270,4192),(129271,4193),(129272,4194),(129273,4195),(129274,4196),(129275,4197),(129276,4198),(129277,4199),(129278,4200),(129279,4201),(129280,4202),(129281,4203),(129282,4204),(129283,4205),(129284,4206),(129285,4207),(129286,4208),(129287,4209),(129288,4210),(129289,4211),(129290,4212),(129291,4213),(129292,4214),(129293,4215),(129294,4216),(129295,4217),(129296,4218),(129297,4219),(129298,4220),(129299,4221),(129300,4222),(129301,4223),(129302,4224),(129303,4225),(129304,4226),(129305,4227),(129306,4228),(129307,4229),(129308,4230),(129309,4231),(129310,4232),(129311,4233),(129312,4234),(129313,4235),(129314,4236),(129315,4237),(129316,4238),(129317,4239),(129318,4240),(129319,4241),(129320,4242),(129321,4243),(129322,4244),(129323,4245),(129324,4246),(129325,4247),(129326,4248),(129327,4249),(129328,4250),(129329,4251),(129330,4252),(129331,4253),(129332,4254),(129333,4255),(129334,4256),(129335,4257),(129336,4258),(129337,4259),(129338,4260),(129339,4261),(129340,4262),(129341,4263),(129342,4264),(129343,4265),(129344,4266),(129345,4267),(129346,4268),(129347,4269),(129348,4270),(129349,4271),(129350,4272),(129351,4273),(129352,4274),(129353,4275),(129354,4276),(129355,4277),(129356,4278),(129357,4279),(129358,4280),(129359,4281),(129360,4282),(129361,4283),(129362,4284),(129363,4285),(129364,4286),(129365,4287),(129366,4288),(129367,4289),(129368,4290),(129369,4291),(129370,4292),(129371,4293),(129372,4294),(129373,4295),(129374,4296),(129375,4297),(129376,4298),(129377,4299),(129378,4300),(129379,4301),(129380,4302),(129381,4303),(129382,4304),(129383,4305),(129384,4306),(129385,4307),(129386,4308),(129387,4309),(129388,4310),(129389,4311),(129390,4312),(129391,4313),(129392,4314),(129393,4315),(129394,4316),(129395,4317),(129396,4318),(129397,4319),(129398,4320),(129399,4321),(129400,4322),(129401,4323),(129402,4324),(129403,4325),(129404,4326),(129405,4327),(129406,4328),(129407,4329),(129408,4330),(129409,4331),(129410,4332),(129411,4333),(129412,4334),(129413,4335),(129414,4336),(129415,4337),(129416,4338),(129417,4339),(129418,4340),(129419,4341),(129420,4342),(129421,4343),(129422,4344),(129423,4345),(129424,4346),(129425,4347),(129426,4348),(129427,4349),(129428,4350),(129429,4351),(129430,4352),(129431,4353),(129432,4354),(129433,4355),(129434,4356),(129435,4357),(129436,4358),(129437,4359),(129438,4360),(129439,4361),(129440,4362),(129441,4363),(129442,4364),(129443,4365),(129444,4366),(129445,4367),(129446,4368),(129447,4369),(129448,4370),(129449,4371),(129450,4372),(129451,4373),(129452,4374),(129453,4375),(129454,4376),(129455,4377),(129456,4378),(129457,4379),(129458,4380),(129459,4381),(129460,4382),(129461,4383),(129462,4384),(129463,4385),(129464,4386),(129465,4387),(129466,4388),(129467,4389),(129468,4390),(129469,4391),(129470,4392),(129471,4393),(129472,4394),(129473,4395),(129474,4396),(129475,4397),(129476,4398),(129477,4399),(129478,4400),(129479,4401),(129480,4402),(129481,4403),(129482,4404),(129483,4405),(129484,4406),(129485,4407),(129486,4408),(129487,4409),(129488,4410),(129489,4411),(129490,4412),(129491,4413),(129492,4414),(129493,4415),(129494,4416),(129495,4417),(129496,4418),(129497,4419),(129498,4420),(129499,4421),(129500,4422),(129501,4423),(129502,4424),(129503,4425),(129504,4426),(129505,4427),(129506,4428),(129507,4429),(129508,4430),(129509,4431),(129510,4432),(129511,4433),(129512,4434),(129513,4435),(129514,4436),(129515,4437),(129516,4438),(129517,4439),(129518,4440),(129519,4441),(129520,4442),(129521,4443),(129522,4444),(129523,4445),(129524,4446),(129525,4447),(129526,4448),(129527,4449),(129528,4450),(129529,4451),(129530,4452),(129531,4453),(129532,4454),(129533,4455),(129534,4456),(129535,4457),(129536,4458),(129537,4459),(129538,4460),(129539,4461),(129540,4462),(129541,4463),(129542,4464),(129543,4465),(129544,4466),(129545,4467),(129546,4468),(129547,4469),(129548,4470),(129549,4471),(129550,4472),(129551,4473),(129552,4474),(129553,4475),(129554,4476),(129555,4477),(129556,4478),(129557,4479),(129558,4480),(129559,4481),(129560,4482),(129561,4483),(129562,4484),(129563,4485),(129564,4486),(129565,4487),(129566,4488),(129567,4489),(129568,4490),(129569,4491),(129570,4492),(129571,4493),(129572,4494),(129573,4495),(129574,4496),(129575,4497),(129576,4498),(129577,4499),(129578,4500),(129579,4501),(129580,4502),(129581,4503),(129582,4504),(129583,4505),(129584,4506),(129585,4507),(129586,4508),(129587,4509),(129588,4510),(129589,4511),(129590,4512),(129591,4513),(129592,4514),(129593,4515),(129594,4516),(129595,4517),(129596,4518),(129597,4519),(129598,4520),(129599,4521),(129600,4522),(129601,4523),(129602,4524),(129603,4525),(129604,4526),(129605,4527),(129606,4528),(129607,4529),(129608,4530),(129609,4531),(129610,4532),(129611,4533),(129612,4534),(129613,4535),(129614,4536),(129615,4537),(129616,4538),(129617,4539),(129618,4540),(129619,4541),(129620,4542),(129621,4543),(129622,4544),(129623,4545),(129624,4546),(129625,4547),(129626,4548),(129627,4549),(129628,4550),(129629,4551),(129630,4552),(129631,4553),(129632,4554),(129633,4555),(129634,4556),(129635,4557),(129636,4558),(129637,4559),(129638,4560),(129639,4561),(129640,4562),(129641,4563),(129642,4564),(129643,4565),(129644,4566),(129645,4567),(129646,4568),(129647,4569),(129648,4570),(129649,4571),(129650,4572),(129651,4573),(129652,4574),(129653,4575),(129654,4576),(129655,4577),(129656,4578),(129657,4579),(129658,4580),(129659,4581),(129660,4582),(129661,4583),(129662,4584),(129663,4585),(129664,4586),(129665,4587),(129666,4588),(129667,4589),(129668,4590),(129669,4591),(129670,4592),(129671,4593),(129672,4594),(129673,4595),(129674,4596),(129675,4597),(129676,4598),(129677,4599),(129678,4600),(129679,4601),(129680,4602),(129681,4603),(129682,4604),(129683,4605),(129684,4606),(129685,4607),(129686,4608),(129687,4609),(129688,4610),(129689,4611),(129690,4612),(129691,4613),(129692,4614),(129693,4615),(129694,4616),(129695,4617),(129696,4618),(129697,4619),(129698,4620),(129699,4621),(129700,4622),(129701,4623),(129702,4624),(129703,4625),(129704,4626),(129705,4627),(129706,4628),(129707,4629),(129708,4630),(129709,4631),(129710,4632),(129711,4633),(129712,4634),(129713,4635),(129714,4636),(129715,4637),(129716,4638),(129717,4639),(129718,4640),(129719,4641),(129720,4642),(129721,4643),(129722,4644),(129723,4645),(129724,4646),(129725,4647),(129726,4648),(129727,4649),(129728,4650),(129729,4651),(129730,4652),(129731,4653),(129732,4654),(129733,4655),(129734,4656),(129735,4657),(129736,4658),(129737,4659),(129738,4660),(129739,4661),(129740,4662),(129741,4663),(129742,4664),(129743,4665),(129744,4666),(129745,4667),(129746,4668),(129747,4669),(129748,4670),(129749,4671),(129750,4672),(129751,4673),(129752,4674),(129753,4675),(129754,4676),(129755,4677),(129756,4678),(129757,4679),(129758,4680),(129759,4681),(129760,4682),(129761,4683),(129762,4684),(129763,4685),(129764,4686),(129765,4687),(129766,4688),(129767,4689),(129768,4690),(129769,4691),(129770,4692),(129771,4693),(129772,4694),(129773,4695),(129774,4696),(129775,4697),(129776,4698),(129777,4699),(129778,4700),(129779,4701),(129780,4702),(129781,4703),(129782,4704),(129783,4705),(129784,4706),(129785,4707),(129786,4708),(129787,4709),(129788,4710),(129789,4711),(129790,4712),(129791,4713),(129792,4714),(129793,4715),(129794,4716),(129795,4717),(129796,4718),(129797,4719),(129798,4720),(129799,4721),(129800,4722),(129801,4723),(129802,4724),(129803,4725),(129804,4726),(129805,4727),(129806,4728),(129807,4729),(129808,4730),(129809,4731),(129810,4732),(129811,4733),(129812,4734),(129813,4735),(129814,4736),(129815,4737),(129816,4738),(129817,4739),(129818,4740),(129819,4741),(129820,4742),(129821,4743),(129822,4744),(129823,4745),(129824,4746),(129825,4747),(129826,4748),(129827,4749),(129828,4750),(129829,4751),(129830,4752),(129831,4753),(129832,4754),(129833,4755),(129834,4756),(129835,4757),(129836,4758),(129837,4759),(129838,4760),(129839,4761),(129840,4762),(129841,4763),(129842,4764),(129843,4765),(129844,4766),(129845,4767),(129846,4768),(129847,4769),(129848,4770),(129849,4771),(129850,4772),(129851,4773),(129852,4774),(129853,4775),(129854,4776),(129855,4777),(129856,4778),(129857,4779),(129858,4780),(129859,4781),(129860,4782),(129861,4783),(129862,4784),(129863,4785),(129864,4786),(129865,4787),(129866,4788),(129867,4789),(129868,4790),(129869,4791),(129870,4792),(129871,4793),(129872,4794),(129873,4795),(129874,4796),(129875,4797),(129876,4798),(129877,4799),(129878,4800),(129879,4801),(129880,4802),(129881,4803),(129882,4804),(129883,4805),(129884,4806),(129885,4807),(129886,4808),(129887,4809),(129888,4810),(129889,4811),(129890,4812),(129891,4813),(129892,4814),(129893,4815),(129894,4816),(129895,4817),(129896,4818),(129897,4819),(129898,4820),(129899,4821),(129900,4822),(129901,4823),(129902,4824),(129903,4825),(129904,4826),(129905,4827),(129906,4828),(129907,4829),(129908,4830),(129909,4831),(129910,4832),(129911,4833),(129912,4834),(129913,4835),(129914,4836),(129915,4837),(129916,4838),(129917,4839),(129918,4840),(129919,4841),(129920,4842),(129921,4843),(129922,4844),(129923,4845),(129924,4846),(129925,4847),(129926,4848),(129927,4849),(129928,4850),(129929,4851),(129930,4852),(129931,4853),(129932,4854),(129933,4855),(129934,4856),(129935,4857),(129936,4858),(129937,4859),(129938,4860),(129939,4861),(129940,4862),(129941,4863),(129942,4864),(129943,4865),(129944,4866),(129945,4867),(129946,4868),(129947,4869),(129948,4870),(129949,4871),(129950,4872),(129951,4873),(129952,4874),(129953,4875),(129954,4876),(129955,4877),(129956,4878),(129957,4879),(129958,4880),(129959,4881),(129960,4882),(129961,4883),(129962,4884),(129963,4885),(129964,4886),(129965,4887),(129966,4888),(129967,4889),(129968,4890),(129969,4891),(129970,4892),(129971,4893),(129972,4894),(129973,4895),(129974,4896),(129975,4897),(129976,4898),(129977,4899),(129978,4900),(129979,4901),(129980,4902),(129981,4903),(129982,4904),(129983,4905),(129984,4906),(129985,4907),(129986,4908),(129987,4909),(129988,4910),(129989,4911),(129990,4912),(129991,4913),(129992,4914),(129993,4915),(129994,4916),(129995,4917),(129996,4918),(129997,4919),(129998,4920),(129999,4921),(130000,4922),(130001,4923),(130002,4924),(130003,4925),(130004,4926),(130005,4927),(130006,4928),(130007,4929),(130008,4930),(130009,4931),(130010,4932),(130011,4933),(130012,4934),(130013,4935),(130014,4936),(130015,4937),(130016,4938),(130017,4939),(130018,4940),(130019,4941),(130020,4942),(130021,4943),(130022,4944),(130023,4945),(130024,4946),(130025,4947),(130026,4948),(130027,4949),(130028,4950),(130029,4951),(130030,4952),(130031,4953),(130032,4954),(130033,4955),(130034,4956),(130035,4957),(130036,4958),(130037,4959),(130038,4960),(130039,4961),(130040,4962),(130041,4963),(130042,4964),(130043,4965),(130044,4966),(130045,4967),(130046,4968),(130047,4969),(130048,4970),(130049,4971),(130050,4972),(130051,4973),(130052,4974),(130053,4975),(130054,4976),(130055,4977),(130056,4978),(130057,4979),(130058,4980),(130059,4981),(130060,4982),(130061,4983),(130062,4984),(130063,4985),(130064,4986),(130065,4987),(130066,4988),(130067,4989),(130068,4990),(130069,4991),(130070,4992),(130071,4993),(130072,4994),(130073,4995),(130074,4996),(130075,4997),(130076,4998),(130077,4999),(130078,5000),(130079,5001),(130080,5002),(130081,5003),(130082,5004),(130083,5005),(130084,5006),(130085,5007),(130086,5008),(130087,5009),(130088,5010),(130089,5011),(130090,5012),(130091,5013),(130092,5014),(130093,5015),(130094,5016),(130095,5017),(130096,5018),(130097,5019),(130098,5020),(130099,5021),(130100,5022),(130101,5023),(130102,5024),(130103,5025),(130104,5026),(130105,5027),(130106,5028),(130107,5029),(130108,5030),(130109,5031),(130110,5032),(130111,5033),(130112,5034),(130113,5035),(130114,5036),(130115,5037),(130116,5038),(130117,5039),(130118,5040),(130119,5041),(130120,5042),(130121,5043),(130122,5044),(130123,5045),(130124,5046),(130125,5047),(130126,5048),(130127,5049),(130128,5050),(130129,5051),(130130,5052),(130131,5053),(130132,5054),(130133,5055),(130134,5056),(130135,5057),(130136,5058),(130137,5059),(130138,5060),(130139,5061),(130140,5062),(130141,5063),(130142,5064),(130143,5065),(130144,5066),(130145,5067),(130146,5068),(130147,5069),(130148,5070),(130149,5071),(130150,5072),(130151,5073),(130152,5074),(130153,5075),(130154,5076),(130155,5077),(130156,5078),(130157,5079),(130158,5080),(130159,5081),(130160,5082),(130161,5083),(130162,5084),(130163,5085),(130164,5086),(130165,5087),(130166,5088),(130167,5089),(130168,5090),(130169,5091),(130170,5092),(130171,5093),(130172,5094),(130173,5095),(130174,5096),(130175,5097),(130176,5098),(130177,5099),(130178,5100),(130179,5101),(130180,5102),(130181,5103),(130182,5104),(130183,5105),(130184,5106),(130185,5107),(130186,5108),(130187,5109),(130188,5110),(130189,5111),(130190,5112),(130191,5113),(130192,5114),(130193,5115),(130194,5116),(130195,5117),(130196,5118),(130197,5119),(130198,5120),(130199,5121),(130200,5122),(130201,5123),(130202,5124),(130203,5125),(130204,5126),(130205,5127),(130206,5128),(130207,5129),(130208,5130),(130209,5131),(130210,5132),(130211,5133),(130212,5134),(130213,5135),(130214,5136),(130215,5137),(130216,5138),(130217,5139),(130218,5140),(130219,5141),(130220,5142),(130221,5143),(130222,5144),(130223,5145),(130224,5146),(130225,5147),(130226,5148),(130227,5149),(130228,5150),(130229,5151),(130230,5152),(130231,5153),(130232,5154),(130233,5155),(130234,5156),(130235,5157),(130236,5158),(130237,5159),(130238,5160),(130239,5161),(130240,5162),(130241,5163),(130242,5164),(130243,5165),(130244,5166),(130245,5167),(130246,5168),(130247,5169),(130248,5170),(130249,5171),(130250,5172),(130251,5173),(130252,5174),(130253,5175),(130254,5176),(130255,5177),(130256,5178),(130257,5179),(130258,5180),(130259,5181),(130260,5182),(130261,5183),(130262,5184),(130263,5185),(130264,5186),(130265,5187),(130266,5188),(130267,5189),(130268,5190),(130269,5191),(130270,5192),(130271,5193),(130272,5194),(130273,5195),(130274,5196),(130275,5197),(130276,5198),(130277,5199),(130278,5200),(130279,5201),(130280,5202),(130281,5203),(130282,5204),(130283,5205),(130284,5206),(130285,5207),(130286,5208),(130287,5209),(130288,5210),(130289,5211),(130290,5212),(130291,5213),(130292,5214),(130293,5215),(130294,5216),(130295,5217),(130296,5218),(130297,5219),(130298,5220),(130299,5221),(130300,5222),(130301,5223),(130302,5224),(130303,5225),(130304,5226),(130305,5227),(130306,5228),(130307,5229),(130308,5230),(130309,5231),(130310,5232),(130311,5233),(130312,5234),(130313,5235),(130314,5236),(130315,5237),(130316,5238),(130317,5239),(130318,5240),(130319,5241),(130320,5242),(130321,5243),(130322,5244),(130323,5245),(130324,5246),(130325,5247),(130326,5248),(130327,5249),(130328,5250),(130329,5251),(130330,5252),(130331,5253),(130332,5254),(130333,5255),(130334,5256),(130335,5257),(130336,5258),(130337,5259),(130338,5260),(130339,5261),(130340,5262),(130341,5263),(130342,5264),(130343,5265),(130344,5266),(130345,5267),(130346,5268),(130347,5269),(130348,5270),(130349,5271),(130350,5272),(130351,5273),(130352,5274),(130353,5275),(130354,5276),(130355,5277),(130356,5278),(130357,5279),(130358,5280),(130359,5281),(130360,5282),(130361,5283),(130362,5284),(130363,5285),(130364,5286),(130365,5287),(130366,5288),(130367,5289),(130368,5290),(130369,5291),(130370,5292),(130371,5293),(130372,5294),(130373,5295),(130374,5296),(130375,5297),(130376,5298),(130377,5299),(130378,5300),(130379,5301),(130380,5302),(130381,5303),(130382,5304),(130383,5305),(130384,5306),(130385,5307),(130386,5308),(130387,5309),(130388,5310),(130389,5311),(130390,5312),(130391,5313),(130392,5314),(130393,5315),(130394,5316),(130395,5317),(130396,5318),(130397,5319),(130398,5320),(130399,5321),(130400,5322),(130401,5323),(130402,5324),(130403,5325),(130404,5326),(130405,5327),(130406,5328),(130407,5329),(130408,5330),(130409,5331),(130410,5332),(130411,5333),(130412,5334),(130413,5335),(130414,5336),(130415,5337),(130416,5338),(130417,5339),(130418,5340),(130419,5341),(130420,5342),(130421,5343),(130422,5344),(130423,5345),(130424,5346),(130425,5347),(130426,5348),(130427,5349),(130428,5350),(130429,5351),(130430,5352),(130431,5353),(130432,5354),(130433,5355),(130434,5356),(130435,5357),(130436,5358),(130437,5359),(130438,5360),(130439,5361),(130440,5362),(130441,5363),(130442,5364),(130443,5365),(130444,5366),(130445,5367),(130446,5368),(130447,5369),(130448,5370),(130449,5371),(130450,5372),(130451,5373),(130452,5374),(130453,5375),(130454,5376),(130455,5377),(130456,5378),(130457,5379),(130458,5380),(130459,5381),(130460,5382),(130461,5383),(130462,5384),(130463,5385),(130464,5386),(130465,5387),(130466,5388),(130467,5389),(130468,5390),(130469,5391),(130470,5392),(130471,5393),(130472,5394),(130473,5395),(130474,5396),(130475,5397),(130476,5398),(130477,5399),(130478,5400),(130479,5401),(130480,5402),(130481,5403),(130482,5404),(130483,5405),(130484,5406),(130485,5407),(130486,5408),(130487,5409),(130488,5410),(130489,5411),(130490,5412),(130491,5413),(130492,5414),(130493,5415),(130494,5416),(130495,5417),(130496,5418),(130497,5419),(130498,5420),(130499,5421),(130500,5422),(130501,5423),(130502,5424),(130503,5425),(130504,5426),(130505,5427),(130506,5428),(130507,5429),(130508,5430),(130509,5431),(130510,5432),(130511,5433),(130512,5434),(130513,5435),(130514,5436),(130515,5437),(130516,5438),(130517,5439),(130518,5440),(130519,5441),(130520,5442),(130521,5443),(130522,5444),(130523,5445),(130524,5446),(130525,5447),(130526,5448),(130527,5449),(130528,5450),(130529,5451),(130530,5452),(130531,5453),(130532,5454),(130533,5455),(130534,5456),(130535,5457),(130536,5458),(130537,5459),(130538,5460),(130539,5461),(130540,5462),(130541,5463),(130542,5464),(130543,5465),(130544,5466),(130545,5467),(130546,5468),(130547,5469),(130548,5470),(130549,5471),(130550,5472),(130551,5473),(130552,5474),(130553,5475),(130554,5476),(130555,5477),(130556,5478),(130557,5479),(130558,5480),(130559,5481),(130560,5482),(130561,5483),(130562,5484),(130563,5485),(130564,5486),(130565,5487),(130566,5488),(130567,5489),(130568,5490),(130569,5491),(130570,5492),(130571,5493),(130572,5494),(130573,5495),(130574,5496),(130575,5497),(130576,5498),(130577,5499),(130578,5500),(130579,5501),(130580,5502),(130581,5503),(130582,5504),(130583,5505),(130584,5506),(130585,5507),(130586,5508),(130587,5509),(130588,5510),(130589,5511),(130590,5512),(130591,5513),(130592,5514),(130593,5515),(130594,5516),(130595,5517),(130596,5518),(130597,5519),(130598,5520),(130599,5521),(130600,5522),(130601,5523),(130602,5524),(130603,5525),(130604,5526),(130605,5527),(130606,5528),(130607,5529),(130608,5530),(130609,5531),(130610,5532),(130611,5533),(130612,5534),(130613,5535),(130614,5536),(130615,5537),(130616,5538),(130617,5539),(130618,5540),(130619,5541),(130620,5542),(130621,5543),(130622,5544),(130623,5545),(130624,5546),(130625,5547),(130626,5548),(130627,5549),(130628,5550),(130629,5551),(130630,5552),(130631,5553),(130632,5554),(130633,5555),(130634,5556),(130635,5557),(130636,5558),(130637,5559),(130638,5560),(130639,5561),(130640,5562),(130641,5563),(130642,5564),(130643,5565),(130644,5566),(130645,5567),(130646,5568),(130647,5569),(130648,5570),(130649,5571),(130650,5572),(130651,5573),(130652,5574),(130653,5575),(130654,5576),(130655,5577),(130656,5578),(130657,5579),(130658,5580),(130659,5581),(130660,5582),(130661,5583),(130662,5584),(130663,5585),(130664,5586),(130665,5587),(130666,5588),(130667,5589),(130668,5590),(130669,5591),(130670,5592),(130671,5593),(130672,5594),(130673,5595),(130674,5596),(130675,5597),(130676,5598),(130677,5599),(130678,5600),(130679,5601),(130680,5602),(130681,5603),(130682,5604),(130683,5605),(130684,5606),(130685,5607),(130686,5608),(130687,5609),(130688,5610),(130689,5611),(130690,5612),(130691,5613),(130692,5614),(130693,5615),(130694,5616),(130695,5617),(130696,5618),(130697,5619),(130698,5620),(130699,5621),(130700,5622),(130701,5623),(130702,5624),(130703,5625),(130704,5626),(130705,5627),(130706,5628),(130707,5629),(130708,5630),(130709,5631),(130710,5632),(130711,5633),(130712,5634),(130713,5635),(130714,5636),(130715,5637),(130716,5638),(130717,5639),(130718,5640),(130719,5641),(130720,5642),(130721,5643),(130722,5644),(130723,5645),(130724,5646),(130725,5647),(130726,5648),(130727,5649),(130728,5650),(130729,5651),(130730,5652),(130731,5653),(130732,5654),(130733,5655),(130734,5656),(130735,5657),(130736,5658),(130737,5659),(130738,5660),(130739,5661),(130740,5662),(130741,5663),(130742,5664),(130743,5665),(130744,5666),(130745,5667),(130746,5668),(130747,5669),(130748,5670),(130749,5671),(130750,5672),(130751,5673),(130752,5674),(130753,5675),(130754,5676),(130755,5677),(130756,5678),(130757,5679),(130758,5680),(130759,5681),(130760,5682),(130761,5683),(130762,5684),(130763,5685),(130764,5686),(130765,5687),(130766,5688),(130767,5689),(130768,5690),(130769,5691),(130770,5692),(130771,5693),(130772,5694),(130773,5695),(130774,5696),(130775,5697),(130776,5698),(130777,5699),(130778,5700),(130779,5701),(130780,5702),(130781,5703),(130782,5704),(130783,5705),(130784,5706),(130785,5707),(130786,5708),(130787,5709),(130788,5710),(130789,5711),(130790,5712),(130791,5713),(130792,5714),(130793,5715),(130794,5716),(130795,5717),(130796,5718),(130797,5719),(130798,5720),(130799,5721),(130800,5722),(130801,5723),(130802,5724),(130803,5725),(130804,5726),(130805,5727),(130806,5728),(130807,5729),(130808,5730),(130809,5731),(130810,5732),(130811,5733),(130812,5734),(130813,5735),(130814,5736),(130815,5737),(130816,5738),(130817,5739),(130818,5740),(130819,5741),(130820,5742),(130821,5743),(130822,5744),(130823,5745),(130824,5746),(130825,5747),(130826,5748),(130827,5749),(130828,5750),(130829,5751),(130830,5752),(130831,5753),(130832,5754),(130833,5755),(130834,5756),(130835,5757),(130836,5758),(130837,5759),(130838,5760),(130839,5760),(130840,5760),(130841,5760),(130842,5760),(130843,5760),(130844,5760),(130845,5760),(130846,5760),(130847,5760),(130848,5760),(130849,5760),(130850,5760),(130851,5760),(130852,5760),(130853,5760),(130854,5760),(130855,5760),(130856,5760),(130857,5760),(130858,5760),(130859,5760),(130860,5760),(130861,5760),(130862,5760),(130863,5760),(130864,5760),(130865,5760),(130866,5760),(130867,5760),(130868,5760),(130869,5760),(130870,5760),(130871,5760),(130872,5760),(130873,5760),(130874,5760),(130875,5760),(130876,5760),(130877,5760),(130878,5760),(130879,5760),(130880,5761),(130881,5762),(130882,5763),(130883,5764),(130884,5765),(130885,5766),(130886,5767),(130887,5768),(130888,5769),(130889,5770),(130890,5771),(130891,5772),(130892,5773),(130893,5774),(130894,5775),(130895,5776),(130896,5777),(130897,5778),(130898,5779),(130899,5780),(130900,5781),(130901,5782),(130902,5783),(130903,5784),(130904,5785),(130905,5786),(130906,5787),(130907,5788),(130908,5789),(130909,5790),(130910,5791),(130911,5792),(130912,5793),(130913,5794),(130914,5795),(130915,5796),(130916,5797),(130917,5798),(130918,5799),(130919,5800),(130920,5801),(130921,5802),(130922,5803),(130923,5804),(130924,5805),(130925,5806),(130926,5807),(130927,5808),(130928,5809),(130929,5810),(130930,5811),(130931,5812),(130932,5813),(130933,5814),(130934,5815),(130935,5816),(130936,5817),(130937,5818),(130938,5819),(130939,5820),(130940,5821),(130941,5822),(130942,5823),(130943,5824),(130944,5825),(130945,5826),(130946,5827),(130947,5828),(130948,5829),(130949,5830),(130950,5831),(130951,5832),(130952,5833),(130953,5834),(130954,5835),(130955,5836),(130956,5837),(130957,5838),(130958,5839),(130959,5840),(130960,5841),(130961,5842),(130962,5843),(130963,5844),(130964,5845),(130965,5846),(130966,5847),(130967,5848),(130968,5849),(130969,5850),(130970,5851),(130971,5852),(130972,5853),(130973,5854),(130974,5855),(130975,5856),(130976,5857),(130977,5858),(130978,5859),(130979,5860),(130980,5761),(130981,5761),(130982,5761),(130983,5761),(130984,5761),(130985,5761),(130986,5761),(130987,5762),(130988,5762),(130989,5762),(130990,5762),(130991,5762),(130992,5762),(130993,5762),(130994,5763),(130995,5763),(130996,5763),(130997,5763),(130998,5763),(130999,5763),(131000,5763),(131001,5764),(131002,5764),(131003,5764),(131004,5764),(131005,5764),(131006,5764),(131007,5764),(131008,5765),(131009,5765),(131010,5765),(131011,5765),(131012,5765),(131013,5765),(131014,5765),(131015,5766),(131016,5766),(131017,5766),(131018,5766),(131019,5766),(131020,5766),(131021,5766),(131022,5767),(131023,5767),(131024,5767),(131025,5767),(131026,5767),(131027,5767),(131028,5767),(131029,5768),(131030,5768),(131031,5768),(131032,5768),(131033,5768),(131034,5768),(131035,5768),(131036,5769),(131037,5769),(131038,5769),(131039,5769),(131040,5770),(131041,5770),(131042,5770),(131043,5770),(131044,5770),(131045,5770),(131046,5771),(131047,5771),(131048,5771),(131049,5771),(131050,5772),(131051,5772),(131052,5772),(131053,5772),(131054,5773),(131055,5773),(131056,5773),(131057,5773),(131058,5774),(131059,5774),(131060,5774),(131061,5774),(131062,5775),(131063,5775),(131064,5775),(131065,5775),(131066,5776),(131067,5776),(131068,5776),(131069,5776),(131070,5777),(131071,5777),(131072,5777),(131073,5777),(131074,5777),(131075,5777),(131076,5777),(131077,5778),(131078,5778),(131079,5778),(131080,5778),(131081,5778),(131082,5778),(131083,5778),(131084,5779),(131085,5779),(131086,5779),(131087,5779),(131088,5779),(131089,5779),(131090,5779),(131091,5780),(131092,5780),(131093,5780),(131094,5780),(131095,5781),(131096,5781),(131097,5781),(131098,5781),(131099,5781),(131100,5781),(131101,5781),(131102,5782),(131103,5782),(131104,5782),(131105,5782),(131106,5782),(131107,5782),(131108,5782),(131109,5783),(131110,5783),(131111,5783),(131112,5783),(131113,5783),(131114,5783),(131115,5783),(131116,5784),(131117,5784),(131118,5784),(131119,5784),(131120,5784),(131121,5784),(131122,5784),(131123,5785),(131124,5785),(131125,5785),(131126,5785),(131127,5785),(131128,5785),(131129,5785),(131130,5786),(131131,5786),(131132,5786),(131133,5786),(131134,5786),(131135,5786),(131136,5786),(131137,5787),(131138,5787),(131139,5787),(131140,5787),(131141,5788),(131142,5788),(131143,5788),(131144,5788),(131145,5788),(131146,5788),(131147,5788),(131148,5789),(131149,5789),(131150,5789),(131151,5789),(131152,5789),(131153,5789),(131154,5789),(131155,5790),(131156,5790),(131157,5790),(131158,5790),(131159,5790),(131160,5790),(131161,5790),(131162,5791),(131163,5791),(131164,5791),(131165,5791),(131166,5791),(131167,5791),(131168,5791),(131169,5792),(131170,5792),(131171,5792),(131172,5792),(131173,5792),(131174,5792),(131175,5792),(131176,5793),(131177,5793),(131178,5793),(131179,5793),(131180,5793),(131181,5793),(131182,5794),(131183,5794),(131184,5794),(131185,5794),(131186,5794),(131187,5794),(131188,5794),(131189,5795),(131190,5795),(131191,5795),(131192,5795),(131193,5795),(131194,5795),(131195,5795),(131196,5796),(131197,5796),(131198,5796),(131199,5796),(131200,5796),(131201,5796),(131202,5796),(131203,5797),(131204,5797),(131205,5797),(131206,5797),(131207,5797),(131208,5797),(131209,5797),(131210,5798),(131211,5798),(131212,5798),(131213,5798),(131214,5798),(131215,5798),(131216,5798),(131217,5799),(131218,5799),(131219,5799),(131220,5799),(131221,5799),(131222,5799),(131223,5799),(131224,5800),(131225,5800),(131226,5800),(131227,5800),(131228,5800),(131229,5800),(131230,5800),(131231,5801),(131232,5801),(131233,5801),(131234,5801),(131235,5801),(131236,5801),(131237,5801),(131238,5802),(131239,5802),(131240,5802),(131241,5802),(131242,5802),(131243,5802),(131244,5802),(131245,5803),(131246,5803),(131247,5803),(131248,5803),(131249,5803),(131250,5803),(131251,5803),(131252,5804),(131253,5804),(131254,5804),(131255,5804),(131256,5804),(131257,5804),(131258,5804),(131259,5805),(131260,5805),(131261,5805),(131262,5805),(131263,5805),(131264,5805),(131265,5805),(131266,5806),(131267,5806),(131268,5806),(131269,5806),(131270,5806),(131271,5806),(131272,5806),(131273,5807),(131274,5807),(131275,5807),(131276,5807),(131277,5807),(131278,5807),(131279,5807),(131280,5807),(131281,5807),(131282,5808),(131283,5808),(131284,5808),(131285,5808),(131286,5808),(131287,5808),(131288,5808),(131289,5808),(131290,5808),(131291,5809),(131292,5809),(131293,5809),(131294,5809),(131295,5809),(131296,5809),(131297,5809),(131298,5809),(131299,5809),(131300,5810),(131301,5810),(131302,5810),(131303,5810),(131304,5810),(131305,5810),(131306,5810),(131307,5810),(131308,5810),(131309,5811),(131310,5811),(131311,5811),(131312,5811),(131313,5811),(131314,5811),(131315,5811),(131316,5811),(131317,5811),(131318,5812),(131319,5812),(131320,5812),(131321,5812),(131322,5812),(131323,5812),(131324,5812),(131325,5812),(131326,5812),(131327,5813),(131328,5813),(131329,5813),(131330,5813),(131331,5813),(131332,5813),(131333,5813),(131334,5813),(131335,5813),(131336,5814),(131337,5814),(131338,5814),(131339,5814),(131340,5814),(131341,5814),(131342,5814),(131343,5814),(131344,5814),(131345,5815),(131346,5815),(131347,5815),(131348,5815),(131349,5815),(131350,5815),(131351,5815),(131352,5815),(131353,5815),(131354,5816),(131355,5816),(131356,5816),(131357,5816),(131358,5816),(131359,5816),(131360,5816),(131361,5816),(131362,5816),(131363,5817),(131364,5817),(131365,5817),(131366,5817),(131367,5817),(131368,5817),(131369,5817),(131370,5817),(131371,5817),(131372,5818),(131373,5818),(131374,5818),(131375,5818),(131376,5818),(131377,5818),(131378,5818),(131379,5818),(131380,5818),(131381,5819),(131382,5819),(131383,5819),(131384,5819),(131385,5819),(131386,5819),(131387,5819),(131388,5820),(131389,5820),(131390,5820),(131391,5820),(131392,5820),(131393,5820),(131394,5820),(131395,5821),(131396,5821),(131397,5821),(131398,5821),(131399,5821),(131400,5821),(131401,5821),(131402,5822),(131403,5822),(131404,5822),(131405,5822),(131406,5823),(131407,5823),(131408,5823),(131409,5823),(131410,5824),(131411,5824),(131412,5824),(131413,5824),(131414,5824),(131415,5824),(131416,5824),(131417,5825),(131418,5825),(131419,5825),(131420,5825),(131421,5826),(131422,5826),(131423,5826),(131424,5826),(131425,5827),(131426,5827),(131427,5827),(131428,5827),(131429,5828),(131430,5828),(131431,5828),(131432,5828),(131433,5829),(131434,5829),(131435,5829),(131436,5829),(131437,5830),(131438,5830),(131439,5830),(131440,5830),(131441,5831),(131442,5831),(131443,5831),(131444,5831),(131445,5832),(131446,5832),(131447,5832),(131448,5832),(131449,5832),(131450,5832),(131451,5832),(131452,5833),(131453,5833),(131454,5833),(131455,5833),(131456,5833),(131457,5833),(131458,5833),(131459,5834),(131460,5834),(131461,5834),(131462,5834),(131463,5834),(131464,5834),(131465,5834),(131466,5835),(131467,5835),(131468,5835),(131469,5835),(131470,5835),(131471,5835),(131472,5835),(131473,5836),(131474,5836),(131475,5836),(131476,5836),(131477,5836),(131478,5836),(131479,5836),(131480,5837),(131481,5837),(131482,5837),(131483,5837),(131484,5837),(131485,5837),(131486,5837),(131487,5838),(131488,5838),(131489,5838),(131490,5838),(131491,5838),(131492,5838),(131493,5838),(131494,5839),(131495,5839),(131496,5839),(131497,5839),(131498,5839),(131499,5839),(131500,5839),(131501,5840),(131502,5840),(131503,5840),(131504,5840),(131505,5840),(131506,5840),(131507,5840),(131508,5840),(131509,5840),(131510,5841),(131511,5841),(131512,5841),(131513,5841),(131514,5841),(131515,5841),(131516,5841),(131517,5842),(131518,5842),(131519,5842),(131520,5842),(131521,5842),(131522,5842),(131523,5842),(131524,5843),(131525,5843),(131526,5843),(131527,5843),(131528,5843),(131529,5843),(131530,5843),(131531,5843),(131532,5843),(131533,5844),(131534,5844),(131535,5844),(131536,5844),(131537,5844),(131538,5844),(131539,5844),(131540,5845),(131541,5845),(131542,5845),(131543,5845),(131544,5845),(131545,5845),(131546,5845),(131547,5846),(131548,5846),(131549,5846),(131550,5846),(131551,5846),(131552,5846),(131553,5846),(131554,5847),(131555,5847),(131556,5847),(131557,5847),(131558,5847),(131559,5847),(131560,5847),(131561,5848),(131562,5848),(131563,5848),(131564,5848),(131565,5848),(131566,5848),(131567,5848),(131568,5849),(131569,5849),(131570,5849),(131571,5849),(131572,5849),(131573,5849),(131574,5849),(131575,5850),(131576,5850),(131577,5850),(131578,5850),(131579,5850),(131580,5850),(131581,5850),(131582,5850),(131583,5850),(131584,5851),(131585,5851),(131586,5851),(131587,5851),(131588,5851),(131589,5851),(131590,5851),(131591,5851),(131592,5851),(131593,5852),(131594,5852),(131595,5852),(131596,5852),(131597,5852),(131598,5852),(131599,5852),(131600,5852),(131601,5852),(131602,5853),(131603,5853),(131604,5853),(131605,5853),(131606,5853),(131607,5853),(131608,5853),(131609,5853),(131610,5853),(131611,5854),(131612,5854),(131613,5854),(131614,5854),(131615,5854),(131616,5854),(131617,5854),(131618,5854),(131619,5854),(131620,5855),(131621,5855),(131622,5855),(131623,5855),(131624,5855),(131625,5855),(131626,5855),(131627,5855),(131628,5855),(131629,5856),(131630,5856),(131631,5856),(131632,5856),(131633,5856),(131634,5856),(131635,5856),(131636,5856),(131637,5856),(131638,5857),(131639,5857),(131640,5857),(131641,5857),(131642,5857),(131643,5857),(131644,5857),(131645,5857),(131646,5857),(131647,5858),(131648,5858),(131649,5858),(131650,5858),(131651,5858),(131652,5858),(131653,5858),(131654,5858),(131655,5858),(131656,5859),(131657,5859),(131658,5859),(131659,5859),(131660,5859),(131661,5859),(131662,5859),(131663,5859),(131664,5859),(131665,5860),(131666,5860),(131667,5860),(131668,5860),(131669,5860),(131670,5860),(131671,5860),(131672,5860),(131673,5860),(131674,5761),(131675,5761),(131676,5761),(131677,5762),(131678,5762),(131679,5762),(131680,5763),(131681,5763),(131682,5763),(131683,5764),(131684,5764),(131685,5764),(131686,5765),(131687,5765),(131688,5765),(131689,5766),(131690,5766),(131691,5766),(131692,5767),(131693,5767),(131694,5767),(131695,5768),(131696,5768),(131697,5768),(131698,5769),(131699,5769),(131700,5769),(131701,5770),(131702,5770),(131703,5770),(131704,5771),(131705,5771),(131706,5771),(131707,5772),(131708,5772),(131709,5772),(131710,5773),(131711,5773),(131712,5773),(131713,5774),(131714,5774),(131715,5774),(131716,5775),(131717,5775),(131718,5775),(131719,5776),(131720,5776),(131721,5776),(131722,5777),(131723,5777),(131724,5777),(131725,5778),(131726,5778),(131727,5778),(131728,5779),(131729,5779),(131730,5779),(131731,5780),(131732,5780),(131733,5780),(131734,5781),(131735,5781),(131736,5781),(131737,5782),(131738,5782),(131739,5782),(131740,5783),(131741,5783),(131742,5783),(131743,5784),(131744,5784),(131745,5784),(131746,5785),(131747,5785),(131748,5785),(131749,5786),(131750,5786),(131751,5786),(131752,5787),(131753,5787),(131754,5787),(131755,5788),(131756,5788),(131757,5788),(131758,5789),(131759,5789),(131760,5789),(131761,5790),(131762,5790),(131763,5790),(131764,5791),(131765,5791),(131766,5791),(131767,5792),(131768,5792),(131769,5792),(131770,5793),(131771,5794),(131772,5794),(131773,5794),(131774,5795),(131775,5795),(131776,5795),(131777,5796),(131778,5796),(131779,5796),(131780,5797),(131781,5797),(131782,5797),(131783,5798),(131784,5798),(131785,5798),(131786,5799),(131787,5799),(131788,5799),(131789,5800),(131790,5800),(131791,5800),(131792,5801),(131793,5801),(131794,5801),(131795,5802),(131796,5802),(131797,5802),(131798,5803),(131799,5803),(131800,5803),(131801,5804),(131802,5804),(131803,5804),(131804,5805),(131805,5805),(131806,5805),(131807,5806),(131808,5806),(131809,5806),(131810,5807),(131811,5807),(131812,5807),(131813,5808),(131814,5808),(131815,5808),(131816,5809),(131817,5809),(131818,5809),(131819,5810),(131820,5810),(131821,5810),(131822,5811),(131823,5811),(131824,5811),(131825,5812),(131826,5812),(131827,5812),(131828,5813),(131829,5813),(131830,5813),(131831,5814),(131832,5814),(131833,5814),(131834,5815),(131835,5815),(131836,5815),(131837,5816),(131838,5816),(131839,5816),(131840,5817),(131841,5817),(131842,5817),(131843,5818),(131844,5818),(131845,5818),(131846,5819),(131847,5819),(131848,5819),(131849,5820),(131850,5820),(131851,5820),(131852,5821),(131853,5821),(131854,5821),(131855,5822),(131856,5822),(131857,5822),(131858,5823),(131859,5823),(131860,5823),(131861,5824),(131862,5824),(131863,5824),(131864,5825),(131865,5825),(131866,5825),(131867,5826),(131868,5826),(131869,5826),(131870,5827),(131871,5827),(131872,5827),(131873,5828),(131874,5828),(131875,5828),(131876,5829),(131877,5829),(131878,5829),(131879,5830),(131880,5830),(131881,5830),(131882,5831),(131883,5831),(131884,5831),(131885,5832),(131886,5832),(131887,5832),(131888,5833),(131889,5833),(131890,5833),(131891,5834),(131892,5834),(131893,5834),(131894,5835),(131895,5835),(131896,5835),(131897,5836),(131898,5836),(131899,5836),(131900,5837),(131901,5837),(131902,5837),(131903,5838),(131904,5838),(131905,5838),(131906,5839),(131907,5839),(131908,5839),(131909,5840),(131910,5840),(131911,5840),(131912,5841),(131913,5841),(131914,5841),(131915,5842),(131916,5842),(131917,5842),(131918,5843),(131919,5843),(131920,5843),(131921,5844),(131922,5844),(131923,5844),(131924,5845),(131925,5845),(131926,5845),(131927,5846),(131928,5846),(131929,5846),(131930,5847),(131931,5847),(131932,5847),(131933,5848),(131934,5848),(131935,5848),(131936,5849),(131937,5849),(131938,5849),(131939,5850),(131940,5850),(131941,5851),(131942,5851),(131943,5852),(131944,5852),(131945,5853),(131946,5853),(131947,5854),(131948,5854),(131949,5855),(131950,5855),(131951,5856),(131952,5856),(131953,5857),(131954,5857),(131955,5858),(131956,5858),(131957,5859),(131958,5859),(131959,5860),(131960,5860),(131961,5761),(131962,5761),(131963,5761),(131964,5761),(131965,5761),(131966,5761),(131967,5761),(131968,5761),(131969,5761),(131970,5761),(131971,5761),(131972,5762),(131973,5762),(131974,5762),(131975,5762),(131976,5762),(131977,5762),(131978,5762),(131979,5762),(131980,5762),(131981,5762),(131982,5762),(131983,5763),(131984,5763),(131985,5763),(131986,5763),(131987,5763),(131988,5763),(131989,5763),(131990,5763),(131991,5763),(131992,5763),(131993,5763),(131994,5764),(131995,5764),(131996,5764),(131997,5764),(131998,5764),(131999,5764),(132000,5764),(132001,5764),(132002,5764),(132003,5764),(132004,5764),(132005,5765),(132006,5765),(132007,5765),(132008,5765),(132009,5765),(132010,5765),(132011,5765),(132012,5765),(132013,5765),(132014,5765),(132015,5765),(132016,5766),(132017,5766),(132018,5766),(132019,5766),(132020,5766),(132021,5766),(132022,5766),(132023,5766),(132024,5766),(132025,5766),(132026,5766),(132027,5767),(132028,5767),(132029,5767),(132030,5767),(132031,5767),(132032,5767),(132033,5767),(132034,5767),(132035,5767),(132036,5767),(132037,5767),(132038,5768),(132039,5768),(132040,5768),(132041,5768),(132042,5768),(132043,5768),(132044,5768),(132045,5768),(132046,5768),(132047,5768),(132048,5768),(132049,5769),(132050,5769),(132051,5769),(132052,5769),(132053,5769),(132054,5769),(132055,5769),(132056,5769),(132057,5769),(132058,5769),(132059,5769),(132060,5770),(132061,5770),(132062,5770),(132063,5770),(132064,5770),(132065,5770),(132066,5770),(132067,5770),(132068,5770),(132069,5770),(132070,5770),(132071,5771),(132072,5771),(132073,5771),(132074,5771),(132075,5771),(132076,5771),(132077,5771),(132078,5771),(132079,5771),(132080,5771),(132081,5771),(132082,5772),(132083,5772),(132084,5772),(132085,5772),(132086,5772),(132087,5772),(132088,5772),(132089,5772),(132090,5772),(132091,5772),(132092,5772),(132093,5773),(132094,5773),(132095,5773),(132096,5773),(132097,5773),(132098,5773),(132099,5773),(132100,5773),(132101,5773),(132102,5773),(132103,5773),(132104,5774),(132105,5774),(132106,5774),(132107,5774),(132108,5774),(132109,5774),(132110,5774),(132111,5774),(132112,5774),(132113,5774),(132114,5774),(132115,5775),(132116,5775),(132117,5775),(132118,5775),(132119,5775),(132120,5775),(132121,5775),(132122,5775),(132123,5775),(132124,5775),(132125,5775),(132126,5776),(132127,5776),(132128,5776),(132129,5776),(132130,5776),(132131,5776),(132132,5776),(132133,5776),(132134,5776),(132135,5776),(132136,5776),(132137,5777),(132138,5777),(132139,5777),(132140,5777),(132141,5777),(132142,5777),(132143,5777),(132144,5777),(132145,5777),(132146,5777),(132147,5777),(132148,5778),(132149,5778),(132150,5778),(132151,5778),(132152,5778),(132153,5778),(132154,5778),(132155,5778),(132156,5778),(132157,5778),(132158,5778),(132159,5779),(132160,5779),(132161,5779),(132162,5779),(132163,5779),(132164,5779),(132165,5779),(132166,5779),(132167,5779),(132168,5779),(132169,5779),(132170,5780),(132171,5780),(132172,5780),(132173,5780),(132174,5780),(132175,5780),(132176,5780),(132177,5780),(132178,5780),(132179,5780),(132180,5780),(132181,5781),(132182,5781),(132183,5781),(132184,5781),(132185,5781),(132186,5781),(132187,5781),(132188,5781),(132189,5781),(132190,5781),(132191,5781),(132192,5782),(132193,5782),(132194,5782),(132195,5782),(132196,5782),(132197,5782),(132198,5782),(132199,5782),(132200,5782),(132201,5782),(132202,5782),(132203,5783),(132204,5783),(132205,5783),(132206,5783),(132207,5783),(132208,5783),(132209,5783),(132210,5783),(132211,5783),(132212,5783),(132213,5783),(132214,5784),(132215,5784),(132216,5784),(132217,5784),(132218,5784),(132219,5784),(132220,5784),(132221,5784),(132222,5784),(132223,5784),(132224,5784),(132225,5785),(132226,5785),(132227,5785),(132228,5785),(132229,5785),(132230,5785),(132231,5785),(132232,5785),(132233,5785),(132234,5785),(132235,5785),(132236,5786),(132237,5786),(132238,5786),(132239,5786),(132240,5786),(132241,5786),(132242,5786),(132243,5786),(132244,5786),(132245,5786),(132246,5786),(132247,5787),(132248,5787),(132249,5787),(132250,5787),(132251,5787),(132252,5787),(132253,5787),(132254,5787),(132255,5787),(132256,5787),(132257,5787),(132258,5788),(132259,5788),(132260,5788),(132261,5788),(132262,5788),(132263,5788),(132264,5788),(132265,5788),(132266,5788),(132267,5788),(132268,5788),(132269,5789),(132270,5789),(132271,5789),(132272,5789),(132273,5789),(132274,5789),(132275,5789),(132276,5789),(132277,5789),(132278,5789),(132279,5789),(132280,5790),(132281,5790),(132282,5790),(132283,5790),(132284,5790),(132285,5790),(132286,5790),(132287,5790),(132288,5790),(132289,5790),(132290,5790),(132291,5791),(132292,5791),(132293,5791),(132294,5791),(132295,5791),(132296,5791),(132297,5791),(132298,5791),(132299,5791),(132300,5791),(132301,5791),(132302,5792),(132303,5792),(132304,5792),(132305,5792),(132306,5792),(132307,5792),(132308,5792),(132309,5792),(132310,5792),(132311,5792),(132312,5792),(132313,5793),(132314,5793),(132315,5793),(132316,5793),(132317,5793),(132318,5793),(132319,5793),(132320,5793),(132321,5793),(132322,5793),(132323,5793),(132324,5794),(132325,5794),(132326,5794),(132327,5794),(132328,5794),(132329,5794),(132330,5794),(132331,5794),(132332,5794),(132333,5794),(132334,5794),(132335,5795),(132336,5795),(132337,5795),(132338,5795),(132339,5795),(132340,5795),(132341,5795),(132342,5795),(132343,5795),(132344,5795),(132345,5795),(132346,5796),(132347,5796),(132348,5796),(132349,5796),(132350,5796),(132351,5796),(132352,5796),(132353,5796),(132354,5796),(132355,5796),(132356,5796),(132357,5797),(132358,5797),(132359,5797),(132360,5797),(132361,5797),(132362,5797),(132363,5797),(132364,5797),(132365,5797),(132366,5797),(132367,5797),(132368,5798),(132369,5798),(132370,5798),(132371,5798),(132372,5798),(132373,5798),(132374,5798),(132375,5798),(132376,5798),(132377,5798),(132378,5798),(132379,5799),(132380,5799),(132381,5799),(132382,5799),(132383,5799),(132384,5799),(132385,5799),(132386,5799),(132387,5799),(132388,5799),(132389,5799),(132390,5800),(132391,5800),(132392,5800),(132393,5800),(132394,5800),(132395,5800),(132396,5800),(132397,5800),(132398,5800),(132399,5800),(132400,5800),(132401,5801),(132402,5801),(132403,5801),(132404,5801),(132405,5801),(132406,5801),(132407,5801),(132408,5801),(132409,5801),(132410,5801),(132411,5801),(132412,5802),(132413,5802),(132414,5802),(132415,5802),(132416,5802),(132417,5802),(132418,5802),(132419,5802),(132420,5802),(132421,5802),(132422,5802),(132423,5803),(132424,5803),(132425,5803),(132426,5803),(132427,5803),(132428,5803),(132429,5803),(132430,5803),(132431,5803),(132432,5803),(132433,5803),(132434,5804),(132435,5804),(132436,5804),(132437,5804),(132438,5804),(132439,5804),(132440,5804),(132441,5804),(132442,5804),(132443,5804),(132444,5804),(132445,5805),(132446,5805),(132447,5805),(132448,5805),(132449,5805),(132450,5805),(132451,5805),(132452,5805),(132453,5805),(132454,5805),(132455,5805),(132456,5806),(132457,5806),(132458,5806),(132459,5806),(132460,5806),(132461,5806),(132462,5806),(132463,5806),(132464,5806),(132465,5806),(132466,5806),(132467,5807),(132468,5807),(132469,5807),(132470,5807),(132471,5807),(132472,5807),(132473,5807),(132474,5807),(132475,5807),(132476,5807),(132477,5807),(132478,5808),(132479,5808),(132480,5808),(132481,5808),(132482,5808),(132483,5808),(132484,5808),(132485,5808),(132486,5808),(132487,5808),(132488,5808),(132489,5809),(132490,5809),(132491,5809),(132492,5809),(132493,5809),(132494,5809),(132495,5809),(132496,5809),(132497,5809),(132498,5809),(132499,5809),(132500,5810),(132501,5810),(132502,5810),(132503,5810),(132504,5810),(132505,5810),(132506,5810),(132507,5810),(132508,5810),(132509,5810),(132510,5810),(132511,5811),(132512,5811),(132513,5811),(132514,5811),(132515,5811),(132516,5811),(132517,5811),(132518,5811),(132519,5811),(132520,5811),(132521,5811),(132522,5812),(132523,5812),(132524,5812),(132525,5812),(132526,5812),(132527,5812),(132528,5812),(132529,5812),(132530,5812),(132531,5812),(132532,5812),(132533,5813),(132534,5813),(132535,5813),(132536,5813),(132537,5813),(132538,5813),(132539,5813),(132540,5813),(132541,5813),(132542,5813),(132543,5813),(132544,5814),(132545,5814),(132546,5814),(132547,5814),(132548,5814),(132549,5814),(132550,5814),(132551,5814),(132552,5814),(132553,5814),(132554,5814),(132555,5815),(132556,5815),(132557,5815),(132558,5815),(132559,5815),(132560,5815),(132561,5815),(132562,5815),(132563,5815),(132564,5815),(132565,5815),(132566,5816),(132567,5816),(132568,5816),(132569,5816),(132570,5816),(132571,5816),(132572,5816),(132573,5816),(132574,5816),(132575,5816),(132576,5816),(132577,5817),(132578,5817),(132579,5817),(132580,5817),(132581,5817),(132582,5817),(132583,5817),(132584,5817),(132585,5817),(132586,5817),(132587,5817),(132588,5818),(132589,5818),(132590,5818),(132591,5818),(132592,5818),(132593,5818),(132594,5818),(132595,5818),(132596,5818),(132597,5818),(132598,5818),(132599,5819),(132600,5819),(132601,5819),(132602,5819),(132603,5819),(132604,5819),(132605,5819),(132606,5819),(132607,5819),(132608,5819),(132609,5819),(132610,5820),(132611,5820),(132612,5820),(132613,5820),(132614,5820),(132615,5820),(132616,5820),(132617,5820),(132618,5820),(132619,5820),(132620,5820),(132621,5821),(132622,5821),(132623,5821),(132624,5821),(132625,5821),(132626,5821),(132627,5821),(132628,5821),(132629,5821),(132630,5821),(132631,5821),(132632,5822),(132633,5822),(132634,5822),(132635,5822),(132636,5822),(132637,5822),(132638,5822),(132639,5822),(132640,5822),(132641,5822),(132642,5822),(132643,5823),(132644,5823),(132645,5823),(132646,5823),(132647,5823),(132648,5823),(132649,5823),(132650,5823),(132651,5823),(132652,5823),(132653,5823),(132654,5824),(132655,5824),(132656,5824),(132657,5824),(132658,5824),(132659,5824),(132660,5824),(132661,5824),(132662,5824),(132663,5824),(132664,5824),(132665,5825),(132666,5825),(132667,5825),(132668,5825),(132669,5825),(132670,5825),(132671,5825),(132672,5825),(132673,5825),(132674,5825),(132675,5825),(132676,5826),(132677,5826),(132678,5826),(132679,5826),(132680,5826),(132681,5826),(132682,5826),(132683,5826),(132684,5826),(132685,5826),(132686,5826),(132687,5827),(132688,5827),(132689,5827),(132690,5827),(132691,5827),(132692,5827),(132693,5827),(132694,5827),(132695,5827),(132696,5827),(132697,5827),(132698,5828),(132699,5828),(132700,5828),(132701,5828),(132702,5828),(132703,5828),(132704,5828),(132705,5828),(132706,5828),(132707,5828),(132708,5828),(132709,5829),(132710,5829),(132711,5829),(132712,5829),(132713,5829),(132714,5829),(132715,5829),(132716,5829),(132717,5829),(132718,5829),(132719,5829),(132720,5830),(132721,5830),(132722,5830),(132723,5830),(132724,5830),(132725,5830),(132726,5830),(132727,5830),(132728,5830),(132729,5830),(132730,5830),(132731,5831),(132732,5831),(132733,5831),(132734,5831),(132735,5831),(132736,5831),(132737,5831),(132738,5831),(132739,5831),(132740,5831),(132741,5831),(132742,5832),(132743,5832),(132744,5832),(132745,5832),(132746,5832),(132747,5832),(132748,5832),(132749,5832),(132750,5832),(132751,5832),(132752,5832),(132753,5833),(132754,5833),(132755,5833),(132756,5833),(132757,5833),(132758,5833),(132759,5833),(132760,5833),(132761,5833),(132762,5833),(132763,5833),(132764,5834),(132765,5834),(132766,5834),(132767,5834),(132768,5834),(132769,5834),(132770,5834),(132771,5834),(132772,5834),(132773,5834),(132774,5834),(132775,5835),(132776,5835),(132777,5835),(132778,5835),(132779,5835),(132780,5835),(132781,5835),(132782,5835),(132783,5835),(132784,5835),(132785,5835),(132786,5836),(132787,5836),(132788,5836),(132789,5836),(132790,5836),(132791,5836),(132792,5836),(132793,5836),(132794,5836),(132795,5836),(132796,5836),(132797,5837),(132798,5837),(132799,5837),(132800,5837),(132801,5837),(132802,5837),(132803,5837),(132804,5837),(132805,5837),(132806,5837),(132807,5837),(132808,5838),(132809,5838),(132810,5838),(132811,5838),(132812,5838),(132813,5838),(132814,5838),(132815,5838),(132816,5838),(132817,5838),(132818,5838),(132819,5839),(132820,5839),(132821,5839),(132822,5839),(132823,5839),(132824,5839),(132825,5839),(132826,5839),(132827,5839),(132828,5839),(132829,5839),(132830,5840),(132831,5840),(132832,5840),(132833,5840),(132834,5840),(132835,5840),(132836,5840),(132837,5840),(132838,5840),(132839,5840),(132840,5840),(132841,5841),(132842,5841),(132843,5841),(132844,5841),(132845,5841),(132846,5841),(132847,5841),(132848,5841),(132849,5841),(132850,5841),(132851,5841),(132852,5842),(132853,5842),(132854,5842),(132855,5842),(132856,5842),(132857,5842),(132858,5842),(132859,5842),(132860,5842),(132861,5842),(132862,5842),(132863,5843),(132864,5843),(132865,5843),(132866,5843),(132867,5843),(132868,5843),(132869,5843),(132870,5843),(132871,5843),(132872,5843),(132873,5843),(132874,5844),(132875,5844),(132876,5844),(132877,5844),(132878,5844),(132879,5844),(132880,5844),(132881,5844),(132882,5844),(132883,5844),(132884,5844),(132885,5845),(132886,5845),(132887,5845),(132888,5845),(132889,5845),(132890,5845),(132891,5845),(132892,5845),(132893,5845),(132894,5845),(132895,5845),(132896,5846),(132897,5846),(132898,5846),(132899,5846),(132900,5846),(132901,5846),(132902,5846),(132903,5846),(132904,5846),(132905,5846),(132906,5846),(132907,5847),(132908,5847),(132909,5847),(132910,5847),(132911,5847),(132912,5847),(132913,5847),(132914,5847),(132915,5847),(132916,5847),(132917,5847),(132918,5848),(132919,5848),(132920,5848),(132921,5848),(132922,5848),(132923,5848),(132924,5848),(132925,5848),(132926,5848),(132927,5848),(132928,5848),(132929,5849),(132930,5849),(132931,5849),(132932,5849),(132933,5849),(132934,5849),(132935,5849),(132936,5849),(132937,5849),(132938,5849),(132939,5849),(132940,5850),(132941,5850),(132942,5850),(132943,5850),(132944,5850),(132945,5850),(132946,5850),(132947,5850),(132948,5850),(132949,5850),(132950,5850),(132951,5851),(132952,5851),(132953,5851),(132954,5851),(132955,5851),(132956,5851),(132957,5851),(132958,5851),(132959,5851),(132960,5851),(132961,5851),(132962,5852),(132963,5852),(132964,5852),(132965,5852),(132966,5852),(132967,5852),(132968,5852),(132969,5852),(132970,5852),(132971,5852),(132972,5852),(132973,5853),(132974,5853),(132975,5853),(132976,5853),(132977,5853),(132978,5853),(132979,5853),(132980,5853),(132981,5853),(132982,5853),(132983,5853),(132984,5854),(132985,5854),(132986,5854),(132987,5854),(132988,5854),(132989,5854),(132990,5854),(132991,5854),(132992,5854),(132993,5854),(132994,5854),(132995,5855),(132996,5855),(132997,5855),(132998,5855),(132999,5855),(133000,5855),(133001,5855),(133002,5855),(133003,5855),(133004,5855),(133005,5855),(133006,5856),(133007,5856),(133008,5856),(133009,5856),(133010,5856),(133011,5856),(133012,5856),(133013,5856),(133014,5856),(133015,5856),(133016,5856),(133017,5857),(133018,5857),(133019,5857),(133020,5857),(133021,5857),(133022,5857),(133023,5857),(133024,5857),(133025,5857),(133026,5857),(133027,5857),(133028,5858),(133029,5858),(133030,5858),(133031,5858),(133032,5858),(133033,5858),(133034,5858),(133035,5858),(133036,5858),(133037,5858),(133038,5858),(133039,5859),(133040,5859),(133041,5859),(133042,5859),(133043,5859),(133044,5859),(133045,5859),(133046,5859),(133047,5859),(133048,5859),(133049,5859),(133050,5860),(133051,5860),(133052,5860),(133053,5860),(133054,5860),(133055,5860),(133056,5860),(133057,5860),(133058,5860),(133059,5860),(133060,5860),(133061,5761),(133062,5761),(133063,5761),(133064,5761),(133065,5762),(133066,5762),(133067,5762),(133068,5762),(133069,5763),(133070,5763),(133071,5763),(133072,5763),(133073,5764),(133074,5764),(133075,5764),(133076,5764),(133077,5765),(133078,5765),(133079,5765),(133080,5765),(133081,5766),(133082,5766),(133083,5766),(133084,5766),(133085,5767),(133086,5767),(133087,5767),(133088,5767),(133089,5768),(133090,5768),(133091,5768),(133092,5768),(133093,5769),(133094,5769),(133095,5769),(133096,5770),(133097,5770),(133098,5770),(133099,5771),(133100,5771),(133101,5771),(133102,5772),(133103,5772),(133104,5772),(133105,5773),(133106,5773),(133107,5773),(133108,5774),(133109,5774),(133110,5774),(133111,5775),(133112,5775),(133113,5775),(133114,5776),(133115,5776),(133116,5776),(133117,5777),(133118,5777),(133119,5777),(133120,5777),(133121,5778),(133122,5778),(133123,5778),(133124,5778),(133125,5779),(133126,5779),(133127,5779),(133128,5779),(133129,5780),(133130,5780),(133131,5780),(133132,5781),(133133,5781),(133134,5781),(133135,5781),(133136,5782),(133137,5782),(133138,5782),(133139,5782),(133140,5783),(133141,5783),(133142,5783),(133143,5783),(133144,5784),(133145,5784),(133146,5784),(133147,5784),(133148,5785),(133149,5785),(133150,5785),(133151,5786),(133152,5786),(133153,5786),(133154,5786),(133155,5787),(133156,5787),(133157,5787),(133158,5788),(133159,5788),(133160,5788),(133161,5789),(133162,5789),(133163,5789),(133164,5790),(133165,5790),(133166,5790),(133167,5791),(133168,5791),(133169,5791),(133170,5791),(133171,5792),(133172,5792),(133173,5792),(133174,5792),(133175,5793),(133176,5793),(133177,5793),(133178,5794),(133179,5794),(133180,5794),(133181,5794),(133182,5795),(133183,5795),(133184,5795),(133185,5795),(133186,5796),(133187,5796),(133188,5796),(133189,5796),(133190,5797),(133191,5797),(133192,5797),(133193,5797),(133194,5798),(133195,5798),(133196,5798),(133197,5798),(133198,5799),(133199,5799),(133200,5799),(133201,5799),(133202,5800),(133203,5800),(133204,5800),(133205,5800),(133206,5801),(133207,5801),(133208,5801),(133209,5801),(133210,5802),(133211,5802),(133212,5802),(133213,5802),(133214,5803),(133215,5803),(133216,5803),(133217,5803),(133218,5804),(133219,5804),(133220,5804),(133221,5804),(133222,5805),(133223,5805),(133224,5805),(133225,5805),(133226,5806),(133227,5806),(133228,5806),(133229,5806),(133230,5807),(133231,5807),(133232,5807),(133233,5807),(133234,5808),(133235,5808),(133236,5808),(133237,5808),(133238,5809),(133239,5809),(133240,5809),(133241,5809),(133242,5810),(133243,5810),(133244,5810),(133245,5810),(133246,5811),(133247,5811),(133248,5811),(133249,5811),(133250,5812),(133251,5812),(133252,5812),(133253,5812),(133254,5813),(133255,5813),(133256,5813),(133257,5813),(133258,5814),(133259,5814),(133260,5814),(133261,5814),(133262,5815),(133263,5815),(133264,5815),(133265,5815),(133266,5816),(133267,5816),(133268,5816),(133269,5816),(133270,5817),(133271,5817),(133272,5817),(133273,5817),(133274,5818),(133275,5818),(133276,5818),(133277,5818),(133278,5819),(133279,5819),(133280,5819),(133281,5820),(133282,5820),(133283,5820),(133284,5820),(133285,5821),(133286,5821),(133287,5821),(133288,5822),(133289,5822),(133290,5822),(133291,5823),(133292,5823),(133293,5823),(133294,5824),(133295,5824),(133296,5824),(133297,5824),(133298,5825),(133299,5825),(133300,5825),(133301,5826),(133302,5826),(133303,5826),(133304,5827),(133305,5827),(133306,5827),(133307,5828),(133308,5828),(133309,5828),(133310,5829),(133311,5829),(133312,5829),(133313,5830),(133314,5830),(133315,5830),(133316,5831),(133317,5831),(133318,5831),(133319,5832),(133320,5832),(133321,5832),(133322,5832),(133323,5833),(133324,5833),(133325,5833),(133326,5833),(133327,5834),(133328,5834),(133329,5834),(133330,5834),(133331,5835),(133332,5835),(133333,5835),(133334,5835),(133335,5836),(133336,5836),(133337,5836),(133338,5836),(133339,5837),(133340,5837),(133341,5837),(133342,5837),(133343,5838),(133344,5838),(133345,5838),(133346,5838),(133347,5839),(133348,5839),(133349,5839),(133350,5839),(133351,5840),(133352,5840),(133353,5840),(133354,5840),(133355,5841),(133356,5841),(133357,5841),(133358,5841),(133359,5842),(133360,5842),(133361,5842),(133362,5842),(133363,5843),(133364,5843),(133365,5843),(133366,5843),(133367,5844),(133368,5844),(133369,5844),(133370,5844),(133371,5845),(133372,5845),(133373,5845),(133374,5845),(133375,5846),(133376,5846),(133377,5846),(133378,5846),(133379,5847),(133380,5847),(133381,5847),(133382,5847),(133383,5848),(133384,5848),(133385,5848),(133386,5848),(133387,5849),(133388,5849),(133389,5849),(133390,5849),(133391,5850),(133392,5850),(133393,5850),(133394,5850),(133395,5851),(133396,5851),(133397,5851),(133398,5851),(133399,5852),(133400,5852),(133401,5852),(133402,5852),(133403,5853),(133404,5853),(133405,5853),(133406,5853),(133407,5854),(133408,5854),(133409,5854),(133410,5854),(133411,5855),(133412,5855),(133413,5855),(133414,5855),(133415,5856),(133416,5856),(133417,5856),(133418,5856),(133419,5857),(133420,5857),(133421,5857),(133422,5857),(133423,5858),(133424,5858),(133425,5858),(133426,5858),(133427,5859),(133428,5859),(133429,5859),(133430,5859),(133431,5860),(133432,5860),(133433,5860),(133434,5860),(133435,5861),(133436,5862),(133437,5863),(133438,5864),(133439,5865),(133440,5866),(133441,5867),(133442,5868),(133443,5869),(133444,5870),(133445,5871),(133446,5872),(133447,5873),(133448,5874),(133449,5875),(133450,5876),(133451,5877),(133452,5878),(133453,5879),(133454,5880),(133455,5881),(133456,5882),(133457,5883),(133458,5884),(133459,5885),(133460,5886),(133461,5887),(133462,5888),(133463,5889),(133464,5890),(133465,5891),(133466,5892),(133467,5893),(133468,5894),(133469,5895),(133470,5896),(133471,5897),(133472,5898),(133473,5899),(133474,5900),(133475,5901),(133476,5902),(133477,5903),(133478,5904),(133479,5905),(133480,5906),(133481,5907),(133482,5908),(133483,5909),(133484,5910),(133485,5911),(133486,5912),(133487,5913),(133488,5914),(133489,5915),(133490,5916),(133491,5917),(133492,5918),(133493,5919),(133494,5920),(133495,5921),(133496,5922),(133497,5923),(133498,5924),(133499,5925),(133500,5926),(133501,5927),(133502,5928),(133503,5929),(133504,5930),(133505,5931),(133506,5932),(133507,5933),(133508,5934),(133509,5935),(133510,5936),(133511,5937),(133512,5938),(133513,5939),(133514,5940),(133515,5941),(133516,5942),(133517,5943),(133518,5944),(133519,5945),(133520,5946),(133521,5947),(133522,5948),(133523,5949),(133524,5950),(133525,5951),(133526,5952),(133527,5953),(133528,5954),(133529,5955),(133530,5956),(133531,5957),(133532,5958),(133533,5959),(133534,5960),(133535,5861),(133536,5861),(133537,5861),(133538,5861),(133539,5861),(133540,5861),(133541,5861),(133542,5861),(133543,5861),(133544,5862),(133545,5862),(133546,5862),(133547,5862),(133548,5862),(133549,5862),(133550,5862),(133551,5862),(133552,5862),(133553,5863),(133554,5863),(133555,5863),(133556,5863),(133557,5863),(133558,5863),(133559,5863),(133560,5863),(133561,5863),(133562,5864),(133563,5864),(133564,5864),(133565,5864),(133566,5864),(133567,5864),(133568,5864),(133569,5865),(133570,5865),(133571,5865),(133572,5865),(133573,5865),(133574,5865),(133575,5865),(133576,5866),(133577,5866),(133578,5866),(133579,5866),(133580,5866),(133581,5866),(133582,5866),(133583,5867),(133584,5867),(133585,5867),(133586,5867),(133587,5868),(133588,5868),(133589,5868),(133590,5868),(133591,5868),(133592,5868),(133593,5868),(133594,5869),(133595,5869),(133596,5869),(133597,5869),(133598,5869),(133599,5869),(133600,5869),(133601,5870),(133602,5870),(133603,5870),(133604,5870),(133605,5870),(133606,5870),(133607,5870),(133608,5871),(133609,5871),(133610,5871),(133611,5871),(133612,5872),(133613,5872),(133614,5872),(133615,5872),(133616,5872),(133617,5872),(133618,5872),(133619,5873),(133620,5873),(133621,5873),(133622,5873),(133623,5873),(133624,5873),(133625,5873),(133626,5874),(133627,5874),(133628,5874),(133629,5874),(133630,5874),(133631,5874),(133632,5874),(133633,5875),(133634,5875),(133635,5875),(133636,5875),(133637,5875),(133638,5875),(133639,5875),(133640,5876),(133641,5876),(133642,5876),(133643,5876),(133644,5876),(133645,5876),(133646,5876),(133647,5876),(133648,5876),(133649,5877),(133650,5877),(133651,5877),(133652,5877),(133653,5877),(133654,5877),(133655,5877),(133656,5878),(133657,5878),(133658,5878),(133659,5878),(133660,5878),(133661,5878),(133662,5878),(133663,5879),(133664,5879),(133665,5879),(133666,5879),(133667,5879),(133668,5879),(133669,5879),(133670,5880),(133671,5880),(133672,5880),(133673,5880),(133674,5880),(133675,5880),(133676,5880),(133677,5881),(133678,5881),(133679,5881),(133680,5881),(133681,5881),(133682,5881),(133683,5881),(133684,5881),(133685,5881),(133686,5882),(133687,5882),(133688,5882),(133689,5882),(133690,5882),(133691,5882),(133692,5882),(133693,5882),(133694,5882),(133695,5883),(133696,5883),(133697,5883),(133698,5883),(133699,5883),(133700,5883),(133701,5883),(133702,5883),(133703,5883),(133704,5884),(133705,5884),(133706,5884),(133707,5884),(133708,5884),(133709,5884),(133710,5884),(133711,5884),(133712,5884),(133713,5885),(133714,5885),(133715,5885),(133716,5885),(133717,5885),(133718,5885),(133719,5885),(133720,5885),(133721,5885),(133722,5886),(133723,5886),(133724,5886),(133725,5886),(133726,5886),(133727,5886),(133728,5886),(133729,5886),(133730,5886),(133731,5887),(133732,5887),(133733,5887),(133734,5887),(133735,5887),(133736,5887),(133737,5887),(133738,5887),(133739,5887),(133740,5888),(133741,5888),(133742,5888),(133743,5888),(133744,5888),(133745,5888),(133746,5888),(133747,5888),(133748,5888),(133749,5889),(133750,5889),(133751,5889),(133752,5889),(133753,5889),(133754,5889),(133755,5889),(133756,5889),(133757,5889),(133758,5890),(133759,5890),(133760,5890),(133761,5890),(133762,5890),(133763,5890),(133764,5890),(133765,5890),(133766,5890),(133767,5891),(133768,5891),(133769,5891),(133770,5891),(133771,5891),(133772,5891),(133773,5891),(133774,5891),(133775,5891),(133776,5892),(133777,5892),(133778,5892),(133779,5892),(133780,5892),(133781,5892),(133782,5892),(133783,5892),(133784,5892),(133785,5893),(133786,5893),(133787,5893),(133788,5893),(133789,5893),(133790,5893),(133791,5893),(133792,5894),(133793,5894),(133794,5894),(133795,5894),(133796,5894),(133797,5894),(133798,5894),(133799,5895),(133800,5895),(133801,5895),(133802,5895),(133803,5895),(133804,5895),(133805,5895),(133806,5896),(133807,5896),(133808,5896),(133809,5896),(133810,5897),(133811,5897),(133812,5897),(133813,5897),(133814,5897),(133815,5897),(133816,5897),(133817,5898),(133818,5898),(133819,5898),(133820,5898),(133821,5898),(133822,5898),(133823,5898),(133824,5899),(133825,5899),(133826,5899),(133827,5899),(133828,5899),(133829,5899),(133830,5899),(133831,5899),(133832,5899),(133833,5900),(133834,5900),(133835,5900),(133836,5900),(133837,5900),(133838,5900),(133839,5900),(133840,5901),(133841,5901),(133842,5901),(133843,5901),(133844,5901),(133845,5901),(133846,5901),(133847,5901),(133848,5901),(133849,5902),(133850,5902),(133851,5902),(133852,5902),(133853,5902),(133854,5902),(133855,5902),(133856,5902),(133857,5902),(133858,5903),(133859,5903),(133860,5903),(133861,5903),(133862,5903),(133863,5903),(133864,5903),(133865,5903),(133866,5903),(133867,5904),(133868,5904),(133869,5904),(133870,5904),(133871,5904),(133872,5904),(133873,5904),(133874,5905),(133875,5905),(133876,5905),(133877,5905),(133878,5905),(133879,5905),(133880,5905),(133881,5906),(133882,5906),(133883,5906),(133884,5906),(133885,5907),(133886,5907),(133887,5907),(133888,5907),(133889,5907),(133890,5907),(133891,5907),(133892,5907),(133893,5907),(133894,5908),(133895,5908),(133896,5908),(133897,5908),(133898,5908),(133899,5908),(133900,5908),(133901,5908),(133902,5908),(133903,5909),(133904,5909),(133905,5909),(133906,5909),(133907,5909),(133908,5909),(133909,5909),(133910,5909),(133911,5909),(133912,5910),(133913,5910),(133914,5910),(133915,5910),(133916,5910),(133917,5910),(133918,5910),(133919,5911),(133920,5911),(133921,5911),(133922,5911),(133923,5911),(133924,5911),(133925,5911),(133926,5912),(133927,5912),(133928,5912),(133929,5912),(133930,5912),(133931,5912),(133932,5912),(133933,5913),(133934,5913),(133935,5913),(133936,5913),(133937,5913),(133938,5913),(133939,5913),(133940,5914),(133941,5914),(133942,5914),(133943,5914),(133944,5914),(133945,5914),(133946,5914),(133947,5915),(133948,5915),(133949,5915),(133950,5915),(133951,5915),(133952,5915),(133953,5915),(133954,5916),(133955,5916),(133956,5916),(133957,5916),(133958,5916),(133959,5916),(133960,5916),(133961,5916),(133962,5916),(133963,5917),(133964,5917),(133965,5917),(133966,5917),(133967,5917),(133968,5917),(133969,5917),(133970,5918),(133971,5918),(133972,5918),(133973,5918),(133974,5918),(133975,5918),(133976,5919),(133977,5919),(133978,5919),(133979,5919),(133980,5919),(133981,5919),(133982,5919),(133983,5920),(133984,5920),(133985,5920),(133986,5920),(133987,5920),(133988,5920),(133989,5921),(133990,5921),(133991,5921),(133992,5921),(133993,5921),(133994,5921),(133995,5921),(133996,5922),(133997,5922),(133998,5922),(133999,5922),(134000,5922),(134001,5922),(134002,5922),(134003,5923),(134004,5923),(134005,5923),(134006,5923),(134007,5923),(134008,5923),(134009,5923),(134010,5924),(134011,5924),(134012,5924),(134013,5924),(134014,5924),(134015,5924),(134016,5924),(134017,5925),(134018,5925),(134019,5925),(134020,5925),(134021,5925),(134022,5925),(134023,5925),(134024,5926),(134025,5926),(134026,5926),(134027,5926),(134028,5926),(134029,5926),(134030,5927),(134031,5927),(134032,5927),(134033,5927),(134034,5927),(134035,5927),(134036,5927),(134037,5928),(134038,5928),(134039,5928),(134040,5928),(134041,5928),(134042,5928),(134043,5928),(134044,5929),(134045,5929),(134046,5929),(134047,5929),(134048,5929),(134049,5929),(134050,5929),(134051,5930),(134052,5930),(134053,5930),(134054,5930),(134055,5931),(134056,5931),(134057,5931),(134058,5931),(134059,5932),(134060,5932),(134061,5932),(134062,5932),(134063,5933),(134064,5933),(134065,5933),(134066,5933),(134067,5934),(134068,5934),(134069,5934),(134070,5934),(134071,5935),(134072,5935),(134073,5935),(134074,5935),(134075,5936),(134076,5936),(134077,5936),(134078,5936),(134079,5937),(134080,5937),(134081,5937),(134082,5937),(134083,5938),(134084,5938),(134085,5938),(134086,5938),(134087,5939),(134088,5939),(134089,5939),(134090,5939),(134091,5940),(134092,5940),(134093,5940),(134094,5940),(134095,5941),(134096,5941),(134097,5941),(134098,5941),(134099,5942),(134100,5942),(134101,5942),(134102,5942),(134103,5943),(134104,5943),(134105,5943),(134106,5943),(134107,5944),(134108,5944),(134109,5944),(134110,5944),(134111,5944),(134112,5944),(134113,5944),(134114,5944),(134115,5944),(134116,5945),(134117,5945),(134118,5945),(134119,5945),(134120,5945),(134121,5945),(134122,5945),(134123,5945),(134124,5945),(134125,5946),(134126,5946),(134127,5946),(134128,5946),(134129,5946),(134130,5946),(134131,5946),(134132,5946),(134133,5946),(134134,5947),(134135,5947),(134136,5947),(134137,5947),(134138,5947),(134139,5947),(134140,5947),(134141,5947),(134142,5947),(134143,5948),(134144,5948),(134145,5948),(134146,5948),(134147,5948),(134148,5948),(134149,5948),(134150,5948),(134151,5948),(134152,5949),(134153,5949),(134154,5949),(134155,5949),(134156,5949),(134157,5949),(134158,5949),(134159,5949),(134160,5949),(134161,5950),(134162,5950),(134163,5950),(134164,5950),(134165,5950),(134166,5950),(134167,5950),(134168,5950),(134169,5950),(134170,5951),(134171,5951),(134172,5951),(134173,5951),(134174,5951),(134175,5951),(134176,5951),(134177,5951),(134178,5951),(134179,5952),(134180,5952),(134181,5952),(134182,5952),(134183,5953),(134184,5953),(134185,5953),(134186,5953),(134187,5954),(134188,5954),(134189,5954),(134190,5954),(134191,5955),(134192,5955),(134193,5955),(134194,5955),(134195,5955),(134196,5955),(134197,5955),(134198,5955),(134199,5955),(134200,5956),(134201,5956),(134202,5956),(134203,5956),(134204,5956),(134205,5956),(134206,5956),(134207,5956),(134208,5956),(134209,5957),(134210,5957),(134211,5957),(134212,5957),(134213,5957),(134214,5957),(134215,5957),(134216,5957),(134217,5957),(134218,5958),(134219,5958),(134220,5958),(134221,5958),(134222,5959),(134223,5959),(134224,5959),(134225,5959),(134226,5960),(134227,5960),(134228,5960),(134229,5960),(134230,5861),(134231,5861),(134232,5862),(134233,5862),(134234,5863),(134235,5863),(134236,5864),(134237,5864),(134238,5864),(134239,5865),(134240,5865),(134241,5865),(134242,5866),(134243,5866),(134244,5866),(134245,5867),(134246,5867),(134247,5867),(134248,5868),(134249,5868),(134250,5868),(134251,5869),(134252,5869),(134253,5869),(134254,5870),(134255,5870),(134256,5870),(134257,5871),(134258,5871),(134259,5871),(134260,5872),(134261,5872),(134262,5872),(134263,5873),(134264,5873),(134265,5873),(134266,5874),(134267,5874),(134268,5874),(134269,5875),(134270,5875),(134271,5875),(134272,5876),(134273,5876),(134274,5876),(134275,5877),(134276,5877),(134277,5877),(134278,5878),(134279,5878),(134280,5878),(134281,5879),(134282,5879),(134283,5879),(134284,5880),(134285,5880),(134286,5880),(134287,5881),(134288,5881),(134289,5881),(134290,5882),(134291,5882),(134292,5882),(134293,5883),(134294,5883),(134295,5883),(134296,5884),(134297,5884),(134298,5884),(134299,5885),(134300,5885),(134301,5885),(134302,5886),(134303,5886),(134304,5886),(134305,5887),(134306,5887),(134307,5887),(134308,5888),(134309,5888),(134310,5888),(134311,5889),(134312,5889),(134313,5889),(134314,5890),(134315,5890),(134316,5890),(134317,5891),(134318,5891),(134319,5891),(134320,5892),(134321,5892),(134322,5893),(134323,5893),(134324,5893),(134325,5894),(134326,5894),(134327,5894),(134328,5895),(134329,5895),(134330,5895),(134331,5896),(134332,5896),(134333,5896),(134334,5897),(134335,5897),(134336,5897),(134337,5898),(134338,5898),(134339,5898),(134340,5899),(134341,5899),(134342,5899),(134343,5900),(134344,5900),(134345,5900),(134346,5901),(134347,5901),(134348,5901),(134349,5902),(134350,5902),(134351,5902),(134352,5903),(134353,5903),(134354,5903),(134355,5904),(134356,5904),(134357,5904),(134358,5905),(134359,5905),(134360,5905),(134361,5906),(134362,5906),(134363,5906),(134364,5907),(134365,5907),(134366,5907),(134367,5908),(134368,5908),(134369,5908),(134370,5909),(134371,5909),(134372,5909),(134373,5910),(134374,5910),(134375,5910),(134376,5911),(134377,5911),(134378,5911),(134379,5912),(134380,5912),(134381,5912),(134382,5913),(134383,5913),(134384,5913),(134385,5914),(134386,5914),(134387,5914),(134388,5915),(134389,5915),(134390,5915),(134391,5916),(134392,5916),(134393,5916),(134394,5917),(134395,5917),(134396,5917),(134397,5918),(134398,5918),(134399,5918),(134400,5919),(134401,5919),(134402,5919),(134403,5920),(134404,5920),(134405,5920),(134406,5921),(134407,5921),(134408,5921),(134409,5922),(134410,5922),(134411,5922),(134412,5923),(134413,5923),(134414,5923),(134415,5924),(134416,5924),(134417,5924),(134418,5925),(134419,5925),(134420,5925),(134421,5926),(134422,5926),(134423,5926),(134424,5927),(134425,5927),(134426,5927),(134427,5928),(134428,5928),(134429,5928),(134430,5929),(134431,5929),(134432,5929),(134433,5930),(134434,5930),(134435,5930),(134436,5931),(134437,5931),(134438,5931),(134439,5932),(134440,5932),(134441,5932),(134442,5933),(134443,5933),(134444,5933),(134445,5934),(134446,5934),(134447,5934),(134448,5935),(134449,5935),(134450,5935),(134451,5936),(134452,5936),(134453,5936),(134454,5937),(134455,5937),(134456,5937),(134457,5938),(134458,5938),(134459,5938),(134460,5939),(134461,5939),(134462,5939),(134463,5940),(134464,5940),(134465,5940),(134466,5941),(134467,5941),(134468,5941),(134469,5942),(134470,5942),(134471,5942),(134472,5943),(134473,5943),(134474,5943),(134475,5944),(134476,5944),(134477,5944),(134478,5945),(134479,5945),(134480,5945),(134481,5946),(134482,5946),(134483,5946),(134484,5947),(134485,5947),(134486,5947),(134487,5948),(134488,5948),(134489,5948),(134490,5949),(134491,5949),(134492,5949),(134493,5950),(134494,5950),(134495,5950),(134496,5951),(134497,5951),(134498,5951),(134499,5952),(134500,5952),(134501,5952),(134502,5953),(134503,5953),(134504,5953),(134505,5954),(134506,5954),(134507,5954),(134508,5955),(134509,5955),(134510,5955),(134511,5956),(134512,5956),(134513,5956),(134514,5957),(134515,5957),(134516,5957),(134517,5958),(134518,5958),(134519,5958),(134520,5959),(134521,5959),(134522,5959),(134523,5960),(134524,5960),(134525,5960),(134526,5861),(134527,5861),(134528,5861),(134529,5861),(134530,5861),(134531,5861),(134532,5861),(134533,5861),(134534,5861),(134535,5861),(134536,5861),(134537,5862),(134538,5862),(134539,5862),(134540,5862),(134541,5862),(134542,5862),(134543,5862),(134544,5862),(134545,5862),(134546,5862),(134547,5862),(134548,5863),(134549,5863),(134550,5863),(134551,5863),(134552,5863),(134553,5863),(134554,5863),(134555,5863),(134556,5863),(134557,5863),(134558,5863),(134559,5864),(134560,5864),(134561,5864),(134562,5864),(134563,5864),(134564,5864),(134565,5864),(134566,5864),(134567,5864),(134568,5864),(134569,5864),(134570,5865),(134571,5865),(134572,5865),(134573,5865),(134574,5865),(134575,5865),(134576,5865),(134577,5865),(134578,5865),(134579,5865),(134580,5865),(134581,5866),(134582,5866),(134583,5866),(134584,5866),(134585,5866),(134586,5866),(134587,5866),(134588,5866),(134589,5866),(134590,5866),(134591,5866),(134592,5867),(134593,5867),(134594,5867),(134595,5867),(134596,5867),(134597,5867),(134598,5867),(134599,5867),(134600,5867),(134601,5867),(134602,5867),(134603,5868),(134604,5868),(134605,5868),(134606,5868),(134607,5868),(134608,5868),(134609,5868),(134610,5868),(134611,5868),(134612,5868),(134613,5868),(134614,5869),(134615,5869),(134616,5869),(134617,5869),(134618,5869),(134619,5869),(134620,5869),(134621,5869),(134622,5869),(134623,5869),(134624,5869),(134625,5870),(134626,5870),(134627,5870),(134628,5870),(134629,5870),(134630,5870),(134631,5870),(134632,5870),(134633,5870),(134634,5870),(134635,5870),(134636,5871),(134637,5871),(134638,5871),(134639,5871),(134640,5871),(134641,5871),(134642,5871),(134643,5871),(134644,5871),(134645,5871),(134646,5871),(134647,5872),(134648,5872),(134649,5872),(134650,5872),(134651,5872),(134652,5872),(134653,5872),(134654,5872),(134655,5872),(134656,5872),(134657,5872),(134658,5873),(134659,5873),(134660,5873),(134661,5873),(134662,5873),(134663,5873),(134664,5873),(134665,5873),(134666,5873),(134667,5873),(134668,5873),(134669,5874),(134670,5874),(134671,5874),(134672,5874),(134673,5874),(134674,5874),(134675,5874),(134676,5874),(134677,5874),(134678,5874),(134679,5874),(134680,5875),(134681,5875),(134682,5875),(134683,5875),(134684,5875),(134685,5875),(134686,5875),(134687,5875),(134688,5875),(134689,5875),(134690,5875),(134691,5876),(134692,5876),(134693,5876),(134694,5876),(134695,5876),(134696,5876),(134697,5876),(134698,5876),(134699,5876),(134700,5876),(134701,5876),(134702,5877),(134703,5877),(134704,5877),(134705,5877),(134706,5877),(134707,5877),(134708,5877),(134709,5877),(134710,5877),(134711,5877),(134712,5877),(134713,5878),(134714,5878),(134715,5878),(134716,5878),(134717,5878),(134718,5878),(134719,5878),(134720,5878),(134721,5878),(134722,5878),(134723,5878),(134724,5879),(134725,5879),(134726,5879),(134727,5879),(134728,5879),(134729,5879),(134730,5879),(134731,5879),(134732,5879),(134733,5879),(134734,5879),(134735,5880),(134736,5880),(134737,5880),(134738,5880),(134739,5880),(134740,5880),(134741,5880),(134742,5880),(134743,5880),(134744,5880),(134745,5880),(134746,5881),(134747,5881),(134748,5881),(134749,5881),(134750,5881),(134751,5881),(134752,5881),(134753,5881),(134754,5881),(134755,5881),(134756,5881),(134757,5882),(134758,5882),(134759,5882),(134760,5882),(134761,5882),(134762,5882),(134763,5882),(134764,5882),(134765,5882),(134766,5882),(134767,5882),(134768,5883),(134769,5883),(134770,5883),(134771,5883),(134772,5883),(134773,5883),(134774,5883),(134775,5883),(134776,5883),(134777,5883),(134778,5883),(134779,5884),(134780,5884),(134781,5884),(134782,5884),(134783,5884),(134784,5884),(134785,5884),(134786,5884),(134787,5884),(134788,5884),(134789,5884),(134790,5885),(134791,5885),(134792,5885),(134793,5885),(134794,5885),(134795,5885),(134796,5885),(134797,5885),(134798,5885),(134799,5885),(134800,5885),(134801,5886),(134802,5886),(134803,5886),(134804,5886),(134805,5886),(134806,5886),(134807,5886),(134808,5886),(134809,5886),(134810,5886),(134811,5886),(134812,5887),(134813,5887),(134814,5887),(134815,5887),(134816,5887),(134817,5887),(134818,5887),(134819,5887),(134820,5887),(134821,5887),(134822,5887),(134823,5888),(134824,5888),(134825,5888),(134826,5888),(134827,5888),(134828,5888),(134829,5888),(134830,5888),(134831,5888),(134832,5888),(134833,5888),(134834,5889),(134835,5889),(134836,5889),(134837,5889),(134838,5889),(134839,5889),(134840,5889),(134841,5889),(134842,5889),(134843,5889),(134844,5889),(134845,5890),(134846,5890),(134847,5890),(134848,5890),(134849,5890),(134850,5890),(134851,5890),(134852,5890),(134853,5890),(134854,5890),(134855,5890),(134856,5891),(134857,5891),(134858,5891),(134859,5891),(134860,5891),(134861,5891),(134862,5891),(134863,5891),(134864,5891),(134865,5891),(134866,5891),(134867,5892),(134868,5892),(134869,5892),(134870,5892),(134871,5892),(134872,5892),(134873,5892),(134874,5892),(134875,5892),(134876,5892),(134877,5892),(134878,5893),(134879,5893),(134880,5893),(134881,5893),(134882,5893),(134883,5893),(134884,5893),(134885,5893),(134886,5893),(134887,5893),(134888,5893),(134889,5894),(134890,5894),(134891,5894),(134892,5894),(134893,5894),(134894,5894),(134895,5894),(134896,5894),(134897,5894),(134898,5894),(134899,5894),(134900,5895),(134901,5895),(134902,5895),(134903,5895),(134904,5895),(134905,5895),(134906,5895),(134907,5895),(134908,5895),(134909,5895),(134910,5895),(134911,5896),(134912,5896),(134913,5896),(134914,5896),(134915,5896),(134916,5896),(134917,5896),(134918,5896),(134919,5896),(134920,5896),(134921,5896),(134922,5897),(134923,5897),(134924,5897),(134925,5897),(134926,5897),(134927,5897),(134928,5897),(134929,5897),(134930,5897),(134931,5897),(134932,5897),(134933,5898),(134934,5898),(134935,5898),(134936,5898),(134937,5898),(134938,5898),(134939,5898),(134940,5898),(134941,5898),(134942,5898),(134943,5898),(134944,5899),(134945,5899),(134946,5899),(134947,5899),(134948,5899),(134949,5899),(134950,5899),(134951,5899),(134952,5899),(134953,5899),(134954,5899),(134955,5900),(134956,5900),(134957,5900),(134958,5900),(134959,5900),(134960,5900),(134961,5900),(134962,5900),(134963,5900),(134964,5900),(134965,5900),(134966,5901),(134967,5901),(134968,5901),(134969,5901),(134970,5901),(134971,5901),(134972,5901),(134973,5901),(134974,5901),(134975,5901),(134976,5901),(134977,5902),(134978,5902),(134979,5902),(134980,5902),(134981,5902),(134982,5902),(134983,5902),(134984,5902),(134985,5902),(134986,5902),(134987,5902),(134988,5903),(134989,5903),(134990,5903),(134991,5903),(134992,5903),(134993,5903),(134994,5903),(134995,5903),(134996,5903),(134997,5903),(134998,5903),(134999,5904),(135000,5904),(135001,5904),(135002,5904),(135003,5904),(135004,5904),(135005,5904),(135006,5904),(135007,5904),(135008,5904),(135009,5904),(135010,5905),(135011,5905),(135012,5905),(135013,5905),(135014,5905),(135015,5905),(135016,5905),(135017,5905),(135018,5905),(135019,5905),(135020,5905),(135021,5906),(135022,5906),(135023,5906),(135024,5906),(135025,5906),(135026,5906),(135027,5906),(135028,5906),(135029,5906),(135030,5906),(135031,5906),(135032,5907),(135033,5907),(135034,5907),(135035,5907),(135036,5907),(135037,5907),(135038,5907),(135039,5907),(135040,5907),(135041,5907),(135042,5907),(135043,5908),(135044,5908),(135045,5908),(135046,5908),(135047,5908),(135048,5908),(135049,5908),(135050,5908),(135051,5908),(135052,5908),(135053,5908),(135054,5909),(135055,5909),(135056,5909),(135057,5909),(135058,5909),(135059,5909),(135060,5909),(135061,5909),(135062,5909),(135063,5909),(135064,5909),(135065,5910),(135066,5910),(135067,5910),(135068,5910),(135069,5910),(135070,5910),(135071,5910),(135072,5910),(135073,5910),(135074,5910),(135075,5910),(135076,5911),(135077,5911),(135078,5911),(135079,5911),(135080,5911),(135081,5911),(135082,5911),(135083,5911),(135084,5911),(135085,5911),(135086,5911),(135087,5912),(135088,5912),(135089,5912),(135090,5912),(135091,5912),(135092,5912),(135093,5912),(135094,5912),(135095,5912),(135096,5912),(135097,5912),(135098,5913),(135099,5913),(135100,5913),(135101,5913),(135102,5913),(135103,5913),(135104,5913),(135105,5913),(135106,5913),(135107,5913),(135108,5913),(135109,5914),(135110,5914),(135111,5914),(135112,5914),(135113,5914),(135114,5914),(135115,5914),(135116,5914),(135117,5914),(135118,5914),(135119,5914),(135120,5915),(135121,5915),(135122,5915),(135123,5915),(135124,5915),(135125,5915),(135126,5915),(135127,5915),(135128,5915),(135129,5915),(135130,5915),(135131,5916),(135132,5916),(135133,5916),(135134,5916),(135135,5916),(135136,5916),(135137,5916),(135138,5916),(135139,5916),(135140,5916),(135141,5916),(135142,5917),(135143,5917),(135144,5917),(135145,5917),(135146,5917),(135147,5917),(135148,5917),(135149,5917),(135150,5917),(135151,5917),(135152,5917),(135153,5918),(135154,5918),(135155,5918),(135156,5918),(135157,5918),(135158,5918),(135159,5918),(135160,5918),(135161,5918),(135162,5918),(135163,5918),(135164,5919),(135165,5919),(135166,5919),(135167,5919),(135168,5919),(135169,5919),(135170,5919),(135171,5919),(135172,5919),(135173,5919),(135174,5919),(135175,5920),(135176,5920),(135177,5920),(135178,5920),(135179,5920),(135180,5920),(135181,5920),(135182,5920),(135183,5920),(135184,5920),(135185,5920),(135186,5921),(135187,5921),(135188,5921),(135189,5921),(135190,5921),(135191,5921),(135192,5921),(135193,5921),(135194,5921),(135195,5921),(135196,5921),(135197,5922),(135198,5922),(135199,5922),(135200,5922),(135201,5922),(135202,5922),(135203,5922),(135204,5922),(135205,5922),(135206,5922),(135207,5922),(135208,5923),(135209,5923),(135210,5923),(135211,5923),(135212,5923),(135213,5923),(135214,5923),(135215,5923),(135216,5923),(135217,5923),(135218,5923),(135219,5924),(135220,5924),(135221,5924),(135222,5924),(135223,5924),(135224,5924),(135225,5924),(135226,5924),(135227,5924),(135228,5924),(135229,5924),(135230,5925),(135231,5925),(135232,5925),(135233,5925),(135234,5925),(135235,5925),(135236,5925),(135237,5925),(135238,5925),(135239,5925),(135240,5925),(135241,5926),(135242,5926),(135243,5926),(135244,5926),(135245,5926),(135246,5926),(135247,5926),(135248,5926),(135249,5926),(135250,5926),(135251,5926),(135252,5927),(135253,5927),(135254,5927),(135255,5927),(135256,5927),(135257,5927),(135258,5927),(135259,5927),(135260,5927),(135261,5927),(135262,5927),(135263,5928),(135264,5928),(135265,5928),(135266,5928),(135267,5928),(135268,5928),(135269,5928),(135270,5928),(135271,5928),(135272,5928),(135273,5928),(135274,5929),(135275,5929),(135276,5929),(135277,5929),(135278,5929),(135279,5929),(135280,5929),(135281,5929),(135282,5929),(135283,5929),(135284,5929),(135285,5930),(135286,5930),(135287,5930),(135288,5930),(135289,5930),(135290,5930),(135291,5930),(135292,5930),(135293,5930),(135294,5930),(135295,5930),(135296,5931),(135297,5931),(135298,5931),(135299,5931),(135300,5931),(135301,5931),(135302,5931),(135303,5931),(135304,5931),(135305,5931),(135306,5931),(135307,5932),(135308,5932),(135309,5932),(135310,5932),(135311,5932),(135312,5932),(135313,5932),(135314,5932),(135315,5932),(135316,5932),(135317,5932),(135318,5933),(135319,5933),(135320,5933),(135321,5933),(135322,5933),(135323,5933),(135324,5933),(135325,5933),(135326,5933),(135327,5933),(135328,5933),(135329,5934),(135330,5934),(135331,5934),(135332,5934),(135333,5934),(135334,5934),(135335,5934),(135336,5934),(135337,5934),(135338,5934),(135339,5934),(135340,5935),(135341,5935),(135342,5935),(135343,5935),(135344,5935),(135345,5935),(135346,5935),(135347,5935),(135348,5935),(135349,5935),(135350,5935),(135351,5936),(135352,5936),(135353,5936),(135354,5936),(135355,5936),(135356,5936),(135357,5936),(135358,5936),(135359,5936),(135360,5936),(135361,5936),(135362,5937),(135363,5937),(135364,5937),(135365,5937),(135366,5937),(135367,5937),(135368,5937),(135369,5937),(135370,5937),(135371,5937),(135372,5937),(135373,5938),(135374,5938),(135375,5938),(135376,5938),(135377,5938),(135378,5938),(135379,5938),(135380,5938),(135381,5938),(135382,5938),(135383,5938),(135384,5939),(135385,5939),(135386,5939),(135387,5939),(135388,5939),(135389,5939),(135390,5939),(135391,5939),(135392,5939),(135393,5939),(135394,5939),(135395,5940),(135396,5940),(135397,5940),(135398,5940),(135399,5940),(135400,5940),(135401,5940),(135402,5940),(135403,5940),(135404,5940),(135405,5940),(135406,5941),(135407,5941),(135408,5941),(135409,5941),(135410,5941),(135411,5941),(135412,5941),(135413,5941),(135414,5941),(135415,5941),(135416,5941),(135417,5942),(135418,5942),(135419,5942),(135420,5942),(135421,5942),(135422,5942),(135423,5942),(135424,5942),(135425,5942),(135426,5942),(135427,5942),(135428,5943),(135429,5943),(135430,5943),(135431,5943),(135432,5943),(135433,5943),(135434,5943),(135435,5943),(135436,5943),(135437,5943),(135438,5943),(135439,5944),(135440,5944),(135441,5944),(135442,5944),(135443,5944),(135444,5944),(135445,5944),(135446,5944),(135447,5944),(135448,5944),(135449,5944),(135450,5945),(135451,5945),(135452,5945),(135453,5945),(135454,5945),(135455,5945),(135456,5945),(135457,5945),(135458,5945),(135459,5945),(135460,5945),(135461,5946),(135462,5946),(135463,5946),(135464,5946),(135465,5946),(135466,5946),(135467,5946),(135468,5946),(135469,5946),(135470,5946),(135471,5946),(135472,5947),(135473,5947),(135474,5947),(135475,5947),(135476,5947),(135477,5947),(135478,5947),(135479,5947),(135480,5947),(135481,5947),(135482,5947),(135483,5948),(135484,5948),(135485,5948),(135486,5948),(135487,5948),(135488,5948),(135489,5948),(135490,5948),(135491,5948),(135492,5948),(135493,5948),(135494,5949),(135495,5949),(135496,5949),(135497,5949),(135498,5949),(135499,5949),(135500,5949),(135501,5949),(135502,5949),(135503,5949),(135504,5949),(135505,5950),(135506,5950),(135507,5950),(135508,5950),(135509,5950),(135510,5950),(135511,5950),(135512,5950),(135513,5950),(135514,5950),(135515,5950),(135516,5951),(135517,5951),(135518,5951),(135519,5951),(135520,5951),(135521,5951),(135522,5951),(135523,5951),(135524,5951),(135525,5951),(135526,5951),(135527,5952),(135528,5952),(135529,5952),(135530,5952),(135531,5952),(135532,5952),(135533,5952),(135534,5952),(135535,5952),(135536,5952),(135537,5952),(135538,5953),(135539,5953),(135540,5953),(135541,5953),(135542,5953),(135543,5953),(135544,5953),(135545,5953),(135546,5953),(135547,5953),(135548,5953),(135549,5954),(135550,5954),(135551,5954),(135552,5954),(135553,5954),(135554,5954),(135555,5954),(135556,5954),(135557,5954),(135558,5954),(135559,5954),(135560,5955),(135561,5955),(135562,5955),(135563,5955),(135564,5955),(135565,5955),(135566,5955),(135567,5955),(135568,5955),(135569,5955),(135570,5955),(135571,5956),(135572,5956),(135573,5956),(135574,5956),(135575,5956),(135576,5956),(135577,5956),(135578,5956),(135579,5956),(135580,5956),(135581,5956),(135582,5957),(135583,5957),(135584,5957),(135585,5957),(135586,5957),(135587,5957),(135588,5957),(135589,5957),(135590,5957),(135591,5957),(135592,5957),(135593,5958),(135594,5958),(135595,5958),(135596,5958),(135597,5958),(135598,5958),(135599,5958),(135600,5958),(135601,5958),(135602,5958),(135603,5958),(135604,5959),(135605,5959),(135606,5959),(135607,5959),(135608,5959),(135609,5959),(135610,5959),(135611,5959),(135612,5959),(135613,5959),(135614,5959),(135615,5960),(135616,5960),(135617,5960),(135618,5960),(135619,5960),(135620,5960),(135621,5960),(135622,5960),(135623,5960),(135624,5960),(135625,5960),(135626,5861),(135627,5861),(135628,5861),(135629,5861),(135630,5862),(135631,5862),(135632,5862),(135633,5862),(135634,5863),(135635,5863),(135636,5863),(135637,5863),(135638,5864),(135639,5864),(135640,5864),(135641,5864),(135642,5865),(135643,5865),(135644,5865),(135645,5865),(135646,5866),(135647,5866),(135648,5866),(135649,5866),(135650,5867),(135651,5867),(135652,5867),(135653,5868),(135654,5868),(135655,5868),(135656,5868),(135657,5869),(135658,5869),(135659,5869),(135660,5869),(135661,5870),(135662,5870),(135663,5870),(135664,5870),(135665,5871),(135666,5871),(135667,5871),(135668,5872),(135669,5872),(135670,5872),(135671,5873),(135672,5873),(135673,5873),(135674,5874),(135675,5874),(135676,5874),(135677,5875),(135678,5875),(135679,5875),(135680,5876),(135681,5876),(135682,5876),(135683,5876),(135684,5877),(135685,5877),(135686,5877),(135687,5877),(135688,5878),(135689,5878),(135690,5878),(135691,5878),(135692,5879),(135693,5879),(135694,5879),(135695,5879),(135696,5880),(135697,5880),(135698,5880),(135699,5880),(135700,5881),(135701,5881),(135702,5881),(135703,5881),(135704,5882),(135705,5882),(135706,5882),(135707,5882),(135708,5883),(135709,5883),(135710,5883),(135711,5883),(135712,5884),(135713,5884),(135714,5884),(135715,5884),(135716,5885),(135717,5885),(135718,5885),(135719,5885),(135720,5886),(135721,5886),(135722,5886),(135723,5886),(135724,5887),(135725,5887),(135726,5887),(135727,5887),(135728,5888),(135729,5888),(135730,5888),(135731,5888),(135732,5889),(135733,5889),(135734,5889),(135735,5889),(135736,5890),(135737,5890),(135738,5890),(135739,5890),(135740,5891),(135741,5891),(135742,5891),(135743,5891),(135744,5892),(135745,5892),(135746,5892),(135747,5892),(135748,5893),(135749,5893),(135750,5893),(135751,5893),(135752,5894),(135753,5894),(135754,5894),(135755,5894),(135756,5895),(135757,5895),(135758,5895),(135759,5895),(135760,5896),(135761,5896),(135762,5896),(135763,5897),(135764,5897),(135765,5897),(135766,5897),(135767,5898),(135768,5898),(135769,5898),(135770,5898),(135771,5899),(135772,5899),(135773,5899),(135774,5899),(135775,5900),(135776,5900),(135777,5900),(135778,5900),(135779,5901),(135780,5901),(135781,5901),(135782,5901),(135783,5902),(135784,5902),(135785,5902),(135786,5902),(135787,5903),(135788,5903),(135789,5903),(135790,5903),(135791,5904),(135792,5904),(135793,5904),(135794,5904),(135795,5905),(135796,5905),(135797,5905),(135798,5905),(135799,5906),(135800,5906),(135801,5906),(135802,5907),(135803,5907),(135804,5907),(135805,5907),(135806,5908),(135807,5908),(135808,5908),(135809,5908),(135810,5909),(135811,5909),(135812,5909),(135813,5909),(135814,5910),(135815,5910),(135816,5910),(135817,5910),(135818,5911),(135819,5911),(135820,5911),(135821,5911),(135822,5912),(135823,5912),(135824,5912),(135825,5912),(135826,5913),(135827,5913),(135828,5913),(135829,5913),(135830,5914),(135831,5914),(135832,5914),(135833,5914),(135834,5915),(135835,5915),(135836,5915),(135837,5915),(135838,5916),(135839,5916),(135840,5916),(135841,5916),(135842,5917),(135843,5917),(135844,5917),(135845,5917),(135846,5918),(135847,5918),(135848,5918),(135849,5918),(135850,5919),(135851,5919),(135852,5919),(135853,5919),(135854,5920),(135855,5920),(135856,5920),(135857,5920),(135858,5921),(135859,5921),(135860,5921),(135861,5921),(135862,5922),(135863,5922),(135864,5922),(135865,5922),(135866,5923),(135867,5923),(135868,5923),(135869,5923),(135870,5924),(135871,5924),(135872,5924),(135873,5924),(135874,5925),(135875,5925),(135876,5925),(135877,5925),(135878,5926),(135879,5926),(135880,5926),(135881,5926),(135882,5927),(135883,5927),(135884,5927),(135885,5927),(135886,5928),(135887,5928),(135888,5928),(135889,5928),(135890,5929),(135891,5929),(135892,5929),(135893,5929),(135894,5930),(135895,5930),(135896,5930),(135897,5931),(135898,5931),(135899,5931),(135900,5932),(135901,5932),(135902,5932),(135903,5933),(135904,5933),(135905,5933),(135906,5934),(135907,5934),(135908,5934),(135909,5935),(135910,5935),(135911,5935),(135912,5936),(135913,5936),(135914,5936),(135915,5937),(135916,5937),(135917,5937),(135918,5938),(135919,5938),(135920,5938),(135921,5939),(135922,5939),(135923,5939),(135924,5940),(135925,5940),(135926,5940),(135927,5941),(135928,5941),(135929,5941),(135930,5942),(135931,5942),(135932,5942),(135933,5943),(135934,5943),(135935,5943),(135936,5944),(135937,5944),(135938,5944),(135939,5944),(135940,5945),(135941,5945),(135942,5945),(135943,5945),(135944,5946),(135945,5946),(135946,5946),(135947,5946),(135948,5947),(135949,5947),(135950,5947),(135951,5947),(135952,5948),(135953,5948),(135954,5948),(135955,5948),(135956,5949),(135957,5949),(135958,5949),(135959,5949),(135960,5950),(135961,5950),(135962,5950),(135963,5950),(135964,5951),(135965,5951),(135966,5951),(135967,5951),(135968,5952),(135969,5952),(135970,5952),(135971,5953),(135972,5953),(135973,5953),(135974,5954),(135975,5954),(135976,5954),(135977,5955),(135978,5955),(135979,5955),(135980,5955),(135981,5956),(135982,5956),(135983,5956),(135984,5956),(135985,5957),(135986,5957),(135987,5957),(135988,5957),(135989,5958),(135990,5958),(135991,5958),(135992,5959),(135993,5959),(135994,5959),(135995,5960),(135996,5960),(135997,5960),(135998,5961),(135999,5962),(136000,5963),(136001,5964),(136002,5965),(136003,5966),(136004,5967),(136005,5968),(136006,5969),(136007,5970),(136008,5971),(136009,5972),(136010,5973),(136011,5974),(136012,5975),(136013,5976),(136014,5977),(136015,5978),(136016,5979),(136017,5980),(136018,5981),(136019,5982),(136020,5983),(136021,5984),(136022,5985),(136023,5986),(136024,5987),(136025,5988),(136026,5989),(136027,5990),(136028,5991),(136029,5992),(136030,5993),(136031,5994),(136032,5995),(136033,5996),(136034,5997),(136035,5998),(136036,5999),(136037,6000),(136038,6001),(136039,6002),(136040,6003),(136041,6004),(136042,6005),(136043,6006),(136044,6007),(136045,6008),(136046,6009),(136047,6010),(136048,6011),(136049,6012),(136050,6013),(136051,6014),(136052,6015),(136053,6016),(136054,6017),(136055,6018),(136056,6019),(136057,6020),(136058,6021),(136059,6022),(136060,6023),(136061,6024),(136062,6025),(136063,6026),(136064,6027),(136065,6028),(136066,6029),(136067,6030),(136068,6031),(136069,6032),(136070,6033),(136071,6034),(136072,5961),(136073,5961),(136074,5961),(136075,5961),(136076,5962),(136077,5962),(136078,5962),(136079,5962),(136080,5963),(136081,5963),(136082,5963),(136083,5963),(136084,5964),(136085,5964),(136086,5964),(136087,5964),(136088,5965),(136089,5965),(136090,5965),(136091,5965),(136092,5966),(136093,5966),(136094,5966),(136095,5966),(136096,5967),(136097,5967),(136098,5967),(136099,5967),(136100,5968),(136101,5968),(136102,5968),(136103,5968),(136104,5969),(136105,5969),(136106,5969),(136107,5969),(136108,5970),(136109,5970),(136110,5970),(136111,5970),(136112,5971),(136113,5971),(136114,5971),(136115,5971),(136116,5972),(136117,5972),(136118,5972),(136119,5972),(136120,5973),(136121,5973),(136122,5973),(136123,5973),(136124,5974),(136125,5974),(136126,5974),(136127,5974),(136128,5975),(136129,5975),(136130,5975),(136131,5975),(136132,5975),(136133,5975),(136134,5975),(136135,5976),(136136,5976),(136137,5976),(136138,5976),(136139,5976),(136140,5976),(136141,5976),(136142,5977),(136143,5977),(136144,5977),(136145,5977),(136146,5977),(136147,5977),(136148,5977),(136149,5978),(136150,5978),(136151,5978),(136152,5978),(136153,5978),(136154,5978),(136155,5978),(136156,5979),(136157,5979),(136158,5979),(136159,5979),(136160,5979),(136161,5979),(136162,5979),(136163,5980),(136164,5980),(136165,5980),(136166,5980),(136167,5980),(136168,5980),(136169,5980),(136170,5981),(136171,5981),(136172,5981),(136173,5981),(136174,5981),(136175,5981),(136176,5981),(136177,5982),(136178,5982),(136179,5982),(136180,5982),(136181,5982),(136182,5982),(136183,5982),(136184,5983),(136185,5983),(136186,5983),(136187,5983),(136188,5983),(136189,5983),(136190,5983),(136191,5984),(136192,5984),(136193,5984),(136194,5984),(136195,5984),(136196,5984),(136197,5984),(136198,5985),(136199,5985),(136200,5985),(136201,5985),(136202,5985),(136203,5985),(136204,5985),(136205,5986),(136206,5986),(136207,5986),(136208,5986),(136209,5986),(136210,5986),(136211,5986),(136212,5987),(136213,5987),(136214,5987),(136215,5987),(136216,5987),(136217,5987),(136218,5987),(136219,5988),(136220,5988),(136221,5988),(136222,5988),(136223,5988),(136224,5988),(136225,5988),(136226,5989),(136227,5989),(136228,5989),(136229,5989),(136230,5989),(136231,5989),(136232,5989),(136233,5990),(136234,5990),(136235,5990),(136236,5990),(136237,5990),(136238,5990),(136239,5990),(136240,5991),(136241,5991),(136242,5991),(136243,5991),(136244,5991),(136245,5991),(136246,5991),(136247,5992),(136248,5992),(136249,5992),(136250,5992),(136251,5992),(136252,5992),(136253,5992),(136254,5993),(136255,5993),(136256,5993),(136257,5993),(136258,5993),(136259,5993),(136260,5993),(136261,5994),(136262,5994),(136263,5994),(136264,5994),(136265,5994),(136266,5994),(136267,5994),(136268,5995),(136269,5995),(136270,5995),(136271,5995),(136272,5995),(136273,5995),(136274,5995),(136275,5996),(136276,5996),(136277,5996),(136278,5996),(136279,5996),(136280,5996),(136281,5996),(136282,5997),(136283,5997),(136284,5997),(136285,5997),(136286,5997),(136287,5997),(136288,5997),(136289,5998),(136290,5998),(136291,5998),(136292,5998),(136293,5998),(136294,5998),(136295,5998),(136296,5998),(136297,5998),(136298,5999),(136299,5999),(136300,5999),(136301,5999),(136302,5999),(136303,5999),(136304,5999),(136305,5999),(136306,5999),(136307,6000),(136308,6000),(136309,6000),(136310,6000),(136311,6000),(136312,6000),(136313,6000),(136314,6001),(136315,6001),(136316,6001),(136317,6001),(136318,6001),(136319,6001),(136320,6001),(136321,6002),(136322,6002),(136323,6002),(136324,6002),(136325,6002),(136326,6002),(136327,6002),(136328,6003),(136329,6003),(136330,6003),(136331,6003),(136332,6003),(136333,6003),(136334,6003),(136335,6004),(136336,6004),(136337,6004),(136338,6004),(136339,6004),(136340,6004),(136341,6004),(136342,6005),(136343,6005),(136344,6005),(136345,6005),(136346,6005),(136347,6005),(136348,6005),(136349,6005),(136350,6005),(136351,6006),(136352,6006),(136353,6006),(136354,6006),(136355,6006),(136356,6006),(136357,6006),(136358,6007),(136359,6007),(136360,6007),(136361,6007),(136362,6007),(136363,6007),(136364,6007),(136365,6008),(136366,6008),(136367,6008),(136368,6008),(136369,6008),(136370,6008),(136371,6009),(136372,6009),(136373,6009),(136374,6009),(136375,6009),(136376,6009),(136377,6010),(136378,6010),(136379,6010),(136380,6010),(136381,6010),(136382,6010),(136383,6011),(136384,6011),(136385,6011),(136386,6011),(136387,6011),(136388,6011),(136389,6012),(136390,6012),(136391,6012),(136392,6012),(136393,6012),(136394,6012),(136395,6012),(136396,6013),(136397,6013),(136398,6013),(136399,6013),(136400,6013),(136401,6013),(136402,6013),(136403,6014),(136404,6014),(136405,6014),(136406,6014),(136407,6014),(136408,6014),(136409,6014),(136410,6015),(136411,6015),(136412,6015),(136413,6015),(136414,6015),(136415,6015),(136416,6015),(136417,6016),(136418,6016),(136419,6016),(136420,6016),(136421,6016),(136422,6016),(136423,6016),(136424,6017),(136425,6017),(136426,6017),(136427,6017),(136428,6017),(136429,6017),(136430,6017),(136431,6018),(136432,6018),(136433,6018),(136434,6018),(136435,6018),(136436,6018),(136437,6018),(136438,6019),(136439,6019),(136440,6019),(136441,6019),(136442,6019),(136443,6019),(136444,6019),(136445,6020),(136446,6020),(136447,6020),(136448,6020),(136449,6020),(136450,6020),(136451,6020),(136452,6021),(136453,6021),(136454,6021),(136455,6021),(136456,6021),(136457,6021),(136458,6021),(136459,6022),(136460,6022),(136461,6022),(136462,6022),(136463,6022),(136464,6022),(136465,6022),(136466,6022),(136467,6022),(136468,6023),(136469,6023),(136470,6023),(136471,6023),(136472,6023),(136473,6023),(136474,6023),(136475,6023),(136476,6023),(136477,6024),(136478,6024),(136479,6024),(136480,6024),(136481,6024),(136482,6024),(136483,6024),(136484,6024),(136485,6024),(136486,6025),(136487,6025),(136488,6025),(136489,6025),(136490,6025),(136491,6025),(136492,6025),(136493,6025),(136494,6025),(136495,6026),(136496,6026),(136497,6026),(136498,6026),(136499,6026),(136500,6026),(136501,6026),(136502,6026),(136503,6026),(136504,6027),(136505,6027),(136506,6027),(136507,6027),(136508,6027),(136509,6027),(136510,6027),(136511,6027),(136512,6027),(136513,6028),(136514,6028),(136515,6028),(136516,6028),(136517,6028),(136518,6028),(136519,6028),(136520,6028),(136521,6028),(136522,6029),(136523,6029),(136524,6029),(136525,6029),(136526,6029),(136527,6029),(136528,6029),(136529,6029),(136530,6029),(136531,6030),(136532,6030),(136533,6030),(136534,6030),(136535,6030),(136536,6030),(136537,6030),(136538,6031),(136539,6031),(136540,6031),(136541,6031),(136542,6031),(136543,6031),(136544,6031),(136545,6032),(136546,6032),(136547,6032),(136548,6032),(136549,6032),(136550,6032),(136551,6032),(136552,6033),(136553,6033),(136554,6033),(136555,6033),(136556,6033),(136557,6033),(136558,6033),(136559,6034),(136560,6034),(136561,6034),(136562,6034),(136563,6034),(136564,6034),(136565,6034),(136566,5961),(136567,5961),(136568,5961),(136569,5962),(136570,5962),(136571,5962),(136572,5963),(136573,5963),(136574,5963),(136575,5964),(136576,5964),(136577,5964),(136578,5965),(136579,5965),(136580,5965),(136581,5966),(136582,5966),(136583,5966),(136584,5967),(136585,5967),(136586,5967),(136587,5968),(136588,5968),(136589,5968),(136590,5969),(136591,5969),(136592,5969),(136593,5970),(136594,5970),(136595,5970),(136596,5971),(136597,5971),(136598,5971),(136599,5972),(136600,5972),(136601,5972),(136602,5973),(136603,5973),(136604,5973),(136605,5974),(136606,5974),(136607,5974),(136608,5975),(136609,5975),(136610,5975),(136611,5976),(136612,5976),(136613,5976),(136614,5977),(136615,5977),(136616,5977),(136617,5978),(136618,5978),(136619,5978),(136620,5979),(136621,5979),(136622,5979),(136623,5980),(136624,5980),(136625,5980),(136626,5981),(136627,5981),(136628,5981),(136629,5982),(136630,5982),(136631,5982),(136632,5983),(136633,5983),(136634,5983),(136635,5984),(136636,5984),(136637,5984),(136638,5985),(136639,5985),(136640,5985),(136641,5986),(136642,5986),(136643,5986),(136644,5987),(136645,5987),(136646,5987),(136647,5988),(136648,5988),(136649,5988),(136650,5989),(136651,5989),(136652,5989),(136653,5990),(136654,5990),(136655,5990),(136656,5991),(136657,5991),(136658,5991),(136659,5992),(136660,5992),(136661,5992),(136662,5993),(136663,5993),(136664,5993),(136665,5994),(136666,5994),(136667,5994),(136668,5995),(136669,5995),(136670,5995),(136671,5996),(136672,5996),(136673,5996),(136674,5997),(136675,5997),(136676,5997),(136677,5998),(136678,5998),(136679,5999),(136680,5999),(136681,6000),(136682,6000),(136683,6000),(136684,6001),(136685,6001),(136686,6001),(136687,6002),(136688,6002),(136689,6002),(136690,6003),(136691,6003),(136692,6003),(136693,6004),(136694,6004),(136695,6004),(136696,6005),(136697,6005),(136698,6006),(136699,6006),(136700,6006),(136701,6007),(136702,6007),(136703,6007),(136704,6008),(136705,6008),(136706,6008),(136707,6009),(136708,6009),(136709,6009),(136710,6010),(136711,6010),(136712,6010),(136713,6011),(136714,6011),(136715,6011),(136716,6012),(136717,6012),(136718,6012),(136719,6013),(136720,6013),(136721,6013),(136722,6014),(136723,6014),(136724,6014),(136725,6015),(136726,6015),(136727,6015),(136728,6016),(136729,6016),(136730,6016),(136731,6017),(136732,6017),(136733,6017),(136734,6018),(136735,6018),(136736,6018),(136737,6019),(136738,6019),(136739,6019),(136740,6020),(136741,6020),(136742,6020),(136743,6021),(136744,6021),(136745,6021),(136746,6022),(136747,6022),(136748,6022),(136749,6023),(136750,6023),(136751,6023),(136752,6024),(136753,6024),(136754,6024),(136755,6025),(136756,6025),(136757,6025),(136758,6026),(136759,6026),(136760,6026),(136761,6027),(136762,6027),(136763,6027),(136764,6028),(136765,6028),(136766,6028),(136767,6029),(136768,6029),(136769,6029),(136770,6030),(136771,6030),(136772,6030),(136773,6031),(136774,6031),(136775,6031),(136776,6032),(136777,6032),(136778,6032),(136779,6033),(136780,6033),(136781,6033),(136782,6034),(136783,6034),(136784,6034),(136785,5961),(136786,5961),(136787,5961),(136788,5961),(136789,5961),(136790,5961),(136791,5961),(136792,5961),(136793,5961),(136794,5961),(136795,5961),(136796,5962),(136797,5962),(136798,5962),(136799,5962),(136800,5962),(136801,5962),(136802,5962),(136803,5962),(136804,5962),(136805,5962),(136806,5962),(136807,5963),(136808,5963),(136809,5963),(136810,5963),(136811,5963),(136812,5963),(136813,5963),(136814,5963),(136815,5963),(136816,5963),(136817,5963),(136818,5964),(136819,5964),(136820,5964),(136821,5964),(136822,5964),(136823,5964),(136824,5964),(136825,5964),(136826,5964),(136827,5964),(136828,5964),(136829,5965),(136830,5965),(136831,5965),(136832,5965),(136833,5965),(136834,5965),(136835,5965),(136836,5965),(136837,5965),(136838,5965),(136839,5965),(136840,5966),(136841,5966),(136842,5966),(136843,5966),(136844,5966),(136845,5966),(136846,5966),(136847,5966),(136848,5966),(136849,5966),(136850,5966),(136851,5967),(136852,5967),(136853,5967),(136854,5967),(136855,5967),(136856,5967),(136857,5967),(136858,5967),(136859,5967),(136860,5967),(136861,5967),(136862,5968),(136863,5968),(136864,5968),(136865,5968),(136866,5968),(136867,5968),(136868,5968),(136869,5968),(136870,5968),(136871,5968),(136872,5968),(136873,5969),(136874,5969),(136875,5969),(136876,5969),(136877,5969),(136878,5969),(136879,5969),(136880,5969),(136881,5969),(136882,5969),(136883,5969),(136884,5970),(136885,5970),(136886,5970),(136887,5970),(136888,5970),(136889,5970),(136890,5970),(136891,5970),(136892,5970),(136893,5970),(136894,5970),(136895,5971),(136896,5971),(136897,5971),(136898,5971),(136899,5971),(136900,5971),(136901,5971),(136902,5971),(136903,5971),(136904,5971),(136905,5971),(136906,5972),(136907,5972),(136908,5972),(136909,5972),(136910,5972),(136911,5972),(136912,5972),(136913,5972),(136914,5972),(136915,5972),(136916,5972),(136917,5973),(136918,5973),(136919,5973),(136920,5973),(136921,5973),(136922,5973),(136923,5973),(136924,5973),(136925,5973),(136926,5973),(136927,5973),(136928,5974),(136929,5974),(136930,5974),(136931,5974),(136932,5974),(136933,5974),(136934,5974),(136935,5974),(136936,5974),(136937,5974),(136938,5974),(136939,5975),(136940,5975),(136941,5975),(136942,5975),(136943,5975),(136944,5975),(136945,5975),(136946,5975),(136947,5975),(136948,5975),(136949,5975),(136950,5976),(136951,5976),(136952,5976),(136953,5976),(136954,5976),(136955,5976),(136956,5976),(136957,5976),(136958,5976),(136959,5976),(136960,5976),(136961,5977),(136962,5977),(136963,5977),(136964,5977),(136965,5977),(136966,5977),(136967,5977),(136968,5977),(136969,5977),(136970,5977),(136971,5977),(136972,5978),(136973,5978),(136974,5978),(136975,5978),(136976,5978),(136977,5978),(136978,5978),(136979,5978),(136980,5978),(136981,5978),(136982,5978),(136983,5979),(136984,5979),(136985,5979),(136986,5979),(136987,5979),(136988,5979),(136989,5979),(136990,5979),(136991,5979),(136992,5979),(136993,5979),(136994,5980),(136995,5980),(136996,5980),(136997,5980),(136998,5980),(136999,5980),(137000,5980),(137001,5980),(137002,5980),(137003,5980),(137004,5980),(137005,5981),(137006,5981),(137007,5981),(137008,5981),(137009,5981),(137010,5981),(137011,5981),(137012,5981),(137013,5981),(137014,5981),(137015,5981),(137016,5982),(137017,5982),(137018,5982),(137019,5982),(137020,5982),(137021,5982),(137022,5982),(137023,5982),(137024,5982),(137025,5982),(137026,5982),(137027,5983),(137028,5983),(137029,5983),(137030,5983),(137031,5983),(137032,5983),(137033,5983),(137034,5983),(137035,5983),(137036,5983),(137037,5983),(137038,5984),(137039,5984),(137040,5984),(137041,5984),(137042,5984),(137043,5984),(137044,5984),(137045,5984),(137046,5984),(137047,5984),(137048,5984),(137049,5985),(137050,5985),(137051,5985),(137052,5985),(137053,5985),(137054,5985),(137055,5985),(137056,5985),(137057,5985),(137058,5985),(137059,5985),(137060,5986),(137061,5986),(137062,5986),(137063,5986),(137064,5986),(137065,5986),(137066,5986),(137067,5986),(137068,5986),(137069,5986),(137070,5986),(137071,5987),(137072,5987),(137073,5987),(137074,5987),(137075,5987),(137076,5987),(137077,5987),(137078,5987),(137079,5987),(137080,5987),(137081,5987),(137082,5988),(137083,5988),(137084,5988),(137085,5988),(137086,5988),(137087,5988),(137088,5988),(137089,5988),(137090,5988),(137091,5988),(137092,5988),(137093,5989),(137094,5989),(137095,5989),(137096,5989),(137097,5989),(137098,5989),(137099,5989),(137100,5989),(137101,5989),(137102,5989),(137103,5989),(137104,5990),(137105,5990),(137106,5990),(137107,5990),(137108,5990),(137109,5990),(137110,5990),(137111,5990),(137112,5990),(137113,5990),(137114,5990),(137115,5991),(137116,5991),(137117,5991),(137118,5991),(137119,5991),(137120,5991),(137121,5991),(137122,5991),(137123,5991),(137124,5991),(137125,5991),(137126,5992),(137127,5992),(137128,5992),(137129,5992),(137130,5992),(137131,5992),(137132,5992),(137133,5992),(137134,5992),(137135,5992),(137136,5992),(137137,5993),(137138,5993),(137139,5993),(137140,5993),(137141,5993),(137142,5993),(137143,5993),(137144,5993),(137145,5993),(137146,5993),(137147,5993),(137148,5994),(137149,5994),(137150,5994),(137151,5994),(137152,5994),(137153,5994),(137154,5994),(137155,5994),(137156,5994),(137157,5994),(137158,5994),(137159,5995),(137160,5995),(137161,5995),(137162,5995),(137163,5995),(137164,5995),(137165,5995),(137166,5995),(137167,5995),(137168,5995),(137169,5995),(137170,5996),(137171,5996),(137172,5996),(137173,5996),(137174,5996),(137175,5996),(137176,5996),(137177,5996),(137178,5996),(137179,5996),(137180,5996),(137181,5997),(137182,5997),(137183,5997),(137184,5997),(137185,5997),(137186,5997),(137187,5997),(137188,5997),(137189,5997),(137190,5997),(137191,5997),(137192,5998),(137193,5998),(137194,5998),(137195,5998),(137196,5998),(137197,5998),(137198,5998),(137199,5998),(137200,5998),(137201,5998),(137202,5998),(137203,5999),(137204,5999),(137205,5999),(137206,5999),(137207,5999),(137208,5999),(137209,5999),(137210,5999),(137211,5999),(137212,5999),(137213,5999),(137214,6000),(137215,6000),(137216,6000),(137217,6000),(137218,6000),(137219,6000),(137220,6000),(137221,6000),(137222,6000),(137223,6000),(137224,6000),(137225,6001),(137226,6001),(137227,6001),(137228,6001),(137229,6001),(137230,6001),(137231,6001),(137232,6001),(137233,6001),(137234,6001),(137235,6001),(137236,6002),(137237,6002),(137238,6002),(137239,6002),(137240,6002),(137241,6002),(137242,6002),(137243,6002),(137244,6002),(137245,6002),(137246,6002),(137247,6003),(137248,6003),(137249,6003),(137250,6003),(137251,6003),(137252,6003),(137253,6003),(137254,6003),(137255,6003),(137256,6003),(137257,6003),(137258,6004),(137259,6004),(137260,6004),(137261,6004),(137262,6004),(137263,6004),(137264,6004),(137265,6004),(137266,6004),(137267,6004),(137268,6004),(137269,6005),(137270,6005),(137271,6005),(137272,6005),(137273,6005),(137274,6005),(137275,6005),(137276,6005),(137277,6005),(137278,6005),(137279,6005),(137280,6006),(137281,6006),(137282,6006),(137283,6006),(137284,6006),(137285,6006),(137286,6006),(137287,6006),(137288,6006),(137289,6006),(137290,6006),(137291,6007),(137292,6007),(137293,6007),(137294,6007),(137295,6007),(137296,6007),(137297,6007),(137298,6007),(137299,6007),(137300,6007),(137301,6007),(137302,6008),(137303,6008),(137304,6008),(137305,6008),(137306,6008),(137307,6008),(137308,6008),(137309,6008),(137310,6008),(137311,6008),(137312,6008),(137313,6009),(137314,6009),(137315,6009),(137316,6009),(137317,6009),(137318,6009),(137319,6009),(137320,6009),(137321,6009),(137322,6009),(137323,6009),(137324,6010),(137325,6010),(137326,6010),(137327,6010),(137328,6010),(137329,6010),(137330,6010),(137331,6010),(137332,6010),(137333,6010),(137334,6010),(137335,6011),(137336,6011),(137337,6011),(137338,6011),(137339,6011),(137340,6011),(137341,6011),(137342,6011),(137343,6011),(137344,6011),(137345,6011),(137346,6012),(137347,6012),(137348,6012),(137349,6012),(137350,6012),(137351,6012),(137352,6012),(137353,6012),(137354,6012),(137355,6012),(137356,6012),(137357,6013),(137358,6013),(137359,6013),(137360,6013),(137361,6013),(137362,6013),(137363,6013),(137364,6013),(137365,6013),(137366,6013),(137367,6013),(137368,6014),(137369,6014),(137370,6014),(137371,6014),(137372,6014),(137373,6014),(137374,6014),(137375,6014),(137376,6014),(137377,6014),(137378,6014),(137379,6015),(137380,6015),(137381,6015),(137382,6015),(137383,6015),(137384,6015),(137385,6015),(137386,6015),(137387,6015),(137388,6015),(137389,6015),(137390,6016),(137391,6016),(137392,6016),(137393,6016),(137394,6016),(137395,6016),(137396,6016),(137397,6016),(137398,6016),(137399,6016),(137400,6016),(137401,6017),(137402,6017),(137403,6017),(137404,6017),(137405,6017),(137406,6017),(137407,6017),(137408,6017),(137409,6017),(137410,6017),(137411,6017),(137412,6018),(137413,6018),(137414,6018),(137415,6018),(137416,6018),(137417,6018),(137418,6018),(137419,6018),(137420,6018),(137421,6018),(137422,6018),(137423,6019),(137424,6019),(137425,6019),(137426,6019),(137427,6019),(137428,6019),(137429,6019),(137430,6019),(137431,6019),(137432,6019),(137433,6019),(137434,6020),(137435,6020),(137436,6020),(137437,6020),(137438,6020),(137439,6020),(137440,6020),(137441,6020),(137442,6020),(137443,6020),(137444,6020),(137445,6021),(137446,6021),(137447,6021),(137448,6021),(137449,6021),(137450,6021),(137451,6021),(137452,6021),(137453,6021),(137454,6021),(137455,6021),(137456,6022),(137457,6022),(137458,6022),(137459,6022),(137460,6022),(137461,6022),(137462,6022),(137463,6022),(137464,6022),(137465,6022),(137466,6022),(137467,6023),(137468,6023),(137469,6023),(137470,6023),(137471,6023),(137472,6023),(137473,6023),(137474,6023),(137475,6023),(137476,6023),(137477,6023),(137478,6024),(137479,6024),(137480,6024),(137481,6024),(137482,6024),(137483,6024),(137484,6024),(137485,6024),(137486,6024),(137487,6024),(137488,6024),(137489,6025),(137490,6025),(137491,6025),(137492,6025),(137493,6025),(137494,6025),(137495,6025),(137496,6025),(137497,6025),(137498,6025),(137499,6025),(137500,6026),(137501,6026),(137502,6026),(137503,6026),(137504,6026),(137505,6026),(137506,6026),(137507,6026),(137508,6026),(137509,6026),(137510,6026),(137511,6027),(137512,6027),(137513,6027),(137514,6027),(137515,6027),(137516,6027),(137517,6027),(137518,6027),(137519,6027),(137520,6027),(137521,6027),(137522,6028),(137523,6028),(137524,6028),(137525,6028),(137526,6028),(137527,6028),(137528,6028),(137529,6028),(137530,6028),(137531,6028),(137532,6028),(137533,6029),(137534,6029),(137535,6029),(137536,6029),(137537,6029),(137538,6029),(137539,6029),(137540,6029),(137541,6029),(137542,6029),(137543,6029),(137544,6030),(137545,6030),(137546,6030),(137547,6030),(137548,6030),(137549,6030),(137550,6030),(137551,6030),(137552,6030),(137553,6030),(137554,6030),(137555,6031),(137556,6031),(137557,6031),(137558,6031),(137559,6031),(137560,6031),(137561,6031),(137562,6031),(137563,6031),(137564,6031),(137565,6031),(137566,6032),(137567,6032),(137568,6032),(137569,6032),(137570,6032),(137571,6032),(137572,6032),(137573,6032),(137574,6032),(137575,6032),(137576,6032),(137577,6033),(137578,6033),(137579,6033),(137580,6033),(137581,6033),(137582,6033),(137583,6033),(137584,6033),(137585,6033),(137586,6033),(137587,6033),(137588,6034),(137589,6034),(137590,6034),(137591,6034),(137592,6034),(137593,6034),(137594,6034),(137595,6034),(137596,6034),(137597,6034),(137598,6034),(137599,5961),(137600,5961),(137601,5961),(137602,5962),(137603,5962),(137604,5962),(137605,5963),(137606,5963),(137607,5963),(137608,5964),(137609,5964),(137610,5964),(137611,5965),(137612,5965),(137613,5965),(137614,5966),(137615,5966),(137616,5966),(137617,5967),(137618,5967),(137619,5967),(137620,5968),(137621,5968),(137622,5968),(137623,5969),(137624,5969),(137625,5969),(137626,5970),(137627,5970),(137628,5970),(137629,5971),(137630,5971),(137631,5971),(137632,5972),(137633,5972),(137634,5972),(137635,5973),(137636,5973),(137637,5973),(137638,5974),(137639,5974),(137640,5974),(137641,5975),(137642,5975),(137643,5975),(137644,5975),(137645,5976),(137646,5976),(137647,5976),(137648,5976),(137649,5977),(137650,5977),(137651,5977),(137652,5977),(137653,5978),(137654,5978),(137655,5978),(137656,5978),(137657,5979),(137658,5979),(137659,5979),(137660,5979),(137661,5980),(137662,5980),(137663,5980),(137664,5980),(137665,5981),(137666,5981),(137667,5981),(137668,5981),(137669,5982),(137670,5982),(137671,5982),(137672,5982),(137673,5983),(137674,5983),(137675,5983),(137676,5983),(137677,5984),(137678,5984),(137679,5984),(137680,5984),(137681,5985),(137682,5985),(137683,5985),(137684,5985),(137685,5986),(137686,5986),(137687,5986),(137688,5986),(137689,5987),(137690,5987),(137691,5987),(137692,5987),(137693,5988),(137694,5988),(137695,5988),(137696,5988),(137697,5989),(137698,5989),(137699,5989),(137700,5989),(137701,5990),(137702,5990),(137703,5990),(137704,5990),(137705,5991),(137706,5991),(137707,5991),(137708,5991),(137709,5992),(137710,5992),(137711,5992),(137712,5992),(137713,5993),(137714,5993),(137715,5993),(137716,5993),(137717,5994),(137718,5994),(137719,5994),(137720,5995),(137721,5995),(137722,5995),(137723,5996),(137724,5996),(137725,5996),(137726,5997),(137727,5997),(137728,5997),(137729,5998),(137730,5998),(137731,5998),(137732,5998),(137733,5999),(137734,5999),(137735,5999),(137736,5999),(137737,6000),(137738,6000),(137739,6000),(137740,6001),(137741,6001),(137742,6001),(137743,6002),(137744,6002),(137745,6002),(137746,6003),(137747,6003),(137748,6003),(137749,6003),(137750,6004),(137751,6004),(137752,6004),(137753,6004),(137754,6005),(137755,6005),(137756,6005),(137757,6005),(137758,6006),(137759,6006),(137760,6006),(137761,6006),(137762,6007),(137763,6007),(137764,6007),(137765,6007),(137766,6008),(137767,6008),(137768,6008),(137769,6008),(137770,6009),(137771,6009),(137772,6009),(137773,6009),(137774,6010),(137775,6010),(137776,6010),(137777,6010),(137778,6011),(137779,6011),(137780,6011),(137781,6011),(137782,6012),(137783,6012),(137784,6012),(137785,6013),(137786,6013),(137787,6013),(137788,6014),(137789,6014),(137790,6014),(137791,6015),(137792,6015),(137793,6015),(137794,6016),(137795,6016),(137796,6016),(137797,6017),(137798,6017),(137799,6017),(137800,6018),(137801,6018),(137802,6018),(137803,6019),(137804,6019),(137805,6019),(137806,6020),(137807,6020),(137808,6020),(137809,6020),(137810,6021),(137811,6021),(137812,6021),(137813,6021),(137814,6022),(137815,6022),(137816,6022),(137817,6022),(137818,6023),(137819,6023),(137820,6023),(137821,6023),(137822,6024),(137823,6024),(137824,6024),(137825,6024),(137826,6025),(137827,6025),(137828,6025),(137829,6025),(137830,6026),(137831,6026),(137832,6026),(137833,6026),(137834,6027),(137835,6027),(137836,6027),(137837,6027),(137838,6028),(137839,6028),(137840,6028),(137841,6028),(137842,6029),(137843,6029),(137844,6029),(137845,6029),(137846,6030),(137847,6030),(137848,6030),(137849,6030),(137850,6031),(137851,6031),(137852,6031),(137853,6031),(137854,6032),(137855,6032),(137856,6032),(137857,6032),(137858,6033),(137859,6033),(137860,6033),(137861,6033),(137862,6034),(137863,6034),(137864,6034),(137865,6034),(137866,5761),(137867,5762),(137868,5763),(137869,5764),(137870,5765),(137871,5766),(137872,5767),(137873,5768),(137874,5769),(137875,5770),(137876,5771),(137877,5772),(137878,5773),(137879,5774),(137880,5775),(137881,5776),(137882,5777),(137883,5778),(137884,5779),(137885,5780),(137886,5781),(137887,5782),(137888,5783),(137889,5784),(137890,5785),(137891,5786),(137892,5787),(137893,5788),(137894,5789),(137895,5790),(137896,5791),(137897,5792),(137898,5793),(137899,5794),(137900,5795),(137901,5796),(137902,5797),(137903,5798),(137904,5799),(137905,5800),(137906,5801),(137907,5802),(137908,5803),(137909,5804),(137910,5805),(137911,5806),(137912,5807),(137913,5808),(137914,5809),(137915,5810),(137916,5811),(137917,5812),(137918,5813),(137919,5814),(137920,5815),(137921,5816),(137922,5817),(137923,5818),(137924,5819),(137925,5820),(137926,5821),(137927,5822),(137928,5823),(137929,5824),(137930,5825),(137931,5826),(137932,5827),(137933,5828),(137934,5829),(137935,5830),(137936,5831),(137937,5832),(137938,5833),(137939,5834),(137940,5835),(137941,5836),(137942,5837),(137943,5838),(137944,5839),(137945,5840),(137946,5841),(137947,5842),(137948,5843),(137949,5844),(137950,5845),(137951,5846),(137952,5847),(137953,5848),(137954,5849),(137955,5850),(137956,5851),(137957,5852),(137958,5853),(137959,5854),(137960,5855),(137961,5856),(137962,5857),(137963,5858),(137964,5859),(137965,5860),(137966,5861),(137967,5862),(137968,5863),(137969,5864),(137970,5865),(137971,5866),(137972,5867),(137973,5868),(137974,5869),(137975,5870),(137976,5871),(137977,5872),(137978,5873),(137979,5874),(137980,5875),(137981,5876),(137982,5877),(137983,5878),(137984,5879),(137985,5880),(137986,5881),(137987,5882),(137988,5883),(137989,5884),(137990,5885),(137991,5886),(137992,5887),(137993,5888),(137994,5889),(137995,5890),(137996,5891),(137997,5892),(137998,5893),(137999,5894),(138000,5895),(138001,5896),(138002,5897),(138003,5898),(138004,5899),(138005,5900),(138006,5901),(138007,5902),(138008,5903),(138009,5904),(138010,5905),(138011,5906),(138012,5907),(138013,5908),(138014,5909),(138015,5910),(138016,5911),(138017,5912),(138018,5913),(138019,5914),(138020,5915),(138021,5916),(138022,5917),(138023,5918),(138024,5919),(138025,5920),(138026,5921),(138027,5922),(138028,5923),(138029,5924),(138030,5925),(138031,5926),(138032,5927),(138033,5928),(138034,5929),(138035,5930),(138036,5931),(138037,5932),(138038,5933),(138039,5934),(138040,5935),(138041,5936),(138042,5937),(138043,5938),(138044,5939),(138045,5940),(138046,5941),(138047,5942),(138048,5943),(138049,5944),(138050,5945),(138051,5946),(138052,5947),(138053,5948),(138054,5949),(138055,5950),(138056,5951),(138057,5952),(138058,5953),(138059,5954),(138060,5955),(138061,5956),(138062,5957),(138063,5958),(138064,5959),(138065,5960),(138066,5961),(138067,5962),(138068,5963),(138069,5964),(138070,5965),(138071,5966),(138072,5967),(138073,5968),(138074,5969),(138075,5970),(138076,5971),(138077,5972),(138078,5973),(138079,5974),(138080,5975),(138081,5976),(138082,5977),(138083,5978),(138084,5979),(138085,5980),(138086,5981),(138087,5982),(138088,5983),(138089,5984),(138090,5985),(138091,5986),(138092,5987),(138093,5988),(138094,5989),(138095,5990),(138096,5991),(138097,5992),(138098,5993),(138099,5994),(138100,5995),(138101,5996),(138102,5997),(138103,5998),(138104,5999),(138105,6000),(138106,6001),(138107,6002),(138108,6003),(138109,6004),(138110,6005),(138111,6006),(138112,6007),(138113,6008),(138114,6009),(138115,6010),(138116,6011),(138117,6012),(138118,6013),(138119,6014),(138120,6015),(138121,6016),(138122,6017),(138123,6018),(138124,6019),(138125,6020),(138126,6021),(138127,6022),(138128,6023),(138129,6024),(138130,6025),(138131,6026),(138132,6027),(138133,6028),(138134,6029),(138135,6030),(138136,6031),(138137,6032),(138138,6033),(138139,6034),(138140,6035),(138141,6036),(138142,6037),(138143,6038),(138144,6039),(138145,6040),(138146,6041),(138147,6042),(138148,6043),(138149,6044),(138150,6045),(138151,6046),(138152,6047),(138153,6048),(138154,6049),(138155,6050),(138156,6051),(138157,6052),(138158,6053),(138159,6054),(138160,6055),(138161,6056),(138162,6057),(138163,6058),(138164,6059),(138165,6060),(138166,6061),(138167,6062),(138168,6063),(138169,6064),(138170,6065),(138171,6066),(138172,6067),(138173,6068),(138174,6069),(138175,6070),(138176,6071),(138177,6072),(138178,6073),(138179,6074),(138180,6075),(138181,6076),(138182,6077),(138183,6078),(138184,6079),(138185,6080),(138186,6081),(138187,6082),(138188,6083),(138189,6084),(138190,6085),(138191,6086),(138192,6087),(138193,6088),(138194,6089),(138195,6090),(138196,6091),(138197,6092),(138198,6093),(138199,6094),(138200,6095),(138201,6096),(138202,6097),(138203,6098),(138204,6099),(138205,6100),(138206,6101),(138207,6102),(138208,6103),(138209,6104),(138210,6105),(138211,6106),(138212,6107),(138213,6108),(138214,6109),(138215,6110),(138216,6111),(138217,6112),(138218,6113),(138219,6114),(138220,6115),(138221,6116),(138222,6117),(138223,6118),(138224,6119),(138225,6120),(138226,6121),(138227,6122),(138228,6123),(138229,6124),(138230,6125),(138231,6126),(138232,6127),(138233,6128),(138234,6129),(138235,6130),(138236,6131),(138237,6132),(138238,6133),(138239,6134),(138240,6035),(138241,6035),(138242,6035),(138243,6036),(138244,6036),(138245,6036),(138246,6037),(138247,6037),(138248,6037),(138249,6038),(138250,6038),(138251,6038),(138252,6039),(138253,6039),(138254,6039),(138255,6040),(138256,6040),(138257,6040),(138258,6041),(138259,6041),(138260,6041),(138261,6042),(138262,6042),(138263,6042),(138264,6043),(138265,6043),(138266,6043),(138267,6044),(138268,6044),(138269,6044),(138270,6045),(138271,6045),(138272,6045),(138273,6046),(138274,6046),(138275,6046),(138276,6047),(138277,6047),(138278,6047),(138279,6048),(138280,6048),(138281,6048),(138282,6049),(138283,6049),(138284,6049),(138285,6050),(138286,6050),(138287,6050),(138288,6051),(138289,6051),(138290,6051),(138291,6052),(138292,6052),(138293,6052),(138294,6053),(138295,6053),(138296,6053),(138297,6054),(138298,6054),(138299,6054),(138300,6055),(138301,6055),(138302,6055),(138303,6056),(138304,6056),(138305,6056),(138306,6057),(138307,6057),(138308,6057),(138309,6058),(138310,6058),(138311,6058),(138312,6059),(138313,6059),(138314,6059),(138315,6060),(138316,6060),(138317,6060),(138318,6061),(138319,6061),(138320,6061),(138321,6062),(138322,6062),(138323,6062),(138324,6063),(138325,6063),(138326,6063),(138327,6064),(138328,6064),(138329,6064),(138330,6065),(138331,6065),(138332,6065),(138333,6066),(138334,6066),(138335,6066),(138336,6067),(138337,6067),(138338,6067),(138339,6068),(138340,6068),(138341,6068),(138342,6069),(138343,6069),(138344,6069),(138345,6070),(138346,6070),(138347,6070),(138348,6071),(138349,6071),(138350,6071),(138351,6072),(138352,6072),(138353,6072),(138354,6073),(138355,6073),(138356,6073),(138357,6074),(138358,6074),(138359,6074),(138360,6075),(138361,6075),(138362,6075),(138363,6076),(138364,6076),(138365,6076),(138366,6077),(138367,6077),(138368,6077),(138369,6078),(138370,6078),(138371,6078),(138372,6079),(138373,6079),(138374,6079),(138375,6080),(138376,6080),(138377,6080),(138378,6081),(138379,6081),(138380,6081),(138381,6082),(138382,6082),(138383,6082),(138384,6083),(138385,6083),(138386,6083),(138387,6084),(138388,6084),(138389,6084),(138390,6085),(138391,6085),(138392,6085),(138393,6086),(138394,6086),(138395,6086),(138396,6087),(138397,6087),(138398,6087),(138399,6088),(138400,6088),(138401,6088),(138402,6089),(138403,6089),(138404,6089),(138405,6090),(138406,6090),(138407,6090),(138408,6091),(138409,6091),(138410,6091),(138411,6092),(138412,6092),(138413,6092),(138414,6093),(138415,6093),(138416,6093),(138417,6094),(138418,6094),(138419,6094),(138420,6095),(138421,6095),(138422,6095),(138423,6096),(138424,6096),(138425,6096),(138426,6097),(138427,6097),(138428,6097),(138429,6098),(138430,6098),(138431,6098),(138432,6099),(138433,6099),(138434,6099),(138435,6100),(138436,6100),(138437,6100),(138438,6101),(138439,6101),(138440,6101),(138441,6102),(138442,6102),(138443,6102),(138444,6103),(138445,6103),(138446,6103),(138447,6104),(138448,6104),(138449,6104),(138450,6105),(138451,6105),(138452,6105),(138453,6106),(138454,6106),(138455,6106),(138456,6107),(138457,6107),(138458,6107),(138459,6108),(138460,6108),(138461,6108),(138462,6109),(138463,6109),(138464,6109),(138465,6110),(138466,6110),(138467,6110),(138468,6111),(138469,6111),(138470,6111),(138471,6112),(138472,6112),(138473,6112),(138474,6113),(138475,6113),(138476,6113),(138477,6114),(138478,6114),(138479,6114),(138480,6115),(138481,6115),(138482,6115),(138483,6116),(138484,6116),(138485,6116),(138486,6117),(138487,6117),(138488,6117),(138489,6118),(138490,6118),(138491,6118),(138492,6119),(138493,6119),(138494,6119),(138495,6120),(138496,6120),(138497,6120),(138498,6121),(138499,6121),(138500,6121),(138501,6122),(138502,6122),(138503,6122),(138504,6123),(138505,6123),(138506,6123),(138507,6124),(138508,6124),(138509,6124),(138510,6125),(138511,6125),(138512,6125),(138513,6126),(138514,6126),(138515,6126),(138516,6127),(138517,6127),(138518,6127),(138519,6128),(138520,6128),(138521,6128),(138522,6129),(138523,6129),(138524,6129),(138525,6130),(138526,6130),(138527,6130),(138528,6131),(138529,6131),(138530,6131),(138531,6132),(138532,6132),(138533,6132),(138534,6133),(138535,6133),(138536,6133),(138537,6134),(138538,6134),(138539,6134),(138540,6035),(138541,6035),(138542,6035),(138543,6035),(138544,6035),(138545,6035),(138546,6035),(138547,6035),(138548,6036),(138549,6036),(138550,6036),(138551,6036),(138552,6036),(138553,6036),(138554,6036),(138555,6036),(138556,6037),(138557,6037),(138558,6037),(138559,6037),(138560,6037),(138561,6037),(138562,6037),(138563,6037),(138564,6038),(138565,6038),(138566,6038),(138567,6038),(138568,6038),(138569,6038),(138570,6038),(138571,6038),(138572,6039),(138573,6039),(138574,6039),(138575,6039),(138576,6039),(138577,6039),(138578,6039),(138579,6039),(138580,6040),(138581,6040),(138582,6040),(138583,6040),(138584,6040),(138585,6040),(138586,6040),(138587,6040),(138588,6041),(138589,6041),(138590,6041),(138591,6041),(138592,6041),(138593,6041),(138594,6041),(138595,6041),(138596,6041),(138597,6041),(138598,6042),(138599,6042),(138600,6042),(138601,6042),(138602,6042),(138603,6042),(138604,6042),(138605,6042),(138606,6042),(138607,6042),(138608,6043),(138609,6043),(138610,6043),(138611,6043),(138612,6043),(138613,6043),(138614,6043),(138615,6043),(138616,6043),(138617,6043),(138618,6044),(138619,6044),(138620,6044),(138621,6044),(138622,6044),(138623,6044),(138624,6044),(138625,6044),(138626,6044),(138627,6044),(138628,6045),(138629,6045),(138630,6045),(138631,6045),(138632,6045),(138633,6045),(138634,6045),(138635,6045),(138636,6045),(138637,6045),(138638,6046),(138639,6046),(138640,6046),(138641,6046),(138642,6046),(138643,6046),(138644,6046),(138645,6046),(138646,6046),(138647,6046),(138648,6047),(138649,6047),(138650,6047),(138651,6047),(138652,6047),(138653,6047),(138654,6047),(138655,6047),(138656,6047),(138657,6047),(138658,6048),(138659,6048),(138660,6048),(138661,6048),(138662,6048),(138663,6048),(138664,6048),(138665,6048),(138666,6048),(138667,6048),(138668,6049),(138669,6049),(138670,6049),(138671,6049),(138672,6049),(138673,6049),(138674,6049),(138675,6049),(138676,6049),(138677,6049),(138678,6050),(138679,6050),(138680,6050),(138681,6050),(138682,6050),(138683,6050),(138684,6050),(138685,6050),(138686,6050),(138687,6050),(138688,6051),(138689,6051),(138690,6051),(138691,6051),(138692,6051),(138693,6051),(138694,6051),(138695,6051),(138696,6051),(138697,6051),(138698,6052),(138699,6052),(138700,6052),(138701,6052),(138702,6052),(138703,6052),(138704,6052),(138705,6052),(138706,6052),(138707,6052),(138708,6053),(138709,6053),(138710,6053),(138711,6053),(138712,6053),(138713,6053),(138714,6053),(138715,6053),(138716,6053),(138717,6053),(138718,6053),(138719,6053),(138720,6053),(138721,6053),(138722,6054),(138723,6054),(138724,6054),(138725,6054),(138726,6054),(138727,6054),(138728,6054),(138729,6054),(138730,6054),(138731,6054),(138732,6054),(138733,6054),(138734,6054),(138735,6054),(138736,6055),(138737,6055),(138738,6055),(138739,6055),(138740,6055),(138741,6055),(138742,6055),(138743,6055),(138744,6055),(138745,6055),(138746,6056),(138747,6056),(138748,6056),(138749,6056),(138750,6056),(138751,6056),(138752,6056),(138753,6056),(138754,6056),(138755,6056),(138756,6057),(138757,6057),(138758,6057),(138759,6057),(138760,6057),(138761,6057),(138762,6057),(138763,6057),(138764,6057),(138765,6057),(138766,6058),(138767,6058),(138768,6058),(138769,6058),(138770,6058),(138771,6058),(138772,6058),(138773,6058),(138774,6058),(138775,6058),(138776,6059),(138777,6059),(138778,6059),(138779,6059),(138780,6059),(138781,6059),(138782,6059),(138783,6059),(138784,6059),(138785,6059),(138786,6060),(138787,6060),(138788,6060),(138789,6060),(138790,6060),(138791,6060),(138792,6060),(138793,6060),(138794,6060),(138795,6060),(138796,6061),(138797,6061),(138798,6061),(138799,6061),(138800,6061),(138801,6061),(138802,6061),(138803,6061),(138804,6061),(138805,6061),(138806,6062),(138807,6062),(138808,6062),(138809,6062),(138810,6062),(138811,6062),(138812,6062),(138813,6062),(138814,6062),(138815,6062),(138816,6063),(138817,6063),(138818,6063),(138819,6063),(138820,6063),(138821,6063),(138822,6063),(138823,6063),(138824,6063),(138825,6063),(138826,6064),(138827,6064),(138828,6064),(138829,6064),(138830,6064),(138831,6064),(138832,6064),(138833,6064),(138834,6064),(138835,6064),(138836,6065),(138837,6065),(138838,6065),(138839,6065),(138840,6065),(138841,6065),(138842,6065),(138843,6065),(138844,6065),(138845,6065),(138846,6066),(138847,6066),(138848,6066),(138849,6066),(138850,6066),(138851,6066),(138852,6066),(138853,6066),(138854,6066),(138855,6066),(138856,6067),(138857,6067),(138858,6067),(138859,6067),(138860,6067),(138861,6067),(138862,6067),(138863,6067),(138864,6067),(138865,6067),(138866,6068),(138867,6068),(138868,6068),(138869,6068),(138870,6068),(138871,6068),(138872,6068),(138873,6068),(138874,6068),(138875,6068),(138876,6069),(138877,6069),(138878,6069),(138879,6069),(138880,6069),(138881,6069),(138882,6069),(138883,6069),(138884,6069),(138885,6069),(138886,6070),(138887,6070),(138888,6070),(138889,6070),(138890,6070),(138891,6070),(138892,6070),(138893,6070),(138894,6070),(138895,6070),(138896,6071),(138897,6071),(138898,6071),(138899,6071),(138900,6071),(138901,6071),(138902,6071),(138903,6071),(138904,6071),(138905,6071),(138906,6071),(138907,6071),(138908,6071),(138909,6071),(138910,6072),(138911,6072),(138912,6072),(138913,6072),(138914,6072),(138915,6072),(138916,6072),(138917,6072),(138918,6072),(138919,6072),(138920,6073),(138921,6073),(138922,6073),(138923,6073),(138924,6073),(138925,6073),(138926,6073),(138927,6073),(138928,6073),(138929,6073),(138930,6074),(138931,6074),(138932,6074),(138933,6074),(138934,6074),(138935,6074),(138936,6074),(138937,6074),(138938,6074),(138939,6074),(138940,6075),(138941,6075),(138942,6075),(138943,6075),(138944,6075),(138945,6075),(138946,6075),(138947,6075),(138948,6075),(138949,6075),(138950,6076),(138951,6076),(138952,6076),(138953,6076),(138954,6076),(138955,6076),(138956,6076),(138957,6076),(138958,6076),(138959,6076),(138960,6077),(138961,6077),(138962,6077),(138963,6077),(138964,6077),(138965,6077),(138966,6077),(138967,6077),(138968,6077),(138969,6077),(138970,6078),(138971,6078),(138972,6078),(138973,6078),(138974,6078),(138975,6078),(138976,6078),(138977,6078),(138978,6078),(138979,6078),(138980,6079),(138981,6079),(138982,6079),(138983,6079),(138984,6079),(138985,6079),(138986,6079),(138987,6079),(138988,6079),(138989,6079),(138990,6080),(138991,6080),(138992,6080),(138993,6080),(138994,6080),(138995,6080),(138996,6080),(138997,6080),(138998,6080),(138999,6080),(139000,6081),(139001,6081),(139002,6081),(139003,6081),(139004,6081),(139005,6081),(139006,6081),(139007,6081),(139008,6081),(139009,6081),(139010,6082),(139011,6082),(139012,6082),(139013,6082),(139014,6082),(139015,6082),(139016,6082),(139017,6082),(139018,6082),(139019,6082),(139020,6083),(139021,6083),(139022,6083),(139023,6083),(139024,6083),(139025,6083),(139026,6083),(139027,6083),(139028,6083),(139029,6083),(139030,6084),(139031,6084),(139032,6084),(139033,6084),(139034,6084),(139035,6084),(139036,6084),(139037,6084),(139038,6084),(139039,6084),(139040,6085),(139041,6085),(139042,6085),(139043,6085),(139044,6085),(139045,6085),(139046,6085),(139047,6085),(139048,6085),(139049,6085),(139050,6086),(139051,6086),(139052,6086),(139053,6086),(139054,6086),(139055,6086),(139056,6086),(139057,6086),(139058,6086),(139059,6086),(139060,6087),(139061,6087),(139062,6087),(139063,6087),(139064,6087),(139065,6087),(139066,6087),(139067,6087),(139068,6087),(139069,6087),(139070,6088),(139071,6088),(139072,6088),(139073,6088),(139074,6088),(139075,6088),(139076,6088),(139077,6088),(139078,6088),(139079,6088),(139080,6088),(139081,6088),(139082,6088),(139083,6088),(139084,6089),(139085,6089),(139086,6089),(139087,6089),(139088,6089),(139089,6089),(139090,6089),(139091,6089),(139092,6089),(139093,6089),(139094,6090),(139095,6090),(139096,6090),(139097,6090),(139098,6090),(139099,6090),(139100,6090),(139101,6090),(139102,6090),(139103,6090),(139104,6091),(139105,6091),(139106,6091),(139107,6091),(139108,6091),(139109,6091),(139110,6091),(139111,6091),(139112,6091),(139113,6091),(139114,6092),(139115,6092),(139116,6092),(139117,6092),(139118,6092),(139119,6092),(139120,6092),(139121,6092),(139122,6092),(139123,6092),(139124,6092),(139125,6092),(139126,6092),(139127,6092),(139128,6093),(139129,6093),(139130,6093),(139131,6093),(139132,6093),(139133,6093),(139134,6093),(139135,6093),(139136,6093),(139137,6093),(139138,6094),(139139,6094),(139140,6094),(139141,6094),(139142,6094),(139143,6094),(139144,6094),(139145,6094),(139146,6094),(139147,6094),(139148,6095),(139149,6095),(139150,6095),(139151,6095),(139152,6095),(139153,6095),(139154,6095),(139155,6095),(139156,6095),(139157,6095),(139158,6096),(139159,6096),(139160,6096),(139161,6096),(139162,6096),(139163,6096),(139164,6096),(139165,6096),(139166,6096),(139167,6096),(139168,6096),(139169,6096),(139170,6096),(139171,6096),(139172,6097),(139173,6097),(139174,6097),(139175,6097),(139176,6097),(139177,6097),(139178,6097),(139179,6097),(139180,6097),(139181,6097),(139182,6098),(139183,6098),(139184,6098),(139185,6098),(139186,6098),(139187,6098),(139188,6098),(139189,6098),(139190,6098),(139191,6098),(139192,6099),(139193,6099),(139194,6099),(139195,6099),(139196,6099),(139197,6099),(139198,6099),(139199,6099),(139200,6099),(139201,6099),(139202,6100),(139203,6100),(139204,6100),(139205,6100),(139206,6100),(139207,6100),(139208,6100),(139209,6100),(139210,6100),(139211,6100),(139212,6101),(139213,6101),(139214,6101),(139215,6101),(139216,6101),(139217,6101),(139218,6101),(139219,6101),(139220,6101),(139221,6101),(139222,6102),(139223,6102),(139224,6102),(139225,6102),(139226,6102),(139227,6102),(139228,6102),(139229,6102),(139230,6102),(139231,6102),(139232,6103),(139233,6103),(139234,6103),(139235,6103),(139236,6103),(139237,6103),(139238,6103),(139239,6103),(139240,6103),(139241,6103),(139242,6104),(139243,6104),(139244,6104),(139245,6104),(139246,6104),(139247,6104),(139248,6104),(139249,6104),(139250,6104),(139251,6104),(139252,6105),(139253,6105),(139254,6105),(139255,6105),(139256,6105),(139257,6105),(139258,6105),(139259,6105),(139260,6105),(139261,6105),(139262,6105),(139263,6105),(139264,6105),(139265,6105),(139266,6106),(139267,6106),(139268,6106),(139269,6106),(139270,6106),(139271,6106),(139272,6106),(139273,6106),(139274,6106),(139275,6106),(139276,6107),(139277,6107),(139278,6107),(139279,6107),(139280,6107),(139281,6107),(139282,6107),(139283,6107),(139284,6107),(139285,6107),(139286,6108),(139287,6108),(139288,6108),(139289,6108),(139290,6108),(139291,6108),(139292,6108),(139293,6108),(139294,6108),(139295,6108),(139296,6109),(139297,6109),(139298,6109),(139299,6109),(139300,6109),(139301,6109),(139302,6109),(139303,6109),(139304,6109),(139305,6109),(139306,6109),(139307,6109),(139308,6109),(139309,6109),(139310,6110),(139311,6110),(139312,6110),(139313,6110),(139314,6110),(139315,6110),(139316,6110),(139317,6110),(139318,6110),(139319,6110),(139320,6111),(139321,6111),(139322,6111),(139323,6111),(139324,6111),(139325,6111),(139326,6111),(139327,6111),(139328,6111),(139329,6111),(139330,6112),(139331,6112),(139332,6112),(139333,6112),(139334,6112),(139335,6112),(139336,6112),(139337,6112),(139338,6112),(139339,6112),(139340,6113),(139341,6113),(139342,6113),(139343,6113),(139344,6113),(139345,6113),(139346,6113),(139347,6113),(139348,6113),(139349,6113),(139350,6113),(139351,6113),(139352,6113),(139353,6113),(139354,6114),(139355,6114),(139356,6114),(139357,6114),(139358,6114),(139359,6114),(139360,6114),(139361,6114),(139362,6114),(139363,6114),(139364,6115),(139365,6115),(139366,6115),(139367,6115),(139368,6115),(139369,6115),(139370,6115),(139371,6115),(139372,6115),(139373,6115),(139374,6116),(139375,6116),(139376,6116),(139377,6116),(139378,6116),(139379,6116),(139380,6116),(139381,6116),(139382,6116),(139383,6116),(139384,6117),(139385,6117),(139386,6117),(139387,6117),(139388,6117),(139389,6117),(139390,6117),(139391,6117),(139392,6117),(139393,6117),(139394,6118),(139395,6118),(139396,6118),(139397,6118),(139398,6118),(139399,6118),(139400,6118),(139401,6118),(139402,6118),(139403,6118),(139404,6119),(139405,6119),(139406,6119),(139407,6119),(139408,6119),(139409,6119),(139410,6119),(139411,6119),(139412,6119),(139413,6119),(139414,6120),(139415,6120),(139416,6120),(139417,6120),(139418,6120),(139419,6120),(139420,6120),(139421,6120),(139422,6120),(139423,6120),(139424,6121),(139425,6121),(139426,6121),(139427,6121),(139428,6121),(139429,6121),(139430,6121),(139431,6121),(139432,6121),(139433,6121),(139434,6122),(139435,6122),(139436,6122),(139437,6122),(139438,6122),(139439,6122),(139440,6122),(139441,6122),(139442,6122),(139443,6122),(139444,6123),(139445,6123),(139446,6123),(139447,6123),(139448,6123),(139449,6123),(139450,6123),(139451,6123),(139452,6123),(139453,6123),(139454,6124),(139455,6124),(139456,6124),(139457,6124),(139458,6124),(139459,6124),(139460,6124),(139461,6124),(139462,6124),(139463,6124),(139464,6125),(139465,6125),(139466,6125),(139467,6125),(139468,6125),(139469,6125),(139470,6125),(139471,6125),(139472,6125),(139473,6125),(139474,6125),(139475,6125),(139476,6125),(139477,6125),(139478,6126),(139479,6126),(139480,6126),(139481,6126),(139482,6126),(139483,6126),(139484,6126),(139485,6126),(139486,6126),(139487,6126),(139488,6126),(139489,6126),(139490,6126),(139491,6126),(139492,6127),(139493,6127),(139494,6127),(139495,6127),(139496,6127),(139497,6127),(139498,6127),(139499,6127),(139500,6127),(139501,6127),(139502,6127),(139503,6127),(139504,6127),(139505,6127),(139506,6128),(139507,6128),(139508,6128),(139509,6128),(139510,6128),(139511,6128),(139512,6128),(139513,6128),(139514,6128),(139515,6128),(139516,6128),(139517,6128),(139518,6128),(139519,6128),(139520,6129),(139521,6129),(139522,6129),(139523,6129),(139524,6129),(139525,6129),(139526,6129),(139527,6129),(139528,6129),(139529,6129),(139530,6129),(139531,6129),(139532,6129),(139533,6129),(139534,6130),(139535,6130),(139536,6130),(139537,6130),(139538,6130),(139539,6130),(139540,6130),(139541,6130),(139542,6130),(139543,6130),(139544,6131),(139545,6131),(139546,6131),(139547,6131),(139548,6131),(139549,6131),(139550,6131),(139551,6131),(139552,6131),(139553,6131),(139554,6131),(139555,6131),(139556,6131),(139557,6131),(139558,6132),(139559,6132),(139560,6132),(139561,6132),(139562,6132),(139563,6132),(139564,6132),(139565,6132),(139566,6132),(139567,6132),(139568,6133),(139569,6133),(139570,6133),(139571,6133),(139572,6133),(139573,6133),(139574,6133),(139575,6133),(139576,6133),(139577,6133),(139578,6134),(139579,6134),(139580,6134),(139581,6134),(139582,6134),(139583,6134),(139584,6134),(139585,6134),(139586,6134),(139587,6134),(139588,6035),(139589,6035),(139590,6035),(139591,6035),(139592,6035),(139593,6036),(139594,6036),(139595,6036),(139596,6036),(139597,6036),(139598,6037),(139599,6037),(139600,6037),(139601,6037),(139602,6037),(139603,6038),(139604,6038),(139605,6038),(139606,6038),(139607,6038),(139608,6039),(139609,6039),(139610,6039),(139611,6039),(139612,6039),(139613,6040),(139614,6040),(139615,6040),(139616,6040),(139617,6040),(139618,6041),(139619,6041),(139620,6041),(139621,6041),(139622,6041),(139623,6042),(139624,6042),(139625,6042),(139626,6042),(139627,6042),(139628,6043),(139629,6043),(139630,6043),(139631,6043),(139632,6043),(139633,6044),(139634,6044),(139635,6044),(139636,6044),(139637,6044),(139638,6045),(139639,6045),(139640,6045),(139641,6045),(139642,6045),(139643,6046),(139644,6046),(139645,6046),(139646,6046),(139647,6046),(139648,6047),(139649,6047),(139650,6047),(139651,6047),(139652,6047),(139653,6048),(139654,6048),(139655,6048),(139656,6048),(139657,6048),(139658,6049),(139659,6049),(139660,6049),(139661,6049),(139662,6049),(139663,6050),(139664,6050),(139665,6050),(139666,6050),(139667,6050),(139668,6051),(139669,6051),(139670,6051),(139671,6051),(139672,6051),(139673,6052),(139674,6052),(139675,6052),(139676,6052),(139677,6052),(139678,6053),(139679,6053),(139680,6053),(139681,6053),(139682,6053),(139683,6054),(139684,6054),(139685,6054),(139686,6054),(139687,6054),(139688,6055),(139689,6055),(139690,6055),(139691,6055),(139692,6055),(139693,6056),(139694,6056),(139695,6056),(139696,6056),(139697,6056),(139698,6057),(139699,6057),(139700,6057),(139701,6057),(139702,6057),(139703,6058),(139704,6058),(139705,6058),(139706,6058),(139707,6058),(139708,6059),(139709,6059),(139710,6059),(139711,6059),(139712,6059),(139713,6060),(139714,6060),(139715,6060),(139716,6060),(139717,6060),(139718,6061),(139719,6061),(139720,6061),(139721,6061),(139722,6061),(139723,6062),(139724,6062),(139725,6062),(139726,6062),(139727,6062),(139728,6063),(139729,6063),(139730,6063),(139731,6063),(139732,6063),(139733,6064),(139734,6064),(139735,6064),(139736,6064),(139737,6064),(139738,6065),(139739,6065),(139740,6065),(139741,6065),(139742,6065),(139743,6066),(139744,6066),(139745,6066),(139746,6066),(139747,6066),(139748,6067),(139749,6067),(139750,6067),(139751,6067),(139752,6067),(139753,6068),(139754,6068),(139755,6068),(139756,6068),(139757,6068),(139758,6069),(139759,6069),(139760,6069),(139761,6069),(139762,6069),(139763,6070),(139764,6070),(139765,6070),(139766,6071),(139767,6071),(139768,6071),(139769,6071),(139770,6071),(139771,6072),(139772,6072),(139773,6072),(139774,6072),(139775,6072),(139776,6073),(139777,6073),(139778,6073),(139779,6073),(139780,6073),(139781,6074),(139782,6074),(139783,6074),(139784,6075),(139785,6075),(139786,6075),(139787,6075),(139788,6075),(139789,6076),(139790,6076),(139791,6076),(139792,6076),(139793,6076),(139794,6077),(139795,6077),(139796,6077),(139797,6077),(139798,6077),(139799,6078),(139800,6078),(139801,6078),(139802,6078),(139803,6078),(139804,6079),(139805,6079),(139806,6079),(139807,6079),(139808,6079),(139809,6080),(139810,6080),(139811,6080),(139812,6080),(139813,6080),(139814,6081),(139815,6081),(139816,6081),(139817,6081),(139818,6081),(139819,6082),(139820,6082),(139821,6082),(139822,6082),(139823,6082),(139824,6083),(139825,6083),(139826,6083),(139827,6083),(139828,6083),(139829,6084),(139830,6084),(139831,6084),(139832,6084),(139833,6084),(139834,6085),(139835,6085),(139836,6085),(139837,6085),(139838,6085),(139839,6086),(139840,6086),(139841,6086),(139842,6086),(139843,6086),(139844,6087),(139845,6087),(139846,6087),(139847,6087),(139848,6087),(139849,6088),(139850,6088),(139851,6088),(139852,6088),(139853,6088),(139854,6089),(139855,6089),(139856,6089),(139857,6089),(139858,6089),(139859,6090),(139860,6090),(139861,6090),(139862,6090),(139863,6090),(139864,6091),(139865,6091),(139866,6091),(139867,6091),(139868,6091),(139869,6092),(139870,6092),(139871,6092),(139872,6092),(139873,6092),(139874,6093),(139875,6093),(139876,6093),(139877,6093),(139878,6093),(139879,6094),(139880,6094),(139881,6094),(139882,6094),(139883,6094),(139884,6095),(139885,6095),(139886,6095),(139887,6095),(139888,6095),(139889,6096),(139890,6096),(139891,6096),(139892,6096),(139893,6096),(139894,6097),(139895,6097),(139896,6097),(139897,6098),(139898,6098),(139899,6098),(139900,6098),(139901,6098),(139902,6099),(139903,6099),(139904,6099),(139905,6099),(139906,6099),(139907,6100),(139908,6100),(139909,6100),(139910,6100),(139911,6100),(139912,6101),(139913,6101),(139914,6101),(139915,6101),(139916,6101),(139917,6102),(139918,6102),(139919,6102),(139920,6102),(139921,6102),(139922,6103),(139923,6103),(139924,6103),(139925,6103),(139926,6103),(139927,6104),(139928,6104),(139929,6104),(139930,6104),(139931,6104),(139932,6105),(139933,6105),(139934,6105),(139935,6105),(139936,6105),(139937,6106),(139938,6106),(139939,6106),(139940,6106),(139941,6106),(139942,6107),(139943,6107),(139944,6107),(139945,6107),(139946,6107),(139947,6108),(139948,6108),(139949,6108),(139950,6108),(139951,6108),(139952,6109),(139953,6109),(139954,6109),(139955,6109),(139956,6109),(139957,6110),(139958,6110),(139959,6110),(139960,6111),(139961,6111),(139962,6111),(139963,6112),(139964,6112),(139965,6112),(139966,6113),(139967,6113),(139968,6113),(139969,6113),(139970,6113),(139971,6114),(139972,6114),(139973,6114),(139974,6115),(139975,6115),(139976,6115),(139977,6116),(139978,6116),(139979,6116),(139980,6117),(139981,6117),(139982,6117),(139983,6118),(139984,6118),(139985,6118),(139986,6119),(139987,6119),(139988,6119),(139989,6120),(139990,6120),(139991,6120),(139992,6121),(139993,6121),(139994,6121),(139995,6121),(139996,6121),(139997,6122),(139998,6122),(139999,6122),(140000,6122),(140001,6122),(140002,6123),(140003,6123),(140004,6123),(140005,6123),(140006,6123),(140007,6124),(140008,6124),(140009,6124),(140010,6124),(140011,6124),(140012,6125),(140013,6125),(140014,6125),(140015,6125),(140016,6125),(140017,6126),(140018,6126),(140019,6126),(140020,6126),(140021,6126),(140022,6127),(140023,6127),(140024,6127),(140025,6127),(140026,6127),(140027,6128),(140028,6128),(140029,6128),(140030,6128),(140031,6128),(140032,6129),(140033,6129),(140034,6129),(140035,6129),(140036,6129),(140037,6130),(140038,6130),(140039,6130),(140040,6130),(140041,6130),(140042,6131),(140043,6131),(140044,6131),(140045,6131),(140046,6131),(140047,6132),(140048,6132),(140049,6132),(140050,6132),(140051,6132),(140052,6133),(140053,6133),(140054,6133),(140055,6133),(140056,6133),(140057,6134),(140058,6134),(140059,6134),(140060,6134),(140061,6134),(140062,6035),(140063,6035),(140064,6035),(140065,6035),(140066,6035),(140067,6036),(140068,6036),(140069,6036),(140070,6036),(140071,6036),(140072,6037),(140073,6037),(140074,6037),(140075,6037),(140076,6037),(140077,6038),(140078,6038),(140079,6038),(140080,6038),(140081,6038),(140082,6039),(140083,6039),(140084,6039),(140085,6039),(140086,6039),(140087,6040),(140088,6040),(140089,6040),(140090,6040),(140091,6040),(140092,6041),(140093,6041),(140094,6041),(140095,6041),(140096,6041),(140097,6042),(140098,6042),(140099,6042),(140100,6042),(140101,6042),(140102,6043),(140103,6043),(140104,6043),(140105,6043),(140106,6043),(140107,6044),(140108,6044),(140109,6044),(140110,6044),(140111,6044),(140112,6045),(140113,6045),(140114,6045),(140115,6045),(140116,6045),(140117,6046),(140118,6046),(140119,6046),(140120,6046),(140121,6046),(140122,6047),(140123,6047),(140124,6047),(140125,6047),(140126,6047),(140127,6048),(140128,6048),(140129,6048),(140130,6048),(140131,6048),(140132,6049),(140133,6049),(140134,6049),(140135,6049),(140136,6049),(140137,6050),(140138,6050),(140139,6050),(140140,6050),(140141,6050),(140142,6051),(140143,6051),(140144,6051),(140145,6051),(140146,6051),(140147,6052),(140148,6052),(140149,6052),(140150,6052),(140151,6052),(140152,6053),(140153,6053),(140154,6053),(140155,6053),(140156,6053),(140157,6054),(140158,6054),(140159,6054),(140160,6054),(140161,6054),(140162,6055),(140163,6055),(140164,6055),(140165,6055),(140166,6055),(140167,6056),(140168,6056),(140169,6056),(140170,6056),(140171,6056),(140172,6057),(140173,6057),(140174,6057),(140175,6057),(140176,6057),(140177,6058),(140178,6058),(140179,6058),(140180,6058),(140181,6058),(140182,6059),(140183,6059),(140184,6059),(140185,6059),(140186,6059),(140187,6060),(140188,6060),(140189,6060),(140190,6060),(140191,6060),(140192,6061),(140193,6061),(140194,6061),(140195,6061),(140196,6061),(140197,6062),(140198,6062),(140199,6062),(140200,6062),(140201,6062),(140202,6063),(140203,6063),(140204,6063),(140205,6063),(140206,6063),(140207,6064),(140208,6064),(140209,6064),(140210,6064),(140211,6064),(140212,6065),(140213,6065),(140214,6065),(140215,6065),(140216,6065),(140217,6066),(140218,6066),(140219,6066),(140220,6066),(140221,6066),(140222,6067),(140223,6067),(140224,6067),(140225,6067),(140226,6067),(140227,6068),(140228,6068),(140229,6068),(140230,6068),(140231,6068),(140232,6069),(140233,6069),(140234,6069),(140235,6069),(140236,6069),(140237,6070),(140238,6070),(140239,6070),(140240,6070),(140241,6070),(140242,6071),(140243,6071),(140244,6071),(140245,6071),(140246,6071),(140247,6072),(140248,6072),(140249,6072),(140250,6072),(140251,6072),(140252,6073),(140253,6073),(140254,6073),(140255,6073),(140256,6073),(140257,6074),(140258,6074),(140259,6074),(140260,6074),(140261,6074),(140262,6075),(140263,6075),(140264,6075),(140265,6075),(140266,6075),(140267,6076),(140268,6076),(140269,6076),(140270,6076),(140271,6076),(140272,6077),(140273,6077),(140274,6077),(140275,6077),(140276,6077),(140277,6078),(140278,6078),(140279,6078),(140280,6078),(140281,6078),(140282,6079),(140283,6079),(140284,6079),(140285,6079),(140286,6079),(140287,6080),(140288,6080),(140289,6080),(140290,6080),(140291,6080),(140292,6081),(140293,6081),(140294,6081),(140295,6081),(140296,6081),(140297,6082),(140298,6082),(140299,6082),(140300,6082),(140301,6082),(140302,6083),(140303,6083),(140304,6083),(140305,6083),(140306,6083),(140307,6084),(140308,6084),(140309,6084),(140310,6084),(140311,6084),(140312,6085),(140313,6085),(140314,6085),(140315,6085),(140316,6085),(140317,6086),(140318,6086),(140319,6086),(140320,6086),(140321,6086),(140322,6087),(140323,6087),(140324,6087),(140325,6087),(140326,6087),(140327,6088),(140328,6088),(140329,6088),(140330,6088),(140331,6088),(140332,6089),(140333,6089),(140334,6089),(140335,6089),(140336,6089),(140337,6090),(140338,6090),(140339,6090),(140340,6090),(140341,6090),(140342,6091),(140343,6091),(140344,6091),(140345,6091),(140346,6091),(140347,6092),(140348,6092),(140349,6092),(140350,6092),(140351,6092),(140352,6093),(140353,6093),(140354,6093),(140355,6093),(140356,6093),(140357,6094),(140358,6094),(140359,6094),(140360,6094),(140361,6094),(140362,6095),(140363,6095),(140364,6095),(140365,6095),(140366,6095),(140367,6096),(140368,6096),(140369,6096),(140370,6096),(140371,6096),(140372,6097),(140373,6097),(140374,6097),(140375,6097),(140376,6097),(140377,6098),(140378,6098),(140379,6098),(140380,6098),(140381,6098),(140382,6099),(140383,6099),(140384,6099),(140385,6099),(140386,6099),(140387,6100),(140388,6100),(140389,6100),(140390,6100),(140391,6100),(140392,6101),(140393,6101),(140394,6101),(140395,6101),(140396,6101),(140397,6102),(140398,6102),(140399,6102),(140400,6102),(140401,6102),(140402,6103),(140403,6103),(140404,6103),(140405,6103),(140406,6103),(140407,6104),(140408,6104),(140409,6104),(140410,6104),(140411,6104),(140412,6105),(140413,6105),(140414,6105),(140415,6105),(140416,6105),(140417,6106),(140418,6106),(140419,6106),(140420,6106),(140421,6106),(140422,6107),(140423,6107),(140424,6107),(140425,6107),(140426,6107),(140427,6108),(140428,6108),(140429,6108),(140430,6108),(140431,6108),(140432,6109),(140433,6109),(140434,6109),(140435,6109),(140436,6109),(140437,6110),(140438,6110),(140439,6110),(140440,6110),(140441,6110),(140442,6111),(140443,6111),(140444,6111),(140445,6111),(140446,6111),(140447,6112),(140448,6112),(140449,6112),(140450,6112),(140451,6112),(140452,6113),(140453,6113),(140454,6113),(140455,6113),(140456,6113),(140457,6114),(140458,6114),(140459,6114),(140460,6114),(140461,6114),(140462,6115),(140463,6115),(140464,6115),(140465,6115),(140466,6115),(140467,6116),(140468,6116),(140469,6116),(140470,6116),(140471,6116),(140472,6117),(140473,6117),(140474,6117),(140475,6117),(140476,6117),(140477,6118),(140478,6118),(140479,6118),(140480,6118),(140481,6118),(140482,6119),(140483,6119),(140484,6119),(140485,6119),(140486,6119),(140487,6120),(140488,6120),(140489,6120),(140490,6120),(140491,6120),(140492,6121),(140493,6121),(140494,6121),(140495,6121),(140496,6121),(140497,6122),(140498,6122),(140499,6122),(140500,6122),(140501,6122),(140502,6123),(140503,6123),(140504,6123),(140505,6123),(140506,6123),(140507,6124),(140508,6124),(140509,6124),(140510,6124),(140511,6124),(140512,6125),(140513,6125),(140514,6125),(140515,6125),(140516,6125),(140517,6126),(140518,6126),(140519,6126),(140520,6126),(140521,6126),(140522,6127),(140523,6127),(140524,6127),(140525,6127),(140526,6127),(140527,6128),(140528,6128),(140529,6128),(140530,6128),(140531,6128),(140532,6129),(140533,6129),(140534,6129),(140535,6129),(140536,6129),(140537,6130),(140538,6130),(140539,6130),(140540,6130),(140541,6130),(140542,6131),(140543,6131),(140544,6131),(140545,6131),(140546,6131),(140547,6132),(140548,6132),(140549,6132),(140550,6132),(140551,6132),(140552,6133),(140553,6133),(140554,6133),(140555,6133),(140556,6133),(140557,6134),(140558,6134),(140559,6134),(140560,6134),(140561,6134),(140562,6135),(140563,6136),(140564,6137),(140565,6138),(140566,6139),(140567,6140),(140568,6141),(140569,6142),(140570,6143),(140571,6144),(140572,6145),(140573,6146),(140574,6147),(140575,6148),(140576,6149),(140577,6150),(140578,6151),(140579,6152),(140580,6153),(140581,6154),(140582,6155),(140583,6156),(140584,6157),(140585,6158),(140586,6159),(140587,6160),(140588,6161),(140589,6162),(140590,6163),(140591,6164),(140592,6165),(140593,6166),(140594,6167),(140595,6168),(140596,6169),(140597,6170),(140598,6171),(140599,6172),(140600,6173),(140601,6174),(140602,6175),(140603,6176),(140604,6177),(140605,6178),(140606,6179),(140607,6180),(140608,6181),(140609,6182),(140610,6183),(140611,6184),(140612,6185),(140613,6186),(140614,6187),(140615,6188),(140616,6189),(140617,6190),(140618,6191),(140619,6192),(140620,6193),(140621,6194),(140622,6195),(140623,6196),(140624,6197),(140625,6198),(140626,6199),(140627,6200),(140628,6201),(140629,6202),(140630,6203),(140631,6204),(140632,6205),(140633,6206),(140634,6207),(140635,6208),(140636,6209),(140637,6210),(140638,6211),(140639,6212),(140640,6213),(140641,6214),(140642,6215),(140643,6216),(140644,6217),(140645,6218),(140646,6219),(140647,6220),(140648,6221),(140649,6222),(140650,6223),(140651,6224),(140652,6225),(140653,6226),(140654,6227),(140655,6228),(140656,6229),(140657,6230),(140658,6231),(140659,6232),(140660,6233),(140661,6234),(140662,6135),(140663,6135),(140664,6135),(140665,6136),(140666,6136),(140667,6136),(140668,6137),(140669,6137),(140670,6137),(140671,6138),(140672,6138),(140673,6138),(140674,6139),(140675,6139),(140676,6139),(140677,6140),(140678,6140),(140679,6140),(140680,6141),(140681,6141),(140682,6141),(140683,6142),(140684,6142),(140685,6142),(140686,6143),(140687,6143),(140688,6143),(140689,6144),(140690,6144),(140691,6144),(140692,6145),(140693,6145),(140694,6145),(140695,6146),(140696,6146),(140697,6146),(140698,6147),(140699,6147),(140700,6147),(140701,6148),(140702,6148),(140703,6148),(140704,6149),(140705,6149),(140706,6149),(140707,6150),(140708,6150),(140709,6150),(140710,6151),(140711,6151),(140712,6151),(140713,6152),(140714,6152),(140715,6152),(140716,6153),(140717,6153),(140718,6153),(140719,6154),(140720,6154),(140721,6154),(140722,6155),(140723,6155),(140724,6155),(140725,6156),(140726,6156),(140727,6156),(140728,6157),(140729,6157),(140730,6157),(140731,6158),(140732,6158),(140733,6158),(140734,6159),(140735,6159),(140736,6159),(140737,6160),(140738,6160),(140739,6160),(140740,6161),(140741,6161),(140742,6161),(140743,6162),(140744,6162),(140745,6162),(140746,6163),(140747,6163),(140748,6163),(140749,6164),(140750,6164),(140751,6164),(140752,6165),(140753,6165),(140754,6165),(140755,6166),(140756,6166),(140757,6166),(140758,6167),(140759,6167),(140760,6167),(140761,6168),(140762,6168),(140763,6168),(140764,6169),(140765,6169),(140766,6169),(140767,6170),(140768,6170),(140769,6170),(140770,6171),(140771,6171),(140772,6171),(140773,6172),(140774,6172),(140775,6172),(140776,6173),(140777,6173),(140778,6173),(140779,6174),(140780,6174),(140781,6174),(140782,6175),(140783,6175),(140784,6175),(140785,6176),(140786,6176),(140787,6176),(140788,6177),(140789,6177),(140790,6177),(140791,6178),(140792,6178),(140793,6178),(140794,6179),(140795,6179),(140796,6179),(140797,6180),(140798,6180),(140799,6180),(140800,6181),(140801,6181),(140802,6181),(140803,6182),(140804,6182),(140805,6182),(140806,6183),(140807,6183),(140808,6183),(140809,6184),(140810,6184),(140811,6184),(140812,6185),(140813,6185),(140814,6185),(140815,6186),(140816,6186),(140817,6186),(140818,6187),(140819,6187),(140820,6187),(140821,6188),(140822,6188),(140823,6188),(140824,6189),(140825,6189),(140826,6189),(140827,6190),(140828,6190),(140829,6190),(140830,6191),(140831,6191),(140832,6191),(140833,6192),(140834,6192),(140835,6192),(140836,6193),(140837,6193),(140838,6193),(140839,6194),(140840,6194),(140841,6194),(140842,6195),(140843,6195),(140844,6195),(140845,6196),(140846,6196),(140847,6196),(140848,6197),(140849,6197),(140850,6197),(140851,6198),(140852,6198),(140853,6198),(140854,6199),(140855,6199),(140856,6199),(140857,6200),(140858,6200),(140859,6200),(140860,6201),(140861,6201),(140862,6201),(140863,6202),(140864,6202),(140865,6202),(140866,6203),(140867,6203),(140868,6203),(140869,6204),(140870,6204),(140871,6204),(140872,6205),(140873,6205),(140874,6205),(140875,6206),(140876,6206),(140877,6206),(140878,6207),(140879,6207),(140880,6207),(140881,6208),(140882,6208),(140883,6208),(140884,6209),(140885,6209),(140886,6209),(140887,6210),(140888,6210),(140889,6210),(140890,6211),(140891,6211),(140892,6211),(140893,6212),(140894,6212),(140895,6212),(140896,6213),(140897,6213),(140898,6213),(140899,6214),(140900,6214),(140901,6214),(140902,6215),(140903,6215),(140904,6215),(140905,6216),(140906,6216),(140907,6216),(140908,6217),(140909,6217),(140910,6217),(140911,6218),(140912,6218),(140913,6218),(140914,6219),(140915,6219),(140916,6219),(140917,6220),(140918,6220),(140919,6220),(140920,6221),(140921,6221),(140922,6221),(140923,6222),(140924,6222),(140925,6222),(140926,6223),(140927,6223),(140928,6223),(140929,6224),(140930,6224),(140931,6224),(140932,6225),(140933,6225),(140934,6225),(140935,6226),(140936,6226),(140937,6226),(140938,6227),(140939,6227),(140940,6227),(140941,6228),(140942,6228),(140943,6228),(140944,6229),(140945,6229),(140946,6229),(140947,6230),(140948,6230),(140949,6230),(140950,6231),(140951,6231),(140952,6231),(140953,6232),(140954,6232),(140955,6232),(140956,6233),(140957,6233),(140958,6233),(140959,6234),(140960,6234),(140961,6234),(140962,6135),(140963,6135),(140964,6135),(140965,6135),(140966,6135),(140967,6135),(140968,6135),(140969,6135),(140970,6135),(140971,6135),(140972,6135),(140973,6135),(140974,6135),(140975,6135),(140976,6136),(140977,6136),(140978,6136),(140979,6136),(140980,6136),(140981,6136),(140982,6136),(140983,6136),(140984,6136),(140985,6136),(140986,6137),(140987,6137),(140988,6137),(140989,6137),(140990,6137),(140991,6137),(140992,6137),(140993,6137),(140994,6137),(140995,6137),(140996,6138),(140997,6138),(140998,6138),(140999,6138),(141000,6138),(141001,6138),(141002,6138),(141003,6138),(141004,6138),(141005,6138),(141006,6139),(141007,6139),(141008,6139),(141009,6139),(141010,6139),(141011,6139),(141012,6139),(141013,6139),(141014,6139),(141015,6139),(141016,6140),(141017,6140),(141018,6140),(141019,6140),(141020,6140),(141021,6140),(141022,6140),(141023,6140),(141024,6140),(141025,6140),(141026,6141),(141027,6141),(141028,6141),(141029,6141),(141030,6141),(141031,6141),(141032,6141),(141033,6141),(141034,6141),(141035,6141),(141036,6142),(141037,6142),(141038,6142),(141039,6142),(141040,6142),(141041,6142),(141042,6142),(141043,6142),(141044,6142),(141045,6142),(141046,6143),(141047,6143),(141048,6143),(141049,6143),(141050,6143),(141051,6143),(141052,6143),(141053,6143),(141054,6143),(141055,6143),(141056,6144),(141057,6144),(141058,6144),(141059,6144),(141060,6144),(141061,6144),(141062,6144),(141063,6144),(141064,6144),(141065,6144),(141066,6145),(141067,6145),(141068,6145),(141069,6145),(141070,6145),(141071,6145),(141072,6145),(141073,6145),(141074,6145),(141075,6145),(141076,6146),(141077,6146),(141078,6146),(141079,6146),(141080,6146),(141081,6146),(141082,6146),(141083,6146),(141084,6146),(141085,6146),(141086,6147),(141087,6147),(141088,6147),(141089,6147),(141090,6147),(141091,6147),(141092,6147),(141093,6147),(141094,6147),(141095,6147),(141096,6148),(141097,6148),(141098,6148),(141099,6148),(141100,6148),(141101,6148),(141102,6148),(141103,6148),(141104,6148),(141105,6148),(141106,6149),(141107,6149),(141108,6149),(141109,6149),(141110,6149),(141111,6149),(141112,6149),(141113,6149),(141114,6149),(141115,6149),(141116,6150),(141117,6150),(141118,6150),(141119,6150),(141120,6150),(141121,6150),(141122,6150),(141123,6150),(141124,6150),(141125,6150),(141126,6151),(141127,6151),(141128,6151),(141129,6151),(141130,6151),(141131,6151),(141132,6151),(141133,6151),(141134,6151),(141135,6151),(141136,6152),(141137,6152),(141138,6152),(141139,6152),(141140,6152),(141141,6152),(141142,6152),(141143,6152),(141144,6152),(141145,6152),(141146,6153),(141147,6153),(141148,6153),(141149,6153),(141150,6153),(141151,6153),(141152,6153),(141153,6153),(141154,6153),(141155,6153),(141156,6154),(141157,6154),(141158,6154),(141159,6154),(141160,6154),(141161,6154),(141162,6154),(141163,6154),(141164,6154),(141165,6154),(141166,6155),(141167,6155),(141168,6155),(141169,6155),(141170,6155),(141171,6155),(141172,6155),(141173,6155),(141174,6155),(141175,6155),(141176,6156),(141177,6156),(141178,6156),(141179,6156),(141180,6156),(141181,6156),(141182,6156),(141183,6156),(141184,6156),(141185,6156),(141186,6157),(141187,6157),(141188,6157),(141189,6157),(141190,6157),(141191,6157),(141192,6157),(141193,6157),(141194,6157),(141195,6157),(141196,6158),(141197,6158),(141198,6158),(141199,6158),(141200,6158),(141201,6158),(141202,6158),(141203,6158),(141204,6158),(141205,6158),(141206,6159),(141207,6159),(141208,6159),(141209,6159),(141210,6159),(141211,6159),(141212,6159),(141213,6159),(141214,6159),(141215,6159),(141216,6160),(141217,6160),(141218,6160),(141219,6160),(141220,6160),(141221,6160),(141222,6160),(141223,6160),(141224,6160),(141225,6160),(141226,6161),(141227,6161),(141228,6161),(141229,6161),(141230,6161),(141231,6161),(141232,6161),(141233,6161),(141234,6161),(141235,6161),(141236,6162),(141237,6162),(141238,6162),(141239,6162),(141240,6162),(141241,6162),(141242,6162),(141243,6162),(141244,6162),(141245,6162),(141246,6163),(141247,6163),(141248,6163),(141249,6163),(141250,6163),(141251,6163),(141252,6163),(141253,6163),(141254,6163),(141255,6163),(141256,6164),(141257,6164),(141258,6164),(141259,6164),(141260,6164),(141261,6164),(141262,6164),(141263,6164),(141264,6164),(141265,6164),(141266,6164),(141267,6164),(141268,6164),(141269,6164),(141270,6165),(141271,6165),(141272,6165),(141273,6165),(141274,6165),(141275,6165),(141276,6165),(141277,6165),(141278,6165),(141279,6165),(141280,6166),(141281,6166),(141282,6166),(141283,6166),(141284,6166),(141285,6166),(141286,6166),(141287,6166),(141288,6166),(141289,6166),(141290,6167),(141291,6167),(141292,6167),(141293,6167),(141294,6167),(141295,6167),(141296,6167),(141297,6167),(141298,6168),(141299,6168),(141300,6168),(141301,6168),(141302,6168),(141303,6168),(141304,6168),(141305,6168),(141306,6169),(141307,6169),(141308,6169),(141309,6169),(141310,6169),(141311,6169),(141312,6169),(141313,6169),(141314,6169),(141315,6169),(141316,6170),(141317,6170),(141318,6170),(141319,6170),(141320,6170),(141321,6170),(141322,6170),(141323,6170),(141324,6170),(141325,6170),(141326,6170),(141327,6170),(141328,6170),(141329,6170),(141330,6171),(141331,6171),(141332,6171),(141333,6171),(141334,6171),(141335,6171),(141336,6171),(141337,6171),(141338,6171),(141339,6171),(141340,6172),(141341,6172),(141342,6172),(141343,6172),(141344,6172),(141345,6172),(141346,6172),(141347,6172),(141348,6172),(141349,6172),(141350,6173),(141351,6173),(141352,6173),(141353,6173),(141354,6173),(141355,6173),(141356,6173),(141357,6173),(141358,6173),(141359,6173),(141360,6174),(141361,6174),(141362,6174),(141363,6174),(141364,6174),(141365,6174),(141366,6174),(141367,6174),(141368,6174),(141369,6174),(141370,6174),(141371,6174),(141372,6174),(141373,6174),(141374,6175),(141375,6175),(141376,6175),(141377,6175),(141378,6175),(141379,6175),(141380,6175),(141381,6175),(141382,6175),(141383,6175),(141384,6176),(141385,6176),(141386,6176),(141387,6176),(141388,6176),(141389,6176),(141390,6176),(141391,6176),(141392,6176),(141393,6176),(141394,6177),(141395,6177),(141396,6177),(141397,6177),(141398,6177),(141399,6177),(141400,6177),(141401,6177),(141402,6177),(141403,6177),(141404,6177),(141405,6177),(141406,6177),(141407,6177),(141408,6178),(141409,6178),(141410,6178),(141411,6178),(141412,6178),(141413,6178),(141414,6178),(141415,6178),(141416,6178),(141417,6178),(141418,6179),(141419,6179),(141420,6179),(141421,6179),(141422,6179),(141423,6179),(141424,6179),(141425,6179),(141426,6179),(141427,6179),(141428,6180),(141429,6180),(141430,6180),(141431,6180),(141432,6180),(141433,6180),(141434,6180),(141435,6180),(141436,6180),(141437,6180),(141438,6180),(141439,6180),(141440,6180),(141441,6180),(141442,6181),(141443,6181),(141444,6181),(141445,6181),(141446,6181),(141447,6181),(141448,6181),(141449,6181),(141450,6181),(141451,6181),(141452,6182),(141453,6182),(141454,6182),(141455,6182),(141456,6182),(141457,6182),(141458,6182),(141459,6182),(141460,6182),(141461,6182),(141462,6183),(141463,6183),(141464,6183),(141465,6183),(141466,6183),(141467,6183),(141468,6183),(141469,6183),(141470,6183),(141471,6183),(141472,6184),(141473,6184),(141474,6184),(141475,6184),(141476,6184),(141477,6184),(141478,6184),(141479,6184),(141480,6184),(141481,6184),(141482,6185),(141483,6185),(141484,6185),(141485,6185),(141486,6185),(141487,6185),(141488,6185),(141489,6185),(141490,6185),(141491,6185),(141492,6186),(141493,6186),(141494,6186),(141495,6186),(141496,6186),(141497,6186),(141498,6186),(141499,6186),(141500,6186),(141501,6186),(141502,6187),(141503,6187),(141504,6187),(141505,6187),(141506,6187),(141507,6187),(141508,6187),(141509,6187),(141510,6187),(141511,6187),(141512,6187),(141513,6187),(141514,6187),(141515,6187),(141516,6188),(141517,6188),(141518,6188),(141519,6188),(141520,6188),(141521,6188),(141522,6188),(141523,6188),(141524,6188),(141525,6188),(141526,6188),(141527,6188),(141528,6188),(141529,6188),(141530,6189),(141531,6189),(141532,6189),(141533,6189),(141534,6189),(141535,6189),(141536,6189),(141537,6189),(141538,6189),(141539,6189),(141540,6190),(141541,6190),(141542,6190),(141543,6190),(141544,6190),(141545,6190),(141546,6190),(141547,6190),(141548,6190),(141549,6190),(141550,6191),(141551,6191),(141552,6191),(141553,6191),(141554,6191),(141555,6191),(141556,6191),(141557,6191),(141558,6191),(141559,6191),(141560,6192),(141561,6192),(141562,6192),(141563,6192),(141564,6192),(141565,6192),(141566,6192),(141567,6192),(141568,6192),(141569,6192),(141570,6193),(141571,6193),(141572,6193),(141573,6193),(141574,6193),(141575,6193),(141576,6193),(141577,6193),(141578,6193),(141579,6193),(141580,6194),(141581,6194),(141582,6194),(141583,6194),(141584,6194),(141585,6194),(141586,6194),(141587,6194),(141588,6194),(141589,6194),(141590,6195),(141591,6195),(141592,6195),(141593,6195),(141594,6195),(141595,6195),(141596,6195),(141597,6195),(141598,6195),(141599,6195),(141600,6196),(141601,6196),(141602,6196),(141603,6196),(141604,6196),(141605,6196),(141606,6196),(141607,6196),(141608,6196),(141609,6196),(141610,6197),(141611,6197),(141612,6197),(141613,6197),(141614,6197),(141615,6197),(141616,6197),(141617,6197),(141618,6197),(141619,6197),(141620,6198),(141621,6198),(141622,6198),(141623,6198),(141624,6198),(141625,6198),(141626,6198),(141627,6198),(141628,6198),(141629,6198),(141630,6199),(141631,6199),(141632,6199),(141633,6199),(141634,6199),(141635,6199),(141636,6199),(141637,6199),(141638,6199),(141639,6199),(141640,6199),(141641,6199),(141642,6199),(141643,6199),(141644,6200),(141645,6200),(141646,6200),(141647,6200),(141648,6200),(141649,6200),(141650,6200),(141651,6200),(141652,6200),(141653,6200),(141654,6201),(141655,6201),(141656,6201),(141657,6201),(141658,6201),(141659,6201),(141660,6201),(141661,6201),(141662,6201),(141663,6201),(141664,6202),(141665,6202),(141666,6202),(141667,6202),(141668,6202),(141669,6202),(141670,6202),(141671,6202),(141672,6202),(141673,6202),(141674,6203),(141675,6203),(141676,6203),(141677,6203),(141678,6203),(141679,6203),(141680,6203),(141681,6203),(141682,6203),(141683,6203),(141684,6204),(141685,6204),(141686,6204),(141687,6204),(141688,6204),(141689,6204),(141690,6204),(141691,6204),(141692,6204),(141693,6204),(141694,6205),(141695,6205),(141696,6205),(141697,6205),(141698,6205),(141699,6205),(141700,6205),(141701,6205),(141702,6205),(141703,6205),(141704,6206),(141705,6206),(141706,6206),(141707,6206),(141708,6206),(141709,6206),(141710,6206),(141711,6206),(141712,6206),(141713,6206),(141714,6206),(141715,6206),(141716,6206),(141717,6206),(141718,6207),(141719,6207),(141720,6207),(141721,6207),(141722,6207),(141723,6207),(141724,6207),(141725,6207),(141726,6207),(141727,6207),(141728,6207),(141729,6207),(141730,6207),(141731,6207),(141732,6208),(141733,6208),(141734,6208),(141735,6208),(141736,6208),(141737,6208),(141738,6208),(141739,6208),(141740,6208),(141741,6208),(141742,6208),(141743,6208),(141744,6209),(141745,6209),(141746,6209),(141747,6209),(141748,6209),(141749,6209),(141750,6209),(141751,6209),(141752,6209),(141753,6209),(141754,6209),(141755,6209),(141756,6210),(141757,6210),(141758,6210),(141759,6210),(141760,6210),(141761,6210),(141762,6210),(141763,6210),(141764,6210),(141765,6210),(141766,6211),(141767,6211),(141768,6211),(141769,6211),(141770,6211),(141771,6211),(141772,6211),(141773,6211),(141774,6211),(141775,6211),(141776,6212),(141777,6212),(141778,6212),(141779,6212),(141780,6212),(141781,6212),(141782,6212),(141783,6212),(141784,6212),(141785,6212),(141786,6213),(141787,6213),(141788,6213),(141789,6213),(141790,6213),(141791,6213),(141792,6213),(141793,6213),(141794,6213),(141795,6213),(141796,6214),(141797,6214),(141798,6214),(141799,6214),(141800,6214),(141801,6214),(141802,6214),(141803,6214),(141804,6214),(141805,6214),(141806,6215),(141807,6215),(141808,6215),(141809,6215),(141810,6215),(141811,6215),(141812,6215),(141813,6215),(141814,6215),(141815,6215),(141816,6216),(141817,6216),(141818,6216),(141819,6216),(141820,6216),(141821,6216),(141822,6216),(141823,6216),(141824,6216),(141825,6216),(141826,6217),(141827,6217),(141828,6217),(141829,6217),(141830,6217),(141831,6217),(141832,6217),(141833,6217),(141834,6217),(141835,6217),(141836,6218),(141837,6218),(141838,6218),(141839,6218),(141840,6218),(141841,6218),(141842,6218),(141843,6218),(141844,6218),(141845,6218),(141846,6219),(141847,6219),(141848,6219),(141849,6219),(141850,6219),(141851,6219),(141852,6219),(141853,6219),(141854,6219),(141855,6219),(141856,6220),(141857,6220),(141858,6220),(141859,6220),(141860,6220),(141861,6220),(141862,6220),(141863,6220),(141864,6220),(141865,6220),(141866,6220),(141867,6220),(141868,6220),(141869,6220),(141870,6221),(141871,6221),(141872,6221),(141873,6221),(141874,6221),(141875,6221),(141876,6221),(141877,6221),(141878,6221),(141879,6221),(141880,6221),(141881,6221),(141882,6221),(141883,6221),(141884,6222),(141885,6222),(141886,6222),(141887,6222),(141888,6222),(141889,6222),(141890,6222),(141891,6222),(141892,6222),(141893,6222),(141894,6222),(141895,6222),(141896,6222),(141897,6222),(141898,6223),(141899,6223),(141900,6223),(141901,6223),(141902,6223),(141903,6223),(141904,6223),(141905,6223),(141906,6223),(141907,6223),(141908,6224),(141909,6224),(141910,6224),(141911,6224),(141912,6224),(141913,6224),(141914,6224),(141915,6224),(141916,6224),(141917,6224),(141918,6225),(141919,6225),(141920,6225),(141921,6225),(141922,6225),(141923,6225),(141924,6225),(141925,6225),(141926,6225),(141927,6225),(141928,6226),(141929,6226),(141930,6226),(141931,6226),(141932,6226),(141933,6226),(141934,6226),(141935,6226),(141936,6226),(141937,6226),(141938,6227),(141939,6227),(141940,6227),(141941,6227),(141942,6227),(141943,6227),(141944,6227),(141945,6227),(141946,6227),(141947,6227),(141948,6228),(141949,6228),(141950,6228),(141951,6228),(141952,6228),(141953,6228),(141954,6228),(141955,6228),(141956,6228),(141957,6228),(141958,6229),(141959,6229),(141960,6229),(141961,6229),(141962,6229),(141963,6229),(141964,6229),(141965,6229),(141966,6229),(141967,6229),(141968,6230),(141969,6230),(141970,6230),(141971,6230),(141972,6230),(141973,6230),(141974,6230),(141975,6230),(141976,6230),(141977,6230),(141978,6231),(141979,6231),(141980,6231),(141981,6231),(141982,6232),(141983,6232),(141984,6232),(141985,6232),(141986,6232),(141987,6232),(141988,6232),(141989,6232),(141990,6232),(141991,6232),(141992,6233),(141993,6233),(141994,6233),(141995,6233),(141996,6233),(141997,6233),(141998,6233),(141999,6233),(142000,6233),(142001,6233),(142002,6233),(142003,6233),(142004,6234),(142005,6234),(142006,6234),(142007,6234),(142008,6234),(142009,6234),(142010,6234),(142011,6234),(142012,6234),(142013,6234),(142014,6135),(142015,6135),(142016,6135),(142017,6135),(142018,6135),(142019,6136),(142020,6136),(142021,6136),(142022,6136),(142023,6136),(142024,6137),(142025,6137),(142026,6137),(142027,6137),(142028,6137),(142029,6138),(142030,6138),(142031,6138),(142032,6138),(142033,6138),(142034,6139),(142035,6139),(142036,6139),(142037,6139),(142038,6139),(142039,6140),(142040,6140),(142041,6140),(142042,6140),(142043,6140),(142044,6141),(142045,6141),(142046,6141),(142047,6141),(142048,6141),(142049,6142),(142050,6142),(142051,6142),(142052,6142),(142053,6142),(142054,6143),(142055,6143),(142056,6143),(142057,6143),(142058,6143),(142059,6144),(142060,6144),(142061,6144),(142062,6144),(142063,6144),(142064,6145),(142065,6145),(142066,6145),(142067,6145),(142068,6145),(142069,6146),(142070,6146),(142071,6146),(142072,6146),(142073,6146),(142074,6147),(142075,6147),(142076,6147),(142077,6147),(142078,6147),(142079,6148),(142080,6148),(142081,6148),(142082,6148),(142083,6148),(142084,6149),(142085,6149),(142086,6149),(142087,6149),(142088,6149),(142089,6150),(142090,6150),(142091,6150),(142092,6150),(142093,6150),(142094,6151),(142095,6151),(142096,6151),(142097,6151),(142098,6151),(142099,6152),(142100,6152),(142101,6152),(142102,6152),(142103,6152),(142104,6153),(142105,6153),(142106,6153),(142107,6153),(142108,6153),(142109,6154),(142110,6154),(142111,6154),(142112,6154),(142113,6154),(142114,6155),(142115,6155),(142116,6155),(142117,6155),(142118,6155),(142119,6156),(142120,6156),(142121,6156),(142122,6156),(142123,6156),(142124,6157),(142125,6157),(142126,6157),(142127,6157),(142128,6157),(142129,6158),(142130,6158),(142131,6158),(142132,6158),(142133,6158),(142134,6159),(142135,6159),(142136,6159),(142137,6159),(142138,6159),(142139,6160),(142140,6160),(142141,6160),(142142,6160),(142143,6160),(142144,6161),(142145,6161),(142146,6161),(142147,6161),(142148,6161),(142149,6162),(142150,6162),(142151,6162),(142152,6162),(142153,6162),(142154,6163),(142155,6163),(142156,6163),(142157,6163),(142158,6163),(142159,6164),(142160,6164),(142161,6164),(142162,6164),(142163,6164),(142164,6165),(142165,6165),(142166,6165),(142167,6165),(142168,6165),(142169,6166),(142170,6166),(142171,6166),(142172,6166),(142173,6166),(142174,6167),(142175,6167),(142176,6167),(142177,6167),(142178,6167),(142179,6168),(142180,6168),(142181,6168),(142182,6168),(142183,6168),(142184,6169),(142185,6169),(142186,6169),(142187,6169),(142188,6169),(142189,6170),(142190,6170),(142191,6170),(142192,6170),(142193,6170),(142194,6171),(142195,6171),(142196,6171),(142197,6171),(142198,6171),(142199,6172),(142200,6172),(142201,6172),(142202,6172),(142203,6172),(142204,6173),(142205,6173),(142206,6173),(142207,6173),(142208,6173),(142209,6174),(142210,6174),(142211,6174),(142212,6174),(142213,6174),(142214,6175),(142215,6175),(142216,6175),(142217,6175),(142218,6175),(142219,6176),(142220,6176),(142221,6176),(142222,6176),(142223,6176),(142224,6177),(142225,6177),(142226,6177),(142227,6177),(142228,6177),(142229,6178),(142230,6178),(142231,6178),(142232,6178),(142233,6178),(142234,6179),(142235,6179),(142236,6179),(142237,6179),(142238,6179),(142239,6180),(142240,6180),(142241,6180),(142242,6180),(142243,6180),(142244,6181),(142245,6181),(142246,6181),(142247,6181),(142248,6181),(142249,6182),(142250,6182),(142251,6182),(142252,6182),(142253,6182),(142254,6183),(142255,6183),(142256,6183),(142257,6183),(142258,6183),(142259,6184),(142260,6184),(142261,6184),(142262,6184),(142263,6184),(142264,6185),(142265,6185),(142266,6185),(142267,6185),(142268,6185),(142269,6186),(142270,6186),(142271,6186),(142272,6186),(142273,6186),(142274,6187),(142275,6187),(142276,6187),(142277,6187),(142278,6187),(142279,6188),(142280,6188),(142281,6188),(142282,6188),(142283,6188),(142284,6189),(142285,6189),(142286,6189),(142287,6189),(142288,6189),(142289,6190),(142290,6190),(142291,6190),(142292,6190),(142293,6190),(142294,6191),(142295,6191),(142296,6191),(142297,6191),(142298,6191),(142299,6192),(142300,6192),(142301,6192),(142302,6192),(142303,6192),(142304,6193),(142305,6193),(142306,6193),(142307,6193),(142308,6193),(142309,6194),(142310,6194),(142311,6194),(142312,6194),(142313,6194),(142314,6195),(142315,6195),(142316,6195),(142317,6195),(142318,6195),(142319,6196),(142320,6196),(142321,6196),(142322,6196),(142323,6196),(142324,6197),(142325,6197),(142326,6197),(142327,6197),(142328,6197),(142329,6198),(142330,6198),(142331,6198),(142332,6198),(142333,6198),(142334,6199),(142335,6199),(142336,6199),(142337,6199),(142338,6199),(142339,6200),(142340,6200),(142341,6200),(142342,6200),(142343,6200),(142344,6201),(142345,6201),(142346,6201),(142347,6201),(142348,6201),(142349,6202),(142350,6202),(142351,6202),(142352,6202),(142353,6202),(142354,6203),(142355,6203),(142356,6203),(142357,6203),(142358,6203),(142359,6204),(142360,6204),(142361,6204),(142362,6204),(142363,6204),(142364,6205),(142365,6205),(142366,6205),(142367,6205),(142368,6205),(142369,6206),(142370,6206),(142371,6206),(142372,6206),(142373,6206),(142374,6207),(142375,6207),(142376,6207),(142377,6207),(142378,6207),(142379,6208),(142380,6208),(142381,6208),(142382,6208),(142383,6208),(142384,6209),(142385,6209),(142386,6209),(142387,6209),(142388,6209),(142389,6210),(142390,6210),(142391,6210),(142392,6210),(142393,6210),(142394,6211),(142395,6211),(142396,6211),(142397,6211),(142398,6211),(142399,6212),(142400,6212),(142401,6212),(142402,6212),(142403,6212),(142404,6213),(142405,6213),(142406,6213),(142407,6213),(142408,6213),(142409,6214),(142410,6214),(142411,6214),(142412,6214),(142413,6214),(142414,6215),(142415,6215),(142416,6215),(142417,6215),(142418,6215),(142419,6216),(142420,6216),(142421,6216),(142422,6216),(142423,6216),(142424,6217),(142425,6217),(142426,6217),(142427,6217),(142428,6217),(142429,6218),(142430,6218),(142431,6218),(142432,6218),(142433,6218),(142434,6219),(142435,6219),(142436,6219),(142437,6219),(142438,6219),(142439,6220),(142440,6220),(142441,6220),(142442,6220),(142443,6220),(142444,6221),(142445,6221),(142446,6221),(142447,6221),(142448,6221),(142449,6222),(142450,6222),(142451,6222),(142452,6222),(142453,6222),(142454,6223),(142455,6223),(142456,6223),(142457,6223),(142458,6223),(142459,6224),(142460,6224),(142461,6224),(142462,6224),(142463,6224),(142464,6225),(142465,6225),(142466,6225),(142467,6225),(142468,6225),(142469,6226),(142470,6226),(142471,6226),(142472,6226),(142473,6226),(142474,6227),(142475,6227),(142476,6227),(142477,6227),(142478,6227),(142479,6228),(142480,6228),(142481,6228),(142482,6228),(142483,6228),(142484,6229),(142485,6229),(142486,6229),(142487,6229),(142488,6229),(142489,6230),(142490,6230),(142491,6230),(142492,6230),(142493,6230),(142494,6231),(142495,6231),(142496,6231),(142497,6232),(142498,6232),(142499,6232),(142500,6232),(142501,6232),(142502,6233),(142503,6233),(142504,6233),(142505,6233),(142506,6233),(142507,6234),(142508,6234),(142509,6234),(142510,6234),(142511,6234),(142512,6135),(142513,6135),(142514,6135),(142515,6135),(142516,6135),(142517,6136),(142518,6136),(142519,6136),(142520,6136),(142521,6136),(142522,6137),(142523,6137),(142524,6137),(142525,6137),(142526,6137),(142527,6138),(142528,6138),(142529,6138),(142530,6138),(142531,6138),(142532,6139),(142533,6139),(142534,6139),(142535,6139),(142536,6139),(142537,6140),(142538,6140),(142539,6140),(142540,6140),(142541,6140),(142542,6141),(142543,6141),(142544,6141),(142545,6141),(142546,6141),(142547,6142),(142548,6142),(142549,6142),(142550,6142),(142551,6142),(142552,6143),(142553,6143),(142554,6143),(142555,6143),(142556,6143),(142557,6144),(142558,6144),(142559,6144),(142560,6144),(142561,6144),(142562,6145),(142563,6145),(142564,6145),(142565,6145),(142566,6145),(142567,6146),(142568,6146),(142569,6146),(142570,6146),(142571,6146),(142572,6147),(142573,6147),(142574,6147),(142575,6147),(142576,6147),(142577,6148),(142578,6148),(142579,6148),(142580,6148),(142581,6148),(142582,6149),(142583,6149),(142584,6149),(142585,6149),(142586,6149),(142587,6150),(142588,6150),(142589,6150),(142590,6150),(142591,6150),(142592,6151),(142593,6151),(142594,6151),(142595,6151),(142596,6151),(142597,6152),(142598,6152),(142599,6152),(142600,6152),(142601,6152),(142602,6153),(142603,6153),(142604,6153),(142605,6153),(142606,6153),(142607,6154),(142608,6154),(142609,6154),(142610,6154),(142611,6154),(142612,6155),(142613,6155),(142614,6155),(142615,6155),(142616,6155),(142617,6156),(142618,6156),(142619,6156),(142620,6156),(142621,6156),(142622,6157),(142623,6157),(142624,6157),(142625,6157),(142626,6157),(142627,6158),(142628,6158),(142629,6158),(142630,6158),(142631,6158),(142632,6159),(142633,6159),(142634,6159),(142635,6159),(142636,6159),(142637,6160),(142638,6160),(142639,6160),(142640,6160),(142641,6160),(142642,6161),(142643,6161),(142644,6161),(142645,6161),(142646,6161),(142647,6162),(142648,6162),(142649,6162),(142650,6162),(142651,6162),(142652,6163),(142653,6163),(142654,6163),(142655,6163),(142656,6163),(142657,6164),(142658,6164),(142659,6164),(142660,6164),(142661,6164),(142662,6165),(142663,6165),(142664,6165),(142665,6165),(142666,6165),(142667,6166),(142668,6166),(142669,6166),(142670,6166),(142671,6166),(142672,6167),(142673,6167),(142674,6167),(142675,6167),(142676,6167),(142677,6168),(142678,6168),(142679,6168),(142680,6168),(142681,6168),(142682,6169),(142683,6169),(142684,6169),(142685,6169),(142686,6169),(142687,6170),(142688,6170),(142689,6170),(142690,6170),(142691,6170),(142692,6171),(142693,6171),(142694,6171),(142695,6171),(142696,6171),(142697,6172),(142698,6172),(142699,6172),(142700,6172),(142701,6172),(142702,6173),(142703,6173),(142704,6173),(142705,6173),(142706,6173),(142707,6174),(142708,6174),(142709,6174),(142710,6174),(142711,6174),(142712,6175),(142713,6175),(142714,6175),(142715,6175),(142716,6175),(142717,6176),(142718,6176),(142719,6176),(142720,6176),(142721,6176),(142722,6177),(142723,6177),(142724,6177),(142725,6177),(142726,6177),(142727,6178),(142728,6178),(142729,6178),(142730,6178),(142731,6178),(142732,6179),(142733,6179),(142734,6179),(142735,6179),(142736,6179),(142737,6180),(142738,6180),(142739,6180),(142740,6180),(142741,6180),(142742,6181),(142743,6181),(142744,6181),(142745,6181),(142746,6181),(142747,6182),(142748,6182),(142749,6182),(142750,6182),(142751,6182),(142752,6183),(142753,6183),(142754,6183),(142755,6183),(142756,6183),(142757,6184),(142758,6184),(142759,6184),(142760,6184),(142761,6184),(142762,6185),(142763,6185),(142764,6185),(142765,6185),(142766,6185),(142767,6186),(142768,6186),(142769,6186),(142770,6186),(142771,6186),(142772,6187),(142773,6187),(142774,6187),(142775,6187),(142776,6187),(142777,6188),(142778,6188),(142779,6188),(142780,6188),(142781,6188),(142782,6189),(142783,6189),(142784,6189),(142785,6189),(142786,6189),(142787,6190),(142788,6190),(142789,6190),(142790,6190),(142791,6190),(142792,6191),(142793,6191),(142794,6191),(142795,6191),(142796,6191),(142797,6192),(142798,6192),(142799,6192),(142800,6192),(142801,6192),(142802,6193),(142803,6193),(142804,6193),(142805,6193),(142806,6193),(142807,6194),(142808,6194),(142809,6194),(142810,6194),(142811,6194),(142812,6195),(142813,6195),(142814,6195),(142815,6195),(142816,6195),(142817,6196),(142818,6196),(142819,6196),(142820,6196),(142821,6196),(142822,6197),(142823,6197),(142824,6197),(142825,6197),(142826,6197),(142827,6198),(142828,6198),(142829,6198),(142830,6198),(142831,6198),(142832,6199),(142833,6199),(142834,6199),(142835,6199),(142836,6199),(142837,6200),(142838,6200),(142839,6200),(142840,6200),(142841,6200),(142842,6201),(142843,6201),(142844,6201),(142845,6201),(142846,6201),(142847,6202),(142848,6202),(142849,6202),(142850,6202),(142851,6202),(142852,6203),(142853,6203),(142854,6203),(142855,6203),(142856,6203),(142857,6204),(142858,6204),(142859,6204),(142860,6204),(142861,6204),(142862,6205),(142863,6205),(142864,6205),(142865,6205),(142866,6205),(142867,6206),(142868,6206),(142869,6206),(142870,6206),(142871,6206),(142872,6207),(142873,6207),(142874,6207),(142875,6207),(142876,6207),(142877,6208),(142878,6208),(142879,6208),(142880,6208),(142881,6208),(142882,6209),(142883,6209),(142884,6209),(142885,6209),(142886,6209),(142887,6210),(142888,6210),(142889,6210),(142890,6210),(142891,6210),(142892,6211),(142893,6211),(142894,6211),(142895,6211),(142896,6211),(142897,6212),(142898,6212),(142899,6212),(142900,6212),(142901,6212),(142902,6213),(142903,6213),(142904,6213),(142905,6213),(142906,6213),(142907,6214),(142908,6214),(142909,6214),(142910,6214),(142911,6214),(142912,6215),(142913,6215),(142914,6215),(142915,6215),(142916,6215),(142917,6216),(142918,6216),(142919,6216),(142920,6216),(142921,6216),(142922,6217),(142923,6217),(142924,6217),(142925,6217),(142926,6217),(142927,6218),(142928,6218),(142929,6218),(142930,6218),(142931,6218),(142932,6219),(142933,6219),(142934,6219),(142935,6219),(142936,6219),(142937,6220),(142938,6220),(142939,6220),(142940,6220),(142941,6220),(142942,6221),(142943,6221),(142944,6221),(142945,6221),(142946,6221),(142947,6222),(142948,6222),(142949,6222),(142950,6222),(142951,6222),(142952,6223),(142953,6223),(142954,6223),(142955,6223),(142956,6223),(142957,6224),(142958,6224),(142959,6224),(142960,6224),(142961,6224),(142962,6225),(142963,6225),(142964,6225),(142965,6225),(142966,6225),(142967,6226),(142968,6226),(142969,6226),(142970,6226),(142971,6226),(142972,6227),(142973,6227),(142974,6227),(142975,6227),(142976,6227),(142977,6228),(142978,6228),(142979,6228),(142980,6228),(142981,6228),(142982,6229),(142983,6229),(142984,6229),(142985,6229),(142986,6229),(142987,6230),(142988,6230),(142989,6230),(142990,6230),(142991,6230),(142992,6231),(142993,6231),(142994,6231),(142995,6231),(142996,6231),(142997,6232),(142998,6232),(142999,6232),(143000,6232),(143001,6232),(143002,6233),(143003,6233),(143004,6233),(143005,6233),(143006,6233),(143007,6234),(143008,6234),(143009,6234),(143010,6234),(143011,6234),(143012,6235),(143013,6236),(143014,6237),(143015,6238),(143016,6239),(143017,6240),(143018,6241),(143019,6242),(143020,6243),(143021,6244),(143022,6245),(143023,6246),(143024,6247),(143025,6248),(143026,6249),(143027,6250),(143028,6251),(143029,6252),(143030,6253),(143031,6254),(143032,6255),(143033,6256),(143034,6257),(143035,6258),(143036,6259),(143037,6260),(143038,6261),(143039,6262),(143040,6263),(143041,6264),(143042,6265),(143043,6266),(143044,6267),(143045,6268),(143046,6269),(143047,6270),(143048,6271),(143049,6272),(143050,6273),(143051,6274),(143052,6275),(143053,6276),(143054,6277),(143055,6278),(143056,6279),(143057,6280),(143058,6281),(143059,6282),(143060,6283),(143061,6284),(143062,6285),(143063,6286),(143064,6287),(143065,6288),(143066,6289),(143067,6290),(143068,6291),(143069,6292),(143070,6293),(143071,6294),(143072,6295),(143073,6296),(143074,6297),(143075,6298),(143076,6299),(143077,6300),(143078,6301),(143079,6302),(143080,6303),(143081,6304),(143082,6305),(143083,6306),(143084,6307),(143085,6308),(143086,6309),(143087,6310),(143088,6311),(143089,6312),(143090,6313),(143091,6314),(143092,6315),(143093,6316),(143094,6317),(143095,6318),(143096,6319),(143097,6320),(143098,6321),(143099,6322),(143100,6323),(143101,6324),(143102,6325),(143103,6326),(143104,6327),(143105,6328),(143106,6329),(143107,6330),(143108,6331),(143109,6332),(143110,6333),(143111,6334),(143112,6235),(143113,6235),(143114,6235),(143115,6236),(143116,6236),(143117,6236),(143118,6237),(143119,6237),(143120,6237),(143121,6238),(143122,6238),(143123,6238),(143124,6239),(143125,6239),(143126,6239),(143127,6240),(143128,6240),(143129,6240),(143130,6241),(143131,6241),(143132,6241),(143133,6242),(143134,6242),(143135,6242),(143136,6243),(143137,6243),(143138,6243),(143139,6244),(143140,6244),(143141,6244),(143142,6245),(143143,6245),(143144,6245),(143145,6246),(143146,6246),(143147,6246),(143148,6247),(143149,6247),(143150,6247),(143151,6248),(143152,6248),(143153,6248),(143154,6249),(143155,6249),(143156,6249),(143157,6250),(143158,6250),(143159,6250),(143160,6251),(143161,6251),(143162,6251),(143163,6252),(143164,6252),(143165,6252),(143166,6253),(143167,6253),(143168,6253),(143169,6254),(143170,6254),(143171,6254),(143172,6255),(143173,6255),(143174,6255),(143175,6256),(143176,6256),(143177,6256),(143178,6257),(143179,6257),(143180,6257),(143181,6258),(143182,6258),(143183,6258),(143184,6259),(143185,6259),(143186,6259),(143187,6260),(143188,6260),(143189,6260),(143190,6261),(143191,6261),(143192,6261),(143193,6262),(143194,6262),(143195,6262),(143196,6263),(143197,6263),(143198,6263),(143199,6264),(143200,6264),(143201,6264),(143202,6265),(143203,6265),(143204,6265),(143205,6266),(143206,6266),(143207,6266),(143208,6267),(143209,6267),(143210,6267),(143211,6268),(143212,6268),(143213,6268),(143214,6269),(143215,6269),(143216,6269),(143217,6270),(143218,6270),(143219,6270),(143220,6271),(143221,6271),(143222,6271),(143223,6272),(143224,6272),(143225,6272),(143226,6273),(143227,6273),(143228,6273),(143229,6274),(143230,6274),(143231,6274),(143232,6275),(143233,6275),(143234,6275),(143235,6276),(143236,6276),(143237,6276),(143238,6277),(143239,6277),(143240,6277),(143241,6278),(143242,6278),(143243,6278),(143244,6279),(143245,6279),(143246,6279),(143247,6280),(143248,6280),(143249,6280),(143250,6281),(143251,6281),(143252,6281),(143253,6282),(143254,6282),(143255,6282),(143256,6283),(143257,6283),(143258,6283),(143259,6284),(143260,6284),(143261,6284),(143262,6285),(143263,6285),(143264,6285),(143265,6286),(143266,6286),(143267,6286),(143268,6287),(143269,6287),(143270,6287),(143271,6288),(143272,6288),(143273,6288),(143274,6289),(143275,6289),(143276,6289),(143277,6290),(143278,6290),(143279,6290),(143280,6291),(143281,6291),(143282,6291),(143283,6292),(143284,6292),(143285,6292),(143286,6293),(143287,6293),(143288,6293),(143289,6294),(143290,6294),(143291,6294),(143292,6295),(143293,6295),(143294,6295),(143295,6296),(143296,6296),(143297,6296),(143298,6297),(143299,6297),(143300,6297),(143301,6298),(143302,6298),(143303,6298),(143304,6299),(143305,6299),(143306,6299),(143307,6300),(143308,6300),(143309,6300),(143310,6301),(143311,6301),(143312,6301),(143313,6302),(143314,6302),(143315,6302),(143316,6303),(143317,6303),(143318,6303),(143319,6304),(143320,6304),(143321,6304),(143322,6305),(143323,6305),(143324,6305),(143325,6306),(143326,6306),(143327,6306),(143328,6307),(143329,6307),(143330,6307),(143331,6308),(143332,6308),(143333,6308),(143334,6309),(143335,6309),(143336,6309),(143337,6310),(143338,6310),(143339,6310),(143340,6311),(143341,6311),(143342,6311),(143343,6312),(143344,6312),(143345,6312),(143346,6313),(143347,6313),(143348,6313),(143349,6314),(143350,6314),(143351,6314),(143352,6315),(143353,6315),(143354,6315),(143355,6316),(143356,6316),(143357,6316),(143358,6317),(143359,6317),(143360,6317),(143361,6318),(143362,6318),(143363,6318),(143364,6319),(143365,6319),(143366,6319),(143367,6320),(143368,6320),(143369,6320),(143370,6321),(143371,6321),(143372,6321),(143373,6322),(143374,6322),(143375,6322),(143376,6323),(143377,6323),(143378,6323),(143379,6324),(143380,6324),(143381,6324),(143382,6325),(143383,6325),(143384,6325),(143385,6326),(143386,6326),(143387,6326),(143388,6327),(143389,6327),(143390,6327),(143391,6328),(143392,6328),(143393,6328),(143394,6329),(143395,6329),(143396,6329),(143397,6330),(143398,6330),(143399,6330),(143400,6331),(143401,6331),(143402,6331),(143403,6332),(143404,6332),(143405,6332),(143406,6333),(143407,6333),(143408,6333),(143409,6334),(143410,6334),(143411,6334),(143412,6235),(143413,6235),(143414,6235),(143415,6235),(143416,6235),(143417,6235),(143418,6235),(143419,6235),(143420,6235),(143421,6235),(143422,6236),(143423,6236),(143424,6236),(143425,6236),(143426,6236),(143427,6236),(143428,6236),(143429,6236),(143430,6236),(143431,6236),(143432,6237),(143433,6237),(143434,6237),(143435,6237),(143436,6237),(143437,6237),(143438,6237),(143439,6237),(143440,6237),(143441,6237),(143442,6238),(143443,6238),(143444,6238),(143445,6238),(143446,6238),(143447,6238),(143448,6238),(143449,6238),(143450,6238),(143451,6238),(143452,6239),(143453,6239),(143454,6239),(143455,6239),(143456,6239),(143457,6239),(143458,6239),(143459,6239),(143460,6239),(143461,6239),(143462,6240),(143463,6240),(143464,6240),(143465,6240),(143466,6240),(143467,6240),(143468,6240),(143469,6240),(143470,6240),(143471,6240),(143472,6240),(143473,6240),(143474,6241),(143475,6241),(143476,6241),(143477,6241),(143478,6241),(143479,6241),(143480,6241),(143481,6241),(143482,6241),(143483,6241),(143484,6241),(143485,6241),(143486,6242),(143487,6242),(143488,6242),(143489,6242),(143490,6242),(143491,6242),(143492,6242),(143493,6242),(143494,6242),(143495,6242),(143496,6243),(143497,6243),(143498,6243),(143499,6243),(143500,6243),(143501,6243),(143502,6243),(143503,6243),(143504,6243),(143505,6243),(143506,6243),(143507,6243),(143508,6243),(143509,6243),(143510,6244),(143511,6244),(143512,6244),(143513,6244),(143514,6244),(143515,6244),(143516,6244),(143517,6244),(143518,6244),(143519,6244),(143520,6244),(143521,6244),(143522,6244),(143523,6244),(143524,6245),(143525,6245),(143526,6245),(143527,6245),(143528,6245),(143529,6245),(143530,6245),(143531,6245),(143532,6245),(143533,6245),(143534,6246),(143535,6246),(143536,6246),(143537,6246),(143538,6246),(143539,6246),(143540,6246),(143541,6246),(143542,6246),(143543,6246),(143544,6247),(143545,6247),(143546,6247),(143547,6247),(143548,6247),(143549,6247),(143550,6247),(143551,6247),(143552,6247),(143553,6247),(143554,6248),(143555,6248),(143556,6248),(143557,6248),(143558,6248),(143559,6248),(143560,6248),(143561,6248),(143562,6248),(143563,6248),(143564,6249),(143565,6249),(143566,6249),(143567,6249),(143568,6249),(143569,6249),(143570,6249),(143571,6249),(143572,6249),(143573,6249),(143574,6250),(143575,6250),(143576,6250),(143577,6250),(143578,6250),(143579,6250),(143580,6250),(143581,6250),(143582,6250),(143583,6250),(143584,6251),(143585,6251),(143586,6251),(143587,6251),(143588,6251),(143589,6251),(143590,6251),(143591,6251),(143592,6251),(143593,6251),(143594,6251),(143595,6251),(143596,6251),(143597,6251),(143598,6252),(143599,6252),(143600,6252),(143601,6252),(143602,6252),(143603,6252),(143604,6252),(143605,6252),(143606,6252),(143607,6252),(143608,6253),(143609,6253),(143610,6253),(143611,6253),(143612,6253),(143613,6253),(143614,6253),(143615,6253),(143616,6253),(143617,6253),(143618,6254),(143619,6254),(143620,6254),(143621,6254),(143622,6254),(143623,6254),(143624,6254),(143625,6254),(143626,6254),(143627,6254),(143628,6255),(143629,6255),(143630,6255),(143631,6255),(143632,6255),(143633,6255),(143634,6255),(143635,6255),(143636,6255),(143637,6255),(143638,6255),(143639,6255),(143640,6255),(143641,6255),(143642,6256),(143643,6256),(143644,6256),(143645,6256),(143646,6256),(143647,6256),(143648,6256),(143649,6256),(143650,6256),(143651,6256),(143652,6257),(143653,6257),(143654,6257),(143655,6257),(143656,6257),(143657,6257),(143658,6257),(143659,6257),(143660,6257),(143661,6257),(143662,6258),(143663,6258),(143664,6258),(143665,6258),(143666,6258),(143667,6258),(143668,6258),(143669,6258),(143670,6258),(143671,6258),(143672,6258),(143673,6258),(143674,6259),(143675,6259),(143676,6259),(143677,6259),(143678,6259),(143679,6259),(143680,6259),(143681,6259),(143682,6259),(143683,6259),(143684,6259),(143685,6259),(143686,6260),(143687,6260),(143688,6260),(143689,6260),(143690,6260),(143691,6260),(143692,6260),(143693,6260),(143694,6260),(143695,6260),(143696,6260),(143697,6260),(143698,6261),(143699,6261),(143700,6261),(143701,6261),(143702,6261),(143703,6261),(143704,6261),(143705,6261),(143706,6262),(143707,6262),(143708,6262),(143709,6262),(143710,6262),(143711,6262),(143712,6262),(143713,6262),(143714,6263),(143715,6263),(143716,6263),(143717,6263),(143718,6263),(143719,6263),(143720,6263),(143721,6263),(143722,6264),(143723,6264),(143724,6264),(143725,6264),(143726,6264),(143727,6264),(143728,6264),(143729,6264),(143730,6265),(143731,6265),(143732,6265),(143733,6265),(143734,6265),(143735,6265),(143736,6265),(143737,6265),(143738,6266),(143739,6266),(143740,6266),(143741,6266),(143742,6266),(143743,6266),(143744,6266),(143745,6266),(143746,6267),(143747,6267),(143748,6267),(143749,6267),(143750,6267),(143751,6267),(143752,6267),(143753,6267),(143754,6267),(143755,6267),(143756,6267),(143757,6267),(143758,6267),(143759,6267),(143760,6268),(143761,6268),(143762,6268),(143763,6268),(143764,6268),(143765,6268),(143766,6268),(143767,6268),(143768,6268),(143769,6268),(143770,6268),(143771,6268),(143772,6268),(143773,6268),(143774,6269),(143775,6269),(143776,6269),(143777,6269),(143778,6269),(143779,6269),(143780,6269),(143781,6269),(143782,6269),(143783,6269),(143784,6270),(143785,6270),(143786,6270),(143787,6270),(143788,6270),(143789,6270),(143790,6270),(143791,6270),(143792,6270),(143793,6270),(143794,6271),(143795,6271),(143796,6271),(143797,6271),(143798,6271),(143799,6271),(143800,6271),(143801,6271),(143802,6271),(143803,6271),(143804,6271),(143805,6271),(143806,6271),(143807,6271),(143808,6272),(143809,6272),(143810,6272),(143811,6272),(143812,6272),(143813,6272),(143814,6272),(143815,6272),(143816,6272),(143817,6272),(143818,6272),(143819,6272),(143820,6272),(143821,6272),(143822,6273),(143823,6273),(143824,6273),(143825,6273),(143826,6273),(143827,6273),(143828,6273),(143829,6273),(143830,6273),(143831,6273),(143832,6273),(143833,6273),(143834,6273),(143835,6273),(143836,6274),(143837,6274),(143838,6274),(143839,6274),(143840,6274),(143841,6274),(143842,6274),(143843,6274),(143844,6274),(143845,6274),(143846,6274),(143847,6274),(143848,6274),(143849,6274),(143850,6275),(143851,6275),(143852,6275),(143853,6275),(143854,6275),(143855,6275),(143856,6275),(143857,6275),(143858,6275),(143859,6275),(143860,6276),(143861,6276),(143862,6276),(143863,6276),(143864,6276),(143865,6276),(143866,6276),(143867,6276),(143868,6276),(143869,6276),(143870,6276),(143871,6276),(143872,6276),(143873,6276),(143874,6277),(143875,6277),(143876,6277),(143877,6277),(143878,6277),(143879,6277),(143880,6277),(143881,6277),(143882,6277),(143883,6277),(143884,6277),(143885,6277),(143886,6277),(143887,6277),(143888,6278),(143889,6278),(143890,6278),(143891,6278),(143892,6278),(143893,6278),(143894,6278),(143895,6278),(143896,6278),(143897,6278),(143898,6278),(143899,6278),(143900,6278),(143901,6278),(143902,6279),(143903,6279),(143904,6279),(143905,6279),(143906,6279),(143907,6279),(143908,6279),(143909,6279),(143910,6279),(143911,6279),(143912,6279),(143913,6279),(143914,6279),(143915,6279),(143916,6280),(143917,6280),(143918,6280),(143919,6280),(143920,6280),(143921,6280),(143922,6280),(143923,6280),(143924,6280),(143925,6280),(143926,6281),(143927,6281),(143928,6281),(143929,6281),(143930,6281),(143931,6281),(143932,6281),(143933,6281),(143934,6281),(143935,6281),(143936,6282),(143937,6282),(143938,6282),(143939,6282),(143940,6282),(143941,6282),(143942,6282),(143943,6282),(143944,6282),(143945,6282),(143946,6283),(143947,6283),(143948,6283),(143949,6283),(143950,6283),(143951,6283),(143952,6283),(143953,6283),(143954,6283),(143955,6283),(143956,6284),(143957,6284),(143958,6284),(143959,6284),(143960,6284),(143961,6284),(143962,6284),(143963,6284),(143964,6284),(143965,6284),(143966,6285),(143967,6285),(143968,6285),(143969,6285),(143970,6285),(143971,6285),(143972,6285),(143973,6285),(143974,6285),(143975,6285),(143976,6286),(143977,6286),(143978,6286),(143979,6286),(143980,6286),(143981,6286),(143982,6286),(143983,6286),(143984,6286),(143985,6286),(143986,6287),(143987,6287),(143988,6287),(143989,6287),(143990,6287),(143991,6287),(143992,6287),(143993,6287),(143994,6287),(143995,6287),(143996,6288),(143997,6288),(143998,6288),(143999,6288),(144000,6288),(144001,6288),(144002,6288),(144003,6288),(144004,6288),(144005,6288),(144006,6289),(144007,6289),(144008,6289),(144009,6289),(144010,6289),(144011,6289),(144012,6289),(144013,6289),(144014,6289),(144015,6289),(144016,6290),(144017,6290),(144018,6290),(144019,6290),(144020,6290),(144021,6290),(144022,6290),(144023,6290),(144024,6290),(144025,6290),(144026,6291),(144027,6291),(144028,6291),(144029,6291),(144030,6291),(144031,6291),(144032,6291),(144033,6291),(144034,6291),(144035,6291),(144036,6292),(144037,6292),(144038,6292),(144039,6292),(144040,6292),(144041,6292),(144042,6292),(144043,6292),(144044,6292),(144045,6292),(144046,6293),(144047,6293),(144048,6293),(144049,6293),(144050,6293),(144051,6293),(144052,6293),(144053,6293),(144054,6293),(144055,6293),(144056,6294),(144057,6294),(144058,6294),(144059,6294),(144060,6294),(144061,6294),(144062,6294),(144063,6294),(144064,6294),(144065,6294),(144066,6295),(144067,6295),(144068,6295),(144069,6295),(144070,6295),(144071,6295),(144072,6295),(144073,6295),(144074,6295),(144075,6295),(144076,6296),(144077,6296),(144078,6296),(144079,6296),(144080,6296),(144081,6296),(144082,6296),(144083,6296),(144084,6296),(144085,6296),(144086,6297),(144087,6297),(144088,6297),(144089,6297),(144090,6297),(144091,6297),(144092,6297),(144093,6297),(144094,6297),(144095,6297),(144096,6298),(144097,6298),(144098,6298),(144099,6298),(144100,6298),(144101,6298),(144102,6298),(144103,6298),(144104,6298),(144105,6298),(144106,6298),(144107,6298),(144108,6298),(144109,6298),(144110,6299),(144111,6299),(144112,6299),(144113,6299),(144114,6299),(144115,6299),(144116,6299),(144117,6299),(144118,6299),(144119,6299),(144120,6299),(144121,6299),(144122,6299),(144123,6299),(144124,6300),(144125,6300),(144126,6300),(144127,6300),(144128,6300),(144129,6300),(144130,6300),(144131,6300),(144132,6300),(144133,6300),(144134,6301),(144135,6301),(144136,6301),(144137,6301),(144138,6301),(144139,6301),(144140,6301),(144141,6301),(144142,6301),(144143,6301),(144144,6302),(144145,6302),(144146,6302),(144147,6302),(144148,6302),(144149,6302),(144150,6302),(144151,6302),(144152,6302),(144153,6302),(144154,6303),(144155,6303),(144156,6303),(144157,6303),(144158,6303),(144159,6303),(144160,6303),(144161,6303),(144162,6303),(144163,6303),(144164,6304),(144165,6304),(144166,6304),(144167,6304),(144168,6304),(144169,6304),(144170,6304),(144171,6304),(144172,6304),(144173,6304),(144174,6305),(144175,6305),(144176,6305),(144177,6305),(144178,6305),(144179,6305),(144180,6305),(144181,6305),(144182,6305),(144183,6305),(144184,6306),(144185,6306),(144186,6306),(144187,6306),(144188,6306),(144189,6306),(144190,6306),(144191,6306),(144192,6306),(144193,6306),(144194,6307),(144195,6307),(144196,6307),(144197,6307),(144198,6307),(144199,6307),(144200,6307),(144201,6307),(144202,6307),(144203,6307),(144204,6308),(144205,6308),(144206,6308),(144207,6308),(144208,6308),(144209,6308),(144210,6308),(144211,6308),(144212,6308),(144213,6308),(144214,6309),(144215,6309),(144216,6309),(144217,6309),(144218,6309),(144219,6309),(144220,6309),(144221,6309),(144222,6309),(144223,6309),(144224,6310),(144225,6310),(144226,6310),(144227,6310),(144228,6310),(144229,6310),(144230,6310),(144231,6310),(144232,6310),(144233,6310),(144234,6311),(144235,6311),(144236,6311),(144237,6311),(144238,6311),(144239,6311),(144240,6311),(144241,6311),(144242,6311),(144243,6311),(144244,6312),(144245,6312),(144246,6312),(144247,6312),(144248,6312),(144249,6312),(144250,6312),(144251,6312),(144252,6312),(144253,6312),(144254,6313),(144255,6313),(144256,6313),(144257,6313),(144258,6313),(144259,6313),(144260,6313),(144261,6313),(144262,6313),(144263,6313),(144264,6314),(144265,6314),(144266,6314),(144267,6314),(144268,6314),(144269,6314),(144270,6314),(144271,6314),(144272,6314),(144273,6314),(144274,6315),(144275,6315),(144276,6315),(144277,6315),(144278,6315),(144279,6315),(144280,6315),(144281,6315),(144282,6315),(144283,6315),(144284,6316),(144285,6316),(144286,6316),(144287,6316),(144288,6316),(144289,6316),(144290,6316),(144291,6316),(144292,6316),(144293,6316),(144294,6317),(144295,6317),(144296,6317),(144297,6317),(144298,6317),(144299,6317),(144300,6317),(144301,6317),(144302,6317),(144303,6317),(144304,6318),(144305,6318),(144306,6318),(144307,6318),(144308,6318),(144309,6318),(144310,6318),(144311,6318),(144312,6318),(144313,6318),(144314,6319),(144315,6319),(144316,6319),(144317,6319),(144318,6319),(144319,6319),(144320,6319),(144321,6319),(144322,6319),(144323,6319),(144324,6320),(144325,6320),(144326,6320),(144327,6320),(144328,6320),(144329,6320),(144330,6320),(144331,6320),(144332,6320),(144333,6320),(144334,6321),(144335,6321),(144336,6321),(144337,6321),(144338,6321),(144339,6321),(144340,6321),(144341,6321),(144342,6321),(144343,6321),(144344,6322),(144345,6322),(144346,6322),(144347,6322),(144348,6322),(144349,6322),(144350,6322),(144351,6322),(144352,6322),(144353,6322),(144354,6323),(144355,6323),(144356,6323),(144357,6323),(144358,6323),(144359,6323),(144360,6323),(144361,6323),(144362,6323),(144363,6323),(144364,6324),(144365,6324),(144366,6324),(144367,6324),(144368,6324),(144369,6324),(144370,6324),(144371,6324),(144372,6324),(144373,6324),(144374,6325),(144375,6325),(144376,6325),(144377,6325),(144378,6325),(144379,6325),(144380,6325),(144381,6325),(144382,6325),(144383,6325),(144384,6326),(144385,6326),(144386,6326),(144387,6326),(144388,6326),(144389,6326),(144390,6326),(144391,6326),(144392,6326),(144393,6326),(144394,6327),(144395,6327),(144396,6327),(144397,6327),(144398,6327),(144399,6327),(144400,6327),(144401,6327),(144402,6327),(144403,6327),(144404,6328),(144405,6328),(144406,6328),(144407,6328),(144408,6328),(144409,6328),(144410,6328),(144411,6328),(144412,6328),(144413,6328),(144414,6329),(144415,6329),(144416,6329),(144417,6329),(144418,6329),(144419,6329),(144420,6329),(144421,6329),(144422,6329),(144423,6329),(144424,6330),(144425,6330),(144426,6330),(144427,6330),(144428,6330),(144429,6330),(144430,6330),(144431,6330),(144432,6330),(144433,6330),(144434,6331),(144435,6331),(144436,6331),(144437,6331),(144438,6331),(144439,6331),(144440,6331),(144441,6331),(144442,6331),(144443,6331),(144444,6332),(144445,6332),(144446,6332),(144447,6332),(144448,6332),(144449,6332),(144450,6332),(144451,6332),(144452,6332),(144453,6332),(144454,6333),(144455,6333),(144456,6333),(144457,6333),(144458,6333),(144459,6333),(144460,6333),(144461,6333),(144462,6333),(144463,6333),(144464,6334),(144465,6334),(144466,6334),(144467,6334),(144468,6334),(144469,6334),(144470,6334),(144471,6334),(144472,6334),(144473,6334),(144474,6235),(144475,6235),(144476,6235),(144477,6235),(144478,6235),(144479,6236),(144480,6236),(144481,6236),(144482,6236),(144483,6236),(144484,6237),(144485,6237),(144486,6237),(144487,6237),(144488,6237),(144489,6238),(144490,6238),(144491,6238),(144492,6238),(144493,6238),(144494,6239),(144495,6239),(144496,6239),(144497,6239),(144498,6239),(144499,6240),(144500,6240),(144501,6240),(144502,6240),(144503,6240),(144504,6241),(144505,6241),(144506,6241),(144507,6241),(144508,6241),(144509,6242),(144510,6242),(144511,6242),(144512,6242),(144513,6242),(144514,6243),(144515,6243),(144516,6243),(144517,6243),(144518,6243),(144519,6244),(144520,6244),(144521,6244),(144522,6244),(144523,6244),(144524,6245),(144525,6245),(144526,6245),(144527,6246),(144528,6246),(144529,6246),(144530,6247),(144531,6247),(144532,6247),(144533,6248),(144534,6248),(144535,6248),(144536,6249),(144537,6249),(144538,6249),(144539,6249),(144540,6249),(144541,6250),(144542,6250),(144543,6250),(144544,6250),(144545,6250),(144546,6251),(144547,6251),(144548,6251),(144549,6251),(144550,6251),(144551,6252),(144552,6252),(144553,6252),(144554,6252),(144555,6252),(144556,6253),(144557,6253),(144558,6253),(144559,6253),(144560,6253),(144561,6254),(144562,6254),(144563,6254),(144564,6254),(144565,6254),(144566,6255),(144567,6255),(144568,6255),(144569,6255),(144570,6255),(144571,6256),(144572,6256),(144573,6256),(144574,6256),(144575,6256),(144576,6257),(144577,6257),(144578,6257),(144579,6257),(144580,6257),(144581,6258),(144582,6258),(144583,6258),(144584,6258),(144585,6258),(144586,6259),(144587,6259),(144588,6259),(144589,6259),(144590,6259),(144591,6260),(144592,6260),(144593,6260),(144594,6260),(144595,6260),(144596,6261),(144597,6261),(144598,6261),(144599,6261),(144600,6261),(144601,6262),(144602,6262),(144603,6262),(144604,6262),(144605,6262),(144606,6263),(144607,6263),(144608,6263),(144609,6263),(144610,6263),(144611,6264),(144612,6264),(144613,6264),(144614,6264),(144615,6264),(144616,6265),(144617,6265),(144618,6265),(144619,6265),(144620,6265),(144621,6266),(144622,6266),(144623,6266),(144624,6266),(144625,6266),(144626,6267),(144627,6267),(144628,6267),(144629,6267),(144630,6267),(144631,6268),(144632,6268),(144633,6268),(144634,6268),(144635,6268),(144636,6269),(144637,6269),(144638,6269),(144639,6269),(144640,6269),(144641,6270),(144642,6270),(144643,6270),(144644,6270),(144645,6270),(144646,6271),(144647,6271),(144648,6271),(144649,6271),(144650,6271),(144651,6272),(144652,6272),(144653,6272),(144654,6272),(144655,6272),(144656,6273),(144657,6273),(144658,6273),(144659,6273),(144660,6273),(144661,6274),(144662,6274),(144663,6274),(144664,6274),(144665,6274),(144666,6275),(144667,6275),(144668,6275),(144669,6275),(144670,6275),(144671,6276),(144672,6276),(144673,6276),(144674,6276),(144675,6276),(144676,6277),(144677,6277),(144678,6277),(144679,6277),(144680,6277),(144681,6278),(144682,6278),(144683,6278),(144684,6278),(144685,6278),(144686,6279),(144687,6279),(144688,6279),(144689,6279),(144690,6279),(144691,6280),(144692,6280),(144693,6280),(144694,6280),(144695,6280),(144696,6281),(144697,6281),(144698,6281),(144699,6281),(144700,6281),(144701,6282),(144702,6282),(144703,6282),(144704,6282),(144705,6282),(144706,6283),(144707,6283),(144708,6283),(144709,6283),(144710,6283),(144711,6284),(144712,6284),(144713,6284),(144714,6284),(144715,6284),(144716,6285),(144717,6285),(144718,6285),(144719,6285),(144720,6285),(144721,6286),(144722,6286),(144723,6286),(144724,6286),(144725,6286),(144726,6287),(144727,6287),(144728,6287),(144729,6287),(144730,6287),(144731,6288),(144732,6288),(144733,6288),(144734,6288),(144735,6288),(144736,6289),(144737,6289),(144738,6289),(144739,6289),(144740,6289),(144741,6290),(144742,6290),(144743,6290),(144744,6290),(144745,6290),(144746,6291),(144747,6291),(144748,6291),(144749,6291),(144750,6291),(144751,6292),(144752,6292),(144753,6292),(144754,6292),(144755,6292),(144756,6293),(144757,6293),(144758,6293),(144759,6293),(144760,6293),(144761,6294),(144762,6294),(144763,6294),(144764,6294),(144765,6294),(144766,6295),(144767,6295),(144768,6295),(144769,6295),(144770,6295),(144771,6296),(144772,6296),(144773,6296),(144774,6296),(144775,6296),(144776,6297),(144777,6297),(144778,6297),(144779,6297),(144780,6297),(144781,6298),(144782,6298),(144783,6298),(144784,6298),(144785,6298),(144786,6299),(144787,6299),(144788,6299),(144789,6299),(144790,6299),(144791,6300),(144792,6300),(144793,6300),(144794,6300),(144795,6300),(144796,6301),(144797,6301),(144798,6301),(144799,6301),(144800,6301),(144801,6302),(144802,6302),(144803,6302),(144804,6302),(144805,6302),(144806,6303),(144807,6303),(144808,6303),(144809,6303),(144810,6303),(144811,6304),(144812,6304),(144813,6304),(144814,6304),(144815,6304),(144816,6305),(144817,6305),(144818,6305),(144819,6305),(144820,6305),(144821,6306),(144822,6306),(144823,6306),(144824,6306),(144825,6306),(144826,6307),(144827,6307),(144828,6307),(144829,6307),(144830,6307),(144831,6308),(144832,6308),(144833,6308),(144834,6308),(144835,6308),(144836,6309),(144837,6309),(144838,6309),(144839,6309),(144840,6309),(144841,6310),(144842,6310),(144843,6310),(144844,6310),(144845,6310),(144846,6311),(144847,6311),(144848,6311),(144849,6311),(144850,6311),(144851,6312),(144852,6312),(144853,6312),(144854,6313),(144855,6313),(144856,6313),(144857,6313),(144858,6313),(144859,6314),(144860,6314),(144861,6314),(144862,6314),(144863,6314),(144864,6315),(144865,6315),(144866,6315),(144867,6315),(144868,6315),(144869,6316),(144870,6316),(144871,6316),(144872,6316),(144873,6316),(144874,6317),(144875,6317),(144876,6317),(144877,6317),(144878,6317),(144879,6318),(144880,6318),(144881,6318),(144882,6318),(144883,6318),(144884,6319),(144885,6319),(144886,6319),(144887,6319),(144888,6319),(144889,6320),(144890,6320),(144891,6320),(144892,6320),(144893,6320),(144894,6321),(144895,6321),(144896,6321),(144897,6321),(144898,6321),(144899,6322),(144900,6322),(144901,6322),(144902,6322),(144903,6322),(144904,6323),(144905,6323),(144906,6323),(144907,6323),(144908,6323),(144909,6324),(144910,6324),(144911,6324),(144912,6324),(144913,6324),(144914,6325),(144915,6325),(144916,6325),(144917,6325),(144918,6325),(144919,6326),(144920,6326),(144921,6326),(144922,6326),(144923,6326),(144924,6327),(144925,6327),(144926,6327),(144927,6327),(144928,6327),(144929,6328),(144930,6328),(144931,6328),(144932,6328),(144933,6328),(144934,6329),(144935,6329),(144936,6329),(144937,6329),(144938,6329),(144939,6330),(144940,6330),(144941,6330),(144942,6330),(144943,6330),(144944,6331),(144945,6331),(144946,6331),(144947,6331),(144948,6331),(144949,6332),(144950,6332),(144951,6332),(144952,6332),(144953,6332),(144954,6333),(144955,6333),(144956,6333),(144957,6333),(144958,6333),(144959,6334),(144960,6334),(144961,6334),(144962,6334),(144963,6334),(144964,6235),(144965,6235),(144966,6235),(144967,6235),(144968,6235),(144969,6236),(144970,6236),(144971,6236),(144972,6236),(144973,6236),(144974,6237),(144975,6237),(144976,6237),(144977,6237),(144978,6237),(144979,6238),(144980,6238),(144981,6238),(144982,6238),(144983,6238),(144984,6239),(144985,6239),(144986,6239),(144987,6239),(144988,6239),(144989,6240),(144990,6240),(144991,6240),(144992,6240),(144993,6240),(144994,6241),(144995,6241),(144996,6241),(144997,6241),(144998,6241),(144999,6242),(145000,6242),(145001,6242),(145002,6242),(145003,6242),(145004,6243),(145005,6243),(145006,6243),(145007,6243),(145008,6243),(145009,6244),(145010,6244),(145011,6244),(145012,6244),(145013,6244),(145014,6245),(145015,6245),(145016,6245),(145017,6245),(145018,6245),(145019,6246),(145020,6246),(145021,6246),(145022,6246),(145023,6246),(145024,6247),(145025,6247),(145026,6247),(145027,6247),(145028,6247),(145029,6248),(145030,6248),(145031,6248),(145032,6248),(145033,6248),(145034,6249),(145035,6249),(145036,6249),(145037,6249),(145038,6249),(145039,6250),(145040,6250),(145041,6250),(145042,6250),(145043,6250),(145044,6251),(145045,6251),(145046,6251),(145047,6251),(145048,6251),(145049,6252),(145050,6252),(145051,6252),(145052,6252),(145053,6252),(145054,6253),(145055,6253),(145056,6253),(145057,6253),(145058,6253),(145059,6254),(145060,6254),(145061,6254),(145062,6254),(145063,6254),(145064,6255),(145065,6255),(145066,6255),(145067,6255),(145068,6255),(145069,6256),(145070,6256),(145071,6256),(145072,6256),(145073,6256),(145074,6257),(145075,6257),(145076,6257),(145077,6257),(145078,6257),(145079,6258),(145080,6258),(145081,6258),(145082,6258),(145083,6258),(145084,6259),(145085,6259),(145086,6259),(145087,6259),(145088,6259),(145089,6260),(145090,6260),(145091,6260),(145092,6260),(145093,6260),(145094,6261),(145095,6261),(145096,6261),(145097,6261),(145098,6261),(145099,6262),(145100,6262),(145101,6262),(145102,6262),(145103,6262),(145104,6263),(145105,6263),(145106,6263),(145107,6263),(145108,6263),(145109,6264),(145110,6264),(145111,6264),(145112,6264),(145113,6264),(145114,6265),(145115,6265),(145116,6265),(145117,6265),(145118,6265),(145119,6266),(145120,6266),(145121,6266),(145122,6266),(145123,6266),(145124,6267),(145125,6267),(145126,6267),(145127,6267),(145128,6267),(145129,6268),(145130,6268),(145131,6268),(145132,6268),(145133,6268),(145134,6269),(145135,6269),(145136,6269),(145137,6269),(145138,6269),(145139,6270),(145140,6270),(145141,6270),(145142,6270),(145143,6270),(145144,6271),(145145,6271),(145146,6271),(145147,6271),(145148,6271),(145149,6272),(145150,6272),(145151,6272),(145152,6272),(145153,6272),(145154,6273),(145155,6273),(145156,6273),(145157,6273),(145158,6273),(145159,6274),(145160,6274),(145161,6274),(145162,6274),(145163,6274),(145164,6275),(145165,6275),(145166,6275),(145167,6275),(145168,6275),(145169,6276),(145170,6276),(145171,6276),(145172,6276),(145173,6276),(145174,6277),(145175,6277),(145176,6277),(145177,6277),(145178,6277),(145179,6278),(145180,6278),(145181,6278),(145182,6278),(145183,6278),(145184,6279),(145185,6279),(145186,6279),(145187,6279),(145188,6279),(145189,6280),(145190,6280),(145191,6280),(145192,6280),(145193,6280),(145194,6281),(145195,6281),(145196,6281),(145197,6281),(145198,6281),(145199,6282),(145200,6282),(145201,6282),(145202,6282),(145203,6282),(145204,6283),(145205,6283),(145206,6283),(145207,6283),(145208,6283),(145209,6284),(145210,6284),(145211,6284),(145212,6284),(145213,6284),(145214,6285),(145215,6285),(145216,6285),(145217,6285),(145218,6285),(145219,6286),(145220,6286),(145221,6286),(145222,6286),(145223,6286),(145224,6287),(145225,6287),(145226,6287),(145227,6287),(145228,6287),(145229,6288),(145230,6288),(145231,6288),(145232,6288),(145233,6288),(145234,6289),(145235,6289),(145236,6289),(145237,6289),(145238,6289),(145239,6290),(145240,6290),(145241,6290),(145242,6290),(145243,6290),(145244,6291),(145245,6291),(145246,6291),(145247,6291),(145248,6291),(145249,6292),(145250,6292),(145251,6292),(145252,6292),(145253,6292),(145254,6293),(145255,6293),(145256,6293),(145257,6293),(145258,6293),(145259,6294),(145260,6294),(145261,6294),(145262,6294),(145263,6294),(145264,6295),(145265,6295),(145266,6295),(145267,6295),(145268,6295),(145269,6296),(145270,6296),(145271,6296),(145272,6296),(145273,6296),(145274,6297),(145275,6297),(145276,6297),(145277,6297),(145278,6297),(145279,6298),(145280,6298),(145281,6298),(145282,6298),(145283,6298),(145284,6299),(145285,6299),(145286,6299),(145287,6299),(145288,6299),(145289,6300),(145290,6300),(145291,6300),(145292,6300),(145293,6300),(145294,6301),(145295,6301),(145296,6301),(145297,6301),(145298,6301),(145299,6302),(145300,6302),(145301,6302),(145302,6302),(145303,6302),(145304,6303),(145305,6303),(145306,6303),(145307,6303),(145308,6303),(145309,6304),(145310,6304),(145311,6304),(145312,6304),(145313,6304),(145314,6305),(145315,6305),(145316,6305),(145317,6305),(145318,6305),(145319,6306),(145320,6306),(145321,6306),(145322,6306),(145323,6306),(145324,6307),(145325,6307),(145326,6307),(145327,6307),(145328,6307),(145329,6308),(145330,6308),(145331,6308),(145332,6308),(145333,6308),(145334,6309),(145335,6309),(145336,6309),(145337,6309),(145338,6309),(145339,6310),(145340,6310),(145341,6310),(145342,6310),(145343,6310),(145344,6311),(145345,6311),(145346,6311),(145347,6311),(145348,6311),(145349,6312),(145350,6312),(145351,6312),(145352,6312),(145353,6312),(145354,6313),(145355,6313),(145356,6313),(145357,6313),(145358,6313),(145359,6314),(145360,6314),(145361,6314),(145362,6314),(145363,6314),(145364,6315),(145365,6315),(145366,6315),(145367,6315),(145368,6315),(145369,6316),(145370,6316),(145371,6316),(145372,6316),(145373,6316),(145374,6317),(145375,6317),(145376,6317),(145377,6317),(145378,6317),(145379,6318),(145380,6318),(145381,6318),(145382,6318),(145383,6318),(145384,6319),(145385,6319),(145386,6319),(145387,6319),(145388,6319),(145389,6320),(145390,6320),(145391,6320),(145392,6320),(145393,6320),(145394,6321),(145395,6321),(145396,6321),(145397,6321),(145398,6321),(145399,6322),(145400,6322),(145401,6322),(145402,6322),(145403,6322),(145404,6323),(145405,6323),(145406,6323),(145407,6323),(145408,6323),(145409,6324),(145410,6324),(145411,6324),(145412,6324),(145413,6324),(145414,6325),(145415,6325),(145416,6325),(145417,6325),(145418,6325),(145419,6326),(145420,6326),(145421,6326),(145422,6326),(145423,6326),(145424,6327),(145425,6327),(145426,6327),(145427,6327),(145428,6327),(145429,6328),(145430,6328),(145431,6328),(145432,6328),(145433,6328),(145434,6329),(145435,6329),(145436,6329),(145437,6329),(145438,6329),(145439,6330),(145440,6330),(145441,6330),(145442,6330),(145443,6330),(145444,6331),(145445,6331),(145446,6331),(145447,6331),(145448,6331),(145449,6332),(145450,6332),(145451,6332),(145452,6332),(145453,6332),(145454,6333),(145455,6333),(145456,6333),(145457,6333),(145458,6333),(145459,6334),(145460,6334),(145461,6334),(145462,6334),(145463,6334),(145464,6335),(145465,6336),(145466,6337),(145467,6338),(145468,6339),(145469,6340),(145470,6341),(145471,6342),(145472,6343),(145473,6344),(145474,6345),(145475,6335),(145476,6335),(145477,6335),(145478,6336),(145479,6336),(145480,6336),(145481,6337),(145482,6337),(145483,6337),(145484,6338),(145485,6338),(145486,6338),(145487,6339),(145488,6339),(145489,6339),(145490,6340),(145491,6340),(145492,6340),(145493,6341),(145494,6341),(145495,6341),(145496,6342),(145497,6342),(145498,6342),(145499,6343),(145500,6343),(145501,6343),(145502,6344),(145503,6344),(145504,6344),(145505,6345),(145506,6345),(145507,6345),(145508,6335),(145509,6335),(145510,6335),(145511,6335),(145512,6335),(145513,6335),(145514,6335),(145515,6335),(145516,6335),(145517,6335),(145518,6336),(145519,6336),(145520,6336),(145521,6336),(145522,6336),(145523,6336),(145524,6336),(145525,6336),(145526,6336),(145527,6336),(145528,6337),(145529,6337),(145530,6337),(145531,6337),(145532,6337),(145533,6337),(145534,6337),(145535,6337),(145536,6337),(145537,6337),(145538,6338),(145539,6338),(145540,6338),(145541,6338),(145542,6338),(145543,6338),(145544,6338),(145545,6338),(145546,6338),(145547,6338),(145548,6339),(145549,6339),(145550,6339),(145551,6339),(145552,6339),(145553,6339),(145554,6339),(145555,6339),(145556,6339),(145557,6339),(145558,6340),(145559,6340),(145560,6340),(145561,6340),(145562,6340),(145563,6340),(145564,6340),(145565,6340),(145566,6340),(145567,6340),(145568,6341),(145569,6341),(145570,6341),(145571,6341),(145572,6341),(145573,6341),(145574,6341),(145575,6341),(145576,6341),(145577,6341),(145578,6342),(145579,6342),(145580,6342),(145581,6342),(145582,6342),(145583,6342),(145584,6342),(145585,6342),(145586,6342),(145587,6342),(145588,6343),(145589,6343),(145590,6343),(145591,6343),(145592,6343),(145593,6343),(145594,6343),(145595,6343),(145596,6343),(145597,6343),(145598,6344),(145599,6344),(145600,6344),(145601,6344),(145602,6344),(145603,6344),(145604,6344),(145605,6344),(145606,6344),(145607,6344),(145608,6345),(145609,6345),(145610,6345),(145611,6345),(145612,6345),(145613,6345),(145614,6345),(145615,6345),(145616,6345),(145617,6345),(145618,6335),(145619,6335),(145620,6335),(145621,6335),(145622,6335),(145623,6336),(145624,6336),(145625,6336),(145626,6336),(145627,6336),(145628,6337),(145629,6337),(145630,6337),(145631,6337),(145632,6337),(145633,6338),(145634,6338),(145635,6338),(145636,6339),(145637,6339),(145638,6339),(145639,6339),(145640,6339),(145641,6340),(145642,6340),(145643,6340),(145644,6340),(145645,6340),(145646,6341),(145647,6341),(145648,6341),(145649,6341),(145650,6341),(145651,6342),(145652,6342),(145653,6342),(145654,6342),(145655,6342),(145656,6343),(145657,6343),(145658,6343),(145659,6343),(145660,6343),(145661,6344),(145662,6344),(145663,6344),(145664,6344),(145665,6344),(145666,6345),(145667,6345),(145668,6345),(145669,6335),(145670,6335),(145671,6335),(145672,6335),(145673,6335),(145674,6336),(145675,6336),(145676,6336),(145677,6336),(145678,6336),(145679,6337),(145680,6337),(145681,6337),(145682,6337),(145683,6337),(145684,6338),(145685,6338),(145686,6338),(145687,6338),(145688,6338),(145689,6339),(145690,6339),(145691,6339),(145692,6339),(145693,6339),(145694,6340),(145695,6340),(145696,6340),(145697,6340),(145698,6340),(145699,6341),(145700,6341),(145701,6341),(145702,6341),(145703,6341),(145704,6342),(145705,6342),(145706,6342),(145707,6342),(145708,6342),(145709,6343),(145710,6343),(145711,6343),(145712,6343),(145713,6343),(145714,6344),(145715,6344),(145716,6344),(145717,6344),(145718,6344),(145719,6345),(145720,6345),(145721,6345),(145722,6345),(145723,6345),(145724,6035),(145725,6035),(145726,6035),(145727,6035),(145728,6035),(145729,6035),(145730,6035),(145731,6035),(145732,6035),(145733,6035),(145734,6035),(145735,6035),(145736,6035),(145737,6035),(145738,6035),(145739,6035),(145740,6035),(145741,6035),(145742,6035),(145743,6035),(145744,6035),(145745,6035),(145746,6035),(145747,6035),(145748,6035),(145749,6035),(145750,6035),(145751,6035),(145752,6035),(145753,6035),(145754,6035),(145755,6035),(145756,6035),(145757,6035),(145758,6035),(145759,6035),(145760,6035),(145761,6035),(145762,6035),(145763,6035),(145764,6035),(145765,6035),(145766,6035),(145767,6035),(145768,5760),(145769,6326),(145770,6327),(145771,6328),(145772,6329),(145773,6330),(145774,6331),(145775,6332),(145776,6333),(145777,6334),(145778,6335),(145779,6336),(145780,6337),(145781,6338),(145782,6339),(145783,6340),(145784,6341),(145785,6342),(145786,6343),(145787,6344),(145788,6345),(145789,6036),(145790,6036),(145791,6036),(145792,6036),(145793,6036),(145794,6036),(145795,6036),(145796,6036),(145797,6036),(145798,6036),(145799,6036),(145800,6036),(145801,6036),(145802,6036),(145803,6036),(145804,6036),(145805,6036),(145806,6036),(145807,6036),(145808,6036),(145809,6036),(145810,6036),(145811,6036),(145812,6036),(145813,6036),(145814,6036),(145815,6036),(145816,6036),(145817,6036),(145818,5760),(145819,6035),(145820,6293),(145821,6299),(145822,6310),(145823,6311),(145824,6332),(145825,6333),(145826,6334),(145827,6335),(145828,6336),(145829,6337),(145830,6035),(145831,6035),(145832,6035),(145833,6035),(145834,6035),(145835,6035),(145836,6036),(145837,6037),(145838,6038),(145839,6039),(145840,6040),(145841,6346),(145842,6347),(145843,6348),(145844,6349),(145845,6350),(145846,6351),(145847,6352),(145848,6353),(145849,6354),(145850,6355),(145851,6356),(145852,6346),(145853,6346),(145854,6346),(145855,6347),(145856,6347),(145857,6347),(145858,6348),(145859,6348),(145860,6348),(145861,6349),(145862,6349),(145863,6349),(145864,6350),(145865,6350),(145866,6350),(145867,6351),(145868,6351),(145869,6351),(145870,6352),(145871,6352),(145872,6352),(145873,6353),(145874,6353),(145875,6353),(145876,6354),(145877,6354),(145878,6354),(145879,6355),(145880,6355),(145881,6355),(145882,6356),(145883,6356),(145884,6356),(145885,6346),(145886,6346),(145887,6346),(145888,6346),(145889,6346),(145890,6346),(145891,6346),(145892,6346),(145893,6346),(145894,6346),(145895,6347),(145896,6347),(145897,6347),(145898,6347),(145899,6347),(145900,6347),(145901,6347),(145902,6347),(145903,6347),(145904,6347),(145905,6348),(145906,6348),(145907,6348),(145908,6348),(145909,6348),(145910,6348),(145911,6348),(145912,6348),(145913,6348),(145914,6348),(145915,6349),(145916,6349),(145917,6349),(145918,6349),(145919,6349),(145920,6349),(145921,6349),(145922,6349),(145923,6349),(145924,6349),(145925,6350),(145926,6350),(145927,6350),(145928,6350),(145929,6350),(145930,6350),(145931,6350),(145932,6350),(145933,6350),(145934,6350),(145935,6351),(145936,6351),(145937,6351),(145938,6351),(145939,6351),(145940,6351),(145941,6351),(145942,6351),(145943,6351),(145944,6351),(145945,6352),(145946,6352),(145947,6352),(145948,6352),(145949,6352),(145950,6352),(145951,6352),(145952,6352),(145953,6352),(145954,6352),(145955,6353),(145956,6353),(145957,6353),(145958,6353),(145959,6353),(145960,6353),(145961,6353),(145962,6353),(145963,6353),(145964,6353),(145965,6354),(145966,6354),(145967,6354),(145968,6354),(145969,6354),(145970,6354),(145971,6354),(145972,6354),(145973,6354),(145974,6354),(145975,6355),(145976,6355),(145977,6355),(145978,6355),(145979,6355),(145980,6355),(145981,6355),(145982,6355),(145983,6355),(145984,6355),(145985,6356),(145986,6356),(145987,6356),(145988,6356),(145989,6356),(145990,6356),(145991,6356),(145992,6356),(145993,6356),(145994,6356),(145995,6346),(145996,6346),(145997,6346),(145998,6346),(145999,6346),(146000,6347),(146001,6347),(146002,6347),(146003,6347),(146004,6347),(146005,6348),(146006,6348),(146007,6348),(146008,6348),(146009,6348),(146010,6349),(146011,6349),(146012,6349),(146013,6349),(146014,6349),(146015,6350),(146016,6350),(146017,6350),(146018,6350),(146019,6350),(146020,6351),(146021,6351),(146022,6351),(146023,6351),(146024,6351),(146025,6352),(146026,6352),(146027,6352),(146028,6352),(146029,6352),(146030,6353),(146031,6353),(146032,6353),(146033,6353),(146034,6353),(146035,6354),(146036,6354),(146037,6354),(146038,6354),(146039,6354),(146040,6355),(146041,6355),(146042,6355),(146043,6355),(146044,6355),(146045,6356),(146046,6356),(146047,6356),(146048,6356),(146049,6356),(146050,6346),(146051,6346),(146052,6346),(146053,6346),(146054,6346),(146055,6347),(146056,6347),(146057,6347),(146058,6347),(146059,6347),(146060,6348),(146061,6348),(146062,6348),(146063,6348),(146064,6348),(146065,6349),(146066,6349),(146067,6349),(146068,6349),(146069,6349),(146070,6350),(146071,6350),(146072,6350),(146073,6350),(146074,6350),(146075,6351),(146076,6351),(146077,6351),(146078,6351),(146079,6351),(146080,6352),(146081,6352),(146082,6352),(146083,6352),(146084,6352),(146085,6353),(146086,6353),(146087,6353),(146088,6353),(146089,6353),(146090,6354),(146091,6354),(146092,6354),(146093,6354),(146094,6354),(146095,6355),(146096,6355),(146097,6355),(146098,6355),(146099,6355),(146100,6356),(146101,6356),(146102,6356),(146103,6356),(146104,6356),(146105,6357),(146106,6358),(146107,6359),(146108,6360),(146109,6361),(146110,6362),(146111,6363),(146112,6364),(146113,6365),(146114,6366),(146115,6367),(146116,6368),(146117,6369),(146118,6370),(146119,6371),(146120,6372),(146121,6373),(146122,6374),(146123,6375),(146124,6376),(146125,6377),(146126,6378),(146127,6379),(146128,6380),(146129,6381),(146130,6382),(146131,6383),(146132,6384),(146133,6385),(146134,6386),(146135,6387),(146136,6388),(146137,6389),(146138,6390),(146139,6391),(146140,6392),(146141,6393),(146142,6394),(146143,6395),(146144,6396),(146145,6397),(146146,6398),(146147,6399),(146148,6400),(146149,6401),(146150,6402),(146151,6403),(146152,6404),(146153,6405),(146154,6406),(146155,6407),(146156,6408),(146157,6409),(146158,6410),(146159,6411),(146160,6412),(146161,6413),(146162,6414),(146163,6415),(146164,6416),(146165,6417),(146166,6418),(146167,6419),(146168,6420),(146169,6421),(146170,6422),(146171,6423),(146172,6424),(146173,6425),(146174,6426),(146175,6427),(146176,6428),(146177,6429),(146178,6430),(146179,6431),(146180,6432),(146181,6433),(146182,6434),(146183,6435),(146184,6436),(146185,6437),(146186,6438),(146187,6439),(146188,6440),(146189,6441),(146190,6442),(146191,6443),(146192,6444),(146193,6445),(146194,6357),(146195,6357),(146196,6357),(146197,6358),(146198,6358),(146199,6358),(146200,6359),(146201,6359),(146202,6359),(146203,6360),(146204,6360),(146205,6360),(146206,6361),(146207,6361),(146208,6361),(146209,6362),(146210,6362),(146211,6362),(146212,6363),(146213,6363),(146214,6363),(146215,6364),(146216,6364),(146217,6364),(146218,6365),(146219,6365),(146220,6365),(146221,6366),(146222,6366),(146223,6366),(146224,6367),(146225,6367),(146226,6367),(146227,6368),(146228,6368),(146229,6368),(146230,6369),(146231,6369),(146232,6369),(146233,6370),(146234,6370),(146235,6370),(146236,6371),(146237,6371),(146238,6371),(146239,6372),(146240,6372),(146241,6372),(146242,6373),(146243,6373),(146244,6373),(146245,6374),(146246,6374),(146247,6374),(146248,6375),(146249,6375),(146250,6375),(146251,6376),(146252,6376),(146253,6376),(146254,6377),(146255,6377),(146256,6377),(146257,6378),(146258,6378),(146259,6378),(146260,6379),(146261,6379),(146262,6379),(146263,6380),(146264,6380),(146265,6380),(146266,6381),(146267,6381),(146268,6381),(146269,6382),(146270,6382),(146271,6382),(146272,6383),(146273,6383),(146274,6383),(146275,6384),(146276,6384),(146277,6384),(146278,6385),(146279,6385),(146280,6385),(146281,6386),(146282,6386),(146283,6386),(146284,6387),(146285,6387),(146286,6387),(146287,6388),(146288,6388),(146289,6388),(146290,6389),(146291,6389),(146292,6389),(146293,6390),(146294,6390),(146295,6390),(146296,6391),(146297,6391),(146298,6391),(146299,6392),(146300,6392),(146301,6392),(146302,6393),(146303,6393),(146304,6393),(146305,6394),(146306,6394),(146307,6394),(146308,6395),(146309,6395),(146310,6395),(146311,6396),(146312,6396),(146313,6396),(146314,6397),(146315,6397),(146316,6397),(146317,6398),(146318,6398),(146319,6398),(146320,6399),(146321,6399),(146322,6399),(146323,6400),(146324,6400),(146325,6400),(146326,6401),(146327,6401),(146328,6401),(146329,6402),(146330,6402),(146331,6402),(146332,6403),(146333,6404),(146334,6404),(146335,6404),(146336,6405),(146337,6405),(146338,6405),(146339,6406),(146340,6406),(146341,6406),(146342,6407),(146343,6407),(146344,6407),(146345,6408),(146346,6408),(146347,6408),(146348,6409),(146349,6409),(146350,6409),(146351,6410),(146352,6410),(146353,6410),(146354,6411),(146355,6411),(146356,6411),(146357,6412),(146358,6412),(146359,6412),(146360,6413),(146361,6413),(146362,6413),(146363,6414),(146364,6414),(146365,6414),(146366,6415),(146367,6415),(146368,6415),(146369,6416),(146370,6416),(146371,6416),(146372,6417),(146373,6417),(146374,6417),(146375,6418),(146376,6418),(146377,6418),(146378,6419),(146379,6419),(146380,6419),(146381,6420),(146382,6420),(146383,6420),(146384,6421),(146385,6421),(146386,6421),(146387,6422),(146388,6422),(146389,6422),(146390,6423),(146391,6423),(146392,6423),(146393,6424),(146394,6424),(146395,6424),(146396,6425),(146397,6425),(146398,6425),(146399,6426),(146400,6426),(146401,6426),(146402,6427),(146403,6427),(146404,6427),(146405,6428),(146406,6428),(146407,6428),(146408,6429),(146409,6429),(146410,6429),(146411,6430),(146412,6430),(146413,6430),(146414,6431),(146415,6431),(146416,6431),(146417,6432),(146418,6432),(146419,6432),(146420,6433),(146421,6433),(146422,6433),(146423,6434),(146424,6434),(146425,6434),(146426,6435),(146427,6435),(146428,6435),(146429,6436),(146430,6436),(146431,6436),(146432,6437),(146433,6437),(146434,6437),(146435,6438),(146436,6438),(146437,6438),(146438,6439),(146439,6439),(146440,6439),(146441,6440),(146442,6440),(146443,6440),(146444,6441),(146445,6441),(146446,6441),(146447,6442),(146448,6442),(146449,6442),(146450,6443),(146451,6443),(146452,6443),(146453,6444),(146454,6444),(146455,6444),(146456,6445),(146457,6445),(146458,6445),(146459,6357),(146460,6357),(146461,6357),(146462,6357),(146463,6357),(146464,6357),(146465,6357),(146466,6357),(146467,6357),(146468,6357),(146469,6358),(146470,6358),(146471,6358),(146472,6358),(146473,6358),(146474,6358),(146475,6358),(146476,6358),(146477,6358),(146478,6358),(146479,6359),(146480,6359),(146481,6359),(146482,6359),(146483,6359),(146484,6359),(146485,6359),(146486,6359),(146487,6359),(146488,6359),(146489,6360),(146490,6360),(146491,6360),(146492,6360),(146493,6360),(146494,6360),(146495,6360),(146496,6360),(146497,6360),(146498,6360),(146499,6361),(146500,6361),(146501,6361),(146502,6361),(146503,6361),(146504,6361),(146505,6361),(146506,6361),(146507,6361),(146508,6361),(146509,6362),(146510,6362),(146511,6362),(146512,6362),(146513,6362),(146514,6362),(146515,6362),(146516,6362),(146517,6362),(146518,6362),(146519,6363),(146520,6363),(146521,6363),(146522,6363),(146523,6363),(146524,6363),(146525,6363),(146526,6363),(146527,6363),(146528,6363),(146529,6364),(146530,6364),(146531,6364),(146532,6364),(146533,6364),(146534,6364),(146535,6364),(146536,6364),(146537,6364),(146538,6364),(146539,6365),(146540,6365),(146541,6365),(146542,6365),(146543,6365),(146544,6365),(146545,6365),(146546,6365),(146547,6365),(146548,6365),(146549,6366),(146550,6366),(146551,6366),(146552,6366),(146553,6366),(146554,6366),(146555,6366),(146556,6366),(146557,6366),(146558,6366),(146559,6367),(146560,6367),(146561,6367),(146562,6367),(146563,6367),(146564,6367),(146565,6367),(146566,6367),(146567,6367),(146568,6367),(146569,6368),(146570,6368),(146571,6368),(146572,6368),(146573,6368),(146574,6368),(146575,6368),(146576,6368),(146577,6368),(146578,6368),(146579,6369),(146580,6369),(146581,6369),(146582,6369),(146583,6369),(146584,6369),(146585,6369),(146586,6369),(146587,6369),(146588,6369),(146589,6370),(146590,6370),(146591,6370),(146592,6370),(146593,6370),(146594,6370),(146595,6370),(146596,6370),(146597,6370),(146598,6370),(146599,6371),(146600,6371),(146601,6371),(146602,6371),(146603,6371),(146604,6371),(146605,6371),(146606,6371),(146607,6371),(146608,6371),(146609,6372),(146610,6372),(146611,6372),(146612,6372),(146613,6372),(146614,6372),(146615,6372),(146616,6372),(146617,6372),(146618,6372),(146619,6373),(146620,6373),(146621,6373),(146622,6373),(146623,6373),(146624,6373),(146625,6373),(146626,6373),(146627,6373),(146628,6373),(146629,6374),(146630,6374),(146631,6374),(146632,6374),(146633,6374),(146634,6374),(146635,6374),(146636,6374),(146637,6374),(146638,6374),(146639,6375),(146640,6375),(146641,6375),(146642,6375),(146643,6375),(146644,6375),(146645,6375),(146646,6375),(146647,6375),(146648,6375),(146649,6376),(146650,6376),(146651,6376),(146652,6376),(146653,6376),(146654,6376),(146655,6376),(146656,6376),(146657,6376),(146658,6376),(146659,6377),(146660,6377),(146661,6377),(146662,6377),(146663,6377),(146664,6377),(146665,6377),(146666,6377),(146667,6377),(146668,6377),(146669,6378),(146670,6378),(146671,6378),(146672,6378),(146673,6378),(146674,6378),(146675,6378),(146676,6378),(146677,6378),(146678,6378),(146679,6379),(146680,6379),(146681,6379),(146682,6379),(146683,6379),(146684,6379),(146685,6379),(146686,6379),(146687,6379),(146688,6379),(146689,6380),(146690,6380),(146691,6380),(146692,6380),(146693,6380),(146694,6380),(146695,6380),(146696,6380),(146697,6380),(146698,6380),(146699,6381),(146700,6381),(146701,6381),(146702,6381),(146703,6381),(146704,6381),(146705,6381),(146706,6381),(146707,6381),(146708,6381),(146709,6382),(146710,6382),(146711,6382),(146712,6382),(146713,6382),(146714,6382),(146715,6382),(146716,6382),(146717,6382),(146718,6382),(146719,6383),(146720,6383),(146721,6383),(146722,6383),(146723,6383),(146724,6383),(146725,6383),(146726,6383),(146727,6383),(146728,6383),(146729,6384),(146730,6384),(146731,6384),(146732,6384),(146733,6384),(146734,6384),(146735,6384),(146736,6384),(146737,6384),(146738,6384),(146739,6385),(146740,6385),(146741,6385),(146742,6385),(146743,6385),(146744,6385),(146745,6385),(146746,6385),(146747,6385),(146748,6385),(146749,6386),(146750,6386),(146751,6386),(146752,6386),(146753,6386),(146754,6386),(146755,6386),(146756,6386),(146757,6386),(146758,6386),(146759,6387),(146760,6387),(146761,6387),(146762,6387),(146763,6387),(146764,6387),(146765,6387),(146766,6387),(146767,6387),(146768,6387),(146769,6388),(146770,6388),(146771,6388),(146772,6388),(146773,6388),(146774,6388),(146775,6388),(146776,6388),(146777,6388),(146778,6388),(146779,6389),(146780,6389),(146781,6389),(146782,6389),(146783,6389),(146784,6389),(146785,6389),(146786,6389),(146787,6389),(146788,6389),(146789,6390),(146790,6390),(146791,6390),(146792,6390),(146793,6390),(146794,6390),(146795,6390),(146796,6390),(146797,6390),(146798,6390),(146799,6391),(146800,6391),(146801,6391),(146802,6391),(146803,6391),(146804,6391),(146805,6391),(146806,6391),(146807,6391),(146808,6391),(146809,6392),(146810,6392),(146811,6392),(146812,6392),(146813,6392),(146814,6392),(146815,6392),(146816,6392),(146817,6392),(146818,6392),(146819,6393),(146820,6393),(146821,6393),(146822,6393),(146823,6393),(146824,6393),(146825,6393),(146826,6393),(146827,6393),(146828,6393),(146829,6394),(146830,6394),(146831,6394),(146832,6394),(146833,6394),(146834,6394),(146835,6394),(146836,6394),(146837,6394),(146838,6394),(146839,6395),(146840,6395),(146841,6395),(146842,6395),(146843,6395),(146844,6395),(146845,6395),(146846,6395),(146847,6395),(146848,6395),(146849,6396),(146850,6396),(146851,6396),(146852,6396),(146853,6396),(146854,6396),(146855,6396),(146856,6396),(146857,6396),(146858,6396),(146859,6396),(146860,6396),(146861,6396),(146862,6396),(146863,6397),(146864,6397),(146865,6397),(146866,6397),(146867,6397),(146868,6397),(146869,6397),(146870,6397),(146871,6397),(146872,6397),(146873,6398),(146874,6398),(146875,6398),(146876,6398),(146877,6398),(146878,6398),(146879,6398),(146880,6398),(146881,6398),(146882,6398),(146883,6399),(146884,6399),(146885,6399),(146886,6399),(146887,6399),(146888,6399),(146889,6399),(146890,6399),(146891,6399),(146892,6399),(146893,6400),(146894,6400),(146895,6400),(146896,6400),(146897,6400),(146898,6400),(146899,6400),(146900,6400),(146901,6400),(146902,6400),(146903,6401),(146904,6401),(146905,6401),(146906,6401),(146907,6401),(146908,6401),(146909,6401),(146910,6401),(146911,6401),(146912,6401),(146913,6402),(146914,6402),(146915,6402),(146916,6402),(146917,6402),(146918,6402),(146919,6402),(146920,6402),(146921,6402),(146922,6402),(146923,6403),(146924,6403),(146925,6403),(146926,6403),(146927,6403),(146928,6403),(146929,6403),(146930,6403),(146931,6404),(146932,6404),(146933,6404),(146934,6404),(146935,6404),(146936,6404),(146937,6404),(146938,6404),(146939,6404),(146940,6404),(146941,6405),(146942,6405),(146943,6405),(146944,6405),(146945,6405),(146946,6405),(146947,6405),(146948,6405),(146949,6405),(146950,6405),(146951,6406),(146952,6406),(146953,6406),(146954,6406),(146955,6406),(146956,6406),(146957,6406),(146958,6406),(146959,6406),(146960,6406),(146961,6407),(146962,6407),(146963,6407),(146964,6407),(146965,6407),(146966,6407),(146967,6407),(146968,6407),(146969,6407),(146970,6407),(146971,6408),(146972,6408),(146973,6408),(146974,6408),(146975,6408),(146976,6408),(146977,6408),(146978,6408),(146979,6408),(146980,6408),(146981,6409),(146982,6409),(146983,6409),(146984,6409),(146985,6409),(146986,6409),(146987,6409),(146988,6409),(146989,6409),(146990,6409),(146991,6410),(146992,6410),(146993,6410),(146994,6410),(146995,6410),(146996,6410),(146997,6410),(146998,6410),(146999,6410),(147000,6410),(147001,6411),(147002,6411),(147003,6411),(147004,6411),(147005,6411),(147006,6411),(147007,6411),(147008,6411),(147009,6411),(147010,6411),(147011,6412),(147012,6412),(147013,6412),(147014,6412),(147015,6412),(147016,6412),(147017,6412),(147018,6412),(147019,6412),(147020,6412),(147021,6413),(147022,6413),(147023,6413),(147024,6413),(147025,6413),(147026,6413),(147027,6413),(147028,6413),(147029,6413),(147030,6413),(147031,6414),(147032,6414),(147033,6414),(147034,6414),(147035,6414),(147036,6414),(147037,6414),(147038,6414),(147039,6414),(147040,6414),(147041,6415),(147042,6415),(147043,6415),(147044,6415),(147045,6415),(147046,6415),(147047,6415),(147048,6415),(147049,6415),(147050,6415),(147051,6416),(147052,6416),(147053,6416),(147054,6416),(147055,6416),(147056,6416),(147057,6416),(147058,6416),(147059,6416),(147060,6416),(147061,6417),(147062,6417),(147063,6417),(147064,6417),(147065,6417),(147066,6417),(147067,6417),(147068,6417),(147069,6417),(147070,6417),(147071,6418),(147072,6418),(147073,6418),(147074,6418),(147075,6418),(147076,6418),(147077,6418),(147078,6418),(147079,6418),(147080,6418),(147081,6419),(147082,6419),(147083,6419),(147084,6419),(147085,6419),(147086,6419),(147087,6419),(147088,6419),(147089,6419),(147090,6419),(147091,6420),(147092,6420),(147093,6420),(147094,6420),(147095,6420),(147096,6420),(147097,6420),(147098,6420),(147099,6420),(147100,6420),(147101,6421),(147102,6421),(147103,6421),(147104,6421),(147105,6421),(147106,6421),(147107,6421),(147108,6421),(147109,6421),(147110,6421),(147111,6422),(147112,6422),(147113,6422),(147114,6422),(147115,6422),(147116,6422),(147117,6422),(147118,6422),(147119,6422),(147120,6422),(147121,6423),(147122,6423),(147123,6423),(147124,6423),(147125,6423),(147126,6423),(147127,6423),(147128,6423),(147129,6423),(147130,6423),(147131,6424),(147132,6424),(147133,6424),(147134,6424),(147135,6424),(147136,6424),(147137,6424),(147138,6424),(147139,6424),(147140,6424),(147141,6425),(147142,6425),(147143,6425),(147144,6425),(147145,6425),(147146,6425),(147147,6425),(147148,6425),(147149,6425),(147150,6425),(147151,6426),(147152,6426),(147153,6426),(147154,6426),(147155,6426),(147156,6426),(147157,6426),(147158,6426),(147159,6426),(147160,6426),(147161,6427),(147162,6427),(147163,6427),(147164,6427),(147165,6427),(147166,6427),(147167,6427),(147168,6427),(147169,6427),(147170,6427),(147171,6428),(147172,6428),(147173,6428),(147174,6428),(147175,6428),(147176,6428),(147177,6428),(147178,6428),(147179,6428),(147180,6428),(147181,6429),(147182,6429),(147183,6429),(147184,6429),(147185,6429),(147186,6429),(147187,6429),(147188,6429),(147189,6429),(147190,6429),(147191,6430),(147192,6430),(147193,6430),(147194,6430),(147195,6430),(147196,6430),(147197,6430),(147198,6430),(147199,6430),(147200,6430),(147201,6431),(147202,6431),(147203,6431),(147204,6431),(147205,6431),(147206,6431),(147207,6431),(147208,6431),(147209,6431),(147210,6431),(147211,6431),(147212,6431),(147213,6431),(147214,6431),(147215,6432),(147216,6432),(147217,6432),(147218,6432),(147219,6432),(147220,6432),(147221,6432),(147222,6432),(147223,6432),(147224,6432),(147225,6433),(147226,6433),(147227,6433),(147228,6433),(147229,6433),(147230,6433),(147231,6433),(147232,6433),(147233,6433),(147234,6433),(147235,6434),(147236,6434),(147237,6434),(147238,6434),(147239,6434),(147240,6434),(147241,6434),(147242,6434),(147243,6434),(147244,6434),(147245,6435),(147246,6435),(147247,6435),(147248,6435),(147249,6435),(147250,6435),(147251,6435),(147252,6435),(147253,6435),(147254,6435),(147255,6436),(147256,6436),(147257,6436),(147258,6436),(147259,6436),(147260,6436),(147261,6436),(147262,6436),(147263,6436),(147264,6436),(147265,6437),(147266,6437),(147267,6437),(147268,6437),(147269,6437),(147270,6437),(147271,6437),(147272,6437),(147273,6437),(147274,6437),(147275,6437),(147276,6437),(147277,6437),(147278,6437),(147279,6438),(147280,6438),(147281,6438),(147282,6438),(147283,6438),(147284,6438),(147285,6438),(147286,6438),(147287,6438),(147288,6438),(147289,6439),(147290,6439),(147291,6439),(147292,6439),(147293,6439),(147294,6439),(147295,6439),(147296,6439),(147297,6439),(147298,6439),(147299,6440),(147300,6440),(147301,6440),(147302,6440),(147303,6440),(147304,6440),(147305,6440),(147306,6440),(147307,6440),(147308,6440),(147309,6440),(147310,6440),(147311,6440),(147312,6440),(147313,6441),(147314,6441),(147315,6441),(147316,6441),(147317,6441),(147318,6441),(147319,6441),(147320,6441),(147321,6441),(147322,6441),(147323,6441),(147324,6441),(147325,6441),(147326,6441),(147327,6442),(147328,6442),(147329,6442),(147330,6442),(147331,6442),(147332,6442),(147333,6442),(147334,6442),(147335,6442),(147336,6442),(147337,6442),(147338,6442),(147339,6442),(147340,6442),(147341,6443),(147342,6443),(147343,6443),(147344,6443),(147345,6443),(147346,6443),(147347,6443),(147348,6443),(147349,6443),(147350,6443),(147351,6444),(147352,6444),(147353,6444),(147354,6444),(147355,6444),(147356,6444),(147357,6444),(147358,6444),(147359,6444),(147360,6444),(147361,6444),(147362,6444),(147363,6444),(147364,6444),(147365,6445),(147366,6445),(147367,6445),(147368,6445),(147369,6445),(147370,6445),(147371,6445),(147372,6445),(147373,6445),(147374,6445),(147375,6445),(147376,6445),(147377,6445),(147378,6445),(147379,6357),(147380,6357),(147381,6357),(147382,6357),(147383,6357),(147384,6358),(147385,6358),(147386,6358),(147387,6358),(147388,6358),(147389,6359),(147390,6359),(147391,6359),(147392,6359),(147393,6359),(147394,6360),(147395,6360),(147396,6360),(147397,6360),(147398,6360),(147399,6361),(147400,6361),(147401,6361),(147402,6361),(147403,6361),(147404,6362),(147405,6362),(147406,6362),(147407,6362),(147408,6362),(147409,6363),(147410,6363),(147411,6363),(147412,6363),(147413,6363),(147414,6364),(147415,6364),(147416,6364),(147417,6364),(147418,6364),(147419,6365),(147420,6365),(147421,6365),(147422,6365),(147423,6365),(147424,6366),(147425,6366),(147426,6366),(147427,6366),(147428,6366),(147429,6367),(147430,6367),(147431,6367),(147432,6367),(147433,6367),(147434,6368),(147435,6368),(147436,6368),(147437,6368),(147438,6368),(147439,6369),(147440,6369),(147441,6369),(147442,6369),(147443,6369),(147444,6370),(147445,6370),(147446,6370),(147447,6370),(147448,6370),(147449,6371),(147450,6371),(147451,6371),(147452,6371),(147453,6371),(147454,6372),(147455,6372),(147456,6372),(147457,6372),(147458,6372),(147459,6373),(147460,6373),(147461,6373),(147462,6373),(147463,6373),(147464,6374),(147465,6374),(147466,6374),(147467,6374),(147468,6374),(147469,6375),(147470,6375),(147471,6375),(147472,6375),(147473,6375),(147474,6376),(147475,6376),(147476,6376),(147477,6376),(147478,6376),(147479,6377),(147480,6377),(147481,6377),(147482,6377),(147483,6377),(147484,6378),(147485,6378),(147486,6378),(147487,6378),(147488,6378),(147489,6379),(147490,6379),(147491,6379),(147492,6379),(147493,6379),(147494,6380),(147495,6380),(147496,6380),(147497,6380),(147498,6380),(147499,6381),(147500,6381),(147501,6381),(147502,6381),(147503,6381),(147504,6382),(147505,6382),(147506,6382),(147507,6382),(147508,6382),(147509,6383),(147510,6383),(147511,6383),(147512,6383),(147513,6383),(147514,6384),(147515,6384),(147516,6384),(147517,6384),(147518,6384),(147519,6384),(147520,6384),(147521,6385),(147522,6385),(147523,6385),(147524,6385),(147525,6385),(147526,6385),(147527,6385),(147528,6386),(147529,6386),(147530,6386),(147531,6386),(147532,6386),(147533,6386),(147534,6386),(147535,6387),(147536,6387),(147537,6387),(147538,6387),(147539,6387),(147540,6387),(147541,6387),(147542,6388),(147543,6388),(147544,6388),(147545,6388),(147546,6388),(147547,6389),(147548,6389),(147549,6389),(147550,6389),(147551,6389),(147552,6390),(147553,6390),(147554,6390),(147555,6390),(147556,6390),(147557,6391),(147558,6391),(147559,6391),(147560,6391),(147561,6391),(147562,6392),(147563,6392),(147564,6392),(147565,6392),(147566,6392),(147567,6392),(147568,6392),(147569,6393),(147570,6393),(147571,6393),(147572,6393),(147573,6393),(147574,6393),(147575,6393),(147576,6394),(147577,6394),(147578,6394),(147579,6394),(147580,6394),(147581,6394),(147582,6394),(147583,6395),(147584,6395),(147585,6395),(147586,6395),(147587,6395),(147588,6395),(147589,6395),(147590,6396),(147591,6396),(147592,6396),(147593,6396),(147594,6396),(147595,6396),(147596,6396),(147597,6397),(147598,6397),(147599,6397),(147600,6397),(147601,6397),(147602,6397),(147603,6397),(147604,6398),(147605,6398),(147606,6398),(147607,6398),(147608,6398),(147609,6398),(147610,6398),(147611,6399),(147612,6399),(147613,6399),(147614,6399),(147615,6399),(147616,6399),(147617,6399),(147618,6400),(147619,6400),(147620,6400),(147621,6400),(147622,6400),(147623,6400),(147624,6400),(147625,6401),(147626,6401),(147627,6401),(147628,6401),(147629,6401),(147630,6401),(147631,6401),(147632,6402),(147633,6402),(147634,6402),(147635,6402),(147636,6402),(147637,6402),(147638,6402),(147639,6403),(147640,6403),(147641,6403),(147642,6403),(147643,6404),(147644,6404),(147645,6404),(147646,6404),(147647,6404),(147648,6405),(147649,6405),(147650,6405),(147651,6405),(147652,6405),(147653,6405),(147654,6405),(147655,6406),(147656,6406),(147657,6406),(147658,6406),(147659,6406),(147660,6406),(147661,6406),(147662,6407),(147663,6407),(147664,6407),(147665,6407),(147666,6407),(147667,6407),(147668,6407),(147669,6408),(147670,6408),(147671,6408),(147672,6408),(147673,6408),(147674,6408),(147675,6408),(147676,6409),(147677,6409),(147678,6409),(147679,6409),(147680,6409),(147681,6409),(147682,6409),(147683,6410),(147684,6410),(147685,6410),(147686,6410),(147687,6410),(147688,6410),(147689,6410),(147690,6411),(147691,6411),(147692,6411),(147693,6411),(147694,6411),(147695,6411),(147696,6411),(147697,6412),(147698,6412),(147699,6412),(147700,6412),(147701,6412),(147702,6412),(147703,6412),(147704,6413),(147705,6413),(147706,6413),(147707,6413),(147708,6413),(147709,6413),(147710,6413),(147711,6414),(147712,6414),(147713,6414),(147714,6414),(147715,6414),(147716,6414),(147717,6414),(147718,6415),(147719,6415),(147720,6415),(147721,6415),(147722,6415),(147723,6415),(147724,6415),(147725,6416),(147726,6416),(147727,6416),(147728,6416),(147729,6416),(147730,6416),(147731,6416),(147732,6417),(147733,6417),(147734,6417),(147735,6417),(147736,6417),(147737,6417),(147738,6417),(147739,6418),(147740,6418),(147741,6418),(147742,6418),(147743,6418),(147744,6418),(147745,6418),(147746,6419),(147747,6419),(147748,6419),(147749,6419),(147750,6419),(147751,6419),(147752,6419),(147753,6420),(147754,6420),(147755,6420),(147756,6420),(147757,6420),(147758,6420),(147759,6420),(147760,6421),(147761,6421),(147762,6421),(147763,6421),(147764,6421),(147765,6421),(147766,6421),(147767,6422),(147768,6422),(147769,6422),(147770,6422),(147771,6422),(147772,6422),(147773,6422),(147774,6423),(147775,6423),(147776,6423),(147777,6423),(147778,6423),(147779,6423),(147780,6423),(147781,6424),(147782,6424),(147783,6424),(147784,6424),(147785,6424),(147786,6424),(147787,6424),(147788,6425),(147789,6425),(147790,6425),(147791,6425),(147792,6425),(147793,6425),(147794,6425),(147795,6426),(147796,6426),(147797,6426),(147798,6426),(147799,6426),(147800,6426),(147801,6426),(147802,6427),(147803,6427),(147804,6427),(147805,6427),(147806,6427),(147807,6427),(147808,6427),(147809,6428),(147810,6428),(147811,6428),(147812,6428),(147813,6428),(147814,6428),(147815,6428),(147816,6429),(147817,6429),(147818,6429),(147819,6429),(147820,6429),(147821,6429),(147822,6429),(147823,6430),(147824,6430),(147825,6430),(147826,6430),(147827,6430),(147828,6430),(147829,6430),(147830,6431),(147831,6431),(147832,6431),(147833,6431),(147834,6431),(147835,6431),(147836,6431),(147837,6432),(147838,6432),(147839,6432),(147840,6432),(147841,6432),(147842,6432),(147843,6432),(147844,6433),(147845,6433),(147846,6433),(147847,6433),(147848,6433),(147849,6433),(147850,6433),(147851,6434),(147852,6434),(147853,6434),(147854,6434),(147855,6434),(147856,6434),(147857,6434),(147858,6435),(147859,6435),(147860,6435),(147861,6435),(147862,6435),(147863,6435),(147864,6435),(147865,6436),(147866,6436),(147867,6436),(147868,6436),(147869,6436),(147870,6436),(147871,6436),(147872,6437),(147873,6437),(147874,6437),(147875,6437),(147876,6437),(147877,6437),(147878,6437),(147879,6438),(147880,6438),(147881,6438),(147882,6438),(147883,6438),(147884,6438),(147885,6438),(147886,6439),(147887,6439),(147888,6439),(147889,6439),(147890,6439),(147891,6439),(147892,6439),(147893,6440),(147894,6440),(147895,6440),(147896,6440),(147897,6440),(147898,6440),(147899,6440),(147900,6441),(147901,6441),(147902,6441),(147903,6441),(147904,6441),(147905,6441),(147906,6441),(147907,6442),(147908,6442),(147909,6442),(147910,6442),(147911,6442),(147912,6442),(147913,6442),(147914,6443),(147915,6443),(147916,6443),(147917,6443),(147918,6443),(147919,6443),(147920,6443),(147921,6444),(147922,6444),(147923,6444),(147924,6444),(147925,6444),(147926,6444),(147927,6444),(147928,6445),(147929,6445),(147930,6445),(147931,6445),(147932,6445),(147933,6445),(147934,6445),(147935,6357),(147936,6357),(147937,6357),(147938,6357),(147939,6357),(147940,6358),(147941,6358),(147942,6358),(147943,6358),(147944,6358),(147945,6359),(147946,6359),(147947,6359),(147948,6359),(147949,6359),(147950,6360),(147951,6360),(147952,6360),(147953,6360),(147954,6360),(147955,6361),(147956,6361),(147957,6361),(147958,6361),(147959,6361),(147960,6362),(147961,6362),(147962,6362),(147963,6362),(147964,6362),(147965,6363),(147966,6363),(147967,6363),(147968,6363),(147969,6363),(147970,6364),(147971,6364),(147972,6364),(147973,6364),(147974,6364),(147975,6365),(147976,6365),(147977,6365),(147978,6365),(147979,6365),(147980,6366),(147981,6366),(147982,6366),(147983,6366),(147984,6366),(147985,6367),(147986,6367),(147987,6367),(147988,6367),(147989,6367),(147990,6368),(147991,6368),(147992,6368),(147993,6368),(147994,6368),(147995,6369),(147996,6369),(147997,6369),(147998,6369),(147999,6369),(148000,6370),(148001,6370),(148002,6370),(148003,6370),(148004,6370),(148005,6371),(148006,6371),(148007,6371),(148008,6371),(148009,6371),(148010,6372),(148011,6372),(148012,6372),(148013,6372),(148014,6372),(148015,6373),(148016,6373),(148017,6373),(148018,6373),(148019,6373),(148020,6374),(148021,6374),(148022,6374),(148023,6374),(148024,6374),(148025,6375),(148026,6375),(148027,6375),(148028,6375),(148029,6375),(148030,6376),(148031,6376),(148032,6376),(148033,6376),(148034,6376),(148035,6377),(148036,6377),(148037,6377),(148038,6377),(148039,6377),(148040,6378),(148041,6378),(148042,6378),(148043,6378),(148044,6378),(148045,6379),(148046,6379),(148047,6379),(148048,6379),(148049,6379),(148050,6380),(148051,6380),(148052,6380),(148053,6380),(148054,6380),(148055,6381),(148056,6381),(148057,6381),(148058,6381),(148059,6381),(148060,6382),(148061,6382),(148062,6382),(148063,6382),(148064,6382),(148065,6383),(148066,6383),(148067,6383),(148068,6383),(148069,6383),(148070,6384),(148071,6384),(148072,6384),(148073,6384),(148074,6384),(148075,6385),(148076,6385),(148077,6385),(148078,6385),(148079,6385),(148080,6386),(148081,6386),(148082,6386),(148083,6386),(148084,6386),(148085,6387),(148086,6387),(148087,6387),(148088,6387),(148089,6387),(148090,6388),(148091,6388),(148092,6388),(148093,6388),(148094,6388),(148095,6389),(148096,6389),(148097,6389),(148098,6389),(148099,6389),(148100,6390),(148101,6390),(148102,6390),(148103,6390),(148104,6390),(148105,6391),(148106,6391),(148107,6391),(148108,6391),(148109,6391),(148110,6392),(148111,6392),(148112,6392),(148113,6392),(148114,6392),(148115,6393),(148116,6393),(148117,6393),(148118,6393),(148119,6393),(148120,6394),(148121,6394),(148122,6394),(148123,6394),(148124,6394),(148125,6395),(148126,6395),(148127,6395),(148128,6395),(148129,6395),(148130,6396),(148131,6396),(148132,6396),(148133,6396),(148134,6396),(148135,6397),(148136,6397),(148137,6397),(148138,6397),(148139,6397),(148140,6398),(148141,6398),(148142,6398),(148143,6398),(148144,6398),(148145,6399),(148146,6399),(148147,6399),(148148,6399),(148149,6399),(148150,6400),(148151,6400),(148152,6400),(148153,6400),(148154,6400),(148155,6401),(148156,6401),(148157,6401),(148158,6401),(148159,6401),(148160,6402),(148161,6402),(148162,6402),(148163,6402),(148164,6402),(148165,6403),(148166,6403),(148167,6403),(148168,6403),(148169,6403),(148170,6404),(148171,6404),(148172,6404),(148173,6404),(148174,6404),(148175,6405),(148176,6405),(148177,6405),(148178,6405),(148179,6405),(148180,6406),(148181,6406),(148182,6406),(148183,6406),(148184,6406),(148185,6407),(148186,6407),(148187,6407),(148188,6407),(148189,6407),(148190,6408),(148191,6408),(148192,6408),(148193,6408),(148194,6408),(148195,6409),(148196,6409),(148197,6409),(148198,6409),(148199,6409),(148200,6410),(148201,6410),(148202,6410),(148203,6410),(148204,6410),(148205,6411),(148206,6411),(148207,6411),(148208,6411),(148209,6411),(148210,6412),(148211,6412),(148212,6412),(148213,6412),(148214,6412),(148215,6413),(148216,6413),(148217,6413),(148218,6413),(148219,6413),(148220,6414),(148221,6414),(148222,6414),(148223,6414),(148224,6414),(148225,6415),(148226,6415),(148227,6415),(148228,6415),(148229,6415),(148230,6416),(148231,6416),(148232,6416),(148233,6416),(148234,6416),(148235,6417),(148236,6417),(148237,6417),(148238,6417),(148239,6417),(148240,6418),(148241,6418),(148242,6418),(148243,6418),(148244,6418),(148245,6419),(148246,6419),(148247,6419),(148248,6419),(148249,6419),(148250,6420),(148251,6420),(148252,6420),(148253,6420),(148254,6420),(148255,6421),(148256,6421),(148257,6421),(148258,6421),(148259,6421),(148260,6422),(148261,6422),(148262,6422),(148263,6422),(148264,6422),(148265,6423),(148266,6423),(148267,6423),(148268,6423),(148269,6423),(148270,6424),(148271,6424),(148272,6424),(148273,6424),(148274,6424),(148275,6425),(148276,6425),(148277,6425),(148278,6425),(148279,6425),(148280,6426),(148281,6426),(148282,6426),(148283,6426),(148284,6426),(148285,6427),(148286,6427),(148287,6427),(148288,6427),(148289,6427),(148290,6428),(148291,6428),(148292,6428),(148293,6428),(148294,6428),(148295,6429),(148296,6429),(148297,6429),(148298,6429),(148299,6429),(148300,6430),(148301,6430),(148302,6430),(148303,6430),(148304,6430),(148305,6431),(148306,6431),(148307,6431),(148308,6431),(148309,6431),(148310,6432),(148311,6432),(148312,6432),(148313,6432),(148314,6432),(148315,6433),(148316,6433),(148317,6433),(148318,6433),(148319,6433),(148320,6434),(148321,6434),(148322,6434),(148323,6434),(148324,6434),(148325,6435),(148326,6435),(148327,6435),(148328,6435),(148329,6435),(148330,6436),(148331,6436),(148332,6436),(148333,6436),(148334,6436),(148335,6437),(148336,6437),(148337,6437),(148338,6437),(148339,6437),(148340,6438),(148341,6438),(148342,6438),(148343,6438),(148344,6438),(148345,6439),(148346,6439),(148347,6439),(148348,6439),(148349,6439),(148350,6440),(148351,6440),(148352,6440),(148353,6440),(148354,6440),(148355,6441),(148356,6441),(148357,6441),(148358,6441),(148359,6441),(148360,6442),(148361,6442),(148362,6442),(148363,6442),(148364,6442),(148365,6443),(148366,6443),(148367,6443),(148368,6443),(148369,6443),(148370,6444),(148371,6444),(148372,6444),(148373,6444),(148374,6444),(148375,6445),(148376,6445),(148377,6445),(148378,6445),(148379,6445),(148380,6446),(148381,6447),(148382,6448),(148383,6449),(148384,6450),(148385,6451),(148386,6452),(148387,6453),(148388,6454),(148389,6455),(148390,6456),(148391,6457),(148392,6458),(148393,6459),(148394,6460),(148395,6461),(148396,6462),(148397,6463),(148398,6464),(148399,6465),(148400,6466),(148401,6467),(148402,6468),(148403,6469),(148404,6470),(148405,6471),(148406,6472),(148407,6473),(148408,6474),(148409,6475),(148410,6476),(148411,6477),(148412,6478),(148413,6479),(148414,6480),(148415,6481),(148416,6482),(148417,6483),(148418,6484),(148419,6485),(148420,6486),(148421,6487),(148422,6488),(148423,6489),(148424,6490),(148425,6491),(148426,6492),(148427,6493),(148428,6494),(148429,6495),(148430,6496),(148431,6497),(148432,6498),(148433,6499),(148434,6500),(148435,6501),(148436,6502),(148437,6503),(148438,6504),(148439,6505),(148440,6506),(148441,6507),(148442,6508),(148443,6509),(148444,6510),(148445,6511),(148446,6512),(148447,6513),(148448,6514),(148449,6515),(148450,6516),(148451,6517),(148452,6518),(148453,6519),(148454,6520),(148455,6521),(148456,6522),(148457,6523),(148458,6524),(148459,6525),(148460,6526),(148461,6527),(148462,6528),(148463,6529),(148464,6530),(148465,6531),(148466,6532),(148467,6533),(148468,6534),(148469,6535),(148470,6536),(148471,6537),(148472,6538),(148473,6539),(148474,6540),(148475,6541),(148476,6542),(148477,6543),(148478,6544),(148479,6545),(148480,6446),(148481,6446),(148482,6446),(148483,6447),(148484,6447),(148485,6447),(148486,6448),(148487,6448),(148488,6448),(148489,6449),(148490,6449),(148491,6449),(148492,6450),(148493,6450),(148494,6450),(148495,6451),(148496,6451),(148497,6451),(148498,6452),(148499,6452),(148500,6452),(148501,6453),(148502,6453),(148503,6453),(148504,6454),(148505,6454),(148506,6454),(148507,6455),(148508,6455),(148509,6455),(148510,6456),(148511,6456),(148512,6456),(148513,6457),(148514,6457),(148515,6457),(148516,6458),(148517,6458),(148518,6458),(148519,6459),(148520,6459),(148521,6459),(148522,6460),(148523,6460),(148524,6460),(148525,6461),(148526,6461),(148527,6461),(148528,6462),(148529,6462),(148530,6462),(148531,6463),(148532,6463),(148533,6463),(148534,6464),(148535,6464),(148536,6464),(148537,6465),(148538,6465),(148539,6465),(148540,6466),(148541,6466),(148542,6466),(148543,6467),(148544,6467),(148545,6467),(148546,6468),(148547,6468),(148548,6468),(148549,6469),(148550,6469),(148551,6469),(148552,6470),(148553,6470),(148554,6470),(148555,6471),(148556,6471),(148557,6471),(148558,6472),(148559,6472),(148560,6472),(148561,6473),(148562,6473),(148563,6473),(148564,6474),(148565,6474),(148566,6474),(148567,6475),(148568,6475),(148569,6475),(148570,6476),(148571,6476),(148572,6476),(148573,6477),(148574,6477),(148575,6477),(148576,6478),(148577,6478),(148578,6478),(148579,6479),(148580,6479),(148581,6479),(148582,6480),(148583,6480),(148584,6480),(148585,6481),(148586,6481),(148587,6481),(148588,6482),(148589,6482),(148590,6482),(148591,6483),(148592,6483),(148593,6483),(148594,6484),(148595,6484),(148596,6484),(148597,6485),(148598,6485),(148599,6485),(148600,6486),(148601,6486),(148602,6486),(148603,6487),(148604,6487),(148605,6487),(148606,6488),(148607,6488),(148608,6488),(148609,6489),(148610,6489),(148611,6489),(148612,6490),(148613,6490),(148614,6490),(148615,6491),(148616,6491),(148617,6491),(148618,6492),(148619,6492),(148620,6492),(148621,6493),(148622,6493),(148623,6493),(148624,6494),(148625,6494),(148626,6494),(148627,6495),(148628,6495),(148629,6495),(148630,6496),(148631,6496),(148632,6496),(148633,6497),(148634,6497),(148635,6497),(148636,6498),(148637,6498),(148638,6498),(148639,6499),(148640,6499),(148641,6499),(148642,6500),(148643,6500),(148644,6500),(148645,6501),(148646,6501),(148647,6501),(148648,6502),(148649,6502),(148650,6502),(148651,6503),(148652,6503),(148653,6503),(148654,6504),(148655,6504),(148656,6504),(148657,6505),(148658,6505),(148659,6505),(148660,6506),(148661,6506),(148662,6506),(148663,6507),(148664,6507),(148665,6507),(148666,6508),(148667,6508),(148668,6508),(148669,6509),(148670,6509),(148671,6509),(148672,6510),(148673,6510),(148674,6510),(148675,6511),(148676,6511),(148677,6511),(148678,6512),(148679,6512),(148680,6512),(148681,6513),(148682,6513),(148683,6513),(148684,6514),(148685,6514),(148686,6514),(148687,6515),(148688,6515),(148689,6515),(148690,6516),(148691,6516),(148692,6516),(148693,6517),(148694,6517),(148695,6517),(148696,6518),(148697,6518),(148698,6518),(148699,6519),(148700,6519),(148701,6519),(148702,6520),(148703,6520),(148704,6520),(148705,6521),(148706,6521),(148707,6521),(148708,6522),(148709,6522),(148710,6522),(148711,6523),(148712,6523),(148713,6523),(148714,6524),(148715,6524),(148716,6524),(148717,6525),(148718,6525),(148719,6525),(148720,6526),(148721,6526),(148722,6526),(148723,6527),(148724,6527),(148725,6527),(148726,6528),(148727,6528),(148728,6528),(148729,6529),(148730,6529),(148731,6529),(148732,6530),(148733,6530),(148734,6530),(148735,6531),(148736,6531),(148737,6531),(148738,6532),(148739,6532),(148740,6532),(148741,6533),(148742,6533),(148743,6533),(148744,6534),(148745,6534),(148746,6534),(148747,6535),(148748,6535),(148749,6535),(148750,6536),(148751,6536),(148752,6536),(148753,6537),(148754,6537),(148755,6537),(148756,6538),(148757,6538),(148758,6538),(148759,6539),(148760,6539),(148761,6539),(148762,6540),(148763,6540),(148764,6540),(148765,6541),(148766,6541),(148767,6541),(148768,6542),(148769,6542),(148770,6542),(148771,6543);
INSERT INTO `catalogrule_product_cl` VALUES (148772,6543),(148773,6543),(148774,6544),(148775,6544),(148776,6544),(148777,6545),(148778,6545),(148779,6545),(148780,6446),(148781,6446),(148782,6446),(148783,6446),(148784,6446),(148785,6446),(148786,6446),(148787,6446),(148788,6446),(148789,6446),(148790,6446),(148791,6446),(148792,6446),(148793,6446),(148794,6447),(148795,6447),(148796,6447),(148797,6447),(148798,6447),(148799,6447),(148800,6447),(148801,6447),(148802,6447),(148803,6447),(148804,6448),(148805,6448),(148806,6448),(148807,6448),(148808,6448),(148809,6448),(148810,6448),(148811,6448),(148812,6448),(148813,6448),(148814,6449),(148815,6449),(148816,6449),(148817,6449),(148818,6449),(148819,6449),(148820,6449),(148821,6449),(148822,6449),(148823,6449),(148824,6449),(148825,6449),(148826,6449),(148827,6449),(148828,6450),(148829,6450),(148830,6450),(148831,6450),(148832,6450),(148833,6450),(148834,6450),(148835,6450),(148836,6450),(148837,6450),(148838,6450),(148839,6450),(148840,6450),(148841,6450),(148842,6451),(148843,6451),(148844,6451),(148845,6451),(148846,6451),(148847,6451),(148848,6451),(148849,6451),(148850,6451),(148851,6451),(148852,6452),(148853,6452),(148854,6452),(148855,6452),(148856,6452),(148857,6452),(148858,6452),(148859,6452),(148860,6452),(148861,6452),(148862,6452),(148863,6452),(148864,6452),(148865,6452),(148866,6453),(148867,6453),(148868,6453),(148869,6453),(148870,6453),(148871,6453),(148872,6453),(148873,6453),(148874,6453),(148875,6453),(148876,6454),(148877,6454),(148878,6454),(148879,6454),(148880,6454),(148881,6454),(148882,6454),(148883,6454),(148884,6454),(148885,6454),(148886,6455),(148887,6455),(148888,6455),(148889,6455),(148890,6455),(148891,6455),(148892,6455),(148893,6455),(148894,6455),(148895,6455),(148896,6456),(148897,6456),(148898,6456),(148899,6456),(148900,6456),(148901,6456),(148902,6456),(148903,6456),(148904,6456),(148905,6456),(148906,6457),(148907,6457),(148908,6457),(148909,6457),(148910,6457),(148911,6457),(148912,6457),(148913,6457),(148914,6457),(148915,6457),(148916,6458),(148917,6458),(148918,6458),(148919,6458),(148920,6458),(148921,6458),(148922,6458),(148923,6458),(148924,6458),(148925,6458),(148926,6459),(148927,6459),(148928,6459),(148929,6459),(148930,6459),(148931,6459),(148932,6459),(148933,6459),(148934,6459),(148935,6459),(148936,6460),(148937,6460),(148938,6460),(148939,6460),(148940,6460),(148941,6460),(148942,6460),(148943,6460),(148944,6460),(148945,6460),(148946,6461),(148947,6461),(148948,6461),(148949,6461),(148950,6461),(148951,6461),(148952,6461),(148953,6461),(148954,6461),(148955,6461),(148956,6462),(148957,6462),(148958,6462),(148959,6462),(148960,6462),(148961,6462),(148962,6462),(148963,6462),(148964,6462),(148965,6462),(148966,6463),(148967,6463),(148968,6463),(148969,6463),(148970,6463),(148971,6463),(148972,6463),(148973,6463),(148974,6463),(148975,6463),(148976,6463),(148977,6463),(148978,6463),(148979,6463),(148980,6464),(148981,6464),(148982,6464),(148983,6464),(148984,6464),(148985,6464),(148986,6464),(148987,6464),(148988,6464),(148989,6464),(148990,6464),(148991,6464),(148992,6464),(148993,6464),(148994,6465),(148995,6465),(148996,6465),(148997,6465),(148998,6465),(148999,6465),(149000,6465),(149001,6465),(149002,6465),(149003,6465),(149004,6466),(149005,6466),(149006,6466),(149007,6466),(149008,6466),(149009,6466),(149010,6466),(149011,6466),(149012,6466),(149013,6466),(149014,6467),(149015,6467),(149016,6467),(149017,6467),(149018,6467),(149019,6467),(149020,6467),(149021,6467),(149022,6467),(149023,6467),(149024,6468),(149025,6468),(149026,6468),(149027,6468),(149028,6468),(149029,6468),(149030,6468),(149031,6468),(149032,6468),(149033,6468),(149034,6469),(149035,6469),(149036,6469),(149037,6469),(149038,6469),(149039,6469),(149040,6469),(149041,6469),(149042,6469),(149043,6469),(149044,6470),(149045,6470),(149046,6470),(149047,6470),(149048,6470),(149049,6470),(149050,6470),(149051,6470),(149052,6470),(149053,6470),(149054,6471),(149055,6471),(149056,6471),(149057,6471),(149058,6471),(149059,6471),(149060,6471),(149061,6471),(149062,6471),(149063,6471),(149064,6471),(149065,6471),(149066,6471),(149067,6471),(149068,6472),(149069,6472),(149070,6472),(149071,6472),(149072,6472),(149073,6472),(149074,6472),(149075,6472),(149076,6472),(149077,6472),(149078,6472),(149079,6472),(149080,6472),(149081,6472),(149082,6473),(149083,6473),(149084,6473),(149085,6473),(149086,6473),(149087,6473),(149088,6473),(149089,6473),(149090,6473),(149091,6473),(149092,6473),(149093,6473),(149094,6473),(149095,6473),(149096,6474),(149097,6474),(149098,6474),(149099,6474),(149100,6474),(149101,6474),(149102,6474),(149103,6474),(149104,6474),(149105,6474),(149106,6474),(149107,6474),(149108,6474),(149109,6474),(149110,6475),(149111,6475),(149112,6475),(149113,6475),(149114,6475),(149115,6475),(149116,6475),(149117,6475),(149118,6475),(149119,6475),(149120,6475),(149121,6475),(149122,6475),(149123,6475),(149124,6476),(149125,6476),(149126,6476),(149127,6476),(149128,6476),(149129,6476),(149130,6476),(149131,6476),(149132,6476),(149133,6476),(149134,6476),(149135,6476),(149136,6476),(149137,6476),(149138,6477),(149139,6477),(149140,6477),(149141,6477),(149142,6477),(149143,6477),(149144,6477),(149145,6477),(149146,6477),(149147,6477),(149148,6477),(149149,6477),(149150,6477),(149151,6477),(149152,6478),(149153,6478),(149154,6478),(149155,6478),(149156,6478),(149157,6478),(149158,6478),(149159,6478),(149160,6478),(149161,6478),(149162,6478),(149163,6478),(149164,6478),(149165,6478),(149166,6479),(149167,6479),(149168,6479),(149169,6479),(149170,6479),(149171,6479),(149172,6479),(149173,6479),(149174,6479),(149175,6479),(149176,6479),(149177,6479),(149178,6479),(149179,6479),(149180,6480),(149181,6480),(149182,6480),(149183,6480),(149184,6480),(149185,6480),(149186,6480),(149187,6480),(149188,6480),(149189,6480),(149190,6480),(149191,6480),(149192,6480),(149193,6480),(149194,6481),(149195,6481),(149196,6481),(149197,6481),(149198,6481),(149199,6481),(149200,6481),(149201,6481),(149202,6481),(149203,6481),(149204,6481),(149205,6481),(149206,6481),(149207,6481),(149208,6482),(149209,6482),(149210,6482),(149211,6482),(149212,6482),(149213,6482),(149214,6482),(149215,6482),(149216,6482),(149217,6482),(149218,6482),(149219,6482),(149220,6482),(149221,6482),(149222,6483),(149223,6483),(149224,6483),(149225,6483),(149226,6483),(149227,6483),(149228,6483),(149229,6483),(149230,6483),(149231,6483),(149232,6484),(149233,6484),(149234,6484),(149235,6484),(149236,6484),(149237,6484),(149238,6484),(149239,6484),(149240,6484),(149241,6484),(149242,6485),(149243,6485),(149244,6485),(149245,6485),(149246,6485),(149247,6485),(149248,6485),(149249,6485),(149250,6486),(149251,6486),(149252,6486),(149253,6486),(149254,6486),(149255,6486),(149256,6486),(149257,6486),(149258,6487),(149259,6487),(149260,6487),(149261,6487),(149262,6487),(149263,6487),(149264,6487),(149265,6487),(149266,6488),(149267,6488),(149268,6488),(149269,6488),(149270,6488),(149271,6488),(149272,6488),(149273,6488),(149274,6489),(149275,6489),(149276,6489),(149277,6489),(149278,6489),(149279,6489),(149280,6489),(149281,6489),(149282,6490),(149283,6490),(149284,6490),(149285,6490),(149286,6490),(149287,6490),(149288,6490),(149289,6490),(149290,6491),(149291,6491),(149292,6491),(149293,6491),(149294,6491),(149295,6491),(149296,6491),(149297,6491),(149298,6492),(149299,6492),(149300,6492),(149301,6492),(149302,6492),(149303,6492),(149304,6492),(149305,6492),(149306,6492),(149307,6492),(149308,6493),(149309,6493),(149310,6493),(149311,6493),(149312,6493),(149313,6493),(149314,6493),(149315,6493),(149316,6493),(149317,6493),(149318,6494),(149319,6494),(149320,6494),(149321,6494),(149322,6494),(149323,6494),(149324,6494),(149325,6494),(149326,6494),(149327,6494),(149328,6495),(149329,6495),(149330,6495),(149331,6495),(149332,6495),(149333,6495),(149334,6495),(149335,6495),(149336,6495),(149337,6495),(149338,6496),(149339,6496),(149340,6496),(149341,6496),(149342,6496),(149343,6496),(149344,6496),(149345,6496),(149346,6496),(149347,6496),(149348,6497),(149349,6497),(149350,6497),(149351,6497),(149352,6497),(149353,6497),(149354,6497),(149355,6497),(149356,6497),(149357,6497),(149358,6498),(149359,6498),(149360,6498),(149361,6498),(149362,6498),(149363,6498),(149364,6498),(149365,6498),(149366,6498),(149367,6498),(149368,6499),(149369,6499),(149370,6499),(149371,6499),(149372,6499),(149373,6499),(149374,6499),(149375,6499),(149376,6499),(149377,6499),(149378,6500),(149379,6500),(149380,6500),(149381,6500),(149382,6500),(149383,6500),(149384,6500),(149385,6500),(149386,6500),(149387,6500),(149388,6501),(149389,6501),(149390,6501),(149391,6501),(149392,6501),(149393,6501),(149394,6501),(149395,6501),(149396,6501),(149397,6501),(149398,6502),(149399,6502),(149400,6502),(149401,6502),(149402,6502),(149403,6502),(149404,6502),(149405,6502),(149406,6502),(149407,6502),(149408,6503),(149409,6503),(149410,6503),(149411,6503),(149412,6503),(149413,6503),(149414,6503),(149415,6503),(149416,6503),(149417,6503),(149418,6504),(149419,6504),(149420,6504),(149421,6504),(149422,6504),(149423,6504),(149424,6504),(149425,6504),(149426,6504),(149427,6504),(149428,6505),(149429,6505),(149430,6505),(149431,6505),(149432,6505),(149433,6505),(149434,6505),(149435,6505),(149436,6505),(149437,6505),(149438,6506),(149439,6506),(149440,6506),(149441,6506),(149442,6506),(149443,6506),(149444,6506),(149445,6506),(149446,6506),(149447,6506),(149448,6507),(149449,6507),(149450,6507),(149451,6507),(149452,6507),(149453,6507),(149454,6507),(149455,6507),(149456,6508),(149457,6508),(149458,6508),(149459,6508),(149460,6508),(149461,6508),(149462,6508),(149463,6508),(149464,6508),(149465,6508),(149466,6508),(149467,6508),(149468,6508),(149469,6508),(149470,6509),(149471,6509),(149472,6509),(149473,6509),(149474,6509),(149475,6509),(149476,6509),(149477,6509),(149478,6509),(149479,6509),(149480,6509),(149481,6509),(149482,6509),(149483,6509),(149484,6510),(149485,6510),(149486,6510),(149487,6510),(149488,6510),(149489,6510),(149490,6510),(149491,6510),(149492,6510),(149493,6510),(149494,6510),(149495,6510),(149496,6510),(149497,6510),(149498,6511),(149499,6511),(149500,6511),(149501,6511),(149502,6511),(149503,6511),(149504,6511),(149505,6511),(149506,6511),(149507,6511),(149508,6511),(149509,6511),(149510,6511),(149511,6511),(149512,6512),(149513,6512),(149514,6512),(149515,6512),(149516,6512),(149517,6512),(149518,6512),(149519,6512),(149520,6512),(149521,6512),(149522,6512),(149523,6512),(149524,6512),(149525,6512),(149526,6513),(149527,6513),(149528,6513),(149529,6513),(149530,6513),(149531,6513),(149532,6513),(149533,6513),(149534,6513),(149535,6513),(149536,6513),(149537,6513),(149538,6513),(149539,6513),(149540,6514),(149541,6514),(149542,6514),(149543,6514),(149544,6515),(149545,6515),(149546,6515),(149547,6515),(149548,6516),(149549,6516),(149550,6516),(149551,6516),(149552,6517),(149553,6517),(149554,6517),(149555,6517),(149556,6518),(149557,6518),(149558,6518),(149559,6518),(149560,6519),(149561,6519),(149562,6519),(149563,6519),(149564,6520),(149565,6520),(149566,6520),(149567,6520),(149568,6521),(149569,6521),(149570,6521),(149571,6521),(149572,6521),(149573,6521),(149574,6521),(149575,6521),(149576,6521),(149577,6521),(149578,6522),(149579,6522),(149580,6522),(149581,6522),(149582,6522),(149583,6522),(149584,6522),(149585,6522),(149586,6522),(149587,6522),(149588,6523),(149589,6523),(149590,6523),(149591,6523),(149592,6523),(149593,6523),(149594,6523),(149595,6523),(149596,6523),(149597,6523),(149598,6524),(149599,6524),(149600,6524),(149601,6524),(149602,6524),(149603,6524),(149604,6524),(149605,6524),(149606,6524),(149607,6524),(149608,6525),(149609,6525),(149610,6525),(149611,6525),(149612,6526),(149613,6526),(149614,6526),(149615,6526),(149616,6527),(149617,6527),(149618,6527),(149619,6527),(149620,6528),(149621,6528),(149622,6528),(149623,6528),(149624,6529),(149625,6529),(149626,6529),(149627,6529),(149628,6530),(149629,6530),(149630,6530),(149631,6530),(149632,6531),(149633,6531),(149634,6531),(149635,6531),(149636,6532),(149637,6532),(149638,6532),(149639,6532),(149640,6533),(149641,6533),(149642,6533),(149643,6533),(149644,6534),(149645,6534),(149646,6534),(149647,6534),(149648,6535),(149649,6535),(149650,6535),(149651,6535),(149652,6536),(149653,6536),(149654,6536),(149655,6536),(149656,6537),(149657,6537),(149658,6537),(149659,6537),(149660,6538),(149661,6538),(149662,6538),(149663,6538),(149664,6539),(149665,6539),(149666,6539),(149667,6539),(149668,6540),(149669,6540),(149670,6540),(149671,6540),(149672,6540),(149673,6540),(149674,6540),(149675,6540),(149676,6540),(149677,6540),(149678,6541),(149679,6541),(149680,6541),(149681,6541),(149682,6541),(149683,6541),(149684,6541),(149685,6541),(149686,6541),(149687,6541),(149688,6542),(149689,6542),(149690,6542),(149691,6542),(149692,6542),(149693,6542),(149694,6542),(149695,6542),(149696,6542),(149697,6542),(149698,6543),(149699,6543),(149700,6543),(149701,6543),(149702,6543),(149703,6543),(149704,6543),(149705,6543),(149706,6543),(149707,6543),(149708,6544),(149709,6544),(149710,6544),(149711,6544),(149712,6544),(149713,6544),(149714,6544),(149715,6544),(149716,6544),(149717,6544),(149718,6545),(149719,6545),(149720,6545),(149721,6545),(149722,6545),(149723,6545),(149724,6545),(149725,6545),(149726,6545),(149727,6545),(149728,6446),(149729,6446),(149730,6446),(149731,6446),(149732,6446),(149733,6446),(149734,6446),(149735,6447),(149736,6447),(149737,6447),(149738,6447),(149739,6447),(149740,6447),(149741,6447),(149742,6448),(149743,6448),(149744,6448),(149745,6448),(149746,6448),(149747,6448),(149748,6448),(149749,6449),(149750,6449),(149751,6449),(149752,6449),(149753,6449),(149754,6449),(149755,6449),(149756,6450),(149757,6450),(149758,6450),(149759,6450),(149760,6450),(149761,6450),(149762,6450),(149763,6451),(149764,6451),(149765,6451),(149766,6451),(149767,6451),(149768,6451),(149769,6451),(149770,6452),(149771,6452),(149772,6452),(149773,6452),(149774,6452),(149775,6452),(149776,6452),(149777,6453),(149778,6453),(149779,6453),(149780,6453),(149781,6453),(149782,6453),(149783,6453),(149784,6454),(149785,6454),(149786,6454),(149787,6454),(149788,6454),(149789,6454),(149790,6454),(149791,6455),(149792,6455),(149793,6455),(149794,6455),(149795,6455),(149796,6455),(149797,6455),(149798,6456),(149799,6456),(149800,6456),(149801,6456),(149802,6456),(149803,6456),(149804,6456),(149805,6457),(149806,6457),(149807,6457),(149808,6457),(149809,6457),(149810,6457),(149811,6457),(149812,6458),(149813,6458),(149814,6458),(149815,6458),(149816,6458),(149817,6458),(149818,6458),(149819,6459),(149820,6459),(149821,6459),(149822,6459),(149823,6459),(149824,6459),(149825,6459),(149826,6460),(149827,6460),(149828,6460),(149829,6460),(149830,6460),(149831,6460),(149832,6460),(149833,6461),(149834,6461),(149835,6461),(149836,6461),(149837,6461),(149838,6461),(149839,6461),(149840,6462),(149841,6462),(149842,6462),(149843,6462),(149844,6462),(149845,6462),(149846,6462),(149847,6463),(149848,6463),(149849,6463),(149850,6463),(149851,6463),(149852,6463),(149853,6463),(149854,6464),(149855,6464),(149856,6464),(149857,6464),(149858,6464),(149859,6464),(149860,6464),(149861,6465),(149862,6465),(149863,6465),(149864,6465),(149865,6465),(149866,6465),(149867,6465),(149868,6466),(149869,6466),(149870,6466),(149871,6466),(149872,6466),(149873,6466),(149874,6466),(149875,6467),(149876,6467),(149877,6467),(149878,6467),(149879,6467),(149880,6467),(149881,6467),(149882,6468),(149883,6468),(149884,6468),(149885,6468),(149886,6468),(149887,6468),(149888,6468),(149889,6469),(149890,6469),(149891,6469),(149892,6469),(149893,6469),(149894,6469),(149895,6469),(149896,6470),(149897,6470),(149898,6470),(149899,6470),(149900,6470),(149901,6470),(149902,6470),(149903,6471),(149904,6471),(149905,6471),(149906,6471),(149907,6471),(149908,6471),(149909,6471),(149910,6472),(149911,6472),(149912,6472),(149913,6472),(149914,6472),(149915,6472),(149916,6472),(149917,6473),(149918,6473),(149919,6473),(149920,6473),(149921,6473),(149922,6473),(149923,6473),(149924,6474),(149925,6474),(149926,6474),(149927,6474),(149928,6474),(149929,6474),(149930,6474),(149931,6475),(149932,6475),(149933,6475),(149934,6475),(149935,6475),(149936,6475),(149937,6475),(149938,6476),(149939,6476),(149940,6476),(149941,6476),(149942,6476),(149943,6476),(149944,6476),(149945,6477),(149946,6477),(149947,6477),(149948,6477),(149949,6477),(149950,6477),(149951,6477),(149952,6478),(149953,6478),(149954,6478),(149955,6478),(149956,6478),(149957,6478),(149958,6478),(149959,6479),(149960,6479),(149961,6479),(149962,6479),(149963,6479),(149964,6479),(149965,6479),(149966,6480),(149967,6480),(149968,6480),(149969,6480),(149970,6480),(149971,6480),(149972,6480),(149973,6481),(149974,6481),(149975,6481),(149976,6481),(149977,6481),(149978,6481),(149979,6481),(149980,6482),(149981,6482),(149982,6482),(149983,6482),(149984,6482),(149985,6482),(149986,6482),(149987,6483),(149988,6483),(149989,6483),(149990,6483),(149991,6483),(149992,6483),(149993,6483),(149994,6484),(149995,6484),(149996,6484),(149997,6484),(149998,6484),(149999,6484),(150000,6484),(150001,6485),(150002,6485),(150003,6485),(150004,6485),(150005,6485),(150006,6485),(150007,6485),(150008,6486),(150009,6486),(150010,6486),(150011,6486),(150012,6486),(150013,6486),(150014,6486),(150015,6487),(150016,6487),(150017,6487),(150018,6487),(150019,6487),(150020,6487),(150021,6487),(150022,6488),(150023,6488),(150024,6488),(150025,6488),(150026,6488),(150027,6488),(150028,6488),(150029,6489),(150030,6489),(150031,6489),(150032,6489),(150033,6489),(150034,6489),(150035,6489),(150036,6490),(150037,6490),(150038,6490),(150039,6490),(150040,6490),(150041,6490),(150042,6490),(150043,6491),(150044,6491),(150045,6491),(150046,6491),(150047,6491),(150048,6491),(150049,6491),(150050,6492),(150051,6492),(150052,6492),(150053,6493),(150054,6493),(150055,6493),(150056,6494),(150057,6494),(150058,6494),(150059,6495),(150060,6495),(150061,6495),(150062,6496),(150063,6496),(150064,6496),(150065,6497),(150066,6497),(150067,6497),(150068,6498),(150069,6498),(150070,6498),(150071,6499),(150072,6499),(150073,6499),(150074,6500),(150075,6500),(150076,6500),(150077,6501),(150078,6501),(150079,6501),(150080,6502),(150081,6502),(150082,6502),(150083,6503),(150084,6503),(150085,6503),(150086,6504),(150087,6504),(150088,6504),(150089,6505),(150090,6505),(150091,6505),(150092,6506),(150093,6506),(150094,6506),(150095,6507),(150096,6507),(150097,6507),(150098,6507),(150099,6507),(150100,6508),(150101,6508),(150102,6508),(150103,6508),(150104,6508),(150105,6508),(150106,6508),(150107,6509),(150108,6509),(150109,6509),(150110,6509),(150111,6509),(150112,6509),(150113,6509),(150114,6510),(150115,6510),(150116,6510),(150117,6510),(150118,6510),(150119,6510),(150120,6510),(150121,6511),(150122,6511),(150123,6511),(150124,6511),(150125,6511),(150126,6511),(150127,6511),(150128,6512),(150129,6512),(150130,6512),(150131,6512),(150132,6512),(150133,6512),(150134,6512),(150135,6513),(150136,6513),(150137,6513),(150138,6513),(150139,6513),(150140,6513),(150141,6513),(150142,6514),(150143,6514),(150144,6514),(150145,6514),(150146,6514),(150147,6515),(150148,6515),(150149,6515),(150150,6515),(150151,6515),(150152,6516),(150153,6516),(150154,6516),(150155,6516),(150156,6516),(150157,6517),(150158,6517),(150159,6517),(150160,6517),(150161,6517),(150162,6518),(150163,6518),(150164,6518),(150165,6518),(150166,6518),(150167,6519),(150168,6519),(150169,6519),(150170,6519),(150171,6519),(150172,6520),(150173,6520),(150174,6520),(150175,6520),(150176,6520),(150177,6521),(150178,6521),(150179,6521),(150180,6521),(150181,6521),(150182,6522),(150183,6522),(150184,6522),(150185,6522),(150186,6522),(150187,6523),(150188,6523),(150189,6523),(150190,6523),(150191,6523),(150192,6524),(150193,6524),(150194,6524),(150195,6524),(150196,6524),(150197,6525),(150198,6525),(150199,6525),(150200,6525),(150201,6525),(150202,6526),(150203,6526),(150204,6526),(150205,6526),(150206,6526),(150207,6527),(150208,6527),(150209,6527),(150210,6527),(150211,6527),(150212,6528),(150213,6528),(150214,6528),(150215,6528),(150216,6528),(150217,6529),(150218,6529),(150219,6529),(150220,6529),(150221,6529),(150222,6530),(150223,6530),(150224,6530),(150225,6530),(150226,6530),(150227,6531),(150228,6531),(150229,6531),(150230,6531),(150231,6531),(150232,6532),(150233,6532),(150234,6532),(150235,6532),(150236,6532),(150237,6533),(150238,6533),(150239,6533),(150240,6533),(150241,6533),(150242,6534),(150243,6534),(150244,6534),(150245,6534),(150246,6534),(150247,6535),(150248,6535),(150249,6535),(150250,6535),(150251,6535),(150252,6536),(150253,6536),(150254,6536),(150255,6536),(150256,6536),(150257,6537),(150258,6537),(150259,6537),(150260,6538),(150261,6538),(150262,6538),(150263,6538),(150264,6538),(150265,6539),(150266,6539),(150267,6539),(150268,6539),(150269,6539),(150270,6540),(150271,6540),(150272,6540),(150273,6540),(150274,6540),(150275,6541),(150276,6541),(150277,6541),(150278,6541),(150279,6541),(150280,6542),(150281,6542),(150282,6542),(150283,6542),(150284,6542),(150285,6543),(150286,6543),(150287,6543),(150288,6543),(150289,6543),(150290,6544),(150291,6544),(150292,6544),(150293,6544),(150294,6544),(150295,6545),(150296,6545),(150297,6545),(150298,6545),(150299,6545),(150300,6446),(150301,6446),(150302,6446),(150303,6446),(150304,6446),(150305,6447),(150306,6447),(150307,6447),(150308,6447),(150309,6447),(150310,6448),(150311,6448),(150312,6448),(150313,6448),(150314,6448),(150315,6449),(150316,6449),(150317,6449),(150318,6449),(150319,6449),(150320,6450),(150321,6450),(150322,6450),(150323,6450),(150324,6450),(150325,6451),(150326,6451),(150327,6451),(150328,6451),(150329,6451),(150330,6452),(150331,6452),(150332,6452),(150333,6452),(150334,6452),(150335,6453),(150336,6453),(150337,6453),(150338,6453),(150339,6453),(150340,6454),(150341,6454),(150342,6454),(150343,6454),(150344,6454),(150345,6455),(150346,6455),(150347,6455),(150348,6455),(150349,6455),(150350,6456),(150351,6456),(150352,6456),(150353,6456),(150354,6456),(150355,6457),(150356,6457),(150357,6457),(150358,6457),(150359,6457),(150360,6458),(150361,6458),(150362,6458),(150363,6458),(150364,6458),(150365,6459),(150366,6459),(150367,6459),(150368,6459),(150369,6459),(150370,6460),(150371,6460),(150372,6460),(150373,6460),(150374,6460),(150375,6461),(150376,6461),(150377,6461),(150378,6461),(150379,6461),(150380,6462),(150381,6462),(150382,6462),(150383,6462),(150384,6462),(150385,6463),(150386,6463),(150387,6463),(150388,6463),(150389,6463),(150390,6464),(150391,6464),(150392,6464),(150393,6464),(150394,6464),(150395,6465),(150396,6465),(150397,6465),(150398,6465),(150399,6465),(150400,6466),(150401,6466),(150402,6466),(150403,6466),(150404,6466),(150405,6467),(150406,6467),(150407,6467),(150408,6467),(150409,6467),(150410,6468),(150411,6468),(150412,6468),(150413,6468),(150414,6468),(150415,6469),(150416,6469),(150417,6469),(150418,6469),(150419,6469),(150420,6470),(150421,6470),(150422,6470),(150423,6470),(150424,6470),(150425,6471),(150426,6471),(150427,6471),(150428,6471),(150429,6471),(150430,6472),(150431,6472),(150432,6472),(150433,6472),(150434,6472),(150435,6473),(150436,6473),(150437,6473),(150438,6473),(150439,6473),(150440,6474),(150441,6474),(150442,6474),(150443,6474),(150444,6474),(150445,6475),(150446,6475),(150447,6475),(150448,6475),(150449,6475),(150450,6476),(150451,6476),(150452,6476),(150453,6476),(150454,6476),(150455,6477),(150456,6477),(150457,6477),(150458,6477),(150459,6477),(150460,6478),(150461,6478),(150462,6478),(150463,6478),(150464,6478),(150465,6479),(150466,6479),(150467,6479),(150468,6479),(150469,6479),(150470,6480),(150471,6480),(150472,6480),(150473,6480),(150474,6480),(150475,6481),(150476,6481),(150477,6481),(150478,6481),(150479,6481),(150480,6482),(150481,6482),(150482,6482),(150483,6482),(150484,6482),(150485,6483),(150486,6483),(150487,6483),(150488,6483),(150489,6483),(150490,6484),(150491,6484),(150492,6484),(150493,6484),(150494,6484),(150495,6485),(150496,6485),(150497,6485),(150498,6485),(150499,6485),(150500,6486),(150501,6486),(150502,6486),(150503,6486),(150504,6486),(150505,6487),(150506,6487),(150507,6487),(150508,6487),(150509,6487),(150510,6488),(150511,6488),(150512,6488),(150513,6488),(150514,6488),(150515,6489),(150516,6489),(150517,6489),(150518,6489),(150519,6489),(150520,6490),(150521,6490),(150522,6490),(150523,6490),(150524,6490),(150525,6491),(150526,6491),(150527,6491),(150528,6491),(150529,6491),(150530,6492),(150531,6492),(150532,6492),(150533,6492),(150534,6492),(150535,6493),(150536,6493),(150537,6493),(150538,6493),(150539,6493),(150540,6494),(150541,6494),(150542,6494),(150543,6494),(150544,6494),(150545,6495),(150546,6495),(150547,6495),(150548,6495),(150549,6495),(150550,6496),(150551,6496),(150552,6496),(150553,6496),(150554,6496),(150555,6497),(150556,6497),(150557,6497),(150558,6497),(150559,6497),(150560,6498),(150561,6498),(150562,6498),(150563,6498),(150564,6498),(150565,6499),(150566,6499),(150567,6499),(150568,6499),(150569,6499),(150570,6500),(150571,6500),(150572,6500),(150573,6500),(150574,6500),(150575,6501),(150576,6501),(150577,6501),(150578,6501),(150579,6501),(150580,6502),(150581,6502),(150582,6502),(150583,6502),(150584,6502),(150585,6503),(150586,6503),(150587,6503),(150588,6503),(150589,6503),(150590,6504),(150591,6504),(150592,6504),(150593,6504),(150594,6504),(150595,6505),(150596,6505),(150597,6505),(150598,6505),(150599,6505),(150600,6506),(150601,6506),(150602,6506),(150603,6506),(150604,6506),(150605,6507),(150606,6507),(150607,6507),(150608,6507),(150609,6507),(150610,6508),(150611,6508),(150612,6508),(150613,6508),(150614,6508),(150615,6509),(150616,6509),(150617,6509),(150618,6509),(150619,6509),(150620,6510),(150621,6510),(150622,6510),(150623,6510),(150624,6510),(150625,6511),(150626,6511),(150627,6511),(150628,6511),(150629,6511),(150630,6512),(150631,6512),(150632,6512),(150633,6512),(150634,6512),(150635,6513),(150636,6513),(150637,6513),(150638,6513),(150639,6513),(150640,6514),(150641,6514),(150642,6514),(150643,6514),(150644,6514),(150645,6515),(150646,6515),(150647,6515),(150648,6515),(150649,6515),(150650,6516),(150651,6516),(150652,6516),(150653,6516),(150654,6516),(150655,6517),(150656,6517),(150657,6517),(150658,6517),(150659,6517),(150660,6518),(150661,6518),(150662,6518),(150663,6518),(150664,6518),(150665,6519),(150666,6519),(150667,6519),(150668,6519),(150669,6519),(150670,6520),(150671,6520),(150672,6520),(150673,6520),(150674,6520),(150675,6521),(150676,6521),(150677,6521),(150678,6521),(150679,6521),(150680,6522),(150681,6522),(150682,6522),(150683,6522),(150684,6522),(150685,6523),(150686,6523),(150687,6523),(150688,6523),(150689,6523),(150690,6524),(150691,6524),(150692,6524),(150693,6524),(150694,6524),(150695,6525),(150696,6525),(150697,6525),(150698,6525),(150699,6525),(150700,6526),(150701,6526),(150702,6526),(150703,6526),(150704,6526),(150705,6527),(150706,6527),(150707,6527),(150708,6527),(150709,6527),(150710,6528),(150711,6528),(150712,6528),(150713,6528),(150714,6528),(150715,6529),(150716,6529),(150717,6529),(150718,6529),(150719,6529),(150720,6530),(150721,6530),(150722,6530),(150723,6530),(150724,6530),(150725,6531),(150726,6531),(150727,6531),(150728,6531),(150729,6531),(150730,6532),(150731,6532),(150732,6532),(150733,6532),(150734,6532),(150735,6533),(150736,6533),(150737,6533),(150738,6533),(150739,6533),(150740,6534),(150741,6534),(150742,6534),(150743,6534),(150744,6534),(150745,6535),(150746,6535),(150747,6535),(150748,6535),(150749,6535),(150750,6536),(150751,6536),(150752,6536),(150753,6536),(150754,6536),(150755,6537),(150756,6537),(150757,6537),(150758,6537),(150759,6537),(150760,6538),(150761,6538),(150762,6538),(150763,6538),(150764,6538),(150765,6539),(150766,6539),(150767,6539),(150768,6539),(150769,6539),(150770,6540),(150771,6540),(150772,6540),(150773,6540),(150774,6540),(150775,6541),(150776,6541),(150777,6541),(150778,6541),(150779,6541),(150780,6542),(150781,6542),(150782,6542),(150783,6542),(150784,6542),(150785,6543),(150786,6543),(150787,6543),(150788,6543),(150789,6543),(150790,6544),(150791,6544),(150792,6544),(150793,6544),(150794,6544),(150795,6545),(150796,6545),(150797,6545),(150798,6545),(150799,6545),(150800,6546),(150801,6547),(150802,6548),(150803,6549),(150804,6550),(150805,6551),(150806,6552),(150807,6553),(150808,6554),(150809,6555),(150810,6556),(150811,6557),(150812,6558),(150813,6559),(150814,6560),(150815,6561),(150816,6562),(150817,6563),(150818,6564),(150819,6565),(150820,6566),(150821,6567),(150822,6568),(150823,6569),(150824,6570),(150825,6571),(150826,6572),(150827,6546),(150828,6546),(150829,6547),(150830,6547),(150831,6548),(150832,6548),(150833,6549),(150834,6549),(150835,6550),(150836,6550),(150837,6551),(150838,6551),(150839,6552),(150840,6552),(150841,6553),(150842,6553),(150843,6554),(150844,6554),(150845,6555),(150846,6555),(150847,6556),(150848,6556),(150849,6557),(150850,6557),(150851,6558),(150852,6558),(150853,6559),(150854,6559),(150855,6560),(150856,6560),(150857,6561),(150858,6561),(150859,6562),(150860,6562),(150861,6563),(150862,6563),(150863,6564),(150864,6564),(150865,6564),(150866,6565),(150867,6565),(150868,6565),(150869,6566),(150870,6566),(150871,6566),(150872,6567),(150873,6567),(150874,6567),(150875,6568),(150876,6568),(150877,6568),(150878,6569),(150879,6569),(150880,6569),(150881,6570),(150882,6570),(150883,6570),(150884,6571),(150885,6571),(150886,6571),(150887,6572),(150888,6572),(150889,6572),(150890,6546),(150891,6546),(150892,6546),(150893,6546),(150894,6546),(150895,6546),(150896,6546),(150897,6546),(150898,6546),(150899,6546),(150900,6546),(150901,6546),(150902,6546),(150903,6546),(150904,6547),(150905,6547),(150906,6547),(150907,6547),(150908,6547),(150909,6547),(150910,6547),(150911,6547),(150912,6547),(150913,6547),(150914,6547),(150915,6547),(150916,6547),(150917,6547),(150918,6548),(150919,6548),(150920,6548),(150921,6548),(150922,6548),(150923,6548),(150924,6548),(150925,6548),(150926,6548),(150927,6548),(150928,6548),(150929,6548),(150930,6548),(150931,6548),(150932,6549),(150933,6549),(150934,6549),(150935,6549),(150936,6549),(150937,6549),(150938,6549),(150939,6549),(150940,6549),(150941,6549),(150942,6549),(150943,6549),(150944,6549),(150945,6549),(150946,6550),(150947,6550),(150948,6550),(150949,6550),(150950,6550),(150951,6550),(150952,6550),(150953,6550),(150954,6550),(150955,6550),(150956,6550),(150957,6550),(150958,6550),(150959,6550),(150960,6551),(150961,6551),(150962,6551),(150963,6551),(150964,6551),(150965,6551),(150966,6551),(150967,6551),(150968,6551),(150969,6551),(150970,6551),(150971,6551),(150972,6551),(150973,6551),(150974,6552),(150975,6552),(150976,6552),(150977,6552),(150978,6552),(150979,6552),(150980,6552),(150981,6552),(150982,6552),(150983,6552),(150984,6552),(150985,6552),(150986,6552),(150987,6552),(150988,6553),(150989,6553),(150990,6553),(150991,6553),(150992,6553),(150993,6553),(150994,6553),(150995,6553),(150996,6553),(150997,6553),(150998,6553),(150999,6553),(151000,6553),(151001,6553),(151002,6554),(151003,6554),(151004,6554),(151005,6554),(151006,6554),(151007,6554),(151008,6554),(151009,6554),(151010,6554),(151011,6554),(151012,6554),(151013,6554),(151014,6554),(151015,6554),(151016,6555),(151017,6555),(151018,6555),(151019,6555),(151020,6555),(151021,6555),(151022,6555),(151023,6555),(151024,6555),(151025,6555),(151026,6555),(151027,6555),(151028,6555),(151029,6555),(151030,6556),(151031,6556),(151032,6556),(151033,6556),(151034,6556),(151035,6556),(151036,6556),(151037,6556),(151038,6556),(151039,6556),(151040,6556),(151041,6556),(151042,6556),(151043,6556),(151044,6557),(151045,6557),(151046,6557),(151047,6557),(151048,6557),(151049,6557),(151050,6557),(151051,6557),(151052,6557),(151053,6557),(151054,6557),(151055,6557),(151056,6557),(151057,6557),(151058,6558),(151059,6558),(151060,6558),(151061,6558),(151062,6558),(151063,6558),(151064,6558),(151065,6558),(151066,6558),(151067,6558),(151068,6558),(151069,6558),(151070,6558),(151071,6558),(151072,6559),(151073,6559),(151074,6559),(151075,6559),(151076,6559),(151077,6559),(151078,6559),(151079,6559),(151080,6559),(151081,6559),(151082,6559),(151083,6559),(151084,6559),(151085,6559),(151086,6560),(151087,6560),(151088,6560),(151089,6560),(151090,6560),(151091,6560),(151092,6560),(151093,6560),(151094,6560),(151095,6560),(151096,6560),(151097,6560),(151098,6560),(151099,6560),(151100,6561),(151101,6561),(151102,6561),(151103,6561),(151104,6561),(151105,6561),(151106,6561),(151107,6561),(151108,6561),(151109,6561),(151110,6561),(151111,6561),(151112,6561),(151113,6561),(151114,6562),(151115,6562),(151116,6562),(151117,6562),(151118,6562),(151119,6562),(151120,6562),(151121,6562),(151122,6562),(151123,6562),(151124,6562),(151125,6562),(151126,6562),(151127,6562),(151128,6563),(151129,6563),(151130,6563),(151131,6563),(151132,6563),(151133,6563),(151134,6563),(151135,6563),(151136,6563),(151137,6563),(151138,6563),(151139,6563),(151140,6563),(151141,6563),(151142,6564),(151143,6564),(151144,6564),(151145,6564),(151146,6564),(151147,6564),(151148,6564),(151149,6564),(151150,6564),(151151,6564),(151152,6564),(151153,6564),(151154,6564),(151155,6564),(151156,6565),(151157,6565),(151158,6565),(151159,6565),(151160,6565),(151161,6565),(151162,6565),(151163,6565),(151164,6565),(151165,6565),(151166,6565),(151167,6565),(151168,6565),(151169,6565),(151170,6566),(151171,6566),(151172,6566),(151173,6566),(151174,6566),(151175,6566),(151176,6566),(151177,6566),(151178,6566),(151179,6566),(151180,6566),(151181,6566),(151182,6566),(151183,6566),(151184,6567),(151185,6567),(151186,6567),(151187,6567),(151188,6567),(151189,6567),(151190,6567),(151191,6567),(151192,6567),(151193,6567),(151194,6567),(151195,6567),(151196,6567),(151197,6567),(151198,6568),(151199,6568),(151200,6568),(151201,6568),(151202,6568),(151203,6568),(151204,6568),(151205,6568),(151206,6568),(151207,6568),(151208,6568),(151209,6568),(151210,6568),(151211,6568),(151212,6569),(151213,6569),(151214,6569),(151215,6569),(151216,6569),(151217,6569),(151218,6569),(151219,6569),(151220,6569),(151221,6569),(151222,6569),(151223,6569),(151224,6569),(151225,6569),(151226,6570),(151227,6570),(151228,6570),(151229,6570),(151230,6570),(151231,6570),(151232,6570),(151233,6570),(151234,6570),(151235,6570),(151236,6570),(151237,6570),(151238,6570),(151239,6570),(151240,6571),(151241,6571),(151242,6571),(151243,6571),(151244,6571),(151245,6571),(151246,6571),(151247,6571),(151248,6571),(151249,6571),(151250,6571),(151251,6571),(151252,6571),(151253,6571),(151254,6572),(151255,6572),(151256,6572),(151257,6572),(151258,6572),(151259,6572),(151260,6572),(151261,6572),(151262,6572),(151263,6572),(151264,6572),(151265,6572),(151266,6572),(151267,6572),(151268,6546),(151269,6546),(151270,6546),(151271,6546),(151272,6546),(151273,6546),(151274,6546),(151275,6547),(151276,6547),(151277,6547),(151278,6547),(151279,6547),(151280,6547),(151281,6547),(151282,6548),(151283,6548),(151284,6548),(151285,6548),(151286,6548),(151287,6548),(151288,6548),(151289,6549),(151290,6549),(151291,6549),(151292,6549),(151293,6549),(151294,6549),(151295,6549),(151296,6550),(151297,6550),(151298,6550),(151299,6550),(151300,6550),(151301,6550),(151302,6550),(151303,6551),(151304,6551),(151305,6551),(151306,6551),(151307,6551),(151308,6551),(151309,6551),(151310,6552),(151311,6552),(151312,6552),(151313,6552),(151314,6552),(151315,6552),(151316,6552),(151317,6553),(151318,6553),(151319,6553),(151320,6553),(151321,6553),(151322,6553),(151323,6553),(151324,6554),(151325,6554),(151326,6554),(151327,6554),(151328,6554),(151329,6554),(151330,6554),(151331,6555),(151332,6555),(151333,6555),(151334,6555),(151335,6555),(151336,6555),(151337,6555),(151338,6556),(151339,6556),(151340,6556),(151341,6556),(151342,6556),(151343,6556),(151344,6556),(151345,6557),(151346,6557),(151347,6557),(151348,6557),(151349,6557),(151350,6557),(151351,6557),(151352,6558),(151353,6558),(151354,6558),(151355,6558),(151356,6558),(151357,6558),(151358,6558),(151359,6559),(151360,6559),(151361,6559),(151362,6559),(151363,6559),(151364,6559),(151365,6559),(151366,6560),(151367,6560),(151368,6560),(151369,6560),(151370,6560),(151371,6560),(151372,6560),(151373,6561),(151374,6561),(151375,6561),(151376,6561),(151377,6561),(151378,6561),(151379,6561),(151380,6562),(151381,6562),(151382,6562),(151383,6562),(151384,6562),(151385,6562),(151386,6562),(151387,6563),(151388,6563),(151389,6563),(151390,6563),(151391,6563),(151392,6563),(151393,6563),(151394,6564),(151395,6564),(151396,6564),(151397,6564),(151398,6564),(151399,6565),(151400,6565),(151401,6565),(151402,6565),(151403,6565),(151404,6566),(151405,6566),(151406,6566),(151407,6566),(151408,6566),(151409,6567),(151410,6567),(151411,6567),(151412,6567),(151413,6567),(151414,6568),(151415,6568),(151416,6568),(151417,6568),(151418,6568),(151419,6569),(151420,6569),(151421,6569),(151422,6569),(151423,6569),(151424,6570),(151425,6570),(151426,6570),(151427,6570),(151428,6570),(151429,6571),(151430,6571),(151431,6571),(151432,6571),(151433,6571),(151434,6572),(151435,6572),(151436,6572),(151437,6572),(151438,6572),(151439,6546),(151440,6546),(151441,6546),(151442,6546),(151443,6546),(151444,6547),(151445,6547),(151446,6547),(151447,6547),(151448,6547),(151449,6548),(151450,6548),(151451,6548),(151452,6548),(151453,6548),(151454,6549),(151455,6549),(151456,6549),(151457,6549),(151458,6549),(151459,6550),(151460,6550),(151461,6550),(151462,6550),(151463,6550),(151464,6551),(151465,6551),(151466,6551),(151467,6551),(151468,6551),(151469,6552),(151470,6552),(151471,6552),(151472,6552),(151473,6552),(151474,6553),(151475,6553),(151476,6553),(151477,6553),(151478,6553),(151479,6554),(151480,6554),(151481,6554),(151482,6554),(151483,6554),(151484,6555),(151485,6555),(151486,6555),(151487,6555),(151488,6555),(151489,6556),(151490,6556),(151491,6556),(151492,6556),(151493,6556),(151494,6557),(151495,6557),(151496,6557),(151497,6557),(151498,6557),(151499,6558),(151500,6558),(151501,6558),(151502,6558),(151503,6558),(151504,6559),(151505,6559),(151506,6559),(151507,6559),(151508,6559),(151509,6560),(151510,6560),(151511,6560),(151512,6560),(151513,6560),(151514,6561),(151515,6561),(151516,6561),(151517,6561),(151518,6561),(151519,6562),(151520,6562),(151521,6562),(151522,6562),(151523,6562),(151524,6563),(151525,6563),(151526,6563),(151527,6563),(151528,6563),(151529,6564),(151530,6564),(151531,6564),(151532,6564),(151533,6564),(151534,6565),(151535,6565),(151536,6565),(151537,6565),(151538,6565),(151539,6566),(151540,6566),(151541,6566),(151542,6566),(151543,6566),(151544,6567),(151545,6567),(151546,6567),(151547,6567),(151548,6567),(151549,6568),(151550,6568),(151551,6568),(151552,6568),(151553,6568),(151554,6569),(151555,6569),(151556,6569),(151557,6569),(151558,6569),(151559,6570),(151560,6570),(151561,6570),(151562,6570),(151563,6570),(151564,6571),(151565,6571),(151566,6571),(151567,6571),(151568,6571),(151569,6572),(151570,6572),(151571,6572),(151572,6572),(151573,6572);
/*!40000 ALTER TABLE `catalogrule_product_cl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalogrule_product_price`
--

DROP TABLE IF EXISTS `catalogrule_product_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalogrule_product_price` (
  `rule_product_price_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rule Product PriceId',
  `rule_date` date NOT NULL COMMENT 'Rule Date',
  `customer_group_id` int DEFAULT NULL,
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `rule_price` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Rule Price',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `latest_start_date` date DEFAULT NULL COMMENT 'Latest StartDate',
  `earliest_end_date` date DEFAULT NULL COMMENT 'Earliest EndDate',
  PRIMARY KEY (`rule_product_price_id`),
  UNIQUE KEY `CATRULE_PRD_PRICE_RULE_DATE_WS_ID_CSTR_GROUP_ID_PRD_ID` (`rule_date`,`website_id`,`customer_group_id`,`product_id`),
  KEY `CATALOGRULE_PRODUCT_PRICE_CUSTOMER_GROUP_ID` (`customer_group_id`),
  KEY `CATALOGRULE_PRODUCT_PRICE_WEBSITE_ID` (`website_id`),
  KEY `CATALOGRULE_PRODUCT_PRICE_PRODUCT_ID` (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='CatalogRule Product Price';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalogrule_product_price`
--

LOCK TABLES `catalogrule_product_price` WRITE;
/*!40000 ALTER TABLE `catalogrule_product_price` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalogrule_product_price` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalogrule_product_price_after_insert` AFTER INSERT ON `catalogrule_product_price` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (NEW.`product_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalogrule_product_price_after_update` AFTER UPDATE ON `catalogrule_product_price` FOR EACH ROW BEGIN
IF (NOT(NEW.`rule_product_price_id` <=> OLD.`rule_product_price_id`) OR NOT(NEW.`rule_date` <=> OLD.`rule_date`) OR NOT(NEW.`customer_group_id` <=> OLD.`customer_group_id`) OR NOT(NEW.`product_id` <=> OLD.`product_id`) OR NOT(NEW.`rule_price` <=> OLD.`rule_price`) OR NOT(NEW.`website_id` <=> OLD.`website_id`) OR NOT(NEW.`latest_start_date` <=> OLD.`latest_start_date`) OR NOT(NEW.`earliest_end_date` <=> OLD.`earliest_end_date`)) THEN INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (NEW.`product_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_catalogrule_product_price_after_delete` AFTER DELETE ON `catalogrule_product_price` FOR EACH ROW BEGIN
INSERT IGNORE INTO `catalog_product_price_cl` (`entity_id`) VALUES (OLD.`product_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `catalogrule_product_price_replica`
--

DROP TABLE IF EXISTS `catalogrule_product_price_replica`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalogrule_product_price_replica` (
  `rule_product_price_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rule Product PriceId',
  `rule_date` date NOT NULL COMMENT 'Rule Date',
  `customer_group_id` int DEFAULT NULL,
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `rule_price` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Rule Price',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `latest_start_date` date DEFAULT NULL COMMENT 'Latest StartDate',
  `earliest_end_date` date DEFAULT NULL COMMENT 'Earliest EndDate',
  PRIMARY KEY (`rule_product_price_id`),
  UNIQUE KEY `CATRULE_PRD_PRICE_RULE_DATE_WS_ID_CSTR_GROUP_ID_PRD_ID` (`rule_date`,`website_id`,`customer_group_id`,`product_id`),
  KEY `CATALOGRULE_PRODUCT_PRICE_CUSTOMER_GROUP_ID` (`customer_group_id`),
  KEY `CATALOGRULE_PRODUCT_PRICE_WEBSITE_ID` (`website_id`),
  KEY `CATALOGRULE_PRODUCT_PRICE_PRODUCT_ID` (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='CatalogRule Product Price';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalogrule_product_price_replica`
--

LOCK TABLES `catalogrule_product_price_replica` WRITE;
/*!40000 ALTER TABLE `catalogrule_product_price_replica` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalogrule_product_price_replica` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalogrule_product_replica`
--

DROP TABLE IF EXISTS `catalogrule_product_replica`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalogrule_product_replica` (
  `rule_product_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rule Product ID',
  `rule_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Rule ID',
  `from_time` int unsigned NOT NULL DEFAULT '0' COMMENT 'From Time',
  `to_time` int unsigned NOT NULL DEFAULT '0' COMMENT 'To time',
  `customer_group_id` int DEFAULT NULL,
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `action_operator` varchar(10) DEFAULT 'to_fixed' COMMENT 'Action Operator',
  `action_amount` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Action Amount',
  `action_stop` smallint NOT NULL DEFAULT '0' COMMENT 'Action Stop',
  `sort_order` int unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  PRIMARY KEY (`rule_product_id`),
  UNIQUE KEY `UNQ_EAA51B56FF092A0DCB795D1CEF812B7B` (`rule_id`,`from_time`,`to_time`,`website_id`,`customer_group_id`,`product_id`,`sort_order`),
  KEY `CATALOGRULE_PRODUCT_CUSTOMER_GROUP_ID` (`customer_group_id`),
  KEY `CATALOGRULE_PRODUCT_WEBSITE_ID` (`website_id`),
  KEY `CATALOGRULE_PRODUCT_FROM_TIME` (`from_time`),
  KEY `CATALOGRULE_PRODUCT_TO_TIME` (`to_time`),
  KEY `CATALOGRULE_PRODUCT_PRODUCT_ID` (`product_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='CatalogRule Product';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalogrule_product_replica`
--

LOCK TABLES `catalogrule_product_replica` WRITE;
/*!40000 ALTER TABLE `catalogrule_product_replica` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalogrule_product_replica` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalogrule_rule_cl`
--

DROP TABLE IF EXISTS `catalogrule_rule_cl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalogrule_rule_cl` (
  `version_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Version ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  PRIMARY KEY (`version_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='catalogrule_rule_cl';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalogrule_rule_cl`
--

LOCK TABLES `catalogrule_rule_cl` WRITE;
/*!40000 ALTER TABLE `catalogrule_rule_cl` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalogrule_rule_cl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalogrule_website`
--

DROP TABLE IF EXISTS `catalogrule_website`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalogrule_website` (
  `rule_id` int unsigned NOT NULL COMMENT 'Rule ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  PRIMARY KEY (`rule_id`,`website_id`),
  KEY `CATALOGRULE_WEBSITE_WEBSITE_ID` (`website_id`),
  CONSTRAINT `CATALOGRULE_WEBSITE_RULE_ID_CATALOGRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `catalogrule` (`rule_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOGRULE_WEBSITE_WEBSITE_ID_STORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Catalog Rules To Websites Relations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalogrule_website`
--

LOCK TABLES `catalogrule_website` WRITE;
/*!40000 ALTER TABLE `catalogrule_website` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalogrule_website` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalogsearch_fulltext_cl`
--

DROP TABLE IF EXISTS `catalogsearch_fulltext_cl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalogsearch_fulltext_cl` (
  `version_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Version ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  PRIMARY KEY (`version_id`)
) ENGINE=InnoDB AUTO_INCREMENT=158259 DEFAULT CHARSET=utf8mb3 COMMENT='catalogsearch_fulltext_cl';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalogsearch_fulltext_cl`
--

LOCK TABLES `catalogsearch_fulltext_cl` WRITE;
/*!40000 ALTER TABLE `catalogsearch_fulltext_cl` DISABLE KEYS */;
INSERT INTO `catalogsearch_fulltext_cl` VALUES (1,1),(2,2),(3,3),(4,4),(5,5),(6,6),(7,1),(8,2),(9,3),(10,4),(11,5),(12,6),(13,1),(14,1),(15,2),(16,2),(17,3),(18,3),(19,4),(20,4),(21,5),(22,5),(23,6),(24,6),(25,1),(26,1),(27,1),(28,1),(29,1),(30,1),(31,2),(32,2),(33,2),(34,2),(35,2),(36,2),(37,3),(38,3),(39,3),(40,3),(41,3),(42,3),(43,4),(44,4),(45,4),(46,4),(47,4),(48,5),(49,5),(50,5),(51,5),(52,5),(53,5),(54,6),(55,6),(56,6),(57,6),(58,6),(59,6),(60,1),(61,1),(62,2),(63,2),(64,3),(65,3),(66,4),(67,4),(68,5),(69,5),(70,6),(71,6),(72,1),(73,1),(74,2),(75,2),(76,3),(77,3),(78,5),(79,5),(80,6),(81,6),(82,1),(83,1),(84,1),(85,1),(86,2),(87,2),(88,2),(89,2),(90,3),(91,3),(92,3),(93,3),(94,4),(95,4),(96,4),(97,5),(98,5),(99,5),(100,5),(101,5),(102,5),(103,5),(104,5),(105,5),(106,6),(107,6),(108,6),(109,6),(110,6),(111,6),(112,6),(113,6),(114,6),(115,5),(116,5),(117,6),(118,6),(119,4),(120,4),(121,1),(122,1),(123,1),(124,1),(125,1),(126,1),(127,2),(128,2),(129,2),(130,3),(131,3),(132,3),(133,4),(134,4),(135,4),(136,4),(137,4),(138,4),(139,5),(140,5),(141,5),(142,5),(143,5),(144,5),(145,6),(146,6),(147,6),(148,6),(149,6),(150,6),(151,1),(152,1),(153,1),(154,1),(155,1),(156,1),(157,1),(158,1),(159,1),(160,1),(161,1),(162,1),(163,1),(164,1),(165,1),(166,1),(167,1),(168,1),(169,1),(170,1),(171,1),(172,1),(173,2),(174,2),(175,2),(176,2),(177,2),(178,2),(179,2),(180,2),(181,2),(182,2),(183,2),(184,2),(185,2),(186,2),(187,6),(188,6),(189,6),(190,6),(191,6),(192,6),(193,6),(194,6),(195,6),(196,6),(197,6),(198,6),(199,6),(200,6),(201,6),(202,6),(203,6),(204,6),(205,6),(206,6),(207,5),(208,5),(209,5),(210,5),(211,5),(212,5),(213,5),(214,5),(215,5),(216,5),(217,5),(218,5),(219,5),(220,5),(221,5),(222,5),(223,5),(224,5),(225,4),(226,4),(227,4),(228,4),(229,4),(230,4),(231,4),(232,4),(233,4),(234,4),(235,4),(236,4),(237,4),(238,4),(239,4),(240,4),(241,4),(242,4),(243,4),(244,4),(245,4),(246,4),(247,3),(248,3),(249,3),(250,3),(251,3),(252,3),(253,3),(254,3),(255,3),(256,3),(257,7),(258,7),(259,7),(260,7),(261,7),(262,7),(263,7),(264,7),(265,7),(266,7),(267,7),(268,7),(269,7),(270,7),(271,7),(272,7),(273,7),(274,7),(275,7),(276,7),(277,7),(278,7),(279,7),(280,7),(281,8),(282,9),(283,10),(284,11),(285,12),(286,13),(287,14),(288,15),(289,16),(290,17),(291,18),(292,19),(293,20),(294,21),(295,22),(296,23),(297,24),(298,25),(299,26),(300,27),(301,28),(302,29),(303,30),(304,31),(305,32),(306,33),(307,34),(308,35),(309,36),(310,37),(311,38),(312,39),(313,40),(314,41),(315,42),(316,43),(317,44),(318,45),(319,46),(320,47),(321,48),(322,49),(323,50),(324,51),(325,52),(326,53),(327,54),(328,55),(329,56),(330,57),(331,58),(332,59),(333,60),(334,61),(335,62),(336,63),(337,64),(338,65),(339,66),(340,67),(341,68),(342,69),(343,70),(344,71),(345,72),(346,73),(347,74),(348,75),(349,76),(350,77),(351,78),(352,79),(353,80),(354,81),(355,82),(356,83),(357,84),(358,85),(359,86),(360,87),(361,88),(362,89),(363,90),(364,91),(365,92),(366,93),(367,94),(368,95),(369,96),(370,97),(371,98),(372,99),(373,100),(374,101),(375,102),(376,103),(377,104),(378,105),(379,106),(380,8),(381,9),(382,10),(383,11),(384,12),(385,13),(386,14),(387,15),(388,16),(389,17),(390,18),(391,19),(392,20),(393,21),(394,22),(395,23),(396,24),(397,25),(398,26),(399,27),(400,28),(401,29),(402,30),(403,31),(404,32),(405,33),(406,34),(407,35),(408,36),(409,37),(410,38),(411,39),(412,40),(413,41),(414,42),(415,43),(416,44),(417,45),(418,46),(419,47),(420,48),(421,49),(422,50),(423,51),(424,52),(425,53),(426,54),(427,55),(428,56),(429,57),(430,58),(431,59),(432,60),(433,61),(434,62),(435,63),(436,64),(437,65),(438,66),(439,67),(440,68),(441,69),(442,70),(443,71),(444,72),(445,73),(446,74),(447,75),(448,76),(449,77),(450,78),(451,79),(452,80),(453,81),(454,82),(455,83),(456,84),(457,85),(458,86),(459,87),(460,88),(461,89),(462,90),(463,91),(464,92),(465,93),(466,94),(467,95),(468,96),(469,97),(470,98),(471,99),(472,100),(473,101),(474,102),(475,103),(476,104),(477,105),(478,106),(479,7),(480,7),(481,7),(482,8),(483,8),(484,8),(485,8),(486,8),(487,8),(488,8),(489,9),(490,9),(491,9),(492,9),(493,9),(494,9),(495,9),(496,10),(497,10),(498,10),(499,10),(500,10),(501,10),(502,10),(503,11),(504,11),(505,11),(506,11),(507,11),(508,11),(509,11),(510,12),(511,12),(512,12),(513,12),(514,12),(515,12),(516,12),(517,13),(518,13),(519,13),(520,13),(521,13),(522,13),(523,13),(524,14),(525,14),(526,14),(527,14),(528,14),(529,14),(530,14),(531,15),(532,15),(533,15),(534,15),(535,16),(536,16),(537,16),(538,16),(539,16),(540,16),(541,17),(542,17),(543,17),(544,17),(545,18),(546,18),(547,18),(548,18),(549,19),(550,19),(551,19),(552,19),(553,20),(554,20),(555,20),(556,20),(557,21),(558,21),(559,21),(560,21),(561,22),(562,22),(563,22),(564,22),(565,23),(566,23),(567,23),(568,23),(569,23),(570,23),(571,23),(572,24),(573,24),(574,24),(575,24),(576,24),(577,24),(578,24),(579,25),(580,25),(581,25),(582,25),(583,25),(584,25),(585,25),(586,26),(587,26),(588,26),(589,26),(590,27),(591,27),(592,27),(593,27),(594,27),(595,27),(596,27),(597,28),(598,28),(599,28),(600,28),(601,28),(602,28),(603,28),(604,29),(605,29),(606,29),(607,29),(608,29),(609,29),(610,29),(611,30),(612,30),(613,30),(614,30),(615,30),(616,30),(617,30),(618,31),(619,31),(620,31),(621,31),(622,31),(623,31),(624,31),(625,32),(626,32),(627,32),(628,32),(629,32),(630,32),(631,32),(632,33),(633,33),(634,33),(635,33),(636,34),(637,34),(638,34),(639,34),(640,34),(641,34),(642,34),(643,35),(644,35),(645,35),(646,35),(647,35),(648,35),(649,35),(650,36),(651,36),(652,36),(653,36),(654,36),(655,36),(656,36),(657,37),(658,37),(659,37),(660,37),(661,37),(662,37),(663,37),(664,38),(665,38),(666,38),(667,38),(668,38),(669,38),(670,38),(671,39),(672,39),(673,39),(674,39),(675,39),(676,39),(677,40),(678,40),(679,40),(680,40),(681,40),(682,40),(683,40),(684,41),(685,41),(686,41),(687,41),(688,41),(689,41),(690,41),(691,42),(692,42),(693,42),(694,42),(695,42),(696,42),(697,42),(698,43),(699,43),(700,43),(701,43),(702,43),(703,43),(704,43),(705,44),(706,44),(707,44),(708,44),(709,44),(710,44),(711,44),(712,45),(713,45),(714,45),(715,45),(716,45),(717,45),(718,45),(719,46),(720,46),(721,46),(722,46),(723,46),(724,46),(725,46),(726,47),(727,47),(728,47),(729,47),(730,47),(731,47),(732,47),(733,48),(734,48),(735,48),(736,48),(737,48),(738,48),(739,48),(740,49),(741,49),(742,49),(743,49),(744,49),(745,49),(746,49),(747,50),(748,50),(749,50),(750,50),(751,50),(752,50),(753,50),(754,51),(755,51),(756,51),(757,51),(758,51),(759,51),(760,51),(761,52),(762,52),(763,52),(764,52),(765,52),(766,52),(767,52),(768,53),(769,53),(770,53),(771,53),(772,53),(773,53),(774,53),(775,53),(776,53),(777,54),(778,54),(779,54),(780,54),(781,54),(782,54),(783,54),(784,54),(785,54),(786,55),(787,55),(788,55),(789,55),(790,55),(791,55),(792,55),(793,55),(794,55),(795,56),(796,56),(797,56),(798,56),(799,56),(800,56),(801,56),(802,56),(803,56),(804,57),(805,57),(806,57),(807,57),(808,57),(809,57),(810,57),(811,57),(812,57),(813,58),(814,58),(815,58),(816,58),(817,58),(818,58),(819,58),(820,58),(821,58),(822,59),(823,59),(824,59),(825,59),(826,59),(827,59),(828,59),(829,59),(830,59),(831,60),(832,60),(833,60),(834,60),(835,60),(836,60),(837,60),(838,60),(839,60),(840,61),(841,61),(842,61),(843,61),(844,61),(845,61),(846,61),(847,61),(848,61),(849,62),(850,62),(851,62),(852,62),(853,62),(854,62),(855,62),(856,62),(857,62),(858,63),(859,63),(860,63),(861,63),(862,63),(863,63),(864,63),(865,63),(866,63),(867,64),(868,64),(869,64),(870,64),(871,64),(872,64),(873,64),(874,64),(875,64),(876,65),(877,65),(878,65),(879,65),(880,65),(881,65),(882,65),(883,66),(884,66),(885,66),(886,66),(887,66),(888,66),(889,66),(890,67),(891,67),(892,67),(893,67),(894,67),(895,67),(896,67),(897,68),(898,68),(899,68),(900,68),(901,69),(902,69),(903,69),(904,69),(905,70),(906,70),(907,70),(908,70),(909,70),(910,70),(911,70),(912,71),(913,71),(914,71),(915,71),(916,72),(917,72),(918,72),(919,72),(920,73),(921,73),(922,73),(923,73),(924,74),(925,74),(926,74),(927,74),(928,75),(929,75),(930,75),(931,75),(932,76),(933,76),(934,76),(935,76),(936,77),(937,77),(938,77),(939,77),(940,78),(941,78),(942,78),(943,78),(944,78),(945,78),(946,78),(947,79),(948,79),(949,79),(950,79),(951,79),(952,79),(953,79),(954,80),(955,80),(956,80),(957,80),(958,80),(959,80),(960,80),(961,81),(962,81),(963,81),(964,81),(965,81),(966,81),(967,81),(968,82),(969,82),(970,82),(971,82),(972,82),(973,82),(974,82),(975,83),(976,83),(977,83),(978,83),(979,83),(980,83),(981,83),(982,84),(983,84),(984,84),(985,84),(986,84),(987,84),(988,84),(989,85),(990,85),(991,85),(992,85),(993,85),(994,85),(995,85),(996,86),(997,86),(998,86),(999,86),(1000,86),(1001,86),(1002,86),(1003,86),(1004,86),(1005,87),(1006,87),(1007,87),(1008,87),(1009,87),(1010,87),(1011,87),(1012,88),(1013,88),(1014,88),(1015,88),(1016,88),(1017,88),(1018,88),(1019,89),(1020,89),(1021,89),(1022,89),(1023,89),(1024,89),(1025,89),(1026,89),(1027,89),(1028,90),(1029,90),(1030,90),(1031,90),(1032,90),(1033,90),(1034,90),(1035,91),(1036,91),(1037,91),(1038,91),(1039,91),(1040,91),(1041,91),(1042,92),(1043,92),(1044,92),(1045,92),(1046,92),(1047,92),(1048,92),(1049,93),(1050,93),(1051,93),(1052,93),(1053,93),(1054,93),(1055,93),(1056,94),(1057,94),(1058,94),(1059,94),(1060,94),(1061,94),(1062,94),(1063,95),(1064,95),(1065,95),(1066,95),(1067,95),(1068,95),(1069,95),(1070,96),(1071,96),(1072,96),(1073,96),(1074,96),(1075,96),(1076,96),(1077,96),(1078,96),(1079,97),(1080,97),(1081,97),(1082,97),(1083,97),(1084,97),(1085,97),(1086,97),(1087,97),(1088,98),(1089,98),(1090,98),(1091,98),(1092,98),(1093,98),(1094,98),(1095,98),(1096,98),(1097,99),(1098,99),(1099,99),(1100,99),(1101,99),(1102,99),(1103,99),(1104,99),(1105,99),(1106,100),(1107,100),(1108,100),(1109,100),(1110,100),(1111,100),(1112,100),(1113,100),(1114,100),(1115,101),(1116,101),(1117,101),(1118,101),(1119,101),(1120,101),(1121,101),(1122,101),(1123,101),(1124,102),(1125,102),(1126,102),(1127,102),(1128,102),(1129,102),(1130,102),(1131,102),(1132,102),(1133,103),(1134,103),(1135,103),(1136,103),(1137,103),(1138,103),(1139,103),(1140,103),(1141,103),(1142,104),(1143,104),(1144,104),(1145,104),(1146,104),(1147,104),(1148,104),(1149,104),(1150,104),(1151,105),(1152,105),(1153,105),(1154,105),(1155,105),(1156,105),(1157,105),(1158,105),(1159,105),(1160,106),(1161,106),(1162,106),(1163,106),(1164,106),(1165,106),(1166,106),(1167,106),(1168,106),(1169,7),(1170,8),(1171,8),(1172,9),(1173,9),(1174,10),(1175,10),(1176,11),(1177,11),(1178,12),(1179,12),(1180,13),(1181,13),(1182,14),(1183,14),(1184,15),(1185,16),(1186,17),(1187,18),(1188,19),(1189,20),(1190,21),(1191,22),(1192,23),(1193,23),(1194,24),(1195,24),(1196,25),(1197,25),(1198,26),(1199,27),(1200,27),(1201,28),(1202,28),(1203,29),(1204,29),(1205,30),(1206,30),(1207,31),(1208,32),(1209,32),(1210,33),(1211,34),(1212,35),(1213,36),(1214,37),(1215,37),(1216,38),(1217,38),(1218,39),(1219,39),(1220,40),(1221,40),(1222,41),(1223,41),(1224,42),(1225,42),(1226,43),(1227,43),(1228,44),(1229,44),(1230,45),(1231,45),(1232,46),(1233,46),(1234,47),(1235,47),(1236,48),(1237,48),(1238,49),(1239,49),(1240,50),(1241,50),(1242,51),(1243,51),(1244,52),(1245,52),(1246,53),(1247,53),(1248,54),(1249,54),(1250,55),(1251,55),(1252,56),(1253,56),(1254,57),(1255,57),(1256,58),(1257,58),(1258,59),(1259,59),(1260,60),(1261,60),(1262,61),(1263,61),(1264,62),(1265,62),(1266,63),(1267,63),(1268,64),(1269,64),(1270,65),(1271,66),(1272,66),(1273,67),(1274,68),(1275,69),(1276,70),(1277,70),(1278,71),(1279,72),(1280,73),(1281,74),(1282,75),(1283,76),(1284,77),(1285,78),(1286,78),(1287,79),(1288,79),(1289,80),(1290,80),(1291,81),(1292,81),(1293,82),(1294,82),(1295,83),(1296,83),(1297,84),(1298,84),(1299,85),(1300,85),(1301,86),(1302,86),(1303,87),(1304,87),(1305,88),(1306,88),(1307,89),(1308,89),(1309,90),(1310,90),(1311,91),(1312,91),(1313,92),(1314,92),(1315,93),(1316,93),(1317,94),(1318,94),(1319,95),(1320,95),(1321,96),(1322,96),(1323,97),(1324,97),(1325,98),(1326,98),(1327,99),(1328,99),(1329,100),(1330,100),(1331,101),(1332,101),(1333,102),(1334,102),(1335,103),(1336,103),(1337,104),(1338,104),(1339,105),(1340,105),(1341,106),(1342,106),(1343,7),(1344,8),(1345,8),(1346,8),(1347,9),(1348,9),(1349,9),(1350,10),(1351,10),(1352,10),(1353,11),(1354,11),(1355,11),(1356,12),(1357,12),(1358,12),(1359,13),(1360,13),(1361,13),(1362,14),(1363,14),(1364,14),(1365,15),(1366,15),(1367,15),(1368,16),(1369,16),(1370,16),(1371,17),(1372,17),(1373,17),(1374,18),(1375,18),(1376,18),(1377,19),(1378,19),(1379,19),(1380,20),(1381,20),(1382,20),(1383,21),(1384,21),(1385,21),(1386,22),(1387,22),(1388,22),(1389,23),(1390,23),(1391,23),(1392,24),(1393,24),(1394,24),(1395,25),(1396,25),(1397,25),(1398,26),(1399,26),(1400,26),(1401,27),(1402,27),(1403,27),(1404,28),(1405,28),(1406,28),(1407,29),(1408,29),(1409,29),(1410,30),(1411,30),(1412,30),(1413,31),(1414,31),(1415,31),(1416,32),(1417,32),(1418,32),(1419,33),(1420,33),(1421,33),(1422,34),(1423,34),(1424,34),(1425,35),(1426,35),(1427,35),(1428,36),(1429,36),(1430,36),(1431,37),(1432,37),(1433,37),(1434,38),(1435,38),(1436,38),(1437,39),(1438,40),(1439,40),(1440,40),(1441,41),(1442,41),(1443,41),(1444,42),(1445,42),(1446,42),(1447,43),(1448,43),(1449,43),(1450,44),(1451,44),(1452,44),(1453,45),(1454,45),(1455,45),(1456,46),(1457,46),(1458,46),(1459,47),(1460,47),(1461,47),(1462,48),(1463,48),(1464,48),(1465,49),(1466,49),(1467,49),(1468,50),(1469,50),(1470,50),(1471,51),(1472,51),(1473,51),(1474,52),(1475,52),(1476,52),(1477,53),(1478,53),(1479,53),(1480,54),(1481,54),(1482,54),(1483,55),(1484,55),(1485,55),(1486,56),(1487,56),(1488,56),(1489,57),(1490,57),(1491,57),(1492,58),(1493,58),(1494,58),(1495,59),(1496,59),(1497,59),(1498,60),(1499,60),(1500,60),(1501,61),(1502,61),(1503,61),(1504,62),(1505,62),(1506,62),(1507,63),(1508,63),(1509,63),(1510,64),(1511,64),(1512,64),(1513,65),(1514,65),(1515,65),(1516,66),(1517,66),(1518,66),(1519,67),(1520,67),(1521,67),(1522,68),(1523,68),(1524,68),(1525,69),(1526,69),(1527,69),(1528,70),(1529,70),(1530,70),(1531,71),(1532,71),(1533,71),(1534,72),(1535,72),(1536,72),(1537,73),(1538,73),(1539,73),(1540,74),(1541,74),(1542,74),(1543,75),(1544,75),(1545,75),(1546,76),(1547,76),(1548,76),(1549,77),(1550,77),(1551,77),(1552,78),(1553,78),(1554,78),(1555,79),(1556,79),(1557,79),(1558,80),(1559,80),(1560,80),(1561,81),(1562,81),(1563,81),(1564,82),(1565,82),(1566,82),(1567,83),(1568,83),(1569,83),(1570,84),(1571,84),(1572,84),(1573,85),(1574,85),(1575,85),(1576,86),(1577,86),(1578,86),(1579,87),(1580,87),(1581,87),(1582,88),(1583,88),(1584,88),(1585,89),(1586,89),(1587,89),(1588,90),(1589,90),(1590,90),(1591,91),(1592,91),(1593,91),(1594,92),(1595,92),(1596,92),(1597,93),(1598,93),(1599,93),(1600,94),(1601,94),(1602,94),(1603,95),(1604,95),(1605,95),(1606,96),(1607,96),(1608,97),(1609,97),(1610,98),(1611,98),(1612,99),(1613,99),(1614,100),(1615,100),(1616,101),(1617,101),(1618,102),(1619,102),(1620,103),(1621,103),(1622,104),(1623,104),(1624,105),(1625,105),(1626,106),(1627,106),(1628,8),(1629,8),(1630,8),(1631,8),(1632,9),(1633,9),(1634,9),(1635,9),(1636,10),(1637,10),(1638,10),(1639,10),(1640,11),(1641,11),(1642,11),(1643,11),(1644,12),(1645,12),(1646,12),(1647,12),(1648,13),(1649,13),(1650,13),(1651,13),(1652,14),(1653,14),(1654,14),(1655,14),(1656,15),(1657,15),(1658,15),(1659,15),(1660,16),(1661,16),(1662,16),(1663,16),(1664,17),(1665,17),(1666,17),(1667,17),(1668,18),(1669,18),(1670,18),(1671,18),(1672,19),(1673,19),(1674,19),(1675,19),(1676,20),(1677,20),(1678,20),(1679,20),(1680,21),(1681,21),(1682,21),(1683,21),(1684,22),(1685,22),(1686,22),(1687,22),(1688,23),(1689,23),(1690,23),(1691,23),(1692,24),(1693,24),(1694,24),(1695,24),(1696,25),(1697,25),(1698,25),(1699,25),(1700,26),(1701,26),(1702,26),(1703,26),(1704,27),(1705,27),(1706,27),(1707,27),(1708,28),(1709,28),(1710,28),(1711,28),(1712,29),(1713,29),(1714,29),(1715,29),(1716,30),(1717,30),(1718,30),(1719,30),(1720,31),(1721,31),(1722,31),(1723,31),(1724,32),(1725,32),(1726,32),(1727,32),(1728,33),(1729,33),(1730,33),(1731,33),(1732,34),(1733,34),(1734,34),(1735,34),(1736,35),(1737,35),(1738,35),(1739,35),(1740,36),(1741,36),(1742,36),(1743,36),(1744,37),(1745,37),(1746,37),(1747,37),(1748,38),(1749,38),(1750,38),(1751,38),(1752,39),(1753,39),(1754,39),(1755,39),(1756,40),(1757,40),(1758,40),(1759,40),(1760,41),(1761,41),(1762,41),(1763,41),(1764,42),(1765,42),(1766,42),(1767,42),(1768,43),(1769,43),(1770,43),(1771,43),(1772,44),(1773,44),(1774,44),(1775,44),(1776,45),(1777,45),(1778,45),(1779,45),(1780,46),(1781,46),(1782,46),(1783,46),(1784,47),(1785,47),(1786,47),(1787,47),(1788,48),(1789,48),(1790,48),(1791,48),(1792,49),(1793,49),(1794,49),(1795,49),(1796,50),(1797,50),(1798,50),(1799,50),(1800,51),(1801,51),(1802,51),(1803,51),(1804,52),(1805,52),(1806,52),(1807,52),(1808,53),(1809,53),(1810,53),(1811,53),(1812,54),(1813,54),(1814,54),(1815,54),(1816,55),(1817,55),(1818,55),(1819,55),(1820,56),(1821,56),(1822,56),(1823,56),(1824,57),(1825,57),(1826,57),(1827,57),(1828,58),(1829,58),(1830,58),(1831,58),(1832,59),(1833,59),(1834,59),(1835,59),(1836,60),(1837,60),(1838,60),(1839,60),(1840,61),(1841,61),(1842,61),(1843,61),(1844,62),(1845,62),(1846,62),(1847,62),(1848,63),(1849,63),(1850,63),(1851,63),(1852,64),(1853,64),(1854,64),(1855,64),(1856,65),(1857,65),(1858,65),(1859,65),(1860,66),(1861,66),(1862,66),(1863,66),(1864,67),(1865,67),(1866,67),(1867,67),(1868,68),(1869,68),(1870,68),(1871,68),(1872,69),(1873,69),(1874,69),(1875,69),(1876,70),(1877,70),(1878,70),(1879,70),(1880,71),(1881,71),(1882,71),(1883,71),(1884,72),(1885,72),(1886,72),(1887,72),(1888,73),(1889,73),(1890,73),(1891,73),(1892,74),(1893,74),(1894,74),(1895,74),(1896,75),(1897,75),(1898,75),(1899,75),(1900,76),(1901,76),(1902,76),(1903,76),(1904,77),(1905,77),(1906,77),(1907,77),(1908,78),(1909,78),(1910,78),(1911,78),(1912,79),(1913,79),(1914,79),(1915,79),(1916,80),(1917,80),(1918,80),(1919,80),(1920,81),(1921,81),(1922,81),(1923,81),(1924,82),(1925,82),(1926,82),(1927,82),(1928,83),(1929,83),(1930,83),(1931,83),(1932,84),(1933,84),(1934,84),(1935,84),(1936,85),(1937,85),(1938,85),(1939,85),(1940,86),(1941,86),(1942,86),(1943,86),(1944,87),(1945,87),(1946,87),(1947,87),(1948,88),(1949,88),(1950,88),(1951,88),(1952,89),(1953,89),(1954,89),(1955,89),(1956,90),(1957,90),(1958,90),(1959,90),(1960,91),(1961,91),(1962,91),(1963,91),(1964,92),(1965,92),(1966,92),(1967,92),(1968,93),(1969,93),(1970,93),(1971,93),(1972,94),(1973,94),(1974,94),(1975,94),(1976,95),(1977,95),(1978,95),(1979,95),(1980,96),(1981,96),(1982,96),(1983,96),(1984,97),(1985,97),(1986,97),(1987,97),(1988,98),(1989,98),(1990,98),(1991,98),(1992,99),(1993,99),(1994,99),(1995,99),(1996,100),(1997,100),(1998,100),(1999,100),(2000,101),(2001,101),(2002,101),(2003,101),(2004,102),(2005,102),(2006,102),(2007,102),(2008,103),(2009,103),(2010,103),(2011,103),(2012,104),(2013,104),(2014,104),(2015,104),(2016,105),(2017,105),(2018,105),(2019,105),(2020,106),(2021,106),(2022,106),(2023,106),(2024,107),(2025,108),(2026,109),(2027,110),(2028,111),(2029,112),(2030,113),(2031,114),(2032,115),(2033,116),(2034,117),(2035,118),(2036,119),(2037,120),(2038,121),(2039,122),(2040,123),(2041,124),(2042,125),(2043,126),(2044,127),(2045,128),(2046,129),(2047,130),(2048,131),(2049,132),(2050,133),(2051,134),(2052,135),(2053,136),(2054,137),(2055,138),(2056,139),(2057,140),(2058,141),(2059,142),(2060,143),(2061,144),(2062,145),(2063,146),(2064,147),(2065,148),(2066,149),(2067,150),(2068,151),(2069,152),(2070,153),(2071,154),(2072,155),(2073,156),(2074,157),(2075,158),(2076,159),(2077,160),(2078,161),(2079,162),(2080,163),(2081,164),(2082,165),(2083,166),(2084,167),(2085,168),(2086,169),(2087,170),(2088,171),(2089,172),(2090,173),(2091,174),(2092,175),(2093,176),(2094,177),(2095,178),(2096,179),(2097,180),(2098,181),(2099,182),(2100,183),(2101,184),(2102,185),(2103,186),(2104,187),(2105,188),(2106,189),(2107,190),(2108,191),(2109,192),(2110,193),(2111,194),(2112,195),(2113,196),(2114,197),(2115,198),(2116,199),(2117,200),(2118,201),(2119,202),(2120,203),(2121,204),(2122,205),(2123,206),(2124,107),(2125,108),(2126,109),(2127,110),(2128,111),(2129,112),(2130,113),(2131,114),(2132,115),(2133,116),(2134,117),(2135,118),(2136,119),(2137,120),(2138,121),(2139,122),(2140,123),(2141,124),(2142,125),(2143,126),(2144,127),(2145,128),(2146,129),(2147,130),(2148,131),(2149,132),(2150,133),(2151,134),(2152,135),(2153,136),(2154,137),(2155,138),(2156,139),(2157,140),(2158,141),(2159,142),(2160,143),(2161,144),(2162,145),(2163,146),(2164,147),(2165,148),(2166,149),(2167,150),(2168,151),(2169,152),(2170,153),(2171,154),(2172,155),(2173,156),(2174,157),(2175,158),(2176,159),(2177,160),(2178,161),(2179,162),(2180,163),(2181,164),(2182,165),(2183,166),(2184,167),(2185,168),(2186,169),(2187,170),(2188,171),(2189,172),(2190,173),(2191,174),(2192,175),(2193,176),(2194,177),(2195,178),(2196,179),(2197,180),(2198,181),(2199,182),(2200,183),(2201,184),(2202,185),(2203,186),(2204,187),(2205,188),(2206,189),(2207,190),(2208,191),(2209,192),(2210,193),(2211,194),(2212,195),(2213,196),(2214,197),(2215,198),(2216,199),(2217,200),(2218,201),(2219,202),(2220,203),(2221,204),(2222,205),(2223,206),(2224,107),(2225,107),(2226,107),(2227,107),(2228,107),(2229,107),(2230,107),(2231,107),(2232,107),(2233,108),(2234,108),(2235,108),(2236,108),(2237,108),(2238,108),(2239,108),(2240,108),(2241,108),(2242,109),(2243,109),(2244,109),(2245,109),(2246,109),(2247,109),(2248,109),(2249,109),(2250,109),(2251,110),(2252,110),(2253,110),(2254,110),(2255,110),(2256,110),(2257,110),(2258,111),(2259,111),(2260,111),(2261,111),(2262,111),(2263,111),(2264,111),(2265,112),(2266,112),(2267,112),(2268,112),(2269,112),(2270,112),(2271,112),(2272,113),(2273,113),(2274,113),(2275,113),(2276,114),(2277,114),(2278,114),(2279,114),(2280,114),(2281,114),(2282,114),(2283,115),(2284,115),(2285,115),(2286,115),(2287,115),(2288,115),(2289,115),(2290,116),(2291,116),(2292,116),(2293,116),(2294,116),(2295,116),(2296,116),(2297,117),(2298,117),(2299,117),(2300,117),(2301,118),(2302,118),(2303,118),(2304,118),(2305,118),(2306,118),(2307,118),(2308,119),(2309,119),(2310,119),(2311,119),(2312,119),(2313,119),(2314,119),(2315,120),(2316,120),(2317,120),(2318,120),(2319,120),(2320,120),(2321,120),(2322,121),(2323,121),(2324,121),(2325,121),(2326,121),(2327,121),(2328,121),(2329,122),(2330,122),(2331,122),(2332,122),(2333,122),(2334,122),(2335,122),(2336,122),(2337,122),(2338,123),(2339,123),(2340,123),(2341,123),(2342,123),(2343,123),(2344,123),(2345,124),(2346,124),(2347,124),(2348,124),(2349,124),(2350,124),(2351,124),(2352,125),(2353,125),(2354,125),(2355,125),(2356,125),(2357,125),(2358,125),(2359,126),(2360,126),(2361,126),(2362,126),(2363,126),(2364,126),(2365,126),(2366,127),(2367,127),(2368,127),(2369,127),(2370,127),(2371,127),(2372,127),(2373,127),(2374,127),(2375,128),(2376,128),(2377,128),(2378,128),(2379,128),(2380,128),(2381,128),(2382,128),(2383,128),(2384,129),(2385,129),(2386,129),(2387,129),(2388,129),(2389,129),(2390,129),(2391,129),(2392,129),(2393,130),(2394,130),(2395,130),(2396,130),(2397,130),(2398,130),(2399,130),(2400,130),(2401,130),(2402,131),(2403,131),(2404,131),(2405,131),(2406,131),(2407,131),(2408,131),(2409,131),(2410,131),(2411,132),(2412,132),(2413,132),(2414,132),(2415,132),(2416,132),(2417,132),(2418,132),(2419,132),(2420,133),(2421,133),(2422,133),(2423,133),(2424,133),(2425,133),(2426,133),(2427,133),(2428,133),(2429,134),(2430,134),(2431,134),(2432,134),(2433,134),(2434,134),(2435,134),(2436,134),(2437,134),(2438,135),(2439,135),(2440,135),(2441,135),(2442,135),(2443,135),(2444,135),(2445,135),(2446,135),(2447,136),(2448,136),(2449,136),(2450,136),(2451,136),(2452,136),(2453,136),(2454,136),(2455,136),(2456,137),(2457,137),(2458,137),(2459,137),(2460,137),(2461,137),(2462,137),(2463,137),(2464,137),(2465,138),(2466,138),(2467,138),(2468,138),(2469,138),(2470,138),(2471,138),(2472,138),(2473,138),(2474,139),(2475,139),(2476,139),(2477,139),(2478,139),(2479,139),(2480,139),(2481,140),(2482,140),(2483,140),(2484,140),(2485,140),(2486,140),(2487,140),(2488,141),(2489,141),(2490,141),(2491,141),(2492,141),(2493,141),(2494,141),(2495,142),(2496,142),(2497,142),(2498,142),(2499,143),(2500,143),(2501,143),(2502,143),(2503,143),(2504,143),(2505,143),(2506,144),(2507,144),(2508,144),(2509,144),(2510,144),(2511,144),(2512,144),(2513,145),(2514,145),(2515,145),(2516,145),(2517,145),(2518,145),(2519,145),(2520,145),(2521,145),(2522,146),(2523,146),(2524,146),(2525,146),(2526,146),(2527,146),(2528,146),(2529,147),(2530,147),(2531,147),(2532,147),(2533,147),(2534,147),(2535,147),(2536,147),(2537,147),(2538,148),(2539,148),(2540,148),(2541,148),(2542,148),(2543,148),(2544,148),(2545,148),(2546,148),(2547,149),(2548,149),(2549,149),(2550,149),(2551,149),(2552,149),(2553,149),(2554,149),(2555,149),(2556,150),(2557,150),(2558,150),(2559,150),(2560,150),(2561,150),(2562,150),(2563,151),(2564,151),(2565,151),(2566,151),(2567,151),(2568,151),(2569,151),(2570,152),(2571,152),(2572,152),(2573,152),(2574,153),(2575,153),(2576,153),(2577,153),(2578,153),(2579,153),(2580,153),(2581,153),(2582,153),(2583,154),(2584,154),(2585,154),(2586,154),(2587,154),(2588,154),(2589,154),(2590,154),(2591,154),(2592,155),(2593,155),(2594,155),(2595,155),(2596,155),(2597,155),(2598,155),(2599,155),(2600,155),(2601,156),(2602,156),(2603,156),(2604,156),(2605,156),(2606,156),(2607,156),(2608,157),(2609,157),(2610,157),(2611,157),(2612,157),(2613,157),(2614,157),(2615,158),(2616,158),(2617,158),(2618,158),(2619,158),(2620,158),(2621,158),(2622,159),(2623,159),(2624,159),(2625,159),(2626,159),(2627,159),(2628,159),(2629,160),(2630,160),(2631,160),(2632,160),(2633,160),(2634,160),(2635,160),(2636,161),(2637,161),(2638,161),(2639,161),(2640,161),(2641,161),(2642,161),(2643,162),(2644,162),(2645,162),(2646,162),(2647,162),(2648,162),(2649,162),(2650,162),(2651,162),(2652,163),(2653,163),(2654,163),(2655,163),(2656,163),(2657,163),(2658,163),(2659,164),(2660,164),(2661,164),(2662,164),(2663,164),(2664,164),(2665,165),(2666,165),(2667,165),(2668,165),(2669,165),(2670,165),(2671,165),(2672,166),(2673,166),(2674,166),(2675,166),(2676,166),(2677,166),(2678,167),(2679,167),(2680,167),(2681,167),(2682,167),(2683,167),(2684,167),(2685,168),(2686,168),(2687,168),(2688,168),(2689,168),(2690,168),(2691,168),(2692,169),(2693,169),(2694,169),(2695,169),(2696,169),(2697,169),(2698,169),(2699,170),(2700,170),(2701,170),(2702,170),(2703,170),(2704,170),(2705,170),(2706,171),(2707,171),(2708,171),(2709,171),(2710,171),(2711,171),(2712,171),(2713,172),(2714,172),(2715,172),(2716,172),(2717,172),(2718,172),(2719,173),(2720,173),(2721,173),(2722,173),(2723,173),(2724,173),(2725,173),(2726,174),(2727,174),(2728,174),(2729,174),(2730,174),(2731,174),(2732,174),(2733,175),(2734,175),(2735,175),(2736,175),(2737,175),(2738,175),(2739,175),(2740,176),(2741,176),(2742,176),(2743,176),(2744,177),(2745,177),(2746,177),(2747,177),(2748,178),(2749,178),(2750,178),(2751,178),(2752,179),(2753,179),(2754,179),(2755,179),(2756,180),(2757,180),(2758,180),(2759,180),(2760,181),(2761,181),(2762,181),(2763,181),(2764,182),(2765,182),(2766,182),(2767,182),(2768,183),(2769,183),(2770,183),(2771,183),(2772,184),(2773,184),(2774,184),(2775,184),(2776,185),(2777,185),(2778,185),(2779,185),(2780,186),(2781,186),(2782,186),(2783,186),(2784,187),(2785,187),(2786,187),(2787,187),(2788,188),(2789,188),(2790,188),(2791,188),(2792,189),(2793,189),(2794,189),(2795,189),(2796,190),(2797,190),(2798,190),(2799,190),(2800,190),(2801,190),(2802,190),(2803,190),(2804,190),(2805,191),(2806,191),(2807,191),(2808,191),(2809,191),(2810,191),(2811,191),(2812,191),(2813,191),(2814,192),(2815,192),(2816,192),(2817,192),(2818,192),(2819,192),(2820,192),(2821,192),(2822,192),(2823,193),(2824,193),(2825,193),(2826,193),(2827,193),(2828,193),(2829,193),(2830,193),(2831,193),(2832,194),(2833,194),(2834,194),(2835,194),(2836,194),(2837,194),(2838,194),(2839,194),(2840,194),(2841,195),(2842,195),(2843,195),(2844,195),(2845,195),(2846,195),(2847,195),(2848,195),(2849,195),(2850,196),(2851,196),(2852,196),(2853,196),(2854,196),(2855,196),(2856,196),(2857,196),(2858,196),(2859,197),(2860,197),(2861,197),(2862,197),(2863,197),(2864,197),(2865,197),(2866,197),(2867,197),(2868,198),(2869,198),(2870,198),(2871,198),(2872,199),(2873,199),(2874,199),(2875,199),(2876,200),(2877,200),(2878,200),(2879,200),(2880,201),(2881,201),(2882,201),(2883,201),(2884,201),(2885,201),(2886,201),(2887,201),(2888,201),(2889,202),(2890,202),(2891,202),(2892,202),(2893,202),(2894,202),(2895,202),(2896,202),(2897,202),(2898,203),(2899,203),(2900,203),(2901,203),(2902,203),(2903,203),(2904,203),(2905,203),(2906,203),(2907,204),(2908,204),(2909,204),(2910,204),(2911,205),(2912,205),(2913,205),(2914,205),(2915,206),(2916,206),(2917,206),(2918,206),(2919,107),(2920,107),(2921,108),(2922,108),(2923,109),(2924,109),(2925,110),(2926,110),(2927,111),(2928,111),(2929,112),(2930,112),(2931,113),(2932,114),(2933,114),(2934,115),(2935,115),(2936,116),(2937,116),(2938,117),(2939,118),(2940,119),(2941,120),(2942,121),(2943,122),(2944,122),(2945,123),(2946,123),(2947,124),(2948,124),(2949,125),(2950,125),(2951,126),(2952,126),(2953,127),(2954,127),(2955,128),(2956,128),(2957,129),(2958,129),(2959,130),(2960,130),(2961,131),(2962,131),(2963,132),(2964,132),(2965,133),(2966,133),(2967,134),(2968,134),(2969,135),(2970,135),(2971,136),(2972,136),(2973,137),(2974,137),(2975,138),(2976,138),(2977,139),(2978,139),(2979,140),(2980,140),(2981,141),(2982,141),(2983,142),(2984,143),(2985,143),(2986,144),(2987,144),(2988,145),(2989,145),(2990,146),(2991,146),(2992,147),(2993,147),(2994,148),(2995,148),(2996,149),(2997,149),(2998,150),(2999,150),(3000,151),(3001,151),(3002,152),(3003,153),(3004,153),(3005,154),(3006,154),(3007,155),(3008,155),(3009,156),(3010,156),(3011,157),(3012,157),(3013,158),(3014,158),(3015,159),(3016,159),(3017,160),(3018,160),(3019,161),(3020,161),(3021,162),(3022,162),(3023,163),(3024,163),(3025,164),(3026,164),(3027,165),(3028,165),(3029,166),(3030,166),(3031,167),(3032,167),(3033,168),(3034,168),(3035,169),(3036,169),(3037,170),(3038,170),(3039,171),(3040,171),(3041,172),(3042,172),(3043,173),(3044,173),(3045,174),(3046,174),(3047,175),(3048,175),(3049,176),(3050,177),(3051,178),(3052,179),(3053,180),(3054,181),(3055,182),(3056,183),(3057,184),(3058,185),(3059,186),(3060,187),(3061,188),(3062,189),(3063,190),(3064,190),(3065,191),(3066,191),(3067,192),(3068,192),(3069,193),(3070,193),(3071,194),(3072,194),(3073,195),(3074,195),(3075,196),(3076,196),(3077,197),(3078,197),(3079,198),(3080,199),(3081,200),(3082,201),(3083,201),(3084,202),(3085,202),(3086,203),(3087,203),(3088,204),(3089,205),(3090,206),(3091,107),(3092,107),(3093,108),(3094,108),(3095,109),(3096,109),(3097,110),(3098,110),(3099,110),(3100,111),(3101,111),(3102,111),(3103,112),(3104,112),(3105,112),(3106,113),(3107,113),(3108,113),(3109,114),(3110,114),(3111,114),(3112,115),(3113,115),(3114,115),(3115,116),(3116,116),(3117,116),(3118,117),(3119,117),(3120,117),(3121,118),(3122,118),(3123,118),(3124,119),(3125,119),(3126,119),(3127,120),(3128,120),(3129,120),(3130,121),(3131,121),(3132,121),(3133,122),(3134,122),(3135,122),(3136,123),(3137,123),(3138,123),(3139,124),(3140,124),(3141,124),(3142,125),(3143,125),(3144,125),(3145,126),(3146,126),(3147,126),(3148,127),(3149,127),(3150,127),(3151,128),(3152,128),(3153,128),(3154,129),(3155,129),(3156,129),(3157,130),(3158,130),(3159,130),(3160,131),(3161,131),(3162,131),(3163,132),(3164,132),(3165,132),(3166,133),(3167,133),(3168,133),(3169,134),(3170,134),(3171,134),(3172,135),(3173,135),(3174,135),(3175,136),(3176,136),(3177,136),(3178,137),(3179,137),(3180,137),(3181,138),(3182,138),(3183,139),(3184,139),(3185,139),(3186,140),(3187,140),(3188,140),(3189,141),(3190,141),(3191,141),(3192,142),(3193,142),(3194,142),(3195,143),(3196,143),(3197,143),(3198,144),(3199,144),(3200,144),(3201,145),(3202,145),(3203,145),(3204,146),(3205,146),(3206,146),(3207,147),(3208,147),(3209,147),(3210,148),(3211,148),(3212,148),(3213,149),(3214,149),(3215,149),(3216,150),(3217,150),(3218,150),(3219,151),(3220,151),(3221,151),(3222,152),(3223,152),(3224,152),(3225,153),(3226,153),(3227,153),(3228,154),(3229,154),(3230,154),(3231,155),(3232,155),(3233,155),(3234,156),(3235,156),(3236,156),(3237,157),(3238,157),(3239,157),(3240,158),(3241,158),(3242,158),(3243,159),(3244,159),(3245,159),(3246,160),(3247,160),(3248,160),(3249,161),(3250,161),(3251,161),(3252,162),(3253,162),(3254,162),(3255,163),(3256,163),(3257,163),(3258,164),(3259,164),(3260,164),(3261,165),(3262,165),(3263,165),(3264,166),(3265,166),(3266,166),(3267,167),(3268,167),(3269,167),(3270,168),(3271,168),(3272,168),(3273,169),(3274,169),(3275,169),(3276,170),(3277,170),(3278,170),(3279,171),(3280,171),(3281,171),(3282,172),(3283,172),(3284,172),(3285,173),(3286,173),(3287,173),(3288,174),(3289,174),(3290,174),(3291,175),(3292,175),(3293,175),(3294,176),(3295,176),(3296,176),(3297,177),(3298,177),(3299,177),(3300,178),(3301,178),(3302,178),(3303,179),(3304,179),(3305,179),(3306,180),(3307,180),(3308,180),(3309,181),(3310,181),(3311,181),(3312,182),(3313,182),(3314,182),(3315,183),(3316,183),(3317,183),(3318,184),(3319,184),(3320,184),(3321,185),(3322,185),(3323,185),(3324,186),(3325,186),(3326,186),(3327,187),(3328,187),(3329,187),(3330,188),(3331,188),(3332,188),(3333,189),(3334,189),(3335,189),(3336,190),(3337,190),(3338,190),(3339,191),(3340,191),(3341,191),(3342,192),(3343,192),(3344,192),(3345,193),(3346,193),(3347,193),(3348,194),(3349,194),(3350,194),(3351,195),(3352,195),(3353,195),(3354,196),(3355,196),(3356,196),(3357,197),(3358,197),(3359,197),(3360,198),(3361,198),(3362,198),(3363,199),(3364,199),(3365,199),(3366,200),(3367,200),(3368,200),(3369,201),(3370,201),(3371,201),(3372,202),(3373,202),(3374,202),(3375,203),(3376,203),(3377,203),(3378,204),(3379,204),(3380,204),(3381,205),(3382,205),(3383,205),(3384,206),(3385,206),(3386,206),(3387,107),(3388,107),(3389,107),(3390,107),(3391,108),(3392,108),(3393,108),(3394,108),(3395,109),(3396,109),(3397,109),(3398,109),(3399,110),(3400,110),(3401,110),(3402,110),(3403,111),(3404,111),(3405,111),(3406,111),(3407,112),(3408,112),(3409,112),(3410,112),(3411,113),(3412,113),(3413,113),(3414,113),(3415,114),(3416,114),(3417,114),(3418,114),(3419,115),(3420,115),(3421,115),(3422,115),(3423,116),(3424,116),(3425,116),(3426,116),(3427,117),(3428,117),(3429,117),(3430,117),(3431,118),(3432,118),(3433,118),(3434,118),(3435,119),(3436,119),(3437,119),(3438,119),(3439,120),(3440,120),(3441,120),(3442,120),(3443,121),(3444,121),(3445,121),(3446,121),(3447,122),(3448,122),(3449,122),(3450,122),(3451,123),(3452,123),(3453,123),(3454,123),(3455,124),(3456,124),(3457,124),(3458,124),(3459,125),(3460,125),(3461,125),(3462,125),(3463,126),(3464,126),(3465,126),(3466,126),(3467,127),(3468,127),(3469,127),(3470,127),(3471,128),(3472,128),(3473,128),(3474,128),(3475,129),(3476,129),(3477,129),(3478,129),(3479,130),(3480,130),(3481,130),(3482,130),(3483,131),(3484,131),(3485,131),(3486,131),(3487,132),(3488,132),(3489,132),(3490,132),(3491,133),(3492,133),(3493,133),(3494,133),(3495,134),(3496,134),(3497,134),(3498,134),(3499,135),(3500,135),(3501,135),(3502,135),(3503,136),(3504,136),(3505,136),(3506,136),(3507,137),(3508,137),(3509,137),(3510,137),(3511,138),(3512,138),(3513,138),(3514,138),(3515,139),(3516,139),(3517,139),(3518,139),(3519,140),(3520,140),(3521,140),(3522,140),(3523,141),(3524,141),(3525,141),(3526,141),(3527,142),(3528,142),(3529,142),(3530,142),(3531,143),(3532,143),(3533,143),(3534,143),(3535,144),(3536,144),(3537,144),(3538,144),(3539,145),(3540,145),(3541,145),(3542,145),(3543,146),(3544,146),(3545,146),(3546,146),(3547,147),(3548,147),(3549,147),(3550,147),(3551,148),(3552,148),(3553,148),(3554,148),(3555,149),(3556,149),(3557,149),(3558,149),(3559,150),(3560,150),(3561,150),(3562,150),(3563,151),(3564,151),(3565,151),(3566,151),(3567,152),(3568,152),(3569,152),(3570,152),(3571,153),(3572,153),(3573,153),(3574,153),(3575,154),(3576,154),(3577,154),(3578,154),(3579,155),(3580,155),(3581,155),(3582,155),(3583,156),(3584,156),(3585,156),(3586,156),(3587,157),(3588,157),(3589,157),(3590,157),(3591,158),(3592,158),(3593,158),(3594,158),(3595,159),(3596,159),(3597,159),(3598,159),(3599,160),(3600,160),(3601,160),(3602,160),(3603,161),(3604,161),(3605,161),(3606,161),(3607,162),(3608,162),(3609,162),(3610,162),(3611,163),(3612,163),(3613,163),(3614,163),(3615,164),(3616,164),(3617,164),(3618,164),(3619,165),(3620,165),(3621,165),(3622,165),(3623,166),(3624,166),(3625,166),(3626,166),(3627,167),(3628,167),(3629,167),(3630,167),(3631,168),(3632,168),(3633,168),(3634,168),(3635,169),(3636,169),(3637,169),(3638,169),(3639,170),(3640,170),(3641,170),(3642,170),(3643,171),(3644,171),(3645,171),(3646,171),(3647,172),(3648,172),(3649,172),(3650,172),(3651,173),(3652,173),(3653,173),(3654,173),(3655,174),(3656,174),(3657,174),(3658,174),(3659,175),(3660,175),(3661,175),(3662,175),(3663,176),(3664,176),(3665,176),(3666,176),(3667,177),(3668,177),(3669,177),(3670,177),(3671,178),(3672,178),(3673,178),(3674,178),(3675,179),(3676,179),(3677,179),(3678,179),(3679,180),(3680,180),(3681,180),(3682,180),(3683,181),(3684,181),(3685,181),(3686,181),(3687,182),(3688,182),(3689,182),(3690,182),(3691,183),(3692,183),(3693,183),(3694,183),(3695,184),(3696,184),(3697,184),(3698,184),(3699,185),(3700,185),(3701,185),(3702,185),(3703,186),(3704,186),(3705,186),(3706,186),(3707,187),(3708,187),(3709,187),(3710,187),(3711,188),(3712,188),(3713,188),(3714,188),(3715,189),(3716,189),(3717,189),(3718,189),(3719,190),(3720,190),(3721,190),(3722,190),(3723,191),(3724,191),(3725,191),(3726,191),(3727,192),(3728,192),(3729,192),(3730,192),(3731,193),(3732,193),(3733,193),(3734,193),(3735,194),(3736,194),(3737,194),(3738,194),(3739,195),(3740,195),(3741,195),(3742,195),(3743,196),(3744,196),(3745,196),(3746,196),(3747,197),(3748,197),(3749,197),(3750,197),(3751,198),(3752,198),(3753,198),(3754,198),(3755,199),(3756,199),(3757,199),(3758,199),(3759,200),(3760,200),(3761,200),(3762,200),(3763,201),(3764,201),(3765,201),(3766,201),(3767,202),(3768,202),(3769,202),(3770,202),(3771,203),(3772,203),(3773,203),(3774,203),(3775,204),(3776,204),(3777,204),(3778,204),(3779,205),(3780,205),(3781,205),(3782,205),(3783,206),(3784,206),(3785,206),(3786,206),(3787,207),(3788,208),(3789,209),(3790,210),(3791,211),(3792,212),(3793,213),(3794,214),(3795,215),(3796,216),(3797,217),(3798,218),(3799,219),(3800,220),(3801,221),(3802,222),(3803,223),(3804,224),(3805,225),(3806,226),(3807,227),(3808,228),(3809,229),(3810,230),(3811,231),(3812,232),(3813,233),(3814,234),(3815,235),(3816,236),(3817,237),(3818,238),(3819,239),(3820,240),(3821,241),(3822,242),(3823,243),(3824,244),(3825,245),(3826,246),(3827,247),(3828,248),(3829,249),(3830,250),(3831,251),(3832,252),(3833,253),(3834,254),(3835,255),(3836,256),(3837,257),(3838,258),(3839,259),(3840,260),(3841,261),(3842,262),(3843,263),(3844,264),(3845,265),(3846,266),(3847,267),(3848,268),(3849,269),(3850,270),(3851,271),(3852,272),(3853,273),(3854,274),(3855,275),(3856,276),(3857,277),(3858,278),(3859,279),(3860,280),(3861,207),(3862,208),(3863,209),(3864,210),(3865,211),(3866,212),(3867,213),(3868,214),(3869,215),(3870,216),(3871,217),(3872,218),(3873,219),(3874,220),(3875,221),(3876,222),(3877,223),(3878,224),(3879,225),(3880,226),(3881,227),(3882,228),(3883,229),(3884,230),(3885,231),(3886,232),(3887,233),(3888,234),(3889,235),(3890,236),(3891,237),(3892,238),(3893,239),(3894,240),(3895,241),(3896,242),(3897,243),(3898,244),(3899,245),(3900,246),(3901,247),(3902,248),(3903,249),(3904,250),(3905,251),(3906,252),(3907,253),(3908,254),(3909,255),(3910,256),(3911,257),(3912,258),(3913,259),(3914,260),(3915,261),(3916,262),(3917,263),(3918,264),(3919,265),(3920,266),(3921,267),(3922,268),(3923,269),(3924,270),(3925,271),(3926,272),(3927,273),(3928,274),(3929,275),(3930,276),(3931,277),(3932,278),(3933,279),(3934,280),(3935,207),(3936,207),(3937,207),(3938,207),(3939,208),(3940,208),(3941,208),(3942,208),(3943,209),(3944,209),(3945,209),(3946,209),(3947,210),(3948,210),(3949,210),(3950,210),(3951,211),(3952,211),(3953,211),(3954,211),(3955,212),(3956,212),(3957,212),(3958,212),(3959,213),(3960,213),(3961,213),(3962,213),(3963,214),(3964,214),(3965,214),(3966,214),(3967,215),(3968,215),(3969,215),(3970,215),(3971,216),(3972,216),(3973,216),(3974,216),(3975,217),(3976,217),(3977,217),(3978,217),(3979,218),(3980,218),(3981,218),(3982,218),(3983,219),(3984,219),(3985,219),(3986,219),(3987,220),(3988,220),(3989,220),(3990,220),(3991,221),(3992,221),(3993,221),(3994,221),(3995,221),(3996,221),(3997,221),(3998,222),(3999,222),(4000,222),(4001,222),(4002,222),(4003,222),(4004,222),(4005,223),(4006,223),(4007,223),(4008,223),(4009,223),(4010,223),(4011,223),(4012,224),(4013,224),(4014,224),(4015,224),(4016,224),(4017,224),(4018,224),(4019,225),(4020,225),(4021,225),(4022,225),(4023,225),(4024,225),(4025,225),(4026,226),(4027,226),(4028,226),(4029,226),(4030,226),(4031,226),(4032,226),(4033,227),(4034,227),(4035,227),(4036,227),(4037,227),(4038,227),(4039,227),(4040,228),(4041,228),(4042,228),(4043,228),(4044,228),(4045,228),(4046,228),(4047,229),(4048,229),(4049,229),(4050,229),(4051,229),(4052,229),(4053,229),(4054,230),(4055,230),(4056,230),(4057,230),(4058,230),(4059,230),(4060,230),(4061,231),(4062,231),(4063,231),(4064,231),(4065,231),(4066,231),(4067,231),(4068,232),(4069,232),(4070,232),(4071,232),(4072,232),(4073,232),(4074,232),(4075,233),(4076,233),(4077,233),(4078,233),(4079,233),(4080,233),(4081,233),(4082,234),(4083,234),(4084,234),(4085,234),(4086,234),(4087,234),(4088,234),(4089,235),(4090,235),(4091,235),(4092,235),(4093,235),(4094,235),(4095,235),(4096,236),(4097,236),(4098,236),(4099,236),(4100,236),(4101,236),(4102,236),(4103,237),(4104,237),(4105,237),(4106,237),(4107,237),(4108,237),(4109,237),(4110,238),(4111,238),(4112,238),(4113,238),(4114,238),(4115,238),(4116,238),(4117,239),(4118,239),(4119,239),(4120,239),(4121,239),(4122,239),(4123,239),(4124,240),(4125,240),(4126,240),(4127,240),(4128,240),(4129,240),(4130,240),(4131,241),(4132,241),(4133,241),(4134,241),(4135,241),(4136,241),(4137,241),(4138,242),(4139,242),(4140,242),(4141,242),(4142,242),(4143,242),(4144,242),(4145,243),(4146,243),(4147,243),(4148,243),(4149,243),(4150,243),(4151,243),(4152,244),(4153,244),(4154,244),(4155,244),(4156,244),(4157,244),(4158,244),(4159,244),(4160,244),(4161,245),(4162,245),(4163,245),(4164,245),(4165,245),(4166,245),(4167,245),(4168,245),(4169,245),(4170,246),(4171,246),(4172,246),(4173,246),(4174,246),(4175,246),(4176,246),(4177,247),(4178,247),(4179,247),(4180,247),(4181,247),(4182,247),(4183,247),(4184,248),(4185,248),(4186,248),(4187,248),(4188,248),(4189,248),(4190,248),(4191,249),(4192,249),(4193,249),(4194,249),(4195,249),(4196,249),(4197,249),(4198,250),(4199,250),(4200,250),(4201,250),(4202,250),(4203,250),(4204,250),(4205,251),(4206,251),(4207,251),(4208,251),(4209,251),(4210,251),(4211,251),(4212,251),(4213,251),(4214,252),(4215,252),(4216,252),(4217,252),(4218,252),(4219,252),(4220,252),(4221,253),(4222,253),(4223,253),(4224,253),(4225,253),(4226,253),(4227,253),(4228,254),(4229,254),(4230,254),(4231,254),(4232,254),(4233,254),(4234,255),(4235,255),(4236,255),(4237,255),(4238,255),(4239,255),(4240,256),(4241,256),(4242,256),(4243,256),(4244,256),(4245,256),(4246,257),(4247,257),(4248,257),(4249,257),(4250,257),(4251,257),(4252,258),(4253,258),(4254,258),(4255,258),(4256,258),(4257,258),(4258,258),(4259,259),(4260,259),(4261,259),(4262,259),(4263,259),(4264,259),(4265,259),(4266,260),(4267,260),(4268,260),(4269,260),(4270,260),(4271,260),(4272,260),(4273,261),(4274,261),(4275,261),(4276,261),(4277,261),(4278,261),(4279,261),(4280,262),(4281,262),(4282,262),(4283,262),(4284,262),(4285,262),(4286,262),(4287,263),(4288,263),(4289,263),(4290,263),(4291,263),(4292,263),(4293,263),(4294,264),(4295,264),(4296,264),(4297,264),(4298,264),(4299,264),(4300,264),(4301,265),(4302,265),(4303,265),(4304,265),(4305,265),(4306,265),(4307,265),(4308,266),(4309,266),(4310,266),(4311,266),(4312,266),(4313,266),(4314,266),(4315,267),(4316,267),(4317,267),(4318,267),(4319,267),(4320,267),(4321,267),(4322,268),(4323,268),(4324,268),(4325,268),(4326,268),(4327,268),(4328,268),(4329,268),(4330,268),(4331,269),(4332,269),(4333,269),(4334,269),(4335,269),(4336,269),(4337,269),(4338,269),(4339,269),(4340,270),(4341,270),(4342,270),(4343,270),(4344,270),(4345,270),(4346,270),(4347,270),(4348,270),(4349,271),(4350,271),(4351,271),(4352,271),(4353,271),(4354,271),(4355,271),(4356,271),(4357,271),(4358,272),(4359,272),(4360,272),(4361,272),(4362,272),(4363,272),(4364,272),(4365,272),(4366,272),(4367,273),(4368,273),(4369,273),(4370,273),(4371,273),(4372,273),(4373,273),(4374,273),(4375,273),(4376,274),(4377,274),(4378,274),(4379,274),(4380,274),(4381,274),(4382,274),(4383,274),(4384,274),(4385,275),(4386,275),(4387,275),(4388,275),(4389,275),(4390,275),(4391,275),(4392,275),(4393,275),(4394,276),(4395,276),(4396,276),(4397,276),(4398,276),(4399,276),(4400,276),(4401,277),(4402,277),(4403,277),(4404,277),(4405,277),(4406,277),(4407,277),(4408,278),(4409,278),(4410,278),(4411,278),(4412,278),(4413,278),(4414,278),(4415,279),(4416,279),(4417,279),(4418,279),(4419,279),(4420,279),(4421,279),(4422,280),(4423,280),(4424,280),(4425,280),(4426,280),(4427,280),(4428,280),(4429,207),(4430,208),(4431,209),(4432,210),(4433,211),(4434,212),(4435,213),(4436,214),(4437,215),(4438,216),(4439,217),(4440,218),(4441,219),(4442,220),(4443,221),(4444,221),(4445,222),(4446,222),(4447,223),(4448,223),(4449,224),(4450,224),(4451,225),(4452,225),(4453,226),(4454,226),(4455,227),(4456,227),(4457,228),(4458,228),(4459,229),(4460,229),(4461,230),(4462,230),(4463,231),(4464,231),(4465,232),(4466,232),(4467,233),(4468,233),(4469,234),(4470,234),(4471,235),(4472,235),(4473,236),(4474,236),(4475,237),(4476,237),(4477,238),(4478,238),(4479,239),(4480,239),(4481,240),(4482,241),(4483,242),(4484,243),(4485,244),(4486,244),(4487,245),(4488,245),(4489,246),(4490,247),(4491,248),(4492,249),(4493,249),(4494,250),(4495,250),(4496,251),(4497,251),(4498,252),(4499,252),(4500,253),(4501,253),(4502,254),(4503,254),(4504,255),(4505,255),(4506,256),(4507,256),(4508,257),(4509,257),(4510,258),(4511,259),(4512,260),(4513,261),(4514,262),(4515,263),(4516,264),(4517,265),(4518,266),(4519,266),(4520,267),(4521,267),(4522,268),(4523,268),(4524,269),(4525,269),(4526,270),(4527,270),(4528,271),(4529,271),(4530,272),(4531,272),(4532,273),(4533,273),(4534,274),(4535,274),(4536,275),(4537,275),(4538,276),(4539,276),(4540,277),(4541,277),(4542,278),(4543,278),(4544,279),(4545,279),(4546,280),(4547,280),(4548,207),(4549,207),(4550,207),(4551,208),(4552,208),(4553,208),(4554,209),(4555,209),(4556,209),(4557,210),(4558,210),(4559,210),(4560,211),(4561,211),(4562,211),(4563,212),(4564,212),(4565,212),(4566,213),(4567,213),(4568,213),(4569,214),(4570,214),(4571,214),(4572,215),(4573,215),(4574,215),(4575,216),(4576,216),(4577,216),(4578,217),(4579,217),(4580,217),(4581,218),(4582,218),(4583,218),(4584,219),(4585,219),(4586,219),(4587,220),(4588,220),(4589,220),(4590,221),(4591,221),(4592,221),(4593,222),(4594,222),(4595,222),(4596,223),(4597,223),(4598,223),(4599,224),(4600,224),(4601,224),(4602,225),(4603,225),(4604,225),(4605,226),(4606,226),(4607,226),(4608,227),(4609,227),(4610,227),(4611,228),(4612,228),(4613,228),(4614,229),(4615,229),(4616,229),(4617,230),(4618,230),(4619,230),(4620,231),(4621,231),(4622,231),(4623,232),(4624,232),(4625,232),(4626,233),(4627,233),(4628,233),(4629,234),(4630,234),(4631,234),(4632,235),(4633,235),(4634,235),(4635,236),(4636,236),(4637,236),(4638,237),(4639,237),(4640,237),(4641,238),(4642,238),(4643,238),(4644,239),(4645,239),(4646,239),(4647,240),(4648,240),(4649,240),(4650,241),(4651,241),(4652,241),(4653,242),(4654,242),(4655,242),(4656,243),(4657,243),(4658,243),(4659,244),(4660,244),(4661,245),(4662,245),(4663,246),(4664,246),(4665,246),(4666,247),(4667,247),(4668,247),(4669,248),(4670,248),(4671,248),(4672,249),(4673,249),(4674,249),(4675,250),(4676,250),(4677,250),(4678,251),(4679,251),(4680,252),(4681,252),(4682,252),(4683,253),(4684,253),(4685,253),(4686,254),(4687,254),(4688,254),(4689,255),(4690,255),(4691,255),(4692,256),(4693,256),(4694,256),(4695,257),(4696,257),(4697,257),(4698,258),(4699,258),(4700,258),(4701,259),(4702,259),(4703,259),(4704,260),(4705,260),(4706,260),(4707,261),(4708,261),(4709,261),(4710,262),(4711,262),(4712,262),(4713,263),(4714,263),(4715,263),(4716,264),(4717,264),(4718,264),(4719,265),(4720,265),(4721,265),(4722,266),(4723,266),(4724,266),(4725,267),(4726,267),(4727,267),(4728,268),(4729,268),(4730,268),(4731,269),(4732,269),(4733,269),(4734,270),(4735,270),(4736,270),(4737,271),(4738,271),(4739,271),(4740,272),(4741,272),(4742,272),(4743,273),(4744,273),(4745,273),(4746,274),(4747,274),(4748,274),(4749,275),(4750,275),(4751,275),(4752,276),(4753,276),(4754,276),(4755,277),(4756,277),(4757,277),(4758,278),(4759,278),(4760,278),(4761,279),(4762,279),(4763,279),(4764,280),(4765,280),(4766,280),(4767,207),(4768,207),(4769,207),(4770,207),(4771,208),(4772,208),(4773,208),(4774,208),(4775,209),(4776,209),(4777,209),(4778,209),(4779,210),(4780,210),(4781,210),(4782,210),(4783,211),(4784,211),(4785,211),(4786,211),(4787,212),(4788,212),(4789,212),(4790,212),(4791,213),(4792,213),(4793,213),(4794,213),(4795,214),(4796,214),(4797,214),(4798,214),(4799,215),(4800,215),(4801,215),(4802,215),(4803,216),(4804,216),(4805,216),(4806,216),(4807,217),(4808,217),(4809,217),(4810,217),(4811,218),(4812,218),(4813,218),(4814,218),(4815,219),(4816,219),(4817,219),(4818,219),(4819,220),(4820,220),(4821,220),(4822,220),(4823,221),(4824,221),(4825,221),(4826,221),(4827,222),(4828,222),(4829,222),(4830,222),(4831,223),(4832,223),(4833,223),(4834,223),(4835,224),(4836,224),(4837,224),(4838,224),(4839,225),(4840,225),(4841,225),(4842,225),(4843,226),(4844,226),(4845,226),(4846,226),(4847,227),(4848,227),(4849,227),(4850,227),(4851,228),(4852,228),(4853,228),(4854,228),(4855,229),(4856,229),(4857,229),(4858,229),(4859,230),(4860,230),(4861,230),(4862,230),(4863,231),(4864,231),(4865,231),(4866,231),(4867,232),(4868,232),(4869,232),(4870,232),(4871,233),(4872,233),(4873,233),(4874,233),(4875,234),(4876,234),(4877,234),(4878,234),(4879,235),(4880,235),(4881,235),(4882,235),(4883,236),(4884,236),(4885,236),(4886,236),(4887,237),(4888,237),(4889,237),(4890,237),(4891,238),(4892,238),(4893,238),(4894,238),(4895,239),(4896,239),(4897,239),(4898,239),(4899,240),(4900,240),(4901,240),(4902,240),(4903,241),(4904,241),(4905,241),(4906,241),(4907,242),(4908,242),(4909,242),(4910,242),(4911,243),(4912,243),(4913,243),(4914,243),(4915,244),(4916,244),(4917,244),(4918,244),(4919,245),(4920,245),(4921,245),(4922,245),(4923,246),(4924,246),(4925,246),(4926,246),(4927,247),(4928,247),(4929,247),(4930,247),(4931,248),(4932,248),(4933,248),(4934,248),(4935,249),(4936,249),(4937,249),(4938,249),(4939,250),(4940,250),(4941,250),(4942,250),(4943,251),(4944,251),(4945,251),(4946,251),(4947,252),(4948,252),(4949,252),(4950,252),(4951,253),(4952,253),(4953,253),(4954,253),(4955,254),(4956,254),(4957,254),(4958,254),(4959,255),(4960,255),(4961,255),(4962,255),(4963,256),(4964,256),(4965,256),(4966,256),(4967,257),(4968,257),(4969,257),(4970,257),(4971,258),(4972,258),(4973,258),(4974,258),(4975,259),(4976,259),(4977,259),(4978,259),(4979,260),(4980,260),(4981,260),(4982,260),(4983,261),(4984,261),(4985,261),(4986,261),(4987,262),(4988,262),(4989,262),(4990,262),(4991,263),(4992,263),(4993,263),(4994,263),(4995,264),(4996,264),(4997,264),(4998,264),(4999,265),(5000,265),(5001,265),(5002,265),(5003,266),(5004,266),(5005,266),(5006,266),(5007,267),(5008,267),(5009,267),(5010,267),(5011,268),(5012,268),(5013,268),(5014,268),(5015,269),(5016,269),(5017,269),(5018,269),(5019,270),(5020,270),(5021,270),(5022,270),(5023,271),(5024,271),(5025,271),(5026,271),(5027,272),(5028,272),(5029,272),(5030,272),(5031,273),(5032,273),(5033,273),(5034,273),(5035,274),(5036,274),(5037,274),(5038,274),(5039,275),(5040,275),(5041,275),(5042,275),(5043,276),(5044,276),(5045,276),(5046,276),(5047,277),(5048,277),(5049,277),(5050,277),(5051,278),(5052,278),(5053,278),(5054,278),(5055,279),(5056,279),(5057,279),(5058,279),(5059,280),(5060,280),(5061,280),(5062,280),(5063,7),(5064,8),(5065,9),(5066,10),(5067,11),(5068,12),(5069,13),(5070,14),(5071,15),(5072,16),(5073,17),(5074,18),(5075,19),(5076,20),(5077,21),(5078,22),(5079,23),(5080,24),(5081,25),(5082,26),(5083,27),(5084,28),(5085,29),(5086,30),(5087,31),(5088,32),(5089,33),(5090,34),(5091,35),(5092,36),(5093,37),(5094,38),(5095,39),(5096,40),(5097,41),(5098,42),(5099,43),(5100,44),(5101,45),(5102,46),(5103,47),(5104,48),(5105,49),(5106,50),(5107,51),(5108,52),(5109,53),(5110,54),(5111,55),(5112,56),(5113,57),(5114,58),(5115,59),(5116,60),(5117,61),(5118,62),(5119,63),(5120,64),(5121,65),(5122,66),(5123,67),(5124,68),(5125,69),(5126,70),(5127,71),(5128,72),(5129,73),(5130,74),(5131,75),(5132,76),(5133,77),(5134,78),(5135,79),(5136,80),(5137,81),(5138,82),(5139,83),(5140,84),(5141,85),(5142,86),(5143,87),(5144,88),(5145,89),(5146,90),(5147,91),(5148,92),(5149,93),(5150,94),(5151,95),(5152,96),(5153,97),(5154,98),(5155,99),(5156,100),(5157,101),(5158,102),(5159,103),(5160,104),(5161,105),(5162,106),(5163,107),(5164,108),(5165,109),(5166,110),(5167,111),(5168,112),(5169,113),(5170,114),(5171,115),(5172,116),(5173,117),(5174,118),(5175,119),(5176,120),(5177,121),(5178,122),(5179,123),(5180,124),(5181,125),(5182,126),(5183,127),(5184,128),(5185,129),(5186,130),(5187,131),(5188,132),(5189,133),(5190,134),(5191,135),(5192,136),(5193,137),(5194,138),(5195,139),(5196,140),(5197,141),(5198,142),(5199,143),(5200,144),(5201,145),(5202,146),(5203,147),(5204,148),(5205,149),(5206,150),(5207,151),(5208,152),(5209,153),(5210,154),(5211,155),(5212,156),(5213,157),(5214,158),(5215,159),(5216,160),(5217,161),(5218,162),(5219,163),(5220,164),(5221,165),(5222,166),(5223,167),(5224,168),(5225,169),(5226,170),(5227,171),(5228,172),(5229,173),(5230,174),(5231,175),(5232,176),(5233,177),(5234,178),(5235,179),(5236,180),(5237,181),(5238,182),(5239,183),(5240,184),(5241,185),(5242,186),(5243,187),(5244,188),(5245,189),(5246,190),(5247,191),(5248,192),(5249,193),(5250,194),(5251,195),(5252,196),(5253,197),(5254,198),(5255,199),(5256,200),(5257,201),(5258,202),(5259,203),(5260,204),(5261,205),(5262,206),(5263,207),(5264,208),(5265,209),(5266,210),(5267,211),(5268,212),(5269,213),(5270,214),(5271,215),(5272,216),(5273,217),(5274,218),(5275,219),(5276,220),(5277,221),(5278,222),(5279,223),(5280,224),(5281,225),(5282,226),(5283,227),(5284,228),(5285,229),(5286,230),(5287,231),(5288,232),(5289,233),(5290,234),(5291,235),(5292,236),(5293,237),(5294,238),(5295,239),(5296,240),(5297,241),(5298,242),(5299,243),(5300,244),(5301,245),(5302,246),(5303,247),(5304,248),(5305,249),(5306,251),(5307,252),(5308,253),(5309,254),(5310,255),(5311,256),(5312,257),(5313,258),(5314,259),(5315,260),(5316,261),(5317,262),(5318,263),(5319,264),(5320,265),(5321,266),(5322,267),(5323,268),(5324,269),(5325,270),(5326,271),(5327,272),(5328,273),(5329,274),(5330,275),(5331,276),(5332,277),(5333,278),(5334,279),(5335,280),(5336,250),(5337,281),(5338,282),(5339,283),(5340,284),(5341,285),(5342,286),(5343,287),(5344,288),(5345,289),(5346,290),(5347,291),(5348,292),(5349,293),(5350,294),(5351,295),(5352,296),(5353,297),(5354,298),(5355,299),(5356,300),(5357,301),(5358,302),(5359,303),(5360,304),(5361,305),(5362,306),(5363,307),(5364,308),(5365,309),(5366,310),(5367,311),(5368,312),(5369,313),(5370,314),(5371,315),(5372,316),(5373,317),(5374,318),(5375,319),(5376,320),(5377,321),(5378,322),(5379,323),(5380,324),(5381,325),(5382,326),(5383,327),(5384,328),(5385,329),(5386,330),(5387,331),(5388,332),(5389,333),(5390,334),(5391,335),(5392,336),(5393,337),(5394,338),(5395,339),(5396,340),(5397,341),(5398,342),(5399,343),(5400,344),(5401,345),(5402,346),(5403,347),(5404,348),(5405,349),(5406,350),(5407,351),(5408,352),(5409,353),(5410,354),(5411,355),(5412,356),(5413,357),(5414,358),(5415,359),(5416,360),(5417,361),(5418,362),(5419,363),(5420,364),(5421,365),(5422,366),(5423,367),(5424,368),(5425,369),(5426,370),(5427,371),(5428,372),(5429,373),(5430,374),(5431,375),(5432,376),(5433,377),(5434,378),(5435,379),(5436,380),(5437,281),(5438,282),(5439,283),(5440,284),(5441,285),(5442,286),(5443,287),(5444,288),(5445,289),(5446,290),(5447,291),(5448,292),(5449,293),(5450,294),(5451,295),(5452,296),(5453,297),(5454,298),(5455,299),(5456,300),(5457,301),(5458,302),(5459,303),(5460,304),(5461,305),(5462,306),(5463,307),(5464,308),(5465,309),(5466,310),(5467,311),(5468,312),(5469,313),(5470,314),(5471,315),(5472,316),(5473,317),(5474,318),(5475,319),(5476,320),(5477,321),(5478,322),(5479,323),(5480,324),(5481,325),(5482,326),(5483,327),(5484,328),(5485,329),(5486,330),(5487,331),(5488,332),(5489,333),(5490,334),(5491,335),(5492,336),(5493,337),(5494,338),(5495,339),(5496,340),(5497,341),(5498,342),(5499,343),(5500,344),(5501,345),(5502,346),(5503,347),(5504,348),(5505,349),(5506,350),(5507,351),(5508,352),(5509,353),(5510,354),(5511,355),(5512,356),(5513,357),(5514,358),(5515,359),(5516,360),(5517,361),(5518,362),(5519,363),(5520,364),(5521,365),(5522,366),(5523,367),(5524,368),(5525,369),(5526,370),(5527,371),(5528,372),(5529,373),(5530,374),(5531,375),(5532,376),(5533,377),(5534,378),(5535,379),(5536,380),(5537,281),(5538,281),(5539,282),(5540,282),(5541,283),(5542,283),(5543,284),(5544,284),(5545,285),(5546,285),(5547,286),(5548,286),(5549,287),(5550,287),(5551,288),(5552,288),(5553,289),(5554,289),(5555,290),(5556,290),(5557,291),(5558,291),(5559,292),(5560,292),(5561,293),(5562,293),(5563,294),(5564,294),(5565,295),(5566,295),(5567,296),(5568,296),(5569,297),(5570,297),(5571,298),(5572,298),(5573,299),(5574,299),(5575,300),(5576,300),(5577,301),(5578,301),(5579,302),(5580,302),(5581,303),(5582,303),(5583,304),(5584,304),(5585,305),(5586,305),(5587,306),(5588,306),(5589,307),(5590,307),(5591,308),(5592,308),(5593,309),(5594,309),(5595,310),(5596,310),(5597,311),(5598,311),(5599,312),(5600,312),(5601,313),(5602,313),(5603,314),(5604,314),(5605,315),(5606,315),(5607,316),(5608,316),(5609,317),(5610,317),(5611,318),(5612,318),(5613,319),(5614,319),(5615,320),(5616,320),(5617,321),(5618,321),(5619,322),(5620,322),(5621,323),(5622,323),(5623,324),(5624,324),(5625,325),(5626,325),(5627,326),(5628,326),(5629,327),(5630,327),(5631,328),(5632,328),(5633,329),(5634,329),(5635,330),(5636,330),(5637,331),(5638,331),(5639,332),(5640,332),(5641,333),(5642,333),(5643,334),(5644,334),(5645,335),(5646,335),(5647,336),(5648,336),(5649,337),(5650,337),(5651,338),(5652,338),(5653,339),(5654,339),(5655,340),(5656,340),(5657,341),(5658,341),(5659,342),(5660,342),(5661,343),(5662,343),(5663,344),(5664,344),(5665,345),(5666,345),(5667,346),(5668,346),(5669,347),(5670,347),(5671,348),(5672,348),(5673,349),(5674,349),(5675,350),(5676,350),(5677,351),(5678,351),(5679,352),(5680,352),(5681,353),(5682,353),(5683,354),(5684,354),(5685,355),(5686,355),(5687,356),(5688,356),(5689,357),(5690,357),(5691,358),(5692,358),(5693,359),(5694,359),(5695,360),(5696,360),(5697,361),(5698,361),(5699,362),(5700,362),(5701,363),(5702,363),(5703,364),(5704,364),(5705,365),(5706,365),(5707,366),(5708,366),(5709,367),(5710,367),(5711,368),(5712,368),(5713,369),(5714,369),(5715,370),(5716,370),(5717,371),(5718,371),(5719,372),(5720,372),(5721,373),(5722,373),(5723,374),(5724,374),(5725,375),(5726,375),(5727,376),(5728,376),(5729,377),(5730,377),(5731,378),(5732,378),(5733,379),(5734,379),(5735,380),(5736,380),(5737,281),(5738,281),(5739,281),(5740,281),(5741,281),(5742,281),(5743,282),(5744,282),(5745,282),(5746,282),(5747,283),(5748,283),(5749,283),(5750,283),(5751,284),(5752,284),(5753,284),(5754,284),(5755,284),(5756,284),(5757,285),(5758,285),(5759,285),(5760,285),(5761,286),(5762,286),(5763,286),(5764,286),(5765,286),(5766,286),(5767,287),(5768,287),(5769,287),(5770,287),(5771,287),(5772,287),(5773,288),(5774,288),(5775,288),(5776,288),(5777,289),(5778,289),(5779,289),(5780,289),(5781,289),(5782,289),(5783,290),(5784,290),(5785,290),(5786,290),(5787,291),(5788,291),(5789,291),(5790,291),(5791,291),(5792,291),(5793,292),(5794,292),(5795,292),(5796,292),(5797,292),(5798,292),(5799,293),(5800,293),(5801,293),(5802,293),(5803,294),(5804,294),(5805,294),(5806,294),(5807,294),(5808,294),(5809,295),(5810,295),(5811,295),(5812,295),(5813,296),(5814,296),(5815,296),(5816,296),(5817,296),(5818,296),(5819,297),(5820,297),(5821,297),(5822,297),(5823,297),(5824,297),(5825,298),(5826,298),(5827,298),(5828,298),(5829,298),(5830,298),(5831,299),(5832,299),(5833,299),(5834,299),(5835,299),(5836,299),(5837,300),(5838,300),(5839,300),(5840,300),(5841,300),(5842,300),(5843,301),(5844,301),(5845,301),(5846,301),(5847,302),(5848,302),(5849,302),(5850,302),(5851,303),(5852,303),(5853,303),(5854,303),(5855,304),(5856,304),(5857,304),(5858,304),(5859,304),(5860,304),(5861,305),(5862,305),(5863,305),(5864,305),(5865,306),(5866,306),(5867,306),(5868,306),(5869,307),(5870,307),(5871,307),(5872,307),(5873,307),(5874,307),(5875,308),(5876,308),(5877,308),(5878,308),(5879,308),(5880,309),(5881,309),(5882,309),(5883,309),(5884,310),(5885,310),(5886,310),(5887,310),(5888,311),(5889,311),(5890,311),(5891,311),(5892,311),(5893,312),(5894,312),(5895,312),(5896,312),(5897,312),(5898,312),(5899,313),(5900,313),(5901,313),(5902,313),(5903,314),(5904,314),(5905,314),(5906,314),(5907,314),(5908,314),(5909,315),(5910,315),(5911,315),(5912,315),(5913,316),(5914,316),(5915,316),(5916,316),(5917,317),(5918,317),(5919,317),(5920,317),(5921,317),(5922,317),(5923,318),(5924,318),(5925,318),(5926,318),(5927,319),(5928,319),(5929,319),(5930,319),(5931,319),(5932,319),(5933,320),(5934,320),(5935,320),(5936,320),(5937,320),(5938,320),(5939,321),(5940,321),(5941,321),(5942,321),(5943,321),(5944,321),(5945,322),(5946,322),(5947,322),(5948,322),(5949,322),(5950,322),(5951,323),(5952,323),(5953,323),(5954,323),(5955,323),(5956,323),(5957,324),(5958,324),(5959,324),(5960,324),(5961,325),(5962,325),(5963,325),(5964,325),(5965,326),(5966,326),(5967,326),(5968,326),(5969,327),(5970,327),(5971,327),(5972,327),(5973,328),(5974,328),(5975,328),(5976,328),(5977,329),(5978,329),(5979,329),(5980,329),(5981,330),(5982,330),(5983,330),(5984,330),(5985,331),(5986,331),(5987,331),(5988,331),(5989,332),(5990,332),(5991,332),(5992,332),(5993,332),(5994,333),(5995,333),(5996,333),(5997,333),(5998,333),(5999,334),(6000,334),(6001,334),(6002,334),(6003,334),(6004,334),(6005,335),(6006,335),(6007,335),(6008,335),(6009,335),(6010,335),(6011,336),(6012,336),(6013,336),(6014,336),(6015,336),(6016,337),(6017,337),(6018,337),(6019,337),(6020,337),(6021,338),(6022,338),(6023,338),(6024,338),(6025,338),(6026,338),(6027,339),(6028,339),(6029,339),(6030,339),(6031,339),(6032,339),(6033,340),(6034,340),(6035,340),(6036,340),(6037,340),(6038,340),(6039,341),(6040,341),(6041,341),(6042,341),(6043,341),(6044,341),(6045,342),(6046,342),(6047,342),(6048,342),(6049,342),(6050,342),(6051,343),(6052,343),(6053,343),(6054,343),(6055,344),(6056,344),(6057,344),(6058,344),(6059,344),(6060,344),(6061,345),(6062,345),(6063,345),(6064,345),(6065,345),(6066,345),(6067,346),(6068,346),(6069,346),(6070,346),(6071,346),(6072,347),(6073,347),(6074,347),(6075,347),(6076,348),(6077,348),(6078,348),(6079,348),(6080,348),(6081,348),(6082,349),(6083,349),(6084,349),(6085,349),(6086,349),(6087,349),(6088,350),(6089,350),(6090,350),(6091,350),(6092,350),(6093,350),(6094,351),(6095,351),(6096,351),(6097,351),(6098,351),(6099,351),(6100,352),(6101,352),(6102,352),(6103,352),(6104,352),(6105,352),(6106,353),(6107,353),(6108,353),(6109,353),(6110,353),(6111,353),(6112,354),(6113,354),(6114,354),(6115,354),(6116,354),(6117,354),(6118,355),(6119,355),(6120,355),(6121,355),(6122,355),(6123,355),(6124,356),(6125,356),(6126,356),(6127,356),(6128,356),(6129,356),(6130,357),(6131,357),(6132,357),(6133,357),(6134,357),(6135,357),(6136,358),(6137,358),(6138,358),(6139,358),(6140,358),(6141,358),(6142,359),(6143,359),(6144,359),(6145,359),(6146,359),(6147,359),(6148,360),(6149,360),(6150,360),(6151,360),(6152,360),(6153,360),(6154,361),(6155,361),(6156,361),(6157,361),(6158,361),(6159,361),(6160,362),(6161,362),(6162,362),(6163,362),(6164,362),(6165,362),(6166,363),(6167,363),(6168,363),(6169,363),(6170,363),(6171,363),(6172,364),(6173,364),(6174,364),(6175,364),(6176,364),(6177,364),(6178,365),(6179,365),(6180,365),(6181,365),(6182,365),(6183,365),(6184,366),(6185,366),(6186,366),(6187,366),(6188,366),(6189,366),(6190,367),(6191,367),(6192,367),(6193,367),(6194,367),(6195,367),(6196,368),(6197,368),(6198,368),(6199,368),(6200,368),(6201,368),(6202,369),(6203,369),(6204,369),(6205,369),(6206,369),(6207,369),(6208,370),(6209,370),(6210,370),(6211,370),(6212,370),(6213,370),(6214,371),(6215,371),(6216,371),(6217,371),(6218,371),(6219,371),(6220,372),(6221,372),(6222,372),(6223,372),(6224,372),(6225,372),(6226,373),(6227,373),(6228,373),(6229,373),(6230,373),(6231,373),(6232,374),(6233,374),(6234,374),(6235,374),(6236,374),(6237,374),(6238,375),(6239,375),(6240,375),(6241,375),(6242,375),(6243,375),(6244,376),(6245,376),(6246,376),(6247,376),(6248,376),(6249,376),(6250,377),(6251,377),(6252,377),(6253,377),(6254,377),(6255,377),(6256,378),(6257,378),(6258,378),(6259,378),(6260,378),(6261,378),(6262,379),(6263,379),(6264,379),(6265,379),(6266,379),(6267,379),(6268,380),(6269,380),(6270,380),(6271,380),(6272,380),(6273,380),(6274,281),(6275,281),(6276,281),(6277,282),(6278,282),(6279,283),(6280,283),(6281,284),(6282,284),(6283,284),(6284,285),(6285,285),(6286,286),(6287,286),(6288,286),(6289,287),(6290,287),(6291,287),(6292,288),(6293,288),(6294,289),(6295,289),(6296,289),(6297,290),(6298,290),(6299,291),(6300,291),(6301,291),(6302,292),(6303,292),(6304,292),(6305,293),(6306,293),(6307,294),(6308,294),(6309,294),(6310,295),(6311,295),(6312,296),(6313,296),(6314,296),(6315,297),(6316,297),(6317,297),(6318,298),(6319,298),(6320,298),(6321,299),(6322,299),(6323,299),(6324,300),(6325,300),(6326,300),(6327,301),(6328,301),(6329,302),(6330,302),(6331,303),(6332,303),(6333,304),(6334,304),(6335,304),(6336,305),(6337,305),(6338,306),(6339,306),(6340,307),(6341,307),(6342,307),(6343,308),(6344,308),(6345,309),(6346,309),(6347,310),(6348,310),(6349,311),(6350,311),(6351,311),(6352,312),(6353,312),(6354,312),(6355,313),(6356,313),(6357,314),(6358,314),(6359,314),(6360,315),(6361,315),(6362,316),(6363,316),(6364,317),(6365,317),(6366,317),(6367,318),(6368,318),(6369,319),(6370,319),(6371,319),(6372,320),(6373,320),(6374,320),(6375,321),(6376,321),(6377,321),(6378,322),(6379,322),(6380,322),(6381,323),(6382,323),(6383,323),(6384,324),(6385,324),(6386,325),(6387,325),(6388,326),(6389,326),(6390,327),(6391,327),(6392,328),(6393,328),(6394,329),(6395,329),(6396,330),(6397,330),(6398,331),(6399,331),(6400,332),(6401,332),(6402,332),(6403,333),(6404,333),(6405,333),(6406,334),(6407,334),(6408,335),(6409,335),(6410,336),(6411,336),(6412,336),(6413,337),(6414,337),(6415,337),(6416,338),(6417,338),(6418,339),(6419,339),(6420,340),(6421,340),(6422,341),(6423,341),(6424,342),(6425,342),(6426,342),(6427,343),(6428,343),(6429,344),(6430,344),(6431,345),(6432,345),(6433,346),(6434,346),(6435,347),(6436,347),(6437,348),(6438,348),(6439,349),(6440,349),(6441,350),(6442,350),(6443,351),(6444,351),(6445,352),(6446,352),(6447,353),(6448,353),(6449,354),(6450,354),(6451,355),(6452,355),(6453,356),(6454,356),(6455,357),(6456,357),(6457,358),(6458,358),(6459,359),(6460,359),(6461,360),(6462,360),(6463,361),(6464,361),(6465,362),(6466,362),(6467,363),(6468,363),(6469,364),(6470,364),(6471,365),(6472,365),(6473,366),(6474,366),(6475,367),(6476,367),(6477,368),(6478,368),(6479,369),(6480,369),(6481,370),(6482,370),(6483,371),(6484,371),(6485,372),(6486,372),(6487,373),(6488,373),(6489,374),(6490,374),(6491,375),(6492,375),(6493,376),(6494,376),(6495,377),(6496,377),(6497,378),(6498,378),(6499,379),(6500,379),(6501,380),(6502,380),(6503,281),(6504,281),(6505,281),(6506,282),(6507,282),(6508,282),(6509,283),(6510,283),(6511,283),(6512,284),(6513,284),(6514,284),(6515,285),(6516,285),(6517,285),(6518,286),(6519,286),(6520,286),(6521,287),(6522,287),(6523,287),(6524,288),(6525,288),(6526,288),(6527,289),(6528,289),(6529,289),(6530,290),(6531,290),(6532,290),(6533,291),(6534,291),(6535,291),(6536,292),(6537,292),(6538,292),(6539,293),(6540,293),(6541,293),(6542,294),(6543,294),(6544,294),(6545,295),(6546,295),(6547,295),(6548,296),(6549,296),(6550,296),(6551,297),(6552,297),(6553,297),(6554,298),(6555,298),(6556,298),(6557,299),(6558,299),(6559,299),(6560,300),(6561,300),(6562,300),(6563,301),(6564,301),(6565,301),(6566,302),(6567,302),(6568,302),(6569,303),(6570,303),(6571,303),(6572,304),(6573,304),(6574,304),(6575,305),(6576,305),(6577,305),(6578,306),(6579,306),(6580,306),(6581,307),(6582,307),(6583,307),(6584,308),(6585,308),(6586,308),(6587,309),(6588,309),(6589,309),(6590,310),(6591,310),(6592,310),(6593,311),(6594,311),(6595,311),(6596,312),(6597,312),(6598,312),(6599,313),(6600,313),(6601,313),(6602,314),(6603,314),(6604,314),(6605,315),(6606,315),(6607,315),(6608,316),(6609,316),(6610,316),(6611,317),(6612,317),(6613,317),(6614,318),(6615,318),(6616,318),(6617,319),(6618,319),(6619,319),(6620,320),(6621,320),(6622,320),(6623,321),(6624,321),(6625,321),(6626,322),(6627,322),(6628,322),(6629,323),(6630,323),(6631,323),(6632,324),(6633,324),(6634,324),(6635,325),(6636,325),(6637,325),(6638,326),(6639,326),(6640,326),(6641,327),(6642,327),(6643,327),(6644,328),(6645,328),(6646,328),(6647,329),(6648,329),(6649,329),(6650,330),(6651,330),(6652,330),(6653,331),(6654,331),(6655,331),(6656,332),(6657,332),(6658,332),(6659,333),(6660,333),(6661,333),(6662,334),(6663,334),(6664,334),(6665,335),(6666,335),(6667,335),(6668,336),(6669,336),(6670,336),(6671,337),(6672,337),(6673,337),(6674,338),(6675,338),(6676,338),(6677,339),(6678,339),(6679,339),(6680,340),(6681,340),(6682,340),(6683,341),(6684,341),(6685,341),(6686,342),(6687,342),(6688,342),(6689,343),(6690,343),(6691,343),(6692,344),(6693,344),(6694,344),(6695,345),(6696,345),(6697,345),(6698,346),(6699,346),(6700,346),(6701,347),(6702,347),(6703,347),(6704,348),(6705,348),(6706,348),(6707,349),(6708,349),(6709,349),(6710,350),(6711,350),(6712,350),(6713,351),(6714,351),(6715,351),(6716,352),(6717,352),(6718,352),(6719,353),(6720,353),(6721,353),(6722,354),(6723,354),(6724,354),(6725,355),(6726,355),(6727,355),(6728,356),(6729,356),(6730,356),(6731,357),(6732,357),(6733,357),(6734,358),(6735,358),(6736,358),(6737,359),(6738,359),(6739,359),(6740,360),(6741,360),(6742,360),(6743,361),(6744,361),(6745,361),(6746,362),(6747,362),(6748,362),(6749,363),(6750,363),(6751,363),(6752,364),(6753,364),(6754,364),(6755,365),(6756,365),(6757,365),(6758,366),(6759,366),(6760,366),(6761,367),(6762,367),(6763,367),(6764,368),(6765,368),(6766,368),(6767,369),(6768,369),(6769,369),(6770,370),(6771,370),(6772,370),(6773,371),(6774,371),(6775,371),(6776,372),(6777,372),(6778,372),(6779,373),(6780,373),(6781,373),(6782,374),(6783,374),(6784,374),(6785,375),(6786,375),(6787,375),(6788,376),(6789,376),(6790,376),(6791,377),(6792,377),(6793,377),(6794,378),(6795,378),(6796,378),(6797,379),(6798,379),(6799,379),(6800,380),(6801,380),(6802,380),(6803,281),(6804,281),(6805,281),(6806,281),(6807,282),(6808,282),(6809,282),(6810,282),(6811,283),(6812,283),(6813,283),(6814,283),(6815,284),(6816,284),(6817,284),(6818,284),(6819,285),(6820,285),(6821,285),(6822,285),(6823,286),(6824,286),(6825,286),(6826,286),(6827,287),(6828,287),(6829,287),(6830,287),(6831,288),(6832,288),(6833,288),(6834,288),(6835,289),(6836,289),(6837,289),(6838,289),(6839,290),(6840,290),(6841,290),(6842,290),(6843,291),(6844,291),(6845,291),(6846,291),(6847,292),(6848,292),(6849,292),(6850,292),(6851,293),(6852,293),(6853,293),(6854,293),(6855,294),(6856,294),(6857,294),(6858,294),(6859,295),(6860,295),(6861,295),(6862,295),(6863,296),(6864,296),(6865,296),(6866,296),(6867,297),(6868,297),(6869,297),(6870,297),(6871,298),(6872,298),(6873,298),(6874,298),(6875,299),(6876,299),(6877,299),(6878,299),(6879,300),(6880,300),(6881,300),(6882,300),(6883,301),(6884,301),(6885,301),(6886,301),(6887,302),(6888,302),(6889,302),(6890,302),(6891,303),(6892,303),(6893,303),(6894,303),(6895,304),(6896,304),(6897,304),(6898,304),(6899,305),(6900,305),(6901,305),(6902,305),(6903,306),(6904,306),(6905,306),(6906,306),(6907,307),(6908,307),(6909,307),(6910,307),(6911,308),(6912,308),(6913,308),(6914,308),(6915,309),(6916,309),(6917,309),(6918,309),(6919,310),(6920,310),(6921,310),(6922,310),(6923,311),(6924,311),(6925,311),(6926,311),(6927,312),(6928,312),(6929,312),(6930,312),(6931,313),(6932,313),(6933,313),(6934,313),(6935,314),(6936,314),(6937,314),(6938,314),(6939,315),(6940,315),(6941,315),(6942,315),(6943,316),(6944,316),(6945,316),(6946,316),(6947,317),(6948,317),(6949,317),(6950,317),(6951,318),(6952,318),(6953,318),(6954,318),(6955,319),(6956,319),(6957,319),(6958,319),(6959,320),(6960,320),(6961,320),(6962,320),(6963,321),(6964,321),(6965,321),(6966,321),(6967,322),(6968,322),(6969,322),(6970,322),(6971,323),(6972,323),(6973,323),(6974,323),(6975,324),(6976,324),(6977,324),(6978,324),(6979,325),(6980,325),(6981,325),(6982,325),(6983,326),(6984,326),(6985,326),(6986,326),(6987,327),(6988,327),(6989,327),(6990,327),(6991,328),(6992,328),(6993,328),(6994,328),(6995,329),(6996,329),(6997,329),(6998,329),(6999,330),(7000,330),(7001,330),(7002,330),(7003,331),(7004,331),(7005,331),(7006,331),(7007,332),(7008,332),(7009,332),(7010,332),(7011,333),(7012,333),(7013,333),(7014,333),(7015,334),(7016,334),(7017,334),(7018,334),(7019,335),(7020,335),(7021,335),(7022,335),(7023,336),(7024,336),(7025,336),(7026,336),(7027,337),(7028,337),(7029,337),(7030,337),(7031,338),(7032,338),(7033,338),(7034,338),(7035,339),(7036,339),(7037,339),(7038,339),(7039,340),(7040,340),(7041,340),(7042,340),(7043,341),(7044,341),(7045,341),(7046,341),(7047,342),(7048,342),(7049,342),(7050,342),(7051,343),(7052,343),(7053,343),(7054,343),(7055,344),(7056,344),(7057,344),(7058,344),(7059,345),(7060,345),(7061,345),(7062,345),(7063,346),(7064,346),(7065,346),(7066,346),(7067,347),(7068,347),(7069,347),(7070,347),(7071,348),(7072,348),(7073,348),(7074,348),(7075,349),(7076,349),(7077,349),(7078,349),(7079,350),(7080,350),(7081,350),(7082,350),(7083,351),(7084,351),(7085,351),(7086,351),(7087,352),(7088,352),(7089,352),(7090,352),(7091,353),(7092,353),(7093,353),(7094,353),(7095,354),(7096,354),(7097,354),(7098,354),(7099,355),(7100,355),(7101,355),(7102,355),(7103,356),(7104,356),(7105,356),(7106,356),(7107,357),(7108,357),(7109,357),(7110,357),(7111,358),(7112,358),(7113,358),(7114,358),(7115,359),(7116,359),(7117,359),(7118,359),(7119,360),(7120,360),(7121,360),(7122,360),(7123,361),(7124,361),(7125,361),(7126,361),(7127,362),(7128,362),(7129,362),(7130,362),(7131,363),(7132,363),(7133,363),(7134,363),(7135,364),(7136,364),(7137,364),(7138,364),(7139,365),(7140,365),(7141,365),(7142,365),(7143,366),(7144,366),(7145,366),(7146,366),(7147,367),(7148,367),(7149,367),(7150,367),(7151,368),(7152,368),(7153,368),(7154,368),(7155,369),(7156,369),(7157,369),(7158,369),(7159,370),(7160,370),(7161,370),(7162,370),(7163,371),(7164,371),(7165,371),(7166,371),(7167,372),(7168,372),(7169,372),(7170,372),(7171,373),(7172,373),(7173,373),(7174,373),(7175,374),(7176,374),(7177,374),(7178,374),(7179,375),(7180,375),(7181,375),(7182,375),(7183,376),(7184,376),(7185,376),(7186,376),(7187,377),(7188,377),(7189,377),(7190,377),(7191,378),(7192,378),(7193,378),(7194,378),(7195,379),(7196,379),(7197,379),(7198,379),(7199,380),(7200,380),(7201,380),(7202,380),(7203,381),(7204,382),(7205,383),(7206,384),(7207,385),(7208,386),(7209,387),(7210,388),(7211,389),(7212,390),(7213,391),(7214,392),(7215,393),(7216,394),(7217,395),(7218,396),(7219,397),(7220,398),(7221,399),(7222,400),(7223,401),(7224,402),(7225,403),(7226,404),(7227,405),(7228,406),(7229,407),(7230,408),(7231,409),(7232,410),(7233,411),(7234,412),(7235,413),(7236,414),(7237,415),(7238,416),(7239,417),(7240,418),(7241,419),(7242,420),(7243,421),(7244,422),(7245,423),(7246,424),(7247,425),(7248,426),(7249,427),(7250,428),(7251,429),(7252,430),(7253,431),(7254,432),(7255,433),(7256,434),(7257,435),(7258,436),(7259,437),(7260,438),(7261,439),(7262,440),(7263,441),(7264,442),(7265,443),(7266,444),(7267,445),(7268,446),(7269,447),(7270,448),(7271,449),(7272,450),(7273,451),(7274,452),(7275,453),(7276,454),(7277,455),(7278,456),(7279,457),(7280,458),(7281,459),(7282,460),(7283,461),(7284,462),(7285,463),(7286,464),(7287,465),(7288,466),(7289,467),(7290,468),(7291,469),(7292,470),(7293,471),(7294,472),(7295,473),(7296,474),(7297,475),(7298,476),(7299,477),(7300,478),(7301,479),(7302,480),(7303,381),(7304,382),(7305,383),(7306,384),(7307,385),(7308,386),(7309,387),(7310,388),(7311,389),(7312,390),(7313,391),(7314,392),(7315,393),(7316,394),(7317,395),(7318,396),(7319,397),(7320,398),(7321,399),(7322,400),(7323,401),(7324,402),(7325,403),(7326,404),(7327,405),(7328,406),(7329,407),(7330,408),(7331,409),(7332,410),(7333,411),(7334,412),(7335,413),(7336,414),(7337,415),(7338,416),(7339,417),(7340,418),(7341,419),(7342,420),(7343,421),(7344,422),(7345,423),(7346,424),(7347,425),(7348,426),(7349,427),(7350,428),(7351,429),(7352,430),(7353,431),(7354,432),(7355,433),(7356,434),(7357,435),(7358,436),(7359,437),(7360,438),(7361,439),(7362,440),(7363,441),(7364,442),(7365,443),(7366,444),(7367,445),(7368,446),(7369,447),(7370,448),(7371,449),(7372,450),(7373,451),(7374,452),(7375,453),(7376,454),(7377,455),(7378,456),(7379,457),(7380,458),(7381,459),(7382,460),(7383,461),(7384,462),(7385,463),(7386,464),(7387,465),(7388,466),(7389,467),(7390,468),(7391,469),(7392,470),(7393,471),(7394,472),(7395,473),(7396,474),(7397,475),(7398,476),(7399,477),(7400,478),(7401,479),(7402,480),(7403,381),(7404,381),(7405,382),(7406,382),(7407,383),(7408,383),(7409,384),(7410,384),(7411,385),(7412,385),(7413,386),(7414,386),(7415,387),(7416,387),(7417,388),(7418,388),(7419,389),(7420,389),(7421,390),(7422,390),(7423,391),(7424,391),(7425,392),(7426,392),(7427,393),(7428,393),(7429,394),(7430,394),(7431,395),(7432,395),(7433,396),(7434,396),(7435,397),(7436,397),(7437,398),(7438,398),(7439,399),(7440,399),(7441,400),(7442,400),(7443,401),(7444,401),(7445,402),(7446,402),(7447,403),(7448,403),(7449,404),(7450,404),(7451,405),(7452,405),(7453,406),(7454,406),(7455,407),(7456,407),(7457,408),(7458,408),(7459,409),(7460,409),(7461,410),(7462,410),(7463,411),(7464,411),(7465,412),(7466,412),(7467,413),(7468,413),(7469,414),(7470,414),(7471,415),(7472,415),(7473,416),(7474,416),(7475,417),(7476,417),(7477,418),(7478,418),(7479,419),(7480,419),(7481,420),(7482,420),(7483,421),(7484,421),(7485,422),(7486,422),(7487,423),(7488,423),(7489,424),(7490,424),(7491,425),(7492,425),(7493,426),(7494,426),(7495,427),(7496,427),(7497,428),(7498,428),(7499,429),(7500,429),(7501,430),(7502,430),(7503,431),(7504,431),(7505,432),(7506,432),(7507,433),(7508,433),(7509,434),(7510,434),(7511,435),(7512,435),(7513,436),(7514,436),(7515,437),(7516,437),(7517,438),(7518,438),(7519,439),(7520,439),(7521,440),(7522,440),(7523,441),(7524,441),(7525,442),(7526,442),(7527,443),(7528,443),(7529,444),(7530,444),(7531,445),(7532,445),(7533,446),(7534,446),(7535,447),(7536,447),(7537,448),(7538,448),(7539,449),(7540,449),(7541,450),(7542,450),(7543,451),(7544,451),(7545,452),(7546,452),(7547,453),(7548,453),(7549,454),(7550,454),(7551,455),(7552,455),(7553,456),(7554,456),(7555,457),(7556,457),(7557,458),(7558,458),(7559,459),(7560,459),(7561,460),(7562,460),(7563,461),(7564,461),(7565,462),(7566,462),(7567,463),(7568,463),(7569,464),(7570,464),(7571,465),(7572,465),(7573,466),(7574,466),(7575,467),(7576,467),(7577,468),(7578,468),(7579,469),(7580,469),(7581,470),(7582,470),(7583,471),(7584,471),(7585,472),(7586,472),(7587,473),(7588,473),(7589,474),(7590,474),(7591,475),(7592,475),(7593,476),(7594,476),(7595,477),(7596,477),(7597,478),(7598,478),(7599,479),(7600,479),(7601,480),(7602,480),(7603,381),(7604,381),(7605,381),(7606,381),(7607,381),(7608,381),(7609,382),(7610,382),(7611,382),(7612,382),(7613,382),(7614,382),(7615,383),(7616,383),(7617,383),(7618,383),(7619,383),(7620,383),(7621,384),(7622,384),(7623,384),(7624,384),(7625,384),(7626,384),(7627,385),(7628,385),(7629,385),(7630,385),(7631,385),(7632,385),(7633,386),(7634,386),(7635,386),(7636,386),(7637,386),(7638,386),(7639,387),(7640,387),(7641,387),(7642,387),(7643,387),(7644,387),(7645,388),(7646,388),(7647,388),(7648,388),(7649,388),(7650,388),(7651,389),(7652,389),(7653,389),(7654,389),(7655,389),(7656,389),(7657,390),(7658,390),(7659,390),(7660,390),(7661,390),(7662,390),(7663,391),(7664,391),(7665,391),(7666,391),(7667,391),(7668,391),(7669,392),(7670,392),(7671,392),(7672,392),(7673,392),(7674,392),(7675,393),(7676,393),(7677,393),(7678,393),(7679,393),(7680,393),(7681,394),(7682,394),(7683,394),(7684,394),(7685,394),(7686,394),(7687,395),(7688,395),(7689,395),(7690,395),(7691,395),(7692,395),(7693,396),(7694,396),(7695,396),(7696,396),(7697,396),(7698,396),(7699,397),(7700,397),(7701,397),(7702,397),(7703,397),(7704,397),(7705,398),(7706,398),(7707,398),(7708,398),(7709,398),(7710,398),(7711,399),(7712,399),(7713,399),(7714,399),(7715,399),(7716,399),(7717,400),(7718,400),(7719,400),(7720,400),(7721,400),(7722,400),(7723,401),(7724,401),(7725,401),(7726,401),(7727,401),(7728,401),(7729,402),(7730,402),(7731,402),(7732,402),(7733,402),(7734,402),(7735,403),(7736,403),(7737,403),(7738,403),(7739,403),(7740,403),(7741,404),(7742,404),(7743,404),(7744,404),(7745,404),(7746,404),(7747,405),(7748,405),(7749,405),(7750,405),(7751,405),(7752,405),(7753,406),(7754,406),(7755,406),(7756,406),(7757,406),(7758,406),(7759,407),(7760,407),(7761,407),(7762,407),(7763,407),(7764,407),(7765,408),(7766,408),(7767,408),(7768,408),(7769,408),(7770,408),(7771,409),(7772,409),(7773,409),(7774,409),(7775,409),(7776,409),(7777,410),(7778,410),(7779,410),(7780,410),(7781,410),(7782,410),(7783,411),(7784,411),(7785,411),(7786,411),(7787,411),(7788,411),(7789,412),(7790,412),(7791,412),(7792,412),(7793,412),(7794,412),(7795,413),(7796,413),(7797,413),(7798,413),(7799,413),(7800,413),(7801,414),(7802,414),(7803,414),(7804,414),(7805,414),(7806,414),(7807,415),(7808,415),(7809,415),(7810,415),(7811,415),(7812,415),(7813,416),(7814,416),(7815,416),(7816,416),(7817,416),(7818,416),(7819,417),(7820,417),(7821,417),(7822,417),(7823,417),(7824,417),(7825,418),(7826,418),(7827,418),(7828,418),(7829,418),(7830,418),(7831,419),(7832,419),(7833,419),(7834,419),(7835,419),(7836,419),(7837,420),(7838,420),(7839,420),(7840,420),(7841,420),(7842,420),(7843,421),(7844,421),(7845,421),(7846,421),(7847,421),(7848,421),(7849,422),(7850,422),(7851,422),(7852,422),(7853,422),(7854,422),(7855,423),(7856,423),(7857,423),(7858,423),(7859,423),(7860,423),(7861,424),(7862,424),(7863,424),(7864,424),(7865,424),(7866,424),(7867,425),(7868,425),(7869,425),(7870,425),(7871,425),(7872,425),(7873,426),(7874,426),(7875,426),(7876,426),(7877,426),(7878,426),(7879,427),(7880,427),(7881,427),(7882,427),(7883,427),(7884,427),(7885,428),(7886,428),(7887,428),(7888,428),(7889,428),(7890,428),(7891,429),(7892,429),(7893,429),(7894,429),(7895,429),(7896,429),(7897,430),(7898,430),(7899,430),(7900,430),(7901,430),(7902,430),(7903,431),(7904,431),(7905,431),(7906,431),(7907,431),(7908,431),(7909,432),(7910,432),(7911,432),(7912,432),(7913,432),(7914,432),(7915,433),(7916,433),(7917,433),(7918,433),(7919,433),(7920,433),(7921,434),(7922,434),(7923,434),(7924,434),(7925,434),(7926,434),(7927,435),(7928,435),(7929,435),(7930,435),(7931,435),(7932,435),(7933,436),(7934,436),(7935,436),(7936,436),(7937,436),(7938,436),(7939,437),(7940,437),(7941,437),(7942,437),(7943,437),(7944,437),(7945,438),(7946,438),(7947,438),(7948,438),(7949,438),(7950,438),(7951,439),(7952,439),(7953,439),(7954,439),(7955,439),(7956,439),(7957,440),(7958,440),(7959,440),(7960,440),(7961,440),(7962,440),(7963,441),(7964,441),(7965,441),(7966,441),(7967,441),(7968,441),(7969,442),(7970,442),(7971,442),(7972,442),(7973,442),(7974,442),(7975,443),(7976,443),(7977,443),(7978,443),(7979,443),(7980,443),(7981,444),(7982,444),(7983,444),(7984,444),(7985,444),(7986,444),(7987,445),(7988,445),(7989,445),(7990,445),(7991,445),(7992,445),(7993,446),(7994,446),(7995,446),(7996,446),(7997,446),(7998,446),(7999,447),(8000,447),(8001,447),(8002,447),(8003,447),(8004,447),(8005,448),(8006,448),(8007,448),(8008,448),(8009,448),(8010,448),(8011,449),(8012,449),(8013,449),(8014,449),(8015,449),(8016,449),(8017,450),(8018,450),(8019,450),(8020,450),(8021,450),(8022,450),(8023,451),(8024,451),(8025,451),(8026,451),(8027,451),(8028,451),(8029,452),(8030,452),(8031,452),(8032,452),(8033,452),(8034,452),(8035,453),(8036,453),(8037,453),(8038,453),(8039,453),(8040,453),(8041,454),(8042,454),(8043,454),(8044,454),(8045,454),(8046,454),(8047,455),(8048,455),(8049,455),(8050,455),(8051,455),(8052,455),(8053,456),(8054,456),(8055,456),(8056,456),(8057,456),(8058,456),(8059,457),(8060,457),(8061,457),(8062,457),(8063,457),(8064,457),(8065,458),(8066,458),(8067,458),(8068,458),(8069,458),(8070,458),(8071,459),(8072,459),(8073,459),(8074,459),(8075,459),(8076,459),(8077,460),(8078,460),(8079,460),(8080,460),(8081,460),(8082,460),(8083,461),(8084,461),(8085,461),(8086,461),(8087,461),(8088,461),(8089,462),(8090,462),(8091,462),(8092,462),(8093,462),(8094,462),(8095,463),(8096,463),(8097,463),(8098,463),(8099,463),(8100,463),(8101,464),(8102,464),(8103,464),(8104,464),(8105,464),(8106,464),(8107,465),(8108,465),(8109,465),(8110,465),(8111,465),(8112,465),(8113,466),(8114,466),(8115,466),(8116,466),(8117,466),(8118,466),(8119,467),(8120,467),(8121,467),(8122,467),(8123,467),(8124,467),(8125,468),(8126,468),(8127,468),(8128,468),(8129,468),(8130,468),(8131,469),(8132,469),(8133,469),(8134,469),(8135,469),(8136,469),(8137,470),(8138,470),(8139,470),(8140,470),(8141,470),(8142,470),(8143,471),(8144,471),(8145,471),(8146,471),(8147,471),(8148,471),(8149,472),(8150,472),(8151,472),(8152,472),(8153,472),(8154,472),(8155,473),(8156,473),(8157,473),(8158,473),(8159,473),(8160,473),(8161,474),(8162,474),(8163,474),(8164,474),(8165,474),(8166,474),(8167,475),(8168,475),(8169,475),(8170,475),(8171,475),(8172,475),(8173,476),(8174,476),(8175,476),(8176,476),(8177,476),(8178,476),(8179,477),(8180,477),(8181,477),(8182,477),(8183,477),(8184,477),(8185,478),(8186,478),(8187,478),(8188,478),(8189,478),(8190,478),(8191,479),(8192,479),(8193,479),(8194,479),(8195,479),(8196,479),(8197,480),(8198,480),(8199,480),(8200,480),(8201,480),(8202,480),(8203,381),(8204,381),(8205,382),(8206,382),(8207,383),(8208,383),(8209,384),(8210,384),(8211,385),(8212,385),(8213,386),(8214,386),(8215,387),(8216,387),(8217,388),(8218,388),(8219,389),(8220,389),(8221,390),(8222,390),(8223,391),(8224,391),(8225,392),(8226,392),(8227,393),(8228,393),(8229,394),(8230,394),(8231,395),(8232,395),(8233,396),(8234,396),(8235,397),(8236,397),(8237,398),(8238,398),(8239,399),(8240,399),(8241,400),(8242,400),(8243,401),(8244,401),(8245,402),(8246,402),(8247,403),(8248,403),(8249,404),(8250,404),(8251,405),(8252,405),(8253,406),(8254,406),(8255,407),(8256,407),(8257,408),(8258,408),(8259,409),(8260,409),(8261,410),(8262,410),(8263,411),(8264,411),(8265,412),(8266,412),(8267,413),(8268,413),(8269,414),(8270,414),(8271,415),(8272,415),(8273,416),(8274,416),(8275,417),(8276,417),(8277,418),(8278,418),(8279,419),(8280,419),(8281,420),(8282,420),(8283,421),(8284,421),(8285,422),(8286,422),(8287,423),(8288,423),(8289,424),(8290,424),(8291,425),(8292,425),(8293,426),(8294,426),(8295,427),(8296,427),(8297,428),(8298,428),(8299,429),(8300,429),(8301,430),(8302,430),(8303,431),(8304,431),(8305,432),(8306,432),(8307,433),(8308,433),(8309,434),(8310,434),(8311,435),(8312,435),(8313,436),(8314,436),(8315,437),(8316,437),(8317,438),(8318,438),(8319,439),(8320,439),(8321,440),(8322,440),(8323,441),(8324,441),(8325,442),(8326,442),(8327,443),(8328,443),(8329,444),(8330,444),(8331,445),(8332,445),(8333,446),(8334,446),(8335,447),(8336,447),(8337,448),(8338,448),(8339,449),(8340,449),(8341,450),(8342,450),(8343,451),(8344,451),(8345,452),(8346,452),(8347,453),(8348,453),(8349,454),(8350,454),(8351,455),(8352,455),(8353,456),(8354,456),(8355,457),(8356,457),(8357,458),(8358,458),(8359,459),(8360,459),(8361,460),(8362,460),(8363,461),(8364,461),(8365,462),(8366,462),(8367,463),(8368,463),(8369,464),(8370,464),(8371,465),(8372,465),(8373,466),(8374,466),(8375,467),(8376,467),(8377,468),(8378,468),(8379,469),(8380,469),(8381,470),(8382,470),(8383,471),(8384,471),(8385,472),(8386,472),(8387,473),(8388,473),(8389,474),(8390,474),(8391,475),(8392,475),(8393,476),(8394,476),(8395,477),(8396,477),(8397,478),(8398,478),(8399,479),(8400,479),(8401,480),(8402,480),(8403,381),(8404,381),(8405,381),(8406,382),(8407,382),(8408,382),(8409,383),(8410,383),(8411,383),(8412,384),(8413,384),(8414,384),(8415,385),(8416,385),(8417,385),(8418,386),(8419,386),(8420,386),(8421,387),(8422,387),(8423,387),(8424,388),(8425,388),(8426,388),(8427,389),(8428,389),(8429,389),(8430,390),(8431,390),(8432,390),(8433,391),(8434,391),(8435,391),(8436,392),(8437,392),(8438,392),(8439,393),(8440,393),(8441,393),(8442,394),(8443,394),(8444,394),(8445,395),(8446,395),(8447,395),(8448,396),(8449,396),(8450,396),(8451,397),(8452,397),(8453,397),(8454,398),(8455,398),(8456,398),(8457,399),(8458,399),(8459,399),(8460,400),(8461,400),(8462,400),(8463,401),(8464,401),(8465,401),(8466,402),(8467,402),(8468,402),(8469,403),(8470,403),(8471,403),(8472,404),(8473,404),(8474,404),(8475,405),(8476,405),(8477,405),(8478,406),(8479,406),(8480,406),(8481,407),(8482,407),(8483,407),(8484,408),(8485,408),(8486,408),(8487,409),(8488,409),(8489,409),(8490,410),(8491,410),(8492,410),(8493,411),(8494,411),(8495,411),(8496,412),(8497,412),(8498,412),(8499,413),(8500,413),(8501,413),(8502,414),(8503,414),(8504,414),(8505,415),(8506,415),(8507,415),(8508,416),(8509,416),(8510,416),(8511,417),(8512,417),(8513,417),(8514,418),(8515,418),(8516,418),(8517,419),(8518,419),(8519,419),(8520,420),(8521,420),(8522,420),(8523,421),(8524,421),(8525,421),(8526,422),(8527,422),(8528,422),(8529,423),(8530,423),(8531,423),(8532,424),(8533,424),(8534,424),(8535,425),(8536,425),(8537,425),(8538,426),(8539,426),(8540,426),(8541,427),(8542,427),(8543,427),(8544,428),(8545,428),(8546,428),(8547,429),(8548,429),(8549,429),(8550,430),(8551,430),(8552,430),(8553,431),(8554,431),(8555,431),(8556,432),(8557,432),(8558,432),(8559,433),(8560,433),(8561,433),(8562,434),(8563,434),(8564,434),(8565,435),(8566,435),(8567,435),(8568,436),(8569,436),(8570,436),(8571,437),(8572,437),(8573,437),(8574,438),(8575,438),(8576,438),(8577,439),(8578,439),(8579,439),(8580,440),(8581,440),(8582,440),(8583,441),(8584,441),(8585,441),(8586,442),(8587,442),(8588,442),(8589,443),(8590,443),(8591,443),(8592,444),(8593,444),(8594,444),(8595,445),(8596,445),(8597,445),(8598,446),(8599,446),(8600,446),(8601,447),(8602,447),(8603,447),(8604,448),(8605,448),(8606,448),(8607,449),(8608,449),(8609,449),(8610,450),(8611,450),(8612,450),(8613,451),(8614,451),(8615,451),(8616,452),(8617,452),(8618,452),(8619,453),(8620,453),(8621,453),(8622,454),(8623,454),(8624,454),(8625,455),(8626,455),(8627,455),(8628,456),(8629,456),(8630,456),(8631,457),(8632,457),(8633,457),(8634,458),(8635,458),(8636,458),(8637,459),(8638,459),(8639,459),(8640,460),(8641,460),(8642,460),(8643,461),(8644,461),(8645,461),(8646,462),(8647,462),(8648,462),(8649,463),(8650,463),(8651,463),(8652,464),(8653,464),(8654,464),(8655,465),(8656,465),(8657,465),(8658,466),(8659,466),(8660,466),(8661,467),(8662,467),(8663,467),(8664,468),(8665,468),(8666,468),(8667,469),(8668,469),(8669,469),(8670,470),(8671,470),(8672,470),(8673,471),(8674,471),(8675,471),(8676,472),(8677,472),(8678,472),(8679,473),(8680,473),(8681,473),(8682,474),(8683,474),(8684,474),(8685,475),(8686,475),(8687,475),(8688,476),(8689,476),(8690,476),(8691,477),(8692,477),(8693,477),(8694,478),(8695,478),(8696,478),(8697,479),(8698,479),(8699,479),(8700,480),(8701,480),(8702,480),(8703,381),(8704,381),(8705,381),(8706,381),(8707,382),(8708,382),(8709,382),(8710,382),(8711,383),(8712,383),(8713,383),(8714,383),(8715,384),(8716,384),(8717,384),(8718,384),(8719,385),(8720,385),(8721,385),(8722,385),(8723,386),(8724,386),(8725,386),(8726,386),(8727,387),(8728,387),(8729,387),(8730,387),(8731,388),(8732,388),(8733,388),(8734,388),(8735,389),(8736,389),(8737,389),(8738,389),(8739,390),(8740,390),(8741,390),(8742,390),(8743,391),(8744,391),(8745,391),(8746,391),(8747,392),(8748,392),(8749,392),(8750,392),(8751,393),(8752,393),(8753,393),(8754,393),(8755,394),(8756,394),(8757,394),(8758,394),(8759,395),(8760,395),(8761,395),(8762,395),(8763,396),(8764,396),(8765,396),(8766,396),(8767,397),(8768,397),(8769,397),(8770,397),(8771,398),(8772,398),(8773,398),(8774,398),(8775,399),(8776,399),(8777,399),(8778,399),(8779,400),(8780,400),(8781,400),(8782,400),(8783,401),(8784,401),(8785,401),(8786,401),(8787,402),(8788,402),(8789,402),(8790,402),(8791,403),(8792,403),(8793,403),(8794,403),(8795,404),(8796,404),(8797,404),(8798,404),(8799,405),(8800,405),(8801,405),(8802,405),(8803,406),(8804,406),(8805,406),(8806,406),(8807,407),(8808,407),(8809,407),(8810,407),(8811,408),(8812,408),(8813,408),(8814,408),(8815,409),(8816,409),(8817,409),(8818,409),(8819,410),(8820,410),(8821,410),(8822,410),(8823,411),(8824,411),(8825,411),(8826,411),(8827,412),(8828,412),(8829,412),(8830,412),(8831,413),(8832,413),(8833,413),(8834,413),(8835,414),(8836,414),(8837,414),(8838,414),(8839,415),(8840,415),(8841,415),(8842,415),(8843,416),(8844,416),(8845,416),(8846,416),(8847,417),(8848,417),(8849,417),(8850,417),(8851,418),(8852,418),(8853,418),(8854,418),(8855,419),(8856,419),(8857,419),(8858,419),(8859,420),(8860,420),(8861,420),(8862,420),(8863,421),(8864,421),(8865,421),(8866,421),(8867,422),(8868,422),(8869,422),(8870,422),(8871,423),(8872,423),(8873,423),(8874,423),(8875,424),(8876,424),(8877,424),(8878,424),(8879,425),(8880,425),(8881,425),(8882,425),(8883,426),(8884,426),(8885,426),(8886,426),(8887,427),(8888,427),(8889,427),(8890,427),(8891,428),(8892,428),(8893,428),(8894,428),(8895,429),(8896,429),(8897,429),(8898,429),(8899,430),(8900,430),(8901,430),(8902,430),(8903,431),(8904,431),(8905,431),(8906,431),(8907,432),(8908,432),(8909,432),(8910,432),(8911,433),(8912,433),(8913,433),(8914,433),(8915,434),(8916,434),(8917,434),(8918,434),(8919,435),(8920,435),(8921,435),(8922,435),(8923,436),(8924,436),(8925,436),(8926,436),(8927,437),(8928,437),(8929,437),(8930,437),(8931,438),(8932,438),(8933,438),(8934,438),(8935,439),(8936,439),(8937,439),(8938,439),(8939,440),(8940,440),(8941,440),(8942,440),(8943,441),(8944,441),(8945,441),(8946,441),(8947,442),(8948,442),(8949,442),(8950,442),(8951,443),(8952,443),(8953,443),(8954,443),(8955,444),(8956,444),(8957,444),(8958,444),(8959,445),(8960,445),(8961,445),(8962,445),(8963,446),(8964,446),(8965,446),(8966,446),(8967,447),(8968,447),(8969,447),(8970,447),(8971,448),(8972,448),(8973,448),(8974,448),(8975,449),(8976,449),(8977,449),(8978,449),(8979,450),(8980,450),(8981,450),(8982,450),(8983,451),(8984,451),(8985,451),(8986,451),(8987,452),(8988,452),(8989,452),(8990,452),(8991,453),(8992,453),(8993,453),(8994,453),(8995,454),(8996,454),(8997,454),(8998,454),(8999,455),(9000,455),(9001,455),(9002,455),(9003,456),(9004,456),(9005,456),(9006,456),(9007,457),(9008,457),(9009,457),(9010,457),(9011,458),(9012,458),(9013,458),(9014,458),(9015,459),(9016,459),(9017,459),(9018,459),(9019,460),(9020,460),(9021,460),(9022,460),(9023,461),(9024,461),(9025,461),(9026,461),(9027,462),(9028,462),(9029,462),(9030,462),(9031,463),(9032,463),(9033,463),(9034,463),(9035,464),(9036,464),(9037,464),(9038,464),(9039,465),(9040,465),(9041,465),(9042,465),(9043,466),(9044,466),(9045,466),(9046,466),(9047,467),(9048,467),(9049,467),(9050,467),(9051,468),(9052,468),(9053,468),(9054,468),(9055,469),(9056,469),(9057,469),(9058,469),(9059,470),(9060,470),(9061,470),(9062,470),(9063,471),(9064,471),(9065,471),(9066,471),(9067,472),(9068,472),(9069,472),(9070,472),(9071,473),(9072,473),(9073,473),(9074,473),(9075,474),(9076,474),(9077,474),(9078,474),(9079,475),(9080,475),(9081,475),(9082,475),(9083,476),(9084,476),(9085,476),(9086,476),(9087,477),(9088,477),(9089,477),(9090,477),(9091,478),(9092,478),(9093,478),(9094,478),(9095,479),(9096,479),(9097,479),(9098,479),(9099,480),(9100,480),(9101,480),(9102,480),(9103,481),(9104,482),(9105,483),(9106,484),(9107,485),(9108,486),(9109,487),(9110,488),(9111,489),(9112,490),(9113,491),(9114,492),(9115,493),(9116,494),(9117,495),(9118,496),(9119,497),(9120,498),(9121,499),(9122,500),(9123,501),(9124,502),(9125,503),(9126,504),(9127,505),(9128,506),(9129,507),(9130,508),(9131,509),(9132,510),(9133,511),(9134,512),(9135,513),(9136,514),(9137,515),(9138,516),(9139,517),(9140,518),(9141,519),(9142,520),(9143,521),(9144,522),(9145,523),(9146,524),(9147,525),(9148,526),(9149,527),(9150,528),(9151,529),(9152,530),(9153,531),(9154,532),(9155,533),(9156,534),(9157,535),(9158,536),(9159,537),(9160,538),(9161,539),(9162,540),(9163,541),(9164,542),(9165,543),(9166,544),(9167,545),(9168,546),(9169,547),(9170,548),(9171,549),(9172,550),(9173,551),(9174,552),(9175,553),(9176,554),(9177,555),(9178,556),(9179,557),(9180,558),(9181,559),(9182,560),(9183,561),(9184,562),(9185,563),(9186,564),(9187,565),(9188,566),(9189,567),(9190,568),(9191,569),(9192,570),(9193,571),(9194,572),(9195,573),(9196,574),(9197,575),(9198,576),(9199,577),(9200,578),(9201,579),(9202,580),(9203,481),(9204,482),(9205,483),(9206,484),(9207,485),(9208,486),(9209,487),(9210,488),(9211,489),(9212,490),(9213,491),(9214,492),(9215,493),(9216,494),(9217,495),(9218,496),(9219,497),(9220,498),(9221,499),(9222,500),(9223,501),(9224,502),(9225,503),(9226,504),(9227,505),(9228,506),(9229,507),(9230,508),(9231,509),(9232,510),(9233,511),(9234,512),(9235,513),(9236,514),(9237,515),(9238,516),(9239,517),(9240,518),(9241,519),(9242,520),(9243,521),(9244,522),(9245,523),(9246,524),(9247,525),(9248,526),(9249,527),(9250,528),(9251,529),(9252,530),(9253,531),(9254,532),(9255,533),(9256,534),(9257,535),(9258,536),(9259,537),(9260,538),(9261,539),(9262,540),(9263,541),(9264,542),(9265,543),(9266,544),(9267,545),(9268,546),(9269,547),(9270,548),(9271,549),(9272,550),(9273,551),(9274,552),(9275,553),(9276,554),(9277,555),(9278,556),(9279,557),(9280,558),(9281,559),(9282,560),(9283,561),(9284,562),(9285,563),(9286,564),(9287,565),(9288,566),(9289,567),(9290,568),(9291,569),(9292,570),(9293,571),(9294,572),(9295,573),(9296,574),(9297,575),(9298,576),(9299,577),(9300,578),(9301,579),(9302,580),(9303,481),(9304,481),(9305,482),(9306,482),(9307,483),(9308,483),(9309,484),(9310,484),(9311,485),(9312,485),(9313,486),(9314,486),(9315,487),(9316,487),(9317,488),(9318,488),(9319,489),(9320,489),(9321,490),(9322,490),(9323,491),(9324,491),(9325,492),(9326,492),(9327,493),(9328,493),(9329,494),(9330,494),(9331,495),(9332,495),(9333,496),(9334,496),(9335,497),(9336,497),(9337,498),(9338,498),(9339,499),(9340,499),(9341,500),(9342,500),(9343,501),(9344,501),(9345,502),(9346,502),(9347,503),(9348,503),(9349,504),(9350,504),(9351,505),(9352,505),(9353,506),(9354,506),(9355,507),(9356,507),(9357,508),(9358,508),(9359,509),(9360,509),(9361,510),(9362,510),(9363,511),(9364,511),(9365,512),(9366,512),(9367,513),(9368,513),(9369,514),(9370,514),(9371,515),(9372,515),(9373,516),(9374,516),(9375,517),(9376,517),(9377,518),(9378,518),(9379,519),(9380,519),(9381,520),(9382,520),(9383,521),(9384,521),(9385,522),(9386,522),(9387,523),(9388,523),(9389,524),(9390,524),(9391,525),(9392,525),(9393,526),(9394,526),(9395,527),(9396,527),(9397,528),(9398,528),(9399,529),(9400,529),(9401,530),(9402,530),(9403,531),(9404,531),(9405,532),(9406,532),(9407,533),(9408,533),(9409,534),(9410,534),(9411,535),(9412,535),(9413,536),(9414,536),(9415,537),(9416,537),(9417,538),(9418,538),(9419,539),(9420,539),(9421,540),(9422,540),(9423,541),(9424,541),(9425,542),(9426,542),(9427,543),(9428,543),(9429,544),(9430,544),(9431,545),(9432,545),(9433,546),(9434,546),(9435,547),(9436,547),(9437,548),(9438,548),(9439,549),(9440,549),(9441,550),(9442,550),(9443,551),(9444,551),(9445,552),(9446,552),(9447,553),(9448,553),(9449,554),(9450,554),(9451,555),(9452,555),(9453,556),(9454,556),(9455,557),(9456,557),(9457,558),(9458,558),(9459,559),(9460,559),(9461,560),(9462,560),(9463,561),(9464,561),(9465,562),(9466,562),(9467,563),(9468,563),(9469,564),(9470,564),(9471,565),(9472,565),(9473,566),(9474,566),(9475,567),(9476,567),(9477,568),(9478,568),(9479,569),(9480,569),(9481,570),(9482,570),(9483,571),(9484,571),(9485,572),(9486,572),(9487,573),(9488,573),(9489,574),(9490,574),(9491,575),(9492,575),(9493,576),(9494,576),(9495,577),(9496,577),(9497,578),(9498,578),(9499,579),(9500,579),(9501,580),(9502,580),(9503,481),(9504,481),(9505,481),(9506,481),(9507,481),(9508,481),(9509,482),(9510,482),(9511,482),(9512,482),(9513,482),(9514,482),(9515,483),(9516,483),(9517,483),(9518,483),(9519,483),(9520,483),(9521,484),(9522,484),(9523,484),(9524,484),(9525,484),(9526,484),(9527,485),(9528,485),(9529,485),(9530,485),(9531,485),(9532,485),(9533,486),(9534,486),(9535,486),(9536,486),(9537,486),(9538,486),(9539,487),(9540,487),(9541,487),(9542,487),(9543,487),(9544,487),(9545,488),(9546,488),(9547,488),(9548,488),(9549,488),(9550,488),(9551,489),(9552,489),(9553,489),(9554,489),(9555,489),(9556,489),(9557,490),(9558,490),(9559,490),(9560,490),(9561,490),(9562,490),(9563,491),(9564,491),(9565,491),(9566,491),(9567,491),(9568,491),(9569,492),(9570,492),(9571,492),(9572,492),(9573,492),(9574,492),(9575,493),(9576,493),(9577,493),(9578,493),(9579,493),(9580,493),(9581,494),(9582,494),(9583,494),(9584,494),(9585,494),(9586,494),(9587,495),(9588,495),(9589,495),(9590,495),(9591,495),(9592,495),(9593,496),(9594,496),(9595,496),(9596,496),(9597,496),(9598,496),(9599,497),(9600,497),(9601,497),(9602,497),(9603,497),(9604,497),(9605,498),(9606,498),(9607,498),(9608,498),(9609,498),(9610,498),(9611,499),(9612,499),(9613,499),(9614,499),(9615,499),(9616,499),(9617,500),(9618,500),(9619,500),(9620,500),(9621,500),(9622,500),(9623,501),(9624,501),(9625,501),(9626,501),(9627,501),(9628,501),(9629,502),(9630,502),(9631,502),(9632,502),(9633,502),(9634,502),(9635,503),(9636,503),(9637,503),(9638,503),(9639,503),(9640,503),(9641,504),(9642,504),(9643,504),(9644,504),(9645,504),(9646,504),(9647,505),(9648,505),(9649,505),(9650,505),(9651,505),(9652,505),(9653,506),(9654,506),(9655,506),(9656,506),(9657,506),(9658,506),(9659,507),(9660,507),(9661,507),(9662,507),(9663,507),(9664,507),(9665,508),(9666,508),(9667,508),(9668,508),(9669,508),(9670,508),(9671,509),(9672,509),(9673,509),(9674,509),(9675,509),(9676,509),(9677,510),(9678,510),(9679,510),(9680,510),(9681,510),(9682,510),(9683,511),(9684,511),(9685,511),(9686,511),(9687,511),(9688,511),(9689,512),(9690,512),(9691,512),(9692,512),(9693,512),(9694,512),(9695,513),(9696,513),(9697,513),(9698,513),(9699,513),(9700,513),(9701,514),(9702,514),(9703,514),(9704,514),(9705,514),(9706,514),(9707,515),(9708,515),(9709,515),(9710,515),(9711,515),(9712,515),(9713,516),(9714,516),(9715,516),(9716,516),(9717,516),(9718,516),(9719,517),(9720,517),(9721,517),(9722,517),(9723,517),(9724,517),(9725,518),(9726,518),(9727,518),(9728,518),(9729,518),(9730,518),(9731,519),(9732,519),(9733,519),(9734,519),(9735,519),(9736,519),(9737,520),(9738,520),(9739,520),(9740,520),(9741,520),(9742,520),(9743,521),(9744,521),(9745,521),(9746,521),(9747,521),(9748,521),(9749,522),(9750,522),(9751,522),(9752,522),(9753,522),(9754,522),(9755,523),(9756,523),(9757,523),(9758,523),(9759,523),(9760,523),(9761,524),(9762,524),(9763,524),(9764,524),(9765,524),(9766,524),(9767,525),(9768,525),(9769,525),(9770,525),(9771,525),(9772,525),(9773,526),(9774,526),(9775,526),(9776,526),(9777,526),(9778,526),(9779,527),(9780,527),(9781,527),(9782,527),(9783,527),(9784,527),(9785,528),(9786,528),(9787,528),(9788,528),(9789,528),(9790,528),(9791,529),(9792,529),(9793,529),(9794,529),(9795,529),(9796,529),(9797,530),(9798,530),(9799,530),(9800,530),(9801,530),(9802,530),(9803,531),(9804,531),(9805,531),(9806,531),(9807,531),(9808,531),(9809,532),(9810,532),(9811,532),(9812,532),(9813,532),(9814,532),(9815,533),(9816,533),(9817,533),(9818,533),(9819,533),(9820,533),(9821,534),(9822,534),(9823,534),(9824,534),(9825,534),(9826,534),(9827,535),(9828,535),(9829,535),(9830,535),(9831,535),(9832,535),(9833,536),(9834,536),(9835,536),(9836,536),(9837,536),(9838,536),(9839,537),(9840,537),(9841,537),(9842,537),(9843,537),(9844,537),(9845,538),(9846,538),(9847,538),(9848,538),(9849,538),(9850,538),(9851,539),(9852,539),(9853,539),(9854,539),(9855,539),(9856,539),(9857,540),(9858,540),(9859,540),(9860,540),(9861,540),(9862,540),(9863,541),(9864,541),(9865,541),(9866,541),(9867,541),(9868,541),(9869,542),(9870,542),(9871,542),(9872,542),(9873,542),(9874,542),(9875,543),(9876,543),(9877,543),(9878,543),(9879,543),(9880,543),(9881,544),(9882,544),(9883,544),(9884,544),(9885,544),(9886,544),(9887,545),(9888,545),(9889,545),(9890,545),(9891,545),(9892,545),(9893,546),(9894,546),(9895,546),(9896,546),(9897,546),(9898,546),(9899,547),(9900,547),(9901,547),(9902,547),(9903,547),(9904,547),(9905,548),(9906,548),(9907,548),(9908,548),(9909,548),(9910,548),(9911,549),(9912,549),(9913,549),(9914,549),(9915,549),(9916,549),(9917,550),(9918,550),(9919,550),(9920,550),(9921,550),(9922,550),(9923,551),(9924,551),(9925,551),(9926,551),(9927,551),(9928,551),(9929,552),(9930,552),(9931,552),(9932,552),(9933,552),(9934,552),(9935,553),(9936,553),(9937,553),(9938,553),(9939,553),(9940,553),(9941,554),(9942,554),(9943,554),(9944,554),(9945,554),(9946,554),(9947,555),(9948,555),(9949,555),(9950,555),(9951,555),(9952,555),(9953,556),(9954,556),(9955,556),(9956,556),(9957,556),(9958,556),(9959,557),(9960,557),(9961,557),(9962,557),(9963,557),(9964,557),(9965,558),(9966,558),(9967,558),(9968,558),(9969,558),(9970,558),(9971,559),(9972,559),(9973,559),(9974,559),(9975,559),(9976,559),(9977,560),(9978,560),(9979,560),(9980,560),(9981,560),(9982,560),(9983,561),(9984,561),(9985,561),(9986,561),(9987,561),(9988,561),(9989,562),(9990,562),(9991,562),(9992,562),(9993,562),(9994,562),(9995,563),(9996,563),(9997,563),(9998,563),(9999,563),(10000,563),(10001,564),(10002,564),(10003,564),(10004,564),(10005,564),(10006,564),(10007,565),(10008,565),(10009,565),(10010,565),(10011,565),(10012,565),(10013,566),(10014,566),(10015,566),(10016,566),(10017,566),(10018,566),(10019,567),(10020,567),(10021,567),(10022,567),(10023,567),(10024,567),(10025,568),(10026,568),(10027,568),(10028,568),(10029,568),(10030,568),(10031,569),(10032,569),(10033,569),(10034,569),(10035,569),(10036,569),(10037,570),(10038,570),(10039,570),(10040,570),(10041,570),(10042,570),(10043,571),(10044,571),(10045,571),(10046,571),(10047,571),(10048,571),(10049,572),(10050,572),(10051,572),(10052,572),(10053,572),(10054,572),(10055,573),(10056,573),(10057,573),(10058,573),(10059,573),(10060,573),(10061,574),(10062,574),(10063,574),(10064,574),(10065,574),(10066,574),(10067,575),(10068,575),(10069,575),(10070,575),(10071,575),(10072,575),(10073,576),(10074,576),(10075,576),(10076,576),(10077,576),(10078,576),(10079,577),(10080,577),(10081,577),(10082,577),(10083,577),(10084,577),(10085,578),(10086,578),(10087,578),(10088,578),(10089,578),(10090,578),(10091,579),(10092,579),(10093,579),(10094,579),(10095,579),(10096,579),(10097,580),(10098,580),(10099,580),(10100,580),(10101,580),(10102,580),(10103,481),(10104,481),(10105,482),(10106,482),(10107,483),(10108,483),(10109,484),(10110,484),(10111,485),(10112,485),(10113,486),(10114,486),(10115,487),(10116,487),(10117,488),(10118,488),(10119,489),(10120,489),(10121,490),(10122,490),(10123,491),(10124,491),(10125,492),(10126,492),(10127,493),(10128,493),(10129,494),(10130,494),(10131,495),(10132,495),(10133,496),(10134,496),(10135,497),(10136,497),(10137,498),(10138,498),(10139,499),(10140,499),(10141,500),(10142,500),(10143,501),(10144,501),(10145,502),(10146,502),(10147,503),(10148,503),(10149,504),(10150,504),(10151,505),(10152,505),(10153,506),(10154,506),(10155,507),(10156,507),(10157,508),(10158,508),(10159,509),(10160,509),(10161,510),(10162,510),(10163,511),(10164,511),(10165,512),(10166,512),(10167,513),(10168,513),(10169,514),(10170,514),(10171,515),(10172,515),(10173,516),(10174,516),(10175,517),(10176,517),(10177,518),(10178,518),(10179,519),(10180,519),(10181,520),(10182,520),(10183,521),(10184,521),(10185,522),(10186,522),(10187,523),(10188,523),(10189,524),(10190,524),(10191,525),(10192,525),(10193,526),(10194,526),(10195,527),(10196,527),(10197,528),(10198,528),(10199,529),(10200,529),(10201,530),(10202,530),(10203,531),(10204,531),(10205,532),(10206,532),(10207,533),(10208,533),(10209,534),(10210,534),(10211,535),(10212,535),(10213,536),(10214,536),(10215,537),(10216,537),(10217,538),(10218,538),(10219,539),(10220,539),(10221,540),(10222,540),(10223,541),(10224,541),(10225,542),(10226,542),(10227,543),(10228,543),(10229,544),(10230,544),(10231,545),(10232,545),(10233,546),(10234,546),(10235,547),(10236,547),(10237,548),(10238,548),(10239,549),(10240,549),(10241,550),(10242,550),(10243,551),(10244,551),(10245,552),(10246,552),(10247,553),(10248,553),(10249,554),(10250,554),(10251,555),(10252,555),(10253,556),(10254,556),(10255,557),(10256,557),(10257,558),(10258,558),(10259,559),(10260,559),(10261,560),(10262,560),(10263,561),(10264,561),(10265,562),(10266,562),(10267,563),(10268,563),(10269,564),(10270,564),(10271,565),(10272,565),(10273,566),(10274,566),(10275,567),(10276,567),(10277,568),(10278,568),(10279,569),(10280,569),(10281,570),(10282,570),(10283,571),(10284,571),(10285,572),(10286,572),(10287,573),(10288,573),(10289,574),(10290,574),(10291,575),(10292,575),(10293,576),(10294,576),(10295,577),(10296,577),(10297,578),(10298,578),(10299,579),(10300,579),(10301,580),(10302,580),(10303,481),(10304,481),(10305,481),(10306,482),(10307,482),(10308,482),(10309,483),(10310,483),(10311,483),(10312,484),(10313,484),(10314,484),(10315,485),(10316,485),(10317,485),(10318,486),(10319,486),(10320,486),(10321,487),(10322,487),(10323,487),(10324,488),(10325,488),(10326,488),(10327,489),(10328,489),(10329,489),(10330,490),(10331,490),(10332,490),(10333,491),(10334,491),(10335,491),(10336,492),(10337,492),(10338,492),(10339,493),(10340,493),(10341,493),(10342,494),(10343,494),(10344,494),(10345,495),(10346,495),(10347,495),(10348,496),(10349,496),(10350,496),(10351,497),(10352,497),(10353,497),(10354,498),(10355,498),(10356,498),(10357,499),(10358,499),(10359,499),(10360,500),(10361,500),(10362,500),(10363,501),(10364,501),(10365,501),(10366,502),(10367,502),(10368,502),(10369,503),(10370,503),(10371,503),(10372,504),(10373,504),(10374,504),(10375,505),(10376,505),(10377,505),(10378,506),(10379,506),(10380,506),(10381,507),(10382,507),(10383,507),(10384,508),(10385,508),(10386,508),(10387,509),(10388,509),(10389,509),(10390,510),(10391,510),(10392,510),(10393,511),(10394,511),(10395,511),(10396,512),(10397,512),(10398,512),(10399,513),(10400,513),(10401,513),(10402,514),(10403,514),(10404,514),(10405,515),(10406,515),(10407,515),(10408,516),(10409,516),(10410,516),(10411,517),(10412,517),(10413,517),(10414,518),(10415,518),(10416,518),(10417,519),(10418,519),(10419,519),(10420,520),(10421,520),(10422,520),(10423,521),(10424,521),(10425,521),(10426,522),(10427,522),(10428,522),(10429,523),(10430,523),(10431,523),(10432,524),(10433,524),(10434,524),(10435,525),(10436,525),(10437,525),(10438,526),(10439,526),(10440,526),(10441,527),(10442,527),(10443,527),(10444,528),(10445,528),(10446,528),(10447,529),(10448,529),(10449,529),(10450,530),(10451,530),(10452,530),(10453,531),(10454,531),(10455,531),(10456,532),(10457,532),(10458,532),(10459,533),(10460,533),(10461,533),(10462,534),(10463,534),(10464,534),(10465,535),(10466,535),(10467,535),(10468,536),(10469,536),(10470,536),(10471,537),(10472,537),(10473,537),(10474,538),(10475,538),(10476,538),(10477,539),(10478,539),(10479,539),(10480,540),(10481,540),(10482,540),(10483,541),(10484,541),(10485,541),(10486,542),(10487,542),(10488,542),(10489,543),(10490,543),(10491,543),(10492,544),(10493,544),(10494,544),(10495,545),(10496,545),(10497,545),(10498,546),(10499,546),(10500,546),(10501,547),(10502,547),(10503,547),(10504,548),(10505,548),(10506,548),(10507,549),(10508,549),(10509,549),(10510,550),(10511,550),(10512,550),(10513,551),(10514,551),(10515,551),(10516,552),(10517,552),(10518,552),(10519,553),(10520,553),(10521,553),(10522,554),(10523,554),(10524,554),(10525,555),(10526,555),(10527,555),(10528,556),(10529,556),(10530,556),(10531,557),(10532,557),(10533,557),(10534,558),(10535,558),(10536,558),(10537,559),(10538,559),(10539,559),(10540,560),(10541,560),(10542,560),(10543,561),(10544,561),(10545,561),(10546,562),(10547,562),(10548,562),(10549,563),(10550,563),(10551,563),(10552,564),(10553,564),(10554,564),(10555,565),(10556,565),(10557,565),(10558,566),(10559,566),(10560,566),(10561,567),(10562,567),(10563,567),(10564,568),(10565,568),(10566,568),(10567,569),(10568,569),(10569,569),(10570,570),(10571,570),(10572,570),(10573,571),(10574,571),(10575,571),(10576,572),(10577,572),(10578,572),(10579,573),(10580,573),(10581,573),(10582,574),(10583,574),(10584,574),(10585,575),(10586,575),(10587,575),(10588,576),(10589,576),(10590,576),(10591,577),(10592,577),(10593,577),(10594,578),(10595,578),(10596,578),(10597,579),(10598,579),(10599,579),(10600,580),(10601,580),(10602,580),(10603,481),(10604,481),(10605,481),(10606,481),(10607,482),(10608,482),(10609,482),(10610,482),(10611,483),(10612,483),(10613,483),(10614,483),(10615,484),(10616,484),(10617,484),(10618,484),(10619,485),(10620,485),(10621,485),(10622,485),(10623,486),(10624,486),(10625,486),(10626,486),(10627,487),(10628,487),(10629,487),(10630,487),(10631,488),(10632,488),(10633,488),(10634,488),(10635,489),(10636,489),(10637,489),(10638,489),(10639,490),(10640,490),(10641,490),(10642,490),(10643,491),(10644,491),(10645,491),(10646,491),(10647,492),(10648,492),(10649,492),(10650,492),(10651,493),(10652,493),(10653,493),(10654,493),(10655,494),(10656,494),(10657,494),(10658,494),(10659,495),(10660,495),(10661,495),(10662,495),(10663,496),(10664,496),(10665,496),(10666,496),(10667,497),(10668,497),(10669,497),(10670,497),(10671,498),(10672,498),(10673,498),(10674,498),(10675,499),(10676,499),(10677,499),(10678,499),(10679,500),(10680,500),(10681,500),(10682,500),(10683,501),(10684,501),(10685,501),(10686,501),(10687,502),(10688,502),(10689,502),(10690,502),(10691,503),(10692,503),(10693,503),(10694,503),(10695,504),(10696,504),(10697,504),(10698,504),(10699,505),(10700,505),(10701,505),(10702,505),(10703,506),(10704,506),(10705,506),(10706,506),(10707,507),(10708,507),(10709,507),(10710,507),(10711,508),(10712,508),(10713,508),(10714,508),(10715,509),(10716,509),(10717,509),(10718,509),(10719,510),(10720,510),(10721,510),(10722,510),(10723,511),(10724,511),(10725,511),(10726,511),(10727,512),(10728,512),(10729,512),(10730,512),(10731,513),(10732,513),(10733,513),(10734,513),(10735,514),(10736,514),(10737,514),(10738,514),(10739,515),(10740,515),(10741,515),(10742,515),(10743,516),(10744,516),(10745,516),(10746,516),(10747,517),(10748,517),(10749,517),(10750,517),(10751,518),(10752,518),(10753,518),(10754,518),(10755,519),(10756,519),(10757,519),(10758,519),(10759,520),(10760,520),(10761,520),(10762,520),(10763,521),(10764,521),(10765,521),(10766,521),(10767,522),(10768,522),(10769,522),(10770,522),(10771,523),(10772,523),(10773,523),(10774,523),(10775,524),(10776,524),(10777,524),(10778,524),(10779,525),(10780,525),(10781,525),(10782,525),(10783,526),(10784,526),(10785,526),(10786,526),(10787,527),(10788,527),(10789,527),(10790,527),(10791,528),(10792,528),(10793,528),(10794,528),(10795,529),(10796,529),(10797,529),(10798,529),(10799,530),(10800,530),(10801,530),(10802,530),(10803,531),(10804,531),(10805,531),(10806,531),(10807,532),(10808,532),(10809,532),(10810,532),(10811,533),(10812,533),(10813,533),(10814,533),(10815,534),(10816,534),(10817,534),(10818,534),(10819,535),(10820,535),(10821,535),(10822,535),(10823,536),(10824,536),(10825,536),(10826,536),(10827,537),(10828,537),(10829,537),(10830,537),(10831,538),(10832,538),(10833,538),(10834,538),(10835,539),(10836,539),(10837,539),(10838,539),(10839,540),(10840,540),(10841,540),(10842,540),(10843,541),(10844,541),(10845,541),(10846,541),(10847,542),(10848,542),(10849,542),(10850,542),(10851,543),(10852,543),(10853,543),(10854,543),(10855,544),(10856,544),(10857,544),(10858,544),(10859,545),(10860,545),(10861,545),(10862,545),(10863,546),(10864,546),(10865,546),(10866,546),(10867,547),(10868,547),(10869,547),(10870,547),(10871,548),(10872,548),(10873,548),(10874,548),(10875,549),(10876,549),(10877,549),(10878,549),(10879,550),(10880,550),(10881,550),(10882,550),(10883,551),(10884,551),(10885,551),(10886,551),(10887,552),(10888,552),(10889,552),(10890,552),(10891,553),(10892,553),(10893,553),(10894,553),(10895,554),(10896,554),(10897,554),(10898,554),(10899,555),(10900,555),(10901,555),(10902,555),(10903,556),(10904,556),(10905,556),(10906,556),(10907,557),(10908,557),(10909,557),(10910,557),(10911,558),(10912,558),(10913,558),(10914,558),(10915,559),(10916,559),(10917,559),(10918,559),(10919,560),(10920,560),(10921,560),(10922,560),(10923,561),(10924,561),(10925,561),(10926,561),(10927,562),(10928,562),(10929,562),(10930,562),(10931,563),(10932,563),(10933,563),(10934,563),(10935,564),(10936,564),(10937,564),(10938,564),(10939,565),(10940,565),(10941,565),(10942,565),(10943,566),(10944,566),(10945,566),(10946,566),(10947,567),(10948,567),(10949,567),(10950,567),(10951,568),(10952,568),(10953,568),(10954,568),(10955,569),(10956,569),(10957,569),(10958,569),(10959,570),(10960,570),(10961,570),(10962,570),(10963,571),(10964,571),(10965,571),(10966,571),(10967,572),(10968,572),(10969,572),(10970,572),(10971,573),(10972,573),(10973,573),(10974,573),(10975,574),(10976,574),(10977,574),(10978,574),(10979,575),(10980,575),(10981,575),(10982,575),(10983,576),(10984,576),(10985,576),(10986,576),(10987,577),(10988,577),(10989,577),(10990,577),(10991,578),(10992,578),(10993,578),(10994,578),(10995,579),(10996,579),(10997,579),(10998,579),(10999,580),(11000,580),(11001,580),(11002,580),(11003,581),(11004,582),(11005,583),(11006,584),(11007,585),(11008,586),(11009,587),(11010,588),(11011,589),(11012,590),(11013,591),(11014,592),(11015,593),(11016,594),(11017,595),(11018,596),(11019,597),(11020,598),(11021,599),(11022,600),(11023,601),(11024,602),(11025,603),(11026,604),(11027,605),(11028,606),(11029,607),(11030,608),(11031,609),(11032,610),(11033,611),(11034,612),(11035,613),(11036,614),(11037,615),(11038,616),(11039,617),(11040,618),(11041,619),(11042,620),(11043,621),(11044,622),(11045,623),(11046,624),(11047,625),(11048,626),(11049,627),(11050,628),(11051,629),(11052,630),(11053,631),(11054,632),(11055,633),(11056,634),(11057,635),(11058,636),(11059,637),(11060,638),(11061,639),(11062,640),(11063,641),(11064,642),(11065,643),(11066,644),(11067,645),(11068,646),(11069,647),(11070,648),(11071,649),(11072,650),(11073,651),(11074,652),(11075,653),(11076,654),(11077,655),(11078,656),(11079,657),(11080,658),(11081,659),(11082,660),(11083,661),(11084,662),(11085,663),(11086,664),(11087,665),(11088,666),(11089,667),(11090,668),(11091,669),(11092,670),(11093,671),(11094,672),(11095,673),(11096,674),(11097,675),(11098,676),(11099,677),(11100,678),(11101,679),(11102,680),(11103,581),(11104,582),(11105,583),(11106,584),(11107,585),(11108,586),(11109,587),(11110,588),(11111,589),(11112,590),(11113,591),(11114,592),(11115,593),(11116,594),(11117,595),(11118,596),(11119,597),(11120,598),(11121,599),(11122,600),(11123,601),(11124,602),(11125,603),(11126,604),(11127,605),(11128,606),(11129,607),(11130,608),(11131,609),(11132,610),(11133,611),(11134,612),(11135,613),(11136,614),(11137,615),(11138,616),(11139,617),(11140,618),(11141,619),(11142,620),(11143,621),(11144,622),(11145,623),(11146,624),(11147,625),(11148,626),(11149,627),(11150,628),(11151,629),(11152,630),(11153,631),(11154,632),(11155,633),(11156,634),(11157,635),(11158,636),(11159,637),(11160,638),(11161,639),(11162,640),(11163,641),(11164,642),(11165,643),(11166,644),(11167,645),(11168,646),(11169,647),(11170,648),(11171,649),(11172,650),(11173,651),(11174,652),(11175,653),(11176,654),(11177,655),(11178,656),(11179,657),(11180,658),(11181,659),(11182,660),(11183,661),(11184,662),(11185,663),(11186,664),(11187,665),(11188,666),(11189,667),(11190,668),(11191,669),(11192,670),(11193,671),(11194,672),(11195,673),(11196,674),(11197,675),(11198,676),(11199,677),(11200,678),(11201,679),(11202,680),(11203,581),(11204,581),(11205,582),(11206,582),(11207,583),(11208,583),(11209,584),(11210,584),(11211,585),(11212,585),(11213,586),(11214,586),(11215,587),(11216,587),(11217,588),(11218,588),(11219,589),(11220,589),(11221,590),(11222,590),(11223,591),(11224,591),(11225,592),(11226,592),(11227,593),(11228,593),(11229,594),(11230,594),(11231,595),(11232,595),(11233,596),(11234,596),(11235,597),(11236,597),(11237,598),(11238,598),(11239,599),(11240,599),(11241,600),(11242,600),(11243,601),(11244,601),(11245,602),(11246,602),(11247,603),(11248,603),(11249,604),(11250,604),(11251,605),(11252,605),(11253,606),(11254,606),(11255,607),(11256,607),(11257,608),(11258,608),(11259,609),(11260,609),(11261,610),(11262,610),(11263,611),(11264,611),(11265,612),(11266,612),(11267,613),(11268,613),(11269,614),(11270,614),(11271,615),(11272,615),(11273,616),(11274,616),(11275,617),(11276,617),(11277,618),(11278,618),(11279,619),(11280,619),(11281,620),(11282,620),(11283,621),(11284,621),(11285,622),(11286,622),(11287,623),(11288,623),(11289,624),(11290,624),(11291,625),(11292,625),(11293,626),(11294,626),(11295,627),(11296,627),(11297,628),(11298,628),(11299,629),(11300,629),(11301,630),(11302,630),(11303,631),(11304,631),(11305,632),(11306,632),(11307,633),(11308,633),(11309,634),(11310,634),(11311,635),(11312,635),(11313,636),(11314,636),(11315,637),(11316,637),(11317,638),(11318,638),(11319,639),(11320,639),(11321,640),(11322,640),(11323,641),(11324,641),(11325,642),(11326,642),(11327,643),(11328,643),(11329,644),(11330,644),(11331,645),(11332,645),(11333,646),(11334,646),(11335,647),(11336,647),(11337,648),(11338,648),(11339,649),(11340,649),(11341,650),(11342,650),(11343,651),(11344,651),(11345,652),(11346,652),(11347,653),(11348,653),(11349,654),(11350,654),(11351,655),(11352,655),(11353,656),(11354,656),(11355,657),(11356,657),(11357,658),(11358,658),(11359,659),(11360,659),(11361,660),(11362,660),(11363,661),(11364,661),(11365,662),(11366,662),(11367,663),(11368,663),(11369,664),(11370,664),(11371,665),(11372,665),(11373,666),(11374,666),(11375,667),(11376,667),(11377,668),(11378,668),(11379,669),(11380,669),(11381,670),(11382,670),(11383,671),(11384,671),(11385,672),(11386,672),(11387,673),(11388,673),(11389,674),(11390,674),(11391,675),(11392,675),(11393,676),(11394,676),(11395,677),(11396,677),(11397,678),(11398,678),(11399,679),(11400,679),(11401,680),(11402,680),(11403,581),(11404,581),(11405,581),(11406,581),(11407,581),(11408,581),(11409,582),(11410,582),(11411,582),(11412,582),(11413,582),(11414,582),(11415,583),(11416,583),(11417,583),(11418,583),(11419,583),(11420,583),(11421,584),(11422,584),(11423,584),(11424,584),(11425,584),(11426,584),(11427,585),(11428,585),(11429,585),(11430,585),(11431,585),(11432,585),(11433,586),(11434,586),(11435,586),(11436,586),(11437,586),(11438,586),(11439,587),(11440,587),(11441,587),(11442,587),(11443,587),(11444,587),(11445,588),(11446,588),(11447,588),(11448,588),(11449,588),(11450,588),(11451,589),(11452,589),(11453,589),(11454,589),(11455,589),(11456,589),(11457,590),(11458,590),(11459,590),(11460,590),(11461,590),(11462,590),(11463,591),(11464,591),(11465,591),(11466,591),(11467,591),(11468,591),(11469,592),(11470,592),(11471,592),(11472,592),(11473,592),(11474,592),(11475,593),(11476,593),(11477,593),(11478,593),(11479,593),(11480,593),(11481,594),(11482,594),(11483,594),(11484,594),(11485,594),(11486,594),(11487,595),(11488,595),(11489,595),(11490,595),(11491,595),(11492,595),(11493,596),(11494,596),(11495,596),(11496,596),(11497,596),(11498,596),(11499,597),(11500,597),(11501,597),(11502,597),(11503,597),(11504,597),(11505,598),(11506,598),(11507,598),(11508,598),(11509,598),(11510,598),(11511,599),(11512,599),(11513,599),(11514,599),(11515,599),(11516,599),(11517,600),(11518,600),(11519,600),(11520,600),(11521,600),(11522,600),(11523,601),(11524,601),(11525,601),(11526,601),(11527,601),(11528,601),(11529,602),(11530,602),(11531,602),(11532,602),(11533,602),(11534,602),(11535,603),(11536,603),(11537,603),(11538,603),(11539,603),(11540,603),(11541,604),(11542,604),(11543,604),(11544,604),(11545,604),(11546,604),(11547,605),(11548,605),(11549,605),(11550,605),(11551,605),(11552,605),(11553,606),(11554,606),(11555,606),(11556,606),(11557,606),(11558,606),(11559,607),(11560,607),(11561,607),(11562,607),(11563,607),(11564,607),(11565,608),(11566,608),(11567,608),(11568,608),(11569,608),(11570,608),(11571,609),(11572,609),(11573,609),(11574,609),(11575,609),(11576,609),(11577,610),(11578,610),(11579,610),(11580,610),(11581,610),(11582,610),(11583,611),(11584,611),(11585,611),(11586,611),(11587,611),(11588,611),(11589,612),(11590,612),(11591,612),(11592,612),(11593,612),(11594,612),(11595,613),(11596,613),(11597,613),(11598,613),(11599,613),(11600,613),(11601,614),(11602,614),(11603,614),(11604,614),(11605,614),(11606,614),(11607,615),(11608,615),(11609,615),(11610,615),(11611,615),(11612,615),(11613,616),(11614,616),(11615,616),(11616,616),(11617,616),(11618,616),(11619,617),(11620,617),(11621,617),(11622,617),(11623,617),(11624,617),(11625,618),(11626,618),(11627,618),(11628,618),(11629,618),(11630,618),(11631,619),(11632,619),(11633,619),(11634,619),(11635,619),(11636,619),(11637,620),(11638,620),(11639,620),(11640,620),(11641,620),(11642,620),(11643,621),(11644,621),(11645,621),(11646,621),(11647,621),(11648,621),(11649,622),(11650,622),(11651,622),(11652,622),(11653,622),(11654,622),(11655,623),(11656,623),(11657,623),(11658,623),(11659,623),(11660,623),(11661,624),(11662,624),(11663,624),(11664,624),(11665,624),(11666,624),(11667,625),(11668,625),(11669,625),(11670,625),(11671,625),(11672,625),(11673,626),(11674,626),(11675,626),(11676,626),(11677,626),(11678,626),(11679,627),(11680,627),(11681,627),(11682,627),(11683,627),(11684,627),(11685,628),(11686,628),(11687,628),(11688,628),(11689,628),(11690,628),(11691,629),(11692,629),(11693,629),(11694,629),(11695,629),(11696,629),(11697,630),(11698,630),(11699,630),(11700,630),(11701,630),(11702,630),(11703,631),(11704,631),(11705,631),(11706,631),(11707,631),(11708,631),(11709,632),(11710,632),(11711,632),(11712,632),(11713,632),(11714,632),(11715,633),(11716,633),(11717,633),(11718,633),(11719,633),(11720,633),(11721,634),(11722,634),(11723,634),(11724,634),(11725,634),(11726,634),(11727,635),(11728,635),(11729,635),(11730,635),(11731,635),(11732,635),(11733,636),(11734,636),(11735,636),(11736,636),(11737,636),(11738,636),(11739,637),(11740,637),(11741,637),(11742,637),(11743,637),(11744,637),(11745,638),(11746,638),(11747,638),(11748,638),(11749,638),(11750,638),(11751,639),(11752,639),(11753,639),(11754,639),(11755,639),(11756,639),(11757,640),(11758,640),(11759,640),(11760,640),(11761,640),(11762,640),(11763,641),(11764,641),(11765,641),(11766,641),(11767,641),(11768,641),(11769,642),(11770,642),(11771,642),(11772,642),(11773,642),(11774,642),(11775,643),(11776,643),(11777,643),(11778,643),(11779,643),(11780,643),(11781,644),(11782,644),(11783,644),(11784,644),(11785,644),(11786,644),(11787,645),(11788,645),(11789,645),(11790,645),(11791,645),(11792,645),(11793,646),(11794,646),(11795,646),(11796,646),(11797,646),(11798,646),(11799,647),(11800,647),(11801,647),(11802,647),(11803,647),(11804,647),(11805,648),(11806,648),(11807,648),(11808,648),(11809,648),(11810,648),(11811,649),(11812,649),(11813,649),(11814,649),(11815,649),(11816,649),(11817,650),(11818,650),(11819,650),(11820,650),(11821,650),(11822,650),(11823,651),(11824,651),(11825,651),(11826,651),(11827,651),(11828,651),(11829,652),(11830,652),(11831,652),(11832,652),(11833,652),(11834,652),(11835,653),(11836,653),(11837,653),(11838,653),(11839,653),(11840,653),(11841,654),(11842,654),(11843,654),(11844,654),(11845,654),(11846,654),(11847,655),(11848,655),(11849,655),(11850,655),(11851,655),(11852,655),(11853,656),(11854,656),(11855,656),(11856,656),(11857,656),(11858,656),(11859,657),(11860,657),(11861,657),(11862,657),(11863,657),(11864,657),(11865,658),(11866,658),(11867,658),(11868,658),(11869,658),(11870,658),(11871,659),(11872,659),(11873,659),(11874,659),(11875,659),(11876,659),(11877,660),(11878,660),(11879,660),(11880,660),(11881,660),(11882,660),(11883,661),(11884,661),(11885,661),(11886,661),(11887,661),(11888,661),(11889,662),(11890,662),(11891,662),(11892,662),(11893,662),(11894,662),(11895,663),(11896,663),(11897,663),(11898,663),(11899,663),(11900,663),(11901,664),(11902,664),(11903,664),(11904,664),(11905,664),(11906,664),(11907,665),(11908,665),(11909,665),(11910,665),(11911,665),(11912,665),(11913,666),(11914,666),(11915,666),(11916,666),(11917,666),(11918,666),(11919,667),(11920,667),(11921,667),(11922,667),(11923,667),(11924,667),(11925,668),(11926,668),(11927,668),(11928,668),(11929,668),(11930,668),(11931,669),(11932,669),(11933,669),(11934,669),(11935,669),(11936,669),(11937,670),(11938,670),(11939,670),(11940,670),(11941,670),(11942,670),(11943,671),(11944,671),(11945,671),(11946,671),(11947,671),(11948,671),(11949,672),(11950,672),(11951,672),(11952,672),(11953,672),(11954,672),(11955,673),(11956,673),(11957,673),(11958,673),(11959,673),(11960,673),(11961,674),(11962,674),(11963,674),(11964,674),(11965,674),(11966,674),(11967,675),(11968,675),(11969,675),(11970,675),(11971,675),(11972,675),(11973,676),(11974,676),(11975,676),(11976,676),(11977,676),(11978,676),(11979,677),(11980,677),(11981,677),(11982,677),(11983,677),(11984,677),(11985,678),(11986,678),(11987,678),(11988,678),(11989,678),(11990,678),(11991,679),(11992,679),(11993,679),(11994,679),(11995,679),(11996,679),(11997,680),(11998,680),(11999,680),(12000,680),(12001,680),(12002,680),(12003,581),(12004,581),(12005,582),(12006,582),(12007,583),(12008,583),(12009,584),(12010,584),(12011,585),(12012,585),(12013,586),(12014,586),(12015,587),(12016,587),(12017,588),(12018,588),(12019,589),(12020,589),(12021,590),(12022,590),(12023,591),(12024,591),(12025,592),(12026,592),(12027,593),(12028,593),(12029,594),(12030,594),(12031,595),(12032,595),(12033,596),(12034,596),(12035,597),(12036,597),(12037,598),(12038,598),(12039,599),(12040,599),(12041,600),(12042,600),(12043,601),(12044,601),(12045,602),(12046,602),(12047,603),(12048,603),(12049,604),(12050,604),(12051,605),(12052,605),(12053,606),(12054,606),(12055,607),(12056,607),(12057,608),(12058,608),(12059,609),(12060,609),(12061,610),(12062,610),(12063,611),(12064,611),(12065,612),(12066,612),(12067,613),(12068,613),(12069,614),(12070,614),(12071,615),(12072,615),(12073,616),(12074,616),(12075,617),(12076,617),(12077,618),(12078,618),(12079,619),(12080,619),(12081,620),(12082,620),(12083,621),(12084,621),(12085,622),(12086,622),(12087,623),(12088,623),(12089,624),(12090,624),(12091,625),(12092,625),(12093,626),(12094,626),(12095,627),(12096,627),(12097,628),(12098,628),(12099,629),(12100,629),(12101,630),(12102,630),(12103,631),(12104,631),(12105,632),(12106,632),(12107,633),(12108,633),(12109,634),(12110,634),(12111,635),(12112,635),(12113,636),(12114,636),(12115,637),(12116,637),(12117,638),(12118,638),(12119,639),(12120,639),(12121,640),(12122,640),(12123,641),(12124,641),(12125,642),(12126,642),(12127,643),(12128,643),(12129,644),(12130,644),(12131,645),(12132,645),(12133,646),(12134,646),(12135,647),(12136,647),(12137,648),(12138,648),(12139,649),(12140,649),(12141,650),(12142,650),(12143,651),(12144,651),(12145,652),(12146,652),(12147,653),(12148,653),(12149,654),(12150,654),(12151,655),(12152,655),(12153,656),(12154,656),(12155,657),(12156,657),(12157,658),(12158,658),(12159,659),(12160,659),(12161,660),(12162,660),(12163,661),(12164,661),(12165,662),(12166,662),(12167,663),(12168,663),(12169,664),(12170,664),(12171,665),(12172,665),(12173,666),(12174,666),(12175,667),(12176,667),(12177,668),(12178,668),(12179,669),(12180,669),(12181,670),(12182,670),(12183,671),(12184,671),(12185,672),(12186,672),(12187,673),(12188,673),(12189,674),(12190,674),(12191,675),(12192,675),(12193,676),(12194,676),(12195,677),(12196,677),(12197,678),(12198,678),(12199,679),(12200,679),(12201,680),(12202,680),(12203,581),(12204,581),(12205,581),(12206,582),(12207,582),(12208,582),(12209,583),(12210,583),(12211,583),(12212,584),(12213,584),(12214,584),(12215,585),(12216,585),(12217,585),(12218,586),(12219,586),(12220,586),(12221,587),(12222,587),(12223,587),(12224,588),(12225,588),(12226,588),(12227,589),(12228,589),(12229,589),(12230,590),(12231,590),(12232,590),(12233,591),(12234,591),(12235,591),(12236,592),(12237,592),(12238,592),(12239,593),(12240,593),(12241,593),(12242,594),(12243,594),(12244,594),(12245,595),(12246,595),(12247,595),(12248,596),(12249,596),(12250,596),(12251,597),(12252,597),(12253,597),(12254,598),(12255,598),(12256,598),(12257,599),(12258,599),(12259,599),(12260,600),(12261,600),(12262,600),(12263,601),(12264,601),(12265,601),(12266,602),(12267,602),(12268,602),(12269,603),(12270,603),(12271,603),(12272,604),(12273,604),(12274,604),(12275,605),(12276,605),(12277,605),(12278,606),(12279,606),(12280,606),(12281,607),(12282,607),(12283,607),(12284,608),(12285,608),(12286,608),(12287,609),(12288,609),(12289,609),(12290,610),(12291,610),(12292,610),(12293,611),(12294,611),(12295,611),(12296,612),(12297,612),(12298,612),(12299,613),(12300,613),(12301,613),(12302,614),(12303,614),(12304,614),(12305,615),(12306,615),(12307,615),(12308,616),(12309,616),(12310,616),(12311,617),(12312,617),(12313,617),(12314,618),(12315,618),(12316,618),(12317,619),(12318,619),(12319,619),(12320,620),(12321,620),(12322,620),(12323,621),(12324,621),(12325,621),(12326,622),(12327,622),(12328,622),(12329,623),(12330,623),(12331,623),(12332,624),(12333,624),(12334,624),(12335,625),(12336,625),(12337,625),(12338,626),(12339,626),(12340,626),(12341,627),(12342,627),(12343,627),(12344,628),(12345,628),(12346,628),(12347,629),(12348,629),(12349,629),(12350,630),(12351,630),(12352,630),(12353,631),(12354,631),(12355,631),(12356,632),(12357,632),(12358,632),(12359,633),(12360,633),(12361,633),(12362,634),(12363,634),(12364,634),(12365,635),(12366,635),(12367,635),(12368,636),(12369,636),(12370,636),(12371,637),(12372,637),(12373,637),(12374,638),(12375,638),(12376,638),(12377,639),(12378,639),(12379,639),(12380,640),(12381,640),(12382,640),(12383,641),(12384,641),(12385,641),(12386,642),(12387,642),(12388,642),(12389,643),(12390,643),(12391,643),(12392,644),(12393,644),(12394,644),(12395,645),(12396,645),(12397,645),(12398,646),(12399,646),(12400,646),(12401,647),(12402,647),(12403,647),(12404,648),(12405,648),(12406,648),(12407,649),(12408,649),(12409,649),(12410,650),(12411,650),(12412,650),(12413,651),(12414,651),(12415,651),(12416,652),(12417,652),(12418,652),(12419,653),(12420,653),(12421,653),(12422,654),(12423,654),(12424,654),(12425,655),(12426,655),(12427,655),(12428,656),(12429,656),(12430,656),(12431,657),(12432,657),(12433,657),(12434,658),(12435,658),(12436,658),(12437,659),(12438,659),(12439,659),(12440,660),(12441,660),(12442,660),(12443,661),(12444,661),(12445,661),(12446,662),(12447,662),(12448,662),(12449,663),(12450,663),(12451,663),(12452,664),(12453,664),(12454,664),(12455,665),(12456,665),(12457,665),(12458,666),(12459,666),(12460,666),(12461,667),(12462,667),(12463,667),(12464,668),(12465,668),(12466,668),(12467,669),(12468,669),(12469,669),(12470,670),(12471,670),(12472,670),(12473,671),(12474,671),(12475,671),(12476,672),(12477,672),(12478,672),(12479,673),(12480,673),(12481,673),(12482,674),(12483,674),(12484,674),(12485,675),(12486,675),(12487,675),(12488,676),(12489,676),(12490,676),(12491,677),(12492,677),(12493,677),(12494,678),(12495,678),(12496,678),(12497,679),(12498,679),(12499,679),(12500,680),(12501,680),(12502,680),(12503,581),(12504,581),(12505,581),(12506,581),(12507,582),(12508,582),(12509,582),(12510,582),(12511,583),(12512,583),(12513,583),(12514,583),(12515,584),(12516,584),(12517,584),(12518,584),(12519,585),(12520,585),(12521,585),(12522,585),(12523,586),(12524,586),(12525,586),(12526,586),(12527,587),(12528,587),(12529,587),(12530,587),(12531,588),(12532,588),(12533,588),(12534,588),(12535,589),(12536,589),(12537,589),(12538,589),(12539,590),(12540,590),(12541,590),(12542,590),(12543,591),(12544,591),(12545,591),(12546,591),(12547,592),(12548,592),(12549,592),(12550,592),(12551,593),(12552,593),(12553,593),(12554,593),(12555,594),(12556,594),(12557,594),(12558,594),(12559,595),(12560,595),(12561,595),(12562,595),(12563,596),(12564,596),(12565,596),(12566,596),(12567,597),(12568,597),(12569,597),(12570,597),(12571,598),(12572,598),(12573,598),(12574,598),(12575,599),(12576,599),(12577,599),(12578,599),(12579,600),(12580,600),(12581,600),(12582,600),(12583,601),(12584,601),(12585,601),(12586,601),(12587,602),(12588,602),(12589,602),(12590,602),(12591,603),(12592,603),(12593,603),(12594,603),(12595,604),(12596,604),(12597,604),(12598,604),(12599,605),(12600,605),(12601,605),(12602,605),(12603,606),(12604,606),(12605,606),(12606,606),(12607,607),(12608,607),(12609,607),(12610,607),(12611,608),(12612,608),(12613,608),(12614,608),(12615,609),(12616,609),(12617,609),(12618,609),(12619,610),(12620,610),(12621,610),(12622,610),(12623,611),(12624,611),(12625,611),(12626,611),(12627,612),(12628,612),(12629,612),(12630,612),(12631,613),(12632,613),(12633,613),(12634,613),(12635,614),(12636,614),(12637,614),(12638,614),(12639,615),(12640,615),(12641,615),(12642,615),(12643,616),(12644,616),(12645,616),(12646,616),(12647,617),(12648,617),(12649,617),(12650,617),(12651,618),(12652,618),(12653,618),(12654,618),(12655,619),(12656,619),(12657,619),(12658,619),(12659,620),(12660,620),(12661,620),(12662,620),(12663,621),(12664,621),(12665,621),(12666,621),(12667,622),(12668,622),(12669,622),(12670,622),(12671,623),(12672,623),(12673,623),(12674,623),(12675,624),(12676,624),(12677,624),(12678,624),(12679,625),(12680,625),(12681,625),(12682,625),(12683,626),(12684,626),(12685,626),(12686,626),(12687,627),(12688,627),(12689,627),(12690,627),(12691,628),(12692,628),(12693,628),(12694,628),(12695,629),(12696,629),(12697,629),(12698,629),(12699,630),(12700,630),(12701,630),(12702,630),(12703,631),(12704,631),(12705,631),(12706,631),(12707,632),(12708,632),(12709,632),(12710,632),(12711,633),(12712,633),(12713,633),(12714,633),(12715,634),(12716,634),(12717,634),(12718,634),(12719,635),(12720,635),(12721,635),(12722,635),(12723,636),(12724,636),(12725,636),(12726,636),(12727,637),(12728,637),(12729,637),(12730,637),(12731,638),(12732,638),(12733,638),(12734,638),(12735,639),(12736,639),(12737,639),(12738,639),(12739,640),(12740,640),(12741,640),(12742,640),(12743,641),(12744,641),(12745,641),(12746,641),(12747,642),(12748,642),(12749,642),(12750,642),(12751,643),(12752,643),(12753,643),(12754,643),(12755,644),(12756,644),(12757,644),(12758,644),(12759,645),(12760,645),(12761,645),(12762,645),(12763,646),(12764,646),(12765,646),(12766,646),(12767,647),(12768,647),(12769,647),(12770,647),(12771,648),(12772,648),(12773,648),(12774,648),(12775,649),(12776,649),(12777,649),(12778,649),(12779,650),(12780,650),(12781,650),(12782,650),(12783,651),(12784,651),(12785,651),(12786,651),(12787,652),(12788,652),(12789,652),(12790,652),(12791,653),(12792,653),(12793,653),(12794,653),(12795,654),(12796,654),(12797,654),(12798,654),(12799,655),(12800,655),(12801,655),(12802,655),(12803,656),(12804,656),(12805,656),(12806,656),(12807,657),(12808,657),(12809,657),(12810,657),(12811,658),(12812,658),(12813,658),(12814,658),(12815,659),(12816,659),(12817,659),(12818,659),(12819,660),(12820,660),(12821,660),(12822,660),(12823,661),(12824,661),(12825,661),(12826,661),(12827,662),(12828,662),(12829,662),(12830,662),(12831,663),(12832,663),(12833,663),(12834,663),(12835,664),(12836,664),(12837,664),(12838,664),(12839,665),(12840,665),(12841,665),(12842,665),(12843,666),(12844,666),(12845,666),(12846,666),(12847,667),(12848,667),(12849,667),(12850,667),(12851,668),(12852,668),(12853,668),(12854,668),(12855,669),(12856,669),(12857,669),(12858,669),(12859,670),(12860,670),(12861,670),(12862,670),(12863,671),(12864,671),(12865,671),(12866,671),(12867,672),(12868,672),(12869,672),(12870,672),(12871,673),(12872,673),(12873,673),(12874,673),(12875,674),(12876,674),(12877,674),(12878,674),(12879,675),(12880,675),(12881,675),(12882,675),(12883,676),(12884,676),(12885,676),(12886,676),(12887,677),(12888,677),(12889,677),(12890,677),(12891,678),(12892,678),(12893,678),(12894,678),(12895,679),(12896,679),(12897,679),(12898,679),(12899,680),(12900,680),(12901,680),(12902,680),(12903,681),(12904,682),(12905,683),(12906,684),(12907,685),(12908,686),(12909,687),(12910,688),(12911,689),(12912,690),(12913,691),(12914,692),(12915,693),(12916,694),(12917,695),(12918,696),(12919,697),(12920,698),(12921,699),(12922,700),(12923,701),(12924,702),(12925,703),(12926,704),(12927,705),(12928,706),(12929,707),(12930,708),(12931,709),(12932,710),(12933,711),(12934,712),(12935,713),(12936,714),(12937,715),(12938,716),(12939,717),(12940,718),(12941,719),(12942,720),(12943,721),(12944,722),(12945,723),(12946,724),(12947,725),(12948,726),(12949,727),(12950,728),(12951,729),(12952,730),(12953,731),(12954,732),(12955,733),(12956,734),(12957,735),(12958,736),(12959,737),(12960,738),(12961,739),(12962,740),(12963,741),(12964,742),(12965,743),(12966,744),(12967,745),(12968,746),(12969,747),(12970,748),(12971,749),(12972,750),(12973,751),(12974,752),(12975,753),(12976,754),(12977,755),(12978,756),(12979,757),(12980,758),(12981,759),(12982,760),(12983,761),(12984,762),(12985,763),(12986,764),(12987,765),(12988,766),(12989,767),(12990,768),(12991,769),(12992,770),(12993,771),(12994,772),(12995,773),(12996,774),(12997,775),(12998,776),(12999,777),(13000,778),(13001,779),(13002,780),(13003,681),(13004,682),(13005,683),(13006,684),(13007,685),(13008,686),(13009,687),(13010,688),(13011,689),(13012,690),(13013,691),(13014,692),(13015,693),(13016,694),(13017,695),(13018,696),(13019,697),(13020,698),(13021,699),(13022,700),(13023,701),(13024,702),(13025,703),(13026,704),(13027,705),(13028,706),(13029,707),(13030,708),(13031,709),(13032,710),(13033,711),(13034,712),(13035,713),(13036,714),(13037,715),(13038,716),(13039,717),(13040,718),(13041,719),(13042,720),(13043,721),(13044,722),(13045,723),(13046,724),(13047,725),(13048,726),(13049,727),(13050,728),(13051,729),(13052,730),(13053,731),(13054,732),(13055,733),(13056,734),(13057,735),(13058,736),(13059,737),(13060,738),(13061,739),(13062,740),(13063,741),(13064,742),(13065,743),(13066,744),(13067,745),(13068,746),(13069,747),(13070,748),(13071,749),(13072,750),(13073,751),(13074,752),(13075,753),(13076,754),(13077,755),(13078,756),(13079,757),(13080,758),(13081,759),(13082,760),(13083,761),(13084,762),(13085,763),(13086,764),(13087,765),(13088,766),(13089,767),(13090,768),(13091,769),(13092,770),(13093,771),(13094,772),(13095,773),(13096,774),(13097,775),(13098,776),(13099,777),(13100,778),(13101,779),(13102,780),(13103,681),(13104,681),(13105,682),(13106,682),(13107,683),(13108,683),(13109,684),(13110,684),(13111,685),(13112,685),(13113,686),(13114,686),(13115,687),(13116,687),(13117,688),(13118,688),(13119,689),(13120,689),(13121,690),(13122,690),(13123,691),(13124,691),(13125,692),(13126,692),(13127,693),(13128,693),(13129,694),(13130,694),(13131,695),(13132,695),(13133,696),(13134,696),(13135,697),(13136,697),(13137,698),(13138,698),(13139,699),(13140,699),(13141,700),(13142,700),(13143,701),(13144,701),(13145,702),(13146,702),(13147,703),(13148,703),(13149,704),(13150,704),(13151,705),(13152,705),(13153,706),(13154,706),(13155,707),(13156,707),(13157,708),(13158,708),(13159,709),(13160,709),(13161,710),(13162,710),(13163,711),(13164,711),(13165,712),(13166,712),(13167,713),(13168,713),(13169,714),(13170,714),(13171,715),(13172,715),(13173,716),(13174,716),(13175,717),(13176,717),(13177,718),(13178,718),(13179,719),(13180,719),(13181,720),(13182,720),(13183,721),(13184,721),(13185,722),(13186,722),(13187,723),(13188,723),(13189,724),(13190,724),(13191,725),(13192,725),(13193,726),(13194,726),(13195,727),(13196,727),(13197,728),(13198,728),(13199,729),(13200,729),(13201,730),(13202,730),(13203,731),(13204,731),(13205,732),(13206,732),(13207,733),(13208,733),(13209,734),(13210,734),(13211,735),(13212,735),(13213,736),(13214,736),(13215,737),(13216,737),(13217,738),(13218,738),(13219,739),(13220,739),(13221,740),(13222,740),(13223,741),(13224,741),(13225,742),(13226,742),(13227,743),(13228,743),(13229,744),(13230,744),(13231,745),(13232,745),(13233,746),(13234,746),(13235,747),(13236,747),(13237,748),(13238,748),(13239,749),(13240,749),(13241,750),(13242,750),(13243,751),(13244,751),(13245,752),(13246,752),(13247,753),(13248,753),(13249,754),(13250,754),(13251,755),(13252,755),(13253,756),(13254,756),(13255,757),(13256,757),(13257,758),(13258,758),(13259,759),(13260,759),(13261,760),(13262,760),(13263,761),(13264,761),(13265,762),(13266,762),(13267,763),(13268,763),(13269,764),(13270,764),(13271,765),(13272,765),(13273,766),(13274,766),(13275,767),(13276,767),(13277,768),(13278,768),(13279,769),(13280,769),(13281,770),(13282,770),(13283,771),(13284,771),(13285,772),(13286,772),(13287,773),(13288,773),(13289,774),(13290,774),(13291,775),(13292,775),(13293,776),(13294,776),(13295,777),(13296,777),(13297,778),(13298,778),(13299,779),(13300,779),(13301,780),(13302,780),(13303,681),(13304,681),(13305,681),(13306,681),(13307,682),(13308,682),(13309,682),(13310,682),(13311,682),(13312,682),(13313,683),(13314,683),(13315,683),(13316,683),(13317,684),(13318,684),(13319,684),(13320,684),(13321,685),(13322,685),(13323,685),(13324,685),(13325,686),(13326,686),(13327,686),(13328,686),(13329,687),(13330,687),(13331,687),(13332,687),(13333,687),(13334,687),(13335,688),(13336,688),(13337,688),(13338,688),(13339,688),(13340,688),(13341,689),(13342,689),(13343,689),(13344,689),(13345,690),(13346,690),(13347,690),(13348,690),(13349,690),(13350,690),(13351,691),(13352,691),(13353,691),(13354,691),(13355,691),(13356,691),(13357,692),(13358,692),(13359,692),(13360,692),(13361,692),(13362,692),(13363,693),(13364,693),(13365,693),(13366,693),(13367,693),(13368,693),(13369,694),(13370,694),(13371,694),(13372,694),(13373,694),(13374,694),(13375,695),(13376,695),(13377,695),(13378,695),(13379,695),(13380,695),(13381,696),(13382,696),(13383,696),(13384,696),(13385,696),(13386,696),(13387,697),(13388,697),(13389,697),(13390,697),(13391,697),(13392,697),(13393,698),(13394,698),(13395,698),(13396,698),(13397,698),(13398,698),(13399,699),(13400,699),(13401,699),(13402,699),(13403,700),(13404,700),(13405,700),(13406,700),(13407,700),(13408,700),(13409,701),(13410,701),(13411,701),(13412,701),(13413,701),(13414,701),(13415,702),(13416,702),(13417,702),(13418,702),(13419,702),(13420,702),(13421,703),(13422,703),(13423,703),(13424,703),(13425,703),(13426,703),(13427,704),(13428,704),(13429,704),(13430,704),(13431,704),(13432,704),(13433,705),(13434,705),(13435,705),(13436,705),(13437,705),(13438,705),(13439,706),(13440,706),(13441,706),(13442,706),(13443,706),(13444,706),(13445,707),(13446,707),(13447,707),(13448,707),(13449,707),(13450,707),(13451,708),(13452,708),(13453,708),(13454,708),(13455,708),(13456,708),(13457,709),(13458,709),(13459,709),(13460,709),(13461,710),(13462,710),(13463,710),(13464,710),(13465,711),(13466,711),(13467,711),(13468,711),(13469,711),(13470,711),(13471,712),(13472,712),(13473,712),(13474,712),(13475,713),(13476,713),(13477,713),(13478,713),(13479,713),(13480,713),(13481,714),(13482,714),(13483,714),(13484,714),(13485,714),(13486,714),(13487,715),(13488,715),(13489,715),(13490,715),(13491,716),(13492,716),(13493,716),(13494,716),(13495,717),(13496,717),(13497,717),(13498,717),(13499,718),(13500,718),(13501,718),(13502,718),(13503,719),(13504,719),(13505,719),(13506,719),(13507,720),(13508,720),(13509,720),(13510,720),(13511,721),(13512,721),(13513,721),(13514,721),(13515,721),(13516,721),(13517,722),(13518,722),(13519,722),(13520,722),(13521,723),(13522,723),(13523,723),(13524,723),(13525,724),(13526,724),(13527,724),(13528,724),(13529,725),(13530,725),(13531,725),(13532,725),(13533,725),(13534,726),(13535,726),(13536,726),(13537,726),(13538,727),(13539,727),(13540,727),(13541,727),(13542,728),(13543,728),(13544,728),(13545,728),(13546,729),(13547,729),(13548,729),(13549,729),(13550,730),(13551,730),(13552,730),(13553,730),(13554,731),(13555,731),(13556,731),(13557,731),(13558,732),(13559,732),(13560,732),(13561,732),(13562,732),(13563,732),(13564,733),(13565,733),(13566,733),(13567,733),(13568,733),(13569,733),(13570,734),(13571,734),(13572,734),(13573,734),(13574,734),(13575,734),(13576,735),(13577,735),(13578,735),(13579,735),(13580,736),(13581,736),(13582,736),(13583,736),(13584,737),(13585,737),(13586,737),(13587,737),(13588,737),(13589,737),(13590,738),(13591,738),(13592,738),(13593,738),(13594,739),(13595,739),(13596,739),(13597,739),(13598,740),(13599,740),(13600,740),(13601,740),(13602,741),(13603,741),(13604,741),(13605,741),(13606,741),(13607,741),(13608,742),(13609,742),(13610,742),(13611,742),(13612,742),(13613,742),(13614,743),(13615,743),(13616,743),(13617,743),(13618,743),(13619,743),(13620,744),(13621,744),(13622,744),(13623,744),(13624,744),(13625,744),(13626,745),(13627,745),(13628,745),(13629,745),(13630,745),(13631,745),(13632,746),(13633,746),(13634,746),(13635,746),(13636,746),(13637,746),(13638,747),(13639,747),(13640,747),(13641,747),(13642,747),(13643,747),(13644,748),(13645,748),(13646,748),(13647,748),(13648,748),(13649,748),(13650,749),(13651,749),(13652,749),(13653,749),(13654,749),(13655,749),(13656,750),(13657,750),(13658,750),(13659,750),(13660,750),(13661,750),(13662,751),(13663,751),(13664,751),(13665,751),(13666,751),(13667,751),(13668,752),(13669,752),(13670,752),(13671,752),(13672,752),(13673,752),(13674,753),(13675,753),(13676,753),(13677,753),(13678,753),(13679,753),(13680,754),(13681,754),(13682,754),(13683,754),(13684,754),(13685,754),(13686,755),(13687,755),(13688,755),(13689,755),(13690,755),(13691,755),(13692,756),(13693,756),(13694,756),(13695,756),(13696,756),(13697,756),(13698,757),(13699,757),(13700,757),(13701,757),(13702,757),(13703,757),(13704,758),(13705,758),(13706,758),(13707,758),(13708,758),(13709,758),(13710,759),(13711,759),(13712,759),(13713,759),(13714,759),(13715,759),(13716,760),(13717,760),(13718,760),(13719,760),(13720,760),(13721,760),(13722,761),(13723,761),(13724,761),(13725,761),(13726,761),(13727,761),(13728,762),(13729,762),(13730,762),(13731,762),(13732,762),(13733,762),(13734,763),(13735,763),(13736,763),(13737,763),(13738,763),(13739,763),(13740,764),(13741,764),(13742,764),(13743,764),(13744,764),(13745,764),(13746,765),(13747,765),(13748,765),(13749,765),(13750,765),(13751,765),(13752,766),(13753,766),(13754,766),(13755,766),(13756,766),(13757,766),(13758,767),(13759,767),(13760,767),(13761,767),(13762,767),(13763,767),(13764,768),(13765,768),(13766,768),(13767,768),(13768,768),(13769,768),(13770,769),(13771,769),(13772,769),(13773,769),(13774,769),(13775,769),(13776,770),(13777,770),(13778,770),(13779,770),(13780,770),(13781,770),(13782,771),(13783,771),(13784,771),(13785,771),(13786,771),(13787,771),(13788,772),(13789,772),(13790,772),(13791,772),(13792,772),(13793,772),(13794,773),(13795,773),(13796,773),(13797,773),(13798,773),(13799,773),(13800,774),(13801,774),(13802,774),(13803,774),(13804,774),(13805,774),(13806,775),(13807,775),(13808,775),(13809,775),(13810,775),(13811,775),(13812,776),(13813,776),(13814,776),(13815,776),(13816,776),(13817,776),(13818,777),(13819,777),(13820,777),(13821,777),(13822,777),(13823,777),(13824,778),(13825,778),(13826,778),(13827,778),(13828,778),(13829,778),(13830,779),(13831,779),(13832,779),(13833,779),(13834,779),(13835,779),(13836,780),(13837,780),(13838,780),(13839,780),(13840,780),(13841,780),(13842,681),(13843,682),(13844,682),(13845,683),(13846,684),(13847,685),(13848,686),(13849,687),(13850,687),(13851,688),(13852,688),(13853,689),(13854,690),(13855,690),(13856,691),(13857,691),(13858,692),(13859,692),(13860,693),(13861,693),(13862,694),(13863,694),(13864,695),(13865,695),(13866,696),(13867,696),(13868,697),(13869,697),(13870,698),(13871,698),(13872,699),(13873,700),(13874,700),(13875,701),(13876,701),(13877,702),(13878,702),(13879,703),(13880,703),(13881,704),(13882,704),(13883,705),(13884,705),(13885,706),(13886,706),(13887,707),(13888,707),(13889,708),(13890,708),(13891,709),(13892,710),(13893,711),(13894,711),(13895,712),(13896,713),(13897,713),(13898,714),(13899,714),(13900,715),(13901,716),(13902,717),(13903,718),(13904,719),(13905,720),(13906,721),(13907,721),(13908,722),(13909,723),(13910,724),(13911,725),(13912,725),(13913,726),(13914,727),(13915,728),(13916,729),(13917,730),(13918,731),(13919,732),(13920,732),(13921,733),(13922,733),(13923,734),(13924,734),(13925,735),(13926,736),(13927,737),(13928,737),(13929,738),(13930,739),(13931,740),(13932,741),(13933,741),(13934,742),(13935,742),(13936,743),(13937,743),(13938,744),(13939,744),(13940,745),(13941,745),(13942,746),(13943,746),(13944,747),(13945,747),(13946,748),(13947,748),(13948,749),(13949,749),(13950,750),(13951,750),(13952,751),(13953,751),(13954,752),(13955,752),(13956,753),(13957,753),(13958,754),(13959,754),(13960,755),(13961,755),(13962,756),(13963,756),(13964,757),(13965,757),(13966,758),(13967,758),(13968,759),(13969,759),(13970,760),(13971,760),(13972,761),(13973,761),(13974,762),(13975,762),(13976,763),(13977,763),(13978,764),(13979,764),(13980,765),(13981,765),(13982,766),(13983,766),(13984,767),(13985,767),(13986,768),(13987,768),(13988,769),(13989,769),(13990,770),(13991,770),(13992,771),(13993,771),(13994,772),(13995,772),(13996,773),(13997,773),(13998,774),(13999,774),(14000,775),(14001,775),(14002,776),(14003,776),(14004,777),(14005,777),(14006,778),(14007,778),(14008,779),(14009,779),(14010,780),(14011,780),(14012,681),(14013,681),(14014,681),(14015,682),(14016,682),(14017,682),(14018,683),(14019,683),(14020,683),(14021,684),(14022,684),(14023,684),(14024,685),(14025,685),(14026,685),(14027,686),(14028,686),(14029,686),(14030,687),(14031,687),(14032,687),(14033,688),(14034,688),(14035,688),(14036,689),(14037,689),(14038,689),(14039,690),(14040,690),(14041,690),(14042,691),(14043,691),(14044,691),(14045,692),(14046,692),(14047,692),(14048,693),(14049,693),(14050,693),(14051,694),(14052,694),(14053,694),(14054,695),(14055,695),(14056,695),(14057,696),(14058,696),(14059,696),(14060,697),(14061,697),(14062,697),(14063,698),(14064,698),(14065,698),(14066,699),(14067,699),(14068,699),(14069,700),(14070,700),(14071,700),(14072,701),(14073,701),(14074,701),(14075,702),(14076,702),(14077,702),(14078,703),(14079,703),(14080,703),(14081,704),(14082,704),(14083,704),(14084,705),(14085,705),(14086,705),(14087,706),(14088,706),(14089,706),(14090,707),(14091,707),(14092,707),(14093,708),(14094,708),(14095,708),(14096,709),(14097,709),(14098,709),(14099,710),(14100,710),(14101,710),(14102,711),(14103,711),(14104,711),(14105,712),(14106,712),(14107,712),(14108,713),(14109,713),(14110,713),(14111,714),(14112,714),(14113,714),(14114,715),(14115,715),(14116,715),(14117,716),(14118,716),(14119,716),(14120,717),(14121,717),(14122,717),(14123,718),(14124,718),(14125,718),(14126,719),(14127,719),(14128,719),(14129,720),(14130,720),(14131,720),(14132,721),(14133,721),(14134,721),(14135,722),(14136,722),(14137,722),(14138,723),(14139,723),(14140,723),(14141,724),(14142,724),(14143,724),(14144,725),(14145,725),(14146,725),(14147,726),(14148,726),(14149,726),(14150,727),(14151,727),(14152,727),(14153,728),(14154,728),(14155,728),(14156,729),(14157,729),(14158,729),(14159,730),(14160,730),(14161,730),(14162,731),(14163,731),(14164,731),(14165,732),(14166,732),(14167,732),(14168,733),(14169,733),(14170,733),(14171,734),(14172,734),(14173,734),(14174,735),(14175,735),(14176,735),(14177,736),(14178,736),(14179,736),(14180,737),(14181,737),(14182,737),(14183,738),(14184,738),(14185,738),(14186,739),(14187,739),(14188,739),(14189,740),(14190,740),(14191,740),(14192,741),(14193,741),(14194,741),(14195,742),(14196,742),(14197,742),(14198,743),(14199,743),(14200,743),(14201,744),(14202,744),(14203,744),(14204,745),(14205,745),(14206,745),(14207,746),(14208,746),(14209,746),(14210,747),(14211,747),(14212,747),(14213,748),(14214,748),(14215,748),(14216,749),(14217,749),(14218,749),(14219,750),(14220,750),(14221,750),(14222,751),(14223,751),(14224,751),(14225,752),(14226,752),(14227,752),(14228,753),(14229,753),(14230,753),(14231,754),(14232,754),(14233,754),(14234,755),(14235,755),(14236,755),(14237,756),(14238,756),(14239,756),(14240,757),(14241,757),(14242,757),(14243,758),(14244,758),(14245,758),(14246,759),(14247,759),(14248,759),(14249,760),(14250,760),(14251,760),(14252,761),(14253,761),(14254,761),(14255,762),(14256,762),(14257,762),(14258,763),(14259,763),(14260,763),(14261,764),(14262,764),(14263,764),(14264,765),(14265,765),(14266,765),(14267,766),(14268,766),(14269,766),(14270,767),(14271,767),(14272,767),(14273,768),(14274,768),(14275,768),(14276,769),(14277,769),(14278,769),(14279,770),(14280,770),(14281,770),(14282,771),(14283,771),(14284,771),(14285,772),(14286,772),(14287,772),(14288,773),(14289,773),(14290,773),(14291,774),(14292,774),(14293,774),(14294,775),(14295,775),(14296,775),(14297,776),(14298,776),(14299,776),(14300,777),(14301,777),(14302,777),(14303,778),(14304,778),(14305,778),(14306,779),(14307,779),(14308,779),(14309,780),(14310,780),(14311,780),(14312,681),(14313,681),(14314,681),(14315,681),(14316,682),(14317,682),(14318,682),(14319,682),(14320,683),(14321,683),(14322,683),(14323,683),(14324,684),(14325,684),(14326,684),(14327,684),(14328,685),(14329,685),(14330,685),(14331,685),(14332,686),(14333,686),(14334,686),(14335,686),(14336,687),(14337,687),(14338,687),(14339,687),(14340,688),(14341,688),(14342,688),(14343,688),(14344,689),(14345,689),(14346,689),(14347,689),(14348,690),(14349,690),(14350,690),(14351,690),(14352,691),(14353,691),(14354,691),(14355,691),(14356,692),(14357,692),(14358,692),(14359,692),(14360,693),(14361,693),(14362,693),(14363,693),(14364,694),(14365,694),(14366,694),(14367,694),(14368,695),(14369,695),(14370,695),(14371,695),(14372,696),(14373,696),(14374,696),(14375,696),(14376,697),(14377,697),(14378,697),(14379,697),(14380,698),(14381,698),(14382,698),(14383,698),(14384,699),(14385,699),(14386,699),(14387,699),(14388,700),(14389,700),(14390,700),(14391,700),(14392,701),(14393,701),(14394,701),(14395,701),(14396,702),(14397,702),(14398,702),(14399,702),(14400,703),(14401,703),(14402,703),(14403,703),(14404,704),(14405,704),(14406,704),(14407,704),(14408,705),(14409,705),(14410,705),(14411,705),(14412,706),(14413,706),(14414,706),(14415,706),(14416,707),(14417,707),(14418,707),(14419,707),(14420,708),(14421,708),(14422,708),(14423,708),(14424,709),(14425,709),(14426,709),(14427,709),(14428,710),(14429,710),(14430,710),(14431,710),(14432,711),(14433,711),(14434,711),(14435,711),(14436,712),(14437,712),(14438,712),(14439,712),(14440,713),(14441,713),(14442,713),(14443,713),(14444,714),(14445,714),(14446,714),(14447,714),(14448,715),(14449,715),(14450,715),(14451,715),(14452,716),(14453,716),(14454,716),(14455,716),(14456,717),(14457,717),(14458,717),(14459,717),(14460,718),(14461,718),(14462,718),(14463,718),(14464,719),(14465,719),(14466,719),(14467,719),(14468,720),(14469,720),(14470,720),(14471,720),(14472,721),(14473,721),(14474,721),(14475,721),(14476,722),(14477,722),(14478,722),(14479,722),(14480,723),(14481,723),(14482,723),(14483,723),(14484,724),(14485,724),(14486,724),(14487,724),(14488,725),(14489,725),(14490,725),(14491,725),(14492,726),(14493,726),(14494,726),(14495,726),(14496,727),(14497,727),(14498,727),(14499,727),(14500,728),(14501,728),(14502,728),(14503,728),(14504,729),(14505,729),(14506,729),(14507,729),(14508,730),(14509,730),(14510,730),(14511,730),(14512,731),(14513,731),(14514,731),(14515,731),(14516,732),(14517,732),(14518,732),(14519,732),(14520,733),(14521,733),(14522,733),(14523,733),(14524,734),(14525,734),(14526,734),(14527,734),(14528,735),(14529,735),(14530,735),(14531,735),(14532,736),(14533,736),(14534,736),(14535,736),(14536,737),(14537,737),(14538,737),(14539,737),(14540,738),(14541,738),(14542,738),(14543,738),(14544,739),(14545,739),(14546,739),(14547,739),(14548,740),(14549,740),(14550,740),(14551,740),(14552,741),(14553,741),(14554,741),(14555,741),(14556,742),(14557,742),(14558,742),(14559,742),(14560,743),(14561,743),(14562,743),(14563,743),(14564,744),(14565,744),(14566,744),(14567,744),(14568,745),(14569,745),(14570,745),(14571,745),(14572,746),(14573,746),(14574,746),(14575,746),(14576,747),(14577,747),(14578,747),(14579,747),(14580,748),(14581,748),(14582,748),(14583,748),(14584,749),(14585,749),(14586,749),(14587,749),(14588,750),(14589,750),(14590,750),(14591,750),(14592,751),(14593,751),(14594,751),(14595,751),(14596,752),(14597,752),(14598,752),(14599,752),(14600,753),(14601,753),(14602,753),(14603,753),(14604,754),(14605,754),(14606,754),(14607,754),(14608,755),(14609,755),(14610,755),(14611,755),(14612,756),(14613,756),(14614,756),(14615,756),(14616,757),(14617,757),(14618,757),(14619,757),(14620,758),(14621,758),(14622,758),(14623,758),(14624,759),(14625,759),(14626,759),(14627,759),(14628,760),(14629,760),(14630,760),(14631,760),(14632,761),(14633,761),(14634,761),(14635,761),(14636,762),(14637,762),(14638,762),(14639,762),(14640,763),(14641,763),(14642,763),(14643,763),(14644,764),(14645,764),(14646,764),(14647,764),(14648,765),(14649,765),(14650,765),(14651,765),(14652,766),(14653,766),(14654,766),(14655,766),(14656,767),(14657,767),(14658,767),(14659,767),(14660,768),(14661,768),(14662,768),(14663,768),(14664,769),(14665,769),(14666,769),(14667,769),(14668,770),(14669,770),(14670,770),(14671,770),(14672,771),(14673,771),(14674,771),(14675,771),(14676,772),(14677,772),(14678,772),(14679,772),(14680,773),(14681,773),(14682,773),(14683,773),(14684,774),(14685,774),(14686,774),(14687,774),(14688,775),(14689,775),(14690,775),(14691,775),(14692,776),(14693,776),(14694,776),(14695,776),(14696,777),(14697,777),(14698,777),(14699,777),(14700,778),(14701,778),(14702,778),(14703,778),(14704,779),(14705,779),(14706,779),(14707,779),(14708,780),(14709,780),(14710,780),(14711,780),(14712,781),(14713,782),(14714,783),(14715,784),(14716,785),(14717,786),(14718,787),(14719,788),(14720,789),(14721,790),(14722,791),(14723,792),(14724,793),(14725,794),(14726,795),(14727,796),(14728,797),(14729,798),(14730,799),(14731,800),(14732,801),(14733,802),(14734,803),(14735,804),(14736,805),(14737,806),(14738,807),(14739,808),(14740,809),(14741,810),(14742,811),(14743,812),(14744,813),(14745,814),(14746,815),(14747,816),(14748,817),(14749,818),(14750,819),(14751,820),(14752,821),(14753,822),(14754,823),(14755,824),(14756,825),(14757,826),(14758,827),(14759,828),(14760,829),(14761,830),(14762,831),(14763,832),(14764,833),(14765,834),(14766,835),(14767,836),(14768,837),(14769,838),(14770,839),(14771,840),(14772,841),(14773,842),(14774,843),(14775,844),(14776,845),(14777,846),(14778,847),(14779,848),(14780,849),(14781,850),(14782,851),(14783,852),(14784,853),(14785,854),(14786,855),(14787,856),(14788,857),(14789,858),(14790,859),(14791,860),(14792,861),(14793,862),(14794,863),(14795,864),(14796,865),(14797,866),(14798,867),(14799,868),(14800,869),(14801,870),(14802,871),(14803,872),(14804,873),(14805,874),(14806,875),(14807,876),(14808,877),(14809,878),(14810,879),(14811,880),(14812,781),(14813,782),(14814,783),(14815,784),(14816,785),(14817,786),(14818,787),(14819,788),(14820,789),(14821,790),(14822,791),(14823,792),(14824,793),(14825,794),(14826,795),(14827,796),(14828,797),(14829,798),(14830,799),(14831,800),(14832,801),(14833,802),(14834,803),(14835,804),(14836,805),(14837,806),(14838,807),(14839,808),(14840,809),(14841,810),(14842,811),(14843,812),(14844,813),(14845,814),(14846,815),(14847,816),(14848,817),(14849,818),(14850,819),(14851,820),(14852,821),(14853,822),(14854,823),(14855,824),(14856,825),(14857,826),(14858,827),(14859,828),(14860,829),(14861,830),(14862,831),(14863,832),(14864,833),(14865,834),(14866,835),(14867,836),(14868,837),(14869,838),(14870,839),(14871,840),(14872,841),(14873,842),(14874,843),(14875,844),(14876,845),(14877,846),(14878,847),(14879,848),(14880,849),(14881,850),(14882,851),(14883,852),(14884,853),(14885,854),(14886,855),(14887,856),(14888,857),(14889,858),(14890,859),(14891,860),(14892,861),(14893,862),(14894,863),(14895,864),(14896,865),(14897,866),(14898,867),(14899,868),(14900,869),(14901,870),(14902,871),(14903,872),(14904,873),(14905,874),(14906,875),(14907,876),(14908,877),(14909,878),(14910,879),(14911,880),(14912,781),(14913,781),(14914,782),(14915,782),(14916,783),(14917,783),(14918,784),(14919,784),(14920,785),(14921,785),(14922,786),(14923,786),(14924,787),(14925,787),(14926,788),(14927,788),(14928,789),(14929,789),(14930,790),(14931,790),(14932,791),(14933,791),(14934,792),(14935,792),(14936,793),(14937,793),(14938,794),(14939,794),(14940,795),(14941,795),(14942,796),(14943,796),(14944,797),(14945,797),(14946,798),(14947,798),(14948,799),(14949,799),(14950,800),(14951,800),(14952,801),(14953,801),(14954,802),(14955,802),(14956,803),(14957,803),(14958,804),(14959,804),(14960,805),(14961,805),(14962,806),(14963,806),(14964,807),(14965,807),(14966,808),(14967,808),(14968,809),(14969,809),(14970,810),(14971,810),(14972,811),(14973,811),(14974,812),(14975,812),(14976,813),(14977,813),(14978,814),(14979,814),(14980,815),(14981,815),(14982,816),(14983,816),(14984,817),(14985,817),(14986,818),(14987,818),(14988,819),(14989,819),(14990,820),(14991,820),(14992,821),(14993,821),(14994,822),(14995,822),(14996,823),(14997,823),(14998,824),(14999,824),(15000,825),(15001,825),(15002,826),(15003,826),(15004,827),(15005,827),(15006,828),(15007,828),(15008,829),(15009,829),(15010,830),(15011,830),(15012,831),(15013,831),(15014,832),(15015,832),(15016,833),(15017,833),(15018,834),(15019,834),(15020,835),(15021,835),(15022,836),(15023,836),(15024,837),(15025,837),(15026,838),(15027,838),(15028,839),(15029,839),(15030,840),(15031,840),(15032,841),(15033,841),(15034,842),(15035,842),(15036,843),(15037,843),(15038,844),(15039,844),(15040,845),(15041,845),(15042,846),(15043,846),(15044,847),(15045,847),(15046,848),(15047,848),(15048,849),(15049,849),(15050,850),(15051,850),(15052,851),(15053,851),(15054,852),(15055,852),(15056,853),(15057,853),(15058,854),(15059,854),(15060,855),(15061,855),(15062,856),(15063,856),(15064,857),(15065,857),(15066,858),(15067,858),(15068,859),(15069,859),(15070,860),(15071,860),(15072,861),(15073,861),(15074,862),(15075,862),(15076,863),(15077,863),(15078,864),(15079,864),(15080,865),(15081,865),(15082,866),(15083,866),(15084,867),(15085,867),(15086,868),(15087,868),(15088,869),(15089,869),(15090,870),(15091,870),(15092,871),(15093,871),(15094,872),(15095,872),(15096,873),(15097,873),(15098,874),(15099,874),(15100,875),(15101,875),(15102,876),(15103,876),(15104,877),(15105,877),(15106,878),(15107,878),(15108,879),(15109,879),(15110,880),(15111,880),(15112,781),(15113,781),(15114,781),(15115,781),(15116,781),(15117,781),(15118,782),(15119,782),(15120,782),(15121,782),(15122,782),(15123,782),(15124,783),(15125,783),(15126,783),(15127,783),(15128,783),(15129,783),(15130,784),(15131,784),(15132,784),(15133,784),(15134,784),(15135,784),(15136,785),(15137,785),(15138,785),(15139,785),(15140,785),(15141,785),(15142,786),(15143,786),(15144,786),(15145,786),(15146,786),(15147,786),(15148,787),(15149,787),(15150,787),(15151,787),(15152,787),(15153,787),(15154,788),(15155,788),(15156,788),(15157,788),(15158,788),(15159,788),(15160,789),(15161,789),(15162,789),(15163,789),(15164,789),(15165,789),(15166,790),(15167,790),(15168,790),(15169,790),(15170,790),(15171,790),(15172,791),(15173,791),(15174,791),(15175,791),(15176,791),(15177,791),(15178,792),(15179,792),(15180,792),(15181,792),(15182,792),(15183,792),(15184,793),(15185,793),(15186,793),(15187,793),(15188,793),(15189,793),(15190,794),(15191,794),(15192,794),(15193,794),(15194,794),(15195,794),(15196,795),(15197,795),(15198,795),(15199,795),(15200,795),(15201,795),(15202,796),(15203,796),(15204,796),(15205,796),(15206,796),(15207,796),(15208,797),(15209,797),(15210,797),(15211,797),(15212,797),(15213,797),(15214,798),(15215,798),(15216,798),(15217,798),(15218,798),(15219,798),(15220,799),(15221,799),(15222,799),(15223,799),(15224,799),(15225,799),(15226,800),(15227,800),(15228,800),(15229,800),(15230,800),(15231,800),(15232,801),(15233,801),(15234,801),(15235,801),(15236,801),(15237,801),(15238,802),(15239,802),(15240,802),(15241,802),(15242,802),(15243,802),(15244,803),(15245,803),(15246,803),(15247,803),(15248,803),(15249,803),(15250,804),(15251,804),(15252,804),(15253,804),(15254,804),(15255,804),(15256,805),(15257,805),(15258,805),(15259,805),(15260,805),(15261,805),(15262,806),(15263,806),(15264,806),(15265,806),(15266,806),(15267,806),(15268,807),(15269,807),(15270,807),(15271,807),(15272,807),(15273,807),(15274,808),(15275,808),(15276,808),(15277,808),(15278,808),(15279,808),(15280,809),(15281,809),(15282,809),(15283,809),(15284,809),(15285,809),(15286,810),(15287,810),(15288,810),(15289,810),(15290,810),(15291,810),(15292,811),(15293,811),(15294,811),(15295,811),(15296,811),(15297,811),(15298,812),(15299,812),(15300,812),(15301,812),(15302,812),(15303,812),(15304,813),(15305,813),(15306,813),(15307,813),(15308,813),(15309,813),(15310,814),(15311,814),(15312,814),(15313,814),(15314,814),(15315,814),(15316,815),(15317,815),(15318,815),(15319,815),(15320,815),(15321,815),(15322,816),(15323,816),(15324,816),(15325,816),(15326,816),(15327,816),(15328,817),(15329,817),(15330,817),(15331,817),(15332,817),(15333,817),(15334,818),(15335,818),(15336,818),(15337,818),(15338,818),(15339,818),(15340,819),(15341,819),(15342,819),(15343,819),(15344,819),(15345,819),(15346,820),(15347,820),(15348,820),(15349,820),(15350,820),(15351,820),(15352,821),(15353,821),(15354,821),(15355,821),(15356,821),(15357,821),(15358,822),(15359,822),(15360,822),(15361,822),(15362,822),(15363,822),(15364,823),(15365,823),(15366,823),(15367,823),(15368,823),(15369,823),(15370,824),(15371,824),(15372,824),(15373,824),(15374,824),(15375,824),(15376,825),(15377,825),(15378,825),(15379,825),(15380,825),(15381,825),(15382,826),(15383,826),(15384,826),(15385,826),(15386,826),(15387,826),(15388,827),(15389,827),(15390,827),(15391,827),(15392,827),(15393,827),(15394,828),(15395,828),(15396,828),(15397,828),(15398,828),(15399,828),(15400,829),(15401,829),(15402,829),(15403,829),(15404,829),(15405,829),(15406,830),(15407,830),(15408,830),(15409,830),(15410,830),(15411,830),(15412,831),(15413,831),(15414,831),(15415,831),(15416,831),(15417,831),(15418,832),(15419,832),(15420,832),(15421,832),(15422,832),(15423,832),(15424,833),(15425,833),(15426,833),(15427,833),(15428,833),(15429,833),(15430,834),(15431,834),(15432,834),(15433,834),(15434,834),(15435,834),(15436,835),(15437,835),(15438,835),(15439,835),(15440,835),(15441,835),(15442,836),(15443,836),(15444,836),(15445,836),(15446,836),(15447,836),(15448,837),(15449,837),(15450,837),(15451,837),(15452,837),(15453,837),(15454,838),(15455,838),(15456,838),(15457,838),(15458,838),(15459,838),(15460,839),(15461,839),(15462,839),(15463,839),(15464,839),(15465,839),(15466,840),(15467,840),(15468,840),(15469,840),(15470,840),(15471,840),(15472,841),(15473,841),(15474,841),(15475,841),(15476,841),(15477,841),(15478,842),(15479,842),(15480,842),(15481,842),(15482,842),(15483,842),(15484,843),(15485,843),(15486,843),(15487,843),(15488,843),(15489,843),(15490,844),(15491,844),(15492,844),(15493,844),(15494,844),(15495,844),(15496,845),(15497,845),(15498,845),(15499,845),(15500,845),(15501,845),(15502,846),(15503,846),(15504,846),(15505,846),(15506,846),(15507,846),(15508,847),(15509,847),(15510,847),(15511,847),(15512,847),(15513,847),(15514,848),(15515,848),(15516,848),(15517,848),(15518,848),(15519,848),(15520,849),(15521,849),(15522,849),(15523,849),(15524,849),(15525,849),(15526,850),(15527,850),(15528,850),(15529,850),(15530,850),(15531,850),(15532,851),(15533,851),(15534,851),(15535,851),(15536,851),(15537,851),(15538,852),(15539,852),(15540,852),(15541,852),(15542,852),(15543,852),(15544,853),(15545,853),(15546,853),(15547,853),(15548,853),(15549,853),(15550,854),(15551,854),(15552,854),(15553,854),(15554,854),(15555,854),(15556,855),(15557,855),(15558,855),(15559,855),(15560,855),(15561,855),(15562,856),(15563,856),(15564,856),(15565,856),(15566,856),(15567,856),(15568,857),(15569,857),(15570,857),(15571,857),(15572,857),(15573,857),(15574,858),(15575,858),(15576,858),(15577,858),(15578,858),(15579,858),(15580,859),(15581,859),(15582,859),(15583,859),(15584,859),(15585,859),(15586,860),(15587,860),(15588,860),(15589,860),(15590,860),(15591,860),(15592,861),(15593,861),(15594,861),(15595,861),(15596,861),(15597,861),(15598,862),(15599,862),(15600,862),(15601,862),(15602,862),(15603,862),(15604,863),(15605,863),(15606,863),(15607,863),(15608,863),(15609,863),(15610,864),(15611,864),(15612,864),(15613,864),(15614,864),(15615,864),(15616,865),(15617,865),(15618,865),(15619,865),(15620,865),(15621,865),(15622,866),(15623,866),(15624,866),(15625,866),(15626,866),(15627,866),(15628,867),(15629,867),(15630,867),(15631,867),(15632,867),(15633,867),(15634,868),(15635,868),(15636,868),(15637,868),(15638,868),(15639,868),(15640,869),(15641,869),(15642,869),(15643,869),(15644,869),(15645,869),(15646,870),(15647,870),(15648,870),(15649,870),(15650,870),(15651,870),(15652,871),(15653,871),(15654,871),(15655,871),(15656,871),(15657,871),(15658,872),(15659,872),(15660,872),(15661,872),(15662,872),(15663,872),(15664,873),(15665,873),(15666,873),(15667,873),(15668,873),(15669,873),(15670,874),(15671,874),(15672,874),(15673,874),(15674,874),(15675,874),(15676,875),(15677,875),(15678,875),(15679,875),(15680,875),(15681,875),(15682,876),(15683,876),(15684,876),(15685,876),(15686,876),(15687,876),(15688,877),(15689,877),(15690,877),(15691,877),(15692,877),(15693,877),(15694,878),(15695,878),(15696,878),(15697,878),(15698,878),(15699,878),(15700,879),(15701,879),(15702,879),(15703,879),(15704,879),(15705,879),(15706,880),(15707,880),(15708,880),(15709,880),(15710,880),(15711,880),(15712,781),(15713,781),(15714,782),(15715,782),(15716,783),(15717,783),(15718,784),(15719,784),(15720,785),(15721,785),(15722,786),(15723,786),(15724,787),(15725,787),(15726,788),(15727,788),(15728,789),(15729,789),(15730,790),(15731,790),(15732,791),(15733,791),(15734,792),(15735,792),(15736,793),(15737,793),(15738,794),(15739,794),(15740,795),(15741,795),(15742,796),(15743,796),(15744,797),(15745,797),(15746,798),(15747,798),(15748,799),(15749,799),(15750,800),(15751,800),(15752,801),(15753,801),(15754,802),(15755,802),(15756,803),(15757,803),(15758,804),(15759,804),(15760,805),(15761,805),(15762,806),(15763,806),(15764,807),(15765,807),(15766,808),(15767,808),(15768,809),(15769,809),(15770,810),(15771,810),(15772,811),(15773,811),(15774,812),(15775,812),(15776,813),(15777,813),(15778,814),(15779,814),(15780,815),(15781,815),(15782,816),(15783,816),(15784,817),(15785,817),(15786,818),(15787,818),(15788,819),(15789,819),(15790,820),(15791,820),(15792,821),(15793,821),(15794,822),(15795,822),(15796,823),(15797,823),(15798,824),(15799,824),(15800,825),(15801,825),(15802,826),(15803,826),(15804,827),(15805,827),(15806,828),(15807,828),(15808,829),(15809,829),(15810,830),(15811,830),(15812,831),(15813,831),(15814,832),(15815,832),(15816,833),(15817,833),(15818,834),(15819,834),(15820,835),(15821,835),(15822,836),(15823,836),(15824,837),(15825,837),(15826,838),(15827,838),(15828,839),(15829,839),(15830,840),(15831,840),(15832,841),(15833,841),(15834,842),(15835,842),(15836,843),(15837,843),(15838,844),(15839,844),(15840,845),(15841,845),(15842,846),(15843,846),(15844,847),(15845,847),(15846,848),(15847,848),(15848,849),(15849,849),(15850,850),(15851,850),(15852,851),(15853,851),(15854,852),(15855,852),(15856,853),(15857,853),(15858,854),(15859,854),(15860,855),(15861,855),(15862,856),(15863,856),(15864,857),(15865,857),(15866,858),(15867,858),(15868,859),(15869,859),(15870,860),(15871,860),(15872,861),(15873,861),(15874,862),(15875,862),(15876,863),(15877,863),(15878,864),(15879,864),(15880,865),(15881,865),(15882,866),(15883,866),(15884,867),(15885,867),(15886,868),(15887,868),(15888,869),(15889,869),(15890,870),(15891,870),(15892,871),(15893,871),(15894,872),(15895,872),(15896,873),(15897,873),(15898,873),(15899,874),(15900,874),(15901,874),(15902,875),(15903,875),(15904,875),(15905,876),(15906,876),(15907,876),(15908,877),(15909,877),(15910,877),(15911,878),(15912,878),(15913,879),(15914,879),(15915,880),(15916,880),(15917,880),(15918,781),(15919,781),(15920,781),(15921,782),(15922,782),(15923,782),(15924,783),(15925,783),(15926,783),(15927,784),(15928,784),(15929,784),(15930,785),(15931,785),(15932,785),(15933,786),(15934,786),(15935,786),(15936,787),(15937,787),(15938,787),(15939,788),(15940,788),(15941,788),(15942,789),(15943,789),(15944,789),(15945,790),(15946,790),(15947,790),(15948,791),(15949,791),(15950,791),(15951,792),(15952,792),(15953,792),(15954,793),(15955,793),(15956,793),(15957,794),(15958,794),(15959,794),(15960,795),(15961,795),(15962,795),(15963,796),(15964,796),(15965,796),(15966,797),(15967,797),(15968,797),(15969,798),(15970,798),(15971,798),(15972,799),(15973,799),(15974,799),(15975,800),(15976,800),(15977,800),(15978,801),(15979,801),(15980,801),(15981,802),(15982,802),(15983,802),(15984,803),(15985,803),(15986,803),(15987,804),(15988,804),(15989,804),(15990,805),(15991,805),(15992,805),(15993,806),(15994,806),(15995,806),(15996,807),(15997,807),(15998,807),(15999,808),(16000,808),(16001,808),(16002,809),(16003,809),(16004,809),(16005,810),(16006,810),(16007,810),(16008,811),(16009,811),(16010,811),(16011,812),(16012,812),(16013,812),(16014,813),(16015,813),(16016,813),(16017,814),(16018,814),(16019,814),(16020,815),(16021,815),(16022,815),(16023,816),(16024,816),(16025,816),(16026,817),(16027,817),(16028,817),(16029,818),(16030,818),(16031,818),(16032,819),(16033,819),(16034,819),(16035,820),(16036,820),(16037,820),(16038,821),(16039,821),(16040,821),(16041,822),(16042,822),(16043,822),(16044,823),(16045,823),(16046,823),(16047,824),(16048,824),(16049,824),(16050,825),(16051,825),(16052,825),(16053,826),(16054,826),(16055,826),(16056,827),(16057,827),(16058,827),(16059,828),(16060,828),(16061,828),(16062,829),(16063,829),(16064,829),(16065,830),(16066,830),(16067,830),(16068,831),(16069,831),(16070,831),(16071,832),(16072,832),(16073,832),(16074,833),(16075,833),(16076,833),(16077,834),(16078,834),(16079,834),(16080,835),(16081,835),(16082,835),(16083,836),(16084,836),(16085,836),(16086,837),(16087,837),(16088,837),(16089,838),(16090,838),(16091,838),(16092,839),(16093,839),(16094,839),(16095,840),(16096,840),(16097,840),(16098,841),(16099,841),(16100,841),(16101,842),(16102,842),(16103,842),(16104,843),(16105,843),(16106,843),(16107,844),(16108,844),(16109,844),(16110,845),(16111,845),(16112,845),(16113,846),(16114,846),(16115,846),(16116,847),(16117,847),(16118,847),(16119,848),(16120,848),(16121,848),(16122,849),(16123,849),(16124,849),(16125,850),(16126,850),(16127,850),(16128,851),(16129,851),(16130,851),(16131,852),(16132,852),(16133,852),(16134,853),(16135,853),(16136,853),(16137,854),(16138,854),(16139,854),(16140,855),(16141,855),(16142,855),(16143,856),(16144,856),(16145,856),(16146,857),(16147,857),(16148,857),(16149,858),(16150,858),(16151,858),(16152,859),(16153,859),(16154,859),(16155,860),(16156,860),(16157,860),(16158,861),(16159,861),(16160,861),(16161,862),(16162,862),(16163,862),(16164,863),(16165,863),(16166,863),(16167,864),(16168,864),(16169,864),(16170,865),(16171,865),(16172,865),(16173,866),(16174,866),(16175,866),(16176,867),(16177,867),(16178,867),(16179,868),(16180,868),(16181,868),(16182,869),(16183,869),(16184,869),(16185,870),(16186,870),(16187,870),(16188,871),(16189,871),(16190,871),(16191,872),(16192,872),(16193,872),(16194,873),(16195,873),(16196,874),(16197,874),(16198,875),(16199,875),(16200,876),(16201,876),(16202,877),(16203,877),(16204,878),(16205,878),(16206,879),(16207,879),(16208,880),(16209,880),(16210,781),(16211,781),(16212,781),(16213,781),(16214,782),(16215,782),(16216,782),(16217,782),(16218,783),(16219,783),(16220,783),(16221,783),(16222,784),(16223,784),(16224,784),(16225,784),(16226,785),(16227,785),(16228,785),(16229,785),(16230,786),(16231,786),(16232,786),(16233,786),(16234,787),(16235,787),(16236,787),(16237,787),(16238,788),(16239,788),(16240,788),(16241,788),(16242,789),(16243,789),(16244,789),(16245,789),(16246,790),(16247,790),(16248,790),(16249,790),(16250,791),(16251,791),(16252,791),(16253,791),(16254,792),(16255,792),(16256,792),(16257,792),(16258,793),(16259,793),(16260,793),(16261,793),(16262,794),(16263,794),(16264,794),(16265,794),(16266,795),(16267,795),(16268,795),(16269,795),(16270,796),(16271,796),(16272,796),(16273,796),(16274,797),(16275,797),(16276,797),(16277,797),(16278,798),(16279,798),(16280,798),(16281,798),(16282,799),(16283,799),(16284,799),(16285,799),(16286,800),(16287,800),(16288,800),(16289,800),(16290,801),(16291,801),(16292,801),(16293,801),(16294,802),(16295,802),(16296,802),(16297,802),(16298,803),(16299,803),(16300,803),(16301,803),(16302,804),(16303,804),(16304,804),(16305,804),(16306,805),(16307,805),(16308,805),(16309,805),(16310,806),(16311,806),(16312,806),(16313,806),(16314,807),(16315,807),(16316,807),(16317,807),(16318,808),(16319,808),(16320,808),(16321,808),(16322,809),(16323,809),(16324,809),(16325,809),(16326,810),(16327,810),(16328,810),(16329,810),(16330,811),(16331,811),(16332,811),(16333,811),(16334,812),(16335,812),(16336,812),(16337,812),(16338,813),(16339,813),(16340,813),(16341,813),(16342,814),(16343,814),(16344,814),(16345,814),(16346,815),(16347,815),(16348,815),(16349,815),(16350,816),(16351,816),(16352,816),(16353,816),(16354,817),(16355,817),(16356,817),(16357,817),(16358,818),(16359,818),(16360,818),(16361,818),(16362,819),(16363,819),(16364,819),(16365,819),(16366,820),(16367,820),(16368,820),(16369,820),(16370,821),(16371,821),(16372,821),(16373,821),(16374,822),(16375,822),(16376,822),(16377,822),(16378,823),(16379,823),(16380,823),(16381,823),(16382,824),(16383,824),(16384,824),(16385,824),(16386,825),(16387,825),(16388,825),(16389,825),(16390,826),(16391,826),(16392,826),(16393,826),(16394,827),(16395,827),(16396,827),(16397,827),(16398,828),(16399,828),(16400,828),(16401,828),(16402,829),(16403,829),(16404,829),(16405,829),(16406,830),(16407,830),(16408,830),(16409,830),(16410,831),(16411,831),(16412,831),(16413,831),(16414,832),(16415,832),(16416,832),(16417,832),(16418,833),(16419,833),(16420,833),(16421,833),(16422,834),(16423,834),(16424,834),(16425,834),(16426,835),(16427,835),(16428,835),(16429,835),(16430,836),(16431,836),(16432,836),(16433,836),(16434,837),(16435,837),(16436,837),(16437,837),(16438,838),(16439,838),(16440,838),(16441,838),(16442,839),(16443,839),(16444,839),(16445,839),(16446,840),(16447,840),(16448,840),(16449,840),(16450,841),(16451,841),(16452,841),(16453,841),(16454,842),(16455,842),(16456,842),(16457,842),(16458,843),(16459,843),(16460,843),(16461,843),(16462,844),(16463,844),(16464,844),(16465,844),(16466,845),(16467,845),(16468,845),(16469,845),(16470,846),(16471,846),(16472,846),(16473,846),(16474,847),(16475,847),(16476,847),(16477,847),(16478,848),(16479,848),(16480,848),(16481,848),(16482,849),(16483,849),(16484,849),(16485,849),(16486,850),(16487,850),(16488,850),(16489,850),(16490,851),(16491,851),(16492,851),(16493,851),(16494,852),(16495,852),(16496,852),(16497,852),(16498,853),(16499,853),(16500,853),(16501,853),(16502,854),(16503,854),(16504,854),(16505,854),(16506,855),(16507,855),(16508,855),(16509,855),(16510,856),(16511,856),(16512,856),(16513,856),(16514,857),(16515,857),(16516,857),(16517,857),(16518,858),(16519,858),(16520,858),(16521,858),(16522,859),(16523,859),(16524,859),(16525,859),(16526,860),(16527,860),(16528,860),(16529,860),(16530,861),(16531,861),(16532,861),(16533,861),(16534,862),(16535,862),(16536,862),(16537,862),(16538,863),(16539,863),(16540,863),(16541,863),(16542,864),(16543,864),(16544,864),(16545,864),(16546,865),(16547,865),(16548,865),(16549,865),(16550,866),(16551,866),(16552,866),(16553,866),(16554,867),(16555,867),(16556,867),(16557,867),(16558,868),(16559,868),(16560,868),(16561,868),(16562,869),(16563,869),(16564,869),(16565,869),(16566,870),(16567,870),(16568,870),(16569,870),(16570,871),(16571,871),(16572,871),(16573,871),(16574,872),(16575,872),(16576,872),(16577,872),(16578,873),(16579,873),(16580,873),(16581,873),(16582,874),(16583,874),(16584,874),(16585,874),(16586,875),(16587,875),(16588,875),(16589,875),(16590,876),(16591,876),(16592,876),(16593,876),(16594,877),(16595,877),(16596,877),(16597,877),(16598,878),(16599,878),(16600,878),(16601,878),(16602,879),(16603,879),(16604,879),(16605,879),(16606,880),(16607,880),(16608,880),(16609,880),(16610,881),(16611,882),(16612,883),(16613,884),(16614,885),(16615,886),(16616,887),(16617,888),(16618,889),(16619,890),(16620,891),(16621,892),(16622,893),(16623,894),(16624,895),(16625,896),(16626,897),(16627,898),(16628,899),(16629,900),(16630,901),(16631,902),(16632,903),(16633,904),(16634,905),(16635,906),(16636,907),(16637,908),(16638,909),(16639,910),(16640,911),(16641,912),(16642,913),(16643,914),(16644,915),(16645,916),(16646,917),(16647,918),(16648,919),(16649,920),(16650,921),(16651,922),(16652,923),(16653,924),(16654,925),(16655,926),(16656,927),(16657,928),(16658,929),(16659,930),(16660,931),(16661,932),(16662,933),(16663,934),(16664,935),(16665,936),(16666,937),(16667,938),(16668,939),(16669,940),(16670,941),(16671,942),(16672,943),(16673,944),(16674,945),(16675,946),(16676,947),(16677,948),(16678,949),(16679,950),(16680,951),(16681,952),(16682,953),(16683,954),(16684,955),(16685,956),(16686,957),(16687,958),(16688,959),(16689,960),(16690,961),(16691,962),(16692,963),(16693,964),(16694,965),(16695,966),(16696,967),(16697,968),(16698,969),(16699,970),(16700,971),(16701,972),(16702,973),(16703,974),(16704,975),(16705,976),(16706,977),(16707,978),(16708,979),(16709,980),(16710,881),(16711,882),(16712,883),(16713,884),(16714,885),(16715,886),(16716,887),(16717,888),(16718,889),(16719,890),(16720,891),(16721,892),(16722,893),(16723,894),(16724,895),(16725,896),(16726,897),(16727,898),(16728,899),(16729,900),(16730,901),(16731,902),(16732,903),(16733,904),(16734,905),(16735,906),(16736,907),(16737,908),(16738,909),(16739,910),(16740,911),(16741,912),(16742,913),(16743,914),(16744,915),(16745,916),(16746,917),(16747,918),(16748,919),(16749,920),(16750,921),(16751,922),(16752,923),(16753,924),(16754,925),(16755,926),(16756,927),(16757,928),(16758,929),(16759,930),(16760,931),(16761,932),(16762,933),(16763,934),(16764,935),(16765,936),(16766,937),(16767,938),(16768,939),(16769,940),(16770,941),(16771,942),(16772,943),(16773,944),(16774,945),(16775,946),(16776,947),(16777,948),(16778,949),(16779,950),(16780,951),(16781,952),(16782,953),(16783,954),(16784,955),(16785,956),(16786,957),(16787,958),(16788,959),(16789,960),(16790,961),(16791,962),(16792,963),(16793,964),(16794,965),(16795,966),(16796,967),(16797,968),(16798,969),(16799,970),(16800,971),(16801,972),(16802,973),(16803,974),(16804,975),(16805,976),(16806,977),(16807,978),(16808,979),(16809,980),(16810,881),(16811,881),(16812,882),(16813,882),(16814,883),(16815,883),(16816,884),(16817,884),(16818,885),(16819,885),(16820,886),(16821,886),(16822,887),(16823,887),(16824,888),(16825,888),(16826,889),(16827,889),(16828,890),(16829,890),(16830,891),(16831,891),(16832,892),(16833,892),(16834,893),(16835,893),(16836,894),(16837,894),(16838,895),(16839,895),(16840,896),(16841,896),(16842,897),(16843,897),(16844,898),(16845,898),(16846,899),(16847,899),(16848,900),(16849,900),(16850,901),(16851,901),(16852,902),(16853,902),(16854,903),(16855,903),(16856,904),(16857,904),(16858,905),(16859,905),(16860,906),(16861,906),(16862,907),(16863,907),(16864,908),(16865,908),(16866,909),(16867,909),(16868,910),(16869,910),(16870,911),(16871,911),(16872,912),(16873,912),(16874,913),(16875,913),(16876,914),(16877,914),(16878,915),(16879,915),(16880,916),(16881,916),(16882,917),(16883,917),(16884,918),(16885,918),(16886,919),(16887,919),(16888,920),(16889,920),(16890,921),(16891,921),(16892,922),(16893,922),(16894,923),(16895,923),(16896,924),(16897,924),(16898,925),(16899,925),(16900,926),(16901,926),(16902,927),(16903,927),(16904,928),(16905,928),(16906,929),(16907,929),(16908,930),(16909,930),(16910,931),(16911,931),(16912,932),(16913,932),(16914,933),(16915,933),(16916,934),(16917,934),(16918,935),(16919,935),(16920,936),(16921,936),(16922,937),(16923,937),(16924,938),(16925,938),(16926,939),(16927,939),(16928,940),(16929,940),(16930,941),(16931,941),(16932,942),(16933,942),(16934,943),(16935,943),(16936,944),(16937,944),(16938,945),(16939,945),(16940,946),(16941,946),(16942,947),(16943,947),(16944,948),(16945,948),(16946,949),(16947,949),(16948,950),(16949,950),(16950,951),(16951,951),(16952,952),(16953,952),(16954,953),(16955,953),(16956,954),(16957,954),(16958,955),(16959,955),(16960,956),(16961,956),(16962,957),(16963,957),(16964,958),(16965,958),(16966,959),(16967,959),(16968,960),(16969,960),(16970,961),(16971,961),(16972,962),(16973,962),(16974,963),(16975,963),(16976,964),(16977,964),(16978,965),(16979,965),(16980,966),(16981,966),(16982,967),(16983,967),(16984,968),(16985,968),(16986,969),(16987,969),(16988,970),(16989,970),(16990,971),(16991,971),(16992,972),(16993,972),(16994,973),(16995,973),(16996,974),(16997,974),(16998,975),(16999,975),(17000,976),(17001,976),(17002,977),(17003,977),(17004,978),(17005,978),(17006,979),(17007,979),(17008,980),(17009,980),(17010,881),(17011,881),(17012,881),(17013,881),(17014,881),(17015,881),(17016,882),(17017,882),(17018,882),(17019,882),(17020,882),(17021,882),(17022,883),(17023,883),(17024,883),(17025,883),(17026,883),(17027,883),(17028,884),(17029,884),(17030,884),(17031,884),(17032,884),(17033,884),(17034,885),(17035,885),(17036,885),(17037,885),(17038,885),(17039,885),(17040,886),(17041,886),(17042,886),(17043,886),(17044,886),(17045,886),(17046,887),(17047,887),(17048,887),(17049,887),(17050,887),(17051,887),(17052,888),(17053,888),(17054,888),(17055,888),(17056,888),(17057,888),(17058,889),(17059,889),(17060,889),(17061,889),(17062,889),(17063,889),(17064,890),(17065,890),(17066,890),(17067,890),(17068,890),(17069,890),(17070,891),(17071,891),(17072,891),(17073,891),(17074,891),(17075,891),(17076,892),(17077,892),(17078,892),(17079,892),(17080,892),(17081,892),(17082,893),(17083,893),(17084,893),(17085,893),(17086,893),(17087,893),(17088,894),(17089,894),(17090,894),(17091,894),(17092,894),(17093,894),(17094,895),(17095,895),(17096,895),(17097,895),(17098,895),(17099,895),(17100,896),(17101,896),(17102,896),(17103,896),(17104,896),(17105,896),(17106,897),(17107,897),(17108,897),(17109,897),(17110,897),(17111,897),(17112,898),(17113,898),(17114,898),(17115,898),(17116,898),(17117,898),(17118,899),(17119,899),(17120,899),(17121,899),(17122,899),(17123,899),(17124,900),(17125,900),(17126,900),(17127,900),(17128,900),(17129,900),(17130,901),(17131,901),(17132,901),(17133,901),(17134,901),(17135,901),(17136,902),(17137,902),(17138,902),(17139,902),(17140,902),(17141,902),(17142,903),(17143,903),(17144,903),(17145,903),(17146,903),(17147,903),(17148,904),(17149,904),(17150,904),(17151,904),(17152,904),(17153,904),(17154,905),(17155,905),(17156,905),(17157,905),(17158,905),(17159,905),(17160,906),(17161,906),(17162,906),(17163,906),(17164,906),(17165,906),(17166,907),(17167,907),(17168,907),(17169,907),(17170,907),(17171,907),(17172,908),(17173,908),(17174,908),(17175,908),(17176,908),(17177,908),(17178,909),(17179,909),(17180,909),(17181,909),(17182,909),(17183,909),(17184,910),(17185,910),(17186,910),(17187,910),(17188,910),(17189,910),(17190,911),(17191,911),(17192,911),(17193,911),(17194,911),(17195,911),(17196,912),(17197,912),(17198,912),(17199,912),(17200,912),(17201,912),(17202,913),(17203,913),(17204,913),(17205,913),(17206,913),(17207,913),(17208,914),(17209,914),(17210,914),(17211,914),(17212,914),(17213,914),(17214,915),(17215,915),(17216,915),(17217,915),(17218,915),(17219,915),(17220,916),(17221,916),(17222,916),(17223,916),(17224,916),(17225,916),(17226,917),(17227,917),(17228,917),(17229,917),(17230,917),(17231,917),(17232,918),(17233,918),(17234,918),(17235,918),(17236,918),(17237,918),(17238,919),(17239,919),(17240,919),(17241,919),(17242,919),(17243,919),(17244,920),(17245,920),(17246,920),(17247,920),(17248,920),(17249,920),(17250,921),(17251,921),(17252,921),(17253,921),(17254,921),(17255,921),(17256,922),(17257,922),(17258,922),(17259,922),(17260,922),(17261,922),(17262,923),(17263,923),(17264,923),(17265,923),(17266,923),(17267,923),(17268,924),(17269,924),(17270,924),(17271,924),(17272,924),(17273,924),(17274,925),(17275,925),(17276,925),(17277,925),(17278,925),(17279,925),(17280,926),(17281,926),(17282,926),(17283,926),(17284,926),(17285,926),(17286,927),(17287,927),(17288,927),(17289,927),(17290,927),(17291,927),(17292,928),(17293,928),(17294,928),(17295,928),(17296,928),(17297,928),(17298,929),(17299,929),(17300,929),(17301,929),(17302,929),(17303,929),(17304,930),(17305,930),(17306,930),(17307,930),(17308,930),(17309,930),(17310,931),(17311,931),(17312,931),(17313,931),(17314,931),(17315,931),(17316,932),(17317,932),(17318,932),(17319,932),(17320,932),(17321,932),(17322,933),(17323,933),(17324,933),(17325,933),(17326,933),(17327,933),(17328,934),(17329,934),(17330,934),(17331,934),(17332,934),(17333,934),(17334,935),(17335,935),(17336,935),(17337,935),(17338,935),(17339,935),(17340,936),(17341,936),(17342,936),(17343,936),(17344,936),(17345,936),(17346,937),(17347,937),(17348,937),(17349,937),(17350,937),(17351,937),(17352,938),(17353,938),(17354,938),(17355,938),(17356,938),(17357,938),(17358,939),(17359,939),(17360,939),(17361,939),(17362,939),(17363,939),(17364,940),(17365,940),(17366,940),(17367,940),(17368,940),(17369,940),(17370,941),(17371,941),(17372,941),(17373,941),(17374,941),(17375,941),(17376,942),(17377,942),(17378,942),(17379,942),(17380,942),(17381,942),(17382,943),(17383,943),(17384,943),(17385,943),(17386,943),(17387,943),(17388,944),(17389,944),(17390,944),(17391,944),(17392,944),(17393,944),(17394,945),(17395,945),(17396,945),(17397,945),(17398,945),(17399,945),(17400,946),(17401,946),(17402,946),(17403,946),(17404,946),(17405,946),(17406,947),(17407,947),(17408,947),(17409,947),(17410,947),(17411,947),(17412,948),(17413,948),(17414,948),(17415,948),(17416,948),(17417,948),(17418,949),(17419,949),(17420,949),(17421,949),(17422,949),(17423,949),(17424,950),(17425,950),(17426,950),(17427,950),(17428,950),(17429,950),(17430,951),(17431,951),(17432,951),(17433,951),(17434,951),(17435,951),(17436,952),(17437,952),(17438,952),(17439,952),(17440,952),(17441,952),(17442,953),(17443,953),(17444,953),(17445,953),(17446,953),(17447,953),(17448,954),(17449,954),(17450,954),(17451,954),(17452,954),(17453,954),(17454,955),(17455,955),(17456,955),(17457,955),(17458,955),(17459,955),(17460,956),(17461,956),(17462,956),(17463,956),(17464,956),(17465,956),(17466,957),(17467,957),(17468,957),(17469,957),(17470,957),(17471,957),(17472,958),(17473,958),(17474,958),(17475,958),(17476,958),(17477,958),(17478,959),(17479,959),(17480,959),(17481,959),(17482,959),(17483,959),(17484,960),(17485,960),(17486,960),(17487,960),(17488,960),(17489,960),(17490,961),(17491,961),(17492,961),(17493,961),(17494,961),(17495,961),(17496,962),(17497,962),(17498,962),(17499,962),(17500,962),(17501,962),(17502,963),(17503,963),(17504,963),(17505,963),(17506,963),(17507,963),(17508,964),(17509,964),(17510,964),(17511,964),(17512,964),(17513,964),(17514,965),(17515,965),(17516,965),(17517,965),(17518,965),(17519,965),(17520,966),(17521,966),(17522,966),(17523,966),(17524,966),(17525,966),(17526,967),(17527,967),(17528,967),(17529,967),(17530,967),(17531,967),(17532,968),(17533,968),(17534,968),(17535,968),(17536,968),(17537,968),(17538,969),(17539,969),(17540,969),(17541,969),(17542,969),(17543,969),(17544,970),(17545,970),(17546,970),(17547,970),(17548,970),(17549,970),(17550,971),(17551,971),(17552,971),(17553,971),(17554,971),(17555,971),(17556,972),(17557,972),(17558,972),(17559,972),(17560,972),(17561,972),(17562,973),(17563,973),(17564,973),(17565,973),(17566,973),(17567,973),(17568,974),(17569,974),(17570,974),(17571,974),(17572,974),(17573,974),(17574,975),(17575,975),(17576,975),(17577,975),(17578,975),(17579,975),(17580,976),(17581,976),(17582,976),(17583,976),(17584,976),(17585,976),(17586,977),(17587,977),(17588,977),(17589,977),(17590,977),(17591,977),(17592,978),(17593,978),(17594,978),(17595,978),(17596,978),(17597,978),(17598,979),(17599,979),(17600,979),(17601,979),(17602,979),(17603,979),(17604,980),(17605,980),(17606,980),(17607,980),(17608,980),(17609,980),(17610,881),(17611,881),(17612,881),(17613,882),(17614,882),(17615,883),(17616,883),(17617,884),(17618,884),(17619,885),(17620,885),(17621,886),(17622,886),(17623,887),(17624,887),(17625,888),(17626,888),(17627,889),(17628,889),(17629,890),(17630,890),(17631,891),(17632,891),(17633,892),(17634,892),(17635,893),(17636,893),(17637,894),(17638,894),(17639,895),(17640,895),(17641,896),(17642,896),(17643,897),(17644,897),(17645,898),(17646,898),(17647,899),(17648,899),(17649,900),(17650,900),(17651,901),(17652,901),(17653,902),(17654,902),(17655,903),(17656,903),(17657,904),(17658,904),(17659,905),(17660,905),(17661,906),(17662,906),(17663,906),(17664,907),(17665,907),(17666,907),(17667,908),(17668,908),(17669,909),(17670,909),(17671,910),(17672,910),(17673,911),(17674,911),(17675,912),(17676,912),(17677,913),(17678,913),(17679,914),(17680,914),(17681,915),(17682,915),(17683,916),(17684,916),(17685,917),(17686,917),(17687,918),(17688,918),(17689,919),(17690,919),(17691,920),(17692,920),(17693,921),(17694,921),(17695,922),(17696,922),(17697,923),(17698,923),(17699,924),(17700,924),(17701,925),(17702,925),(17703,926),(17704,926),(17705,927),(17706,927),(17707,928),(17708,928),(17709,929),(17710,929),(17711,930),(17712,930),(17713,931),(17714,931),(17715,932),(17716,932),(17717,933),(17718,933),(17719,934),(17720,934),(17721,935),(17722,935),(17723,936),(17724,936),(17725,937),(17726,937),(17727,938),(17728,938),(17729,939),(17730,939),(17731,940),(17732,940),(17733,941),(17734,941),(17735,942),(17736,942),(17737,943),(17738,943),(17739,944),(17740,944),(17741,945),(17742,945),(17743,946),(17744,946),(17745,947),(17746,947),(17747,948),(17748,948),(17749,949),(17750,949),(17751,950),(17752,950),(17753,951),(17754,951),(17755,952),(17756,952),(17757,953),(17758,953),(17759,954),(17760,954),(17761,955),(17762,955),(17763,956),(17764,956),(17765,957),(17766,957),(17767,958),(17768,958),(17769,959),(17770,959),(17771,960),(17772,960),(17773,961),(17774,961),(17775,962),(17776,962),(17777,963),(17778,963),(17779,964),(17780,964),(17781,965),(17782,965),(17783,966),(17784,966),(17785,967),(17786,967),(17787,968),(17788,968),(17789,969),(17790,969),(17791,970),(17792,970),(17793,971),(17794,971),(17795,972),(17796,972),(17797,973),(17798,973),(17799,974),(17800,974),(17801,975),(17802,975),(17803,976),(17804,976),(17805,977),(17806,977),(17807,978),(17808,978),(17809,979),(17810,979),(17811,980),(17812,980),(17813,881),(17814,881),(17815,882),(17816,882),(17817,882),(17818,883),(17819,884),(17820,884),(17821,884),(17822,885),(17823,885),(17824,885),(17825,886),(17826,886),(17827,886),(17828,887),(17829,887),(17830,887),(17831,888),(17832,888),(17833,888),(17834,889),(17835,889),(17836,889),(17837,890),(17838,890),(17839,890),(17840,891),(17841,891),(17842,891),(17843,892),(17844,892),(17845,892),(17846,893),(17847,893),(17848,893),(17849,894),(17850,894),(17851,894),(17852,895),(17853,895),(17854,895),(17855,896),(17856,896),(17857,896),(17858,897),(17859,897),(17860,897),(17861,898),(17862,898),(17863,898),(17864,899),(17865,899),(17866,899),(17867,900),(17868,900),(17869,900),(17870,901),(17871,901),(17872,901),(17873,902),(17874,902),(17875,902),(17876,903),(17877,903),(17878,903),(17879,904),(17880,904),(17881,904),(17882,905),(17883,905),(17884,905),(17885,906),(17886,906),(17887,906),(17888,907),(17889,907),(17890,907),(17891,908),(17892,908),(17893,908),(17894,909),(17895,909),(17896,909),(17897,910),(17898,910),(17899,910),(17900,911),(17901,911),(17902,911),(17903,912),(17904,912),(17905,912),(17906,913),(17907,913),(17908,913),(17909,914),(17910,914),(17911,914),(17912,915),(17913,915),(17914,915),(17915,916),(17916,916),(17917,916),(17918,917),(17919,917),(17920,917),(17921,918),(17922,918),(17923,918),(17924,919),(17925,919),(17926,919),(17927,920),(17928,920),(17929,920),(17930,921),(17931,921),(17932,921),(17933,922),(17934,922),(17935,922),(17936,923),(17937,923),(17938,923),(17939,924),(17940,924),(17941,924),(17942,925),(17943,925),(17944,925),(17945,926),(17946,926),(17947,926),(17948,927),(17949,927),(17950,927),(17951,928),(17952,928),(17953,928),(17954,929),(17955,929),(17956,929),(17957,930),(17958,930),(17959,930),(17960,931),(17961,931),(17962,931),(17963,932),(17964,932),(17965,932),(17966,933),(17967,933),(17968,933),(17969,934),(17970,934),(17971,934),(17972,935),(17973,935),(17974,935),(17975,936),(17976,936),(17977,936),(17978,937),(17979,937),(17980,937),(17981,938),(17982,938),(17983,938),(17984,939),(17985,939),(17986,939),(17987,940),(17988,940),(17989,940),(17990,941),(17991,941),(17992,941),(17993,942),(17994,942),(17995,942),(17996,943),(17997,943),(17998,943),(17999,944),(18000,944),(18001,944),(18002,945),(18003,945),(18004,945),(18005,946),(18006,946),(18007,946),(18008,947),(18009,947),(18010,947),(18011,948),(18012,948),(18013,948),(18014,949),(18015,949),(18016,949),(18017,950),(18018,950),(18019,950),(18020,951),(18021,951),(18022,951),(18023,952),(18024,952),(18025,952),(18026,953),(18027,953),(18028,953),(18029,954),(18030,954),(18031,954),(18032,955),(18033,955),(18034,955),(18035,956),(18036,956),(18037,956),(18038,957),(18039,957),(18040,957),(18041,958),(18042,958),(18043,958),(18044,959),(18045,959),(18046,959),(18047,960),(18048,960),(18049,960),(18050,961),(18051,961),(18052,961),(18053,962),(18054,962),(18055,962),(18056,963),(18057,963),(18058,963),(18059,964),(18060,964),(18061,964),(18062,965),(18063,965),(18064,965),(18065,966),(18066,966),(18067,966),(18068,967),(18069,967),(18070,967),(18071,968),(18072,968),(18073,968),(18074,969),(18075,969),(18076,969),(18077,970),(18078,970),(18079,970),(18080,971),(18081,971),(18082,971),(18083,972),(18084,972),(18085,972),(18086,973),(18087,973),(18088,973),(18089,974),(18090,974),(18091,974),(18092,975),(18093,975),(18094,975),(18095,976),(18096,976),(18097,976),(18098,977),(18099,977),(18100,977),(18101,978),(18102,978),(18103,978),(18104,979),(18105,979),(18106,979),(18107,980),(18108,980),(18109,980),(18110,881),(18111,881),(18112,881),(18113,881),(18114,882),(18115,882),(18116,882),(18117,882),(18118,883),(18119,883),(18120,883),(18121,883),(18122,884),(18123,884),(18124,884),(18125,884),(18126,885),(18127,885),(18128,885),(18129,885),(18130,886),(18131,886),(18132,886),(18133,886),(18134,887),(18135,887),(18136,887),(18137,887),(18138,888),(18139,888),(18140,888),(18141,888),(18142,889),(18143,889),(18144,889),(18145,889),(18146,890),(18147,890),(18148,890),(18149,890),(18150,891),(18151,891),(18152,891),(18153,891),(18154,892),(18155,892),(18156,892),(18157,892),(18158,893),(18159,893),(18160,893),(18161,893),(18162,894),(18163,894),(18164,894),(18165,894),(18166,895),(18167,895),(18168,895),(18169,895),(18170,896),(18171,896),(18172,896),(18173,896),(18174,897),(18175,897),(18176,897),(18177,897),(18178,898),(18179,898),(18180,898),(18181,898),(18182,899),(18183,899),(18184,899),(18185,899),(18186,900),(18187,900),(18188,900),(18189,900),(18190,901),(18191,901),(18192,901),(18193,901),(18194,902),(18195,902),(18196,902),(18197,902),(18198,903),(18199,903),(18200,903),(18201,903),(18202,904),(18203,904),(18204,904),(18205,904),(18206,905),(18207,905),(18208,905),(18209,905),(18210,906),(18211,906),(18212,906),(18213,906),(18214,907),(18215,907),(18216,907),(18217,907),(18218,908),(18219,908),(18220,908),(18221,908),(18222,909),(18223,909),(18224,909),(18225,909),(18226,910),(18227,910),(18228,910),(18229,910),(18230,911),(18231,911),(18232,911),(18233,911),(18234,912),(18235,912),(18236,912),(18237,912),(18238,913),(18239,913),(18240,913),(18241,913),(18242,914),(18243,914),(18244,914),(18245,914),(18246,915),(18247,915),(18248,915),(18249,915),(18250,916),(18251,916),(18252,916),(18253,916),(18254,917),(18255,917),(18256,917),(18257,917),(18258,918),(18259,918),(18260,918),(18261,918),(18262,919),(18263,919),(18264,919),(18265,919),(18266,920),(18267,920),(18268,920),(18269,920),(18270,921),(18271,921),(18272,921),(18273,921),(18274,922),(18275,922),(18276,922),(18277,922),(18278,923),(18279,923),(18280,923),(18281,923),(18282,924),(18283,924),(18284,924),(18285,924),(18286,925),(18287,925),(18288,925),(18289,925),(18290,926),(18291,926),(18292,926),(18293,926),(18294,927),(18295,927),(18296,927),(18297,927),(18298,928),(18299,928),(18300,928),(18301,928),(18302,929),(18303,929),(18304,929),(18305,929),(18306,930),(18307,930),(18308,930),(18309,930),(18310,931),(18311,931),(18312,931),(18313,931),(18314,932),(18315,932),(18316,932),(18317,932),(18318,933),(18319,933),(18320,933),(18321,933),(18322,934),(18323,934),(18324,934),(18325,934),(18326,935),(18327,935),(18328,935),(18329,935),(18330,936),(18331,936),(18332,936),(18333,936),(18334,937),(18335,937),(18336,937),(18337,937),(18338,938),(18339,938),(18340,938),(18341,938),(18342,939),(18343,939),(18344,939),(18345,939),(18346,940),(18347,940),(18348,940),(18349,940),(18350,941),(18351,941),(18352,941),(18353,941),(18354,942),(18355,942),(18356,942),(18357,942),(18358,943),(18359,943),(18360,943),(18361,943),(18362,944),(18363,944),(18364,944),(18365,944),(18366,945),(18367,945),(18368,945),(18369,945),(18370,946),(18371,946),(18372,946),(18373,946),(18374,947),(18375,947),(18376,947),(18377,947),(18378,948),(18379,948),(18380,948),(18381,948),(18382,949),(18383,949),(18384,949),(18385,949),(18386,950),(18387,950),(18388,950),(18389,950),(18390,951),(18391,951),(18392,951),(18393,951),(18394,952),(18395,952),(18396,952),(18397,952),(18398,953),(18399,953),(18400,953),(18401,953),(18402,954),(18403,954),(18404,954),(18405,954),(18406,955),(18407,955),(18408,955),(18409,955),(18410,956),(18411,956),(18412,956),(18413,956),(18414,957),(18415,957),(18416,957),(18417,957),(18418,958),(18419,958),(18420,958),(18421,958),(18422,959),(18423,959),(18424,959),(18425,959),(18426,960),(18427,960),(18428,960),(18429,960),(18430,961),(18431,961),(18432,961),(18433,961),(18434,962),(18435,962),(18436,962),(18437,962),(18438,963),(18439,963),(18440,963),(18441,963),(18442,964),(18443,964),(18444,964),(18445,964),(18446,965),(18447,965),(18448,965),(18449,965),(18450,966),(18451,966),(18452,966),(18453,966),(18454,967),(18455,967),(18456,967),(18457,967),(18458,968),(18459,968),(18460,968),(18461,968),(18462,969),(18463,969),(18464,969),(18465,969),(18466,970),(18467,970),(18468,970),(18469,970),(18470,971),(18471,971),(18472,971),(18473,971),(18474,972),(18475,972),(18476,972),(18477,972),(18478,973),(18479,973),(18480,973),(18481,973),(18482,974),(18483,974),(18484,974),(18485,974),(18486,975),(18487,975),(18488,975),(18489,975),(18490,976),(18491,976),(18492,976),(18493,976),(18494,977),(18495,977),(18496,977),(18497,977),(18498,978),(18499,978),(18500,978),(18501,978),(18502,979),(18503,979),(18504,979),(18505,979),(18506,980),(18507,980),(18508,980),(18509,980),(18510,981),(18511,982),(18512,983),(18513,984),(18514,985),(18515,986),(18516,987),(18517,988),(18518,989),(18519,990),(18520,991),(18521,992),(18522,993),(18523,994),(18524,995),(18525,996),(18526,997),(18527,998),(18528,999),(18529,1000),(18530,1001),(18531,1002),(18532,1003),(18533,1004),(18534,1005),(18535,1006),(18536,1007),(18537,1008),(18538,1009),(18539,1010),(18540,1011),(18541,1012),(18542,1013),(18543,1014),(18544,1015),(18545,1016),(18546,1017),(18547,1018),(18548,1019),(18549,1020),(18550,1021),(18551,1022),(18552,1023),(18553,1024),(18554,1025),(18555,1026),(18556,1027),(18557,1028),(18558,1029),(18559,1030),(18560,1031),(18561,1032),(18562,1033),(18563,1034),(18564,1035),(18565,1036),(18566,1037),(18567,1038),(18568,1039),(18569,1040),(18570,1041),(18571,1042),(18572,1043),(18573,1044),(18574,1045),(18575,1046),(18576,1047),(18577,1048),(18578,1049),(18579,1050),(18580,1051),(18581,1052),(18582,1053),(18583,1054),(18584,1055),(18585,1056),(18586,1057),(18587,1058),(18588,1059),(18589,1060),(18590,1061),(18591,1062),(18592,1063),(18593,1064),(18594,1065),(18595,1066),(18596,1067),(18597,1068),(18598,1069),(18599,1070),(18600,1071),(18601,1072),(18602,1073),(18603,1074),(18604,1075),(18605,1076),(18606,1077),(18607,1078),(18608,1079),(18609,1080),(18610,981),(18611,982),(18612,983),(18613,984),(18614,985),(18615,986),(18616,987),(18617,988),(18618,989),(18619,990),(18620,991),(18621,992),(18622,993),(18623,994),(18624,995),(18625,996),(18626,997),(18627,998),(18628,999),(18629,1000),(18630,1001),(18631,1002),(18632,1003),(18633,1004),(18634,1005),(18635,1006),(18636,1007),(18637,1008),(18638,1009),(18639,1010),(18640,1011),(18641,1012),(18642,1013),(18643,1014),(18644,1015),(18645,1016),(18646,1017),(18647,1018),(18648,1019),(18649,1020),(18650,1021),(18651,1022),(18652,1023),(18653,1024),(18654,1025),(18655,1026),(18656,1027),(18657,1028),(18658,1029),(18659,1030),(18660,1031),(18661,1032),(18662,1033),(18663,1034),(18664,1035),(18665,1036),(18666,1037),(18667,1038),(18668,1039),(18669,1040),(18670,1041),(18671,1042),(18672,1043),(18673,1044),(18674,1045),(18675,1046),(18676,1047),(18677,1048),(18678,1049),(18679,1050),(18680,1051),(18681,1052),(18682,1053),(18683,1054),(18684,1055),(18685,1056),(18686,1057),(18687,1058),(18688,1059),(18689,1060),(18690,1061),(18691,1062),(18692,1063),(18693,1064),(18694,1065),(18695,1066),(18696,1067),(18697,1068),(18698,1069),(18699,1070),(18700,1071),(18701,1072),(18702,1073),(18703,1074),(18704,1075),(18705,1076),(18706,1077),(18707,1078),(18708,1079),(18709,1080),(18710,981),(18711,981),(18712,982),(18713,982),(18714,983),(18715,983),(18716,984),(18717,984),(18718,985),(18719,985),(18720,986),(18721,986),(18722,987),(18723,987),(18724,988),(18725,988),(18726,989),(18727,989),(18728,990),(18729,990),(18730,991),(18731,991),(18732,992),(18733,992),(18734,993),(18735,993),(18736,994),(18737,994),(18738,995),(18739,995),(18740,996),(18741,996),(18742,997),(18743,997),(18744,998),(18745,998),(18746,999),(18747,999),(18748,1000),(18749,1000),(18750,1001),(18751,1001),(18752,1002),(18753,1002),(18754,1003),(18755,1003),(18756,1004),(18757,1004),(18758,1005),(18759,1005),(18760,1006),(18761,1006),(18762,1007),(18763,1007),(18764,1008),(18765,1008),(18766,1009),(18767,1009),(18768,1010),(18769,1010),(18770,1011),(18771,1011),(18772,1012),(18773,1012),(18774,1013),(18775,1013),(18776,1014),(18777,1014),(18778,1015),(18779,1015),(18780,1016),(18781,1016),(18782,1017),(18783,1017),(18784,1018),(18785,1018),(18786,1019),(18787,1019),(18788,1020),(18789,1020),(18790,1021),(18791,1021),(18792,1022),(18793,1022),(18794,1023),(18795,1023),(18796,1024),(18797,1024),(18798,1025),(18799,1025),(18800,1026),(18801,1026),(18802,1027),(18803,1027),(18804,1028),(18805,1028),(18806,1029),(18807,1029),(18808,1030),(18809,1030),(18810,1031),(18811,1031),(18812,1032),(18813,1032),(18814,1033),(18815,1033),(18816,1034),(18817,1034),(18818,1035),(18819,1035),(18820,1036),(18821,1036),(18822,1037),(18823,1037),(18824,1038),(18825,1038),(18826,1039),(18827,1039),(18828,1040),(18829,1040),(18830,1041),(18831,1041),(18832,1042),(18833,1042),(18834,1043),(18835,1043),(18836,1044),(18837,1044),(18838,1045),(18839,1045),(18840,1046),(18841,1046),(18842,1047),(18843,1047),(18844,1048),(18845,1048),(18846,1049),(18847,1049),(18848,1050),(18849,1050),(18850,1051),(18851,1051),(18852,1052),(18853,1052),(18854,1053),(18855,1053),(18856,1054),(18857,1054),(18858,1055),(18859,1055),(18860,1056),(18861,1056),(18862,1057),(18863,1057),(18864,1058),(18865,1058),(18866,1059),(18867,1059),(18868,1060),(18869,1060),(18870,1061),(18871,1061),(18872,1062),(18873,1062),(18874,1063),(18875,1063),(18876,1064),(18877,1064),(18878,1065),(18879,1065),(18880,1066),(18881,1066),(18882,1067),(18883,1067),(18884,1068),(18885,1068),(18886,1069),(18887,1069),(18888,1070),(18889,1070),(18890,1071),(18891,1071),(18892,1072),(18893,1072),(18894,1073),(18895,1073),(18896,1074),(18897,1074),(18898,1075),(18899,1075),(18900,1076),(18901,1076),(18902,1077),(18903,1077),(18904,1078),(18905,1078),(18906,1079),(18907,1079),(18908,1080),(18909,1080),(18910,981),(18911,981),(18912,981),(18913,981),(18914,981),(18915,981),(18916,982),(18917,982),(18918,982),(18919,982),(18920,982),(18921,982),(18922,983),(18923,983),(18924,983),(18925,983),(18926,983),(18927,983),(18928,984),(18929,984),(18930,984),(18931,984),(18932,984),(18933,984),(18934,985),(18935,985),(18936,985),(18937,985),(18938,985),(18939,985),(18940,986),(18941,986),(18942,986),(18943,986),(18944,986),(18945,986),(18946,987),(18947,987),(18948,987),(18949,987),(18950,987),(18951,987),(18952,988),(18953,988),(18954,988),(18955,988),(18956,988),(18957,988),(18958,989),(18959,989),(18960,989),(18961,989),(18962,989),(18963,989),(18964,990),(18965,990),(18966,990),(18967,990),(18968,990),(18969,990),(18970,991),(18971,991),(18972,991),(18973,991),(18974,991),(18975,991),(18976,992),(18977,992),(18978,992),(18979,992),(18980,992),(18981,992),(18982,993),(18983,993),(18984,993),(18985,993),(18986,993),(18987,993),(18988,994),(18989,994),(18990,994),(18991,994),(18992,994),(18993,994),(18994,995),(18995,995),(18996,995),(18997,995),(18998,995),(18999,995),(19000,996),(19001,996),(19002,996),(19003,996),(19004,996),(19005,996),(19006,997),(19007,997),(19008,997),(19009,997),(19010,997),(19011,997),(19012,998),(19013,998),(19014,998),(19015,998),(19016,998),(19017,998),(19018,999),(19019,999),(19020,999),(19021,999),(19022,999),(19023,999),(19024,1000),(19025,1000),(19026,1000),(19027,1000),(19028,1000),(19029,1000),(19030,1001),(19031,1001),(19032,1001),(19033,1001),(19034,1001),(19035,1001),(19036,1002),(19037,1002),(19038,1002),(19039,1002),(19040,1002),(19041,1002),(19042,1003),(19043,1003),(19044,1003),(19045,1003),(19046,1004),(19047,1004),(19048,1004),(19049,1004),(19050,1004),(19051,1004),(19052,1005),(19053,1005),(19054,1005),(19055,1005),(19056,1006),(19057,1006),(19058,1006),(19059,1006),(19060,1006),(19061,1006),(19062,1007),(19063,1007),(19064,1007),(19065,1007),(19066,1007),(19067,1007),(19068,1008),(19069,1008),(19070,1008),(19071,1008),(19072,1008),(19073,1008),(19074,1009),(19075,1009),(19076,1009),(19077,1009),(19078,1009),(19079,1009),(19080,1010),(19081,1010),(19082,1010),(19083,1010),(19084,1010),(19085,1010),(19086,1011),(19087,1011),(19088,1011),(19089,1011),(19090,1011),(19091,1011),(19092,1012),(19093,1012),(19094,1012),(19095,1012),(19096,1012),(19097,1012),(19098,1013),(19099,1013),(19100,1013),(19101,1013),(19102,1013),(19103,1013),(19104,1014),(19105,1014),(19106,1014),(19107,1014),(19108,1014),(19109,1014),(19110,1015),(19111,1015),(19112,1015),(19113,1015),(19114,1015),(19115,1015),(19116,1016),(19117,1016),(19118,1016),(19119,1016),(19120,1016),(19121,1016),(19122,1017),(19123,1017),(19124,1017),(19125,1017),(19126,1017),(19127,1017),(19128,1018),(19129,1018),(19130,1018),(19131,1018),(19132,1018),(19133,1018),(19134,1019),(19135,1019),(19136,1019),(19137,1019),(19138,1019),(19139,1019),(19140,1020),(19141,1020),(19142,1020),(19143,1020),(19144,1020),(19145,1020),(19146,1021),(19147,1021),(19148,1021),(19149,1021),(19150,1021),(19151,1021),(19152,1022),(19153,1022),(19154,1022),(19155,1022),(19156,1022),(19157,1022),(19158,1023),(19159,1023),(19160,1023),(19161,1023),(19162,1023),(19163,1023),(19164,1024),(19165,1024),(19166,1024),(19167,1024),(19168,1024),(19169,1024),(19170,1025),(19171,1025),(19172,1025),(19173,1025),(19174,1025),(19175,1025),(19176,1026),(19177,1026),(19178,1026),(19179,1026),(19180,1026),(19181,1026),(19182,1027),(19183,1027),(19184,1027),(19185,1027),(19186,1027),(19187,1027),(19188,1028),(19189,1028),(19190,1028),(19191,1028),(19192,1028),(19193,1028),(19194,1029),(19195,1029),(19196,1029),(19197,1029),(19198,1029),(19199,1029),(19200,1030),(19201,1030),(19202,1030),(19203,1030),(19204,1030),(19205,1030),(19206,1031),(19207,1031),(19208,1031),(19209,1031),(19210,1031),(19211,1031),(19212,1032),(19213,1032),(19214,1032),(19215,1032),(19216,1032),(19217,1032),(19218,1033),(19219,1033),(19220,1033),(19221,1033),(19222,1033),(19223,1033),(19224,1034),(19225,1034),(19226,1034),(19227,1034),(19228,1034),(19229,1034),(19230,1035),(19231,1035),(19232,1035),(19233,1035),(19234,1036),(19235,1036),(19236,1036),(19237,1036),(19238,1036),(19239,1036),(19240,1037),(19241,1037),(19242,1037),(19243,1037),(19244,1037),(19245,1037),(19246,1038),(19247,1038),(19248,1038),(19249,1038),(19250,1038),(19251,1038),(19252,1039),(19253,1039),(19254,1039),(19255,1039),(19256,1039),(19257,1039),(19258,1040),(19259,1040),(19260,1040),(19261,1040),(19262,1040),(19263,1040),(19264,1041),(19265,1041),(19266,1041),(19267,1041),(19268,1041),(19269,1041),(19270,1042),(19271,1042),(19272,1042),(19273,1042),(19274,1042),(19275,1042),(19276,1043),(19277,1043),(19278,1043),(19279,1043),(19280,1043),(19281,1043),(19282,1044),(19283,1044),(19284,1044),(19285,1044),(19286,1044),(19287,1044),(19288,1045),(19289,1045),(19290,1045),(19291,1045),(19292,1045),(19293,1045),(19294,1046),(19295,1046),(19296,1046),(19297,1046),(19298,1046),(19299,1046),(19300,1047),(19301,1047),(19302,1047),(19303,1047),(19304,1047),(19305,1047),(19306,1048),(19307,1048),(19308,1048),(19309,1048),(19310,1048),(19311,1048),(19312,1049),(19313,1049),(19314,1049),(19315,1049),(19316,1049),(19317,1049),(19318,1050),(19319,1050),(19320,1050),(19321,1050),(19322,1050),(19323,1050),(19324,1051),(19325,1051),(19326,1051),(19327,1051),(19328,1051),(19329,1051),(19330,1052),(19331,1052),(19332,1052),(19333,1052),(19334,1052),(19335,1052),(19336,1053),(19337,1053),(19338,1053),(19339,1053),(19340,1053),(19341,1053),(19342,1054),(19343,1054),(19344,1054),(19345,1054),(19346,1054),(19347,1054),(19348,1055),(19349,1055),(19350,1055),(19351,1055),(19352,1055),(19353,1055),(19354,1056),(19355,1056),(19356,1056),(19357,1056),(19358,1056),(19359,1056),(19360,1057),(19361,1057),(19362,1057),(19363,1057),(19364,1057),(19365,1057),(19366,1058),(19367,1058),(19368,1058),(19369,1058),(19370,1058),(19371,1058),(19372,1059),(19373,1059),(19374,1059),(19375,1059),(19376,1059),(19377,1059),(19378,1060),(19379,1060),(19380,1060),(19381,1060),(19382,1060),(19383,1060),(19384,1061),(19385,1061),(19386,1061),(19387,1061),(19388,1061),(19389,1061),(19390,1062),(19391,1062),(19392,1062),(19393,1062),(19394,1062),(19395,1062),(19396,1063),(19397,1063),(19398,1063),(19399,1063),(19400,1063),(19401,1063),(19402,1064),(19403,1064),(19404,1064),(19405,1064),(19406,1064),(19407,1064),(19408,1065),(19409,1065),(19410,1065),(19411,1065),(19412,1065),(19413,1065),(19414,1066),(19415,1066),(19416,1066),(19417,1066),(19418,1066),(19419,1066),(19420,1067),(19421,1067),(19422,1067),(19423,1067),(19424,1067),(19425,1067),(19426,1068),(19427,1068),(19428,1068),(19429,1068),(19430,1068),(19431,1068),(19432,1069),(19433,1069),(19434,1069),(19435,1069),(19436,1069),(19437,1069),(19438,1070),(19439,1070),(19440,1070),(19441,1070),(19442,1070),(19443,1070),(19444,1071),(19445,1071),(19446,1071),(19447,1071),(19448,1071),(19449,1071),(19450,1072),(19451,1072),(19452,1072),(19453,1072),(19454,1072),(19455,1072),(19456,1073),(19457,1073),(19458,1073),(19459,1073),(19460,1073),(19461,1073),(19462,1074),(19463,1074),(19464,1074),(19465,1074),(19466,1074),(19467,1074),(19468,1075),(19469,1075),(19470,1075),(19471,1075),(19472,1075),(19473,1075),(19474,1076),(19475,1076),(19476,1076),(19477,1076),(19478,1076),(19479,1076),(19480,1077),(19481,1077),(19482,1077),(19483,1077),(19484,1077),(19485,1077),(19486,1078),(19487,1078),(19488,1078),(19489,1078),(19490,1078),(19491,1078),(19492,1079),(19493,1079),(19494,1079),(19495,1079),(19496,1079),(19497,1079),(19498,1080),(19499,1080),(19500,1080),(19501,1080),(19502,1080),(19503,1080),(19504,981),(19505,981),(19506,982),(19507,982),(19508,983),(19509,983),(19510,984),(19511,984),(19512,985),(19513,985),(19514,986),(19515,986),(19516,987),(19517,987),(19518,988),(19519,988),(19520,989),(19521,989),(19522,990),(19523,990),(19524,991),(19525,991),(19526,992),(19527,992),(19528,993),(19529,993),(19530,994),(19531,994),(19532,995),(19533,995),(19534,996),(19535,996),(19536,997),(19537,997),(19538,998),(19539,998),(19540,999),(19541,999),(19542,1000),(19543,1000),(19544,1001),(19545,1001),(19546,1002),(19547,1002),(19548,1003),(19549,1004),(19550,1004),(19551,1004),(19552,1005),(19553,1006),(19554,1006),(19555,1007),(19556,1007),(19557,1008),(19558,1008),(19559,1009),(19560,1009),(19561,1010),(19562,1010),(19563,1011),(19564,1011),(19565,1012),(19566,1012),(19567,1012),(19568,1013),(19569,1013),(19570,1014),(19571,1014),(19572,1015),(19573,1015),(19574,1016),(19575,1016),(19576,1017),(19577,1017),(19578,1018),(19579,1018),(19580,1019),(19581,1019),(19582,1019),(19583,1020),(19584,1020),(19585,1021),(19586,1021),(19587,1022),(19588,1022),(19589,1023),(19590,1023),(19591,1024),(19592,1024),(19593,1025),(19594,1025),(19595,1026),(19596,1026),(19597,1027),(19598,1027),(19599,1028),(19600,1028),(19601,1029),(19602,1029),(19603,1030),(19604,1030),(19605,1031),(19606,1031),(19607,1032),(19608,1032),(19609,1033),(19610,1033),(19611,1034),(19612,1034),(19613,1035),(19614,1036),(19615,1036),(19616,1037),(19617,1037),(19618,1038),(19619,1038),(19620,1039),(19621,1039),(19622,1039),(19623,1040),(19624,1040),(19625,1041),(19626,1041),(19627,1042),(19628,1042),(19629,1043),(19630,1043),(19631,1044),(19632,1044),(19633,1045),(19634,1045),(19635,1046),(19636,1046),(19637,1047),(19638,1047),(19639,1048),(19640,1048),(19641,1049),(19642,1049),(19643,1049),(19644,1050),(19645,1050),(19646,1050),(19647,1051),(19648,1051),(19649,1051),(19650,1052),(19651,1052),(19652,1052),(19653,1053),(19654,1053),(19655,1053),(19656,1054),(19657,1054),(19658,1054),(19659,1055),(19660,1055),(19661,1055),(19662,1056),(19663,1056),(19664,1056),(19665,1057),(19666,1057),(19667,1057),(19668,1058),(19669,1058),(19670,1058),(19671,1059),(19672,1059),(19673,1059),(19674,1060),(19675,1060),(19676,1060),(19677,1061),(19678,1061),(19679,1061),(19680,1062),(19681,1062),(19682,1062),(19683,1063),(19684,1063),(19685,1063),(19686,1064),(19687,1064),(19688,1064),(19689,1065),(19690,1065),(19691,1065),(19692,1066),(19693,1066),(19694,1066),(19695,1067),(19696,1067),(19697,1067),(19698,1068),(19699,1068),(19700,1068),(19701,1069),(19702,1069),(19703,1069),(19704,1070),(19705,1070),(19706,1070),(19707,1071),(19708,1071),(19709,1071),(19710,1072),(19711,1072),(19712,1072),(19713,1073),(19714,1073),(19715,1073),(19716,1074),(19717,1074),(19718,1074),(19719,1075),(19720,1075),(19721,1075),(19722,1076),(19723,1076),(19724,1076),(19725,1077),(19726,1077),(19727,1077),(19728,1078),(19729,1078),(19730,1078),(19731,1079),(19732,1079),(19733,1079),(19734,1080),(19735,1080),(19736,1080),(19737,981),(19738,981),(19739,981),(19740,982),(19741,982),(19742,982),(19743,983),(19744,983),(19745,983),(19746,984),(19747,984),(19748,984),(19749,985),(19750,985),(19751,985),(19752,986),(19753,986),(19754,986),(19755,987),(19756,987),(19757,987),(19758,988),(19759,988),(19760,988),(19761,989),(19762,989),(19763,989),(19764,990),(19765,990),(19766,990),(19767,991),(19768,991),(19769,991),(19770,992),(19771,992),(19772,992),(19773,993),(19774,993),(19775,993),(19776,994),(19777,994),(19778,994),(19779,995),(19780,995),(19781,995),(19782,996),(19783,996),(19784,996),(19785,997),(19786,997),(19787,997),(19788,998),(19789,998),(19790,998),(19791,999),(19792,999),(19793,999),(19794,1000),(19795,1000),(19796,1000),(19797,1001),(19798,1001),(19799,1001),(19800,1002),(19801,1002),(19802,1002),(19803,1003),(19804,1003),(19805,1003),(19806,1004),(19807,1004),(19808,1004),(19809,1005),(19810,1005),(19811,1005),(19812,1006),(19813,1006),(19814,1006),(19815,1007),(19816,1007),(19817,1007),(19818,1008),(19819,1008),(19820,1008),(19821,1009),(19822,1009),(19823,1009),(19824,1010),(19825,1010),(19826,1010),(19827,1011),(19828,1011),(19829,1011),(19830,1012),(19831,1012),(19832,1012),(19833,1013),(19834,1013),(19835,1013),(19836,1014),(19837,1014),(19838,1014),(19839,1015),(19840,1015),(19841,1015),(19842,1016),(19843,1016),(19844,1016),(19845,1017),(19846,1017),(19847,1017),(19848,1018),(19849,1018),(19850,1018),(19851,1019),(19852,1019),(19853,1019),(19854,1020),(19855,1020),(19856,1020),(19857,1021),(19858,1021),(19859,1021),(19860,1022),(19861,1022),(19862,1022),(19863,1023),(19864,1023),(19865,1023),(19866,1024),(19867,1024),(19868,1024),(19869,1025),(19870,1025),(19871,1025),(19872,1026),(19873,1026),(19874,1026),(19875,1027),(19876,1027),(19877,1027),(19878,1028),(19879,1028),(19880,1028),(19881,1029),(19882,1029),(19883,1029),(19884,1030),(19885,1030),(19886,1030),(19887,1031),(19888,1031),(19889,1031),(19890,1032),(19891,1032),(19892,1032),(19893,1033),(19894,1033),(19895,1033),(19896,1034),(19897,1034),(19898,1034),(19899,1035),(19900,1035),(19901,1035),(19902,1036),(19903,1036),(19904,1036),(19905,1037),(19906,1037),(19907,1037),(19908,1038),(19909,1038),(19910,1038),(19911,1039),(19912,1039),(19913,1040),(19914,1040),(19915,1040),(19916,1041),(19917,1041),(19918,1041),(19919,1042),(19920,1042),(19921,1042),(19922,1043),(19923,1043),(19924,1043),(19925,1044),(19926,1044),(19927,1044),(19928,1045),(19929,1045),(19930,1045),(19931,1046),(19932,1046),(19933,1046),(19934,1047),(19935,1047),(19936,1047),(19937,1048),(19938,1048),(19939,1048),(19940,1049),(19941,1049),(19942,1049),(19943,1050),(19944,1050),(19945,1050),(19946,1051),(19947,1051),(19948,1051),(19949,1052),(19950,1052),(19951,1052),(19952,1053),(19953,1053),(19954,1053),(19955,1054),(19956,1054),(19957,1054),(19958,1055),(19959,1055),(19960,1055),(19961,1056),(19962,1056),(19963,1056),(19964,1057),(19965,1057),(19966,1057),(19967,1058),(19968,1058),(19969,1058),(19970,1059),(19971,1059),(19972,1059),(19973,1060),(19974,1060),(19975,1060),(19976,1061),(19977,1061),(19978,1061),(19979,1062),(19980,1062),(19981,1062),(19982,1063),(19983,1063),(19984,1063),(19985,1064),(19986,1064),(19987,1064),(19988,1065),(19989,1065),(19990,1065),(19991,1066),(19992,1066),(19993,1066),(19994,1067),(19995,1067),(19996,1067),(19997,1068),(19998,1068),(19999,1068),(20000,1069),(20001,1069),(20002,1069),(20003,1070),(20004,1070),(20005,1070),(20006,1071),(20007,1071),(20008,1071),(20009,1072),(20010,1072),(20011,1072),(20012,1073),(20013,1073),(20014,1073),(20015,1074),(20016,1074),(20017,1074),(20018,1075),(20019,1075),(20020,1075),(20021,1076),(20022,1076),(20023,1076),(20024,1077),(20025,1077),(20026,1077),(20027,1078),(20028,1078),(20029,1078),(20030,1079),(20031,1079),(20032,1079),(20033,1080),(20034,1080),(20035,1080),(20036,981),(20037,981),(20038,981),(20039,981),(20040,982),(20041,982),(20042,982),(20043,982),(20044,983),(20045,983),(20046,983),(20047,983),(20048,984),(20049,984),(20050,984),(20051,984),(20052,985),(20053,985),(20054,985),(20055,985),(20056,986),(20057,986),(20058,986),(20059,986),(20060,987),(20061,987),(20062,987),(20063,987),(20064,988),(20065,988),(20066,988),(20067,988),(20068,989),(20069,989),(20070,989),(20071,989),(20072,990),(20073,990),(20074,990),(20075,990),(20076,991),(20077,991),(20078,991),(20079,991),(20080,992),(20081,992),(20082,992),(20083,992),(20084,993),(20085,993),(20086,993),(20087,993),(20088,994),(20089,994),(20090,994),(20091,994),(20092,995),(20093,995),(20094,995),(20095,995),(20096,996),(20097,996),(20098,996),(20099,996),(20100,997),(20101,997),(20102,997),(20103,997),(20104,998),(20105,998),(20106,998),(20107,998),(20108,999),(20109,999),(20110,999),(20111,999),(20112,1000),(20113,1000),(20114,1000),(20115,1000),(20116,1001),(20117,1001),(20118,1001),(20119,1001),(20120,1002),(20121,1002),(20122,1002),(20123,1002),(20124,1003),(20125,1003),(20126,1003),(20127,1003),(20128,1004),(20129,1004),(20130,1004),(20131,1004),(20132,1005),(20133,1005),(20134,1005),(20135,1005),(20136,1006),(20137,1006),(20138,1006),(20139,1006),(20140,1007),(20141,1007),(20142,1007),(20143,1007),(20144,1008),(20145,1008),(20146,1008),(20147,1008),(20148,1009),(20149,1009),(20150,1009),(20151,1009),(20152,1010),(20153,1010),(20154,1010),(20155,1010),(20156,1011),(20157,1011),(20158,1011),(20159,1011),(20160,1012),(20161,1012),(20162,1012),(20163,1012),(20164,1013),(20165,1013),(20166,1013),(20167,1013),(20168,1014),(20169,1014),(20170,1014),(20171,1014),(20172,1015),(20173,1015),(20174,1015),(20175,1015),(20176,1016),(20177,1016),(20178,1016),(20179,1016),(20180,1017),(20181,1017),(20182,1017),(20183,1017),(20184,1018),(20185,1018),(20186,1018),(20187,1018),(20188,1019),(20189,1019),(20190,1019),(20191,1019),(20192,1020),(20193,1020),(20194,1020),(20195,1020),(20196,1021),(20197,1021),(20198,1021),(20199,1021),(20200,1022),(20201,1022),(20202,1022),(20203,1022),(20204,1023),(20205,1023),(20206,1023),(20207,1023),(20208,1024),(20209,1024),(20210,1024),(20211,1024),(20212,1025),(20213,1025),(20214,1025),(20215,1025),(20216,1026),(20217,1026),(20218,1026),(20219,1026),(20220,1027),(20221,1027),(20222,1027),(20223,1027),(20224,1028),(20225,1028),(20226,1028),(20227,1028),(20228,1029),(20229,1029),(20230,1029),(20231,1029),(20232,1030),(20233,1030),(20234,1030),(20235,1030),(20236,1031),(20237,1031),(20238,1031),(20239,1031),(20240,1032),(20241,1032),(20242,1032),(20243,1032),(20244,1033),(20245,1033),(20246,1033),(20247,1033),(20248,1034),(20249,1034),(20250,1034),(20251,1034),(20252,1035),(20253,1035),(20254,1035),(20255,1035),(20256,1036),(20257,1036),(20258,1036),(20259,1036),(20260,1037),(20261,1037),(20262,1037),(20263,1037),(20264,1038),(20265,1038),(20266,1038),(20267,1038),(20268,1039),(20269,1039),(20270,1039),(20271,1039),(20272,1040),(20273,1040),(20274,1040),(20275,1040),(20276,1041),(20277,1041),(20278,1041),(20279,1041),(20280,1042),(20281,1042),(20282,1042),(20283,1042),(20284,1043),(20285,1043),(20286,1043),(20287,1043),(20288,1044),(20289,1044),(20290,1044),(20291,1044),(20292,1045),(20293,1045),(20294,1045),(20295,1045),(20296,1046),(20297,1046),(20298,1046),(20299,1046),(20300,1047),(20301,1047),(20302,1047),(20303,1047),(20304,1048),(20305,1048),(20306,1048),(20307,1048),(20308,1049),(20309,1049),(20310,1049),(20311,1049),(20312,1050),(20313,1050),(20314,1050),(20315,1050),(20316,1051),(20317,1051),(20318,1051),(20319,1051),(20320,1052),(20321,1052),(20322,1052),(20323,1052),(20324,1053),(20325,1053),(20326,1053),(20327,1053),(20328,1054),(20329,1054),(20330,1054),(20331,1054),(20332,1055),(20333,1055),(20334,1055),(20335,1055),(20336,1056),(20337,1056),(20338,1056),(20339,1056),(20340,1057),(20341,1057),(20342,1057),(20343,1057),(20344,1058),(20345,1058),(20346,1058),(20347,1058),(20348,1059),(20349,1059),(20350,1059),(20351,1059),(20352,1060),(20353,1060),(20354,1060),(20355,1060),(20356,1061),(20357,1061),(20358,1061),(20359,1061),(20360,1062),(20361,1062),(20362,1062),(20363,1062),(20364,1063),(20365,1063),(20366,1063),(20367,1063),(20368,1064),(20369,1064),(20370,1064),(20371,1064),(20372,1065),(20373,1065),(20374,1065),(20375,1065),(20376,1066),(20377,1066),(20378,1066),(20379,1066),(20380,1067),(20381,1067),(20382,1067),(20383,1067),(20384,1068),(20385,1068),(20386,1068),(20387,1068),(20388,1069),(20389,1069),(20390,1069),(20391,1069),(20392,1070),(20393,1070),(20394,1070),(20395,1070),(20396,1071),(20397,1071),(20398,1071),(20399,1071),(20400,1072),(20401,1072),(20402,1072),(20403,1072),(20404,1073),(20405,1073),(20406,1073),(20407,1073),(20408,1074),(20409,1074),(20410,1074),(20411,1074),(20412,1075),(20413,1075),(20414,1075),(20415,1075),(20416,1076),(20417,1076),(20418,1076),(20419,1076),(20420,1077),(20421,1077),(20422,1077),(20423,1077),(20424,1078),(20425,1078),(20426,1078),(20427,1078),(20428,1079),(20429,1079),(20430,1079),(20431,1079),(20432,1080),(20433,1080),(20434,1080),(20435,1080),(20436,1081),(20437,1082),(20438,1083),(20439,1084),(20440,1085),(20441,1086),(20442,1087),(20443,1088),(20444,1089),(20445,1090),(20446,1091),(20447,1092),(20448,1093),(20449,1094),(20450,1095),(20451,1096),(20452,1097),(20453,1098),(20454,1099),(20455,1100),(20456,1101),(20457,1102),(20458,1103),(20459,1104),(20460,1105),(20461,1106),(20462,1107),(20463,1108),(20464,1109),(20465,1110),(20466,1111),(20467,1112),(20468,1113),(20469,1114),(20470,1115),(20471,1116),(20472,1117),(20473,1118),(20474,1119),(20475,1120),(20476,1121),(20477,1122),(20478,1123),(20479,1124),(20480,1125),(20481,1126),(20482,1127),(20483,1128),(20484,1129),(20485,1130),(20486,1131),(20487,1132),(20488,1133),(20489,1134),(20490,1135),(20491,1136),(20492,1137),(20493,1138),(20494,1139),(20495,1081),(20496,1082),(20497,1083),(20498,1084),(20499,1085),(20500,1086),(20501,1087),(20502,1088),(20503,1089),(20504,1090),(20505,1091),(20506,1092),(20507,1093),(20508,1094),(20509,1095),(20510,1096),(20511,1097),(20512,1098),(20513,1099),(20514,1100),(20515,1101),(20516,1102),(20517,1103),(20518,1104),(20519,1105),(20520,1106),(20521,1107),(20522,1108),(20523,1109),(20524,1110),(20525,1111),(20526,1112),(20527,1113),(20528,1114),(20529,1115),(20530,1116),(20531,1117),(20532,1118),(20533,1119),(20534,1120),(20535,1121),(20536,1122),(20537,1123),(20538,1124),(20539,1125),(20540,1126),(20541,1127),(20542,1128),(20543,1129),(20544,1130),(20545,1131),(20546,1132),(20547,1133),(20548,1134),(20549,1135),(20550,1136),(20551,1137),(20552,1138),(20553,1139),(20554,1081),(20555,1081),(20556,1082),(20557,1082),(20558,1083),(20559,1083),(20560,1084),(20561,1084),(20562,1085),(20563,1085),(20564,1086),(20565,1086),(20566,1087),(20567,1087),(20568,1088),(20569,1088),(20570,1089),(20571,1089),(20572,1090),(20573,1090),(20574,1091),(20575,1091),(20576,1092),(20577,1092),(20578,1093),(20579,1093),(20580,1094),(20581,1094),(20582,1095),(20583,1095),(20584,1096),(20585,1096),(20586,1097),(20587,1097),(20588,1098),(20589,1098),(20590,1099),(20591,1099),(20592,1100),(20593,1100),(20594,1101),(20595,1101),(20596,1102),(20597,1102),(20598,1103),(20599,1103),(20600,1104),(20601,1104),(20602,1105),(20603,1105),(20604,1106),(20605,1106),(20606,1107),(20607,1107),(20608,1108),(20609,1108),(20610,1109),(20611,1109),(20612,1110),(20613,1110),(20614,1111),(20615,1111),(20616,1112),(20617,1112),(20618,1113),(20619,1113),(20620,1114),(20621,1114),(20622,1115),(20623,1115),(20624,1116),(20625,1116),(20626,1117),(20627,1117),(20628,1118),(20629,1118),(20630,1119),(20631,1119),(20632,1120),(20633,1120),(20634,1121),(20635,1121),(20636,1122),(20637,1122),(20638,1123),(20639,1123),(20640,1124),(20641,1124),(20642,1125),(20643,1125),(20644,1126),(20645,1126),(20646,1127),(20647,1127),(20648,1128),(20649,1128),(20650,1129),(20651,1129),(20652,1130),(20653,1130),(20654,1131),(20655,1131),(20656,1132),(20657,1132),(20658,1133),(20659,1133),(20660,1134),(20661,1134),(20662,1135),(20663,1135),(20664,1136),(20665,1136),(20666,1137),(20667,1137),(20668,1138),(20669,1138),(20670,1139),(20671,1139),(20672,1081),(20673,1081),(20674,1081),(20675,1081),(20676,1081),(20677,1081),(20678,1082),(20679,1082),(20680,1082),(20681,1082),(20682,1082),(20683,1082),(20684,1083),(20685,1083),(20686,1083),(20687,1083),(20688,1083),(20689,1083),(20690,1084),(20691,1084),(20692,1084),(20693,1084),(20694,1084),(20695,1084),(20696,1085),(20697,1085),(20698,1085),(20699,1085),(20700,1085),(20701,1085),(20702,1086),(20703,1086),(20704,1086),(20705,1086),(20706,1086),(20707,1086),(20708,1087),(20709,1087),(20710,1087),(20711,1087),(20712,1087),(20713,1087),(20714,1088),(20715,1088),(20716,1088),(20717,1088),(20718,1088),(20719,1088),(20720,1089),(20721,1089),(20722,1089),(20723,1089),(20724,1089),(20725,1089),(20726,1090),(20727,1090),(20728,1090),(20729,1090),(20730,1090),(20731,1090),(20732,1091),(20733,1091),(20734,1091),(20735,1091),(20736,1091),(20737,1091),(20738,1092),(20739,1092),(20740,1092),(20741,1092),(20742,1092),(20743,1092),(20744,1093),(20745,1093),(20746,1093),(20747,1093),(20748,1093),(20749,1093),(20750,1094),(20751,1094),(20752,1094),(20753,1094),(20754,1094),(20755,1094),(20756,1095),(20757,1095),(20758,1095),(20759,1095),(20760,1095),(20761,1095),(20762,1096),(20763,1096),(20764,1096),(20765,1096),(20766,1096),(20767,1096),(20768,1097),(20769,1097),(20770,1097),(20771,1097),(20772,1097),(20773,1097),(20774,1098),(20775,1098),(20776,1098),(20777,1098),(20778,1098),(20779,1098),(20780,1099),(20781,1099),(20782,1099),(20783,1099),(20784,1099),(20785,1099),(20786,1100),(20787,1100),(20788,1100),(20789,1100),(20790,1100),(20791,1100),(20792,1101),(20793,1101),(20794,1101),(20795,1101),(20796,1101),(20797,1101),(20798,1102),(20799,1102),(20800,1102),(20801,1102),(20802,1102),(20803,1102),(20804,1103),(20805,1103),(20806,1103),(20807,1103),(20808,1103),(20809,1103),(20810,1104),(20811,1104),(20812,1104),(20813,1104),(20814,1104),(20815,1104),(20816,1105),(20817,1105),(20818,1105),(20819,1105),(20820,1105),(20821,1105),(20822,1106),(20823,1106),(20824,1106),(20825,1106),(20826,1106),(20827,1106),(20828,1107),(20829,1107),(20830,1107),(20831,1107),(20832,1107),(20833,1107),(20834,1108),(20835,1108),(20836,1108),(20837,1108),(20838,1108),(20839,1108),(20840,1109),(20841,1109),(20842,1109),(20843,1109),(20844,1109),(20845,1109),(20846,1110),(20847,1110),(20848,1110),(20849,1110),(20850,1110),(20851,1110),(20852,1111),(20853,1111),(20854,1111),(20855,1111),(20856,1111),(20857,1111),(20858,1112),(20859,1112),(20860,1112),(20861,1112),(20862,1112),(20863,1112),(20864,1113),(20865,1113),(20866,1113),(20867,1113),(20868,1113),(20869,1113),(20870,1114),(20871,1114),(20872,1114),(20873,1114),(20874,1114),(20875,1114),(20876,1115),(20877,1115),(20878,1115),(20879,1115),(20880,1115),(20881,1115),(20882,1116),(20883,1116),(20884,1116),(20885,1116),(20886,1116),(20887,1116),(20888,1117),(20889,1117),(20890,1117),(20891,1117),(20892,1117),(20893,1117),(20894,1118),(20895,1118),(20896,1118),(20897,1118),(20898,1118),(20899,1118),(20900,1119),(20901,1119),(20902,1119),(20903,1119),(20904,1119),(20905,1119),(20906,1120),(20907,1120),(20908,1120),(20909,1120),(20910,1120),(20911,1120),(20912,1121),(20913,1121),(20914,1121),(20915,1121),(20916,1121),(20917,1121),(20918,1122),(20919,1122),(20920,1122),(20921,1122),(20922,1122),(20923,1122),(20924,1123),(20925,1123),(20926,1123),(20927,1123),(20928,1123),(20929,1123),(20930,1124),(20931,1124),(20932,1124),(20933,1124),(20934,1124),(20935,1124),(20936,1125),(20937,1125),(20938,1125),(20939,1125),(20940,1125),(20941,1125),(20942,1126),(20943,1126),(20944,1126),(20945,1126),(20946,1126),(20947,1126),(20948,1127),(20949,1127),(20950,1127),(20951,1127),(20952,1127),(20953,1127),(20954,1128),(20955,1128),(20956,1128),(20957,1128),(20958,1128),(20959,1128),(20960,1129),(20961,1129),(20962,1129),(20963,1129),(20964,1129),(20965,1129),(20966,1130),(20967,1130),(20968,1130),(20969,1130),(20970,1130),(20971,1130),(20972,1131),(20973,1131),(20974,1131),(20975,1131),(20976,1131),(20977,1131),(20978,1132),(20979,1132),(20980,1132),(20981,1132),(20982,1132),(20983,1132),(20984,1133),(20985,1133),(20986,1133),(20987,1133),(20988,1133),(20989,1133),(20990,1134),(20991,1134),(20992,1134),(20993,1134),(20994,1134),(20995,1134),(20996,1135),(20997,1135),(20998,1135),(20999,1135),(21000,1135),(21001,1135),(21002,1136),(21003,1136),(21004,1136),(21005,1136),(21006,1136),(21007,1136),(21008,1137),(21009,1137),(21010,1137),(21011,1137),(21012,1137),(21013,1137),(21014,1138),(21015,1138),(21016,1138),(21017,1138),(21018,1138),(21019,1138),(21020,1139),(21021,1139),(21022,1139),(21023,1139),(21024,1139),(21025,1139),(21026,1081),(21027,1081),(21028,1081),(21029,1082),(21030,1082),(21031,1082),(21032,1083),(21033,1083),(21034,1083),(21035,1084),(21036,1084),(21037,1084),(21038,1085),(21039,1085),(21040,1085),(21041,1086),(21042,1086),(21043,1086),(21044,1087),(21045,1087),(21046,1087),(21047,1088),(21048,1088),(21049,1088),(21050,1089),(21051,1089),(21052,1089),(21053,1090),(21054,1090),(21055,1090),(21056,1091),(21057,1091),(21058,1091),(21059,1092),(21060,1092),(21061,1092),(21062,1093),(21063,1093),(21064,1094),(21065,1094),(21066,1095),(21067,1095),(21068,1096),(21069,1096),(21070,1097),(21071,1097),(21072,1098),(21073,1098),(21074,1099),(21075,1099),(21076,1099),(21077,1100),(21078,1100),(21079,1101),(21080,1101),(21081,1102),(21082,1102),(21083,1103),(21084,1103),(21085,1104),(21086,1104),(21087,1105),(21088,1105),(21089,1106),(21090,1106),(21091,1107),(21092,1107),(21093,1108),(21094,1108),(21095,1109),(21096,1109),(21097,1110),(21098,1110),(21099,1111),(21100,1111),(21101,1112),(21102,1112),(21103,1113),(21104,1113),(21105,1114),(21106,1114),(21107,1115),(21108,1115),(21109,1116),(21110,1116),(21111,1117),(21112,1117),(21113,1118),(21114,1118),(21115,1119),(21116,1119),(21117,1119),(21118,1120),(21119,1120),(21120,1121),(21121,1121),(21122,1122),(21123,1122),(21124,1123),(21125,1123),(21126,1124),(21127,1124),(21128,1125),(21129,1125),(21130,1126),(21131,1126),(21132,1127),(21133,1127),(21134,1128),(21135,1128),(21136,1129),(21137,1129),(21138,1130),(21139,1130),(21140,1131),(21141,1131),(21142,1132),(21143,1132),(21144,1133),(21145,1133),(21146,1134),(21147,1134),(21148,1135),(21149,1135),(21150,1136),(21151,1136),(21152,1137),(21153,1137),(21154,1138),(21155,1138),(21156,1139),(21157,1139),(21158,1081),(21159,1081),(21160,1081),(21161,1082),(21162,1082),(21163,1082),(21164,1083),(21165,1083),(21166,1083),(21167,1084),(21168,1084),(21169,1084),(21170,1085),(21171,1085),(21172,1085),(21173,1086),(21174,1086),(21175,1086),(21176,1087),(21177,1087),(21178,1087),(21179,1088),(21180,1088),(21181,1088),(21182,1089),(21183,1089),(21184,1089),(21185,1090),(21186,1090),(21187,1090),(21188,1091),(21189,1091),(21190,1091),(21191,1092),(21192,1092),(21193,1092),(21194,1093),(21195,1093),(21196,1093),(21197,1094),(21198,1094),(21199,1094),(21200,1095),(21201,1095),(21202,1095),(21203,1096),(21204,1096),(21205,1096),(21206,1097),(21207,1097),(21208,1097),(21209,1098),(21210,1098),(21211,1098),(21212,1099),(21213,1099),(21214,1100),(21215,1100),(21216,1100),(21217,1101),(21218,1101),(21219,1101),(21220,1102),(21221,1102),(21222,1102),(21223,1103),(21224,1103),(21225,1103),(21226,1104),(21227,1104),(21228,1104),(21229,1105),(21230,1105),(21231,1105),(21232,1106),(21233,1106),(21234,1106),(21235,1107),(21236,1107),(21237,1107),(21238,1108),(21239,1108),(21240,1108),(21241,1109),(21242,1109),(21243,1109),(21244,1110),(21245,1110),(21246,1110),(21247,1111),(21248,1111),(21249,1111),(21250,1112),(21251,1112),(21252,1112),(21253,1113),(21254,1113),(21255,1113),(21256,1114),(21257,1114),(21258,1114),(21259,1115),(21260,1115),(21261,1115),(21262,1116),(21263,1116),(21264,1116),(21265,1117),(21266,1117),(21267,1117),(21268,1118),(21269,1118),(21270,1118),(21271,1119),(21272,1119),(21273,1119),(21274,1120),(21275,1120),(21276,1120),(21277,1121),(21278,1121),(21279,1121),(21280,1122),(21281,1122),(21282,1122),(21283,1123),(21284,1123),(21285,1123),(21286,1124),(21287,1124),(21288,1124),(21289,1125),(21290,1125),(21291,1125),(21292,1126),(21293,1126),(21294,1126),(21295,1127),(21296,1127),(21297,1127),(21298,1128),(21299,1128),(21300,1128),(21301,1129),(21302,1129),(21303,1129),(21304,1130),(21305,1130),(21306,1130),(21307,1131),(21308,1131),(21309,1131),(21310,1132),(21311,1132),(21312,1132),(21313,1133),(21314,1133),(21315,1133),(21316,1134),(21317,1134),(21318,1134),(21319,1135),(21320,1135),(21321,1135),(21322,1136),(21323,1136),(21324,1136),(21325,1137),(21326,1137),(21327,1137),(21328,1138),(21329,1138),(21330,1138),(21331,1139),(21332,1139),(21333,1139),(21334,1081),(21335,1081),(21336,1081),(21337,1081),(21338,1082),(21339,1082),(21340,1082),(21341,1082),(21342,1083),(21343,1083),(21344,1083),(21345,1083),(21346,1084),(21347,1084),(21348,1084),(21349,1084),(21350,1085),(21351,1085),(21352,1085),(21353,1085),(21354,1086),(21355,1086),(21356,1086),(21357,1086),(21358,1087),(21359,1087),(21360,1087),(21361,1087),(21362,1088),(21363,1088),(21364,1088),(21365,1088),(21366,1089),(21367,1089),(21368,1089),(21369,1089),(21370,1090),(21371,1090),(21372,1090),(21373,1090),(21374,1091),(21375,1091),(21376,1091),(21377,1091),(21378,1092),(21379,1092),(21380,1092),(21381,1092),(21382,1093),(21383,1093),(21384,1093),(21385,1093),(21386,1094),(21387,1094),(21388,1094),(21389,1094),(21390,1095),(21391,1095),(21392,1095),(21393,1095),(21394,1096),(21395,1096),(21396,1096),(21397,1096),(21398,1097),(21399,1097),(21400,1097),(21401,1097),(21402,1098),(21403,1098),(21404,1098),(21405,1098),(21406,1099),(21407,1099),(21408,1099),(21409,1099),(21410,1100),(21411,1100),(21412,1100),(21413,1100),(21414,1101),(21415,1101),(21416,1101),(21417,1101),(21418,1102),(21419,1102),(21420,1102),(21421,1102),(21422,1103),(21423,1103),(21424,1103),(21425,1103),(21426,1104),(21427,1104),(21428,1104),(21429,1104),(21430,1105),(21431,1105),(21432,1105),(21433,1105),(21434,1106),(21435,1106),(21436,1106),(21437,1106),(21438,1107),(21439,1107),(21440,1107),(21441,1107),(21442,1108),(21443,1108),(21444,1108),(21445,1108),(21446,1109),(21447,1109),(21448,1109),(21449,1109),(21450,1110),(21451,1110),(21452,1110),(21453,1110),(21454,1111),(21455,1111),(21456,1111),(21457,1111),(21458,1112),(21459,1112),(21460,1112),(21461,1112),(21462,1113),(21463,1113),(21464,1113),(21465,1113),(21466,1114),(21467,1114),(21468,1114),(21469,1114),(21470,1115),(21471,1115),(21472,1115),(21473,1115),(21474,1116),(21475,1116),(21476,1116),(21477,1116),(21478,1117),(21479,1117),(21480,1117),(21481,1117),(21482,1118),(21483,1118),(21484,1118),(21485,1118),(21486,1119),(21487,1119),(21488,1119),(21489,1119),(21490,1120),(21491,1120),(21492,1120),(21493,1120),(21494,1121),(21495,1121),(21496,1121),(21497,1121),(21498,1122),(21499,1122),(21500,1122),(21501,1122),(21502,1123),(21503,1123),(21504,1123),(21505,1123),(21506,1124),(21507,1124),(21508,1124),(21509,1124),(21510,1125),(21511,1125),(21512,1125),(21513,1125),(21514,1126),(21515,1126),(21516,1126),(21517,1126),(21518,1127),(21519,1127),(21520,1127),(21521,1127),(21522,1128),(21523,1128),(21524,1128),(21525,1128),(21526,1129),(21527,1129),(21528,1129),(21529,1129),(21530,1130),(21531,1130),(21532,1130),(21533,1130),(21534,1131),(21535,1131),(21536,1131),(21537,1131),(21538,1132),(21539,1132),(21540,1132),(21541,1132),(21542,1133),(21543,1133),(21544,1133),(21545,1133),(21546,1134),(21547,1134),(21548,1134),(21549,1134),(21550,1135),(21551,1135),(21552,1135),(21553,1135),(21554,1136),(21555,1136),(21556,1136),(21557,1136),(21558,1137),(21559,1137),(21560,1137),(21561,1137),(21562,1138),(21563,1138),(21564,1138),(21565,1138),(21566,1139),(21567,1139),(21568,1139),(21569,1139),(21570,1140),(21571,1141),(21572,1142),(21573,1143),(21574,1144),(21575,1145),(21576,1146),(21577,1147),(21578,1148),(21579,1149),(21580,1150),(21581,1140),(21582,1141),(21583,1142),(21584,1143),(21585,1144),(21586,1145),(21587,1146),(21588,1147),(21589,1148),(21590,1149),(21591,1150),(21592,1140),(21593,1140),(21594,1141),(21595,1141),(21596,1142),(21597,1142),(21598,1143),(21599,1143),(21600,1144),(21601,1144),(21602,1145),(21603,1145),(21604,1146),(21605,1146),(21606,1147),(21607,1147),(21608,1148),(21609,1148),(21610,1149),(21611,1149),(21612,1150),(21613,1150),(21614,1140),(21615,1140),(21616,1140),(21617,1140),(21618,1140),(21619,1140),(21620,1140),(21621,1140),(21622,1140),(21623,1141),(21624,1141),(21625,1141),(21626,1141),(21627,1141),(21628,1141),(21629,1141),(21630,1141),(21631,1141),(21632,1142),(21633,1142),(21634,1142),(21635,1142),(21636,1142),(21637,1142),(21638,1142),(21639,1142),(21640,1142),(21641,1143),(21642,1143),(21643,1143),(21644,1143),(21645,1143),(21646,1143),(21647,1143),(21648,1143),(21649,1143),(21650,1144),(21651,1144),(21652,1144),(21653,1144),(21654,1144),(21655,1144),(21656,1144),(21657,1144),(21658,1144),(21659,1145),(21660,1145),(21661,1145),(21662,1145),(21663,1145),(21664,1145),(21665,1145),(21666,1145),(21667,1145),(21668,1146),(21669,1146),(21670,1146),(21671,1146),(21672,1146),(21673,1146),(21674,1146),(21675,1147),(21676,1147),(21677,1147),(21678,1147),(21679,1147),(21680,1147),(21681,1147),(21682,1148),(21683,1148),(21684,1148),(21685,1148),(21686,1148),(21687,1148),(21688,1148),(21689,1149),(21690,1149),(21691,1149),(21692,1149),(21693,1149),(21694,1149),(21695,1149),(21696,1149),(21697,1149),(21698,1150),(21699,1150),(21700,1150),(21701,1150),(21702,1150),(21703,1150),(21704,1150),(21705,1150),(21706,1150),(21707,1140),(21708,1140),(21709,1140),(21710,1141),(21711,1141),(21712,1141),(21713,1142),(21714,1142),(21715,1142),(21716,1143),(21717,1143),(21718,1143),(21719,1144),(21720,1144),(21721,1145),(21722,1146),(21723,1147),(21724,1148),(21725,1148),(21726,1149),(21727,1149),(21728,1149),(21729,1150),(21730,1150),(21731,1150),(21732,1140),(21733,1140),(21734,1141),(21735,1141),(21736,1142),(21737,1142),(21738,1143),(21739,1143),(21740,1144),(21741,1144),(21742,1144),(21743,1145),(21744,1145),(21745,1145),(21746,1146),(21747,1146),(21748,1146),(21749,1147),(21750,1147),(21751,1147),(21752,1148),(21753,1148),(21754,1148),(21755,1149),(21756,1149),(21757,1150),(21758,1150),(21759,1140),(21760,1140),(21761,1140),(21762,1140),(21763,1141),(21764,1141),(21765,1141),(21766,1141),(21767,1142),(21768,1142),(21769,1142),(21770,1142),(21771,1143),(21772,1143),(21773,1143),(21774,1143),(21775,1144),(21776,1144),(21777,1144),(21778,1144),(21779,1145),(21780,1145),(21781,1145),(21782,1145),(21783,1146),(21784,1146),(21785,1146),(21786,1146),(21787,1147),(21788,1147),(21789,1147),(21790,1147),(21791,1148),(21792,1148),(21793,1148),(21794,1148),(21795,1149),(21796,1149),(21797,1149),(21798,1149),(21799,1150),(21800,1150),(21801,1150),(21802,1150),(21803,1151),(21804,1152),(21805,1153),(21806,1154),(21807,1155),(21808,1156),(21809,1157),(21810,1158),(21811,1159),(21812,1160),(21813,1161),(21814,1151),(21815,1152),(21816,1153),(21817,1154),(21818,1155),(21819,1156),(21820,1157),(21821,1158),(21822,1159),(21823,1160),(21824,1161),(21825,1151),(21826,1151),(21827,1151),(21828,1151),(21829,1151),(21830,1151),(21831,1152),(21832,1152),(21833,1152),(21834,1152),(21835,1152),(21836,1152),(21837,1152),(21838,1152),(21839,1152),(21840,1153),(21841,1153),(21842,1153),(21843,1153),(21844,1153),(21845,1153),(21846,1153),(21847,1153),(21848,1153),(21849,1154),(21850,1154),(21851,1154),(21852,1154),(21853,1154),(21854,1154),(21855,1154),(21856,1154),(21857,1154),(21858,1155),(21859,1155),(21860,1155),(21861,1155),(21862,1155),(21863,1155),(21864,1155),(21865,1155),(21866,1155),(21867,1156),(21868,1156),(21869,1156),(21870,1156),(21871,1156),(21872,1156),(21873,1156),(21874,1156),(21875,1156),(21876,1157),(21877,1157),(21878,1157),(21879,1157),(21880,1157),(21881,1157),(21882,1157),(21883,1157),(21884,1157),(21885,1158),(21886,1158),(21887,1158),(21888,1158),(21889,1158),(21890,1158),(21891,1158),(21892,1158),(21893,1158),(21894,1159),(21895,1159),(21896,1159),(21897,1159),(21898,1159),(21899,1159),(21900,1159),(21901,1160),(21902,1160),(21903,1160),(21904,1160),(21905,1160),(21906,1160),(21907,1160),(21908,1161),(21909,1161),(21910,1161),(21911,1161),(21912,1161),(21913,1161),(21914,1161),(21915,1151),(21916,1151),(21917,1151),(21918,1152),(21919,1152),(21920,1153),(21921,1153),(21922,1154),(21923,1154),(21924,1155),(21925,1155),(21926,1156),(21927,1156),(21928,1157),(21929,1157),(21930,1158),(21931,1158),(21932,1159),(21933,1159),(21934,1160),(21935,1160),(21936,1161),(21937,1161),(21938,1151),(21939,1151),(21940,1151),(21941,1152),(21942,1152),(21943,1152),(21944,1153),(21945,1153),(21946,1153),(21947,1154),(21948,1154),(21949,1154),(21950,1155),(21951,1155),(21952,1155),(21953,1156),(21954,1156),(21955,1156),(21956,1157),(21957,1157),(21958,1157),(21959,1158),(21960,1158),(21961,1158),(21962,1159),(21963,1159),(21964,1159),(21965,1160),(21966,1160),(21967,1160),(21968,1161),(21969,1161),(21970,1161),(21971,1151),(21972,1151),(21973,1151),(21974,1151),(21975,1152),(21976,1152),(21977,1152),(21978,1152),(21979,1153),(21980,1153),(21981,1153),(21982,1153),(21983,1154),(21984,1154),(21985,1154),(21986,1154),(21987,1155),(21988,1155),(21989,1155),(21990,1155),(21991,1156),(21992,1156),(21993,1156),(21994,1156),(21995,1157),(21996,1157),(21997,1157),(21998,1157),(21999,1158),(22000,1158),(22001,1158),(22002,1158),(22003,1159),(22004,1159),(22005,1159),(22006,1159),(22007,1160),(22008,1160),(22009,1160),(22010,1160),(22011,1161),(22012,1161),(22013,1161),(22014,1161),(22015,1142),(22016,1143),(22017,1144),(22018,1145),(22019,1146),(22020,1147),(22021,1148),(22022,1149),(22023,1150),(22024,1151),(22025,1152),(22026,1153),(22027,1154),(22028,1155),(22029,1156),(22030,1157),(22031,1158),(22032,1159),(22033,1160),(22034,1161),(22035,1162),(22036,1162),(22037,1162),(22038,1162),(22039,1162),(22040,1162),(22041,1162),(22042,1162),(22043,1162),(22044,1162),(22045,1162),(22046,1162),(22047,1162),(22048,1162),(22049,1162),(22050,1162),(22051,1162),(22052,1162),(22053,1162),(22054,1162),(22055,1162),(22056,1162),(22057,1162),(22058,1162),(22059,1162),(22060,1162),(22061,1162),(22062,1163),(22063,1163),(22064,1163),(22065,1163),(22066,1163),(22067,1163),(22068,1163),(22069,1163),(22070,1163),(22071,1163),(22072,1163),(22073,1163),(22074,1163),(22075,1163),(22076,1163),(22077,1163),(22078,1163),(22079,1163),(22080,1163),(22081,1163),(22082,1163),(22083,1163),(22084,1163),(22085,1163),(22086,1163),(22087,1163),(22088,1163),(22089,1163),(22090,1163),(22091,1163),(22092,1163),(22093,1163),(22094,1163),(22095,1163),(22096,1163),(22097,1164),(22098,1164),(22099,1164),(22100,1164),(22101,1164),(22102,1164),(22103,1164),(22104,1164),(22105,1164),(22106,1164),(22107,1164),(22108,1164),(22109,1164),(22110,1164),(22111,1164),(22112,1164),(22113,1164),(22114,1164),(22115,1164),(22116,1164),(22117,1164),(22118,1164),(22119,1164),(22120,1164),(22121,1164),(22122,1164),(22123,1164),(22124,1164),(22125,1164),(22126,1164),(22127,1164),(22128,1164),(22129,1164),(22130,1164),(22131,1164),(22132,1165),(22133,1165),(22134,1165),(22135,1165),(22136,1165),(22137,1165),(22138,1165),(22139,1165),(22140,1165),(22141,1165),(22142,1165),(22143,1165),(22144,1165),(22145,1165),(22146,1165),(22147,1165),(22148,1165),(22149,1165),(22150,1165),(22151,1165),(22152,1165),(22153,1165),(22154,1165),(22155,1165),(22156,1165),(22157,1165),(22158,1165),(22159,1165),(22160,1165),(22161,1165),(22162,1165),(22163,1165),(22164,1165),(22165,1165),(22166,1165),(22167,1154),(22168,1155),(22169,1156),(22170,1157),(22171,1142),(22172,1143),(22173,1144),(22174,1145),(22175,1146),(22176,1147),(22177,1148),(22178,1149),(22179,1150),(22180,1151),(22181,1152),(22182,1153),(22183,1158),(22184,1159),(22185,1159),(22186,1160),(22187,1161),(22188,1162),(22189,1163),(22190,1164),(22191,1165),(22192,1166),(22193,1167),(22194,1168),(22195,1169),(22196,1170),(22197,1171),(22198,1172),(22199,1173),(22200,1174),(22201,1175),(22202,1176),(22203,1166),(22204,1167),(22205,1168),(22206,1169),(22207,1170),(22208,1171),(22209,1172),(22210,1173),(22211,1174),(22212,1175),(22213,1176),(22214,1166),(22215,1166),(22216,1166),(22217,1166),(22218,1166),(22219,1166),(22220,1166),(22221,1167),(22222,1167),(22223,1167),(22224,1167),(22225,1167),(22226,1167),(22227,1167),(22228,1168),(22229,1168),(22230,1168),(22231,1168),(22232,1168),(22233,1168),(22234,1168),(22235,1169),(22236,1169),(22237,1169),(22238,1169),(22239,1169),(22240,1169),(22241,1169),(22242,1170),(22243,1170),(22244,1170),(22245,1170),(22246,1170),(22247,1170),(22248,1170),(22249,1171),(22250,1171),(22251,1171),(22252,1171),(22253,1171),(22254,1171),(22255,1171),(22256,1172),(22257,1172),(22258,1172),(22259,1172),(22260,1172),(22261,1172),(22262,1172),(22263,1173),(22264,1173),(22265,1173),(22266,1173),(22267,1173),(22268,1173),(22269,1173),(22270,1174),(22271,1174),(22272,1174),(22273,1174),(22274,1174),(22275,1174),(22276,1174),(22277,1175),(22278,1175),(22279,1175),(22280,1175),(22281,1175),(22282,1175),(22283,1175),(22284,1176),(22285,1176),(22286,1176),(22287,1176),(22288,1176),(22289,1176),(22290,1176),(22291,1166),(22292,1166),(22293,1167),(22294,1167),(22295,1168),(22296,1168),(22297,1169),(22298,1169),(22299,1170),(22300,1170),(22301,1171),(22302,1171),(22303,1172),(22304,1172),(22305,1173),(22306,1173),(22307,1174),(22308,1174),(22309,1175),(22310,1175),(22311,1176),(22312,1176),(22313,1166),(22314,1166),(22315,1166),(22316,1167),(22317,1167),(22318,1167),(22319,1168),(22320,1168),(22321,1168),(22322,1169),(22323,1169),(22324,1169),(22325,1170),(22326,1170),(22327,1170),(22328,1171),(22329,1171),(22330,1171),(22331,1172),(22332,1172),(22333,1172),(22334,1173),(22335,1173),(22336,1173),(22337,1174),(22338,1174),(22339,1174),(22340,1175),(22341,1175),(22342,1175),(22343,1176),(22344,1176),(22345,1176),(22346,1166),(22347,1166),(22348,1166),(22349,1166),(22350,1167),(22351,1167),(22352,1167),(22353,1167),(22354,1168),(22355,1168),(22356,1168),(22357,1168),(22358,1169),(22359,1169),(22360,1169),(22361,1169),(22362,1170),(22363,1170),(22364,1170),(22365,1170),(22366,1171),(22367,1171),(22368,1171),(22369,1171),(22370,1172),(22371,1172),(22372,1172),(22373,1172),(22374,1173),(22375,1173),(22376,1173),(22377,1173),(22378,1174),(22379,1174),(22380,1174),(22381,1174),(22382,1175),(22383,1175),(22384,1175),(22385,1175),(22386,1176),(22387,1176),(22388,1176),(22389,1176),(22390,1177),(22391,1178),(22392,1179),(22393,1180),(22394,1181),(22395,1182),(22396,1183),(22397,1184),(22398,1185),(22399,1186),(22400,1187),(22401,1188),(22402,1189),(22403,1190),(22404,1191),(22405,1192),(22406,1193),(22407,1194),(22408,1195),(22409,1196),(22410,1197),(22411,1198),(22412,1199),(22413,1200),(22414,1201),(22415,1202),(22416,1203),(22417,1204),(22418,1205),(22419,1206),(22420,1207),(22421,1208),(22422,1209),(22423,1210),(22424,1211),(22425,1212),(22426,1213),(22427,1214),(22428,1215),(22429,1216),(22430,1217),(22431,1218),(22432,1219),(22433,1220),(22434,1221),(22435,1222),(22436,1223),(22437,1224),(22438,1225),(22439,1226),(22440,1227),(22441,1228),(22442,1229),(22443,1230),(22444,1231),(22445,1232),(22446,1233),(22447,1234),(22448,1235),(22449,1236),(22450,1237),(22451,1238),(22452,1239),(22453,1240),(22454,1241),(22455,1242),(22456,1243),(22457,1244),(22458,1245),(22459,1246),(22460,1247),(22461,1248),(22462,1249),(22463,1250),(22464,1251),(22465,1252),(22466,1253),(22467,1254),(22468,1255),(22469,1256),(22470,1257),(22471,1258),(22472,1259),(22473,1260),(22474,1261),(22475,1262),(22476,1263),(22477,1264),(22478,1265),(22479,1177),(22480,1178),(22481,1179),(22482,1180),(22483,1181),(22484,1182),(22485,1183),(22486,1184),(22487,1185),(22488,1186),(22489,1187),(22490,1188),(22491,1189),(22492,1190),(22493,1191),(22494,1192),(22495,1193),(22496,1194),(22497,1195),(22498,1196),(22499,1197),(22500,1198),(22501,1199),(22502,1200),(22503,1201),(22504,1202),(22505,1203),(22506,1204),(22507,1205),(22508,1206),(22509,1207),(22510,1208),(22511,1209),(22512,1210),(22513,1211),(22514,1212),(22515,1213),(22516,1214),(22517,1215),(22518,1216),(22519,1217),(22520,1218),(22521,1219),(22522,1220),(22523,1221),(22524,1222),(22525,1223),(22526,1224),(22527,1225),(22528,1226),(22529,1227),(22530,1228),(22531,1229),(22532,1230),(22533,1231),(22534,1232),(22535,1233),(22536,1234),(22537,1235),(22538,1236),(22539,1237),(22540,1238),(22541,1239),(22542,1240),(22543,1241),(22544,1242),(22545,1243),(22546,1244),(22547,1245),(22548,1246),(22549,1247),(22550,1248),(22551,1249),(22552,1250),(22553,1251),(22554,1252),(22555,1253),(22556,1254),(22557,1255),(22558,1256),(22559,1257),(22560,1258),(22561,1259),(22562,1260),(22563,1261),(22564,1262),(22565,1263),(22566,1264),(22567,1265),(22568,1177),(22569,1177),(22570,1177),(22571,1177),(22572,1177),(22573,1177),(22574,1177),(22575,1178),(22576,1178),(22577,1178),(22578,1178),(22579,1178),(22580,1178),(22581,1178),(22582,1179),(22583,1179),(22584,1179),(22585,1179),(22586,1179),(22587,1179),(22588,1179),(22589,1180),(22590,1180),(22591,1180),(22592,1180),(22593,1180),(22594,1180),(22595,1180),(22596,1181),(22597,1181),(22598,1181),(22599,1181),(22600,1181),(22601,1181),(22602,1181),(22603,1182),(22604,1182),(22605,1182),(22606,1182),(22607,1182),(22608,1182),(22609,1183),(22610,1183),(22611,1183),(22612,1183),(22613,1183),(22614,1183),(22615,1184),(22616,1184),(22617,1184),(22618,1184),(22619,1184),(22620,1184),(22621,1184),(22622,1185),(22623,1185),(22624,1185),(22625,1185),(22626,1185),(22627,1185),(22628,1185),(22629,1186),(22630,1186),(22631,1186),(22632,1186),(22633,1186),(22634,1186),(22635,1186),(22636,1187),(22637,1187),(22638,1187),(22639,1187),(22640,1187),(22641,1187),(22642,1187),(22643,1188),(22644,1188),(22645,1188),(22646,1188),(22647,1188),(22648,1188),(22649,1188),(22650,1189),(22651,1189),(22652,1189),(22653,1189),(22654,1189),(22655,1189),(22656,1189),(22657,1190),(22658,1190),(22659,1190),(22660,1190),(22661,1190),(22662,1190),(22663,1190),(22664,1191),(22665,1191),(22666,1191),(22667,1191),(22668,1191),(22669,1191),(22670,1191),(22671,1192),(22672,1192),(22673,1192),(22674,1192),(22675,1192),(22676,1192),(22677,1192),(22678,1193),(22679,1193),(22680,1193),(22681,1193),(22682,1193),(22683,1193),(22684,1193),(22685,1194),(22686,1194),(22687,1194),(22688,1194),(22689,1194),(22690,1194),(22691,1194),(22692,1195),(22693,1195),(22694,1195),(22695,1195),(22696,1195),(22697,1195),(22698,1195),(22699,1196),(22700,1196),(22701,1196),(22702,1196),(22703,1196),(22704,1196),(22705,1196),(22706,1197),(22707,1197),(22708,1197),(22709,1197),(22710,1197),(22711,1197),(22712,1197),(22713,1198),(22714,1198),(22715,1198),(22716,1198),(22717,1198),(22718,1198),(22719,1198),(22720,1199),(22721,1199),(22722,1199),(22723,1199),(22724,1199),(22725,1199),(22726,1199),(22727,1200),(22728,1200),(22729,1200),(22730,1200),(22731,1200),(22732,1200),(22733,1200),(22734,1201),(22735,1201),(22736,1201),(22737,1201),(22738,1201),(22739,1201),(22740,1201),(22741,1202),(22742,1202),(22743,1202),(22744,1202),(22745,1202),(22746,1202),(22747,1202),(22748,1203),(22749,1203),(22750,1203),(22751,1203),(22752,1203),(22753,1203),(22754,1203),(22755,1204),(22756,1204),(22757,1204),(22758,1204),(22759,1204),(22760,1204),(22761,1204),(22762,1205),(22763,1205),(22764,1205),(22765,1205),(22766,1205),(22767,1205),(22768,1205),(22769,1206),(22770,1206),(22771,1206),(22772,1206),(22773,1206),(22774,1206),(22775,1206),(22776,1207),(22777,1207),(22778,1207),(22779,1207),(22780,1207),(22781,1207),(22782,1207),(22783,1208),(22784,1208),(22785,1208),(22786,1208),(22787,1208),(22788,1208),(22789,1208),(22790,1209),(22791,1209),(22792,1209),(22793,1209),(22794,1209),(22795,1209),(22796,1209),(22797,1210),(22798,1210),(22799,1210),(22800,1210),(22801,1210),(22802,1210),(22803,1210),(22804,1210),(22805,1210),(22806,1211),(22807,1211),(22808,1211),(22809,1211),(22810,1211),(22811,1211),(22812,1211),(22813,1212),(22814,1212),(22815,1212),(22816,1212),(22817,1212),(22818,1212),(22819,1212),(22820,1213),(22821,1213),(22822,1213),(22823,1213),(22824,1213),(22825,1213),(22826,1213),(22827,1214),(22828,1214),(22829,1214),(22830,1214),(22831,1214),(22832,1214),(22833,1214),(22834,1215),(22835,1215),(22836,1215),(22837,1215),(22838,1215),(22839,1215),(22840,1215),(22841,1216),(22842,1216),(22843,1216),(22844,1216),(22845,1216),(22846,1216),(22847,1217),(22848,1217),(22849,1217),(22850,1217),(22851,1217),(22852,1217),(22853,1217),(22854,1218),(22855,1218),(22856,1218),(22857,1218),(22858,1218),(22859,1218),(22860,1218),(22861,1219),(22862,1219),(22863,1219),(22864,1219),(22865,1219),(22866,1219),(22867,1219),(22868,1220),(22869,1220),(22870,1220),(22871,1220),(22872,1220),(22873,1220),(22874,1220),(22875,1221),(22876,1221),(22877,1221),(22878,1221),(22879,1221),(22880,1221),(22881,1221),(22882,1222),(22883,1222),(22884,1222),(22885,1222),(22886,1222),(22887,1222),(22888,1222),(22889,1223),(22890,1223),(22891,1223),(22892,1223),(22893,1223),(22894,1223),(22895,1223),(22896,1224),(22897,1224),(22898,1224),(22899,1224),(22900,1224),(22901,1224),(22902,1224),(22903,1225),(22904,1225),(22905,1225),(22906,1225),(22907,1225),(22908,1225),(22909,1225),(22910,1226),(22911,1226),(22912,1226),(22913,1226),(22914,1226),(22915,1226),(22916,1226),(22917,1227),(22918,1227),(22919,1227),(22920,1227),(22921,1227),(22922,1227),(22923,1227),(22924,1228),(22925,1228),(22926,1228),(22927,1228),(22928,1228),(22929,1228),(22930,1228),(22931,1229),(22932,1229),(22933,1229),(22934,1229),(22935,1229),(22936,1229),(22937,1229),(22938,1230),(22939,1230),(22940,1230),(22941,1230),(22942,1230),(22943,1230),(22944,1230),(22945,1231),(22946,1231),(22947,1231),(22948,1231),(22949,1231),(22950,1231),(22951,1231),(22952,1232),(22953,1232),(22954,1232),(22955,1232),(22956,1232),(22957,1232),(22958,1232),(22959,1233),(22960,1233),(22961,1233),(22962,1233),(22963,1233),(22964,1233),(22965,1233),(22966,1234),(22967,1234),(22968,1234),(22969,1234),(22970,1234),(22971,1234),(22972,1234),(22973,1235),(22974,1235),(22975,1235),(22976,1235),(22977,1235),(22978,1235),(22979,1235),(22980,1236),(22981,1236),(22982,1236),(22983,1236),(22984,1236),(22985,1236),(22986,1236),(22987,1237),(22988,1237),(22989,1237),(22990,1237),(22991,1237),(22992,1237),(22993,1237),(22994,1238),(22995,1238),(22996,1238),(22997,1238),(22998,1238),(22999,1238),(23000,1238),(23001,1239),(23002,1239),(23003,1239),(23004,1239),(23005,1239),(23006,1239),(23007,1239),(23008,1240),(23009,1240),(23010,1240),(23011,1240),(23012,1240),(23013,1240),(23014,1240),(23015,1241),(23016,1241),(23017,1241),(23018,1241),(23019,1241),(23020,1241),(23021,1241),(23022,1242),(23023,1242),(23024,1242),(23025,1242),(23026,1242),(23027,1242),(23028,1242),(23029,1243),(23030,1243),(23031,1243),(23032,1243),(23033,1243),(23034,1243),(23035,1243),(23036,1244),(23037,1244),(23038,1244),(23039,1244),(23040,1244),(23041,1244),(23042,1244),(23043,1245),(23044,1245),(23045,1245),(23046,1245),(23047,1245),(23048,1245),(23049,1245),(23050,1246),(23051,1246),(23052,1246),(23053,1246),(23054,1246),(23055,1246),(23056,1246),(23057,1247),(23058,1247),(23059,1247),(23060,1247),(23061,1247),(23062,1247),(23063,1247),(23064,1248),(23065,1248),(23066,1248),(23067,1248),(23068,1248),(23069,1248),(23070,1248),(23071,1249),(23072,1249),(23073,1249),(23074,1249),(23075,1249),(23076,1249),(23077,1249),(23078,1250),(23079,1250),(23080,1250),(23081,1250),(23082,1250),(23083,1250),(23084,1250),(23085,1251),(23086,1251),(23087,1251),(23088,1251),(23089,1251),(23090,1251),(23091,1251),(23092,1252),(23093,1252),(23094,1252),(23095,1252),(23096,1252),(23097,1252),(23098,1252),(23099,1253),(23100,1253),(23101,1253),(23102,1253),(23103,1253),(23104,1253),(23105,1253),(23106,1254),(23107,1254),(23108,1254),(23109,1254),(23110,1254),(23111,1254),(23112,1254),(23113,1255),(23114,1255),(23115,1255),(23116,1255),(23117,1255),(23118,1255),(23119,1255),(23120,1256),(23121,1256),(23122,1256),(23123,1256),(23124,1256),(23125,1256),(23126,1256),(23127,1257),(23128,1257),(23129,1257),(23130,1257),(23131,1257),(23132,1257),(23133,1257),(23134,1258),(23135,1258),(23136,1258),(23137,1258),(23138,1258),(23139,1258),(23140,1258),(23141,1259),(23142,1259),(23143,1259),(23144,1259),(23145,1259),(23146,1259),(23147,1259),(23148,1260),(23149,1260),(23150,1260),(23151,1260),(23152,1260),(23153,1260),(23154,1260),(23155,1261),(23156,1261),(23157,1261),(23158,1261),(23159,1261),(23160,1261),(23161,1261),(23162,1262),(23163,1262),(23164,1262),(23165,1262),(23166,1262),(23167,1262),(23168,1262),(23169,1263),(23170,1263),(23171,1263),(23172,1263),(23173,1263),(23174,1263),(23175,1263),(23176,1264),(23177,1264),(23178,1264),(23179,1264),(23180,1264),(23181,1264),(23182,1264),(23183,1265),(23184,1265),(23185,1265),(23186,1265),(23187,1265),(23188,1265),(23189,1265),(23190,1177),(23191,1177),(23192,1178),(23193,1178),(23194,1179),(23195,1179),(23196,1180),(23197,1180),(23198,1181),(23199,1181),(23200,1182),(23201,1183),(23202,1184),(23203,1184),(23204,1185),(23205,1185),(23206,1186),(23207,1186),(23208,1187),(23209,1187),(23210,1188),(23211,1188),(23212,1189),(23213,1189),(23214,1190),(23215,1190),(23216,1191),(23217,1191),(23218,1192),(23219,1192),(23220,1193),(23221,1193),(23222,1194),(23223,1194),(23224,1195),(23225,1195),(23226,1196),(23227,1196),(23228,1197),(23229,1197),(23230,1198),(23231,1198),(23232,1199),(23233,1199),(23234,1200),(23235,1200),(23236,1201),(23237,1201),(23238,1202),(23239,1202),(23240,1203),(23241,1203),(23242,1204),(23243,1204),(23244,1205),(23245,1205),(23246,1206),(23247,1206),(23248,1207),(23249,1207),(23250,1208),(23251,1208),(23252,1209),(23253,1209),(23254,1210),(23255,1210),(23256,1211),(23257,1211),(23258,1212),(23259,1212),(23260,1213),(23261,1213),(23262,1214),(23263,1214),(23264,1215),(23265,1215),(23266,1216),(23267,1216),(23268,1217),(23269,1217),(23270,1218),(23271,1218),(23272,1219),(23273,1219),(23274,1220),(23275,1220),(23276,1221),(23277,1221),(23278,1222),(23279,1222),(23280,1223),(23281,1223),(23282,1224),(23283,1224),(23284,1225),(23285,1225),(23286,1226),(23287,1226),(23288,1227),(23289,1227),(23290,1228),(23291,1228),(23292,1229),(23293,1229),(23294,1230),(23295,1230),(23296,1231),(23297,1231),(23298,1232),(23299,1232),(23300,1233),(23301,1233),(23302,1234),(23303,1234),(23304,1235),(23305,1235),(23306,1236),(23307,1236),(23308,1237),(23309,1237),(23310,1238),(23311,1238),(23312,1239),(23313,1239),(23314,1240),(23315,1240),(23316,1241),(23317,1241),(23318,1242),(23319,1242),(23320,1243),(23321,1243),(23322,1244),(23323,1244),(23324,1245),(23325,1245),(23326,1246),(23327,1246),(23328,1247),(23329,1247),(23330,1248),(23331,1248),(23332,1249),(23333,1249),(23334,1250),(23335,1250),(23336,1251),(23337,1251),(23338,1252),(23339,1252),(23340,1253),(23341,1253),(23342,1254),(23343,1254),(23344,1255),(23345,1255),(23346,1256),(23347,1256),(23348,1257),(23349,1257),(23350,1258),(23351,1258),(23352,1259),(23353,1259),(23354,1260),(23355,1260),(23356,1261),(23357,1261),(23358,1262),(23359,1262),(23360,1263),(23361,1263),(23362,1264),(23363,1264),(23364,1265),(23365,1265),(23366,1177),(23367,1177),(23368,1177),(23369,1178),(23370,1178),(23371,1178),(23372,1179),(23373,1179),(23374,1179),(23375,1180),(23376,1180),(23377,1180),(23378,1181),(23379,1181),(23380,1181),(23381,1182),(23382,1182),(23383,1182),(23384,1183),(23385,1183),(23386,1183),(23387,1184),(23388,1184),(23389,1184),(23390,1185),(23391,1185),(23392,1185),(23393,1186),(23394,1186),(23395,1186),(23396,1187),(23397,1187),(23398,1187),(23399,1188),(23400,1188),(23401,1188),(23402,1189),(23403,1189),(23404,1189),(23405,1190),(23406,1190),(23407,1190),(23408,1191),(23409,1191),(23410,1191),(23411,1192),(23412,1192),(23413,1192),(23414,1193),(23415,1193),(23416,1193),(23417,1194),(23418,1194),(23419,1194),(23420,1195),(23421,1195),(23422,1195),(23423,1196),(23424,1196),(23425,1196),(23426,1197),(23427,1197),(23428,1197),(23429,1198),(23430,1198),(23431,1198),(23432,1199),(23433,1199),(23434,1199),(23435,1200),(23436,1200),(23437,1200),(23438,1201),(23439,1201),(23440,1201),(23441,1202),(23442,1202),(23443,1202),(23444,1203),(23445,1203),(23446,1203),(23447,1204),(23448,1204),(23449,1204),(23450,1205),(23451,1205),(23452,1205),(23453,1206),(23454,1206),(23455,1206),(23456,1207),(23457,1207),(23458,1207),(23459,1208),(23460,1208),(23461,1208),(23462,1209),(23463,1209),(23464,1209),(23465,1210),(23466,1210),(23467,1210),(23468,1211),(23469,1211),(23470,1211),(23471,1212),(23472,1212),(23473,1212),(23474,1213),(23475,1213),(23476,1213),(23477,1214),(23478,1214),(23479,1214),(23480,1215),(23481,1215),(23482,1215),(23483,1216),(23484,1216),(23485,1216),(23486,1217),(23487,1217),(23488,1217),(23489,1218),(23490,1218),(23491,1218),(23492,1219),(23493,1219),(23494,1219),(23495,1220),(23496,1220),(23497,1220),(23498,1221),(23499,1221),(23500,1221),(23501,1222),(23502,1222),(23503,1222),(23504,1223),(23505,1223),(23506,1223),(23507,1224),(23508,1224),(23509,1224),(23510,1225),(23511,1225),(23512,1225),(23513,1226),(23514,1226),(23515,1226),(23516,1227),(23517,1227),(23518,1227),(23519,1228),(23520,1228),(23521,1228),(23522,1229),(23523,1229),(23524,1229),(23525,1230),(23526,1230),(23527,1230),(23528,1231),(23529,1231),(23530,1231),(23531,1232),(23532,1232),(23533,1232),(23534,1233),(23535,1233),(23536,1233),(23537,1234),(23538,1234),(23539,1234),(23540,1235),(23541,1235),(23542,1235),(23543,1236),(23544,1236),(23545,1236),(23546,1237),(23547,1237),(23548,1237),(23549,1238),(23550,1238),(23551,1238),(23552,1239),(23553,1239),(23554,1239),(23555,1240),(23556,1240),(23557,1240),(23558,1241),(23559,1241),(23560,1241),(23561,1242),(23562,1242),(23563,1242),(23564,1243),(23565,1243),(23566,1243),(23567,1244),(23568,1244),(23569,1244),(23570,1245),(23571,1245),(23572,1245),(23573,1246),(23574,1246),(23575,1246),(23576,1247),(23577,1247),(23578,1247),(23579,1248),(23580,1248),(23581,1248),(23582,1249),(23583,1249),(23584,1249),(23585,1250),(23586,1250),(23587,1250),(23588,1251),(23589,1251),(23590,1251),(23591,1252),(23592,1252),(23593,1252),(23594,1253),(23595,1253),(23596,1253),(23597,1254),(23598,1254),(23599,1254),(23600,1255),(23601,1255),(23602,1255),(23603,1256),(23604,1256),(23605,1256),(23606,1257),(23607,1257),(23608,1257),(23609,1258),(23610,1258),(23611,1258),(23612,1259),(23613,1259),(23614,1259),(23615,1260),(23616,1260),(23617,1260),(23618,1261),(23619,1261),(23620,1261),(23621,1262),(23622,1262),(23623,1262),(23624,1263),(23625,1263),(23626,1263),(23627,1264),(23628,1264),(23629,1264),(23630,1265),(23631,1265),(23632,1265),(23633,1177),(23634,1177),(23635,1177),(23636,1177),(23637,1178),(23638,1178),(23639,1178),(23640,1178),(23641,1179),(23642,1179),(23643,1179),(23644,1179),(23645,1180),(23646,1180),(23647,1180),(23648,1180),(23649,1181),(23650,1181),(23651,1181),(23652,1181),(23653,1182),(23654,1182),(23655,1182),(23656,1182),(23657,1183),(23658,1183),(23659,1183),(23660,1183),(23661,1184),(23662,1184),(23663,1184),(23664,1184),(23665,1185),(23666,1185),(23667,1185),(23668,1185),(23669,1186),(23670,1186),(23671,1186),(23672,1186),(23673,1187),(23674,1187),(23675,1187),(23676,1187),(23677,1188),(23678,1188),(23679,1188),(23680,1188),(23681,1189),(23682,1189),(23683,1189),(23684,1189),(23685,1190),(23686,1190),(23687,1190),(23688,1190),(23689,1191),(23690,1191),(23691,1191),(23692,1191),(23693,1192),(23694,1192),(23695,1192),(23696,1192),(23697,1193),(23698,1193),(23699,1193),(23700,1193),(23701,1194),(23702,1194),(23703,1194),(23704,1194),(23705,1195),(23706,1195),(23707,1195),(23708,1195),(23709,1196),(23710,1196),(23711,1196),(23712,1196),(23713,1197),(23714,1197),(23715,1197),(23716,1197),(23717,1198),(23718,1198),(23719,1198),(23720,1198),(23721,1199),(23722,1199),(23723,1199),(23724,1199),(23725,1200),(23726,1200),(23727,1200),(23728,1200),(23729,1201),(23730,1201),(23731,1201),(23732,1201),(23733,1202),(23734,1202),(23735,1202),(23736,1202),(23737,1203),(23738,1203),(23739,1203),(23740,1203),(23741,1204),(23742,1204),(23743,1204),(23744,1204),(23745,1205),(23746,1205),(23747,1205),(23748,1205),(23749,1206),(23750,1206),(23751,1206),(23752,1206),(23753,1207),(23754,1207),(23755,1207),(23756,1207),(23757,1208),(23758,1208),(23759,1208),(23760,1208),(23761,1209),(23762,1209),(23763,1209),(23764,1209),(23765,1210),(23766,1210),(23767,1210),(23768,1210),(23769,1211),(23770,1211),(23771,1211),(23772,1211),(23773,1212),(23774,1212),(23775,1212),(23776,1212),(23777,1213),(23778,1213),(23779,1213),(23780,1213),(23781,1214),(23782,1214),(23783,1214),(23784,1214),(23785,1215),(23786,1215),(23787,1215),(23788,1215),(23789,1216),(23790,1216),(23791,1216),(23792,1216),(23793,1217),(23794,1217),(23795,1217),(23796,1217),(23797,1218),(23798,1218),(23799,1218),(23800,1218),(23801,1219),(23802,1219),(23803,1219),(23804,1219),(23805,1220),(23806,1220),(23807,1220),(23808,1220),(23809,1221),(23810,1221),(23811,1221),(23812,1221),(23813,1222),(23814,1222),(23815,1222),(23816,1222),(23817,1223),(23818,1223),(23819,1223),(23820,1223),(23821,1224),(23822,1224),(23823,1224),(23824,1224),(23825,1225),(23826,1225),(23827,1225),(23828,1225),(23829,1226),(23830,1226),(23831,1226),(23832,1226),(23833,1227),(23834,1227),(23835,1227),(23836,1227),(23837,1228),(23838,1228),(23839,1228),(23840,1228),(23841,1229),(23842,1229),(23843,1229),(23844,1229),(23845,1230),(23846,1230),(23847,1230),(23848,1230),(23849,1231),(23850,1231),(23851,1231),(23852,1231),(23853,1232),(23854,1232),(23855,1232),(23856,1232),(23857,1233),(23858,1233),(23859,1233),(23860,1233),(23861,1234),(23862,1234),(23863,1234),(23864,1234),(23865,1235),(23866,1235),(23867,1235),(23868,1235),(23869,1236),(23870,1236),(23871,1236),(23872,1236),(23873,1237),(23874,1237),(23875,1237),(23876,1237),(23877,1238),(23878,1238),(23879,1238),(23880,1238),(23881,1239),(23882,1239),(23883,1239),(23884,1239),(23885,1240),(23886,1240),(23887,1240),(23888,1240),(23889,1241),(23890,1241),(23891,1241),(23892,1241),(23893,1242),(23894,1242),(23895,1242),(23896,1242),(23897,1243),(23898,1243),(23899,1243),(23900,1243),(23901,1244),(23902,1244),(23903,1244),(23904,1244),(23905,1245),(23906,1245),(23907,1245),(23908,1245),(23909,1246),(23910,1246),(23911,1246),(23912,1246),(23913,1247),(23914,1247),(23915,1247),(23916,1247),(23917,1248),(23918,1248),(23919,1248),(23920,1248),(23921,1249),(23922,1249),(23923,1249),(23924,1249),(23925,1250),(23926,1250),(23927,1250),(23928,1250),(23929,1251),(23930,1251),(23931,1251),(23932,1251),(23933,1252),(23934,1252),(23935,1252),(23936,1252),(23937,1253),(23938,1253),(23939,1253),(23940,1253),(23941,1254),(23942,1254),(23943,1254),(23944,1254),(23945,1255),(23946,1255),(23947,1255),(23948,1255),(23949,1256),(23950,1256),(23951,1256),(23952,1256),(23953,1257),(23954,1257),(23955,1257),(23956,1257),(23957,1258),(23958,1258),(23959,1258),(23960,1258),(23961,1259),(23962,1259),(23963,1259),(23964,1259),(23965,1260),(23966,1260),(23967,1260),(23968,1260),(23969,1261),(23970,1261),(23971,1261),(23972,1261),(23973,1262),(23974,1262),(23975,1262),(23976,1262),(23977,1263),(23978,1263),(23979,1263),(23980,1263),(23981,1264),(23982,1264),(23983,1264),(23984,1264),(23985,1265),(23986,1265),(23987,1265),(23988,1265),(23989,1266),(23990,1267),(23991,1268),(23992,1269),(23993,1270),(23994,1271),(23995,1272),(23996,1273),(23997,1274),(23998,1275),(23999,1276),(24000,1277),(24001,1278),(24002,1279),(24003,1280),(24004,1281),(24005,1282),(24006,1283),(24007,1284),(24008,1285),(24009,1286),(24010,1287),(24011,1288),(24012,1289),(24013,1290),(24014,1291),(24015,1292),(24016,1293),(24017,1294),(24018,1295),(24019,1296),(24020,1297),(24021,1298),(24022,1299),(24023,1300),(24024,1301),(24025,1302),(24026,1303),(24027,1304),(24028,1305),(24029,1306),(24030,1307),(24031,1308),(24032,1309),(24033,1310),(24034,1311),(24035,1312),(24036,1313),(24037,1314),(24038,1315),(24039,1316),(24040,1317),(24041,1318),(24042,1319),(24043,1320),(24044,1321),(24045,1322),(24046,1323),(24047,1324),(24048,1325),(24049,1326),(24050,1327),(24051,1328),(24052,1329),(24053,1330),(24054,1331),(24055,1332),(24056,1333),(24057,1334),(24058,1335),(24059,1336),(24060,1337),(24061,1338),(24062,1339),(24063,1340),(24064,1341),(24065,1342),(24066,1343),(24067,1344),(24068,1345),(24069,1346),(24070,1347),(24071,1348),(24072,1349),(24073,1350),(24074,1351),(24075,1352),(24076,1353),(24077,1354),(24078,1355),(24079,1356),(24080,1357),(24081,1358),(24082,1359),(24083,1360),(24084,1361),(24085,1362),(24086,1363),(24087,1364),(24088,1365),(24089,1266),(24090,1267),(24091,1268),(24092,1269),(24093,1270),(24094,1271),(24095,1272),(24096,1273),(24097,1274),(24098,1275),(24099,1276),(24100,1277),(24101,1278),(24102,1279),(24103,1280),(24104,1281),(24105,1282),(24106,1283),(24107,1284),(24108,1285),(24109,1286),(24110,1287),(24111,1288),(24112,1289),(24113,1290),(24114,1291),(24115,1292),(24116,1293),(24117,1294),(24118,1295),(24119,1296),(24120,1297),(24121,1298),(24122,1299),(24123,1300),(24124,1301),(24125,1302),(24126,1303),(24127,1304),(24128,1305),(24129,1306),(24130,1307),(24131,1308),(24132,1309),(24133,1310),(24134,1311),(24135,1312),(24136,1313),(24137,1314),(24138,1315),(24139,1316),(24140,1317),(24141,1318),(24142,1319),(24143,1320),(24144,1321),(24145,1322),(24146,1323),(24147,1324),(24148,1325),(24149,1326),(24150,1327),(24151,1328),(24152,1329),(24153,1330),(24154,1331),(24155,1332),(24156,1333),(24157,1334),(24158,1335),(24159,1336),(24160,1337),(24161,1338),(24162,1339),(24163,1340),(24164,1341),(24165,1342),(24166,1343),(24167,1344),(24168,1345),(24169,1346),(24170,1347),(24171,1348),(24172,1349),(24173,1350),(24174,1351),(24175,1352),(24176,1353),(24177,1354),(24178,1355),(24179,1356),(24180,1357),(24181,1358),(24182,1359),(24183,1360),(24184,1361),(24185,1362),(24186,1363),(24187,1364),(24188,1365),(24189,1266),(24190,1266),(24191,1266),(24192,1266),(24193,1266),(24194,1266),(24195,1266),(24196,1267),(24197,1267),(24198,1267),(24199,1267),(24200,1267),(24201,1267),(24202,1267),(24203,1268),(24204,1268),(24205,1268),(24206,1268),(24207,1268),(24208,1268),(24209,1268),(24210,1269),(24211,1269),(24212,1269),(24213,1269),(24214,1269),(24215,1269),(24216,1269),(24217,1270),(24218,1270),(24219,1270),(24220,1270),(24221,1270),(24222,1270),(24223,1270),(24224,1271),(24225,1271),(24226,1271),(24227,1271),(24228,1271),(24229,1271),(24230,1271),(24231,1272),(24232,1272),(24233,1272),(24234,1272),(24235,1272),(24236,1272),(24237,1272),(24238,1273),(24239,1273),(24240,1273),(24241,1273),(24242,1273),(24243,1273),(24244,1273),(24245,1274),(24246,1274),(24247,1274),(24248,1274),(24249,1274),(24250,1274),(24251,1274),(24252,1275),(24253,1275),(24254,1275),(24255,1275),(24256,1275),(24257,1275),(24258,1275),(24259,1276),(24260,1276),(24261,1276),(24262,1276),(24263,1276),(24264,1276),(24265,1276),(24266,1277),(24267,1277),(24268,1277),(24269,1277),(24270,1277),(24271,1277),(24272,1277),(24273,1278),(24274,1278),(24275,1278),(24276,1278),(24277,1278),(24278,1278),(24279,1278),(24280,1279),(24281,1279),(24282,1279),(24283,1279),(24284,1279),(24285,1279),(24286,1279),(24287,1280),(24288,1280),(24289,1280),(24290,1280),(24291,1280),(24292,1280),(24293,1280),(24294,1281),(24295,1281),(24296,1281),(24297,1281),(24298,1281),(24299,1281),(24300,1281),(24301,1282),(24302,1282),(24303,1282),(24304,1282),(24305,1282),(24306,1282),(24307,1282),(24308,1283),(24309,1283),(24310,1283),(24311,1283),(24312,1283),(24313,1283),(24314,1283),(24315,1284),(24316,1284),(24317,1284),(24318,1284),(24319,1284),(24320,1284),(24321,1284),(24322,1285),(24323,1285),(24324,1285),(24325,1285),(24326,1285),(24327,1285),(24328,1285),(24329,1286),(24330,1286),(24331,1286),(24332,1286),(24333,1286),(24334,1286),(24335,1286),(24336,1287),(24337,1287),(24338,1287),(24339,1287),(24340,1287),(24341,1287),(24342,1287),(24343,1288),(24344,1288),(24345,1288),(24346,1288),(24347,1288),(24348,1288),(24349,1288),(24350,1289),(24351,1289),(24352,1289),(24353,1289),(24354,1289),(24355,1289),(24356,1289),(24357,1290),(24358,1290),(24359,1290),(24360,1290),(24361,1290),(24362,1290),(24363,1290),(24364,1291),(24365,1291),(24366,1291),(24367,1291),(24368,1291),(24369,1291),(24370,1291),(24371,1292),(24372,1292),(24373,1292),(24374,1292),(24375,1292),(24376,1292),(24377,1292),(24378,1293),(24379,1293),(24380,1293),(24381,1293),(24382,1293),(24383,1293),(24384,1293),(24385,1294),(24386,1294),(24387,1294),(24388,1294),(24389,1294),(24390,1294),(24391,1294),(24392,1295),(24393,1295),(24394,1295),(24395,1295),(24396,1295),(24397,1295),(24398,1295),(24399,1296),(24400,1296),(24401,1296),(24402,1296),(24403,1296),(24404,1296),(24405,1296),(24406,1297),(24407,1297),(24408,1297),(24409,1297),(24410,1297),(24411,1297),(24412,1297),(24413,1298),(24414,1298),(24415,1298),(24416,1298),(24417,1298),(24418,1298),(24419,1298),(24420,1299),(24421,1299),(24422,1299),(24423,1299),(24424,1299),(24425,1299),(24426,1299),(24427,1300),(24428,1300),(24429,1300),(24430,1300),(24431,1300),(24432,1300),(24433,1300),(24434,1301),(24435,1301),(24436,1301),(24437,1301),(24438,1301),(24439,1301),(24440,1301),(24441,1302),(24442,1302),(24443,1302),(24444,1302),(24445,1302),(24446,1302),(24447,1302),(24448,1303),(24449,1303),(24450,1303),(24451,1303),(24452,1303),(24453,1303),(24454,1303),(24455,1304),(24456,1304),(24457,1304),(24458,1304),(24459,1304),(24460,1304),(24461,1304),(24462,1305),(24463,1305),(24464,1305),(24465,1305),(24466,1305),(24467,1305),(24468,1305),(24469,1306),(24470,1306),(24471,1306),(24472,1306),(24473,1306),(24474,1306),(24475,1306),(24476,1307),(24477,1307),(24478,1307),(24479,1307),(24480,1307),(24481,1307),(24482,1307),(24483,1308),(24484,1308),(24485,1308),(24486,1308),(24487,1308),(24488,1308),(24489,1308),(24490,1309),(24491,1309),(24492,1309),(24493,1309),(24494,1309),(24495,1309),(24496,1309),(24497,1310),(24498,1310),(24499,1310),(24500,1310),(24501,1310),(24502,1310),(24503,1310),(24504,1311),(24505,1311),(24506,1311),(24507,1311),(24508,1311),(24509,1311),(24510,1311),(24511,1312),(24512,1312),(24513,1312),(24514,1312),(24515,1312),(24516,1312),(24517,1312),(24518,1313),(24519,1313),(24520,1313),(24521,1313),(24522,1313),(24523,1313),(24524,1313),(24525,1314),(24526,1314),(24527,1314),(24528,1314),(24529,1314),(24530,1314),(24531,1314),(24532,1315),(24533,1315),(24534,1315),(24535,1315),(24536,1315),(24537,1315),(24538,1315),(24539,1316),(24540,1316),(24541,1316),(24542,1316),(24543,1316),(24544,1316),(24545,1316),(24546,1317),(24547,1317),(24548,1317),(24549,1317),(24550,1317),(24551,1317),(24552,1317),(24553,1318),(24554,1318),(24555,1318),(24556,1318),(24557,1318),(24558,1318),(24559,1318),(24560,1319),(24561,1319),(24562,1319),(24563,1319),(24564,1319),(24565,1319),(24566,1319),(24567,1320),(24568,1320),(24569,1320),(24570,1320),(24571,1320),(24572,1320),(24573,1320),(24574,1321),(24575,1321),(24576,1321),(24577,1321),(24578,1321),(24579,1321),(24580,1321),(24581,1322),(24582,1322),(24583,1322),(24584,1322),(24585,1322),(24586,1322),(24587,1322),(24588,1323),(24589,1323),(24590,1323),(24591,1323),(24592,1323),(24593,1323),(24594,1323),(24595,1324),(24596,1324),(24597,1324),(24598,1324),(24599,1324),(24600,1324),(24601,1324),(24602,1325),(24603,1325),(24604,1325),(24605,1325),(24606,1325),(24607,1325),(24608,1325),(24609,1326),(24610,1326),(24611,1326),(24612,1326),(24613,1326),(24614,1326),(24615,1326),(24616,1327),(24617,1327),(24618,1327),(24619,1327),(24620,1327),(24621,1327),(24622,1327),(24623,1328),(24624,1328),(24625,1328),(24626,1328),(24627,1328),(24628,1328),(24629,1328),(24630,1329),(24631,1329),(24632,1329),(24633,1329),(24634,1329),(24635,1329),(24636,1329),(24637,1330),(24638,1330),(24639,1330),(24640,1330),(24641,1330),(24642,1330),(24643,1330),(24644,1331),(24645,1331),(24646,1331),(24647,1331),(24648,1331),(24649,1331),(24650,1331),(24651,1332),(24652,1332),(24653,1332),(24654,1332),(24655,1332),(24656,1332),(24657,1332),(24658,1333),(24659,1333),(24660,1333),(24661,1333),(24662,1333),(24663,1333),(24664,1333),(24665,1334),(24666,1334),(24667,1334),(24668,1334),(24669,1334),(24670,1334),(24671,1334),(24672,1335),(24673,1335),(24674,1335),(24675,1335),(24676,1335),(24677,1335),(24678,1335),(24679,1336),(24680,1336),(24681,1336),(24682,1336),(24683,1336),(24684,1336),(24685,1336),(24686,1337),(24687,1337),(24688,1337),(24689,1337),(24690,1337),(24691,1337),(24692,1337),(24693,1338),(24694,1338),(24695,1338),(24696,1338),(24697,1338),(24698,1338),(24699,1338),(24700,1339),(24701,1339),(24702,1339),(24703,1339),(24704,1339),(24705,1339),(24706,1339),(24707,1340),(24708,1340),(24709,1340),(24710,1340),(24711,1340),(24712,1340),(24713,1340),(24714,1341),(24715,1341),(24716,1341),(24717,1341),(24718,1341),(24719,1341),(24720,1341),(24721,1342),(24722,1342),(24723,1342),(24724,1342),(24725,1342),(24726,1342),(24727,1342),(24728,1343),(24729,1343),(24730,1343),(24731,1343),(24732,1343),(24733,1343),(24734,1343),(24735,1344),(24736,1344),(24737,1344),(24738,1344),(24739,1344),(24740,1344),(24741,1344),(24742,1345),(24743,1345),(24744,1345),(24745,1345),(24746,1345),(24747,1345),(24748,1345),(24749,1346),(24750,1346),(24751,1346),(24752,1346),(24753,1346),(24754,1346),(24755,1346),(24756,1347),(24757,1347),(24758,1347),(24759,1347),(24760,1347),(24761,1347),(24762,1347),(24763,1348),(24764,1348),(24765,1348),(24766,1348),(24767,1348),(24768,1348),(24769,1348),(24770,1349),(24771,1349),(24772,1349),(24773,1349),(24774,1349),(24775,1349),(24776,1349),(24777,1350),(24778,1350),(24779,1350),(24780,1350),(24781,1350),(24782,1350),(24783,1350),(24784,1351),(24785,1351),(24786,1351),(24787,1351),(24788,1351),(24789,1351),(24790,1351),(24791,1352),(24792,1352),(24793,1352),(24794,1352),(24795,1352),(24796,1352),(24797,1352),(24798,1353),(24799,1353),(24800,1353),(24801,1353),(24802,1353),(24803,1353),(24804,1353),(24805,1354),(24806,1354),(24807,1354),(24808,1354),(24809,1354),(24810,1354),(24811,1354),(24812,1355),(24813,1355),(24814,1355),(24815,1355),(24816,1355),(24817,1355),(24818,1355),(24819,1356),(24820,1356),(24821,1356),(24822,1356),(24823,1356),(24824,1356),(24825,1356),(24826,1357),(24827,1357),(24828,1357),(24829,1357),(24830,1357),(24831,1357),(24832,1357),(24833,1358),(24834,1358),(24835,1358),(24836,1358),(24837,1358),(24838,1358),(24839,1358),(24840,1359),(24841,1359),(24842,1359),(24843,1359),(24844,1359),(24845,1359),(24846,1359),(24847,1360),(24848,1360),(24849,1360),(24850,1360),(24851,1360),(24852,1360),(24853,1360),(24854,1361),(24855,1361),(24856,1361),(24857,1361),(24858,1361),(24859,1361),(24860,1361),(24861,1362),(24862,1362),(24863,1362),(24864,1362),(24865,1362),(24866,1362),(24867,1362),(24868,1363),(24869,1363),(24870,1363),(24871,1363),(24872,1363),(24873,1363),(24874,1363),(24875,1364),(24876,1364),(24877,1364),(24878,1364),(24879,1364),(24880,1364),(24881,1364),(24882,1365),(24883,1365),(24884,1365),(24885,1365),(24886,1365),(24887,1365),(24888,1365),(24889,1266),(24890,1266),(24891,1267),(24892,1267),(24893,1268),(24894,1268),(24895,1269),(24896,1269),(24897,1270),(24898,1270),(24899,1271),(24900,1271),(24901,1272),(24902,1272),(24903,1273),(24904,1273),(24905,1274),(24906,1274),(24907,1275),(24908,1275),(24909,1276),(24910,1276),(24911,1277),(24912,1277),(24913,1278),(24914,1278),(24915,1279),(24916,1279),(24917,1280),(24918,1280),(24919,1281),(24920,1281),(24921,1282),(24922,1282),(24923,1283),(24924,1283),(24925,1284),(24926,1284),(24927,1285),(24928,1285),(24929,1286),(24930,1286),(24931,1287),(24932,1287),(24933,1288),(24934,1288),(24935,1289),(24936,1289),(24937,1290),(24938,1290),(24939,1291),(24940,1291),(24941,1292),(24942,1292),(24943,1293),(24944,1293),(24945,1294),(24946,1294),(24947,1295),(24948,1295),(24949,1296),(24950,1296),(24951,1297),(24952,1297),(24953,1298),(24954,1298),(24955,1299),(24956,1299),(24957,1300),(24958,1300),(24959,1301),(24960,1301),(24961,1302),(24962,1302),(24963,1303),(24964,1303),(24965,1304),(24966,1304),(24967,1305),(24968,1305),(24969,1306),(24970,1306),(24971,1307),(24972,1307),(24973,1308),(24974,1308),(24975,1309),(24976,1309),(24977,1310),(24978,1310),(24979,1311),(24980,1311),(24981,1312),(24982,1312),(24983,1313),(24984,1313),(24985,1314),(24986,1314),(24987,1315),(24988,1315),(24989,1316),(24990,1316),(24991,1317),(24992,1317),(24993,1318),(24994,1318),(24995,1319),(24996,1319),(24997,1320),(24998,1320),(24999,1321),(25000,1321),(25001,1322),(25002,1322),(25003,1323),(25004,1323),(25005,1324),(25006,1324),(25007,1325),(25008,1325),(25009,1326),(25010,1326),(25011,1327),(25012,1327),(25013,1328),(25014,1328),(25015,1329),(25016,1329),(25017,1330),(25018,1330),(25019,1331),(25020,1331),(25021,1332),(25022,1332),(25023,1333),(25024,1333),(25025,1334),(25026,1334),(25027,1335),(25028,1335),(25029,1336),(25030,1336),(25031,1337),(25032,1337),(25033,1338),(25034,1338),(25035,1339),(25036,1339),(25037,1340),(25038,1340),(25039,1341),(25040,1341),(25041,1342),(25042,1342),(25043,1343),(25044,1344),(25045,1344),(25046,1345),(25047,1345),(25048,1346),(25049,1346),(25050,1347),(25051,1347),(25052,1348),(25053,1348),(25054,1349),(25055,1349),(25056,1350),(25057,1350),(25058,1351),(25059,1351),(25060,1352),(25061,1352),(25062,1353),(25063,1353),(25064,1354),(25065,1354),(25066,1355),(25067,1355),(25068,1356),(25069,1356),(25070,1357),(25071,1357),(25072,1358),(25073,1358),(25074,1359),(25075,1359),(25076,1360),(25077,1360),(25078,1361),(25079,1361),(25080,1362),(25081,1362),(25082,1363),(25083,1363),(25084,1364),(25085,1364),(25086,1365),(25087,1365),(25088,1266),(25089,1266),(25090,1266),(25091,1267),(25092,1267),(25093,1267),(25094,1268),(25095,1268),(25096,1268),(25097,1269),(25098,1269),(25099,1269),(25100,1270),(25101,1270),(25102,1270),(25103,1271),(25104,1271),(25105,1271),(25106,1272),(25107,1272),(25108,1272),(25109,1273),(25110,1273),(25111,1273),(25112,1274),(25113,1274),(25114,1274),(25115,1275),(25116,1275),(25117,1275),(25118,1276),(25119,1276),(25120,1276),(25121,1277),(25122,1277),(25123,1277),(25124,1278),(25125,1278),(25126,1278),(25127,1279),(25128,1279),(25129,1279),(25130,1280),(25131,1280),(25132,1280),(25133,1281),(25134,1281),(25135,1281),(25136,1282),(25137,1282),(25138,1282),(25139,1283),(25140,1283),(25141,1283),(25142,1284),(25143,1284),(25144,1284),(25145,1285),(25146,1285),(25147,1285),(25148,1286),(25149,1286),(25150,1286),(25151,1287),(25152,1287),(25153,1287),(25154,1288),(25155,1288),(25156,1288),(25157,1289),(25158,1289),(25159,1289),(25160,1290),(25161,1290),(25162,1290),(25163,1291),(25164,1291),(25165,1291),(25166,1292),(25167,1292),(25168,1292),(25169,1293),(25170,1293),(25171,1293),(25172,1294),(25173,1294),(25174,1294),(25175,1295),(25176,1295),(25177,1295),(25178,1296),(25179,1296),(25180,1296),(25181,1297),(25182,1297),(25183,1297),(25184,1298),(25185,1298),(25186,1298),(25187,1299),(25188,1299),(25189,1299),(25190,1300),(25191,1300),(25192,1300),(25193,1301),(25194,1301),(25195,1301),(25196,1302),(25197,1302),(25198,1302),(25199,1303),(25200,1303),(25201,1303),(25202,1304),(25203,1304),(25204,1304),(25205,1305),(25206,1305),(25207,1305),(25208,1306),(25209,1306),(25210,1306),(25211,1307),(25212,1307),(25213,1307),(25214,1308),(25215,1308),(25216,1308),(25217,1309),(25218,1309),(25219,1309),(25220,1310),(25221,1310),(25222,1310),(25223,1311),(25224,1311),(25225,1311),(25226,1312),(25227,1312),(25228,1312),(25229,1313),(25230,1313),(25231,1313),(25232,1314),(25233,1314),(25234,1314),(25235,1315),(25236,1315),(25237,1315),(25238,1316),(25239,1316),(25240,1316),(25241,1317),(25242,1317),(25243,1317),(25244,1318),(25245,1318),(25246,1318),(25247,1319),(25248,1319),(25249,1319),(25250,1320),(25251,1320),(25252,1320),(25253,1321),(25254,1321),(25255,1321),(25256,1322),(25257,1322),(25258,1322),(25259,1323),(25260,1323),(25261,1323),(25262,1324),(25263,1324),(25264,1324),(25265,1325),(25266,1325),(25267,1325),(25268,1326),(25269,1326),(25270,1326),(25271,1327),(25272,1327),(25273,1327),(25274,1328),(25275,1328),(25276,1328),(25277,1329),(25278,1329),(25279,1329),(25280,1330),(25281,1330),(25282,1330),(25283,1331),(25284,1331),(25285,1331),(25286,1332),(25287,1332),(25288,1332),(25289,1333),(25290,1333),(25291,1333),(25292,1334),(25293,1334),(25294,1334),(25295,1335),(25296,1335),(25297,1335),(25298,1336),(25299,1336),(25300,1336),(25301,1337),(25302,1337),(25303,1337),(25304,1338),(25305,1338),(25306,1338),(25307,1339),(25308,1339),(25309,1339),(25310,1340),(25311,1340),(25312,1340),(25313,1341),(25314,1341),(25315,1341),(25316,1342),(25317,1342),(25318,1342),(25319,1343),(25320,1343),(25321,1343),(25322,1344),(25323,1344),(25324,1344),(25325,1345),(25326,1345),(25327,1345),(25328,1346),(25329,1346),(25330,1346),(25331,1347),(25332,1347),(25333,1347),(25334,1348),(25335,1348),(25336,1348),(25337,1349),(25338,1349),(25339,1349),(25340,1350),(25341,1350),(25342,1350),(25343,1351),(25344,1351),(25345,1351),(25346,1352),(25347,1352),(25348,1352),(25349,1353),(25350,1353),(25351,1353),(25352,1354),(25353,1354),(25354,1354),(25355,1355),(25356,1355),(25357,1355),(25358,1356),(25359,1356),(25360,1356),(25361,1357),(25362,1357),(25363,1357),(25364,1358),(25365,1358),(25366,1358),(25367,1359),(25368,1359),(25369,1359),(25370,1360),(25371,1360),(25372,1360),(25373,1361),(25374,1361),(25375,1361),(25376,1362),(25377,1362),(25378,1362),(25379,1363),(25380,1363),(25381,1363),(25382,1364),(25383,1364),(25384,1364),(25385,1365),(25386,1365),(25387,1365),(25388,1266),(25389,1266),(25390,1266),(25391,1266),(25392,1267),(25393,1267),(25394,1267),(25395,1267),(25396,1268),(25397,1268),(25398,1268),(25399,1268),(25400,1269),(25401,1269),(25402,1269),(25403,1269),(25404,1270),(25405,1270),(25406,1270),(25407,1270),(25408,1271),(25409,1271),(25410,1271),(25411,1271),(25412,1272),(25413,1272),(25414,1272),(25415,1272),(25416,1273),(25417,1273),(25418,1273),(25419,1273),(25420,1274),(25421,1274),(25422,1274),(25423,1274),(25424,1275),(25425,1275),(25426,1275),(25427,1275),(25428,1276),(25429,1276),(25430,1276),(25431,1276),(25432,1277),(25433,1277),(25434,1277),(25435,1277),(25436,1278),(25437,1278),(25438,1278),(25439,1278),(25440,1279),(25441,1279),(25442,1279),(25443,1279),(25444,1280),(25445,1280),(25446,1280),(25447,1280),(25448,1281),(25449,1281),(25450,1281),(25451,1281),(25452,1282),(25453,1282),(25454,1282),(25455,1282),(25456,1283),(25457,1283),(25458,1283),(25459,1283),(25460,1284),(25461,1284),(25462,1284),(25463,1284),(25464,1285),(25465,1285),(25466,1285),(25467,1285),(25468,1286),(25469,1286),(25470,1286),(25471,1286),(25472,1287),(25473,1287),(25474,1287),(25475,1287),(25476,1288),(25477,1288),(25478,1288),(25479,1288),(25480,1289),(25481,1289),(25482,1289),(25483,1289),(25484,1290),(25485,1290),(25486,1290),(25487,1290),(25488,1291),(25489,1291),(25490,1291),(25491,1291),(25492,1292),(25493,1292),(25494,1292),(25495,1292),(25496,1293),(25497,1293),(25498,1293),(25499,1293),(25500,1294),(25501,1294),(25502,1294),(25503,1294),(25504,1295),(25505,1295),(25506,1295),(25507,1295),(25508,1296),(25509,1296),(25510,1296),(25511,1296),(25512,1297),(25513,1297),(25514,1297),(25515,1297),(25516,1298),(25517,1298),(25518,1298),(25519,1298),(25520,1299),(25521,1299),(25522,1299),(25523,1299),(25524,1300),(25525,1300),(25526,1300),(25527,1300),(25528,1301),(25529,1301),(25530,1301),(25531,1301),(25532,1302),(25533,1302),(25534,1302),(25535,1302),(25536,1303),(25537,1303),(25538,1303),(25539,1303),(25540,1304),(25541,1304),(25542,1304),(25543,1304),(25544,1305),(25545,1305),(25546,1305),(25547,1305),(25548,1306),(25549,1306),(25550,1306),(25551,1306),(25552,1307),(25553,1307),(25554,1307),(25555,1307),(25556,1308),(25557,1308),(25558,1308),(25559,1308),(25560,1309),(25561,1309),(25562,1309),(25563,1309),(25564,1310),(25565,1310),(25566,1310),(25567,1310),(25568,1311),(25569,1311),(25570,1311),(25571,1311),(25572,1312),(25573,1312),(25574,1312),(25575,1312),(25576,1313),(25577,1313),(25578,1313),(25579,1313),(25580,1314),(25581,1314),(25582,1314),(25583,1314),(25584,1315),(25585,1315),(25586,1315),(25587,1315),(25588,1316),(25589,1316),(25590,1316),(25591,1316),(25592,1317),(25593,1317),(25594,1317),(25595,1317),(25596,1318),(25597,1318),(25598,1318),(25599,1318),(25600,1319),(25601,1319),(25602,1319),(25603,1319),(25604,1320),(25605,1320),(25606,1320),(25607,1320),(25608,1321),(25609,1321),(25610,1321),(25611,1321),(25612,1322),(25613,1322),(25614,1322),(25615,1322),(25616,1323),(25617,1323),(25618,1323),(25619,1323),(25620,1324),(25621,1324),(25622,1324),(25623,1324),(25624,1325),(25625,1325),(25626,1325),(25627,1325),(25628,1326),(25629,1326),(25630,1326),(25631,1326),(25632,1327),(25633,1327),(25634,1327),(25635,1327),(25636,1328),(25637,1328),(25638,1328),(25639,1328),(25640,1329),(25641,1329),(25642,1329),(25643,1329),(25644,1330),(25645,1330),(25646,1330),(25647,1330),(25648,1331),(25649,1331),(25650,1331),(25651,1331),(25652,1332),(25653,1332),(25654,1332),(25655,1332),(25656,1333),(25657,1333),(25658,1333),(25659,1333),(25660,1334),(25661,1334),(25662,1334),(25663,1334),(25664,1335),(25665,1335),(25666,1335),(25667,1335),(25668,1336),(25669,1336),(25670,1336),(25671,1336),(25672,1337),(25673,1337),(25674,1337),(25675,1337),(25676,1338),(25677,1338),(25678,1338),(25679,1338),(25680,1339),(25681,1339),(25682,1339),(25683,1339),(25684,1340),(25685,1340),(25686,1340),(25687,1340),(25688,1341),(25689,1341),(25690,1341),(25691,1341),(25692,1342),(25693,1342),(25694,1342),(25695,1342),(25696,1343),(25697,1343),(25698,1343),(25699,1343),(25700,1344),(25701,1344),(25702,1344),(25703,1344),(25704,1345),(25705,1345),(25706,1345),(25707,1345),(25708,1346),(25709,1346),(25710,1346),(25711,1346),(25712,1347),(25713,1347),(25714,1347),(25715,1347),(25716,1348),(25717,1348),(25718,1348),(25719,1348),(25720,1349),(25721,1349),(25722,1349),(25723,1349),(25724,1350),(25725,1350),(25726,1350),(25727,1350),(25728,1351),(25729,1351),(25730,1351),(25731,1351),(25732,1352),(25733,1352),(25734,1352),(25735,1352),(25736,1353),(25737,1353),(25738,1353),(25739,1353),(25740,1354),(25741,1354),(25742,1354),(25743,1354),(25744,1355),(25745,1355),(25746,1355),(25747,1355),(25748,1356),(25749,1356),(25750,1356),(25751,1356),(25752,1357),(25753,1357),(25754,1357),(25755,1357),(25756,1358),(25757,1358),(25758,1358),(25759,1358),(25760,1359),(25761,1359),(25762,1359),(25763,1359),(25764,1360),(25765,1360),(25766,1360),(25767,1360),(25768,1361),(25769,1361),(25770,1361),(25771,1361),(25772,1362),(25773,1362),(25774,1362),(25775,1362),(25776,1363),(25777,1363),(25778,1363),(25779,1363),(25780,1364),(25781,1364),(25782,1364),(25783,1364),(25784,1365),(25785,1365),(25786,1365),(25787,1365),(25788,1366),(25789,1367),(25790,1368),(25791,1369),(25792,1370),(25793,1371),(25794,1372),(25795,1373),(25796,1374),(25797,1375),(25798,1376),(25799,1377),(25800,1378),(25801,1379),(25802,1380),(25803,1381),(25804,1382),(25805,1383),(25806,1384),(25807,1385),(25808,1386),(25809,1387),(25810,1388),(25811,1389),(25812,1390),(25813,1391),(25814,1392),(25815,1393),(25816,1394),(25817,1395),(25818,1396),(25819,1397),(25820,1398),(25821,1399),(25822,1400),(25823,1401),(25824,1402),(25825,1403),(25826,1404),(25827,1405),(25828,1406),(25829,1407),(25830,1408),(25831,1409),(25832,1410),(25833,1411),(25834,1412),(25835,1413),(25836,1414),(25837,1415),(25838,1416),(25839,1417),(25840,1418),(25841,1419),(25842,1420),(25843,1421),(25844,1422),(25845,1423),(25846,1424),(25847,1425),(25848,1426),(25849,1427),(25850,1428),(25851,1429),(25852,1430),(25853,1431),(25854,1432),(25855,1433),(25856,1434),(25857,1435),(25858,1436),(25859,1437),(25860,1438),(25861,1439),(25862,1440),(25863,1441),(25864,1442),(25865,1443),(25866,1444),(25867,1445),(25868,1446),(25869,1447),(25870,1448),(25871,1449),(25872,1450),(25873,1451),(25874,1452),(25875,1453),(25876,1454),(25877,1455),(25878,1456),(25879,1457),(25880,1458),(25881,1459),(25882,1460),(25883,1461),(25884,1462),(25885,1463),(25886,1464),(25887,1465),(25888,1366),(25889,1367),(25890,1368),(25891,1369),(25892,1370),(25893,1371),(25894,1372),(25895,1373),(25896,1374),(25897,1375),(25898,1376),(25899,1377),(25900,1378),(25901,1379),(25902,1380),(25903,1381),(25904,1382),(25905,1383),(25906,1384),(25907,1385),(25908,1386),(25909,1387),(25910,1388),(25911,1389),(25912,1390),(25913,1391),(25914,1392),(25915,1393),(25916,1394),(25917,1395),(25918,1396),(25919,1397),(25920,1398),(25921,1399),(25922,1400),(25923,1401),(25924,1402),(25925,1403),(25926,1404),(25927,1405),(25928,1406),(25929,1407),(25930,1408),(25931,1409),(25932,1410),(25933,1411),(25934,1412),(25935,1413),(25936,1414),(25937,1415),(25938,1416),(25939,1417),(25940,1418),(25941,1419),(25942,1420),(25943,1421),(25944,1422),(25945,1423),(25946,1424),(25947,1425),(25948,1426),(25949,1427),(25950,1428),(25951,1429),(25952,1430),(25953,1431),(25954,1432),(25955,1433),(25956,1434),(25957,1435),(25958,1436),(25959,1437),(25960,1438),(25961,1439),(25962,1440),(25963,1441),(25964,1442),(25965,1443),(25966,1444),(25967,1445),(25968,1446),(25969,1447),(25970,1448),(25971,1449),(25972,1450),(25973,1451),(25974,1452),(25975,1453),(25976,1454),(25977,1455),(25978,1456),(25979,1457),(25980,1458),(25981,1459),(25982,1460),(25983,1461),(25984,1462),(25985,1463),(25986,1464),(25987,1465),(25988,1366),(25989,1366),(25990,1366),(25991,1366),(25992,1366),(25993,1366),(25994,1366),(25995,1367),(25996,1367),(25997,1367),(25998,1367),(25999,1367),(26000,1367),(26001,1367),(26002,1368),(26003,1368),(26004,1368),(26005,1368),(26006,1368),(26007,1368),(26008,1368),(26009,1369),(26010,1369),(26011,1369),(26012,1369),(26013,1369),(26014,1369),(26015,1369),(26016,1370),(26017,1370),(26018,1370),(26019,1370),(26020,1370),(26021,1370),(26022,1370),(26023,1371),(26024,1371),(26025,1371),(26026,1371),(26027,1371),(26028,1371),(26029,1371),(26030,1372),(26031,1372),(26032,1372),(26033,1372),(26034,1372),(26035,1372),(26036,1372),(26037,1373),(26038,1373),(26039,1373),(26040,1373),(26041,1373),(26042,1373),(26043,1373),(26044,1374),(26045,1374),(26046,1374),(26047,1374),(26048,1374),(26049,1374),(26050,1374),(26051,1375),(26052,1375),(26053,1375),(26054,1375),(26055,1375),(26056,1375),(26057,1375),(26058,1376),(26059,1376),(26060,1376),(26061,1376),(26062,1376),(26063,1376),(26064,1376),(26065,1377),(26066,1377),(26067,1377),(26068,1377),(26069,1377),(26070,1377),(26071,1377),(26072,1378),(26073,1378),(26074,1378),(26075,1378),(26076,1378),(26077,1378),(26078,1378),(26079,1379),(26080,1379),(26081,1379),(26082,1379),(26083,1379),(26084,1379),(26085,1379),(26086,1380),(26087,1380),(26088,1380),(26089,1380),(26090,1380),(26091,1380),(26092,1380),(26093,1381),(26094,1381),(26095,1381),(26096,1381),(26097,1381),(26098,1381),(26099,1381),(26100,1382),(26101,1382),(26102,1382),(26103,1382),(26104,1382),(26105,1382),(26106,1382),(26107,1383),(26108,1383),(26109,1383),(26110,1383),(26111,1383),(26112,1383),(26113,1383),(26114,1384),(26115,1384),(26116,1384),(26117,1384),(26118,1384),(26119,1384),(26120,1384),(26121,1385),(26122,1385),(26123,1385),(26124,1385),(26125,1385),(26126,1385),(26127,1385),(26128,1386),(26129,1386),(26130,1386),(26131,1386),(26132,1386),(26133,1386),(26134,1386),(26135,1387),(26136,1387),(26137,1387),(26138,1387),(26139,1387),(26140,1387),(26141,1387),(26142,1388),(26143,1388),(26144,1388),(26145,1388),(26146,1388),(26147,1388),(26148,1388),(26149,1389),(26150,1389),(26151,1389),(26152,1389),(26153,1389),(26154,1389),(26155,1389),(26156,1390),(26157,1390),(26158,1390),(26159,1390),(26160,1390),(26161,1390),(26162,1390),(26163,1391),(26164,1391),(26165,1391),(26166,1391),(26167,1391),(26168,1391),(26169,1391),(26170,1392),(26171,1392),(26172,1392),(26173,1392),(26174,1392),(26175,1392),(26176,1392),(26177,1393),(26178,1393),(26179,1393),(26180,1393),(26181,1393),(26182,1393),(26183,1393),(26184,1394),(26185,1394),(26186,1394),(26187,1394),(26188,1394),(26189,1394),(26190,1394),(26191,1395),(26192,1395),(26193,1395),(26194,1395),(26195,1395),(26196,1395),(26197,1395),(26198,1396),(26199,1396),(26200,1396),(26201,1396),(26202,1396),(26203,1396),(26204,1396),(26205,1397),(26206,1397),(26207,1397),(26208,1397),(26209,1397),(26210,1397),(26211,1397),(26212,1398),(26213,1398),(26214,1398),(26215,1398),(26216,1398),(26217,1398),(26218,1398),(26219,1399),(26220,1399),(26221,1399),(26222,1399),(26223,1399),(26224,1399),(26225,1399),(26226,1400),(26227,1400),(26228,1400),(26229,1400),(26230,1400),(26231,1400),(26232,1400),(26233,1401),(26234,1401),(26235,1401),(26236,1401),(26237,1401),(26238,1401),(26239,1401),(26240,1402),(26241,1402),(26242,1402),(26243,1402),(26244,1402),(26245,1402),(26246,1402),(26247,1403),(26248,1403),(26249,1403),(26250,1403),(26251,1403),(26252,1403),(26253,1403),(26254,1404),(26255,1404),(26256,1404),(26257,1404),(26258,1404),(26259,1404),(26260,1404),(26261,1405),(26262,1405),(26263,1405),(26264,1405),(26265,1405),(26266,1405),(26267,1405),(26268,1406),(26269,1406),(26270,1406),(26271,1406),(26272,1406),(26273,1406),(26274,1406),(26275,1407),(26276,1407),(26277,1407),(26278,1407),(26279,1407),(26280,1407),(26281,1407),(26282,1408),(26283,1408),(26284,1408),(26285,1408),(26286,1408),(26287,1408),(26288,1408),(26289,1409),(26290,1409),(26291,1409),(26292,1409),(26293,1409),(26294,1409),(26295,1409),(26296,1410),(26297,1410),(26298,1410),(26299,1410),(26300,1410),(26301,1410),(26302,1410),(26303,1411),(26304,1411),(26305,1411),(26306,1411),(26307,1411),(26308,1411),(26309,1411),(26310,1412),(26311,1412),(26312,1412),(26313,1412),(26314,1412),(26315,1412),(26316,1412),(26317,1413),(26318,1413),(26319,1413),(26320,1413),(26321,1413),(26322,1413),(26323,1413),(26324,1414),(26325,1414),(26326,1414),(26327,1414),(26328,1414),(26329,1414),(26330,1414),(26331,1415),(26332,1415),(26333,1415),(26334,1415),(26335,1415),(26336,1415),(26337,1415),(26338,1416),(26339,1416),(26340,1416),(26341,1416),(26342,1416),(26343,1416),(26344,1416),(26345,1417),(26346,1417),(26347,1417),(26348,1417),(26349,1417),(26350,1417),(26351,1417),(26352,1418),(26353,1418),(26354,1418),(26355,1418),(26356,1418),(26357,1418),(26358,1418),(26359,1419),(26360,1419),(26361,1419),(26362,1419),(26363,1419),(26364,1419),(26365,1419),(26366,1420),(26367,1420),(26368,1420),(26369,1420),(26370,1420),(26371,1420),(26372,1420),(26373,1421),(26374,1421),(26375,1421),(26376,1421),(26377,1421),(26378,1421),(26379,1421),(26380,1422),(26381,1422),(26382,1422),(26383,1422),(26384,1422),(26385,1422),(26386,1422),(26387,1423),(26388,1423),(26389,1423),(26390,1423),(26391,1423),(26392,1423),(26393,1423),(26394,1424),(26395,1424),(26396,1424),(26397,1424),(26398,1424),(26399,1424),(26400,1424),(26401,1425),(26402,1425),(26403,1425),(26404,1425),(26405,1425),(26406,1425),(26407,1425),(26408,1426),(26409,1426),(26410,1426),(26411,1426),(26412,1426),(26413,1426),(26414,1426),(26415,1427),(26416,1427),(26417,1427),(26418,1427),(26419,1427),(26420,1427),(26421,1427),(26422,1428),(26423,1428),(26424,1428),(26425,1428),(26426,1428),(26427,1428),(26428,1428),(26429,1429),(26430,1429),(26431,1429),(26432,1429),(26433,1429),(26434,1429),(26435,1429),(26436,1430),(26437,1430),(26438,1430),(26439,1430),(26440,1430),(26441,1430),(26442,1430),(26443,1431),(26444,1431),(26445,1431),(26446,1431),(26447,1431),(26448,1431),(26449,1431),(26450,1432),(26451,1432),(26452,1432),(26453,1432),(26454,1432),(26455,1432),(26456,1432),(26457,1433),(26458,1433),(26459,1433),(26460,1433),(26461,1433),(26462,1433),(26463,1433),(26464,1434),(26465,1434),(26466,1434),(26467,1434),(26468,1434),(26469,1434),(26470,1434),(26471,1435),(26472,1435),(26473,1435),(26474,1435),(26475,1435),(26476,1435),(26477,1435),(26478,1436),(26479,1436),(26480,1436),(26481,1436),(26482,1436),(26483,1436),(26484,1436),(26485,1437),(26486,1437),(26487,1437),(26488,1437),(26489,1437),(26490,1437),(26491,1437),(26492,1438),(26493,1438),(26494,1438),(26495,1438),(26496,1438),(26497,1438),(26498,1438),(26499,1439),(26500,1439),(26501,1439),(26502,1439),(26503,1439),(26504,1439),(26505,1439),(26506,1440),(26507,1440),(26508,1440),(26509,1440),(26510,1440),(26511,1440),(26512,1440),(26513,1441),(26514,1441),(26515,1441),(26516,1441),(26517,1441),(26518,1441),(26519,1441),(26520,1442),(26521,1442),(26522,1442),(26523,1442),(26524,1442),(26525,1442),(26526,1442),(26527,1443),(26528,1443),(26529,1443),(26530,1443),(26531,1443),(26532,1443),(26533,1443),(26534,1444),(26535,1444),(26536,1444),(26537,1444),(26538,1444),(26539,1444),(26540,1444),(26541,1445),(26542,1445),(26543,1445),(26544,1445),(26545,1445),(26546,1445),(26547,1445),(26548,1446),(26549,1446),(26550,1446),(26551,1446),(26552,1446),(26553,1446),(26554,1446),(26555,1447),(26556,1447),(26557,1447),(26558,1447),(26559,1447),(26560,1447),(26561,1447),(26562,1448),(26563,1448),(26564,1448),(26565,1448),(26566,1448),(26567,1448),(26568,1448),(26569,1449),(26570,1449),(26571,1449),(26572,1449),(26573,1449),(26574,1449),(26575,1449),(26576,1450),(26577,1450),(26578,1450),(26579,1450),(26580,1450),(26581,1450),(26582,1450),(26583,1451),(26584,1451),(26585,1451),(26586,1451),(26587,1451),(26588,1451),(26589,1451),(26590,1452),(26591,1452),(26592,1452),(26593,1452),(26594,1452),(26595,1452),(26596,1452),(26597,1453),(26598,1453),(26599,1453),(26600,1453),(26601,1453),(26602,1453),(26603,1453),(26604,1454),(26605,1454),(26606,1454),(26607,1454),(26608,1454),(26609,1454),(26610,1454),(26611,1455),(26612,1455),(26613,1455),(26614,1455),(26615,1455),(26616,1455),(26617,1455),(26618,1456),(26619,1456),(26620,1456),(26621,1456),(26622,1456),(26623,1456),(26624,1456),(26625,1457),(26626,1457),(26627,1457),(26628,1457),(26629,1457),(26630,1457),(26631,1457),(26632,1458),(26633,1458),(26634,1458),(26635,1458),(26636,1458),(26637,1458),(26638,1458),(26639,1459),(26640,1459),(26641,1459),(26642,1459),(26643,1459),(26644,1459),(26645,1459),(26646,1460),(26647,1460),(26648,1460),(26649,1460),(26650,1460),(26651,1460),(26652,1460),(26653,1461),(26654,1461),(26655,1461),(26656,1461),(26657,1461),(26658,1461),(26659,1461),(26660,1462),(26661,1462),(26662,1462),(26663,1462),(26664,1462),(26665,1462),(26666,1462),(26667,1463),(26668,1463),(26669,1463),(26670,1463),(26671,1463),(26672,1463),(26673,1463),(26674,1464),(26675,1464),(26676,1464),(26677,1464),(26678,1464),(26679,1464),(26680,1464),(26681,1465),(26682,1465),(26683,1465),(26684,1465),(26685,1465),(26686,1465),(26687,1465),(26688,1366),(26689,1366),(26690,1367),(26691,1367),(26692,1368),(26693,1368),(26694,1369),(26695,1369),(26696,1370),(26697,1370),(26698,1371),(26699,1371),(26700,1372),(26701,1372),(26702,1373),(26703,1373),(26704,1374),(26705,1374),(26706,1375),(26707,1375),(26708,1376),(26709,1376),(26710,1377),(26711,1377),(26712,1378),(26713,1378),(26714,1379),(26715,1379),(26716,1380),(26717,1380),(26718,1381),(26719,1381),(26720,1382),(26721,1382),(26722,1383),(26723,1383),(26724,1384),(26725,1384),(26726,1385),(26727,1385),(26728,1386),(26729,1386),(26730,1387),(26731,1387),(26732,1388),(26733,1388),(26734,1389),(26735,1389),(26736,1390),(26737,1390),(26738,1391),(26739,1391),(26740,1392),(26741,1392),(26742,1393),(26743,1393),(26744,1394),(26745,1394),(26746,1395),(26747,1395),(26748,1396),(26749,1396),(26750,1397),(26751,1397),(26752,1398),(26753,1398),(26754,1399),(26755,1399),(26756,1400),(26757,1400),(26758,1401),(26759,1401),(26760,1402),(26761,1402),(26762,1403),(26763,1403),(26764,1404),(26765,1404),(26766,1405),(26767,1405),(26768,1406),(26769,1406),(26770,1407),(26771,1407),(26772,1408),(26773,1408),(26774,1409),(26775,1409),(26776,1410),(26777,1410),(26778,1411),(26779,1411),(26780,1412),(26781,1412),(26782,1413),(26783,1413),(26784,1414),(26785,1414),(26786,1415),(26787,1415),(26788,1416),(26789,1416),(26790,1417),(26791,1417),(26792,1418),(26793,1418),(26794,1419),(26795,1419),(26796,1420),(26797,1420),(26798,1421),(26799,1421),(26800,1422),(26801,1422),(26802,1423),(26803,1423),(26804,1424),(26805,1424),(26806,1425),(26807,1425),(26808,1426),(26809,1426),(26810,1427),(26811,1427),(26812,1428),(26813,1428),(26814,1429),(26815,1429),(26816,1430),(26817,1430),(26818,1431),(26819,1431),(26820,1432),(26821,1432),(26822,1433),(26823,1433),(26824,1434),(26825,1434),(26826,1435),(26827,1435),(26828,1436),(26829,1436),(26830,1437),(26831,1437),(26832,1438),(26833,1438),(26834,1439),(26835,1439),(26836,1440),(26837,1440),(26838,1441),(26839,1441),(26840,1442),(26841,1442),(26842,1443),(26843,1443),(26844,1444),(26845,1444),(26846,1445),(26847,1445),(26848,1446),(26849,1446),(26850,1447),(26851,1447),(26852,1448),(26853,1448),(26854,1449),(26855,1449),(26856,1450),(26857,1450),(26858,1451),(26859,1451),(26860,1452),(26861,1452),(26862,1453),(26863,1453),(26864,1454),(26865,1454),(26866,1455),(26867,1455),(26868,1456),(26869,1456),(26870,1457),(26871,1457),(26872,1458),(26873,1458),(26874,1459),(26875,1459),(26876,1460),(26877,1460),(26878,1461),(26879,1461),(26880,1462),(26881,1462),(26882,1463),(26883,1463),(26884,1464),(26885,1464),(26886,1465),(26887,1465),(26888,1366),(26889,1366),(26890,1366),(26891,1367),(26892,1367),(26893,1367),(26894,1368),(26895,1368),(26896,1368),(26897,1369),(26898,1369),(26899,1369),(26900,1370),(26901,1370),(26902,1370),(26903,1371),(26904,1371),(26905,1371),(26906,1372),(26907,1372),(26908,1372),(26909,1373),(26910,1373),(26911,1373),(26912,1374),(26913,1374),(26914,1374),(26915,1375),(26916,1375),(26917,1375),(26918,1376),(26919,1376),(26920,1376),(26921,1377),(26922,1377),(26923,1377),(26924,1378),(26925,1378),(26926,1378),(26927,1379),(26928,1379),(26929,1379),(26930,1380),(26931,1380),(26932,1380),(26933,1381),(26934,1381),(26935,1381),(26936,1382),(26937,1382),(26938,1382),(26939,1383),(26940,1383),(26941,1383),(26942,1384),(26943,1384),(26944,1384),(26945,1385),(26946,1385),(26947,1385),(26948,1386),(26949,1386),(26950,1386),(26951,1387),(26952,1387),(26953,1387),(26954,1388),(26955,1388),(26956,1388),(26957,1389),(26958,1389),(26959,1389),(26960,1390),(26961,1390),(26962,1390),(26963,1391),(26964,1391),(26965,1391),(26966,1392),(26967,1392),(26968,1392),(26969,1393),(26970,1393),(26971,1393),(26972,1394),(26973,1394),(26974,1394),(26975,1395),(26976,1395),(26977,1395),(26978,1396),(26979,1396),(26980,1396),(26981,1397),(26982,1397),(26983,1397),(26984,1398),(26985,1398),(26986,1398),(26987,1399),(26988,1399),(26989,1399),(26990,1400),(26991,1400),(26992,1400),(26993,1401),(26994,1401),(26995,1401),(26996,1402),(26997,1402),(26998,1402),(26999,1403),(27000,1403),(27001,1403),(27002,1404),(27003,1404),(27004,1404),(27005,1405),(27006,1405),(27007,1405),(27008,1406),(27009,1406),(27010,1406),(27011,1407),(27012,1407),(27013,1407),(27014,1408),(27015,1408),(27016,1408),(27017,1409),(27018,1409),(27019,1409),(27020,1410),(27021,1410),(27022,1410),(27023,1411),(27024,1411),(27025,1411),(27026,1412),(27027,1412),(27028,1412),(27029,1413),(27030,1413),(27031,1413),(27032,1414),(27033,1414),(27034,1414),(27035,1415),(27036,1415),(27037,1415),(27038,1416),(27039,1416),(27040,1416),(27041,1417),(27042,1417),(27043,1417),(27044,1418),(27045,1418),(27046,1418),(27047,1419),(27048,1419),(27049,1419),(27050,1420),(27051,1420),(27052,1420),(27053,1421),(27054,1421),(27055,1421),(27056,1422),(27057,1422),(27058,1422),(27059,1423),(27060,1423),(27061,1423),(27062,1424),(27063,1424),(27064,1424),(27065,1425),(27066,1425),(27067,1425),(27068,1426),(27069,1426),(27070,1426),(27071,1427),(27072,1427),(27073,1427),(27074,1428),(27075,1428),(27076,1428),(27077,1429),(27078,1429),(27079,1429),(27080,1430),(27081,1430),(27082,1430),(27083,1431),(27084,1431),(27085,1431),(27086,1432),(27087,1432),(27088,1432),(27089,1433),(27090,1433),(27091,1433),(27092,1434),(27093,1434),(27094,1434),(27095,1435),(27096,1435),(27097,1435),(27098,1436),(27099,1436),(27100,1436),(27101,1437),(27102,1437),(27103,1437),(27104,1438),(27105,1438),(27106,1438),(27107,1439),(27108,1439),(27109,1439),(27110,1440),(27111,1440),(27112,1440),(27113,1441),(27114,1441),(27115,1441),(27116,1442),(27117,1442),(27118,1442),(27119,1443),(27120,1443),(27121,1443),(27122,1444),(27123,1444),(27124,1444),(27125,1445),(27126,1445),(27127,1445),(27128,1446),(27129,1446),(27130,1446),(27131,1447),(27132,1447),(27133,1447),(27134,1448),(27135,1448),(27136,1448),(27137,1449),(27138,1449),(27139,1449),(27140,1450),(27141,1450),(27142,1450),(27143,1451),(27144,1451),(27145,1451),(27146,1452),(27147,1452),(27148,1452),(27149,1453),(27150,1453),(27151,1453),(27152,1454),(27153,1454),(27154,1454),(27155,1455),(27156,1455),(27157,1455),(27158,1456),(27159,1456),(27160,1456),(27161,1457),(27162,1457),(27163,1457),(27164,1458),(27165,1458),(27166,1458),(27167,1459),(27168,1459),(27169,1459),(27170,1460),(27171,1460),(27172,1460),(27173,1461),(27174,1461),(27175,1461),(27176,1462),(27177,1462),(27178,1462),(27179,1463),(27180,1463),(27181,1463),(27182,1464),(27183,1464),(27184,1464),(27185,1465),(27186,1465),(27187,1465),(27188,1366),(27189,1366),(27190,1366),(27191,1366),(27192,1367),(27193,1367),(27194,1367),(27195,1367),(27196,1368),(27197,1368),(27198,1368),(27199,1368),(27200,1369),(27201,1369),(27202,1369),(27203,1369),(27204,1370),(27205,1370),(27206,1370),(27207,1370),(27208,1371),(27209,1371),(27210,1371),(27211,1371),(27212,1372),(27213,1372),(27214,1372),(27215,1372),(27216,1373),(27217,1373),(27218,1373),(27219,1373),(27220,1374),(27221,1374),(27222,1374),(27223,1374),(27224,1375),(27225,1375),(27226,1375),(27227,1375),(27228,1376),(27229,1376),(27230,1376),(27231,1376),(27232,1377),(27233,1377),(27234,1377),(27235,1377),(27236,1378),(27237,1378),(27238,1378),(27239,1378),(27240,1379),(27241,1379),(27242,1379),(27243,1379),(27244,1380),(27245,1380),(27246,1380),(27247,1380),(27248,1381),(27249,1381),(27250,1381),(27251,1381),(27252,1382),(27253,1382),(27254,1382),(27255,1382),(27256,1383),(27257,1383),(27258,1383),(27259,1383),(27260,1384),(27261,1384),(27262,1384),(27263,1384),(27264,1385),(27265,1385),(27266,1385),(27267,1385),(27268,1386),(27269,1386),(27270,1386),(27271,1386),(27272,1387),(27273,1387),(27274,1387),(27275,1387),(27276,1388),(27277,1388),(27278,1388),(27279,1388),(27280,1389),(27281,1389),(27282,1389),(27283,1389),(27284,1390),(27285,1390),(27286,1390),(27287,1390),(27288,1391),(27289,1391),(27290,1391),(27291,1391),(27292,1392),(27293,1392),(27294,1392),(27295,1392),(27296,1393),(27297,1393),(27298,1393),(27299,1393),(27300,1394),(27301,1394),(27302,1394),(27303,1394),(27304,1395),(27305,1395),(27306,1395),(27307,1395),(27308,1396),(27309,1396),(27310,1396),(27311,1396),(27312,1397),(27313,1397),(27314,1397),(27315,1397),(27316,1398),(27317,1398),(27318,1398),(27319,1398),(27320,1399),(27321,1399),(27322,1399),(27323,1399),(27324,1400),(27325,1400),(27326,1400),(27327,1400),(27328,1401),(27329,1401),(27330,1401),(27331,1401),(27332,1402),(27333,1402),(27334,1402),(27335,1402),(27336,1403),(27337,1403),(27338,1403),(27339,1403),(27340,1404),(27341,1404),(27342,1404),(27343,1404),(27344,1405),(27345,1405),(27346,1405),(27347,1405),(27348,1406),(27349,1406),(27350,1406),(27351,1406),(27352,1407),(27353,1407),(27354,1407),(27355,1407),(27356,1408),(27357,1408),(27358,1408),(27359,1408),(27360,1409),(27361,1409),(27362,1409),(27363,1409),(27364,1410),(27365,1410),(27366,1410),(27367,1410),(27368,1411),(27369,1411),(27370,1411),(27371,1411),(27372,1412),(27373,1412),(27374,1412),(27375,1412),(27376,1413),(27377,1413),(27378,1413),(27379,1413),(27380,1414),(27381,1414),(27382,1414),(27383,1414),(27384,1415),(27385,1415),(27386,1415),(27387,1415),(27388,1416),(27389,1416),(27390,1416),(27391,1416),(27392,1417),(27393,1417),(27394,1417),(27395,1417),(27396,1418),(27397,1418),(27398,1418),(27399,1418),(27400,1419),(27401,1419),(27402,1419),(27403,1419),(27404,1420),(27405,1420),(27406,1420),(27407,1420),(27408,1421),(27409,1421),(27410,1421),(27411,1421),(27412,1422),(27413,1422),(27414,1422),(27415,1422),(27416,1423),(27417,1423),(27418,1423),(27419,1423),(27420,1424),(27421,1424),(27422,1424),(27423,1424),(27424,1425),(27425,1425),(27426,1425),(27427,1425),(27428,1426),(27429,1426),(27430,1426),(27431,1426),(27432,1427),(27433,1427),(27434,1427),(27435,1427),(27436,1428),(27437,1428),(27438,1428),(27439,1428),(27440,1429),(27441,1429),(27442,1429),(27443,1429),(27444,1430),(27445,1430),(27446,1430),(27447,1430),(27448,1431),(27449,1431),(27450,1431),(27451,1431),(27452,1432),(27453,1432),(27454,1432),(27455,1432),(27456,1433),(27457,1433),(27458,1433),(27459,1433),(27460,1434),(27461,1434),(27462,1434),(27463,1434),(27464,1435),(27465,1435),(27466,1435),(27467,1435),(27468,1436),(27469,1436),(27470,1436),(27471,1436),(27472,1437),(27473,1437),(27474,1437),(27475,1437),(27476,1438),(27477,1438),(27478,1438),(27479,1438),(27480,1439),(27481,1439),(27482,1439),(27483,1439),(27484,1440),(27485,1440),(27486,1440),(27487,1440),(27488,1441),(27489,1441),(27490,1441),(27491,1441),(27492,1442),(27493,1442),(27494,1442),(27495,1442),(27496,1443),(27497,1443),(27498,1443),(27499,1443),(27500,1444),(27501,1444),(27502,1444),(27503,1444),(27504,1445),(27505,1445),(27506,1445),(27507,1445),(27508,1446),(27509,1446),(27510,1446),(27511,1446),(27512,1447),(27513,1447),(27514,1447),(27515,1447),(27516,1448),(27517,1448),(27518,1448),(27519,1448),(27520,1449),(27521,1449),(27522,1449),(27523,1449),(27524,1450),(27525,1450),(27526,1450),(27527,1450),(27528,1451),(27529,1451),(27530,1451),(27531,1451),(27532,1452),(27533,1452),(27534,1452),(27535,1452),(27536,1453),(27537,1453),(27538,1453),(27539,1453),(27540,1454),(27541,1454),(27542,1454),(27543,1454),(27544,1455),(27545,1455),(27546,1455),(27547,1455),(27548,1456),(27549,1456),(27550,1456),(27551,1456),(27552,1457),(27553,1457),(27554,1457),(27555,1457),(27556,1458),(27557,1458),(27558,1458),(27559,1458),(27560,1459),(27561,1459),(27562,1459),(27563,1459),(27564,1460),(27565,1460),(27566,1460),(27567,1460),(27568,1461),(27569,1461),(27570,1461),(27571,1461),(27572,1462),(27573,1462),(27574,1462),(27575,1462),(27576,1463),(27577,1463),(27578,1463),(27579,1463),(27580,1464),(27581,1464),(27582,1464),(27583,1464),(27584,1465),(27585,1465),(27586,1465),(27587,1465),(27588,1466),(27589,1467),(27590,1468),(27591,1469),(27592,1470),(27593,1471),(27594,1472),(27595,1473),(27596,1474),(27597,1475),(27598,1476),(27599,1477),(27600,1478),(27601,1479),(27602,1480),(27603,1481),(27604,1482),(27605,1483),(27606,1484),(27607,1485),(27608,1486),(27609,1487),(27610,1488),(27611,1489),(27612,1490),(27613,1491),(27614,1492),(27615,1493),(27616,1494),(27617,1495),(27618,1496),(27619,1497),(27620,1498),(27621,1499),(27622,1500),(27623,1501),(27624,1502),(27625,1503),(27626,1504),(27627,1505),(27628,1506),(27629,1507),(27630,1508),(27631,1509),(27632,1510),(27633,1511),(27634,1512),(27635,1513),(27636,1514),(27637,1515),(27638,1516),(27639,1517),(27640,1518),(27641,1519),(27642,1520),(27643,1521),(27644,1522),(27645,1523),(27646,1524),(27647,1525),(27648,1526),(27649,1527),(27650,1528),(27651,1529),(27652,1530),(27653,1531),(27654,1532),(27655,1533),(27656,1534),(27657,1535),(27658,1536),(27659,1537),(27660,1538),(27661,1539),(27662,1540),(27663,1541),(27664,1542),(27665,1543),(27666,1544),(27667,1545),(27668,1546),(27669,1547),(27670,1548),(27671,1549),(27672,1550),(27673,1551),(27674,1552),(27675,1553),(27676,1554),(27677,1555),(27678,1556),(27679,1557),(27680,1558),(27681,1559),(27682,1560),(27683,1561),(27684,1562),(27685,1563),(27686,1564),(27687,1565),(27688,1466),(27689,1467),(27690,1468),(27691,1469),(27692,1470),(27693,1471),(27694,1472),(27695,1473),(27696,1474),(27697,1475),(27698,1476),(27699,1477),(27700,1478),(27701,1479),(27702,1480),(27703,1481),(27704,1482),(27705,1483),(27706,1484),(27707,1485),(27708,1486),(27709,1487),(27710,1488),(27711,1489),(27712,1490),(27713,1491),(27714,1492),(27715,1493),(27716,1494),(27717,1495),(27718,1496),(27719,1497),(27720,1498),(27721,1499),(27722,1500),(27723,1501),(27724,1502),(27725,1503),(27726,1504),(27727,1505),(27728,1506),(27729,1507),(27730,1508),(27731,1509),(27732,1510),(27733,1511),(27734,1512),(27735,1513),(27736,1514),(27737,1515),(27738,1516),(27739,1517),(27740,1518),(27741,1519),(27742,1520),(27743,1521),(27744,1522),(27745,1523),(27746,1524),(27747,1525),(27748,1526),(27749,1527),(27750,1528),(27751,1529),(27752,1530),(27753,1531),(27754,1532),(27755,1533),(27756,1534),(27757,1535),(27758,1536),(27759,1537),(27760,1538),(27761,1539),(27762,1540),(27763,1541),(27764,1542),(27765,1543),(27766,1544),(27767,1545),(27768,1546),(27769,1547),(27770,1548),(27771,1549),(27772,1550),(27773,1551),(27774,1552),(27775,1553),(27776,1554),(27777,1555),(27778,1556),(27779,1557),(27780,1558),(27781,1559),(27782,1560),(27783,1561),(27784,1562),(27785,1563),(27786,1564),(27787,1565),(27788,1466),(27789,1466),(27790,1466),(27791,1466),(27792,1466),(27793,1466),(27794,1466),(27795,1467),(27796,1467),(27797,1467),(27798,1467),(27799,1467),(27800,1467),(27801,1467),(27802,1468),(27803,1468),(27804,1468),(27805,1468),(27806,1468),(27807,1468),(27808,1468),(27809,1469),(27810,1469),(27811,1469),(27812,1469),(27813,1469),(27814,1469),(27815,1469),(27816,1470),(27817,1470),(27818,1470),(27819,1470),(27820,1470),(27821,1470),(27822,1470),(27823,1471),(27824,1471),(27825,1471),(27826,1471),(27827,1471),(27828,1471),(27829,1471),(27830,1472),(27831,1472),(27832,1472),(27833,1472),(27834,1472),(27835,1472),(27836,1472),(27837,1473),(27838,1473),(27839,1473),(27840,1473),(27841,1473),(27842,1473),(27843,1473),(27844,1474),(27845,1474),(27846,1474),(27847,1474),(27848,1474),(27849,1474),(27850,1474),(27851,1475),(27852,1475),(27853,1475),(27854,1475),(27855,1475),(27856,1475),(27857,1475),(27858,1476),(27859,1476),(27860,1476),(27861,1476),(27862,1476),(27863,1476),(27864,1476),(27865,1477),(27866,1477),(27867,1477),(27868,1477),(27869,1477),(27870,1477),(27871,1477),(27872,1478),(27873,1478),(27874,1478),(27875,1478),(27876,1478),(27877,1478),(27878,1478),(27879,1479),(27880,1479),(27881,1479),(27882,1479),(27883,1479),(27884,1479),(27885,1479),(27886,1480),(27887,1480),(27888,1480),(27889,1480),(27890,1480),(27891,1480),(27892,1480),(27893,1481),(27894,1481),(27895,1481),(27896,1481),(27897,1481),(27898,1481),(27899,1481),(27900,1482),(27901,1482),(27902,1482),(27903,1482),(27904,1482),(27905,1482),(27906,1482),(27907,1483),(27908,1483),(27909,1483),(27910,1483),(27911,1483),(27912,1483),(27913,1483),(27914,1484),(27915,1484),(27916,1484),(27917,1484),(27918,1484),(27919,1484),(27920,1484),(27921,1485),(27922,1485),(27923,1485),(27924,1485),(27925,1485),(27926,1485),(27927,1485),(27928,1486),(27929,1486),(27930,1486),(27931,1486),(27932,1486),(27933,1486),(27934,1486),(27935,1487),(27936,1487),(27937,1487),(27938,1487),(27939,1487),(27940,1487),(27941,1487),(27942,1488),(27943,1488),(27944,1488),(27945,1488),(27946,1488),(27947,1488),(27948,1488),(27949,1489),(27950,1489),(27951,1489),(27952,1489),(27953,1489),(27954,1489),(27955,1489),(27956,1490),(27957,1490),(27958,1490),(27959,1490),(27960,1490),(27961,1490),(27962,1490),(27963,1491),(27964,1491),(27965,1491),(27966,1491),(27967,1491),(27968,1491),(27969,1491),(27970,1492),(27971,1492),(27972,1492),(27973,1492),(27974,1492),(27975,1492),(27976,1492),(27977,1493),(27978,1493),(27979,1493),(27980,1493),(27981,1493),(27982,1493),(27983,1493),(27984,1494),(27985,1494),(27986,1494),(27987,1494),(27988,1494),(27989,1494),(27990,1494),(27991,1495),(27992,1495),(27993,1495),(27994,1495),(27995,1495),(27996,1495),(27997,1495),(27998,1496),(27999,1496),(28000,1496),(28001,1496),(28002,1496),(28003,1496),(28004,1496),(28005,1496),(28006,1496),(28007,1497),(28008,1497),(28009,1497),(28010,1497),(28011,1497),(28012,1497),(28013,1497),(28014,1497),(28015,1497),(28016,1498),(28017,1498),(28018,1498),(28019,1498),(28020,1498),(28021,1498),(28022,1498),(28023,1498),(28024,1498),(28025,1499),(28026,1499),(28027,1499),(28028,1499),(28029,1499),(28030,1499),(28031,1499),(28032,1499),(28033,1499),(28034,1500),(28035,1500),(28036,1500),(28037,1500),(28038,1500),(28039,1500),(28040,1500),(28041,1501),(28042,1501),(28043,1501),(28044,1501),(28045,1501),(28046,1501),(28047,1501),(28048,1502),(28049,1502),(28050,1502),(28051,1502),(28052,1502),(28053,1502),(28054,1502),(28055,1503),(28056,1503),(28057,1503),(28058,1503),(28059,1503),(28060,1503),(28061,1503),(28062,1503),(28063,1503),(28064,1504),(28065,1504),(28066,1504),(28067,1504),(28068,1504),(28069,1504),(28070,1504),(28071,1505),(28072,1505),(28073,1505),(28074,1505),(28075,1505),(28076,1505),(28077,1505),(28078,1506),(28079,1506),(28080,1506),(28081,1506),(28082,1506),(28083,1506),(28084,1506),(28085,1506),(28086,1506),(28087,1507),(28088,1507),(28089,1507),(28090,1507),(28091,1507),(28092,1507),(28093,1507),(28094,1508),(28095,1508),(28096,1508),(28097,1508),(28098,1508),(28099,1508),(28100,1508),(28101,1509),(28102,1509),(28103,1509),(28104,1509),(28105,1509),(28106,1509),(28107,1509),(28108,1509),(28109,1509),(28110,1510),(28111,1510),(28112,1510),(28113,1510),(28114,1510),(28115,1510),(28116,1510),(28117,1511),(28118,1511),(28119,1511),(28120,1511),(28121,1511),(28122,1511),(28123,1511),(28124,1511),(28125,1511),(28126,1512),(28127,1512),(28128,1512),(28129,1512),(28130,1512),(28131,1512),(28132,1512),(28133,1512),(28134,1512),(28135,1513),(28136,1513),(28137,1513),(28138,1513),(28139,1513),(28140,1513),(28141,1513),(28142,1514),(28143,1514),(28144,1514),(28145,1514),(28146,1514),(28147,1514),(28148,1514),(28149,1514),(28150,1514),(28151,1515),(28152,1515),(28153,1515),(28154,1515),(28155,1515),(28156,1515),(28157,1515),(28158,1516),(28159,1516),(28160,1516),(28161,1516),(28162,1516),(28163,1516),(28164,1516),(28165,1517),(28166,1517),(28167,1517),(28168,1517),(28169,1517),(28170,1517),(28171,1517),(28172,1518),(28173,1518),(28174,1518),(28175,1518),(28176,1518),(28177,1518),(28178,1518),(28179,1519),(28180,1519),(28181,1519),(28182,1519),(28183,1519),(28184,1519),(28185,1519),(28186,1520),(28187,1520),(28188,1520),(28189,1520),(28190,1520),(28191,1520),(28192,1520),(28193,1521),(28194,1521),(28195,1521),(28196,1521),(28197,1521),(28198,1521),(28199,1521),(28200,1522),(28201,1522),(28202,1522),(28203,1522),(28204,1522),(28205,1522),(28206,1522),(28207,1523),(28208,1523),(28209,1523),(28210,1523),(28211,1523),(28212,1523),(28213,1523),(28214,1524),(28215,1524),(28216,1524),(28217,1524),(28218,1524),(28219,1524),(28220,1524),(28221,1525),(28222,1525),(28223,1525),(28224,1525),(28225,1525),(28226,1525),(28227,1525),(28228,1526),(28229,1526),(28230,1526),(28231,1526),(28232,1526),(28233,1526),(28234,1526),(28235,1527),(28236,1527),(28237,1527),(28238,1527),(28239,1527),(28240,1527),(28241,1527),(28242,1528),(28243,1528),(28244,1528),(28245,1528),(28246,1528),(28247,1528),(28248,1528),(28249,1529),(28250,1529),(28251,1529),(28252,1529),(28253,1529),(28254,1529),(28255,1529),(28256,1530),(28257,1530),(28258,1530),(28259,1530),(28260,1530),(28261,1530),(28262,1530),(28263,1531),(28264,1531),(28265,1531),(28266,1531),(28267,1531),(28268,1531),(28269,1531),(28270,1532),(28271,1532),(28272,1532),(28273,1532),(28274,1532),(28275,1532),(28276,1532),(28277,1533),(28278,1533),(28279,1533),(28280,1533),(28281,1533),(28282,1533),(28283,1533),(28284,1533),(28285,1533),(28286,1534),(28287,1534),(28288,1534),(28289,1534),(28290,1534),(28291,1534),(28292,1534),(28293,1535),(28294,1535),(28295,1535),(28296,1535),(28297,1535),(28298,1535),(28299,1535),(28300,1536),(28301,1536),(28302,1536),(28303,1536),(28304,1536),(28305,1536),(28306,1536),(28307,1537),(28308,1537),(28309,1537),(28310,1537),(28311,1537),(28312,1537),(28313,1537),(28314,1538),(28315,1538),(28316,1538),(28317,1538),(28318,1538),(28319,1538),(28320,1538),(28321,1539),(28322,1539),(28323,1539),(28324,1539),(28325,1539),(28326,1539),(28327,1539),(28328,1540),(28329,1540),(28330,1540),(28331,1540),(28332,1540),(28333,1540),(28334,1540),(28335,1541),(28336,1541),(28337,1541),(28338,1541),(28339,1541),(28340,1541),(28341,1541),(28342,1542),(28343,1542),(28344,1542),(28345,1542),(28346,1542),(28347,1542),(28348,1543),(28349,1543),(28350,1543),(28351,1543),(28352,1543),(28353,1543),(28354,1544),(28355,1544),(28356,1544),(28357,1544),(28358,1544),(28359,1544),(28360,1544),(28361,1545),(28362,1545),(28363,1545),(28364,1545),(28365,1545),(28366,1545),(28367,1546),(28368,1546),(28369,1546),(28370,1546),(28371,1546),(28372,1546),(28373,1546),(28374,1547),(28375,1547),(28376,1547),(28377,1547),(28378,1547),(28379,1547),(28380,1547),(28381,1548),(28382,1548),(28383,1548),(28384,1548),(28385,1548),(28386,1548),(28387,1548),(28388,1549),(28389,1549),(28390,1549),(28391,1549),(28392,1549),(28393,1549),(28394,1549),(28395,1550),(28396,1550),(28397,1550),(28398,1550),(28399,1550),(28400,1550),(28401,1550),(28402,1551),(28403,1551),(28404,1551),(28405,1551),(28406,1551),(28407,1551),(28408,1551),(28409,1552),(28410,1552),(28411,1552),(28412,1552),(28413,1552),(28414,1552),(28415,1552),(28416,1553),(28417,1553),(28418,1553),(28419,1553),(28420,1553),(28421,1553),(28422,1553),(28423,1554),(28424,1554),(28425,1554),(28426,1554),(28427,1554),(28428,1554),(28429,1554),(28430,1554),(28431,1554),(28432,1555),(28433,1555),(28434,1555),(28435,1555),(28436,1555),(28437,1555),(28438,1555),(28439,1556),(28440,1556),(28441,1556),(28442,1556),(28443,1556),(28444,1556),(28445,1556),(28446,1557),(28447,1557),(28448,1557),(28449,1557),(28450,1557),(28451,1557),(28452,1557),(28453,1558),(28454,1558),(28455,1558),(28456,1558),(28457,1558),(28458,1558),(28459,1558),(28460,1559),(28461,1559),(28462,1559),(28463,1559),(28464,1559),(28465,1559),(28466,1559),(28467,1560),(28468,1560),(28469,1560),(28470,1560),(28471,1560),(28472,1560),(28473,1560),(28474,1561),(28475,1561),(28476,1561),(28477,1561),(28478,1561),(28479,1561),(28480,1561),(28481,1562),(28482,1562),(28483,1562),(28484,1562),(28485,1562),(28486,1562),(28487,1562),(28488,1563),(28489,1563),(28490,1563),(28491,1563),(28492,1563),(28493,1563),(28494,1563),(28495,1564),(28496,1564),(28497,1564),(28498,1564),(28499,1564),(28500,1564),(28501,1564),(28502,1564),(28503,1564),(28504,1565),(28505,1565),(28506,1565),(28507,1565),(28508,1565),(28509,1565),(28510,1565),(28511,1565),(28512,1565),(28513,1466),(28514,1466),(28515,1467),(28516,1467),(28517,1468),(28518,1468),(28519,1469),(28520,1469),(28521,1470),(28522,1470),(28523,1471),(28524,1471),(28525,1472),(28526,1472),(28527,1473),(28528,1473),(28529,1474),(28530,1474),(28531,1475),(28532,1475),(28533,1476),(28534,1476),(28535,1477),(28536,1477),(28537,1478),(28538,1478),(28539,1479),(28540,1479),(28541,1480),(28542,1480),(28543,1481),(28544,1481),(28545,1482),(28546,1482),(28547,1483),(28548,1483),(28549,1484),(28550,1484),(28551,1485),(28552,1485),(28553,1486),(28554,1486),(28555,1487),(28556,1487),(28557,1488),(28558,1488),(28559,1489),(28560,1489),(28561,1490),(28562,1490),(28563,1491),(28564,1491),(28565,1492),(28566,1492),(28567,1493),(28568,1493),(28569,1494),(28570,1494),(28571,1495),(28572,1495),(28573,1495),(28574,1496),(28575,1496),(28576,1497),(28577,1497),(28578,1497),(28579,1498),(28580,1498),(28581,1498),(28582,1499),(28583,1499),(28584,1499),(28585,1500),(28586,1500),(28587,1500),(28588,1501),(28589,1501),(28590,1501),(28591,1502),(28592,1502),(28593,1502),(28594,1503),(28595,1503),(28596,1503),(28597,1504),(28598,1504),(28599,1504),(28600,1505),(28601,1505),(28602,1505),(28603,1506),(28604,1506),(28605,1506),(28606,1507),(28607,1507),(28608,1507),(28609,1508),(28610,1508),(28611,1508),(28612,1509),(28613,1509),(28614,1509),(28615,1510),(28616,1510),(28617,1510),(28618,1511),(28619,1511),(28620,1511),(28621,1512),(28622,1512),(28623,1512),(28624,1513),(28625,1513),(28626,1513),(28627,1514),(28628,1514),(28629,1514),(28630,1515),(28631,1515),(28632,1516),(28633,1516),(28634,1517),(28635,1517),(28636,1518),(28637,1518),(28638,1519),(28639,1519),(28640,1520),(28641,1520),(28642,1521),(28643,1521),(28644,1522),(28645,1522),(28646,1523),(28647,1523),(28648,1524),(28649,1524),(28650,1525),(28651,1525),(28652,1526),(28653,1526),(28654,1527),(28655,1527),(28656,1528),(28657,1528),(28658,1529),(28659,1529),(28660,1530),(28661,1530),(28662,1531),(28663,1531),(28664,1532),(28665,1532),(28666,1533),(28667,1533),(28668,1534),(28669,1534),(28670,1535),(28671,1535),(28672,1536),(28673,1536),(28674,1537),(28675,1537),(28676,1538),(28677,1538),(28678,1539),(28679,1539),(28680,1540),(28681,1540),(28682,1541),(28683,1541),(28684,1542),(28685,1542),(28686,1543),(28687,1543),(28688,1544),(28689,1544),(28690,1545),(28691,1545),(28692,1546),(28693,1546),(28694,1547),(28695,1547),(28696,1548),(28697,1548),(28698,1549),(28699,1549),(28700,1550),(28701,1550),(28702,1551),(28703,1551),(28704,1552),(28705,1552),(28706,1553),(28707,1553),(28708,1554),(28709,1554),(28710,1555),(28711,1555),(28712,1556),(28713,1556),(28714,1557),(28715,1557),(28716,1558),(28717,1558),(28718,1559),(28719,1559),(28720,1560),(28721,1560),(28722,1561),(28723,1561),(28724,1562),(28725,1562),(28726,1563),(28727,1563),(28728,1564),(28729,1564),(28730,1565),(28731,1565),(28732,1466),(28733,1466),(28734,1466),(28735,1467),(28736,1467),(28737,1467),(28738,1468),(28739,1468),(28740,1468),(28741,1469),(28742,1469),(28743,1469),(28744,1470),(28745,1470),(28746,1470),(28747,1471),(28748,1471),(28749,1471),(28750,1472),(28751,1472),(28752,1472),(28753,1473),(28754,1473),(28755,1473),(28756,1474),(28757,1474),(28758,1474),(28759,1475),(28760,1475),(28761,1475),(28762,1476),(28763,1476),(28764,1476),(28765,1477),(28766,1477),(28767,1477),(28768,1478),(28769,1478),(28770,1478),(28771,1479),(28772,1479),(28773,1479),(28774,1480),(28775,1480),(28776,1480),(28777,1481),(28778,1481),(28779,1481),(28780,1482),(28781,1482),(28782,1482),(28783,1483),(28784,1483),(28785,1483),(28786,1484),(28787,1484),(28788,1484),(28789,1485),(28790,1485),(28791,1485),(28792,1486),(28793,1486),(28794,1486),(28795,1487),(28796,1487),(28797,1487),(28798,1488),(28799,1488),(28800,1488),(28801,1489),(28802,1489),(28803,1489),(28804,1490),(28805,1490),(28806,1490),(28807,1491),(28808,1491),(28809,1491),(28810,1492),(28811,1492),(28812,1492),(28813,1493),(28814,1493),(28815,1493),(28816,1494),(28817,1494),(28818,1494),(28819,1495),(28820,1495),(28821,1496),(28822,1496),(28823,1496),(28824,1497),(28825,1497),(28826,1498),(28827,1498),(28828,1499),(28829,1499),(28830,1500),(28831,1500),(28832,1501),(28833,1501),(28834,1502),(28835,1502),(28836,1503),(28837,1503),(28838,1504),(28839,1504),(28840,1505),(28841,1505),(28842,1506),(28843,1506),(28844,1507),(28845,1507),(28846,1508),(28847,1508),(28848,1509),(28849,1509),(28850,1510),(28851,1510),(28852,1511),(28853,1511),(28854,1512),(28855,1512),(28856,1513),(28857,1513),(28858,1514),(28859,1514),(28860,1515),(28861,1515),(28862,1515),(28863,1516),(28864,1516),(28865,1516),(28866,1517),(28867,1517),(28868,1517),(28869,1518),(28870,1518),(28871,1518),(28872,1519),(28873,1519),(28874,1519),(28875,1520),(28876,1520),(28877,1520),(28878,1521),(28879,1521),(28880,1521),(28881,1522),(28882,1522),(28883,1522),(28884,1523),(28885,1523),(28886,1523),(28887,1524),(28888,1524),(28889,1524),(28890,1525),(28891,1525),(28892,1525),(28893,1526),(28894,1526),(28895,1526),(28896,1527),(28897,1527),(28898,1527),(28899,1528),(28900,1528),(28901,1528),(28902,1529),(28903,1529),(28904,1529),(28905,1530),(28906,1530),(28907,1530),(28908,1531),(28909,1531),(28910,1531),(28911,1532),(28912,1532),(28913,1532),(28914,1533),(28915,1533),(28916,1533),(28917,1534),(28918,1534),(28919,1534),(28920,1535),(28921,1535),(28922,1535),(28923,1536),(28924,1536),(28925,1536),(28926,1537),(28927,1537),(28928,1537),(28929,1538),(28930,1538),(28931,1538),(28932,1539),(28933,1539),(28934,1539),(28935,1540),(28936,1540),(28937,1540),(28938,1541),(28939,1541),(28940,1541),(28941,1542),(28942,1542),(28943,1542),(28944,1543),(28945,1543),(28946,1543),(28947,1544),(28948,1544),(28949,1544),(28950,1545),(28951,1545),(28952,1545),(28953,1546),(28954,1546),(28955,1546),(28956,1547),(28957,1547),(28958,1547),(28959,1548),(28960,1548),(28961,1548),(28962,1549),(28963,1549),(28964,1549),(28965,1550),(28966,1550),(28967,1550),(28968,1551),(28969,1551),(28970,1551),(28971,1552),(28972,1552),(28973,1552),(28974,1553),(28975,1553),(28976,1553),(28977,1554),(28978,1554),(28979,1554),(28980,1555),(28981,1555),(28982,1555),(28983,1556),(28984,1556),(28985,1556),(28986,1557),(28987,1557),(28988,1557),(28989,1558),(28990,1558),(28991,1558),(28992,1559),(28993,1559),(28994,1559),(28995,1560),(28996,1560),(28997,1560),(28998,1561),(28999,1561),(29000,1561),(29001,1562),(29002,1562),(29003,1562),(29004,1563),(29005,1563),(29006,1563),(29007,1564),(29008,1564),(29009,1564),(29010,1565),(29011,1565),(29012,1565),(29013,1466),(29014,1466),(29015,1466),(29016,1466),(29017,1467),(29018,1467),(29019,1467),(29020,1467),(29021,1468),(29022,1468),(29023,1468),(29024,1468),(29025,1469),(29026,1469),(29027,1469),(29028,1469),(29029,1470),(29030,1470),(29031,1470),(29032,1470),(29033,1471),(29034,1471),(29035,1471),(29036,1471),(29037,1472),(29038,1472),(29039,1472),(29040,1472),(29041,1473),(29042,1473),(29043,1473),(29044,1473),(29045,1474),(29046,1474),(29047,1474),(29048,1474),(29049,1475),(29050,1475),(29051,1475),(29052,1475),(29053,1476),(29054,1476),(29055,1476),(29056,1476),(29057,1477),(29058,1477),(29059,1477),(29060,1477),(29061,1478),(29062,1478),(29063,1478),(29064,1478),(29065,1479),(29066,1479),(29067,1479),(29068,1479),(29069,1480),(29070,1480),(29071,1480),(29072,1480),(29073,1481),(29074,1481),(29075,1481),(29076,1481),(29077,1482),(29078,1482),(29079,1482),(29080,1482),(29081,1483),(29082,1483),(29083,1483),(29084,1483),(29085,1484),(29086,1484),(29087,1484),(29088,1484),(29089,1485),(29090,1485),(29091,1485),(29092,1485),(29093,1486),(29094,1486),(29095,1486),(29096,1486),(29097,1487),(29098,1487),(29099,1487),(29100,1487),(29101,1488),(29102,1488),(29103,1488),(29104,1488),(29105,1489),(29106,1489),(29107,1489),(29108,1489),(29109,1490),(29110,1490),(29111,1490),(29112,1490),(29113,1491),(29114,1491),(29115,1491),(29116,1491),(29117,1492),(29118,1492),(29119,1492),(29120,1492),(29121,1493),(29122,1493),(29123,1493),(29124,1493),(29125,1494),(29126,1494),(29127,1494),(29128,1494),(29129,1495),(29130,1495),(29131,1495),(29132,1495),(29133,1496),(29134,1496),(29135,1496),(29136,1496),(29137,1497),(29138,1497),(29139,1497),(29140,1497),(29141,1498),(29142,1498),(29143,1498),(29144,1498),(29145,1499),(29146,1499),(29147,1499),(29148,1499),(29149,1500),(29150,1500),(29151,1500),(29152,1500),(29153,1501),(29154,1501),(29155,1501),(29156,1501),(29157,1502),(29158,1502),(29159,1502),(29160,1502),(29161,1503),(29162,1503),(29163,1503),(29164,1503),(29165,1504),(29166,1504),(29167,1504),(29168,1504),(29169,1505),(29170,1505),(29171,1505),(29172,1505),(29173,1506),(29174,1506),(29175,1506),(29176,1506),(29177,1507),(29178,1507),(29179,1507),(29180,1507),(29181,1508),(29182,1508),(29183,1508),(29184,1508),(29185,1509),(29186,1509),(29187,1509),(29188,1509),(29189,1510),(29190,1510),(29191,1510),(29192,1510),(29193,1511),(29194,1511),(29195,1511),(29196,1511),(29197,1512),(29198,1512),(29199,1512),(29200,1512),(29201,1513),(29202,1513),(29203,1513),(29204,1513),(29205,1514),(29206,1514),(29207,1514),(29208,1514),(29209,1515),(29210,1515),(29211,1515),(29212,1515),(29213,1516),(29214,1516),(29215,1516),(29216,1516),(29217,1517),(29218,1517),(29219,1517),(29220,1517),(29221,1518),(29222,1518),(29223,1518),(29224,1518),(29225,1519),(29226,1519),(29227,1519),(29228,1519),(29229,1520),(29230,1520),(29231,1520),(29232,1520),(29233,1521),(29234,1521),(29235,1521),(29236,1521),(29237,1522),(29238,1522),(29239,1522),(29240,1522),(29241,1523),(29242,1523),(29243,1523),(29244,1523),(29245,1524),(29246,1524),(29247,1524),(29248,1524),(29249,1525),(29250,1525),(29251,1525),(29252,1525),(29253,1526),(29254,1526),(29255,1526),(29256,1526),(29257,1527),(29258,1527),(29259,1527),(29260,1527),(29261,1528),(29262,1528),(29263,1528),(29264,1528),(29265,1529),(29266,1529),(29267,1529),(29268,1529),(29269,1530),(29270,1530),(29271,1530),(29272,1530),(29273,1531),(29274,1531),(29275,1531),(29276,1531),(29277,1532),(29278,1532),(29279,1532),(29280,1532),(29281,1533),(29282,1533),(29283,1533),(29284,1533),(29285,1534),(29286,1534),(29287,1534),(29288,1534),(29289,1535),(29290,1535),(29291,1535),(29292,1535),(29293,1536),(29294,1536),(29295,1536),(29296,1536),(29297,1537),(29298,1537),(29299,1537),(29300,1537),(29301,1538),(29302,1538),(29303,1538),(29304,1538),(29305,1539),(29306,1539),(29307,1539),(29308,1539),(29309,1540),(29310,1540),(29311,1540),(29312,1540),(29313,1541),(29314,1541),(29315,1541),(29316,1541),(29317,1542),(29318,1542),(29319,1542),(29320,1542),(29321,1543),(29322,1543),(29323,1543),(29324,1543),(29325,1544),(29326,1544),(29327,1544),(29328,1544),(29329,1545),(29330,1545),(29331,1545),(29332,1545),(29333,1546),(29334,1546),(29335,1546),(29336,1546),(29337,1547),(29338,1547),(29339,1547),(29340,1547),(29341,1548),(29342,1548),(29343,1548),(29344,1548),(29345,1549),(29346,1549),(29347,1549),(29348,1549),(29349,1550),(29350,1550),(29351,1550),(29352,1550),(29353,1551),(29354,1551),(29355,1551),(29356,1551),(29357,1552),(29358,1552),(29359,1552),(29360,1552),(29361,1553),(29362,1553),(29363,1553),(29364,1553),(29365,1554),(29366,1554),(29367,1554),(29368,1554),(29369,1555),(29370,1555),(29371,1555),(29372,1555),(29373,1556),(29374,1556),(29375,1556),(29376,1556),(29377,1557),(29378,1557),(29379,1557),(29380,1557),(29381,1558),(29382,1558),(29383,1558),(29384,1558),(29385,1559),(29386,1559),(29387,1559),(29388,1559),(29389,1560),(29390,1560),(29391,1560),(29392,1560),(29393,1561),(29394,1561),(29395,1561),(29396,1561),(29397,1562),(29398,1562),(29399,1562),(29400,1562),(29401,1563),(29402,1563),(29403,1563),(29404,1563),(29405,1564),(29406,1564),(29407,1564),(29408,1564),(29409,1565),(29410,1565),(29411,1565),(29412,1565),(29413,1566),(29414,1567),(29415,1568),(29416,1569),(29417,1570),(29418,1571),(29419,1572),(29420,1573),(29421,1574),(29422,1575),(29423,1576),(29424,1577),(29425,1578),(29426,1579),(29427,1580),(29428,1581),(29429,1582),(29430,1583),(29431,1584),(29432,1585),(29433,1586),(29434,1587),(29435,1588),(29436,1589),(29437,1590),(29438,1591),(29439,1592),(29440,1593),(29441,1594),(29442,1595),(29443,1596),(29444,1597),(29445,1598),(29446,1599),(29447,1600),(29448,1601),(29449,1602),(29450,1603),(29451,1604),(29452,1605),(29453,1606),(29454,1607),(29455,1608),(29456,1609),(29457,1610),(29458,1611),(29459,1612),(29460,1613),(29461,1614),(29462,1615),(29463,1616),(29464,1617),(29465,1618),(29466,1619),(29467,1620),(29468,1621),(29469,1622),(29470,1623),(29471,1624),(29472,1625),(29473,1626),(29474,1627),(29475,1628),(29476,1629),(29477,1630),(29478,1631),(29479,1632),(29480,1633),(29481,1634),(29482,1635),(29483,1636),(29484,1637),(29485,1638),(29486,1639),(29487,1640),(29488,1641),(29489,1642),(29490,1643),(29491,1644),(29492,1645),(29493,1646),(29494,1647),(29495,1648),(29496,1649),(29497,1650),(29498,1651),(29499,1652),(29500,1653),(29501,1654),(29502,1655),(29503,1656),(29504,1657),(29505,1658),(29506,1659),(29507,1660),(29508,1661),(29509,1662),(29510,1663),(29511,1664),(29512,1665),(29513,1566),(29514,1567),(29515,1568),(29516,1569),(29517,1570),(29518,1571),(29519,1572),(29520,1573),(29521,1574),(29522,1575),(29523,1576),(29524,1577),(29525,1578),(29526,1579),(29527,1580),(29528,1581),(29529,1582),(29530,1583),(29531,1584),(29532,1585),(29533,1586),(29534,1587),(29535,1588),(29536,1589),(29537,1590),(29538,1591),(29539,1592),(29540,1593),(29541,1594),(29542,1595),(29543,1596),(29544,1597),(29545,1598),(29546,1599),(29547,1600),(29548,1601),(29549,1602),(29550,1603),(29551,1604),(29552,1605),(29553,1606),(29554,1607),(29555,1608),(29556,1609),(29557,1610),(29558,1611),(29559,1612),(29560,1613),(29561,1614),(29562,1615),(29563,1616),(29564,1617),(29565,1618),(29566,1619),(29567,1620),(29568,1621),(29569,1622),(29570,1623),(29571,1624),(29572,1625),(29573,1626),(29574,1627),(29575,1628),(29576,1629),(29577,1630),(29578,1631),(29579,1632),(29580,1633),(29581,1634),(29582,1635),(29583,1636),(29584,1637),(29585,1638),(29586,1639),(29587,1640),(29588,1641),(29589,1642),(29590,1643),(29591,1644),(29592,1645),(29593,1646),(29594,1647),(29595,1648),(29596,1649),(29597,1650),(29598,1651),(29599,1652),(29600,1653),(29601,1654),(29602,1655),(29603,1656),(29604,1657),(29605,1658),(29606,1659),(29607,1660),(29608,1661),(29609,1662),(29610,1663),(29611,1664),(29612,1665),(29613,1566),(29614,1566),(29615,1566),(29616,1566),(29617,1566),(29618,1566),(29619,1566),(29620,1566),(29621,1566),(29622,1567),(29623,1567),(29624,1567),(29625,1567),(29626,1567),(29627,1567),(29628,1567),(29629,1567),(29630,1568),(29631,1568),(29632,1568),(29633,1568),(29634,1568),(29635,1568),(29636,1568),(29637,1568),(29638,1568),(29639,1569),(29640,1569),(29641,1569),(29642,1569),(29643,1569),(29644,1569),(29645,1569),(29646,1569),(29647,1569),(29648,1570),(29649,1570),(29650,1570),(29651,1570),(29652,1570),(29653,1570),(29654,1570),(29655,1570),(29656,1570),(29657,1571),(29658,1571),(29659,1571),(29660,1571),(29661,1571),(29662,1571),(29663,1571),(29664,1571),(29665,1571),(29666,1572),(29667,1572),(29668,1572),(29669,1572),(29670,1572),(29671,1572),(29672,1572),(29673,1572),(29674,1572),(29675,1573),(29676,1573),(29677,1573),(29678,1573),(29679,1573),(29680,1573),(29681,1573),(29682,1573),(29683,1573),(29684,1574),(29685,1574),(29686,1574),(29687,1574),(29688,1574),(29689,1574),(29690,1574),(29691,1574),(29692,1574),(29693,1575),(29694,1575),(29695,1575),(29696,1575),(29697,1575),(29698,1575),(29699,1575),(29700,1576),(29701,1576),(29702,1576),(29703,1576),(29704,1576),(29705,1576),(29706,1576),(29707,1577),(29708,1577),(29709,1577),(29710,1577),(29711,1577),(29712,1577),(29713,1577),(29714,1578),(29715,1578),(29716,1578),(29717,1578),(29718,1578),(29719,1578),(29720,1578),(29721,1578),(29722,1578),(29723,1579),(29724,1579),(29725,1579),(29726,1579),(29727,1580),(29728,1580),(29729,1580),(29730,1580),(29731,1580),(29732,1580),(29733,1580),(29734,1581),(29735,1581),(29736,1581),(29737,1581),(29738,1581),(29739,1581),(29740,1581),(29741,1582),(29742,1582),(29743,1582),(29744,1582),(29745,1582),(29746,1582),(29747,1582),(29748,1583),(29749,1583),(29750,1583),(29751,1583),(29752,1583),(29753,1583),(29754,1583),(29755,1584),(29756,1584),(29757,1584),(29758,1584),(29759,1584),(29760,1584),(29761,1584),(29762,1584),(29763,1585),(29764,1585),(29765,1585),(29766,1585),(29767,1585),(29768,1585),(29769,1585),(29770,1585),(29771,1586),(29772,1586),(29773,1586),(29774,1586),(29775,1586),(29776,1586),(29777,1586),(29778,1586),(29779,1587),(29780,1587),(29781,1587),(29782,1587),(29783,1587),(29784,1587),(29785,1587),(29786,1588),(29787,1588),(29788,1588),(29789,1588),(29790,1588),(29791,1588),(29792,1588),(29793,1588),(29794,1588),(29795,1589),(29796,1589),(29797,1589),(29798,1589),(29799,1589),(29800,1589),(29801,1589),(29802,1589),(29803,1589),(29804,1590),(29805,1590),(29806,1590),(29807,1590),(29808,1590),(29809,1590),(29810,1590),(29811,1590),(29812,1590),(29813,1591),(29814,1591),(29815,1591),(29816,1591),(29817,1591),(29818,1591),(29819,1591),(29820,1591),(29821,1591),(29822,1592),(29823,1592),(29824,1592),(29825,1592),(29826,1592),(29827,1592),(29828,1592),(29829,1592),(29830,1592),(29831,1593),(29832,1593),(29833,1593),(29834,1593),(29835,1593),(29836,1593),(29837,1593),(29838,1593),(29839,1593),(29840,1594),(29841,1594),(29842,1594),(29843,1594),(29844,1594),(29845,1594),(29846,1594),(29847,1594),(29848,1594),(29849,1595),(29850,1595),(29851,1595),(29852,1595),(29853,1595),(29854,1595),(29855,1595),(29856,1595),(29857,1595),(29858,1596),(29859,1596),(29860,1596),(29861,1596),(29862,1596),(29863,1596),(29864,1596),(29865,1596),(29866,1596),(29867,1597),(29868,1597),(29869,1597),(29870,1597),(29871,1597),(29872,1597),(29873,1597),(29874,1597),(29875,1597),(29876,1598),(29877,1598),(29878,1598),(29879,1598),(29880,1598),(29881,1598),(29882,1598),(29883,1598),(29884,1598),(29885,1599),(29886,1599),(29887,1599),(29888,1599),(29889,1599),(29890,1599),(29891,1599),(29892,1599),(29893,1599),(29894,1600),(29895,1600),(29896,1600),(29897,1600),(29898,1600),(29899,1600),(29900,1600),(29901,1600),(29902,1601),(29903,1601),(29904,1601),(29905,1601),(29906,1601),(29907,1601),(29908,1601),(29909,1601),(29910,1602),(29911,1602),(29912,1602),(29913,1602),(29914,1602),(29915,1602),(29916,1602),(29917,1602),(29918,1603),(29919,1603),(29920,1603),(29921,1603),(29922,1603),(29923,1603),(29924,1603),(29925,1603),(29926,1603),(29927,1604),(29928,1604),(29929,1604),(29930,1604),(29931,1604),(29932,1604),(29933,1604),(29934,1604),(29935,1604),(29936,1605),(29937,1605),(29938,1605),(29939,1605),(29940,1605),(29941,1605),(29942,1605),(29943,1605),(29944,1606),(29945,1606),(29946,1606),(29947,1606),(29948,1606),(29949,1606),(29950,1606),(29951,1606),(29952,1607),(29953,1607),(29954,1607),(29955,1607),(29956,1607),(29957,1607),(29958,1607),(29959,1607),(29960,1607),(29961,1608),(29962,1608),(29963,1608),(29964,1608),(29965,1608),(29966,1608),(29967,1608),(29968,1608),(29969,1609),(29970,1609),(29971,1609),(29972,1609),(29973,1609),(29974,1609),(29975,1609),(29976,1609),(29977,1610),(29978,1610),(29979,1610),(29980,1610),(29981,1610),(29982,1610),(29983,1610),(29984,1610),(29985,1610),(29986,1611),(29987,1611),(29988,1611),(29989,1611),(29990,1611),(29991,1611),(29992,1611),(29993,1612),(29994,1612),(29995,1612),(29996,1612),(29997,1612),(29998,1612),(29999,1613),(30000,1613),(30001,1613),(30002,1613),(30003,1613),(30004,1613),(30005,1613),(30006,1614),(30007,1614),(30008,1614),(30009,1614),(30010,1614),(30011,1614),(30012,1615),(30013,1615),(30014,1615),(30015,1615),(30016,1615),(30017,1615),(30018,1615),(30019,1616),(30020,1616),(30021,1616),(30022,1616),(30023,1616),(30024,1616),(30025,1616),(30026,1617),(30027,1617),(30028,1617),(30029,1617),(30030,1617),(30031,1617),(30032,1617),(30033,1618),(30034,1618),(30035,1618),(30036,1618),(30037,1618),(30038,1618),(30039,1618),(30040,1618),(30041,1618),(30042,1619),(30043,1619),(30044,1619),(30045,1619),(30046,1619),(30047,1619),(30048,1619),(30049,1619),(30050,1619),(30051,1620),(30052,1620),(30053,1620),(30054,1620),(30055,1620),(30056,1620),(30057,1620),(30058,1620),(30059,1620),(30060,1621),(30061,1621),(30062,1621),(30063,1621),(30064,1621),(30065,1621),(30066,1621),(30067,1621),(30068,1621),(30069,1622),(30070,1622),(30071,1622),(30072,1622),(30073,1622),(30074,1622),(30075,1622),(30076,1622),(30077,1623),(30078,1623),(30079,1623),(30080,1623),(30081,1623),(30082,1623),(30083,1623),(30084,1623),(30085,1623),(30086,1624),(30087,1624),(30088,1624),(30089,1624),(30090,1624),(30091,1624),(30092,1624),(30093,1624),(30094,1625),(30095,1625),(30096,1625),(30097,1625),(30098,1625),(30099,1625),(30100,1625),(30101,1625),(30102,1626),(30103,1626),(30104,1626),(30105,1626),(30106,1626),(30107,1626),(30108,1626),(30109,1626),(30110,1626),(30111,1627),(30112,1627),(30113,1627),(30114,1627),(30115,1627),(30116,1627),(30117,1627),(30118,1627),(30119,1627),(30120,1628),(30121,1628),(30122,1628),(30123,1628),(30124,1628),(30125,1628),(30126,1628),(30127,1628),(30128,1629),(30129,1629),(30130,1629),(30131,1629),(30132,1629),(30133,1629),(30134,1629),(30135,1629),(30136,1629),(30137,1630),(30138,1630),(30139,1630),(30140,1630),(30141,1630),(30142,1630),(30143,1631),(30144,1631),(30145,1631),(30146,1631),(30147,1631),(30148,1631),(30149,1631),(30150,1631),(30151,1631),(30152,1632),(30153,1632),(30154,1632),(30155,1632),(30156,1632),(30157,1632),(30158,1632),(30159,1632),(30160,1632),(30161,1633),(30162,1633),(30163,1633),(30164,1633),(30165,1633),(30166,1633),(30167,1634),(30168,1634),(30169,1634),(30170,1634),(30171,1634),(30172,1634),(30173,1634),(30174,1634),(30175,1634),(30176,1635),(30177,1635),(30178,1635),(30179,1635),(30180,1635),(30181,1635),(30182,1635),(30183,1635),(30184,1635),(30185,1636),(30186,1636),(30187,1636),(30188,1636),(30189,1636),(30190,1636),(30191,1636),(30192,1636),(30193,1636),(30194,1637),(30195,1637),(30196,1637),(30197,1637),(30198,1637),(30199,1637),(30200,1637),(30201,1637),(30202,1637),(30203,1638),(30204,1638),(30205,1638),(30206,1638),(30207,1638),(30208,1638),(30209,1638),(30210,1638),(30211,1638),(30212,1639),(30213,1639),(30214,1639),(30215,1639),(30216,1639),(30217,1639),(30218,1639),(30219,1639),(30220,1639),(30221,1640),(30222,1640),(30223,1640),(30224,1640),(30225,1640),(30226,1640),(30227,1640),(30228,1640),(30229,1640),(30230,1641),(30231,1641),(30232,1641),(30233,1641),(30234,1641),(30235,1641),(30236,1642),(30237,1642),(30238,1642),(30239,1642),(30240,1642),(30241,1642),(30242,1643),(30243,1643),(30244,1643),(30245,1643),(30246,1643),(30247,1643),(30248,1643),(30249,1643),(30250,1643),(30251,1644),(30252,1644),(30253,1644),(30254,1644),(30255,1644),(30256,1644),(30257,1644),(30258,1644),(30259,1644),(30260,1645),(30261,1645),(30262,1645),(30263,1645),(30264,1645),(30265,1645),(30266,1645),(30267,1645),(30268,1645),(30269,1646),(30270,1646),(30271,1646),(30272,1646),(30273,1646),(30274,1646),(30275,1646),(30276,1646),(30277,1646),(30278,1647),(30279,1647),(30280,1647),(30281,1647),(30282,1647),(30283,1647),(30284,1647),(30285,1647),(30286,1647),(30287,1648),(30288,1648),(30289,1648),(30290,1648),(30291,1648),(30292,1648),(30293,1648),(30294,1648),(30295,1648),(30296,1649),(30297,1649),(30298,1649),(30299,1649),(30300,1649),(30301,1649),(30302,1649),(30303,1649),(30304,1649),(30305,1650),(30306,1650),(30307,1650),(30308,1650),(30309,1650),(30310,1650),(30311,1650),(30312,1651),(30313,1651),(30314,1651),(30315,1651),(30316,1651),(30317,1651),(30318,1651),(30319,1651),(30320,1651),(30321,1652),(30322,1652),(30323,1652),(30324,1652),(30325,1652),(30326,1652),(30327,1652),(30328,1653),(30329,1653),(30330,1653),(30331,1653),(30332,1653),(30333,1653),(30334,1653),(30335,1653),(30336,1653),(30337,1654),(30338,1654),(30339,1654),(30340,1654),(30341,1654),(30342,1654),(30343,1655),(30344,1655),(30345,1655),(30346,1655),(30347,1655),(30348,1655),(30349,1655),(30350,1656),(30351,1656),(30352,1656),(30353,1656),(30354,1656),(30355,1656),(30356,1656),(30357,1657),(30358,1657),(30359,1657),(30360,1657),(30361,1657),(30362,1657),(30363,1658),(30364,1658),(30365,1658),(30366,1658),(30367,1658),(30368,1658),(30369,1658),(30370,1658),(30371,1658),(30372,1659),(30373,1659),(30374,1659),(30375,1659),(30376,1659),(30377,1659),(30378,1659),(30379,1659),(30380,1659),(30381,1660),(30382,1660),(30383,1660),(30384,1660),(30385,1660),(30386,1660),(30387,1660),(30388,1660),(30389,1660),(30390,1661),(30391,1661),(30392,1661),(30393,1661),(30394,1661),(30395,1661),(30396,1661),(30397,1662),(30398,1662),(30399,1662),(30400,1662),(30401,1662),(30402,1662),(30403,1662),(30404,1663),(30405,1663),(30406,1663),(30407,1663),(30408,1663),(30409,1663),(30410,1663),(30411,1664),(30412,1664),(30413,1664),(30414,1664),(30415,1664),(30416,1664),(30417,1664),(30418,1665),(30419,1665),(30420,1665),(30421,1665),(30422,1665),(30423,1665),(30424,1665),(30425,1566),(30426,1566),(30427,1567),(30428,1567),(30429,1568),(30430,1568),(30431,1569),(30432,1569),(30433,1570),(30434,1570),(30435,1571),(30436,1571),(30437,1572),(30438,1572),(30439,1573),(30440,1573),(30441,1574),(30442,1574),(30443,1575),(30444,1575),(30445,1576),(30446,1576),(30447,1577),(30448,1577),(30449,1578),(30450,1578),(30451,1579),(30452,1580),(30453,1580),(30454,1581),(30455,1581),(30456,1582),(30457,1582),(30458,1583),(30459,1583),(30460,1584),(30461,1584),(30462,1585),(30463,1585),(30464,1586),(30465,1586),(30466,1587),(30467,1587),(30468,1588),(30469,1588),(30470,1589),(30471,1589),(30472,1590),(30473,1590),(30474,1591),(30475,1591),(30476,1592),(30477,1592),(30478,1593),(30479,1593),(30480,1594),(30481,1594),(30482,1595),(30483,1595),(30484,1596),(30485,1596),(30486,1597),(30487,1597),(30488,1598),(30489,1598),(30490,1599),(30491,1599),(30492,1600),(30493,1600),(30494,1601),(30495,1601),(30496,1602),(30497,1602),(30498,1603),(30499,1603),(30500,1604),(30501,1604),(30502,1605),(30503,1605),(30504,1606),(30505,1606),(30506,1607),(30507,1607),(30508,1608),(30509,1608),(30510,1609),(30511,1609),(30512,1610),(30513,1610),(30514,1611),(30515,1611),(30516,1611),(30517,1612),(30518,1612),(30519,1612),(30520,1613),(30521,1613),(30522,1613),(30523,1614),(30524,1614),(30525,1614),(30526,1615),(30527,1615),(30528,1616),(30529,1616),(30530,1616),(30531,1617),(30532,1617),(30533,1617),(30534,1618),(30535,1618),(30536,1619),(30537,1619),(30538,1620),(30539,1620),(30540,1621),(30541,1621),(30542,1622),(30543,1622),(30544,1623),(30545,1623),(30546,1624),(30547,1624),(30548,1625),(30549,1625),(30550,1626),(30551,1626),(30552,1627),(30553,1627),(30554,1628),(30555,1628),(30556,1629),(30557,1629),(30558,1630),(30559,1630),(30560,1631),(30561,1631),(30562,1632),(30563,1632),(30564,1633),(30565,1633),(30566,1634),(30567,1634),(30568,1635),(30569,1635),(30570,1636),(30571,1636),(30572,1637),(30573,1637),(30574,1638),(30575,1638),(30576,1639),(30577,1639),(30578,1640),(30579,1640),(30580,1641),(30581,1641),(30582,1642),(30583,1642),(30584,1643),(30585,1643),(30586,1644),(30587,1644),(30588,1645),(30589,1645),(30590,1646),(30591,1646),(30592,1646),(30593,1647),(30594,1647),(30595,1647),(30596,1648),(30597,1648),(30598,1649),(30599,1649),(30600,1650),(30601,1650),(30602,1650),(30603,1651),(30604,1651),(30605,1651),(30606,1652),(30607,1652),(30608,1652),(30609,1653),(30610,1653),(30611,1653),(30612,1654),(30613,1654),(30614,1654),(30615,1655),(30616,1655),(30617,1655),(30618,1656),(30619,1656),(30620,1656),(30621,1657),(30622,1657),(30623,1657),(30624,1658),(30625,1658),(30626,1659),(30627,1659),(30628,1660),(30629,1660),(30630,1661),(30631,1661),(30632,1662),(30633,1662),(30634,1663),(30635,1663),(30636,1664),(30637,1664),(30638,1665),(30639,1665),(30640,1566),(30641,1566),(30642,1566),(30643,1567),(30644,1567),(30645,1567),(30646,1568),(30647,1568),(30648,1568),(30649,1569),(30650,1569),(30651,1569),(30652,1570),(30653,1570),(30654,1570),(30655,1571),(30656,1571),(30657,1571),(30658,1572),(30659,1572),(30660,1572),(30661,1573),(30662,1573),(30663,1573),(30664,1574),(30665,1574),(30666,1574),(30667,1575),(30668,1575),(30669,1575),(30670,1576),(30671,1576),(30672,1576),(30673,1577),(30674,1577),(30675,1577),(30676,1578),(30677,1578),(30678,1578),(30679,1579),(30680,1579),(30681,1579),(30682,1580),(30683,1580),(30684,1580),(30685,1581),(30686,1581),(30687,1581),(30688,1582),(30689,1582),(30690,1582),(30691,1583),(30692,1583),(30693,1583),(30694,1584),(30695,1584),(30696,1584),(30697,1585),(30698,1585),(30699,1585),(30700,1586),(30701,1586),(30702,1586),(30703,1587),(30704,1587),(30705,1587),(30706,1588),(30707,1588),(30708,1588),(30709,1589),(30710,1589),(30711,1589),(30712,1590),(30713,1590),(30714,1590),(30715,1591),(30716,1591),(30717,1591),(30718,1592),(30719,1592),(30720,1592),(30721,1593),(30722,1593),(30723,1593),(30724,1594),(30725,1594),(30726,1594),(30727,1595),(30728,1595),(30729,1595),(30730,1596),(30731,1596),(30732,1596),(30733,1597),(30734,1597),(30735,1597),(30736,1598),(30737,1598),(30738,1598),(30739,1599),(30740,1599),(30741,1599),(30742,1600),(30743,1600),(30744,1600),(30745,1601),(30746,1601),(30747,1601),(30748,1602),(30749,1602),(30750,1602),(30751,1603),(30752,1603),(30753,1603),(30754,1604),(30755,1604),(30756,1604),(30757,1605),(30758,1605),(30759,1605),(30760,1606),(30761,1606),(30762,1606),(30763,1607),(30764,1607),(30765,1607),(30766,1608),(30767,1608),(30768,1608),(30769,1609),(30770,1609),(30771,1609),(30772,1610),(30773,1610),(30774,1610),(30775,1611),(30776,1611),(30777,1611),(30778,1612),(30779,1612),(30780,1612),(30781,1613),(30782,1613),(30783,1613),(30784,1614),(30785,1614),(30786,1614),(30787,1615),(30788,1615),(30789,1615),(30790,1616),(30791,1616),(30792,1616),(30793,1617),(30794,1617),(30795,1617),(30796,1618),(30797,1618),(30798,1618),(30799,1619),(30800,1619),(30801,1619),(30802,1620),(30803,1620),(30804,1620),(30805,1621),(30806,1621),(30807,1621),(30808,1622),(30809,1622),(30810,1622),(30811,1623),(30812,1623),(30813,1623),(30814,1624),(30815,1624),(30816,1624),(30817,1625),(30818,1625),(30819,1625),(30820,1626),(30821,1626),(30822,1626),(30823,1627),(30824,1627),(30825,1627),(30826,1628),(30827,1628),(30828,1628),(30829,1629),(30830,1629),(30831,1629),(30832,1629),(30833,1630),(30834,1630),(30835,1630),(30836,1631),(30837,1631),(30838,1631),(30839,1632),(30840,1632),(30841,1632),(30842,1633),(30843,1633),(30844,1633),(30845,1634),(30846,1634),(30847,1634),(30848,1635),(30849,1635),(30850,1635),(30851,1636),(30852,1636),(30853,1636),(30854,1637),(30855,1637),(30856,1637),(30857,1638),(30858,1638),(30859,1638),(30860,1639),(30861,1639),(30862,1639),(30863,1640),(30864,1640),(30865,1640),(30866,1640),(30867,1641),(30868,1641),(30869,1641),(30870,1641),(30871,1642),(30872,1642),(30873,1642),(30874,1642),(30875,1643),(30876,1643),(30877,1643),(30878,1644),(30879,1644),(30880,1644),(30881,1645),(30882,1645),(30883,1645),(30884,1646),(30885,1646),(30886,1646),(30887,1647),(30888,1647),(30889,1647),(30890,1648),(30891,1648),(30892,1648),(30893,1649),(30894,1649),(30895,1649),(30896,1650),(30897,1650),(30898,1650),(30899,1651),(30900,1651),(30901,1651),(30902,1652),(30903,1652),(30904,1652),(30905,1653),(30906,1653),(30907,1653),(30908,1654),(30909,1654),(30910,1654),(30911,1655),(30912,1655),(30913,1655),(30914,1656),(30915,1656),(30916,1656),(30917,1657),(30918,1657),(30919,1657),(30920,1658),(30921,1658),(30922,1658),(30923,1659),(30924,1659),(30925,1659),(30926,1660),(30927,1660),(30928,1660),(30929,1661),(30930,1661),(30931,1661),(30932,1662),(30933,1662),(30934,1662),(30935,1663),(30936,1663),(30937,1663),(30938,1664),(30939,1664),(30940,1664),(30941,1665),(30942,1665),(30943,1665),(30944,1566),(30945,1566),(30946,1566),(30947,1566),(30948,1567),(30949,1567),(30950,1567),(30951,1567),(30952,1568),(30953,1568),(30954,1568),(30955,1568),(30956,1569),(30957,1569),(30958,1569),(30959,1569),(30960,1570),(30961,1570),(30962,1570),(30963,1570),(30964,1571),(30965,1571),(30966,1571),(30967,1571),(30968,1572),(30969,1572),(30970,1572),(30971,1572),(30972,1573),(30973,1573),(30974,1573),(30975,1573),(30976,1574),(30977,1574),(30978,1574),(30979,1574),(30980,1575),(30981,1575),(30982,1575),(30983,1575),(30984,1576),(30985,1576),(30986,1576),(30987,1576),(30988,1577),(30989,1577),(30990,1577),(30991,1577),(30992,1578),(30993,1578),(30994,1578),(30995,1578),(30996,1579),(30997,1579),(30998,1579),(30999,1579),(31000,1580),(31001,1580),(31002,1580),(31003,1580),(31004,1581),(31005,1581),(31006,1581),(31007,1581),(31008,1582),(31009,1582),(31010,1582),(31011,1582),(31012,1583),(31013,1583),(31014,1583),(31015,1583),(31016,1584),(31017,1584),(31018,1584),(31019,1584),(31020,1585),(31021,1585),(31022,1585),(31023,1585),(31024,1586),(31025,1586),(31026,1586),(31027,1586),(31028,1587),(31029,1587),(31030,1587),(31031,1587),(31032,1588),(31033,1588),(31034,1588),(31035,1588),(31036,1589),(31037,1589),(31038,1589),(31039,1589),(31040,1590),(31041,1590),(31042,1590),(31043,1590),(31044,1591),(31045,1591),(31046,1591),(31047,1591),(31048,1592),(31049,1592),(31050,1592),(31051,1592),(31052,1593),(31053,1593),(31054,1593),(31055,1593),(31056,1594),(31057,1594),(31058,1594),(31059,1594),(31060,1595),(31061,1595),(31062,1595),(31063,1595),(31064,1596),(31065,1596),(31066,1596),(31067,1596),(31068,1597),(31069,1597),(31070,1597),(31071,1597),(31072,1598),(31073,1598),(31074,1598),(31075,1598),(31076,1599),(31077,1599),(31078,1599),(31079,1599),(31080,1600),(31081,1600),(31082,1600),(31083,1600),(31084,1601),(31085,1601),(31086,1601),(31087,1601),(31088,1602),(31089,1602),(31090,1602),(31091,1602),(31092,1603),(31093,1603),(31094,1603),(31095,1603),(31096,1604),(31097,1604),(31098,1604),(31099,1604),(31100,1605),(31101,1605),(31102,1605),(31103,1605),(31104,1606),(31105,1606),(31106,1606),(31107,1606),(31108,1607),(31109,1607),(31110,1607),(31111,1607),(31112,1608),(31113,1608),(31114,1608),(31115,1608),(31116,1609),(31117,1609),(31118,1609),(31119,1609),(31120,1610),(31121,1610),(31122,1610),(31123,1610),(31124,1611),(31125,1611),(31126,1611),(31127,1611),(31128,1612),(31129,1612),(31130,1612),(31131,1612),(31132,1613),(31133,1613),(31134,1613),(31135,1613),(31136,1614),(31137,1614),(31138,1614),(31139,1614),(31140,1615),(31141,1615),(31142,1615),(31143,1615),(31144,1616),(31145,1616),(31146,1616),(31147,1616),(31148,1617),(31149,1617),(31150,1617),(31151,1617),(31152,1618),(31153,1618),(31154,1618),(31155,1618),(31156,1619),(31157,1619),(31158,1619),(31159,1619),(31160,1620),(31161,1620),(31162,1620),(31163,1620),(31164,1621),(31165,1621),(31166,1621),(31167,1621),(31168,1622),(31169,1622),(31170,1622),(31171,1622),(31172,1623),(31173,1623),(31174,1623),(31175,1623),(31176,1624),(31177,1624),(31178,1624),(31179,1624),(31180,1625),(31181,1625),(31182,1625),(31183,1625),(31184,1626),(31185,1626),(31186,1626),(31187,1626),(31188,1627),(31189,1627),(31190,1627),(31191,1627),(31192,1628),(31193,1628),(31194,1628),(31195,1628),(31196,1629),(31197,1629),(31198,1629),(31199,1629),(31200,1630),(31201,1630),(31202,1630),(31203,1630),(31204,1631),(31205,1631),(31206,1631),(31207,1631),(31208,1632),(31209,1632),(31210,1632),(31211,1632),(31212,1633),(31213,1633),(31214,1633),(31215,1633),(31216,1634),(31217,1634),(31218,1634),(31219,1634),(31220,1635),(31221,1635),(31222,1635),(31223,1635),(31224,1636),(31225,1636),(31226,1636),(31227,1636),(31228,1637),(31229,1637),(31230,1637),(31231,1637),(31232,1638),(31233,1638),(31234,1638),(31235,1638),(31236,1639),(31237,1639),(31238,1639),(31239,1639),(31240,1640),(31241,1640),(31242,1640),(31243,1640),(31244,1641),(31245,1641),(31246,1641),(31247,1641),(31248,1642),(31249,1642),(31250,1642),(31251,1642),(31252,1643),(31253,1643),(31254,1643),(31255,1643),(31256,1644),(31257,1644),(31258,1644),(31259,1644),(31260,1645),(31261,1645),(31262,1645),(31263,1645),(31264,1646),(31265,1646),(31266,1646),(31267,1646),(31268,1647),(31269,1647),(31270,1647),(31271,1647),(31272,1648),(31273,1648),(31274,1648),(31275,1648),(31276,1649),(31277,1649),(31278,1649),(31279,1649),(31280,1650),(31281,1650),(31282,1650),(31283,1650),(31284,1651),(31285,1651),(31286,1651),(31287,1651),(31288,1652),(31289,1652),(31290,1652),(31291,1652),(31292,1653),(31293,1653),(31294,1653),(31295,1653),(31296,1654),(31297,1654),(31298,1654),(31299,1654),(31300,1655),(31301,1655),(31302,1655),(31303,1655),(31304,1656),(31305,1656),(31306,1656),(31307,1656),(31308,1657),(31309,1657),(31310,1657),(31311,1657),(31312,1658),(31313,1658),(31314,1658),(31315,1658),(31316,1659),(31317,1659),(31318,1659),(31319,1659),(31320,1660),(31321,1660),(31322,1660),(31323,1660),(31324,1661),(31325,1661),(31326,1661),(31327,1661),(31328,1662),(31329,1662),(31330,1662),(31331,1662),(31332,1663),(31333,1663),(31334,1663),(31335,1663),(31336,1664),(31337,1664),(31338,1664),(31339,1664),(31340,1665),(31341,1665),(31342,1665),(31343,1665),(31344,1666),(31345,1667),(31346,1668),(31347,1669),(31348,1670),(31349,1671),(31350,1672),(31351,1673),(31352,1674),(31353,1675),(31354,1676),(31355,1677),(31356,1678),(31357,1679),(31358,1680),(31359,1681),(31360,1682),(31361,1683),(31362,1684),(31363,1685),(31364,1686),(31365,1687),(31366,1688),(31367,1689),(31368,1690),(31369,1691),(31370,1692),(31371,1693),(31372,1694),(31373,1695),(31374,1696),(31375,1697),(31376,1698),(31377,1699),(31378,1700),(31379,1701),(31380,1702),(31381,1703),(31382,1704),(31383,1705),(31384,1706),(31385,1707),(31386,1708),(31387,1709),(31388,1710),(31389,1711),(31390,1712),(31391,1713),(31392,1714),(31393,1715),(31394,1716),(31395,1717),(31396,1718),(31397,1719),(31398,1720),(31399,1721),(31400,1722),(31401,1723),(31402,1724),(31403,1725),(31404,1726),(31405,1727),(31406,1728),(31407,1729),(31408,1730),(31409,1731),(31410,1732),(31411,1733),(31412,1734),(31413,1735),(31414,1736),(31415,1737),(31416,1738),(31417,1739),(31418,1740),(31419,1741),(31420,1742),(31421,1743),(31422,1744),(31423,1745),(31424,1746),(31425,1747),(31426,1748),(31427,1749),(31428,1750),(31429,1751),(31430,1752),(31431,1753),(31432,1754),(31433,1755),(31434,1756),(31435,1757),(31436,1758),(31437,1759),(31438,1760),(31439,1761),(31440,1762),(31441,1763),(31442,1764),(31443,1765),(31444,1666),(31445,1667),(31446,1668),(31447,1669),(31448,1670),(31449,1671),(31450,1672),(31451,1673),(31452,1674),(31453,1675),(31454,1676),(31455,1677),(31456,1678),(31457,1679),(31458,1680),(31459,1681),(31460,1682),(31461,1683),(31462,1684),(31463,1685),(31464,1686),(31465,1687),(31466,1688),(31467,1689),(31468,1690),(31469,1691),(31470,1692),(31471,1693),(31472,1694),(31473,1695),(31474,1696),(31475,1697),(31476,1698),(31477,1699),(31478,1700),(31479,1701),(31480,1702),(31481,1703),(31482,1704),(31483,1705),(31484,1706),(31485,1707),(31486,1708),(31487,1709),(31488,1710),(31489,1711),(31490,1712),(31491,1713),(31492,1714),(31493,1715),(31494,1716),(31495,1717),(31496,1718),(31497,1719),(31498,1720),(31499,1721),(31500,1722),(31501,1723),(31502,1724),(31503,1725),(31504,1726),(31505,1727),(31506,1728),(31507,1729),(31508,1730),(31509,1731),(31510,1732),(31511,1733),(31512,1734),(31513,1735),(31514,1736),(31515,1737),(31516,1738),(31517,1739),(31518,1740),(31519,1741),(31520,1742),(31521,1743),(31522,1744),(31523,1745),(31524,1746),(31525,1747),(31526,1748),(31527,1749),(31528,1750),(31529,1751),(31530,1752),(31531,1753),(31532,1754),(31533,1755),(31534,1756),(31535,1757),(31536,1758),(31537,1759),(31538,1760),(31539,1761),(31540,1762),(31541,1763),(31542,1764),(31543,1765),(31544,1666),(31545,1666),(31546,1666),(31547,1666),(31548,1666),(31549,1666),(31550,1666),(31551,1667),(31552,1667),(31553,1667),(31554,1667),(31555,1667),(31556,1667),(31557,1667),(31558,1668),(31559,1668),(31560,1668),(31561,1668),(31562,1668),(31563,1668),(31564,1668),(31565,1669),(31566,1669),(31567,1669),(31568,1669),(31569,1669),(31570,1669),(31571,1669),(31572,1670),(31573,1670),(31574,1670),(31575,1670),(31576,1670),(31577,1670),(31578,1670),(31579,1671),(31580,1671),(31581,1671),(31582,1671),(31583,1671),(31584,1671),(31585,1671),(31586,1672),(31587,1672),(31588,1672),(31589,1672),(31590,1672),(31591,1672),(31592,1672),(31593,1673),(31594,1673),(31595,1673),(31596,1673),(31597,1673),(31598,1673),(31599,1673),(31600,1674),(31601,1674),(31602,1674),(31603,1674),(31604,1674),(31605,1674),(31606,1674),(31607,1675),(31608,1675),(31609,1675),(31610,1675),(31611,1675),(31612,1675),(31613,1675),(31614,1676),(31615,1676),(31616,1676),(31617,1676),(31618,1676),(31619,1676),(31620,1676),(31621,1677),(31622,1677),(31623,1677),(31624,1677),(31625,1677),(31626,1677),(31627,1677),(31628,1678),(31629,1678),(31630,1678),(31631,1678),(31632,1678),(31633,1678),(31634,1678),(31635,1679),(31636,1679),(31637,1679),(31638,1679),(31639,1679),(31640,1679),(31641,1679),(31642,1679),(31643,1679),(31644,1680),(31645,1680),(31646,1680),(31647,1680),(31648,1680),(31649,1680),(31650,1680),(31651,1680),(31652,1680),(31653,1681),(31654,1681),(31655,1681),(31656,1681),(31657,1681),(31658,1681),(31659,1681),(31660,1681),(31661,1681),(31662,1682),(31663,1682),(31664,1682),(31665,1682),(31666,1682),(31667,1682),(31668,1682),(31669,1682),(31670,1682),(31671,1683),(31672,1683),(31673,1683),(31674,1683),(31675,1683),(31676,1683),(31677,1684),(31678,1684),(31679,1684),(31680,1684),(31681,1684),(31682,1684),(31683,1685),(31684,1685),(31685,1685),(31686,1685),(31687,1685),(31688,1685),(31689,1685),(31690,1685),(31691,1685),(31692,1686),(31693,1686),(31694,1686),(31695,1686),(31696,1686),(31697,1686),(31698,1687),(31699,1687),(31700,1687),(31701,1687),(31702,1687),(31703,1687),(31704,1687),(31705,1688),(31706,1688),(31707,1688),(31708,1688),(31709,1688),(31710,1688),(31711,1688),(31712,1689),(31713,1689),(31714,1689),(31715,1689),(31716,1689),(31717,1689),(31718,1689),(31719,1689),(31720,1689),(31721,1690),(31722,1690),(31723,1690),(31724,1690),(31725,1690),(31726,1690),(31727,1690),(31728,1691),(31729,1691),(31730,1691),(31731,1691),(31732,1691),(31733,1691),(31734,1691),(31735,1692),(31736,1692),(31737,1692),(31738,1692),(31739,1692),(31740,1692),(31741,1692),(31742,1693),(31743,1693),(31744,1693),(31745,1693),(31746,1693),(31747,1693),(31748,1693),(31749,1694),(31750,1694),(31751,1694),(31752,1694),(31753,1694),(31754,1694),(31755,1694),(31756,1695),(31757,1695),(31758,1695),(31759,1695),(31760,1695),(31761,1695),(31762,1695),(31763,1696),(31764,1696),(31765,1696),(31766,1696),(31767,1696),(31768,1696),(31769,1696),(31770,1697),(31771,1697),(31772,1697),(31773,1697),(31774,1697),(31775,1697),(31776,1697),(31777,1698),(31778,1698),(31779,1698),(31780,1698),(31781,1698),(31782,1698),(31783,1698),(31784,1699),(31785,1699),(31786,1699),(31787,1699),(31788,1699),(31789,1699),(31790,1699),(31791,1700),(31792,1700),(31793,1700),(31794,1700),(31795,1700),(31796,1700),(31797,1700),(31798,1700),(31799,1700),(31800,1701),(31801,1701),(31802,1701),(31803,1701),(31804,1701),(31805,1701),(31806,1701),(31807,1701),(31808,1701),(31809,1702),(31810,1702),(31811,1702),(31812,1702),(31813,1702),(31814,1702),(31815,1702),(31816,1702),(31817,1702),(31818,1703),(31819,1703),(31820,1703),(31821,1703),(31822,1703),(31823,1703),(31824,1703),(31825,1703),(31826,1704),(31827,1704),(31828,1704),(31829,1704),(31830,1704),(31831,1704),(31832,1705),(31833,1705),(31834,1705),(31835,1705),(31836,1705),(31837,1705),(31838,1705),(31839,1706),(31840,1706),(31841,1706),(31842,1706),(31843,1706),(31844,1706),(31845,1706),(31846,1707),(31847,1707),(31848,1707),(31849,1707),(31850,1707),(31851,1707),(31852,1707),(31853,1708),(31854,1708),(31855,1708),(31856,1708),(31857,1708),(31858,1708),(31859,1708),(31860,1709),(31861,1709),(31862,1709),(31863,1709),(31864,1709),(31865,1709),(31866,1709),(31867,1710),(31868,1710),(31869,1710),(31870,1710),(31871,1710),(31872,1710),(31873,1710),(31874,1711),(31875,1711),(31876,1711),(31877,1711),(31878,1711),(31879,1711),(31880,1712),(31881,1712),(31882,1712),(31883,1712),(31884,1712),(31885,1712),(31886,1712),(31887,1713),(31888,1713),(31889,1713),(31890,1713),(31891,1713),(31892,1713),(31893,1714),(31894,1714),(31895,1714),(31896,1714),(31897,1714),(31898,1714),(31899,1714),(31900,1715),(31901,1715),(31902,1715),(31903,1715),(31904,1715),(31905,1715),(31906,1715),(31907,1715),(31908,1716),(31909,1716),(31910,1716),(31911,1716),(31912,1716),(31913,1716),(31914,1716),(31915,1716),(31916,1716),(31917,1717),(31918,1717),(31919,1717),(31920,1717),(31921,1717),(31922,1717),(31923,1717),(31924,1717),(31925,1718),(31926,1718),(31927,1718),(31928,1718),(31929,1718),(31930,1718),(31931,1718),(31932,1718),(31933,1718),(31934,1719),(31935,1719),(31936,1719),(31937,1719),(31938,1719),(31939,1719),(31940,1719),(31941,1719),(31942,1719),(31943,1720),(31944,1720),(31945,1720),(31946,1720),(31947,1720),(31948,1720),(31949,1720),(31950,1720),(31951,1720),(31952,1721),(31953,1721),(31954,1721),(31955,1721),(31956,1721),(31957,1721),(31958,1721),(31959,1721),(31960,1721),(31961,1722),(31962,1722),(31963,1722),(31964,1722),(31965,1722),(31966,1722),(31967,1722),(31968,1722),(31969,1722),(31970,1723),(31971,1723),(31972,1723),(31973,1723),(31974,1723),(31975,1723),(31976,1723),(31977,1723),(31978,1723),(31979,1724),(31980,1724),(31981,1724),(31982,1724),(31983,1724),(31984,1724),(31985,1724),(31986,1724),(31987,1724),(31988,1725),(31989,1725),(31990,1725),(31991,1725),(31992,1725),(31993,1725),(31994,1725),(31995,1725),(31996,1725),(31997,1726),(31998,1726),(31999,1726),(32000,1726),(32001,1726),(32002,1726),(32003,1726),(32004,1726),(32005,1727),(32006,1727),(32007,1727),(32008,1727),(32009,1727),(32010,1727),(32011,1727),(32012,1727),(32013,1728),(32014,1728),(32015,1728),(32016,1728),(32017,1728),(32018,1728),(32019,1728),(32020,1728),(32021,1729),(32022,1729),(32023,1729),(32024,1729),(32025,1729),(32026,1729),(32027,1729),(32028,1729),(32029,1730),(32030,1730),(32031,1730),(32032,1730),(32033,1730),(32034,1730),(32035,1730),(32036,1730),(32037,1731),(32038,1731),(32039,1731),(32040,1731),(32041,1731),(32042,1731),(32043,1731),(32044,1731),(32045,1732),(32046,1732),(32047,1732),(32048,1732),(32049,1732),(32050,1732),(32051,1732),(32052,1732),(32053,1733),(32054,1733),(32055,1733),(32056,1733),(32057,1733),(32058,1733),(32059,1733),(32060,1733),(32061,1733),(32062,1734),(32063,1734),(32064,1734),(32065,1734),(32066,1734),(32067,1734),(32068,1734),(32069,1734),(32070,1734),(32071,1735),(32072,1735),(32073,1735),(32074,1735),(32075,1735),(32076,1735),(32077,1735),(32078,1735),(32079,1735),(32080,1736),(32081,1736),(32082,1736),(32083,1736),(32084,1736),(32085,1736),(32086,1736),(32087,1736),(32088,1737),(32089,1737),(32090,1737),(32091,1737),(32092,1737),(32093,1737),(32094,1737),(32095,1737),(32096,1738),(32097,1738),(32098,1738),(32099,1738),(32100,1738),(32101,1738),(32102,1738),(32103,1738),(32104,1739),(32105,1739),(32106,1739),(32107,1739),(32108,1739),(32109,1739),(32110,1739),(32111,1740),(32112,1740),(32113,1740),(32114,1740),(32115,1740),(32116,1740),(32117,1740),(32118,1741),(32119,1741),(32120,1741),(32121,1741),(32122,1741),(32123,1741),(32124,1741),(32125,1742),(32126,1742),(32127,1742),(32128,1742),(32129,1742),(32130,1742),(32131,1742),(32132,1743),(32133,1743),(32134,1743),(32135,1743),(32136,1743),(32137,1743),(32138,1743),(32139,1744),(32140,1744),(32141,1744),(32142,1744),(32143,1744),(32144,1744),(32145,1744),(32146,1745),(32147,1745),(32148,1745),(32149,1745),(32150,1745),(32151,1745),(32152,1745),(32153,1746),(32154,1746),(32155,1746),(32156,1746),(32157,1746),(32158,1746),(32159,1746),(32160,1747),(32161,1747),(32162,1747),(32163,1747),(32164,1747),(32165,1747),(32166,1747),(32167,1748),(32168,1748),(32169,1748),(32170,1748),(32171,1748),(32172,1748),(32173,1748),(32174,1749),(32175,1749),(32176,1749),(32177,1749),(32178,1749),(32179,1749),(32180,1749),(32181,1750),(32182,1750),(32183,1750),(32184,1750),(32185,1750),(32186,1750),(32187,1750),(32188,1751),(32189,1751),(32190,1751),(32191,1751),(32192,1751),(32193,1751),(32194,1751),(32195,1752),(32196,1752),(32197,1752),(32198,1752),(32199,1752),(32200,1752),(32201,1752),(32202,1753),(32203,1753),(32204,1753),(32205,1753),(32206,1753),(32207,1753),(32208,1753),(32209,1754),(32210,1754),(32211,1754),(32212,1754),(32213,1754),(32214,1754),(32215,1754),(32216,1755),(32217,1755),(32218,1755),(32219,1755),(32220,1755),(32221,1755),(32222,1755),(32223,1756),(32224,1756),(32225,1756),(32226,1756),(32227,1756),(32228,1756),(32229,1756),(32230,1757),(32231,1757),(32232,1757),(32233,1757),(32234,1757),(32235,1757),(32236,1757),(32237,1758),(32238,1758),(32239,1758),(32240,1758),(32241,1758),(32242,1758),(32243,1758),(32244,1759),(32245,1759),(32246,1759),(32247,1759),(32248,1759),(32249,1759),(32250,1759),(32251,1760),(32252,1760),(32253,1760),(32254,1760),(32255,1760),(32256,1760),(32257,1760),(32258,1761),(32259,1761),(32260,1761),(32261,1761),(32262,1761),(32263,1761),(32264,1761),(32265,1762),(32266,1762),(32267,1762),(32268,1762),(32269,1762),(32270,1762),(32271,1762),(32272,1763),(32273,1763),(32274,1763),(32275,1763),(32276,1763),(32277,1763),(32278,1763),(32279,1763),(32280,1763),(32281,1764),(32282,1764),(32283,1764),(32284,1764),(32285,1764),(32286,1764),(32287,1764),(32288,1765),(32289,1765),(32290,1765),(32291,1765),(32292,1765),(32293,1765),(32294,1765),(32295,1666),(32296,1666),(32297,1667),(32298,1667),(32299,1668),(32300,1668),(32301,1669),(32302,1669),(32303,1670),(32304,1670),(32305,1671),(32306,1671),(32307,1672),(32308,1672),(32309,1673),(32310,1673),(32311,1674),(32312,1674),(32313,1675),(32314,1675),(32315,1676),(32316,1676),(32317,1677),(32318,1677),(32319,1678),(32320,1678),(32321,1679),(32322,1679),(32323,1680),(32324,1680),(32325,1681),(32326,1681),(32327,1682),(32328,1682),(32329,1683),(32330,1683),(32331,1684),(32332,1684),(32333,1685),(32334,1685),(32335,1686),(32336,1686),(32337,1687),(32338,1687),(32339,1688),(32340,1688),(32341,1689),(32342,1689),(32343,1690),(32344,1690),(32345,1691),(32346,1691),(32347,1692),(32348,1692),(32349,1693),(32350,1693),(32351,1694),(32352,1694),(32353,1695),(32354,1695),(32355,1696),(32356,1696),(32357,1697),(32358,1697),(32359,1698),(32360,1698),(32361,1699),(32362,1699),(32363,1700),(32364,1700),(32365,1701),(32366,1701),(32367,1701),(32368,1702),(32369,1702),(32370,1703),(32371,1703),(32372,1703),(32373,1704),(32374,1704),(32375,1705),(32376,1705),(32377,1705),(32378,1706),(32379,1706),(32380,1706),(32381,1707),(32382,1707),(32383,1707),(32384,1708),(32385,1708),(32386,1709),(32387,1709),(32388,1710),(32389,1710),(32390,1711),(32391,1711),(32392,1712),(32393,1712),(32394,1713),(32395,1713),(32396,1714),(32397,1714),(32398,1715),(32399,1715),(32400,1716),(32401,1716),(32402,1717),(32403,1717),(32404,1718),(32405,1718),(32406,1719),(32407,1719),(32408,1720),(32409,1720),(32410,1721),(32411,1721),(32412,1722),(32413,1722),(32414,1723),(32415,1723),(32416,1724),(32417,1724),(32418,1725),(32419,1725),(32420,1726),(32421,1726),(32422,1727),(32423,1727),(32424,1728),(32425,1728),(32426,1729),(32427,1729),(32428,1730),(32429,1730),(32430,1731),(32431,1731),(32432,1732),(32433,1732),(32434,1733),(32435,1733),(32436,1734),(32437,1734),(32438,1735),(32439,1735),(32440,1736),(32441,1736),(32442,1737),(32443,1737),(32444,1737),(32445,1738),(32446,1738),(32447,1738),(32448,1739),(32449,1739),(32450,1739),(32451,1740),(32452,1740),(32453,1741),(32454,1741),(32455,1741),(32456,1742),(32457,1742),(32458,1742),(32459,1743),(32460,1743),(32461,1744),(32462,1744),(32463,1745),(32464,1745),(32465,1746),(32466,1746),(32467,1747),(32468,1747),(32469,1748),(32470,1748),(32471,1749),(32472,1749),(32473,1750),(32474,1750),(32475,1751),(32476,1751),(32477,1752),(32478,1752),(32479,1753),(32480,1753),(32481,1754),(32482,1754),(32483,1755),(32484,1755),(32485,1756),(32486,1756),(32487,1757),(32488,1757),(32489,1758),(32490,1758),(32491,1759),(32492,1759),(32493,1759),(32494,1760),(32495,1760),(32496,1760),(32497,1761),(32498,1761),(32499,1762),(32500,1762),(32501,1763),(32502,1763),(32503,1764),(32504,1764),(32505,1764),(32506,1765),(32507,1765),(32508,1765),(32509,1666),(32510,1666),(32511,1666),(32512,1667),(32513,1667),(32514,1667),(32515,1668),(32516,1668),(32517,1668),(32518,1669),(32519,1669),(32520,1669),(32521,1670),(32522,1670),(32523,1670),(32524,1671),(32525,1671),(32526,1671),(32527,1672),(32528,1672),(32529,1672),(32530,1673),(32531,1673),(32532,1673),(32533,1674),(32534,1674),(32535,1674),(32536,1675),(32537,1675),(32538,1675),(32539,1676),(32540,1676),(32541,1676),(32542,1677),(32543,1677),(32544,1677),(32545,1678),(32546,1678),(32547,1678),(32548,1679),(32549,1679),(32550,1679),(32551,1680),(32552,1680),(32553,1680),(32554,1681),(32555,1681),(32556,1681),(32557,1682),(32558,1682),(32559,1682),(32560,1683),(32561,1683),(32562,1683),(32563,1684),(32564,1684),(32565,1684),(32566,1685),(32567,1685),(32568,1685),(32569,1686),(32570,1686),(32571,1686),(32572,1687),(32573,1687),(32574,1687),(32575,1688),(32576,1688),(32577,1688),(32578,1689),(32579,1689),(32580,1689),(32581,1690),(32582,1690),(32583,1690),(32584,1691),(32585,1691),(32586,1691),(32587,1692),(32588,1692),(32589,1692),(32590,1693),(32591,1693),(32592,1693),(32593,1694),(32594,1694),(32595,1694),(32596,1695),(32597,1695),(32598,1695),(32599,1696),(32600,1696),(32601,1696),(32602,1697),(32603,1697),(32604,1697),(32605,1698),(32606,1698),(32607,1698),(32608,1699),(32609,1699),(32610,1699),(32611,1700),(32612,1700),(32613,1700),(32614,1701),(32615,1701),(32616,1701),(32617,1702),(32618,1702),(32619,1702),(32620,1703),(32621,1703),(32622,1703),(32623,1704),(32624,1704),(32625,1704),(32626,1705),(32627,1705),(32628,1705),(32629,1706),(32630,1706),(32631,1706),(32632,1707),(32633,1707),(32634,1707),(32635,1708),(32636,1708),(32637,1708),(32638,1709),(32639,1709),(32640,1709),(32641,1710),(32642,1710),(32643,1710),(32644,1711),(32645,1711),(32646,1711),(32647,1711),(32648,1712),(32649,1712),(32650,1712),(32651,1713),(32652,1713),(32653,1713),(32654,1713),(32655,1714),(32656,1714),(32657,1714),(32658,1715),(32659,1715),(32660,1715),(32661,1716),(32662,1716),(32663,1716),(32664,1717),(32665,1717),(32666,1717),(32667,1718),(32668,1718),(32669,1718),(32670,1719),(32671,1719),(32672,1719),(32673,1720),(32674,1720),(32675,1720),(32676,1721),(32677,1721),(32678,1721),(32679,1722),(32680,1722),(32681,1722),(32682,1723),(32683,1723),(32684,1723),(32685,1724),(32686,1724),(32687,1724),(32688,1725),(32689,1725),(32690,1725),(32691,1726),(32692,1726),(32693,1726),(32694,1727),(32695,1727),(32696,1727),(32697,1728),(32698,1728),(32699,1728),(32700,1729),(32701,1729),(32702,1729),(32703,1730),(32704,1730),(32705,1730),(32706,1731),(32707,1731),(32708,1731),(32709,1732),(32710,1732),(32711,1732),(32712,1733),(32713,1733),(32714,1733),(32715,1734),(32716,1734),(32717,1734),(32718,1735),(32719,1735),(32720,1735),(32721,1736),(32722,1736),(32723,1736),(32724,1737),(32725,1737),(32726,1737),(32727,1738),(32728,1738),(32729,1738),(32730,1739),(32731,1739),(32732,1739),(32733,1740),(32734,1740),(32735,1740),(32736,1741),(32737,1741),(32738,1741),(32739,1742),(32740,1742),(32741,1742),(32742,1743),(32743,1743),(32744,1743),(32745,1744),(32746,1744),(32747,1744),(32748,1745),(32749,1745),(32750,1745),(32751,1746),(32752,1746),(32753,1746),(32754,1747),(32755,1747),(32756,1747),(32757,1748),(32758,1748),(32759,1748),(32760,1749),(32761,1749),(32762,1749),(32763,1750),(32764,1750),(32765,1750),(32766,1751),(32767,1751),(32768,1751),(32769,1752),(32770,1752),(32771,1752),(32772,1753),(32773,1753),(32774,1753),(32775,1754),(32776,1754),(32777,1754),(32778,1755),(32779,1755),(32780,1755),(32781,1756),(32782,1756),(32783,1756),(32784,1757),(32785,1757),(32786,1757),(32787,1758),(32788,1758),(32789,1758),(32790,1759),(32791,1759),(32792,1759),(32793,1760),(32794,1760),(32795,1760),(32796,1761),(32797,1761),(32798,1761),(32799,1762),(32800,1762),(32801,1762),(32802,1763),(32803,1763),(32804,1763),(32805,1764),(32806,1764),(32807,1764),(32808,1765),(32809,1765),(32810,1765),(32811,1666),(32812,1666),(32813,1666),(32814,1666),(32815,1667),(32816,1667),(32817,1667),(32818,1667),(32819,1668),(32820,1668),(32821,1668),(32822,1668),(32823,1669),(32824,1669),(32825,1669),(32826,1669),(32827,1670),(32828,1670),(32829,1670),(32830,1670),(32831,1671),(32832,1671),(32833,1671),(32834,1671),(32835,1672),(32836,1672),(32837,1672),(32838,1672),(32839,1673),(32840,1673),(32841,1673),(32842,1673),(32843,1674),(32844,1674),(32845,1674),(32846,1674),(32847,1675),(32848,1675),(32849,1675),(32850,1675),(32851,1676),(32852,1676),(32853,1676),(32854,1676),(32855,1677),(32856,1677),(32857,1677),(32858,1677),(32859,1678),(32860,1678),(32861,1678),(32862,1678),(32863,1679),(32864,1679),(32865,1679),(32866,1679),(32867,1680),(32868,1680),(32869,1680),(32870,1680),(32871,1681),(32872,1681),(32873,1681),(32874,1681),(32875,1682),(32876,1682),(32877,1682),(32878,1682),(32879,1683),(32880,1683),(32881,1683),(32882,1683),(32883,1684),(32884,1684),(32885,1684),(32886,1684),(32887,1685),(32888,1685),(32889,1685),(32890,1685),(32891,1686),(32892,1686),(32893,1686),(32894,1686),(32895,1687),(32896,1687),(32897,1687),(32898,1687),(32899,1688),(32900,1688),(32901,1688),(32902,1688),(32903,1689),(32904,1689),(32905,1689),(32906,1689),(32907,1690),(32908,1690),(32909,1690),(32910,1690),(32911,1691),(32912,1691),(32913,1691),(32914,1691),(32915,1692),(32916,1692),(32917,1692),(32918,1692),(32919,1693),(32920,1693),(32921,1693),(32922,1693),(32923,1694),(32924,1694),(32925,1694),(32926,1694),(32927,1695),(32928,1695),(32929,1695),(32930,1695),(32931,1696),(32932,1696),(32933,1696),(32934,1696),(32935,1697),(32936,1697),(32937,1697),(32938,1697),(32939,1698),(32940,1698),(32941,1698),(32942,1698),(32943,1699),(32944,1699),(32945,1699),(32946,1699),(32947,1700),(32948,1700),(32949,1700),(32950,1700),(32951,1701),(32952,1701),(32953,1701),(32954,1701),(32955,1702),(32956,1702),(32957,1702),(32958,1702),(32959,1703),(32960,1703),(32961,1703),(32962,1703),(32963,1704),(32964,1704),(32965,1704),(32966,1704),(32967,1705),(32968,1705),(32969,1705),(32970,1705),(32971,1706),(32972,1706),(32973,1706),(32974,1706),(32975,1707),(32976,1707),(32977,1707),(32978,1707),(32979,1708),(32980,1708),(32981,1708),(32982,1708),(32983,1709),(32984,1709),(32985,1709),(32986,1709),(32987,1710),(32988,1710),(32989,1710),(32990,1710),(32991,1711),(32992,1711),(32993,1711),(32994,1711),(32995,1712),(32996,1712),(32997,1712),(32998,1712),(32999,1713),(33000,1713),(33001,1713),(33002,1713),(33003,1714),(33004,1714),(33005,1714),(33006,1714),(33007,1715),(33008,1715),(33009,1715),(33010,1715),(33011,1716),(33012,1716),(33013,1716),(33014,1716),(33015,1717),(33016,1717),(33017,1717),(33018,1717),(33019,1718),(33020,1718),(33021,1718),(33022,1718),(33023,1719),(33024,1719),(33025,1719),(33026,1719),(33027,1720),(33028,1720),(33029,1720),(33030,1720),(33031,1721),(33032,1721),(33033,1721),(33034,1721),(33035,1722),(33036,1722),(33037,1722),(33038,1722),(33039,1723),(33040,1723),(33041,1723),(33042,1723),(33043,1724),(33044,1724),(33045,1724),(33046,1724),(33047,1725),(33048,1725),(33049,1725),(33050,1725),(33051,1726),(33052,1726),(33053,1726),(33054,1726),(33055,1727),(33056,1727),(33057,1727),(33058,1727),(33059,1728),(33060,1728),(33061,1728),(33062,1728),(33063,1729),(33064,1729),(33065,1729),(33066,1729),(33067,1730),(33068,1730),(33069,1730),(33070,1730),(33071,1731),(33072,1731),(33073,1731),(33074,1731),(33075,1732),(33076,1732),(33077,1732),(33078,1732),(33079,1733),(33080,1733),(33081,1733),(33082,1733),(33083,1734),(33084,1734),(33085,1734),(33086,1734),(33087,1735),(33088,1735),(33089,1735),(33090,1735),(33091,1736),(33092,1736),(33093,1736),(33094,1736),(33095,1737),(33096,1737),(33097,1737),(33098,1737),(33099,1738),(33100,1738),(33101,1738),(33102,1738),(33103,1739),(33104,1739),(33105,1739),(33106,1739),(33107,1740),(33108,1740),(33109,1740),(33110,1740),(33111,1741),(33112,1741),(33113,1741),(33114,1741),(33115,1742),(33116,1742),(33117,1742),(33118,1742),(33119,1743),(33120,1743),(33121,1743),(33122,1743),(33123,1744),(33124,1744),(33125,1744),(33126,1744),(33127,1745),(33128,1745),(33129,1745),(33130,1745),(33131,1746),(33132,1746),(33133,1746),(33134,1746),(33135,1747),(33136,1747),(33137,1747),(33138,1747),(33139,1748),(33140,1748),(33141,1748),(33142,1748),(33143,1749),(33144,1749),(33145,1749),(33146,1749),(33147,1750),(33148,1750),(33149,1750),(33150,1750),(33151,1751),(33152,1751),(33153,1751),(33154,1751),(33155,1752),(33156,1752),(33157,1752),(33158,1752),(33159,1753),(33160,1753),(33161,1753),(33162,1753),(33163,1754),(33164,1754),(33165,1754),(33166,1754),(33167,1755),(33168,1755),(33169,1755),(33170,1755),(33171,1756),(33172,1756),(33173,1756),(33174,1756),(33175,1757),(33176,1757),(33177,1757),(33178,1757),(33179,1758),(33180,1758),(33181,1758),(33182,1758),(33183,1759),(33184,1759),(33185,1759),(33186,1759),(33187,1760),(33188,1760),(33189,1760),(33190,1760),(33191,1761),(33192,1761),(33193,1761),(33194,1761),(33195,1762),(33196,1762),(33197,1762),(33198,1762),(33199,1763),(33200,1763),(33201,1763),(33202,1763),(33203,1764),(33204,1764),(33205,1764),(33206,1764),(33207,1765),(33208,1765),(33209,1765),(33210,1765),(33211,1766),(33212,1767),(33213,1768),(33214,1769),(33215,1770),(33216,1771),(33217,1772),(33218,1773),(33219,1774),(33220,1775),(33221,1776),(33222,1777),(33223,1778),(33224,1779),(33225,1780),(33226,1781),(33227,1782),(33228,1783),(33229,1784),(33230,1785),(33231,1786),(33232,1787),(33233,1788),(33234,1789),(33235,1790),(33236,1791),(33237,1792),(33238,1793),(33239,1794),(33240,1795),(33241,1796),(33242,1797),(33243,1798),(33244,1799),(33245,1800),(33246,1801),(33247,1802),(33248,1803),(33249,1804),(33250,1805),(33251,1806),(33252,1807),(33253,1808),(33254,1809),(33255,1810),(33256,1811),(33257,1812),(33258,1766),(33259,1767),(33260,1768),(33261,1769),(33262,1770),(33263,1771),(33264,1772),(33265,1773),(33266,1774),(33267,1775),(33268,1776),(33269,1777),(33270,1778),(33271,1779),(33272,1780),(33273,1781),(33274,1782),(33275,1783),(33276,1784),(33277,1785),(33278,1786),(33279,1787),(33280,1788),(33281,1789),(33282,1790),(33283,1791),(33284,1792),(33285,1793),(33286,1794),(33287,1795),(33288,1796),(33289,1797),(33290,1798),(33291,1799),(33292,1800),(33293,1801),(33294,1802),(33295,1803),(33296,1804),(33297,1805),(33298,1806),(33299,1807),(33300,1808),(33301,1809),(33302,1810),(33303,1811),(33304,1812),(33305,1766),(33306,1766),(33307,1766),(33308,1766),(33309,1766),(33310,1766),(33311,1767),(33312,1767),(33313,1767),(33314,1767),(33315,1767),(33316,1767),(33317,1768),(33318,1768),(33319,1768),(33320,1768),(33321,1768),(33322,1768),(33323,1769),(33324,1769),(33325,1769),(33326,1769),(33327,1769),(33328,1769),(33329,1769),(33330,1770),(33331,1770),(33332,1770),(33333,1770),(33334,1770),(33335,1770),(33336,1771),(33337,1771),(33338,1771),(33339,1771),(33340,1771),(33341,1771),(33342,1772),(33343,1772),(33344,1772),(33345,1772),(33346,1772),(33347,1772),(33348,1772),(33349,1773),(33350,1773),(33351,1773),(33352,1773),(33353,1773),(33354,1773),(33355,1773),(33356,1773),(33357,1773),(33358,1774),(33359,1774),(33360,1774),(33361,1774),(33362,1774),(33363,1774),(33364,1774),(33365,1775),(33366,1775),(33367,1775),(33368,1775),(33369,1775),(33370,1775),(33371,1775),(33372,1776),(33373,1776),(33374,1776),(33375,1776),(33376,1776),(33377,1776),(33378,1776),(33379,1777),(33380,1777),(33381,1777),(33382,1777),(33383,1777),(33384,1777),(33385,1778),(33386,1778),(33387,1778),(33388,1778),(33389,1778),(33390,1778),(33391,1778),(33392,1779),(33393,1779),(33394,1779),(33395,1779),(33396,1779),(33397,1779),(33398,1779),(33399,1780),(33400,1780),(33401,1780),(33402,1780),(33403,1780),(33404,1780),(33405,1780),(33406,1781),(33407,1781),(33408,1781),(33409,1781),(33410,1781),(33411,1781),(33412,1781),(33413,1782),(33414,1782),(33415,1782),(33416,1782),(33417,1782),(33418,1782),(33419,1782),(33420,1783),(33421,1783),(33422,1783),(33423,1783),(33424,1783),(33425,1783),(33426,1783),(33427,1784),(33428,1784),(33429,1784),(33430,1784),(33431,1784),(33432,1784),(33433,1784),(33434,1785),(33435,1785),(33436,1785),(33437,1785),(33438,1785),(33439,1785),(33440,1786),(33441,1786),(33442,1786),(33443,1786),(33444,1786),(33445,1786),(33446,1786),(33447,1787),(33448,1787),(33449,1787),(33450,1787),(33451,1787),(33452,1787),(33453,1787),(33454,1788),(33455,1788),(33456,1788),(33457,1788),(33458,1788),(33459,1788),(33460,1788),(33461,1789),(33462,1789),(33463,1789),(33464,1789),(33465,1789),(33466,1789),(33467,1789),(33468,1790),(33469,1790),(33470,1790),(33471,1790),(33472,1790),(33473,1790),(33474,1790),(33475,1791),(33476,1791),(33477,1791),(33478,1791),(33479,1791),(33480,1791),(33481,1791),(33482,1791),(33483,1791),(33484,1792),(33485,1792),(33486,1792),(33487,1792),(33488,1792),(33489,1792),(33490,1792),(33491,1792),(33492,1792),(33493,1793),(33494,1793),(33495,1793),(33496,1793),(33497,1793),(33498,1793),(33499,1793),(33500,1794),(33501,1794),(33502,1794),(33503,1794),(33504,1794),(33505,1794),(33506,1794),(33507,1795),(33508,1795),(33509,1795),(33510,1795),(33511,1795),(33512,1795),(33513,1795),(33514,1796),(33515,1796),(33516,1796),(33517,1796),(33518,1796),(33519,1796),(33520,1796),(33521,1796),(33522,1796),(33523,1797),(33524,1797),(33525,1797),(33526,1797),(33527,1797),(33528,1797),(33529,1797),(33530,1797),(33531,1797),(33532,1798),(33533,1798),(33534,1798),(33535,1798),(33536,1798),(33537,1798),(33538,1798),(33539,1798),(33540,1798),(33541,1799),(33542,1799),(33543,1799),(33544,1799),(33545,1799),(33546,1799),(33547,1799),(33548,1800),(33549,1800),(33550,1800),(33551,1800),(33552,1800),(33553,1800),(33554,1800),(33555,1801),(33556,1801),(33557,1801),(33558,1801),(33559,1801),(33560,1801),(33561,1801),(33562,1802),(33563,1802),(33564,1802),(33565,1802),(33566,1802),(33567,1802),(33568,1802),(33569,1803),(33570,1803),(33571,1803),(33572,1803),(33573,1803),(33574,1803),(33575,1803),(33576,1803),(33577,1803),(33578,1804),(33579,1804),(33580,1804),(33581,1804),(33582,1804),(33583,1804),(33584,1804),(33585,1804),(33586,1804),(33587,1805),(33588,1805),(33589,1805),(33590,1805),(33591,1805),(33592,1805),(33593,1805),(33594,1805),(33595,1805),(33596,1806),(33597,1806),(33598,1806),(33599,1806),(33600,1806),(33601,1806),(33602,1806),(33603,1806),(33604,1806),(33605,1807),(33606,1807),(33607,1807),(33608,1807),(33609,1807),(33610,1807),(33611,1807),(33612,1807),(33613,1807),(33614,1808),(33615,1808),(33616,1808),(33617,1808),(33618,1808),(33619,1808),(33620,1808),(33621,1808),(33622,1808),(33623,1809),(33624,1809),(33625,1809),(33626,1809),(33627,1809),(33628,1809),(33629,1809),(33630,1809),(33631,1809),(33632,1810),(33633,1810),(33634,1810),(33635,1810),(33636,1810),(33637,1810),(33638,1810),(33639,1810),(33640,1810),(33641,1811),(33642,1811),(33643,1811),(33644,1811),(33645,1811),(33646,1811),(33647,1811),(33648,1811),(33649,1811),(33650,1812),(33651,1812),(33652,1812),(33653,1812),(33654,1812),(33655,1812),(33656,1766),(33657,1766),(33658,1766),(33659,1767),(33660,1767),(33661,1767),(33662,1768),(33663,1768),(33664,1768),(33665,1769),(33666,1769),(33667,1769),(33668,1770),(33669,1770),(33670,1770),(33671,1771),(33672,1771),(33673,1771),(33674,1772),(33675,1772),(33676,1772),(33677,1773),(33678,1773),(33679,1774),(33680,1774),(33681,1774),(33682,1775),(33683,1775),(33684,1776),(33685,1776),(33686,1776),(33687,1777),(33688,1777),(33689,1777),(33690,1778),(33691,1778),(33692,1779),(33693,1779),(33694,1780),(33695,1780),(33696,1781),(33697,1781),(33698,1782),(33699,1782),(33700,1783),(33701,1783),(33702,1783),(33703,1784),(33704,1784),(33705,1784),(33706,1785),(33707,1785),(33708,1786),(33709,1786),(33710,1787),(33711,1787),(33712,1788),(33713,1788),(33714,1789),(33715,1789),(33716,1790),(33717,1790),(33718,1791),(33719,1791),(33720,1792),(33721,1792),(33722,1793),(33723,1793),(33724,1794),(33725,1794),(33726,1795),(33727,1795),(33728,1796),(33729,1796),(33730,1796),(33731,1797),(33732,1797),(33733,1797),(33734,1798),(33735,1798),(33736,1799),(33737,1799),(33738,1800),(33739,1800),(33740,1801),(33741,1801),(33742,1802),(33743,1802),(33744,1803),(33745,1803),(33746,1804),(33747,1804),(33748,1805),(33749,1805),(33750,1806),(33751,1806),(33752,1807),(33753,1807),(33754,1808),(33755,1808),(33756,1809),(33757,1809),(33758,1810),(33759,1810),(33760,1811),(33761,1811),(33762,1812),(33763,1812),(33764,1812),(33765,1766),(33766,1766),(33767,1766),(33768,1767),(33769,1767),(33770,1767),(33771,1768),(33772,1768),(33773,1768),(33774,1769),(33775,1769),(33776,1769),(33777,1770),(33778,1770),(33779,1770),(33780,1771),(33781,1771),(33782,1771),(33783,1772),(33784,1772),(33785,1772),(33786,1773),(33787,1773),(33788,1773),(33789,1774),(33790,1774),(33791,1774),(33792,1775),(33793,1775),(33794,1775),(33795,1776),(33796,1776),(33797,1776),(33798,1777),(33799,1777),(33800,1777),(33801,1778),(33802,1778),(33803,1778),(33804,1779),(33805,1779),(33806,1779),(33807,1780),(33808,1780),(33809,1780),(33810,1781),(33811,1781),(33812,1781),(33813,1782),(33814,1782),(33815,1782),(33816,1783),(33817,1783),(33818,1783),(33819,1784),(33820,1784),(33821,1784),(33822,1785),(33823,1785),(33824,1785),(33825,1786),(33826,1786),(33827,1786),(33828,1787),(33829,1787),(33830,1787),(33831,1788),(33832,1788),(33833,1788),(33834,1789),(33835,1789),(33836,1789),(33837,1790),(33838,1790),(33839,1790),(33840,1791),(33841,1791),(33842,1791),(33843,1792),(33844,1792),(33845,1792),(33846,1793),(33847,1793),(33848,1793),(33849,1794),(33850,1794),(33851,1794),(33852,1795),(33853,1795),(33854,1795),(33855,1796),(33856,1796),(33857,1797),(33858,1797),(33859,1798),(33860,1798),(33861,1798),(33862,1799),(33863,1799),(33864,1799),(33865,1800),(33866,1800),(33867,1800),(33868,1801),(33869,1801),(33870,1801),(33871,1802),(33872,1802),(33873,1802),(33874,1803),(33875,1803),(33876,1803),(33877,1803),(33878,1804),(33879,1804),(33880,1804),(33881,1805),(33882,1805),(33883,1805),(33884,1806),(33885,1806),(33886,1806),(33887,1807),(33888,1807),(33889,1807),(33890,1808),(33891,1808),(33892,1808),(33893,1809),(33894,1809),(33895,1809),(33896,1810),(33897,1810),(33898,1810),(33899,1811),(33900,1811),(33901,1811),(33902,1812),(33903,1812),(33904,1812),(33905,1766),(33906,1766),(33907,1766),(33908,1766),(33909,1767),(33910,1767),(33911,1767),(33912,1767),(33913,1768),(33914,1768),(33915,1768),(33916,1768),(33917,1769),(33918,1769),(33919,1769),(33920,1769),(33921,1770),(33922,1770),(33923,1770),(33924,1770),(33925,1771),(33926,1771),(33927,1771),(33928,1771),(33929,1772),(33930,1772),(33931,1772),(33932,1772),(33933,1773),(33934,1773),(33935,1773),(33936,1773),(33937,1774),(33938,1774),(33939,1774),(33940,1774),(33941,1775),(33942,1775),(33943,1775),(33944,1775),(33945,1776),(33946,1776),(33947,1776),(33948,1776),(33949,1777),(33950,1777),(33951,1777),(33952,1777),(33953,1778),(33954,1778),(33955,1778),(33956,1778),(33957,1779),(33958,1779),(33959,1779),(33960,1779),(33961,1780),(33962,1780),(33963,1780),(33964,1780),(33965,1781),(33966,1781),(33967,1781),(33968,1781),(33969,1782),(33970,1782),(33971,1782),(33972,1782),(33973,1783),(33974,1783),(33975,1783),(33976,1783),(33977,1784),(33978,1784),(33979,1784),(33980,1784),(33981,1785),(33982,1785),(33983,1785),(33984,1785),(33985,1786),(33986,1786),(33987,1786),(33988,1786),(33989,1787),(33990,1787),(33991,1787),(33992,1787),(33993,1788),(33994,1788),(33995,1788),(33996,1788),(33997,1789),(33998,1789),(33999,1789),(34000,1789),(34001,1790),(34002,1790),(34003,1790),(34004,1790),(34005,1791),(34006,1791),(34007,1791),(34008,1791),(34009,1792),(34010,1792),(34011,1792),(34012,1792),(34013,1793),(34014,1793),(34015,1793),(34016,1793),(34017,1794),(34018,1794),(34019,1794),(34020,1794),(34021,1795),(34022,1795),(34023,1795),(34024,1795),(34025,1796),(34026,1796),(34027,1796),(34028,1796),(34029,1797),(34030,1797),(34031,1797),(34032,1797),(34033,1798),(34034,1798),(34035,1798),(34036,1798),(34037,1799),(34038,1799),(34039,1799),(34040,1799),(34041,1800),(34042,1800),(34043,1800),(34044,1800),(34045,1801),(34046,1801),(34047,1801),(34048,1801),(34049,1802),(34050,1802),(34051,1802),(34052,1802),(34053,1803),(34054,1803),(34055,1803),(34056,1803),(34057,1804),(34058,1804),(34059,1804),(34060,1804),(34061,1805),(34062,1805),(34063,1805),(34064,1805),(34065,1806),(34066,1806),(34067,1806),(34068,1806),(34069,1807),(34070,1807),(34071,1807),(34072,1807),(34073,1808),(34074,1808),(34075,1808),(34076,1808),(34077,1809),(34078,1809),(34079,1809),(34080,1809),(34081,1810),(34082,1810),(34083,1810),(34084,1810),(34085,1811),(34086,1811),(34087,1811),(34088,1811),(34089,1812),(34090,1812),(34091,1812),(34092,1812),(34093,1813),(34094,1814),(34095,1815),(34096,1816),(34097,1817),(34098,1818),(34099,1819),(34100,1820),(34101,1821),(34102,1822),(34103,1823),(34104,1813),(34105,1814),(34106,1815),(34107,1816),(34108,1817),(34109,1818),(34110,1819),(34111,1820),(34112,1821),(34113,1822),(34114,1823),(34115,1813),(34116,1813),(34117,1813),(34118,1813),(34119,1813),(34120,1813),(34121,1813),(34122,1814),(34123,1814),(34124,1814),(34125,1814),(34126,1814),(34127,1814),(34128,1814),(34129,1815),(34130,1815),(34131,1815),(34132,1815),(34133,1815),(34134,1815),(34135,1815),(34136,1816),(34137,1816),(34138,1816),(34139,1816),(34140,1816),(34141,1816),(34142,1816),(34143,1817),(34144,1817),(34145,1817),(34146,1817),(34147,1817),(34148,1817),(34149,1817),(34150,1818),(34151,1818),(34152,1818),(34153,1818),(34154,1818),(34155,1818),(34156,1818),(34157,1819),(34158,1819),(34159,1819),(34160,1819),(34161,1819),(34162,1819),(34163,1819),(34164,1820),(34165,1820),(34166,1820),(34167,1820),(34168,1820),(34169,1820),(34170,1820),(34171,1821),(34172,1821),(34173,1821),(34174,1821),(34175,1821),(34176,1821),(34177,1821),(34178,1822),(34179,1822),(34180,1822),(34181,1822),(34182,1822),(34183,1822),(34184,1822),(34185,1823),(34186,1823),(34187,1823),(34188,1823),(34189,1823),(34190,1823),(34191,1823),(34192,1813),(34193,1813),(34194,1813),(34195,1814),(34196,1814),(34197,1815),(34198,1815),(34199,1815),(34200,1816),(34201,1816),(34202,1816),(34203,1817),(34204,1817),(34205,1818),(34206,1818),(34207,1818),(34208,1819),(34209,1819),(34210,1819),(34211,1820),(34212,1820),(34213,1820),(34214,1821),(34215,1821),(34216,1822),(34217,1822),(34218,1822),(34219,1823),(34220,1823),(34221,1823),(34222,1813),(34223,1813),(34224,1813),(34225,1814),(34226,1814),(34227,1814),(34228,1815),(34229,1815),(34230,1815),(34231,1816),(34232,1816),(34233,1816),(34234,1817),(34235,1817),(34236,1817),(34237,1818),(34238,1818),(34239,1818),(34240,1819),(34241,1819),(34242,1819),(34243,1820),(34244,1820),(34245,1820),(34246,1821),(34247,1821),(34248,1821),(34249,1822),(34250,1822),(34251,1822),(34252,1823),(34253,1823),(34254,1823),(34255,1813),(34256,1813),(34257,1813),(34258,1813),(34259,1814),(34260,1814),(34261,1814),(34262,1814),(34263,1815),(34264,1815),(34265,1815),(34266,1815),(34267,1816),(34268,1816),(34269,1816),(34270,1816),(34271,1817),(34272,1817),(34273,1817),(34274,1817),(34275,1818),(34276,1818),(34277,1818),(34278,1818),(34279,1819),(34280,1819),(34281,1819),(34282,1819),(34283,1820),(34284,1820),(34285,1820),(34286,1820),(34287,1821),(34288,1821),(34289,1821),(34290,1821),(34291,1822),(34292,1822),(34293,1822),(34294,1822),(34295,1823),(34296,1823),(34297,1823),(34298,1823),(34299,1824),(34300,1825),(34301,1826),(34302,1827),(34303,1828),(34304,1829),(34305,1830),(34306,1831),(34307,1832),(34308,1833),(34309,1834),(34310,1835),(34311,1836),(34312,1837),(34313,1838),(34314,1839),(34315,1840),(34316,1841),(34317,1842),(34318,1843),(34319,1844),(34320,1845),(34321,1846),(34322,1847),(34323,1848),(34324,1849),(34325,1850),(34326,1851),(34327,1852),(34328,1853),(34329,1854),(34330,1855),(34331,1856),(34332,1857),(34333,1858),(34334,1859),(34335,1860),(34336,1861),(34337,1862),(34338,1863),(34339,1864),(34340,1865),(34341,1866),(34342,1867),(34343,1868),(34344,1869),(34345,1870),(34346,1871),(34347,1872),(34348,1873),(34349,1874),(34350,1875),(34351,1876),(34352,1877),(34353,1878),(34354,1879),(34355,1880),(34356,1881),(34357,1882),(34358,1883),(34359,1884),(34360,1885),(34361,1886),(34362,1887),(34363,1888),(34364,1889),(34365,1890),(34366,1891),(34367,1892),(34368,1893),(34369,1894),(34370,1895),(34371,1896),(34372,1897),(34373,1898),(34374,1899),(34375,1900),(34376,1901),(34377,1902),(34378,1903),(34379,1904),(34380,1905),(34381,1906),(34382,1907),(34383,1908),(34384,1909),(34385,1910),(34386,1911),(34387,1912),(34388,1824),(34389,1825),(34390,1826),(34391,1827),(34392,1828),(34393,1829),(34394,1830),(34395,1831),(34396,1832),(34397,1833),(34398,1834),(34399,1835),(34400,1836),(34401,1837),(34402,1838),(34403,1839),(34404,1840),(34405,1841),(34406,1842),(34407,1843),(34408,1844),(34409,1845),(34410,1846),(34411,1847),(34412,1848),(34413,1849),(34414,1850),(34415,1851),(34416,1852),(34417,1853),(34418,1854),(34419,1855),(34420,1856),(34421,1857),(34422,1858),(34423,1859),(34424,1860),(34425,1861),(34426,1862),(34427,1863),(34428,1864),(34429,1865),(34430,1866),(34431,1867),(34432,1868),(34433,1869),(34434,1870),(34435,1871),(34436,1872),(34437,1873),(34438,1874),(34439,1875),(34440,1876),(34441,1877),(34442,1878),(34443,1879),(34444,1880),(34445,1881),(34446,1882),(34447,1883),(34448,1884),(34449,1885),(34450,1886),(34451,1887),(34452,1888),(34453,1889),(34454,1890),(34455,1891),(34456,1892),(34457,1893),(34458,1894),(34459,1895),(34460,1896),(34461,1897),(34462,1898),(34463,1899),(34464,1900),(34465,1901),(34466,1902),(34467,1903),(34468,1904),(34469,1905),(34470,1906),(34471,1907),(34472,1908),(34473,1909),(34474,1910),(34475,1911),(34476,1912),(34477,1824),(34478,1824),(34479,1824),(34480,1824),(34481,1824),(34482,1824),(34483,1824),(34484,1824),(34485,1824),(34486,1825),(34487,1825),(34488,1825),(34489,1825),(34490,1825),(34491,1825),(34492,1825),(34493,1826),(34494,1826),(34495,1826),(34496,1826),(34497,1826),(34498,1826),(34499,1826),(34500,1827),(34501,1827),(34502,1827),(34503,1827),(34504,1827),(34505,1827),(34506,1827),(34507,1828),(34508,1828),(34509,1828),(34510,1828),(34511,1828),(34512,1828),(34513,1828),(34514,1829),(34515,1829),(34516,1829),(34517,1829),(34518,1829),(34519,1829),(34520,1829),(34521,1830),(34522,1830),(34523,1830),(34524,1830),(34525,1830),(34526,1830),(34527,1830),(34528,1831),(34529,1831),(34530,1831),(34531,1831),(34532,1831),(34533,1831),(34534,1831),(34535,1832),(34536,1832),(34537,1832),(34538,1832),(34539,1832),(34540,1832),(34541,1832),(34542,1833),(34543,1833),(34544,1833),(34545,1833),(34546,1833),(34547,1833),(34548,1833),(34549,1834),(34550,1834),(34551,1834),(34552,1834),(34553,1834),(34554,1834),(34555,1835),(34556,1835),(34557,1835),(34558,1835),(34559,1836),(34560,1836),(34561,1836),(34562,1836),(34563,1836),(34564,1836),(34565,1836),(34566,1836),(34567,1836),(34568,1837),(34569,1837),(34570,1837),(34571,1837),(34572,1837),(34573,1837),(34574,1837),(34575,1837),(34576,1837),(34577,1838),(34578,1838),(34579,1838),(34580,1838),(34581,1838),(34582,1838),(34583,1838),(34584,1838),(34585,1838),(34586,1839),(34587,1839),(34588,1839),(34589,1839),(34590,1839),(34591,1839),(34592,1839),(34593,1839),(34594,1839),(34595,1840),(34596,1840),(34597,1840),(34598,1840),(34599,1840),(34600,1840),(34601,1840),(34602,1840),(34603,1840),(34604,1841),(34605,1841),(34606,1841),(34607,1841),(34608,1841),(34609,1841),(34610,1841),(34611,1841),(34612,1841),(34613,1842),(34614,1842),(34615,1842),(34616,1842),(34617,1842),(34618,1842),(34619,1842),(34620,1842),(34621,1842),(34622,1843),(34623,1843),(34624,1843),(34625,1843),(34626,1843),(34627,1843),(34628,1843),(34629,1843),(34630,1843),(34631,1844),(34632,1844),(34633,1844),(34634,1844),(34635,1844),(34636,1844),(34637,1844),(34638,1844),(34639,1844),(34640,1845),(34641,1845),(34642,1845),(34643,1845),(34644,1845),(34645,1845),(34646,1845),(34647,1845),(34648,1845),(34649,1846),(34650,1846),(34651,1846),(34652,1846),(34653,1846),(34654,1846),(34655,1846),(34656,1846),(34657,1846),(34658,1847),(34659,1847),(34660,1847),(34661,1847),(34662,1847),(34663,1847),(34664,1847),(34665,1847),(34666,1847),(34667,1848),(34668,1848),(34669,1848),(34670,1848),(34671,1848),(34672,1848),(34673,1848),(34674,1848),(34675,1848),(34676,1849),(34677,1849),(34678,1849),(34679,1849),(34680,1849),(34681,1849),(34682,1849),(34683,1849),(34684,1849),(34685,1850),(34686,1850),(34687,1850),(34688,1850),(34689,1850),(34690,1850),(34691,1850),(34692,1850),(34693,1850),(34694,1851),(34695,1851),(34696,1851),(34697,1851),(34698,1851),(34699,1851),(34700,1851),(34701,1851),(34702,1851),(34703,1852),(34704,1852),(34705,1852),(34706,1852),(34707,1852),(34708,1852),(34709,1852),(34710,1852),(34711,1852),(34712,1853),(34713,1853),(34714,1853),(34715,1853),(34716,1853),(34717,1853),(34718,1853),(34719,1853),(34720,1853),(34721,1854),(34722,1854),(34723,1854),(34724,1854),(34725,1854),(34726,1854),(34727,1854),(34728,1854),(34729,1854),(34730,1855),(34731,1855),(34732,1855),(34733,1855),(34734,1855),(34735,1855),(34736,1855),(34737,1855),(34738,1855),(34739,1856),(34740,1856),(34741,1856),(34742,1856),(34743,1856),(34744,1856),(34745,1856),(34746,1856),(34747,1856),(34748,1857),(34749,1857),(34750,1857),(34751,1857),(34752,1857),(34753,1857),(34754,1857),(34755,1857),(34756,1857),(34757,1858),(34758,1858),(34759,1858),(34760,1858),(34761,1858),(34762,1858),(34763,1858),(34764,1858),(34765,1858),(34766,1859),(34767,1859),(34768,1859),(34769,1859),(34770,1859),(34771,1859),(34772,1859),(34773,1859),(34774,1859),(34775,1860),(34776,1860),(34777,1860),(34778,1860),(34779,1860),(34780,1860),(34781,1860),(34782,1860),(34783,1860),(34784,1861),(34785,1861),(34786,1861),(34787,1861),(34788,1861),(34789,1861),(34790,1861),(34791,1861),(34792,1861),(34793,1862),(34794,1862),(34795,1862),(34796,1862),(34797,1862),(34798,1862),(34799,1862),(34800,1862),(34801,1862),(34802,1863),(34803,1863),(34804,1863),(34805,1863),(34806,1863),(34807,1863),(34808,1863),(34809,1863),(34810,1863),(34811,1864),(34812,1864),(34813,1864),(34814,1864),(34815,1864),(34816,1864),(34817,1864),(34818,1864),(34819,1864),(34820,1865),(34821,1865),(34822,1865),(34823,1865),(34824,1865),(34825,1865),(34826,1865),(34827,1865),(34828,1865),(34829,1866),(34830,1866),(34831,1866),(34832,1866),(34833,1866),(34834,1866),(34835,1866),(34836,1867),(34837,1867),(34838,1867),(34839,1867),(34840,1867),(34841,1867),(34842,1867),(34843,1867),(34844,1867),(34845,1868),(34846,1868),(34847,1868),(34848,1868),(34849,1868),(34850,1868),(34851,1868),(34852,1869),(34853,1869),(34854,1869),(34855,1869),(34856,1869),(34857,1869),(34858,1869),(34859,1869),(34860,1869),(34861,1870),(34862,1870),(34863,1870),(34864,1870),(34865,1870),(34866,1870),(34867,1870),(34868,1870),(34869,1870),(34870,1871),(34871,1871),(34872,1871),(34873,1871),(34874,1871),(34875,1871),(34876,1871),(34877,1871),(34878,1871),(34879,1872),(34880,1872),(34881,1872),(34882,1872),(34883,1872),(34884,1872),(34885,1872),(34886,1872),(34887,1872),(34888,1873),(34889,1873),(34890,1873),(34891,1873),(34892,1873),(34893,1873),(34894,1873),(34895,1873),(34896,1873),(34897,1874),(34898,1874),(34899,1874),(34900,1874),(34901,1874),(34902,1874),(34903,1874),(34904,1874),(34905,1874),(34906,1875),(34907,1875),(34908,1875),(34909,1875),(34910,1875),(34911,1875),(34912,1875),(34913,1875),(34914,1875),(34915,1876),(34916,1876),(34917,1876),(34918,1876),(34919,1876),(34920,1876),(34921,1876),(34922,1876),(34923,1876),(34924,1877),(34925,1877),(34926,1877),(34927,1877),(34928,1877),(34929,1877),(34930,1877),(34931,1878),(34932,1878),(34933,1878),(34934,1878),(34935,1878),(34936,1878),(34937,1878),(34938,1879),(34939,1879),(34940,1879),(34941,1879),(34942,1879),(34943,1879),(34944,1879),(34945,1879),(34946,1879),(34947,1880),(34948,1880),(34949,1880),(34950,1880),(34951,1880),(34952,1880),(34953,1880),(34954,1881),(34955,1881),(34956,1881),(34957,1881),(34958,1881),(34959,1881),(34960,1881),(34961,1882),(34962,1882),(34963,1882),(34964,1882),(34965,1882),(34966,1882),(34967,1882),(34968,1882),(34969,1882),(34970,1883),(34971,1883),(34972,1883),(34973,1883),(34974,1883),(34975,1883),(34976,1883),(34977,1883),(34978,1883),(34979,1884),(34980,1884),(34981,1884),(34982,1884),(34983,1884),(34984,1884),(34985,1884),(34986,1884),(34987,1884),(34988,1885),(34989,1885),(34990,1885),(34991,1885),(34992,1885),(34993,1885),(34994,1885),(34995,1885),(34996,1885),(34997,1886),(34998,1886),(34999,1886),(35000,1886),(35001,1886),(35002,1886),(35003,1886),(35004,1886),(35005,1886),(35006,1887),(35007,1887),(35008,1887),(35009,1887),(35010,1887),(35011,1887),(35012,1887),(35013,1887),(35014,1887),(35015,1888),(35016,1888),(35017,1888),(35018,1888),(35019,1888),(35020,1888),(35021,1888),(35022,1888),(35023,1888),(35024,1889),(35025,1889),(35026,1889),(35027,1889),(35028,1889),(35029,1889),(35030,1889),(35031,1889),(35032,1889),(35033,1890),(35034,1890),(35035,1890),(35036,1890),(35037,1890),(35038,1890),(35039,1890),(35040,1890),(35041,1890),(35042,1891),(35043,1891),(35044,1891),(35045,1891),(35046,1891),(35047,1891),(35048,1891),(35049,1891),(35050,1891),(35051,1892),(35052,1892),(35053,1892),(35054,1892),(35055,1892),(35056,1892),(35057,1892),(35058,1892),(35059,1892),(35060,1893),(35061,1893),(35062,1893),(35063,1893),(35064,1893),(35065,1893),(35066,1893),(35067,1893),(35068,1893),(35069,1894),(35070,1894),(35071,1894),(35072,1894),(35073,1894),(35074,1894),(35075,1894),(35076,1894),(35077,1894),(35078,1895),(35079,1895),(35080,1895),(35081,1895),(35082,1895),(35083,1895),(35084,1895),(35085,1895),(35086,1895),(35087,1896),(35088,1896),(35089,1896),(35090,1896),(35091,1896),(35092,1896),(35093,1896),(35094,1896),(35095,1896),(35096,1897),(35097,1897),(35098,1897),(35099,1897),(35100,1897),(35101,1897),(35102,1897),(35103,1897),(35104,1897),(35105,1898),(35106,1898),(35107,1898),(35108,1898),(35109,1898),(35110,1898),(35111,1898),(35112,1898),(35113,1898),(35114,1899),(35115,1899),(35116,1899),(35117,1899),(35118,1899),(35119,1899),(35120,1899),(35121,1899),(35122,1899),(35123,1900),(35124,1900),(35125,1900),(35126,1900),(35127,1900),(35128,1900),(35129,1900),(35130,1900),(35131,1900),(35132,1901),(35133,1901),(35134,1901),(35135,1901),(35136,1901),(35137,1901),(35138,1901),(35139,1901),(35140,1901),(35141,1902),(35142,1902),(35143,1902),(35144,1902),(35145,1902),(35146,1902),(35147,1902),(35148,1902),(35149,1902),(35150,1903),(35151,1903),(35152,1903),(35153,1903),(35154,1903),(35155,1903),(35156,1903),(35157,1903),(35158,1903),(35159,1904),(35160,1904),(35161,1904),(35162,1904),(35163,1904),(35164,1904),(35165,1904),(35166,1904),(35167,1904),(35168,1905),(35169,1905),(35170,1905),(35171,1905),(35172,1905),(35173,1905),(35174,1905),(35175,1905),(35176,1905),(35177,1906),(35178,1906),(35179,1906),(35180,1906),(35181,1906),(35182,1906),(35183,1906),(35184,1906),(35185,1906),(35186,1907),(35187,1907),(35188,1907),(35189,1907),(35190,1907),(35191,1907),(35192,1907),(35193,1907),(35194,1907),(35195,1908),(35196,1908),(35197,1908),(35198,1908),(35199,1908),(35200,1908),(35201,1908),(35202,1908),(35203,1908),(35204,1909),(35205,1909),(35206,1909),(35207,1909),(35208,1909),(35209,1909),(35210,1909),(35211,1909),(35212,1909),(35213,1910),(35214,1910),(35215,1910),(35216,1910),(35217,1910),(35218,1910),(35219,1910),(35220,1910),(35221,1910),(35222,1911),(35223,1911),(35224,1911),(35225,1911),(35226,1911),(35227,1911),(35228,1911),(35229,1911),(35230,1911),(35231,1912),(35232,1912),(35233,1912),(35234,1912),(35235,1912),(35236,1912),(35237,1912),(35238,1912),(35239,1912),(35240,1824),(35241,1824),(35242,1824),(35243,1825),(35244,1825),(35245,1825),(35246,1826),(35247,1826),(35248,1826),(35249,1827),(35250,1827),(35251,1828),(35252,1828),(35253,1829),(35254,1829),(35255,1830),(35256,1830),(35257,1831),(35258,1831),(35259,1832),(35260,1832),(35261,1832),(35262,1833),(35263,1833),(35264,1833),(35265,1834),(35266,1834),(35267,1834),(35268,1835),(35269,1835),(35270,1836),(35271,1836),(35272,1837),(35273,1837),(35274,1838),(35275,1838),(35276,1839),(35277,1839),(35278,1840),(35279,1840),(35280,1841),(35281,1841),(35282,1842),(35283,1842),(35284,1843),(35285,1843),(35286,1844),(35287,1844),(35288,1845),(35289,1845),(35290,1846),(35291,1846),(35292,1847),(35293,1847),(35294,1848),(35295,1848),(35296,1849),(35297,1849),(35298,1850),(35299,1850),(35300,1851),(35301,1851),(35302,1852),(35303,1852),(35304,1853),(35305,1853),(35306,1854),(35307,1854),(35308,1855),(35309,1855),(35310,1856),(35311,1856),(35312,1857),(35313,1857),(35314,1858),(35315,1858),(35316,1859),(35317,1859),(35318,1860),(35319,1860),(35320,1861),(35321,1861),(35322,1862),(35323,1862),(35324,1863),(35325,1863),(35326,1864),(35327,1864),(35328,1865),(35329,1865),(35330,1866),(35331,1866),(35332,1867),(35333,1867),(35334,1868),(35335,1868),(35336,1869),(35337,1869),(35338,1870),(35339,1870),(35340,1871),(35341,1871),(35342,1872),(35343,1872),(35344,1873),(35345,1873),(35346,1874),(35347,1874),(35348,1875),(35349,1875),(35350,1876),(35351,1876),(35352,1877),(35353,1877),(35354,1878),(35355,1878),(35356,1879),(35357,1879),(35358,1880),(35359,1880),(35360,1881),(35361,1881),(35362,1882),(35363,1882),(35364,1883),(35365,1883),(35366,1884),(35367,1884),(35368,1885),(35369,1885),(35370,1886),(35371,1886),(35372,1887),(35373,1887),(35374,1888),(35375,1888),(35376,1889),(35377,1889),(35378,1890),(35379,1890),(35380,1891),(35381,1891),(35382,1892),(35383,1892),(35384,1893),(35385,1893),(35386,1894),(35387,1894),(35388,1895),(35389,1895),(35390,1896),(35391,1896),(35392,1897),(35393,1897),(35394,1898),(35395,1898),(35396,1899),(35397,1899),(35398,1900),(35399,1900),(35400,1901),(35401,1901),(35402,1902),(35403,1902),(35404,1903),(35405,1903),(35406,1904),(35407,1904),(35408,1905),(35409,1905),(35410,1906),(35411,1906),(35412,1907),(35413,1907),(35414,1908),(35415,1908),(35416,1909),(35417,1909),(35418,1910),(35419,1910),(35420,1911),(35421,1911),(35422,1912),(35423,1912),(35424,1824),(35425,1824),(35426,1824),(35427,1825),(35428,1825),(35429,1825),(35430,1826),(35431,1826),(35432,1826),(35433,1827),(35434,1827),(35435,1827),(35436,1828),(35437,1828),(35438,1828),(35439,1829),(35440,1829),(35441,1829),(35442,1830),(35443,1830),(35444,1830),(35445,1831),(35446,1831),(35447,1831),(35448,1832),(35449,1832),(35450,1832),(35451,1833),(35452,1833),(35453,1833),(35454,1834),(35455,1834),(35456,1834),(35457,1835),(35458,1835),(35459,1835),(35460,1836),(35461,1836),(35462,1836),(35463,1837),(35464,1837),(35465,1837),(35466,1838),(35467,1838),(35468,1838),(35469,1839),(35470,1839),(35471,1839),(35472,1840),(35473,1840),(35474,1840),(35475,1841),(35476,1841),(35477,1841),(35478,1842),(35479,1842),(35480,1842),(35481,1843),(35482,1843),(35483,1843),(35484,1844),(35485,1844),(35486,1844),(35487,1845),(35488,1845),(35489,1845),(35490,1846),(35491,1846),(35492,1846),(35493,1847),(35494,1847),(35495,1847),(35496,1848),(35497,1848),(35498,1848),(35499,1849),(35500,1849),(35501,1849),(35502,1850),(35503,1850),(35504,1850),(35505,1851),(35506,1851),(35507,1851),(35508,1852),(35509,1852),(35510,1852),(35511,1853),(35512,1853),(35513,1853),(35514,1854),(35515,1854),(35516,1854),(35517,1855),(35518,1855),(35519,1855),(35520,1856),(35521,1856),(35522,1856),(35523,1857),(35524,1857),(35525,1857),(35526,1858),(35527,1858),(35528,1858),(35529,1859),(35530,1859),(35531,1859),(35532,1860),(35533,1860),(35534,1860),(35535,1861),(35536,1861),(35537,1861),(35538,1862),(35539,1862),(35540,1862),(35541,1863),(35542,1863),(35543,1863),(35544,1864),(35545,1864),(35546,1864),(35547,1865),(35548,1865),(35549,1865),(35550,1866),(35551,1866),(35552,1866),(35553,1867),(35554,1867),(35555,1867),(35556,1868),(35557,1868),(35558,1868),(35559,1869),(35560,1869),(35561,1869),(35562,1870),(35563,1870),(35564,1870),(35565,1871),(35566,1871),(35567,1871),(35568,1872),(35569,1872),(35570,1872),(35571,1873),(35572,1873),(35573,1873),(35574,1874),(35575,1874),(35576,1874),(35577,1875),(35578,1875),(35579,1875),(35580,1876),(35581,1876),(35582,1876),(35583,1877),(35584,1877),(35585,1877),(35586,1878),(35587,1878),(35588,1878),(35589,1879),(35590,1879),(35591,1879),(35592,1880),(35593,1880),(35594,1880),(35595,1881),(35596,1881),(35597,1881),(35598,1882),(35599,1882),(35600,1882),(35601,1883),(35602,1883),(35603,1883),(35604,1884),(35605,1884),(35606,1884),(35607,1885),(35608,1885),(35609,1885),(35610,1886),(35611,1886),(35612,1886),(35613,1887),(35614,1887),(35615,1887),(35616,1888),(35617,1888),(35618,1888),(35619,1889),(35620,1889),(35621,1889),(35622,1890),(35623,1890),(35624,1890),(35625,1891),(35626,1891),(35627,1891),(35628,1892),(35629,1892),(35630,1892),(35631,1893),(35632,1893),(35633,1893),(35634,1894),(35635,1894),(35636,1894),(35637,1895),(35638,1895),(35639,1895),(35640,1896),(35641,1896),(35642,1896),(35643,1897),(35644,1897),(35645,1897),(35646,1898),(35647,1898),(35648,1898),(35649,1899),(35650,1899),(35651,1899),(35652,1900),(35653,1900),(35654,1900),(35655,1901),(35656,1901),(35657,1901),(35658,1902),(35659,1902),(35660,1902),(35661,1903),(35662,1903),(35663,1903),(35664,1904),(35665,1904),(35666,1904),(35667,1905),(35668,1905),(35669,1905),(35670,1906),(35671,1906),(35672,1906),(35673,1907),(35674,1907),(35675,1907),(35676,1908),(35677,1908),(35678,1908),(35679,1909),(35680,1909),(35681,1909),(35682,1910),(35683,1910),(35684,1910),(35685,1911),(35686,1911),(35687,1911),(35688,1912),(35689,1912),(35690,1912),(35691,1824),(35692,1824),(35693,1824),(35694,1824),(35695,1825),(35696,1825),(35697,1825),(35698,1825),(35699,1826),(35700,1826),(35701,1826),(35702,1826),(35703,1827),(35704,1827),(35705,1827),(35706,1827),(35707,1828),(35708,1828),(35709,1828),(35710,1828),(35711,1829),(35712,1829),(35713,1829),(35714,1829),(35715,1830),(35716,1830),(35717,1830),(35718,1830),(35719,1831),(35720,1831),(35721,1831),(35722,1831),(35723,1832),(35724,1832),(35725,1832),(35726,1832),(35727,1833),(35728,1833),(35729,1833),(35730,1833),(35731,1834),(35732,1834),(35733,1834),(35734,1834),(35735,1835),(35736,1835),(35737,1835),(35738,1835),(35739,1836),(35740,1836),(35741,1836),(35742,1836),(35743,1837),(35744,1837),(35745,1837),(35746,1837),(35747,1838),(35748,1838),(35749,1838),(35750,1838),(35751,1839),(35752,1839),(35753,1839),(35754,1839),(35755,1840),(35756,1840),(35757,1840),(35758,1840),(35759,1841),(35760,1841),(35761,1841),(35762,1841),(35763,1842),(35764,1842),(35765,1842),(35766,1842),(35767,1843),(35768,1843),(35769,1843),(35770,1843),(35771,1844),(35772,1844),(35773,1844),(35774,1844),(35775,1845),(35776,1845),(35777,1845),(35778,1845),(35779,1846),(35780,1846),(35781,1846),(35782,1846),(35783,1847),(35784,1847),(35785,1847),(35786,1847),(35787,1848),(35788,1848),(35789,1848),(35790,1848),(35791,1849),(35792,1849),(35793,1849),(35794,1849),(35795,1850),(35796,1850),(35797,1850),(35798,1850),(35799,1851),(35800,1851),(35801,1851),(35802,1851),(35803,1852),(35804,1852),(35805,1852),(35806,1852),(35807,1853),(35808,1853),(35809,1853),(35810,1853),(35811,1854),(35812,1854),(35813,1854),(35814,1854),(35815,1855),(35816,1855),(35817,1855),(35818,1855),(35819,1856),(35820,1856),(35821,1856),(35822,1856),(35823,1857),(35824,1857),(35825,1857),(35826,1857),(35827,1858),(35828,1858),(35829,1858),(35830,1858),(35831,1859),(35832,1859),(35833,1859),(35834,1859),(35835,1860),(35836,1860),(35837,1860),(35838,1860),(35839,1861),(35840,1861),(35841,1861),(35842,1861),(35843,1862),(35844,1862),(35845,1862),(35846,1862),(35847,1863),(35848,1863),(35849,1863),(35850,1863),(35851,1864),(35852,1864),(35853,1864),(35854,1864),(35855,1865),(35856,1865),(35857,1865),(35858,1865),(35859,1866),(35860,1866),(35861,1866),(35862,1866),(35863,1867),(35864,1867),(35865,1867),(35866,1867),(35867,1868),(35868,1868),(35869,1868),(35870,1868),(35871,1869),(35872,1869),(35873,1869),(35874,1869),(35875,1870),(35876,1870),(35877,1870),(35878,1870),(35879,1871),(35880,1871),(35881,1871),(35882,1871),(35883,1872),(35884,1872),(35885,1872),(35886,1872),(35887,1873),(35888,1873),(35889,1873),(35890,1873),(35891,1874),(35892,1874),(35893,1874),(35894,1874),(35895,1875),(35896,1875),(35897,1875),(35898,1875),(35899,1876),(35900,1876),(35901,1876),(35902,1876),(35903,1877),(35904,1877),(35905,1877),(35906,1877),(35907,1878),(35908,1878),(35909,1878),(35910,1878),(35911,1879),(35912,1879),(35913,1879),(35914,1879),(35915,1880),(35916,1880),(35917,1880),(35918,1880),(35919,1881),(35920,1881),(35921,1881),(35922,1881),(35923,1882),(35924,1882),(35925,1882),(35926,1882),(35927,1883),(35928,1883),(35929,1883),(35930,1883),(35931,1884),(35932,1884),(35933,1884),(35934,1884),(35935,1885),(35936,1885),(35937,1885),(35938,1885),(35939,1886),(35940,1886),(35941,1886),(35942,1886),(35943,1887),(35944,1887),(35945,1887),(35946,1887),(35947,1888),(35948,1888),(35949,1888),(35950,1888),(35951,1889),(35952,1889),(35953,1889),(35954,1889),(35955,1890),(35956,1890),(35957,1890),(35958,1890),(35959,1891),(35960,1891),(35961,1891),(35962,1891),(35963,1892),(35964,1892),(35965,1892),(35966,1892),(35967,1893),(35968,1893),(35969,1893),(35970,1893),(35971,1894),(35972,1894),(35973,1894),(35974,1894),(35975,1895),(35976,1895),(35977,1895),(35978,1895),(35979,1896),(35980,1896),(35981,1896),(35982,1896),(35983,1897),(35984,1897),(35985,1897),(35986,1897),(35987,1898),(35988,1898),(35989,1898),(35990,1898),(35991,1899),(35992,1899),(35993,1899),(35994,1899),(35995,1900),(35996,1900),(35997,1900),(35998,1900),(35999,1901),(36000,1901),(36001,1901),(36002,1901),(36003,1902),(36004,1902),(36005,1902),(36006,1902),(36007,1903),(36008,1903),(36009,1903),(36010,1903),(36011,1904),(36012,1904),(36013,1904),(36014,1904),(36015,1905),(36016,1905),(36017,1905),(36018,1905),(36019,1906),(36020,1906),(36021,1906),(36022,1906),(36023,1907),(36024,1907),(36025,1907),(36026,1907),(36027,1908),(36028,1908),(36029,1908),(36030,1908),(36031,1909),(36032,1909),(36033,1909),(36034,1909),(36035,1910),(36036,1910),(36037,1910),(36038,1910),(36039,1911),(36040,1911),(36041,1911),(36042,1911),(36043,1912),(36044,1912),(36045,1912),(36046,1912),(36047,1913),(36048,1914),(36049,1915),(36050,1916),(36051,1917),(36052,1918),(36053,1919),(36054,1920),(36055,1921),(36056,1922),(36057,1923),(36058,1924),(36059,1925),(36060,1926),(36061,1927),(36062,1928),(36063,1929),(36064,1930),(36065,1931),(36066,1932),(36067,1933),(36068,1934),(36069,1935),(36070,1936),(36071,1937),(36072,1938),(36073,1939),(36074,1940),(36075,1941),(36076,1942),(36077,1943),(36078,1944),(36079,1945),(36080,1946),(36081,1947),(36082,1948),(36083,1949),(36084,1950),(36085,1951),(36086,1952),(36087,1953),(36088,1954),(36089,1955),(36090,1956),(36091,1957),(36092,1958),(36093,1959),(36094,1960),(36095,1961),(36096,1962),(36097,1963),(36098,1964),(36099,1965),(36100,1966),(36101,1967),(36102,1968),(36103,1969),(36104,1970),(36105,1971),(36106,1972),(36107,1973),(36108,1974),(36109,1975),(36110,1976),(36111,1977),(36112,1978),(36113,1979),(36114,1980),(36115,1981),(36116,1982),(36117,1983),(36118,1984),(36119,1985),(36120,1986),(36121,1987),(36122,1988),(36123,1989),(36124,1990),(36125,1991),(36126,1992),(36127,1993),(36128,1994),(36129,1995),(36130,1996),(36131,1997),(36132,1998),(36133,1999),(36134,2000),(36135,2001),(36136,2002),(36137,2003),(36138,2004),(36139,2005),(36140,2006),(36141,2007),(36142,2008),(36143,2009),(36144,2010),(36145,2011),(36146,2012),(36147,1913),(36148,1914),(36149,1915),(36150,1916),(36151,1917),(36152,1918),(36153,1919),(36154,1920),(36155,1921),(36156,1922),(36157,1923),(36158,1924),(36159,1925),(36160,1926),(36161,1927),(36162,1928),(36163,1929),(36164,1930),(36165,1931),(36166,1932),(36167,1933),(36168,1934),(36169,1935),(36170,1936),(36171,1937),(36172,1938),(36173,1939),(36174,1940),(36175,1941),(36176,1942),(36177,1943),(36178,1944),(36179,1945),(36180,1946),(36181,1947),(36182,1948),(36183,1949),(36184,1950),(36185,1951),(36186,1952),(36187,1953),(36188,1954),(36189,1955),(36190,1956),(36191,1957),(36192,1958),(36193,1959),(36194,1960),(36195,1961),(36196,1962),(36197,1963),(36198,1964),(36199,1965),(36200,1966),(36201,1967),(36202,1968),(36203,1969),(36204,1970),(36205,1971),(36206,1972),(36207,1973),(36208,1974),(36209,1975),(36210,1976),(36211,1977),(36212,1978),(36213,1979),(36214,1980),(36215,1981),(36216,1982),(36217,1983),(36218,1984),(36219,1985),(36220,1986),(36221,1987),(36222,1988),(36223,1989),(36224,1990),(36225,1991),(36226,1992),(36227,1993),(36228,1994),(36229,1995),(36230,1996),(36231,1997),(36232,1998),(36233,1999),(36234,2000),(36235,2001),(36236,2002),(36237,2003),(36238,2004),(36239,2005),(36240,2006),(36241,2007),(36242,2008),(36243,2009),(36244,2010),(36245,2011),(36246,2012),(36247,1913),(36248,1913),(36249,1913),(36250,1913),(36251,1913),(36252,1913),(36253,1913),(36254,1913),(36255,1913),(36256,1914),(36257,1914),(36258,1914),(36259,1914),(36260,1914),(36261,1914),(36262,1914),(36263,1914),(36264,1914),(36265,1915),(36266,1915),(36267,1915),(36268,1915),(36269,1915),(36270,1915),(36271,1915),(36272,1915),(36273,1915),(36274,1916),(36275,1916),(36276,1916),(36277,1916),(36278,1916),(36279,1916),(36280,1916),(36281,1916),(36282,1916),(36283,1917),(36284,1917),(36285,1917),(36286,1917),(36287,1917),(36288,1917),(36289,1917),(36290,1917),(36291,1917),(36292,1918),(36293,1918),(36294,1918),(36295,1918),(36296,1918),(36297,1918),(36298,1918),(36299,1918),(36300,1918),(36301,1919),(36302,1919),(36303,1919),(36304,1919),(36305,1919),(36306,1919),(36307,1919),(36308,1919),(36309,1919),(36310,1920),(36311,1920),(36312,1920),(36313,1920),(36314,1920),(36315,1920),(36316,1920),(36317,1920),(36318,1920),(36319,1921),(36320,1921),(36321,1921),(36322,1921),(36323,1921),(36324,1921),(36325,1921),(36326,1921),(36327,1921),(36328,1922),(36329,1922),(36330,1922),(36331,1922),(36332,1922),(36333,1922),(36334,1922),(36335,1922),(36336,1922),(36337,1923),(36338,1923),(36339,1923),(36340,1923),(36341,1923),(36342,1923),(36343,1923),(36344,1923),(36345,1923),(36346,1924),(36347,1924),(36348,1924),(36349,1924),(36350,1924),(36351,1924),(36352,1924),(36353,1924),(36354,1924),(36355,1925),(36356,1925),(36357,1925),(36358,1925),(36359,1925),(36360,1925),(36361,1925),(36362,1925),(36363,1925),(36364,1926),(36365,1926),(36366,1926),(36367,1926),(36368,1926),(36369,1926),(36370,1926),(36371,1926),(36372,1926),(36373,1927),(36374,1927),(36375,1927),(36376,1927),(36377,1927),(36378,1927),(36379,1927),(36380,1927),(36381,1927),(36382,1928),(36383,1928),(36384,1928),(36385,1928),(36386,1928),(36387,1928),(36388,1928),(36389,1928),(36390,1928),(36391,1929),(36392,1929),(36393,1929),(36394,1929),(36395,1929),(36396,1929),(36397,1929),(36398,1929),(36399,1929),(36400,1930),(36401,1930),(36402,1930),(36403,1930),(36404,1930),(36405,1930),(36406,1930),(36407,1930),(36408,1930),(36409,1931),(36410,1931),(36411,1931),(36412,1931),(36413,1931),(36414,1931),(36415,1931),(36416,1931),(36417,1931),(36418,1932),(36419,1932),(36420,1932),(36421,1932),(36422,1932),(36423,1932),(36424,1932),(36425,1932),(36426,1932),(36427,1933),(36428,1933),(36429,1933),(36430,1933),(36431,1933),(36432,1933),(36433,1933),(36434,1933),(36435,1933),(36436,1934),(36437,1934),(36438,1934),(36439,1934),(36440,1934),(36441,1934),(36442,1934),(36443,1934),(36444,1934),(36445,1935),(36446,1935),(36447,1935),(36448,1935),(36449,1935),(36450,1935),(36451,1935),(36452,1935),(36453,1935),(36454,1936),(36455,1936),(36456,1936),(36457,1936),(36458,1936),(36459,1936),(36460,1936),(36461,1936),(36462,1936),(36463,1937),(36464,1937),(36465,1937),(36466,1937),(36467,1937),(36468,1937),(36469,1937),(36470,1938),(36471,1938),(36472,1938),(36473,1938),(36474,1938),(36475,1938),(36476,1938),(36477,1939),(36478,1939),(36479,1939),(36480,1939),(36481,1939),(36482,1939),(36483,1939),(36484,1939),(36485,1939),(36486,1940),(36487,1940),(36488,1940),(36489,1940),(36490,1940),(36491,1940),(36492,1940),(36493,1940),(36494,1940),(36495,1941),(36496,1941),(36497,1941),(36498,1941),(36499,1941),(36500,1941),(36501,1941),(36502,1941),(36503,1941),(36504,1942),(36505,1942),(36506,1942),(36507,1942),(36508,1942),(36509,1942),(36510,1942),(36511,1942),(36512,1942),(36513,1943),(36514,1943),(36515,1943),(36516,1943),(36517,1943),(36518,1943),(36519,1943),(36520,1943),(36521,1943),(36522,1944),(36523,1944),(36524,1944),(36525,1944),(36526,1944),(36527,1944),(36528,1944),(36529,1944),(36530,1944),(36531,1945),(36532,1945),(36533,1945),(36534,1945),(36535,1945),(36536,1945),(36537,1945),(36538,1945),(36539,1945),(36540,1946),(36541,1946),(36542,1946),(36543,1946),(36544,1946),(36545,1946),(36546,1946),(36547,1946),(36548,1946),(36549,1947),(36550,1947),(36551,1947),(36552,1947),(36553,1947),(36554,1947),(36555,1947),(36556,1947),(36557,1947),(36558,1948),(36559,1948),(36560,1948),(36561,1948),(36562,1948),(36563,1948),(36564,1948),(36565,1948),(36566,1948),(36567,1949),(36568,1949),(36569,1949),(36570,1949),(36571,1949),(36572,1949),(36573,1949),(36574,1949),(36575,1949),(36576,1950),(36577,1950),(36578,1950),(36579,1950),(36580,1950),(36581,1950),(36582,1950),(36583,1951),(36584,1951),(36585,1951),(36586,1951),(36587,1951),(36588,1951),(36589,1951),(36590,1952),(36591,1952),(36592,1952),(36593,1952),(36594,1952),(36595,1952),(36596,1952),(36597,1953),(36598,1953),(36599,1953),(36600,1953),(36601,1953),(36602,1953),(36603,1954),(36604,1954),(36605,1954),(36606,1954),(36607,1954),(36608,1954),(36609,1955),(36610,1955),(36611,1955),(36612,1955),(36613,1955),(36614,1955),(36615,1956),(36616,1956),(36617,1956),(36618,1956),(36619,1956),(36620,1956),(36621,1957),(36622,1957),(36623,1957),(36624,1957),(36625,1957),(36626,1957),(36627,1958),(36628,1958),(36629,1958),(36630,1958),(36631,1958),(36632,1958),(36633,1959),(36634,1959),(36635,1959),(36636,1959),(36637,1959),(36638,1959),(36639,1959),(36640,1960),(36641,1960),(36642,1960),(36643,1960),(36644,1960),(36645,1960),(36646,1960),(36647,1961),(36648,1961),(36649,1961),(36650,1961),(36651,1961),(36652,1961),(36653,1961),(36654,1962),(36655,1962),(36656,1962),(36657,1962),(36658,1962),(36659,1962),(36660,1962),(36661,1963),(36662,1963),(36663,1963),(36664,1963),(36665,1963),(36666,1963),(36667,1963),(36668,1964),(36669,1964),(36670,1964),(36671,1964),(36672,1964),(36673,1964),(36674,1964),(36675,1965),(36676,1965),(36677,1965),(36678,1965),(36679,1965),(36680,1965),(36681,1965),(36682,1966),(36683,1966),(36684,1966),(36685,1966),(36686,1966),(36687,1966),(36688,1966),(36689,1967),(36690,1967),(36691,1967),(36692,1967),(36693,1967),(36694,1967),(36695,1967),(36696,1968),(36697,1968),(36698,1968),(36699,1968),(36700,1968),(36701,1968),(36702,1968),(36703,1969),(36704,1969),(36705,1969),(36706,1969),(36707,1969),(36708,1969),(36709,1969),(36710,1970),(36711,1970),(36712,1970),(36713,1970),(36714,1970),(36715,1970),(36716,1970),(36717,1971),(36718,1971),(36719,1971),(36720,1971),(36721,1971),(36722,1971),(36723,1971),(36724,1972),(36725,1972),(36726,1972),(36727,1972),(36728,1972),(36729,1973),(36730,1973),(36731,1973),(36732,1973),(36733,1973),(36734,1973),(36735,1973),(36736,1974),(36737,1974),(36738,1974),(36739,1974),(36740,1974),(36741,1974),(36742,1974),(36743,1975),(36744,1975),(36745,1975),(36746,1975),(36747,1975),(36748,1975),(36749,1975),(36750,1976),(36751,1976),(36752,1976),(36753,1976),(36754,1976),(36755,1976),(36756,1976),(36757,1977),(36758,1977),(36759,1977),(36760,1977),(36761,1977),(36762,1977),(36763,1977),(36764,1978),(36765,1978),(36766,1978),(36767,1978),(36768,1978),(36769,1978),(36770,1978),(36771,1979),(36772,1979),(36773,1979),(36774,1979),(36775,1979),(36776,1979),(36777,1979),(36778,1980),(36779,1980),(36780,1980),(36781,1980),(36782,1980),(36783,1980),(36784,1980),(36785,1981),(36786,1981),(36787,1981),(36788,1981),(36789,1981),(36790,1981),(36791,1981),(36792,1982),(36793,1982),(36794,1982),(36795,1982),(36796,1982),(36797,1982),(36798,1982),(36799,1983),(36800,1983),(36801,1983),(36802,1983),(36803,1983),(36804,1983),(36805,1983),(36806,1984),(36807,1984),(36808,1984),(36809,1984),(36810,1984),(36811,1984),(36812,1984),(36813,1985),(36814,1985),(36815,1985),(36816,1985),(36817,1985),(36818,1985),(36819,1985),(36820,1986),(36821,1986),(36822,1986),(36823,1986),(36824,1986),(36825,1986),(36826,1986),(36827,1987),(36828,1987),(36829,1987),(36830,1987),(36831,1987),(36832,1987),(36833,1987),(36834,1988),(36835,1988),(36836,1988),(36837,1988),(36838,1988),(36839,1988),(36840,1988),(36841,1989),(36842,1989),(36843,1989),(36844,1989),(36845,1989),(36846,1989),(36847,1989),(36848,1990),(36849,1990),(36850,1990),(36851,1990),(36852,1990),(36853,1990),(36854,1990),(36855,1991),(36856,1991),(36857,1991),(36858,1991),(36859,1991),(36860,1991),(36861,1991),(36862,1991),(36863,1991),(36864,1992),(36865,1992),(36866,1992),(36867,1992),(36868,1992),(36869,1992),(36870,1992),(36871,1993),(36872,1993),(36873,1993),(36874,1993),(36875,1993),(36876,1993),(36877,1993),(36878,1994),(36879,1994),(36880,1994),(36881,1994),(36882,1994),(36883,1994),(36884,1994),(36885,1995),(36886,1995),(36887,1995),(36888,1995),(36889,1995),(36890,1995),(36891,1995),(36892,1996),(36893,1996),(36894,1996),(36895,1996),(36896,1996),(36897,1996),(36898,1996),(36899,1997),(36900,1997),(36901,1997),(36902,1997),(36903,1997),(36904,1997),(36905,1997),(36906,1998),(36907,1998),(36908,1998),(36909,1998),(36910,1998),(36911,1998),(36912,1998),(36913,1999),(36914,1999),(36915,1999),(36916,1999),(36917,1999),(36918,1999),(36919,1999),(36920,2000),(36921,2000),(36922,2000),(36923,2000),(36924,2000),(36925,2000),(36926,2000),(36927,2001),(36928,2001),(36929,2001),(36930,2001),(36931,2001),(36932,2001),(36933,2001),(36934,2002),(36935,2002),(36936,2002),(36937,2002),(36938,2002),(36939,2002),(36940,2002),(36941,2003),(36942,2003),(36943,2003),(36944,2003),(36945,2003),(36946,2003),(36947,2003),(36948,2004),(36949,2004),(36950,2004),(36951,2004),(36952,2004),(36953,2004),(36954,2004),(36955,2005),(36956,2005),(36957,2005),(36958,2005),(36959,2005),(36960,2005),(36961,2005),(36962,2006),(36963,2006),(36964,2006),(36965,2006),(36966,2006),(36967,2006),(36968,2006),(36969,2007),(36970,2007),(36971,2007),(36972,2007),(36973,2007),(36974,2007),(36975,2007),(36976,2008),(36977,2008),(36978,2008),(36979,2008),(36980,2008),(36981,2008),(36982,2008),(36983,2009),(36984,2009),(36985,2009),(36986,2009),(36987,2009),(36988,2009),(36989,2009),(36990,2010),(36991,2010),(36992,2010),(36993,2010),(36994,2010),(36995,2010),(36996,2010),(36997,2011),(36998,2011),(36999,2011),(37000,2011),(37001,2011),(37002,2011),(37003,2011),(37004,2012),(37005,2012),(37006,2012),(37007,2012),(37008,2012),(37009,2012),(37010,2012),(37011,1913),(37012,1913),(37013,1914),(37014,1914),(37015,1915),(37016,1915),(37017,1916),(37018,1916),(37019,1917),(37020,1917),(37021,1918),(37022,1918),(37023,1919),(37024,1919),(37025,1920),(37026,1920),(37027,1921),(37028,1921),(37029,1922),(37030,1922),(37031,1923),(37032,1923),(37033,1924),(37034,1924),(37035,1925),(37036,1925),(37037,1926),(37038,1926),(37039,1927),(37040,1927),(37041,1928),(37042,1928),(37043,1929),(37044,1929),(37045,1930),(37046,1930),(37047,1931),(37048,1931),(37049,1932),(37050,1932),(37051,1933),(37052,1933),(37053,1934),(37054,1934),(37055,1935),(37056,1935),(37057,1936),(37058,1936),(37059,1937),(37060,1937),(37061,1938),(37062,1938),(37063,1939),(37064,1939),(37065,1940),(37066,1940),(37067,1941),(37068,1941),(37069,1942),(37070,1942),(37071,1943),(37072,1943),(37073,1944),(37074,1944),(37075,1945),(37076,1945),(37077,1946),(37078,1946),(37079,1947),(37080,1947),(37081,1948),(37082,1948),(37083,1949),(37084,1949),(37085,1950),(37086,1950),(37087,1950),(37088,1951),(37089,1951),(37090,1951),(37091,1952),(37092,1952),(37093,1952),(37094,1953),(37095,1953),(37096,1953),(37097,1954),(37098,1954),(37099,1954),(37100,1955),(37101,1955),(37102,1955),(37103,1956),(37104,1956),(37105,1956),(37106,1957),(37107,1957),(37108,1957),(37109,1958),(37110,1958),(37111,1958),(37112,1959),(37113,1959),(37114,1959),(37115,1960),(37116,1960),(37117,1960),(37118,1961),(37119,1961),(37120,1961),(37121,1962),(37122,1962),(37123,1962),(37124,1963),(37125,1963),(37126,1963),(37127,1964),(37128,1964),(37129,1964),(37130,1965),(37131,1965),(37132,1965),(37133,1966),(37134,1966),(37135,1966),(37136,1967),(37137,1967),(37138,1967),(37139,1968),(37140,1968),(37141,1968),(37142,1969),(37143,1969),(37144,1969),(37145,1970),(37146,1970),(37147,1970),(37148,1971),(37149,1971),(37150,1971),(37151,1972),(37152,1973),(37153,1973),(37154,1974),(37155,1974),(37156,1975),(37157,1975),(37158,1976),(37159,1976),(37160,1977),(37161,1977),(37162,1978),(37163,1978),(37164,1979),(37165,1979),(37166,1980),(37167,1980),(37168,1981),(37169,1981),(37170,1982),(37171,1982),(37172,1983),(37173,1983),(37174,1984),(37175,1984),(37176,1985),(37177,1985),(37178,1986),(37179,1986),(37180,1987),(37181,1987),(37182,1988),(37183,1988),(37184,1989),(37185,1989),(37186,1990),(37187,1990),(37188,1991),(37189,1991),(37190,1992),(37191,1992),(37192,1993),(37193,1993),(37194,1994),(37195,1994),(37196,1995),(37197,1995),(37198,1996),(37199,1996),(37200,1997),(37201,1997),(37202,1998),(37203,1998),(37204,1999),(37205,1999),(37206,2000),(37207,2000),(37208,2001),(37209,2001),(37210,2002),(37211,2002),(37212,2003),(37213,2003),(37214,2003),(37215,2004),(37216,2004),(37217,2004),(37218,2005),(37219,2005),(37220,2005),(37221,2006),(37222,2006),(37223,2006),(37224,2007),(37225,2007),(37226,2007),(37227,2008),(37228,2008),(37229,2009),(37230,2009),(37231,2009),(37232,2010),(37233,2010),(37234,2010),(37235,2011),(37236,2011),(37237,2011),(37238,2012),(37239,2012),(37240,2012),(37241,1913),(37242,1913),(37243,1913),(37244,1914),(37245,1914),(37246,1914),(37247,1915),(37248,1915),(37249,1915),(37250,1916),(37251,1916),(37252,1916),(37253,1917),(37254,1917),(37255,1917),(37256,1918),(37257,1918),(37258,1918),(37259,1919),(37260,1919),(37261,1919),(37262,1920),(37263,1920),(37264,1920),(37265,1921),(37266,1921),(37267,1921),(37268,1922),(37269,1922),(37270,1922),(37271,1923),(37272,1923),(37273,1923),(37274,1924),(37275,1924),(37276,1924),(37277,1925),(37278,1925),(37279,1925),(37280,1926),(37281,1926),(37282,1926),(37283,1927),(37284,1927),(37285,1927),(37286,1928),(37287,1928),(37288,1928),(37289,1929),(37290,1929),(37291,1929),(37292,1930),(37293,1930),(37294,1930),(37295,1931),(37296,1931),(37297,1931),(37298,1932),(37299,1932),(37300,1932),(37301,1933),(37302,1933),(37303,1933),(37304,1934),(37305,1934),(37306,1934),(37307,1935),(37308,1935),(37309,1935),(37310,1936),(37311,1936),(37312,1936),(37313,1937),(37314,1937),(37315,1937),(37316,1938),(37317,1938),(37318,1938),(37319,1939),(37320,1939),(37321,1939),(37322,1940),(37323,1940),(37324,1940),(37325,1941),(37326,1941),(37327,1941),(37328,1942),(37329,1942),(37330,1942),(37331,1943),(37332,1943),(37333,1943),(37334,1944),(37335,1944),(37336,1944),(37337,1945),(37338,1945),(37339,1945),(37340,1946),(37341,1946),(37342,1946),(37343,1947),(37344,1947),(37345,1947),(37346,1948),(37347,1948),(37348,1948),(37349,1949),(37350,1949),(37351,1949),(37352,1950),(37353,1950),(37354,1950),(37355,1951),(37356,1951),(37357,1951),(37358,1952),(37359,1952),(37360,1952),(37361,1953),(37362,1953),(37363,1953),(37364,1954),(37365,1954),(37366,1954),(37367,1955),(37368,1955),(37369,1955),(37370,1956),(37371,1956),(37372,1956),(37373,1957),(37374,1957),(37375,1957),(37376,1958),(37377,1958),(37378,1958),(37379,1959),(37380,1959),(37381,1959),(37382,1960),(37383,1960),(37384,1960),(37385,1961),(37386,1961),(37387,1961),(37388,1962),(37389,1962),(37390,1962),(37391,1963),(37392,1963),(37393,1963),(37394,1964),(37395,1964),(37396,1964),(37397,1965),(37398,1965),(37399,1965),(37400,1966),(37401,1966),(37402,1966),(37403,1967),(37404,1967),(37405,1967),(37406,1968),(37407,1968),(37408,1968),(37409,1969),(37410,1969),(37411,1969),(37412,1970),(37413,1970),(37414,1970),(37415,1971),(37416,1971),(37417,1971),(37418,1972),(37419,1972),(37420,1972),(37421,1973),(37422,1973),(37423,1973),(37424,1974),(37425,1974),(37426,1974),(37427,1975),(37428,1975),(37429,1975),(37430,1976),(37431,1976),(37432,1976),(37433,1977),(37434,1977),(37435,1977),(37436,1978),(37437,1978),(37438,1978),(37439,1979),(37440,1979),(37441,1979),(37442,1980),(37443,1980),(37444,1980),(37445,1981),(37446,1981),(37447,1981),(37448,1982),(37449,1982),(37450,1982),(37451,1983),(37452,1983),(37453,1983),(37454,1984),(37455,1984),(37456,1984),(37457,1985),(37458,1985),(37459,1985),(37460,1986),(37461,1986),(37462,1986),(37463,1987),(37464,1987),(37465,1987),(37466,1988),(37467,1988),(37468,1988),(37469,1989),(37470,1989),(37471,1989),(37472,1990),(37473,1990),(37474,1990),(37475,1991),(37476,1991),(37477,1991),(37478,1992),(37479,1992),(37480,1992),(37481,1993),(37482,1993),(37483,1993),(37484,1994),(37485,1994),(37486,1994),(37487,1995),(37488,1995),(37489,1995),(37490,1996),(37491,1996),(37492,1996),(37493,1997),(37494,1997),(37495,1997),(37496,1998),(37497,1998),(37498,1998),(37499,1999),(37500,1999),(37501,1999),(37502,2000),(37503,2000),(37504,2000),(37505,2001),(37506,2001),(37507,2001),(37508,2002),(37509,2002),(37510,2002),(37511,2003),(37512,2003),(37513,2003),(37514,2004),(37515,2004),(37516,2004),(37517,2005),(37518,2005),(37519,2005),(37520,2006),(37521,2006),(37522,2006),(37523,2007),(37524,2007),(37525,2007),(37526,2008),(37527,2008),(37528,2008),(37529,2009),(37530,2009),(37531,2009),(37532,2010),(37533,2010),(37534,2010),(37535,2011),(37536,2011),(37537,2011),(37538,2012),(37539,2012),(37540,2012),(37541,1913),(37542,1913),(37543,1913),(37544,1913),(37545,1914),(37546,1914),(37547,1914),(37548,1914),(37549,1915),(37550,1915),(37551,1915),(37552,1915),(37553,1916),(37554,1916),(37555,1916),(37556,1916),(37557,1917),(37558,1917),(37559,1917),(37560,1917),(37561,1918),(37562,1918),(37563,1918),(37564,1918),(37565,1919),(37566,1919),(37567,1919),(37568,1919),(37569,1920),(37570,1920),(37571,1920),(37572,1920),(37573,1921),(37574,1921),(37575,1921),(37576,1921),(37577,1922),(37578,1922),(37579,1922),(37580,1922),(37581,1923),(37582,1923),(37583,1923),(37584,1923),(37585,1924),(37586,1924),(37587,1924),(37588,1924),(37589,1925),(37590,1925),(37591,1925),(37592,1925),(37593,1926),(37594,1926),(37595,1926),(37596,1926),(37597,1927),(37598,1927),(37599,1927),(37600,1927),(37601,1928),(37602,1928),(37603,1928),(37604,1928),(37605,1929),(37606,1929),(37607,1929),(37608,1929),(37609,1930),(37610,1930),(37611,1930),(37612,1930),(37613,1931),(37614,1931),(37615,1931),(37616,1931),(37617,1932),(37618,1932),(37619,1932),(37620,1932),(37621,1933),(37622,1933),(37623,1933),(37624,1933),(37625,1934),(37626,1934),(37627,1934),(37628,1934),(37629,1935),(37630,1935),(37631,1935),(37632,1935),(37633,1936),(37634,1936),(37635,1936),(37636,1936),(37637,1937),(37638,1937),(37639,1937),(37640,1937),(37641,1938),(37642,1938),(37643,1938),(37644,1938),(37645,1939),(37646,1939),(37647,1939),(37648,1939),(37649,1940),(37650,1940),(37651,1940),(37652,1940),(37653,1941),(37654,1941),(37655,1941),(37656,1941),(37657,1942),(37658,1942),(37659,1942),(37660,1942),(37661,1943),(37662,1943),(37663,1943),(37664,1943),(37665,1944),(37666,1944),(37667,1944),(37668,1944),(37669,1945),(37670,1945),(37671,1945),(37672,1945),(37673,1946),(37674,1946),(37675,1946),(37676,1946),(37677,1947),(37678,1947),(37679,1947),(37680,1947),(37681,1948),(37682,1948),(37683,1948),(37684,1948),(37685,1949),(37686,1949),(37687,1949),(37688,1949),(37689,1950),(37690,1950),(37691,1950),(37692,1950),(37693,1951),(37694,1951),(37695,1951),(37696,1951),(37697,1952),(37698,1952),(37699,1952),(37700,1952),(37701,1953),(37702,1953),(37703,1953),(37704,1953),(37705,1954),(37706,1954),(37707,1954),(37708,1954),(37709,1955),(37710,1955),(37711,1955),(37712,1955),(37713,1956),(37714,1956),(37715,1956),(37716,1956),(37717,1957),(37718,1957),(37719,1957),(37720,1957),(37721,1958),(37722,1958),(37723,1958),(37724,1958),(37725,1959),(37726,1959),(37727,1959),(37728,1959),(37729,1960),(37730,1960),(37731,1960),(37732,1960),(37733,1961),(37734,1961),(37735,1961),(37736,1961),(37737,1962),(37738,1962),(37739,1962),(37740,1962),(37741,1963),(37742,1963),(37743,1963),(37744,1963),(37745,1964),(37746,1964),(37747,1964),(37748,1964),(37749,1965),(37750,1965),(37751,1965),(37752,1965),(37753,1966),(37754,1966),(37755,1966),(37756,1966),(37757,1967),(37758,1967),(37759,1967),(37760,1967),(37761,1968),(37762,1968),(37763,1968),(37764,1968),(37765,1969),(37766,1969),(37767,1969),(37768,1969),(37769,1970),(37770,1970),(37771,1970),(37772,1970),(37773,1971),(37774,1971),(37775,1971),(37776,1971),(37777,1972),(37778,1972),(37779,1972),(37780,1972),(37781,1973),(37782,1973),(37783,1973),(37784,1973),(37785,1974),(37786,1974),(37787,1974),(37788,1974),(37789,1975),(37790,1975),(37791,1975),(37792,1975),(37793,1976),(37794,1976),(37795,1976),(37796,1976),(37797,1977),(37798,1977),(37799,1977),(37800,1977),(37801,1978),(37802,1978),(37803,1978),(37804,1978),(37805,1979),(37806,1979),(37807,1979),(37808,1979),(37809,1980),(37810,1980),(37811,1980),(37812,1980),(37813,1981),(37814,1981),(37815,1981),(37816,1981),(37817,1982),(37818,1982),(37819,1982),(37820,1982),(37821,1983),(37822,1983),(37823,1983),(37824,1983),(37825,1984),(37826,1984),(37827,1984),(37828,1984),(37829,1985),(37830,1985),(37831,1985),(37832,1985),(37833,1986),(37834,1986),(37835,1986),(37836,1986),(37837,1987),(37838,1987),(37839,1987),(37840,1987),(37841,1988),(37842,1988),(37843,1988),(37844,1988),(37845,1989),(37846,1989),(37847,1989),(37848,1989),(37849,1990),(37850,1990),(37851,1990),(37852,1990),(37853,1991),(37854,1991),(37855,1991),(37856,1991),(37857,1992),(37858,1992),(37859,1992),(37860,1992),(37861,1993),(37862,1993),(37863,1993),(37864,1993),(37865,1994),(37866,1994),(37867,1994),(37868,1994),(37869,1995),(37870,1995),(37871,1995),(37872,1995),(37873,1996),(37874,1996),(37875,1996),(37876,1996),(37877,1997),(37878,1997),(37879,1997),(37880,1997),(37881,1998),(37882,1998),(37883,1998),(37884,1998),(37885,1999),(37886,1999),(37887,1999),(37888,1999),(37889,2000),(37890,2000),(37891,2000),(37892,2000),(37893,2001),(37894,2001),(37895,2001),(37896,2001),(37897,2002),(37898,2002),(37899,2002),(37900,2002),(37901,2003),(37902,2003),(37903,2003),(37904,2003),(37905,2004),(37906,2004),(37907,2004),(37908,2004),(37909,2005),(37910,2005),(37911,2005),(37912,2005),(37913,2006),(37914,2006),(37915,2006),(37916,2006),(37917,2007),(37918,2007),(37919,2007),(37920,2007),(37921,2008),(37922,2008),(37923,2008),(37924,2008),(37925,2009),(37926,2009),(37927,2009),(37928,2009),(37929,2010),(37930,2010),(37931,2010),(37932,2010),(37933,2011),(37934,2011),(37935,2011),(37936,2011),(37937,2012),(37938,2012),(37939,2012),(37940,2012),(37941,2013),(37942,2014),(37943,2015),(37944,2016),(37945,2017),(37946,2018),(37947,2019),(37948,2020),(37949,2021),(37950,2022),(37951,2023),(37952,2024),(37953,2025),(37954,2026),(37955,2027),(37956,2028),(37957,2029),(37958,2030),(37959,2031),(37960,2032),(37961,2033),(37962,2034),(37963,2035),(37964,2036),(37965,2037),(37966,2038),(37967,2039),(37968,2040),(37969,2041),(37970,2042),(37971,2043),(37972,2044),(37973,2045),(37974,2046),(37975,2047),(37976,2048),(37977,2049),(37978,2050),(37979,2051),(37980,2052),(37981,2053),(37982,2054),(37983,2055),(37984,2056),(37985,2057),(37986,2058),(37987,2059),(37988,2060),(37989,2061),(37990,2062),(37991,2063),(37992,2064),(37993,2065),(37994,2066),(37995,2067),(37996,2068),(37997,2069),(37998,2070),(37999,2071),(38000,2072),(38001,2073),(38002,2074),(38003,2075),(38004,2076),(38005,2077),(38006,2078),(38007,2079),(38008,2080),(38009,2081),(38010,2082),(38011,2083),(38012,2084),(38013,2085),(38014,2086),(38015,2087),(38016,2088),(38017,2089),(38018,2090),(38019,2091),(38020,2092),(38021,2093),(38022,2094),(38023,2095),(38024,2096),(38025,2097),(38026,2098),(38027,2099),(38028,2100),(38029,2101),(38030,2102),(38031,2103),(38032,2104),(38033,2105),(38034,2106),(38035,2107),(38036,2108),(38037,2109),(38038,2110),(38039,2111),(38040,2112),(38041,2013),(38042,2014),(38043,2015),(38044,2016),(38045,2017),(38046,2018),(38047,2019),(38048,2020),(38049,2021),(38050,2022),(38051,2023),(38052,2024),(38053,2025),(38054,2026),(38055,2027),(38056,2028),(38057,2029),(38058,2030),(38059,2031),(38060,2032),(38061,2033),(38062,2034),(38063,2035),(38064,2036),(38065,2037),(38066,2038),(38067,2039),(38068,2040),(38069,2041),(38070,2042),(38071,2043),(38072,2044),(38073,2045),(38074,2046),(38075,2047),(38076,2048),(38077,2049),(38078,2050),(38079,2051),(38080,2052),(38081,2053),(38082,2054),(38083,2055),(38084,2056),(38085,2057),(38086,2058),(38087,2059),(38088,2060),(38089,2061),(38090,2062),(38091,2063),(38092,2064),(38093,2065),(38094,2066),(38095,2067),(38096,2068),(38097,2069),(38098,2070),(38099,2071),(38100,2072),(38101,2073),(38102,2074),(38103,2075),(38104,2076),(38105,2077),(38106,2078),(38107,2079),(38108,2080),(38109,2081),(38110,2082),(38111,2083),(38112,2084),(38113,2085),(38114,2086),(38115,2087),(38116,2088),(38117,2089),(38118,2090),(38119,2091),(38120,2092),(38121,2093),(38122,2094),(38123,2095),(38124,2096),(38125,2097),(38126,2098),(38127,2099),(38128,2100),(38129,2101),(38130,2102),(38131,2103),(38132,2104),(38133,2105),(38134,2106),(38135,2107),(38136,2108),(38137,2109),(38138,2110),(38139,2111),(38140,2112),(38141,2013),(38142,2013),(38143,2013),(38144,2013),(38145,2013),(38146,2013),(38147,2013),(38148,2014),(38149,2014),(38150,2014),(38151,2014),(38152,2014),(38153,2014),(38154,2014),(38155,2015),(38156,2015),(38157,2015),(38158,2015),(38159,2015),(38160,2015),(38161,2015),(38162,2016),(38163,2016),(38164,2016),(38165,2016),(38166,2016),(38167,2016),(38168,2016),(38169,2017),(38170,2017),(38171,2017),(38172,2017),(38173,2017),(38174,2017),(38175,2017),(38176,2018),(38177,2018),(38178,2018),(38179,2018),(38180,2018),(38181,2018),(38182,2018),(38183,2019),(38184,2019),(38185,2019),(38186,2019),(38187,2019),(38188,2019),(38189,2019),(38190,2020),(38191,2020),(38192,2020),(38193,2020),(38194,2020),(38195,2020),(38196,2020),(38197,2021),(38198,2021),(38199,2021),(38200,2021),(38201,2021),(38202,2021),(38203,2021),(38204,2022),(38205,2022),(38206,2022),(38207,2022),(38208,2022),(38209,2022),(38210,2022),(38211,2023),(38212,2023),(38213,2023),(38214,2023),(38215,2023),(38216,2023),(38217,2023),(38218,2024),(38219,2024),(38220,2024),(38221,2024),(38222,2024),(38223,2024),(38224,2024),(38225,2024),(38226,2024),(38227,2025),(38228,2025),(38229,2025),(38230,2025),(38231,2025),(38232,2025),(38233,2025),(38234,2025),(38235,2025),(38236,2026),(38237,2026),(38238,2026),(38239,2026),(38240,2026),(38241,2026),(38242,2026),(38243,2026),(38244,2026),(38245,2027),(38246,2027),(38247,2027),(38248,2027),(38249,2027),(38250,2027),(38251,2027),(38252,2027),(38253,2027),(38254,2028),(38255,2028),(38256,2028),(38257,2028),(38258,2028),(38259,2028),(38260,2028),(38261,2028),(38262,2028),(38263,2029),(38264,2029),(38265,2029),(38266,2029),(38267,2029),(38268,2029),(38269,2029),(38270,2029),(38271,2029),(38272,2030),(38273,2030),(38274,2030),(38275,2030),(38276,2030),(38277,2030),(38278,2030),(38279,2030),(38280,2030),(38281,2031),(38282,2031),(38283,2031),(38284,2031),(38285,2031),(38286,2031),(38287,2031),(38288,2031),(38289,2031),(38290,2032),(38291,2032),(38292,2032),(38293,2032),(38294,2032),(38295,2032),(38296,2032),(38297,2032),(38298,2032),(38299,2033),(38300,2033),(38301,2033),(38302,2033),(38303,2033),(38304,2033),(38305,2033),(38306,2033),(38307,2033),(38308,2034),(38309,2034),(38310,2034),(38311,2034),(38312,2034),(38313,2034),(38314,2034),(38315,2034),(38316,2034),(38317,2035),(38318,2035),(38319,2035),(38320,2035),(38321,2035),(38322,2035),(38323,2035),(38324,2036),(38325,2036),(38326,2036),(38327,2036),(38328,2036),(38329,2036),(38330,2036),(38331,2037),(38332,2037),(38333,2037),(38334,2037),(38335,2037),(38336,2037),(38337,2037),(38338,2038),(38339,2038),(38340,2038),(38341,2038),(38342,2038),(38343,2038),(38344,2038),(38345,2039),(38346,2039),(38347,2039),(38348,2039),(38349,2039),(38350,2039),(38351,2039),(38352,2039),(38353,2039),(38354,2040),(38355,2040),(38356,2040),(38357,2040),(38358,2040),(38359,2040),(38360,2040),(38361,2040),(38362,2040),(38363,2041),(38364,2041),(38365,2041),(38366,2041),(38367,2041),(38368,2041),(38369,2041),(38370,2042),(38371,2042),(38372,2042),(38373,2042),(38374,2042),(38375,2042),(38376,2042),(38377,2042),(38378,2042),(38379,2043),(38380,2043),(38381,2043),(38382,2043),(38383,2043),(38384,2043),(38385,2043),(38386,2044),(38387,2044),(38388,2044),(38389,2044),(38390,2044),(38391,2044),(38392,2044),(38393,2044),(38394,2044),(38395,2045),(38396,2045),(38397,2045),(38398,2045),(38399,2045),(38400,2045),(38401,2045),(38402,2045),(38403,2045),(38404,2046),(38405,2046),(38406,2046),(38407,2046),(38408,2046),(38409,2046),(38410,2046),(38411,2046),(38412,2046),(38413,2047),(38414,2047),(38415,2047),(38416,2047),(38417,2047),(38418,2047),(38419,2047),(38420,2048),(38421,2048),(38422,2048),(38423,2048),(38424,2048),(38425,2048),(38426,2048),(38427,2049),(38428,2049),(38429,2049),(38430,2049),(38431,2049),(38432,2049),(38433,2049),(38434,2050),(38435,2050),(38436,2050),(38437,2050),(38438,2050),(38439,2050),(38440,2050),(38441,2051),(38442,2051),(38443,2051),(38444,2051),(38445,2051),(38446,2051),(38447,2051),(38448,2052),(38449,2052),(38450,2052),(38451,2052),(38452,2052),(38453,2052),(38454,2052),(38455,2053),(38456,2053),(38457,2053),(38458,2053),(38459,2053),(38460,2053),(38461,2053),(38462,2054),(38463,2054),(38464,2054),(38465,2054),(38466,2054),(38467,2054),(38468,2054),(38469,2055),(38470,2055),(38471,2055),(38472,2055),(38473,2055),(38474,2055),(38475,2055),(38476,2056),(38477,2056),(38478,2056),(38479,2056),(38480,2056),(38481,2056),(38482,2056),(38483,2057),(38484,2057),(38485,2057),(38486,2057),(38487,2057),(38488,2057),(38489,2057),(38490,2058),(38491,2058),(38492,2058),(38493,2058),(38494,2058),(38495,2058),(38496,2058),(38497,2059),(38498,2059),(38499,2059),(38500,2059),(38501,2059),(38502,2059),(38503,2059),(38504,2060),(38505,2060),(38506,2060),(38507,2060),(38508,2060),(38509,2060),(38510,2060),(38511,2061),(38512,2061),(38513,2061),(38514,2061),(38515,2061),(38516,2061),(38517,2061),(38518,2061),(38519,2061),(38520,2062),(38521,2062),(38522,2062),(38523,2062),(38524,2062),(38525,2062),(38526,2062),(38527,2063),(38528,2063),(38529,2063),(38530,2063),(38531,2063),(38532,2063),(38533,2063),(38534,2064),(38535,2064),(38536,2064),(38537,2064),(38538,2064),(38539,2064),(38540,2064),(38541,2065),(38542,2065),(38543,2065),(38544,2065),(38545,2065),(38546,2065),(38547,2065),(38548,2066),(38549,2066),(38550,2066),(38551,2066),(38552,2066),(38553,2066),(38554,2066),(38555,2067),(38556,2067),(38557,2067),(38558,2067),(38559,2067),(38560,2067),(38561,2067),(38562,2068),(38563,2068),(38564,2068),(38565,2068),(38566,2068),(38567,2068),(38568,2068),(38569,2069),(38570,2069),(38571,2069),(38572,2069),(38573,2069),(38574,2069),(38575,2069),(38576,2070),(38577,2070),(38578,2070),(38579,2070),(38580,2070),(38581,2070),(38582,2070),(38583,2071),(38584,2071),(38585,2071),(38586,2071),(38587,2071),(38588,2071),(38589,2071),(38590,2072),(38591,2072),(38592,2072),(38593,2072),(38594,2072),(38595,2072),(38596,2072),(38597,2073),(38598,2073),(38599,2073),(38600,2073),(38601,2073),(38602,2073),(38603,2073),(38604,2074),(38605,2074),(38606,2074),(38607,2074),(38608,2074),(38609,2074),(38610,2074),(38611,2075),(38612,2075),(38613,2075),(38614,2075),(38615,2075),(38616,2075),(38617,2075),(38618,2076),(38619,2076),(38620,2076),(38621,2076),(38622,2076),(38623,2076),(38624,2076),(38625,2077),(38626,2077),(38627,2077),(38628,2077),(38629,2077),(38630,2077),(38631,2077),(38632,2078),(38633,2078),(38634,2078),(38635,2078),(38636,2078),(38637,2078),(38638,2078),(38639,2078),(38640,2078),(38641,2079),(38642,2079),(38643,2079),(38644,2079),(38645,2079),(38646,2079),(38647,2079),(38648,2080),(38649,2080),(38650,2080),(38651,2080),(38652,2080),(38653,2080),(38654,2080),(38655,2081),(38656,2081),(38657,2081),(38658,2081),(38659,2081),(38660,2081),(38661,2081),(38662,2082),(38663,2082),(38664,2082),(38665,2082),(38666,2082),(38667,2082),(38668,2082),(38669,2083),(38670,2083),(38671,2083),(38672,2083),(38673,2083),(38674,2083),(38675,2083),(38676,2084),(38677,2084),(38678,2084),(38679,2084),(38680,2084),(38681,2084),(38682,2084),(38683,2084),(38684,2084),(38685,2085),(38686,2085),(38687,2085),(38688,2085),(38689,2085),(38690,2085),(38691,2085),(38692,2086),(38693,2086),(38694,2086),(38695,2086),(38696,2086),(38697,2086),(38698,2086),(38699,2087),(38700,2087),(38701,2087),(38702,2087),(38703,2087),(38704,2087),(38705,2087),(38706,2088),(38707,2088),(38708,2088),(38709,2088),(38710,2088),(38711,2088),(38712,2088),(38713,2088),(38714,2088),(38715,2089),(38716,2089),(38717,2089),(38718,2089),(38719,2089),(38720,2089),(38721,2089),(38722,2090),(38723,2090),(38724,2090),(38725,2090),(38726,2090),(38727,2090),(38728,2090),(38729,2091),(38730,2091),(38731,2091),(38732,2091),(38733,2091),(38734,2091),(38735,2091),(38736,2092),(38737,2092),(38738,2092),(38739,2092),(38740,2092),(38741,2092),(38742,2092),(38743,2093),(38744,2093),(38745,2093),(38746,2093),(38747,2093),(38748,2093),(38749,2093),(38750,2094),(38751,2094),(38752,2094),(38753,2094),(38754,2094),(38755,2094),(38756,2094),(38757,2095),(38758,2095),(38759,2095),(38760,2095),(38761,2095),(38762,2095),(38763,2095),(38764,2096),(38765,2096),(38766,2096),(38767,2096),(38768,2096),(38769,2096),(38770,2096),(38771,2097),(38772,2097),(38773,2097),(38774,2097),(38775,2097),(38776,2097),(38777,2097),(38778,2097),(38779,2097),(38780,2098),(38781,2098),(38782,2098),(38783,2098),(38784,2098),(38785,2098),(38786,2098),(38787,2099),(38788,2099),(38789,2099),(38790,2099),(38791,2099),(38792,2099),(38793,2099),(38794,2100),(38795,2100),(38796,2100),(38797,2100),(38798,2100),(38799,2100),(38800,2100),(38801,2101),(38802,2101),(38803,2101),(38804,2101),(38805,2101),(38806,2101),(38807,2101),(38808,2101),(38809,2101),(38810,2102),(38811,2102),(38812,2102),(38813,2102),(38814,2102),(38815,2102),(38816,2102),(38817,2103),(38818,2103),(38819,2103),(38820,2103),(38821,2103),(38822,2103),(38823,2103),(38824,2104),(38825,2104),(38826,2104),(38827,2104),(38828,2104),(38829,2104),(38830,2104),(38831,2105),(38832,2105),(38833,2105),(38834,2105),(38835,2105),(38836,2105),(38837,2105),(38838,2105),(38839,2105),(38840,2106),(38841,2106),(38842,2106),(38843,2106),(38844,2106),(38845,2106),(38846,2106),(38847,2107),(38848,2107),(38849,2107),(38850,2107),(38851,2107),(38852,2107),(38853,2107),(38854,2108),(38855,2108),(38856,2108),(38857,2108),(38858,2108),(38859,2108),(38860,2108),(38861,2109),(38862,2109),(38863,2109),(38864,2109),(38865,2109),(38866,2109),(38867,2109),(38868,2110),(38869,2110),(38870,2110),(38871,2110),(38872,2110),(38873,2110),(38874,2110),(38875,2111),(38876,2111),(38877,2111),(38878,2111),(38879,2111),(38880,2111),(38881,2111),(38882,2112),(38883,2112),(38884,2112),(38885,2112),(38886,2112),(38887,2112),(38888,2112),(38889,2013),(38890,2013),(38891,2014),(38892,2014),(38893,2015),(38894,2015),(38895,2015),(38896,2016),(38897,2016),(38898,2016),(38899,2017),(38900,2017),(38901,2017),(38902,2018),(38903,2018),(38904,2018),(38905,2019),(38906,2019),(38907,2019),(38908,2020),(38909,2020),(38910,2020),(38911,2021),(38912,2022),(38913,2023),(38914,2024),(38915,2024),(38916,2025),(38917,2025),(38918,2026),(38919,2026),(38920,2027),(38921,2027),(38922,2028),(38923,2028),(38924,2029),(38925,2029),(38926,2030),(38927,2030),(38928,2031),(38929,2031),(38930,2032),(38931,2032),(38932,2033),(38933,2033),(38934,2034),(38935,2034),(38936,2035),(38937,2035),(38938,2036),(38939,2036),(38940,2036),(38941,2037),(38942,2037),(38943,2038),(38944,2038),(38945,2038),(38946,2039),(38947,2039),(38948,2040),(38949,2040),(38950,2041),(38951,2041),(38952,2042),(38953,2042),(38954,2043),(38955,2043),(38956,2043),(38957,2044),(38958,2044),(38959,2045),(38960,2045),(38961,2046),(38962,2046),(38963,2047),(38964,2047),(38965,2047),(38966,2048),(38967,2048),(38968,2048),(38969,2049),(38970,2049),(38971,2049),(38972,2050),(38973,2050),(38974,2050),(38975,2051),(38976,2051),(38977,2051),(38978,2052),(38979,2052),(38980,2052),(38981,2053),(38982,2053),(38983,2053),(38984,2054),(38985,2054),(38986,2054),(38987,2055),(38988,2055),(38989,2055),(38990,2056),(38991,2056),(38992,2056),(38993,2057),(38994,2057),(38995,2057),(38996,2058),(38997,2058),(38998,2058),(38999,2059),(39000,2059),(39001,2060),(39002,2060),(39003,2060),(39004,2061),(39005,2061),(39006,2062),(39007,2062),(39008,2062),(39009,2063),(39010,2063),(39011,2063),(39012,2064),(39013,2064),(39014,2065),(39015,2065),(39016,2065),(39017,2066),(39018,2066),(39019,2066),(39020,2067),(39021,2067),(39022,2067),(39023,2068),(39024,2068),(39025,2068),(39026,2069),(39027,2069),(39028,2069),(39029,2070),(39030,2070),(39031,2070),(39032,2071),(39033,2071),(39034,2071),(39035,2072),(39036,2072),(39037,2072),(39038,2073),(39039,2073),(39040,2073),(39041,2074),(39042,2074),(39043,2074),(39044,2075),(39045,2075),(39046,2075),(39047,2076),(39048,2076),(39049,2076),(39050,2077),(39051,2077),(39052,2077),(39053,2078),(39054,2078),(39055,2078),(39056,2079),(39057,2079),(39058,2079),(39059,2080),(39060,2080),(39061,2080),(39062,2081),(39063,2081),(39064,2081),(39065,2082),(39066,2082),(39067,2082),(39068,2083),(39069,2083),(39070,2083),(39071,2084),(39072,2084),(39073,2085),(39074,2085),(39075,2086),(39076,2086),(39077,2086),(39078,2087),(39079,2087),(39080,2087),(39081,2088),(39082,2088),(39083,2088),(39084,2089),(39085,2089),(39086,2090),(39087,2090),(39088,2090),(39089,2091),(39090,2091),(39091,2091),(39092,2092),(39093,2092),(39094,2092),(39095,2093),(39096,2093),(39097,2093),(39098,2094),(39099,2094),(39100,2094),(39101,2095),(39102,2095),(39103,2096),(39104,2096),(39105,2096),(39106,2097),(39107,2097),(39108,2097),(39109,2098),(39110,2098),(39111,2098),(39112,2099),(39113,2099),(39114,2099),(39115,2100),(39116,2100),(39117,2100),(39118,2101),(39119,2101),(39120,2101),(39121,2102),(39122,2102),(39123,2103),(39124,2103),(39125,2104),(39126,2104),(39127,2105),(39128,2105),(39129,2106),(39130,2106),(39131,2107),(39132,2107),(39133,2108),(39134,2108),(39135,2109),(39136,2109),(39137,2110),(39138,2110),(39139,2111),(39140,2111),(39141,2112),(39142,2112),(39143,2013),(39144,2013),(39145,2013),(39146,2014),(39147,2014),(39148,2014),(39149,2015),(39150,2015),(39151,2015),(39152,2016),(39153,2016),(39154,2016),(39155,2017),(39156,2017),(39157,2017),(39158,2018),(39159,2018),(39160,2018),(39161,2019),(39162,2019),(39163,2019),(39164,2020),(39165,2020),(39166,2020),(39167,2021),(39168,2021),(39169,2021),(39170,2022),(39171,2022),(39172,2022),(39173,2023),(39174,2023),(39175,2023),(39176,2024),(39177,2024),(39178,2024),(39179,2025),(39180,2025),(39181,2025),(39182,2026),(39183,2026),(39184,2026),(39185,2027),(39186,2027),(39187,2027),(39188,2028),(39189,2028),(39190,2028),(39191,2029),(39192,2029),(39193,2029),(39194,2030),(39195,2030),(39196,2030),(39197,2031),(39198,2031),(39199,2031),(39200,2032),(39201,2032),(39202,2032),(39203,2033),(39204,2033),(39205,2033),(39206,2034),(39207,2034),(39208,2034),(39209,2035),(39210,2035),(39211,2035),(39212,2036),(39213,2036),(39214,2036),(39215,2037),(39216,2037),(39217,2037),(39218,2038),(39219,2038),(39220,2038),(39221,2039),(39222,2039),(39223,2039),(39224,2040),(39225,2040),(39226,2040),(39227,2041),(39228,2041),(39229,2041),(39230,2042),(39231,2042),(39232,2042),(39233,2043),(39234,2043),(39235,2043),(39236,2044),(39237,2044),(39238,2044),(39239,2045),(39240,2045),(39241,2045),(39242,2046),(39243,2046),(39244,2046),(39245,2047),(39246,2047),(39247,2047),(39248,2048),(39249,2048),(39250,2048),(39251,2049),(39252,2049),(39253,2049),(39254,2050),(39255,2050),(39256,2050),(39257,2051),(39258,2051),(39259,2051),(39260,2052),(39261,2052),(39262,2052),(39263,2053),(39264,2053),(39265,2053),(39266,2054),(39267,2054),(39268,2054),(39269,2055),(39270,2055),(39271,2055),(39272,2056),(39273,2056),(39274,2056),(39275,2057),(39276,2057),(39277,2057),(39278,2058),(39279,2058),(39280,2058),(39281,2059),(39282,2059),(39283,2059),(39284,2060),(39285,2060),(39286,2060),(39287,2061),(39288,2061),(39289,2061),(39290,2062),(39291,2062),(39292,2062),(39293,2063),(39294,2063),(39295,2063),(39296,2064),(39297,2064),(39298,2064),(39299,2065),(39300,2065),(39301,2065),(39302,2066),(39303,2066),(39304,2066),(39305,2067),(39306,2067),(39307,2067),(39308,2068),(39309,2068),(39310,2068),(39311,2069),(39312,2069),(39313,2069),(39314,2070),(39315,2070),(39316,2070),(39317,2071),(39318,2071),(39319,2071),(39320,2072),(39321,2072),(39322,2072),(39323,2073),(39324,2073),(39325,2073),(39326,2074),(39327,2074),(39328,2074),(39329,2075),(39330,2075),(39331,2075),(39332,2076),(39333,2076),(39334,2076),(39335,2077),(39336,2077),(39337,2077),(39338,2078),(39339,2078),(39340,2078),(39341,2079),(39342,2079),(39343,2079),(39344,2080),(39345,2080),(39346,2080),(39347,2081),(39348,2081),(39349,2081),(39350,2082),(39351,2082),(39352,2082),(39353,2083),(39354,2083),(39355,2083),(39356,2084),(39357,2084),(39358,2084),(39359,2085),(39360,2085),(39361,2085),(39362,2086),(39363,2086),(39364,2086),(39365,2087),(39366,2087),(39367,2087),(39368,2088),(39369,2088),(39370,2088),(39371,2089),(39372,2089),(39373,2089),(39374,2090),(39375,2090),(39376,2090),(39377,2091),(39378,2091),(39379,2091),(39380,2092),(39381,2092),(39382,2092),(39383,2093),(39384,2093),(39385,2093),(39386,2094),(39387,2094),(39388,2094),(39389,2095),(39390,2095),(39391,2095),(39392,2096),(39393,2096),(39394,2096),(39395,2097),(39396,2097),(39397,2097),(39398,2098),(39399,2098),(39400,2098),(39401,2099),(39402,2099),(39403,2099),(39404,2100),(39405,2100),(39406,2100),(39407,2101),(39408,2101),(39409,2101),(39410,2102),(39411,2102),(39412,2102),(39413,2103),(39414,2103),(39415,2103),(39416,2104),(39417,2104),(39418,2104),(39419,2105),(39420,2105),(39421,2105),(39422,2106),(39423,2106),(39424,2106),(39425,2107),(39426,2107),(39427,2107),(39428,2108),(39429,2108),(39430,2108),(39431,2109),(39432,2109),(39433,2109),(39434,2110),(39435,2110),(39436,2110),(39437,2111),(39438,2111),(39439,2111),(39440,2112),(39441,2112),(39442,2112),(39443,2013),(39444,2013),(39445,2013),(39446,2013),(39447,2014),(39448,2014),(39449,2014),(39450,2014),(39451,2015),(39452,2015),(39453,2015),(39454,2015),(39455,2016),(39456,2016),(39457,2016),(39458,2016),(39459,2017),(39460,2017),(39461,2017),(39462,2017),(39463,2018),(39464,2018),(39465,2018),(39466,2018),(39467,2019),(39468,2019),(39469,2019),(39470,2019),(39471,2020),(39472,2020),(39473,2020),(39474,2020),(39475,2021),(39476,2021),(39477,2021),(39478,2021),(39479,2022),(39480,2022),(39481,2022),(39482,2022),(39483,2023),(39484,2023),(39485,2023),(39486,2023),(39487,2024),(39488,2024),(39489,2024),(39490,2024),(39491,2025),(39492,2025),(39493,2025),(39494,2025),(39495,2026),(39496,2026),(39497,2026),(39498,2026),(39499,2027),(39500,2027),(39501,2027),(39502,2027),(39503,2028),(39504,2028),(39505,2028),(39506,2028),(39507,2029),(39508,2029),(39509,2029),(39510,2029),(39511,2030),(39512,2030),(39513,2030),(39514,2030),(39515,2031),(39516,2031),(39517,2031),(39518,2031),(39519,2032),(39520,2032),(39521,2032),(39522,2032),(39523,2033),(39524,2033),(39525,2033),(39526,2033),(39527,2034),(39528,2034),(39529,2034),(39530,2034),(39531,2035),(39532,2035),(39533,2035),(39534,2035),(39535,2036),(39536,2036),(39537,2036),(39538,2036),(39539,2037),(39540,2037),(39541,2037),(39542,2037),(39543,2038),(39544,2038),(39545,2038),(39546,2038),(39547,2039),(39548,2039),(39549,2039),(39550,2039),(39551,2040),(39552,2040),(39553,2040),(39554,2040),(39555,2041),(39556,2041),(39557,2041),(39558,2041),(39559,2042),(39560,2042),(39561,2042),(39562,2042),(39563,2043),(39564,2043),(39565,2043),(39566,2043),(39567,2044),(39568,2044),(39569,2044),(39570,2044),(39571,2045),(39572,2045),(39573,2045),(39574,2045),(39575,2046),(39576,2046),(39577,2046),(39578,2046),(39579,2047),(39580,2047),(39581,2047),(39582,2047),(39583,2048),(39584,2048),(39585,2048),(39586,2048),(39587,2049),(39588,2049),(39589,2049),(39590,2049),(39591,2050),(39592,2050),(39593,2050),(39594,2050),(39595,2051),(39596,2051),(39597,2051),(39598,2051),(39599,2052),(39600,2052),(39601,2052),(39602,2052),(39603,2053),(39604,2053),(39605,2053),(39606,2053),(39607,2054),(39608,2054),(39609,2054),(39610,2054),(39611,2055),(39612,2055),(39613,2055),(39614,2055),(39615,2056),(39616,2056),(39617,2056),(39618,2056),(39619,2057),(39620,2057),(39621,2057),(39622,2057),(39623,2058),(39624,2058),(39625,2058),(39626,2058),(39627,2059),(39628,2059),(39629,2059),(39630,2059),(39631,2060),(39632,2060),(39633,2060),(39634,2060),(39635,2061),(39636,2061),(39637,2061),(39638,2061),(39639,2062),(39640,2062),(39641,2062),(39642,2062),(39643,2063),(39644,2063),(39645,2063),(39646,2063),(39647,2064),(39648,2064),(39649,2064),(39650,2064),(39651,2065),(39652,2065),(39653,2065),(39654,2065),(39655,2066),(39656,2066),(39657,2066),(39658,2066),(39659,2067),(39660,2067),(39661,2067),(39662,2067),(39663,2068),(39664,2068),(39665,2068),(39666,2068),(39667,2069),(39668,2069),(39669,2069),(39670,2069),(39671,2070),(39672,2070),(39673,2070),(39674,2070),(39675,2071),(39676,2071),(39677,2071),(39678,2071),(39679,2072),(39680,2072),(39681,2072),(39682,2072),(39683,2073),(39684,2073),(39685,2073),(39686,2073),(39687,2074),(39688,2074),(39689,2074),(39690,2074),(39691,2075),(39692,2075),(39693,2075),(39694,2075),(39695,2076),(39696,2076),(39697,2076),(39698,2076),(39699,2077),(39700,2077),(39701,2077),(39702,2077),(39703,2078),(39704,2078),(39705,2078),(39706,2078),(39707,2079),(39708,2079),(39709,2079),(39710,2079),(39711,2080),(39712,2080),(39713,2080),(39714,2080),(39715,2081),(39716,2081),(39717,2081),(39718,2081),(39719,2082),(39720,2082),(39721,2082),(39722,2082),(39723,2083),(39724,2083),(39725,2083),(39726,2083),(39727,2084),(39728,2084),(39729,2084),(39730,2084),(39731,2085),(39732,2085),(39733,2085),(39734,2085),(39735,2086),(39736,2086),(39737,2086),(39738,2086),(39739,2087),(39740,2087),(39741,2087),(39742,2087),(39743,2088),(39744,2088),(39745,2088),(39746,2088),(39747,2089),(39748,2089),(39749,2089),(39750,2089),(39751,2090),(39752,2090),(39753,2090),(39754,2090),(39755,2091),(39756,2091),(39757,2091),(39758,2091),(39759,2092),(39760,2092),(39761,2092),(39762,2092),(39763,2093),(39764,2093),(39765,2093),(39766,2093),(39767,2094),(39768,2094),(39769,2094),(39770,2094),(39771,2095),(39772,2095),(39773,2095),(39774,2095),(39775,2096),(39776,2096),(39777,2096),(39778,2096),(39779,2097),(39780,2097),(39781,2097),(39782,2097),(39783,2098),(39784,2098),(39785,2098),(39786,2098),(39787,2099),(39788,2099),(39789,2099),(39790,2099),(39791,2100),(39792,2100),(39793,2100),(39794,2100),(39795,2101),(39796,2101),(39797,2101),(39798,2101),(39799,2102),(39800,2102),(39801,2102),(39802,2102),(39803,2103),(39804,2103),(39805,2103),(39806,2103),(39807,2104),(39808,2104),(39809,2104),(39810,2104),(39811,2105),(39812,2105),(39813,2105),(39814,2105),(39815,2106),(39816,2106),(39817,2106),(39818,2106),(39819,2107),(39820,2107),(39821,2107),(39822,2107),(39823,2108),(39824,2108),(39825,2108),(39826,2108),(39827,2109),(39828,2109),(39829,2109),(39830,2109),(39831,2110),(39832,2110),(39833,2110),(39834,2110),(39835,2111),(39836,2111),(39837,2111),(39838,2111),(39839,2112),(39840,2112),(39841,2112),(39842,2112),(39843,2113),(39844,2114),(39845,2115),(39846,2116),(39847,2117),(39848,2118),(39849,2119),(39850,2120),(39851,2121),(39852,2122),(39853,2123),(39854,2124),(39855,2125),(39856,2126),(39857,2127),(39858,2128),(39859,2129),(39860,2130),(39861,2131),(39862,2132),(39863,2133),(39864,2134),(39865,2135),(39866,2136),(39867,2137),(39868,2138),(39869,2139),(39870,2140),(39871,2141),(39872,2142),(39873,2143),(39874,2144),(39875,2145),(39876,2146),(39877,2147),(39878,2148),(39879,2149),(39880,2150),(39881,2151),(39882,2152),(39883,2153),(39884,2154),(39885,2155),(39886,2156),(39887,2157),(39888,2158),(39889,2159),(39890,2160),(39891,2161),(39892,2162),(39893,2163),(39894,2164),(39895,2165),(39896,2166),(39897,2167),(39898,2168),(39899,2169),(39900,2170),(39901,2171),(39902,2172),(39903,2173),(39904,2174),(39905,2175),(39906,2176),(39907,2177),(39908,2178),(39909,2179),(39910,2180),(39911,2181),(39912,2182),(39913,2183),(39914,2184),(39915,2185),(39916,2186),(39917,2187),(39918,2188),(39919,2189),(39920,2190),(39921,2191),(39922,2192),(39923,2193),(39924,2194),(39925,2195),(39926,2196),(39927,2197),(39928,2198),(39929,2199),(39930,2200),(39931,2201),(39932,2202),(39933,2203),(39934,2204),(39935,2205),(39936,2206),(39937,2207),(39938,2208),(39939,2209),(39940,2210),(39941,2211),(39942,2212),(39943,2113),(39944,2114),(39945,2115),(39946,2116),(39947,2117),(39948,2118),(39949,2119),(39950,2120),(39951,2121),(39952,2122),(39953,2123),(39954,2124),(39955,2125),(39956,2126),(39957,2127),(39958,2128),(39959,2129),(39960,2130),(39961,2131),(39962,2132),(39963,2133),(39964,2134),(39965,2135),(39966,2136),(39967,2137),(39968,2138),(39969,2139),(39970,2140),(39971,2141),(39972,2142),(39973,2143),(39974,2144),(39975,2145),(39976,2146),(39977,2147),(39978,2148),(39979,2149),(39980,2150),(39981,2151),(39982,2152),(39983,2153),(39984,2154),(39985,2155),(39986,2156),(39987,2157),(39988,2158),(39989,2159),(39990,2160),(39991,2161),(39992,2162),(39993,2163),(39994,2164),(39995,2165),(39996,2166),(39997,2167),(39998,2168),(39999,2169),(40000,2170),(40001,2171),(40002,2172),(40003,2173),(40004,2174),(40005,2175),(40006,2176),(40007,2177),(40008,2178),(40009,2179),(40010,2180),(40011,2181),(40012,2182),(40013,2183),(40014,2184),(40015,2185),(40016,2186),(40017,2187),(40018,2188),(40019,2189),(40020,2190),(40021,2191),(40022,2192),(40023,2193),(40024,2194),(40025,2195),(40026,2196),(40027,2197),(40028,2198),(40029,2199),(40030,2200),(40031,2201),(40032,2202),(40033,2203),(40034,2204),(40035,2205),(40036,2206),(40037,2207),(40038,2208),(40039,2209),(40040,2210),(40041,2211),(40042,2212),(40043,2113),(40044,2113),(40045,2113),(40046,2113),(40047,2113),(40048,2113),(40049,2114),(40050,2114),(40051,2114),(40052,2114),(40053,2114),(40054,2114),(40055,2115),(40056,2115),(40057,2115),(40058,2115),(40059,2115),(40060,2115),(40061,2115),(40062,2116),(40063,2116),(40064,2116),(40065,2116),(40066,2116),(40067,2116),(40068,2116),(40069,2117),(40070,2117),(40071,2117),(40072,2117),(40073,2117),(40074,2117),(40075,2117),(40076,2118),(40077,2118),(40078,2118),(40079,2118),(40080,2118),(40081,2118),(40082,2118),(40083,2119),(40084,2119),(40085,2119),(40086,2119),(40087,2119),(40088,2119),(40089,2119),(40090,2120),(40091,2120),(40092,2120),(40093,2120),(40094,2120),(40095,2120),(40096,2120),(40097,2120),(40098,2120),(40099,2121),(40100,2121),(40101,2121),(40102,2121),(40103,2121),(40104,2121),(40105,2121),(40106,2121),(40107,2121),(40108,2122),(40109,2122),(40110,2122),(40111,2122),(40112,2122),(40113,2122),(40114,2122),(40115,2122),(40116,2122),(40117,2123),(40118,2123),(40119,2123),(40120,2123),(40121,2123),(40122,2123),(40123,2123),(40124,2123),(40125,2123),(40126,2124),(40127,2124),(40128,2124),(40129,2124),(40130,2124),(40131,2124),(40132,2124),(40133,2124),(40134,2124),(40135,2125),(40136,2125),(40137,2125),(40138,2125),(40139,2125),(40140,2125),(40141,2125),(40142,2125),(40143,2125),(40144,2126),(40145,2126),(40146,2126),(40147,2126),(40148,2126),(40149,2126),(40150,2126),(40151,2126),(40152,2126),(40153,2127),(40154,2127),(40155,2127),(40156,2127),(40157,2127),(40158,2127),(40159,2127),(40160,2127),(40161,2127),(40162,2128),(40163,2128),(40164,2128),(40165,2128),(40166,2128),(40167,2128),(40168,2128),(40169,2128),(40170,2128),(40171,2129),(40172,2129),(40173,2129),(40174,2129),(40175,2129),(40176,2129),(40177,2129),(40178,2129),(40179,2129),(40180,2130),(40181,2130),(40182,2130),(40183,2130),(40184,2130),(40185,2130),(40186,2130),(40187,2130),(40188,2130),(40189,2131),(40190,2131),(40191,2131),(40192,2131),(40193,2131),(40194,2131),(40195,2131),(40196,2131),(40197,2131),(40198,2132),(40199,2132),(40200,2132),(40201,2132),(40202,2132),(40203,2132),(40204,2132),(40205,2132),(40206,2132),(40207,2133),(40208,2133),(40209,2133),(40210,2133),(40211,2133),(40212,2133),(40213,2133),(40214,2134),(40215,2134),(40216,2134),(40217,2134),(40218,2134),(40219,2134),(40220,2134),(40221,2135),(40222,2135),(40223,2135),(40224,2135),(40225,2135),(40226,2135),(40227,2135),(40228,2135),(40229,2136),(40230,2136),(40231,2136),(40232,2136),(40233,2136),(40234,2136),(40235,2136),(40236,2136),(40237,2136),(40238,2137),(40239,2137),(40240,2137),(40241,2137),(40242,2137),(40243,2137),(40244,2137),(40245,2137),(40246,2137),(40247,2138),(40248,2138),(40249,2138),(40250,2138),(40251,2138),(40252,2138),(40253,2138),(40254,2138),(40255,2138),(40256,2139),(40257,2139),(40258,2139),(40259,2139),(40260,2139),(40261,2139),(40262,2139),(40263,2140),(40264,2140),(40265,2140),(40266,2140),(40267,2140),(40268,2140),(40269,2140),(40270,2141),(40271,2141),(40272,2141),(40273,2141),(40274,2141),(40275,2141),(40276,2141),(40277,2142),(40278,2142),(40279,2142),(40280,2142),(40281,2142),(40282,2142),(40283,2142),(40284,2143),(40285,2143),(40286,2143),(40287,2143),(40288,2143),(40289,2143),(40290,2143),(40291,2144),(40292,2144),(40293,2144),(40294,2144),(40295,2144),(40296,2144),(40297,2144),(40298,2145),(40299,2145),(40300,2145),(40301,2145),(40302,2145),(40303,2145),(40304,2145),(40305,2146),(40306,2146),(40307,2146),(40308,2146),(40309,2146),(40310,2146),(40311,2146),(40312,2147),(40313,2147),(40314,2147),(40315,2147),(40316,2147),(40317,2147),(40318,2147),(40319,2148),(40320,2148),(40321,2148),(40322,2148),(40323,2148),(40324,2148),(40325,2148),(40326,2149),(40327,2149),(40328,2149),(40329,2149),(40330,2149),(40331,2149),(40332,2149),(40333,2150),(40334,2150),(40335,2150),(40336,2150),(40337,2150),(40338,2150),(40339,2150),(40340,2151),(40341,2151),(40342,2151),(40343,2151),(40344,2151),(40345,2151),(40346,2151),(40347,2152),(40348,2152),(40349,2152),(40350,2152),(40351,2152),(40352,2152),(40353,2152),(40354,2153),(40355,2153),(40356,2153),(40357,2153),(40358,2153),(40359,2153),(40360,2153),(40361,2154),(40362,2154),(40363,2154),(40364,2154),(40365,2154),(40366,2154),(40367,2154),(40368,2154),(40369,2154),(40370,2155),(40371,2155),(40372,2155),(40373,2155),(40374,2155),(40375,2155),(40376,2155),(40377,2155),(40378,2155),(40379,2156),(40380,2156),(40381,2156),(40382,2156),(40383,2156),(40384,2156),(40385,2156),(40386,2156),(40387,2156),(40388,2157),(40389,2157),(40390,2157),(40391,2157),(40392,2157),(40393,2157),(40394,2157),(40395,2157),(40396,2157),(40397,2158),(40398,2158),(40399,2158),(40400,2158),(40401,2158),(40402,2158),(40403,2158),(40404,2159),(40405,2159),(40406,2159),(40407,2159),(40408,2159),(40409,2159),(40410,2159),(40411,2159),(40412,2159),(40413,2160),(40414,2160),(40415,2160),(40416,2160),(40417,2160),(40418,2160),(40419,2160),(40420,2161),(40421,2161),(40422,2161),(40423,2161),(40424,2161),(40425,2161),(40426,2161),(40427,2162),(40428,2162),(40429,2162),(40430,2162),(40431,2162),(40432,2162),(40433,2162),(40434,2163),(40435,2163),(40436,2163),(40437,2163),(40438,2163),(40439,2163),(40440,2163),(40441,2163),(40442,2163),(40443,2164),(40444,2164),(40445,2164),(40446,2164),(40447,2164),(40448,2164),(40449,2164),(40450,2165),(40451,2165),(40452,2165),(40453,2165),(40454,2165),(40455,2165),(40456,2165),(40457,2166),(40458,2166),(40459,2166),(40460,2166),(40461,2166),(40462,2166),(40463,2166),(40464,2167),(40465,2167),(40466,2167),(40467,2167),(40468,2167),(40469,2167),(40470,2167),(40471,2168),(40472,2168),(40473,2168),(40474,2168),(40475,2168),(40476,2168),(40477,2168),(40478,2169),(40479,2169),(40480,2169),(40481,2169),(40482,2169),(40483,2169),(40484,2169),(40485,2170),(40486,2170),(40487,2170),(40488,2170),(40489,2170),(40490,2170),(40491,2170),(40492,2171),(40493,2171),(40494,2171),(40495,2171),(40496,2171),(40497,2171),(40498,2171),(40499,2172),(40500,2172),(40501,2172),(40502,2172),(40503,2172),(40504,2172),(40505,2172),(40506,2173),(40507,2173),(40508,2173),(40509,2173),(40510,2173),(40511,2173),(40512,2173),(40513,2174),(40514,2174),(40515,2174),(40516,2174),(40517,2174),(40518,2174),(40519,2174),(40520,2175),(40521,2175),(40522,2175),(40523,2175),(40524,2175),(40525,2175),(40526,2175),(40527,2176),(40528,2176),(40529,2176),(40530,2176),(40531,2176),(40532,2176),(40533,2176),(40534,2177),(40535,2177),(40536,2177),(40537,2177),(40538,2177),(40539,2177),(40540,2177),(40541,2177),(40542,2177),(40543,2178),(40544,2178),(40545,2178),(40546,2178),(40547,2178),(40548,2178),(40549,2178),(40550,2179),(40551,2179),(40552,2179),(40553,2179),(40554,2179),(40555,2179),(40556,2179),(40557,2180),(40558,2180),(40559,2180),(40560,2180),(40561,2180),(40562,2180),(40563,2180),(40564,2181),(40565,2181),(40566,2181),(40567,2181),(40568,2181),(40569,2181),(40570,2181),(40571,2182),(40572,2182),(40573,2182),(40574,2182),(40575,2182),(40576,2182),(40577,2182),(40578,2183),(40579,2183),(40580,2183),(40581,2183),(40582,2183),(40583,2183),(40584,2183),(40585,2184),(40586,2184),(40587,2184),(40588,2184),(40589,2184),(40590,2184),(40591,2184),(40592,2185),(40593,2185),(40594,2185),(40595,2185),(40596,2185),(40597,2185),(40598,2185),(40599,2186),(40600,2186),(40601,2186),(40602,2186),(40603,2186),(40604,2186),(40605,2186),(40606,2187),(40607,2187),(40608,2187),(40609,2187),(40610,2187),(40611,2187),(40612,2187),(40613,2188),(40614,2188),(40615,2188),(40616,2188),(40617,2188),(40618,2188),(40619,2188),(40620,2189),(40621,2189),(40622,2189),(40623,2189),(40624,2189),(40625,2189),(40626,2189),(40627,2190),(40628,2190),(40629,2190),(40630,2190),(40631,2190),(40632,2190),(40633,2190),(40634,2191),(40635,2191),(40636,2191),(40637,2191),(40638,2192),(40639,2192),(40640,2192),(40641,2192),(40642,2192),(40643,2192),(40644,2192),(40645,2193),(40646,2193),(40647,2193),(40648,2193),(40649,2194),(40650,2194),(40651,2194),(40652,2194),(40653,2194),(40654,2194),(40655,2194),(40656,2195),(40657,2195),(40658,2195),(40659,2195),(40660,2196),(40661,2196),(40662,2196),(40663,2196),(40664,2196),(40665,2196),(40666,2197),(40667,2197),(40668,2197),(40669,2197),(40670,2197),(40671,2197),(40672,2197),(40673,2198),(40674,2198),(40675,2198),(40676,2198),(40677,2199),(40678,2199),(40679,2199),(40680,2199),(40681,2199),(40682,2199),(40683,2199),(40684,2200),(40685,2200),(40686,2200),(40687,2200),(40688,2200),(40689,2200),(40690,2200),(40691,2201),(40692,2201),(40693,2201),(40694,2201),(40695,2201),(40696,2201),(40697,2201),(40698,2202),(40699,2202),(40700,2202),(40701,2202),(40702,2202),(40703,2202),(40704,2202),(40705,2203),(40706,2203),(40707,2203),(40708,2203),(40709,2203),(40710,2203),(40711,2203),(40712,2204),(40713,2204),(40714,2204),(40715,2204),(40716,2204),(40717,2204),(40718,2204),(40719,2205),(40720,2205),(40721,2205),(40722,2205),(40723,2205),(40724,2205),(40725,2205),(40726,2206),(40727,2206),(40728,2206),(40729,2206),(40730,2206),(40731,2206),(40732,2206),(40733,2207),(40734,2207),(40735,2207),(40736,2207),(40737,2207),(40738,2207),(40739,2207),(40740,2208),(40741,2208),(40742,2208),(40743,2208),(40744,2208),(40745,2208),(40746,2208),(40747,2209),(40748,2209),(40749,2209),(40750,2209),(40751,2209),(40752,2209),(40753,2209),(40754,2210),(40755,2210),(40756,2210),(40757,2210),(40758,2210),(40759,2210),(40760,2210),(40761,2211),(40762,2211),(40763,2211),(40764,2211),(40765,2211),(40766,2211),(40767,2211),(40768,2211),(40769,2211),(40770,2212),(40771,2212),(40772,2212),(40773,2212),(40774,2212),(40775,2212),(40776,2212),(40777,2113),(40778,2113),(40779,2114),(40780,2114),(40781,2115),(40782,2116),(40783,2116),(40784,2116),(40785,2117),(40786,2117),(40787,2117),(40788,2118),(40789,2118),(40790,2118),(40791,2119),(40792,2119),(40793,2119),(40794,2120),(40795,2120),(40796,2121),(40797,2121),(40798,2122),(40799,2122),(40800,2123),(40801,2123),(40802,2124),(40803,2124),(40804,2125),(40805,2125),(40806,2126),(40807,2126),(40808,2127),(40809,2127),(40810,2128),(40811,2128),(40812,2129),(40813,2129),(40814,2130),(40815,2130),(40816,2131),(40817,2131),(40818,2132),(40819,2132),(40820,2133),(40821,2133),(40822,2133),(40823,2134),(40824,2134),(40825,2134),(40826,2135),(40827,2135),(40828,2136),(40829,2136),(40830,2137),(40831,2137),(40832,2138),(40833,2138),(40834,2139),(40835,2139),(40836,2139),(40837,2140),(40838,2140),(40839,2140),(40840,2141),(40841,2141),(40842,2141),(40843,2142),(40844,2142),(40845,2142),(40846,2143),(40847,2143),(40848,2143),(40849,2144),(40850,2144),(40851,2144),(40852,2145),(40853,2145),(40854,2145),(40855,2146),(40856,2146),(40857,2146),(40858,2147),(40859,2147),(40860,2147),(40861,2148),(40862,2148),(40863,2148),(40864,2149),(40865,2149),(40866,2149),(40867,2150),(40868,2150),(40869,2150),(40870,2151),(40871,2151),(40872,2151),(40873,2152),(40874,2152),(40875,2152),(40876,2153),(40877,2153),(40878,2153),(40879,2154),(40880,2154),(40881,2154),(40882,2155),(40883,2155),(40884,2156),(40885,2156),(40886,2157),(40887,2157),(40888,2158),(40889,2158),(40890,2158),(40891,2159),(40892,2159),(40893,2159),(40894,2160),(40895,2160),(40896,2160),(40897,2161),(40898,2161),(40899,2161),(40900,2162),(40901,2162),(40902,2162),(40903,2163),(40904,2163),(40905,2164),(40906,2164),(40907,2164),(40908,2165),(40909,2165),(40910,2165),(40911,2166),(40912,2166),(40913,2166),(40914,2167),(40915,2167),(40916,2167),(40917,2168),(40918,2168),(40919,2168),(40920,2169),(40921,2169),(40922,2169),(40923,2170),(40924,2170),(40925,2170),(40926,2171),(40927,2171),(40928,2171),(40929,2172),(40930,2172),(40931,2172),(40932,2173),(40933,2173),(40934,2173),(40935,2174),(40936,2174),(40937,2174),(40938,2175),(40939,2175),(40940,2175),(40941,2176),(40942,2176),(40943,2176),(40944,2177),(40945,2177),(40946,2177),(40947,2178),(40948,2178),(40949,2178),(40950,2179),(40951,2179),(40952,2179),(40953,2180),(40954,2180),(40955,2180),(40956,2181),(40957,2181),(40958,2181),(40959,2182),(40960,2182),(40961,2182),(40962,2183),(40963,2183),(40964,2183),(40965,2184),(40966,2184),(40967,2184),(40968,2185),(40969,2185),(40970,2185),(40971,2186),(40972,2186),(40973,2186),(40974,2187),(40975,2187),(40976,2187),(40977,2188),(40978,2188),(40979,2188),(40980,2189),(40981,2189),(40982,2189),(40983,2190),(40984,2190),(40985,2190),(40986,2191),(40987,2192),(40988,2192),(40989,2192),(40990,2193),(40991,2194),(40992,2194),(40993,2194),(40994,2195),(40995,2196),(40996,2196),(40997,2196),(40998,2197),(40999,2197),(41000,2197),(41001,2198),(41002,2199),(41003,2199),(41004,2199),(41005,2200),(41006,2200),(41007,2200),(41008,2201),(41009,2201),(41010,2201),(41011,2202),(41012,2202),(41013,2202),(41014,2203),(41015,2203),(41016,2203),(41017,2204),(41018,2204),(41019,2204),(41020,2205),(41021,2205),(41022,2205),(41023,2206),(41024,2206),(41025,2206),(41026,2207),(41027,2207),(41028,2207),(41029,2208),(41030,2208),(41031,2208),(41032,2209),(41033,2209),(41034,2209),(41035,2210),(41036,2210),(41037,2210),(41038,2211),(41039,2211),(41040,2211),(41041,2212),(41042,2212),(41043,2212),(41044,2113),(41045,2113),(41046,2113),(41047,2114),(41048,2114),(41049,2114),(41050,2115),(41051,2115),(41052,2115),(41053,2116),(41054,2116),(41055,2116),(41056,2117),(41057,2117),(41058,2117),(41059,2118),(41060,2118),(41061,2118),(41062,2119),(41063,2119),(41064,2119),(41065,2120),(41066,2120),(41067,2120),(41068,2121),(41069,2121),(41070,2121),(41071,2122),(41072,2122),(41073,2122),(41074,2123),(41075,2123),(41076,2123),(41077,2124),(41078,2124),(41079,2124),(41080,2125),(41081,2125),(41082,2125),(41083,2126),(41084,2126),(41085,2126),(41086,2127),(41087,2127),(41088,2127),(41089,2128),(41090,2128),(41091,2128),(41092,2129),(41093,2129),(41094,2129),(41095,2130),(41096,2130),(41097,2130),(41098,2131),(41099,2131),(41100,2131),(41101,2132),(41102,2132),(41103,2132),(41104,2133),(41105,2133),(41106,2133),(41107,2134),(41108,2134),(41109,2134),(41110,2135),(41111,2135),(41112,2135),(41113,2136),(41114,2136),(41115,2136),(41116,2137),(41117,2137),(41118,2137),(41119,2138),(41120,2138),(41121,2138),(41122,2139),(41123,2139),(41124,2139),(41125,2140),(41126,2140),(41127,2140),(41128,2141),(41129,2141),(41130,2141),(41131,2142),(41132,2142),(41133,2142),(41134,2143),(41135,2143),(41136,2143),(41137,2144),(41138,2144),(41139,2144),(41140,2145),(41141,2145),(41142,2145),(41143,2146),(41144,2146),(41145,2146),(41146,2147),(41147,2147),(41148,2147),(41149,2148),(41150,2148),(41151,2148),(41152,2149),(41153,2149),(41154,2149),(41155,2150),(41156,2150),(41157,2150),(41158,2151),(41159,2151),(41160,2151),(41161,2152),(41162,2152),(41163,2152),(41164,2153),(41165,2153),(41166,2153),(41167,2154),(41168,2154),(41169,2154),(41170,2155),(41171,2155),(41172,2155),(41173,2156),(41174,2156),(41175,2156),(41176,2157),(41177,2157),(41178,2157),(41179,2158),(41180,2158),(41181,2158),(41182,2159),(41183,2159),(41184,2159),(41185,2160),(41186,2160),(41187,2160),(41188,2161),(41189,2161),(41190,2161),(41191,2162),(41192,2162),(41193,2162),(41194,2163),(41195,2163),(41196,2163),(41197,2164),(41198,2164),(41199,2164),(41200,2165),(41201,2165),(41202,2165),(41203,2166),(41204,2166),(41205,2166),(41206,2167),(41207,2167),(41208,2167),(41209,2168),(41210,2168),(41211,2168),(41212,2169),(41213,2169),(41214,2169),(41215,2169),(41216,2170),(41217,2170),(41218,2170),(41219,2171),(41220,2171),(41221,2171),(41222,2172),(41223,2172),(41224,2172),(41225,2173),(41226,2173),(41227,2173),(41228,2174),(41229,2174),(41230,2174),(41231,2175),(41232,2175),(41233,2175),(41234,2176),(41235,2176),(41236,2176),(41237,2177),(41238,2177),(41239,2177),(41240,2178),(41241,2178),(41242,2178),(41243,2179),(41244,2179),(41245,2179),(41246,2180),(41247,2180),(41248,2180),(41249,2181),(41250,2181),(41251,2181),(41252,2182),(41253,2182),(41254,2182),(41255,2183),(41256,2183),(41257,2183),(41258,2184),(41259,2184),(41260,2184),(41261,2185),(41262,2185),(41263,2185),(41264,2186),(41265,2186),(41266,2186),(41267,2187),(41268,2187),(41269,2187),(41270,2188),(41271,2188),(41272,2188),(41273,2189),(41274,2189),(41275,2189),(41276,2190),(41277,2190),(41278,2190),(41279,2191),(41280,2191),(41281,2191),(41282,2192),(41283,2192),(41284,2192),(41285,2193),(41286,2193),(41287,2193),(41288,2194),(41289,2194),(41290,2194),(41291,2195),(41292,2195),(41293,2195),(41294,2196),(41295,2196),(41296,2196),(41297,2197),(41298,2197),(41299,2197),(41300,2198),(41301,2198),(41302,2198),(41303,2199),(41304,2199),(41305,2199),(41306,2200),(41307,2200),(41308,2200),(41309,2201),(41310,2201),(41311,2201),(41312,2202),(41313,2202),(41314,2202),(41315,2203),(41316,2203),(41317,2203),(41318,2204),(41319,2204),(41320,2204),(41321,2205),(41322,2205),(41323,2205),(41324,2206),(41325,2206),(41326,2206),(41327,2207),(41328,2207),(41329,2207),(41330,2208),(41331,2208),(41332,2208),(41333,2209),(41334,2209),(41335,2209),(41336,2210),(41337,2210),(41338,2210),(41339,2211),(41340,2211),(41341,2211),(41342,2212),(41343,2212),(41344,2212),(41345,2113),(41346,2113),(41347,2113),(41348,2113),(41349,2114),(41350,2114),(41351,2114),(41352,2114),(41353,2115),(41354,2115),(41355,2115),(41356,2115),(41357,2116),(41358,2116),(41359,2116),(41360,2116),(41361,2117),(41362,2117),(41363,2117),(41364,2117),(41365,2118),(41366,2118),(41367,2118),(41368,2118),(41369,2119),(41370,2119),(41371,2119),(41372,2119),(41373,2120),(41374,2120),(41375,2120),(41376,2120),(41377,2121),(41378,2121),(41379,2121),(41380,2121),(41381,2122),(41382,2122),(41383,2122),(41384,2122),(41385,2123),(41386,2123),(41387,2123),(41388,2123),(41389,2124),(41390,2124),(41391,2124),(41392,2124),(41393,2125),(41394,2125),(41395,2125),(41396,2125),(41397,2126),(41398,2126),(41399,2126),(41400,2126),(41401,2127),(41402,2127),(41403,2127),(41404,2127),(41405,2128),(41406,2128),(41407,2128),(41408,2128),(41409,2129),(41410,2129),(41411,2129),(41412,2129),(41413,2130),(41414,2130),(41415,2130),(41416,2130),(41417,2131),(41418,2131),(41419,2131),(41420,2131),(41421,2132),(41422,2132),(41423,2132),(41424,2132),(41425,2133),(41426,2133),(41427,2133),(41428,2133),(41429,2134),(41430,2134),(41431,2134),(41432,2134),(41433,2135),(41434,2135),(41435,2135),(41436,2135),(41437,2136),(41438,2136),(41439,2136),(41440,2136),(41441,2137),(41442,2137),(41443,2137),(41444,2137),(41445,2138),(41446,2138),(41447,2138),(41448,2138),(41449,2139),(41450,2139),(41451,2139),(41452,2139),(41453,2140),(41454,2140),(41455,2140),(41456,2140),(41457,2141),(41458,2141),(41459,2141),(41460,2141),(41461,2142),(41462,2142),(41463,2142),(41464,2142),(41465,2143),(41466,2143),(41467,2143),(41468,2143),(41469,2144),(41470,2144),(41471,2144),(41472,2144),(41473,2145),(41474,2145),(41475,2145),(41476,2145),(41477,2146),(41478,2146),(41479,2146),(41480,2146),(41481,2147),(41482,2147),(41483,2147),(41484,2147),(41485,2148),(41486,2148),(41487,2148),(41488,2148),(41489,2149),(41490,2149),(41491,2149),(41492,2149),(41493,2150),(41494,2150),(41495,2150),(41496,2150),(41497,2151),(41498,2151),(41499,2151),(41500,2151),(41501,2152),(41502,2152),(41503,2152),(41504,2152),(41505,2153),(41506,2153),(41507,2153),(41508,2153),(41509,2154),(41510,2154),(41511,2154),(41512,2154),(41513,2155),(41514,2155),(41515,2155),(41516,2155),(41517,2156),(41518,2156),(41519,2156),(41520,2156),(41521,2157),(41522,2157),(41523,2157),(41524,2157),(41525,2158),(41526,2158),(41527,2158),(41528,2158),(41529,2159),(41530,2159),(41531,2159),(41532,2159),(41533,2160),(41534,2160),(41535,2160),(41536,2160),(41537,2161),(41538,2161),(41539,2161),(41540,2161),(41541,2162),(41542,2162),(41543,2162),(41544,2162),(41545,2163),(41546,2163),(41547,2163),(41548,2163),(41549,2164),(41550,2164),(41551,2164),(41552,2164),(41553,2165),(41554,2165),(41555,2165),(41556,2165),(41557,2166),(41558,2166),(41559,2166),(41560,2166),(41561,2167),(41562,2167),(41563,2167),(41564,2167),(41565,2168),(41566,2168),(41567,2168),(41568,2168),(41569,2169),(41570,2169),(41571,2169),(41572,2169),(41573,2170),(41574,2170),(41575,2170),(41576,2170),(41577,2171),(41578,2171),(41579,2171),(41580,2171),(41581,2172),(41582,2172),(41583,2172),(41584,2172),(41585,2173),(41586,2173),(41587,2173),(41588,2173),(41589,2174),(41590,2174),(41591,2174),(41592,2174),(41593,2175),(41594,2175),(41595,2175),(41596,2175),(41597,2176),(41598,2176),(41599,2176),(41600,2176),(41601,2177),(41602,2177),(41603,2177),(41604,2177),(41605,2178),(41606,2178),(41607,2178),(41608,2178),(41609,2179),(41610,2179),(41611,2179),(41612,2179),(41613,2180),(41614,2180),(41615,2180),(41616,2180),(41617,2181),(41618,2181),(41619,2181),(41620,2181),(41621,2182),(41622,2182),(41623,2182),(41624,2182),(41625,2183),(41626,2183),(41627,2183),(41628,2183),(41629,2184),(41630,2184),(41631,2184),(41632,2184),(41633,2185),(41634,2185),(41635,2185),(41636,2185),(41637,2186),(41638,2186),(41639,2186),(41640,2186),(41641,2187),(41642,2187),(41643,2187),(41644,2187),(41645,2188),(41646,2188),(41647,2188),(41648,2188),(41649,2189),(41650,2189),(41651,2189),(41652,2189),(41653,2190),(41654,2190),(41655,2190),(41656,2190),(41657,2191),(41658,2191),(41659,2191),(41660,2191),(41661,2192),(41662,2192),(41663,2192),(41664,2192),(41665,2193),(41666,2193),(41667,2193),(41668,2193),(41669,2194),(41670,2194),(41671,2194),(41672,2194),(41673,2195),(41674,2195),(41675,2195),(41676,2195),(41677,2196),(41678,2196),(41679,2196),(41680,2196),(41681,2197),(41682,2197),(41683,2197),(41684,2197),(41685,2198),(41686,2198),(41687,2198),(41688,2198),(41689,2199),(41690,2199),(41691,2199),(41692,2199),(41693,2200),(41694,2200),(41695,2200),(41696,2200),(41697,2201),(41698,2201),(41699,2201),(41700,2201),(41701,2202),(41702,2202),(41703,2202),(41704,2202),(41705,2203),(41706,2203),(41707,2203),(41708,2203),(41709,2204),(41710,2204),(41711,2204),(41712,2204),(41713,2205),(41714,2205),(41715,2205),(41716,2205),(41717,2206),(41718,2206),(41719,2206),(41720,2206),(41721,2207),(41722,2207),(41723,2207),(41724,2207),(41725,2208),(41726,2208),(41727,2208),(41728,2208),(41729,2209),(41730,2209),(41731,2209),(41732,2209),(41733,2210),(41734,2210),(41735,2210),(41736,2210),(41737,2211),(41738,2211),(41739,2211),(41740,2211),(41741,2212),(41742,2212),(41743,2212),(41744,2212),(41745,2213),(41746,2214),(41747,2215),(41748,2216),(41749,2217),(41750,2218),(41751,2219),(41752,2220),(41753,2221),(41754,2222),(41755,2223),(41756,2224),(41757,2225),(41758,2226),(41759,2227),(41760,2228),(41761,2229),(41762,2230),(41763,2231),(41764,2232),(41765,2233),(41766,2234),(41767,2235),(41768,2236),(41769,2237),(41770,2238),(41771,2239),(41772,2240),(41773,2241),(41774,2242),(41775,2243),(41776,2244),(41777,2245),(41778,2246),(41779,2247),(41780,2248),(41781,2249),(41782,2250),(41783,2251),(41784,2252),(41785,2253),(41786,2254),(41787,2255),(41788,2256),(41789,2257),(41790,2258),(41791,2259),(41792,2260),(41793,2261),(41794,2262),(41795,2263),(41796,2264),(41797,2265),(41798,2266),(41799,2267),(41800,2268),(41801,2269),(41802,2270),(41803,2271),(41804,2272),(41805,2273),(41806,2274),(41807,2275),(41808,2276),(41809,2277),(41810,2278),(41811,2279),(41812,2280),(41813,2281),(41814,2282),(41815,2283),(41816,2284),(41817,2285),(41818,2286),(41819,2287),(41820,2288),(41821,2289),(41822,2290),(41823,2291),(41824,2292),(41825,2293),(41826,2294),(41827,2295),(41828,2296),(41829,2297),(41830,2298),(41831,2299),(41832,2300),(41833,2301),(41834,2302),(41835,2303),(41836,2304),(41837,2305),(41838,2306),(41839,2307),(41840,2308),(41841,2309),(41842,2310),(41843,2213),(41844,2214),(41845,2215),(41846,2216),(41847,2217),(41848,2218),(41849,2219),(41850,2220),(41851,2221),(41852,2222),(41853,2223),(41854,2224),(41855,2225),(41856,2226),(41857,2227),(41858,2228),(41859,2229),(41860,2230),(41861,2231),(41862,2232),(41863,2233),(41864,2234),(41865,2235),(41866,2236),(41867,2237),(41868,2238),(41869,2239),(41870,2240),(41871,2241),(41872,2242),(41873,2243),(41874,2244),(41875,2245),(41876,2246),(41877,2247),(41878,2248),(41879,2249),(41880,2250),(41881,2251),(41882,2252),(41883,2253),(41884,2254),(41885,2255),(41886,2256),(41887,2257),(41888,2258),(41889,2259),(41890,2260),(41891,2261),(41892,2262),(41893,2263),(41894,2264),(41895,2265),(41896,2266),(41897,2267),(41898,2268),(41899,2269),(41900,2270),(41901,2271),(41902,2272),(41903,2273),(41904,2274),(41905,2275),(41906,2276),(41907,2277),(41908,2278),(41909,2279),(41910,2280),(41911,2281),(41912,2282),(41913,2283),(41914,2284),(41915,2285),(41916,2286),(41917,2287),(41918,2288),(41919,2289),(41920,2290),(41921,2291),(41922,2292),(41923,2293),(41924,2294),(41925,2295),(41926,2296),(41927,2297),(41928,2298),(41929,2299),(41930,2300),(41931,2301),(41932,2302),(41933,2303),(41934,2304),(41935,2305),(41936,2306),(41937,2307),(41938,2308),(41939,2309),(41940,2310),(41941,2213),(41942,2213),(41943,2213),(41944,2213),(41945,2213),(41946,2213),(41947,2213),(41948,2214),(41949,2214),(41950,2214),(41951,2214),(41952,2214),(41953,2214),(41954,2214),(41955,2215),(41956,2215),(41957,2215),(41958,2215),(41959,2215),(41960,2215),(41961,2215),(41962,2216),(41963,2216),(41964,2216),(41965,2216),(41966,2216),(41967,2216),(41968,2216),(41969,2217),(41970,2217),(41971,2217),(41972,2217),(41973,2217),(41974,2217),(41975,2217),(41976,2218),(41977,2218),(41978,2218),(41979,2218),(41980,2218),(41981,2218),(41982,2218),(41983,2219),(41984,2219),(41985,2219),(41986,2219),(41987,2219),(41988,2219),(41989,2219),(41990,2220),(41991,2220),(41992,2220),(41993,2220),(41994,2220),(41995,2220),(41996,2220),(41997,2221),(41998,2221),(41999,2221),(42000,2221),(42001,2221),(42002,2221),(42003,2222),(42004,2222),(42005,2222),(42006,2222),(42007,2222),(42008,2222),(42009,2223),(42010,2223),(42011,2223),(42012,2223),(42013,2223),(42014,2223),(42015,2224),(42016,2224),(42017,2224),(42018,2224),(42019,2224),(42020,2224),(42021,2225),(42022,2225),(42023,2225),(42024,2225),(42025,2225),(42026,2225),(42027,2225),(42028,2226),(42029,2226),(42030,2226),(42031,2226),(42032,2226),(42033,2226),(42034,2226),(42035,2226),(42036,2226),(42037,2227),(42038,2227),(42039,2227),(42040,2227),(42041,2227),(42042,2227),(42043,2227),(42044,2228),(42045,2228),(42046,2228),(42047,2228),(42048,2228),(42049,2228),(42050,2228),(42051,2229),(42052,2229),(42053,2229),(42054,2229),(42055,2229),(42056,2229),(42057,2229),(42058,2230),(42059,2230),(42060,2230),(42061,2230),(42062,2230),(42063,2230),(42064,2230),(42065,2230),(42066,2230),(42067,2231),(42068,2231),(42069,2231),(42070,2231),(42071,2231),(42072,2231),(42073,2231),(42074,2232),(42075,2232),(42076,2232),(42077,2232),(42078,2232),(42079,2232),(42080,2232),(42081,2233),(42082,2233),(42083,2233),(42084,2233),(42085,2233),(42086,2233),(42087,2233),(42088,2234),(42089,2234),(42090,2234),(42091,2234),(42092,2234),(42093,2234),(42094,2234),(42095,2235),(42096,2235),(42097,2235),(42098,2235),(42099,2236),(42100,2236),(42101,2236),(42102,2236),(42103,2236),(42104,2236),(42105,2236),(42106,2237),(42107,2237),(42108,2237),(42109,2237),(42110,2237),(42111,2237),(42112,2237),(42113,2238),(42114,2238),(42115,2238),(42116,2238),(42117,2238),(42118,2238),(42119,2238),(42120,2239),(42121,2239),(42122,2239),(42123,2239),(42124,2239),(42125,2239),(42126,2240),(42127,2240),(42128,2240),(42129,2240),(42130,2241),(42131,2241),(42132,2241),(42133,2241),(42134,2241),(42135,2241),(42136,2242),(42137,2242),(42138,2242),(42139,2242),(42140,2242),(42141,2242),(42142,2243),(42143,2243),(42144,2243),(42145,2243),(42146,2243),(42147,2243),(42148,2244),(42149,2244),(42150,2244),(42151,2244),(42152,2244),(42153,2244),(42154,2245),(42155,2245),(42156,2245),(42157,2245),(42158,2245),(42159,2245),(42160,2246),(42161,2246),(42162,2246),(42163,2246),(42164,2246),(42165,2246),(42166,2246),(42167,2246),(42168,2246),(42169,2247),(42170,2247),(42171,2247),(42172,2247),(42173,2247),(42174,2247),(42175,2247),(42176,2248),(42177,2248),(42178,2248),(42179,2248),(42180,2248),(42181,2248),(42182,2248),(42183,2248),(42184,2248),(42185,2249),(42186,2249),(42187,2249),(42188,2249),(42189,2249),(42190,2249),(42191,2249),(42192,2250),(42193,2250),(42194,2250),(42195,2250),(42196,2250),(42197,2250),(42198,2250),(42199,2251),(42200,2251),(42201,2251),(42202,2251),(42203,2251),(42204,2251),(42205,2251),(42206,2252),(42207,2252),(42208,2252),(42209,2252),(42210,2252),(42211,2252),(42212,2252),(42213,2252),(42214,2252),(42215,2253),(42216,2253),(42217,2253),(42218,2253),(42219,2253),(42220,2253),(42221,2253),(42222,2254),(42223,2254),(42224,2254),(42225,2254),(42226,2254),(42227,2254),(42228,2254),(42229,2255),(42230,2255),(42231,2255),(42232,2255),(42233,2255),(42234,2255),(42235,2255),(42236,2256),(42237,2256),(42238,2256),(42239,2256),(42240,2256),(42241,2256),(42242,2256),(42243,2257),(42244,2257),(42245,2257),(42246,2257),(42247,2258),(42248,2258),(42249,2258),(42250,2258),(42251,2259),(42252,2259),(42253,2259),(42254,2259),(42255,2259),(42256,2259),(42257,2259),(42258,2260),(42259,2260),(42260,2260),(42261,2260),(42262,2260),(42263,2260),(42264,2260),(42265,2261),(42266,2261),(42267,2261),(42268,2261),(42269,2261),(42270,2261),(42271,2261),(42272,2262),(42273,2262),(42274,2262),(42275,2262),(42276,2262),(42277,2262),(42278,2262),(42279,2262),(42280,2263),(42281,2263),(42282,2263),(42283,2263),(42284,2263),(42285,2263),(42286,2263),(42287,2264),(42288,2264),(42289,2264),(42290,2264),(42291,2264),(42292,2264),(42293,2264),(42294,2265),(42295,2265),(42296,2265),(42297,2265),(42298,2265),(42299,2265),(42300,2265),(42301,2266),(42302,2266),(42303,2266),(42304,2266),(42305,2266),(42306,2266),(42307,2266),(42308,2267),(42309,2267),(42310,2267),(42311,2267),(42312,2267),(42313,2267),(42314,2267),(42315,2268),(42316,2268),(42317,2268),(42318,2268),(42319,2268),(42320,2268),(42321,2268),(42322,2269),(42323,2269),(42324,2269),(42325,2269),(42326,2269),(42327,2269),(42328,2269),(42329,2270),(42330,2270),(42331,2270),(42332,2270),(42333,2270),(42334,2270),(42335,2270),(42336,2270),(42337,2270),(42338,2271),(42339,2271),(42340,2271),(42341,2271),(42342,2271),(42343,2271),(42344,2271),(42345,2271),(42346,2271),(42347,2272),(42348,2272),(42349,2272),(42350,2272),(42351,2272),(42352,2272),(42353,2272),(42354,2273),(42355,2273),(42356,2273),(42357,2273),(42358,2273),(42359,2273),(42360,2273),(42361,2274),(42362,2274),(42363,2274),(42364,2274),(42365,2274),(42366,2274),(42367,2274),(42368,2275),(42369,2275),(42370,2275),(42371,2275),(42372,2275),(42373,2275),(42374,2276),(42375,2276),(42376,2276),(42377,2276),(42378,2276),(42379,2276),(42380,2276),(42381,2277),(42382,2277),(42383,2277),(42384,2277),(42385,2277),(42386,2277),(42387,2277),(42388,2277),(42389,2277),(42390,2278),(42391,2278),(42392,2278),(42393,2278),(42394,2278),(42395,2278),(42396,2278),(42397,2279),(42398,2279),(42399,2279),(42400,2279),(42401,2279),(42402,2279),(42403,2279),(42404,2280),(42405,2280),(42406,2280),(42407,2280),(42408,2280),(42409,2280),(42410,2280),(42411,2281),(42412,2281),(42413,2281),(42414,2281),(42415,2281),(42416,2281),(42417,2281),(42418,2282),(42419,2282),(42420,2282),(42421,2282),(42422,2282),(42423,2282),(42424,2282),(42425,2283),(42426,2283),(42427,2283),(42428,2283),(42429,2283),(42430,2283),(42431,2283),(42432,2284),(42433,2284),(42434,2284),(42435,2284),(42436,2284),(42437,2284),(42438,2284),(42439,2285),(42440,2285),(42441,2285),(42442,2285),(42443,2285),(42444,2285),(42445,2285),(42446,2286),(42447,2286),(42448,2286),(42449,2286),(42450,2286),(42451,2286),(42452,2286),(42453,2286),(42454,2286),(42455,2287),(42456,2287),(42457,2287),(42458,2287),(42459,2287),(42460,2287),(42461,2287),(42462,2288),(42463,2288),(42464,2288),(42465,2288),(42466,2288),(42467,2288),(42468,2288),(42469,2289),(42470,2289),(42471,2289),(42472,2289),(42473,2289),(42474,2289),(42475,2290),(42476,2290),(42477,2290),(42478,2290),(42479,2290),(42480,2290),(42481,2291),(42482,2291),(42483,2291),(42484,2291),(42485,2291),(42486,2291),(42487,2292),(42488,2292),(42489,2292),(42490,2292),(42491,2292),(42492,2292),(42493,2292),(42494,2293),(42495,2293),(42496,2293),(42497,2293),(42498,2293),(42499,2293),(42500,2294),(42501,2294),(42502,2294),(42503,2294),(42504,2294),(42505,2294),(42506,2294),(42507,2295),(42508,2295),(42509,2295),(42510,2295),(42511,2295),(42512,2295),(42513,2295),(42514,2296),(42515,2296),(42516,2296),(42517,2296),(42518,2296),(42519,2296),(42520,2296),(42521,2297),(42522,2297),(42523,2297),(42524,2297),(42525,2297),(42526,2297),(42527,2297),(42528,2297),(42529,2297),(42530,2298),(42531,2298),(42532,2298),(42533,2298),(42534,2298),(42535,2298),(42536,2298),(42537,2298),(42538,2298),(42539,2299),(42540,2299),(42541,2299),(42542,2299),(42543,2299),(42544,2299),(42545,2299),(42546,2300),(42547,2300),(42548,2300),(42549,2300),(42550,2300),(42551,2300),(42552,2300),(42553,2300),(42554,2301),(42555,2301),(42556,2301),(42557,2301),(42558,2301),(42559,2301),(42560,2301),(42561,2301),(42562,2302),(42563,2302),(42564,2302),(42565,2302),(42566,2303),(42567,2303),(42568,2303),(42569,2303),(42570,2304),(42571,2304),(42572,2304),(42573,2304),(42574,2304),(42575,2304),(42576,2304),(42577,2305),(42578,2305),(42579,2305),(42580,2305),(42581,2305),(42582,2305),(42583,2305),(42584,2306),(42585,2306),(42586,2306),(42587,2306),(42588,2306),(42589,2306),(42590,2306),(42591,2307),(42592,2307),(42593,2307),(42594,2307),(42595,2307),(42596,2307),(42597,2307),(42598,2308),(42599,2308),(42600,2308),(42601,2308),(42602,2308),(42603,2308),(42604,2308),(42605,2309),(42606,2309),(42607,2309),(42608,2309),(42609,2309),(42610,2309),(42611,2309),(42612,2310),(42613,2310),(42614,2310),(42615,2310),(42616,2310),(42617,2310),(42618,2310),(42619,2213),(42620,2213),(42621,2213),(42622,2214),(42623,2214),(42624,2214),(42625,2215),(42626,2215),(42627,2215),(42628,2216),(42629,2216),(42630,2216),(42631,2217),(42632,2217),(42633,2217),(42634,2218),(42635,2218),(42636,2218),(42637,2219),(42638,2219),(42639,2219),(42640,2220),(42641,2220),(42642,2220),(42643,2221),(42644,2221),(42645,2222),(42646,2222),(42647,2223),(42648,2223),(42649,2223),(42650,2224),(42651,2224),(42652,2224),(42653,2225),(42654,2225),(42655,2225),(42656,2226),(42657,2226),(42658,2227),(42659,2227),(42660,2227),(42661,2228),(42662,2228),(42663,2228),(42664,2229),(42665,2229),(42666,2229),(42667,2230),(42668,2230),(42669,2231),(42670,2231),(42671,2231),(42672,2232),(42673,2232),(42674,2232),(42675,2233),(42676,2233),(42677,2233),(42678,2234),(42679,2234),(42680,2234),(42681,2235),(42682,2236),(42683,2236),(42684,2236),(42685,2237),(42686,2237),(42687,2237),(42688,2238),(42689,2238),(42690,2238),(42691,2239),(42692,2239),(42693,2239),(42694,2240),(42695,2241),(42696,2241),(42697,2242),(42698,2242),(42699,2243),(42700,2243),(42701,2244),(42702,2244),(42703,2245),(42704,2245),(42705,2245),(42706,2246),(42707,2246),(42708,2247),(42709,2247),(42710,2247),(42711,2248),(42712,2248),(42713,2249),(42714,2249),(42715,2249),(42716,2250),(42717,2250),(42718,2250),(42719,2251),(42720,2251),(42721,2251),(42722,2252),(42723,2252),(42724,2252),(42725,2253),(42726,2253),(42727,2253),(42728,2254),(42729,2254),(42730,2254),(42731,2255),(42732,2255),(42733,2255),(42734,2256),(42735,2256),(42736,2256),(42737,2257),(42738,2258),(42739,2258),(42740,2259),(42741,2259),(42742,2259),(42743,2260),(42744,2260),(42745,2260),(42746,2261),(42747,2261),(42748,2261),(42749,2262),(42750,2262),(42751,2263),(42752,2263),(42753,2263),(42754,2264),(42755,2264),(42756,2264),(42757,2265),(42758,2265),(42759,2266),(42760,2266),(42761,2267),(42762,2267),(42763,2268),(42764,2268),(42765,2269),(42766,2269),(42767,2270),(42768,2270),(42769,2271),(42770,2271),(42771,2272),(42772,2272),(42773,2272),(42774,2273),(42775,2273),(42776,2273),(42777,2274),(42778,2274),(42779,2274),(42780,2275),(42781,2275),(42782,2275),(42783,2276),(42784,2276),(42785,2277),(42786,2277),(42787,2277),(42788,2278),(42789,2278),(42790,2278),(42791,2279),(42792,2279),(42793,2279),(42794,2280),(42795,2280),(42796,2280),(42797,2281),(42798,2281),(42799,2281),(42800,2282),(42801,2282),(42802,2282),(42803,2283),(42804,2283),(42805,2283),(42806,2284),(42807,2284),(42808,2284),(42809,2285),(42810,2285),(42811,2285),(42812,2286),(42813,2286),(42814,2286),(42815,2287),(42816,2287),(42817,2287),(42818,2288),(42819,2288),(42820,2288),(42821,2289),(42822,2289),(42823,2289),(42824,2290),(42825,2290),(42826,2290),(42827,2291),(42828,2291),(42829,2291),(42830,2292),(42831,2292),(42832,2292),(42833,2293),(42834,2293),(42835,2293),(42836,2294),(42837,2294),(42838,2294),(42839,2295),(42840,2295),(42841,2295),(42842,2296),(42843,2296),(42844,2296),(42845,2297),(42846,2297),(42847,2297),(42848,2298),(42849,2298),(42850,2298),(42851,2299),(42852,2299),(42853,2300),(42854,2300),(42855,2301),(42856,2301),(42857,2302),(42858,2303),(42859,2304),(42860,2304),(42861,2304),(42862,2305),(42863,2305),(42864,2305),(42865,2306),(42866,2306),(42867,2306),(42868,2307),(42869,2307),(42870,2307),(42871,2308),(42872,2308),(42873,2308),(42874,2309),(42875,2309),(42876,2309),(42877,2310),(42878,2310),(42879,2310),(42880,2213),(42881,2213),(42882,2213),(42883,2214),(42884,2214),(42885,2214),(42886,2215),(42887,2215),(42888,2215),(42889,2216),(42890,2216),(42891,2216),(42892,2217),(42893,2217),(42894,2217),(42895,2218),(42896,2218),(42897,2218),(42898,2219),(42899,2219),(42900,2219),(42901,2220),(42902,2220),(42903,2220),(42904,2221),(42905,2221),(42906,2221),(42907,2222),(42908,2222),(42909,2222),(42910,2223),(42911,2223),(42912,2223),(42913,2224),(42914,2224),(42915,2224),(42916,2225),(42917,2225),(42918,2225),(42919,2226),(42920,2226),(42921,2226),(42922,2227),(42923,2227),(42924,2227),(42925,2228),(42926,2228),(42927,2228),(42928,2229),(42929,2229),(42930,2229),(42931,2230),(42932,2230),(42933,2230),(42934,2231),(42935,2231),(42936,2231),(42937,2232),(42938,2232),(42939,2232),(42940,2233),(42941,2233),(42942,2233),(42943,2234),(42944,2234),(42945,2234),(42946,2235),(42947,2235),(42948,2235),(42949,2236),(42950,2236),(42951,2236),(42952,2237),(42953,2237),(42954,2237),(42955,2238),(42956,2238),(42957,2238),(42958,2239),(42959,2239),(42960,2239),(42961,2239),(42962,2240),(42963,2240),(42964,2240),(42965,2241),(42966,2242),(42967,2243),(42968,2244),(42969,2245),(42970,2245),(42971,2245),(42972,2245),(42973,2246),(42974,2246),(42975,2246),(42976,2247),(42977,2247),(42978,2247),(42979,2248),(42980,2248),(42981,2248),(42982,2249),(42983,2249),(42984,2249),(42985,2250),(42986,2250),(42987,2250),(42988,2251),(42989,2251),(42990,2251),(42991,2252),(42992,2252),(42993,2252),(42994,2253),(42995,2253),(42996,2253),(42997,2254),(42998,2254),(42999,2254),(43000,2255),(43001,2255),(43002,2255),(43003,2256),(43004,2256),(43005,2256),(43006,2257),(43007,2257),(43008,2257),(43009,2258),(43010,2258),(43011,2258),(43012,2259),(43013,2259),(43014,2259),(43015,2260),(43016,2260),(43017,2260),(43018,2261),(43019,2261),(43020,2261),(43021,2262),(43022,2262),(43023,2262),(43024,2263),(43025,2263),(43026,2263),(43027,2264),(43028,2264),(43029,2264),(43030,2265),(43031,2265),(43032,2265),(43033,2266),(43034,2266),(43035,2266),(43036,2267),(43037,2267),(43038,2267),(43039,2268),(43040,2268),(43041,2268),(43042,2269),(43043,2269),(43044,2269),(43045,2270),(43046,2270),(43047,2270),(43048,2271),(43049,2271),(43050,2271),(43051,2272),(43052,2272),(43053,2272),(43054,2273),(43055,2273),(43056,2273),(43057,2274),(43058,2274),(43059,2274),(43060,2275),(43061,2275),(43062,2275),(43063,2276),(43064,2276),(43065,2276),(43066,2277),(43067,2277),(43068,2277),(43069,2278),(43070,2278),(43071,2278),(43072,2279),(43073,2279),(43074,2279),(43075,2280),(43076,2280),(43077,2280),(43078,2281),(43079,2281),(43080,2281),(43081,2282),(43082,2282),(43083,2282),(43084,2283),(43085,2283),(43086,2283),(43087,2284),(43088,2284),(43089,2284),(43090,2285),(43091,2285),(43092,2285),(43093,2286),(43094,2286),(43095,2286),(43096,2287),(43097,2287),(43098,2287),(43099,2288),(43100,2288),(43101,2288),(43102,2289),(43103,2289),(43104,2289),(43105,2290),(43106,2290),(43107,2290),(43108,2291),(43109,2291),(43110,2291),(43111,2292),(43112,2292),(43113,2292),(43114,2293),(43115,2293),(43116,2293),(43117,2294),(43118,2294),(43119,2294),(43120,2295),(43121,2295),(43122,2295),(43123,2296),(43124,2296),(43125,2296),(43126,2297),(43127,2297),(43128,2297),(43129,2298),(43130,2298),(43131,2298),(43132,2299),(43133,2299),(43134,2299),(43135,2300),(43136,2300),(43137,2300),(43138,2301),(43139,2301),(43140,2301),(43141,2302),(43142,2302),(43143,2302),(43144,2303),(43145,2303),(43146,2303),(43147,2304),(43148,2304),(43149,2304),(43150,2305),(43151,2305),(43152,2305),(43153,2306),(43154,2306),(43155,2306),(43156,2307),(43157,2307),(43158,2307),(43159,2308),(43160,2308),(43161,2308),(43162,2309),(43163,2309),(43164,2309),(43165,2310),(43166,2310),(43167,2310),(43168,2213),(43169,2213),(43170,2213),(43171,2213),(43172,2214),(43173,2214),(43174,2214),(43175,2214),(43176,2215),(43177,2215),(43178,2215),(43179,2215),(43180,2216),(43181,2216),(43182,2216),(43183,2216),(43184,2217),(43185,2217),(43186,2217),(43187,2217),(43188,2218),(43189,2218),(43190,2218),(43191,2218),(43192,2219),(43193,2219),(43194,2219),(43195,2219),(43196,2220),(43197,2220),(43198,2220),(43199,2220),(43200,2221),(43201,2221),(43202,2221),(43203,2221),(43204,2222),(43205,2222),(43206,2222),(43207,2222),(43208,2223),(43209,2223),(43210,2223),(43211,2223),(43212,2224),(43213,2224),(43214,2224),(43215,2224),(43216,2225),(43217,2225),(43218,2225),(43219,2225),(43220,2226),(43221,2226),(43222,2226),(43223,2226),(43224,2227),(43225,2227),(43226,2227),(43227,2227),(43228,2228),(43229,2228),(43230,2228),(43231,2228),(43232,2229),(43233,2229),(43234,2229),(43235,2229),(43236,2230),(43237,2230),(43238,2230),(43239,2230),(43240,2231),(43241,2231),(43242,2231),(43243,2231),(43244,2232),(43245,2232),(43246,2232),(43247,2232),(43248,2233),(43249,2233),(43250,2233),(43251,2233),(43252,2234),(43253,2234),(43254,2234),(43255,2234),(43256,2235),(43257,2235),(43258,2235),(43259,2235),(43260,2236),(43261,2236),(43262,2236),(43263,2236),(43264,2237),(43265,2237),(43266,2237),(43267,2237),(43268,2238),(43269,2238),(43270,2238),(43271,2238),(43272,2239),(43273,2239),(43274,2239),(43275,2239),(43276,2240),(43277,2240),(43278,2240),(43279,2240),(43280,2241),(43281,2241),(43282,2241),(43283,2241),(43284,2242),(43285,2242),(43286,2242),(43287,2242),(43288,2243),(43289,2243),(43290,2243),(43291,2243),(43292,2244),(43293,2244),(43294,2244),(43295,2244),(43296,2245),(43297,2245),(43298,2245),(43299,2245),(43300,2246),(43301,2246),(43302,2246),(43303,2246),(43304,2247),(43305,2247),(43306,2247),(43307,2247),(43308,2248),(43309,2248),(43310,2248),(43311,2248),(43312,2249),(43313,2249),(43314,2249),(43315,2249),(43316,2250),(43317,2250),(43318,2250),(43319,2250),(43320,2251),(43321,2251),(43322,2251),(43323,2251),(43324,2252),(43325,2252),(43326,2252),(43327,2252),(43328,2253),(43329,2253),(43330,2253),(43331,2253),(43332,2254),(43333,2254),(43334,2254),(43335,2254),(43336,2255),(43337,2255),(43338,2255),(43339,2255),(43340,2256),(43341,2256),(43342,2256),(43343,2256),(43344,2257),(43345,2257),(43346,2257),(43347,2257),(43348,2258),(43349,2258),(43350,2258),(43351,2258),(43352,2259),(43353,2259),(43354,2259),(43355,2259),(43356,2260),(43357,2260),(43358,2260),(43359,2260),(43360,2261),(43361,2261),(43362,2261),(43363,2261),(43364,2262),(43365,2262),(43366,2262),(43367,2262),(43368,2263),(43369,2263),(43370,2263),(43371,2263),(43372,2264),(43373,2264),(43374,2264),(43375,2264),(43376,2265),(43377,2265),(43378,2265),(43379,2265),(43380,2266),(43381,2266),(43382,2266),(43383,2266),(43384,2267),(43385,2267),(43386,2267),(43387,2267),(43388,2268),(43389,2268),(43390,2268),(43391,2268),(43392,2269),(43393,2269),(43394,2269),(43395,2269),(43396,2270),(43397,2270),(43398,2270),(43399,2270),(43400,2271),(43401,2271),(43402,2271),(43403,2271),(43404,2272),(43405,2272),(43406,2272),(43407,2272),(43408,2273),(43409,2273),(43410,2273),(43411,2273),(43412,2274),(43413,2274),(43414,2274),(43415,2274),(43416,2275),(43417,2275),(43418,2275),(43419,2275),(43420,2276),(43421,2276),(43422,2276),(43423,2276),(43424,2277),(43425,2277),(43426,2277),(43427,2277),(43428,2278),(43429,2278),(43430,2278),(43431,2278),(43432,2279),(43433,2279),(43434,2279),(43435,2279),(43436,2280),(43437,2280),(43438,2280),(43439,2280),(43440,2281),(43441,2281),(43442,2281),(43443,2281),(43444,2282),(43445,2282),(43446,2282),(43447,2282),(43448,2283),(43449,2283),(43450,2283),(43451,2283),(43452,2284),(43453,2284),(43454,2284),(43455,2284),(43456,2285),(43457,2285),(43458,2285),(43459,2285),(43460,2286),(43461,2286),(43462,2286),(43463,2286),(43464,2287),(43465,2287),(43466,2287),(43467,2287),(43468,2288),(43469,2288),(43470,2288),(43471,2288),(43472,2289),(43473,2289),(43474,2289),(43475,2289),(43476,2290),(43477,2290),(43478,2290),(43479,2290),(43480,2291),(43481,2291),(43482,2291),(43483,2291),(43484,2292),(43485,2292),(43486,2292),(43487,2292),(43488,2293),(43489,2293),(43490,2293),(43491,2293),(43492,2294),(43493,2294),(43494,2294),(43495,2294),(43496,2295),(43497,2295),(43498,2295),(43499,2295),(43500,2296),(43501,2296),(43502,2296),(43503,2296),(43504,2297),(43505,2297),(43506,2297),(43507,2297),(43508,2298),(43509,2298),(43510,2298),(43511,2298),(43512,2299),(43513,2299),(43514,2299),(43515,2299),(43516,2300),(43517,2300),(43518,2300),(43519,2300),(43520,2301),(43521,2301),(43522,2301),(43523,2301),(43524,2302),(43525,2302),(43526,2302),(43527,2302),(43528,2303),(43529,2303),(43530,2303),(43531,2303),(43532,2304),(43533,2304),(43534,2304),(43535,2304),(43536,2305),(43537,2305),(43538,2305),(43539,2305),(43540,2306),(43541,2306),(43542,2306),(43543,2306),(43544,2307),(43545,2307),(43546,2307),(43547,2307),(43548,2308),(43549,2308),(43550,2308),(43551,2308),(43552,2309),(43553,2309),(43554,2309),(43555,2309),(43556,2310),(43557,2310),(43558,2310),(43559,2310),(43560,2311),(43561,2312),(43562,2313),(43563,2314),(43564,2315),(43565,2316),(43566,2317),(43567,2318),(43568,2319),(43569,2320),(43570,2321),(43571,2311),(43572,2312),(43573,2313),(43574,2314),(43575,2315),(43576,2316),(43577,2317),(43578,2318),(43579,2319),(43580,2320),(43581,2321),(43582,2311),(43583,2311),(43584,2311),(43585,2311),(43586,2312),(43587,2312),(43588,2312),(43589,2312),(43590,2312),(43591,2312),(43592,2312),(43593,2313),(43594,2313),(43595,2313),(43596,2313),(43597,2313),(43598,2313),(43599,2313),(43600,2314),(43601,2314),(43602,2314),(43603,2314),(43604,2314),(43605,2314),(43606,2314),(43607,2315),(43608,2315),(43609,2315),(43610,2315),(43611,2316),(43612,2316),(43613,2316),(43614,2316),(43615,2316),(43616,2316),(43617,2316),(43618,2317),(43619,2317),(43620,2317),(43621,2317),(43622,2317),(43623,2317),(43624,2317),(43625,2318),(43626,2318),(43627,2318),(43628,2318),(43629,2318),(43630,2318),(43631,2318),(43632,2319),(43633,2319),(43634,2319),(43635,2319),(43636,2319),(43637,2319),(43638,2319),(43639,2320),(43640,2320),(43641,2320),(43642,2320),(43643,2320),(43644,2320),(43645,2320),(43646,2321),(43647,2321),(43648,2321),(43649,2321),(43650,2321),(43651,2321),(43652,2321),(43653,2311),(43654,2312),(43655,2312),(43656,2312),(43657,2313),(43658,2313),(43659,2313),(43660,2314),(43661,2314),(43662,2314),(43663,2315),(43664,2315),(43665,2316),(43666,2316),(43667,2316),(43668,2317),(43669,2317),(43670,2318),(43671,2318),(43672,2319),(43673,2319),(43674,2320),(43675,2320),(43676,2321),(43677,2321),(43678,2311),(43679,2311),(43680,2311),(43681,2312),(43682,2312),(43683,2312),(43684,2313),(43685,2313),(43686,2313),(43687,2314),(43688,2314),(43689,2314),(43690,2315),(43691,2315),(43692,2315),(43693,2316),(43694,2316),(43695,2316),(43696,2317),(43697,2317),(43698,2317),(43699,2318),(43700,2318),(43701,2318),(43702,2319),(43703,2319),(43704,2319),(43705,2320),(43706,2320),(43707,2320),(43708,2321),(43709,2321),(43710,2321),(43711,2311),(43712,2311),(43713,2311),(43714,2311),(43715,2312),(43716,2312),(43717,2312),(43718,2312),(43719,2313),(43720,2313),(43721,2313),(43722,2313),(43723,2314),(43724,2314),(43725,2314),(43726,2314),(43727,2315),(43728,2315),(43729,2315),(43730,2315),(43731,2316),(43732,2316),(43733,2316),(43734,2316),(43735,2317),(43736,2317),(43737,2317),(43738,2317),(43739,2318),(43740,2318),(43741,2318),(43742,2318),(43743,2319),(43744,2319),(43745,2319),(43746,2319),(43747,2320),(43748,2320),(43749,2320),(43750,2320),(43751,2321),(43752,2321),(43753,2321),(43754,2321),(43755,2322),(43756,2323),(43757,2324),(43758,2325),(43759,2326),(43760,2327),(43761,2328),(43762,2329),(43763,2330),(43764,2331),(43765,2332),(43766,2333),(43767,2334),(43768,2335),(43769,2336),(43770,2337),(43771,2338),(43772,2339),(43773,2340),(43774,2341),(43775,2342),(43776,2343),(43777,2344),(43778,2345),(43779,2346),(43780,2347),(43781,2348),(43782,2349),(43783,2350),(43784,2351),(43785,2352),(43786,2353),(43787,2354),(43788,2355),(43789,2356),(43790,2357),(43791,2358),(43792,2359),(43793,2360),(43794,2361),(43795,2362),(43796,2363),(43797,2364),(43798,2365),(43799,2366),(43800,2367),(43801,2368),(43802,2369),(43803,2370),(43804,2371),(43805,2372),(43806,2373),(43807,2374),(43808,2375),(43809,2376),(43810,2377),(43811,2378),(43812,2379),(43813,2380),(43814,2381),(43815,2382),(43816,2383),(43817,2384),(43818,2385),(43819,2386),(43820,2387),(43821,2388),(43822,2389),(43823,2390),(43824,2391),(43825,2392),(43826,2393),(43827,2394),(43828,2395),(43829,2396),(43830,2397),(43831,2398),(43832,2399),(43833,2400),(43834,2401),(43835,2402),(43836,2403),(43837,2404),(43838,2405),(43839,2406),(43840,2407),(43841,2408),(43842,2409),(43843,2410),(43844,2322),(43845,2323),(43846,2324),(43847,2325),(43848,2326),(43849,2327),(43850,2328),(43851,2329),(43852,2330),(43853,2331),(43854,2332),(43855,2333),(43856,2334),(43857,2335),(43858,2336),(43859,2337),(43860,2338),(43861,2339),(43862,2340),(43863,2341),(43864,2342),(43865,2343),(43866,2344),(43867,2345),(43868,2346),(43869,2347),(43870,2348),(43871,2349),(43872,2350),(43873,2351),(43874,2352),(43875,2353),(43876,2354),(43877,2355),(43878,2356),(43879,2357),(43880,2358),(43881,2359),(43882,2360),(43883,2361),(43884,2362),(43885,2363),(43886,2364),(43887,2365),(43888,2366),(43889,2367),(43890,2368),(43891,2369),(43892,2370),(43893,2371),(43894,2372),(43895,2373),(43896,2374),(43897,2375),(43898,2376),(43899,2377),(43900,2378),(43901,2379),(43902,2380),(43903,2381),(43904,2382),(43905,2383),(43906,2384),(43907,2385),(43908,2386),(43909,2387),(43910,2388),(43911,2389),(43912,2390),(43913,2391),(43914,2392),(43915,2393),(43916,2394),(43917,2395),(43918,2396),(43919,2397),(43920,2398),(43921,2399),(43922,2400),(43923,2401),(43924,2402),(43925,2403),(43926,2404),(43927,2405),(43928,2406),(43929,2407),(43930,2408),(43931,2409),(43932,2410),(43933,2322),(43934,2322),(43935,2322),(43936,2322),(43937,2322),(43938,2322),(43939,2322),(43940,2323),(43941,2323),(43942,2323),(43943,2323),(43944,2323),(43945,2323),(43946,2323),(43947,2324),(43948,2324),(43949,2324),(43950,2324),(43951,2324),(43952,2324),(43953,2324),(43954,2325),(43955,2325),(43956,2325),(43957,2325),(43958,2325),(43959,2325),(43960,2325),(43961,2326),(43962,2326),(43963,2326),(43964,2326),(43965,2326),(43966,2326),(43967,2326),(43968,2327),(43969,2327),(43970,2327),(43971,2327),(43972,2327),(43973,2327),(43974,2327),(43975,2328),(43976,2328),(43977,2328),(43978,2328),(43979,2328),(43980,2328),(43981,2328),(43982,2329),(43983,2329),(43984,2329),(43985,2329),(43986,2329),(43987,2329),(43988,2329),(43989,2330),(43990,2330),(43991,2330),(43992,2330),(43993,2330),(43994,2330),(43995,2330),(43996,2331),(43997,2331),(43998,2331),(43999,2331),(44000,2331),(44001,2331),(44002,2331),(44003,2332),(44004,2332),(44005,2332),(44006,2332),(44007,2332),(44008,2332),(44009,2332),(44010,2333),(44011,2333),(44012,2333),(44013,2333),(44014,2333),(44015,2333),(44016,2333),(44017,2334),(44018,2334),(44019,2334),(44020,2334),(44021,2334),(44022,2334),(44023,2334),(44024,2335),(44025,2335),(44026,2335),(44027,2335),(44028,2335),(44029,2335),(44030,2335),(44031,2336),(44032,2336),(44033,2336),(44034,2336),(44035,2336),(44036,2336),(44037,2336),(44038,2337),(44039,2337),(44040,2337),(44041,2337),(44042,2337),(44043,2337),(44044,2337),(44045,2338),(44046,2338),(44047,2338),(44048,2338),(44049,2338),(44050,2338),(44051,2338),(44052,2339),(44053,2339),(44054,2339),(44055,2339),(44056,2339),(44057,2339),(44058,2339),(44059,2340),(44060,2340),(44061,2340),(44062,2340),(44063,2340),(44064,2340),(44065,2340),(44066,2341),(44067,2341),(44068,2341),(44069,2341),(44070,2341),(44071,2341),(44072,2341),(44073,2342),(44074,2342),(44075,2342),(44076,2342),(44077,2342),(44078,2342),(44079,2342),(44080,2343),(44081,2343),(44082,2343),(44083,2343),(44084,2343),(44085,2343),(44086,2343),(44087,2344),(44088,2344),(44089,2344),(44090,2344),(44091,2344),(44092,2344),(44093,2344),(44094,2345),(44095,2345),(44096,2345),(44097,2345),(44098,2345),(44099,2345),(44100,2345),(44101,2346),(44102,2346),(44103,2346),(44104,2346),(44105,2346),(44106,2346),(44107,2346),(44108,2347),(44109,2347),(44110,2347),(44111,2347),(44112,2347),(44113,2347),(44114,2347),(44115,2348),(44116,2348),(44117,2348),(44118,2348),(44119,2348),(44120,2348),(44121,2348),(44122,2349),(44123,2349),(44124,2349),(44125,2349),(44126,2349),(44127,2349),(44128,2349),(44129,2350),(44130,2350),(44131,2350),(44132,2350),(44133,2350),(44134,2350),(44135,2350),(44136,2351),(44137,2351),(44138,2351),(44139,2351),(44140,2351),(44141,2351),(44142,2351),(44143,2352),(44144,2352),(44145,2352),(44146,2352),(44147,2352),(44148,2352),(44149,2352),(44150,2353),(44151,2353),(44152,2353),(44153,2353),(44154,2353),(44155,2353),(44156,2353),(44157,2354),(44158,2354),(44159,2354),(44160,2354),(44161,2354),(44162,2354),(44163,2354),(44164,2355),(44165,2355),(44166,2355),(44167,2355),(44168,2355),(44169,2355),(44170,2355),(44171,2356),(44172,2356),(44173,2356),(44174,2356),(44175,2356),(44176,2356),(44177,2356),(44178,2357),(44179,2357),(44180,2357),(44181,2357),(44182,2357),(44183,2357),(44184,2357),(44185,2358),(44186,2358),(44187,2358),(44188,2358),(44189,2358),(44190,2358),(44191,2358),(44192,2359),(44193,2359),(44194,2359),(44195,2359),(44196,2359),(44197,2359),(44198,2359),(44199,2360),(44200,2360),(44201,2360),(44202,2360),(44203,2360),(44204,2360),(44205,2360),(44206,2361),(44207,2361),(44208,2361),(44209,2361),(44210,2361),(44211,2361),(44212,2361),(44213,2362),(44214,2362),(44215,2362),(44216,2362),(44217,2362),(44218,2362),(44219,2362),(44220,2363),(44221,2363),(44222,2363),(44223,2363),(44224,2363),(44225,2363),(44226,2363),(44227,2364),(44228,2364),(44229,2364),(44230,2364),(44231,2364),(44232,2364),(44233,2364),(44234,2365),(44235,2365),(44236,2365),(44237,2365),(44238,2365),(44239,2365),(44240,2365),(44241,2366),(44242,2366),(44243,2366),(44244,2366),(44245,2366),(44246,2366),(44247,2366),(44248,2367),(44249,2367),(44250,2367),(44251,2367),(44252,2367),(44253,2367),(44254,2367),(44255,2368),(44256,2368),(44257,2368),(44258,2368),(44259,2368),(44260,2368),(44261,2368),(44262,2369),(44263,2369),(44264,2369),(44265,2369),(44266,2369),(44267,2369),(44268,2369),(44269,2370),(44270,2370),(44271,2370),(44272,2370),(44273,2370),(44274,2370),(44275,2370),(44276,2371),(44277,2371),(44278,2371),(44279,2371),(44280,2371),(44281,2371),(44282,2371),(44283,2372),(44284,2372),(44285,2372),(44286,2372),(44287,2372),(44288,2372),(44289,2372),(44290,2373),(44291,2373),(44292,2373),(44293,2373),(44294,2373),(44295,2373),(44296,2373),(44297,2374),(44298,2374),(44299,2374),(44300,2374),(44301,2374),(44302,2374),(44303,2374),(44304,2375),(44305,2375),(44306,2375),(44307,2375),(44308,2375),(44309,2375),(44310,2376),(44311,2376),(44312,2376),(44313,2376),(44314,2376),(44315,2376),(44316,2377),(44317,2377),(44318,2377),(44319,2377),(44320,2377),(44321,2377),(44322,2377),(44323,2377),(44324,2377),(44325,2378),(44326,2378),(44327,2378),(44328,2378),(44329,2378),(44330,2378),(44331,2378),(44332,2378),(44333,2378),(44334,2379),(44335,2379),(44336,2379),(44337,2379),(44338,2379),(44339,2379),(44340,2380),(44341,2380),(44342,2380),(44343,2380),(44344,2380),(44345,2380),(44346,2381),(44347,2381),(44348,2381),(44349,2381),(44350,2381),(44351,2381),(44352,2382),(44353,2382),(44354,2382),(44355,2382),(44356,2382),(44357,2382),(44358,2382),(44359,2382),(44360,2382),(44361,2383),(44362,2383),(44363,2383),(44364,2383),(44365,2383),(44366,2383),(44367,2384),(44368,2384),(44369,2384),(44370,2384),(44371,2384),(44372,2384),(44373,2385),(44374,2385),(44375,2385),(44376,2385),(44377,2385),(44378,2385),(44379,2385),(44380,2385),(44381,2385),(44382,2386),(44383,2386),(44384,2386),(44385,2386),(44386,2386),(44387,2386),(44388,2386),(44389,2386),(44390,2386),(44391,2387),(44392,2387),(44393,2387),(44394,2387),(44395,2387),(44396,2387),(44397,2388),(44398,2388),(44399,2388),(44400,2388),(44401,2388),(44402,2388),(44403,2388),(44404,2388),(44405,2388),(44406,2389),(44407,2389),(44408,2389),(44409,2389),(44410,2389),(44411,2389),(44412,2389),(44413,2389),(44414,2389),(44415,2390),(44416,2390),(44417,2390),(44418,2390),(44419,2390),(44420,2390),(44421,2391),(44422,2391),(44423,2391),(44424,2391),(44425,2391),(44426,2391),(44427,2391),(44428,2391),(44429,2391),(44430,2392),(44431,2392),(44432,2392),(44433,2392),(44434,2392),(44435,2392),(44436,2392),(44437,2393),(44438,2393),(44439,2393),(44440,2393),(44441,2393),(44442,2393),(44443,2393),(44444,2394),(44445,2394),(44446,2394),(44447,2394),(44448,2394),(44449,2394),(44450,2394),(44451,2395),(44452,2395),(44453,2395),(44454,2395),(44455,2395),(44456,2395),(44457,2395),(44458,2396),(44459,2396),(44460,2396),(44461,2396),(44462,2396),(44463,2396),(44464,2396),(44465,2397),(44466,2397),(44467,2397),(44468,2397),(44469,2397),(44470,2397),(44471,2397),(44472,2398),(44473,2398),(44474,2398),(44475,2398),(44476,2398),(44477,2398),(44478,2398),(44479,2399),(44480,2399),(44481,2399),(44482,2399),(44483,2399),(44484,2399),(44485,2399),(44486,2400),(44487,2400),(44488,2400),(44489,2400),(44490,2400),(44491,2400),(44492,2400),(44493,2401),(44494,2401),(44495,2401),(44496,2401),(44497,2401),(44498,2401),(44499,2401),(44500,2402),(44501,2402),(44502,2402),(44503,2402),(44504,2402),(44505,2402),(44506,2402),(44507,2403),(44508,2403),(44509,2403),(44510,2403),(44511,2403),(44512,2403),(44513,2403),(44514,2404),(44515,2404),(44516,2404),(44517,2404),(44518,2404),(44519,2404),(44520,2404),(44521,2405),(44522,2405),(44523,2405),(44524,2405),(44525,2405),(44526,2405),(44527,2405),(44528,2406),(44529,2406),(44530,2406),(44531,2406),(44532,2406),(44533,2406),(44534,2406),(44535,2407),(44536,2407),(44537,2407),(44538,2407),(44539,2407),(44540,2407),(44541,2407),(44542,2408),(44543,2408),(44544,2408),(44545,2408),(44546,2408),(44547,2408),(44548,2408),(44549,2409),(44550,2409),(44551,2409),(44552,2409),(44553,2409),(44554,2409),(44555,2409),(44556,2410),(44557,2410),(44558,2410),(44559,2410),(44560,2410),(44561,2410),(44562,2410),(44563,2322),(44564,2322),(44565,2323),(44566,2323),(44567,2323),(44568,2324),(44569,2324),(44570,2324),(44571,2325),(44572,2325),(44573,2325),(44574,2326),(44575,2326),(44576,2326),(44577,2327),(44578,2327),(44579,2327),(44580,2328),(44581,2328),(44582,2328),(44583,2329),(44584,2329),(44585,2329),(44586,2330),(44587,2330),(44588,2330),(44589,2331),(44590,2331),(44591,2331),(44592,2332),(44593,2332),(44594,2332),(44595,2333),(44596,2333),(44597,2333),(44598,2334),(44599,2334),(44600,2334),(44601,2335),(44602,2335),(44603,2335),(44604,2336),(44605,2336),(44606,2336),(44607,2337),(44608,2337),(44609,2337),(44610,2338),(44611,2338),(44612,2338),(44613,2339),(44614,2339),(44615,2339),(44616,2340),(44617,2340),(44618,2340),(44619,2341),(44620,2341),(44621,2341),(44622,2342),(44623,2342),(44624,2342),(44625,2343),(44626,2343),(44627,2343),(44628,2344),(44629,2344),(44630,2344),(44631,2345),(44632,2345),(44633,2345),(44634,2346),(44635,2346),(44636,2346),(44637,2347),(44638,2347),(44639,2347),(44640,2348),(44641,2348),(44642,2348),(44643,2349),(44644,2349),(44645,2349),(44646,2350),(44647,2350),(44648,2350),(44649,2351),(44650,2351),(44651,2351),(44652,2352),(44653,2352),(44654,2352),(44655,2353),(44656,2353),(44657,2353),(44658,2354),(44659,2354),(44660,2354),(44661,2355),(44662,2355),(44663,2355),(44664,2356),(44665,2356),(44666,2356),(44667,2357),(44668,2357),(44669,2357),(44670,2358),(44671,2358),(44672,2358),(44673,2359),(44674,2359),(44675,2359),(44676,2360),(44677,2360),(44678,2360),(44679,2361),(44680,2361),(44681,2361),(44682,2362),(44683,2362),(44684,2362),(44685,2363),(44686,2363),(44687,2363),(44688,2364),(44689,2364),(44690,2364),(44691,2365),(44692,2365),(44693,2365),(44694,2366),(44695,2366),(44696,2366),(44697,2367),(44698,2367),(44699,2367),(44700,2368),(44701,2368),(44702,2368),(44703,2369),(44704,2369),(44705,2369),(44706,2370),(44707,2370),(44708,2370),(44709,2371),(44710,2371),(44711,2371),(44712,2372),(44713,2372),(44714,2372),(44715,2373),(44716,2373),(44717,2373),(44718,2374),(44719,2374),(44720,2374),(44721,2375),(44722,2375),(44723,2375),(44724,2376),(44725,2376),(44726,2376),(44727,2377),(44728,2377),(44729,2378),(44730,2378),(44731,2379),(44732,2379),(44733,2379),(44734,2380),(44735,2380),(44736,2380),(44737,2381),(44738,2381),(44739,2381),(44740,2382),(44741,2382),(44742,2382),(44743,2383),(44744,2383),(44745,2383),(44746,2384),(44747,2384),(44748,2384),(44749,2385),(44750,2385),(44751,2386),(44752,2386),(44753,2387),(44754,2387),(44755,2387),(44756,2388),(44757,2388),(44758,2389),(44759,2389),(44760,2390),(44761,2390),(44762,2390),(44763,2391),(44764,2391),(44765,2392),(44766,2392),(44767,2392),(44768,2393),(44769,2393),(44770,2393),(44771,2394),(44772,2394),(44773,2394),(44774,2395),(44775,2395),(44776,2395),(44777,2396),(44778,2396),(44779,2396),(44780,2397),(44781,2397),(44782,2398),(44783,2398),(44784,2399),(44785,2399),(44786,2400),(44787,2400),(44788,2401),(44789,2401),(44790,2402),(44791,2402),(44792,2403),(44793,2403),(44794,2404),(44795,2404),(44796,2405),(44797,2405),(44798,2406),(44799,2406),(44800,2407),(44801,2407),(44802,2408),(44803,2408),(44804,2409),(44805,2409),(44806,2410),(44807,2410),(44808,2322),(44809,2322),(44810,2322),(44811,2323),(44812,2323),(44813,2323),(44814,2324),(44815,2324),(44816,2324),(44817,2325),(44818,2325),(44819,2325),(44820,2326),(44821,2326),(44822,2326),(44823,2327),(44824,2327),(44825,2327),(44826,2328),(44827,2328),(44828,2328),(44829,2329),(44830,2329),(44831,2329),(44832,2330),(44833,2330),(44834,2330),(44835,2331),(44836,2331),(44837,2331),(44838,2332),(44839,2332),(44840,2332),(44841,2333),(44842,2333),(44843,2333),(44844,2334),(44845,2334),(44846,2334),(44847,2335),(44848,2335),(44849,2335),(44850,2336),(44851,2336),(44852,2336),(44853,2337),(44854,2337),(44855,2337),(44856,2338),(44857,2338),(44858,2338),(44859,2339),(44860,2339),(44861,2339),(44862,2340),(44863,2340),(44864,2340),(44865,2341),(44866,2341),(44867,2341),(44868,2342),(44869,2342),(44870,2342),(44871,2343),(44872,2343),(44873,2343),(44874,2344),(44875,2344),(44876,2344),(44877,2345),(44878,2345),(44879,2345),(44880,2346),(44881,2346),(44882,2346),(44883,2347),(44884,2347),(44885,2347),(44886,2348),(44887,2348),(44888,2348),(44889,2349),(44890,2349),(44891,2349),(44892,2350),(44893,2350),(44894,2350),(44895,2351),(44896,2351),(44897,2351),(44898,2352),(44899,2352),(44900,2352),(44901,2353),(44902,2353),(44903,2353),(44904,2354),(44905,2354),(44906,2354),(44907,2355),(44908,2355),(44909,2355),(44910,2356),(44911,2356),(44912,2356),(44913,2357),(44914,2357),(44915,2357),(44916,2358),(44917,2358),(44918,2358),(44919,2359),(44920,2359),(44921,2359),(44922,2360),(44923,2360),(44924,2360),(44925,2361),(44926,2361),(44927,2361),(44928,2362),(44929,2362),(44930,2362),(44931,2363),(44932,2363),(44933,2363),(44934,2364),(44935,2364),(44936,2364),(44937,2365),(44938,2365),(44939,2365),(44940,2366),(44941,2366),(44942,2366),(44943,2367),(44944,2367),(44945,2367),(44946,2368),(44947,2368),(44948,2368),(44949,2369),(44950,2369),(44951,2369),(44952,2370),(44953,2370),(44954,2370),(44955,2371),(44956,2371),(44957,2371),(44958,2372),(44959,2372),(44960,2372),(44961,2373),(44962,2373),(44963,2373),(44964,2374),(44965,2374),(44966,2374),(44967,2375),(44968,2375),(44969,2375),(44970,2376),(44971,2376),(44972,2376),(44973,2377),(44974,2377),(44975,2377),(44976,2378),(44977,2378),(44978,2378),(44979,2379),(44980,2379),(44981,2379),(44982,2380),(44983,2380),(44984,2380),(44985,2381),(44986,2381),(44987,2381),(44988,2382),(44989,2382),(44990,2382),(44991,2383),(44992,2383),(44993,2383),(44994,2384),(44995,2384),(44996,2384),(44997,2385),(44998,2385),(44999,2385),(45000,2386),(45001,2386),(45002,2386),(45003,2387),(45004,2387),(45005,2387),(45006,2388),(45007,2388),(45008,2388),(45009,2389),(45010,2389),(45011,2389),(45012,2390),(45013,2390),(45014,2390),(45015,2391),(45016,2391),(45017,2391),(45018,2392),(45019,2392),(45020,2392),(45021,2393),(45022,2393),(45023,2393),(45024,2394),(45025,2394),(45026,2394),(45027,2395),(45028,2395),(45029,2395),(45030,2396),(45031,2396),(45032,2396),(45033,2397),(45034,2397),(45035,2397),(45036,2398),(45037,2398),(45038,2398),(45039,2399),(45040,2399),(45041,2399),(45042,2400),(45043,2400),(45044,2400),(45045,2401),(45046,2401),(45047,2401),(45048,2402),(45049,2402),(45050,2402),(45051,2403),(45052,2403),(45053,2403),(45054,2404),(45055,2404),(45056,2404),(45057,2405),(45058,2405),(45059,2405),(45060,2406),(45061,2406),(45062,2406),(45063,2407),(45064,2407),(45065,2407),(45066,2408),(45067,2408),(45068,2408),(45069,2409),(45070,2409),(45071,2409),(45072,2410),(45073,2410),(45074,2410),(45075,2322),(45076,2322),(45077,2322),(45078,2322),(45079,2323),(45080,2323),(45081,2323),(45082,2323),(45083,2324),(45084,2324),(45085,2324),(45086,2324),(45087,2325),(45088,2325),(45089,2325),(45090,2325),(45091,2326),(45092,2326),(45093,2326),(45094,2326),(45095,2327),(45096,2327),(45097,2327),(45098,2327),(45099,2328),(45100,2328),(45101,2328),(45102,2328),(45103,2329),(45104,2329),(45105,2329),(45106,2329),(45107,2330),(45108,2330),(45109,2330),(45110,2330),(45111,2331),(45112,2331),(45113,2331),(45114,2331),(45115,2332),(45116,2332),(45117,2332),(45118,2332),(45119,2333),(45120,2333),(45121,2333),(45122,2333),(45123,2334),(45124,2334),(45125,2334),(45126,2334),(45127,2335),(45128,2335),(45129,2335),(45130,2335),(45131,2336),(45132,2336),(45133,2336),(45134,2336),(45135,2337),(45136,2337),(45137,2337),(45138,2337),(45139,2338),(45140,2338),(45141,2338),(45142,2338),(45143,2339),(45144,2339),(45145,2339),(45146,2339),(45147,2340),(45148,2340),(45149,2340),(45150,2340),(45151,2341),(45152,2341),(45153,2341),(45154,2341),(45155,2342),(45156,2342),(45157,2342),(45158,2342),(45159,2343),(45160,2343),(45161,2343),(45162,2343),(45163,2344),(45164,2344),(45165,2344),(45166,2344),(45167,2345),(45168,2345),(45169,2345),(45170,2345),(45171,2346),(45172,2346),(45173,2346),(45174,2346),(45175,2347),(45176,2347),(45177,2347),(45178,2347),(45179,2348),(45180,2348),(45181,2348),(45182,2348),(45183,2349),(45184,2349),(45185,2349),(45186,2349),(45187,2350),(45188,2350),(45189,2350),(45190,2350),(45191,2351),(45192,2351),(45193,2351),(45194,2351),(45195,2352),(45196,2352),(45197,2352),(45198,2352),(45199,2353),(45200,2353),(45201,2353),(45202,2353),(45203,2354),(45204,2354),(45205,2354),(45206,2354),(45207,2355),(45208,2355),(45209,2355),(45210,2355),(45211,2356),(45212,2356),(45213,2356),(45214,2356),(45215,2357),(45216,2357),(45217,2357),(45218,2357),(45219,2358),(45220,2358),(45221,2358),(45222,2358),(45223,2359),(45224,2359),(45225,2359),(45226,2359),(45227,2360),(45228,2360),(45229,2360),(45230,2360),(45231,2361),(45232,2361),(45233,2361),(45234,2361),(45235,2362),(45236,2362),(45237,2362),(45238,2362),(45239,2363),(45240,2363),(45241,2363),(45242,2363),(45243,2364),(45244,2364),(45245,2364),(45246,2364),(45247,2365),(45248,2365),(45249,2365),(45250,2365),(45251,2366),(45252,2366),(45253,2366),(45254,2366),(45255,2367),(45256,2367),(45257,2367),(45258,2367),(45259,2368),(45260,2368),(45261,2368),(45262,2368),(45263,2369),(45264,2369),(45265,2369),(45266,2369),(45267,2370),(45268,2370),(45269,2370),(45270,2370),(45271,2371),(45272,2371),(45273,2371),(45274,2371),(45275,2372),(45276,2372),(45277,2372),(45278,2372),(45279,2373),(45280,2373),(45281,2373),(45282,2373),(45283,2374),(45284,2374),(45285,2374),(45286,2374),(45287,2375),(45288,2375),(45289,2375),(45290,2375),(45291,2376),(45292,2376),(45293,2376),(45294,2376),(45295,2377),(45296,2377),(45297,2377),(45298,2377),(45299,2378),(45300,2378),(45301,2378),(45302,2378),(45303,2379),(45304,2379),(45305,2379),(45306,2379),(45307,2380),(45308,2380),(45309,2380),(45310,2380),(45311,2381),(45312,2381),(45313,2381),(45314,2381),(45315,2382),(45316,2382),(45317,2382),(45318,2382),(45319,2383),(45320,2383),(45321,2383),(45322,2383),(45323,2384),(45324,2384),(45325,2384),(45326,2384),(45327,2385),(45328,2385),(45329,2385),(45330,2385),(45331,2386),(45332,2386),(45333,2386),(45334,2386),(45335,2387),(45336,2387),(45337,2387),(45338,2387),(45339,2388),(45340,2388),(45341,2388),(45342,2388),(45343,2389),(45344,2389),(45345,2389),(45346,2389),(45347,2390),(45348,2390),(45349,2390),(45350,2390),(45351,2391),(45352,2391),(45353,2391),(45354,2391),(45355,2392),(45356,2392),(45357,2392),(45358,2392),(45359,2393),(45360,2393),(45361,2393),(45362,2393),(45363,2394),(45364,2394),(45365,2394),(45366,2394),(45367,2395),(45368,2395),(45369,2395),(45370,2395),(45371,2396),(45372,2396),(45373,2396),(45374,2396),(45375,2397),(45376,2397),(45377,2397),(45378,2397),(45379,2398),(45380,2398),(45381,2398),(45382,2398),(45383,2399),(45384,2399),(45385,2399),(45386,2399),(45387,2400),(45388,2400),(45389,2400),(45390,2400),(45391,2401),(45392,2401),(45393,2401),(45394,2401),(45395,2402),(45396,2402),(45397,2402),(45398,2402),(45399,2403),(45400,2403),(45401,2403),(45402,2403),(45403,2404),(45404,2404),(45405,2404),(45406,2404),(45407,2405),(45408,2405),(45409,2405),(45410,2405),(45411,2406),(45412,2406),(45413,2406),(45414,2406),(45415,2407),(45416,2407),(45417,2407),(45418,2407),(45419,2408),(45420,2408),(45421,2408),(45422,2408),(45423,2409),(45424,2409),(45425,2409),(45426,2409),(45427,2410),(45428,2410),(45429,2410),(45430,2410),(45431,2411),(45432,2412),(45433,2413),(45434,2414),(45435,2415),(45436,2416),(45437,2417),(45438,2418),(45439,2419),(45440,2420),(45441,2421),(45442,2422),(45443,2423),(45444,2424),(45445,2425),(45446,2426),(45447,2427),(45448,2428),(45449,2429),(45450,2430),(45451,2431),(45452,2432),(45453,2433),(45454,2434),(45455,2435),(45456,2436),(45457,2437),(45458,2438),(45459,2439),(45460,2440),(45461,2441),(45462,2442),(45463,2443),(45464,2444),(45465,2445),(45466,2446),(45467,2447),(45468,2448),(45469,2449),(45470,2450),(45471,2451),(45472,2452),(45473,2453),(45474,2454),(45475,2455),(45476,2456),(45477,2457),(45478,2458),(45479,2459),(45480,2460),(45481,2461),(45482,2462),(45483,2463),(45484,2464),(45485,2465),(45486,2466),(45487,2467),(45488,2468),(45489,2469),(45490,2470),(45491,2471),(45492,2472),(45493,2473),(45494,2474),(45495,2475),(45496,2476),(45497,2477),(45498,2478),(45499,2479),(45500,2480),(45501,2481),(45502,2482),(45503,2483),(45504,2484),(45505,2485),(45506,2486),(45507,2487),(45508,2488),(45509,2489),(45510,2490),(45511,2491),(45512,2492),(45513,2493),(45514,2494),(45515,2495),(45516,2496),(45517,2497),(45518,2498),(45519,2499),(45520,2500),(45521,2501),(45522,2502),(45523,2503),(45524,2504),(45525,2505),(45526,2506),(45527,2507),(45528,2508),(45529,2509),(45530,2510),(45531,2411),(45532,2412),(45533,2413),(45534,2414),(45535,2415),(45536,2416),(45537,2417),(45538,2418),(45539,2419),(45540,2420),(45541,2421),(45542,2422),(45543,2423),(45544,2424),(45545,2425),(45546,2426),(45547,2427),(45548,2428),(45549,2429),(45550,2430),(45551,2431),(45552,2432),(45553,2433),(45554,2434),(45555,2435),(45556,2436),(45557,2437),(45558,2438),(45559,2439),(45560,2440),(45561,2441),(45562,2442),(45563,2443),(45564,2444),(45565,2445),(45566,2446),(45567,2447),(45568,2448),(45569,2449),(45570,2450),(45571,2451),(45572,2452),(45573,2453),(45574,2454),(45575,2455),(45576,2456),(45577,2457),(45578,2458),(45579,2459),(45580,2460),(45581,2461),(45582,2462),(45583,2463),(45584,2464),(45585,2465),(45586,2466),(45587,2467),(45588,2468),(45589,2469),(45590,2470),(45591,2471),(45592,2472),(45593,2473),(45594,2474),(45595,2475),(45596,2476),(45597,2477),(45598,2478),(45599,2479),(45600,2480),(45601,2481),(45602,2482),(45603,2483),(45604,2484),(45605,2485),(45606,2486),(45607,2487),(45608,2488),(45609,2489),(45610,2490),(45611,2491),(45612,2492),(45613,2493),(45614,2494),(45615,2495),(45616,2496),(45617,2497),(45618,2498),(45619,2499),(45620,2500),(45621,2501),(45622,2502),(45623,2503),(45624,2504),(45625,2505),(45626,2506),(45627,2507),(45628,2508),(45629,2509),(45630,2510),(45631,2411),(45632,2411),(45633,2411),(45634,2411),(45635,2411),(45636,2411),(45637,2411),(45638,2412),(45639,2412),(45640,2412),(45641,2412),(45642,2412),(45643,2412),(45644,2412),(45645,2413),(45646,2413),(45647,2413),(45648,2413),(45649,2413),(45650,2413),(45651,2413),(45652,2414),(45653,2414),(45654,2414),(45655,2414),(45656,2414),(45657,2414),(45658,2414),(45659,2415),(45660,2415),(45661,2415),(45662,2415),(45663,2415),(45664,2415),(45665,2415),(45666,2416),(45667,2416),(45668,2416),(45669,2416),(45670,2416),(45671,2416),(45672,2416),(45673,2417),(45674,2417),(45675,2417),(45676,2417),(45677,2417),(45678,2417),(45679,2417),(45680,2418),(45681,2418),(45682,2418),(45683,2418),(45684,2418),(45685,2418),(45686,2418),(45687,2419),(45688,2419),(45689,2419),(45690,2419),(45691,2419),(45692,2419),(45693,2419),(45694,2420),(45695,2420),(45696,2420),(45697,2420),(45698,2420),(45699,2420),(45700,2420),(45701,2421),(45702,2421),(45703,2421),(45704,2421),(45705,2421),(45706,2421),(45707,2421),(45708,2422),(45709,2422),(45710,2422),(45711,2422),(45712,2422),(45713,2422),(45714,2422),(45715,2423),(45716,2423),(45717,2423),(45718,2423),(45719,2423),(45720,2423),(45721,2423),(45722,2424),(45723,2424),(45724,2424),(45725,2424),(45726,2424),(45727,2424),(45728,2424),(45729,2425),(45730,2425),(45731,2425),(45732,2425),(45733,2425),(45734,2425),(45735,2425),(45736,2426),(45737,2426),(45738,2426),(45739,2426),(45740,2426),(45741,2426),(45742,2426),(45743,2427),(45744,2427),(45745,2427),(45746,2427),(45747,2427),(45748,2427),(45749,2427),(45750,2428),(45751,2428),(45752,2428),(45753,2428),(45754,2428),(45755,2428),(45756,2428),(45757,2429),(45758,2429),(45759,2429),(45760,2429),(45761,2429),(45762,2429),(45763,2429),(45764,2430),(45765,2430),(45766,2430),(45767,2430),(45768,2430),(45769,2430),(45770,2430),(45771,2431),(45772,2431),(45773,2431),(45774,2431),(45775,2431),(45776,2431),(45777,2431),(45778,2432),(45779,2432),(45780,2432),(45781,2432),(45782,2432),(45783,2432),(45784,2432),(45785,2433),(45786,2433),(45787,2433),(45788,2433),(45789,2433),(45790,2433),(45791,2433),(45792,2434),(45793,2434),(45794,2434),(45795,2434),(45796,2434),(45797,2434),(45798,2434),(45799,2435),(45800,2435),(45801,2435),(45802,2435),(45803,2435),(45804,2435),(45805,2435),(45806,2435),(45807,2436),(45808,2436),(45809,2436),(45810,2436),(45811,2436),(45812,2436),(45813,2436),(45814,2437),(45815,2437),(45816,2437),(45817,2437),(45818,2437),(45819,2437),(45820,2437),(45821,2438),(45822,2438),(45823,2438),(45824,2438),(45825,2438),(45826,2438),(45827,2438),(45828,2439),(45829,2439),(45830,2439),(45831,2439),(45832,2439),(45833,2439),(45834,2439),(45835,2440),(45836,2440),(45837,2440),(45838,2440),(45839,2440),(45840,2440),(45841,2440),(45842,2440),(45843,2440),(45844,2441),(45845,2441),(45846,2441),(45847,2441),(45848,2441),(45849,2441),(45850,2441),(45851,2441),(45852,2441),(45853,2442),(45854,2442),(45855,2442),(45856,2442),(45857,2442),(45858,2442),(45859,2442),(45860,2442),(45861,2442),(45862,2443),(45863,2443),(45864,2443),(45865,2443),(45866,2443),(45867,2443),(45868,2443),(45869,2444),(45870,2444),(45871,2444),(45872,2444),(45873,2444),(45874,2444),(45875,2444),(45876,2445),(45877,2445),(45878,2445),(45879,2445),(45880,2445),(45881,2445),(45882,2445),(45883,2446),(45884,2446),(45885,2446),(45886,2446),(45887,2446),(45888,2446),(45889,2446),(45890,2447),(45891,2447),(45892,2447),(45893,2447),(45894,2447),(45895,2447),(45896,2447),(45897,2448),(45898,2448),(45899,2448),(45900,2448),(45901,2448),(45902,2448),(45903,2448),(45904,2449),(45905,2449),(45906,2449),(45907,2449),(45908,2449),(45909,2449),(45910,2450),(45911,2450),(45912,2450),(45913,2450),(45914,2450),(45915,2450),(45916,2450),(45917,2451),(45918,2451),(45919,2451),(45920,2451),(45921,2451),(45922,2451),(45923,2451),(45924,2452),(45925,2452),(45926,2452),(45927,2452),(45928,2453),(45929,2453),(45930,2453),(45931,2453),(45932,2453),(45933,2453),(45934,2453),(45935,2454),(45936,2454),(45937,2454),(45938,2454),(45939,2454),(45940,2454),(45941,2454),(45942,2454),(45943,2454),(45944,2455),(45945,2455),(45946,2455),(45947,2455),(45948,2455),(45949,2455),(45950,2455),(45951,2455),(45952,2455),(45953,2456),(45954,2456),(45955,2456),(45956,2456),(45957,2456),(45958,2456),(45959,2456),(45960,2456),(45961,2456),(45962,2457),(45963,2457),(45964,2457),(45965,2457),(45966,2457),(45967,2457),(45968,2457),(45969,2457),(45970,2458),(45971,2458),(45972,2458),(45973,2458),(45974,2458),(45975,2458),(45976,2458),(45977,2459),(45978,2459),(45979,2459),(45980,2459),(45981,2459),(45982,2459),(45983,2459),(45984,2460),(45985,2460),(45986,2460),(45987,2460),(45988,2460),(45989,2460),(45990,2460),(45991,2461),(45992,2461),(45993,2461),(45994,2461),(45995,2461),(45996,2461),(45997,2461),(45998,2462),(45999,2462),(46000,2462),(46001,2462),(46002,2462),(46003,2462),(46004,2462),(46005,2463),(46006,2463),(46007,2463),(46008,2463),(46009,2463),(46010,2463),(46011,2463),(46012,2464),(46013,2464),(46014,2464),(46015,2464),(46016,2464),(46017,2464),(46018,2464),(46019,2465),(46020,2465),(46021,2465),(46022,2465),(46023,2465),(46024,2465),(46025,2465),(46026,2466),(46027,2466),(46028,2466),(46029,2466),(46030,2466),(46031,2466),(46032,2466),(46033,2467),(46034,2467),(46035,2467),(46036,2467),(46037,2467),(46038,2467),(46039,2467),(46040,2468),(46041,2468),(46042,2468),(46043,2468),(46044,2468),(46045,2468),(46046,2468),(46047,2469),(46048,2469),(46049,2469),(46050,2469),(46051,2469),(46052,2469),(46053,2469),(46054,2470),(46055,2470),(46056,2470),(46057,2470),(46058,2470),(46059,2470),(46060,2470),(46061,2471),(46062,2471),(46063,2471),(46064,2471),(46065,2471),(46066,2471),(46067,2471),(46068,2472),(46069,2472),(46070,2472),(46071,2472),(46072,2472),(46073,2472),(46074,2472),(46075,2472),(46076,2473),(46077,2473),(46078,2473),(46079,2473),(46080,2473),(46081,2473),(46082,2473),(46083,2473),(46084,2474),(46085,2474),(46086,2474),(46087,2474),(46088,2474),(46089,2474),(46090,2474),(46091,2475),(46092,2475),(46093,2475),(46094,2475),(46095,2475),(46096,2475),(46097,2475),(46098,2475),(46099,2475),(46100,2476),(46101,2476),(46102,2476),(46103,2476),(46104,2476),(46105,2476),(46106,2476),(46107,2476),(46108,2476),(46109,2477),(46110,2477),(46111,2477),(46112,2477),(46113,2477),(46114,2477),(46115,2477),(46116,2478),(46117,2478),(46118,2478),(46119,2478),(46120,2478),(46121,2478),(46122,2478),(46123,2479),(46124,2479),(46125,2479),(46126,2479),(46127,2479),(46128,2479),(46129,2479),(46130,2480),(46131,2480),(46132,2480),(46133,2480),(46134,2480),(46135,2480),(46136,2480),(46137,2481),(46138,2481),(46139,2481),(46140,2481),(46141,2481),(46142,2481),(46143,2481),(46144,2482),(46145,2482),(46146,2482),(46147,2482),(46148,2482),(46149,2482),(46150,2482),(46151,2483),(46152,2483),(46153,2483),(46154,2483),(46155,2483),(46156,2483),(46157,2483),(46158,2483),(46159,2483),(46160,2484),(46161,2484),(46162,2484),(46163,2484),(46164,2484),(46165,2484),(46166,2484),(46167,2485),(46168,2485),(46169,2485),(46170,2485),(46171,2485),(46172,2485),(46173,2485),(46174,2486),(46175,2486),(46176,2486),(46177,2486),(46178,2486),(46179,2486),(46180,2486),(46181,2487),(46182,2487),(46183,2487),(46184,2487),(46185,2487),(46186,2487),(46187,2487),(46188,2487),(46189,2487),(46190,2488),(46191,2488),(46192,2488),(46193,2488),(46194,2488),(46195,2488),(46196,2488),(46197,2489),(46198,2489),(46199,2489),(46200,2489),(46201,2489),(46202,2489),(46203,2489),(46204,2489),(46205,2490),(46206,2490),(46207,2490),(46208,2490),(46209,2490),(46210,2490),(46211,2490),(46212,2490),(46213,2491),(46214,2491),(46215,2491),(46216,2491),(46217,2491),(46218,2491),(46219,2491),(46220,2491),(46221,2492),(46222,2492),(46223,2492),(46224,2492),(46225,2492),(46226,2492),(46227,2493),(46228,2493),(46229,2493),(46230,2493),(46231,2493),(46232,2493),(46233,2494),(46234,2494),(46235,2494),(46236,2494),(46237,2494),(46238,2494),(46239,2495),(46240,2495),(46241,2495),(46242,2495),(46243,2495),(46244,2495),(46245,2496),(46246,2496),(46247,2496),(46248,2496),(46249,2496),(46250,2496),(46251,2497),(46252,2497),(46253,2497),(46254,2497),(46255,2497),(46256,2497),(46257,2498),(46258,2498),(46259,2498),(46260,2498),(46261,2498),(46262,2498),(46263,2498),(46264,2498),(46265,2498),(46266,2499),(46267,2499),(46268,2499),(46269,2499),(46270,2499),(46271,2499),(46272,2499),(46273,2499),(46274,2499),(46275,2500),(46276,2500),(46277,2500),(46278,2500),(46279,2500),(46280,2500),(46281,2500),(46282,2500),(46283,2500),(46284,2501),(46285,2501),(46286,2501),(46287,2501),(46288,2501),(46289,2501),(46290,2501),(46291,2502),(46292,2502),(46293,2502),(46294,2502),(46295,2502),(46296,2502),(46297,2502),(46298,2503),(46299,2503),(46300,2503),(46301,2503),(46302,2503),(46303,2503),(46304,2503),(46305,2504),(46306,2504),(46307,2504),(46308,2504),(46309,2504),(46310,2504),(46311,2504),(46312,2505),(46313,2505),(46314,2505),(46315,2505),(46316,2505),(46317,2505),(46318,2505),(46319,2506),(46320,2506),(46321,2506),(46322,2506),(46323,2506),(46324,2506),(46325,2506),(46326,2506),(46327,2506),(46328,2507),(46329,2507),(46330,2507),(46331,2507),(46332,2507),(46333,2507),(46334,2507),(46335,2507),(46336,2507),(46337,2508),(46338,2508),(46339,2508),(46340,2508),(46341,2508),(46342,2508),(46343,2508),(46344,2508),(46345,2508),(46346,2509),(46347,2509),(46348,2509),(46349,2509),(46350,2509),(46351,2509),(46352,2509),(46353,2509),(46354,2509),(46355,2510),(46356,2510),(46357,2510),(46358,2510),(46359,2510),(46360,2510),(46361,2510),(46362,2411),(46363,2411),(46364,2411),(46365,2412),(46366,2412),(46367,2412),(46368,2413),(46369,2413),(46370,2413),(46371,2414),(46372,2414),(46373,2414),(46374,2415),(46375,2415),(46376,2415),(46377,2416),(46378,2416),(46379,2416),(46380,2417),(46381,2417),(46382,2417),(46383,2418),(46384,2418),(46385,2418),(46386,2419),(46387,2419),(46388,2419),(46389,2420),(46390,2420),(46391,2420),(46392,2421),(46393,2421),(46394,2421),(46395,2422),(46396,2422),(46397,2422),(46398,2423),(46399,2423),(46400,2423),(46401,2424),(46402,2424),(46403,2424),(46404,2425),(46405,2425),(46406,2425),(46407,2426),(46408,2426),(46409,2426),(46410,2427),(46411,2427),(46412,2427),(46413,2428),(46414,2428),(46415,2428),(46416,2429),(46417,2429),(46418,2429),(46419,2430),(46420,2430),(46421,2430),(46422,2431),(46423,2431),(46424,2431),(46425,2432),(46426,2432),(46427,2432),(46428,2433),(46429,2433),(46430,2433),(46431,2434),(46432,2434),(46433,2434),(46434,2435),(46435,2435),(46436,2436),(46437,2436),(46438,2436),(46439,2437),(46440,2437),(46441,2437),(46442,2438),(46443,2438),(46444,2438),(46445,2439),(46446,2439),(46447,2439),(46448,2440),(46449,2440),(46450,2441),(46451,2441),(46452,2442),(46453,2442),(46454,2443),(46455,2443),(46456,2443),(46457,2444),(46458,2444),(46459,2444),(46460,2445),(46461,2445),(46462,2445),(46463,2446),(46464,2446),(46465,2446),(46466,2447),(46467,2447),(46468,2447),(46469,2448),(46470,2448),(46471,2448),(46472,2449),(46473,2449),(46474,2450),(46475,2450),(46476,2450),(46477,2451),(46478,2451),(46479,2451),(46480,2452),(46481,2452),(46482,2453),(46483,2453),(46484,2453),(46485,2454),(46486,2454),(46487,2455),(46488,2455),(46489,2456),(46490,2456),(46491,2457),(46492,2457),(46493,2458),(46494,2458),(46495,2458),(46496,2459),(46497,2459),(46498,2459),(46499,2460),(46500,2460),(46501,2460),(46502,2461),(46503,2461),(46504,2461),(46505,2462),(46506,2462),(46507,2462),(46508,2463),(46509,2463),(46510,2463),(46511,2464),(46512,2464),(46513,2464),(46514,2465),(46515,2465),(46516,2465),(46517,2466),(46518,2466),(46519,2466),(46520,2467),(46521,2467),(46522,2467),(46523,2468),(46524,2468),(46525,2468),(46526,2469),(46527,2469),(46528,2469),(46529,2470),(46530,2470),(46531,2470),(46532,2471),(46533,2471),(46534,2471),(46535,2472),(46536,2472),(46537,2473),(46538,2473),(46539,2474),(46540,2474),(46541,2474),(46542,2475),(46543,2475),(46544,2476),(46545,2476),(46546,2477),(46547,2477),(46548,2478),(46549,2478),(46550,2479),(46551,2479),(46552,2480),(46553,2480),(46554,2481),(46555,2481),(46556,2481),(46557,2482),(46558,2482),(46559,2482),(46560,2483),(46561,2483),(46562,2483),(46563,2484),(46564,2484),(46565,2484),(46566,2485),(46567,2485),(46568,2485),(46569,2486),(46570,2486),(46571,2486),(46572,2487),(46573,2487),(46574,2487),(46575,2488),(46576,2488),(46577,2488),(46578,2489),(46579,2489),(46580,2490),(46581,2490),(46582,2491),(46583,2491),(46584,2492),(46585,2492),(46586,2492),(46587,2493),(46588,2493),(46589,2493),(46590,2494),(46591,2494),(46592,2494),(46593,2495),(46594,2495),(46595,2495),(46596,2496),(46597,2496),(46598,2496),(46599,2497),(46600,2497),(46601,2497),(46602,2498),(46603,2498),(46604,2498),(46605,2499),(46606,2499),(46607,2499),(46608,2500),(46609,2500),(46610,2500),(46611,2501),(46612,2501),(46613,2501),(46614,2502),(46615,2502),(46616,2502),(46617,2503),(46618,2503),(46619,2503),(46620,2504),(46621,2504),(46622,2504),(46623,2505),(46624,2505),(46625,2505),(46626,2506),(46627,2506),(46628,2507),(46629,2507),(46630,2508),(46631,2508),(46632,2509),(46633,2509),(46634,2510),(46635,2510),(46636,2510),(46637,2411),(46638,2411),(46639,2411),(46640,2412),(46641,2412),(46642,2412),(46643,2413),(46644,2413),(46645,2413),(46646,2414),(46647,2414),(46648,2414),(46649,2415),(46650,2415),(46651,2415),(46652,2416),(46653,2416),(46654,2416),(46655,2417),(46656,2417),(46657,2417),(46658,2418),(46659,2418),(46660,2418),(46661,2419),(46662,2419),(46663,2419),(46664,2420),(46665,2420),(46666,2420),(46667,2421),(46668,2421),(46669,2421),(46670,2422),(46671,2422),(46672,2422),(46673,2423),(46674,2423),(46675,2423),(46676,2424),(46677,2424),(46678,2424),(46679,2425),(46680,2425),(46681,2425),(46682,2426),(46683,2426),(46684,2426),(46685,2426),(46686,2427),(46687,2427),(46688,2427),(46689,2428),(46690,2428),(46691,2428),(46692,2429),(46693,2429),(46694,2429),(46695,2430),(46696,2430),(46697,2430),(46698,2431),(46699,2431),(46700,2431),(46701,2432),(46702,2432),(46703,2432),(46704,2433),(46705,2433),(46706,2433),(46707,2434),(46708,2434),(46709,2434),(46710,2435),(46711,2435),(46712,2435),(46713,2436),(46714,2436),(46715,2436),(46716,2437),(46717,2437),(46718,2437),(46719,2438),(46720,2438),(46721,2438),(46722,2439),(46723,2439),(46724,2439),(46725,2440),(46726,2440),(46727,2440),(46728,2441),(46729,2441),(46730,2441),(46731,2442),(46732,2442),(46733,2442),(46734,2443),(46735,2443),(46736,2443),(46737,2444),(46738,2444),(46739,2444),(46740,2445),(46741,2445),(46742,2445),(46743,2446),(46744,2446),(46745,2446),(46746,2447),(46747,2447),(46748,2447),(46749,2448),(46750,2448),(46751,2448),(46752,2449),(46753,2450),(46754,2450),(46755,2450),(46756,2451),(46757,2451),(46758,2451),(46759,2452),(46760,2452),(46761,2452),(46762,2453),(46763,2453),(46764,2453),(46765,2454),(46766,2454),(46767,2454),(46768,2455),(46769,2455),(46770,2455),(46771,2456),(46772,2456),(46773,2456),(46774,2457),(46775,2457),(46776,2457),(46777,2458),(46778,2458),(46779,2458),(46780,2459),(46781,2459),(46782,2459),(46783,2460),(46784,2460),(46785,2460),(46786,2461),(46787,2461),(46788,2461),(46789,2462),(46790,2462),(46791,2462),(46792,2463),(46793,2463),(46794,2463),(46795,2464),(46796,2464),(46797,2464),(46798,2465),(46799,2465),(46800,2465),(46801,2466),(46802,2466),(46803,2466),(46804,2467),(46805,2467),(46806,2467),(46807,2468),(46808,2468),(46809,2468),(46810,2469),(46811,2469),(46812,2469),(46813,2470),(46814,2470),(46815,2470),(46816,2471),(46817,2471),(46818,2471),(46819,2472),(46820,2472),(46821,2472),(46822,2473),(46823,2473),(46824,2473),(46825,2474),(46826,2474),(46827,2474),(46828,2475),(46829,2475),(46830,2475),(46831,2476),(46832,2476),(46833,2476),(46834,2477),(46835,2477),(46836,2477),(46837,2478),(46838,2478),(46839,2478),(46840,2479),(46841,2479),(46842,2479),(46843,2480),(46844,2480),(46845,2480),(46846,2481),(46847,2481),(46848,2481),(46849,2482),(46850,2482),(46851,2482),(46852,2483),(46853,2483),(46854,2483),(46855,2484),(46856,2484),(46857,2484),(46858,2485),(46859,2485),(46860,2485),(46861,2486),(46862,2486),(46863,2486),(46864,2487),(46865,2487),(46866,2487),(46867,2488),(46868,2488),(46869,2488),(46870,2489),(46871,2489),(46872,2489),(46873,2490),(46874,2490),(46875,2490),(46876,2491),(46877,2491),(46878,2491),(46879,2492),(46880,2492),(46881,2492),(46882,2493),(46883,2493),(46884,2493),(46885,2494),(46886,2494),(46887,2494),(46888,2495),(46889,2495),(46890,2495),(46891,2496),(46892,2496),(46893,2496),(46894,2497),(46895,2497),(46896,2497),(46897,2498),(46898,2498),(46899,2498),(46900,2499),(46901,2499),(46902,2499),(46903,2500),(46904,2500),(46905,2500),(46906,2501),(46907,2501),(46908,2501),(46909,2502),(46910,2502),(46911,2502),(46912,2503),(46913,2503),(46914,2503),(46915,2504),(46916,2504),(46917,2504),(46918,2505),(46919,2505),(46920,2505),(46921,2506),(46922,2506),(46923,2506),(46924,2507),(46925,2507),(46926,2507),(46927,2508),(46928,2508),(46929,2508),(46930,2509),(46931,2509),(46932,2509),(46933,2510),(46934,2510),(46935,2510),(46936,2411),(46937,2411),(46938,2411),(46939,2411),(46940,2412),(46941,2412),(46942,2412),(46943,2412),(46944,2413),(46945,2413),(46946,2413),(46947,2413),(46948,2414),(46949,2414),(46950,2414),(46951,2414),(46952,2415),(46953,2415),(46954,2415),(46955,2415),(46956,2416),(46957,2416),(46958,2416),(46959,2416),(46960,2417),(46961,2417),(46962,2417),(46963,2417),(46964,2418),(46965,2418),(46966,2418),(46967,2418),(46968,2419),(46969,2419),(46970,2419),(46971,2419),(46972,2420),(46973,2420),(46974,2420),(46975,2420),(46976,2421),(46977,2421),(46978,2421),(46979,2421),(46980,2422),(46981,2422),(46982,2422),(46983,2422),(46984,2423),(46985,2423),(46986,2423),(46987,2423),(46988,2424),(46989,2424),(46990,2424),(46991,2424),(46992,2425),(46993,2425),(46994,2425),(46995,2425),(46996,2426),(46997,2426),(46998,2426),(46999,2426),(47000,2427),(47001,2427),(47002,2427),(47003,2427),(47004,2428),(47005,2428),(47006,2428),(47007,2428),(47008,2429),(47009,2429),(47010,2429),(47011,2429),(47012,2430),(47013,2430),(47014,2430),(47015,2430),(47016,2431),(47017,2431),(47018,2431),(47019,2431),(47020,2432),(47021,2432),(47022,2432),(47023,2432),(47024,2433),(47025,2433),(47026,2433),(47027,2433),(47028,2434),(47029,2434),(47030,2434),(47031,2434),(47032,2435),(47033,2435),(47034,2435),(47035,2435),(47036,2436),(47037,2436),(47038,2436),(47039,2436),(47040,2437),(47041,2437),(47042,2437),(47043,2437),(47044,2438),(47045,2438),(47046,2438),(47047,2438),(47048,2439),(47049,2439),(47050,2439),(47051,2439),(47052,2440),(47053,2440),(47054,2440),(47055,2440),(47056,2441),(47057,2441),(47058,2441),(47059,2441),(47060,2442),(47061,2442),(47062,2442),(47063,2442),(47064,2443),(47065,2443),(47066,2443),(47067,2443),(47068,2444),(47069,2444),(47070,2444),(47071,2444),(47072,2445),(47073,2445),(47074,2445),(47075,2445),(47076,2446),(47077,2446),(47078,2446),(47079,2446),(47080,2447),(47081,2447),(47082,2447),(47083,2447),(47084,2448),(47085,2448),(47086,2448),(47087,2448),(47088,2449),(47089,2449),(47090,2449),(47091,2449),(47092,2450),(47093,2450),(47094,2450),(47095,2450),(47096,2451),(47097,2451),(47098,2451),(47099,2451),(47100,2452),(47101,2452),(47102,2452),(47103,2452),(47104,2453),(47105,2453),(47106,2453),(47107,2453),(47108,2454),(47109,2454),(47110,2454),(47111,2454),(47112,2455),(47113,2455),(47114,2455),(47115,2455),(47116,2456),(47117,2456),(47118,2456),(47119,2456),(47120,2457),(47121,2457),(47122,2457),(47123,2457),(47124,2458),(47125,2458),(47126,2458),(47127,2458),(47128,2459),(47129,2459),(47130,2459),(47131,2459),(47132,2460),(47133,2460),(47134,2460),(47135,2460),(47136,2461),(47137,2461),(47138,2461),(47139,2461),(47140,2462),(47141,2462),(47142,2462),(47143,2462),(47144,2463),(47145,2463),(47146,2463),(47147,2463),(47148,2464),(47149,2464),(47150,2464),(47151,2464),(47152,2465),(47153,2465),(47154,2465),(47155,2465),(47156,2466),(47157,2466),(47158,2466),(47159,2466),(47160,2467),(47161,2467),(47162,2467),(47163,2467),(47164,2468),(47165,2468),(47166,2468),(47167,2468),(47168,2469),(47169,2469),(47170,2469),(47171,2469),(47172,2470),(47173,2470),(47174,2470),(47175,2470),(47176,2471),(47177,2471),(47178,2471),(47179,2471),(47180,2472),(47181,2472),(47182,2472),(47183,2472),(47184,2473),(47185,2473),(47186,2473),(47187,2473),(47188,2474),(47189,2474),(47190,2474),(47191,2474),(47192,2475),(47193,2475),(47194,2475),(47195,2475),(47196,2476),(47197,2476),(47198,2476),(47199,2476),(47200,2477),(47201,2477),(47202,2477),(47203,2477),(47204,2478),(47205,2478),(47206,2478),(47207,2478),(47208,2479),(47209,2479),(47210,2479),(47211,2479),(47212,2480),(47213,2480),(47214,2480),(47215,2480),(47216,2481),(47217,2481),(47218,2481),(47219,2481),(47220,2482),(47221,2482),(47222,2482),(47223,2482),(47224,2483),(47225,2483),(47226,2483),(47227,2483),(47228,2484),(47229,2484),(47230,2484),(47231,2484),(47232,2485),(47233,2485),(47234,2485),(47235,2485),(47236,2486),(47237,2486),(47238,2486),(47239,2486),(47240,2487),(47241,2487),(47242,2487),(47243,2487),(47244,2488),(47245,2488),(47246,2488),(47247,2488),(47248,2489),(47249,2489),(47250,2489),(47251,2489),(47252,2490),(47253,2490),(47254,2490),(47255,2490),(47256,2491),(47257,2491),(47258,2491),(47259,2491),(47260,2492),(47261,2492),(47262,2492),(47263,2492),(47264,2493),(47265,2493),(47266,2493),(47267,2493),(47268,2494),(47269,2494),(47270,2494),(47271,2494),(47272,2495),(47273,2495),(47274,2495),(47275,2495),(47276,2496),(47277,2496),(47278,2496),(47279,2496),(47280,2497),(47281,2497),(47282,2497),(47283,2497),(47284,2498),(47285,2498),(47286,2498),(47287,2498),(47288,2499),(47289,2499),(47290,2499),(47291,2499),(47292,2500),(47293,2500),(47294,2500),(47295,2500),(47296,2501),(47297,2501),(47298,2501),(47299,2501),(47300,2502),(47301,2502),(47302,2502),(47303,2502),(47304,2503),(47305,2503),(47306,2503),(47307,2503),(47308,2504),(47309,2504),(47310,2504),(47311,2504),(47312,2505),(47313,2505),(47314,2505),(47315,2505),(47316,2506),(47317,2506),(47318,2506),(47319,2506),(47320,2507),(47321,2507),(47322,2507),(47323,2507),(47324,2508),(47325,2508),(47326,2508),(47327,2508),(47328,2509),(47329,2509),(47330,2509),(47331,2509),(47332,2510),(47333,2510),(47334,2510),(47335,2510),(47336,2511),(47337,2512),(47338,2513),(47339,2514),(47340,2515),(47341,2516),(47342,2517),(47343,2518),(47344,2519),(47345,2520),(47346,2521),(47347,2522),(47348,2523),(47349,2524),(47350,2525),(47351,2526),(47352,2527),(47353,2528),(47354,2529),(47355,2530),(47356,2531),(47357,2532),(47358,2533),(47359,2534),(47360,2535),(47361,2536),(47362,2537),(47363,2538),(47364,2539),(47365,2540),(47366,2541),(47367,2542),(47368,2543),(47369,2544),(47370,2545),(47371,2546),(47372,2547),(47373,2548),(47374,2549),(47375,2550),(47376,2551),(47377,2552),(47378,2553),(47379,2554),(47380,2555),(47381,2556),(47382,2557),(47383,2558),(47384,2559),(47385,2560),(47386,2561),(47387,2562),(47388,2563),(47389,2564),(47390,2565),(47391,2566),(47392,2567),(47393,2568),(47394,2569),(47395,2570),(47396,2571),(47397,2572),(47398,2573),(47399,2574),(47400,2575),(47401,2576),(47402,2577),(47403,2578),(47404,2579),(47405,2580),(47406,2581),(47407,2582),(47408,2583),(47409,2584),(47410,2585),(47411,2586),(47412,2587),(47413,2588),(47414,2589),(47415,2590),(47416,2591),(47417,2592),(47418,2593),(47419,2594),(47420,2595),(47421,2596),(47422,2597),(47423,2598),(47424,2599),(47425,2600),(47426,2601),(47427,2602),(47428,2603),(47429,2604),(47430,2605),(47431,2606),(47432,2607),(47433,2608),(47434,2609),(47435,2610),(47436,2511),(47437,2512),(47438,2513),(47439,2514),(47440,2515),(47441,2516),(47442,2517),(47443,2518),(47444,2519),(47445,2520),(47446,2521),(47447,2522),(47448,2523),(47449,2524),(47450,2525),(47451,2526),(47452,2527),(47453,2528),(47454,2529),(47455,2530),(47456,2531),(47457,2532),(47458,2533),(47459,2534),(47460,2535),(47461,2536),(47462,2537),(47463,2538),(47464,2539),(47465,2540),(47466,2541),(47467,2542),(47468,2543),(47469,2544),(47470,2545),(47471,2546),(47472,2547),(47473,2548),(47474,2549),(47475,2550),(47476,2551),(47477,2552),(47478,2553),(47479,2554),(47480,2555),(47481,2556),(47482,2557),(47483,2558),(47484,2559),(47485,2560),(47486,2561),(47487,2562),(47488,2563),(47489,2564),(47490,2565),(47491,2566),(47492,2567),(47493,2568),(47494,2569),(47495,2570),(47496,2571),(47497,2572),(47498,2573),(47499,2574),(47500,2575),(47501,2576),(47502,2577),(47503,2578),(47504,2579),(47505,2580),(47506,2581),(47507,2582),(47508,2583),(47509,2584),(47510,2585),(47511,2586),(47512,2587),(47513,2588),(47514,2589),(47515,2590),(47516,2591),(47517,2592),(47518,2593),(47519,2594),(47520,2595),(47521,2596),(47522,2597),(47523,2598),(47524,2599),(47525,2600),(47526,2601),(47527,2602),(47528,2603),(47529,2604),(47530,2605),(47531,2606),(47532,2607),(47533,2608),(47534,2609),(47535,2610),(47536,2511),(47537,2511),(47538,2511),(47539,2511),(47540,2511),(47541,2511),(47542,2511),(47543,2511),(47544,2511),(47545,2512),(47546,2512),(47547,2512),(47548,2512),(47549,2512),(47550,2512),(47551,2512),(47552,2512),(47553,2512),(47554,2513),(47555,2513),(47556,2513),(47557,2513),(47558,2513),(47559,2513),(47560,2513),(47561,2513),(47562,2513),(47563,2514),(47564,2514),(47565,2514),(47566,2514),(47567,2514),(47568,2514),(47569,2514),(47570,2514),(47571,2514),(47572,2515),(47573,2515),(47574,2515),(47575,2515),(47576,2515),(47577,2515),(47578,2515),(47579,2516),(47580,2516),(47581,2516),(47582,2516),(47583,2516),(47584,2516),(47585,2516),(47586,2517),(47587,2517),(47588,2517),(47589,2517),(47590,2517),(47591,2517),(47592,2517),(47593,2518),(47594,2518),(47595,2518),(47596,2518),(47597,2518),(47598,2518),(47599,2518),(47600,2519),(47601,2519),(47602,2519),(47603,2519),(47604,2519),(47605,2519),(47606,2519),(47607,2520),(47608,2520),(47609,2520),(47610,2520),(47611,2520),(47612,2520),(47613,2520),(47614,2521),(47615,2521),(47616,2521),(47617,2521),(47618,2521),(47619,2521),(47620,2521),(47621,2522),(47622,2522),(47623,2522),(47624,2522),(47625,2522),(47626,2522),(47627,2522),(47628,2523),(47629,2523),(47630,2523),(47631,2523),(47632,2523),(47633,2523),(47634,2523),(47635,2524),(47636,2524),(47637,2524),(47638,2524),(47639,2524),(47640,2524),(47641,2524),(47642,2525),(47643,2525),(47644,2525),(47645,2525),(47646,2525),(47647,2525),(47648,2525),(47649,2526),(47650,2526),(47651,2526),(47652,2526),(47653,2526),(47654,2526),(47655,2526),(47656,2527),(47657,2527),(47658,2527),(47659,2527),(47660,2527),(47661,2527),(47662,2527),(47663,2528),(47664,2528),(47665,2528),(47666,2528),(47667,2528),(47668,2528),(47669,2528),(47670,2529),(47671,2529),(47672,2529),(47673,2529),(47674,2529),(47675,2529),(47676,2529),(47677,2530),(47678,2530),(47679,2530),(47680,2530),(47681,2530),(47682,2530),(47683,2530),(47684,2531),(47685,2531),(47686,2531),(47687,2531),(47688,2531),(47689,2531),(47690,2531),(47691,2532),(47692,2532),(47693,2532),(47694,2532),(47695,2532),(47696,2532),(47697,2532),(47698,2533),(47699,2533),(47700,2533),(47701,2533),(47702,2533),(47703,2533),(47704,2533),(47705,2534),(47706,2534),(47707,2534),(47708,2534),(47709,2534),(47710,2534),(47711,2534),(47712,2535),(47713,2535),(47714,2535),(47715,2535),(47716,2535),(47717,2535),(47718,2535),(47719,2536),(47720,2536),(47721,2536),(47722,2536),(47723,2536),(47724,2536),(47725,2536),(47726,2536),(47727,2536),(47728,2537),(47729,2537),(47730,2537),(47731,2537),(47732,2537),(47733,2537),(47734,2537),(47735,2538),(47736,2538),(47737,2538),(47738,2538),(47739,2538),(47740,2538),(47741,2538),(47742,2539),(47743,2539),(47744,2539),(47745,2539),(47746,2539),(47747,2539),(47748,2539),(47749,2539),(47750,2539),(47751,2540),(47752,2540),(47753,2540),(47754,2540),(47755,2540),(47756,2540),(47757,2541),(47758,2541),(47759,2541),(47760,2541),(47761,2541),(47762,2541),(47763,2541),(47764,2541),(47765,2541),(47766,2542),(47767,2542),(47768,2542),(47769,2542),(47770,2542),(47771,2542),(47772,2542),(47773,2542),(47774,2542),(47775,2543),(47776,2543),(47777,2543),(47778,2543),(47779,2543),(47780,2543),(47781,2543),(47782,2544),(47783,2544),(47784,2544),(47785,2544),(47786,2544),(47787,2544),(47788,2544),(47789,2545),(47790,2545),(47791,2545),(47792,2545),(47793,2545),(47794,2545),(47795,2545),(47796,2546),(47797,2546),(47798,2546),(47799,2546),(47800,2546),(47801,2546),(47802,2546),(47803,2547),(47804,2547),(47805,2547),(47806,2547),(47807,2547),(47808,2547),(47809,2547),(47810,2548),(47811,2548),(47812,2548),(47813,2548),(47814,2548),(47815,2548),(47816,2548),(47817,2549),(47818,2549),(47819,2549),(47820,2549),(47821,2549),(47822,2549),(47823,2549),(47824,2550),(47825,2550),(47826,2550),(47827,2550),(47828,2550),(47829,2550),(47830,2550),(47831,2551),(47832,2551),(47833,2551),(47834,2551),(47835,2551),(47836,2551),(47837,2551),(47838,2552),(47839,2552),(47840,2552),(47841,2552),(47842,2552),(47843,2552),(47844,2552),(47845,2553),(47846,2553),(47847,2553),(47848,2553),(47849,2553),(47850,2553),(47851,2553),(47852,2554),(47853,2554),(47854,2554),(47855,2554),(47856,2554),(47857,2554),(47858,2554),(47859,2555),(47860,2555),(47861,2555),(47862,2555),(47863,2555),(47864,2555),(47865,2555),(47866,2556),(47867,2556),(47868,2556),(47869,2556),(47870,2556),(47871,2556),(47872,2556),(47873,2557),(47874,2557),(47875,2557),(47876,2557),(47877,2557),(47878,2557),(47879,2557),(47880,2558),(47881,2558),(47882,2558),(47883,2558),(47884,2558),(47885,2558),(47886,2558),(47887,2559),(47888,2559),(47889,2559),(47890,2559),(47891,2559),(47892,2559),(47893,2560),(47894,2560),(47895,2560),(47896,2560),(47897,2560),(47898,2560),(47899,2560),(47900,2561),(47901,2561),(47902,2561),(47903,2561),(47904,2561),(47905,2561),(47906,2561),(47907,2562),(47908,2562),(47909,2562),(47910,2562),(47911,2562),(47912,2562),(47913,2562),(47914,2563),(47915,2563),(47916,2563),(47917,2563),(47918,2563),(47919,2563),(47920,2563),(47921,2564),(47922,2564),(47923,2564),(47924,2564),(47925,2564),(47926,2564),(47927,2564),(47928,2565),(47929,2565),(47930,2565),(47931,2565),(47932,2565),(47933,2565),(47934,2565),(47935,2566),(47936,2566),(47937,2566),(47938,2566),(47939,2566),(47940,2566),(47941,2566),(47942,2567),(47943,2567),(47944,2567),(47945,2567),(47946,2567),(47947,2567),(47948,2567),(47949,2568),(47950,2568),(47951,2568),(47952,2568),(47953,2568),(47954,2568),(47955,2568),(47956,2569),(47957,2569),(47958,2569),(47959,2569),(47960,2569),(47961,2569),(47962,2569),(47963,2570),(47964,2570),(47965,2570),(47966,2570),(47967,2570),(47968,2570),(47969,2570),(47970,2571),(47971,2571),(47972,2571),(47973,2571),(47974,2571),(47975,2571),(47976,2571),(47977,2572),(47978,2572),(47979,2572),(47980,2572),(47981,2572),(47982,2572),(47983,2572),(47984,2573),(47985,2573),(47986,2573),(47987,2573),(47988,2573),(47989,2573),(47990,2573),(47991,2574),(47992,2574),(47993,2574),(47994,2574),(47995,2574),(47996,2574),(47997,2574),(47998,2575),(47999,2575),(48000,2575),(48001,2575),(48002,2575),(48003,2575),(48004,2575),(48005,2576),(48006,2576),(48007,2576),(48008,2576),(48009,2576),(48010,2576),(48011,2576),(48012,2577),(48013,2577),(48014,2577),(48015,2577),(48016,2577),(48017,2577),(48018,2577),(48019,2578),(48020,2578),(48021,2578),(48022,2578),(48023,2578),(48024,2578),(48025,2578),(48026,2579),(48027,2579),(48028,2579),(48029,2579),(48030,2579),(48031,2579),(48032,2579),(48033,2580),(48034,2580),(48035,2580),(48036,2580),(48037,2580),(48038,2580),(48039,2580),(48040,2581),(48041,2581),(48042,2581),(48043,2581),(48044,2582),(48045,2582),(48046,2582),(48047,2582),(48048,2582),(48049,2582),(48050,2582),(48051,2583),(48052,2583),(48053,2583),(48054,2583),(48055,2583),(48056,2583),(48057,2583),(48058,2584),(48059,2584),(48060,2584),(48061,2584),(48062,2584),(48063,2584),(48064,2584),(48065,2585),(48066,2585),(48067,2585),(48068,2585),(48069,2585),(48070,2585),(48071,2585),(48072,2586),(48073,2586),(48074,2586),(48075,2586),(48076,2586),(48077,2586),(48078,2586),(48079,2587),(48080,2587),(48081,2587),(48082,2587),(48083,2587),(48084,2587),(48085,2587),(48086,2588),(48087,2588),(48088,2588),(48089,2588),(48090,2588),(48091,2588),(48092,2588),(48093,2589),(48094,2589),(48095,2589),(48096,2589),(48097,2589),(48098,2589),(48099,2589),(48100,2590),(48101,2590),(48102,2590),(48103,2590),(48104,2590),(48105,2590),(48106,2590),(48107,2591),(48108,2591),(48109,2591),(48110,2591),(48111,2591),(48112,2591),(48113,2591),(48114,2592),(48115,2592),(48116,2592),(48117,2592),(48118,2592),(48119,2592),(48120,2592),(48121,2593),(48122,2593),(48123,2593),(48124,2593),(48125,2593),(48126,2593),(48127,2593),(48128,2594),(48129,2594),(48130,2594),(48131,2594),(48132,2594),(48133,2594),(48134,2594),(48135,2595),(48136,2595),(48137,2595),(48138,2595),(48139,2595),(48140,2595),(48141,2595),(48142,2596),(48143,2596),(48144,2596),(48145,2596),(48146,2596),(48147,2596),(48148,2596),(48149,2597),(48150,2597),(48151,2597),(48152,2597),(48153,2597),(48154,2597),(48155,2597),(48156,2598),(48157,2598),(48158,2598),(48159,2598),(48160,2598),(48161,2598),(48162,2598),(48163,2599),(48164,2599),(48165,2599),(48166,2599),(48167,2599),(48168,2599),(48169,2599),(48170,2600),(48171,2600),(48172,2600),(48173,2600),(48174,2600),(48175,2600),(48176,2600),(48177,2601),(48178,2601),(48179,2601),(48180,2601),(48181,2601),(48182,2601),(48183,2601),(48184,2602),(48185,2602),(48186,2602),(48187,2602),(48188,2602),(48189,2602),(48190,2602),(48191,2603),(48192,2603),(48193,2603),(48194,2603),(48195,2603),(48196,2603),(48197,2603),(48198,2604),(48199,2604),(48200,2604),(48201,2604),(48202,2604),(48203,2604),(48204,2604),(48205,2605),(48206,2605),(48207,2605),(48208,2605),(48209,2605),(48210,2605),(48211,2605),(48212,2606),(48213,2606),(48214,2606),(48215,2606),(48216,2606),(48217,2606),(48218,2606),(48219,2607),(48220,2607),(48221,2607),(48222,2607),(48223,2607),(48224,2607),(48225,2607),(48226,2608),(48227,2608),(48228,2608),(48229,2608),(48230,2608),(48231,2608),(48232,2608),(48233,2609),(48234,2609),(48235,2609),(48236,2609),(48237,2609),(48238,2609),(48239,2609),(48240,2609),(48241,2609),(48242,2610),(48243,2610),(48244,2610),(48245,2610),(48246,2610),(48247,2610),(48248,2610),(48249,2511),(48250,2511),(48251,2512),(48252,2512),(48253,2513),(48254,2513),(48255,2513),(48256,2514),(48257,2514),(48258,2514),(48259,2515),(48260,2515),(48261,2516),(48262,2516),(48263,2517),(48264,2517),(48265,2517),(48266,2518),(48267,2518),(48268,2518),(48269,2519),(48270,2519),(48271,2519),(48272,2520),(48273,2520),(48274,2520),(48275,2521),(48276,2521),(48277,2521),(48278,2522),(48279,2522),(48280,2522),(48281,2523),(48282,2523),(48283,2523),(48284,2524),(48285,2524),(48286,2524),(48287,2525),(48288,2525),(48289,2525),(48290,2526),(48291,2526),(48292,2526),(48293,2527),(48294,2527),(48295,2527),(48296,2528),(48297,2528),(48298,2528),(48299,2529),(48300,2529),(48301,2529),(48302,2530),(48303,2530),(48304,2530),(48305,2531),(48306,2531),(48307,2532),(48308,2532),(48309,2532),(48310,2533),(48311,2533),(48312,2533),(48313,2534),(48314,2534),(48315,2534),(48316,2535),(48317,2535),(48318,2535),(48319,2536),(48320,2536),(48321,2537),(48322,2537),(48323,2537),(48324,2538),(48325,2538),(48326,2538),(48327,2539),(48328,2539),(48329,2539),(48330,2540),(48331,2540),(48332,2541),(48333,2541),(48334,2542),(48335,2542),(48336,2543),(48337,2543),(48338,2543),(48339,2544),(48340,2544),(48341,2544),(48342,2545),(48343,2545),(48344,2545),(48345,2546),(48346,2546),(48347,2546),(48348,2547),(48349,2547),(48350,2547),(48351,2548),(48352,2548),(48353,2548),(48354,2549),(48355,2549),(48356,2549),(48357,2550),(48358,2550),(48359,2550),(48360,2551),(48361,2551),(48362,2551),(48363,2552),(48364,2552),(48365,2552),(48366,2553),(48367,2553),(48368,2553),(48369,2554),(48370,2554),(48371,2554),(48372,2555),(48373,2555),(48374,2556),(48375,2556),(48376,2556),(48377,2557),(48378,2557),(48379,2557),(48380,2558),(48381,2558),(48382,2558),(48383,2559),(48384,2559),(48385,2559),(48386,2560),(48387,2560),(48388,2560),(48389,2561),(48390,2561),(48391,2561),(48392,2562),(48393,2562),(48394,2562),(48395,2563),(48396,2563),(48397,2563),(48398,2564),(48399,2564),(48400,2564),(48401,2565),(48402,2565),(48403,2565),(48404,2566),(48405,2566),(48406,2566),(48407,2567),(48408,2567),(48409,2567),(48410,2568),(48411,2568),(48412,2568),(48413,2569),(48414,2569),(48415,2569),(48416,2570),(48417,2570),(48418,2570),(48419,2571),(48420,2571),(48421,2571),(48422,2572),(48423,2572),(48424,2572),(48425,2573),(48426,2573),(48427,2573),(48428,2574),(48429,2574),(48430,2574),(48431,2575),(48432,2575),(48433,2575),(48434,2576),(48435,2576),(48436,2576),(48437,2577),(48438,2577),(48439,2577),(48440,2578),(48441,2578),(48442,2578),(48443,2579),(48444,2579),(48445,2579),(48446,2580),(48447,2580),(48448,2580),(48449,2581),(48450,2582),(48451,2582),(48452,2582),(48453,2583),(48454,2583),(48455,2583),(48456,2584),(48457,2584),(48458,2584),(48459,2585),(48460,2585),(48461,2585),(48462,2586),(48463,2586),(48464,2586),(48465,2587),(48466,2587),(48467,2587),(48468,2588),(48469,2588),(48470,2589),(48471,2589),(48472,2590),(48473,2590),(48474,2591),(48475,2591),(48476,2592),(48477,2592),(48478,2593),(48479,2593),(48480,2594),(48481,2594),(48482,2595),(48483,2595),(48484,2596),(48485,2596),(48486,2597),(48487,2597),(48488,2598),(48489,2598),(48490,2599),(48491,2599),(48492,2600),(48493,2600),(48494,2601),(48495,2601),(48496,2602),(48497,2602),(48498,2603),(48499,2603),(48500,2604),(48501,2604),(48502,2605),(48503,2605),(48504,2606),(48505,2606),(48506,2607),(48507,2607),(48508,2608),(48509,2608),(48510,2609),(48511,2609),(48512,2610),(48513,2610),(48514,2511),(48515,2511),(48516,2511),(48517,2512),(48518,2512),(48519,2512),(48520,2513),(48521,2513),(48522,2513),(48523,2514),(48524,2514),(48525,2514),(48526,2515),(48527,2515),(48528,2515),(48529,2516),(48530,2516),(48531,2516),(48532,2517),(48533,2517),(48534,2517),(48535,2518),(48536,2518),(48537,2518),(48538,2519),(48539,2519),(48540,2519),(48541,2520),(48542,2520),(48543,2520),(48544,2521),(48545,2521),(48546,2521),(48547,2522),(48548,2522),(48549,2522),(48550,2523),(48551,2523),(48552,2523),(48553,2524),(48554,2524),(48555,2524),(48556,2525),(48557,2525),(48558,2525),(48559,2526),(48560,2526),(48561,2526),(48562,2527),(48563,2527),(48564,2527),(48565,2528),(48566,2528),(48567,2528),(48568,2529),(48569,2529),(48570,2529),(48571,2530),(48572,2530),(48573,2530),(48574,2531),(48575,2531),(48576,2531),(48577,2532),(48578,2532),(48579,2532),(48580,2533),(48581,2533),(48582,2533),(48583,2534),(48584,2534),(48585,2534),(48586,2535),(48587,2535),(48588,2535),(48589,2536),(48590,2536),(48591,2536),(48592,2537),(48593,2537),(48594,2537),(48595,2538),(48596,2538),(48597,2538),(48598,2539),(48599,2539),(48600,2539),(48601,2540),(48602,2540),(48603,2540),(48604,2541),(48605,2541),(48606,2541),(48607,2542),(48608,2542),(48609,2542),(48610,2543),(48611,2543),(48612,2543),(48613,2544),(48614,2544),(48615,2544),(48616,2545),(48617,2545),(48618,2545),(48619,2546),(48620,2546),(48621,2546),(48622,2547),(48623,2547),(48624,2547),(48625,2548),(48626,2548),(48627,2548),(48628,2549),(48629,2549),(48630,2549),(48631,2550),(48632,2550),(48633,2550),(48634,2551),(48635,2551),(48636,2551),(48637,2552),(48638,2552),(48639,2552),(48640,2553),(48641,2553),(48642,2553),(48643,2554),(48644,2554),(48645,2554),(48646,2555),(48647,2555),(48648,2555),(48649,2556),(48650,2556),(48651,2556),(48652,2557),(48653,2557),(48654,2557),(48655,2558),(48656,2558),(48657,2558),(48658,2559),(48659,2559),(48660,2559),(48661,2560),(48662,2560),(48663,2560),(48664,2561),(48665,2561),(48666,2561),(48667,2562),(48668,2562),(48669,2562),(48670,2563),(48671,2563),(48672,2563),(48673,2564),(48674,2564),(48675,2564),(48676,2565),(48677,2565),(48678,2565),(48679,2566),(48680,2566),(48681,2566),(48682,2567),(48683,2567),(48684,2567),(48685,2568),(48686,2568),(48687,2568),(48688,2569),(48689,2569),(48690,2569),(48691,2570),(48692,2570),(48693,2570),(48694,2571),(48695,2571),(48696,2571),(48697,2572),(48698,2572),(48699,2572),(48700,2573),(48701,2573),(48702,2573),(48703,2574),(48704,2574),(48705,2574),(48706,2575),(48707,2575),(48708,2575),(48709,2576),(48710,2576),(48711,2576),(48712,2577),(48713,2577),(48714,2577),(48715,2578),(48716,2578),(48717,2578),(48718,2579),(48719,2579),(48720,2579),(48721,2580),(48722,2580),(48723,2580),(48724,2581),(48725,2581),(48726,2581),(48727,2582),(48728,2582),(48729,2582),(48730,2583),(48731,2583),(48732,2583),(48733,2584),(48734,2584),(48735,2584),(48736,2585),(48737,2585),(48738,2585),(48739,2586),(48740,2586),(48741,2586),(48742,2587),(48743,2587),(48744,2587),(48745,2588),(48746,2588),(48747,2588),(48748,2589),(48749,2589),(48750,2589),(48751,2590),(48752,2590),(48753,2590),(48754,2591),(48755,2591),(48756,2591),(48757,2592),(48758,2592),(48759,2592),(48760,2593),(48761,2593),(48762,2593),(48763,2594),(48764,2594),(48765,2594),(48766,2595),(48767,2595),(48768,2595),(48769,2596),(48770,2596),(48771,2596),(48772,2597),(48773,2597),(48774,2597),(48775,2598),(48776,2598),(48777,2598),(48778,2599),(48779,2599),(48780,2599),(48781,2600),(48782,2600),(48783,2600),(48784,2601),(48785,2601),(48786,2601),(48787,2602),(48788,2602),(48789,2602),(48790,2603),(48791,2603),(48792,2603),(48793,2604),(48794,2604),(48795,2604),(48796,2605),(48797,2605),(48798,2605),(48799,2606),(48800,2606),(48801,2606),(48802,2607),(48803,2607),(48804,2607),(48805,2608),(48806,2608),(48807,2608),(48808,2609),(48809,2609),(48810,2609),(48811,2610),(48812,2610),(48813,2610),(48814,2511),(48815,2511),(48816,2511),(48817,2511),(48818,2512),(48819,2512),(48820,2512),(48821,2512),(48822,2513),(48823,2513),(48824,2513),(48825,2513),(48826,2514),(48827,2514),(48828,2514),(48829,2514),(48830,2515),(48831,2515),(48832,2515),(48833,2515),(48834,2516),(48835,2516),(48836,2516),(48837,2516),(48838,2517),(48839,2517),(48840,2517),(48841,2517),(48842,2518),(48843,2518),(48844,2518),(48845,2518),(48846,2519),(48847,2519),(48848,2519),(48849,2519),(48850,2520),(48851,2520),(48852,2520),(48853,2520),(48854,2521),(48855,2521),(48856,2521),(48857,2521),(48858,2522),(48859,2522),(48860,2522),(48861,2522),(48862,2523),(48863,2523),(48864,2523),(48865,2523),(48866,2524),(48867,2524),(48868,2524),(48869,2524),(48870,2525),(48871,2525),(48872,2525),(48873,2525),(48874,2526),(48875,2526),(48876,2526),(48877,2526),(48878,2527),(48879,2527),(48880,2527),(48881,2527),(48882,2528),(48883,2528),(48884,2528),(48885,2528),(48886,2529),(48887,2529),(48888,2529),(48889,2529),(48890,2530),(48891,2530),(48892,2530),(48893,2530),(48894,2531),(48895,2531),(48896,2531),(48897,2531),(48898,2532),(48899,2532),(48900,2532),(48901,2532),(48902,2533),(48903,2533),(48904,2533),(48905,2533),(48906,2534),(48907,2534),(48908,2534),(48909,2534),(48910,2535),(48911,2535),(48912,2535),(48913,2535),(48914,2536),(48915,2536),(48916,2536),(48917,2536),(48918,2537),(48919,2537),(48920,2537),(48921,2537),(48922,2538),(48923,2538),(48924,2538),(48925,2538),(48926,2539),(48927,2539),(48928,2539),(48929,2539),(48930,2540),(48931,2540),(48932,2540),(48933,2540),(48934,2541),(48935,2541),(48936,2541),(48937,2541),(48938,2542),(48939,2542),(48940,2542),(48941,2542),(48942,2543),(48943,2543),(48944,2543),(48945,2543),(48946,2544),(48947,2544),(48948,2544),(48949,2544),(48950,2545),(48951,2545),(48952,2545),(48953,2545),(48954,2546),(48955,2546),(48956,2546),(48957,2546),(48958,2547),(48959,2547),(48960,2547),(48961,2547),(48962,2548),(48963,2548),(48964,2548),(48965,2548),(48966,2549),(48967,2549),(48968,2549),(48969,2549),(48970,2550),(48971,2550),(48972,2550),(48973,2550),(48974,2551),(48975,2551),(48976,2551),(48977,2551),(48978,2552),(48979,2552),(48980,2552),(48981,2552),(48982,2553),(48983,2553),(48984,2553),(48985,2553),(48986,2554),(48987,2554),(48988,2554),(48989,2554),(48990,2555),(48991,2555),(48992,2555),(48993,2555),(48994,2556),(48995,2556),(48996,2556),(48997,2556),(48998,2557),(48999,2557),(49000,2557),(49001,2557),(49002,2558),(49003,2558),(49004,2558),(49005,2558),(49006,2559),(49007,2559),(49008,2559),(49009,2559),(49010,2560),(49011,2560),(49012,2560),(49013,2560),(49014,2561),(49015,2561),(49016,2561),(49017,2561),(49018,2562),(49019,2562),(49020,2562),(49021,2562),(49022,2563),(49023,2563),(49024,2563),(49025,2563),(49026,2564),(49027,2564),(49028,2564),(49029,2564),(49030,2565),(49031,2565),(49032,2565),(49033,2565),(49034,2566),(49035,2566),(49036,2566),(49037,2566),(49038,2567),(49039,2567),(49040,2567),(49041,2567),(49042,2568),(49043,2568),(49044,2568),(49045,2568),(49046,2569),(49047,2569),(49048,2569),(49049,2569),(49050,2570),(49051,2570),(49052,2570),(49053,2570),(49054,2571),(49055,2571),(49056,2571),(49057,2571),(49058,2572),(49059,2572),(49060,2572),(49061,2572),(49062,2573),(49063,2573),(49064,2573),(49065,2573),(49066,2574),(49067,2574),(49068,2574),(49069,2574),(49070,2575),(49071,2575),(49072,2575),(49073,2575),(49074,2576),(49075,2576),(49076,2576),(49077,2576),(49078,2577),(49079,2577),(49080,2577),(49081,2577),(49082,2578),(49083,2578),(49084,2578),(49085,2578),(49086,2579),(49087,2579),(49088,2579),(49089,2579),(49090,2580),(49091,2580),(49092,2580),(49093,2580),(49094,2581),(49095,2581),(49096,2581),(49097,2581),(49098,2582),(49099,2582),(49100,2582),(49101,2582),(49102,2583),(49103,2583),(49104,2583),(49105,2583),(49106,2584),(49107,2584),(49108,2584),(49109,2584),(49110,2585),(49111,2585),(49112,2585),(49113,2585),(49114,2586),(49115,2586),(49116,2586),(49117,2586),(49118,2587),(49119,2587),(49120,2587),(49121,2587),(49122,2588),(49123,2588),(49124,2588),(49125,2588),(49126,2589),(49127,2589),(49128,2589),(49129,2589),(49130,2590),(49131,2590),(49132,2590),(49133,2590),(49134,2591),(49135,2591),(49136,2591),(49137,2591),(49138,2592),(49139,2592),(49140,2592),(49141,2592),(49142,2593),(49143,2593),(49144,2593),(49145,2593),(49146,2594),(49147,2594),(49148,2594),(49149,2594),(49150,2595),(49151,2595),(49152,2595),(49153,2595),(49154,2596),(49155,2596),(49156,2596),(49157,2596),(49158,2597),(49159,2597),(49160,2597),(49161,2597),(49162,2598),(49163,2598),(49164,2598),(49165,2598),(49166,2599),(49167,2599),(49168,2599),(49169,2599),(49170,2600),(49171,2600),(49172,2600),(49173,2600),(49174,2601),(49175,2601),(49176,2601),(49177,2601),(49178,2602),(49179,2602),(49180,2602),(49181,2602),(49182,2603),(49183,2603),(49184,2603),(49185,2603),(49186,2604),(49187,2604),(49188,2604),(49189,2604),(49190,2605),(49191,2605),(49192,2605),(49193,2605),(49194,2606),(49195,2606),(49196,2606),(49197,2606),(49198,2607),(49199,2607),(49200,2607),(49201,2607),(49202,2608),(49203,2608),(49204,2608),(49205,2608),(49206,2609),(49207,2609),(49208,2609),(49209,2609),(49210,2610),(49211,2610),(49212,2610),(49213,2610),(49214,2611),(49215,2612),(49216,2613),(49217,2614),(49218,2615),(49219,2616),(49220,2617),(49221,2618),(49222,2619),(49223,2620),(49224,2621),(49225,2611),(49226,2612),(49227,2613),(49228,2614),(49229,2615),(49230,2616),(49231,2617),(49232,2618),(49233,2619),(49234,2620),(49235,2621),(49236,2611),(49237,2611),(49238,2611),(49239,2611),(49240,2611),(49241,2611),(49242,2611),(49243,2612),(49244,2612),(49245,2612),(49246,2612),(49247,2612),(49248,2612),(49249,2612),(49250,2613),(49251,2613),(49252,2613),(49253,2613),(49254,2613),(49255,2613),(49256,2613),(49257,2614),(49258,2614),(49259,2614),(49260,2614),(49261,2614),(49262,2614),(49263,2614),(49264,2615),(49265,2615),(49266,2615),(49267,2615),(49268,2615),(49269,2615),(49270,2615),(49271,2616),(49272,2616),(49273,2616),(49274,2616),(49275,2616),(49276,2616),(49277,2616),(49278,2617),(49279,2617),(49280,2617),(49281,2617),(49282,2617),(49283,2617),(49284,2617),(49285,2618),(49286,2618),(49287,2618),(49288,2618),(49289,2618),(49290,2618),(49291,2618),(49292,2619),(49293,2619),(49294,2619),(49295,2619),(49296,2619),(49297,2619),(49298,2619),(49299,2620),(49300,2620),(49301,2620),(49302,2620),(49303,2620),(49304,2620),(49305,2620),(49306,2621),(49307,2621),(49308,2621),(49309,2621),(49310,2621),(49311,2621),(49312,2621),(49313,2611),(49314,2611),(49315,2612),(49316,2612),(49317,2613),(49318,2613),(49319,2614),(49320,2614),(49321,2615),(49322,2615),(49323,2615),(49324,2616),(49325,2616),(49326,2616),(49327,2617),(49328,2617),(49329,2617),(49330,2618),(49331,2618),(49332,2618),(49333,2619),(49334,2619),(49335,2619),(49336,2620),(49337,2620),(49338,2620),(49339,2621),(49340,2621),(49341,2611),(49342,2611),(49343,2611),(49344,2612),(49345,2612),(49346,2612),(49347,2613),(49348,2613),(49349,2613),(49350,2614),(49351,2614),(49352,2614),(49353,2615),(49354,2615),(49355,2615),(49356,2616),(49357,2616),(49358,2616),(49359,2617),(49360,2617),(49361,2617),(49362,2618),(49363,2618),(49364,2618),(49365,2619),(49366,2619),(49367,2619),(49368,2620),(49369,2620),(49370,2620),(49371,2621),(49372,2621),(49373,2621),(49374,2611),(49375,2611),(49376,2611),(49377,2611),(49378,2612),(49379,2612),(49380,2612),(49381,2612),(49382,2613),(49383,2613),(49384,2613),(49385,2613),(49386,2614),(49387,2614),(49388,2614),(49389,2614),(49390,2615),(49391,2615),(49392,2615),(49393,2615),(49394,2616),(49395,2616),(49396,2616),(49397,2616),(49398,2617),(49399,2617),(49400,2617),(49401,2617),(49402,2618),(49403,2618),(49404,2618),(49405,2618),(49406,2619),(49407,2619),(49408,2619),(49409,2619),(49410,2620),(49411,2620),(49412,2620),(49413,2620),(49414,2621),(49415,2621),(49416,2621),(49417,2621),(49418,2622),(49419,2623),(49420,2624),(49421,2625),(49422,2626),(49423,2627),(49424,2628),(49425,2629),(49426,2630),(49427,2631),(49428,2632),(49429,2633),(49430,2634),(49431,2635),(49432,2636),(49433,2637),(49434,2638),(49435,2639),(49436,2640),(49437,2641),(49438,2642),(49439,2643),(49440,2644),(49441,2645),(49442,2646),(49443,2647),(49444,2648),(49445,2649),(49446,2650),(49447,2651),(49448,2652),(49449,2653),(49450,2654),(49451,2655),(49452,2656),(49453,2657),(49454,2658),(49455,2659),(49456,2660),(49457,2661),(49458,2662),(49459,2663),(49460,2664),(49461,2665),(49462,2666),(49463,2667),(49464,2668),(49465,2669),(49466,2670),(49467,2671),(49468,2672),(49469,2673),(49470,2674),(49471,2675),(49472,2676),(49473,2677),(49474,2678),(49475,2679),(49476,2680),(49477,2681),(49478,2682),(49479,2683),(49480,2684),(49481,2685),(49482,2686),(49483,2687),(49484,2688),(49485,2689),(49486,2690),(49487,2691),(49488,2692),(49489,2693),(49490,2694),(49491,2695),(49492,2696),(49493,2697),(49494,2698),(49495,2699),(49496,2700),(49497,2701),(49498,2702),(49499,2703),(49500,2704),(49501,2705),(49502,2706),(49503,2707),(49504,2708),(49505,2709),(49506,2710),(49507,2711),(49508,2712),(49509,2713),(49510,2714),(49511,2715),(49512,2716),(49513,2717),(49514,2718),(49515,2719),(49516,2720),(49517,2721),(49518,2622),(49519,2623),(49520,2624),(49521,2625),(49522,2626),(49523,2627),(49524,2628),(49525,2629),(49526,2630),(49527,2631),(49528,2632),(49529,2633),(49530,2634),(49531,2635),(49532,2636),(49533,2637),(49534,2638),(49535,2639),(49536,2640),(49537,2641),(49538,2642),(49539,2643),(49540,2644),(49541,2645),(49542,2646),(49543,2647),(49544,2648),(49545,2649),(49546,2650),(49547,2651),(49548,2652),(49549,2653),(49550,2654),(49551,2655),(49552,2656),(49553,2657),(49554,2658),(49555,2659),(49556,2660),(49557,2661),(49558,2662),(49559,2663),(49560,2664),(49561,2665),(49562,2666),(49563,2667),(49564,2668),(49565,2669),(49566,2670),(49567,2671),(49568,2672),(49569,2673),(49570,2674),(49571,2675),(49572,2676),(49573,2677),(49574,2678),(49575,2679),(49576,2680),(49577,2681),(49578,2682),(49579,2683),(49580,2684),(49581,2685),(49582,2686),(49583,2687),(49584,2688),(49585,2689),(49586,2690),(49587,2691),(49588,2692),(49589,2693),(49590,2694),(49591,2695),(49592,2696),(49593,2697),(49594,2698),(49595,2699),(49596,2700),(49597,2701),(49598,2702),(49599,2703),(49600,2704),(49601,2705),(49602,2706),(49603,2707),(49604,2708),(49605,2709),(49606,2710),(49607,2711),(49608,2712),(49609,2713),(49610,2714),(49611,2715),(49612,2716),(49613,2717),(49614,2718),(49615,2719),(49616,2720),(49617,2721),(49618,2622),(49619,2622),(49620,2622),(49621,2622),(49622,2622),(49623,2622),(49624,2623),(49625,2623),(49626,2623),(49627,2623),(49628,2623),(49629,2623),(49630,2624),(49631,2624),(49632,2624),(49633,2624),(49634,2624),(49635,2624),(49636,2625),(49637,2625),(49638,2625),(49639,2625),(49640,2625),(49641,2625),(49642,2626),(49643,2626),(49644,2626),(49645,2626),(49646,2626),(49647,2626),(49648,2627),(49649,2627),(49650,2627),(49651,2627),(49652,2627),(49653,2627),(49654,2628),(49655,2628),(49656,2628),(49657,2628),(49658,2628),(49659,2628),(49660,2629),(49661,2629),(49662,2629),(49663,2629),(49664,2629),(49665,2629),(49666,2630),(49667,2630),(49668,2630),(49669,2630),(49670,2630),(49671,2630),(49672,2631),(49673,2631),(49674,2631),(49675,2631),(49676,2631),(49677,2631),(49678,2632),(49679,2632),(49680,2632),(49681,2632),(49682,2632),(49683,2632),(49684,2633),(49685,2633),(49686,2633),(49687,2633),(49688,2633),(49689,2633),(49690,2634),(49691,2634),(49692,2634),(49693,2634),(49694,2634),(49695,2634),(49696,2635),(49697,2635),(49698,2635),(49699,2635),(49700,2635),(49701,2635),(49702,2636),(49703,2636),(49704,2636),(49705,2636),(49706,2636),(49707,2636),(49708,2637),(49709,2637),(49710,2637),(49711,2637),(49712,2637),(49713,2637),(49714,2638),(49715,2638),(49716,2638),(49717,2638),(49718,2638),(49719,2638),(49720,2639),(49721,2639),(49722,2639),(49723,2639),(49724,2639),(49725,2639),(49726,2640),(49727,2640),(49728,2640),(49729,2640),(49730,2640),(49731,2640),(49732,2641),(49733,2641),(49734,2641),(49735,2641),(49736,2641),(49737,2641),(49738,2642),(49739,2642),(49740,2642),(49741,2642),(49742,2642),(49743,2642),(49744,2643),(49745,2643),(49746,2643),(49747,2643),(49748,2643),(49749,2643),(49750,2644),(49751,2644),(49752,2644),(49753,2644),(49754,2644),(49755,2644),(49756,2645),(49757,2645),(49758,2645),(49759,2645),(49760,2645),(49761,2645),(49762,2646),(49763,2646),(49764,2646),(49765,2646),(49766,2646),(49767,2646),(49768,2647),(49769,2647),(49770,2647),(49771,2647),(49772,2647),(49773,2647),(49774,2648),(49775,2648),(49776,2648),(49777,2648),(49778,2648),(49779,2648),(49780,2649),(49781,2649),(49782,2649),(49783,2649),(49784,2649),(49785,2649),(49786,2650),(49787,2650),(49788,2650),(49789,2650),(49790,2650),(49791,2650),(49792,2651),(49793,2651),(49794,2651),(49795,2651),(49796,2651),(49797,2651),(49798,2652),(49799,2652),(49800,2652),(49801,2652),(49802,2652),(49803,2652),(49804,2653),(49805,2653),(49806,2653),(49807,2653),(49808,2653),(49809,2653),(49810,2654),(49811,2654),(49812,2654),(49813,2654),(49814,2654),(49815,2654),(49816,2655),(49817,2655),(49818,2655),(49819,2655),(49820,2655),(49821,2655),(49822,2656),(49823,2656),(49824,2656),(49825,2656),(49826,2656),(49827,2656),(49828,2657),(49829,2657),(49830,2657),(49831,2657),(49832,2657),(49833,2657),(49834,2658),(49835,2658),(49836,2658),(49837,2658),(49838,2658),(49839,2658),(49840,2659),(49841,2659),(49842,2659),(49843,2659),(49844,2659),(49845,2659),(49846,2660),(49847,2660),(49848,2660),(49849,2660),(49850,2660),(49851,2660),(49852,2661),(49853,2661),(49854,2661),(49855,2661),(49856,2661),(49857,2661),(49858,2662),(49859,2662),(49860,2662),(49861,2662),(49862,2662),(49863,2662),(49864,2663),(49865,2663),(49866,2663),(49867,2663),(49868,2663),(49869,2663),(49870,2664),(49871,2664),(49872,2664),(49873,2664),(49874,2664),(49875,2664),(49876,2665),(49877,2665),(49878,2665),(49879,2665),(49880,2665),(49881,2665),(49882,2666),(49883,2666),(49884,2666),(49885,2666),(49886,2666),(49887,2666),(49888,2667),(49889,2667),(49890,2667),(49891,2667),(49892,2667),(49893,2667),(49894,2668),(49895,2668),(49896,2668),(49897,2668),(49898,2668),(49899,2668),(49900,2669),(49901,2669),(49902,2669),(49903,2669),(49904,2669),(49905,2669),(49906,2670),(49907,2670),(49908,2670),(49909,2670),(49910,2670),(49911,2670),(49912,2671),(49913,2671),(49914,2671),(49915,2671),(49916,2671),(49917,2671),(49918,2672),(49919,2672),(49920,2672),(49921,2672),(49922,2672),(49923,2672),(49924,2673),(49925,2673),(49926,2673),(49927,2673),(49928,2673),(49929,2673),(49930,2674),(49931,2674),(49932,2674),(49933,2674),(49934,2674),(49935,2674),(49936,2675),(49937,2675),(49938,2675),(49939,2675),(49940,2675),(49941,2675),(49942,2676),(49943,2676),(49944,2676),(49945,2676),(49946,2676),(49947,2676),(49948,2677),(49949,2677),(49950,2677),(49951,2677),(49952,2677),(49953,2677),(49954,2678),(49955,2678),(49956,2678),(49957,2678),(49958,2678),(49959,2678),(49960,2679),(49961,2679),(49962,2679),(49963,2679),(49964,2679),(49965,2679),(49966,2680),(49967,2680),(49968,2680),(49969,2680),(49970,2680),(49971,2680),(49972,2681),(49973,2681),(49974,2681),(49975,2681),(49976,2681),(49977,2681),(49978,2682),(49979,2682),(49980,2682),(49981,2682),(49982,2682),(49983,2682),(49984,2683),(49985,2683),(49986,2683),(49987,2683),(49988,2683),(49989,2683),(49990,2684),(49991,2684),(49992,2684),(49993,2684),(49994,2684),(49995,2684),(49996,2685),(49997,2685),(49998,2685),(49999,2685),(50000,2685),(50001,2685),(50002,2686),(50003,2686),(50004,2686),(50005,2686),(50006,2686),(50007,2686),(50008,2687),(50009,2687),(50010,2687),(50011,2687),(50012,2687),(50013,2687),(50014,2688),(50015,2688),(50016,2688),(50017,2688),(50018,2688),(50019,2688),(50020,2689),(50021,2689),(50022,2689),(50023,2689),(50024,2689),(50025,2689),(50026,2690),(50027,2690),(50028,2690),(50029,2690),(50030,2690),(50031,2690),(50032,2691),(50033,2691),(50034,2691),(50035,2691),(50036,2691),(50037,2691),(50038,2692),(50039,2692),(50040,2692),(50041,2692),(50042,2692),(50043,2692),(50044,2693),(50045,2693),(50046,2693),(50047,2693),(50048,2693),(50049,2693),(50050,2694),(50051,2694),(50052,2694),(50053,2694),(50054,2694),(50055,2694),(50056,2695),(50057,2695),(50058,2695),(50059,2695),(50060,2695),(50061,2695),(50062,2696),(50063,2696),(50064,2696),(50065,2696),(50066,2696),(50067,2696),(50068,2697),(50069,2697),(50070,2697),(50071,2697),(50072,2697),(50073,2697),(50074,2698),(50075,2698),(50076,2698),(50077,2698),(50078,2698),(50079,2698),(50080,2699),(50081,2699),(50082,2699),(50083,2699),(50084,2699),(50085,2699),(50086,2700),(50087,2700),(50088,2700),(50089,2700),(50090,2700),(50091,2700),(50092,2701),(50093,2701),(50094,2701),(50095,2701),(50096,2701),(50097,2701),(50098,2702),(50099,2702),(50100,2702),(50101,2702),(50102,2702),(50103,2702),(50104,2703),(50105,2703),(50106,2703),(50107,2703),(50108,2703),(50109,2703),(50110,2704),(50111,2704),(50112,2704),(50113,2704),(50114,2704),(50115,2704),(50116,2705),(50117,2705),(50118,2705),(50119,2705),(50120,2705),(50121,2705),(50122,2706),(50123,2706),(50124,2706),(50125,2706),(50126,2706),(50127,2706),(50128,2707),(50129,2707),(50130,2707),(50131,2707),(50132,2707),(50133,2707),(50134,2708),(50135,2708),(50136,2708),(50137,2708),(50138,2708),(50139,2708),(50140,2709),(50141,2709),(50142,2709),(50143,2709),(50144,2709),(50145,2709),(50146,2710),(50147,2710),(50148,2710),(50149,2710),(50150,2710),(50151,2710),(50152,2711),(50153,2711),(50154,2711),(50155,2711),(50156,2711),(50157,2711),(50158,2712),(50159,2712),(50160,2712),(50161,2712),(50162,2712),(50163,2712),(50164,2713),(50165,2713),(50166,2713),(50167,2713),(50168,2713),(50169,2713),(50170,2714),(50171,2714),(50172,2714),(50173,2714),(50174,2714),(50175,2714),(50176,2715),(50177,2715),(50178,2715),(50179,2715),(50180,2715),(50181,2715),(50182,2716),(50183,2716),(50184,2716),(50185,2716),(50186,2716),(50187,2716),(50188,2717),(50189,2717),(50190,2717),(50191,2717),(50192,2717),(50193,2717),(50194,2718),(50195,2718),(50196,2718),(50197,2718),(50198,2718),(50199,2718),(50200,2719),(50201,2719),(50202,2719),(50203,2719),(50204,2719),(50205,2719),(50206,2720),(50207,2720),(50208,2720),(50209,2720),(50210,2720),(50211,2720),(50212,2721),(50213,2721),(50214,2721),(50215,2721),(50216,2721),(50217,2721),(50218,2622),(50219,2622),(50220,2623),(50221,2623),(50222,2624),(50223,2624),(50224,2625),(50225,2625),(50226,2626),(50227,2626),(50228,2627),(50229,2627),(50230,2628),(50231,2628),(50232,2629),(50233,2629),(50234,2630),(50235,2630),(50236,2631),(50237,2631),(50238,2632),(50239,2632),(50240,2633),(50241,2633),(50242,2634),(50243,2634),(50244,2635),(50245,2635),(50246,2636),(50247,2636),(50248,2637),(50249,2637),(50250,2638),(50251,2638),(50252,2639),(50253,2639),(50254,2640),(50255,2640),(50256,2641),(50257,2641),(50258,2642),(50259,2642),(50260,2643),(50261,2643),(50262,2644),(50263,2644),(50264,2645),(50265,2645),(50266,2646),(50267,2646),(50268,2647),(50269,2647),(50270,2648),(50271,2648),(50272,2649),(50273,2649),(50274,2650),(50275,2650),(50276,2651),(50277,2651),(50278,2652),(50279,2652),(50280,2653),(50281,2653),(50282,2654),(50283,2654),(50284,2655),(50285,2655),(50286,2656),(50287,2656),(50288,2657),(50289,2657),(50290,2658),(50291,2658),(50292,2659),(50293,2659),(50294,2660),(50295,2660),(50296,2661),(50297,2661),(50298,2662),(50299,2662),(50300,2663),(50301,2663),(50302,2664),(50303,2664),(50304,2665),(50305,2665),(50306,2666),(50307,2666),(50308,2667),(50309,2667),(50310,2668),(50311,2668),(50312,2669),(50313,2669),(50314,2670),(50315,2670),(50316,2671),(50317,2671),(50318,2672),(50319,2672),(50320,2673),(50321,2673),(50322,2674),(50323,2674),(50324,2675),(50325,2675),(50326,2676),(50327,2676),(50328,2677),(50329,2677),(50330,2678),(50331,2678),(50332,2679),(50333,2679),(50334,2680),(50335,2680),(50336,2681),(50337,2681),(50338,2682),(50339,2682),(50340,2683),(50341,2683),(50342,2684),(50343,2684),(50344,2685),(50345,2685),(50346,2686),(50347,2686),(50348,2687),(50349,2687),(50350,2688),(50351,2688),(50352,2689),(50353,2689),(50354,2690),(50355,2690),(50356,2691),(50357,2691),(50358,2692),(50359,2692),(50360,2693),(50361,2693),(50362,2694),(50363,2694),(50364,2695),(50365,2695),(50366,2696),(50367,2696),(50368,2697),(50369,2697),(50370,2698),(50371,2698),(50372,2699),(50373,2699),(50374,2700),(50375,2700),(50376,2701),(50377,2701),(50378,2701),(50379,2702),(50380,2702),(50381,2702),(50382,2703),(50383,2703),(50384,2704),(50385,2704),(50386,2705),(50387,2705),(50388,2706),(50389,2706),(50390,2707),(50391,2707),(50392,2708),(50393,2708),(50394,2709),(50395,2709),(50396,2710),(50397,2710),(50398,2711),(50399,2711),(50400,2712),(50401,2712),(50402,2713),(50403,2713),(50404,2714),(50405,2714),(50406,2715),(50407,2715),(50408,2716),(50409,2716),(50410,2717),(50411,2717),(50412,2718),(50413,2718),(50414,2719),(50415,2719),(50416,2720),(50417,2720),(50418,2721),(50419,2721),(50420,2622),(50421,2622),(50422,2622),(50423,2623),(50424,2623),(50425,2623),(50426,2624),(50427,2624),(50428,2624),(50429,2625),(50430,2625),(50431,2625),(50432,2626),(50433,2626),(50434,2626),(50435,2627),(50436,2627),(50437,2627),(50438,2628),(50439,2628),(50440,2628),(50441,2629),(50442,2629),(50443,2629),(50444,2630),(50445,2630),(50446,2630),(50447,2631),(50448,2631),(50449,2631),(50450,2632),(50451,2632),(50452,2632),(50453,2633),(50454,2633),(50455,2633),(50456,2634),(50457,2634),(50458,2634),(50459,2635),(50460,2635),(50461,2635),(50462,2636),(50463,2636),(50464,2636),(50465,2637),(50466,2637),(50467,2637),(50468,2638),(50469,2638),(50470,2638),(50471,2639),(50472,2639),(50473,2639),(50474,2640),(50475,2640),(50476,2640),(50477,2641),(50478,2641),(50479,2641),(50480,2642),(50481,2642),(50482,2642),(50483,2643),(50484,2643),(50485,2643),(50486,2644),(50487,2644),(50488,2644),(50489,2645),(50490,2645),(50491,2645),(50492,2646),(50493,2646),(50494,2646),(50495,2647),(50496,2647),(50497,2647),(50498,2648),(50499,2648),(50500,2648),(50501,2649),(50502,2649),(50503,2649),(50504,2650),(50505,2650),(50506,2650),(50507,2651),(50508,2651),(50509,2651),(50510,2652),(50511,2652),(50512,2652),(50513,2653),(50514,2653),(50515,2653),(50516,2654),(50517,2654),(50518,2654),(50519,2655),(50520,2655),(50521,2655),(50522,2656),(50523,2656),(50524,2656),(50525,2657),(50526,2657),(50527,2657),(50528,2658),(50529,2658),(50530,2658),(50531,2659),(50532,2659),(50533,2659),(50534,2660),(50535,2660),(50536,2660),(50537,2661),(50538,2661),(50539,2661),(50540,2662),(50541,2662),(50542,2662),(50543,2663),(50544,2663),(50545,2663),(50546,2664),(50547,2664),(50548,2664),(50549,2665),(50550,2665),(50551,2665),(50552,2666),(50553,2666),(50554,2666),(50555,2667),(50556,2667),(50557,2667),(50558,2668),(50559,2668),(50560,2668),(50561,2669),(50562,2669),(50563,2669),(50564,2670),(50565,2670),(50566,2670),(50567,2671),(50568,2671),(50569,2671),(50570,2672),(50571,2672),(50572,2672),(50573,2673),(50574,2673),(50575,2673),(50576,2674),(50577,2674),(50578,2674),(50579,2675),(50580,2675),(50581,2675),(50582,2676),(50583,2676),(50584,2676),(50585,2677),(50586,2677),(50587,2677),(50588,2678),(50589,2678),(50590,2678),(50591,2679),(50592,2679),(50593,2679),(50594,2680),(50595,2680),(50596,2680),(50597,2681),(50598,2681),(50599,2681),(50600,2682),(50601,2682),(50602,2682),(50603,2683),(50604,2683),(50605,2683),(50606,2684),(50607,2684),(50608,2684),(50609,2685),(50610,2685),(50611,2685),(50612,2686),(50613,2686),(50614,2686),(50615,2687),(50616,2687),(50617,2687),(50618,2688),(50619,2688),(50620,2688),(50621,2689),(50622,2689),(50623,2689),(50624,2690),(50625,2690),(50626,2690),(50627,2691),(50628,2691),(50629,2691),(50630,2692),(50631,2692),(50632,2692),(50633,2693),(50634,2693),(50635,2693),(50636,2694),(50637,2694),(50638,2694),(50639,2695),(50640,2695),(50641,2695),(50642,2696),(50643,2696),(50644,2696),(50645,2697),(50646,2697),(50647,2697),(50648,2698),(50649,2698),(50650,2698),(50651,2699),(50652,2699),(50653,2699),(50654,2700),(50655,2700),(50656,2700),(50657,2701),(50658,2701),(50659,2701),(50660,2702),(50661,2702),(50662,2702),(50663,2703),(50664,2703),(50665,2703),(50666,2704),(50667,2704),(50668,2704),(50669,2705),(50670,2705),(50671,2705),(50672,2706),(50673,2706),(50674,2706),(50675,2707),(50676,2707),(50677,2708),(50678,2708),(50679,2708),(50680,2709),(50681,2709),(50682,2709),(50683,2710),(50684,2710),(50685,2710),(50686,2711),(50687,2711),(50688,2711),(50689,2712),(50690,2712),(50691,2712),(50692,2713),(50693,2713),(50694,2713),(50695,2714),(50696,2714),(50697,2714),(50698,2715),(50699,2715),(50700,2715),(50701,2716),(50702,2716),(50703,2716),(50704,2717),(50705,2717),(50706,2717),(50707,2718),(50708,2718),(50709,2718),(50710,2719),(50711,2719),(50712,2719),(50713,2720),(50714,2720),(50715,2720),(50716,2721),(50717,2721),(50718,2721),(50719,2622),(50720,2622),(50721,2622),(50722,2622),(50723,2623),(50724,2623),(50725,2623),(50726,2623),(50727,2624),(50728,2624),(50729,2624),(50730,2624),(50731,2625),(50732,2625),(50733,2625),(50734,2625),(50735,2626),(50736,2626),(50737,2626),(50738,2626),(50739,2627),(50740,2627),(50741,2627),(50742,2627),(50743,2628),(50744,2628),(50745,2628),(50746,2628),(50747,2629),(50748,2629),(50749,2629),(50750,2629),(50751,2630),(50752,2630),(50753,2630),(50754,2630),(50755,2631),(50756,2631),(50757,2631),(50758,2631),(50759,2632),(50760,2632),(50761,2632),(50762,2632),(50763,2633),(50764,2633),(50765,2633),(50766,2633),(50767,2634),(50768,2634),(50769,2634),(50770,2634),(50771,2635),(50772,2635),(50773,2635),(50774,2635),(50775,2636),(50776,2636),(50777,2636),(50778,2636),(50779,2637),(50780,2637),(50781,2637),(50782,2637),(50783,2638),(50784,2638),(50785,2638),(50786,2638),(50787,2639),(50788,2639),(50789,2639),(50790,2639),(50791,2640),(50792,2640),(50793,2640),(50794,2640),(50795,2641),(50796,2641),(50797,2641),(50798,2641),(50799,2642),(50800,2642),(50801,2642),(50802,2642),(50803,2643),(50804,2643),(50805,2643),(50806,2643),(50807,2644),(50808,2644),(50809,2644),(50810,2644),(50811,2645),(50812,2645),(50813,2645),(50814,2645),(50815,2646),(50816,2646),(50817,2646),(50818,2646),(50819,2647),(50820,2647),(50821,2647),(50822,2647),(50823,2648),(50824,2648),(50825,2648),(50826,2648),(50827,2649),(50828,2649),(50829,2649),(50830,2649),(50831,2650),(50832,2650),(50833,2650),(50834,2650),(50835,2651),(50836,2651),(50837,2651),(50838,2651),(50839,2652),(50840,2652),(50841,2652),(50842,2652),(50843,2653),(50844,2653),(50845,2653),(50846,2653),(50847,2654),(50848,2654),(50849,2654),(50850,2654),(50851,2655),(50852,2655),(50853,2655),(50854,2655),(50855,2656),(50856,2656),(50857,2656),(50858,2656),(50859,2657),(50860,2657),(50861,2657),(50862,2657),(50863,2658),(50864,2658),(50865,2658),(50866,2658),(50867,2659),(50868,2659),(50869,2659),(50870,2659),(50871,2660),(50872,2660),(50873,2660),(50874,2660),(50875,2661),(50876,2661),(50877,2661),(50878,2661),(50879,2662),(50880,2662),(50881,2662),(50882,2662),(50883,2663),(50884,2663),(50885,2663),(50886,2663),(50887,2664),(50888,2664),(50889,2664),(50890,2664),(50891,2665),(50892,2665),(50893,2665),(50894,2665),(50895,2666),(50896,2666),(50897,2666),(50898,2666),(50899,2667),(50900,2667),(50901,2667),(50902,2667),(50903,2668),(50904,2668),(50905,2668),(50906,2668),(50907,2669),(50908,2669),(50909,2669),(50910,2669),(50911,2670),(50912,2670),(50913,2670),(50914,2670),(50915,2671),(50916,2671),(50917,2671),(50918,2671),(50919,2672),(50920,2672),(50921,2672),(50922,2672),(50923,2673),(50924,2673),(50925,2673),(50926,2673),(50927,2674),(50928,2674),(50929,2674),(50930,2674),(50931,2675),(50932,2675),(50933,2675),(50934,2675),(50935,2676),(50936,2676),(50937,2676),(50938,2676),(50939,2677),(50940,2677),(50941,2677),(50942,2677),(50943,2678),(50944,2678),(50945,2678),(50946,2678),(50947,2679),(50948,2679),(50949,2679),(50950,2679),(50951,2680),(50952,2680),(50953,2680),(50954,2680),(50955,2681),(50956,2681),(50957,2681),(50958,2681),(50959,2682),(50960,2682),(50961,2682),(50962,2682),(50963,2683),(50964,2683),(50965,2683),(50966,2683),(50967,2684),(50968,2684),(50969,2684),(50970,2684),(50971,2685),(50972,2685),(50973,2685),(50974,2685),(50975,2686),(50976,2686),(50977,2686),(50978,2686),(50979,2687),(50980,2687),(50981,2687),(50982,2687),(50983,2688),(50984,2688),(50985,2688),(50986,2688),(50987,2689),(50988,2689),(50989,2689),(50990,2689),(50991,2690),(50992,2690),(50993,2690),(50994,2690),(50995,2691),(50996,2691),(50997,2691),(50998,2691),(50999,2692),(51000,2692),(51001,2692),(51002,2692),(51003,2693),(51004,2693),(51005,2693),(51006,2693),(51007,2694),(51008,2694),(51009,2694),(51010,2694),(51011,2695),(51012,2695),(51013,2695),(51014,2695),(51015,2696),(51016,2696),(51017,2696),(51018,2696),(51019,2697),(51020,2697),(51021,2697),(51022,2697),(51023,2698),(51024,2698),(51025,2698),(51026,2698),(51027,2699),(51028,2699),(51029,2699),(51030,2699),(51031,2700),(51032,2700),(51033,2700),(51034,2700),(51035,2701),(51036,2701),(51037,2701),(51038,2701),(51039,2702),(51040,2702),(51041,2702),(51042,2702),(51043,2703),(51044,2703),(51045,2703),(51046,2703),(51047,2704),(51048,2704),(51049,2704),(51050,2704),(51051,2705),(51052,2705),(51053,2705),(51054,2705),(51055,2706),(51056,2706),(51057,2706),(51058,2706),(51059,2707),(51060,2707),(51061,2707),(51062,2707),(51063,2708),(51064,2708),(51065,2708),(51066,2708),(51067,2709),(51068,2709),(51069,2709),(51070,2709),(51071,2710),(51072,2710),(51073,2710),(51074,2710),(51075,2711),(51076,2711),(51077,2711),(51078,2711),(51079,2712),(51080,2712),(51081,2712),(51082,2712),(51083,2713),(51084,2713),(51085,2713),(51086,2713),(51087,2714),(51088,2714),(51089,2714),(51090,2714),(51091,2715),(51092,2715),(51093,2715),(51094,2715),(51095,2716),(51096,2716),(51097,2716),(51098,2716),(51099,2717),(51100,2717),(51101,2717),(51102,2717),(51103,2718),(51104,2718),(51105,2718),(51106,2718),(51107,2719),(51108,2719),(51109,2719),(51110,2719),(51111,2720),(51112,2720),(51113,2720),(51114,2720),(51115,2721),(51116,2721),(51117,2721),(51118,2721),(51119,2722),(51120,2723),(51121,2724),(51122,2725),(51123,2726),(51124,2727),(51125,2728),(51126,2729),(51127,2730),(51128,2731),(51129,2732),(51130,2733),(51131,2734),(51132,2735),(51133,2736),(51134,2737),(51135,2738),(51136,2739),(51137,2740),(51138,2741),(51139,2742),(51140,2743),(51141,2744),(51142,2745),(51143,2746),(51144,2747),(51145,2748),(51146,2749),(51147,2750),(51148,2751),(51149,2752),(51150,2753),(51151,2754),(51152,2755),(51153,2756),(51154,2757),(51155,2758),(51156,2759),(51157,2760),(51158,2761),(51159,2762),(51160,2763),(51161,2764),(51162,2765),(51163,2766),(51164,2767),(51165,2768),(51166,2769),(51167,2770),(51168,2771),(51169,2772),(51170,2773),(51171,2774),(51172,2775),(51173,2776),(51174,2777),(51175,2778),(51176,2779),(51177,2780),(51178,2781),(51179,2782),(51180,2783),(51181,2784),(51182,2785),(51183,2786),(51184,2787),(51185,2788),(51186,2789),(51187,2790),(51188,2791),(51189,2792),(51190,2793),(51191,2794),(51192,2795),(51193,2796),(51194,2797),(51195,2798),(51196,2799),(51197,2800),(51198,2801),(51199,2802),(51200,2803),(51201,2804),(51202,2805),(51203,2806),(51204,2807),(51205,2808),(51206,2809),(51207,2810),(51208,2811),(51209,2812),(51210,2813),(51211,2814),(51212,2815),(51213,2816),(51214,2817),(51215,2818),(51216,2819),(51217,2820),(51218,2821),(51219,2722),(51220,2723),(51221,2724),(51222,2725),(51223,2726),(51224,2727),(51225,2728),(51226,2729),(51227,2730),(51228,2731),(51229,2732),(51230,2733),(51231,2734),(51232,2735),(51233,2736),(51234,2737),(51235,2738),(51236,2739),(51237,2740),(51238,2741),(51239,2742),(51240,2743),(51241,2744),(51242,2745),(51243,2746),(51244,2747),(51245,2748),(51246,2749),(51247,2750),(51248,2751),(51249,2752),(51250,2753),(51251,2754),(51252,2755),(51253,2756),(51254,2757),(51255,2758),(51256,2759),(51257,2760),(51258,2761),(51259,2762),(51260,2763),(51261,2764),(51262,2765),(51263,2766),(51264,2767),(51265,2768),(51266,2769),(51267,2770),(51268,2771),(51269,2772),(51270,2773),(51271,2774),(51272,2775),(51273,2776),(51274,2777),(51275,2778),(51276,2779),(51277,2780),(51278,2781),(51279,2782),(51280,2783),(51281,2784),(51282,2785),(51283,2786),(51284,2787),(51285,2788),(51286,2789),(51287,2790),(51288,2791),(51289,2792),(51290,2793),(51291,2794),(51292,2795),(51293,2796),(51294,2797),(51295,2798),(51296,2799),(51297,2800),(51298,2801),(51299,2802),(51300,2803),(51301,2804),(51302,2805),(51303,2806),(51304,2807),(51305,2808),(51306,2809),(51307,2810),(51308,2811),(51309,2812),(51310,2813),(51311,2814),(51312,2815),(51313,2816),(51314,2817),(51315,2818),(51316,2819),(51317,2820),(51318,2821),(51319,2722),(51320,2722),(51321,2722),(51322,2722),(51323,2722),(51324,2722),(51325,2723),(51326,2723),(51327,2723),(51328,2723),(51329,2723),(51330,2723),(51331,2724),(51332,2724),(51333,2724),(51334,2724),(51335,2724),(51336,2724),(51337,2725),(51338,2725),(51339,2725),(51340,2725),(51341,2725),(51342,2725),(51343,2726),(51344,2726),(51345,2726),(51346,2726),(51347,2726),(51348,2726),(51349,2727),(51350,2727),(51351,2727),(51352,2727),(51353,2727),(51354,2727),(51355,2728),(51356,2728),(51357,2728),(51358,2728),(51359,2728),(51360,2728),(51361,2729),(51362,2729),(51363,2729),(51364,2729),(51365,2729),(51366,2729),(51367,2730),(51368,2730),(51369,2730),(51370,2730),(51371,2730),(51372,2730),(51373,2731),(51374,2731),(51375,2731),(51376,2731),(51377,2731),(51378,2731),(51379,2732),(51380,2732),(51381,2732),(51382,2732),(51383,2732),(51384,2732),(51385,2733),(51386,2733),(51387,2733),(51388,2733),(51389,2733),(51390,2733),(51391,2734),(51392,2734),(51393,2734),(51394,2734),(51395,2734),(51396,2734),(51397,2735),(51398,2735),(51399,2735),(51400,2735),(51401,2735),(51402,2735),(51403,2736),(51404,2736),(51405,2736),(51406,2736),(51407,2736),(51408,2736),(51409,2737),(51410,2737),(51411,2737),(51412,2737),(51413,2737),(51414,2737),(51415,2738),(51416,2738),(51417,2738),(51418,2738),(51419,2738),(51420,2738),(51421,2739),(51422,2739),(51423,2739),(51424,2739),(51425,2739),(51426,2739),(51427,2740),(51428,2740),(51429,2740),(51430,2740),(51431,2740),(51432,2740),(51433,2741),(51434,2741),(51435,2741),(51436,2741),(51437,2741),(51438,2741),(51439,2742),(51440,2742),(51441,2742),(51442,2742),(51443,2742),(51444,2742),(51445,2743),(51446,2743),(51447,2743),(51448,2743),(51449,2743),(51450,2743),(51451,2744),(51452,2744),(51453,2744),(51454,2744),(51455,2744),(51456,2744),(51457,2745),(51458,2745),(51459,2745),(51460,2745),(51461,2745),(51462,2745),(51463,2746),(51464,2746),(51465,2746),(51466,2746),(51467,2746),(51468,2746),(51469,2747),(51470,2747),(51471,2747),(51472,2747),(51473,2747),(51474,2747),(51475,2748),(51476,2748),(51477,2748),(51478,2748),(51479,2748),(51480,2748),(51481,2749),(51482,2749),(51483,2749),(51484,2749),(51485,2749),(51486,2749),(51487,2750),(51488,2750),(51489,2750),(51490,2750),(51491,2750),(51492,2750),(51493,2751),(51494,2751),(51495,2751),(51496,2751),(51497,2751),(51498,2751),(51499,2752),(51500,2752),(51501,2752),(51502,2752),(51503,2752),(51504,2752),(51505,2753),(51506,2753),(51507,2753),(51508,2753),(51509,2753),(51510,2753),(51511,2754),(51512,2754),(51513,2754),(51514,2754),(51515,2754),(51516,2754),(51517,2755),(51518,2755),(51519,2755),(51520,2755),(51521,2755),(51522,2755),(51523,2756),(51524,2756),(51525,2756),(51526,2756),(51527,2756),(51528,2756),(51529,2757),(51530,2757),(51531,2757),(51532,2757),(51533,2757),(51534,2757),(51535,2758),(51536,2758),(51537,2758),(51538,2758),(51539,2758),(51540,2758),(51541,2759),(51542,2759),(51543,2759),(51544,2759),(51545,2759),(51546,2759),(51547,2760),(51548,2760),(51549,2760),(51550,2760),(51551,2760),(51552,2760),(51553,2761),(51554,2761),(51555,2761),(51556,2761),(51557,2761),(51558,2761),(51559,2762),(51560,2762),(51561,2762),(51562,2762),(51563,2762),(51564,2762),(51565,2763),(51566,2763),(51567,2763),(51568,2763),(51569,2763),(51570,2763),(51571,2764),(51572,2764),(51573,2764),(51574,2764),(51575,2764),(51576,2764),(51577,2765),(51578,2765),(51579,2765),(51580,2765),(51581,2765),(51582,2765),(51583,2766),(51584,2766),(51585,2766),(51586,2766),(51587,2766),(51588,2766),(51589,2767),(51590,2767),(51591,2767),(51592,2767),(51593,2767),(51594,2767),(51595,2768),(51596,2768),(51597,2768),(51598,2768),(51599,2768),(51600,2768),(51601,2769),(51602,2769),(51603,2769),(51604,2769),(51605,2769),(51606,2769),(51607,2770),(51608,2770),(51609,2770),(51610,2770),(51611,2770),(51612,2770),(51613,2771),(51614,2771),(51615,2771),(51616,2771),(51617,2771),(51618,2771),(51619,2772),(51620,2772),(51621,2772),(51622,2772),(51623,2772),(51624,2772),(51625,2773),(51626,2773),(51627,2773),(51628,2773),(51629,2773),(51630,2773),(51631,2774),(51632,2774),(51633,2774),(51634,2774),(51635,2775),(51636,2775),(51637,2775),(51638,2775),(51639,2776),(51640,2776),(51641,2776),(51642,2776),(51643,2777),(51644,2777),(51645,2777),(51646,2777),(51647,2778),(51648,2778),(51649,2778),(51650,2778),(51651,2779),(51652,2779),(51653,2779),(51654,2779),(51655,2780),(51656,2780),(51657,2780),(51658,2780),(51659,2780),(51660,2780),(51661,2781),(51662,2781),(51663,2781),(51664,2781),(51665,2781),(51666,2781),(51667,2782),(51668,2782),(51669,2782),(51670,2782),(51671,2782),(51672,2782),(51673,2783),(51674,2783),(51675,2783),(51676,2783),(51677,2784),(51678,2784),(51679,2784),(51680,2784),(51681,2785),(51682,2785),(51683,2785),(51684,2785),(51685,2786),(51686,2786),(51687,2786),(51688,2786),(51689,2787),(51690,2787),(51691,2787),(51692,2787),(51693,2788),(51694,2788),(51695,2788),(51696,2788),(51697,2789),(51698,2789),(51699,2789),(51700,2789),(51701,2790),(51702,2790),(51703,2790),(51704,2790),(51705,2791),(51706,2791),(51707,2791),(51708,2791),(51709,2792),(51710,2792),(51711,2792),(51712,2792),(51713,2793),(51714,2793),(51715,2793),(51716,2793),(51717,2793),(51718,2793),(51719,2794),(51720,2794),(51721,2794),(51722,2794),(51723,2794),(51724,2794),(51725,2795),(51726,2795),(51727,2795),(51728,2795),(51729,2795),(51730,2795),(51731,2796),(51732,2796),(51733,2796),(51734,2796),(51735,2796),(51736,2796),(51737,2797),(51738,2797),(51739,2797),(51740,2797),(51741,2797),(51742,2797),(51743,2798),(51744,2798),(51745,2798),(51746,2798),(51747,2798),(51748,2798),(51749,2799),(51750,2799),(51751,2799),(51752,2799),(51753,2799),(51754,2799),(51755,2800),(51756,2800),(51757,2800),(51758,2800),(51759,2800),(51760,2800),(51761,2801),(51762,2801),(51763,2801),(51764,2801),(51765,2801),(51766,2801),(51767,2802),(51768,2802),(51769,2802),(51770,2802),(51771,2802),(51772,2802),(51773,2803),(51774,2803),(51775,2803),(51776,2803),(51777,2803),(51778,2803),(51779,2804),(51780,2804),(51781,2804),(51782,2804),(51783,2804),(51784,2804),(51785,2805),(51786,2805),(51787,2805),(51788,2805),(51789,2805),(51790,2805),(51791,2806),(51792,2806),(51793,2806),(51794,2806),(51795,2806),(51796,2806),(51797,2807),(51798,2807),(51799,2807),(51800,2807),(51801,2807),(51802,2807),(51803,2808),(51804,2808),(51805,2808),(51806,2808),(51807,2808),(51808,2808),(51809,2809),(51810,2809),(51811,2809),(51812,2809),(51813,2809),(51814,2809),(51815,2810),(51816,2810),(51817,2810),(51818,2810),(51819,2810),(51820,2810),(51821,2811),(51822,2811),(51823,2811),(51824,2811),(51825,2811),(51826,2811),(51827,2812),(51828,2812),(51829,2812),(51830,2812),(51831,2812),(51832,2812),(51833,2813),(51834,2813),(51835,2813),(51836,2813),(51837,2813),(51838,2813),(51839,2814),(51840,2814),(51841,2814),(51842,2814),(51843,2814),(51844,2814),(51845,2815),(51846,2815),(51847,2815),(51848,2815),(51849,2815),(51850,2815),(51851,2816),(51852,2816),(51853,2816),(51854,2816),(51855,2816),(51856,2816),(51857,2817),(51858,2817),(51859,2817),(51860,2817),(51861,2817),(51862,2817),(51863,2818),(51864,2818),(51865,2818),(51866,2818),(51867,2818),(51868,2818),(51869,2819),(51870,2819),(51871,2819),(51872,2819),(51873,2819),(51874,2819),(51875,2820),(51876,2820),(51877,2820),(51878,2820),(51879,2820),(51880,2820),(51881,2821),(51882,2821),(51883,2821),(51884,2821),(51885,2821),(51886,2821),(51887,2722),(51888,2722),(51889,2723),(51890,2723),(51891,2724),(51892,2724),(51893,2725),(51894,2725),(51895,2726),(51896,2726),(51897,2727),(51898,2727),(51899,2728),(51900,2728),(51901,2729),(51902,2729),(51903,2730),(51904,2730),(51905,2731),(51906,2731),(51907,2732),(51908,2732),(51909,2733),(51910,2733),(51911,2734),(51912,2734),(51913,2735),(51914,2735),(51915,2736),(51916,2736),(51917,2737),(51918,2737),(51919,2738),(51920,2738),(51921,2739),(51922,2739),(51923,2740),(51924,2740),(51925,2741),(51926,2741),(51927,2742),(51928,2742),(51929,2743),(51930,2743),(51931,2744),(51932,2744),(51933,2745),(51934,2745),(51935,2746),(51936,2746),(51937,2747),(51938,2747),(51939,2748),(51940,2748),(51941,2749),(51942,2749),(51943,2750),(51944,2750),(51945,2751),(51946,2751),(51947,2752),(51948,2752),(51949,2753),(51950,2753),(51951,2754),(51952,2754),(51953,2755),(51954,2755),(51955,2756),(51956,2756),(51957,2757),(51958,2757),(51959,2758),(51960,2758),(51961,2759),(51962,2759),(51963,2760),(51964,2760),(51965,2760),(51966,2761),(51967,2761),(51968,2761),(51969,2762),(51970,2762),(51971,2762),(51972,2763),(51973,2763),(51974,2763),(51975,2764),(51976,2764),(51977,2764),(51978,2765),(51979,2765),(51980,2765),(51981,2766),(51982,2766),(51983,2767),(51984,2767),(51985,2768),(51986,2768),(51987,2769),(51988,2769),(51989,2770),(51990,2770),(51991,2771),(51992,2771),(51993,2772),(51994,2772),(51995,2772),(51996,2773),(51997,2773),(51998,2774),(51999,2774),(52000,2775),(52001,2775),(52002,2776),(52003,2776),(52004,2777),(52005,2777),(52006,2778),(52007,2778),(52008,2779),(52009,2779),(52010,2780),(52011,2780),(52012,2780),(52013,2781),(52014,2781),(52015,2782),(52016,2782),(52017,2783),(52018,2783),(52019,2784),(52020,2784),(52021,2785),(52022,2785),(52023,2786),(52024,2786),(52025,2787),(52026,2787),(52027,2788),(52028,2788),(52029,2789),(52030,2789),(52031,2790),(52032,2790),(52033,2791),(52034,2791),(52035,2792),(52036,2792),(52037,2793),(52038,2793),(52039,2794),(52040,2794),(52041,2795),(52042,2795),(52043,2796),(52044,2796),(52045,2797),(52046,2797),(52047,2798),(52048,2798),(52049,2799),(52050,2799),(52051,2799),(52052,2800),(52053,2800),(52054,2800),(52055,2801),(52056,2801),(52057,2801),(52058,2802),(52059,2802),(52060,2802),(52061,2803),(52062,2803),(52063,2803),(52064,2804),(52065,2804),(52066,2804),(52067,2805),(52068,2805),(52069,2805),(52070,2806),(52071,2806),(52072,2806),(52073,2807),(52074,2807),(52075,2807),(52076,2808),(52077,2808),(52078,2808),(52079,2809),(52080,2809),(52081,2809),(52082,2810),(52083,2810),(52084,2810),(52085,2811),(52086,2811),(52087,2811),(52088,2812),(52089,2812),(52090,2812),(52091,2813),(52092,2813),(52093,2813),(52094,2814),(52095,2814),(52096,2814),(52097,2815),(52098,2815),(52099,2815),(52100,2816),(52101,2816),(52102,2816),(52103,2817),(52104,2817),(52105,2817),(52106,2818),(52107,2818),(52108,2818),(52109,2819),(52110,2819),(52111,2819),(52112,2820),(52113,2820),(52114,2820),(52115,2821),(52116,2821),(52117,2722),(52118,2722),(52119,2722),(52120,2723),(52121,2723),(52122,2723),(52123,2724),(52124,2724),(52125,2724),(52126,2725),(52127,2725),(52128,2725),(52129,2726),(52130,2726),(52131,2726),(52132,2727),(52133,2727),(52134,2727),(52135,2728),(52136,2728),(52137,2728),(52138,2729),(52139,2729),(52140,2729),(52141,2730),(52142,2730),(52143,2730),(52144,2731),(52145,2731),(52146,2731),(52147,2732),(52148,2732),(52149,2732),(52150,2733),(52151,2733),(52152,2733),(52153,2734),(52154,2734),(52155,2734),(52156,2735),(52157,2735),(52158,2735),(52159,2736),(52160,2736),(52161,2736),(52162,2737),(52163,2737),(52164,2737),(52165,2738),(52166,2738),(52167,2738),(52168,2739),(52169,2739),(52170,2739),(52171,2740),(52172,2740),(52173,2740),(52174,2741),(52175,2741),(52176,2741),(52177,2742),(52178,2742),(52179,2742),(52180,2743),(52181,2743),(52182,2743),(52183,2744),(52184,2744),(52185,2744),(52186,2745),(52187,2745),(52188,2745),(52189,2746),(52190,2746),(52191,2746),(52192,2747),(52193,2747),(52194,2747),(52195,2748),(52196,2748),(52197,2748),(52198,2749),(52199,2749),(52200,2749),(52201,2750),(52202,2750),(52203,2750),(52204,2751),(52205,2751),(52206,2751),(52207,2752),(52208,2752),(52209,2752),(52210,2753),(52211,2753),(52212,2753),(52213,2754),(52214,2754),(52215,2754),(52216,2755),(52217,2755),(52218,2755),(52219,2756),(52220,2756),(52221,2756),(52222,2757),(52223,2757),(52224,2757),(52225,2758),(52226,2758),(52227,2758),(52228,2759),(52229,2759),(52230,2759),(52231,2760),(52232,2760),(52233,2760),(52234,2761),(52235,2761),(52236,2761),(52237,2762),(52238,2762),(52239,2762),(52240,2763),(52241,2763),(52242,2763),(52243,2764),(52244,2764),(52245,2764),(52246,2765),(52247,2765),(52248,2765),(52249,2766),(52250,2766),(52251,2766),(52252,2767),(52253,2767),(52254,2767),(52255,2768),(52256,2768),(52257,2768),(52258,2769),(52259,2769),(52260,2769),(52261,2770),(52262,2770),(52263,2770),(52264,2771),(52265,2771),(52266,2771),(52267,2772),(52268,2772),(52269,2772),(52270,2773),(52271,2773),(52272,2773),(52273,2774),(52274,2774),(52275,2774),(52276,2775),(52277,2775),(52278,2775),(52279,2776),(52280,2776),(52281,2776),(52282,2777),(52283,2777),(52284,2777),(52285,2778),(52286,2778),(52287,2778),(52288,2779),(52289,2779),(52290,2779),(52291,2780),(52292,2780),(52293,2780),(52294,2781),(52295,2781),(52296,2781),(52297,2782),(52298,2782),(52299,2782),(52300,2783),(52301,2783),(52302,2783),(52303,2784),(52304,2784),(52305,2784),(52306,2785),(52307,2785),(52308,2785),(52309,2786),(52310,2786),(52311,2786),(52312,2787),(52313,2787),(52314,2787),(52315,2788),(52316,2788),(52317,2788),(52318,2789),(52319,2789),(52320,2789),(52321,2790),(52322,2790),(52323,2790),(52324,2791),(52325,2791),(52326,2791),(52327,2792),(52328,2792),(52329,2792),(52330,2793),(52331,2793),(52332,2793),(52333,2794),(52334,2794),(52335,2794),(52336,2795),(52337,2795),(52338,2795),(52339,2796),(52340,2796),(52341,2796),(52342,2797),(52343,2797),(52344,2797),(52345,2798),(52346,2798),(52347,2798),(52348,2799),(52349,2799),(52350,2799),(52351,2800),(52352,2800),(52353,2800),(52354,2801),(52355,2801),(52356,2801),(52357,2802),(52358,2802),(52359,2802),(52360,2803),(52361,2803),(52362,2803),(52363,2804),(52364,2804),(52365,2804),(52366,2805),(52367,2805),(52368,2805),(52369,2806),(52370,2806),(52371,2806),(52372,2807),(52373,2807),(52374,2807),(52375,2808),(52376,2808),(52377,2808),(52378,2809),(52379,2809),(52380,2809),(52381,2810),(52382,2810),(52383,2810),(52384,2811),(52385,2811),(52386,2811),(52387,2812),(52388,2812),(52389,2812),(52390,2813),(52391,2813),(52392,2813),(52393,2814),(52394,2814),(52395,2814),(52396,2815),(52397,2815),(52398,2815),(52399,2816),(52400,2816),(52401,2816),(52402,2817),(52403,2817),(52404,2817),(52405,2818),(52406,2818),(52407,2818),(52408,2819),(52409,2819),(52410,2819),(52411,2820),(52412,2820),(52413,2820),(52414,2821),(52415,2821),(52416,2821),(52417,2722),(52418,2722),(52419,2722),(52420,2722),(52421,2723),(52422,2723),(52423,2723),(52424,2723),(52425,2724),(52426,2724),(52427,2724),(52428,2724),(52429,2725),(52430,2725),(52431,2725),(52432,2725),(52433,2726),(52434,2726),(52435,2726),(52436,2726),(52437,2727),(52438,2727),(52439,2727),(52440,2727),(52441,2728),(52442,2728),(52443,2728),(52444,2728),(52445,2729),(52446,2729),(52447,2729),(52448,2729),(52449,2730),(52450,2730),(52451,2730),(52452,2730),(52453,2731),(52454,2731),(52455,2731),(52456,2731),(52457,2732),(52458,2732),(52459,2732),(52460,2732),(52461,2733),(52462,2733),(52463,2733),(52464,2733),(52465,2734),(52466,2734),(52467,2734),(52468,2734),(52469,2735),(52470,2735),(52471,2735),(52472,2735),(52473,2736),(52474,2736),(52475,2736),(52476,2736),(52477,2737),(52478,2737),(52479,2737),(52480,2737),(52481,2738),(52482,2738),(52483,2738),(52484,2738),(52485,2739),(52486,2739),(52487,2739),(52488,2739),(52489,2740),(52490,2740),(52491,2740),(52492,2740),(52493,2741),(52494,2741),(52495,2741),(52496,2741),(52497,2742),(52498,2742),(52499,2742),(52500,2742),(52501,2743),(52502,2743),(52503,2743),(52504,2743),(52505,2744),(52506,2744),(52507,2744),(52508,2744),(52509,2745),(52510,2745),(52511,2745),(52512,2745),(52513,2746),(52514,2746),(52515,2746),(52516,2746),(52517,2747),(52518,2747),(52519,2747),(52520,2747),(52521,2748),(52522,2748),(52523,2748),(52524,2748),(52525,2749),(52526,2749),(52527,2749),(52528,2749),(52529,2750),(52530,2750),(52531,2750),(52532,2750),(52533,2751),(52534,2751),(52535,2751),(52536,2751),(52537,2752),(52538,2752),(52539,2752),(52540,2752),(52541,2753),(52542,2753),(52543,2753),(52544,2753),(52545,2754),(52546,2754),(52547,2754),(52548,2754),(52549,2755),(52550,2755),(52551,2755),(52552,2755),(52553,2756),(52554,2756),(52555,2756),(52556,2756),(52557,2757),(52558,2757),(52559,2757),(52560,2757),(52561,2758),(52562,2758),(52563,2758),(52564,2758),(52565,2759),(52566,2759),(52567,2759),(52568,2759),(52569,2760),(52570,2760),(52571,2760),(52572,2760),(52573,2761),(52574,2761),(52575,2761),(52576,2761),(52577,2762),(52578,2762),(52579,2762),(52580,2762),(52581,2763),(52582,2763),(52583,2763),(52584,2763),(52585,2764),(52586,2764),(52587,2764),(52588,2764),(52589,2765),(52590,2765),(52591,2765),(52592,2765),(52593,2766),(52594,2766),(52595,2766),(52596,2766),(52597,2767),(52598,2767),(52599,2767),(52600,2767),(52601,2768),(52602,2768),(52603,2768),(52604,2768),(52605,2769),(52606,2769),(52607,2769),(52608,2769),(52609,2770),(52610,2770),(52611,2770),(52612,2770),(52613,2771),(52614,2771),(52615,2771),(52616,2771),(52617,2772),(52618,2772),(52619,2772),(52620,2772),(52621,2773),(52622,2773),(52623,2773),(52624,2773),(52625,2774),(52626,2774),(52627,2774),(52628,2774),(52629,2775),(52630,2775),(52631,2775),(52632,2775),(52633,2776),(52634,2776),(52635,2776),(52636,2776),(52637,2777),(52638,2777),(52639,2777),(52640,2777),(52641,2778),(52642,2778),(52643,2778),(52644,2778),(52645,2779),(52646,2779),(52647,2779),(52648,2779),(52649,2780),(52650,2780),(52651,2780),(52652,2780),(52653,2781),(52654,2781),(52655,2781),(52656,2781),(52657,2782),(52658,2782),(52659,2782),(52660,2782),(52661,2783),(52662,2783),(52663,2783),(52664,2783),(52665,2784),(52666,2784),(52667,2784),(52668,2784),(52669,2785),(52670,2785),(52671,2785),(52672,2785),(52673,2786),(52674,2786),(52675,2786),(52676,2786),(52677,2787),(52678,2787),(52679,2787),(52680,2787),(52681,2788),(52682,2788),(52683,2788),(52684,2788),(52685,2789),(52686,2789),(52687,2789),(52688,2789),(52689,2790),(52690,2790),(52691,2790),(52692,2790),(52693,2791),(52694,2791),(52695,2791),(52696,2791),(52697,2792),(52698,2792),(52699,2792),(52700,2792),(52701,2793),(52702,2793),(52703,2793),(52704,2793),(52705,2794),(52706,2794),(52707,2794),(52708,2794),(52709,2795),(52710,2795),(52711,2795),(52712,2795),(52713,2796),(52714,2796),(52715,2796),(52716,2796),(52717,2797),(52718,2797),(52719,2797),(52720,2797),(52721,2798),(52722,2798),(52723,2798),(52724,2798),(52725,2799),(52726,2799),(52727,2799),(52728,2799),(52729,2800),(52730,2800),(52731,2800),(52732,2800),(52733,2801),(52734,2801),(52735,2801),(52736,2801),(52737,2802),(52738,2802),(52739,2802),(52740,2802),(52741,2803),(52742,2803),(52743,2803),(52744,2803),(52745,2804),(52746,2804),(52747,2804),(52748,2804),(52749,2805),(52750,2805),(52751,2805),(52752,2805),(52753,2806),(52754,2806),(52755,2806),(52756,2806),(52757,2807),(52758,2807),(52759,2807),(52760,2807),(52761,2808),(52762,2808),(52763,2808),(52764,2808),(52765,2809),(52766,2809),(52767,2809),(52768,2809),(52769,2810),(52770,2810),(52771,2810),(52772,2810),(52773,2811),(52774,2811),(52775,2811),(52776,2811),(52777,2812),(52778,2812),(52779,2812),(52780,2812),(52781,2813),(52782,2813),(52783,2813),(52784,2813),(52785,2814),(52786,2814),(52787,2814),(52788,2814),(52789,2815),(52790,2815),(52791,2815),(52792,2815),(52793,2816),(52794,2816),(52795,2816),(52796,2816),(52797,2817),(52798,2817),(52799,2817),(52800,2817),(52801,2818),(52802,2818),(52803,2818),(52804,2818),(52805,2819),(52806,2819),(52807,2819),(52808,2819),(52809,2820),(52810,2820),(52811,2820),(52812,2820),(52813,2821),(52814,2821),(52815,2821),(52816,2821),(52817,2822),(52818,2823),(52819,2824),(52820,2825),(52821,2826),(52822,2827),(52823,2828),(52824,2829),(52825,2830),(52826,2831),(52827,2832),(52828,2833),(52829,2834),(52830,2835),(52831,2836),(52832,2837),(52833,2838),(52834,2839),(52835,2840),(52836,2841),(52837,2842),(52838,2843),(52839,2844),(52840,2845),(52841,2846),(52842,2847),(52843,2848),(52844,2849),(52845,2850),(52846,2851),(52847,2852),(52848,2853),(52849,2854),(52850,2855),(52851,2856),(52852,2857),(52853,2858),(52854,2859),(52855,2860),(52856,2861),(52857,2862),(52858,2863),(52859,2864),(52860,2865),(52861,2866),(52862,2867),(52863,2868),(52864,2869),(52865,2870),(52866,2871),(52867,2872),(52868,2873),(52869,2874),(52870,2875),(52871,2876),(52872,2877),(52873,2878),(52874,2879),(52875,2880),(52876,2881),(52877,2882),(52878,2883),(52879,2884),(52880,2885),(52881,2886),(52882,2887),(52883,2888),(52884,2889),(52885,2890),(52886,2891),(52887,2892),(52888,2893),(52889,2894),(52890,2895),(52891,2896),(52892,2897),(52893,2898),(52894,2899),(52895,2900),(52896,2901),(52897,2902),(52898,2903),(52899,2904),(52900,2905),(52901,2906),(52902,2907),(52903,2908),(52904,2909),(52905,2910),(52906,2911),(52907,2912),(52908,2913),(52909,2914),(52910,2915),(52911,2916),(52912,2917),(52913,2918),(52914,2919),(52915,2920),(52916,2921),(52917,2822),(52918,2823),(52919,2824),(52920,2825),(52921,2826),(52922,2827),(52923,2828),(52924,2829),(52925,2830),(52926,2831),(52927,2832),(52928,2833),(52929,2834),(52930,2835),(52931,2836),(52932,2837),(52933,2838),(52934,2839),(52935,2840),(52936,2841),(52937,2842),(52938,2843),(52939,2844),(52940,2845),(52941,2846),(52942,2847),(52943,2848),(52944,2849),(52945,2850),(52946,2851),(52947,2852),(52948,2853),(52949,2854),(52950,2855),(52951,2856),(52952,2857),(52953,2858),(52954,2859),(52955,2860),(52956,2861),(52957,2862),(52958,2863),(52959,2864),(52960,2865),(52961,2866),(52962,2867),(52963,2868),(52964,2869),(52965,2870),(52966,2871),(52967,2872),(52968,2873),(52969,2874),(52970,2875),(52971,2876),(52972,2877),(52973,2878),(52974,2879),(52975,2880),(52976,2881),(52977,2882),(52978,2883),(52979,2884),(52980,2885),(52981,2886),(52982,2887),(52983,2888),(52984,2889),(52985,2890),(52986,2891),(52987,2892),(52988,2893),(52989,2894),(52990,2895),(52991,2896),(52992,2897),(52993,2898),(52994,2899),(52995,2900),(52996,2901),(52997,2902),(52998,2903),(52999,2904),(53000,2905),(53001,2906),(53002,2907),(53003,2908),(53004,2909),(53005,2910),(53006,2911),(53007,2912),(53008,2913),(53009,2914),(53010,2915),(53011,2916),(53012,2917),(53013,2918),(53014,2919),(53015,2920),(53016,2921),(53017,2822),(53018,2822),(53019,2822),(53020,2822),(53021,2823),(53022,2823),(53023,2823),(53024,2823),(53025,2824),(53026,2824),(53027,2824),(53028,2824),(53029,2825),(53030,2825),(53031,2825),(53032,2825),(53033,2826),(53034,2826),(53035,2826),(53036,2826),(53037,2827),(53038,2827),(53039,2827),(53040,2827),(53041,2828),(53042,2828),(53043,2828),(53044,2828),(53045,2828),(53046,2828),(53047,2829),(53048,2829),(53049,2829),(53050,2829),(53051,2829),(53052,2829),(53053,2830),(53054,2830),(53055,2830),(53056,2830),(53057,2830),(53058,2830),(53059,2831),(53060,2831),(53061,2831),(53062,2831),(53063,2832),(53064,2832),(53065,2832),(53066,2832),(53067,2833),(53068,2833),(53069,2833),(53070,2833),(53071,2833),(53072,2833),(53073,2834),(53074,2834),(53075,2834),(53076,2834),(53077,2834),(53078,2834),(53079,2835),(53080,2835),(53081,2835),(53082,2835),(53083,2835),(53084,2835),(53085,2836),(53086,2836),(53087,2836),(53088,2836),(53089,2836),(53090,2836),(53091,2837),(53092,2837),(53093,2837),(53094,2837),(53095,2837),(53096,2837),(53097,2838),(53098,2838),(53099,2838),(53100,2838),(53101,2838),(53102,2838),(53103,2839),(53104,2839),(53105,2839),(53106,2839),(53107,2839),(53108,2839),(53109,2840),(53110,2840),(53111,2840),(53112,2840),(53113,2840),(53114,2840),(53115,2841),(53116,2841),(53117,2841),(53118,2841),(53119,2841),(53120,2841),(53121,2842),(53122,2842),(53123,2842),(53124,2842),(53125,2842),(53126,2842),(53127,2843),(53128,2843),(53129,2843),(53130,2843),(53131,2843),(53132,2843),(53133,2844),(53134,2844),(53135,2844),(53136,2844),(53137,2845),(53138,2845),(53139,2845),(53140,2845),(53141,2846),(53142,2846),(53143,2846),(53144,2846),(53145,2847),(53146,2847),(53147,2847),(53148,2847),(53149,2848),(53150,2848),(53151,2848),(53152,2848),(53153,2849),(53154,2849),(53155,2849),(53156,2849),(53157,2850),(53158,2850),(53159,2850),(53160,2850),(53161,2851),(53162,2851),(53163,2851),(53164,2851),(53165,2852),(53166,2852),(53167,2852),(53168,2852),(53169,2852),(53170,2852),(53171,2853),(53172,2853),(53173,2853),(53174,2853),(53175,2853),(53176,2853),(53177,2854),(53178,2854),(53179,2854),(53180,2854),(53181,2854),(53182,2854),(53183,2855),(53184,2855),(53185,2855),(53186,2855),(53187,2855),(53188,2855),(53189,2856),(53190,2856),(53191,2856),(53192,2856),(53193,2856),(53194,2856),(53195,2857),(53196,2857),(53197,2857),(53198,2857),(53199,2857),(53200,2857),(53201,2858),(53202,2858),(53203,2858),(53204,2858),(53205,2858),(53206,2858),(53207,2859),(53208,2859),(53209,2859),(53210,2859),(53211,2859),(53212,2859),(53213,2860),(53214,2860),(53215,2860),(53216,2860),(53217,2860),(53218,2860),(53219,2861),(53220,2861),(53221,2861),(53222,2861),(53223,2861),(53224,2861),(53225,2862),(53226,2862),(53227,2862),(53228,2862),(53229,2862),(53230,2862),(53231,2863),(53232,2863),(53233,2863),(53234,2863),(53235,2863),(53236,2863),(53237,2864),(53238,2864),(53239,2864),(53240,2864),(53241,2864),(53242,2864),(53243,2865),(53244,2865),(53245,2865),(53246,2865),(53247,2865),(53248,2865),(53249,2866),(53250,2866),(53251,2866),(53252,2866),(53253,2866),(53254,2866),(53255,2867),(53256,2867),(53257,2867),(53258,2867),(53259,2867),(53260,2867),(53261,2868),(53262,2868),(53263,2868),(53264,2868),(53265,2868),(53266,2868),(53267,2869),(53268,2869),(53269,2869),(53270,2869),(53271,2869),(53272,2869),(53273,2870),(53274,2870),(53275,2870),(53276,2870),(53277,2870),(53278,2870),(53279,2871),(53280,2871),(53281,2871),(53282,2871),(53283,2871),(53284,2871),(53285,2872),(53286,2872),(53287,2872),(53288,2872),(53289,2872),(53290,2872),(53291,2873),(53292,2873),(53293,2873),(53294,2873),(53295,2873),(53296,2873),(53297,2874),(53298,2874),(53299,2874),(53300,2874),(53301,2874),(53302,2874),(53303,2875),(53304,2875),(53305,2875),(53306,2875),(53307,2875),(53308,2875),(53309,2876),(53310,2876),(53311,2876),(53312,2876),(53313,2876),(53314,2876),(53315,2877),(53316,2877),(53317,2877),(53318,2877),(53319,2877),(53320,2877),(53321,2878),(53322,2878),(53323,2878),(53324,2878),(53325,2878),(53326,2878),(53327,2879),(53328,2879),(53329,2879),(53330,2879),(53331,2879),(53332,2879),(53333,2880),(53334,2880),(53335,2880),(53336,2880),(53337,2880),(53338,2880),(53339,2881),(53340,2881),(53341,2881),(53342,2881),(53343,2881),(53344,2881),(53345,2882),(53346,2882),(53347,2882),(53348,2882),(53349,2882),(53350,2882),(53351,2883),(53352,2883),(53353,2883),(53354,2883),(53355,2883),(53356,2883),(53357,2884),(53358,2884),(53359,2884),(53360,2884),(53361,2884),(53362,2884),(53363,2885),(53364,2885),(53365,2885),(53366,2885),(53367,2885),(53368,2885),(53369,2886),(53370,2886),(53371,2886),(53372,2886),(53373,2886),(53374,2886),(53375,2887),(53376,2887),(53377,2887),(53378,2887),(53379,2887),(53380,2887),(53381,2888),(53382,2888),(53383,2888),(53384,2888),(53385,2888),(53386,2888),(53387,2889),(53388,2889),(53389,2889),(53390,2889),(53391,2889),(53392,2889),(53393,2890),(53394,2890),(53395,2890),(53396,2890),(53397,2890),(53398,2890),(53399,2891),(53400,2891),(53401,2891),(53402,2891),(53403,2891),(53404,2891),(53405,2892),(53406,2892),(53407,2892),(53408,2892),(53409,2892),(53410,2892),(53411,2893),(53412,2893),(53413,2893),(53414,2893),(53415,2893),(53416,2893),(53417,2894),(53418,2894),(53419,2894),(53420,2894),(53421,2894),(53422,2894),(53423,2895),(53424,2895),(53425,2895),(53426,2895),(53427,2895),(53428,2895),(53429,2896),(53430,2896),(53431,2896),(53432,2896),(53433,2896),(53434,2896),(53435,2897),(53436,2897),(53437,2897),(53438,2897),(53439,2897),(53440,2897),(53441,2898),(53442,2898),(53443,2898),(53444,2898),(53445,2898),(53446,2898),(53447,2899),(53448,2899),(53449,2899),(53450,2899),(53451,2899),(53452,2899),(53453,2900),(53454,2900),(53455,2900),(53456,2900),(53457,2900),(53458,2900),(53459,2901),(53460,2901),(53461,2901),(53462,2901),(53463,2901),(53464,2901),(53465,2902),(53466,2902),(53467,2902),(53468,2902),(53469,2902),(53470,2902),(53471,2903),(53472,2903),(53473,2903),(53474,2903),(53475,2903),(53476,2903),(53477,2904),(53478,2904),(53479,2904),(53480,2904),(53481,2904),(53482,2904),(53483,2905),(53484,2905),(53485,2905),(53486,2905),(53487,2905),(53488,2905),(53489,2906),(53490,2906),(53491,2906),(53492,2906),(53493,2906),(53494,2906),(53495,2907),(53496,2907),(53497,2907),(53498,2907),(53499,2907),(53500,2907),(53501,2908),(53502,2908),(53503,2908),(53504,2908),(53505,2908),(53506,2908),(53507,2909),(53508,2909),(53509,2909),(53510,2909),(53511,2909),(53512,2909),(53513,2910),(53514,2910),(53515,2910),(53516,2910),(53517,2910),(53518,2910),(53519,2911),(53520,2911),(53521,2911),(53522,2911),(53523,2911),(53524,2911),(53525,2912),(53526,2912),(53527,2912),(53528,2912),(53529,2912),(53530,2912),(53531,2913),(53532,2913),(53533,2913),(53534,2913),(53535,2914),(53536,2914),(53537,2914),(53538,2914),(53539,2915),(53540,2915),(53541,2915),(53542,2915),(53543,2916),(53544,2916),(53545,2916),(53546,2916),(53547,2917),(53548,2917),(53549,2917),(53550,2917),(53551,2917),(53552,2917),(53553,2918),(53554,2918),(53555,2918),(53556,2918),(53557,2918),(53558,2918),(53559,2919),(53560,2919),(53561,2919),(53562,2919),(53563,2919),(53564,2919),(53565,2920),(53566,2920),(53567,2920),(53568,2920),(53569,2920),(53570,2920),(53571,2921),(53572,2921),(53573,2921),(53574,2921),(53575,2921),(53576,2921),(53577,2822),(53578,2822),(53579,2823),(53580,2823),(53581,2824),(53582,2824),(53583,2825),(53584,2825),(53585,2826),(53586,2826),(53587,2827),(53588,2827),(53589,2828),(53590,2828),(53591,2829),(53592,2829),(53593,2830),(53594,2830),(53595,2831),(53596,2831),(53597,2832),(53598,2832),(53599,2833),(53600,2833),(53601,2834),(53602,2834),(53603,2835),(53604,2835),(53605,2836),(53606,2836),(53607,2837),(53608,2837),(53609,2838),(53610,2838),(53611,2839),(53612,2839),(53613,2840),(53614,2840),(53615,2841),(53616,2841),(53617,2842),(53618,2842),(53619,2843),(53620,2843),(53621,2844),(53622,2844),(53623,2845),(53624,2845),(53625,2846),(53626,2846),(53627,2847),(53628,2847),(53629,2848),(53630,2848),(53631,2849),(53632,2849),(53633,2850),(53634,2850),(53635,2851),(53636,2851),(53637,2852),(53638,2852),(53639,2852),(53640,2853),(53641,2853),(53642,2853),(53643,2854),(53644,2854),(53645,2854),(53646,2855),(53647,2855),(53648,2855),(53649,2856),(53650,2856),(53651,2856),(53652,2857),(53653,2857),(53654,2858),(53655,2858),(53656,2859),(53657,2859),(53658,2859),(53659,2860),(53660,2860),(53661,2860),(53662,2861),(53663,2861),(53664,2861),(53665,2862),(53666,2862),(53667,2862),(53668,2863),(53669,2863),(53670,2864),(53671,2864),(53672,2864),(53673,2865),(53674,2865),(53675,2865),(53676,2866),(53677,2866),(53678,2867),(53679,2867),(53680,2868),(53681,2868),(53682,2868),(53683,2869),(53684,2869),(53685,2869),(53686,2870),(53687,2870),(53688,2870),(53689,2871),(53690,2871),(53691,2871),(53692,2872),(53693,2872),(53694,2872),(53695,2873),(53696,2873),(53697,2873),(53698,2874),(53699,2874),(53700,2874),(53701,2875),(53702,2875),(53703,2875),(53704,2876),(53705,2876),(53706,2876),(53707,2877),(53708,2877),(53709,2877),(53710,2878),(53711,2878),(53712,2878),(53713,2879),(53714,2879),(53715,2879),(53716,2880),(53717,2880),(53718,2880),(53719,2881),(53720,2881),(53721,2881),(53722,2882),(53723,2882),(53724,2882),(53725,2883),(53726,2883),(53727,2883),(53728,2884),(53729,2884),(53730,2884),(53731,2885),(53732,2885),(53733,2885),(53734,2886),(53735,2886),(53736,2886),(53737,2887),(53738,2887),(53739,2887),(53740,2888),(53741,2888),(53742,2888),(53743,2889),(53744,2889),(53745,2889),(53746,2890),(53747,2890),(53748,2891),(53749,2891),(53750,2892),(53751,2892),(53752,2892),(53753,2893),(53754,2893),(53755,2893),(53756,2894),(53757,2894),(53758,2895),(53759,2895),(53760,2896),(53761,2896),(53762,2897),(53763,2897),(53764,2898),(53765,2898),(53766,2899),(53767,2899),(53768,2900),(53769,2900),(53770,2900),(53771,2901),(53772,2901),(53773,2901),(53774,2902),(53775,2902),(53776,2902),(53777,2903),(53778,2903),(53779,2903),(53780,2904),(53781,2904),(53782,2905),(53783,2905),(53784,2905),(53785,2906),(53786,2906),(53787,2906),(53788,2907),(53789,2907),(53790,2907),(53791,2908),(53792,2908),(53793,2908),(53794,2909),(53795,2909),(53796,2909),(53797,2910),(53798,2910),(53799,2910),(53800,2911),(53801,2911),(53802,2911),(53803,2912),(53804,2912),(53805,2912),(53806,2913),(53807,2913),(53808,2914),(53809,2914),(53810,2915),(53811,2915),(53812,2916),(53813,2916),(53814,2917),(53815,2917),(53816,2918),(53817,2918),(53818,2919),(53819,2919),(53820,2920),(53821,2920),(53822,2921),(53823,2921),(53824,2822),(53825,2822),(53826,2822),(53827,2823),(53828,2823),(53829,2823),(53830,2824),(53831,2824),(53832,2824),(53833,2825),(53834,2825),(53835,2825),(53836,2826),(53837,2826),(53838,2826),(53839,2827),(53840,2827),(53841,2827),(53842,2828),(53843,2828),(53844,2828),(53845,2829),(53846,2829),(53847,2829),(53848,2830),(53849,2830),(53850,2830),(53851,2831),(53852,2831),(53853,2831),(53854,2832),(53855,2832),(53856,2832),(53857,2833),(53858,2833),(53859,2833),(53860,2834),(53861,2834),(53862,2834),(53863,2835),(53864,2835),(53865,2835),(53866,2836),(53867,2836),(53868,2836),(53869,2837),(53870,2837),(53871,2837),(53872,2838),(53873,2838),(53874,2838),(53875,2839),(53876,2839),(53877,2839),(53878,2840),(53879,2840),(53880,2840),(53881,2841),(53882,2841),(53883,2841),(53884,2842),(53885,2842),(53886,2842),(53887,2843),(53888,2843),(53889,2843),(53890,2844),(53891,2844),(53892,2844),(53893,2845),(53894,2845),(53895,2845),(53896,2846),(53897,2846),(53898,2846),(53899,2847),(53900,2847),(53901,2847),(53902,2848),(53903,2848),(53904,2848),(53905,2849),(53906,2849),(53907,2849),(53908,2850),(53909,2850),(53910,2850),(53911,2851),(53912,2851),(53913,2851),(53914,2852),(53915,2852),(53916,2852),(53917,2853),(53918,2853),(53919,2853),(53920,2854),(53921,2854),(53922,2854),(53923,2855),(53924,2855),(53925,2855),(53926,2856),(53927,2856),(53928,2856),(53929,2857),(53930,2857),(53931,2857),(53932,2858),(53933,2858),(53934,2858),(53935,2859),(53936,2859),(53937,2859),(53938,2860),(53939,2860),(53940,2860),(53941,2861),(53942,2861),(53943,2861),(53944,2862),(53945,2862),(53946,2862),(53947,2863),(53948,2863),(53949,2863),(53950,2864),(53951,2864),(53952,2864),(53953,2865),(53954,2865),(53955,2865),(53956,2866),(53957,2866),(53958,2866),(53959,2867),(53960,2867),(53961,2867),(53962,2868),(53963,2868),(53964,2868),(53965,2869),(53966,2869),(53967,2869),(53968,2870),(53969,2870),(53970,2870),(53971,2871),(53972,2871),(53973,2871),(53974,2872),(53975,2872),(53976,2872),(53977,2873),(53978,2873),(53979,2873),(53980,2874),(53981,2874),(53982,2874),(53983,2875),(53984,2875),(53985,2875),(53986,2876),(53987,2876),(53988,2876),(53989,2877),(53990,2877),(53991,2877),(53992,2878),(53993,2878),(53994,2878),(53995,2879),(53996,2879),(53997,2879),(53998,2880),(53999,2880),(54000,2880),(54001,2881),(54002,2881),(54003,2881),(54004,2882),(54005,2882),(54006,2882),(54007,2883),(54008,2883),(54009,2883),(54010,2884),(54011,2884),(54012,2884),(54013,2885),(54014,2885),(54015,2885),(54016,2886),(54017,2886),(54018,2886),(54019,2887),(54020,2887),(54021,2887),(54022,2888),(54023,2888),(54024,2888),(54025,2889),(54026,2889),(54027,2889),(54028,2890),(54029,2890),(54030,2890),(54031,2891),(54032,2891),(54033,2891),(54034,2892),(54035,2892),(54036,2892),(54037,2893),(54038,2893),(54039,2893),(54040,2894),(54041,2894),(54042,2894),(54043,2895),(54044,2895),(54045,2895),(54046,2896),(54047,2896),(54048,2896),(54049,2897),(54050,2897),(54051,2897),(54052,2898),(54053,2898),(54054,2898),(54055,2899),(54056,2899),(54057,2899),(54058,2900),(54059,2900),(54060,2900),(54061,2901),(54062,2901),(54063,2901),(54064,2902),(54065,2902),(54066,2902),(54067,2903),(54068,2903),(54069,2903),(54070,2904),(54071,2904),(54072,2904),(54073,2905),(54074,2905),(54075,2905),(54076,2906),(54077,2906),(54078,2906),(54079,2907),(54080,2907),(54081,2907),(54082,2908),(54083,2908),(54084,2908),(54085,2909),(54086,2909),(54087,2909),(54088,2910),(54089,2910),(54090,2910),(54091,2911),(54092,2911),(54093,2911),(54094,2912),(54095,2912),(54096,2912),(54097,2913),(54098,2913),(54099,2913),(54100,2914),(54101,2914),(54102,2914),(54103,2915),(54104,2915),(54105,2915),(54106,2916),(54107,2916),(54108,2916),(54109,2917),(54110,2917),(54111,2917),(54112,2918),(54113,2918),(54114,2918),(54115,2919),(54116,2919),(54117,2919),(54118,2920),(54119,2920),(54120,2920),(54121,2921),(54122,2921),(54123,2921),(54124,2822),(54125,2822),(54126,2822),(54127,2822),(54128,2823),(54129,2823),(54130,2823),(54131,2823),(54132,2824),(54133,2824),(54134,2824),(54135,2824),(54136,2825),(54137,2825),(54138,2825),(54139,2825),(54140,2826),(54141,2826),(54142,2826),(54143,2826),(54144,2827),(54145,2827),(54146,2827),(54147,2827),(54148,2828),(54149,2828),(54150,2828),(54151,2828),(54152,2829),(54153,2829),(54154,2829),(54155,2829),(54156,2830),(54157,2830),(54158,2830),(54159,2830),(54160,2831),(54161,2831),(54162,2831),(54163,2831),(54164,2832),(54165,2832),(54166,2832),(54167,2832),(54168,2833),(54169,2833),(54170,2833),(54171,2833),(54172,2834),(54173,2834),(54174,2834),(54175,2834),(54176,2835),(54177,2835),(54178,2835),(54179,2835),(54180,2836),(54181,2836),(54182,2836),(54183,2836),(54184,2837),(54185,2837),(54186,2837),(54187,2837),(54188,2838),(54189,2838),(54190,2838),(54191,2838),(54192,2839),(54193,2839),(54194,2839),(54195,2839),(54196,2840),(54197,2840),(54198,2840),(54199,2840),(54200,2841),(54201,2841),(54202,2841),(54203,2841),(54204,2842),(54205,2842),(54206,2842),(54207,2842),(54208,2843),(54209,2843),(54210,2843),(54211,2843),(54212,2844),(54213,2844),(54214,2844),(54215,2844),(54216,2845),(54217,2845),(54218,2845),(54219,2845),(54220,2846),(54221,2846),(54222,2846),(54223,2846),(54224,2847),(54225,2847),(54226,2847),(54227,2847),(54228,2848),(54229,2848),(54230,2848),(54231,2848),(54232,2849),(54233,2849),(54234,2849),(54235,2849),(54236,2850),(54237,2850),(54238,2850),(54239,2850),(54240,2851),(54241,2851),(54242,2851),(54243,2851),(54244,2852),(54245,2852),(54246,2852),(54247,2852),(54248,2853),(54249,2853),(54250,2853),(54251,2853),(54252,2854),(54253,2854),(54254,2854),(54255,2854),(54256,2855),(54257,2855),(54258,2855),(54259,2855),(54260,2856),(54261,2856),(54262,2856),(54263,2856),(54264,2857),(54265,2857),(54266,2857),(54267,2857),(54268,2858),(54269,2858),(54270,2858),(54271,2858),(54272,2859),(54273,2859),(54274,2859),(54275,2859),(54276,2860),(54277,2860),(54278,2860),(54279,2860),(54280,2861),(54281,2861),(54282,2861),(54283,2861),(54284,2862),(54285,2862),(54286,2862),(54287,2862),(54288,2863),(54289,2863),(54290,2863),(54291,2863),(54292,2864),(54293,2864),(54294,2864),(54295,2864),(54296,2865),(54297,2865),(54298,2865),(54299,2865),(54300,2866),(54301,2866),(54302,2866),(54303,2866),(54304,2867),(54305,2867),(54306,2867),(54307,2867),(54308,2868),(54309,2868),(54310,2868),(54311,2868),(54312,2869),(54313,2869),(54314,2869),(54315,2869),(54316,2870),(54317,2870),(54318,2870),(54319,2870),(54320,2871),(54321,2871),(54322,2871),(54323,2871),(54324,2872),(54325,2872),(54326,2872),(54327,2872),(54328,2873),(54329,2873),(54330,2873),(54331,2873),(54332,2874),(54333,2874),(54334,2874),(54335,2874),(54336,2875),(54337,2875),(54338,2875),(54339,2875),(54340,2876),(54341,2876),(54342,2876),(54343,2876),(54344,2877),(54345,2877),(54346,2877),(54347,2877),(54348,2878),(54349,2878),(54350,2878),(54351,2878),(54352,2879),(54353,2879),(54354,2879),(54355,2879),(54356,2880),(54357,2880),(54358,2880),(54359,2880),(54360,2881),(54361,2881),(54362,2881),(54363,2881),(54364,2882),(54365,2882),(54366,2882),(54367,2882),(54368,2883),(54369,2883),(54370,2883),(54371,2883),(54372,2884),(54373,2884),(54374,2884),(54375,2884),(54376,2885),(54377,2885),(54378,2885),(54379,2885),(54380,2886),(54381,2886),(54382,2886),(54383,2886),(54384,2887),(54385,2887),(54386,2887),(54387,2887),(54388,2888),(54389,2888),(54390,2888),(54391,2888),(54392,2889),(54393,2889),(54394,2889),(54395,2889),(54396,2890),(54397,2890),(54398,2890),(54399,2890),(54400,2891),(54401,2891),(54402,2891),(54403,2891),(54404,2892),(54405,2892),(54406,2892),(54407,2892),(54408,2893),(54409,2893),(54410,2893),(54411,2893),(54412,2894),(54413,2894),(54414,2894),(54415,2894),(54416,2895),(54417,2895),(54418,2895),(54419,2895),(54420,2896),(54421,2896),(54422,2896),(54423,2896),(54424,2897),(54425,2897),(54426,2897),(54427,2897),(54428,2898),(54429,2898),(54430,2898),(54431,2898),(54432,2899),(54433,2899),(54434,2899),(54435,2899),(54436,2900),(54437,2900),(54438,2900),(54439,2900),(54440,2901),(54441,2901),(54442,2901),(54443,2901),(54444,2902),(54445,2902),(54446,2902),(54447,2902),(54448,2903),(54449,2903),(54450,2903),(54451,2903),(54452,2904),(54453,2904),(54454,2904),(54455,2904),(54456,2905),(54457,2905),(54458,2905),(54459,2905),(54460,2906),(54461,2906),(54462,2906),(54463,2906),(54464,2907),(54465,2907),(54466,2907),(54467,2907),(54468,2908),(54469,2908),(54470,2908),(54471,2908),(54472,2909),(54473,2909),(54474,2909),(54475,2909),(54476,2910),(54477,2910),(54478,2910),(54479,2910),(54480,2911),(54481,2911),(54482,2911),(54483,2911),(54484,2912),(54485,2912),(54486,2912),(54487,2912),(54488,2913),(54489,2913),(54490,2913),(54491,2913),(54492,2914),(54493,2914),(54494,2914),(54495,2914),(54496,2915),(54497,2915),(54498,2915),(54499,2915),(54500,2916),(54501,2916),(54502,2916),(54503,2916),(54504,2917),(54505,2917),(54506,2917),(54507,2917),(54508,2918),(54509,2918),(54510,2918),(54511,2918),(54512,2919),(54513,2919),(54514,2919),(54515,2919),(54516,2920),(54517,2920),(54518,2920),(54519,2920),(54520,2921),(54521,2921),(54522,2921),(54523,2921),(54524,2922),(54525,2923),(54526,2924),(54527,2925),(54528,2926),(54529,2927),(54530,2928),(54531,2929),(54532,2930),(54533,2931),(54534,2932),(54535,2933),(54536,2934),(54537,2935),(54538,2936),(54539,2937),(54540,2938),(54541,2939),(54542,2940),(54543,2941),(54544,2942),(54545,2943),(54546,2944),(54547,2945),(54548,2946),(54549,2947),(54550,2948),(54551,2949),(54552,2950),(54553,2951),(54554,2952),(54555,2953),(54556,2954),(54557,2955),(54558,2956),(54559,2957),(54560,2958),(54561,2959),(54562,2960),(54563,2961),(54564,2962),(54565,2963),(54566,2964),(54567,2965),(54568,2966),(54569,2967),(54570,2968),(54571,2969),(54572,2970),(54573,2971),(54574,2972),(54575,2973),(54576,2974),(54577,2975),(54578,2976),(54579,2977),(54580,2978),(54581,2979),(54582,2980),(54583,2981),(54584,2982),(54585,2983),(54586,2984),(54587,2985),(54588,2986),(54589,2987),(54590,2988),(54591,2989),(54592,2990),(54593,2991),(54594,2992),(54595,2993),(54596,2994),(54597,2995),(54598,2996),(54599,2997),(54600,2998),(54601,2999),(54602,3000),(54603,3001),(54604,3002),(54605,3003),(54606,3004),(54607,3005),(54608,3006),(54609,3007),(54610,3008),(54611,3009),(54612,3010),(54613,3011),(54614,3012),(54615,3013),(54616,3014),(54617,3015),(54618,3016),(54619,3017),(54620,3018),(54621,3019),(54622,3020),(54623,3021),(54624,2922),(54625,2923),(54626,2924),(54627,2925),(54628,2926),(54629,2927),(54630,2928),(54631,2929),(54632,2930),(54633,2931),(54634,2932),(54635,2933),(54636,2934),(54637,2935),(54638,2936),(54639,2937),(54640,2938),(54641,2939),(54642,2940),(54643,2941),(54644,2942),(54645,2943),(54646,2944),(54647,2945),(54648,2946),(54649,2947),(54650,2948),(54651,2949),(54652,2950),(54653,2951),(54654,2952),(54655,2953),(54656,2954),(54657,2955),(54658,2956),(54659,2957),(54660,2958),(54661,2959),(54662,2960),(54663,2961),(54664,2962),(54665,2963),(54666,2964),(54667,2965),(54668,2966),(54669,2967),(54670,2968),(54671,2969),(54672,2970),(54673,2971),(54674,2972),(54675,2973),(54676,2974),(54677,2975),(54678,2976),(54679,2977),(54680,2978),(54681,2979),(54682,2980),(54683,2981),(54684,2982),(54685,2983),(54686,2984),(54687,2985),(54688,2986),(54689,2987),(54690,2988),(54691,2989),(54692,2990),(54693,2991),(54694,2992),(54695,2993),(54696,2994),(54697,2995),(54698,2996),(54699,2997),(54700,2998),(54701,2999),(54702,3000),(54703,3001),(54704,3002),(54705,3003),(54706,3004),(54707,3005),(54708,3006),(54709,3007),(54710,3008),(54711,3009),(54712,3010),(54713,3011),(54714,3012),(54715,3013),(54716,3014),(54717,3015),(54718,3016),(54719,3017),(54720,3018),(54721,3019),(54722,3020),(54723,3021),(54724,2922),(54725,2922),(54726,2922),(54727,2922),(54728,2922),(54729,2922),(54730,2923),(54731,2923),(54732,2923),(54733,2923),(54734,2923),(54735,2923),(54736,2924),(54737,2924),(54738,2924),(54739,2924),(54740,2924),(54741,2924),(54742,2925),(54743,2925),(54744,2925),(54745,2925),(54746,2925),(54747,2925),(54748,2926),(54749,2926),(54750,2926),(54751,2926),(54752,2926),(54753,2926),(54754,2927),(54755,2927),(54756,2927),(54757,2927),(54758,2927),(54759,2927),(54760,2928),(54761,2928),(54762,2928),(54763,2928),(54764,2928),(54765,2928),(54766,2929),(54767,2929),(54768,2929),(54769,2929),(54770,2929),(54771,2929),(54772,2930),(54773,2930),(54774,2930),(54775,2930),(54776,2930),(54777,2930),(54778,2931),(54779,2931),(54780,2931),(54781,2931),(54782,2931),(54783,2931),(54784,2932),(54785,2932),(54786,2932),(54787,2932),(54788,2932),(54789,2932),(54790,2933),(54791,2933),(54792,2933),(54793,2933),(54794,2933),(54795,2933),(54796,2934),(54797,2934),(54798,2934),(54799,2934),(54800,2934),(54801,2934),(54802,2935),(54803,2935),(54804,2935),(54805,2935),(54806,2935),(54807,2935),(54808,2936),(54809,2936),(54810,2936),(54811,2936),(54812,2936),(54813,2936),(54814,2937),(54815,2937),(54816,2937),(54817,2937),(54818,2937),(54819,2937),(54820,2938),(54821,2938),(54822,2938),(54823,2938),(54824,2938),(54825,2938),(54826,2939),(54827,2939),(54828,2939),(54829,2939),(54830,2939),(54831,2939),(54832,2940),(54833,2940),(54834,2940),(54835,2940),(54836,2940),(54837,2940),(54838,2941),(54839,2941),(54840,2941),(54841,2941),(54842,2941),(54843,2941),(54844,2942),(54845,2942),(54846,2942),(54847,2942),(54848,2942),(54849,2942),(54850,2943),(54851,2943),(54852,2943),(54853,2943),(54854,2943),(54855,2943),(54856,2944),(54857,2944),(54858,2944),(54859,2944),(54860,2944),(54861,2944),(54862,2945),(54863,2945),(54864,2945),(54865,2945),(54866,2945),(54867,2945),(54868,2946),(54869,2946),(54870,2946),(54871,2946),(54872,2946),(54873,2946),(54874,2947),(54875,2947),(54876,2947),(54877,2947),(54878,2947),(54879,2947),(54880,2948),(54881,2948),(54882,2948),(54883,2948),(54884,2948),(54885,2948),(54886,2949),(54887,2949),(54888,2949),(54889,2949),(54890,2949),(54891,2949),(54892,2950),(54893,2950),(54894,2950),(54895,2950),(54896,2950),(54897,2950),(54898,2951),(54899,2951),(54900,2951),(54901,2951),(54902,2951),(54903,2951),(54904,2952),(54905,2952),(54906,2952),(54907,2952),(54908,2952),(54909,2952),(54910,2953),(54911,2953),(54912,2953),(54913,2953),(54914,2953),(54915,2953),(54916,2954),(54917,2954),(54918,2954),(54919,2954),(54920,2954),(54921,2954),(54922,2955),(54923,2955),(54924,2955),(54925,2955),(54926,2955),(54927,2955),(54928,2956),(54929,2956),(54930,2956),(54931,2956),(54932,2956),(54933,2956),(54934,2957),(54935,2957),(54936,2957),(54937,2957),(54938,2957),(54939,2957),(54940,2958),(54941,2958),(54942,2958),(54943,2958),(54944,2958),(54945,2958),(54946,2959),(54947,2959),(54948,2959),(54949,2959),(54950,2959),(54951,2959),(54952,2960),(54953,2960),(54954,2960),(54955,2960),(54956,2960),(54957,2960),(54958,2961),(54959,2961),(54960,2961),(54961,2961),(54962,2961),(54963,2961),(54964,2962),(54965,2962),(54966,2962),(54967,2962),(54968,2962),(54969,2962),(54970,2963),(54971,2963),(54972,2963),(54973,2963),(54974,2964),(54975,2964),(54976,2964),(54977,2964),(54978,2965),(54979,2965),(54980,2965),(54981,2965),(54982,2966),(54983,2966),(54984,2966),(54985,2966),(54986,2967),(54987,2967),(54988,2967),(54989,2967),(54990,2968),(54991,2968),(54992,2968),(54993,2968),(54994,2969),(54995,2969),(54996,2969),(54997,2969),(54998,2969),(54999,2969),(55000,2970),(55001,2970),(55002,2970),(55003,2970),(55004,2970),(55005,2970),(55006,2971),(55007,2971),(55008,2971),(55009,2971),(55010,2971),(55011,2971),(55012,2972),(55013,2972),(55014,2972),(55015,2972),(55016,2972),(55017,2972),(55018,2973),(55019,2973),(55020,2973),(55021,2973),(55022,2973),(55023,2973),(55024,2974),(55025,2974),(55026,2974),(55027,2974),(55028,2974),(55029,2974),(55030,2975),(55031,2975),(55032,2975),(55033,2975),(55034,2975),(55035,2975),(55036,2976),(55037,2976),(55038,2976),(55039,2976),(55040,2976),(55041,2976),(55042,2977),(55043,2977),(55044,2977),(55045,2977),(55046,2977),(55047,2977),(55048,2978),(55049,2978),(55050,2978),(55051,2978),(55052,2978),(55053,2978),(55054,2979),(55055,2979),(55056,2979),(55057,2979),(55058,2979),(55059,2979),(55060,2980),(55061,2980),(55062,2980),(55063,2980),(55064,2980),(55065,2980),(55066,2981),(55067,2981),(55068,2981),(55069,2981),(55070,2982),(55071,2982),(55072,2982),(55073,2982),(55074,2983),(55075,2983),(55076,2983),(55077,2983),(55078,2984),(55079,2984),(55080,2984),(55081,2984),(55082,2985),(55083,2985),(55084,2985),(55085,2985),(55086,2986),(55087,2986),(55088,2986),(55089,2986),(55090,2987),(55091,2987),(55092,2987),(55093,2987),(55094,2987),(55095,2987),(55096,2988),(55097,2988),(55098,2988),(55099,2988),(55100,2988),(55101,2988),(55102,2989),(55103,2989),(55104,2989),(55105,2989),(55106,2989),(55107,2989),(55108,2990),(55109,2990),(55110,2990),(55111,2990),(55112,2990),(55113,2990),(55114,2991),(55115,2991),(55116,2991),(55117,2991),(55118,2991),(55119,2991),(55120,2992),(55121,2992),(55122,2992),(55123,2992),(55124,2992),(55125,2992),(55126,2993),(55127,2993),(55128,2993),(55129,2993),(55130,2993),(55131,2993),(55132,2994),(55133,2994),(55134,2994),(55135,2994),(55136,2994),(55137,2994),(55138,2995),(55139,2995),(55140,2995),(55141,2995),(55142,2995),(55143,2995),(55144,2996),(55145,2996),(55146,2996),(55147,2996),(55148,2996),(55149,2996),(55150,2997),(55151,2997),(55152,2997),(55153,2997),(55154,2997),(55155,2997),(55156,2998),(55157,2998),(55158,2998),(55159,2998),(55160,2998),(55161,2998),(55162,2999),(55163,2999),(55164,2999),(55165,2999),(55166,2999),(55167,2999),(55168,3000),(55169,3000),(55170,3000),(55171,3000),(55172,3000),(55173,3000),(55174,3001),(55175,3001),(55176,3001),(55177,3001),(55178,3001),(55179,3001),(55180,3002),(55181,3002),(55182,3002),(55183,3002),(55184,3002),(55185,3002),(55186,3003),(55187,3003),(55188,3003),(55189,3003),(55190,3003),(55191,3003),(55192,3004),(55193,3004),(55194,3004),(55195,3004),(55196,3004),(55197,3004),(55198,3005),(55199,3005),(55200,3005),(55201,3005),(55202,3005),(55203,3005),(55204,3006),(55205,3006),(55206,3006),(55207,3006),(55208,3006),(55209,3006),(55210,3007),(55211,3007),(55212,3007),(55213,3007),(55214,3007),(55215,3007),(55216,3008),(55217,3008),(55218,3008),(55219,3008),(55220,3008),(55221,3008),(55222,3009),(55223,3009),(55224,3009),(55225,3009),(55226,3009),(55227,3009),(55228,3010),(55229,3010),(55230,3010),(55231,3010),(55232,3010),(55233,3010),(55234,3011),(55235,3011),(55236,3011),(55237,3011),(55238,3011),(55239,3011),(55240,3012),(55241,3012),(55242,3012),(55243,3012),(55244,3012),(55245,3012),(55246,3013),(55247,3013),(55248,3013),(55249,3013),(55250,3013),(55251,3013),(55252,3014),(55253,3014),(55254,3014),(55255,3014),(55256,3014),(55257,3014),(55258,3015),(55259,3015),(55260,3015),(55261,3015),(55262,3015),(55263,3015),(55264,3016),(55265,3016),(55266,3016),(55267,3016),(55268,3016),(55269,3016),(55270,3017),(55271,3017),(55272,3017),(55273,3017),(55274,3017),(55275,3017),(55276,3018),(55277,3018),(55278,3018),(55279,3018),(55280,3018),(55281,3018),(55282,3019),(55283,3019),(55284,3019),(55285,3019),(55286,3019),(55287,3019),(55288,3020),(55289,3020),(55290,3020),(55291,3020),(55292,3020),(55293,3020),(55294,3021),(55295,3021),(55296,3021),(55297,3021),(55298,3021),(55299,3021),(55300,2922),(55301,2922),(55302,2923),(55303,2923),(55304,2924),(55305,2924),(55306,2925),(55307,2925),(55308,2926),(55309,2926),(55310,2927),(55311,2927),(55312,2928),(55313,2928),(55314,2929),(55315,2929),(55316,2930),(55317,2930),(55318,2931),(55319,2931),(55320,2932),(55321,2932),(55322,2933),(55323,2933),(55324,2934),(55325,2934),(55326,2935),(55327,2935),(55328,2936),(55329,2936),(55330,2937),(55331,2937),(55332,2938),(55333,2938),(55334,2939),(55335,2939),(55336,2940),(55337,2940),(55338,2941),(55339,2941),(55340,2942),(55341,2942),(55342,2943),(55343,2943),(55344,2944),(55345,2944),(55346,2945),(55347,2945),(55348,2946),(55349,2946),(55350,2947),(55351,2947),(55352,2948),(55353,2948),(55354,2949),(55355,2949),(55356,2950),(55357,2950),(55358,2951),(55359,2951),(55360,2952),(55361,2952),(55362,2953),(55363,2953),(55364,2954),(55365,2954),(55366,2955),(55367,2955),(55368,2955),(55369,2956),(55370,2956),(55371,2956),(55372,2957),(55373,2957),(55374,2957),(55375,2958),(55376,2958),(55377,2958),(55378,2959),(55379,2959),(55380,2959),(55381,2960),(55382,2960),(55383,2960),(55384,2961),(55385,2961),(55386,2961),(55387,2962),(55388,2962),(55389,2962),(55390,2963),(55391,2963),(55392,2964),(55393,2964),(55394,2965),(55395,2965),(55396,2966),(55397,2966),(55398,2967),(55399,2967),(55400,2968),(55401,2968),(55402,2969),(55403,2969),(55404,2970),(55405,2970),(55406,2971),(55407,2971),(55408,2972),(55409,2972),(55410,2973),(55411,2973),(55412,2974),(55413,2974),(55414,2975),(55415,2975),(55416,2976),(55417,2976),(55418,2977),(55419,2977),(55420,2978),(55421,2978),(55422,2979),(55423,2979),(55424,2980),(55425,2980),(55426,2981),(55427,2981),(55428,2982),(55429,2982),(55430,2983),(55431,2983),(55432,2984),(55433,2984),(55434,2985),(55435,2985),(55436,2986),(55437,2986),(55438,2987),(55439,2987),(55440,2988),(55441,2988),(55442,2989),(55443,2989),(55444,2990),(55445,2990),(55446,2991),(55447,2991),(55448,2991),(55449,2992),(55450,2992),(55451,2992),(55452,2993),(55453,2993),(55454,2994),(55455,2994),(55456,2995),(55457,2995),(55458,2996),(55459,2996),(55460,2997),(55461,2997),(55462,2998),(55463,2998),(55464,2999),(55465,2999),(55466,3000),(55467,3000),(55468,3001),(55469,3001),(55470,3002),(55471,3002),(55472,3003),(55473,3003),(55474,3004),(55475,3004),(55476,3005),(55477,3005),(55478,3006),(55479,3006),(55480,3007),(55481,3007),(55482,3008),(55483,3008),(55484,3009),(55485,3009),(55486,3010),(55487,3010),(55488,3011),(55489,3011),(55490,3012),(55491,3012),(55492,3013),(55493,3013),(55494,3013),(55495,3014),(55496,3014),(55497,3014),(55498,3015),(55499,3015),(55500,3015),(55501,3016),(55502,3016),(55503,3016),(55504,3017),(55505,3017),(55506,3017),(55507,3018),(55508,3018),(55509,3018),(55510,3019),(55511,3019),(55512,3019),(55513,3020),(55514,3020),(55515,3020),(55516,3021),(55517,3021),(55518,3021),(55519,2922),(55520,2922),(55521,2922),(55522,2923),(55523,2923),(55524,2923),(55525,2924),(55526,2924),(55527,2924),(55528,2925),(55529,2925),(55530,2925),(55531,2926),(55532,2926),(55533,2926),(55534,2927),(55535,2927),(55536,2927),(55537,2928),(55538,2928),(55539,2928),(55540,2929),(55541,2929),(55542,2929),(55543,2930),(55544,2930),(55545,2930),(55546,2931),(55547,2931),(55548,2931),(55549,2932),(55550,2932),(55551,2932),(55552,2933),(55553,2933),(55554,2933),(55555,2934),(55556,2934),(55557,2934),(55558,2935),(55559,2935),(55560,2935),(55561,2936),(55562,2936),(55563,2936),(55564,2937),(55565,2937),(55566,2937),(55567,2938),(55568,2938),(55569,2938),(55570,2939),(55571,2939),(55572,2939),(55573,2940),(55574,2940),(55575,2940),(55576,2941),(55577,2941),(55578,2941),(55579,2942),(55580,2942),(55581,2942),(55582,2943),(55583,2943),(55584,2943),(55585,2944),(55586,2944),(55587,2944),(55588,2945),(55589,2945),(55590,2945),(55591,2946),(55592,2946),(55593,2946),(55594,2947),(55595,2947),(55596,2947),(55597,2948),(55598,2948),(55599,2948),(55600,2949),(55601,2949),(55602,2949),(55603,2950),(55604,2950),(55605,2950),(55606,2951),(55607,2951),(55608,2951),(55609,2952),(55610,2952),(55611,2952),(55612,2953),(55613,2953),(55614,2953),(55615,2954),(55616,2954),(55617,2954),(55618,2955),(55619,2955),(55620,2955),(55621,2956),(55622,2956),(55623,2956),(55624,2957),(55625,2957),(55626,2957),(55627,2958),(55628,2958),(55629,2958),(55630,2959),(55631,2959),(55632,2959),(55633,2960),(55634,2960),(55635,2960),(55636,2961),(55637,2961),(55638,2961),(55639,2962),(55640,2962),(55641,2962),(55642,2963),(55643,2963),(55644,2963),(55645,2964),(55646,2964),(55647,2964),(55648,2965),(55649,2965),(55650,2965),(55651,2966),(55652,2966),(55653,2966),(55654,2967),(55655,2967),(55656,2967),(55657,2968),(55658,2968),(55659,2968),(55660,2969),(55661,2969),(55662,2969),(55663,2970),(55664,2970),(55665,2970),(55666,2971),(55667,2971),(55668,2971),(55669,2972),(55670,2972),(55671,2972),(55672,2973),(55673,2973),(55674,2973),(55675,2974),(55676,2974),(55677,2974),(55678,2975),(55679,2975),(55680,2975),(55681,2976),(55682,2976),(55683,2976),(55684,2977),(55685,2977),(55686,2977),(55687,2978),(55688,2978),(55689,2978),(55690,2979),(55691,2979),(55692,2979),(55693,2980),(55694,2980),(55695,2980),(55696,2981),(55697,2981),(55698,2981),(55699,2982),(55700,2982),(55701,2982),(55702,2983),(55703,2983),(55704,2983),(55705,2984),(55706,2984),(55707,2984),(55708,2985),(55709,2985),(55710,2985),(55711,2986),(55712,2986),(55713,2986),(55714,2987),(55715,2987),(55716,2987),(55717,2988),(55718,2988),(55719,2988),(55720,2989),(55721,2989),(55722,2989),(55723,2990),(55724,2990),(55725,2990),(55726,2991),(55727,2991),(55728,2991),(55729,2992),(55730,2992),(55731,2992),(55732,2993),(55733,2993),(55734,2993),(55735,2994),(55736,2994),(55737,2994),(55738,2995),(55739,2995),(55740,2995),(55741,2996),(55742,2996),(55743,2996),(55744,2997),(55745,2997),(55746,2997),(55747,2998),(55748,2998),(55749,2998),(55750,2999),(55751,2999),(55752,2999),(55753,3000),(55754,3000),(55755,3000),(55756,3001),(55757,3001),(55758,3001),(55759,3002),(55760,3002),(55761,3002),(55762,3003),(55763,3003),(55764,3003),(55765,3004),(55766,3004),(55767,3004),(55768,3005),(55769,3005),(55770,3005),(55771,3006),(55772,3006),(55773,3006),(55774,3007),(55775,3007),(55776,3007),(55777,3008),(55778,3008),(55779,3008),(55780,3009),(55781,3009),(55782,3009),(55783,3010),(55784,3010),(55785,3010),(55786,3011),(55787,3011),(55788,3011),(55789,3012),(55790,3012),(55791,3012),(55792,3013),(55793,3013),(55794,3013),(55795,3014),(55796,3014),(55797,3014),(55798,3015),(55799,3015),(55800,3015),(55801,3016),(55802,3016),(55803,3016),(55804,3017),(55805,3017),(55806,3017),(55807,3018),(55808,3018),(55809,3018),(55810,3019),(55811,3019),(55812,3019),(55813,3020),(55814,3020),(55815,3020),(55816,3021),(55817,3021),(55818,3021),(55819,2922),(55820,2922),(55821,2922),(55822,2922),(55823,2923),(55824,2923),(55825,2923),(55826,2923),(55827,2924),(55828,2924),(55829,2924),(55830,2924),(55831,2925),(55832,2925),(55833,2925),(55834,2925),(55835,2926),(55836,2926),(55837,2926),(55838,2926),(55839,2927),(55840,2927),(55841,2927),(55842,2927),(55843,2928),(55844,2928),(55845,2928),(55846,2928),(55847,2929),(55848,2929),(55849,2929),(55850,2929),(55851,2930),(55852,2930),(55853,2930),(55854,2930),(55855,2931),(55856,2931),(55857,2931),(55858,2931),(55859,2932),(55860,2932),(55861,2932),(55862,2932),(55863,2933),(55864,2933),(55865,2933),(55866,2933),(55867,2934),(55868,2934),(55869,2934),(55870,2934),(55871,2935),(55872,2935),(55873,2935),(55874,2935),(55875,2936),(55876,2936),(55877,2936),(55878,2936),(55879,2937),(55880,2937),(55881,2937),(55882,2937),(55883,2938),(55884,2938),(55885,2938),(55886,2938),(55887,2939),(55888,2939),(55889,2939),(55890,2939),(55891,2940),(55892,2940),(55893,2940),(55894,2940),(55895,2941),(55896,2941),(55897,2941),(55898,2941),(55899,2942),(55900,2942),(55901,2942),(55902,2942),(55903,2943),(55904,2943),(55905,2943),(55906,2943),(55907,2944),(55908,2944),(55909,2944),(55910,2944),(55911,2945),(55912,2945),(55913,2945),(55914,2945),(55915,2946),(55916,2946),(55917,2946),(55918,2946),(55919,2947),(55920,2947),(55921,2947),(55922,2947),(55923,2948),(55924,2948),(55925,2948),(55926,2948),(55927,2949),(55928,2949),(55929,2949),(55930,2949),(55931,2950),(55932,2950),(55933,2950),(55934,2950),(55935,2951),(55936,2951),(55937,2951),(55938,2951),(55939,2952),(55940,2952),(55941,2952),(55942,2952),(55943,2953),(55944,2953),(55945,2953),(55946,2953),(55947,2954),(55948,2954),(55949,2954),(55950,2954),(55951,2955),(55952,2955),(55953,2955),(55954,2955),(55955,2956),(55956,2956),(55957,2956),(55958,2956),(55959,2957),(55960,2957),(55961,2957),(55962,2957),(55963,2958),(55964,2958),(55965,2958),(55966,2958),(55967,2959),(55968,2959),(55969,2959),(55970,2959),(55971,2960),(55972,2960),(55973,2960),(55974,2960),(55975,2961),(55976,2961),(55977,2961),(55978,2961),(55979,2962),(55980,2962),(55981,2962),(55982,2962),(55983,2963),(55984,2963),(55985,2963),(55986,2963),(55987,2964),(55988,2964),(55989,2964),(55990,2964),(55991,2965),(55992,2965),(55993,2965),(55994,2965),(55995,2966),(55996,2966),(55997,2966),(55998,2966),(55999,2967),(56000,2967),(56001,2967),(56002,2967),(56003,2968),(56004,2968),(56005,2968),(56006,2968),(56007,2969),(56008,2969),(56009,2969),(56010,2969),(56011,2970),(56012,2970),(56013,2970),(56014,2970),(56015,2971),(56016,2971),(56017,2971),(56018,2971),(56019,2972),(56020,2972),(56021,2972),(56022,2972),(56023,2973),(56024,2973),(56025,2973),(56026,2973),(56027,2974),(56028,2974),(56029,2974),(56030,2974),(56031,2975),(56032,2975),(56033,2975),(56034,2975),(56035,2976),(56036,2976),(56037,2976),(56038,2976),(56039,2977),(56040,2977),(56041,2977),(56042,2977),(56043,2978),(56044,2978),(56045,2978),(56046,2978),(56047,2979),(56048,2979),(56049,2979),(56050,2979),(56051,2980),(56052,2980),(56053,2980),(56054,2980),(56055,2981),(56056,2981),(56057,2981),(56058,2981),(56059,2982),(56060,2982),(56061,2982),(56062,2982),(56063,2983),(56064,2983),(56065,2983),(56066,2983),(56067,2984),(56068,2984),(56069,2984),(56070,2984),(56071,2985),(56072,2985),(56073,2985),(56074,2985),(56075,2986),(56076,2986),(56077,2986),(56078,2986),(56079,2987),(56080,2987),(56081,2987),(56082,2987),(56083,2988),(56084,2988),(56085,2988),(56086,2988),(56087,2989),(56088,2989),(56089,2989),(56090,2989),(56091,2990),(56092,2990),(56093,2990),(56094,2990),(56095,2991),(56096,2991),(56097,2991),(56098,2991),(56099,2992),(56100,2992),(56101,2992),(56102,2992),(56103,2993),(56104,2993),(56105,2993),(56106,2993),(56107,2994),(56108,2994),(56109,2994),(56110,2994),(56111,2995),(56112,2995),(56113,2995),(56114,2995),(56115,2996),(56116,2996),(56117,2996),(56118,2996),(56119,2997),(56120,2997),(56121,2997),(56122,2997),(56123,2998),(56124,2998),(56125,2998),(56126,2998),(56127,2999),(56128,2999),(56129,2999),(56130,2999),(56131,3000),(56132,3000),(56133,3000),(56134,3000),(56135,3001),(56136,3001),(56137,3001),(56138,3001),(56139,3002),(56140,3002),(56141,3002),(56142,3002),(56143,3003),(56144,3003),(56145,3003),(56146,3003),(56147,3004),(56148,3004),(56149,3004),(56150,3004),(56151,3005),(56152,3005),(56153,3005),(56154,3005),(56155,3006),(56156,3006),(56157,3006),(56158,3006),(56159,3007),(56160,3007),(56161,3007),(56162,3007),(56163,3008),(56164,3008),(56165,3008),(56166,3008),(56167,3009),(56168,3009),(56169,3009),(56170,3009),(56171,3010),(56172,3010),(56173,3010),(56174,3010),(56175,3011),(56176,3011),(56177,3011),(56178,3011),(56179,3012),(56180,3012),(56181,3012),(56182,3012),(56183,3013),(56184,3013),(56185,3013),(56186,3013),(56187,3014),(56188,3014),(56189,3014),(56190,3014),(56191,3015),(56192,3015),(56193,3015),(56194,3015),(56195,3016),(56196,3016),(56197,3016),(56198,3016),(56199,3017),(56200,3017),(56201,3017),(56202,3017),(56203,3018),(56204,3018),(56205,3018),(56206,3018),(56207,3019),(56208,3019),(56209,3019),(56210,3019),(56211,3020),(56212,3020),(56213,3020),(56214,3020),(56215,3021),(56216,3021),(56217,3021),(56218,3021),(56219,3022),(56220,3023),(56221,3024),(56222,3025),(56223,3026),(56224,3027),(56225,3028),(56226,3029),(56227,3030),(56228,3031),(56229,3032),(56230,3033),(56231,3034),(56232,3035),(56233,3036),(56234,3037),(56235,3038),(56236,3039),(56237,3040),(56238,3041),(56239,3042),(56240,3043),(56241,3044),(56242,3045),(56243,3046),(56244,3047),(56245,3048),(56246,3049),(56247,3050),(56248,3051),(56249,3052),(56250,3053),(56251,3054),(56252,3055),(56253,3056),(56254,3057),(56255,3058),(56256,3059),(56257,3060),(56258,3061),(56259,3062),(56260,3063),(56261,3064),(56262,3065),(56263,3066),(56264,3067),(56265,3068),(56266,3069),(56267,3070),(56268,3071),(56269,3072),(56270,3073),(56271,3074),(56272,3075),(56273,3076),(56274,3077),(56275,3078),(56276,3079),(56277,3080),(56278,3081),(56279,3082),(56280,3083),(56281,3084),(56282,3085),(56283,3086),(56284,3087),(56285,3088),(56286,3089),(56287,3090),(56288,3091),(56289,3092),(56290,3093),(56291,3094),(56292,3095),(56293,3096),(56294,3097),(56295,3098),(56296,3099),(56297,3100),(56298,3101),(56299,3102),(56300,3103),(56301,3104),(56302,3105),(56303,3106),(56304,3107),(56305,3108),(56306,3109),(56307,3110),(56308,3111),(56309,3112),(56310,3113),(56311,3114),(56312,3115),(56313,3116),(56314,3117),(56315,3118),(56316,3119),(56317,3120),(56318,3121),(56319,3022),(56320,3023),(56321,3024),(56322,3025),(56323,3026),(56324,3027),(56325,3028),(56326,3029),(56327,3030),(56328,3031),(56329,3032),(56330,3033),(56331,3034),(56332,3035),(56333,3036),(56334,3037),(56335,3038),(56336,3039),(56337,3040),(56338,3041),(56339,3042),(56340,3043),(56341,3044),(56342,3045),(56343,3046),(56344,3047),(56345,3048),(56346,3049),(56347,3050),(56348,3051),(56349,3052),(56350,3053),(56351,3054),(56352,3055),(56353,3056),(56354,3057),(56355,3058),(56356,3059),(56357,3060),(56358,3061),(56359,3062),(56360,3063),(56361,3064),(56362,3065),(56363,3066),(56364,3067),(56365,3068),(56366,3069),(56367,3070),(56368,3071),(56369,3072),(56370,3073),(56371,3074),(56372,3075),(56373,3076),(56374,3077),(56375,3078),(56376,3079),(56377,3080),(56378,3081),(56379,3082),(56380,3083),(56381,3084),(56382,3085),(56383,3086),(56384,3087),(56385,3088),(56386,3089),(56387,3090),(56388,3091),(56389,3092),(56390,3093),(56391,3094),(56392,3095),(56393,3096),(56394,3097),(56395,3098),(56396,3099),(56397,3100),(56398,3101),(56399,3102),(56400,3103),(56401,3104),(56402,3105),(56403,3106),(56404,3107),(56405,3108),(56406,3109),(56407,3110),(56408,3111),(56409,3112),(56410,3113),(56411,3114),(56412,3115),(56413,3116),(56414,3117),(56415,3118),(56416,3119),(56417,3120),(56418,3121),(56419,3022),(56420,3022),(56421,3022),(56422,3022),(56423,3022),(56424,3022),(56425,3023),(56426,3023),(56427,3023),(56428,3023),(56429,3023),(56430,3023),(56431,3024),(56432,3024),(56433,3024),(56434,3024),(56435,3024),(56436,3024),(56437,3025),(56438,3025),(56439,3025),(56440,3025),(56441,3025),(56442,3025),(56443,3026),(56444,3026),(56445,3026),(56446,3026),(56447,3026),(56448,3026),(56449,3027),(56450,3027),(56451,3027),(56452,3027),(56453,3027),(56454,3027),(56455,3028),(56456,3028),(56457,3028),(56458,3028),(56459,3028),(56460,3028),(56461,3029),(56462,3029),(56463,3029),(56464,3029),(56465,3029),(56466,3029),(56467,3030),(56468,3030),(56469,3030),(56470,3030),(56471,3030),(56472,3030),(56473,3031),(56474,3031),(56475,3031),(56476,3031),(56477,3031),(56478,3031),(56479,3032),(56480,3032),(56481,3032),(56482,3032),(56483,3032),(56484,3032),(56485,3033),(56486,3033),(56487,3033),(56488,3033),(56489,3033),(56490,3033),(56491,3034),(56492,3034),(56493,3034),(56494,3034),(56495,3034),(56496,3034),(56497,3035),(56498,3035),(56499,3035),(56500,3035),(56501,3035),(56502,3035),(56503,3036),(56504,3036),(56505,3036),(56506,3036),(56507,3036),(56508,3036),(56509,3037),(56510,3037),(56511,3037),(56512,3037),(56513,3037),(56514,3037),(56515,3038),(56516,3038),(56517,3038),(56518,3038),(56519,3039),(56520,3039),(56521,3039),(56522,3039),(56523,3040),(56524,3040),(56525,3040),(56526,3040),(56527,3041),(56528,3041),(56529,3041),(56530,3041),(56531,3042),(56532,3042),(56533,3042),(56534,3042),(56535,3042),(56536,3042),(56537,3043),(56538,3043),(56539,3043),(56540,3043),(56541,3043),(56542,3043),(56543,3044),(56544,3044),(56545,3044),(56546,3044),(56547,3045),(56548,3045),(56549,3045),(56550,3045),(56551,3046),(56552,3046),(56553,3046),(56554,3046),(56555,3047),(56556,3047),(56557,3047),(56558,3047),(56559,3048),(56560,3048),(56561,3048),(56562,3048),(56563,3048),(56564,3048),(56565,3049),(56566,3049),(56567,3049),(56568,3049),(56569,3049),(56570,3049),(56571,3050),(56572,3050),(56573,3050),(56574,3050),(56575,3050),(56576,3050),(56577,3051),(56578,3051),(56579,3051),(56580,3051),(56581,3051),(56582,3051),(56583,3052),(56584,3052),(56585,3052),(56586,3052),(56587,3052),(56588,3052),(56589,3053),(56590,3053),(56591,3053),(56592,3053),(56593,3053),(56594,3053),(56595,3054),(56596,3054),(56597,3054),(56598,3054),(56599,3054),(56600,3054),(56601,3055),(56602,3055),(56603,3055),(56604,3055),(56605,3055),(56606,3055),(56607,3056),(56608,3056),(56609,3056),(56610,3056),(56611,3057),(56612,3057),(56613,3057),(56614,3057),(56615,3058),(56616,3058),(56617,3058),(56618,3058),(56619,3059),(56620,3059),(56621,3059),(56622,3059),(56623,3060),(56624,3060),(56625,3060),(56626,3060),(56627,3061),(56628,3061),(56629,3061),(56630,3061),(56631,3062),(56632,3062),(56633,3062),(56634,3062),(56635,3063),(56636,3063),(56637,3063),(56638,3063),(56639,3064),(56640,3064),(56641,3064),(56642,3064),(56643,3065),(56644,3065),(56645,3065),(56646,3065),(56647,3065),(56648,3065),(56649,3066),(56650,3066),(56651,3066),(56652,3066),(56653,3066),(56654,3066),(56655,3067),(56656,3067),(56657,3067),(56658,3067),(56659,3067),(56660,3067),(56661,3068),(56662,3068),(56663,3068),(56664,3068),(56665,3068),(56666,3068),(56667,3069),(56668,3069),(56669,3069),(56670,3069),(56671,3069),(56672,3069),(56673,3070),(56674,3070),(56675,3070),(56676,3070),(56677,3070),(56678,3070),(56679,3071),(56680,3071),(56681,3071),(56682,3071),(56683,3071),(56684,3071),(56685,3072),(56686,3072),(56687,3072),(56688,3072),(56689,3072),(56690,3072),(56691,3073),(56692,3073),(56693,3073),(56694,3073),(56695,3073),(56696,3073),(56697,3074),(56698,3074),(56699,3074),(56700,3074),(56701,3074),(56702,3074),(56703,3075),(56704,3075),(56705,3075),(56706,3075),(56707,3075),(56708,3075),(56709,3076),(56710,3076),(56711,3076),(56712,3076),(56713,3076),(56714,3076),(56715,3077),(56716,3077),(56717,3077),(56718,3077),(56719,3077),(56720,3077),(56721,3078),(56722,3078),(56723,3078),(56724,3078),(56725,3078),(56726,3078),(56727,3079),(56728,3079),(56729,3079),(56730,3079),(56731,3079),(56732,3079),(56733,3080),(56734,3080),(56735,3080),(56736,3080),(56737,3080),(56738,3080),(56739,3081),(56740,3081),(56741,3081),(56742,3081),(56743,3081),(56744,3081),(56745,3082),(56746,3082),(56747,3082),(56748,3082),(56749,3082),(56750,3082),(56751,3083),(56752,3083),(56753,3083),(56754,3083),(56755,3083),(56756,3083),(56757,3084),(56758,3084),(56759,3084),(56760,3084),(56761,3084),(56762,3084),(56763,3085),(56764,3085),(56765,3085),(56766,3085),(56767,3085),(56768,3085),(56769,3086),(56770,3086),(56771,3086),(56772,3086),(56773,3086),(56774,3086),(56775,3087),(56776,3087),(56777,3087),(56778,3087),(56779,3087),(56780,3087),(56781,3088),(56782,3088),(56783,3088),(56784,3088),(56785,3088),(56786,3088),(56787,3089),(56788,3089),(56789,3089),(56790,3089),(56791,3089),(56792,3089),(56793,3090),(56794,3090),(56795,3090),(56796,3090),(56797,3090),(56798,3090),(56799,3091),(56800,3091),(56801,3091),(56802,3091),(56803,3091),(56804,3091),(56805,3092),(56806,3092),(56807,3092),(56808,3092),(56809,3092),(56810,3092),(56811,3093),(56812,3093),(56813,3093),(56814,3093),(56815,3093),(56816,3093),(56817,3094),(56818,3094),(56819,3094),(56820,3094),(56821,3094),(56822,3094),(56823,3095),(56824,3095),(56825,3095),(56826,3095),(56827,3095),(56828,3095),(56829,3096),(56830,3096),(56831,3096),(56832,3096),(56833,3096),(56834,3096),(56835,3097),(56836,3097),(56837,3097),(56838,3097),(56839,3097),(56840,3097),(56841,3098),(56842,3098),(56843,3098),(56844,3098),(56845,3098),(56846,3098),(56847,3099),(56848,3099),(56849,3099),(56850,3099),(56851,3099),(56852,3099),(56853,3100),(56854,3100),(56855,3100),(56856,3100),(56857,3100),(56858,3100),(56859,3101),(56860,3101),(56861,3101),(56862,3101),(56863,3101),(56864,3101),(56865,3102),(56866,3102),(56867,3102),(56868,3102),(56869,3102),(56870,3102),(56871,3103),(56872,3103),(56873,3103),(56874,3103),(56875,3103),(56876,3103),(56877,3104),(56878,3104),(56879,3104),(56880,3104),(56881,3104),(56882,3104),(56883,3105),(56884,3105),(56885,3105),(56886,3105),(56887,3105),(56888,3105),(56889,3106),(56890,3106),(56891,3106),(56892,3106),(56893,3106),(56894,3106),(56895,3107),(56896,3107),(56897,3107),(56898,3107),(56899,3107),(56900,3107),(56901,3108),(56902,3108),(56903,3108),(56904,3108),(56905,3108),(56906,3108),(56907,3109),(56908,3109),(56909,3109),(56910,3109),(56911,3109),(56912,3109),(56913,3110),(56914,3110),(56915,3110),(56916,3110),(56917,3111),(56918,3111),(56919,3111),(56920,3111),(56921,3112),(56922,3112),(56923,3112),(56924,3112),(56925,3113),(56926,3113),(56927,3113),(56928,3113),(56929,3114),(56930,3114),(56931,3114),(56932,3114),(56933,3115),(56934,3115),(56935,3115),(56936,3115),(56937,3116),(56938,3116),(56939,3116),(56940,3116),(56941,3117),(56942,3117),(56943,3117),(56944,3117),(56945,3118),(56946,3118),(56947,3118),(56948,3118),(56949,3118),(56950,3118),(56951,3119),(56952,3119),(56953,3119),(56954,3119),(56955,3120),(56956,3120),(56957,3120),(56958,3120),(56959,3121),(56960,3121),(56961,3121),(56962,3121),(56963,3022),(56964,3022),(56965,3022),(56966,3023),(56967,3023),(56968,3023),(56969,3024),(56970,3024),(56971,3024),(56972,3025),(56973,3025),(56974,3025),(56975,3026),(56976,3026),(56977,3026),(56978,3027),(56979,3027),(56980,3027),(56981,3028),(56982,3028),(56983,3028),(56984,3029),(56985,3029),(56986,3029),(56987,3030),(56988,3030),(56989,3030),(56990,3031),(56991,3031),(56992,3031),(56993,3032),(56994,3032),(56995,3032),(56996,3033),(56997,3033),(56998,3033),(56999,3034),(57000,3034),(57001,3034),(57002,3035),(57003,3035),(57004,3035),(57005,3036),(57006,3036),(57007,3036),(57008,3037),(57009,3037),(57010,3037),(57011,3038),(57012,3038),(57013,3039),(57014,3039),(57015,3040),(57016,3040),(57017,3041),(57018,3041),(57019,3042),(57020,3042),(57021,3043),(57022,3043),(57023,3044),(57024,3044),(57025,3045),(57026,3045),(57027,3046),(57028,3046),(57029,3047),(57030,3047),(57031,3048),(57032,3048),(57033,3048),(57034,3049),(57035,3049),(57036,3049),(57037,3050),(57038,3050),(57039,3051),(57040,3051),(57041,3052),(57042,3052),(57043,3053),(57044,3053),(57045,3054),(57046,3054),(57047,3055),(57048,3055),(57049,3056),(57050,3056),(57051,3057),(57052,3057),(57053,3058),(57054,3058),(57055,3059),(57056,3059),(57057,3060),(57058,3060),(57059,3061),(57060,3061),(57061,3062),(57062,3062),(57063,3063),(57064,3063),(57065,3064),(57066,3064),(57067,3065),(57068,3065),(57069,3065),(57070,3066),(57071,3066),(57072,3066),(57073,3067),(57074,3067),(57075,3067),(57076,3068),(57077,3068),(57078,3068),(57079,3069),(57080,3069),(57081,3069),(57082,3070),(57083,3070),(57084,3070),(57085,3071),(57086,3071),(57087,3071),(57088,3072),(57089,3072),(57090,3072),(57091,3073),(57092,3073),(57093,3073),(57094,3074),(57095,3074),(57096,3074),(57097,3075),(57098,3075),(57099,3075),(57100,3076),(57101,3076),(57102,3076),(57103,3077),(57104,3077),(57105,3077),(57106,3078),(57107,3078),(57108,3078),(57109,3079),(57110,3079),(57111,3079),(57112,3080),(57113,3080),(57114,3080),(57115,3081),(57116,3081),(57117,3081),(57118,3082),(57119,3082),(57120,3082),(57121,3083),(57122,3083),(57123,3083),(57124,3084),(57125,3084),(57126,3084),(57127,3085),(57128,3085),(57129,3085),(57130,3086),(57131,3086),(57132,3086),(57133,3087),(57134,3087),(57135,3087),(57136,3088),(57137,3088),(57138,3088),(57139,3089),(57140,3089),(57141,3089),(57142,3090),(57143,3090),(57144,3090),(57145,3091),(57146,3091),(57147,3091),(57148,3092),(57149,3092),(57150,3092),(57151,3093),(57152,3093),(57153,3093),(57154,3094),(57155,3094),(57156,3094),(57157,3095),(57158,3095),(57159,3095),(57160,3096),(57161,3096),(57162,3096),(57163,3097),(57164,3097),(57165,3097),(57166,3098),(57167,3098),(57168,3098),(57169,3099),(57170,3099),(57171,3099),(57172,3100),(57173,3100),(57174,3100),(57175,3101),(57176,3101),(57177,3101),(57178,3102),(57179,3102),(57180,3103),(57181,3103),(57182,3103),(57183,3104),(57184,3104),(57185,3104),(57186,3105),(57187,3105),(57188,3105),(57189,3106),(57190,3106),(57191,3106),(57192,3107),(57193,3107),(57194,3107),(57195,3108),(57196,3108),(57197,3108),(57198,3109),(57199,3109),(57200,3109),(57201,3110),(57202,3110),(57203,3111),(57204,3111),(57205,3112),(57206,3112),(57207,3113),(57208,3113),(57209,3114),(57210,3114),(57211,3115),(57212,3115),(57213,3116),(57214,3116),(57215,3117),(57216,3117),(57217,3118),(57218,3118),(57219,3119),(57220,3119),(57221,3120),(57222,3120),(57223,3121),(57224,3121),(57225,3022),(57226,3022),(57227,3022),(57228,3023),(57229,3023),(57230,3023),(57231,3024),(57232,3024),(57233,3024),(57234,3025),(57235,3025),(57236,3025),(57237,3026),(57238,3026),(57239,3026),(57240,3027),(57241,3027),(57242,3027),(57243,3028),(57244,3028),(57245,3028),(57246,3029),(57247,3029),(57248,3029),(57249,3030),(57250,3030),(57251,3030),(57252,3031),(57253,3031),(57254,3031),(57255,3032),(57256,3032),(57257,3032),(57258,3033),(57259,3033),(57260,3033),(57261,3034),(57262,3034),(57263,3034),(57264,3035),(57265,3035),(57266,3035),(57267,3036),(57268,3036),(57269,3036),(57270,3037),(57271,3037),(57272,3037),(57273,3038),(57274,3038),(57275,3038),(57276,3039),(57277,3039),(57278,3039),(57279,3040),(57280,3040),(57281,3040),(57282,3041),(57283,3041),(57284,3041),(57285,3042),(57286,3042),(57287,3042),(57288,3043),(57289,3043),(57290,3043),(57291,3044),(57292,3044),(57293,3044),(57294,3045),(57295,3045),(57296,3045),(57297,3046),(57298,3046),(57299,3046),(57300,3047),(57301,3047),(57302,3047),(57303,3048),(57304,3048),(57305,3048),(57306,3049),(57307,3049),(57308,3049),(57309,3050),(57310,3050),(57311,3050),(57312,3051),(57313,3051),(57314,3051),(57315,3052),(57316,3052),(57317,3052),(57318,3053),(57319,3053),(57320,3053),(57321,3054),(57322,3054),(57323,3054),(57324,3055),(57325,3055),(57326,3055),(57327,3056),(57328,3056),(57329,3056),(57330,3057),(57331,3057),(57332,3057),(57333,3058),(57334,3058),(57335,3058),(57336,3059),(57337,3059),(57338,3059),(57339,3060),(57340,3060),(57341,3060),(57342,3061),(57343,3061),(57344,3061),(57345,3062),(57346,3062),(57347,3062),(57348,3063),(57349,3063),(57350,3063),(57351,3064),(57352,3064),(57353,3064),(57354,3065),(57355,3065),(57356,3065),(57357,3066),(57358,3066),(57359,3066),(57360,3067),(57361,3067),(57362,3067),(57363,3068),(57364,3068),(57365,3068),(57366,3069),(57367,3069),(57368,3069),(57369,3070),(57370,3070),(57371,3070),(57372,3071),(57373,3071),(57374,3071),(57375,3072),(57376,3072),(57377,3072),(57378,3073),(57379,3073),(57380,3073),(57381,3074),(57382,3074),(57383,3074),(57384,3075),(57385,3075),(57386,3075),(57387,3076),(57388,3076),(57389,3076),(57390,3077),(57391,3077),(57392,3077),(57393,3078),(57394,3078),(57395,3078),(57396,3079),(57397,3079),(57398,3079),(57399,3080),(57400,3080),(57401,3080),(57402,3081),(57403,3081),(57404,3081),(57405,3082),(57406,3082),(57407,3082),(57408,3083),(57409,3083),(57410,3083),(57411,3084),(57412,3084),(57413,3084),(57414,3085),(57415,3085),(57416,3085),(57417,3086),(57418,3086),(57419,3086),(57420,3087),(57421,3087),(57422,3087),(57423,3088),(57424,3088),(57425,3088),(57426,3089),(57427,3089),(57428,3089),(57429,3090),(57430,3090),(57431,3090),(57432,3091),(57433,3091),(57434,3091),(57435,3092),(57436,3092),(57437,3092),(57438,3093),(57439,3093),(57440,3093),(57441,3094),(57442,3094),(57443,3094),(57444,3095),(57445,3095),(57446,3095),(57447,3096),(57448,3096),(57449,3096),(57450,3097),(57451,3097),(57452,3097),(57453,3098),(57454,3098),(57455,3098),(57456,3099),(57457,3099),(57458,3099),(57459,3100),(57460,3100),(57461,3100),(57462,3101),(57463,3101),(57464,3101),(57465,3102),(57466,3102),(57467,3102),(57468,3103),(57469,3103),(57470,3103),(57471,3104),(57472,3104),(57473,3104),(57474,3105),(57475,3105),(57476,3105),(57477,3106),(57478,3106),(57479,3106),(57480,3107),(57481,3107),(57482,3107),(57483,3108),(57484,3108),(57485,3108),(57486,3109),(57487,3109),(57488,3109),(57489,3110),(57490,3110),(57491,3110),(57492,3111),(57493,3111),(57494,3111),(57495,3112),(57496,3112),(57497,3112),(57498,3113),(57499,3113),(57500,3113),(57501,3114),(57502,3114),(57503,3114),(57504,3115),(57505,3115),(57506,3115),(57507,3116),(57508,3116),(57509,3116),(57510,3117),(57511,3117),(57512,3117),(57513,3118),(57514,3118),(57515,3118),(57516,3119),(57517,3119),(57518,3119),(57519,3120),(57520,3120),(57521,3120),(57522,3121),(57523,3121),(57524,3121),(57525,3022),(57526,3022),(57527,3022),(57528,3022),(57529,3023),(57530,3023),(57531,3023),(57532,3023),(57533,3024),(57534,3024),(57535,3024),(57536,3024),(57537,3025),(57538,3025),(57539,3025),(57540,3025),(57541,3026),(57542,3026),(57543,3026),(57544,3026),(57545,3027),(57546,3027),(57547,3027),(57548,3027),(57549,3028),(57550,3028),(57551,3028),(57552,3028),(57553,3029),(57554,3029),(57555,3029),(57556,3029),(57557,3030),(57558,3030),(57559,3030),(57560,3030),(57561,3031),(57562,3031),(57563,3031),(57564,3031),(57565,3032),(57566,3032),(57567,3032),(57568,3032),(57569,3033),(57570,3033),(57571,3033),(57572,3033),(57573,3034),(57574,3034),(57575,3034),(57576,3034),(57577,3035),(57578,3035),(57579,3035),(57580,3035),(57581,3036),(57582,3036),(57583,3036),(57584,3036),(57585,3037),(57586,3037),(57587,3037),(57588,3037),(57589,3038),(57590,3038),(57591,3038),(57592,3038),(57593,3039),(57594,3039),(57595,3039),(57596,3039),(57597,3040),(57598,3040),(57599,3040),(57600,3040),(57601,3041),(57602,3041),(57603,3041),(57604,3041),(57605,3042),(57606,3042),(57607,3042),(57608,3042),(57609,3043),(57610,3043),(57611,3043),(57612,3043),(57613,3044),(57614,3044),(57615,3044),(57616,3044),(57617,3045),(57618,3045),(57619,3045),(57620,3045),(57621,3046),(57622,3046),(57623,3046),(57624,3046),(57625,3047),(57626,3047),(57627,3047),(57628,3047),(57629,3048),(57630,3048),(57631,3048),(57632,3048),(57633,3049),(57634,3049),(57635,3049),(57636,3049),(57637,3050),(57638,3050),(57639,3050),(57640,3050),(57641,3051),(57642,3051),(57643,3051),(57644,3051),(57645,3052),(57646,3052),(57647,3052),(57648,3052),(57649,3053),(57650,3053),(57651,3053),(57652,3053),(57653,3054),(57654,3054),(57655,3054),(57656,3054),(57657,3055),(57658,3055),(57659,3055),(57660,3055),(57661,3056),(57662,3056),(57663,3056),(57664,3056),(57665,3057),(57666,3057),(57667,3057),(57668,3057),(57669,3058),(57670,3058),(57671,3058),(57672,3058),(57673,3059),(57674,3059),(57675,3059),(57676,3059),(57677,3060),(57678,3060),(57679,3060),(57680,3060),(57681,3061),(57682,3061),(57683,3061),(57684,3061),(57685,3062),(57686,3062),(57687,3062),(57688,3062),(57689,3063),(57690,3063),(57691,3063),(57692,3063),(57693,3064),(57694,3064),(57695,3064),(57696,3064),(57697,3065),(57698,3065),(57699,3065),(57700,3065),(57701,3066),(57702,3066),(57703,3066),(57704,3066),(57705,3067),(57706,3067),(57707,3067),(57708,3067),(57709,3068),(57710,3068),(57711,3068),(57712,3068),(57713,3069),(57714,3069),(57715,3069),(57716,3069),(57717,3070),(57718,3070),(57719,3070),(57720,3070),(57721,3071),(57722,3071),(57723,3071),(57724,3071),(57725,3072),(57726,3072),(57727,3072),(57728,3072),(57729,3073),(57730,3073),(57731,3073),(57732,3073),(57733,3074),(57734,3074),(57735,3074),(57736,3074),(57737,3075),(57738,3075),(57739,3075),(57740,3075),(57741,3076),(57742,3076),(57743,3076),(57744,3076),(57745,3077),(57746,3077),(57747,3077),(57748,3077),(57749,3078),(57750,3078),(57751,3078),(57752,3078),(57753,3079),(57754,3079),(57755,3079),(57756,3079),(57757,3080),(57758,3080),(57759,3080),(57760,3080),(57761,3081),(57762,3081),(57763,3081),(57764,3081),(57765,3082),(57766,3082),(57767,3082),(57768,3082),(57769,3083),(57770,3083),(57771,3083),(57772,3083),(57773,3084),(57774,3084),(57775,3084),(57776,3084),(57777,3085),(57778,3085),(57779,3085),(57780,3085),(57781,3086),(57782,3086),(57783,3086),(57784,3086),(57785,3087),(57786,3087),(57787,3087),(57788,3087),(57789,3088),(57790,3088),(57791,3088),(57792,3088),(57793,3089),(57794,3089),(57795,3089),(57796,3089),(57797,3090),(57798,3090),(57799,3090),(57800,3090),(57801,3091),(57802,3091),(57803,3091),(57804,3091),(57805,3092),(57806,3092),(57807,3092),(57808,3092),(57809,3093),(57810,3093),(57811,3093),(57812,3093),(57813,3094),(57814,3094),(57815,3094),(57816,3094),(57817,3095),(57818,3095),(57819,3095),(57820,3095),(57821,3096),(57822,3096),(57823,3096),(57824,3096),(57825,3097),(57826,3097),(57827,3097),(57828,3097),(57829,3098),(57830,3098),(57831,3098),(57832,3098),(57833,3099),(57834,3099),(57835,3099),(57836,3099),(57837,3100),(57838,3100),(57839,3100),(57840,3100),(57841,3101),(57842,3101),(57843,3101),(57844,3101),(57845,3102),(57846,3102),(57847,3102),(57848,3102),(57849,3103),(57850,3103),(57851,3103),(57852,3103),(57853,3104),(57854,3104),(57855,3104),(57856,3104),(57857,3105),(57858,3105),(57859,3105),(57860,3105),(57861,3106),(57862,3106),(57863,3106),(57864,3106),(57865,3107),(57866,3107),(57867,3107),(57868,3107),(57869,3108),(57870,3108),(57871,3108),(57872,3108),(57873,3109),(57874,3109),(57875,3109),(57876,3109),(57877,3110),(57878,3110),(57879,3110),(57880,3110),(57881,3111),(57882,3111),(57883,3111),(57884,3111),(57885,3112),(57886,3112),(57887,3112),(57888,3112),(57889,3113),(57890,3113),(57891,3113),(57892,3113),(57893,3114),(57894,3114),(57895,3114),(57896,3114),(57897,3115),(57898,3115),(57899,3115),(57900,3115),(57901,3116),(57902,3116),(57903,3116),(57904,3116),(57905,3117),(57906,3117),(57907,3117),(57908,3117),(57909,3118),(57910,3118),(57911,3118),(57912,3118),(57913,3119),(57914,3119),(57915,3119),(57916,3119),(57917,3120),(57918,3120),(57919,3120),(57920,3120),(57921,3121),(57922,3121),(57923,3121),(57924,3121),(57925,3122),(57926,3123),(57927,3124),(57928,3125),(57929,3126),(57930,3127),(57931,3128),(57932,3129),(57933,3130),(57934,3131),(57935,3132),(57936,3133),(57937,3134),(57938,3135),(57939,3136),(57940,3137),(57941,3138),(57942,3139),(57943,3140),(57944,3141),(57945,3142),(57946,3143),(57947,3144),(57948,3145),(57949,3146),(57950,3147),(57951,3148),(57952,3149),(57953,3150),(57954,3151),(57955,3152),(57956,3153),(57957,3154),(57958,3155),(57959,3156),(57960,3157),(57961,3158),(57962,3159),(57963,3160),(57964,3161),(57965,3162),(57966,3163),(57967,3164),(57968,3165),(57969,3166),(57970,3167),(57971,3168),(57972,3122),(57973,3123),(57974,3124),(57975,3125),(57976,3126),(57977,3127),(57978,3128),(57979,3129),(57980,3130),(57981,3131),(57982,3132),(57983,3133),(57984,3134),(57985,3135),(57986,3136),(57987,3137),(57988,3138),(57989,3139),(57990,3140),(57991,3141),(57992,3142),(57993,3143),(57994,3144),(57995,3145),(57996,3146),(57997,3147),(57998,3148),(57999,3149),(58000,3150),(58001,3151),(58002,3152),(58003,3153),(58004,3154),(58005,3155),(58006,3156),(58007,3157),(58008,3158),(58009,3159),(58010,3160),(58011,3161),(58012,3162),(58013,3163),(58014,3164),(58015,3165),(58016,3166),(58017,3167),(58018,3168),(58019,3122),(58020,3122),(58021,3122),(58022,3122),(58023,3123),(58024,3123),(58025,3123),(58026,3123),(58027,3124),(58028,3124),(58029,3124),(58030,3124),(58031,3125),(58032,3125),(58033,3125),(58034,3125),(58035,3125),(58036,3125),(58037,3126),(58038,3126),(58039,3126),(58040,3126),(58041,3126),(58042,3126),(58043,3127),(58044,3127),(58045,3127),(58046,3127),(58047,3127),(58048,3127),(58049,3128),(58050,3128),(58051,3128),(58052,3128),(58053,3128),(58054,3128),(58055,3129),(58056,3129),(58057,3129),(58058,3129),(58059,3129),(58060,3129),(58061,3130),(58062,3130),(58063,3130),(58064,3130),(58065,3130),(58066,3130),(58067,3131),(58068,3131),(58069,3131),(58070,3131),(58071,3131),(58072,3131),(58073,3132),(58074,3132),(58075,3132),(58076,3132),(58077,3132),(58078,3132),(58079,3133),(58080,3133),(58081,3133),(58082,3133),(58083,3133),(58084,3133),(58085,3134),(58086,3134),(58087,3134),(58088,3134),(58089,3134),(58090,3134),(58091,3135),(58092,3135),(58093,3135),(58094,3135),(58095,3135),(58096,3135),(58097,3136),(58098,3136),(58099,3136),(58100,3136),(58101,3136),(58102,3136),(58103,3137),(58104,3137),(58105,3137),(58106,3137),(58107,3137),(58108,3137),(58109,3138),(58110,3138),(58111,3138),(58112,3138),(58113,3138),(58114,3138),(58115,3139),(58116,3139),(58117,3139),(58118,3139),(58119,3139),(58120,3139),(58121,3140),(58122,3140),(58123,3140),(58124,3140),(58125,3140),(58126,3140),(58127,3141),(58128,3141),(58129,3141),(58130,3141),(58131,3141),(58132,3141),(58133,3142),(58134,3142),(58135,3142),(58136,3142),(58137,3142),(58138,3142),(58139,3143),(58140,3143),(58141,3143),(58142,3143),(58143,3143),(58144,3143),(58145,3144),(58146,3144),(58147,3144),(58148,3144),(58149,3144),(58150,3144),(58151,3145),(58152,3145),(58153,3145),(58154,3145),(58155,3145),(58156,3145),(58157,3146),(58158,3146),(58159,3146),(58160,3146),(58161,3146),(58162,3146),(58163,3147),(58164,3147),(58165,3147),(58166,3147),(58167,3147),(58168,3147),(58169,3148),(58170,3148),(58171,3148),(58172,3148),(58173,3148),(58174,3148),(58175,3149),(58176,3149),(58177,3149),(58178,3149),(58179,3149),(58180,3149),(58181,3150),(58182,3150),(58183,3150),(58184,3150),(58185,3150),(58186,3150),(58187,3151),(58188,3151),(58189,3151),(58190,3151),(58191,3151),(58192,3151),(58193,3152),(58194,3152),(58195,3152),(58196,3152),(58197,3152),(58198,3152),(58199,3153),(58200,3153),(58201,3153),(58202,3153),(58203,3153),(58204,3153),(58205,3154),(58206,3154),(58207,3154),(58208,3154),(58209,3154),(58210,3154),(58211,3155),(58212,3155),(58213,3155),(58214,3155),(58215,3155),(58216,3155),(58217,3156),(58218,3156),(58219,3156),(58220,3156),(58221,3156),(58222,3156),(58223,3157),(58224,3157),(58225,3157),(58226,3157),(58227,3157),(58228,3157),(58229,3158),(58230,3158),(58231,3158),(58232,3158),(58233,3158),(58234,3158),(58235,3159),(58236,3159),(58237,3159),(58238,3159),(58239,3159),(58240,3159),(58241,3160),(58242,3160),(58243,3160),(58244,3160),(58245,3160),(58246,3160),(58247,3161),(58248,3161),(58249,3161),(58250,3161),(58251,3161),(58252,3161),(58253,3162),(58254,3162),(58255,3162),(58256,3162),(58257,3162),(58258,3162),(58259,3163),(58260,3163),(58261,3163),(58262,3163),(58263,3163),(58264,3163),(58265,3164),(58266,3164),(58267,3164),(58268,3164),(58269,3164),(58270,3164),(58271,3165),(58272,3165),(58273,3165),(58274,3165),(58275,3165),(58276,3165),(58277,3166),(58278,3166),(58279,3166),(58280,3166),(58281,3166),(58282,3166),(58283,3167),(58284,3167),(58285,3167),(58286,3167),(58287,3167),(58288,3167),(58289,3168),(58290,3168),(58291,3168),(58292,3168),(58293,3168),(58294,3168),(58295,3122),(58296,3122),(58297,3123),(58298,3123),(58299,3124),(58300,3124),(58301,3125),(58302,3125),(58303,3126),(58304,3126),(58305,3127),(58306,3127),(58307,3128),(58308,3128),(58309,3129),(58310,3129),(58311,3130),(58312,3130),(58313,3131),(58314,3131),(58315,3132),(58316,3132),(58317,3133),(58318,3133),(58319,3134),(58320,3134),(58321,3135),(58322,3135),(58323,3136),(58324,3136),(58325,3137),(58326,3137),(58327,3138),(58328,3138),(58329,3139),(58330,3139),(58331,3140),(58332,3140),(58333,3141),(58334,3141),(58335,3142),(58336,3142),(58337,3143),(58338,3143),(58339,3144),(58340,3144),(58341,3145),(58342,3145),(58343,3146),(58344,3146),(58345,3147),(58346,3147),(58347,3148),(58348,3148),(58349,3149),(58350,3149),(58351,3150),(58352,3150),(58353,3151),(58354,3151),(58355,3152),(58356,3152),(58357,3153),(58358,3153),(58359,3154),(58360,3154),(58361,3155),(58362,3155),(58363,3156),(58364,3156),(58365,3157),(58366,3157),(58367,3158),(58368,3158),(58369,3159),(58370,3159),(58371,3160),(58372,3160),(58373,3161),(58374,3161),(58375,3162),(58376,3162),(58377,3163),(58378,3163),(58379,3164),(58380,3164),(58381,3165),(58382,3165),(58383,3166),(58384,3166),(58385,3167),(58386,3167),(58387,3168),(58388,3168),(58389,3122),(58390,3122),(58391,3122),(58392,3123),(58393,3123),(58394,3123),(58395,3124),(58396,3124),(58397,3124),(58398,3125),(58399,3125),(58400,3125),(58401,3126),(58402,3126),(58403,3126),(58404,3127),(58405,3127),(58406,3127),(58407,3128),(58408,3128),(58409,3128),(58410,3129),(58411,3129),(58412,3129),(58413,3130),(58414,3130),(58415,3130),(58416,3131),(58417,3131),(58418,3131),(58419,3132),(58420,3132),(58421,3132),(58422,3133),(58423,3133),(58424,3133),(58425,3134),(58426,3134),(58427,3134),(58428,3135),(58429,3135),(58430,3135),(58431,3136),(58432,3136),(58433,3136),(58434,3137),(58435,3137),(58436,3137),(58437,3138),(58438,3138),(58439,3138),(58440,3139),(58441,3139),(58442,3139),(58443,3140),(58444,3140),(58445,3140),(58446,3141),(58447,3141),(58448,3141),(58449,3142),(58450,3142),(58451,3142),(58452,3143),(58453,3143),(58454,3143),(58455,3144),(58456,3144),(58457,3144),(58458,3145),(58459,3145),(58460,3145),(58461,3146),(58462,3146),(58463,3146),(58464,3147),(58465,3147),(58466,3147),(58467,3148),(58468,3148),(58469,3148),(58470,3149),(58471,3149),(58472,3149),(58473,3150),(58474,3150),(58475,3150),(58476,3151),(58477,3151),(58478,3151),(58479,3152),(58480,3152),(58481,3152),(58482,3153),(58483,3153),(58484,3153),(58485,3154),(58486,3154),(58487,3154),(58488,3155),(58489,3155),(58490,3155),(58491,3156),(58492,3156),(58493,3156),(58494,3157),(58495,3157),(58496,3157),(58497,3158),(58498,3158),(58499,3158),(58500,3159),(58501,3159),(58502,3159),(58503,3160),(58504,3160),(58505,3160),(58506,3161),(58507,3161),(58508,3161),(58509,3162),(58510,3162),(58511,3162),(58512,3163),(58513,3163),(58514,3163),(58515,3164),(58516,3164),(58517,3164),(58518,3165),(58519,3165),(58520,3165),(58521,3166),(58522,3166),(58523,3166),(58524,3167),(58525,3167),(58526,3167),(58527,3168),(58528,3168),(58529,3168),(58530,3122),(58531,3122),(58532,3122),(58533,3122),(58534,3123),(58535,3123),(58536,3123),(58537,3123),(58538,3124),(58539,3124),(58540,3124),(58541,3124),(58542,3125),(58543,3125),(58544,3125),(58545,3125),(58546,3126),(58547,3126),(58548,3126),(58549,3126),(58550,3127),(58551,3127),(58552,3127),(58553,3127),(58554,3128),(58555,3128),(58556,3128),(58557,3128),(58558,3129),(58559,3129),(58560,3129),(58561,3129),(58562,3130),(58563,3130),(58564,3130),(58565,3130),(58566,3131),(58567,3131),(58568,3131),(58569,3131),(58570,3132),(58571,3132),(58572,3132),(58573,3132),(58574,3133),(58575,3133),(58576,3133),(58577,3133),(58578,3134),(58579,3134),(58580,3134),(58581,3134),(58582,3135),(58583,3135),(58584,3135),(58585,3135),(58586,3136),(58587,3136),(58588,3136),(58589,3136),(58590,3137),(58591,3137),(58592,3137),(58593,3137),(58594,3138),(58595,3138),(58596,3138),(58597,3138),(58598,3139),(58599,3139),(58600,3139),(58601,3139),(58602,3140),(58603,3140),(58604,3140),(58605,3140),(58606,3141),(58607,3141),(58608,3141),(58609,3141),(58610,3142),(58611,3142),(58612,3142),(58613,3142),(58614,3143),(58615,3143),(58616,3143),(58617,3143),(58618,3144),(58619,3144),(58620,3144),(58621,3144),(58622,3145),(58623,3145),(58624,3145),(58625,3145),(58626,3146),(58627,3146),(58628,3146),(58629,3146),(58630,3147),(58631,3147),(58632,3147),(58633,3147),(58634,3148),(58635,3148),(58636,3148),(58637,3148),(58638,3149),(58639,3149),(58640,3149),(58641,3149),(58642,3150),(58643,3150),(58644,3150),(58645,3150),(58646,3151),(58647,3151),(58648,3151),(58649,3151),(58650,3152),(58651,3152),(58652,3152),(58653,3152),(58654,3153),(58655,3153),(58656,3153),(58657,3153),(58658,3154),(58659,3154),(58660,3154),(58661,3154),(58662,3155),(58663,3155),(58664,3155),(58665,3155),(58666,3156),(58667,3156),(58668,3156),(58669,3156),(58670,3157),(58671,3157),(58672,3157),(58673,3157),(58674,3158),(58675,3158),(58676,3158),(58677,3158),(58678,3159),(58679,3159),(58680,3159),(58681,3159),(58682,3160),(58683,3160),(58684,3160),(58685,3160),(58686,3161),(58687,3161),(58688,3161),(58689,3161),(58690,3162),(58691,3162),(58692,3162),(58693,3162),(58694,3163),(58695,3163),(58696,3163),(58697,3163),(58698,3164),(58699,3164),(58700,3164),(58701,3164),(58702,3165),(58703,3165),(58704,3165),(58705,3165),(58706,3166),(58707,3166),(58708,3166),(58709,3166),(58710,3167),(58711,3167),(58712,3167),(58713,3167),(58714,3168),(58715,3168),(58716,3168),(58717,3168),(58718,3169),(58719,3170),(58720,3171),(58721,3172),(58722,3173),(58723,3174),(58724,3175),(58725,3176),(58726,3177),(58727,3178),(58728,3179),(58729,3180),(58730,3181),(58731,3182),(58732,3183),(58733,3184),(58734,3185),(58735,3186),(58736,3187),(58737,3188),(58738,3189),(58739,3190),(58740,3191),(58741,3192),(58742,3193),(58743,3194),(58744,3195),(58745,3196),(58746,3197),(58747,3198),(58748,3199),(58749,3200),(58750,3201),(58751,3202),(58752,3203),(58753,3204),(58754,3205),(58755,3206),(58756,3207),(58757,3208),(58758,3209),(58759,3210),(58760,3211),(58761,3212),(58762,3213),(58763,3214),(58764,3215),(58765,3216),(58766,3217),(58767,3218),(58768,3219),(58769,3220),(58770,3221),(58771,3222),(58772,3223),(58773,3224),(58774,3225),(58775,3226),(58776,3227),(58777,3228),(58778,3229),(58779,3230),(58780,3231),(58781,3232),(58782,3233),(58783,3234),(58784,3235),(58785,3236),(58786,3237),(58787,3238),(58788,3239),(58789,3240),(58790,3241),(58791,3242),(58792,3243),(58793,3244),(58794,3245),(58795,3246),(58796,3247),(58797,3248),(58798,3249),(58799,3250),(58800,3251),(58801,3252),(58802,3253),(58803,3254),(58804,3255),(58805,3256),(58806,3257),(58807,3258),(58808,3259),(58809,3260),(58810,3261),(58811,3262),(58812,3263),(58813,3264),(58814,3265),(58815,3266),(58816,3267),(58817,3268),(58818,3169),(58819,3170),(58820,3171),(58821,3172),(58822,3173),(58823,3174),(58824,3175),(58825,3176),(58826,3177),(58827,3178),(58828,3179),(58829,3180),(58830,3181),(58831,3182),(58832,3183),(58833,3184),(58834,3185),(58835,3186),(58836,3187),(58837,3188),(58838,3189),(58839,3190),(58840,3191),(58841,3192),(58842,3193),(58843,3194),(58844,3195),(58845,3196),(58846,3197),(58847,3198),(58848,3199),(58849,3200),(58850,3201),(58851,3202),(58852,3203),(58853,3204),(58854,3205),(58855,3206),(58856,3207),(58857,3208),(58858,3209),(58859,3210),(58860,3211),(58861,3212),(58862,3213),(58863,3214),(58864,3215),(58865,3216),(58866,3217),(58867,3218),(58868,3219),(58869,3220),(58870,3221),(58871,3222),(58872,3223),(58873,3224),(58874,3225),(58875,3226),(58876,3227),(58877,3228),(58878,3229),(58879,3230),(58880,3231),(58881,3232),(58882,3233),(58883,3234),(58884,3235),(58885,3236),(58886,3237),(58887,3238),(58888,3239),(58889,3240),(58890,3241),(58891,3242),(58892,3243),(58893,3244),(58894,3245),(58895,3246),(58896,3247),(58897,3248),(58898,3249),(58899,3250),(58900,3251),(58901,3252),(58902,3253),(58903,3254),(58904,3255),(58905,3256),(58906,3257),(58907,3258),(58908,3259),(58909,3260),(58910,3261),(58911,3262),(58912,3263),(58913,3264),(58914,3265),(58915,3266),(58916,3267),(58917,3268),(58918,3169),(58919,3169),(58920,3169),(58921,3169),(58922,3169),(58923,3169),(58924,3170),(58925,3170),(58926,3170),(58927,3170),(58928,3170),(58929,3170),(58930,3171),(58931,3171),(58932,3171),(58933,3171),(58934,3171),(58935,3171),(58936,3172),(58937,3172),(58938,3172),(58939,3172),(58940,3172),(58941,3172),(58942,3173),(58943,3173),(58944,3173),(58945,3173),(58946,3173),(58947,3173),(58948,3174),(58949,3174),(58950,3174),(58951,3174),(58952,3174),(58953,3174),(58954,3175),(58955,3175),(58956,3175),(58957,3175),(58958,3175),(58959,3175),(58960,3176),(58961,3176),(58962,3176),(58963,3176),(58964,3176),(58965,3176),(58966,3177),(58967,3177),(58968,3177),(58969,3177),(58970,3177),(58971,3177),(58972,3178),(58973,3178),(58974,3178),(58975,3178),(58976,3178),(58977,3178),(58978,3179),(58979,3179),(58980,3179),(58981,3179),(58982,3179),(58983,3179),(58984,3180),(58985,3180),(58986,3180),(58987,3180),(58988,3180),(58989,3180),(58990,3181),(58991,3181),(58992,3181),(58993,3181),(58994,3181),(58995,3181),(58996,3182),(58997,3182),(58998,3182),(58999,3182),(59000,3182),(59001,3182),(59002,3183),(59003,3183),(59004,3183),(59005,3183),(59006,3183),(59007,3183),(59008,3184),(59009,3184),(59010,3184),(59011,3184),(59012,3184),(59013,3184),(59014,3185),(59015,3185),(59016,3185),(59017,3185),(59018,3185),(59019,3185),(59020,3186),(59021,3186),(59022,3186),(59023,3186),(59024,3186),(59025,3186),(59026,3187),(59027,3187),(59028,3187),(59029,3187),(59030,3187),(59031,3187),(59032,3188),(59033,3188),(59034,3188),(59035,3188),(59036,3188),(59037,3188),(59038,3189),(59039,3189),(59040,3189),(59041,3189),(59042,3189),(59043,3189),(59044,3190),(59045,3190),(59046,3190),(59047,3190),(59048,3190),(59049,3190),(59050,3191),(59051,3191),(59052,3191),(59053,3191),(59054,3191),(59055,3191),(59056,3192),(59057,3192),(59058,3192),(59059,3192),(59060,3192),(59061,3192),(59062,3193),(59063,3193),(59064,3193),(59065,3193),(59066,3193),(59067,3193),(59068,3194),(59069,3194),(59070,3194),(59071,3194),(59072,3194),(59073,3194),(59074,3195),(59075,3195),(59076,3195),(59077,3195),(59078,3195),(59079,3195),(59080,3196),(59081,3196),(59082,3196),(59083,3196),(59084,3196),(59085,3196),(59086,3197),(59087,3197),(59088,3197),(59089,3197),(59090,3197),(59091,3197),(59092,3198),(59093,3198),(59094,3198),(59095,3198),(59096,3198),(59097,3198),(59098,3199),(59099,3199),(59100,3199),(59101,3199),(59102,3199),(59103,3199),(59104,3200),(59105,3200),(59106,3200),(59107,3200),(59108,3200),(59109,3200),(59110,3201),(59111,3201),(59112,3201),(59113,3201),(59114,3201),(59115,3201),(59116,3202),(59117,3202),(59118,3202),(59119,3202),(59120,3202),(59121,3202),(59122,3203),(59123,3203),(59124,3203),(59125,3203),(59126,3203),(59127,3203),(59128,3204),(59129,3204),(59130,3204),(59131,3204),(59132,3204),(59133,3204),(59134,3205),(59135,3205),(59136,3205),(59137,3205),(59138,3205),(59139,3205),(59140,3206),(59141,3206),(59142,3206),(59143,3206),(59144,3206),(59145,3206),(59146,3207),(59147,3207),(59148,3207),(59149,3207),(59150,3207),(59151,3207),(59152,3208),(59153,3208),(59154,3208),(59155,3208),(59156,3208),(59157,3208),(59158,3209),(59159,3209),(59160,3209),(59161,3209),(59162,3209),(59163,3209),(59164,3210),(59165,3210),(59166,3210),(59167,3210),(59168,3210),(59169,3210),(59170,3211),(59171,3211),(59172,3211),(59173,3211),(59174,3211),(59175,3211),(59176,3212),(59177,3212),(59178,3212),(59179,3212),(59180,3212),(59181,3212),(59182,3213),(59183,3213),(59184,3213),(59185,3213),(59186,3213),(59187,3213),(59188,3214),(59189,3214),(59190,3214),(59191,3214),(59192,3214),(59193,3214),(59194,3215),(59195,3215),(59196,3215),(59197,3215),(59198,3215),(59199,3215),(59200,3216),(59201,3216),(59202,3216),(59203,3216),(59204,3216),(59205,3216),(59206,3217),(59207,3217),(59208,3217),(59209,3217),(59210,3217),(59211,3217),(59212,3218),(59213,3218),(59214,3218),(59215,3218),(59216,3218),(59217,3218),(59218,3219),(59219,3219),(59220,3219),(59221,3219),(59222,3219),(59223,3219),(59224,3220),(59225,3220),(59226,3220),(59227,3220),(59228,3220),(59229,3220),(59230,3221),(59231,3221),(59232,3221),(59233,3221),(59234,3221),(59235,3221),(59236,3222),(59237,3222),(59238,3222),(59239,3222),(59240,3222),(59241,3222),(59242,3223),(59243,3223),(59244,3223),(59245,3223),(59246,3223),(59247,3223),(59248,3224),(59249,3224),(59250,3224),(59251,3224),(59252,3224),(59253,3224),(59254,3225),(59255,3225),(59256,3225),(59257,3225),(59258,3225),(59259,3225),(59260,3226),(59261,3226),(59262,3226),(59263,3226),(59264,3226),(59265,3226),(59266,3227),(59267,3227),(59268,3227),(59269,3227),(59270,3227),(59271,3227),(59272,3228),(59273,3228),(59274,3228),(59275,3228),(59276,3228),(59277,3228),(59278,3229),(59279,3229),(59280,3229),(59281,3229),(59282,3229),(59283,3229),(59284,3230),(59285,3230),(59286,3230),(59287,3230),(59288,3230),(59289,3230),(59290,3231),(59291,3231),(59292,3231),(59293,3231),(59294,3231),(59295,3231),(59296,3232),(59297,3232),(59298,3232),(59299,3232),(59300,3232),(59301,3232),(59302,3233),(59303,3233),(59304,3233),(59305,3233),(59306,3233),(59307,3233),(59308,3234),(59309,3234),(59310,3234),(59311,3234),(59312,3234),(59313,3234),(59314,3235),(59315,3235),(59316,3235),(59317,3235),(59318,3235),(59319,3235),(59320,3236),(59321,3236),(59322,3236),(59323,3236),(59324,3236),(59325,3236),(59326,3237),(59327,3237),(59328,3237),(59329,3237),(59330,3237),(59331,3237),(59332,3238),(59333,3238),(59334,3238),(59335,3238),(59336,3238),(59337,3238),(59338,3239),(59339,3239),(59340,3239),(59341,3239),(59342,3239),(59343,3239),(59344,3240),(59345,3240),(59346,3240),(59347,3240),(59348,3240),(59349,3240),(59350,3241),(59351,3241),(59352,3241),(59353,3241),(59354,3241),(59355,3241),(59356,3242),(59357,3242),(59358,3242),(59359,3242),(59360,3242),(59361,3242),(59362,3243),(59363,3243),(59364,3243),(59365,3243),(59366,3243),(59367,3243),(59368,3244),(59369,3244),(59370,3244),(59371,3244),(59372,3244),(59373,3244),(59374,3245),(59375,3245),(59376,3245),(59377,3245),(59378,3245),(59379,3245),(59380,3246),(59381,3246),(59382,3246),(59383,3246),(59384,3246),(59385,3246),(59386,3247),(59387,3247),(59388,3247),(59389,3247),(59390,3247),(59391,3247),(59392,3248),(59393,3248),(59394,3248),(59395,3248),(59396,3248),(59397,3248),(59398,3249),(59399,3249),(59400,3249),(59401,3249),(59402,3249),(59403,3249),(59404,3250),(59405,3250),(59406,3250),(59407,3250),(59408,3250),(59409,3250),(59410,3251),(59411,3251),(59412,3251),(59413,3251),(59414,3251),(59415,3251),(59416,3252),(59417,3252),(59418,3252),(59419,3252),(59420,3252),(59421,3252),(59422,3253),(59423,3253),(59424,3253),(59425,3253),(59426,3253),(59427,3253),(59428,3254),(59429,3254),(59430,3254),(59431,3254),(59432,3254),(59433,3254),(59434,3255),(59435,3255),(59436,3255),(59437,3255),(59438,3255),(59439,3255),(59440,3256),(59441,3256),(59442,3256),(59443,3256),(59444,3256),(59445,3256),(59446,3257),(59447,3257),(59448,3257),(59449,3257),(59450,3257),(59451,3257),(59452,3258),(59453,3258),(59454,3258),(59455,3258),(59456,3258),(59457,3258),(59458,3259),(59459,3259),(59460,3259),(59461,3259),(59462,3259),(59463,3259),(59464,3260),(59465,3260),(59466,3260),(59467,3260),(59468,3260),(59469,3260),(59470,3261),(59471,3261),(59472,3261),(59473,3261),(59474,3261),(59475,3261),(59476,3262),(59477,3262),(59478,3262),(59479,3262),(59480,3262),(59481,3262),(59482,3263),(59483,3263),(59484,3263),(59485,3263),(59486,3263),(59487,3263),(59488,3264),(59489,3264),(59490,3264),(59491,3264),(59492,3264),(59493,3264),(59494,3265),(59495,3265),(59496,3265),(59497,3265),(59498,3265),(59499,3265),(59500,3266),(59501,3266),(59502,3266),(59503,3266),(59504,3266),(59505,3266),(59506,3267),(59507,3267),(59508,3267),(59509,3267),(59510,3267),(59511,3267),(59512,3268),(59513,3268),(59514,3268),(59515,3268),(59516,3268),(59517,3268),(59518,3169),(59519,3169),(59520,3170),(59521,3170),(59522,3171),(59523,3171),(59524,3172),(59525,3172),(59526,3173),(59527,3173),(59528,3174),(59529,3174),(59530,3175),(59531,3175),(59532,3176),(59533,3176),(59534,3177),(59535,3177),(59536,3178),(59537,3178),(59538,3179),(59539,3179),(59540,3180),(59541,3180),(59542,3181),(59543,3181),(59544,3182),(59545,3182),(59546,3183),(59547,3183),(59548,3184),(59549,3184),(59550,3185),(59551,3185),(59552,3186),(59553,3186),(59554,3187),(59555,3187),(59556,3188),(59557,3188),(59558,3189),(59559,3189),(59560,3190),(59561,3190),(59562,3191),(59563,3191),(59564,3192),(59565,3192),(59566,3193),(59567,3193),(59568,3194),(59569,3194),(59570,3195),(59571,3195),(59572,3196),(59573,3196),(59574,3197),(59575,3197),(59576,3198),(59577,3198),(59578,3199),(59579,3199),(59580,3200),(59581,3200),(59582,3201),(59583,3201),(59584,3202),(59585,3202),(59586,3203),(59587,3203),(59588,3204),(59589,3204),(59590,3205),(59591,3205),(59592,3206),(59593,3206),(59594,3207),(59595,3207),(59596,3208),(59597,3208),(59598,3209),(59599,3209),(59600,3210),(59601,3210),(59602,3211),(59603,3211),(59604,3212),(59605,3212),(59606,3213),(59607,3213),(59608,3214),(59609,3214),(59610,3215),(59611,3215),(59612,3216),(59613,3216),(59614,3217),(59615,3217),(59616,3218),(59617,3218),(59618,3219),(59619,3219),(59620,3220),(59621,3220),(59622,3221),(59623,3221),(59624,3222),(59625,3222),(59626,3223),(59627,3223),(59628,3224),(59629,3224),(59630,3225),(59631,3225),(59632,3226),(59633,3226),(59634,3227),(59635,3227),(59636,3228),(59637,3228),(59638,3229),(59639,3229),(59640,3230),(59641,3230),(59642,3231),(59643,3231),(59644,3232),(59645,3232),(59646,3233),(59647,3233),(59648,3234),(59649,3234),(59650,3235),(59651,3235),(59652,3236),(59653,3236),(59654,3237),(59655,3237),(59656,3238),(59657,3238),(59658,3239),(59659,3239),(59660,3240),(59661,3240),(59662,3241),(59663,3241),(59664,3242),(59665,3242),(59666,3243),(59667,3243),(59668,3244),(59669,3244),(59670,3245),(59671,3245),(59672,3246),(59673,3246),(59674,3247),(59675,3247),(59676,3248),(59677,3248),(59678,3249),(59679,3249),(59680,3250),(59681,3250),(59682,3251),(59683,3251),(59684,3252),(59685,3252),(59686,3253),(59687,3253),(59688,3254),(59689,3254),(59690,3255),(59691,3255),(59692,3256),(59693,3256),(59694,3257),(59695,3257),(59696,3258),(59697,3258),(59698,3259),(59699,3259),(59700,3260),(59701,3260),(59702,3261),(59703,3261),(59704,3262),(59705,3262),(59706,3263),(59707,3263),(59708,3264),(59709,3264),(59710,3265),(59711,3265),(59712,3266),(59713,3266),(59714,3267),(59715,3267),(59716,3268),(59717,3268),(59718,3169),(59719,3169),(59720,3169),(59721,3170),(59722,3170),(59723,3170),(59724,3171),(59725,3171),(59726,3171),(59727,3172),(59728,3172),(59729,3172),(59730,3173),(59731,3173),(59732,3173),(59733,3174),(59734,3174),(59735,3174),(59736,3175),(59737,3175),(59738,3175),(59739,3176),(59740,3176),(59741,3176),(59742,3177),(59743,3177),(59744,3177),(59745,3178),(59746,3178),(59747,3178),(59748,3179),(59749,3179),(59750,3179),(59751,3180),(59752,3180),(59753,3180),(59754,3181),(59755,3181),(59756,3181),(59757,3182),(59758,3182),(59759,3182),(59760,3183),(59761,3183),(59762,3183),(59763,3184),(59764,3184),(59765,3184),(59766,3185),(59767,3185),(59768,3185),(59769,3186),(59770,3186),(59771,3186),(59772,3187),(59773,3187),(59774,3187),(59775,3188),(59776,3188),(59777,3188),(59778,3189),(59779,3189),(59780,3189),(59781,3190),(59782,3190),(59783,3190),(59784,3191),(59785,3191),(59786,3191),(59787,3192),(59788,3192),(59789,3192),(59790,3193),(59791,3193),(59792,3193),(59793,3194),(59794,3194),(59795,3194),(59796,3195),(59797,3195),(59798,3195),(59799,3196),(59800,3196),(59801,3196),(59802,3197),(59803,3197),(59804,3197),(59805,3198),(59806,3198),(59807,3198),(59808,3199),(59809,3199),(59810,3199),(59811,3200),(59812,3200),(59813,3200),(59814,3201),(59815,3201),(59816,3201),(59817,3202),(59818,3202),(59819,3202),(59820,3203),(59821,3203),(59822,3203),(59823,3204),(59824,3204),(59825,3204),(59826,3205),(59827,3205),(59828,3205),(59829,3206),(59830,3206),(59831,3206),(59832,3207),(59833,3207),(59834,3207),(59835,3208),(59836,3208),(59837,3208),(59838,3209),(59839,3209),(59840,3209),(59841,3210),(59842,3210),(59843,3210),(59844,3211),(59845,3211),(59846,3211),(59847,3212),(59848,3212),(59849,3212),(59850,3213),(59851,3213),(59852,3213),(59853,3214),(59854,3214),(59855,3214),(59856,3215),(59857,3215),(59858,3215),(59859,3216),(59860,3216),(59861,3216),(59862,3217),(59863,3217),(59864,3217),(59865,3218),(59866,3218),(59867,3218),(59868,3219),(59869,3219),(59870,3219),(59871,3220),(59872,3220),(59873,3220),(59874,3221),(59875,3221),(59876,3221),(59877,3222),(59878,3222),(59879,3222),(59880,3223),(59881,3223),(59882,3223),(59883,3224),(59884,3224),(59885,3224),(59886,3225),(59887,3225),(59888,3225),(59889,3226),(59890,3226),(59891,3226),(59892,3227),(59893,3227),(59894,3227),(59895,3228),(59896,3228),(59897,3228),(59898,3229),(59899,3229),(59900,3229),(59901,3230),(59902,3230),(59903,3230),(59904,3231),(59905,3231),(59906,3231),(59907,3232),(59908,3232),(59909,3232),(59910,3233),(59911,3233),(59912,3233),(59913,3234),(59914,3234),(59915,3234),(59916,3235),(59917,3235),(59918,3235),(59919,3236),(59920,3236),(59921,3236),(59922,3237),(59923,3237),(59924,3237),(59925,3238),(59926,3238),(59927,3238),(59928,3239),(59929,3239),(59930,3239),(59931,3240),(59932,3240),(59933,3240),(59934,3241),(59935,3241),(59936,3241),(59937,3242),(59938,3242),(59939,3242),(59940,3243),(59941,3243),(59942,3243),(59943,3244),(59944,3244),(59945,3244),(59946,3245),(59947,3245),(59948,3245),(59949,3246),(59950,3246),(59951,3246),(59952,3247),(59953,3247),(59954,3247),(59955,3248),(59956,3248),(59957,3248),(59958,3249),(59959,3249),(59960,3249),(59961,3250),(59962,3250),(59963,3250),(59964,3251),(59965,3251),(59966,3251),(59967,3252),(59968,3252),(59969,3252),(59970,3253),(59971,3253),(59972,3253),(59973,3254),(59974,3254),(59975,3254),(59976,3255),(59977,3255),(59978,3255),(59979,3256),(59980,3256),(59981,3256),(59982,3257),(59983,3257),(59984,3257),(59985,3258),(59986,3258),(59987,3258),(59988,3259),(59989,3259),(59990,3259),(59991,3260),(59992,3260),(59993,3260),(59994,3261),(59995,3261),(59996,3261),(59997,3262),(59998,3262),(59999,3262),(60000,3263),(60001,3263),(60002,3263),(60003,3264),(60004,3264),(60005,3264),(60006,3265),(60007,3265),(60008,3265),(60009,3266),(60010,3266),(60011,3266),(60012,3267),(60013,3267),(60014,3267),(60015,3268),(60016,3268),(60017,3268),(60018,3169),(60019,3169),(60020,3169),(60021,3169),(60022,3170),(60023,3170),(60024,3170),(60025,3170),(60026,3171),(60027,3171),(60028,3171),(60029,3171),(60030,3172),(60031,3172),(60032,3172),(60033,3172),(60034,3173),(60035,3173),(60036,3173),(60037,3173),(60038,3174),(60039,3174),(60040,3174),(60041,3174),(60042,3175),(60043,3175),(60044,3175),(60045,3175),(60046,3176),(60047,3176),(60048,3176),(60049,3176),(60050,3177),(60051,3177),(60052,3177),(60053,3177),(60054,3178),(60055,3178),(60056,3178),(60057,3178),(60058,3179),(60059,3179),(60060,3179),(60061,3179),(60062,3180),(60063,3180),(60064,3180),(60065,3180),(60066,3181),(60067,3181),(60068,3181),(60069,3181),(60070,3182),(60071,3182),(60072,3182),(60073,3182),(60074,3183),(60075,3183),(60076,3183),(60077,3183),(60078,3184),(60079,3184),(60080,3184),(60081,3184),(60082,3185),(60083,3185),(60084,3185),(60085,3185),(60086,3186),(60087,3186),(60088,3186),(60089,3186),(60090,3187),(60091,3187),(60092,3187),(60093,3187),(60094,3188),(60095,3188),(60096,3188),(60097,3188),(60098,3189),(60099,3189),(60100,3189),(60101,3189),(60102,3190),(60103,3190),(60104,3190),(60105,3190),(60106,3191),(60107,3191),(60108,3191),(60109,3191),(60110,3192),(60111,3192),(60112,3192),(60113,3192),(60114,3193),(60115,3193),(60116,3193),(60117,3193),(60118,3194),(60119,3194),(60120,3194),(60121,3194),(60122,3195),(60123,3195),(60124,3195),(60125,3195),(60126,3196),(60127,3196),(60128,3196),(60129,3196),(60130,3197),(60131,3197),(60132,3197),(60133,3197),(60134,3198),(60135,3198),(60136,3198),(60137,3198),(60138,3199),(60139,3199),(60140,3199),(60141,3199),(60142,3200),(60143,3200),(60144,3200),(60145,3200),(60146,3201),(60147,3201),(60148,3201),(60149,3201),(60150,3202),(60151,3202),(60152,3202),(60153,3202),(60154,3203),(60155,3203),(60156,3203),(60157,3203),(60158,3204),(60159,3204),(60160,3204),(60161,3204),(60162,3205),(60163,3205),(60164,3205),(60165,3205),(60166,3206),(60167,3206),(60168,3206),(60169,3206),(60170,3207),(60171,3207),(60172,3207),(60173,3207),(60174,3208),(60175,3208),(60176,3208),(60177,3208),(60178,3209),(60179,3209),(60180,3209),(60181,3209),(60182,3210),(60183,3210),(60184,3210),(60185,3210),(60186,3211),(60187,3211),(60188,3211),(60189,3211),(60190,3212),(60191,3212),(60192,3212),(60193,3212),(60194,3213),(60195,3213),(60196,3213),(60197,3213),(60198,3214),(60199,3214),(60200,3214),(60201,3214),(60202,3215),(60203,3215),(60204,3215),(60205,3215),(60206,3216),(60207,3216),(60208,3216),(60209,3216),(60210,3217),(60211,3217),(60212,3217),(60213,3217),(60214,3218),(60215,3218),(60216,3218),(60217,3218),(60218,3219),(60219,3219),(60220,3219),(60221,3219),(60222,3220),(60223,3220),(60224,3220),(60225,3220),(60226,3221),(60227,3221),(60228,3221),(60229,3221),(60230,3222),(60231,3222),(60232,3222),(60233,3222),(60234,3223),(60235,3223),(60236,3223),(60237,3223),(60238,3224),(60239,3224),(60240,3224),(60241,3224),(60242,3225),(60243,3225),(60244,3225),(60245,3225),(60246,3226),(60247,3226),(60248,3226),(60249,3226),(60250,3227),(60251,3227),(60252,3227),(60253,3227),(60254,3228),(60255,3228),(60256,3228),(60257,3228),(60258,3229),(60259,3229),(60260,3229),(60261,3229),(60262,3230),(60263,3230),(60264,3230),(60265,3230),(60266,3231),(60267,3231),(60268,3231),(60269,3231),(60270,3232),(60271,3232),(60272,3232),(60273,3232),(60274,3233),(60275,3233),(60276,3233),(60277,3233),(60278,3234),(60279,3234),(60280,3234),(60281,3234),(60282,3235),(60283,3235),(60284,3235),(60285,3235),(60286,3236),(60287,3236),(60288,3236),(60289,3236),(60290,3237),(60291,3237),(60292,3237),(60293,3237),(60294,3238),(60295,3238),(60296,3238),(60297,3238),(60298,3239),(60299,3239),(60300,3239),(60301,3239),(60302,3240),(60303,3240),(60304,3240),(60305,3240),(60306,3241),(60307,3241),(60308,3241),(60309,3241),(60310,3242),(60311,3242),(60312,3242),(60313,3242),(60314,3243),(60315,3243),(60316,3243),(60317,3243),(60318,3244),(60319,3244),(60320,3244),(60321,3244),(60322,3245),(60323,3245),(60324,3245),(60325,3245),(60326,3246),(60327,3246),(60328,3246),(60329,3246),(60330,3247),(60331,3247),(60332,3247),(60333,3247),(60334,3248),(60335,3248),(60336,3248),(60337,3248),(60338,3249),(60339,3249),(60340,3249),(60341,3249),(60342,3250),(60343,3250),(60344,3250),(60345,3250),(60346,3251),(60347,3251),(60348,3251),(60349,3251),(60350,3252),(60351,3252),(60352,3252),(60353,3252),(60354,3253),(60355,3253),(60356,3253),(60357,3253),(60358,3254),(60359,3254),(60360,3254),(60361,3254),(60362,3255),(60363,3255),(60364,3255),(60365,3255),(60366,3256),(60367,3256),(60368,3256),(60369,3256),(60370,3257),(60371,3257),(60372,3257),(60373,3257),(60374,3258),(60375,3258),(60376,3258),(60377,3258),(60378,3259),(60379,3259),(60380,3259),(60381,3259),(60382,3260),(60383,3260),(60384,3260),(60385,3260),(60386,3261),(60387,3261),(60388,3261),(60389,3261),(60390,3262),(60391,3262),(60392,3262),(60393,3262),(60394,3263),(60395,3263),(60396,3263),(60397,3263),(60398,3264),(60399,3264),(60400,3264),(60401,3264),(60402,3265),(60403,3265),(60404,3265),(60405,3265),(60406,3266),(60407,3266),(60408,3266),(60409,3266),(60410,3267),(60411,3267),(60412,3267),(60413,3267),(60414,3268),(60415,3268),(60416,3268),(60417,3268),(60418,3269),(60419,3270),(60420,3271),(60421,3272),(60422,3273),(60423,3274),(60424,3275),(60425,3276),(60426,3277),(60427,3278),(60428,3279),(60429,3280),(60430,3281),(60431,3282),(60432,3283),(60433,3284),(60434,3285),(60435,3286),(60436,3287),(60437,3288),(60438,3289),(60439,3290),(60440,3291),(60441,3292),(60442,3293),(60443,3294),(60444,3295),(60445,3296),(60446,3297),(60447,3298),(60448,3299),(60449,3300),(60450,3301),(60451,3302),(60452,3303),(60453,3304),(60454,3305),(60455,3306),(60456,3307),(60457,3308),(60458,3309),(60459,3310),(60460,3311),(60461,3312),(60462,3313),(60463,3314),(60464,3315),(60465,3316),(60466,3317),(60467,3318),(60468,3319),(60469,3320),(60470,3321),(60471,3322),(60472,3323),(60473,3324),(60474,3325),(60475,3326),(60476,3327),(60477,3328),(60478,3329),(60479,3330),(60480,3331),(60481,3332),(60482,3333),(60483,3334),(60484,3335),(60485,3336),(60486,3337),(60487,3338),(60488,3339),(60489,3340),(60490,3341),(60491,3342),(60492,3343),(60493,3344),(60494,3345),(60495,3346),(60496,3347),(60497,3348),(60498,3349),(60499,3350),(60500,3351),(60501,3352),(60502,3353),(60503,3354),(60504,3355),(60505,3356),(60506,3357),(60507,3358),(60508,3359),(60509,3360),(60510,3361),(60511,3362),(60512,3363),(60513,3364),(60514,3365),(60515,3366),(60516,3367),(60517,3368),(60518,3269),(60519,3270),(60520,3271),(60521,3272),(60522,3273),(60523,3274),(60524,3275),(60525,3276),(60526,3277),(60527,3278),(60528,3279),(60529,3280),(60530,3281),(60531,3282),(60532,3283),(60533,3284),(60534,3285),(60535,3286),(60536,3287),(60537,3288),(60538,3289),(60539,3290),(60540,3291),(60541,3292),(60542,3293),(60543,3294),(60544,3295),(60545,3296),(60546,3297),(60547,3298),(60548,3299),(60549,3300),(60550,3301),(60551,3302),(60552,3303),(60553,3304),(60554,3305),(60555,3306),(60556,3307),(60557,3308),(60558,3309),(60559,3310),(60560,3311),(60561,3312),(60562,3313),(60563,3314),(60564,3315),(60565,3316),(60566,3317),(60567,3318),(60568,3319),(60569,3320),(60570,3321),(60571,3322),(60572,3323),(60573,3324),(60574,3325),(60575,3326),(60576,3327),(60577,3328),(60578,3329),(60579,3330),(60580,3331),(60581,3332),(60582,3333),(60583,3334),(60584,3335),(60585,3336),(60586,3337),(60587,3338),(60588,3339),(60589,3340),(60590,3341),(60591,3342),(60592,3343),(60593,3344),(60594,3345),(60595,3346),(60596,3347),(60597,3348),(60598,3349),(60599,3350),(60600,3351),(60601,3352),(60602,3353),(60603,3354),(60604,3355),(60605,3356),(60606,3357),(60607,3358),(60608,3359),(60609,3360),(60610,3361),(60611,3362),(60612,3363),(60613,3364),(60614,3365),(60615,3366),(60616,3367),(60617,3368),(60618,3269),(60619,3269),(60620,3269),(60621,3269),(60622,3269),(60623,3269),(60624,3270),(60625,3270),(60626,3270),(60627,3270),(60628,3270),(60629,3270),(60630,3271),(60631,3271),(60632,3271),(60633,3271),(60634,3271),(60635,3271),(60636,3272),(60637,3272),(60638,3272),(60639,3272),(60640,3272),(60641,3272),(60642,3273),(60643,3273),(60644,3273),(60645,3273),(60646,3273),(60647,3273),(60648,3274),(60649,3274),(60650,3274),(60651,3274),(60652,3274),(60653,3274),(60654,3275),(60655,3275),(60656,3275),(60657,3275),(60658,3275),(60659,3275),(60660,3276),(60661,3276),(60662,3276),(60663,3276),(60664,3276),(60665,3276),(60666,3277),(60667,3277),(60668,3277),(60669,3277),(60670,3277),(60671,3277),(60672,3278),(60673,3278),(60674,3278),(60675,3278),(60676,3278),(60677,3278),(60678,3279),(60679,3279),(60680,3279),(60681,3279),(60682,3279),(60683,3279),(60684,3280),(60685,3280),(60686,3280),(60687,3280),(60688,3280),(60689,3280),(60690,3281),(60691,3281),(60692,3281),(60693,3281),(60694,3281),(60695,3281),(60696,3282),(60697,3282),(60698,3282),(60699,3282),(60700,3282),(60701,3282),(60702,3283),(60703,3283),(60704,3283),(60705,3283),(60706,3283),(60707,3283),(60708,3284),(60709,3284),(60710,3284),(60711,3284),(60712,3284),(60713,3284),(60714,3285),(60715,3285),(60716,3285),(60717,3285),(60718,3285),(60719,3285),(60720,3286),(60721,3286),(60722,3286),(60723,3286),(60724,3286),(60725,3286),(60726,3287),(60727,3287),(60728,3287),(60729,3287),(60730,3287),(60731,3287),(60732,3288),(60733,3288),(60734,3288),(60735,3288),(60736,3288),(60737,3288),(60738,3289),(60739,3289),(60740,3289),(60741,3289),(60742,3289),(60743,3289),(60744,3290),(60745,3290),(60746,3290),(60747,3290),(60748,3290),(60749,3290),(60750,3291),(60751,3291),(60752,3291),(60753,3291),(60754,3291),(60755,3291),(60756,3292),(60757,3292),(60758,3292),(60759,3292),(60760,3292),(60761,3292),(60762,3293),(60763,3293),(60764,3293),(60765,3293),(60766,3293),(60767,3293),(60768,3294),(60769,3294),(60770,3294),(60771,3294),(60772,3294),(60773,3294),(60774,3295),(60775,3295),(60776,3295),(60777,3295),(60778,3295),(60779,3295),(60780,3296),(60781,3296),(60782,3296),(60783,3296),(60784,3296),(60785,3296),(60786,3297),(60787,3297),(60788,3297),(60789,3297),(60790,3297),(60791,3297),(60792,3298),(60793,3298),(60794,3298),(60795,3298),(60796,3298),(60797,3298),(60798,3299),(60799,3299),(60800,3299),(60801,3299),(60802,3299),(60803,3299),(60804,3300),(60805,3300),(60806,3300),(60807,3300),(60808,3300),(60809,3300),(60810,3301),(60811,3301),(60812,3301),(60813,3301),(60814,3301),(60815,3301),(60816,3302),(60817,3302),(60818,3302),(60819,3302),(60820,3302),(60821,3302),(60822,3303),(60823,3303),(60824,3303),(60825,3303),(60826,3303),(60827,3303),(60828,3304),(60829,3304),(60830,3304),(60831,3304),(60832,3304),(60833,3304),(60834,3305),(60835,3305),(60836,3305),(60837,3305),(60838,3305),(60839,3305),(60840,3306),(60841,3306),(60842,3306),(60843,3306),(60844,3306),(60845,3306),(60846,3307),(60847,3307),(60848,3307),(60849,3307),(60850,3307),(60851,3307),(60852,3308),(60853,3308),(60854,3308),(60855,3308),(60856,3308),(60857,3308),(60858,3309),(60859,3309),(60860,3309),(60861,3309),(60862,3309),(60863,3309),(60864,3310),(60865,3310),(60866,3310),(60867,3310),(60868,3310),(60869,3310),(60870,3311),(60871,3311),(60872,3311),(60873,3311),(60874,3311),(60875,3311),(60876,3312),(60877,3312),(60878,3312),(60879,3312),(60880,3312),(60881,3312),(60882,3313),(60883,3313),(60884,3313),(60885,3313),(60886,3313),(60887,3313),(60888,3314),(60889,3314),(60890,3314),(60891,3314),(60892,3314),(60893,3314),(60894,3315),(60895,3315),(60896,3315),(60897,3315),(60898,3315),(60899,3315),(60900,3316),(60901,3316),(60902,3316),(60903,3316),(60904,3316),(60905,3316),(60906,3317),(60907,3317),(60908,3317),(60909,3317),(60910,3317),(60911,3317),(60912,3318),(60913,3318),(60914,3318),(60915,3318),(60916,3318),(60917,3318),(60918,3319),(60919,3319),(60920,3319),(60921,3319),(60922,3319),(60923,3319),(60924,3320),(60925,3320),(60926,3320),(60927,3320),(60928,3320),(60929,3320),(60930,3321),(60931,3321),(60932,3321),(60933,3321),(60934,3321),(60935,3321),(60936,3322),(60937,3322),(60938,3322),(60939,3322),(60940,3322),(60941,3322),(60942,3323),(60943,3323),(60944,3323),(60945,3323),(60946,3323),(60947,3323),(60948,3324),(60949,3324),(60950,3324),(60951,3324),(60952,3324),(60953,3324),(60954,3325),(60955,3325),(60956,3325),(60957,3325),(60958,3325),(60959,3325),(60960,3326),(60961,3326),(60962,3326),(60963,3326),(60964,3326),(60965,3326),(60966,3327),(60967,3327),(60968,3327),(60969,3327),(60970,3327),(60971,3327),(60972,3328),(60973,3328),(60974,3328),(60975,3328),(60976,3328),(60977,3328),(60978,3329),(60979,3329),(60980,3329),(60981,3329),(60982,3329),(60983,3329),(60984,3330),(60985,3330),(60986,3330),(60987,3330),(60988,3330),(60989,3330),(60990,3331),(60991,3331),(60992,3331),(60993,3331),(60994,3331),(60995,3331),(60996,3332),(60997,3332),(60998,3332),(60999,3332),(61000,3332),(61001,3332),(61002,3333),(61003,3333),(61004,3333),(61005,3333),(61006,3333),(61007,3333),(61008,3334),(61009,3334),(61010,3334),(61011,3334),(61012,3334),(61013,3334),(61014,3335),(61015,3335),(61016,3335),(61017,3335),(61018,3335),(61019,3335),(61020,3336),(61021,3336),(61022,3336),(61023,3336),(61024,3336),(61025,3336),(61026,3337),(61027,3337),(61028,3337),(61029,3337),(61030,3337),(61031,3337),(61032,3338),(61033,3338),(61034,3338),(61035,3338),(61036,3338),(61037,3338),(61038,3339),(61039,3339),(61040,3339),(61041,3339),(61042,3339),(61043,3339),(61044,3340),(61045,3340),(61046,3340),(61047,3340),(61048,3340),(61049,3340),(61050,3341),(61051,3341),(61052,3341),(61053,3341),(61054,3341),(61055,3341),(61056,3342),(61057,3342),(61058,3342),(61059,3342),(61060,3342),(61061,3342),(61062,3343),(61063,3343),(61064,3343),(61065,3343),(61066,3343),(61067,3343),(61068,3344),(61069,3344),(61070,3344),(61071,3344),(61072,3344),(61073,3344),(61074,3345),(61075,3345),(61076,3345),(61077,3345),(61078,3345),(61079,3345),(61080,3346),(61081,3346),(61082,3346),(61083,3346),(61084,3346),(61085,3346),(61086,3347),(61087,3347),(61088,3347),(61089,3347),(61090,3347),(61091,3347),(61092,3348),(61093,3348),(61094,3348),(61095,3348),(61096,3348),(61097,3348),(61098,3349),(61099,3349),(61100,3349),(61101,3349),(61102,3349),(61103,3349),(61104,3350),(61105,3350),(61106,3350),(61107,3350),(61108,3350),(61109,3350),(61110,3351),(61111,3351),(61112,3351),(61113,3351),(61114,3351),(61115,3351),(61116,3352),(61117,3352),(61118,3352),(61119,3352),(61120,3352),(61121,3352),(61122,3353),(61123,3353),(61124,3353),(61125,3353),(61126,3353),(61127,3353),(61128,3354),(61129,3354),(61130,3354),(61131,3354),(61132,3354),(61133,3354),(61134,3355),(61135,3355),(61136,3355),(61137,3355),(61138,3355),(61139,3355),(61140,3356),(61141,3356),(61142,3356),(61143,3356),(61144,3356),(61145,3356),(61146,3357),(61147,3357),(61148,3357),(61149,3357),(61150,3357),(61151,3357),(61152,3358),(61153,3358),(61154,3358),(61155,3358),(61156,3358),(61157,3358),(61158,3359),(61159,3359),(61160,3359),(61161,3359),(61162,3359),(61163,3359),(61164,3360),(61165,3360),(61166,3360),(61167,3360),(61168,3360),(61169,3360),(61170,3361),(61171,3361),(61172,3361),(61173,3361),(61174,3361),(61175,3361),(61176,3362),(61177,3362),(61178,3362),(61179,3362),(61180,3362),(61181,3362),(61182,3363),(61183,3363),(61184,3363),(61185,3363),(61186,3363),(61187,3363),(61188,3364),(61189,3364),(61190,3364),(61191,3364),(61192,3364),(61193,3364),(61194,3365),(61195,3365),(61196,3365),(61197,3365),(61198,3365),(61199,3365),(61200,3366),(61201,3366),(61202,3366),(61203,3366),(61204,3366),(61205,3366),(61206,3367),(61207,3367),(61208,3367),(61209,3367),(61210,3367),(61211,3367),(61212,3368),(61213,3368),(61214,3368),(61215,3368),(61216,3368),(61217,3368),(61218,3269),(61219,3269),(61220,3270),(61221,3270),(61222,3271),(61223,3271),(61224,3272),(61225,3272),(61226,3273),(61227,3273),(61228,3274),(61229,3274),(61230,3275),(61231,3275),(61232,3276),(61233,3276),(61234,3277),(61235,3277),(61236,3278),(61237,3278),(61238,3279),(61239,3279),(61240,3280),(61241,3280),(61242,3281),(61243,3281),(61244,3282),(61245,3282),(61246,3283),(61247,3283),(61248,3284),(61249,3284),(61250,3285),(61251,3285),(61252,3286),(61253,3286),(61254,3287),(61255,3287),(61256,3288),(61257,3288),(61258,3289),(61259,3289),(61260,3290),(61261,3290),(61262,3291),(61263,3291),(61264,3292),(61265,3292),(61266,3293),(61267,3293),(61268,3294),(61269,3294),(61270,3295),(61271,3295),(61272,3296),(61273,3296),(61274,3297),(61275,3297),(61276,3298),(61277,3298),(61278,3299),(61279,3299),(61280,3300),(61281,3300),(61282,3301),(61283,3301),(61284,3302),(61285,3302),(61286,3303),(61287,3303),(61288,3304),(61289,3304),(61290,3305),(61291,3305),(61292,3306),(61293,3306),(61294,3307),(61295,3307),(61296,3308),(61297,3308),(61298,3309),(61299,3309),(61300,3310),(61301,3310),(61302,3311),(61303,3311),(61304,3312),(61305,3312),(61306,3313),(61307,3313),(61308,3314),(61309,3314),(61310,3315),(61311,3315),(61312,3316),(61313,3316),(61314,3317),(61315,3317),(61316,3318),(61317,3318),(61318,3319),(61319,3319),(61320,3320),(61321,3320),(61322,3321),(61323,3321),(61324,3322),(61325,3322),(61326,3323),(61327,3323),(61328,3324),(61329,3324),(61330,3325),(61331,3325),(61332,3326),(61333,3326),(61334,3327),(61335,3327),(61336,3328),(61337,3328),(61338,3329),(61339,3329),(61340,3330),(61341,3330),(61342,3331),(61343,3331),(61344,3332),(61345,3332),(61346,3333),(61347,3333),(61348,3334),(61349,3334),(61350,3335),(61351,3335),(61352,3336),(61353,3336),(61354,3337),(61355,3337),(61356,3338),(61357,3338),(61358,3339),(61359,3339),(61360,3340),(61361,3340),(61362,3341),(61363,3341),(61364,3342),(61365,3342),(61366,3343),(61367,3343),(61368,3344),(61369,3344),(61370,3345),(61371,3345),(61372,3346),(61373,3346),(61374,3347),(61375,3347),(61376,3348),(61377,3348),(61378,3349),(61379,3349),(61380,3350),(61381,3350),(61382,3351),(61383,3351),(61384,3352),(61385,3352),(61386,3353),(61387,3353),(61388,3354),(61389,3354),(61390,3355),(61391,3355),(61392,3356),(61393,3356),(61394,3357),(61395,3357),(61396,3358),(61397,3358),(61398,3359),(61399,3359),(61400,3360),(61401,3360),(61402,3361),(61403,3361),(61404,3362),(61405,3362),(61406,3363),(61407,3363),(61408,3364),(61409,3364),(61410,3365),(61411,3365),(61412,3366),(61413,3366),(61414,3367),(61415,3367),(61416,3368),(61417,3368),(61418,3269),(61419,3269),(61420,3269),(61421,3270),(61422,3270),(61423,3270),(61424,3271),(61425,3271),(61426,3271),(61427,3272),(61428,3272),(61429,3272),(61430,3273),(61431,3273),(61432,3273),(61433,3274),(61434,3274),(61435,3274),(61436,3275),(61437,3275),(61438,3275),(61439,3276),(61440,3276),(61441,3276),(61442,3277),(61443,3277),(61444,3277),(61445,3278),(61446,3278),(61447,3278),(61448,3279),(61449,3279),(61450,3279),(61451,3280),(61452,3280),(61453,3280),(61454,3281),(61455,3281),(61456,3281),(61457,3282),(61458,3282),(61459,3282),(61460,3283),(61461,3283),(61462,3283),(61463,3284),(61464,3284),(61465,3284),(61466,3285),(61467,3285),(61468,3285),(61469,3286),(61470,3286),(61471,3286),(61472,3287),(61473,3287),(61474,3287),(61475,3288),(61476,3288),(61477,3288),(61478,3289),(61479,3289),(61480,3289),(61481,3290),(61482,3290),(61483,3290),(61484,3291),(61485,3291),(61486,3291),(61487,3292),(61488,3292),(61489,3292),(61490,3293),(61491,3293),(61492,3293),(61493,3294),(61494,3294),(61495,3294),(61496,3295),(61497,3295),(61498,3295),(61499,3296),(61500,3296),(61501,3296),(61502,3297),(61503,3297),(61504,3297),(61505,3298),(61506,3298),(61507,3298),(61508,3299),(61509,3299),(61510,3299),(61511,3300),(61512,3300),(61513,3300),(61514,3301),(61515,3301),(61516,3301),(61517,3302),(61518,3302),(61519,3302),(61520,3303),(61521,3303),(61522,3303),(61523,3304),(61524,3304),(61525,3304),(61526,3305),(61527,3305),(61528,3305),(61529,3306),(61530,3306),(61531,3306),(61532,3307),(61533,3307),(61534,3307),(61535,3308),(61536,3308),(61537,3308),(61538,3309),(61539,3309),(61540,3309),(61541,3310),(61542,3310),(61543,3310),(61544,3311),(61545,3311),(61546,3311),(61547,3312),(61548,3312),(61549,3312),(61550,3313),(61551,3313),(61552,3313),(61553,3314),(61554,3314),(61555,3314),(61556,3315),(61557,3315),(61558,3315),(61559,3316),(61560,3316),(61561,3316),(61562,3317),(61563,3317),(61564,3317),(61565,3318),(61566,3318),(61567,3318),(61568,3319),(61569,3319),(61570,3319),(61571,3320),(61572,3320),(61573,3320),(61574,3321),(61575,3321),(61576,3321),(61577,3322),(61578,3322),(61579,3322),(61580,3323),(61581,3323),(61582,3323),(61583,3324),(61584,3324),(61585,3324),(61586,3325),(61587,3325),(61588,3325),(61589,3326),(61590,3326),(61591,3326),(61592,3327),(61593,3327),(61594,3327),(61595,3328),(61596,3328),(61597,3328),(61598,3329),(61599,3329),(61600,3329),(61601,3330),(61602,3330),(61603,3330),(61604,3331),(61605,3331),(61606,3331),(61607,3332),(61608,3332),(61609,3332),(61610,3333),(61611,3333),(61612,3333),(61613,3334),(61614,3334),(61615,3334),(61616,3335),(61617,3335),(61618,3335),(61619,3336),(61620,3336),(61621,3336),(61622,3337),(61623,3337),(61624,3337),(61625,3338),(61626,3338),(61627,3338),(61628,3339),(61629,3339),(61630,3339),(61631,3340),(61632,3340),(61633,3340),(61634,3341),(61635,3341),(61636,3341),(61637,3342),(61638,3342),(61639,3342),(61640,3343),(61641,3343),(61642,3343),(61643,3344),(61644,3344),(61645,3344),(61646,3345),(61647,3345),(61648,3345),(61649,3346),(61650,3346),(61651,3346),(61652,3347),(61653,3347),(61654,3347),(61655,3348),(61656,3348),(61657,3348),(61658,3349),(61659,3349),(61660,3349),(61661,3350),(61662,3350),(61663,3350),(61664,3351),(61665,3351),(61666,3351),(61667,3352),(61668,3352),(61669,3352),(61670,3353),(61671,3353),(61672,3353),(61673,3354),(61674,3354),(61675,3354),(61676,3355),(61677,3355),(61678,3355),(61679,3356),(61680,3356),(61681,3356),(61682,3357),(61683,3357),(61684,3357),(61685,3358),(61686,3358),(61687,3358),(61688,3359),(61689,3359),(61690,3359),(61691,3360),(61692,3360),(61693,3360),(61694,3361),(61695,3361),(61696,3361),(61697,3362),(61698,3362),(61699,3362),(61700,3363),(61701,3363),(61702,3363),(61703,3364),(61704,3364),(61705,3364),(61706,3365),(61707,3365),(61708,3365),(61709,3366),(61710,3366),(61711,3366),(61712,3367),(61713,3367),(61714,3367),(61715,3368),(61716,3368),(61717,3368),(61718,3269),(61719,3269),(61720,3269),(61721,3269),(61722,3270),(61723,3270),(61724,3270),(61725,3270),(61726,3271),(61727,3271),(61728,3271),(61729,3271),(61730,3272),(61731,3272),(61732,3272),(61733,3272),(61734,3273),(61735,3273),(61736,3273),(61737,3273),(61738,3274),(61739,3274),(61740,3274),(61741,3274),(61742,3275),(61743,3275),(61744,3275),(61745,3275),(61746,3276),(61747,3276),(61748,3276),(61749,3276),(61750,3277),(61751,3277),(61752,3277),(61753,3277),(61754,3278),(61755,3278),(61756,3278),(61757,3278),(61758,3279),(61759,3279),(61760,3279),(61761,3279),(61762,3280),(61763,3280),(61764,3280),(61765,3280),(61766,3281),(61767,3281),(61768,3281),(61769,3281),(61770,3282),(61771,3282),(61772,3282),(61773,3282),(61774,3283),(61775,3283),(61776,3283),(61777,3283),(61778,3284),(61779,3284),(61780,3284),(61781,3284),(61782,3285),(61783,3285),(61784,3285),(61785,3285),(61786,3286),(61787,3286),(61788,3286),(61789,3286),(61790,3287),(61791,3287),(61792,3287),(61793,3287),(61794,3288),(61795,3288),(61796,3288),(61797,3288),(61798,3289),(61799,3289),(61800,3289),(61801,3289),(61802,3290),(61803,3290),(61804,3290),(61805,3290),(61806,3291),(61807,3291),(61808,3291),(61809,3291),(61810,3292),(61811,3292),(61812,3292),(61813,3292),(61814,3293),(61815,3293),(61816,3293),(61817,3293),(61818,3294),(61819,3294),(61820,3294),(61821,3294),(61822,3295),(61823,3295),(61824,3295),(61825,3295),(61826,3296),(61827,3296),(61828,3296),(61829,3296),(61830,3297),(61831,3297),(61832,3297),(61833,3297),(61834,3298),(61835,3298),(61836,3298),(61837,3298),(61838,3299),(61839,3299),(61840,3299),(61841,3299),(61842,3300),(61843,3300),(61844,3300),(61845,3300),(61846,3301),(61847,3301),(61848,3301),(61849,3301),(61850,3302),(61851,3302),(61852,3302),(61853,3302),(61854,3303),(61855,3303),(61856,3303),(61857,3303),(61858,3304),(61859,3304),(61860,3304),(61861,3304),(61862,3305),(61863,3305),(61864,3305),(61865,3305),(61866,3306),(61867,3306),(61868,3306),(61869,3306),(61870,3307),(61871,3307),(61872,3307),(61873,3307),(61874,3308),(61875,3308),(61876,3308),(61877,3308),(61878,3309),(61879,3309),(61880,3309),(61881,3309),(61882,3310),(61883,3310),(61884,3310),(61885,3310),(61886,3311),(61887,3311),(61888,3311),(61889,3311),(61890,3312),(61891,3312),(61892,3312),(61893,3312),(61894,3313),(61895,3313),(61896,3313),(61897,3313),(61898,3314),(61899,3314),(61900,3314),(61901,3314),(61902,3315),(61903,3315),(61904,3315),(61905,3315),(61906,3316),(61907,3316),(61908,3316),(61909,3316),(61910,3317),(61911,3317),(61912,3317),(61913,3317),(61914,3318),(61915,3318),(61916,3318),(61917,3318),(61918,3319),(61919,3319),(61920,3319),(61921,3319),(61922,3320),(61923,3320),(61924,3320),(61925,3320),(61926,3321),(61927,3321),(61928,3321),(61929,3321),(61930,3322),(61931,3322),(61932,3322),(61933,3322),(61934,3323),(61935,3323),(61936,3323),(61937,3323),(61938,3324),(61939,3324),(61940,3324),(61941,3324),(61942,3325),(61943,3325),(61944,3325),(61945,3325),(61946,3326),(61947,3326),(61948,3326),(61949,3326),(61950,3327),(61951,3327),(61952,3327),(61953,3327),(61954,3328),(61955,3328),(61956,3328),(61957,3328),(61958,3329),(61959,3329),(61960,3329),(61961,3329),(61962,3330),(61963,3330),(61964,3330),(61965,3330),(61966,3331),(61967,3331),(61968,3331),(61969,3331),(61970,3332),(61971,3332),(61972,3332),(61973,3332),(61974,3333),(61975,3333),(61976,3333),(61977,3333),(61978,3334),(61979,3334),(61980,3334),(61981,3334),(61982,3335),(61983,3335),(61984,3335),(61985,3335),(61986,3336),(61987,3336),(61988,3336),(61989,3336),(61990,3337),(61991,3337),(61992,3337),(61993,3337),(61994,3338),(61995,3338),(61996,3338),(61997,3338),(61998,3339),(61999,3339),(62000,3339),(62001,3339),(62002,3340),(62003,3340),(62004,3340),(62005,3340),(62006,3341),(62007,3341),(62008,3341),(62009,3341),(62010,3342),(62011,3342),(62012,3342),(62013,3342),(62014,3343),(62015,3343),(62016,3343),(62017,3343),(62018,3344),(62019,3344),(62020,3344),(62021,3344),(62022,3345),(62023,3345),(62024,3345),(62025,3345),(62026,3346),(62027,3346),(62028,3346),(62029,3346),(62030,3347),(62031,3347),(62032,3347),(62033,3347),(62034,3348),(62035,3348),(62036,3348),(62037,3348),(62038,3349),(62039,3349),(62040,3349),(62041,3349),(62042,3350),(62043,3350),(62044,3350),(62045,3350),(62046,3351),(62047,3351),(62048,3351),(62049,3351),(62050,3352),(62051,3352),(62052,3352),(62053,3352),(62054,3353),(62055,3353),(62056,3353),(62057,3353),(62058,3354),(62059,3354),(62060,3354),(62061,3354),(62062,3355),(62063,3355),(62064,3355),(62065,3355),(62066,3356),(62067,3356),(62068,3356),(62069,3356),(62070,3357),(62071,3357),(62072,3357),(62073,3357),(62074,3358),(62075,3358),(62076,3358),(62077,3358),(62078,3359),(62079,3359),(62080,3359),(62081,3359),(62082,3360),(62083,3360),(62084,3360),(62085,3360),(62086,3361),(62087,3361),(62088,3361),(62089,3361),(62090,3362),(62091,3362),(62092,3362),(62093,3362),(62094,3363),(62095,3363),(62096,3363),(62097,3363),(62098,3364),(62099,3364),(62100,3364),(62101,3364),(62102,3365),(62103,3365),(62104,3365),(62105,3365),(62106,3366),(62107,3366),(62108,3366),(62109,3366),(62110,3367),(62111,3367),(62112,3367),(62113,3367),(62114,3368),(62115,3368),(62116,3368),(62117,3368),(62118,3369),(62119,3370),(62120,3371),(62121,3372),(62122,3373),(62123,3374),(62124,3375),(62125,3376),(62126,3377),(62127,3378),(62128,3379),(62129,3380),(62130,3381),(62131,3382),(62132,3383),(62133,3384),(62134,3385),(62135,3386),(62136,3387),(62137,3388),(62138,3389),(62139,3390),(62140,3391),(62141,3392),(62142,3393),(62143,3394),(62144,3395),(62145,3396),(62146,3397),(62147,3398),(62148,3399),(62149,3400),(62150,3401),(62151,3402),(62152,3403),(62153,3404),(62154,3405),(62155,3406),(62156,3407),(62157,3408),(62158,3409),(62159,3410),(62160,3411),(62161,3412),(62162,3413),(62163,3414),(62164,3415),(62165,3416),(62166,3417),(62167,3418),(62168,3419),(62169,3420),(62170,3421),(62171,3422),(62172,3423),(62173,3424),(62174,3425),(62175,3426),(62176,3427),(62177,3428),(62178,3429),(62179,3430),(62180,3431),(62181,3432),(62182,3433),(62183,3434),(62184,3435),(62185,3436),(62186,3437),(62187,3438),(62188,3439),(62189,3440),(62190,3441),(62191,3442),(62192,3443),(62193,3444),(62194,3445),(62195,3446),(62196,3447),(62197,3448),(62198,3449),(62199,3450),(62200,3451),(62201,3452),(62202,3453),(62203,3454),(62204,3455),(62205,3456),(62206,3457),(62207,3458),(62208,3459),(62209,3460),(62210,3461),(62211,3462),(62212,3463),(62213,3464),(62214,3465),(62215,3466),(62216,3467),(62217,3468),(62218,3369),(62219,3370),(62220,3371),(62221,3372),(62222,3373),(62223,3374),(62224,3375),(62225,3376),(62226,3377),(62227,3378),(62228,3379),(62229,3380),(62230,3381),(62231,3382),(62232,3383),(62233,3384),(62234,3385),(62235,3386),(62236,3387),(62237,3388),(62238,3389),(62239,3390),(62240,3391),(62241,3392),(62242,3393),(62243,3394),(62244,3395),(62245,3396),(62246,3397),(62247,3398),(62248,3399),(62249,3400),(62250,3401),(62251,3402),(62252,3403),(62253,3404),(62254,3405),(62255,3406),(62256,3407),(62257,3408),(62258,3409),(62259,3410),(62260,3411),(62261,3412),(62262,3413),(62263,3414),(62264,3415),(62265,3416),(62266,3417),(62267,3418),(62268,3419),(62269,3420),(62270,3421),(62271,3422),(62272,3423),(62273,3424),(62274,3425),(62275,3426),(62276,3427),(62277,3428),(62278,3429),(62279,3430),(62280,3431),(62281,3432),(62282,3433),(62283,3434),(62284,3435),(62285,3436),(62286,3437),(62287,3438),(62288,3439),(62289,3440),(62290,3441),(62291,3442),(62292,3443),(62293,3444),(62294,3445),(62295,3446),(62296,3447),(62297,3448),(62298,3449),(62299,3450),(62300,3451),(62301,3452),(62302,3453),(62303,3454),(62304,3455),(62305,3456),(62306,3457),(62307,3458),(62308,3459),(62309,3460),(62310,3461),(62311,3462),(62312,3463),(62313,3464),(62314,3465),(62315,3466),(62316,3467),(62317,3468),(62318,3369),(62319,3369),(62320,3369),(62321,3369),(62322,3369),(62323,3369),(62324,3370),(62325,3370),(62326,3370),(62327,3370),(62328,3370),(62329,3370),(62330,3371),(62331,3371),(62332,3371),(62333,3371),(62334,3371),(62335,3371),(62336,3372),(62337,3372),(62338,3372),(62339,3372),(62340,3372),(62341,3372),(62342,3373),(62343,3373),(62344,3373),(62345,3373),(62346,3373),(62347,3373),(62348,3374),(62349,3374),(62350,3374),(62351,3374),(62352,3374),(62353,3374),(62354,3375),(62355,3375),(62356,3375),(62357,3375),(62358,3375),(62359,3375),(62360,3376),(62361,3376),(62362,3376),(62363,3376),(62364,3376),(62365,3376),(62366,3377),(62367,3377),(62368,3377),(62369,3377),(62370,3377),(62371,3377),(62372,3378),(62373,3378),(62374,3378),(62375,3378),(62376,3378),(62377,3378),(62378,3379),(62379,3379),(62380,3379),(62381,3379),(62382,3379),(62383,3379),(62384,3380),(62385,3380),(62386,3380),(62387,3380),(62388,3380),(62389,3380),(62390,3381),(62391,3381),(62392,3381),(62393,3381),(62394,3381),(62395,3381),(62396,3382),(62397,3382),(62398,3382),(62399,3382),(62400,3382),(62401,3382),(62402,3383),(62403,3383),(62404,3383),(62405,3383),(62406,3383),(62407,3383),(62408,3384),(62409,3384),(62410,3384),(62411,3384),(62412,3384),(62413,3384),(62414,3385),(62415,3385),(62416,3385),(62417,3385),(62418,3385),(62419,3385),(62420,3386),(62421,3386),(62422,3386),(62423,3386),(62424,3386),(62425,3386),(62426,3387),(62427,3387),(62428,3387),(62429,3387),(62430,3387),(62431,3387),(62432,3388),(62433,3388),(62434,3388),(62435,3388),(62436,3388),(62437,3388),(62438,3389),(62439,3389),(62440,3389),(62441,3389),(62442,3389),(62443,3389),(62444,3390),(62445,3390),(62446,3390),(62447,3390),(62448,3390),(62449,3390),(62450,3391),(62451,3391),(62452,3391),(62453,3391),(62454,3391),(62455,3391),(62456,3392),(62457,3392),(62458,3392),(62459,3392),(62460,3392),(62461,3392),(62462,3393),(62463,3393),(62464,3393),(62465,3393),(62466,3393),(62467,3393),(62468,3394),(62469,3394),(62470,3394),(62471,3394),(62472,3394),(62473,3394),(62474,3395),(62475,3395),(62476,3395),(62477,3395),(62478,3395),(62479,3395),(62480,3396),(62481,3396),(62482,3396),(62483,3396),(62484,3396),(62485,3396),(62486,3397),(62487,3397),(62488,3397),(62489,3397),(62490,3397),(62491,3397),(62492,3398),(62493,3398),(62494,3398),(62495,3398),(62496,3398),(62497,3398),(62498,3399),(62499,3399),(62500,3399),(62501,3399),(62502,3399),(62503,3399),(62504,3400),(62505,3400),(62506,3400),(62507,3400),(62508,3400),(62509,3400),(62510,3401),(62511,3401),(62512,3401),(62513,3401),(62514,3401),(62515,3401),(62516,3402),(62517,3402),(62518,3402),(62519,3402),(62520,3402),(62521,3402),(62522,3403),(62523,3403),(62524,3403),(62525,3403),(62526,3403),(62527,3403),(62528,3404),(62529,3404),(62530,3404),(62531,3404),(62532,3404),(62533,3404),(62534,3405),(62535,3405),(62536,3405),(62537,3405),(62538,3405),(62539,3405),(62540,3406),(62541,3406),(62542,3406),(62543,3406),(62544,3406),(62545,3406),(62546,3407),(62547,3407),(62548,3407),(62549,3407),(62550,3407),(62551,3407),(62552,3408),(62553,3408),(62554,3408),(62555,3408),(62556,3408),(62557,3408),(62558,3409),(62559,3409),(62560,3409),(62561,3409),(62562,3409),(62563,3409),(62564,3410),(62565,3410),(62566,3410),(62567,3410),(62568,3410),(62569,3410),(62570,3411),(62571,3411),(62572,3411),(62573,3411),(62574,3411),(62575,3411),(62576,3412),(62577,3412),(62578,3412),(62579,3412),(62580,3412),(62581,3412),(62582,3413),(62583,3413),(62584,3413),(62585,3413),(62586,3413),(62587,3413),(62588,3414),(62589,3414),(62590,3414),(62591,3414),(62592,3414),(62593,3414),(62594,3415),(62595,3415),(62596,3415),(62597,3415),(62598,3415),(62599,3415),(62600,3416),(62601,3416),(62602,3416),(62603,3416),(62604,3416),(62605,3416),(62606,3417),(62607,3417),(62608,3417),(62609,3417),(62610,3417),(62611,3417),(62612,3418),(62613,3418),(62614,3418),(62615,3418),(62616,3418),(62617,3418),(62618,3419),(62619,3419),(62620,3419),(62621,3419),(62622,3419),(62623,3419),(62624,3420),(62625,3420),(62626,3420),(62627,3420),(62628,3420),(62629,3420),(62630,3421),(62631,3421),(62632,3421),(62633,3421),(62634,3421),(62635,3421),(62636,3422),(62637,3422),(62638,3422),(62639,3422),(62640,3422),(62641,3422),(62642,3423),(62643,3423),(62644,3423),(62645,3423),(62646,3423),(62647,3423),(62648,3424),(62649,3424),(62650,3424),(62651,3424),(62652,3424),(62653,3424),(62654,3425),(62655,3425),(62656,3425),(62657,3425),(62658,3425),(62659,3425),(62660,3426),(62661,3426),(62662,3426),(62663,3426),(62664,3426),(62665,3426),(62666,3427),(62667,3427),(62668,3427),(62669,3427),(62670,3427),(62671,3427),(62672,3428),(62673,3428),(62674,3428),(62675,3428),(62676,3428),(62677,3428),(62678,3429),(62679,3429),(62680,3429),(62681,3429),(62682,3429),(62683,3429),(62684,3430),(62685,3430),(62686,3430),(62687,3430),(62688,3430),(62689,3430),(62690,3431),(62691,3431),(62692,3431),(62693,3431),(62694,3431),(62695,3431),(62696,3432),(62697,3432),(62698,3432),(62699,3432),(62700,3432),(62701,3432),(62702,3433),(62703,3433),(62704,3433),(62705,3433),(62706,3433),(62707,3433),(62708,3434),(62709,3434),(62710,3434),(62711,3434),(62712,3434),(62713,3434),(62714,3435),(62715,3435),(62716,3435),(62717,3435),(62718,3435),(62719,3435),(62720,3436),(62721,3436),(62722,3436),(62723,3436),(62724,3436),(62725,3436),(62726,3437),(62727,3437),(62728,3437),(62729,3437),(62730,3437),(62731,3437),(62732,3438),(62733,3438),(62734,3438),(62735,3438),(62736,3438),(62737,3438),(62738,3439),(62739,3439),(62740,3439),(62741,3439),(62742,3439),(62743,3439),(62744,3440),(62745,3440),(62746,3440),(62747,3440),(62748,3440),(62749,3440),(62750,3441),(62751,3441),(62752,3441),(62753,3441),(62754,3441),(62755,3441),(62756,3442),(62757,3442),(62758,3442),(62759,3442),(62760,3442),(62761,3442),(62762,3443),(62763,3443),(62764,3443),(62765,3443),(62766,3443),(62767,3443),(62768,3444),(62769,3444),(62770,3444),(62771,3444),(62772,3444),(62773,3444),(62774,3445),(62775,3445),(62776,3445),(62777,3445),(62778,3445),(62779,3445),(62780,3446),(62781,3446),(62782,3446),(62783,3446),(62784,3446),(62785,3446),(62786,3447),(62787,3447),(62788,3447),(62789,3447),(62790,3447),(62791,3447),(62792,3448),(62793,3448),(62794,3448),(62795,3448),(62796,3448),(62797,3448),(62798,3449),(62799,3449),(62800,3449),(62801,3449),(62802,3449),(62803,3449),(62804,3450),(62805,3450),(62806,3450),(62807,3450),(62808,3450),(62809,3450),(62810,3451),(62811,3451),(62812,3451),(62813,3451),(62814,3451),(62815,3451),(62816,3452),(62817,3452),(62818,3452),(62819,3452),(62820,3452),(62821,3452),(62822,3453),(62823,3453),(62824,3453),(62825,3453),(62826,3453),(62827,3453),(62828,3454),(62829,3454),(62830,3454),(62831,3454),(62832,3454),(62833,3454),(62834,3455),(62835,3455),(62836,3455),(62837,3455),(62838,3455),(62839,3455),(62840,3456),(62841,3456),(62842,3456),(62843,3456),(62844,3456),(62845,3456),(62846,3457),(62847,3457),(62848,3457),(62849,3457),(62850,3457),(62851,3457),(62852,3458),(62853,3458),(62854,3458),(62855,3458),(62856,3458),(62857,3458),(62858,3459),(62859,3459),(62860,3459),(62861,3459),(62862,3459),(62863,3459),(62864,3460),(62865,3460),(62866,3460),(62867,3460),(62868,3460),(62869,3460),(62870,3461),(62871,3461),(62872,3461),(62873,3461),(62874,3461),(62875,3461),(62876,3462),(62877,3462),(62878,3462),(62879,3462),(62880,3462),(62881,3462),(62882,3463),(62883,3463),(62884,3463),(62885,3463),(62886,3463),(62887,3463),(62888,3464),(62889,3464),(62890,3464),(62891,3464),(62892,3464),(62893,3464),(62894,3465),(62895,3465),(62896,3465),(62897,3465),(62898,3465),(62899,3465),(62900,3466),(62901,3466),(62902,3466),(62903,3466),(62904,3466),(62905,3466),(62906,3467),(62907,3467),(62908,3467),(62909,3467),(62910,3467),(62911,3467),(62912,3468),(62913,3468),(62914,3468),(62915,3468),(62916,3468),(62917,3468),(62918,3369),(62919,3369),(62920,3370),(62921,3370),(62922,3371),(62923,3371),(62924,3372),(62925,3372),(62926,3373),(62927,3373),(62928,3374),(62929,3374),(62930,3375),(62931,3375),(62932,3376),(62933,3376),(62934,3377),(62935,3377),(62936,3378),(62937,3378),(62938,3379),(62939,3379),(62940,3380),(62941,3380),(62942,3381),(62943,3381),(62944,3382),(62945,3382),(62946,3383),(62947,3383),(62948,3384),(62949,3384),(62950,3385),(62951,3385),(62952,3386),(62953,3386),(62954,3387),(62955,3387),(62956,3388),(62957,3388),(62958,3389),(62959,3389),(62960,3390),(62961,3390),(62962,3391),(62963,3391),(62964,3392),(62965,3392),(62966,3393),(62967,3393),(62968,3394),(62969,3394),(62970,3395),(62971,3395),(62972,3396),(62973,3396),(62974,3397),(62975,3397),(62976,3398),(62977,3398),(62978,3399),(62979,3399),(62980,3400),(62981,3400),(62982,3401),(62983,3401),(62984,3402),(62985,3402),(62986,3403),(62987,3403),(62988,3404),(62989,3404),(62990,3405),(62991,3405),(62992,3406),(62993,3406),(62994,3407),(62995,3407),(62996,3408),(62997,3408),(62998,3409),(62999,3409),(63000,3410),(63001,3410),(63002,3411),(63003,3411),(63004,3412),(63005,3412),(63006,3413),(63007,3413),(63008,3414),(63009,3414),(63010,3415),(63011,3415),(63012,3416),(63013,3416),(63014,3417),(63015,3417),(63016,3418),(63017,3418),(63018,3419),(63019,3419),(63020,3420),(63021,3420),(63022,3421),(63023,3421),(63024,3422),(63025,3422),(63026,3423),(63027,3423),(63028,3424),(63029,3424),(63030,3425),(63031,3425),(63032,3426),(63033,3426),(63034,3427),(63035,3427),(63036,3428),(63037,3428),(63038,3429),(63039,3429),(63040,3430),(63041,3430),(63042,3431),(63043,3431),(63044,3432),(63045,3432),(63046,3433),(63047,3433),(63048,3434),(63049,3434),(63050,3435),(63051,3435),(63052,3436),(63053,3436),(63054,3437),(63055,3437),(63056,3438),(63057,3438),(63058,3439),(63059,3439),(63060,3440),(63061,3440),(63062,3441),(63063,3441),(63064,3442),(63065,3442),(63066,3443),(63067,3443),(63068,3444),(63069,3444),(63070,3445),(63071,3445),(63072,3446),(63073,3446),(63074,3447),(63075,3447),(63076,3448),(63077,3448),(63078,3449),(63079,3449),(63080,3450),(63081,3450),(63082,3451),(63083,3451),(63084,3452),(63085,3452),(63086,3453),(63087,3453),(63088,3454),(63089,3454),(63090,3455),(63091,3455),(63092,3456),(63093,3456),(63094,3457),(63095,3457),(63096,3458),(63097,3458),(63098,3459),(63099,3459),(63100,3460),(63101,3460),(63102,3461),(63103,3461),(63104,3462),(63105,3462),(63106,3463),(63107,3463),(63108,3464),(63109,3464),(63110,3465),(63111,3465),(63112,3466),(63113,3466),(63114,3467),(63115,3467),(63116,3468),(63117,3468),(63118,3369),(63119,3369),(63120,3369),(63121,3370),(63122,3370),(63123,3370),(63124,3371),(63125,3371),(63126,3371),(63127,3372),(63128,3372),(63129,3372),(63130,3373),(63131,3373),(63132,3373),(63133,3374),(63134,3374),(63135,3374),(63136,3375),(63137,3375),(63138,3375),(63139,3376),(63140,3376),(63141,3376),(63142,3377),(63143,3377),(63144,3377),(63145,3378),(63146,3378),(63147,3378),(63148,3379),(63149,3379),(63150,3379),(63151,3380),(63152,3380),(63153,3380),(63154,3381),(63155,3381),(63156,3381),(63157,3382),(63158,3382),(63159,3382),(63160,3383),(63161,3383),(63162,3383),(63163,3384),(63164,3384),(63165,3384),(63166,3385),(63167,3385),(63168,3385),(63169,3386),(63170,3386),(63171,3386),(63172,3387),(63173,3387),(63174,3387),(63175,3388),(63176,3388),(63177,3388),(63178,3389),(63179,3389),(63180,3389),(63181,3390),(63182,3390),(63183,3390),(63184,3391),(63185,3391),(63186,3391),(63187,3392),(63188,3392),(63189,3392),(63190,3393),(63191,3393),(63192,3393),(63193,3394),(63194,3394),(63195,3394),(63196,3395),(63197,3395),(63198,3395),(63199,3396),(63200,3396),(63201,3396),(63202,3397),(63203,3397),(63204,3397),(63205,3398),(63206,3398),(63207,3398),(63208,3399),(63209,3399),(63210,3399),(63211,3400),(63212,3400),(63213,3400),(63214,3401),(63215,3401),(63216,3401),(63217,3402),(63218,3402),(63219,3402),(63220,3403),(63221,3403),(63222,3403),(63223,3404),(63224,3404),(63225,3404),(63226,3405),(63227,3405),(63228,3405),(63229,3406),(63230,3406),(63231,3406),(63232,3407),(63233,3407),(63234,3407),(63235,3408),(63236,3408),(63237,3408),(63238,3409),(63239,3409),(63240,3409),(63241,3410),(63242,3410),(63243,3410),(63244,3411),(63245,3411),(63246,3411),(63247,3412),(63248,3412),(63249,3412),(63250,3413),(63251,3413),(63252,3413),(63253,3414),(63254,3414),(63255,3414),(63256,3415),(63257,3415),(63258,3415),(63259,3416),(63260,3416),(63261,3416),(63262,3417),(63263,3417),(63264,3417),(63265,3418),(63266,3418),(63267,3418),(63268,3419),(63269,3419),(63270,3419),(63271,3420),(63272,3420),(63273,3420),(63274,3421),(63275,3421),(63276,3421),(63277,3422),(63278,3422),(63279,3422),(63280,3423),(63281,3423),(63282,3423),(63283,3424),(63284,3424),(63285,3424),(63286,3425),(63287,3425),(63288,3425),(63289,3426),(63290,3426),(63291,3426),(63292,3427),(63293,3427),(63294,3427),(63295,3428),(63296,3428),(63297,3428),(63298,3429),(63299,3429),(63300,3429),(63301,3430),(63302,3430),(63303,3430),(63304,3431),(63305,3431),(63306,3431),(63307,3432),(63308,3432),(63309,3432),(63310,3433),(63311,3433),(63312,3433),(63313,3434),(63314,3434),(63315,3434),(63316,3435),(63317,3435),(63318,3435),(63319,3436),(63320,3436),(63321,3436),(63322,3437),(63323,3437),(63324,3437),(63325,3438),(63326,3438),(63327,3438),(63328,3439),(63329,3439),(63330,3439),(63331,3440),(63332,3440),(63333,3440),(63334,3441),(63335,3441),(63336,3441),(63337,3442),(63338,3442),(63339,3442),(63340,3443),(63341,3443),(63342,3443),(63343,3444),(63344,3444),(63345,3444),(63346,3445),(63347,3445),(63348,3445),(63349,3446),(63350,3446),(63351,3446),(63352,3447),(63353,3447),(63354,3447),(63355,3448),(63356,3448),(63357,3448),(63358,3449),(63359,3449),(63360,3449),(63361,3450),(63362,3450),(63363,3450),(63364,3451),(63365,3451),(63366,3451),(63367,3452),(63368,3452),(63369,3452),(63370,3453),(63371,3453),(63372,3453),(63373,3454),(63374,3454),(63375,3454),(63376,3455),(63377,3455),(63378,3455),(63379,3456),(63380,3456),(63381,3456),(63382,3457),(63383,3457),(63384,3457),(63385,3458),(63386,3458),(63387,3458),(63388,3459),(63389,3459),(63390,3459),(63391,3460),(63392,3460),(63393,3460),(63394,3461),(63395,3461),(63396,3461),(63397,3462),(63398,3462),(63399,3462),(63400,3463),(63401,3463),(63402,3463),(63403,3464),(63404,3464),(63405,3464),(63406,3465),(63407,3465),(63408,3465),(63409,3466),(63410,3466),(63411,3466),(63412,3467),(63413,3467),(63414,3467),(63415,3468),(63416,3468),(63417,3468),(63418,3369),(63419,3369),(63420,3369),(63421,3369),(63422,3370),(63423,3370),(63424,3370),(63425,3370),(63426,3371),(63427,3371),(63428,3371),(63429,3371),(63430,3372),(63431,3372),(63432,3372),(63433,3372),(63434,3373),(63435,3373),(63436,3373),(63437,3373),(63438,3374),(63439,3374),(63440,3374),(63441,3374),(63442,3375),(63443,3375),(63444,3375),(63445,3375),(63446,3376),(63447,3376),(63448,3376),(63449,3376),(63450,3377),(63451,3377),(63452,3377),(63453,3377),(63454,3378),(63455,3378),(63456,3378),(63457,3378),(63458,3379),(63459,3379),(63460,3379),(63461,3379),(63462,3380),(63463,3380),(63464,3380),(63465,3380),(63466,3381),(63467,3381),(63468,3381),(63469,3381),(63470,3382),(63471,3382),(63472,3382),(63473,3382),(63474,3383),(63475,3383),(63476,3383),(63477,3383),(63478,3384),(63479,3384),(63480,3384),(63481,3384),(63482,3385),(63483,3385),(63484,3385),(63485,3385),(63486,3386),(63487,3386),(63488,3386),(63489,3386),(63490,3387),(63491,3387),(63492,3387),(63493,3387),(63494,3388),(63495,3388),(63496,3388),(63497,3388),(63498,3389),(63499,3389),(63500,3389),(63501,3389),(63502,3390),(63503,3390),(63504,3390),(63505,3390),(63506,3391),(63507,3391),(63508,3391),(63509,3391),(63510,3392),(63511,3392),(63512,3392),(63513,3392),(63514,3393),(63515,3393),(63516,3393),(63517,3393),(63518,3394),(63519,3394),(63520,3394),(63521,3394),(63522,3395),(63523,3395),(63524,3395),(63525,3395),(63526,3396),(63527,3396),(63528,3396),(63529,3396),(63530,3397),(63531,3397),(63532,3397),(63533,3397),(63534,3398),(63535,3398),(63536,3398),(63537,3398),(63538,3399),(63539,3399),(63540,3399),(63541,3399),(63542,3400),(63543,3400),(63544,3400),(63545,3400),(63546,3401),(63547,3401),(63548,3401),(63549,3401),(63550,3402),(63551,3402),(63552,3402),(63553,3402),(63554,3403),(63555,3403),(63556,3403),(63557,3403),(63558,3404),(63559,3404),(63560,3404),(63561,3404),(63562,3405),(63563,3405),(63564,3405),(63565,3405),(63566,3406),(63567,3406),(63568,3406),(63569,3406),(63570,3407),(63571,3407),(63572,3407),(63573,3407),(63574,3408),(63575,3408),(63576,3408),(63577,3408),(63578,3409),(63579,3409),(63580,3409),(63581,3409),(63582,3410),(63583,3410),(63584,3410),(63585,3410),(63586,3411),(63587,3411),(63588,3411),(63589,3411),(63590,3412),(63591,3412),(63592,3412),(63593,3412),(63594,3413),(63595,3413),(63596,3413),(63597,3413),(63598,3414),(63599,3414),(63600,3414),(63601,3414),(63602,3415),(63603,3415),(63604,3415),(63605,3415),(63606,3416),(63607,3416),(63608,3416),(63609,3416),(63610,3417),(63611,3417),(63612,3417),(63613,3417),(63614,3418),(63615,3418),(63616,3418),(63617,3418),(63618,3419),(63619,3419),(63620,3419),(63621,3419),(63622,3420),(63623,3420),(63624,3420),(63625,3420),(63626,3421),(63627,3421),(63628,3421),(63629,3421),(63630,3422),(63631,3422),(63632,3422),(63633,3422),(63634,3423),(63635,3423),(63636,3423),(63637,3423),(63638,3424),(63639,3424),(63640,3424),(63641,3424),(63642,3425),(63643,3425),(63644,3425),(63645,3425),(63646,3426),(63647,3426),(63648,3426),(63649,3426),(63650,3427),(63651,3427),(63652,3427),(63653,3427),(63654,3428),(63655,3428),(63656,3428),(63657,3428),(63658,3429),(63659,3429),(63660,3429),(63661,3429),(63662,3430),(63663,3430),(63664,3430),(63665,3430),(63666,3431),(63667,3431),(63668,3431),(63669,3431),(63670,3432),(63671,3432),(63672,3432),(63673,3432),(63674,3433),(63675,3433),(63676,3433),(63677,3433),(63678,3434),(63679,3434),(63680,3434),(63681,3434),(63682,3435),(63683,3435),(63684,3435),(63685,3435),(63686,3436),(63687,3436),(63688,3436),(63689,3436),(63690,3437),(63691,3437),(63692,3437),(63693,3437),(63694,3438),(63695,3438),(63696,3438),(63697,3438),(63698,3439),(63699,3439),(63700,3439),(63701,3439),(63702,3440),(63703,3440),(63704,3440),(63705,3440),(63706,3441),(63707,3441),(63708,3441),(63709,3441),(63710,3442),(63711,3442),(63712,3442),(63713,3442),(63714,3443),(63715,3443),(63716,3443),(63717,3443),(63718,3444),(63719,3444),(63720,3444),(63721,3444),(63722,3445),(63723,3445),(63724,3445),(63725,3445),(63726,3446),(63727,3446),(63728,3446),(63729,3446),(63730,3447),(63731,3447),(63732,3447),(63733,3447),(63734,3448),(63735,3448),(63736,3448),(63737,3448),(63738,3449),(63739,3449),(63740,3449),(63741,3449),(63742,3450),(63743,3450),(63744,3450),(63745,3450),(63746,3451),(63747,3451),(63748,3451),(63749,3451),(63750,3452),(63751,3452),(63752,3452),(63753,3452),(63754,3453),(63755,3453),(63756,3453),(63757,3453),(63758,3454),(63759,3454),(63760,3454),(63761,3454),(63762,3455),(63763,3455),(63764,3455),(63765,3455),(63766,3456),(63767,3456),(63768,3456),(63769,3456),(63770,3457),(63771,3457),(63772,3457),(63773,3457),(63774,3458),(63775,3458),(63776,3458),(63777,3458),(63778,3459),(63779,3459),(63780,3459),(63781,3459),(63782,3460),(63783,3460),(63784,3460),(63785,3460),(63786,3461),(63787,3461),(63788,3461),(63789,3461),(63790,3462),(63791,3462),(63792,3462),(63793,3462),(63794,3463),(63795,3463),(63796,3463),(63797,3463),(63798,3464),(63799,3464),(63800,3464),(63801,3464),(63802,3465),(63803,3465),(63804,3465),(63805,3465),(63806,3466),(63807,3466),(63808,3466),(63809,3466),(63810,3467),(63811,3467),(63812,3467),(63813,3467),(63814,3468),(63815,3468),(63816,3468),(63817,3468),(63818,3469),(63819,3470),(63820,3471),(63821,3472),(63822,3473),(63823,3474),(63824,3475),(63825,3476),(63826,3477),(63827,3478),(63828,3479),(63829,3480),(63830,3481),(63831,3482),(63832,3483),(63833,3484),(63834,3485),(63835,3486),(63836,3487),(63837,3488),(63838,3489),(63839,3490),(63840,3491),(63841,3492),(63842,3493),(63843,3494),(63844,3495),(63845,3496),(63846,3497),(63847,3498),(63848,3499),(63849,3500),(63850,3501),(63851,3502),(63852,3503),(63853,3504),(63854,3505),(63855,3506),(63856,3507),(63857,3508),(63858,3509),(63859,3510),(63860,3511),(63861,3512),(63862,3513),(63863,3514),(63864,3515),(63865,3516),(63866,3517),(63867,3518),(63868,3519),(63869,3520),(63870,3521),(63871,3522),(63872,3523),(63873,3524),(63874,3525),(63875,3526),(63876,3527),(63877,3528),(63878,3529),(63879,3530),(63880,3531),(63881,3532),(63882,3533),(63883,3534),(63884,3535),(63885,3536),(63886,3537),(63887,3538),(63888,3539),(63889,3540),(63890,3541),(63891,3542),(63892,3543),(63893,3544),(63894,3545),(63895,3546),(63896,3547),(63897,3548),(63898,3549),(63899,3550),(63900,3551),(63901,3552),(63902,3553),(63903,3554),(63904,3555),(63905,3556),(63906,3557),(63907,3558),(63908,3559),(63909,3560),(63910,3561),(63911,3562),(63912,3563),(63913,3564),(63914,3565),(63915,3566),(63916,3567),(63917,3568),(63918,3469),(63919,3470),(63920,3471),(63921,3472),(63922,3473),(63923,3474),(63924,3475),(63925,3476),(63926,3477),(63927,3478),(63928,3479),(63929,3480),(63930,3481),(63931,3482),(63932,3483),(63933,3484),(63934,3485),(63935,3486),(63936,3487),(63937,3488),(63938,3489),(63939,3490),(63940,3491),(63941,3492),(63942,3493),(63943,3494),(63944,3495),(63945,3496),(63946,3497),(63947,3498),(63948,3499),(63949,3500),(63950,3501),(63951,3502),(63952,3503),(63953,3504),(63954,3505),(63955,3506),(63956,3507),(63957,3508),(63958,3509),(63959,3510),(63960,3511),(63961,3512),(63962,3513),(63963,3514),(63964,3515),(63965,3516),(63966,3517),(63967,3518),(63968,3519),(63969,3520),(63970,3521),(63971,3522),(63972,3523),(63973,3524),(63974,3525),(63975,3526),(63976,3527),(63977,3528),(63978,3529),(63979,3530),(63980,3531),(63981,3532),(63982,3533),(63983,3534),(63984,3535),(63985,3536),(63986,3537),(63987,3538),(63988,3539),(63989,3540),(63990,3541),(63991,3542),(63992,3543),(63993,3544),(63994,3545),(63995,3546),(63996,3547),(63997,3548),(63998,3549),(63999,3550),(64000,3551),(64001,3552),(64002,3553),(64003,3554),(64004,3555),(64005,3556),(64006,3557),(64007,3558),(64008,3559),(64009,3560),(64010,3561),(64011,3562),(64012,3563),(64013,3564),(64014,3565),(64015,3566),(64016,3567),(64017,3568),(64018,3469),(64019,3469),(64020,3469),(64021,3469),(64022,3469),(64023,3469),(64024,3470),(64025,3470),(64026,3470),(64027,3470),(64028,3470),(64029,3470),(64030,3471),(64031,3471),(64032,3471),(64033,3471),(64034,3471),(64035,3471),(64036,3472),(64037,3472),(64038,3472),(64039,3472),(64040,3472),(64041,3472),(64042,3473),(64043,3473),(64044,3473),(64045,3473),(64046,3473),(64047,3473),(64048,3474),(64049,3474),(64050,3474),(64051,3474),(64052,3474),(64053,3474),(64054,3475),(64055,3475),(64056,3475),(64057,3475),(64058,3475),(64059,3475),(64060,3476),(64061,3476),(64062,3476),(64063,3476),(64064,3476),(64065,3476),(64066,3477),(64067,3477),(64068,3477),(64069,3477),(64070,3477),(64071,3477),(64072,3478),(64073,3478),(64074,3478),(64075,3478),(64076,3478),(64077,3478),(64078,3479),(64079,3479),(64080,3479),(64081,3479),(64082,3479),(64083,3479),(64084,3480),(64085,3480),(64086,3480),(64087,3480),(64088,3480),(64089,3480),(64090,3481),(64091,3481),(64092,3481),(64093,3481),(64094,3481),(64095,3481),(64096,3482),(64097,3482),(64098,3482),(64099,3482),(64100,3482),(64101,3482),(64102,3483),(64103,3483),(64104,3483),(64105,3483),(64106,3483),(64107,3483),(64108,3484),(64109,3484),(64110,3484),(64111,3484),(64112,3484),(64113,3484),(64114,3485),(64115,3485),(64116,3485),(64117,3485),(64118,3485),(64119,3485),(64120,3486),(64121,3486),(64122,3486),(64123,3486),(64124,3486),(64125,3486),(64126,3487),(64127,3487),(64128,3487),(64129,3487),(64130,3487),(64131,3487),(64132,3488),(64133,3488),(64134,3488),(64135,3488),(64136,3488),(64137,3488),(64138,3489),(64139,3489),(64140,3489),(64141,3489),(64142,3489),(64143,3489),(64144,3490),(64145,3490),(64146,3490),(64147,3490),(64148,3490),(64149,3490),(64150,3491),(64151,3491),(64152,3491),(64153,3491),(64154,3491),(64155,3491),(64156,3492),(64157,3492),(64158,3492),(64159,3492),(64160,3492),(64161,3492),(64162,3493),(64163,3493),(64164,3493),(64165,3493),(64166,3493),(64167,3493),(64168,3494),(64169,3494),(64170,3494),(64171,3494),(64172,3494),(64173,3494),(64174,3495),(64175,3495),(64176,3495),(64177,3495),(64178,3495),(64179,3495),(64180,3496),(64181,3496),(64182,3496),(64183,3496),(64184,3496),(64185,3496),(64186,3497),(64187,3497),(64188,3497),(64189,3497),(64190,3497),(64191,3497),(64192,3498),(64193,3498),(64194,3498),(64195,3498),(64196,3498),(64197,3498),(64198,3499),(64199,3499),(64200,3499),(64201,3499),(64202,3499),(64203,3499),(64204,3500),(64205,3500),(64206,3500),(64207,3500),(64208,3500),(64209,3500),(64210,3501),(64211,3501),(64212,3501),(64213,3501),(64214,3501),(64215,3501),(64216,3502),(64217,3502),(64218,3502),(64219,3502),(64220,3502),(64221,3502),(64222,3503),(64223,3503),(64224,3503),(64225,3503),(64226,3503),(64227,3503),(64228,3504),(64229,3504),(64230,3504),(64231,3504),(64232,3504),(64233,3504),(64234,3505),(64235,3505),(64236,3505),(64237,3505),(64238,3505),(64239,3505),(64240,3506),(64241,3506),(64242,3506),(64243,3506),(64244,3506),(64245,3506),(64246,3507),(64247,3507),(64248,3507),(64249,3507),(64250,3507),(64251,3507),(64252,3508),(64253,3508),(64254,3508),(64255,3508),(64256,3508),(64257,3508),(64258,3509),(64259,3509),(64260,3509),(64261,3509),(64262,3509),(64263,3509),(64264,3510),(64265,3510),(64266,3510),(64267,3510),(64268,3510),(64269,3510),(64270,3511),(64271,3511),(64272,3511),(64273,3511),(64274,3511),(64275,3511),(64276,3512),(64277,3512),(64278,3512),(64279,3512),(64280,3512),(64281,3512),(64282,3513),(64283,3513),(64284,3513),(64285,3513),(64286,3513),(64287,3513),(64288,3514),(64289,3514),(64290,3514),(64291,3514),(64292,3514),(64293,3514),(64294,3515),(64295,3515),(64296,3515),(64297,3515),(64298,3515),(64299,3515),(64300,3516),(64301,3516),(64302,3516),(64303,3516),(64304,3516),(64305,3516),(64306,3517),(64307,3517),(64308,3517),(64309,3517),(64310,3517),(64311,3517),(64312,3518),(64313,3518),(64314,3518),(64315,3518),(64316,3518),(64317,3518),(64318,3519),(64319,3519),(64320,3519),(64321,3519),(64322,3519),(64323,3519),(64324,3520),(64325,3520),(64326,3520),(64327,3520),(64328,3520),(64329,3520),(64330,3521),(64331,3521),(64332,3521),(64333,3521),(64334,3521),(64335,3521),(64336,3522),(64337,3522),(64338,3522),(64339,3522),(64340,3522),(64341,3522),(64342,3523),(64343,3523),(64344,3523),(64345,3523),(64346,3523),(64347,3523),(64348,3524),(64349,3524),(64350,3524),(64351,3524),(64352,3524),(64353,3524),(64354,3525),(64355,3525),(64356,3525),(64357,3525),(64358,3525),(64359,3525),(64360,3526),(64361,3526),(64362,3526),(64363,3526),(64364,3526),(64365,3526),(64366,3527),(64367,3527),(64368,3527),(64369,3527),(64370,3527),(64371,3527),(64372,3528),(64373,3528),(64374,3528),(64375,3528),(64376,3529),(64377,3529),(64378,3529),(64379,3529),(64380,3530),(64381,3530),(64382,3530),(64383,3530),(64384,3531),(64385,3531),(64386,3531),(64387,3531),(64388,3532),(64389,3532),(64390,3532),(64391,3532),(64392,3533),(64393,3533),(64394,3533),(64395,3533),(64396,3534),(64397,3534),(64398,3534),(64399,3534),(64400,3534),(64401,3534),(64402,3535),(64403,3535),(64404,3535),(64405,3535),(64406,3535),(64407,3535),(64408,3536),(64409,3536),(64410,3536),(64411,3536),(64412,3536),(64413,3536),(64414,3537),(64415,3537),(64416,3537),(64417,3537),(64418,3537),(64419,3537),(64420,3538),(64421,3538),(64422,3538),(64423,3538),(64424,3538),(64425,3538),(64426,3539),(64427,3539),(64428,3539),(64429,3539),(64430,3539),(64431,3539),(64432,3540),(64433,3540),(64434,3540),(64435,3540),(64436,3540),(64437,3540),(64438,3541),(64439,3541),(64440,3541),(64441,3541),(64442,3541),(64443,3541),(64444,3542),(64445,3542),(64446,3542),(64447,3542),(64448,3542),(64449,3542),(64450,3543),(64451,3543),(64452,3543),(64453,3543),(64454,3543),(64455,3543),(64456,3544),(64457,3544),(64458,3544),(64459,3544),(64460,3544),(64461,3544),(64462,3545),(64463,3545),(64464,3545),(64465,3545),(64466,3545),(64467,3545),(64468,3546),(64469,3546),(64470,3546),(64471,3546),(64472,3546),(64473,3546),(64474,3547),(64475,3547),(64476,3547),(64477,3547),(64478,3547),(64479,3547),(64480,3548),(64481,3548),(64482,3548),(64483,3548),(64484,3548),(64485,3548),(64486,3549),(64487,3549),(64488,3549),(64489,3549),(64490,3550),(64491,3550),(64492,3550),(64493,3550),(64494,3551),(64495,3551),(64496,3551),(64497,3551),(64498,3551),(64499,3551),(64500,3552),(64501,3552),(64502,3552),(64503,3552),(64504,3552),(64505,3552),(64506,3553),(64507,3553),(64508,3553),(64509,3553),(64510,3553),(64511,3553),(64512,3554),(64513,3554),(64514,3554),(64515,3554),(64516,3554),(64517,3554),(64518,3555),(64519,3555),(64520,3555),(64521,3555),(64522,3555),(64523,3555),(64524,3556),(64525,3556),(64526,3556),(64527,3556),(64528,3556),(64529,3556),(64530,3557),(64531,3557),(64532,3557),(64533,3557),(64534,3557),(64535,3557),(64536,3558),(64537,3558),(64538,3558),(64539,3558),(64540,3558),(64541,3558),(64542,3559),(64543,3559),(64544,3559),(64545,3559),(64546,3559),(64547,3559),(64548,3560),(64549,3560),(64550,3560),(64551,3560),(64552,3560),(64553,3560),(64554,3561),(64555,3561),(64556,3561),(64557,3561),(64558,3561),(64559,3561),(64560,3562),(64561,3562),(64562,3562),(64563,3562),(64564,3562),(64565,3562),(64566,3563),(64567,3563),(64568,3563),(64569,3563),(64570,3563),(64571,3563),(64572,3564),(64573,3564),(64574,3564),(64575,3564),(64576,3564),(64577,3564),(64578,3565),(64579,3565),(64580,3565),(64581,3565),(64582,3565),(64583,3565),(64584,3566),(64585,3566),(64586,3566),(64587,3566),(64588,3566),(64589,3566),(64590,3567),(64591,3567),(64592,3567),(64593,3567),(64594,3567),(64595,3567),(64596,3568),(64597,3568),(64598,3568),(64599,3568),(64600,3568),(64601,3568),(64602,3469),(64603,3469),(64604,3470),(64605,3470),(64606,3471),(64607,3471),(64608,3472),(64609,3472),(64610,3473),(64611,3473),(64612,3474),(64613,3474),(64614,3475),(64615,3475),(64616,3476),(64617,3476),(64618,3477),(64619,3477),(64620,3478),(64621,3478),(64622,3479),(64623,3479),(64624,3480),(64625,3480),(64626,3481),(64627,3481),(64628,3482),(64629,3482),(64630,3483),(64631,3483),(64632,3484),(64633,3484),(64634,3485),(64635,3485),(64636,3486),(64637,3486),(64638,3487),(64639,3487),(64640,3488),(64641,3488),(64642,3489),(64643,3489),(64644,3490),(64645,3490),(64646,3491),(64647,3491),(64648,3492),(64649,3492),(64650,3493),(64651,3493),(64652,3494),(64653,3494),(64654,3495),(64655,3495),(64656,3496),(64657,3496),(64658,3497),(64659,3497),(64660,3498),(64661,3498),(64662,3499),(64663,3499),(64664,3500),(64665,3500),(64666,3501),(64667,3501),(64668,3502),(64669,3502),(64670,3503),(64671,3503),(64672,3504),(64673,3504),(64674,3505),(64675,3505),(64676,3506),(64677,3506),(64678,3507),(64679,3507),(64680,3508),(64681,3508),(64682,3509),(64683,3509),(64684,3510),(64685,3510),(64686,3511),(64687,3511),(64688,3512),(64689,3512),(64690,3513),(64691,3513),(64692,3514),(64693,3514),(64694,3515),(64695,3515),(64696,3516),(64697,3516),(64698,3517),(64699,3517),(64700,3518),(64701,3518),(64702,3519),(64703,3519),(64704,3520),(64705,3520),(64706,3521),(64707,3521),(64708,3522),(64709,3522),(64710,3523),(64711,3523),(64712,3524),(64713,3524),(64714,3525),(64715,3525),(64716,3526),(64717,3526),(64718,3527),(64719,3527),(64720,3528),(64721,3528),(64722,3529),(64723,3529),(64724,3530),(64725,3530),(64726,3531),(64727,3531),(64728,3532),(64729,3532),(64730,3533),(64731,3533),(64732,3534),(64733,3534),(64734,3535),(64735,3535),(64736,3536),(64737,3536),(64738,3537),(64739,3537),(64740,3537),(64741,3538),(64742,3538),(64743,3538),(64744,3539),(64745,3539),(64746,3540),(64747,3540),(64748,3541),(64749,3541),(64750,3542),(64751,3542),(64752,3543),(64753,3543),(64754,3543),(64755,3544),(64756,3544),(64757,3544),(64758,3545),(64759,3545),(64760,3545),(64761,3546),(64762,3546),(64763,3546),(64764,3547),(64765,3547),(64766,3547),(64767,3548),(64768,3548),(64769,3548),(64770,3549),(64771,3549),(64772,3550),(64773,3550),(64774,3551),(64775,3551),(64776,3551),(64777,3552),(64778,3552),(64779,3552),(64780,3553),(64781,3553),(64782,3553),(64783,3554),(64784,3554),(64785,3554),(64786,3555),(64787,3555),(64788,3555),(64789,3556),(64790,3556),(64791,3556),(64792,3557),(64793,3557),(64794,3557),(64795,3558),(64796,3558),(64797,3558),(64798,3559),(64799,3559),(64800,3559),(64801,3560),(64802,3560),(64803,3560),(64804,3561),(64805,3561),(64806,3561),(64807,3562),(64808,3562),(64809,3562),(64810,3563),(64811,3563),(64812,3563),(64813,3564),(64814,3564),(64815,3564),(64816,3565),(64817,3565),(64818,3565),(64819,3566),(64820,3566),(64821,3566),(64822,3567),(64823,3567),(64824,3567),(64825,3568),(64826,3568),(64827,3568),(64828,3469),(64829,3469),(64830,3469),(64831,3470),(64832,3470),(64833,3470),(64834,3471),(64835,3471),(64836,3471),(64837,3472),(64838,3472),(64839,3472),(64840,3473),(64841,3473),(64842,3473),(64843,3474),(64844,3474),(64845,3474),(64846,3475),(64847,3475),(64848,3475),(64849,3476),(64850,3476),(64851,3476),(64852,3477),(64853,3477),(64854,3477),(64855,3478),(64856,3478),(64857,3478),(64858,3479),(64859,3479),(64860,3479),(64861,3480),(64862,3480),(64863,3480),(64864,3481),(64865,3481),(64866,3481),(64867,3482),(64868,3482),(64869,3482),(64870,3483),(64871,3483),(64872,3483),(64873,3484),(64874,3484),(64875,3484),(64876,3485),(64877,3485),(64878,3485),(64879,3486),(64880,3486),(64881,3486),(64882,3487),(64883,3487),(64884,3487),(64885,3488),(64886,3488),(64887,3488),(64888,3489),(64889,3489),(64890,3489),(64891,3490),(64892,3490),(64893,3490),(64894,3491),(64895,3491),(64896,3491),(64897,3492),(64898,3492),(64899,3492),(64900,3493),(64901,3493),(64902,3493),(64903,3494),(64904,3494),(64905,3494),(64906,3495),(64907,3495),(64908,3495),(64909,3496),(64910,3496),(64911,3496),(64912,3497),(64913,3497),(64914,3497),(64915,3498),(64916,3498),(64917,3498),(64918,3499),(64919,3499),(64920,3499),(64921,3500),(64922,3500),(64923,3500),(64924,3501),(64925,3501),(64926,3501),(64927,3502),(64928,3502),(64929,3502),(64930,3503),(64931,3503),(64932,3503),(64933,3504),(64934,3504),(64935,3504),(64936,3505),(64937,3505),(64938,3505),(64939,3506),(64940,3506),(64941,3506),(64942,3507),(64943,3507),(64944,3507),(64945,3508),(64946,3508),(64947,3508),(64948,3509),(64949,3509),(64950,3509),(64951,3510),(64952,3510),(64953,3510),(64954,3511),(64955,3511),(64956,3511),(64957,3512),(64958,3512),(64959,3512),(64960,3513),(64961,3513),(64962,3513),(64963,3514),(64964,3514),(64965,3514),(64966,3515),(64967,3515),(64968,3515),(64969,3516),(64970,3516),(64971,3516),(64972,3517),(64973,3517),(64974,3517),(64975,3518),(64976,3518),(64977,3518),(64978,3519),(64979,3519),(64980,3519),(64981,3520),(64982,3520),(64983,3520),(64984,3521),(64985,3521),(64986,3521),(64987,3522),(64988,3522),(64989,3522),(64990,3523),(64991,3523),(64992,3523),(64993,3524),(64994,3524),(64995,3524),(64996,3525),(64997,3525),(64998,3525),(64999,3526),(65000,3526),(65001,3526),(65002,3527),(65003,3527),(65004,3527),(65005,3528),(65006,3528),(65007,3528),(65008,3529),(65009,3529),(65010,3529),(65011,3530),(65012,3530),(65013,3530),(65014,3531),(65015,3531),(65016,3531),(65017,3532),(65018,3532),(65019,3532),(65020,3533),(65021,3533),(65022,3533),(65023,3534),(65024,3534),(65025,3534),(65026,3535),(65027,3535),(65028,3535),(65029,3536),(65030,3536),(65031,3536),(65032,3537),(65033,3537),(65034,3537),(65035,3538),(65036,3538),(65037,3538),(65038,3539),(65039,3539),(65040,3539),(65041,3540),(65042,3540),(65043,3540),(65044,3541),(65045,3541),(65046,3541),(65047,3542),(65048,3542),(65049,3542),(65050,3543),(65051,3543),(65052,3543),(65053,3544),(65054,3544),(65055,3544),(65056,3545),(65057,3545),(65058,3545),(65059,3546),(65060,3546),(65061,3546),(65062,3547),(65063,3547),(65064,3547),(65065,3548),(65066,3548),(65067,3548),(65068,3549),(65069,3549),(65070,3549),(65071,3550),(65072,3550),(65073,3550),(65074,3551),(65075,3551),(65076,3551),(65077,3552),(65078,3552),(65079,3552),(65080,3553),(65081,3553),(65082,3553),(65083,3554),(65084,3554),(65085,3554),(65086,3555),(65087,3555),(65088,3555),(65089,3556),(65090,3556),(65091,3556),(65092,3557),(65093,3557),(65094,3557),(65095,3558),(65096,3558),(65097,3558),(65098,3559),(65099,3559),(65100,3559),(65101,3560),(65102,3560),(65103,3560),(65104,3561),(65105,3561),(65106,3561),(65107,3562),(65108,3562),(65109,3562),(65110,3563),(65111,3563),(65112,3563),(65113,3564),(65114,3564),(65115,3564),(65116,3565),(65117,3565),(65118,3565),(65119,3566),(65120,3566),(65121,3566),(65122,3567),(65123,3567),(65124,3567),(65125,3568),(65126,3568),(65127,3568),(65128,3469),(65129,3469),(65130,3469),(65131,3469),(65132,3470),(65133,3470),(65134,3470),(65135,3470),(65136,3471),(65137,3471),(65138,3471),(65139,3471),(65140,3472),(65141,3472),(65142,3472),(65143,3472),(65144,3473),(65145,3473),(65146,3473),(65147,3473),(65148,3474),(65149,3474),(65150,3474),(65151,3474),(65152,3475),(65153,3475),(65154,3475),(65155,3475),(65156,3476),(65157,3476),(65158,3476),(65159,3476),(65160,3477),(65161,3477),(65162,3477),(65163,3477),(65164,3478),(65165,3478),(65166,3478),(65167,3478),(65168,3479),(65169,3479),(65170,3479),(65171,3479),(65172,3480),(65173,3480),(65174,3480),(65175,3480),(65176,3481),(65177,3481),(65178,3481),(65179,3481),(65180,3482),(65181,3482),(65182,3482),(65183,3482),(65184,3483),(65185,3483),(65186,3483),(65187,3483),(65188,3484),(65189,3484),(65190,3484),(65191,3484),(65192,3485),(65193,3485),(65194,3485),(65195,3485),(65196,3486),(65197,3486),(65198,3486),(65199,3486),(65200,3487),(65201,3487),(65202,3487),(65203,3487),(65204,3488),(65205,3488),(65206,3488),(65207,3488),(65208,3489),(65209,3489),(65210,3489),(65211,3489),(65212,3490),(65213,3490),(65214,3490),(65215,3490),(65216,3491),(65217,3491),(65218,3491),(65219,3491),(65220,3492),(65221,3492),(65222,3492),(65223,3492),(65224,3493),(65225,3493),(65226,3493),(65227,3493),(65228,3494),(65229,3494),(65230,3494),(65231,3494),(65232,3495),(65233,3495),(65234,3495),(65235,3495),(65236,3496),(65237,3496),(65238,3496),(65239,3496),(65240,3497),(65241,3497),(65242,3497),(65243,3497),(65244,3498),(65245,3498),(65246,3498),(65247,3498),(65248,3499),(65249,3499),(65250,3499),(65251,3499),(65252,3500),(65253,3500),(65254,3500),(65255,3500),(65256,3501),(65257,3501),(65258,3501),(65259,3501),(65260,3502),(65261,3502),(65262,3502),(65263,3502),(65264,3503),(65265,3503),(65266,3503),(65267,3503),(65268,3504),(65269,3504),(65270,3504),(65271,3504),(65272,3505),(65273,3505),(65274,3505),(65275,3505),(65276,3506),(65277,3506),(65278,3506),(65279,3506),(65280,3507),(65281,3507),(65282,3507),(65283,3507),(65284,3508),(65285,3508),(65286,3508),(65287,3508),(65288,3509),(65289,3509),(65290,3509),(65291,3509),(65292,3510),(65293,3510),(65294,3510),(65295,3510),(65296,3511),(65297,3511),(65298,3511),(65299,3511),(65300,3512),(65301,3512),(65302,3512),(65303,3512),(65304,3513),(65305,3513),(65306,3513),(65307,3513),(65308,3514),(65309,3514),(65310,3514),(65311,3514),(65312,3515),(65313,3515),(65314,3515),(65315,3515),(65316,3516),(65317,3516),(65318,3516),(65319,3516),(65320,3517),(65321,3517),(65322,3517),(65323,3517),(65324,3518),(65325,3518),(65326,3518),(65327,3518),(65328,3519),(65329,3519),(65330,3519),(65331,3519),(65332,3520),(65333,3520),(65334,3520),(65335,3520),(65336,3521),(65337,3521),(65338,3521),(65339,3521),(65340,3522),(65341,3522),(65342,3522),(65343,3522),(65344,3523),(65345,3523),(65346,3523),(65347,3523),(65348,3524),(65349,3524),(65350,3524),(65351,3524),(65352,3525),(65353,3525),(65354,3525),(65355,3525),(65356,3526),(65357,3526),(65358,3526),(65359,3526),(65360,3527),(65361,3527),(65362,3527),(65363,3527),(65364,3528),(65365,3528),(65366,3528),(65367,3528),(65368,3529),(65369,3529),(65370,3529),(65371,3529),(65372,3530),(65373,3530),(65374,3530),(65375,3530),(65376,3531),(65377,3531),(65378,3531),(65379,3531),(65380,3532),(65381,3532),(65382,3532),(65383,3532),(65384,3533),(65385,3533),(65386,3533),(65387,3533),(65388,3534),(65389,3534),(65390,3534),(65391,3534),(65392,3535),(65393,3535),(65394,3535),(65395,3535),(65396,3536),(65397,3536),(65398,3536),(65399,3536),(65400,3537),(65401,3537),(65402,3537),(65403,3537),(65404,3538),(65405,3538),(65406,3538),(65407,3538),(65408,3539),(65409,3539),(65410,3539),(65411,3539),(65412,3540),(65413,3540),(65414,3540),(65415,3540),(65416,3541),(65417,3541),(65418,3541),(65419,3541),(65420,3542),(65421,3542),(65422,3542),(65423,3542),(65424,3543),(65425,3543),(65426,3543),(65427,3543),(65428,3544),(65429,3544),(65430,3544),(65431,3544),(65432,3545),(65433,3545),(65434,3545),(65435,3545),(65436,3546),(65437,3546),(65438,3546),(65439,3546),(65440,3547),(65441,3547),(65442,3547),(65443,3547),(65444,3548),(65445,3548),(65446,3548),(65447,3548),(65448,3549),(65449,3549),(65450,3549),(65451,3549),(65452,3550),(65453,3550),(65454,3550),(65455,3550),(65456,3551),(65457,3551),(65458,3551),(65459,3551),(65460,3552),(65461,3552),(65462,3552),(65463,3552),(65464,3553),(65465,3553),(65466,3553),(65467,3553),(65468,3554),(65469,3554),(65470,3554),(65471,3554),(65472,3555),(65473,3555),(65474,3555),(65475,3555),(65476,3556),(65477,3556),(65478,3556),(65479,3556),(65480,3557),(65481,3557),(65482,3557),(65483,3557),(65484,3558),(65485,3558),(65486,3558),(65487,3558),(65488,3559),(65489,3559),(65490,3559),(65491,3559),(65492,3560),(65493,3560),(65494,3560),(65495,3560),(65496,3561),(65497,3561),(65498,3561),(65499,3561),(65500,3562),(65501,3562),(65502,3562),(65503,3562),(65504,3563),(65505,3563),(65506,3563),(65507,3563),(65508,3564),(65509,3564),(65510,3564),(65511,3564),(65512,3565),(65513,3565),(65514,3565),(65515,3565),(65516,3566),(65517,3566),(65518,3566),(65519,3566),(65520,3567),(65521,3567),(65522,3567),(65523,3567),(65524,3568),(65525,3568),(65526,3568),(65527,3568),(65528,3569),(65529,3570),(65530,3571),(65531,3572),(65532,3573),(65533,3574),(65534,3575),(65535,3576),(65536,3577),(65537,3578),(65538,3579),(65539,3580),(65540,3581),(65541,3582),(65542,3583),(65543,3584),(65544,3585),(65545,3586),(65546,3587),(65547,3588),(65548,3589),(65549,3590),(65550,3591),(65551,3592),(65552,3593),(65553,3594),(65554,3595),(65555,3596),(65556,3597),(65557,3598),(65558,3599),(65559,3600),(65560,3601),(65561,3602),(65562,3603),(65563,3604),(65564,3605),(65565,3606),(65566,3607),(65567,3608),(65568,3609),(65569,3610),(65570,3611),(65571,3612),(65572,3613),(65573,3614),(65574,3615),(65575,3616),(65576,3617),(65577,3618),(65578,3619),(65579,3620),(65580,3621),(65581,3622),(65582,3623),(65583,3624),(65584,3625),(65585,3626),(65586,3627),(65587,3628),(65588,3629),(65589,3630),(65590,3631),(65591,3632),(65592,3633),(65593,3634),(65594,3635),(65595,3636),(65596,3637),(65597,3638),(65598,3639),(65599,3640),(65600,3641),(65601,3642),(65602,3643),(65603,3644),(65604,3645),(65605,3646),(65606,3647),(65607,3648),(65608,3649),(65609,3650),(65610,3651),(65611,3652),(65612,3653),(65613,3654),(65614,3655),(65615,3656),(65616,3657),(65617,3658),(65618,3659),(65619,3660),(65620,3661),(65621,3662),(65622,3663),(65623,3664),(65624,3665),(65625,3666),(65626,3667),(65627,3668),(65628,3569),(65629,3570),(65630,3571),(65631,3572),(65632,3573),(65633,3574),(65634,3575),(65635,3576),(65636,3577),(65637,3578),(65638,3579),(65639,3580),(65640,3581),(65641,3582),(65642,3583),(65643,3584),(65644,3585),(65645,3586),(65646,3587),(65647,3588),(65648,3589),(65649,3590),(65650,3591),(65651,3592),(65652,3593),(65653,3594),(65654,3595),(65655,3596),(65656,3597),(65657,3598),(65658,3599),(65659,3600),(65660,3601),(65661,3602),(65662,3603),(65663,3604),(65664,3605),(65665,3606),(65666,3607),(65667,3608),(65668,3609),(65669,3610),(65670,3611),(65671,3612),(65672,3613),(65673,3614),(65674,3615),(65675,3616),(65676,3617),(65677,3618),(65678,3619),(65679,3620),(65680,3621),(65681,3622),(65682,3623),(65683,3624),(65684,3625),(65685,3626),(65686,3627),(65687,3628),(65688,3629),(65689,3630),(65690,3631),(65691,3632),(65692,3633),(65693,3634),(65694,3635),(65695,3636),(65696,3637),(65697,3638),(65698,3639),(65699,3640),(65700,3641),(65701,3642),(65702,3643),(65703,3644),(65704,3645),(65705,3646),(65706,3647),(65707,3648),(65708,3649),(65709,3650),(65710,3651),(65711,3652),(65712,3653),(65713,3654),(65714,3655),(65715,3656),(65716,3657),(65717,3658),(65718,3659),(65719,3660),(65720,3661),(65721,3662),(65722,3663),(65723,3664),(65724,3665),(65725,3666),(65726,3667),(65727,3668),(65728,3569),(65729,3569),(65730,3569),(65731,3569),(65732,3569),(65733,3569),(65734,3570),(65735,3570),(65736,3570),(65737,3570),(65738,3570),(65739,3570),(65740,3571),(65741,3571),(65742,3571),(65743,3571),(65744,3571),(65745,3571),(65746,3572),(65747,3572),(65748,3572),(65749,3572),(65750,3572),(65751,3572),(65752,3573),(65753,3573),(65754,3573),(65755,3573),(65756,3573),(65757,3573),(65758,3574),(65759,3574),(65760,3574),(65761,3574),(65762,3574),(65763,3574),(65764,3575),(65765,3575),(65766,3575),(65767,3575),(65768,3575),(65769,3575),(65770,3576),(65771,3576),(65772,3576),(65773,3576),(65774,3576),(65775,3576),(65776,3577),(65777,3577),(65778,3577),(65779,3577),(65780,3577),(65781,3577),(65782,3578),(65783,3578),(65784,3578),(65785,3578),(65786,3578),(65787,3578),(65788,3579),(65789,3579),(65790,3579),(65791,3579),(65792,3579),(65793,3579),(65794,3580),(65795,3580),(65796,3580),(65797,3580),(65798,3580),(65799,3580),(65800,3581),(65801,3581),(65802,3581),(65803,3581),(65804,3581),(65805,3581),(65806,3582),(65807,3582),(65808,3582),(65809,3582),(65810,3582),(65811,3582),(65812,3583),(65813,3583),(65814,3583),(65815,3583),(65816,3583),(65817,3583),(65818,3584),(65819,3584),(65820,3584),(65821,3584),(65822,3584),(65823,3584),(65824,3585),(65825,3585),(65826,3585),(65827,3585),(65828,3585),(65829,3585),(65830,3586),(65831,3586),(65832,3586),(65833,3586),(65834,3586),(65835,3586),(65836,3587),(65837,3587),(65838,3587),(65839,3587),(65840,3587),(65841,3587),(65842,3588),(65843,3588),(65844,3588),(65845,3588),(65846,3588),(65847,3588),(65848,3589),(65849,3589),(65850,3589),(65851,3589),(65852,3589),(65853,3589),(65854,3590),(65855,3590),(65856,3590),(65857,3590),(65858,3590),(65859,3590),(65860,3591),(65861,3591),(65862,3591),(65863,3591),(65864,3591),(65865,3591),(65866,3592),(65867,3592),(65868,3592),(65869,3592),(65870,3592),(65871,3592),(65872,3593),(65873,3593),(65874,3593),(65875,3593),(65876,3593),(65877,3593),(65878,3594),(65879,3594),(65880,3594),(65881,3594),(65882,3594),(65883,3594),(65884,3595),(65885,3595),(65886,3595),(65887,3595),(65888,3595),(65889,3595),(65890,3596),(65891,3596),(65892,3596),(65893,3596),(65894,3596),(65895,3596),(65896,3597),(65897,3597),(65898,3597),(65899,3597),(65900,3597),(65901,3597),(65902,3598),(65903,3598),(65904,3598),(65905,3598),(65906,3598),(65907,3598),(65908,3599),(65909,3599),(65910,3599),(65911,3599),(65912,3599),(65913,3599),(65914,3600),(65915,3600),(65916,3600),(65917,3600),(65918,3600),(65919,3600),(65920,3601),(65921,3601),(65922,3601),(65923,3601),(65924,3601),(65925,3601),(65926,3602),(65927,3602),(65928,3602),(65929,3602),(65930,3602),(65931,3602),(65932,3603),(65933,3603),(65934,3603),(65935,3603),(65936,3603),(65937,3603),(65938,3604),(65939,3604),(65940,3604),(65941,3604),(65942,3604),(65943,3604),(65944,3605),(65945,3605),(65946,3605),(65947,3605),(65948,3605),(65949,3605),(65950,3606),(65951,3606),(65952,3606),(65953,3606),(65954,3606),(65955,3606),(65956,3607),(65957,3607),(65958,3607),(65959,3607),(65960,3607),(65961,3607),(65962,3608),(65963,3608),(65964,3608),(65965,3608),(65966,3608),(65967,3608),(65968,3609),(65969,3609),(65970,3609),(65971,3609),(65972,3609),(65973,3609),(65974,3610),(65975,3610),(65976,3610),(65977,3610),(65978,3611),(65979,3611),(65980,3611),(65981,3611),(65982,3612),(65983,3612),(65984,3612),(65985,3612),(65986,3613),(65987,3613),(65988,3613),(65989,3613),(65990,3614),(65991,3614),(65992,3614),(65993,3614),(65994,3614),(65995,3614),(65996,3615),(65997,3615),(65998,3615),(65999,3615),(66000,3615),(66001,3615),(66002,3616),(66003,3616),(66004,3616),(66005,3616),(66006,3616),(66007,3616),(66008,3617),(66009,3617),(66010,3617),(66011,3617),(66012,3617),(66013,3617),(66014,3618),(66015,3618),(66016,3618),(66017,3618),(66018,3618),(66019,3618),(66020,3619),(66021,3619),(66022,3619),(66023,3619),(66024,3619),(66025,3619),(66026,3620),(66027,3620),(66028,3620),(66029,3620),(66030,3620),(66031,3620),(66032,3621),(66033,3621),(66034,3621),(66035,3621),(66036,3621),(66037,3621),(66038,3622),(66039,3622),(66040,3622),(66041,3622),(66042,3622),(66043,3622),(66044,3623),(66045,3623),(66046,3623),(66047,3623),(66048,3623),(66049,3623),(66050,3624),(66051,3624),(66052,3624),(66053,3624),(66054,3624),(66055,3624),(66056,3625),(66057,3625),(66058,3625),(66059,3625),(66060,3625),(66061,3625),(66062,3626),(66063,3626),(66064,3626),(66065,3626),(66066,3626),(66067,3626),(66068,3627),(66069,3627),(66070,3627),(66071,3627),(66072,3627),(66073,3627),(66074,3628),(66075,3628),(66076,3628),(66077,3628),(66078,3628),(66079,3628),(66080,3629),(66081,3629),(66082,3629),(66083,3629),(66084,3629),(66085,3629),(66086,3630),(66087,3630),(66088,3630),(66089,3630),(66090,3630),(66091,3630),(66092,3631),(66093,3631),(66094,3631),(66095,3631),(66096,3631),(66097,3631),(66098,3632),(66099,3632),(66100,3632),(66101,3632),(66102,3632),(66103,3632),(66104,3633),(66105,3633),(66106,3633),(66107,3633),(66108,3633),(66109,3633),(66110,3634),(66111,3634),(66112,3634),(66113,3634),(66114,3634),(66115,3634),(66116,3635),(66117,3635),(66118,3635),(66119,3635),(66120,3635),(66121,3635),(66122,3636),(66123,3636),(66124,3636),(66125,3636),(66126,3636),(66127,3636),(66128,3637),(66129,3637),(66130,3637),(66131,3637),(66132,3637),(66133,3637),(66134,3638),(66135,3638),(66136,3638),(66137,3638),(66138,3638),(66139,3638),(66140,3639),(66141,3639),(66142,3639),(66143,3639),(66144,3639),(66145,3639),(66146,3640),(66147,3640),(66148,3640),(66149,3640),(66150,3640),(66151,3640),(66152,3641),(66153,3641),(66154,3641),(66155,3641),(66156,3641),(66157,3641),(66158,3642),(66159,3642),(66160,3642),(66161,3642),(66162,3642),(66163,3642),(66164,3643),(66165,3643),(66166,3643),(66167,3643),(66168,3643),(66169,3643),(66170,3644),(66171,3644),(66172,3644),(66173,3644),(66174,3645),(66175,3645),(66176,3645),(66177,3645),(66178,3646),(66179,3646),(66180,3646),(66181,3646),(66182,3647),(66183,3647),(66184,3647),(66185,3647),(66186,3648),(66187,3648),(66188,3648),(66189,3648),(66190,3648),(66191,3648),(66192,3649),(66193,3649),(66194,3649),(66195,3649),(66196,3650),(66197,3650),(66198,3650),(66199,3650),(66200,3651),(66201,3651),(66202,3651),(66203,3651),(66204,3652),(66205,3652),(66206,3652),(66207,3652),(66208,3653),(66209,3653),(66210,3653),(66211,3653),(66212,3654),(66213,3654),(66214,3654),(66215,3654),(66216,3655),(66217,3655),(66218,3655),(66219,3655),(66220,3656),(66221,3656),(66222,3656),(66223,3656),(66224,3657),(66225,3657),(66226,3657),(66227,3657),(66228,3658),(66229,3658),(66230,3658),(66231,3658),(66232,3659),(66233,3659),(66234,3659),(66235,3659),(66236,3659),(66237,3659),(66238,3660),(66239,3660),(66240,3660),(66241,3660),(66242,3660),(66243,3660),(66244,3661),(66245,3661),(66246,3661),(66247,3661),(66248,3661),(66249,3661),(66250,3662),(66251,3662),(66252,3662),(66253,3662),(66254,3662),(66255,3662),(66256,3663),(66257,3663),(66258,3663),(66259,3663),(66260,3663),(66261,3663),(66262,3664),(66263,3664),(66264,3664),(66265,3664),(66266,3664),(66267,3664),(66268,3665),(66269,3665),(66270,3665),(66271,3665),(66272,3665),(66273,3665),(66274,3666),(66275,3666),(66276,3666),(66277,3666),(66278,3666),(66279,3666),(66280,3667),(66281,3667),(66282,3667),(66283,3667),(66284,3667),(66285,3667),(66286,3668),(66287,3668),(66288,3668),(66289,3668),(66290,3668),(66291,3668),(66292,3569),(66293,3569),(66294,3569),(66295,3570),(66296,3570),(66297,3570),(66298,3571),(66299,3571),(66300,3571),(66301,3572),(66302,3572),(66303,3572),(66304,3573),(66305,3573),(66306,3574),(66307,3574),(66308,3575),(66309,3575),(66310,3576),(66311,3576),(66312,3577),(66313,3577),(66314,3578),(66315,3578),(66316,3579),(66317,3579),(66318,3580),(66319,3580),(66320,3581),(66321,3581),(66322,3581),(66323,3582),(66324,3582),(66325,3582),(66326,3583),(66327,3583),(66328,3584),(66329,3584),(66330,3584),(66331,3585),(66332,3585),(66333,3585),(66334,3586),(66335,3586),(66336,3586),(66337,3587),(66338,3587),(66339,3587),(66340,3588),(66341,3588),(66342,3588),(66343,3589),(66344,3589),(66345,3589),(66346,3590),(66347,3590),(66348,3590),(66349,3591),(66350,3591),(66351,3591),(66352,3592),(66353,3592),(66354,3593),(66355,3593),(66356,3594),(66357,3594),(66358,3595),(66359,3595),(66360,3596),(66361,3596),(66362,3597),(66363,3597),(66364,3598),(66365,3598),(66366,3599),(66367,3599),(66368,3600),(66369,3600),(66370,3601),(66371,3601),(66372,3602),(66373,3602),(66374,3603),(66375,3603),(66376,3604),(66377,3604),(66378,3605),(66379,3605),(66380,3606),(66381,3606),(66382,3607),(66383,3607),(66384,3608),(66385,3608),(66386,3609),(66387,3609),(66388,3610),(66389,3610),(66390,3611),(66391,3611),(66392,3612),(66393,3612),(66394,3613),(66395,3613),(66396,3614),(66397,3614),(66398,3614),(66399,3615),(66400,3615),(66401,3615),(66402,3616),(66403,3616),(66404,3616),(66405,3617),(66406,3617),(66407,3617),(66408,3618),(66409,3618),(66410,3618),(66411,3619),(66412,3619),(66413,3619),(66414,3620),(66415,3620),(66416,3620),(66417,3621),(66418,3621),(66419,3621),(66420,3622),(66421,3622),(66422,3622),(66423,3623),(66424,3623),(66425,3624),(66426,3624),(66427,3624),(66428,3625),(66429,3625),(66430,3625),(66431,3626),(66432,3626),(66433,3626),(66434,3627),(66435,3627),(66436,3627),(66437,3628),(66438,3628),(66439,3628),(66440,3629),(66441,3629),(66442,3629),(66443,3630),(66444,3630),(66445,3630),(66446,3631),(66447,3631),(66448,3631),(66449,3632),(66450,3632),(66451,3632),(66452,3633),(66453,3633),(66454,3633),(66455,3634),(66456,3634),(66457,3634),(66458,3635),(66459,3635),(66460,3635),(66461,3636),(66462,3636),(66463,3636),(66464,3637),(66465,3637),(66466,3637),(66467,3638),(66468,3638),(66469,3638),(66470,3639),(66471,3639),(66472,3639),(66473,3640),(66474,3640),(66475,3640),(66476,3641),(66477,3641),(66478,3641),(66479,3642),(66480,3642),(66481,3642),(66482,3643),(66483,3643),(66484,3643),(66485,3644),(66486,3644),(66487,3645),(66488,3645),(66489,3646),(66490,3646),(66491,3647),(66492,3647),(66493,3648),(66494,3648),(66495,3649),(66496,3649),(66497,3650),(66498,3650),(66499,3651),(66500,3651),(66501,3652),(66502,3652),(66503,3653),(66504,3653),(66505,3654),(66506,3654),(66507,3655),(66508,3655),(66509,3656),(66510,3656),(66511,3657),(66512,3657),(66513,3658),(66514,3658),(66515,3659),(66516,3659),(66517,3659),(66518,3660),(66519,3660),(66520,3660),(66521,3661),(66522,3661),(66523,3661),(66524,3662),(66525,3662),(66526,3662),(66527,3663),(66528,3663),(66529,3663),(66530,3664),(66531,3664),(66532,3664),(66533,3665),(66534,3665),(66535,3665),(66536,3666),(66537,3666),(66538,3666),(66539,3667),(66540,3667),(66541,3667),(66542,3668),(66543,3668),(66544,3668),(66545,3569),(66546,3569),(66547,3569),(66548,3570),(66549,3570),(66550,3570),(66551,3571),(66552,3571),(66553,3571),(66554,3572),(66555,3572),(66556,3572),(66557,3573),(66558,3573),(66559,3573),(66560,3574),(66561,3574),(66562,3574),(66563,3575),(66564,3575),(66565,3575),(66566,3576),(66567,3576),(66568,3576),(66569,3577),(66570,3577),(66571,3577),(66572,3578),(66573,3578),(66574,3578),(66575,3579),(66576,3579),(66577,3579),(66578,3580),(66579,3580),(66580,3580),(66581,3581),(66582,3581),(66583,3581),(66584,3582),(66585,3582),(66586,3582),(66587,3583),(66588,3583),(66589,3583),(66590,3584),(66591,3584),(66592,3584),(66593,3585),(66594,3585),(66595,3585),(66596,3586),(66597,3586),(66598,3586),(66599,3587),(66600,3587),(66601,3587),(66602,3588),(66603,3588),(66604,3588),(66605,3589),(66606,3589),(66607,3589),(66608,3590),(66609,3590),(66610,3590),(66611,3591),(66612,3591),(66613,3591),(66614,3592),(66615,3592),(66616,3592),(66617,3593),(66618,3593),(66619,3593),(66620,3594),(66621,3594),(66622,3594),(66623,3595),(66624,3595),(66625,3595),(66626,3596),(66627,3596),(66628,3596),(66629,3597),(66630,3597),(66631,3597),(66632,3598),(66633,3598),(66634,3598),(66635,3599),(66636,3599),(66637,3599),(66638,3600),(66639,3600),(66640,3600),(66641,3601),(66642,3601),(66643,3601),(66644,3602),(66645,3602),(66646,3602),(66647,3603),(66648,3603),(66649,3603),(66650,3604),(66651,3604),(66652,3604),(66653,3605),(66654,3605),(66655,3605),(66656,3606),(66657,3606),(66658,3606),(66659,3607),(66660,3607),(66661,3607),(66662,3608),(66663,3608),(66664,3608),(66665,3609),(66666,3609),(66667,3609),(66668,3610),(66669,3610),(66670,3610),(66671,3611),(66672,3611),(66673,3611),(66674,3612),(66675,3612),(66676,3612),(66677,3613),(66678,3613),(66679,3613),(66680,3614),(66681,3614),(66682,3614),(66683,3615),(66684,3615),(66685,3615),(66686,3616),(66687,3616),(66688,3616),(66689,3617),(66690,3617),(66691,3617),(66692,3618),(66693,3618),(66694,3618),(66695,3619),(66696,3619),(66697,3619),(66698,3620),(66699,3620),(66700,3620),(66701,3621),(66702,3621),(66703,3621),(66704,3622),(66705,3622),(66706,3622),(66707,3623),(66708,3623),(66709,3623),(66710,3624),(66711,3624),(66712,3624),(66713,3625),(66714,3625),(66715,3625),(66716,3626),(66717,3626),(66718,3626),(66719,3627),(66720,3627),(66721,3627),(66722,3628),(66723,3628),(66724,3628),(66725,3629),(66726,3629),(66727,3629),(66728,3630),(66729,3630),(66730,3630),(66731,3631),(66732,3631),(66733,3631),(66734,3632),(66735,3632),(66736,3632),(66737,3633),(66738,3633),(66739,3633),(66740,3634),(66741,3634),(66742,3634),(66743,3635),(66744,3635),(66745,3635),(66746,3636),(66747,3636),(66748,3636),(66749,3637),(66750,3637),(66751,3637),(66752,3638),(66753,3638),(66754,3638),(66755,3639),(66756,3639),(66757,3639),(66758,3640),(66759,3640),(66760,3640),(66761,3641),(66762,3641),(66763,3641),(66764,3642),(66765,3642),(66766,3642),(66767,3643),(66768,3643),(66769,3643),(66770,3644),(66771,3644),(66772,3644),(66773,3645),(66774,3645),(66775,3645),(66776,3646),(66777,3646),(66778,3646),(66779,3647),(66780,3647),(66781,3647),(66782,3648),(66783,3648),(66784,3648),(66785,3649),(66786,3649),(66787,3649),(66788,3650),(66789,3650),(66790,3650),(66791,3651),(66792,3651),(66793,3651),(66794,3652),(66795,3652),(66796,3652),(66797,3653),(66798,3653),(66799,3653),(66800,3654),(66801,3654),(66802,3654),(66803,3655),(66804,3655),(66805,3655),(66806,3656),(66807,3656),(66808,3656),(66809,3657),(66810,3657),(66811,3657),(66812,3658),(66813,3658),(66814,3658),(66815,3659),(66816,3659),(66817,3659),(66818,3660),(66819,3660),(66820,3660),(66821,3661),(66822,3661),(66823,3661),(66824,3662),(66825,3662),(66826,3662),(66827,3663),(66828,3663),(66829,3663),(66830,3664),(66831,3664),(66832,3664),(66833,3665),(66834,3665),(66835,3665),(66836,3666),(66837,3666),(66838,3666),(66839,3667),(66840,3667),(66841,3667),(66842,3668),(66843,3668),(66844,3668),(66845,3569),(66846,3569),(66847,3569),(66848,3569),(66849,3570),(66850,3570),(66851,3570),(66852,3570),(66853,3571),(66854,3571),(66855,3571),(66856,3571),(66857,3572),(66858,3572),(66859,3572),(66860,3572),(66861,3573),(66862,3573),(66863,3573),(66864,3573),(66865,3574),(66866,3574),(66867,3574),(66868,3574),(66869,3575),(66870,3575),(66871,3575),(66872,3575),(66873,3576),(66874,3576),(66875,3576),(66876,3576),(66877,3577),(66878,3577),(66879,3577),(66880,3577),(66881,3578),(66882,3578),(66883,3578),(66884,3578),(66885,3579),(66886,3579),(66887,3579),(66888,3579),(66889,3580),(66890,3580),(66891,3580),(66892,3580),(66893,3581),(66894,3581),(66895,3581),(66896,3581),(66897,3582),(66898,3582),(66899,3582),(66900,3582),(66901,3583),(66902,3583),(66903,3583),(66904,3583),(66905,3584),(66906,3584),(66907,3584),(66908,3584),(66909,3585),(66910,3585),(66911,3585),(66912,3585),(66913,3586),(66914,3586),(66915,3586),(66916,3586),(66917,3587),(66918,3587),(66919,3587),(66920,3587),(66921,3588),(66922,3588),(66923,3588),(66924,3588),(66925,3589),(66926,3589),(66927,3589),(66928,3589),(66929,3590),(66930,3590),(66931,3590),(66932,3590),(66933,3591),(66934,3591),(66935,3591),(66936,3591),(66937,3592),(66938,3592),(66939,3592),(66940,3592),(66941,3593),(66942,3593),(66943,3593),(66944,3593),(66945,3594),(66946,3594),(66947,3594),(66948,3594),(66949,3595),(66950,3595),(66951,3595),(66952,3595),(66953,3596),(66954,3596),(66955,3596),(66956,3596),(66957,3597),(66958,3597),(66959,3597),(66960,3597),(66961,3598),(66962,3598),(66963,3598),(66964,3598),(66965,3599),(66966,3599),(66967,3599),(66968,3599),(66969,3600),(66970,3600),(66971,3600),(66972,3600),(66973,3601),(66974,3601),(66975,3601),(66976,3601),(66977,3602),(66978,3602),(66979,3602),(66980,3602),(66981,3603),(66982,3603),(66983,3603),(66984,3603),(66985,3604),(66986,3604),(66987,3604),(66988,3604),(66989,3605),(66990,3605),(66991,3605),(66992,3605),(66993,3606),(66994,3606),(66995,3606),(66996,3606),(66997,3607),(66998,3607),(66999,3607),(67000,3607),(67001,3608),(67002,3608),(67003,3608),(67004,3608),(67005,3609),(67006,3609),(67007,3609),(67008,3609),(67009,3610),(67010,3610),(67011,3610),(67012,3610),(67013,3611),(67014,3611),(67015,3611),(67016,3611),(67017,3612),(67018,3612),(67019,3612),(67020,3612),(67021,3613),(67022,3613),(67023,3613),(67024,3613),(67025,3614),(67026,3614),(67027,3614),(67028,3614),(67029,3615),(67030,3615),(67031,3615),(67032,3615),(67033,3616),(67034,3616),(67035,3616),(67036,3616),(67037,3617),(67038,3617),(67039,3617),(67040,3617),(67041,3618),(67042,3618),(67043,3618),(67044,3618),(67045,3619),(67046,3619),(67047,3619),(67048,3619),(67049,3620),(67050,3620),(67051,3620),(67052,3620),(67053,3621),(67054,3621),(67055,3621),(67056,3621),(67057,3622),(67058,3622),(67059,3622),(67060,3622),(67061,3623),(67062,3623),(67063,3623),(67064,3623),(67065,3624),(67066,3624),(67067,3624),(67068,3624),(67069,3625),(67070,3625),(67071,3625),(67072,3625),(67073,3626),(67074,3626),(67075,3626),(67076,3626),(67077,3627),(67078,3627),(67079,3627),(67080,3627),(67081,3628),(67082,3628),(67083,3628),(67084,3628),(67085,3629),(67086,3629),(67087,3629),(67088,3629),(67089,3630),(67090,3630),(67091,3630),(67092,3630),(67093,3631),(67094,3631),(67095,3631),(67096,3631),(67097,3632),(67098,3632),(67099,3632),(67100,3632),(67101,3633),(67102,3633),(67103,3633),(67104,3633),(67105,3634),(67106,3634),(67107,3634),(67108,3634),(67109,3635),(67110,3635),(67111,3635),(67112,3635),(67113,3636),(67114,3636),(67115,3636),(67116,3636),(67117,3637),(67118,3637),(67119,3637),(67120,3637),(67121,3638),(67122,3638),(67123,3638),(67124,3638),(67125,3639),(67126,3639),(67127,3639),(67128,3639),(67129,3640),(67130,3640),(67131,3640),(67132,3640),(67133,3641),(67134,3641),(67135,3641),(67136,3641),(67137,3642),(67138,3642),(67139,3642),(67140,3642),(67141,3643),(67142,3643),(67143,3643),(67144,3643),(67145,3644),(67146,3644),(67147,3644),(67148,3644),(67149,3645),(67150,3645),(67151,3645),(67152,3645),(67153,3646),(67154,3646),(67155,3646),(67156,3646),(67157,3647),(67158,3647),(67159,3647),(67160,3647),(67161,3648),(67162,3648),(67163,3648),(67164,3648),(67165,3649),(67166,3649),(67167,3649),(67168,3649),(67169,3650),(67170,3650),(67171,3650),(67172,3650),(67173,3651),(67174,3651),(67175,3651),(67176,3651),(67177,3652),(67178,3652),(67179,3652),(67180,3652),(67181,3653),(67182,3653),(67183,3653),(67184,3653),(67185,3654),(67186,3654),(67187,3654),(67188,3654),(67189,3655),(67190,3655),(67191,3655),(67192,3655),(67193,3656),(67194,3656),(67195,3656),(67196,3656),(67197,3657),(67198,3657),(67199,3657),(67200,3657),(67201,3658),(67202,3658),(67203,3658),(67204,3658),(67205,3659),(67206,3659),(67207,3659),(67208,3659),(67209,3660),(67210,3660),(67211,3660),(67212,3660),(67213,3661),(67214,3661),(67215,3661),(67216,3661),(67217,3662),(67218,3662),(67219,3662),(67220,3662),(67221,3663),(67222,3663),(67223,3663),(67224,3663),(67225,3664),(67226,3664),(67227,3664),(67228,3664),(67229,3665),(67230,3665),(67231,3665),(67232,3665),(67233,3666),(67234,3666),(67235,3666),(67236,3666),(67237,3667),(67238,3667),(67239,3667),(67240,3667),(67241,3668),(67242,3668),(67243,3668),(67244,3668),(67245,3669),(67246,3670),(67247,3671),(67248,3672),(67249,3673),(67250,3674),(67251,3675),(67252,3676),(67253,3677),(67254,3678),(67255,3679),(67256,3680),(67257,3681),(67258,3682),(67259,3683),(67260,3684),(67261,3685),(67262,3686),(67263,3687),(67264,3688),(67265,3689),(67266,3690),(67267,3691),(67268,3692),(67269,3693),(67270,3694),(67271,3695),(67272,3696),(67273,3697),(67274,3698),(67275,3699),(67276,3700),(67277,3701),(67278,3702),(67279,3703),(67280,3704),(67281,3705),(67282,3706),(67283,3707),(67284,3708),(67285,3709),(67286,3710),(67287,3711),(67288,3712),(67289,3713),(67290,3714),(67291,3669),(67292,3670),(67293,3671),(67294,3672),(67295,3673),(67296,3674),(67297,3675),(67298,3676),(67299,3677),(67300,3678),(67301,3679),(67302,3680),(67303,3681),(67304,3682),(67305,3683),(67306,3684),(67307,3685),(67308,3686),(67309,3687),(67310,3688),(67311,3689),(67312,3690),(67313,3691),(67314,3692),(67315,3693),(67316,3694),(67317,3695),(67318,3696),(67319,3697),(67320,3698),(67321,3699),(67322,3700),(67323,3701),(67324,3702),(67325,3703),(67326,3704),(67327,3705),(67328,3706),(67329,3707),(67330,3708),(67331,3709),(67332,3710),(67333,3711),(67334,3712),(67335,3713),(67336,3714),(67337,3669),(67338,3669),(67339,3669),(67340,3669),(67341,3669),(67342,3669),(67343,3670),(67344,3670),(67345,3670),(67346,3670),(67347,3670),(67348,3670),(67349,3671),(67350,3671),(67351,3671),(67352,3671),(67353,3671),(67354,3671),(67355,3672),(67356,3672),(67357,3672),(67358,3672),(67359,3672),(67360,3672),(67361,3673),(67362,3673),(67363,3673),(67364,3673),(67365,3673),(67366,3673),(67367,3674),(67368,3674),(67369,3674),(67370,3674),(67371,3674),(67372,3674),(67373,3675),(67374,3675),(67375,3675),(67376,3675),(67377,3675),(67378,3675),(67379,3676),(67380,3676),(67381,3676),(67382,3676),(67383,3676),(67384,3676),(67385,3677),(67386,3677),(67387,3677),(67388,3677),(67389,3677),(67390,3677),(67391,3678),(67392,3678),(67393,3678),(67394,3678),(67395,3678),(67396,3678),(67397,3679),(67398,3679),(67399,3679),(67400,3679),(67401,3679),(67402,3679),(67403,3680),(67404,3680),(67405,3680),(67406,3680),(67407,3680),(67408,3680),(67409,3681),(67410,3681),(67411,3681),(67412,3681),(67413,3681),(67414,3681),(67415,3682),(67416,3682),(67417,3682),(67418,3682),(67419,3682),(67420,3682),(67421,3683),(67422,3683),(67423,3683),(67424,3683),(67425,3683),(67426,3683),(67427,3684),(67428,3684),(67429,3684),(67430,3684),(67431,3685),(67432,3685),(67433,3685),(67434,3685),(67435,3686),(67436,3686),(67437,3686),(67438,3686),(67439,3686),(67440,3686),(67441,3687),(67442,3687),(67443,3687),(67444,3687),(67445,3687),(67446,3687),(67447,3688),(67448,3688),(67449,3688),(67450,3688),(67451,3688),(67452,3688),(67453,3689),(67454,3689),(67455,3689),(67456,3689),(67457,3689),(67458,3689),(67459,3690),(67460,3690),(67461,3690),(67462,3690),(67463,3690),(67464,3690),(67465,3691),(67466,3691),(67467,3691),(67468,3691),(67469,3691),(67470,3691),(67471,3692),(67472,3692),(67473,3692),(67474,3692),(67475,3692),(67476,3692),(67477,3693),(67478,3693),(67479,3693),(67480,3693),(67481,3693),(67482,3693),(67483,3694),(67484,3694),(67485,3694),(67486,3694),(67487,3694),(67488,3694),(67489,3695),(67490,3695),(67491,3695),(67492,3695),(67493,3695),(67494,3695),(67495,3696),(67496,3696),(67497,3696),(67498,3696),(67499,3696),(67500,3696),(67501,3697),(67502,3697),(67503,3697),(67504,3697),(67505,3697),(67506,3697),(67507,3698),(67508,3698),(67509,3698),(67510,3698),(67511,3698),(67512,3698),(67513,3699),(67514,3699),(67515,3699),(67516,3699),(67517,3699),(67518,3699),(67519,3700),(67520,3700),(67521,3700),(67522,3700),(67523,3700),(67524,3700),(67525,3701),(67526,3701),(67527,3701),(67528,3701),(67529,3701),(67530,3701),(67531,3702),(67532,3702),(67533,3702),(67534,3702),(67535,3702),(67536,3702),(67537,3703),(67538,3703),(67539,3703),(67540,3703),(67541,3703),(67542,3703),(67543,3704),(67544,3704),(67545,3704),(67546,3704),(67547,3704),(67548,3704),(67549,3705),(67550,3705),(67551,3705),(67552,3705),(67553,3705),(67554,3705),(67555,3706),(67556,3706),(67557,3706),(67558,3706),(67559,3706),(67560,3706),(67561,3707),(67562,3707),(67563,3707),(67564,3707),(67565,3707),(67566,3707),(67567,3708),(67568,3708),(67569,3708),(67570,3708),(67571,3708),(67572,3708),(67573,3709),(67574,3709),(67575,3709),(67576,3709),(67577,3709),(67578,3709),(67579,3710),(67580,3710),(67581,3710),(67582,3710),(67583,3710),(67584,3710),(67585,3711),(67586,3711),(67587,3711),(67588,3711),(67589,3711),(67590,3711),(67591,3712),(67592,3712),(67593,3712),(67594,3712),(67595,3712),(67596,3712),(67597,3713),(67598,3713),(67599,3713),(67600,3713),(67601,3713),(67602,3713),(67603,3714),(67604,3714),(67605,3714),(67606,3714),(67607,3714),(67608,3714),(67609,3669),(67610,3669),(67611,3669),(67612,3670),(67613,3670),(67614,3670),(67615,3671),(67616,3671),(67617,3671),(67618,3672),(67619,3672),(67620,3672),(67621,3673),(67622,3673),(67623,3673),(67624,3674),(67625,3674),(67626,3674),(67627,3675),(67628,3675),(67629,3676),(67630,3676),(67631,3677),(67632,3677),(67633,3678),(67634,3678),(67635,3679),(67636,3679),(67637,3680),(67638,3680),(67639,3681),(67640,3681),(67641,3682),(67642,3682),(67643,3683),(67644,3683),(67645,3684),(67646,3684),(67647,3685),(67648,3685),(67649,3686),(67650,3686),(67651,3687),(67652,3687),(67653,3688),(67654,3688),(67655,3689),(67656,3689),(67657,3690),(67658,3690),(67659,3691),(67660,3691),(67661,3692),(67662,3692),(67663,3693),(67664,3693),(67665,3694),(67666,3694),(67667,3695),(67668,3695),(67669,3696),(67670,3696),(67671,3697),(67672,3697),(67673,3698),(67674,3698),(67675,3699),(67676,3699),(67677,3700),(67678,3700),(67679,3701),(67680,3701),(67681,3702),(67682,3702),(67683,3703),(67684,3703),(67685,3704),(67686,3704),(67687,3705),(67688,3705),(67689,3706),(67690,3706),(67691,3707),(67692,3707),(67693,3708),(67694,3708),(67695,3709),(67696,3709),(67697,3710),(67698,3710),(67699,3711),(67700,3711),(67701,3712),(67702,3712),(67703,3713),(67704,3713),(67705,3714),(67706,3714),(67707,3669),(67708,3669),(67709,3669),(67710,3670),(67711,3670),(67712,3670),(67713,3671),(67714,3671),(67715,3671),(67716,3672),(67717,3672),(67718,3672),(67719,3673),(67720,3673),(67721,3673),(67722,3674),(67723,3674),(67724,3674),(67725,3675),(67726,3675),(67727,3675),(67728,3676),(67729,3676),(67730,3676),(67731,3677),(67732,3677),(67733,3677),(67734,3678),(67735,3678),(67736,3678),(67737,3679),(67738,3679),(67739,3679),(67740,3680),(67741,3680),(67742,3680),(67743,3681),(67744,3681),(67745,3681),(67746,3682),(67747,3682),(67748,3682),(67749,3683),(67750,3683),(67751,3683),(67752,3684),(67753,3684),(67754,3684),(67755,3685),(67756,3685),(67757,3685),(67758,3686),(67759,3686),(67760,3686),(67761,3687),(67762,3687),(67763,3687),(67764,3688),(67765,3688),(67766,3688),(67767,3689),(67768,3689),(67769,3689),(67770,3690),(67771,3690),(67772,3690),(67773,3691),(67774,3691),(67775,3691),(67776,3692),(67777,3692),(67778,3692),(67779,3693),(67780,3693),(67781,3693),(67782,3694),(67783,3694),(67784,3694),(67785,3695),(67786,3695),(67787,3695),(67788,3696),(67789,3696),(67790,3696),(67791,3697),(67792,3697),(67793,3697),(67794,3698),(67795,3698),(67796,3698),(67797,3699),(67798,3699),(67799,3699),(67800,3700),(67801,3700),(67802,3700),(67803,3701),(67804,3701),(67805,3701),(67806,3702),(67807,3702),(67808,3702),(67809,3703),(67810,3703),(67811,3703),(67812,3704),(67813,3704),(67814,3704),(67815,3705),(67816,3705),(67817,3705),(67818,3706),(67819,3706),(67820,3706),(67821,3707),(67822,3707),(67823,3707),(67824,3708),(67825,3708),(67826,3708),(67827,3709),(67828,3709),(67829,3709),(67830,3710),(67831,3710),(67832,3710),(67833,3711),(67834,3711),(67835,3711),(67836,3712),(67837,3712),(67838,3712),(67839,3713),(67840,3713),(67841,3713),(67842,3714),(67843,3714),(67844,3714),(67845,3669),(67846,3669),(67847,3669),(67848,3669),(67849,3670),(67850,3670),(67851,3670),(67852,3670),(67853,3671),(67854,3671),(67855,3671),(67856,3671),(67857,3672),(67858,3672),(67859,3672),(67860,3672),(67861,3673),(67862,3673),(67863,3673),(67864,3673),(67865,3674),(67866,3674),(67867,3674),(67868,3674),(67869,3675),(67870,3675),(67871,3675),(67872,3675),(67873,3676),(67874,3676),(67875,3676),(67876,3676),(67877,3677),(67878,3677),(67879,3677),(67880,3677),(67881,3678),(67882,3678),(67883,3678),(67884,3678),(67885,3679),(67886,3679),(67887,3679),(67888,3679),(67889,3680),(67890,3680),(67891,3680),(67892,3680),(67893,3681),(67894,3681),(67895,3681),(67896,3681),(67897,3682),(67898,3682),(67899,3682),(67900,3682),(67901,3683),(67902,3683),(67903,3683),(67904,3683),(67905,3684),(67906,3684),(67907,3684),(67908,3684),(67909,3685),(67910,3685),(67911,3685),(67912,3685),(67913,3686),(67914,3686),(67915,3686),(67916,3686),(67917,3687),(67918,3687),(67919,3687),(67920,3687),(67921,3688),(67922,3688),(67923,3688),(67924,3688),(67925,3689),(67926,3689),(67927,3689),(67928,3689),(67929,3690),(67930,3690),(67931,3690),(67932,3690),(67933,3691),(67934,3691),(67935,3691),(67936,3691),(67937,3692),(67938,3692),(67939,3692),(67940,3692),(67941,3693),(67942,3693),(67943,3693),(67944,3693),(67945,3694),(67946,3694),(67947,3694),(67948,3694),(67949,3695),(67950,3695),(67951,3695),(67952,3695),(67953,3696),(67954,3696),(67955,3696),(67956,3696),(67957,3697),(67958,3697),(67959,3697),(67960,3697),(67961,3698),(67962,3698),(67963,3698),(67964,3698),(67965,3699),(67966,3699),(67967,3699),(67968,3699),(67969,3700),(67970,3700),(67971,3700),(67972,3700),(67973,3701),(67974,3701),(67975,3701),(67976,3701),(67977,3702),(67978,3702),(67979,3702),(67980,3702),(67981,3703),(67982,3703),(67983,3703),(67984,3703),(67985,3704),(67986,3704),(67987,3704),(67988,3704),(67989,3705),(67990,3705),(67991,3705),(67992,3705),(67993,3706),(67994,3706),(67995,3706),(67996,3706),(67997,3707),(67998,3707),(67999,3707),(68000,3707),(68001,3708),(68002,3708),(68003,3708),(68004,3708),(68005,3709),(68006,3709),(68007,3709),(68008,3709),(68009,3710),(68010,3710),(68011,3710),(68012,3710),(68013,3711),(68014,3711),(68015,3711),(68016,3711),(68017,3712),(68018,3712),(68019,3712),(68020,3712),(68021,3713),(68022,3713),(68023,3713),(68024,3713),(68025,3714),(68026,3714),(68027,3714),(68028,3714),(68029,3715),(68030,3716),(68031,3717),(68032,3718),(68033,3719),(68034,3720),(68035,3721),(68036,3722),(68037,3723),(68038,3724),(68039,3725),(68040,3726),(68041,3727),(68042,3728),(68043,3729),(68044,3730),(68045,3731),(68046,3732),(68047,3733),(68048,3734),(68049,3735),(68050,3736),(68051,3737),(68052,3738),(68053,3739),(68054,3740),(68055,3741),(68056,3742),(68057,3743),(68058,3744),(68059,3745),(68060,3746),(68061,3747),(68062,3748),(68063,3749),(68064,3750),(68065,3751),(68066,3752),(68067,3753),(68068,3754),(68069,3755),(68070,3756),(68071,3757),(68072,3758),(68073,3759),(68074,3760),(68075,3761),(68076,3762),(68077,3763),(68078,3764),(68079,3765),(68080,3766),(68081,3767),(68082,3768),(68083,3769),(68084,3770),(68085,3771),(68086,3772),(68087,3773),(68088,3774),(68089,3775),(68090,3776),(68091,3777),(68092,3778),(68093,3779),(68094,3780),(68095,3781),(68096,3782),(68097,3783),(68098,3784),(68099,3785),(68100,3786),(68101,3787),(68102,3788),(68103,3789),(68104,3790),(68105,3791),(68106,3792),(68107,3793),(68108,3794),(68109,3795),(68110,3796),(68111,3797),(68112,3798),(68113,3799),(68114,3800),(68115,3801),(68116,3802),(68117,3803),(68118,3804),(68119,3805),(68120,3806),(68121,3807),(68122,3808),(68123,3809),(68124,3810),(68125,3811),(68126,3812),(68127,3813),(68128,3814),(68129,3715),(68130,3716),(68131,3717),(68132,3718),(68133,3719),(68134,3720),(68135,3721),(68136,3722),(68137,3723),(68138,3724),(68139,3725),(68140,3726),(68141,3727),(68142,3728),(68143,3729),(68144,3730),(68145,3731),(68146,3732),(68147,3733),(68148,3734),(68149,3735),(68150,3736),(68151,3737),(68152,3738),(68153,3739),(68154,3740),(68155,3741),(68156,3742),(68157,3743),(68158,3744),(68159,3745),(68160,3746),(68161,3747),(68162,3748),(68163,3749),(68164,3750),(68165,3751),(68166,3752),(68167,3753),(68168,3754),(68169,3755),(68170,3756),(68171,3757),(68172,3758),(68173,3759),(68174,3760),(68175,3761),(68176,3762),(68177,3763),(68178,3764),(68179,3765),(68180,3766),(68181,3767),(68182,3768),(68183,3769),(68184,3770),(68185,3771),(68186,3772),(68187,3773),(68188,3774),(68189,3775),(68190,3776),(68191,3777),(68192,3778),(68193,3779),(68194,3780),(68195,3781),(68196,3782),(68197,3783),(68198,3784),(68199,3785),(68200,3786),(68201,3787),(68202,3788),(68203,3789),(68204,3790),(68205,3791),(68206,3792),(68207,3793),(68208,3794),(68209,3795),(68210,3796),(68211,3797),(68212,3798),(68213,3799),(68214,3800),(68215,3801),(68216,3802),(68217,3803),(68218,3804),(68219,3805),(68220,3806),(68221,3807),(68222,3808),(68223,3809),(68224,3810),(68225,3811),(68226,3812),(68227,3813),(68228,3814),(68229,3715),(68230,3715),(68231,3715),(68232,3715),(68233,3715),(68234,3715),(68235,3716),(68236,3716),(68237,3716),(68238,3716),(68239,3716),(68240,3716),(68241,3717),(68242,3717),(68243,3717),(68244,3717),(68245,3717),(68246,3717),(68247,3718),(68248,3718),(68249,3718),(68250,3718),(68251,3718),(68252,3718),(68253,3719),(68254,3719),(68255,3719),(68256,3719),(68257,3719),(68258,3719),(68259,3720),(68260,3720),(68261,3720),(68262,3720),(68263,3720),(68264,3720),(68265,3721),(68266,3721),(68267,3721),(68268,3721),(68269,3721),(68270,3721),(68271,3722),(68272,3722),(68273,3722),(68274,3722),(68275,3722),(68276,3722),(68277,3723),(68278,3723),(68279,3723),(68280,3723),(68281,3723),(68282,3723),(68283,3724),(68284,3724),(68285,3724),(68286,3724),(68287,3724),(68288,3724),(68289,3725),(68290,3725),(68291,3725),(68292,3725),(68293,3725),(68294,3725),(68295,3726),(68296,3726),(68297,3726),(68298,3726),(68299,3726),(68300,3726),(68301,3727),(68302,3727),(68303,3727),(68304,3727),(68305,3727),(68306,3727),(68307,3728),(68308,3728),(68309,3728),(68310,3728),(68311,3728),(68312,3728),(68313,3729),(68314,3729),(68315,3729),(68316,3729),(68317,3729),(68318,3729),(68319,3730),(68320,3730),(68321,3730),(68322,3730),(68323,3730),(68324,3730),(68325,3731),(68326,3731),(68327,3731),(68328,3731),(68329,3731),(68330,3731),(68331,3732),(68332,3732),(68333,3732),(68334,3732),(68335,3732),(68336,3732),(68337,3733),(68338,3733),(68339,3733),(68340,3733),(68341,3733),(68342,3733),(68343,3734),(68344,3734),(68345,3734),(68346,3734),(68347,3734),(68348,3734),(68349,3735),(68350,3735),(68351,3735),(68352,3735),(68353,3735),(68354,3735),(68355,3736),(68356,3736),(68357,3736),(68358,3736),(68359,3736),(68360,3736),(68361,3737),(68362,3737),(68363,3737),(68364,3737),(68365,3737),(68366,3737),(68367,3738),(68368,3738),(68369,3738),(68370,3738),(68371,3738),(68372,3738),(68373,3739),(68374,3739),(68375,3739),(68376,3739),(68377,3739),(68378,3739),(68379,3740),(68380,3740),(68381,3740),(68382,3740),(68383,3740),(68384,3740),(68385,3741),(68386,3741),(68387,3741),(68388,3741),(68389,3741),(68390,3741),(68391,3742),(68392,3742),(68393,3742),(68394,3742),(68395,3742),(68396,3742),(68397,3743),(68398,3743),(68399,3743),(68400,3743),(68401,3743),(68402,3743),(68403,3744),(68404,3744),(68405,3744),(68406,3744),(68407,3744),(68408,3744),(68409,3745),(68410,3745),(68411,3745),(68412,3745),(68413,3745),(68414,3745),(68415,3746),(68416,3746),(68417,3746),(68418,3746),(68419,3746),(68420,3746),(68421,3747),(68422,3747),(68423,3747),(68424,3747),(68425,3747),(68426,3747),(68427,3748),(68428,3748),(68429,3748),(68430,3748),(68431,3748),(68432,3748),(68433,3749),(68434,3749),(68435,3749),(68436,3749),(68437,3749),(68438,3749),(68439,3750),(68440,3750),(68441,3750),(68442,3750),(68443,3750),(68444,3750),(68445,3751),(68446,3751),(68447,3751),(68448,3751),(68449,3751),(68450,3751),(68451,3752),(68452,3752),(68453,3752),(68454,3752),(68455,3752),(68456,3752),(68457,3753),(68458,3753),(68459,3753),(68460,3753),(68461,3753),(68462,3753),(68463,3754),(68464,3754),(68465,3754),(68466,3754),(68467,3754),(68468,3754),(68469,3755),(68470,3755),(68471,3755),(68472,3755),(68473,3755),(68474,3755),(68475,3756),(68476,3756),(68477,3756),(68478,3756),(68479,3756),(68480,3756),(68481,3757),(68482,3757),(68483,3757),(68484,3757),(68485,3757),(68486,3757),(68487,3758),(68488,3758),(68489,3758),(68490,3758),(68491,3758),(68492,3758),(68493,3759),(68494,3759),(68495,3759),(68496,3759),(68497,3759),(68498,3759),(68499,3760),(68500,3760),(68501,3760),(68502,3760),(68503,3760),(68504,3760),(68505,3761),(68506,3761),(68507,3761),(68508,3761),(68509,3761),(68510,3761),(68511,3762),(68512,3762),(68513,3762),(68514,3762),(68515,3762),(68516,3762),(68517,3763),(68518,3763),(68519,3763),(68520,3763),(68521,3763),(68522,3763),(68523,3764),(68524,3764),(68525,3764),(68526,3764),(68527,3764),(68528,3764),(68529,3765),(68530,3765),(68531,3765),(68532,3765),(68533,3765),(68534,3765),(68535,3766),(68536,3766),(68537,3766),(68538,3766),(68539,3766),(68540,3766),(68541,3767),(68542,3767),(68543,3767),(68544,3767),(68545,3767),(68546,3767),(68547,3768),(68548,3768),(68549,3768),(68550,3768),(68551,3768),(68552,3768),(68553,3769),(68554,3769),(68555,3769),(68556,3769),(68557,3769),(68558,3769),(68559,3770),(68560,3770),(68561,3770),(68562,3770),(68563,3770),(68564,3770),(68565,3771),(68566,3771),(68567,3771),(68568,3771),(68569,3771),(68570,3771),(68571,3772),(68572,3772),(68573,3772),(68574,3772),(68575,3772),(68576,3772),(68577,3773),(68578,3773),(68579,3773),(68580,3773),(68581,3773),(68582,3773),(68583,3774),(68584,3774),(68585,3774),(68586,3774),(68587,3774),(68588,3774),(68589,3775),(68590,3775),(68591,3775),(68592,3775),(68593,3775),(68594,3775),(68595,3776),(68596,3776),(68597,3776),(68598,3776),(68599,3776),(68600,3776),(68601,3777),(68602,3777),(68603,3777),(68604,3777),(68605,3777),(68606,3777),(68607,3778),(68608,3778),(68609,3778),(68610,3778),(68611,3778),(68612,3778),(68613,3779),(68614,3779),(68615,3779),(68616,3779),(68617,3779),(68618,3779),(68619,3780),(68620,3780),(68621,3780),(68622,3780),(68623,3780),(68624,3780),(68625,3781),(68626,3781),(68627,3781),(68628,3781),(68629,3781),(68630,3781),(68631,3782),(68632,3782),(68633,3782),(68634,3782),(68635,3782),(68636,3782),(68637,3783),(68638,3783),(68639,3783),(68640,3783),(68641,3783),(68642,3783),(68643,3784),(68644,3784),(68645,3784),(68646,3784),(68647,3784),(68648,3784),(68649,3785),(68650,3785),(68651,3785),(68652,3785),(68653,3785),(68654,3785),(68655,3786),(68656,3786),(68657,3786),(68658,3786),(68659,3786),(68660,3786),(68661,3787),(68662,3787),(68663,3787),(68664,3787),(68665,3787),(68666,3787),(68667,3788),(68668,3788),(68669,3788),(68670,3788),(68671,3788),(68672,3788),(68673,3789),(68674,3789),(68675,3789),(68676,3789),(68677,3789),(68678,3789),(68679,3790),(68680,3790),(68681,3790),(68682,3790),(68683,3790),(68684,3790),(68685,3791),(68686,3791),(68687,3791),(68688,3791),(68689,3791),(68690,3791),(68691,3792),(68692,3792),(68693,3792),(68694,3792),(68695,3792),(68696,3792),(68697,3793),(68698,3793),(68699,3793),(68700,3793),(68701,3793),(68702,3793),(68703,3794),(68704,3794),(68705,3794),(68706,3794),(68707,3794),(68708,3794),(68709,3795),(68710,3795),(68711,3795),(68712,3795),(68713,3795),(68714,3795),(68715,3796),(68716,3796),(68717,3796),(68718,3796),(68719,3796),(68720,3796),(68721,3797),(68722,3797),(68723,3797),(68724,3797),(68725,3797),(68726,3797),(68727,3798),(68728,3798),(68729,3798),(68730,3798),(68731,3798),(68732,3798),(68733,3799),(68734,3799),(68735,3799),(68736,3799),(68737,3799),(68738,3799),(68739,3800),(68740,3800),(68741,3800),(68742,3800),(68743,3800),(68744,3800),(68745,3801),(68746,3801),(68747,3801),(68748,3801),(68749,3801),(68750,3801),(68751,3802),(68752,3802),(68753,3802),(68754,3802),(68755,3802),(68756,3802),(68757,3803),(68758,3803),(68759,3803),(68760,3803),(68761,3803),(68762,3803),(68763,3804),(68764,3804),(68765,3804),(68766,3804),(68767,3804),(68768,3804),(68769,3805),(68770,3805),(68771,3805),(68772,3805),(68773,3805),(68774,3805),(68775,3806),(68776,3806),(68777,3806),(68778,3806),(68779,3806),(68780,3806),(68781,3807),(68782,3807),(68783,3807),(68784,3807),(68785,3807),(68786,3807),(68787,3808),(68788,3808),(68789,3808),(68790,3808),(68791,3808),(68792,3808),(68793,3809),(68794,3809),(68795,3809),(68796,3809),(68797,3809),(68798,3809),(68799,3810),(68800,3810),(68801,3810),(68802,3810),(68803,3810),(68804,3810),(68805,3811),(68806,3811),(68807,3811),(68808,3811),(68809,3811),(68810,3811),(68811,3812),(68812,3812),(68813,3812),(68814,3812),(68815,3812),(68816,3812),(68817,3813),(68818,3813),(68819,3813),(68820,3813),(68821,3813),(68822,3813),(68823,3814),(68824,3814),(68825,3814),(68826,3814),(68827,3814),(68828,3814),(68829,3715),(68830,3715),(68831,3716),(68832,3716),(68833,3717),(68834,3717),(68835,3718),(68836,3718),(68837,3719),(68838,3719),(68839,3720),(68840,3720),(68841,3721),(68842,3721),(68843,3722),(68844,3722),(68845,3723),(68846,3723),(68847,3724),(68848,3724),(68849,3725),(68850,3725),(68851,3726),(68852,3726),(68853,3727),(68854,3727),(68855,3728),(68856,3728),(68857,3729),(68858,3729),(68859,3730),(68860,3730),(68861,3731),(68862,3731),(68863,3732),(68864,3732),(68865,3733),(68866,3733),(68867,3734),(68868,3734),(68869,3735),(68870,3735),(68871,3736),(68872,3736),(68873,3737),(68874,3737),(68875,3738),(68876,3738),(68877,3739),(68878,3739),(68879,3740),(68880,3740),(68881,3741),(68882,3741),(68883,3742),(68884,3742),(68885,3743),(68886,3743),(68887,3744),(68888,3744),(68889,3745),(68890,3745),(68891,3746),(68892,3746),(68893,3747),(68894,3747),(68895,3748),(68896,3748),(68897,3749),(68898,3749),(68899,3750),(68900,3750),(68901,3751),(68902,3751),(68903,3752),(68904,3752),(68905,3753),(68906,3753),(68907,3754),(68908,3754),(68909,3755),(68910,3755),(68911,3756),(68912,3756),(68913,3757),(68914,3757),(68915,3758),(68916,3758),(68917,3759),(68918,3759),(68919,3760),(68920,3760),(68921,3761),(68922,3761),(68923,3762),(68924,3762),(68925,3763),(68926,3763),(68927,3764),(68928,3764),(68929,3765),(68930,3765),(68931,3765),(68932,3766),(68933,3766),(68934,3767),(68935,3767),(68936,3768),(68937,3768),(68938,3769),(68939,3769),(68940,3770),(68941,3770),(68942,3771),(68943,3771),(68944,3772),(68945,3772),(68946,3773),(68947,3773),(68948,3774),(68949,3774),(68950,3775),(68951,3775),(68952,3776),(68953,3776),(68954,3777),(68955,3777),(68956,3778),(68957,3778),(68958,3779),(68959,3779),(68960,3780),(68961,3780),(68962,3781),(68963,3781),(68964,3782),(68965,3782),(68966,3783),(68967,3783),(68968,3784),(68969,3784),(68970,3785),(68971,3785),(68972,3786),(68973,3786),(68974,3787),(68975,3787),(68976,3788),(68977,3788),(68978,3789),(68979,3789),(68980,3790),(68981,3790),(68982,3791),(68983,3791),(68984,3792),(68985,3792),(68986,3793),(68987,3793),(68988,3794),(68989,3794),(68990,3795),(68991,3795),(68992,3796),(68993,3796),(68994,3797),(68995,3797),(68996,3798),(68997,3798),(68998,3799),(68999,3799),(69000,3800),(69001,3800),(69002,3801),(69003,3801),(69004,3802),(69005,3802),(69006,3803),(69007,3803),(69008,3804),(69009,3804),(69010,3805),(69011,3805),(69012,3806),(69013,3806),(69014,3807),(69015,3807),(69016,3808),(69017,3808),(69018,3809),(69019,3809),(69020,3810),(69021,3810),(69022,3811),(69023,3811),(69024,3812),(69025,3812),(69026,3813),(69027,3813),(69028,3814),(69029,3814),(69030,3715),(69031,3715),(69032,3715),(69033,3716),(69034,3716),(69035,3716),(69036,3717),(69037,3717),(69038,3717),(69039,3718),(69040,3718),(69041,3718),(69042,3719),(69043,3719),(69044,3719),(69045,3720),(69046,3720),(69047,3720),(69048,3721),(69049,3721),(69050,3721),(69051,3722),(69052,3722),(69053,3722),(69054,3723),(69055,3723),(69056,3723),(69057,3724),(69058,3724),(69059,3724),(69060,3725),(69061,3725),(69062,3725),(69063,3726),(69064,3726),(69065,3726),(69066,3727),(69067,3727),(69068,3727),(69069,3728),(69070,3728),(69071,3728),(69072,3729),(69073,3729),(69074,3729),(69075,3730),(69076,3730),(69077,3730),(69078,3731),(69079,3731),(69080,3731),(69081,3732),(69082,3732),(69083,3732),(69084,3733),(69085,3733),(69086,3733),(69087,3734),(69088,3734),(69089,3734),(69090,3735),(69091,3735),(69092,3735),(69093,3736),(69094,3736),(69095,3736),(69096,3737),(69097,3737),(69098,3737),(69099,3738),(69100,3738),(69101,3738),(69102,3739),(69103,3739),(69104,3739),(69105,3740),(69106,3740),(69107,3740),(69108,3741),(69109,3741),(69110,3741),(69111,3742),(69112,3742),(69113,3742),(69114,3743),(69115,3743),(69116,3743),(69117,3744),(69118,3744),(69119,3744),(69120,3745),(69121,3745),(69122,3745),(69123,3746),(69124,3746),(69125,3746),(69126,3747),(69127,3747),(69128,3747),(69129,3748),(69130,3748),(69131,3748),(69132,3749),(69133,3749),(69134,3749),(69135,3750),(69136,3750),(69137,3750),(69138,3751),(69139,3751),(69140,3751),(69141,3752),(69142,3752),(69143,3752),(69144,3753),(69145,3753),(69146,3753),(69147,3754),(69148,3754),(69149,3754),(69150,3755),(69151,3755),(69152,3755),(69153,3756),(69154,3756),(69155,3756),(69156,3757),(69157,3757),(69158,3757),(69159,3758),(69160,3758),(69161,3758),(69162,3759),(69163,3759),(69164,3759),(69165,3760),(69166,3760),(69167,3760),(69168,3761),(69169,3761),(69170,3761),(69171,3762),(69172,3762),(69173,3762),(69174,3763),(69175,3763),(69176,3763),(69177,3764),(69178,3764),(69179,3764),(69180,3765),(69181,3765),(69182,3765),(69183,3766),(69184,3766),(69185,3766),(69186,3767),(69187,3767),(69188,3767),(69189,3768),(69190,3768),(69191,3768),(69192,3769),(69193,3769),(69194,3769),(69195,3770),(69196,3770),(69197,3770),(69198,3771),(69199,3771),(69200,3771),(69201,3772),(69202,3772),(69203,3772),(69204,3773),(69205,3773),(69206,3773),(69207,3774),(69208,3774),(69209,3774),(69210,3775),(69211,3775),(69212,3775),(69213,3776),(69214,3776),(69215,3776),(69216,3777),(69217,3777),(69218,3777),(69219,3778),(69220,3778),(69221,3778),(69222,3779),(69223,3779),(69224,3779),(69225,3780),(69226,3780),(69227,3780),(69228,3781),(69229,3781),(69230,3781),(69231,3782),(69232,3782),(69233,3782),(69234,3783),(69235,3783),(69236,3783),(69237,3784),(69238,3784),(69239,3784),(69240,3785),(69241,3785),(69242,3785),(69243,3786),(69244,3786),(69245,3786),(69246,3787),(69247,3787),(69248,3787),(69249,3788),(69250,3788),(69251,3788),(69252,3789),(69253,3789),(69254,3789),(69255,3790),(69256,3790),(69257,3790),(69258,3791),(69259,3791),(69260,3791),(69261,3792),(69262,3792),(69263,3792),(69264,3793),(69265,3793),(69266,3793),(69267,3794),(69268,3794),(69269,3794),(69270,3795),(69271,3795),(69272,3795),(69273,3796),(69274,3796),(69275,3796),(69276,3797),(69277,3797),(69278,3797),(69279,3798),(69280,3798),(69281,3798),(69282,3799),(69283,3799),(69284,3799),(69285,3800),(69286,3800),(69287,3800),(69288,3801),(69289,3801),(69290,3801),(69291,3802),(69292,3802),(69293,3802),(69294,3803),(69295,3803),(69296,3803),(69297,3804),(69298,3804),(69299,3804),(69300,3805),(69301,3805),(69302,3805),(69303,3806),(69304,3806),(69305,3806),(69306,3807),(69307,3807),(69308,3807),(69309,3808),(69310,3808),(69311,3808),(69312,3809),(69313,3809),(69314,3809),(69315,3810),(69316,3810),(69317,3810),(69318,3811),(69319,3811),(69320,3811),(69321,3812),(69322,3812),(69323,3812),(69324,3813),(69325,3813),(69326,3813),(69327,3814),(69328,3814),(69329,3814),(69330,3715),(69331,3715),(69332,3715),(69333,3715),(69334,3716),(69335,3716),(69336,3716),(69337,3716),(69338,3717),(69339,3717),(69340,3717),(69341,3717),(69342,3718),(69343,3718),(69344,3718),(69345,3718),(69346,3719),(69347,3719),(69348,3719),(69349,3719),(69350,3720),(69351,3720),(69352,3720),(69353,3720),(69354,3721),(69355,3721),(69356,3721),(69357,3721),(69358,3722),(69359,3722),(69360,3722),(69361,3722),(69362,3723),(69363,3723),(69364,3723),(69365,3723),(69366,3724),(69367,3724),(69368,3724),(69369,3724),(69370,3725),(69371,3725),(69372,3725),(69373,3725),(69374,3726),(69375,3726),(69376,3726),(69377,3726),(69378,3727),(69379,3727),(69380,3727),(69381,3727),(69382,3728),(69383,3728),(69384,3728),(69385,3728),(69386,3729),(69387,3729),(69388,3729),(69389,3729),(69390,3730),(69391,3730),(69392,3730),(69393,3730),(69394,3731),(69395,3731),(69396,3731),(69397,3731),(69398,3732),(69399,3732),(69400,3732),(69401,3732),(69402,3733),(69403,3733),(69404,3733),(69405,3733),(69406,3734),(69407,3734),(69408,3734),(69409,3734),(69410,3735),(69411,3735),(69412,3735),(69413,3735),(69414,3736),(69415,3736),(69416,3736),(69417,3736),(69418,3737),(69419,3737),(69420,3737),(69421,3737),(69422,3738),(69423,3738),(69424,3738),(69425,3738),(69426,3739),(69427,3739),(69428,3739),(69429,3739),(69430,3740),(69431,3740),(69432,3740),(69433,3740),(69434,3741),(69435,3741),(69436,3741),(69437,3741),(69438,3742),(69439,3742),(69440,3742),(69441,3742),(69442,3743),(69443,3743),(69444,3743),(69445,3743),(69446,3744),(69447,3744),(69448,3744),(69449,3744),(69450,3745),(69451,3745),(69452,3745),(69453,3745),(69454,3746),(69455,3746),(69456,3746),(69457,3746),(69458,3747),(69459,3747),(69460,3747),(69461,3747),(69462,3748),(69463,3748),(69464,3748),(69465,3748),(69466,3749),(69467,3749),(69468,3749),(69469,3749),(69470,3750),(69471,3750),(69472,3750),(69473,3750),(69474,3751),(69475,3751),(69476,3751),(69477,3751),(69478,3752),(69479,3752),(69480,3752),(69481,3752),(69482,3753),(69483,3753),(69484,3753),(69485,3753),(69486,3754),(69487,3754),(69488,3754),(69489,3754),(69490,3755),(69491,3755),(69492,3755),(69493,3755),(69494,3756),(69495,3756),(69496,3756),(69497,3756),(69498,3757),(69499,3757),(69500,3757),(69501,3757),(69502,3758),(69503,3758),(69504,3758),(69505,3758),(69506,3759),(69507,3759),(69508,3759),(69509,3759),(69510,3760),(69511,3760),(69512,3760),(69513,3760),(69514,3761),(69515,3761),(69516,3761),(69517,3761),(69518,3762),(69519,3762),(69520,3762),(69521,3762),(69522,3763),(69523,3763),(69524,3763),(69525,3763),(69526,3764),(69527,3764),(69528,3764),(69529,3764),(69530,3765),(69531,3765),(69532,3765),(69533,3765),(69534,3766),(69535,3766),(69536,3766),(69537,3766),(69538,3767),(69539,3767),(69540,3767),(69541,3767),(69542,3768),(69543,3768),(69544,3768),(69545,3768),(69546,3769),(69547,3769),(69548,3769),(69549,3769),(69550,3770),(69551,3770),(69552,3770),(69553,3770),(69554,3771),(69555,3771),(69556,3771),(69557,3771),(69558,3772),(69559,3772),(69560,3772),(69561,3772),(69562,3773),(69563,3773),(69564,3773),(69565,3773),(69566,3774),(69567,3774),(69568,3774),(69569,3774),(69570,3775),(69571,3775),(69572,3775),(69573,3775),(69574,3776),(69575,3776),(69576,3776),(69577,3776),(69578,3777),(69579,3777),(69580,3777),(69581,3777),(69582,3778),(69583,3778),(69584,3778),(69585,3778),(69586,3779),(69587,3779),(69588,3779),(69589,3779),(69590,3780),(69591,3780),(69592,3780),(69593,3780),(69594,3781),(69595,3781),(69596,3781),(69597,3781),(69598,3782),(69599,3782),(69600,3782),(69601,3782),(69602,3783),(69603,3783),(69604,3783),(69605,3783),(69606,3784),(69607,3784),(69608,3784),(69609,3784),(69610,3785),(69611,3785),(69612,3785),(69613,3785),(69614,3786),(69615,3786),(69616,3786),(69617,3786),(69618,3787),(69619,3787),(69620,3787),(69621,3787),(69622,3788),(69623,3788),(69624,3788),(69625,3788),(69626,3789),(69627,3789),(69628,3789),(69629,3789),(69630,3790),(69631,3790),(69632,3790),(69633,3790),(69634,3791),(69635,3791),(69636,3791),(69637,3791),(69638,3792),(69639,3792),(69640,3792),(69641,3792),(69642,3793),(69643,3793),(69644,3793),(69645,3793),(69646,3794),(69647,3794),(69648,3794),(69649,3794),(69650,3795),(69651,3795),(69652,3795),(69653,3795),(69654,3796),(69655,3796),(69656,3796),(69657,3796),(69658,3797),(69659,3797),(69660,3797),(69661,3797),(69662,3798),(69663,3798),(69664,3798),(69665,3798),(69666,3799),(69667,3799),(69668,3799),(69669,3799),(69670,3800),(69671,3800),(69672,3800),(69673,3800),(69674,3801),(69675,3801),(69676,3801),(69677,3801),(69678,3802),(69679,3802),(69680,3802),(69681,3802),(69682,3803),(69683,3803),(69684,3803),(69685,3803),(69686,3804),(69687,3804),(69688,3804),(69689,3804),(69690,3805),(69691,3805),(69692,3805),(69693,3805),(69694,3806),(69695,3806),(69696,3806),(69697,3806),(69698,3807),(69699,3807),(69700,3807),(69701,3807),(69702,3808),(69703,3808),(69704,3808),(69705,3808),(69706,3809),(69707,3809),(69708,3809),(69709,3809),(69710,3810),(69711,3810),(69712,3810),(69713,3810),(69714,3811),(69715,3811),(69716,3811),(69717,3811),(69718,3812),(69719,3812),(69720,3812),(69721,3812),(69722,3813),(69723,3813),(69724,3813),(69725,3813),(69726,3814),(69727,3814),(69728,3814),(69729,3814),(69730,3815),(69731,3816),(69732,3817),(69733,3818),(69734,3819),(69735,3820),(69736,3821),(69737,3822),(69738,3823),(69739,3824),(69740,3825),(69741,3826),(69742,3827),(69743,3828),(69744,3829),(69745,3830),(69746,3831),(69747,3832),(69748,3833),(69749,3834),(69750,3835),(69751,3836),(69752,3837),(69753,3838),(69754,3839),(69755,3840),(69756,3841),(69757,3842),(69758,3843),(69759,3844),(69760,3845),(69761,3846),(69762,3847),(69763,3848),(69764,3849),(69765,3850),(69766,3851),(69767,3852),(69768,3853),(69769,3854),(69770,3855),(69771,3856),(69772,3857),(69773,3858),(69774,3859),(69775,3860),(69776,3861),(69777,3862),(69778,3863),(69779,3864),(69780,3865),(69781,3866),(69782,3867),(69783,3868),(69784,3869),(69785,3870),(69786,3871),(69787,3872),(69788,3873),(69789,3874),(69790,3875),(69791,3876),(69792,3877),(69793,3878),(69794,3879),(69795,3880),(69796,3881),(69797,3882),(69798,3883),(69799,3884),(69800,3885),(69801,3886),(69802,3887),(69803,3888),(69804,3889),(69805,3890),(69806,3891),(69807,3892),(69808,3893),(69809,3894),(69810,3895),(69811,3896),(69812,3897),(69813,3898),(69814,3899),(69815,3900),(69816,3901),(69817,3902),(69818,3903),(69819,3904),(69820,3905),(69821,3906),(69822,3907),(69823,3908),(69824,3909),(69825,3910),(69826,3911),(69827,3912),(69828,3913),(69829,3914),(69830,3815),(69831,3816),(69832,3817),(69833,3818),(69834,3819),(69835,3820),(69836,3821),(69837,3822),(69838,3823),(69839,3824),(69840,3825),(69841,3826),(69842,3827),(69843,3828),(69844,3829),(69845,3830),(69846,3831),(69847,3832),(69848,3833),(69849,3834),(69850,3835),(69851,3836),(69852,3837),(69853,3838),(69854,3839),(69855,3840),(69856,3841),(69857,3842),(69858,3843),(69859,3844),(69860,3845),(69861,3846),(69862,3847),(69863,3848),(69864,3849),(69865,3850),(69866,3851),(69867,3852),(69868,3853),(69869,3854),(69870,3855),(69871,3856),(69872,3857),(69873,3858),(69874,3859),(69875,3860),(69876,3861),(69877,3862),(69878,3863),(69879,3864),(69880,3865),(69881,3866),(69882,3867),(69883,3868),(69884,3869),(69885,3870),(69886,3871),(69887,3872),(69888,3873),(69889,3874),(69890,3875),(69891,3876),(69892,3877),(69893,3878),(69894,3879),(69895,3880),(69896,3881),(69897,3882),(69898,3883),(69899,3884),(69900,3885),(69901,3886),(69902,3887),(69903,3888),(69904,3889),(69905,3890),(69906,3891),(69907,3892),(69908,3893),(69909,3894),(69910,3895),(69911,3896),(69912,3897),(69913,3898),(69914,3899),(69915,3900),(69916,3901),(69917,3902),(69918,3903),(69919,3904),(69920,3905),(69921,3906),(69922,3907),(69923,3908),(69924,3909),(69925,3910),(69926,3911),(69927,3912),(69928,3913),(69929,3914),(69930,3815),(69931,3815),(69932,3815),(69933,3815),(69934,3815),(69935,3815),(69936,3816),(69937,3816),(69938,3816),(69939,3816),(69940,3816),(69941,3816),(69942,3817),(69943,3817),(69944,3817),(69945,3817),(69946,3817),(69947,3817),(69948,3818),(69949,3818),(69950,3818),(69951,3818),(69952,3818),(69953,3818),(69954,3819),(69955,3819),(69956,3819),(69957,3819),(69958,3820),(69959,3820),(69960,3820),(69961,3820),(69962,3820),(69963,3820),(69964,3821),(69965,3821),(69966,3821),(69967,3821),(69968,3821),(69969,3821),(69970,3822),(69971,3822),(69972,3822),(69973,3822),(69974,3822),(69975,3822),(69976,3823),(69977,3823),(69978,3823),(69979,3823),(69980,3823),(69981,3823),(69982,3824),(69983,3824),(69984,3824),(69985,3824),(69986,3824),(69987,3824),(69988,3825),(69989,3825),(69990,3825),(69991,3825),(69992,3825),(69993,3825),(69994,3826),(69995,3826),(69996,3826),(69997,3826),(69998,3826),(69999,3826),(70000,3827),(70001,3827),(70002,3827),(70003,3827),(70004,3827),(70005,3827),(70006,3828),(70007,3828),(70008,3828),(70009,3828),(70010,3828),(70011,3828),(70012,3829),(70013,3829),(70014,3829),(70015,3829),(70016,3829),(70017,3829),(70018,3830),(70019,3830),(70020,3830),(70021,3830),(70022,3830),(70023,3830),(70024,3831),(70025,3831),(70026,3831),(70027,3831),(70028,3831),(70029,3831),(70030,3832),(70031,3832),(70032,3832),(70033,3832),(70034,3832),(70035,3832),(70036,3833),(70037,3833),(70038,3833),(70039,3833),(70040,3833),(70041,3833),(70042,3834),(70043,3834),(70044,3834),(70045,3834),(70046,3834),(70047,3834),(70048,3835),(70049,3835),(70050,3835),(70051,3835),(70052,3835),(70053,3835),(70054,3836),(70055,3836),(70056,3836),(70057,3836),(70058,3836),(70059,3836),(70060,3837),(70061,3837),(70062,3837),(70063,3837),(70064,3837),(70065,3837),(70066,3838),(70067,3838),(70068,3838),(70069,3838),(70070,3838),(70071,3838),(70072,3839),(70073,3839),(70074,3839),(70075,3839),(70076,3839),(70077,3839),(70078,3840),(70079,3840),(70080,3840),(70081,3840),(70082,3840),(70083,3840),(70084,3841),(70085,3841),(70086,3841),(70087,3841),(70088,3841),(70089,3841),(70090,3842),(70091,3842),(70092,3842),(70093,3842),(70094,3842),(70095,3842),(70096,3843),(70097,3843),(70098,3843),(70099,3843),(70100,3843),(70101,3843),(70102,3844),(70103,3844),(70104,3844),(70105,3844),(70106,3844),(70107,3844),(70108,3845),(70109,3845),(70110,3845),(70111,3845),(70112,3845),(70113,3845),(70114,3846),(70115,3846),(70116,3846),(70117,3846),(70118,3846),(70119,3846),(70120,3847),(70121,3847),(70122,3847),(70123,3847),(70124,3847),(70125,3847),(70126,3848),(70127,3848),(70128,3848),(70129,3848),(70130,3848),(70131,3848),(70132,3849),(70133,3849),(70134,3849),(70135,3849),(70136,3849),(70137,3849),(70138,3850),(70139,3850),(70140,3850),(70141,3850),(70142,3850),(70143,3850),(70144,3851),(70145,3851),(70146,3851),(70147,3851),(70148,3851),(70149,3851),(70150,3852),(70151,3852),(70152,3852),(70153,3852),(70154,3852),(70155,3852),(70156,3853),(70157,3853),(70158,3853),(70159,3853),(70160,3853),(70161,3853),(70162,3854),(70163,3854),(70164,3854),(70165,3854),(70166,3854),(70167,3854),(70168,3855),(70169,3855),(70170,3855),(70171,3855),(70172,3855),(70173,3855),(70174,3856),(70175,3856),(70176,3856),(70177,3856),(70178,3856),(70179,3856),(70180,3857),(70181,3857),(70182,3857),(70183,3857),(70184,3857),(70185,3857),(70186,3858),(70187,3858),(70188,3858),(70189,3858),(70190,3858),(70191,3858),(70192,3859),(70193,3859),(70194,3859),(70195,3859),(70196,3859),(70197,3859),(70198,3860),(70199,3860),(70200,3860),(70201,3860),(70202,3860),(70203,3860),(70204,3861),(70205,3861),(70206,3861),(70207,3861),(70208,3861),(70209,3861),(70210,3862),(70211,3862),(70212,3862),(70213,3862),(70214,3862),(70215,3862),(70216,3863),(70217,3863),(70218,3863),(70219,3863),(70220,3863),(70221,3863),(70222,3864),(70223,3864),(70224,3864),(70225,3864),(70226,3864),(70227,3864),(70228,3865),(70229,3865),(70230,3865),(70231,3865),(70232,3865),(70233,3865),(70234,3866),(70235,3866),(70236,3866),(70237,3866),(70238,3866),(70239,3866),(70240,3867),(70241,3867),(70242,3867),(70243,3867),(70244,3867),(70245,3867),(70246,3868),(70247,3868),(70248,3868),(70249,3868),(70250,3868),(70251,3868),(70252,3869),(70253,3869),(70254,3869),(70255,3869),(70256,3869),(70257,3869),(70258,3870),(70259,3870),(70260,3870),(70261,3870),(70262,3870),(70263,3870),(70264,3871),(70265,3871),(70266,3871),(70267,3871),(70268,3871),(70269,3871),(70270,3872),(70271,3872),(70272,3872),(70273,3872),(70274,3872),(70275,3872),(70276,3873),(70277,3873),(70278,3873),(70279,3873),(70280,3873),(70281,3873),(70282,3874),(70283,3874),(70284,3874),(70285,3874),(70286,3874),(70287,3874),(70288,3875),(70289,3875),(70290,3875),(70291,3875),(70292,3875),(70293,3875),(70294,3876),(70295,3876),(70296,3876),(70297,3876),(70298,3876),(70299,3876),(70300,3877),(70301,3877),(70302,3877),(70303,3877),(70304,3877),(70305,3877),(70306,3878),(70307,3878),(70308,3878),(70309,3878),(70310,3878),(70311,3878),(70312,3879),(70313,3879),(70314,3879),(70315,3879),(70316,3879),(70317,3879),(70318,3880),(70319,3880),(70320,3880),(70321,3880),(70322,3880),(70323,3880),(70324,3881),(70325,3881),(70326,3881),(70327,3881),(70328,3881),(70329,3881),(70330,3882),(70331,3882),(70332,3882),(70333,3882),(70334,3882),(70335,3882),(70336,3883),(70337,3883),(70338,3883),(70339,3883),(70340,3883),(70341,3883),(70342,3884),(70343,3884),(70344,3884),(70345,3884),(70346,3884),(70347,3884),(70348,3885),(70349,3885),(70350,3885),(70351,3885),(70352,3885),(70353,3885),(70354,3886),(70355,3886),(70356,3886),(70357,3886),(70358,3886),(70359,3886),(70360,3887),(70361,3887),(70362,3887),(70363,3887),(70364,3887),(70365,3887),(70366,3888),(70367,3888),(70368,3888),(70369,3888),(70370,3888),(70371,3888),(70372,3889),(70373,3889),(70374,3889),(70375,3889),(70376,3889),(70377,3889),(70378,3890),(70379,3890),(70380,3890),(70381,3890),(70382,3890),(70383,3890),(70384,3891),(70385,3891),(70386,3891),(70387,3891),(70388,3891),(70389,3891),(70390,3892),(70391,3892),(70392,3892),(70393,3892),(70394,3892),(70395,3892),(70396,3893),(70397,3893),(70398,3893),(70399,3893),(70400,3893),(70401,3893),(70402,3894),(70403,3894),(70404,3894),(70405,3894),(70406,3894),(70407,3894),(70408,3895),(70409,3895),(70410,3895),(70411,3895),(70412,3895),(70413,3895),(70414,3896),(70415,3896),(70416,3896),(70417,3896),(70418,3896),(70419,3897),(70420,3897),(70421,3897),(70422,3897),(70423,3897),(70424,3898),(70425,3898),(70426,3898),(70427,3898),(70428,3898),(70429,3898),(70430,3899),(70431,3899),(70432,3899),(70433,3899),(70434,3899),(70435,3899),(70436,3900),(70437,3900),(70438,3900),(70439,3900),(70440,3900),(70441,3900),(70442,3901),(70443,3901),(70444,3901),(70445,3901),(70446,3901),(70447,3901),(70448,3902),(70449,3902),(70450,3902),(70451,3902),(70452,3902),(70453,3902),(70454,3903),(70455,3903),(70456,3903),(70457,3903),(70458,3903),(70459,3903),(70460,3904),(70461,3904),(70462,3904),(70463,3904),(70464,3904),(70465,3904),(70466,3905),(70467,3905),(70468,3905),(70469,3905),(70470,3905),(70471,3905),(70472,3906),(70473,3906),(70474,3906),(70475,3906),(70476,3906),(70477,3906),(70478,3907),(70479,3907),(70480,3907),(70481,3907),(70482,3907),(70483,3907),(70484,3908),(70485,3908),(70486,3908),(70487,3908),(70488,3908),(70489,3908),(70490,3909),(70491,3909),(70492,3909),(70493,3909),(70494,3909),(70495,3909),(70496,3910),(70497,3910),(70498,3910),(70499,3910),(70500,3910),(70501,3910),(70502,3911),(70503,3911),(70504,3911),(70505,3911),(70506,3911),(70507,3911),(70508,3912),(70509,3912),(70510,3912),(70511,3912),(70512,3912),(70513,3912),(70514,3913),(70515,3913),(70516,3913),(70517,3913),(70518,3913),(70519,3913),(70520,3914),(70521,3914),(70522,3914),(70523,3914),(70524,3914),(70525,3914),(70526,3815),(70527,3815),(70528,3816),(70529,3816),(70530,3817),(70531,3817),(70532,3818),(70533,3818),(70534,3819),(70535,3820),(70536,3820),(70537,3821),(70538,3821),(70539,3822),(70540,3822),(70541,3823),(70542,3823),(70543,3824),(70544,3824),(70545,3825),(70546,3825),(70547,3826),(70548,3826),(70549,3827),(70550,3827),(70551,3828),(70552,3828),(70553,3829),(70554,3829),(70555,3830),(70556,3830),(70557,3831),(70558,3831),(70559,3832),(70560,3832),(70561,3833),(70562,3833),(70563,3834),(70564,3834),(70565,3835),(70566,3835),(70567,3836),(70568,3836),(70569,3837),(70570,3837),(70571,3838),(70572,3838),(70573,3839),(70574,3839),(70575,3840),(70576,3840),(70577,3841),(70578,3841),(70579,3842),(70580,3842),(70581,3843),(70582,3843),(70583,3844),(70584,3844),(70585,3845),(70586,3845),(70587,3846),(70588,3846),(70589,3847),(70590,3847),(70591,3848),(70592,3848),(70593,3849),(70594,3849),(70595,3850),(70596,3850),(70597,3851),(70598,3851),(70599,3852),(70600,3852),(70601,3853),(70602,3853),(70603,3854),(70604,3854),(70605,3855),(70606,3855),(70607,3856),(70608,3856),(70609,3857),(70610,3857),(70611,3858),(70612,3858),(70613,3859),(70614,3859),(70615,3860),(70616,3860),(70617,3861),(70618,3861),(70619,3862),(70620,3862),(70621,3863),(70622,3863),(70623,3864),(70624,3864),(70625,3865),(70626,3865),(70627,3866),(70628,3866),(70629,3867),(70630,3867),(70631,3868),(70632,3868),(70633,3869),(70634,3869),(70635,3870),(70636,3870),(70637,3871),(70638,3871),(70639,3872),(70640,3872),(70641,3873),(70642,3873),(70643,3874),(70644,3874),(70645,3875),(70646,3875),(70647,3876),(70648,3876),(70649,3877),(70650,3877),(70651,3878),(70652,3878),(70653,3879),(70654,3879),(70655,3880),(70656,3880),(70657,3881),(70658,3881),(70659,3882),(70660,3882),(70661,3883),(70662,3883),(70663,3884),(70664,3884),(70665,3884),(70666,3885),(70667,3885),(70668,3886),(70669,3886),(70670,3887),(70671,3887),(70672,3888),(70673,3888),(70674,3889),(70675,3889),(70676,3890),(70677,3890),(70678,3891),(70679,3891),(70680,3892),(70681,3892),(70682,3893),(70683,3893),(70684,3894),(70685,3894),(70686,3895),(70687,3895),(70688,3896),(70689,3896),(70690,3897),(70691,3897),(70692,3898),(70693,3898),(70694,3899),(70695,3899),(70696,3900),(70697,3900),(70698,3901),(70699,3901),(70700,3902),(70701,3902),(70702,3903),(70703,3903),(70704,3904),(70705,3904),(70706,3905),(70707,3905),(70708,3906),(70709,3906),(70710,3907),(70711,3907),(70712,3908),(70713,3908),(70714,3909),(70715,3909),(70716,3910),(70717,3910),(70718,3911),(70719,3911),(70720,3912),(70721,3912),(70722,3913),(70723,3913),(70724,3914),(70725,3914),(70726,3914),(70727,3815),(70728,3815),(70729,3815),(70730,3816),(70731,3816),(70732,3816),(70733,3817),(70734,3817),(70735,3817),(70736,3818),(70737,3818),(70738,3818),(70739,3819),(70740,3819),(70741,3819),(70742,3820),(70743,3820),(70744,3820),(70745,3821),(70746,3821),(70747,3821),(70748,3822),(70749,3822),(70750,3822),(70751,3823),(70752,3823),(70753,3823),(70754,3824),(70755,3824),(70756,3824),(70757,3825),(70758,3825),(70759,3825),(70760,3826),(70761,3826),(70762,3826),(70763,3827),(70764,3827),(70765,3827),(70766,3828),(70767,3828),(70768,3828),(70769,3829),(70770,3829),(70771,3829),(70772,3830),(70773,3830),(70774,3830),(70775,3831),(70776,3831),(70777,3831),(70778,3832),(70779,3832),(70780,3832),(70781,3833),(70782,3833),(70783,3833),(70784,3834),(70785,3834),(70786,3834),(70787,3835),(70788,3835),(70789,3835),(70790,3836),(70791,3836),(70792,3836),(70793,3837),(70794,3837),(70795,3837),(70796,3838),(70797,3838),(70798,3838),(70799,3839),(70800,3839),(70801,3839),(70802,3840),(70803,3840),(70804,3840),(70805,3841),(70806,3841),(70807,3841),(70808,3842),(70809,3842),(70810,3842),(70811,3843),(70812,3843),(70813,3843),(70814,3844),(70815,3844),(70816,3844),(70817,3845),(70818,3845),(70819,3845),(70820,3846),(70821,3846),(70822,3846),(70823,3847),(70824,3847),(70825,3847),(70826,3848),(70827,3848),(70828,3848),(70829,3849),(70830,3849),(70831,3849),(70832,3850),(70833,3850),(70834,3850),(70835,3851),(70836,3851),(70837,3851),(70838,3852),(70839,3852),(70840,3852),(70841,3853),(70842,3853),(70843,3853),(70844,3854),(70845,3854),(70846,3854),(70847,3855),(70848,3855),(70849,3855),(70850,3856),(70851,3856),(70852,3856),(70853,3857),(70854,3857),(70855,3857),(70856,3858),(70857,3858),(70858,3858),(70859,3859),(70860,3859),(70861,3859),(70862,3860),(70863,3860),(70864,3860),(70865,3861),(70866,3861),(70867,3861),(70868,3862),(70869,3862),(70870,3862),(70871,3863),(70872,3863),(70873,3863),(70874,3864),(70875,3864),(70876,3864),(70877,3865),(70878,3865),(70879,3865),(70880,3866),(70881,3866),(70882,3866),(70883,3867),(70884,3867),(70885,3867),(70886,3868),(70887,3868),(70888,3868),(70889,3869),(70890,3869),(70891,3869),(70892,3870),(70893,3870),(70894,3870),(70895,3871),(70896,3871),(70897,3871),(70898,3872),(70899,3872),(70900,3873),(70901,3873),(70902,3874),(70903,3874),(70904,3874),(70905,3875),(70906,3875),(70907,3875),(70908,3876),(70909,3876),(70910,3876),(70911,3877),(70912,3877),(70913,3877),(70914,3878),(70915,3878),(70916,3878),(70917,3879),(70918,3879),(70919,3879),(70920,3880),(70921,3880),(70922,3880),(70923,3881),(70924,3881),(70925,3881),(70926,3882),(70927,3882),(70928,3882),(70929,3883),(70930,3883),(70931,3883),(70932,3884),(70933,3884),(70934,3884),(70935,3885),(70936,3885),(70937,3886),(70938,3886),(70939,3886),(70940,3887),(70941,3887),(70942,3887),(70943,3888),(70944,3888),(70945,3888),(70946,3889),(70947,3889),(70948,3889),(70949,3890),(70950,3890),(70951,3890),(70952,3891),(70953,3891),(70954,3891),(70955,3892),(70956,3892),(70957,3892),(70958,3893),(70959,3893),(70960,3893),(70961,3894),(70962,3894),(70963,3894),(70964,3895),(70965,3895),(70966,3895),(70967,3896),(70968,3896),(70969,3896),(70970,3897),(70971,3897),(70972,3897),(70973,3898),(70974,3898),(70975,3898),(70976,3899),(70977,3899),(70978,3899),(70979,3900),(70980,3900),(70981,3900),(70982,3901),(70983,3901),(70984,3901),(70985,3902),(70986,3902),(70987,3902),(70988,3903),(70989,3903),(70990,3903),(70991,3904),(70992,3904),(70993,3904),(70994,3905),(70995,3905),(70996,3905),(70997,3906),(70998,3906),(70999,3906),(71000,3907),(71001,3907),(71002,3907),(71003,3908),(71004,3908),(71005,3908),(71006,3909),(71007,3909),(71008,3909),(71009,3910),(71010,3910),(71011,3910),(71012,3911),(71013,3911),(71014,3911),(71015,3912),(71016,3912),(71017,3912),(71018,3913),(71019,3913),(71020,3913),(71021,3914),(71022,3914),(71023,3914),(71024,3815),(71025,3815),(71026,3815),(71027,3815),(71028,3816),(71029,3816),(71030,3816),(71031,3816),(71032,3817),(71033,3817),(71034,3817),(71035,3817),(71036,3818),(71037,3818),(71038,3818),(71039,3818),(71040,3819),(71041,3819),(71042,3819),(71043,3819),(71044,3820),(71045,3820),(71046,3820),(71047,3820),(71048,3821),(71049,3821),(71050,3821),(71051,3821),(71052,3822),(71053,3822),(71054,3822),(71055,3822),(71056,3823),(71057,3823),(71058,3823),(71059,3823),(71060,3824),(71061,3824),(71062,3824),(71063,3824),(71064,3825),(71065,3825),(71066,3825),(71067,3825),(71068,3826),(71069,3826),(71070,3826),(71071,3826),(71072,3827),(71073,3827),(71074,3827),(71075,3827),(71076,3828),(71077,3828),(71078,3828),(71079,3828),(71080,3829),(71081,3829),(71082,3829),(71083,3829),(71084,3830),(71085,3830),(71086,3830),(71087,3830),(71088,3831),(71089,3831),(71090,3831),(71091,3831),(71092,3832),(71093,3832),(71094,3832),(71095,3832),(71096,3833),(71097,3833),(71098,3833),(71099,3833),(71100,3834),(71101,3834),(71102,3834),(71103,3834),(71104,3835),(71105,3835),(71106,3835),(71107,3835),(71108,3836),(71109,3836),(71110,3836),(71111,3836),(71112,3837),(71113,3837),(71114,3837),(71115,3837),(71116,3838),(71117,3838),(71118,3838),(71119,3838),(71120,3839),(71121,3839),(71122,3839),(71123,3839),(71124,3840),(71125,3840),(71126,3840),(71127,3840),(71128,3841),(71129,3841),(71130,3841),(71131,3841),(71132,3842),(71133,3842),(71134,3842),(71135,3842),(71136,3843),(71137,3843),(71138,3843),(71139,3843),(71140,3844),(71141,3844),(71142,3844),(71143,3844),(71144,3845),(71145,3845),(71146,3845),(71147,3845),(71148,3846),(71149,3846),(71150,3846),(71151,3846),(71152,3847),(71153,3847),(71154,3847),(71155,3847),(71156,3848),(71157,3848),(71158,3848),(71159,3848),(71160,3849),(71161,3849),(71162,3849),(71163,3849),(71164,3850),(71165,3850),(71166,3850),(71167,3850),(71168,3851),(71169,3851),(71170,3851),(71171,3851),(71172,3852),(71173,3852),(71174,3852),(71175,3852),(71176,3853),(71177,3853),(71178,3853),(71179,3853),(71180,3854),(71181,3854),(71182,3854),(71183,3854),(71184,3855),(71185,3855),(71186,3855),(71187,3855),(71188,3856),(71189,3856),(71190,3856),(71191,3856),(71192,3857),(71193,3857),(71194,3857),(71195,3857),(71196,3858),(71197,3858),(71198,3858),(71199,3858),(71200,3859),(71201,3859),(71202,3859),(71203,3859),(71204,3860),(71205,3860),(71206,3860),(71207,3860),(71208,3861),(71209,3861),(71210,3861),(71211,3861),(71212,3862),(71213,3862),(71214,3862),(71215,3862),(71216,3863),(71217,3863),(71218,3863),(71219,3863),(71220,3864),(71221,3864),(71222,3864),(71223,3864),(71224,3865),(71225,3865),(71226,3865),(71227,3865),(71228,3866),(71229,3866),(71230,3866),(71231,3866),(71232,3867),(71233,3867),(71234,3867),(71235,3867),(71236,3868),(71237,3868),(71238,3868),(71239,3868),(71240,3869),(71241,3869),(71242,3869),(71243,3869),(71244,3870),(71245,3870),(71246,3870),(71247,3870),(71248,3871),(71249,3871),(71250,3871),(71251,3871),(71252,3872),(71253,3872),(71254,3872),(71255,3872),(71256,3873),(71257,3873),(71258,3873),(71259,3873),(71260,3874),(71261,3874),(71262,3874),(71263,3874),(71264,3875),(71265,3875),(71266,3875),(71267,3875),(71268,3876),(71269,3876),(71270,3876),(71271,3876),(71272,3877),(71273,3877),(71274,3877),(71275,3877),(71276,3878),(71277,3878),(71278,3878),(71279,3878),(71280,3879),(71281,3879),(71282,3879),(71283,3879),(71284,3880),(71285,3880),(71286,3880),(71287,3880),(71288,3881),(71289,3881),(71290,3881),(71291,3881),(71292,3882),(71293,3882),(71294,3882),(71295,3882),(71296,3883),(71297,3883),(71298,3883),(71299,3883),(71300,3884),(71301,3884),(71302,3884),(71303,3884),(71304,3885),(71305,3885),(71306,3885),(71307,3885),(71308,3886),(71309,3886),(71310,3886),(71311,3886),(71312,3887),(71313,3887),(71314,3887),(71315,3887),(71316,3888),(71317,3888),(71318,3888),(71319,3888),(71320,3889),(71321,3889),(71322,3889),(71323,3889),(71324,3890),(71325,3890),(71326,3890),(71327,3890),(71328,3891),(71329,3891),(71330,3891),(71331,3891),(71332,3892),(71333,3892),(71334,3892),(71335,3892),(71336,3893),(71337,3893),(71338,3893),(71339,3893),(71340,3894),(71341,3894),(71342,3894),(71343,3894),(71344,3895),(71345,3895),(71346,3895),(71347,3895),(71348,3896),(71349,3896),(71350,3896),(71351,3896),(71352,3897),(71353,3897),(71354,3897),(71355,3897),(71356,3898),(71357,3898),(71358,3898),(71359,3898),(71360,3899),(71361,3899),(71362,3899),(71363,3899),(71364,3900),(71365,3900),(71366,3900),(71367,3900),(71368,3901),(71369,3901),(71370,3901),(71371,3901),(71372,3902),(71373,3902),(71374,3902),(71375,3902),(71376,3903),(71377,3903),(71378,3903),(71379,3903),(71380,3904),(71381,3904),(71382,3904),(71383,3904),(71384,3905),(71385,3905),(71386,3905),(71387,3905),(71388,3906),(71389,3906),(71390,3906),(71391,3906),(71392,3907),(71393,3907),(71394,3907),(71395,3907),(71396,3908),(71397,3908),(71398,3908),(71399,3908),(71400,3909),(71401,3909),(71402,3909),(71403,3909),(71404,3910),(71405,3910),(71406,3910),(71407,3910),(71408,3911),(71409,3911),(71410,3911),(71411,3911),(71412,3912),(71413,3912),(71414,3912),(71415,3912),(71416,3913),(71417,3913),(71418,3913),(71419,3913),(71420,3914),(71421,3914),(71422,3914),(71423,3914),(71424,3915),(71425,3916),(71426,3917),(71427,3918),(71428,3919),(71429,3920),(71430,3921),(71431,3922),(71432,3923),(71433,3924),(71434,3925),(71435,3926),(71436,3927),(71437,3928),(71438,3929),(71439,3930),(71440,3931),(71441,3932),(71442,3933),(71443,3934),(71444,3935),(71445,3936),(71446,3937),(71447,3938),(71448,3939),(71449,3940),(71450,3941),(71451,3942),(71452,3943),(71453,3944),(71454,3945),(71455,3946),(71456,3947),(71457,3948),(71458,3949),(71459,3950),(71460,3951),(71461,3952),(71462,3953),(71463,3954),(71464,3955),(71465,3956),(71466,3957),(71467,3958),(71468,3959),(71469,3960),(71470,3961),(71471,3962),(71472,3963),(71473,3964),(71474,3965),(71475,3966),(71476,3967),(71477,3968),(71478,3969),(71479,3970),(71480,3971),(71481,3972),(71482,3973),(71483,3974),(71484,3975),(71485,3976),(71486,3977),(71487,3978),(71488,3979),(71489,3980),(71490,3981),(71491,3982),(71492,3983),(71493,3984),(71494,3985),(71495,3986),(71496,3987),(71497,3988),(71498,3989),(71499,3990),(71500,3991),(71501,3992),(71502,3993),(71503,3994),(71504,3995),(71505,3996),(71506,3997),(71507,3998),(71508,3999),(71509,4000),(71510,4001),(71511,4002),(71512,4003),(71513,4004),(71514,4005),(71515,4006),(71516,4007),(71517,4008),(71518,4009),(71519,4010),(71520,4011),(71521,4012),(71522,4013),(71523,4014),(71524,3915),(71525,3916),(71526,3917),(71527,3918),(71528,3919),(71529,3920),(71530,3921),(71531,3922),(71532,3923),(71533,3924),(71534,3925),(71535,3926),(71536,3927),(71537,3928),(71538,3929),(71539,3930),(71540,3931),(71541,3932),(71542,3933),(71543,3934),(71544,3935),(71545,3936),(71546,3937),(71547,3938),(71548,3939),(71549,3940),(71550,3941),(71551,3942),(71552,3943),(71553,3944),(71554,3945),(71555,3946),(71556,3947),(71557,3948),(71558,3949),(71559,3950),(71560,3951),(71561,3952),(71562,3953),(71563,3954),(71564,3955),(71565,3956),(71566,3957),(71567,3958),(71568,3959),(71569,3960),(71570,3961),(71571,3962),(71572,3963),(71573,3964),(71574,3965),(71575,3966),(71576,3967),(71577,3968),(71578,3969),(71579,3970),(71580,3971),(71581,3972),(71582,3973),(71583,3974),(71584,3975),(71585,3976),(71586,3977),(71587,3978),(71588,3979),(71589,3980),(71590,3981),(71591,3982),(71592,3983),(71593,3984),(71594,3985),(71595,3986),(71596,3987),(71597,3988),(71598,3989),(71599,3990),(71600,3991),(71601,3992),(71602,3993),(71603,3994),(71604,3995),(71605,3996),(71606,3997),(71607,3998),(71608,3999),(71609,4000),(71610,4001),(71611,4002),(71612,4003),(71613,4004),(71614,4005),(71615,4006),(71616,4007),(71617,4008),(71618,4009),(71619,4010),(71620,4011),(71621,4012),(71622,4013),(71623,4014),(71624,3915),(71625,3915),(71626,3915),(71627,3915),(71628,3915),(71629,3915),(71630,3916),(71631,3916),(71632,3916),(71633,3916),(71634,3916),(71635,3916),(71636,3917),(71637,3917),(71638,3917),(71639,3917),(71640,3917),(71641,3917),(71642,3918),(71643,3918),(71644,3918),(71645,3918),(71646,3918),(71647,3918),(71648,3919),(71649,3919),(71650,3919),(71651,3919),(71652,3919),(71653,3919),(71654,3920),(71655,3920),(71656,3920),(71657,3920),(71658,3920),(71659,3920),(71660,3921),(71661,3921),(71662,3921),(71663,3921),(71664,3921),(71665,3921),(71666,3922),(71667,3922),(71668,3922),(71669,3922),(71670,3922),(71671,3922),(71672,3923),(71673,3923),(71674,3923),(71675,3923),(71676,3923),(71677,3923),(71678,3924),(71679,3924),(71680,3924),(71681,3924),(71682,3924),(71683,3924),(71684,3925),(71685,3925),(71686,3925),(71687,3925),(71688,3925),(71689,3925),(71690,3926),(71691,3926),(71692,3926),(71693,3926),(71694,3926),(71695,3926),(71696,3927),(71697,3927),(71698,3927),(71699,3927),(71700,3927),(71701,3927),(71702,3928),(71703,3928),(71704,3928),(71705,3928),(71706,3928),(71707,3928),(71708,3929),(71709,3929),(71710,3929),(71711,3929),(71712,3929),(71713,3929),(71714,3930),(71715,3930),(71716,3930),(71717,3930),(71718,3930),(71719,3930),(71720,3931),(71721,3931),(71722,3931),(71723,3931),(71724,3931),(71725,3931),(71726,3932),(71727,3932),(71728,3932),(71729,3932),(71730,3932),(71731,3932),(71732,3933),(71733,3933),(71734,3933),(71735,3933),(71736,3933),(71737,3933),(71738,3934),(71739,3934),(71740,3934),(71741,3934),(71742,3934),(71743,3934),(71744,3935),(71745,3935),(71746,3935),(71747,3935),(71748,3935),(71749,3935),(71750,3936),(71751,3936),(71752,3936),(71753,3936),(71754,3936),(71755,3936),(71756,3937),(71757,3937),(71758,3937),(71759,3937),(71760,3937),(71761,3937),(71762,3938),(71763,3938),(71764,3938),(71765,3938),(71766,3938),(71767,3938),(71768,3939),(71769,3939),(71770,3939),(71771,3939),(71772,3939),(71773,3939),(71774,3940),(71775,3940),(71776,3940),(71777,3940),(71778,3940),(71779,3940),(71780,3941),(71781,3941),(71782,3941),(71783,3941),(71784,3941),(71785,3941),(71786,3942),(71787,3942),(71788,3942),(71789,3942),(71790,3942),(71791,3942),(71792,3943),(71793,3943),(71794,3943),(71795,3943),(71796,3943),(71797,3943),(71798,3944),(71799,3944),(71800,3944),(71801,3944),(71802,3944),(71803,3944),(71804,3945),(71805,3945),(71806,3945),(71807,3945),(71808,3945),(71809,3945),(71810,3946),(71811,3946),(71812,3946),(71813,3946),(71814,3946),(71815,3946),(71816,3947),(71817,3947),(71818,3947),(71819,3947),(71820,3947),(71821,3947),(71822,3948),(71823,3948),(71824,3948),(71825,3948),(71826,3948),(71827,3948),(71828,3949),(71829,3949),(71830,3949),(71831,3949),(71832,3949),(71833,3949),(71834,3950),(71835,3950),(71836,3950),(71837,3950),(71838,3950),(71839,3950),(71840,3951),(71841,3951),(71842,3951),(71843,3951),(71844,3951),(71845,3951),(71846,3952),(71847,3952),(71848,3952),(71849,3952),(71850,3952),(71851,3952),(71852,3953),(71853,3953),(71854,3953),(71855,3953),(71856,3953),(71857,3953),(71858,3954),(71859,3954),(71860,3954),(71861,3954),(71862,3954),(71863,3954),(71864,3955),(71865,3955),(71866,3955),(71867,3955),(71868,3955),(71869,3955),(71870,3956),(71871,3956),(71872,3956),(71873,3956),(71874,3956),(71875,3956),(71876,3957),(71877,3957),(71878,3957),(71879,3957),(71880,3957),(71881,3957),(71882,3958),(71883,3958),(71884,3958),(71885,3958),(71886,3958),(71887,3958),(71888,3959),(71889,3959),(71890,3959),(71891,3959),(71892,3959),(71893,3959),(71894,3960),(71895,3960),(71896,3960),(71897,3960),(71898,3960),(71899,3960),(71900,3961),(71901,3961),(71902,3961),(71903,3961),(71904,3961),(71905,3961),(71906,3962),(71907,3962),(71908,3962),(71909,3962),(71910,3962),(71911,3962),(71912,3963),(71913,3963),(71914,3963),(71915,3963),(71916,3963),(71917,3963),(71918,3964),(71919,3964),(71920,3964),(71921,3964),(71922,3964),(71923,3964),(71924,3965),(71925,3965),(71926,3965),(71927,3965),(71928,3965),(71929,3965),(71930,3966),(71931,3966),(71932,3966),(71933,3966),(71934,3966),(71935,3966),(71936,3967),(71937,3967),(71938,3967),(71939,3967),(71940,3967),(71941,3967),(71942,3968),(71943,3968),(71944,3968),(71945,3968),(71946,3968),(71947,3968),(71948,3969),(71949,3969),(71950,3969),(71951,3969),(71952,3969),(71953,3969),(71954,3970),(71955,3970),(71956,3970),(71957,3970),(71958,3970),(71959,3970),(71960,3971),(71961,3971),(71962,3971),(71963,3971),(71964,3971),(71965,3971),(71966,3972),(71967,3972),(71968,3972),(71969,3972),(71970,3972),(71971,3972),(71972,3973),(71973,3973),(71974,3973),(71975,3973),(71976,3973),(71977,3973),(71978,3974),(71979,3974),(71980,3974),(71981,3974),(71982,3974),(71983,3974),(71984,3975),(71985,3975),(71986,3975),(71987,3975),(71988,3975),(71989,3975),(71990,3976),(71991,3976),(71992,3976),(71993,3976),(71994,3976),(71995,3976),(71996,3977),(71997,3977),(71998,3977),(71999,3977),(72000,3977),(72001,3977),(72002,3978),(72003,3978),(72004,3978),(72005,3978),(72006,3978),(72007,3978),(72008,3979),(72009,3979),(72010,3979),(72011,3979),(72012,3979),(72013,3979),(72014,3980),(72015,3980),(72016,3980),(72017,3980),(72018,3980),(72019,3980),(72020,3981),(72021,3981),(72022,3981),(72023,3981),(72024,3981),(72025,3981),(72026,3982),(72027,3982),(72028,3982),(72029,3982),(72030,3983),(72031,3983),(72032,3983),(72033,3983),(72034,3984),(72035,3984),(72036,3984),(72037,3984),(72038,3985),(72039,3985),(72040,3985),(72041,3985),(72042,3986),(72043,3986),(72044,3986),(72045,3986),(72046,3987),(72047,3987),(72048,3987),(72049,3987),(72050,3988),(72051,3988),(72052,3988),(72053,3988),(72054,3989),(72055,3989),(72056,3989),(72057,3989),(72058,3989),(72059,3989),(72060,3990),(72061,3990),(72062,3990),(72063,3990),(72064,3990),(72065,3990),(72066,3991),(72067,3991),(72068,3991),(72069,3991),(72070,3991),(72071,3991),(72072,3992),(72073,3992),(72074,3992),(72075,3992),(72076,3992),(72077,3992),(72078,3993),(72079,3993),(72080,3993),(72081,3993),(72082,3993),(72083,3993),(72084,3994),(72085,3994),(72086,3994),(72087,3994),(72088,3994),(72089,3994),(72090,3995),(72091,3995),(72092,3995),(72093,3995),(72094,3995),(72095,3995),(72096,3996),(72097,3996),(72098,3996),(72099,3996),(72100,3996),(72101,3996),(72102,3997),(72103,3997),(72104,3997),(72105,3997),(72106,3997),(72107,3997),(72108,3998),(72109,3998),(72110,3998),(72111,3998),(72112,3998),(72113,3998),(72114,3999),(72115,3999),(72116,3999),(72117,3999),(72118,3999),(72119,3999),(72120,4000),(72121,4000),(72122,4000),(72123,4000),(72124,4000),(72125,4000),(72126,4001),(72127,4001),(72128,4001),(72129,4001),(72130,4001),(72131,4001),(72132,4002),(72133,4002),(72134,4002),(72135,4002),(72136,4002),(72137,4002),(72138,4003),(72139,4003),(72140,4003),(72141,4003),(72142,4003),(72143,4003),(72144,4004),(72145,4004),(72146,4004),(72147,4004),(72148,4004),(72149,4004),(72150,4005),(72151,4005),(72152,4005),(72153,4005),(72154,4005),(72155,4005),(72156,4006),(72157,4006),(72158,4006),(72159,4006),(72160,4006),(72161,4006),(72162,4007),(72163,4007),(72164,4007),(72165,4007),(72166,4007),(72167,4007),(72168,4008),(72169,4008),(72170,4008),(72171,4008),(72172,4008),(72173,4008),(72174,4009),(72175,4009),(72176,4009),(72177,4009),(72178,4009),(72179,4009),(72180,4010),(72181,4010),(72182,4010),(72183,4010),(72184,4010),(72185,4010),(72186,4011),(72187,4011),(72188,4011),(72189,4011),(72190,4011),(72191,4011),(72192,4012),(72193,4012),(72194,4012),(72195,4012),(72196,4012),(72197,4012),(72198,4013),(72199,4013),(72200,4013),(72201,4013),(72202,4013),(72203,4013),(72204,4014),(72205,4014),(72206,4014),(72207,4014),(72208,4014),(72209,4014),(72210,3915),(72211,3915),(72212,3916),(72213,3916),(72214,3917),(72215,3917),(72216,3918),(72217,3918),(72218,3919),(72219,3919),(72220,3920),(72221,3920),(72222,3921),(72223,3921),(72224,3922),(72225,3922),(72226,3923),(72227,3923),(72228,3924),(72229,3924),(72230,3925),(72231,3925),(72232,3926),(72233,3926),(72234,3927),(72235,3927),(72236,3928),(72237,3928),(72238,3929),(72239,3929),(72240,3930),(72241,3930),(72242,3931),(72243,3931),(72244,3932),(72245,3932),(72246,3933),(72247,3933),(72248,3934),(72249,3934),(72250,3935),(72251,3935),(72252,3936),(72253,3936),(72254,3937),(72255,3937),(72256,3938),(72257,3938),(72258,3939),(72259,3939),(72260,3940),(72261,3940),(72262,3941),(72263,3941),(72264,3942),(72265,3942),(72266,3943),(72267,3943),(72268,3944),(72269,3944),(72270,3945),(72271,3945),(72272,3946),(72273,3946),(72274,3947),(72275,3947),(72276,3948),(72277,3948),(72278,3949),(72279,3949),(72280,3950),(72281,3950),(72282,3951),(72283,3951),(72284,3952),(72285,3952),(72286,3953),(72287,3953),(72288,3954),(72289,3954),(72290,3955),(72291,3955),(72292,3956),(72293,3956),(72294,3957),(72295,3957),(72296,3958),(72297,3958),(72298,3959),(72299,3959),(72300,3960),(72301,3960),(72302,3961),(72303,3961),(72304,3962),(72305,3962),(72306,3963),(72307,3963),(72308,3964),(72309,3964),(72310,3965),(72311,3965),(72312,3966),(72313,3966),(72314,3967),(72315,3967),(72316,3968),(72317,3968),(72318,3969),(72319,3969),(72320,3970),(72321,3970),(72322,3971),(72323,3971),(72324,3972),(72325,3972),(72326,3973),(72327,3973),(72328,3974),(72329,3974),(72330,3975),(72331,3975),(72332,3976),(72333,3976),(72334,3977),(72335,3977),(72336,3978),(72337,3978),(72338,3979),(72339,3979),(72340,3980),(72341,3980),(72342,3981),(72343,3981),(72344,3982),(72345,3983),(72346,3984),(72347,3985),(72348,3986),(72349,3987),(72350,3988),(72351,3989),(72352,3989),(72353,3990),(72354,3990),(72355,3991),(72356,3991),(72357,3992),(72358,3992),(72359,3993),(72360,3993),(72361,3994),(72362,3994),(72363,3995),(72364,3995),(72365,3996),(72366,3996),(72367,3997),(72368,3997),(72369,3998),(72370,3998),(72371,3999),(72372,3999),(72373,4000),(72374,4000),(72375,4001),(72376,4001),(72377,4002),(72378,4002),(72379,4003),(72380,4003),(72381,4004),(72382,4004),(72383,4005),(72384,4005),(72385,4006),(72386,4006),(72387,4007),(72388,4007),(72389,4008),(72390,4008),(72391,4009),(72392,4009),(72393,4010),(72394,4010),(72395,4011),(72396,4011),(72397,4012),(72398,4012),(72399,4013),(72400,4013),(72401,4014),(72402,4014),(72403,3915),(72404,3915),(72405,3915),(72406,3916),(72407,3916),(72408,3916),(72409,3917),(72410,3917),(72411,3917),(72412,3918),(72413,3918),(72414,3918),(72415,3919),(72416,3919),(72417,3920),(72418,3920),(72419,3921),(72420,3921),(72421,3922),(72422,3922),(72423,3923),(72424,3923),(72425,3923),(72426,3924),(72427,3924),(72428,3924),(72429,3925),(72430,3925),(72431,3925),(72432,3926),(72433,3926),(72434,3926),(72435,3927),(72436,3927),(72437,3927),(72438,3928),(72439,3928),(72440,3928),(72441,3929),(72442,3929),(72443,3929),(72444,3930),(72445,3930),(72446,3930),(72447,3931),(72448,3931),(72449,3931),(72450,3932),(72451,3932),(72452,3932),(72453,3933),(72454,3933),(72455,3933),(72456,3934),(72457,3934),(72458,3934),(72459,3935),(72460,3935),(72461,3935),(72462,3936),(72463,3936),(72464,3936),(72465,3937),(72466,3937),(72467,3937),(72468,3938),(72469,3938),(72470,3938),(72471,3939),(72472,3939),(72473,3939),(72474,3940),(72475,3940),(72476,3940),(72477,3941),(72478,3941),(72479,3941),(72480,3942),(72481,3942),(72482,3942),(72483,3943),(72484,3943),(72485,3943),(72486,3944),(72487,3944),(72488,3944),(72489,3945),(72490,3945),(72491,3945),(72492,3946),(72493,3946),(72494,3946),(72495,3947),(72496,3947),(72497,3947),(72498,3948),(72499,3948),(72500,3948),(72501,3949),(72502,3949),(72503,3949),(72504,3950),(72505,3950),(72506,3950),(72507,3951),(72508,3951),(72509,3951),(72510,3952),(72511,3952),(72512,3952),(72513,3953),(72514,3953),(72515,3953),(72516,3954),(72517,3954),(72518,3954),(72519,3955),(72520,3955),(72521,3955),(72522,3956),(72523,3956),(72524,3956),(72525,3957),(72526,3957),(72527,3957),(72528,3958),(72529,3958),(72530,3958),(72531,3959),(72532,3959),(72533,3959),(72534,3960),(72535,3960),(72536,3960),(72537,3961),(72538,3961),(72539,3961),(72540,3962),(72541,3962),(72542,3962),(72543,3963),(72544,3963),(72545,3963),(72546,3964),(72547,3964),(72548,3964),(72549,3965),(72550,3965),(72551,3965),(72552,3966),(72553,3966),(72554,3966),(72555,3967),(72556,3967),(72557,3967),(72558,3968),(72559,3968),(72560,3968),(72561,3969),(72562,3969),(72563,3969),(72564,3970),(72565,3970),(72566,3970),(72567,3971),(72568,3971),(72569,3971),(72570,3972),(72571,3972),(72572,3972),(72573,3973),(72574,3973),(72575,3973),(72576,3974),(72577,3974),(72578,3974),(72579,3975),(72580,3975),(72581,3975),(72582,3976),(72583,3976),(72584,3976),(72585,3977),(72586,3977),(72587,3977),(72588,3978),(72589,3978),(72590,3978),(72591,3979),(72592,3979),(72593,3979),(72594,3980),(72595,3980),(72596,3980),(72597,3981),(72598,3981),(72599,3981),(72600,3982),(72601,3982),(72602,3982),(72603,3983),(72604,3983),(72605,3983),(72606,3984),(72607,3984),(72608,3984),(72609,3985),(72610,3985),(72611,3985),(72612,3986),(72613,3986),(72614,3986),(72615,3987),(72616,3987),(72617,3987),(72618,3988),(72619,3988),(72620,3988),(72621,3989),(72622,3989),(72623,3989),(72624,3990),(72625,3990),(72626,3990),(72627,3991),(72628,3991),(72629,3991),(72630,3992),(72631,3992),(72632,3992),(72633,3993),(72634,3993),(72635,3993),(72636,3994),(72637,3994),(72638,3994),(72639,3995),(72640,3995),(72641,3995),(72642,3996),(72643,3996),(72644,3996),(72645,3997),(72646,3997),(72647,3997),(72648,3998),(72649,3998),(72650,3998),(72651,3999),(72652,3999),(72653,3999),(72654,4000),(72655,4000),(72656,4000),(72657,4001),(72658,4001),(72659,4001),(72660,4002),(72661,4002),(72662,4002),(72663,4003),(72664,4003),(72665,4003),(72666,4004),(72667,4004),(72668,4004),(72669,4005),(72670,4005),(72671,4005),(72672,4006),(72673,4006),(72674,4006),(72675,4007),(72676,4007),(72677,4007),(72678,4008),(72679,4008),(72680,4008),(72681,4009),(72682,4009),(72683,4009),(72684,4010),(72685,4010),(72686,4010),(72687,4011),(72688,4011),(72689,4011),(72690,4012),(72691,4012),(72692,4012),(72693,4013),(72694,4013),(72695,4013),(72696,4014),(72697,4014),(72698,4014),(72699,3915),(72700,3915),(72701,3915),(72702,3915),(72703,3916),(72704,3916),(72705,3916),(72706,3916),(72707,3917),(72708,3917),(72709,3917),(72710,3917),(72711,3918),(72712,3918),(72713,3918),(72714,3918),(72715,3919),(72716,3919),(72717,3919),(72718,3919),(72719,3920),(72720,3920),(72721,3920),(72722,3920),(72723,3921),(72724,3921),(72725,3921),(72726,3921),(72727,3922),(72728,3922),(72729,3922),(72730,3922),(72731,3923),(72732,3923),(72733,3923),(72734,3923),(72735,3924),(72736,3924),(72737,3924),(72738,3924),(72739,3925),(72740,3925),(72741,3925),(72742,3925),(72743,3926),(72744,3926),(72745,3926),(72746,3926),(72747,3927),(72748,3927),(72749,3927),(72750,3927),(72751,3928),(72752,3928),(72753,3928),(72754,3928),(72755,3929),(72756,3929),(72757,3929),(72758,3929),(72759,3930),(72760,3930),(72761,3930),(72762,3930),(72763,3931),(72764,3931),(72765,3931),(72766,3931),(72767,3932),(72768,3932),(72769,3932),(72770,3932),(72771,3933),(72772,3933),(72773,3933),(72774,3933),(72775,3934),(72776,3934),(72777,3934),(72778,3934),(72779,3935),(72780,3935),(72781,3935),(72782,3935),(72783,3936),(72784,3936),(72785,3936),(72786,3936),(72787,3937),(72788,3937),(72789,3937),(72790,3937),(72791,3938),(72792,3938),(72793,3938),(72794,3938),(72795,3939),(72796,3939),(72797,3939),(72798,3939),(72799,3940),(72800,3940),(72801,3940),(72802,3940),(72803,3941),(72804,3941),(72805,3941),(72806,3941),(72807,3942),(72808,3942),(72809,3942),(72810,3942),(72811,3943),(72812,3943),(72813,3943),(72814,3943),(72815,3944),(72816,3944),(72817,3944),(72818,3944),(72819,3945),(72820,3945),(72821,3945),(72822,3945),(72823,3946),(72824,3946),(72825,3946),(72826,3946),(72827,3947),(72828,3947),(72829,3947),(72830,3947),(72831,3948),(72832,3948),(72833,3948),(72834,3948),(72835,3949),(72836,3949),(72837,3949),(72838,3949),(72839,3950),(72840,3950),(72841,3950),(72842,3950),(72843,3951),(72844,3951),(72845,3951),(72846,3951),(72847,3952),(72848,3952),(72849,3952),(72850,3952),(72851,3953),(72852,3953),(72853,3953),(72854,3953),(72855,3954),(72856,3954),(72857,3954),(72858,3954),(72859,3955),(72860,3955),(72861,3955),(72862,3955),(72863,3956),(72864,3956),(72865,3956),(72866,3956),(72867,3957),(72868,3957),(72869,3957),(72870,3957),(72871,3958),(72872,3958),(72873,3958),(72874,3958),(72875,3959),(72876,3959),(72877,3959),(72878,3959),(72879,3960),(72880,3960),(72881,3960),(72882,3960),(72883,3961),(72884,3961),(72885,3961),(72886,3961),(72887,3962),(72888,3962),(72889,3962),(72890,3962),(72891,3963),(72892,3963),(72893,3963),(72894,3963),(72895,3964),(72896,3964),(72897,3964),(72898,3964),(72899,3965),(72900,3965),(72901,3965),(72902,3965),(72903,3966),(72904,3966),(72905,3966),(72906,3966),(72907,3967),(72908,3967),(72909,3967),(72910,3967),(72911,3968),(72912,3968),(72913,3968),(72914,3968),(72915,3969),(72916,3969),(72917,3969),(72918,3969),(72919,3970),(72920,3970),(72921,3970),(72922,3970),(72923,3971),(72924,3971),(72925,3971),(72926,3971),(72927,3972),(72928,3972),(72929,3972),(72930,3972),(72931,3973),(72932,3973),(72933,3973),(72934,3973),(72935,3974),(72936,3974),(72937,3974),(72938,3974),(72939,3975),(72940,3975),(72941,3975),(72942,3975),(72943,3976),(72944,3976),(72945,3976),(72946,3976),(72947,3977),(72948,3977),(72949,3977),(72950,3977),(72951,3978),(72952,3978),(72953,3978),(72954,3978),(72955,3979),(72956,3979),(72957,3979),(72958,3979),(72959,3980),(72960,3980),(72961,3980),(72962,3980),(72963,3981),(72964,3981),(72965,3981),(72966,3981),(72967,3982),(72968,3982),(72969,3982),(72970,3982),(72971,3983),(72972,3983),(72973,3983),(72974,3983),(72975,3984),(72976,3984),(72977,3984),(72978,3984),(72979,3985),(72980,3985),(72981,3985),(72982,3985),(72983,3986),(72984,3986),(72985,3986),(72986,3986),(72987,3987),(72988,3987),(72989,3987),(72990,3987),(72991,3988),(72992,3988),(72993,3988),(72994,3988),(72995,3989),(72996,3989),(72997,3989),(72998,3989),(72999,3990),(73000,3990),(73001,3990),(73002,3990),(73003,3991),(73004,3991),(73005,3991),(73006,3991),(73007,3992),(73008,3992),(73009,3992),(73010,3992),(73011,3993),(73012,3993),(73013,3993),(73014,3993),(73015,3994),(73016,3994),(73017,3994),(73018,3994),(73019,3995),(73020,3995),(73021,3995),(73022,3995),(73023,3996),(73024,3996),(73025,3996),(73026,3996),(73027,3997),(73028,3997),(73029,3997),(73030,3997),(73031,3998),(73032,3998),(73033,3998),(73034,3998),(73035,3999),(73036,3999),(73037,3999),(73038,3999),(73039,4000),(73040,4000),(73041,4000),(73042,4000),(73043,4001),(73044,4001),(73045,4001),(73046,4001),(73047,4002),(73048,4002),(73049,4002),(73050,4002),(73051,4003),(73052,4003),(73053,4003),(73054,4003),(73055,4004),(73056,4004),(73057,4004),(73058,4004),(73059,4005),(73060,4005),(73061,4005),(73062,4005),(73063,4006),(73064,4006),(73065,4006),(73066,4006),(73067,4007),(73068,4007),(73069,4007),(73070,4007),(73071,4008),(73072,4008),(73073,4008),(73074,4008),(73075,4009),(73076,4009),(73077,4009),(73078,4009),(73079,4010),(73080,4010),(73081,4010),(73082,4010),(73083,4011),(73084,4011),(73085,4011),(73086,4011),(73087,4012),(73088,4012),(73089,4012),(73090,4012),(73091,4013),(73092,4013),(73093,4013),(73094,4013),(73095,4014),(73096,4014),(73097,4014),(73098,4014),(73099,4015),(73100,4016),(73101,4017),(73102,4018),(73103,4019),(73104,4020),(73105,4021),(73106,4022),(73107,4023),(73108,4024),(73109,4025),(73110,4026),(73111,4027),(73112,4028),(73113,4029),(73114,4030),(73115,4031),(73116,4032),(73117,4033),(73118,4034),(73119,4035),(73120,4036),(73121,4037),(73122,4038),(73123,4039),(73124,4040),(73125,4041),(73126,4042),(73127,4043),(73128,4044),(73129,4045),(73130,4046),(73131,4047),(73132,4048),(73133,4049),(73134,4050),(73135,4051),(73136,4052),(73137,4053),(73138,4054),(73139,4055),(73140,4056),(73141,4057),(73142,4058),(73143,4059),(73144,4060),(73145,4061),(73146,4062),(73147,4063),(73148,4064),(73149,4065),(73150,4066),(73151,4067),(73152,4068),(73153,4069),(73154,4070),(73155,4071),(73156,4072),(73157,4073),(73158,4074),(73159,4075),(73160,4076),(73161,4077),(73162,4078),(73163,4079),(73164,4080),(73165,4081),(73166,4082),(73167,4083),(73168,4084),(73169,4085),(73170,4086),(73171,4087),(73172,4088),(73173,4089),(73174,4090),(73175,4091),(73176,4092),(73177,4093),(73178,4094),(73179,4095),(73180,4096),(73181,4097),(73182,4098),(73183,4099),(73184,4100),(73185,4101),(73186,4102),(73187,4103),(73188,4104),(73189,4105),(73190,4106),(73191,4107),(73192,4108),(73193,4109),(73194,4110),(73195,4111),(73196,4112),(73197,4113),(73198,4114),(73199,4015),(73200,4016),(73201,4017),(73202,4018),(73203,4019),(73204,4020),(73205,4021),(73206,4022),(73207,4023),(73208,4024),(73209,4025),(73210,4026),(73211,4027),(73212,4028),(73213,4029),(73214,4030),(73215,4031),(73216,4032),(73217,4033),(73218,4034),(73219,4035),(73220,4036),(73221,4037),(73222,4038),(73223,4039),(73224,4040),(73225,4041),(73226,4042),(73227,4043),(73228,4044),(73229,4045),(73230,4046),(73231,4047),(73232,4048),(73233,4049),(73234,4050),(73235,4051),(73236,4052),(73237,4053),(73238,4054),(73239,4055),(73240,4056),(73241,4057),(73242,4058),(73243,4059),(73244,4060),(73245,4061),(73246,4062),(73247,4063),(73248,4064),(73249,4065),(73250,4066),(73251,4067),(73252,4068),(73253,4069),(73254,4070),(73255,4071),(73256,4072),(73257,4073),(73258,4074),(73259,4075),(73260,4076),(73261,4077),(73262,4078),(73263,4079),(73264,4080),(73265,4081),(73266,4082),(73267,4083),(73268,4084),(73269,4085),(73270,4086),(73271,4087),(73272,4088),(73273,4089),(73274,4090),(73275,4091),(73276,4092),(73277,4093),(73278,4094),(73279,4095),(73280,4096),(73281,4097),(73282,4098),(73283,4099),(73284,4100),(73285,4101),(73286,4102),(73287,4103),(73288,4104),(73289,4105),(73290,4106),(73291,4107),(73292,4108),(73293,4109),(73294,4110),(73295,4111),(73296,4112),(73297,4113),(73298,4114),(73299,4015),(73300,4015),(73301,4015),(73302,4015),(73303,4015),(73304,4015),(73305,4016),(73306,4016),(73307,4016),(73308,4016),(73309,4016),(73310,4016),(73311,4017),(73312,4017),(73313,4017),(73314,4017),(73315,4017),(73316,4017),(73317,4018),(73318,4018),(73319,4018),(73320,4018),(73321,4018),(73322,4018),(73323,4019),(73324,4019),(73325,4019),(73326,4019),(73327,4019),(73328,4019),(73329,4020),(73330,4020),(73331,4020),(73332,4020),(73333,4020),(73334,4020),(73335,4021),(73336,4021),(73337,4021),(73338,4021),(73339,4021),(73340,4021),(73341,4022),(73342,4022),(73343,4022),(73344,4022),(73345,4022),(73346,4022),(73347,4023),(73348,4023),(73349,4023),(73350,4023),(73351,4023),(73352,4023),(73353,4024),(73354,4024),(73355,4024),(73356,4024),(73357,4024),(73358,4024),(73359,4025),(73360,4025),(73361,4025),(73362,4025),(73363,4025),(73364,4025),(73365,4026),(73366,4026),(73367,4026),(73368,4026),(73369,4026),(73370,4026),(73371,4027),(73372,4027),(73373,4027),(73374,4027),(73375,4027),(73376,4027),(73377,4028),(73378,4028),(73379,4028),(73380,4028),(73381,4028),(73382,4028),(73383,4029),(73384,4029),(73385,4029),(73386,4029),(73387,4029),(73388,4029),(73389,4030),(73390,4030),(73391,4030),(73392,4030),(73393,4030),(73394,4030),(73395,4031),(73396,4031),(73397,4031),(73398,4031),(73399,4031),(73400,4031),(73401,4032),(73402,4032),(73403,4032),(73404,4032),(73405,4032),(73406,4032),(73407,4033),(73408,4033),(73409,4033),(73410,4033),(73411,4033),(73412,4033),(73413,4034),(73414,4034),(73415,4034),(73416,4034),(73417,4034),(73418,4034),(73419,4035),(73420,4035),(73421,4035),(73422,4035),(73423,4035),(73424,4035),(73425,4036),(73426,4036),(73427,4036),(73428,4036),(73429,4036),(73430,4036),(73431,4037),(73432,4037),(73433,4037),(73434,4037),(73435,4037),(73436,4037),(73437,4038),(73438,4038),(73439,4038),(73440,4038),(73441,4038),(73442,4038),(73443,4039),(73444,4039),(73445,4039),(73446,4039),(73447,4039),(73448,4039),(73449,4040),(73450,4040),(73451,4040),(73452,4040),(73453,4040),(73454,4040),(73455,4041),(73456,4041),(73457,4041),(73458,4041),(73459,4041),(73460,4041),(73461,4042),(73462,4042),(73463,4042),(73464,4042),(73465,4042),(73466,4042),(73467,4043),(73468,4043),(73469,4043),(73470,4043),(73471,4043),(73472,4043),(73473,4044),(73474,4044),(73475,4044),(73476,4044),(73477,4044),(73478,4044),(73479,4045),(73480,4045),(73481,4045),(73482,4045),(73483,4045),(73484,4045),(73485,4046),(73486,4046),(73487,4046),(73488,4046),(73489,4046),(73490,4046),(73491,4047),(73492,4047),(73493,4047),(73494,4047),(73495,4047),(73496,4047),(73497,4048),(73498,4048),(73499,4048),(73500,4048),(73501,4048),(73502,4048),(73503,4049),(73504,4049),(73505,4049),(73506,4049),(73507,4049),(73508,4049),(73509,4050),(73510,4050),(73511,4050),(73512,4050),(73513,4050),(73514,4050),(73515,4051),(73516,4051),(73517,4051),(73518,4051),(73519,4051),(73520,4051),(73521,4052),(73522,4052),(73523,4052),(73524,4052),(73525,4052),(73526,4052),(73527,4053),(73528,4053),(73529,4053),(73530,4053),(73531,4053),(73532,4053),(73533,4054),(73534,4054),(73535,4054),(73536,4054),(73537,4054),(73538,4054),(73539,4055),(73540,4055),(73541,4055),(73542,4055),(73543,4055),(73544,4055),(73545,4056),(73546,4056),(73547,4056),(73548,4056),(73549,4056),(73550,4056),(73551,4057),(73552,4057),(73553,4057),(73554,4057),(73555,4057),(73556,4057),(73557,4058),(73558,4058),(73559,4058),(73560,4058),(73561,4058),(73562,4058),(73563,4059),(73564,4059),(73565,4059),(73566,4059),(73567,4059),(73568,4059),(73569,4060),(73570,4060),(73571,4060),(73572,4060),(73573,4060),(73574,4060),(73575,4061),(73576,4061),(73577,4061),(73578,4061),(73579,4061),(73580,4061),(73581,4062),(73582,4062),(73583,4062),(73584,4062),(73585,4062),(73586,4062),(73587,4063),(73588,4063),(73589,4063),(73590,4063),(73591,4063),(73592,4063),(73593,4064),(73594,4064),(73595,4064),(73596,4064),(73597,4064),(73598,4064),(73599,4065),(73600,4065),(73601,4065),(73602,4065),(73603,4065),(73604,4065),(73605,4066),(73606,4066),(73607,4066),(73608,4066),(73609,4066),(73610,4066),(73611,4067),(73612,4067),(73613,4067),(73614,4067),(73615,4067),(73616,4067),(73617,4068),(73618,4068),(73619,4068),(73620,4068),(73621,4068),(73622,4068),(73623,4069),(73624,4069),(73625,4069),(73626,4069),(73627,4069),(73628,4069),(73629,4070),(73630,4070),(73631,4070),(73632,4070),(73633,4070),(73634,4070),(73635,4071),(73636,4071),(73637,4071),(73638,4071),(73639,4071),(73640,4071),(73641,4072),(73642,4072),(73643,4072),(73644,4072),(73645,4072),(73646,4072),(73647,4073),(73648,4073),(73649,4073),(73650,4073),(73651,4073),(73652,4073),(73653,4074),(73654,4074),(73655,4074),(73656,4074),(73657,4074),(73658,4074),(73659,4075),(73660,4075),(73661,4075),(73662,4075),(73663,4075),(73664,4075),(73665,4076),(73666,4076),(73667,4076),(73668,4076),(73669,4076),(73670,4076),(73671,4077),(73672,4077),(73673,4077),(73674,4077),(73675,4077),(73676,4077),(73677,4078),(73678,4078),(73679,4078),(73680,4078),(73681,4078),(73682,4078),(73683,4079),(73684,4079),(73685,4079),(73686,4079),(73687,4079),(73688,4079),(73689,4080),(73690,4080),(73691,4080),(73692,4080),(73693,4080),(73694,4080),(73695,4081),(73696,4081),(73697,4081),(73698,4081),(73699,4081),(73700,4081),(73701,4082),(73702,4082),(73703,4082),(73704,4082),(73705,4082),(73706,4082),(73707,4083),(73708,4083),(73709,4083),(73710,4083),(73711,4083),(73712,4083),(73713,4084),(73714,4084),(73715,4084),(73716,4084),(73717,4084),(73718,4084),(73719,4085),(73720,4085),(73721,4085),(73722,4085),(73723,4085),(73724,4085),(73725,4086),(73726,4086),(73727,4086),(73728,4086),(73729,4086),(73730,4086),(73731,4087),(73732,4087),(73733,4087),(73734,4087),(73735,4087),(73736,4087),(73737,4088),(73738,4088),(73739,4088),(73740,4088),(73741,4088),(73742,4088),(73743,4089),(73744,4089),(73745,4089),(73746,4089),(73747,4089),(73748,4089),(73749,4090),(73750,4090),(73751,4090),(73752,4090),(73753,4090),(73754,4090),(73755,4091),(73756,4091),(73757,4091),(73758,4091),(73759,4091),(73760,4091),(73761,4092),(73762,4092),(73763,4092),(73764,4092),(73765,4092),(73766,4092),(73767,4093),(73768,4093),(73769,4093),(73770,4093),(73771,4093),(73772,4093),(73773,4094),(73774,4094),(73775,4094),(73776,4094),(73777,4094),(73778,4094),(73779,4095),(73780,4095),(73781,4095),(73782,4095),(73783,4095),(73784,4095),(73785,4096),(73786,4096),(73787,4096),(73788,4096),(73789,4096),(73790,4096),(73791,4097),(73792,4097),(73793,4097),(73794,4097),(73795,4097),(73796,4097),(73797,4098),(73798,4098),(73799,4098),(73800,4098),(73801,4098),(73802,4098),(73803,4099),(73804,4099),(73805,4099),(73806,4099),(73807,4099),(73808,4099),(73809,4100),(73810,4100),(73811,4100),(73812,4100),(73813,4100),(73814,4100),(73815,4101),(73816,4101),(73817,4101),(73818,4101),(73819,4101),(73820,4101),(73821,4102),(73822,4102),(73823,4102),(73824,4102),(73825,4102),(73826,4102),(73827,4103),(73828,4103),(73829,4103),(73830,4103),(73831,4103),(73832,4103),(73833,4104),(73834,4104),(73835,4104),(73836,4104),(73837,4104),(73838,4104),(73839,4105),(73840,4105),(73841,4105),(73842,4105),(73843,4105),(73844,4105),(73845,4106),(73846,4106),(73847,4106),(73848,4106),(73849,4106),(73850,4106),(73851,4107),(73852,4107),(73853,4107),(73854,4107),(73855,4107),(73856,4107),(73857,4108),(73858,4108),(73859,4108),(73860,4108),(73861,4108),(73862,4108),(73863,4109),(73864,4109),(73865,4109),(73866,4109),(73867,4109),(73868,4109),(73869,4110),(73870,4110),(73871,4110),(73872,4110),(73873,4110),(73874,4110),(73875,4111),(73876,4111),(73877,4111),(73878,4111),(73879,4111),(73880,4111),(73881,4112),(73882,4112),(73883,4112),(73884,4112),(73885,4112),(73886,4112),(73887,4113),(73888,4113),(73889,4113),(73890,4113),(73891,4113),(73892,4113),(73893,4114),(73894,4114),(73895,4114),(73896,4114),(73897,4114),(73898,4114),(73899,4015),(73900,4015),(73901,4016),(73902,4016),(73903,4017),(73904,4017),(73905,4018),(73906,4018),(73907,4019),(73908,4019),(73909,4020),(73910,4020),(73911,4021),(73912,4021),(73913,4022),(73914,4022),(73915,4023),(73916,4023),(73917,4024),(73918,4024),(73919,4025),(73920,4025),(73921,4026),(73922,4026),(73923,4027),(73924,4027),(73925,4028),(73926,4028),(73927,4029),(73928,4029),(73929,4030),(73930,4030),(73931,4031),(73932,4031),(73933,4032),(73934,4032),(73935,4033),(73936,4033),(73937,4034),(73938,4034),(73939,4035),(73940,4035),(73941,4036),(73942,4036),(73943,4037),(73944,4037),(73945,4038),(73946,4038),(73947,4039),(73948,4039),(73949,4040),(73950,4040),(73951,4041),(73952,4041),(73953,4042),(73954,4042),(73955,4043),(73956,4043),(73957,4044),(73958,4044),(73959,4045),(73960,4045),(73961,4046),(73962,4046),(73963,4047),(73964,4047),(73965,4048),(73966,4048),(73967,4049),(73968,4049),(73969,4050),(73970,4050),(73971,4051),(73972,4051),(73973,4052),(73974,4052),(73975,4053),(73976,4053),(73977,4054),(73978,4054),(73979,4055),(73980,4055),(73981,4056),(73982,4056),(73983,4057),(73984,4057),(73985,4058),(73986,4058),(73987,4059),(73988,4059),(73989,4060),(73990,4060),(73991,4061),(73992,4061),(73993,4062),(73994,4062),(73995,4063),(73996,4063),(73997,4064),(73998,4064),(73999,4065),(74000,4065),(74001,4066),(74002,4066),(74003,4067),(74004,4067),(74005,4068),(74006,4068),(74007,4069),(74008,4069),(74009,4070),(74010,4070),(74011,4071),(74012,4071),(74013,4072),(74014,4072),(74015,4073),(74016,4073),(74017,4074),(74018,4074),(74019,4075),(74020,4075),(74021,4076),(74022,4076),(74023,4077),(74024,4077),(74025,4078),(74026,4078),(74027,4079),(74028,4079),(74029,4080),(74030,4080),(74031,4081),(74032,4081),(74033,4082),(74034,4082),(74035,4083),(74036,4083),(74037,4084),(74038,4084),(74039,4085),(74040,4085),(74041,4086),(74042,4086),(74043,4087),(74044,4087),(74045,4088),(74046,4088),(74047,4089),(74048,4089),(74049,4090),(74050,4090),(74051,4091),(74052,4091),(74053,4091),(74054,4092),(74055,4092),(74056,4093),(74057,4093),(74058,4094),(74059,4094),(74060,4095),(74061,4095),(74062,4096),(74063,4096),(74064,4097),(74065,4097),(74066,4098),(74067,4098),(74068,4099),(74069,4099),(74070,4100),(74071,4100),(74072,4101),(74073,4101),(74074,4102),(74075,4102),(74076,4103),(74077,4103),(74078,4104),(74079,4104),(74080,4105),(74081,4105),(74082,4106),(74083,4106),(74084,4107),(74085,4107),(74086,4108),(74087,4108),(74088,4109),(74089,4109),(74090,4110),(74091,4110),(74092,4111),(74093,4111),(74094,4112),(74095,4112),(74096,4113),(74097,4113),(74098,4114),(74099,4114),(74100,4015),(74101,4015),(74102,4015),(74103,4016),(74104,4016),(74105,4016),(74106,4017),(74107,4017),(74108,4017),(74109,4018),(74110,4018),(74111,4018),(74112,4019),(74113,4019),(74114,4019),(74115,4020),(74116,4020),(74117,4020),(74118,4021),(74119,4021),(74120,4021),(74121,4022),(74122,4022),(74123,4022),(74124,4023),(74125,4023),(74126,4023),(74127,4024),(74128,4024),(74129,4024),(74130,4025),(74131,4025),(74132,4025),(74133,4026),(74134,4026),(74135,4026),(74136,4027),(74137,4027),(74138,4027),(74139,4028),(74140,4028),(74141,4028),(74142,4029),(74143,4029),(74144,4029),(74145,4030),(74146,4030),(74147,4030),(74148,4031),(74149,4031),(74150,4031),(74151,4032),(74152,4032),(74153,4032),(74154,4033),(74155,4033),(74156,4033),(74157,4034),(74158,4034),(74159,4034),(74160,4035),(74161,4035),(74162,4035),(74163,4036),(74164,4036),(74165,4036),(74166,4037),(74167,4037),(74168,4037),(74169,4038),(74170,4038),(74171,4038),(74172,4039),(74173,4039),(74174,4039),(74175,4040),(74176,4040),(74177,4040),(74178,4041),(74179,4041),(74180,4041),(74181,4042),(74182,4042),(74183,4042),(74184,4043),(74185,4043),(74186,4044),(74187,4044),(74188,4044),(74189,4045),(74190,4045),(74191,4045),(74192,4046),(74193,4046),(74194,4046),(74195,4047),(74196,4047),(74197,4047),(74198,4048),(74199,4048),(74200,4048),(74201,4049),(74202,4049),(74203,4049),(74204,4050),(74205,4050),(74206,4050),(74207,4051),(74208,4051),(74209,4051),(74210,4052),(74211,4052),(74212,4052),(74213,4053),(74214,4053),(74215,4053),(74216,4054),(74217,4054),(74218,4055),(74219,4055),(74220,4056),(74221,4056),(74222,4056),(74223,4057),(74224,4057),(74225,4057),(74226,4058),(74227,4058),(74228,4058),(74229,4059),(74230,4059),(74231,4059),(74232,4060),(74233,4060),(74234,4060),(74235,4061),(74236,4061),(74237,4061),(74238,4062),(74239,4062),(74240,4062),(74241,4063),(74242,4063),(74243,4063),(74244,4064),(74245,4064),(74246,4064),(74247,4065),(74248,4065),(74249,4065),(74250,4066),(74251,4066),(74252,4066),(74253,4067),(74254,4067),(74255,4067),(74256,4068),(74257,4068),(74258,4068),(74259,4069),(74260,4069),(74261,4069),(74262,4070),(74263,4070),(74264,4070),(74265,4071),(74266,4071),(74267,4071),(74268,4072),(74269,4072),(74270,4072),(74271,4073),(74272,4073),(74273,4073),(74274,4074),(74275,4074),(74276,4074),(74277,4075),(74278,4075),(74279,4076),(74280,4076),(74281,4077),(74282,4077),(74283,4078),(74284,4078),(74285,4079),(74286,4079),(74287,4079),(74288,4080),(74289,4080),(74290,4080),(74291,4081),(74292,4081),(74293,4081),(74294,4082),(74295,4082),(74296,4082),(74297,4083),(74298,4083),(74299,4083),(74300,4084),(74301,4084),(74302,4084),(74303,4085),(74304,4085),(74305,4085),(74306,4086),(74307,4086),(74308,4086),(74309,4087),(74310,4087),(74311,4087),(74312,4088),(74313,4088),(74314,4088),(74315,4089),(74316,4089),(74317,4089),(74318,4090),(74319,4090),(74320,4090),(74321,4091),(74322,4091),(74323,4091),(74324,4092),(74325,4092),(74326,4093),(74327,4093),(74328,4094),(74329,4094),(74330,4095),(74331,4095),(74332,4096),(74333,4096),(74334,4097),(74335,4097),(74336,4098),(74337,4098),(74338,4098),(74339,4099),(74340,4099),(74341,4099),(74342,4100),(74343,4100),(74344,4100),(74345,4101),(74346,4101),(74347,4101),(74348,4102),(74349,4102),(74350,4102),(74351,4103),(74352,4103),(74353,4103),(74354,4104),(74355,4104),(74356,4104),(74357,4105),(74358,4105),(74359,4105),(74360,4106),(74361,4106),(74362,4106),(74363,4107),(74364,4107),(74365,4107),(74366,4108),(74367,4108),(74368,4108),(74369,4109),(74370,4109),(74371,4109),(74372,4110),(74373,4110),(74374,4110),(74375,4111),(74376,4111),(74377,4111),(74378,4112),(74379,4112),(74380,4112),(74381,4113),(74382,4113),(74383,4113),(74384,4114),(74385,4114),(74386,4114),(74387,4015),(74388,4015),(74389,4015),(74390,4015),(74391,4016),(74392,4016),(74393,4016),(74394,4016),(74395,4017),(74396,4017),(74397,4017),(74398,4017),(74399,4018),(74400,4018),(74401,4018),(74402,4018),(74403,4019),(74404,4019),(74405,4019),(74406,4019),(74407,4020),(74408,4020),(74409,4020),(74410,4020),(74411,4021),(74412,4021),(74413,4021),(74414,4021),(74415,4022),(74416,4022),(74417,4022),(74418,4022),(74419,4023),(74420,4023),(74421,4023),(74422,4023),(74423,4024),(74424,4024),(74425,4024),(74426,4024),(74427,4025),(74428,4025),(74429,4025),(74430,4025),(74431,4026),(74432,4026),(74433,4026),(74434,4026),(74435,4027),(74436,4027),(74437,4027),(74438,4027),(74439,4028),(74440,4028),(74441,4028),(74442,4028),(74443,4029),(74444,4029),(74445,4029),(74446,4029),(74447,4030),(74448,4030),(74449,4030),(74450,4030),(74451,4031),(74452,4031),(74453,4031),(74454,4031),(74455,4032),(74456,4032),(74457,4032),(74458,4032),(74459,4033),(74460,4033),(74461,4033),(74462,4033),(74463,4034),(74464,4034),(74465,4034),(74466,4034),(74467,4035),(74468,4035),(74469,4035),(74470,4035),(74471,4036),(74472,4036),(74473,4036),(74474,4036),(74475,4037),(74476,4037),(74477,4037),(74478,4037),(74479,4038),(74480,4038),(74481,4038),(74482,4038),(74483,4039),(74484,4039),(74485,4039),(74486,4039),(74487,4040),(74488,4040),(74489,4040),(74490,4040),(74491,4041),(74492,4041),(74493,4041),(74494,4041),(74495,4042),(74496,4042),(74497,4042),(74498,4042),(74499,4043),(74500,4043),(74501,4043),(74502,4043),(74503,4044),(74504,4044),(74505,4044),(74506,4044),(74507,4045),(74508,4045),(74509,4045),(74510,4045),(74511,4046),(74512,4046),(74513,4046),(74514,4046),(74515,4047),(74516,4047),(74517,4047),(74518,4047),(74519,4048),(74520,4048),(74521,4048),(74522,4048),(74523,4049),(74524,4049),(74525,4049),(74526,4049),(74527,4050),(74528,4050),(74529,4050),(74530,4050),(74531,4051),(74532,4051),(74533,4051),(74534,4051),(74535,4052),(74536,4052),(74537,4052),(74538,4052),(74539,4053),(74540,4053),(74541,4053),(74542,4053),(74543,4054),(74544,4054),(74545,4054),(74546,4054),(74547,4055),(74548,4055),(74549,4055),(74550,4055),(74551,4056),(74552,4056),(74553,4056),(74554,4056),(74555,4057),(74556,4057),(74557,4057),(74558,4057),(74559,4058),(74560,4058),(74561,4058),(74562,4058),(74563,4059),(74564,4059),(74565,4059),(74566,4059),(74567,4060),(74568,4060),(74569,4060),(74570,4060),(74571,4061),(74572,4061),(74573,4061),(74574,4061),(74575,4062),(74576,4062),(74577,4062),(74578,4062),(74579,4063),(74580,4063),(74581,4063),(74582,4063),(74583,4064),(74584,4064),(74585,4064),(74586,4064),(74587,4065),(74588,4065),(74589,4065),(74590,4065),(74591,4066),(74592,4066),(74593,4066),(74594,4066),(74595,4067),(74596,4067),(74597,4067),(74598,4067),(74599,4068),(74600,4068),(74601,4068),(74602,4068),(74603,4069),(74604,4069),(74605,4069),(74606,4069),(74607,4070),(74608,4070),(74609,4070),(74610,4070),(74611,4071),(74612,4071),(74613,4071),(74614,4071),(74615,4072),(74616,4072),(74617,4072),(74618,4072),(74619,4073),(74620,4073),(74621,4073),(74622,4073),(74623,4074),(74624,4074),(74625,4074),(74626,4074),(74627,4075),(74628,4075),(74629,4075),(74630,4075),(74631,4076),(74632,4076),(74633,4076),(74634,4076),(74635,4077),(74636,4077),(74637,4077),(74638,4077),(74639,4078),(74640,4078),(74641,4078),(74642,4078),(74643,4079),(74644,4079),(74645,4079),(74646,4079),(74647,4080),(74648,4080),(74649,4080),(74650,4080),(74651,4081),(74652,4081),(74653,4081),(74654,4081),(74655,4082),(74656,4082),(74657,4082),(74658,4082),(74659,4083),(74660,4083),(74661,4083),(74662,4083),(74663,4084),(74664,4084),(74665,4084),(74666,4084),(74667,4085),(74668,4085),(74669,4085),(74670,4085),(74671,4086),(74672,4086),(74673,4086),(74674,4086),(74675,4087),(74676,4087),(74677,4087),(74678,4087),(74679,4088),(74680,4088),(74681,4088),(74682,4088),(74683,4089),(74684,4089),(74685,4089),(74686,4089),(74687,4090),(74688,4090),(74689,4090),(74690,4090),(74691,4091),(74692,4091),(74693,4091),(74694,4091),(74695,4092),(74696,4092),(74697,4092),(74698,4092),(74699,4093),(74700,4093),(74701,4093),(74702,4093),(74703,4094),(74704,4094),(74705,4094),(74706,4094),(74707,4095),(74708,4095),(74709,4095),(74710,4095),(74711,4096),(74712,4096),(74713,4096),(74714,4096),(74715,4097),(74716,4097),(74717,4097),(74718,4097),(74719,4098),(74720,4098),(74721,4098),(74722,4098),(74723,4099),(74724,4099),(74725,4099),(74726,4099),(74727,4100),(74728,4100),(74729,4100),(74730,4100),(74731,4101),(74732,4101),(74733,4101),(74734,4101),(74735,4102),(74736,4102),(74737,4102),(74738,4102),(74739,4103),(74740,4103),(74741,4103),(74742,4103),(74743,4104),(74744,4104),(74745,4104),(74746,4104),(74747,4105),(74748,4105),(74749,4105),(74750,4105),(74751,4106),(74752,4106),(74753,4106),(74754,4106),(74755,4107),(74756,4107),(74757,4107),(74758,4107),(74759,4108),(74760,4108),(74761,4108),(74762,4108),(74763,4109),(74764,4109),(74765,4109),(74766,4109),(74767,4110),(74768,4110),(74769,4110),(74770,4110),(74771,4111),(74772,4111),(74773,4111),(74774,4111),(74775,4112),(74776,4112),(74777,4112),(74778,4112),(74779,4113),(74780,4113),(74781,4113),(74782,4113),(74783,4114),(74784,4114),(74785,4114),(74786,4114),(74787,4115),(74788,4116),(74789,4117),(74790,4118),(74791,4119),(74792,4120),(74793,4121),(74794,4122),(74795,4123),(74796,4124),(74797,4125),(74798,4126),(74799,4127),(74800,4128),(74801,4129),(74802,4130),(74803,4131),(74804,4132),(74805,4133),(74806,4134),(74807,4135),(74808,4136),(74809,4137),(74810,4138),(74811,4139),(74812,4140),(74813,4141),(74814,4142),(74815,4143),(74816,4144),(74817,4145),(74818,4146),(74819,4147),(74820,4148),(74821,4149),(74822,4150),(74823,4151),(74824,4152),(74825,4153),(74826,4154),(74827,4155),(74828,4156),(74829,4157),(74830,4158),(74831,4159),(74832,4160),(74833,4161),(74834,4162),(74835,4163),(74836,4164),(74837,4165),(74838,4166),(74839,4167),(74840,4168),(74841,4169),(74842,4170),(74843,4171),(74844,4172),(74845,4173),(74846,4174),(74847,4175),(74848,4176),(74849,4177),(74850,4178),(74851,4179),(74852,4180),(74853,4181),(74854,4182),(74855,4183),(74856,4184),(74857,4185),(74858,4186),(74859,4187),(74860,4188),(74861,4189),(74862,4190),(74863,4191),(74864,4192),(74865,4193),(74866,4194),(74867,4195),(74868,4196),(74869,4197),(74870,4198),(74871,4199),(74872,4200),(74873,4201),(74874,4202),(74875,4203),(74876,4204),(74877,4205),(74878,4206),(74879,4207),(74880,4208),(74881,4209),(74882,4210),(74883,4211),(74884,4212),(74885,4213),(74886,4115),(74887,4116),(74888,4117),(74889,4118),(74890,4119),(74891,4120),(74892,4121),(74893,4122),(74894,4123),(74895,4124),(74896,4125),(74897,4126),(74898,4127),(74899,4128),(74900,4129),(74901,4130),(74902,4131),(74903,4132),(74904,4133),(74905,4134),(74906,4135),(74907,4136),(74908,4137),(74909,4138),(74910,4139),(74911,4140),(74912,4141),(74913,4142),(74914,4143),(74915,4144),(74916,4145),(74917,4146),(74918,4147),(74919,4148),(74920,4149),(74921,4150),(74922,4151),(74923,4152),(74924,4153),(74925,4154),(74926,4155),(74927,4156),(74928,4157),(74929,4158),(74930,4159),(74931,4160),(74932,4161),(74933,4162),(74934,4163),(74935,4164),(74936,4165),(74937,4166),(74938,4167),(74939,4168),(74940,4169),(74941,4170),(74942,4171),(74943,4172),(74944,4173),(74945,4174),(74946,4175),(74947,4176),(74948,4177),(74949,4178),(74950,4179),(74951,4180),(74952,4181),(74953,4182),(74954,4183),(74955,4184),(74956,4185),(74957,4186),(74958,4187),(74959,4188),(74960,4189),(74961,4190),(74962,4191),(74963,4192),(74964,4193),(74965,4194),(74966,4195),(74967,4196),(74968,4197),(74969,4198),(74970,4199),(74971,4200),(74972,4201),(74973,4202),(74974,4203),(74975,4204),(74976,4205),(74977,4206),(74978,4207),(74979,4208),(74980,4209),(74981,4210),(74982,4211),(74983,4212),(74984,4213),(74985,4115),(74986,4115),(74987,4115),(74988,4115),(74989,4115),(74990,4115),(74991,4116),(74992,4116),(74993,4116),(74994,4116),(74995,4116),(74996,4116),(74997,4117),(74998,4117),(74999,4117),(75000,4117),(75001,4117),(75002,4117),(75003,4118),(75004,4118),(75005,4118),(75006,4118),(75007,4118),(75008,4118),(75009,4119),(75010,4119),(75011,4119),(75012,4119),(75013,4119),(75014,4119),(75015,4120),(75016,4120),(75017,4120),(75018,4120),(75019,4120),(75020,4120),(75021,4121),(75022,4121),(75023,4121),(75024,4121),(75025,4121),(75026,4121),(75027,4122),(75028,4122),(75029,4122),(75030,4122),(75031,4122),(75032,4122),(75033,4123),(75034,4123),(75035,4123),(75036,4123),(75037,4123),(75038,4123),(75039,4124),(75040,4124),(75041,4124),(75042,4124),(75043,4124),(75044,4124),(75045,4125),(75046,4125),(75047,4125),(75048,4125),(75049,4125),(75050,4125),(75051,4126),(75052,4126),(75053,4126),(75054,4126),(75055,4126),(75056,4126),(75057,4127),(75058,4127),(75059,4127),(75060,4127),(75061,4127),(75062,4127),(75063,4128),(75064,4128),(75065,4128),(75066,4128),(75067,4128),(75068,4128),(75069,4129),(75070,4129),(75071,4129),(75072,4129),(75073,4129),(75074,4129),(75075,4130),(75076,4130),(75077,4130),(75078,4130),(75079,4130),(75080,4130),(75081,4131),(75082,4131),(75083,4131),(75084,4131),(75085,4131),(75086,4131),(75087,4132),(75088,4132),(75089,4132),(75090,4132),(75091,4132),(75092,4132),(75093,4133),(75094,4133),(75095,4133),(75096,4133),(75097,4133),(75098,4133),(75099,4134),(75100,4134),(75101,4134),(75102,4134),(75103,4134),(75104,4134),(75105,4135),(75106,4135),(75107,4135),(75108,4135),(75109,4135),(75110,4135),(75111,4136),(75112,4136),(75113,4136),(75114,4136),(75115,4136),(75116,4136),(75117,4137),(75118,4137),(75119,4137),(75120,4137),(75121,4137),(75122,4137),(75123,4138),(75124,4138),(75125,4138),(75126,4138),(75127,4138),(75128,4138),(75129,4139),(75130,4139),(75131,4139),(75132,4139),(75133,4139),(75134,4139),(75135,4140),(75136,4140),(75137,4140),(75138,4140),(75139,4140),(75140,4140),(75141,4141),(75142,4141),(75143,4141),(75144,4141),(75145,4141),(75146,4141),(75147,4142),(75148,4142),(75149,4142),(75150,4142),(75151,4142),(75152,4142),(75153,4143),(75154,4143),(75155,4143),(75156,4143),(75157,4143),(75158,4143),(75159,4144),(75160,4144),(75161,4144),(75162,4144),(75163,4144),(75164,4144),(75165,4145),(75166,4145),(75167,4145),(75168,4145),(75169,4145),(75170,4145),(75171,4146),(75172,4146),(75173,4146),(75174,4146),(75175,4146),(75176,4146),(75177,4147),(75178,4147),(75179,4147),(75180,4147),(75181,4147),(75182,4147),(75183,4148),(75184,4148),(75185,4148),(75186,4148),(75187,4148),(75188,4148),(75189,4149),(75190,4149),(75191,4149),(75192,4149),(75193,4149),(75194,4149),(75195,4150),(75196,4150),(75197,4150),(75198,4150),(75199,4150),(75200,4150),(75201,4151),(75202,4151),(75203,4151),(75204,4151),(75205,4151),(75206,4151),(75207,4152),(75208,4152),(75209,4152),(75210,4152),(75211,4152),(75212,4152),(75213,4153),(75214,4153),(75215,4153),(75216,4153),(75217,4153),(75218,4153),(75219,4154),(75220,4154),(75221,4154),(75222,4154),(75223,4154),(75224,4154),(75225,4155),(75226,4155),(75227,4155),(75228,4155),(75229,4155),(75230,4155),(75231,4156),(75232,4156),(75233,4156),(75234,4156),(75235,4156),(75236,4156),(75237,4157),(75238,4157),(75239,4157),(75240,4157),(75241,4157),(75242,4157),(75243,4158),(75244,4158),(75245,4158),(75246,4158),(75247,4158),(75248,4158),(75249,4159),(75250,4159),(75251,4159),(75252,4159),(75253,4159),(75254,4159),(75255,4160),(75256,4160),(75257,4160),(75258,4160),(75259,4160),(75260,4160),(75261,4161),(75262,4161),(75263,4161),(75264,4161),(75265,4161),(75266,4161),(75267,4162),(75268,4162),(75269,4162),(75270,4162),(75271,4162),(75272,4162),(75273,4163),(75274,4163),(75275,4163),(75276,4163),(75277,4163),(75278,4163),(75279,4164),(75280,4164),(75281,4164),(75282,4164),(75283,4164),(75284,4164),(75285,4165),(75286,4165),(75287,4165),(75288,4165),(75289,4165),(75290,4165),(75291,4166),(75292,4166),(75293,4166),(75294,4166),(75295,4166),(75296,4166),(75297,4167),(75298,4167),(75299,4167),(75300,4167),(75301,4167),(75302,4167),(75303,4168),(75304,4168),(75305,4168),(75306,4168),(75307,4168),(75308,4168),(75309,4169),(75310,4169),(75311,4169),(75312,4169),(75313,4169),(75314,4169),(75315,4170),(75316,4170),(75317,4170),(75318,4170),(75319,4170),(75320,4170),(75321,4171),(75322,4171),(75323,4171),(75324,4171),(75325,4171),(75326,4171),(75327,4172),(75328,4172),(75329,4172),(75330,4172),(75331,4172),(75332,4172),(75333,4173),(75334,4173),(75335,4173),(75336,4173),(75337,4173),(75338,4173),(75339,4174),(75340,4174),(75341,4174),(75342,4174),(75343,4174),(75344,4174),(75345,4175),(75346,4175),(75347,4175),(75348,4175),(75349,4175),(75350,4175),(75351,4176),(75352,4176),(75353,4176),(75354,4176),(75355,4176),(75356,4176),(75357,4177),(75358,4177),(75359,4177),(75360,4177),(75361,4177),(75362,4177),(75363,4178),(75364,4178),(75365,4178),(75366,4178),(75367,4178),(75368,4178),(75369,4179),(75370,4179),(75371,4179),(75372,4179),(75373,4179),(75374,4179),(75375,4180),(75376,4180),(75377,4180),(75378,4180),(75379,4180),(75380,4180),(75381,4181),(75382,4181),(75383,4181),(75384,4181),(75385,4181),(75386,4181),(75387,4182),(75388,4182),(75389,4182),(75390,4182),(75391,4182),(75392,4182),(75393,4183),(75394,4183),(75395,4183),(75396,4183),(75397,4183),(75398,4183),(75399,4184),(75400,4184),(75401,4184),(75402,4184),(75403,4184),(75404,4184),(75405,4185),(75406,4185),(75407,4185),(75408,4185),(75409,4185),(75410,4185),(75411,4186),(75412,4186),(75413,4186),(75414,4186),(75415,4186),(75416,4186),(75417,4187),(75418,4187),(75419,4187),(75420,4187),(75421,4187),(75422,4187),(75423,4188),(75424,4188),(75425,4188),(75426,4188),(75427,4188),(75428,4188),(75429,4189),(75430,4189),(75431,4189),(75432,4189),(75433,4189),(75434,4189),(75435,4190),(75436,4190),(75437,4190),(75438,4190),(75439,4190),(75440,4190),(75441,4191),(75442,4191),(75443,4191),(75444,4191),(75445,4191),(75446,4191),(75447,4192),(75448,4192),(75449,4192),(75450,4192),(75451,4192),(75452,4192),(75453,4193),(75454,4193),(75455,4193),(75456,4193),(75457,4193),(75458,4193),(75459,4194),(75460,4194),(75461,4194),(75462,4194),(75463,4194),(75464,4194),(75465,4195),(75466,4195),(75467,4195),(75468,4195),(75469,4195),(75470,4195),(75471,4196),(75472,4196),(75473,4196),(75474,4196),(75475,4196),(75476,4196),(75477,4197),(75478,4197),(75479,4197),(75480,4197),(75481,4197),(75482,4197),(75483,4198),(75484,4198),(75485,4198),(75486,4198),(75487,4198),(75488,4198),(75489,4199),(75490,4199),(75491,4199),(75492,4199),(75493,4199),(75494,4199),(75495,4200),(75496,4200),(75497,4200),(75498,4200),(75499,4200),(75500,4200),(75501,4201),(75502,4201),(75503,4201),(75504,4201),(75505,4201),(75506,4201),(75507,4202),(75508,4202),(75509,4202),(75510,4202),(75511,4202),(75512,4202),(75513,4203),(75514,4203),(75515,4203),(75516,4203),(75517,4203),(75518,4203),(75519,4204),(75520,4204),(75521,4204),(75522,4204),(75523,4204),(75524,4204),(75525,4205),(75526,4205),(75527,4205),(75528,4205),(75529,4205),(75530,4205),(75531,4206),(75532,4206),(75533,4206),(75534,4206),(75535,4206),(75536,4206),(75537,4207),(75538,4207),(75539,4207),(75540,4207),(75541,4207),(75542,4207),(75543,4208),(75544,4208),(75545,4208),(75546,4208),(75547,4208),(75548,4208),(75549,4209),(75550,4209),(75551,4209),(75552,4209),(75553,4209),(75554,4209),(75555,4210),(75556,4210),(75557,4210),(75558,4210),(75559,4210),(75560,4210),(75561,4211),(75562,4211),(75563,4211),(75564,4211),(75565,4211),(75566,4211),(75567,4212),(75568,4212),(75569,4212),(75570,4212),(75571,4212),(75572,4212),(75573,4213),(75574,4213),(75575,4213),(75576,4213),(75577,4213),(75578,4213),(75579,4115),(75580,4115),(75581,4116),(75582,4116),(75583,4117),(75584,4117),(75585,4118),(75586,4118),(75587,4119),(75588,4119),(75589,4120),(75590,4120),(75591,4121),(75592,4121),(75593,4122),(75594,4122),(75595,4123),(75596,4123),(75597,4124),(75598,4124),(75599,4125),(75600,4125),(75601,4126),(75602,4126),(75603,4127),(75604,4127),(75605,4128),(75606,4128),(75607,4129),(75608,4129),(75609,4130),(75610,4130),(75611,4131),(75612,4131),(75613,4132),(75614,4132),(75615,4133),(75616,4133),(75617,4134),(75618,4134),(75619,4135),(75620,4135),(75621,4136),(75622,4136),(75623,4137),(75624,4137),(75625,4138),(75626,4138),(75627,4139),(75628,4139),(75629,4140),(75630,4140),(75631,4141),(75632,4141),(75633,4142),(75634,4142),(75635,4143),(75636,4143),(75637,4144),(75638,4144),(75639,4145),(75640,4145),(75641,4146),(75642,4146),(75643,4147),(75644,4147),(75645,4148),(75646,4148),(75647,4149),(75648,4149),(75649,4150),(75650,4150),(75651,4151),(75652,4151),(75653,4152),(75654,4152),(75655,4153),(75656,4153),(75657,4154),(75658,4154),(75659,4155),(75660,4155),(75661,4156),(75662,4156),(75663,4157),(75664,4157),(75665,4158),(75666,4158),(75667,4159),(75668,4159),(75669,4160),(75670,4160),(75671,4161),(75672,4161),(75673,4162),(75674,4162),(75675,4163),(75676,4163),(75677,4164),(75678,4164),(75679,4165),(75680,4165),(75681,4166),(75682,4166),(75683,4167),(75684,4167),(75685,4168),(75686,4168),(75687,4169),(75688,4169),(75689,4170),(75690,4170),(75691,4171),(75692,4171),(75693,4172),(75694,4172),(75695,4173),(75696,4173),(75697,4174),(75698,4174),(75699,4175),(75700,4175),(75701,4176),(75702,4176),(75703,4177),(75704,4177),(75705,4178),(75706,4178),(75707,4179),(75708,4179),(75709,4180),(75710,4180),(75711,4181),(75712,4181),(75713,4182),(75714,4182),(75715,4183),(75716,4183),(75717,4184),(75718,4184),(75719,4185),(75720,4185),(75721,4186),(75722,4186),(75723,4187),(75724,4187),(75725,4188),(75726,4188),(75727,4189),(75728,4189),(75729,4190),(75730,4190),(75731,4191),(75732,4191),(75733,4192),(75734,4192),(75735,4193),(75736,4193),(75737,4194),(75738,4194),(75739,4195),(75740,4195),(75741,4196),(75742,4196),(75743,4197),(75744,4197),(75745,4198),(75746,4198),(75747,4199),(75748,4199),(75749,4200),(75750,4200),(75751,4201),(75752,4201),(75753,4202),(75754,4202),(75755,4203),(75756,4203),(75757,4204),(75758,4204),(75759,4205),(75760,4205),(75761,4206),(75762,4206),(75763,4207),(75764,4207),(75765,4208),(75766,4208),(75767,4209),(75768,4209),(75769,4210),(75770,4210),(75771,4211),(75772,4211),(75773,4212),(75774,4212),(75775,4213),(75776,4213),(75777,4115),(75778,4115),(75779,4115),(75780,4116),(75781,4116),(75782,4116),(75783,4117),(75784,4117),(75785,4117),(75786,4118),(75787,4118),(75788,4118),(75789,4119),(75790,4119),(75791,4119),(75792,4120),(75793,4120),(75794,4121),(75795,4121),(75796,4121),(75797,4122),(75798,4122),(75799,4122),(75800,4123),(75801,4123),(75802,4123),(75803,4124),(75804,4124),(75805,4124),(75806,4125),(75807,4125),(75808,4125),(75809,4126),(75810,4126),(75811,4126),(75812,4127),(75813,4127),(75814,4127),(75815,4128),(75816,4128),(75817,4128),(75818,4129),(75819,4129),(75820,4129),(75821,4130),(75822,4130),(75823,4130),(75824,4131),(75825,4131),(75826,4131),(75827,4132),(75828,4132),(75829,4132),(75830,4133),(75831,4133),(75832,4133),(75833,4134),(75834,4134),(75835,4134),(75836,4135),(75837,4135),(75838,4135),(75839,4136),(75840,4136),(75841,4136),(75842,4137),(75843,4137),(75844,4137),(75845,4138),(75846,4138),(75847,4138),(75848,4139),(75849,4139),(75850,4139),(75851,4140),(75852,4140),(75853,4140),(75854,4141),(75855,4141),(75856,4141),(75857,4142),(75858,4142),(75859,4143),(75860,4143),(75861,4144),(75862,4144),(75863,4144),(75864,4145),(75865,4145),(75866,4145),(75867,4146),(75868,4146),(75869,4146),(75870,4147),(75871,4147),(75872,4147),(75873,4148),(75874,4148),(75875,4148),(75876,4149),(75877,4149),(75878,4149),(75879,4150),(75880,4150),(75881,4151),(75882,4151),(75883,4152),(75884,4152),(75885,4152),(75886,4153),(75887,4153),(75888,4153),(75889,4154),(75890,4154),(75891,4154),(75892,4155),(75893,4155),(75894,4155),(75895,4156),(75896,4156),(75897,4156),(75898,4157),(75899,4157),(75900,4157),(75901,4158),(75902,4158),(75903,4158),(75904,4159),(75905,4159),(75906,4159),(75907,4160),(75908,4160),(75909,4160),(75910,4161),(75911,4161),(75912,4161),(75913,4162),(75914,4162),(75915,4163),(75916,4163),(75917,4163),(75918,4164),(75919,4164),(75920,4164),(75921,4165),(75922,4165),(75923,4165),(75924,4166),(75925,4166),(75926,4166),(75927,4167),(75928,4167),(75929,4167),(75930,4168),(75931,4168),(75932,4168),(75933,4169),(75934,4169),(75935,4169),(75936,4170),(75937,4170),(75938,4170),(75939,4171),(75940,4171),(75941,4171),(75942,4172),(75943,4172),(75944,4172),(75945,4173),(75946,4173),(75947,4173),(75948,4174),(75949,4174),(75950,4174),(75951,4175),(75952,4175),(75953,4175),(75954,4176),(75955,4176),(75956,4176),(75957,4177),(75958,4177),(75959,4177),(75960,4178),(75961,4178),(75962,4178),(75963,4179),(75964,4179),(75965,4179),(75966,4180),(75967,4180),(75968,4180),(75969,4181),(75970,4181),(75971,4181),(75972,4182),(75973,4182),(75974,4182),(75975,4183),(75976,4183),(75977,4183),(75978,4184),(75979,4184),(75980,4184),(75981,4185),(75982,4185),(75983,4185),(75984,4186),(75985,4186),(75986,4186),(75987,4187),(75988,4187),(75989,4187),(75990,4188),(75991,4188),(75992,4188),(75993,4189),(75994,4189),(75995,4189),(75996,4190),(75997,4190),(75998,4190),(75999,4191),(76000,4191),(76001,4191),(76002,4192),(76003,4192),(76004,4192),(76005,4193),(76006,4193),(76007,4193),(76008,4194),(76009,4194),(76010,4194),(76011,4195),(76012,4195),(76013,4195),(76014,4196),(76015,4196),(76016,4196),(76017,4197),(76018,4197),(76019,4197),(76020,4198),(76021,4198),(76022,4198),(76023,4199),(76024,4199),(76025,4200),(76026,4200),(76027,4201),(76028,4201),(76029,4202),(76030,4202),(76031,4202),(76032,4203),(76033,4203),(76034,4203),(76035,4204),(76036,4204),(76037,4204),(76038,4205),(76039,4205),(76040,4205),(76041,4206),(76042,4206),(76043,4206),(76044,4207),(76045,4207),(76046,4207),(76047,4208),(76048,4208),(76049,4208),(76050,4209),(76051,4209),(76052,4209),(76053,4210),(76054,4210),(76055,4210),(76056,4211),(76057,4211),(76058,4211),(76059,4212),(76060,4212),(76061,4212),(76062,4213),(76063,4213),(76064,4213),(76065,4115),(76066,4115),(76067,4115),(76068,4115),(76069,4116),(76070,4116),(76071,4116),(76072,4116),(76073,4117),(76074,4117),(76075,4117),(76076,4117),(76077,4118),(76078,4118),(76079,4118),(76080,4118),(76081,4119),(76082,4119),(76083,4119),(76084,4119),(76085,4120),(76086,4120),(76087,4120),(76088,4120),(76089,4121),(76090,4121),(76091,4121),(76092,4121),(76093,4122),(76094,4122),(76095,4122),(76096,4122),(76097,4123),(76098,4123),(76099,4123),(76100,4123),(76101,4124),(76102,4124),(76103,4124),(76104,4124),(76105,4125),(76106,4125),(76107,4125),(76108,4125),(76109,4126),(76110,4126),(76111,4126),(76112,4126),(76113,4127),(76114,4127),(76115,4127),(76116,4127),(76117,4128),(76118,4128),(76119,4128),(76120,4128),(76121,4129),(76122,4129),(76123,4129),(76124,4129),(76125,4130),(76126,4130),(76127,4130),(76128,4130),(76129,4131),(76130,4131),(76131,4131),(76132,4131),(76133,4132),(76134,4132),(76135,4132),(76136,4132),(76137,4133),(76138,4133),(76139,4133),(76140,4133),(76141,4134),(76142,4134),(76143,4134),(76144,4134),(76145,4135),(76146,4135),(76147,4135),(76148,4135),(76149,4136),(76150,4136),(76151,4136),(76152,4136),(76153,4137),(76154,4137),(76155,4137),(76156,4137),(76157,4138),(76158,4138),(76159,4138),(76160,4138),(76161,4139),(76162,4139),(76163,4139),(76164,4139),(76165,4140),(76166,4140),(76167,4140),(76168,4140),(76169,4141),(76170,4141),(76171,4141),(76172,4141),(76173,4142),(76174,4142),(76175,4142),(76176,4142),(76177,4143),(76178,4143),(76179,4143),(76180,4143),(76181,4144),(76182,4144),(76183,4144),(76184,4144),(76185,4145),(76186,4145),(76187,4145),(76188,4145),(76189,4146),(76190,4146),(76191,4146),(76192,4146),(76193,4147),(76194,4147),(76195,4147),(76196,4147),(76197,4148),(76198,4148),(76199,4148),(76200,4148),(76201,4149),(76202,4149),(76203,4149),(76204,4149),(76205,4150),(76206,4150),(76207,4150),(76208,4150),(76209,4151),(76210,4151),(76211,4151),(76212,4151),(76213,4152),(76214,4152),(76215,4152),(76216,4152),(76217,4153),(76218,4153),(76219,4153),(76220,4153),(76221,4154),(76222,4154),(76223,4154),(76224,4154),(76225,4155),(76226,4155),(76227,4155),(76228,4155),(76229,4156),(76230,4156),(76231,4156),(76232,4156),(76233,4157),(76234,4157),(76235,4157),(76236,4157),(76237,4158),(76238,4158),(76239,4158),(76240,4158),(76241,4159),(76242,4159),(76243,4159),(76244,4159),(76245,4160),(76246,4160),(76247,4160),(76248,4160),(76249,4161),(76250,4161),(76251,4161),(76252,4161),(76253,4162),(76254,4162),(76255,4162),(76256,4162),(76257,4163),(76258,4163),(76259,4163),(76260,4163),(76261,4164),(76262,4164),(76263,4164),(76264,4164),(76265,4165),(76266,4165),(76267,4165),(76268,4165),(76269,4166),(76270,4166),(76271,4166),(76272,4166),(76273,4167),(76274,4167),(76275,4167),(76276,4167),(76277,4168),(76278,4168),(76279,4168),(76280,4168),(76281,4169),(76282,4169),(76283,4169),(76284,4169),(76285,4170),(76286,4170),(76287,4170),(76288,4170),(76289,4171),(76290,4171),(76291,4171),(76292,4171),(76293,4172),(76294,4172),(76295,4172),(76296,4172),(76297,4173),(76298,4173),(76299,4173),(76300,4173),(76301,4174),(76302,4174),(76303,4174),(76304,4174),(76305,4175),(76306,4175),(76307,4175),(76308,4175),(76309,4176),(76310,4176),(76311,4176),(76312,4176),(76313,4177),(76314,4177),(76315,4177),(76316,4177),(76317,4178),(76318,4178),(76319,4178),(76320,4178),(76321,4179),(76322,4179),(76323,4179),(76324,4179),(76325,4180),(76326,4180),(76327,4180),(76328,4180),(76329,4181),(76330,4181),(76331,4181),(76332,4181),(76333,4182),(76334,4182),(76335,4182),(76336,4182),(76337,4183),(76338,4183),(76339,4183),(76340,4183),(76341,4184),(76342,4184),(76343,4184),(76344,4184),(76345,4185),(76346,4185),(76347,4185),(76348,4185),(76349,4186),(76350,4186),(76351,4186),(76352,4186),(76353,4187),(76354,4187),(76355,4187),(76356,4187),(76357,4188),(76358,4188),(76359,4188),(76360,4188),(76361,4189),(76362,4189),(76363,4189),(76364,4189),(76365,4190),(76366,4190),(76367,4190),(76368,4190),(76369,4191),(76370,4191),(76371,4191),(76372,4191),(76373,4192),(76374,4192),(76375,4192),(76376,4192),(76377,4193),(76378,4193),(76379,4193),(76380,4193),(76381,4194),(76382,4194),(76383,4194),(76384,4194),(76385,4195),(76386,4195),(76387,4195),(76388,4195),(76389,4196),(76390,4196),(76391,4196),(76392,4196),(76393,4197),(76394,4197),(76395,4197),(76396,4197),(76397,4198),(76398,4198),(76399,4198),(76400,4198),(76401,4199),(76402,4199),(76403,4199),(76404,4199),(76405,4200),(76406,4200),(76407,4200),(76408,4200),(76409,4201),(76410,4201),(76411,4201),(76412,4201),(76413,4202),(76414,4202),(76415,4202),(76416,4202),(76417,4203),(76418,4203),(76419,4203),(76420,4203),(76421,4204),(76422,4204),(76423,4204),(76424,4204),(76425,4205),(76426,4205),(76427,4205),(76428,4205),(76429,4206),(76430,4206),(76431,4206),(76432,4206),(76433,4207),(76434,4207),(76435,4207),(76436,4207),(76437,4208),(76438,4208),(76439,4208),(76440,4208),(76441,4209),(76442,4209),(76443,4209),(76444,4209),(76445,4210),(76446,4210),(76447,4210),(76448,4210),(76449,4211),(76450,4211),(76451,4211),(76452,4211),(76453,4212),(76454,4212),(76455,4212),(76456,4212),(76457,4213),(76458,4213),(76459,4213),(76460,4213),(76461,4214),(76462,4215),(76463,4216),(76464,4217),(76465,4218),(76466,4219),(76467,4220),(76468,4221),(76469,4222),(76470,4223),(76471,4224),(76472,4225),(76473,4226),(76474,4227),(76475,4228),(76476,4229),(76477,4230),(76478,4231),(76479,4232),(76480,4233),(76481,4234),(76482,4235),(76483,4236),(76484,4237),(76485,4238),(76486,4239),(76487,4240),(76488,4241),(76489,4242),(76490,4243),(76491,4244),(76492,4245),(76493,4246),(76494,4247),(76495,4248),(76496,4249),(76497,4250),(76498,4251),(76499,4252),(76500,4253),(76501,4254),(76502,4255),(76503,4256),(76504,4257),(76505,4258),(76506,4259),(76507,4260),(76508,4261),(76509,4262),(76510,4263),(76511,4264),(76512,4265),(76513,4266),(76514,4267),(76515,4268),(76516,4269),(76517,4270),(76518,4271),(76519,4272),(76520,4273),(76521,4274),(76522,4275),(76523,4276),(76524,4277),(76525,4278),(76526,4279),(76527,4280),(76528,4281),(76529,4282),(76530,4283),(76531,4284),(76532,4285),(76533,4286),(76534,4287),(76535,4288),(76536,4289),(76537,4290),(76538,4291),(76539,4292),(76540,4293),(76541,4294),(76542,4295),(76543,4296),(76544,4297),(76545,4298),(76546,4299),(76547,4300),(76548,4301),(76549,4302),(76550,4303),(76551,4304),(76552,4305),(76553,4306),(76554,4307),(76555,4308),(76556,4309),(76557,4310),(76558,4311),(76559,4312),(76560,4313),(76561,4214),(76562,4215),(76563,4216),(76564,4217),(76565,4218),(76566,4219),(76567,4220),(76568,4221),(76569,4222),(76570,4223),(76571,4224),(76572,4225),(76573,4226),(76574,4227),(76575,4228),(76576,4229),(76577,4230),(76578,4231),(76579,4232),(76580,4233),(76581,4234),(76582,4235),(76583,4236),(76584,4237),(76585,4238),(76586,4239),(76587,4240),(76588,4241),(76589,4242),(76590,4243),(76591,4244),(76592,4245),(76593,4246),(76594,4247),(76595,4248),(76596,4249),(76597,4250),(76598,4251),(76599,4252),(76600,4253),(76601,4254),(76602,4255),(76603,4256),(76604,4257),(76605,4258),(76606,4259),(76607,4260),(76608,4261),(76609,4262),(76610,4263),(76611,4264),(76612,4265),(76613,4266),(76614,4267),(76615,4268),(76616,4269),(76617,4270),(76618,4271),(76619,4272),(76620,4273),(76621,4274),(76622,4275),(76623,4276),(76624,4277),(76625,4278),(76626,4279),(76627,4280),(76628,4281),(76629,4282),(76630,4283),(76631,4284),(76632,4285),(76633,4286),(76634,4287),(76635,4288),(76636,4289),(76637,4290),(76638,4291),(76639,4292),(76640,4293),(76641,4294),(76642,4295),(76643,4296),(76644,4297),(76645,4298),(76646,4299),(76647,4300),(76648,4301),(76649,4302),(76650,4303),(76651,4304),(76652,4305),(76653,4306),(76654,4307),(76655,4308),(76656,4309),(76657,4310),(76658,4311),(76659,4312),(76660,4313),(76661,4214),(76662,4214),(76663,4214),(76664,4214),(76665,4214),(76666,4214),(76667,4215),(76668,4215),(76669,4215),(76670,4215),(76671,4215),(76672,4215),(76673,4216),(76674,4216),(76675,4216),(76676,4216),(76677,4216),(76678,4216),(76679,4217),(76680,4217),(76681,4217),(76682,4217),(76683,4217),(76684,4217),(76685,4218),(76686,4218),(76687,4218),(76688,4218),(76689,4218),(76690,4218),(76691,4219),(76692,4219),(76693,4219),(76694,4219),(76695,4219),(76696,4219),(76697,4220),(76698,4220),(76699,4220),(76700,4220),(76701,4220),(76702,4220),(76703,4221),(76704,4221),(76705,4221),(76706,4221),(76707,4221),(76708,4221),(76709,4222),(76710,4222),(76711,4222),(76712,4222),(76713,4222),(76714,4222),(76715,4223),(76716,4223),(76717,4223),(76718,4223),(76719,4223),(76720,4223),(76721,4224),(76722,4224),(76723,4224),(76724,4224),(76725,4224),(76726,4224),(76727,4225),(76728,4225),(76729,4225),(76730,4225),(76731,4225),(76732,4225),(76733,4226),(76734,4226),(76735,4226),(76736,4226),(76737,4226),(76738,4226),(76739,4227),(76740,4227),(76741,4227),(76742,4227),(76743,4227),(76744,4227),(76745,4228),(76746,4228),(76747,4228),(76748,4228),(76749,4228),(76750,4228),(76751,4229),(76752,4229),(76753,4229),(76754,4229),(76755,4229),(76756,4229),(76757,4230),(76758,4230),(76759,4230),(76760,4230),(76761,4230),(76762,4230),(76763,4231),(76764,4231),(76765,4231),(76766,4231),(76767,4231),(76768,4231),(76769,4232),(76770,4232),(76771,4232),(76772,4232),(76773,4232),(76774,4232),(76775,4233),(76776,4233),(76777,4233),(76778,4233),(76779,4233),(76780,4233),(76781,4234),(76782,4234),(76783,4234),(76784,4234),(76785,4234),(76786,4234),(76787,4235),(76788,4235),(76789,4235),(76790,4235),(76791,4235),(76792,4235),(76793,4236),(76794,4236),(76795,4236),(76796,4236),(76797,4236),(76798,4236),(76799,4237),(76800,4237),(76801,4237),(76802,4237),(76803,4237),(76804,4237),(76805,4238),(76806,4238),(76807,4238),(76808,4238),(76809,4238),(76810,4238),(76811,4239),(76812,4239),(76813,4239),(76814,4239),(76815,4239),(76816,4239),(76817,4240),(76818,4240),(76819,4240),(76820,4240),(76821,4240),(76822,4240),(76823,4241),(76824,4241),(76825,4241),(76826,4241),(76827,4241),(76828,4241),(76829,4242),(76830,4242),(76831,4242),(76832,4242),(76833,4242),(76834,4242),(76835,4243),(76836,4243),(76837,4243),(76838,4243),(76839,4243),(76840,4243),(76841,4244),(76842,4244),(76843,4244),(76844,4244),(76845,4244),(76846,4244),(76847,4245),(76848,4245),(76849,4245),(76850,4245),(76851,4245),(76852,4245),(76853,4246),(76854,4246),(76855,4246),(76856,4246),(76857,4246),(76858,4246),(76859,4247),(76860,4247),(76861,4247),(76862,4247),(76863,4247),(76864,4247),(76865,4248),(76866,4248),(76867,4248),(76868,4248),(76869,4248),(76870,4248),(76871,4249),(76872,4249),(76873,4249),(76874,4249),(76875,4249),(76876,4249),(76877,4250),(76878,4250),(76879,4250),(76880,4250),(76881,4250),(76882,4250),(76883,4251),(76884,4251),(76885,4251),(76886,4251),(76887,4251),(76888,4251),(76889,4252),(76890,4252),(76891,4252),(76892,4252),(76893,4252),(76894,4252),(76895,4253),(76896,4253),(76897,4253),(76898,4253),(76899,4253),(76900,4253),(76901,4254),(76902,4254),(76903,4254),(76904,4254),(76905,4254),(76906,4254),(76907,4255),(76908,4255),(76909,4255),(76910,4255),(76911,4255),(76912,4255),(76913,4256),(76914,4256),(76915,4256),(76916,4256),(76917,4256),(76918,4256),(76919,4257),(76920,4257),(76921,4257),(76922,4257),(76923,4257),(76924,4257),(76925,4258),(76926,4258),(76927,4258),(76928,4258),(76929,4258),(76930,4258),(76931,4259),(76932,4259),(76933,4259),(76934,4259),(76935,4259),(76936,4259),(76937,4260),(76938,4260),(76939,4260),(76940,4260),(76941,4260),(76942,4260),(76943,4261),(76944,4261),(76945,4261),(76946,4261),(76947,4261),(76948,4261),(76949,4262),(76950,4262),(76951,4262),(76952,4262),(76953,4262),(76954,4262),(76955,4263),(76956,4263),(76957,4263),(76958,4263),(76959,4263),(76960,4263),(76961,4264),(76962,4264),(76963,4264),(76964,4264),(76965,4264),(76966,4264),(76967,4265),(76968,4265),(76969,4265),(76970,4265),(76971,4265),(76972,4265),(76973,4266),(76974,4266),(76975,4266),(76976,4266),(76977,4266),(76978,4266),(76979,4267),(76980,4267),(76981,4267),(76982,4267),(76983,4267),(76984,4267),(76985,4268),(76986,4268),(76987,4268),(76988,4268),(76989,4268),(76990,4268),(76991,4269),(76992,4269),(76993,4269),(76994,4269),(76995,4269),(76996,4269),(76997,4270),(76998,4270),(76999,4270),(77000,4270),(77001,4270),(77002,4270),(77003,4271),(77004,4271),(77005,4271),(77006,4271),(77007,4271),(77008,4271),(77009,4272),(77010,4272),(77011,4272),(77012,4272),(77013,4272),(77014,4272),(77015,4273),(77016,4273),(77017,4273),(77018,4273),(77019,4273),(77020,4273),(77021,4274),(77022,4274),(77023,4274),(77024,4274),(77025,4274),(77026,4274),(77027,4275),(77028,4275),(77029,4275),(77030,4275),(77031,4275),(77032,4275),(77033,4276),(77034,4276),(77035,4276),(77036,4276),(77037,4276),(77038,4276),(77039,4277),(77040,4277),(77041,4277),(77042,4277),(77043,4277),(77044,4277),(77045,4278),(77046,4278),(77047,4278),(77048,4278),(77049,4278),(77050,4278),(77051,4279),(77052,4279),(77053,4279),(77054,4279);
INSERT INTO `catalogsearch_fulltext_cl` VALUES (77055,4279),(77056,4279),(77057,4280),(77058,4280),(77059,4280),(77060,4280),(77061,4280),(77062,4280),(77063,4281),(77064,4281),(77065,4281),(77066,4281),(77067,4281),(77068,4281),(77069,4282),(77070,4282),(77071,4282),(77072,4282),(77073,4282),(77074,4282),(77075,4283),(77076,4283),(77077,4283),(77078,4283),(77079,4283),(77080,4283),(77081,4284),(77082,4284),(77083,4284),(77084,4284),(77085,4284),(77086,4284),(77087,4285),(77088,4285),(77089,4285),(77090,4285),(77091,4285),(77092,4285),(77093,4286),(77094,4286),(77095,4286),(77096,4286),(77097,4286),(77098,4286),(77099,4287),(77100,4287),(77101,4287),(77102,4287),(77103,4287),(77104,4287),(77105,4288),(77106,4288),(77107,4288),(77108,4288),(77109,4288),(77110,4288),(77111,4289),(77112,4289),(77113,4289),(77114,4289),(77115,4289),(77116,4289),(77117,4290),(77118,4290),(77119,4290),(77120,4290),(77121,4290),(77122,4290),(77123,4291),(77124,4291),(77125,4291),(77126,4291),(77127,4291),(77128,4291),(77129,4292),(77130,4292),(77131,4292),(77132,4292),(77133,4292),(77134,4292),(77135,4293),(77136,4293),(77137,4293),(77138,4293),(77139,4293),(77140,4293),(77141,4294),(77142,4294),(77143,4294),(77144,4294),(77145,4294),(77146,4294),(77147,4295),(77148,4295),(77149,4295),(77150,4295),(77151,4295),(77152,4295),(77153,4296),(77154,4296),(77155,4296),(77156,4296),(77157,4296),(77158,4296),(77159,4297),(77160,4297),(77161,4297),(77162,4297),(77163,4297),(77164,4297),(77165,4298),(77166,4298),(77167,4298),(77168,4298),(77169,4298),(77170,4298),(77171,4299),(77172,4299),(77173,4299),(77174,4299),(77175,4299),(77176,4299),(77177,4300),(77178,4300),(77179,4300),(77180,4300),(77181,4300),(77182,4300),(77183,4301),(77184,4301),(77185,4301),(77186,4301),(77187,4301),(77188,4301),(77189,4302),(77190,4302),(77191,4302),(77192,4302),(77193,4302),(77194,4302),(77195,4303),(77196,4303),(77197,4303),(77198,4303),(77199,4303),(77200,4303),(77201,4304),(77202,4304),(77203,4304),(77204,4304),(77205,4304),(77206,4304),(77207,4305),(77208,4305),(77209,4305),(77210,4305),(77211,4305),(77212,4305),(77213,4306),(77214,4306),(77215,4306),(77216,4306),(77217,4306),(77218,4306),(77219,4307),(77220,4307),(77221,4307),(77222,4307),(77223,4307),(77224,4307),(77225,4308),(77226,4308),(77227,4308),(77228,4308),(77229,4308),(77230,4308),(77231,4309),(77232,4309),(77233,4309),(77234,4309),(77235,4309),(77236,4309),(77237,4310),(77238,4310),(77239,4310),(77240,4310),(77241,4310),(77242,4310),(77243,4311),(77244,4311),(77245,4311),(77246,4311),(77247,4311),(77248,4311),(77249,4312),(77250,4312),(77251,4312),(77252,4312),(77253,4312),(77254,4312),(77255,4313),(77256,4313),(77257,4313),(77258,4313),(77259,4313),(77260,4313),(77261,4214),(77262,4214),(77263,4215),(77264,4215),(77265,4216),(77266,4216),(77267,4217),(77268,4217),(77269,4218),(77270,4218),(77271,4219),(77272,4219),(77273,4220),(77274,4220),(77275,4221),(77276,4221),(77277,4222),(77278,4222),(77279,4223),(77280,4223),(77281,4224),(77282,4224),(77283,4225),(77284,4225),(77285,4226),(77286,4226),(77287,4227),(77288,4227),(77289,4228),(77290,4228),(77291,4229),(77292,4229),(77293,4230),(77294,4230),(77295,4231),(77296,4231),(77297,4232),(77298,4232),(77299,4233),(77300,4233),(77301,4234),(77302,4234),(77303,4235),(77304,4235),(77305,4236),(77306,4236),(77307,4237),(77308,4237),(77309,4238),(77310,4238),(77311,4239),(77312,4239),(77313,4240),(77314,4240),(77315,4241),(77316,4241),(77317,4242),(77318,4242),(77319,4243),(77320,4243),(77321,4244),(77322,4244),(77323,4245),(77324,4245),(77325,4246),(77326,4246),(77327,4247),(77328,4247),(77329,4248),(77330,4248),(77331,4249),(77332,4249),(77333,4250),(77334,4250),(77335,4251),(77336,4251),(77337,4252),(77338,4252),(77339,4253),(77340,4253),(77341,4254),(77342,4254),(77343,4255),(77344,4255),(77345,4256),(77346,4256),(77347,4257),(77348,4257),(77349,4258),(77350,4258),(77351,4259),(77352,4259),(77353,4260),(77354,4260),(77355,4261),(77356,4261),(77357,4262),(77358,4262),(77359,4263),(77360,4263),(77361,4264),(77362,4264),(77363,4265),(77364,4265),(77365,4266),(77366,4266),(77367,4267),(77368,4267),(77369,4268),(77370,4268),(77371,4269),(77372,4269),(77373,4270),(77374,4270),(77375,4271),(77376,4271),(77377,4272),(77378,4272),(77379,4273),(77380,4273),(77381,4274),(77382,4274),(77383,4275),(77384,4275),(77385,4276),(77386,4276),(77387,4277),(77388,4277),(77389,4278),(77390,4278),(77391,4279),(77392,4279),(77393,4280),(77394,4280),(77395,4281),(77396,4281),(77397,4282),(77398,4282),(77399,4283),(77400,4283),(77401,4284),(77402,4284),(77403,4285),(77404,4285),(77405,4286),(77406,4286),(77407,4287),(77408,4287),(77409,4288),(77410,4288),(77411,4289),(77412,4289),(77413,4290),(77414,4290),(77415,4291),(77416,4291),(77417,4292),(77418,4292),(77419,4293),(77420,4293),(77421,4294),(77422,4294),(77423,4295),(77424,4295),(77425,4296),(77426,4296),(77427,4297),(77428,4297),(77429,4298),(77430,4298),(77431,4299),(77432,4299),(77433,4300),(77434,4300),(77435,4301),(77436,4301),(77437,4302),(77438,4302),(77439,4303),(77440,4303),(77441,4304),(77442,4304),(77443,4305),(77444,4305),(77445,4306),(77446,4306),(77447,4307),(77448,4307),(77449,4308),(77450,4308),(77451,4309),(77452,4309),(77453,4310),(77454,4310),(77455,4311),(77456,4311),(77457,4312),(77458,4312),(77459,4313),(77460,4313),(77461,4214),(77462,4214),(77463,4215),(77464,4215),(77465,4215),(77466,4216),(77467,4216),(77468,4216),(77469,4217),(77470,4217),(77471,4217),(77472,4218),(77473,4218),(77474,4218),(77475,4219),(77476,4219),(77477,4219),(77478,4220),(77479,4220),(77480,4220),(77481,4221),(77482,4221),(77483,4221),(77484,4222),(77485,4222),(77486,4222),(77487,4223),(77488,4223),(77489,4223),(77490,4224),(77491,4224),(77492,4224),(77493,4225),(77494,4225),(77495,4225),(77496,4226),(77497,4226),(77498,4226),(77499,4227),(77500,4227),(77501,4227),(77502,4228),(77503,4228),(77504,4228),(77505,4229),(77506,4229),(77507,4229),(77508,4230),(77509,4230),(77510,4230),(77511,4231),(77512,4231),(77513,4231),(77514,4232),(77515,4232),(77516,4232),(77517,4233),(77518,4233),(77519,4233),(77520,4234),(77521,4234),(77522,4234),(77523,4235),(77524,4235),(77525,4235),(77526,4236),(77527,4236),(77528,4236),(77529,4237),(77530,4237),(77531,4237),(77532,4238),(77533,4238),(77534,4238),(77535,4239),(77536,4239),(77537,4239),(77538,4240),(77539,4240),(77540,4240),(77541,4241),(77542,4241),(77543,4241),(77544,4242),(77545,4242),(77546,4242),(77547,4243),(77548,4243),(77549,4243),(77550,4244),(77551,4244),(77552,4244),(77553,4245),(77554,4245),(77555,4245),(77556,4246),(77557,4246),(77558,4246),(77559,4247),(77560,4247),(77561,4247),(77562,4248),(77563,4248),(77564,4248),(77565,4249),(77566,4249),(77567,4249),(77568,4250),(77569,4250),(77570,4250),(77571,4251),(77572,4251),(77573,4251),(77574,4252),(77575,4252),(77576,4252),(77577,4253),(77578,4253),(77579,4253),(77580,4254),(77581,4254),(77582,4254),(77583,4255),(77584,4255),(77585,4255),(77586,4256),(77587,4256),(77588,4256),(77589,4257),(77590,4257),(77591,4257),(77592,4258),(77593,4258),(77594,4258),(77595,4259),(77596,4259),(77597,4259),(77598,4260),(77599,4260),(77600,4260),(77601,4261),(77602,4261),(77603,4261),(77604,4262),(77605,4262),(77606,4262),(77607,4263),(77608,4263),(77609,4263),(77610,4264),(77611,4264),(77612,4264),(77613,4265),(77614,4265),(77615,4265),(77616,4266),(77617,4266),(77618,4266),(77619,4267),(77620,4267),(77621,4267),(77622,4268),(77623,4268),(77624,4268),(77625,4269),(77626,4269),(77627,4269),(77628,4270),(77629,4270),(77630,4270),(77631,4271),(77632,4271),(77633,4272),(77634,4272),(77635,4273),(77636,4273),(77637,4274),(77638,4274),(77639,4274),(77640,4275),(77641,4275),(77642,4275),(77643,4276),(77644,4276),(77645,4276),(77646,4277),(77647,4277),(77648,4277),(77649,4278),(77650,4278),(77651,4278),(77652,4279),(77653,4279),(77654,4279),(77655,4280),(77656,4280),(77657,4280),(77658,4281),(77659,4281),(77660,4281),(77661,4282),(77662,4282),(77663,4282),(77664,4283),(77665,4283),(77666,4283),(77667,4284),(77668,4284),(77669,4284),(77670,4285),(77671,4285),(77672,4285),(77673,4286),(77674,4286),(77675,4286),(77676,4287),(77677,4287),(77678,4287),(77679,4288),(77680,4288),(77681,4288),(77682,4289),(77683,4289),(77684,4289),(77685,4290),(77686,4290),(77687,4290),(77688,4291),(77689,4291),(77690,4291),(77691,4292),(77692,4292),(77693,4292),(77694,4293),(77695,4293),(77696,4293),(77697,4294),(77698,4294),(77699,4294),(77700,4295),(77701,4295),(77702,4295),(77703,4296),(77704,4296),(77705,4296),(77706,4297),(77707,4297),(77708,4297),(77709,4298),(77710,4298),(77711,4298),(77712,4299),(77713,4299),(77714,4299),(77715,4300),(77716,4300),(77717,4300),(77718,4301),(77719,4301),(77720,4301),(77721,4302),(77722,4302),(77723,4302),(77724,4303),(77725,4303),(77726,4303),(77727,4304),(77728,4304),(77729,4304),(77730,4305),(77731,4305),(77732,4305),(77733,4306),(77734,4306),(77735,4307),(77736,4307),(77737,4307),(77738,4308),(77739,4308),(77740,4308),(77741,4309),(77742,4309),(77743,4309),(77744,4310),(77745,4310),(77746,4310),(77747,4311),(77748,4311),(77749,4311),(77750,4312),(77751,4312),(77752,4312),(77753,4313),(77754,4313),(77755,4214),(77756,4214),(77757,4214),(77758,4214),(77759,4215),(77760,4215),(77761,4215),(77762,4215),(77763,4216),(77764,4216),(77765,4216),(77766,4216),(77767,4217),(77768,4217),(77769,4217),(77770,4217),(77771,4218),(77772,4218),(77773,4218),(77774,4218),(77775,4219),(77776,4219),(77777,4219),(77778,4219),(77779,4220),(77780,4220),(77781,4220),(77782,4220),(77783,4221),(77784,4221),(77785,4221),(77786,4221),(77787,4222),(77788,4222),(77789,4222),(77790,4222),(77791,4223),(77792,4223),(77793,4223),(77794,4223),(77795,4224),(77796,4224),(77797,4224),(77798,4224),(77799,4225),(77800,4225),(77801,4225),(77802,4225),(77803,4226),(77804,4226),(77805,4226),(77806,4226),(77807,4227),(77808,4227),(77809,4227),(77810,4227),(77811,4228),(77812,4228),(77813,4228),(77814,4228),(77815,4229),(77816,4229),(77817,4229),(77818,4229),(77819,4230),(77820,4230),(77821,4230),(77822,4230),(77823,4231),(77824,4231),(77825,4231),(77826,4231),(77827,4232),(77828,4232),(77829,4232),(77830,4232),(77831,4233),(77832,4233),(77833,4233),(77834,4233),(77835,4234),(77836,4234),(77837,4234),(77838,4234),(77839,4235),(77840,4235),(77841,4235),(77842,4235),(77843,4236),(77844,4236),(77845,4236),(77846,4236),(77847,4237),(77848,4237),(77849,4237),(77850,4237),(77851,4238),(77852,4238),(77853,4238),(77854,4238),(77855,4239),(77856,4239),(77857,4239),(77858,4239),(77859,4240),(77860,4240),(77861,4240),(77862,4240),(77863,4241),(77864,4241),(77865,4241),(77866,4241),(77867,4242),(77868,4242),(77869,4242),(77870,4242),(77871,4243),(77872,4243),(77873,4243),(77874,4243),(77875,4244),(77876,4244),(77877,4244),(77878,4244),(77879,4245),(77880,4245),(77881,4245),(77882,4245),(77883,4246),(77884,4246),(77885,4246),(77886,4246),(77887,4247),(77888,4247),(77889,4247),(77890,4247),(77891,4248),(77892,4248),(77893,4248),(77894,4248),(77895,4249),(77896,4249),(77897,4249),(77898,4249),(77899,4250),(77900,4250),(77901,4250),(77902,4250),(77903,4251),(77904,4251),(77905,4251),(77906,4251),(77907,4252),(77908,4252),(77909,4252),(77910,4252),(77911,4253),(77912,4253),(77913,4253),(77914,4253),(77915,4254),(77916,4254),(77917,4254),(77918,4254),(77919,4255),(77920,4255),(77921,4255),(77922,4255),(77923,4256),(77924,4256),(77925,4256),(77926,4256),(77927,4257),(77928,4257),(77929,4257),(77930,4257),(77931,4258),(77932,4258),(77933,4258),(77934,4258),(77935,4259),(77936,4259),(77937,4259),(77938,4259),(77939,4260),(77940,4260),(77941,4260),(77942,4260),(77943,4261),(77944,4261),(77945,4261),(77946,4261),(77947,4262),(77948,4262),(77949,4262),(77950,4262),(77951,4263),(77952,4263),(77953,4263),(77954,4263),(77955,4264),(77956,4264),(77957,4264),(77958,4264),(77959,4265),(77960,4265),(77961,4265),(77962,4265),(77963,4266),(77964,4266),(77965,4266),(77966,4266),(77967,4267),(77968,4267),(77969,4267),(77970,4267),(77971,4268),(77972,4268),(77973,4268),(77974,4268),(77975,4269),(77976,4269),(77977,4269),(77978,4269),(77979,4270),(77980,4270),(77981,4270),(77982,4270),(77983,4271),(77984,4271),(77985,4271),(77986,4271),(77987,4272),(77988,4272),(77989,4272),(77990,4272),(77991,4273),(77992,4273),(77993,4273),(77994,4273),(77995,4274),(77996,4274),(77997,4274),(77998,4274),(77999,4275),(78000,4275),(78001,4275),(78002,4275),(78003,4276),(78004,4276),(78005,4276),(78006,4276),(78007,4277),(78008,4277),(78009,4277),(78010,4277),(78011,4278),(78012,4278),(78013,4278),(78014,4278),(78015,4279),(78016,4279),(78017,4279),(78018,4279),(78019,4280),(78020,4280),(78021,4280),(78022,4280),(78023,4281),(78024,4281),(78025,4281),(78026,4281),(78027,4282),(78028,4282),(78029,4282),(78030,4282),(78031,4283),(78032,4283),(78033,4283),(78034,4283),(78035,4284),(78036,4284),(78037,4284),(78038,4284),(78039,4285),(78040,4285),(78041,4285),(78042,4285),(78043,4286),(78044,4286),(78045,4286),(78046,4286),(78047,4287),(78048,4287),(78049,4287),(78050,4287),(78051,4288),(78052,4288),(78053,4288),(78054,4288),(78055,4289),(78056,4289),(78057,4289),(78058,4289),(78059,4290),(78060,4290),(78061,4290),(78062,4290),(78063,4291),(78064,4291),(78065,4291),(78066,4291),(78067,4292),(78068,4292),(78069,4292),(78070,4292),(78071,4293),(78072,4293),(78073,4293),(78074,4293),(78075,4294),(78076,4294),(78077,4294),(78078,4294),(78079,4295),(78080,4295),(78081,4295),(78082,4295),(78083,4296),(78084,4296),(78085,4296),(78086,4296),(78087,4297),(78088,4297),(78089,4297),(78090,4297),(78091,4298),(78092,4298),(78093,4298),(78094,4298),(78095,4299),(78096,4299),(78097,4299),(78098,4299),(78099,4300),(78100,4300),(78101,4300),(78102,4300),(78103,4301),(78104,4301),(78105,4301),(78106,4301),(78107,4302),(78108,4302),(78109,4302),(78110,4302),(78111,4303),(78112,4303),(78113,4303),(78114,4303),(78115,4304),(78116,4304),(78117,4304),(78118,4304),(78119,4305),(78120,4305),(78121,4305),(78122,4305),(78123,4306),(78124,4306),(78125,4306),(78126,4306),(78127,4307),(78128,4307),(78129,4307),(78130,4307),(78131,4308),(78132,4308),(78133,4308),(78134,4308),(78135,4309),(78136,4309),(78137,4309),(78138,4309),(78139,4310),(78140,4310),(78141,4310),(78142,4310),(78143,4311),(78144,4311),(78145,4311),(78146,4311),(78147,4312),(78148,4312),(78149,4312),(78150,4312),(78151,4313),(78152,4313),(78153,4313),(78154,4313),(78155,4314),(78156,4315),(78157,4316),(78158,4317),(78159,4318),(78160,4319),(78161,4320),(78162,4321),(78163,4322),(78164,4323),(78165,4324),(78166,4325),(78167,4326),(78168,4327),(78169,4328),(78170,4329),(78171,4330),(78172,4331),(78173,4332),(78174,4333),(78175,4334),(78176,4335),(78177,4336),(78178,4337),(78179,4338),(78180,4339),(78181,4340),(78182,4341),(78183,4342),(78184,4343),(78185,4344),(78186,4345),(78187,4346),(78188,4347),(78189,4348),(78190,4349),(78191,4350),(78192,4351),(78193,4352),(78194,4353),(78195,4354),(78196,4355),(78197,4356),(78198,4357),(78199,4358),(78200,4359),(78201,4360),(78202,4361),(78203,4362),(78204,4363),(78205,4364),(78206,4365),(78207,4366),(78208,4367),(78209,4368),(78210,4369),(78211,4370),(78212,4371),(78213,4372),(78214,4373),(78215,4374),(78216,4375),(78217,4376),(78218,4377),(78219,4378),(78220,4379),(78221,4380),(78222,4381),(78223,4382),(78224,4383),(78225,4384),(78226,4385),(78227,4386),(78228,4387),(78229,4388),(78230,4389),(78231,4390),(78232,4391),(78233,4392),(78234,4393),(78235,4394),(78236,4395),(78237,4396),(78238,4397),(78239,4398),(78240,4399),(78241,4400),(78242,4401),(78243,4402),(78244,4403),(78245,4404),(78246,4405),(78247,4406),(78248,4407),(78249,4408),(78250,4409),(78251,4410),(78252,4411),(78253,4412),(78254,4413),(78255,4314),(78256,4315),(78257,4316),(78258,4317),(78259,4318),(78260,4319),(78261,4320),(78262,4321),(78263,4322),(78264,4323),(78265,4324),(78266,4325),(78267,4326),(78268,4327),(78269,4328),(78270,4329),(78271,4330),(78272,4331),(78273,4332),(78274,4333),(78275,4334),(78276,4335),(78277,4336),(78278,4337),(78279,4338),(78280,4339),(78281,4340),(78282,4341),(78283,4342),(78284,4343),(78285,4344),(78286,4345),(78287,4346),(78288,4347),(78289,4348),(78290,4349),(78291,4350),(78292,4351),(78293,4352),(78294,4353),(78295,4354),(78296,4355),(78297,4356),(78298,4357),(78299,4358),(78300,4359),(78301,4360),(78302,4361),(78303,4362),(78304,4363),(78305,4364),(78306,4365),(78307,4366),(78308,4367),(78309,4368),(78310,4369),(78311,4370),(78312,4371),(78313,4372),(78314,4373),(78315,4374),(78316,4375),(78317,4376),(78318,4377),(78319,4378),(78320,4379),(78321,4380),(78322,4381),(78323,4382),(78324,4383),(78325,4384),(78326,4385),(78327,4386),(78328,4387),(78329,4388),(78330,4389),(78331,4390),(78332,4391),(78333,4392),(78334,4393),(78335,4394),(78336,4395),(78337,4396),(78338,4397),(78339,4398),(78340,4399),(78341,4400),(78342,4401),(78343,4402),(78344,4403),(78345,4404),(78346,4405),(78347,4406),(78348,4407),(78349,4408),(78350,4409),(78351,4410),(78352,4411),(78353,4412),(78354,4413),(78355,4314),(78356,4314),(78357,4314),(78358,4314),(78359,4314),(78360,4314),(78361,4315),(78362,4315),(78363,4315),(78364,4315),(78365,4315),(78366,4315),(78367,4316),(78368,4316),(78369,4316),(78370,4316),(78371,4316),(78372,4316),(78373,4317),(78374,4317),(78375,4317),(78376,4317),(78377,4317),(78378,4317),(78379,4318),(78380,4318),(78381,4318),(78382,4318),(78383,4318),(78384,4318),(78385,4319),(78386,4319),(78387,4319),(78388,4319),(78389,4319),(78390,4319),(78391,4320),(78392,4320),(78393,4320),(78394,4320),(78395,4320),(78396,4320),(78397,4321),(78398,4321),(78399,4321),(78400,4321),(78401,4321),(78402,4321),(78403,4322),(78404,4322),(78405,4322),(78406,4322),(78407,4322),(78408,4322),(78409,4323),(78410,4323),(78411,4323),(78412,4323),(78413,4323),(78414,4323),(78415,4324),(78416,4324),(78417,4324),(78418,4324),(78419,4324),(78420,4324),(78421,4325),(78422,4325),(78423,4325),(78424,4325),(78425,4325),(78426,4325),(78427,4326),(78428,4326),(78429,4326),(78430,4326),(78431,4326),(78432,4326),(78433,4327),(78434,4327),(78435,4327),(78436,4327),(78437,4327),(78438,4327),(78439,4328),(78440,4328),(78441,4328),(78442,4328),(78443,4328),(78444,4328),(78445,4329),(78446,4329),(78447,4329),(78448,4329),(78449,4329),(78450,4329),(78451,4330),(78452,4330),(78453,4330),(78454,4330),(78455,4330),(78456,4330),(78457,4331),(78458,4331),(78459,4331),(78460,4331),(78461,4331),(78462,4331),(78463,4332),(78464,4332),(78465,4332),(78466,4332),(78467,4332),(78468,4332),(78469,4333),(78470,4333),(78471,4333),(78472,4333),(78473,4333),(78474,4333),(78475,4334),(78476,4334),(78477,4334),(78478,4334),(78479,4334),(78480,4334),(78481,4335),(78482,4335),(78483,4335),(78484,4335),(78485,4335),(78486,4335),(78487,4336),(78488,4336),(78489,4336),(78490,4336),(78491,4336),(78492,4336),(78493,4337),(78494,4337),(78495,4337),(78496,4337),(78497,4337),(78498,4337),(78499,4338),(78500,4338),(78501,4338),(78502,4338),(78503,4338),(78504,4338),(78505,4339),(78506,4339),(78507,4339),(78508,4339),(78509,4339),(78510,4339),(78511,4340),(78512,4340),(78513,4340),(78514,4340),(78515,4340),(78516,4340),(78517,4341),(78518,4341),(78519,4341),(78520,4341),(78521,4341),(78522,4341),(78523,4342),(78524,4342),(78525,4342),(78526,4342),(78527,4342),(78528,4342),(78529,4343),(78530,4343),(78531,4343),(78532,4343),(78533,4343),(78534,4343),(78535,4344),(78536,4344),(78537,4344),(78538,4344),(78539,4344),(78540,4344),(78541,4345),(78542,4345),(78543,4345),(78544,4345),(78545,4345),(78546,4345),(78547,4346),(78548,4346),(78549,4346),(78550,4346),(78551,4346),(78552,4346),(78553,4347),(78554,4347),(78555,4347),(78556,4347),(78557,4347),(78558,4347),(78559,4348),(78560,4348),(78561,4348),(78562,4348),(78563,4348),(78564,4348),(78565,4349),(78566,4349),(78567,4349),(78568,4349),(78569,4349),(78570,4349),(78571,4350),(78572,4350),(78573,4350),(78574,4350),(78575,4350),(78576,4350),(78577,4351),(78578,4351),(78579,4351),(78580,4351),(78581,4351),(78582,4351),(78583,4352),(78584,4352),(78585,4352),(78586,4352),(78587,4352),(78588,4352),(78589,4353),(78590,4353),(78591,4353),(78592,4353),(78593,4353),(78594,4353),(78595,4354),(78596,4354),(78597,4354),(78598,4354),(78599,4354),(78600,4354),(78601,4355),(78602,4355),(78603,4355),(78604,4355),(78605,4355),(78606,4355),(78607,4356),(78608,4356),(78609,4356),(78610,4356),(78611,4356),(78612,4356),(78613,4357),(78614,4357),(78615,4357),(78616,4357),(78617,4357),(78618,4357),(78619,4358),(78620,4358),(78621,4358),(78622,4358),(78623,4358),(78624,4358),(78625,4359),(78626,4359),(78627,4359),(78628,4359),(78629,4359),(78630,4359),(78631,4360),(78632,4360),(78633,4360),(78634,4360),(78635,4360),(78636,4360),(78637,4361),(78638,4361),(78639,4361),(78640,4361),(78641,4361),(78642,4361),(78643,4362),(78644,4362),(78645,4362),(78646,4362),(78647,4362),(78648,4362),(78649,4363),(78650,4363),(78651,4363),(78652,4363),(78653,4363),(78654,4363),(78655,4364),(78656,4364),(78657,4364),(78658,4364),(78659,4364),(78660,4364),(78661,4365),(78662,4365),(78663,4365),(78664,4365),(78665,4365),(78666,4365),(78667,4366),(78668,4366),(78669,4366),(78670,4366),(78671,4366),(78672,4366),(78673,4367),(78674,4367),(78675,4367),(78676,4367),(78677,4367),(78678,4367),(78679,4368),(78680,4368),(78681,4368),(78682,4368),(78683,4368),(78684,4368),(78685,4369),(78686,4369),(78687,4369),(78688,4369),(78689,4369),(78690,4369),(78691,4370),(78692,4370),(78693,4370),(78694,4370),(78695,4370),(78696,4370),(78697,4371),(78698,4371),(78699,4371),(78700,4371),(78701,4371),(78702,4371),(78703,4372),(78704,4372),(78705,4372),(78706,4372),(78707,4372),(78708,4372),(78709,4373),(78710,4373),(78711,4373),(78712,4373),(78713,4373),(78714,4373),(78715,4374),(78716,4374),(78717,4374),(78718,4374),(78719,4374),(78720,4374),(78721,4375),(78722,4375),(78723,4375),(78724,4375),(78725,4375),(78726,4375),(78727,4376),(78728,4376),(78729,4376),(78730,4376),(78731,4376),(78732,4376),(78733,4377),(78734,4377),(78735,4377),(78736,4377),(78737,4377),(78738,4377),(78739,4378),(78740,4378),(78741,4378),(78742,4378),(78743,4378),(78744,4378),(78745,4379),(78746,4379),(78747,4379),(78748,4379),(78749,4379),(78750,4379),(78751,4380),(78752,4380),(78753,4380),(78754,4380),(78755,4380),(78756,4380),(78757,4381),(78758,4381),(78759,4381),(78760,4381),(78761,4381),(78762,4381),(78763,4382),(78764,4382),(78765,4382),(78766,4382),(78767,4382),(78768,4382),(78769,4383),(78770,4383),(78771,4383),(78772,4383),(78773,4383),(78774,4383),(78775,4384),(78776,4384),(78777,4384),(78778,4384),(78779,4384),(78780,4384),(78781,4385),(78782,4385),(78783,4385),(78784,4385),(78785,4385),(78786,4385),(78787,4386),(78788,4386),(78789,4386),(78790,4386),(78791,4386),(78792,4386),(78793,4387),(78794,4387),(78795,4387),(78796,4387),(78797,4387),(78798,4387),(78799,4388),(78800,4388),(78801,4388),(78802,4388),(78803,4388),(78804,4388),(78805,4389),(78806,4389),(78807,4389),(78808,4389),(78809,4389),(78810,4389),(78811,4390),(78812,4390),(78813,4390),(78814,4390),(78815,4390),(78816,4390),(78817,4391),(78818,4391),(78819,4391),(78820,4391),(78821,4391),(78822,4391),(78823,4392),(78824,4392),(78825,4392),(78826,4392),(78827,4392),(78828,4392),(78829,4393),(78830,4393),(78831,4393),(78832,4393),(78833,4393),(78834,4393),(78835,4394),(78836,4394),(78837,4394),(78838,4394),(78839,4394),(78840,4394),(78841,4395),(78842,4395),(78843,4395),(78844,4395),(78845,4395),(78846,4395),(78847,4396),(78848,4396),(78849,4396),(78850,4396),(78851,4396),(78852,4396),(78853,4397),(78854,4397),(78855,4397),(78856,4397),(78857,4397),(78858,4397),(78859,4398),(78860,4398),(78861,4398),(78862,4398),(78863,4398),(78864,4398),(78865,4399),(78866,4399),(78867,4399),(78868,4399),(78869,4399),(78870,4399),(78871,4400),(78872,4400),(78873,4400),(78874,4400),(78875,4400),(78876,4400),(78877,4401),(78878,4401),(78879,4401),(78880,4401),(78881,4401),(78882,4401),(78883,4402),(78884,4402),(78885,4402),(78886,4402),(78887,4402),(78888,4402),(78889,4403),(78890,4403),(78891,4403),(78892,4403),(78893,4403),(78894,4403),(78895,4404),(78896,4404),(78897,4404),(78898,4404),(78899,4404),(78900,4404),(78901,4405),(78902,4405),(78903,4405),(78904,4405),(78905,4405),(78906,4405),(78907,4406),(78908,4406),(78909,4406),(78910,4406),(78911,4406),(78912,4406),(78913,4407),(78914,4407),(78915,4407),(78916,4407),(78917,4407),(78918,4407),(78919,4408),(78920,4408),(78921,4408),(78922,4408),(78923,4408),(78924,4408),(78925,4409),(78926,4409),(78927,4409),(78928,4409),(78929,4409),(78930,4409),(78931,4410),(78932,4410),(78933,4410),(78934,4410),(78935,4410),(78936,4410),(78937,4411),(78938,4411),(78939,4411),(78940,4411),(78941,4411),(78942,4411),(78943,4412),(78944,4412),(78945,4412),(78946,4412),(78947,4412),(78948,4412),(78949,4413),(78950,4413),(78951,4413),(78952,4413),(78953,4413),(78954,4413),(78955,4314),(78956,4314),(78957,4315),(78958,4315),(78959,4316),(78960,4316),(78961,4317),(78962,4317),(78963,4318),(78964,4318),(78965,4319),(78966,4319),(78967,4320),(78968,4320),(78969,4321),(78970,4321),(78971,4322),(78972,4322),(78973,4323),(78974,4323),(78975,4324),(78976,4324),(78977,4325),(78978,4325),(78979,4326),(78980,4326),(78981,4327),(78982,4327),(78983,4328),(78984,4328),(78985,4329),(78986,4329),(78987,4330),(78988,4330),(78989,4331),(78990,4331),(78991,4332),(78992,4332),(78993,4333),(78994,4333),(78995,4334),(78996,4334),(78997,4335),(78998,4335),(78999,4336),(79000,4336),(79001,4337),(79002,4337),(79003,4338),(79004,4338),(79005,4339),(79006,4339),(79007,4340),(79008,4340),(79009,4341),(79010,4341),(79011,4342),(79012,4342),(79013,4343),(79014,4343),(79015,4344),(79016,4344),(79017,4345),(79018,4345),(79019,4346),(79020,4346),(79021,4347),(79022,4347),(79023,4348),(79024,4348),(79025,4349),(79026,4349),(79027,4350),(79028,4350),(79029,4351),(79030,4351),(79031,4352),(79032,4352),(79033,4353),(79034,4353),(79035,4354),(79036,4354),(79037,4355),(79038,4355),(79039,4356),(79040,4356),(79041,4357),(79042,4357),(79043,4357),(79044,4358),(79045,4358),(79046,4359),(79047,4359),(79048,4360),(79049,4360),(79050,4361),(79051,4361),(79052,4362),(79053,4362),(79054,4363),(79055,4363),(79056,4364),(79057,4364),(79058,4365),(79059,4365),(79060,4366),(79061,4366),(79062,4367),(79063,4367),(79064,4368),(79065,4368),(79066,4369),(79067,4369),(79068,4370),(79069,4370),(79070,4371),(79071,4371),(79072,4372),(79073,4372),(79074,4373),(79075,4373),(79076,4374),(79077,4374),(79078,4375),(79079,4375),(79080,4376),(79081,4376),(79082,4377),(79083,4377),(79084,4378),(79085,4378),(79086,4379),(79087,4379),(79088,4380),(79089,4380),(79090,4381),(79091,4381),(79092,4382),(79093,4382),(79094,4383),(79095,4383),(79096,4384),(79097,4384),(79098,4385),(79099,4385),(79100,4386),(79101,4386),(79102,4387),(79103,4387),(79104,4388),(79105,4388),(79106,4389),(79107,4389),(79108,4390),(79109,4390),(79110,4391),(79111,4391),(79112,4392),(79113,4392),(79114,4393),(79115,4393),(79116,4394),(79117,4394),(79118,4395),(79119,4395),(79120,4396),(79121,4396),(79122,4397),(79123,4397),(79124,4398),(79125,4398),(79126,4399),(79127,4399),(79128,4400),(79129,4400),(79130,4401),(79131,4401),(79132,4402),(79133,4402),(79134,4402),(79135,4403),(79136,4403),(79137,4404),(79138,4404),(79139,4405),(79140,4405),(79141,4406),(79142,4406),(79143,4407),(79144,4407),(79145,4408),(79146,4408),(79147,4409),(79148,4409),(79149,4410),(79150,4410),(79151,4411),(79152,4411),(79153,4412),(79154,4412),(79155,4413),(79156,4413),(79157,4314),(79158,4314),(79159,4315),(79160,4315),(79161,4315),(79162,4316),(79163,4316),(79164,4316),(79165,4317),(79166,4317),(79167,4317),(79168,4318),(79169,4318),(79170,4318),(79171,4319),(79172,4319),(79173,4319),(79174,4320),(79175,4320),(79176,4320),(79177,4321),(79178,4321),(79179,4321),(79180,4322),(79181,4322),(79182,4322),(79183,4323),(79184,4323),(79185,4323),(79186,4324),(79187,4324),(79188,4324),(79189,4325),(79190,4325),(79191,4325),(79192,4326),(79193,4326),(79194,4326),(79195,4327),(79196,4327),(79197,4327),(79198,4328),(79199,4328),(79200,4328),(79201,4329),(79202,4329),(79203,4329),(79204,4330),(79205,4330),(79206,4330),(79207,4331),(79208,4331),(79209,4331),(79210,4332),(79211,4332),(79212,4332),(79213,4333),(79214,4333),(79215,4333),(79216,4334),(79217,4334),(79218,4334),(79219,4335),(79220,4335),(79221,4335),(79222,4336),(79223,4336),(79224,4336),(79225,4337),(79226,4337),(79227,4337),(79228,4338),(79229,4338),(79230,4338),(79231,4339),(79232,4339),(79233,4339),(79234,4340),(79235,4340),(79236,4340),(79237,4341),(79238,4341),(79239,4342),(79240,4342),(79241,4342),(79242,4343),(79243,4343),(79244,4343),(79245,4344),(79246,4344),(79247,4344),(79248,4345),(79249,4345),(79250,4345),(79251,4346),(79252,4346),(79253,4346),(79254,4347),(79255,4347),(79256,4347),(79257,4348),(79258,4348),(79259,4348),(79260,4349),(79261,4349),(79262,4349),(79263,4350),(79264,4350),(79265,4350),(79266,4351),(79267,4351),(79268,4351),(79269,4352),(79270,4352),(79271,4352),(79272,4353),(79273,4353),(79274,4353),(79275,4354),(79276,4354),(79277,4354),(79278,4355),(79279,4355),(79280,4355),(79281,4356),(79282,4356),(79283,4356),(79284,4357),(79285,4357),(79286,4357),(79287,4358),(79288,4358),(79289,4359),(79290,4359),(79291,4359),(79292,4360),(79293,4360),(79294,4360),(79295,4361),(79296,4361),(79297,4361),(79298,4362),(79299,4362),(79300,4362),(79301,4363),(79302,4363),(79303,4363),(79304,4364),(79305,4364),(79306,4364),(79307,4365),(79308,4365),(79309,4365),(79310,4366),(79311,4366),(79312,4366),(79313,4367),(79314,4367),(79315,4367),(79316,4368),(79317,4368),(79318,4368),(79319,4369),(79320,4369),(79321,4369),(79322,4370),(79323,4370),(79324,4370),(79325,4371),(79326,4371),(79327,4371),(79328,4372),(79329,4372),(79330,4372),(79331,4373),(79332,4373),(79333,4373),(79334,4374),(79335,4374),(79336,4374),(79337,4375),(79338,4375),(79339,4375),(79340,4376),(79341,4376),(79342,4376),(79343,4377),(79344,4377),(79345,4377),(79346,4378),(79347,4378),(79348,4378),(79349,4379),(79350,4379),(79351,4379),(79352,4380),(79353,4380),(79354,4380),(79355,4381),(79356,4381),(79357,4381),(79358,4382),(79359,4382),(79360,4382),(79361,4383),(79362,4383),(79363,4383),(79364,4384),(79365,4384),(79366,4384),(79367,4385),(79368,4385),(79369,4385),(79370,4386),(79371,4386),(79372,4386),(79373,4387),(79374,4387),(79375,4387),(79376,4388),(79377,4388),(79378,4388),(79379,4389),(79380,4389),(79381,4389),(79382,4390),(79383,4390),(79384,4390),(79385,4391),(79386,4391),(79387,4391),(79388,4392),(79389,4392),(79390,4392),(79391,4393),(79392,4393),(79393,4393),(79394,4394),(79395,4394),(79396,4394),(79397,4395),(79398,4395),(79399,4395),(79400,4396),(79401,4396),(79402,4396),(79403,4397),(79404,4397),(79405,4397),(79406,4398),(79407,4398),(79408,4398),(79409,4399),(79410,4399),(79411,4399),(79412,4400),(79413,4400),(79414,4400),(79415,4401),(79416,4401),(79417,4401),(79418,4402),(79419,4402),(79420,4402),(79421,4403),(79422,4403),(79423,4403),(79424,4404),(79425,4404),(79426,4404),(79427,4405),(79428,4405),(79429,4405),(79430,4406),(79431,4406),(79432,4406),(79433,4407),(79434,4407),(79435,4407),(79436,4408),(79437,4408),(79438,4408),(79439,4409),(79440,4409),(79441,4409),(79442,4410),(79443,4410),(79444,4410),(79445,4411),(79446,4411),(79447,4411),(79448,4412),(79449,4412),(79450,4412),(79451,4413),(79452,4413),(79453,4413),(79454,4314),(79455,4314),(79456,4314),(79457,4314),(79458,4315),(79459,4315),(79460,4315),(79461,4315),(79462,4316),(79463,4316),(79464,4316),(79465,4316),(79466,4317),(79467,4317),(79468,4317),(79469,4317),(79470,4318),(79471,4318),(79472,4318),(79473,4318),(79474,4319),(79475,4319),(79476,4319),(79477,4319),(79478,4320),(79479,4320),(79480,4320),(79481,4320),(79482,4321),(79483,4321),(79484,4321),(79485,4321),(79486,4322),(79487,4322),(79488,4322),(79489,4322),(79490,4323),(79491,4323),(79492,4323),(79493,4323),(79494,4324),(79495,4324),(79496,4324),(79497,4324),(79498,4325),(79499,4325),(79500,4325),(79501,4325),(79502,4326),(79503,4326),(79504,4326),(79505,4326),(79506,4327),(79507,4327),(79508,4327),(79509,4327),(79510,4328),(79511,4328),(79512,4328),(79513,4328),(79514,4329),(79515,4329),(79516,4329),(79517,4329),(79518,4330),(79519,4330),(79520,4330),(79521,4330),(79522,4331),(79523,4331),(79524,4331),(79525,4331),(79526,4332),(79527,4332),(79528,4332),(79529,4332),(79530,4333),(79531,4333),(79532,4333),(79533,4333),(79534,4334),(79535,4334),(79536,4334),(79537,4334),(79538,4335),(79539,4335),(79540,4335),(79541,4335),(79542,4336),(79543,4336),(79544,4336),(79545,4336),(79546,4337),(79547,4337),(79548,4337),(79549,4337),(79550,4338),(79551,4338),(79552,4338),(79553,4338),(79554,4339),(79555,4339),(79556,4339),(79557,4339),(79558,4340),(79559,4340),(79560,4340),(79561,4340),(79562,4341),(79563,4341),(79564,4341),(79565,4341),(79566,4342),(79567,4342),(79568,4342),(79569,4342),(79570,4343),(79571,4343),(79572,4343),(79573,4343),(79574,4344),(79575,4344),(79576,4344),(79577,4344),(79578,4345),(79579,4345),(79580,4345),(79581,4345),(79582,4346),(79583,4346),(79584,4346),(79585,4346),(79586,4347),(79587,4347),(79588,4347),(79589,4347),(79590,4348),(79591,4348),(79592,4348),(79593,4348),(79594,4349),(79595,4349),(79596,4349),(79597,4349),(79598,4350),(79599,4350),(79600,4350),(79601,4350),(79602,4351),(79603,4351),(79604,4351),(79605,4351),(79606,4352),(79607,4352),(79608,4352),(79609,4352),(79610,4353),(79611,4353),(79612,4353),(79613,4353),(79614,4354),(79615,4354),(79616,4354),(79617,4354),(79618,4355),(79619,4355),(79620,4355),(79621,4355),(79622,4356),(79623,4356),(79624,4356),(79625,4356),(79626,4357),(79627,4357),(79628,4357),(79629,4357),(79630,4358),(79631,4358),(79632,4358),(79633,4358),(79634,4359),(79635,4359),(79636,4359),(79637,4359),(79638,4360),(79639,4360),(79640,4360),(79641,4360),(79642,4361),(79643,4361),(79644,4361),(79645,4361),(79646,4362),(79647,4362),(79648,4362),(79649,4362),(79650,4363),(79651,4363),(79652,4363),(79653,4363),(79654,4364),(79655,4364),(79656,4364),(79657,4364),(79658,4365),(79659,4365),(79660,4365),(79661,4365),(79662,4366),(79663,4366),(79664,4366),(79665,4366),(79666,4367),(79667,4367),(79668,4367),(79669,4367),(79670,4368),(79671,4368),(79672,4368),(79673,4368),(79674,4369),(79675,4369),(79676,4369),(79677,4369),(79678,4370),(79679,4370),(79680,4370),(79681,4370),(79682,4371),(79683,4371),(79684,4371),(79685,4371),(79686,4372),(79687,4372),(79688,4372),(79689,4372),(79690,4373),(79691,4373),(79692,4373),(79693,4373),(79694,4374),(79695,4374),(79696,4374),(79697,4374),(79698,4375),(79699,4375),(79700,4375),(79701,4375),(79702,4376),(79703,4376),(79704,4376),(79705,4376),(79706,4377),(79707,4377),(79708,4377),(79709,4377),(79710,4378),(79711,4378),(79712,4378),(79713,4378),(79714,4379),(79715,4379),(79716,4379),(79717,4379),(79718,4380),(79719,4380),(79720,4380),(79721,4380),(79722,4381),(79723,4381),(79724,4381),(79725,4381),(79726,4382),(79727,4382),(79728,4382),(79729,4382),(79730,4383),(79731,4383),(79732,4383),(79733,4383),(79734,4384),(79735,4384),(79736,4384),(79737,4384),(79738,4385),(79739,4385),(79740,4385),(79741,4385),(79742,4386),(79743,4386),(79744,4386),(79745,4386),(79746,4387),(79747,4387),(79748,4387),(79749,4387),(79750,4388),(79751,4388),(79752,4388),(79753,4388),(79754,4389),(79755,4389),(79756,4389),(79757,4389),(79758,4390),(79759,4390),(79760,4390),(79761,4390),(79762,4391),(79763,4391),(79764,4391),(79765,4391),(79766,4392),(79767,4392),(79768,4392),(79769,4392),(79770,4393),(79771,4393),(79772,4393),(79773,4393),(79774,4394),(79775,4394),(79776,4394),(79777,4394),(79778,4395),(79779,4395),(79780,4395),(79781,4395),(79782,4396),(79783,4396),(79784,4396),(79785,4396),(79786,4397),(79787,4397),(79788,4397),(79789,4397),(79790,4398),(79791,4398),(79792,4398),(79793,4398),(79794,4399),(79795,4399),(79796,4399),(79797,4399),(79798,4400),(79799,4400),(79800,4400),(79801,4400),(79802,4401),(79803,4401),(79804,4401),(79805,4401),(79806,4402),(79807,4402),(79808,4402),(79809,4402),(79810,4403),(79811,4403),(79812,4403),(79813,4403),(79814,4404),(79815,4404),(79816,4404),(79817,4404),(79818,4405),(79819,4405),(79820,4405),(79821,4405),(79822,4406),(79823,4406),(79824,4406),(79825,4406),(79826,4407),(79827,4407),(79828,4407),(79829,4407),(79830,4408),(79831,4408),(79832,4408),(79833,4408),(79834,4409),(79835,4409),(79836,4409),(79837,4409),(79838,4410),(79839,4410),(79840,4410),(79841,4410),(79842,4411),(79843,4411),(79844,4411),(79845,4411),(79846,4412),(79847,4412),(79848,4412),(79849,4412),(79850,4413),(79851,4413),(79852,4413),(79853,4413),(79854,4414),(79855,4415),(79856,4416),(79857,4417),(79858,4418),(79859,4419),(79860,4420),(79861,4421),(79862,4422),(79863,4423),(79864,4424),(79865,4425),(79866,4426),(79867,4427),(79868,4428),(79869,4429),(79870,4430),(79871,4431),(79872,4432),(79873,4433),(79874,4434),(79875,4435),(79876,4436),(79877,4437),(79878,4438),(79879,4439),(79880,4440),(79881,4441),(79882,4442),(79883,4443),(79884,4444),(79885,4445),(79886,4446),(79887,4447),(79888,4448),(79889,4449),(79890,4450),(79891,4451),(79892,4452),(79893,4453),(79894,4454),(79895,4455),(79896,4456),(79897,4457),(79898,4458),(79899,4459),(79900,4460),(79901,4461),(79902,4462),(79903,4463),(79904,4464),(79905,4465),(79906,4466),(79907,4467),(79908,4468),(79909,4469),(79910,4470),(79911,4471),(79912,4472),(79913,4473),(79914,4474),(79915,4475),(79916,4476),(79917,4477),(79918,4478),(79919,4479),(79920,4480),(79921,4481),(79922,4482),(79923,4483),(79924,4484),(79925,4485),(79926,4486),(79927,4487),(79928,4488),(79929,4489),(79930,4490),(79931,4414),(79932,4415),(79933,4416),(79934,4417),(79935,4418),(79936,4419),(79937,4420),(79938,4421),(79939,4422),(79940,4423),(79941,4424),(79942,4425),(79943,4426),(79944,4427),(79945,4428),(79946,4429),(79947,4430),(79948,4431),(79949,4432),(79950,4433),(79951,4434),(79952,4435),(79953,4436),(79954,4437),(79955,4438),(79956,4439),(79957,4440),(79958,4441),(79959,4442),(79960,4443),(79961,4444),(79962,4445),(79963,4446),(79964,4447),(79965,4448),(79966,4449),(79967,4450),(79968,4451),(79969,4452),(79970,4453),(79971,4454),(79972,4455),(79973,4456),(79974,4457),(79975,4458),(79976,4459),(79977,4460),(79978,4461),(79979,4462),(79980,4463),(79981,4464),(79982,4465),(79983,4466),(79984,4467),(79985,4468),(79986,4469),(79987,4470),(79988,4471),(79989,4472),(79990,4473),(79991,4474),(79992,4475),(79993,4476),(79994,4477),(79995,4478),(79996,4479),(79997,4480),(79998,4481),(79999,4482),(80000,4483),(80001,4484),(80002,4485),(80003,4486),(80004,4487),(80005,4488),(80006,4489),(80007,4490),(80008,4414),(80009,4414),(80010,4414),(80011,4414),(80012,4414),(80013,4414),(80014,4415),(80015,4415),(80016,4415),(80017,4415),(80018,4415),(80019,4415),(80020,4416),(80021,4416),(80022,4416),(80023,4416),(80024,4416),(80025,4416),(80026,4417),(80027,4417),(80028,4417),(80029,4417),(80030,4417),(80031,4417),(80032,4418),(80033,4418),(80034,4418),(80035,4418),(80036,4418),(80037,4418),(80038,4419),(80039,4419),(80040,4419),(80041,4419),(80042,4419),(80043,4419),(80044,4420),(80045,4420),(80046,4420),(80047,4420),(80048,4420),(80049,4420),(80050,4421),(80051,4421),(80052,4421),(80053,4421),(80054,4421),(80055,4421),(80056,4422),(80057,4422),(80058,4422),(80059,4422),(80060,4422),(80061,4422),(80062,4423),(80063,4423),(80064,4423),(80065,4423),(80066,4423),(80067,4423),(80068,4424),(80069,4424),(80070,4424),(80071,4424),(80072,4424),(80073,4424),(80074,4425),(80075,4425),(80076,4425),(80077,4425),(80078,4425),(80079,4425),(80080,4426),(80081,4426),(80082,4426),(80083,4426),(80084,4426),(80085,4426),(80086,4427),(80087,4427),(80088,4427),(80089,4427),(80090,4427),(80091,4427),(80092,4428),(80093,4428),(80094,4428),(80095,4428),(80096,4428),(80097,4428),(80098,4429),(80099,4429),(80100,4429),(80101,4429),(80102,4429),(80103,4429),(80104,4430),(80105,4430),(80106,4430),(80107,4430),(80108,4430),(80109,4430),(80110,4431),(80111,4431),(80112,4431),(80113,4431),(80114,4431),(80115,4431),(80116,4432),(80117,4432),(80118,4432),(80119,4432),(80120,4433),(80121,4433),(80122,4433),(80123,4433),(80124,4434),(80125,4434),(80126,4434),(80127,4434),(80128,4434),(80129,4434),(80130,4435),(80131,4435),(80132,4435),(80133,4435),(80134,4435),(80135,4435),(80136,4436),(80137,4436),(80138,4436),(80139,4436),(80140,4436),(80141,4436),(80142,4437),(80143,4437),(80144,4437),(80145,4437),(80146,4437),(80147,4437),(80148,4438),(80149,4438),(80150,4438),(80151,4438),(80152,4438),(80153,4438),(80154,4439),(80155,4439),(80156,4439),(80157,4439),(80158,4439),(80159,4439),(80160,4440),(80161,4440),(80162,4440),(80163,4440),(80164,4440),(80165,4440),(80166,4441),(80167,4441),(80168,4441),(80169,4441),(80170,4441),(80171,4441),(80172,4442),(80173,4442),(80174,4442),(80175,4442),(80176,4442),(80177,4442),(80178,4443),(80179,4443),(80180,4443),(80181,4443),(80182,4443),(80183,4443),(80184,4444),(80185,4444),(80186,4444),(80187,4444),(80188,4444),(80189,4444),(80190,4445),(80191,4445),(80192,4445),(80193,4445),(80194,4445),(80195,4445),(80196,4446),(80197,4446),(80198,4446),(80199,4446),(80200,4446),(80201,4446),(80202,4447),(80203,4447),(80204,4447),(80205,4447),(80206,4447),(80207,4447),(80208,4448),(80209,4448),(80210,4448),(80211,4448),(80212,4448),(80213,4448),(80214,4449),(80215,4449),(80216,4449),(80217,4449),(80218,4449),(80219,4449),(80220,4450),(80221,4450),(80222,4450),(80223,4450),(80224,4450),(80225,4450),(80226,4451),(80227,4451),(80228,4451),(80229,4451),(80230,4451),(80231,4451),(80232,4452),(80233,4452),(80234,4452),(80235,4452),(80236,4452),(80237,4452),(80238,4453),(80239,4453),(80240,4453),(80241,4453),(80242,4453),(80243,4453),(80244,4454),(80245,4454),(80246,4454),(80247,4454),(80248,4454),(80249,4454),(80250,4455),(80251,4455),(80252,4455),(80253,4455),(80254,4455),(80255,4455),(80256,4456),(80257,4456),(80258,4456),(80259,4456),(80260,4456),(80261,4456),(80262,4457),(80263,4457),(80264,4457),(80265,4457),(80266,4457),(80267,4457),(80268,4458),(80269,4458),(80270,4458),(80271,4458),(80272,4458),(80273,4458),(80274,4459),(80275,4459),(80276,4459),(80277,4459),(80278,4459),(80279,4459),(80280,4460),(80281,4460),(80282,4460),(80283,4460),(80284,4460),(80285,4460),(80286,4461),(80287,4461),(80288,4461),(80289,4461),(80290,4461),(80291,4461),(80292,4462),(80293,4462),(80294,4462),(80295,4462),(80296,4462),(80297,4462),(80298,4463),(80299,4463),(80300,4463),(80301,4463),(80302,4463),(80303,4463),(80304,4464),(80305,4464),(80306,4464),(80307,4464),(80308,4464),(80309,4464),(80310,4465),(80311,4465),(80312,4465),(80313,4465),(80314,4465),(80315,4465),(80316,4466),(80317,4466),(80318,4466),(80319,4466),(80320,4466),(80321,4466),(80322,4467),(80323,4467),(80324,4467),(80325,4467),(80326,4467),(80327,4467),(80328,4468),(80329,4468),(80330,4468),(80331,4468),(80332,4468),(80333,4468),(80334,4469),(80335,4469),(80336,4469),(80337,4469),(80338,4469),(80339,4469),(80340,4470),(80341,4470),(80342,4470),(80343,4470),(80344,4470),(80345,4470),(80346,4471),(80347,4471),(80348,4471),(80349,4471),(80350,4471),(80351,4471),(80352,4472),(80353,4472),(80354,4472),(80355,4472),(80356,4472),(80357,4472),(80358,4473),(80359,4473),(80360,4473),(80361,4473),(80362,4473),(80363,4473),(80364,4474),(80365,4474),(80366,4474),(80367,4474),(80368,4474),(80369,4474),(80370,4475),(80371,4475),(80372,4475),(80373,4475),(80374,4475),(80375,4475),(80376,4476),(80377,4476),(80378,4476),(80379,4476),(80380,4476),(80381,4476),(80382,4477),(80383,4477),(80384,4477),(80385,4477),(80386,4477),(80387,4477),(80388,4478),(80389,4478),(80390,4478),(80391,4478),(80392,4478),(80393,4478),(80394,4479),(80395,4479),(80396,4479),(80397,4479),(80398,4479),(80399,4479),(80400,4480),(80401,4480),(80402,4480),(80403,4480),(80404,4480),(80405,4481),(80406,4481),(80407,4481),(80408,4481),(80409,4481),(80410,4481),(80411,4482),(80412,4482),(80413,4482),(80414,4482),(80415,4482),(80416,4482),(80417,4483),(80418,4483),(80419,4483),(80420,4483),(80421,4483),(80422,4483),(80423,4484),(80424,4484),(80425,4484),(80426,4484),(80427,4484),(80428,4484),(80429,4485),(80430,4485),(80431,4485),(80432,4485),(80433,4485),(80434,4485),(80435,4486),(80436,4486),(80437,4486),(80438,4486),(80439,4486),(80440,4486),(80441,4487),(80442,4487),(80443,4487),(80444,4487),(80445,4487),(80446,4487),(80447,4488),(80448,4488),(80449,4488),(80450,4488),(80451,4488),(80452,4488),(80453,4489),(80454,4489),(80455,4489),(80456,4489),(80457,4489),(80458,4489),(80459,4490),(80460,4490),(80461,4490),(80462,4490),(80463,4490),(80464,4490),(80465,4414),(80466,4414),(80467,4415),(80468,4415),(80469,4416),(80470,4416),(80471,4417),(80472,4417),(80473,4418),(80474,4418),(80475,4419),(80476,4419),(80477,4420),(80478,4420),(80479,4421),(80480,4421),(80481,4422),(80482,4422),(80483,4423),(80484,4423),(80485,4424),(80486,4424),(80487,4425),(80488,4425),(80489,4426),(80490,4426),(80491,4427),(80492,4427),(80493,4428),(80494,4428),(80495,4429),(80496,4429),(80497,4430),(80498,4430),(80499,4431),(80500,4431),(80501,4432),(80502,4433),(80503,4434),(80504,4434),(80505,4435),(80506,4435),(80507,4436),(80508,4436),(80509,4437),(80510,4437),(80511,4437),(80512,4438),(80513,4438),(80514,4439),(80515,4439),(80516,4440),(80517,4440),(80518,4441),(80519,4441),(80520,4442),(80521,4442),(80522,4443),(80523,4443),(80524,4444),(80525,4444),(80526,4445),(80527,4445),(80528,4446),(80529,4446),(80530,4447),(80531,4447),(80532,4448),(80533,4448),(80534,4449),(80535,4449),(80536,4450),(80537,4450),(80538,4451),(80539,4451),(80540,4452),(80541,4452),(80542,4453),(80543,4453),(80544,4454),(80545,4454),(80546,4455),(80547,4455),(80548,4456),(80549,4456),(80550,4457),(80551,4457),(80552,4458),(80553,4458),(80554,4459),(80555,4459),(80556,4460),(80557,4460),(80558,4461),(80559,4461),(80560,4462),(80561,4462),(80562,4463),(80563,4463),(80564,4464),(80565,4464),(80566,4465),(80567,4465),(80568,4466),(80569,4466),(80570,4467),(80571,4467),(80572,4468),(80573,4468),(80574,4469),(80575,4469),(80576,4470),(80577,4470),(80578,4471),(80579,4471),(80580,4472),(80581,4472),(80582,4473),(80583,4473),(80584,4474),(80585,4474),(80586,4475),(80587,4475),(80588,4476),(80589,4476),(80590,4477),(80591,4477),(80592,4478),(80593,4478),(80594,4479),(80595,4479),(80596,4480),(80597,4481),(80598,4481),(80599,4482),(80600,4482),(80601,4483),(80602,4483),(80603,4484),(80604,4484),(80605,4485),(80606,4485),(80607,4486),(80608,4486),(80609,4487),(80610,4487),(80611,4488),(80612,4488),(80613,4489),(80614,4489),(80615,4490),(80616,4490),(80617,4414),(80618,4414),(80619,4414),(80620,4415),(80621,4415),(80622,4415),(80623,4416),(80624,4416),(80625,4417),(80626,4417),(80627,4417),(80628,4418),(80629,4418),(80630,4418),(80631,4419),(80632,4419),(80633,4419),(80634,4420),(80635,4420),(80636,4420),(80637,4421),(80638,4421),(80639,4421),(80640,4422),(80641,4422),(80642,4422),(80643,4423),(80644,4423),(80645,4423),(80646,4424),(80647,4424),(80648,4424),(80649,4425),(80650,4425),(80651,4425),(80652,4426),(80653,4426),(80654,4426),(80655,4427),(80656,4427),(80657,4427),(80658,4428),(80659,4428),(80660,4428),(80661,4429),(80662,4429),(80663,4429),(80664,4430),(80665,4430),(80666,4431),(80667,4431),(80668,4432),(80669,4432),(80670,4432),(80671,4433),(80672,4433),(80673,4433),(80674,4434),(80675,4434),(80676,4434),(80677,4435),(80678,4435),(80679,4435),(80680,4436),(80681,4436),(80682,4436),(80683,4437),(80684,4437),(80685,4437),(80686,4438),(80687,4438),(80688,4438),(80689,4439),(80690,4439),(80691,4439),(80692,4440),(80693,4440),(80694,4440),(80695,4441),(80696,4441),(80697,4441),(80698,4442),(80699,4442),(80700,4442),(80701,4443),(80702,4443),(80703,4443),(80704,4444),(80705,4444),(80706,4444),(80707,4445),(80708,4445),(80709,4445),(80710,4446),(80711,4446),(80712,4446),(80713,4447),(80714,4447),(80715,4447),(80716,4448),(80717,4448),(80718,4448),(80719,4449),(80720,4449),(80721,4449),(80722,4450),(80723,4450),(80724,4450),(80725,4451),(80726,4451),(80727,4451),(80728,4452),(80729,4452),(80730,4452),(80731,4453),(80732,4453),(80733,4453),(80734,4454),(80735,4454),(80736,4454),(80737,4455),(80738,4455),(80739,4455),(80740,4456),(80741,4456),(80742,4456),(80743,4457),(80744,4457),(80745,4458),(80746,4458),(80747,4458),(80748,4459),(80749,4459),(80750,4459),(80751,4460),(80752,4460),(80753,4460),(80754,4461),(80755,4461),(80756,4461),(80757,4462),(80758,4462),(80759,4462),(80760,4463),(80761,4463),(80762,4463),(80763,4464),(80764,4464),(80765,4464),(80766,4465),(80767,4465),(80768,4465),(80769,4466),(80770,4466),(80771,4466),(80772,4467),(80773,4467),(80774,4467),(80775,4468),(80776,4468),(80777,4468),(80778,4469),(80779,4469),(80780,4469),(80781,4470),(80782,4470),(80783,4470),(80784,4471),(80785,4471),(80786,4471),(80787,4472),(80788,4472),(80789,4472),(80790,4473),(80791,4473),(80792,4473),(80793,4474),(80794,4474),(80795,4474),(80796,4475),(80797,4475),(80798,4475),(80799,4476),(80800,4476),(80801,4476),(80802,4477),(80803,4477),(80804,4477),(80805,4478),(80806,4478),(80807,4478),(80808,4479),(80809,4479),(80810,4479),(80811,4480),(80812,4480),(80813,4480),(80814,4481),(80815,4481),(80816,4481),(80817,4482),(80818,4482),(80819,4482),(80820,4483),(80821,4483),(80822,4483),(80823,4484),(80824,4484),(80825,4484),(80826,4485),(80827,4485),(80828,4485),(80829,4486),(80830,4486),(80831,4486),(80832,4487),(80833,4487),(80834,4487),(80835,4488),(80836,4488),(80837,4488),(80838,4489),(80839,4489),(80840,4489),(80841,4490),(80842,4490),(80843,4490),(80844,4414),(80845,4414),(80846,4414),(80847,4414),(80848,4415),(80849,4415),(80850,4415),(80851,4415),(80852,4416),(80853,4416),(80854,4416),(80855,4416),(80856,4417),(80857,4417),(80858,4417),(80859,4417),(80860,4418),(80861,4418),(80862,4418),(80863,4418),(80864,4419),(80865,4419),(80866,4419),(80867,4419),(80868,4420),(80869,4420),(80870,4420),(80871,4420),(80872,4421),(80873,4421),(80874,4421),(80875,4421),(80876,4422),(80877,4422),(80878,4422),(80879,4422),(80880,4423),(80881,4423),(80882,4423),(80883,4423),(80884,4424),(80885,4424),(80886,4424),(80887,4424),(80888,4425),(80889,4425),(80890,4425),(80891,4425),(80892,4426),(80893,4426),(80894,4426),(80895,4426),(80896,4427),(80897,4427),(80898,4427),(80899,4427),(80900,4428),(80901,4428),(80902,4428),(80903,4428),(80904,4429),(80905,4429),(80906,4429),(80907,4429),(80908,4430),(80909,4430),(80910,4430),(80911,4430),(80912,4431),(80913,4431),(80914,4431),(80915,4431),(80916,4432),(80917,4432),(80918,4432),(80919,4432),(80920,4433),(80921,4433),(80922,4433),(80923,4433),(80924,4434),(80925,4434),(80926,4434),(80927,4434),(80928,4435),(80929,4435),(80930,4435),(80931,4435),(80932,4436),(80933,4436),(80934,4436),(80935,4436),(80936,4437),(80937,4437),(80938,4437),(80939,4437),(80940,4438),(80941,4438),(80942,4438),(80943,4438),(80944,4439),(80945,4439),(80946,4439),(80947,4439),(80948,4440),(80949,4440),(80950,4440),(80951,4440),(80952,4441),(80953,4441),(80954,4441),(80955,4441),(80956,4442),(80957,4442),(80958,4442),(80959,4442),(80960,4443),(80961,4443),(80962,4443),(80963,4443),(80964,4444),(80965,4444),(80966,4444),(80967,4444),(80968,4445),(80969,4445),(80970,4445),(80971,4445),(80972,4446),(80973,4446),(80974,4446),(80975,4446),(80976,4447),(80977,4447),(80978,4447),(80979,4447),(80980,4448),(80981,4448),(80982,4448),(80983,4448),(80984,4449),(80985,4449),(80986,4449),(80987,4449),(80988,4450),(80989,4450),(80990,4450),(80991,4450),(80992,4451),(80993,4451),(80994,4451),(80995,4451),(80996,4452),(80997,4452),(80998,4452),(80999,4452),(81000,4453),(81001,4453),(81002,4453),(81003,4453),(81004,4454),(81005,4454),(81006,4454),(81007,4454),(81008,4455),(81009,4455),(81010,4455),(81011,4455),(81012,4456),(81013,4456),(81014,4456),(81015,4456),(81016,4457),(81017,4457),(81018,4457),(81019,4457),(81020,4458),(81021,4458),(81022,4458),(81023,4458),(81024,4459),(81025,4459),(81026,4459),(81027,4459),(81028,4460),(81029,4460),(81030,4460),(81031,4460),(81032,4461),(81033,4461),(81034,4461),(81035,4461),(81036,4462),(81037,4462),(81038,4462),(81039,4462),(81040,4463),(81041,4463),(81042,4463),(81043,4463),(81044,4464),(81045,4464),(81046,4464),(81047,4464),(81048,4465),(81049,4465),(81050,4465),(81051,4465),(81052,4466),(81053,4466),(81054,4466),(81055,4466),(81056,4467),(81057,4467),(81058,4467),(81059,4467),(81060,4468),(81061,4468),(81062,4468),(81063,4468),(81064,4469),(81065,4469),(81066,4469),(81067,4469),(81068,4470),(81069,4470),(81070,4470),(81071,4470),(81072,4471),(81073,4471),(81074,4471),(81075,4471),(81076,4472),(81077,4472),(81078,4472),(81079,4472),(81080,4473),(81081,4473),(81082,4473),(81083,4473),(81084,4474),(81085,4474),(81086,4474),(81087,4474),(81088,4475),(81089,4475),(81090,4475),(81091,4475),(81092,4476),(81093,4476),(81094,4476),(81095,4476),(81096,4477),(81097,4477),(81098,4477),(81099,4477),(81100,4478),(81101,4478),(81102,4478),(81103,4478),(81104,4479),(81105,4479),(81106,4479),(81107,4479),(81108,4480),(81109,4480),(81110,4480),(81111,4480),(81112,4481),(81113,4481),(81114,4481),(81115,4481),(81116,4482),(81117,4482),(81118,4482),(81119,4482),(81120,4483),(81121,4483),(81122,4483),(81123,4483),(81124,4484),(81125,4484),(81126,4484),(81127,4484),(81128,4485),(81129,4485),(81130,4485),(81131,4485),(81132,4486),(81133,4486),(81134,4486),(81135,4486),(81136,4487),(81137,4487),(81138,4487),(81139,4487),(81140,4488),(81141,4488),(81142,4488),(81143,4488),(81144,4489),(81145,4489),(81146,4489),(81147,4489),(81148,4490),(81149,4490),(81150,4490),(81151,4490),(81152,4491),(81153,4492),(81154,4493),(81155,4494),(81156,4495),(81157,4496),(81158,4497),(81159,4498),(81160,4499),(81161,4500),(81162,4501),(81163,4502),(81164,4503),(81165,4504),(81166,4505),(81167,4506),(81168,4507),(81169,4508),(81170,4509),(81171,4510),(81172,4511),(81173,4512),(81174,4513),(81175,4514),(81176,4515),(81177,4516),(81178,4517),(81179,4518),(81180,4519),(81181,4520),(81182,4521),(81183,4522),(81184,4523),(81185,4524),(81186,4525),(81187,4526),(81188,4527),(81189,4528),(81190,4529),(81191,4530),(81192,4531),(81193,4532),(81194,4533),(81195,4534),(81196,4535),(81197,4536),(81198,4537),(81199,4538),(81200,4539),(81201,4540),(81202,4541),(81203,4542),(81204,4543),(81205,4544),(81206,4545),(81207,4546),(81208,4547),(81209,4548),(81210,4549),(81211,4550),(81212,4551),(81213,4552),(81214,4553),(81215,4554),(81216,4555),(81217,4556),(81218,4557),(81219,4558),(81220,4559),(81221,4560),(81222,4561),(81223,4562),(81224,4563),(81225,4564),(81226,4565),(81227,4566),(81228,4567),(81229,4568),(81230,4569),(81231,4570),(81232,4571),(81233,4572),(81234,4573),(81235,4574),(81236,4575),(81237,4576),(81238,4577),(81239,4578),(81240,4579),(81241,4491),(81242,4492),(81243,4493),(81244,4494),(81245,4495),(81246,4496),(81247,4497),(81248,4498),(81249,4499),(81250,4500),(81251,4501),(81252,4502),(81253,4503),(81254,4504),(81255,4505),(81256,4506),(81257,4507),(81258,4508),(81259,4509),(81260,4510),(81261,4511),(81262,4512),(81263,4513),(81264,4514),(81265,4515),(81266,4516),(81267,4517),(81268,4518),(81269,4519),(81270,4520),(81271,4521),(81272,4522),(81273,4523),(81274,4524),(81275,4525),(81276,4526),(81277,4527),(81278,4528),(81279,4529),(81280,4530),(81281,4531),(81282,4532),(81283,4533),(81284,4534),(81285,4535),(81286,4536),(81287,4537),(81288,4538),(81289,4539),(81290,4540),(81291,4541),(81292,4542),(81293,4543),(81294,4544),(81295,4545),(81296,4546),(81297,4547),(81298,4548),(81299,4549),(81300,4550),(81301,4551),(81302,4552),(81303,4553),(81304,4554),(81305,4555),(81306,4556),(81307,4557),(81308,4558),(81309,4559),(81310,4560),(81311,4561),(81312,4562),(81313,4563),(81314,4564),(81315,4565),(81316,4566),(81317,4567),(81318,4568),(81319,4569),(81320,4570),(81321,4571),(81322,4572),(81323,4573),(81324,4574),(81325,4575),(81326,4576),(81327,4577),(81328,4578),(81329,4579),(81330,4491),(81331,4491),(81332,4491),(81333,4491),(81334,4491),(81335,4491),(81336,4492),(81337,4492),(81338,4492),(81339,4492),(81340,4492),(81341,4492),(81342,4493),(81343,4493),(81344,4493),(81345,4493),(81346,4493),(81347,4493),(81348,4494),(81349,4494),(81350,4494),(81351,4494),(81352,4494),(81353,4494),(81354,4495),(81355,4495),(81356,4495),(81357,4495),(81358,4495),(81359,4495),(81360,4496),(81361,4496),(81362,4496),(81363,4496),(81364,4496),(81365,4496),(81366,4497),(81367,4497),(81368,4497),(81369,4497),(81370,4497),(81371,4497),(81372,4498),(81373,4498),(81374,4498),(81375,4498),(81376,4498),(81377,4498),(81378,4499),(81379,4499),(81380,4499),(81381,4499),(81382,4499),(81383,4499),(81384,4500),(81385,4500),(81386,4500),(81387,4500),(81388,4500),(81389,4500),(81390,4501),(81391,4501),(81392,4501),(81393,4501),(81394,4501),(81395,4501),(81396,4502),(81397,4502),(81398,4502),(81399,4502),(81400,4502),(81401,4502),(81402,4503),(81403,4503),(81404,4503),(81405,4503),(81406,4503),(81407,4503),(81408,4504),(81409,4504),(81410,4504),(81411,4504),(81412,4504),(81413,4504),(81414,4505),(81415,4505),(81416,4505),(81417,4505),(81418,4505),(81419,4505),(81420,4506),(81421,4506),(81422,4506),(81423,4506),(81424,4506),(81425,4506),(81426,4507),(81427,4507),(81428,4507),(81429,4507),(81430,4507),(81431,4507),(81432,4508),(81433,4508),(81434,4508),(81435,4508),(81436,4508),(81437,4508),(81438,4509),(81439,4509),(81440,4509),(81441,4509),(81442,4509),(81443,4509),(81444,4510),(81445,4510),(81446,4510),(81447,4510),(81448,4510),(81449,4510),(81450,4511),(81451,4511),(81452,4511),(81453,4511),(81454,4511),(81455,4511),(81456,4512),(81457,4512),(81458,4512),(81459,4512),(81460,4512),(81461,4512),(81462,4513),(81463,4513),(81464,4513),(81465,4513),(81466,4513),(81467,4513),(81468,4514),(81469,4514),(81470,4514),(81471,4514),(81472,4514),(81473,4514),(81474,4515),(81475,4515),(81476,4515),(81477,4515),(81478,4515),(81479,4515),(81480,4516),(81481,4516),(81482,4516),(81483,4516),(81484,4516),(81485,4516),(81486,4517),(81487,4517),(81488,4517),(81489,4517),(81490,4517),(81491,4517),(81492,4518),(81493,4518),(81494,4518),(81495,4518),(81496,4518),(81497,4518),(81498,4519),(81499,4519),(81500,4519),(81501,4519),(81502,4519),(81503,4519),(81504,4520),(81505,4520),(81506,4520),(81507,4520),(81508,4520),(81509,4520),(81510,4521),(81511,4521),(81512,4521),(81513,4521),(81514,4521),(81515,4521),(81516,4522),(81517,4522),(81518,4522),(81519,4522),(81520,4522),(81521,4522),(81522,4523),(81523,4523),(81524,4523),(81525,4523),(81526,4523),(81527,4523),(81528,4524),(81529,4524),(81530,4524),(81531,4524),(81532,4524),(81533,4524),(81534,4525),(81535,4525),(81536,4525),(81537,4525),(81538,4525),(81539,4525),(81540,4526),(81541,4526),(81542,4526),(81543,4526),(81544,4526),(81545,4526),(81546,4527),(81547,4527),(81548,4527),(81549,4527),(81550,4527),(81551,4527),(81552,4528),(81553,4528),(81554,4528),(81555,4528),(81556,4528),(81557,4528),(81558,4529),(81559,4529),(81560,4529),(81561,4529),(81562,4529),(81563,4529),(81564,4530),(81565,4530),(81566,4530),(81567,4530),(81568,4530),(81569,4530),(81570,4531),(81571,4531),(81572,4531),(81573,4531),(81574,4531),(81575,4531),(81576,4532),(81577,4532),(81578,4532),(81579,4532),(81580,4532),(81581,4532),(81582,4533),(81583,4533),(81584,4533),(81585,4533),(81586,4533),(81587,4533),(81588,4534),(81589,4534),(81590,4534),(81591,4534),(81592,4534),(81593,4534),(81594,4535),(81595,4535),(81596,4535),(81597,4535),(81598,4535),(81599,4535),(81600,4536),(81601,4536),(81602,4536),(81603,4536),(81604,4536),(81605,4536),(81606,4537),(81607,4537),(81608,4537),(81609,4537),(81610,4537),(81611,4537),(81612,4538),(81613,4538),(81614,4538),(81615,4538),(81616,4538),(81617,4538),(81618,4539),(81619,4539),(81620,4539),(81621,4539),(81622,4539),(81623,4539),(81624,4540),(81625,4540),(81626,4540),(81627,4540),(81628,4540),(81629,4540),(81630,4541),(81631,4541),(81632,4541),(81633,4541),(81634,4541),(81635,4541),(81636,4542),(81637,4542),(81638,4542),(81639,4542),(81640,4542),(81641,4542),(81642,4543),(81643,4543),(81644,4543),(81645,4543),(81646,4543),(81647,4543),(81648,4544),(81649,4544),(81650,4544),(81651,4544),(81652,4544),(81653,4544),(81654,4545),(81655,4545),(81656,4545),(81657,4545),(81658,4545),(81659,4545),(81660,4546),(81661,4546),(81662,4546),(81663,4546),(81664,4546),(81665,4546),(81666,4547),(81667,4547),(81668,4547),(81669,4547),(81670,4547),(81671,4547),(81672,4548),(81673,4548),(81674,4548),(81675,4548),(81676,4548),(81677,4548),(81678,4549),(81679,4549),(81680,4549),(81681,4549),(81682,4549),(81683,4549),(81684,4550),(81685,4550),(81686,4550),(81687,4550),(81688,4550),(81689,4550),(81690,4551),(81691,4551),(81692,4551),(81693,4551),(81694,4551),(81695,4551),(81696,4552),(81697,4552),(81698,4552),(81699,4552),(81700,4552),(81701,4552),(81702,4553),(81703,4553),(81704,4553),(81705,4553),(81706,4553),(81707,4553),(81708,4554),(81709,4554),(81710,4554),(81711,4554),(81712,4554),(81713,4554),(81714,4555),(81715,4555),(81716,4555),(81717,4555),(81718,4555),(81719,4555),(81720,4556),(81721,4556),(81722,4556),(81723,4556),(81724,4556),(81725,4556),(81726,4557),(81727,4557),(81728,4557),(81729,4557),(81730,4557),(81731,4557),(81732,4558),(81733,4558),(81734,4558),(81735,4558),(81736,4558),(81737,4558),(81738,4559),(81739,4559),(81740,4559),(81741,4559),(81742,4559),(81743,4559),(81744,4560),(81745,4560),(81746,4560),(81747,4560),(81748,4560),(81749,4560),(81750,4561),(81751,4561),(81752,4561),(81753,4561),(81754,4561),(81755,4561),(81756,4562),(81757,4562),(81758,4562),(81759,4562),(81760,4562),(81761,4562),(81762,4563),(81763,4563),(81764,4563),(81765,4563),(81766,4563),(81767,4563),(81768,4564),(81769,4564),(81770,4564),(81771,4564),(81772,4564),(81773,4564),(81774,4565),(81775,4565),(81776,4565),(81777,4565),(81778,4565),(81779,4565),(81780,4566),(81781,4566),(81782,4566),(81783,4566),(81784,4566),(81785,4566),(81786,4567),(81787,4567),(81788,4567),(81789,4567),(81790,4567),(81791,4567),(81792,4568),(81793,4568),(81794,4568),(81795,4568),(81796,4569),(81797,4569),(81798,4569),(81799,4569),(81800,4570),(81801,4570),(81802,4570),(81803,4570),(81804,4571),(81805,4571),(81806,4571),(81807,4571),(81808,4572),(81809,4572),(81810,4572),(81811,4572),(81812,4572),(81813,4572),(81814,4573),(81815,4573),(81816,4573),(81817,4573),(81818,4573),(81819,4573),(81820,4574),(81821,4574),(81822,4574),(81823,4574),(81824,4574),(81825,4574),(81826,4575),(81827,4575),(81828,4575),(81829,4575),(81830,4576),(81831,4576),(81832,4576),(81833,4576),(81834,4577),(81835,4577),(81836,4577),(81837,4577),(81838,4577),(81839,4577),(81840,4578),(81841,4578),(81842,4578),(81843,4578),(81844,4578),(81845,4579),(81846,4579),(81847,4579),(81848,4579),(81849,4579),(81850,4491),(81851,4491),(81852,4492),(81853,4492),(81854,4493),(81855,4493),(81856,4494),(81857,4494),(81858,4495),(81859,4495),(81860,4496),(81861,4496),(81862,4497),(81863,4497),(81864,4498),(81865,4498),(81866,4499),(81867,4499),(81868,4500),(81869,4500),(81870,4501),(81871,4501),(81872,4502),(81873,4502),(81874,4503),(81875,4503),(81876,4504),(81877,4504),(81878,4505),(81879,4505),(81880,4506),(81881,4506),(81882,4507),(81883,4507),(81884,4508),(81885,4508),(81886,4509),(81887,4509),(81888,4510),(81889,4510),(81890,4511),(81891,4511),(81892,4512),(81893,4512),(81894,4513),(81895,4513),(81896,4514),(81897,4514),(81898,4515),(81899,4515),(81900,4516),(81901,4516),(81902,4517),(81903,4517),(81904,4518),(81905,4518),(81906,4519),(81907,4519),(81908,4520),(81909,4520),(81910,4521),(81911,4521),(81912,4522),(81913,4522),(81914,4523),(81915,4523),(81916,4524),(81917,4524),(81918,4525),(81919,4525),(81920,4526),(81921,4526),(81922,4527),(81923,4527),(81924,4528),(81925,4528),(81926,4529),(81927,4529),(81928,4530),(81929,4530),(81930,4531),(81931,4531),(81932,4532),(81933,4532),(81934,4533),(81935,4533),(81936,4534),(81937,4534),(81938,4535),(81939,4535),(81940,4536),(81941,4536),(81942,4537),(81943,4537),(81944,4538),(81945,4538),(81946,4539),(81947,4539),(81948,4540),(81949,4540),(81950,4541),(81951,4541),(81952,4542),(81953,4542),(81954,4543),(81955,4543),(81956,4544),(81957,4544),(81958,4545),(81959,4545),(81960,4546),(81961,4546),(81962,4547),(81963,4547),(81964,4548),(81965,4548),(81966,4549),(81967,4549),(81968,4550),(81969,4550),(81970,4551),(81971,4551),(81972,4552),(81973,4552),(81974,4553),(81975,4553),(81976,4554),(81977,4554),(81978,4555),(81979,4555),(81980,4556),(81981,4556),(81982,4557),(81983,4557),(81984,4558),(81985,4558),(81986,4559),(81987,4559),(81988,4560),(81989,4560),(81990,4561),(81991,4561),(81992,4562),(81993,4562),(81994,4563),(81995,4563),(81996,4564),(81997,4564),(81998,4565),(81999,4565),(82000,4566),(82001,4566),(82002,4567),(82003,4567),(82004,4568),(82005,4569),(82006,4570),(82007,4571),(82008,4572),(82009,4572),(82010,4573),(82011,4573),(82012,4573),(82013,4574),(82014,4574),(82015,4574),(82016,4575),(82017,4575),(82018,4576),(82019,4576),(82020,4577),(82021,4577),(82022,4578),(82023,4578),(82024,4578),(82025,4579),(82026,4579),(82027,4579),(82028,4491),(82029,4491),(82030,4491),(82031,4492),(82032,4492),(82033,4492),(82034,4493),(82035,4493),(82036,4493),(82037,4494),(82038,4494),(82039,4494),(82040,4495),(82041,4495),(82042,4495),(82043,4496),(82044,4496),(82045,4496),(82046,4497),(82047,4497),(82048,4497),(82049,4498),(82050,4498),(82051,4498),(82052,4499),(82053,4499),(82054,4499),(82055,4500),(82056,4500),(82057,4500),(82058,4501),(82059,4501),(82060,4501),(82061,4502),(82062,4502),(82063,4502),(82064,4503),(82065,4503),(82066,4503),(82067,4504),(82068,4504),(82069,4504),(82070,4505),(82071,4505),(82072,4505),(82073,4506),(82074,4506),(82075,4506),(82076,4507),(82077,4507),(82078,4507),(82079,4508),(82080,4508),(82081,4508),(82082,4509),(82083,4509),(82084,4509),(82085,4510),(82086,4510),(82087,4510),(82088,4511),(82089,4511),(82090,4511),(82091,4512),(82092,4512),(82093,4512),(82094,4513),(82095,4513),(82096,4513),(82097,4514),(82098,4514),(82099,4514),(82100,4515),(82101,4515),(82102,4515),(82103,4516),(82104,4516),(82105,4516),(82106,4517),(82107,4517),(82108,4517),(82109,4518),(82110,4518),(82111,4518),(82112,4519),(82113,4519),(82114,4519),(82115,4520),(82116,4520),(82117,4520),(82118,4521),(82119,4521),(82120,4521),(82121,4522),(82122,4522),(82123,4522),(82124,4523),(82125,4523),(82126,4523),(82127,4524),(82128,4524),(82129,4524),(82130,4525),(82131,4525),(82132,4525),(82133,4526),(82134,4526),(82135,4526),(82136,4527),(82137,4527),(82138,4527),(82139,4528),(82140,4528),(82141,4528),(82142,4529),(82143,4529),(82144,4529),(82145,4530),(82146,4530),(82147,4530),(82148,4531),(82149,4531),(82150,4531),(82151,4532),(82152,4532),(82153,4532),(82154,4533),(82155,4533),(82156,4533),(82157,4534),(82158,4534),(82159,4534),(82160,4535),(82161,4535),(82162,4535),(82163,4536),(82164,4536),(82165,4536),(82166,4537),(82167,4537),(82168,4537),(82169,4538),(82170,4538),(82171,4539),(82172,4539),(82173,4539),(82174,4540),(82175,4540),(82176,4540),(82177,4541),(82178,4541),(82179,4541),(82180,4542),(82181,4542),(82182,4542),(82183,4543),(82184,4543),(82185,4543),(82186,4544),(82187,4544),(82188,4544),(82189,4545),(82190,4545),(82191,4545),(82192,4546),(82193,4546),(82194,4546),(82195,4547),(82196,4547),(82197,4547),(82198,4548),(82199,4548),(82200,4548),(82201,4549),(82202,4549),(82203,4549),(82204,4550),(82205,4550),(82206,4550),(82207,4551),(82208,4551),(82209,4551),(82210,4552),(82211,4552),(82212,4552),(82213,4553),(82214,4553),(82215,4553),(82216,4554),(82217,4554),(82218,4554),(82219,4555),(82220,4555),(82221,4555),(82222,4556),(82223,4556),(82224,4556),(82225,4557),(82226,4557),(82227,4557),(82228,4558),(82229,4558),(82230,4558),(82231,4559),(82232,4559),(82233,4559),(82234,4560),(82235,4560),(82236,4560),(82237,4561),(82238,4561),(82239,4561),(82240,4562),(82241,4562),(82242,4562),(82243,4563),(82244,4563),(82245,4563),(82246,4564),(82247,4564),(82248,4564),(82249,4565),(82250,4565),(82251,4565),(82252,4566),(82253,4566),(82254,4566),(82255,4567),(82256,4567),(82257,4567),(82258,4568),(82259,4568),(82260,4568),(82261,4569),(82262,4569),(82263,4569),(82264,4570),(82265,4570),(82266,4570),(82267,4571),(82268,4571),(82269,4571),(82270,4572),(82271,4572),(82272,4572),(82273,4573),(82274,4573),(82275,4573),(82276,4574),(82277,4574),(82278,4574),(82279,4575),(82280,4575),(82281,4575),(82282,4576),(82283,4576),(82284,4576),(82285,4577),(82286,4577),(82287,4577),(82288,4578),(82289,4578),(82290,4578),(82291,4579),(82292,4579),(82293,4579),(82294,4491),(82295,4491),(82296,4491),(82297,4491),(82298,4492),(82299,4492),(82300,4492),(82301,4492),(82302,4493),(82303,4493),(82304,4493),(82305,4493),(82306,4494),(82307,4494),(82308,4494),(82309,4494),(82310,4495),(82311,4495),(82312,4495),(82313,4495),(82314,4496),(82315,4496),(82316,4496),(82317,4496),(82318,4497),(82319,4497),(82320,4497),(82321,4497),(82322,4498),(82323,4498),(82324,4498),(82325,4498),(82326,4499),(82327,4499),(82328,4499),(82329,4499),(82330,4500),(82331,4500),(82332,4500),(82333,4500),(82334,4501),(82335,4501),(82336,4501),(82337,4501),(82338,4502),(82339,4502),(82340,4502),(82341,4502),(82342,4503),(82343,4503),(82344,4503),(82345,4503),(82346,4504),(82347,4504),(82348,4504),(82349,4504),(82350,4505),(82351,4505),(82352,4505),(82353,4505),(82354,4506),(82355,4506),(82356,4506),(82357,4506),(82358,4507),(82359,4507),(82360,4507),(82361,4507),(82362,4508),(82363,4508),(82364,4508),(82365,4508),(82366,4509),(82367,4509),(82368,4509),(82369,4509),(82370,4510),(82371,4510),(82372,4510),(82373,4510),(82374,4511),(82375,4511),(82376,4511),(82377,4511),(82378,4512),(82379,4512),(82380,4512),(82381,4512),(82382,4513),(82383,4513),(82384,4513),(82385,4513),(82386,4514),(82387,4514),(82388,4514),(82389,4514),(82390,4515),(82391,4515),(82392,4515),(82393,4515),(82394,4516),(82395,4516),(82396,4516),(82397,4516),(82398,4517),(82399,4517),(82400,4517),(82401,4517),(82402,4518),(82403,4518),(82404,4518),(82405,4518),(82406,4519),(82407,4519),(82408,4519),(82409,4519),(82410,4520),(82411,4520),(82412,4520),(82413,4520),(82414,4521),(82415,4521),(82416,4521),(82417,4521),(82418,4522),(82419,4522),(82420,4522),(82421,4522),(82422,4523),(82423,4523),(82424,4523),(82425,4523),(82426,4524),(82427,4524),(82428,4524),(82429,4524),(82430,4525),(82431,4525),(82432,4525),(82433,4525),(82434,4526),(82435,4526),(82436,4526),(82437,4526),(82438,4527),(82439,4527),(82440,4527),(82441,4527),(82442,4528),(82443,4528),(82444,4528),(82445,4528),(82446,4529),(82447,4529),(82448,4529),(82449,4529),(82450,4530),(82451,4530),(82452,4530),(82453,4530),(82454,4531),(82455,4531),(82456,4531),(82457,4531),(82458,4532),(82459,4532),(82460,4532),(82461,4532),(82462,4533),(82463,4533),(82464,4533),(82465,4533),(82466,4534),(82467,4534),(82468,4534),(82469,4534),(82470,4535),(82471,4535),(82472,4535),(82473,4535),(82474,4536),(82475,4536),(82476,4536),(82477,4536),(82478,4537),(82479,4537),(82480,4537),(82481,4537),(82482,4538),(82483,4538),(82484,4538),(82485,4538),(82486,4539),(82487,4539),(82488,4539),(82489,4539),(82490,4540),(82491,4540),(82492,4540),(82493,4540),(82494,4541),(82495,4541),(82496,4541),(82497,4541),(82498,4542),(82499,4542),(82500,4542),(82501,4542),(82502,4543),(82503,4543),(82504,4543),(82505,4543),(82506,4544),(82507,4544),(82508,4544),(82509,4544),(82510,4545),(82511,4545),(82512,4545),(82513,4545),(82514,4546),(82515,4546),(82516,4546),(82517,4546),(82518,4547),(82519,4547),(82520,4547),(82521,4547),(82522,4548),(82523,4548),(82524,4548),(82525,4548),(82526,4549),(82527,4549),(82528,4549),(82529,4549),(82530,4550),(82531,4550),(82532,4550),(82533,4550),(82534,4551),(82535,4551),(82536,4551),(82537,4551),(82538,4552),(82539,4552),(82540,4552),(82541,4552),(82542,4553),(82543,4553),(82544,4553),(82545,4553),(82546,4554),(82547,4554),(82548,4554),(82549,4554),(82550,4555),(82551,4555),(82552,4555),(82553,4555),(82554,4556),(82555,4556),(82556,4556),(82557,4556),(82558,4557),(82559,4557),(82560,4557),(82561,4557),(82562,4558),(82563,4558),(82564,4558),(82565,4558),(82566,4559),(82567,4559),(82568,4559),(82569,4559),(82570,4560),(82571,4560),(82572,4560),(82573,4560),(82574,4561),(82575,4561),(82576,4561),(82577,4561),(82578,4562),(82579,4562),(82580,4562),(82581,4562),(82582,4563),(82583,4563),(82584,4563),(82585,4563),(82586,4564),(82587,4564),(82588,4564),(82589,4564),(82590,4565),(82591,4565),(82592,4565),(82593,4565),(82594,4566),(82595,4566),(82596,4566),(82597,4566),(82598,4567),(82599,4567),(82600,4567),(82601,4567),(82602,4568),(82603,4568),(82604,4568),(82605,4568),(82606,4569),(82607,4569),(82608,4569),(82609,4569),(82610,4570),(82611,4570),(82612,4570),(82613,4570),(82614,4571),(82615,4571),(82616,4571),(82617,4571),(82618,4572),(82619,4572),(82620,4572),(82621,4572),(82622,4573),(82623,4573),(82624,4573),(82625,4573),(82626,4574),(82627,4574),(82628,4574),(82629,4574),(82630,4575),(82631,4575),(82632,4575),(82633,4575),(82634,4576),(82635,4576),(82636,4576),(82637,4576),(82638,4577),(82639,4577),(82640,4577),(82641,4577),(82642,4578),(82643,4578),(82644,4578),(82645,4578),(82646,4579),(82647,4579),(82648,4579),(82649,4579),(82650,4580),(82651,4581),(82652,4582),(82653,4583),(82654,4584),(82655,4585),(82656,4586),(82657,4587),(82658,4588),(82659,4589),(82660,4590),(82661,4591),(82662,4592),(82663,4593),(82664,4594),(82665,4595),(82666,4596),(82667,4597),(82668,4598),(82669,4599),(82670,4600),(82671,4601),(82672,4602),(82673,4603),(82674,4604),(82675,4605),(82676,4606),(82677,4607),(82678,4608),(82679,4609),(82680,4610),(82681,4611),(82682,4612),(82683,4613),(82684,4614),(82685,4615),(82686,4616),(82687,4617),(82688,4618),(82689,4619),(82690,4620),(82691,4621),(82692,4622),(82693,4623),(82694,4624),(82695,4625),(82696,4626),(82697,4627),(82698,4628),(82699,4629),(82700,4630),(82701,4631),(82702,4632),(82703,4633),(82704,4634),(82705,4635),(82706,4636),(82707,4637),(82708,4638),(82709,4639),(82710,4640),(82711,4641),(82712,4642),(82713,4643),(82714,4644),(82715,4645),(82716,4646),(82717,4647),(82718,4648),(82719,4649),(82720,4650),(82721,4651),(82722,4652),(82723,4653),(82724,4654),(82725,4655),(82726,4656),(82727,4657),(82728,4658),(82729,4659),(82730,4660),(82731,4661),(82732,4662),(82733,4663),(82734,4664),(82735,4665),(82736,4666),(82737,4667),(82738,4668),(82739,4669),(82740,4670),(82741,4671),(82742,4672),(82743,4673),(82744,4674),(82745,4675),(82746,4676),(82747,4677),(82748,4678),(82749,4679),(82750,4580),(82751,4581),(82752,4582),(82753,4583),(82754,4584),(82755,4585),(82756,4586),(82757,4587),(82758,4588),(82759,4589),(82760,4590),(82761,4591),(82762,4592),(82763,4593),(82764,4594),(82765,4595),(82766,4596),(82767,4597),(82768,4598),(82769,4599),(82770,4600),(82771,4601),(82772,4602),(82773,4603),(82774,4604),(82775,4605),(82776,4606),(82777,4607),(82778,4608),(82779,4609),(82780,4610),(82781,4611),(82782,4612),(82783,4613),(82784,4614),(82785,4615),(82786,4616),(82787,4617),(82788,4618),(82789,4619),(82790,4620),(82791,4621),(82792,4622),(82793,4623),(82794,4624),(82795,4625),(82796,4626),(82797,4627),(82798,4628),(82799,4629),(82800,4630),(82801,4631),(82802,4632),(82803,4633),(82804,4634),(82805,4635),(82806,4636),(82807,4637),(82808,4638),(82809,4639),(82810,4640),(82811,4641),(82812,4642),(82813,4643),(82814,4644),(82815,4645),(82816,4646),(82817,4647),(82818,4648),(82819,4649),(82820,4650),(82821,4651),(82822,4652),(82823,4653),(82824,4654),(82825,4655),(82826,4656),(82827,4657),(82828,4658),(82829,4659),(82830,4660),(82831,4661),(82832,4662),(82833,4663),(82834,4664),(82835,4665),(82836,4666),(82837,4667),(82838,4668),(82839,4669),(82840,4670),(82841,4671),(82842,4672),(82843,4673),(82844,4674),(82845,4675),(82846,4676),(82847,4677),(82848,4678),(82849,4679),(82850,4580),(82851,4580),(82852,4580),(82853,4580),(82854,4580),(82855,4581),(82856,4581),(82857,4581),(82858,4581),(82859,4581),(82860,4582),(82861,4582),(82862,4582),(82863,4582),(82864,4582),(82865,4582),(82866,4583),(82867,4583),(82868,4583),(82869,4583),(82870,4583),(82871,4583),(82872,4584),(82873,4584),(82874,4584),(82875,4584),(82876,4584),(82877,4584),(82878,4585),(82879,4585),(82880,4585),(82881,4585),(82882,4585),(82883,4585),(82884,4586),(82885,4586),(82886,4586),(82887,4586),(82888,4586),(82889,4586),(82890,4587),(82891,4587),(82892,4587),(82893,4587),(82894,4587),(82895,4587),(82896,4588),(82897,4588),(82898,4588),(82899,4588),(82900,4588),(82901,4588),(82902,4589),(82903,4589),(82904,4589),(82905,4589),(82906,4589),(82907,4589),(82908,4590),(82909,4590),(82910,4590),(82911,4590),(82912,4590),(82913,4590),(82914,4591),(82915,4591),(82916,4591),(82917,4591),(82918,4591),(82919,4591),(82920,4592),(82921,4592),(82922,4592),(82923,4592),(82924,4592),(82925,4592),(82926,4593),(82927,4593),(82928,4593),(82929,4593),(82930,4593),(82931,4593),(82932,4594),(82933,4594),(82934,4594),(82935,4594),(82936,4594),(82937,4594),(82938,4595),(82939,4595),(82940,4595),(82941,4595),(82942,4595),(82943,4595),(82944,4596),(82945,4596),(82946,4596),(82947,4596),(82948,4596),(82949,4596),(82950,4597),(82951,4597),(82952,4597),(82953,4597),(82954,4597),(82955,4597),(82956,4598),(82957,4598),(82958,4598),(82959,4598),(82960,4598),(82961,4598),(82962,4599),(82963,4599),(82964,4599),(82965,4599),(82966,4599),(82967,4599),(82968,4600),(82969,4600),(82970,4600),(82971,4600),(82972,4600),(82973,4600),(82974,4601),(82975,4601),(82976,4601),(82977,4601),(82978,4601),(82979,4601),(82980,4602),(82981,4602),(82982,4602),(82983,4602),(82984,4602),(82985,4602),(82986,4603),(82987,4603),(82988,4603),(82989,4603),(82990,4603),(82991,4603),(82992,4604),(82993,4604),(82994,4604),(82995,4604),(82996,4604),(82997,4604),(82998,4605),(82999,4605),(83000,4605),(83001,4605),(83002,4605),(83003,4606),(83004,4606),(83005,4606),(83006,4606),(83007,4606),(83008,4607),(83009,4607),(83010,4607),(83011,4607),(83012,4607),(83013,4608),(83014,4608),(83015,4608),(83016,4608),(83017,4608),(83018,4608),(83019,4609),(83020,4609),(83021,4609),(83022,4609),(83023,4610),(83024,4610),(83025,4610),(83026,4610),(83027,4611),(83028,4611),(83029,4611),(83030,4611),(83031,4612),(83032,4612),(83033,4612),(83034,4612),(83035,4612),(83036,4612),(83037,4613),(83038,4613),(83039,4613),(83040,4613),(83041,4613),(83042,4613),(83043,4614),(83044,4614),(83045,4614),(83046,4614),(83047,4614),(83048,4614),(83049,4615),(83050,4615),(83051,4615),(83052,4615),(83053,4616),(83054,4616),(83055,4616),(83056,4616),(83057,4617),(83058,4617),(83059,4617),(83060,4617),(83061,4618),(83062,4618),(83063,4618),(83064,4618),(83065,4619),(83066,4619),(83067,4619),(83068,4619),(83069,4620),(83070,4620),(83071,4620),(83072,4620),(83073,4621),(83074,4621),(83075,4621),(83076,4621),(83077,4621),(83078,4621),(83079,4622),(83080,4622),(83081,4622),(83082,4622),(83083,4622),(83084,4622),(83085,4623),(83086,4623),(83087,4623),(83088,4623),(83089,4623),(83090,4623),(83091,4624),(83092,4624),(83093,4624),(83094,4624),(83095,4624),(83096,4624),(83097,4625),(83098,4625),(83099,4625),(83100,4625),(83101,4625),(83102,4626),(83103,4626),(83104,4626),(83105,4626),(83106,4626),(83107,4627),(83108,4627),(83109,4627),(83110,4627),(83111,4627),(83112,4627),(83113,4628),(83114,4628),(83115,4628),(83116,4628),(83117,4628),(83118,4628),(83119,4629),(83120,4629),(83121,4629),(83122,4629),(83123,4629),(83124,4629),(83125,4630),(83126,4630),(83127,4630),(83128,4630),(83129,4630),(83130,4630),(83131,4631),(83132,4631),(83133,4631),(83134,4631),(83135,4631),(83136,4631),(83137,4632),(83138,4632),(83139,4632),(83140,4632),(83141,4632),(83142,4632),(83143,4633),(83144,4633),(83145,4633),(83146,4633),(83147,4633),(83148,4633),(83149,4634),(83150,4634),(83151,4634),(83152,4634),(83153,4634),(83154,4634),(83155,4635),(83156,4635),(83157,4635),(83158,4635),(83159,4635),(83160,4635),(83161,4636),(83162,4636),(83163,4636),(83164,4636),(83165,4636),(83166,4636),(83167,4637),(83168,4637),(83169,4637),(83170,4637),(83171,4637),(83172,4637),(83173,4638),(83174,4638),(83175,4638),(83176,4638),(83177,4638),(83178,4638),(83179,4639),(83180,4639),(83181,4639),(83182,4639),(83183,4639),(83184,4639),(83185,4640),(83186,4640),(83187,4640),(83188,4640),(83189,4640),(83190,4640),(83191,4641),(83192,4641),(83193,4641),(83194,4641),(83195,4641),(83196,4641),(83197,4642),(83198,4642),(83199,4642),(83200,4642),(83201,4642),(83202,4642),(83203,4643),(83204,4643),(83205,4643),(83206,4643),(83207,4643),(83208,4643),(83209,4644),(83210,4644),(83211,4644),(83212,4644),(83213,4644),(83214,4644),(83215,4645),(83216,4645),(83217,4645),(83218,4645),(83219,4645),(83220,4645),(83221,4646),(83222,4646),(83223,4646),(83224,4646),(83225,4646),(83226,4646),(83227,4647),(83228,4647),(83229,4647),(83230,4647),(83231,4647),(83232,4647),(83233,4648),(83234,4648),(83235,4648),(83236,4648),(83237,4648),(83238,4648),(83239,4649),(83240,4649),(83241,4649),(83242,4649),(83243,4649),(83244,4649),(83245,4650),(83246,4650),(83247,4650),(83248,4650),(83249,4650),(83250,4650),(83251,4651),(83252,4651),(83253,4651),(83254,4651),(83255,4651),(83256,4651),(83257,4652),(83258,4652),(83259,4652),(83260,4652),(83261,4652),(83262,4652),(83263,4653),(83264,4653),(83265,4653),(83266,4653),(83267,4653),(83268,4653),(83269,4654),(83270,4654),(83271,4654),(83272,4654),(83273,4654),(83274,4654),(83275,4655),(83276,4655),(83277,4655),(83278,4655),(83279,4655),(83280,4655),(83281,4656),(83282,4656),(83283,4656),(83284,4656),(83285,4656),(83286,4656),(83287,4657),(83288,4657),(83289,4657),(83290,4657),(83291,4657),(83292,4657),(83293,4658),(83294,4658),(83295,4658),(83296,4658),(83297,4658),(83298,4658),(83299,4659),(83300,4659),(83301,4659),(83302,4659),(83303,4659),(83304,4659),(83305,4660),(83306,4660),(83307,4660),(83308,4660),(83309,4660),(83310,4660),(83311,4661),(83312,4661),(83313,4661),(83314,4661),(83315,4661),(83316,4661),(83317,4662),(83318,4662),(83319,4662),(83320,4662),(83321,4662),(83322,4662),(83323,4663),(83324,4663),(83325,4663),(83326,4663),(83327,4663),(83328,4663),(83329,4664),(83330,4664),(83331,4664),(83332,4664),(83333,4664),(83334,4664),(83335,4665),(83336,4665),(83337,4665),(83338,4665),(83339,4665),(83340,4665),(83341,4666),(83342,4666),(83343,4666),(83344,4666),(83345,4666),(83346,4666),(83347,4667),(83348,4667),(83349,4667),(83350,4667),(83351,4667),(83352,4667),(83353,4668),(83354,4668),(83355,4668),(83356,4668),(83357,4668),(83358,4668),(83359,4669),(83360,4669),(83361,4669),(83362,4669),(83363,4669),(83364,4669),(83365,4670),(83366,4670),(83367,4670),(83368,4670),(83369,4671),(83370,4671),(83371,4671),(83372,4671),(83373,4671),(83374,4671),(83375,4672),(83376,4672),(83377,4672),(83378,4672),(83379,4673),(83380,4673),(83381,4673),(83382,4673),(83383,4673),(83384,4673),(83385,4674),(83386,4674),(83387,4674),(83388,4674),(83389,4674),(83390,4674),(83391,4675),(83392,4675),(83393,4675),(83394,4675),(83395,4675),(83396,4675),(83397,4676),(83398,4676),(83399,4676),(83400,4676),(83401,4676),(83402,4676),(83403,4677),(83404,4677),(83405,4677),(83406,4677),(83407,4678),(83408,4678),(83409,4678),(83410,4678),(83411,4679),(83412,4679),(83413,4679),(83414,4679),(83415,4580),(83416,4580),(83417,4580),(83418,4581),(83419,4581),(83420,4581),(83421,4582),(83422,4582),(83423,4583),(83424,4583),(83425,4584),(83426,4584),(83427,4585),(83428,4585),(83429,4586),(83430,4586),(83431,4587),(83432,4587),(83433,4588),(83434,4588),(83435,4589),(83436,4589),(83437,4590),(83438,4590),(83439,4591),(83440,4591),(83441,4592),(83442,4592),(83443,4593),(83444,4593),(83445,4594),(83446,4594),(83447,4595),(83448,4595),(83449,4596),(83450,4596),(83451,4597),(83452,4597),(83453,4598),(83454,4598),(83455,4599),(83456,4599),(83457,4600),(83458,4600),(83459,4601),(83460,4601),(83461,4602),(83462,4602),(83463,4603),(83464,4603),(83465,4604),(83466,4604),(83467,4605),(83468,4605),(83469,4605),(83470,4606),(83471,4606),(83472,4606),(83473,4607),(83474,4607),(83475,4607),(83476,4608),(83477,4608),(83478,4609),(83479,4609),(83480,4610),(83481,4610),(83482,4611),(83483,4611),(83484,4612),(83485,4612),(83486,4612),(83487,4613),(83488,4613),(83489,4613),(83490,4614),(83491,4614),(83492,4614),(83493,4615),(83494,4615),(83495,4616),(83496,4616),(83497,4617),(83498,4617),(83499,4618),(83500,4618),(83501,4619),(83502,4619),(83503,4620),(83504,4620),(83505,4621),(83506,4621),(83507,4622),(83508,4622),(83509,4622),(83510,4623),(83511,4623),(83512,4623),(83513,4624),(83514,4624),(83515,4624),(83516,4625),(83517,4625),(83518,4625),(83519,4626),(83520,4626),(83521,4626),(83522,4627),(83523,4627),(83524,4628),(83525,4628),(83526,4629),(83527,4629),(83528,4629),(83529,4630),(83530,4630),(83531,4630),(83532,4631),(83533,4631),(83534,4631),(83535,4632),(83536,4632),(83537,4632),(83538,4633),(83539,4633),(83540,4633),(83541,4634),(83542,4634),(83543,4634),(83544,4635),(83545,4635),(83546,4635),(83547,4636),(83548,4636),(83549,4636),(83550,4637),(83551,4637),(83552,4637),(83553,4638),(83554,4638),(83555,4638),(83556,4639),(83557,4639),(83558,4639),(83559,4640),(83560,4640),(83561,4640),(83562,4641),(83563,4641),(83564,4641),(83565,4642),(83566,4642),(83567,4642),(83568,4643),(83569,4643),(83570,4643),(83571,4644),(83572,4644),(83573,4644),(83574,4645),(83575,4645),(83576,4645),(83577,4646),(83578,4646),(83579,4646),(83580,4647),(83581,4647),(83582,4647),(83583,4648),(83584,4648),(83585,4648),(83586,4649),(83587,4649),(83588,4649),(83589,4650),(83590,4650),(83591,4650),(83592,4651),(83593,4651),(83594,4651),(83595,4652),(83596,4652),(83597,4652),(83598,4653),(83599,4653),(83600,4653),(83601,4654),(83602,4654),(83603,4654),(83604,4655),(83605,4655),(83606,4655),(83607,4656),(83608,4656),(83609,4656),(83610,4657),(83611,4657),(83612,4657),(83613,4658),(83614,4658),(83615,4658),(83616,4659),(83617,4659),(83618,4659),(83619,4660),(83620,4660),(83621,4660),(83622,4661),(83623,4661),(83624,4661),(83625,4662),(83626,4662),(83627,4662),(83628,4663),(83629,4663),(83630,4663),(83631,4664),(83632,4664),(83633,4664),(83634,4665),(83635,4665),(83636,4665),(83637,4666),(83638,4666),(83639,4666),(83640,4667),(83641,4667),(83642,4667),(83643,4668),(83644,4668),(83645,4668),(83646,4669),(83647,4669),(83648,4670),(83649,4670),(83650,4671),(83651,4671),(83652,4671),(83653,4672),(83654,4672),(83655,4673),(83656,4673),(83657,4673),(83658,4674),(83659,4674),(83660,4674),(83661,4675),(83662,4675),(83663,4675),(83664,4676),(83665,4676),(83666,4676),(83667,4677),(83668,4677),(83669,4678),(83670,4678),(83671,4679),(83672,4679),(83673,4580),(83674,4580),(83675,4580),(83676,4581),(83677,4581),(83678,4581),(83679,4582),(83680,4582),(83681,4582),(83682,4583),(83683,4583),(83684,4583),(83685,4584),(83686,4584),(83687,4584),(83688,4585),(83689,4585),(83690,4585),(83691,4586),(83692,4586),(83693,4586),(83694,4587),(83695,4587),(83696,4587),(83697,4588),(83698,4588),(83699,4588),(83700,4589),(83701,4589),(83702,4589),(83703,4590),(83704,4590),(83705,4590),(83706,4591),(83707,4591),(83708,4591),(83709,4592),(83710,4592),(83711,4592),(83712,4593),(83713,4593),(83714,4593),(83715,4594),(83716,4594),(83717,4594),(83718,4595),(83719,4595),(83720,4595),(83721,4596),(83722,4596),(83723,4596),(83724,4597),(83725,4597),(83726,4597),(83727,4598),(83728,4598),(83729,4598),(83730,4599),(83731,4599),(83732,4599),(83733,4600),(83734,4600),(83735,4600),(83736,4601),(83737,4601),(83738,4601),(83739,4602),(83740,4602),(83741,4602),(83742,4603),(83743,4603),(83744,4603),(83745,4604),(83746,4604),(83747,4604),(83748,4605),(83749,4605),(83750,4605),(83751,4606),(83752,4606),(83753,4606),(83754,4607),(83755,4607),(83756,4607),(83757,4608),(83758,4608),(83759,4608),(83760,4609),(83761,4609),(83762,4609),(83763,4610),(83764,4610),(83765,4610),(83766,4611),(83767,4611),(83768,4611),(83769,4612),(83770,4612),(83771,4612),(83772,4613),(83773,4613),(83774,4613),(83775,4614),(83776,4614),(83777,4614),(83778,4615),(83779,4615),(83780,4615),(83781,4616),(83782,4616),(83783,4616),(83784,4617),(83785,4617),(83786,4617),(83787,4618),(83788,4618),(83789,4618),(83790,4619),(83791,4619),(83792,4619),(83793,4620),(83794,4620),(83795,4620),(83796,4621),(83797,4621),(83798,4621),(83799,4622),(83800,4622),(83801,4622),(83802,4623),(83803,4623),(83804,4623),(83805,4624),(83806,4624),(83807,4624),(83808,4625),(83809,4625),(83810,4625),(83811,4626),(83812,4626),(83813,4626),(83814,4627),(83815,4627),(83816,4627),(83817,4628),(83818,4628),(83819,4628),(83820,4629),(83821,4629),(83822,4629),(83823,4630),(83824,4630),(83825,4630),(83826,4631),(83827,4631),(83828,4631),(83829,4632),(83830,4632),(83831,4632),(83832,4633),(83833,4633),(83834,4633),(83835,4634),(83836,4634),(83837,4634),(83838,4635),(83839,4635),(83840,4635),(83841,4636),(83842,4636),(83843,4636),(83844,4637),(83845,4637),(83846,4637),(83847,4638),(83848,4638),(83849,4638),(83850,4639),(83851,4639),(83852,4639),(83853,4640),(83854,4640),(83855,4640),(83856,4641),(83857,4641),(83858,4641),(83859,4642),(83860,4642),(83861,4642),(83862,4643),(83863,4643),(83864,4643),(83865,4644),(83866,4644),(83867,4644),(83868,4645),(83869,4645),(83870,4645),(83871,4646),(83872,4646),(83873,4646),(83874,4647),(83875,4647),(83876,4647),(83877,4648),(83878,4648),(83879,4648),(83880,4649),(83881,4649),(83882,4649),(83883,4650),(83884,4650),(83885,4650),(83886,4651),(83887,4651),(83888,4651),(83889,4652),(83890,4652),(83891,4652),(83892,4653),(83893,4653),(83894,4653),(83895,4654),(83896,4654),(83897,4654),(83898,4655),(83899,4655),(83900,4655),(83901,4656),(83902,4656),(83903,4656),(83904,4657),(83905,4657),(83906,4657),(83907,4658),(83908,4658),(83909,4658),(83910,4659),(83911,4659),(83912,4659),(83913,4660),(83914,4660),(83915,4660),(83916,4661),(83917,4661),(83918,4661),(83919,4662),(83920,4662),(83921,4662),(83922,4663),(83923,4663),(83924,4663),(83925,4664),(83926,4664),(83927,4664),(83928,4665),(83929,4665),(83930,4665),(83931,4666),(83932,4666),(83933,4666),(83934,4667),(83935,4667),(83936,4667),(83937,4668),(83938,4668),(83939,4668),(83940,4669),(83941,4669),(83942,4669),(83943,4670),(83944,4670),(83945,4670),(83946,4671),(83947,4671),(83948,4671),(83949,4672),(83950,4672),(83951,4672),(83952,4673),(83953,4673),(83954,4673),(83955,4674),(83956,4674),(83957,4674),(83958,4675),(83959,4675),(83960,4675),(83961,4676),(83962,4676),(83963,4676),(83964,4677),(83965,4677),(83966,4677),(83967,4678),(83968,4678),(83969,4678),(83970,4679),(83971,4679),(83972,4679),(83973,4580),(83974,4580),(83975,4580),(83976,4580),(83977,4581),(83978,4581),(83979,4581),(83980,4581),(83981,4582),(83982,4582),(83983,4582),(83984,4582),(83985,4583),(83986,4583),(83987,4583),(83988,4583),(83989,4584),(83990,4584),(83991,4584),(83992,4584),(83993,4585),(83994,4585),(83995,4585),(83996,4585),(83997,4586),(83998,4586),(83999,4586),(84000,4586),(84001,4587),(84002,4587),(84003,4587),(84004,4587),(84005,4588),(84006,4588),(84007,4588),(84008,4588),(84009,4589),(84010,4589),(84011,4589),(84012,4589),(84013,4590),(84014,4590),(84015,4590),(84016,4590),(84017,4591),(84018,4591),(84019,4591),(84020,4591),(84021,4592),(84022,4592),(84023,4592),(84024,4592),(84025,4593),(84026,4593),(84027,4593),(84028,4593),(84029,4594),(84030,4594),(84031,4594),(84032,4594),(84033,4595),(84034,4595),(84035,4595),(84036,4595),(84037,4596),(84038,4596),(84039,4596),(84040,4596),(84041,4597),(84042,4597),(84043,4597),(84044,4597),(84045,4598),(84046,4598),(84047,4598),(84048,4598),(84049,4599),(84050,4599),(84051,4599),(84052,4599),(84053,4600),(84054,4600),(84055,4600),(84056,4600),(84057,4601),(84058,4601),(84059,4601),(84060,4601),(84061,4602),(84062,4602),(84063,4602),(84064,4602),(84065,4603),(84066,4603),(84067,4603),(84068,4603),(84069,4604),(84070,4604),(84071,4604),(84072,4604),(84073,4605),(84074,4605),(84075,4605),(84076,4605),(84077,4606),(84078,4606),(84079,4606),(84080,4606),(84081,4607),(84082,4607),(84083,4607),(84084,4607),(84085,4608),(84086,4608),(84087,4608),(84088,4608),(84089,4609),(84090,4609),(84091,4609),(84092,4609),(84093,4610),(84094,4610),(84095,4610),(84096,4610),(84097,4611),(84098,4611),(84099,4611),(84100,4611),(84101,4612),(84102,4612),(84103,4612),(84104,4612),(84105,4613),(84106,4613),(84107,4613),(84108,4613),(84109,4614),(84110,4614),(84111,4614),(84112,4614),(84113,4615),(84114,4615),(84115,4615),(84116,4615),(84117,4616),(84118,4616),(84119,4616),(84120,4616),(84121,4617),(84122,4617),(84123,4617),(84124,4617),(84125,4618),(84126,4618),(84127,4618),(84128,4618),(84129,4619),(84130,4619),(84131,4619),(84132,4619),(84133,4620),(84134,4620),(84135,4620),(84136,4620),(84137,4621),(84138,4621),(84139,4621),(84140,4621),(84141,4622),(84142,4622),(84143,4622),(84144,4622),(84145,4623),(84146,4623),(84147,4623),(84148,4623),(84149,4624),(84150,4624),(84151,4624),(84152,4624),(84153,4625),(84154,4625),(84155,4625),(84156,4625),(84157,4626),(84158,4626),(84159,4626),(84160,4626),(84161,4627),(84162,4627),(84163,4627),(84164,4627),(84165,4628),(84166,4628),(84167,4628),(84168,4628),(84169,4629),(84170,4629),(84171,4629),(84172,4629),(84173,4630),(84174,4630),(84175,4630),(84176,4630),(84177,4631),(84178,4631),(84179,4631),(84180,4631),(84181,4632),(84182,4632),(84183,4632),(84184,4632),(84185,4633),(84186,4633),(84187,4633),(84188,4633),(84189,4634),(84190,4634),(84191,4634),(84192,4634),(84193,4635),(84194,4635),(84195,4635),(84196,4635),(84197,4636),(84198,4636),(84199,4636),(84200,4636),(84201,4637),(84202,4637),(84203,4637),(84204,4637),(84205,4638),(84206,4638),(84207,4638),(84208,4638),(84209,4639),(84210,4639),(84211,4639),(84212,4639),(84213,4640),(84214,4640),(84215,4640),(84216,4640),(84217,4641),(84218,4641),(84219,4641),(84220,4641),(84221,4642),(84222,4642),(84223,4642),(84224,4642),(84225,4643),(84226,4643),(84227,4643),(84228,4643),(84229,4644),(84230,4644),(84231,4644),(84232,4644),(84233,4645),(84234,4645),(84235,4645),(84236,4645),(84237,4646),(84238,4646),(84239,4646),(84240,4646),(84241,4647),(84242,4647),(84243,4647),(84244,4647),(84245,4648),(84246,4648),(84247,4648),(84248,4648),(84249,4649),(84250,4649),(84251,4649),(84252,4649),(84253,4650),(84254,4650),(84255,4650),(84256,4650),(84257,4651),(84258,4651),(84259,4651),(84260,4651),(84261,4652),(84262,4652),(84263,4652),(84264,4652),(84265,4653),(84266,4653),(84267,4653),(84268,4653),(84269,4654),(84270,4654),(84271,4654),(84272,4654),(84273,4655),(84274,4655),(84275,4655),(84276,4655),(84277,4656),(84278,4656),(84279,4656),(84280,4656),(84281,4657),(84282,4657),(84283,4657),(84284,4657),(84285,4658),(84286,4658),(84287,4658),(84288,4658),(84289,4659),(84290,4659),(84291,4659),(84292,4659),(84293,4660),(84294,4660),(84295,4660),(84296,4660),(84297,4661),(84298,4661),(84299,4661),(84300,4661),(84301,4662),(84302,4662),(84303,4662),(84304,4662),(84305,4663),(84306,4663),(84307,4663),(84308,4663),(84309,4664),(84310,4664),(84311,4664),(84312,4664),(84313,4665),(84314,4665),(84315,4665),(84316,4665),(84317,4666),(84318,4666),(84319,4666),(84320,4666),(84321,4667),(84322,4667),(84323,4667),(84324,4667),(84325,4668),(84326,4668),(84327,4668),(84328,4668),(84329,4669),(84330,4669),(84331,4669),(84332,4669),(84333,4670),(84334,4670),(84335,4670),(84336,4670),(84337,4671),(84338,4671),(84339,4671),(84340,4671),(84341,4672),(84342,4672),(84343,4672),(84344,4672),(84345,4673),(84346,4673),(84347,4673),(84348,4673),(84349,4674),(84350,4674),(84351,4674),(84352,4674),(84353,4675),(84354,4675),(84355,4675),(84356,4675),(84357,4676),(84358,4676),(84359,4676),(84360,4676),(84361,4677),(84362,4677),(84363,4677),(84364,4677),(84365,4678),(84366,4678),(84367,4678),(84368,4678),(84369,4679),(84370,4679),(84371,4679),(84372,4679),(84373,4680),(84374,4681),(84375,4682),(84376,4683),(84377,4684),(84378,4685),(84379,4686),(84380,4687),(84381,4688),(84382,4689),(84383,4690),(84384,4691),(84385,4692),(84386,4693),(84387,4694),(84388,4695),(84389,4696),(84390,4697),(84391,4698),(84392,4699),(84393,4700),(84394,4701),(84395,4702),(84396,4703),(84397,4704),(84398,4705),(84399,4706),(84400,4707),(84401,4708),(84402,4709),(84403,4710),(84404,4711),(84405,4712),(84406,4713),(84407,4714),(84408,4715),(84409,4716),(84410,4717),(84411,4718),(84412,4719),(84413,4720),(84414,4721),(84415,4722),(84416,4723),(84417,4724),(84418,4725),(84419,4726),(84420,4727),(84421,4728),(84422,4729),(84423,4730),(84424,4731),(84425,4732),(84426,4733),(84427,4734),(84428,4735),(84429,4736),(84430,4737),(84431,4738),(84432,4739),(84433,4740),(84434,4741),(84435,4742),(84436,4743),(84437,4744),(84438,4745),(84439,4746),(84440,4747),(84441,4748),(84442,4749),(84443,4750),(84444,4751),(84445,4752),(84446,4753),(84447,4754),(84448,4755),(84449,4756),(84450,4757),(84451,4758),(84452,4759),(84453,4760),(84454,4761),(84455,4762),(84456,4763),(84457,4764),(84458,4765),(84459,4766),(84460,4767),(84461,4768),(84462,4769),(84463,4770),(84464,4771),(84465,4772),(84466,4773),(84467,4774),(84468,4775),(84469,4776),(84470,4777),(84471,4778),(84472,4779),(84473,4680),(84474,4681),(84475,4682),(84476,4683),(84477,4684),(84478,4685),(84479,4686),(84480,4687),(84481,4688),(84482,4689),(84483,4690),(84484,4691),(84485,4692),(84486,4693),(84487,4694),(84488,4695),(84489,4696),(84490,4697),(84491,4698),(84492,4699),(84493,4700),(84494,4701),(84495,4702),(84496,4703),(84497,4704),(84498,4705),(84499,4706),(84500,4707),(84501,4708),(84502,4709),(84503,4710),(84504,4711),(84505,4712),(84506,4713),(84507,4714),(84508,4715),(84509,4716),(84510,4717),(84511,4718),(84512,4719),(84513,4720),(84514,4721),(84515,4722),(84516,4723),(84517,4724),(84518,4725),(84519,4726),(84520,4727),(84521,4728),(84522,4729),(84523,4730),(84524,4731),(84525,4732),(84526,4733),(84527,4734),(84528,4735),(84529,4736),(84530,4737),(84531,4738),(84532,4739),(84533,4740),(84534,4741),(84535,4742),(84536,4743),(84537,4744),(84538,4745),(84539,4746),(84540,4747),(84541,4748),(84542,4749),(84543,4750),(84544,4751),(84545,4752),(84546,4753),(84547,4754),(84548,4755),(84549,4756),(84550,4757),(84551,4758),(84552,4759),(84553,4760),(84554,4761),(84555,4762),(84556,4763),(84557,4764),(84558,4765),(84559,4766),(84560,4767),(84561,4768),(84562,4769),(84563,4770),(84564,4771),(84565,4772),(84566,4773),(84567,4774),(84568,4775),(84569,4776),(84570,4777),(84571,4778),(84572,4779),(84573,4680),(84574,4680),(84575,4680),(84576,4680),(84577,4680),(84578,4680),(84579,4681),(84580,4681),(84581,4681),(84582,4681),(84583,4681),(84584,4681),(84585,4682),(84586,4682),(84587,4682),(84588,4682),(84589,4682),(84590,4682),(84591,4683),(84592,4683),(84593,4683),(84594,4683),(84595,4683),(84596,4683),(84597,4684),(84598,4684),(84599,4684),(84600,4684),(84601,4684),(84602,4684),(84603,4685),(84604,4685),(84605,4685),(84606,4685),(84607,4685),(84608,4685),(84609,4686),(84610,4686),(84611,4686),(84612,4686),(84613,4686),(84614,4686),(84615,4687),(84616,4687),(84617,4687),(84618,4687),(84619,4687),(84620,4687),(84621,4688),(84622,4688),(84623,4688),(84624,4688),(84625,4688),(84626,4688),(84627,4689),(84628,4689),(84629,4689),(84630,4689),(84631,4689),(84632,4689),(84633,4690),(84634,4690),(84635,4690),(84636,4690),(84637,4690),(84638,4690),(84639,4691),(84640,4691),(84641,4691),(84642,4691),(84643,4691),(84644,4691),(84645,4692),(84646,4692),(84647,4692),(84648,4692),(84649,4692),(84650,4692),(84651,4693),(84652,4693),(84653,4693),(84654,4693),(84655,4693),(84656,4693),(84657,4694),(84658,4694),(84659,4694),(84660,4694),(84661,4694),(84662,4694),(84663,4695),(84664,4695),(84665,4695),(84666,4695),(84667,4695),(84668,4695),(84669,4696),(84670,4696),(84671,4696),(84672,4696),(84673,4696),(84674,4696),(84675,4697),(84676,4697),(84677,4697),(84678,4697),(84679,4697),(84680,4697),(84681,4698),(84682,4698),(84683,4698),(84684,4698),(84685,4698),(84686,4698),(84687,4699),(84688,4699),(84689,4699),(84690,4699),(84691,4699),(84692,4699),(84693,4700),(84694,4700),(84695,4700),(84696,4700),(84697,4700),(84698,4700),(84699,4701),(84700,4701),(84701,4701),(84702,4701),(84703,4701),(84704,4701),(84705,4702),(84706,4702),(84707,4702),(84708,4702),(84709,4702),(84710,4702),(84711,4703),(84712,4703),(84713,4703),(84714,4703),(84715,4703),(84716,4703),(84717,4704),(84718,4704),(84719,4704),(84720,4704),(84721,4704),(84722,4704),(84723,4705),(84724,4705),(84725,4705),(84726,4705),(84727,4705),(84728,4705),(84729,4706),(84730,4706),(84731,4706),(84732,4706),(84733,4706),(84734,4706),(84735,4707),(84736,4707),(84737,4707),(84738,4707),(84739,4707),(84740,4707),(84741,4708),(84742,4708),(84743,4708),(84744,4708),(84745,4708),(84746,4708),(84747,4709),(84748,4709),(84749,4709),(84750,4709),(84751,4709),(84752,4709),(84753,4710),(84754,4710),(84755,4710),(84756,4710),(84757,4710),(84758,4710),(84759,4711),(84760,4711),(84761,4711),(84762,4711),(84763,4711),(84764,4711),(84765,4712),(84766,4712),(84767,4712),(84768,4712),(84769,4712),(84770,4712),(84771,4713),(84772,4713),(84773,4713),(84774,4713),(84775,4713),(84776,4713),(84777,4714),(84778,4714),(84779,4714),(84780,4714),(84781,4714),(84782,4714),(84783,4715),(84784,4715),(84785,4715),(84786,4715),(84787,4715),(84788,4715),(84789,4716),(84790,4716),(84791,4716),(84792,4716),(84793,4716),(84794,4716),(84795,4717),(84796,4717),(84797,4717),(84798,4717),(84799,4717),(84800,4717),(84801,4718),(84802,4718),(84803,4718),(84804,4718),(84805,4718),(84806,4718),(84807,4719),(84808,4719),(84809,4719),(84810,4719),(84811,4719),(84812,4719),(84813,4720),(84814,4720),(84815,4720),(84816,4720),(84817,4720),(84818,4720),(84819,4721),(84820,4721),(84821,4721),(84822,4721),(84823,4722),(84824,4722),(84825,4722),(84826,4722),(84827,4722),(84828,4722),(84829,4723),(84830,4723),(84831,4723),(84832,4723),(84833,4723),(84834,4723),(84835,4724),(84836,4724),(84837,4724),(84838,4724),(84839,4724),(84840,4724),(84841,4725),(84842,4725),(84843,4725),(84844,4725),(84845,4726),(84846,4726),(84847,4726),(84848,4726),(84849,4727),(84850,4727),(84851,4727),(84852,4727),(84853,4728),(84854,4728),(84855,4728),(84856,4728),(84857,4729),(84858,4729),(84859,4729),(84860,4729),(84861,4730),(84862,4730),(84863,4730),(84864,4730),(84865,4730),(84866,4730),(84867,4731),(84868,4731),(84869,4731),(84870,4731),(84871,4731),(84872,4731),(84873,4732),(84874,4732),(84875,4732),(84876,4732),(84877,4732),(84878,4732),(84879,4733),(84880,4733),(84881,4733),(84882,4733),(84883,4733),(84884,4733),(84885,4734),(84886,4734),(84887,4734),(84888,4734),(84889,4734),(84890,4734),(84891,4735),(84892,4735),(84893,4735),(84894,4735),(84895,4735),(84896,4735),(84897,4736),(84898,4736),(84899,4736),(84900,4736),(84901,4736),(84902,4736),(84903,4737),(84904,4737),(84905,4737),(84906,4737),(84907,4737),(84908,4737),(84909,4738),(84910,4738),(84911,4738),(84912,4738),(84913,4738),(84914,4738),(84915,4739),(84916,4739),(84917,4739),(84918,4739),(84919,4739),(84920,4739),(84921,4740),(84922,4740),(84923,4740),(84924,4740),(84925,4740),(84926,4740),(84927,4741),(84928,4741),(84929,4741),(84930,4741),(84931,4741),(84932,4741),(84933,4742),(84934,4742),(84935,4742),(84936,4742),(84937,4742),(84938,4742),(84939,4743),(84940,4743),(84941,4743),(84942,4743),(84943,4743),(84944,4743),(84945,4744),(84946,4744),(84947,4744),(84948,4744),(84949,4744),(84950,4744),(84951,4745),(84952,4745),(84953,4745),(84954,4745),(84955,4746),(84956,4746),(84957,4746),(84958,4746),(84959,4746),(84960,4746),(84961,4747),(84962,4747),(84963,4747),(84964,4747),(84965,4747),(84966,4747),(84967,4748),(84968,4748),(84969,4748),(84970,4748),(84971,4748),(84972,4748),(84973,4749),(84974,4749),(84975,4749),(84976,4749),(84977,4749),(84978,4749),(84979,4750),(84980,4750),(84981,4750),(84982,4750),(84983,4750),(84984,4750),(84985,4751),(84986,4751),(84987,4751),(84988,4751),(84989,4751),(84990,4751),(84991,4752),(84992,4752),(84993,4752),(84994,4752),(84995,4752),(84996,4752),(84997,4753),(84998,4753),(84999,4753),(85000,4753),(85001,4753),(85002,4753),(85003,4754),(85004,4754),(85005,4754),(85006,4754),(85007,4754),(85008,4754),(85009,4755),(85010,4755),(85011,4755),(85012,4755),(85013,4755),(85014,4755),(85015,4756),(85016,4756),(85017,4756),(85018,4756),(85019,4756),(85020,4756),(85021,4757),(85022,4757),(85023,4757),(85024,4757),(85025,4757),(85026,4757),(85027,4758),(85028,4758),(85029,4758),(85030,4758),(85031,4758),(85032,4758),(85033,4759),(85034,4759),(85035,4759),(85036,4759),(85037,4759),(85038,4759),(85039,4760),(85040,4760),(85041,4760),(85042,4760),(85043,4760),(85044,4760),(85045,4761),(85046,4761),(85047,4761),(85048,4761),(85049,4761),(85050,4761),(85051,4762),(85052,4762),(85053,4762),(85054,4762),(85055,4762),(85056,4762),(85057,4763),(85058,4763),(85059,4763),(85060,4763),(85061,4763),(85062,4763),(85063,4764),(85064,4764),(85065,4764),(85066,4764),(85067,4764),(85068,4764),(85069,4765),(85070,4765),(85071,4765),(85072,4765),(85073,4766),(85074,4766),(85075,4766),(85076,4766),(85077,4766),(85078,4766),(85079,4767),(85080,4767),(85081,4767),(85082,4767),(85083,4767),(85084,4767),(85085,4768),(85086,4768),(85087,4768),(85088,4768),(85089,4768),(85090,4768),(85091,4769),(85092,4769),(85093,4769),(85094,4769),(85095,4769),(85096,4769),(85097,4770),(85098,4770),(85099,4770),(85100,4770),(85101,4770),(85102,4770),(85103,4771),(85104,4771),(85105,4771),(85106,4771),(85107,4771),(85108,4771),(85109,4772),(85110,4772),(85111,4772),(85112,4772),(85113,4772),(85114,4772),(85115,4773),(85116,4773),(85117,4773),(85118,4773),(85119,4773),(85120,4773),(85121,4774),(85122,4774),(85123,4774),(85124,4774),(85125,4774),(85126,4774),(85127,4775),(85128,4775),(85129,4775),(85130,4775),(85131,4775),(85132,4775),(85133,4776),(85134,4776),(85135,4776),(85136,4776),(85137,4776),(85138,4776),(85139,4777),(85140,4777),(85141,4777),(85142,4777),(85143,4777),(85144,4777),(85145,4778),(85146,4778),(85147,4778),(85148,4778),(85149,4778),(85150,4778),(85151,4779),(85152,4779),(85153,4779),(85154,4779),(85155,4779),(85156,4779),(85157,4680),(85158,4680),(85159,4680),(85160,4681),(85161,4681),(85162,4681),(85163,4682),(85164,4682),(85165,4682),(85166,4683),(85167,4683),(85168,4683),(85169,4684),(85170,4684),(85171,4684),(85172,4685),(85173,4685),(85174,4685),(85175,4686),(85176,4686),(85177,4686),(85178,4687),(85179,4687),(85180,4687),(85181,4688),(85182,4688),(85183,4688),(85184,4689),(85185,4689),(85186,4689),(85187,4690),(85188,4690),(85189,4690),(85190,4691),(85191,4691),(85192,4691),(85193,4692),(85194,4692),(85195,4692),(85196,4693),(85197,4693),(85198,4693),(85199,4694),(85200,4694),(85201,4694),(85202,4695),(85203,4695),(85204,4695),(85205,4696),(85206,4696),(85207,4696),(85208,4697),(85209,4697),(85210,4697),(85211,4698),(85212,4698),(85213,4698),(85214,4699),(85215,4699),(85216,4699),(85217,4700),(85218,4700),(85219,4700),(85220,4701),(85221,4701),(85222,4701),(85223,4702),(85224,4702),(85225,4702),(85226,4703),(85227,4703),(85228,4703),(85229,4704),(85230,4704),(85231,4704),(85232,4705),(85233,4705),(85234,4705),(85235,4706),(85236,4706),(85237,4706),(85238,4707),(85239,4707),(85240,4707),(85241,4708),(85242,4708),(85243,4708),(85244,4709),(85245,4709),(85246,4709),(85247,4710),(85248,4710),(85249,4710),(85250,4711),(85251,4711),(85252,4711),(85253,4712),(85254,4712),(85255,4712),(85256,4713),(85257,4713),(85258,4713),(85259,4714),(85260,4714),(85261,4714),(85262,4715),(85263,4715),(85264,4715),(85265,4716),(85266,4716),(85267,4716),(85268,4717),(85269,4717),(85270,4717),(85271,4718),(85272,4718),(85273,4718),(85274,4719),(85275,4719),(85276,4719),(85277,4720),(85278,4720),(85279,4720),(85280,4721),(85281,4721),(85282,4722),(85283,4722),(85284,4722),(85285,4723),(85286,4723),(85287,4723),(85288,4724),(85289,4724),(85290,4724),(85291,4725),(85292,4725),(85293,4726),(85294,4726),(85295,4727),(85296,4727),(85297,4728),(85298,4728),(85299,4729),(85300,4729),(85301,4730),(85302,4730),(85303,4730),(85304,4731),(85305,4731),(85306,4731),(85307,4732),(85308,4732),(85309,4732),(85310,4733),(85311,4733),(85312,4733),(85313,4734),(85314,4734),(85315,4734),(85316,4735),(85317,4735),(85318,4735),(85319,4736),(85320,4736),(85321,4736),(85322,4737),(85323,4737),(85324,4737),(85325,4738),(85326,4738),(85327,4738),(85328,4739),(85329,4739),(85330,4739),(85331,4740),(85332,4740),(85333,4740),(85334,4741),(85335,4741),(85336,4741),(85337,4742),(85338,4742),(85339,4742),(85340,4743),(85341,4743),(85342,4743),(85343,4744),(85344,4744),(85345,4744),(85346,4745),(85347,4745),(85348,4746),(85349,4746),(85350,4746),(85351,4747),(85352,4747),(85353,4747),(85354,4748),(85355,4748),(85356,4748),(85357,4749),(85358,4749),(85359,4749),(85360,4750),(85361,4750),(85362,4750),(85363,4751),(85364,4751),(85365,4751),(85366,4752),(85367,4752),(85368,4752),(85369,4753),(85370,4753),(85371,4753),(85372,4754),(85373,4754),(85374,4754),(85375,4755),(85376,4755),(85377,4756),(85378,4756),(85379,4757),(85380,4757),(85381,4757),(85382,4758),(85383,4758),(85384,4758),(85385,4759),(85386,4759),(85387,4759),(85388,4760),(85389,4760),(85390,4760),(85391,4761),(85392,4761),(85393,4761),(85394,4762),(85395,4762),(85396,4762),(85397,4763),(85398,4763),(85399,4763),(85400,4764),(85401,4764),(85402,4764),(85403,4765),(85404,4765),(85405,4766),(85406,4766),(85407,4766),(85408,4767),(85409,4767),(85410,4767),(85411,4768),(85412,4768),(85413,4768),(85414,4769),(85415,4769),(85416,4769),(85417,4770),(85418,4770),(85419,4770),(85420,4771),(85421,4771),(85422,4771),(85423,4772),(85424,4772),(85425,4772),(85426,4773),(85427,4773),(85428,4773),(85429,4774),(85430,4774),(85431,4774),(85432,4775),(85433,4775),(85434,4775),(85435,4776),(85436,4776),(85437,4776),(85438,4777),(85439,4777),(85440,4777),(85441,4778),(85442,4778),(85443,4778),(85444,4779),(85445,4779),(85446,4779),(85447,4680),(85448,4680),(85449,4680),(85450,4681),(85451,4681),(85452,4681),(85453,4682),(85454,4682),(85455,4682),(85456,4683),(85457,4683),(85458,4683),(85459,4684),(85460,4684),(85461,4684),(85462,4685),(85463,4685),(85464,4685),(85465,4686),(85466,4686),(85467,4686),(85468,4687),(85469,4687),(85470,4687),(85471,4688),(85472,4688),(85473,4688),(85474,4689),(85475,4689),(85476,4689),(85477,4690),(85478,4690),(85479,4690),(85480,4691),(85481,4691),(85482,4691),(85483,4692),(85484,4692),(85485,4692),(85486,4693),(85487,4693),(85488,4693),(85489,4694),(85490,4694),(85491,4694),(85492,4695),(85493,4695),(85494,4695),(85495,4696),(85496,4696),(85497,4696),(85498,4697),(85499,4697),(85500,4697),(85501,4698),(85502,4698),(85503,4698),(85504,4699),(85505,4699),(85506,4699),(85507,4700),(85508,4700),(85509,4700),(85510,4701),(85511,4701),(85512,4701),(85513,4702),(85514,4702),(85515,4702),(85516,4703),(85517,4703),(85518,4703),(85519,4704),(85520,4704),(85521,4704),(85522,4705),(85523,4705),(85524,4705),(85525,4706),(85526,4706),(85527,4706),(85528,4707),(85529,4707),(85530,4707),(85531,4708),(85532,4708),(85533,4708),(85534,4709),(85535,4709),(85536,4709),(85537,4710),(85538,4710),(85539,4710),(85540,4711),(85541,4711),(85542,4711),(85543,4712),(85544,4712),(85545,4712),(85546,4713),(85547,4713),(85548,4713),(85549,4714),(85550,4714),(85551,4714),(85552,4715),(85553,4715),(85554,4715),(85555,4716),(85556,4716),(85557,4716),(85558,4717),(85559,4717),(85560,4717),(85561,4718),(85562,4718),(85563,4718),(85564,4719),(85565,4719),(85566,4719),(85567,4720),(85568,4720),(85569,4720),(85570,4721),(85571,4721),(85572,4721),(85573,4722),(85574,4722),(85575,4722),(85576,4723),(85577,4723),(85578,4723),(85579,4724),(85580,4724),(85581,4724),(85582,4725),(85583,4725),(85584,4725),(85585,4726),(85586,4726),(85587,4726),(85588,4727),(85589,4727),(85590,4727),(85591,4728),(85592,4728),(85593,4728),(85594,4729),(85595,4729),(85596,4729),(85597,4730),(85598,4730),(85599,4730),(85600,4731),(85601,4731),(85602,4731),(85603,4732),(85604,4732),(85605,4732),(85606,4733),(85607,4733),(85608,4733),(85609,4734),(85610,4734),(85611,4734),(85612,4735),(85613,4735),(85614,4735),(85615,4736),(85616,4736),(85617,4736),(85618,4737),(85619,4737),(85620,4737),(85621,4738),(85622,4738),(85623,4738),(85624,4739),(85625,4739),(85626,4739),(85627,4740),(85628,4740),(85629,4740),(85630,4741),(85631,4741),(85632,4741),(85633,4742),(85634,4742),(85635,4742),(85636,4743),(85637,4743),(85638,4743),(85639,4744),(85640,4744),(85641,4744),(85642,4745),(85643,4745),(85644,4745),(85645,4746),(85646,4746),(85647,4746),(85648,4747),(85649,4747),(85650,4747),(85651,4748),(85652,4748),(85653,4748),(85654,4749),(85655,4749),(85656,4749),(85657,4750),(85658,4750),(85659,4750),(85660,4751),(85661,4751),(85662,4751),(85663,4752),(85664,4752),(85665,4752),(85666,4753),(85667,4753),(85668,4753),(85669,4754),(85670,4754),(85671,4754),(85672,4755),(85673,4755),(85674,4755),(85675,4756),(85676,4756),(85677,4756),(85678,4757),(85679,4757),(85680,4757),(85681,4758),(85682,4758),(85683,4758),(85684,4759),(85685,4759),(85686,4759),(85687,4760),(85688,4760),(85689,4760),(85690,4761),(85691,4761),(85692,4761),(85693,4762),(85694,4762),(85695,4762),(85696,4763),(85697,4763),(85698,4763),(85699,4764),(85700,4764),(85701,4764),(85702,4765),(85703,4765),(85704,4765),(85705,4766),(85706,4766),(85707,4766),(85708,4767),(85709,4767),(85710,4767),(85711,4768),(85712,4768),(85713,4768),(85714,4769),(85715,4769),(85716,4769),(85717,4770),(85718,4770),(85719,4770),(85720,4771),(85721,4771),(85722,4771),(85723,4772),(85724,4772),(85725,4772),(85726,4773),(85727,4773),(85728,4773),(85729,4774),(85730,4774),(85731,4774),(85732,4775),(85733,4775),(85734,4775),(85735,4776),(85736,4776),(85737,4776),(85738,4777),(85739,4777),(85740,4777),(85741,4778),(85742,4778),(85743,4778),(85744,4779),(85745,4779),(85746,4779),(85747,4680),(85748,4680),(85749,4680),(85750,4680),(85751,4681),(85752,4681),(85753,4681),(85754,4681),(85755,4682),(85756,4682),(85757,4682),(85758,4682),(85759,4683),(85760,4683),(85761,4683),(85762,4683),(85763,4684),(85764,4684),(85765,4684),(85766,4684),(85767,4685),(85768,4685),(85769,4685),(85770,4685),(85771,4686),(85772,4686),(85773,4686),(85774,4686),(85775,4687),(85776,4687),(85777,4687),(85778,4687),(85779,4688),(85780,4688),(85781,4688),(85782,4688),(85783,4689),(85784,4689),(85785,4689),(85786,4689),(85787,4690),(85788,4690),(85789,4690),(85790,4690),(85791,4691),(85792,4691),(85793,4691),(85794,4691),(85795,4692),(85796,4692),(85797,4692),(85798,4692),(85799,4693),(85800,4693),(85801,4693),(85802,4693),(85803,4694),(85804,4694),(85805,4694),(85806,4694),(85807,4695),(85808,4695),(85809,4695),(85810,4695),(85811,4696),(85812,4696),(85813,4696),(85814,4696),(85815,4697),(85816,4697),(85817,4697),(85818,4697),(85819,4698),(85820,4698),(85821,4698),(85822,4698),(85823,4699),(85824,4699),(85825,4699),(85826,4699),(85827,4700),(85828,4700),(85829,4700),(85830,4700),(85831,4701),(85832,4701),(85833,4701),(85834,4701),(85835,4702),(85836,4702),(85837,4702),(85838,4702),(85839,4703),(85840,4703),(85841,4703),(85842,4703),(85843,4704),(85844,4704),(85845,4704),(85846,4704),(85847,4705),(85848,4705),(85849,4705),(85850,4705),(85851,4706),(85852,4706),(85853,4706),(85854,4706),(85855,4707),(85856,4707),(85857,4707),(85858,4707),(85859,4708),(85860,4708),(85861,4708),(85862,4708),(85863,4709),(85864,4709),(85865,4709),(85866,4709),(85867,4710),(85868,4710),(85869,4710),(85870,4710),(85871,4711),(85872,4711),(85873,4711),(85874,4711),(85875,4712),(85876,4712),(85877,4712),(85878,4712),(85879,4713),(85880,4713),(85881,4713),(85882,4713),(85883,4714),(85884,4714),(85885,4714),(85886,4714),(85887,4715),(85888,4715),(85889,4715),(85890,4715),(85891,4716),(85892,4716),(85893,4716),(85894,4716),(85895,4717),(85896,4717),(85897,4717),(85898,4717),(85899,4718),(85900,4718),(85901,4718),(85902,4718),(85903,4719),(85904,4719),(85905,4719),(85906,4719),(85907,4720),(85908,4720),(85909,4720),(85910,4720),(85911,4721),(85912,4721),(85913,4721),(85914,4721),(85915,4722),(85916,4722),(85917,4722),(85918,4722),(85919,4723),(85920,4723),(85921,4723),(85922,4723),(85923,4724),(85924,4724),(85925,4724),(85926,4724),(85927,4725),(85928,4725),(85929,4725),(85930,4725),(85931,4726),(85932,4726),(85933,4726),(85934,4726),(85935,4727),(85936,4727),(85937,4727),(85938,4727),(85939,4728),(85940,4728),(85941,4728),(85942,4728),(85943,4729),(85944,4729),(85945,4729),(85946,4729),(85947,4730),(85948,4730),(85949,4730),(85950,4730),(85951,4731),(85952,4731),(85953,4731),(85954,4731),(85955,4732),(85956,4732),(85957,4732),(85958,4732),(85959,4733),(85960,4733),(85961,4733),(85962,4733),(85963,4734),(85964,4734),(85965,4734),(85966,4734),(85967,4735),(85968,4735),(85969,4735),(85970,4735),(85971,4736),(85972,4736),(85973,4736),(85974,4736),(85975,4737),(85976,4737),(85977,4737),(85978,4737),(85979,4738),(85980,4738),(85981,4738),(85982,4738),(85983,4739),(85984,4739),(85985,4739),(85986,4739),(85987,4740),(85988,4740),(85989,4740),(85990,4740),(85991,4741),(85992,4741),(85993,4741),(85994,4741),(85995,4742),(85996,4742),(85997,4742),(85998,4742),(85999,4743),(86000,4743),(86001,4743),(86002,4743),(86003,4744),(86004,4744),(86005,4744),(86006,4744),(86007,4745),(86008,4745),(86009,4745),(86010,4745),(86011,4746),(86012,4746),(86013,4746),(86014,4746),(86015,4747),(86016,4747),(86017,4747),(86018,4747),(86019,4748),(86020,4748),(86021,4748),(86022,4748),(86023,4749),(86024,4749),(86025,4749),(86026,4749),(86027,4750),(86028,4750),(86029,4750),(86030,4750),(86031,4751),(86032,4751),(86033,4751),(86034,4751),(86035,4752),(86036,4752),(86037,4752),(86038,4752),(86039,4753),(86040,4753),(86041,4753),(86042,4753),(86043,4754),(86044,4754),(86045,4754),(86046,4754),(86047,4755),(86048,4755),(86049,4755),(86050,4755),(86051,4756),(86052,4756),(86053,4756),(86054,4756),(86055,4757),(86056,4757),(86057,4757),(86058,4757),(86059,4758),(86060,4758),(86061,4758),(86062,4758),(86063,4759),(86064,4759),(86065,4759),(86066,4759),(86067,4760),(86068,4760),(86069,4760),(86070,4760),(86071,4761),(86072,4761),(86073,4761),(86074,4761),(86075,4762),(86076,4762),(86077,4762),(86078,4762),(86079,4763),(86080,4763),(86081,4763),(86082,4763),(86083,4764),(86084,4764),(86085,4764),(86086,4764),(86087,4765),(86088,4765),(86089,4765),(86090,4765),(86091,4766),(86092,4766),(86093,4766),(86094,4766),(86095,4767),(86096,4767),(86097,4767),(86098,4767),(86099,4768),(86100,4768),(86101,4768),(86102,4768),(86103,4769),(86104,4769),(86105,4769),(86106,4769),(86107,4770),(86108,4770),(86109,4770),(86110,4770),(86111,4771),(86112,4771),(86113,4771),(86114,4771),(86115,4772),(86116,4772),(86117,4772),(86118,4772),(86119,4773),(86120,4773),(86121,4773),(86122,4773),(86123,4774),(86124,4774),(86125,4774),(86126,4774),(86127,4775),(86128,4775),(86129,4775),(86130,4775),(86131,4776),(86132,4776),(86133,4776),(86134,4776),(86135,4777),(86136,4777),(86137,4777),(86138,4777),(86139,4778),(86140,4778),(86141,4778),(86142,4778),(86143,4779),(86144,4779),(86145,4779),(86146,4779),(86147,4780),(86148,4781),(86149,4782),(86150,4783),(86151,4784),(86152,4785),(86153,4786),(86154,4787),(86155,4788),(86156,4789),(86157,4790),(86158,4791),(86159,4792),(86160,4793),(86161,4794),(86162,4795),(86163,4796),(86164,4797),(86165,4798),(86166,4799),(86167,4800),(86168,4801),(86169,4802),(86170,4803),(86171,4804),(86172,4805),(86173,4806),(86174,4807),(86175,4808),(86176,4809),(86177,4810),(86178,4811),(86179,4812),(86180,4813),(86181,4814),(86182,4815),(86183,4816),(86184,4817),(86185,4818),(86186,4819),(86187,4820),(86188,4821),(86189,4822),(86190,4823),(86191,4824),(86192,4825),(86193,4826),(86194,4827),(86195,4828),(86196,4829),(86197,4830),(86198,4831),(86199,4832),(86200,4833),(86201,4834),(86202,4835),(86203,4836),(86204,4837),(86205,4838),(86206,4839),(86207,4840),(86208,4841),(86209,4842),(86210,4843),(86211,4844),(86212,4845),(86213,4846),(86214,4847),(86215,4848),(86216,4849),(86217,4850),(86218,4851),(86219,4852),(86220,4853),(86221,4854),(86222,4855),(86223,4856),(86224,4857),(86225,4858),(86226,4859),(86227,4860),(86228,4861),(86229,4862),(86230,4863),(86231,4864),(86232,4865),(86233,4866),(86234,4867),(86235,4868),(86236,4869),(86237,4870),(86238,4871),(86239,4872),(86240,4873),(86241,4874),(86242,4875),(86243,4876),(86244,4877),(86245,4878),(86246,4879),(86247,4780),(86248,4781),(86249,4782),(86250,4783),(86251,4784),(86252,4785),(86253,4786),(86254,4787),(86255,4788),(86256,4789),(86257,4790),(86258,4791),(86259,4792),(86260,4793),(86261,4794),(86262,4795),(86263,4796),(86264,4797),(86265,4798),(86266,4799),(86267,4800),(86268,4801),(86269,4802),(86270,4803),(86271,4804),(86272,4805),(86273,4806),(86274,4807),(86275,4808),(86276,4809),(86277,4810),(86278,4811),(86279,4812),(86280,4813),(86281,4814),(86282,4815),(86283,4816),(86284,4817),(86285,4818),(86286,4819),(86287,4820),(86288,4821),(86289,4822),(86290,4823),(86291,4824),(86292,4825),(86293,4826),(86294,4827),(86295,4828),(86296,4829),(86297,4830),(86298,4831),(86299,4832),(86300,4833),(86301,4834),(86302,4835),(86303,4836),(86304,4837),(86305,4838),(86306,4839),(86307,4840),(86308,4841),(86309,4842),(86310,4843),(86311,4844),(86312,4845),(86313,4846),(86314,4847),(86315,4848),(86316,4849),(86317,4850),(86318,4851),(86319,4852),(86320,4853),(86321,4854),(86322,4855),(86323,4856),(86324,4857),(86325,4858),(86326,4859),(86327,4860),(86328,4861),(86329,4862),(86330,4863),(86331,4864),(86332,4865),(86333,4866),(86334,4867),(86335,4868),(86336,4869),(86337,4870),(86338,4871),(86339,4872),(86340,4873),(86341,4874),(86342,4875),(86343,4876),(86344,4877),(86345,4878),(86346,4879),(86347,4780),(86348,4780),(86349,4780),(86350,4780),(86351,4780),(86352,4780),(86353,4781),(86354,4781),(86355,4781),(86356,4781),(86357,4781),(86358,4781),(86359,4782),(86360,4782),(86361,4782),(86362,4782),(86363,4782),(86364,4782),(86365,4783),(86366,4783),(86367,4783),(86368,4783),(86369,4783),(86370,4783),(86371,4784),(86372,4784),(86373,4784),(86374,4784),(86375,4784),(86376,4784),(86377,4785),(86378,4785),(86379,4785),(86380,4785),(86381,4785),(86382,4785),(86383,4786),(86384,4786),(86385,4786),(86386,4786),(86387,4786),(86388,4786),(86389,4787),(86390,4787),(86391,4787),(86392,4787),(86393,4787),(86394,4787),(86395,4788),(86396,4788),(86397,4788),(86398,4788),(86399,4788),(86400,4788),(86401,4789),(86402,4789),(86403,4789),(86404,4789),(86405,4789),(86406,4789),(86407,4790),(86408,4790),(86409,4790),(86410,4790),(86411,4790),(86412,4790),(86413,4791),(86414,4791),(86415,4791),(86416,4791),(86417,4791),(86418,4791),(86419,4792),(86420,4792),(86421,4792),(86422,4792),(86423,4792),(86424,4792),(86425,4793),(86426,4793),(86427,4793),(86428,4793),(86429,4793),(86430,4793),(86431,4794),(86432,4794),(86433,4794),(86434,4794),(86435,4794),(86436,4794),(86437,4795),(86438,4795),(86439,4795),(86440,4795),(86441,4795),(86442,4795),(86443,4796),(86444,4796),(86445,4796),(86446,4796),(86447,4796),(86448,4796),(86449,4797),(86450,4797),(86451,4797),(86452,4797),(86453,4797),(86454,4797),(86455,4798),(86456,4798),(86457,4798),(86458,4798),(86459,4798),(86460,4798),(86461,4799),(86462,4799),(86463,4799),(86464,4799),(86465,4799),(86466,4799),(86467,4800),(86468,4800),(86469,4800),(86470,4800),(86471,4800),(86472,4800),(86473,4801),(86474,4801),(86475,4801),(86476,4801),(86477,4801),(86478,4801),(86479,4802),(86480,4802),(86481,4802),(86482,4802),(86483,4802),(86484,4802),(86485,4803),(86486,4803),(86487,4803),(86488,4803),(86489,4803),(86490,4803),(86491,4804),(86492,4804),(86493,4804),(86494,4804),(86495,4804),(86496,4804),(86497,4805),(86498,4805),(86499,4805),(86500,4805),(86501,4806),(86502,4806),(86503,4806),(86504,4806),(86505,4807),(86506,4807),(86507,4807),(86508,4807),(86509,4808),(86510,4808),(86511,4808),(86512,4808),(86513,4809),(86514,4809),(86515,4809),(86516,4809),(86517,4809),(86518,4809),(86519,4810),(86520,4810),(86521,4810),(86522,4810),(86523,4810),(86524,4810),(86525,4811),(86526,4811),(86527,4811),(86528,4811),(86529,4811),(86530,4811),(86531,4812),(86532,4812),(86533,4812),(86534,4812),(86535,4812),(86536,4812),(86537,4813),(86538,4813),(86539,4813),(86540,4813),(86541,4813),(86542,4813),(86543,4814),(86544,4814),(86545,4814),(86546,4814),(86547,4814),(86548,4814),(86549,4815),(86550,4815),(86551,4815),(86552,4815),(86553,4815),(86554,4815),(86555,4816),(86556,4816),(86557,4816),(86558,4816),(86559,4816),(86560,4816),(86561,4817),(86562,4817),(86563,4817),(86564,4817),(86565,4817),(86566,4817),(86567,4818),(86568,4818),(86569,4818),(86570,4818),(86571,4818),(86572,4818),(86573,4819),(86574,4819),(86575,4819),(86576,4819),(86577,4819),(86578,4819),(86579,4820),(86580,4820),(86581,4820),(86582,4820),(86583,4820),(86584,4820),(86585,4821),(86586,4821),(86587,4821),(86588,4821),(86589,4821),(86590,4821),(86591,4822),(86592,4822),(86593,4822),(86594,4822),(86595,4822),(86596,4822),(86597,4823),(86598,4823),(86599,4823),(86600,4823),(86601,4823),(86602,4823),(86603,4824),(86604,4824),(86605,4824),(86606,4824),(86607,4825),(86608,4825),(86609,4825),(86610,4825),(86611,4826),(86612,4826),(86613,4826),(86614,4826),(86615,4827),(86616,4827),(86617,4827),(86618,4827),(86619,4828),(86620,4828),(86621,4828),(86622,4828),(86623,4829),(86624,4829),(86625,4829),(86626,4829),(86627,4830),(86628,4830),(86629,4830),(86630,4830),(86631,4831),(86632,4831),(86633,4831),(86634,4831),(86635,4832),(86636,4832),(86637,4832),(86638,4832),(86639,4833),(86640,4833),(86641,4833),(86642,4833),(86643,4834),(86644,4834),(86645,4834),(86646,4834),(86647,4834),(86648,4834),(86649,4835),(86650,4835),(86651,4835),(86652,4835),(86653,4835),(86654,4835),(86655,4836),(86656,4836),(86657,4836),(86658,4836),(86659,4836),(86660,4836),(86661,4837),(86662,4837),(86663,4837),(86664,4837),(86665,4837),(86666,4837),(86667,4838),(86668,4838),(86669,4838),(86670,4838),(86671,4838),(86672,4838),(86673,4839),(86674,4839),(86675,4839),(86676,4839),(86677,4839),(86678,4839),(86679,4840),(86680,4840),(86681,4840),(86682,4840),(86683,4840),(86684,4840),(86685,4841),(86686,4841),(86687,4841),(86688,4841),(86689,4841),(86690,4841),(86691,4842),(86692,4842),(86693,4842),(86694,4842),(86695,4842),(86696,4842),(86697,4843),(86698,4843),(86699,4843),(86700,4843),(86701,4843),(86702,4843),(86703,4844),(86704,4844),(86705,4844),(86706,4844),(86707,4845),(86708,4845),(86709,4845),(86710,4845),(86711,4845),(86712,4845),(86713,4846),(86714,4846),(86715,4846),(86716,4846),(86717,4846),(86718,4846),(86719,4847),(86720,4847),(86721,4847),(86722,4847),(86723,4847),(86724,4847),(86725,4848),(86726,4848),(86727,4848),(86728,4848),(86729,4848),(86730,4848),(86731,4849),(86732,4849),(86733,4849),(86734,4849),(86735,4849),(86736,4849),(86737,4850),(86738,4850),(86739,4850),(86740,4850),(86741,4850),(86742,4850),(86743,4851),(86744,4851),(86745,4851),(86746,4851),(86747,4851),(86748,4851),(86749,4852),(86750,4852),(86751,4852),(86752,4852),(86753,4852),(86754,4852),(86755,4853),(86756,4853),(86757,4853),(86758,4853),(86759,4853),(86760,4853),(86761,4854),(86762,4854),(86763,4854),(86764,4854),(86765,4854),(86766,4854),(86767,4855),(86768,4855),(86769,4855),(86770,4855),(86771,4855),(86772,4855),(86773,4856),(86774,4856),(86775,4856),(86776,4856),(86777,4856),(86778,4856),(86779,4857),(86780,4857),(86781,4857),(86782,4857),(86783,4857),(86784,4857),(86785,4858),(86786,4858),(86787,4858),(86788,4858),(86789,4858),(86790,4858),(86791,4859),(86792,4859),(86793,4859),(86794,4859),(86795,4859),(86796,4859),(86797,4860),(86798,4860),(86799,4860),(86800,4860),(86801,4860),(86802,4860),(86803,4861),(86804,4861),(86805,4861),(86806,4861),(86807,4861),(86808,4861),(86809,4862),(86810,4862),(86811,4862),(86812,4862),(86813,4862),(86814,4862),(86815,4863),(86816,4863),(86817,4863),(86818,4863),(86819,4863),(86820,4863),(86821,4864),(86822,4864),(86823,4864),(86824,4864),(86825,4864),(86826,4864),(86827,4865),(86828,4865),(86829,4865),(86830,4865),(86831,4865),(86832,4865),(86833,4866),(86834,4866),(86835,4866),(86836,4866),(86837,4866),(86838,4866),(86839,4867),(86840,4867),(86841,4867),(86842,4867),(86843,4867),(86844,4867),(86845,4868),(86846,4868),(86847,4868),(86848,4868),(86849,4868),(86850,4868),(86851,4869),(86852,4869),(86853,4869),(86854,4869),(86855,4869),(86856,4869),(86857,4870),(86858,4870),(86859,4870),(86860,4870),(86861,4870),(86862,4870),(86863,4871),(86864,4871),(86865,4871),(86866,4871),(86867,4871),(86868,4871),(86869,4872),(86870,4872),(86871,4872),(86872,4872),(86873,4872),(86874,4872),(86875,4873),(86876,4873),(86877,4873),(86878,4873),(86879,4873),(86880,4873),(86881,4874),(86882,4874),(86883,4874),(86884,4874),(86885,4874),(86886,4874),(86887,4875),(86888,4875),(86889,4875),(86890,4875),(86891,4875),(86892,4875),(86893,4876),(86894,4876),(86895,4876),(86896,4876),(86897,4876),(86898,4876),(86899,4877),(86900,4877),(86901,4877),(86902,4877),(86903,4877),(86904,4877),(86905,4878),(86906,4878),(86907,4878),(86908,4878),(86909,4878),(86910,4878),(86911,4879),(86912,4879),(86913,4879),(86914,4879),(86915,4879),(86916,4879),(86917,4780),(86918,4780),(86919,4780),(86920,4781),(86921,4781),(86922,4781),(86923,4782),(86924,4782),(86925,4782),(86926,4783),(86927,4783),(86928,4783),(86929,4784),(86930,4784),(86931,4784),(86932,4785),(86933,4785),(86934,4785),(86935,4786),(86936,4786),(86937,4786),(86938,4787),(86939,4787),(86940,4787),(86941,4788),(86942,4788),(86943,4788),(86944,4789),(86945,4789),(86946,4789),(86947,4790),(86948,4790),(86949,4790),(86950,4791),(86951,4791),(86952,4792),(86953,4792),(86954,4792),(86955,4793),(86956,4793),(86957,4793),(86958,4794),(86959,4794),(86960,4794),(86961,4795),(86962,4795),(86963,4795),(86964,4796),(86965,4796),(86966,4796),(86967,4797),(86968,4797),(86969,4797),(86970,4798),(86971,4798),(86972,4798),(86973,4799),(86974,4799),(86975,4799),(86976,4800),(86977,4800),(86978,4800),(86979,4801),(86980,4801),(86981,4801),(86982,4802),(86983,4802),(86984,4802),(86985,4803),(86986,4803),(86987,4803),(86988,4804),(86989,4804),(86990,4804),(86991,4805),(86992,4805),(86993,4806),(86994,4806),(86995,4807),(86996,4807),(86997,4808),(86998,4808),(86999,4809),(87000,4809),(87001,4809),(87002,4810),(87003,4810),(87004,4810),(87005,4811),(87006,4811),(87007,4811),(87008,4812),(87009,4812),(87010,4812),(87011,4813),(87012,4813),(87013,4813),(87014,4814),(87015,4814),(87016,4814),(87017,4815),(87018,4815),(87019,4815),(87020,4816),(87021,4816),(87022,4816),(87023,4817),(87024,4817),(87025,4817),(87026,4818),(87027,4818),(87028,4818),(87029,4819),(87030,4819),(87031,4819),(87032,4820),(87033,4820),(87034,4820),(87035,4821),(87036,4821),(87037,4821),(87038,4822),(87039,4822),(87040,4822),(87041,4823),(87042,4823),(87043,4824),(87044,4824),(87045,4825),(87046,4825),(87047,4826),(87048,4826),(87049,4827),(87050,4827),(87051,4828),(87052,4828),(87053,4829),(87054,4829),(87055,4830),(87056,4830),(87057,4831),(87058,4831),(87059,4832),(87060,4832),(87061,4833),(87062,4833),(87063,4834),(87064,4834),(87065,4835),(87066,4835),(87067,4836),(87068,4836),(87069,4837),(87070,4837),(87071,4838),(87072,4838),(87073,4839),(87074,4839),(87075,4840),(87076,4840),(87077,4841),(87078,4841),(87079,4842),(87080,4842),(87081,4843),(87082,4843),(87083,4843),(87084,4844),(87085,4844),(87086,4845),(87087,4845),(87088,4845),(87089,4846),(87090,4846),(87091,4846),(87092,4847),(87093,4847),(87094,4847),(87095,4848),(87096,4848),(87097,4848),(87098,4849),(87099,4849),(87100,4849),(87101,4850),(87102,4850),(87103,4850),(87104,4851),(87105,4851),(87106,4851),(87107,4852),(87108,4852),(87109,4852),(87110,4853),(87111,4853),(87112,4853),(87113,4854),(87114,4854),(87115,4854),(87116,4855),(87117,4855),(87118,4855),(87119,4856),(87120,4856),(87121,4856),(87122,4857),(87123,4857),(87124,4857),(87125,4858),(87126,4858),(87127,4858),(87128,4859),(87129,4859),(87130,4859),(87131,4860),(87132,4860),(87133,4860),(87134,4861),(87135,4861),(87136,4861),(87137,4862),(87138,4862),(87139,4862),(87140,4863),(87141,4863),(87142,4863),(87143,4864),(87144,4864),(87145,4864),(87146,4865),(87147,4865),(87148,4865),(87149,4866),(87150,4866),(87151,4866),(87152,4867),(87153,4867),(87154,4867),(87155,4868),(87156,4868),(87157,4868),(87158,4869),(87159,4869),(87160,4870),(87161,4870),(87162,4871),(87163,4871),(87164,4872),(87165,4872),(87166,4873),(87167,4873),(87168,4873),(87169,4874),(87170,4874),(87171,4875),(87172,4875),(87173,4876),(87174,4876),(87175,4876),(87176,4877),(87177,4877),(87178,4877),(87179,4878),(87180,4878),(87181,4878),(87182,4879),(87183,4879),(87184,4879),(87185,4780),(87186,4780),(87187,4780),(87188,4781),(87189,4781),(87190,4781),(87191,4782),(87192,4782),(87193,4782),(87194,4783),(87195,4783),(87196,4783),(87197,4784),(87198,4784),(87199,4784),(87200,4785),(87201,4785),(87202,4785),(87203,4786),(87204,4786),(87205,4786),(87206,4787),(87207,4787),(87208,4787),(87209,4788),(87210,4788),(87211,4788),(87212,4789),(87213,4789),(87214,4789),(87215,4790),(87216,4790),(87217,4790),(87218,4791),(87219,4791),(87220,4791),(87221,4792),(87222,4792),(87223,4792),(87224,4793),(87225,4793),(87226,4793),(87227,4794),(87228,4794),(87229,4794),(87230,4795),(87231,4795),(87232,4795),(87233,4796),(87234,4796),(87235,4796),(87236,4797),(87237,4797),(87238,4797),(87239,4798),(87240,4798),(87241,4798),(87242,4799),(87243,4799),(87244,4799),(87245,4800),(87246,4800),(87247,4800),(87248,4801),(87249,4801),(87250,4801),(87251,4802),(87252,4802),(87253,4802),(87254,4803),(87255,4803),(87256,4803),(87257,4804),(87258,4804),(87259,4804),(87260,4805),(87261,4805),(87262,4805),(87263,4806),(87264,4806),(87265,4806),(87266,4807),(87267,4807),(87268,4807),(87269,4808),(87270,4808),(87271,4808),(87272,4809),(87273,4809),(87274,4809),(87275,4810),(87276,4810),(87277,4810),(87278,4811),(87279,4811),(87280,4811),(87281,4812),(87282,4812),(87283,4812),(87284,4813),(87285,4813),(87286,4813),(87287,4814),(87288,4814),(87289,4814),(87290,4815),(87291,4815),(87292,4815),(87293,4816),(87294,4816),(87295,4816),(87296,4817),(87297,4817),(87298,4817),(87299,4818),(87300,4818),(87301,4818),(87302,4819),(87303,4819),(87304,4819),(87305,4820),(87306,4820),(87307,4820),(87308,4821),(87309,4821),(87310,4821),(87311,4822),(87312,4822),(87313,4822),(87314,4823),(87315,4823),(87316,4823),(87317,4824),(87318,4824),(87319,4824),(87320,4825),(87321,4825),(87322,4825),(87323,4826),(87324,4826),(87325,4826),(87326,4827),(87327,4827),(87328,4827),(87329,4828),(87330,4828),(87331,4828),(87332,4829),(87333,4829),(87334,4829),(87335,4830),(87336,4830),(87337,4830),(87338,4831),(87339,4831),(87340,4831),(87341,4832),(87342,4832),(87343,4832),(87344,4833),(87345,4833),(87346,4833),(87347,4834),(87348,4834),(87349,4834),(87350,4835),(87351,4835),(87352,4835),(87353,4836),(87354,4836),(87355,4836),(87356,4837),(87357,4837),(87358,4837),(87359,4838),(87360,4838),(87361,4838),(87362,4839),(87363,4839),(87364,4839),(87365,4840),(87366,4840),(87367,4840),(87368,4841),(87369,4841),(87370,4841),(87371,4842),(87372,4842),(87373,4842),(87374,4843),(87375,4843),(87376,4843),(87377,4844),(87378,4844),(87379,4844),(87380,4845),(87381,4845),(87382,4845),(87383,4846),(87384,4846),(87385,4846),(87386,4847),(87387,4847),(87388,4847),(87389,4848),(87390,4848),(87391,4848),(87392,4849),(87393,4849),(87394,4849),(87395,4850),(87396,4850),(87397,4850),(87398,4851),(87399,4851),(87400,4851),(87401,4852),(87402,4852),(87403,4852),(87404,4853),(87405,4853),(87406,4853),(87407,4854),(87408,4854),(87409,4854),(87410,4855),(87411,4855),(87412,4855),(87413,4856),(87414,4856),(87415,4856),(87416,4857),(87417,4857),(87418,4857),(87419,4858),(87420,4858),(87421,4858),(87422,4859),(87423,4859),(87424,4859),(87425,4860),(87426,4860),(87427,4860),(87428,4861),(87429,4861),(87430,4861),(87431,4862),(87432,4862),(87433,4862),(87434,4863),(87435,4863),(87436,4863),(87437,4864),(87438,4864),(87439,4864),(87440,4865),(87441,4865),(87442,4865),(87443,4866),(87444,4866),(87445,4866),(87446,4867),(87447,4867),(87448,4867),(87449,4868),(87450,4868),(87451,4868),(87452,4869),(87453,4869),(87454,4869),(87455,4870),(87456,4870),(87457,4870),(87458,4871),(87459,4871),(87460,4871),(87461,4872),(87462,4872),(87463,4872),(87464,4873),(87465,4873),(87466,4873),(87467,4874),(87468,4874),(87469,4874),(87470,4875),(87471,4875),(87472,4875),(87473,4876),(87474,4876),(87475,4876),(87476,4877),(87477,4877),(87478,4877),(87479,4878),(87480,4878),(87481,4878),(87482,4879),(87483,4879),(87484,4879),(87485,4780),(87486,4780),(87487,4780),(87488,4780),(87489,4781),(87490,4781),(87491,4781),(87492,4781),(87493,4782),(87494,4782),(87495,4782),(87496,4782),(87497,4783),(87498,4783),(87499,4783),(87500,4783),(87501,4784),(87502,4784),(87503,4784),(87504,4784),(87505,4785),(87506,4785),(87507,4785),(87508,4785),(87509,4786),(87510,4786),(87511,4786),(87512,4786),(87513,4787),(87514,4787),(87515,4787),(87516,4787),(87517,4788),(87518,4788),(87519,4788),(87520,4788),(87521,4789),(87522,4789),(87523,4789),(87524,4789),(87525,4790),(87526,4790),(87527,4790),(87528,4790),(87529,4791),(87530,4791),(87531,4791),(87532,4791),(87533,4792),(87534,4792),(87535,4792),(87536,4792),(87537,4793),(87538,4793),(87539,4793),(87540,4793),(87541,4794),(87542,4794),(87543,4794),(87544,4794),(87545,4795),(87546,4795),(87547,4795),(87548,4795),(87549,4796),(87550,4796),(87551,4796),(87552,4796),(87553,4797),(87554,4797),(87555,4797),(87556,4797),(87557,4798),(87558,4798),(87559,4798),(87560,4798),(87561,4799),(87562,4799),(87563,4799),(87564,4799),(87565,4800),(87566,4800),(87567,4800),(87568,4800),(87569,4801),(87570,4801),(87571,4801),(87572,4801),(87573,4802),(87574,4802),(87575,4802),(87576,4802),(87577,4803),(87578,4803),(87579,4803),(87580,4803),(87581,4804),(87582,4804),(87583,4804),(87584,4804),(87585,4805),(87586,4805),(87587,4805),(87588,4805),(87589,4806),(87590,4806),(87591,4806),(87592,4806),(87593,4807),(87594,4807),(87595,4807),(87596,4807),(87597,4808),(87598,4808),(87599,4808),(87600,4808),(87601,4809),(87602,4809),(87603,4809),(87604,4809),(87605,4810),(87606,4810),(87607,4810),(87608,4810),(87609,4811),(87610,4811),(87611,4811),(87612,4811),(87613,4812),(87614,4812),(87615,4812),(87616,4812),(87617,4813),(87618,4813),(87619,4813),(87620,4813),(87621,4814),(87622,4814),(87623,4814),(87624,4814),(87625,4815),(87626,4815),(87627,4815),(87628,4815),(87629,4816),(87630,4816),(87631,4816),(87632,4816),(87633,4817),(87634,4817),(87635,4817),(87636,4817),(87637,4818),(87638,4818),(87639,4818),(87640,4818),(87641,4819),(87642,4819),(87643,4819),(87644,4819),(87645,4820),(87646,4820),(87647,4820),(87648,4820),(87649,4821),(87650,4821),(87651,4821),(87652,4821),(87653,4822),(87654,4822),(87655,4822),(87656,4822),(87657,4823),(87658,4823),(87659,4823),(87660,4823),(87661,4824),(87662,4824),(87663,4824),(87664,4824),(87665,4825),(87666,4825),(87667,4825),(87668,4825),(87669,4826),(87670,4826),(87671,4826),(87672,4826),(87673,4827),(87674,4827),(87675,4827),(87676,4827),(87677,4828),(87678,4828),(87679,4828),(87680,4828),(87681,4829),(87682,4829),(87683,4829),(87684,4829),(87685,4830),(87686,4830),(87687,4830),(87688,4830),(87689,4831),(87690,4831),(87691,4831),(87692,4831),(87693,4832),(87694,4832),(87695,4832),(87696,4832),(87697,4833),(87698,4833),(87699,4833),(87700,4833),(87701,4834),(87702,4834),(87703,4834),(87704,4834),(87705,4835),(87706,4835),(87707,4835),(87708,4835),(87709,4836),(87710,4836),(87711,4836),(87712,4836),(87713,4837),(87714,4837),(87715,4837),(87716,4837),(87717,4838),(87718,4838),(87719,4838),(87720,4838),(87721,4839),(87722,4839),(87723,4839),(87724,4839),(87725,4840),(87726,4840),(87727,4840),(87728,4840),(87729,4841),(87730,4841),(87731,4841),(87732,4841),(87733,4842),(87734,4842),(87735,4842),(87736,4842),(87737,4843),(87738,4843),(87739,4843),(87740,4843),(87741,4844),(87742,4844),(87743,4844),(87744,4844),(87745,4845),(87746,4845),(87747,4845),(87748,4845),(87749,4846),(87750,4846),(87751,4846),(87752,4846),(87753,4847),(87754,4847),(87755,4847),(87756,4847),(87757,4848),(87758,4848),(87759,4848),(87760,4848),(87761,4849),(87762,4849),(87763,4849),(87764,4849),(87765,4850),(87766,4850),(87767,4850),(87768,4850),(87769,4851),(87770,4851),(87771,4851),(87772,4851),(87773,4852),(87774,4852),(87775,4852),(87776,4852),(87777,4853),(87778,4853),(87779,4853),(87780,4853),(87781,4854),(87782,4854),(87783,4854),(87784,4854),(87785,4855),(87786,4855),(87787,4855),(87788,4855),(87789,4856),(87790,4856),(87791,4856),(87792,4856),(87793,4857),(87794,4857),(87795,4857),(87796,4857),(87797,4858),(87798,4858),(87799,4858),(87800,4858),(87801,4859),(87802,4859),(87803,4859),(87804,4859),(87805,4860),(87806,4860),(87807,4860),(87808,4860),(87809,4861),(87810,4861),(87811,4861),(87812,4861),(87813,4862),(87814,4862),(87815,4862),(87816,4862),(87817,4863),(87818,4863),(87819,4863),(87820,4863),(87821,4864),(87822,4864),(87823,4864),(87824,4864),(87825,4865),(87826,4865),(87827,4865),(87828,4865),(87829,4866),(87830,4866),(87831,4866),(87832,4866),(87833,4867),(87834,4867),(87835,4867),(87836,4867),(87837,4868),(87838,4868),(87839,4868),(87840,4868),(87841,4869),(87842,4869),(87843,4869),(87844,4869),(87845,4870),(87846,4870),(87847,4870),(87848,4870),(87849,4871),(87850,4871),(87851,4871),(87852,4871),(87853,4872),(87854,4872),(87855,4872),(87856,4872),(87857,4873),(87858,4873),(87859,4873),(87860,4873),(87861,4874),(87862,4874),(87863,4874),(87864,4874),(87865,4875),(87866,4875),(87867,4875),(87868,4875),(87869,4876),(87870,4876),(87871,4876),(87872,4876),(87873,4877),(87874,4877),(87875,4877),(87876,4877),(87877,4878),(87878,4878),(87879,4878),(87880,4878),(87881,4879),(87882,4879),(87883,4879),(87884,4879),(87885,4880),(87886,4881),(87887,4882),(87888,4883),(87889,4884),(87890,4885),(87891,4886),(87892,4887),(87893,4888),(87894,4889),(87895,4890),(87896,4891),(87897,4892),(87898,4893),(87899,4894),(87900,4895),(87901,4896),(87902,4897),(87903,4898),(87904,4899),(87905,4900),(87906,4901),(87907,4902),(87908,4903),(87909,4904),(87910,4905),(87911,4906),(87912,4907),(87913,4908),(87914,4909),(87915,4910),(87916,4911),(87917,4912),(87918,4913),(87919,4914),(87920,4915),(87921,4916),(87922,4917),(87923,4918),(87924,4919),(87925,4920),(87926,4921),(87927,4922),(87928,4923),(87929,4924),(87930,4925),(87931,4926),(87932,4927),(87933,4928),(87934,4929),(87935,4930),(87936,4931),(87937,4932),(87938,4933),(87939,4934),(87940,4935),(87941,4936),(87942,4937),(87943,4938),(87944,4939),(87945,4940),(87946,4941),(87947,4942),(87948,4943),(87949,4944),(87950,4945),(87951,4946),(87952,4947),(87953,4948),(87954,4949),(87955,4950),(87956,4951),(87957,4952),(87958,4953),(87959,4954),(87960,4955),(87961,4956),(87962,4957),(87963,4958),(87964,4959),(87965,4960),(87966,4961),(87967,4962),(87968,4963),(87969,4964),(87970,4965),(87971,4966),(87972,4967),(87973,4968),(87974,4969),(87975,4970),(87976,4971),(87977,4972),(87978,4973),(87979,4974),(87980,4975),(87981,4976),(87982,4977),(87983,4978),(87984,4979),(87985,4880),(87986,4881),(87987,4882),(87988,4883),(87989,4884),(87990,4885),(87991,4886),(87992,4887),(87993,4888),(87994,4889),(87995,4890),(87996,4891),(87997,4892),(87998,4893),(87999,4894),(88000,4895),(88001,4896),(88002,4897),(88003,4898),(88004,4899),(88005,4900),(88006,4901),(88007,4902),(88008,4903),(88009,4904),(88010,4905),(88011,4906),(88012,4907),(88013,4908),(88014,4909),(88015,4910),(88016,4911),(88017,4912),(88018,4913),(88019,4914),(88020,4915),(88021,4916),(88022,4917),(88023,4918),(88024,4919),(88025,4920),(88026,4921),(88027,4922),(88028,4923),(88029,4924),(88030,4925),(88031,4926),(88032,4927),(88033,4928),(88034,4929),(88035,4930),(88036,4931),(88037,4932),(88038,4933),(88039,4934),(88040,4935),(88041,4936),(88042,4937),(88043,4938),(88044,4939),(88045,4940),(88046,4941),(88047,4942),(88048,4943),(88049,4944),(88050,4945),(88051,4946),(88052,4947),(88053,4948),(88054,4949),(88055,4950),(88056,4951),(88057,4952),(88058,4953),(88059,4954),(88060,4955),(88061,4956),(88062,4957),(88063,4958),(88064,4959),(88065,4960),(88066,4961),(88067,4962),(88068,4963),(88069,4964),(88070,4965),(88071,4966),(88072,4967),(88073,4968),(88074,4969),(88075,4970),(88076,4971),(88077,4972),(88078,4973),(88079,4974),(88080,4975),(88081,4976),(88082,4977),(88083,4978),(88084,4979),(88085,4880),(88086,4880),(88087,4880),(88088,4880),(88089,4880),(88090,4880),(88091,4881),(88092,4881),(88093,4881),(88094,4881),(88095,4881),(88096,4881),(88097,4882),(88098,4882),(88099,4882),(88100,4882),(88101,4882),(88102,4882),(88103,4883),(88104,4883),(88105,4883),(88106,4883),(88107,4883),(88108,4883),(88109,4884),(88110,4884),(88111,4884),(88112,4884),(88113,4884),(88114,4884),(88115,4885),(88116,4885),(88117,4885),(88118,4885),(88119,4885),(88120,4885),(88121,4886),(88122,4886),(88123,4886),(88124,4886),(88125,4886),(88126,4886),(88127,4887),(88128,4887),(88129,4887),(88130,4887),(88131,4887),(88132,4887),(88133,4888),(88134,4888),(88135,4888),(88136,4888),(88137,4888),(88138,4888),(88139,4889),(88140,4889),(88141,4889),(88142,4889),(88143,4889),(88144,4889),(88145,4890),(88146,4890),(88147,4890),(88148,4890),(88149,4890),(88150,4890),(88151,4891),(88152,4891),(88153,4891),(88154,4891),(88155,4891),(88156,4891),(88157,4892),(88158,4892),(88159,4892),(88160,4892),(88161,4892),(88162,4892),(88163,4893),(88164,4893),(88165,4893),(88166,4893),(88167,4893),(88168,4893),(88169,4894),(88170,4894),(88171,4894),(88172,4894),(88173,4894),(88174,4894),(88175,4895),(88176,4895),(88177,4895),(88178,4895),(88179,4895),(88180,4895),(88181,4896),(88182,4896),(88183,4896),(88184,4896),(88185,4896),(88186,4896),(88187,4897),(88188,4897),(88189,4897),(88190,4897),(88191,4897),(88192,4897),(88193,4898),(88194,4898),(88195,4898),(88196,4898),(88197,4898),(88198,4898),(88199,4899),(88200,4899),(88201,4899),(88202,4899),(88203,4899),(88204,4899),(88205,4900),(88206,4900),(88207,4900),(88208,4900),(88209,4900),(88210,4900),(88211,4901),(88212,4901),(88213,4901),(88214,4901),(88215,4901),(88216,4901),(88217,4902),(88218,4902),(88219,4902),(88220,4902),(88221,4902),(88222,4902),(88223,4903),(88224,4903),(88225,4903),(88226,4903),(88227,4903),(88228,4903),(88229,4904),(88230,4904),(88231,4904),(88232,4904),(88233,4904),(88234,4904),(88235,4905),(88236,4905),(88237,4905),(88238,4905),(88239,4905),(88240,4905),(88241,4906),(88242,4906),(88243,4906),(88244,4906),(88245,4906),(88246,4906),(88247,4907),(88248,4907),(88249,4907),(88250,4907),(88251,4907),(88252,4907),(88253,4908),(88254,4908),(88255,4908),(88256,4908),(88257,4908),(88258,4908),(88259,4909),(88260,4909),(88261,4909),(88262,4909),(88263,4909),(88264,4909),(88265,4910),(88266,4910),(88267,4910),(88268,4910),(88269,4910),(88270,4910),(88271,4911),(88272,4911),(88273,4911),(88274,4911),(88275,4911),(88276,4911),(88277,4912),(88278,4912),(88279,4912),(88280,4912),(88281,4912),(88282,4912),(88283,4913),(88284,4913),(88285,4913),(88286,4913),(88287,4913),(88288,4913),(88289,4914),(88290,4914),(88291,4914),(88292,4914),(88293,4914),(88294,4914),(88295,4915),(88296,4915),(88297,4915),(88298,4915),(88299,4915),(88300,4915),(88301,4916),(88302,4916),(88303,4916),(88304,4916),(88305,4916),(88306,4916),(88307,4917),(88308,4917),(88309,4917),(88310,4917),(88311,4917),(88312,4917),(88313,4918),(88314,4918),(88315,4918),(88316,4918),(88317,4918),(88318,4918),(88319,4919),(88320,4919),(88321,4919),(88322,4919),(88323,4919),(88324,4919),(88325,4920),(88326,4920),(88327,4920),(88328,4920),(88329,4920),(88330,4920),(88331,4921),(88332,4921),(88333,4921),(88334,4921),(88335,4921),(88336,4921),(88337,4922),(88338,4922),(88339,4922),(88340,4922),(88341,4922),(88342,4922),(88343,4923),(88344,4923),(88345,4923),(88346,4923),(88347,4923),(88348,4923),(88349,4924),(88350,4924),(88351,4924),(88352,4924),(88353,4925),(88354,4925),(88355,4925),(88356,4925),(88357,4926),(88358,4926),(88359,4926),(88360,4926),(88361,4927),(88362,4927),(88363,4927),(88364,4927),(88365,4928),(88366,4928),(88367,4928),(88368,4928),(88369,4929),(88370,4929),(88371,4929),(88372,4929),(88373,4930),(88374,4930),(88375,4930),(88376,4930),(88377,4931),(88378,4931),(88379,4931),(88380,4931),(88381,4932),(88382,4932),(88383,4932),(88384,4932),(88385,4933),(88386,4933),(88387,4933),(88388,4933),(88389,4933),(88390,4933),(88391,4934),(88392,4934),(88393,4934),(88394,4934),(88395,4935),(88396,4935),(88397,4935),(88398,4935),(88399,4936),(88400,4936),(88401,4936),(88402,4936),(88403,4937),(88404,4937),(88405,4937),(88406,4937),(88407,4938),(88408,4938),(88409,4938),(88410,4938),(88411,4939),(88412,4939),(88413,4939),(88414,4939),(88415,4940),(88416,4940),(88417,4940),(88418,4940),(88419,4941),(88420,4941),(88421,4941),(88422,4941),(88423,4942),(88424,4942),(88425,4942),(88426,4942),(88427,4942),(88428,4942),(88429,4943),(88430,4943),(88431,4943),(88432,4943),(88433,4943),(88434,4943),(88435,4944),(88436,4944),(88437,4944),(88438,4944),(88439,4944),(88440,4944),(88441,4945),(88442,4945),(88443,4945),(88444,4945),(88445,4945),(88446,4945),(88447,4946),(88448,4946),(88449,4946),(88450,4946),(88451,4946),(88452,4946),(88453,4947),(88454,4947),(88455,4947),(88456,4947),(88457,4947),(88458,4947),(88459,4948),(88460,4948),(88461,4948),(88462,4948),(88463,4948),(88464,4948),(88465,4949),(88466,4949),(88467,4949),(88468,4949),(88469,4949),(88470,4949),(88471,4950),(88472,4950),(88473,4950),(88474,4950),(88475,4950),(88476,4950),(88477,4951),(88478,4951),(88479,4951),(88480,4951),(88481,4951),(88482,4951),(88483,4952),(88484,4952),(88485,4952),(88486,4952),(88487,4952),(88488,4952),(88489,4953),(88490,4953),(88491,4953),(88492,4953),(88493,4953),(88494,4953),(88495,4954),(88496,4954),(88497,4954),(88498,4954),(88499,4954),(88500,4955),(88501,4955),(88502,4955),(88503,4955),(88504,4955),(88505,4955),(88506,4956),(88507,4956),(88508,4956),(88509,4956),(88510,4956),(88511,4956),(88512,4957),(88513,4957),(88514,4957),(88515,4957),(88516,4957),(88517,4957),(88518,4958),(88519,4958),(88520,4958),(88521,4958),(88522,4958),(88523,4958),(88524,4959),(88525,4959),(88526,4959),(88527,4959),(88528,4959),(88529,4959),(88530,4960),(88531,4960),(88532,4960),(88533,4960),(88534,4960),(88535,4960),(88536,4961),(88537,4961),(88538,4961),(88539,4961),(88540,4961),(88541,4961),(88542,4962),(88543,4962),(88544,4962),(88545,4962),(88546,4962),(88547,4962),(88548,4963),(88549,4963),(88550,4963),(88551,4963),(88552,4964),(88553,4964),(88554,4964),(88555,4964),(88556,4965),(88557,4965),(88558,4965),(88559,4965),(88560,4965),(88561,4965),(88562,4966),(88563,4966),(88564,4966),(88565,4966),(88566,4966),(88567,4966),(88568,4967),(88569,4967),(88570,4967),(88571,4967),(88572,4967),(88573,4967),(88574,4968),(88575,4968),(88576,4968),(88577,4968),(88578,4968),(88579,4968),(88580,4969),(88581,4969),(88582,4969),(88583,4969),(88584,4969),(88585,4969),(88586,4970),(88587,4970),(88588,4970),(88589,4970),(88590,4970),(88591,4970),(88592,4971),(88593,4971),(88594,4971),(88595,4971),(88596,4971),(88597,4971),(88598,4972),(88599,4972),(88600,4972),(88601,4972),(88602,4972),(88603,4972),(88604,4973),(88605,4973),(88606,4973),(88607,4973),(88608,4973),(88609,4973),(88610,4974),(88611,4974),(88612,4974),(88613,4974),(88614,4974),(88615,4974),(88616,4975),(88617,4975),(88618,4975),(88619,4975),(88620,4975),(88621,4975),(88622,4976),(88623,4976),(88624,4976),(88625,4976),(88626,4976),(88627,4976),(88628,4977),(88629,4977),(88630,4977),(88631,4977),(88632,4977),(88633,4977),(88634,4978),(88635,4978),(88636,4978),(88637,4978),(88638,4978),(88639,4978),(88640,4979),(88641,4979),(88642,4979),(88643,4979),(88644,4979),(88645,4979),(88646,4880),(88647,4880),(88648,4880),(88649,4881),(88650,4881),(88651,4881),(88652,4882),(88653,4882),(88654,4882),(88655,4883),(88656,4883),(88657,4883),(88658,4884),(88659,4884),(88660,4884),(88661,4885),(88662,4885),(88663,4885),(88664,4886),(88665,4886),(88666,4886),(88667,4887),(88668,4887),(88669,4887),(88670,4888),(88671,4888),(88672,4888),(88673,4889),(88674,4889),(88675,4889),(88676,4890),(88677,4890),(88678,4890),(88679,4891),(88680,4891),(88681,4892),(88682,4892),(88683,4893),(88684,4893),(88685,4894),(88686,4894),(88687,4895),(88688,4895),(88689,4896),(88690,4896),(88691,4896),(88692,4897),(88693,4897),(88694,4898),(88695,4898),(88696,4898),(88697,4899),(88698,4899),(88699,4899),(88700,4900),(88701,4900),(88702,4900),(88703,4901),(88704,4901),(88705,4901),(88706,4902),(88707,4902),(88708,4902),(88709,4903),(88710,4903),(88711,4903),(88712,4904),(88713,4904),(88714,4904),(88715,4905),(88716,4905),(88717,4905),(88718,4906),(88719,4906),(88720,4906),(88721,4907),(88722,4907),(88723,4907),(88724,4908),(88725,4908),(88726,4908),(88727,4909),(88728,4909),(88729,4909),(88730,4910),(88731,4910),(88732,4910),(88733,4911),(88734,4911),(88735,4911),(88736,4912),(88737,4912),(88738,4912),(88739,4913),(88740,4913),(88741,4913),(88742,4914),(88743,4914),(88744,4914),(88745,4915),(88746,4915),(88747,4915),(88748,4916),(88749,4916),(88750,4916),(88751,4917),(88752,4917),(88753,4917),(88754,4918),(88755,4918),(88756,4918),(88757,4919),(88758,4919),(88759,4919),(88760,4920),(88761,4920),(88762,4920),(88763,4921),(88764,4921),(88765,4921),(88766,4922),(88767,4922),(88768,4922),(88769,4923),(88770,4923),(88771,4923),(88772,4924),(88773,4924),(88774,4925),(88775,4925),(88776,4926),(88777,4926),(88778,4927),(88779,4927),(88780,4928),(88781,4928),(88782,4929),(88783,4929),(88784,4930),(88785,4930),(88786,4931),(88787,4931),(88788,4932),(88789,4932),(88790,4933),(88791,4933),(88792,4934),(88793,4934),(88794,4935),(88795,4935),(88796,4936),(88797,4936),(88798,4937),(88799,4937),(88800,4938),(88801,4938),(88802,4939),(88803,4939),(88804,4940),(88805,4940),(88806,4941),(88807,4941),(88808,4942),(88809,4942),(88810,4943),(88811,4943),(88812,4943),(88813,4944),(88814,4944),(88815,4944),(88816,4945),(88817,4945),(88818,4945),(88819,4946),(88820,4946),(88821,4946),(88822,4947),(88823,4947),(88824,4947),(88825,4948),(88826,4948),(88827,4948),(88828,4949),(88829,4949),(88830,4949),(88831,4950),(88832,4950),(88833,4950),(88834,4951),(88835,4951),(88836,4951),(88837,4952),(88838,4952),(88839,4952),(88840,4953),(88841,4953),(88842,4953),(88843,4954),(88844,4954),(88845,4955),(88846,4955),(88847,4955),(88848,4956),(88849,4956),(88850,4956),(88851,4957),(88852,4957),(88853,4957),(88854,4958),(88855,4958),(88856,4958),(88857,4959),(88858,4959),(88859,4959),(88860,4960),(88861,4960),(88862,4960),(88863,4961),(88864,4961),(88865,4961),(88866,4962),(88867,4962),(88868,4962),(88869,4963),(88870,4963),(88871,4964),(88872,4964),(88873,4965),(88874,4965),(88875,4965),(88876,4966),(88877,4966),(88878,4966),(88879,4967),(88880,4967),(88881,4967),(88882,4968),(88883,4968),(88884,4968),(88885,4969),(88886,4969),(88887,4969),(88888,4970),(88889,4970),(88890,4971),(88891,4971),(88892,4971),(88893,4972),(88894,4972),(88895,4972),(88896,4973),(88897,4973),(88898,4973),(88899,4974),(88900,4974),(88901,4974),(88902,4975),(88903,4975),(88904,4975),(88905,4976),(88906,4976),(88907,4976),(88908,4977),(88909,4977),(88910,4977),(88911,4978),(88912,4978),(88913,4978),(88914,4979),(88915,4979),(88916,4979),(88917,4880),(88918,4880),(88919,4880),(88920,4881),(88921,4881),(88922,4881),(88923,4882),(88924,4882),(88925,4882),(88926,4883),(88927,4883),(88928,4883),(88929,4884),(88930,4884),(88931,4884),(88932,4885),(88933,4885),(88934,4885),(88935,4886),(88936,4886),(88937,4886),(88938,4887),(88939,4887),(88940,4887),(88941,4888),(88942,4888),(88943,4888),(88944,4889),(88945,4889),(88946,4889),(88947,4890),(88948,4890),(88949,4890),(88950,4891),(88951,4891),(88952,4891),(88953,4892),(88954,4892),(88955,4892),(88956,4893),(88957,4893),(88958,4893),(88959,4894),(88960,4894),(88961,4894),(88962,4895),(88963,4895),(88964,4895),(88965,4896),(88966,4896),(88967,4896),(88968,4897),(88969,4897),(88970,4897),(88971,4898),(88972,4898),(88973,4898),(88974,4899),(88975,4899),(88976,4899),(88977,4900),(88978,4900),(88979,4900),(88980,4901),(88981,4901),(88982,4901),(88983,4902),(88984,4902),(88985,4902),(88986,4903),(88987,4903),(88988,4903),(88989,4904),(88990,4904),(88991,4904),(88992,4905),(88993,4905),(88994,4905),(88995,4906),(88996,4906),(88997,4906),(88998,4907),(88999,4907),(89000,4907),(89001,4908),(89002,4908),(89003,4908),(89004,4909),(89005,4909),(89006,4909),(89007,4910),(89008,4910),(89009,4910),(89010,4911),(89011,4911),(89012,4911),(89013,4912),(89014,4912),(89015,4912),(89016,4913),(89017,4913),(89018,4913),(89019,4914),(89020,4914),(89021,4914),(89022,4915),(89023,4915),(89024,4915),(89025,4916),(89026,4916),(89027,4916),(89028,4917),(89029,4917),(89030,4917),(89031,4918),(89032,4918),(89033,4918),(89034,4919),(89035,4919),(89036,4919),(89037,4920),(89038,4920),(89039,4920),(89040,4921),(89041,4921),(89042,4921),(89043,4922),(89044,4922),(89045,4922),(89046,4923),(89047,4923),(89048,4923),(89049,4924),(89050,4924),(89051,4924),(89052,4925),(89053,4925),(89054,4925),(89055,4926),(89056,4926),(89057,4926),(89058,4927),(89059,4927),(89060,4927),(89061,4928),(89062,4928),(89063,4928),(89064,4929),(89065,4929),(89066,4929),(89067,4930),(89068,4930),(89069,4930),(89070,4931),(89071,4931),(89072,4931),(89073,4932),(89074,4932),(89075,4932),(89076,4933),(89077,4933),(89078,4933),(89079,4934),(89080,4934),(89081,4934),(89082,4935),(89083,4935),(89084,4935),(89085,4936),(89086,4936),(89087,4936),(89088,4937),(89089,4937),(89090,4937),(89091,4938),(89092,4938),(89093,4938),(89094,4939),(89095,4939),(89096,4939),(89097,4940),(89098,4940),(89099,4940),(89100,4941),(89101,4941),(89102,4941),(89103,4942),(89104,4942),(89105,4942),(89106,4943),(89107,4943),(89108,4943),(89109,4944),(89110,4944),(89111,4944),(89112,4945),(89113,4945),(89114,4945),(89115,4946),(89116,4946),(89117,4946),(89118,4947),(89119,4947),(89120,4947),(89121,4948),(89122,4948),(89123,4948),(89124,4949),(89125,4949),(89126,4949),(89127,4950),(89128,4950),(89129,4950),(89130,4951),(89131,4951),(89132,4951),(89133,4952),(89134,4952),(89135,4952),(89136,4953),(89137,4953),(89138,4953),(89139,4954),(89140,4954),(89141,4954),(89142,4955),(89143,4955),(89144,4955),(89145,4956),(89146,4956),(89147,4956),(89148,4957),(89149,4957),(89150,4957),(89151,4958),(89152,4958),(89153,4958),(89154,4959),(89155,4959),(89156,4959),(89157,4960),(89158,4960),(89159,4960),(89160,4961),(89161,4961),(89162,4961),(89163,4962),(89164,4962),(89165,4962),(89166,4963),(89167,4963),(89168,4963),(89169,4964),(89170,4964),(89171,4964),(89172,4965),(89173,4965),(89174,4965),(89175,4966),(89176,4966),(89177,4966),(89178,4967),(89179,4967),(89180,4967),(89181,4968),(89182,4968),(89183,4968),(89184,4969),(89185,4969),(89186,4969),(89187,4970),(89188,4970),(89189,4970),(89190,4971),(89191,4971),(89192,4971),(89193,4972),(89194,4972),(89195,4972),(89196,4973),(89197,4973),(89198,4973),(89199,4974),(89200,4974),(89201,4974),(89202,4975),(89203,4975),(89204,4975),(89205,4976),(89206,4976),(89207,4976),(89208,4977),(89209,4977),(89210,4977),(89211,4978),(89212,4978),(89213,4978),(89214,4979),(89215,4979),(89216,4979),(89217,4880),(89218,4880),(89219,4880),(89220,4880),(89221,4881),(89222,4881),(89223,4881),(89224,4881),(89225,4882),(89226,4882),(89227,4882),(89228,4882),(89229,4883),(89230,4883),(89231,4883),(89232,4883),(89233,4884),(89234,4884),(89235,4884),(89236,4884),(89237,4885),(89238,4885),(89239,4885),(89240,4885),(89241,4886),(89242,4886),(89243,4886),(89244,4886),(89245,4887),(89246,4887),(89247,4887),(89248,4887),(89249,4888),(89250,4888),(89251,4888),(89252,4888),(89253,4889),(89254,4889),(89255,4889),(89256,4889),(89257,4890),(89258,4890),(89259,4890),(89260,4890),(89261,4891),(89262,4891),(89263,4891),(89264,4891),(89265,4892),(89266,4892),(89267,4892),(89268,4892),(89269,4893),(89270,4893),(89271,4893),(89272,4893),(89273,4894),(89274,4894),(89275,4894),(89276,4894),(89277,4895),(89278,4895),(89279,4895),(89280,4895),(89281,4896),(89282,4896),(89283,4896),(89284,4896),(89285,4897),(89286,4897),(89287,4897),(89288,4897),(89289,4898),(89290,4898),(89291,4898),(89292,4898),(89293,4899),(89294,4899),(89295,4899),(89296,4899),(89297,4900),(89298,4900),(89299,4900),(89300,4900),(89301,4901),(89302,4901),(89303,4901),(89304,4901),(89305,4902),(89306,4902),(89307,4902),(89308,4902),(89309,4903),(89310,4903),(89311,4903),(89312,4903),(89313,4904),(89314,4904),(89315,4904),(89316,4904),(89317,4905),(89318,4905),(89319,4905),(89320,4905),(89321,4906),(89322,4906),(89323,4906),(89324,4906),(89325,4907),(89326,4907),(89327,4907),(89328,4907),(89329,4908),(89330,4908),(89331,4908),(89332,4908),(89333,4909),(89334,4909),(89335,4909),(89336,4909),(89337,4910),(89338,4910),(89339,4910),(89340,4910),(89341,4911),(89342,4911),(89343,4911),(89344,4911),(89345,4912),(89346,4912),(89347,4912),(89348,4912),(89349,4913),(89350,4913),(89351,4913),(89352,4913),(89353,4914),(89354,4914),(89355,4914),(89356,4914),(89357,4915),(89358,4915),(89359,4915),(89360,4915),(89361,4916),(89362,4916),(89363,4916),(89364,4916),(89365,4917),(89366,4917),(89367,4917),(89368,4917),(89369,4918),(89370,4918),(89371,4918),(89372,4918),(89373,4919),(89374,4919),(89375,4919),(89376,4919),(89377,4920),(89378,4920),(89379,4920),(89380,4920),(89381,4921),(89382,4921),(89383,4921),(89384,4921),(89385,4922),(89386,4922),(89387,4922),(89388,4922),(89389,4923),(89390,4923),(89391,4923),(89392,4923),(89393,4924),(89394,4924),(89395,4924),(89396,4924),(89397,4925),(89398,4925),(89399,4925),(89400,4925),(89401,4926),(89402,4926),(89403,4926),(89404,4926),(89405,4927),(89406,4927),(89407,4927),(89408,4927),(89409,4928),(89410,4928),(89411,4928),(89412,4928),(89413,4929),(89414,4929),(89415,4929),(89416,4929),(89417,4930),(89418,4930),(89419,4930),(89420,4930),(89421,4931),(89422,4931),(89423,4931),(89424,4931),(89425,4932),(89426,4932),(89427,4932),(89428,4932),(89429,4933),(89430,4933),(89431,4933),(89432,4933),(89433,4934),(89434,4934),(89435,4934),(89436,4934),(89437,4935),(89438,4935),(89439,4935),(89440,4935),(89441,4936),(89442,4936),(89443,4936),(89444,4936),(89445,4937),(89446,4937),(89447,4937),(89448,4937),(89449,4938),(89450,4938),(89451,4938),(89452,4938),(89453,4939),(89454,4939),(89455,4939),(89456,4939),(89457,4940),(89458,4940),(89459,4940),(89460,4940),(89461,4941),(89462,4941),(89463,4941),(89464,4941),(89465,4942),(89466,4942),(89467,4942),(89468,4942),(89469,4943),(89470,4943),(89471,4943),(89472,4943),(89473,4944),(89474,4944),(89475,4944),(89476,4944),(89477,4945),(89478,4945),(89479,4945),(89480,4945),(89481,4946),(89482,4946),(89483,4946),(89484,4946),(89485,4947),(89486,4947),(89487,4947),(89488,4947),(89489,4948),(89490,4948),(89491,4948),(89492,4948),(89493,4949),(89494,4949),(89495,4949),(89496,4949),(89497,4950),(89498,4950),(89499,4950),(89500,4950),(89501,4951),(89502,4951),(89503,4951),(89504,4951),(89505,4952),(89506,4952),(89507,4952),(89508,4952),(89509,4953),(89510,4953),(89511,4953),(89512,4953),(89513,4954),(89514,4954),(89515,4954),(89516,4954),(89517,4955),(89518,4955),(89519,4955),(89520,4955),(89521,4956),(89522,4956),(89523,4956),(89524,4956),(89525,4957),(89526,4957),(89527,4957),(89528,4957),(89529,4958),(89530,4958),(89531,4958),(89532,4958),(89533,4959),(89534,4959),(89535,4959),(89536,4959),(89537,4960),(89538,4960),(89539,4960),(89540,4960),(89541,4961),(89542,4961),(89543,4961),(89544,4961),(89545,4962),(89546,4962),(89547,4962),(89548,4962),(89549,4963),(89550,4963),(89551,4963),(89552,4963),(89553,4964),(89554,4964),(89555,4964),(89556,4964),(89557,4965),(89558,4965),(89559,4965),(89560,4965),(89561,4966),(89562,4966),(89563,4966),(89564,4966),(89565,4967),(89566,4967),(89567,4967),(89568,4967),(89569,4968),(89570,4968),(89571,4968),(89572,4968),(89573,4969),(89574,4969),(89575,4969),(89576,4969),(89577,4970),(89578,4970),(89579,4970),(89580,4970),(89581,4971),(89582,4971),(89583,4971),(89584,4971),(89585,4972),(89586,4972),(89587,4972),(89588,4972),(89589,4973),(89590,4973),(89591,4973),(89592,4973),(89593,4974),(89594,4974),(89595,4974),(89596,4974),(89597,4975),(89598,4975),(89599,4975),(89600,4975),(89601,4976),(89602,4976),(89603,4976),(89604,4976),(89605,4977),(89606,4977),(89607,4977),(89608,4977),(89609,4978),(89610,4978),(89611,4978),(89612,4978),(89613,4979),(89614,4979),(89615,4979),(89616,4979),(89617,4980),(89618,4981),(89619,4982),(89620,4983),(89621,4984),(89622,4985),(89623,4986),(89624,4987),(89625,4988),(89626,4989),(89627,4990),(89628,4991),(89629,4992),(89630,4993),(89631,4994),(89632,4995),(89633,4996),(89634,4997),(89635,4998),(89636,4999),(89637,5000),(89638,5001),(89639,5002),(89640,5003),(89641,5004),(89642,5005),(89643,5006),(89644,5007),(89645,5008),(89646,5009),(89647,5010),(89648,5011),(89649,5012),(89650,5013),(89651,5014),(89652,5015),(89653,5016),(89654,5017),(89655,5018),(89656,5019),(89657,5020),(89658,5021),(89659,5022),(89660,5023),(89661,5024),(89662,5025),(89663,5026),(89664,5027),(89665,5028),(89666,5029),(89667,5030),(89668,5031),(89669,5032),(89670,5033),(89671,5034),(89672,5035),(89673,5036),(89674,5037),(89675,5038),(89676,5039),(89677,5040),(89678,5041),(89679,5042),(89680,5043),(89681,5044),(89682,5045),(89683,5046),(89684,5047),(89685,5048),(89686,5049),(89687,5050),(89688,5051),(89689,5052),(89690,5053),(89691,5054),(89692,5055),(89693,5056),(89694,5057),(89695,5058),(89696,5059),(89697,5060),(89698,5061),(89699,5062),(89700,5063),(89701,5064),(89702,5065),(89703,5066),(89704,5067),(89705,5068),(89706,5069),(89707,5070),(89708,5071),(89709,5072),(89710,5073),(89711,5074),(89712,5075),(89713,5076),(89714,5077),(89715,5078),(89716,5079),(89717,4980),(89718,4981),(89719,4982),(89720,4983),(89721,4984),(89722,4985),(89723,4986),(89724,4987),(89725,4988),(89726,4989),(89727,4990),(89728,4991),(89729,4992),(89730,4993),(89731,4994),(89732,4995),(89733,4996),(89734,4997),(89735,4998),(89736,4999),(89737,5000),(89738,5001),(89739,5002),(89740,5003),(89741,5004),(89742,5005),(89743,5006),(89744,5007),(89745,5008),(89746,5009),(89747,5010),(89748,5011),(89749,5012),(89750,5013),(89751,5014),(89752,5015),(89753,5016),(89754,5017),(89755,5018),(89756,5019),(89757,5020),(89758,5021),(89759,5022),(89760,5023),(89761,5024),(89762,5025),(89763,5026),(89764,5027),(89765,5028),(89766,5029),(89767,5030),(89768,5031),(89769,5032),(89770,5033),(89771,5034),(89772,5035),(89773,5036),(89774,5037),(89775,5038),(89776,5039),(89777,5040),(89778,5041),(89779,5042),(89780,5043),(89781,5044),(89782,5045),(89783,5046),(89784,5047),(89785,5048),(89786,5049),(89787,5050),(89788,5051),(89789,5052),(89790,5053),(89791,5054),(89792,5055),(89793,5056),(89794,5057),(89795,5058),(89796,5059),(89797,5060),(89798,5061),(89799,5062),(89800,5063),(89801,5064),(89802,5065),(89803,5066),(89804,5067),(89805,5068),(89806,5069),(89807,5070),(89808,5071),(89809,5072),(89810,5073),(89811,5074),(89812,5075),(89813,5076),(89814,5077),(89815,5078),(89816,5079),(89817,4980),(89818,4980),(89819,4980),(89820,4980),(89821,4980),(89822,4980),(89823,4981),(89824,4981),(89825,4981),(89826,4981),(89827,4981),(89828,4981),(89829,4982),(89830,4982),(89831,4982),(89832,4982),(89833,4982),(89834,4982),(89835,4983),(89836,4983),(89837,4983),(89838,4983),(89839,4983),(89840,4983),(89841,4984),(89842,4984),(89843,4984),(89844,4984),(89845,4984),(89846,4984),(89847,4985),(89848,4985),(89849,4985),(89850,4985),(89851,4985),(89852,4985),(89853,4986),(89854,4986),(89855,4986),(89856,4986),(89857,4986),(89858,4986),(89859,4987),(89860,4987),(89861,4987),(89862,4987),(89863,4987),(89864,4987),(89865,4988),(89866,4988),(89867,4988),(89868,4988),(89869,4988),(89870,4988),(89871,4989),(89872,4989),(89873,4989),(89874,4989),(89875,4989),(89876,4989),(89877,4990),(89878,4990),(89879,4990),(89880,4990),(89881,4990),(89882,4990),(89883,4991),(89884,4991),(89885,4991),(89886,4991),(89887,4991),(89888,4991),(89889,4992),(89890,4992),(89891,4992),(89892,4992),(89893,4992),(89894,4992),(89895,4993),(89896,4993),(89897,4993),(89898,4993),(89899,4993),(89900,4993),(89901,4994),(89902,4994),(89903,4994),(89904,4994),(89905,4994),(89906,4994),(89907,4995),(89908,4995),(89909,4995),(89910,4995),(89911,4995),(89912,4995),(89913,4996),(89914,4996),(89915,4996),(89916,4996),(89917,4996),(89918,4996),(89919,4997),(89920,4997),(89921,4997),(89922,4997),(89923,4997),(89924,4997),(89925,4998),(89926,4998),(89927,4998),(89928,4998),(89929,4998),(89930,4998),(89931,4999),(89932,4999),(89933,4999),(89934,4999),(89935,4999),(89936,4999),(89937,5000),(89938,5000),(89939,5000),(89940,5000),(89941,5000),(89942,5000),(89943,5001),(89944,5001),(89945,5001),(89946,5001),(89947,5001),(89948,5001),(89949,5002),(89950,5002),(89951,5002),(89952,5002),(89953,5002),(89954,5002),(89955,5003),(89956,5003),(89957,5003),(89958,5003),(89959,5003),(89960,5003),(89961,5004),(89962,5004),(89963,5004),(89964,5004),(89965,5004),(89966,5004),(89967,5005),(89968,5005),(89969,5005),(89970,5005),(89971,5005),(89972,5005),(89973,5006),(89974,5006),(89975,5006),(89976,5006),(89977,5006),(89978,5006),(89979,5007),(89980,5007),(89981,5007),(89982,5007),(89983,5007),(89984,5007),(89985,5008),(89986,5008),(89987,5008),(89988,5008),(89989,5008),(89990,5008),(89991,5009),(89992,5009),(89993,5009),(89994,5009),(89995,5009),(89996,5009),(89997,5010),(89998,5010),(89999,5010),(90000,5010),(90001,5010),(90002,5010),(90003,5011),(90004,5011),(90005,5011),(90006,5011),(90007,5011),(90008,5011),(90009,5012),(90010,5012),(90011,5012),(90012,5012),(90013,5012),(90014,5012),(90015,5013),(90016,5013),(90017,5013),(90018,5013),(90019,5013),(90020,5013),(90021,5014),(90022,5014),(90023,5014),(90024,5014),(90025,5014),(90026,5014),(90027,5015),(90028,5015),(90029,5015),(90030,5015),(90031,5015),(90032,5015),(90033,5016),(90034,5016),(90035,5016),(90036,5016),(90037,5016),(90038,5016),(90039,5017),(90040,5017),(90041,5017),(90042,5017),(90043,5017),(90044,5017),(90045,5018),(90046,5018),(90047,5018),(90048,5018),(90049,5018),(90050,5018),(90051,5019),(90052,5019),(90053,5019),(90054,5019),(90055,5019),(90056,5019),(90057,5020),(90058,5020),(90059,5020),(90060,5020),(90061,5020),(90062,5020),(90063,5021),(90064,5021),(90065,5021),(90066,5021),(90067,5021),(90068,5021),(90069,5022),(90070,5022),(90071,5022),(90072,5022),(90073,5022),(90074,5022),(90075,5023),(90076,5023),(90077,5023),(90078,5023),(90079,5023),(90080,5023),(90081,5024),(90082,5024),(90083,5024),(90084,5024),(90085,5024),(90086,5024),(90087,5025),(90088,5025),(90089,5025),(90090,5025),(90091,5025),(90092,5025),(90093,5026),(90094,5026),(90095,5026),(90096,5026),(90097,5026),(90098,5026),(90099,5027),(90100,5027),(90101,5027),(90102,5027),(90103,5027),(90104,5027),(90105,5028),(90106,5028),(90107,5028),(90108,5028),(90109,5028),(90110,5028),(90111,5029),(90112,5029),(90113,5029),(90114,5029),(90115,5029),(90116,5029),(90117,5030),(90118,5030),(90119,5030),(90120,5030),(90121,5030),(90122,5030),(90123,5031),(90124,5031),(90125,5031),(90126,5031),(90127,5031),(90128,5031),(90129,5032),(90130,5032),(90131,5032),(90132,5032),(90133,5032),(90134,5032),(90135,5033),(90136,5033),(90137,5033),(90138,5033),(90139,5033),(90140,5033),(90141,5034),(90142,5034),(90143,5034),(90144,5034),(90145,5034),(90146,5034),(90147,5035),(90148,5035),(90149,5035),(90150,5035),(90151,5035),(90152,5035),(90153,5036),(90154,5036),(90155,5036),(90156,5036),(90157,5036),(90158,5036),(90159,5037),(90160,5037),(90161,5037),(90162,5037),(90163,5038),(90164,5038),(90165,5038),(90166,5038),(90167,5039),(90168,5039),(90169,5039),(90170,5039),(90171,5039),(90172,5039),(90173,5040),(90174,5040),(90175,5040),(90176,5040),(90177,5040),(90178,5040),(90179,5041),(90180,5041),(90181,5041),(90182,5041),(90183,5041),(90184,5041),(90185,5042),(90186,5042),(90187,5042),(90188,5042),(90189,5042),(90190,5042),(90191,5043),(90192,5043),(90193,5043),(90194,5043),(90195,5043),(90196,5043),(90197,5044),(90198,5044),(90199,5044),(90200,5044),(90201,5044),(90202,5044),(90203,5045),(90204,5045),(90205,5045),(90206,5045),(90207,5045),(90208,5045),(90209,5046),(90210,5046),(90211,5046),(90212,5046),(90213,5046),(90214,5046),(90215,5047),(90216,5047),(90217,5047),(90218,5047),(90219,5047),(90220,5047),(90221,5048),(90222,5048),(90223,5048),(90224,5048),(90225,5048),(90226,5048),(90227,5049),(90228,5049),(90229,5049),(90230,5049),(90231,5049),(90232,5049),(90233,5050),(90234,5050),(90235,5050),(90236,5050),(90237,5050),(90238,5050),(90239,5051),(90240,5051),(90241,5051),(90242,5051),(90243,5051),(90244,5051),(90245,5052),(90246,5052),(90247,5052),(90248,5052),(90249,5052),(90250,5052),(90251,5053),(90252,5053),(90253,5053),(90254,5053),(90255,5053),(90256,5053),(90257,5054),(90258,5054),(90259,5054),(90260,5054),(90261,5054),(90262,5054),(90263,5055),(90264,5055),(90265,5055),(90266,5055),(90267,5055),(90268,5055),(90269,5056),(90270,5056),(90271,5056),(90272,5056),(90273,5056),(90274,5056),(90275,5057),(90276,5057),(90277,5057),(90278,5057),(90279,5057),(90280,5057),(90281,5058),(90282,5058),(90283,5058),(90284,5058),(90285,5058),(90286,5058),(90287,5059),(90288,5059),(90289,5059),(90290,5059),(90291,5059),(90292,5059),(90293,5060),(90294,5060),(90295,5060),(90296,5060),(90297,5060),(90298,5060),(90299,5061),(90300,5061),(90301,5061),(90302,5061),(90303,5061),(90304,5061),(90305,5062),(90306,5062),(90307,5062),(90308,5062),(90309,5063),(90310,5063),(90311,5063),(90312,5063),(90313,5064),(90314,5064),(90315,5064),(90316,5064),(90317,5065),(90318,5065),(90319,5065),(90320,5065),(90321,5065),(90322,5065),(90323,5066),(90324,5066),(90325,5066),(90326,5066),(90327,5066),(90328,5066),(90329,5067),(90330,5067),(90331,5067),(90332,5067),(90333,5068),(90334,5068),(90335,5068),(90336,5068),(90337,5069),(90338,5069),(90339,5069),(90340,5069),(90341,5070),(90342,5070),(90343,5070),(90344,5070),(90345,5070),(90346,5070),(90347,5071),(90348,5071),(90349,5071),(90350,5071),(90351,5071),(90352,5071),(90353,5072),(90354,5072),(90355,5072),(90356,5072),(90357,5072),(90358,5072),(90359,5073),(90360,5073),(90361,5073),(90362,5073),(90363,5074),(90364,5074),(90365,5074),(90366,5074),(90367,5075),(90368,5075),(90369,5075),(90370,5075),(90371,5076),(90372,5076),(90373,5076),(90374,5076),(90375,5077),(90376,5077),(90377,5077),(90378,5077),(90379,5077),(90380,5077),(90381,5078),(90382,5078),(90383,5078),(90384,5078),(90385,5078),(90386,5078),(90387,5079),(90388,5079),(90389,5079),(90390,5079),(90391,5079),(90392,5079),(90393,4980),(90394,4980),(90395,4980),(90396,4981),(90397,4981),(90398,4981),(90399,4982),(90400,4982),(90401,4982),(90402,4983),(90403,4983),(90404,4983),(90405,4984),(90406,4984),(90407,4984),(90408,4985),(90409,4985),(90410,4985),(90411,4986),(90412,4986),(90413,4986),(90414,4987),(90415,4987),(90416,4987),(90417,4988),(90418,4988),(90419,4988),(90420,4989),(90421,4989),(90422,4989),(90423,4990),(90424,4990),(90425,4990),(90426,4991),(90427,4991),(90428,4991),(90429,4992),(90430,4992),(90431,4992),(90432,4993),(90433,4993),(90434,4993),(90435,4994),(90436,4994),(90437,4994),(90438,4995),(90439,4995),(90440,4995),(90441,4996),(90442,4996),(90443,4996),(90444,4997),(90445,4997),(90446,4997),(90447,4998),(90448,4998),(90449,4998),(90450,4999),(90451,4999),(90452,4999),(90453,5000),(90454,5000),(90455,5000),(90456,5001),(90457,5001),(90458,5001),(90459,5002),(90460,5002),(90461,5002),(90462,5003),(90463,5003),(90464,5003),(90465,5004),(90466,5004),(90467,5004),(90468,5005),(90469,5005),(90470,5005),(90471,5006),(90472,5006),(90473,5006),(90474,5007),(90475,5007),(90476,5007),(90477,5008),(90478,5008),(90479,5008),(90480,5009),(90481,5009),(90482,5009),(90483,5010),(90484,5010),(90485,5010),(90486,5011),(90487,5011),(90488,5011),(90489,5012),(90490,5012),(90491,5012),(90492,5013),(90493,5013),(90494,5013),(90495,5014),(90496,5014),(90497,5014),(90498,5015),(90499,5015),(90500,5015),(90501,5016),(90502,5016),(90503,5016),(90504,5017),(90505,5017),(90506,5017),(90507,5018),(90508,5018),(90509,5018),(90510,5019),(90511,5019),(90512,5019),(90513,5020),(90514,5020),(90515,5020),(90516,5021),(90517,5021),(90518,5022),(90519,5022),(90520,5023),(90521,5023),(90522,5024),(90523,5024),(90524,5024),(90525,5025),(90526,5025),(90527,5025),(90528,5026),(90529,5026),(90530,5027),(90531,5027),(90532,5028),(90533,5028),(90534,5029),(90535,5029),(90536,5030),(90537,5030),(90538,5031),(90539,5031),(90540,5032),(90541,5032),(90542,5033),(90543,5033),(90544,5034),(90545,5034),(90546,5035),(90547,5035),(90548,5036),(90549,5036),(90550,5037),(90551,5037),(90552,5038),(90553,5038),(90554,5039),(90555,5039),(90556,5039),(90557,5040),(90558,5040),(90559,5040),(90560,5041),(90561,5041),(90562,5041),(90563,5042),(90564,5042),(90565,5042),(90566,5043),(90567,5043),(90568,5043),(90569,5044),(90570,5044),(90571,5044),(90572,5045),(90573,5045),(90574,5045),(90575,5046),(90576,5046),(90577,5046),(90578,5047),(90579,5047),(90580,5047),(90581,5048),(90582,5048),(90583,5048),(90584,5049),(90585,5049),(90586,5049),(90587,5050),(90588,5050),(90589,5050),(90590,5051),(90591,5051),(90592,5051),(90593,5052),(90594,5052),(90595,5052),(90596,5053),(90597,5053),(90598,5053),(90599,5054),(90600,5054),(90601,5054),(90602,5055),(90603,5055),(90604,5055),(90605,5056),(90606,5056),(90607,5056),(90608,5057),(90609,5057),(90610,5057),(90611,5058),(90612,5058),(90613,5058),(90614,5059),(90615,5059),(90616,5059),(90617,5060),(90618,5060),(90619,5060),(90620,5061),(90621,5061),(90622,5061),(90623,5062),(90624,5062),(90625,5063),(90626,5063),(90627,5064),(90628,5064),(90629,5065),(90630,5065),(90631,5065),(90632,5066),(90633,5066),(90634,5066),(90635,5067),(90636,5067),(90637,5068),(90638,5068),(90639,5069),(90640,5069),(90641,5070),(90642,5070),(90643,5070),(90644,5071),(90645,5071),(90646,5071),(90647,5072),(90648,5072),(90649,5072),(90650,5073),(90651,5073),(90652,5074),(90653,5074),(90654,5075),(90655,5075),(90656,5076),(90657,5076),(90658,5077),(90659,5077),(90660,5078),(90661,5078),(90662,5079),(90663,5079),(90664,4980),(90665,4980),(90666,4980),(90667,4981),(90668,4981),(90669,4981),(90670,4982),(90671,4982),(90672,4982),(90673,4983),(90674,4983),(90675,4983),(90676,4984),(90677,4984),(90678,4984),(90679,4985),(90680,4985),(90681,4985),(90682,4986),(90683,4986),(90684,4986),(90685,4987),(90686,4987),(90687,4987),(90688,4988),(90689,4988),(90690,4988),(90691,4989),(90692,4989),(90693,4989),(90694,4990),(90695,4990),(90696,4990),(90697,4991),(90698,4991),(90699,4991),(90700,4992),(90701,4992),(90702,4992),(90703,4993),(90704,4993),(90705,4993),(90706,4994),(90707,4994),(90708,4994),(90709,4995),(90710,4995),(90711,4995),(90712,4996),(90713,4996),(90714,4996),(90715,4997),(90716,4997),(90717,4997),(90718,4998),(90719,4998),(90720,4998),(90721,4999),(90722,4999),(90723,4999),(90724,5000),(90725,5000),(90726,5000),(90727,5001),(90728,5001),(90729,5001),(90730,5002),(90731,5002),(90732,5002),(90733,5003),(90734,5003),(90735,5003),(90736,5004),(90737,5004),(90738,5004),(90739,5005),(90740,5005),(90741,5005),(90742,5006),(90743,5006),(90744,5006),(90745,5007),(90746,5007),(90747,5007),(90748,5008),(90749,5008),(90750,5008),(90751,5009),(90752,5009),(90753,5009),(90754,5010),(90755,5010),(90756,5010),(90757,5011),(90758,5011),(90759,5011),(90760,5012),(90761,5012),(90762,5012),(90763,5013),(90764,5013),(90765,5013),(90766,5014),(90767,5014),(90768,5014),(90769,5015),(90770,5015),(90771,5015),(90772,5016),(90773,5016),(90774,5016),(90775,5017),(90776,5017),(90777,5017),(90778,5018),(90779,5018),(90780,5018),(90781,5019),(90782,5019),(90783,5019),(90784,5020),(90785,5020),(90786,5020),(90787,5021),(90788,5021),(90789,5021),(90790,5022),(90791,5022),(90792,5023),(90793,5023),(90794,5023),(90795,5024),(90796,5024),(90797,5024),(90798,5025),(90799,5025),(90800,5025),(90801,5026),(90802,5026),(90803,5026),(90804,5027),(90805,5027),(90806,5027),(90807,5028),(90808,5028),(90809,5028),(90810,5029),(90811,5029),(90812,5029),(90813,5030),(90814,5030),(90815,5030),(90816,5031),(90817,5031),(90818,5031),(90819,5032),(90820,5032),(90821,5032),(90822,5033),(90823,5033),(90824,5033),(90825,5034),(90826,5034),(90827,5034),(90828,5035),(90829,5035),(90830,5035),(90831,5036),(90832,5036),(90833,5036),(90834,5037),(90835,5037),(90836,5037),(90837,5038),(90838,5038),(90839,5038),(90840,5039),(90841,5039),(90842,5039),(90843,5040),(90844,5040),(90845,5040),(90846,5041),(90847,5041),(90848,5041),(90849,5042),(90850,5042),(90851,5042),(90852,5043),(90853,5043),(90854,5043),(90855,5044),(90856,5044),(90857,5044),(90858,5045),(90859,5045),(90860,5045),(90861,5046),(90862,5046),(90863,5046),(90864,5047),(90865,5047),(90866,5047),(90867,5048),(90868,5048),(90869,5048),(90870,5049),(90871,5049),(90872,5049),(90873,5050),(90874,5050),(90875,5050),(90876,5051),(90877,5051),(90878,5051),(90879,5052),(90880,5052),(90881,5052),(90882,5053),(90883,5053),(90884,5053),(90885,5054),(90886,5054),(90887,5054),(90888,5055),(90889,5055),(90890,5055),(90891,5056),(90892,5056),(90893,5056),(90894,5057),(90895,5057),(90896,5057),(90897,5058),(90898,5058),(90899,5058),(90900,5059),(90901,5059),(90902,5059),(90903,5060),(90904,5060),(90905,5060),(90906,5061),(90907,5061),(90908,5061),(90909,5062),(90910,5062),(90911,5062),(90912,5063),(90913,5063),(90914,5063),(90915,5064),(90916,5064),(90917,5064),(90918,5065),(90919,5065),(90920,5065),(90921,5066),(90922,5066),(90923,5066),(90924,5067),(90925,5067),(90926,5067),(90927,5068),(90928,5068),(90929,5068),(90930,5069),(90931,5069),(90932,5069),(90933,5070),(90934,5070),(90935,5070),(90936,5071),(90937,5071),(90938,5071),(90939,5072),(90940,5072),(90941,5072),(90942,5073),(90943,5073),(90944,5073),(90945,5074),(90946,5074),(90947,5074),(90948,5075),(90949,5075),(90950,5075),(90951,5076),(90952,5076),(90953,5076),(90954,5077),(90955,5077),(90956,5077),(90957,5078),(90958,5078),(90959,5078),(90960,5079),(90961,5079),(90962,5079),(90963,4980),(90964,4980),(90965,4980),(90966,4980),(90967,4981),(90968,4981),(90969,4981),(90970,4981),(90971,4982),(90972,4982),(90973,4982),(90974,4982),(90975,4983),(90976,4983),(90977,4983),(90978,4983),(90979,4984),(90980,4984),(90981,4984),(90982,4984),(90983,4985),(90984,4985),(90985,4985),(90986,4985),(90987,4986),(90988,4986),(90989,4986),(90990,4986),(90991,4987),(90992,4987),(90993,4987),(90994,4987),(90995,4988),(90996,4988),(90997,4988),(90998,4988),(90999,4989),(91000,4989),(91001,4989),(91002,4989),(91003,4990),(91004,4990),(91005,4990),(91006,4990),(91007,4991),(91008,4991),(91009,4991),(91010,4991),(91011,4992),(91012,4992),(91013,4992),(91014,4992),(91015,4993),(91016,4993),(91017,4993),(91018,4993),(91019,4994),(91020,4994),(91021,4994),(91022,4994),(91023,4995),(91024,4995),(91025,4995),(91026,4995),(91027,4996),(91028,4996),(91029,4996),(91030,4996),(91031,4997),(91032,4997),(91033,4997),(91034,4997),(91035,4998),(91036,4998),(91037,4998),(91038,4998),(91039,4999),(91040,4999),(91041,4999),(91042,4999),(91043,5000),(91044,5000),(91045,5000),(91046,5000),(91047,5001),(91048,5001),(91049,5001),(91050,5001),(91051,5002),(91052,5002),(91053,5002),(91054,5002),(91055,5003),(91056,5003),(91057,5003),(91058,5003),(91059,5004),(91060,5004),(91061,5004),(91062,5004),(91063,5005),(91064,5005),(91065,5005),(91066,5005),(91067,5006),(91068,5006),(91069,5006),(91070,5006),(91071,5007),(91072,5007),(91073,5007),(91074,5007),(91075,5008),(91076,5008),(91077,5008),(91078,5008),(91079,5009),(91080,5009),(91081,5009),(91082,5009),(91083,5010),(91084,5010),(91085,5010),(91086,5010),(91087,5011),(91088,5011),(91089,5011),(91090,5011),(91091,5012),(91092,5012),(91093,5012),(91094,5012),(91095,5013),(91096,5013),(91097,5013),(91098,5013),(91099,5014),(91100,5014),(91101,5014),(91102,5014),(91103,5015),(91104,5015),(91105,5015),(91106,5015),(91107,5016),(91108,5016),(91109,5016),(91110,5016),(91111,5017),(91112,5017),(91113,5017),(91114,5017),(91115,5018),(91116,5018),(91117,5018),(91118,5018),(91119,5019),(91120,5019),(91121,5019),(91122,5019),(91123,5020),(91124,5020),(91125,5020),(91126,5020),(91127,5021),(91128,5021),(91129,5021),(91130,5021),(91131,5022),(91132,5022),(91133,5022),(91134,5022),(91135,5023),(91136,5023),(91137,5023),(91138,5023),(91139,5024),(91140,5024),(91141,5024),(91142,5024),(91143,5025),(91144,5025),(91145,5025),(91146,5025),(91147,5026),(91148,5026),(91149,5026),(91150,5026),(91151,5027),(91152,5027),(91153,5027),(91154,5027),(91155,5028),(91156,5028),(91157,5028),(91158,5028),(91159,5029),(91160,5029),(91161,5029),(91162,5029),(91163,5030),(91164,5030),(91165,5030),(91166,5030),(91167,5031),(91168,5031),(91169,5031),(91170,5031),(91171,5032),(91172,5032),(91173,5032),(91174,5032),(91175,5033),(91176,5033),(91177,5033),(91178,5033),(91179,5034),(91180,5034),(91181,5034),(91182,5034),(91183,5035),(91184,5035),(91185,5035),(91186,5035),(91187,5036),(91188,5036),(91189,5036),(91190,5036),(91191,5037),(91192,5037),(91193,5037),(91194,5037),(91195,5038),(91196,5038),(91197,5038),(91198,5038),(91199,5039),(91200,5039),(91201,5039),(91202,5039),(91203,5040),(91204,5040),(91205,5040),(91206,5040),(91207,5041),(91208,5041),(91209,5041),(91210,5041),(91211,5042),(91212,5042),(91213,5042),(91214,5042),(91215,5043),(91216,5043),(91217,5043),(91218,5043),(91219,5044),(91220,5044),(91221,5044),(91222,5044),(91223,5045),(91224,5045),(91225,5045),(91226,5045),(91227,5046),(91228,5046),(91229,5046),(91230,5046),(91231,5047),(91232,5047),(91233,5047),(91234,5047),(91235,5048),(91236,5048),(91237,5048),(91238,5048),(91239,5049),(91240,5049),(91241,5049),(91242,5049),(91243,5050),(91244,5050),(91245,5050),(91246,5050),(91247,5051),(91248,5051),(91249,5051),(91250,5051),(91251,5052),(91252,5052),(91253,5052),(91254,5052),(91255,5053),(91256,5053),(91257,5053),(91258,5053),(91259,5054),(91260,5054),(91261,5054),(91262,5054),(91263,5055),(91264,5055),(91265,5055),(91266,5055),(91267,5056),(91268,5056),(91269,5056),(91270,5056),(91271,5057),(91272,5057),(91273,5057),(91274,5057),(91275,5058),(91276,5058),(91277,5058),(91278,5058),(91279,5059),(91280,5059),(91281,5059),(91282,5059),(91283,5060),(91284,5060),(91285,5060),(91286,5060),(91287,5061),(91288,5061),(91289,5061),(91290,5061),(91291,5062),(91292,5062),(91293,5062),(91294,5062),(91295,5063),(91296,5063),(91297,5063),(91298,5063),(91299,5064),(91300,5064),(91301,5064),(91302,5064),(91303,5065),(91304,5065),(91305,5065),(91306,5065),(91307,5066),(91308,5066),(91309,5066),(91310,5066),(91311,5067),(91312,5067),(91313,5067),(91314,5067),(91315,5068),(91316,5068),(91317,5068),(91318,5068),(91319,5069),(91320,5069),(91321,5069),(91322,5069),(91323,5070),(91324,5070),(91325,5070),(91326,5070),(91327,5071),(91328,5071),(91329,5071),(91330,5071),(91331,5072),(91332,5072),(91333,5072),(91334,5072),(91335,5073),(91336,5073),(91337,5073),(91338,5073),(91339,5074),(91340,5074),(91341,5074),(91342,5074),(91343,5075),(91344,5075),(91345,5075),(91346,5075),(91347,5076),(91348,5076),(91349,5076),(91350,5076),(91351,5077),(91352,5077),(91353,5077),(91354,5077),(91355,5078),(91356,5078),(91357,5078),(91358,5078),(91359,5079),(91360,5079),(91361,5079),(91362,5079),(91363,5080),(91364,5081),(91365,5082),(91366,5083),(91367,5084),(91368,5085),(91369,5086),(91370,5087),(91371,5088),(91372,5089),(91373,5090),(91374,5091),(91375,5092),(91376,5093),(91377,5094),(91378,5095),(91379,5096),(91380,5097),(91381,5098),(91382,5099),(91383,5100),(91384,5101),(91385,5102),(91386,5103),(91387,5104),(91388,5105),(91389,5106),(91390,5107),(91391,5108),(91392,5109),(91393,5110),(91394,5111),(91395,5112),(91396,5113),(91397,5114),(91398,5115),(91399,5116),(91400,5117),(91401,5118),(91402,5119),(91403,5120),(91404,5121),(91405,5122),(91406,5123),(91407,5124),(91408,5125),(91409,5126),(91410,5127),(91411,5128),(91412,5129),(91413,5130),(91414,5131),(91415,5132),(91416,5133),(91417,5134),(91418,5135),(91419,5136),(91420,5137),(91421,5138),(91422,5139),(91423,5140),(91424,5141),(91425,5142),(91426,5143),(91427,5144),(91428,5145),(91429,5146),(91430,5147),(91431,5148),(91432,5149),(91433,5150),(91434,5151),(91435,5152),(91436,5153),(91437,5154),(91438,5155),(91439,5156),(91440,5157),(91441,5158),(91442,5159),(91443,5160),(91444,5161),(91445,5162),(91446,5163),(91447,5164),(91448,5165),(91449,5166),(91450,5167),(91451,5168),(91452,5169),(91453,5170),(91454,5171),(91455,5172),(91456,5173),(91457,5174),(91458,5175),(91459,5176),(91460,5177),(91461,5178),(91462,5179),(91463,5080),(91464,5081),(91465,5082),(91466,5083),(91467,5084),(91468,5085),(91469,5086),(91470,5087),(91471,5088),(91472,5089),(91473,5090),(91474,5091),(91475,5092),(91476,5093),(91477,5094),(91478,5095),(91479,5096),(91480,5097),(91481,5098),(91482,5099),(91483,5100),(91484,5101),(91485,5102),(91486,5103),(91487,5104),(91488,5105),(91489,5106),(91490,5107),(91491,5108),(91492,5109),(91493,5110),(91494,5111),(91495,5112),(91496,5113),(91497,5114),(91498,5115),(91499,5116),(91500,5117),(91501,5118),(91502,5119),(91503,5120),(91504,5121),(91505,5122),(91506,5123),(91507,5124),(91508,5125),(91509,5126),(91510,5127),(91511,5128),(91512,5129),(91513,5130),(91514,5131),(91515,5132),(91516,5133),(91517,5134),(91518,5135),(91519,5136),(91520,5137),(91521,5138),(91522,5139),(91523,5140),(91524,5141),(91525,5142),(91526,5143),(91527,5144),(91528,5145),(91529,5146),(91530,5147),(91531,5148),(91532,5149),(91533,5150),(91534,5151),(91535,5152),(91536,5153),(91537,5154),(91538,5155),(91539,5156),(91540,5157),(91541,5158),(91542,5159),(91543,5160),(91544,5161),(91545,5162),(91546,5163),(91547,5164),(91548,5165),(91549,5166),(91550,5167),(91551,5168),(91552,5169),(91553,5170),(91554,5171),(91555,5172),(91556,5173),(91557,5174),(91558,5175),(91559,5176),(91560,5177),(91561,5178),(91562,5179),(91563,5080),(91564,5080),(91565,5080),(91566,5080),(91567,5080),(91568,5080),(91569,5081),(91570,5081),(91571,5081),(91572,5081),(91573,5081),(91574,5081),(91575,5082),(91576,5082),(91577,5082),(91578,5082),(91579,5082),(91580,5082),(91581,5083),(91582,5083),(91583,5083),(91584,5083),(91585,5083),(91586,5083),(91587,5084),(91588,5084),(91589,5084),(91590,5084),(91591,5084),(91592,5084),(91593,5085),(91594,5085),(91595,5085),(91596,5085),(91597,5085),(91598,5085),(91599,5086),(91600,5086),(91601,5086),(91602,5086),(91603,5086),(91604,5086),(91605,5087),(91606,5087),(91607,5087),(91608,5087),(91609,5087),(91610,5087),(91611,5088),(91612,5088),(91613,5088),(91614,5088),(91615,5089),(91616,5089),(91617,5089),(91618,5089),(91619,5090),(91620,5090),(91621,5090),(91622,5090),(91623,5090),(91624,5090),(91625,5091),(91626,5091),(91627,5091),(91628,5091),(91629,5091),(91630,5091),(91631,5092),(91632,5092),(91633,5092),(91634,5092),(91635,5092),(91636,5092),(91637,5093),(91638,5093),(91639,5093),(91640,5093),(91641,5093),(91642,5093),(91643,5094),(91644,5094),(91645,5094),(91646,5094),(91647,5094),(91648,5094),(91649,5095),(91650,5095),(91651,5095),(91652,5095),(91653,5095),(91654,5095),(91655,5096),(91656,5096),(91657,5096),(91658,5096),(91659,5096),(91660,5096),(91661,5097),(91662,5097),(91663,5097),(91664,5097),(91665,5097),(91666,5097),(91667,5098),(91668,5098),(91669,5098),(91670,5098),(91671,5098),(91672,5098),(91673,5099),(91674,5099),(91675,5099),(91676,5099),(91677,5099),(91678,5099),(91679,5100),(91680,5100),(91681,5100),(91682,5100),(91683,5100),(91684,5100),(91685,5101),(91686,5101),(91687,5101),(91688,5101),(91689,5101),(91690,5101),(91691,5102),(91692,5102),(91693,5102),(91694,5102),(91695,5102),(91696,5102),(91697,5103),(91698,5103),(91699,5103),(91700,5103),(91701,5103),(91702,5103),(91703,5104),(91704,5104),(91705,5104),(91706,5104),(91707,5104),(91708,5104),(91709,5105),(91710,5105),(91711,5105),(91712,5105),(91713,5105),(91714,5105),(91715,5106),(91716,5106),(91717,5106),(91718,5106),(91719,5107),(91720,5107),(91721,5107),(91722,5107),(91723,5108),(91724,5108),(91725,5108),(91726,5108),(91727,5109),(91728,5109),(91729,5109),(91730,5109),(91731,5110),(91732,5110),(91733,5110),(91734,5110),(91735,5110),(91736,5110),(91737,5111),(91738,5111),(91739,5111),(91740,5111),(91741,5111),(91742,5111),(91743,5112),(91744,5112),(91745,5112),(91746,5112),(91747,5112),(91748,5112),(91749,5113),(91750,5113),(91751,5113),(91752,5113),(91753,5113),(91754,5113),(91755,5114),(91756,5114),(91757,5114),(91758,5114),(91759,5114),(91760,5114),(91761,5115),(91762,5115),(91763,5115),(91764,5115),(91765,5115),(91766,5115),(91767,5116),(91768,5116),(91769,5116),(91770,5116),(91771,5116),(91772,5116),(91773,5117),(91774,5117),(91775,5117),(91776,5117),(91777,5117),(91778,5117),(91779,5118),(91780,5118),(91781,5118),(91782,5118),(91783,5118),(91784,5118),(91785,5119),(91786,5119),(91787,5119),(91788,5119),(91789,5119),(91790,5119),(91791,5120),(91792,5120),(91793,5120),(91794,5120),(91795,5120),(91796,5120),(91797,5121),(91798,5121),(91799,5121),(91800,5121),(91801,5121),(91802,5121),(91803,5122),(91804,5122),(91805,5122),(91806,5122),(91807,5122),(91808,5122),(91809,5123),(91810,5123),(91811,5123),(91812,5123),(91813,5123),(91814,5123),(91815,5124),(91816,5124),(91817,5124),(91818,5124),(91819,5124),(91820,5124),(91821,5125),(91822,5125),(91823,5125),(91824,5125),(91825,5125),(91826,5125),(91827,5126),(91828,5126),(91829,5126),(91830,5126),(91831,5126),(91832,5126),(91833,5127),(91834,5127),(91835,5127),(91836,5127),(91837,5127),(91838,5127),(91839,5128),(91840,5128),(91841,5128),(91842,5128),(91843,5128),(91844,5128),(91845,5129),(91846,5129),(91847,5129),(91848,5129),(91849,5129),(91850,5129),(91851,5130),(91852,5130),(91853,5130),(91854,5130),(91855,5130),(91856,5130),(91857,5131),(91858,5131),(91859,5131),(91860,5131),(91861,5131),(91862,5131),(91863,5132),(91864,5132),(91865,5132),(91866,5132),(91867,5133),(91868,5133),(91869,5133),(91870,5133),(91871,5134),(91872,5134),(91873,5134),(91874,5134),(91875,5135),(91876,5135),(91877,5135),(91878,5135),(91879,5136),(91880,5136),(91881,5136),(91882,5136),(91883,5136),(91884,5136),(91885,5137),(91886,5137),(91887,5137),(91888,5137),(91889,5137),(91890,5137),(91891,5138),(91892,5138),(91893,5138),(91894,5138),(91895,5138),(91896,5138),(91897,5139),(91898,5139),(91899,5139),(91900,5139),(91901,5139),(91902,5139),(91903,5140),(91904,5140),(91905,5140),(91906,5140),(91907,5141),(91908,5141),(91909,5141),(91910,5141),(91911,5142),(91912,5142),(91913,5142),(91914,5142),(91915,5142),(91916,5142),(91917,5143),(91918,5143),(91919,5143),(91920,5143),(91921,5144),(91922,5144),(91923,5144),(91924,5144),(91925,5145),(91926,5145),(91927,5145),(91928,5145),(91929,5146),(91930,5146),(91931,5146),(91932,5146),(91933,5147),(91934,5147),(91935,5147),(91936,5147),(91937,5147),(91938,5147),(91939,5148),(91940,5148),(91941,5148),(91942,5148),(91943,5148),(91944,5148),(91945,5149),(91946,5149),(91947,5149),(91948,5149),(91949,5149),(91950,5149),(91951,5150),(91952,5150),(91953,5150),(91954,5150),(91955,5150),(91956,5150),(91957,5151),(91958,5151),(91959,5151),(91960,5151),(91961,5151),(91962,5151),(91963,5152),(91964,5152),(91965,5152),(91966,5152),(91967,5152),(91968,5152),(91969,5153),(91970,5153),(91971,5153),(91972,5153),(91973,5153),(91974,5153),(91975,5154),(91976,5154),(91977,5154),(91978,5154),(91979,5154),(91980,5154),(91981,5155),(91982,5155),(91983,5155),(91984,5155),(91985,5155),(91986,5155),(91987,5156),(91988,5156),(91989,5156),(91990,5156),(91991,5156),(91992,5156),(91993,5157),(91994,5157),(91995,5157),(91996,5157),(91997,5157),(91998,5157),(91999,5158),(92000,5158),(92001,5158),(92002,5158),(92003,5158),(92004,5158),(92005,5159),(92006,5159),(92007,5159),(92008,5159),(92009,5159),(92010,5159),(92011,5160),(92012,5160),(92013,5160),(92014,5160),(92015,5160),(92016,5160),(92017,5161),(92018,5161),(92019,5161),(92020,5161),(92021,5161),(92022,5161),(92023,5162),(92024,5162),(92025,5162),(92026,5162),(92027,5163),(92028,5163),(92029,5163),(92030,5163),(92031,5163),(92032,5163),(92033,5164),(92034,5164),(92035,5164),(92036,5164),(92037,5164),(92038,5164),(92039,5165),(92040,5165),(92041,5165),(92042,5165),(92043,5166),(92044,5166),(92045,5166),(92046,5166),(92047,5166),(92048,5166),(92049,5167),(92050,5167),(92051,5167),(92052,5167),(92053,5167),(92054,5167),(92055,5168),(92056,5168),(92057,5168),(92058,5168),(92059,5168),(92060,5168),(92061,5169),(92062,5169),(92063,5169),(92064,5169),(92065,5170),(92066,5170),(92067,5170),(92068,5170),(92069,5171),(92070,5171),(92071,5171),(92072,5171),(92073,5171),(92074,5171),(92075,5172),(92076,5172),(92077,5172),(92078,5172),(92079,5172),(92080,5172),(92081,5173),(92082,5173),(92083,5173),(92084,5173),(92085,5173),(92086,5173),(92087,5174),(92088,5174),(92089,5174),(92090,5174),(92091,5174),(92092,5174),(92093,5175),(92094,5175),(92095,5175),(92096,5175),(92097,5175),(92098,5175),(92099,5176),(92100,5176),(92101,5176),(92102,5176),(92103,5176),(92104,5176),(92105,5177),(92106,5177),(92107,5177),(92108,5177),(92109,5177),(92110,5177),(92111,5178),(92112,5178),(92113,5178),(92114,5178),(92115,5178),(92116,5178),(92117,5179),(92118,5179),(92119,5179),(92120,5179),(92121,5179),(92122,5179),(92123,5080),(92124,5080),(92125,5081),(92126,5081),(92127,5082),(92128,5082),(92129,5083),(92130,5083),(92131,5084),(92132,5084),(92133,5085),(92134,5085),(92135,5086),(92136,5086),(92137,5087),(92138,5087),(92139,5088),(92140,5088),(92141,5089),(92142,5089),(92143,5090),(92144,5090),(92145,5091),(92146,5091),(92147,5091),(92148,5092),(92149,5092),(92150,5092),(92151,5093),(92152,5093),(92153,5094),(92154,5094),(92155,5095),(92156,5095),(92157,5096),(92158,5096),(92159,5097),(92160,5097),(92161,5097),(92162,5098),(92163,5098),(92164,5098),(92165,5099),(92166,5099),(92167,5099),(92168,5100),(92169,5100),(92170,5100),(92171,5101),(92172,5101),(92173,5101),(92174,5102),(92175,5102),(92176,5102),(92177,5103),(92178,5103),(92179,5103),(92180,5104),(92181,5104),(92182,5104),(92183,5105),(92184,5105),(92185,5105),(92186,5106),(92187,5106),(92188,5107),(92189,5107),(92190,5108),(92191,5108),(92192,5109),(92193,5109),(92194,5110),(92195,5110),(92196,5110),(92197,5111),(92198,5111),(92199,5111),(92200,5112),(92201,5112),(92202,5112),(92203,5113),(92204,5113),(92205,5113),(92206,5114),(92207,5114),(92208,5114),(92209,5115),(92210,5115),(92211,5115),(92212,5116),(92213,5116),(92214,5116),(92215,5117),(92216,5117),(92217,5117),(92218,5118),(92219,5118),(92220,5119),(92221,5119),(92222,5119),(92223,5120),(92224,5120),(92225,5120),(92226,5121),(92227,5121),(92228,5122),(92229,5122),(92230,5122),(92231,5123),(92232,5123),(92233,5123),(92234,5124),(92235,5124),(92236,5124),(92237,5125),(92238,5125),(92239,5125),(92240,5126),(92241,5126),(92242,5126),(92243,5127),(92244,5127),(92245,5127),(92246,5128),(92247,5128),(92248,5128),(92249,5129),(92250,5129),(92251,5129),(92252,5130),(92253,5130),(92254,5130),(92255,5131),(92256,5131),(92257,5131),(92258,5132),(92259,5132),(92260,5133),(92261,5133),(92262,5134),(92263,5134),(92264,5135),(92265,5135),(92266,5136),(92267,5136),(92268,5136),(92269,5137),(92270,5137),(92271,5137),(92272,5138),(92273,5138),(92274,5138),(92275,5139),(92276,5139),(92277,5139),(92278,5140),(92279,5140),(92280,5141),(92281,5141),(92282,5142),(92283,5142),(92284,5142),(92285,5143),(92286,5143),(92287,5144),(92288,5144),(92289,5145),(92290,5145),(92291,5146),(92292,5146),(92293,5147),(92294,5147),(92295,5147),(92296,5148),(92297,5148),(92298,5148),(92299,5149),(92300,5149),(92301,5149),(92302,5150),(92303,5150),(92304,5150),(92305,5151),(92306,5151),(92307,5152),(92308,5152),(92309,5153),(92310,5153),(92311,5154),(92312,5154),(92313,5155),(92314,5155),(92315,5156),(92316,5156),(92317,5157),(92318,5157),(92319,5158),(92320,5158),(92321,5159),(92322,5159),(92323,5159),(92324,5160),(92325,5160),(92326,5160),(92327,5161),(92328,5161),(92329,5161),(92330,5162),(92331,5162),(92332,5163),(92333,5163),(92334,5163),(92335,5164),(92336,5164),(92337,5164),(92338,5165),(92339,5165),(92340,5166),(92341,5166),(92342,5166),(92343,5167),(92344,5167),(92345,5167),(92346,5168),(92347,5168),(92348,5168),(92349,5169),(92350,5169),(92351,5170),(92352,5170),(92353,5171),(92354,5171),(92355,5171),(92356,5172),(92357,5172),(92358,5172),(92359,5173),(92360,5173),(92361,5173),(92362,5174),(92363,5174),(92364,5174),(92365,5175),(92366,5175),(92367,5175),(92368,5176),(92369,5176),(92370,5176),(92371,5177),(92372,5177),(92373,5177),(92374,5178),(92375,5178),(92376,5178),(92377,5179),(92378,5179),(92379,5179),(92380,5080),(92381,5080),(92382,5080),(92383,5081),(92384,5081),(92385,5081),(92386,5082),(92387,5082),(92388,5082),(92389,5083),(92390,5083),(92391,5083),(92392,5084),(92393,5084),(92394,5084),(92395,5085),(92396,5085),(92397,5085),(92398,5086),(92399,5086),(92400,5086),(92401,5087),(92402,5087),(92403,5087),(92404,5088),(92405,5088),(92406,5088),(92407,5089),(92408,5089),(92409,5089),(92410,5090),(92411,5090),(92412,5090),(92413,5091),(92414,5091),(92415,5091),(92416,5092),(92417,5092),(92418,5092),(92419,5093),(92420,5093),(92421,5093),(92422,5094),(92423,5094),(92424,5094),(92425,5095),(92426,5095),(92427,5095),(92428,5096),(92429,5096),(92430,5096),(92431,5097),(92432,5097),(92433,5097),(92434,5098),(92435,5098),(92436,5098),(92437,5099),(92438,5099),(92439,5099),(92440,5100),(92441,5100),(92442,5100),(92443,5101),(92444,5101),(92445,5101),(92446,5102),(92447,5102),(92448,5102),(92449,5103),(92450,5103),(92451,5103),(92452,5104),(92453,5104),(92454,5104),(92455,5105),(92456,5105),(92457,5105),(92458,5106),(92459,5106),(92460,5106),(92461,5107),(92462,5107),(92463,5107),(92464,5108),(92465,5108),(92466,5108),(92467,5109),(92468,5109),(92469,5109),(92470,5110),(92471,5110),(92472,5110),(92473,5111),(92474,5111),(92475,5111),(92476,5112),(92477,5112),(92478,5112),(92479,5113),(92480,5113),(92481,5113),(92482,5114),(92483,5114),(92484,5114),(92485,5115),(92486,5115),(92487,5115),(92488,5116),(92489,5116),(92490,5116),(92491,5117),(92492,5117),(92493,5117),(92494,5118),(92495,5118),(92496,5118),(92497,5119),(92498,5119),(92499,5119),(92500,5120),(92501,5120),(92502,5120),(92503,5121),(92504,5121),(92505,5121),(92506,5122),(92507,5122),(92508,5122),(92509,5123),(92510,5123),(92511,5123),(92512,5124),(92513,5124),(92514,5124),(92515,5125),(92516,5125),(92517,5125),(92518,5126),(92519,5126),(92520,5126),(92521,5127),(92522,5127),(92523,5127),(92524,5128),(92525,5128),(92526,5128),(92527,5129),(92528,5129),(92529,5129),(92530,5130),(92531,5130),(92532,5130),(92533,5131),(92534,5131),(92535,5131),(92536,5132),(92537,5132),(92538,5132),(92539,5133),(92540,5133),(92541,5133),(92542,5134),(92543,5134),(92544,5134),(92545,5135),(92546,5135),(92547,5135),(92548,5136),(92549,5136),(92550,5136),(92551,5137),(92552,5137),(92553,5137),(92554,5138),(92555,5138),(92556,5138),(92557,5139),(92558,5139),(92559,5139),(92560,5140),(92561,5140),(92562,5140),(92563,5141),(92564,5141),(92565,5141),(92566,5142),(92567,5142),(92568,5142),(92569,5143),(92570,5143),(92571,5143),(92572,5144),(92573,5144),(92574,5144),(92575,5145),(92576,5145),(92577,5145),(92578,5146),(92579,5146),(92580,5146),(92581,5147),(92582,5147),(92583,5147),(92584,5148),(92585,5148),(92586,5148),(92587,5149),(92588,5149),(92589,5149),(92590,5150),(92591,5150),(92592,5150),(92593,5151),(92594,5151),(92595,5151),(92596,5152),(92597,5152),(92598,5152),(92599,5153),(92600,5153),(92601,5153),(92602,5154),(92603,5154),(92604,5154),(92605,5155),(92606,5155),(92607,5155),(92608,5156),(92609,5156),(92610,5156),(92611,5157),(92612,5157),(92613,5157),(92614,5158),(92615,5158),(92616,5158),(92617,5159),(92618,5159),(92619,5159),(92620,5160),(92621,5160),(92622,5160),(92623,5161),(92624,5161),(92625,5161),(92626,5162),(92627,5162),(92628,5162),(92629,5163),(92630,5163),(92631,5163),(92632,5164),(92633,5164),(92634,5164),(92635,5165),(92636,5165),(92637,5165),(92638,5166),(92639,5166),(92640,5166),(92641,5167),(92642,5167),(92643,5167),(92644,5168),(92645,5168),(92646,5168),(92647,5169),(92648,5169),(92649,5169),(92650,5170),(92651,5170),(92652,5170),(92653,5171),(92654,5171),(92655,5172),(92656,5172),(92657,5172),(92658,5173),(92659,5173),(92660,5173),(92661,5174),(92662,5174),(92663,5174),(92664,5175),(92665,5175),(92666,5175),(92667,5176),(92668,5176),(92669,5176),(92670,5177),(92671,5177),(92672,5177),(92673,5178),(92674,5178),(92675,5178),(92676,5179),(92677,5179),(92678,5179),(92679,5080),(92680,5080),(92681,5080),(92682,5080),(92683,5081),(92684,5081),(92685,5081),(92686,5081),(92687,5082),(92688,5082),(92689,5082),(92690,5082),(92691,5083),(92692,5083),(92693,5083),(92694,5083),(92695,5084),(92696,5084),(92697,5084),(92698,5084),(92699,5085),(92700,5085),(92701,5085),(92702,5085),(92703,5086),(92704,5086),(92705,5086),(92706,5086),(92707,5087),(92708,5087),(92709,5087),(92710,5087),(92711,5088),(92712,5088),(92713,5088),(92714,5088),(92715,5089),(92716,5089),(92717,5089),(92718,5089),(92719,5090),(92720,5090),(92721,5090),(92722,5090),(92723,5091),(92724,5091),(92725,5091),(92726,5091),(92727,5092),(92728,5092),(92729,5092),(92730,5092),(92731,5093),(92732,5093),(92733,5093),(92734,5093),(92735,5094),(92736,5094),(92737,5094),(92738,5094),(92739,5095),(92740,5095),(92741,5095),(92742,5095),(92743,5096),(92744,5096),(92745,5096),(92746,5096),(92747,5097),(92748,5097),(92749,5097),(92750,5097),(92751,5098),(92752,5098),(92753,5098),(92754,5098),(92755,5099),(92756,5099),(92757,5099),(92758,5099),(92759,5100),(92760,5100),(92761,5100),(92762,5100),(92763,5101),(92764,5101),(92765,5101),(92766,5101),(92767,5102),(92768,5102),(92769,5102),(92770,5102),(92771,5103),(92772,5103),(92773,5103),(92774,5103),(92775,5104),(92776,5104),(92777,5104),(92778,5104),(92779,5105),(92780,5105),(92781,5105),(92782,5105),(92783,5106),(92784,5106),(92785,5106),(92786,5106),(92787,5107),(92788,5107),(92789,5107),(92790,5107),(92791,5108),(92792,5108),(92793,5108),(92794,5108),(92795,5109),(92796,5109),(92797,5109),(92798,5109),(92799,5110),(92800,5110),(92801,5110),(92802,5110),(92803,5111),(92804,5111),(92805,5111),(92806,5111),(92807,5112),(92808,5112),(92809,5112),(92810,5112),(92811,5113),(92812,5113),(92813,5113),(92814,5113),(92815,5114),(92816,5114),(92817,5114),(92818,5114),(92819,5115),(92820,5115),(92821,5115),(92822,5115),(92823,5116),(92824,5116),(92825,5116),(92826,5116),(92827,5117),(92828,5117),(92829,5117),(92830,5117),(92831,5118),(92832,5118),(92833,5118),(92834,5118),(92835,5119),(92836,5119),(92837,5119),(92838,5119),(92839,5120),(92840,5120),(92841,5120),(92842,5120),(92843,5121),(92844,5121),(92845,5121),(92846,5121),(92847,5122),(92848,5122),(92849,5122),(92850,5122),(92851,5123),(92852,5123),(92853,5123),(92854,5123),(92855,5124),(92856,5124),(92857,5124),(92858,5124),(92859,5125),(92860,5125),(92861,5125),(92862,5125),(92863,5126),(92864,5126),(92865,5126),(92866,5126),(92867,5127),(92868,5127),(92869,5127),(92870,5127),(92871,5128),(92872,5128),(92873,5128),(92874,5128),(92875,5129),(92876,5129),(92877,5129),(92878,5129),(92879,5130),(92880,5130),(92881,5130),(92882,5130),(92883,5131),(92884,5131),(92885,5131),(92886,5131),(92887,5132),(92888,5132),(92889,5132),(92890,5132),(92891,5133),(92892,5133),(92893,5133),(92894,5133),(92895,5134),(92896,5134),(92897,5134),(92898,5134),(92899,5135),(92900,5135),(92901,5135),(92902,5135),(92903,5136),(92904,5136),(92905,5136),(92906,5136),(92907,5137),(92908,5137),(92909,5137),(92910,5137),(92911,5138),(92912,5138),(92913,5138),(92914,5138),(92915,5139),(92916,5139),(92917,5139),(92918,5139),(92919,5140),(92920,5140),(92921,5140),(92922,5140),(92923,5141),(92924,5141),(92925,5141),(92926,5141),(92927,5142),(92928,5142),(92929,5142),(92930,5142),(92931,5143),(92932,5143),(92933,5143),(92934,5143),(92935,5144),(92936,5144),(92937,5144),(92938,5144),(92939,5145),(92940,5145),(92941,5145),(92942,5145),(92943,5146),(92944,5146),(92945,5146),(92946,5146),(92947,5147),(92948,5147),(92949,5147),(92950,5147),(92951,5148),(92952,5148),(92953,5148),(92954,5148),(92955,5149),(92956,5149),(92957,5149),(92958,5149),(92959,5150),(92960,5150),(92961,5150),(92962,5150),(92963,5151),(92964,5151),(92965,5151),(92966,5151),(92967,5152),(92968,5152),(92969,5152),(92970,5152),(92971,5153),(92972,5153),(92973,5153),(92974,5153),(92975,5154),(92976,5154),(92977,5154),(92978,5154),(92979,5155),(92980,5155),(92981,5155),(92982,5155),(92983,5156),(92984,5156),(92985,5156),(92986,5156),(92987,5157),(92988,5157),(92989,5157),(92990,5157),(92991,5158),(92992,5158),(92993,5158),(92994,5158),(92995,5159),(92996,5159),(92997,5159),(92998,5159),(92999,5160),(93000,5160),(93001,5160),(93002,5160),(93003,5161),(93004,5161),(93005,5161),(93006,5161),(93007,5162),(93008,5162),(93009,5162),(93010,5162),(93011,5163),(93012,5163),(93013,5163),(93014,5163),(93015,5164),(93016,5164),(93017,5164),(93018,5164),(93019,5165),(93020,5165),(93021,5165),(93022,5165),(93023,5166),(93024,5166),(93025,5166),(93026,5166),(93027,5167),(93028,5167),(93029,5167),(93030,5167),(93031,5168),(93032,5168),(93033,5168),(93034,5168),(93035,5169),(93036,5169),(93037,5169),(93038,5169),(93039,5170),(93040,5170),(93041,5170),(93042,5170),(93043,5171),(93044,5171),(93045,5171),(93046,5171),(93047,5172),(93048,5172),(93049,5172),(93050,5172),(93051,5173),(93052,5173),(93053,5173),(93054,5173),(93055,5174),(93056,5174),(93057,5174),(93058,5174),(93059,5175),(93060,5175),(93061,5175),(93062,5175),(93063,5176),(93064,5176),(93065,5176),(93066,5176),(93067,5177),(93068,5177),(93069,5177),(93070,5177),(93071,5178),(93072,5178),(93073,5178),(93074,5178),(93075,5179),(93076,5179),(93077,5179),(93078,5179),(93079,5180),(93080,5181),(93081,5182),(93082,5183),(93083,5184),(93084,5185),(93085,5186),(93086,5187),(93087,5188),(93088,5189),(93089,5190),(93090,5191),(93091,5192),(93092,5193),(93093,5194),(93094,5195),(93095,5196),(93096,5197),(93097,5198),(93098,5199),(93099,5200),(93100,5201),(93101,5202),(93102,5203),(93103,5204),(93104,5205),(93105,5206),(93106,5207),(93107,5208),(93108,5209),(93109,5210),(93110,5211),(93111,5212),(93112,5213),(93113,5214),(93114,5215),(93115,5216),(93116,5217),(93117,5218),(93118,5219),(93119,5220),(93120,5221),(93121,5222),(93122,5223),(93123,5224),(93124,5225),(93125,5226),(93126,5227),(93127,5228),(93128,5229),(93129,5230),(93130,5231),(93131,5232),(93132,5233),(93133,5234),(93134,5235),(93135,5236),(93136,5237),(93137,5238),(93138,5239),(93139,5240),(93140,5241),(93141,5242),(93142,5243),(93143,5244),(93144,5245),(93145,5246),(93146,5247),(93147,5248),(93148,5249),(93149,5250),(93150,5251),(93151,5252),(93152,5253),(93153,5254),(93154,5255),(93155,5256),(93156,5257),(93157,5258),(93158,5259),(93159,5260),(93160,5261),(93161,5262),(93162,5263),(93163,5264),(93164,5265),(93165,5266),(93166,5267),(93167,5268),(93168,5269),(93169,5270),(93170,5180),(93171,5181),(93172,5182),(93173,5183),(93174,5184),(93175,5185),(93176,5186),(93177,5187),(93178,5188),(93179,5189),(93180,5190),(93181,5191),(93182,5192),(93183,5193),(93184,5194),(93185,5195),(93186,5196),(93187,5197),(93188,5198),(93189,5199),(93190,5200),(93191,5201),(93192,5202),(93193,5203),(93194,5204),(93195,5205),(93196,5206),(93197,5207),(93198,5208),(93199,5209),(93200,5210),(93201,5211),(93202,5212),(93203,5213),(93204,5214),(93205,5215),(93206,5216),(93207,5217),(93208,5218),(93209,5219),(93210,5220),(93211,5221),(93212,5222),(93213,5223),(93214,5224),(93215,5225),(93216,5226),(93217,5227),(93218,5228),(93219,5229),(93220,5230),(93221,5231),(93222,5232),(93223,5233),(93224,5234),(93225,5235),(93226,5236),(93227,5237),(93228,5238),(93229,5239),(93230,5240),(93231,5241),(93232,5242),(93233,5243),(93234,5244),(93235,5245),(93236,5246),(93237,5247),(93238,5248),(93239,5249),(93240,5250),(93241,5251),(93242,5252),(93243,5253),(93244,5254),(93245,5255),(93246,5256),(93247,5257),(93248,5258),(93249,5259),(93250,5260),(93251,5261),(93252,5262),(93253,5263),(93254,5264),(93255,5265),(93256,5266),(93257,5267),(93258,5268),(93259,5269),(93260,5270),(93261,5180),(93262,5180),(93263,5180),(93264,5180),(93265,5180),(93266,5180),(93267,5181),(93268,5181),(93269,5181),(93270,5181),(93271,5182),(93272,5182),(93273,5182),(93274,5182),(93275,5182),(93276,5182),(93277,5183),(93278,5183),(93279,5183),(93280,5183),(93281,5183),(93282,5183),(93283,5184),(93284,5184),(93285,5184),(93286,5184),(93287,5185),(93288,5185),(93289,5185),(93290,5185),(93291,5186),(93292,5186),(93293,5186),(93294,5186),(93295,5186),(93296,5186),(93297,5187),(93298,5187),(93299,5187),(93300,5187),(93301,5187),(93302,5187),(93303,5188),(93304,5188),(93305,5188),(93306,5188),(93307,5188),(93308,5188),(93309,5189),(93310,5189),(93311,5189),(93312,5189),(93313,5189),(93314,5189),(93315,5190),(93316,5190),(93317,5190),(93318,5190),(93319,5190),(93320,5190),(93321,5191),(93322,5191),(93323,5191),(93324,5191),(93325,5191),(93326,5191),(93327,5192),(93328,5192),(93329,5192),(93330,5192),(93331,5192),(93332,5192),(93333,5193),(93334,5193),(93335,5193),(93336,5193),(93337,5193),(93338,5193),(93339,5194),(93340,5194),(93341,5194),(93342,5194),(93343,5194),(93344,5194),(93345,5195),(93346,5195),(93347,5195),(93348,5195),(93349,5195),(93350,5195),(93351,5196),(93352,5196),(93353,5196),(93354,5196),(93355,5196),(93356,5196),(93357,5197),(93358,5197),(93359,5197),(93360,5197),(93361,5197),(93362,5197),(93363,5198),(93364,5198),(93365,5198),(93366,5198),(93367,5198),(93368,5198),(93369,5199),(93370,5199),(93371,5199),(93372,5199),(93373,5199),(93374,5199),(93375,5200),(93376,5200),(93377,5200),(93378,5200),(93379,5201),(93380,5201),(93381,5201),(93382,5201),(93383,5202),(93384,5202),(93385,5202),(93386,5202),(93387,5202),(93388,5202),(93389,5203),(93390,5203),(93391,5203),(93392,5203),(93393,5203),(93394,5203),(93395,5204),(93396,5204),(93397,5204),(93398,5204),(93399,5204),(93400,5204),(93401,5205),(93402,5205),(93403,5205),(93404,5205),(93405,5205),(93406,5205),(93407,5206),(93408,5206),(93409,5206),(93410,5206),(93411,5206),(93412,5206),(93413,5207),(93414,5207),(93415,5207),(93416,5207),(93417,5207),(93418,5207),(93419,5208),(93420,5208),(93421,5208),(93422,5208),(93423,5208),(93424,5208),(93425,5209),(93426,5209),(93427,5209),(93428,5209),(93429,5209),(93430,5209),(93431,5210),(93432,5210),(93433,5210),(93434,5210),(93435,5210),(93436,5210),(93437,5211),(93438,5211),(93439,5211),(93440,5211),(93441,5211),(93442,5211),(93443,5212),(93444,5212),(93445,5212),(93446,5212),(93447,5212),(93448,5212),(93449,5213),(93450,5213),(93451,5213),(93452,5213),(93453,5213),(93454,5213),(93455,5214),(93456,5214),(93457,5214),(93458,5214),(93459,5214),(93460,5214),(93461,5215),(93462,5215),(93463,5215),(93464,5215),(93465,5215),(93466,5215),(93467,5216),(93468,5216),(93469,5216),(93470,5216),(93471,5216),(93472,5216),(93473,5217),(93474,5217),(93475,5217),(93476,5217),(93477,5217),(93478,5217),(93479,5218),(93480,5218),(93481,5218),(93482,5218),(93483,5218),(93484,5218),(93485,5219),(93486,5219),(93487,5219),(93488,5219),(93489,5219),(93490,5219),(93491,5220),(93492,5220),(93493,5220),(93494,5220),(93495,5220),(93496,5220),(93497,5221),(93498,5221),(93499,5221),(93500,5221),(93501,5221),(93502,5221),(93503,5222),(93504,5222),(93505,5222),(93506,5222),(93507,5222),(93508,5222),(93509,5223),(93510,5223),(93511,5223),(93512,5223),(93513,5223),(93514,5223),(93515,5224),(93516,5224),(93517,5224),(93518,5224),(93519,5224),(93520,5224),(93521,5225),(93522,5225),(93523,5225),(93524,5225),(93525,5225),(93526,5225),(93527,5226),(93528,5226),(93529,5226),(93530,5226),(93531,5226),(93532,5226),(93533,5227),(93534,5227),(93535,5227),(93536,5227),(93537,5227),(93538,5227),(93539,5228),(93540,5228),(93541,5228),(93542,5228),(93543,5228),(93544,5228),(93545,5229),(93546,5229),(93547,5229),(93548,5229),(93549,5229),(93550,5229),(93551,5230),(93552,5230),(93553,5230),(93554,5230),(93555,5230),(93556,5230),(93557,5231),(93558,5231),(93559,5231),(93560,5231),(93561,5231),(93562,5231),(93563,5232),(93564,5232),(93565,5232),(93566,5232),(93567,5232),(93568,5232),(93569,5233),(93570,5233),(93571,5233),(93572,5233),(93573,5233),(93574,5233),(93575,5234),(93576,5234),(93577,5234),(93578,5234),(93579,5234),(93580,5234),(93581,5235),(93582,5235),(93583,5235),(93584,5235),(93585,5235),(93586,5235),(93587,5236),(93588,5236),(93589,5236),(93590,5236),(93591,5236),(93592,5236),(93593,5237),(93594,5237),(93595,5237),(93596,5237),(93597,5237),(93598,5237),(93599,5238),(93600,5238),(93601,5238),(93602,5238),(93603,5239),(93604,5239),(93605,5239),(93606,5239),(93607,5240),(93608,5240),(93609,5240),(93610,5240),(93611,5241),(93612,5241),(93613,5241),(93614,5241),(93615,5242),(93616,5242),(93617,5242),(93618,5242),(93619,5243),(93620,5243),(93621,5243),(93622,5243),(93623,5244),(93624,5244),(93625,5244),(93626,5244),(93627,5245),(93628,5245),(93629,5245),(93630,5245),(93631,5246),(93632,5246),(93633,5246),(93634,5246),(93635,5247),(93636,5247),(93637,5247),(93638,5247),(93639,5248),(93640,5248),(93641,5248),(93642,5248),(93643,5248),(93644,5248),(93645,5249),(93646,5249),(93647,5249),(93648,5249),(93649,5249),(93650,5249),(93651,5250),(93652,5250),(93653,5250),(93654,5250),(93655,5250),(93656,5250),(93657,5251),(93658,5251),(93659,5251),(93660,5251),(93661,5251),(93662,5251),(93663,5252),(93664,5252),(93665,5252),(93666,5252),(93667,5252),(93668,5252),(93669,5253),(93670,5253),(93671,5253),(93672,5253),(93673,5253),(93674,5253),(93675,5254),(93676,5254),(93677,5254),(93678,5254),(93679,5254),(93680,5254),(93681,5255),(93682,5255),(93683,5255),(93684,5255),(93685,5255),(93686,5255),(93687,5256),(93688,5256),(93689,5256),(93690,5256),(93691,5256),(93692,5256),(93693,5257),(93694,5257),(93695,5257),(93696,5257),(93697,5257),(93698,5257),(93699,5258),(93700,5258),(93701,5258),(93702,5258),(93703,5258),(93704,5259),(93705,5259),(93706,5259),(93707,5259),(93708,5259),(93709,5260),(93710,5260),(93711,5260),(93712,5260),(93713,5260),(93714,5261),(93715,5261),(93716,5261),(93717,5261),(93718,5261),(93719,5262),(93720,5262),(93721,5262),(93722,5262),(93723,5262),(93724,5263),(93725,5263),(93726,5263),(93727,5263),(93728,5264),(93729,5264),(93730,5264),(93731,5264),(93732,5265),(93733,5265),(93734,5265),(93735,5265),(93736,5266),(93737,5266),(93738,5266),(93739,5266),(93740,5266),(93741,5267),(93742,5267),(93743,5267),(93744,5267),(93745,5267),(93746,5268),(93747,5268),(93748,5268),(93749,5268),(93750,5268),(93751,5269),(93752,5269),(93753,5269),(93754,5269),(93755,5270),(93756,5270),(93757,5270),(93758,5270),(93759,5180),(93760,5180),(93761,5180),(93762,5181),(93763,5181),(93764,5182),(93765,5182),(93766,5182),(93767,5183),(93768,5183),(93769,5184),(93770,5184),(93771,5185),(93772,5185),(93773,5186),(93774,5186),(93775,5186),(93776,5187),(93777,5187),(93778,5187),(93779,5188),(93780,5188),(93781,5188),(93782,5189),(93783,5189),(93784,5189),(93785,5190),(93786,5190),(93787,5190),(93788,5191),(93789,5191),(93790,5191),(93791,5192),(93792,5192),(93793,5192),(93794,5193),(93795,5193),(93796,5194),(93797,5194),(93798,5194),(93799,5195),(93800,5195),(93801,5195),(93802,5196),(93803,5196),(93804,5196),(93805,5197),(93806,5197),(93807,5197),(93808,5198),(93809,5198),(93810,5198),(93811,5199),(93812,5199),(93813,5200),(93814,5200),(93815,5201),(93816,5201),(93817,5202),(93818,5202),(93819,5202),(93820,5203),(93821,5203),(93822,5203),(93823,5204),(93824,5204),(93825,5204),(93826,5205),(93827,5205),(93828,5205),(93829,5206),(93830,5206),(93831,5206),(93832,5207),(93833,5207),(93834,5207),(93835,5208),(93836,5208),(93837,5208),(93838,5209),(93839,5209),(93840,5209),(93841,5210),(93842,5210),(93843,5210),(93844,5211),(93845,5211),(93846,5211),(93847,5212),(93848,5212),(93849,5212),(93850,5213),(93851,5213),(93852,5213),(93853,5214),(93854,5214),(93855,5214),(93856,5215),(93857,5215),(93858,5215),(93859,5216),(93860,5216),(93861,5216),(93862,5217),(93863,5217),(93864,5217),(93865,5218),(93866,5218),(93867,5218),(93868,5219),(93869,5219),(93870,5219),(93871,5220),(93872,5220),(93873,5220),(93874,5221),(93875,5221),(93876,5221),(93877,5222),(93878,5222),(93879,5222),(93880,5223),(93881,5223),(93882,5223),(93883,5224),(93884,5224),(93885,5224),(93886,5225),(93887,5225),(93888,5225),(93889,5226),(93890,5226),(93891,5226),(93892,5227),(93893,5227),(93894,5227),(93895,5228),(93896,5228),(93897,5228),(93898,5229),(93899,5229),(93900,5229),(93901,5230),(93902,5230),(93903,5230),(93904,5231),(93905,5231),(93906,5231),(93907,5232),(93908,5232),(93909,5232),(93910,5233),(93911,5233),(93912,5233),(93913,5234),(93914,5234),(93915,5234),(93916,5235),(93917,5235),(93918,5235),(93919,5236),(93920,5236),(93921,5236),(93922,5237),(93923,5237),(93924,5237),(93925,5238),(93926,5238),(93927,5239),(93928,5239),(93929,5240),(93930,5240),(93931,5241),(93932,5241),(93933,5242),(93934,5242),(93935,5243),(93936,5243),(93937,5244),(93938,5244),(93939,5245),(93940,5245),(93941,5246),(93942,5246),(93943,5247),(93944,5247),(93945,5248),(93946,5248),(93947,5249),(93948,5249),(93949,5250),(93950,5250),(93951,5251),(93952,5251),(93953,5252),(93954,5252),(93955,5253),(93956,5253),(93957,5254),(93958,5254),(93959,5255),(93960,5255),(93961,5256),(93962,5256),(93963,5257),(93964,5257),(93965,5258),(93966,5258),(93967,5259),(93968,5260),(93969,5261),(93970,5262),(93971,5263),(93972,5264),(93973,5265),(93974,5266),(93975,5267),(93976,5268),(93977,5269),(93978,5270),(93979,5180),(93980,5180),(93981,5180),(93982,5181),(93983,5181),(93984,5181),(93985,5182),(93986,5182),(93987,5182),(93988,5183),(93989,5183),(93990,5183),(93991,5184),(93992,5184),(93993,5184),(93994,5185),(93995,5185),(93996,5185),(93997,5186),(93998,5186),(93999,5186),(94000,5187),(94001,5187),(94002,5187),(94003,5188),(94004,5188),(94005,5188),(94006,5189),(94007,5189),(94008,5189),(94009,5190),(94010,5190),(94011,5190),(94012,5191),(94013,5191),(94014,5191),(94015,5192),(94016,5192),(94017,5192),(94018,5193),(94019,5193),(94020,5193),(94021,5194),(94022,5194),(94023,5194),(94024,5195),(94025,5195),(94026,5195),(94027,5196),(94028,5196),(94029,5196),(94030,5197),(94031,5197),(94032,5197),(94033,5198),(94034,5198),(94035,5198),(94036,5199),(94037,5199),(94038,5200),(94039,5200),(94040,5200),(94041,5201),(94042,5201),(94043,5201),(94044,5202),(94045,5202),(94046,5202),(94047,5203),(94048,5203),(94049,5203),(94050,5204),(94051,5204),(94052,5204),(94053,5205),(94054,5205),(94055,5205),(94056,5206),(94057,5206),(94058,5206),(94059,5207),(94060,5207),(94061,5207),(94062,5208),(94063,5208),(94064,5208),(94065,5209),(94066,5209),(94067,5209),(94068,5210),(94069,5210),(94070,5210),(94071,5211),(94072,5211),(94073,5211),(94074,5212),(94075,5212),(94076,5212),(94077,5213),(94078,5213),(94079,5213),(94080,5214),(94081,5214),(94082,5214),(94083,5215),(94084,5215),(94085,5215),(94086,5216),(94087,5216),(94088,5216),(94089,5217),(94090,5217),(94091,5217),(94092,5218),(94093,5218),(94094,5218),(94095,5219),(94096,5219),(94097,5219),(94098,5220),(94099,5220),(94100,5220),(94101,5221),(94102,5221),(94103,5221),(94104,5222),(94105,5222),(94106,5222),(94107,5223),(94108,5223),(94109,5223),(94110,5224),(94111,5224),(94112,5224),(94113,5225),(94114,5225),(94115,5225),(94116,5226),(94117,5226),(94118,5226),(94119,5227),(94120,5227),(94121,5227),(94122,5228),(94123,5228),(94124,5228),(94125,5229),(94126,5229),(94127,5229),(94128,5230),(94129,5230),(94130,5230),(94131,5231),(94132,5231),(94133,5231),(94134,5232),(94135,5232),(94136,5232),(94137,5233),(94138,5233),(94139,5233),(94140,5234),(94141,5234),(94142,5234),(94143,5235),(94144,5235),(94145,5235),(94146,5236),(94147,5236),(94148,5236),(94149,5237),(94150,5237),(94151,5237),(94152,5238),(94153,5238),(94154,5238),(94155,5239),(94156,5239),(94157,5239),(94158,5240),(94159,5240),(94160,5240),(94161,5241),(94162,5241),(94163,5241),(94164,5242),(94165,5242),(94166,5242),(94167,5243),(94168,5243),(94169,5243),(94170,5244),(94171,5244),(94172,5244),(94173,5245),(94174,5245),(94175,5245),(94176,5246),(94177,5246),(94178,5246),(94179,5247),(94180,5247),(94181,5247),(94182,5248),(94183,5248),(94184,5248),(94185,5249),(94186,5249),(94187,5249),(94188,5250),(94189,5250),(94190,5250),(94191,5251),(94192,5251),(94193,5251),(94194,5252),(94195,5252),(94196,5252),(94197,5253),(94198,5253),(94199,5253),(94200,5254),(94201,5254),(94202,5254),(94203,5255),(94204,5255),(94205,5255),(94206,5256),(94207,5256),(94208,5256),(94209,5257),(94210,5257),(94211,5257),(94212,5258),(94213,5258),(94214,5258),(94215,5259),(94216,5259),(94217,5259),(94218,5260),(94219,5260),(94220,5260),(94221,5261),(94222,5261),(94223,5261),(94224,5262),(94225,5262),(94226,5262),(94227,5263),(94228,5263),(94229,5263),(94230,5264),(94231,5264),(94232,5264),(94233,5265),(94234,5265),(94235,5265),(94236,5266),(94237,5266),(94238,5266),(94239,5267),(94240,5267),(94241,5267),(94242,5268),(94243,5268),(94244,5268),(94245,5269),(94246,5269),(94247,5269),(94248,5270),(94249,5270),(94250,5270),(94251,5180),(94252,5180),(94253,5180),(94254,5180),(94255,5181),(94256,5181),(94257,5181),(94258,5181),(94259,5182),(94260,5182),(94261,5182),(94262,5182),(94263,5183),(94264,5183),(94265,5183),(94266,5183),(94267,5184),(94268,5184),(94269,5184),(94270,5184),(94271,5185),(94272,5185),(94273,5185),(94274,5185),(94275,5186),(94276,5186),(94277,5186),(94278,5186),(94279,5187),(94280,5187),(94281,5187),(94282,5187),(94283,5188),(94284,5188),(94285,5188),(94286,5188),(94287,5189),(94288,5189),(94289,5189),(94290,5189),(94291,5190),(94292,5190),(94293,5190),(94294,5190),(94295,5191),(94296,5191),(94297,5191),(94298,5191),(94299,5192),(94300,5192),(94301,5192),(94302,5192),(94303,5193),(94304,5193),(94305,5193),(94306,5193),(94307,5194),(94308,5194),(94309,5194),(94310,5194),(94311,5195),(94312,5195),(94313,5195),(94314,5195),(94315,5196),(94316,5196),(94317,5196),(94318,5196),(94319,5197),(94320,5197),(94321,5197),(94322,5197),(94323,5198),(94324,5198),(94325,5198),(94326,5198),(94327,5199),(94328,5199),(94329,5199),(94330,5199),(94331,5200),(94332,5200),(94333,5200),(94334,5200),(94335,5201),(94336,5201),(94337,5201),(94338,5201),(94339,5202),(94340,5202),(94341,5202),(94342,5202),(94343,5203),(94344,5203),(94345,5203),(94346,5203),(94347,5204),(94348,5204),(94349,5204),(94350,5204),(94351,5205),(94352,5205),(94353,5205),(94354,5205),(94355,5206),(94356,5206),(94357,5206),(94358,5206),(94359,5207),(94360,5207),(94361,5207),(94362,5207),(94363,5208),(94364,5208),(94365,5208),(94366,5208),(94367,5209),(94368,5209),(94369,5209),(94370,5209),(94371,5210),(94372,5210),(94373,5210),(94374,5210),(94375,5211),(94376,5211),(94377,5211),(94378,5211),(94379,5212),(94380,5212),(94381,5212),(94382,5212),(94383,5213),(94384,5213),(94385,5213),(94386,5213),(94387,5214),(94388,5214),(94389,5214),(94390,5214),(94391,5215),(94392,5215),(94393,5215),(94394,5215),(94395,5216),(94396,5216),(94397,5216),(94398,5216),(94399,5217),(94400,5217),(94401,5217),(94402,5217),(94403,5218),(94404,5218),(94405,5218),(94406,5218),(94407,5219),(94408,5219),(94409,5219),(94410,5219),(94411,5220),(94412,5220),(94413,5220),(94414,5220),(94415,5221),(94416,5221),(94417,5221),(94418,5221),(94419,5222),(94420,5222),(94421,5222),(94422,5222),(94423,5223),(94424,5223),(94425,5223),(94426,5223),(94427,5224),(94428,5224),(94429,5224),(94430,5224),(94431,5225),(94432,5225),(94433,5225),(94434,5225),(94435,5226),(94436,5226),(94437,5226),(94438,5226),(94439,5227),(94440,5227),(94441,5227),(94442,5227),(94443,5228),(94444,5228),(94445,5228),(94446,5228),(94447,5229),(94448,5229),(94449,5229),(94450,5229),(94451,5230),(94452,5230),(94453,5230),(94454,5230),(94455,5231),(94456,5231),(94457,5231),(94458,5231),(94459,5232),(94460,5232),(94461,5232),(94462,5232),(94463,5233),(94464,5233),(94465,5233),(94466,5233),(94467,5234),(94468,5234),(94469,5234),(94470,5234),(94471,5235),(94472,5235),(94473,5235),(94474,5235),(94475,5236),(94476,5236),(94477,5236),(94478,5236),(94479,5237),(94480,5237),(94481,5237),(94482,5237),(94483,5238),(94484,5238),(94485,5238),(94486,5238),(94487,5239),(94488,5239),(94489,5239),(94490,5239),(94491,5240),(94492,5240),(94493,5240),(94494,5240),(94495,5241),(94496,5241),(94497,5241),(94498,5241),(94499,5242),(94500,5242),(94501,5242),(94502,5242),(94503,5243),(94504,5243),(94505,5243),(94506,5243),(94507,5244),(94508,5244),(94509,5244),(94510,5244),(94511,5245),(94512,5245),(94513,5245),(94514,5245),(94515,5246),(94516,5246),(94517,5246),(94518,5246),(94519,5247),(94520,5247),(94521,5247),(94522,5247),(94523,5248),(94524,5248),(94525,5248),(94526,5248),(94527,5249),(94528,5249),(94529,5249),(94530,5249),(94531,5250),(94532,5250),(94533,5250),(94534,5250),(94535,5251),(94536,5251),(94537,5251),(94538,5251),(94539,5252),(94540,5252),(94541,5252),(94542,5252),(94543,5253),(94544,5253),(94545,5253),(94546,5253),(94547,5254),(94548,5254),(94549,5254),(94550,5254),(94551,5255),(94552,5255),(94553,5255),(94554,5255),(94555,5256),(94556,5256),(94557,5256),(94558,5256),(94559,5257),(94560,5257),(94561,5257),(94562,5257),(94563,5258),(94564,5258),(94565,5258),(94566,5258),(94567,5259),(94568,5259),(94569,5259),(94570,5259),(94571,5260),(94572,5260),(94573,5260),(94574,5260),(94575,5261),(94576,5261),(94577,5261),(94578,5261),(94579,5262),(94580,5262),(94581,5262),(94582,5262),(94583,5263),(94584,5263),(94585,5263),(94586,5263),(94587,5264),(94588,5264),(94589,5264),(94590,5264),(94591,5265),(94592,5265),(94593,5265),(94594,5265),(94595,5266),(94596,5266),(94597,5266),(94598,5266),(94599,5267),(94600,5267),(94601,5267),(94602,5267),(94603,5268),(94604,5268),(94605,5268),(94606,5268),(94607,5269),(94608,5269),(94609,5269),(94610,5269),(94611,5270),(94612,5270),(94613,5270),(94614,5270),(94615,5271),(94616,5272),(94617,5273),(94618,5274),(94619,5275),(94620,5276),(94621,5277),(94622,5278),(94623,5279),(94624,5280),(94625,5281),(94626,5282),(94627,5283),(94628,5284),(94629,5285),(94630,5286),(94631,5287),(94632,5288),(94633,5289),(94634,5290),(94635,5291),(94636,5292),(94637,5293),(94638,5294),(94639,5295),(94640,5296),(94641,5297),(94642,5298),(94643,5299),(94644,5300),(94645,5301),(94646,5302),(94647,5303),(94648,5304),(94649,5305),(94650,5306),(94651,5307),(94652,5308),(94653,5309),(94654,5310),(94655,5311),(94656,5312),(94657,5313),(94658,5314),(94659,5315),(94660,5316),(94661,5317),(94662,5318),(94663,5319),(94664,5320),(94665,5321),(94666,5322),(94667,5323),(94668,5324),(94669,5325),(94670,5326),(94671,5327),(94672,5328),(94673,5329),(94674,5330),(94675,5331),(94676,5332),(94677,5333),(94678,5334),(94679,5335),(94680,5336),(94681,5337),(94682,5338),(94683,5339),(94684,5340),(94685,5341),(94686,5342),(94687,5343),(94688,5344),(94689,5345),(94690,5346),(94691,5347),(94692,5348),(94693,5349),(94694,5350),(94695,5351),(94696,5352),(94697,5353),(94698,5354),(94699,5355),(94700,5356),(94701,5357),(94702,5358),(94703,5359),(94704,5271),(94705,5272),(94706,5273),(94707,5274),(94708,5275),(94709,5276),(94710,5277),(94711,5278),(94712,5279),(94713,5280),(94714,5281),(94715,5282),(94716,5283),(94717,5284),(94718,5285),(94719,5286),(94720,5287),(94721,5288),(94722,5289),(94723,5290),(94724,5291),(94725,5292),(94726,5293),(94727,5294),(94728,5295),(94729,5296),(94730,5297),(94731,5298),(94732,5299),(94733,5300),(94734,5301),(94735,5302),(94736,5303),(94737,5304),(94738,5305),(94739,5306),(94740,5307),(94741,5308),(94742,5309),(94743,5310),(94744,5311),(94745,5312),(94746,5313),(94747,5314),(94748,5315),(94749,5316),(94750,5317),(94751,5318),(94752,5319),(94753,5320),(94754,5321),(94755,5322),(94756,5323),(94757,5324),(94758,5325),(94759,5326),(94760,5327),(94761,5328),(94762,5329),(94763,5330),(94764,5331),(94765,5332),(94766,5333),(94767,5334),(94768,5335),(94769,5336),(94770,5337),(94771,5338),(94772,5339),(94773,5340),(94774,5341),(94775,5342),(94776,5343),(94777,5344),(94778,5345),(94779,5346),(94780,5347),(94781,5348),(94782,5349),(94783,5350),(94784,5351),(94785,5352),(94786,5353),(94787,5354),(94788,5355),(94789,5356),(94790,5357),(94791,5358),(94792,5359),(94793,5271),(94794,5271),(94795,5271),(94796,5271),(94797,5271),(94798,5271),(94799,5272),(94800,5272),(94801,5272),(94802,5272),(94803,5272),(94804,5272),(94805,5273),(94806,5273),(94807,5273),(94808,5273),(94809,5273),(94810,5273),(94811,5274),(94812,5274),(94813,5274),(94814,5274),(94815,5274),(94816,5274),(94817,5275),(94818,5275),(94819,5275),(94820,5275),(94821,5275),(94822,5275),(94823,5276),(94824,5276),(94825,5276),(94826,5276),(94827,5276),(94828,5276),(94829,5277),(94830,5277),(94831,5277),(94832,5277),(94833,5277),(94834,5277),(94835,5278),(94836,5278),(94837,5278),(94838,5278),(94839,5278),(94840,5278),(94841,5279),(94842,5279),(94843,5279),(94844,5279),(94845,5279),(94846,5279),(94847,5280),(94848,5280),(94849,5280),(94850,5280),(94851,5280),(94852,5280),(94853,5281),(94854,5281),(94855,5281),(94856,5281),(94857,5281),(94858,5281),(94859,5282),(94860,5282),(94861,5282),(94862,5282),(94863,5282),(94864,5282),(94865,5283),(94866,5283),(94867,5283),(94868,5283),(94869,5283),(94870,5283),(94871,5284),(94872,5284),(94873,5284),(94874,5284),(94875,5284),(94876,5284),(94877,5285),(94878,5285),(94879,5285),(94880,5285),(94881,5285),(94882,5285),(94883,5286),(94884,5286),(94885,5286),(94886,5286),(94887,5286),(94888,5286),(94889,5287),(94890,5287),(94891,5287),(94892,5287),(94893,5287),(94894,5287),(94895,5288),(94896,5288),(94897,5288),(94898,5288),(94899,5288),(94900,5288),(94901,5289),(94902,5289),(94903,5289),(94904,5289),(94905,5289),(94906,5289),(94907,5290),(94908,5290),(94909,5290),(94910,5290),(94911,5290),(94912,5290),(94913,5291),(94914,5291),(94915,5291),(94916,5291),(94917,5291),(94918,5291),(94919,5292),(94920,5292),(94921,5292),(94922,5292),(94923,5292),(94924,5292),(94925,5293),(94926,5293),(94927,5293),(94928,5293),(94929,5293),(94930,5293),(94931,5294),(94932,5294),(94933,5294),(94934,5294),(94935,5294),(94936,5294),(94937,5295),(94938,5295),(94939,5295),(94940,5295),(94941,5295),(94942,5295),(94943,5296),(94944,5296),(94945,5296),(94946,5296),(94947,5296),(94948,5296),(94949,5297),(94950,5297),(94951,5297),(94952,5297),(94953,5297),(94954,5297),(94955,5298),(94956,5298),(94957,5298),(94958,5298),(94959,5298),(94960,5298),(94961,5299),(94962,5299),(94963,5299),(94964,5299),(94965,5299),(94966,5299),(94967,5300),(94968,5300),(94969,5300),(94970,5300),(94971,5300),(94972,5300),(94973,5301),(94974,5301),(94975,5301),(94976,5301),(94977,5301),(94978,5301),(94979,5302),(94980,5302),(94981,5302),(94982,5302),(94983,5302),(94984,5302),(94985,5303),(94986,5303),(94987,5303),(94988,5303),(94989,5303),(94990,5303),(94991,5304),(94992,5304),(94993,5304),(94994,5304),(94995,5304),(94996,5304),(94997,5305),(94998,5305),(94999,5305),(95000,5305),(95001,5305),(95002,5305),(95003,5306),(95004,5306),(95005,5306),(95006,5306),(95007,5306),(95008,5306),(95009,5307),(95010,5307),(95011,5307),(95012,5307),(95013,5307),(95014,5307),(95015,5308),(95016,5308),(95017,5308),(95018,5308),(95019,5308),(95020,5308),(95021,5309),(95022,5309),(95023,5309),(95024,5309),(95025,5309),(95026,5309),(95027,5310),(95028,5310),(95029,5310),(95030,5310),(95031,5310),(95032,5310),(95033,5311),(95034,5311),(95035,5311),(95036,5311),(95037,5311),(95038,5311),(95039,5312),(95040,5312),(95041,5312),(95042,5312),(95043,5312),(95044,5312),(95045,5313),(95046,5313),(95047,5313),(95048,5313),(95049,5313),(95050,5313),(95051,5314),(95052,5314),(95053,5314),(95054,5314),(95055,5314),(95056,5314),(95057,5315),(95058,5315),(95059,5315),(95060,5315),(95061,5315),(95062,5315),(95063,5316),(95064,5316),(95065,5316),(95066,5316),(95067,5316),(95068,5316),(95069,5317),(95070,5317),(95071,5317),(95072,5317),(95073,5317),(95074,5317),(95075,5318),(95076,5318),(95077,5318),(95078,5318),(95079,5318),(95080,5318),(95081,5319),(95082,5319),(95083,5319),(95084,5319),(95085,5319),(95086,5319),(95087,5320),(95088,5320),(95089,5320),(95090,5320),(95091,5320),(95092,5320),(95093,5321),(95094,5321),(95095,5321),(95096,5321),(95097,5321),(95098,5321),(95099,5322),(95100,5322),(95101,5322),(95102,5322),(95103,5322),(95104,5322),(95105,5323),(95106,5323),(95107,5323),(95108,5323),(95109,5323),(95110,5323),(95111,5324),(95112,5324),(95113,5324),(95114,5324),(95115,5324),(95116,5324),(95117,5325),(95118,5325),(95119,5325),(95120,5325),(95121,5325),(95122,5325),(95123,5326),(95124,5326),(95125,5326),(95126,5326),(95127,5326),(95128,5326),(95129,5327),(95130,5327),(95131,5327),(95132,5327),(95133,5327),(95134,5327),(95135,5328),(95136,5328),(95137,5328),(95138,5328),(95139,5328),(95140,5328),(95141,5329),(95142,5329),(95143,5329),(95144,5329),(95145,5329),(95146,5329),(95147,5330),(95148,5330),(95149,5330),(95150,5330),(95151,5330),(95152,5330),(95153,5331),(95154,5331),(95155,5331),(95156,5331),(95157,5331),(95158,5331),(95159,5332),(95160,5332),(95161,5332),(95162,5332),(95163,5332),(95164,5332),(95165,5333),(95166,5333),(95167,5333),(95168,5333),(95169,5333),(95170,5333),(95171,5334),(95172,5334),(95173,5334),(95174,5334),(95175,5334),(95176,5335),(95177,5335),(95178,5335),(95179,5335),(95180,5335),(95181,5335),(95182,5336),(95183,5336),(95184,5336),(95185,5336),(95186,5336),(95187,5336),(95188,5337),(95189,5337),(95190,5337),(95191,5337),(95192,5337),(95193,5337),(95194,5338),(95195,5338),(95196,5338),(95197,5338),(95198,5338),(95199,5338),(95200,5339),(95201,5339),(95202,5339),(95203,5339),(95204,5339),(95205,5339),(95206,5340),(95207,5340),(95208,5340),(95209,5340),(95210,5340),(95211,5340),(95212,5341),(95213,5341),(95214,5341),(95215,5341),(95216,5341),(95217,5341),(95218,5342),(95219,5342),(95220,5342),(95221,5342),(95222,5342),(95223,5342),(95224,5343),(95225,5343),(95226,5343),(95227,5343),(95228,5343),(95229,5343),(95230,5344),(95231,5344),(95232,5344),(95233,5344),(95234,5344),(95235,5344),(95236,5345),(95237,5345),(95238,5345),(95239,5345),(95240,5345),(95241,5345),(95242,5346),(95243,5346),(95244,5346),(95245,5346),(95246,5346),(95247,5346),(95248,5347),(95249,5347),(95250,5347),(95251,5347),(95252,5347),(95253,5347),(95254,5348),(95255,5348),(95256,5348),(95257,5348),(95258,5348),(95259,5348),(95260,5349),(95261,5349),(95262,5349),(95263,5349),(95264,5349),(95265,5349),(95266,5350),(95267,5350),(95268,5350),(95269,5350),(95270,5350),(95271,5350),(95272,5351),(95273,5351),(95274,5351),(95275,5351),(95276,5351),(95277,5351),(95278,5352),(95279,5352),(95280,5352),(95281,5352),(95282,5352),(95283,5352),(95284,5353),(95285,5353),(95286,5353),(95287,5353),(95288,5353),(95289,5353),(95290,5354),(95291,5354),(95292,5354),(95293,5354),(95294,5354),(95295,5354),(95296,5355),(95297,5355),(95298,5355),(95299,5355),(95300,5355),(95301,5355),(95302,5356),(95303,5356),(95304,5356),(95305,5356),(95306,5356),(95307,5356),(95308,5357),(95309,5357),(95310,5357),(95311,5357),(95312,5357),(95313,5357),(95314,5358),(95315,5358),(95316,5358),(95317,5358),(95318,5358),(95319,5358),(95320,5359),(95321,5359),(95322,5359),(95323,5359),(95324,5359),(95325,5359),(95326,5271),(95327,5271),(95328,5272),(95329,5272),(95330,5273),(95331,5273),(95332,5274),(95333,5274),(95334,5275),(95335,5275),(95336,5276),(95337,5276),(95338,5277),(95339,5277),(95340,5278),(95341,5278),(95342,5279),(95343,5279),(95344,5280),(95345,5280),(95346,5281),(95347,5281),(95348,5282),(95349,5282),(95350,5283),(95351,5283),(95352,5284),(95353,5284),(95354,5285),(95355,5285),(95356,5285),(95357,5286),(95358,5286),(95359,5287),(95360,5287),(95361,5287),(95362,5288),(95363,5288),(95364,5288),(95365,5289),(95366,5289),(95367,5289),(95368,5290),(95369,5290),(95370,5290),(95371,5291),(95372,5291),(95373,5291),(95374,5292),(95375,5292),(95376,5292),(95377,5293),(95378,5293),(95379,5293),(95380,5294),(95381,5294),(95382,5294),(95383,5295),(95384,5295),(95385,5295),(95386,5296),(95387,5296),(95388,5296),(95389,5297),(95390,5297),(95391,5297),(95392,5298),(95393,5298),(95394,5298),(95395,5299),(95396,5299),(95397,5299),(95398,5300),(95399,5300),(95400,5300),(95401,5301),(95402,5301),(95403,5302),(95404,5302),(95405,5302),(95406,5303),(95407,5303),(95408,5303),(95409,5304),(95410,5304),(95411,5304),(95412,5305),(95413,5305),(95414,5305),(95415,5306),(95416,5306),(95417,5306),(95418,5307),(95419,5307),(95420,5307),(95421,5308),(95422,5308),(95423,5308),(95424,5309),(95425,5309),(95426,5310),(95427,5310),(95428,5311),(95429,5311),(95430,5312),(95431,5312),(95432,5313),(95433,5313),(95434,5314),(95435,5314),(95436,5315),(95437,5315),(95438,5316),(95439,5316),(95440,5317),(95441,5317),(95442,5318),(95443,5318),(95444,5319),(95445,5319),(95446,5320),(95447,5320),(95448,5321),(95449,5321),(95450,5321),(95451,5322),(95452,5322),(95453,5322),(95454,5323),(95455,5323),(95456,5324),(95457,5324),(95458,5325),(95459,5325),(95460,5326),(95461,5326),(95462,5327),(95463,5327),(95464,5328),(95465,5328),(95466,5329),(95467,5329),(95468,5330),(95469,5330),(95470,5331),(95471,5331),(95472,5332),(95473,5332),(95474,5333),(95475,5333),(95476,5334),(95477,5334),(95478,5335),(95479,5335),(95480,5336),(95481,5336),(95482,5337),(95483,5337),(95484,5338),(95485,5338),(95486,5339),(95487,5339),(95488,5340),(95489,5340),(95490,5341),(95491,5341),(95492,5342),(95493,5342),(95494,5343),(95495,5343),(95496,5344),(95497,5344),(95498,5345),(95499,5345),(95500,5346),(95501,5346),(95502,5347),(95503,5347),(95504,5348),(95505,5348),(95506,5349),(95507,5349),(95508,5350),(95509,5350),(95510,5351),(95511,5351),(95512,5352),(95513,5352),(95514,5353),(95515,5353),(95516,5354),(95517,5354),(95518,5355),(95519,5355),(95520,5356),(95521,5356),(95522,5357),(95523,5357),(95524,5358),(95525,5358),(95526,5359),(95527,5359),(95528,5271),(95529,5271),(95530,5271),(95531,5272),(95532,5272),(95533,5272),(95534,5273),(95535,5273),(95536,5273),(95537,5274),(95538,5274),(95539,5274),(95540,5275),(95541,5275),(95542,5275),(95543,5276),(95544,5276),(95545,5276),(95546,5277),(95547,5277),(95548,5277),(95549,5278),(95550,5278),(95551,5278),(95552,5279),(95553,5279),(95554,5279),(95555,5280),(95556,5280),(95557,5280),(95558,5281),(95559,5281),(95560,5281),(95561,5282),(95562,5282),(95563,5282),(95564,5283),(95565,5283),(95566,5283),(95567,5284),(95568,5284),(95569,5284),(95570,5285),(95571,5285),(95572,5286),(95573,5286),(95574,5286),(95575,5287),(95576,5287),(95577,5288),(95578,5288),(95579,5289),(95580,5289),(95581,5290),(95582,5290),(95583,5291),(95584,5291),(95585,5292),(95586,5292),(95587,5293),(95588,5293),(95589,5294),(95590,5294),(95591,5295),(95592,5295),(95593,5296),(95594,5296),(95595,5297),(95596,5297),(95597,5298),(95598,5298),(95599,5299),(95600,5299),(95601,5300),(95602,5300),(95603,5301),(95604,5301),(95605,5301),(95606,5302),(95607,5302),(95608,5303),(95609,5303),(95610,5304),(95611,5304),(95612,5305),(95613,5305),(95614,5306),(95615,5306),(95616,5307),(95617,5307),(95618,5308),(95619,5308),(95620,5309),(95621,5309),(95622,5309),(95623,5310),(95624,5310),(95625,5310),(95626,5311),(95627,5311),(95628,5311),(95629,5312),(95630,5312),(95631,5312),(95632,5313),(95633,5313),(95634,5313),(95635,5314),(95636,5314),(95637,5314),(95638,5315),(95639,5315),(95640,5315),(95641,5316),(95642,5316),(95643,5316),(95644,5317),(95645,5317),(95646,5317),(95647,5318),(95648,5318),(95649,5318),(95650,5319),(95651,5319),(95652,5319),(95653,5320),(95654,5320),(95655,5320),(95656,5321),(95657,5321),(95658,5322),(95659,5322),(95660,5323),(95661,5323),(95662,5323),(95663,5324),(95664,5324),(95665,5324),(95666,5325),(95667,5325),(95668,5325),(95669,5326),(95670,5326),(95671,5326),(95672,5327),(95673,5327),(95674,5327),(95675,5328),(95676,5328),(95677,5328),(95678,5329),(95679,5329),(95680,5329),(95681,5330),(95682,5330),(95683,5330),(95684,5331),(95685,5331),(95686,5331),(95687,5332),(95688,5332),(95689,5332),(95690,5333),(95691,5333),(95692,5333),(95693,5334),(95694,5334),(95695,5334),(95696,5335),(95697,5335),(95698,5335),(95699,5336),(95700,5336),(95701,5336),(95702,5337),(95703,5337),(95704,5337),(95705,5338),(95706,5338),(95707,5338),(95708,5339),(95709,5339),(95710,5339),(95711,5340),(95712,5340),(95713,5340),(95714,5341),(95715,5341),(95716,5341),(95717,5342),(95718,5342),(95719,5342),(95720,5343),(95721,5343),(95722,5343),(95723,5344),(95724,5344),(95725,5344),(95726,5345),(95727,5345),(95728,5345),(95729,5346),(95730,5346),(95731,5346),(95732,5347),(95733,5347),(95734,5347),(95735,5348),(95736,5348),(95737,5348),(95738,5349),(95739,5349),(95740,5349),(95741,5350),(95742,5350),(95743,5350),(95744,5351),(95745,5351),(95746,5351),(95747,5352),(95748,5352),(95749,5352),(95750,5353),(95751,5353),(95752,5353),(95753,5354),(95754,5354),(95755,5354),(95756,5355),(95757,5355),(95758,5355),(95759,5356),(95760,5356),(95761,5356),(95762,5357),(95763,5357),(95764,5357),(95765,5358),(95766,5358),(95767,5358),(95768,5359),(95769,5359),(95770,5359),(95771,5271),(95772,5271),(95773,5271),(95774,5271),(95775,5272),(95776,5272),(95777,5272),(95778,5272),(95779,5273),(95780,5273),(95781,5273),(95782,5273),(95783,5274),(95784,5274),(95785,5274),(95786,5274),(95787,5275),(95788,5275),(95789,5275),(95790,5275),(95791,5276),(95792,5276),(95793,5276),(95794,5276),(95795,5277),(95796,5277),(95797,5277),(95798,5277),(95799,5278),(95800,5278),(95801,5278),(95802,5278),(95803,5279),(95804,5279),(95805,5279),(95806,5279),(95807,5280),(95808,5280),(95809,5280),(95810,5280),(95811,5281),(95812,5281),(95813,5281),(95814,5281),(95815,5282),(95816,5282),(95817,5282),(95818,5282),(95819,5283),(95820,5283),(95821,5283),(95822,5283),(95823,5284),(95824,5284),(95825,5284),(95826,5284),(95827,5285),(95828,5285),(95829,5285),(95830,5285),(95831,5286),(95832,5286),(95833,5286),(95834,5286),(95835,5287),(95836,5287),(95837,5287),(95838,5287),(95839,5288),(95840,5288),(95841,5288),(95842,5288),(95843,5289),(95844,5289),(95845,5289),(95846,5289),(95847,5290),(95848,5290),(95849,5290),(95850,5290),(95851,5291),(95852,5291),(95853,5291),(95854,5291),(95855,5292),(95856,5292),(95857,5292),(95858,5292),(95859,5293),(95860,5293),(95861,5293),(95862,5293),(95863,5294),(95864,5294),(95865,5294),(95866,5294),(95867,5295),(95868,5295),(95869,5295),(95870,5295),(95871,5296),(95872,5296),(95873,5296),(95874,5296),(95875,5297),(95876,5297),(95877,5297),(95878,5297),(95879,5298),(95880,5298),(95881,5298),(95882,5298),(95883,5299),(95884,5299),(95885,5299),(95886,5299),(95887,5300),(95888,5300),(95889,5300),(95890,5300),(95891,5301),(95892,5301),(95893,5301),(95894,5301),(95895,5302),(95896,5302),(95897,5302),(95898,5302),(95899,5303),(95900,5303),(95901,5303),(95902,5303),(95903,5304),(95904,5304),(95905,5304),(95906,5304),(95907,5305),(95908,5305),(95909,5305),(95910,5305),(95911,5306),(95912,5306),(95913,5306),(95914,5306),(95915,5307),(95916,5307),(95917,5307),(95918,5307),(95919,5308),(95920,5308),(95921,5308),(95922,5308),(95923,5309),(95924,5309),(95925,5309),(95926,5309),(95927,5310),(95928,5310),(95929,5310),(95930,5310),(95931,5311),(95932,5311),(95933,5311),(95934,5311),(95935,5312),(95936,5312),(95937,5312),(95938,5312),(95939,5313),(95940,5313),(95941,5313),(95942,5313),(95943,5314),(95944,5314),(95945,5314),(95946,5314),(95947,5315),(95948,5315),(95949,5315),(95950,5315),(95951,5316),(95952,5316),(95953,5316),(95954,5316),(95955,5317),(95956,5317),(95957,5317),(95958,5317),(95959,5318),(95960,5318),(95961,5318),(95962,5318),(95963,5319),(95964,5319),(95965,5319),(95966,5319),(95967,5320),(95968,5320),(95969,5320),(95970,5320),(95971,5321),(95972,5321),(95973,5321),(95974,5321),(95975,5322),(95976,5322),(95977,5322),(95978,5322),(95979,5323),(95980,5323),(95981,5323),(95982,5323),(95983,5324),(95984,5324),(95985,5324),(95986,5324),(95987,5325),(95988,5325),(95989,5325),(95990,5325),(95991,5326),(95992,5326),(95993,5326),(95994,5326),(95995,5327),(95996,5327),(95997,5327),(95998,5327),(95999,5328),(96000,5328),(96001,5328),(96002,5328),(96003,5329),(96004,5329),(96005,5329),(96006,5329),(96007,5330),(96008,5330),(96009,5330),(96010,5330),(96011,5331),(96012,5331),(96013,5331),(96014,5331),(96015,5332),(96016,5332),(96017,5332),(96018,5332),(96019,5333),(96020,5333),(96021,5333),(96022,5333),(96023,5334),(96024,5334),(96025,5334),(96026,5334),(96027,5335),(96028,5335),(96029,5335),(96030,5335),(96031,5336),(96032,5336),(96033,5336),(96034,5336),(96035,5337),(96036,5337),(96037,5337),(96038,5337),(96039,5338),(96040,5338),(96041,5338),(96042,5338),(96043,5339),(96044,5339),(96045,5339),(96046,5339),(96047,5340),(96048,5340),(96049,5340),(96050,5340),(96051,5341),(96052,5341),(96053,5341),(96054,5341),(96055,5342),(96056,5342),(96057,5342),(96058,5342),(96059,5343),(96060,5343),(96061,5343),(96062,5343),(96063,5344),(96064,5344),(96065,5344),(96066,5344),(96067,5345),(96068,5345),(96069,5345),(96070,5345),(96071,5346),(96072,5346),(96073,5346),(96074,5346),(96075,5347),(96076,5347),(96077,5347),(96078,5347),(96079,5348),(96080,5348),(96081,5348),(96082,5348),(96083,5349),(96084,5349),(96085,5349),(96086,5349),(96087,5350),(96088,5350),(96089,5350),(96090,5350),(96091,5351),(96092,5351),(96093,5351),(96094,5351),(96095,5352),(96096,5352),(96097,5352),(96098,5352),(96099,5353),(96100,5353),(96101,5353),(96102,5353),(96103,5354),(96104,5354),(96105,5354),(96106,5354),(96107,5355),(96108,5355),(96109,5355),(96110,5355),(96111,5356),(96112,5356),(96113,5356),(96114,5356),(96115,5357),(96116,5357),(96117,5357),(96118,5357),(96119,5358),(96120,5358),(96121,5358),(96122,5358),(96123,5359),(96124,5359),(96125,5359),(96126,5359),(96127,5360),(96128,5361),(96129,5362),(96130,5363),(96131,5364),(96132,5365),(96133,5366),(96134,5367),(96135,5368),(96136,5369),(96137,5370),(96138,5371),(96139,5372),(96140,5373),(96141,5374),(96142,5375),(96143,5376),(96144,5377),(96145,5378),(96146,5379),(96147,5380),(96148,5381),(96149,5382),(96150,5383),(96151,5384),(96152,5385),(96153,5386),(96154,5387),(96155,5388),(96156,5389),(96157,5390),(96158,5391),(96159,5392),(96160,5393),(96161,5394),(96162,5395),(96163,5396),(96164,5397),(96165,5398),(96166,5399),(96167,5400),(96168,5401),(96169,5402),(96170,5403),(96171,5404),(96172,5405),(96173,5406),(96174,5407),(96175,5408),(96176,5409),(96177,5410),(96178,5411),(96179,5412),(96180,5413),(96181,5414),(96182,5415),(96183,5416),(96184,5417),(96185,5418),(96186,5419),(96187,5420),(96188,5421),(96189,5422),(96190,5423),(96191,5424),(96192,5425),(96193,5426),(96194,5427),(96195,5428),(96196,5429),(96197,5430),(96198,5431),(96199,5432),(96200,5433),(96201,5434),(96202,5435),(96203,5436),(96204,5437),(96205,5438),(96206,5439),(96207,5440),(96208,5441),(96209,5442),(96210,5443),(96211,5444),(96212,5445),(96213,5446),(96214,5447),(96215,5448),(96216,5449),(96217,5450),(96218,5451),(96219,5452),(96220,5453),(96221,5454),(96222,5455),(96223,5456),(96224,5457),(96225,5458),(96226,5459),(96227,5360),(96228,5361),(96229,5362),(96230,5363),(96231,5364),(96232,5365),(96233,5366),(96234,5367),(96235,5368),(96236,5369),(96237,5370),(96238,5371),(96239,5372),(96240,5373),(96241,5374),(96242,5375),(96243,5376),(96244,5377),(96245,5378),(96246,5379),(96247,5380),(96248,5381),(96249,5382),(96250,5383),(96251,5384),(96252,5385),(96253,5386),(96254,5387),(96255,5388),(96256,5389),(96257,5390),(96258,5391),(96259,5392),(96260,5393),(96261,5394),(96262,5395),(96263,5396),(96264,5397),(96265,5398),(96266,5399),(96267,5400),(96268,5401),(96269,5402),(96270,5403),(96271,5404),(96272,5405),(96273,5406),(96274,5407),(96275,5408),(96276,5409),(96277,5410),(96278,5411),(96279,5412),(96280,5413),(96281,5414),(96282,5415),(96283,5416),(96284,5417),(96285,5418),(96286,5419),(96287,5420),(96288,5421),(96289,5422),(96290,5423),(96291,5424),(96292,5425),(96293,5426),(96294,5427),(96295,5428),(96296,5429),(96297,5430),(96298,5431),(96299,5432),(96300,5433),(96301,5434),(96302,5435),(96303,5436),(96304,5437),(96305,5438),(96306,5439),(96307,5440),(96308,5441),(96309,5442),(96310,5443),(96311,5444),(96312,5445),(96313,5446),(96314,5447),(96315,5448),(96316,5449),(96317,5450),(96318,5451),(96319,5452),(96320,5453),(96321,5454),(96322,5455),(96323,5456),(96324,5457),(96325,5458),(96326,5459),(96327,5360),(96328,5360),(96329,5360),(96330,5360),(96331,5360),(96332,5360),(96333,5361),(96334,5361),(96335,5361),(96336,5361),(96337,5361),(96338,5361),(96339,5362),(96340,5362),(96341,5362),(96342,5362),(96343,5362),(96344,5362),(96345,5363),(96346,5363),(96347,5363),(96348,5363),(96349,5363),(96350,5363),(96351,5364),(96352,5364),(96353,5364),(96354,5364),(96355,5364),(96356,5364),(96357,5365),(96358,5365),(96359,5365),(96360,5365),(96361,5365),(96362,5365),(96363,5366),(96364,5366),(96365,5366),(96366,5366),(96367,5366),(96368,5366),(96369,5367),(96370,5367),(96371,5367),(96372,5367),(96373,5367),(96374,5367),(96375,5368),(96376,5368),(96377,5368),(96378,5368),(96379,5368),(96380,5368),(96381,5369),(96382,5369),(96383,5369),(96384,5369),(96385,5369),(96386,5369),(96387,5370),(96388,5370),(96389,5370),(96390,5370),(96391,5370),(96392,5370),(96393,5371),(96394,5371),(96395,5371),(96396,5371),(96397,5371),(96398,5371),(96399,5372),(96400,5372),(96401,5372),(96402,5372),(96403,5372),(96404,5372),(96405,5373),(96406,5373),(96407,5373),(96408,5373),(96409,5373),(96410,5373),(96411,5374),(96412,5374),(96413,5374),(96414,5374),(96415,5374),(96416,5374),(96417,5375),(96418,5375),(96419,5375),(96420,5375),(96421,5375),(96422,5375),(96423,5376),(96424,5376),(96425,5376),(96426,5376),(96427,5376),(96428,5376),(96429,5377),(96430,5377),(96431,5377),(96432,5377),(96433,5377),(96434,5377),(96435,5378),(96436,5378),(96437,5378),(96438,5378),(96439,5378),(96440,5378),(96441,5379),(96442,5379),(96443,5379),(96444,5379),(96445,5379),(96446,5379),(96447,5380),(96448,5380),(96449,5380),(96450,5380),(96451,5380),(96452,5380),(96453,5381),(96454,5381),(96455,5381),(96456,5381),(96457,5381),(96458,5381),(96459,5382),(96460,5382),(96461,5382),(96462,5382),(96463,5382),(96464,5382),(96465,5383),(96466,5383),(96467,5383),(96468,5383),(96469,5384),(96470,5384),(96471,5384),(96472,5384),(96473,5385),(96474,5385),(96475,5385),(96476,5385),(96477,5385),(96478,5385),(96479,5386),(96480,5386),(96481,5386),(96482,5386),(96483,5386),(96484,5386),(96485,5387),(96486,5387),(96487,5387),(96488,5387),(96489,5387),(96490,5387),(96491,5388),(96492,5388),(96493,5388),(96494,5388),(96495,5388),(96496,5388),(96497,5389),(96498,5389),(96499,5389),(96500,5389),(96501,5389),(96502,5389),(96503,5390),(96504,5390),(96505,5390),(96506,5390),(96507,5390),(96508,5390),(96509,5391),(96510,5391),(96511,5391),(96512,5391),(96513,5391),(96514,5391),(96515,5392),(96516,5392),(96517,5392),(96518,5392),(96519,5392),(96520,5392),(96521,5393),(96522,5393),(96523,5393),(96524,5393),(96525,5394),(96526,5394),(96527,5394),(96528,5394),(96529,5395),(96530,5395),(96531,5395),(96532,5395),(96533,5396),(96534,5396),(96535,5396),(96536,5396),(96537,5397),(96538,5397),(96539,5397),(96540,5397),(96541,5398),(96542,5398),(96543,5398),(96544,5398),(96545,5399),(96546,5399),(96547,5399),(96548,5399),(96549,5400),(96550,5400),(96551,5400),(96552,5400),(96553,5401),(96554,5401),(96555,5401),(96556,5401),(96557,5401),(96558,5401),(96559,5402),(96560,5402),(96561,5402),(96562,5402),(96563,5402),(96564,5402),(96565,5403),(96566,5403),(96567,5403),(96568,5403),(96569,5403),(96570,5403),(96571,5404),(96572,5404),(96573,5404),(96574,5404),(96575,5404),(96576,5404),(96577,5405),(96578,5405),(96579,5405),(96580,5405),(96581,5405),(96582,5405),(96583,5406),(96584,5406),(96585,5406),(96586,5406),(96587,5406),(96588,5406),(96589,5407),(96590,5407),(96591,5407),(96592,5407),(96593,5407),(96594,5407),(96595,5408),(96596,5408),(96597,5408),(96598,5408),(96599,5408),(96600,5408),(96601,5409),(96602,5409),(96603,5409),(96604,5409),(96605,5409),(96606,5409),(96607,5410),(96608,5410),(96609,5410),(96610,5410),(96611,5410),(96612,5410),(96613,5411),(96614,5411),(96615,5411),(96616,5411),(96617,5411),(96618,5411),(96619,5412),(96620,5412),(96621,5412),(96622,5412),(96623,5412),(96624,5412),(96625,5413),(96626,5413),(96627,5413),(96628,5413),(96629,5413),(96630,5413),(96631,5414),(96632,5414),(96633,5414),(96634,5414),(96635,5414),(96636,5414),(96637,5415),(96638,5415),(96639,5415),(96640,5415),(96641,5415),(96642,5415),(96643,5416),(96644,5416),(96645,5416),(96646,5416),(96647,5416),(96648,5416),(96649,5417),(96650,5417),(96651,5417),(96652,5417),(96653,5417),(96654,5417),(96655,5418),(96656,5418),(96657,5418),(96658,5418),(96659,5418),(96660,5418),(96661,5419),(96662,5419),(96663,5419),(96664,5419),(96665,5419),(96666,5419),(96667,5420),(96668,5420),(96669,5420),(96670,5420),(96671,5420),(96672,5420),(96673,5421),(96674,5421),(96675,5421),(96676,5421),(96677,5421),(96678,5421),(96679,5422),(96680,5422),(96681,5422),(96682,5422),(96683,5422),(96684,5422),(96685,5423),(96686,5423),(96687,5423),(96688,5423),(96689,5423),(96690,5423),(96691,5424),(96692,5424),(96693,5424),(96694,5424),(96695,5424),(96696,5424),(96697,5425),(96698,5425),(96699,5425),(96700,5425),(96701,5425),(96702,5425),(96703,5426),(96704,5426),(96705,5426),(96706,5426),(96707,5426),(96708,5426),(96709,5427),(96710,5427),(96711,5427),(96712,5427),(96713,5427),(96714,5427),(96715,5428),(96716,5428),(96717,5428),(96718,5428),(96719,5428),(96720,5428),(96721,5429),(96722,5429),(96723,5429),(96724,5429),(96725,5429),(96726,5429),(96727,5430),(96728,5430),(96729,5430),(96730,5430),(96731,5430),(96732,5431),(96733,5431),(96734,5431),(96735,5431),(96736,5431),(96737,5431),(96738,5432),(96739,5432),(96740,5432),(96741,5432),(96742,5432),(96743,5433),(96744,5433),(96745,5433),(96746,5433),(96747,5433),(96748,5433),(96749,5434),(96750,5434),(96751,5434),(96752,5434),(96753,5434),(96754,5435),(96755,5435),(96756,5435),(96757,5435),(96758,5435),(96759,5435),(96760,5436),(96761,5436),(96762,5436),(96763,5436),(96764,5436),(96765,5436),(96766,5437),(96767,5437),(96768,5437),(96769,5437),(96770,5437),(96771,5437),(96772,5438),(96773,5438),(96774,5438),(96775,5438),(96776,5438),(96777,5438),(96778,5439),(96779,5439),(96780,5439),(96781,5439),(96782,5439),(96783,5439),(96784,5440),(96785,5440),(96786,5440),(96787,5440),(96788,5440),(96789,5440),(96790,5441),(96791,5441),(96792,5441),(96793,5441),(96794,5441),(96795,5441),(96796,5442),(96797,5442),(96798,5442),(96799,5442),(96800,5442),(96801,5442),(96802,5443),(96803,5443),(96804,5443),(96805,5443),(96806,5443),(96807,5443),(96808,5444),(96809,5444),(96810,5444),(96811,5444),(96812,5444),(96813,5444),(96814,5445),(96815,5445),(96816,5445),(96817,5445),(96818,5445),(96819,5445),(96820,5446),(96821,5446),(96822,5446),(96823,5446),(96824,5446),(96825,5446),(96826,5447),(96827,5447),(96828,5447),(96829,5447),(96830,5447),(96831,5447),(96832,5448),(96833,5448),(96834,5448),(96835,5448),(96836,5448),(96837,5448),(96838,5449),(96839,5449),(96840,5449),(96841,5449),(96842,5449),(96843,5449),(96844,5450),(96845,5450),(96846,5450),(96847,5450),(96848,5450),(96849,5450),(96850,5451),(96851,5451),(96852,5451),(96853,5451),(96854,5451),(96855,5451),(96856,5452),(96857,5452),(96858,5452),(96859,5452),(96860,5452),(96861,5452),(96862,5453),(96863,5453),(96864,5453),(96865,5453),(96866,5453),(96867,5453),(96868,5454),(96869,5454),(96870,5454),(96871,5454),(96872,5454),(96873,5454),(96874,5455),(96875,5455),(96876,5455),(96877,5455),(96878,5455),(96879,5455),(96880,5456),(96881,5456),(96882,5456),(96883,5456),(96884,5456),(96885,5456),(96886,5457),(96887,5457),(96888,5457),(96889,5457),(96890,5457),(96891,5457),(96892,5458),(96893,5458),(96894,5458),(96895,5458),(96896,5458),(96897,5458),(96898,5459),(96899,5459),(96900,5459),(96901,5459),(96902,5459),(96903,5459),(96904,5360),(96905,5360),(96906,5361),(96907,5361),(96908,5362),(96909,5362),(96910,5363),(96911,5363),(96912,5364),(96913,5364),(96914,5365),(96915,5365),(96916,5366),(96917,5366),(96918,5367),(96919,5367),(96920,5368),(96921,5368),(96922,5368),(96923,5369),(96924,5369),(96925,5370),(96926,5370),(96927,5371),(96928,5371),(96929,5372),(96930,5372),(96931,5373),(96932,5373),(96933,5374),(96934,5374),(96935,5375),(96936,5375),(96937,5376),(96938,5376),(96939,5377),(96940,5377),(96941,5378),(96942,5378),(96943,5379),(96944,5379),(96945,5380),(96946,5380),(96947,5381),(96948,5381),(96949,5382),(96950,5382),(96951,5383),(96952,5384),(96953,5385),(96954,5385),(96955,5386),(96956,5386),(96957,5387),(96958,5387),(96959,5388),(96960,5388),(96961,5389),(96962,5389),(96963,5390),(96964,5390),(96965,5391),(96966,5391),(96967,5392),(96968,5392),(96969,5393),(96970,5394),(96971,5395),(96972,5396),(96973,5397),(96974,5398),(96975,5399),(96976,5400),(96977,5401),(96978,5401),(96979,5402),(96980,5402),(96981,5403),(96982,5403),(96983,5404),(96984,5404),(96985,5405),(96986,5405),(96987,5406),(96988,5406),(96989,5407),(96990,5407),(96991,5408),(96992,5408),(96993,5408),(96994,5409),(96995,5409),(96996,5410),(96997,5410),(96998,5410),(96999,5411),(97000,5411),(97001,5411),(97002,5412),(97003,5412),(97004,5412),(97005,5413),(97006,5413),(97007,5413),(97008,5414),(97009,5414),(97010,5414),(97011,5415),(97012,5415),(97013,5415),(97014,5416),(97015,5416),(97016,5416),(97017,5417),(97018,5417),(97019,5417),(97020,5418),(97021,5418),(97022,5418),(97023,5419),(97024,5419),(97025,5419),(97026,5420),(97027,5420),(97028,5421),(97029,5421),(97030,5422),(97031,5422),(97032,5423),(97033,5423),(97034,5424),(97035,5424),(97036,5425),(97037,5425),(97038,5426),(97039,5426),(97040,5427),(97041,5427),(97042,5428),(97043,5428),(97044,5428),(97045,5429),(97046,5429),(97047,5430),(97048,5430),(97049,5431),(97050,5431),(97051,5432),(97052,5432),(97053,5433),(97054,5433),(97055,5434),(97056,5434),(97057,5435),(97058,5435),(97059,5436),(97060,5436),(97061,5437),(97062,5437),(97063,5438),(97064,5438),(97065,5439),(97066,5439),(97067,5440),(97068,5440),(97069,5441),(97070,5441),(97071,5442),(97072,5442),(97073,5443),(97074,5443),(97075,5444),(97076,5444),(97077,5445),(97078,5445),(97079,5446),(97080,5446),(97081,5447),(97082,5447),(97083,5448),(97084,5448),(97085,5449),(97086,5449),(97087,5450),(97088,5450),(97089,5451),(97090,5451),(97091,5452),(97092,5452),(97093,5453),(97094,5453),(97095,5454),(97096,5454),(97097,5455),(97098,5455),(97099,5456),(97100,5456),(97101,5456),(97102,5457),(97103,5457),(97104,5458),(97105,5458),(97106,5459),(97107,5459),(97108,5459),(97109,5360),(97110,5360),(97111,5360),(97112,5361),(97113,5361),(97114,5361),(97115,5362),(97116,5362),(97117,5362),(97118,5363),(97119,5363),(97120,5363),(97121,5364),(97122,5364),(97123,5364),(97124,5365),(97125,5365),(97126,5365),(97127,5366),(97128,5366),(97129,5366),(97130,5367),(97131,5367),(97132,5367),(97133,5368),(97134,5368),(97135,5368),(97136,5369),(97137,5369),(97138,5369),(97139,5370),(97140,5370),(97141,5370),(97142,5371),(97143,5371),(97144,5371),(97145,5372),(97146,5372),(97147,5372),(97148,5373),(97149,5373),(97150,5373),(97151,5374),(97152,5374),(97153,5374),(97154,5375),(97155,5375),(97156,5375),(97157,5376),(97158,5376),(97159,5376),(97160,5377),(97161,5377),(97162,5377),(97163,5378),(97164,5378),(97165,5378),(97166,5379),(97167,5379),(97168,5379),(97169,5380),(97170,5380),(97171,5380),(97172,5381),(97173,5381),(97174,5381),(97175,5382),(97176,5382),(97177,5382),(97178,5383),(97179,5383),(97180,5383),(97181,5384),(97182,5384),(97183,5384),(97184,5385),(97185,5385),(97186,5385),(97187,5386),(97188,5386),(97189,5386),(97190,5387),(97191,5387),(97192,5387),(97193,5388),(97194,5388),(97195,5388),(97196,5389),(97197,5389),(97198,5389),(97199,5390),(97200,5390),(97201,5390),(97202,5391),(97203,5391),(97204,5391),(97205,5392),(97206,5392),(97207,5392),(97208,5393),(97209,5393),(97210,5393),(97211,5394),(97212,5394),(97213,5394),(97214,5395),(97215,5395),(97216,5395),(97217,5396),(97218,5396),(97219,5396),(97220,5397),(97221,5397),(97222,5397),(97223,5398),(97224,5398),(97225,5398),(97226,5399),(97227,5399),(97228,5399),(97229,5400),(97230,5400),(97231,5400),(97232,5401),(97233,5401),(97234,5401),(97235,5402),(97236,5402),(97237,5402),(97238,5403),(97239,5403),(97240,5403),(97241,5404),(97242,5404),(97243,5404),(97244,5405),(97245,5405),(97246,5405),(97247,5406),(97248,5406),(97249,5406),(97250,5407),(97251,5407),(97252,5407),(97253,5408),(97254,5408),(97255,5408),(97256,5409),(97257,5409),(97258,5409),(97259,5410),(97260,5410),(97261,5410),(97262,5411),(97263,5411),(97264,5411),(97265,5411),(97266,5412),(97267,5412),(97268,5412),(97269,5413),(97270,5413),(97271,5413),(97272,5414),(97273,5414),(97274,5414),(97275,5415),(97276,5415),(97277,5415),(97278,5416),(97279,5416),(97280,5416),(97281,5417),(97282,5417),(97283,5417),(97284,5418),(97285,5418),(97286,5418),(97287,5419),(97288,5419),(97289,5419),(97290,5420),(97291,5420),(97292,5420),(97293,5421),(97294,5421),(97295,5421),(97296,5422),(97297,5422),(97298,5422),(97299,5423),(97300,5423),(97301,5423),(97302,5424),(97303,5424),(97304,5424),(97305,5425),(97306,5425),(97307,5425),(97308,5426),(97309,5426),(97310,5426),(97311,5427),(97312,5427),(97313,5427),(97314,5428),(97315,5428),(97316,5428),(97317,5429),(97318,5429),(97319,5429),(97320,5430),(97321,5430),(97322,5430),(97323,5431),(97324,5431),(97325,5431),(97326,5432),(97327,5432),(97328,5432),(97329,5433),(97330,5433),(97331,5433),(97332,5434),(97333,5434),(97334,5434),(97335,5435),(97336,5435),(97337,5435),(97338,5436),(97339,5436),(97340,5436),(97341,5437),(97342,5437),(97343,5437),(97344,5438),(97345,5438),(97346,5438),(97347,5439),(97348,5439),(97349,5439),(97350,5440),(97351,5440),(97352,5440),(97353,5441),(97354,5441),(97355,5441),(97356,5442),(97357,5442),(97358,5442),(97359,5443),(97360,5443),(97361,5443),(97362,5444),(97363,5444),(97364,5444),(97365,5445),(97366,5445),(97367,5445),(97368,5446),(97369,5446),(97370,5446),(97371,5447),(97372,5447),(97373,5447),(97374,5448),(97375,5448),(97376,5448),(97377,5449),(97378,5449),(97379,5449),(97380,5450),(97381,5450),(97382,5450),(97383,5451),(97384,5451),(97385,5451),(97386,5452),(97387,5452),(97388,5452),(97389,5453),(97390,5453),(97391,5453),(97392,5454),(97393,5454),(97394,5454),(97395,5455),(97396,5455),(97397,5455),(97398,5456),(97399,5456),(97400,5456),(97401,5457),(97402,5457),(97403,5457),(97404,5458),(97405,5458),(97406,5458),(97407,5459),(97408,5459),(97409,5459),(97410,5360),(97411,5360),(97412,5360),(97413,5360),(97414,5361),(97415,5361),(97416,5361),(97417,5361),(97418,5362),(97419,5362),(97420,5362),(97421,5362),(97422,5363),(97423,5363),(97424,5363),(97425,5363),(97426,5364),(97427,5364),(97428,5364),(97429,5364),(97430,5365),(97431,5365),(97432,5365),(97433,5365),(97434,5366),(97435,5366),(97436,5366),(97437,5366),(97438,5367),(97439,5367),(97440,5367),(97441,5367),(97442,5368),(97443,5368),(97444,5368),(97445,5368),(97446,5369),(97447,5369),(97448,5369),(97449,5369),(97450,5370),(97451,5370),(97452,5370),(97453,5370),(97454,5371),(97455,5371),(97456,5371),(97457,5371),(97458,5372),(97459,5372),(97460,5372),(97461,5372),(97462,5373),(97463,5373),(97464,5373),(97465,5373),(97466,5374),(97467,5374),(97468,5374),(97469,5374),(97470,5375),(97471,5375),(97472,5375),(97473,5375),(97474,5376),(97475,5376),(97476,5376),(97477,5376),(97478,5377),(97479,5377),(97480,5377),(97481,5377),(97482,5378),(97483,5378),(97484,5378),(97485,5378),(97486,5379),(97487,5379),(97488,5379),(97489,5379),(97490,5380),(97491,5380),(97492,5380),(97493,5380),(97494,5381),(97495,5381),(97496,5381),(97497,5381),(97498,5382),(97499,5382),(97500,5382),(97501,5382),(97502,5383),(97503,5383),(97504,5383),(97505,5383),(97506,5384),(97507,5384),(97508,5384),(97509,5384),(97510,5385),(97511,5385),(97512,5385),(97513,5385),(97514,5386),(97515,5386),(97516,5386),(97517,5386),(97518,5387),(97519,5387),(97520,5387),(97521,5387),(97522,5388),(97523,5388),(97524,5388),(97525,5388),(97526,5389),(97527,5389),(97528,5389),(97529,5389),(97530,5390),(97531,5390),(97532,5390),(97533,5390),(97534,5391),(97535,5391),(97536,5391),(97537,5391),(97538,5392),(97539,5392),(97540,5392),(97541,5392),(97542,5393),(97543,5393),(97544,5393),(97545,5393),(97546,5394),(97547,5394),(97548,5394),(97549,5394),(97550,5395),(97551,5395),(97552,5395),(97553,5395),(97554,5396),(97555,5396),(97556,5396),(97557,5396),(97558,5397),(97559,5397),(97560,5397),(97561,5397),(97562,5398),(97563,5398),(97564,5398),(97565,5398),(97566,5399),(97567,5399),(97568,5399),(97569,5399),(97570,5400),(97571,5400),(97572,5400),(97573,5400),(97574,5401),(97575,5401),(97576,5401),(97577,5401),(97578,5402),(97579,5402),(97580,5402),(97581,5402),(97582,5403),(97583,5403),(97584,5403),(97585,5403),(97586,5404),(97587,5404),(97588,5404),(97589,5404),(97590,5405),(97591,5405),(97592,5405),(97593,5405),(97594,5406),(97595,5406),(97596,5406),(97597,5406),(97598,5407),(97599,5407),(97600,5407),(97601,5407),(97602,5408),(97603,5408),(97604,5408),(97605,5408),(97606,5409),(97607,5409),(97608,5409),(97609,5409),(97610,5410),(97611,5410),(97612,5410),(97613,5410),(97614,5411),(97615,5411),(97616,5411),(97617,5411),(97618,5412),(97619,5412),(97620,5412),(97621,5412),(97622,5413),(97623,5413),(97624,5413),(97625,5413),(97626,5414),(97627,5414),(97628,5414),(97629,5414),(97630,5415),(97631,5415),(97632,5415),(97633,5415),(97634,5416),(97635,5416),(97636,5416),(97637,5416),(97638,5417),(97639,5417),(97640,5417),(97641,5417),(97642,5418),(97643,5418),(97644,5418),(97645,5418),(97646,5419),(97647,5419),(97648,5419),(97649,5419),(97650,5420),(97651,5420),(97652,5420),(97653,5420),(97654,5421),(97655,5421),(97656,5421),(97657,5421),(97658,5422),(97659,5422),(97660,5422),(97661,5422),(97662,5423),(97663,5423),(97664,5423),(97665,5423),(97666,5424),(97667,5424),(97668,5424),(97669,5424),(97670,5425),(97671,5425),(97672,5425),(97673,5425),(97674,5426),(97675,5426),(97676,5426),(97677,5426),(97678,5427),(97679,5427),(97680,5427),(97681,5427),(97682,5428),(97683,5428),(97684,5428),(97685,5428),(97686,5429),(97687,5429),(97688,5429),(97689,5429),(97690,5430),(97691,5430),(97692,5430),(97693,5430),(97694,5431),(97695,5431),(97696,5431),(97697,5431),(97698,5432),(97699,5432),(97700,5432),(97701,5432),(97702,5433),(97703,5433),(97704,5433),(97705,5433),(97706,5434),(97707,5434),(97708,5434),(97709,5434),(97710,5435),(97711,5435),(97712,5435),(97713,5435),(97714,5436),(97715,5436),(97716,5436),(97717,5436),(97718,5437),(97719,5437),(97720,5437),(97721,5437),(97722,5438),(97723,5438),(97724,5438),(97725,5438),(97726,5439),(97727,5439),(97728,5439),(97729,5439),(97730,5440),(97731,5440),(97732,5440),(97733,5440),(97734,5441),(97735,5441),(97736,5441),(97737,5441),(97738,5442),(97739,5442),(97740,5442),(97741,5442),(97742,5443),(97743,5443),(97744,5443),(97745,5443),(97746,5444),(97747,5444),(97748,5444),(97749,5444),(97750,5445),(97751,5445),(97752,5445),(97753,5445),(97754,5446),(97755,5446),(97756,5446),(97757,5446),(97758,5447),(97759,5447),(97760,5447),(97761,5447),(97762,5448),(97763,5448),(97764,5448),(97765,5448),(97766,5449),(97767,5449),(97768,5449),(97769,5449),(97770,5450),(97771,5450),(97772,5450),(97773,5450),(97774,5451),(97775,5451),(97776,5451),(97777,5451),(97778,5452),(97779,5452),(97780,5452),(97781,5452),(97782,5453),(97783,5453),(97784,5453),(97785,5453),(97786,5454),(97787,5454),(97788,5454),(97789,5454),(97790,5455),(97791,5455),(97792,5455),(97793,5455),(97794,5456),(97795,5456),(97796,5456),(97797,5456),(97798,5457),(97799,5457),(97800,5457),(97801,5457),(97802,5458),(97803,5458),(97804,5458),(97805,5458),(97806,5459),(97807,5459),(97808,5459),(97809,5459),(97810,5460),(97811,5461),(97812,5462),(97813,5463),(97814,5464),(97815,5465),(97816,5466),(97817,5467),(97818,5468),(97819,5469),(97820,5470),(97821,5471),(97822,5472),(97823,5473),(97824,5474),(97825,5475),(97826,5476),(97827,5477),(97828,5478),(97829,5479),(97830,5480),(97831,5481),(97832,5482),(97833,5483),(97834,5484),(97835,5485),(97836,5486),(97837,5487),(97838,5488),(97839,5489),(97840,5490),(97841,5491),(97842,5492),(97843,5493),(97844,5494),(97845,5495),(97846,5496),(97847,5497),(97848,5498),(97849,5499),(97850,5500),(97851,5501),(97852,5502),(97853,5503),(97854,5504),(97855,5505),(97856,5506),(97857,5507),(97858,5508),(97859,5509),(97860,5510),(97861,5511),(97862,5512),(97863,5513),(97864,5514),(97865,5515),(97866,5516),(97867,5517),(97868,5518),(97869,5519),(97870,5520),(97871,5521),(97872,5522),(97873,5523),(97874,5524),(97875,5525),(97876,5526),(97877,5527),(97878,5528),(97879,5529),(97880,5530),(97881,5531),(97882,5532),(97883,5533),(97884,5534),(97885,5535),(97886,5536),(97887,5537),(97888,5538),(97889,5539),(97890,5540),(97891,5541),(97892,5542),(97893,5543),(97894,5544),(97895,5545),(97896,5546),(97897,5547),(97898,5548),(97899,5549),(97900,5550),(97901,5551),(97902,5552),(97903,5553),(97904,5554),(97905,5555),(97906,5556),(97907,5557),(97908,5558),(97909,5559),(97910,5460),(97911,5461),(97912,5462),(97913,5463),(97914,5464),(97915,5465),(97916,5466),(97917,5467),(97918,5468),(97919,5469),(97920,5470),(97921,5471),(97922,5472),(97923,5473),(97924,5474),(97925,5475),(97926,5476),(97927,5477),(97928,5478),(97929,5479),(97930,5480),(97931,5481),(97932,5482),(97933,5483),(97934,5484),(97935,5485),(97936,5486),(97937,5487),(97938,5488),(97939,5489),(97940,5490),(97941,5491),(97942,5492),(97943,5493),(97944,5494),(97945,5495),(97946,5496),(97947,5497),(97948,5498),(97949,5499),(97950,5500),(97951,5501),(97952,5502),(97953,5503),(97954,5504),(97955,5505),(97956,5506),(97957,5507),(97958,5508),(97959,5509),(97960,5510),(97961,5511),(97962,5512),(97963,5513),(97964,5514),(97965,5515),(97966,5516),(97967,5517),(97968,5518),(97969,5519),(97970,5520),(97971,5521),(97972,5522),(97973,5523),(97974,5524),(97975,5525),(97976,5526),(97977,5527),(97978,5528),(97979,5529),(97980,5530),(97981,5531),(97982,5532),(97983,5533),(97984,5534),(97985,5535),(97986,5536),(97987,5537),(97988,5538),(97989,5539),(97990,5540),(97991,5541),(97992,5542),(97993,5543),(97994,5544),(97995,5545),(97996,5546),(97997,5547),(97998,5548),(97999,5549),(98000,5550),(98001,5551),(98002,5552),(98003,5553),(98004,5554),(98005,5555),(98006,5556),(98007,5557),(98008,5558),(98009,5559),(98010,5460),(98011,5460),(98012,5460),(98013,5460),(98014,5460),(98015,5460),(98016,5461),(98017,5461),(98018,5461),(98019,5461),(98020,5461),(98021,5461),(98022,5462),(98023,5462),(98024,5462),(98025,5462),(98026,5462),(98027,5462),(98028,5463),(98029,5463),(98030,5463),(98031,5463),(98032,5463),(98033,5463),(98034,5464),(98035,5464),(98036,5464),(98037,5464),(98038,5464),(98039,5464),(98040,5465),(98041,5465),(98042,5465),(98043,5465),(98044,5465),(98045,5465),(98046,5466),(98047,5466),(98048,5466),(98049,5466),(98050,5466),(98051,5466),(98052,5467),(98053,5467),(98054,5467),(98055,5467),(98056,5467),(98057,5467),(98058,5468),(98059,5468),(98060,5468),(98061,5468),(98062,5468),(98063,5468),(98064,5469),(98065,5469),(98066,5469),(98067,5469),(98068,5469),(98069,5469),(98070,5470),(98071,5470),(98072,5470),(98073,5470),(98074,5470),(98075,5470),(98076,5471),(98077,5471),(98078,5471),(98079,5471),(98080,5471),(98081,5471),(98082,5472),(98083,5472),(98084,5472),(98085,5472),(98086,5472),(98087,5472),(98088,5473),(98089,5473),(98090,5473),(98091,5473),(98092,5473),(98093,5473),(98094,5474),(98095,5474),(98096,5474),(98097,5474),(98098,5474),(98099,5474),(98100,5475),(98101,5475),(98102,5475),(98103,5475),(98104,5475),(98105,5475),(98106,5476),(98107,5476),(98108,5476),(98109,5476),(98110,5476),(98111,5476),(98112,5477),(98113,5477),(98114,5477),(98115,5477),(98116,5477),(98117,5477),(98118,5478),(98119,5478),(98120,5478),(98121,5478),(98122,5478),(98123,5478),(98124,5479),(98125,5479),(98126,5479),(98127,5479),(98128,5479),(98129,5479),(98130,5480),(98131,5480),(98132,5480),(98133,5480),(98134,5480),(98135,5480),(98136,5481),(98137,5481),(98138,5481),(98139,5481),(98140,5481),(98141,5481),(98142,5482),(98143,5482),(98144,5482),(98145,5482),(98146,5482),(98147,5482),(98148,5483),(98149,5483),(98150,5483),(98151,5483),(98152,5483),(98153,5483),(98154,5484),(98155,5484),(98156,5484),(98157,5484),(98158,5484),(98159,5484),(98160,5485),(98161,5485),(98162,5485),(98163,5485),(98164,5485),(98165,5485),(98166,5486),(98167,5486),(98168,5486),(98169,5486),(98170,5486),(98171,5486),(98172,5487),(98173,5487),(98174,5487),(98175,5487),(98176,5487),(98177,5487),(98178,5488),(98179,5488),(98180,5488),(98181,5488),(98182,5488),(98183,5488),(98184,5489),(98185,5489),(98186,5489),(98187,5489),(98188,5489),(98189,5489),(98190,5490),(98191,5490),(98192,5490),(98193,5490),(98194,5490),(98195,5490),(98196,5491),(98197,5491),(98198,5491),(98199,5491),(98200,5491),(98201,5491),(98202,5492),(98203,5492),(98204,5492),(98205,5492),(98206,5492),(98207,5492),(98208,5493),(98209,5493),(98210,5493),(98211,5493),(98212,5493),(98213,5493),(98214,5494),(98215,5494),(98216,5494),(98217,5494),(98218,5494),(98219,5494),(98220,5495),(98221,5495),(98222,5495),(98223,5495),(98224,5495),(98225,5495),(98226,5496),(98227,5496),(98228,5496),(98229,5496),(98230,5496),(98231,5496),(98232,5497),(98233,5497),(98234,5497),(98235,5497),(98236,5497),(98237,5497),(98238,5498),(98239,5498),(98240,5498),(98241,5498),(98242,5498),(98243,5498),(98244,5499),(98245,5499),(98246,5499),(98247,5499),(98248,5499),(98249,5499),(98250,5500),(98251,5500),(98252,5500),(98253,5500),(98254,5500),(98255,5500),(98256,5501),(98257,5501),(98258,5501),(98259,5501),(98260,5501),(98261,5501),(98262,5502),(98263,5502),(98264,5502),(98265,5502),(98266,5502),(98267,5502),(98268,5503),(98269,5503),(98270,5503),(98271,5503),(98272,5503),(98273,5503),(98274,5504),(98275,5504),(98276,5504),(98277,5504),(98278,5504),(98279,5504),(98280,5505),(98281,5505),(98282,5505),(98283,5505),(98284,5505),(98285,5505),(98286,5506),(98287,5506),(98288,5506),(98289,5506),(98290,5506),(98291,5506),(98292,5507),(98293,5507),(98294,5507),(98295,5507),(98296,5507),(98297,5507),(98298,5508),(98299,5508),(98300,5508),(98301,5508),(98302,5508),(98303,5508),(98304,5509),(98305,5509),(98306,5509),(98307,5509),(98308,5509),(98309,5509),(98310,5510),(98311,5510),(98312,5510),(98313,5510),(98314,5510),(98315,5510),(98316,5511),(98317,5511),(98318,5511),(98319,5511),(98320,5511),(98321,5511),(98322,5512),(98323,5512),(98324,5512),(98325,5512),(98326,5512),(98327,5512),(98328,5513),(98329,5513),(98330,5513),(98331,5513),(98332,5513),(98333,5513),(98334,5514),(98335,5514),(98336,5514),(98337,5514),(98338,5514),(98339,5514),(98340,5515),(98341,5515),(98342,5515),(98343,5515),(98344,5515),(98345,5515),(98346,5516),(98347,5516),(98348,5516),(98349,5516),(98350,5516),(98351,5516),(98352,5517),(98353,5517),(98354,5517),(98355,5517),(98356,5517),(98357,5517),(98358,5518),(98359,5518),(98360,5518),(98361,5518),(98362,5518),(98363,5518),(98364,5519),(98365,5519),(98366,5519),(98367,5519),(98368,5519),(98369,5519),(98370,5520),(98371,5520),(98372,5520),(98373,5520),(98374,5520),(98375,5520),(98376,5521),(98377,5521),(98378,5521),(98379,5521),(98380,5521),(98381,5521),(98382,5522),(98383,5522),(98384,5522),(98385,5522),(98386,5522),(98387,5522),(98388,5523),(98389,5523),(98390,5523),(98391,5523),(98392,5523),(98393,5523),(98394,5524),(98395,5524),(98396,5524),(98397,5524),(98398,5524),(98399,5525),(98400,5525),(98401,5525),(98402,5525),(98403,5525),(98404,5525),(98405,5526),(98406,5526),(98407,5526),(98408,5526),(98409,5526),(98410,5526),(98411,5527),(98412,5527),(98413,5527),(98414,5527),(98415,5527),(98416,5527),(98417,5528),(98418,5528),(98419,5528),(98420,5528),(98421,5528),(98422,5528),(98423,5529),(98424,5529),(98425,5529),(98426,5529),(98427,5529),(98428,5529),(98429,5530),(98430,5530),(98431,5530),(98432,5530),(98433,5530),(98434,5530),(98435,5531),(98436,5531),(98437,5531),(98438,5531),(98439,5531),(98440,5531),(98441,5532),(98442,5532),(98443,5532),(98444,5532),(98445,5532),(98446,5532),(98447,5533),(98448,5533),(98449,5533),(98450,5533),(98451,5533),(98452,5533),(98453,5534),(98454,5534),(98455,5534),(98456,5534),(98457,5534),(98458,5534),(98459,5535),(98460,5535),(98461,5535),(98462,5535),(98463,5535),(98464,5535),(98465,5536),(98466,5536),(98467,5536),(98468,5536),(98469,5536),(98470,5536),(98471,5537),(98472,5537),(98473,5537),(98474,5537),(98475,5537),(98476,5537),(98477,5538),(98478,5538),(98479,5538),(98480,5538),(98481,5538),(98482,5538),(98483,5539),(98484,5539),(98485,5539),(98486,5539),(98487,5539),(98488,5539),(98489,5540),(98490,5540),(98491,5540),(98492,5540),(98493,5540),(98494,5540),(98495,5541),(98496,5541),(98497,5541),(98498,5541),(98499,5541),(98500,5541),(98501,5542),(98502,5542),(98503,5542),(98504,5542),(98505,5542),(98506,5542),(98507,5543),(98508,5543),(98509,5543),(98510,5543),(98511,5543),(98512,5543),(98513,5544),(98514,5544),(98515,5544),(98516,5544),(98517,5544),(98518,5544),(98519,5545),(98520,5545),(98521,5545),(98522,5545),(98523,5545),(98524,5545),(98525,5546),(98526,5546),(98527,5546),(98528,5546),(98529,5546),(98530,5546),(98531,5547),(98532,5547),(98533,5547),(98534,5547),(98535,5547),(98536,5547),(98537,5548),(98538,5548),(98539,5548),(98540,5548),(98541,5548),(98542,5548),(98543,5549),(98544,5549),(98545,5549),(98546,5549),(98547,5549),(98548,5549),(98549,5550),(98550,5550),(98551,5550),(98552,5550),(98553,5550),(98554,5550),(98555,5551),(98556,5551),(98557,5551),(98558,5551),(98559,5551),(98560,5551),(98561,5552),(98562,5552),(98563,5552),(98564,5552),(98565,5552),(98566,5552),(98567,5553),(98568,5553),(98569,5553),(98570,5553),(98571,5553),(98572,5553),(98573,5554),(98574,5554),(98575,5554),(98576,5554),(98577,5554),(98578,5554),(98579,5555),(98580,5555),(98581,5555),(98582,5555),(98583,5555),(98584,5555),(98585,5556),(98586,5556),(98587,5556),(98588,5556),(98589,5556),(98590,5556),(98591,5557),(98592,5557),(98593,5557),(98594,5557),(98595,5557),(98596,5557),(98597,5558),(98598,5558),(98599,5558),(98600,5558),(98601,5558),(98602,5558),(98603,5559),(98604,5559),(98605,5559),(98606,5559),(98607,5559),(98608,5559),(98609,5460),(98610,5460),(98611,5460),(98612,5461),(98613,5461),(98614,5461),(98615,5462),(98616,5462),(98617,5462),(98618,5463),(98619,5463),(98620,5464),(98621,5464),(98622,5465),(98623,5465),(98624,5466),(98625,5466),(98626,5467),(98627,5467),(98628,5468),(98629,5468),(98630,5469),(98631,5469),(98632,5469),(98633,5470),(98634,5470),(98635,5470),(98636,5471),(98637,5471),(98638,5471),(98639,5472),(98640,5472),(98641,5472),(98642,5473),(98643,5473),(98644,5473),(98645,5474),(98646,5474),(98647,5475),(98648,5475),(98649,5476),(98650,5476),(98651,5477),(98652,5477),(98653,5478),(98654,5478),(98655,5479),(98656,5479),(98657,5480),(98658,5480),(98659,5481),(98660,5481),(98661,5482),(98662,5482),(98663,5483),(98664,5483),(98665,5484),(98666,5484),(98667,5485),(98668,5485),(98669,5486),(98670,5486),(98671,5487),(98672,5487),(98673,5488),(98674,5488),(98675,5489),(98676,5489),(98677,5490),(98678,5490),(98679,5490),(98680,5491),(98681,5491),(98682,5491),(98683,5492),(98684,5492),(98685,5492),(98686,5493),(98687,5493),(98688,5493),(98689,5494),(98690,5494),(98691,5494),(98692,5495),(98693,5495),(98694,5495),(98695,5496),(98696,5496),(98697,5496),(98698,5497),(98699,5497),(98700,5497),(98701,5498),(98702,5498),(98703,5498),(98704,5499),(98705,5499),(98706,5499),(98707,5500),(98708,5500),(98709,5500),(98710,5501),(98711,5501),(98712,5501),(98713,5502),(98714,5502),(98715,5502),(98716,5503),(98717,5503),(98718,5503),(98719,5504),(98720,5504),(98721,5504),(98722,5505),(98723,5505),(98724,5505),(98725,5506),(98726,5506),(98727,5506),(98728,5507),(98729,5507),(98730,5507),(98731,5508),(98732,5508),(98733,5508),(98734,5509),(98735,5509),(98736,5509),(98737,5510),(98738,5510),(98739,5510),(98740,5511),(98741,5511),(98742,5511),(98743,5512),(98744,5512),(98745,5512),(98746,5513),(98747,5513),(98748,5513),(98749,5514),(98750,5514),(98751,5514),(98752,5515),(98753,5515),(98754,5515),(98755,5516),(98756,5516),(98757,5516),(98758,5517),(98759,5517),(98760,5517),(98761,5518),(98762,5518),(98763,5519),(98764,5519),(98765,5520),(98766,5520),(98767,5521),(98768,5521),(98769,5522),(98770,5522),(98771,5523),(98772,5523),(98773,5524),(98774,5524),(98775,5525),(98776,5525),(98777,5526),(98778,5526),(98779,5527),(98780,5527),(98781,5528),(98782,5528),(98783,5529),(98784,5529),(98785,5530),(98786,5530),(98787,5531),(98788,5531),(98789,5532),(98790,5532),(98791,5533),(98792,5533),(98793,5534),(98794,5534),(98795,5535),(98796,5535),(98797,5536),(98798,5536),(98799,5536),(98800,5537),(98801,5537),(98802,5537),(98803,5538),(98804,5538),(98805,5538),(98806,5539),(98807,5539),(98808,5539),(98809,5540),(98810,5540),(98811,5540),(98812,5541),(98813,5541),(98814,5541),(98815,5542),(98816,5542),(98817,5542),(98818,5543),(98819,5543),(98820,5543),(98821,5544),(98822,5544),(98823,5544),(98824,5545),(98825,5545),(98826,5545),(98827,5546),(98828,5546),(98829,5546),(98830,5547),(98831,5547),(98832,5547),(98833,5548),(98834,5548),(98835,5548),(98836,5549),(98837,5549),(98838,5549),(98839,5550),(98840,5550),(98841,5550),(98842,5551),(98843,5551),(98844,5552),(98845,5552),(98846,5553),(98847,5553),(98848,5554),(98849,5554),(98850,5555),(98851,5555),(98852,5556),(98853,5556),(98854,5557),(98855,5557),(98856,5558),(98857,5558),(98858,5559),(98859,5559),(98860,5460),(98861,5460),(98862,5460),(98863,5461),(98864,5461),(98865,5461),(98866,5462),(98867,5462),(98868,5462),(98869,5463),(98870,5463),(98871,5463),(98872,5464),(98873,5464),(98874,5464),(98875,5465),(98876,5465),(98877,5465),(98878,5466),(98879,5466),(98880,5466),(98881,5467),(98882,5467),(98883,5467),(98884,5468),(98885,5468),(98886,5468),(98887,5469),(98888,5469),(98889,5469),(98890,5470),(98891,5470),(98892,5470),(98893,5471),(98894,5471),(98895,5471),(98896,5471),(98897,5472),(98898,5472),(98899,5472),(98900,5472),(98901,5473),(98902,5473),(98903,5473),(98904,5474),(98905,5474),(98906,5474),(98907,5475),(98908,5475),(98909,5475),(98910,5476),(98911,5476),(98912,5476),(98913,5477),(98914,5477),(98915,5477),(98916,5478),(98917,5478),(98918,5478),(98919,5479),(98920,5479),(98921,5479),(98922,5480),(98923,5480),(98924,5480),(98925,5481),(98926,5481),(98927,5481),(98928,5482),(98929,5482),(98930,5482),(98931,5483),(98932,5483),(98933,5483),(98934,5484),(98935,5484),(98936,5484),(98937,5485),(98938,5485),(98939,5485),(98940,5486),(98941,5486),(98942,5486),(98943,5487),(98944,5487),(98945,5487),(98946,5488),(98947,5488),(98948,5488),(98949,5489),(98950,5489),(98951,5489),(98952,5490),(98953,5490),(98954,5490),(98955,5491),(98956,5491),(98957,5491),(98958,5492),(98959,5492),(98960,5492),(98961,5493),(98962,5493),(98963,5493),(98964,5494),(98965,5494),(98966,5494),(98967,5495),(98968,5495),(98969,5495),(98970,5496),(98971,5496),(98972,5496),(98973,5497),(98974,5497),(98975,5497),(98976,5498),(98977,5498),(98978,5498),(98979,5499),(98980,5499),(98981,5499),(98982,5500),(98983,5500),(98984,5500),(98985,5501),(98986,5501),(98987,5501),(98988,5502),(98989,5502),(98990,5502),(98991,5503),(98992,5503),(98993,5503),(98994,5504),(98995,5504),(98996,5504),(98997,5505),(98998,5505),(98999,5505),(99000,5506),(99001,5506),(99002,5506),(99003,5507),(99004,5507),(99005,5507),(99006,5508),(99007,5508),(99008,5508),(99009,5509),(99010,5509),(99011,5509),(99012,5510),(99013,5510),(99014,5510),(99015,5511),(99016,5511),(99017,5511),(99018,5512),(99019,5512),(99020,5512),(99021,5513),(99022,5513),(99023,5513),(99024,5514),(99025,5514),(99026,5514),(99027,5515),(99028,5515),(99029,5515),(99030,5516),(99031,5516),(99032,5516),(99033,5517),(99034,5517),(99035,5517),(99036,5518),(99037,5518),(99038,5518),(99039,5519),(99040,5519),(99041,5519),(99042,5520),(99043,5520),(99044,5520),(99045,5521),(99046,5521),(99047,5521),(99048,5522),(99049,5522),(99050,5522),(99051,5523),(99052,5523),(99053,5523),(99054,5524),(99055,5524),(99056,5524),(99057,5525),(99058,5525),(99059,5525),(99060,5526),(99061,5526),(99062,5526),(99063,5527),(99064,5527),(99065,5527),(99066,5528),(99067,5528),(99068,5528),(99069,5529),(99070,5529),(99071,5529),(99072,5530),(99073,5530),(99074,5530),(99075,5531),(99076,5531),(99077,5531),(99078,5532),(99079,5532),(99080,5532),(99081,5533),(99082,5533),(99083,5533),(99084,5534),(99085,5534),(99086,5534),(99087,5535),(99088,5535),(99089,5535),(99090,5536),(99091,5536),(99092,5537),(99093,5537),(99094,5538),(99095,5538),(99096,5538),(99097,5539),(99098,5539),(99099,5539),(99100,5540),(99101,5540),(99102,5540),(99103,5540),(99104,5541),(99105,5541),(99106,5541),(99107,5541),(99108,5542),(99109,5542),(99110,5542),(99111,5542),(99112,5543),(99113,5543),(99114,5543),(99115,5543),(99116,5544),(99117,5544),(99118,5544),(99119,5544),(99120,5545),(99121,5545),(99122,5545),(99123,5545),(99124,5546),(99125,5546),(99126,5546),(99127,5547),(99128,5547),(99129,5547),(99130,5548),(99131,5548),(99132,5548),(99133,5549),(99134,5549),(99135,5549),(99136,5550),(99137,5550),(99138,5550),(99139,5551),(99140,5551),(99141,5551),(99142,5552),(99143,5552),(99144,5552),(99145,5553),(99146,5553),(99147,5553),(99148,5554),(99149,5554),(99150,5554),(99151,5555),(99152,5555),(99153,5555),(99154,5556),(99155,5556),(99156,5556),(99157,5557),(99158,5557),(99159,5557),(99160,5558),(99161,5558),(99162,5558),(99163,5559),(99164,5559),(99165,5559),(99166,5460),(99167,5460),(99168,5460),(99169,5460),(99170,5461),(99171,5461),(99172,5461),(99173,5461),(99174,5462),(99175,5462),(99176,5462),(99177,5462),(99178,5463),(99179,5463),(99180,5463),(99181,5463),(99182,5464),(99183,5464),(99184,5464),(99185,5464),(99186,5465),(99187,5465),(99188,5465),(99189,5465),(99190,5466),(99191,5466),(99192,5466),(99193,5466),(99194,5467),(99195,5467),(99196,5467),(99197,5467),(99198,5468),(99199,5468),(99200,5468),(99201,5468),(99202,5469),(99203,5469),(99204,5469),(99205,5469),(99206,5470),(99207,5470),(99208,5470),(99209,5470),(99210,5471),(99211,5471),(99212,5471),(99213,5471),(99214,5472),(99215,5472),(99216,5472),(99217,5472),(99218,5473),(99219,5473),(99220,5473),(99221,5473),(99222,5474),(99223,5474),(99224,5474),(99225,5474),(99226,5475),(99227,5475),(99228,5475),(99229,5475),(99230,5476),(99231,5476),(99232,5476),(99233,5476),(99234,5477),(99235,5477),(99236,5477),(99237,5477),(99238,5478),(99239,5478),(99240,5478),(99241,5478),(99242,5479),(99243,5479),(99244,5479),(99245,5479),(99246,5480),(99247,5480),(99248,5480),(99249,5480),(99250,5481),(99251,5481),(99252,5481),(99253,5481),(99254,5482),(99255,5482),(99256,5482),(99257,5482),(99258,5483),(99259,5483),(99260,5483),(99261,5483),(99262,5484),(99263,5484),(99264,5484),(99265,5484),(99266,5485),(99267,5485),(99268,5485),(99269,5485),(99270,5486),(99271,5486),(99272,5486),(99273,5486),(99274,5487),(99275,5487),(99276,5487),(99277,5487),(99278,5488),(99279,5488),(99280,5488),(99281,5488),(99282,5489),(99283,5489),(99284,5489),(99285,5489),(99286,5490),(99287,5490),(99288,5490),(99289,5490),(99290,5491),(99291,5491),(99292,5491),(99293,5491),(99294,5492),(99295,5492),(99296,5492),(99297,5492),(99298,5493),(99299,5493),(99300,5493),(99301,5493),(99302,5494),(99303,5494),(99304,5494),(99305,5494),(99306,5495),(99307,5495),(99308,5495),(99309,5495),(99310,5496),(99311,5496),(99312,5496),(99313,5496),(99314,5497),(99315,5497),(99316,5497),(99317,5497),(99318,5498),(99319,5498),(99320,5498),(99321,5498),(99322,5499),(99323,5499),(99324,5499),(99325,5499),(99326,5500),(99327,5500),(99328,5500),(99329,5500),(99330,5501),(99331,5501),(99332,5501),(99333,5501),(99334,5502),(99335,5502),(99336,5502),(99337,5502),(99338,5503),(99339,5503),(99340,5503),(99341,5503),(99342,5504),(99343,5504),(99344,5504),(99345,5504),(99346,5505),(99347,5505),(99348,5505),(99349,5505),(99350,5506),(99351,5506),(99352,5506),(99353,5506),(99354,5507),(99355,5507),(99356,5507),(99357,5507),(99358,5508),(99359,5508),(99360,5508),(99361,5508),(99362,5509),(99363,5509),(99364,5509),(99365,5509),(99366,5510),(99367,5510),(99368,5510),(99369,5510),(99370,5511),(99371,5511),(99372,5511),(99373,5511),(99374,5512),(99375,5512),(99376,5512),(99377,5512),(99378,5513),(99379,5513),(99380,5513),(99381,5513),(99382,5514),(99383,5514),(99384,5514),(99385,5514),(99386,5515),(99387,5515),(99388,5515),(99389,5515),(99390,5516),(99391,5516),(99392,5516),(99393,5516),(99394,5517),(99395,5517),(99396,5517),(99397,5517),(99398,5518),(99399,5518),(99400,5518),(99401,5518),(99402,5519),(99403,5519),(99404,5519),(99405,5519),(99406,5520),(99407,5520),(99408,5520),(99409,5520),(99410,5521),(99411,5521),(99412,5521),(99413,5521),(99414,5522),(99415,5522),(99416,5522),(99417,5522),(99418,5523),(99419,5523),(99420,5523),(99421,5523),(99422,5524),(99423,5524),(99424,5524),(99425,5524),(99426,5525),(99427,5525),(99428,5525),(99429,5525),(99430,5526),(99431,5526),(99432,5526),(99433,5526),(99434,5527),(99435,5527),(99436,5527),(99437,5527),(99438,5528),(99439,5528),(99440,5528),(99441,5528),(99442,5529),(99443,5529),(99444,5529),(99445,5529),(99446,5530),(99447,5530),(99448,5530),(99449,5530),(99450,5531),(99451,5531),(99452,5531),(99453,5531),(99454,5532),(99455,5532),(99456,5532),(99457,5532),(99458,5533),(99459,5533),(99460,5533),(99461,5533),(99462,5534),(99463,5534),(99464,5534),(99465,5534),(99466,5535),(99467,5535),(99468,5535),(99469,5535),(99470,5536),(99471,5536),(99472,5536),(99473,5536),(99474,5537),(99475,5537),(99476,5537),(99477,5537),(99478,5538),(99479,5538),(99480,5538),(99481,5538),(99482,5539),(99483,5539),(99484,5539),(99485,5539),(99486,5540),(99487,5540),(99488,5540),(99489,5540),(99490,5541),(99491,5541),(99492,5541),(99493,5541),(99494,5542),(99495,5542),(99496,5542),(99497,5542),(99498,5543),(99499,5543),(99500,5543),(99501,5543),(99502,5544),(99503,5544),(99504,5544),(99505,5544),(99506,5545),(99507,5545),(99508,5545),(99509,5545),(99510,5546),(99511,5546),(99512,5546),(99513,5546),(99514,5547),(99515,5547),(99516,5547),(99517,5547),(99518,5548),(99519,5548),(99520,5548),(99521,5548),(99522,5549),(99523,5549),(99524,5549),(99525,5549),(99526,5550),(99527,5550),(99528,5550),(99529,5550),(99530,5551),(99531,5551),(99532,5551),(99533,5551),(99534,5552),(99535,5552),(99536,5552),(99537,5552),(99538,5553),(99539,5553),(99540,5553),(99541,5553),(99542,5554),(99543,5554),(99544,5554),(99545,5554),(99546,5555),(99547,5555),(99548,5555),(99549,5555),(99550,5556),(99551,5556),(99552,5556),(99553,5556),(99554,5557),(99555,5557),(99556,5557),(99557,5557),(99558,5558),(99559,5558),(99560,5558),(99561,5558),(99562,5559),(99563,5559),(99564,5559),(99565,5559),(99566,5560),(99567,5561),(99568,5562),(99569,5563),(99570,5564),(99571,5565),(99572,5566),(99573,5567),(99574,5568),(99575,5569),(99576,5570),(99577,5571),(99578,5572),(99579,5573),(99580,5574),(99581,5575),(99582,5576),(99583,5577),(99584,5578),(99585,5579),(99586,5580),(99587,5581),(99588,5582),(99589,5583),(99590,5584),(99591,5585),(99592,5586),(99593,5587),(99594,5588),(99595,5589),(99596,5590),(99597,5591),(99598,5592),(99599,5593),(99600,5594),(99601,5595),(99602,5596),(99603,5597),(99604,5598),(99605,5599),(99606,5600),(99607,5601),(99608,5602),(99609,5603),(99610,5604),(99611,5605),(99612,5606),(99613,5607),(99614,5608),(99615,5609),(99616,5610),(99617,5611),(99618,5612),(99619,5613),(99620,5614),(99621,5615),(99622,5616),(99623,5617),(99624,5618),(99625,5619),(99626,5620),(99627,5621),(99628,5622),(99629,5623),(99630,5624),(99631,5625),(99632,5626),(99633,5627),(99634,5628),(99635,5629),(99636,5630),(99637,5631),(99638,5632),(99639,5633),(99640,5634),(99641,5635),(99642,5636),(99643,5637),(99644,5638),(99645,5639),(99646,5640),(99647,5641),(99648,5642),(99649,5643),(99650,5644),(99651,5645),(99652,5646),(99653,5647),(99654,5648),(99655,5649),(99656,5650),(99657,5651),(99658,5652),(99659,5653),(99660,5654),(99661,5655),(99662,5656),(99663,5657),(99664,5658),(99665,5659),(99666,5560),(99667,5561),(99668,5562),(99669,5563),(99670,5564),(99671,5565),(99672,5566),(99673,5567),(99674,5568),(99675,5569),(99676,5570),(99677,5571),(99678,5572),(99679,5573),(99680,5574),(99681,5575),(99682,5576),(99683,5577),(99684,5578),(99685,5579),(99686,5580),(99687,5581),(99688,5582),(99689,5583),(99690,5584),(99691,5585),(99692,5586),(99693,5587),(99694,5588),(99695,5589),(99696,5590),(99697,5591),(99698,5592),(99699,5593),(99700,5594),(99701,5595),(99702,5596),(99703,5597),(99704,5598),(99705,5599),(99706,5600),(99707,5601),(99708,5602),(99709,5603),(99710,5604),(99711,5605),(99712,5606),(99713,5607),(99714,5608),(99715,5609),(99716,5610),(99717,5611),(99718,5612),(99719,5613),(99720,5614),(99721,5615),(99722,5616),(99723,5617),(99724,5618),(99725,5619),(99726,5620),(99727,5621),(99728,5622),(99729,5623),(99730,5624),(99731,5625),(99732,5626),(99733,5627),(99734,5628),(99735,5629),(99736,5630),(99737,5631),(99738,5632),(99739,5633),(99740,5634),(99741,5635),(99742,5636),(99743,5637),(99744,5638),(99745,5639),(99746,5640),(99747,5641),(99748,5642),(99749,5643),(99750,5644),(99751,5645),(99752,5646),(99753,5647),(99754,5648),(99755,5649),(99756,5650),(99757,5651),(99758,5652),(99759,5653),(99760,5654),(99761,5655),(99762,5656),(99763,5657),(99764,5658),(99765,5659),(99766,5560),(99767,5560),(99768,5560),(99769,5560),(99770,5560),(99771,5560),(99772,5561),(99773,5561),(99774,5561),(99775,5561),(99776,5561),(99777,5561),(99778,5562),(99779,5562),(99780,5562),(99781,5562),(99782,5562),(99783,5562),(99784,5563),(99785,5563),(99786,5563),(99787,5563),(99788,5563),(99789,5563),(99790,5564),(99791,5564),(99792,5564),(99793,5564),(99794,5564),(99795,5564),(99796,5565),(99797,5565),(99798,5565),(99799,5565),(99800,5565),(99801,5565),(99802,5566),(99803,5566),(99804,5566),(99805,5566),(99806,5566),(99807,5566),(99808,5567),(99809,5567),(99810,5567),(99811,5567),(99812,5567),(99813,5567),(99814,5568),(99815,5568),(99816,5568),(99817,5568),(99818,5568),(99819,5568),(99820,5569),(99821,5569),(99822,5569),(99823,5569),(99824,5569),(99825,5569),(99826,5570),(99827,5570),(99828,5570),(99829,5570),(99830,5570),(99831,5571),(99832,5571),(99833,5571),(99834,5571),(99835,5571),(99836,5571),(99837,5572),(99838,5572),(99839,5572),(99840,5572),(99841,5572),(99842,5572),(99843,5573),(99844,5573),(99845,5573),(99846,5573),(99847,5573),(99848,5573),(99849,5574),(99850,5574),(99851,5574),(99852,5574),(99853,5574),(99854,5574),(99855,5575),(99856,5575),(99857,5575),(99858,5575),(99859,5575),(99860,5575),(99861,5576),(99862,5576),(99863,5576),(99864,5576),(99865,5576),(99866,5576),(99867,5577),(99868,5577),(99869,5577),(99870,5577),(99871,5578),(99872,5578),(99873,5578),(99874,5578),(99875,5578),(99876,5578),(99877,5579),(99878,5579),(99879,5579),(99880,5579),(99881,5579),(99882,5579),(99883,5580),(99884,5580),(99885,5580),(99886,5580),(99887,5581),(99888,5581),(99889,5581),(99890,5581),(99891,5582),(99892,5582),(99893,5582),(99894,5582),(99895,5582),(99896,5582),(99897,5583),(99898,5583),(99899,5583),(99900,5583),(99901,5583),(99902,5583),(99903,5584),(99904,5584),(99905,5584),(99906,5584),(99907,5584),(99908,5584),(99909,5585),(99910,5585),(99911,5585),(99912,5585),(99913,5585),(99914,5585),(99915,5586),(99916,5586),(99917,5586),(99918,5586),(99919,5586),(99920,5587),(99921,5587),(99922,5587),(99923,5587),(99924,5587),(99925,5588),(99926,5588),(99927,5588),(99928,5588),(99929,5588),(99930,5589),(99931,5589),(99932,5589),(99933,5589),(99934,5589),(99935,5590),(99936,5590),(99937,5590),(99938,5590),(99939,5590),(99940,5590),(99941,5591),(99942,5591),(99943,5591),(99944,5591),(99945,5591),(99946,5591),(99947,5592),(99948,5592),(99949,5592),(99950,5592),(99951,5592),(99952,5592),(99953,5593),(99954,5593),(99955,5593),(99956,5593),(99957,5593),(99958,5593),(99959,5594),(99960,5594),(99961,5594),(99962,5594),(99963,5594),(99964,5594),(99965,5595),(99966,5595),(99967,5595),(99968,5595),(99969,5595),(99970,5595),(99971,5596),(99972,5596),(99973,5596),(99974,5596),(99975,5596),(99976,5596),(99977,5597),(99978,5597),(99979,5597),(99980,5597),(99981,5597),(99982,5597),(99983,5598),(99984,5598),(99985,5598),(99986,5598),(99987,5598),(99988,5598),(99989,5599),(99990,5599),(99991,5599),(99992,5599),(99993,5599),(99994,5599),(99995,5600),(99996,5600),(99997,5600),(99998,5600),(99999,5600),(100000,5600),(100001,5601),(100002,5601),(100003,5601),(100004,5601),(100005,5601),(100006,5601),(100007,5602),(100008,5602),(100009,5602),(100010,5602),(100011,5602),(100012,5602),(100013,5603),(100014,5603),(100015,5603),(100016,5603),(100017,5603),(100018,5603),(100019,5604),(100020,5604),(100021,5604),(100022,5604),(100023,5604),(100024,5604),(100025,5605),(100026,5605),(100027,5605),(100028,5605),(100029,5605),(100030,5605),(100031,5606),(100032,5606),(100033,5606),(100034,5606),(100035,5606),(100036,5606),(100037,5607),(100038,5607),(100039,5607),(100040,5607),(100041,5607),(100042,5607),(100043,5608),(100044,5608),(100045,5608),(100046,5608),(100047,5608),(100048,5608),(100049,5609),(100050,5609),(100051,5609),(100052,5609),(100053,5609),(100054,5609),(100055,5610),(100056,5610),(100057,5610),(100058,5610),(100059,5610),(100060,5610),(100061,5611),(100062,5611),(100063,5611),(100064,5611),(100065,5611),(100066,5611),(100067,5612),(100068,5612),(100069,5612),(100070,5612),(100071,5612),(100072,5612),(100073,5613),(100074,5613),(100075,5613),(100076,5613),(100077,5613),(100078,5613),(100079,5614),(100080,5614),(100081,5614),(100082,5614),(100083,5614),(100084,5614),(100085,5615),(100086,5615),(100087,5615),(100088,5615),(100089,5615),(100090,5615),(100091,5616),(100092,5616),(100093,5616),(100094,5616),(100095,5616),(100096,5616),(100097,5617),(100098,5617),(100099,5617),(100100,5617),(100101,5617),(100102,5617),(100103,5618),(100104,5618),(100105,5618),(100106,5618),(100107,5618),(100108,5618),(100109,5619),(100110,5619),(100111,5619),(100112,5619),(100113,5619),(100114,5619),(100115,5620),(100116,5620),(100117,5620),(100118,5620),(100119,5620),(100120,5620),(100121,5621),(100122,5621),(100123,5621),(100124,5621),(100125,5621),(100126,5621),(100127,5622),(100128,5622),(100129,5622),(100130,5622),(100131,5622),(100132,5622),(100133,5623),(100134,5623),(100135,5623),(100136,5623),(100137,5623),(100138,5623),(100139,5624),(100140,5624),(100141,5624),(100142,5624),(100143,5624),(100144,5624),(100145,5625),(100146,5625),(100147,5625),(100148,5625),(100149,5625),(100150,5625),(100151,5626),(100152,5626),(100153,5626),(100154,5626),(100155,5626),(100156,5626),(100157,5627),(100158,5627),(100159,5627),(100160,5627),(100161,5627),(100162,5627),(100163,5628),(100164,5628),(100165,5628),(100166,5628),(100167,5628),(100168,5628),(100169,5629),(100170,5629),(100171,5629),(100172,5629),(100173,5629),(100174,5629),(100175,5630),(100176,5630),(100177,5630),(100178,5630),(100179,5630),(100180,5630),(100181,5631),(100182,5631),(100183,5631),(100184,5631),(100185,5631),(100186,5631),(100187,5632),(100188,5632),(100189,5632),(100190,5632),(100191,5632),(100192,5632),(100193,5633),(100194,5633),(100195,5633),(100196,5633),(100197,5633),(100198,5633),(100199,5634),(100200,5634),(100201,5634),(100202,5634),(100203,5634),(100204,5634),(100205,5635),(100206,5635),(100207,5635),(100208,5635),(100209,5635),(100210,5635),(100211,5636),(100212,5636),(100213,5636),(100214,5636),(100215,5636),(100216,5636),(100217,5637),(100218,5637),(100219,5637),(100220,5637),(100221,5637),(100222,5637),(100223,5638),(100224,5638),(100225,5638),(100226,5638),(100227,5638),(100228,5638),(100229,5639),(100230,5639),(100231,5639),(100232,5639),(100233,5639),(100234,5639),(100235,5640),(100236,5640),(100237,5640),(100238,5640),(100239,5640),(100240,5640),(100241,5641),(100242,5641),(100243,5641),(100244,5641),(100245,5641),(100246,5641),(100247,5642),(100248,5642),(100249,5642),(100250,5642),(100251,5642),(100252,5642),(100253,5643),(100254,5643),(100255,5643),(100256,5643),(100257,5643),(100258,5643),(100259,5644),(100260,5644),(100261,5644),(100262,5644),(100263,5644),(100264,5644),(100265,5645),(100266,5645),(100267,5645),(100268,5645),(100269,5645),(100270,5645),(100271,5646),(100272,5646),(100273,5646),(100274,5646),(100275,5646),(100276,5646),(100277,5647),(100278,5647),(100279,5647),(100280,5647),(100281,5647),(100282,5647),(100283,5648),(100284,5648),(100285,5648),(100286,5648),(100287,5648),(100288,5648),(100289,5649),(100290,5649),(100291,5649),(100292,5649),(100293,5649),(100294,5649),(100295,5650),(100296,5650),(100297,5650),(100298,5650),(100299,5650),(100300,5650),(100301,5651),(100302,5651),(100303,5651),(100304,5651),(100305,5651),(100306,5651),(100307,5652),(100308,5652),(100309,5652),(100310,5652),(100311,5652),(100312,5652),(100313,5653),(100314,5653),(100315,5653),(100316,5653),(100317,5653),(100318,5653),(100319,5654),(100320,5654),(100321,5654),(100322,5654),(100323,5654),(100324,5654),(100325,5655),(100326,5655),(100327,5655),(100328,5655),(100329,5655),(100330,5655),(100331,5656),(100332,5656),(100333,5656),(100334,5656),(100335,5656),(100336,5656),(100337,5657),(100338,5657),(100339,5657),(100340,5657),(100341,5657),(100342,5657),(100343,5658),(100344,5658),(100345,5658),(100346,5658),(100347,5658),(100348,5658),(100349,5659),(100350,5659),(100351,5659),(100352,5659),(100353,5659),(100354,5659),(100355,5560),(100356,5560),(100357,5561),(100358,5561),(100359,5562),(100360,5562),(100361,5563),(100362,5563),(100363,5564),(100364,5564),(100365,5565),(100366,5565),(100367,5566),(100368,5566),(100369,5567),(100370,5567),(100371,5568),(100372,5568),(100373,5569),(100374,5569),(100375,5570),(100376,5570),(100377,5571),(100378,5571),(100379,5571),(100380,5572),(100381,5572),(100382,5573),(100383,5573),(100384,5574),(100385,5574),(100386,5575),(100387,5575),(100388,5576),(100389,5576),(100390,5577),(100391,5578),(100392,5578),(100393,5579),(100394,5579),(100395,5580),(100396,5581),(100397,5582),(100398,5582),(100399,5583),(100400,5583),(100401,5584),(100402,5584),(100403,5585),(100404,5585),(100405,5586),(100406,5586),(100407,5587),(100408,5587),(100409,5588),(100410,5588),(100411,5589),(100412,5589),(100413,5590),(100414,5590),(100415,5591),(100416,5591),(100417,5591),(100418,5592),(100419,5592),(100420,5592),(100421,5593),(100422,5593),(100423,5593),(100424,5594),(100425,5594),(100426,5594),(100427,5595),(100428,5595),(100429,5595),(100430,5596),(100431,5596),(100432,5596),(100433,5597),(100434,5597),(100435,5597),(100436,5598),(100437,5598),(100438,5599),(100439,5599),(100440,5599),(100441,5600),(100442,5600),(100443,5600),(100444,5601),(100445,5601),(100446,5601),(100447,5602),(100448,5602),(100449,5602),(100450,5603),(100451,5603),(100452,5603),(100453,5604),(100454,5604),(100455,5604),(100456,5605),(100457,5605),(100458,5605),(100459,5606),(100460,5606),(100461,5606),(100462,5607),(100463,5607),(100464,5607),(100465,5608),(100466,5608),(100467,5608),(100468,5609),(100469,5609),(100470,5609),(100471,5610),(100472,5610),(100473,5610),(100474,5611),(100475,5611),(100476,5611),(100477,5612),(100478,5612),(100479,5612),(100480,5613),(100481,5613),(100482,5613),(100483,5614),(100484,5614),(100485,5614),(100486,5615),(100487,5615),(100488,5615),(100489,5616),(100490,5616),(100491,5617),(100492,5617),(100493,5618),(100494,5618),(100495,5619),(100496,5619),(100497,5620),(100498,5620),(100499,5620),(100500,5621),(100501,5621),(100502,5622),(100503,5622),(100504,5623),(100505,5623),(100506,5624),(100507,5624),(100508,5625),(100509,5625),(100510,5626),(100511,5626),(100512,5627),(100513,5627),(100514,5628),(100515,5628),(100516,5629),(100517,5629),(100518,5630),(100519,5630),(100520,5631),(100521,5631),(100522,5632),(100523,5632),(100524,5633),(100525,5633),(100526,5634),(100527,5634),(100528,5635),(100529,5635),(100530,5636),(100531,5636),(100532,5637),(100533,5637),(100534,5638),(100535,5638),(100536,5639),(100537,5639),(100538,5640),(100539,5640),(100540,5641),(100541,5641),(100542,5642),(100543,5642),(100544,5643),(100545,5643),(100546,5644),(100547,5644),(100548,5645),(100549,5645),(100550,5646),(100551,5646),(100552,5647),(100553,5647),(100554,5648),(100555,5648),(100556,5649),(100557,5649),(100558,5650),(100559,5650),(100560,5651),(100561,5651),(100562,5652),(100563,5652),(100564,5653),(100565,5653),(100566,5654),(100567,5654),(100568,5655),(100569,5655),(100570,5656),(100571,5656),(100572,5657),(100573,5657),(100574,5658),(100575,5658),(100576,5659),(100577,5659),(100578,5560),(100579,5560),(100580,5560),(100581,5561),(100582,5561),(100583,5561),(100584,5562),(100585,5562),(100586,5562),(100587,5563),(100588,5563),(100589,5563),(100590,5564),(100591,5564),(100592,5564),(100593,5565),(100594,5565),(100595,5565),(100596,5566),(100597,5566),(100598,5566),(100599,5567),(100600,5567),(100601,5567),(100602,5568),(100603,5568),(100604,5568),(100605,5569),(100606,5569),(100607,5569),(100608,5570),(100609,5570),(100610,5570),(100611,5571),(100612,5571),(100613,5571),(100614,5572),(100615,5572),(100616,5572),(100617,5573),(100618,5573),(100619,5573),(100620,5574),(100621,5574),(100622,5574),(100623,5575),(100624,5575),(100625,5575),(100626,5576),(100627,5576),(100628,5576),(100629,5577),(100630,5577),(100631,5577),(100632,5578),(100633,5578),(100634,5578),(100635,5579),(100636,5579),(100637,5579),(100638,5580),(100639,5580),(100640,5580),(100641,5581),(100642,5581),(100643,5581),(100644,5582),(100645,5582),(100646,5582),(100647,5583),(100648,5583),(100649,5583),(100650,5584),(100651,5584),(100652,5584),(100653,5585),(100654,5585),(100655,5585),(100656,5586),(100657,5586),(100658,5586),(100659,5587),(100660,5587),(100661,5587),(100662,5588),(100663,5588),(100664,5588),(100665,5589),(100666,5589),(100667,5589),(100668,5590),(100669,5590),(100670,5590),(100671,5591),(100672,5591),(100673,5591),(100674,5592),(100675,5592),(100676,5592),(100677,5592),(100678,5593),(100679,5593),(100680,5593),(100681,5594),(100682,5594),(100683,5594),(100684,5595),(100685,5595),(100686,5595),(100687,5596),(100688,5596),(100689,5596),(100690,5597),(100691,5597),(100692,5597),(100693,5598),(100694,5598),(100695,5598),(100696,5599),(100697,5599),(100698,5599),(100699,5600),(100700,5600),(100701,5600),(100702,5601),(100703,5601),(100704,5601),(100705,5602),(100706,5602),(100707,5602),(100708,5602),(100709,5603),(100710,5603),(100711,5603),(100712,5603),(100713,5604),(100714,5604),(100715,5604),(100716,5605),(100717,5605),(100718,5605),(100719,5605),(100720,5606),(100721,5606),(100722,5606),(100723,5607),(100724,5607),(100725,5607),(100726,5608),(100727,5608),(100728,5608),(100729,5608),(100730,5609),(100731,5609),(100732,5609),(100733,5609),(100734,5610),(100735,5610),(100736,5610),(100737,5610),(100738,5611),(100739,5611),(100740,5611),(100741,5611),(100742,5612),(100743,5612),(100744,5612),(100745,5612),(100746,5613),(100747,5613),(100748,5613),(100749,5613),(100750,5614),(100751,5614),(100752,5614),(100753,5614),(100754,5615),(100755,5615),(100756,5615),(100757,5616),(100758,5616),(100759,5616),(100760,5617),(100761,5617),(100762,5617),(100763,5618),(100764,5618),(100765,5618),(100766,5619),(100767,5619),(100768,5619),(100769,5620),(100770,5620),(100771,5620),(100772,5620),(100773,5621),(100774,5621),(100775,5621),(100776,5622),(100777,5622),(100778,5622),(100779,5623),(100780,5623),(100781,5623),(100782,5624),(100783,5624),(100784,5624),(100785,5625),(100786,5625),(100787,5625),(100788,5626),(100789,5626),(100790,5626),(100791,5627),(100792,5627),(100793,5627),(100794,5628),(100795,5628),(100796,5628),(100797,5629),(100798,5629),(100799,5629),(100800,5630),(100801,5630),(100802,5630),(100803,5631),(100804,5631),(100805,5631),(100806,5632),(100807,5632),(100808,5632),(100809,5633),(100810,5633),(100811,5633),(100812,5634),(100813,5634),(100814,5634),(100815,5635),(100816,5635),(100817,5635),(100818,5636),(100819,5636),(100820,5636),(100821,5637),(100822,5637),(100823,5637),(100824,5638),(100825,5638),(100826,5638),(100827,5639),(100828,5639),(100829,5639),(100830,5640),(100831,5640),(100832,5640),(100833,5641),(100834,5641),(100835,5641),(100836,5642),(100837,5642),(100838,5642),(100839,5643),(100840,5643),(100841,5643),(100842,5644),(100843,5644),(100844,5644),(100845,5645),(100846,5645),(100847,5645),(100848,5646),(100849,5646),(100850,5646),(100851,5647),(100852,5647),(100853,5647),(100854,5648),(100855,5648),(100856,5648),(100857,5649),(100858,5649),(100859,5649),(100860,5650),(100861,5650),(100862,5650),(100863,5651),(100864,5651),(100865,5651),(100866,5652),(100867,5652),(100868,5652),(100869,5653),(100870,5653),(100871,5653),(100872,5654),(100873,5654),(100874,5654),(100875,5655),(100876,5655),(100877,5655),(100878,5656),(100879,5656),(100880,5656),(100881,5657),(100882,5657),(100883,5657),(100884,5658),(100885,5658),(100886,5658),(100887,5659),(100888,5659),(100889,5659),(100890,5560),(100891,5560),(100892,5560),(100893,5560),(100894,5561),(100895,5561),(100896,5561),(100897,5561),(100898,5562),(100899,5562),(100900,5562),(100901,5562),(100902,5563),(100903,5563),(100904,5563),(100905,5563),(100906,5564),(100907,5564),(100908,5564),(100909,5564),(100910,5565),(100911,5565),(100912,5565),(100913,5565),(100914,5566),(100915,5566),(100916,5566),(100917,5566),(100918,5567),(100919,5567),(100920,5567),(100921,5567),(100922,5568),(100923,5568),(100924,5568),(100925,5568),(100926,5569),(100927,5569),(100928,5569),(100929,5569),(100930,5570),(100931,5570),(100932,5570),(100933,5570),(100934,5571),(100935,5571),(100936,5571),(100937,5571),(100938,5572),(100939,5572),(100940,5572),(100941,5572),(100942,5573),(100943,5573),(100944,5573),(100945,5573),(100946,5574),(100947,5574),(100948,5574),(100949,5574),(100950,5575),(100951,5575),(100952,5575),(100953,5575),(100954,5576),(100955,5576),(100956,5576),(100957,5576),(100958,5577),(100959,5577),(100960,5577),(100961,5577),(100962,5578),(100963,5578),(100964,5578),(100965,5578),(100966,5579),(100967,5579),(100968,5579),(100969,5579),(100970,5580),(100971,5580),(100972,5580),(100973,5580),(100974,5581),(100975,5581),(100976,5581),(100977,5581),(100978,5582),(100979,5582),(100980,5582),(100981,5582),(100982,5583),(100983,5583),(100984,5583),(100985,5583),(100986,5584),(100987,5584),(100988,5584),(100989,5584),(100990,5585),(100991,5585),(100992,5585),(100993,5585),(100994,5586),(100995,5586),(100996,5586),(100997,5586),(100998,5587),(100999,5587),(101000,5587),(101001,5587),(101002,5588),(101003,5588),(101004,5588),(101005,5588),(101006,5589),(101007,5589),(101008,5589),(101009,5589),(101010,5590),(101011,5590),(101012,5590),(101013,5590),(101014,5591),(101015,5591),(101016,5591),(101017,5591),(101018,5592),(101019,5592),(101020,5592),(101021,5592),(101022,5593),(101023,5593),(101024,5593),(101025,5593),(101026,5594),(101027,5594),(101028,5594),(101029,5594),(101030,5595),(101031,5595),(101032,5595),(101033,5595),(101034,5596),(101035,5596),(101036,5596),(101037,5596),(101038,5597),(101039,5597),(101040,5597),(101041,5597),(101042,5598),(101043,5598),(101044,5598),(101045,5598),(101046,5599),(101047,5599),(101048,5599),(101049,5599),(101050,5600),(101051,5600),(101052,5600),(101053,5600),(101054,5601),(101055,5601),(101056,5601),(101057,5601),(101058,5602),(101059,5602),(101060,5602),(101061,5602),(101062,5603),(101063,5603),(101064,5603),(101065,5603),(101066,5604),(101067,5604),(101068,5604),(101069,5604),(101070,5605),(101071,5605),(101072,5605),(101073,5605),(101074,5606),(101075,5606),(101076,5606),(101077,5606),(101078,5607),(101079,5607),(101080,5607),(101081,5607),(101082,5608),(101083,5608),(101084,5608),(101085,5608),(101086,5609),(101087,5609),(101088,5609),(101089,5609),(101090,5610),(101091,5610),(101092,5610),(101093,5610),(101094,5611),(101095,5611),(101096,5611),(101097,5611),(101098,5612),(101099,5612),(101100,5612),(101101,5612),(101102,5613),(101103,5613),(101104,5613),(101105,5613),(101106,5614),(101107,5614),(101108,5614),(101109,5614),(101110,5615),(101111,5615),(101112,5615),(101113,5615),(101114,5616),(101115,5616),(101116,5616),(101117,5616),(101118,5617),(101119,5617),(101120,5617),(101121,5617),(101122,5618),(101123,5618),(101124,5618),(101125,5618),(101126,5619),(101127,5619),(101128,5619),(101129,5619),(101130,5620),(101131,5620),(101132,5620),(101133,5620),(101134,5621),(101135,5621),(101136,5621),(101137,5621),(101138,5622),(101139,5622),(101140,5622),(101141,5622),(101142,5623),(101143,5623),(101144,5623),(101145,5623),(101146,5624),(101147,5624),(101148,5624),(101149,5624),(101150,5625),(101151,5625),(101152,5625),(101153,5625),(101154,5626),(101155,5626),(101156,5626),(101157,5626),(101158,5627),(101159,5627),(101160,5627),(101161,5627),(101162,5628),(101163,5628),(101164,5628),(101165,5628),(101166,5629),(101167,5629),(101168,5629),(101169,5629),(101170,5630),(101171,5630),(101172,5630),(101173,5630),(101174,5631),(101175,5631),(101176,5631),(101177,5631),(101178,5632),(101179,5632),(101180,5632),(101181,5632),(101182,5633),(101183,5633),(101184,5633),(101185,5633),(101186,5634),(101187,5634),(101188,5634),(101189,5634),(101190,5635),(101191,5635),(101192,5635),(101193,5635),(101194,5636),(101195,5636),(101196,5636),(101197,5636),(101198,5637),(101199,5637),(101200,5637),(101201,5637),(101202,5638),(101203,5638),(101204,5638),(101205,5638),(101206,5639),(101207,5639),(101208,5639),(101209,5639),(101210,5640),(101211,5640),(101212,5640),(101213,5640),(101214,5641),(101215,5641),(101216,5641),(101217,5641),(101218,5642),(101219,5642),(101220,5642),(101221,5642),(101222,5643),(101223,5643),(101224,5643),(101225,5643),(101226,5644),(101227,5644),(101228,5644),(101229,5644),(101230,5645),(101231,5645),(101232,5645),(101233,5645),(101234,5646),(101235,5646),(101236,5646),(101237,5646),(101238,5647),(101239,5647),(101240,5647),(101241,5647),(101242,5648),(101243,5648),(101244,5648),(101245,5648),(101246,5649),(101247,5649),(101248,5649),(101249,5649),(101250,5650),(101251,5650),(101252,5650),(101253,5650),(101254,5651),(101255,5651),(101256,5651),(101257,5651),(101258,5652),(101259,5652),(101260,5652),(101261,5652),(101262,5653),(101263,5653),(101264,5653),(101265,5653),(101266,5654),(101267,5654),(101268,5654),(101269,5654),(101270,5655),(101271,5655),(101272,5655),(101273,5655),(101274,5656),(101275,5656),(101276,5656),(101277,5656),(101278,5657),(101279,5657),(101280,5657),(101281,5657),(101282,5658),(101283,5658),(101284,5658),(101285,5658),(101286,5659),(101287,5659),(101288,5659),(101289,5659),(101290,5660),(101291,5661),(101292,5662),(101293,5663),(101294,5664),(101295,5665),(101296,5666),(101297,5667),(101298,5668),(101299,5669),(101300,5670),(101301,5671),(101302,5672),(101303,5673),(101304,5674),(101305,5675),(101306,5676),(101307,5677),(101308,5678),(101309,5679),(101310,5680),(101311,5681),(101312,5682),(101313,5683),(101314,5684),(101315,5685),(101316,5686),(101317,5687),(101318,5688),(101319,5689),(101320,5690),(101321,5691),(101322,5692),(101323,5693),(101324,5694),(101325,5695),(101326,5696),(101327,5697),(101328,5698),(101329,5699),(101330,5700),(101331,5701),(101332,5702),(101333,5703),(101334,5704),(101335,5705),(101336,5706),(101337,5707),(101338,5708),(101339,5709),(101340,5710),(101341,5711),(101342,5712),(101343,5713),(101344,5714),(101345,5715),(101346,5716),(101347,5717),(101348,5718),(101349,5719),(101350,5720),(101351,5721),(101352,5722),(101353,5723),(101354,5724),(101355,5725),(101356,5726),(101357,5727),(101358,5728),(101359,5729),(101360,5730),(101361,5731),(101362,5732),(101363,5733),(101364,5734),(101365,5735),(101366,5736),(101367,5737),(101368,5738),(101369,5739),(101370,5740),(101371,5741),(101372,5742),(101373,5743),(101374,5744),(101375,5745),(101376,5746),(101377,5747),(101378,5748),(101379,5749),(101380,5750),(101381,5751),(101382,5752),(101383,5660),(101384,5661),(101385,5662),(101386,5663),(101387,5664),(101388,5665),(101389,5666),(101390,5667),(101391,5668),(101392,5669),(101393,5670),(101394,5671),(101395,5672),(101396,5673),(101397,5674),(101398,5675),(101399,5676),(101400,5677),(101401,5678),(101402,5679),(101403,5680),(101404,5681),(101405,5682),(101406,5683),(101407,5684),(101408,5685),(101409,5686),(101410,5687),(101411,5688),(101412,5689),(101413,5690),(101414,5691),(101415,5692),(101416,5693),(101417,5694),(101418,5695),(101419,5696),(101420,5697),(101421,5698),(101422,5699),(101423,5700),(101424,5701),(101425,5702),(101426,5703),(101427,5704),(101428,5705),(101429,5706),(101430,5707),(101431,5708),(101432,5709),(101433,5710),(101434,5711),(101435,5712),(101436,5713),(101437,5714),(101438,5715),(101439,5716),(101440,5717),(101441,5718),(101442,5719),(101443,5720),(101444,5721),(101445,5722),(101446,5723),(101447,5724),(101448,5725),(101449,5726),(101450,5727),(101451,5728),(101452,5729),(101453,5730),(101454,5731),(101455,5732),(101456,5733),(101457,5734),(101458,5735),(101459,5736),(101460,5737),(101461,5738),(101462,5739),(101463,5740),(101464,5741),(101465,5742),(101466,5743),(101467,5744),(101468,5745),(101469,5746),(101470,5747),(101471,5748),(101472,5749),(101473,5750),(101474,5751),(101475,5752),(101476,5660),(101477,5660),(101478,5660),(101479,5660),(101480,5660),(101481,5660),(101482,5661),(101483,5661),(101484,5661),(101485,5661),(101486,5661),(101487,5661),(101488,5662),(101489,5662),(101490,5662),(101491,5662),(101492,5662),(101493,5662),(101494,5663),(101495,5663),(101496,5663),(101497,5663),(101498,5663),(101499,5663),(101500,5664),(101501,5664),(101502,5664),(101503,5664),(101504,5664),(101505,5664),(101506,5665),(101507,5665),(101508,5665),(101509,5665),(101510,5665),(101511,5665),(101512,5666),(101513,5666),(101514,5666),(101515,5666),(101516,5666),(101517,5666),(101518,5667),(101519,5667),(101520,5667),(101521,5667),(101522,5667),(101523,5667),(101524,5668),(101525,5668),(101526,5668),(101527,5668),(101528,5668),(101529,5668),(101530,5669),(101531,5669),(101532,5669),(101533,5669),(101534,5669),(101535,5669),(101536,5670),(101537,5670),(101538,5670),(101539,5670),(101540,5670),(101541,5670),(101542,5671),(101543,5671),(101544,5671),(101545,5671),(101546,5671),(101547,5671),(101548,5672),(101549,5672),(101550,5672),(101551,5672),(101552,5672),(101553,5672),(101554,5673),(101555,5673),(101556,5673),(101557,5673),(101558,5673),(101559,5673),(101560,5674),(101561,5674),(101562,5674),(101563,5674),(101564,5674),(101565,5674),(101566,5675),(101567,5675),(101568,5675),(101569,5675),(101570,5675),(101571,5675),(101572,5676),(101573,5676),(101574,5676),(101575,5676),(101576,5676),(101577,5676),(101578,5677),(101579,5677),(101580,5677),(101581,5677),(101582,5677),(101583,5677),(101584,5678),(101585,5678),(101586,5678),(101587,5678),(101588,5678),(101589,5678),(101590,5679),(101591,5679),(101592,5679),(101593,5679),(101594,5679),(101595,5679),(101596,5680),(101597,5680),(101598,5680),(101599,5680),(101600,5680),(101601,5680),(101602,5681),(101603,5681),(101604,5681),(101605,5681),(101606,5681),(101607,5681),(101608,5682),(101609,5682),(101610,5682),(101611,5682),(101612,5682),(101613,5682),(101614,5683),(101615,5683),(101616,5683),(101617,5683),(101618,5683),(101619,5683),(101620,5684),(101621,5684),(101622,5684),(101623,5684),(101624,5684),(101625,5684),(101626,5685),(101627,5685),(101628,5685),(101629,5685),(101630,5685),(101631,5685),(101632,5686),(101633,5686),(101634,5686),(101635,5686),(101636,5686),(101637,5686),(101638,5687),(101639,5687),(101640,5687),(101641,5687),(101642,5687),(101643,5687),(101644,5688),(101645,5688),(101646,5688),(101647,5688),(101648,5688),(101649,5688),(101650,5689),(101651,5689),(101652,5689),(101653,5689),(101654,5689),(101655,5689),(101656,5690),(101657,5690),(101658,5690),(101659,5690),(101660,5690),(101661,5690),(101662,5691),(101663,5691),(101664,5691),(101665,5691),(101666,5691),(101667,5691),(101668,5692),(101669,5692),(101670,5692),(101671,5692),(101672,5692),(101673,5692),(101674,5693),(101675,5693),(101676,5693),(101677,5693),(101678,5693),(101679,5693),(101680,5694),(101681,5694),(101682,5694),(101683,5694),(101684,5694),(101685,5694),(101686,5695),(101687,5695),(101688,5695),(101689,5695),(101690,5695),(101691,5695),(101692,5696),(101693,5696),(101694,5696),(101695,5696),(101696,5696),(101697,5696),(101698,5697),(101699,5697),(101700,5697),(101701,5697),(101702,5697),(101703,5697),(101704,5698),(101705,5698),(101706,5698),(101707,5698),(101708,5698),(101709,5698),(101710,5699),(101711,5699),(101712,5699),(101713,5699),(101714,5699),(101715,5699),(101716,5700),(101717,5700),(101718,5700),(101719,5700),(101720,5700),(101721,5700),(101722,5701),(101723,5701),(101724,5701),(101725,5701),(101726,5701),(101727,5701),(101728,5702),(101729,5702),(101730,5702),(101731,5702),(101732,5702),(101733,5702),(101734,5703),(101735,5703),(101736,5703),(101737,5703),(101738,5703),(101739,5703),(101740,5704),(101741,5704),(101742,5704),(101743,5704),(101744,5704),(101745,5704),(101746,5705),(101747,5705),(101748,5705),(101749,5705),(101750,5705),(101751,5705),(101752,5706),(101753,5706),(101754,5706),(101755,5706),(101756,5706),(101757,5706),(101758,5707),(101759,5707),(101760,5707),(101761,5707),(101762,5707),(101763,5707),(101764,5708),(101765,5708),(101766,5708),(101767,5708),(101768,5708),(101769,5708),(101770,5709),(101771,5709),(101772,5709),(101773,5709),(101774,5709),(101775,5709),(101776,5710),(101777,5710),(101778,5710),(101779,5710),(101780,5710),(101781,5710),(101782,5711),(101783,5711),(101784,5711),(101785,5711),(101786,5711),(101787,5711),(101788,5712),(101789,5712),(101790,5712),(101791,5712),(101792,5712),(101793,5712),(101794,5713),(101795,5713),(101796,5713),(101797,5713),(101798,5713),(101799,5713),(101800,5714),(101801,5714),(101802,5714),(101803,5714),(101804,5714),(101805,5714),(101806,5715),(101807,5715),(101808,5715),(101809,5715),(101810,5715),(101811,5715),(101812,5716),(101813,5716),(101814,5716),(101815,5716),(101816,5716),(101817,5716),(101818,5717),(101819,5717),(101820,5717),(101821,5717),(101822,5717),(101823,5717),(101824,5718),(101825,5718),(101826,5718),(101827,5718),(101828,5718),(101829,5718),(101830,5719),(101831,5719),(101832,5719),(101833,5719),(101834,5719),(101835,5719),(101836,5720),(101837,5720),(101838,5720),(101839,5720),(101840,5720),(101841,5720),(101842,5721),(101843,5721),(101844,5721),(101845,5721),(101846,5721),(101847,5721),(101848,5722),(101849,5722),(101850,5722),(101851,5722),(101852,5722),(101853,5722),(101854,5723),(101855,5723),(101856,5723),(101857,5723),(101858,5723),(101859,5723),(101860,5724),(101861,5724),(101862,5724),(101863,5724),(101864,5724),(101865,5724),(101866,5725),(101867,5725),(101868,5725),(101869,5725),(101870,5725),(101871,5725),(101872,5726),(101873,5726),(101874,5726),(101875,5726),(101876,5726),(101877,5726),(101878,5727),(101879,5727),(101880,5727),(101881,5727),(101882,5727),(101883,5727),(101884,5728),(101885,5728),(101886,5728),(101887,5728),(101888,5728),(101889,5728),(101890,5729),(101891,5729),(101892,5729),(101893,5729),(101894,5729),(101895,5729),(101896,5730),(101897,5730),(101898,5730),(101899,5730),(101900,5730),(101901,5730),(101902,5731),(101903,5731),(101904,5731),(101905,5731),(101906,5731),(101907,5731),(101908,5732),(101909,5732),(101910,5732),(101911,5732),(101912,5732),(101913,5732),(101914,5733),(101915,5733),(101916,5733),(101917,5733),(101918,5733),(101919,5733),(101920,5734),(101921,5734),(101922,5734),(101923,5734),(101924,5734),(101925,5734),(101926,5735),(101927,5735),(101928,5735),(101929,5735),(101930,5735),(101931,5735),(101932,5736),(101933,5736),(101934,5736),(101935,5736),(101936,5736),(101937,5736),(101938,5737),(101939,5737),(101940,5737),(101941,5737),(101942,5737),(101943,5737),(101944,5738),(101945,5738),(101946,5738),(101947,5738),(101948,5738),(101949,5738),(101950,5739),(101951,5739),(101952,5739),(101953,5739),(101954,5739),(101955,5739),(101956,5740),(101957,5740),(101958,5740),(101959,5740),(101960,5740),(101961,5740),(101962,5741),(101963,5741),(101964,5741),(101965,5741),(101966,5741),(101967,5741),(101968,5742),(101969,5742),(101970,5742),(101971,5742),(101972,5742),(101973,5742),(101974,5743),(101975,5743),(101976,5743),(101977,5743),(101978,5743),(101979,5743),(101980,5744),(101981,5744),(101982,5744),(101983,5744),(101984,5744),(101985,5744),(101986,5745),(101987,5745),(101988,5745),(101989,5745),(101990,5745),(101991,5745),(101992,5746),(101993,5746),(101994,5746),(101995,5746),(101996,5746),(101997,5746),(101998,5747),(101999,5747),(102000,5747),(102001,5747),(102002,5747),(102003,5747),(102004,5748),(102005,5748),(102006,5748),(102007,5748),(102008,5748),(102009,5748),(102010,5749),(102011,5749),(102012,5749),(102013,5749),(102014,5749),(102015,5749),(102016,5750),(102017,5750),(102018,5750),(102019,5750),(102020,5751),(102021,5751),(102022,5751),(102023,5751),(102024,5751),(102025,5751),(102026,5752),(102027,5752),(102028,5752),(102029,5752),(102030,5752),(102031,5752),(102032,5660),(102033,5660),(102034,5661),(102035,5661),(102036,5662),(102037,5662),(102038,5663),(102039,5663),(102040,5664),(102041,5664),(102042,5665),(102043,5665),(102044,5666),(102045,5666),(102046,5667),(102047,5667),(102048,5668),(102049,5668),(102050,5669),(102051,5669),(102052,5670),(102053,5670),(102054,5671),(102055,5671),(102056,5672),(102057,5672),(102058,5673),(102059,5673),(102060,5674),(102061,5674),(102062,5675),(102063,5675),(102064,5676),(102065,5676),(102066,5677),(102067,5677),(102068,5678),(102069,5678),(102070,5679),(102071,5679),(102072,5680),(102073,5680),(102074,5681),(102075,5681),(102076,5682),(102077,5682),(102078,5682),(102079,5683),(102080,5683),(102081,5683),(102082,5684),(102083,5684),(102084,5684),(102085,5685),(102086,5685),(102087,5685),(102088,5686),(102089,5686),(102090,5686),(102091,5687),(102092,5687),(102093,5687),(102094,5688),(102095,5688),(102096,5688),(102097,5689),(102098,5689),(102099,5689),(102100,5690),(102101,5690),(102102,5690),(102103,5691),(102104,5691),(102105,5691),(102106,5692),(102107,5692),(102108,5692),(102109,5693),(102110,5693),(102111,5693),(102112,5694),(102113,5694),(102114,5694),(102115,5695),(102116,5695),(102117,5696),(102118,5696),(102119,5696),(102120,5697),(102121,5697),(102122,5697),(102123,5698),(102124,5698),(102125,5698),(102126,5699),(102127,5699),(102128,5699),(102129,5700),(102130,5700),(102131,5700),(102132,5701),(102133,5701),(102134,5701),(102135,5702),(102136,5702),(102137,5702),(102138,5703),(102139,5703),(102140,5703),(102141,5704),(102142,5704),(102143,5705),(102144,5705),(102145,5706),(102146,5706),(102147,5707),(102148,5707),(102149,5708),(102150,5708),(102151,5709),(102152,5709),(102153,5709),(102154,5710),(102155,5710),(102156,5710),(102157,5711),(102158,5711),(102159,5711),(102160,5712),(102161,5712),(102162,5712),(102163,5713),(102164,5713),(102165,5714),(102166,5714),(102167,5715),(102168,5715),(102169,5716),(102170,5716),(102171,5717),(102172,5717),(102173,5718),(102174,5718),(102175,5719),(102176,5719),(102177,5720),(102178,5720),(102179,5721),(102180,5721),(102181,5722),(102182,5722),(102183,5723),(102184,5723),(102185,5724),(102186,5724),(102187,5725),(102188,5725),(102189,5726),(102190,5726),(102191,5727),(102192,5727),(102193,5728),(102194,5728),(102195,5729),(102196,5729),(102197,5730),(102198,5730),(102199,5731),(102200,5731),(102201,5732),(102202,5732),(102203,5733),(102204,5733),(102205,5734),(102206,5734),(102207,5735),(102208,5735),(102209,5736),(102210,5736),(102211,5737),(102212,5737),(102213,5738),(102214,5738),(102215,5739),(102216,5739),(102217,5740),(102218,5740),(102219,5741),(102220,5741),(102221,5742),(102222,5742),(102223,5743),(102224,5743),(102225,5744),(102226,5744),(102227,5745),(102228,5745),(102229,5745),(102230,5746),(102231,5746),(102232,5746),(102233,5747),(102234,5747),(102235,5747),(102236,5748),(102237,5748),(102238,5748),(102239,5749),(102240,5749),(102241,5749),(102242,5750),(102243,5751),(102244,5751),(102245,5752),(102246,5752),(102247,5752),(102248,5660),(102249,5660),(102250,5660),(102251,5661),(102252,5661),(102253,5661),(102254,5662),(102255,5662),(102256,5662),(102257,5663),(102258,5663),(102259,5663),(102260,5664),(102261,5664),(102262,5664),(102263,5665),(102264,5665),(102265,5665),(102266,5666),(102267,5666),(102268,5666),(102269,5667),(102270,5667),(102271,5667),(102272,5668),(102273,5668),(102274,5668),(102275,5669),(102276,5669),(102277,5669),(102278,5670),(102279,5670),(102280,5670),(102281,5671),(102282,5671),(102283,5671),(102284,5672),(102285,5672),(102286,5672),(102287,5673),(102288,5673),(102289,5673),(102290,5674),(102291,5674),(102292,5674),(102293,5675),(102294,5675),(102295,5675),(102296,5676),(102297,5676),(102298,5676),(102299,5677),(102300,5677),(102301,5677),(102302,5678),(102303,5678),(102304,5678),(102305,5679),(102306,5679),(102307,5679),(102308,5680),(102309,5680),(102310,5680),(102311,5681),(102312,5681),(102313,5681),(102314,5682),(102315,5682),(102316,5682),(102317,5682),(102318,5683),(102319,5683),(102320,5683),(102321,5683),(102322,5684),(102323,5684),(102324,5684),(102325,5684),(102326,5685),(102327,5685),(102328,5685),(102329,5685),(102330,5686),(102331,5686),(102332,5686),(102333,5686),(102334,5687),(102335,5687),(102336,5687),(102337,5688),(102338,5688),(102339,5688),(102340,5688),(102341,5689),(102342,5689),(102343,5690),(102344,5690),(102345,5690),(102346,5691),(102347,5691),(102348,5691),(102349,5692),(102350,5692),(102351,5692),(102352,5693),(102353,5693),(102354,5693),(102355,5694),(102356,5694),(102357,5694),(102358,5695),(102359,5695),(102360,5695),(102361,5696),(102362,5696),(102363,5697),(102364,5697),(102365,5697),(102366,5698),(102367,5698),(102368,5698),(102369,5699),(102370,5699),(102371,5699),(102372,5700),(102373,5700),(102374,5700),(102375,5701),(102376,5701),(102377,5701),(102378,5702),(102379,5702),(102380,5702),(102381,5703),(102382,5703),(102383,5703),(102384,5704),(102385,5704),(102386,5704),(102387,5705),(102388,5705),(102389,5705),(102390,5706),(102391,5706),(102392,5706),(102393,5707),(102394,5707),(102395,5707),(102396,5708),(102397,5708),(102398,5708),(102399,5709),(102400,5709),(102401,5709),(102402,5709),(102403,5710),(102404,5710),(102405,5710),(102406,5711),(102407,5711),(102408,5711),(102409,5711),(102410,5712),(102411,5712),(102412,5712),(102413,5713),(102414,5713),(102415,5713),(102416,5714),(102417,5714),(102418,5714),(102419,5715),(102420,5715),(102421,5715),(102422,5716),(102423,5716),(102424,5716),(102425,5717),(102426,5717),(102427,5717),(102428,5718),(102429,5718),(102430,5718),(102431,5719),(102432,5719),(102433,5719),(102434,5720),(102435,5720),(102436,5720),(102437,5721),(102438,5721),(102439,5721),(102440,5722),(102441,5722),(102442,5722),(102443,5723),(102444,5723),(102445,5723),(102446,5724),(102447,5724),(102448,5724),(102449,5725),(102450,5725),(102451,5725),(102452,5726),(102453,5726),(102454,5726),(102455,5727),(102456,5727),(102457,5727),(102458,5728),(102459,5728),(102460,5728),(102461,5729),(102462,5729),(102463,5729),(102464,5730),(102465,5730),(102466,5730),(102467,5731),(102468,5731),(102469,5731),(102470,5732),(102471,5732),(102472,5732),(102473,5733),(102474,5733),(102475,5733),(102476,5734),(102477,5734),(102478,5734),(102479,5735),(102480,5735),(102481,5735),(102482,5736),(102483,5736),(102484,5736),(102485,5737),(102486,5737),(102487,5737),(102488,5738),(102489,5738),(102490,5738),(102491,5739),(102492,5739),(102493,5739),(102494,5740),(102495,5740),(102496,5740),(102497,5741),(102498,5741),(102499,5741),(102500,5742),(102501,5742),(102502,5742),(102503,5743),(102504,5743),(102505,5743),(102506,5744),(102507,5744),(102508,5744),(102509,5745),(102510,5745),(102511,5745),(102512,5745),(102513,5746),(102514,5746),(102515,5746),(102516,5746),(102517,5747),(102518,5747),(102519,5747),(102520,5747),(102521,5748),(102522,5748),(102523,5748),(102524,5749),(102525,5749),(102526,5749),(102527,5749),(102528,5750),(102529,5750),(102530,5750),(102531,5751),(102532,5751),(102533,5751),(102534,5752),(102535,5752),(102536,5660),(102537,5660),(102538,5660),(102539,5660),(102540,5661),(102541,5661),(102542,5661),(102543,5661),(102544,5662),(102545,5662),(102546,5662),(102547,5662),(102548,5663),(102549,5663),(102550,5663),(102551,5663),(102552,5664),(102553,5664),(102554,5664),(102555,5664),(102556,5665),(102557,5665),(102558,5665),(102559,5665),(102560,5666),(102561,5666),(102562,5666),(102563,5666),(102564,5667),(102565,5667),(102566,5667),(102567,5667),(102568,5668),(102569,5668),(102570,5668),(102571,5668),(102572,5669),(102573,5669),(102574,5669),(102575,5669),(102576,5670),(102577,5670),(102578,5670),(102579,5670),(102580,5671),(102581,5671),(102582,5671),(102583,5671),(102584,5672),(102585,5672),(102586,5672),(102587,5672),(102588,5673),(102589,5673),(102590,5673),(102591,5673),(102592,5674),(102593,5674),(102594,5674),(102595,5674),(102596,5675),(102597,5675),(102598,5675),(102599,5675),(102600,5676),(102601,5676),(102602,5676),(102603,5676),(102604,5677),(102605,5677),(102606,5677),(102607,5677),(102608,5678),(102609,5678),(102610,5678),(102611,5678),(102612,5679),(102613,5679),(102614,5679),(102615,5679),(102616,5680),(102617,5680),(102618,5680),(102619,5680),(102620,5681),(102621,5681),(102622,5681),(102623,5681),(102624,5682),(102625,5682),(102626,5682),(102627,5682),(102628,5683),(102629,5683),(102630,5683),(102631,5683),(102632,5684),(102633,5684),(102634,5684),(102635,5684),(102636,5685),(102637,5685),(102638,5685),(102639,5685),(102640,5686),(102641,5686),(102642,5686),(102643,5686),(102644,5687),(102645,5687),(102646,5687),(102647,5687),(102648,5688),(102649,5688),(102650,5688),(102651,5688),(102652,5689),(102653,5689),(102654,5689),(102655,5689),(102656,5690),(102657,5690),(102658,5690),(102659,5690),(102660,5691),(102661,5691),(102662,5691),(102663,5691),(102664,5692),(102665,5692),(102666,5692),(102667,5692),(102668,5693),(102669,5693),(102670,5693),(102671,5693),(102672,5694),(102673,5694),(102674,5694),(102675,5694),(102676,5695),(102677,5695),(102678,5695),(102679,5695),(102680,5696),(102681,5696),(102682,5696),(102683,5696),(102684,5697),(102685,5697),(102686,5697),(102687,5697),(102688,5698),(102689,5698),(102690,5698),(102691,5698),(102692,5699),(102693,5699),(102694,5699),(102695,5699),(102696,5700),(102697,5700),(102698,5700),(102699,5700),(102700,5701),(102701,5701),(102702,5701),(102703,5701),(102704,5702),(102705,5702),(102706,5702),(102707,5702),(102708,5703),(102709,5703),(102710,5703),(102711,5703),(102712,5704),(102713,5704),(102714,5704),(102715,5704),(102716,5705),(102717,5705),(102718,5705),(102719,5705),(102720,5706),(102721,5706),(102722,5706),(102723,5706),(102724,5707),(102725,5707),(102726,5707),(102727,5707),(102728,5708),(102729,5708),(102730,5708),(102731,5708),(102732,5709),(102733,5709),(102734,5709),(102735,5709),(102736,5710),(102737,5710),(102738,5710),(102739,5710),(102740,5711),(102741,5711),(102742,5711),(102743,5711),(102744,5712),(102745,5712),(102746,5712),(102747,5712),(102748,5713),(102749,5713),(102750,5713),(102751,5713),(102752,5714),(102753,5714),(102754,5714),(102755,5714),(102756,5715),(102757,5715),(102758,5715),(102759,5715),(102760,5716),(102761,5716),(102762,5716),(102763,5716),(102764,5717),(102765,5717),(102766,5717),(102767,5717),(102768,5718),(102769,5718),(102770,5718),(102771,5718),(102772,5719),(102773,5719),(102774,5719),(102775,5719),(102776,5720),(102777,5720),(102778,5720),(102779,5720),(102780,5721),(102781,5721),(102782,5721),(102783,5721),(102784,5722),(102785,5722),(102786,5722),(102787,5722),(102788,5723),(102789,5723),(102790,5723),(102791,5723),(102792,5724),(102793,5724),(102794,5724),(102795,5724),(102796,5725),(102797,5725),(102798,5725),(102799,5725),(102800,5726),(102801,5726),(102802,5726),(102803,5726),(102804,5727),(102805,5727),(102806,5727),(102807,5727),(102808,5728),(102809,5728),(102810,5728),(102811,5728),(102812,5729),(102813,5729),(102814,5729),(102815,5729),(102816,5730),(102817,5730),(102818,5730),(102819,5730),(102820,5731),(102821,5731),(102822,5731),(102823,5731),(102824,5732),(102825,5732),(102826,5732),(102827,5732),(102828,5733),(102829,5733),(102830,5733),(102831,5733),(102832,5734),(102833,5734),(102834,5734),(102835,5734),(102836,5735),(102837,5735),(102838,5735),(102839,5735),(102840,5736),(102841,5736),(102842,5736),(102843,5736),(102844,5737),(102845,5737),(102846,5737),(102847,5737),(102848,5738),(102849,5738),(102850,5738),(102851,5738),(102852,5739),(102853,5739),(102854,5739),(102855,5739),(102856,5740),(102857,5740),(102858,5740),(102859,5740),(102860,5741),(102861,5741),(102862,5741),(102863,5741),(102864,5742),(102865,5742),(102866,5742),(102867,5742),(102868,5743),(102869,5743),(102870,5743),(102871,5743),(102872,5744),(102873,5744),(102874,5744),(102875,5744),(102876,5745),(102877,5745),(102878,5745),(102879,5745),(102880,5746),(102881,5746),(102882,5746),(102883,5746),(102884,5747),(102885,5747),(102886,5747),(102887,5747),(102888,5748),(102889,5748),(102890,5748),(102891,5748),(102892,5749),(102893,5749),(102894,5749),(102895,5749),(102896,5750),(102897,5750),(102898,5750),(102899,5750),(102900,5751),(102901,5751),(102902,5751),(102903,5751),(102904,5752),(102905,5752),(102906,5752),(102907,5752),(102908,1475),(102909,1476),(102910,1497),(102911,1498),(102912,1501),(102913,1503),(102914,1504),(102915,1506),(102916,1507),(102917,1508),(102918,1509),(102919,1510),(102920,1511),(102921,1512),(102922,1513),(102923,1514),(102924,1515),(102925,1545),(102926,1588),(102927,1589),(102928,1590),(102929,1591),(102930,1592),(102931,1593),(102932,1594),(102933,1595),(102934,1596),(102935,1597),(102936,1598),(102937,1599),(102938,1600),(102939,1601),(102940,1602),(102941,1603),(102942,1604),(102943,1605),(102944,1606),(102945,1607),(102946,1608),(102947,1609),(102948,1610),(102949,1613),(102950,1615),(102951,1618),(102952,1619),(102953,1620),(102954,1621),(102955,1622),(102956,1623),(102957,1624),(102958,1625),(102959,1626),(102960,1627),(102961,1628),(102962,1654),(102963,1657),(102964,1715),(102965,1717),(102966,1718),(102967,1719),(102968,1720),(102969,1721),(102970,1722),(102971,1723),(102972,1724),(102973,1725),(102974,1727),(102975,1728),(102976,1729),(102977,1732),(102978,1733),(102979,1734),(102980,1735),(102981,1766),(102982,1767),(102983,1768),(102984,1770),(102985,1771),(102986,1774),(102987,1775),(102988,1784),(102989,1785),(102990,1797),(102991,1812),(102992,2289),(102993,4881),(102994,4889),(102995,5363),(102996,5366),(102997,5623),(102998,5629),(102999,5636),(103000,5642),(103001,5651),(103002,5662),(103003,5668),(103004,1497),(103005,1503),(103006,1504),(103007,1507),(103008,1508),(103009,1510),(103010,1512),(103011,1592),(103012,1595),(103013,1600),(103014,1601),(103015,1602),(103016,1603),(103017,1605),(103018,1606),(103019,1608),(103020,1609),(103021,1622),(103022,1624),(103023,1625),(103024,1626),(103025,1627),(103026,1628),(103027,1717),(103028,1720),(103029,1723),(103030,1724),(103031,1725),(103032,1727),(103033,1728),(103034,1729),(103035,1732),(103036,1797),(103037,1498),(103038,1503),(103039,1513),(103040,1588),(103041,1589),(103042,1590),(103043,1604),(103044,1613),(103045,1615),(103046,1619),(103047,1715),(103048,1718),(103049,1721),(103050,1723),(103051,1724),(103052,1733),(103053,1734),(103054,1770),(103055,1771),(103056,1774),(103057,1775),(103058,1784),(103059,1785),(103060,4889),(103061,1501),(103062,1506),(103063,1509),(103064,1511),(103065,1514),(103066,1607),(103067,1615),(103068,1618),(103069,1620),(103070,1654),(103071,1657),(103072,1719),(103073,1722),(103074,1735),(103075,1766),(103076,1767),(103077,1768),(103078,1812),(103079,4881),(103080,1160),(103081,1160),(103082,1160),(103083,1160),(103084,1160),(103085,1160),(103086,1160),(103087,1160),(103088,1160),(103089,1160),(103090,1160),(103091,1160),(103092,1161),(103093,1161),(103094,1161),(103095,1161),(103096,1161),(103097,1161),(103098,1161),(103099,1161),(103100,1161),(103101,1161),(103102,1161),(103103,1161),(103104,1161),(103105,1159),(103106,1162),(103107,1162),(103108,1162),(103109,1162),(103110,1162),(103111,1162),(103112,1162),(103113,1162),(103114,1162),(103115,1164),(103116,1165),(103117,1164),(103118,1165),(103119,1119),(103120,1119),(103121,1119),(103122,1119),(103123,1119),(103124,1119),(103125,4711),(103126,4713),(103127,5738),(103128,5752),(103129,1162),(103130,1163),(103131,1164),(103132,1165),(103133,5752),(103134,5752),(103135,5752),(103136,5752),(103137,5752),(103138,5752),(103139,5752),(103140,5752),(103141,5752),(103142,5752),(103143,5752),(103144,5752),(103145,5738),(103146,5738),(103147,5738),(103148,5738),(103149,5738),(103150,5738),(103151,5738),(103152,5738),(103153,5738),(103154,5738),(103155,5738),(103156,5738),(103157,5738),(103158,4713),(103159,4713),(103160,4713),(103161,4713),(103162,4713),(103163,4713),(103164,4713),(103165,4713),(103166,4713),(103167,4713),(103168,4713),(103169,4875),(103170,4876),(103171,4891),(103172,4892),(103173,4893),(103174,4894),(103175,1160),(103176,1161),(103177,1162),(103178,1163),(103179,1164),(103180,1165),(103181,4711),(103182,4713),(103183,5738),(103184,5752),(103185,5191),(103186,5192),(103187,5193),(103188,5194),(103189,5197),(103190,1160),(103191,1161),(103192,5190),(103193,5190),(103194,4713),(103195,5197),(103196,5197),(103197,5197),(103198,5197),(103199,5197),(103200,5197),(103201,5197),(103202,5197),(103203,5197),(103204,5197),(103205,5197),(103206,5194),(103207,5194),(103208,5194),(103209,5194),(103210,5194),(103211,5194),(103212,5194),(103213,5194),(103214,5194),(103215,5194),(103216,5194),(103217,5193),(103218,5193),(103219,5193),(103220,5193),(103221,5193),(103222,5193),(103223,5193),(103224,5193),(103225,5193),(103226,5193),(103227,5193),(103228,5192),(103229,5192),(103230,5192),(103231,5192),(103232,5192),(103233,5192),(103234,5192),(103235,5192),(103236,5192),(103237,5192),(103238,5192),(103239,5191),(103240,5191),(103241,5191),(103242,5191),(103243,5191),(103244,5191),(103245,5191),(103246,5191),(103247,5191),(103248,5191),(103249,5191),(103250,4713),(103251,5190),(103252,5190),(103253,5190),(103254,5190),(103255,5190),(103256,5190),(103257,5190),(103258,5190),(103259,5190),(103260,5190),(103261,5190),(103262,5190),(103263,5190),(103264,4875),(103265,4875),(103266,4875),(103267,4876),(103268,4876),(103269,4876),(103270,4876),(103271,4876),(103272,4876),(103273,4876),(103274,4876),(103275,4876),(103276,4876),(103277,4876),(103278,4876),(103279,4876),(103280,4891),(103281,4891),(103282,4891),(103283,4891),(103284,4892),(103285,4892),(103286,4892),(103287,4893),(103288,4893),(103289,4893),(103290,4893),(103291,4893),(103292,4893),(103293,4893),(103294,4893),(103295,4893),(103296,4893),(103297,4893),(103298,4894),(103299,4894),(103300,4894),(103301,4894),(103302,4894),(103303,4894),(103304,4894),(103305,4894),(103306,4894),(103307,4894),(103308,4894),(103309,4894),(103310,4892),(103311,4892),(103312,4892),(103313,4892),(103314,4892),(103315,4892),(103316,4892),(103317,4892),(103318,4875),(103319,4875),(103320,4875),(103321,4875),(103322,4875),(103323,4875),(103324,4875),(103325,4875),(103326,4892),(103327,4892),(103328,4892),(103329,4892),(103330,4892),(103331,4892),(103332,4892),(103333,4892),(103334,4891),(103335,4891),(103336,4891),(103337,4891),(103338,4891),(103339,4891),(103340,4891),(103341,4891),(103342,4891),(103343,4891),(103344,1162),(103345,1162),(103346,1162),(103347,1165),(103348,1165),(103349,1165),(103350,2163),(103351,2163),(103352,2163),(103353,2163),(103354,2163),(103355,2163),(103356,2163),(103357,2163),(103358,2163),(103359,2176),(103360,2176),(103361,2176),(103362,2176),(103363,2176),(103364,2176),(103365,2176),(103366,2176),(103367,2176),(103368,2176),(103369,2176),(103370,1164),(103371,1164),(103372,1164),(103373,4894),(103374,4894),(103375,4894),(103376,4894),(103377,2163),(103378,1),(103379,1),(103380,1),(103381,1),(103382,1),(103383,1),(103384,1),(103385,1),(103386,1),(103387,1),(103388,1),(103389,1),(103390,1),(103391,1),(103392,1),(103393,1),(103394,1),(103395,1),(103396,1),(103397,1),(103398,1),(103399,1),(103400,1),(103401,1),(103402,1),(103403,1),(103404,1),(103405,1),(103406,1),(103407,1),(103408,42),(103409,141),(103410,143),(103411,163),(103412,165),(103413,145),(103414,148),(103415,180),(103416,186),(103417,1509),(103418,1775),(103419,1785),(103420,2375),(103421,2390),(103422,176),(103423,177),(103424,178),(103425,179),(103426,183),(103427,184),(103428,185),(103429,187),(103430,162),(103431,181),(103432,188),(103433,189),(103434,190),(103435,191),(103436,201),(103437,203),(103438,206),(103439,207),(103440,208),(103441,209),(103442,210),(103443,192),(103444,193),(103445,194),(103446,196),(103447,1480),(103448,1483),(103449,1486),(103450,1487),(103451,1495),(103452,1502),(103453,1611),(103454,1705),(103455,1707),(103456,1769),(103457,1505),(103458,1616),(103459,1617),(103460,1655),(103461,1656),(103462,1706),(103463,1742),(103464,1776),(103465,1539),(103466,1540),(103467,1541),(103468,1548),(103469,1549),(103470,1560),(103471,1561),(103472,1741),(103473,1764),(103474,1765),(103475,1783),(103476,1477),(103477,1537),(103478,1538),(103479,1544),(103480,1546),(103481,1547),(103482,1550),(103483,1551),(103484,1552),(103485,1554),(103486,1555),(103487,1556),(103488,1496),(103489,1553),(103490,1612),(103491,1614),(103492,1777),(103493,1473),(103494,1474),(103495,1475),(103496,1476),(103497,1477),(103498,1500),(103499,1537),(103500,1538),(103501,1539),(103502,1540),(103503,1541),(103504,1542),(103505,1543),(103506,1544),(103507,1545),(103508,1561),(103509,1591),(103510,1593),(103511,1594),(103512,1596),(103513,1597),(103514,1610),(103515,1598),(103516,1599),(103517,1621),(103518,1623),(103519,4538),(103520,1485),(103521,1611),(103522,1707),(103523,1769),(103524,1486),(103525,1487),(103526,1495),(103527,1505),(103528,1517),(103529,1776),(103530,1546),(103531,1553),(103532,1554),(103533,1555),(103534,1556),(103535,1612),(103536,1655),(103537,1656),(103538,1764),(103539,1777),(103540,1584),(103541,1585),(103542,1586),(103543,1730),(103544,1731),(103545,1796),(103546,1478),(103547,1481),(103548,1482),(103549,1484),(103550,1516),(103551,1705),(103552,5753),(103553,5753),(103554,5753),(103555,5753),(103556,5753),(103557,5753),(103558,5753),(103559,5753),(103560,5753),(103561,5753),(103562,5753),(103563,5753),(103564,5753),(103565,5753),(103566,5753),(103567,5753),(103568,5753),(103569,5753),(103570,5753),(103571,5753),(103572,5754),(103573,5754),(103574,5754),(103575,5754),(103576,5754),(103577,5754),(103578,5754),(103579,5754),(103580,5754),(103581,5754),(103582,5754),(103583,5754),(103584,5754),(103585,5754),(103586,5754),(103587,5754),(103588,5754),(103589,5754),(103590,5754),(103591,5754),(103592,5754),(103593,5755),(103594,5755),(103595,5755),(103596,5755),(103597,5755),(103598,5755),(103599,5755),(103600,5755),(103601,5755),(103602,5755),(103603,5755),(103604,5755),(103605,5755),(103606,5755),(103607,5755),(103608,5755),(103609,5755),(103610,5755),(103611,5755),(103612,5755),(103613,5755),(103614,5756),(103615,5756),(103616,5756),(103617,5756),(103618,5756),(103619,5756),(103620,5756),(103621,5756),(103622,5756),(103623,5756),(103624,5756),(103625,5756),(103626,5756),(103627,5756),(103628,5756),(103629,5756),(103630,5756),(103631,5756),(103632,5756),(103633,5756),(103634,5756),(103635,5753),(103636,5753),(103637,5754),(103638,5755),(103639,5756),(103640,5753),(103641,5753),(103642,5754),(103643,5755),(103644,5756),(103645,1479),(103646,1480),(103647,1483),(103648,1502),(103649,1515),(103650,1616),(103651,1617),(103652,1548),(103653,1549),(103654,1551),(103655,1552),(103656,1560),(103657,1706),(103658,1741),(103659,1765),(103660,1783),(103661,1496),(103662,1547),(103663,1550),(103664,1614),(103665,1716),(103666,1726),(103667,1736),(103668,5278),(103669,5279),(103670,5280),(103671,5281),(103672,5295),(103673,5470),(103674,5473),(103675,5538),(103676,5539),(103677,5549),(103678,5550),(103679,5607),(103680,5701),(103681,5353),(103682,5469),(103683,5687),(103684,5712),(103685,5748),(103686,1739),(103687,1772),(103688,5310),(103689,5311),(103690,5312),(103691,5315),(103692,5318),(103693,5321),(103694,5322),(103695,5309),(103696,5313),(103697,5314),(103698,5316),(103699,5317),(103700,5319),(103701,1140),(103702,5689),(103703,5696),(103704,1154),(103705,4530),(103706,4535),(103707,4536),(103708,5256),(103709,5257),(103710,5284),(103711,5320),(103712,4622),(103713,4623),(103714,4624),(103715,4853),(103716,4854),(103717,4855),(103718,4881),(103719,4889),(103720,5282),(103721,5283),(103722,4526),(103723,4527),(103724,4531),(103725,4533),(103726,4534),(103727,4877),(103728,4878),(103729,4879),(103730,4886),(103731,4887),(103732,4888),(103733,5259),(103734,5260),(103735,5261),(103736,5262),(103737,5263),(103738,4882),(103739,4883),(103740,5264),(103741,5265),(103742,5266),(103743,5267),(103744,5268),(103745,5269),(103746,5270),(103747,1151),(103748,1152),(103749,1153),(103750,1155),(103751,1156),(103752,4890),(103753,4897),(103754,5171),(103755,5258),(103756,5435),(103757,5436),(103758,5437),(103759,5438),(103760,5439),(103761,5440),(103762,5441),(103763,5443),(103764,5444),(103765,5285),(103766,5296),(103767,5297),(103768,5338),(103769,5339),(103770,5340),(103771,5431),(103772,5442),(103773,5341),(103774,5342),(103775,5345),(103776,5346),(103777,5347),(103778,5348),(103779,5349),(103780,5350),(103781,5535),(103782,5674),(103783,5675),(103784,5676),(103785,5677),(103786,5679),(103787,5369),(103788,5402),(103789,5531),(103790,5532),(103791,5537),(103792,5615),(103793,5752),(103794,5403),(103795,5412),(103796,5423),(103797,5445),(103798,5446),(103799,5447),(103800,5448),(103801,5450),(103802,5546),(103803,5547),(103804,5606),(103805,5690),(103806,5288),(103807,5290),(103808,5292),(103809,5293),(103810,5680),(103811,5681),(103812,5697),(103813,5698),(103814,5710),(103815,5294),(103816,5411),(103817,5611),(103818,5614),(103819,5620),(103820,5683),(103821,5709),(103822,5747),(103823,5749),(103824,5471),(103825,5472),(103826,5533),(103827,5534),(103828,5535),(103829,5609),(103830,5682),(103831,5685),(103832,5745),(103833,5746),(103834,5674),(103835,5675),(103836,5676),(103837,5677),(103838,5678),(103839,5679),(103840,5369),(103841,5402),(103842,5531),(103843,5532),(103844,5537),(103845,5752),(103846,5277),(103847,5415),(103848,5416),(103849,5417),(103850,5547),(103851,5567),(103852,5680),(103853,5681),(103854,5691),(103855,5699),(103856,5275),(103857,5276),(103858,5542),(103859,5543),(103860,5608),(103861,5610),(103862,5612),(103863,5684),(103864,5686),(103865,5338),(103866,5339),(103867,5340),(103868,5341),(103869,5342),(103870,5410),(103871,5544),(103872,5545),(103873,5688),(103874,5345),(103875,5346),(103876,5347),(103877,5348),(103878,5349),(103879,5350),(103880,5369),(103881,5531),(103882,5532),(103883,5535),(103884,5738),(103885,5417),(103886,5567),(103887,1615),(103888,5563),(103889,5688),(103890,5608),(103891,5291),(103892,5558),(103893,5564),(103894,5566),(103895,5605),(103896,5608),(103897,5612),(103898,5684),(103899,5686),(103900,5688),(103901,5691),(103902,5290),(103903,5345),(103904,5346),(103905,5347),(103906,5348),(103907,5349),(103908,5350),(103909,5594),(103910,5599),(103911,5600),(103912,5601),(103913,5604),(103914,5693),(103915,5285),(103916,5413),(103917,5414),(103918,5418),(103919,5419),(103920,5548),(103921,5593),(103922,5692),(103923,5694),(103924,5700),(103925,5286),(103926,5296),(103927,5297),(103928,5298),(103929,5541),(103930,5711),(103931,5443),(103932,5289),(103933,5302),(103934,5442),(103935,5591),(103936,5595),(103937,5602),(103938,5603),(103939,5613),(103940,5618),(103941,5733),(103942,5431),(103943,5435),(103944,5436),(103945,5437),(103946,5438),(103947,5439),(103948,5440),(103949,5441),(103950,5444),(103951,5408),(103952,5420),(103953,5553),(103954,5554),(103955,5555),(103956,5556),(103957,5557),(103958,5599),(103959,5600),(103960,5601),(103961,5615),(103962,5618),(103963,5540),(103964,5553),(103965,5554),(103966,5555),(103967,5556),(103968,5557),(103969,5571),(103970,5592),(103971,5596),(103972,5597),(103973,1148),(103974,5452),(103975,5659),(103976,5661),(103977,2540),(103978,2541),(103979,2542),(103980,5357),(103981,5630),(103982,5631),(103983,5632),(103984,5633),(103985,5634),(103986,1162),(103987,1162),(103988,1162),(103989,4894),(103990,4894),(103991,4894),(103992,1164),(103993,1164),(103994,1164),(103995,2176),(103996,2176),(103997,2176),(103998,224),(103999,225),(104000,226),(104001,227),(104002,228),(104003,235),(104004,236),(104005,237),(104006,238),(104007,239),(104008,163),(104009,165),(104010,167),(104011,168),(104012,229),(104013,230),(104014,231),(104015,232),(104016,233),(104017,234),(104018,7),(104019,39),(104020,40),(104021,41),(104022,42),(104023,43),(104024,44),(104025,141),(104026,143),(104027,144),(104028,146),(104029,150),(104030,151),(104031,8),(104032,9),(104033,10),(104034,11),(104035,12),(104036,13),(104037,14),(104038,23),(104039,24),(104040,25),(104041,27),(104042,28),(104043,29),(104044,30),(104045,32),(104046,37),(104047,38),(104048,45),(104049,46),(104050,47),(104051,53),(104052,66),(104053,70),(104054,78),(104055,79),(104056,80),(104057,81),(104058,54),(104059,55),(104060,61),(104061,62),(104062,82),(104063,83),(104064,84),(104065,85),(104066,86),(104067,87),(104068,88),(104069,90),(104070,56),(104071,57),(104072,59),(104073,60),(104074,91),(104075,92),(104076,58),(104077,93),(104078,95),(104079,122),(104080,133),(104081,134),(104082,135),(104083,136),(104084,137),(104085,16),(104086,94),(104087,145),(104088,147),(104089,148),(104090,153),(104091,164),(104092,166),(104093,172),(104094,256),(104095,257),(104096,100),(104097,104),(104098,138),(104099,154),(104100,155),(104101,244),(104102,251),(104103,139),(104104,160),(104105,161),(104106,169),(104107,171),(104108,173),(104109,175),(104110,221),(104111,222),(104112,223),(104113,276),(104114,277),(104115,278),(104116,279),(104117,240),(104118,241),(104119,242),(104120,243),(104121,254),(104122,255),(104123,258),(104124,259),(104125,260),(104126,261),(104127,280),(104128,106),(104129,162),(104130,262),(104131,263),(104132,264),(104133,265),(104134,110),(104135,111),(104136,112),(104137,114),(104138,115),(104139,116),(104140,157),(104141,159),(104142,188),(104143,189),(104144,48),(104145,49),(104146,50),(104147,51),(104148,52),(104149,106),(104150,123),(104151,124),(104152,125),(104153,126),(104154,140),(104155,156),(104156,158),(104157,255),(104158,245),(104159,268),(104160,269),(104161,270),(104162,271),(104163,272),(104164,273),(104165,274),(104166,275),(104167,4524),(104168,176),(104169,177),(104170,178),(104171,180),(104172,183),(104173,184),(104174,185),(104175,186),(104176,179),(104177,181),(104178,187),(104179,188),(104180,189),(104181,206),(104182,207),(104183,208),(104184,162),(104185,190),(104186,193),(104187,194),(104188,195),(104189,196),(104190,197),(104191,202),(104192,209),(104193,210),(104194,139),(104195,169),(104196,173),(104197,175),(104198,221),(104199,222),(104200,223),(104201,5465),(104202,5466),(104203,5467),(104204,5525),(104205,5551),(104206,5552),(104207,5561),(104208,5562),(104209,5565),(104210,5572),(104211,5573),(104212,5574),(104213,5575),(104214,5576),(104215,5578),(104216,5579),(104217,5582),(104218,5583),(104219,5584),(104220,5456),(104221,5459),(104222,5460),(104223,5462),(104224,5577),(104225,5580),(104226,5581),(104227,5585),(104228,5702),(104229,5703),(104230,5707),(104231,5708),(104232,1145),(104233,1146),(104234,1147),(104235,5271),(104236,5272),(104237,5273),(104238,5655),(104239,5656),(104240,5657),(104241,5385),(104242,5433),(104243,5451),(104244,5453),(104245,5454),(104246,5455),(104247,5468),(104248,5301),(104249,2276),(104250,4552),(104251,4561),(104252,4564),(104253,4565),(104254,5155),(104255,5248),(104256,5249),(104257,5154),(104258,4545),(104259,4562),(104260,5151),(104261,5152),(104262,4539),(104263,4543),(104264,4544),(104265,4546),(104266,4970),(104267,5153),(104268,5157),(104269,5158),(104270,5183),(104271,2389),(104272,4540),(104273,4541),(104274,4542),(104275,4547),(104276,4548),(104277,4549),(104278,4550),(104279,4551),(104280,4553),(104281,4554),(104282,4555),(104283,4556),(104284,4557),(104285,4558),(104286,4559),(104287,4560),(104288,4539),(104289,4545),(104290,4547),(104291,4548),(104292,4549),(104293,4552),(104294,4553),(104295,4563),(104296,5151),(104297,5152),(104298,5153),(104299,5156),(104300,5157),(104301,5158),(104302,5248),(104303,4539),(104304,4545),(104305,4552),(104306,4561),(104307,4562),(104308,4564),(104309,4565),(104310,4970),(104311,5249),(104312,4543),(104313,4544),(104314,4546),(104315,4547),(104316,4548),(104317,4549),(104318,4550),(104319,4551),(104320,4553),(104321,4554),(104322,4555),(104323,4540),(104324,4541),(104325,4542),(104326,4556),(104327,4557),(104328,4558),(104329,4559),(104330,4560),(104331,5183),(104332,5154),(104333,5155),(104334,1615),(104335,1775),(104336,1615),(104337,1775),(104338,1615),(104339,1775),(104340,2289),(104341,4492),(104342,4493),(104343,4494),(104344,4529),(104345,4884),(104346,4885),(104347,1158),(104348,1159),(104349,4495),(104350,4496),(104351,4497),(104352,4498),(104353,4499),(104354,4532),(104355,4537),(104356,4877),(104357,4878),(104358,4879),(104359,4880),(104360,5257),(104361,1160),(104362,1161),(104363,4491),(104364,4528),(104365,1866),(104366,1867),(104367,1868),(104368,1875),(104369,1876),(104370,1877),(104371,1878),(104372,1879),(104373,1880),(104374,1881),(104375,1882),(104376,1883),(104377,1884),(104378,1936),(104379,1937),(104380,1938),(104381,1992),(104382,1993),(104383,1493),(104384,1994),(104385,1995),(104386,1996),(104387,1997),(104388,1998),(104389,1999),(104390,2000),(104391,2001),(104392,2002),(104393,2289),(104394,2290),(104395,1836),(104396,1843),(104397,1848),(104398,1856),(104399,1860),(104400,1862),(104401,1869),(104402,1885),(104403,2291),(104404,2293),(104405,1886),(104406,1898),(104407,1913),(104408,1930),(104409,1939),(104410,1940),(104411,1945),(104412,5524),(104413,2330),(104414,2331),(104415,2332),(104416,2333),(104417,2334),(104418,2335),(104419,2336),(104420,2341),(104421,2342),(104422,2343),(104423,2133),(104424,2134),(104425,2139),(104426,2140),(104427,2141),(104428,2142),(104429,2337),(104430,2338),(104431,2339),(104432,2340),(104433,3515),(104434,4552),(104435,2143),(104436,2144),(104437,2145),(104438,2146),(104439,2147),(104440,2148),(104441,2149),(104442,2150),(104443,2151),(104444,2152),(104445,2153),(104446,2325),(104447,2326),(104448,2327),(104449,2328),(104450,2329),(104451,2344),(104452,2345),(104453,2346),(104454,2347),(104455,2348),(104456,2349),(104457,2350),(104458,2351),(104459,2352),(104460,2353),(104461,2354),(104462,2355),(104463,2356),(104464,2357),(104465,2358),(104466,2359),(104467,2360),(104468,2361),(104469,2362),(104470,2363),(104471,2364),(104472,2365),(104473,2366),(104474,2367),(104475,2368),(104476,2369),(104477,2370),(104478,2371),(104479,2372),(104480,2373),(104481,2374),(104482,2515),(104483,2516),(104484,1959),(104485,1960),(104486,1961),(104487,1963),(104488,1964),(104489,2413),(104490,2414),(104491,2415),(104492,2416),(104493,2417),(104494,2418),(104495,2419),(104496,2420),(104497,2421),(104498,2422),(104499,2423),(104500,2424),(104501,2425),(104502,2426),(104503,2537),(104504,2538),(104505,2816),(104506,2818),(104507,4550),(104508,4551),(104509,4553),(104510,4554),(104511,4555),(104512,4558),(104513,2002),(104514,2275),(104515,2379),(104516,2383),(104517,2384),(104518,2390),(104519,2559),(104520,4559),(104521,2375),(104522,2376),(104523,2380),(104524,2381),(104525,2387),(104526,2454),(104527,2455),(104528,2456),(104529,2135),(104530,2136),(104531,2137),(104532,2138),(104533,2382),(104534,3549),(104535,3550),(104536,3581),(104537,3582),(104538,2026),(104539,2027),(104540,2028),(104541,2029),(104542,2034),(104543,2039),(104544,2040),(104545,2030),(104546,2031),(104547,2032),(104548,2042),(104549,2044),(104550,2045),(104551,2046),(104552,2122),(104553,2123),(104554,2124),(104555,2125),(104556,2377),(104557,2378),(104558,2385),(104559,2386),(104560,2388),(104561,2389),(104562,2391),(104563,2133),(104564,2134),(104565,2139),(104566,2140),(104567,2141),(104568,2142),(104569,2143),(104570,2144),(104571,2145),(104572,2146),(104573,2147),(104574,2148),(104575,2149),(104576,2150),(104577,2151),(104578,2152),(104579,2153),(104580,2325),(104581,2326),(104582,2327),(104583,2328),(104584,2329),(104585,2355),(104586,2356),(104587,2357),(104588,2358),(104589,2359),(104590,2360),(104591,2361),(104592,2362),(104593,2363),(104594,2364),(104595,2365),(104596,2366),(104597,2367),(104598,2368),(104599,2369),(104600,2370),(104601,2371),(104602,2372),(104603,2275),(104604,2373),(104605,2374),(104606,2417),(104607,2418),(104608,2419),(104609,2420),(104610,2421),(104611,2422),(104612,2423),(104613,2424),(104614,2425),(104615,2426),(104616,2537),(104617,2538),(104618,2135),(104619,2375),(104620,2376),(104621,2379),(104622,2380),(104623,2381),(104624,2383),(104625,2384),(104626,2387),(104627,2390),(104628,2456),(104629,2559),(104630,2136),(104631,2137),(104632,2138),(104633,2377),(104634,2378),(104635,2385),(104636,2386),(104637,2388),(104638,2391),(104639,2330),(104640,2331),(104641,2332),(104642,2333),(104643,2334),(104644,2335),(104645,2336),(104646,2340),(104647,2341),(104648,2342),(104649,2343),(104650,2337),(104651,2338),(104652,2339),(104653,2344),(104654,2345),(104655,2346),(104656,2347),(104657,2348),(104658,2349),(104659,1959),(104660,1960),(104661,1961),(104662,1963),(104663,1964),(104664,2350),(104665,2351),(104666,2352),(104667,2353),(104668,2354),(104669,2413),(104670,2414),(104671,2515),(104672,2516),(104673,2026),(104674,2027),(104675,2028),(104676,2029),(104677,2034),(104678,2039),(104679,2382),(104680,2415),(104681,2416),(104682,2454),(104683,2455),(104684,2030),(104685,2031),(104686,2040),(104687,2042),(104688,2044),(104689,2045),(104690,2046),(104691,2032),(104692,2122),(104693,2123),(104694,2124),(104695,2125),(104696,2389),(104697,4608),(104698,4837),(104699,4942),(104700,5029),(104701,5030),(104702,5031),(104703,5032),(104704,5033),(104705,4955),(104706,4956),(104707,4967),(104708,5097),(104709,5100),(104710,5111),(104711,5116),(104712,5117),(104713,5119),(104714,5120),(104715,5121),(104716,1658),(104717,1659),(104718,1660),(104719,4818),(104720,4820),(104721,5118),(104722,4718),(104723,4838),(104724,5028),(104725,4730),(104726,4812),(104727,4813),(104728,4815),(104729,4822),(104730,4845),(104731,4942),(104732,4589),(104733,4590),(104734,4591),(104735,4592),(104736,4593),(104737,4594),(104738,4595),(104739,4596),(104740,4597),(104741,4598),(104742,4599),(104743,4818),(104744,4820),(104745,4841),(104746,4842),(104747,5101),(104748,5113),(104749,4582),(104750,4583),(104751,4584),(104752,4585),(104753,4586),(104754,4587),(104755,4834),(104756,4835),(104757,4836),(104758,4608),(104759,5116),(104760,5117),(104761,5118),(104762,5119),(104763,5120),(104764,4588),(104765,4600),(104766,4601),(104767,4602),(104768,4603),(104769,5029),(104770,5030),(104771,5031),(104772,5032),(104773,5033),(104774,4604),(104775,4608),(104776,4718),(104777,4839),(104778,4840),(104779,5097),(104780,5110),(104781,5111),(104782,4816),(104783,4967),(104784,5100),(104785,5250),(104786,5739),(104787,5740),(104788,5741),(104789,5742),(104790,5743),(104791,5744),(104792,1651),(104793,1652),(104794,1653),(104795,5103),(104796,5104),(104797,5251),(104798,5252),(104799,5253),(104800,5255),(104801,1650),(104802,1703),(104803,1704),(104804,1737),(104805,1738),(104806,4612),(104807,5254),(104808,4813),(104809,4837),(104810,4955),(104811,4956),(104812,5097),(104813,5098),(104814,5101),(104815,5110),(104816,5111),(104817,5116),(104818,4730),(104819,4812),(104820,4818),(104821,4822),(104822,4845),(104823,5117),(104824,5118),(104825,1687),(104826,1780),(104827,1660),(104828,1689),(104829,1692),(104830,1695),(104831,5090),(104832,1691),(104833,1687),(104834,1689),(104835,1691),(104836,1692),(104837,1695),(104838,1696),(104839,1750),(104840,1759),(104841,1760),(104842,5090),(104843,1659),(104844,1688),(104845,1740),(104846,1743),(104847,1690),(104848,4838),(104849,5028),(104850,5098),(104851,5099),(104852,5121),(104853,4812),(104854,4813),(104855,4814),(104856,4815),(104857,4817),(104858,4942),(104859,4969),(104860,5461),(104861,4821),(104862,4822),(104863,5093),(104864,5094),(104865,5095),(104866,5096),(104867,4589),(104868,4590),(104869,4591),(104870,4592),(104871,4593),(104872,4594),(104873,5034),(104874,5035),(104875,5036),(104876,4595),(104877,4596),(104878,4597),(104879,4598),(104880,4599),(104881,4718),(104882,4841),(104883,4842),(104884,5101),(104885,4819),(104886,5078),(104887,5080),(104888,5081),(104889,5084),(104890,5102),(104891,5112),(104892,4582),(104893,4583),(104894,4584),(104895,4585),(104896,4586),(104897,4587),(104898,4834),(104899,4835),(104900,4836),(104901,2219),(104902,2220),(104903,2261),(104904,2307),(104905,2308),(104906,2310),(104907,2251),(104908,2260),(104909,2309),(104910,2312),(104911,2313),(104912,2314),(104913,2316),(104914,2461),(104915,2259),(104916,2460),(104917,2462),(104918,2463),(104919,2504),(104920,2505),(104921,2201),(104922,2202),(104923,2214),(104924,2215),(104925,2216),(104926,2217),(104927,2218),(104928,2187),(104929,2188),(104930,2190),(104931,2192),(104932,2194),(104933,2197),(104934,2232),(104935,2233),(104936,2234),(104937,2237),(104938,2238),(104939,2236),(104940,2392),(104941,2393),(104942,2394),(104943,2395),(104944,2411),(104945,2412),(104946,2577),(104947,2578),(104948,2579),(104949,2580),(104950,5123),(104951,5124),(104952,5125),(104953,5126),(104954,5127),(104955,5129),(104956,5130),(104957,5131),(104958,5148),(104959,5149),(104960,5150),(104961,2256),(104962,2305),(104963,5128),(104964,5136),(104965,5167),(104966,2208),(104967,2209),(104968,2304),(104969,2458),(104970,2459),(104971,2503),(104972,4860),(104973,5203),(104974,5204),(104975,5205),(104976,5230),(104977,5105),(104978,5207),(104979,5208),(104980,5209),(104981,5210),(104982,5212),(104983,5213),(104984,5214),(104985,5215),(104986,5216),(104987,5217),(104988,5218),(104989,5229),(104990,5234),(104991,5235),(104992,5236),(104993,4714),(104994,4715),(104995,4716),(104996,4717),(104997,4724),(104998,4809),(104999,4810),(105000,4811),(105001,4843),(105002,4851),(105003,5237),(105004,4668),(105005,4669),(105006,4688),(105007,4689),(105008,4691),(105009,4693),(105010,4696),(105011,4698),(105012,4699),(105013,4700),(105014,4705),(105015,4706),(105016,4707),(105017,4708),(105018,4709),(105019,4636),(105020,4638),(105021,4641),(105022,4642),(105023,4643),(105024,4644),(105025,4674),(105026,4675),(105027,4690),(105028,4692),(105029,4694),(105030,4697),(105031,4710),(105032,4712),(105033,4645),(105034,4646),(105035,4647),(105036,4648),(105037,4649),(105038,4652),(105039,4654),(105040,4656),(105041,4657),(105042,4658),(105043,4659),(105044,4660),(105045,4661),(105046,4662),(105047,4663),(105048,4665),(105049,4667),(105050,5045),(105051,5046),(105052,5055),(105053,5056),(105054,5060),(105055,5061),(105056,5041),(105057,5043),(105058,5047),(105059,5048),(105060,5049),(105061,5050),(105062,5051),(105063,5052),(105064,5054),(105065,5057),(105066,5058),(105067,5059),(105068,2399),(105069,2400),(105070,2401),(105071,2403),(105072,2591),(105073,2592),(105074,2605),(105075,4628),(105076,4731),(105077,4734),(105078,4739),(105079,4744),(105080,4747),(105081,4748),(105082,4757),(105083,4766),(105084,4767),(105085,4768),(105086,4773),(105087,4774),(105088,4775),(105089,4776),(105090,4781),(105091,2204),(105092,2205),(105093,2206),(105094,2318),(105095,2321),(105096,2322),(105097,4613),(105098,4614),(105099,4769),(105100,4782),(105101,4783),(105102,4784),(105103,4790),(105104,4792),(105105,4794),(105106,4796),(105107,4802),(105108,4873),(105109,2200),(105110,2210),(105111,2614),(105112,4639),(105113,4664),(105114,4680),(105115,4719),(105116,4952),(105117,5202),(105118,5211),(105119,5220),(105120,5224),(105121,5225),(105122,2163),(105123,2248),(105124,2270),(105125,2271),(105126,2300),(105127,2301),(105128,2311),(105129,2440),(105130,2441),(105131,2442),(105132,2489),(105133,2497),(105134,2506),(105135,2507),(105136,2508),(105137,2509),(105138,2511),(105139,2512),(105140,2609),(105141,4722),(105142,4740),(105143,4770),(105144,5044),(105145,5053),(105146,5065),(105147,5066),(105148,5072),(105149,2024),(105150,2226),(105151,2472),(105152,2473),(105153,2475),(105154,2476),(105155,2490),(105156,2491),(105157,4764),(105158,4872),(105159,4957),(105160,4958),(105161,4959),(105162,4960),(105163,4961),(105164,4962),(105165,1711),(105166,4777),(105167,4778),(105168,4779),(105169,4780),(105170,2311),(105171,4764),(105172,4957),(105173,4958),(105174,4959),(105175,4960),(105176,4961),(105177,4962),(105178,5106),(105179,5107),(105180,5108),(105181,5109),(105182,2251),(105183,2260),(105184,2307),(105185,2308),(105186,2309),(105187,2310),(105188,2312),(105189,2313),(105190,2314),(105191,2316),(105192,2188),(105193,2190),(105194,2192),(105195,2194),(105196,2197),(105197,2460),(105198,2461),(105199,2462),(105200,2463),(105201,2504),(105202,2505),(105203,2187),(105204,2245),(105205,2256),(105206,2304),(105207,2305),(105208,2306),(105209,2315),(105210,2396),(105211,2411),(105212,2412),(105213,2458),(105214,2459),(105215,2503),(105216,2577),(105217,2578),(105218,2579),(105219,2580),(105220,2191),(105221,2193),(105222,2195),(105223,2198),(105224,2235),(105225,2240),(105226,2246),(105227,2257),(105228,2302),(105229,2303),(105230,2311),(105231,2581),(105232,5123),(105233,5124),(105234,5130),(105235,5131),(105236,5148),(105237,5149),(105238,5150),(105239,5125),(105240,5126),(105241,5127),(105242,5128),(105243,5129),(105244,5136),(105245,5167),(105246,5203),(105247,5204),(105248,5205),(105249,5217),(105250,5229),(105251,5230),(105252,5105),(105253,5207),(105254,5208),(105255,5209),(105256,5210),(105257,5212),(105258,5213),(105259,5214),(105260,5215),(105261,5216),(105262,5218),(105263,5234),(105264,5235),(105265,4714),(105266,4715),(105267,4716),(105268,4717),(105269,4724),(105270,4809),(105271,4810),(105272,4811),(105273,5236),(105274,5237),(105275,4719),(105276,4722),(105277,4843),(105278,4851),(105279,4873),(105280,5166),(105281,5202),(105282,5211),(105283,5220),(105284,5224),(105285,5225),(105286,5122),(105287,5137),(105288,5138),(105289,5139),(105290,5142),(105291,5147),(105292,5159),(105293,5160),(105294,5161),(105295,5163),(105296,5164),(105297,5168),(105298,5222),(105299,5231),(105300,5232),(105301,5233),(105302,4720),(105303,4723),(105304,4846),(105305,4847),(105306,4848),(105307,4849),(105308,4850),(105309,4852),(105310,4856),(105311,5141),(105312,5206),(105313,5219),(105314,5221),(105315,5223),(105316,5226),(105317,5227),(105318,5228),(105319,4721),(105320,4725),(105321,4726),(105322,4727),(105323,4728),(105324,4729),(105325,4777),(105326,4844),(105327,5140),(105328,5162),(105329,5165),(105330,4778),(105331,4779),(105332,4780),(105333,4823),(105334,4872),(105335,5106),(105336,5107),(105337,5108),(105338,5109),(105339,2245),(105340,2201),(105341,2202),(105342,2214),(105343,2215),(105344,2216),(105345,2217),(105346,2218),(105347,2219),(105348,2220),(105349,2232),(105350,2233),(105351,2234),(105352,2236),(105353,2237),(105354,2238),(105355,2251),(105356,2259),(105357,2260),(105358,2261),(105359,2200),(105360,2208),(105361,2209),(105362,2210),(105363,2246),(105364,2256),(105365,2258),(105366,2392),(105367,2393),(105368,2394),(105369,2395),(105370,2396),(105371,2459),(105372,4621),(105373,4627),(105374,4628),(105375,1575),(105376,1576),(105377,1577),(105378,1580),(105379,1581),(105380,1582),(105381,1583),(105382,1708),(105383,1709),(105384,1710),(105385,1711),(105386,1712),(105387,1714),(105388,1578),(105389,1579),(105390,1713),(105391,2265),(105392,2266),(105393,2267),(105394,2268),(105395,2269),(105396,2276),(105397,2320),(105398,2397),(105399,2398),(105400,2400),(105401,2401),(105402,2403),(105403,2405),(105404,2406),(105405,2407),(105406,2408),(105407,2409),(105408,2410),(105409,2589),(105410,2590),(105411,2591),(105412,2592),(105413,2593),(105414,2594),(105415,2595),(105416,2598),(105417,2599),(105418,2600),(105419,2601),(105420,2602),(105421,2603),(105422,2604),(105423,2605),(105424,2606),(105425,2607),(105426,2318),(105427,2319),(105428,2321),(105429,2322),(105430,2608),(105431,2610),(105432,2611),(105433,2612),(105434,2613),(105435,2317),(105436,2596),(105437,2597),(105438,2609),(105439,2614),(105440,2399),(105441,4860),(105442,4668),(105443,4688),(105444,4689),(105445,4691),(105446,4693),(105447,4696),(105448,4698),(105449,4699),(105450,4700),(105451,4705),(105452,4706),(105453,4669),(105454,4690),(105455,4694),(105456,4697),(105457,4707),(105458,4708),(105459,4709),(105460,4710),(105461,4712),(105462,4636),(105463,4638),(105464,4641),(105465,4642),(105466,4643),(105467,4644),(105468,4645),(105469,4646),(105470,4647),(105471,4648),(105472,4674),(105473,4675),(105474,4692),(105475,4649),(105476,4652),(105477,4654),(105478,4656),(105479,4657),(105480,4658),(105481,4659),(105482,4660),(105483,4661),(105484,4662),(105485,4663),(105486,4665),(105487,4667),(105488,5045),(105489,5046),(105490,5047),(105491,5048),(105492,5049),(105493,5051),(105494,5052),(105495,5055),(105496,5056),(105497,5057),(105498,5058),(105499,5060),(105500,5061),(105501,2605),(105502,4731),(105503,4734),(105504,4739),(105505,4744),(105506,4747),(105507,4748),(105508,4757),(105509,5041),(105510,5043),(105511,5050),(105512,5054),(105513,5059),(105514,4613),(105515,4614),(105516,4639),(105517,4664),(105518,4680),(105519,4766),(105520,4767),(105521,4768),(105522,4769),(105523,4773),(105524,4774),(105525,4775),(105526,4776),(105527,4781),(105528,4782),(105529,4783),(105530,4784),(105531,4790),(105532,4792),(105533,4794),(105534,4796),(105535,4802),(105536,4804),(105537,4952),(105538,4676),(105539,4687),(105540,4695),(105541,4701),(105542,4702),(105543,4703),(105544,4704),(105545,4740),(105546,5044),(105547,5053),(105548,5065),(105549,5066),(105550,5072),(105551,4673),(105552,4711),(105553,4713),(105554,4944),(105555,4949),(105556,4953),(105557,4637),(105558,4640),(105559,4650),(105560,4651),(105561,4655),(105562,4666),(105563,4943),(105564,4945),(105565,4946),(105566,4947),(105567,4948),(105568,4950),(105569,4951),(105570,4635),(105571,4653),(105572,4671),(105573,4735),(105574,4741),(105575,4742),(105576,4754),(105577,4759),(105578,4762),(105579,4763),(105580,4771),(105581,4786),(105582,4795),(105583,4857),(105584,4858),(105585,4859),(105586,4861),(105587,4867),(105588,4868),(105589,5039),(105590,5040),(105591,5042),(105592,5070),(105593,5071),(105594,4629),(105595,4630),(105596,4631),(105597,4632),(105598,4633),(105599,4634),(105600,4670),(105601,4672),(105602,4770),(105603,4862),(105604,4863),(105605,4864),(105606,4865),(105607,4866),(105608,4876),(105609,5069),(105610,4732),(105611,4736),(105612,4746),(105613,4758),(105614,4760),(105615,4787),(105616,4789),(105617,4797),(105618,4799),(105619,5067),(105620,5068),(105621,4743),(105622,4749),(105623,4750),(105624,4751),(105625,4752),(105626,4753),(105627,4761),(105628,4772),(105629,4785),(105630,4788),(105631,4798),(105632,4800),(105633,4801),(105634,4803),(105635,4733),(105636,4737),(105637,4738),(105638,4745),(105639,4755),(105640,4764),(105641,4765),(105642,4791),(105643,4793),(105644,4954),(105645,4957),(105646,4958),(105647,4959),(105648,4960),(105649,4961),(105650,4962),(105651,4756),(105652,4869),(105653,4870),(105654,4871),(105655,4874),(105656,4875),(105657,4891),(105658,4892),(105659,4893),(105660,4894),(105661,4895),(105662,1791),(105663,1792),(105664,1798),(105665,1803),(105666,1805),(105667,1806),(105668,1807),(105669,1808),(105670,1809),(105671,1810),(105672,1811),(105673,1748),(105674,1791),(105675,1792),(105676,1798),(105677,1803),(105678,1804),(105679,1805),(105680,1809),(105681,1806),(105682,1807),(105683,1808),(105684,1810),(105685,1811),(105686,5178),(105687,5180),(105688,5181),(105689,5191),(105690,5192),(105691,5193),(105692,5178),(105693,5179),(105694,5180),(105695,5182),(105696,5190),(105697,5192),(105698,5194),(105699,5197),(105700,5181),(105701,5191),(105702,5193),(105703,5195),(105704,5196),(105705,5199),(105706,4971),(105707,4973),(105708,4974),(105709,4976),(105710,4977),(105711,4982),(105712,4992),(105713,4993),(105714,4994),(105715,5009),(105716,5025),(105717,4972),(105718,4979),(105719,4980),(105720,4981),(105721,4983),(105722,4984),(105723,4985),(105724,4986),(105725,4987),(105726,4988),(105727,4989),(105728,4990),(105729,4991),(105730,5001),(105731,5002),(105732,4995),(105733,4996),(105734,4997),(105735,4998),(105736,4999),(105737,5000),(105738,5005),(105739,5008),(105740,5011),(105741,5012),(105742,5019),(105743,4975),(105744,4978),(105745,5003),(105746,5004),(105747,5006),(105748,5007),(105749,5010),(105750,5013),(105751,5014),(105752,5015),(105753,5016),(105754,5022),(105755,5024),(105756,4972),(105757,4973),(105758,4976),(105759,4977),(105760,4983),(105761,4984),(105762,4985),(105763,4986),(105764,4987),(105765,4988),(105766,4989),(105767,4990),(105768,4991),(105769,4996),(105770,4998),(105771,5002),(105772,4997),(105773,4999),(105774,5000),(105775,5005),(105776,5008),(105777,5011),(105778,5012),(105779,5013),(105780,5014),(105781,5015),(105782,5016),(105783,4971),(105784,4981),(105785,4982),(105786,4992),(105787,4993),(105788,4994),(105789,5001),(105790,5009),(105791,5025),(105792,4979),(105793,4980),(105794,4995),(105795,5003),(105796,5004),(105797,5006),(105798,5007),(105799,5010),(105800,5019),(105801,5022),(105802,5024),(105803,4896),(105804,4898),(105805,4899),(105806,4900),(105807,4901),(105808,4902),(105809,4903),(105810,4904),(105811,4905),(105812,4906),(105813,4907),(105814,4908),(105815,4909),(105816,4910),(105817,4911),(105818,4972),(105819,1679),(105820,1680),(105821,5021),(105822,5023),(105823,5026),(105824,5027),(105825,4973),(105826,4975),(105827,4976),(105828,4977),(105829,4978),(105830,2036),(105831,2086),(105832,2088),(105833,2174),(105834,2204),(105835,2252),(105836,2087),(105837,2094),(105838,2095),(105839,2096),(105840,2205),(105841,2206),(105842,2296),(105843,2510),(105844,2543),(105845,1953),(105846,1954),(105847,1955),(105848,2064),(105849,2089),(105850,2159),(105851,2494),(105852,2495),(105853,2497),(105854,2059),(105855,2103),(105856,2106),(105857,2107),(105858,2108),(105859,2109),(105860,2110),(105861,2111),(105862,2112),(105863,2452),(105864,2555),(105865,2621),(105866,2104),(105867,2163),(105868,2248),(105869,2270),(105870,2271),(105871,2441),(105872,2442),(105873,2477),(105874,2478),(105875,2479),(105876,2507),(105877,2508),(105878,2509),(105879,2025),(105880,2226),(105881,2230),(105882,2300),(105883,2301),(105884,2472),(105885,2473),(105886,2475),(105887,2476),(105888,2489),(105889,2490),(105890,2491),(105891,2511),(105892,2512),(105893,1816),(105894,1818),(105895,1822),(105896,1827),(105897,1965),(105898,1966),(105899,2008),(105900,2013),(105901,2014),(105902,1972),(105903,1973),(105904,1974),(105905,1977),(105906,1978),(105907,1983),(105908,1984),(105909,1986),(105910,1988),(105911,2035),(105912,2037),(105913,2041),(105914,1975),(105915,1976),(105916,1979),(105917,1980),(105918,1982),(105919,1985),(105920,1987),(105921,1989),(105922,1990),(105923,1813),(105924,1814),(105925,1815),(105926,1820),(105927,1821),(105928,1824),(105929,1825),(105930,1826),(105931,1817),(105932,1819),(105933,1823),(105934,1828),(105935,1981),(105936,2021),(105937,2022),(105938,2154),(105939,2177),(105940,2221),(105941,2222),(105942,2299),(105943,2435),(105944,2531),(105945,2540),(105946,2541),(105947,2542),(105948,2066),(105949,2067),(105950,2068),(105951,2069),(105952,2078),(105953,2100),(105954,2165),(105955,2166),(105956,2169),(105957,2070),(105958,2071),(105959,2072),(105960,2073),(105961,2074),(105962,2075),(105963,2076),(105964,2077),(105965,2079),(105966,2097),(105967,2098),(105968,2099),(105969,2101),(105970,2167),(105971,2049),(105972,2050),(105973,2051),(105974,2052),(105975,2053),(105976,2054),(105977,2055),(105978,2056),(105979,2060),(105980,2085),(105981,2168),(105982,2252),(105983,2253),(105984,2254),(105985,2255),(105986,2003),(105987,2004),(105988,2005),(105989,2006),(105990,2012),(105991,2015),(105992,2016),(105993,2038),(105994,2272),(105995,2273),(105996,2274),(105997,2009),(105998,2010),(105999,2011),(106000,2057),(106001,2058),(106002,2170),(106003,2171),(106004,2172),(106005,2173),(106006,2174),(106007,2175),(106008,2297),(106009,2298),(106010,2444),(106011,2445),(106012,2446),(106013,2447),(106014,2448),(106015,2485),(106016,2487),(106017,2615),(106018,2247),(106019,2429),(106020,2430),(106021,2431),(106022,2513),(106023,2514),(106024,2521),(106025,2522),(106026,2523),(106027,2524),(106028,2525),(106029,2526),(106030,2527),(106031,2528),(106032,2539),(106033,2573),(106034,2574),(106035,2575),(106036,2576),(106037,2017),(106038,2018),(106039,2019),(106040,2020),(106041,2062),(106042,2063),(106043,2080),(106044,2158),(106045,2160),(106046,2161),(106047,2164),(106048,2176),(106049,2180),(106050,2207),(106051,2249),(106052,2250),(106053,2474),(106054,2482),(106055,2484),(106056,2486),(106057,2543),(106058,2544),(106059,2545),(106060,2546),(106061,2047),(106062,2048),(106063,2116),(106064,2117),(106065,2118),(106066,2119),(106067,2184),(106068,2185),(106069,2186),(106070,2225),(106071,2227),(106072,2228),(106073,2229),(106074,2231),(106075,2483),(106076,2488),(106077,2553),(106078,2554),(106079,1955),(106080,2007),(106081,2065),(106082,2081),(106083,2082),(106084,2083),(106085,2090),(106086,2091),(106087,2159),(106088,2223),(106089,2296),(106090,2494),(106091,2495),(106092,2496),(106093,2497),(106094,2510),(106095,1953),(106096,1954),(106097,1956),(106098,1957),(106099,2059),(106100,2064),(106101,2089),(106102,2103),(106103,2106),(106104,2107),(106105,2108),(106106,2109),(106107,2110),(106108,2111),(106109,2112),(106110,2492),(106111,2493),(106112,2498),(106113,2499),(106114,2555),(106115,1991),(106116,2024),(106117,2025),(106118,2033),(106119,2061),(106120,2084),(106121,2102),(106122,2104),(106123,2105),(106124,2120),(106125,2121),(106126,2163),(106127,2226),(106128,2248),(106129,2270),(106130,2271),(106131,2441),(106132,2472),(106133,2473),(106134,2506),(106135,2507),(106136,2508),(106137,2509),(106138,2511),(106139,2536),(106140,2512),(106141,2066),(106142,2067),(106143,2068),(106144,2069),(106145,2070),(106146,2078),(106147,2079),(106148,2100),(106149,2101),(106150,2165),(106151,2166),(106152,2169),(106153,2616),(106154,2617),(106155,2618),(106156,2049),(106157,2050),(106158,2051),(106159,2052),(106160,2053),(106161,2056),(106162,2071),(106163,2072),(106164,2073),(106165,2074),(106166,2075),(106167,2076),(106168,2077),(106169,2097),(106170,2098),(106171,2099),(106172,2167),(106173,2168),(106174,2253),(106175,2254),(106176,2005),(106177,2006),(106178,2012),(106179,2015),(106180,2016),(106181,2054),(106182,2055),(106183,2060),(106184,2085),(106185,2255),(106186,2264),(106187,2272),(106188,2273),(106189,2274),(106190,2283),(106191,2284),(106192,2465),(106193,2003),(106194,2004),(106195,2009),(106196,2010),(106197,2011),(106198,2057),(106199,2058),(106200,2170),(106201,2171),(106202,2172),(106203,2173),(106204,2175),(106205,2199),(106206,2281),(106207,2294),(106208,2297),(106209,2298),(106210,2444),(106211,2445),(106212,2466),(106213,2467),(106214,2468),(106215,2469),(106216,2470),(106217,2471),(106218,2552),(106219,2556),(106220,2557),(106221,2558),(106222,2562),(106223,2563),(106224,2566),(106225,2567),(106226,2568),(106227,2569),(106228,2570),(106229,2571),(106230,2615),(106231,2247),(106232,2429),(106233,2446),(106234,2447),(106235,2448),(106236,2485),(106237,2487),(106238,2513),(106239,2514),(106240,2521),(106241,2523),(106242,2529),(106243,2530),(106244,2539),(106245,2584),(106246,2586),(106247,2587),(106248,2522),(106249,2524),(106250,2525),(106251,2526),(106252,2527),(106253,2528),(106254,2573),(106255,2574),(106256,2575),(106257,2576),(106258,2164),(106259,2176),(106260,2203),(106261,2205),(106262,2206),(106263,2207),(106264,2249),(106265,2250),(106266,2277),(106267,2278),(106268,2279),(106269,2280),(106270,2430),(106271,2431),(106272,2532),(106273,2533),(106274,2534),(106275,2535),(106276,2547),(106277,2548),(106278,2549),(106279,2550),(106280,2551),(106281,2158),(106282,2160),(106283,2161),(106284,2162),(106285,2181),(106286,2183),(106287,2292),(106288,2295),(106289,2432),(106290,2474),(106291,2543),(106292,2544),(106293,2545),(106294,2546),(106295,2017),(106296,2062),(106297,2063),(106298,2080),(106299,2178),(106300,2179),(106301,2180),(106302,2263),(106303,2285),(106304,2433),(106305,2434),(106306,2436),(106307,2437),(106308,2438),(106309,2450),(106310,2482),(106311,2484),(106312,2486),(106313,2018),(106314,2019),(106315,2020),(106316,2047),(106317,2048),(106318,2116),(106319,2117),(106320,2118),(106321,2119),(106322,2451),(106323,2453),(106324,2501),(106325,2502),(106326,2560),(106327,2561),(106328,2565),(106329,2184),(106330,2185),(106331,2186),(106332,2212),(106333,2225),(106334,2227),(106335,2228),(106336,2229),(106337,2231),(106338,2282),(106339,2483),(106340,2517),(106341,2518),(106342,2519),(106343,2520),(106344,2619),(106345,2620),(106346,2296),(106347,2488),(106348,2553),(106349,2554),(106350,2582),(106351,2583),(106352,2585),(106353,1955),(106354,2007),(106355,2065),(106356,2081),(106357,2082),(106358,2083),(106359,2090),(106360,2091),(106361,2092),(106362,2093),(106363,2286),(106364,2287),(106365,2288),(106366,2496),(106367,2497),(106368,2510),(106369,2564),(106370,2572),(106371,1953),(106372,1954),(106373,1956),(106374,1957),(106375,1958),(106376,2059),(106377,2064),(106378,2089),(106379,2110),(106380,2111),(106381,2112),(106382,2159),(106383,2223),(106384,2492),(106385,2493),(106386,2494),(106387,2495),(106388,2498),(106389,2499),(106390,2555),(106391,2102),(106392,2103),(106393,2104),(106394,2106),(106395,2107),(106396,2108),(106397,2109),(106398,2163),(106399,2270),(106400,2271),(106401,2441),(106402,2452),(106403,2478),(106404,2480),(106405,2621),(106406,2248),(106407,2457),(106408,2506),(106409,2507),(106410,2508),(106411,2509),(106412,2511),(106413,2512),(106414,2536),(106415,2038),(106416,1),(106417,4),(106418,5),(106419,6),(106420,1162),(106421,1163),(106422,1164),(106423,1165),(106424,3835),(106425,4013),(106426,4014),(106427,4015),(106428,4016),(106429,4017),(106430,4018),(106431,4019),(106432,4020),(106433,4021),(106434,4022),(106435,4023),(106436,4024),(106437,4025),(106438,4026),(106439,4027),(106440,4028),(106441,4029),(106442,4030),(106443,4031),(106444,4032),(106445,4033),(106446,4034),(106447,4035),(106448,4036),(106449,4037),(106450,4127),(106451,4128),(106452,4129),(106453,4130),(106454,4132),(106455,4133),(106456,4211),(106457,3724),(106458,3733),(106459,3734),(106460,3735),(106461,3736),(106462,3737),(106463,3740),(106464,3746),(106465,4135),(106466,4156),(106467,4297),(106468,4298),(106469,4300),(106470,4301),(106471,4302),(106472,4303),(106473,4304),(106474,4458),(106475,4459),(106476,3719),(106477,3720),(106478,3723),(106479,3725),(106480,3726),(106481,3728),(106482,3731),(106483,3748),(106484,3751),(106485,3752),(106486,3753),(106487,3754),(106488,3755),(106489,3757),(106490,3758),(106491,3759),(106492,3760),(106493,3909),(106494,3721),(106495,3727),(106496,3732),(106497,3741),(106498,3743),(106499,3744),(106500,3749),(106501,3761),(106502,3762),(106503,3765),(106504,3942),(106505,3972),(106506,3978),(106507,3980),(106508,4080),(106509,4081),(106510,4082),(106511,4083),(106512,4084),(106513,4085),(106514,4088),(106515,4089),(106516,4196),(106517,4197),(106518,4198),(106519,4204),(106520,4205),(106521,4206),(106522,4207),(106523,3884),(106524,3889),(106525,3905),(106526,3917),(106527,3974),(106528,4208),(106529,4209),(106530,4210),(106531,4222),(106532,4226),(106533,4227),(106534,4228),(106535,4230),(106536,4231),(106537,4232),(106538,4233),(106539,4235),(106540,4237),(106541,4238),(106542,4247),(106543,4259),(106544,4275),(106545,4292),(106546,4425),(106547,3885),(106548,3894),(106549,3919),(106550,3920),(106551,3921),(106552,3922),(106553,3966),(106554,3968),(106555,4062),(106556,4121),(106557,4122),(106558,4249),(106559,4250),(106560,4252),(106561,4253),(106562,4255),(106563,4270),(106564,4336),(106565,4360),(106566,4418),(106567,4427),(106568,4063),(106569,4123),(106570,4124),(106571,4179),(106572,4180),(106573,4181),(106574,4182),(106575,4183),(106576,4184),(106577,4185),(106578,4187),(106579,4188),(106580,4189),(106581,4190),(106582,4191),(106583,3785),(106584,3786),(106585,4192),(106586,4215),(106587,4305),(106588,4309),(106589,4310),(106590,4316),(106591,4317),(106592,4070),(106593,4318),(106594,4319),(106595,4364),(106596,4366),(106597,4390),(106598,4391),(106599,4393),(106600,4394),(106601,4395),(106602,4396),(106603,4397),(106604,4398),(106605,4399),(106606,3715),(106607,3716),(106608,3750),(106609,3827),(106610,3828),(106611,3829),(106612,3830),(106613,3832),(106614,3833),(106615,3834),(106616,4092),(106617,4093),(106618,4096),(106619,4097),(106620,4400),(106621,4401),(106622,4460),(106623,4461),(106624,4462),(106625,4467),(106626,4469),(106627,4470),(106628,4474),(106629,4475),(106630,4120),(106631,4151),(106632,4162),(106633,4199),(106634,4200),(106635,4201),(106636,4271),(106637,4272),(106638,4273),(106639,4313),(106640,4430),(106641,4431),(106642,4457),(106643,3874),(106644,3918),(106645,3941),(106646,3963),(106647,4012),(106648,4043),(106649,4087),(106650,4090),(106651,4091),(106652,4095),(106653,4195),(106654,4214),(106655,4224),(106656,4225),(106657,4234),(106658,4236),(106659,4291),(106660,4306),(106661,4358),(106662,1641),(106663,1642),(106664,3722),(106665,3875),(106666,3876),(106667,3877),(106668,3878),(106669,3880),(106670,3892),(106671,4243),(106672,4244),(106673,4245),(106674,4294),(106675,4295),(106676,4436),(106677,4444),(106678,4446),(106679,4447),(106680,4448),(106681,4449),(106682,4450),(106683,4451),(106684,4452),(106685,4454),(106686,4455),(106687,4456),(106688,3729),(106689,3893),(106690,3895),(106691,3924),(106692,3925),(106693,3926),(106694,3927),(106695,3928),(106696,3931),(106697,3933),(106698,3934),(106699,3935),(106700,4086),(106701,4194),(106702,4229),(106703,4251),(106704,4254),(106705,4402),(106706,4403),(106707,4404),(106708,4413),(106709,4414),(106710,4415),(106711,3730),(106712,3738),(106713,3739),(106714,3742),(106715,3747),(106716,3763),(106717,3764),(106718,3831),(106719,3861),(106720,3964),(106721,3965),(106722,3975),(106723,3976),(106724,4052),(106725,4053),(106726,4219),(106727,4276),(106728,4417),(106729,4419),(106730,4065),(106731,4066),(106732,4069),(106733,4170),(106734,4171),(106735,4172),(106736,4173),(106737,4174),(106738,4175),(106739,4186),(106740,4202),(106741,4203),(106742,4212),(106743,5753),(106744,5753),(106745,5753),(106746,5753),(106747,5753),(106748,5753),(106749,5753),(106750,5753),(106751,5753),(106752,5753),(106753,4216),(106754,4217),(106755,4218),(106756,4220),(106757,4257),(106758,4277),(106759,4278),(106760,4279),(106761,4280),(106762,4282),(106763,4283),(106764,4287),(106765,4288),(106766,4289),(106767,4290),(106768,4315),(106769,4340),(106770,4342),(106771,4343),(106772,4392),(106773,3981),(106774,4054),(106775,4075),(106776,4077),(106777,4142),(106778,4150),(106779,4223),(106780,4434),(106781,4435),(106782,4437),(106783,4438),(106784,4439),(106785,4441),(106786,4442),(106787,4443),(106788,4445),(106789,3756),(106790,3982),(106791,3983),(106792,3984),(106793,3985),(106794,3986),(106795,3987),(106796,3988),(106797,4067),(106798,4068),(106799,4078),(106800,4261),(106801,4262),(106802,4308),(106803,4311),(106804,4312),(106805,4480),(106806,3923),(106807,3929),(106808,3936),(106809,3967),(106810,3969),(106811,4239),(106812,4240),(106813,4241),(106814,4256),(106815,4307),(106816,4346),(106817,4405),(106818,4407),(106819,4408),(106820,4410),(106821,4426),(106822,4473),(106823,4476),(106824,1630),(106825,1631),(106826,1632),(106827,1633),(106828,1634),(106829,1635),(106830,1682),(106831,1683),(106832,1686),(106833,4347),(106834,4349),(106835,4351),(106836,4353),(106837,4355),(106838,1681),(106839,1684),(106840,1685),(106841,3767),(106842,3882),(106843,3903),(106844,3973),(106845,4055),(106846,4059),(106847,4060),(106848,4094),(106849,4143),(106850,4152),(106851,4154),(106852,4168),(106853,3747),(106854,3718),(106855,3745),(106856,3769),(106857,3770),(106858,3772),(106859,3773),(106860,3774),(106861,3904),(106862,3989),(106863,4039),(106864,4041),(106865,4079),(106866,4293),(106867,4370),(106868,4373),(106869,4375),(106870,4378),(106871,4381),(106872,4383),(106873,4384),(106874,4385),(106875,4424),(106876,3787),(106877,3930),(106878,4368),(106879,4369),(106880,4371),(106881,4372),(106882,4374),(106883,4376),(106884,4377),(106885,4379),(106886,4380),(106887,4382),(106888,4386),(106889,4387),(106890,4388),(106891,4389),(106892,3932),(106893,3937),(106894,3938),(106895,3943),(106896,3944),(106897,3945),(106898,3946),(106899,3947),(106900,3948),(106901,3949),(106902,3950),(106903,3951),(106904,3952),(106905,3953),(106906,3954),(106907,3955),(106908,3956),(106909,3957),(106910,3958),(106911,3959),(106912,3960),(106913,3961),(106914,4108),(106915,4140),(106916,4411),(106917,4412),(106918,4131),(106919,4134),(106920,4136),(106921,4138),(106922,4139),(106923,4145),(106924,4146),(106925,4148),(106926,4149),(106927,4248),(106928,4359),(106929,3747),(106930,4021),(106931,4022),(106932,4023),(106933,4024),(106934,4025),(106935,4026),(106936,4027),(106937,4028),(106938,4029),(106939,4030),(106940,4031),(106941,4032),(106942,4033),(106943,4034),(106944,3724),(106945,3733),(106946,3734),(106947,3735),(106948,3736),(106949,3737),(106950,3740),(106951,4035),(106952,4036),(106953,4037),(106954,4211),(106955,3719),(106956,3720),(106957,3723),(106958,3725),(106959,3726),(106960,3728),(106961,3731),(106962,3746),(106963,3751),(106964,3752),(106965,3753),(106966,3754),(106967,3755),(106968,3757),(106969,3758),(106970,3759),(106971,3760),(106972,3909),(106973,3721),(106974,3727),(106975,3732),(106976,3741),(106977,3743),(106978,3744),(106979,3748),(106980,3749),(106981,3761),(106982,3762),(106983,3765),(106984,3942),(106985,3972),(106986,4080),(106987,4081),(106988,4082),(106989,4083),(106990,4084),(106991,4085),(106992,4089),(106993,4196),(106994,4197),(106995,4198),(106996,4204),(106997,4205),(106998,4206),(106999,4207),(107000,4208),(107001,4209),(107002,4210),(107003,4222),(107004,3894),(107005,3966),(107006,3968),(107007,4187),(107008,4188),(107009,4226),(107010,4227),(107011,4228),(107012,4230),(107013,4231),(107014,4232),(107015,4233),(107016,4235),(107017,4237),(107018,4238),(107019,4250),(107020,4252),(107021,4253),(107022,4275),(107023,4292),(107024,4418),(107025,4425),(107026,4427),(107027,4179),(107028,4180),(107029,4181),(107030,4182),(107031,4183),(107032,4184),(107033,4185),(107034,4189),(107035,4309),(107036,4310),(107037,4316),(107038,4317),(107039,4318),(107040,4319),(107041,4390),(107042,4391),(107043,4393),(107044,4394),(107045,4395),(107046,4396),(107047,4397),(107048,4398),(107049,4399),(107050,4400),(107051,4401),(107052,3715),(107053,3716),(107054,3750),(107055,3827),(107056,3828),(107057,3829),(107058,3830),(107059,3832),(107060,3833),(107061,3834),(107062,3918),(107063,3941),(107064,4087),(107065,4090),(107066,4091),(107067,4195),(107068,4224),(107069,4225),(107070,4236),(107071,3722),(107072,3729),(107073,3893),(107074,3895),(107075,3924),(107076,3925),(107077,3926),(107078,3927),(107079,3928),(107080,3931),(107081,3933),(107082,3934),(107083,3935),(107084,4194),(107085,4251),(107086,4254),(107087,4402),(107088,4403),(107089,4404),(107090,3730),(107091,3738),(107092,3739),(107093,3742),(107094,3747),(107095,3763),(107096,3764),(107097,3831),(107098,3975),(107099,3976),(107100,4052),(107101,4053),(107102,4065),(107103,4086),(107104,4219),(107105,4229),(107106,4276),(107107,4413),(107108,4414),(107109,4415),(107110,4417),(107111,4419),(107112,3981),(107113,3982),(107114,3983),(107115,3984),(107116,3985),(107117,4066),(107118,4069),(107119,4186),(107120,4212),(107121,4218),(107122,4220),(107123,4223),(107124,4282),(107125,4283),(107126,4392),(107127,4437),(107128,4438),(107129,4439),(107130,3756),(107131,4067),(107132,4068),(107133,4307),(107134,4308),(107135,4311),(107136,4312),(107137,3745),(107138,3903),(107139,3967),(107140,3969),(107141,4059),(107142,4060),(107143,4346),(107144,4347),(107145,4349),(107146,4351),(107147,4353),(107148,4355),(107149,4405),(107150,4407),(107151,4408),(107152,4410),(107153,4426),(107154,3718),(107155,3871),(107156,4041),(107157,4167),(107158,4274),(107159,4348),(107160,4350),(107161,4352),(107162,4354),(107163,4356),(107164,4406),(107165,4409),(107166,4411),(107167,4412),(107168,4021),(107169,4022),(107170,4023),(107171,4024),(107172,4025),(107173,4026),(107174,4027),(107175,4028),(107176,4029),(107177,4030),(107178,4031),(107179,4032),(107180,4033),(107181,4034),(107182,4035),(107183,3724),(107184,3733),(107185,3735),(107186,3736),(107187,3740),(107188,3746),(107189,3751),(107190,3755),(107191,3757),(107192,3758),(107193,3759),(107194,3760),(107195,3909),(107196,4036),(107197,4037),(107198,3719),(107199,3720),(107200,3723),(107201,3725),(107202,3726),(107203,3727),(107204,3728),(107205,3731),(107206,3748),(107207,3752),(107208,3753),(107209,3754),(107210,3721),(107211,3732),(107212,3741),(107213,3743),(107214,3744),(107215,3749),(107216,3761),(107217,3762),(107218,3765),(107219,3966),(107220,3968),(107221,4083),(107222,4088),(107223,4204),(107224,4207),(107225,4235),(107226,4237),(107227,4249),(107228,4179),(107229,4180),(107230,4181),(107231,4182),(107232,4183),(107233,4184),(107234,4185),(107235,4187),(107236,4188),(107237,4189),(107238,4250),(107239,4252),(107240,4253),(107241,4255),(107242,4309),(107243,4310),(107244,4316),(107245,4317),(107246,3827),(107247,3828),(107248,3829),(107249,4318),(107250,4390),(107251,4391),(107252,4393),(107253,4394),(107254,4396),(107255,4397),(107256,4398),(107257,4399),(107258,4400),(107259,4401),(107260,3715),(107261,3716),(107262,3722),(107263,3729),(107264,3750),(107265,3830),(107266,3833),(107267,3834),(107268,3925),(107269,3926),(107270,3927),(107271,3928),(107272,3941),(107273,4087),(107274,4090),(107275,4091),(107276,3730),(107277,3738),(107278,3739),(107279,3742),(107280,3747),(107281,3763),(107282,3764),(107283,3831),(107284,3931),(107285,3933),(107286,3934),(107287,3935),(107288,3975),(107289,3976),(107290,4086),(107291,4219),(107292,4229),(107293,4251),(107294,4254),(107295,4404),(107296,4415),(107297,4052),(107298,4053),(107299,4065),(107300,4066),(107301,4069),(107302,4186),(107303,4218),(107304,4220),(107305,4282),(107306,4283),(107307,4392),(107308,4437),(107309,4438),(107310,4439),(107311,3787),(107312,3893),(107313,3894),(107314,3895),(107315,3903),(107316,3925),(107317,3932),(107318,3981),(107319,4081),(107320,4084),(107321,4089),(107322,4195),(107323,4197),(107324,4205),(107325,4210),(107326,4224),(107327,4225),(107328,4230),(107329,4275),(107330,4403),(107331,4407),(107332,4411),(107333,4414),(107334,3972),(107335,4082),(107336,4085),(107337,4196),(107338,4198),(107339,4206),(107340,4209),(107341,4211),(107342,4226),(107343,4227),(107344,4231),(107345,4232),(107346,3918),(107347,3924),(107348,4193),(107349,4194),(107350,4225),(107351,4276),(107352,4292),(107353,4312),(107354,4402),(107355,4405),(107356,4425),(107357,4426),(107358,4427),(107359,3927),(107360,3942),(107361,3985),(107362,4141),(107363,4208),(107364,4222),(107365,4228),(107366,4234),(107367,4236),(107368,4238),(107369,4347),(107370,4348),(107371,4351),(107372,4352),(107373,4355),(107374,4356),(107375,4395),(107376,4410),(107377,4417),(107378,4418),(107379,4419),(107380,4481),(107381,4482),(107382,4483),(107383,4484),(107384,4485),(107385,4486),(107386,4487),(107387,4488),(107388,4489),(107389,4490),(107390,3721),(107391,3723),(107392,3732),(107393,3733),(107394,3746),(107395,3765),(107396,3889),(107397,3966),(107398,3968),(107399,4020),(107400,4080),(107401,4083),(107402,4204),(107403,4207),(107404,4233),(107405,4235),(107406,4237),(107407,4249),(107408,4250),(107409,4252),(107410,4253),(107411,4275),(107412,3785),(107413,3786),(107414,4181),(107415,4255),(107416,4305),(107417,4309),(107418,4310),(107419,4316),(107420,4317),(107421,4318),(107422,4319),(107423,4393),(107424,4394),(107425,4398),(107426,4399),(107427,4400),(107428,4401),(107429,3924),(107430,3941),(107431,4087),(107432,4090),(107433,4091),(107434,4092),(107435,4093),(107436,4095),(107437,4096),(107438,4097),(107439,4162),(107440,4271),(107441,4272),(107442,3739),(107443,3747),(107444,3764),(107445,3861),(107446,3925),(107447,3926),(107448,4065),(107449,4066),(107450,4069),(107451,4086),(107452,4229),(107453,4251),(107454,4254),(107455,4404),(107456,4414),(107457,4415),(107458,4067),(107459,4068),(107460,4075),(107461,4150),(107462,4170),(107463,4171),(107464,4174),(107465,4175),(107466,4203),(107467,4223),(107468,4340),(107469,4392),(107470,4434),(107471,3718),(107472,3967),(107473,3969),(107474,4094),(107475,4256),(107476,4346),(107477,4349),(107478,4353),(107479,4375),(107480,4377),(107481,4385),(107482,4386),(107483,4408),(107484,3930),(107485,4354),(107486,4368),(107487,4369),(107488,4372),(107489,4376),(107490,4379),(107491,4380),(107492,4382),(107493,4387),(107494,4388),(107495,4389),(107496,3719),(107497,3723),(107498,3735),(107499,3736),(107500,3740),(107501,3744),(107502,3746),(107503,3942),(107504,3972),(107505,4035),(107506,4037),(107507,4081),(107508,4082),(107509,4083),(107510,4084),(107511,4085),(107512,4089),(107513,4196),(107514,4197),(107515,4198),(107516,4204),(107517,4205),(107518,4206),(107519,4207),(107520,4208),(107521,4209),(107522,4210),(107523,4222),(107524,4226),(107525,4227),(107526,4228),(107527,4231),(107528,4232),(107529,4233),(107530,4235),(107531,4237),(107532,4238),(107533,4275),(107534,3894),(107535,3966),(107536,3968),(107537,4249),(107538,4250),(107539,4252),(107540,4253),(107541,4255),(107542,4292),(107543,4425),(107544,4179),(107545,4180),(107546,4181),(107547,4182),(107548,4183),(107549,4184),(107550,4309),(107551,4316),(107552,4318),(107553,4390),(107554,4391),(107555,4394),(107556,4418),(107557,4427),(107558,3715),(107559,3750),(107560,3828),(107561,3829),(107562,3830),(107563,3918),(107564,3941),(107565,4090),(107566,4395),(107567,4396),(107568,4398),(107569,4399),(107570,4400),(107571,4401),(107572,3722),(107573,3729),(107574,3893),(107575,3895),(107576,3924),(107577,3925),(107578,3926),(107579,3927),(107580,3928),(107581,3931),(107582,3933),(107583,3934),(107584,3935),(107585,4194),(107586,4195),(107587,4224),(107588,4225),(107589,4234),(107590,4236),(107591,4251),(107592,4254),(107593,3742),(107594,3747),(107595,3831),(107596,3975),(107597,4052),(107598,4053),(107599,4086),(107600,4193),(107601,4229),(107602,4276),(107603,4402),(107604,4403),(107605,4404),(107606,4415),(107607,4417),(107608,4419),(107609,3756),(107610,3981),(107611,4065),(107612,4218),(107613,4220),(107614,4223),(107615,4346),(107616,4347),(107617,4349),(107618,4351),(107619,4353),(107620,4355),(107621,4405),(107622,4407),(107623,4408),(107624,4410),(107625,4438),(107626,4439),(107627,4230),(107628,4021),(107629,4022),(107630,4023),(107631,4024),(107632,4025),(107633,4026),(107634,4027),(107635,4028),(107636,4029),(107637,4030),(107638,4031),(107639,4032),(107640,4033),(107641,4034),(107642,4035),(107643,4036),(107644,4037),(107645,3721),(107646,3723),(107647,3732),(107648,3733),(107649,3746),(107650,3765),(107651,3942),(107652,3972),(107653,4034),(107654,4035),(107655,4036),(107656,4080),(107657,4081),(107658,4083),(107659,4084),(107660,4089),(107661,4181),(107662,4237),(107663,4275),(107664,4292),(107665,4316),(107666,3718),(107667,3739),(107668,3747),(107669,3764),(107670,3871),(107671,3976),(107672,4065),(107673,4066),(107674,4069),(107675,4186),(107676,4282),(107677,4283),(107678,4317),(107679,4350),(107680,4354),(107681,4392),(107682,4393),(107683,4394),(107684,4398),(107685,4399),(107686,4400),(107687,4401),(107688,4406),(107689,4412),(107690,3733),(107691,3746),(107692,3942),(107693,3972),(107694,4080),(107695,4081),(107696,4082),(107697,4083),(107698,4084),(107699,4085),(107700,4089),(107701,4196),(107702,4197),(107703,4198),(107704,4204),(107705,4205),(107706,4206),(107707,4207),(107708,4208),(107709,4209),(107710,4210),(107711,4211),(107712,4222),(107713,3894),(107714,3966),(107715,4226),(107716,4227),(107717,4228),(107718,4230),(107719,4231),(107720,4232),(107721,4233),(107722,4235),(107723,4237),(107724,4238),(107725,4275),(107726,4292),(107727,4425),(107728,3750),(107729,3918),(107730,3941),(107731,3968),(107732,4087),(107733,4090),(107734,4179),(107735,4181),(107736,4183),(107737,4249),(107738,4250),(107739,4252),(107740,4253),(107741,4255),(107742,4309),(107743,4316),(107744,4317),(107745,4318),(107746,4390),(107747,4394),(107748,4395),(107749,4396),(107750,4398),(107751,4400),(107752,4401),(107753,4418),(107754,4427),(107755,3722),(107756,3729),(107757,3831),(107758,3895),(107759,4065),(107760,4066),(107761,4069),(107762,4086),(107763,4193),(107764,4195),(107765,4223),(107766,4224),(107767,4225),(107768,4229),(107769,4234),(107770,4236),(107771,4254),(107772,4276),(107773,4311),(107774,4392),(107775,4402),(107776,4312),(107777,3734),(107778,3735),(107779,3736),(107780,3740),(107781,3751),(107782,3758),(107783,4021),(107784,4022),(107785,4023),(107786,4024),(107787,4025),(107788,4026),(107789,4027),(107790,4028),(107791,4029),(107792,4030),(107793,4031),(107794,4032),(107795,4033),(107796,4037),(107797,3728),(107798,3731),(107799,3741),(107800,3743),(107801,3744),(107802,3752),(107803,3753),(107804,3754),(107805,3755),(107806,3757),(107807,3759),(107808,3760),(107809,3761),(107810,3762),(107811,3909),(107812,3750),(107813,3827),(107814,3828),(107815,3829),(107816,3830),(107817,4179),(107818,4180),(107819,4182),(107820,4183),(107821,4184),(107822,4185),(107823,4187),(107824,4188),(107825,4189),(107826,3715),(107827,3722),(107828,3729),(107829,3730),(107830,3738),(107831,3742),(107832,3763),(107833,3764),(107834,3831),(107835,3832),(107836,3833),(107837,3834),(107838,3975),(107839,3976),(107840,4052),(107841,4053),(107842,4186),(107843,4212),(107844,4219),(107845,4220),(107846,3745),(107847,3756),(107848,4218),(107849,4282),(107850,4283),(107851,4437),(107852,4438),(107853,4439),(107854,3765),(107855,3942),(107856,3972),(107857,4032),(107858,4033),(107859,4035),(107860,4036),(107861,4037),(107862,4081),(107863,4082),(107864,4083),(107865,4084),(107866,4211),(107867,4085),(107868,4089),(107869,4196),(107870,4197),(107871,4198),(107872,4204),(107873,4205),(107874,4206),(107875,4207),(107876,4208),(107877,4209),(107878,4210),(107879,4222),(107880,4226),(107881,4227),(107882,4228),(107883,4230),(107884,4231),(107885,4232),(107886,4233),(107887,4235),(107888,4237),(107889,4238),(107890,4275),(107891,4179),(107892,4180),(107893,4181),(107894,4182),(107895,4187),(107896,4188),(107897,4189),(107898,4292),(107899,4425),(107900,4183),(107901,4184),(107902,4185),(107903,4316),(107904,4317),(107905,4390),(107906,4391),(107907,4393),(107908,4394),(107909,4395),(107910,4396),(107911,4397),(107912,4398),(107913,4399),(107914,4400),(107915,4401),(107916,3918),(107917,3941),(107918,4086),(107919,4087),(107920,4090),(107921,4091),(107922,4195),(107923,4224),(107924,4225),(107925,4229),(107926,4234),(107927,4236),(107928,4065),(107929,3967),(107930,3981),(107931,4066),(107932,4069),(107933,4186),(107934,4392),(107935,4408),(107936,4410),(107937,4426),(107938,4438),(107939,3718),(107940,3969),(107941,4256),(107942,4346),(107943,4347),(107944,4351),(107945,4353),(107946,4355),(107947,4356),(107948,5753),(107949,5753),(107950,5753),(107951,5753),(107952,5753),(107953,5753),(107954,5753),(107955,1165),(107956,1165),(107957,1165),(107958,1165),(107959,1165),(107960,1165),(107961,1165),(107962,1165),(107963,5193),(107964,5193),(107965,5193),(107966,5193),(107967,5193),(107968,5193),(107969,5193),(107970,5193),(107971,5193),(107972,5192),(107973,5192),(107974,5192),(107975,5192),(107976,5192),(107977,5192),(107978,5192),(107979,5192),(107980,5192),(107981,5190),(107982,5190),(107983,5190),(107984,5190),(107985,5190),(107986,5190),(107987,5190),(107988,5190),(107989,5190),(107990,5753),(107991,5753),(107992,5753),(107993,5753),(107994,5753),(107995,5753),(107996,5753),(107997,5753),(107998,5753),(107999,5753),(108000,5753),(108001,5753),(108002,5753),(108003,5753),(108004,5753),(108005,5753),(108006,5753),(108007,5753),(108008,5753),(108009,5753),(108010,5753),(108011,5753),(108012,5753),(108013,5753),(108014,5753),(108015,5753),(108016,5753),(108017,5753),(108018,5753),(108019,5753),(108020,5753),(108021,5753),(108022,5753),(108023,5753),(108024,5753),(108025,5753),(108026,5753),(108027,5753),(108028,5753),(108029,5753),(108030,5753),(108031,5753),(108032,5753),(108033,5753),(108034,5753),(108035,5753),(108036,5753),(108037,5753),(108038,5753),(108039,5753),(108040,5753),(108041,5753),(108042,5753),(108043,5753),(108044,5753),(108045,5753),(108046,5753),(108047,5753),(108048,5753),(108049,5753),(108050,5753),(108051,5753),(108052,5753),(108053,5753),(108054,5753),(108055,5753),(108056,5753),(108057,5754),(108058,5755),(108059,5756),(108060,5753),(108061,5753),(108062,5753),(108063,5753),(108064,5753),(108065,5753),(108066,5753),(108067,5753),(108068,5753),(108069,5753),(108070,5753),(108071,5753),(108072,5753),(108073,5753),(108074,5753),(108075,5753),(108076,5753),(108077,5753),(108078,5753),(108079,5753),(108080,5753),(108081,5753),(108082,5753),(108083,5753),(108084,5753),(108085,5753),(108086,5753),(108087,5753),(108088,5753),(108089,5753),(108090,5753),(108091,5753),(108092,5753),(108093,4127),(108094,4128),(108095,4129),(108096,4130),(108097,4132),(108098,4133),(108099,4135),(108100,4137),(108101,4156),(108102,4297),(108103,4298),(108104,4299),(108105,4300),(108106,4301),(108107,4302),(108108,4303),(108109,4304),(108110,4458),(108111,4459),(108112,1629),(108113,3884),(108114,3905),(108115,3970),(108116,3980),(108117,4062),(108118,4121),(108119,4122),(108120,4123),(108121,4259),(108122,4270),(108123,4063),(108124,4070),(108125,4124),(108126,4215),(108127,4364),(108128,4366),(108129,4460),(108130,4461),(108131,4462),(108132,4467),(108133,4470),(108134,1640),(108135,1641),(108136,1642),(108137,3875),(108138,3876),(108139,3877),(108140,3878),(108141,3880),(108142,3977),(108143,4469),(108144,4474),(108145,4475),(108146,4243),(108147,4244),(108148,4245),(108149,4294),(108150,4295),(108151,4296),(108152,4436),(108153,4444),(108154,4446),(108155,4447),(108156,4448),(108157,4449),(108158,4450),(108159,3870),(108160,3892),(108161,3964),(108162,3965),(108163,3979),(108164,4172),(108165,4173),(108166,4451),(108167,4452),(108168,4453),(108169,4454),(108170,4455),(108171,4456),(108172,4202),(108173,4216),(108174,4217),(108175,4257),(108176,4277),(108177,4278),(108178,4279),(108179,4280),(108180,4281),(108181,4287),(108182,4288),(108183,4289),(108184,4290),(108185,4315),(108186,4342),(108187,4343),(108188,4441),(108189,1632),(108190,4239),(108191,4240),(108192,4241),(108193,4442),(108194,4443),(108195,4445),(108196,4473),(108197,4476),(108198,4480),(108199,1630),(108200,1631),(108201,1633),(108202,1634),(108203,1635),(108204,1681),(108205,1682),(108206,1683),(108207,1684),(108208,1685),(108209,1686),(108210,3903),(108211,1638),(108212,1639),(108213,1645),(108214,3768),(108215,3771),(108216,3882),(108217,3973),(108218,4152),(108219,4153),(108220,4154),(108221,4168),(108222,4337),(108223,4338),(108224,4339),(108225,1568),(108226,1569),(108227,1570),(108228,1571),(108229,1572),(108230,1573),(108231,1636),(108232,1637),(108233,1643),(108234,1644),(108235,1574),(108236,1646),(108237,1647),(108238,1648),(108239,1649),(108240,4145),(108241,4146),(108242,4148),(108243,4149),(108244,4248),(108245,4359),(108246,4127),(108247,4128),(108248,4129),(108249,4130),(108250,4132),(108251,4133),(108252,4135),(108253,4137),(108254,4156),(108255,4297),(108256,4298),(108257,4299),(108258,4300),(108259,4301),(108260,1640),(108261,1641),(108262,3977),(108263,3978),(108264,4302),(108265,4303),(108266,4304),(108267,4458),(108268,4459),(108269,1642),(108270,3875),(108271,3876),(108272,3877),(108273,3878),(108274,3879),(108275,3880),(108276,4243),(108277,4244),(108278,4245),(108279,4294),(108280,4295),(108281,4296),(108282,4436),(108283,4444),(108284,4446),(108285,4447),(108286,3892),(108287,4448),(108288,4449),(108289,4450),(108290,4451),(108291,4452),(108292,4453),(108293,4454),(108294,4455),(108295,4456),(108296,3870),(108297,3964),(108298,3965),(108299,4172),(108300,4173),(108301,4202),(108302,4257),(108303,4277),(108304,4278),(108305,4279),(108306,4280),(108307,4281),(108308,4287),(108309,1632),(108310,1635),(108311,1683),(108312,1686),(108313,4288),(108314,4289),(108315,4290),(108316,4342),(108317,4343),(108318,4441),(108319,4442),(108320,4443),(108321,4445),(108322,1568),(108323,1569),(108324,1570),(108325,1571),(108326,1572),(108327,3882),(108328,3903),(108329,3973),(108330,4152),(108331,1573),(108332,1574),(108333,4145),(108334,4146),(108335,4148),(108336,4149),(108337,3884),(108338,3905),(108339,3970),(108340,4062),(108341,4121),(108342,4259),(108343,4270),(108344,4422),(108345,1630),(108346,1633),(108347,4063),(108348,4070),(108349,4215),(108350,4239),(108351,4241),(108352,4460),(108353,4473),(108354,4476),(108355,4480),(108356,1681),(108357,1684),(108358,3768),(108359,3771),(108360,4127),(108361,4128),(108362,4129),(108363,4130),(108364,4132),(108365,4133),(108366,4135),(108367,4137),(108368,4156),(108369,4297),(108370,4298),(108371,4299),(108372,4300),(108373,4301),(108374,1640),(108375,1641),(108376,1642),(108377,3875),(108378,3876),(108379,3877),(108380,3878),(108381,3879),(108382,3880),(108383,3978),(108384,4243),(108385,4244),(108386,4245),(108387,4294),(108388,4295),(108389,4296),(108390,4302),(108391,4303),(108392,4304),(108393,4436),(108394,4444),(108395,4446),(108396,4458),(108397,4459),(108398,3870),(108399,3892),(108400,3964),(108401,3965),(108402,4170),(108403,4171),(108404,4447),(108405,4448),(108406,4449),(108407,4450),(108408,4451),(108409,4452),(108410,4453),(108411,4454),(108412,4455),(108413,4456),(108414,4172),(108415,4173),(108416,4174),(108417,4202),(108418,4257),(108419,4277),(108420,4278),(108421,4279),(108422,4280),(108423,4281),(108424,4287),(108425,4288),(108426,4289),(108427,4290),(108428,4342),(108429,4343),(108430,1568),(108431,1569),(108432,1570),(108433,1636),(108434,1637),(108435,1638),(108436,1639),(108437,1643),(108438,1644),(108439,1645),(108440,3903),(108441,3973),(108442,4153),(108443,4154),(108444,4168),(108445,4337),(108446,4338),(108447,4339),(108448,4441),(108449,4442),(108450,4443),(108451,4445),(108452,1571),(108453,1572),(108454,1573),(108455,1574),(108456,1646),(108457,1647),(108458,1648),(108459,1649),(108460,4141),(108461,4146),(108462,4148),(108463,4149),(108464,1631),(108465,1634),(108466,1682),(108467,1685),(108468,4122),(108469,4123),(108470,4124),(108471,4216),(108472,4217),(108473,4315),(108474,4364),(108475,4366),(108476,4461),(108477,4462),(108478,4467),(108479,4469),(108480,4470),(108481,4474),(108482,4475),(108483,3889),(108484,4013),(108485,4014),(108486,4015),(108487,4016),(108488,4017),(108489,4018),(108490,4019),(108491,4020),(108492,3917),(108493,3974),(108494,4247),(108495,4336),(108496,3885),(108497,3919),(108498,4360),(108499,3785),(108500,3786),(108501,3920),(108502,3921),(108503,3922),(108504,4062),(108505,4092),(108506,4093),(108507,4096),(108508,4097),(108509,4120),(108510,4151),(108511,4305),(108512,4460),(108513,4043),(108514,4095),(108515,4162),(108516,4199),(108517,4200),(108518,4271),(108519,4272),(108520,4273),(108521,4313),(108522,4314),(108523,4430),(108524,4431),(108525,4457),(108526,4214),(108527,4306),(108528,4358),(108529,3874),(108530,3963),(108531,3986),(108532,3987),(108533,3988),(108534,4012),(108535,4291),(108536,3767),(108537,3773),(108538,3774),(108539,3868),(108540,3904),(108541,3923),(108542,3929),(108543,3936),(108544,4039),(108545,4094),(108546,4143),(108547,4293),(108548,4385),(108549,4468),(108550,3908),(108551,3930),(108552,3932),(108553,3937),(108554,3938),(108555,4040),(108556,4044),(108557,4125),(108558,4178),(108559,4213),(108560,4320),(108561,4322),(108562,4323),(108563,4324),(108564,4325),(108565,4345),(108566,4368),(108567,4372),(108568,4375),(108569,4376),(108570,4379),(108571,4382),(108572,4383),(108573,4384),(108574,4386),(108575,3872),(108576,3873),(108577,3944),(108578,3946),(108579,3948),(108580,3949),(108581,3951),(108582,3952),(108583,3953),(108584,3954),(108585,3960),(108586,4076),(108587,4341),(108588,4416),(108589,3943),(108590,3945),(108591,3947),(108592,3950),(108593,3955),(108594,3956),(108595,3957),(108596,3958),(108597,3959),(108598,3961),(108599,4108),(108600,3885),(108601,3919),(108602,3920),(108603,3921),(108604,3922),(108605,3974),(108606,4013),(108607,4014),(108608,4015),(108609,4016),(108610,4191),(108611,4192),(108612,4215),(108613,4336),(108614,3767),(108615,3923),(108616,3936),(108617,4043),(108618,4094),(108619,4120),(108620,4162),(108621,4271),(108622,4272),(108623,4291),(108624,4305),(108625,4306),(108626,4313),(108627,4314),(108628,4358),(108629,4430),(108630,4431),(108631,3773),(108632,3774),(108633,3872),(108634,3873),(108635,3904),(108636,3930),(108637,3989),(108638,4039),(108639,4079),(108640,4293),(108641,4341),(108642,4416),(108643,4424),(108644,4468),(108645,3943),(108646,3944),(108647,3946),(108648,3947),(108649,3948),(108650,3949),(108651,3950),(108652,3951),(108653,3952),(108654,3953),(108655,3954),(108656,3955),(108657,3956),(108658,3957),(108659,3958),(108660,3959),(108661,3960),(108662,4108),(108663,3768),(108664,3771),(108665,3884),(108666,3905),(108667,3970),(108668,4062),(108669,4063),(108670,4070),(108671,4121),(108672,4215),(108673,4239),(108674,4241),(108675,4259),(108676,4270),(108677,4422),(108678,4460),(108679,4473),(108680,4476),(108681,3769),(108682,3874),(108683,4012),(108684,4054),(108685,4055),(108686,4075),(108687,4077),(108688,4078),(108689,4094),(108690,4097),(108691,4142),(108692,4143),(108693,4150),(108694,4151),(108695,4199),(108696,4200),(108697,4201),(108698,3770),(108699,3787),(108700,3932),(108701,3944),(108702,3946),(108703,3948),(108704,3949),(108705,3951),(108706,3952),(108707,3953),(108708,3954),(108709,3960),(108710,4076),(108711,4341),(108712,4375),(108713,4385),(108714,4386),(108715,4388),(108716,4468),(108717,3943),(108718,3945),(108719,3947),(108720,3950),(108721,3955),(108722,3958),(108723,3961),(108724,4108),(108725,3986),(108726,3987),(108727,3988),(108728,4012),(108729,4013),(108730,4014),(108731,4015),(108732,4016),(108733,4017),(108734,4018),(108735,4019),(108736,4020),(108737,4097),(108738,4341),(108739,4416),(108740,3776),(108741,3777),(108742,3778),(108743,3779),(108744,3780),(108745,3781),(108746,3782),(108747,3783),(108748,3788),(108749,3789),(108750,3790),(108751,3791),(108752,3792),(108753,3793),(108754,3794),(108755,3795),(108756,3796),(108757,3797),(108758,3798),(108759,3799),(108760,3800),(108761,3801),(108762,3802),(108763,3803),(108764,3804),(108765,3805),(108766,3806),(108767,3807),(108768,3808),(108769,3809),(108770,3810),(108771,3811),(108772,3812),(108773,3813),(108774,3814),(108775,3815),(108776,3816),(108777,3817),(108778,3818),(108779,3820),(108780,3821),(108781,3822),(108782,3823),(108783,3824),(108784,3825),(108785,3826),(108786,3836),(108787,3837),(108788,3838),(108789,3839),(108790,3840),(108791,3841),(108792,3847),(108793,3852),(108794,3853),(108795,3854),(108796,3857),(108797,3890),(108798,3849),(108799,3855),(108800,3856),(108801,3858),(108802,3859),(108803,4326),(108804,4327),(108805,4328),(108806,4330),(108807,4331),(108808,4332),(108809,4333),(108810,4335),(108811,3842),(108812,3846),(108813,3848),(108814,3850),(108815,3851),(108816,3887),(108817,3910),(108818,3911),(108819,3912),(108820,4057),(108821,4064),(108822,4329),(108823,4334),(108824,1),(108825,2),(108826,5),(108827,6),(108828,1162),(108829,1163),(108830,1164),(108831,1165),(108832,3128),(108833,3130),(108834,3133),(108835,3172),(108836,3134),(108837,3136),(108838,3137),(108839,3138),(108840,3139),(108841,3145),(108842,3150),(108843,3151),(108844,3155),(108845,3407),(108846,2704),(108847,2705),(108848,2731),(108849,3153),(108850,3160),(108851,3161),(108852,3162),(108853,3163),(108854,3713),(108855,2924),(108856,2927),(108857,2928),(108858,2931),(108859,2932),(108860,2933),(108861,2934),(108862,2935),(108863,2936),(108864,2937),(108865,2988),(108866,3164),(108867,3165),(108868,2938),(108869,2939),(108870,2940),(108871,2941),(108872,3102),(108873,3133),(108874,3134),(108875,3136),(108876,3137),(108877,3138),(108878,3139),(108879,3145),(108880,3150),(108881,3151),(108882,3157),(108883,3166),(108884,2704),(108885,2705),(108886,2731),(108887,2732),(108888,2733),(108889,2734),(108890,2735),(108891,2736),(108892,2737),(108893,2738),(108894,2739),(108895,3160),(108896,3161),(108897,3162),(108898,3163),(108899,2740),(108900,2741),(108901,2742),(108902,2743),(108903,2744),(108904,2745),(108905,2746),(108906,2747),(108907,2748),(108908,2749),(108909,2750),(108910,2751),(108911,2752),(108912,2753),(108913,2754),(108914,2755),(108915,2756),(108916,2757),(108917,2758),(108918,2759),(108919,3118),(108920,3131),(108921,3153),(108922,3623),(108923,3713),(108924,2942),(108925,2944),(108926,3153),(108927,3534),(108928,3535),(108929,3536),(108930,3675),(108931,3676),(108932,3677),(108933,3678),(108934,3679),(108935,3680),(108936,3681),(108937,3682),(108938,3683),(108939,2700),(108940,2866),(108941,2867),(108942,2919),(108943,2920),(108944,2655),(108945,2656),(108946,2657),(108947,2759),(108948,2766),(108949,2767),(108950,2768),(108951,2769),(108952,2770),(108953,2771),(108954,2970),(108955,3131),(108956,2796),(108957,3042),(108958,3169),(108959,3336),(108960,3391),(108961,2864),(108962,2887),(108963,2888),(108964,2911),(108965,3036),(108966,3048),(108967,3078),(108968,3108),(108969,3537),(108970,3543),(108971,3561),(108972,3621),(108973,3671),(108974,2655),(108975,2656),(108976,2657),(108977,2767),(108978,2768),(108979,2781),(108980,2794),(108981,2833),(108982,2835),(108983,2837),(108984,2838),(108985,2894),(108986,2895),(108987,2896),(108988,2978),(108989,2991),(108990,3052),(108991,3167),(108992,3168),(108993,2771),(108994,2971),(108995,2972),(108996,2973),(108997,2974),(108998,2975),(108999,2993),(109000,2994),(109001,2995),(109002,2996),(109003,3504),(109004,3505),(109005,3507),(109006,3508),(109007,2932),(109008,2939),(109009,2947),(109010,2948),(109011,2949),(109012,2950),(109013,3407),(109014,3509),(109015,3510),(109016,3511),(109017,3512),(109018,3513),(109019,3514),(109020,3711),(109021,2724),(109022,2748),(109023,2755),(109024,2782),(109025,2793),(109026,2807),(109027,2809),(109028,2811),(109029,2813),(109030,2817),(109031,2819),(109032,3136),(109033,3137),(109034,3150),(109035,3151),(109036,3156),(109037,3160),(109038,3161),(109039,3184),(109040,3214),(109041,3488),(109042,3623),(109043,2699),(109044,2925),(109045,2926),(109046,2929),(109047,2930),(109048,2943),(109049,2945),(109050,2979),(109051,2980),(109052,3042),(109053,3128),(109054,3172),(109055,2740),(109056,2741),(109057,2742),(109058,2743),(109059,2749),(109060,2750),(109061,2751),(109062,2753),(109063,2754),(109064,2757),(109065,2758),(109066,2800),(109067,2812),(109068,3118),(109069,3130),(109070,3131),(109071,3157),(109072,3407),(109073,3623),(109074,3714),(109075,2765),(109076,2798),(109077,2821),(109078,2856),(109079,2886),(109080,2893),(109081,2900),(109082,2904),(109083,2955),(109084,3543),(109085,3548),(109086,3620),(109087,3673),(109088,3674),(109089,2828),(109090,2829),(109091,2843),(109092,2858),(109093,2863),(109094,2891),(109095,2978),(109096,2987),(109097,2989),(109098,2990),(109099,2998),(109100,3539),(109101,3540),(109102,2999),(109103,3000),(109104,3001),(109105,3002),(109106,3003),(109107,3004),(109108,3005),(109109,3006),(109110,3007),(109111,3490),(109112,3491),(109113,3492),(109114,3493),(109115,3494),(109116,3495),(109117,3496),(109118,3497),(109119,3498),(109120,3499),(109121,3500),(109122,3501),(109123,3502),(109124,3503),(109125,3573),(109126,3574),(109127,3575),(109128,3576),(109129,3577),(109130,3578),(109131,3579),(109132,3580),(109133,3583),(109134,3592),(109135,3593),(109136,3594),(109137,3595),(109138,3596),(109139,3597),(109140,3598),(109141,3599),(109142,3600),(109143,3601),(109144,3602),(109145,3603),(109146,3604),(109147,3605),(109148,3606),(109149,3607),(109150,3608),(109151,3609),(109152,3686),(109153,3687),(109154,3688),(109155,3689),(109156,3690),(109157,3691),(109158,3692),(109159,3693),(109160,3694),(109161,3695),(109162,3696),(109163,3697),(109164,3698),(109165,3699),(109166,3700),(109167,3701),(109168,3702),(109169,3703),(109170,2699),(109171,2923),(109172,2925),(109173,2926),(109174,2929),(109175,2930),(109176,2943),(109177,2945),(109178,2979),(109179,3704),(109180,3705),(109181,3706),(109182,3707),(109183,3708),(109184,3709),(109185,3710),(109186,2703),(109187,2980),(109188,3042),(109189,2890),(109190,2899),(109191,2917),(109192,2976),(109193,3012),(109194,3128),(109195,3130),(109196,3142),(109197,3146),(109198,3149),(109199,3152),(109200,3154),(109201,3155),(109202,3156),(109203,3172),(109204,3184),(109205,3214),(109206,3407),(109207,3479),(109208,3480),(109209,3488),(109210,2708),(109211,2711),(109212,2712),(109213,2713),(109214,2714),(109215,2717),(109216,2721),(109217,2722),(109218,2723),(109219,2730),(109220,2799),(109221,2800),(109222,2801),(109223,2802),(109224,2918),(109225,3043),(109226,3489),(109227,2677),(109228,2803),(109229,2804),(109230,2810),(109231,2812),(109232,2815),(109233,3126),(109234,3132),(109235,3135),(109236,3140),(109237,3143),(109238,3144),(109239,3147),(109240,3148),(109241,3159),(109242,3421),(109243,3714),(109244,2828),(109245,2842),(109246,2843),(109247,2987),(109248,3479),(109249,3539),(109250,2856),(109251,2893),(109252,2912),(109253,2955),(109254,3037),(109255,3049),(109256,3077),(109257,3079),(109258,3109),(109259,3538),(109260,3543),(109261,3548),(109262,3571),(109263,3620),(109264,3674),(109265,2765),(109266,2796),(109267,2797),(109268,2798),(109269,2857),(109270,2865),(109271,2886),(109272,2889),(109273,2894),(109274,2900),(109275,2988),(109276,2992),(109277,3019),(109278,3562),(109279,3622),(109280,3672),(109281,3673),(109282,2828),(109283,2829),(109284,2834),(109285,2836),(109286,2839),(109287,2843),(109288,2858),(109289,2863),(109290,2897),(109291,2898),(109292,2978),(109293,2987),(109294,2989),(109295,2990),(109296,2997),(109297,3008),(109298,3053),(109299,3054),(109300,3539),(109301,3540),(109302,3541),(109303,3542),(109304,3648),(109305,3009),(109306,3010),(109307,3011),(109308,3490),(109309,3491),(109310,3492),(109311,3493),(109312,3494),(109313,3495),(109314,3496),(109315,3497),(109316,3498),(109317,3499),(109318,3500),(109319,3501),(109320,3502),(109321,3503),(109322,3515),(109323,3516),(109324,3517),(109325,3518),(109326,3519),(109327,3520),(109328,3521),(109329,3522),(109330,3523),(109331,3524),(109332,3525),(109333,3526),(109334,3527),(109335,3573),(109336,2924),(109337,2927),(109338,2928),(109339,2931),(109340,2933),(109341,2934),(109342,2935),(109343,2936),(109344,3164),(109345,3165),(109346,3574),(109347,3575),(109348,3576),(109349,3577),(109350,3578),(109351,3579),(109352,3580),(109353,3583),(109354,3701),(109355,3712),(109356,2703),(109357,2937),(109358,2938),(109359,2940),(109360,2941),(109361,2948),(109362,2949),(109363,2951),(109364,2952),(109365,2953),(109366,2954),(109367,3166),(109368,2795),(109369,2830),(109370,2890),(109371,2899),(109372,2917),(109373,2976),(109374,3012),(109375,3102),(109376,3127),(109377,3128),(109378,3130),(109379,3133),(109380,3134),(109381,3138),(109382,3139),(109383,3141),(109384,3142),(109385,3145),(109386,3146),(109387,3172),(109388,3149),(109389,3152),(109390,3154),(109391,3155),(109392,3156),(109393,3157),(109394,3162),(109395,3163),(109396,3169),(109397,3214),(109398,3336),(109399,3342),(109400,3388),(109401,3488),(109402,2704),(109403,2705),(109404,2706),(109405,2707),(109406,2708),(109407,2709),(109408,2710),(109409,2711),(109410,2712),(109411,2713),(109412,2714),(109413,2715),(109414,2716),(109415,2717),(109416,2718),(109417,2719),(109418,2720),(109419,2721),(109420,2722),(109421,2723),(109422,2725),(109423,3158),(109424,3277),(109425,3479),(109426,3480),(109427,2726),(109428,2727),(109429,2728),(109430,2729),(109431,2730),(109432,2731),(109433,2732),(109434,2733),(109435,2734),(109436,2735),(109437,2736),(109438,2737),(109439,2738),(109440,2739),(109441,2744),(109442,2745),(109443,2746),(109444,2747),(109445,2740),(109446,2750),(109447,2752),(109448,2753),(109449,2754),(109450,2756),(109451,2757),(109452,2758),(109453,2759),(109454,2799),(109455,2800),(109456,2801),(109457,2802),(109458,2803),(109459,2804),(109460,2805),(109461,2806),(109462,2807),(109463,2808),(109464,2809),(109465,2810),(109466,2812),(109467,2814),(109468,2815),(109469,2816),(109470,2818),(109471,2820),(109472,2970),(109473,2977),(109474,3050),(109475,3051),(109476,3055),(109477,3125),(109478,3140),(109479,3144),(109480,3147),(109481,3148),(109482,3713),(109483,3714),(109484,2),(109485,4),(109486,1162),(109487,1163),(109488,1164),(109489,1165),(109490,400),(109491,480),(109492,482),(109493,515),(109494,48),(109495,48),(109496,48),(109497,48),(109498,48),(109499,48),(109500,48),(109501,48),(109502,48),(109503,48),(109504,48),(109505,48),(109506,48),(109507,48),(109508,48),(109509,48),(109510,48),(109511,48),(109512,48),(109513,48),(109514,48),(109515,499),(109516,659),(109517,687),(109518,695),(109519,697),(109520,906),(109521,913),(109522,914),(109523,1004),(109524,1019),(109525,1038),(109526,1092),(109527,1119),(109528,882),(109529,884),(109530,885),(109531,886),(109532,887),(109533,888),(109534,889),(109535,890),(109536,891),(109537,892),(109538,893),(109539,894),(109540,895),(109541,896),(109542,897),(109543,898),(109544,899),(109545,900),(109546,901),(109547,915),(109548,1166),(109549,1167),(109550,321),(109551,342),(109552,418),(109553,436),(109554,542),(109555,543),(109556,553),(109557,766),(109558,809),(109559,843),(109560,1169),(109561,312),(109562,314),(109563,317),(109564,319),(109565,320),(109566,322),(109567,323),(109568,701),(109569,707),(109570,708),(109571,907),(109572,911),(109573,916),(109574,996),(109575,1002),(109576,1034),(109577,917),(109578,918),(109579,919),(109580,920),(109581,921),(109582,922),(109583,923),(109584,928),(109585,929),(109586,931),(109587,934),(109588,936),(109589,937),(109590,938),(109591,939),(109592,942),(109593,948),(109594,949),(109595,950),(109596,951),(109597,952),(109598,953),(109599,954),(109600,955),(109601,956),(109602,957),(109603,958),(109604,959),(109605,960),(109606,961),(109607,962),(109608,963),(109609,964),(109610,965),(109611,966),(109612,967),(109613,973),(109614,974),(109615,975),(109616,976),(109617,977),(109618,978),(109619,979),(109620,980),(109621,981),(109622,982),(109623,983),(109624,984),(109625,985),(109626,986),(109627,987),(109628,992),(109629,993),(109630,994),(109631,995),(109632,1007),(109633,1109),(109634,1115),(109635,1122),(109636,1123),(109637,1136),(109638,1137),(109639,1138),(109640,308),(109641,346),(109642,699),(109643,718),(109644,719),(109645,720),(109646,722),(109647,723),(109648,724),(109649,738),(109650,739),(109651,740),(109652,1003),(109653,1005),(109654,1035),(109655,1039),(109656,1139),(109657,5752),(109658,301),(109659,311),(109660,324),(109661,326),(109662,328),(109663,330),(109664,332),(109665,333),(109666,336),(109667,337),(109668,636),(109669,743),(109670,744),(109671,745),(109672,746),(109673,869),(109674,875),(109675,878),(109676,879),(109677,883),(109678,334),(109679,335),(109680,338),(109681,344),(109682,692),(109683,702),(109684,703),(109685,704),(109686,706),(109687,711),(109688,713),(109689,714),(109690,732),(109691,733),(109692,734),(109693,737),(109694,741),(109695,742),(109696,748),(109697,749),(109698,747),(109699,1021),(109700,1037),(109701,48),(109702,48),(109703,48),(109704,48),(109705,48),(109706,294),(109707,659),(109708,1004),(109709,319),(109710,320),(109711,687),(109712,707),(109713,1012),(109714,1019),(109715,1092),(109716,312),(109717,314),(109718,322),(109719,323),(109720,618),(109721,907),(109722,308),(109723,346),(109724,632),(109725,699),(109726,718),(109727,719),(109728,720),(109729,722),(109730,723),(109731,724),(109732,738),(109733,739),(109734,740),(109735,1003),(109736,1005),(109737,1035),(109738,301),(109739,311),(109740,332),(109741,333),(109742,336),(109743,337),(109744,347),(109745,636),(109746,743),(109747,334),(109748,335),(109749,338),(109750,339),(109751,340),(109752,344),(109753,345),(109754,744),(109755,745),(109756,746),(109757,903),(109758,904),(109759,905),(109760,692),(109761,702),(109762,703),(109763,704),(109764,706),(109765,711),(109766,713),(109767,714),(109768,732),(109769,733),(109770,734),(109771,737),(109772,741),(109773,742),(109774,748),(109775,749),(109776,721),(109777,725),(109778,747),(109779,1037),(109780,296),(109781,374),(109782,375),(109783,376),(109784,527),(109785,528),(109786,529),(109787,531),(109788,557),(109789,560),(109790,587),(109791,646),(109792,588),(109793,589),(109794,590),(109795,591),(109796,592),(109797,611),(109798,613),(109799,617),(109800,619),(109801,624),(109802,637),(109803,639),(109804,639),(109805,648),(109806,652),(109807,670),(109808,672),(109809,778),(109810,779),(109811,834),(109812,835),(109813,836),(109814,837),(109815,838),(109816,839),(109817,639),(109818,648),(109819,652),(109820,670),(109821,672),(109822,778),(109823,779),(109824,834),(109825,835),(109826,836),(109827,837),(109828,838),(109829,839),(109830,281),(109831,284),(109832,648),(109833,652),(109834,670),(109835,672),(109836,778),(109837,779),(109838,834),(109839,835),(109840,836),(109841,837),(109842,838),(109843,839),(109844,840),(109845,286),(109846,287),(109847,289),(109848,291),(109849,292),(109850,294),(109851,297),(109852,530),(109853,532),(109854,625),(109855,660),(109856,691),(109857,693),(109858,694),(109859,906),(109860,997),(109861,998),(109862,999),(109863,1001),(109864,1036),(109865,299),(109866,304),(109867,307),(109868,682),(109869,688),(109870,690),(109871,696),(109872,1000),(109873,1067),(109874,1068),(109875,1069),(109876,1070),(109877,1072),(109878,1073),(109879,1074),(109880,1075),(109881,1133),(109882,298),(109883,300),(109884,321),(109885,342),(109886,687),(109887,695),(109888,697),(109889,698),(109890,700),(109891,705),(109892,1004),(109893,1012),(109894,1019),(109895,1038),(109896,1092),(109897,1119),(109898,317),(109899,319),(109900,320),(109901,322),(109902,323),(109903,701),(109904,707),(109905,708),(109906,907),(109907,996),(109908,1034),(109909,308),(109910,312),(109911,314),(109912,346),(109913,618),(109914,632),(109915,699),(109916,718),(109917,722),(109918,724),(109919,738),(109920,739),(109921,301),(109922,332),(109923,336),(109924,347),(109925,636),(109926,719),(109927,720),(109928,723),(109929,740),(109930,1003),(109931,1005),(109932,1035),(109933,311),(109934,333),(109935,334),(109936,335),(109937,337),(109938,338),(109939,339),(109940,340),(109941,743),(109942,744),(109943,745),(109944,746),(109945,903),(109946,904),(109947,905),(109948,344),(109949,345),(109950,702),(109951,704),(109952,706),(109953,711),(109954,732),(109955,733),(109956,734),(109957,737),(109958,741),(109959,742),(109960,748),(109961,749),(109962,692),(109963,703),(109964,713),(109965,714),(109966,725),(109967,747),(109968,1037),(109969,718),(109970,721),(109971,725),(109972,747),(109973,319),(109974,1060),(109975,1062),(109976,1064),(109977,1061),(109978,469),(109979,558),(109980,559),(109981,596),(109982,597),(109983,600),(109984,601),(109985,614),(109986,615),(109987,645),(109988,650),(109989,651),(109990,656),(109991,664),(109992,771),(109993,772),(109994,780),(109995,815),(109996,855),(109997,856),(109998,470),(109999,518),(110000,599),(110001,753),(110002,814),(110003,875),(110004,902),(110005,936),(110006,937),(110007,938),(110008,939),(110009,980),(110010,981),(110011,982),(110012,983),(110013,1028),(110014,1050),(110015,878),(110016,879),(110017,1021),(110018,553),(110019,913),(110020,914),(110021,915),(110022,957),(110023,958),(110024,959),(110025,1021),(110026,1089),(110027,399),(110028,400),(110029,402),(110030,403),(110031,421),(110032,460),(110033,461),(110034,462),(110035,480),(110036,481),(110037,482),(110038,499),(110039,514),(110040,515),(110041,521),(110042,526),(110043,662),(110044,665),(110045,668),(110046,669),(110047,407),(110048,411),(110049,412),(110050,413),(110051,414),(110052,422),(110053,423),(110054,425),(110055,430),(110056,472),(110057,473),(110058,500),(110059,501),(110060,502),(110061,517),(110062,524),(110063,661),(110064,663),(110065,666),(110066,667),(110067,348),(110068,349),(110069,350),(110070,353),(110071,354),(110072,355),(110073,359),(110074,522),(110075,602),(110076,603),(110077,604),(110078,605),(110079,606),(110080,607),(110081,608),(110082,609),(110083,776),(110084,777),(110085,781),(110086,785),(110087,788),(110088,791),(110089,561),(110090,564),(110091,569),(110092,584),(110093,782),(110094,783),(110095,784),(110096,786),(110097,787),(110098,789),(110099,790),(110100,794),(110101,798),(110102,799),(110103,800),(110104,801),(110105,802),(110106,803),(110107,804),(110108,360),(110109,389),(110110,390),(110111,396),(110112,397),(110113,562),(110114,563),(110115,565),(110116,566),(110117,567),(110118,568),(110119,583),(110120,816),(110121,817),(110122,821),(110123,822),(110124,823),(110125,824),(110126,830),(110127,831),(110128,832),(110129,833),(110130,858),(110131,859),(110132,860),(110133,863),(110134,864),(110135,865),(110136,867),(110137,857),(110138,862),(110139,866),(110140,868),(110141,924),(110142,926),(110143,930),(110144,1006),(110145,1015),(110146,1025),(110147,1026),(110148,1053),(110149,1057),(110150,1112),(110151,1118),(110152,1127),(110153,418),(110154,436),(110155,553),(110156,928),(110157,929),(110158,931),(110159,946),(110160,957),(110161,958),(110162,959),(110163,960),(110164,961),(110165,962),(110166,963),(110167,964),(110168,965),(110169,966),(110170,967),(110171,1059),(110172,1079),(110173,1081),(110174,1083),(110175,1084),(110176,1087),(110177,1089),(110178,311),(110179,332),(110180,333),(110181,336),(110182,337),(110183,878),(110184,879),(110185,970),(110186,971),(110187,973),(110188,974),(110189,975),(110190,988),(110191,1008),(110192,1021),(110193,1094),(110194,1101),(110195,1109),(110196,1115),(110197,1122),(110198,1135),(110199,435),(110200,437),(110201,447),(110202,460),(110203,461),(110204,472),(110205,502),(110206,504),(110207,507),(110208,537),(110209,538),(110210,598),(110211,616),(110212,643),(110213,644),(110214,661),(110215,662),(110216,665),(110217,667),(110218,668),(110219,669),(110220,774),(110221,775),(110222,1040),(110223,351),(110224,352),(110225,356),(110226,357),(110227,361),(110228,471),(110229,473),(110230,605),(110231,609),(110232,635),(110233,671),(110234,675),(110235,676),(110236,678),(110237,679),(110238,776),(110239,777),(110240,788),(110241,358),(110242,565),(110243,566),(110244,750),(110245,787),(110246,794),(110247,798),(110248,799),(110249,803),(110250,804),(110251,821),(110252,822),(110253,830),(110254,857),(110255,858),(110256,866),(110257,1041),(110258,751),(110259,917),(110260,919),(110261,921),(110262,923),(110263,925),(110264,927),(110265,929),(110266,931),(110267,969),(110268,971),(110269,973),(110270,975),(110271,1043),(110272,474),(110273,475),(110274,514),(110275,564),(110276,862),(110277,1044),(110278,1045),(110279,362),(110280,363),(110281,364),(110282,365),(110283,366),(110284,367),(110285,368),(110286,369),(110287,370),(110288,371),(110289,372),(110290,373),(110291,570),(110292,793),(110293,861),(110294,944),(110295,945),(110296,947),(110297,1112),(110298,1118),(110299,626),(110300,629),(110301,630),(110302,946),(110303,988),(110304,989),(110305,990),(110306,991),(110307,519),(110308,520),(110309,523),(110310,525),(110311,916),(110312,1014),(110313,1032),(110314,1040),(110315,1043),(110316,1052),(110317,1056),(110318,1058),(110319,1078),(110320,1080),(110321,1086),(110322,1111),(110323,1117),(110324,1126),(110325,917),(110326,918),(110327,919),(110328,920),(110329,921),(110330,922),(110331,923),(110332,960),(110333,961),(110334,962),(110335,963),(110336,964),(110337,965),(110338,966),(110339,967),(110340,1007),(110341,1093),(110342,1100),(110343,1124),(110344,1134),(110345,400),(110346,480),(110347,482),(110348,499),(110349,515),(110350,882),(110351,884),(110352,885),(110353,886),(110354,887),(110355,890),(110356,892),(110357,894),(110358,895),(110359,898),(110360,899),(110361,1022),(110362,1023),(110363,1106),(110364,458),(110365,883),(110366,888),(110367,889),(110368,891),(110369,893),(110370,896),(110371,897),(110372,900),(110373,901),(110374,1039),(110375,1099),(110376,544),(110377,545),(110378,546),(110379,547),(110380,1060),(110381,1061),(110382,401),(110383,405),(110384,408),(110385,409),(110386,410),(110387,415),(110388,416),(110389,417),(110390,419),(110391,426),(110392,428),(110393,432),(110394,433),(110395,437),(110396,444),(110397,447),(110398,504),(110399,507),(110400,537),(110401,538),(110402,556),(110403,594),(110404,427),(110405,429),(110406,434),(110407,435),(110408,448),(110409,449),(110410,598),(110411,752),(110412,774),(110413,775),(110414,818),(110415,820),(110416,852),(110417,853),(110418,892),(110419,893),(110420,900),(110421,948),(110422,949),(110423,950),(110424,951),(110425,992),(110426,993),(110427,1040),(110428,1047),(110429,1060),(110430,1108),(110431,1114),(110432,994),(110433,995),(110434,1010),(110435,1096),(110436,1103),(110437,1121),(110438,1137),(110439,400),(110440,401),(110441,405),(110442,408),(110443,409),(110444,410),(110445,415),(110446,416),(110447,417),(110448,419),(110449,426),(110450,428),(110451,432),(110452,433),(110453,437),(110454,438),(110455,439),(110456,440),(110457,559),(110458,600),(110459,780),(110460,856),(110461,441),(110462,442),(110463,443),(110464,444),(110465,445),(110466,446),(110467,447),(110468,450),(110469,452),(110470,453),(110471,454),(110472,455),(110473,456),(110474,457),(110475,459),(110476,463),(110477,464),(110478,465),(110479,467),(110480,476),(110481,477),(110482,478),(110483,479),(110484,480),(110485,482),(110486,485),(110487,495),(110488,496),(110489,497),(110490,498),(110491,503),(110492,504),(110493,505),(110494,506),(110495,507),(110496,508),(110497,509),(110498,510),(110499,511),(110500,512),(110501,513),(110502,515),(110503,516),(110504,534),(110505,535),(110506,536),(110507,537),(110508,538),(110509,539),(110510,540),(110511,541),(110512,544),(110513,545),(110514,546),(110515,547),(110516,548),(110517,549),(110518,550),(110519,551),(110520,552),(110521,554),(110522,555),(110523,556),(110524,571),(110525,572),(110526,573),(110527,574),(110528,575),(110529,576),(110530,577),(110531,578),(110532,579),(110533,580),(110534,581),(110535,582),(110536,586),(110537,594),(110538,595),(110539,598),(110540,610),(110541,612),(110542,621),(110543,633),(110544,634),(110545,638),(110546,647),(110547,649),(110548,653),(110549,654),(110550,657),(110551,674),(110552,755),(110553,757),(110554,758),(110555,760),(110556,763),(110557,764),(110558,765),(110559,768),(110560,769),(110561,427),(110562,429),(110563,434),(110564,435),(110565,448),(110566,449),(110567,451),(110568,770),(110569,774),(110570,775),(110571,805),(110572,808),(110573,810),(110574,813),(110575,818),(110576,819),(110577,820),(110578,826),(110579,827),(110580,828),(110581,841),(110582,850),(110583,852),(110584,853),(110585,466),(110586,468),(110587,483),(110588,484),(110589,486),(110590,487),(110591,488),(110592,489),(110593,490),(110594,491),(110595,492),(110596,493),(110597,494),(110598,499),(110599,533),(110600,585),(110601,593),(110602,620),(110603,622),(110604,623),(110605,640),(110606,641),(110607,642),(110608,655),(110609,658),(110610,752),(110611,754),(110612,1020),(110613,756),(110614,759),(110615,761),(110616,762),(110617,767),(110618,773),(110619,806),(110620,807),(110621,811),(110622,812),(110623,829),(110624,842),(110625,844),(110626,845),(110627,846),(110628,847),(110629,848),(110630,849),(110631,851),(110632,854),(110633,909),(110634,910),(110635,912),(110636,932),(110637,933),(110638,935),(110639,940),(110640,941),(110641,943),(110642,1023),(110643,1106),(110644,1013),(110645,1016),(110646,1017),(110647,1027),(110648,1029),(110649,1030),(110650,1031),(110651,1033),(110652,1042),(110653,1046),(110654,1047),(110655,1048),(110656,1107),(110657,1108),(110658,1110),(110659,1113),(110660,1114),(110661,1116),(110662,1128),(110663,882),(110664,884),(110665,885),(110666,886),(110667,887),(110668,890),(110669,892),(110670,894),(110671,895),(110672,897),(110673,898),(110674,899),(110675,900),(110676,1018),(110677,1049),(110678,1051),(110679,1054),(110680,1055),(110681,1065),(110682,1076),(110683,1077),(110684,1082),(110685,1085),(110686,1088),(110687,1090),(110688,1091),(110689,1129),(110690,1130),(110691,1131),(110692,1132),(110693,542),(110694,543),(110695,766),(110696,809),(110697,843),(110698,888),(110699,889),(110700,891),(110701,893),(110702,896),(110703,901),(110704,934),(110705,942),(110706,948),(110707,949),(110708,950),(110709,951),(110710,952),(110711,953),(110712,954),(110713,955),(110714,956),(110715,976),(110716,977),(110717,978),(110718,979),(110719,984),(110720,985),(110721,986),(110722,987),(110723,992),(110724,993),(110725,994),(110726,995),(110727,1009),(110728,1010),(110729,1011),(110730,1095),(110731,1096),(110732,1097),(110733,1098),(110734,1102),(110735,458),(110736,869),(110737,883),(110738,1039),(110739,1099),(110740,1103),(110741,1104),(110742,1105),(110743,1120),(110744,1121),(110745,1123),(110746,1136),(110747,1137),(110748,1138),(110749,1139),(110750,1021),(110751,1022),(110752,2),(110753,1162),(110754,1163),(110755,1164),(110756,1165),(110757,1761),(110758,1762),(110759,1779),(110760,4524),(110761,4524),(110762,1673),(110763,1674),(110764,1790),(110765,4506),(110766,4507),(110767,4508),(110768,4511),(110769,4512),(110770,4513),(110771,4514),(110772,4566),(110773,4567),(110774,4577),(110775,5336),(110776,1332),(110777,4500),(110778,4501),(110779,4502),(110780,4503),(110781,4504),(110782,4505),(110783,4509),(110784,4510),(110785,4515),(110786,4516),(110787,4521),(110788,4522),(110789,4523),(110790,4525),(110791,1210),(110792,4517),(110793,4518),(110794,4519),(110795,4520),(110796,4568),(110797,4569),(110798,4570),(110799,4571),(110800,1749),(110801,1396),(110802,1406),(110803,1427),(110804,5323),(110805,5487),(110806,1208),(110807,1217),(110808,1218),(110809,1219),(110810,1220),(110811,1221),(110812,1222),(110813,1223),(110814,1224),(110815,1225),(110816,1226),(110817,1227),(110818,5330),(110819,5335),(110820,5355),(110821,5520),(110822,5521),(110823,5522),(110824,5523),(110825,1228),(110826,1240),(110827,1241),(110828,1246),(110829,1247),(110830,1310),(110831,1311),(110832,1312),(110833,1313),(110834,1314),(110835,1315),(110836,1316),(110837,1317),(110838,1318),(110839,1319),(110840,1320),(110841,1321),(110842,1322),(110843,1323),(110844,1330),(110845,1331),(110846,1336),(110847,1340),(110848,1344),(110849,1345),(110850,1348),(110851,1352),(110852,1375),(110853,1376),(110854,1377),(110855,1380),(110856,1209),(110857,1239),(110858,1248),(110859,1257),(110860,1258),(110861,1302),(110862,1303),(110863,1381),(110864,1382),(110865,1384),(110866,1385),(110867,1402),(110868,1403),(110869,1404),(110870,1419),(110871,1436),(110872,1450),(110873,1451),(110874,1452),(110875,1454),(110876,1455),(110877,1456),(110878,1457),(110879,1467),(110880,1249),(110881,1250),(110882,1251),(110883,1523),(110884,1533),(110885,1536),(110886,1664),(110887,1667),(110888,1781),(110889,1782),(110890,4572),(110891,5325),(110892,5326),(110893,5327),(110894,5331),(110895,5333),(110896,1252),(110897,1253),(110898,1254),(110899,1255),(110900,1256),(110901,1259),(110902,1260),(110903,1261),(110904,1262),(110905,1263),(110906,1264),(110907,1265),(110908,1266),(110909,1267),(110910,1268),(110911,1269),(110912,1270),(110913,1271),(110914,1272),(110915,1273),(110916,1274),(110917,1275),(110918,1276),(110919,1277),(110920,1278),(110921,1279),(110922,1280),(110923,1281),(110924,1282),(110925,1283),(110926,1284),(110927,1285),(110928,1286),(110929,1287),(110930,1329),(110931,1333),(110932,1334),(110933,1335),(110934,1337),(110935,1339),(110936,1369),(110937,1213),(110938,1214),(110939,1215),(110940,1216),(110941,1293),(110942,1294),(110943,1295),(110944,1296),(110945,1297),(110946,1298),(110947,1299),(110948,1300),(110949,1301),(110950,1370),(110951,1372),(110952,1373),(110953,1374),(110954,1379),(110955,1383),(110956,1389),(110957,1390),(110958,1391),(110959,1392),(110960,1393),(110961,1394),(110962,1395),(110963,1397),(110964,1398),(110965,1399),(110966,1400),(110967,1405),(110968,1465),(110969,5323),(110970,5324),(110971,5328),(110972,5329),(110973,5390),(110974,5474),(110975,5475),(110976,5476),(110977,5477),(110978,5478),(110979,5479),(110980,5480),(110981,5481),(110982,5482),(110983,5483),(110984,5484),(110985,5485),(110986,5486),(110987,5704),(110988,5705),(110989,5706),(110990,1195),(110991,1196),(110992,1197),(110993,1198),(110994,1199),(110995,1200),(110996,1201),(110997,1202),(110998,1203),(110999,1204),(111000,1205),(111001,1206),(111002,1207),(111003,1211),(111004,1212),(111005,1229),(111006,1230),(111007,1233),(111008,1236),(111009,5487),(111010,5488),(111011,1237),(111012,1288),(111013,1289),(111014,1290),(111015,1291),(111016,1292),(111017,1304),(111018,1305),(111019,1306),(111020,1307),(111021,1308),(111022,1309),(111023,1325),(111024,1328),(111025,1338),(111026,1341),(111027,1346),(111028,1347),(111029,1350),(111030,1351),(111031,1359),(111032,1360),(111033,1361),(111034,1362),(111035,1363),(111036,1364),(111037,1365),(111038,1366),(111039,1367),(111040,1368),(111041,1387),(111042,1401),(111043,1410),(111044,1426),(111045,1438),(111046,1439),(111047,1443),(111048,1444),(111049,1445),(111050,1231),(111051,1232),(111052,1234),(111053,1242),(111054,1243),(111055,1244),(111056,1245),(111057,1342),(111058,1349),(111059,1411),(111060,1446),(111061,1448),(111062,1466),(111063,1353),(111064,1354),(111065,1355),(111066,1356),(111067,1357),(111068,1358),(111069,1412),(111070,1413),(111071,1414),(111072,1415),(111073,1416),(111074,1437),(111075,1440),(111076,1449),(111077,1453),(111078,1464),(111079,1468),(111080,5327),(111081,5334),(111082,5370),(111083,5371),(111084,5372),(111085,5373),(111086,5374),(111087,5375),(111088,5376),(111089,5377),(111090,1447),(111091,5351),(111092,5352),(111093,5356),(111094,5390),(111095,1420),(111096,1421),(111097,1422),(111098,1423),(111099,1424),(111100,1425),(111101,1427),(111102,1428),(111103,1429),(111104,1430),(111105,1431),(111106,1432),(111107,1433),(111108,1434),(111109,1558),(111110,1559),(111111,5332),(111112,1168),(111113,1170),(111114,1171),(111115,1172),(111116,1173),(111117,1182),(111118,1183),(111119,1235),(111120,1324),(111121,1326),(111122,1327),(111123,1329),(111124,1343),(111125,1371),(111126,1532),(111127,5332),(111128,5337),(111129,5343),(111130,5344),(111131,5351),(111132,5352),(111133,5354),(111134,5474),(111135,5476),(111136,5526),(111137,1386),(111138,1388),(111139,1407),(111140,1408),(111141,1409),(111142,1417),(111143,1418),(111144,1435),(111145,1441),(111146,1442),(111147,1458),(111148,1459),(111149,1461),(111150,1469),(111151,1488),(111152,1489),(111153,1491),(111154,1492),(111155,1494),(111156,5489),(111157,1188),(111158,1524),(111159,1526),(111160,1528),(111161,1666),(111162,1529),(111163,1534),(111164,1535),(111165,1557),(111166,1799),(111167,1800),(111168,1175),(111169,1176),(111170,1177),(111171,1178),(111172,1179),(111173,1180),(111174,1181),(111175,1185),(111176,1186),(111177,1187),(111178,1190),(111179,1192),(111180,1193),(111181,1518),(111182,1519),(111183,1520),(111184,1521),(111185,1563),(111186,1564),(111187,1565),(111188,1665),(111189,1675),(111190,1676),(111191,1677),(111192,1678),(111193,1751),(111194,1752),(111195,1753),(111196,1761),(111197,1762),(111198,1778),(111199,1779),(111200,377),(111201,378),(111202,379),(111203,380),(111204,381),(111205,382),(111206,383),(111207,384),(111208,385),(111209,386),(111210,387),(111211,388),(111212,391),(111213,392),(111214,394),(111215,395),(111216,1527),(111217,1522),(111218,1525),(111219,1530),(111220,1534),(111221,1535),(111222,1661),(111223,1662),(111224,1663),(111225,1668),(111226,1669),(111227,1670),(111228,1671),(111229,1745),(111230,1747),(111231,1794),(111232,1801),(111233,1802),(111234,1191),(111235,1522),(111236,1524),(111237,1525),(111238,1526),(111239,1528),(111240,1529),(111241,1530),(111242,1531),(111243,1535),(111244,1661),(111245,1662),(111246,1663),(111247,1177),(111248,1178),(111249,1179),(111250,1180),(111251,1181),(111252,1563),(111253,1564),(111254,1565),(111255,1566),(111256,1675),(111257,1676),(111258,1677),(111259,1678),(111260,1761),(111261,1762),(111262,1778),(111263,1779),(111264,356),(111265,607),(111266,608),(111267,1518),(111268,1519),(111269,1520),(111270,1521),(111271,1665),(111272,1666),(111273,1751),(111274,1752),(111275,1753),(111276,1754),(111277,1755),(111278,1756),(111279,1757),(111280,1758),(111281,1786),(111282,1787),(111283,1788),(111284,1789),(111285,1790),(111286,389),(111287,390),(111288,396),(111289,397),(111290,563),(111291,606),(111292,777),(111293,789),(111294,795),(111295,798),(111296,799),(111297,800),(111298,801),(111299,802),(111300,803),(111301,804),(111302,823),(111303,832),(111304,833),(111305,830),(111306,831),(111307,859),(111308,860),(111309,866),(111310,867),(111311,868),(111312,1189),(111313,1522),(111314,1524),(111315,1525),(111316,1526),(111317,1527),(111318,1528),(111319,1669),(111320,1671),(111321,1745),(111322,1422),(111323,1529),(111324,1530),(111325,1531),(111326,1534),(111327,1535),(111328,1587),(111329,1661),(111330,1662),(111331,1663),(111332,1668),(111333,1670),(111334,1672),(111335,1744),(111336,1746),(111337,1793),(111338,1794),(111339,1795),(111340,1799),(111341,1800),(111342,1801),(111343,1802),(111344,2),(111345,4),(111346,1162),(111347,1163),(111348,1164),(111349,1165),(111350,2449),(111351,5394),(111352,5489),(111353,1471),(111354,1567),(111355,5282),(111356,5283),(111357,5284),(111358,5301),(111359,5389),(111360,5393),(111361,5394),(111362,5395),(111363,5468),(111364,5489),(111365,5598),(111366,5650),(111367,5673),(111368,1700),(111369,2699),(111370,5365),(111371,5527),(111372,5528),(111373,5621),(111374,5627),(111375,5637),(111376,5644),(111377,5645),(111378,5646),(111379,5652),(111380,5654),(111381,5663),(111382,5670),(111383,5671),(111384,5672),(111385,5490),(111386,5491),(111387,5492),(111388,5493),(111389,5494),(111390,5495),(111391,5496),(111392,5497),(111393,5498),(111394,5499),(111395,5500),(111396,5501),(111397,5502),(111398,5503),(111399,5504),(111400,5505),(111401,5506),(111402,5507),(111403,5508),(111404,5509),(111405,5510),(111406,5511),(111407,5512),(111408,5513),(111409,5514),(111410,5515),(111411,5516),(111412,5517),(111413,2921),(111414,5359),(111415,5360),(111416,5367),(111417,5529),(111418,5530),(111419,5363),(111420,5366),(111421,5636),(111422,5651),(111423,5662),(111424,4622),(111425,4623),(111426,4624),(111427,4853),(111428,4854),(111429,4855),(111430,4888),(111431,5598),(111432,5660),(111433,5695),(111434,1184),(111435,1238),(111436,1378),(111437,1462),(111438,5361),(111439,5362),(111440,5364),(111441,5626),(111442,5639),(111443,5640),(111444,5648),(111445,5665),(111446,5666),(111447,5628),(111448,5646),(111449,5672),(111450,2126),(111451,2127),(111452,2128),(111453,2129),(111454,2130),(111455,2131),(111456,2132),(111457,2323),(111458,2324),(111459,2449),(111460,2427),(111461,2126),(111462,2127),(111463,2128),(111464,2129),(111465,2130),(111466,2131),(111467,2132),(111468,2323),(111469,2324),(111470,2449),(111471,1816),(111472,1818),(111473,1822),(111474,1827),(111475,1965),(111476,1966),(111477,1972),(111478,1983),(111479,1984),(111480,1986),(111481,2008),(111482,2013),(111483,2014),(111484,2035),(111485,2037),(111486,2041),(111487,1813),(111488,1815),(111489,1820),(111490,1973),(111491,1974),(111492,1975),(111493,1976),(111494,1977),(111495,1978),(111496,1979),(111497,1980),(111498,1982),(111499,1985),(111500,1987),(111501,1988),(111502,1989),(111503,1990),(111504,1814),(111505,1817),(111506,1819),(111507,1821),(111508,1823),(111509,1824),(111510,1825),(111511,1826),(111512,1967),(111513,1968),(111514,1971),(111515,1981),(111516,2299),(111517,2404),(111518,2531),(111519,5622),(111520,5641),(111521,5667),(111522,1828),(111523,1829),(111524,1830),(111525,1831),(111526,1832),(111527,1833),(111528,1950),(111529,1952),(111530,1969),(111531,1970),(111532,2021),(111533,2022),(111534,2154),(111535,2177),(111536,2221),(111537,2222),(111538,2435),(111539,2540),(111540,2541),(111541,2542),(111542,2265),(111543,2266),(111544,2267),(111545,2268),(111546,2269),(111547,2276),(111548,2317),(111549,2318),(111550,2319),(111551,2320),(111552,2321),(111553,2322),(111554,2397),(111555,2398),(111556,2399),(111557,2400),(111558,2401),(111559,2403),(111560,2405),(111561,2406),(111562,2407),(111563,2408),(111564,2409),(111565,2410),(111566,2589),(111567,2590),(111568,2591),(111569,2592),(111570,2593),(111571,2594),(111572,2595),(111573,2598),(111574,2599),(111575,2600),(111576,2601),(111577,2602),(111578,2603),(111579,2604),(111580,2605),(111581,2606),(111582,2607),(111583,2596),(111584,2597),(111585,2608),(111586,2609),(111587,2610),(111588,2611),(111589,2612),(111590,2613),(111591,2614),(111592,4894),(111593,4894),(111594,4894),(111595,4894),(111596,4894),(111597,5753),(111598,5753),(111599,5753),(111600,5753),(111601,5753),(111602,5753),(111603,5753),(111604,5753),(111605,5753),(111606,5753),(111607,5753),(111608,5753),(111609,5753),(111610,2176),(111611,2176),(111612,2176),(111613,2176),(111614,2176),(111615,5753),(111616,5753),(111617,5753),(111618,5753),(111619,5753),(111620,5753),(111621,5753),(111622,5753),(111623,5753),(111624,5753),(111625,5753),(111626,7),(111627,7),(111628,7),(111629,7),(111630,7),(111631,7),(111632,7),(111633,7),(111634,7),(111635,7),(111636,7),(111637,7),(111638,7),(111639,7),(111640,7),(111641,7),(111642,7),(111643,7),(111644,7),(111645,7),(111646,7),(111647,7),(111648,7),(111649,7),(111650,7),(111651,7),(111652,5757),(111653,5757),(111654,5757),(111655,5757),(111656,5757),(111657,5757),(111658,5757),(111659,5757),(111660,5757),(111661,5757),(111662,5757),(111663,5757),(111664,5757),(111665,5757),(111666,5757),(111667,5757),(111668,5757),(111669,5757),(111670,5757),(111671,5757),(111672,5757),(111673,5757),(111674,5757),(111675,5757),(111676,5757),(111677,5757),(111678,5758),(111679,5758),(111680,5758),(111681,5758),(111682,5758),(111683,5758),(111684,5758),(111685,5758),(111686,5758),(111687,5758),(111688,5758),(111689,5758),(111690,5758),(111691,5758),(111692,5758),(111693,5758),(111694,5758),(111695,5758),(111696,5758),(111697,5758),(111698,5758),(111699,5758),(111700,5758),(111701,5758),(111702,5758),(111703,5758),(111704,5759),(111705,5759),(111706,5759),(111707,5759),(111708,5759),(111709,5759),(111710,5759),(111711,5759),(111712,5759),(111713,5759),(111714,5759),(111715,5759),(111716,5759),(111717,5759),(111718,5759),(111719,5759),(111720,5759),(111721,5759),(111722,5759),(111723,5759),(111724,5759),(111725,5759),(111726,5759),(111727,5759),(111728,5759),(111729,5759),(111730,1165),(111731,1165),(111732,1165),(111733,1165),(111734,5757),(111735,5758),(111736,5759),(111737,1165),(111738,1165),(111739,1165),(111740,7),(111741,7),(111742,7),(111743,7),(111744,7),(111745,7),(111746,7),(111747,7),(111748,7),(111749,7),(111750,7),(111751,7),(111752,7),(111753,7),(111754,7),(111755,7),(111756,7),(111757,7),(111758,7),(111759,7),(111760,7),(111761,7),(111762,7),(111763,7),(111764,7),(111765,7),(111766,2026),(111767,2027),(111768,2028),(111769,2029),(111770,2030),(111771,2031),(111772,2032),(111773,2034),(111774,2039),(111775,2040),(111776,2042),(111777,2044),(111778,2045),(111779,2046),(111780,2122),(111781,2123),(111782,2124),(111783,2125),(111784,2133),(111785,2134),(111786,2135),(111787,2136),(111788,2137),(111789,2138),(111790,2139),(111791,2140),(111792,2141),(111793,2142),(111794,2143),(111795,2144),(111796,2145),(111797,2146),(111798,2147),(111799,2148),(111800,2149),(111801,2150),(111802,2151),(111803,2152),(111804,2153),(111805,2275),(111806,2325),(111807,2326),(111808,2327),(111809,2328),(111810,2329),(111811,2330),(111812,2331),(111813,2332),(111814,2333),(111815,2334),(111816,2335),(111817,2336),(111818,2337),(111819,2338),(111820,2339),(111821,2340),(111822,2341),(111823,2342),(111824,2343),(111825,2344),(111826,2345),(111827,2346),(111828,2347),(111829,2348),(111830,2349),(111831,2350),(111832,2351),(111833,2352),(111834,2353),(111835,2354),(111836,2355),(111837,2356),(111838,2357),(111839,2358),(111840,2359),(111841,2360),(111842,2361),(111843,2362),(111844,2363),(111845,2364),(111846,2365),(111847,2366),(111848,2367),(111849,2368),(111850,2369),(111851,2370),(111852,2371),(111853,2372),(111854,2373),(111855,2374),(111856,2375),(111857,2376),(111858,2377),(111859,2378),(111860,2379),(111861,2380),(111862,2381),(111863,2382),(111864,2383),(111865,2384),(111866,2385),(111867,2386),(111868,2387),(111869,2388),(111870,2389),(111871,2390),(111872,2391),(111873,2559),(111874,7),(111875,7),(111876,7),(111877,7),(111878,7),(111879,7),(111880,7),(111881,7),(111882,7),(111883,7),(111884,7),(111885,7),(111886,7),(111887,7),(111888,7),(111889,7),(111890,7),(111891,7),(111892,7),(111893,7),(111894,7),(111895,7),(111896,7),(111897,7),(111898,7),(111899,7),(111900,7),(111901,7),(111902,7),(111903,7),(111904,7),(111905,7),(111906,7),(111907,7),(111908,7),(111909,7),(111910,7),(111911,7),(111912,7),(111913,7),(111914,7),(111915,7),(111916,7),(111917,7),(111918,7),(111919,7),(111920,7),(111921,7),(111922,7),(111923,7),(111924,7),(111925,7),(111926,7),(111927,7),(111928,7),(111929,7),(111930,7),(111931,7),(111932,51),(111933,51),(111934,51),(111935,51),(111936,51),(111937,51),(111938,51),(111939,51),(111940,51),(111941,51),(111942,51),(111943,51),(111944,51),(111945,51),(111946,51),(111947,51),(111948,51),(111949,51),(111950,51),(111951,51),(111952,51),(111953,51),(111954,51),(111955,221),(111956,221),(111957,221),(111958,221),(111959,221),(111960,221),(111961,221),(111962,221),(111963,221),(111964,221),(111965,221),(111966,221),(111967,221),(111968,221),(111969,221),(111970,221),(111971,112),(111972,112),(111973,112),(111974,112),(111975,112),(111976,112),(111977,112),(111978,112),(111979,112),(111980,112),(111981,112),(111982,112),(111983,112),(111984,112),(111985,112),(111986,18),(111987,18),(111988,18),(111989,18),(111990,18),(111991,18),(111992,18),(111993,18),(111994,18),(111995,18),(111996,18),(111997,18),(111998,18),(111999,18),(112000,18),(112001,1623),(112002,1623),(112003,1623),(112004,1623),(112005,1623),(112006,1623),(112007,1623),(112008,1623),(112009,1623),(112010,1623),(112011,1623),(112012,1623),(112013,1623),(112014,1623),(112015,1623),(112016,1623),(112017,2289),(112018,2289),(112019,2289),(112020,2289),(112021,2289),(112022,2289),(112023,2289),(112024,2289),(112025,2289),(112026,2289),(112027,2289),(112028,2289),(112029,2289),(112030,2289),(112031,2289),(112032,2289),(112033,2289),(112034,2289),(112035,2289),(112036,2289),(112037,2289),(112038,1165),(112039,1164),(112040,1164),(112041,1164),(112042,1164),(112043,1164),(112044,1162),(112045,1162),(112046,1162),(112047,1162),(112048,1162),(112049,1165),(112050,4370),(112051,4371),(112052,4372),(112053,4373),(112054,4374),(112055,4375),(112056,4376),(112057,4377),(112058,4378),(112059,4379),(112060,4380),(112061,4381),(112062,4382),(112063,4383),(112064,4384),(112065,4385),(112066,4386),(112067,4387),(112068,4388),(112069,4389),(112070,1629),(112071,1630),(112072,1631),(112073,1632),(112074,1633),(112075,1634),(112076,1635),(112077,1681),(112078,1682),(112079,1683),(112080,1684),(112081,1685),(112082,1686),(112083,4368),(112084,4369),(112085,2704),(112086,2705),(112087,2706),(112088,2707),(112089,2708),(112090,2709),(112091,2710),(112092,2711),(112093,2712),(112094,2713),(112095,2714),(112096,2715),(112097,2716),(112098,2717),(112099,2718),(112100,2719),(112101,2720),(112102,2721),(112103,2722),(112104,2723),(112105,2724),(112106,2725),(112107,2726),(112108,2727),(112109,2728),(112110,2729),(112111,2730),(112112,2731),(112113,2732),(112114,2733),(112115,2734),(112116,2735),(112117,2736),(112118,2737),(112119,2738),(112120,2739),(112121,2740),(112122,2741),(112123,2742),(112124,2743),(112125,2744),(112126,2745),(112127,2746),(112128,2747),(112129,2748),(112130,2749),(112131,2750),(112132,2751),(112133,2752),(112134,2753),(112135,2754),(112136,2755),(112137,2756),(112138,2757),(112139,2758),(112140,2759),(112141,2797),(112142,2857),(112143,2894),(112144,2904),(112145,2977),(112146,2988),(112147,3118),(112148,3623),(112149,7),(112150,8),(112151,9),(112152,10),(112153,11),(112154,12),(112155,13),(112156,14),(112157,15),(112158,16),(112159,17),(112160,18),(112161,19),(112162,20),(112163,21),(112164,22),(112165,23),(112166,24),(112167,25),(112168,26),(112169,27),(112170,28),(112171,29),(112172,30),(112173,31),(112174,32),(112175,33),(112176,34),(112177,35),(112178,36),(112179,37),(112180,38),(112181,45),(112182,46),(112183,47),(112184,48),(112185,49),(112186,50),(112187,51),(112188,52),(112189,53),(112190,54),(112191,55),(112192,56),(112193,57),(112194,58),(112195,59),(112196,60),(112197,61),(112198,62),(112199,63),(112200,64),(112201,65),(112202,66),(112203,67),(112204,68),(112205,69),(112206,70),(112207,71),(112208,72),(112209,73),(112210,74),(112211,75),(112212,76),(112213,77),(112214,78),(112215,79),(112216,80),(112217,81),(112218,82),(112219,83),(112220,84),(112221,85),(112222,86),(112223,87),(112224,88),(112225,89),(112226,90),(112227,91),(112228,92),(112229,93),(112230,94),(112231,95),(112232,110),(112233,111),(112234,112),(112235,113),(112236,114),(112237,115),(112238,116),(112239,117),(112240,118),(112241,119),(112242,120),(112243,121),(112244,122),(112245,123),(112246,124),(112247,125),(112248,126),(112249,127),(112250,128),(112251,129),(112252,130),(112253,131),(112254,132),(112255,133),(112256,134),(112257,135),(112258,136),(112259,137),(112260,140),(112261,141),(112262,142),(112263,143),(112264,144),(112265,145),(112266,146),(112267,147),(112268,148),(112269,149),(112270,150),(112271,151),(112272,152),(112273,153),(112274,154),(112275,155),(112276,156),(112277,157),(112278,158),(112279,159),(112280,1567),(112281,5378),(112282,5379),(112283,5380),(112284,5381),(112285,5382),(112286,5383),(112287,5384),(112288,5385),(112289,5386),(112290,5387),(112291,5388),(112292,5389),(112293,5391),(112294,5392),(112295,5673),(112296,5750),(112297,5751),(112298,1002),(112299,1003),(112300,1005),(112301,1034),(112302,1035),(112303,1036),(112304,1038),(112305,1133),(112306,1972),(112307,1973),(112308,1974),(112309,1975),(112310,1976),(112311,1977),(112312,1978),(112313,1979),(112314,1980),(112315,1981),(112316,1982),(112317,1983),(112318,1984),(112319,1985),(112320,1986),(112321,1987),(112322,1988),(112323,1989),(112324,1990),(112325,1991),(112326,2003),(112327,2004),(112328,2005),(112329,2006),(112330,2007),(112331,2008),(112332,2009),(112333,2010),(112334,2011),(112335,2012),(112336,2013),(112337,2014),(112338,2015),(112339,2016),(112340,2017),(112341,2018),(112342,2019),(112343,2020),(112344,2021),(112345,2022),(112346,2023),(112347,2024),(112348,2025),(112349,2033),(112350,2035),(112351,2036),(112352,2037),(112353,2038),(112354,2041),(112355,2043),(112356,2047),(112357,2048),(112358,2049),(112359,2050),(112360,2051),(112361,2052),(112362,2053),(112363,2054),(112364,2055),(112365,2056),(112366,2057),(112367,2058),(112368,2059),(112369,2060),(112370,2061),(112371,2062),(112372,2063),(112373,2064),(112374,2065),(112375,2066),(112376,2067),(112377,2068),(112378,2069),(112379,2070),(112380,2071),(112381,2072),(112382,2073),(112383,2074),(112384,2075),(112385,2076),(112386,2077),(112387,2078),(112388,2079),(112389,2080),(112390,2081),(112391,2082),(112392,2083),(112393,2084),(112394,2085),(112395,2086),(112396,2087),(112397,2088),(112398,2089),(112399,2090),(112400,2091),(112401,2092),(112402,2093),(112403,2094),(112404,2095),(112405,2096),(112406,2097),(112407,2098),(112408,2099),(112409,2100),(112410,2101),(112411,2102),(112412,2103),(112413,2104),(112414,2105),(112415,2106),(112416,2107),(112417,2108),(112418,2109),(112419,2110),(112420,2111),(112421,2112),(112422,2113),(112423,2114),(112424,2115),(112425,2116),(112426,2117),(112427,2118),(112428,2119),(112429,2120),(112430,2121),(112431,2155),(112432,2156),(112433,2157),(112434,2165),(112435,2166),(112436,2167),(112437,2168),(112438,2169),(112439,2178),(112440,2179),(112441,2180),(112442,2221),(112443,2222),(112444,2252),(112445,2253),(112446,2254),(112447,2255),(112448,2263),(112449,2264),(112450,2272),(112451,2273),(112452,2274),(112453,2283),(112454,2284),(112455,2285),(112456,2286),(112457,2287),(112458,2288),(112459,2450),(112460,2451),(112461,2452),(112462,2453),(112463,2465),(112464,2466),(112465,2467),(112466,2468),(112467,2469),(112468,2470),(112469,2471),(112470,2501),(112471,2502),(112472,2552),(112473,2555),(112474,2556),(112475,2557),(112476,2558),(112477,2560),(112478,2561),(112479,2562),(112480,2563),(112481,2564),(112482,2565),(112483,2566),(112484,2567),(112485,2568),(112486,2569),(112487,2570),(112488,2571),(112489,2572),(112490,2588),(112491,2615),(112492,2616),(112493,2617),(112494,2618),(112495,2619),(112496,2620),(112497,2621),(112498,681),(112499,682),(112500,687),(112501,688),(112502,690),(112503,691),(112504,692),(112505,693),(112506,694),(112507,695),(112508,696),(112509,697),(112510,698),(112511,699),(112512,700),(112513,701),(112514,702),(112515,703),(112516,704),(112517,705),(112518,706),(112519,707),(112520,708),(112521,711),(112522,713),(112523,714),(112524,718),(112525,719),(112526,720),(112527,721),(112528,722),(112529,723),(112530,724),(112531,725),(112532,732),(112533,733),(112534,734),(112535,737),(112536,738),(112537,739),(112538,740),(112539,741),(112540,742),(112541,743),(112542,744),(112543,745),(112544,746),(112545,747),(112546,748),(112547,749),(112548,996),(112549,997),(112550,998),(112551,999),(112552,1000),(112553,1001),(112554,683),(112555,684),(112556,685),(112557,686),(112558,689),(112559,709),(112560,710),(112561,712),(112562,715),(112563,716),(112564,717),(112565,726),(112566,727),(112567,728),(112568,729),(112569,730),(112570,731),(112571,735),(112572,736),(112573,3028),(112574,3029),(112575,3030),(112576,3031),(112577,3032),(112578,3033),(112579,3034),(112580,3035),(112581,3036),(112582,3037),(112583,3038),(112584,3039),(112585,3040),(112586,3041),(112587,3044),(112588,3045),(112589,3046),(112590,3047),(112591,3048),(112592,3049),(112593,3056),(112594,3057),(112595,3058),(112596,3059),(112597,3060),(112598,3061),(112599,3062),(112600,3063),(112601,3064),(112602,3065),(112603,3066),(112604,3067),(112605,3068),(112606,3069),(112607,3070),(112608,3071),(112609,3072),(112610,3073),(112611,3074),(112612,3075),(112613,3076),(112614,3077),(112615,3078),(112616,3079),(112617,3080),(112618,3081),(112619,3082),(112620,3083),(112621,3084),(112622,3085),(112623,3086),(112624,3087),(112625,3088),(112626,3089),(112627,3090),(112628,3091),(112629,3092),(112630,3093),(112631,3094),(112632,3095),(112633,3096),(112634,3097),(112635,3098),(112636,3099),(112637,3100),(112638,3101),(112639,3103),(112640,3104),(112641,3105),(112642,3106),(112643,3107),(112644,3108),(112645,3109),(112646,3110),(112647,3111),(112648,3112),(112649,3113),(112650,3114),(112651,3115),(112652,3116),(112653,3117),(112654,3119),(112655,3120),(112656,3121),(112657,3122),(112658,3123),(112659,3124),(112660,3528),(112661,3529),(112662,3530),(112663,3531),(112664,3532),(112665,3533),(112666,3537),(112667,3538),(112668,3543),(112669,3544),(112670,3545),(112671,3546),(112672,3547),(112673,3548),(112674,3549),(112675,3550),(112676,3551),(112677,3552),(112678,3553),(112679,3554),(112680,3555),(112681,3556),(112682,3557),(112683,3558),(112684,3559),(112685,3560),(112686,3561),(112687,3562),(112688,3563),(112689,3564),(112690,3565),(112691,3566),(112692,3567),(112693,3568),(112694,3569),(112695,3570),(112696,3571),(112697,3572),(112698,3581),(112699,3582),(112700,3584),(112701,3585),(112702,3586),(112703,3587),(112704,3588),(112705,3589),(112706,3590),(112707,3591),(112708,3610),(112709,3611),(112710,3612),(112711,3613),(112712,3614),(112713,3615),(112714,3616),(112715,3617),(112716,3618),(112717,3619),(112718,3620),(112719,3621),(112720,3622),(112721,3624),(112722,3625),(112723,3626),(112724,3627),(112725,3628),(112726,3629),(112727,3630),(112728,3631),(112729,3632),(112730,3633),(112731,3634),(112732,3635),(112733,3636),(112734,3637),(112735,3638),(112736,3639),(112737,3640),(112738,3641),(112739,3642),(112740,3643),(112741,3644),(112742,3645),(112743,3646),(112744,3647),(112745,3649),(112746,3650),(112747,3651),(112748,3652),(112749,3653),(112750,3654),(112751,3655),(112752,3656),(112753,3657),(112754,3658),(112755,3659),(112756,3660),(112757,3661),(112758,3662),(112759,3663),(112760,3664),(112761,3665),(112762,3666),(112763,3667),(112764,3668),(112765,3669),(112766,3670),(112767,3671),(112768,3672),(112769,3673),(112770,3674),(112771,3684),(112772,3685),(112773,2701),(112774,2702),(112775,2760),(112776,2761),(112777,2762),(112778,2763),(112779,2764),(112780,2765),(112781,2772),(112782,2774),(112783,2775),(112784,2776),(112785,2777),(112786,2778),(112787,2779),(112788,2780),(112789,2783),(112790,2784),(112791,2785),(112792,2786),(112793,2787),(112794,2788),(112795,2789),(112796,2790),(112797,2791),(112798,2792),(112799,2799),(112800,2800),(112801,2801),(112802,2802),(112803,2803),(112804,2804),(112805,2805),(112806,2806),(112807,2807),(112808,2808),(112809,2809),(112810,2810),(112811,2811),(112812,2812),(112813,2813),(112814,2814),(112815,2815),(112816,2816),(112817,2817),(112818,2818),(112819,2819),(112820,2820),(112821,2822),(112822,2823),(112823,2824),(112824,2825),(112825,2826),(112826,2827),(112827,2831),(112828,2832),(112829,2844),(112830,2845),(112831,2846),(112832,2847),(112833,2848),(112834,2849),(112835,2850),(112836,2851),(112837,2852),(112838,2853),(112839,2854),(112840,2855),(112841,2856),(112842,2859),(112843,2860),(112844,2861),(112845,2862),(112846,2864),(112847,2865),(112848,2868),(112849,2869),(112850,2870),(112851,2871),(112852,2872),(112853,2873),(112854,2874),(112855,2875),(112856,2876),(112857,2877),(112858,2878),(112859,2879),(112860,2880),(112861,2881),(112862,2882),(112863,2883),(112864,2884),(112865,2885),(112866,2886),(112867,2887),(112868,2888),(112869,2889),(112870,2892),(112871,2893),(112872,2900),(112873,2901),(112874,2902),(112875,2903),(112876,2905),(112877,2906),(112878,2907),(112879,2908),(112880,2909),(112881,2910),(112882,2911),(112883,2912),(112884,2913),(112885,2914),(112886,2915),(112887,2916),(112888,2955),(112889,2956),(112890,2957),(112891,2958),(112892,2959),(112893,2960),(112894,2961),(112895,2962),(112896,2963),(112897,2964),(112898,2965),(112899,2966),(112900,2967),(112901,2968),(112902,2981),(112903,2982),(112904,2983),(112905,2984),(112906,2985),(112907,2986),(112908,2991),(112909,2992),(112910,3013),(112911,3014),(112912,3015),(112913,3016),(112914,3017),(112915,3018),(112916,3019),(112917,3020),(112918,3021),(112919,3022),(112920,3023),(112921,3024),(112922,3025),(112923,3026),(112924,3027),(112925,4147),(112926,4148),(112927,4149),(112928,4152),(112929,4153),(112930,4154),(112931,4156),(112932,4168),(112933,4248),(112934,4297),(112935,4298),(112936,4299),(112937,4300),(112938,4301),(112939,4302),(112940,4303),(112941,4304),(112942,4359),(112943,4458),(112944,4459),(112945,3842),(112946,3846),(112947,3882),(112948,3903),(112949,3973),(112950,4057),(112951,4127),(112952,4128),(112953,4129),(112954,4130),(112955,4131),(112956,4132),(112957,4133),(112958,4134),(112959,4135),(112960,4136),(112961,4137),(112962,4138),(112963,4139),(112964,4140),(112965,4141),(112966,4145),(112967,4146),(112968,3767),(112969,3768),(112970,3769),(112971,3770),(112972,3771),(112973,3772),(112974,3773),(112975,3775),(112976,3868),(112977,3874),(112978,3884),(112979,3889),(112980,3904),(112981,3905),(112982,3913),(112983,3914),(112984,3915),(112985,3916),(112986,3917),(112987,3963),(112988,3970),(112989,3974),(112990,3989),(112991,4039),(112992,4079),(112993,4119),(112994,4247),(112995,4259),(112996,4261),(112997,4262),(112998,4270),(112999,4284),(113000,4285),(113001,4291),(113002,4293),(113003,4336),(113004,4357),(113005,4360),(113006,4422),(113007,4424),(113008,4468),(113009,4480),(113010,3776),(113011,3777),(113012,3778),(113013,3779),(113014,3780),(113015,3781),(113016,3782),(113017,3783),(113018,3788),(113019,3789),(113020,3790),(113021,3791),(113022,3792),(113023,3793),(113024,3794),(113025,3795),(113026,3796),(113027,3797),(113028,3798),(113029,3799),(113030,3800),(113031,3801),(113032,3802),(113033,3803),(113034,3804),(113035,3805),(113036,3806),(113037,3807),(113038,3808),(113039,3809),(113040,3810),(113041,3811),(113042,3812),(113043,3813),(113044,3814),(113045,3815),(113046,3816),(113047,3817),(113048,3818),(113049,3819),(113050,3820),(113051,3821),(113052,3822),(113053,3823),(113054,3824),(113055,3825),(113056,3826),(113057,3836),(113058,3837),(113059,3838),(113060,3839),(113061,3840),(113062,3841),(113063,3918),(113064,3941),(113065,3942),(113066,3972),(113067,3977),(113068,3978),(113069,3979),(113070,3980),(113071,3981),(113072,3982),(113073,3983),(113074,3984),(113075,3985),(113076,3986),(113077,3987),(113078,3988),(113079,4080),(113080,4081),(113081,4082),(113082,4083),(113083,4084),(113084,4085),(113085,4086),(113086,4087),(113087,4088),(113088,4089),(113089,4090),(113090,4091),(113091,4195),(113092,4196),(113093,4197),(113094,4198),(113095,4204),(113096,4205),(113097,4206),(113098,4207),(113099,4208),(113100,4209),(113101,4210),(113102,4211),(113103,4222),(113104,4223),(113105,4224),(113106,4225),(113107,4226),(113108,4227),(113109,4228),(113110,4229),(113111,4230),(113112,4231),(113113,4232),(113114,4233),(113115,4234),(113116,4235),(113117,4236),(113118,4237),(113119,4238),(113120,4275),(113121,4276),(113122,4292),(113123,4425),(113124,4432),(113125,4433),(113126,4481),(113127,4482),(113128,4483),(113129,4484),(113130,4485),(113131,4486),(113132,4487),(113133,4488),(113134,4489),(113135,4490),(113136,3835),(113137,4012),(113138,4013),(113139,4014),(113140,4015),(113141,4016),(113142,4017),(113143,4018),(113144,4019),(113145,4020),(113146,4021),(113147,4022),(113148,4023),(113149,4024),(113150,4025),(113151,4026),(113152,4027),(113153,4028),(113154,4029),(113155,4030),(113156,4031),(113157,4032),(113158,4033),(113159,4034),(113160,4035),(113161,4036),(113162,4037),(113163,4356),(113164,4402),(113165,4403),(113166,4404),(113167,4405),(113168,4406),(113169,4407),(113170,4408),(113171,4409),(113172,4410),(113173,4411),(113174,4412),(113175,4413),(113176,4414),(113177,4415),(113178,4417),(113179,4418),(113180,4419),(113181,4426),(113182,4427),(113183,3787),(113184,3871),(113185,3893),(113186,3894),(113187,3895),(113188,3923),(113189,3924),(113190,3925),(113191,3926),(113192,3927),(113193,3928),(113194,3929),(113195,3930),(113196,3931),(113197,3932),(113198,3933),(113199,3934),(113200,3935),(113201,3936),(113202,3937),(113203,3938),(113204,3966),(113205,3967),(113206,3968),(113207,3969),(113208,4167),(113209,4193),(113210,4194),(113211,4249),(113212,4250),(113213,4251),(113214,4252),(113215,4253),(113216,4254),(113217,4255),(113218,4256),(113219,4274),(113220,4346),(113221,4347),(113222,4348),(113223,4349),(113224,4350),(113225,4351),(113226,4352),(113227,4353),(113228,4354),(113229,4355),(113230,4611),(113231,4615),(113232,4616),(113233,4617),(113234,4618),(113235,4619),(113236,4620),(113237,4625),(113238,4626),(113239,4677),(113240,4678),(113241,4679),(113242,4681),(113243,4682),(113244,4683),(113245,4684),(113246,4685),(113247,4686),(113248,4731),(113249,4732),(113250,4733),(113251,4734),(113252,4735),(113253,4736),(113254,4737),(113255,4738),(113256,4739),(113257,4740),(113258,4741),(113259,4742),(113260,4743),(113261,4744),(113262,4745),(113263,4746),(113264,4747),(113265,4748),(113266,4749),(113267,4750),(113268,4751),(113269,4752),(113270,4753),(113271,4754),(113272,4755),(113273,4756),(113274,4757),(113275,4758),(113276,4759),(113277,4760),(113278,4761),(113279,4762),(113280,4763),(113281,4764),(113282,4765),(113283,4766),(113284,4767),(113285,4768),(113286,4769),(113287,4770),(113288,4771),(113289,4772),(113290,4773),(113291,4774),(113292,4775),(113293,4776),(113294,4777),(113295,4778),(113296,4779),(113297,4780),(113298,4781),(113299,4782),(113300,4783),(113301,4784),(113302,4785),(113303,4786),(113304,4787),(113305,4788),(113306,4789),(113307,4790),(113308,4791),(113309,4792),(113310,4793),(113311,4794),(113312,4795),(113313,4796),(113314,4797),(113315,4798),(113316,4799),(113317,4800),(113318,4801),(113319,4802),(113320,4803),(113321,4804),(113322,4805),(113323,4806),(113324,4807),(113325,4808),(113326,4824),(113327,4825),(113328,4826),(113329,4827),(113330,4828),(113331,4829),(113332,4830),(113333,4831),(113334,4832),(113335,4833),(113336,4912),(113337,4913),(113338,4914),(113339,4915),(113340,4916),(113341,4917),(113342,4918),(113343,4919),(113344,4920),(113345,4921),(113346,4922),(113347,4923),(113348,4924),(113349,4925),(113350,4926),(113351,4927),(113352,4928),(113353,4929),(113354,4930),(113355,4931),(113356,4932),(113357,4934),(113358,4935),(113359,4936),(113360,4937),(113361,4938),(113362,4939),(113363,4940),(113364,4941),(113365,4957),(113366,4958),(113367,4959),(113368,4960),(113369,4961),(113370,4962),(113371,4963),(113372,4964),(113373,4965),(113374,4966),(113375,5017),(113376,5018),(113377,5037),(113378,5038),(113379,5062),(113380,5063),(113381,5064),(113382,5073),(113383,5074),(113384,5075),(113385,5076),(113386,5088),(113387,5089),(113388,5091),(113389,5092),(113390,5106),(113391,5107),(113392,5108),(113393,5109),(113394,5114),(113395,5115),(113396,5132),(113397,5133),(113398,5134),(113399,5135),(113400,5143),(113401,5144),(113402,5145),(113403,5146),(113404,5169),(113405,5170),(113406,5172),(113407,5173),(113408,5174),(113409,5175),(113410,5176),(113411,5177),(113412,5184),(113413,5185),(113414,5186),(113415,5187),(113416,5188),(113417,5189),(113418,5200),(113419,5201),(113420,5238),(113421,5239),(113422,5240),(113423,5241),(113424,5242),(113425,5243),(113426,5244),(113427,5245),(113428,5246),(113429,5247),(113430,2435),(113431,4573),(113432,4574),(113433,4575),(113434,4576),(113435,4578),(113436,4579),(113437,4580),(113438,4581),(113439,4605),(113440,4606),(113441,4607),(113442,4609),(113443,4610),(113444,398),(113445,399),(113446,410),(113447,418),(113448,432),(113449,436),(113450,441),(113451,442),(113452,485),(113453,512),(113454,513),(113455,514),(113456,516),(113457,529),(113458,530),(113459,531),(113460,532),(113461,647),(113462,651),(113463,668),(113464,669),(113465,674),(113466,1636),(113467,1637),(113468,1638),(113469,1639),(113470,1640),(113471,1641),(113472,1642),(113473,1643),(113474,1644),(113475,1645),(113476,1646),(113477,1647),(113478,1648),(113479,1649),(113480,2017),(113481,2351),(113482,3732),(113483,4816),(113484,4967),(113485,5100),(113486,5285),(113487,5286),(113488,5296),(113489,5297),(113490,5298),(113491,5413),(113492,5414),(113493,5418),(113494,5419),(113495,5541),(113496,5548),(113497,5593),(113498,5692),(113499,5694),(113500,5700),(113501,5711),(113502,5738),(113503,3860),(113504,3862),(113505,3863),(113506,3864),(113507,3865),(113508,3866),(113509,3867),(113510,3869),(113511,3881),(113512,3883),(113513,3886),(113514,3888),(113515,3891),(113516,3900),(113517,3901),(113518,3902),(113519,3906),(113520,3907),(113521,3908),(113522,3939),(113523,3940),(113524,3943),(113525,3944),(113526,3945),(113527,3946),(113528,3947),(113529,3948),(113530,3949),(113531,3950),(113532,3951),(113533,3952),(113534,3953),(113535,3954),(113536,3955),(113537,3956),(113538,3957),(113539,3958),(113540,3959),(113541,3960),(113542,3961),(113543,3962),(113544,3971),(113545,3990),(113546,3991),(113547,3992),(113548,3993),(113549,3994),(113550,3995),(113551,3996),(113552,3997),(113553,3998),(113554,3999),(113555,4000),(113556,4001),(113557,4002),(113558,4003),(113559,4004),(113560,4005),(113561,4006),(113562,4007),(113563,4008),(113564,4009),(113565,4010),(113566,4011),(113567,4038),(113568,4040),(113569,4042),(113570,4044),(113571,4045),(113572,4046),(113573,4047),(113574,4048),(113575,4049),(113576,4050),(113577,4051),(113578,4056),(113579,4061),(113580,4071),(113581,4072),(113582,4073),(113583,4074),(113584,4098),(113585,4099),(113586,4100),(113587,4101),(113588,4102),(113589,4103),(113590,4104),(113591,4105),(113592,4106),(113593,4107),(113594,4108),(113595,4109),(113596,4110),(113597,4111),(113598,4112),(113599,4113),(113600,4114),(113601,4115),(113602,4116),(113603,4117),(113604,4118),(113605,4125),(113606,4126),(113607,4144),(113608,4155),(113609,4157),(113610,4158),(113611,4159),(113612,4160),(113613,4161),(113614,4163),(113615,4164),(113616,4165),(113617,4166),(113618,4169),(113619,4176),(113620,4177),(113621,4178),(113622,4213),(113623,4221),(113624,4242),(113625,4246),(113626,4258),(113627,4260),(113628,4263),(113629,4264),(113630,4265),(113631,4266),(113632,4267),(113633,4268),(113634,4269),(113635,4286),(113636,4320),(113637,4321),(113638,4322),(113639,4323),(113640,4324),(113641,4325),(113642,4344),(113643,4345),(113644,4361),(113645,4367),(113646,4421),(113647,4423),(113648,4428),(113649,4429),(113650,4440),(113651,4479),(113652,3872),(113653,3873),(113654,3885),(113655,3919),(113656,3920),(113657,3921),(113658,3922),(113659,4043),(113660,4054),(113661,4055),(113662,4075),(113663,4076),(113664,4077),(113665,4078),(113666,4092),(113667,4093),(113668,4094),(113669,4095),(113670,4096),(113671,4097),(113672,4120),(113673,4142),(113674,4143),(113675,4150),(113676,4151),(113677,4162),(113678,4199),(113679,4200),(113680,4201),(113681,4214),(113682,4271),(113683,4272),(113684,4273),(113685,4306),(113686,4313),(113687,4314),(113688,4341),(113689,4358),(113690,4416),(113691,4430),(113692,4431),(113693,4457),(113694,3719),(113695,3720),(113696,3721),(113697,3722),(113698,3723),(113699,3724),(113700,3725),(113701,3726),(113702,3727),(113703,3728),(113704,3729),(113705,3730),(113706,3731),(113707,3732),(113708,3733),(113709,3734),(113710,3735),(113711,3736),(113712,3737),(113713,3738),(113714,3739),(113715,3740),(113716,3741),(113717,3742),(113718,3743),(113719,3744),(113720,3745),(113721,3746),(113722,3747),(113723,3748),(113724,3749),(113725,3751),(113726,3752),(113727,3753),(113728,3754),(113729,3755),(113730,3756),(113731,3757),(113732,3758),(113733,3759),(113734,3760),(113735,3761),(113736,3762),(113737,3763),(113738,3764),(113739,3765),(113740,3909),(113741,4041),(113742,305),(113743,306),(113744,307),(113745,308),(113746,309),(113747,310),(113748,311),(113749,312),(113750,313),(113751,314),(113752,315),(113753,316),(113754,317),(113755,318),(113756,319),(113757,320),(113758,321),(113759,322),(113760,323),(113761,324),(113762,325),(113763,326),(113764,327),(113765,328),(113766,329),(113767,330),(113768,331),(113769,332),(113770,333),(113771,334),(113772,335),(113773,336),(113774,337),(113775,338),(113776,339),(113777,340),(113778,341),(113779,342),(113780,343),(113781,344),(113782,345),(113783,346),(113784,347),(113785,903),(113786,904),(113787,905),(113788,907),(113789,1813),(113790,1814),(113791,1815),(113792,1816),(113793,1817),(113794,1818),(113795,1819),(113796,1820),(113797,1821),(113798,1822),(113799,1823),(113800,1824),(113801,1825),(113802,1826),(113803,1827),(113804,1828),(113805,1829),(113806,1830),(113807,1831),(113808,1832),(113809,1833),(113810,1834),(113811,1835),(113812,1950),(113813,1951),(113814,1952),(113815,1953),(113816,1954),(113817,1955),(113818,1956),(113819,1957),(113820,1958),(113821,1965),(113822,1966),(113823,1967),(113824,1968),(113825,1969),(113826,1970),(113827,1971),(113828,2154),(113829,2158),(113830,2159),(113831,2160),(113832,2161),(113833,2162),(113834,2170),(113835,2171),(113836,2172),(113837,2173),(113838,2174),(113839,2175),(113840,2177),(113841,2181),(113842,2182),(113843,2183),(113844,2184),(113845,2185),(113846,2186),(113847,2199),(113848,2211),(113849,2212),(113850,2213),(113851,2223),(113852,2224),(113853,2225),(113854,2226),(113855,2227),(113856,2228),(113857,2229),(113858,2230),(113859,2231),(113860,2281),(113861,2282),(113862,2292),(113863,2294),(113864,2295),(113865,2297),(113866,2298),(113867,2432),(113868,2433),(113869,2434),(113870,2436),(113871,2437),(113872,2438),(113873,2439),(113874,2443),(113875,2444),(113876,2445),(113877,2446),(113878,2447),(113879,2448),(113880,2475),(113881,2476),(113882,2477),(113883,2478),(113884,2479),(113885,2480),(113886,2481),(113887,2482),(113888,2483),(113889,2484),(113890,2485),(113891,2486),(113892,2487),(113893,2488),(113894,2492),(113895,2493),(113896,2494),(113897,2495),(113898,2496),(113899,2497),(113900,2498),(113901,2499),(113902,2500),(113903,2513),(113904,2514),(113905,2529),(113906,2530),(113907,2539),(113908,2553),(113909,2554),(113910,2582),(113911,2583),(113912,2584),(113913,2585),(113914,2586),(113915,2587),(113916,4613),(113917,4614),(113918,4857),(113919,4858),(113920,4859),(113921,4860),(113922,4861),(113923,4862),(113924,4863),(113925,4864),(113926,4865),(113927,4866),(113928,4867),(113929,4868),(113930,4869),(113931,4870),(113932,4871),(113933,4872),(113934,4873),(113935,4874),(113936,4875),(113937,4876),(113938,4891),(113939,4892),(113940,4893),(113941,4894),(113942,281),(113943,282),(113944,283),(113945,284),(113946,285),(113947,286),(113948,287),(113949,288),(113950,289),(113951,290),(113952,291),(113953,292),(113954,293),(113955,294),(113956,295),(113957,296),(113958,297),(113959,298),(113960,299),(113961,300),(113962,301),(113963,302),(113964,303),(113965,304),(113966,1144),(113967,1145),(113968,1146),(113969,1147),(113970,1148),(113971,1151),(113972,1152),(113973,1153),(113974,1154),(113975,1155),(113976,1156),(113977,1157),(113978,1158),(113979,1159),(113980,1160),(113981,1161),(113982,1496),(113983,1836),(113984,1837),(113985,1838),(113986,1839),(113987,1840),(113988,1841),(113989,1842),(113990,1843),(113991,1844),(113992,1845),(113993,1846),(113994,1847),(113995,1848),(113996,1849),(113997,1850),(113998,1851),(113999,1852),(114000,1853),(114001,1854),(114002,1855),(114003,1856),(114004,1857),(114005,1858),(114006,1859),(114007,1860),(114008,1861),(114009,1862),(114010,1863),(114011,1864),(114012,1865),(114013,1866),(114014,1867),(114015,1868),(114016,1869),(114017,1870),(114018,1871),(114019,1872),(114020,1873),(114021,1874),(114022,1875),(114023,1876),(114024,1877),(114025,1878),(114026,1879),(114027,1880),(114028,1881),(114029,1882),(114030,1883),(114031,1884),(114032,1885),(114033,1886),(114034,1887),(114035,1888),(114036,1889),(114037,1890),(114038,1891),(114039,1892),(114040,1893),(114041,1894),(114042,1895),(114043,1896),(114044,1897),(114045,1898),(114046,1899),(114047,1900),(114048,1901),(114049,1902),(114050,1903),(114051,1904),(114052,1905),(114053,1906),(114054,1907),(114055,1908),(114056,1909),(114057,1910),(114058,1911),(114059,1912),(114060,1913),(114061,1914),(114062,1915),(114063,1916),(114064,1917),(114065,1918),(114066,1919),(114067,1920),(114068,1921),(114069,1922),(114070,1923),(114071,1924),(114072,1925),(114073,1926),(114074,1927),(114075,1928),(114076,1929),(114077,1930),(114078,1931),(114079,1932),(114080,1933),(114081,1934),(114082,1935),(114083,1936),(114084,1937),(114085,1938),(114086,1939),(114087,1940),(114088,1941),(114089,1942),(114090,1943),(114091,1944),(114092,1945),(114093,1946),(114094,1947),(114095,1948),(114096,1949),(114097,4491),(114098,4492),(114099,4493),(114100,4494),(114101,4495),(114102,4496),(114103,4497),(114104,4498),(114105,4499),(114106,4537),(114107,4897),(114108,5286),(114109,1219),(114110,1220),(114111,1221),(114112,1222),(114113,1223),(114114,1224),(114115,1225),(114116,1226),(114117,1227),(114118,1228),(114119,1229),(114120,1230),(114121,1231),(114122,1232),(114123,1233),(114124,1234),(114125,1235),(114126,1236),(114127,1237),(114128,1238),(114129,1239),(114130,1240),(114131,1241),(114132,1242),(114133,1243),(114134,1244),(114135,1245),(114136,1246),(114137,1247),(114138,1248),(114139,1249),(114140,1250),(114141,1251),(114142,1252),(114143,1253),(114144,1254),(114145,1255),(114146,1256),(114147,1257),(114148,1258),(114149,1259),(114150,1260),(114151,1261),(114152,1262),(114153,1263),(114154,1264),(114155,1265),(114156,1266),(114157,1267),(114158,1268),(114159,1269),(114160,1270),(114161,1271),(114162,1272),(114163,1273),(114164,1274),(114165,1275),(114166,1276),(114167,1277),(114168,1278),(114169,1279),(114170,1280),(114171,1281),(114172,1282),(114173,1283),(114174,1284),(114175,1285),(114176,1286),(114177,1287),(114178,1288),(114179,1289),(114180,1290),(114181,1291),(114182,1292),(114183,1293),(114184,1294),(114185,1295),(114186,1296),(114187,1297),(114188,1298),(114189,1299),(114190,1300),(114191,1301),(114192,1302),(114193,1303),(114194,1304),(114195,1305),(114196,1306),(114197,1307),(114198,1308),(114199,1309),(114200,1310),(114201,1311),(114202,1312),(114203,1313),(114204,1314),(114205,1315),(114206,1316),(114207,1317),(114208,1318),(114209,1319),(114210,1320),(114211,1321),(114212,1322),(114213,1323),(114214,1332),(114215,1342),(114216,1346),(114217,1347),(114218,1349),(114219,1350),(114220,1351),(114221,1353),(114222,1354),(114223,1355),(114224,1356),(114225,1357),(114226,1358),(114227,1359),(114228,1360),(114229,1361),(114230,1362),(114231,1363),(114232,1364),(114233,1366),(114234,1367),(114235,1368),(114236,1371),(114237,1375),(114238,1376),(114239,1377),(114240,1379),(114241,1389),(114242,1390),(114243,1391),(114244,1392),(114245,1393),(114246,1394),(114247,1395),(114248,1397),(114249,1398),(114250,1400),(114251,1420),(114252,1421),(114253,1422),(114254,1423),(114255,1424),(114256,1425),(114257,1427),(114258,1428),(114259,1429),(114260,1430),(114261,1431),(114262,1432),(114263,1433),(114264,1434),(114265,1435),(114266,1442),(114267,1443),(114268,1444),(114269,1445),(114270,1446),(114271,1447),(114272,1448),(114273,1450),(114274,1451),(114275,1452),(114276,1454),(114277,1455),(114278,1456),(114279,1457),(114280,1462),(114281,1469),(114282,1749),(114283,4500),(114284,4501),(114285,4502),(114286,4503),(114287,4504),(114288,4505),(114289,4506),(114290,4507),(114291,4508),(114292,4509),(114293,4510),(114294,4511),(114295,4512),(114296,4513),(114297,4514),(114298,4515),(114299,4516),(114300,4517),(114301,4518),(114302,4519),(114303,4520),(114304,4522),(114305,4523),(114306,5301),(114307,5468),(114308,5489),(114309,582),(114310,583),(114311,584),(114312,585),(114313,586),(114314,587),(114315,588),(114316,589),(114317,590),(114318,591),(114319,592),(114320,593),(114321,594),(114322,595),(114323,596),(114324,597),(114325,598),(114326,599),(114327,600),(114328,601),(114329,602),(114330,603),(114331,604),(114332,605),(114333,606),(114334,607),(114335,608),(114336,609),(114337,610),(114338,612),(114339,626),(114340,627),(114341,628),(114342,629),(114343,630),(114344,631),(114345,754),(114346,755),(114347,756),(114348,757),(114349,758),(114350,759),(114351,760),(114352,761),(114353,762),(114354,763),(114355,764),(114356,765),(114357,766),(114358,767),(114359,768),(114360,769),(114361,770),(114362,771),(114363,772),(114364,773),(114365,774),(114366,775),(114367,776),(114368,777),(114369,778),(114370,779),(114371,780),(114372,781),(114373,782),(114374,783),(114375,784),(114376,785),(114377,786),(114378,787),(114379,788),(114380,789),(114381,790),(114382,791),(114383,792),(114384,793),(114385,794),(114386,795),(114387,796),(114388,797),(114389,798),(114390,799),(114391,800),(114392,801),(114393,802),(114394,803),(114395,804),(114396,805),(114397,806),(114398,807),(114399,808),(114400,809),(114401,810),(114402,811),(114403,812),(114404,813),(114405,814),(114406,815),(114407,816),(114408,817),(114409,818),(114410,819),(114411,820),(114412,821),(114413,822),(114414,823),(114415,824),(114416,825),(114417,826),(114418,827),(114419,828),(114420,829),(114421,830),(114422,831),(114423,832),(114424,833),(114425,834),(114426,835),(114427,836),(114428,837),(114429,838),(114430,839),(114431,840),(114432,841),(114433,842),(114434,843),(114435,844),(114436,845),(114437,846),(114438,847),(114439,848),(114440,849),(114441,850),(114442,851),(114443,852),(114444,853),(114445,854),(114446,855),(114447,856),(114448,857),(114449,858),(114450,859),(114451,860),(114452,861),(114453,862),(114454,863),(114455,864),(114456,865),(114457,866),(114458,867),(114459,868),(114460,869),(114461,870),(114462,871),(114463,872),(114464,1020),(114465,1021),(114466,1022),(114467,1023),(114468,1106),(114469,1166),(114470,1167),(114471,1168),(114472,1169),(114473,1170),(114474,1171),(114475,1172),(114476,1173),(114477,1174),(114478,1175),(114479,1176),(114480,1177),(114481,1178),(114482,1179),(114483,1180),(114484,1181),(114485,1182),(114486,1183),(114487,1195),(114488,1196),(114489,1197),(114490,1198),(114491,1199),(114492,1200),(114493,1201),(114494,1202),(114495,1203),(114496,1204),(114497,1205),(114498,1206),(114499,1207),(114500,1210),(114501,1211),(114502,1212),(114503,1213),(114504,1214),(114505,1215),(114506,1216),(114507,1217),(114508,1218),(114509,348),(114510,349),(114511,350),(114512,351),(114513,352),(114514,353),(114515,354),(114516,355),(114517,356),(114518,357),(114519,358),(114520,359),(114521,360),(114522,361),(114523,370),(114524,371),(114525,372),(114526,373),(114527,374),(114528,375),(114529,376),(114530,377),(114531,378),(114532,379),(114533,380),(114534,381),(114535,382),(114536,383),(114537,384),(114538,385),(114539,386),(114540,387),(114541,388),(114542,389),(114543,390),(114544,391),(114545,392),(114546,393),(114547,394),(114548,395),(114549,396),(114550,397),(114551,533),(114552,534),(114553,535),(114554,536),(114555,537),(114556,538),(114557,539),(114558,540),(114559,541),(114560,542),(114561,543),(114562,544),(114563,545),(114564,546),(114565,547),(114566,548),(114567,549),(114568,550),(114569,551),(114570,552),(114571,553),(114572,554),(114573,555),(114574,556),(114575,558),(114576,559),(114577,561),(114578,562),(114579,563),(114580,564),(114581,565),(114582,566),(114583,567),(114584,568),(114585,569),(114586,570),(114587,571),(114588,572),(114589,573),(114590,574),(114591,575),(114592,576),(114593,577),(114594,578),(114595,579),(114596,580),(114597,581),(114598,5500),(114599,5501),(114600,5502),(114601,5503),(114602,5504),(114603,5505),(114604,5506),(114605,5507),(114606,5508),(114607,5509),(114608,5510),(114609,5511),(114610,5512),(114611,5513),(114612,5514),(114613,5515),(114614,5516),(114615,5517),(114616,5518),(114617,5519),(114618,1024),(114619,2026),(114620,2027),(114621,2028),(114622,2029),(114623,2030),(114624,2031),(114625,2032),(114626,2034),(114627,2039),(114628,2040),(114629,2042),(114630,2044),(114631,2045),(114632,2046),(114633,2122),(114634,2123),(114635,2124),(114636,2125),(114637,2126),(114638,2127),(114639,2128),(114640,2129),(114641,2130),(114642,2131),(114643,2132),(114644,2133),(114645,2134),(114646,2135),(114647,2136),(114648,2137),(114649,2138),(114650,2139),(114651,2140),(114652,2141),(114653,2142),(114654,2143),(114655,2144),(114656,2145),(114657,2146),(114658,2147),(114659,2148),(114660,2149),(114661,2150),(114662,2151),(114663,2152),(114664,2153),(114665,2275),(114666,2323),(114667,2324),(114668,2325),(114669,2326),(114670,2327),(114671,2328),(114672,2329),(114673,2330),(114674,2331),(114675,2332),(114676,2333),(114677,2334),(114678,2335),(114679,2336),(114680,2337),(114681,2338),(114682,2339),(114683,2340),(114684,2341),(114685,2342),(114686,2343),(114687,2344),(114688,2345),(114689,2346),(114690,2347),(114691,2348),(114692,2349),(114693,2350),(114694,2351),(114695,2352),(114696,2353),(114697,2354),(114698,2355),(114699,2356),(114700,2357),(114701,2358),(114702,2359),(114703,2360),(114704,2361),(114705,2362),(114706,2363),(114707,2364),(114708,2365),(114709,2366),(114710,2367),(114711,2368),(114712,2369),(114713,2370),(114714,2371),(114715,2372),(114716,2373),(114717,2374),(114718,2375),(114719,2376),(114720,2377),(114721,2378),(114722,2379),(114723,2380),(114724,2381),(114725,2382),(114726,2383),(114727,2384),(114728,2385),(114729,2386),(114730,2387),(114731,2388),(114732,2389),(114733,2390),(114734,2391),(114735,2559),(114736,4933),(114737,5490),(114738,5491),(114739,5492),(114740,5493),(114741,5494),(114742,5495),(114743,5496),(114744,5497),(114745,5498),(114746,5499),(114747,240),(114748,241),(114749,242),(114750,243),(114751,246),(114752,247),(114753,248),(114754,258),(114755,259),(114756,260),(114757,261),(114758,262),(114759,263),(114760,264),(114761,265),(114762,909),(114763,910),(114764,911),(114765,912),(114766,913),(114767,914),(114768,915),(114769,916),(114770,917),(114771,918),(114772,919),(114773,920),(114774,921),(114775,922),(114776,923),(114777,924),(114778,925),(114779,926),(114780,927),(114781,928),(114782,929),(114783,930),(114784,931),(114785,932),(114786,933),(114787,934),(114788,935),(114789,936),(114790,937),(114791,938),(114792,939),(114793,940),(114794,941),(114795,942),(114796,943),(114797,944),(114798,945),(114799,946),(114800,947),(114801,948),(114802,949),(114803,950),(114804,951),(114805,952),(114806,953),(114807,954),(114808,955),(114809,956),(114810,957),(114811,958),(114812,959),(114813,960),(114814,961),(114815,962),(114816,963),(114817,964),(114818,965),(114819,966),(114820,967),(114821,968),(114822,969),(114823,970),(114824,971),(114825,972),(114826,973),(114827,974),(114828,975),(114829,976),(114830,977),(114831,978),(114832,979),(114833,980),(114834,981),(114835,982),(114836,983),(114837,984),(114838,985),(114839,986),(114840,987),(114841,988),(114842,989),(114843,990),(114844,991),(114845,992),(114846,993),(114847,994),(114848,995),(114849,1007),(114850,1008),(114851,1009),(114852,1010),(114853,1011),(114854,1040),(114855,1041),(114856,1042),(114857,1043),(114858,1044),(114859,1045),(114860,1046),(114861,1047),(114862,1048),(114863,1093),(114864,1094),(114865,1095),(114866,1096),(114867,1097),(114868,1098),(114869,1100),(114870,1101),(114871,1102),(114872,1103),(114873,1104),(114874,1105),(114875,1107),(114876,1108),(114877,1109),(114878,1110),(114879,1111),(114880,1112),(114881,1113),(114882,1114),(114883,1115),(114884,1116),(114885,1117),(114886,1118),(114887,1120),(114888,1121),(114889,1122),(114890,1123),(114891,1124),(114892,1125),(114893,1134),(114894,1135),(114895,1136),(114896,1137),(114897,1138),(114898,1139),(114899,1518),(114900,1519),(114901,1520),(114902,1521),(114903,1533),(114904,1563),(114905,1564),(114906,1565),(114907,1566),(114908,1588),(114909,1589),(114910,1590),(114911,1591),(114912,1592),(114913,1593),(114914,1594),(114915,1595),(114916,1596),(114917,1597),(114918,1598),(114919,1599),(114920,1604),(114921,1607),(114922,1610),(114923,1618),(114924,1619),(114925,1620),(114926,1621),(114927,1623),(114928,1626),(114929,1658),(114930,1659),(114931,1660),(114932,1665),(114933,1666),(114934,1675),(114935,1676),(114936,1677),(114937,1678),(114938,1733),(114939,1734),(114940,1735),(114941,1751),(114942,1752),(114943,1753),(114944,1754),(114945,1755),(114946,1756),(114947,1757),(114948,1758),(114949,1761),(114950,1762),(114951,1778),(114952,1779),(114953,1786),(114954,1787),(114955,1788),(114956,1789),(114957,1790),(114958,2454),(114959,2455),(114960,2456),(114961,2699),(114962,2919),(114963,2920),(114964,2921),(114965,2922),(114966,2923),(114967,2924),(114968,2925),(114969,2926),(114970,2927),(114971,2928),(114972,2929),(114973,2930),(114974,2931),(114975,2932),(114976,2933),(114977,2934),(114978,2935),(114979,2936),(114980,2937),(114981,2938),(114982,2939),(114983,2940),(114984,2941),(114985,2942),(114986,2943),(114987,2944),(114988,2945),(114989,2946),(114990,2947),(114991,2948),(114992,2949),(114993,2950),(114994,2951),(114995,2952),(114996,2953),(114997,2954),(114998,2979),(114999,2980),(115000,3042),(115001,3164),(115002,3165),(115003,3166),(115004,3534),(115005,3535),(115006,3536),(115007,4566),(115008,4567),(115009,4568),(115010,4569),(115011,4570),(115012,4571),(115013,4572),(115014,4577),(115015,5077),(115016,5078),(115017,5079),(115018,5080),(115019,5081),(115020,5082),(115021,5083),(115022,5084),(115023,5085),(115024,5086),(115025,5087),(115026,5093),(115027,5094),(115028,5095),(115029,5096),(115030,5250),(115031,5251),(115032,5252),(115033,5253),(115034,5254),(115035,5255),(115036,5258),(115037,5259),(115038,5260),(115039,5261),(115040,5262),(115041,5263),(115042,5264),(115043,5265),(115044,5266),(115045,5267),(115046,5268),(115047,5269),(115048,5270),(115049,5323),(115050,5324),(115051,5325),(115052,5326),(115053,5327),(115054,5328),(115055,5329),(115056,5330),(115057,5331),(115058,5332),(115059,5333),(115060,5334),(115061,5335),(115062,5336),(115063,5337),(115064,5343),(115065,5344),(115066,5351),(115067,5352),(115068,5354),(115069,5356),(115070,5367),(115071,5369),(115072,5372),(115073,5373),(115074,5374),(115075,5375),(115076,5376),(115077,5377),(115078,5390),(115079,5402),(115080,5433),(115081,5434),(115082,5451),(115083,5452),(115084,5453),(115085,5454),(115086,5455),(115087,5474),(115088,5475),(115089,5476),(115090,5477),(115091,5478),(115092,5479),(115093,5480),(115094,5481),(115095,5484),(115096,5485),(115097,5486),(115098,5487),(115099,5488),(115100,5524),(115101,5526),(115102,5527),(115103,5528),(115104,5529),(115105,5530),(115106,5531),(115107,5532),(115108,5533),(115109,5534),(115110,5535),(115111,5558),(115112,5563),(115113,5564),(115114,5566),(115115,5570),(115116,5577),(115117,5578),(115118,5580),(115119,5581),(115120,5588),(115121,5674),(115122,5675),(115123,5676),(115124,5677),(115125,5678),(115126,5679),(115127,5738),(115128,5028),(115129,5029),(115130,5030),(115131,5031),(115132,5032),(115133,5033),(115134,5034),(115135,5035),(115136,5036),(115137,5359),(115138,5360),(115139,5361),(115140,5362),(115141,5363),(115142,5364),(115143,5365),(115144,5366),(115145,5420),(115146,5431),(115147,5435),(115148,5436),(115149,5437),(115150,5438),(115151,5439),(115152,5440),(115153,5441),(115154,5442),(115155,5443),(115156,5444),(115157,5445),(115158,5446),(115159,5447),(115160,5448),(115161,5449),(115162,5450),(115163,5525),(115164,5707),(115165,5708),(115166,162),(115167,176),(115168,177),(115169,178),(115170,179),(115171,180),(115172,181),(115173,182),(115174,183),(115175,184),(115176,185),(115177,186),(115178,187),(115179,188),(115180,189),(115181,190),(115182,191),(115183,192),(115184,193),(115185,194),(115186,195),(115187,196),(115188,197),(115189,198),(115190,199),(115191,200),(115192,201),(115193,202),(115194,203),(115195,204),(115196,205),(115197,206),(115198,207),(115199,208),(115200,209),(115201,210),(115202,211),(115203,212),(115204,213),(115205,214),(115206,215),(115207,216),(115208,217),(115209,218),(115210,219),(115211,220),(115212,5393),(115213,5394),(115214,5395),(115215,5396),(115216,5397),(115217,5398),(115218,5399),(115219,5400),(115220,1650),(115221,1651),(115222,1652),(115223,1653),(115224,1687),(115225,1688),(115226,1689),(115227,1690),(115228,1691),(115229,1692),(115230,1693),(115231,1694),(115232,1695),(115233,1696),(115234,1697),(115235,1698),(115236,1699),(115237,1700),(115238,1701),(115239,1702),(115240,1703),(115241,1704),(115242,1737),(115243,1738),(115244,1773),(115245,4612),(115246,4718),(115247,4730),(115248,4812),(115249,4813),(115250,4814),(115251,4815),(115252,4816),(115253,4817),(115254,4818),(115255,4819),(115256,4820),(115257,4821),(115258,4822),(115259,4845),(115260,4955),(115261,4956),(115262,4967),(115263,4968),(115264,4969),(115265,5090),(115266,5097),(115267,5098),(115268,5099),(115269,5100),(115270,5101),(115271,5102),(115272,5103),(115273,5104),(115274,5110),(115275,5111),(115276,5112),(115277,5113),(115278,5116),(115279,5117),(115280,5118),(115281,5119),(115282,5120),(115283,5456),(115284,5457),(115285,5459),(115286,5460),(115287,5461),(115288,5462),(115289,5702),(115290,5703),(115291,1679),(115292,1680),(115293,1708),(115294,1709),(115295,1710),(115296,1711),(115297,1712),(115298,1713),(115299,1714),(115300,1748),(115301,1791),(115302,1792),(115303,1798),(115304,2187),(115305,2188),(115306,2189),(115307,2190),(115308,2191),(115309,2192),(115310,2193),(115311,2194),(115312,2195),(115313,2196),(115314,2197),(115315,2198),(115316,2232),(115317,2233),(115318,2234),(115319,2235),(115320,2236),(115321,2237),(115322,2238),(115323,2239),(115324,2240),(115325,2392),(115326,2393),(115327,2394),(115328,2395),(115329,2411),(115330,2412),(115331,2577),(115332,2578),(115333,2579),(115334,2580),(115335,2581),(115336,2589),(115337,2590),(115338,2591),(115339,2592),(115340,2593),(115341,2594),(115342,2595),(115343,2596),(115344,2597),(115345,2598),(115346,2599),(115347,2600),(115348,2601),(115349,2602),(115350,2603),(115351,2604),(115352,2605),(115353,2606),(115354,2607),(115355,2608),(115356,2609),(115357,2610),(115358,2611),(115359,2612),(115360,2613),(115361,2614),(115362,4621),(115363,4629),(115364,4630),(115365,4631),(115366,4632),(115367,4633),(115368,4634),(115369,4635),(115370,4636),(115371,4637),(115372,4638),(115373,4639),(115374,4640),(115375,4641),(115376,4642),(115377,4643),(115378,4644),(115379,4645),(115380,4646),(115381,4647),(115382,4648),(115383,4649),(115384,4650),(115385,4651),(115386,4652),(115387,4653),(115388,4654),(115389,4655),(115390,4656),(115391,4657),(115392,4658),(115393,4659),(115394,4660),(115395,4661),(115396,4662),(115397,4663),(115398,4664),(115399,4665),(115400,4666),(115401,4667),(115402,4896),(115403,4898),(115404,4900),(115405,4902),(115406,4903),(115407,4904),(115408,4943),(115409,4944),(115410,4945),(115411,4946),(115412,4947),(115413,4948),(115414,4949),(115415,4950),(115416,4951),(115417,4952),(115418,4953),(115419,4954),(115420,4971),(115421,4972),(115422,4973),(115423,4979),(115424,4980),(115425,4981),(115426,4982),(115427,4983),(115428,4984),(115429,4985),(115430,4986),(115431,4987),(115432,4988),(115433,4989),(115434,4990),(115435,4991),(115436,5001),(115437,5002),(115438,5105),(115439,5178),(115440,5179),(115441,5180),(115442,5181),(115443,5182),(115444,5202),(115445,5203),(115446,5204),(115447,5205),(115448,5206),(115449,5207),(115450,5208),(115451,5209),(115452,5210),(115453,5211),(115454,5212),(115455,5213),(115456,5214),(115457,5215),(115458,5216),(115459,5217),(115460,5218),(115461,5219),(115462,5220),(115463,5221),(115464,5222),(115465,5223),(115466,5224),(115467,5225),(115468,5226),(115469,5227),(115470,5228),(115471,5229),(115472,5230),(115473,5231),(115474,5232),(115475,5233),(115476,5234),(115477,5235),(115478,5236),(115479,5237),(115480,1527),(115481,1528),(115482,1529),(115483,1530),(115484,1531),(115485,1532),(115486,1534),(115487,1535),(115488,1536),(115489,1557),(115490,1558),(115491,1559),(115492,1562),(115493,1584),(115494,1585),(115495,1586),(115496,1587),(115497,1600),(115498,1601),(115499,1602),(115500,1603),(115501,1605),(115502,1606),(115503,1608),(115504,1609),(115505,1622),(115506,1624),(115507,1625),(115508,1627),(115509,1628),(115510,1661),(115511,1662),(115512,1663),(115513,1664),(115514,1667),(115515,1668),(115516,1669),(115517,1670),(115518,1671),(115519,1672),(115520,1673),(115521,1674),(115522,1715),(115523,1716),(115524,1717),(115525,1718),(115526,1719),(115527,1720),(115528,1721),(115529,1722),(115530,1723),(115531,1724),(115532,1725),(115533,1726),(115534,1727),(115535,1728),(115536,1729),(115537,1730),(115538,1731),(115539,1732),(115540,1736),(115541,1740),(115542,1743),(115543,1744),(115544,1745),(115545,1746),(115546,1747),(115547,1750),(115548,1780),(115549,1781),(115550,1782),(115551,1793),(115552,1794),(115553,1795),(115554,1799),(115555,1800),(115556,1801),(115557,1802),(115558,2515),(115559,2516),(115560,2918),(115561,3043),(115562,4582),(115563,4583),(115564,4584),(115565,4585),(115566,4586),(115567,4587),(115568,4588),(115569,4589),(115570,4590),(115571,4591),(115572,4592),(115573,4593),(115574,4594),(115575,4595),(115576,4596),(115577,4597),(115578,4598),(115579,4599),(115580,4600),(115581,4601),(115582,4602),(115583,4603),(115584,4604),(115585,4608),(115586,4834),(115587,4835),(115588,4836),(115589,4837),(115590,4838),(115591,4839),(115592,4840),(115593,4841),(115594,4842),(115595,4942),(115596,5121),(115597,5151),(115598,5152),(115599,5153),(115600,5154),(115601,5155),(115602,5156),(115603,5157),(115604,5158),(115605,5183),(115606,5248),(115607,5249),(115608,5256),(115609,5257),(115610,5355),(115611,5370),(115612,5371),(115613,5401),(115614,5403),(115615,5404),(115616,5405),(115617,5406),(115618,5407),(115619,5409),(115620,5421),(115621,5422),(115622,5423),(115623,5424),(115624,5425),(115625,5426),(115626,5427),(115627,5429),(115628,5430),(115629,5432),(115630,5458),(115631,5463),(115632,5464),(115633,5465),(115634,5466),(115635,5467),(115636,5482),(115637,5483),(115638,5520),(115639,5521),(115640,5522),(115641,5523),(115642,5551),(115643,5552),(115644,5553),(115645,5554),(115646,5555),(115647,5556),(115648,5557),(115649,5559),(115650,5560),(115651,5561),(115652,5562),(115653,5565),(115654,5567),(115655,5568),(115656,5569),(115657,5572),(115658,5573),(115659,5574),(115660,5575),(115661,5576),(115662,5579),(115663,5582),(115664,5583),(115665,5584),(115666,5585),(115667,5586),(115668,5587),(115669,5589),(115670,5590),(115671,5704),(115672,5705),(115673,5706),(115674,5739),(115675,5740),(115676,5741),(115677,5742),(115678,5743),(115679,5744),(115680,224),(115681,225),(115682,226),(115683,227),(115684,228),(115685,229),(115686,230),(115687,231),(115688,232),(115689,233),(115690,234),(115691,235),(115692,236),(115693,237),(115694,238),(115695,239),(115696,268),(115697,269),(115698,270),(115699,271),(115700,272),(115701,273),(115702,274),(115703,275),(115704,1006),(115705,1013),(115706,1014),(115707,1015),(115708,1016),(115709,1017),(115710,1018),(115711,1025),(115712,1026),(115713,1027),(115714,1028),(115715,1029),(115716,1030),(115717,1031),(115718,1032),(115719,1033),(115720,1126),(115721,1127),(115722,1128),(115723,1129),(115724,1130),(115725,1131),(115726,1132),(115727,1522),(115728,1523),(115729,1524),(115730,1525),(115731,1526),(115732,2422),(115733,2423),(115734,2424),(115735,2425),(115736,2426),(115737,2427),(115738,2428),(115739,2517),(115740,2518),(115741,2519),(115742,2520),(115743,2537),(115744,2538),(115745,4622),(115746,4623),(115747,4624),(115748,4853),(115749,4854),(115750,4855),(115751,4877),(115752,4878),(115753,4879),(115754,4880),(115755,4881),(115756,4882),(115757,4883),(115758,4884),(115759,4885),(115760,4886),(115761,4887),(115762,4888),(115763,4889),(115764,4890),(115765,4970),(115766,5368),(115767,5408),(115768,5410),(115769,5411),(115770,5412),(115771,5413),(115772,5414),(115773,5415),(115774,5416),(115775,5417),(115776,5418),(115777,5419),(115778,5428),(115779,5469),(115780,5470),(115781,5471),(115782,5472),(115783,5473),(115784,5538),(115785,5539),(115786,5540),(115787,5541),(115788,5542),(115789,5543),(115790,5544),(115791,5545),(115792,5546),(115793,5547),(115794,5548),(115795,5549),(115796,5550),(115797,5571),(115798,5591),(115799,5592),(115800,5593),(115801,5594),(115802,5595),(115803,5596),(115804,5597),(115805,5598),(115806,5599),(115807,5600),(115808,5601),(115809,5602),(115810,5603),(115811,5604),(115812,5605),(115813,5606),(115814,5607),(115815,5608),(115816,5609),(115817,5610),(115818,5611),(115819,5612),(115820,5613),(115821,5614),(115822,5615),(115823,5616),(115824,5617),(115825,5618),(115826,5619),(115827,5620),(115828,5621),(115829,5622),(115830,5623),(115831,5624),(115832,5625),(115833,5626),(115834,5627),(115835,5628),(115836,5629),(115837,5630),(115838,5631),(115839,5632),(115840,5633),(115841,5634),(115842,5635),(115843,5636),(115844,5637),(115845,5638),(115846,5639),(115847,5640),(115848,5641),(115849,5642),(115850,5643),(115851,5644),(115852,5645),(115853,5646),(115854,5647),(115855,5648),(115856,5649),(115857,5650),(115858,5651),(115859,5652),(115860,5653),(115861,5654),(115862,5655),(115863,5656),(115864,5657),(115865,5658),(115866,5659),(115867,5660),(115868,5661),(115869,5662),(115870,5663),(115871,5664),(115872,5665),(115873,5666),(115874,5667),(115875,5668),(115876,5669),(115877,5670),(115878,5671),(115879,5672),(115880,5682),(115881,5683),(115882,5684),(115883,5685),(115884,5686),(115885,5687),(115886,5688),(115887,5690),(115888,5691),(115889,5692),(115890,5693),(115891,5694),(115892,5695),(115893,5697),(115894,5698),(115895,5699),(115896,5700),(115897,5701),(115898,5709),(115899,5710),(115900,5711),(115901,5712),(115902,5713),(115903,5714),(115904,5715),(115905,5716),(115906,5717),(115907,5718),(115908,5719),(115909,5720),(115910,5721),(115911,5722),(115912,5723),(115913,5724),(115914,5725),(115915,5726),(115916,5727),(115917,5728),(115918,5729),(115919,5730),(115920,5731),(115921,5732),(115922,5733),(115923,5734),(115924,5735),(115925,5736),(115926,5737),(115927,5745),(115928,5746),(115929,5747),(115930,5748),(115931,5749),(115932,163),(115933,164),(115934,165),(115935,166),(115936,167),(115937,168),(115938,172),(115939,254),(115940,255),(115941,256),(115942,257),(115943,1049),(115944,1050),(115945,1051),(115946,1052),(115947,1053),(115948,1054),(115949,1055),(115950,1056),(115951,1057),(115952,1058),(115953,1059),(115954,1060),(115955,1061),(115956,1062),(115957,1063),(115958,1064),(115959,1065),(115960,1066),(115961,1067),(115962,1068),(115963,1069),(115964,1070),(115965,1071),(115966,1072),(115967,1073),(115968,1074),(115969,1075),(115970,1076),(115971,1077),(115972,1078),(115973,1079),(115974,1080),(115975,1081),(115976,1082),(115977,1083),(115978,1084),(115979,1085),(115980,1086),(115981,1087),(115982,1088),(115983,1089),(115984,1090),(115985,1091),(115986,1611),(115987,1612),(115988,1613),(115989,1614),(115990,1615),(115991,1616),(115992,1617),(115993,1654),(115994,1655),(115995,1656),(115996,1657),(115997,1705),(115998,1706),(115999,1707),(116000,1739),(116001,1741),(116002,1742),(116003,1759),(116004,1760),(116005,1764),(116006,1765),(116007,1766),(116008,1767),(116009,1768),(116010,1769),(116011,1770),(116012,1771),(116013,1772),(116014,1774),(116015,1775),(116016,1776),(116017,1777),(116018,1783),(116019,1784),(116020,1785),(116021,1812),(116022,1959),(116023,1960),(116024,1961),(116025,1962),(116026,1963),(116027,1964),(116028,2289),(116029,2290),(116030,2291),(116031,2293),(116032,2413),(116033,2414),(116034,2415),(116035,2416),(116036,2417),(116037,2418),(116038,2419),(116039,2420),(116040,2421),(116041,906),(116042,908),(116043,1004),(116044,1012),(116045,1019),(116046,1037),(116047,1092),(116048,1119),(116049,1162),(116050,1163),(116051,1164),(116052,1165),(116053,2163),(116054,2164),(116055,2176),(116056,2203),(116057,2204),(116058,2205),(116059,2206),(116060,2207),(116061,2247),(116062,2248),(116063,2249),(116064,2250),(116065,2270),(116066,2271),(116067,2277),(116068,2278),(116069,2279),(116070,2280),(116071,2296),(116072,2299),(116073,2300),(116074,2301),(116075,2429),(116076,2430),(116077,2431),(116078,2440),(116079,2441),(116080,2442),(116081,2457),(116082,2472),(116083,2473),(116084,2474),(116085,2489),(116086,2490),(116087,2491),(116088,2506),(116089,2507),(116090,2508),(116091,2509),(116092,2510),(116093,2511),(116094,2512),(116095,2521),(116096,2522),(116097,2523),(116098,2524),(116099,2525),(116100,2526),(116101,2527),(116102,2528),(116103,2531),(116104,2532),(116105,2533),(116106,2534),(116107,2535),(116108,2536),(116109,2540),(116110,2541),(116111,2542),(116112,2543),(116113,2544),(116114,2545),(116115,2546),(116116,2547),(116117,2548),(116118,2549),(116119,2550),(116120,2551),(116121,2573),(116122,2574),(116123,2575),(116124,2576),(116125,5757),(116126,5758),(116127,5759),(116128,3304),(116129,3305),(116130,3306),(116131,3307),(116132,3308),(116133,3309),(116134,3310),(116135,3311),(116136,3312),(116137,3313),(116138,3314),(116139,3315),(116140,3316),(116141,3317),(116142,3318),(116143,3319),(116144,3320),(116145,3321),(116146,3322),(116147,3323),(116148,3324),(116149,3325),(116150,3326),(116151,3327),(116152,3328),(116153,3329),(116154,3330),(116155,3331),(116156,3332),(116157,3333),(116158,3334),(116159,3335),(116160,3336),(116161,3337),(116162,3338),(116163,3339),(116164,3340),(116165,3341),(116166,3342),(116167,3343),(116168,3344),(116169,3345),(116170,3346),(116171,3347),(116172,3348),(116173,3349),(116174,3350),(116175,3351),(116176,3352),(116177,3353),(116178,3354),(116179,3355),(116180,3356),(116181,3357),(116182,3358),(116183,3359),(116184,3360),(116185,3361),(116186,3362),(116187,3363),(116188,3364),(116189,3365),(116190,3366),(116191,3367),(116192,3368),(116193,3369),(116194,3370),(116195,3371),(116196,3372),(116197,3373),(116198,3374),(116199,3375),(116200,3376),(116201,3377),(116202,3378),(116203,3379),(116204,3380),(116205,3381),(116206,3382),(116207,3383),(116208,3384),(116209,3385),(116210,3386),(116211,3387),(116212,3388),(116213,3389),(116214,3390),(116215,3391),(116216,3392),(116217,3393),(116218,3394),(116219,3395),(116220,3396),(116221,3397),(116222,3398),(116223,3399),(116224,3400),(116225,3401),(116226,3402),(116227,3403),(116228,3404),(116229,3405),(116230,3406),(116231,3407),(116232,3408),(116233,3409),(116234,3410),(116235,3411),(116236,3412),(116237,3413),(116238,3414),(116239,3415),(116240,3416),(116241,3417),(116242,3418),(116243,3419),(116244,3420),(116245,3421),(116246,3422),(116247,3423),(116248,3424),(116249,3425),(116250,3426),(116251,3427),(116252,3428),(116253,3429),(116254,3430),(116255,3431),(116256,3432),(116257,3433),(116258,3434),(116259,3435),(116260,3436),(116261,3437),(116262,3438),(116263,3439),(116264,3440),(116265,3441),(116266,3442),(116267,3443),(116268,3444),(116269,3445),(116270,3446),(116271,3447),(116272,3448),(116273,3449),(116274,3450),(116275,3451),(116276,3452),(116277,3453),(116278,3454),(116279,3455),(116280,3456),(116281,3457),(116282,3458),(116283,3459),(116284,3460),(116285,3461),(116286,3462),(116287,3463),(116288,3464),(116289,3465),(116290,3466),(116291,3467),(116292,3468),(116293,3469),(116294,3470),(116295,3471),(116296,3472),(116297,3473),(116298,3474),(116299,3475),(116300,3476),(116301,3477),(116302,3478),(116303,3479),(116304,3480),(116305,3481),(116306,3482),(116307,3483),(116308,3484),(116309,3485),(116310,3486),(116311,3487),(116312,3488),(116313,3489),(116314,3539),(116315,3540),(116316,3541),(116317,3542),(116318,3648),(116319,3675),(116320,3676),(116321,3677),(116322,3678),(116323,3679),(116324,3680),(116325,3681),(116326,3682),(116327,3683),(116328,2858),(116329,2863),(116330,2866),(116331,2867),(116332,2890),(116333,2891),(116334,2895),(116335,2896),(116336,2897),(116337,2898),(116338,2899),(116339,2917),(116340,2976),(116341,2978),(116342,2987),(116343,2989),(116344,2990),(116345,3012),(116346,3050),(116347,3051),(116348,3052),(116349,3053),(116350,3054),(116351,3055),(116352,3102),(116353,3126),(116354,3127),(116355,3128),(116356,3129),(116357,3130),(116358,3131),(116359,3132),(116360,3133),(116361,3134),(116362,3135),(116363,3136),(116364,3137),(116365,3138),(116366,3139),(116367,3140),(116368,3141),(116369,3142),(116370,3143),(116371,3144),(116372,3145),(116373,3146),(116374,3147),(116375,3148),(116376,3149),(116377,3150),(116378,3151),(116379,3152),(116380,3153),(116381,3154),(116382,3155),(116383,3156),(116384,3157),(116385,3158),(116386,3159),(116387,3160),(116388,3161),(116389,3162),(116390,3163),(116391,3167),(116392,3168),(116393,3169),(116394,3170),(116395,3171),(116396,3172),(116397,3173),(116398,3174),(116399,3175),(116400,3176),(116401,3177),(116402,3178),(116403,3179),(116404,3180),(116405,3181),(116406,3182),(116407,3183),(116408,3184),(116409,3185),(116410,3186),(116411,3187),(116412,3188),(116413,3189),(116414,3190),(116415,3191),(116416,3192),(116417,3193),(116418,3194),(116419,3195),(116420,3196),(116421,3197),(116422,3198),(116423,3199),(116424,3200),(116425,3201),(116426,3202),(116427,3203),(116428,3204),(116429,3205),(116430,3206),(116431,3207),(116432,3208),(116433,3209),(116434,3210),(116435,3211),(116436,3212),(116437,3213),(116438,3214),(116439,3215),(116440,3216),(116441,3217),(116442,3218),(116443,3219),(116444,3220),(116445,3221),(116446,3222),(116447,3223),(116448,3224),(116449,3225),(116450,3226),(116451,3227),(116452,3228),(116453,3229),(116454,3230),(116455,3231),(116456,3232),(116457,3233),(116458,3234),(116459,3235),(116460,3236),(116461,3237),(116462,3238),(116463,3239),(116464,3240),(116465,3241),(116466,3242),(116467,3243),(116468,3244),(116469,3245),(116470,3246),(116471,3247),(116472,3248),(116473,3249),(116474,3250),(116475,3251),(116476,3252),(116477,3253),(116478,3254),(116479,3255),(116480,3256),(116481,3257),(116482,3258),(116483,3259),(116484,3260),(116485,3261),(116486,3262),(116487,3263),(116488,3264),(116489,3265),(116490,3266),(116491,3267),(116492,3268),(116493,3269),(116494,3270),(116495,3271),(116496,3272),(116497,3273),(116498,3274),(116499,3275),(116500,3276),(116501,3277),(116502,3278),(116503,3279),(116504,3280),(116505,3281),(116506,3282),(116507,3283),(116508,3284),(116509,3285),(116510,3286),(116511,3287),(116512,3288),(116513,3289),(116514,3290),(116515,3291),(116516,3292),(116517,3293),(116518,3294),(116519,3295),(116520,3296),(116521,3297),(116522,3298),(116523,3299),(116524,3300),(116525,3301),(116526,3302),(116527,3303),(116528,2622),(116529,2623),(116530,2624),(116531,2625),(116532,2626),(116533,2627),(116534,2628),(116535,2629),(116536,2630),(116537,2631),(116538,2632),(116539,2633),(116540,2634),(116541,2635),(116542,2636),(116543,2637),(116544,2638),(116545,2639),(116546,2640),(116547,2641),(116548,2642),(116549,2643),(116550,2644),(116551,2645),(116552,2646),(116553,2647),(116554,2648),(116555,2649),(116556,2650),(116557,2651),(116558,2652),(116559,2653),(116560,2654),(116561,2658),(116562,2659),(116563,2660),(116564,2661),(116565,2662),(116566,2663),(116567,2664),(116568,2665),(116569,2666),(116570,2667),(116571,2668),(116572,2669),(116573,2670),(116574,2671),(116575,2672),(116576,2673),(116577,2674),(116578,2675),(116579,2676),(116580,2677),(116581,2678),(116582,2679),(116583,2680),(116584,2681),(116585,2682),(116586,2683),(116587,2684),(116588,2685),(116589,2686),(116590,2687),(116591,2688),(116592,2689),(116593,2690),(116594,2691),(116595,2692),(116596,2693),(116597,2694),(116598,2695),(116599,2696),(116600,2697),(116601,2698),(116602,2700),(116603,2703),(116604,2781),(116605,2794),(116606,2795),(116607,2796),(116608,2798),(116609,2821),(116610,2828),(116611,2829),(116612,2830),(116613,2833),(116614,2834),(116615,2835),(116616,2836),(116617,2837),(116618,2838),(116619,2839),(116620,2840),(116621,2841),(116622,2842),(116623,2843),(116624,39),(116625,40),(116626,41),(116627,42),(116628,43),(116629,44),(116630,750),(116631,751),(116632,752),(116633,753),(116634,882),(116635,883),(116636,884),(116637,885),(116638,886),(116639,887),(116640,888),(116641,889),(116642,890),(116643,891),(116644,892),(116645,893),(116646,894),(116647,895),(116648,896),(116649,897),(116650,898),(116651,899),(116652,900),(116653,901),(116654,902),(116655,1473),(116656,1474),(116657,1475),(116658,1476),(116659,1477),(116660,1478),(116661,1479),(116662,1480),(116663,1481),(116664,1482),(116665,1483),(116666,1484),(116667,1485),(116668,1486),(116669,1487),(116670,1515),(116671,1516),(116672,1517),(116673,1537),(116674,1538),(116675,1539),(116676,1540),(116677,1541),(116678,1542),(116679,1543),(116680,1544),(116681,1545),(116682,1546),(116683,1547),(116684,1548),(116685,1549),(116686,1550),(116687,1551),(116688,1552),(116689,1553),(116690,1554),(116691,1555),(116692,1556),(116693,1560),(116694,1561),(116695,1763),(116696,4539),(116697,4540),(116698,4541),(116699,4542),(116700,4543),(116701,4544),(116702,4545),(116703,4546),(116704,4547),(116705,4548),(116706,4549),(116707,4550),(116708,4551),(116709,4552),(116710,4553),(116711,4554),(116712,4555),(116713,4556),(116714,4557),(116715,4558),(116716,4559),(116717,4560),(116718,4561),(116719,4562),(116720,4563),(116721,4564),(116722,4565),(116723,5275),(116724,5276),(116725,5277),(116726,5278),(116727,5279),(116728,5280),(116729,5281),(116730,5309),(116731,5310),(116732,5311),(116733,5312),(116734,5313),(116735,5314),(116736,5315),(116737,5316),(116738,5317),(116739,5318),(116740,5319),(116741,5320),(116742,5338),(116743,5339),(116744,5340),(116745,5341),(116746,5342),(116747,5345),(116748,5346),(116749,5347),(116750,5348),(116751,5349),(116752,5350),(116753,5353),(116754,5357),(116755,5358),(116756,5680),(116757,5681),(116758,139),(116759,160),(116760,161),(116761,169),(116762,170),(116763,171),(116764,173),(116765,174),(116766,175),(116767,221),(116768,222),(116769,223),(116770,249),(116771,250),(116772,252),(116773,253),(116774,266),(116775,267),(116776,276),(116777,277),(116778,278),(116779,279),(116780,280),(116781,1575),(116782,1576),(116783,1577),(116784,1578),(116785,1805),(116786,1806),(116787,2200),(116788,2208),(116789,2209),(116790,2210),(116791,2245),(116792,2246),(116793,2256),(116794,2257),(116795,2302),(116796,2303),(116797,2304),(116798,2305),(116799,2306),(116800,2396),(116801,2397),(116802,2398),(116803,2399),(116804,2400),(116805,2401),(116806,2402),(116807,2403),(116808,2404),(116809,2405),(116810,2406),(116811,2407),(116812,2408),(116813,2409),(116814,2410),(116815,2458),(116816,2459),(116817,2503),(116818,4627),(116819,4714),(116820,4715),(116821,4716),(116822,4717),(116823,4719),(116824,4720),(116825,4721),(116826,4722),(116827,4723),(116828,4724),(116829,4725),(116830,4726),(116831,4727),(116832,4728),(116833,4729),(116834,4809),(116835,4810),(116836,4811),(116837,4823),(116838,4843),(116839,4844),(116840,4846),(116841,4847),(116842,4848),(116843,4849),(116844,4850),(116845,4851),(116846,4852),(116847,4856),(116848,4899),(116849,4901),(116850,4905),(116851,4906),(116852,4910),(116853,4992),(116854,4993),(116855,4994),(116856,4995),(116857,4996),(116858,4997),(116859,4998),(116860,4999),(116861,5000),(116862,5019),(116863,5020),(116864,5021),(116865,5022),(116866,5023),(116867,5039),(116868,5040),(116869,5041),(116870,5042),(116871,5043),(116872,5044),(116873,5045),(116874,5046),(116875,5047),(116876,5048),(116877,5049),(116878,5050),(116879,5051),(116880,5052),(116881,5053),(116882,5054),(116883,5055),(116884,5056),(116885,5057),(116886,5058),(116887,5059),(116888,5060),(116889,5061),(116890,5065),(116891,5066),(116892,5067),(116893,5068),(116894,5069),(116895,5070),(116896,5071),(116897,5072),(116898,5195),(116899,5196),(116900,5198),(116901,5199),(116902,3829),(116903,3830),(116904,3831),(116905,3832),(116906,3833),(116907,3834),(116908,3975),(116909,3976),(116910,4052),(116911,4053),(116912,4212),(116913,4218),(116914,4219),(116915,4220),(116916,4282),(116917,4283),(116918,4315),(116919,4437),(116920,4438),(116921,4439),(116922,3715),(116923,3716),(116924,3718),(116925,3750),(116926,3774),(116927,3827),(116928,3828),(116929,96),(116930,97),(116931,98),(116932,99),(116933,100),(116934,101),(116935,102),(116936,103),(116937,104),(116938,105),(116939,106),(116940,107),(116941,108),(116942,109),(116943,138),(116944,244),(116945,245),(116946,251),(116947,873),(116948,874),(116949,875),(116950,876),(116951,877),(116952,878),(116953,879),(116954,880),(116955,881),(116956,1039),(116957,1099),(116958,1140),(116959,1141),(116960,1142),(116961,1143),(116962,1149),(116963,1150),(116964,1495),(116965,1497),(116966,1498),(116967,1499),(116968,1500),(116969,1501),(116970,1502),(116971,1503),(116972,1504),(116973,1505),(116974,1506),(116975,1507),(116976,1508),(116977,1509),(116978,1510),(116979,1511),(116980,1512),(116981,1513),(116982,1514),(116983,1796),(116984,1797),(116985,4538),(116986,5171),(116987,5285),(116988,5287),(116989,5288),(116990,5289),(116991,5290),(116992,5291),(116993,5292),(116994,5293),(116995,5294),(116996,5295),(116997,5296),(116998,5297),(116999,5298),(117000,5299),(117001,5300),(117002,5302),(117003,5303),(117004,5304),(117005,5305),(117006,5306),(117007,5307),(117008,5308),(117009,5321),(117010,5322),(117011,5536),(117012,5537),(117013,5689),(117014,5696),(117015,5752),(117016,2655),(117017,2656),(117018,2657),(117019,2766),(117020,2767),(117021,2768),(117022,2769),(117023,2770),(117024,2771),(117025,2773),(117026,2782),(117027,2793),(117028,2969),(117029,2970),(117030,2971),(117031,2972),(117032,2973),(117033,2974),(117034,2975),(117035,2993),(117036,2994),(117037,2995),(117038,2996),(117039,2997),(117040,2998),(117041,2999),(117042,3000),(117043,3001),(117044,3002),(117045,3003),(117046,3004),(117047,3005),(117048,3006),(117049,3007),(117050,3008),(117051,3009),(117052,3010),(117053,3011),(117054,3125),(117055,3490),(117056,3491),(117057,3492),(117058,3493),(117059,3494),(117060,3495),(117061,3496),(117062,3497),(117063,3498),(117064,3499),(117065,3500),(117066,3501),(117067,3502),(117068,3503),(117069,3504),(117070,3505),(117071,3506),(117072,3507),(117073,3508),(117074,3509),(117075,3510),(117076,3511),(117077,3512),(117078,3513),(117079,3514),(117080,3515),(117081,3516),(117082,3517),(117083,3518),(117084,3519),(117085,3520),(117086,3521),(117087,3522),(117088,3523),(117089,3524),(117090,3525),(117091,3526),(117092,3527),(117093,3573),(117094,3574),(117095,3575),(117096,3576),(117097,3577),(117098,3578),(117099,3579),(117100,3580),(117101,3583),(117102,3592),(117103,3593),(117104,3594),(117105,3595),(117106,3596),(117107,3597),(117108,3598),(117109,3599),(117110,3600),(117111,3601),(117112,3602),(117113,3603),(117114,3604),(117115,3605),(117116,3606),(117117,3607),(117118,3608),(117119,3609),(117120,3686),(117121,3687),(117122,3688),(117123,3689),(117124,3690),(117125,3691),(117126,3692),(117127,3693),(117128,3694),(117129,3695),(117130,3696),(117131,3697),(117132,3698),(117133,3699),(117134,3700),(117135,3701),(117136,3702),(117137,3703),(117138,3704),(117139,3705),(117140,3706),(117141,3707),(117142,3708),(117143,3709),(117144,3710),(117145,3711),(117146,3712),(117147,3713),(117148,3714),(117149,3861),(117150,3870),(117151,3875),(117152,3876),(117153,3877),(117154,3878),(117155,3879),(117156,3880),(117157,3892),(117158,3964),(117159,3965),(117160,4059),(117161,4060),(117162,4170),(117163,4171),(117164,4172),(117165,4173),(117166,4174),(117167,4175),(117168,4202),(117169,4203),(117170,4243),(117171,4244),(117172,4245),(117173,4257),(117174,4277),(117175,4278),(117176,4279),(117177,4280),(117178,4281),(117179,4287),(117180,4288),(117181,4289),(117182,4290),(117183,4294),(117184,4295),(117185,4296),(117186,4337),(117187,4338),(117188,4339),(117189,4340),(117190,4342),(117191,4343),(117192,4434),(117193,4435),(117194,4436),(117195,4441),(117196,4442),(117197,4443),(117198,4444),(117199,4445),(117200,4446),(117201,4447),(117202,4448),(117203,4449),(117204,4450),(117205,4451),(117206,4452),(117207,4453),(117208,4454),(117209,4455),(117210,4456),(117211,2667),(117212,2668),(117213,2669),(117214,2670),(117215,2833),(117216,2834),(117217,2835),(117218,2836),(117219,2837),(117220,2861),(117221,2862),(117222,2887),(117223,2699),(117224,2703),(117225,2708),(117226,2711),(117227,2712),(117228,2713),(117229,2714),(117230,2717),(117231,2721),(117232,2722),(117233,2723),(117234,2730),(117235,2765),(117236,2798),(117237,2799),(117238,2800),(117239,2801),(117240,2802),(117241,2803),(117242,2804),(117243,2810),(117244,2812),(117245,2815),(117246,2821),(117247,2828),(117248,2829),(117249,2843),(117250,2856),(117251,2858),(117252,2863),(117253,2886),(117254,2890),(117255,2891),(117256,2893),(117257,2899),(117258,2900),(117259,2904),(117260,2917),(117261,2918),(117262,2923),(117263,2925),(117264,2926),(117265,2929),(117266,2930),(117267,2943),(117268,2945),(117269,2955),(117270,2976),(117271,2978),(117272,2979),(117273,2980),(117274,2987),(117275,2989),(117276,2990),(117277,2998),(117278,2999),(117279,3000),(117280,3001),(117281,3002),(117282,3003),(117283,3004),(117284,3005),(117285,3006),(117286,3007),(117287,3012),(117288,3042),(117289,3043),(117290,3126),(117291,3128),(117292,3130),(117293,3132),(117294,3135),(117295,3140),(117296,3142),(117297,3143),(117298,3146),(117299,3147),(117300,3148),(117301,3149),(117302,3152),(117303,3154),(117304,3155),(117305,3156),(117306,3159),(117307,3172),(117308,3184),(117309,3214),(117310,3407),(117311,3421),(117312,3479),(117313,3480),(117314,3488),(117315,3489),(117316,3490),(117317,3491),(117318,3492),(117319,3493),(117320,3494),(117321,3495),(117322,3496),(117323,3497),(117324,3498),(117325,3499),(117326,3500),(117327,3501),(117328,3502),(117329,3503),(117330,3539),(117331,3540),(117332,3543),(117333,3548),(117334,3573),(117335,3574),(117336,3575),(117337,3576),(117338,3577),(117339,3578),(117340,3579),(117341,3580),(117342,3583),(117343,3592),(117344,3593),(117345,3594),(117346,3595),(117347,3596),(117348,3597),(117349,3598),(117350,3599),(117351,3600),(117352,3601),(117353,3602),(117354,3603),(117355,3604),(117356,3605),(117357,3606),(117358,3607),(117359,3608),(117360,3609),(117361,3620),(117362,3673),(117363,3674),(117364,3686),(117365,3687),(117366,3688),(117367,3689),(117368,3690),(117369,3691),(117370,3692),(117371,3693),(117372,3694),(117373,3695),(117374,3696),(117375,3697),(117376,3698),(117377,3699),(117378,3700),(117379,3701),(117380,3702),(117381,3703),(117382,3704),(117383,3705),(117384,3706),(117385,3707),(117386,3708),(117387,3709),(117388,3710),(117389,3714),(117390,1700),(117391,2696),(117392,2697),(117393,2698),(117394,2699),(117395,2821),(117396,2840),(117397,2841),(117398,2842),(117399,2891),(117400,2904),(117401,2918),(117402,2922),(117403,2923),(117404,2925),(117405,2926),(117406,2929),(117407,2930),(117408,2943),(117409,2945),(117410,2979),(117411,2980),(117412,2998),(117413,2999),(117414,3000),(117415,3001),(117416,3002),(117417,3003),(117418,3004),(117419,3005),(117420,3006),(117421,3007),(117422,3042),(117423,3043),(117424,3118),(117425,3126),(117426,3132),(117427,3135),(117428,3143),(117429,3147),(117430,3148),(117431,3159),(117432,3170),(117433,3171),(117434,3173),(117435,3174),(117436,3175),(117437,3176),(117438,3177),(117439,3178),(117440,3179),(117441,3180),(117442,3181),(117443,3185),(117444,3186),(117445,3187),(117446,3188),(117447,3189),(117448,3190),(117449,3191),(117450,3192),(117451,3193),(117452,3194),(117453,3195),(117454,3204),(117455,3205),(117456,3206),(117457,3207),(117458,3208),(117459,3212),(117460,3213),(117461,3245),(117462,3246),(117463,3247),(117464,3248),(117465,3249),(117466,3250),(117467,3251),(117468,3252),(117469,3253),(117470,3254),(117471,3255),(117472,3256),(117473,3278),(117474,3279),(117475,3280),(117476,3281),(117477,3282),(117478,3283),(117479,3284),(117480,3285),(117481,3286),(117482,3287),(117483,3288),(117484,3289),(117485,3290),(117486,3291),(117487,3292),(117488,3381),(117489,3382),(117490,3383),(117491,3384),(117492,3385),(117493,3386),(117494,3387),(117495,3389),(117496,3390),(117497,3392),(117498,3393),(117499,3394),(117500,3395),(117501,3396),(117502,3397),(117503,3398),(117504,3399),(117505,3400),(117506,3401),(117507,3404),(117508,3405),(117509,3406),(117510,3408),(117511,3409),(117512,3410),(117513,3411),(117514,3412),(117515,3413),(117516,3414),(117517,3415),(117518,3416),(117519,3417),(117520,3418),(117521,3419),(117522,3420),(117523,3421),(117524,3422),(117525,3423),(117526,3424),(117527,3425),(117528,3426),(117529,3427),(117530,3428),(117531,3429),(117532,3430),(117533,3431),(117534,3432),(117535,3433),(117536,3434),(117537,3435),(117538,3436),(117539,3437),(117540,3438),(117541,3439),(117542,3440),(117543,3441),(117544,3442),(117545,3443),(117546,3444),(117547,3445),(117548,3446),(117549,3447),(117550,3448),(117551,3449),(117552,3450),(117553,3451),(117554,3452),(117555,3453),(117556,3454),(117557,3455),(117558,3456),(117559,3457),(117560,3458),(117561,3481),(117562,3482),(117563,3483),(117564,3484),(117565,3485),(117566,3486),(117567,3487),(117568,3489),(117569,3592),(117570,3595),(117571,3596),(117572,3597),(117573,3598),(117574,3599),(117575,3600),(117576,3601),(117577,3602),(117578,3603),(117579,3604),(117580,3605),(117581,3606),(117582,3607),(117583,3608),(117584,3609),(117585,3623),(117586,3686),(117587,3687),(117588,3688),(117589,3689),(117590,3690),(117591,3691),(117592,3692),(117593,3693),(117594,3694),(117595,3695),(117596,3696),(117597,3697),(117598,3698),(117599,3699),(117600,3700),(117601,3701),(117602,3702),(117603,3703),(117604,3704),(117605,3705),(117606,3706),(117607,3707),(117608,3708),(117609,3709),(117610,3710),(117611,3714),(117612,4563),(117613,4563),(117614,3714),(117615,326),(117616,327),(117617,330),(117618,331),(117619,904),(117620,1153),(117621,1154),(117622,1473),(117623,1475),(117624,1486),(117625,1487),(117626,1529),(117627,1530),(117628,1542),(117629,1543),(117630,1545),(117631,1665),(117632,1666),(117633,1836),(117634,1837),(117635,1838),(117636,1839),(117637,1840),(117638,1841),(117639,1842),(117640,1843),(117641,1844),(117642,1845),(117643,1846),(117644,1847),(117645,1848),(117646,1849),(117647,1850),(117648,1851),(117649,1852),(117650,1853),(117651,1854),(117652,1855),(117653,1856),(117654,1857),(117655,1858),(117656,1859),(117657,1860),(117658,1861),(117659,1862),(117660,1863),(117661,1864),(117662,1865),(117663,1866),(117664,1867),(117665,1868),(117666,1869),(117667,1870),(117668,1871),(117669,1872),(117670,1873),(117671,1874),(117672,1875),(117673,1876),(117674,1880),(117675,1881),(117676,1882),(117677,1883),(117678,1884),(117679,1886),(117680,1887),(117681,1888),(117682,1889),(117683,1890),(117684,1891),(117685,1892),(117686,1893),(117687,1894),(117688,1895),(117689,1896),(117690,1897),(117691,1898),(117692,1899),(117693,1900),(117694,1901),(117695,1902),(117696,1903),(117697,1904),(117698,1905),(117699,1906),(117700,1907),(117701,1908),(117702,1909),(117703,1910),(117704,1911),(117705,1912),(117706,1913),(117707,1914),(117708,1915),(117709,1916),(117710,1917),(117711,1918),(117712,1919),(117713,1920),(117714,1921),(117715,1922),(117716,1923),(117717,1924),(117718,1925),(117719,1926),(117720,1927),(117721,1928),(117722,1929),(117723,1930),(117724,1936),(117725,1937),(117726,1938),(117727,2221),(117728,2290),(117729,2291),(117730,2293),(117731,2700),(117732,4530),(117733,4536),(117734,4897),(117735,5171),(117736,5524),(117737,326),(117738,327),(117739,330),(117740,331),(117741,904),(117742,1153),(117743,1154),(117744,1473),(117745,1475),(117746,1486),(117747,1487),(117748,1529),(117749,1530),(117750,1542),(117751,1543),(117752,1545),(117753,1665),(117754,1666),(117755,1836),(117756,1837),(117757,1838),(117758,1839),(117759,1840),(117760,1841),(117761,1842),(117762,1843),(117763,1844),(117764,1845),(117765,1846),(117766,1847),(117767,1848),(117768,1849),(117769,1850),(117770,1851),(117771,1852),(117772,1853),(117773,1854),(117774,1855),(117775,1856),(117776,1857),(117777,1858),(117778,1859),(117779,1860),(117780,1861),(117781,1862),(117782,1863),(117783,1864),(117784,1865),(117785,1866),(117786,1867),(117787,1868),(117788,1869),(117789,1870),(117790,1871),(117791,1872),(117792,1873),(117793,1874),(117794,1875),(117795,1876),(117796,1880),(117797,1881),(117798,1882),(117799,1883),(117800,1884),(117801,1886),(117802,1887),(117803,1888),(117804,1889),(117805,1890),(117806,1891),(117807,1892),(117808,1893),(117809,1894),(117810,1895),(117811,1896),(117812,1897),(117813,1898),(117814,1899),(117815,1900),(117816,1901),(117817,1902),(117818,1903),(117819,1904),(117820,1905),(117821,1906),(117822,1907),(117823,1908),(117824,1909),(117825,1910),(117826,1911),(117827,1912),(117828,1913),(117829,1914),(117830,1915),(117831,1916),(117832,1917),(117833,1918),(117834,1919),(117835,1920),(117836,1921),(117837,1922),(117838,1923),(117839,1924),(117840,1925),(117841,1926),(117842,1927),(117843,1928),(117844,1929),(117845,1930),(117846,1936),(117847,1937),(117848,1938),(117849,2221),(117850,2290),(117851,2291),(117852,2293),(117853,4530),(117854,4536),(117855,4897),(117856,5171),(117857,5524),(117858,2700),(117859,2918),(117860,3043),(117861,5584),(117862,5585),(117863,2921),(117864,2922),(117865,2924),(117866,2927),(117867,2928),(117868,2929),(117869,2930),(117870,2931),(117871,2932),(117872,2933),(117873,2934),(117874,2935),(117875,2936),(117876,2937),(117877,2938),(117878,2939),(117879,2940),(117880,2941),(117881,2942),(117882,2944),(117883,2945),(117884,2946),(117885,2947),(117886,2948),(117887,2949),(117888,2950),(117889,2951),(117890,2952),(117891,2953),(117892,2954),(117893,3164),(117894,3165),(117895,3166),(117896,3534),(117897,3535),(117898,3536),(117899,2699),(117900,2923),(117901,2925),(117902,2926),(117903,2943),(117904,2979),(117905,2980),(117906,3042),(117907,2701),(117908,2702),(117909,2760),(117910,2761),(117911,2762),(117912,2763),(117913,2764),(117914,2765),(117915,2772),(117916,2774),(117917,2775),(117918,2776),(117919,2777),(117920,2778),(117921,2779),(117922,2780),(117923,2783),(117924,2784),(117925,2785),(117926,2786),(117927,2787),(117928,2788),(117929,2789),(117930,2790),(117931,2791),(117932,2792),(117933,2799),(117934,2800),(117935,2801),(117936,2802),(117937,2803),(117938,2804),(117939,2805),(117940,2806),(117941,2807),(117942,2808),(117943,2809),(117944,2810),(117945,2811),(117946,2812),(117947,2813),(117948,2814),(117949,2815),(117950,2816),(117951,2817),(117952,2818),(117953,2819),(117954,2820),(117955,2822),(117956,2823),(117957,2824),(117958,2825),(117959,2826),(117960,2827),(117961,2831),(117962,2832),(117963,2844),(117964,2845),(117965,2846),(117966,2847),(117967,2848),(117968,2849),(117969,2850),(117970,2851),(117971,2852),(117972,2853),(117973,2854),(117974,2855),(117975,2856),(117976,2859),(117977,2860),(117978,2861),(117979,2862),(117980,2864),(117981,2865),(117982,2868),(117983,2869),(117984,2870),(117985,2871),(117986,2872),(117987,2873),(117988,2874),(117989,2875),(117990,2876),(117991,2877),(117992,2878),(117993,2879),(117994,2880),(117995,2881),(117996,2882),(117997,2883),(117998,2884),(117999,2885),(118000,2886),(118001,2887),(118002,2888),(118003,2889),(118004,2892),(118005,2893),(118006,2900),(118007,2901),(118008,2902),(118009,2903),(118010,2905),(118011,2906),(118012,2907),(118013,2908),(118014,2909),(118015,2910),(118016,2911),(118017,2912),(118018,2913),(118019,2914),(118020,2915),(118021,2916),(118022,2955),(118023,2956),(118024,2957),(118025,2958),(118026,2959),(118027,2960),(118028,2961),(118029,2962),(118030,2963),(118031,2964),(118032,2965),(118033,2966),(118034,2967),(118035,2968),(118036,2981),(118037,2982),(118038,2983),(118039,2984),(118040,2985),(118041,2986),(118042,2991),(118043,2992),(118044,3013),(118045,3014),(118046,3015),(118047,3016),(118048,3017),(118049,3018),(118050,3019),(118051,3020),(118052,3021),(118053,3022),(118054,3023),(118055,3024),(118056,3025),(118057,3026),(118058,3027),(118059,3028),(118060,3029),(118061,3030),(118062,3031),(118063,3032),(118064,3033),(118065,3034),(118066,3035),(118067,3036),(118068,3037),(118069,3038),(118070,3039),(118071,3040),(118072,3041),(118073,3044),(118074,3045),(118075,3046),(118076,3047),(118077,3048),(118078,3049),(118079,3056),(118080,3057),(118081,3058),(118082,3059),(118083,3060),(118084,3061),(118085,3062),(118086,3063),(118087,3064),(118088,3065),(118089,3066),(118090,3067),(118091,3068),(118092,3069),(118093,3070),(118094,3071),(118095,3072),(118096,3073),(118097,3074),(118098,3075),(118099,3076),(118100,3077),(118101,3078),(118102,3079),(118103,3080),(118104,3081),(118105,3082),(118106,3083),(118107,3084),(118108,3085),(118109,3086),(118110,3087),(118111,3088),(118112,3089),(118113,3090),(118114,3091),(118115,3092),(118116,3093),(118117,3094),(118118,3095),(118119,3096),(118120,3097),(118121,3098),(118122,3099),(118123,3100),(118124,3101),(118125,3103),(118126,3104),(118127,3105),(118128,3106),(118129,3107),(118130,3108),(118131,3109),(118132,3110),(118133,3111),(118134,3112),(118135,3113),(118136,3114),(118137,3115),(118138,3116),(118139,3117),(118140,3119),(118141,3120),(118142,3121),(118143,3122),(118144,3123),(118145,3124),(118146,3528),(118147,3529),(118148,3530),(118149,3531),(118150,3532),(118151,3533),(118152,3537),(118153,3538),(118154,3543),(118155,3544),(118156,3545),(118157,3546),(118158,3547),(118159,3548),(118160,3549),(118161,3550),(118162,3551),(118163,3552),(118164,3553),(118165,3554),(118166,3555),(118167,3556),(118168,3557),(118169,3558),(118170,3559),(118171,3560),(118172,3561),(118173,3562),(118174,3563),(118175,3564),(118176,3565),(118177,3566),(118178,3567),(118179,3568),(118180,3569),(118181,3570),(118182,3571),(118183,3572),(118184,3581),(118185,3582),(118186,3584),(118187,3585),(118188,3586),(118189,3587),(118190,3588),(118191,3589),(118192,3590),(118193,3591),(118194,3610),(118195,3611),(118196,3612),(118197,3613),(118198,3614),(118199,3615),(118200,3616),(118201,3617),(118202,3618),(118203,3619),(118204,3620),(118205,3621),(118206,3622),(118207,3624),(118208,3625),(118209,3626),(118210,3627),(118211,3628),(118212,3629),(118213,3630),(118214,3631),(118215,3632),(118216,3633),(118217,3634),(118218,3635),(118219,3636),(118220,3637),(118221,3638),(118222,3639),(118223,3640),(118224,3641),(118225,3642),(118226,3643),(118227,3644),(118228,3645),(118229,3646),(118230,3647),(118231,3649),(118232,3650),(118233,3651),(118234,3652),(118235,3653),(118236,3654),(118237,3655),(118238,3656),(118239,3657),(118240,3658),(118241,3659),(118242,3661),(118243,3662),(118244,3663),(118245,3664),(118246,3665),(118247,3666),(118248,3667),(118249,3668),(118250,3669),(118251,3670),(118252,3671),(118253,3672),(118254,3673),(118255,3674),(118256,3684),(118257,3685),(118258,3660),(118259,2655),(118260,2656),(118261,2657),(118262,2766),(118263,2767),(118264,2768),(118265,2769),(118266,2770),(118267,2771),(118268,2773),(118269,2782),(118270,2793),(118271,2969),(118272,2970),(118273,2971),(118274,2972),(118275,2973),(118276,2974),(118277,2975),(118278,2993),(118279,2994),(118280,2995),(118281,2996),(118282,2997),(118283,2998),(118284,2999),(118285,3000),(118286,3001),(118287,3002),(118288,3003),(118289,3004),(118290,3005),(118291,3006),(118292,3007),(118293,3008),(118294,3009),(118295,3010),(118296,3011),(118297,3125),(118298,3490),(118299,3491),(118300,3492),(118301,3493),(118302,3494),(118303,3495),(118304,3496),(118305,3497),(118306,3498),(118307,3499),(118308,3500),(118309,3501),(118310,3502),(118311,3503),(118312,3504),(118313,3505),(118314,3506),(118315,3507),(118316,3508),(118317,3509),(118318,3510),(118319,3511),(118320,3512),(118321,3513),(118322,3514),(118323,3515),(118324,3516),(118325,3517),(118326,3518),(118327,3519),(118328,3520),(118329,3521),(118330,3522),(118331,3523),(118332,3524),(118333,3525),(118334,3526),(118335,3527),(118336,3573),(118337,3574),(118338,3575),(118339,3576),(118340,3577),(118341,3578),(118342,3579),(118343,3580),(118344,3583),(118345,3592),(118346,3593),(118347,3594),(118348,3595),(118349,3596),(118350,3597),(118351,3598),(118352,3599),(118353,3600),(118354,3601),(118355,3602),(118356,3603),(118357,3604),(118358,3605),(118359,3606),(118360,3607),(118361,3608),(118362,3609),(118363,3686),(118364,3687),(118365,3688),(118366,3689),(118367,3690),(118368,3691),(118369,3692),(118370,3693),(118371,3694),(118372,3695),(118373,3696),(118374,3697),(118375,3698),(118376,3699),(118377,3700),(118378,3701),(118379,3702),(118380,3703),(118381,3704),(118382,3705),(118383,3706),(118384,3707),(118385,3708),(118386,3709),(118387,3710),(118388,3711),(118389,3712),(118390,3713),(118391,3714),(118392,2622),(118393,2623),(118394,2624),(118395,2625),(118396,2626),(118397,2627),(118398,2628),(118399,2629),(118400,2630),(118401,2631),(118402,2632),(118403,2633),(118404,2634),(118405,2635),(118406,2636),(118407,2637),(118408,2638),(118409,2639),(118410,2640),(118411,2641),(118412,2642),(118413,2643),(118414,2644),(118415,2645),(118416,2646),(118417,2647),(118418,2648),(118419,2649),(118420,2650),(118421,2651),(118422,2652),(118423,2653),(118424,2654),(118425,2658),(118426,2659),(118427,2660),(118428,2661),(118429,2662),(118430,2663),(118431,2664),(118432,2665),(118433,2666),(118434,2667),(118435,2668),(118436,2669),(118437,2670),(118438,2671),(118439,2672),(118440,2673),(118441,2674),(118442,2675),(118443,2676),(118444,2677),(118445,2678),(118446,2679),(118447,2680),(118448,2681),(118449,2682),(118450,2683),(118451,2684),(118452,2685),(118453,2686),(118454,2687),(118455,2688),(118456,2689),(118457,2690),(118458,2691),(118459,2692),(118460,2693),(118461,2694),(118462,2695),(118463,2696),(118464,2697),(118465,2698),(118466,2700),(118467,2703),(118468,2781),(118469,2794),(118470,2795),(118471,2796),(118472,2798),(118473,2821),(118474,2828),(118475,2829),(118476,2830),(118477,2833),(118478,2834),(118479,2835),(118480,2836),(118481,2837),(118482,2838),(118483,2839),(118484,2840),(118485,2841),(118486,2842),(118487,2843),(118488,2858),(118489,2863),(118490,2866),(118491,2867),(118492,2890),(118493,2891),(118494,2895),(118495,2896),(118496,2897),(118497,2898),(118498,2899),(118499,2917),(118500,2976),(118501,2978),(118502,2987),(118503,2989),(118504,2990),(118505,3012),(118506,3050),(118507,3051),(118508,3052),(118509,3053),(118510,3054),(118511,3055),(118512,3102),(118513,3126),(118514,3127),(118515,3128),(118516,3129),(118517,3130),(118518,3131),(118519,3132),(118520,3133),(118521,3134),(118522,3135),(118523,3136),(118524,3137),(118525,3138),(118526,3139),(118527,3140),(118528,3141),(118529,3142),(118530,3143),(118531,3144),(118532,3145),(118533,3146),(118534,3147),(118535,3148),(118536,3149),(118537,3150),(118538,3151),(118539,3152),(118540,3153),(118541,3154),(118542,3155),(118543,3156),(118544,3157),(118545,3158),(118546,3159),(118547,3160),(118548,3161),(118549,3162),(118550,3163),(118551,3167),(118552,3168),(118553,3169),(118554,3170),(118555,3171),(118556,3172),(118557,3173),(118558,3174),(118559,3175),(118560,3176),(118561,3177),(118562,3178),(118563,3179),(118564,3180),(118565,3181),(118566,3182),(118567,3183),(118568,3184),(118569,3185),(118570,3186),(118571,3187),(118572,3188),(118573,3189),(118574,3190),(118575,3191),(118576,3192),(118577,3193),(118578,3194),(118579,3195),(118580,3196),(118581,3197),(118582,3198),(118583,3199),(118584,3200),(118585,3201),(118586,3202),(118587,3203),(118588,3204),(118589,3205),(118590,3206),(118591,3207),(118592,3208),(118593,3209),(118594,3210),(118595,3211),(118596,3212),(118597,3213),(118598,3214),(118599,3215),(118600,3216),(118601,3217),(118602,3218),(118603,3219),(118604,3220),(118605,3221),(118606,3222),(118607,3223),(118608,3224),(118609,3225),(118610,3226),(118611,3227),(118612,3228),(118613,3229),(118614,3230),(118615,3231),(118616,3232),(118617,3233),(118618,3234),(118619,3235),(118620,3236),(118621,3237),(118622,3238),(118623,3239),(118624,3240),(118625,3241),(118626,3242),(118627,3243),(118628,3244),(118629,3245),(118630,3246),(118631,3247),(118632,3248),(118633,3249),(118634,3250),(118635,3251),(118636,3252),(118637,3253),(118638,3254),(118639,3255),(118640,3256),(118641,3257),(118642,3258),(118643,3259),(118644,3260),(118645,3261),(118646,3262),(118647,3263),(118648,3264),(118649,3265),(118650,3266),(118651,3267),(118652,3268),(118653,3269),(118654,3270),(118655,3271),(118656,3272),(118657,3273),(118658,3274),(118659,3275),(118660,3276),(118661,3277),(118662,3278),(118663,3279),(118664,3280),(118665,3281),(118666,3282),(118667,3283),(118668,3284),(118669,3285),(118670,3286),(118671,3287),(118672,3288),(118673,3289),(118674,3290),(118675,3291),(118676,3292),(118677,3293),(118678,3294),(118679,3295),(118680,3296),(118681,3297),(118682,3298),(118683,3299),(118684,3300),(118685,3301),(118686,3302),(118687,3303),(118688,3304),(118689,3305),(118690,3306),(118691,3307),(118692,3308),(118693,3309),(118694,3310),(118695,3311),(118696,3312),(118697,3313),(118698,3314),(118699,3315),(118700,3316),(118701,3317),(118702,3318),(118703,3319),(118704,3320),(118705,3321),(118706,3322),(118707,3323),(118708,3324),(118709,3325),(118710,3326),(118711,3327),(118712,3328),(118713,3329),(118714,3330),(118715,3331),(118716,3332),(118717,3333),(118718,3334),(118719,3335),(118720,3336),(118721,3337),(118722,3338),(118723,3339),(118724,3340),(118725,3341),(118726,3342),(118727,3343),(118728,3344),(118729,3345),(118730,3346),(118731,3347),(118732,3348),(118733,3349),(118734,3350),(118735,3351),(118736,3352),(118737,3353),(118738,3354),(118739,3355),(118740,3356),(118741,3357),(118742,3358),(118743,3359),(118744,3360),(118745,3361),(118746,3362),(118747,3363),(118748,3364),(118749,3365),(118750,3366),(118751,3367),(118752,3368),(118753,3369),(118754,3370),(118755,3371),(118756,3372),(118757,3373),(118758,3374),(118759,3375),(118760,3376),(118761,3377),(118762,3378),(118763,3379),(118764,3380),(118765,3381),(118766,3382),(118767,3383),(118768,3384),(118769,3385),(118770,3386),(118771,3387),(118772,3388),(118773,3389),(118774,3390),(118775,3391),(118776,3392),(118777,3393),(118778,3394),(118779,3395),(118780,3396),(118781,3397),(118782,3398),(118783,3399),(118784,3400),(118785,3401),(118786,3402),(118787,3403),(118788,3404),(118789,3405),(118790,3406),(118791,3407),(118792,3408),(118793,3409),(118794,3410),(118795,3411),(118796,3412),(118797,3413),(118798,3414),(118799,3415),(118800,3416),(118801,3417),(118802,3418),(118803,3419),(118804,3420),(118805,3421),(118806,3422),(118807,3423),(118808,3424),(118809,3425),(118810,3426),(118811,3427),(118812,3428),(118813,3429),(118814,3430),(118815,3431),(118816,3432),(118817,3433),(118818,3434),(118819,3435),(118820,3436),(118821,3437),(118822,3438),(118823,3439),(118824,3440),(118825,3441),(118826,3442),(118827,3443),(118828,3444),(118829,3445),(118830,3446),(118831,3447),(118832,3448),(118833,3449),(118834,3450),(118835,3451),(118836,3452),(118837,3453),(118838,3454),(118839,3455),(118840,3456),(118841,3457),(118842,3458),(118843,3459),(118844,3460),(118845,3461),(118846,3462),(118847,3463),(118848,3464),(118849,3465),(118850,3466),(118851,3467),(118852,3468),(118853,3469),(118854,3470),(118855,3471),(118856,3472),(118857,3473),(118858,3474),(118859,3475),(118860,3476),(118861,3477),(118862,3478),(118863,3479),(118864,3480),(118865,3481),(118866,3482),(118867,3483),(118868,3484),(118869,3485),(118870,3486),(118871,3487),(118872,3488),(118873,3489),(118874,3539),(118875,3540),(118876,3541),(118877,3542),(118878,3648),(118879,3675),(118880,3676),(118881,3677),(118882,3678),(118883,3679),(118884,3680),(118885,3681),(118886,3682),(118887,3683),(118888,2700),(118889,2866),(118890,2867),(118891,3153),(118892,3675),(118893,3676),(118894,3677),(118895,3678),(118896,3679),(118897,3680),(118898,3681),(118899,3682),(118900,3683),(118901,2821),(118902,2842),(118903,2891),(118904,2918),(118905,2922),(118906,3043),(118907,3143),(118908,3170),(118909,3173),(118910,3175),(118911,3176),(118912,3178),(118913,3181),(118914,3185),(118915,3187),(118916,3204),(118917,3206),(118918,3208),(118919,3246),(118920,3251),(118921,3253),(118922,3254),(118923,3256),(118924,3278),(118925,3279),(118926,3284),(118927,3286),(118928,3382),(118929,3415),(118930,3425),(118931,3429),(118932,3439),(118933,3440),(118934,3443),(118935,3447),(118936,3686),(118937,3687),(118938,3701),(118939,5621),(118940,1700),(118941,2677),(118942,2696),(118943,2697),(118944,2698),(118945,2702),(118946,2703),(118947,2708),(118948,2711),(118949,2712),(118950,2713),(118951,2714),(118952,2717),(118953,2721),(118954,2722),(118955,2723),(118956,2730),(118957,2760),(118958,2761),(118959,2762),(118960,2763),(118961,2764),(118962,2765),(118963,2772),(118964,2774),(118965,2775),(118966,2776),(118967,2777),(118968,2778),(118969,2779),(118970,2780),(118971,2783),(118972,2784),(118973,2785),(118974,2786),(118975,2787),(118976,2788),(118977,2789),(118978,2790),(118979,2791),(118980,2792),(118981,2799),(118982,2801),(118983,2802),(118984,2803),(118985,2804),(118986,2810),(118987,2815),(118988,2822),(118989,2823),(118990,2824),(118991,2825),(118992,2826),(118993,2827),(118994,2831),(118995,2832),(118996,2840),(118997,2841),(118998,2844),(118999,2845),(119000,2852),(119001,2853),(119002,2854),(119003,2855),(119004,2856),(119005,2859),(119006,2860),(119007,2863),(119008,2886),(119009,2890),(119010,2892),(119011,2893),(119012,2899),(119013,2900),(119014,2901),(119015,2902),(119016,2903),(119017,2904),(119018,2917),(119019,2923),(119020,2955),(119021,2956),(119022,2957),(119023,2958),(119024,2959),(119025,2960),(119026,2961),(119027,2962),(119028,2976),(119029,2978),(119030,2989),(119031,2990),(119032,2998),(119033,2999),(119034,3000),(119035,3001),(119036,3002),(119037,3003),(119038,3004),(119039,3005),(119040,3006),(119041,3007),(119042,3012),(119043,3126),(119044,3129),(119045,3132),(119046,3135),(119047,3140),(119048,3142),(119049,3144),(119050,3146),(119051,3147),(119052,3148),(119053,3149),(119054,3152),(119055,3154),(119056,3155),(119057,3156),(119058,3159),(119059,3171),(119060,3174),(119061,3177),(119062,3179),(119063,3180),(119064,3184),(119065,3186),(119066,3188),(119067,3189),(119068,3190),(119069,3191),(119070,3192),(119071,3193),(119072,3194),(119073,3195),(119074,3205),(119075,3207),(119076,3212),(119077,3213),(119078,3214),(119079,3245),(119080,3247),(119081,3248),(119082,3249),(119083,3250),(119084,3252),(119085,3255),(119086,3280),(119087,3281),(119088,3282),(119089,3283),(119090,3285),(119091,3287),(119092,3288),(119093,3289),(119094,3290),(119095,3291),(119096,3292),(119097,3376),(119098,3377),(119099,3378),(119100,3379),(119101,3380),(119102,3381),(119103,3383),(119104,3384),(119105,3385),(119106,3386),(119107,3387),(119108,3389),(119109,3390),(119110,3392),(119111,3393),(119112,3394),(119113,3395),(119114,3396),(119115,3397),(119116,3398),(119117,3399),(119118,3400),(119119,3401),(119120,3404),(119121,3405),(119122,3406),(119123,3408),(119124,3409),(119125,3410),(119126,3411),(119127,3412),(119128,3413),(119129,3414),(119130,3416),(119131,3417),(119132,3418),(119133,3419),(119134,3420),(119135,3421),(119136,3422),(119137,3423),(119138,3424),(119139,3426),(119140,3427),(119141,3428),(119142,3430),(119143,3431),(119144,3432),(119145,3433),(119146,3434),(119147,3435),(119148,3436),(119149,3437),(119150,3438),(119151,3441),(119152,3442),(119153,3444),(119154,3445),(119155,3446),(119156,3448),(119157,3449),(119158,3450),(119159,3451),(119160,3452),(119161,3453),(119162,3454),(119163,3455),(119164,3456),(119165,3457),(119166,3458),(119167,3480),(119168,3481),(119169,3482),(119170,3483),(119171,3484),(119172,3485),(119173,3486),(119174,3487),(119175,3488),(119176,3489),(119177,3490),(119178,3491),(119179,3492),(119180,3493),(119181,3494),(119182,3495),(119183,3496),(119184,3497),(119185,3498),(119186,3499),(119187,3500),(119188,3501),(119189,3502),(119190,3503),(119191,3540),(119192,3543),(119193,3544),(119194,3545),(119195,3546),(119196,3547),(119197,3548),(119198,3573),(119199,3574),(119200,3575),(119201,3576),(119202,3577),(119203,3578),(119204,3579),(119205,3580),(119206,3583),(119207,3592),(119208,3593),(119209,3594),(119210,3595),(119211,3596),(119212,3597),(119213,3598),(119214,3599),(119215,3600),(119216,3601),(119217,3602),(119218,3603),(119219,3604),(119220,3605),(119221,3606),(119222,3607),(119223,3608),(119224,3609),(119225,3614),(119226,3615),(119227,3616),(119228,3617),(119229,3618),(119230,3619),(119231,3620),(119232,3649),(119233,3650),(119234,3673),(119235,3674),(119236,3684),(119237,3685),(119238,3688),(119239,3689),(119240,3690),(119241,3691),(119242,3692),(119243,3693),(119244,3694),(119245,3695),(119246,3696),(119247,3697),(119248,3698),(119249,3699),(119250,3700),(119251,3702),(119252,3703),(119253,3704),(119254,3705),(119255,3706),(119256,3707),(119257,3708),(119258,3709),(119259,3710),(119260,4563),(119261,5365),(119262,5527),(119263,5584),(119264,5585),(119265,5627),(119266,5637),(119267,5644),(119268,5645),(119269,5646),(119270,5652),(119271,5654),(119272,5663),(119273,5670),(119274,5671),(119275,5672),(119276,2622),(119277,2623),(119278,2624),(119279,2625),(119280,2626),(119281,2627),(119282,2628),(119283,2629),(119284,2630),(119285,2631),(119286,2632),(119287,2633),(119288,2634),(119289,2635),(119290,2636),(119291,2637),(119292,2638),(119293,2639),(119294,2640),(119295,2641),(119296,2642),(119297,2643),(119298,2644),(119299,2645),(119300,2646),(119301,2647),(119302,2648),(119303,2649),(119304,2650),(119305,2651),(119306,2652),(119307,2653),(119308,2654),(119309,2655),(119310,2656),(119311,2657),(119312,2658),(119313,2659),(119314,2660),(119315,2661),(119316,2662),(119317,2663),(119318,2664),(119319,2665),(119320,2666),(119321,2667),(119322,2668),(119323,2669),(119324,2670),(119325,2671),(119326,2672),(119327,2673),(119328,2674),(119329,2675),(119330,2676),(119331,2678),(119332,2679),(119333,2680),(119334,2681),(119335,2682),(119336,2683),(119337,2684),(119338,2685),(119339,2686),(119340,2687),(119341,2688),(119342,2689),(119343,2690),(119344,2691),(119345,2692),(119346,2693),(119347,2694),(119348,2695),(119349,2701),(119350,2702),(119351,2703),(119352,2704),(119353,2705),(119354,2706),(119355,2707),(119356,2708),(119357,2709),(119358,2710),(119359,2711),(119360,2712),(119361,2713),(119362,2714),(119363,2715),(119364,2716),(119365,2717),(119366,2718),(119367,2719),(119368,2720),(119369,2721),(119370,2722),(119371,2723),(119372,2724),(119373,2725),(119374,2726),(119375,2727),(119376,2728),(119377,2729),(119378,2730),(119379,2731),(119380,2732),(119381,2733),(119382,2734),(119383,2735),(119384,2736),(119385,2737),(119386,2738),(119387,2739),(119388,2740),(119389,2741),(119390,2742),(119391,2743),(119392,2744),(119393,2745),(119394,2746),(119395,2747),(119396,2748),(119397,2749),(119398,2750),(119399,2751),(119400,2752),(119401,2753),(119402,2754),(119403,2755),(119404,2756),(119405,2757),(119406,2758),(119407,2759),(119408,2760),(119409,2761),(119410,2762),(119411,2763),(119412,2764),(119413,2765),(119414,2766),(119415,2767),(119416,2768),(119417,2769),(119418,2770),(119419,2771),(119420,2772),(119421,2773),(119422,2774),(119423,2775),(119424,2776),(119425,2777),(119426,2778),(119427,2779),(119428,2780),(119429,2781),(119430,2782),(119431,2783),(119432,2784),(119433,2785),(119434,2786),(119435,2787),(119436,2788),(119437,2789),(119438,2790),(119439,2791),(119440,2792),(119441,2793),(119442,2794),(119443,2795),(119444,2796),(119445,2797),(119446,2798),(119447,2799),(119448,2800),(119449,2801),(119450,2802),(119451,2803),(119452,2804),(119453,2805),(119454,2806),(119455,2807),(119456,2808),(119457,2809),(119458,2810),(119459,2811),(119460,2812),(119461,2813),(119462,2814),(119463,2815),(119464,2816),(119465,2817),(119466,2818),(119467,2819),(119468,2820),(119469,2822),(119470,2823),(119471,2824),(119472,2825),(119473,2826),(119474,2827),(119475,2828),(119476,2829),(119477,2830),(119478,2831),(119479,2832),(119480,2833),(119481,2834),(119482,2835),(119483,2836),(119484,2837),(119485,2838),(119486,2839),(119487,2843),(119488,2844),(119489,2845),(119490,2846),(119491,2847),(119492,2848),(119493,2849),(119494,2850),(119495,2851),(119496,2852),(119497,2853),(119498,2854),(119499,2855),(119500,2856),(119501,2857),(119502,2858),(119503,2859),(119504,2860),(119505,2861),(119506,2862),(119507,2863),(119508,2864),(119509,2865),(119510,2868),(119511,2869),(119512,2870),(119513,2871),(119514,2872),(119515,2873),(119516,2874),(119517,2875),(119518,2876),(119519,2877),(119520,2878),(119521,2879),(119522,2880),(119523,2881),(119524,2882),(119525,2883),(119526,2884),(119527,2885),(119528,2886),(119529,2887),(119530,2888),(119531,2889),(119532,2890),(119533,2892),(119534,2893),(119535,2894),(119536,2895),(119537,2896),(119538,2897),(119539,2898),(119540,2899),(119541,2900),(119542,2901),(119543,2902),(119544,2903),(119545,2905),(119546,2906),(119547,2907),(119548,2908),(119549,2909),(119550,2910),(119551,2911),(119552,2912),(119553,2913),(119554,2914),(119555,2915),(119556,2916),(119557,2917),(119558,2921),(119559,2922),(119560,2924),(119561,2927),(119562,2928),(119563,2931),(119564,2932),(119565,2933),(119566,2934),(119567,2935),(119568,2936),(119569,2937),(119570,2938),(119571,2939),(119572,2940),(119573,2941),(119574,2942),(119575,2944),(119576,2946),(119577,2947),(119578,2948),(119579,2949),(119580,2950),(119581,2951),(119582,2952),(119583,2953),(119584,2954),(119585,2955),(119586,2956),(119587,2957),(119588,2958),(119589,2959),(119590,2960),(119591,2961),(119592,2962),(119593,2963),(119594,2964),(119595,2965),(119596,2966),(119597,2967),(119598,2968),(119599,2969),(119600,2970),(119601,2971),(119602,2972),(119603,2973),(119604,2974),(119605,2975),(119606,2976),(119607,2977),(119608,2978),(119609,2981),(119610,2982),(119611,2983),(119612,2984),(119613,2985),(119614,2986),(119615,2987),(119616,2988),(119617,2989),(119618,2990),(119619,2991),(119620,2992),(119621,2993),(119622,2994),(119623,2995),(119624,2996),(119625,2997),(119626,3008),(119627,3009),(119628,3010),(119629,3011),(119630,3012),(119631,3013),(119632,3014),(119633,3015),(119634,3016),(119635,3017),(119636,3018),(119637,3019),(119638,3020),(119639,3021),(119640,3022),(119641,3023),(119642,3024),(119643,3025),(119644,3026),(119645,3027),(119646,3028),(119647,3029),(119648,3030),(119649,3031),(119650,3032),(119651,3033),(119652,3034),(119653,3035),(119654,3036),(119655,3037),(119656,3038),(119657,3039),(119658,3040),(119659,3041),(119660,3044),(119661,3045),(119662,3046),(119663,3047),(119664,3048),(119665,3049),(119666,3050),(119667,3051),(119668,3052),(119669,3053),(119670,3054),(119671,3055),(119672,3056),(119673,3057),(119674,3058),(119675,3059),(119676,3060),(119677,3061),(119678,3062),(119679,3063),(119680,3064),(119681,3065),(119682,3066),(119683,3067),(119684,3068),(119685,3069),(119686,3070),(119687,3071),(119688,3072),(119689,3073),(119690,3074),(119691,3075),(119692,3076),(119693,3077),(119694,3078),(119695,3079),(119696,3080),(119697,3081),(119698,3082),(119699,3083),(119700,3084),(119701,3085),(119702,3086),(119703,3087),(119704,3088),(119705,3089),(119706,3090),(119707,3091),(119708,3092),(119709,3093),(119710,3094),(119711,3095),(119712,3096),(119713,3097),(119714,3098),(119715,3099),(119716,3100),(119717,3101),(119718,3102),(119719,3103),(119720,3104),(119721,3105),(119722,3106),(119723,3107),(119724,3108),(119725,3109),(119726,3110),(119727,3111),(119728,3112),(119729,3113),(119730,3114),(119731,3115),(119732,3116),(119733,3117),(119734,3119),(119735,3120),(119736,3121),(119737,3122),(119738,3123),(119739,3124),(119740,3125),(119741,3127),(119742,3128),(119743,3129),(119744,3130),(119745,3131),(119746,3133),(119747,3134),(119748,3136),(119749,3137),(119750,3138),(119751,3139),(119752,3140),(119753,3141),(119754,3142),(119755,3144),(119756,3145),(119757,3146),(119758,3147),(119759,3148),(119760,3149),(119761,3150),(119762,3151),(119763,3152),(119764,3153),(119765,3154),(119766,3155),(119767,3156),(119768,3157),(119769,3158),(119770,3160),(119771,3161),(119772,3162),(119773,3163),(119774,3164),(119775,3165),(119776,3166),(119777,3167),(119778,3168),(119779,3169),(119780,3172),(119781,3182),(119782,3183),(119783,3184),(119784,3196),(119785,3197),(119786,3198),(119787,3199),(119788,3200),(119789,3201),(119790,3202),(119791,3203),(119792,3209),(119793,3210),(119794,3211),(119795,3214),(119796,3215),(119797,3216),(119798,3217),(119799,3218),(119800,3219),(119801,3220),(119802,3221),(119803,3222),(119804,3223),(119805,3224),(119806,3225),(119807,3226),(119808,3227),(119809,3228),(119810,3229),(119811,3230),(119812,3231),(119813,3232),(119814,3233),(119815,3234),(119816,3235),(119817,3236),(119818,3237),(119819,3238),(119820,3239),(119821,3240),(119822,3241),(119823,3242),(119824,3243),(119825,3244),(119826,3257),(119827,3258),(119828,3259),(119829,3260),(119830,3261),(119831,3262),(119832,3263),(119833,3264),(119834,3265),(119835,3266),(119836,3267),(119837,3268),(119838,3269),(119839,3270),(119840,3271),(119841,3272),(119842,3273),(119843,3274),(119844,3275),(119845,3276),(119846,3277),(119847,3293),(119848,3294),(119849,3295),(119850,3296),(119851,3297),(119852,3298),(119853,3299),(119854,3300),(119855,3301),(119856,3302),(119857,3303),(119858,3304),(119859,3305),(119860,3306),(119861,3307),(119862,3308),(119863,3309),(119864,3310),(119865,3311),(119866,3312),(119867,3313),(119868,3314),(119869,3315),(119870,3316),(119871,3317),(119872,3318),(119873,3319),(119874,3320),(119875,3321),(119876,3322),(119877,3323),(119878,3324),(119879,3325),(119880,3326),(119881,3327),(119882,3328),(119883,3329),(119884,3330),(119885,3331),(119886,3332),(119887,3333),(119888,3334),(119889,3335),(119890,3336),(119891,3337),(119892,3338),(119893,3339),(119894,3340),(119895,3341),(119896,3342),(119897,3343),(119898,3344),(119899,3345),(119900,3346),(119901,3347),(119902,3348),(119903,3349),(119904,3350),(119905,3351),(119906,3352),(119907,3353),(119908,3354),(119909,3355),(119910,3356),(119911,3357),(119912,3358),(119913,3359),(119914,3360),(119915,3361),(119916,3362),(119917,3363),(119918,3364),(119919,3365),(119920,3366),(119921,3367),(119922,3368),(119923,3369),(119924,3370),(119925,3371),(119926,3372),(119927,3373),(119928,3374),(119929,3375),(119930,3376),(119931,3377),(119932,3378),(119933,3379),(119934,3380),(119935,3388),(119936,3391),(119937,3402),(119938,3403),(119939,3407),(119940,3459),(119941,3460),(119942,3461),(119943,3462),(119944,3463),(119945,3464),(119946,3465),(119947,3466),(119948,3467),(119949,3468),(119950,3469),(119951,3470),(119952,3471),(119953,3472),(119954,3473),(119955,3474),(119956,3475),(119957,3476),(119958,3477),(119959,3478),(119960,3479),(119961,3480),(119962,3488),(119963,3490),(119964,3491),(119965,3492),(119966,3493),(119967,3494),(119968,3495),(119969,3496),(119970,3497),(119971,3498),(119972,3499),(119973,3500),(119974,3501),(119975,3502),(119976,3503),(119977,3504),(119978,3505),(119979,3506),(119980,3507),(119981,3508),(119982,3509),(119983,3510),(119984,3511),(119985,3512),(119986,3513),(119987,3514),(119988,3515),(119989,3516),(119990,3517),(119991,3518),(119992,3519),(119993,3520),(119994,3521),(119995,3522),(119996,3523),(119997,3524),(119998,3525),(119999,3526),(120000,3527),(120001,3528),(120002,3529),(120003,3530),(120004,3531),(120005,3532),(120006,3533),(120007,3534),(120008,3535),(120009,3536),(120010,3537),(120011,3538),(120012,3539),(120013,3540),(120014,3541),(120015,3542),(120016,3543),(120017,3544),(120018,3545),(120019,3546),(120020,3547),(120021,3548),(120022,3549),(120023,3550),(120024,3551),(120025,3552),(120026,3553),(120027,3554),(120028,3555),(120029,3556),(120030,3557),(120031,3558),(120032,3559),(120033,3560),(120034,3561),(120035,3562),(120036,3563),(120037,3564),(120038,3565),(120039,3566),(120040,3567),(120041,3568),(120042,3569),(120043,3570),(120044,3571),(120045,3572),(120046,3573),(120047,3574),(120048,3575),(120049,3576),(120050,3577),(120051,3578),(120052,3579),(120053,3580),(120054,3581),(120055,3582),(120056,3583),(120057,3584),(120058,3585),(120059,3586),(120060,3587),(120061,3588),(120062,3589),(120063,3590),(120064,3591),(120065,3593),(120066,3594),(120067,3610),(120068,3611),(120069,3612),(120070,3613),(120071,3614),(120072,3615),(120073,3616),(120074,3617),(120075,3618),(120076,3619),(120077,3620),(120078,3621),(120079,3622),(120080,3624),(120081,3625),(120082,3626),(120083,3627),(120084,3628),(120085,3629),(120086,3630),(120087,3631),(120088,3632),(120089,3633),(120090,3634),(120091,3635),(120092,3636),(120093,3637),(120094,3638),(120095,3639),(120096,3640),(120097,3641),(120098,3642),(120099,3643),(120100,3644),(120101,3645),(120102,3646),(120103,3647),(120104,3648),(120105,3649),(120106,3650),(120107,3651),(120108,3652),(120109,3653),(120110,3654),(120111,3655),(120112,3656),(120113,3657),(120114,3658),(120115,3659),(120116,3660),(120117,3661),(120118,3662),(120119,3663),(120120,3664),(120121,3665),(120122,3666),(120123,3667),(120124,3668),(120125,3669),(120126,3670),(120127,3671),(120128,3672),(120129,3673),(120130,3674),(120131,3675),(120132,3676),(120133,3677),(120134,3678),(120135,3679),(120136,3680),(120137,3681),(120138,3682),(120139,3683),(120140,3684),(120141,3685),(120142,3701),(120143,3711),(120144,3712),(120145,3713),(120146,3714),(120147,2921),(120148,2922),(120149,2942),(120150,2944),(120151,3153),(120152,3675),(120153,3676),(120154,3677),(120155,3678),(120156,3679),(120157,3680),(120158,3681),(120159,3682),(120160,3683),(120161,1953),(120162,1954),(120163,1955),(120164,1956),(120165,1957),(120166,2003),(120167,2004),(120168,2009),(120169,2010),(120170,2011),(120171,2017),(120172,2043),(120173,2047),(120174,2048),(120175,2049),(120176,2050),(120177,2051),(120178,2052),(120179,2054),(120180,2056),(120181,2057),(120182,2058),(120183,2059),(120184,2060),(120185,2061),(120186,2064),(120187,2067),(120188,2069),(120189,2071),(120190,2073),(120191,2075),(120192,2077),(120193,2078),(120194,2080),(120195,2083),(120196,2084),(120197,2086),(120198,2087),(120199,2088),(120200,2089),(120201,2092),(120202,2105),(120203,2106),(120204,2107),(120205,2108),(120206,2109),(120207,2110),(120208,2111),(120209,2112),(120210,2120),(120211,2121),(120212,2166),(120213,2167),(120214,2170),(120215,2171),(120216,2172),(120217,2173),(120218,2174),(120219,2175),(120220,2227),(120221,2228),(120222,2229),(120223,2230),(120224,2231),(120225,2253),(120226,2254),(120227,2285),(120228,2287),(120229,2292),(120230,2432),(120231,2433),(120232,2434),(120233,2436),(120234,2437),(120235,2438),(120236,2439),(120237,2443),(120238,2444),(120239,2445),(120240,2446),(120241,2447),(120242,2448),(120243,2457),(120244,2475),(120245,2476),(120246,2492),(120247,2493),(120248,2532),(120249,2533),(120250,2534),(120251,2535),(120252,2555),(120253,2560),(120254,2561),(120255,2562),(120256,2563),(120257,2564),(120258,2565),(120259,2566),(120260,2569),(120261,2570),(120262,2571),(120263,2572),(120264,2582),(120265,2583),(120266,2585),(120267,2588),(120268,2615),(120269,3737),(120270,3832),(120271,4021),(120272,4022),(120273,4023),(120274,4024),(120275,4025),(120276,4026),(120277,4027),(120278,4028),(120279,4029),(120280,4030),(120281,4031),(120282,4032),(120283,4033),(120284,4032),(120285,4033),(120286,3731),(120287,3735),(120288,3736),(120289,3744),(120290,3753),(120291,3755),(120292,3760),(120293,4022),(120294,4024),(120295,4026),(120296,4029),(120297,4031),(120298,4033),(120299,4183),(120300,4184),(120301,4189),(120302,3719),(120303,3724),(120304,4138),(120305,4139),(120306,4409),(120307,4413),(120308,3940),(120309,3962),(120310,3992),(120311,3999),(120312,4006),(120313,4008),(120314,4038),(120315,4044),(120316,4092),(120317,4093),(120318,4095),(120319,4125),(120320,4126),(120321,4178),(120322,4246),(120323,4271),(120324,4272),(120325,4273),(120326,4284),(120327,4285),(120328,4320),(120329,4321),(120330,4322),(120331,4323),(120332,4324),(120333,4360),(120334,4457),(120335,3889),(120336,3908),(120337,4094),(120338,4162),(120339,4271),(120340,4272),(120341,4341),(120342,4416),(120343,3971),(120344,3990),(120345,3991),(120346,4000),(120347,4001),(120348,4004),(120349,4005),(120350,4045),(120351,4046),(120352,4047),(120353,4048),(120354,4050),(120355,4051),(120356,4097),(120357,4100),(120358,4101),(120359,4103),(120360,4104),(120361,4105),(120362,4106),(120363,4107),(120364,4109),(120365,4110),(120366,4111),(120367,4112),(120368,4113),(120369,4114),(120370,4115),(120371,4116),(120372,4117),(120373,4144),(120374,4160),(120375,4163),(120376,4166),(120377,4176),(120378,4221),(120379,4284),(120380,4285),(120381,4286),(120382,4361),(120383,4368),(120384,4369),(120385,4372),(120386,4375),(120387,4376),(120388,4377),(120389,4380),(120390,4385),(120391,4386),(120392,4387),(120393,4388),(120394,4389),(120395,4423),(120396,4429),(120397,4440),(120398,3869),(120399,3907),(120400,4096),(120401,4162),(120402,3723),(120403,3732),(120404,3739),(120405,3746),(120406,3835),(120407,3896),(120408,3897),(120409,3898),(120410,3899),(120411,4362),(120412,4363),(120413,4365),(120414,4463),(120415,4464),(120416,4465),(120417,4466),(120418,4471),(120419,4472),(120420,4477),(120421,4478),(120422,3835),(120423,3896),(120424,3897),(120425,3898),(120426,3899),(120427,4240),(120428,4362),(120429,4363),(120430,4365),(120431,4463),(120432,4464),(120433,4465),(120434,4466),(120435,4471),(120436,4472),(120437,4477),(120438,4478),(120439,3843),(120440,3844),(120441,3845),(120442,3879),(120443,3888),(120444,3978),(120445,4049),(120446,4098),(120447,4099),(120448,4141),(120449,4147),(120450,4329),(120451,4357),(120452,4422),(120453,4428),(120454,1629),(120455,1636),(120456,1637),(120457,1638),(120458,1639),(120459,1643),(120460,1644),(120461,1645),(120462,1646),(120463,1647),(120464,1648),(120465,1649),(120466,3979),(120467,3980),(120468,4141),(120469,4147),(120470,4153),(120471,4154),(120472,4168),(120473,4248),(120474,4337),(120475,4338),(120476,4339),(120477,4359),(120478,3835),(120479,3843),(120480,3844),(120481,3845),(120482,3888),(120483,4098),(120484,4099),(120485,4357),(120486,4428),(120487,3772),(120488,3773),(120489,3775),(120490,3860),(120491,3868),(120492,3891),(120493,3900),(120494,3901),(120495,3902),(120496,3906),(120497,3917),(120498,3939),(120499,3940),(120500,4042),(120501,4061),(120502,4071),(120503,4072),(120504,4073),(120505,4074),(120506,4096),(120507,4150),(120508,4157),(120509,4158),(120510,4159),(120511,4164),(120512,4165),(120513,4199),(120514,4200),(120515,4201),(120516,4242),(120517,4247),(120518,4261),(120519,4262),(120520,4263),(120521,4268),(120522,4341),(120523,4368),(120524,4369),(120525,4370),(120526,4371),(120527,4372),(120528,4373),(120529,4374),(120530,4375),(120531,4384),(120532,4387),(120533,4389),(120534,4416),(120535,4479),(120536,3772),(120537,3773),(120538,3775),(120539,3860),(120540,3868),(120541,3891),(120542,3900),(120543,3901),(120544,3902),(120545,3906),(120546,3917),(120547,3939),(120548,3940),(120549,4042),(120550,4061),(120551,4071),(120552,4072),(120553,4073),(120554,4074),(120555,4096),(120556,4150),(120557,4157),(120558,4158),(120559,4159),(120560,4164),(120561,4165),(120562,4199),(120563,4200),(120564,4201),(120565,4242),(120566,4247),(120567,4261),(120568,4262),(120569,4263),(120570,4268),(120571,4341),(120572,4368),(120573,4369),(120574,4370),(120575,4371),(120576,4372),(120577,4373),(120578,4374),(120579,4375),(120580,4384),(120581,4387),(120582,4389),(120583,4416),(120584,4479),(120585,3772),(120586,3773),(120587,3775),(120588,3860),(120589,3868),(120590,3891),(120591,3900),(120592,3901),(120593,3902),(120594,3906),(120595,3917),(120596,3939),(120597,3940),(120598,4042),(120599,4061),(120600,4071),(120601,4072),(120602,4073),(120603,4074),(120604,4096),(120605,4150),(120606,4157),(120607,4158),(120608,4159),(120609,4164),(120610,4165),(120611,4199),(120612,4200),(120613,4201),(120614,4242),(120615,4247),(120616,4261),(120617,4262),(120618,4263),(120619,4268),(120620,4341),(120621,4368),(120622,4369),(120623,4370),(120624,4371),(120625,4372),(120626,4373),(120627,4374),(120628,4375),(120629,4384),(120630,4387),(120631,4389),(120632,4479),(120633,3861),(120634,4170),(120635,4171),(120636,4174),(120637,4175),(120638,4203),(120639,4340),(120640,4434),(120641,4435),(120642,4416),(120643,3772),(120644,3773),(120645,3775),(120646,3860),(120647,3868),(120648,3891),(120649,3900),(120650,3901),(120651,3902),(120652,3906),(120653,3917),(120654,3939),(120655,3940),(120656,4042),(120657,4061),(120658,4071),(120659,4072),(120660,4073),(120661,4074),(120662,4096),(120663,4150),(120664,4157),(120665,4158),(120666,4159),(120667,4164),(120668,4165),(120669,4199),(120670,4200),(120671,4201),(120672,4242),(120673,4247),(120674,4261),(120675,4262),(120676,4263),(120677,4268),(120678,4341),(120679,4368),(120680,4369),(120681,4370),(120682,4371),(120683,4372),(120684,4373),(120685,4374),(120686,4375),(120687,4384),(120688,4387),(120689,4389),(120690,4416),(120691,4479),(120692,3861),(120693,4170),(120694,4171),(120695,4174),(120696,4175),(120697,4203),(120698,4340),(120699,4434),(120700,4435),(120701,2181),(120702,2182),(120703,2183),(120704,2184),(120705,2185),(120706,2186),(120707,2203),(120708,2204),(120709,2205),(120710,2206),(120711,2207),(120712,2212),(120713,2213),(120714,2223),(120715,2224),(120716,2225),(120717,2252),(120718,2255),(120719,2263),(120720,2264),(120721,2272),(120722,2273),(120723,2274),(120724,2277),(120725,2278),(120726,2279),(120727,2280),(120728,2281),(120729,2282),(120730,2283),(120731,2284),(120732,2286),(120733,2288),(120734,2294),(120735,2297),(120736,2298),(120737,2300),(120738,2301),(120739,2429),(120740,2450),(120741,2451),(120742,2452),(120743,2453),(120744,2465),(120745,2466),(120746,2467),(120747,2468),(120748,2469),(120749,2470),(120750,2471),(120751,2474),(120752,2481),(120753,2482),(120754,2483),(120755,2484),(120756,2485),(120757,2487),(120758,2488),(120759,2489),(120760,2490),(120761,2491),(120762,2494),(120763,2495),(120764,2496),(120765,2497),(120766,2501),(120767,2502),(120768,2513),(120769,2514),(120770,2529),(120771,2536),(120772,2543),(120773,2544),(120774,2547),(120775,2548),(120776,2549),(120777,2550),(120778,2551),(120779,2552),(120780,2553),(120781,2554),(120782,2556),(120783,2557),(120784,2558),(120785,2616),(120786,2617),(120787,2618),(120788,2619),(120789,2620),(120790,2621),(120791,1958),(120792,2005),(120793,2006),(120794,2007),(120795,2012),(120796,2015),(120797,2016),(120798,2018),(120799,2019),(120800,2020),(120801,2024),(120802,2025),(120803,2033),(120804,2036),(120805,2038),(120806,2053),(120807,2055),(120808,2062),(120809,2063),(120810,2065),(120811,2066),(120812,2068),(120813,2070),(120814,2072),(120815,2074),(120816,2076),(120817,2079),(120818,2081),(120819,2082),(120820,2085),(120821,2090),(120822,2091),(120823,2093),(120824,2094),(120825,2095),(120826,2096),(120827,2097),(120828,2098),(120829,2099),(120830,2100),(120831,2101),(120832,2102),(120833,2103),(120834,2104),(120835,2116),(120836,2117),(120837,2118),(120838,2119),(120839,2158),(120840,2159),(120841,2160),(120842,2161),(120843,2164),(120844,2165),(120845,2168),(120846,2169),(120847,2178),(120848,2179),(120849,2180),(120850,281),(120851,284),(120852,286),(120853,287),(120854,289),(120855,291),(120856,292),(120857,294),(120858,296),(120859,297),(120860,301),(120861,304),(120862,305),(120863,307),(120864,316),(120865,332),(120866,333),(120867,337),(120868,527),(120869,528),(120870,529),(120871,557),(120872,588),(120873,590),(120874,592),(120875,611),(120876,613),(120877,617),(120878,618),(120879,619),(120880,624),(120881,625),(120882,636),(120883,637),(120884,639),(120885,646),(120886,648),(120887,659),(120888,660),(120889,670),(120890,690),(120891,691),(120892,693),(120893,695),(120894,697),(120895,698),(120896,700),(120897,702),(120898,706),(120899,728),(120900,778),(120901,779),(120902,834),(120903,835),(120904,836),(120905,837),(120906,838),(120907,839),(120908,840),(120909,906),(120910,997),(120911,1001),(120912,1037),(120913,1038),(120914,1064),(120915,1066),(120916,1067),(120917,1068),(120918,1069),(120919,1070),(120920,1071),(120921,1072),(120922,1073),(120923,1074),(120924,1075),(120925,1133),(120926,1165),(120927,1813),(120928,1815),(120929,1816),(120930,1818),(120931,1820),(120932,1821),(120933,1822),(120934,1827),(120935,2003),(120936,2004),(120937,2005),(120938,2006),(120939,2007),(120940,2008),(120941,2009),(120942,2010),(120943,2011),(120944,2012),(120945,2014),(120946,2016),(120947,2017),(120948,2020),(120949,2024),(120950,2033),(120951,2038),(120952,2043),(120953,2067),(120954,2105),(120955,2116),(120956,2117),(120957,2158),(120958,2160),(120959,2161),(120960,2164),(120961,2170),(120962,2171),(120963,2172),(120964,2173),(120965,2176),(120966,2181),(120967,2184),(120968,2185),(120969,2186),(120970,2199),(120971,2203),(120972,2207),(120973,2227),(120974,2247),(120975,2249),(120976,2250),(120977,2277),(120978,2278),(120979,2279),(120980,2280),(120981,2297),(120982,2429),(120983,2430),(120984,2431),(120985,2440),(120986,2443),(120987,2444),(120988,2457),(120989,2474),(120990,2481),(120991,2482),(120992,2483),(120993,2485),(120994,2506),(120995,2517),(120996,2518),(120997,2520),(120998,2521),(120999,2523),(121000,2524),(121001,2525),(121002,2526),(121003,2528),(121004,2529),(121005,2530),(121006,2532),(121007,2533),(121008,2534),(121009,2535),(121010,2536),(121011,2539),(121012,2544),(121013,2545),(121014,2546),(121015,2547),(121016,2548),(121017,2549),(121018,2550),(121019,2551),(121020,2553),(121021,2554),(121022,2560),(121023,2573),(121024,2574),(121025,2575),(121026,2576),(121027,2182),(121028,2183),(121029,2211),(121030,2212),(121031,2213),(121032,2223),(121033,2224),(121034,2225),(121035,2228),(121036,2229),(121037,2231),(121038,2253),(121039,2254),(121040,2255),(121041,2263),(121042,2264),(121043,2272),(121044,2273),(121045,2274),(121046,2281),(121047,2282),(121048,2283),(121049,2284),(121050,2285),(121051,2286),(121052,2287),(121053,2288),(121054,2292),(121055,2294),(121056,2295),(121057,2298),(121058,2432),(121059,2433),(121060,2434),(121061,2436),(121062,2437),(121063,2438),(121064,2439),(121065,2445),(121066,2446),(121067,2447),(121068,2448),(121069,2450),(121070,2451),(121071,2453),(121072,2465),(121073,2466),(121074,2467),(121075,2468),(121076,2469),(121077,2470),(121078,2471),(121079,2480),(121080,2484),(121081,2486),(121082,2487),(121083,2488),(121084,2492),(121085,2493),(121086,2496),(121087,2498),(121088,2499),(121089,2500),(121090,2501),(121091,2502),(121092,2513),(121093,2514),(121094,2519),(121095,2522),(121096,2527),(121097,2552),(121098,2556),(121099,2557),(121100,2558),(121101,2561),(121102,2562),(121103,2563),(121104,2564),(121105,2565),(121106,2566),(121107,2567),(121108,2568),(121109,2569),(121110,2570),(121111,2571),(121112,2572),(121113,2582),(121114,2583),(121115,2584),(121116,2585),(121117,2586),(121118,2587),(121119,2588),(121120,2615),(121121,2616),(121122,2617),(121123,2618),(121124,2619),(121125,2620),(121126,5757),(121127,5758),(121128,5759),(121129,298),(121130,299),(121131,300),(121132,302),(121133,303),(121134,306),(121135,341),(121136,342),(121137,343),(121138,374),(121139,375),(121140,376),(121141,530),(121142,531),(121143,532),(121144,560),(121145,587),(121146,589),(121147,591),(121148,632),(121149,652),(121150,682),(121151,683),(121152,684),(121153,685),(121154,686),(121155,687),(121156,688),(121157,689),(121158,694),(121159,696),(121160,705),(121161,711),(121162,712),(121163,715),(121164,716),(121165,717),(121166,735),(121167,736),(121168,742),(121169,998),(121170,999),(121171,1000),(121172,1036),(121173,1162),(121174,1163),(121175,1164),(121176,1956),(121177,1957),(121178,1958),(121179,2015),(121180,2018),(121181,2019),(121182,2047),(121183,2048),(121184,2049),(121185,2050),(121186,2051),(121187,2052),(121188,2053),(121189,2054),(121190,2055),(121191,2056),(121192,2057),(121193,2058),(121194,2060),(121195,2061),(121196,2062),(121197,2063),(121198,2065),(121199,2066),(121200,2068),(121201,2069),(121202,2070),(121203,2071),(121204,2072),(121205,2073),(121206,2074),(121207,2075),(121208,2076),(121209,2077),(121210,2078),(121211,2079),(121212,2080),(121213,2081),(121214,2082),(121215,2083),(121216,2084),(121217,2085),(121218,2090),(121219,2091),(121220,2092),(121221,2093),(121222,2097),(121223,2098),(121224,2099),(121225,2100),(121226,2101),(121227,2102),(121228,2118),(121229,2119),(121230,2120),(121231,2121),(121232,2155),(121233,2156),(121234,2157),(121235,2162),(121236,2165),(121237,2166),(121238,2167),(121239,2168),(121240,2169),(121241,2175),(121242,2178),(121243,2179),(121244,2180),(121245,1162),(121246,1163),(121247,1164),(121248,1165),(121249,1818),(121250,1953),(121251,1954),(121252,1955),(121253,1956),(121254,2013),(121255,2159),(121256,2164),(121257,2176),(121258,2184),(121259,2185),(121260,2203),(121261,2206),(121262,2212),(121263,2227),(121264,2228),(121265,2229),(121266,2230),(121267,2248),(121268,2271),(121269,2278),(121270,2280),(121271,2300),(121272,2429),(121273,2430),(121274,2431),(121275,2440),(121276,2441),(121277,2472),(121278,2473),(121279,2474),(121280,2475),(121281,2476),(121282,2483),(121283,2489),(121284,2490),(121285,2491),(121286,2494),(121287,2495),(121288,2496),(121289,2497),(121290,2506),(121291,2508),(121292,2511),(121293,2517),(121294,2518),(121295,2519),(121296,2520),(121297,2523),(121298,2524),(121299,2525),(121300,2526),(121301,2528),(121302,2532),(121303,2533),(121304,2534),(121305,2536),(121306,2543),(121307,2544),(121308,2545),(121309,2546),(121310,2548),(121311,2551),(121312,2553),(121313,2574),(121314,2575),(121315,2576),(121316,2583),(121317,5757),(121318,5758),(121319,5759),(121320,1816),(121321,1958),(121322,2014),(121323,2096),(121324,2161),(121325,2163),(121326,2174),(121327,2175),(121328,2183),(121329,2186),(121330,2205),(121331,2213),(121332,2223),(121333,2224),(121334,2225),(121335,2231),(121336,2247),(121337,2270),(121338,2277),(121339,2279),(121340,2282),(121341,2295),(121342,2298),(121343,2301),(121344,2434),(121345,2439),(121346,2448),(121347,2487),(121348,2488),(121349,2492),(121350,2493),(121351,2507),(121352,2509),(121353,2512),(121354,2514),(121355,2522),(121356,2527),(121357,2530),(121358,2547),(121359,2549),(121360,2550),(121361,2554),(121362,2585),(121363,2008),(121364,2182),(121365,2204),(121366,2207),(121367,2249),(121368,2250),(121369,2446),(121370,2587),(121371,1957),(121372,2486),(121373,2043),(121374,2199),(121375,2203),(121376,2586),(121377,2587),(121378,2181),(121379,2182),(121380,2183),(121381,2184),(121382,2185),(121383,2186),(121384,2199),(121385,2203),(121386,2204),(121387,2205),(121388,2206),(121389,2207),(121390,2211),(121391,2212),(121392,2213),(121393,2223),(121394,2224),(121395,2225),(121396,2226),(121397,2227),(121398,2228),(121399,2229),(121400,2230),(121401,2231),(121402,2247),(121403,2248),(121404,2249),(121405,2250),(121406,2252),(121407,2253),(121408,2254),(121409,2255),(121410,2263),(121411,2264),(121412,2270),(121413,2271),(121414,2272),(121415,2273),(121416,2274),(121417,2277),(121418,2278),(121419,2279),(121420,2280),(121421,2281),(121422,2282),(121423,2283),(121424,2284),(121425,2285),(121426,2286),(121427,2287),(121428,2288),(121429,2292),(121430,2294),(121431,2295),(121432,2296),(121433,2297),(121434,2298),(121435,2300),(121436,2301),(121437,2429),(121438,2430),(121439,2431),(121440,2432),(121441,2433),(121442,2434),(121443,2436),(121444,2437),(121445,2438),(121446,2439),(121447,2440),(121448,2441),(121449,2442),(121450,2443),(121451,2444),(121452,2445),(121453,2446),(121454,2447),(121455,2448),(121456,2450),(121457,2451),(121458,2452),(121459,2453),(121460,2457),(121461,2465),(121462,2466),(121463,2467),(121464,2468),(121465,2469),(121466,2470),(121467,2471),(121468,2472),(121469,2473),(121470,2474),(121471,2475),(121472,2476),(121473,2477),(121474,2478),(121475,2479),(121476,2480),(121477,2481),(121478,2482),(121479,2483),(121480,2484),(121481,2485),(121482,2486),(121483,2487),(121484,2488),(121485,2489),(121486,2490),(121487,2491),(121488,2492),(121489,2493),(121490,2494),(121491,2495),(121492,2496),(121493,2497),(121494,2498),(121495,2499),(121496,2500),(121497,2501),(121498,2502),(121499,2506),(121500,2507),(121501,2508),(121502,2509),(121503,2510),(121504,2511),(121505,2512),(121506,2513),(121507,2514),(121508,2517),(121509,2518),(121510,2519),(121511,2520),(121512,2521),(121513,2522),(121514,2523),(121515,2524),(121516,2525),(121517,2526),(121518,2527),(121519,2528),(121520,2529),(121521,2530),(121522,2532),(121523,2533),(121524,2534),(121525,2535),(121526,2536),(121527,2539),(121528,2543),(121529,2544),(121530,2545),(121531,2546),(121532,2547),(121533,2548),(121534,2549),(121535,2550),(121536,2551),(121537,2552),(121538,2553),(121539,2554),(121540,2555),(121541,2556),(121542,2557),(121543,2558),(121544,2560),(121545,2561),(121546,2562),(121547,2563),(121548,2564),(121549,2565),(121550,2566),(121551,2567),(121552,2568),(121553,2569),(121554,2570),(121555,2571),(121556,2572),(121557,2573),(121558,2574),(121559,2575),(121560,2576),(121561,2582),(121562,2583),(121563,2584),(121564,2585),(121565,2586),(121566,2587),(121567,2588),(121568,2615),(121569,2616),(121570,2617),(121571,2618),(121572,2619),(121573,2620),(121574,2621),(121575,5757),(121576,5758),(121577,5759),(121578,281),(121579,284),(121580,286),(121581,287),(121582,289),(121583,291),(121584,292),(121585,294),(121586,296),(121587,297),(121588,298),(121589,299),(121590,300),(121591,301),(121592,302),(121593,303),(121594,304),(121595,305),(121596,306),(121597,307),(121598,316),(121599,332),(121600,333),(121601,337),(121602,341),(121603,342),(121604,343),(121605,374),(121606,375),(121607,376),(121608,527),(121609,528),(121610,529),(121611,530),(121612,531),(121613,532),(121614,557),(121615,560),(121616,587),(121617,588),(121618,589),(121619,590),(121620,591),(121621,592),(121622,611),(121623,613),(121624,617),(121625,618),(121626,619),(121627,624),(121628,625),(121629,632),(121630,636),(121631,637),(121632,639),(121633,646),(121634,648),(121635,652),(121636,659),(121637,660),(121638,670),(121639,682),(121640,683),(121641,684),(121642,685),(121643,686),(121644,687),(121645,688),(121646,689),(121647,690),(121648,691),(121649,693),(121650,694),(121651,695),(121652,696),(121653,697),(121654,698),(121655,700),(121656,702),(121657,705),(121658,706),(121659,711),(121660,712),(121661,715),(121662,716),(121663,717),(121664,728),(121665,735),(121666,736),(121667,742),(121668,778),(121669,779),(121670,834),(121671,835),(121672,836),(121673,837),(121674,838),(121675,839),(121676,840),(121677,906),(121678,997),(121679,998),(121680,999),(121681,1000),(121682,1001),(121683,1036),(121684,1037),(121685,1038),(121686,1064),(121687,1066),(121688,1067),(121689,1068),(121690,1069),(121691,1070),(121692,1071),(121693,1072),(121694,1073),(121695,1074),(121696,1075),(121697,1133),(121698,1162),(121699,1163),(121700,1164),(121701,1165),(121702,1813),(121703,1815),(121704,1816),(121705,1818),(121706,1820),(121707,1821),(121708,1822),(121709,1827),(121710,1953),(121711,1954),(121712,1955),(121713,1956),(121714,1957),(121715,1958),(121716,2003),(121717,2004),(121718,2005),(121719,2006),(121720,2007),(121721,2008),(121722,2009),(121723,2010),(121724,2011),(121725,2012),(121726,2014),(121727,2015),(121728,2016),(121729,2017),(121730,2018),(121731,2019),(121732,2020),(121733,2024),(121734,2025),(121735,2033),(121736,2036),(121737,2038),(121738,2043),(121739,2047),(121740,2048),(121741,2049),(121742,2050),(121743,2051),(121744,2052),(121745,2053),(121746,2054),(121747,2055),(121748,2056),(121749,2057),(121750,2058),(121751,2059),(121752,2060),(121753,2061),(121754,2062),(121755,2063),(121756,2064),(121757,2065),(121758,2066),(121759,2067),(121760,2068),(121761,2069),(121762,2070),(121763,2071),(121764,2072),(121765,2073),(121766,2074),(121767,2075),(121768,2076),(121769,2077),(121770,2078),(121771,2079),(121772,2080),(121773,2081),(121774,2082),(121775,2083),(121776,2084),(121777,2085),(121778,2086),(121779,2087),(121780,2088),(121781,2089),(121782,2090),(121783,2091),(121784,2092),(121785,2093),(121786,2094),(121787,2095),(121788,2096),(121789,2097),(121790,2098),(121791,2099),(121792,2100),(121793,2101),(121794,2102),(121795,2103),(121796,2104),(121797,2105),(121798,2106),(121799,2107),(121800,2108),(121801,2109),(121802,2110),(121803,2111),(121804,2112),(121805,2116),(121806,2117),(121807,2118),(121808,2119),(121809,2120),(121810,2121),(121811,2155),(121812,2156),(121813,2157),(121814,2158),(121815,2159),(121816,2160),(121817,2161),(121818,2162),(121819,2163),(121820,2164),(121821,2165),(121822,2166),(121823,2167),(121824,2168),(121825,2169),(121826,2170),(121827,2171),(121828,2172),(121829,2173),(121830,2174),(121831,2175),(121832,2176),(121833,2178),(121834,2179),(121835,2180),(121836,716),(121837,717),(121838,2199),(121839,2203),(121840,2281),(121841,2282),(121842,2294),(121843,2295),(121844,2457),(121845,2517),(121846,2518),(121847,2519),(121848,2520),(121849,2547),(121850,2548),(121851,2549),(121852,2550),(121853,2551),(121854,2582),(121855,2583),(121856,2584),(121857,2585),(121858,2586),(121859,2587),(121860,1070),(121861,1958),(121862,2036),(121863,2043),(121864,2086),(121865,2087),(121866,2088),(121867,2092),(121868,2093),(121869,2094),(121870,2095),(121871,2096),(121872,2162),(121873,2204),(121874,2205),(121875,2206),(121876,2212),(121877,2213),(121878,2277),(121879,2278),(121880,2279),(121881,2280),(121882,2300),(121883,2301),(121884,2489),(121885,2490),(121886,2491),(121887,2532),(121888,2533),(121889,2534),(121890,2535),(121891,1816),(121892,1818),(121893,1822),(121894,2013),(121895,4861),(121896,4862),(121897,4863),(121898,4864),(121899,4865),(121900,4866),(121901,4867),(121902,4868),(121903,4869),(121904,4870),(121905,4871),(121906,4872),(121907,4873),(121908,4874),(121909,4875),(121910,4876),(121911,4891),(121912,4892),(121913,4893),(121914,4894),(121915,281),(121916,282),(121917,283),(121918,284),(121919,285),(121920,286),(121921,287),(121922,288),(121923,289),(121924,290),(121925,291),(121926,292),(121927,293),(121928,294),(121929,295),(121930,296),(121931,297),(121932,298),(121933,299),(121934,300),(121935,301),(121936,302),(121937,303),(121938,304),(121939,305),(121940,306),(121941,307),(121942,308),(121943,309),(121944,310),(121945,311),(121946,312),(121947,313),(121948,314),(121949,315),(121950,316),(121951,317),(121952,318),(121953,319),(121954,320),(121955,321),(121956,322),(121957,323),(121958,324),(121959,325),(121960,326),(121961,327),(121962,328),(121963,329),(121964,330),(121965,331),(121966,332),(121967,333),(121968,334),(121969,335),(121970,336),(121971,337),(121972,338),(121973,339),(121974,340),(121975,341),(121976,342),(121977,343),(121978,344),(121979,345),(121980,346),(121981,347),(121982,903),(121983,904),(121984,905),(121985,907),(121986,1813),(121987,1814),(121988,1815),(121989,1816),(121990,1817),(121991,1818),(121992,1819),(121993,1820),(121994,1821),(121995,1822),(121996,1823),(121997,1824),(121998,1825),(121999,1826),(122000,1827),(122001,1828),(122002,1829),(122003,1830),(122004,1831),(122005,1832),(122006,1833),(122007,1834),(122008,1835),(122009,1950),(122010,1951),(122011,1952),(122012,1953),(122013,1954),(122014,1955),(122015,1956),(122016,1957),(122017,1958),(122018,1965),(122019,1966),(122020,1967),(122021,1968),(122022,1969),(122023,1970),(122024,1971),(122025,2154),(122026,2158),(122027,2159),(122028,2160),(122029,2161),(122030,2162),(122031,2170),(122032,2171),(122033,2172),(122034,2173),(122035,2174),(122036,2175),(122037,2177),(122038,2181),(122039,2182),(122040,2183),(122041,2184),(122042,2185),(122043,2186),(122044,2199),(122045,2211),(122046,2212),(122047,2213),(122048,2223),(122049,2224),(122050,2225),(122051,2226),(122052,2227),(122053,2228),(122054,2229),(122055,2230),(122056,2231),(122057,2281),(122058,2282),(122059,2292),(122060,2294),(122061,2295),(122062,2297),(122063,2298),(122064,2432),(122065,2433),(122066,2434),(122067,2436),(122068,2437),(122069,2438),(122070,2439),(122071,2443),(122072,2444),(122073,2445),(122074,2446),(122075,2447),(122076,2448),(122077,2475),(122078,2476),(122079,2477),(122080,2478),(122081,2479),(122082,2480),(122083,2481),(122084,2482),(122085,2483),(122086,2484),(122087,2485),(122088,2486),(122089,2487),(122090,2488),(122091,2492),(122092,2493),(122093,2494),(122094,2495),(122095,2496),(122096,2497),(122097,2498),(122098,2499),(122099,2500),(122100,2513),(122101,2514),(122102,2529),(122103,2530),(122104,2539),(122105,2553),(122106,2554),(122107,2582),(122108,2583),(122109,2584),(122110,2585),(122111,2586),(122112,2587),(122113,4613),(122114,4614),(122115,4857),(122116,4858),(122117,4859),(122118,4860),(122119,906),(122120,908),(122121,1004),(122122,1012),(122123,1019),(122124,1037),(122125,1092),(122126,1119),(122127,1162),(122128,1163),(122129,1164),(122130,1165),(122131,2163),(122132,2164),(122133,2176),(122134,2203),(122135,2204),(122136,2205),(122137,2206),(122138,2207),(122139,2247),(122140,2248),(122141,2249),(122142,2250),(122143,2270),(122144,2271),(122145,2277),(122146,2278),(122147,2279),(122148,2280),(122149,2296),(122150,2299),(122151,2300),(122152,2301),(122153,2429),(122154,2430),(122155,2431),(122156,2440),(122157,2441),(122158,2442),(122159,2457),(122160,2472),(122161,2473),(122162,2474),(122163,2489),(122164,2490),(122165,2491),(122166,2506),(122167,2507),(122168,2508),(122169,2509),(122170,2510),(122171,2511),(122172,2512),(122173,2521),(122174,2522),(122175,2523),(122176,2524),(122177,2525),(122178,2526),(122179,2527),(122180,2528),(122181,2531),(122182,2532),(122183,2533),(122184,2534),(122185,2535),(122186,2536),(122187,2540),(122188,2541),(122189,2542),(122190,2543),(122191,2544),(122192,2545),(122193,2546),(122194,2547),(122195,2548),(122196,2549),(122197,2550),(122198,2551),(122199,2573),(122200,2574),(122201,2575),(122202,2576),(122203,5757),(122204,5758),(122205,5759),(122206,681),(122207,682),(122208,683),(122209,684),(122210,685),(122211,686),(122212,687),(122213,688),(122214,689),(122215,690),(122216,691),(122217,692),(122218,693),(122219,694),(122220,695),(122221,696),(122222,697),(122223,698),(122224,699),(122225,700),(122226,701),(122227,702),(122228,703),(122229,704),(122230,705),(122231,706),(122232,707),(122233,708),(122234,709),(122235,710),(122236,711),(122237,712),(122238,713),(122239,714),(122240,715),(122241,716),(122242,717),(122243,718),(122244,719),(122245,720),(122246,721),(122247,722),(122248,723),(122249,724),(122250,725),(122251,726),(122252,727),(122253,728),(122254,729),(122255,730),(122256,731),(122257,732),(122258,733),(122259,734),(122260,735),(122261,736),(122262,737),(122263,738),(122264,739),(122265,740),(122266,741),(122267,742),(122268,743),(122269,744),(122270,745),(122271,746),(122272,747),(122273,748),(122274,749),(122275,996),(122276,997),(122277,998),(122278,999),(122279,1000),(122280,1001),(122281,1002),(122282,1003),(122283,1005),(122284,1034),(122285,1035),(122286,1036),(122287,1038),(122288,1133),(122289,1972),(122290,1973),(122291,1974),(122292,1975),(122293,1976),(122294,1977),(122295,1978),(122296,1979),(122297,1980),(122298,1981),(122299,1982),(122300,1983),(122301,1984),(122302,1985),(122303,1986),(122304,1987),(122305,1988),(122306,1989),(122307,1990),(122308,1991),(122309,2003),(122310,2004),(122311,2005),(122312,2006),(122313,2007),(122314,2008),(122315,2009),(122316,2010),(122317,2011),(122318,2012),(122319,2013),(122320,2014),(122321,2015),(122322,2016),(122323,2017),(122324,2018),(122325,2019),(122326,2020),(122327,2021),(122328,2022),(122329,2023),(122330,2024),(122331,2025),(122332,2033),(122333,2035),(122334,2036),(122335,2037),(122336,2038),(122337,2041),(122338,2043),(122339,2047),(122340,2048),(122341,2049),(122342,2050),(122343,2051),(122344,2052),(122345,2053),(122346,2054),(122347,2055),(122348,2056),(122349,2057),(122350,2058),(122351,2059),(122352,2060),(122353,2061),(122354,2062),(122355,2063),(122356,2064),(122357,2065),(122358,2066),(122359,2067),(122360,2068),(122361,2069),(122362,2070),(122363,2071),(122364,2072),(122365,2073),(122366,2074),(122367,2075),(122368,2076),(122369,2077),(122370,2078),(122371,2079),(122372,2080),(122373,2081),(122374,2082),(122375,2083),(122376,2084),(122377,2085),(122378,2086),(122379,2087),(122380,2088),(122381,2089),(122382,2090),(122383,2091),(122384,2092),(122385,2093),(122386,2094),(122387,2095),(122388,2096),(122389,2097),(122390,2098),(122391,2099),(122392,2100),(122393,2101),(122394,2102),(122395,2103),(122396,2104),(122397,2105),(122398,2106),(122399,2107),(122400,2108),(122401,2109),(122402,2110),(122403,2111),(122404,2112),(122405,2113),(122406,2114),(122407,2115),(122408,2116),(122409,2117),(122410,2118),(122411,2119),(122412,2120),(122413,2121),(122414,2155),(122415,2156),(122416,2157),(122417,2165),(122418,2166),(122419,2167),(122420,2168),(122421,2169),(122422,2178),(122423,2179),(122424,2180),(122425,2221),(122426,2222),(122427,2252),(122428,2253),(122429,2254),(122430,2255),(122431,2263),(122432,2264),(122433,2272),(122434,2273),(122435,2274),(122436,2283),(122437,2284),(122438,2285),(122439,2286),(122440,2287),(122441,2288),(122442,2450),(122443,2451),(122444,2452),(122445,2453),(122446,2465),(122447,2466),(122448,2467),(122449,2468),(122450,2469),(122451,2470),(122452,2471),(122453,2501),(122454,2502),(122455,2552),(122456,2555),(122457,2556),(122458,2557),(122459,2558),(122460,2560),(122461,2561),(122462,2562),(122463,2563),(122464,2564),(122465,2565),(122466,2566),(122467,2567),(122468,2568),(122469,2569),(122470,2570),(122471,2571),(122472,2572),(122473,2588),(122474,2615),(122475,2616),(122476,2617),(122477,2618),(122478,2619),(122479,2620),(122480,2621),(122481,348),(122482,349),(122483,350),(122484,351),(122485,352),(122486,353),(122487,354),(122488,355),(122489,356),(122490,357),(122491,358),(122492,359),(122493,360),(122494,361),(122495,370),(122496,371),(122497,372),(122498,373),(122499,374),(122500,375),(122501,376),(122502,377),(122503,378),(122504,379),(122505,380),(122506,381),(122507,382),(122508,383),(122509,384),(122510,385),(122511,386),(122512,387),(122513,388),(122514,389),(122515,390),(122516,391),(122517,392),(122518,393),(122519,394),(122520,395),(122521,396),(122522,397),(122523,533),(122524,534),(122525,535),(122526,536),(122527,537),(122528,538),(122529,539),(122530,540),(122531,541),(122532,542),(122533,543),(122534,544),(122535,545),(122536,546),(122537,547),(122538,548),(122539,549),(122540,550),(122541,551),(122542,552),(122543,553),(122544,554),(122545,555),(122546,556),(122547,558),(122548,559),(122549,561),(122550,562),(122551,563),(122552,564),(122553,565),(122554,566),(122555,567),(122556,568),(122557,569),(122558,570),(122559,571),(122560,572),(122561,573),(122562,574),(122563,575),(122564,576),(122565,577),(122566,578),(122567,579),(122568,580),(122569,581),(122570,582),(122571,583),(122572,584),(122573,585),(122574,586),(122575,587),(122576,588),(122577,589),(122578,590),(122579,591),(122580,592),(122581,593),(122582,594),(122583,595),(122584,596),(122585,597),(122586,598),(122587,599),(122588,600),(122589,601),(122590,602),(122591,603),(122592,604),(122593,605),(122594,606),(122595,607),(122596,608),(122597,609),(122598,610),(122599,612),(122600,626),(122601,627),(122602,628),(122603,629),(122604,630),(122605,631),(122606,754),(122607,755),(122608,756),(122609,757),(122610,758),(122611,759),(122612,760),(122613,761),(122614,762),(122615,763),(122616,764),(122617,765),(122618,766),(122619,767),(122620,768),(122621,769),(122622,770),(122623,771),(122624,772),(122625,773),(122626,774),(122627,775),(122628,776),(122629,777),(122630,778),(122631,779),(122632,780),(122633,781),(122634,782),(122635,783),(122636,784),(122637,785),(122638,786),(122639,787),(122640,788),(122641,789),(122642,790),(122643,791),(122644,792),(122645,793),(122646,794),(122647,795),(122648,796),(122649,797),(122650,798),(122651,799),(122652,800),(122653,801),(122654,802),(122655,803),(122656,804),(122657,805),(122658,806),(122659,807),(122660,808),(122661,809),(122662,810),(122663,811),(122664,812),(122665,813),(122666,814),(122667,815),(122668,816),(122669,817),(122670,818),(122671,819),(122672,820),(122673,821),(122674,822),(122675,823),(122676,824),(122677,825),(122678,826),(122679,827),(122680,828),(122681,829),(122682,830),(122683,831),(122684,832),(122685,833),(122686,834),(122687,835),(122688,836),(122689,837),(122690,838),(122691,839),(122692,840),(122693,841),(122694,842),(122695,843),(122696,844),(122697,845),(122698,846),(122699,847),(122700,848),(122701,849),(122702,850),(122703,851),(122704,852),(122705,853),(122706,854),(122707,855),(122708,856),(122709,857),(122710,858),(122711,859),(122712,860),(122713,861),(122714,862),(122715,863),(122716,864),(122717,865),(122718,866),(122719,867),(122720,868),(122721,869),(122722,870),(122723,871),(122724,872),(122725,1020),(122726,1021),(122727,1022),(122728,1023),(122729,1106),(122730,1166),(122731,1167),(122732,1168),(122733,1169),(122734,1170),(122735,1171),(122736,1172),(122737,1173),(122738,1174),(122739,1175),(122740,1176),(122741,1177),(122742,1178),(122743,1179),(122744,1180),(122745,1181),(122746,1182),(122747,1183),(122748,1195),(122749,1196),(122750,1197),(122751,1198),(122752,1199),(122753,1200),(122754,1201),(122755,1202),(122756,1203),(122757,1204),(122758,1205),(122759,1206),(122760,1207),(122761,1210),(122762,1211),(122763,1212),(122764,1213),(122765,1214),(122766,1215),(122767,1216),(122768,1217),(122769,1218),(122770,1219),(122771,1220),(122772,1221),(122773,1222),(122774,1223),(122775,1224),(122776,1225),(122777,1226),(122778,1227),(122779,1228),(122780,1229),(122781,1230),(122782,1231),(122783,1232),(122784,1233),(122785,1234),(122786,1235),(122787,1236),(122788,1237),(122789,1238),(122790,1239),(122791,1240),(122792,1241),(122793,1242),(122794,1243),(122795,1244),(122796,1245),(122797,1246),(122798,1247),(122799,1248),(122800,1249),(122801,1250),(122802,1251),(122803,1252),(122804,1253),(122805,1254),(122806,1255),(122807,1256),(122808,1257),(122809,1258),(122810,1259),(122811,1260),(122812,1261),(122813,1262),(122814,1263),(122815,1264),(122816,1265),(122817,1266),(122818,1267),(122819,1268),(122820,1269),(122821,1270),(122822,1271),(122823,1272),(122824,1273),(122825,1274),(122826,1275),(122827,1276),(122828,1277),(122829,1278),(122830,1279),(122831,1280),(122832,1281),(122833,1282),(122834,1283),(122835,1284),(122836,1285),(122837,1286),(122838,1287),(122839,1288),(122840,1289),(122841,1290),(122842,1291),(122843,1292),(122844,1293),(122845,1294),(122846,1295),(122847,1296),(122848,1297),(122849,1298),(122850,1299),(122851,1300),(122852,1301),(122853,1302),(122854,1303),(122855,1304),(122856,1305),(122857,1306),(122858,1307),(122859,1308),(122860,1309),(122861,1310),(122862,1311),(122863,1312),(122864,1313),(122865,1314),(122866,1315),(122867,1316),(122868,1317),(122869,1318),(122870,1319),(122871,1320),(122872,1321),(122873,1322),(122874,1323),(122875,1332),(122876,1342),(122877,1346),(122878,1347),(122879,1349),(122880,1350),(122881,1351),(122882,1353),(122883,1354),(122884,1355),(122885,1356),(122886,1357),(122887,1358),(122888,1359),(122889,1360),(122890,1361),(122891,1362),(122892,1363),(122893,1364),(122894,1366),(122895,1367),(122896,1368),(122897,1371),(122898,1375),(122899,1376),(122900,1377),(122901,1379),(122902,1389),(122903,1390),(122904,1391),(122905,1392),(122906,1393),(122907,1394),(122908,1395),(122909,1397),(122910,1398),(122911,1400),(122912,1420),(122913,1421),(122914,1422),(122915,1423),(122916,1424),(122917,1425),(122918,1427),(122919,1428),(122920,1429),(122921,1430),(122922,1431),(122923,1432),(122924,1433),(122925,1434),(122926,1435),(122927,1442),(122928,1443),(122929,1444),(122930,1445),(122931,1446),(122932,1447),(122933,1448),(122934,1450),(122935,1451),(122936,1452),(122937,1454),(122938,1455),(122939,1456),(122940,1457),(122941,1462),(122942,1469),(122943,1749),(122944,4500),(122945,4501),(122946,4502),(122947,4503),(122948,4504),(122949,4505),(122950,4506),(122951,4507),(122952,4508),(122953,4509),(122954,4510),(122955,4511),(122956,4512),(122957,4513),(122958,4514),(122959,4515),(122960,4516),(122961,4517),(122962,4518),(122963,4519),(122964,4520),(122965,4522),(122966,4523),(122967,5301),(122968,5468),(122969,5489),(122970,348),(122971,349),(122972,350),(122973,351),(122974,352),(122975,353),(122976,354),(122977,355),(122978,356),(122979,357),(122980,358),(122981,359),(122982,360),(122983,361),(122984,362),(122985,363),(122986,364),(122987,365),(122988,366),(122989,367),(122990,368),(122991,369),(122992,370),(122993,371),(122994,372),(122995,373),(122996,374),(122997,375),(122998,376),(122999,377),(123000,378),(123001,379),(123002,380),(123003,381),(123004,382),(123005,383),(123006,384),(123007,385),(123008,386),(123009,387),(123010,388),(123011,389),(123012,390),(123013,391),(123014,392),(123015,393),(123016,394),(123017,395),(123018,396),(123019,397),(123020,398),(123021,399),(123022,400),(123023,401),(123024,402),(123025,403),(123026,404),(123027,405),(123028,406),(123029,407),(123030,408),(123031,409),(123032,410),(123033,411),(123034,412),(123035,413),(123036,414),(123037,415),(123038,416),(123039,417),(123040,418),(123041,419),(123042,420),(123043,421),(123044,422),(123045,423),(123046,424),(123047,425),(123048,426),(123049,427),(123050,428),(123051,429),(123052,430),(123053,431),(123054,432),(123055,433),(123056,434),(123057,435),(123058,436),(123059,437),(123060,438),(123061,439),(123062,440),(123063,441),(123064,442),(123065,443),(123066,444),(123067,445),(123068,446),(123069,447),(123070,448),(123071,449),(123072,450),(123073,451),(123074,452),(123075,453),(123076,454),(123077,455),(123078,456),(123079,457),(123080,458),(123081,459),(123082,460),(123083,461),(123084,462),(123085,463),(123086,464),(123087,465),(123088,466),(123089,467),(123090,468),(123091,469),(123092,470),(123093,471),(123094,472),(123095,473),(123096,474),(123097,475),(123098,476),(123099,477),(123100,478),(123101,479),(123102,480),(123103,481),(123104,482),(123105,483),(123106,484),(123107,485),(123108,486),(123109,487),(123110,488),(123111,489),(123112,490),(123113,491),(123114,492),(123115,493),(123116,494),(123117,495),(123118,496),(123119,497),(123120,498),(123121,499),(123122,500),(123123,501),(123124,502),(123125,503),(123126,504),(123127,505),(123128,506),(123129,507),(123130,508),(123131,509),(123132,510),(123133,511),(123134,512),(123135,513),(123136,514),(123137,515),(123138,516),(123139,517),(123140,518),(123141,519),(123142,520),(123143,521),(123144,522),(123145,523),(123146,524),(123147,525),(123148,526),(123149,527),(123150,528),(123151,529),(123152,530),(123153,531),(123154,532),(123155,533),(123156,534),(123157,535),(123158,536),(123159,537),(123160,538),(123161,539),(123162,540),(123163,541),(123164,542),(123165,543),(123166,544),(123167,545),(123168,546),(123169,547),(123170,548),(123171,549),(123172,550),(123173,551),(123174,552),(123175,553),(123176,554),(123177,555),(123178,556),(123179,557),(123180,558),(123181,559),(123182,560),(123183,561),(123184,562),(123185,563),(123186,564),(123187,565),(123188,566),(123189,567),(123190,568),(123191,569),(123192,570),(123193,571),(123194,572),(123195,573),(123196,574),(123197,575),(123198,576),(123199,577),(123200,578),(123201,579),(123202,580),(123203,581),(123204,582),(123205,583),(123206,584),(123207,585),(123208,586),(123209,587),(123210,588),(123211,589),(123212,590),(123213,591),(123214,592),(123215,593),(123216,594),(123217,595),(123218,596),(123219,597),(123220,598),(123221,599),(123222,600),(123223,601),(123224,602),(123225,603),(123226,604),(123227,605),(123228,606),(123229,607),(123230,608),(123231,609),(123232,610),(123233,611),(123234,612),(123235,613),(123236,614),(123237,615),(123238,616),(123239,617),(123240,618),(123241,619),(123242,620),(123243,621),(123244,622),(123245,623),(123246,624),(123247,625),(123248,626),(123249,627),(123250,628),(123251,629),(123252,630),(123253,631),(123254,632),(123255,633),(123256,634),(123257,635),(123258,636),(123259,637),(123260,638),(123261,639),(123262,640),(123263,641),(123264,642),(123265,643),(123266,644),(123267,645),(123268,646),(123269,647),(123270,648),(123271,649),(123272,650),(123273,651),(123274,652),(123275,653),(123276,654),(123277,655),(123278,656),(123279,657),(123280,658),(123281,659),(123282,660),(123283,661),(123284,662),(123285,663),(123286,664),(123287,665),(123288,666),(123289,667),(123290,668),(123291,669),(123292,670),(123293,671),(123294,672),(123295,673),(123296,674),(123297,675),(123298,676),(123299,677),(123300,678),(123301,679),(123302,680),(123303,754),(123304,755),(123305,756),(123306,757),(123307,758),(123308,759),(123309,760),(123310,761),(123311,762),(123312,763),(123313,764),(123314,765),(123315,766),(123316,767),(123317,768),(123318,769),(123319,770),(123320,771),(123321,772),(123322,773),(123323,774),(123324,775),(123325,776),(123326,777),(123327,778),(123328,779),(123329,780),(123330,781),(123331,782),(123332,783),(123333,784),(123334,785),(123335,786),(123336,787),(123337,788),(123338,789),(123339,790),(123340,791),(123341,792),(123342,793),(123343,794),(123344,795),(123345,796),(123346,797),(123347,798),(123348,799),(123349,800),(123350,801),(123351,802),(123352,803),(123353,804),(123354,805),(123355,806),(123356,807),(123357,808),(123358,809),(123359,810),(123360,811),(123361,812),(123362,813),(123363,814),(123364,815),(123365,816),(123366,817),(123367,818),(123368,819),(123369,820),(123370,821),(123371,822),(123372,823),(123373,824),(123374,825),(123375,826),(123376,827),(123377,828),(123378,829),(123379,830),(123380,831),(123381,832),(123382,833),(123383,834),(123384,835),(123385,836),(123386,837),(123387,838),(123388,839),(123389,840),(123390,841),(123391,842),(123392,843),(123393,844),(123394,845),(123395,846),(123396,847),(123397,848),(123398,849),(123399,850),(123400,851),(123401,852),(123402,853),(123403,854),(123404,855),(123405,856),(123406,857),(123407,858),(123408,859),(123409,860),(123410,861),(123411,862),(123412,863),(123413,864),(123414,865),(123415,866),(123416,867),(123417,868),(123418,869),(123419,870),(123420,871),(123421,872),(123422,1020),(123423,1021),(123424,1022),(123425,1023),(123426,1106),(123427,1166),(123428,1167),(123429,1168),(123430,1169),(123431,1170),(123432,1171),(123433,1172),(123434,1173),(123435,1174),(123436,1175),(123437,1176),(123438,1177),(123439,1178),(123440,1179),(123441,1180),(123442,1181),(123443,1182),(123444,1183),(123445,1184),(123446,1185),(123447,1186),(123448,1187),(123449,1188),(123450,1189),(123451,1190),(123452,1191),(123453,1192),(123454,1193),(123455,1194),(123456,1195),(123457,1196),(123458,1197),(123459,1198),(123460,1199),(123461,1200),(123462,1201),(123463,1202),(123464,1203),(123465,1204),(123466,1205),(123467,1206),(123468,1207),(123469,1208),(123470,1209),(123471,1210),(123472,1211),(123473,1212),(123474,1213),(123475,1214),(123476,1215),(123477,1216),(123478,1217),(123479,1218),(123480,1219),(123481,1220),(123482,1221),(123483,1222),(123484,1223),(123485,1224),(123486,1225),(123487,1226),(123488,1227),(123489,1228),(123490,1229),(123491,1230),(123492,1231),(123493,1232),(123494,1233),(123495,1234),(123496,1235),(123497,1236),(123498,1237),(123499,1238),(123500,1239),(123501,1240),(123502,1241),(123503,1242),(123504,1243),(123505,1244),(123506,1245),(123507,1246),(123508,1247),(123509,1248),(123510,1249),(123511,1250),(123512,1251),(123513,1252),(123514,1253),(123515,1254),(123516,1255),(123517,1256),(123518,1257),(123519,1258),(123520,1259),(123521,1260),(123522,1261),(123523,1262),(123524,1263),(123525,1264),(123526,1265),(123527,1266),(123528,1267),(123529,1268),(123530,1269),(123531,1270),(123532,1271),(123533,1272),(123534,1273),(123535,1274),(123536,1275),(123537,1276),(123538,1277),(123539,1278),(123540,1279),(123541,1280),(123542,1281),(123543,1282),(123544,1283),(123545,1284),(123546,1285),(123547,1286),(123548,1287),(123549,1288),(123550,1289),(123551,1290),(123552,1291),(123553,1292),(123554,1293),(123555,1294),(123556,1295),(123557,1296),(123558,1297),(123559,1298),(123560,1299),(123561,1300),(123562,1301),(123563,1302),(123564,1303),(123565,1304),(123566,1305),(123567,1306),(123568,1307),(123569,1308),(123570,1309),(123571,1310),(123572,1311),(123573,1312),(123574,1313),(123575,1314),(123576,1315),(123577,1316),(123578,1317),(123579,1318),(123580,1319),(123581,1320),(123582,1321),(123583,1322),(123584,1323),(123585,1324),(123586,1325),(123587,1326),(123588,1327),(123589,1328),(123590,1329),(123591,1330),(123592,1331),(123593,1332),(123594,1333),(123595,1334),(123596,1335),(123597,1336),(123598,1337),(123599,1338),(123600,1339),(123601,1340),(123602,1341),(123603,1342),(123604,1343),(123605,1344),(123606,1345),(123607,1346),(123608,1347),(123609,1348),(123610,1349),(123611,1350),(123612,1351),(123613,1352),(123614,1353),(123615,1354),(123616,1355),(123617,1356),(123618,1357),(123619,1358),(123620,1359),(123621,1360),(123622,1361),(123623,1362),(123624,1363),(123625,1364),(123626,1365),(123627,1366),(123628,1367),(123629,1368),(123630,1369),(123631,1370),(123632,1371),(123633,1372),(123634,1373),(123635,1374),(123636,1375),(123637,1376),(123638,1377),(123639,1378),(123640,1379),(123641,1380),(123642,1381),(123643,1382),(123644,1383),(123645,1384),(123646,1385),(123647,1386),(123648,1387),(123649,1388),(123650,1389),(123651,1390),(123652,1391),(123653,1392),(123654,1393),(123655,1394),(123656,1395),(123657,1396),(123658,1397),(123659,1398),(123660,1399),(123661,1400),(123662,1401),(123663,1402),(123664,1403),(123665,1404),(123666,1405),(123667,1406),(123668,1407),(123669,1408),(123670,1409),(123671,1410),(123672,1411),(123673,1412),(123674,1413),(123675,1414),(123676,1415),(123677,1416),(123678,1417),(123679,1418),(123680,1419),(123681,1420),(123682,1421),(123683,1422),(123684,1423),(123685,1424),(123686,1425),(123687,1426),(123688,1427),(123689,1428),(123690,1429),(123691,1430),(123692,1431),(123693,1432),(123694,1433),(123695,1434),(123696,1435),(123697,1436),(123698,1437),(123699,1438),(123700,1439),(123701,1440),(123702,1441),(123703,1442),(123704,1443),(123705,1444),(123706,1445),(123707,1446),(123708,1447),(123709,1448),(123710,1449),(123711,1450),(123712,1451),(123713,1452),(123714,1453),(123715,1454),(123716,1455),(123717,1456),(123718,1457),(123719,1458),(123720,1459),(123721,1460),(123722,1461),(123723,1462),(123724,1463),(123725,1464),(123726,1465),(123727,1466),(123728,1467),(123729,1468),(123730,1469),(123731,1470),(123732,1471),(123733,1472),(123734,1488),(123735,1489),(123736,1490),(123737,1491),(123738,1492),(123739,1493),(123740,1494),(123741,1749),(123742,1992),(123743,1993),(123744,1994),(123745,1995),(123746,1996),(123747,1997),(123748,1998),(123749,1999),(123750,2000),(123751,2001),(123752,2002),(123753,4500),(123754,4501),(123755,4502),(123756,4503),(123757,4504),(123758,4505),(123759,4506),(123760,4507),(123761,4508),(123762,4509),(123763,4510),(123764,4511),(123765,4512),(123766,4513),(123767,4514),(123768,4515),(123769,4516),(123770,4517),(123771,4518),(123772,4519),(123773,4520),(123774,4521),(123775,4522),(123776,4523),(123777,4524),(123778,4525),(123779,4526),(123780,4527),(123781,4528),(123782,4529),(123783,4530),(123784,4531),(123785,4532),(123786,4533),(123787,4534),(123788,4535),(123789,4536),(123790,5271),(123791,5272),(123792,5273),(123793,5274),(123794,5282),(123795,5283),(123796,5284),(123797,5301),(123798,5468),(123799,5489),(123800,348),(123801,349),(123802,350),(123803,351),(123804,352),(123805,353),(123806,354),(123807,355),(123808,356),(123809,357),(123810,358),(123811,359),(123812,360),(123813,361),(123814,370),(123815,371),(123816,372),(123817,373),(123818,374),(123819,375),(123820,376),(123821,377),(123822,378),(123823,379),(123824,380),(123825,381),(123826,382),(123827,383),(123828,384),(123829,385),(123830,386),(123831,387),(123832,388),(123833,389),(123834,390),(123835,391),(123836,392),(123837,393),(123838,394),(123839,395),(123840,396),(123841,397),(123842,533),(123843,534),(123844,535),(123845,536),(123846,537),(123847,538),(123848,539),(123849,540),(123850,541),(123851,542),(123852,543),(123853,544),(123854,545),(123855,546),(123856,547),(123857,548),(123858,549),(123859,550),(123860,551),(123861,552),(123862,553),(123863,554),(123864,555),(123865,556),(123866,558),(123867,559),(123868,561),(123869,562),(123870,563),(123871,564),(123872,565),(123873,566),(123874,567),(123875,568),(123876,569),(123877,570),(123878,571),(123879,572),(123880,573),(123881,574),(123882,575),(123883,576),(123884,577),(123885,578),(123886,579),(123887,580),(123888,581),(123889,582),(123890,583),(123891,584),(123892,585),(123893,586),(123894,587),(123895,588),(123896,589),(123897,590),(123898,591),(123899,592),(123900,593),(123901,594),(123902,595),(123903,596),(123904,597),(123905,598),(123906,599),(123907,600),(123908,601),(123909,602),(123910,603),(123911,604),(123912,605),(123913,606),(123914,607),(123915,608),(123916,609),(123917,610),(123918,612),(123919,626),(123920,627),(123921,628),(123922,629),(123923,630),(123924,631),(123925,754),(123926,755),(123927,756),(123928,757),(123929,758),(123930,759),(123931,760),(123932,761),(123933,762),(123934,763),(123935,764),(123936,765),(123937,766),(123938,767),(123939,768),(123940,769),(123941,770),(123942,771),(123943,772),(123944,773),(123945,774),(123946,775),(123947,776),(123948,777),(123949,778),(123950,779),(123951,780),(123952,781),(123953,782),(123954,783),(123955,784),(123956,785),(123957,786),(123958,787),(123959,788),(123960,789),(123961,790),(123962,791),(123963,792),(123964,793),(123965,794),(123966,795),(123967,796),(123968,797),(123969,798),(123970,799),(123971,800),(123972,801),(123973,802),(123974,803),(123975,804),(123976,805),(123977,806),(123978,807),(123979,808),(123980,809),(123981,810),(123982,811),(123983,812),(123984,813),(123985,814),(123986,815),(123987,816),(123988,817),(123989,818),(123990,819),(123991,820),(123992,821),(123993,822),(123994,823),(123995,824),(123996,825),(123997,826),(123998,827),(123999,828),(124000,829),(124001,830),(124002,831),(124003,832),(124004,833),(124005,834),(124006,835),(124007,836),(124008,837),(124009,838),(124010,839),(124011,840),(124012,841),(124013,842),(124014,843),(124015,844),(124016,845),(124017,846),(124018,847),(124019,848),(124020,849),(124021,850),(124022,851),(124023,852),(124024,853),(124025,854),(124026,855),(124027,856),(124028,857),(124029,858),(124030,859),(124031,860),(124032,861),(124033,862),(124034,863),(124035,864),(124036,865),(124037,866),(124038,867),(124039,868),(124040,869),(124041,870),(124042,871),(124043,872),(124044,1020),(124045,1021),(124046,1022),(124047,1023),(124048,1106),(124049,1166),(124050,1167),(124051,1168),(124052,1169),(124053,1170),(124054,1171),(124055,1172),(124056,1173),(124057,1174),(124058,1175),(124059,1176),(124060,1177),(124061,1178),(124062,1179),(124063,1180),(124064,1181),(124065,1182),(124066,1183),(124067,1195),(124068,1196),(124069,1197),(124070,1198),(124071,1199),(124072,1200),(124073,1201),(124074,1202),(124075,1203),(124076,1204),(124077,1205),(124078,1206),(124079,1207),(124080,1210),(124081,1211),(124082,1212),(124083,1213),(124084,1214),(124085,1215),(124086,1216),(124087,1217),(124088,1218),(124089,1219),(124090,1220),(124091,1221),(124092,1222),(124093,1223),(124094,1224),(124095,1225),(124096,1226),(124097,1227),(124098,1228),(124099,1229),(124100,1230),(124101,1231),(124102,1232),(124103,1233),(124104,1234),(124105,1235),(124106,1236),(124107,1237),(124108,1238),(124109,1239),(124110,1240),(124111,1241),(124112,1242),(124113,1243),(124114,1244),(124115,1245),(124116,1246),(124117,1247),(124118,1248),(124119,1249),(124120,1250),(124121,1251),(124122,1252),(124123,1253),(124124,1254),(124125,1255),(124126,1256),(124127,1257),(124128,1258),(124129,1259),(124130,1260),(124131,1261),(124132,1262),(124133,1263),(124134,1264),(124135,1265),(124136,1266),(124137,1267),(124138,1268),(124139,1269),(124140,1270),(124141,1271),(124142,1272),(124143,1273),(124144,1274),(124145,1275),(124146,1276),(124147,1277),(124148,1278),(124149,1279),(124150,1280),(124151,1281),(124152,1282),(124153,1283),(124154,1284),(124155,1285),(124156,1286),(124157,1287),(124158,1288),(124159,1289),(124160,1290),(124161,1291),(124162,1292),(124163,1293),(124164,1294),(124165,1295),(124166,1296),(124167,1297),(124168,1298),(124169,1299),(124170,1300),(124171,1301),(124172,1302),(124173,1303),(124174,1304),(124175,1305),(124176,1306),(124177,1307),(124178,1308),(124179,1309),(124180,1310),(124181,1311),(124182,1312),(124183,1313),(124184,1314),(124185,1315),(124186,1316),(124187,1317),(124188,1318),(124189,1319),(124190,1320),(124191,1321),(124192,1322),(124193,1323),(124194,1332),(124195,1342),(124196,1346),(124197,1347),(124198,1349),(124199,1350),(124200,1351),(124201,1353),(124202,1354),(124203,1355),(124204,1356),(124205,1357),(124206,1358),(124207,1359),(124208,1360),(124209,1361),(124210,1362),(124211,1363),(124212,1364),(124213,1366),(124214,1367),(124215,1368),(124216,1371),(124217,1375),(124218,1376),(124219,1377),(124220,1379),(124221,1389),(124222,1390),(124223,1391),(124224,1392),(124225,1393),(124226,1394),(124227,1395),(124228,1397),(124229,1398),(124230,1400),(124231,1420),(124232,1421),(124233,1422),(124234,1423),(124235,1424),(124236,1425),(124237,1427),(124238,1428),(124239,1429),(124240,1430),(124241,1431),(124242,1432),(124243,1433),(124244,1434),(124245,1435),(124246,1442),(124247,1443),(124248,1444),(124249,1445),(124250,1446),(124251,1447),(124252,1448),(124253,1450),(124254,1451),(124255,1452),(124256,1454),(124257,1455),(124258,1456),(124259,1457),(124260,1462),(124261,1469),(124262,1749),(124263,4500),(124264,4501),(124265,4502),(124266,4503),(124267,4504),(124268,4505),(124269,4506),(124270,4507),(124271,4508),(124272,4509),(124273,4510),(124274,4511),(124275,4512),(124276,4513),(124277,4514),(124278,4515),(124279,4516),(124280,4517),(124281,4518),(124282,4519),(124283,4520),(124284,4522),(124285,4523),(124286,5301),(124287,5468),(124288,5489),(124289,283),(124290,285),(124291,288),(124292,290),(124293,293),(124294,295),(124295,315),(124296,321),(124297,672),(124298,681),(124299,709),(124300,710),(124301,726),(124302,727),(124303,729),(124304,908),(124305,1002),(124306,1119),(124307,636),(124308,281),(124309,282),(124310,284),(124311,286),(124312,287),(124313,289),(124314,291),(124315,292),(124316,296),(124317,297),(124318,298),(124319,299),(124320,300),(124321,302),(124322,303),(124323,304),(124324,305),(124325,306),(124326,307),(124327,309),(124328,310),(124329,313),(124330,316),(124331,317),(124332,318),(124333,341),(124334,342),(124335,343),(124336,374),(124337,375),(124338,376),(124339,527),(124340,529),(124341,530),(124342,531),(124343,532),(124344,557),(124345,560),(124346,587),(124347,588),(124348,589),(124349,590),(124350,591),(124351,592),(124352,611),(124353,613),(124354,617),(124355,619),(124356,624),(124357,625),(124358,637),(124359,639),(124360,648),(124361,652),(124362,660),(124363,670),(124364,682),(124365,683),(124366,684),(124367,685),(124368,686),(124369,688),(124370,689),(124371,690),(124372,691),(124373,693),(124374,694),(124375,695),(124376,696),(124377,697),(124378,698),(124379,700),(124380,701),(124381,705),(124382,708),(124383,712),(124384,715),(124385,716),(124386,717),(124387,728),(124388,730),(124389,731),(124390,735),(124391,736),(124392,778),(124393,779),(124394,834),(124395,835),(124396,836),(124397,837),(124398,838),(124399,839),(124400,840),(124401,906),(124402,996),(124403,997),(124404,998),(124405,999),(124406,1000),(124407,1034),(124408,1036),(124409,1038),(124410,1062),(124411,1063),(124412,1064),(124413,1066),(124414,1067),(124415,1068),(124416,1069),(124417,1070),(124418,1071),(124419,1072),(124420,1073),(124421,1074),(124422,1075),(124423,1133),(124424,2524),(124425,2526),(124426,281),(124427,284),(124428,286),(124429,287),(124430,289),(124431,291),(124432,292),(124433,294),(124434,296),(124435,297),(124436,298),(124437,299),(124438,300),(124439,301),(124440,302),(124441,303),(124442,304),(124443,305),(124444,306),(124445,307),(124446,316),(124447,332),(124448,333),(124449,337),(124450,341),(124451,342),(124452,343),(124453,374),(124454,375),(124455,376),(124456,527),(124457,528),(124458,529),(124459,530),(124460,531),(124461,532),(124462,557),(124463,560),(124464,587),(124465,588),(124466,589),(124467,590),(124468,591),(124469,592),(124470,611),(124471,613),(124472,617),(124473,618),(124474,619),(124475,624),(124476,625),(124477,632),(124478,636),(124479,637),(124480,639),(124481,646),(124482,648),(124483,652),(124484,659),(124485,660),(124486,670),(124487,682),(124488,683),(124489,684),(124490,685),(124491,686),(124492,687),(124493,688),(124494,689),(124495,690),(124496,691),(124497,693),(124498,694),(124499,695),(124500,696),(124501,697),(124502,698),(124503,700),(124504,702),(124505,705),(124506,706),(124507,711),(124508,712),(124509,715),(124510,716),(124511,717),(124512,728),(124513,735),(124514,736),(124515,742),(124516,778),(124517,779),(124518,834),(124519,835),(124520,836),(124521,837),(124522,838),(124523,839),(124524,840),(124525,906),(124526,997),(124527,998),(124528,999),(124529,1000),(124530,1001),(124531,1036),(124532,1037),(124533,1038),(124534,1064),(124535,1066),(124536,1067),(124537,1068),(124538,1069),(124539,1070),(124540,1071),(124541,1072),(124542,1073),(124543,1074),(124544,1075),(124545,1133),(124546,2524),(124547,2526),(124548,282),(124549,283),(124550,285),(124551,288),(124552,290),(124553,293),(124554,295),(124555,308),(124556,309),(124557,310),(124558,311),(124559,312),(124560,313),(124561,314),(124562,315),(124563,317),(124564,318),(124565,319),(124566,320),(124567,321),(124568,322),(124569,323),(124570,334),(124571,335),(124572,336),(124573,338),(124574,339),(124575,345),(124576,672),(124577,681),(124578,692),(124579,699),(124580,701),(124581,703),(124582,704),(124583,707),(124584,708),(124585,709),(124586,710),(124587,713),(124588,718),(124589,719),(124590,720),(124591,721),(124592,722),(124593,723),(124594,724),(124595,725),(124596,726),(124597,727),(124598,729),(124599,730),(124600,731),(124601,737),(124602,738),(124603,739),(124604,740),(124605,741),(124606,743),(124607,744),(124608,745),(124609,746),(124610,748),(124611,749),(124612,903),(124613,907),(124614,908),(124615,996),(124616,1002),(124617,1003),(124618,1004),(124619,1005),(124620,1012),(124621,1019),(124622,1034),(124623,1035),(124624,1062),(124625,1063),(124626,1092),(124627,1119),(124628,528),(124629,636),(124630,646),(124631,1001),(124632,340),(124633,344),(124634,346),(124635,347),(124636,714),(124637,732),(124638,733),(124639,734),(124640,747),(124641,904),(124642,905),(124643,281),(124644,282),(124645,284),(124646,286),(124647,287),(124648,289),(124649,291),(124650,292),(124651,294),(124652,296),(124653,297),(124654,298),(124655,299),(124656,300),(124657,301),(124658,302),(124659,303),(124660,304),(124661,305),(124662,306),(124663,307),(124664,308),(124665,309),(124666,310),(124667,311),(124668,312),(124669,313),(124670,316),(124671,317),(124672,318),(124673,332),(124674,333),(124675,334),(124676,335),(124677,336),(124678,337),(124679,338),(124680,339),(124681,341),(124682,342),(124683,343),(124684,374),(124685,375),(124686,376),(124687,527),(124688,529),(124689,530),(124690,531),(124691,532),(124692,557),(124693,560),(124694,587),(124695,588),(124696,589),(124697,590),(124698,591),(124699,592),(124700,611),(124701,613),(124702,617),(124703,619),(124704,624),(124705,625),(124706,637),(124707,639),(124708,648),(124709,652),(124710,659),(124711,660),(124712,670),(124713,682),(124714,683),(124715,684),(124716,685),(124717,686),(124718,687),(124719,688),(124720,689),(124721,690),(124722,691),(124723,693),(124724,694),(124725,695),(124726,696),(124727,697),(124728,698),(124729,700),(124730,701),(124731,702),(124732,703),(124733,705),(124734,706),(124735,707),(124736,708),(124737,711),(124738,712),(124739,713),(124740,715),(124741,716),(124742,717),(124743,728),(124744,730),(124745,731),(124746,735),(124747,736),(124748,742),(124749,778),(124750,779),(124751,834),(124752,835),(124753,836),(124754,837),(124755,838),(124756,839),(124757,840),(124758,903),(124759,996),(124760,997),(124761,998),(124762,999),(124763,1000),(124764,1001),(124765,1034),(124766,1035),(124767,1036),(124768,1038),(124769,1062),(124770,1063),(124771,1064),(124772,1066),(124773,1067),(124774,1068),(124775,1069),(124776,1070),(124777,1071),(124778,1072),(124779,1073),(124780,1074),(124781,1075),(124782,1133),(124783,659),(124784,683),(124785,684),(124786,685),(124787,686),(124788,689),(124789,709),(124790,710),(124791,712),(124792,715),(124793,716),(124794,717),(124795,726),(124796,727),(124797,728),(124798,729),(124799,730),(124800,731),(124801,735),(124802,736),(124803,659),(124804,683),(124805,684),(124806,685),(124807,686),(124808,689),(124809,709),(124810,710),(124811,712),(124812,715),(124813,716),(124814,717),(124815,726),(124816,727),(124817,728),(124818,729),(124819,730),(124820,731),(124821,735),(124822,736),(124823,659),(124824,683),(124825,684),(124826,685),(124827,686),(124828,689),(124829,712),(124830,715),(124831,716),(124832,717),(124833,728),(124834,730),(124835,731),(124836,735),(124837,736),(124838,292),(124839,293),(124840,302),(124841,303),(124842,314),(124843,315),(124844,320),(124845,321),(124846,326),(124847,327),(124848,335),(124849,338),(124850,346),(124851,347),(124852,699),(124853,722),(124854,729),(124855,730),(124856,903),(124857,1035),(124858,1073),(124859,1074),(124860,1075),(124861,297),(124862,438),(124863,476),(124864,477),(124865,478),(124866,479),(124867,484),(124868,493),(124869,494),(124870,515),(124871,523),(124872,524),(124873,528),(124874,620),(124875,640),(124876,641),(124877,642),(124878,646),(124879,649),(124880,654),(124881,657),(124882,658),(124883,659),(124884,660),(124885,1184),(124886,1238),(124887,1268),(124888,1294),(124889,1378),(124890,1389),(124891,1462),(124892,2154),(124893,2177),(124894,2221),(124895,2222),(124896,2299),(124897,5361),(124898,5362),(124899,5364),(124900,5622),(124901,5626),(124902,5639),(124903,5640),(124904,5641),(124905,5648),(124906,5665),(124907,5666),(124908,5667),(124909,2265),(124910,2269),(124911,281),(124912,282),(124913,283),(124914,284),(124915,285),(124916,286),(124917,287),(124918,288),(124919,289),(124920,290),(124921,291),(124922,292),(124923,293),(124924,294),(124925,295),(124926,296),(124927,297),(124928,298),(124929,299),(124930,300),(124931,301),(124932,302),(124933,303),(124934,304),(124935,305),(124936,306),(124937,307),(124938,308),(124939,309),(124940,310),(124941,311),(124942,312),(124943,313),(124944,314),(124945,315),(124946,316),(124947,317),(124948,318),(124949,319),(124950,320),(124951,321),(124952,322),(124953,323),(124954,324),(124955,325),(124956,326),(124957,327),(124958,328),(124959,329),(124960,330),(124961,331),(124962,332),(124963,333),(124964,334),(124965,335),(124966,336),(124967,337),(124968,338),(124969,339),(124970,340),(124971,341),(124972,342),(124973,343),(124974,344),(124975,345),(124976,346),(124977,347),(124978,903),(124979,904),(124980,905),(124981,907),(124982,1965),(124983,2439),(124984,2494),(124985,2495),(124986,2496),(124987,2497),(124988,2498),(124989,2499),(124990,2500),(124991,2513),(124992,2514),(124993,2529),(124994,2530),(124995,2539),(124996,2553),(124997,2554),(124998,2582),(124999,2583),(125000,2584),(125001,2585),(125002,2586),(125003,2587),(125004,4859),(125005,4860),(125006,4861),(125007,4862),(125008,4863),(125009,4864),(125010,4865),(125011,4866),(125012,4867),(125013,4868),(125014,4869),(125015,4870),(125016,4871),(125017,4874),(125018,4875),(125019,4876),(125020,4891),(125021,4892),(125022,4893),(125023,4894),(125024,281),(125025,282),(125026,283),(125027,284),(125028,285),(125029,286),(125030,287),(125031,288),(125032,289),(125033,290),(125034,291),(125035,292),(125036,293),(125037,294),(125038,295),(125039,296),(125040,297),(125041,298),(125042,299),(125043,300),(125044,301),(125045,302),(125046,303),(125047,304),(125048,305),(125049,306),(125050,307),(125051,308),(125052,309),(125053,310),(125054,311),(125055,312),(125056,313),(125057,314),(125058,315),(125059,316),(125060,317),(125061,318),(125062,319),(125063,320),(125064,321),(125065,322),(125066,323),(125067,324),(125068,325),(125069,326),(125070,327),(125071,328),(125072,329),(125073,330),(125074,331),(125075,332),(125076,333),(125077,334),(125078,335),(125079,336),(125080,337),(125081,338),(125082,339),(125083,340),(125084,341),(125085,342),(125086,343),(125087,344),(125088,345),(125089,346),(125090,347),(125091,903),(125092,904),(125093,905),(125094,907),(125095,1965),(125096,4613),(125097,4614),(125098,4857),(125099,4858),(125100,4872),(125101,4873),(125102,906),(125103,908),(125104,1004),(125105,1012),(125106,1019),(125107,1037),(125108,1092),(125109,1119),(125110,2524),(125111,2526),(125112,681),(125113,682),(125114,683),(125115,684),(125116,685),(125117,686),(125118,687),(125119,688),(125120,689),(125121,690),(125122,691),(125123,692),(125124,693),(125125,694),(125126,695),(125127,696),(125128,697),(125129,698),(125130,699),(125131,700),(125132,701),(125133,702),(125134,703),(125135,704),(125136,705),(125137,706),(125138,707),(125139,708),(125140,709),(125141,710),(125142,711),(125143,712),(125144,713),(125145,714),(125146,715),(125147,716),(125148,717),(125149,718),(125150,719),(125151,720),(125152,721),(125153,722),(125154,723),(125155,724),(125156,725),(125157,726),(125158,727),(125159,728),(125160,729),(125161,730),(125162,731),(125163,732),(125164,733),(125165,734),(125166,735),(125167,736),(125168,737),(125169,738),(125170,739),(125171,740),(125172,741),(125173,742),(125174,743),(125175,744),(125176,745),(125177,746),(125178,747),(125179,748),(125180,749),(125181,996),(125182,997),(125183,998),(125184,999),(125185,1000),(125186,1001),(125187,1002),(125188,1003),(125189,1005),(125190,1034),(125191,1035),(125192,1036),(125193,1038),(125194,1133),(125195,2221),(125196,2222),(125197,362),(125198,363),(125199,364),(125200,365),(125201,366),(125202,367),(125203,368),(125204,369),(125205,398),(125206,399),(125207,400),(125208,401),(125209,402),(125210,403),(125211,404),(125212,405),(125213,406),(125214,407),(125215,408),(125216,409),(125217,410),(125218,411),(125219,412),(125220,413),(125221,414),(125222,415),(125223,416),(125224,417),(125225,418),(125226,419),(125227,420),(125228,421),(125229,422),(125230,423),(125231,424),(125232,425),(125233,426),(125234,427),(125235,428),(125236,429),(125237,430),(125238,431),(125239,432),(125240,433),(125241,434),(125242,435),(125243,436),(125244,437),(125245,438),(125246,439),(125247,440),(125248,441),(125249,442),(125250,443),(125251,444),(125252,445),(125253,446),(125254,447),(125255,448),(125256,449),(125257,450),(125258,451),(125259,452),(125260,453),(125261,454),(125262,455),(125263,456),(125264,457),(125265,458),(125266,459),(125267,460),(125268,461),(125269,462),(125270,463),(125271,464),(125272,465),(125273,466),(125274,467),(125275,468),(125276,469),(125277,470),(125278,471),(125279,472),(125280,473),(125281,474),(125282,475),(125283,476),(125284,477),(125285,478),(125286,479),(125287,480),(125288,481),(125289,482),(125290,483),(125291,484),(125292,485),(125293,486),(125294,487),(125295,488),(125296,489),(125297,490),(125298,491),(125299,492),(125300,493),(125301,494),(125302,495),(125303,496),(125304,497),(125305,498),(125306,499),(125307,500),(125308,501),(125309,502),(125310,503),(125311,504),(125312,505),(125313,506),(125314,507),(125315,508),(125316,509),(125317,510),(125318,511),(125319,512),(125320,513),(125321,514),(125322,515),(125323,516),(125324,517),(125325,518),(125326,519),(125327,520),(125328,521),(125329,522),(125330,523),(125331,524),(125332,525),(125333,526),(125334,527),(125335,528),(125336,529),(125337,530),(125338,531),(125339,532),(125340,557),(125341,560),(125342,611),(125343,613),(125344,614),(125345,615),(125346,616),(125347,617),(125348,619),(125349,620),(125350,621),(125351,622),(125352,623),(125353,624),(125354,625),(125355,633),(125356,634),(125357,635),(125358,636),(125359,637),(125360,638),(125361,639),(125362,640),(125363,641),(125364,642),(125365,643),(125366,644),(125367,645),(125368,646),(125369,647),(125370,648),(125371,649),(125372,650),(125373,651),(125374,652),(125375,653),(125376,654),(125377,655),(125378,656),(125379,657),(125380,658),(125381,659),(125382,660),(125383,661),(125384,662),(125385,663),(125386,664),(125387,665),(125388,666),(125389,667),(125390,668),(125391,669),(125392,670),(125393,671),(125394,672),(125395,673),(125396,674),(125397,675),(125398,676),(125399,677),(125400,678),(125401,679),(125402,680),(125403,1184),(125404,1185),(125405,1186),(125406,1187),(125407,1188),(125408,1189),(125409,1190),(125410,1191),(125411,1192),(125412,1193),(125413,1194),(125414,1208),(125415,1209),(125416,1324),(125417,1325),(125418,1326),(125419,1327),(125420,1328),(125421,1329),(125422,1330),(125423,1331),(125424,1333),(125425,1334),(125426,1335),(125427,1336),(125428,1337),(125429,1338),(125430,1339),(125431,1340),(125432,1341),(125433,1343),(125434,1344),(125435,1345),(125436,1348),(125437,1352),(125438,1365),(125439,1369),(125440,1370),(125441,1372),(125442,1373),(125443,1374),(125444,1378),(125445,1380),(125446,1381),(125447,1382),(125448,1383),(125449,1384),(125450,1385),(125451,1386),(125452,1387),(125453,1388),(125454,1396),(125455,1399),(125456,1401),(125457,1402),(125458,1403),(125459,1404),(125460,1405),(125461,1406),(125462,1407),(125463,1408),(125464,1409),(125465,1410),(125466,1411),(125467,1412),(125468,1413),(125469,1414),(125470,1415),(125471,1416),(125472,1417),(125473,1418),(125474,1419),(125475,1426),(125476,1436),(125477,1437),(125478,1438),(125479,1439),(125480,1440),(125481,1441),(125482,1449),(125483,1453),(125484,1458),(125485,1459),(125486,1460),(125487,1461),(125488,1463),(125489,1464),(125490,1465),(125491,1466),(125492,1467),(125493,1468),(125494,1470),(125495,1471),(125496,1472),(125497,1488),(125498,1489),(125499,1490),(125500,1491),(125501,1492),(125502,1493),(125503,1494),(125504,1992),(125505,1993),(125506,1994),(125507,1995),(125508,1996),(125509,1997),(125510,1998),(125511,1999),(125512,2000),(125513,2001),(125514,2002),(125515,4521),(125516,4524),(125517,4525),(125518,4526),(125519,4527),(125520,4528),(125521,4529),(125522,4530),(125523,4531),(125524,4532),(125525,4533),(125526,4534),(125527,4535),(125528,4536),(125529,5271),(125530,5272),(125531,5273),(125532,5274),(125533,5282),(125534,5283),(125535,5284),(125536,348),(125537,349),(125538,350),(125539,351),(125540,352),(125541,353),(125542,354),(125543,355),(125544,356),(125545,357),(125546,358),(125547,359),(125548,360),(125549,361),(125550,370),(125551,371),(125552,372),(125553,373),(125554,374),(125555,375),(125556,376),(125557,377),(125558,378),(125559,379),(125560,380),(125561,381),(125562,382),(125563,383),(125564,384),(125565,385),(125566,386),(125567,387),(125568,388),(125569,389),(125570,390),(125571,391),(125572,392),(125573,393),(125574,394),(125575,395),(125576,396),(125577,397),(125578,533),(125579,534),(125580,535),(125581,536),(125582,537),(125583,538),(125584,539),(125585,540),(125586,541),(125587,542),(125588,543),(125589,544),(125590,545),(125591,546),(125592,547),(125593,548),(125594,549),(125595,550),(125596,551),(125597,552),(125598,553),(125599,554),(125600,555),(125601,556),(125602,558),(125603,559),(125604,561),(125605,562),(125606,563),(125607,564),(125608,565),(125609,566),(125610,567),(125611,568),(125612,569),(125613,570),(125614,571),(125615,572),(125616,573),(125617,574),(125618,575),(125619,576),(125620,577),(125621,578),(125622,579),(125623,580),(125624,581),(125625,582),(125626,583),(125627,584),(125628,585),(125629,586),(125630,587),(125631,588),(125632,589),(125633,590),(125634,591),(125635,592),(125636,593),(125637,594),(125638,595),(125639,596),(125640,597),(125641,598),(125642,599),(125643,600),(125644,601),(125645,602),(125646,603),(125647,604),(125648,605),(125649,606),(125650,607),(125651,608),(125652,609),(125653,610),(125654,612),(125655,626),(125656,627),(125657,628),(125658,629),(125659,630),(125660,631),(125661,754),(125662,755),(125663,756),(125664,757),(125665,758),(125666,759),(125667,760),(125668,761),(125669,762),(125670,763),(125671,764),(125672,765),(125673,766),(125674,767),(125675,768),(125676,769),(125677,770),(125678,771),(125679,772),(125680,773),(125681,774),(125682,775),(125683,776),(125684,777),(125685,778),(125686,779),(125687,780),(125688,781),(125689,782),(125690,783),(125691,784),(125692,785),(125693,786),(125694,787),(125695,788),(125696,789),(125697,790),(125698,791),(125699,792),(125700,793),(125701,794),(125702,795),(125703,796),(125704,797),(125705,798),(125706,799),(125707,800),(125708,801),(125709,802),(125710,803),(125711,804),(125712,805),(125713,806),(125714,807),(125715,808),(125716,809),(125717,810),(125718,811),(125719,812),(125720,813),(125721,814),(125722,815),(125723,816),(125724,817),(125725,818),(125726,819),(125727,820),(125728,821),(125729,822),(125730,823),(125731,824),(125732,825),(125733,826),(125734,827),(125735,828),(125736,829),(125737,830),(125738,831),(125739,832),(125740,833),(125741,834),(125742,835),(125743,836),(125744,837),(125745,838),(125746,839),(125747,840),(125748,841),(125749,842),(125750,843),(125751,844),(125752,845),(125753,846),(125754,847),(125755,848),(125756,849),(125757,850),(125758,851),(125759,852),(125760,853),(125761,854),(125762,855),(125763,856),(125764,857),(125765,858),(125766,859),(125767,860),(125768,861),(125769,862),(125770,863),(125771,864),(125772,865),(125773,866),(125774,867),(125775,868),(125776,869),(125777,870),(125778,871),(125779,872),(125780,1020),(125781,1021),(125782,1022),(125783,1023),(125784,1106),(125785,1166),(125786,1167),(125787,1168),(125788,1169),(125789,1170),(125790,1171),(125791,1172),(125792,1173),(125793,1174),(125794,1175),(125795,1176),(125796,1177),(125797,1178),(125798,1179),(125799,1180),(125800,1181),(125801,1182),(125802,1183),(125803,1195),(125804,1196),(125805,1197),(125806,1198),(125807,1199),(125808,1200),(125809,1201),(125810,1202),(125811,1203),(125812,1204),(125813,1205),(125814,1206),(125815,1207),(125816,1210),(125817,1211),(125818,1212),(125819,1213),(125820,1214),(125821,1215),(125822,1216),(125823,1217),(125824,1218),(125825,1219),(125826,1220),(125827,1221),(125828,1222),(125829,1223),(125830,1224),(125831,1225),(125832,1226),(125833,1227),(125834,1228),(125835,1229),(125836,1230),(125837,1231),(125838,1232),(125839,1233),(125840,1234),(125841,1235),(125842,1236),(125843,1237),(125844,1238),(125845,1239),(125846,1240),(125847,1241),(125848,1242),(125849,1243),(125850,1244),(125851,1245),(125852,1246),(125853,1247),(125854,1248),(125855,1249),(125856,1250),(125857,1251),(125858,1252),(125859,1253),(125860,1254),(125861,1255),(125862,1256),(125863,1257),(125864,1258),(125865,1259),(125866,1260),(125867,1261),(125868,1262),(125869,1263),(125870,1264),(125871,1265),(125872,1266),(125873,1267),(125874,1268),(125875,1269),(125876,1270),(125877,1271),(125878,1272),(125879,1273),(125880,1274),(125881,1275),(125882,1276),(125883,1277),(125884,1278),(125885,1279),(125886,1280),(125887,1281),(125888,1282),(125889,1283),(125890,1284),(125891,1285),(125892,1286),(125893,1287),(125894,1288),(125895,1289),(125896,1290),(125897,1291),(125898,1292),(125899,1293),(125900,1294),(125901,1295),(125902,1296),(125903,1297),(125904,1298),(125905,1299),(125906,1300),(125907,1301),(125908,1302),(125909,1303),(125910,1304),(125911,1305),(125912,1306),(125913,1307),(125914,1308),(125915,1309),(125916,1310),(125917,1311),(125918,1312),(125919,1313),(125920,1314),(125921,1315),(125922,1316),(125923,1317),(125924,1318),(125925,1319),(125926,1320),(125927,1321),(125928,1322),(125929,1323),(125930,1332),(125931,1342),(125932,1346),(125933,1347),(125934,1349),(125935,1350),(125936,1351),(125937,1353),(125938,1354),(125939,1355),(125940,1356),(125941,1357),(125942,1358),(125943,1359),(125944,1360),(125945,1361),(125946,1362),(125947,1363),(125948,1364),(125949,1366),(125950,1367),(125951,1368),(125952,1371),(125953,1375),(125954,1376),(125955,1377),(125956,1379),(125957,1389),(125958,1390),(125959,1391),(125960,1392),(125961,1393),(125962,1394),(125963,1395),(125964,1397),(125965,1398),(125966,1400),(125967,1420),(125968,1421),(125969,1422),(125970,1423),(125971,1424),(125972,1425),(125973,1427),(125974,1428),(125975,1429),(125976,1430),(125977,1431),(125978,1432),(125979,1433),(125980,1434),(125981,1435),(125982,1442),(125983,1443),(125984,1444),(125985,1445),(125986,1446),(125987,1447),(125988,1448),(125989,1450),(125990,1451),(125991,1452),(125992,1454),(125993,1455),(125994,1456),(125995,1457),(125996,1462),(125997,1469),(125998,1749),(125999,4500),(126000,4501),(126001,4502),(126002,4503),(126003,4504),(126004,4505),(126005,4506),(126006,4507),(126007,4508),(126008,4509),(126009,4510),(126010,4511),(126011,4512),(126012,4513),(126013,4514),(126014,4515),(126015,4516),(126016,4517),(126017,4518),(126018,4519),(126019,4520),(126020,4522),(126021,4523),(126022,5301),(126023,5468),(126024,5489),(126025,2154),(126026,2177),(126027,681),(126028,682),(126029,683),(126030,684),(126031,685),(126032,686),(126033,687),(126034,688),(126035,689),(126036,690),(126037,691),(126038,692),(126039,693),(126040,694),(126041,695),(126042,696),(126043,697),(126044,698),(126045,699),(126046,700),(126047,701),(126048,702),(126049,703),(126050,704),(126051,705),(126052,706),(126053,707),(126054,708),(126055,709),(126056,710),(126057,711),(126058,712),(126059,713),(126060,714),(126061,715),(126062,716),(126063,717),(126064,718),(126065,719),(126066,720),(126067,721),(126068,722),(126069,723),(126070,724),(126071,725),(126072,726),(126073,727),(126074,728),(126075,729),(126076,730),(126077,731),(126078,732),(126079,733),(126080,734),(126081,735),(126082,736),(126083,737),(126084,738),(126085,739),(126086,740),(126087,741),(126088,742),(126089,743),(126090,744),(126091,745),(126092,746),(126093,747),(126094,748),(126095,749),(126096,996),(126097,997),(126098,998),(126099,999),(126100,1000),(126101,1001),(126102,1002),(126103,1003),(126104,1005),(126105,1034),(126106,1035),(126107,1036),(126108,1038),(126109,1133),(126110,683),(126111,684),(126112,685),(126113,686),(126114,689),(126115,709),(126116,710),(126117,712),(126118,715),(126119,716),(126120,717),(126121,726),(126122,727),(126123,728),(126124,729),(126125,730),(126126,731),(126127,735),(126128,736),(126129,2221),(126130,2222),(126131,2221),(126132,2222),(126133,2221),(126134,2222),(126135,906),(126136,908),(126137,1004),(126138,1012),(126139,1019),(126140,1037),(126141,1092),(126142,1119),(126143,2524),(126144,2526),(126145,2299),(126146,2299),(126147,5757),(126148,5758),(126149,5759),(126150,362),(126151,363),(126152,364),(126153,365),(126154,366),(126155,367),(126156,368),(126157,369),(126158,398),(126159,399),(126160,400),(126161,401),(126162,402),(126163,403),(126164,404),(126165,405),(126166,406),(126167,407),(126168,408),(126169,409),(126170,410),(126171,411),(126172,412),(126173,413),(126174,414),(126175,415),(126176,416),(126177,417),(126178,418),(126179,419),(126180,420),(126181,421),(126182,422),(126183,423),(126184,424),(126185,425),(126186,426),(126187,427),(126188,428),(126189,429),(126190,430),(126191,431),(126192,432),(126193,433),(126194,434),(126195,435),(126196,436),(126197,437),(126198,438),(126199,439),(126200,440),(126201,441),(126202,442),(126203,443),(126204,444),(126205,445),(126206,446),(126207,447),(126208,448),(126209,449),(126210,450),(126211,451),(126212,452),(126213,453),(126214,454),(126215,455),(126216,456),(126217,457),(126218,458),(126219,459),(126220,460),(126221,461),(126222,462),(126223,463),(126224,464),(126225,465),(126226,466),(126227,467),(126228,468),(126229,469),(126230,470),(126231,471),(126232,472),(126233,473),(126234,474),(126235,475),(126236,476),(126237,477),(126238,478),(126239,479),(126240,480),(126241,481),(126242,482),(126243,483),(126244,484),(126245,485),(126246,486),(126247,487),(126248,488),(126249,489),(126250,490),(126251,491),(126252,492),(126253,493),(126254,494),(126255,495),(126256,496),(126257,497),(126258,498),(126259,499),(126260,500),(126261,501),(126262,502),(126263,503),(126264,504),(126265,505),(126266,506),(126267,507),(126268,508),(126269,509),(126270,510),(126271,511),(126272,512),(126273,513),(126274,514),(126275,515),(126276,516),(126277,517),(126278,518),(126279,519),(126280,520),(126281,521),(126282,522),(126283,523),(126284,524),(126285,525),(126286,526),(126287,527),(126288,528),(126289,529),(126290,530),(126291,531),(126292,532),(126293,560),(126294,611),(126295,613),(126296,614),(126297,615),(126298,616),(126299,617),(126300,618),(126301,619),(126302,620),(126303,621),(126304,622),(126305,623),(126306,624),(126307,625),(126308,632),(126309,633),(126310,634),(126311,635),(126312,636),(126313,637),(126314,638),(126315,639),(126316,640),(126317,641),(126318,642),(126319,643),(126320,644),(126321,645),(126322,646),(126323,647),(126324,648),(126325,649),(126326,650),(126327,651),(126328,652),(126329,653),(126330,655),(126331,656),(126332,657),(126333,658),(126334,659),(126335,660),(126336,661),(126337,662),(126338,663),(126339,664),(126340,665),(126341,666),(126342,667),(126343,669),(126344,670),(126345,671),(126346,672),(126347,673),(126348,674),(126349,675),(126350,676),(126351,677),(126352,678),(126353,679),(126354,680),(126355,1184),(126356,1185),(126357,1186),(126358,1187),(126359,1188),(126360,1189),(126361,1190),(126362,1191),(126363,1192),(126364,1193),(126365,1194),(126366,1208),(126367,1209),(126368,1324),(126369,1325),(126370,1326),(126371,1327),(126372,1328),(126373,1329),(126374,1330),(126375,1331),(126376,1333),(126377,1334),(126378,1335),(126379,1336),(126380,1337),(126381,1338),(126382,1339),(126383,1340),(126384,1341),(126385,1343),(126386,1344),(126387,1345),(126388,1348),(126389,1352),(126390,1365),(126391,1369),(126392,1370),(126393,1372),(126394,1373),(126395,1374),(126396,1378),(126397,1379),(126398,1380),(126399,1381),(126400,1382),(126401,1383),(126402,1384),(126403,1385),(126404,1386),(126405,1387),(126406,1388),(126407,1396),(126408,1399),(126409,1401),(126410,1402),(126411,1403),(126412,1404),(126413,1405),(126414,1406),(126415,1407),(126416,1408),(126417,1409),(126418,1410),(126419,1411),(126420,1412),(126421,1413),(126422,1414),(126423,1415),(126424,1416),(126425,1417),(126426,1418),(126427,1419),(126428,1426),(126429,1436),(126430,1437),(126431,1438),(126432,1439),(126433,1440),(126434,1441),(126435,1449),(126436,1453),(126437,1458),(126438,1459),(126439,1460),(126440,1461),(126441,1463),(126442,1464),(126443,1465),(126444,1466),(126445,1467),(126446,1468),(126447,1470),(126448,1471),(126449,1472),(126450,1488),(126451,1489),(126452,1490),(126453,1491),(126454,1492),(126455,1493),(126456,1494),(126457,1992),(126458,1993),(126459,1994),(126460,1995),(126461,1996),(126462,1997),(126463,1998),(126464,1999),(126465,2000),(126466,2001),(126467,2002),(126468,4521),(126469,4524),(126470,4525),(126471,4526),(126472,4527),(126473,4528),(126474,4529),(126475,4530),(126476,4531),(126477,4532),(126478,4533),(126479,4534),(126480,4535),(126481,4536),(126482,5271),(126483,5272),(126484,5273),(126485,5274),(126486,5282),(126487,5283),(126488,5284),(126489,527),(126490,528),(126491,529),(126492,530),(126493,531),(126494,532),(126495,560),(126496,611),(126497,613),(126498,617),(126499,618),(126500,619),(126501,624),(126502,625),(126503,632),(126504,636),(126505,637),(126506,639),(126507,646),(126508,648),(126509,652),(126510,659),(126511,660),(126512,670),(126513,362),(126514,363),(126515,364),(126516,365),(126517,366),(126518,367),(126519,368),(126520,369),(126521,398),(126522,399),(126523,403),(126524,404),(126525,405),(126526,406),(126527,407),(126528,411),(126529,412),(126530,413),(126531,414),(126532,420),(126533,421),(126534,424),(126535,425),(126536,431),(126537,458),(126538,462),(126539,469),(126540,470),(126541,471),(126542,475),(126543,481),(126544,500),(126545,517),(126546,519),(126547,520),(126548,614),(126549,616),(126550,635),(126551,643),(126552,644),(126553,645),(126554,650),(126555,656),(126556,661),(126557,663),(126558,665),(126559,666),(126560,669),(126561,671),(126562,673),(126563,675),(126564,676),(126565,677),(126566,678),(126567,679),(126568,680),(126569,1184),(126570,1185),(126571,1186),(126572,1187),(126573,1188),(126574,1189),(126575,1190),(126576,1191),(126577,1192),(126578,1193),(126579,1194),(126580,1208),(126581,1209),(126582,1324),(126583,1325),(126584,1326),(126585,1327),(126586,1328),(126587,1329),(126588,1330),(126589,1331),(126590,1333),(126591,1334),(126592,1335),(126593,1336),(126594,1337),(126595,1338),(126596,1339),(126597,1340),(126598,1341),(126599,1343),(126600,1344),(126601,1345),(126602,1348),(126603,1352),(126604,1365),(126605,1369),(126606,1370),(126607,1372),(126608,1373),(126609,1374),(126610,1378),(126611,1379),(126612,1380),(126613,1381),(126614,1382),(126615,1383),(126616,1384),(126617,1385),(126618,1386),(126619,1387),(126620,1388),(126621,1396),(126622,1399),(126623,1401),(126624,1402),(126625,1403),(126626,1404),(126627,1405),(126628,1406),(126629,1407),(126630,1408),(126631,1409),(126632,1410),(126633,1411),(126634,1412),(126635,1413),(126636,1414),(126637,1415),(126638,1416),(126639,1417),(126640,1418),(126641,1419),(126642,1426),(126643,1436),(126644,1437),(126645,1438),(126646,1439),(126647,1440),(126648,1441),(126649,1449),(126650,1453),(126651,1458),(126652,1459),(126653,1460),(126654,1461),(126655,1463),(126656,1464),(126657,1465),(126658,1466),(126659,1467),(126660,1468),(126661,1470),(126662,1471),(126663,1472),(126664,1488),(126665,1489),(126666,1490),(126667,1491),(126668,1492),(126669,1493),(126670,1494),(126671,1992),(126672,1993),(126673,1994),(126674,1995),(126675,1996),(126676,1997),(126677,1998),(126678,1999),(126679,2000),(126680,2001),(126681,2002),(126682,4521),(126683,4524),(126684,4525),(126685,4526),(126686,4527),(126687,4528),(126688,4529),(126689,4530),(126690,4531),(126691,4532),(126692,4533),(126693,4534),(126694,4535),(126695,4536),(126696,5271),(126697,5272),(126698,5273),(126699,5274),(126700,5282),(126701,5283),(126702,5284),(126703,374),(126704,375),(126705,376),(126706,533),(126707,534),(126708,535),(126709,536),(126710,537),(126711,538),(126712,539),(126713,540),(126714,541),(126715,542),(126716,543),(126717,544),(126718,545),(126719,546),(126720,547),(126721,548),(126722,549),(126723,550),(126724,551),(126725,552),(126726,553),(126727,554),(126728,555),(126729,558),(126730,559),(126731,561),(126732,562),(126733,564),(126734,566),(126735,571),(126736,572),(126737,573),(126738,574),(126739,575),(126740,576),(126741,577),(126742,578),(126743,579),(126744,580),(126745,581),(126746,582),(126747,585),(126748,586),(126749,587),(126750,588),(126751,589),(126752,590),(126753,591),(126754,592),(126755,593),(126756,594),(126757,595),(126758,596),(126759,598),(126760,600),(126761,601),(126762,602),(126763,603),(126764,604),(126765,605),(126766,609),(126767,610),(126768,612),(126769,754),(126770,755),(126771,756),(126772,757),(126773,758),(126774,759),(126775,760),(126776,761),(126777,762),(126778,763),(126779,764),(126780,765),(126781,766),(126782,767),(126783,768),(126784,769),(126785,770),(126786,771),(126787,772),(126788,773),(126789,774),(126790,775),(126791,776),(126792,778),(126793,779),(126794,780),(126795,781),(126796,782),(126797,783),(126798,784),(126799,785),(126800,786),(126801,787),(126802,788),(126803,790),(126804,791),(126805,794),(126806,796),(126807,797),(126808,805),(126809,806),(126810,807),(126811,808),(126812,809),(126813,810),(126814,811),(126815,812),(126816,813),(126817,814),(126818,816),(126819,817),(126820,818),(126821,819),(126822,820),(126823,821),(126824,822),(126825,824),(126826,826),(126827,827),(126828,828),(126829,829),(126830,834),(126831,835),(126832,836),(126833,837),(126834,838),(126835,839),(126836,840),(126837,841),(126838,842),(126839,843),(126840,844),(126841,845),(126842,846),(126843,847),(126844,848),(126845,849),(126846,850),(126847,851),(126848,852),(126849,853),(126850,854),(126851,855),(126852,856),(126853,857),(126854,858),(126855,862),(126856,864),(126857,865),(126858,1020),(126859,1021),(126860,1022),(126861,1023),(126862,1106),(126863,1166),(126864,1167),(126865,1169),(126866,1184),(126867,1238),(126868,1268),(126869,1294),(126870,1378),(126871,1389),(126872,1462),(126873,2154),(126874,2177),(126875,2221),(126876,2222),(126877,2299),(126878,5361),(126879,5362),(126880,5364),(126881,5622),(126882,5626),(126883,5639),(126884,5640),(126885,5641),(126886,5648),(126887,5665),(126888,5666),(126889,5667),(126890,1972),(126891,1973),(126892,1978),(126893,1981),(126894,1982),(126895,1983),(126896,1988),(126897,2037),(126898,1814),(126899,1817),(126900,1819),(126901,1823),(126902,1826),(126903,1830),(126904,1832),(126905,1835),(126906,1975),(126907,1977),(126908,1979),(126909,1980),(126910,1985),(126911,1987),(126912,1991),(126913,2189),(126914,2196),(126915,2201),(126916,2202),(126917,2208),(126918,2209),(126919,2214),(126920,2215),(126921,2216),(126922,2217),(126923,2218),(126924,2219),(126925,2220),(126926,2232),(126927,2233),(126928,2234),(126929,2236),(126930,2237),(126931,2238),(126932,2239),(126933,2258),(126934,2259),(126935,2261),(126936,2262),(126937,2321),(126938,2322),(126939,2392),(126940,2393),(126941,2394),(126942,2395),(126943,2464),(126944,2589),(126945,2591),(126946,2592),(126947,2318),(126948,2399),(126949,2400),(126950,2401),(126951,2614),(126952,2060),(126953,2139),(126954,2140),(126955,2141),(126956,2142),(126957,2143),(126958,2317),(126959,2398),(126960,2409),(126961,2611),(126962,4613),(126963,4614),(126964,2460),(126965,2461),(126966,2462),(126967,2463),(126968,2464),(126969,2504),(126970,2505),(126971,4573),(126972,4574),(126973,4575),(126974,4576),(126975,4605),(126976,4606),(126977,4607),(126978,4609),(126979,4610),(126980,4611),(126981,4625),(126982,4626),(126983,4805),(126984,4806),(126985,4807),(126986,4808),(126987,4824),(126988,4825),(126989,4826),(126990,4827),(126991,4828),(126992,4829),(126993,4830),(126994,4831),(126995,4832),(126996,4833),(126997,4912),(126998,4913),(126999,4914),(127000,4915),(127001,4916),(127002,4917),(127003,4918),(127004,4919),(127005,4920),(127006,4921),(127007,4922),(127008,4923),(127009,4924),(127010,4925),(127011,4926),(127012,4927),(127013,4928),(127014,4929),(127015,4930),(127016,4931),(127017,4932),(127018,4963),(127019,4964),(127020,4965),(127021,4966),(127022,5017),(127023,5018),(127024,5073),(127025,5074),(127026,5075),(127027,5076),(127028,5091),(127029,5092),(127030,5132),(127031,5133),(127032,5134),(127033,5135),(127034,5143),(127035,5144),(127036,5145),(127037,5146),(127038,5169),(127039,5170),(127040,5172),(127041,5173),(127042,5174),(127043,5175),(127044,5176),(127045,5177),(127046,5184),(127047,5185),(127048,5200),(127049,5201),(127050,5238),(127051,5239),(127052,5240),(127053,5241),(127054,5242),(127055,5243),(127056,5244),(127057,5245),(127058,5246),(127059,5247),(127060,4573),(127061,4574),(127062,4575),(127063,4576),(127064,4605),(127065,4606),(127066,4607),(127067,4609),(127068,4610),(127069,4611),(127070,4625),(127071,4626),(127072,4805),(127073,4806),(127074,4807),(127075,4808),(127076,4824),(127077,4825),(127078,4826),(127079,4827),(127080,4828),(127081,4829),(127082,4830),(127083,4831),(127084,4832),(127085,4833),(127086,4912),(127087,4913),(127088,4914),(127089,4915),(127090,4916),(127091,4917),(127092,4918),(127093,4919),(127094,4920),(127095,4921),(127096,4922),(127097,4923),(127098,4924),(127099,4925),(127100,4926),(127101,4927),(127102,4928),(127103,4929),(127104,4930),(127105,4931),(127106,4932),(127107,4959),(127108,4963),(127109,4964),(127110,4965),(127111,4966),(127112,5017),(127113,5018),(127114,5073),(127115,5074),(127116,5075),(127117,5076),(127118,5091),(127119,5092),(127120,5132),(127121,5133),(127122,5134),(127123,5135),(127124,5143),(127125,5144),(127126,5145),(127127,5146),(127128,5169),(127129,5170),(127130,5172),(127131,5173),(127132,5174),(127133,5175),(127134,5176),(127135,5177),(127136,5184),(127137,5185),(127138,5200),(127139,5201),(127140,5238),(127141,5239),(127142,5240),(127143,5241),(127144,5242),(127145,5243),(127146,5244),(127147,5245),(127148,5246),(127149,5247),(127150,4721),(127151,4725),(127152,4728),(127153,5140),(127154,5141),(127155,2591),(127156,2592),(127157,1828),(127158,1829),(127159,1831),(127160,1950),(127161,1951),(127162,1952),(127163,4896),(127164,4898),(127165,4899),(127166,4900),(127167,4901),(127168,4902),(127169,4903),(127170,4904),(127171,4905),(127172,4906),(127173,4907),(127174,4908),(127175,4909),(127176,4910),(127177,4911),(127178,5020),(127179,1679),(127180,1680),(127181,5021),(127182,5023),(127183,5026),(127184,5027),(127185,4972),(127186,4973),(127187,4974),(127188,4975),(127189,4976),(127190,4977),(127191,4978),(127192,4983),(127193,4984),(127194,4985),(127195,4986),(127196,4987),(127197,4988),(127198,4989),(127199,4990),(127200,4991),(127201,4996),(127202,4997),(127203,4998),(127204,4999),(127205,5000),(127206,5002),(127207,5005),(127208,5008),(127209,5011),(127210,5012),(127211,5013),(127212,5014),(127213,5015),(127214,5016),(127215,5020),(127216,4972),(127217,4973),(127218,4974),(127219,4975),(127220,4976),(127221,4977),(127222,4978),(127223,4983),(127224,4984),(127225,4985),(127226,4986),(127227,4987),(127228,4988),(127229,4989),(127230,4990),(127231,4991),(127232,4996),(127233,4997),(127234,4998),(127235,5000),(127236,5002),(127237,5004),(127238,5005),(127239,5008),(127240,5011),(127241,5012),(127242,5013),(127243,5014),(127244,5015),(127245,5016),(127246,4973),(127247,4974),(127248,4975),(127249,4976),(127250,4977),(127251,4978),(127252,4983),(127253,4984),(127254,4985),(127255,4986),(127256,4987),(127257,4988),(127258,4989),(127259,4990),(127260,4991),(127261,4996),(127262,4997),(127263,4998),(127264,4999),(127265,5000),(127266,5002),(127267,5004),(127268,5005),(127269,5008),(127270,5011),(127271,5012),(127272,5013),(127273,5014),(127274,5015),(127275,5016),(127276,4972),(127277,4973),(127278,4974),(127279,4975),(127280,4976),(127281,4977),(127282,4978),(127283,4983),(127284,4984),(127285,4985),(127286,4986),(127287,4987),(127288,4988),(127289,4989),(127290,4990),(127291,4991),(127292,4996),(127293,4997),(127294,4998),(127295,4999),(127296,5000),(127297,5002),(127298,5004),(127299,5005),(127300,5008),(127301,5011),(127302,5012),(127303,5013),(127304,5014),(127305,5015),(127306,5016),(127307,4896),(127308,4898),(127309,4899),(127310,4900),(127311,4901),(127312,4902),(127313,4903),(127314,4904),(127315,4905),(127316,4906),(127317,4907),(127318,4908),(127319,4909),(127320,4910),(127321,4911),(127322,4971),(127323,4974),(127324,4975),(127325,4978),(127326,4979),(127327,4980),(127328,4981),(127329,4982),(127330,4992),(127331,4993),(127332,4994),(127333,4995),(127334,5001),(127335,5003),(127336,5004),(127337,5006),(127338,5007),(127339,5009),(127340,5010),(127341,5019),(127342,5020),(127343,5022),(127344,5024),(127345,5025),(127346,4974),(127347,1748),(127348,255),(127349,256),(127350,257),(127351,1812),(127352,5620),(127353,5745),(127354,5746),(127355,5747),(127356,5748),(127357,5749),(127358,5179),(127359,5182),(127360,5190),(127361,5194),(127362,5195),(127363,5196),(127364,5197),(127365,5198),(127366,5199),(127367,5198),(127368,1579),(127369,1580),(127370,1581),(127371,1582),(127372,1583),(127373,1803),(127374,1804),(127375,1807),(127376,1808),(127377,1809),(127378,1810),(127379,1811),(127380,2201),(127381,2202),(127382,2214),(127383,2215),(127384,2216),(127385,2217),(127386,2218),(127387,2219),(127388,2220),(127389,2251),(127390,2258),(127391,2259),(127392,2260),(127393,2261),(127394,2262),(127395,2265),(127396,2266),(127397,2267),(127398,2268),(127399,2269),(127400,2276),(127401,2307),(127402,2308),(127403,2309),(127404,2310),(127405,2311),(127406,2312),(127407,2313),(127408,2314),(127409,2315),(127410,2316),(127411,2317),(127412,2318),(127413,2319),(127414,2320),(127415,2321),(127416,2322),(127417,2460),(127418,2461),(127419,2462),(127420,2463),(127421,2464),(127422,2504),(127423,2505),(127424,4628),(127425,4668),(127426,4669),(127427,4670),(127428,4671),(127429,4672),(127430,4673),(127431,4674),(127432,4675),(127433,4676),(127434,4680),(127435,4687),(127436,4688),(127437,4689),(127438,4690),(127439,4691),(127440,4692),(127441,4693),(127442,4694),(127443,4695),(127444,4696),(127445,4697),(127446,4698),(127447,4699),(127448,4700),(127449,4701),(127450,4702),(127451,4703),(127452,4704),(127453,4705),(127454,4706),(127455,4707),(127456,4708),(127457,4709),(127458,4710),(127459,4711),(127460,4712),(127461,4713),(127462,4907),(127463,4908),(127464,4909),(127465,4911),(127466,4974),(127467,4975),(127468,4976),(127469,4977),(127470,4978),(127471,5003),(127472,5004),(127473,5005),(127474,5006),(127475,5007),(127476,5008),(127477,5009),(127478,5010),(127479,5011),(127480,5012),(127481,5013),(127482,5014),(127483,5015),(127484,5016),(127485,5024),(127486,5025),(127487,5026),(127488,5027),(127489,5122),(127490,5123),(127491,5124),(127492,5125),(127493,5126),(127494,5127),(127495,5128),(127496,5129),(127497,5130),(127498,5131),(127499,5136),(127500,5137),(127501,5138),(127502,5139),(127503,5140),(127504,5141),(127505,5142),(127506,5147),(127507,5148),(127508,5149),(127509,5150),(127510,5159),(127511,5160),(127512,5161),(127513,5162),(127514,5163),(127515,5164),(127516,5165),(127517,5166),(127518,5167),(127519,5168),(127520,5190),(127521,5191),(127522,5192),(127523,5193),(127524,5194),(127525,5197),(127526,4974),(127527,5026),(127528,5166),(127529,1679),(127530,1680),(127531,1708),(127532,1709),(127533,1710),(127534,1711),(127535,1712),(127536,1713),(127537,1714),(127538,1748),(127539,1791),(127540,1792),(127541,1798),(127542,2187),(127543,2188),(127544,2189),(127545,2190),(127546,2191),(127547,2192),(127548,2193),(127549,2194),(127550,2195),(127551,2196),(127552,2197),(127553,2198),(127554,2232),(127555,2233),(127556,2234),(127557,2235),(127558,2236),(127559,2237),(127560,2238),(127561,2239),(127562,2240),(127563,2392),(127564,2393),(127565,2394),(127566,2395),(127567,2411),(127568,2412),(127569,2577),(127570,2578),(127571,2579),(127572,2580),(127573,2581),(127574,2589),(127575,2590),(127576,2591),(127577,2592),(127578,2593),(127579,2594),(127580,2595),(127581,2596),(127582,2597),(127583,2598),(127584,2599),(127585,2600),(127586,2601),(127587,2602),(127588,2603),(127589,2604),(127590,2605),(127591,2606),(127592,2607),(127593,2608),(127594,2609),(127595,2610),(127596,2611),(127597,2612),(127598,2613),(127599,2614),(127600,4621),(127601,4629),(127602,4630),(127603,4631),(127604,4632),(127605,4633),(127606,4634),(127607,4635),(127608,4636),(127609,4637),(127610,4638),(127611,4639),(127612,4640),(127613,4641),(127614,4642),(127615,4643),(127616,4644),(127617,4645),(127618,4646),(127619,4647),(127620,4648),(127621,4649),(127622,4650),(127623,4651),(127624,4652),(127625,4653),(127626,4654),(127627,4655),(127628,4656),(127629,4657),(127630,4658),(127631,4659),(127632,4660),(127633,4661),(127634,4662),(127635,4663),(127636,4664),(127637,4665),(127638,4666),(127639,4667),(127640,4896),(127641,4898),(127642,4900),(127643,4902),(127644,4903),(127645,4904),(127646,4943),(127647,4944),(127648,4945),(127649,4946),(127650,4947),(127651,4948),(127652,4949),(127653,4950),(127654,4951),(127655,4952),(127656,4953),(127657,4954),(127658,4971),(127659,4972),(127660,4973),(127661,4979),(127662,4980),(127663,4981),(127664,4982),(127665,4983),(127666,4984),(127667,4985),(127668,4986),(127669,4987),(127670,4988),(127671,4989),(127672,4990),(127673,4991),(127674,5001),(127675,5002),(127676,5105),(127677,5178),(127678,5179),(127679,5180),(127680,5181),(127681,5182),(127682,5202),(127683,5203),(127684,5204),(127685,5205),(127686,5206),(127687,5207),(127688,5208),(127689,5209),(127690,5210),(127691,5211),(127692,5212),(127693,5213),(127694,5214),(127695,5215),(127696,5216),(127697,5217),(127698,5218),(127699,5219),(127700,5220),(127701,5221),(127702,5222),(127703,5223),(127704,5224),(127705,5225),(127706,5226),(127707,5227),(127708,5228),(127709,5229),(127710,5230),(127711,5231),(127712,5232),(127713,5233),(127714,5234),(127715,5235),(127716,5236),(127717,5237),(127718,1575),(127719,1576),(127720,1577),(127721,1578),(127722,1805),(127723,1806),(127724,2200),(127725,2208),(127726,2209),(127727,2210),(127728,2245),(127729,2246),(127730,2256),(127731,2257),(127732,2302),(127733,2303),(127734,2304),(127735,2305),(127736,2306),(127737,2396),(127738,2397),(127739,2398),(127740,2399),(127741,2400),(127742,2401),(127743,2402),(127744,2403),(127745,2404),(127746,2405),(127747,2406),(127748,2407),(127749,2408),(127750,2409),(127751,2410),(127752,2458),(127753,2459),(127754,2503),(127755,4627),(127756,4714),(127757,4715),(127758,4716),(127759,4717),(127760,4719),(127761,4720),(127762,4721),(127763,4722),(127764,4723),(127765,4724),(127766,4725),(127767,4726),(127768,4727),(127769,4728),(127770,4729),(127771,4809),(127772,4810),(127773,4811),(127774,4823),(127775,4843),(127776,4844),(127777,4846),(127778,4847),(127779,4848),(127780,4849),(127781,4850),(127782,4851),(127783,4852),(127784,4856),(127785,4899),(127786,4901),(127787,4905),(127788,4906),(127789,4910),(127790,4992),(127791,4993),(127792,4994),(127793,4995),(127794,4996),(127795,4997),(127796,4998),(127797,4999),(127798,5000),(127799,5019),(127800,5020),(127801,5021),(127802,5022),(127803,5023),(127804,5039),(127805,5040),(127806,5041),(127807,5042),(127808,5043),(127809,5044),(127810,5045),(127811,5046),(127812,5047),(127813,5048),(127814,5049),(127815,5050),(127816,5051),(127817,5052),(127818,5053),(127819,5054),(127820,5055),(127821,5056),(127822,5057),(127823,5058),(127824,5059),(127825,5060),(127826,5061),(127827,5065),(127828,5066),(127829,5067),(127830,5068),(127831,5069),(127832,5070),(127833,5071),(127834,5072),(127835,5195),(127836,5196),(127837,5198),(127838,5199),(127839,4613),(127840,4614),(127841,4857),(127842,4858),(127843,4859),(127844,4860),(127845,4861),(127846,4862),(127847,4863),(127848,4864),(127849,4865),(127850,4866),(127851,4867),(127852,4868),(127853,4869),(127854,4870),(127855,4871),(127856,4874),(127857,4875),(127858,4876),(127859,4891),(127860,4892),(127861,4893),(127862,4894),(127863,2435),(127864,4731),(127865,4732),(127866,4733),(127867,4734),(127868,4735),(127869,4736),(127870,4737),(127871,4738),(127872,4739),(127873,4740),(127874,4741),(127875,4742),(127876,4743),(127877,4744),(127878,4745),(127879,4746),(127880,4747),(127881,4748),(127882,4749),(127883,4750),(127884,4751),(127885,4752),(127886,4753),(127887,4754),(127888,4755),(127889,4756),(127890,4757),(127891,4758),(127892,4759),(127893,4760),(127894,4761),(127895,4762),(127896,4763),(127897,4764),(127898,4765),(127899,4766),(127900,4767),(127901,4768),(127902,4769),(127903,4770),(127904,4771),(127905,4772),(127906,4773),(127907,4774),(127908,4775),(127909,4776),(127910,4777),(127911,4778),(127912,4779),(127913,4780),(127914,4781),(127915,4782),(127916,4783),(127917,4784),(127918,4785),(127919,4786),(127920,4787),(127921,4788),(127922,4789),(127923,4790),(127924,4791),(127925,4792),(127926,4793),(127927,4794),(127928,4795),(127929,4796),(127930,4797),(127931,4798),(127932,4799),(127933,4800),(127934,4801),(127935,4802),(127936,4803),(127937,4804),(127938,4957),(127939,4958),(127940,4960),(127941,4961),(127942,4962),(127943,5106),(127944,5107),(127945,5108),(127946,5109),(127947,2435),(127948,1538),(127949,1539),(127950,1543),(127951,1544),(127952,1561),(127953,5154),(127954,5155),(127955,1763),(127956,1497),(127957,1512),(127958,1590),(127959,1595),(127960,1596),(127961,1597),(127962,1599),(127963,1729),(127964,1732),(127965,1734),(127966,1149),(127967,1150),(127968,1475),(127969,1476),(127970,1480),(127971,1481),(127972,1482),(127973,1483),(127974,1510),(127975,1537),(127976,1538),(127977,1539),(127978,1540),(127979,1542),(127980,1543),(127981,1545),(127982,1546),(127983,1547),(127984,1548),(127985,1549),(127986,1550),(127987,1551),(127988,1552),(127989,1553),(127990,1554),(127991,1555),(127992,1560),(127993,1613),(127994,1616),(127995,1617),(127996,1655),(127997,1657),(127998,1706),(127999,1715),(128000,1716),(128001,1717),(128002,1718),(128003,1719),(128004,1720),(128005,1722),(128006,1723),(128007,1724),(128008,1725),(128009,1735),(128010,1765),(128011,1766),(128012,1767),(128013,1768),(128014,1770),(128015,1771),(128016,1776),(128017,1777),(128018,1783),(128019,1812),(128020,1149),(128021,1150),(128022,1477),(128023,1480),(128024,1483),(128025,1486),(128026,1487),(128027,1495),(128028,1496),(128029,1499),(128030,1500),(128031,1502),(128032,1505),(128033,1509),(128034,1537),(128035,1538),(128036,1539),(128037,1540),(128038,1541),(128039,1544),(128040,1546),(128041,1547),(128042,1548),(128043,1549),(128044,1550),(128045,1551),(128046,1552),(128047,1553),(128048,1554),(128049,1555),(128050,1556),(128051,1560),(128052,1561),(128053,1612),(128054,1614),(128055,1705),(128056,1776),(128057,1777),(128058,1796),(128059,5154),(128060,5155),(128061,377),(128062,378),(128063,380),(128064,382),(128065,385),(128066,386),(128067,387),(128068,389),(128069,391),(128070,397),(128071,569),(128072,584),(128073,607),(128074,608),(128075,774),(128076,791),(128077,792),(128078,795),(128079,800),(128080,801),(128081,818),(128082,823),(128083,831),(128084,860),(128085,867),(128086,868),(128087,893),(128088,1174),(128089,1175),(128090,1176),(128091,1177),(128092,1178),(128093,1179),(128094,1180),(128095,1185),(128096,1186),(128097,1187),(128098,1190),(128099,1192),(128100,1193),(128101,1194),(128102,1470),(128103,1471),(128104,1472),(128105,1494),(128106,1518),(128107,1519),(128108,1520),(128109,1521),(128110,1563),(128111,1564),(128112,1565),(128113,1665),(128114,1675),(128115,1676),(128116,1677),(128117,1678),(128118,1747),(128119,1751),(128120,1752),(128121,1753),(128122,1761),(128123,1762),(128124,1772),(128125,1778),(128126,1779),(128127,4880),(128128,4884),(128129,4885),(128130,5274),(128131,5336),(128132,5524),(128133,4536),(128134,904),(128135,905),(128136,1816),(128137,1818),(128138,1822),(128139,1966),(128140,1967),(128141,1968),(128142,1969),(128143,1970),(128144,1971),(128145,2013),(128146,2265),(128147,2266),(128148,2267),(128149,2268),(128150,2269),(128151,2276),(128152,2319),(128153,2320),(128154,2397),(128155,2400),(128156,2401),(128157,2409),(128158,2410),(128159,2589),(128160,2590),(128161,2591),(128162,2593),(128163,2597),(128164,2599),(128165,2601),(128166,2602),(128167,2603),(128168,2604),(128169,2605),(128170,2606),(128171,2607),(128172,2608),(128173,2609),(128174,2610),(128175,2612),(128176,1813),(128177,1814),(128178,1815),(128179,1816),(128180,1817),(128181,1818),(128182,1819),(128183,1820),(128184,1821),(128185,1822),(128186,1823),(128187,1824),(128188,1825),(128189,1826),(128190,1950),(128191,1951),(128192,1952),(128193,2435),(128194,4539),(128195,4540),(128196,4541),(128197,4542),(128198,4543),(128199,4544),(128200,4545),(128201,4546),(128202,4547),(128203,4548),(128204,4549),(128205,4550),(128206,4551),(128207,4552),(128208,4553),(128209,4554),(128210,4555),(128211,4556),(128212,4557),(128213,4558),(128214,4559),(128215,4560),(128216,4561),(128217,4562),(128218,4563),(128219,4564),(128220,4565),(128221,4933),(128222,4970),(128223,5151),(128224,5152),(128225,5153),(128226,5154),(128227,5155),(128228,5156),(128229,5157),(128230,5158),(128231,5183),(128232,5248),(128233,5249),(128234,4559),(128235,4560),(128236,4561),(128237,4562),(128238,4563),(128239,4564),(128240,4565),(128241,4933),(128242,5151),(128243,5152),(128244,5153),(128245,5154),(128246,5155),(128247,5156),(128248,5157),(128249,5158),(128250,5183),(128251,5248),(128252,5249),(128253,163),(128254,164),(128255,165),(128256,166),(128257,167),(128258,168),(128259,172),(128260,254),(128261,255),(128262,256),(128263,257),(128264,1049),(128265,1050),(128266,1051),(128267,1052),(128268,1053),(128269,1054),(128270,1055),(128271,1056),(128272,1057),(128273,1058),(128274,1059),(128275,1060),(128276,1061),(128277,1062),(128278,1063),(128279,1064),(128280,1065),(128281,1066),(128282,1067),(128283,1068),(128284,1069),(128285,1070),(128286,1071),(128287,1072),(128288,1073),(128289,1074),(128290,1075),(128291,1076),(128292,1077),(128293,1078),(128294,1079),(128295,1080),(128296,1081),(128297,1082),(128298,1083),(128299,1084),(128300,1085),(128301,1086),(128302,1087),(128303,1088),(128304,1089),(128305,1090),(128306,1091),(128307,1611),(128308,1612),(128309,1613),(128310,1614),(128311,1615),(128312,1616),(128313,1617),(128314,1654),(128315,1655),(128316,1656),(128317,1657),(128318,1705),(128319,1706),(128320,1707),(128321,1739),(128322,1741),(128323,1742),(128324,1759),(128325,1760),(128326,1764),(128327,1765),(128328,1766),(128329,1767),(128330,1768),(128331,1769),(128332,1770),(128333,1771),(128334,1772),(128335,1774),(128336,1775),(128337,1776),(128338,1777),(128339,1783),(128340,1784),(128341,1785),(128342,1812),(128343,1959),(128344,1960),(128345,1961),(128346,1962),(128347,1963),(128348,1964),(128349,2289),(128350,2290),(128351,2291),(128352,2293),(128353,2413),(128354,2414),(128355,2415),(128356,2416),(128357,2417),(128358,2418),(128359,2419),(128360,2420),(128361,2421),(128362,2422),(128363,2423),(128364,2424),(128365,2425),(128366,2426),(128367,2427),(128368,2428),(128369,2517),(128370,2518),(128371,2519),(128372,2520),(128373,2537),(128374,2538),(128375,4622),(128376,4623),(128377,4624),(128378,4853),(128379,4854),(128380,4855),(128381,4877),(128382,4878),(128383,4879),(128384,4880),(128385,4881),(128386,4882),(128387,4883),(128388,4884),(128389,4885),(128390,4886),(128391,4887),(128392,4888),(128393,4889),(128394,4890),(128395,5368),(128396,5408),(128397,5410),(128398,5411),(128399,5412),(128400,5413),(128401,5414),(128402,5415),(128403,5416),(128404,5417),(128405,5418),(128406,5419),(128407,5428),(128408,5469),(128409,5470),(128410,5471),(128411,5472),(128412,5473),(128413,5538),(128414,5539),(128415,5540),(128416,5541),(128417,5542),(128418,5543),(128419,5544),(128420,5545),(128421,5546),(128422,5547),(128423,5548),(128424,5549),(128425,5550),(128426,5571),(128427,5591),(128428,5592),(128429,5593),(128430,5594),(128431,5595),(128432,5596),(128433,5597),(128434,5598),(128435,5599),(128436,5600),(128437,5601),(128438,5602),(128439,5603),(128440,5604),(128441,5605),(128442,5606),(128443,5607),(128444,5608),(128445,5609),(128446,5610),(128447,5611),(128448,5612),(128449,5613),(128450,5614),(128451,5615),(128452,5616),(128453,5617),(128454,5618),(128455,5619),(128456,5620),(128457,5621),(128458,5622),(128459,5623),(128460,5624),(128461,5625),(128462,5626),(128463,5627),(128464,5628),(128465,5629),(128466,5630),(128467,5631),(128468,5632),(128469,5633),(128470,5634),(128471,5635),(128472,5636),(128473,5637),(128474,5638),(128475,5639),(128476,5640),(128477,5641),(128478,5642),(128479,5643),(128480,5644),(128481,5645),(128482,5646),(128483,5647),(128484,5648),(128485,5649),(128486,5650),(128487,5651),(128488,5652),(128489,5653),(128490,5654),(128491,5655),(128492,5656),(128493,5657),(128494,5658),(128495,5659),(128496,5660),(128497,5661),(128498,5662),(128499,5663),(128500,5664),(128501,5665),(128502,5666),(128503,5667),(128504,5668),(128505,5669),(128506,5670),(128507,5671),(128508,5672),(128509,5682),(128510,5683),(128511,5684),(128512,5685),(128513,5686),(128514,5687),(128515,5688),(128516,5690),(128517,5691),(128518,5692),(128519,5693),(128520,5694),(128521,5695),(128522,5697),(128523,5698),(128524,5699),(128525,5700),(128526,5701),(128527,5709),(128528,5710),(128529,5711),(128530,5712),(128531,5713),(128532,5714),(128533,5715),(128534,5716),(128535,5717),(128536,5718),(128537,5719),(128538,5720),(128539,5721),(128540,5722),(128541,5723),(128542,5724),(128543,5725),(128544,5726),(128545,5727),(128546,5728),(128547,5729),(128548,5730),(128549,5731),(128550,5732),(128551,5733),(128552,5734),(128553,5735),(128554,5736),(128555,5737),(128556,5745),(128557,5746),(128558,5747),(128559,5748),(128560,5749),(128561,163),(128562,164),(128563,165),(128564,166),(128565,167),(128566,168),(128567,172),(128568,254),(128569,255),(128570,256),(128571,257),(128572,1049),(128573,1050),(128574,1051),(128575,1052),(128576,1053),(128577,1054),(128578,1055),(128579,1056),(128580,1057),(128581,1058),(128582,1059),(128583,1060),(128584,1061),(128585,1062),(128586,1063),(128587,1064),(128588,1065),(128589,1066),(128590,1067),(128591,1068),(128592,1069),(128593,1070),(128594,1071),(128595,1072),(128596,1073),(128597,1074),(128598,1075),(128599,1076),(128600,1077),(128601,1078),(128602,1079),(128603,1080),(128604,1081),(128605,1082),(128606,1083),(128607,1084),(128608,1085),(128609,1086),(128610,1087),(128611,1088),(128612,1089),(128613,1090),(128614,1091),(128615,1611),(128616,1612),(128617,1614),(128618,1616),(128619,1617),(128620,1655),(128621,1656),(128622,1705),(128623,1706),(128624,1707),(128625,1739),(128626,1741),(128627,1742),(128628,1759),(128629,1760),(128630,1764),(128631,1765),(128632,1769),(128633,1772),(128634,1776),(128635,1777),(128636,1783),(128637,1959),(128638,1960),(128639,1961),(128640,1962),(128641,1963),(128642,1964),(128643,2290),(128644,2291),(128645,2293),(128646,2413),(128647,2414),(128648,2415),(128649,2416),(128650,2417),(128651,2418),(128652,2419),(128653,2420),(128654,2421),(128655,2422),(128656,2423),(128657,2424),(128658,2425),(128659,2426),(128660,2427),(128661,2428),(128662,2517),(128663,2518),(128664,2519),(128665,2520),(128666,2537),(128667,2538),(128668,4539),(128669,4540),(128670,4541),(128671,4542),(128672,4543),(128673,4544),(128674,4545),(128675,4546),(128676,4547),(128677,4548),(128678,4549),(128679,4550),(128680,4551),(128681,4552),(128682,4553),(128683,4554),(128684,4555),(128685,4556),(128686,4557),(128687,4558),(128688,4622),(128689,4623),(128690,4624),(128691,4853),(128692,4854),(128693,4855),(128694,4877),(128695,4878),(128696,4879),(128697,4880),(128698,4882),(128699,4883),(128700,4884),(128701,4885),(128702,4886),(128703,4887),(128704,4888),(128705,4890),(128706,4970),(128707,5368),(128708,5408),(128709,5410),(128710,5411),(128711,5412),(128712,5413),(128713,5414),(128714,5415),(128715,5416),(128716,5417),(128717,5418),(128718,5419),(128719,5428),(128720,5469),(128721,5470),(128722,5471),(128723,5472),(128724,5473),(128725,5538),(128726,5539),(128727,5540),(128728,5541),(128729,5542),(128730,5543),(128731,5544),(128732,5545),(128733,5546),(128734,5547),(128735,5548),(128736,5549),(128737,5550),(128738,5571),(128739,5591),(128740,5592),(128741,5593),(128742,5594),(128743,5595),(128744,5596),(128745,5597),(128746,5598),(128747,5599),(128748,5600),(128749,5601),(128750,5602),(128751,5603),(128752,5604),(128753,5605),(128754,5606),(128755,5607),(128756,5608),(128757,5609),(128758,5610),(128759,5611),(128760,5612),(128761,5613),(128762,5614),(128763,5615),(128764,5616),(128765,5617),(128766,5618),(128767,5619),(128768,5620),(128769,5621),(128770,5622),(128771,5624),(128772,5625),(128773,5626),(128774,5627),(128775,5628),(128776,5630),(128777,5631),(128778,5632),(128779,5633),(128780,5634),(128781,5635),(128782,5637),(128783,5638),(128784,5639),(128785,5640),(128786,5641),(128787,5643),(128788,5644),(128789,5645),(128790,5646),(128791,5647),(128792,5648),(128793,5649),(128794,5650),(128795,5652),(128796,5653),(128797,5654),(128798,5655),(128799,5656),(128800,5657),(128801,5658),(128802,5659),(128803,5660),(128804,5661),(128805,5663),(128806,5664),(128807,5665),(128808,5666),(128809,5667),(128810,5669),(128811,5670),(128812,5671),(128813,5672),(128814,5682),(128815,5683),(128816,5684),(128817,5685),(128818,5686),(128819,5687),(128820,5688),(128821,5690),(128822,5691),(128823,5692),(128824,5693),(128825,5694),(128826,5695),(128827,5697),(128828,5698),(128829,5699),(128830,5700),(128831,5701),(128832,5709),(128833,5710),(128834,5711),(128835,5712),(128836,5713),(128837,5714),(128838,5715),(128839,5716),(128840,5717),(128841,5718),(128842,5719),(128843,5720),(128844,5721),(128845,5722),(128846,5723),(128847,5724),(128848,5725),(128849,5726),(128850,5727),(128851,5728),(128852,5729),(128853,5730),(128854,5731),(128855,5732),(128856,5733),(128857,5734),(128858,5735),(128859,5736),(128860,5737),(128861,5745),(128862,5746),(128863,5747),(128864,5748),(128865,5749),(128866,1081),(128867,1611),(128868,1612),(128869,1614),(128870,1616),(128871,1617),(128872,1655),(128873,1656),(128874,1705),(128875,1706),(128876,1707),(128877,1739),(128878,1741),(128879,1742),(128880,1764),(128881,1765),(128882,1769),(128883,1772),(128884,1776),(128885,1777),(128886,1783),(128887,2290),(128888,2291),(128889,2293),(128890,4622),(128891,4623),(128892,4624),(128893,4853),(128894,4854),(128895,4855),(128896,4877),(128897,4878),(128898,4879),(128899,4880),(128900,4882),(128901,4883),(128902,4884),(128903,4885),(128904,4886),(128905,4887),(128906,4888),(128907,5598),(128908,5622),(128909,5625),(128910,5626),(128911,5627),(128912,5638),(128913,5641),(128914,5650),(128915,5660),(128916,5664),(128917,5667),(128918,5695),(128919,1081),(128920,1496),(128921,1992),(128922,1993),(128923,1994),(128924,1995),(128925,1997),(128926,1998),(128927,1999),(128928,2000),(128929,2001),(128930,2002),(128931,4526),(128932,4527),(128933,4530),(128934,4531),(128935,4532),(128936,4533),(128937,4534),(128938,4536),(128939,5274),(128940,5282),(128941,5283),(128942,5284),(128943,1996),(128944,4535),(128945,1588),(128946,1589),(128947,1590),(128948,1591),(128949,1592),(128950,1593),(128951,1594),(128952,1595),(128953,1596),(128954,1597),(128955,1598),(128956,1599),(128957,1604),(128958,1607),(128959,1610),(128960,1618),(128961,1619),(128962,1620),(128963,1621),(128964,1623),(128965,1626),(128966,1733),(128967,1734),(128968,1735),(128969,5258),(128970,5259),(128971,5260),(128972,5261),(128973,5262),(128974,5263),(128975,5264),(128976,5265),(128977,5266),(128978,5267),(128979,5268),(128980,5269),(128981,5270),(128982,5524),(128983,5526),(128984,5570),(128985,5588),(128986,1473),(128987,1474),(128988,1475),(128989,1476),(128990,1477),(128991,1478),(128992,1479),(128993,1480),(128994,1483),(128995,1484),(128996,1485),(128997,1486),(128998,1487),(128999,1515),(129000,1516),(129001,1517),(129002,1537),(129003,1538),(129004,1539),(129005,1540),(129006,1541),(129007,1544),(129008,1545),(129009,1546),(129010,1547),(129011,1548),(129012,1549),(129013,1550),(129014,1551),(129015,1552),(129016,1553),(129017,1554),(129018,1555),(129019,1556),(129020,1560),(129021,1561),(129022,1763),(129023,5309),(129024,5310),(129025,5311),(129026,5312),(129027,5313),(129028,5314),(129029,5315),(129030,5316),(129031,5317),(129032,5318),(129033,5319),(129034,5320),(129035,1481),(129036,1482),(129037,1542),(129038,1543),(129039,1140),(129040,1141),(129041,1142),(129042,1143),(129043,1149),(129044,1150),(129045,1497),(129046,1498),(129047,1501),(129048,1502),(129049,1503),(129050,1504),(129051,1506),(129052,1507),(129053,1508),(129054,1509),(129055,1510),(129056,1511),(129057,1512),(129058,1513),(129059,1514),(129060,1797),(129061,5171),(129062,5307),(129063,5308),(129064,5321),(129065,5322),(129066,5536),(129067,5689),(129068,5696),(129069,1141),(129070,1142),(129071,1143),(129072,1149),(129073,1150),(129074,1497),(129075,1498),(129076,1512),(129077,5307),(129078,5308),(129079,1495),(129080,1500),(129081,1796),(129082,1584),(129083,1585),(129084,1586),(129085,1600),(129086,1601),(129087,1602),(129088,1603),(129089,1605),(129090,1606),(129091,1608),(129092,1609),(129093,1622),(129094,1624),(129095,1625),(129096,1627),(129097,1628),(129098,1715),(129099,1716),(129100,1717),(129101,1718),(129102,1719),(129103,1720),(129104,1721),(129105,1722),(129106,1723),(129107,1724),(129108,1725),(129109,1726),(129110,1727),(129111,1728),(129112,1729),(129113,1730),(129114,1731),(129115,1732),(129116,5256),(129117,5257),(129118,5586),(129119,5587),(129120,5589),(129121,4532),(129122,5282),(129123,5283),(129124,5284),(129125,1497),(129126,1498),(129127,1512),(129128,1498),(129129,1499),(129130,5282),(129131,5283),(129132,5284),(129133,400),(129134,401),(129135,405),(129136,408),(129137,409),(129138,410),(129139,415),(129140,416),(129141,417),(129142,419),(129143,426),(129144,427),(129145,428),(129146,429),(129147,432),(129148,433),(129149,434),(129150,435),(129151,437),(129152,438),(129153,439),(129154,440),(129155,441),(129156,442),(129157,443),(129158,444),(129159,445),(129160,446),(129161,447),(129162,448),(129163,449),(129164,450),(129165,451),(129166,452),(129167,453),(129168,454),(129169,455),(129170,456),(129171,457),(129172,458),(129173,459),(129174,463),(129175,464),(129176,465),(129177,466),(129178,467),(129179,468),(129180,476),(129181,477),(129182,478),(129183,479),(129184,480),(129185,482),(129186,483),(129187,484),(129188,485),(129189,486),(129190,487),(129191,488),(129192,489),(129193,490),(129194,491),(129195,492),(129196,493),(129197,494),(129198,495),(129199,496),(129200,497),(129201,498),(129202,499),(129203,503),(129204,504),(129205,505),(129206,506),(129207,507),(129208,508),(129209,509),(129210,510),(129211,511),(129212,512),(129213,513),(129214,515),(129215,516),(129216,533),(129217,534),(129218,535),(129219,536),(129220,537),(129221,538),(129222,539),(129223,540),(129224,541),(129225,544),(129226,545),(129227,546),(129228,547),(129229,548),(129230,549),(129231,550),(129232,551),(129233,552),(129234,554),(129235,555),(129236,556),(129237,559),(129238,571),(129239,572),(129240,573),(129241,574),(129242,575),(129243,576),(129244,577),(129245,578),(129246,579),(129247,580),(129248,581),(129249,582),(129250,585),(129251,586),(129252,593),(129253,594),(129254,595),(129255,598),(129256,600),(129257,610),(129258,612),(129259,620),(129260,621),(129261,622),(129262,623),(129263,633),(129264,634),(129265,638),(129266,640),(129267,641),(129268,642),(129269,647),(129270,649),(129271,653),(129272,654),(129273,655),(129274,657),(129275,658),(129276,674),(129277,752),(129278,754),(129279,755),(129280,756),(129281,757),(129282,758),(129283,759),(129284,760),(129285,761),(129286,762),(129287,763),(129288,764),(129289,765),(129290,766),(129291,767),(129292,768),(129293,769),(129294,770),(129295,773),(129296,774),(129297,775),(129298,780),(129299,796),(129300,797),(129301,805),(129302,806),(129303,807),(129304,808),(129305,809),(129306,810),(129307,811),(129308,812),(129309,813),(129310,818),(129311,819),(129312,820),(129313,826),(129314,827),(129315,828),(129316,829),(129317,841),(129318,842),(129319,843),(129320,844),(129321,845),(129322,846),(129323,847),(129324,848),(129325,849),(129326,850),(129327,851),(129328,852),(129329,853),(129330,854),(129331,856),(129332,869),(129333,873),(129334,874),(129335,876),(129336,877),(129337,880),(129338,881),(129339,882),(129340,883),(129341,884),(129342,885),(129343,886),(129344,887),(129345,888),(129346,889),(129347,890),(129348,891),(129349,892),(129350,893),(129351,894),(129352,895),(129353,896),(129354,897),(129355,898),(129356,899),(129357,900),(129358,901),(129359,909),(129360,910),(129361,911),(129362,912),(129363,932),(129364,933),(129365,934),(129366,935),(129367,940),(129368,941),(129369,942),(129370,943),(129371,948),(129372,949),(129373,950),(129374,951),(129375,952),(129376,953),(129377,954),(129378,955),(129379,956),(129380,976),(129381,977),(129382,978),(129383,979),(129384,984),(129385,985),(129386,986),(129387,987),(129388,992),(129389,993),(129390,994),(129391,995),(129392,1009),(129393,1010),(129394,1011),(129395,1013),(129396,1016),(129397,1017),(129398,1018),(129399,1020),(129400,1022),(129401,1023),(129402,1024),(129403,1027),(129404,1029),(129405,1030),(129406,1031),(129407,1033),(129408,1039),(129409,1040),(129410,1042),(129411,1046),(129412,1047),(129413,1048),(129414,1049),(129415,1051),(129416,1054),(129417,1055),(129418,1065),(129419,1076),(129420,1077),(129421,1082),(129422,1085),(129423,1088),(129424,1090),(129425,1091),(129426,1095),(129427,1096),(129428,1097),(129429,1098),(129430,1099),(129431,1102),(129432,1103),(129433,1104),(129434,1105),(129435,1106),(129436,1107),(129437,1108),(129438,1110),(129439,1113),(129440,1114),(129441,1116),(129442,1120),(129443,1121),(129444,1123),(129445,1128),(129446,1129),(129447,1130),(129448,1131),(129449,1132),(129450,1136),(129451,1137),(129452,1138),(129453,1139),(129454,1148),(129455,1160),(129456,1161),(129457,1174),(129458,1471),(129459,1615),(129460,1775),(129461,1785),(129462,4491),(129463,4528),(129464,4539),(129465,4540),(129466,4541),(129467,4542),(129468,4543),(129469,4544),(129470,4545),(129471,4546),(129472,4547),(129473,4548),(129474,4549),(129475,4550),(129476,4551),(129477,4552),(129478,4553),(129479,4554),(129480,4555),(129481,4556),(129482,4557),(129483,4558),(129484,4559),(129485,4560),(129486,4563),(129487,4564),(129488,4565),(129489,5248),(129490,5249),(129491,5275),(129492,5276),(129493,5277),(129494,5285),(129495,5286),(129496,5287),(129497,5288),(129498,5289),(129499,5290),(129500,5291),(129501,5292),(129502,5293),(129503,5294),(129504,5296),(129505,5297),(129506,5298),(129507,5299),(129508,5300),(129509,5302),(129510,5303),(129511,5304),(129512,5305),(129513,5306),(129514,5338),(129515,5339),(129516,5340),(129517,5341),(129518,5342),(129519,5345),(129520,5346),(129521,5347),(129522,5348),(129523,5349),(129524,5350),(129525,5357),(129526,5358),(129527,5368),(129528,5369),(129529,5401),(129530,5402),(129531,5403),(129532,5404),(129533,5405),(129534,5406),(129535,5407),(129536,5408),(129537,5409),(129538,5410),(129539,5411),(129540,5412),(129541,5413),(129542,5414),(129543,5415),(129544,5416),(129545,5417),(129546,5418),(129547,5419),(129548,5420),(129549,5421),(129550,5422),(129551,5423),(129552,5424),(129553,5425),(129554,5426),(129555,5427),(129556,5428),(129557,5429),(129558,5431),(129559,5434),(129560,5435),(129561,5436),(129562,5437),(129563,5438),(129564,5439),(129565,5440),(129566,5441),(129567,5442),(129568,5443),(129569,5444),(129570,5445),(129571,5446),(129572,5447),(129573,5448),(129574,5449),(129575,5450),(129576,5458),(129577,5463),(129578,5464),(129579,5471),(129580,5472),(129581,5518),(129582,5519),(129583,5531),(129584,5532),(129585,5533),(129586,5534),(129587,5535),(129588,5537),(129589,5541),(129590,5542),(129591,5543),(129592,5544),(129593,5545),(129594,5546),(129595,5547),(129596,5548),(129597,5553),(129598,5554),(129599,5555),(129600,5556),(129601,5557),(129602,5558),(129603,5559),(129604,5560),(129605,5563),(129606,5564),(129607,5566),(129608,5567),(129609,5568),(129610,5569),(129611,5571),(129612,5590),(129613,5591),(129614,5592),(129615,5593),(129616,5595),(129617,5596),(129618,5597),(129619,5602),(129620,5603),(129621,5605),(129622,5606),(129623,5608),(129624,5609),(129625,5610),(129626,5611),(129627,5612),(129628,5613),(129629,5614),(129630,5615),(129631,5616),(129632,5617),(129633,5618),(129634,5619),(129635,5620),(129636,5630),(129637,5631),(129638,5632),(129639,5633),(129640,5634),(129641,5674),(129642,5675),(129643,5676),(129644,5677),(129645,5678),(129646,5679),(129647,5680),(129648,5681),(129649,5682),(129650,5683),(129651,5684),(129652,5685),(129653,5686),(129654,5688),(129655,5690),(129656,5691),(129657,5692),(129658,5693),(129659,5694),(129660,5697),(129661,5698),(129662,5699),(129663,5700),(129664,5709),(129665,5710),(129666,5711),(129667,5713),(129668,5714),(129669,5715),(129670,5716),(129671,5717),(129672,5718),(129673,5719),(129674,5720),(129675,5721),(129676,5722),(129677,5723),(129678,5724),(129679,5725),(129680,5726),(129681,5727),(129682,5728),(129683,5729),(129684,5730),(129685,5731),(129686,5732),(129687,5733),(129688,5734),(129689,5735),(129690,5736),(129691,5737),(129692,5738),(129693,5745),(129694,5746),(129695,5747),(129696,5749),(129697,5752),(129698,5404),(129699,5425),(129700,5427),(129701,5406),(129702,5407),(129703,5426),(129704,5559),(129705,5560),(129706,5401),(129707,1615),(129708,4539),(129709,4540),(129710,4541),(129711,4542),(129712,4543),(129713,4544),(129714,4546),(129715,4547),(129716,4548),(129717,4549),(129718,4556),(129719,4557),(129720,4558),(129721,4559),(129722,4560),(129723,5249),(129724,5568),(129725,5569),(129726,5443),(129727,5540),(129728,5592),(129729,5594),(129730,5604),(129731,5693),(129732,5596),(129733,5597),(129734,5734),(129735,5735),(129736,5736),(129737,5737),(129738,400),(129739,480),(129740,482),(129741,499),(129742,515),(129743,873),(129744,874),(129745,876),(129746,877),(129747,880),(129748,881),(129749,1024),(129750,5299),(129751,5300),(129752,5303),(129753,5304),(129754,5305),(129755,5306),(129756,5449),(129757,5518),(129758,5519),(129759,5713),(129760,5714),(129761,5715),(129762,5716),(129763,5717),(129764,5718),(129765,5719),(129766,5720),(129767,5721),(129768,5722),(129769,5723),(129770,5724),(129771,5725),(129772,5726),(129773,5727),(129774,5728),(129775,5729),(129776,5730),(129777,5731),(129778,5732),(129779,5733),(129780,5734),(129781,5735),(129782,5736),(129783,5737),(129784,5733),(129785,5734),(129786,5735),(129787,5736),(129788,5737),(129789,4540),(129790,4541),(129791,4542),(129792,5248),(129793,5249),(129794,5629),(129795,5642),(129796,5668),(129797,2540),(129798,2541),(129799,2542),(129800,5357),(129801,5429),(129802,5434),(129803,5458),(129804,5463),(129805,5464),(129806,5518),(129807,2154),(129808,2177),(129809,2221),(129810,2222),(129811,2299),(129812,5622),(129813,5641),(129814,5667),(129815,1184),(129816,5527),(129817,5621),(129818,5644),(129819,5645),(129820,5654),(129821,5670),(129822,5671),(129823,1054),(129824,1055),(129825,1066),(129826,2289),(129827,2290),(129828,2291),(129829,2293),(129830,2428),(129831,5621),(129832,5622),(129833,5623),(129834,5624),(129835,5625),(129836,5626),(129837,5627),(129838,5629),(129839,5630),(129840,5631),(129841,5632),(129842,5633),(129843,5634),(129844,5636),(129845,5637),(129846,5638),(129847,5639),(129848,5640),(129849,5641),(129850,5642),(129851,5643),(129852,5644),(129853,5645),(129854,5647),(129855,5648),(129856,5649),(129857,5650),(129858,5651),(129859,5652),(129860,5653),(129861,5655),(129862,5656),(129863,5658),(129864,5659),(129865,5660),(129866,5662),(129867,5663),(129868,5664),(129869,5665),(129870,5666),(129871,5667),(129872,5668),(129873,5669),(129874,5670),(129875,5671),(129876,5731),(129877,5732),(129878,5733),(129879,5734),(129880,5735),(129881,5736),(129882,5737),(129883,5745),(129884,5746),(129885,5747),(129886,5749),(129887,1054),(129888,1055),(129889,1066),(129890,2289),(129891,2290),(129892,2291),(129893,2293),(129894,2428),(129895,5655),(129896,5656),(129897,5732),(129898,5745),(129899,5746),(129900,5747),(129901,5749),(129902,165),(129903,1082),(129904,1088),(129905,1611),(129906,1612),(129907,1614),(129908,1616),(129909,1617),(129910,1655),(129911,1656),(129912,1705),(129913,1706),(129914,1707),(129915,1739),(129916,1741),(129917,1742),(129918,1764),(129919,1765),(129920,1769),(129921,1776),(129922,1777),(129923,1783),(129924,1962),(129925,2517),(129926,2518),(129927,2519),(129928,2520),(129929,4853),(129930,4854),(129931,4855),(129932,4883),(129933,4970),(129934,5368),(129935,5408),(129936,5410),(129937,5411),(129938,5412),(129939,5413),(129940,5415),(129941,5416),(129942,5417),(129943,5428),(129944,5540),(129945,5546),(129946,5547),(129947,5548),(129948,5571),(129949,5591),(129950,5592),(129951,5593),(129952,5594),(129953,5595),(129954,5596),(129955,5597),(129956,5598),(129957,5599),(129958,5600),(129959,5601),(129960,5602),(129961,5603),(129962,5604),(129963,5613),(129964,5615),(129965,5616),(129966,5617),(129967,5618),(129968,5619),(129969,5628),(129970,5646),(129971,5654),(129972,5661),(129973,5672),(129974,5690),(129975,5691),(129976,5692),(129977,5693),(129978,5694),(129979,5695),(129980,5713),(129981,5715),(129982,5717),(129983,5719),(129984,5721),(129985,5723),(129986,5725),(129987,5727),(129988,5729),(129989,165),(129990,1082),(129991,1088),(129992,1611),(129993,1612),(129994,1614),(129995,1616),(129996,1617),(129997,1655),(129998,1656),(129999,1705),(130000,1706),(130001,1707),(130002,1739),(130003,1741),(130004,1742),(130005,1764),(130006,1765),(130007,1769),(130008,1776),(130009,1777),(130010,1783),(130011,1962),(130012,2517),(130013,2518),(130014,2519),(130015,2520),(130016,4853),(130017,4854),(130018,4855),(130019,4883),(130020,4970),(130021,5598),(130022,5624),(130023,5628),(130024,5643),(130025,5653),(130026,5660),(130027,5669),(130028,5695),(130029,1615),(130030,1775),(130031,1785),(130032,5414),(130033,5418),(130034,5419),(130035,5471),(130036,5472),(130037,5541),(130038,5542),(130039,5543),(130040,5544),(130041,5545),(130042,5605),(130043,5606),(130044,5608),(130045,5609),(130046,5610),(130047,5611),(130048,5614),(130049,5620),(130050,5682),(130051,5683),(130052,5684),(130053,5685),(130054,5686),(130055,5688),(130056,5697),(130057,5698),(130058,5699),(130059,5700),(130060,5709),(130061,5710),(130062,5711),(130063,5714),(130064,5716),(130065,5718),(130066,5720),(130067,5722),(130068,5724),(130069,5726),(130070,5728),(130071,5730),(130072,5732),(130073,5745),(130074,5746),(130075,5747),(130076,5749),(130077,5612),(130078,1148),(130079,5286),(130080,5274),(130081,5282),(130082,5283),(130083,5284),(130084,5369),(130085,5402),(130086,5531),(130087,5532),(130088,5533),(130089,5534),(130090,5535),(130091,5558),(130092,5563),(130093,5564),(130094,5566),(130095,5674),(130096,5675),(130097,5676),(130098,5677),(130099,5678),(130100,5679),(130101,5738),(130102,5434),(130103,5275),(130104,5276),(130105,5277),(130106,5338),(130107,5339),(130108,5340),(130109,5341),(130110,5342),(130111,5345),(130112,5346),(130113,5347),(130114,5348),(130115,5349),(130116,5350),(130117,5357),(130118,5358),(130119,5680),(130120,5681),(130121,5285),(130122,5287),(130123,5288),(130124,5289),(130125,5290),(130126,5291),(130127,5292),(130128,5293),(130129,5294),(130130,5296),(130131,5297),(130132,5298),(130133,5299),(130134,5300),(130135,5302),(130136,5303),(130137,5304),(130138,5305),(130139,5306),(130140,5537),(130141,5752),(130142,5401),(130143,5403),(130144,5404),(130145,5405),(130146,5406),(130147,5407),(130148,5409),(130149,5421),(130150,5422),(130151,5423),(130152,5424),(130153,5425),(130154,5426),(130155,5427),(130156,5429),(130157,5458),(130158,5463),(130159,5464),(130160,5553),(130161,5554),(130162,5555),(130163,5556),(130164,5557),(130165,5559),(130166,5560),(130167,5567),(130168,5568),(130169,5569),(130170,5590),(130171,4524),(130172,4572),(130173,1081),(130174,1196),(130175,1197),(130176,1198),(130177,1199),(130178,1201),(130179,1202),(130180,1203),(130181,1204),(130182,1205),(130183,1206),(130184,1207),(130185,1232),(130186,1243),(130187,1245),(130188,1289),(130189,1332),(130190,1346),(130191,1347),(130192,1349),(130193,1353),(130194,1354),(130195,1355),(130196,1356),(130197,1357),(130198,1358),(130199,1359),(130200,1360),(130201,1361),(130202,1362),(130203,1363),(130204,1364),(130205,1366),(130206,1367),(130207,1368),(130208,1387),(130209,1410),(130210,1411),(130211,1412),(130212,1413),(130213,1414),(130214,1415),(130215,1416),(130216,1437),(130217,1440),(130218,1443),(130219,1444),(130220,1453),(130221,1464),(130222,1468),(130223,5324),(130224,5328),(130225,5329),(130226,5370),(130227,5371),(130228,5372),(130229,5373),(130230,5374),(130231,5375),(130232,5477),(130233,5478),(130234,5479),(130235,5480),(130236,5481),(130237,5484),(130238,5485),(130239,5486),(130240,5487),(130241,5488),(130242,5704),(130243,5705),(130244,5706),(130245,1329),(130246,1333),(130247,1334),(130248,1335),(130249,1337),(130250,1339),(130251,1369),(130252,1370),(130253,1372),(130254,1373),(130255,1374),(130256,5103),(130257,5104),(130258,5274),(130259,1524),(130260,1672),(130261,1673),(130262,1674),(130263,1793),(130264,1794),(130265,1795),(130266,1081),(130267,5370),(130268,5332),(130269,1197),(130270,1332),(130271,1362),(130272,1367),(130273,51),(130274,51),(130275,51),(130276,51),(130277,51),(130278,51),(130279,51),(130280,51),(130281,583),(130282,584),(130283,600),(130284,602),(130285,605),(130286,606),(130287,608),(130288,777),(130289,778),(130290,779),(130291,780),(130292,783),(130293,787),(130294,789),(130295,798),(130296,799),(130297,800),(130298,801),(130299,802),(130300,803),(130301,804),(130302,821),(130303,822),(130304,823),(130305,830),(130306,831),(130307,832),(130308,833),(130309,856),(130310,866),(130311,867),(130312,868),(130313,1173),(130314,1175),(130315,1176),(130316,1177),(130317,1178),(130318,1179),(130319,1180),(130320,1181),(130321,1182),(130322,1183),(130323,1195),(130324,1196),(130325,1197),(130326,1198),(130327,1199),(130328,1200),(130329,1201),(130330,1202),(130331,1203),(130332,1204),(130333,1205),(130334,1206),(130335,1207),(130336,1210),(130337,1211),(130338,1212),(130339,1213),(130340,1214),(130341,1215),(130342,1216),(130343,1217),(130344,1218),(130345,1219),(130346,1220),(130347,1221),(130348,1222),(130349,1223),(130350,1224),(130351,1225),(130352,1226),(130353,1227),(130354,1228),(130355,1229),(130356,1230),(130357,1231),(130358,1232),(130359,1233),(130360,1234),(130361,1235),(130362,1236),(130363,1237),(130364,1238),(130365,1239),(130366,1240),(130367,1241),(130368,1242),(130369,1243),(130370,1244),(130371,1245),(130372,1246),(130373,1247),(130374,1248),(130375,1249),(130376,1250),(130377,1251),(130378,1252),(130379,1253),(130380,1254),(130381,1255),(130382,1256),(130383,1257),(130384,1258),(130385,1259),(130386,1260),(130387,1261),(130388,1262),(130389,1263),(130390,1264),(130391,1265),(130392,1266),(130393,1267),(130394,1268),(130395,1269),(130396,1270),(130397,1271),(130398,1272),(130399,1273),(130400,1274),(130401,1275),(130402,1276),(130403,1277),(130404,1278),(130405,1279),(130406,1280),(130407,1281),(130408,1282),(130409,1283),(130410,1284),(130411,1285),(130412,1286),(130413,1287),(130414,1288),(130415,1289),(130416,1290),(130417,1291),(130418,1292),(130419,1293),(130420,1294),(130421,1295),(130422,1296),(130423,1297),(130424,1298),(130425,1299),(130426,1300),(130427,1301),(130428,1302),(130429,1303),(130430,1304),(130431,1305),(130432,1306),(130433,1307),(130434,1308),(130435,1309),(130436,1310),(130437,1311),(130438,1312),(130439,1313),(130440,1314),(130441,1315),(130442,1316),(130443,1317),(130444,1318),(130445,1319),(130446,1320),(130447,1321),(130448,1322),(130449,1323),(130450,1332),(130451,1342),(130452,1346),(130453,1347),(130454,1349),(130455,1350),(130456,1351),(130457,1353),(130458,1354),(130459,1355),(130460,1356),(130461,1357),(130462,1358),(130463,1359),(130464,1360),(130465,1361),(130466,1362),(130467,1363),(130468,1364),(130469,1366),(130470,1367),(130471,1368),(130472,1371),(130473,1375),(130474,1376),(130475,1377),(130476,1379),(130477,1389),(130478,1390),(130479,1391),(130480,1392),(130481,1393),(130482,1394),(130483,1395),(130484,1397),(130485,1398),(130486,1400),(130487,1420),(130488,1421),(130489,1422),(130490,1423),(130491,1424),(130492,1425),(130493,1427),(130494,1428),(130495,1429),(130496,1430),(130497,1431),(130498,1432),(130499,1433),(130500,1434),(130501,1435),(130502,1442),(130503,1443),(130504,1444),(130505,1445),(130506,1446),(130507,1447),(130508,1448),(130509,1450),(130510,1451),(130511,1452),(130512,1454),(130513,1455),(130514,1456),(130515,1457),(130516,1462),(130517,1469),(130518,1749),(130519,4500),(130520,4501),(130521,4502),(130522,4503),(130523,4504),(130524,4505),(130525,4506),(130526,4507),(130527,4508),(130528,4509),(130529,4510),(130530,4511),(130531,4512),(130532,4513),(130533,4514),(130534,4515),(130535,4516),(130536,4517),(130537,4518),(130538,4519),(130539,4520),(130540,4522),(130541,4523),(130542,583),(130543,602),(130544,605),(130545,778),(130546,779),(130547,780),(130548,783),(130549,787),(130550,821),(130551,822),(130552,856),(130553,1166),(130554,1171),(130555,1172),(130556,1174),(130557,600),(130558,1166),(130559,1184),(130560,1185),(130561,1186),(130562,1187),(130563,1188),(130564,1189),(130565,1190),(130566,1191),(130567,1192),(130568,1193),(130569,1194),(130570,1208),(130571,1209),(130572,1324),(130573,1325),(130574,1326),(130575,1327),(130576,1328),(130577,1329),(130578,1330),(130579,1331),(130580,1333),(130581,1334),(130582,1335),(130583,4521),(130584,4524),(130585,4525),(130586,1185),(130587,1186),(130588,1187),(130589,1188),(130590,1189),(130591,1190),(130592,1192),(130593,1193),(130594,1194),(130595,398),(130596,399),(130597,403),(130598,404),(130599,406),(130600,407),(130601,411),(130602,412),(130603,413),(130604,414),(130605,420),(130606,421),(130607,424),(130608,425),(130609,431),(130610,462),(130611,471),(130612,481),(130613,500),(130614,501),(130615,517),(130616,616),(130617,635),(130618,643),(130619,644),(130620,661),(130621,663),(130622,665),(130623,666),(130624,669),(130625,671),(130626,673),(130627,675),(130628,676),(130629,677),(130630,678),(130631,679),(130632,680),(130633,1336),(130634,1337),(130635,1338),(130636,1339),(130637,1340),(130638,1341),(130639,1344),(130640,1345),(130641,1348),(130642,1352),(130643,1365),(130644,1369),(130645,1370),(130646,1372),(130647,1373),(130648,1374),(130649,1378),(130650,1380),(130651,1381),(130652,1382),(130653,1383),(130654,1384),(130655,1385),(130656,1386),(130657,1387),(130658,1388),(130659,1396),(130660,1399),(130661,1401),(130662,1402),(130663,1403),(130664,1404),(130665,1405),(130666,1406),(130667,1407),(130668,1408),(130669,1409),(130670,1410),(130671,1411),(130672,1412),(130673,1413),(130674,1414),(130675,1415),(130676,1416),(130677,1426),(130678,1436),(130679,1437),(130680,1438),(130681,1439),(130682,1440),(130683,1449),(130684,1453),(130685,1458),(130686,1459),(130687,1460),(130688,1461),(130689,1463),(130690,1464),(130691,1465),(130692,1466),(130693,1467),(130694,1468),(130695,1522),(130696,1523),(130697,1524),(130698,1525),(130699,1526),(130700,1527),(130701,1528),(130702,1529),(130703,1530),(130704,1531),(130705,1532),(130706,1534),(130707,1535),(130708,1536),(130709,1557),(130710,1558),(130711,1559),(130712,1562),(130713,1587),(130714,1661),(130715,1662),(130716,1663),(130717,1664),(130718,1667),(130719,1668),(130720,1669),(130721,1670),(130722,1671),(130723,1672),(130724,1673),(130725,1674),(130726,1740),(130727,1743),(130728,1744),(130729,1745),(130730,1746),(130731,1747),(130732,1750),(130733,1780),(130734,1781),(130735,1782),(130736,1793),(130737,1794),(130738,1795),(130739,1799),(130740,1800),(130741,1801),(130742,1802),(130743,5355),(130744,5370),(130745,5371),(130746,5482),(130747,5483),(130748,5520),(130749,5521),(130750,5522),(130751,5523),(130752,5704),(130753,5705),(130754,5706),(130755,1518),(130756,1519),(130757,1520),(130758,1521),(130759,1533),(130760,1563),(130761,1564),(130762,1565),(130763,1566),(130764,1658),(130765,1659),(130766,1660),(130767,1665),(130768,1666),(130769,1675),(130770,1676),(130771,1677),(130772,1678),(130773,1751),(130774,1752),(130775,1753),(130776,1754),(130777,1756),(130778,1757),(130779,1758),(130780,1761),(130781,1762),(130782,1778),(130783,1779),(130784,1786),(130785,1787),(130786,1788),(130787,1789),(130788,1790),(130789,5323),(130790,5324),(130791,5325),(130792,5326),(130793,5327),(130794,5328),(130795,5329),(130796,5330),(130797,5331),(130798,5332),(130799,5333),(130800,5334),(130801,5335),(130802,5336),(130803,5337),(130804,5351),(130805,5352),(130806,5354),(130807,5356),(130808,5372),(130809,5373),(130810,5374),(130811,5375),(130812,5376),(130813,5377),(130814,5390),(130815,5474),(130816,5475),(130817,5476),(130818,5477),(130819,5478),(130820,5479),(130821,5480),(130822,5481),(130823,5484),(130824,5485),(130825,5486),(130826,5487),(130827,5488),(130828,5726),(130829,5726),(130830,5726),(130831,5726),(130832,5718),(130833,5718),(130834,5718),(130835,5718),(130836,5718),(130837,5718),(130838,5718),(130839,5718),(130840,5718),(130841,5718),(130842,5718),(130843,5718),(130844,5718),(130845,5718),(130846,5718),(130847,5718),(130848,5718),(130849,5718),(130850,5718),(130851,1),(130852,2),(130853,3),(130854,4),(130855,5),(130856,6),(130857,7),(130858,8),(130859,9),(130860,10),(130861,11),(130862,12),(130863,13),(130864,14),(130865,15),(130866,16),(130867,17),(130868,18),(130869,19),(130870,20),(130871,21),(130872,22),(130873,23),(130874,24),(130875,25),(130876,26),(130877,27),(130878,28),(130879,29),(130880,30),(130881,31),(130882,32),(130883,33),(130884,34),(130885,35),(130886,36),(130887,37),(130888,38),(130889,39),(130890,40),(130891,41),(130892,42),(130893,43),(130894,44),(130895,45),(130896,46),(130897,47),(130898,48),(130899,49),(130900,50),(130901,51),(130902,52),(130903,53),(130904,54),(130905,55),(130906,56),(130907,57),(130908,58),(130909,59),(130910,60),(130911,61),(130912,62),(130913,63),(130914,64),(130915,65),(130916,66),(130917,67),(130918,68),(130919,69),(130920,70),(130921,71),(130922,72),(130923,73),(130924,74),(130925,75),(130926,76),(130927,77),(130928,78),(130929,79),(130930,80),(130931,81),(130932,82),(130933,83),(130934,84),(130935,85),(130936,86),(130937,87),(130938,88),(130939,89),(130940,90),(130941,91),(130942,92),(130943,93),(130944,94),(130945,95),(130946,96),(130947,97),(130948,98),(130949,99),(130950,100),(130951,101),(130952,102),(130953,103),(130954,104),(130955,105),(130956,106),(130957,107),(130958,108),(130959,109),(130960,110),(130961,111),(130962,112),(130963,113),(130964,114),(130965,115),(130966,116),(130967,117),(130968,118),(130969,119),(130970,120),(130971,121),(130972,122),(130973,123),(130974,124),(130975,125),(130976,126),(130977,127),(130978,128),(130979,129),(130980,130),(130981,131),(130982,132),(130983,133),(130984,134),(130985,135),(130986,136),(130987,137),(130988,138),(130989,139),(130990,140),(130991,141),(130992,142),(130993,143),(130994,144),(130995,145),(130996,146),(130997,147),(130998,148),(130999,149),(131000,150),(131001,151),(131002,152),(131003,153),(131004,154),(131005,155),(131006,156),(131007,157),(131008,158),(131009,159),(131010,160),(131011,161),(131012,162),(131013,163),(131014,164),(131015,165),(131016,166),(131017,167),(131018,168),(131019,169),(131020,170),(131021,171),(131022,172),(131023,173),(131024,174),(131025,175),(131026,176),(131027,177),(131028,178),(131029,179),(131030,180),(131031,181),(131032,182),(131033,183),(131034,184),(131035,185),(131036,186),(131037,187),(131038,188),(131039,189),(131040,190),(131041,191),(131042,192),(131043,193),(131044,194),(131045,195),(131046,196),(131047,197),(131048,198),(131049,199),(131050,200),(131051,201),(131052,202),(131053,203),(131054,204),(131055,205),(131056,206),(131057,207),(131058,208),(131059,209),(131060,210),(131061,211),(131062,212),(131063,213),(131064,214),(131065,215),(131066,216),(131067,217),(131068,218),(131069,219),(131070,220),(131071,221),(131072,222),(131073,223),(131074,224),(131075,225),(131076,226),(131077,227),(131078,228),(131079,229),(131080,230),(131081,231),(131082,232),(131083,233),(131084,234),(131085,235),(131086,236),(131087,237),(131088,238),(131089,239),(131090,240),(131091,241),(131092,242),(131093,243),(131094,244),(131095,245),(131096,246),(131097,247),(131098,248),(131099,249),(131100,250),(131101,251),(131102,252),(131103,253),(131104,254),(131105,255),(131106,256),(131107,257),(131108,258),(131109,259),(131110,260),(131111,261),(131112,262),(131113,263),(131114,264),(131115,265),(131116,266),(131117,267),(131118,268),(131119,269),(131120,270),(131121,271),(131122,272),(131123,273),(131124,274),(131125,275),(131126,276),(131127,277),(131128,278),(131129,279),(131130,280),(131131,281),(131132,282),(131133,283),(131134,284),(131135,285),(131136,286),(131137,287),(131138,288),(131139,289),(131140,290),(131141,291),(131142,292),(131143,293),(131144,294),(131145,295),(131146,296),(131147,297),(131148,298),(131149,299),(131150,300),(131151,301),(131152,302),(131153,303),(131154,304),(131155,305),(131156,306),(131157,307),(131158,308),(131159,309),(131160,310),(131161,311),(131162,312),(131163,313),(131164,314),(131165,315),(131166,316),(131167,317),(131168,318),(131169,319),(131170,320),(131171,321),(131172,322),(131173,323),(131174,324),(131175,325),(131176,326),(131177,327),(131178,328),(131179,329),(131180,330),(131181,331),(131182,332),(131183,333),(131184,334),(131185,335),(131186,336),(131187,337),(131188,338),(131189,339),(131190,340),(131191,341),(131192,342),(131193,343),(131194,344),(131195,345),(131196,346),(131197,347),(131198,348),(131199,349),(131200,350),(131201,351),(131202,352),(131203,353),(131204,354),(131205,355),(131206,356),(131207,357),(131208,358),(131209,359),(131210,360),(131211,361),(131212,362),(131213,363),(131214,364),(131215,365),(131216,366),(131217,367),(131218,368),(131219,369),(131220,370),(131221,371),(131222,372),(131223,373),(131224,374),(131225,375),(131226,376),(131227,377),(131228,378),(131229,379),(131230,380),(131231,381),(131232,382),(131233,383),(131234,384),(131235,385),(131236,386),(131237,387),(131238,388),(131239,389),(131240,390),(131241,391),(131242,392),(131243,393),(131244,394),(131245,395),(131246,396),(131247,397),(131248,398),(131249,399),(131250,400),(131251,401),(131252,402),(131253,403),(131254,404),(131255,405),(131256,406),(131257,407),(131258,408),(131259,409),(131260,410),(131261,411),(131262,412),(131263,413),(131264,414),(131265,415),(131266,416),(131267,417),(131268,418),(131269,419),(131270,420),(131271,421),(131272,422),(131273,423),(131274,424),(131275,425),(131276,426),(131277,427),(131278,428),(131279,429),(131280,430),(131281,431),(131282,432),(131283,433),(131284,434),(131285,435),(131286,436),(131287,437),(131288,438),(131289,439),(131290,440),(131291,441),(131292,442),(131293,443),(131294,444),(131295,445),(131296,446),(131297,447),(131298,448),(131299,449),(131300,450),(131301,451),(131302,452),(131303,453),(131304,454),(131305,455),(131306,456),(131307,457),(131308,458),(131309,459),(131310,460),(131311,461),(131312,462),(131313,463),(131314,464),(131315,465),(131316,466),(131317,467),(131318,468),(131319,469),(131320,470),(131321,471),(131322,472),(131323,473),(131324,474),(131325,475),(131326,476),(131327,477),(131328,478),(131329,479),(131330,480),(131331,481),(131332,482),(131333,483),(131334,484),(131335,485),(131336,486),(131337,487),(131338,488),(131339,489),(131340,490),(131341,491),(131342,492),(131343,493),(131344,494),(131345,495),(131346,496),(131347,497),(131348,498),(131349,499),(131350,500),(131351,501),(131352,502),(131353,503),(131354,504),(131355,505),(131356,506),(131357,507),(131358,508),(131359,509),(131360,510),(131361,511),(131362,512),(131363,513),(131364,514),(131365,515),(131366,516),(131367,517),(131368,518),(131369,519),(131370,520),(131371,521),(131372,522),(131373,523),(131374,524),(131375,525),(131376,526),(131377,527),(131378,528),(131379,529),(131380,530),(131381,531),(131382,532),(131383,533),(131384,534),(131385,535),(131386,536),(131387,537),(131388,538),(131389,539),(131390,540),(131391,541),(131392,542),(131393,543),(131394,544),(131395,545),(131396,546),(131397,547),(131398,548),(131399,549),(131400,550),(131401,551),(131402,552),(131403,553),(131404,554),(131405,555),(131406,556),(131407,557),(131408,558),(131409,559),(131410,560),(131411,561),(131412,562),(131413,563),(131414,564),(131415,565),(131416,566),(131417,567),(131418,568),(131419,569),(131420,570),(131421,571),(131422,572),(131423,573),(131424,574),(131425,575),(131426,576),(131427,577),(131428,578),(131429,579),(131430,580),(131431,581),(131432,582),(131433,583),(131434,584),(131435,585),(131436,586),(131437,587),(131438,588),(131439,589),(131440,590),(131441,591),(131442,592),(131443,593),(131444,594),(131445,595),(131446,596),(131447,597),(131448,598),(131449,599),(131450,600),(131451,601),(131452,602),(131453,603),(131454,604),(131455,605),(131456,606),(131457,607),(131458,608),(131459,609),(131460,610),(131461,611),(131462,612),(131463,613),(131464,614),(131465,615),(131466,616),(131467,617),(131468,618),(131469,619),(131470,620),(131471,621),(131472,622),(131473,623),(131474,624),(131475,625),(131476,626),(131477,627),(131478,628),(131479,629),(131480,630),(131481,631),(131482,632),(131483,633),(131484,634),(131485,635),(131486,636),(131487,637),(131488,638),(131489,639),(131490,640),(131491,641),(131492,642),(131493,643),(131494,644),(131495,645),(131496,646),(131497,647),(131498,648),(131499,649),(131500,650),(131501,651),(131502,652),(131503,653),(131504,654),(131505,655),(131506,656),(131507,657),(131508,658),(131509,659),(131510,660),(131511,661),(131512,662),(131513,663),(131514,664),(131515,665),(131516,666),(131517,667),(131518,668),(131519,669),(131520,670),(131521,671),(131522,672),(131523,673),(131524,674),(131525,675),(131526,676),(131527,677),(131528,678),(131529,679),(131530,680),(131531,681),(131532,682),(131533,683),(131534,684),(131535,685),(131536,686),(131537,687),(131538,688),(131539,689),(131540,690),(131541,691),(131542,692),(131543,693),(131544,694),(131545,695),(131546,696),(131547,697),(131548,698),(131549,699),(131550,700),(131551,701),(131552,702),(131553,703),(131554,704),(131555,705),(131556,706),(131557,707),(131558,708),(131559,709),(131560,710),(131561,711),(131562,712),(131563,713),(131564,714),(131565,715),(131566,716),(131567,717),(131568,718),(131569,719),(131570,720),(131571,721),(131572,722),(131573,723),(131574,724),(131575,725),(131576,726),(131577,727),(131578,728),(131579,729),(131580,730),(131581,731),(131582,732),(131583,733),(131584,734),(131585,735),(131586,736),(131587,737),(131588,738),(131589,739),(131590,740),(131591,741),(131592,742),(131593,743),(131594,744),(131595,745),(131596,746),(131597,747),(131598,748),(131599,749),(131600,750),(131601,751),(131602,752),(131603,753),(131604,754),(131605,755),(131606,756),(131607,757),(131608,758),(131609,759),(131610,760),(131611,761),(131612,762),(131613,763),(131614,764),(131615,765),(131616,766),(131617,767),(131618,768),(131619,769),(131620,770),(131621,771),(131622,772),(131623,773),(131624,774),(131625,775),(131626,776),(131627,777),(131628,778),(131629,779),(131630,780),(131631,781),(131632,782),(131633,783),(131634,784),(131635,785),(131636,786),(131637,787),(131638,788),(131639,789),(131640,790),(131641,791),(131642,792),(131643,793),(131644,794),(131645,795),(131646,796),(131647,797),(131648,798),(131649,799),(131650,800),(131651,801),(131652,802),(131653,803),(131654,804),(131655,805),(131656,806),(131657,807),(131658,808),(131659,809),(131660,810),(131661,811),(131662,812),(131663,813),(131664,814),(131665,815),(131666,816),(131667,817),(131668,818),(131669,819),(131670,820),(131671,821),(131672,822),(131673,823),(131674,824),(131675,825),(131676,826),(131677,827),(131678,828),(131679,829),(131680,830),(131681,831),(131682,832),(131683,833),(131684,834),(131685,835),(131686,836),(131687,837),(131688,838),(131689,839),(131690,840),(131691,841),(131692,842),(131693,843),(131694,844),(131695,845),(131696,846),(131697,847),(131698,848),(131699,849),(131700,850),(131701,851),(131702,852),(131703,853),(131704,854),(131705,855),(131706,856),(131707,857),(131708,858),(131709,859),(131710,860),(131711,861),(131712,862),(131713,863),(131714,864),(131715,865),(131716,866),(131717,867),(131718,868),(131719,869),(131720,870),(131721,871),(131722,872),(131723,873),(131724,874),(131725,875),(131726,876),(131727,877),(131728,878),(131729,879),(131730,880),(131731,881),(131732,882),(131733,883),(131734,884),(131735,885),(131736,886),(131737,887),(131738,888),(131739,889),(131740,890),(131741,891),(131742,892),(131743,893),(131744,894),(131745,895),(131746,896),(131747,897),(131748,898),(131749,899),(131750,900),(131751,901),(131752,902),(131753,903),(131754,904),(131755,905),(131756,906),(131757,907),(131758,908),(131759,909),(131760,910),(131761,911),(131762,912),(131763,913),(131764,914),(131765,915),(131766,916),(131767,917),(131768,918),(131769,919),(131770,920),(131771,921),(131772,922),(131773,923),(131774,924),(131775,925),(131776,926),(131777,927),(131778,928),(131779,929),(131780,930),(131781,931),(131782,932),(131783,933),(131784,934),(131785,935),(131786,936),(131787,937),(131788,938),(131789,939),(131790,940),(131791,941),(131792,942),(131793,943),(131794,944),(131795,945),(131796,946),(131797,947),(131798,948),(131799,949),(131800,950),(131801,951),(131802,952),(131803,953),(131804,954),(131805,955),(131806,956),(131807,957),(131808,958),(131809,959),(131810,960),(131811,961),(131812,962),(131813,963),(131814,964),(131815,965),(131816,966),(131817,967),(131818,968),(131819,969),(131820,970),(131821,971),(131822,972),(131823,973),(131824,974),(131825,975),(131826,976),(131827,977),(131828,978),(131829,979),(131830,980),(131831,981),(131832,982),(131833,983),(131834,984),(131835,985),(131836,986),(131837,987),(131838,988),(131839,989),(131840,990),(131841,991),(131842,992),(131843,993),(131844,994),(131845,995),(131846,996),(131847,997),(131848,998),(131849,999),(131850,1000),(131851,1001),(131852,1002),(131853,1003),(131854,1004),(131855,1005),(131856,1006),(131857,1007),(131858,1008),(131859,1009),(131860,1010),(131861,1011),(131862,1012),(131863,1013),(131864,1014),(131865,1015),(131866,1016),(131867,1017),(131868,1018),(131869,1019),(131870,1020),(131871,1021),(131872,1022),(131873,1023),(131874,1024),(131875,1025),(131876,1026),(131877,1027),(131878,1028),(131879,1029),(131880,1030),(131881,1031),(131882,1032),(131883,1033),(131884,1034),(131885,1035),(131886,1036),(131887,1037),(131888,1038),(131889,1039),(131890,1040),(131891,1041),(131892,1042),(131893,1043),(131894,1044),(131895,1045),(131896,1046),(131897,1047),(131898,1048),(131899,1049),(131900,1050),(131901,1051),(131902,1052),(131903,1053),(131904,1054),(131905,1055),(131906,1056),(131907,1057),(131908,1058),(131909,1059),(131910,1060),(131911,1061),(131912,1062),(131913,1063),(131914,1064),(131915,1065),(131916,1066),(131917,1067),(131918,1068),(131919,1069),(131920,1070),(131921,1071),(131922,1072),(131923,1073),(131924,1074),(131925,1075),(131926,1076),(131927,1077),(131928,1078),(131929,1079),(131930,1080),(131931,1081),(131932,1082),(131933,1083),(131934,1084),(131935,1085),(131936,1086),(131937,1087),(131938,1088),(131939,1089),(131940,1090),(131941,1091),(131942,1092),(131943,1093),(131944,1094),(131945,1095),(131946,1096),(131947,1097),(131948,1098),(131949,1099),(131950,1100),(131951,1101),(131952,1102),(131953,1103),(131954,1104),(131955,1105),(131956,1106),(131957,1107),(131958,1108),(131959,1109),(131960,1110),(131961,1111),(131962,1112),(131963,1113),(131964,1114),(131965,1115),(131966,1116),(131967,1117),(131968,1118),(131969,1119),(131970,1120),(131971,1121),(131972,1122),(131973,1123),(131974,1124),(131975,1125),(131976,1126),(131977,1127),(131978,1128),(131979,1129),(131980,1130),(131981,1131),(131982,1132),(131983,1133),(131984,1134),(131985,1135),(131986,1136),(131987,1137),(131988,1138),(131989,1139),(131990,1140),(131991,1141),(131992,1142),(131993,1143),(131994,1144),(131995,1145),(131996,1146),(131997,1147),(131998,1148),(131999,1149),(132000,1150),(132001,1151),(132002,1152),(132003,1153),(132004,1154),(132005,1155),(132006,1156),(132007,1157),(132008,1158),(132009,1159),(132010,1160),(132011,1161),(132012,1162),(132013,1163),(132014,1164),(132015,1165),(132016,1166),(132017,1167),(132018,1168),(132019,1169),(132020,1170),(132021,1171),(132022,1172),(132023,1173),(132024,1174),(132025,1175),(132026,1176),(132027,1177),(132028,1178),(132029,1179),(132030,1180),(132031,1181),(132032,1182),(132033,1183),(132034,1184),(132035,1185),(132036,1186),(132037,1187),(132038,1188),(132039,1189),(132040,1190),(132041,1191),(132042,1192),(132043,1193),(132044,1194),(132045,1195),(132046,1196),(132047,1197),(132048,1198),(132049,1199),(132050,1200),(132051,1201),(132052,1202),(132053,1203),(132054,1204),(132055,1205),(132056,1206),(132057,1207),(132058,1208),(132059,1209),(132060,1210),(132061,1211),(132062,1212),(132063,1213),(132064,1214),(132065,1215),(132066,1216),(132067,1217),(132068,1218),(132069,1219),(132070,1220),(132071,1221),(132072,1222),(132073,1223),(132074,1224),(132075,1225),(132076,1226),(132077,1227),(132078,1228),(132079,1229),(132080,1230),(132081,1231),(132082,1232),(132083,1233),(132084,1234),(132085,1235),(132086,1236),(132087,1237),(132088,1238),(132089,1239),(132090,1240),(132091,1241),(132092,1242),(132093,1243),(132094,1244),(132095,1245),(132096,1246),(132097,1247),(132098,1248),(132099,1249),(132100,1250),(132101,1251),(132102,1252),(132103,1253),(132104,1254),(132105,1255),(132106,1256),(132107,1257),(132108,1258),(132109,1259),(132110,1260),(132111,1261),(132112,1262),(132113,1263),(132114,1264),(132115,1265),(132116,1266),(132117,1267),(132118,1268),(132119,1269),(132120,1270),(132121,1271),(132122,1272),(132123,1273),(132124,1274),(132125,1275),(132126,1276),(132127,1277),(132128,1278),(132129,1279),(132130,1280),(132131,1281),(132132,1282),(132133,1283),(132134,1284),(132135,1285),(132136,1286),(132137,1287),(132138,1288),(132139,1289),(132140,1290),(132141,1291),(132142,1292),(132143,1293),(132144,1294),(132145,1295),(132146,1296),(132147,1297),(132148,1298),(132149,1299),(132150,1300),(132151,1301),(132152,1302),(132153,1303),(132154,1304),(132155,1305),(132156,1306),(132157,1307),(132158,1308),(132159,1309),(132160,1310),(132161,1311),(132162,1312),(132163,1313),(132164,1314),(132165,1315),(132166,1316),(132167,1317),(132168,1318),(132169,1319),(132170,1320),(132171,1321),(132172,1322),(132173,1323),(132174,1324),(132175,1325),(132176,1326),(132177,1327),(132178,1328),(132179,1329),(132180,1330),(132181,1331),(132182,1332),(132183,1333),(132184,1334),(132185,1335),(132186,1336),(132187,1337),(132188,1338),(132189,1339),(132190,1340),(132191,1341),(132192,1342),(132193,1343),(132194,1344),(132195,1345),(132196,1346),(132197,1347),(132198,1348),(132199,1349),(132200,1350),(132201,1351),(132202,1352),(132203,1353),(132204,1354),(132205,1355),(132206,1356),(132207,1357),(132208,1358),(132209,1359),(132210,1360),(132211,1361),(132212,1362),(132213,1363),(132214,1364),(132215,1365),(132216,1366),(132217,1367),(132218,1368),(132219,1369),(132220,1370),(132221,1371),(132222,1372),(132223,1373),(132224,1374),(132225,1375),(132226,1376),(132227,1377),(132228,1378),(132229,1379),(132230,1380),(132231,1381),(132232,1382),(132233,1383),(132234,1384),(132235,1385),(132236,1386),(132237,1387),(132238,1388),(132239,1389),(132240,1390),(132241,1391),(132242,1392),(132243,1393),(132244,1394),(132245,1395),(132246,1396),(132247,1397),(132248,1398),(132249,1399),(132250,1400),(132251,1401),(132252,1402),(132253,1403),(132254,1404),(132255,1405),(132256,1406),(132257,1407),(132258,1408),(132259,1409),(132260,1410),(132261,1411),(132262,1412),(132263,1413),(132264,1414),(132265,1415),(132266,1416),(132267,1417),(132268,1418),(132269,1419),(132270,1420),(132271,1421),(132272,1422),(132273,1423),(132274,1424),(132275,1425),(132276,1426),(132277,1427),(132278,1428),(132279,1429),(132280,1430),(132281,1431),(132282,1432),(132283,1433),(132284,1434),(132285,1435),(132286,1436),(132287,1437),(132288,1438),(132289,1439),(132290,1440),(132291,1441),(132292,1442),(132293,1443),(132294,1444),(132295,1445),(132296,1446),(132297,1447),(132298,1448),(132299,1449),(132300,1450),(132301,1451),(132302,1452),(132303,1453),(132304,1454),(132305,1455),(132306,1456),(132307,1457),(132308,1458),(132309,1459),(132310,1460),(132311,1461),(132312,1462),(132313,1463),(132314,1464),(132315,1465),(132316,1466),(132317,1467),(132318,1468),(132319,1469),(132320,1470),(132321,1471),(132322,1472),(132323,1473),(132324,1474),(132325,1475),(132326,1476),(132327,1477),(132328,1478),(132329,1479),(132330,1480),(132331,1481),(132332,1482),(132333,1483),(132334,1484),(132335,1485),(132336,1486),(132337,1487),(132338,1488),(132339,1489),(132340,1490),(132341,1491),(132342,1492),(132343,1493),(132344,1494),(132345,1495),(132346,1496),(132347,1497),(132348,1498),(132349,1499),(132350,1500),(132351,1501),(132352,1502),(132353,1503),(132354,1504),(132355,1505),(132356,1506),(132357,1507),(132358,1508),(132359,1509),(132360,1510),(132361,1511),(132362,1512),(132363,1513),(132364,1514),(132365,1515),(132366,1516),(132367,1517),(132368,1518),(132369,1519),(132370,1520),(132371,1521),(132372,1522),(132373,1523),(132374,1524),(132375,1525),(132376,1526),(132377,1527),(132378,1528),(132379,1529),(132380,1530),(132381,1531),(132382,1532),(132383,1533),(132384,1534),(132385,1535),(132386,1536),(132387,1537),(132388,1538),(132389,1539),(132390,1540),(132391,1541),(132392,1542),(132393,1543),(132394,1544),(132395,1545),(132396,1546),(132397,1547),(132398,1548),(132399,1549),(132400,1550),(132401,1551),(132402,1552),(132403,1553),(132404,1554),(132405,1555),(132406,1556),(132407,1557),(132408,1558),(132409,1559),(132410,1560),(132411,1561),(132412,1562),(132413,1563),(132414,1564),(132415,1565),(132416,1566),(132417,1567),(132418,1568),(132419,1569),(132420,1570),(132421,1571),(132422,1572),(132423,1573),(132424,1574),(132425,1575),(132426,1576),(132427,1577),(132428,1578),(132429,1579),(132430,1580),(132431,1581),(132432,1582),(132433,1583),(132434,1584),(132435,1585),(132436,1586),(132437,1587),(132438,1588),(132439,1589),(132440,1590),(132441,1591),(132442,1592),(132443,1593),(132444,1594),(132445,1595),(132446,1596),(132447,1597),(132448,1598),(132449,1599),(132450,1600),(132451,1601),(132452,1602),(132453,1603),(132454,1604),(132455,1605),(132456,1606),(132457,1607),(132458,1608),(132459,1609),(132460,1610),(132461,1611),(132462,1612),(132463,1613),(132464,1614),(132465,1615),(132466,1616),(132467,1617),(132468,1618),(132469,1619),(132470,1620),(132471,1621),(132472,1622),(132473,1623),(132474,1624),(132475,1625),(132476,1626),(132477,1627),(132478,1628),(132479,1629),(132480,1630),(132481,1631),(132482,1632),(132483,1633),(132484,1634),(132485,1635),(132486,1636),(132487,1637),(132488,1638),(132489,1639),(132490,1640),(132491,1641),(132492,1642),(132493,1643),(132494,1644),(132495,1645),(132496,1646),(132497,1647),(132498,1648),(132499,1649),(132500,1650),(132501,1651),(132502,1652),(132503,1653),(132504,1654),(132505,1655),(132506,1656),(132507,1657),(132508,1658),(132509,1659),(132510,1660),(132511,1661),(132512,1662),(132513,1663),(132514,1664),(132515,1665),(132516,1666),(132517,1667),(132518,1668),(132519,1669),(132520,1670),(132521,1671),(132522,1672),(132523,1673),(132524,1674),(132525,1675),(132526,1676),(132527,1677),(132528,1678),(132529,1679),(132530,1680),(132531,1681),(132532,1682),(132533,1683),(132534,1684),(132535,1685),(132536,1686),(132537,1687),(132538,1688),(132539,1689),(132540,1690),(132541,1691),(132542,1692),(132543,1693),(132544,1694),(132545,1695),(132546,1696),(132547,1697),(132548,1698),(132549,1699),(132550,1700),(132551,1701),(132552,1702),(132553,1703),(132554,1704),(132555,1705),(132556,1706),(132557,1707),(132558,1708),(132559,1709),(132560,1710),(132561,1711),(132562,1712),(132563,1713),(132564,1714),(132565,1715),(132566,1716),(132567,1717),(132568,1718),(132569,1719),(132570,1720),(132571,1721),(132572,1722),(132573,1723),(132574,1724),(132575,1725),(132576,1726),(132577,1727),(132578,1728),(132579,1729),(132580,1730),(132581,1731),(132582,1732),(132583,1733),(132584,1734),(132585,1735),(132586,1736),(132587,1737),(132588,1738),(132589,1739),(132590,1740),(132591,1741),(132592,1742),(132593,1743),(132594,1744),(132595,1745),(132596,1746),(132597,1747),(132598,1748),(132599,1749),(132600,1750),(132601,1751),(132602,1752),(132603,1753),(132604,1754),(132605,1755),(132606,1756),(132607,1757),(132608,1758),(132609,1759),(132610,1760),(132611,1761),(132612,1762),(132613,1763),(132614,1764),(132615,1765),(132616,1766),(132617,1767),(132618,1768),(132619,1769),(132620,1770),(132621,1771),(132622,1772),(132623,1773),(132624,1774),(132625,1775),(132626,1776),(132627,1777),(132628,1778),(132629,1779),(132630,1780),(132631,1781),(132632,1782),(132633,1783),(132634,1784),(132635,1785),(132636,1786),(132637,1787),(132638,1788),(132639,1789),(132640,1790),(132641,1791),(132642,1792),(132643,1793),(132644,1794),(132645,1795),(132646,1796),(132647,1797),(132648,1798),(132649,1799),(132650,1800),(132651,1801),(132652,1802),(132653,1803),(132654,1804),(132655,1805),(132656,1806),(132657,1807),(132658,1808),(132659,1809),(132660,1810),(132661,1811),(132662,1812),(132663,1813),(132664,1814),(132665,1815),(132666,1816),(132667,1817),(132668,1818),(132669,1819),(132670,1820),(132671,1821),(132672,1822),(132673,1823),(132674,1824),(132675,1825),(132676,1826),(132677,1827),(132678,1828),(132679,1829),(132680,1830),(132681,1831),(132682,1832),(132683,1833),(132684,1834),(132685,1835),(132686,1836),(132687,1837),(132688,1838),(132689,1839),(132690,1840),(132691,1841),(132692,1842),(132693,1843),(132694,1844),(132695,1845),(132696,1846),(132697,1847),(132698,1848),(132699,1849),(132700,1850),(132701,1851),(132702,1852),(132703,1853),(132704,1854),(132705,1855),(132706,1856),(132707,1857),(132708,1858),(132709,1859),(132710,1860),(132711,1861),(132712,1862),(132713,1863),(132714,1864),(132715,1865),(132716,1866),(132717,1867),(132718,1868),(132719,1869),(132720,1870),(132721,1871),(132722,1872),(132723,1873),(132724,1874),(132725,1875),(132726,1876),(132727,1877),(132728,1878),(132729,1879),(132730,1880),(132731,1881),(132732,1882),(132733,1883),(132734,1884),(132735,1885),(132736,1886),(132737,1887),(132738,1888),(132739,1889),(132740,1890),(132741,1891),(132742,1892),(132743,1893),(132744,1894),(132745,1895),(132746,1896),(132747,1897),(132748,1898),(132749,1899),(132750,1900),(132751,1901),(132752,1902),(132753,1903),(132754,1904),(132755,1905),(132756,1906),(132757,1907),(132758,1908),(132759,1909),(132760,1910),(132761,1911),(132762,1912),(132763,1913),(132764,1914),(132765,1915),(132766,1916),(132767,1917),(132768,1918),(132769,1919),(132770,1920),(132771,1921),(132772,1922),(132773,1923),(132774,1924),(132775,1925),(132776,1926),(132777,1927),(132778,1928),(132779,1929),(132780,1930),(132781,1931),(132782,1932),(132783,1933),(132784,1934),(132785,1935),(132786,1936),(132787,1937),(132788,1938),(132789,1939),(132790,1940),(132791,1941),(132792,1942),(132793,1943),(132794,1944),(132795,1945),(132796,1946),(132797,1947),(132798,1948),(132799,1949),(132800,1950),(132801,1951),(132802,1952),(132803,1953),(132804,1954),(132805,1955),(132806,1956),(132807,1957),(132808,1958),(132809,1959),(132810,1960),(132811,1961),(132812,1962),(132813,1963),(132814,1964),(132815,1965),(132816,1966),(132817,1967),(132818,1968),(132819,1969),(132820,1970),(132821,1971),(132822,1972),(132823,1973),(132824,1974),(132825,1975),(132826,1976),(132827,1977),(132828,1978),(132829,1979),(132830,1980),(132831,1981),(132832,1982),(132833,1983),(132834,1984),(132835,1985),(132836,1986),(132837,1987),(132838,1988),(132839,1989),(132840,1990),(132841,1991),(132842,1992),(132843,1993),(132844,1994),(132845,1995),(132846,1996),(132847,1997),(132848,1998),(132849,1999),(132850,2000),(132851,2001),(132852,2002),(132853,2003),(132854,2004),(132855,2005),(132856,2006),(132857,2007),(132858,2008),(132859,2009),(132860,2010),(132861,2011),(132862,2012),(132863,2013),(132864,2014),(132865,2015),(132866,2016),(132867,2017),(132868,2018),(132869,2019),(132870,2020),(132871,2021),(132872,2022),(132873,2023),(132874,2024),(132875,2025),(132876,2026),(132877,2027),(132878,2028),(132879,2029),(132880,2030),(132881,2031),(132882,2032),(132883,2033),(132884,2034),(132885,2035),(132886,2036),(132887,2037),(132888,2038),(132889,2039),(132890,2040),(132891,2041),(132892,2042),(132893,2043),(132894,2044),(132895,2045),(132896,2046),(132897,2047),(132898,2048),(132899,2049),(132900,2050),(132901,2051),(132902,2052),(132903,2053),(132904,2054),(132905,2055),(132906,2056),(132907,2057),(132908,2058),(132909,2059),(132910,2060),(132911,2061),(132912,2062),(132913,2063),(132914,2064),(132915,2065),(132916,2066),(132917,2067),(132918,2068),(132919,2069),(132920,2070),(132921,2071),(132922,2072),(132923,2073),(132924,2074),(132925,2075),(132926,2076),(132927,2077),(132928,2078),(132929,2079),(132930,2080),(132931,2081),(132932,2082),(132933,2083),(132934,2084),(132935,2085),(132936,2086),(132937,2087),(132938,2088),(132939,2089),(132940,2090),(132941,2091),(132942,2092),(132943,2093),(132944,2094),(132945,2095),(132946,2096),(132947,2097),(132948,2098),(132949,2099),(132950,2100),(132951,2101),(132952,2102),(132953,2103),(132954,2104),(132955,2105),(132956,2106),(132957,2107),(132958,2108),(132959,2109),(132960,2110),(132961,2111),(132962,2112),(132963,2113),(132964,2114),(132965,2115),(132966,2116),(132967,2117),(132968,2118),(132969,2119),(132970,2120),(132971,2121),(132972,2122),(132973,2123),(132974,2124),(132975,2125),(132976,2126),(132977,2127),(132978,2128),(132979,2129),(132980,2130),(132981,2131),(132982,2132),(132983,2133),(132984,2134),(132985,2135),(132986,2136),(132987,2137),(132988,2138),(132989,2139),(132990,2140),(132991,2141),(132992,2142),(132993,2143),(132994,2144),(132995,2145),(132996,2146),(132997,2147),(132998,2148),(132999,2149),(133000,2150),(133001,2151),(133002,2152),(133003,2153),(133004,2154),(133005,2155),(133006,2156),(133007,2157),(133008,2158),(133009,2159),(133010,2160),(133011,2161),(133012,2162),(133013,2163),(133014,2164),(133015,2165),(133016,2166),(133017,2167),(133018,2168),(133019,2169),(133020,2170),(133021,2171),(133022,2172),(133023,2173),(133024,2174),(133025,2175),(133026,2176),(133027,2177),(133028,2178),(133029,2179),(133030,2180),(133031,2181),(133032,2182),(133033,2183),(133034,2184),(133035,2185),(133036,2186),(133037,2187),(133038,2188),(133039,2189),(133040,2190),(133041,2191),(133042,2192),(133043,2193),(133044,2194),(133045,2195),(133046,2196),(133047,2197),(133048,2198),(133049,2199),(133050,2200),(133051,2201),(133052,2202),(133053,2203),(133054,2204),(133055,2205),(133056,2206),(133057,2207),(133058,2208),(133059,2209),(133060,2210),(133061,2211),(133062,2212),(133063,2213),(133064,2214),(133065,2215),(133066,2216),(133067,2217),(133068,2218),(133069,2219),(133070,2220),(133071,2221),(133072,2222),(133073,2223),(133074,2224),(133075,2225),(133076,2226),(133077,2227),(133078,2228),(133079,2229),(133080,2230),(133081,2231),(133082,2232),(133083,2233),(133084,2234),(133085,2235),(133086,2236),(133087,2237),(133088,2238),(133089,2239),(133090,2240),(133091,2241),(133092,2242),(133093,2243),(133094,2244),(133095,2245),(133096,2246),(133097,2247),(133098,2248),(133099,2249),(133100,2250),(133101,2251),(133102,2252),(133103,2253),(133104,2254),(133105,2255),(133106,2256),(133107,2257),(133108,2258),(133109,2259),(133110,2260),(133111,2261),(133112,2262),(133113,2263),(133114,2264),(133115,2265),(133116,2266),(133117,2267),(133118,2268),(133119,2269),(133120,2270),(133121,2271),(133122,2272),(133123,2273),(133124,2274),(133125,2275),(133126,2276),(133127,2277),(133128,2278),(133129,2279),(133130,2280),(133131,2281),(133132,2282),(133133,2283),(133134,2284),(133135,2285),(133136,2286),(133137,2287),(133138,2288),(133139,2289),(133140,2290),(133141,2291),(133142,2292),(133143,2293),(133144,2294),(133145,2295),(133146,2296),(133147,2297),(133148,2298),(133149,2299),(133150,2300),(133151,2301),(133152,2302),(133153,2303),(133154,2304),(133155,2305),(133156,2306),(133157,2307),(133158,2308),(133159,2309),(133160,2310),(133161,2311),(133162,2312),(133163,2313),(133164,2314),(133165,2315),(133166,2316),(133167,2317),(133168,2318),(133169,2319),(133170,2320),(133171,2321),(133172,2322),(133173,2323),(133174,2324),(133175,2325),(133176,2326),(133177,2327),(133178,2328),(133179,2329),(133180,2330),(133181,2331),(133182,2332),(133183,2333),(133184,2334),(133185,2335),(133186,2336),(133187,2337),(133188,2338),(133189,2339),(133190,2340),(133191,2341),(133192,2342),(133193,2343),(133194,2344),(133195,2345),(133196,2346),(133197,2347),(133198,2348),(133199,2349),(133200,2350),(133201,2351),(133202,2352),(133203,2353),(133204,2354),(133205,2355),(133206,2356),(133207,2357),(133208,2358),(133209,2359),(133210,2360),(133211,2361),(133212,2362),(133213,2363),(133214,2364),(133215,2365),(133216,2366),(133217,2367),(133218,2368),(133219,2369),(133220,2370),(133221,2371),(133222,2372),(133223,2373),(133224,2374),(133225,2375),(133226,2376),(133227,2377),(133228,2378),(133229,2379),(133230,2380),(133231,2381),(133232,2382),(133233,2383),(133234,2384),(133235,2385),(133236,2386),(133237,2387),(133238,2388),(133239,2389),(133240,2390),(133241,2391),(133242,2392),(133243,2393),(133244,2394),(133245,2395),(133246,2396),(133247,2397),(133248,2398),(133249,2399),(133250,2400),(133251,2401),(133252,2402),(133253,2403),(133254,2404),(133255,2405),(133256,2406),(133257,2407),(133258,2408),(133259,2409),(133260,2410),(133261,2411),(133262,2412),(133263,2413),(133264,2414),(133265,2415),(133266,2416),(133267,2417),(133268,2418),(133269,2419),(133270,2420),(133271,2421),(133272,2422),(133273,2423),(133274,2424),(133275,2425),(133276,2426),(133277,2427),(133278,2428),(133279,2429),(133280,2430),(133281,2431),(133282,2432),(133283,2433),(133284,2434),(133285,2435),(133286,2436),(133287,2437),(133288,2438),(133289,2439),(133290,2440),(133291,2441),(133292,2442),(133293,2443),(133294,2444),(133295,2445),(133296,2446),(133297,2447),(133298,2448),(133299,2449),(133300,2450),(133301,2451),(133302,2452),(133303,2453),(133304,2454),(133305,2455),(133306,2456),(133307,2457),(133308,2458),(133309,2459),(133310,2460),(133311,2461),(133312,2462),(133313,2463),(133314,2464),(133315,2465),(133316,2466),(133317,2467),(133318,2468),(133319,2469),(133320,2470),(133321,2471),(133322,2472),(133323,2473),(133324,2474),(133325,2475),(133326,2476),(133327,2477),(133328,2478),(133329,2479),(133330,2480),(133331,2481),(133332,2482),(133333,2483),(133334,2484),(133335,2485),(133336,2486),(133337,2487),(133338,2488),(133339,2489),(133340,2490),(133341,2491),(133342,2492),(133343,2493),(133344,2494),(133345,2495),(133346,2496),(133347,2497),(133348,2498),(133349,2499),(133350,2500),(133351,2501),(133352,2502),(133353,2503),(133354,2504),(133355,2505),(133356,2506),(133357,2507),(133358,2508),(133359,2509),(133360,2510),(133361,2511),(133362,2512),(133363,2513),(133364,2514),(133365,2515),(133366,2516),(133367,2517),(133368,2518),(133369,2519),(133370,2520),(133371,2521),(133372,2522),(133373,2523),(133374,2524),(133375,2525),(133376,2526),(133377,2527),(133378,2528),(133379,2529),(133380,2530),(133381,2531),(133382,2532),(133383,2533),(133384,2534),(133385,2535),(133386,2536),(133387,2537),(133388,2538),(133389,2539),(133390,2540),(133391,2541),(133392,2542),(133393,2543),(133394,2544),(133395,2545),(133396,2546),(133397,2547),(133398,2548),(133399,2549),(133400,2550),(133401,2551),(133402,2552),(133403,2553),(133404,2554),(133405,2555),(133406,2556),(133407,2557),(133408,2558),(133409,2559),(133410,2560),(133411,2561),(133412,2562),(133413,2563),(133414,2564),(133415,2565),(133416,2566),(133417,2567),(133418,2568),(133419,2569),(133420,2570),(133421,2571),(133422,2572),(133423,2573),(133424,2574),(133425,2575),(133426,2576),(133427,2577),(133428,2578),(133429,2579),(133430,2580),(133431,2581),(133432,2582),(133433,2583),(133434,2584),(133435,2585),(133436,2586),(133437,2587),(133438,2588),(133439,2589),(133440,2590),(133441,2591),(133442,2592),(133443,2593),(133444,2594),(133445,2595),(133446,2596),(133447,2597),(133448,2598),(133449,2599),(133450,2600),(133451,2601),(133452,2602),(133453,2603),(133454,2604),(133455,2605),(133456,2606),(133457,2607),(133458,2608),(133459,2609),(133460,2610),(133461,2611),(133462,2612),(133463,2613),(133464,2614),(133465,2615),(133466,2616),(133467,2617),(133468,2618),(133469,2619),(133470,2620),(133471,2621),(133472,2622),(133473,2623),(133474,2624),(133475,2625),(133476,2626),(133477,2627),(133478,2628),(133479,2629),(133480,2630),(133481,2631),(133482,2632),(133483,2633),(133484,2634),(133485,2635),(133486,2636),(133487,2637),(133488,2638),(133489,2639),(133490,2640),(133491,2641),(133492,2642),(133493,2643),(133494,2644),(133495,2645),(133496,2646),(133497,2647),(133498,2648),(133499,2649),(133500,2650),(133501,2651),(133502,2652),(133503,2653),(133504,2654),(133505,2655),(133506,2656),(133507,2657),(133508,2658),(133509,2659),(133510,2660),(133511,2661),(133512,2662),(133513,2663),(133514,2664),(133515,2665),(133516,2666),(133517,2667),(133518,2668),(133519,2669),(133520,2670),(133521,2671),(133522,2672),(133523,2673),(133524,2674),(133525,2675),(133526,2676),(133527,2677),(133528,2678),(133529,2679),(133530,2680),(133531,2681),(133532,2682),(133533,2683),(133534,2684),(133535,2685),(133536,2686),(133537,2687),(133538,2688),(133539,2689),(133540,2690),(133541,2691),(133542,2692),(133543,2693),(133544,2694),(133545,2695),(133546,2696),(133547,2697),(133548,2698),(133549,2699),(133550,2700),(133551,2701),(133552,2702),(133553,2703),(133554,2704),(133555,2705),(133556,2706),(133557,2707),(133558,2708),(133559,2709),(133560,2710),(133561,2711),(133562,2712),(133563,2713),(133564,2714),(133565,2715),(133566,2716),(133567,2717),(133568,2718),(133569,2719),(133570,2720),(133571,2721),(133572,2722),(133573,2723),(133574,2724),(133575,2725),(133576,2726),(133577,2727),(133578,2728),(133579,2729),(133580,2730),(133581,2731),(133582,2732),(133583,2733),(133584,2734),(133585,2735),(133586,2736),(133587,2737),(133588,2738),(133589,2739),(133590,2740),(133591,2741),(133592,2742),(133593,2743),(133594,2744),(133595,2745),(133596,2746),(133597,2747),(133598,2748),(133599,2749),(133600,2750),(133601,2751),(133602,2752),(133603,2753),(133604,2754),(133605,2755),(133606,2756),(133607,2757),(133608,2758),(133609,2759),(133610,2760),(133611,2761),(133612,2762),(133613,2763),(133614,2764),(133615,2765),(133616,2766),(133617,2767),(133618,2768),(133619,2769),(133620,2770),(133621,2771),(133622,2772),(133623,2773),(133624,2774),(133625,2775),(133626,2776),(133627,2777),(133628,2778),(133629,2779),(133630,2780),(133631,2781),(133632,2782),(133633,2783),(133634,2784),(133635,2785),(133636,2786),(133637,2787),(133638,2788),(133639,2789),(133640,2790),(133641,2791),(133642,2792),(133643,2793),(133644,2794),(133645,2795),(133646,2796),(133647,2797),(133648,2798),(133649,2799),(133650,2800),(133651,2801),(133652,2802),(133653,2803),(133654,2804),(133655,2805),(133656,2806),(133657,2807),(133658,2808),(133659,2809),(133660,2810),(133661,2811),(133662,2812),(133663,2813),(133664,2814),(133665,2815),(133666,2816),(133667,2817),(133668,2818),(133669,2819),(133670,2820),(133671,2821),(133672,2822),(133673,2823),(133674,2824),(133675,2825),(133676,2826),(133677,2827),(133678,2828),(133679,2829),(133680,2830),(133681,2831),(133682,2832),(133683,2833),(133684,2834),(133685,2835),(133686,2836),(133687,2837),(133688,2838),(133689,2839),(133690,2840),(133691,2841),(133692,2842),(133693,2843),(133694,2844),(133695,2845),(133696,2846),(133697,2847),(133698,2848),(133699,2849),(133700,2850),(133701,2851),(133702,2852),(133703,2853),(133704,2854),(133705,2855),(133706,2856),(133707,2857),(133708,2858),(133709,2859),(133710,2860),(133711,2861),(133712,2862),(133713,2863),(133714,2864),(133715,2865),(133716,2866),(133717,2867),(133718,2868),(133719,2869),(133720,2870),(133721,2871),(133722,2872),(133723,2873),(133724,2874),(133725,2875),(133726,2876),(133727,2877),(133728,2878),(133729,2879),(133730,2880),(133731,2881),(133732,2882),(133733,2883),(133734,2884),(133735,2885),(133736,2886),(133737,2887),(133738,2888),(133739,2889),(133740,2890),(133741,2891),(133742,2892),(133743,2893),(133744,2894),(133745,2895),(133746,2896),(133747,2897),(133748,2898),(133749,2899),(133750,2900),(133751,2901),(133752,2902),(133753,2903),(133754,2904),(133755,2905),(133756,2906),(133757,2907),(133758,2908),(133759,2909),(133760,2910),(133761,2911),(133762,2912),(133763,2913),(133764,2914),(133765,2915),(133766,2916),(133767,2917),(133768,2918),(133769,2919),(133770,2920),(133771,2921),(133772,2922),(133773,2923),(133774,2924),(133775,2925),(133776,2926),(133777,2927),(133778,2928),(133779,2929),(133780,2930),(133781,2931),(133782,2932),(133783,2933),(133784,2934),(133785,2935),(133786,2936),(133787,2937),(133788,2938),(133789,2939),(133790,2940),(133791,2941),(133792,2942),(133793,2943),(133794,2944),(133795,2945),(133796,2946),(133797,2947),(133798,2948),(133799,2949),(133800,2950),(133801,2951),(133802,2952),(133803,2953),(133804,2954),(133805,2955),(133806,2956),(133807,2957),(133808,2958),(133809,2959),(133810,2960),(133811,2961),(133812,2962),(133813,2963),(133814,2964),(133815,2965),(133816,2966),(133817,2967),(133818,2968),(133819,2969),(133820,2970),(133821,2971),(133822,2972),(133823,2973),(133824,2974),(133825,2975),(133826,2976),(133827,2977),(133828,2978),(133829,2979),(133830,2980),(133831,2981),(133832,2982),(133833,2983),(133834,2984),(133835,2985),(133836,2986),(133837,2987),(133838,2988),(133839,2989),(133840,2990),(133841,2991),(133842,2992),(133843,2993),(133844,2994),(133845,2995),(133846,2996),(133847,2997),(133848,2998),(133849,2999),(133850,3000),(133851,3001),(133852,3002),(133853,3003),(133854,3004),(133855,3005),(133856,3006),(133857,3007),(133858,3008),(133859,3009),(133860,3010),(133861,3011),(133862,3012),(133863,3013),(133864,3014),(133865,3015),(133866,3016),(133867,3017),(133868,3018),(133869,3019),(133870,3020),(133871,3021),(133872,3022),(133873,3023),(133874,3024),(133875,3025),(133876,3026),(133877,3027),(133878,3028),(133879,3029),(133880,3030),(133881,3031),(133882,3032),(133883,3033),(133884,3034),(133885,3035),(133886,3036),(133887,3037),(133888,3038),(133889,3039),(133890,3040),(133891,3041),(133892,3042),(133893,3043),(133894,3044),(133895,3045),(133896,3046),(133897,3047),(133898,3048),(133899,3049),(133900,3050),(133901,3051),(133902,3052),(133903,3053),(133904,3054),(133905,3055),(133906,3056),(133907,3057),(133908,3058),(133909,3059),(133910,3060),(133911,3061),(133912,3062),(133913,3063),(133914,3064),(133915,3065),(133916,3066),(133917,3067),(133918,3068),(133919,3069),(133920,3070),(133921,3071),(133922,3072),(133923,3073),(133924,3074),(133925,3075),(133926,3076),(133927,3077),(133928,3078),(133929,3079),(133930,3080),(133931,3081),(133932,3082),(133933,3083),(133934,3084),(133935,3085),(133936,3086),(133937,3087),(133938,3088),(133939,3089),(133940,3090),(133941,3091),(133942,3092),(133943,3093),(133944,3094),(133945,3095),(133946,3096),(133947,3097),(133948,3098),(133949,3099),(133950,3100),(133951,3101),(133952,3102),(133953,3103),(133954,3104),(133955,3105),(133956,3106),(133957,3107),(133958,3108),(133959,3109),(133960,3110),(133961,3111),(133962,3112),(133963,3113),(133964,3114),(133965,3115),(133966,3116),(133967,3117),(133968,3118),(133969,3119),(133970,3120),(133971,3121),(133972,3122),(133973,3123),(133974,3124),(133975,3125),(133976,3126),(133977,3127),(133978,3128),(133979,3129),(133980,3130),(133981,3131),(133982,3132),(133983,3133),(133984,3134),(133985,3135),(133986,3136),(133987,3137),(133988,3138),(133989,3139),(133990,3140),(133991,3141),(133992,3142),(133993,3143),(133994,3144),(133995,3145),(133996,3146),(133997,3147),(133998,3148),(133999,3149),(134000,3150),(134001,3151),(134002,3152),(134003,3153),(134004,3154),(134005,3155),(134006,3156),(134007,3157),(134008,3158),(134009,3159),(134010,3160),(134011,3161),(134012,3162),(134013,3163),(134014,3164),(134015,3165),(134016,3166),(134017,3167),(134018,3168),(134019,3169),(134020,3170),(134021,3171),(134022,3172),(134023,3173),(134024,3174),(134025,3175),(134026,3176),(134027,3177),(134028,3178),(134029,3179),(134030,3180),(134031,3181),(134032,3182),(134033,3183),(134034,3184),(134035,3185),(134036,3186),(134037,3187),(134038,3188),(134039,3189),(134040,3190),(134041,3191),(134042,3192),(134043,3193),(134044,3194),(134045,3195),(134046,3196),(134047,3197),(134048,3198),(134049,3199),(134050,3200),(134051,3201),(134052,3202),(134053,3203),(134054,3204),(134055,3205),(134056,3206),(134057,3207),(134058,3208),(134059,3209),(134060,3210),(134061,3211),(134062,3212),(134063,3213),(134064,3214),(134065,3215),(134066,3216),(134067,3217),(134068,3218),(134069,3219),(134070,3220),(134071,3221),(134072,3222),(134073,3223),(134074,3224),(134075,3225),(134076,3226),(134077,3227),(134078,3228),(134079,3229),(134080,3230),(134081,3231),(134082,3232),(134083,3233),(134084,3234),(134085,3235),(134086,3236),(134087,3237),(134088,3238),(134089,3239),(134090,3240),(134091,3241),(134092,3242),(134093,3243),(134094,3244),(134095,3245),(134096,3246),(134097,3247),(134098,3248),(134099,3249),(134100,3250),(134101,3251),(134102,3252),(134103,3253),(134104,3254),(134105,3255),(134106,3256),(134107,3257),(134108,3258),(134109,3259),(134110,3260),(134111,3261),(134112,3262),(134113,3263),(134114,3264),(134115,3265),(134116,3266),(134117,3267),(134118,3268),(134119,3269),(134120,3270),(134121,3271),(134122,3272),(134123,3273),(134124,3274),(134125,3275),(134126,3276),(134127,3277),(134128,3278),(134129,3279),(134130,3280),(134131,3281),(134132,3282),(134133,3283),(134134,3284),(134135,3285),(134136,3286),(134137,3287),(134138,3288),(134139,3289),(134140,3290),(134141,3291),(134142,3292),(134143,3293),(134144,3294),(134145,3295),(134146,3296),(134147,3297),(134148,3298),(134149,3299),(134150,3300),(134151,3301),(134152,3302),(134153,3303),(134154,3304),(134155,3305),(134156,3306),(134157,3307),(134158,3308),(134159,3309),(134160,3310),(134161,3311),(134162,3312),(134163,3313),(134164,3314),(134165,3315),(134166,3316),(134167,3317),(134168,3318),(134169,3319),(134170,3320),(134171,3321),(134172,3322),(134173,3323),(134174,3324),(134175,3325),(134176,3326),(134177,3327),(134178,3328),(134179,3329),(134180,3330),(134181,3331),(134182,3332),(134183,3333),(134184,3334),(134185,3335),(134186,3336),(134187,3337),(134188,3338),(134189,3339),(134190,3340),(134191,3341),(134192,3342),(134193,3343),(134194,3344),(134195,3345),(134196,3346),(134197,3347),(134198,3348),(134199,3349),(134200,3350),(134201,3351),(134202,3352),(134203,3353),(134204,3354),(134205,3355),(134206,3356),(134207,3357),(134208,3358),(134209,3359),(134210,3360),(134211,3361),(134212,3362),(134213,3363),(134214,3364),(134215,3365),(134216,3366),(134217,3367),(134218,3368),(134219,3369),(134220,3370),(134221,3371),(134222,3372),(134223,3373),(134224,3374),(134225,3375),(134226,3376),(134227,3377),(134228,3378),(134229,3379),(134230,3380),(134231,3381),(134232,3382),(134233,3383),(134234,3384),(134235,3385),(134236,3386),(134237,3387),(134238,3388),(134239,3389),(134240,3390),(134241,3391),(134242,3392),(134243,3393),(134244,3394),(134245,3395),(134246,3396),(134247,3397),(134248,3398),(134249,3399),(134250,3400),(134251,3401),(134252,3402),(134253,3403),(134254,3404),(134255,3405),(134256,3406),(134257,3407),(134258,3408),(134259,3409),(134260,3410),(134261,3411),(134262,3412),(134263,3413),(134264,3414),(134265,3415),(134266,3416),(134267,3417),(134268,3418),(134269,3419),(134270,3420),(134271,3421),(134272,3422),(134273,3423),(134274,3424),(134275,3425),(134276,3426),(134277,3427),(134278,3428),(134279,3429),(134280,3430),(134281,3431),(134282,3432),(134283,3433),(134284,3434),(134285,3435),(134286,3436),(134287,3437),(134288,3438),(134289,3439),(134290,3440),(134291,3441),(134292,3442),(134293,3443),(134294,3444),(134295,3445),(134296,3446),(134297,3447),(134298,3448),(134299,3449),(134300,3450),(134301,3451),(134302,3452),(134303,3453),(134304,3454),(134305,3455),(134306,3456),(134307,3457),(134308,3458),(134309,3459),(134310,3460),(134311,3461),(134312,3462),(134313,3463),(134314,3464),(134315,3465),(134316,3466),(134317,3467),(134318,3468),(134319,3469),(134320,3470),(134321,3471),(134322,3472),(134323,3473),(134324,3474),(134325,3475),(134326,3476),(134327,3477),(134328,3478),(134329,3479),(134330,3480),(134331,3481),(134332,3482),(134333,3483),(134334,3484),(134335,3485),(134336,3486),(134337,3487),(134338,3488),(134339,3489),(134340,3490),(134341,3491),(134342,3492),(134343,3493),(134344,3494),(134345,3495),(134346,3496),(134347,3497),(134348,3498),(134349,3499),(134350,3500),(134351,3501),(134352,3502),(134353,3503),(134354,3504),(134355,3505),(134356,3506),(134357,3507),(134358,3508),(134359,3509),(134360,3510),(134361,3511),(134362,3512),(134363,3513),(134364,3514),(134365,3515),(134366,3516),(134367,3517),(134368,3518),(134369,3519),(134370,3520),(134371,3521),(134372,3522),(134373,3523),(134374,3524),(134375,3525),(134376,3526),(134377,3527),(134378,3528),(134379,3529),(134380,3530),(134381,3531),(134382,3532),(134383,3533),(134384,3534),(134385,3535),(134386,3536),(134387,3537),(134388,3538),(134389,3539),(134390,3540),(134391,3541),(134392,3542),(134393,3543),(134394,3544),(134395,3545),(134396,3546),(134397,3547),(134398,3548),(134399,3549),(134400,3550),(134401,3551),(134402,3552),(134403,3553),(134404,3554),(134405,3555),(134406,3556),(134407,3557),(134408,3558),(134409,3559),(134410,3560),(134411,3561),(134412,3562),(134413,3563),(134414,3564),(134415,3565),(134416,3566),(134417,3567),(134418,3568),(134419,3569),(134420,3570),(134421,3571),(134422,3572),(134423,3573),(134424,3574),(134425,3575),(134426,3576),(134427,3577),(134428,3578),(134429,3579),(134430,3580),(134431,3581),(134432,3582),(134433,3583),(134434,3584),(134435,3585),(134436,3586),(134437,3587),(134438,3588),(134439,3589),(134440,3590),(134441,3591),(134442,3592),(134443,3593),(134444,3594),(134445,3595),(134446,3596),(134447,3597),(134448,3598),(134449,3599),(134450,3600),(134451,3601),(134452,3602),(134453,3603),(134454,3604),(134455,3605),(134456,3606),(134457,3607),(134458,3608),(134459,3609),(134460,3610),(134461,3611),(134462,3612),(134463,3613),(134464,3614),(134465,3615),(134466,3616),(134467,3617),(134468,3618),(134469,3619),(134470,3620),(134471,3621),(134472,3622),(134473,3623),(134474,3624),(134475,3625),(134476,3626),(134477,3627),(134478,3628),(134479,3629),(134480,3630),(134481,3631),(134482,3632),(134483,3633),(134484,3634),(134485,3635),(134486,3636),(134487,3637),(134488,3638),(134489,3639),(134490,3640),(134491,3641),(134492,3642),(134493,3643),(134494,3644),(134495,3645),(134496,3646),(134497,3647),(134498,3648),(134499,3649),(134500,3650),(134501,3651),(134502,3652),(134503,3653),(134504,3654),(134505,3655),(134506,3656),(134507,3657),(134508,3658),(134509,3659),(134510,3660),(134511,3661),(134512,3662),(134513,3663),(134514,3664),(134515,3665),(134516,3666),(134517,3667),(134518,3668),(134519,3669),(134520,3670),(134521,3671),(134522,3672),(134523,3673),(134524,3674),(134525,3675),(134526,3676),(134527,3677),(134528,3678),(134529,3679),(134530,3680),(134531,3681),(134532,3682),(134533,3683),(134534,3684),(134535,3685),(134536,3686),(134537,3687),(134538,3688),(134539,3689),(134540,3690),(134541,3691),(134542,3692),(134543,3693),(134544,3694),(134545,3695),(134546,3696),(134547,3697),(134548,3698),(134549,3699),(134550,3700),(134551,3701),(134552,3702),(134553,3703),(134554,3704),(134555,3705),(134556,3706),(134557,3707),(134558,3708),(134559,3709),(134560,3710),(134561,3711),(134562,3712),(134563,3713),(134564,3714),(134565,3715),(134566,3716),(134567,3717),(134568,3718),(134569,3719),(134570,3720),(134571,3721),(134572,3722),(134573,3723),(134574,3724),(134575,3725),(134576,3726),(134577,3727),(134578,3728),(134579,3729),(134580,3730),(134581,3731),(134582,3732),(134583,3733),(134584,3734),(134585,3735),(134586,3736),(134587,3737),(134588,3738),(134589,3739),(134590,3740),(134591,3741),(134592,3742),(134593,3743),(134594,3744),(134595,3745),(134596,3746),(134597,3747),(134598,3748),(134599,3749),(134600,3750),(134601,3751),(134602,3752),(134603,3753),(134604,3754),(134605,3755),(134606,3756),(134607,3757),(134608,3758),(134609,3759),(134610,3760),(134611,3761),(134612,3762),(134613,3763),(134614,3764),(134615,3765),(134616,3766),(134617,3767),(134618,3768),(134619,3769),(134620,3770),(134621,3771),(134622,3772),(134623,3773),(134624,3774),(134625,3775),(134626,3776),(134627,3777),(134628,3778),(134629,3779),(134630,3780),(134631,3781),(134632,3782),(134633,3783),(134634,3784),(134635,3785),(134636,3786),(134637,3787),(134638,3788),(134639,3789),(134640,3790),(134641,3791),(134642,3792),(134643,3793),(134644,3794),(134645,3795),(134646,3796),(134647,3797),(134648,3798),(134649,3799),(134650,3800),(134651,3801),(134652,3802),(134653,3803),(134654,3804),(134655,3805),(134656,3806),(134657,3807),(134658,3808),(134659,3809),(134660,3810),(134661,3811),(134662,3812),(134663,3813),(134664,3814),(134665,3815),(134666,3816),(134667,3817),(134668,3818),(134669,3819),(134670,3820),(134671,3821),(134672,3822),(134673,3823),(134674,3824),(134675,3825),(134676,3826),(134677,3827),(134678,3828),(134679,3829),(134680,3830),(134681,3831),(134682,3832),(134683,3833),(134684,3834),(134685,3835),(134686,3836),(134687,3837),(134688,3838),(134689,3839),(134690,3840),(134691,3841),(134692,3842),(134693,3843),(134694,3844),(134695,3845),(134696,3846),(134697,3847),(134698,3848),(134699,3849),(134700,3850),(134701,3851),(134702,3852),(134703,3853),(134704,3854),(134705,3855),(134706,3856),(134707,3857),(134708,3858),(134709,3859),(134710,3860),(134711,3861),(134712,3862),(134713,3863),(134714,3864),(134715,3865),(134716,3866),(134717,3867),(134718,3868),(134719,3869),(134720,3870),(134721,3871),(134722,3872),(134723,3873),(134724,3874),(134725,3875),(134726,3876),(134727,3877),(134728,3878),(134729,3879),(134730,3880),(134731,3881),(134732,3882),(134733,3883),(134734,3884),(134735,3885),(134736,3886),(134737,3887),(134738,3888),(134739,3889),(134740,3890),(134741,3891),(134742,3892),(134743,3893),(134744,3894),(134745,3895),(134746,3896),(134747,3897),(134748,3898),(134749,3899),(134750,3900),(134751,3901),(134752,3902),(134753,3903),(134754,3904),(134755,3905),(134756,3906),(134757,3907),(134758,3908),(134759,3909),(134760,3910),(134761,3911),(134762,3912),(134763,3913),(134764,3914),(134765,3915),(134766,3916),(134767,3917),(134768,3918),(134769,3919),(134770,3920),(134771,3921),(134772,3922),(134773,3923),(134774,3924),(134775,3925),(134776,3926),(134777,3927),(134778,3928),(134779,3929),(134780,3930),(134781,3931),(134782,3932),(134783,3933),(134784,3934),(134785,3935),(134786,3936),(134787,3937),(134788,3938),(134789,3939),(134790,3940),(134791,3941),(134792,3942),(134793,3943),(134794,3944),(134795,3945),(134796,3946),(134797,3947),(134798,3948),(134799,3949),(134800,3950),(134801,3951),(134802,3952),(134803,3953),(134804,3954),(134805,3955),(134806,3956),(134807,3957),(134808,3958),(134809,3959),(134810,3960),(134811,3961),(134812,3962),(134813,3963),(134814,3964),(134815,3965),(134816,3966),(134817,3967),(134818,3968),(134819,3969),(134820,3970),(134821,3971),(134822,3972),(134823,3973),(134824,3974),(134825,3975),(134826,3976),(134827,3977),(134828,3978),(134829,3979),(134830,3980),(134831,3981),(134832,3982),(134833,3983),(134834,3984),(134835,3985),(134836,3986),(134837,3987),(134838,3988),(134839,3989),(134840,3990),(134841,3991),(134842,3992),(134843,3993),(134844,3994),(134845,3995),(134846,3996),(134847,3997),(134848,3998),(134849,3999),(134850,4000),(134851,4001),(134852,4002),(134853,4003),(134854,4004),(134855,4005),(134856,4006),(134857,4007),(134858,4008),(134859,4009),(134860,4010),(134861,4011),(134862,4012),(134863,4013),(134864,4014),(134865,4015),(134866,4016),(134867,4017),(134868,4018),(134869,4019),(134870,4020),(134871,4021),(134872,4022),(134873,4023),(134874,4024),(134875,4025),(134876,4026),(134877,4027),(134878,4028),(134879,4029),(134880,4030),(134881,4031),(134882,4032),(134883,4033),(134884,4034),(134885,4035),(134886,4036),(134887,4037),(134888,4038),(134889,4039),(134890,4040),(134891,4041),(134892,4042),(134893,4043),(134894,4044),(134895,4045),(134896,4046),(134897,4047),(134898,4048),(134899,4049),(134900,4050),(134901,4051),(134902,4052),(134903,4053),(134904,4054),(134905,4055),(134906,4056),(134907,4057),(134908,4058),(134909,4059),(134910,4060),(134911,4061),(134912,4062),(134913,4063),(134914,4064),(134915,4065),(134916,4066),(134917,4067),(134918,4068),(134919,4069),(134920,4070),(134921,4071),(134922,4072),(134923,4073),(134924,4074),(134925,4075),(134926,4076),(134927,4077),(134928,4078),(134929,4079),(134930,4080),(134931,4081),(134932,4082),(134933,4083),(134934,4084),(134935,4085),(134936,4086),(134937,4087),(134938,4088),(134939,4089),(134940,4090),(134941,4091),(134942,4092),(134943,4093),(134944,4094),(134945,4095),(134946,4096),(134947,4097),(134948,4098),(134949,4099),(134950,4100),(134951,4101),(134952,4102),(134953,4103),(134954,4104),(134955,4105),(134956,4106),(134957,4107),(134958,4108),(134959,4109),(134960,4110),(134961,4111),(134962,4112),(134963,4113),(134964,4114),(134965,4115),(134966,4116),(134967,4117),(134968,4118),(134969,4119),(134970,4120),(134971,4121),(134972,4122),(134973,4123),(134974,4124),(134975,4125),(134976,4126),(134977,4127),(134978,4128),(134979,4129),(134980,4130),(134981,4131),(134982,4132),(134983,4133),(134984,4134),(134985,4135),(134986,4136),(134987,4137),(134988,4138),(134989,4139),(134990,4140),(134991,4141),(134992,4142),(134993,4143),(134994,4144),(134995,4145),(134996,4146),(134997,4147),(134998,4148),(134999,4149),(135000,4150),(135001,4151),(135002,4152),(135003,4153),(135004,4154),(135005,4155),(135006,4156),(135007,4157),(135008,4158),(135009,4159),(135010,4160),(135011,4161),(135012,4162),(135013,4163),(135014,4164),(135015,4165),(135016,4166),(135017,4167),(135018,4168),(135019,4169),(135020,4170),(135021,4171),(135022,4172),(135023,4173),(135024,4174),(135025,4175),(135026,4176),(135027,4177),(135028,4178),(135029,4179),(135030,4180),(135031,4181),(135032,4182),(135033,4183),(135034,4184),(135035,4185),(135036,4186),(135037,4187),(135038,4188),(135039,4189),(135040,4190),(135041,4191),(135042,4192),(135043,4193),(135044,4194),(135045,4195),(135046,4196),(135047,4197),(135048,4198),(135049,4199),(135050,4200),(135051,4201),(135052,4202),(135053,4203),(135054,4204),(135055,4205),(135056,4206),(135057,4207),(135058,4208),(135059,4209),(135060,4210),(135061,4211),(135062,4212),(135063,4213),(135064,4214),(135065,4215),(135066,4216),(135067,4217),(135068,4218),(135069,4219),(135070,4220),(135071,4221),(135072,4222),(135073,4223),(135074,4224),(135075,4225),(135076,4226),(135077,4227),(135078,4228),(135079,4229),(135080,4230),(135081,4231),(135082,4232),(135083,4233),(135084,4234),(135085,4235),(135086,4236),(135087,4237),(135088,4238),(135089,4239),(135090,4240),(135091,4241),(135092,4242),(135093,4243),(135094,4244),(135095,4245),(135096,4246),(135097,4247),(135098,4248),(135099,4249),(135100,4250),(135101,4251),(135102,4252),(135103,4253),(135104,4254),(135105,4255),(135106,4256),(135107,4257),(135108,4258),(135109,4259),(135110,4260),(135111,4261),(135112,4262),(135113,4263),(135114,4264),(135115,4265),(135116,4266),(135117,4267),(135118,4268),(135119,4269),(135120,4270),(135121,4271),(135122,4272),(135123,4273),(135124,4274),(135125,4275),(135126,4276),(135127,4277),(135128,4278),(135129,4279),(135130,4280),(135131,4281),(135132,4282),(135133,4283),(135134,4284),(135135,4285),(135136,4286),(135137,4287),(135138,4288),(135139,4289),(135140,4290),(135141,4291),(135142,4292),(135143,4293),(135144,4294),(135145,4295),(135146,4296),(135147,4297),(135148,4298),(135149,4299),(135150,4300),(135151,4301),(135152,4302),(135153,4303),(135154,4304),(135155,4305),(135156,4306),(135157,4307),(135158,4308),(135159,4309),(135160,4310),(135161,4311),(135162,4312),(135163,4313),(135164,4314),(135165,4315),(135166,4316),(135167,4317),(135168,4318),(135169,4319),(135170,4320),(135171,4321),(135172,4322),(135173,4323),(135174,4324),(135175,4325),(135176,4326),(135177,4327),(135178,4328),(135179,4329),(135180,4330),(135181,4331),(135182,4332),(135183,4333),(135184,4334),(135185,4335),(135186,4336),(135187,4337),(135188,4338),(135189,4339),(135190,4340),(135191,4341),(135192,4342),(135193,4343),(135194,4344),(135195,4345),(135196,4346),(135197,4347),(135198,4348),(135199,4349),(135200,4350),(135201,4351),(135202,4352),(135203,4353),(135204,4354),(135205,4355),(135206,4356),(135207,4357),(135208,4358),(135209,4359),(135210,4360),(135211,4361),(135212,4362),(135213,4363),(135214,4364),(135215,4365),(135216,4366),(135217,4367),(135218,4368),(135219,4369),(135220,4370),(135221,4371),(135222,4372),(135223,4373),(135224,4374),(135225,4375),(135226,4376),(135227,4377),(135228,4378),(135229,4379),(135230,4380),(135231,4381),(135232,4382),(135233,4383),(135234,4384),(135235,4385),(135236,4386),(135237,4387),(135238,4388),(135239,4389),(135240,4390),(135241,4391),(135242,4392),(135243,4393),(135244,4394),(135245,4395),(135246,4396),(135247,4397),(135248,4398),(135249,4399),(135250,4400),(135251,4401),(135252,4402),(135253,4403),(135254,4404),(135255,4405),(135256,4406),(135257,4407),(135258,4408),(135259,4409),(135260,4410),(135261,4411),(135262,4412),(135263,4413),(135264,4414),(135265,4415),(135266,4416),(135267,4417),(135268,4418),(135269,4419),(135270,4420),(135271,4421),(135272,4422),(135273,4423),(135274,4424),(135275,4425),(135276,4426),(135277,4427),(135278,4428),(135279,4429),(135280,4430),(135281,4431),(135282,4432),(135283,4433),(135284,4434),(135285,4435),(135286,4436),(135287,4437),(135288,4438),(135289,4439),(135290,4440),(135291,4441),(135292,4442),(135293,4443),(135294,4444),(135295,4445),(135296,4446),(135297,4447),(135298,4448),(135299,4449),(135300,4450),(135301,4451),(135302,4452),(135303,4453),(135304,4454),(135305,4455),(135306,4456),(135307,4457),(135308,4458),(135309,4459),(135310,4460),(135311,4461),(135312,4462),(135313,4463),(135314,4464),(135315,4465),(135316,4466),(135317,4467),(135318,4468),(135319,4469),(135320,4470),(135321,4471),(135322,4472),(135323,4473),(135324,4474),(135325,4475),(135326,4476),(135327,4477),(135328,4478),(135329,4479),(135330,4480),(135331,4481),(135332,4482),(135333,4483),(135334,4484),(135335,4485),(135336,4486),(135337,4487),(135338,4488),(135339,4489),(135340,4490),(135341,4491),(135342,4492),(135343,4493),(135344,4494),(135345,4495),(135346,4496),(135347,4497),(135348,4498),(135349,4499),(135350,4500),(135351,4501),(135352,4502),(135353,4503),(135354,4504),(135355,4505),(135356,4506),(135357,4507),(135358,4508),(135359,4509),(135360,4510),(135361,4511),(135362,4512),(135363,4513),(135364,4514),(135365,4515),(135366,4516),(135367,4517),(135368,4518),(135369,4519),(135370,4520),(135371,4521),(135372,4522),(135373,4523),(135374,4524),(135375,4525),(135376,4526),(135377,4527),(135378,4528),(135379,4529),(135380,4530),(135381,4531),(135382,4532),(135383,4533),(135384,4534),(135385,4535),(135386,4536),(135387,4537),(135388,4538),(135389,4539),(135390,4540),(135391,4541),(135392,4542),(135393,4543),(135394,4544),(135395,4545),(135396,4546),(135397,4547),(135398,4548),(135399,4549),(135400,4550),(135401,4551),(135402,4552),(135403,4553),(135404,4554),(135405,4555),(135406,4556),(135407,4557),(135408,4558),(135409,4559),(135410,4560),(135411,4561),(135412,4562),(135413,4563),(135414,4564),(135415,4565),(135416,4566),(135417,4567),(135418,4568),(135419,4569),(135420,4570),(135421,4571),(135422,4572),(135423,4573),(135424,4574),(135425,4575),(135426,4576),(135427,4577),(135428,4578),(135429,4579),(135430,4580),(135431,4581),(135432,4582),(135433,4583),(135434,4584),(135435,4585),(135436,4586),(135437,4587),(135438,4588),(135439,4589),(135440,4590),(135441,4591),(135442,4592),(135443,4593),(135444,4594),(135445,4595),(135446,4596),(135447,4597),(135448,4598),(135449,4599),(135450,4600),(135451,4601),(135452,4602),(135453,4603),(135454,4604),(135455,4605),(135456,4606),(135457,4607),(135458,4608),(135459,4609),(135460,4610),(135461,4611),(135462,4612),(135463,4613),(135464,4614),(135465,4615),(135466,4616),(135467,4617),(135468,4618),(135469,4619),(135470,4620),(135471,4621),(135472,4622),(135473,4623),(135474,4624),(135475,4625),(135476,4626),(135477,4627),(135478,4628),(135479,4629),(135480,4630),(135481,4631),(135482,4632),(135483,4633),(135484,4634),(135485,4635),(135486,4636),(135487,4637),(135488,4638),(135489,4639),(135490,4640),(135491,4641),(135492,4642),(135493,4643),(135494,4644),(135495,4645),(135496,4646),(135497,4647),(135498,4648),(135499,4649),(135500,4650),(135501,4651),(135502,4652),(135503,4653),(135504,4654),(135505,4655),(135506,4656),(135507,4657),(135508,4658),(135509,4659),(135510,4660),(135511,4661),(135512,4662),(135513,4663),(135514,4664),(135515,4665),(135516,4666),(135517,4667),(135518,4668),(135519,4669),(135520,4670),(135521,4671),(135522,4672),(135523,4673),(135524,4674),(135525,4675),(135526,4676),(135527,4677),(135528,4678),(135529,4679),(135530,4680),(135531,4681),(135532,4682),(135533,4683),(135534,4684),(135535,4685),(135536,4686),(135537,4687),(135538,4688),(135539,4689),(135540,4690),(135541,4691),(135542,4692),(135543,4693),(135544,4694),(135545,4695),(135546,4696),(135547,4697),(135548,4698),(135549,4699),(135550,4700),(135551,4701),(135552,4702),(135553,4703),(135554,4704),(135555,4705),(135556,4706),(135557,4707),(135558,4708),(135559,4709),(135560,4710),(135561,4711),(135562,4712),(135563,4713),(135564,4714),(135565,4715),(135566,4716),(135567,4717),(135568,4718),(135569,4719),(135570,4720),(135571,4721),(135572,4722),(135573,4723),(135574,4724),(135575,4725),(135576,4726),(135577,4727),(135578,4728),(135579,4729),(135580,4730),(135581,4731),(135582,4732),(135583,4733),(135584,4734),(135585,4735),(135586,4736),(135587,4737),(135588,4738),(135589,4739),(135590,4740),(135591,4741),(135592,4742),(135593,4743),(135594,4744),(135595,4745),(135596,4746),(135597,4747),(135598,4748),(135599,4749),(135600,4750),(135601,4751),(135602,4752),(135603,4753),(135604,4754),(135605,4755),(135606,4756),(135607,4757),(135608,4758),(135609,4759),(135610,4760),(135611,4761),(135612,4762),(135613,4763),(135614,4764),(135615,4765),(135616,4766),(135617,4767),(135618,4768),(135619,4769),(135620,4770),(135621,4771),(135622,4772),(135623,4773),(135624,4774),(135625,4775),(135626,4776),(135627,4777),(135628,4778),(135629,4779),(135630,4780),(135631,4781),(135632,4782),(135633,4783),(135634,4784),(135635,4785),(135636,4786),(135637,4787),(135638,4788),(135639,4789),(135640,4790),(135641,4791),(135642,4792),(135643,4793),(135644,4794),(135645,4795),(135646,4796),(135647,4797),(135648,4798),(135649,4799),(135650,4800),(135651,4801),(135652,4802),(135653,4803),(135654,4804),(135655,4805),(135656,4806),(135657,4807),(135658,4808),(135659,4809),(135660,4810),(135661,4811),(135662,4812),(135663,4813),(135664,4814),(135665,4815),(135666,4816),(135667,4817),(135668,4818),(135669,4819),(135670,4820),(135671,4821),(135672,4822),(135673,4823),(135674,4824),(135675,4825),(135676,4826),(135677,4827),(135678,4828),(135679,4829),(135680,4830),(135681,4831),(135682,4832),(135683,4833),(135684,4834),(135685,4835),(135686,4836),(135687,4837),(135688,4838),(135689,4839),(135690,4840),(135691,4841),(135692,4842),(135693,4843),(135694,4844),(135695,4845),(135696,4846),(135697,4847),(135698,4848),(135699,4849),(135700,4850),(135701,4851),(135702,4852),(135703,4853),(135704,4854),(135705,4855),(135706,4856),(135707,4857),(135708,4858),(135709,4859),(135710,4860),(135711,4861),(135712,4862),(135713,4863),(135714,4864),(135715,4865),(135716,4866),(135717,4867),(135718,4868),(135719,4869),(135720,4870),(135721,4871),(135722,4872),(135723,4873),(135724,4874),(135725,4875),(135726,4876),(135727,4877),(135728,4878),(135729,4879),(135730,4880),(135731,4881),(135732,4882),(135733,4883),(135734,4884),(135735,4885),(135736,4886),(135737,4887),(135738,4888),(135739,4889),(135740,4890),(135741,4891),(135742,4892),(135743,4893),(135744,4894),(135745,4895),(135746,4896),(135747,4897),(135748,4898),(135749,4899),(135750,4900),(135751,4901),(135752,4902),(135753,4903),(135754,4904),(135755,4905),(135756,4906),(135757,4907),(135758,4908),(135759,4909),(135760,4910),(135761,4911),(135762,4912),(135763,4913),(135764,4914),(135765,4915),(135766,4916),(135767,4917),(135768,4918),(135769,4919),(135770,4920),(135771,4921),(135772,4922),(135773,4923),(135774,4924),(135775,4925),(135776,4926),(135777,4927),(135778,4928),(135779,4929),(135780,4930),(135781,4931),(135782,4932),(135783,4933),(135784,4934),(135785,4935),(135786,4936),(135787,4937),(135788,4938),(135789,4939),(135790,4940),(135791,4941),(135792,4942),(135793,4943),(135794,4944),(135795,4945),(135796,4946),(135797,4947),(135798,4948),(135799,4949),(135800,4950),(135801,4951),(135802,4952),(135803,4953),(135804,4954),(135805,4955),(135806,4956),(135807,4957),(135808,4958),(135809,4959),(135810,4960),(135811,4961),(135812,4962),(135813,4963),(135814,4964),(135815,4965),(135816,4966),(135817,4967),(135818,4968),(135819,4969),(135820,4970),(135821,4971),(135822,4972),(135823,4973),(135824,4974),(135825,4975),(135826,4976),(135827,4977),(135828,4978),(135829,4979),(135830,4980),(135831,4981),(135832,4982),(135833,4983),(135834,4984),(135835,4985),(135836,4986),(135837,4987),(135838,4988),(135839,4989),(135840,4990),(135841,4991),(135842,4992),(135843,4993),(135844,4994),(135845,4995),(135846,4996),(135847,4997),(135848,4998),(135849,4999),(135850,5000),(135851,5001),(135852,5002),(135853,5003),(135854,5004),(135855,5005),(135856,5006),(135857,5007),(135858,5008),(135859,5009),(135860,5010),(135861,5011),(135862,5012),(135863,5013),(135864,5014),(135865,5015),(135866,5016),(135867,5017),(135868,5018),(135869,5019),(135870,5020),(135871,5021),(135872,5022),(135873,5023),(135874,5024),(135875,5025),(135876,5026),(135877,5027),(135878,5028),(135879,5029),(135880,5030),(135881,5031),(135882,5032),(135883,5033),(135884,5034),(135885,5035),(135886,5036),(135887,5037),(135888,5038),(135889,5039),(135890,5040),(135891,5041),(135892,5042),(135893,5043),(135894,5044),(135895,5045),(135896,5046),(135897,5047),(135898,5048),(135899,5049),(135900,5050),(135901,5051),(135902,5052),(135903,5053),(135904,5054),(135905,5055),(135906,5056),(135907,5057),(135908,5058),(135909,5059),(135910,5060),(135911,5061),(135912,5062),(135913,5063),(135914,5064),(135915,5065),(135916,5066),(135917,5067),(135918,5068),(135919,5069),(135920,5070),(135921,5071),(135922,5072),(135923,5073),(135924,5074),(135925,5075),(135926,5076),(135927,5077),(135928,5078),(135929,5079),(135930,5080),(135931,5081),(135932,5082),(135933,5083),(135934,5084),(135935,5085),(135936,5086),(135937,5087),(135938,5088),(135939,5089),(135940,5090),(135941,5091),(135942,5092),(135943,5093),(135944,5094),(135945,5095),(135946,5096),(135947,5097),(135948,5098),(135949,5099),(135950,5100),(135951,5101),(135952,5102),(135953,5103),(135954,5104),(135955,5105),(135956,5106),(135957,5107),(135958,5108),(135959,5109),(135960,5110),(135961,5111),(135962,5112),(135963,5113),(135964,5114),(135965,5115),(135966,5116),(135967,5117),(135968,5118),(135969,5119),(135970,5120),(135971,5121),(135972,5122),(135973,5123),(135974,5124),(135975,5125),(135976,5126),(135977,5127),(135978,5128),(135979,5129),(135980,5130),(135981,5131),(135982,5132),(135983,5133),(135984,5134),(135985,5135),(135986,5136),(135987,5137),(135988,5138),(135989,5139),(135990,5140),(135991,5141),(135992,5142),(135993,5143),(135994,5144),(135995,5145),(135996,5146),(135997,5147),(135998,5148),(135999,5149),(136000,5150),(136001,5151),(136002,5152),(136003,5153),(136004,5154),(136005,5155),(136006,5156),(136007,5157),(136008,5158),(136009,5159),(136010,5160),(136011,5161),(136012,5162),(136013,5163),(136014,5164),(136015,5165),(136016,5166),(136017,5167),(136018,5168),(136019,5169),(136020,5170),(136021,5171),(136022,5172),(136023,5173),(136024,5174),(136025,5175),(136026,5176),(136027,5177),(136028,5178),(136029,5179),(136030,5180),(136031,5181),(136032,5182),(136033,5183),(136034,5184),(136035,5185),(136036,5186),(136037,5187),(136038,5188),(136039,5189),(136040,5190),(136041,5191),(136042,5192),(136043,5193),(136044,5194),(136045,5195),(136046,5196),(136047,5197),(136048,5198),(136049,5199),(136050,5200),(136051,5201),(136052,5202),(136053,5203),(136054,5204),(136055,5205),(136056,5206),(136057,5207),(136058,5208),(136059,5209),(136060,5210),(136061,5211),(136062,5212),(136063,5213),(136064,5214),(136065,5215),(136066,5216),(136067,5217),(136068,5218),(136069,5219),(136070,5220),(136071,5221),(136072,5222),(136073,5223),(136074,5224),(136075,5225),(136076,5226),(136077,5227),(136078,5228),(136079,5229),(136080,5230),(136081,5231),(136082,5232),(136083,5233),(136084,5234),(136085,5235),(136086,5236),(136087,5237),(136088,5238),(136089,5239),(136090,5240),(136091,5241),(136092,5242),(136093,5243),(136094,5244),(136095,5245),(136096,5246),(136097,5247),(136098,5248),(136099,5249),(136100,5250),(136101,5251),(136102,5252),(136103,5253),(136104,5254),(136105,5255),(136106,5256),(136107,5257),(136108,5258),(136109,5259),(136110,5260),(136111,5261),(136112,5262),(136113,5263),(136114,5264),(136115,5265),(136116,5266),(136117,5267),(136118,5268),(136119,5269),(136120,5270),(136121,5271),(136122,5272),(136123,5273),(136124,5274),(136125,5275),(136126,5276),(136127,5277),(136128,5278),(136129,5279),(136130,5280),(136131,5281),(136132,5282),(136133,5283),(136134,5284),(136135,5285),(136136,5286),(136137,5287),(136138,5288),(136139,5289),(136140,5290),(136141,5291),(136142,5292),(136143,5293),(136144,5294),(136145,5295),(136146,5296),(136147,5297),(136148,5298),(136149,5299),(136150,5300),(136151,5301),(136152,5302),(136153,5303),(136154,5304),(136155,5305),(136156,5306),(136157,5307),(136158,5308),(136159,5309),(136160,5310),(136161,5311),(136162,5312),(136163,5313),(136164,5314),(136165,5315),(136166,5316),(136167,5317),(136168,5318),(136169,5319),(136170,5320),(136171,5321),(136172,5322),(136173,5323),(136174,5324),(136175,5325),(136176,5326),(136177,5327),(136178,5328),(136179,5329),(136180,5330),(136181,5331),(136182,5332),(136183,5333),(136184,5334),(136185,5335),(136186,5336),(136187,5337),(136188,5338),(136189,5339),(136190,5340),(136191,5341),(136192,5342),(136193,5343),(136194,5344),(136195,5345),(136196,5346),(136197,5347),(136198,5348),(136199,5349),(136200,5350),(136201,5351),(136202,5352),(136203,5353),(136204,5354),(136205,5355),(136206,5356),(136207,5357),(136208,5358),(136209,5359),(136210,5360),(136211,5361),(136212,5362),(136213,5363),(136214,5364),(136215,5365),(136216,5366),(136217,5367),(136218,5368),(136219,5369),(136220,5370),(136221,5371),(136222,5372),(136223,5373),(136224,5374),(136225,5375),(136226,5376),(136227,5377),(136228,5378),(136229,5379),(136230,5380),(136231,5381),(136232,5382),(136233,5383),(136234,5384),(136235,5385),(136236,5386),(136237,5387),(136238,5388),(136239,5389),(136240,5390),(136241,5391),(136242,5392),(136243,5393),(136244,5394),(136245,5395),(136246,5396),(136247,5397),(136248,5398),(136249,5399),(136250,5400),(136251,5401),(136252,5402),(136253,5403),(136254,5404),(136255,5405),(136256,5406),(136257,5407),(136258,5408),(136259,5409),(136260,5410),(136261,5411),(136262,5412),(136263,5413),(136264,5414),(136265,5415),(136266,5416),(136267,5417),(136268,5418),(136269,5419),(136270,5420),(136271,5421),(136272,5422),(136273,5423),(136274,5424),(136275,5425),(136276,5426),(136277,5427),(136278,5428),(136279,5429),(136280,5430),(136281,5431),(136282,5432),(136283,5433),(136284,5434),(136285,5435),(136286,5436),(136287,5437),(136288,5438),(136289,5439),(136290,5440),(136291,5441),(136292,5442),(136293,5443),(136294,5444),(136295,5445),(136296,5446),(136297,5447),(136298,5448),(136299,5449),(136300,5450),(136301,5451),(136302,5452),(136303,5453),(136304,5454),(136305,5455),(136306,5456),(136307,5457),(136308,5458),(136309,5459),(136310,5460),(136311,5461),(136312,5462),(136313,5463),(136314,5464),(136315,5465),(136316,5466),(136317,5467),(136318,5468),(136319,5469),(136320,5470),(136321,5471),(136322,5472),(136323,5473),(136324,5474),(136325,5475),(136326,5476),(136327,5477),(136328,5478),(136329,5479),(136330,5480),(136331,5481),(136332,5482),(136333,5483),(136334,5484),(136335,5485),(136336,5486),(136337,5487),(136338,5488),(136339,5489),(136340,5490),(136341,5491),(136342,5492),(136343,5493),(136344,5494),(136345,5495),(136346,5496),(136347,5497),(136348,5498),(136349,5499),(136350,5500),(136351,5501),(136352,5502),(136353,5503),(136354,5504),(136355,5505),(136356,5506),(136357,5507),(136358,5508),(136359,5509),(136360,5510),(136361,5511),(136362,5512),(136363,5513),(136364,5514),(136365,5515),(136366,5516),(136367,5517),(136368,5518),(136369,5519),(136370,5520),(136371,5521),(136372,5522),(136373,5523),(136374,5524),(136375,5525),(136376,5526),(136377,5527),(136378,5528),(136379,5529),(136380,5530),(136381,5531),(136382,5532),(136383,5533),(136384,5534),(136385,5535),(136386,5536),(136387,5537),(136388,5538),(136389,5539),(136390,5540),(136391,5541),(136392,5542),(136393,5543),(136394,5544),(136395,5545),(136396,5546),(136397,5547),(136398,5548),(136399,5549),(136400,5550),(136401,5551),(136402,5552),(136403,5553),(136404,5554),(136405,5555),(136406,5556),(136407,5557),(136408,5558),(136409,5559),(136410,5560),(136411,5561),(136412,5562),(136413,5563),(136414,5564),(136415,5565),(136416,5566),(136417,5567),(136418,5568),(136419,5569),(136420,5570),(136421,5571),(136422,5572),(136423,5573),(136424,5574),(136425,5575),(136426,5576),(136427,5577),(136428,5578),(136429,5579),(136430,5580),(136431,5581),(136432,5582),(136433,5583),(136434,5584),(136435,5585),(136436,5586),(136437,5587),(136438,5588),(136439,5589),(136440,5590),(136441,5591),(136442,5592),(136443,5593),(136444,5594),(136445,5595),(136446,5596),(136447,5597),(136448,5598),(136449,5599),(136450,5600),(136451,5601),(136452,5602),(136453,5603),(136454,5604),(136455,5605),(136456,5606),(136457,5607),(136458,5608),(136459,5609),(136460,5610),(136461,5611),(136462,5612),(136463,5613),(136464,5614),(136465,5615),(136466,5616),(136467,5617),(136468,5618),(136469,5619),(136470,5620),(136471,5621),(136472,5622),(136473,5623),(136474,5624),(136475,5625),(136476,5626),(136477,5627),(136478,5628),(136479,5629),(136480,5630),(136481,5631),(136482,5632),(136483,5633),(136484,5634),(136485,5635),(136486,5636),(136487,5637),(136488,5638),(136489,5639),(136490,5640),(136491,5641),(136492,5642),(136493,5643),(136494,5644),(136495,5645),(136496,5646),(136497,5647),(136498,5648),(136499,5649),(136500,5650),(136501,5651),(136502,5652),(136503,5653),(136504,5654),(136505,5655),(136506,5656),(136507,5657),(136508,5658),(136509,5659),(136510,5660),(136511,5661),(136512,5662),(136513,5663),(136514,5664),(136515,5665),(136516,5666),(136517,5667),(136518,5668),(136519,5669),(136520,5670),(136521,5671),(136522,5672),(136523,5673),(136524,5674),(136525,5675),(136526,5676),(136527,5677),(136528,5678),(136529,5679),(136530,5680),(136531,5681),(136532,5682),(136533,5683),(136534,5684),(136535,5685),(136536,5686),(136537,5687),(136538,5688),(136539,5689),(136540,5690),(136541,5691),(136542,5692),(136543,5693),(136544,5694),(136545,5695),(136546,5696),(136547,5697),(136548,5698),(136549,5699),(136550,5700),(136551,5701),(136552,5702),(136553,5703),(136554,5704),(136555,5705),(136556,5706),(136557,5707),(136558,5708),(136559,5709),(136560,5710),(136561,5711),(136562,5712),(136563,5713),(136564,5714),(136565,5715),(136566,5716),(136567,5717),(136568,5718),(136569,5719),(136570,5720),(136571,5721),(136572,5722),(136573,5723),(136574,5724),(136575,5725),(136576,5726),(136577,5727),(136578,5728),(136579,5729),(136580,5730),(136581,5731),(136582,5732),(136583,5733),(136584,5734),(136585,5735),(136586,5736),(136587,5737),(136588,5738),(136589,5739),(136590,5740),(136591,5741),(136592,5742),(136593,5743),(136594,5744),(136595,5745),(136596,5746),(136597,5747),(136598,5748),(136599,5749),(136600,5750),(136601,5751),(136602,5752),(136603,5753),(136604,5754),(136605,5755),(136606,5756),(136607,5757),(136608,5758),(136609,5759),(136610,5760),(136611,5760),(136612,5760),(136613,5760),(136614,5760),(136615,5760),(136616,5760),(136617,5760),(136618,5760),(136619,5760),(136620,5760),(136621,5760),(136622,5760),(136623,5760),(136624,5760),(136625,5760),(136626,5760),(136627,5760),(136628,5760),(136629,5760),(136630,5760),(136631,5760),(136632,5760),(136633,5760),(136634,5760),(136635,5760),(136636,5760),(136637,5760),(136638,5760),(136639,5760),(136640,5760),(136641,5760),(136642,5760),(136643,5760),(136644,5760),(136645,5760),(136646,5760),(136647,5760),(136648,5760),(136649,5760),(136650,5760),(136651,5760),(136652,5760),(136653,5761),(136654,5762),(136655,5763),(136656,5764),(136657,5765),(136658,5766),(136659,5767),(136660,5768),(136661,5769),(136662,5770),(136663,5771),(136664,5772),(136665,5773),(136666,5774),(136667,5775),(136668,5776),(136669,5777),(136670,5778),(136671,5779),(136672,5780),(136673,5781),(136674,5782),(136675,5783),(136676,5784),(136677,5785),(136678,5786),(136679,5787),(136680,5788),(136681,5789),(136682,5790),(136683,5791),(136684,5792),(136685,5793),(136686,5794),(136687,5795),(136688,5796),(136689,5797),(136690,5798),(136691,5799),(136692,5800),(136693,5801),(136694,5802),(136695,5803),(136696,5804),(136697,5805),(136698,5806),(136699,5807),(136700,5808),(136701,5809),(136702,5810),(136703,5811),(136704,5812),(136705,5813),(136706,5814),(136707,5815),(136708,5816),(136709,5817),(136710,5818),(136711,5819),(136712,5820),(136713,5821),(136714,5822),(136715,5823),(136716,5824),(136717,5825),(136718,5826),(136719,5827),(136720,5828),(136721,5829),(136722,5830),(136723,5831),(136724,5832),(136725,5833),(136726,5834),(136727,5835),(136728,5836),(136729,5837),(136730,5838),(136731,5839),(136732,5840),(136733,5841),(136734,5842),(136735,5843),(136736,5844),(136737,5845),(136738,5846),(136739,5847),(136740,5848),(136741,5849),(136742,5850),(136743,5851),(136744,5852),(136745,5853),(136746,5854),(136747,5855),(136748,5856),(136749,5857),(136750,5858),(136751,5859),(136752,5860),(136753,5761),(136754,5762),(136755,5763),(136756,5764),(136757,5765),(136758,5766),(136759,5767),(136760,5768),(136761,5769),(136762,5770),(136763,5771),(136764,5772),(136765,5773),(136766,5774),(136767,5775),(136768,5776),(136769,5777),(136770,5778),(136771,5779),(136772,5780),(136773,5781),(136774,5782),(136775,5783),(136776,5784),(136777,5785),(136778,5786),(136779,5787),(136780,5788),(136781,5789),(136782,5790),(136783,5791),(136784,5792),(136785,5793),(136786,5794),(136787,5795),(136788,5796),(136789,5797),(136790,5798),(136791,5799),(136792,5800),(136793,5801),(136794,5802),(136795,5803),(136796,5804),(136797,5805),(136798,5806),(136799,5807),(136800,5808),(136801,5809),(136802,5810),(136803,5811),(136804,5812),(136805,5813),(136806,5814),(136807,5815),(136808,5816),(136809,5817),(136810,5818),(136811,5819),(136812,5820),(136813,5821),(136814,5822),(136815,5823),(136816,5824),(136817,5825),(136818,5826),(136819,5827),(136820,5828),(136821,5829),(136822,5830),(136823,5831),(136824,5832),(136825,5833),(136826,5834),(136827,5835),(136828,5836),(136829,5837),(136830,5838),(136831,5839),(136832,5840),(136833,5841),(136834,5842),(136835,5843),(136836,5844),(136837,5845),(136838,5846),(136839,5847),(136840,5848),(136841,5849),(136842,5850),(136843,5851),(136844,5852),(136845,5853),(136846,5854),(136847,5855),(136848,5856),(136849,5857),(136850,5858),(136851,5859),(136852,5860),(136853,5761),(136854,5761),(136855,5761),(136856,5761),(136857,5761),(136858,5761),(136859,5761),(136860,5762),(136861,5762),(136862,5762),(136863,5762),(136864,5762),(136865,5762),(136866,5762),(136867,5763),(136868,5763),(136869,5763),(136870,5763),(136871,5763),(136872,5763),(136873,5763),(136874,5764),(136875,5764),(136876,5764),(136877,5764),(136878,5764),(136879,5764),(136880,5764),(136881,5765),(136882,5765),(136883,5765),(136884,5765),(136885,5765),(136886,5765),(136887,5765),(136888,5766),(136889,5766),(136890,5766),(136891,5766),(136892,5766),(136893,5766),(136894,5766),(136895,5767),(136896,5767),(136897,5767),(136898,5767),(136899,5767),(136900,5767),(136901,5767),(136902,5768),(136903,5768),(136904,5768),(136905,5768),(136906,5768),(136907,5768),(136908,5768),(136909,5769),(136910,5769),(136911,5769),(136912,5769),(136913,5770),(136914,5770),(136915,5770),(136916,5770),(136917,5770),(136918,5770),(136919,5771),(136920,5771),(136921,5771),(136922,5771),(136923,5772),(136924,5772),(136925,5772),(136926,5772),(136927,5773),(136928,5773),(136929,5773),(136930,5773),(136931,5774),(136932,5774),(136933,5774),(136934,5774),(136935,5775),(136936,5775),(136937,5775),(136938,5775),(136939,5776),(136940,5776),(136941,5776),(136942,5776),(136943,5777),(136944,5777),(136945,5777),(136946,5777),(136947,5777),(136948,5777),(136949,5777),(136950,5778),(136951,5778),(136952,5778),(136953,5778),(136954,5778),(136955,5778),(136956,5778),(136957,5779),(136958,5779),(136959,5779),(136960,5779),(136961,5779),(136962,5779),(136963,5779),(136964,5780),(136965,5780),(136966,5780),(136967,5780),(136968,5781),(136969,5781),(136970,5781),(136971,5781),(136972,5781),(136973,5781),(136974,5781),(136975,5782),(136976,5782),(136977,5782),(136978,5782),(136979,5782),(136980,5782),(136981,5782),(136982,5783),(136983,5783),(136984,5783),(136985,5783),(136986,5783),(136987,5783),(136988,5783),(136989,5784),(136990,5784),(136991,5784),(136992,5784),(136993,5784),(136994,5784),(136995,5784),(136996,5785),(136997,5785),(136998,5785),(136999,5785),(137000,5785),(137001,5785),(137002,5785),(137003,5786),(137004,5786),(137005,5786),(137006,5786),(137007,5786),(137008,5786),(137009,5786),(137010,5787),(137011,5787),(137012,5787),(137013,5787),(137014,5788),(137015,5788),(137016,5788),(137017,5788),(137018,5788),(137019,5788),(137020,5788),(137021,5789),(137022,5789),(137023,5789),(137024,5789),(137025,5789),(137026,5789),(137027,5789),(137028,5790),(137029,5790),(137030,5790),(137031,5790),(137032,5790),(137033,5790),(137034,5790),(137035,5791),(137036,5791),(137037,5791),(137038,5791),(137039,5791),(137040,5791),(137041,5791),(137042,5792),(137043,5792),(137044,5792),(137045,5792),(137046,5792),(137047,5792),(137048,5792),(137049,5793),(137050,5793),(137051,5793),(137052,5793),(137053,5793),(137054,5793),(137055,5794),(137056,5794),(137057,5794),(137058,5794),(137059,5794),(137060,5794),(137061,5794),(137062,5795),(137063,5795),(137064,5795),(137065,5795),(137066,5795),(137067,5795),(137068,5795),(137069,5796),(137070,5796),(137071,5796),(137072,5796),(137073,5796),(137074,5796),(137075,5796),(137076,5797),(137077,5797),(137078,5797),(137079,5797),(137080,5797),(137081,5797),(137082,5797),(137083,5798),(137084,5798),(137085,5798),(137086,5798),(137087,5798),(137088,5798),(137089,5798),(137090,5799),(137091,5799),(137092,5799),(137093,5799),(137094,5799),(137095,5799),(137096,5799),(137097,5800),(137098,5800),(137099,5800),(137100,5800),(137101,5800),(137102,5800),(137103,5800),(137104,5801),(137105,5801),(137106,5801),(137107,5801),(137108,5801),(137109,5801),(137110,5801),(137111,5802),(137112,5802),(137113,5802),(137114,5802),(137115,5802),(137116,5802),(137117,5802),(137118,5803),(137119,5803),(137120,5803),(137121,5803),(137122,5803),(137123,5803),(137124,5803),(137125,5804),(137126,5804),(137127,5804),(137128,5804),(137129,5804),(137130,5804),(137131,5804),(137132,5805),(137133,5805),(137134,5805),(137135,5805),(137136,5805),(137137,5805),(137138,5805),(137139,5806),(137140,5806),(137141,5806),(137142,5806),(137143,5806),(137144,5806),(137145,5806),(137146,5807),(137147,5807),(137148,5807),(137149,5807),(137150,5807),(137151,5807),(137152,5807),(137153,5807),(137154,5807),(137155,5808),(137156,5808),(137157,5808),(137158,5808),(137159,5808),(137160,5808),(137161,5808),(137162,5808),(137163,5808),(137164,5809),(137165,5809),(137166,5809),(137167,5809),(137168,5809),(137169,5809),(137170,5809),(137171,5809),(137172,5809),(137173,5810),(137174,5810),(137175,5810),(137176,5810),(137177,5810),(137178,5810),(137179,5810),(137180,5810),(137181,5810),(137182,5811),(137183,5811),(137184,5811),(137185,5811),(137186,5811),(137187,5811),(137188,5811),(137189,5811),(137190,5811),(137191,5812),(137192,5812),(137193,5812),(137194,5812),(137195,5812),(137196,5812),(137197,5812),(137198,5812),(137199,5812),(137200,5813),(137201,5813),(137202,5813),(137203,5813),(137204,5813),(137205,5813),(137206,5813),(137207,5813),(137208,5813),(137209,5814),(137210,5814),(137211,5814),(137212,5814),(137213,5814),(137214,5814),(137215,5814),(137216,5814),(137217,5814),(137218,5815),(137219,5815),(137220,5815),(137221,5815),(137222,5815),(137223,5815),(137224,5815),(137225,5815),(137226,5815),(137227,5816),(137228,5816),(137229,5816),(137230,5816),(137231,5816),(137232,5816),(137233,5816),(137234,5816),(137235,5816),(137236,5817),(137237,5817),(137238,5817),(137239,5817),(137240,5817),(137241,5817),(137242,5817),(137243,5817),(137244,5817),(137245,5818),(137246,5818),(137247,5818),(137248,5818),(137249,5818),(137250,5818),(137251,5818),(137252,5818),(137253,5818),(137254,5819),(137255,5819),(137256,5819),(137257,5819),(137258,5819),(137259,5819),(137260,5819),(137261,5820),(137262,5820),(137263,5820),(137264,5820),(137265,5820),(137266,5820),(137267,5820),(137268,5821),(137269,5821),(137270,5821),(137271,5821),(137272,5821),(137273,5821),(137274,5821),(137275,5822),(137276,5822),(137277,5822),(137278,5822),(137279,5823),(137280,5823),(137281,5823),(137282,5823),(137283,5824),(137284,5824),(137285,5824),(137286,5824),(137287,5824),(137288,5824),(137289,5824),(137290,5825),(137291,5825),(137292,5825),(137293,5825),(137294,5826),(137295,5826),(137296,5826),(137297,5826),(137298,5827),(137299,5827),(137300,5827),(137301,5827),(137302,5828),(137303,5828),(137304,5828),(137305,5828),(137306,5829),(137307,5829),(137308,5829),(137309,5829),(137310,5830),(137311,5830),(137312,5830),(137313,5830),(137314,5831),(137315,5831),(137316,5831),(137317,5831),(137318,5832),(137319,5832),(137320,5832),(137321,5832),(137322,5832),(137323,5832),(137324,5832),(137325,5833),(137326,5833),(137327,5833),(137328,5833),(137329,5833),(137330,5833),(137331,5833),(137332,5834),(137333,5834),(137334,5834),(137335,5834),(137336,5834),(137337,5834),(137338,5834),(137339,5835),(137340,5835),(137341,5835),(137342,5835),(137343,5835),(137344,5835),(137345,5835),(137346,5836),(137347,5836),(137348,5836),(137349,5836),(137350,5836),(137351,5836),(137352,5836),(137353,5837),(137354,5837),(137355,5837),(137356,5837),(137357,5837),(137358,5837),(137359,5837),(137360,5838),(137361,5838),(137362,5838),(137363,5838),(137364,5838),(137365,5838),(137366,5838),(137367,5839),(137368,5839),(137369,5839),(137370,5839),(137371,5839),(137372,5839),(137373,5839),(137374,5840),(137375,5840),(137376,5840),(137377,5840),(137378,5840),(137379,5840),(137380,5840),(137381,5840),(137382,5840),(137383,5841),(137384,5841),(137385,5841),(137386,5841),(137387,5841),(137388,5841),(137389,5841),(137390,5842),(137391,5842),(137392,5842),(137393,5842),(137394,5842),(137395,5842),(137396,5842),(137397,5843),(137398,5843),(137399,5843),(137400,5843),(137401,5843),(137402,5843),(137403,5843),(137404,5843),(137405,5843),(137406,5844),(137407,5844),(137408,5844),(137409,5844),(137410,5844),(137411,5844),(137412,5844),(137413,5845),(137414,5845),(137415,5845),(137416,5845),(137417,5845),(137418,5845),(137419,5845),(137420,5846),(137421,5846),(137422,5846),(137423,5846),(137424,5846),(137425,5846),(137426,5846),(137427,5847),(137428,5847),(137429,5847),(137430,5847),(137431,5847),(137432,5847),(137433,5847),(137434,5848),(137435,5848),(137436,5848),(137437,5848),(137438,5848),(137439,5848),(137440,5848),(137441,5849),(137442,5849),(137443,5849),(137444,5849),(137445,5849),(137446,5849),(137447,5849),(137448,5850),(137449,5850),(137450,5850),(137451,5850),(137452,5850),(137453,5850),(137454,5850),(137455,5850),(137456,5850),(137457,5851),(137458,5851),(137459,5851),(137460,5851),(137461,5851),(137462,5851),(137463,5851),(137464,5851),(137465,5851),(137466,5852),(137467,5852),(137468,5852),(137469,5852),(137470,5852),(137471,5852),(137472,5852),(137473,5852),(137474,5852),(137475,5853),(137476,5853),(137477,5853),(137478,5853),(137479,5853),(137480,5853),(137481,5853),(137482,5853),(137483,5853),(137484,5854),(137485,5854),(137486,5854),(137487,5854),(137488,5854),(137489,5854),(137490,5854),(137491,5854),(137492,5854),(137493,5855),(137494,5855),(137495,5855),(137496,5855),(137497,5855),(137498,5855),(137499,5855),(137500,5855),(137501,5855),(137502,5856),(137503,5856),(137504,5856),(137505,5856),(137506,5856),(137507,5856),(137508,5856),(137509,5856),(137510,5856),(137511,5857),(137512,5857),(137513,5857),(137514,5857),(137515,5857),(137516,5857),(137517,5857),(137518,5857),(137519,5857),(137520,5858),(137521,5858),(137522,5858),(137523,5858),(137524,5858),(137525,5858),(137526,5858),(137527,5858),(137528,5858),(137529,5859),(137530,5859),(137531,5859),(137532,5859),(137533,5859),(137534,5859),(137535,5859),(137536,5859),(137537,5859),(137538,5860),(137539,5860),(137540,5860),(137541,5860),(137542,5860),(137543,5860),(137544,5860),(137545,5860),(137546,5860),(137547,5761),(137548,5761),(137549,5761),(137550,5762),(137551,5762),(137552,5762),(137553,5763),(137554,5763),(137555,5763),(137556,5764),(137557,5764),(137558,5764),(137559,5765),(137560,5765),(137561,5765),(137562,5766),(137563,5766),(137564,5766),(137565,5767),(137566,5767),(137567,5767),(137568,5768),(137569,5768),(137570,5768),(137571,5769),(137572,5769),(137573,5769),(137574,5770),(137575,5770),(137576,5770),(137577,5771),(137578,5771),(137579,5771),(137580,5772),(137581,5772),(137582,5772),(137583,5773),(137584,5773),(137585,5773),(137586,5774),(137587,5774),(137588,5774),(137589,5775),(137590,5775),(137591,5775),(137592,5776),(137593,5776),(137594,5776),(137595,5777),(137596,5777),(137597,5777),(137598,5778),(137599,5778),(137600,5778),(137601,5779),(137602,5779),(137603,5779),(137604,5780),(137605,5780),(137606,5780),(137607,5781),(137608,5781),(137609,5781),(137610,5782),(137611,5782),(137612,5782),(137613,5783),(137614,5783),(137615,5783),(137616,5784),(137617,5784),(137618,5784),(137619,5785),(137620,5785),(137621,5785),(137622,5786),(137623,5786),(137624,5786),(137625,5787),(137626,5787),(137627,5787),(137628,5788),(137629,5788),(137630,5788),(137631,5789),(137632,5789),(137633,5789),(137634,5790),(137635,5790),(137636,5790),(137637,5791),(137638,5791),(137639,5791),(137640,5792),(137641,5792),(137642,5792),(137643,5793),(137644,5794),(137645,5794),(137646,5794),(137647,5795),(137648,5795),(137649,5795),(137650,5796),(137651,5796),(137652,5796),(137653,5797),(137654,5797),(137655,5797),(137656,5798),(137657,5798),(137658,5798),(137659,5799),(137660,5799),(137661,5799),(137662,5800),(137663,5800),(137664,5800),(137665,5801),(137666,5801),(137667,5801),(137668,5802),(137669,5802),(137670,5802),(137671,5803),(137672,5803),(137673,5803),(137674,5804),(137675,5804),(137676,5804),(137677,5805),(137678,5805),(137679,5805),(137680,5806),(137681,5806),(137682,5806),(137683,5807),(137684,5807),(137685,5807),(137686,5808),(137687,5808),(137688,5808),(137689,5809),(137690,5809),(137691,5809),(137692,5810),(137693,5810),(137694,5810),(137695,5811),(137696,5811),(137697,5811),(137698,5812),(137699,5812),(137700,5812),(137701,5813),(137702,5813),(137703,5813),(137704,5814),(137705,5814),(137706,5814),(137707,5815),(137708,5815),(137709,5815),(137710,5816),(137711,5816),(137712,5816),(137713,5817),(137714,5817),(137715,5817),(137716,5818),(137717,5818),(137718,5818),(137719,5819),(137720,5819),(137721,5819),(137722,5820),(137723,5820),(137724,5820),(137725,5821),(137726,5821),(137727,5821),(137728,5822),(137729,5822),(137730,5822),(137731,5823),(137732,5823),(137733,5823),(137734,5824),(137735,5824),(137736,5824),(137737,5825),(137738,5825),(137739,5825),(137740,5826),(137741,5826),(137742,5826),(137743,5827),(137744,5827),(137745,5827),(137746,5828),(137747,5828),(137748,5828),(137749,5829),(137750,5829),(137751,5829),(137752,5830),(137753,5830),(137754,5830),(137755,5831),(137756,5831),(137757,5831),(137758,5832),(137759,5832),(137760,5832),(137761,5833),(137762,5833),(137763,5833),(137764,5834),(137765,5834),(137766,5834),(137767,5835),(137768,5835),(137769,5835),(137770,5836),(137771,5836),(137772,5836),(137773,5837),(137774,5837),(137775,5837),(137776,5838),(137777,5838),(137778,5838),(137779,5839),(137780,5839),(137781,5839),(137782,5840),(137783,5840),(137784,5840),(137785,5841),(137786,5841),(137787,5841),(137788,5842),(137789,5842),(137790,5842),(137791,5843),(137792,5843),(137793,5843),(137794,5844),(137795,5844),(137796,5844),(137797,5845),(137798,5845),(137799,5845),(137800,5846),(137801,5846),(137802,5846),(137803,5847),(137804,5847),(137805,5847),(137806,5848),(137807,5848),(137808,5848),(137809,5849),(137810,5849),(137811,5849),(137812,5850),(137813,5850),(137814,5851),(137815,5851),(137816,5852),(137817,5852),(137818,5853),(137819,5853),(137820,5854),(137821,5854),(137822,5855),(137823,5855),(137824,5856),(137825,5856),(137826,5857),(137827,5857),(137828,5858),(137829,5858),(137830,5859),(137831,5859),(137832,5860),(137833,5860),(137834,5761),(137835,5761),(137836,5761),(137837,5761),(137838,5761),(137839,5761),(137840,5761),(137841,5761),(137842,5761),(137843,5761),(137844,5761),(137845,5762),(137846,5762),(137847,5762),(137848,5762),(137849,5762),(137850,5762),(137851,5762),(137852,5762),(137853,5762),(137854,5762),(137855,5762),(137856,5763),(137857,5763),(137858,5763),(137859,5763),(137860,5763),(137861,5763),(137862,5763),(137863,5763),(137864,5763),(137865,5763),(137866,5763),(137867,5764),(137868,5764),(137869,5764),(137870,5764),(137871,5764),(137872,5764),(137873,5764),(137874,5764),(137875,5764),(137876,5764),(137877,5764),(137878,5765),(137879,5765),(137880,5765),(137881,5765),(137882,5765),(137883,5765),(137884,5765),(137885,5765),(137886,5765),(137887,5765),(137888,5765),(137889,5766),(137890,5766),(137891,5766),(137892,5766),(137893,5766),(137894,5766),(137895,5766),(137896,5766),(137897,5766),(137898,5766),(137899,5766),(137900,5767),(137901,5767),(137902,5767),(137903,5767),(137904,5767),(137905,5767),(137906,5767),(137907,5767),(137908,5767),(137909,5767),(137910,5767),(137911,5768),(137912,5768),(137913,5768),(137914,5768),(137915,5768),(137916,5768),(137917,5768),(137918,5768),(137919,5768),(137920,5768),(137921,5768),(137922,5769),(137923,5769),(137924,5769),(137925,5769),(137926,5769),(137927,5769),(137928,5769),(137929,5769),(137930,5769),(137931,5769),(137932,5769),(137933,5770),(137934,5770),(137935,5770),(137936,5770),(137937,5770),(137938,5770),(137939,5770),(137940,5770),(137941,5770),(137942,5770),(137943,5770),(137944,5771),(137945,5771),(137946,5771),(137947,5771),(137948,5771),(137949,5771),(137950,5771),(137951,5771),(137952,5771),(137953,5771),(137954,5771),(137955,5772),(137956,5772),(137957,5772),(137958,5772),(137959,5772),(137960,5772),(137961,5772),(137962,5772),(137963,5772),(137964,5772),(137965,5772),(137966,5773),(137967,5773),(137968,5773),(137969,5773),(137970,5773),(137971,5773),(137972,5773),(137973,5773),(137974,5773),(137975,5773),(137976,5773),(137977,5774),(137978,5774),(137979,5774),(137980,5774),(137981,5774),(137982,5774),(137983,5774),(137984,5774),(137985,5774),(137986,5774),(137987,5774),(137988,5775),(137989,5775),(137990,5775),(137991,5775),(137992,5775),(137993,5775),(137994,5775),(137995,5775),(137996,5775),(137997,5775),(137998,5775),(137999,5776),(138000,5776),(138001,5776),(138002,5776),(138003,5776),(138004,5776),(138005,5776),(138006,5776),(138007,5776),(138008,5776),(138009,5776),(138010,5777),(138011,5777),(138012,5777),(138013,5777),(138014,5777),(138015,5777),(138016,5777),(138017,5777),(138018,5777),(138019,5777),(138020,5777),(138021,5778),(138022,5778),(138023,5778),(138024,5778),(138025,5778),(138026,5778),(138027,5778),(138028,5778),(138029,5778),(138030,5778),(138031,5778),(138032,5779),(138033,5779),(138034,5779),(138035,5779),(138036,5779),(138037,5779),(138038,5779),(138039,5779),(138040,5779),(138041,5779),(138042,5779),(138043,5780),(138044,5780),(138045,5780),(138046,5780),(138047,5780),(138048,5780),(138049,5780),(138050,5780),(138051,5780),(138052,5780),(138053,5780),(138054,5781),(138055,5781),(138056,5781),(138057,5781),(138058,5781),(138059,5781),(138060,5781),(138061,5781),(138062,5781),(138063,5781),(138064,5781),(138065,5782),(138066,5782),(138067,5782),(138068,5782),(138069,5782),(138070,5782),(138071,5782),(138072,5782),(138073,5782),(138074,5782),(138075,5782),(138076,5783),(138077,5783),(138078,5783),(138079,5783),(138080,5783),(138081,5783),(138082,5783),(138083,5783),(138084,5783),(138085,5783),(138086,5783),(138087,5784),(138088,5784),(138089,5784),(138090,5784),(138091,5784),(138092,5784),(138093,5784),(138094,5784),(138095,5784),(138096,5784),(138097,5784),(138098,5785),(138099,5785),(138100,5785),(138101,5785),(138102,5785),(138103,5785),(138104,5785),(138105,5785),(138106,5785),(138107,5785),(138108,5785),(138109,5786),(138110,5786),(138111,5786),(138112,5786),(138113,5786),(138114,5786),(138115,5786),(138116,5786),(138117,5786),(138118,5786),(138119,5786),(138120,5787),(138121,5787),(138122,5787),(138123,5787),(138124,5787),(138125,5787),(138126,5787),(138127,5787),(138128,5787),(138129,5787),(138130,5787),(138131,5788),(138132,5788),(138133,5788),(138134,5788),(138135,5788),(138136,5788),(138137,5788),(138138,5788),(138139,5788),(138140,5788),(138141,5788),(138142,5789),(138143,5789),(138144,5789),(138145,5789),(138146,5789),(138147,5789),(138148,5789),(138149,5789),(138150,5789),(138151,5789),(138152,5789),(138153,5790),(138154,5790),(138155,5790),(138156,5790),(138157,5790),(138158,5790),(138159,5790),(138160,5790),(138161,5790),(138162,5790),(138163,5790),(138164,5791),(138165,5791),(138166,5791),(138167,5791),(138168,5791),(138169,5791),(138170,5791),(138171,5791),(138172,5791),(138173,5791),(138174,5791),(138175,5792),(138176,5792),(138177,5792),(138178,5792),(138179,5792),(138180,5792),(138181,5792),(138182,5792),(138183,5792),(138184,5792),(138185,5792),(138186,5793),(138187,5793),(138188,5793),(138189,5793),(138190,5793),(138191,5793),(138192,5793),(138193,5793),(138194,5793),(138195,5793),(138196,5793),(138197,5794),(138198,5794),(138199,5794),(138200,5794),(138201,5794),(138202,5794),(138203,5794),(138204,5794),(138205,5794),(138206,5794),(138207,5794),(138208,5795),(138209,5795),(138210,5795),(138211,5795),(138212,5795),(138213,5795),(138214,5795),(138215,5795),(138216,5795),(138217,5795),(138218,5795),(138219,5796),(138220,5796),(138221,5796),(138222,5796),(138223,5796),(138224,5796),(138225,5796),(138226,5796),(138227,5796),(138228,5796),(138229,5796),(138230,5797),(138231,5797),(138232,5797),(138233,5797),(138234,5797),(138235,5797),(138236,5797),(138237,5797),(138238,5797),(138239,5797),(138240,5797),(138241,5798),(138242,5798),(138243,5798),(138244,5798),(138245,5798),(138246,5798),(138247,5798),(138248,5798),(138249,5798),(138250,5798),(138251,5798),(138252,5799),(138253,5799),(138254,5799),(138255,5799),(138256,5799),(138257,5799),(138258,5799),(138259,5799),(138260,5799),(138261,5799),(138262,5799),(138263,5800),(138264,5800),(138265,5800),(138266,5800),(138267,5800),(138268,5800),(138269,5800),(138270,5800),(138271,5800),(138272,5800),(138273,5800),(138274,5801),(138275,5801),(138276,5801),(138277,5801),(138278,5801),(138279,5801),(138280,5801),(138281,5801),(138282,5801),(138283,5801),(138284,5801),(138285,5802),(138286,5802),(138287,5802),(138288,5802),(138289,5802),(138290,5802),(138291,5802),(138292,5802),(138293,5802),(138294,5802),(138295,5802),(138296,5803),(138297,5803),(138298,5803),(138299,5803),(138300,5803),(138301,5803),(138302,5803),(138303,5803),(138304,5803),(138305,5803),(138306,5803),(138307,5804),(138308,5804),(138309,5804),(138310,5804),(138311,5804),(138312,5804),(138313,5804),(138314,5804),(138315,5804),(138316,5804),(138317,5804),(138318,5805),(138319,5805),(138320,5805),(138321,5805),(138322,5805),(138323,5805),(138324,5805),(138325,5805),(138326,5805),(138327,5805),(138328,5805),(138329,5806),(138330,5806),(138331,5806),(138332,5806),(138333,5806),(138334,5806),(138335,5806),(138336,5806),(138337,5806),(138338,5806),(138339,5806),(138340,5807),(138341,5807),(138342,5807),(138343,5807),(138344,5807),(138345,5807),(138346,5807),(138347,5807),(138348,5807),(138349,5807),(138350,5807),(138351,5808),(138352,5808),(138353,5808),(138354,5808),(138355,5808),(138356,5808),(138357,5808),(138358,5808),(138359,5808),(138360,5808),(138361,5808),(138362,5809),(138363,5809),(138364,5809),(138365,5809),(138366,5809),(138367,5809),(138368,5809),(138369,5809),(138370,5809),(138371,5809),(138372,5809),(138373,5810),(138374,5810),(138375,5810),(138376,5810),(138377,5810),(138378,5810),(138379,5810),(138380,5810),(138381,5810),(138382,5810),(138383,5810),(138384,5811),(138385,5811),(138386,5811),(138387,5811),(138388,5811),(138389,5811),(138390,5811),(138391,5811),(138392,5811),(138393,5811),(138394,5811),(138395,5812),(138396,5812),(138397,5812),(138398,5812),(138399,5812),(138400,5812),(138401,5812),(138402,5812),(138403,5812),(138404,5812),(138405,5812),(138406,5813),(138407,5813),(138408,5813),(138409,5813),(138410,5813),(138411,5813),(138412,5813),(138413,5813),(138414,5813),(138415,5813),(138416,5813),(138417,5814),(138418,5814),(138419,5814),(138420,5814),(138421,5814),(138422,5814),(138423,5814),(138424,5814),(138425,5814),(138426,5814),(138427,5814),(138428,5815),(138429,5815),(138430,5815),(138431,5815),(138432,5815),(138433,5815),(138434,5815),(138435,5815),(138436,5815),(138437,5815),(138438,5815),(138439,5816),(138440,5816),(138441,5816),(138442,5816),(138443,5816),(138444,5816),(138445,5816),(138446,5816),(138447,5816),(138448,5816),(138449,5816),(138450,5817),(138451,5817),(138452,5817),(138453,5817),(138454,5817),(138455,5817),(138456,5817),(138457,5817),(138458,5817),(138459,5817),(138460,5817),(138461,5818),(138462,5818),(138463,5818),(138464,5818),(138465,5818),(138466,5818),(138467,5818),(138468,5818),(138469,5818),(138470,5818),(138471,5818),(138472,5819),(138473,5819),(138474,5819),(138475,5819),(138476,5819),(138477,5819),(138478,5819),(138479,5819),(138480,5819),(138481,5819),(138482,5819),(138483,5820),(138484,5820),(138485,5820),(138486,5820),(138487,5820),(138488,5820),(138489,5820),(138490,5820),(138491,5820),(138492,5820),(138493,5820),(138494,5821),(138495,5821),(138496,5821),(138497,5821),(138498,5821),(138499,5821),(138500,5821),(138501,5821),(138502,5821),(138503,5821),(138504,5821),(138505,5822),(138506,5822),(138507,5822),(138508,5822),(138509,5822),(138510,5822),(138511,5822),(138512,5822),(138513,5822),(138514,5822),(138515,5822),(138516,5823),(138517,5823),(138518,5823),(138519,5823),(138520,5823),(138521,5823),(138522,5823),(138523,5823),(138524,5823),(138525,5823),(138526,5823),(138527,5824),(138528,5824),(138529,5824),(138530,5824),(138531,5824),(138532,5824),(138533,5824),(138534,5824),(138535,5824),(138536,5824),(138537,5824),(138538,5825),(138539,5825),(138540,5825),(138541,5825),(138542,5825),(138543,5825),(138544,5825),(138545,5825),(138546,5825),(138547,5825),(138548,5825),(138549,5826),(138550,5826),(138551,5826),(138552,5826),(138553,5826),(138554,5826),(138555,5826),(138556,5826),(138557,5826),(138558,5826),(138559,5826),(138560,5827),(138561,5827),(138562,5827),(138563,5827),(138564,5827),(138565,5827),(138566,5827),(138567,5827),(138568,5827),(138569,5827),(138570,5827),(138571,5828),(138572,5828),(138573,5828),(138574,5828),(138575,5828),(138576,5828),(138577,5828),(138578,5828),(138579,5828),(138580,5828),(138581,5828),(138582,5829),(138583,5829),(138584,5829),(138585,5829),(138586,5829),(138587,5829),(138588,5829),(138589,5829),(138590,5829),(138591,5829),(138592,5829),(138593,5830),(138594,5830),(138595,5830),(138596,5830),(138597,5830),(138598,5830),(138599,5830),(138600,5830),(138601,5830),(138602,5830),(138603,5830),(138604,5831),(138605,5831),(138606,5831),(138607,5831),(138608,5831),(138609,5831),(138610,5831),(138611,5831),(138612,5831),(138613,5831),(138614,5831),(138615,5832),(138616,5832),(138617,5832),(138618,5832),(138619,5832),(138620,5832),(138621,5832),(138622,5832),(138623,5832),(138624,5832),(138625,5832),(138626,5833),(138627,5833),(138628,5833),(138629,5833),(138630,5833),(138631,5833),(138632,5833),(138633,5833),(138634,5833),(138635,5833),(138636,5833),(138637,5834),(138638,5834),(138639,5834),(138640,5834),(138641,5834),(138642,5834),(138643,5834),(138644,5834),(138645,5834),(138646,5834),(138647,5834),(138648,5835),(138649,5835),(138650,5835),(138651,5835),(138652,5835),(138653,5835),(138654,5835),(138655,5835),(138656,5835),(138657,5835),(138658,5835),(138659,5836),(138660,5836),(138661,5836),(138662,5836),(138663,5836),(138664,5836),(138665,5836),(138666,5836),(138667,5836),(138668,5836),(138669,5836),(138670,5837),(138671,5837),(138672,5837),(138673,5837),(138674,5837),(138675,5837),(138676,5837),(138677,5837),(138678,5837),(138679,5837),(138680,5837),(138681,5838),(138682,5838),(138683,5838),(138684,5838),(138685,5838),(138686,5838),(138687,5838),(138688,5838),(138689,5838),(138690,5838),(138691,5838),(138692,5839),(138693,5839),(138694,5839),(138695,5839),(138696,5839),(138697,5839),(138698,5839),(138699,5839),(138700,5839),(138701,5839),(138702,5839),(138703,5840),(138704,5840),(138705,5840),(138706,5840),(138707,5840),(138708,5840),(138709,5840),(138710,5840),(138711,5840),(138712,5840),(138713,5840),(138714,5841),(138715,5841),(138716,5841),(138717,5841),(138718,5841),(138719,5841),(138720,5841),(138721,5841),(138722,5841),(138723,5841),(138724,5841),(138725,5842),(138726,5842),(138727,5842),(138728,5842),(138729,5842),(138730,5842),(138731,5842),(138732,5842),(138733,5842),(138734,5842),(138735,5842),(138736,5843),(138737,5843),(138738,5843),(138739,5843),(138740,5843),(138741,5843),(138742,5843),(138743,5843),(138744,5843),(138745,5843),(138746,5843),(138747,5844),(138748,5844),(138749,5844),(138750,5844),(138751,5844),(138752,5844),(138753,5844),(138754,5844),(138755,5844),(138756,5844),(138757,5844),(138758,5845),(138759,5845),(138760,5845),(138761,5845),(138762,5845),(138763,5845),(138764,5845),(138765,5845),(138766,5845),(138767,5845),(138768,5845),(138769,5846),(138770,5846),(138771,5846),(138772,5846),(138773,5846),(138774,5846),(138775,5846),(138776,5846),(138777,5846),(138778,5846),(138779,5846),(138780,5847),(138781,5847),(138782,5847),(138783,5847),(138784,5847),(138785,5847),(138786,5847),(138787,5847),(138788,5847),(138789,5847),(138790,5847),(138791,5848),(138792,5848),(138793,5848),(138794,5848),(138795,5848),(138796,5848),(138797,5848),(138798,5848),(138799,5848),(138800,5848),(138801,5848),(138802,5849),(138803,5849),(138804,5849),(138805,5849),(138806,5849),(138807,5849),(138808,5849),(138809,5849),(138810,5849),(138811,5849),(138812,5849),(138813,5850),(138814,5850),(138815,5850),(138816,5850),(138817,5850),(138818,5850),(138819,5850),(138820,5850),(138821,5850),(138822,5850),(138823,5850),(138824,5851),(138825,5851),(138826,5851),(138827,5851),(138828,5851),(138829,5851),(138830,5851),(138831,5851),(138832,5851),(138833,5851),(138834,5851),(138835,5852),(138836,5852),(138837,5852),(138838,5852),(138839,5852),(138840,5852),(138841,5852),(138842,5852),(138843,5852),(138844,5852),(138845,5852),(138846,5853),(138847,5853),(138848,5853),(138849,5853),(138850,5853),(138851,5853),(138852,5853),(138853,5853),(138854,5853),(138855,5853),(138856,5853),(138857,5854),(138858,5854),(138859,5854),(138860,5854),(138861,5854),(138862,5854),(138863,5854),(138864,5854),(138865,5854),(138866,5854),(138867,5854),(138868,5855),(138869,5855),(138870,5855),(138871,5855),(138872,5855),(138873,5855),(138874,5855),(138875,5855),(138876,5855),(138877,5855),(138878,5855),(138879,5856),(138880,5856),(138881,5856),(138882,5856),(138883,5856),(138884,5856),(138885,5856),(138886,5856),(138887,5856),(138888,5856),(138889,5856),(138890,5857),(138891,5857),(138892,5857),(138893,5857),(138894,5857),(138895,5857),(138896,5857),(138897,5857),(138898,5857),(138899,5857),(138900,5857),(138901,5858),(138902,5858),(138903,5858),(138904,5858),(138905,5858),(138906,5858),(138907,5858),(138908,5858),(138909,5858),(138910,5858),(138911,5858),(138912,5859),(138913,5859),(138914,5859),(138915,5859),(138916,5859),(138917,5859),(138918,5859),(138919,5859),(138920,5859),(138921,5859),(138922,5859),(138923,5860),(138924,5860),(138925,5860),(138926,5860),(138927,5860),(138928,5860),(138929,5860),(138930,5860),(138931,5860),(138932,5860),(138933,5860),(138934,5761),(138935,5761),(138936,5761),(138937,5761),(138938,5762),(138939,5762),(138940,5762),(138941,5762),(138942,5763),(138943,5763),(138944,5763),(138945,5763),(138946,5764),(138947,5764),(138948,5764),(138949,5764),(138950,5765),(138951,5765),(138952,5765),(138953,5765),(138954,5766),(138955,5766),(138956,5766),(138957,5766),(138958,5767),(138959,5767),(138960,5767),(138961,5767),(138962,5768),(138963,5768),(138964,5768),(138965,5768),(138966,5769),(138967,5769),(138968,5769),(138969,5770),(138970,5770),(138971,5770),(138972,5771),(138973,5771),(138974,5771),(138975,5772),(138976,5772),(138977,5772),(138978,5773),(138979,5773),(138980,5773),(138981,5774),(138982,5774),(138983,5774),(138984,5775),(138985,5775),(138986,5775),(138987,5776),(138988,5776),(138989,5776),(138990,5777),(138991,5777),(138992,5777),(138993,5777),(138994,5778),(138995,5778),(138996,5778),(138997,5778),(138998,5779),(138999,5779),(139000,5779),(139001,5779),(139002,5780),(139003,5780),(139004,5780),(139005,5781),(139006,5781),(139007,5781),(139008,5781),(139009,5782),(139010,5782),(139011,5782),(139012,5782),(139013,5783),(139014,5783),(139015,5783),(139016,5783),(139017,5784),(139018,5784),(139019,5784),(139020,5784),(139021,5785),(139022,5785),(139023,5785),(139024,5786),(139025,5786),(139026,5786),(139027,5786),(139028,5787),(139029,5787),(139030,5787),(139031,5788),(139032,5788),(139033,5788),(139034,5789),(139035,5789),(139036,5789),(139037,5790),(139038,5790),(139039,5790),(139040,5791),(139041,5791),(139042,5791),(139043,5791),(139044,5792),(139045,5792),(139046,5792),(139047,5792),(139048,5793),(139049,5793),(139050,5793),(139051,5794),(139052,5794),(139053,5794),(139054,5794),(139055,5795),(139056,5795),(139057,5795),(139058,5795),(139059,5796),(139060,5796),(139061,5796),(139062,5796),(139063,5797),(139064,5797),(139065,5797),(139066,5797),(139067,5798),(139068,5798),(139069,5798),(139070,5798),(139071,5799),(139072,5799),(139073,5799),(139074,5799),(139075,5800),(139076,5800),(139077,5800),(139078,5800),(139079,5801),(139080,5801),(139081,5801),(139082,5801),(139083,5802),(139084,5802),(139085,5802),(139086,5802),(139087,5803),(139088,5803),(139089,5803),(139090,5803),(139091,5804),(139092,5804),(139093,5804),(139094,5804),(139095,5805),(139096,5805),(139097,5805),(139098,5805),(139099,5806),(139100,5806),(139101,5806),(139102,5806),(139103,5807),(139104,5807),(139105,5807),(139106,5807),(139107,5808),(139108,5808),(139109,5808),(139110,5808),(139111,5809),(139112,5809),(139113,5809),(139114,5809),(139115,5810),(139116,5810),(139117,5810),(139118,5810),(139119,5811),(139120,5811),(139121,5811),(139122,5811),(139123,5812),(139124,5812),(139125,5812),(139126,5812),(139127,5813),(139128,5813),(139129,5813),(139130,5813),(139131,5814),(139132,5814),(139133,5814),(139134,5814),(139135,5815),(139136,5815),(139137,5815),(139138,5815),(139139,5816),(139140,5816),(139141,5816),(139142,5816),(139143,5817),(139144,5817),(139145,5817),(139146,5817),(139147,5818),(139148,5818),(139149,5818),(139150,5818),(139151,5819),(139152,5819),(139153,5819),(139154,5820),(139155,5820),(139156,5820),(139157,5820),(139158,5821),(139159,5821),(139160,5821),(139161,5822),(139162,5822),(139163,5822),(139164,5823),(139165,5823),(139166,5823),(139167,5824),(139168,5824),(139169,5824),(139170,5824),(139171,5825),(139172,5825),(139173,5825),(139174,5826),(139175,5826),(139176,5826),(139177,5827),(139178,5827),(139179,5827),(139180,5828),(139181,5828),(139182,5828),(139183,5829),(139184,5829),(139185,5829),(139186,5830),(139187,5830),(139188,5830),(139189,5831),(139190,5831),(139191,5831),(139192,5832),(139193,5832),(139194,5832),(139195,5832),(139196,5833),(139197,5833),(139198,5833),(139199,5833),(139200,5834),(139201,5834),(139202,5834),(139203,5834),(139204,5835),(139205,5835),(139206,5835),(139207,5835),(139208,5836),(139209,5836),(139210,5836),(139211,5836),(139212,5837),(139213,5837),(139214,5837),(139215,5837),(139216,5838),(139217,5838),(139218,5838),(139219,5838),(139220,5839),(139221,5839),(139222,5839),(139223,5839),(139224,5840),(139225,5840),(139226,5840),(139227,5840),(139228,5841),(139229,5841),(139230,5841),(139231,5841),(139232,5842),(139233,5842),(139234,5842),(139235,5842),(139236,5843),(139237,5843),(139238,5843),(139239,5843),(139240,5844),(139241,5844),(139242,5844),(139243,5844),(139244,5845),(139245,5845),(139246,5845),(139247,5845),(139248,5846),(139249,5846),(139250,5846),(139251,5846),(139252,5847),(139253,5847),(139254,5847),(139255,5847),(139256,5848),(139257,5848),(139258,5848),(139259,5848),(139260,5849),(139261,5849),(139262,5849),(139263,5849),(139264,5850),(139265,5850),(139266,5850),(139267,5850),(139268,5851),(139269,5851),(139270,5851),(139271,5851),(139272,5852),(139273,5852),(139274,5852),(139275,5852),(139276,5853),(139277,5853),(139278,5853),(139279,5853),(139280,5854),(139281,5854),(139282,5854),(139283,5854),(139284,5855),(139285,5855),(139286,5855),(139287,5855),(139288,5856),(139289,5856),(139290,5856),(139291,5856),(139292,5857),(139293,5857),(139294,5857),(139295,5857),(139296,5858),(139297,5858),(139298,5858),(139299,5858),(139300,5859),(139301,5859),(139302,5859),(139303,5859),(139304,5860),(139305,5860),(139306,5860),(139307,5860),(139308,5861),(139309,5862),(139310,5863),(139311,5864),(139312,5865),(139313,5866),(139314,5867),(139315,5868),(139316,5869),(139317,5870),(139318,5871),(139319,5872),(139320,5873),(139321,5874),(139322,5875),(139323,5876),(139324,5877),(139325,5878),(139326,5879),(139327,5880),(139328,5881),(139329,5882),(139330,5883),(139331,5884),(139332,5885),(139333,5886),(139334,5887),(139335,5888),(139336,5889),(139337,5890),(139338,5891),(139339,5892),(139340,5893),(139341,5894),(139342,5895),(139343,5896),(139344,5897),(139345,5898),(139346,5899),(139347,5900),(139348,5901),(139349,5902),(139350,5903),(139351,5904),(139352,5905),(139353,5906),(139354,5907),(139355,5908),(139356,5909),(139357,5910),(139358,5911),(139359,5912),(139360,5913),(139361,5914),(139362,5915),(139363,5916),(139364,5917),(139365,5918),(139366,5919),(139367,5920),(139368,5921),(139369,5922),(139370,5923),(139371,5924),(139372,5925),(139373,5926),(139374,5927),(139375,5928),(139376,5929),(139377,5930),(139378,5931),(139379,5932),(139380,5933),(139381,5934),(139382,5935),(139383,5936),(139384,5937),(139385,5938),(139386,5939),(139387,5940),(139388,5941),(139389,5942),(139390,5943),(139391,5944),(139392,5945),(139393,5946),(139394,5947),(139395,5948),(139396,5949),(139397,5950),(139398,5951),(139399,5952),(139400,5953),(139401,5954),(139402,5955),(139403,5956),(139404,5957),(139405,5958),(139406,5959),(139407,5960),(139408,5861),(139409,5862),(139410,5863),(139411,5864),(139412,5865),(139413,5866),(139414,5867),(139415,5868),(139416,5869),(139417,5870),(139418,5871),(139419,5872),(139420,5873),(139421,5874),(139422,5875),(139423,5876),(139424,5877),(139425,5878),(139426,5879),(139427,5880),(139428,5881),(139429,5882),(139430,5883),(139431,5884),(139432,5885),(139433,5886),(139434,5887),(139435,5888),(139436,5889),(139437,5890),(139438,5891),(139439,5892),(139440,5893),(139441,5894),(139442,5895),(139443,5896),(139444,5897),(139445,5898),(139446,5899),(139447,5900),(139448,5901),(139449,5902),(139450,5903),(139451,5904),(139452,5905),(139453,5906),(139454,5907),(139455,5908),(139456,5909),(139457,5910),(139458,5911),(139459,5912),(139460,5913),(139461,5914),(139462,5915),(139463,5916),(139464,5917),(139465,5918),(139466,5919),(139467,5920),(139468,5921),(139469,5922),(139470,5923),(139471,5924),(139472,5925),(139473,5926),(139474,5927),(139475,5928),(139476,5929),(139477,5930),(139478,5931),(139479,5932),(139480,5933),(139481,5934),(139482,5935),(139483,5936),(139484,5937),(139485,5938),(139486,5939),(139487,5940),(139488,5941),(139489,5942),(139490,5943),(139491,5944),(139492,5945),(139493,5946),(139494,5947),(139495,5948),(139496,5949),(139497,5950),(139498,5951),(139499,5952),(139500,5953),(139501,5954),(139502,5955),(139503,5956),(139504,5957),(139505,5958),(139506,5959),(139507,5960),(139508,5861),(139509,5861),(139510,5861),(139511,5861),(139512,5861),(139513,5861),(139514,5861),(139515,5861),(139516,5861),(139517,5862),(139518,5862),(139519,5862),(139520,5862),(139521,5862),(139522,5862),(139523,5862),(139524,5862),(139525,5862),(139526,5863),(139527,5863),(139528,5863),(139529,5863),(139530,5863),(139531,5863),(139532,5863),(139533,5863),(139534,5863),(139535,5864),(139536,5864),(139537,5864),(139538,5864),(139539,5864),(139540,5864),(139541,5864),(139542,5865),(139543,5865),(139544,5865),(139545,5865),(139546,5865),(139547,5865),(139548,5865),(139549,5866),(139550,5866),(139551,5866),(139552,5866),(139553,5866),(139554,5866),(139555,5866),(139556,5867),(139557,5867),(139558,5867),(139559,5867),(139560,5868),(139561,5868),(139562,5868),(139563,5868),(139564,5868),(139565,5868),(139566,5868),(139567,5869),(139568,5869),(139569,5869),(139570,5869),(139571,5869),(139572,5869),(139573,5869),(139574,5870),(139575,5870),(139576,5870),(139577,5870),(139578,5870),(139579,5870),(139580,5870),(139581,5871),(139582,5871),(139583,5871),(139584,5871),(139585,5872),(139586,5872),(139587,5872),(139588,5872),(139589,5872),(139590,5872),(139591,5872),(139592,5873),(139593,5873),(139594,5873),(139595,5873),(139596,5873),(139597,5873),(139598,5873),(139599,5874),(139600,5874),(139601,5874),(139602,5874),(139603,5874),(139604,5874),(139605,5874),(139606,5875),(139607,5875),(139608,5875),(139609,5875),(139610,5875),(139611,5875),(139612,5875),(139613,5876),(139614,5876),(139615,5876),(139616,5876),(139617,5876),(139618,5876),(139619,5876),(139620,5876),(139621,5876),(139622,5877),(139623,5877),(139624,5877),(139625,5877),(139626,5877),(139627,5877),(139628,5877),(139629,5878),(139630,5878),(139631,5878),(139632,5878),(139633,5878),(139634,5878),(139635,5878),(139636,5879),(139637,5879),(139638,5879),(139639,5879),(139640,5879),(139641,5879),(139642,5879),(139643,5880),(139644,5880),(139645,5880),(139646,5880),(139647,5880),(139648,5880),(139649,5880),(139650,5881),(139651,5881),(139652,5881),(139653,5881),(139654,5881),(139655,5881),(139656,5881),(139657,5881),(139658,5881),(139659,5882),(139660,5882),(139661,5882),(139662,5882),(139663,5882),(139664,5882),(139665,5882),(139666,5882),(139667,5882),(139668,5883),(139669,5883),(139670,5883),(139671,5883),(139672,5883),(139673,5883),(139674,5883),(139675,5883),(139676,5883),(139677,5884),(139678,5884),(139679,5884),(139680,5884),(139681,5884),(139682,5884),(139683,5884),(139684,5884),(139685,5884),(139686,5885),(139687,5885),(139688,5885),(139689,5885),(139690,5885),(139691,5885),(139692,5885),(139693,5885),(139694,5885),(139695,5886),(139696,5886),(139697,5886),(139698,5886),(139699,5886),(139700,5886),(139701,5886),(139702,5886),(139703,5886),(139704,5887),(139705,5887),(139706,5887),(139707,5887),(139708,5887),(139709,5887),(139710,5887),(139711,5887),(139712,5887),(139713,5888),(139714,5888),(139715,5888),(139716,5888),(139717,5888),(139718,5888),(139719,5888),(139720,5888),(139721,5888),(139722,5889),(139723,5889),(139724,5889),(139725,5889),(139726,5889),(139727,5889),(139728,5889),(139729,5889),(139730,5889),(139731,5890),(139732,5890),(139733,5890),(139734,5890),(139735,5890),(139736,5890),(139737,5890),(139738,5890),(139739,5890),(139740,5891),(139741,5891),(139742,5891),(139743,5891),(139744,5891),(139745,5891),(139746,5891),(139747,5891),(139748,5891),(139749,5892),(139750,5892),(139751,5892),(139752,5892),(139753,5892),(139754,5892),(139755,5892),(139756,5892),(139757,5892),(139758,5893),(139759,5893),(139760,5893),(139761,5893),(139762,5893),(139763,5893),(139764,5893),(139765,5894),(139766,5894),(139767,5894),(139768,5894),(139769,5894),(139770,5894),(139771,5894),(139772,5895),(139773,5895),(139774,5895),(139775,5895),(139776,5895),(139777,5895),(139778,5895),(139779,5896),(139780,5896),(139781,5896),(139782,5896),(139783,5897),(139784,5897),(139785,5897),(139786,5897),(139787,5897),(139788,5897),(139789,5897),(139790,5898),(139791,5898),(139792,5898),(139793,5898),(139794,5898),(139795,5898),(139796,5898),(139797,5899),(139798,5899),(139799,5899),(139800,5899),(139801,5899),(139802,5899),(139803,5899),(139804,5899),(139805,5899),(139806,5900),(139807,5900),(139808,5900),(139809,5900),(139810,5900),(139811,5900),(139812,5900),(139813,5901),(139814,5901),(139815,5901),(139816,5901),(139817,5901),(139818,5901),(139819,5901),(139820,5901),(139821,5901),(139822,5902),(139823,5902),(139824,5902),(139825,5902),(139826,5902),(139827,5902),(139828,5902),(139829,5902),(139830,5902),(139831,5903),(139832,5903),(139833,5903),(139834,5903),(139835,5903),(139836,5903),(139837,5903),(139838,5903),(139839,5903),(139840,5904),(139841,5904),(139842,5904),(139843,5904),(139844,5904),(139845,5904),(139846,5904),(139847,5905),(139848,5905),(139849,5905),(139850,5905),(139851,5905),(139852,5905),(139853,5905),(139854,5906),(139855,5906),(139856,5906),(139857,5906),(139858,5907),(139859,5907),(139860,5907),(139861,5907),(139862,5907),(139863,5907),(139864,5907),(139865,5907),(139866,5907),(139867,5908),(139868,5908),(139869,5908),(139870,5908),(139871,5908),(139872,5908),(139873,5908),(139874,5908),(139875,5908),(139876,5909),(139877,5909),(139878,5909),(139879,5909),(139880,5909),(139881,5909),(139882,5909),(139883,5909),(139884,5909),(139885,5910),(139886,5910),(139887,5910),(139888,5910),(139889,5910),(139890,5910),(139891,5910),(139892,5911),(139893,5911),(139894,5911),(139895,5911),(139896,5911),(139897,5911),(139898,5911),(139899,5912),(139900,5912),(139901,5912),(139902,5912),(139903,5912),(139904,5912),(139905,5912),(139906,5913),(139907,5913),(139908,5913),(139909,5913),(139910,5913),(139911,5913),(139912,5913),(139913,5914),(139914,5914),(139915,5914),(139916,5914),(139917,5914),(139918,5914),(139919,5914),(139920,5915),(139921,5915),(139922,5915),(139923,5915),(139924,5915),(139925,5915),(139926,5915),(139927,5916),(139928,5916),(139929,5916),(139930,5916),(139931,5916),(139932,5916),(139933,5916),(139934,5916),(139935,5916),(139936,5917),(139937,5917),(139938,5917),(139939,5917),(139940,5917),(139941,5917),(139942,5917),(139943,5918),(139944,5918),(139945,5918),(139946,5918),(139947,5918),(139948,5918),(139949,5919),(139950,5919),(139951,5919),(139952,5919),(139953,5919),(139954,5919),(139955,5919),(139956,5920),(139957,5920),(139958,5920),(139959,5920),(139960,5920),(139961,5920),(139962,5921),(139963,5921),(139964,5921),(139965,5921),(139966,5921),(139967,5921),(139968,5921),(139969,5922),(139970,5922),(139971,5922),(139972,5922),(139973,5922),(139974,5922),(139975,5922),(139976,5923),(139977,5923),(139978,5923),(139979,5923),(139980,5923),(139981,5923),(139982,5923),(139983,5924),(139984,5924),(139985,5924),(139986,5924),(139987,5924),(139988,5924),(139989,5924),(139990,5925),(139991,5925),(139992,5925),(139993,5925),(139994,5925),(139995,5925),(139996,5925),(139997,5926),(139998,5926),(139999,5926),(140000,5926),(140001,5926),(140002,5926),(140003,5927),(140004,5927),(140005,5927),(140006,5927),(140007,5927),(140008,5927),(140009,5927),(140010,5928),(140011,5928),(140012,5928),(140013,5928),(140014,5928),(140015,5928),(140016,5928),(140017,5929),(140018,5929),(140019,5929),(140020,5929),(140021,5929),(140022,5929),(140023,5929),(140024,5930),(140025,5930),(140026,5930),(140027,5930),(140028,5931),(140029,5931),(140030,5931),(140031,5931),(140032,5932),(140033,5932),(140034,5932),(140035,5932),(140036,5933),(140037,5933),(140038,5933),(140039,5933),(140040,5934),(140041,5934),(140042,5934),(140043,5934),(140044,5935),(140045,5935),(140046,5935),(140047,5935),(140048,5936),(140049,5936),(140050,5936),(140051,5936),(140052,5937),(140053,5937),(140054,5937),(140055,5937),(140056,5938),(140057,5938),(140058,5938),(140059,5938),(140060,5939),(140061,5939),(140062,5939),(140063,5939),(140064,5940),(140065,5940),(140066,5940),(140067,5940),(140068,5941),(140069,5941),(140070,5941),(140071,5941),(140072,5942),(140073,5942),(140074,5942),(140075,5942),(140076,5943),(140077,5943),(140078,5943),(140079,5943),(140080,5944),(140081,5944),(140082,5944),(140083,5944),(140084,5944),(140085,5944),(140086,5944),(140087,5944),(140088,5944),(140089,5945),(140090,5945),(140091,5945),(140092,5945),(140093,5945),(140094,5945),(140095,5945),(140096,5945),(140097,5945),(140098,5946),(140099,5946),(140100,5946),(140101,5946),(140102,5946),(140103,5946),(140104,5946),(140105,5946),(140106,5946),(140107,5947),(140108,5947),(140109,5947),(140110,5947),(140111,5947),(140112,5947),(140113,5947),(140114,5947),(140115,5947),(140116,5948),(140117,5948),(140118,5948),(140119,5948),(140120,5948),(140121,5948),(140122,5948),(140123,5948),(140124,5948),(140125,5949),(140126,5949),(140127,5949),(140128,5949),(140129,5949),(140130,5949),(140131,5949),(140132,5949),(140133,5949),(140134,5950),(140135,5950),(140136,5950),(140137,5950),(140138,5950),(140139,5950),(140140,5950),(140141,5950),(140142,5950),(140143,5951),(140144,5951),(140145,5951),(140146,5951),(140147,5951),(140148,5951),(140149,5951),(140150,5951),(140151,5951),(140152,5952),(140153,5952),(140154,5952),(140155,5952),(140156,5953),(140157,5953),(140158,5953),(140159,5953),(140160,5954),(140161,5954),(140162,5954),(140163,5954),(140164,5955),(140165,5955),(140166,5955),(140167,5955),(140168,5955),(140169,5955),(140170,5955),(140171,5955),(140172,5955),(140173,5956),(140174,5956),(140175,5956),(140176,5956),(140177,5956),(140178,5956),(140179,5956),(140180,5956),(140181,5956),(140182,5957),(140183,5957),(140184,5957),(140185,5957),(140186,5957),(140187,5957),(140188,5957),(140189,5957),(140190,5957),(140191,5958),(140192,5958),(140193,5958),(140194,5958),(140195,5959),(140196,5959),(140197,5959),(140198,5959),(140199,5960),(140200,5960),(140201,5960),(140202,5960),(140203,5861),(140204,5861),(140205,5862),(140206,5862),(140207,5863),(140208,5863),(140209,5864),(140210,5864),(140211,5864),(140212,5865),(140213,5865),(140214,5865),(140215,5866),(140216,5866),(140217,5866),(140218,5867),(140219,5867),(140220,5867),(140221,5868),(140222,5868),(140223,5868),(140224,5869),(140225,5869),(140226,5869),(140227,5870),(140228,5870),(140229,5870),(140230,5871),(140231,5871),(140232,5871),(140233,5872),(140234,5872),(140235,5872),(140236,5873),(140237,5873),(140238,5873),(140239,5874),(140240,5874),(140241,5874),(140242,5875),(140243,5875),(140244,5875),(140245,5876),(140246,5876),(140247,5876),(140248,5877),(140249,5877),(140250,5877),(140251,5878),(140252,5878),(140253,5878),(140254,5879),(140255,5879),(140256,5879),(140257,5880),(140258,5880),(140259,5880),(140260,5881),(140261,5881),(140262,5881),(140263,5882),(140264,5882),(140265,5882),(140266,5883),(140267,5883),(140268,5883),(140269,5884),(140270,5884),(140271,5884),(140272,5885),(140273,5885),(140274,5885),(140275,5886),(140276,5886),(140277,5886),(140278,5887),(140279,5887),(140280,5887),(140281,5888),(140282,5888),(140283,5888),(140284,5889),(140285,5889),(140286,5889),(140287,5890),(140288,5890),(140289,5890),(140290,5891),(140291,5891),(140292,5891),(140293,5892),(140294,5892),(140295,5893),(140296,5893),(140297,5893),(140298,5894),(140299,5894),(140300,5894),(140301,5895),(140302,5895),(140303,5895),(140304,5896),(140305,5896),(140306,5896),(140307,5897),(140308,5897),(140309,5897),(140310,5898),(140311,5898),(140312,5898),(140313,5899),(140314,5899),(140315,5899),(140316,5900),(140317,5900),(140318,5900),(140319,5901),(140320,5901),(140321,5901),(140322,5902),(140323,5902),(140324,5902),(140325,5903),(140326,5903),(140327,5903),(140328,5904),(140329,5904),(140330,5904),(140331,5905),(140332,5905),(140333,5905),(140334,5906),(140335,5906),(140336,5906),(140337,5907),(140338,5907),(140339,5907),(140340,5908),(140341,5908),(140342,5908),(140343,5909),(140344,5909),(140345,5909),(140346,5910),(140347,5910),(140348,5910),(140349,5911),(140350,5911),(140351,5911),(140352,5912),(140353,5912),(140354,5912),(140355,5913),(140356,5913),(140357,5913),(140358,5914),(140359,5914),(140360,5914),(140361,5915),(140362,5915),(140363,5915),(140364,5916),(140365,5916),(140366,5916),(140367,5917),(140368,5917),(140369,5917),(140370,5918),(140371,5918),(140372,5918),(140373,5919),(140374,5919),(140375,5919),(140376,5920),(140377,5920),(140378,5920),(140379,5921),(140380,5921),(140381,5921),(140382,5922),(140383,5922),(140384,5922),(140385,5923),(140386,5923),(140387,5923),(140388,5924),(140389,5924),(140390,5924),(140391,5925),(140392,5925),(140393,5925),(140394,5926),(140395,5926),(140396,5926),(140397,5927),(140398,5927),(140399,5927),(140400,5928),(140401,5928),(140402,5928),(140403,5929),(140404,5929),(140405,5929),(140406,5930),(140407,5930),(140408,5930),(140409,5931),(140410,5931),(140411,5931),(140412,5932),(140413,5932),(140414,5932),(140415,5933),(140416,5933),(140417,5933),(140418,5934),(140419,5934),(140420,5934),(140421,5935),(140422,5935),(140423,5935),(140424,5936),(140425,5936),(140426,5936),(140427,5937),(140428,5937),(140429,5937),(140430,5938),(140431,5938),(140432,5938),(140433,5939),(140434,5939),(140435,5939),(140436,5940),(140437,5940),(140438,5940),(140439,5941),(140440,5941),(140441,5941),(140442,5942),(140443,5942),(140444,5942),(140445,5943),(140446,5943),(140447,5943),(140448,5944),(140449,5944),(140450,5944),(140451,5945),(140452,5945),(140453,5945),(140454,5946),(140455,5946),(140456,5946),(140457,5947),(140458,5947),(140459,5947),(140460,5948),(140461,5948),(140462,5948),(140463,5949),(140464,5949),(140465,5949),(140466,5950),(140467,5950),(140468,5950),(140469,5951),(140470,5951),(140471,5951),(140472,5952),(140473,5952),(140474,5952),(140475,5953),(140476,5953),(140477,5953),(140478,5954),(140479,5954),(140480,5954),(140481,5955),(140482,5955),(140483,5955),(140484,5956),(140485,5956),(140486,5956),(140487,5957),(140488,5957),(140489,5957),(140490,5958),(140491,5958),(140492,5958),(140493,5959),(140494,5959),(140495,5959),(140496,5960),(140497,5960),(140498,5960),(140499,5861),(140500,5861),(140501,5861),(140502,5861),(140503,5861),(140504,5861),(140505,5861),(140506,5861),(140507,5861),(140508,5861),(140509,5861),(140510,5862),(140511,5862),(140512,5862),(140513,5862),(140514,5862),(140515,5862),(140516,5862),(140517,5862),(140518,5862),(140519,5862),(140520,5862),(140521,5863),(140522,5863),(140523,5863),(140524,5863),(140525,5863),(140526,5863),(140527,5863),(140528,5863),(140529,5863),(140530,5863),(140531,5863),(140532,5864),(140533,5864),(140534,5864),(140535,5864),(140536,5864),(140537,5864),(140538,5864),(140539,5864),(140540,5864),(140541,5864),(140542,5864),(140543,5865),(140544,5865),(140545,5865),(140546,5865),(140547,5865),(140548,5865),(140549,5865),(140550,5865),(140551,5865),(140552,5865),(140553,5865),(140554,5866),(140555,5866),(140556,5866),(140557,5866),(140558,5866),(140559,5866),(140560,5866),(140561,5866),(140562,5866),(140563,5866),(140564,5866),(140565,5867),(140566,5867),(140567,5867),(140568,5867),(140569,5867),(140570,5867),(140571,5867),(140572,5867),(140573,5867),(140574,5867),(140575,5867),(140576,5868),(140577,5868),(140578,5868),(140579,5868),(140580,5868),(140581,5868),(140582,5868),(140583,5868),(140584,5868),(140585,5868),(140586,5868),(140587,5869),(140588,5869),(140589,5869),(140590,5869),(140591,5869),(140592,5869),(140593,5869),(140594,5869),(140595,5869),(140596,5869),(140597,5869),(140598,5870),(140599,5870),(140600,5870),(140601,5870),(140602,5870),(140603,5870),(140604,5870),(140605,5870),(140606,5870),(140607,5870),(140608,5870),(140609,5871),(140610,5871),(140611,5871),(140612,5871),(140613,5871),(140614,5871),(140615,5871),(140616,5871),(140617,5871),(140618,5871),(140619,5871),(140620,5872),(140621,5872),(140622,5872),(140623,5872),(140624,5872),(140625,5872),(140626,5872),(140627,5872),(140628,5872),(140629,5872),(140630,5872),(140631,5873),(140632,5873),(140633,5873),(140634,5873),(140635,5873),(140636,5873),(140637,5873),(140638,5873),(140639,5873),(140640,5873),(140641,5873),(140642,5874),(140643,5874),(140644,5874),(140645,5874),(140646,5874),(140647,5874),(140648,5874),(140649,5874),(140650,5874),(140651,5874),(140652,5874),(140653,5875),(140654,5875),(140655,5875),(140656,5875),(140657,5875),(140658,5875),(140659,5875),(140660,5875),(140661,5875),(140662,5875),(140663,5875),(140664,5876),(140665,5876),(140666,5876),(140667,5876),(140668,5876),(140669,5876),(140670,5876),(140671,5876),(140672,5876),(140673,5876),(140674,5876),(140675,5877),(140676,5877),(140677,5877),(140678,5877),(140679,5877),(140680,5877),(140681,5877),(140682,5877),(140683,5877),(140684,5877),(140685,5877),(140686,5878),(140687,5878),(140688,5878),(140689,5878),(140690,5878),(140691,5878),(140692,5878),(140693,5878),(140694,5878),(140695,5878),(140696,5878),(140697,5879),(140698,5879),(140699,5879),(140700,5879),(140701,5879),(140702,5879),(140703,5879),(140704,5879),(140705,5879),(140706,5879),(140707,5879),(140708,5880),(140709,5880),(140710,5880),(140711,5880),(140712,5880),(140713,5880),(140714,5880),(140715,5880),(140716,5880),(140717,5880),(140718,5880),(140719,5881),(140720,5881),(140721,5881),(140722,5881),(140723,5881),(140724,5881),(140725,5881),(140726,5881),(140727,5881),(140728,5881),(140729,5881),(140730,5882),(140731,5882),(140732,5882),(140733,5882),(140734,5882),(140735,5882),(140736,5882),(140737,5882),(140738,5882),(140739,5882),(140740,5882),(140741,5883),(140742,5883),(140743,5883),(140744,5883),(140745,5883),(140746,5883),(140747,5883),(140748,5883),(140749,5883),(140750,5883),(140751,5883),(140752,5884),(140753,5884),(140754,5884),(140755,5884),(140756,5884),(140757,5884),(140758,5884),(140759,5884),(140760,5884),(140761,5884),(140762,5884),(140763,5885),(140764,5885),(140765,5885),(140766,5885),(140767,5885),(140768,5885),(140769,5885),(140770,5885),(140771,5885),(140772,5885),(140773,5885),(140774,5886),(140775,5886),(140776,5886),(140777,5886),(140778,5886),(140779,5886),(140780,5886),(140781,5886),(140782,5886),(140783,5886),(140784,5886),(140785,5887),(140786,5887),(140787,5887),(140788,5887),(140789,5887),(140790,5887),(140791,5887),(140792,5887),(140793,5887),(140794,5887),(140795,5887),(140796,5888),(140797,5888),(140798,5888),(140799,5888),(140800,5888),(140801,5888),(140802,5888),(140803,5888),(140804,5888),(140805,5888),(140806,5888),(140807,5889),(140808,5889),(140809,5889),(140810,5889),(140811,5889),(140812,5889),(140813,5889),(140814,5889),(140815,5889),(140816,5889),(140817,5889),(140818,5890),(140819,5890),(140820,5890),(140821,5890),(140822,5890),(140823,5890),(140824,5890),(140825,5890),(140826,5890),(140827,5890),(140828,5890),(140829,5891),(140830,5891),(140831,5891),(140832,5891),(140833,5891),(140834,5891),(140835,5891),(140836,5891),(140837,5891),(140838,5891),(140839,5891),(140840,5892),(140841,5892),(140842,5892),(140843,5892),(140844,5892),(140845,5892),(140846,5892),(140847,5892),(140848,5892),(140849,5892),(140850,5892),(140851,5893),(140852,5893),(140853,5893),(140854,5893),(140855,5893),(140856,5893),(140857,5893),(140858,5893),(140859,5893),(140860,5893),(140861,5893),(140862,5894),(140863,5894),(140864,5894),(140865,5894),(140866,5894),(140867,5894),(140868,5894),(140869,5894),(140870,5894),(140871,5894),(140872,5894),(140873,5895),(140874,5895),(140875,5895),(140876,5895),(140877,5895),(140878,5895),(140879,5895),(140880,5895),(140881,5895),(140882,5895),(140883,5895),(140884,5896),(140885,5896),(140886,5896),(140887,5896),(140888,5896),(140889,5896),(140890,5896),(140891,5896),(140892,5896),(140893,5896),(140894,5896),(140895,5897),(140896,5897),(140897,5897),(140898,5897),(140899,5897),(140900,5897),(140901,5897),(140902,5897),(140903,5897),(140904,5897),(140905,5897),(140906,5898),(140907,5898),(140908,5898),(140909,5898),(140910,5898),(140911,5898),(140912,5898),(140913,5898),(140914,5898),(140915,5898),(140916,5898),(140917,5899),(140918,5899),(140919,5899),(140920,5899),(140921,5899),(140922,5899),(140923,5899),(140924,5899),(140925,5899),(140926,5899),(140927,5899),(140928,5900),(140929,5900),(140930,5900),(140931,5900),(140932,5900),(140933,5900),(140934,5900),(140935,5900),(140936,5900),(140937,5900),(140938,5900),(140939,5901),(140940,5901),(140941,5901),(140942,5901),(140943,5901),(140944,5901),(140945,5901),(140946,5901),(140947,5901),(140948,5901),(140949,5901),(140950,5902),(140951,5902),(140952,5902),(140953,5902),(140954,5902),(140955,5902),(140956,5902),(140957,5902),(140958,5902),(140959,5902),(140960,5902),(140961,5903),(140962,5903),(140963,5903),(140964,5903),(140965,5903),(140966,5903),(140967,5903),(140968,5903),(140969,5903),(140970,5903),(140971,5903),(140972,5904),(140973,5904),(140974,5904),(140975,5904),(140976,5904),(140977,5904),(140978,5904),(140979,5904),(140980,5904),(140981,5904),(140982,5904),(140983,5905),(140984,5905),(140985,5905),(140986,5905),(140987,5905),(140988,5905),(140989,5905),(140990,5905),(140991,5905),(140992,5905),(140993,5905),(140994,5906),(140995,5906),(140996,5906),(140997,5906),(140998,5906),(140999,5906),(141000,5906),(141001,5906),(141002,5906),(141003,5906),(141004,5906),(141005,5907),(141006,5907),(141007,5907),(141008,5907),(141009,5907),(141010,5907),(141011,5907),(141012,5907),(141013,5907),(141014,5907),(141015,5907),(141016,5908),(141017,5908),(141018,5908),(141019,5908),(141020,5908),(141021,5908),(141022,5908),(141023,5908),(141024,5908),(141025,5908),(141026,5908),(141027,5909),(141028,5909),(141029,5909),(141030,5909),(141031,5909),(141032,5909),(141033,5909),(141034,5909),(141035,5909),(141036,5909),(141037,5909),(141038,5910),(141039,5910),(141040,5910),(141041,5910),(141042,5910),(141043,5910),(141044,5910),(141045,5910),(141046,5910),(141047,5910),(141048,5910),(141049,5911),(141050,5911),(141051,5911),(141052,5911),(141053,5911),(141054,5911),(141055,5911),(141056,5911),(141057,5911),(141058,5911),(141059,5911),(141060,5912),(141061,5912),(141062,5912),(141063,5912),(141064,5912),(141065,5912),(141066,5912),(141067,5912),(141068,5912),(141069,5912),(141070,5912),(141071,5913),(141072,5913),(141073,5913),(141074,5913),(141075,5913),(141076,5913),(141077,5913),(141078,5913),(141079,5913),(141080,5913),(141081,5913),(141082,5914),(141083,5914),(141084,5914),(141085,5914),(141086,5914),(141087,5914),(141088,5914),(141089,5914),(141090,5914),(141091,5914),(141092,5914),(141093,5915),(141094,5915),(141095,5915),(141096,5915),(141097,5915),(141098,5915),(141099,5915),(141100,5915),(141101,5915),(141102,5915),(141103,5915),(141104,5916),(141105,5916),(141106,5916),(141107,5916),(141108,5916),(141109,5916),(141110,5916),(141111,5916),(141112,5916),(141113,5916),(141114,5916),(141115,5917),(141116,5917),(141117,5917),(141118,5917),(141119,5917),(141120,5917),(141121,5917),(141122,5917),(141123,5917),(141124,5917),(141125,5917),(141126,5918),(141127,5918),(141128,5918),(141129,5918),(141130,5918),(141131,5918),(141132,5918),(141133,5918),(141134,5918),(141135,5918),(141136,5918),(141137,5919),(141138,5919),(141139,5919),(141140,5919),(141141,5919),(141142,5919),(141143,5919),(141144,5919),(141145,5919),(141146,5919),(141147,5919),(141148,5920),(141149,5920),(141150,5920),(141151,5920),(141152,5920),(141153,5920),(141154,5920),(141155,5920),(141156,5920),(141157,5920),(141158,5920),(141159,5921),(141160,5921),(141161,5921),(141162,5921),(141163,5921),(141164,5921),(141165,5921),(141166,5921),(141167,5921),(141168,5921),(141169,5921),(141170,5922),(141171,5922),(141172,5922),(141173,5922),(141174,5922),(141175,5922),(141176,5922),(141177,5922),(141178,5922),(141179,5922),(141180,5922),(141181,5923),(141182,5923),(141183,5923),(141184,5923),(141185,5923),(141186,5923),(141187,5923),(141188,5923),(141189,5923),(141190,5923),(141191,5923),(141192,5924),(141193,5924),(141194,5924),(141195,5924),(141196,5924),(141197,5924),(141198,5924),(141199,5924),(141200,5924),(141201,5924),(141202,5924),(141203,5925),(141204,5925),(141205,5925),(141206,5925),(141207,5925),(141208,5925),(141209,5925),(141210,5925),(141211,5925),(141212,5925),(141213,5925),(141214,5926),(141215,5926),(141216,5926),(141217,5926),(141218,5926),(141219,5926),(141220,5926),(141221,5926),(141222,5926),(141223,5926),(141224,5926),(141225,5927),(141226,5927),(141227,5927),(141228,5927),(141229,5927),(141230,5927),(141231,5927),(141232,5927),(141233,5927),(141234,5927),(141235,5927),(141236,5928),(141237,5928),(141238,5928),(141239,5928),(141240,5928),(141241,5928),(141242,5928),(141243,5928),(141244,5928),(141245,5928),(141246,5928),(141247,5929),(141248,5929),(141249,5929),(141250,5929),(141251,5929),(141252,5929),(141253,5929),(141254,5929),(141255,5929),(141256,5929),(141257,5929),(141258,5930),(141259,5930),(141260,5930),(141261,5930),(141262,5930),(141263,5930),(141264,5930),(141265,5930),(141266,5930),(141267,5930),(141268,5930),(141269,5931),(141270,5931),(141271,5931),(141272,5931),(141273,5931),(141274,5931),(141275,5931),(141276,5931),(141277,5931),(141278,5931),(141279,5931),(141280,5932),(141281,5932),(141282,5932),(141283,5932),(141284,5932),(141285,5932),(141286,5932),(141287,5932),(141288,5932),(141289,5932),(141290,5932),(141291,5933),(141292,5933),(141293,5933),(141294,5933),(141295,5933),(141296,5933),(141297,5933),(141298,5933),(141299,5933),(141300,5933),(141301,5933),(141302,5934),(141303,5934),(141304,5934),(141305,5934),(141306,5934),(141307,5934),(141308,5934),(141309,5934),(141310,5934),(141311,5934),(141312,5934),(141313,5935),(141314,5935),(141315,5935),(141316,5935),(141317,5935),(141318,5935),(141319,5935),(141320,5935),(141321,5935),(141322,5935),(141323,5935),(141324,5936),(141325,5936),(141326,5936),(141327,5936),(141328,5936),(141329,5936),(141330,5936),(141331,5936),(141332,5936),(141333,5936),(141334,5936),(141335,5937),(141336,5937),(141337,5937),(141338,5937),(141339,5937),(141340,5937),(141341,5937),(141342,5937),(141343,5937),(141344,5937),(141345,5937),(141346,5938),(141347,5938),(141348,5938),(141349,5938),(141350,5938),(141351,5938),(141352,5938),(141353,5938),(141354,5938),(141355,5938),(141356,5938),(141357,5939),(141358,5939),(141359,5939),(141360,5939),(141361,5939),(141362,5939),(141363,5939),(141364,5939),(141365,5939),(141366,5939),(141367,5939),(141368,5940),(141369,5940),(141370,5940),(141371,5940),(141372,5940),(141373,5940),(141374,5940),(141375,5940),(141376,5940),(141377,5940),(141378,5940),(141379,5941),(141380,5941),(141381,5941),(141382,5941),(141383,5941),(141384,5941),(141385,5941),(141386,5941),(141387,5941),(141388,5941),(141389,5941),(141390,5942),(141391,5942),(141392,5942),(141393,5942),(141394,5942),(141395,5942),(141396,5942),(141397,5942),(141398,5942),(141399,5942),(141400,5942),(141401,5943),(141402,5943),(141403,5943),(141404,5943),(141405,5943),(141406,5943),(141407,5943),(141408,5943),(141409,5943),(141410,5943),(141411,5943),(141412,5944),(141413,5944),(141414,5944),(141415,5944),(141416,5944),(141417,5944),(141418,5944),(141419,5944),(141420,5944),(141421,5944),(141422,5944),(141423,5945),(141424,5945),(141425,5945),(141426,5945),(141427,5945),(141428,5945),(141429,5945),(141430,5945),(141431,5945),(141432,5945),(141433,5945),(141434,5946),(141435,5946),(141436,5946),(141437,5946),(141438,5946),(141439,5946),(141440,5946),(141441,5946),(141442,5946),(141443,5946),(141444,5946),(141445,5947),(141446,5947),(141447,5947),(141448,5947),(141449,5947),(141450,5947),(141451,5947),(141452,5947),(141453,5947),(141454,5947),(141455,5947),(141456,5948),(141457,5948),(141458,5948),(141459,5948),(141460,5948),(141461,5948),(141462,5948),(141463,5948),(141464,5948),(141465,5948),(141466,5948),(141467,5949),(141468,5949),(141469,5949),(141470,5949),(141471,5949),(141472,5949),(141473,5949),(141474,5949),(141475,5949),(141476,5949),(141477,5949),(141478,5950),(141479,5950),(141480,5950),(141481,5950),(141482,5950),(141483,5950),(141484,5950),(141485,5950),(141486,5950),(141487,5950),(141488,5950),(141489,5951),(141490,5951),(141491,5951),(141492,5951),(141493,5951),(141494,5951),(141495,5951),(141496,5951),(141497,5951),(141498,5951),(141499,5951),(141500,5952),(141501,5952),(141502,5952),(141503,5952),(141504,5952),(141505,5952),(141506,5952),(141507,5952),(141508,5952),(141509,5952),(141510,5952),(141511,5953),(141512,5953),(141513,5953),(141514,5953),(141515,5953),(141516,5953),(141517,5953),(141518,5953),(141519,5953),(141520,5953),(141521,5953),(141522,5954),(141523,5954),(141524,5954),(141525,5954),(141526,5954),(141527,5954),(141528,5954),(141529,5954),(141530,5954),(141531,5954),(141532,5954),(141533,5955),(141534,5955),(141535,5955),(141536,5955),(141537,5955),(141538,5955),(141539,5955),(141540,5955),(141541,5955),(141542,5955),(141543,5955),(141544,5956),(141545,5956),(141546,5956),(141547,5956),(141548,5956),(141549,5956),(141550,5956),(141551,5956),(141552,5956),(141553,5956),(141554,5956),(141555,5957),(141556,5957),(141557,5957),(141558,5957),(141559,5957),(141560,5957),(141561,5957),(141562,5957),(141563,5957),(141564,5957),(141565,5957),(141566,5958),(141567,5958),(141568,5958),(141569,5958),(141570,5958),(141571,5958),(141572,5958),(141573,5958),(141574,5958),(141575,5958),(141576,5958),(141577,5959),(141578,5959),(141579,5959),(141580,5959),(141581,5959),(141582,5959),(141583,5959),(141584,5959),(141585,5959),(141586,5959),(141587,5959),(141588,5960),(141589,5960),(141590,5960),(141591,5960),(141592,5960),(141593,5960),(141594,5960),(141595,5960),(141596,5960),(141597,5960),(141598,5960),(141599,5861),(141600,5861),(141601,5861),(141602,5861),(141603,5862),(141604,5862),(141605,5862),(141606,5862),(141607,5863),(141608,5863),(141609,5863),(141610,5863),(141611,5864),(141612,5864),(141613,5864),(141614,5864),(141615,5865),(141616,5865),(141617,5865),(141618,5865),(141619,5866),(141620,5866),(141621,5866),(141622,5866),(141623,5867),(141624,5867),(141625,5867),(141626,5868),(141627,5868),(141628,5868),(141629,5868),(141630,5869),(141631,5869),(141632,5869),(141633,5869),(141634,5870),(141635,5870),(141636,5870),(141637,5870),(141638,5871),(141639,5871),(141640,5871),(141641,5872),(141642,5872),(141643,5872),(141644,5873),(141645,5873),(141646,5873),(141647,5874),(141648,5874),(141649,5874),(141650,5875),(141651,5875),(141652,5875),(141653,5876),(141654,5876),(141655,5876),(141656,5876),(141657,5877),(141658,5877),(141659,5877),(141660,5877),(141661,5878),(141662,5878),(141663,5878),(141664,5878),(141665,5879),(141666,5879),(141667,5879),(141668,5879),(141669,5880),(141670,5880),(141671,5880),(141672,5880),(141673,5881),(141674,5881),(141675,5881),(141676,5881),(141677,5882),(141678,5882),(141679,5882),(141680,5882),(141681,5883),(141682,5883),(141683,5883),(141684,5883),(141685,5884),(141686,5884),(141687,5884),(141688,5884),(141689,5885),(141690,5885),(141691,5885),(141692,5885),(141693,5886),(141694,5886),(141695,5886),(141696,5886),(141697,5887),(141698,5887),(141699,5887),(141700,5887),(141701,5888),(141702,5888),(141703,5888),(141704,5888),(141705,5889),(141706,5889),(141707,5889),(141708,5889),(141709,5890),(141710,5890),(141711,5890),(141712,5890),(141713,5891),(141714,5891),(141715,5891),(141716,5891),(141717,5892),(141718,5892),(141719,5892),(141720,5892),(141721,5893),(141722,5893),(141723,5893),(141724,5893),(141725,5894),(141726,5894),(141727,5894),(141728,5894),(141729,5895),(141730,5895),(141731,5895),(141732,5895),(141733,5896),(141734,5896),(141735,5896),(141736,5897),(141737,5897),(141738,5897),(141739,5897),(141740,5898),(141741,5898),(141742,5898),(141743,5898),(141744,5899),(141745,5899),(141746,5899),(141747,5899),(141748,5900),(141749,5900),(141750,5900),(141751,5900),(141752,5901),(141753,5901),(141754,5901),(141755,5901),(141756,5902),(141757,5902),(141758,5902),(141759,5902),(141760,5903),(141761,5903),(141762,5903),(141763,5903),(141764,5904),(141765,5904),(141766,5904),(141767,5904),(141768,5905),(141769,5905),(141770,5905),(141771,5905),(141772,5906),(141773,5906),(141774,5906),(141775,5907),(141776,5907),(141777,5907),(141778,5907),(141779,5908),(141780,5908),(141781,5908),(141782,5908),(141783,5909),(141784,5909),(141785,5909),(141786,5909),(141787,5910),(141788,5910),(141789,5910),(141790,5910),(141791,5911),(141792,5911),(141793,5911),(141794,5911),(141795,5912),(141796,5912),(141797,5912),(141798,5912),(141799,5913),(141800,5913),(141801,5913),(141802,5913),(141803,5914),(141804,5914),(141805,5914),(141806,5914),(141807,5915),(141808,5915),(141809,5915),(141810,5915),(141811,5916),(141812,5916),(141813,5916),(141814,5916),(141815,5917),(141816,5917),(141817,5917),(141818,5917),(141819,5918),(141820,5918),(141821,5918),(141822,5918),(141823,5919),(141824,5919),(141825,5919),(141826,5919),(141827,5920),(141828,5920),(141829,5920),(141830,5920),(141831,5921),(141832,5921),(141833,5921),(141834,5921),(141835,5922),(141836,5922),(141837,5922),(141838,5922),(141839,5923),(141840,5923),(141841,5923),(141842,5923),(141843,5924),(141844,5924),(141845,5924),(141846,5924),(141847,5925),(141848,5925),(141849,5925),(141850,5925),(141851,5926),(141852,5926),(141853,5926),(141854,5926),(141855,5927),(141856,5927),(141857,5927),(141858,5927),(141859,5928),(141860,5928),(141861,5928),(141862,5928),(141863,5929),(141864,5929),(141865,5929),(141866,5929),(141867,5930),(141868,5930),(141869,5930),(141870,5931),(141871,5931),(141872,5931),(141873,5932),(141874,5932),(141875,5932),(141876,5933),(141877,5933),(141878,5933),(141879,5934),(141880,5934),(141881,5934),(141882,5935),(141883,5935),(141884,5935),(141885,5936),(141886,5936),(141887,5936),(141888,5937),(141889,5937),(141890,5937),(141891,5938),(141892,5938),(141893,5938),(141894,5939),(141895,5939),(141896,5939),(141897,5940),(141898,5940),(141899,5940),(141900,5941),(141901,5941),(141902,5941),(141903,5942),(141904,5942),(141905,5942),(141906,5943),(141907,5943),(141908,5943),(141909,5944),(141910,5944),(141911,5944),(141912,5944),(141913,5945),(141914,5945),(141915,5945),(141916,5945),(141917,5946),(141918,5946),(141919,5946),(141920,5946),(141921,5947),(141922,5947),(141923,5947),(141924,5947),(141925,5948),(141926,5948),(141927,5948),(141928,5948),(141929,5949),(141930,5949),(141931,5949),(141932,5949),(141933,5950),(141934,5950),(141935,5950),(141936,5950),(141937,5951),(141938,5951),(141939,5951),(141940,5951),(141941,5952),(141942,5952),(141943,5952),(141944,5953),(141945,5953),(141946,5953),(141947,5954),(141948,5954),(141949,5954),(141950,5955),(141951,5955),(141952,5955),(141953,5955),(141954,5956),(141955,5956),(141956,5956),(141957,5956),(141958,5957),(141959,5957),(141960,5957),(141961,5957),(141962,5958),(141963,5958),(141964,5958),(141965,5959),(141966,5959),(141967,5959),(141968,5960),(141969,5960),(141970,5960),(141971,5961),(141972,5962),(141973,5963),(141974,5964),(141975,5965),(141976,5966),(141977,5967),(141978,5968),(141979,5969),(141980,5970),(141981,5971),(141982,5972),(141983,5973),(141984,5974),(141985,5975),(141986,5976),(141987,5977),(141988,5978),(141989,5979),(141990,5980),(141991,5981),(141992,5982),(141993,5983),(141994,5984),(141995,5985),(141996,5986),(141997,5987),(141998,5988),(141999,5989),(142000,5990),(142001,5991),(142002,5992),(142003,5993),(142004,5994),(142005,5995),(142006,5996),(142007,5997),(142008,5998),(142009,5999),(142010,6000),(142011,6001),(142012,6002),(142013,6003),(142014,6004),(142015,6005),(142016,6006),(142017,6007),(142018,6008),(142019,6009),(142020,6010),(142021,6011),(142022,6012),(142023,6013),(142024,6014),(142025,6015),(142026,6016),(142027,6017),(142028,6018),(142029,6019),(142030,6020),(142031,6021),(142032,6022),(142033,6023),(142034,6024),(142035,6025),(142036,6026),(142037,6027),(142038,6028),(142039,6029),(142040,6030),(142041,6031),(142042,6032),(142043,6033),(142044,6034),(142045,5961),(142046,5962),(142047,5963),(142048,5964),(142049,5965),(142050,5966),(142051,5967),(142052,5968),(142053,5969),(142054,5970),(142055,5971),(142056,5972),(142057,5973),(142058,5974),(142059,5975),(142060,5976),(142061,5977),(142062,5978),(142063,5979),(142064,5980),(142065,5981),(142066,5982),(142067,5983),(142068,5984),(142069,5985),(142070,5986),(142071,5987),(142072,5988),(142073,5989),(142074,5990),(142075,5991),(142076,5992),(142077,5993),(142078,5994),(142079,5995),(142080,5996),(142081,5997),(142082,5998),(142083,5999),(142084,6000),(142085,6001),(142086,6002),(142087,6003),(142088,6004),(142089,6005),(142090,6006),(142091,6007),(142092,6008),(142093,6009),(142094,6010),(142095,6011),(142096,6012),(142097,6013),(142098,6014),(142099,6015),(142100,6016),(142101,6017),(142102,6018),(142103,6019),(142104,6020),(142105,6021),(142106,6022),(142107,6023),(142108,6024),(142109,6025),(142110,6026),(142111,6027),(142112,6028),(142113,6029),(142114,6030),(142115,6031),(142116,6032),(142117,6033),(142118,6034),(142119,5961),(142120,5961),(142121,5961),(142122,5961),(142123,5962),(142124,5962),(142125,5962),(142126,5962),(142127,5963),(142128,5963),(142129,5963),(142130,5963),(142131,5964),(142132,5964),(142133,5964),(142134,5964),(142135,5965),(142136,5965),(142137,5965),(142138,5965),(142139,5966),(142140,5966),(142141,5966),(142142,5966),(142143,5967),(142144,5967),(142145,5967),(142146,5967),(142147,5968),(142148,5968),(142149,5968),(142150,5968),(142151,5969),(142152,5969),(142153,5969),(142154,5969),(142155,5970),(142156,5970),(142157,5970),(142158,5970),(142159,5971),(142160,5971),(142161,5971),(142162,5971),(142163,5972),(142164,5972),(142165,5972),(142166,5972),(142167,5973),(142168,5973),(142169,5973),(142170,5973),(142171,5974),(142172,5974),(142173,5974),(142174,5974),(142175,5975),(142176,5975),(142177,5975),(142178,5975),(142179,5975),(142180,5975),(142181,5975),(142182,5976),(142183,5976),(142184,5976),(142185,5976),(142186,5976),(142187,5976),(142188,5976),(142189,5977),(142190,5977),(142191,5977),(142192,5977),(142193,5977),(142194,5977),(142195,5977),(142196,5978),(142197,5978),(142198,5978),(142199,5978),(142200,5978),(142201,5978),(142202,5978),(142203,5979),(142204,5979),(142205,5979),(142206,5979),(142207,5979),(142208,5979),(142209,5979),(142210,5980),(142211,5980),(142212,5980),(142213,5980),(142214,5980),(142215,5980),(142216,5980),(142217,5981),(142218,5981),(142219,5981),(142220,5981),(142221,5981),(142222,5981),(142223,5981),(142224,5982),(142225,5982),(142226,5982),(142227,5982),(142228,5982),(142229,5982),(142230,5982),(142231,5983),(142232,5983),(142233,5983),(142234,5983),(142235,5983),(142236,5983),(142237,5983),(142238,5984),(142239,5984),(142240,5984),(142241,5984),(142242,5984),(142243,5984),(142244,5984),(142245,5985),(142246,5985),(142247,5985),(142248,5985),(142249,5985),(142250,5985),(142251,5985),(142252,5986),(142253,5986),(142254,5986),(142255,5986),(142256,5986),(142257,5986),(142258,5986),(142259,5987),(142260,5987),(142261,5987),(142262,5987),(142263,5987),(142264,5987),(142265,5987),(142266,5988),(142267,5988),(142268,5988),(142269,5988),(142270,5988),(142271,5988),(142272,5988),(142273,5989),(142274,5989),(142275,5989),(142276,5989),(142277,5989),(142278,5989),(142279,5989),(142280,5990),(142281,5990),(142282,5990),(142283,5990),(142284,5990),(142285,5990),(142286,5990),(142287,5991),(142288,5991),(142289,5991),(142290,5991),(142291,5991),(142292,5991),(142293,5991),(142294,5992),(142295,5992),(142296,5992),(142297,5992),(142298,5992),(142299,5992),(142300,5992),(142301,5993),(142302,5993),(142303,5993),(142304,5993),(142305,5993),(142306,5993),(142307,5993),(142308,5994),(142309,5994),(142310,5994),(142311,5994),(142312,5994),(142313,5994),(142314,5994),(142315,5995),(142316,5995),(142317,5995),(142318,5995),(142319,5995),(142320,5995),(142321,5995),(142322,5996),(142323,5996),(142324,5996),(142325,5996),(142326,5996),(142327,5996),(142328,5996),(142329,5997),(142330,5997),(142331,5997),(142332,5997),(142333,5997),(142334,5997),(142335,5997),(142336,5998),(142337,5998),(142338,5998),(142339,5998),(142340,5998),(142341,5998),(142342,5998),(142343,5998),(142344,5998),(142345,5999),(142346,5999),(142347,5999),(142348,5999),(142349,5999),(142350,5999),(142351,5999),(142352,5999),(142353,5999),(142354,6000),(142355,6000),(142356,6000),(142357,6000),(142358,6000),(142359,6000),(142360,6000),(142361,6001),(142362,6001),(142363,6001),(142364,6001),(142365,6001),(142366,6001),(142367,6001),(142368,6002),(142369,6002),(142370,6002),(142371,6002),(142372,6002),(142373,6002),(142374,6002),(142375,6003),(142376,6003),(142377,6003),(142378,6003),(142379,6003),(142380,6003),(142381,6003),(142382,6004),(142383,6004),(142384,6004),(142385,6004),(142386,6004),(142387,6004),(142388,6004),(142389,6005),(142390,6005),(142391,6005),(142392,6005),(142393,6005),(142394,6005),(142395,6005),(142396,6005),(142397,6005),(142398,6006),(142399,6006),(142400,6006),(142401,6006),(142402,6006),(142403,6006),(142404,6006),(142405,6007),(142406,6007),(142407,6007),(142408,6007),(142409,6007),(142410,6007),(142411,6007),(142412,6008),(142413,6008),(142414,6008),(142415,6008),(142416,6008),(142417,6008),(142418,6009),(142419,6009),(142420,6009),(142421,6009),(142422,6009),(142423,6009),(142424,6010),(142425,6010),(142426,6010),(142427,6010),(142428,6010),(142429,6010),(142430,6011),(142431,6011),(142432,6011),(142433,6011),(142434,6011),(142435,6011),(142436,6012),(142437,6012),(142438,6012),(142439,6012),(142440,6012),(142441,6012),(142442,6012),(142443,6013),(142444,6013),(142445,6013),(142446,6013),(142447,6013),(142448,6013),(142449,6013),(142450,6014),(142451,6014),(142452,6014),(142453,6014),(142454,6014),(142455,6014),(142456,6014),(142457,6015),(142458,6015),(142459,6015),(142460,6015),(142461,6015),(142462,6015),(142463,6015),(142464,6016),(142465,6016),(142466,6016),(142467,6016),(142468,6016),(142469,6016),(142470,6016),(142471,6017),(142472,6017),(142473,6017),(142474,6017),(142475,6017),(142476,6017),(142477,6017),(142478,6018),(142479,6018),(142480,6018),(142481,6018),(142482,6018),(142483,6018),(142484,6018),(142485,6019),(142486,6019),(142487,6019),(142488,6019),(142489,6019),(142490,6019),(142491,6019),(142492,6020),(142493,6020),(142494,6020),(142495,6020),(142496,6020),(142497,6020),(142498,6020),(142499,6021),(142500,6021),(142501,6021),(142502,6021),(142503,6021),(142504,6021),(142505,6021),(142506,6022),(142507,6022),(142508,6022),(142509,6022),(142510,6022),(142511,6022),(142512,6022),(142513,6022),(142514,6022),(142515,6023),(142516,6023),(142517,6023),(142518,6023),(142519,6023),(142520,6023),(142521,6023),(142522,6023),(142523,6023),(142524,6024),(142525,6024),(142526,6024),(142527,6024),(142528,6024),(142529,6024),(142530,6024),(142531,6024),(142532,6024),(142533,6025),(142534,6025),(142535,6025),(142536,6025),(142537,6025),(142538,6025),(142539,6025),(142540,6025),(142541,6025),(142542,6026),(142543,6026),(142544,6026),(142545,6026),(142546,6026),(142547,6026),(142548,6026),(142549,6026),(142550,6026),(142551,6027),(142552,6027),(142553,6027),(142554,6027),(142555,6027),(142556,6027),(142557,6027),(142558,6027),(142559,6027),(142560,6028),(142561,6028),(142562,6028),(142563,6028),(142564,6028),(142565,6028),(142566,6028),(142567,6028),(142568,6028),(142569,6029),(142570,6029),(142571,6029),(142572,6029),(142573,6029),(142574,6029),(142575,6029),(142576,6029),(142577,6029),(142578,6030),(142579,6030),(142580,6030),(142581,6030),(142582,6030),(142583,6030),(142584,6030),(142585,6031),(142586,6031),(142587,6031),(142588,6031),(142589,6031),(142590,6031),(142591,6031),(142592,6032),(142593,6032),(142594,6032),(142595,6032),(142596,6032),(142597,6032),(142598,6032),(142599,6033),(142600,6033),(142601,6033),(142602,6033),(142603,6033),(142604,6033),(142605,6033),(142606,6034),(142607,6034),(142608,6034),(142609,6034),(142610,6034),(142611,6034),(142612,6034),(142613,5961),(142614,5961),(142615,5961),(142616,5962),(142617,5962),(142618,5962),(142619,5963),(142620,5963),(142621,5963),(142622,5964),(142623,5964),(142624,5964),(142625,5965),(142626,5965),(142627,5965),(142628,5966),(142629,5966),(142630,5966),(142631,5967),(142632,5967),(142633,5967),(142634,5968),(142635,5968),(142636,5968),(142637,5969),(142638,5969),(142639,5969),(142640,5970),(142641,5970),(142642,5970),(142643,5971),(142644,5971),(142645,5971),(142646,5972),(142647,5972),(142648,5972),(142649,5973),(142650,5973),(142651,5973),(142652,5974),(142653,5974),(142654,5974),(142655,5975),(142656,5975),(142657,5975),(142658,5976),(142659,5976),(142660,5976),(142661,5977),(142662,5977),(142663,5977),(142664,5978),(142665,5978),(142666,5978),(142667,5979),(142668,5979),(142669,5979),(142670,5980),(142671,5980),(142672,5980),(142673,5981),(142674,5981),(142675,5981),(142676,5982),(142677,5982),(142678,5982),(142679,5983),(142680,5983),(142681,5983),(142682,5984),(142683,5984),(142684,5984),(142685,5985),(142686,5985),(142687,5985),(142688,5986),(142689,5986),(142690,5986),(142691,5987),(142692,5987),(142693,5987),(142694,5988),(142695,5988),(142696,5988),(142697,5989),(142698,5989),(142699,5989),(142700,5990),(142701,5990),(142702,5990),(142703,5991),(142704,5991),(142705,5991),(142706,5992),(142707,5992),(142708,5992),(142709,5993),(142710,5993),(142711,5993),(142712,5994),(142713,5994),(142714,5994),(142715,5995),(142716,5995),(142717,5995),(142718,5996),(142719,5996),(142720,5996),(142721,5997),(142722,5997),(142723,5997),(142724,5998),(142725,5998),(142726,5999),(142727,5999),(142728,6000),(142729,6000),(142730,6000),(142731,6001),(142732,6001),(142733,6001),(142734,6002),(142735,6002),(142736,6002),(142737,6003),(142738,6003),(142739,6003),(142740,6004),(142741,6004),(142742,6004),(142743,6005),(142744,6005),(142745,6006),(142746,6006),(142747,6006),(142748,6007),(142749,6007),(142750,6007),(142751,6008),(142752,6008),(142753,6008),(142754,6009),(142755,6009),(142756,6009),(142757,6010),(142758,6010),(142759,6010),(142760,6011),(142761,6011),(142762,6011),(142763,6012),(142764,6012),(142765,6012),(142766,6013),(142767,6013),(142768,6013),(142769,6014),(142770,6014),(142771,6014),(142772,6015),(142773,6015),(142774,6015),(142775,6016),(142776,6016),(142777,6016),(142778,6017),(142779,6017),(142780,6017),(142781,6018),(142782,6018),(142783,6018),(142784,6019),(142785,6019),(142786,6019),(142787,6020),(142788,6020),(142789,6020),(142790,6021),(142791,6021),(142792,6021),(142793,6022),(142794,6022),(142795,6022),(142796,6023),(142797,6023),(142798,6023),(142799,6024),(142800,6024),(142801,6024),(142802,6025),(142803,6025),(142804,6025),(142805,6026),(142806,6026),(142807,6026),(142808,6027),(142809,6027),(142810,6027),(142811,6028),(142812,6028),(142813,6028),(142814,6029),(142815,6029),(142816,6029),(142817,6030),(142818,6030),(142819,6030),(142820,6031),(142821,6031),(142822,6031),(142823,6032),(142824,6032),(142825,6032),(142826,6033),(142827,6033),(142828,6033),(142829,6034),(142830,6034),(142831,6034),(142832,5961),(142833,5961),(142834,5961),(142835,5961),(142836,5961),(142837,5961),(142838,5961),(142839,5961),(142840,5961),(142841,5961),(142842,5961),(142843,5962),(142844,5962),(142845,5962),(142846,5962),(142847,5962),(142848,5962),(142849,5962),(142850,5962),(142851,5962),(142852,5962),(142853,5962),(142854,5963),(142855,5963),(142856,5963),(142857,5963),(142858,5963),(142859,5963),(142860,5963),(142861,5963),(142862,5963),(142863,5963),(142864,5963),(142865,5964),(142866,5964),(142867,5964),(142868,5964),(142869,5964),(142870,5964),(142871,5964),(142872,5964),(142873,5964),(142874,5964),(142875,5964),(142876,5965),(142877,5965),(142878,5965),(142879,5965),(142880,5965),(142881,5965),(142882,5965),(142883,5965),(142884,5965),(142885,5965),(142886,5965),(142887,5966),(142888,5966),(142889,5966),(142890,5966),(142891,5966),(142892,5966),(142893,5966),(142894,5966),(142895,5966),(142896,5966),(142897,5966),(142898,5967),(142899,5967),(142900,5967),(142901,5967),(142902,5967),(142903,5967),(142904,5967),(142905,5967),(142906,5967),(142907,5967),(142908,5967),(142909,5968),(142910,5968),(142911,5968),(142912,5968),(142913,5968),(142914,5968),(142915,5968),(142916,5968),(142917,5968),(142918,5968),(142919,5968),(142920,5969),(142921,5969),(142922,5969),(142923,5969),(142924,5969),(142925,5969),(142926,5969),(142927,5969),(142928,5969),(142929,5969),(142930,5969),(142931,5970),(142932,5970),(142933,5970),(142934,5970),(142935,5970),(142936,5970),(142937,5970),(142938,5970),(142939,5970),(142940,5970),(142941,5970),(142942,5971),(142943,5971),(142944,5971),(142945,5971),(142946,5971),(142947,5971),(142948,5971),(142949,5971),(142950,5971),(142951,5971),(142952,5971),(142953,5972),(142954,5972),(142955,5972),(142956,5972),(142957,5972),(142958,5972),(142959,5972),(142960,5972),(142961,5972),(142962,5972),(142963,5972),(142964,5973),(142965,5973),(142966,5973),(142967,5973),(142968,5973),(142969,5973),(142970,5973),(142971,5973),(142972,5973),(142973,5973),(142974,5973),(142975,5974),(142976,5974),(142977,5974),(142978,5974),(142979,5974),(142980,5974),(142981,5974),(142982,5974),(142983,5974),(142984,5974),(142985,5974),(142986,5975),(142987,5975),(142988,5975),(142989,5975),(142990,5975),(142991,5975),(142992,5975),(142993,5975),(142994,5975),(142995,5975),(142996,5975),(142997,5976),(142998,5976),(142999,5976),(143000,5976),(143001,5976),(143002,5976),(143003,5976),(143004,5976),(143005,5976),(143006,5976),(143007,5976),(143008,5977),(143009,5977),(143010,5977),(143011,5977),(143012,5977),(143013,5977),(143014,5977),(143015,5977),(143016,5977),(143017,5977),(143018,5977),(143019,5978),(143020,5978),(143021,5978),(143022,5978),(143023,5978),(143024,5978),(143025,5978),(143026,5978),(143027,5978),(143028,5978),(143029,5978),(143030,5979),(143031,5979),(143032,5979),(143033,5979),(143034,5979),(143035,5979),(143036,5979),(143037,5979),(143038,5979),(143039,5979),(143040,5979),(143041,5980),(143042,5980),(143043,5980),(143044,5980),(143045,5980),(143046,5980),(143047,5980),(143048,5980),(143049,5980),(143050,5980),(143051,5980),(143052,5981),(143053,5981),(143054,5981),(143055,5981),(143056,5981),(143057,5981),(143058,5981),(143059,5981),(143060,5981),(143061,5981),(143062,5981),(143063,5982),(143064,5982),(143065,5982),(143066,5982),(143067,5982),(143068,5982),(143069,5982),(143070,5982),(143071,5982),(143072,5982),(143073,5982),(143074,5983),(143075,5983),(143076,5983),(143077,5983),(143078,5983),(143079,5983),(143080,5983),(143081,5983),(143082,5983),(143083,5983),(143084,5983),(143085,5984),(143086,5984),(143087,5984),(143088,5984),(143089,5984),(143090,5984),(143091,5984),(143092,5984),(143093,5984),(143094,5984),(143095,5984),(143096,5985),(143097,5985),(143098,5985),(143099,5985),(143100,5985),(143101,5985),(143102,5985),(143103,5985),(143104,5985),(143105,5985),(143106,5985),(143107,5986),(143108,5986),(143109,5986),(143110,5986),(143111,5986),(143112,5986),(143113,5986),(143114,5986),(143115,5986),(143116,5986),(143117,5986),(143118,5987),(143119,5987),(143120,5987),(143121,5987),(143122,5987),(143123,5987),(143124,5987),(143125,5987),(143126,5987),(143127,5987),(143128,5987),(143129,5988),(143130,5988),(143131,5988),(143132,5988),(143133,5988),(143134,5988),(143135,5988),(143136,5988),(143137,5988),(143138,5988),(143139,5988),(143140,5989),(143141,5989),(143142,5989),(143143,5989),(143144,5989),(143145,5989),(143146,5989),(143147,5989),(143148,5989),(143149,5989),(143150,5989),(143151,5990),(143152,5990),(143153,5990),(143154,5990),(143155,5990),(143156,5990),(143157,5990),(143158,5990),(143159,5990),(143160,5990),(143161,5990),(143162,5991),(143163,5991),(143164,5991),(143165,5991),(143166,5991),(143167,5991),(143168,5991),(143169,5991),(143170,5991),(143171,5991),(143172,5991),(143173,5992),(143174,5992),(143175,5992),(143176,5992),(143177,5992),(143178,5992),(143179,5992),(143180,5992),(143181,5992),(143182,5992),(143183,5992),(143184,5993),(143185,5993),(143186,5993),(143187,5993),(143188,5993),(143189,5993),(143190,5993),(143191,5993),(143192,5993),(143193,5993),(143194,5993),(143195,5994),(143196,5994),(143197,5994),(143198,5994),(143199,5994),(143200,5994),(143201,5994),(143202,5994),(143203,5994),(143204,5994),(143205,5994),(143206,5995),(143207,5995),(143208,5995),(143209,5995),(143210,5995),(143211,5995),(143212,5995),(143213,5995),(143214,5995),(143215,5995),(143216,5995),(143217,5996),(143218,5996),(143219,5996),(143220,5996),(143221,5996),(143222,5996),(143223,5996),(143224,5996),(143225,5996),(143226,5996),(143227,5996),(143228,5997),(143229,5997),(143230,5997),(143231,5997),(143232,5997),(143233,5997),(143234,5997),(143235,5997),(143236,5997),(143237,5997),(143238,5997),(143239,5998),(143240,5998),(143241,5998),(143242,5998),(143243,5998),(143244,5998),(143245,5998),(143246,5998),(143247,5998),(143248,5998),(143249,5998),(143250,5999),(143251,5999),(143252,5999),(143253,5999),(143254,5999),(143255,5999),(143256,5999),(143257,5999),(143258,5999),(143259,5999),(143260,5999),(143261,6000),(143262,6000),(143263,6000),(143264,6000),(143265,6000),(143266,6000),(143267,6000),(143268,6000),(143269,6000),(143270,6000),(143271,6000),(143272,6001),(143273,6001),(143274,6001),(143275,6001),(143276,6001),(143277,6001),(143278,6001),(143279,6001),(143280,6001),(143281,6001),(143282,6001),(143283,6002),(143284,6002),(143285,6002),(143286,6002),(143287,6002),(143288,6002),(143289,6002),(143290,6002),(143291,6002),(143292,6002),(143293,6002),(143294,6003),(143295,6003),(143296,6003),(143297,6003),(143298,6003),(143299,6003),(143300,6003),(143301,6003),(143302,6003),(143303,6003),(143304,6003),(143305,6004),(143306,6004),(143307,6004),(143308,6004),(143309,6004),(143310,6004),(143311,6004),(143312,6004),(143313,6004),(143314,6004),(143315,6004),(143316,6005),(143317,6005),(143318,6005),(143319,6005),(143320,6005),(143321,6005),(143322,6005),(143323,6005),(143324,6005),(143325,6005),(143326,6005),(143327,6006),(143328,6006),(143329,6006),(143330,6006),(143331,6006),(143332,6006),(143333,6006),(143334,6006),(143335,6006),(143336,6006),(143337,6006),(143338,6007),(143339,6007),(143340,6007),(143341,6007),(143342,6007),(143343,6007),(143344,6007),(143345,6007),(143346,6007),(143347,6007),(143348,6007),(143349,6008),(143350,6008),(143351,6008),(143352,6008),(143353,6008),(143354,6008),(143355,6008),(143356,6008),(143357,6008),(143358,6008),(143359,6008),(143360,6009),(143361,6009),(143362,6009),(143363,6009),(143364,6009),(143365,6009),(143366,6009),(143367,6009),(143368,6009),(143369,6009),(143370,6009),(143371,6010),(143372,6010),(143373,6010),(143374,6010),(143375,6010),(143376,6010),(143377,6010),(143378,6010),(143379,6010),(143380,6010),(143381,6010),(143382,6011),(143383,6011),(143384,6011),(143385,6011),(143386,6011),(143387,6011),(143388,6011),(143389,6011),(143390,6011),(143391,6011),(143392,6011),(143393,6012),(143394,6012),(143395,6012),(143396,6012),(143397,6012),(143398,6012),(143399,6012),(143400,6012),(143401,6012),(143402,6012),(143403,6012),(143404,6013),(143405,6013),(143406,6013),(143407,6013),(143408,6013),(143409,6013),(143410,6013),(143411,6013),(143412,6013),(143413,6013),(143414,6013),(143415,6014),(143416,6014),(143417,6014),(143418,6014),(143419,6014),(143420,6014),(143421,6014),(143422,6014),(143423,6014),(143424,6014),(143425,6014),(143426,6015),(143427,6015),(143428,6015),(143429,6015),(143430,6015),(143431,6015),(143432,6015),(143433,6015),(143434,6015),(143435,6015),(143436,6015),(143437,6016),(143438,6016),(143439,6016),(143440,6016),(143441,6016),(143442,6016),(143443,6016),(143444,6016),(143445,6016),(143446,6016),(143447,6016),(143448,6017),(143449,6017),(143450,6017),(143451,6017),(143452,6017),(143453,6017),(143454,6017),(143455,6017),(143456,6017),(143457,6017),(143458,6017),(143459,6018),(143460,6018),(143461,6018),(143462,6018),(143463,6018),(143464,6018),(143465,6018),(143466,6018),(143467,6018),(143468,6018),(143469,6018),(143470,6019),(143471,6019),(143472,6019),(143473,6019),(143474,6019),(143475,6019),(143476,6019),(143477,6019),(143478,6019),(143479,6019),(143480,6019),(143481,6020),(143482,6020),(143483,6020),(143484,6020),(143485,6020),(143486,6020),(143487,6020),(143488,6020),(143489,6020),(143490,6020),(143491,6020),(143492,6021),(143493,6021),(143494,6021),(143495,6021),(143496,6021),(143497,6021),(143498,6021),(143499,6021),(143500,6021),(143501,6021),(143502,6021),(143503,6022),(143504,6022),(143505,6022),(143506,6022),(143507,6022),(143508,6022),(143509,6022),(143510,6022),(143511,6022),(143512,6022),(143513,6022),(143514,6023),(143515,6023),(143516,6023),(143517,6023),(143518,6023),(143519,6023),(143520,6023),(143521,6023),(143522,6023),(143523,6023),(143524,6023),(143525,6024),(143526,6024),(143527,6024),(143528,6024),(143529,6024),(143530,6024),(143531,6024),(143532,6024),(143533,6024),(143534,6024),(143535,6024),(143536,6025),(143537,6025),(143538,6025),(143539,6025),(143540,6025),(143541,6025),(143542,6025),(143543,6025),(143544,6025),(143545,6025),(143546,6025),(143547,6026),(143548,6026),(143549,6026),(143550,6026),(143551,6026),(143552,6026),(143553,6026),(143554,6026),(143555,6026),(143556,6026),(143557,6026),(143558,6027),(143559,6027),(143560,6027),(143561,6027),(143562,6027),(143563,6027),(143564,6027),(143565,6027),(143566,6027),(143567,6027),(143568,6027),(143569,6028),(143570,6028),(143571,6028),(143572,6028),(143573,6028),(143574,6028),(143575,6028),(143576,6028),(143577,6028),(143578,6028),(143579,6028),(143580,6029),(143581,6029),(143582,6029),(143583,6029),(143584,6029),(143585,6029),(143586,6029),(143587,6029),(143588,6029),(143589,6029),(143590,6029),(143591,6030),(143592,6030),(143593,6030),(143594,6030),(143595,6030),(143596,6030),(143597,6030),(143598,6030),(143599,6030),(143600,6030),(143601,6030),(143602,6031),(143603,6031),(143604,6031),(143605,6031),(143606,6031),(143607,6031),(143608,6031),(143609,6031),(143610,6031),(143611,6031),(143612,6031),(143613,6032),(143614,6032),(143615,6032),(143616,6032),(143617,6032),(143618,6032),(143619,6032),(143620,6032),(143621,6032),(143622,6032),(143623,6032),(143624,6033),(143625,6033),(143626,6033),(143627,6033),(143628,6033),(143629,6033),(143630,6033),(143631,6033),(143632,6033),(143633,6033),(143634,6033),(143635,6034),(143636,6034),(143637,6034),(143638,6034),(143639,6034),(143640,6034),(143641,6034),(143642,6034),(143643,6034),(143644,6034),(143645,6034),(143646,5961),(143647,5961),(143648,5961),(143649,5962),(143650,5962),(143651,5962),(143652,5963),(143653,5963),(143654,5963),(143655,5964),(143656,5964),(143657,5964),(143658,5965),(143659,5965),(143660,5965),(143661,5966),(143662,5966),(143663,5966),(143664,5967),(143665,5967),(143666,5967),(143667,5968),(143668,5968),(143669,5968),(143670,5969),(143671,5969),(143672,5969),(143673,5970),(143674,5970),(143675,5970),(143676,5971),(143677,5971),(143678,5971),(143679,5972),(143680,5972),(143681,5972),(143682,5973),(143683,5973),(143684,5973),(143685,5974),(143686,5974),(143687,5974),(143688,5975),(143689,5975),(143690,5975),(143691,5975),(143692,5976),(143693,5976),(143694,5976),(143695,5976),(143696,5977),(143697,5977),(143698,5977),(143699,5977),(143700,5978),(143701,5978),(143702,5978),(143703,5978),(143704,5979),(143705,5979),(143706,5979),(143707,5979),(143708,5980),(143709,5980),(143710,5980),(143711,5980),(143712,5981),(143713,5981),(143714,5981),(143715,5981),(143716,5982),(143717,5982),(143718,5982),(143719,5982),(143720,5983),(143721,5983),(143722,5983),(143723,5983),(143724,5984),(143725,5984),(143726,5984),(143727,5984),(143728,5985),(143729,5985),(143730,5985),(143731,5985),(143732,5986),(143733,5986),(143734,5986),(143735,5986),(143736,5987),(143737,5987),(143738,5987),(143739,5987),(143740,5988),(143741,5988),(143742,5988),(143743,5988),(143744,5989),(143745,5989),(143746,5989),(143747,5989),(143748,5990),(143749,5990),(143750,5990),(143751,5990),(143752,5991),(143753,5991),(143754,5991),(143755,5991),(143756,5992),(143757,5992),(143758,5992),(143759,5992),(143760,5993),(143761,5993),(143762,5993),(143763,5993),(143764,5994),(143765,5994),(143766,5994),(143767,5995),(143768,5995),(143769,5995),(143770,5996),(143771,5996),(143772,5996),(143773,5997),(143774,5997),(143775,5997),(143776,5998),(143777,5998),(143778,5998),(143779,5998),(143780,5999),(143781,5999),(143782,5999),(143783,5999),(143784,6000),(143785,6000),(143786,6000),(143787,6001),(143788,6001),(143789,6001),(143790,6002),(143791,6002),(143792,6002),(143793,6003),(143794,6003),(143795,6003),(143796,6003),(143797,6004),(143798,6004),(143799,6004),(143800,6004),(143801,6005),(143802,6005),(143803,6005),(143804,6005),(143805,6006),(143806,6006),(143807,6006),(143808,6006),(143809,6007),(143810,6007),(143811,6007),(143812,6007),(143813,6008),(143814,6008),(143815,6008),(143816,6008),(143817,6009),(143818,6009),(143819,6009),(143820,6009),(143821,6010),(143822,6010),(143823,6010),(143824,6010),(143825,6011),(143826,6011),(143827,6011),(143828,6011),(143829,6012),(143830,6012),(143831,6012),(143832,6013),(143833,6013),(143834,6013),(143835,6014),(143836,6014),(143837,6014),(143838,6015),(143839,6015),(143840,6015),(143841,6016),(143842,6016),(143843,6016),(143844,6017),(143845,6017),(143846,6017),(143847,6018),(143848,6018),(143849,6018),(143850,6019),(143851,6019),(143852,6019),(143853,6020),(143854,6020),(143855,6020),(143856,6020),(143857,6021),(143858,6021),(143859,6021),(143860,6021),(143861,6022),(143862,6022),(143863,6022),(143864,6022),(143865,6023),(143866,6023),(143867,6023),(143868,6023),(143869,6024),(143870,6024),(143871,6024),(143872,6024),(143873,6025),(143874,6025),(143875,6025),(143876,6025),(143877,6026),(143878,6026),(143879,6026),(143880,6026),(143881,6027),(143882,6027),(143883,6027),(143884,6027),(143885,6028),(143886,6028),(143887,6028),(143888,6028),(143889,6029),(143890,6029),(143891,6029),(143892,6029),(143893,6030),(143894,6030),(143895,6030),(143896,6030),(143897,6031),(143898,6031),(143899,6031),(143900,6031),(143901,6032),(143902,6032),(143903,6032),(143904,6032),(143905,6033),(143906,6033),(143907,6033),(143908,6033),(143909,6034),(143910,6034),(143911,6034),(143912,6034),(143913,5761),(143914,5762),(143915,5763),(143916,5764),(143917,5765),(143918,5766),(143919,5767),(143920,5768),(143921,5769),(143922,5770),(143923,5771),(143924,5772),(143925,5773),(143926,5774),(143927,5775),(143928,5776),(143929,5777),(143930,5778),(143931,5779),(143932,5780),(143933,5781),(143934,5782),(143935,5783),(143936,5784),(143937,5785),(143938,5786),(143939,5787),(143940,5788),(143941,5789),(143942,5790),(143943,5791),(143944,5792),(143945,5793),(143946,5794),(143947,5795),(143948,5796),(143949,5797),(143950,5798),(143951,5799),(143952,5800),(143953,5801),(143954,5802),(143955,5803),(143956,5804),(143957,5805),(143958,5806),(143959,5807),(143960,5808),(143961,5809),(143962,5810),(143963,5811),(143964,5812),(143965,5813),(143966,5814),(143967,5815),(143968,5816),(143969,5817),(143970,5818),(143971,5819),(143972,5820),(143973,5821),(143974,5822),(143975,5823),(143976,5824),(143977,5825),(143978,5826),(143979,5827),(143980,5828),(143981,5829),(143982,5830),(143983,5831),(143984,5832),(143985,5833),(143986,5834),(143987,5835),(143988,5836),(143989,5837),(143990,5838),(143991,5839),(143992,5840),(143993,5841),(143994,5842),(143995,5843),(143996,5844),(143997,5845),(143998,5846),(143999,5847),(144000,5848),(144001,5849),(144002,5850),(144003,5851),(144004,5852),(144005,5853),(144006,5854),(144007,5855),(144008,5856),(144009,5857),(144010,5858),(144011,5859),(144012,5860),(144013,5861),(144014,5862),(144015,5863),(144016,5864),(144017,5865),(144018,5866),(144019,5867),(144020,5868),(144021,5869),(144022,5870),(144023,5871),(144024,5872),(144025,5873),(144026,5874),(144027,5875),(144028,5876),(144029,5877),(144030,5878),(144031,5879),(144032,5880),(144033,5881),(144034,5882),(144035,5883),(144036,5884),(144037,5885),(144038,5886),(144039,5887),(144040,5888),(144041,5889),(144042,5890),(144043,5891),(144044,5892),(144045,5893),(144046,5894),(144047,5895),(144048,5896),(144049,5897),(144050,5898),(144051,5899),(144052,5900),(144053,5901),(144054,5902),(144055,5903),(144056,5904),(144057,5905),(144058,5906),(144059,5907),(144060,5908),(144061,5909),(144062,5910),(144063,5911),(144064,5912),(144065,5913),(144066,5914),(144067,5915),(144068,5916),(144069,5917),(144070,5918),(144071,5919),(144072,5920),(144073,5921),(144074,5922),(144075,5923),(144076,5924),(144077,5925),(144078,5926),(144079,5927),(144080,5928),(144081,5929),(144082,5930),(144083,5931),(144084,5932),(144085,5933),(144086,5934),(144087,5935),(144088,5936),(144089,5937),(144090,5938),(144091,5939),(144092,5940),(144093,5941),(144094,5942),(144095,5943),(144096,5944),(144097,5945),(144098,5946),(144099,5947),(144100,5948),(144101,5949),(144102,5950),(144103,5951),(144104,5952),(144105,5953),(144106,5954),(144107,5955),(144108,5956),(144109,5957),(144110,5958),(144111,5959),(144112,5960),(144113,5961),(144114,5962),(144115,5963),(144116,5964),(144117,5965),(144118,5966),(144119,5967),(144120,5968),(144121,5969),(144122,5970),(144123,5971),(144124,5972),(144125,5973),(144126,5974),(144127,5975),(144128,5976),(144129,5977),(144130,5978),(144131,5979),(144132,5980),(144133,5981),(144134,5982),(144135,5983),(144136,5984),(144137,5985),(144138,5986),(144139,5987),(144140,5988),(144141,5989),(144142,5990),(144143,5991),(144144,5992),(144145,5993),(144146,5994),(144147,5995),(144148,5996),(144149,5997),(144150,5998),(144151,5999),(144152,6000),(144153,6001),(144154,6002),(144155,6003),(144156,6004),(144157,6005),(144158,6006),(144159,6007),(144160,6008),(144161,6009),(144162,6010),(144163,6011),(144164,6012),(144165,6013),(144166,6014),(144167,6015),(144168,6016),(144169,6017),(144170,6018),(144171,6019),(144172,6020),(144173,6021),(144174,6022),(144175,6023),(144176,6024),(144177,6025),(144178,6026),(144179,6027),(144180,6028),(144181,6029),(144182,6030),(144183,6031),(144184,6032),(144185,6033),(144186,6034),(144187,6035),(144188,6036),(144189,6037),(144190,6038),(144191,6039),(144192,6040),(144193,6041),(144194,6042),(144195,6043),(144196,6044),(144197,6045),(144198,6046),(144199,6047),(144200,6048),(144201,6049),(144202,6050),(144203,6051),(144204,6052),(144205,6053),(144206,6054),(144207,6055),(144208,6056),(144209,6057),(144210,6058),(144211,6059),(144212,6060),(144213,6061),(144214,6062),(144215,6063),(144216,6064),(144217,6065),(144218,6066),(144219,6067),(144220,6068),(144221,6069),(144222,6070),(144223,6071),(144224,6072),(144225,6073),(144226,6074),(144227,6075),(144228,6076),(144229,6077),(144230,6078),(144231,6079),(144232,6080),(144233,6081),(144234,6082),(144235,6083),(144236,6084),(144237,6085),(144238,6086),(144239,6087),(144240,6088),(144241,6089),(144242,6090),(144243,6091),(144244,6092),(144245,6093),(144246,6094),(144247,6095),(144248,6096),(144249,6097),(144250,6098),(144251,6099),(144252,6100),(144253,6101),(144254,6102),(144255,6103),(144256,6104),(144257,6105),(144258,6106),(144259,6107),(144260,6108),(144261,6109),(144262,6110),(144263,6111),(144264,6112),(144265,6113),(144266,6114),(144267,6115),(144268,6116),(144269,6117),(144270,6118),(144271,6119),(144272,6120),(144273,6121),(144274,6122),(144275,6123),(144276,6124),(144277,6125),(144278,6126),(144279,6127),(144280,6128),(144281,6129),(144282,6130),(144283,6131),(144284,6132),(144285,6133),(144286,6134),(144287,6035),(144288,6036),(144289,6037),(144290,6038),(144291,6039),(144292,6040),(144293,6041),(144294,6042),(144295,6043),(144296,6044),(144297,6045),(144298,6046),(144299,6047),(144300,6048),(144301,6049),(144302,6050),(144303,6051),(144304,6052),(144305,6053),(144306,6054),(144307,6055),(144308,6056),(144309,6057),(144310,6058),(144311,6059),(144312,6060),(144313,6061),(144314,6062),(144315,6063),(144316,6064),(144317,6065),(144318,6066),(144319,6067),(144320,6068),(144321,6069),(144322,6070),(144323,6071),(144324,6072),(144325,6073),(144326,6074),(144327,6075),(144328,6076),(144329,6077),(144330,6078),(144331,6079),(144332,6080),(144333,6081),(144334,6082),(144335,6083),(144336,6084),(144337,6085),(144338,6086),(144339,6087),(144340,6088),(144341,6089),(144342,6090),(144343,6091),(144344,6092),(144345,6093),(144346,6094),(144347,6095),(144348,6096),(144349,6097),(144350,6098),(144351,6099),(144352,6100),(144353,6101),(144354,6102),(144355,6103),(144356,6104),(144357,6105),(144358,6106),(144359,6107),(144360,6108),(144361,6109),(144362,6110),(144363,6111),(144364,6112),(144365,6113),(144366,6114),(144367,6115),(144368,6116),(144369,6117),(144370,6118),(144371,6119),(144372,6120),(144373,6121),(144374,6122),(144375,6123),(144376,6124),(144377,6125),(144378,6126),(144379,6127),(144380,6128),(144381,6129),(144382,6130),(144383,6131),(144384,6132),(144385,6133),(144386,6134),(144387,6035),(144388,6035),(144389,6035),(144390,6036),(144391,6036),(144392,6036),(144393,6037),(144394,6037),(144395,6037),(144396,6038),(144397,6038),(144398,6038),(144399,6039),(144400,6039),(144401,6039),(144402,6040),(144403,6040),(144404,6040),(144405,6041),(144406,6041),(144407,6041),(144408,6042),(144409,6042),(144410,6042),(144411,6043),(144412,6043),(144413,6043),(144414,6044),(144415,6044),(144416,6044),(144417,6045),(144418,6045),(144419,6045),(144420,6046),(144421,6046),(144422,6046),(144423,6047),(144424,6047),(144425,6047),(144426,6048),(144427,6048),(144428,6048),(144429,6049),(144430,6049),(144431,6049),(144432,6050),(144433,6050),(144434,6050),(144435,6051),(144436,6051),(144437,6051),(144438,6052),(144439,6052),(144440,6052),(144441,6053),(144442,6053),(144443,6053),(144444,6054),(144445,6054),(144446,6054),(144447,6055),(144448,6055),(144449,6055),(144450,6056),(144451,6056),(144452,6056),(144453,6057),(144454,6057),(144455,6057),(144456,6058),(144457,6058),(144458,6058),(144459,6059),(144460,6059),(144461,6059),(144462,6060),(144463,6060),(144464,6060),(144465,6061),(144466,6061),(144467,6061),(144468,6062),(144469,6062),(144470,6062),(144471,6063),(144472,6063),(144473,6063),(144474,6064),(144475,6064),(144476,6064),(144477,6065),(144478,6065),(144479,6065),(144480,6066),(144481,6066),(144482,6066),(144483,6067),(144484,6067),(144485,6067),(144486,6068),(144487,6068),(144488,6068),(144489,6069),(144490,6069),(144491,6069),(144492,6070),(144493,6070),(144494,6070),(144495,6071),(144496,6071),(144497,6071),(144498,6072),(144499,6072),(144500,6072),(144501,6073),(144502,6073),(144503,6073),(144504,6074),(144505,6074),(144506,6074),(144507,6075),(144508,6075),(144509,6075),(144510,6076),(144511,6076),(144512,6076),(144513,6077),(144514,6077),(144515,6077),(144516,6078),(144517,6078),(144518,6078),(144519,6079),(144520,6079),(144521,6079),(144522,6080),(144523,6080),(144524,6080),(144525,6081),(144526,6081),(144527,6081),(144528,6082),(144529,6082),(144530,6082),(144531,6083),(144532,6083),(144533,6083),(144534,6084),(144535,6084),(144536,6084),(144537,6085),(144538,6085),(144539,6085),(144540,6086),(144541,6086),(144542,6086),(144543,6087),(144544,6087),(144545,6087),(144546,6088),(144547,6088),(144548,6088),(144549,6089),(144550,6089),(144551,6089),(144552,6090),(144553,6090),(144554,6090),(144555,6091),(144556,6091),(144557,6091),(144558,6092),(144559,6092),(144560,6092),(144561,6093),(144562,6093),(144563,6093),(144564,6094),(144565,6094),(144566,6094),(144567,6095),(144568,6095),(144569,6095),(144570,6096),(144571,6096),(144572,6096),(144573,6097),(144574,6097),(144575,6097),(144576,6098),(144577,6098),(144578,6098),(144579,6099),(144580,6099),(144581,6099),(144582,6100),(144583,6100),(144584,6100),(144585,6101),(144586,6101),(144587,6101),(144588,6102),(144589,6102),(144590,6102),(144591,6103),(144592,6103),(144593,6103),(144594,6104),(144595,6104),(144596,6104),(144597,6105),(144598,6105),(144599,6105),(144600,6106),(144601,6106),(144602,6106),(144603,6107),(144604,6107),(144605,6107),(144606,6108),(144607,6108),(144608,6108),(144609,6109),(144610,6109),(144611,6109),(144612,6110),(144613,6110),(144614,6110),(144615,6111),(144616,6111),(144617,6111),(144618,6112),(144619,6112),(144620,6112),(144621,6113),(144622,6113),(144623,6113),(144624,6114),(144625,6114),(144626,6114),(144627,6115),(144628,6115),(144629,6115),(144630,6116),(144631,6116),(144632,6116),(144633,6117),(144634,6117),(144635,6117),(144636,6118),(144637,6118),(144638,6118),(144639,6119),(144640,6119),(144641,6119),(144642,6120),(144643,6120),(144644,6120),(144645,6121),(144646,6121),(144647,6121),(144648,6122),(144649,6122),(144650,6122),(144651,6123),(144652,6123),(144653,6123),(144654,6124),(144655,6124),(144656,6124),(144657,6125),(144658,6125),(144659,6125),(144660,6126),(144661,6126),(144662,6126),(144663,6127),(144664,6127),(144665,6127),(144666,6128),(144667,6128),(144668,6128),(144669,6129),(144670,6129),(144671,6129),(144672,6130),(144673,6130),(144674,6130),(144675,6131),(144676,6131),(144677,6131),(144678,6132),(144679,6132),(144680,6132),(144681,6133),(144682,6133),(144683,6133),(144684,6134),(144685,6134),(144686,6134),(144687,6035),(144688,6035),(144689,6035),(144690,6035),(144691,6035),(144692,6035),(144693,6035),(144694,6035),(144695,6036),(144696,6036),(144697,6036),(144698,6036),(144699,6036),(144700,6036),(144701,6036),(144702,6036),(144703,6037),(144704,6037),(144705,6037),(144706,6037),(144707,6037),(144708,6037),(144709,6037),(144710,6037),(144711,6038),(144712,6038),(144713,6038),(144714,6038),(144715,6038),(144716,6038),(144717,6038),(144718,6038),(144719,6039),(144720,6039),(144721,6039),(144722,6039),(144723,6039),(144724,6039),(144725,6039),(144726,6039),(144727,6040),(144728,6040),(144729,6040),(144730,6040),(144731,6040),(144732,6040),(144733,6040),(144734,6040),(144735,6041),(144736,6041),(144737,6041),(144738,6041),(144739,6041),(144740,6041),(144741,6041),(144742,6041),(144743,6041),(144744,6041),(144745,6042),(144746,6042),(144747,6042),(144748,6042),(144749,6042),(144750,6042),(144751,6042),(144752,6042),(144753,6042),(144754,6042),(144755,6043),(144756,6043),(144757,6043),(144758,6043),(144759,6043),(144760,6043),(144761,6043),(144762,6043),(144763,6043),(144764,6043),(144765,6044),(144766,6044),(144767,6044),(144768,6044),(144769,6044),(144770,6044),(144771,6044),(144772,6044),(144773,6044),(144774,6044),(144775,6045),(144776,6045),(144777,6045),(144778,6045),(144779,6045),(144780,6045),(144781,6045),(144782,6045),(144783,6045),(144784,6045),(144785,6046),(144786,6046),(144787,6046),(144788,6046),(144789,6046),(144790,6046),(144791,6046),(144792,6046),(144793,6046),(144794,6046),(144795,6047),(144796,6047),(144797,6047),(144798,6047),(144799,6047),(144800,6047),(144801,6047),(144802,6047),(144803,6047),(144804,6047),(144805,6048),(144806,6048),(144807,6048),(144808,6048),(144809,6048),(144810,6048),(144811,6048),(144812,6048),(144813,6048),(144814,6048),(144815,6049),(144816,6049),(144817,6049),(144818,6049),(144819,6049),(144820,6049),(144821,6049),(144822,6049),(144823,6049),(144824,6049),(144825,6050),(144826,6050),(144827,6050),(144828,6050),(144829,6050),(144830,6050),(144831,6050),(144832,6050),(144833,6050),(144834,6050),(144835,6051),(144836,6051),(144837,6051),(144838,6051),(144839,6051),(144840,6051),(144841,6051),(144842,6051),(144843,6051),(144844,6051),(144845,6052),(144846,6052),(144847,6052),(144848,6052),(144849,6052),(144850,6052),(144851,6052),(144852,6052),(144853,6052),(144854,6052),(144855,6053),(144856,6053),(144857,6053),(144858,6053),(144859,6053),(144860,6053),(144861,6053),(144862,6053),(144863,6053),(144864,6053),(144865,6053),(144866,6053),(144867,6053),(144868,6053),(144869,6054),(144870,6054),(144871,6054),(144872,6054),(144873,6054),(144874,6054),(144875,6054),(144876,6054),(144877,6054),(144878,6054),(144879,6054),(144880,6054),(144881,6054),(144882,6054),(144883,6055),(144884,6055),(144885,6055),(144886,6055),(144887,6055),(144888,6055),(144889,6055),(144890,6055),(144891,6055),(144892,6055),(144893,6056),(144894,6056),(144895,6056),(144896,6056),(144897,6056),(144898,6056),(144899,6056),(144900,6056),(144901,6056),(144902,6056),(144903,6057),(144904,6057),(144905,6057),(144906,6057),(144907,6057),(144908,6057),(144909,6057),(144910,6057),(144911,6057),(144912,6057),(144913,6058),(144914,6058),(144915,6058),(144916,6058),(144917,6058),(144918,6058),(144919,6058),(144920,6058),(144921,6058),(144922,6058),(144923,6059),(144924,6059),(144925,6059),(144926,6059),(144927,6059),(144928,6059),(144929,6059),(144930,6059),(144931,6059),(144932,6059),(144933,6060),(144934,6060),(144935,6060),(144936,6060),(144937,6060),(144938,6060),(144939,6060),(144940,6060),(144941,6060),(144942,6060),(144943,6061),(144944,6061),(144945,6061),(144946,6061),(144947,6061),(144948,6061),(144949,6061),(144950,6061),(144951,6061),(144952,6061),(144953,6062),(144954,6062),(144955,6062),(144956,6062),(144957,6062),(144958,6062),(144959,6062),(144960,6062),(144961,6062),(144962,6062),(144963,6063),(144964,6063),(144965,6063),(144966,6063),(144967,6063),(144968,6063),(144969,6063),(144970,6063),(144971,6063),(144972,6063),(144973,6064),(144974,6064),(144975,6064),(144976,6064),(144977,6064),(144978,6064),(144979,6064),(144980,6064),(144981,6064),(144982,6064),(144983,6065),(144984,6065),(144985,6065),(144986,6065),(144987,6065),(144988,6065),(144989,6065),(144990,6065),(144991,6065),(144992,6065),(144993,6066),(144994,6066),(144995,6066),(144996,6066),(144997,6066),(144998,6066),(144999,6066),(145000,6066),(145001,6066),(145002,6066),(145003,6067),(145004,6067),(145005,6067),(145006,6067),(145007,6067),(145008,6067),(145009,6067),(145010,6067),(145011,6067),(145012,6067),(145013,6068),(145014,6068),(145015,6068),(145016,6068),(145017,6068),(145018,6068),(145019,6068),(145020,6068),(145021,6068),(145022,6068),(145023,6069),(145024,6069),(145025,6069),(145026,6069),(145027,6069),(145028,6069),(145029,6069),(145030,6069),(145031,6069),(145032,6069),(145033,6070),(145034,6070),(145035,6070),(145036,6070),(145037,6070),(145038,6070),(145039,6070),(145040,6070),(145041,6070),(145042,6070),(145043,6071),(145044,6071),(145045,6071),(145046,6071),(145047,6071),(145048,6071),(145049,6071),(145050,6071),(145051,6071),(145052,6071),(145053,6071),(145054,6071),(145055,6071),(145056,6071),(145057,6072),(145058,6072),(145059,6072),(145060,6072),(145061,6072),(145062,6072),(145063,6072),(145064,6072),(145065,6072),(145066,6072),(145067,6073),(145068,6073),(145069,6073),(145070,6073),(145071,6073),(145072,6073),(145073,6073),(145074,6073),(145075,6073),(145076,6073),(145077,6074),(145078,6074),(145079,6074),(145080,6074),(145081,6074),(145082,6074),(145083,6074),(145084,6074),(145085,6074),(145086,6074),(145087,6075),(145088,6075),(145089,6075),(145090,6075),(145091,6075),(145092,6075),(145093,6075),(145094,6075),(145095,6075),(145096,6075),(145097,6076),(145098,6076),(145099,6076),(145100,6076),(145101,6076),(145102,6076),(145103,6076),(145104,6076),(145105,6076),(145106,6076),(145107,6077),(145108,6077),(145109,6077),(145110,6077),(145111,6077),(145112,6077),(145113,6077),(145114,6077),(145115,6077),(145116,6077),(145117,6078),(145118,6078),(145119,6078),(145120,6078),(145121,6078),(145122,6078),(145123,6078),(145124,6078),(145125,6078),(145126,6078),(145127,6079),(145128,6079),(145129,6079),(145130,6079),(145131,6079),(145132,6079),(145133,6079),(145134,6079),(145135,6079),(145136,6079),(145137,6080),(145138,6080),(145139,6080),(145140,6080),(145141,6080),(145142,6080),(145143,6080),(145144,6080),(145145,6080),(145146,6080),(145147,6081),(145148,6081),(145149,6081),(145150,6081),(145151,6081),(145152,6081),(145153,6081),(145154,6081),(145155,6081),(145156,6081),(145157,6082),(145158,6082),(145159,6082),(145160,6082),(145161,6082),(145162,6082),(145163,6082),(145164,6082),(145165,6082),(145166,6082),(145167,6083),(145168,6083),(145169,6083),(145170,6083),(145171,6083),(145172,6083),(145173,6083),(145174,6083),(145175,6083),(145176,6083),(145177,6084),(145178,6084),(145179,6084),(145180,6084),(145181,6084),(145182,6084),(145183,6084),(145184,6084),(145185,6084),(145186,6084),(145187,6085),(145188,6085),(145189,6085),(145190,6085),(145191,6085),(145192,6085),(145193,6085),(145194,6085),(145195,6085),(145196,6085),(145197,6086),(145198,6086),(145199,6086),(145200,6086),(145201,6086),(145202,6086),(145203,6086),(145204,6086),(145205,6086),(145206,6086),(145207,6087),(145208,6087),(145209,6087),(145210,6087),(145211,6087),(145212,6087),(145213,6087),(145214,6087),(145215,6087),(145216,6087),(145217,6088),(145218,6088),(145219,6088),(145220,6088),(145221,6088),(145222,6088),(145223,6088),(145224,6088),(145225,6088),(145226,6088),(145227,6088),(145228,6088),(145229,6088),(145230,6088),(145231,6089),(145232,6089),(145233,6089),(145234,6089),(145235,6089),(145236,6089),(145237,6089),(145238,6089),(145239,6089),(145240,6089),(145241,6090),(145242,6090),(145243,6090),(145244,6090),(145245,6090),(145246,6090),(145247,6090),(145248,6090),(145249,6090),(145250,6090),(145251,6091),(145252,6091),(145253,6091),(145254,6091),(145255,6091),(145256,6091),(145257,6091),(145258,6091),(145259,6091),(145260,6091),(145261,6092),(145262,6092),(145263,6092),(145264,6092),(145265,6092),(145266,6092),(145267,6092),(145268,6092),(145269,6092),(145270,6092),(145271,6092),(145272,6092),(145273,6092),(145274,6092),(145275,6093),(145276,6093),(145277,6093),(145278,6093),(145279,6093),(145280,6093),(145281,6093),(145282,6093),(145283,6093),(145284,6093),(145285,6094),(145286,6094),(145287,6094),(145288,6094),(145289,6094),(145290,6094),(145291,6094),(145292,6094),(145293,6094),(145294,6094),(145295,6095),(145296,6095),(145297,6095),(145298,6095),(145299,6095),(145300,6095),(145301,6095),(145302,6095),(145303,6095),(145304,6095),(145305,6096),(145306,6096),(145307,6096),(145308,6096),(145309,6096),(145310,6096),(145311,6096),(145312,6096),(145313,6096),(145314,6096),(145315,6096),(145316,6096),(145317,6096),(145318,6096),(145319,6097),(145320,6097),(145321,6097),(145322,6097),(145323,6097),(145324,6097),(145325,6097),(145326,6097),(145327,6097),(145328,6097),(145329,6098),(145330,6098),(145331,6098),(145332,6098),(145333,6098),(145334,6098),(145335,6098),(145336,6098),(145337,6098),(145338,6098),(145339,6099),(145340,6099),(145341,6099),(145342,6099),(145343,6099),(145344,6099),(145345,6099),(145346,6099),(145347,6099),(145348,6099),(145349,6100),(145350,6100),(145351,6100),(145352,6100),(145353,6100),(145354,6100),(145355,6100),(145356,6100),(145357,6100),(145358,6100),(145359,6101),(145360,6101),(145361,6101),(145362,6101),(145363,6101),(145364,6101),(145365,6101),(145366,6101),(145367,6101),(145368,6101),(145369,6102),(145370,6102),(145371,6102),(145372,6102),(145373,6102),(145374,6102),(145375,6102),(145376,6102),(145377,6102),(145378,6102),(145379,6103),(145380,6103),(145381,6103),(145382,6103),(145383,6103),(145384,6103),(145385,6103),(145386,6103),(145387,6103),(145388,6103),(145389,6104),(145390,6104),(145391,6104),(145392,6104),(145393,6104),(145394,6104),(145395,6104),(145396,6104),(145397,6104),(145398,6104),(145399,6105),(145400,6105),(145401,6105),(145402,6105),(145403,6105),(145404,6105),(145405,6105),(145406,6105),(145407,6105),(145408,6105),(145409,6105),(145410,6105),(145411,6105),(145412,6105),(145413,6106),(145414,6106),(145415,6106),(145416,6106),(145417,6106),(145418,6106),(145419,6106),(145420,6106),(145421,6106),(145422,6106),(145423,6107),(145424,6107),(145425,6107),(145426,6107),(145427,6107),(145428,6107),(145429,6107),(145430,6107),(145431,6107),(145432,6107),(145433,6108),(145434,6108),(145435,6108),(145436,6108),(145437,6108),(145438,6108),(145439,6108),(145440,6108),(145441,6108),(145442,6108),(145443,6109),(145444,6109),(145445,6109),(145446,6109),(145447,6109),(145448,6109),(145449,6109),(145450,6109),(145451,6109),(145452,6109),(145453,6109),(145454,6109),(145455,6109),(145456,6109),(145457,6110),(145458,6110),(145459,6110),(145460,6110),(145461,6110),(145462,6110),(145463,6110),(145464,6110),(145465,6110),(145466,6110),(145467,6111),(145468,6111),(145469,6111),(145470,6111),(145471,6111),(145472,6111),(145473,6111),(145474,6111),(145475,6111),(145476,6111),(145477,6112),(145478,6112),(145479,6112),(145480,6112),(145481,6112),(145482,6112),(145483,6112),(145484,6112),(145485,6112),(145486,6112),(145487,6113),(145488,6113),(145489,6113),(145490,6113),(145491,6113),(145492,6113),(145493,6113),(145494,6113),(145495,6113),(145496,6113),(145497,6113),(145498,6113),(145499,6113),(145500,6113),(145501,6114),(145502,6114),(145503,6114),(145504,6114),(145505,6114),(145506,6114),(145507,6114),(145508,6114),(145509,6114),(145510,6114),(145511,6115),(145512,6115),(145513,6115),(145514,6115),(145515,6115),(145516,6115),(145517,6115),(145518,6115),(145519,6115),(145520,6115),(145521,6116),(145522,6116),(145523,6116),(145524,6116),(145525,6116),(145526,6116),(145527,6116),(145528,6116),(145529,6116),(145530,6116),(145531,6117),(145532,6117),(145533,6117),(145534,6117),(145535,6117),(145536,6117),(145537,6117),(145538,6117),(145539,6117),(145540,6117),(145541,6118),(145542,6118),(145543,6118),(145544,6118),(145545,6118),(145546,6118),(145547,6118),(145548,6118),(145549,6118),(145550,6118),(145551,6119),(145552,6119),(145553,6119),(145554,6119),(145555,6119),(145556,6119),(145557,6119),(145558,6119),(145559,6119),(145560,6119),(145561,6120),(145562,6120),(145563,6120),(145564,6120),(145565,6120),(145566,6120),(145567,6120),(145568,6120),(145569,6120),(145570,6120),(145571,6121),(145572,6121),(145573,6121),(145574,6121),(145575,6121),(145576,6121),(145577,6121),(145578,6121),(145579,6121),(145580,6121),(145581,6122),(145582,6122),(145583,6122),(145584,6122),(145585,6122),(145586,6122),(145587,6122),(145588,6122),(145589,6122),(145590,6122),(145591,6123),(145592,6123),(145593,6123),(145594,6123),(145595,6123),(145596,6123),(145597,6123),(145598,6123),(145599,6123),(145600,6123),(145601,6124),(145602,6124),(145603,6124),(145604,6124),(145605,6124),(145606,6124),(145607,6124),(145608,6124),(145609,6124),(145610,6124),(145611,6125),(145612,6125),(145613,6125),(145614,6125),(145615,6125),(145616,6125),(145617,6125),(145618,6125),(145619,6125),(145620,6125),(145621,6125),(145622,6125),(145623,6125),(145624,6125),(145625,6126),(145626,6126),(145627,6126),(145628,6126),(145629,6126),(145630,6126),(145631,6126),(145632,6126),(145633,6126),(145634,6126),(145635,6126),(145636,6126),(145637,6126),(145638,6126),(145639,6127),(145640,6127),(145641,6127),(145642,6127),(145643,6127),(145644,6127),(145645,6127),(145646,6127),(145647,6127),(145648,6127),(145649,6127),(145650,6127),(145651,6127),(145652,6127),(145653,6128),(145654,6128),(145655,6128),(145656,6128),(145657,6128),(145658,6128),(145659,6128),(145660,6128),(145661,6128),(145662,6128),(145663,6128),(145664,6128),(145665,6128),(145666,6128),(145667,6129),(145668,6129),(145669,6129),(145670,6129),(145671,6129),(145672,6129),(145673,6129),(145674,6129),(145675,6129),(145676,6129),(145677,6129),(145678,6129),(145679,6129),(145680,6129),(145681,6130),(145682,6130),(145683,6130),(145684,6130),(145685,6130),(145686,6130),(145687,6130),(145688,6130),(145689,6130),(145690,6130),(145691,6131),(145692,6131),(145693,6131),(145694,6131),(145695,6131),(145696,6131),(145697,6131),(145698,6131),(145699,6131),(145700,6131),(145701,6131),(145702,6131),(145703,6131),(145704,6131),(145705,6132),(145706,6132),(145707,6132),(145708,6132),(145709,6132),(145710,6132),(145711,6132),(145712,6132),(145713,6132),(145714,6132),(145715,6133),(145716,6133),(145717,6133),(145718,6133),(145719,6133),(145720,6133),(145721,6133),(145722,6133),(145723,6133),(145724,6133),(145725,6134),(145726,6134),(145727,6134),(145728,6134),(145729,6134),(145730,6134),(145731,6134),(145732,6134),(145733,6134),(145734,6134),(145735,6035),(145736,6035),(145737,6035),(145738,6035),(145739,6035),(145740,6036),(145741,6036),(145742,6036),(145743,6036),(145744,6036),(145745,6037),(145746,6037),(145747,6037),(145748,6037),(145749,6037),(145750,6038),(145751,6038),(145752,6038),(145753,6038),(145754,6038),(145755,6039),(145756,6039),(145757,6039),(145758,6039),(145759,6039),(145760,6040),(145761,6040),(145762,6040),(145763,6040),(145764,6040),(145765,6041),(145766,6041),(145767,6041),(145768,6041),(145769,6041),(145770,6042),(145771,6042),(145772,6042),(145773,6042),(145774,6042),(145775,6043),(145776,6043),(145777,6043),(145778,6043),(145779,6043),(145780,6044),(145781,6044),(145782,6044),(145783,6044),(145784,6044),(145785,6045),(145786,6045),(145787,6045),(145788,6045),(145789,6045),(145790,6046),(145791,6046),(145792,6046),(145793,6046),(145794,6046),(145795,6047),(145796,6047),(145797,6047),(145798,6047),(145799,6047),(145800,6048),(145801,6048),(145802,6048),(145803,6048),(145804,6048),(145805,6049),(145806,6049),(145807,6049),(145808,6049),(145809,6049),(145810,6050),(145811,6050),(145812,6050),(145813,6050),(145814,6050),(145815,6051),(145816,6051),(145817,6051),(145818,6051),(145819,6051),(145820,6052),(145821,6052),(145822,6052),(145823,6052),(145824,6052),(145825,6053),(145826,6053),(145827,6053),(145828,6053),(145829,6053),(145830,6054),(145831,6054),(145832,6054),(145833,6054),(145834,6054),(145835,6055),(145836,6055),(145837,6055),(145838,6055),(145839,6055),(145840,6056),(145841,6056),(145842,6056),(145843,6056),(145844,6056),(145845,6057),(145846,6057),(145847,6057),(145848,6057),(145849,6057),(145850,6058),(145851,6058),(145852,6058),(145853,6058),(145854,6058),(145855,6059),(145856,6059),(145857,6059),(145858,6059),(145859,6059),(145860,6060),(145861,6060),(145862,6060),(145863,6060),(145864,6060),(145865,6061),(145866,6061),(145867,6061),(145868,6061),(145869,6061),(145870,6062),(145871,6062),(145872,6062),(145873,6062),(145874,6062),(145875,6063),(145876,6063),(145877,6063),(145878,6063),(145879,6063),(145880,6064),(145881,6064),(145882,6064),(145883,6064),(145884,6064),(145885,6065),(145886,6065),(145887,6065),(145888,6065),(145889,6065),(145890,6066),(145891,6066),(145892,6066),(145893,6066),(145894,6066),(145895,6067),(145896,6067),(145897,6067),(145898,6067),(145899,6067),(145900,6068),(145901,6068),(145902,6068),(145903,6068),(145904,6068),(145905,6069),(145906,6069),(145907,6069),(145908,6069),(145909,6069),(145910,6070),(145911,6070),(145912,6070),(145913,6071),(145914,6071),(145915,6071),(145916,6071),(145917,6071),(145918,6072),(145919,6072),(145920,6072),(145921,6072),(145922,6072),(145923,6073),(145924,6073),(145925,6073),(145926,6073),(145927,6073),(145928,6074),(145929,6074),(145930,6074),(145931,6075),(145932,6075),(145933,6075),(145934,6075),(145935,6075),(145936,6076),(145937,6076),(145938,6076),(145939,6076),(145940,6076),(145941,6077),(145942,6077),(145943,6077),(145944,6077),(145945,6077),(145946,6078),(145947,6078),(145948,6078),(145949,6078),(145950,6078),(145951,6079),(145952,6079),(145953,6079),(145954,6079),(145955,6079),(145956,6080),(145957,6080),(145958,6080),(145959,6080),(145960,6080),(145961,6081),(145962,6081),(145963,6081),(145964,6081),(145965,6081),(145966,6082),(145967,6082),(145968,6082),(145969,6082),(145970,6082),(145971,6083),(145972,6083),(145973,6083),(145974,6083),(145975,6083),(145976,6084),(145977,6084),(145978,6084),(145979,6084),(145980,6084),(145981,6085),(145982,6085),(145983,6085),(145984,6085),(145985,6085),(145986,6086),(145987,6086),(145988,6086),(145989,6086),(145990,6086),(145991,6087),(145992,6087),(145993,6087),(145994,6087),(145995,6087),(145996,6088),(145997,6088),(145998,6088),(145999,6088),(146000,6088),(146001,6089),(146002,6089),(146003,6089),(146004,6089),(146005,6089),(146006,6090),(146007,6090),(146008,6090),(146009,6090),(146010,6090),(146011,6091),(146012,6091),(146013,6091),(146014,6091),(146015,6091),(146016,6092),(146017,6092),(146018,6092),(146019,6092),(146020,6092),(146021,6093),(146022,6093),(146023,6093),(146024,6093),(146025,6093),(146026,6094),(146027,6094),(146028,6094),(146029,6094),(146030,6094),(146031,6095),(146032,6095),(146033,6095),(146034,6095),(146035,6095),(146036,6096),(146037,6096),(146038,6096),(146039,6096),(146040,6096),(146041,6097),(146042,6097),(146043,6097),(146044,6098),(146045,6098),(146046,6098),(146047,6098),(146048,6098),(146049,6099),(146050,6099),(146051,6099),(146052,6099),(146053,6099),(146054,6100),(146055,6100),(146056,6100),(146057,6100),(146058,6100),(146059,6101),(146060,6101),(146061,6101),(146062,6101),(146063,6101),(146064,6102),(146065,6102),(146066,6102),(146067,6102),(146068,6102),(146069,6103),(146070,6103),(146071,6103),(146072,6103),(146073,6103),(146074,6104),(146075,6104),(146076,6104),(146077,6104),(146078,6104),(146079,6105),(146080,6105),(146081,6105),(146082,6105),(146083,6105),(146084,6106),(146085,6106),(146086,6106),(146087,6106),(146088,6106),(146089,6107),(146090,6107),(146091,6107),(146092,6107),(146093,6107),(146094,6108),(146095,6108),(146096,6108),(146097,6108),(146098,6108),(146099,6109),(146100,6109),(146101,6109),(146102,6109),(146103,6109),(146104,6110),(146105,6110),(146106,6110),(146107,6111),(146108,6111),(146109,6111),(146110,6112),(146111,6112),(146112,6112),(146113,6113),(146114,6113),(146115,6113),(146116,6113),(146117,6113),(146118,6114),(146119,6114),(146120,6114),(146121,6115),(146122,6115),(146123,6115),(146124,6116),(146125,6116),(146126,6116),(146127,6117),(146128,6117),(146129,6117),(146130,6118),(146131,6118),(146132,6118),(146133,6119),(146134,6119),(146135,6119),(146136,6120),(146137,6120),(146138,6120),(146139,6121),(146140,6121),(146141,6121),(146142,6121),(146143,6121),(146144,6122),(146145,6122),(146146,6122),(146147,6122),(146148,6122),(146149,6123),(146150,6123),(146151,6123),(146152,6123),(146153,6123),(146154,6124),(146155,6124),(146156,6124),(146157,6124),(146158,6124),(146159,6125),(146160,6125),(146161,6125),(146162,6125),(146163,6125),(146164,6126),(146165,6126),(146166,6126),(146167,6126),(146168,6126),(146169,6127),(146170,6127),(146171,6127),(146172,6127),(146173,6127),(146174,6128),(146175,6128),(146176,6128),(146177,6128),(146178,6128),(146179,6129),(146180,6129),(146181,6129),(146182,6129),(146183,6129),(146184,6130),(146185,6130),(146186,6130),(146187,6130),(146188,6130),(146189,6131),(146190,6131),(146191,6131),(146192,6131),(146193,6131),(146194,6132),(146195,6132),(146196,6132),(146197,6132),(146198,6132),(146199,6133),(146200,6133),(146201,6133),(146202,6133),(146203,6133),(146204,6134),(146205,6134),(146206,6134),(146207,6134),(146208,6134),(146209,6035),(146210,6035),(146211,6035),(146212,6035),(146213,6035),(146214,6036),(146215,6036),(146216,6036),(146217,6036),(146218,6036),(146219,6037),(146220,6037),(146221,6037),(146222,6037),(146223,6037),(146224,6038),(146225,6038),(146226,6038),(146227,6038),(146228,6038),(146229,6039),(146230,6039),(146231,6039),(146232,6039),(146233,6039),(146234,6040),(146235,6040),(146236,6040),(146237,6040),(146238,6040),(146239,6041),(146240,6041),(146241,6041),(146242,6041),(146243,6041),(146244,6042),(146245,6042),(146246,6042),(146247,6042),(146248,6042),(146249,6043),(146250,6043),(146251,6043),(146252,6043),(146253,6043),(146254,6044),(146255,6044),(146256,6044),(146257,6044),(146258,6044),(146259,6045),(146260,6045),(146261,6045),(146262,6045),(146263,6045),(146264,6046),(146265,6046),(146266,6046),(146267,6046),(146268,6046),(146269,6047),(146270,6047),(146271,6047),(146272,6047),(146273,6047),(146274,6048),(146275,6048),(146276,6048),(146277,6048),(146278,6048),(146279,6049),(146280,6049),(146281,6049),(146282,6049),(146283,6049),(146284,6050),(146285,6050),(146286,6050),(146287,6050),(146288,6050),(146289,6051),(146290,6051),(146291,6051),(146292,6051),(146293,6051),(146294,6052),(146295,6052),(146296,6052),(146297,6052),(146298,6052),(146299,6053),(146300,6053),(146301,6053),(146302,6053),(146303,6053),(146304,6054),(146305,6054),(146306,6054),(146307,6054),(146308,6054),(146309,6055),(146310,6055),(146311,6055),(146312,6055),(146313,6055),(146314,6056),(146315,6056),(146316,6056),(146317,6056),(146318,6056),(146319,6057),(146320,6057),(146321,6057),(146322,6057),(146323,6057),(146324,6058),(146325,6058),(146326,6058),(146327,6058),(146328,6058),(146329,6059),(146330,6059),(146331,6059),(146332,6059),(146333,6059),(146334,6060),(146335,6060),(146336,6060),(146337,6060),(146338,6060),(146339,6061),(146340,6061),(146341,6061),(146342,6061),(146343,6061),(146344,6062),(146345,6062),(146346,6062),(146347,6062),(146348,6062),(146349,6063),(146350,6063),(146351,6063),(146352,6063),(146353,6063),(146354,6064),(146355,6064),(146356,6064),(146357,6064),(146358,6064),(146359,6065),(146360,6065),(146361,6065),(146362,6065),(146363,6065),(146364,6066),(146365,6066),(146366,6066),(146367,6066),(146368,6066),(146369,6067),(146370,6067),(146371,6067),(146372,6067),(146373,6067),(146374,6068),(146375,6068),(146376,6068),(146377,6068),(146378,6068),(146379,6069),(146380,6069),(146381,6069),(146382,6069),(146383,6069),(146384,6070),(146385,6070),(146386,6070),(146387,6070),(146388,6070),(146389,6071),(146390,6071),(146391,6071),(146392,6071),(146393,6071),(146394,6072),(146395,6072),(146396,6072),(146397,6072),(146398,6072),(146399,6073),(146400,6073),(146401,6073),(146402,6073),(146403,6073),(146404,6074),(146405,6074),(146406,6074),(146407,6074),(146408,6074),(146409,6075),(146410,6075),(146411,6075),(146412,6075),(146413,6075),(146414,6076),(146415,6076),(146416,6076),(146417,6076),(146418,6076),(146419,6077),(146420,6077),(146421,6077),(146422,6077),(146423,6077),(146424,6078),(146425,6078),(146426,6078),(146427,6078),(146428,6078),(146429,6079),(146430,6079),(146431,6079),(146432,6079),(146433,6079),(146434,6080),(146435,6080),(146436,6080),(146437,6080),(146438,6080),(146439,6081),(146440,6081),(146441,6081),(146442,6081),(146443,6081),(146444,6082),(146445,6082),(146446,6082),(146447,6082),(146448,6082),(146449,6083),(146450,6083),(146451,6083),(146452,6083),(146453,6083),(146454,6084),(146455,6084),(146456,6084),(146457,6084),(146458,6084),(146459,6085),(146460,6085),(146461,6085),(146462,6085),(146463,6085),(146464,6086),(146465,6086),(146466,6086),(146467,6086),(146468,6086),(146469,6087),(146470,6087),(146471,6087),(146472,6087),(146473,6087),(146474,6088),(146475,6088),(146476,6088),(146477,6088),(146478,6088),(146479,6089),(146480,6089),(146481,6089),(146482,6089),(146483,6089),(146484,6090),(146485,6090),(146486,6090),(146487,6090),(146488,6090),(146489,6091),(146490,6091),(146491,6091),(146492,6091),(146493,6091),(146494,6092),(146495,6092),(146496,6092),(146497,6092),(146498,6092),(146499,6093),(146500,6093),(146501,6093),(146502,6093),(146503,6093),(146504,6094),(146505,6094),(146506,6094),(146507,6094),(146508,6094),(146509,6095),(146510,6095),(146511,6095),(146512,6095),(146513,6095),(146514,6096),(146515,6096),(146516,6096),(146517,6096),(146518,6096),(146519,6097),(146520,6097),(146521,6097),(146522,6097),(146523,6097),(146524,6098),(146525,6098),(146526,6098),(146527,6098),(146528,6098),(146529,6099),(146530,6099),(146531,6099),(146532,6099),(146533,6099),(146534,6100),(146535,6100),(146536,6100),(146537,6100),(146538,6100),(146539,6101),(146540,6101),(146541,6101),(146542,6101),(146543,6101),(146544,6102),(146545,6102),(146546,6102),(146547,6102),(146548,6102),(146549,6103),(146550,6103),(146551,6103),(146552,6103),(146553,6103),(146554,6104),(146555,6104),(146556,6104),(146557,6104),(146558,6104),(146559,6105),(146560,6105),(146561,6105),(146562,6105),(146563,6105),(146564,6106),(146565,6106),(146566,6106),(146567,6106),(146568,6106),(146569,6107),(146570,6107),(146571,6107),(146572,6107),(146573,6107),(146574,6108),(146575,6108),(146576,6108),(146577,6108),(146578,6108),(146579,6109),(146580,6109),(146581,6109),(146582,6109),(146583,6109),(146584,6110),(146585,6110),(146586,6110),(146587,6110),(146588,6110),(146589,6111),(146590,6111),(146591,6111),(146592,6111),(146593,6111),(146594,6112),(146595,6112),(146596,6112),(146597,6112),(146598,6112),(146599,6113),(146600,6113),(146601,6113),(146602,6113),(146603,6113),(146604,6114),(146605,6114),(146606,6114),(146607,6114),(146608,6114),(146609,6115),(146610,6115),(146611,6115),(146612,6115),(146613,6115),(146614,6116),(146615,6116),(146616,6116),(146617,6116),(146618,6116),(146619,6117),(146620,6117),(146621,6117),(146622,6117),(146623,6117),(146624,6118),(146625,6118),(146626,6118),(146627,6118),(146628,6118),(146629,6119),(146630,6119),(146631,6119),(146632,6119),(146633,6119),(146634,6120),(146635,6120),(146636,6120),(146637,6120),(146638,6120),(146639,6121),(146640,6121),(146641,6121),(146642,6121),(146643,6121),(146644,6122),(146645,6122),(146646,6122),(146647,6122),(146648,6122),(146649,6123),(146650,6123),(146651,6123),(146652,6123),(146653,6123),(146654,6124),(146655,6124),(146656,6124),(146657,6124),(146658,6124),(146659,6125),(146660,6125),(146661,6125),(146662,6125),(146663,6125),(146664,6126),(146665,6126),(146666,6126),(146667,6126),(146668,6126),(146669,6127),(146670,6127),(146671,6127),(146672,6127),(146673,6127),(146674,6128),(146675,6128),(146676,6128),(146677,6128),(146678,6128),(146679,6129),(146680,6129),(146681,6129),(146682,6129),(146683,6129),(146684,6130),(146685,6130),(146686,6130),(146687,6130),(146688,6130),(146689,6131),(146690,6131),(146691,6131),(146692,6131),(146693,6131),(146694,6132),(146695,6132),(146696,6132),(146697,6132),(146698,6132),(146699,6133),(146700,6133),(146701,6133),(146702,6133),(146703,6133),(146704,6134),(146705,6134),(146706,6134),(146707,6134),(146708,6134),(146709,6135),(146710,6136),(146711,6137),(146712,6138),(146713,6139),(146714,6140),(146715,6141),(146716,6142),(146717,6143),(146718,6144),(146719,6145),(146720,6146),(146721,6147),(146722,6148),(146723,6149),(146724,6150),(146725,6151),(146726,6152),(146727,6153),(146728,6154),(146729,6155),(146730,6156),(146731,6157),(146732,6158),(146733,6159),(146734,6160),(146735,6161),(146736,6162),(146737,6163),(146738,6164),(146739,6165),(146740,6166),(146741,6167),(146742,6168),(146743,6169),(146744,6170),(146745,6171),(146746,6172),(146747,6173),(146748,6174),(146749,6175),(146750,6176),(146751,6177),(146752,6178),(146753,6179),(146754,6180),(146755,6181),(146756,6182),(146757,6183),(146758,6184),(146759,6185),(146760,6186),(146761,6187),(146762,6188),(146763,6189),(146764,6190),(146765,6191),(146766,6192),(146767,6193),(146768,6194),(146769,6195),(146770,6196),(146771,6197),(146772,6198),(146773,6199),(146774,6200),(146775,6201),(146776,6202),(146777,6203),(146778,6204),(146779,6205),(146780,6206),(146781,6207),(146782,6208),(146783,6209),(146784,6210),(146785,6211),(146786,6212),(146787,6213),(146788,6214),(146789,6215),(146790,6216),(146791,6217),(146792,6218),(146793,6219),(146794,6220),(146795,6221),(146796,6222),(146797,6223),(146798,6224),(146799,6225),(146800,6226),(146801,6227),(146802,6228),(146803,6229),(146804,6230),(146805,6231),(146806,6232),(146807,6233),(146808,6234),(146809,6135),(146810,6136),(146811,6137),(146812,6138),(146813,6139),(146814,6140),(146815,6141),(146816,6142),(146817,6143),(146818,6144),(146819,6145),(146820,6146),(146821,6147),(146822,6148),(146823,6149),(146824,6150),(146825,6151),(146826,6152),(146827,6153),(146828,6154),(146829,6155),(146830,6156),(146831,6157),(146832,6158),(146833,6159),(146834,6160),(146835,6161),(146836,6162),(146837,6163),(146838,6164),(146839,6165),(146840,6166),(146841,6167),(146842,6168),(146843,6169),(146844,6170),(146845,6171),(146846,6172),(146847,6173),(146848,6174),(146849,6175),(146850,6176),(146851,6177),(146852,6178),(146853,6179),(146854,6180),(146855,6181),(146856,6182),(146857,6183),(146858,6184),(146859,6185),(146860,6186),(146861,6187),(146862,6188),(146863,6189),(146864,6190),(146865,6191),(146866,6192),(146867,6193),(146868,6194),(146869,6195),(146870,6196),(146871,6197),(146872,6198),(146873,6199),(146874,6200),(146875,6201),(146876,6202),(146877,6203),(146878,6204),(146879,6205),(146880,6206),(146881,6207),(146882,6208),(146883,6209),(146884,6210),(146885,6211),(146886,6212),(146887,6213),(146888,6214),(146889,6215),(146890,6216),(146891,6217),(146892,6218),(146893,6219),(146894,6220),(146895,6221),(146896,6222),(146897,6223),(146898,6224),(146899,6225),(146900,6226),(146901,6227),(146902,6228),(146903,6229),(146904,6230),(146905,6231),(146906,6232),(146907,6233),(146908,6234),(146909,6135),(146910,6135),(146911,6135),(146912,6136),(146913,6136),(146914,6136),(146915,6137),(146916,6137),(146917,6137),(146918,6138),(146919,6138),(146920,6138),(146921,6139),(146922,6139),(146923,6139),(146924,6140),(146925,6140),(146926,6140),(146927,6141),(146928,6141),(146929,6141),(146930,6142),(146931,6142),(146932,6142),(146933,6143),(146934,6143),(146935,6143),(146936,6144),(146937,6144),(146938,6144),(146939,6145),(146940,6145),(146941,6145),(146942,6146),(146943,6146),(146944,6146),(146945,6147),(146946,6147),(146947,6147),(146948,6148),(146949,6148),(146950,6148),(146951,6149),(146952,6149),(146953,6149),(146954,6150),(146955,6150),(146956,6150),(146957,6151),(146958,6151),(146959,6151),(146960,6152),(146961,6152),(146962,6152),(146963,6153),(146964,6153),(146965,6153),(146966,6154),(146967,6154),(146968,6154),(146969,6155),(146970,6155),(146971,6155),(146972,6156),(146973,6156),(146974,6156),(146975,6157),(146976,6157),(146977,6157),(146978,6158),(146979,6158),(146980,6158),(146981,6159),(146982,6159),(146983,6159),(146984,6160),(146985,6160),(146986,6160),(146987,6161),(146988,6161),(146989,6161),(146990,6162),(146991,6162),(146992,6162),(146993,6163),(146994,6163),(146995,6163),(146996,6164),(146997,6164),(146998,6164),(146999,6165),(147000,6165),(147001,6165),(147002,6166),(147003,6166),(147004,6166),(147005,6167),(147006,6167),(147007,6167),(147008,6168),(147009,6168),(147010,6168),(147011,6169),(147012,6169),(147013,6169),(147014,6170),(147015,6170),(147016,6170),(147017,6171),(147018,6171),(147019,6171),(147020,6172),(147021,6172),(147022,6172),(147023,6173),(147024,6173),(147025,6173),(147026,6174),(147027,6174),(147028,6174),(147029,6175),(147030,6175),(147031,6175),(147032,6176),(147033,6176),(147034,6176),(147035,6177),(147036,6177),(147037,6177),(147038,6178),(147039,6178),(147040,6178),(147041,6179),(147042,6179),(147043,6179),(147044,6180),(147045,6180),(147046,6180),(147047,6181),(147048,6181),(147049,6181),(147050,6182),(147051,6182),(147052,6182),(147053,6183),(147054,6183),(147055,6183),(147056,6184),(147057,6184),(147058,6184),(147059,6185),(147060,6185),(147061,6185),(147062,6186),(147063,6186),(147064,6186),(147065,6187),(147066,6187),(147067,6187),(147068,6188),(147069,6188),(147070,6188),(147071,6189),(147072,6189),(147073,6189),(147074,6190),(147075,6190),(147076,6190),(147077,6191),(147078,6191),(147079,6191),(147080,6192),(147081,6192),(147082,6192),(147083,6193),(147084,6193),(147085,6193),(147086,6194),(147087,6194),(147088,6194),(147089,6195),(147090,6195),(147091,6195),(147092,6196),(147093,6196),(147094,6196),(147095,6197),(147096,6197),(147097,6197),(147098,6198),(147099,6198),(147100,6198),(147101,6199),(147102,6199),(147103,6199),(147104,6200),(147105,6200),(147106,6200),(147107,6201),(147108,6201),(147109,6201),(147110,6202),(147111,6202),(147112,6202),(147113,6203),(147114,6203),(147115,6203),(147116,6204),(147117,6204),(147118,6204),(147119,6205),(147120,6205),(147121,6205),(147122,6206),(147123,6206),(147124,6206),(147125,6207),(147126,6207),(147127,6207),(147128,6208),(147129,6208),(147130,6208),(147131,6209),(147132,6209),(147133,6209),(147134,6210),(147135,6210),(147136,6210),(147137,6211),(147138,6211),(147139,6211),(147140,6212),(147141,6212),(147142,6212),(147143,6213),(147144,6213),(147145,6213),(147146,6214),(147147,6214),(147148,6214),(147149,6215),(147150,6215),(147151,6215),(147152,6216),(147153,6216),(147154,6216),(147155,6217),(147156,6217),(147157,6217),(147158,6218),(147159,6218),(147160,6218),(147161,6219),(147162,6219),(147163,6219),(147164,6220),(147165,6220),(147166,6220),(147167,6221),(147168,6221),(147169,6221),(147170,6222),(147171,6222),(147172,6222),(147173,6223),(147174,6223),(147175,6223),(147176,6224),(147177,6224),(147178,6224),(147179,6225),(147180,6225),(147181,6225),(147182,6226),(147183,6226),(147184,6226),(147185,6227),(147186,6227),(147187,6227),(147188,6228),(147189,6228),(147190,6228),(147191,6229),(147192,6229),(147193,6229),(147194,6230),(147195,6230),(147196,6230),(147197,6231),(147198,6231),(147199,6231),(147200,6232),(147201,6232),(147202,6232),(147203,6233),(147204,6233),(147205,6233),(147206,6234),(147207,6234),(147208,6234),(147209,6135),(147210,6135),(147211,6135),(147212,6135),(147213,6135),(147214,6135),(147215,6135),(147216,6135),(147217,6135),(147218,6135),(147219,6135),(147220,6135),(147221,6135),(147222,6135),(147223,6136),(147224,6136),(147225,6136),(147226,6136),(147227,6136),(147228,6136),(147229,6136),(147230,6136),(147231,6136),(147232,6136),(147233,6137),(147234,6137),(147235,6137),(147236,6137),(147237,6137),(147238,6137),(147239,6137),(147240,6137),(147241,6137),(147242,6137),(147243,6138),(147244,6138),(147245,6138),(147246,6138),(147247,6138),(147248,6138),(147249,6138),(147250,6138),(147251,6138),(147252,6138),(147253,6139),(147254,6139),(147255,6139),(147256,6139),(147257,6139),(147258,6139),(147259,6139),(147260,6139),(147261,6139),(147262,6139),(147263,6140),(147264,6140),(147265,6140),(147266,6140),(147267,6140),(147268,6140),(147269,6140),(147270,6140),(147271,6140),(147272,6140),(147273,6141),(147274,6141),(147275,6141),(147276,6141),(147277,6141),(147278,6141),(147279,6141),(147280,6141),(147281,6141),(147282,6141),(147283,6142),(147284,6142),(147285,6142),(147286,6142),(147287,6142),(147288,6142),(147289,6142),(147290,6142),(147291,6142),(147292,6142),(147293,6143),(147294,6143),(147295,6143),(147296,6143),(147297,6143),(147298,6143),(147299,6143),(147300,6143),(147301,6143),(147302,6143),(147303,6144),(147304,6144),(147305,6144),(147306,6144),(147307,6144),(147308,6144),(147309,6144),(147310,6144),(147311,6144),(147312,6144),(147313,6145),(147314,6145),(147315,6145),(147316,6145),(147317,6145),(147318,6145),(147319,6145),(147320,6145),(147321,6145),(147322,6145),(147323,6146),(147324,6146),(147325,6146),(147326,6146),(147327,6146),(147328,6146),(147329,6146),(147330,6146),(147331,6146),(147332,6146),(147333,6147),(147334,6147),(147335,6147),(147336,6147),(147337,6147),(147338,6147),(147339,6147),(147340,6147),(147341,6147),(147342,6147),(147343,6148),(147344,6148),(147345,6148),(147346,6148),(147347,6148),(147348,6148),(147349,6148),(147350,6148),(147351,6148),(147352,6148),(147353,6149),(147354,6149),(147355,6149),(147356,6149),(147357,6149),(147358,6149),(147359,6149),(147360,6149),(147361,6149),(147362,6149),(147363,6150),(147364,6150),(147365,6150),(147366,6150),(147367,6150),(147368,6150),(147369,6150),(147370,6150),(147371,6150),(147372,6150),(147373,6151),(147374,6151),(147375,6151),(147376,6151),(147377,6151),(147378,6151),(147379,6151),(147380,6151),(147381,6151),(147382,6151),(147383,6152),(147384,6152),(147385,6152),(147386,6152),(147387,6152),(147388,6152),(147389,6152),(147390,6152),(147391,6152),(147392,6152),(147393,6153),(147394,6153),(147395,6153),(147396,6153),(147397,6153),(147398,6153),(147399,6153),(147400,6153),(147401,6153),(147402,6153),(147403,6154),(147404,6154),(147405,6154),(147406,6154),(147407,6154),(147408,6154),(147409,6154),(147410,6154),(147411,6154),(147412,6154),(147413,6155),(147414,6155),(147415,6155),(147416,6155),(147417,6155),(147418,6155),(147419,6155),(147420,6155),(147421,6155),(147422,6155),(147423,6156),(147424,6156),(147425,6156),(147426,6156),(147427,6156),(147428,6156),(147429,6156),(147430,6156),(147431,6156),(147432,6156),(147433,6157),(147434,6157),(147435,6157),(147436,6157),(147437,6157),(147438,6157),(147439,6157),(147440,6157),(147441,6157),(147442,6157),(147443,6158),(147444,6158),(147445,6158),(147446,6158),(147447,6158),(147448,6158),(147449,6158),(147450,6158),(147451,6158),(147452,6158),(147453,6159),(147454,6159),(147455,6159),(147456,6159),(147457,6159),(147458,6159),(147459,6159),(147460,6159),(147461,6159),(147462,6159),(147463,6160),(147464,6160),(147465,6160),(147466,6160),(147467,6160),(147468,6160),(147469,6160),(147470,6160),(147471,6160),(147472,6160),(147473,6161),(147474,6161),(147475,6161),(147476,6161),(147477,6161),(147478,6161),(147479,6161),(147480,6161),(147481,6161),(147482,6161),(147483,6162),(147484,6162),(147485,6162),(147486,6162),(147487,6162),(147488,6162),(147489,6162),(147490,6162),(147491,6162),(147492,6162),(147493,6163),(147494,6163),(147495,6163),(147496,6163),(147497,6163),(147498,6163),(147499,6163),(147500,6163),(147501,6163),(147502,6163),(147503,6164),(147504,6164),(147505,6164),(147506,6164),(147507,6164),(147508,6164),(147509,6164),(147510,6164),(147511,6164),(147512,6164),(147513,6164),(147514,6164),(147515,6164),(147516,6164),(147517,6165),(147518,6165),(147519,6165),(147520,6165),(147521,6165),(147522,6165),(147523,6165),(147524,6165),(147525,6165),(147526,6165),(147527,6166),(147528,6166),(147529,6166),(147530,6166),(147531,6166),(147532,6166),(147533,6166),(147534,6166),(147535,6166),(147536,6166),(147537,6167),(147538,6167),(147539,6167),(147540,6167),(147541,6167),(147542,6167),(147543,6167),(147544,6167),(147545,6168),(147546,6168),(147547,6168),(147548,6168),(147549,6168),(147550,6168),(147551,6168),(147552,6168),(147553,6169),(147554,6169),(147555,6169),(147556,6169),(147557,6169),(147558,6169),(147559,6169),(147560,6169),(147561,6169),(147562,6169),(147563,6170),(147564,6170),(147565,6170),(147566,6170),(147567,6170),(147568,6170),(147569,6170),(147570,6170),(147571,6170),(147572,6170),(147573,6170),(147574,6170),(147575,6170),(147576,6170),(147577,6171),(147578,6171),(147579,6171),(147580,6171),(147581,6171),(147582,6171),(147583,6171),(147584,6171),(147585,6171),(147586,6171),(147587,6172),(147588,6172),(147589,6172),(147590,6172),(147591,6172),(147592,6172),(147593,6172),(147594,6172),(147595,6172),(147596,6172),(147597,6173),(147598,6173),(147599,6173),(147600,6173),(147601,6173),(147602,6173),(147603,6173),(147604,6173),(147605,6173),(147606,6173),(147607,6174),(147608,6174),(147609,6174),(147610,6174),(147611,6174),(147612,6174),(147613,6174),(147614,6174),(147615,6174),(147616,6174),(147617,6174),(147618,6174),(147619,6174),(147620,6174),(147621,6175),(147622,6175),(147623,6175),(147624,6175),(147625,6175),(147626,6175),(147627,6175),(147628,6175),(147629,6175),(147630,6175),(147631,6176),(147632,6176),(147633,6176),(147634,6176),(147635,6176),(147636,6176),(147637,6176),(147638,6176),(147639,6176),(147640,6176),(147641,6177),(147642,6177),(147643,6177),(147644,6177),(147645,6177),(147646,6177),(147647,6177),(147648,6177),(147649,6177),(147650,6177),(147651,6177),(147652,6177),(147653,6177),(147654,6177),(147655,6178),(147656,6178),(147657,6178),(147658,6178),(147659,6178),(147660,6178),(147661,6178),(147662,6178),(147663,6178),(147664,6178),(147665,6179),(147666,6179),(147667,6179),(147668,6179),(147669,6179),(147670,6179),(147671,6179),(147672,6179),(147673,6179),(147674,6179),(147675,6180),(147676,6180),(147677,6180),(147678,6180),(147679,6180),(147680,6180),(147681,6180),(147682,6180),(147683,6180),(147684,6180),(147685,6180),(147686,6180),(147687,6180),(147688,6180),(147689,6181),(147690,6181),(147691,6181),(147692,6181),(147693,6181),(147694,6181),(147695,6181),(147696,6181),(147697,6181),(147698,6181),(147699,6182),(147700,6182),(147701,6182),(147702,6182),(147703,6182),(147704,6182),(147705,6182),(147706,6182),(147707,6182),(147708,6182),(147709,6183),(147710,6183),(147711,6183),(147712,6183),(147713,6183),(147714,6183),(147715,6183),(147716,6183),(147717,6183),(147718,6183),(147719,6184),(147720,6184),(147721,6184),(147722,6184),(147723,6184),(147724,6184),(147725,6184),(147726,6184),(147727,6184),(147728,6184),(147729,6185),(147730,6185),(147731,6185),(147732,6185),(147733,6185),(147734,6185),(147735,6185),(147736,6185),(147737,6185),(147738,6185),(147739,6186),(147740,6186),(147741,6186),(147742,6186),(147743,6186),(147744,6186),(147745,6186),(147746,6186),(147747,6186),(147748,6186),(147749,6187),(147750,6187),(147751,6187),(147752,6187),(147753,6187),(147754,6187),(147755,6187),(147756,6187),(147757,6187),(147758,6187),(147759,6187),(147760,6187),(147761,6187),(147762,6187),(147763,6188),(147764,6188),(147765,6188),(147766,6188),(147767,6188),(147768,6188),(147769,6188),(147770,6188),(147771,6188),(147772,6188),(147773,6188),(147774,6188),(147775,6188),(147776,6188),(147777,6189),(147778,6189),(147779,6189),(147780,6189),(147781,6189),(147782,6189),(147783,6189),(147784,6189),(147785,6189),(147786,6189),(147787,6190),(147788,6190),(147789,6190),(147790,6190),(147791,6190),(147792,6190),(147793,6190),(147794,6190),(147795,6190),(147796,6190),(147797,6191),(147798,6191),(147799,6191),(147800,6191),(147801,6191),(147802,6191),(147803,6191),(147804,6191),(147805,6191),(147806,6191),(147807,6192),(147808,6192),(147809,6192),(147810,6192),(147811,6192),(147812,6192),(147813,6192),(147814,6192),(147815,6192),(147816,6192),(147817,6193),(147818,6193),(147819,6193),(147820,6193),(147821,6193),(147822,6193),(147823,6193),(147824,6193),(147825,6193),(147826,6193),(147827,6194),(147828,6194),(147829,6194),(147830,6194),(147831,6194),(147832,6194),(147833,6194),(147834,6194),(147835,6194),(147836,6194),(147837,6195),(147838,6195),(147839,6195),(147840,6195),(147841,6195),(147842,6195),(147843,6195),(147844,6195),(147845,6195),(147846,6195),(147847,6196),(147848,6196),(147849,6196),(147850,6196),(147851,6196),(147852,6196),(147853,6196),(147854,6196),(147855,6196),(147856,6196),(147857,6197),(147858,6197),(147859,6197),(147860,6197),(147861,6197),(147862,6197),(147863,6197),(147864,6197),(147865,6197),(147866,6197),(147867,6198),(147868,6198),(147869,6198),(147870,6198),(147871,6198),(147872,6198),(147873,6198),(147874,6198),(147875,6198),(147876,6198),(147877,6199),(147878,6199),(147879,6199),(147880,6199),(147881,6199),(147882,6199),(147883,6199),(147884,6199),(147885,6199),(147886,6199),(147887,6199),(147888,6199),(147889,6199),(147890,6199),(147891,6200),(147892,6200),(147893,6200),(147894,6200),(147895,6200),(147896,6200),(147897,6200),(147898,6200),(147899,6200),(147900,6200),(147901,6201),(147902,6201),(147903,6201),(147904,6201),(147905,6201),(147906,6201),(147907,6201),(147908,6201),(147909,6201),(147910,6201),(147911,6202),(147912,6202),(147913,6202),(147914,6202),(147915,6202),(147916,6202),(147917,6202),(147918,6202),(147919,6202),(147920,6202),(147921,6203),(147922,6203),(147923,6203),(147924,6203),(147925,6203),(147926,6203),(147927,6203),(147928,6203),(147929,6203),(147930,6203),(147931,6204),(147932,6204),(147933,6204),(147934,6204),(147935,6204),(147936,6204),(147937,6204),(147938,6204),(147939,6204),(147940,6204),(147941,6205),(147942,6205),(147943,6205),(147944,6205),(147945,6205),(147946,6205),(147947,6205),(147948,6205),(147949,6205),(147950,6205),(147951,6206),(147952,6206),(147953,6206),(147954,6206),(147955,6206),(147956,6206),(147957,6206),(147958,6206),(147959,6206),(147960,6206),(147961,6206),(147962,6206),(147963,6206),(147964,6206),(147965,6207),(147966,6207),(147967,6207),(147968,6207),(147969,6207),(147970,6207),(147971,6207),(147972,6207),(147973,6207),(147974,6207),(147975,6207),(147976,6207),(147977,6207),(147978,6207),(147979,6208),(147980,6208),(147981,6208),(147982,6208),(147983,6208),(147984,6208),(147985,6208),(147986,6208),(147987,6208),(147988,6208),(147989,6208),(147990,6208),(147991,6209),(147992,6209),(147993,6209),(147994,6209),(147995,6209),(147996,6209),(147997,6209),(147998,6209),(147999,6209),(148000,6209),(148001,6209),(148002,6209),(148003,6210),(148004,6210),(148005,6210),(148006,6210),(148007,6210),(148008,6210),(148009,6210),(148010,6210),(148011,6210),(148012,6210),(148013,6211),(148014,6211),(148015,6211),(148016,6211),(148017,6211),(148018,6211),(148019,6211),(148020,6211),(148021,6211),(148022,6211),(148023,6212),(148024,6212),(148025,6212),(148026,6212),(148027,6212),(148028,6212),(148029,6212),(148030,6212),(148031,6212),(148032,6212),(148033,6213),(148034,6213),(148035,6213),(148036,6213),(148037,6213),(148038,6213),(148039,6213),(148040,6213),(148041,6213),(148042,6213),(148043,6214),(148044,6214),(148045,6214),(148046,6214),(148047,6214),(148048,6214),(148049,6214),(148050,6214),(148051,6214),(148052,6214),(148053,6215),(148054,6215),(148055,6215),(148056,6215),(148057,6215),(148058,6215),(148059,6215),(148060,6215),(148061,6215),(148062,6215),(148063,6216),(148064,6216),(148065,6216),(148066,6216),(148067,6216),(148068,6216),(148069,6216),(148070,6216),(148071,6216),(148072,6216),(148073,6217),(148074,6217),(148075,6217),(148076,6217),(148077,6217),(148078,6217),(148079,6217),(148080,6217),(148081,6217),(148082,6217),(148083,6218),(148084,6218),(148085,6218),(148086,6218),(148087,6218),(148088,6218),(148089,6218),(148090,6218),(148091,6218),(148092,6218),(148093,6219),(148094,6219),(148095,6219),(148096,6219),(148097,6219),(148098,6219),(148099,6219),(148100,6219),(148101,6219),(148102,6219),(148103,6220),(148104,6220),(148105,6220),(148106,6220),(148107,6220),(148108,6220),(148109,6220),(148110,6220),(148111,6220),(148112,6220),(148113,6220),(148114,6220),(148115,6220),(148116,6220),(148117,6221),(148118,6221),(148119,6221),(148120,6221),(148121,6221),(148122,6221),(148123,6221),(148124,6221),(148125,6221),(148126,6221),(148127,6221),(148128,6221),(148129,6221),(148130,6221),(148131,6222),(148132,6222),(148133,6222),(148134,6222),(148135,6222),(148136,6222),(148137,6222),(148138,6222),(148139,6222),(148140,6222),(148141,6222),(148142,6222),(148143,6222),(148144,6222),(148145,6223),(148146,6223),(148147,6223),(148148,6223),(148149,6223),(148150,6223),(148151,6223),(148152,6223),(148153,6223),(148154,6223),(148155,6224),(148156,6224),(148157,6224),(148158,6224),(148159,6224),(148160,6224),(148161,6224),(148162,6224),(148163,6224),(148164,6224),(148165,6225),(148166,6225),(148167,6225),(148168,6225),(148169,6225),(148170,6225),(148171,6225),(148172,6225),(148173,6225),(148174,6225),(148175,6226),(148176,6226),(148177,6226),(148178,6226),(148179,6226),(148180,6226),(148181,6226),(148182,6226),(148183,6226),(148184,6226),(148185,6227),(148186,6227),(148187,6227),(148188,6227),(148189,6227),(148190,6227),(148191,6227),(148192,6227),(148193,6227),(148194,6227),(148195,6228),(148196,6228),(148197,6228),(148198,6228),(148199,6228),(148200,6228),(148201,6228),(148202,6228),(148203,6228),(148204,6228),(148205,6229),(148206,6229),(148207,6229),(148208,6229),(148209,6229),(148210,6229),(148211,6229),(148212,6229),(148213,6229),(148214,6229),(148215,6230),(148216,6230),(148217,6230),(148218,6230),(148219,6230),(148220,6230),(148221,6230),(148222,6230),(148223,6230),(148224,6230),(148225,6231),(148226,6231),(148227,6231),(148228,6231),(148229,6232),(148230,6232),(148231,6232),(148232,6232),(148233,6232),(148234,6232),(148235,6232),(148236,6232),(148237,6232),(148238,6232),(148239,6233),(148240,6233),(148241,6233),(148242,6233),(148243,6233),(148244,6233),(148245,6233),(148246,6233),(148247,6233),(148248,6233),(148249,6233),(148250,6233),(148251,6234),(148252,6234),(148253,6234),(148254,6234),(148255,6234),(148256,6234),(148257,6234),(148258,6234),(148259,6234),(148260,6234),(148261,6135),(148262,6135),(148263,6135),(148264,6135),(148265,6135),(148266,6136),(148267,6136),(148268,6136),(148269,6136),(148270,6136),(148271,6137),(148272,6137),(148273,6137),(148274,6137),(148275,6137),(148276,6138),(148277,6138),(148278,6138),(148279,6138),(148280,6138),(148281,6139),(148282,6139),(148283,6139),(148284,6139),(148285,6139),(148286,6140),(148287,6140),(148288,6140),(148289,6140),(148290,6140),(148291,6141),(148292,6141),(148293,6141),(148294,6141),(148295,6141),(148296,6142),(148297,6142),(148298,6142),(148299,6142),(148300,6142),(148301,6143),(148302,6143),(148303,6143),(148304,6143),(148305,6143),(148306,6144),(148307,6144),(148308,6144),(148309,6144),(148310,6144),(148311,6145),(148312,6145),(148313,6145),(148314,6145),(148315,6145),(148316,6146),(148317,6146),(148318,6146),(148319,6146),(148320,6146),(148321,6147),(148322,6147),(148323,6147),(148324,6147),(148325,6147),(148326,6148),(148327,6148),(148328,6148),(148329,6148),(148330,6148),(148331,6149),(148332,6149),(148333,6149),(148334,6149),(148335,6149),(148336,6150),(148337,6150),(148338,6150),(148339,6150),(148340,6150),(148341,6151),(148342,6151),(148343,6151),(148344,6151),(148345,6151),(148346,6152),(148347,6152),(148348,6152),(148349,6152),(148350,6152),(148351,6153),(148352,6153),(148353,6153),(148354,6153),(148355,6153),(148356,6154),(148357,6154),(148358,6154),(148359,6154),(148360,6154),(148361,6155),(148362,6155),(148363,6155),(148364,6155),(148365,6155),(148366,6156),(148367,6156),(148368,6156),(148369,6156),(148370,6156),(148371,6157),(148372,6157),(148373,6157),(148374,6157),(148375,6157),(148376,6158),(148377,6158),(148378,6158),(148379,6158),(148380,6158),(148381,6159),(148382,6159),(148383,6159),(148384,6159),(148385,6159),(148386,6160),(148387,6160),(148388,6160),(148389,6160),(148390,6160),(148391,6161),(148392,6161),(148393,6161),(148394,6161),(148395,6161),(148396,6162),(148397,6162),(148398,6162),(148399,6162),(148400,6162),(148401,6163),(148402,6163),(148403,6163),(148404,6163),(148405,6163),(148406,6164),(148407,6164),(148408,6164),(148409,6164),(148410,6164),(148411,6165),(148412,6165),(148413,6165),(148414,6165),(148415,6165),(148416,6166),(148417,6166),(148418,6166),(148419,6166),(148420,6166),(148421,6167),(148422,6167),(148423,6167),(148424,6167),(148425,6167),(148426,6168),(148427,6168),(148428,6168),(148429,6168),(148430,6168),(148431,6169),(148432,6169),(148433,6169),(148434,6169),(148435,6169),(148436,6170),(148437,6170),(148438,6170),(148439,6170),(148440,6170),(148441,6171),(148442,6171),(148443,6171),(148444,6171),(148445,6171),(148446,6172),(148447,6172),(148448,6172),(148449,6172),(148450,6172),(148451,6173),(148452,6173),(148453,6173),(148454,6173),(148455,6173),(148456,6174),(148457,6174),(148458,6174),(148459,6174),(148460,6174),(148461,6175),(148462,6175),(148463,6175),(148464,6175),(148465,6175),(148466,6176),(148467,6176),(148468,6176),(148469,6176),(148470,6176),(148471,6177),(148472,6177),(148473,6177),(148474,6177),(148475,6177),(148476,6178),(148477,6178),(148478,6178),(148479,6178),(148480,6178),(148481,6179),(148482,6179),(148483,6179),(148484,6179),(148485,6179),(148486,6180),(148487,6180),(148488,6180),(148489,6180),(148490,6180),(148491,6181),(148492,6181),(148493,6181),(148494,6181),(148495,6181),(148496,6182),(148497,6182),(148498,6182),(148499,6182),(148500,6182),(148501,6183),(148502,6183),(148503,6183),(148504,6183),(148505,6183),(148506,6184),(148507,6184),(148508,6184),(148509,6184),(148510,6184),(148511,6185),(148512,6185),(148513,6185),(148514,6185),(148515,6185),(148516,6186),(148517,6186),(148518,6186),(148519,6186),(148520,6186),(148521,6187),(148522,6187),(148523,6187),(148524,6187),(148525,6187),(148526,6188),(148527,6188),(148528,6188),(148529,6188),(148530,6188),(148531,6189),(148532,6189),(148533,6189),(148534,6189),(148535,6189),(148536,6190),(148537,6190),(148538,6190),(148539,6190),(148540,6190),(148541,6191),(148542,6191),(148543,6191),(148544,6191),(148545,6191),(148546,6192),(148547,6192),(148548,6192),(148549,6192),(148550,6192),(148551,6193),(148552,6193),(148553,6193),(148554,6193),(148555,6193),(148556,6194),(148557,6194),(148558,6194),(148559,6194),(148560,6194),(148561,6195),(148562,6195),(148563,6195),(148564,6195),(148565,6195),(148566,6196),(148567,6196),(148568,6196),(148569,6196),(148570,6196),(148571,6197),(148572,6197),(148573,6197),(148574,6197),(148575,6197),(148576,6198),(148577,6198),(148578,6198),(148579,6198),(148580,6198),(148581,6199),(148582,6199),(148583,6199),(148584,6199),(148585,6199),(148586,6200),(148587,6200),(148588,6200),(148589,6200),(148590,6200),(148591,6201),(148592,6201),(148593,6201),(148594,6201),(148595,6201),(148596,6202),(148597,6202),(148598,6202),(148599,6202),(148600,6202),(148601,6203),(148602,6203),(148603,6203),(148604,6203),(148605,6203),(148606,6204),(148607,6204),(148608,6204),(148609,6204),(148610,6204),(148611,6205),(148612,6205),(148613,6205),(148614,6205),(148615,6205),(148616,6206),(148617,6206),(148618,6206),(148619,6206),(148620,6206),(148621,6207),(148622,6207),(148623,6207),(148624,6207),(148625,6207),(148626,6208),(148627,6208),(148628,6208),(148629,6208),(148630,6208),(148631,6209),(148632,6209),(148633,6209),(148634,6209),(148635,6209),(148636,6210),(148637,6210),(148638,6210),(148639,6210),(148640,6210),(148641,6211),(148642,6211),(148643,6211),(148644,6211),(148645,6211),(148646,6212),(148647,6212),(148648,6212),(148649,6212),(148650,6212),(148651,6213),(148652,6213),(148653,6213),(148654,6213),(148655,6213),(148656,6214),(148657,6214),(148658,6214),(148659,6214),(148660,6214),(148661,6215),(148662,6215),(148663,6215),(148664,6215),(148665,6215),(148666,6216),(148667,6216),(148668,6216),(148669,6216),(148670,6216),(148671,6217),(148672,6217),(148673,6217),(148674,6217),(148675,6217),(148676,6218),(148677,6218),(148678,6218),(148679,6218),(148680,6218),(148681,6219),(148682,6219),(148683,6219),(148684,6219),(148685,6219),(148686,6220),(148687,6220),(148688,6220),(148689,6220),(148690,6220),(148691,6221),(148692,6221),(148693,6221),(148694,6221),(148695,6221),(148696,6222),(148697,6222),(148698,6222),(148699,6222),(148700,6222),(148701,6223),(148702,6223),(148703,6223),(148704,6223),(148705,6223),(148706,6224),(148707,6224),(148708,6224),(148709,6224),(148710,6224),(148711,6225),(148712,6225),(148713,6225),(148714,6225),(148715,6225),(148716,6226),(148717,6226),(148718,6226),(148719,6226),(148720,6226),(148721,6227),(148722,6227),(148723,6227),(148724,6227),(148725,6227),(148726,6228),(148727,6228),(148728,6228),(148729,6228),(148730,6228),(148731,6229),(148732,6229),(148733,6229),(148734,6229),(148735,6229),(148736,6230),(148737,6230),(148738,6230),(148739,6230),(148740,6230),(148741,6231),(148742,6231),(148743,6231),(148744,6232),(148745,6232),(148746,6232),(148747,6232),(148748,6232),(148749,6233),(148750,6233),(148751,6233),(148752,6233),(148753,6233),(148754,6234),(148755,6234),(148756,6234),(148757,6234),(148758,6234),(148759,6135),(148760,6135),(148761,6135),(148762,6135),(148763,6135),(148764,6136),(148765,6136),(148766,6136),(148767,6136),(148768,6136),(148769,6137),(148770,6137),(148771,6137),(148772,6137),(148773,6137),(148774,6138),(148775,6138),(148776,6138),(148777,6138),(148778,6138),(148779,6139),(148780,6139),(148781,6139),(148782,6139),(148783,6139),(148784,6140),(148785,6140),(148786,6140),(148787,6140),(148788,6140),(148789,6141),(148790,6141),(148791,6141),(148792,6141),(148793,6141),(148794,6142),(148795,6142),(148796,6142),(148797,6142),(148798,6142),(148799,6143),(148800,6143),(148801,6143),(148802,6143),(148803,6143),(148804,6144),(148805,6144),(148806,6144),(148807,6144),(148808,6144),(148809,6145),(148810,6145),(148811,6145),(148812,6145),(148813,6145),(148814,6146),(148815,6146),(148816,6146),(148817,6146),(148818,6146),(148819,6147),(148820,6147),(148821,6147),(148822,6147),(148823,6147),(148824,6148),(148825,6148),(148826,6148),(148827,6148),(148828,6148),(148829,6149),(148830,6149),(148831,6149),(148832,6149),(148833,6149),(148834,6150),(148835,6150),(148836,6150),(148837,6150),(148838,6150),(148839,6151),(148840,6151),(148841,6151),(148842,6151),(148843,6151),(148844,6152),(148845,6152),(148846,6152);
INSERT INTO `catalogsearch_fulltext_cl` VALUES (148847,6152),(148848,6152),(148849,6153),(148850,6153),(148851,6153),(148852,6153),(148853,6153),(148854,6154),(148855,6154),(148856,6154),(148857,6154),(148858,6154),(148859,6155),(148860,6155),(148861,6155),(148862,6155),(148863,6155),(148864,6156),(148865,6156),(148866,6156),(148867,6156),(148868,6156),(148869,6157),(148870,6157),(148871,6157),(148872,6157),(148873,6157),(148874,6158),(148875,6158),(148876,6158),(148877,6158),(148878,6158),(148879,6159),(148880,6159),(148881,6159),(148882,6159),(148883,6159),(148884,6160),(148885,6160),(148886,6160),(148887,6160),(148888,6160),(148889,6161),(148890,6161),(148891,6161),(148892,6161),(148893,6161),(148894,6162),(148895,6162),(148896,6162),(148897,6162),(148898,6162),(148899,6163),(148900,6163),(148901,6163),(148902,6163),(148903,6163),(148904,6164),(148905,6164),(148906,6164),(148907,6164),(148908,6164),(148909,6165),(148910,6165),(148911,6165),(148912,6165),(148913,6165),(148914,6166),(148915,6166),(148916,6166),(148917,6166),(148918,6166),(148919,6167),(148920,6167),(148921,6167),(148922,6167),(148923,6167),(148924,6168),(148925,6168),(148926,6168),(148927,6168),(148928,6168),(148929,6169),(148930,6169),(148931,6169),(148932,6169),(148933,6169),(148934,6170),(148935,6170),(148936,6170),(148937,6170),(148938,6170),(148939,6171),(148940,6171),(148941,6171),(148942,6171),(148943,6171),(148944,6172),(148945,6172),(148946,6172),(148947,6172),(148948,6172),(148949,6173),(148950,6173),(148951,6173),(148952,6173),(148953,6173),(148954,6174),(148955,6174),(148956,6174),(148957,6174),(148958,6174),(148959,6175),(148960,6175),(148961,6175),(148962,6175),(148963,6175),(148964,6176),(148965,6176),(148966,6176),(148967,6176),(148968,6176),(148969,6177),(148970,6177),(148971,6177),(148972,6177),(148973,6177),(148974,6178),(148975,6178),(148976,6178),(148977,6178),(148978,6178),(148979,6179),(148980,6179),(148981,6179),(148982,6179),(148983,6179),(148984,6180),(148985,6180),(148986,6180),(148987,6180),(148988,6180),(148989,6181),(148990,6181),(148991,6181),(148992,6181),(148993,6181),(148994,6182),(148995,6182),(148996,6182),(148997,6182),(148998,6182),(148999,6183),(149000,6183),(149001,6183),(149002,6183),(149003,6183),(149004,6184),(149005,6184),(149006,6184),(149007,6184),(149008,6184),(149009,6185),(149010,6185),(149011,6185),(149012,6185),(149013,6185),(149014,6186),(149015,6186),(149016,6186),(149017,6186),(149018,6186),(149019,6187),(149020,6187),(149021,6187),(149022,6187),(149023,6187),(149024,6188),(149025,6188),(149026,6188),(149027,6188),(149028,6188),(149029,6189),(149030,6189),(149031,6189),(149032,6189),(149033,6189),(149034,6190),(149035,6190),(149036,6190),(149037,6190),(149038,6190),(149039,6191),(149040,6191),(149041,6191),(149042,6191),(149043,6191),(149044,6192),(149045,6192),(149046,6192),(149047,6192),(149048,6192),(149049,6193),(149050,6193),(149051,6193),(149052,6193),(149053,6193),(149054,6194),(149055,6194),(149056,6194),(149057,6194),(149058,6194),(149059,6195),(149060,6195),(149061,6195),(149062,6195),(149063,6195),(149064,6196),(149065,6196),(149066,6196),(149067,6196),(149068,6196),(149069,6197),(149070,6197),(149071,6197),(149072,6197),(149073,6197),(149074,6198),(149075,6198),(149076,6198),(149077,6198),(149078,6198),(149079,6199),(149080,6199),(149081,6199),(149082,6199),(149083,6199),(149084,6200),(149085,6200),(149086,6200),(149087,6200),(149088,6200),(149089,6201),(149090,6201),(149091,6201),(149092,6201),(149093,6201),(149094,6202),(149095,6202),(149096,6202),(149097,6202),(149098,6202),(149099,6203),(149100,6203),(149101,6203),(149102,6203),(149103,6203),(149104,6204),(149105,6204),(149106,6204),(149107,6204),(149108,6204),(149109,6205),(149110,6205),(149111,6205),(149112,6205),(149113,6205),(149114,6206),(149115,6206),(149116,6206),(149117,6206),(149118,6206),(149119,6207),(149120,6207),(149121,6207),(149122,6207),(149123,6207),(149124,6208),(149125,6208),(149126,6208),(149127,6208),(149128,6208),(149129,6209),(149130,6209),(149131,6209),(149132,6209),(149133,6209),(149134,6210),(149135,6210),(149136,6210),(149137,6210),(149138,6210),(149139,6211),(149140,6211),(149141,6211),(149142,6211),(149143,6211),(149144,6212),(149145,6212),(149146,6212),(149147,6212),(149148,6212),(149149,6213),(149150,6213),(149151,6213),(149152,6213),(149153,6213),(149154,6214),(149155,6214),(149156,6214),(149157,6214),(149158,6214),(149159,6215),(149160,6215),(149161,6215),(149162,6215),(149163,6215),(149164,6216),(149165,6216),(149166,6216),(149167,6216),(149168,6216),(149169,6217),(149170,6217),(149171,6217),(149172,6217),(149173,6217),(149174,6218),(149175,6218),(149176,6218),(149177,6218),(149178,6218),(149179,6219),(149180,6219),(149181,6219),(149182,6219),(149183,6219),(149184,6220),(149185,6220),(149186,6220),(149187,6220),(149188,6220),(149189,6221),(149190,6221),(149191,6221),(149192,6221),(149193,6221),(149194,6222),(149195,6222),(149196,6222),(149197,6222),(149198,6222),(149199,6223),(149200,6223),(149201,6223),(149202,6223),(149203,6223),(149204,6224),(149205,6224),(149206,6224),(149207,6224),(149208,6224),(149209,6225),(149210,6225),(149211,6225),(149212,6225),(149213,6225),(149214,6226),(149215,6226),(149216,6226),(149217,6226),(149218,6226),(149219,6227),(149220,6227),(149221,6227),(149222,6227),(149223,6227),(149224,6228),(149225,6228),(149226,6228),(149227,6228),(149228,6228),(149229,6229),(149230,6229),(149231,6229),(149232,6229),(149233,6229),(149234,6230),(149235,6230),(149236,6230),(149237,6230),(149238,6230),(149239,6231),(149240,6231),(149241,6231),(149242,6231),(149243,6231),(149244,6232),(149245,6232),(149246,6232),(149247,6232),(149248,6232),(149249,6233),(149250,6233),(149251,6233),(149252,6233),(149253,6233),(149254,6234),(149255,6234),(149256,6234),(149257,6234),(149258,6234),(149259,6235),(149260,6236),(149261,6237),(149262,6238),(149263,6239),(149264,6240),(149265,6241),(149266,6242),(149267,6243),(149268,6244),(149269,6245),(149270,6246),(149271,6247),(149272,6248),(149273,6249),(149274,6250),(149275,6251),(149276,6252),(149277,6253),(149278,6254),(149279,6255),(149280,6256),(149281,6257),(149282,6258),(149283,6259),(149284,6260),(149285,6261),(149286,6262),(149287,6263),(149288,6264),(149289,6265),(149290,6266),(149291,6267),(149292,6268),(149293,6269),(149294,6270),(149295,6271),(149296,6272),(149297,6273),(149298,6274),(149299,6275),(149300,6276),(149301,6277),(149302,6278),(149303,6279),(149304,6280),(149305,6281),(149306,6282),(149307,6283),(149308,6284),(149309,6285),(149310,6286),(149311,6287),(149312,6288),(149313,6289),(149314,6290),(149315,6291),(149316,6292),(149317,6293),(149318,6294),(149319,6295),(149320,6296),(149321,6297),(149322,6298),(149323,6299),(149324,6300),(149325,6301),(149326,6302),(149327,6303),(149328,6304),(149329,6305),(149330,6306),(149331,6307),(149332,6308),(149333,6309),(149334,6310),(149335,6311),(149336,6312),(149337,6313),(149338,6314),(149339,6315),(149340,6316),(149341,6317),(149342,6318),(149343,6319),(149344,6320),(149345,6321),(149346,6322),(149347,6323),(149348,6324),(149349,6325),(149350,6326),(149351,6327),(149352,6328),(149353,6329),(149354,6330),(149355,6331),(149356,6332),(149357,6333),(149358,6334),(149359,6235),(149360,6236),(149361,6237),(149362,6238),(149363,6239),(149364,6240),(149365,6241),(149366,6242),(149367,6243),(149368,6244),(149369,6245),(149370,6246),(149371,6247),(149372,6248),(149373,6249),(149374,6250),(149375,6251),(149376,6252),(149377,6253),(149378,6254),(149379,6255),(149380,6256),(149381,6257),(149382,6258),(149383,6259),(149384,6260),(149385,6261),(149386,6262),(149387,6263),(149388,6264),(149389,6265),(149390,6266),(149391,6267),(149392,6268),(149393,6269),(149394,6270),(149395,6271),(149396,6272),(149397,6273),(149398,6274),(149399,6275),(149400,6276),(149401,6277),(149402,6278),(149403,6279),(149404,6280),(149405,6281),(149406,6282),(149407,6283),(149408,6284),(149409,6285),(149410,6286),(149411,6287),(149412,6288),(149413,6289),(149414,6290),(149415,6291),(149416,6292),(149417,6293),(149418,6294),(149419,6295),(149420,6296),(149421,6297),(149422,6298),(149423,6299),(149424,6300),(149425,6301),(149426,6302),(149427,6303),(149428,6304),(149429,6305),(149430,6306),(149431,6307),(149432,6308),(149433,6309),(149434,6310),(149435,6311),(149436,6312),(149437,6313),(149438,6314),(149439,6315),(149440,6316),(149441,6317),(149442,6318),(149443,6319),(149444,6320),(149445,6321),(149446,6322),(149447,6323),(149448,6324),(149449,6325),(149450,6326),(149451,6327),(149452,6328),(149453,6329),(149454,6330),(149455,6331),(149456,6332),(149457,6333),(149458,6334),(149459,6235),(149460,6235),(149461,6235),(149462,6236),(149463,6236),(149464,6236),(149465,6237),(149466,6237),(149467,6237),(149468,6238),(149469,6238),(149470,6238),(149471,6239),(149472,6239),(149473,6239),(149474,6240),(149475,6240),(149476,6240),(149477,6241),(149478,6241),(149479,6241),(149480,6242),(149481,6242),(149482,6242),(149483,6243),(149484,6243),(149485,6243),(149486,6244),(149487,6244),(149488,6244),(149489,6245),(149490,6245),(149491,6245),(149492,6246),(149493,6246),(149494,6246),(149495,6247),(149496,6247),(149497,6247),(149498,6248),(149499,6248),(149500,6248),(149501,6249),(149502,6249),(149503,6249),(149504,6250),(149505,6250),(149506,6250),(149507,6251),(149508,6251),(149509,6251),(149510,6252),(149511,6252),(149512,6252),(149513,6253),(149514,6253),(149515,6253),(149516,6254),(149517,6254),(149518,6254),(149519,6255),(149520,6255),(149521,6255),(149522,6256),(149523,6256),(149524,6256),(149525,6257),(149526,6257),(149527,6257),(149528,6258),(149529,6258),(149530,6258),(149531,6259),(149532,6259),(149533,6259),(149534,6260),(149535,6260),(149536,6260),(149537,6261),(149538,6261),(149539,6261),(149540,6262),(149541,6262),(149542,6262),(149543,6263),(149544,6263),(149545,6263),(149546,6264),(149547,6264),(149548,6264),(149549,6265),(149550,6265),(149551,6265),(149552,6266),(149553,6266),(149554,6266),(149555,6267),(149556,6267),(149557,6267),(149558,6268),(149559,6268),(149560,6268),(149561,6269),(149562,6269),(149563,6269),(149564,6270),(149565,6270),(149566,6270),(149567,6271),(149568,6271),(149569,6271),(149570,6272),(149571,6272),(149572,6272),(149573,6273),(149574,6273),(149575,6273),(149576,6274),(149577,6274),(149578,6274),(149579,6275),(149580,6275),(149581,6275),(149582,6276),(149583,6276),(149584,6276),(149585,6277),(149586,6277),(149587,6277),(149588,6278),(149589,6278),(149590,6278),(149591,6279),(149592,6279),(149593,6279),(149594,6280),(149595,6280),(149596,6280),(149597,6281),(149598,6281),(149599,6281),(149600,6282),(149601,6282),(149602,6282),(149603,6283),(149604,6283),(149605,6283),(149606,6284),(149607,6284),(149608,6284),(149609,6285),(149610,6285),(149611,6285),(149612,6286),(149613,6286),(149614,6286),(149615,6287),(149616,6287),(149617,6287),(149618,6288),(149619,6288),(149620,6288),(149621,6289),(149622,6289),(149623,6289),(149624,6290),(149625,6290),(149626,6290),(149627,6291),(149628,6291),(149629,6291),(149630,6292),(149631,6292),(149632,6292),(149633,6293),(149634,6293),(149635,6293),(149636,6294),(149637,6294),(149638,6294),(149639,6295),(149640,6295),(149641,6295),(149642,6296),(149643,6296),(149644,6296),(149645,6297),(149646,6297),(149647,6297),(149648,6298),(149649,6298),(149650,6298),(149651,6299),(149652,6299),(149653,6299),(149654,6300),(149655,6300),(149656,6300),(149657,6301),(149658,6301),(149659,6301),(149660,6302),(149661,6302),(149662,6302),(149663,6303),(149664,6303),(149665,6303),(149666,6304),(149667,6304),(149668,6304),(149669,6305),(149670,6305),(149671,6305),(149672,6306),(149673,6306),(149674,6306),(149675,6307),(149676,6307),(149677,6307),(149678,6308),(149679,6308),(149680,6308),(149681,6309),(149682,6309),(149683,6309),(149684,6310),(149685,6310),(149686,6310),(149687,6311),(149688,6311),(149689,6311),(149690,6312),(149691,6312),(149692,6312),(149693,6313),(149694,6313),(149695,6313),(149696,6314),(149697,6314),(149698,6314),(149699,6315),(149700,6315),(149701,6315),(149702,6316),(149703,6316),(149704,6316),(149705,6317),(149706,6317),(149707,6317),(149708,6318),(149709,6318),(149710,6318),(149711,6319),(149712,6319),(149713,6319),(149714,6320),(149715,6320),(149716,6320),(149717,6321),(149718,6321),(149719,6321),(149720,6322),(149721,6322),(149722,6322),(149723,6323),(149724,6323),(149725,6323),(149726,6324),(149727,6324),(149728,6324),(149729,6325),(149730,6325),(149731,6325),(149732,6326),(149733,6326),(149734,6326),(149735,6327),(149736,6327),(149737,6327),(149738,6328),(149739,6328),(149740,6328),(149741,6329),(149742,6329),(149743,6329),(149744,6330),(149745,6330),(149746,6330),(149747,6331),(149748,6331),(149749,6331),(149750,6332),(149751,6332),(149752,6332),(149753,6333),(149754,6333),(149755,6333),(149756,6334),(149757,6334),(149758,6334),(149759,6235),(149760,6235),(149761,6235),(149762,6235),(149763,6235),(149764,6235),(149765,6235),(149766,6235),(149767,6235),(149768,6235),(149769,6236),(149770,6236),(149771,6236),(149772,6236),(149773,6236),(149774,6236),(149775,6236),(149776,6236),(149777,6236),(149778,6236),(149779,6237),(149780,6237),(149781,6237),(149782,6237),(149783,6237),(149784,6237),(149785,6237),(149786,6237),(149787,6237),(149788,6237),(149789,6238),(149790,6238),(149791,6238),(149792,6238),(149793,6238),(149794,6238),(149795,6238),(149796,6238),(149797,6238),(149798,6238),(149799,6239),(149800,6239),(149801,6239),(149802,6239),(149803,6239),(149804,6239),(149805,6239),(149806,6239),(149807,6239),(149808,6239),(149809,6240),(149810,6240),(149811,6240),(149812,6240),(149813,6240),(149814,6240),(149815,6240),(149816,6240),(149817,6240),(149818,6240),(149819,6240),(149820,6240),(149821,6241),(149822,6241),(149823,6241),(149824,6241),(149825,6241),(149826,6241),(149827,6241),(149828,6241),(149829,6241),(149830,6241),(149831,6241),(149832,6241),(149833,6242),(149834,6242),(149835,6242),(149836,6242),(149837,6242),(149838,6242),(149839,6242),(149840,6242),(149841,6242),(149842,6242),(149843,6243),(149844,6243),(149845,6243),(149846,6243),(149847,6243),(149848,6243),(149849,6243),(149850,6243),(149851,6243),(149852,6243),(149853,6243),(149854,6243),(149855,6243),(149856,6243),(149857,6244),(149858,6244),(149859,6244),(149860,6244),(149861,6244),(149862,6244),(149863,6244),(149864,6244),(149865,6244),(149866,6244),(149867,6244),(149868,6244),(149869,6244),(149870,6244),(149871,6245),(149872,6245),(149873,6245),(149874,6245),(149875,6245),(149876,6245),(149877,6245),(149878,6245),(149879,6245),(149880,6245),(149881,6246),(149882,6246),(149883,6246),(149884,6246),(149885,6246),(149886,6246),(149887,6246),(149888,6246),(149889,6246),(149890,6246),(149891,6247),(149892,6247),(149893,6247),(149894,6247),(149895,6247),(149896,6247),(149897,6247),(149898,6247),(149899,6247),(149900,6247),(149901,6248),(149902,6248),(149903,6248),(149904,6248),(149905,6248),(149906,6248),(149907,6248),(149908,6248),(149909,6248),(149910,6248),(149911,6249),(149912,6249),(149913,6249),(149914,6249),(149915,6249),(149916,6249),(149917,6249),(149918,6249),(149919,6249),(149920,6249),(149921,6250),(149922,6250),(149923,6250),(149924,6250),(149925,6250),(149926,6250),(149927,6250),(149928,6250),(149929,6250),(149930,6250),(149931,6251),(149932,6251),(149933,6251),(149934,6251),(149935,6251),(149936,6251),(149937,6251),(149938,6251),(149939,6251),(149940,6251),(149941,6251),(149942,6251),(149943,6251),(149944,6251),(149945,6252),(149946,6252),(149947,6252),(149948,6252),(149949,6252),(149950,6252),(149951,6252),(149952,6252),(149953,6252),(149954,6252),(149955,6253),(149956,6253),(149957,6253),(149958,6253),(149959,6253),(149960,6253),(149961,6253),(149962,6253),(149963,6253),(149964,6253),(149965,6254),(149966,6254),(149967,6254),(149968,6254),(149969,6254),(149970,6254),(149971,6254),(149972,6254),(149973,6254),(149974,6254),(149975,6255),(149976,6255),(149977,6255),(149978,6255),(149979,6255),(149980,6255),(149981,6255),(149982,6255),(149983,6255),(149984,6255),(149985,6255),(149986,6255),(149987,6255),(149988,6255),(149989,6256),(149990,6256),(149991,6256),(149992,6256),(149993,6256),(149994,6256),(149995,6256),(149996,6256),(149997,6256),(149998,6256),(149999,6257),(150000,6257),(150001,6257),(150002,6257),(150003,6257),(150004,6257),(150005,6257),(150006,6257),(150007,6257),(150008,6257),(150009,6258),(150010,6258),(150011,6258),(150012,6258),(150013,6258),(150014,6258),(150015,6258),(150016,6258),(150017,6258),(150018,6258),(150019,6258),(150020,6258),(150021,6259),(150022,6259),(150023,6259),(150024,6259),(150025,6259),(150026,6259),(150027,6259),(150028,6259),(150029,6259),(150030,6259),(150031,6259),(150032,6259),(150033,6260),(150034,6260),(150035,6260),(150036,6260),(150037,6260),(150038,6260),(150039,6260),(150040,6260),(150041,6260),(150042,6260),(150043,6260),(150044,6260),(150045,6261),(150046,6261),(150047,6261),(150048,6261),(150049,6261),(150050,6261),(150051,6261),(150052,6261),(150053,6262),(150054,6262),(150055,6262),(150056,6262),(150057,6262),(150058,6262),(150059,6262),(150060,6262),(150061,6263),(150062,6263),(150063,6263),(150064,6263),(150065,6263),(150066,6263),(150067,6263),(150068,6263),(150069,6264),(150070,6264),(150071,6264),(150072,6264),(150073,6264),(150074,6264),(150075,6264),(150076,6264),(150077,6265),(150078,6265),(150079,6265),(150080,6265),(150081,6265),(150082,6265),(150083,6265),(150084,6265),(150085,6266),(150086,6266),(150087,6266),(150088,6266),(150089,6266),(150090,6266),(150091,6266),(150092,6266),(150093,6267),(150094,6267),(150095,6267),(150096,6267),(150097,6267),(150098,6267),(150099,6267),(150100,6267),(150101,6267),(150102,6267),(150103,6267),(150104,6267),(150105,6267),(150106,6267),(150107,6268),(150108,6268),(150109,6268),(150110,6268),(150111,6268),(150112,6268),(150113,6268),(150114,6268),(150115,6268),(150116,6268),(150117,6268),(150118,6268),(150119,6268),(150120,6268),(150121,6269),(150122,6269),(150123,6269),(150124,6269),(150125,6269),(150126,6269),(150127,6269),(150128,6269),(150129,6269),(150130,6269),(150131,6270),(150132,6270),(150133,6270),(150134,6270),(150135,6270),(150136,6270),(150137,6270),(150138,6270),(150139,6270),(150140,6270),(150141,6271),(150142,6271),(150143,6271),(150144,6271),(150145,6271),(150146,6271),(150147,6271),(150148,6271),(150149,6271),(150150,6271),(150151,6271),(150152,6271),(150153,6271),(150154,6271),(150155,6272),(150156,6272),(150157,6272),(150158,6272),(150159,6272),(150160,6272),(150161,6272),(150162,6272),(150163,6272),(150164,6272),(150165,6272),(150166,6272),(150167,6272),(150168,6272),(150169,6273),(150170,6273),(150171,6273),(150172,6273),(150173,6273),(150174,6273),(150175,6273),(150176,6273),(150177,6273),(150178,6273),(150179,6273),(150180,6273),(150181,6273),(150182,6273),(150183,6274),(150184,6274),(150185,6274),(150186,6274),(150187,6274),(150188,6274),(150189,6274),(150190,6274),(150191,6274),(150192,6274),(150193,6274),(150194,6274),(150195,6274),(150196,6274),(150197,6275),(150198,6275),(150199,6275),(150200,6275),(150201,6275),(150202,6275),(150203,6275),(150204,6275),(150205,6275),(150206,6275),(150207,6276),(150208,6276),(150209,6276),(150210,6276),(150211,6276),(150212,6276),(150213,6276),(150214,6276),(150215,6276),(150216,6276),(150217,6276),(150218,6276),(150219,6276),(150220,6276),(150221,6277),(150222,6277),(150223,6277),(150224,6277),(150225,6277),(150226,6277),(150227,6277),(150228,6277),(150229,6277),(150230,6277),(150231,6277),(150232,6277),(150233,6277),(150234,6277),(150235,6278),(150236,6278),(150237,6278),(150238,6278),(150239,6278),(150240,6278),(150241,6278),(150242,6278),(150243,6278),(150244,6278),(150245,6278),(150246,6278),(150247,6278),(150248,6278),(150249,6279),(150250,6279),(150251,6279),(150252,6279),(150253,6279),(150254,6279),(150255,6279),(150256,6279),(150257,6279),(150258,6279),(150259,6279),(150260,6279),(150261,6279),(150262,6279),(150263,6280),(150264,6280),(150265,6280),(150266,6280),(150267,6280),(150268,6280),(150269,6280),(150270,6280),(150271,6280),(150272,6280),(150273,6281),(150274,6281),(150275,6281),(150276,6281),(150277,6281),(150278,6281),(150279,6281),(150280,6281),(150281,6281),(150282,6281),(150283,6282),(150284,6282),(150285,6282),(150286,6282),(150287,6282),(150288,6282),(150289,6282),(150290,6282),(150291,6282),(150292,6282),(150293,6283),(150294,6283),(150295,6283),(150296,6283),(150297,6283),(150298,6283),(150299,6283),(150300,6283),(150301,6283),(150302,6283),(150303,6284),(150304,6284),(150305,6284),(150306,6284),(150307,6284),(150308,6284),(150309,6284),(150310,6284),(150311,6284),(150312,6284),(150313,6285),(150314,6285),(150315,6285),(150316,6285),(150317,6285),(150318,6285),(150319,6285),(150320,6285),(150321,6285),(150322,6285),(150323,6286),(150324,6286),(150325,6286),(150326,6286),(150327,6286),(150328,6286),(150329,6286),(150330,6286),(150331,6286),(150332,6286),(150333,6287),(150334,6287),(150335,6287),(150336,6287),(150337,6287),(150338,6287),(150339,6287),(150340,6287),(150341,6287),(150342,6287),(150343,6288),(150344,6288),(150345,6288),(150346,6288),(150347,6288),(150348,6288),(150349,6288),(150350,6288),(150351,6288),(150352,6288),(150353,6289),(150354,6289),(150355,6289),(150356,6289),(150357,6289),(150358,6289),(150359,6289),(150360,6289),(150361,6289),(150362,6289),(150363,6290),(150364,6290),(150365,6290),(150366,6290),(150367,6290),(150368,6290),(150369,6290),(150370,6290),(150371,6290),(150372,6290),(150373,6291),(150374,6291),(150375,6291),(150376,6291),(150377,6291),(150378,6291),(150379,6291),(150380,6291),(150381,6291),(150382,6291),(150383,6292),(150384,6292),(150385,6292),(150386,6292),(150387,6292),(150388,6292),(150389,6292),(150390,6292),(150391,6292),(150392,6292),(150393,6293),(150394,6293),(150395,6293),(150396,6293),(150397,6293),(150398,6293),(150399,6293),(150400,6293),(150401,6293),(150402,6293),(150403,6294),(150404,6294),(150405,6294),(150406,6294),(150407,6294),(150408,6294),(150409,6294),(150410,6294),(150411,6294),(150412,6294),(150413,6295),(150414,6295),(150415,6295),(150416,6295),(150417,6295),(150418,6295),(150419,6295),(150420,6295),(150421,6295),(150422,6295),(150423,6296),(150424,6296),(150425,6296),(150426,6296),(150427,6296),(150428,6296),(150429,6296),(150430,6296),(150431,6296),(150432,6296),(150433,6297),(150434,6297),(150435,6297),(150436,6297),(150437,6297),(150438,6297),(150439,6297),(150440,6297),(150441,6297),(150442,6297),(150443,6298),(150444,6298),(150445,6298),(150446,6298),(150447,6298),(150448,6298),(150449,6298),(150450,6298),(150451,6298),(150452,6298),(150453,6298),(150454,6298),(150455,6298),(150456,6298),(150457,6299),(150458,6299),(150459,6299),(150460,6299),(150461,6299),(150462,6299),(150463,6299),(150464,6299),(150465,6299),(150466,6299),(150467,6299),(150468,6299),(150469,6299),(150470,6299),(150471,6300),(150472,6300),(150473,6300),(150474,6300),(150475,6300),(150476,6300),(150477,6300),(150478,6300),(150479,6300),(150480,6300),(150481,6301),(150482,6301),(150483,6301),(150484,6301),(150485,6301),(150486,6301),(150487,6301),(150488,6301),(150489,6301),(150490,6301),(150491,6302),(150492,6302),(150493,6302),(150494,6302),(150495,6302),(150496,6302),(150497,6302),(150498,6302),(150499,6302),(150500,6302),(150501,6303),(150502,6303),(150503,6303),(150504,6303),(150505,6303),(150506,6303),(150507,6303),(150508,6303),(150509,6303),(150510,6303),(150511,6304),(150512,6304),(150513,6304),(150514,6304),(150515,6304),(150516,6304),(150517,6304),(150518,6304),(150519,6304),(150520,6304),(150521,6305),(150522,6305),(150523,6305),(150524,6305),(150525,6305),(150526,6305),(150527,6305),(150528,6305),(150529,6305),(150530,6305),(150531,6306),(150532,6306),(150533,6306),(150534,6306),(150535,6306),(150536,6306),(150537,6306),(150538,6306),(150539,6306),(150540,6306),(150541,6307),(150542,6307),(150543,6307),(150544,6307),(150545,6307),(150546,6307),(150547,6307),(150548,6307),(150549,6307),(150550,6307),(150551,6308),(150552,6308),(150553,6308),(150554,6308),(150555,6308),(150556,6308),(150557,6308),(150558,6308),(150559,6308),(150560,6308),(150561,6309),(150562,6309),(150563,6309),(150564,6309),(150565,6309),(150566,6309),(150567,6309),(150568,6309),(150569,6309),(150570,6309),(150571,6310),(150572,6310),(150573,6310),(150574,6310),(150575,6310),(150576,6310),(150577,6310),(150578,6310),(150579,6310),(150580,6310),(150581,6311),(150582,6311),(150583,6311),(150584,6311),(150585,6311),(150586,6311),(150587,6311),(150588,6311),(150589,6311),(150590,6311),(150591,6312),(150592,6312),(150593,6312),(150594,6312),(150595,6312),(150596,6312),(150597,6312),(150598,6312),(150599,6312),(150600,6312),(150601,6313),(150602,6313),(150603,6313),(150604,6313),(150605,6313),(150606,6313),(150607,6313),(150608,6313),(150609,6313),(150610,6313),(150611,6314),(150612,6314),(150613,6314),(150614,6314),(150615,6314),(150616,6314),(150617,6314),(150618,6314),(150619,6314),(150620,6314),(150621,6315),(150622,6315),(150623,6315),(150624,6315),(150625,6315),(150626,6315),(150627,6315),(150628,6315),(150629,6315),(150630,6315),(150631,6316),(150632,6316),(150633,6316),(150634,6316),(150635,6316),(150636,6316),(150637,6316),(150638,6316),(150639,6316),(150640,6316),(150641,6317),(150642,6317),(150643,6317),(150644,6317),(150645,6317),(150646,6317),(150647,6317),(150648,6317),(150649,6317),(150650,6317),(150651,6318),(150652,6318),(150653,6318),(150654,6318),(150655,6318),(150656,6318),(150657,6318),(150658,6318),(150659,6318),(150660,6318),(150661,6319),(150662,6319),(150663,6319),(150664,6319),(150665,6319),(150666,6319),(150667,6319),(150668,6319),(150669,6319),(150670,6319),(150671,6320),(150672,6320),(150673,6320),(150674,6320),(150675,6320),(150676,6320),(150677,6320),(150678,6320),(150679,6320),(150680,6320),(150681,6321),(150682,6321),(150683,6321),(150684,6321),(150685,6321),(150686,6321),(150687,6321),(150688,6321),(150689,6321),(150690,6321),(150691,6322),(150692,6322),(150693,6322),(150694,6322),(150695,6322),(150696,6322),(150697,6322),(150698,6322),(150699,6322),(150700,6322),(150701,6323),(150702,6323),(150703,6323),(150704,6323),(150705,6323),(150706,6323),(150707,6323),(150708,6323),(150709,6323),(150710,6323),(150711,6324),(150712,6324),(150713,6324),(150714,6324),(150715,6324),(150716,6324),(150717,6324),(150718,6324),(150719,6324),(150720,6324),(150721,6325),(150722,6325),(150723,6325),(150724,6325),(150725,6325),(150726,6325),(150727,6325),(150728,6325),(150729,6325),(150730,6325),(150731,6326),(150732,6326),(150733,6326),(150734,6326),(150735,6326),(150736,6326),(150737,6326),(150738,6326),(150739,6326),(150740,6326),(150741,6327),(150742,6327),(150743,6327),(150744,6327),(150745,6327),(150746,6327),(150747,6327),(150748,6327),(150749,6327),(150750,6327),(150751,6328),(150752,6328),(150753,6328),(150754,6328),(150755,6328),(150756,6328),(150757,6328),(150758,6328),(150759,6328),(150760,6328),(150761,6329),(150762,6329),(150763,6329),(150764,6329),(150765,6329),(150766,6329),(150767,6329),(150768,6329),(150769,6329),(150770,6329),(150771,6330),(150772,6330),(150773,6330),(150774,6330),(150775,6330),(150776,6330),(150777,6330),(150778,6330),(150779,6330),(150780,6330),(150781,6331),(150782,6331),(150783,6331),(150784,6331),(150785,6331),(150786,6331),(150787,6331),(150788,6331),(150789,6331),(150790,6331),(150791,6332),(150792,6332),(150793,6332),(150794,6332),(150795,6332),(150796,6332),(150797,6332),(150798,6332),(150799,6332),(150800,6332),(150801,6333),(150802,6333),(150803,6333),(150804,6333),(150805,6333),(150806,6333),(150807,6333),(150808,6333),(150809,6333),(150810,6333),(150811,6334),(150812,6334),(150813,6334),(150814,6334),(150815,6334),(150816,6334),(150817,6334),(150818,6334),(150819,6334),(150820,6334),(150821,6235),(150822,6235),(150823,6235),(150824,6235),(150825,6235),(150826,6236),(150827,6236),(150828,6236),(150829,6236),(150830,6236),(150831,6237),(150832,6237),(150833,6237),(150834,6237),(150835,6237),(150836,6238),(150837,6238),(150838,6238),(150839,6238),(150840,6238),(150841,6239),(150842,6239),(150843,6239),(150844,6239),(150845,6239),(150846,6240),(150847,6240),(150848,6240),(150849,6240),(150850,6240),(150851,6241),(150852,6241),(150853,6241),(150854,6241),(150855,6241),(150856,6242),(150857,6242),(150858,6242),(150859,6242),(150860,6242),(150861,6243),(150862,6243),(150863,6243),(150864,6243),(150865,6243),(150866,6244),(150867,6244),(150868,6244),(150869,6244),(150870,6244),(150871,6245),(150872,6245),(150873,6245),(150874,6246),(150875,6246),(150876,6246),(150877,6247),(150878,6247),(150879,6247),(150880,6248),(150881,6248),(150882,6248),(150883,6249),(150884,6249),(150885,6249),(150886,6249),(150887,6249),(150888,6250),(150889,6250),(150890,6250),(150891,6250),(150892,6250),(150893,6251),(150894,6251),(150895,6251),(150896,6251),(150897,6251),(150898,6252),(150899,6252),(150900,6252),(150901,6252),(150902,6252),(150903,6253),(150904,6253),(150905,6253),(150906,6253),(150907,6253),(150908,6254),(150909,6254),(150910,6254),(150911,6254),(150912,6254),(150913,6255),(150914,6255),(150915,6255),(150916,6255),(150917,6255),(150918,6256),(150919,6256),(150920,6256),(150921,6256),(150922,6256),(150923,6257),(150924,6257),(150925,6257),(150926,6257),(150927,6257),(150928,6258),(150929,6258),(150930,6258),(150931,6258),(150932,6258),(150933,6259),(150934,6259),(150935,6259),(150936,6259),(150937,6259),(150938,6260),(150939,6260),(150940,6260),(150941,6260),(150942,6260),(150943,6261),(150944,6261),(150945,6261),(150946,6261),(150947,6261),(150948,6262),(150949,6262),(150950,6262),(150951,6262),(150952,6262),(150953,6263),(150954,6263),(150955,6263),(150956,6263),(150957,6263),(150958,6264),(150959,6264),(150960,6264),(150961,6264),(150962,6264),(150963,6265),(150964,6265),(150965,6265),(150966,6265),(150967,6265),(150968,6266),(150969,6266),(150970,6266),(150971,6266),(150972,6266),(150973,6267),(150974,6267),(150975,6267),(150976,6267),(150977,6267),(150978,6268),(150979,6268),(150980,6268),(150981,6268),(150982,6268),(150983,6269),(150984,6269),(150985,6269),(150986,6269),(150987,6269),(150988,6270),(150989,6270),(150990,6270),(150991,6270),(150992,6270),(150993,6271),(150994,6271),(150995,6271),(150996,6271),(150997,6271),(150998,6272),(150999,6272),(151000,6272),(151001,6272),(151002,6272),(151003,6273),(151004,6273),(151005,6273),(151006,6273),(151007,6273),(151008,6274),(151009,6274),(151010,6274),(151011,6274),(151012,6274),(151013,6275),(151014,6275),(151015,6275),(151016,6275),(151017,6275),(151018,6276),(151019,6276),(151020,6276),(151021,6276),(151022,6276),(151023,6277),(151024,6277),(151025,6277),(151026,6277),(151027,6277),(151028,6278),(151029,6278),(151030,6278),(151031,6278),(151032,6278),(151033,6279),(151034,6279),(151035,6279),(151036,6279),(151037,6279),(151038,6280),(151039,6280),(151040,6280),(151041,6280),(151042,6280),(151043,6281),(151044,6281),(151045,6281),(151046,6281),(151047,6281),(151048,6282),(151049,6282),(151050,6282),(151051,6282),(151052,6282),(151053,6283),(151054,6283),(151055,6283),(151056,6283),(151057,6283),(151058,6284),(151059,6284),(151060,6284),(151061,6284),(151062,6284),(151063,6285),(151064,6285),(151065,6285),(151066,6285),(151067,6285),(151068,6286),(151069,6286),(151070,6286),(151071,6286),(151072,6286),(151073,6287),(151074,6287),(151075,6287),(151076,6287),(151077,6287),(151078,6288),(151079,6288),(151080,6288),(151081,6288),(151082,6288),(151083,6289),(151084,6289),(151085,6289),(151086,6289),(151087,6289),(151088,6290),(151089,6290),(151090,6290),(151091,6290),(151092,6290),(151093,6291),(151094,6291),(151095,6291),(151096,6291),(151097,6291),(151098,6292),(151099,6292),(151100,6292),(151101,6292),(151102,6292),(151103,6293),(151104,6293),(151105,6293),(151106,6293),(151107,6293),(151108,6294),(151109,6294),(151110,6294),(151111,6294),(151112,6294),(151113,6295),(151114,6295),(151115,6295),(151116,6295),(151117,6295),(151118,6296),(151119,6296),(151120,6296),(151121,6296),(151122,6296),(151123,6297),(151124,6297),(151125,6297),(151126,6297),(151127,6297),(151128,6298),(151129,6298),(151130,6298),(151131,6298),(151132,6298),(151133,6299),(151134,6299),(151135,6299),(151136,6299),(151137,6299),(151138,6300),(151139,6300),(151140,6300),(151141,6300),(151142,6300),(151143,6301),(151144,6301),(151145,6301),(151146,6301),(151147,6301),(151148,6302),(151149,6302),(151150,6302),(151151,6302),(151152,6302),(151153,6303),(151154,6303),(151155,6303),(151156,6303),(151157,6303),(151158,6304),(151159,6304),(151160,6304),(151161,6304),(151162,6304),(151163,6305),(151164,6305),(151165,6305),(151166,6305),(151167,6305),(151168,6306),(151169,6306),(151170,6306),(151171,6306),(151172,6306),(151173,6307),(151174,6307),(151175,6307),(151176,6307),(151177,6307),(151178,6308),(151179,6308),(151180,6308),(151181,6308),(151182,6308),(151183,6309),(151184,6309),(151185,6309),(151186,6309),(151187,6309),(151188,6310),(151189,6310),(151190,6310),(151191,6310),(151192,6310),(151193,6311),(151194,6311),(151195,6311),(151196,6311),(151197,6311),(151198,6312),(151199,6312),(151200,6312),(151201,6313),(151202,6313),(151203,6313),(151204,6313),(151205,6313),(151206,6314),(151207,6314),(151208,6314),(151209,6314),(151210,6314),(151211,6315),(151212,6315),(151213,6315),(151214,6315),(151215,6315),(151216,6316),(151217,6316),(151218,6316),(151219,6316),(151220,6316),(151221,6317),(151222,6317),(151223,6317),(151224,6317),(151225,6317),(151226,6318),(151227,6318),(151228,6318),(151229,6318),(151230,6318),(151231,6319),(151232,6319),(151233,6319),(151234,6319),(151235,6319),(151236,6320),(151237,6320),(151238,6320),(151239,6320),(151240,6320),(151241,6321),(151242,6321),(151243,6321),(151244,6321),(151245,6321),(151246,6322),(151247,6322),(151248,6322),(151249,6322),(151250,6322),(151251,6323),(151252,6323),(151253,6323),(151254,6323),(151255,6323),(151256,6324),(151257,6324),(151258,6324),(151259,6324),(151260,6324),(151261,6325),(151262,6325),(151263,6325),(151264,6325),(151265,6325),(151266,6326),(151267,6326),(151268,6326),(151269,6326),(151270,6326),(151271,6327),(151272,6327),(151273,6327),(151274,6327),(151275,6327),(151276,6328),(151277,6328),(151278,6328),(151279,6328),(151280,6328),(151281,6329),(151282,6329),(151283,6329),(151284,6329),(151285,6329),(151286,6330),(151287,6330),(151288,6330),(151289,6330),(151290,6330),(151291,6331),(151292,6331),(151293,6331),(151294,6331),(151295,6331),(151296,6332),(151297,6332),(151298,6332),(151299,6332),(151300,6332),(151301,6333),(151302,6333),(151303,6333),(151304,6333),(151305,6333),(151306,6334),(151307,6334),(151308,6334),(151309,6334),(151310,6334),(151311,6235),(151312,6235),(151313,6235),(151314,6235),(151315,6235),(151316,6236),(151317,6236),(151318,6236),(151319,6236),(151320,6236),(151321,6237),(151322,6237),(151323,6237),(151324,6237),(151325,6237),(151326,6238),(151327,6238),(151328,6238),(151329,6238),(151330,6238),(151331,6239),(151332,6239),(151333,6239),(151334,6239),(151335,6239),(151336,6240),(151337,6240),(151338,6240),(151339,6240),(151340,6240),(151341,6241),(151342,6241),(151343,6241),(151344,6241),(151345,6241),(151346,6242),(151347,6242),(151348,6242),(151349,6242),(151350,6242),(151351,6243),(151352,6243),(151353,6243),(151354,6243),(151355,6243),(151356,6244),(151357,6244),(151358,6244),(151359,6244),(151360,6244),(151361,6245),(151362,6245),(151363,6245),(151364,6245),(151365,6245),(151366,6246),(151367,6246),(151368,6246),(151369,6246),(151370,6246),(151371,6247),(151372,6247),(151373,6247),(151374,6247),(151375,6247),(151376,6248),(151377,6248),(151378,6248),(151379,6248),(151380,6248),(151381,6249),(151382,6249),(151383,6249),(151384,6249),(151385,6249),(151386,6250),(151387,6250),(151388,6250),(151389,6250),(151390,6250),(151391,6251),(151392,6251),(151393,6251),(151394,6251),(151395,6251),(151396,6252),(151397,6252),(151398,6252),(151399,6252),(151400,6252),(151401,6253),(151402,6253),(151403,6253),(151404,6253),(151405,6253),(151406,6254),(151407,6254),(151408,6254),(151409,6254),(151410,6254),(151411,6255),(151412,6255),(151413,6255),(151414,6255),(151415,6255),(151416,6256),(151417,6256),(151418,6256),(151419,6256),(151420,6256),(151421,6257),(151422,6257),(151423,6257),(151424,6257),(151425,6257),(151426,6258),(151427,6258),(151428,6258),(151429,6258),(151430,6258),(151431,6259),(151432,6259),(151433,6259),(151434,6259),(151435,6259),(151436,6260),(151437,6260),(151438,6260),(151439,6260),(151440,6260),(151441,6261),(151442,6261),(151443,6261),(151444,6261),(151445,6261),(151446,6262),(151447,6262),(151448,6262),(151449,6262),(151450,6262),(151451,6263),(151452,6263),(151453,6263),(151454,6263),(151455,6263),(151456,6264),(151457,6264),(151458,6264),(151459,6264),(151460,6264),(151461,6265),(151462,6265),(151463,6265),(151464,6265),(151465,6265),(151466,6266),(151467,6266),(151468,6266),(151469,6266),(151470,6266),(151471,6267),(151472,6267),(151473,6267),(151474,6267),(151475,6267),(151476,6268),(151477,6268),(151478,6268),(151479,6268),(151480,6268),(151481,6269),(151482,6269),(151483,6269),(151484,6269),(151485,6269),(151486,6270),(151487,6270),(151488,6270),(151489,6270),(151490,6270),(151491,6271),(151492,6271),(151493,6271),(151494,6271),(151495,6271),(151496,6272),(151497,6272),(151498,6272),(151499,6272),(151500,6272),(151501,6273),(151502,6273),(151503,6273),(151504,6273),(151505,6273),(151506,6274),(151507,6274),(151508,6274),(151509,6274),(151510,6274),(151511,6275),(151512,6275),(151513,6275),(151514,6275),(151515,6275),(151516,6276),(151517,6276),(151518,6276),(151519,6276),(151520,6276),(151521,6277),(151522,6277),(151523,6277),(151524,6277),(151525,6277),(151526,6278),(151527,6278),(151528,6278),(151529,6278),(151530,6278),(151531,6279),(151532,6279),(151533,6279),(151534,6279),(151535,6279),(151536,6280),(151537,6280),(151538,6280),(151539,6280),(151540,6280),(151541,6281),(151542,6281),(151543,6281),(151544,6281),(151545,6281),(151546,6282),(151547,6282),(151548,6282),(151549,6282),(151550,6282),(151551,6283),(151552,6283),(151553,6283),(151554,6283),(151555,6283),(151556,6284),(151557,6284),(151558,6284),(151559,6284),(151560,6284),(151561,6285),(151562,6285),(151563,6285),(151564,6285),(151565,6285),(151566,6286),(151567,6286),(151568,6286),(151569,6286),(151570,6286),(151571,6287),(151572,6287),(151573,6287),(151574,6287),(151575,6287),(151576,6288),(151577,6288),(151578,6288),(151579,6288),(151580,6288),(151581,6289),(151582,6289),(151583,6289),(151584,6289),(151585,6289),(151586,6290),(151587,6290),(151588,6290),(151589,6290),(151590,6290),(151591,6291),(151592,6291),(151593,6291),(151594,6291),(151595,6291),(151596,6292),(151597,6292),(151598,6292),(151599,6292),(151600,6292),(151601,6293),(151602,6293),(151603,6293),(151604,6293),(151605,6293),(151606,6294),(151607,6294),(151608,6294),(151609,6294),(151610,6294),(151611,6295),(151612,6295),(151613,6295),(151614,6295),(151615,6295),(151616,6296),(151617,6296),(151618,6296),(151619,6296),(151620,6296),(151621,6297),(151622,6297),(151623,6297),(151624,6297),(151625,6297),(151626,6298),(151627,6298),(151628,6298),(151629,6298),(151630,6298),(151631,6299),(151632,6299),(151633,6299),(151634,6299),(151635,6299),(151636,6300),(151637,6300),(151638,6300),(151639,6300),(151640,6300),(151641,6301),(151642,6301),(151643,6301),(151644,6301),(151645,6301),(151646,6302),(151647,6302),(151648,6302),(151649,6302),(151650,6302),(151651,6303),(151652,6303),(151653,6303),(151654,6303),(151655,6303),(151656,6304),(151657,6304),(151658,6304),(151659,6304),(151660,6304),(151661,6305),(151662,6305),(151663,6305),(151664,6305),(151665,6305),(151666,6306),(151667,6306),(151668,6306),(151669,6306),(151670,6306),(151671,6307),(151672,6307),(151673,6307),(151674,6307),(151675,6307),(151676,6308),(151677,6308),(151678,6308),(151679,6308),(151680,6308),(151681,6309),(151682,6309),(151683,6309),(151684,6309),(151685,6309),(151686,6310),(151687,6310),(151688,6310),(151689,6310),(151690,6310),(151691,6311),(151692,6311),(151693,6311),(151694,6311),(151695,6311),(151696,6312),(151697,6312),(151698,6312),(151699,6312),(151700,6312),(151701,6313),(151702,6313),(151703,6313),(151704,6313),(151705,6313),(151706,6314),(151707,6314),(151708,6314),(151709,6314),(151710,6314),(151711,6315),(151712,6315),(151713,6315),(151714,6315),(151715,6315),(151716,6316),(151717,6316),(151718,6316),(151719,6316),(151720,6316),(151721,6317),(151722,6317),(151723,6317),(151724,6317),(151725,6317),(151726,6318),(151727,6318),(151728,6318),(151729,6318),(151730,6318),(151731,6319),(151732,6319),(151733,6319),(151734,6319),(151735,6319),(151736,6320),(151737,6320),(151738,6320),(151739,6320),(151740,6320),(151741,6321),(151742,6321),(151743,6321),(151744,6321),(151745,6321),(151746,6322),(151747,6322),(151748,6322),(151749,6322),(151750,6322),(151751,6323),(151752,6323),(151753,6323),(151754,6323),(151755,6323),(151756,6324),(151757,6324),(151758,6324),(151759,6324),(151760,6324),(151761,6325),(151762,6325),(151763,6325),(151764,6325),(151765,6325),(151766,6326),(151767,6326),(151768,6326),(151769,6326),(151770,6326),(151771,6327),(151772,6327),(151773,6327),(151774,6327),(151775,6327),(151776,6328),(151777,6328),(151778,6328),(151779,6328),(151780,6328),(151781,6329),(151782,6329),(151783,6329),(151784,6329),(151785,6329),(151786,6330),(151787,6330),(151788,6330),(151789,6330),(151790,6330),(151791,6331),(151792,6331),(151793,6331),(151794,6331),(151795,6331),(151796,6332),(151797,6332),(151798,6332),(151799,6332),(151800,6332),(151801,6333),(151802,6333),(151803,6333),(151804,6333),(151805,6333),(151806,6334),(151807,6334),(151808,6334),(151809,6334),(151810,6334),(151811,6335),(151812,6336),(151813,6337),(151814,6338),(151815,6339),(151816,6340),(151817,6341),(151818,6342),(151819,6343),(151820,6344),(151821,6345),(151822,6335),(151823,6336),(151824,6337),(151825,6338),(151826,6339),(151827,6340),(151828,6341),(151829,6342),(151830,6343),(151831,6344),(151832,6345),(151833,6335),(151834,6335),(151835,6335),(151836,6336),(151837,6336),(151838,6336),(151839,6337),(151840,6337),(151841,6337),(151842,6338),(151843,6338),(151844,6338),(151845,6339),(151846,6339),(151847,6339),(151848,6340),(151849,6340),(151850,6340),(151851,6341),(151852,6341),(151853,6341),(151854,6342),(151855,6342),(151856,6342),(151857,6343),(151858,6343),(151859,6343),(151860,6344),(151861,6344),(151862,6344),(151863,6345),(151864,6345),(151865,6345),(151866,6335),(151867,6335),(151868,6335),(151869,6335),(151870,6335),(151871,6335),(151872,6335),(151873,6335),(151874,6335),(151875,6335),(151876,6336),(151877,6336),(151878,6336),(151879,6336),(151880,6336),(151881,6336),(151882,6336),(151883,6336),(151884,6336),(151885,6336),(151886,6337),(151887,6337),(151888,6337),(151889,6337),(151890,6337),(151891,6337),(151892,6337),(151893,6337),(151894,6337),(151895,6337),(151896,6338),(151897,6338),(151898,6338),(151899,6338),(151900,6338),(151901,6338),(151902,6338),(151903,6338),(151904,6338),(151905,6338),(151906,6339),(151907,6339),(151908,6339),(151909,6339),(151910,6339),(151911,6339),(151912,6339),(151913,6339),(151914,6339),(151915,6339),(151916,6340),(151917,6340),(151918,6340),(151919,6340),(151920,6340),(151921,6340),(151922,6340),(151923,6340),(151924,6340),(151925,6340),(151926,6341),(151927,6341),(151928,6341),(151929,6341),(151930,6341),(151931,6341),(151932,6341),(151933,6341),(151934,6341),(151935,6341),(151936,6342),(151937,6342),(151938,6342),(151939,6342),(151940,6342),(151941,6342),(151942,6342),(151943,6342),(151944,6342),(151945,6342),(151946,6343),(151947,6343),(151948,6343),(151949,6343),(151950,6343),(151951,6343),(151952,6343),(151953,6343),(151954,6343),(151955,6343),(151956,6344),(151957,6344),(151958,6344),(151959,6344),(151960,6344),(151961,6344),(151962,6344),(151963,6344),(151964,6344),(151965,6344),(151966,6345),(151967,6345),(151968,6345),(151969,6345),(151970,6345),(151971,6345),(151972,6345),(151973,6345),(151974,6345),(151975,6345),(151976,6335),(151977,6335),(151978,6335),(151979,6335),(151980,6335),(151981,6336),(151982,6336),(151983,6336),(151984,6336),(151985,6336),(151986,6337),(151987,6337),(151988,6337),(151989,6337),(151990,6337),(151991,6338),(151992,6338),(151993,6338),(151994,6339),(151995,6339),(151996,6339),(151997,6339),(151998,6339),(151999,6340),(152000,6340),(152001,6340),(152002,6340),(152003,6340),(152004,6341),(152005,6341),(152006,6341),(152007,6341),(152008,6341),(152009,6342),(152010,6342),(152011,6342),(152012,6342),(152013,6342),(152014,6343),(152015,6343),(152016,6343),(152017,6343),(152018,6343),(152019,6344),(152020,6344),(152021,6344),(152022,6344),(152023,6344),(152024,6345),(152025,6345),(152026,6345),(152027,6335),(152028,6335),(152029,6335),(152030,6335),(152031,6335),(152032,6336),(152033,6336),(152034,6336),(152035,6336),(152036,6336),(152037,6337),(152038,6337),(152039,6337),(152040,6337),(152041,6337),(152042,6338),(152043,6338),(152044,6338),(152045,6338),(152046,6338),(152047,6339),(152048,6339),(152049,6339),(152050,6339),(152051,6339),(152052,6340),(152053,6340),(152054,6340),(152055,6340),(152056,6340),(152057,6341),(152058,6341),(152059,6341),(152060,6341),(152061,6341),(152062,6342),(152063,6342),(152064,6342),(152065,6342),(152066,6342),(152067,6343),(152068,6343),(152069,6343),(152070,6343),(152071,6343),(152072,6344),(152073,6344),(152074,6344),(152075,6344),(152076,6344),(152077,6345),(152078,6345),(152079,6345),(152080,6345),(152081,6345),(152082,6035),(152083,6035),(152084,6035),(152085,6035),(152086,6035),(152087,6035),(152088,6035),(152089,6035),(152090,6035),(152091,6035),(152092,6035),(152093,6035),(152094,6035),(152095,6035),(152096,6035),(152097,6035),(152098,6035),(152099,6035),(152100,6035),(152101,6035),(152102,6035),(152103,6035),(152104,6035),(152105,6035),(152106,6035),(152107,6035),(152108,6035),(152109,6035),(152110,6035),(152111,6035),(152112,6035),(152113,6035),(152114,6035),(152115,6035),(152116,6035),(152117,6035),(152118,6035),(152119,6035),(152120,6035),(152121,6035),(152122,6035),(152123,6035),(152124,6035),(152125,6035),(152126,5760),(152127,6326),(152128,6327),(152129,6328),(152130,6329),(152131,6330),(152132,6331),(152133,6332),(152134,6333),(152135,6334),(152136,6335),(152137,6336),(152138,6337),(152139,6338),(152140,6339),(152141,6340),(152142,6341),(152143,6342),(152144,6343),(152145,6344),(152146,6345),(152147,6036),(152148,6036),(152149,6036),(152150,6036),(152151,6036),(152152,6036),(152153,6036),(152154,6036),(152155,6036),(152156,6036),(152157,6036),(152158,6036),(152159,6036),(152160,6036),(152161,6036),(152162,6036),(152163,6036),(152164,6036),(152165,6036),(152166,6036),(152167,6036),(152168,6036),(152169,6036),(152170,6036),(152171,6036),(152172,6036),(152173,6036),(152174,6036),(152175,6036),(152176,5760),(152177,6035),(152178,6293),(152179,6299),(152180,6310),(152181,6311),(152182,6332),(152183,6333),(152184,6334),(152185,6335),(152186,6336),(152187,6337),(152188,5760),(152189,6035),(152190,6036),(152191,6037),(152192,6038),(152193,6039),(152194,6040),(152195,6041),(152196,6042),(152197,6043),(152198,6044),(152199,6045),(152200,6046),(152201,6047),(152202,6048),(152203,6049),(152204,6050),(152205,6051),(152206,6052),(152207,6053),(152208,5760),(152209,6035),(152210,6036),(152211,6037),(152212,6038),(152213,6039),(152214,6040),(152215,6041),(152216,6042),(152217,6043),(152218,6044),(152219,6045),(152220,6046),(152221,6047),(152222,6048),(152223,6049),(152224,6050),(152225,6051),(152226,6052),(152227,6053),(152228,5760),(152229,6035),(152230,6036),(152231,6037),(152232,6038),(152233,6039),(152234,6040),(152235,6041),(152236,6042),(152237,6043),(152238,6044),(152239,6045),(152240,6046),(152241,6047),(152242,6048),(152243,6049),(152244,6050),(152245,6051),(152246,6052),(152247,6053),(152248,5760),(152249,6035),(152250,6036),(152251,6037),(152252,6038),(152253,6039),(152254,6040),(152255,6041),(152256,6042),(152257,6043),(152258,6044),(152259,6045),(152260,6046),(152261,6047),(152262,6048),(152263,6049),(152264,6050),(152265,6051),(152266,6052),(152267,6053),(152268,5760),(152269,6035),(152270,6036),(152271,6037),(152272,6038),(152273,6039),(152274,6040),(152275,6041),(152276,6042),(152277,6043),(152278,6044),(152279,6045),(152280,6046),(152281,6047),(152282,6048),(152283,6049),(152284,6050),(152285,6051),(152286,6052),(152287,6053),(152288,6035),(152289,6035),(152290,6035),(152291,6035),(152292,6035),(152293,6035),(152294,6036),(152295,6037),(152296,6038),(152297,6039),(152298,6040),(152299,6346),(152300,6347),(152301,6348),(152302,6349),(152303,6350),(152304,6351),(152305,6352),(152306,6353),(152307,6354),(152308,6355),(152309,6356),(152310,6346),(152311,6347),(152312,6348),(152313,6349),(152314,6350),(152315,6351),(152316,6352),(152317,6353),(152318,6354),(152319,6355),(152320,6356),(152321,6346),(152322,6346),(152323,6346),(152324,6347),(152325,6347),(152326,6347),(152327,6348),(152328,6348),(152329,6348),(152330,6349),(152331,6349),(152332,6349),(152333,6350),(152334,6350),(152335,6350),(152336,6351),(152337,6351),(152338,6351),(152339,6352),(152340,6352),(152341,6352),(152342,6353),(152343,6353),(152344,6353),(152345,6354),(152346,6354),(152347,6354),(152348,6355),(152349,6355),(152350,6355),(152351,6356),(152352,6356),(152353,6356),(152354,6346),(152355,6346),(152356,6346),(152357,6346),(152358,6346),(152359,6346),(152360,6346),(152361,6346),(152362,6346),(152363,6346),(152364,6347),(152365,6347),(152366,6347),(152367,6347),(152368,6347),(152369,6347),(152370,6347),(152371,6347),(152372,6347),(152373,6347),(152374,6348),(152375,6348),(152376,6348),(152377,6348),(152378,6348),(152379,6348),(152380,6348),(152381,6348),(152382,6348),(152383,6348),(152384,6349),(152385,6349),(152386,6349),(152387,6349),(152388,6349),(152389,6349),(152390,6349),(152391,6349),(152392,6349),(152393,6349),(152394,6350),(152395,6350),(152396,6350),(152397,6350),(152398,6350),(152399,6350),(152400,6350),(152401,6350),(152402,6350),(152403,6350),(152404,6351),(152405,6351),(152406,6351),(152407,6351),(152408,6351),(152409,6351),(152410,6351),(152411,6351),(152412,6351),(152413,6351),(152414,6352),(152415,6352),(152416,6352),(152417,6352),(152418,6352),(152419,6352),(152420,6352),(152421,6352),(152422,6352),(152423,6352),(152424,6353),(152425,6353),(152426,6353),(152427,6353),(152428,6353),(152429,6353),(152430,6353),(152431,6353),(152432,6353),(152433,6353),(152434,6354),(152435,6354),(152436,6354),(152437,6354),(152438,6354),(152439,6354),(152440,6354),(152441,6354),(152442,6354),(152443,6354),(152444,6355),(152445,6355),(152446,6355),(152447,6355),(152448,6355),(152449,6355),(152450,6355),(152451,6355),(152452,6355),(152453,6355),(152454,6356),(152455,6356),(152456,6356),(152457,6356),(152458,6356),(152459,6356),(152460,6356),(152461,6356),(152462,6356),(152463,6356),(152464,6346),(152465,6346),(152466,6346),(152467,6346),(152468,6346),(152469,6347),(152470,6347),(152471,6347),(152472,6347),(152473,6347),(152474,6348),(152475,6348),(152476,6348),(152477,6348),(152478,6348),(152479,6349),(152480,6349),(152481,6349),(152482,6349),(152483,6349),(152484,6350),(152485,6350),(152486,6350),(152487,6350),(152488,6350),(152489,6351),(152490,6351),(152491,6351),(152492,6351),(152493,6351),(152494,6352),(152495,6352),(152496,6352),(152497,6352),(152498,6352),(152499,6353),(152500,6353),(152501,6353),(152502,6353),(152503,6353),(152504,6354),(152505,6354),(152506,6354),(152507,6354),(152508,6354),(152509,6355),(152510,6355),(152511,6355),(152512,6355),(152513,6355),(152514,6356),(152515,6356),(152516,6356),(152517,6356),(152518,6356),(152519,6346),(152520,6346),(152521,6346),(152522,6346),(152523,6346),(152524,6347),(152525,6347),(152526,6347),(152527,6347),(152528,6347),(152529,6348),(152530,6348),(152531,6348),(152532,6348),(152533,6348),(152534,6349),(152535,6349),(152536,6349),(152537,6349),(152538,6349),(152539,6350),(152540,6350),(152541,6350),(152542,6350),(152543,6350),(152544,6351),(152545,6351),(152546,6351),(152547,6351),(152548,6351),(152549,6352),(152550,6352),(152551,6352),(152552,6352),(152553,6352),(152554,6353),(152555,6353),(152556,6353),(152557,6353),(152558,6353),(152559,6354),(152560,6354),(152561,6354),(152562,6354),(152563,6354),(152564,6355),(152565,6355),(152566,6355),(152567,6355),(152568,6355),(152569,6356),(152570,6356),(152571,6356),(152572,6356),(152573,6356),(152574,6357),(152575,6358),(152576,6359),(152577,6360),(152578,6361),(152579,6362),(152580,6363),(152581,6364),(152582,6365),(152583,6366),(152584,6367),(152585,6368),(152586,6369),(152587,6370),(152588,6371),(152589,6372),(152590,6373),(152591,6374),(152592,6375),(152593,6376),(152594,6377),(152595,6378),(152596,6379),(152597,6380),(152598,6381),(152599,6382),(152600,6383),(152601,6384),(152602,6385),(152603,6386),(152604,6387),(152605,6388),(152606,6389),(152607,6390),(152608,6391),(152609,6392),(152610,6393),(152611,6394),(152612,6395),(152613,6396),(152614,6397),(152615,6398),(152616,6399),(152617,6400),(152618,6401),(152619,6402),(152620,6403),(152621,6404),(152622,6405),(152623,6406),(152624,6407),(152625,6408),(152626,6409),(152627,6410),(152628,6411),(152629,6412),(152630,6413),(152631,6414),(152632,6415),(152633,6416),(152634,6417),(152635,6418),(152636,6419),(152637,6420),(152638,6421),(152639,6422),(152640,6423),(152641,6424),(152642,6425),(152643,6426),(152644,6427),(152645,6428),(152646,6429),(152647,6430),(152648,6431),(152649,6432),(152650,6433),(152651,6434),(152652,6435),(152653,6436),(152654,6437),(152655,6438),(152656,6439),(152657,6440),(152658,6441),(152659,6442),(152660,6443),(152661,6444),(152662,6445),(152663,6357),(152664,6358),(152665,6359),(152666,6360),(152667,6361),(152668,6362),(152669,6363),(152670,6364),(152671,6365),(152672,6366),(152673,6367),(152674,6368),(152675,6369),(152676,6370),(152677,6371),(152678,6372),(152679,6373),(152680,6374),(152681,6375),(152682,6376),(152683,6377),(152684,6378),(152685,6379),(152686,6380),(152687,6381),(152688,6382),(152689,6383),(152690,6384),(152691,6385),(152692,6386),(152693,6387),(152694,6388),(152695,6389),(152696,6390),(152697,6391),(152698,6392),(152699,6393),(152700,6394),(152701,6395),(152702,6396),(152703,6397),(152704,6398),(152705,6399),(152706,6400),(152707,6401),(152708,6402),(152709,6403),(152710,6404),(152711,6405),(152712,6406),(152713,6407),(152714,6408),(152715,6409),(152716,6410),(152717,6411),(152718,6412),(152719,6413),(152720,6414),(152721,6415),(152722,6416),(152723,6417),(152724,6418),(152725,6419),(152726,6420),(152727,6421),(152728,6422),(152729,6423),(152730,6424),(152731,6425),(152732,6426),(152733,6427),(152734,6428),(152735,6429),(152736,6430),(152737,6431),(152738,6432),(152739,6433),(152740,6434),(152741,6435),(152742,6436),(152743,6437),(152744,6438),(152745,6439),(152746,6440),(152747,6441),(152748,6442),(152749,6443),(152750,6444),(152751,6445),(152752,6357),(152753,6357),(152754,6357),(152755,6358),(152756,6358),(152757,6358),(152758,6359),(152759,6359),(152760,6359),(152761,6360),(152762,6360),(152763,6360),(152764,6361),(152765,6361),(152766,6361),(152767,6362),(152768,6362),(152769,6362),(152770,6363),(152771,6363),(152772,6363),(152773,6364),(152774,6364),(152775,6364),(152776,6365),(152777,6365),(152778,6365),(152779,6366),(152780,6366),(152781,6366),(152782,6367),(152783,6367),(152784,6367),(152785,6368),(152786,6368),(152787,6368),(152788,6369),(152789,6369),(152790,6369),(152791,6370),(152792,6370),(152793,6370),(152794,6371),(152795,6371),(152796,6371),(152797,6372),(152798,6372),(152799,6372),(152800,6373),(152801,6373),(152802,6373),(152803,6374),(152804,6374),(152805,6374),(152806,6375),(152807,6375),(152808,6375),(152809,6376),(152810,6376),(152811,6376),(152812,6377),(152813,6377),(152814,6377),(152815,6378),(152816,6378),(152817,6378),(152818,6379),(152819,6379),(152820,6379),(152821,6380),(152822,6380),(152823,6380),(152824,6381),(152825,6381),(152826,6381),(152827,6382),(152828,6382),(152829,6382),(152830,6383),(152831,6383),(152832,6383),(152833,6384),(152834,6384),(152835,6384),(152836,6385),(152837,6385),(152838,6385),(152839,6386),(152840,6386),(152841,6386),(152842,6387),(152843,6387),(152844,6387),(152845,6388),(152846,6388),(152847,6388),(152848,6389),(152849,6389),(152850,6389),(152851,6390),(152852,6390),(152853,6390),(152854,6391),(152855,6391),(152856,6391),(152857,6392),(152858,6392),(152859,6392),(152860,6393),(152861,6393),(152862,6393),(152863,6394),(152864,6394),(152865,6394),(152866,6395),(152867,6395),(152868,6395),(152869,6396),(152870,6396),(152871,6396),(152872,6397),(152873,6397),(152874,6397),(152875,6398),(152876,6398),(152877,6398),(152878,6399),(152879,6399),(152880,6399),(152881,6400),(152882,6400),(152883,6400),(152884,6401),(152885,6401),(152886,6401),(152887,6402),(152888,6402),(152889,6402),(152890,6403),(152891,6404),(152892,6404),(152893,6404),(152894,6405),(152895,6405),(152896,6405),(152897,6406),(152898,6406),(152899,6406),(152900,6407),(152901,6407),(152902,6407),(152903,6408),(152904,6408),(152905,6408),(152906,6409),(152907,6409),(152908,6409),(152909,6410),(152910,6410),(152911,6410),(152912,6411),(152913,6411),(152914,6411),(152915,6412),(152916,6412),(152917,6412),(152918,6413),(152919,6413),(152920,6413),(152921,6414),(152922,6414),(152923,6414),(152924,6415),(152925,6415),(152926,6415),(152927,6416),(152928,6416),(152929,6416),(152930,6417),(152931,6417),(152932,6417),(152933,6418),(152934,6418),(152935,6418),(152936,6419),(152937,6419),(152938,6419),(152939,6420),(152940,6420),(152941,6420),(152942,6421),(152943,6421),(152944,6421),(152945,6422),(152946,6422),(152947,6422),(152948,6423),(152949,6423),(152950,6423),(152951,6424),(152952,6424),(152953,6424),(152954,6425),(152955,6425),(152956,6425),(152957,6426),(152958,6426),(152959,6426),(152960,6427),(152961,6427),(152962,6427),(152963,6428),(152964,6428),(152965,6428),(152966,6429),(152967,6429),(152968,6429),(152969,6430),(152970,6430),(152971,6430),(152972,6431),(152973,6431),(152974,6431),(152975,6432),(152976,6432),(152977,6432),(152978,6433),(152979,6433),(152980,6433),(152981,6434),(152982,6434),(152983,6434),(152984,6435),(152985,6435),(152986,6435),(152987,6436),(152988,6436),(152989,6436),(152990,6437),(152991,6437),(152992,6437),(152993,6438),(152994,6438),(152995,6438),(152996,6439),(152997,6439),(152998,6439),(152999,6440),(153000,6440),(153001,6440),(153002,6441),(153003,6441),(153004,6441),(153005,6442),(153006,6442),(153007,6442),(153008,6443),(153009,6443),(153010,6443),(153011,6444),(153012,6444),(153013,6444),(153014,6445),(153015,6445),(153016,6445),(153017,6357),(153018,6357),(153019,6357),(153020,6357),(153021,6357),(153022,6357),(153023,6357),(153024,6357),(153025,6357),(153026,6357),(153027,6358),(153028,6358),(153029,6358),(153030,6358),(153031,6358),(153032,6358),(153033,6358),(153034,6358),(153035,6358),(153036,6358),(153037,6359),(153038,6359),(153039,6359),(153040,6359),(153041,6359),(153042,6359),(153043,6359),(153044,6359),(153045,6359),(153046,6359),(153047,6360),(153048,6360),(153049,6360),(153050,6360),(153051,6360),(153052,6360),(153053,6360),(153054,6360),(153055,6360),(153056,6360),(153057,6361),(153058,6361),(153059,6361),(153060,6361),(153061,6361),(153062,6361),(153063,6361),(153064,6361),(153065,6361),(153066,6361),(153067,6362),(153068,6362),(153069,6362),(153070,6362),(153071,6362),(153072,6362),(153073,6362),(153074,6362),(153075,6362),(153076,6362),(153077,6363),(153078,6363),(153079,6363),(153080,6363),(153081,6363),(153082,6363),(153083,6363),(153084,6363),(153085,6363),(153086,6363),(153087,6364),(153088,6364),(153089,6364),(153090,6364),(153091,6364),(153092,6364),(153093,6364),(153094,6364),(153095,6364),(153096,6364),(153097,6365),(153098,6365),(153099,6365),(153100,6365),(153101,6365),(153102,6365),(153103,6365),(153104,6365),(153105,6365),(153106,6365),(153107,6366),(153108,6366),(153109,6366),(153110,6366),(153111,6366),(153112,6366),(153113,6366),(153114,6366),(153115,6366),(153116,6366),(153117,6367),(153118,6367),(153119,6367),(153120,6367),(153121,6367),(153122,6367),(153123,6367),(153124,6367),(153125,6367),(153126,6367),(153127,6368),(153128,6368),(153129,6368),(153130,6368),(153131,6368),(153132,6368),(153133,6368),(153134,6368),(153135,6368),(153136,6368),(153137,6369),(153138,6369),(153139,6369),(153140,6369),(153141,6369),(153142,6369),(153143,6369),(153144,6369),(153145,6369),(153146,6369),(153147,6370),(153148,6370),(153149,6370),(153150,6370),(153151,6370),(153152,6370),(153153,6370),(153154,6370),(153155,6370),(153156,6370),(153157,6371),(153158,6371),(153159,6371),(153160,6371),(153161,6371),(153162,6371),(153163,6371),(153164,6371),(153165,6371),(153166,6371),(153167,6372),(153168,6372),(153169,6372),(153170,6372),(153171,6372),(153172,6372),(153173,6372),(153174,6372),(153175,6372),(153176,6372),(153177,6373),(153178,6373),(153179,6373),(153180,6373),(153181,6373),(153182,6373),(153183,6373),(153184,6373),(153185,6373),(153186,6373),(153187,6374),(153188,6374),(153189,6374),(153190,6374),(153191,6374),(153192,6374),(153193,6374),(153194,6374),(153195,6374),(153196,6374),(153197,6375),(153198,6375),(153199,6375),(153200,6375),(153201,6375),(153202,6375),(153203,6375),(153204,6375),(153205,6375),(153206,6375),(153207,6376),(153208,6376),(153209,6376),(153210,6376),(153211,6376),(153212,6376),(153213,6376),(153214,6376),(153215,6376),(153216,6376),(153217,6377),(153218,6377),(153219,6377),(153220,6377),(153221,6377),(153222,6377),(153223,6377),(153224,6377),(153225,6377),(153226,6377),(153227,6378),(153228,6378),(153229,6378),(153230,6378),(153231,6378),(153232,6378),(153233,6378),(153234,6378),(153235,6378),(153236,6378),(153237,6379),(153238,6379),(153239,6379),(153240,6379),(153241,6379),(153242,6379),(153243,6379),(153244,6379),(153245,6379),(153246,6379),(153247,6380),(153248,6380),(153249,6380),(153250,6380),(153251,6380),(153252,6380),(153253,6380),(153254,6380),(153255,6380),(153256,6380),(153257,6381),(153258,6381),(153259,6381),(153260,6381),(153261,6381),(153262,6381),(153263,6381),(153264,6381),(153265,6381),(153266,6381),(153267,6382),(153268,6382),(153269,6382),(153270,6382),(153271,6382),(153272,6382),(153273,6382),(153274,6382),(153275,6382),(153276,6382),(153277,6383),(153278,6383),(153279,6383),(153280,6383),(153281,6383),(153282,6383),(153283,6383),(153284,6383),(153285,6383),(153286,6383),(153287,6384),(153288,6384),(153289,6384),(153290,6384),(153291,6384),(153292,6384),(153293,6384),(153294,6384),(153295,6384),(153296,6384),(153297,6385),(153298,6385),(153299,6385),(153300,6385),(153301,6385),(153302,6385),(153303,6385),(153304,6385),(153305,6385),(153306,6385),(153307,6386),(153308,6386),(153309,6386),(153310,6386),(153311,6386),(153312,6386),(153313,6386),(153314,6386),(153315,6386),(153316,6386),(153317,6387),(153318,6387),(153319,6387),(153320,6387),(153321,6387),(153322,6387),(153323,6387),(153324,6387),(153325,6387),(153326,6387),(153327,6388),(153328,6388),(153329,6388),(153330,6388),(153331,6388),(153332,6388),(153333,6388),(153334,6388),(153335,6388),(153336,6388),(153337,6389),(153338,6389),(153339,6389),(153340,6389),(153341,6389),(153342,6389),(153343,6389),(153344,6389),(153345,6389),(153346,6389),(153347,6390),(153348,6390),(153349,6390),(153350,6390),(153351,6390),(153352,6390),(153353,6390),(153354,6390),(153355,6390),(153356,6390),(153357,6391),(153358,6391),(153359,6391),(153360,6391),(153361,6391),(153362,6391),(153363,6391),(153364,6391),(153365,6391),(153366,6391),(153367,6392),(153368,6392),(153369,6392),(153370,6392),(153371,6392),(153372,6392),(153373,6392),(153374,6392),(153375,6392),(153376,6392),(153377,6393),(153378,6393),(153379,6393),(153380,6393),(153381,6393),(153382,6393),(153383,6393),(153384,6393),(153385,6393),(153386,6393),(153387,6394),(153388,6394),(153389,6394),(153390,6394),(153391,6394),(153392,6394),(153393,6394),(153394,6394),(153395,6394),(153396,6394),(153397,6395),(153398,6395),(153399,6395),(153400,6395),(153401,6395),(153402,6395),(153403,6395),(153404,6395),(153405,6395),(153406,6395),(153407,6396),(153408,6396),(153409,6396),(153410,6396),(153411,6396),(153412,6396),(153413,6396),(153414,6396),(153415,6396),(153416,6396),(153417,6396),(153418,6396),(153419,6396),(153420,6396),(153421,6397),(153422,6397),(153423,6397),(153424,6397),(153425,6397),(153426,6397),(153427,6397),(153428,6397),(153429,6397),(153430,6397),(153431,6398),(153432,6398),(153433,6398),(153434,6398),(153435,6398),(153436,6398),(153437,6398),(153438,6398),(153439,6398),(153440,6398),(153441,6399),(153442,6399),(153443,6399),(153444,6399),(153445,6399),(153446,6399),(153447,6399),(153448,6399),(153449,6399),(153450,6399),(153451,6400),(153452,6400),(153453,6400),(153454,6400),(153455,6400),(153456,6400),(153457,6400),(153458,6400),(153459,6400),(153460,6400),(153461,6401),(153462,6401),(153463,6401),(153464,6401),(153465,6401),(153466,6401),(153467,6401),(153468,6401),(153469,6401),(153470,6401),(153471,6402),(153472,6402),(153473,6402),(153474,6402),(153475,6402),(153476,6402),(153477,6402),(153478,6402),(153479,6402),(153480,6402),(153481,6403),(153482,6403),(153483,6403),(153484,6403),(153485,6403),(153486,6403),(153487,6403),(153488,6403),(153489,6404),(153490,6404),(153491,6404),(153492,6404),(153493,6404),(153494,6404),(153495,6404),(153496,6404),(153497,6404),(153498,6404),(153499,6405),(153500,6405),(153501,6405),(153502,6405),(153503,6405),(153504,6405),(153505,6405),(153506,6405),(153507,6405),(153508,6405),(153509,6406),(153510,6406),(153511,6406),(153512,6406),(153513,6406),(153514,6406),(153515,6406),(153516,6406),(153517,6406),(153518,6406),(153519,6407),(153520,6407),(153521,6407),(153522,6407),(153523,6407),(153524,6407),(153525,6407),(153526,6407),(153527,6407),(153528,6407),(153529,6408),(153530,6408),(153531,6408),(153532,6408),(153533,6408),(153534,6408),(153535,6408),(153536,6408),(153537,6408),(153538,6408),(153539,6409),(153540,6409),(153541,6409),(153542,6409),(153543,6409),(153544,6409),(153545,6409),(153546,6409),(153547,6409),(153548,6409),(153549,6410),(153550,6410),(153551,6410),(153552,6410),(153553,6410),(153554,6410),(153555,6410),(153556,6410),(153557,6410),(153558,6410),(153559,6411),(153560,6411),(153561,6411),(153562,6411),(153563,6411),(153564,6411),(153565,6411),(153566,6411),(153567,6411),(153568,6411),(153569,6412),(153570,6412),(153571,6412),(153572,6412),(153573,6412),(153574,6412),(153575,6412),(153576,6412),(153577,6412),(153578,6412),(153579,6413),(153580,6413),(153581,6413),(153582,6413),(153583,6413),(153584,6413),(153585,6413),(153586,6413),(153587,6413),(153588,6413),(153589,6414),(153590,6414),(153591,6414),(153592,6414),(153593,6414),(153594,6414),(153595,6414),(153596,6414),(153597,6414),(153598,6414),(153599,6415),(153600,6415),(153601,6415),(153602,6415),(153603,6415),(153604,6415),(153605,6415),(153606,6415),(153607,6415),(153608,6415),(153609,6416),(153610,6416),(153611,6416),(153612,6416),(153613,6416),(153614,6416),(153615,6416),(153616,6416),(153617,6416),(153618,6416),(153619,6417),(153620,6417),(153621,6417),(153622,6417),(153623,6417),(153624,6417),(153625,6417),(153626,6417),(153627,6417),(153628,6417),(153629,6418),(153630,6418),(153631,6418),(153632,6418),(153633,6418),(153634,6418),(153635,6418),(153636,6418),(153637,6418),(153638,6418),(153639,6419),(153640,6419),(153641,6419),(153642,6419),(153643,6419),(153644,6419),(153645,6419),(153646,6419),(153647,6419),(153648,6419),(153649,6420),(153650,6420),(153651,6420),(153652,6420),(153653,6420),(153654,6420),(153655,6420),(153656,6420),(153657,6420),(153658,6420),(153659,6421),(153660,6421),(153661,6421),(153662,6421),(153663,6421),(153664,6421),(153665,6421),(153666,6421),(153667,6421),(153668,6421),(153669,6422),(153670,6422),(153671,6422),(153672,6422),(153673,6422),(153674,6422),(153675,6422),(153676,6422),(153677,6422),(153678,6422),(153679,6423),(153680,6423),(153681,6423),(153682,6423),(153683,6423),(153684,6423),(153685,6423),(153686,6423),(153687,6423),(153688,6423),(153689,6424),(153690,6424),(153691,6424),(153692,6424),(153693,6424),(153694,6424),(153695,6424),(153696,6424),(153697,6424),(153698,6424),(153699,6425),(153700,6425),(153701,6425),(153702,6425),(153703,6425),(153704,6425),(153705,6425),(153706,6425),(153707,6425),(153708,6425),(153709,6426),(153710,6426),(153711,6426),(153712,6426),(153713,6426),(153714,6426),(153715,6426),(153716,6426),(153717,6426),(153718,6426),(153719,6427),(153720,6427),(153721,6427),(153722,6427),(153723,6427),(153724,6427),(153725,6427),(153726,6427),(153727,6427),(153728,6427),(153729,6428),(153730,6428),(153731,6428),(153732,6428),(153733,6428),(153734,6428),(153735,6428),(153736,6428),(153737,6428),(153738,6428),(153739,6429),(153740,6429),(153741,6429),(153742,6429),(153743,6429),(153744,6429),(153745,6429),(153746,6429),(153747,6429),(153748,6429),(153749,6430),(153750,6430),(153751,6430),(153752,6430),(153753,6430),(153754,6430),(153755,6430),(153756,6430),(153757,6430),(153758,6430),(153759,6431),(153760,6431),(153761,6431),(153762,6431),(153763,6431),(153764,6431),(153765,6431),(153766,6431),(153767,6431),(153768,6431),(153769,6431),(153770,6431),(153771,6431),(153772,6431),(153773,6432),(153774,6432),(153775,6432),(153776,6432),(153777,6432),(153778,6432),(153779,6432),(153780,6432),(153781,6432),(153782,6432),(153783,6433),(153784,6433),(153785,6433),(153786,6433),(153787,6433),(153788,6433),(153789,6433),(153790,6433),(153791,6433),(153792,6433),(153793,6434),(153794,6434),(153795,6434),(153796,6434),(153797,6434),(153798,6434),(153799,6434),(153800,6434),(153801,6434),(153802,6434),(153803,6435),(153804,6435),(153805,6435),(153806,6435),(153807,6435),(153808,6435),(153809,6435),(153810,6435),(153811,6435),(153812,6435),(153813,6436),(153814,6436),(153815,6436),(153816,6436),(153817,6436),(153818,6436),(153819,6436),(153820,6436),(153821,6436),(153822,6436),(153823,6437),(153824,6437),(153825,6437),(153826,6437),(153827,6437),(153828,6437),(153829,6437),(153830,6437),(153831,6437),(153832,6437),(153833,6437),(153834,6437),(153835,6437),(153836,6437),(153837,6438),(153838,6438),(153839,6438),(153840,6438),(153841,6438),(153842,6438),(153843,6438),(153844,6438),(153845,6438),(153846,6438),(153847,6439),(153848,6439),(153849,6439),(153850,6439),(153851,6439),(153852,6439),(153853,6439),(153854,6439),(153855,6439),(153856,6439),(153857,6440),(153858,6440),(153859,6440),(153860,6440),(153861,6440),(153862,6440),(153863,6440),(153864,6440),(153865,6440),(153866,6440),(153867,6440),(153868,6440),(153869,6440),(153870,6440),(153871,6441),(153872,6441),(153873,6441),(153874,6441),(153875,6441),(153876,6441),(153877,6441),(153878,6441),(153879,6441),(153880,6441),(153881,6441),(153882,6441),(153883,6441),(153884,6441),(153885,6442),(153886,6442),(153887,6442),(153888,6442),(153889,6442),(153890,6442),(153891,6442),(153892,6442),(153893,6442),(153894,6442),(153895,6442),(153896,6442),(153897,6442),(153898,6442),(153899,6443),(153900,6443),(153901,6443),(153902,6443),(153903,6443),(153904,6443),(153905,6443),(153906,6443),(153907,6443),(153908,6443),(153909,6444),(153910,6444),(153911,6444),(153912,6444),(153913,6444),(153914,6444),(153915,6444),(153916,6444),(153917,6444),(153918,6444),(153919,6444),(153920,6444),(153921,6444),(153922,6444),(153923,6445),(153924,6445),(153925,6445),(153926,6445),(153927,6445),(153928,6445),(153929,6445),(153930,6445),(153931,6445),(153932,6445),(153933,6445),(153934,6445),(153935,6445),(153936,6445),(153937,6357),(153938,6357),(153939,6357),(153940,6357),(153941,6357),(153942,6358),(153943,6358),(153944,6358),(153945,6358),(153946,6358),(153947,6359),(153948,6359),(153949,6359),(153950,6359),(153951,6359),(153952,6360),(153953,6360),(153954,6360),(153955,6360),(153956,6360),(153957,6361),(153958,6361),(153959,6361),(153960,6361),(153961,6361),(153962,6362),(153963,6362),(153964,6362),(153965,6362),(153966,6362),(153967,6363),(153968,6363),(153969,6363),(153970,6363),(153971,6363),(153972,6364),(153973,6364),(153974,6364),(153975,6364),(153976,6364),(153977,6365),(153978,6365),(153979,6365),(153980,6365),(153981,6365),(153982,6366),(153983,6366),(153984,6366),(153985,6366),(153986,6366),(153987,6367),(153988,6367),(153989,6367),(153990,6367),(153991,6367),(153992,6368),(153993,6368),(153994,6368),(153995,6368),(153996,6368),(153997,6369),(153998,6369),(153999,6369),(154000,6369),(154001,6369),(154002,6370),(154003,6370),(154004,6370),(154005,6370),(154006,6370),(154007,6371),(154008,6371),(154009,6371),(154010,6371),(154011,6371),(154012,6372),(154013,6372),(154014,6372),(154015,6372),(154016,6372),(154017,6373),(154018,6373),(154019,6373),(154020,6373),(154021,6373),(154022,6374),(154023,6374),(154024,6374),(154025,6374),(154026,6374),(154027,6375),(154028,6375),(154029,6375),(154030,6375),(154031,6375),(154032,6376),(154033,6376),(154034,6376),(154035,6376),(154036,6376),(154037,6377),(154038,6377),(154039,6377),(154040,6377),(154041,6377),(154042,6378),(154043,6378),(154044,6378),(154045,6378),(154046,6378),(154047,6379),(154048,6379),(154049,6379),(154050,6379),(154051,6379),(154052,6380),(154053,6380),(154054,6380),(154055,6380),(154056,6380),(154057,6381),(154058,6381),(154059,6381),(154060,6381),(154061,6381),(154062,6382),(154063,6382),(154064,6382),(154065,6382),(154066,6382),(154067,6383),(154068,6383),(154069,6383),(154070,6383),(154071,6383),(154072,6384),(154073,6384),(154074,6384),(154075,6384),(154076,6384),(154077,6384),(154078,6384),(154079,6385),(154080,6385),(154081,6385),(154082,6385),(154083,6385),(154084,6385),(154085,6385),(154086,6386),(154087,6386),(154088,6386),(154089,6386),(154090,6386),(154091,6386),(154092,6386),(154093,6387),(154094,6387),(154095,6387),(154096,6387),(154097,6387),(154098,6387),(154099,6387),(154100,6388),(154101,6388),(154102,6388),(154103,6388),(154104,6388),(154105,6389),(154106,6389),(154107,6389),(154108,6389),(154109,6389),(154110,6390),(154111,6390),(154112,6390),(154113,6390),(154114,6390),(154115,6391),(154116,6391),(154117,6391),(154118,6391),(154119,6391),(154120,6392),(154121,6392),(154122,6392),(154123,6392),(154124,6392),(154125,6392),(154126,6392),(154127,6393),(154128,6393),(154129,6393),(154130,6393),(154131,6393),(154132,6393),(154133,6393),(154134,6394),(154135,6394),(154136,6394),(154137,6394),(154138,6394),(154139,6394),(154140,6394),(154141,6395),(154142,6395),(154143,6395),(154144,6395),(154145,6395),(154146,6395),(154147,6395),(154148,6396),(154149,6396),(154150,6396),(154151,6396),(154152,6396),(154153,6396),(154154,6396),(154155,6397),(154156,6397),(154157,6397),(154158,6397),(154159,6397),(154160,6397),(154161,6397),(154162,6398),(154163,6398),(154164,6398),(154165,6398),(154166,6398),(154167,6398),(154168,6398),(154169,6399),(154170,6399),(154171,6399),(154172,6399),(154173,6399),(154174,6399),(154175,6399),(154176,6400),(154177,6400),(154178,6400),(154179,6400),(154180,6400),(154181,6400),(154182,6400),(154183,6401),(154184,6401),(154185,6401),(154186,6401),(154187,6401),(154188,6401),(154189,6401),(154190,6402),(154191,6402),(154192,6402),(154193,6402),(154194,6402),(154195,6402),(154196,6402),(154197,6403),(154198,6403),(154199,6403),(154200,6403),(154201,6404),(154202,6404),(154203,6404),(154204,6404),(154205,6404),(154206,6405),(154207,6405),(154208,6405),(154209,6405),(154210,6405),(154211,6405),(154212,6405),(154213,6406),(154214,6406),(154215,6406),(154216,6406),(154217,6406),(154218,6406),(154219,6406),(154220,6407),(154221,6407),(154222,6407),(154223,6407),(154224,6407),(154225,6407),(154226,6407),(154227,6408),(154228,6408),(154229,6408),(154230,6408),(154231,6408),(154232,6408),(154233,6408),(154234,6409),(154235,6409),(154236,6409),(154237,6409),(154238,6409),(154239,6409),(154240,6409),(154241,6410),(154242,6410),(154243,6410),(154244,6410),(154245,6410),(154246,6410),(154247,6410),(154248,6411),(154249,6411),(154250,6411),(154251,6411),(154252,6411),(154253,6411),(154254,6411),(154255,6412),(154256,6412),(154257,6412),(154258,6412),(154259,6412),(154260,6412),(154261,6412),(154262,6413),(154263,6413),(154264,6413),(154265,6413),(154266,6413),(154267,6413),(154268,6413),(154269,6414),(154270,6414),(154271,6414),(154272,6414),(154273,6414),(154274,6414),(154275,6414),(154276,6415),(154277,6415),(154278,6415),(154279,6415),(154280,6415),(154281,6415),(154282,6415),(154283,6416),(154284,6416),(154285,6416),(154286,6416),(154287,6416),(154288,6416),(154289,6416),(154290,6417),(154291,6417),(154292,6417),(154293,6417),(154294,6417),(154295,6417),(154296,6417),(154297,6418),(154298,6418),(154299,6418),(154300,6418),(154301,6418),(154302,6418),(154303,6418),(154304,6419),(154305,6419),(154306,6419),(154307,6419),(154308,6419),(154309,6419),(154310,6419),(154311,6420),(154312,6420),(154313,6420),(154314,6420),(154315,6420),(154316,6420),(154317,6420),(154318,6421),(154319,6421),(154320,6421),(154321,6421),(154322,6421),(154323,6421),(154324,6421),(154325,6422),(154326,6422),(154327,6422),(154328,6422),(154329,6422),(154330,6422),(154331,6422),(154332,6423),(154333,6423),(154334,6423),(154335,6423),(154336,6423),(154337,6423),(154338,6423),(154339,6424),(154340,6424),(154341,6424),(154342,6424),(154343,6424),(154344,6424),(154345,6424),(154346,6425),(154347,6425),(154348,6425),(154349,6425),(154350,6425),(154351,6425),(154352,6425),(154353,6426),(154354,6426),(154355,6426),(154356,6426),(154357,6426),(154358,6426),(154359,6426),(154360,6427),(154361,6427),(154362,6427),(154363,6427),(154364,6427),(154365,6427),(154366,6427),(154367,6428),(154368,6428),(154369,6428),(154370,6428),(154371,6428),(154372,6428),(154373,6428),(154374,6429),(154375,6429),(154376,6429),(154377,6429),(154378,6429),(154379,6429),(154380,6429),(154381,6430),(154382,6430),(154383,6430),(154384,6430),(154385,6430),(154386,6430),(154387,6430),(154388,6431),(154389,6431),(154390,6431),(154391,6431),(154392,6431),(154393,6431),(154394,6431),(154395,6432),(154396,6432),(154397,6432),(154398,6432),(154399,6432),(154400,6432),(154401,6432),(154402,6433),(154403,6433),(154404,6433),(154405,6433),(154406,6433),(154407,6433),(154408,6433),(154409,6434),(154410,6434),(154411,6434),(154412,6434),(154413,6434),(154414,6434),(154415,6434),(154416,6435),(154417,6435),(154418,6435),(154419,6435),(154420,6435),(154421,6435),(154422,6435),(154423,6436),(154424,6436),(154425,6436),(154426,6436),(154427,6436),(154428,6436),(154429,6436),(154430,6437),(154431,6437),(154432,6437),(154433,6437),(154434,6437),(154435,6437),(154436,6437),(154437,6438),(154438,6438),(154439,6438),(154440,6438),(154441,6438),(154442,6438),(154443,6438),(154444,6439),(154445,6439),(154446,6439),(154447,6439),(154448,6439),(154449,6439),(154450,6439),(154451,6440),(154452,6440),(154453,6440),(154454,6440),(154455,6440),(154456,6440),(154457,6440),(154458,6441),(154459,6441),(154460,6441),(154461,6441),(154462,6441),(154463,6441),(154464,6441),(154465,6442),(154466,6442),(154467,6442),(154468,6442),(154469,6442),(154470,6442),(154471,6442),(154472,6443),(154473,6443),(154474,6443),(154475,6443),(154476,6443),(154477,6443),(154478,6443),(154479,6444),(154480,6444),(154481,6444),(154482,6444),(154483,6444),(154484,6444),(154485,6444),(154486,6445),(154487,6445),(154488,6445),(154489,6445),(154490,6445),(154491,6445),(154492,6445),(154493,6357),(154494,6357),(154495,6357),(154496,6357),(154497,6357),(154498,6358),(154499,6358),(154500,6358),(154501,6358),(154502,6358),(154503,6359),(154504,6359),(154505,6359),(154506,6359),(154507,6359),(154508,6360),(154509,6360),(154510,6360),(154511,6360),(154512,6360),(154513,6361),(154514,6361),(154515,6361),(154516,6361),(154517,6361),(154518,6362),(154519,6362),(154520,6362),(154521,6362),(154522,6362),(154523,6363),(154524,6363),(154525,6363),(154526,6363),(154527,6363),(154528,6364),(154529,6364),(154530,6364),(154531,6364),(154532,6364),(154533,6365),(154534,6365),(154535,6365),(154536,6365),(154537,6365),(154538,6366),(154539,6366),(154540,6366),(154541,6366),(154542,6366),(154543,6367),(154544,6367),(154545,6367),(154546,6367),(154547,6367),(154548,6368),(154549,6368),(154550,6368),(154551,6368),(154552,6368),(154553,6369),(154554,6369),(154555,6369),(154556,6369),(154557,6369),(154558,6370),(154559,6370),(154560,6370),(154561,6370),(154562,6370),(154563,6371),(154564,6371),(154565,6371),(154566,6371),(154567,6371),(154568,6372),(154569,6372),(154570,6372),(154571,6372),(154572,6372),(154573,6373),(154574,6373),(154575,6373),(154576,6373),(154577,6373),(154578,6374),(154579,6374),(154580,6374),(154581,6374),(154582,6374),(154583,6375),(154584,6375),(154585,6375),(154586,6375),(154587,6375),(154588,6376),(154589,6376),(154590,6376),(154591,6376),(154592,6376),(154593,6377),(154594,6377),(154595,6377),(154596,6377),(154597,6377),(154598,6378),(154599,6378),(154600,6378),(154601,6378),(154602,6378),(154603,6379),(154604,6379),(154605,6379),(154606,6379),(154607,6379),(154608,6380),(154609,6380),(154610,6380),(154611,6380),(154612,6380),(154613,6381),(154614,6381),(154615,6381),(154616,6381),(154617,6381),(154618,6382),(154619,6382),(154620,6382),(154621,6382),(154622,6382),(154623,6383),(154624,6383),(154625,6383),(154626,6383),(154627,6383),(154628,6384),(154629,6384),(154630,6384),(154631,6384),(154632,6384),(154633,6385),(154634,6385),(154635,6385),(154636,6385),(154637,6385),(154638,6386),(154639,6386),(154640,6386),(154641,6386),(154642,6386),(154643,6387),(154644,6387),(154645,6387),(154646,6387),(154647,6387),(154648,6388),(154649,6388),(154650,6388),(154651,6388),(154652,6388),(154653,6389),(154654,6389),(154655,6389),(154656,6389),(154657,6389),(154658,6390),(154659,6390),(154660,6390),(154661,6390),(154662,6390),(154663,6391),(154664,6391),(154665,6391),(154666,6391),(154667,6391),(154668,6392),(154669,6392),(154670,6392),(154671,6392),(154672,6392),(154673,6393),(154674,6393),(154675,6393),(154676,6393),(154677,6393),(154678,6394),(154679,6394),(154680,6394),(154681,6394),(154682,6394),(154683,6395),(154684,6395),(154685,6395),(154686,6395),(154687,6395),(154688,6396),(154689,6396),(154690,6396),(154691,6396),(154692,6396),(154693,6397),(154694,6397),(154695,6397),(154696,6397),(154697,6397),(154698,6398),(154699,6398),(154700,6398),(154701,6398),(154702,6398),(154703,6399),(154704,6399),(154705,6399),(154706,6399),(154707,6399),(154708,6400),(154709,6400),(154710,6400),(154711,6400),(154712,6400),(154713,6401),(154714,6401),(154715,6401),(154716,6401),(154717,6401),(154718,6402),(154719,6402),(154720,6402),(154721,6402),(154722,6402),(154723,6403),(154724,6403),(154725,6403),(154726,6403),(154727,6403),(154728,6404),(154729,6404),(154730,6404),(154731,6404),(154732,6404),(154733,6405),(154734,6405),(154735,6405),(154736,6405),(154737,6405),(154738,6406),(154739,6406),(154740,6406),(154741,6406),(154742,6406),(154743,6407),(154744,6407),(154745,6407),(154746,6407),(154747,6407),(154748,6408),(154749,6408),(154750,6408),(154751,6408),(154752,6408),(154753,6409),(154754,6409),(154755,6409),(154756,6409),(154757,6409),(154758,6410),(154759,6410),(154760,6410),(154761,6410),(154762,6410),(154763,6411),(154764,6411),(154765,6411),(154766,6411),(154767,6411),(154768,6412),(154769,6412),(154770,6412),(154771,6412),(154772,6412),(154773,6413),(154774,6413),(154775,6413),(154776,6413),(154777,6413),(154778,6414),(154779,6414),(154780,6414),(154781,6414),(154782,6414),(154783,6415),(154784,6415),(154785,6415),(154786,6415),(154787,6415),(154788,6416),(154789,6416),(154790,6416),(154791,6416),(154792,6416),(154793,6417),(154794,6417),(154795,6417),(154796,6417),(154797,6417),(154798,6418),(154799,6418),(154800,6418),(154801,6418),(154802,6418),(154803,6419),(154804,6419),(154805,6419),(154806,6419),(154807,6419),(154808,6420),(154809,6420),(154810,6420),(154811,6420),(154812,6420),(154813,6421),(154814,6421),(154815,6421),(154816,6421),(154817,6421),(154818,6422),(154819,6422),(154820,6422),(154821,6422),(154822,6422),(154823,6423),(154824,6423),(154825,6423),(154826,6423),(154827,6423),(154828,6424),(154829,6424),(154830,6424),(154831,6424),(154832,6424),(154833,6425),(154834,6425),(154835,6425),(154836,6425),(154837,6425),(154838,6426),(154839,6426),(154840,6426),(154841,6426),(154842,6426),(154843,6427),(154844,6427),(154845,6427),(154846,6427),(154847,6427),(154848,6428),(154849,6428),(154850,6428),(154851,6428),(154852,6428),(154853,6429),(154854,6429),(154855,6429),(154856,6429),(154857,6429),(154858,6430),(154859,6430),(154860,6430),(154861,6430),(154862,6430),(154863,6431),(154864,6431),(154865,6431),(154866,6431),(154867,6431),(154868,6432),(154869,6432),(154870,6432),(154871,6432),(154872,6432),(154873,6433),(154874,6433),(154875,6433),(154876,6433),(154877,6433),(154878,6434),(154879,6434),(154880,6434),(154881,6434),(154882,6434),(154883,6435),(154884,6435),(154885,6435),(154886,6435),(154887,6435),(154888,6436),(154889,6436),(154890,6436),(154891,6436),(154892,6436),(154893,6437),(154894,6437),(154895,6437),(154896,6437),(154897,6437),(154898,6438),(154899,6438),(154900,6438),(154901,6438),(154902,6438),(154903,6439),(154904,6439),(154905,6439),(154906,6439),(154907,6439),(154908,6440),(154909,6440),(154910,6440),(154911,6440),(154912,6440),(154913,6441),(154914,6441),(154915,6441),(154916,6441),(154917,6441),(154918,6442),(154919,6442),(154920,6442),(154921,6442),(154922,6442),(154923,6443),(154924,6443),(154925,6443),(154926,6443),(154927,6443),(154928,6444),(154929,6444),(154930,6444),(154931,6444),(154932,6444),(154933,6445),(154934,6445),(154935,6445),(154936,6445),(154937,6445),(154938,6446),(154939,6447),(154940,6448),(154941,6449),(154942,6450),(154943,6451),(154944,6452),(154945,6453),(154946,6454),(154947,6455),(154948,6456),(154949,6457),(154950,6458),(154951,6459),(154952,6460),(154953,6461),(154954,6462),(154955,6463),(154956,6464),(154957,6465),(154958,6466),(154959,6467),(154960,6468),(154961,6469),(154962,6470),(154963,6471),(154964,6472),(154965,6473),(154966,6474),(154967,6475),(154968,6476),(154969,6477),(154970,6478),(154971,6479),(154972,6480),(154973,6481),(154974,6482),(154975,6483),(154976,6484),(154977,6485),(154978,6486),(154979,6487),(154980,6488),(154981,6489),(154982,6490),(154983,6491),(154984,6492),(154985,6493),(154986,6494),(154987,6495),(154988,6496),(154989,6497),(154990,6498),(154991,6499),(154992,6500),(154993,6501),(154994,6502),(154995,6503),(154996,6504),(154997,6505),(154998,6506),(154999,6507),(155000,6508),(155001,6509),(155002,6510),(155003,6511),(155004,6512),(155005,6513),(155006,6514),(155007,6515),(155008,6516),(155009,6517),(155010,6518),(155011,6519),(155012,6520),(155013,6521),(155014,6522),(155015,6523),(155016,6524),(155017,6525),(155018,6526),(155019,6527),(155020,6528),(155021,6529),(155022,6530),(155023,6531),(155024,6532),(155025,6533),(155026,6534),(155027,6535),(155028,6536),(155029,6537),(155030,6538),(155031,6539),(155032,6540),(155033,6541),(155034,6542),(155035,6543),(155036,6544),(155037,6545),(155038,6446),(155039,6447),(155040,6448),(155041,6449),(155042,6450),(155043,6451),(155044,6452),(155045,6453),(155046,6454),(155047,6455),(155048,6456),(155049,6457),(155050,6458),(155051,6459),(155052,6460),(155053,6461),(155054,6462),(155055,6463),(155056,6464),(155057,6465),(155058,6466),(155059,6467),(155060,6468),(155061,6469),(155062,6470),(155063,6471),(155064,6472),(155065,6473),(155066,6474),(155067,6475),(155068,6476),(155069,6477),(155070,6478),(155071,6479),(155072,6480),(155073,6481),(155074,6482),(155075,6483),(155076,6484),(155077,6485),(155078,6486),(155079,6487),(155080,6488),(155081,6489),(155082,6490),(155083,6491),(155084,6492),(155085,6493),(155086,6494),(155087,6495),(155088,6496),(155089,6497),(155090,6498),(155091,6499),(155092,6500),(155093,6501),(155094,6502),(155095,6503),(155096,6504),(155097,6505),(155098,6506),(155099,6507),(155100,6508),(155101,6509),(155102,6510),(155103,6511),(155104,6512),(155105,6513),(155106,6514),(155107,6515),(155108,6516),(155109,6517),(155110,6518),(155111,6519),(155112,6520),(155113,6521),(155114,6522),(155115,6523),(155116,6524),(155117,6525),(155118,6526),(155119,6527),(155120,6528),(155121,6529),(155122,6530),(155123,6531),(155124,6532),(155125,6533),(155126,6534),(155127,6535),(155128,6536),(155129,6537),(155130,6538),(155131,6539),(155132,6540),(155133,6541),(155134,6542),(155135,6543),(155136,6544),(155137,6545),(155138,6446),(155139,6446),(155140,6446),(155141,6447),(155142,6447),(155143,6447),(155144,6448),(155145,6448),(155146,6448),(155147,6449),(155148,6449),(155149,6449),(155150,6450),(155151,6450),(155152,6450),(155153,6451),(155154,6451),(155155,6451),(155156,6452),(155157,6452),(155158,6452),(155159,6453),(155160,6453),(155161,6453),(155162,6454),(155163,6454),(155164,6454),(155165,6455),(155166,6455),(155167,6455),(155168,6456),(155169,6456),(155170,6456),(155171,6457),(155172,6457),(155173,6457),(155174,6458),(155175,6458),(155176,6458),(155177,6459),(155178,6459),(155179,6459),(155180,6460),(155181,6460),(155182,6460),(155183,6461),(155184,6461),(155185,6461),(155186,6462),(155187,6462),(155188,6462),(155189,6463),(155190,6463),(155191,6463),(155192,6464),(155193,6464),(155194,6464),(155195,6465),(155196,6465),(155197,6465),(155198,6466),(155199,6466),(155200,6466),(155201,6467),(155202,6467),(155203,6467),(155204,6468),(155205,6468),(155206,6468),(155207,6469),(155208,6469),(155209,6469),(155210,6470),(155211,6470),(155212,6470),(155213,6471),(155214,6471),(155215,6471),(155216,6472),(155217,6472),(155218,6472),(155219,6473),(155220,6473),(155221,6473),(155222,6474),(155223,6474),(155224,6474),(155225,6475),(155226,6475),(155227,6475),(155228,6476),(155229,6476),(155230,6476),(155231,6477),(155232,6477),(155233,6477),(155234,6478),(155235,6478),(155236,6478),(155237,6479),(155238,6479),(155239,6479),(155240,6480),(155241,6480),(155242,6480),(155243,6481),(155244,6481),(155245,6481),(155246,6482),(155247,6482),(155248,6482),(155249,6483),(155250,6483),(155251,6483),(155252,6484),(155253,6484),(155254,6484),(155255,6485),(155256,6485),(155257,6485),(155258,6486),(155259,6486),(155260,6486),(155261,6487),(155262,6487),(155263,6487),(155264,6488),(155265,6488),(155266,6488),(155267,6489),(155268,6489),(155269,6489),(155270,6490),(155271,6490),(155272,6490),(155273,6491),(155274,6491),(155275,6491),(155276,6492),(155277,6492),(155278,6492),(155279,6493),(155280,6493),(155281,6493),(155282,6494),(155283,6494),(155284,6494),(155285,6495),(155286,6495),(155287,6495),(155288,6496),(155289,6496),(155290,6496),(155291,6497),(155292,6497),(155293,6497),(155294,6498),(155295,6498),(155296,6498),(155297,6499),(155298,6499),(155299,6499),(155300,6500),(155301,6500),(155302,6500),(155303,6501),(155304,6501),(155305,6501),(155306,6502),(155307,6502),(155308,6502),(155309,6503),(155310,6503),(155311,6503),(155312,6504),(155313,6504),(155314,6504),(155315,6505),(155316,6505),(155317,6505),(155318,6506),(155319,6506),(155320,6506),(155321,6507),(155322,6507),(155323,6507),(155324,6508),(155325,6508),(155326,6508),(155327,6509),(155328,6509),(155329,6509),(155330,6510),(155331,6510),(155332,6510),(155333,6511),(155334,6511),(155335,6511),(155336,6512),(155337,6512),(155338,6512),(155339,6513),(155340,6513),(155341,6513),(155342,6514),(155343,6514),(155344,6514),(155345,6515),(155346,6515),(155347,6515),(155348,6516),(155349,6516),(155350,6516),(155351,6517),(155352,6517),(155353,6517),(155354,6518),(155355,6518),(155356,6518),(155357,6519),(155358,6519),(155359,6519),(155360,6520),(155361,6520),(155362,6520),(155363,6521),(155364,6521),(155365,6521),(155366,6522),(155367,6522),(155368,6522),(155369,6523),(155370,6523),(155371,6523),(155372,6524),(155373,6524),(155374,6524),(155375,6525),(155376,6525),(155377,6525),(155378,6526),(155379,6526),(155380,6526),(155381,6527),(155382,6527),(155383,6527),(155384,6528),(155385,6528),(155386,6528),(155387,6529),(155388,6529),(155389,6529),(155390,6530),(155391,6530),(155392,6530),(155393,6531),(155394,6531),(155395,6531),(155396,6532),(155397,6532),(155398,6532),(155399,6533),(155400,6533),(155401,6533),(155402,6534),(155403,6534),(155404,6534),(155405,6535),(155406,6535),(155407,6535),(155408,6536),(155409,6536),(155410,6536),(155411,6537),(155412,6537),(155413,6537),(155414,6538),(155415,6538),(155416,6538),(155417,6539),(155418,6539),(155419,6539),(155420,6540),(155421,6540),(155422,6540),(155423,6541),(155424,6541),(155425,6541),(155426,6542),(155427,6542),(155428,6542),(155429,6543),(155430,6543),(155431,6543),(155432,6544),(155433,6544),(155434,6544),(155435,6545),(155436,6545),(155437,6545),(155438,6446),(155439,6446),(155440,6446),(155441,6446),(155442,6446),(155443,6446),(155444,6446),(155445,6446),(155446,6446),(155447,6446),(155448,6446),(155449,6446),(155450,6446),(155451,6446),(155452,6447),(155453,6447),(155454,6447),(155455,6447),(155456,6447),(155457,6447),(155458,6447),(155459,6447),(155460,6447),(155461,6447),(155462,6448),(155463,6448),(155464,6448),(155465,6448),(155466,6448),(155467,6448),(155468,6448),(155469,6448),(155470,6448),(155471,6448),(155472,6449),(155473,6449),(155474,6449),(155475,6449),(155476,6449),(155477,6449),(155478,6449),(155479,6449),(155480,6449),(155481,6449),(155482,6449),(155483,6449),(155484,6449),(155485,6449),(155486,6450),(155487,6450),(155488,6450),(155489,6450),(155490,6450),(155491,6450),(155492,6450),(155493,6450),(155494,6450),(155495,6450),(155496,6450),(155497,6450),(155498,6450),(155499,6450),(155500,6451),(155501,6451),(155502,6451),(155503,6451),(155504,6451),(155505,6451),(155506,6451),(155507,6451),(155508,6451),(155509,6451),(155510,6452),(155511,6452),(155512,6452),(155513,6452),(155514,6452),(155515,6452),(155516,6452),(155517,6452),(155518,6452),(155519,6452),(155520,6452),(155521,6452),(155522,6452),(155523,6452),(155524,6453),(155525,6453),(155526,6453),(155527,6453),(155528,6453),(155529,6453),(155530,6453),(155531,6453),(155532,6453),(155533,6453),(155534,6454),(155535,6454),(155536,6454),(155537,6454),(155538,6454),(155539,6454),(155540,6454),(155541,6454),(155542,6454),(155543,6454),(155544,6455),(155545,6455),(155546,6455),(155547,6455),(155548,6455),(155549,6455),(155550,6455),(155551,6455),(155552,6455),(155553,6455),(155554,6456),(155555,6456),(155556,6456),(155557,6456),(155558,6456),(155559,6456),(155560,6456),(155561,6456),(155562,6456),(155563,6456),(155564,6457),(155565,6457),(155566,6457),(155567,6457),(155568,6457),(155569,6457),(155570,6457),(155571,6457),(155572,6457),(155573,6457),(155574,6458),(155575,6458),(155576,6458),(155577,6458),(155578,6458),(155579,6458),(155580,6458),(155581,6458),(155582,6458),(155583,6458),(155584,6459),(155585,6459),(155586,6459),(155587,6459),(155588,6459),(155589,6459),(155590,6459),(155591,6459),(155592,6459),(155593,6459),(155594,6460),(155595,6460),(155596,6460),(155597,6460),(155598,6460),(155599,6460),(155600,6460),(155601,6460),(155602,6460),(155603,6460),(155604,6461),(155605,6461),(155606,6461),(155607,6461),(155608,6461),(155609,6461),(155610,6461),(155611,6461),(155612,6461),(155613,6461),(155614,6462),(155615,6462),(155616,6462),(155617,6462),(155618,6462),(155619,6462),(155620,6462),(155621,6462),(155622,6462),(155623,6462),(155624,6463),(155625,6463),(155626,6463),(155627,6463),(155628,6463),(155629,6463),(155630,6463),(155631,6463),(155632,6463),(155633,6463),(155634,6463),(155635,6463),(155636,6463),(155637,6463),(155638,6464),(155639,6464),(155640,6464),(155641,6464),(155642,6464),(155643,6464),(155644,6464),(155645,6464),(155646,6464),(155647,6464),(155648,6464),(155649,6464),(155650,6464),(155651,6464),(155652,6465),(155653,6465),(155654,6465),(155655,6465),(155656,6465),(155657,6465),(155658,6465),(155659,6465),(155660,6465),(155661,6465),(155662,6466),(155663,6466),(155664,6466),(155665,6466),(155666,6466),(155667,6466),(155668,6466),(155669,6466),(155670,6466),(155671,6466),(155672,6467),(155673,6467),(155674,6467),(155675,6467),(155676,6467),(155677,6467),(155678,6467),(155679,6467),(155680,6467),(155681,6467),(155682,6468),(155683,6468),(155684,6468),(155685,6468),(155686,6468),(155687,6468),(155688,6468),(155689,6468),(155690,6468),(155691,6468),(155692,6469),(155693,6469),(155694,6469),(155695,6469),(155696,6469),(155697,6469),(155698,6469),(155699,6469),(155700,6469),(155701,6469),(155702,6470),(155703,6470),(155704,6470),(155705,6470),(155706,6470),(155707,6470),(155708,6470),(155709,6470),(155710,6470),(155711,6470),(155712,6471),(155713,6471),(155714,6471),(155715,6471),(155716,6471),(155717,6471),(155718,6471),(155719,6471),(155720,6471),(155721,6471),(155722,6471),(155723,6471),(155724,6471),(155725,6471),(155726,6472),(155727,6472),(155728,6472),(155729,6472),(155730,6472),(155731,6472),(155732,6472),(155733,6472),(155734,6472),(155735,6472),(155736,6472),(155737,6472),(155738,6472),(155739,6472),(155740,6473),(155741,6473),(155742,6473),(155743,6473),(155744,6473),(155745,6473),(155746,6473),(155747,6473),(155748,6473),(155749,6473),(155750,6473),(155751,6473),(155752,6473),(155753,6473),(155754,6474),(155755,6474),(155756,6474),(155757,6474),(155758,6474),(155759,6474),(155760,6474),(155761,6474),(155762,6474),(155763,6474),(155764,6474),(155765,6474),(155766,6474),(155767,6474),(155768,6475),(155769,6475),(155770,6475),(155771,6475),(155772,6475),(155773,6475),(155774,6475),(155775,6475),(155776,6475),(155777,6475),(155778,6475),(155779,6475),(155780,6475),(155781,6475),(155782,6476),(155783,6476),(155784,6476),(155785,6476),(155786,6476),(155787,6476),(155788,6476),(155789,6476),(155790,6476),(155791,6476),(155792,6476),(155793,6476),(155794,6476),(155795,6476),(155796,6477),(155797,6477),(155798,6477),(155799,6477),(155800,6477),(155801,6477),(155802,6477),(155803,6477),(155804,6477),(155805,6477),(155806,6477),(155807,6477),(155808,6477),(155809,6477),(155810,6478),(155811,6478),(155812,6478),(155813,6478),(155814,6478),(155815,6478),(155816,6478),(155817,6478),(155818,6478),(155819,6478),(155820,6478),(155821,6478),(155822,6478),(155823,6478),(155824,6479),(155825,6479),(155826,6479),(155827,6479),(155828,6479),(155829,6479),(155830,6479),(155831,6479),(155832,6479),(155833,6479),(155834,6479),(155835,6479),(155836,6479),(155837,6479),(155838,6480),(155839,6480),(155840,6480),(155841,6480),(155842,6480),(155843,6480),(155844,6480),(155845,6480),(155846,6480),(155847,6480),(155848,6480),(155849,6480),(155850,6480),(155851,6480),(155852,6481),(155853,6481),(155854,6481),(155855,6481),(155856,6481),(155857,6481),(155858,6481),(155859,6481),(155860,6481),(155861,6481),(155862,6481),(155863,6481),(155864,6481),(155865,6481),(155866,6482),(155867,6482),(155868,6482),(155869,6482),(155870,6482),(155871,6482),(155872,6482),(155873,6482),(155874,6482),(155875,6482),(155876,6482),(155877,6482),(155878,6482),(155879,6482),(155880,6483),(155881,6483),(155882,6483),(155883,6483),(155884,6483),(155885,6483),(155886,6483),(155887,6483),(155888,6483),(155889,6483),(155890,6484),(155891,6484),(155892,6484),(155893,6484),(155894,6484),(155895,6484),(155896,6484),(155897,6484),(155898,6484),(155899,6484),(155900,6485),(155901,6485),(155902,6485),(155903,6485),(155904,6485),(155905,6485),(155906,6485),(155907,6485),(155908,6486),(155909,6486),(155910,6486),(155911,6486),(155912,6486),(155913,6486),(155914,6486),(155915,6486),(155916,6487),(155917,6487),(155918,6487),(155919,6487),(155920,6487),(155921,6487),(155922,6487),(155923,6487),(155924,6488),(155925,6488),(155926,6488),(155927,6488),(155928,6488),(155929,6488),(155930,6488),(155931,6488),(155932,6489),(155933,6489),(155934,6489),(155935,6489),(155936,6489),(155937,6489),(155938,6489),(155939,6489),(155940,6490),(155941,6490),(155942,6490),(155943,6490),(155944,6490),(155945,6490),(155946,6490),(155947,6490),(155948,6491),(155949,6491),(155950,6491),(155951,6491),(155952,6491),(155953,6491),(155954,6491),(155955,6491),(155956,6492),(155957,6492),(155958,6492),(155959,6492),(155960,6492),(155961,6492),(155962,6492),(155963,6492),(155964,6492),(155965,6492),(155966,6493),(155967,6493),(155968,6493),(155969,6493),(155970,6493),(155971,6493),(155972,6493),(155973,6493),(155974,6493),(155975,6493),(155976,6494),(155977,6494),(155978,6494),(155979,6494),(155980,6494),(155981,6494),(155982,6494),(155983,6494),(155984,6494),(155985,6494),(155986,6495),(155987,6495),(155988,6495),(155989,6495),(155990,6495),(155991,6495),(155992,6495),(155993,6495),(155994,6495),(155995,6495),(155996,6496),(155997,6496),(155998,6496),(155999,6496),(156000,6496),(156001,6496),(156002,6496),(156003,6496),(156004,6496),(156005,6496),(156006,6497),(156007,6497),(156008,6497),(156009,6497),(156010,6497),(156011,6497),(156012,6497),(156013,6497),(156014,6497),(156015,6497),(156016,6498),(156017,6498),(156018,6498),(156019,6498),(156020,6498),(156021,6498),(156022,6498),(156023,6498),(156024,6498),(156025,6498),(156026,6499),(156027,6499),(156028,6499),(156029,6499),(156030,6499),(156031,6499),(156032,6499),(156033,6499),(156034,6499),(156035,6499),(156036,6500),(156037,6500),(156038,6500),(156039,6500),(156040,6500),(156041,6500),(156042,6500),(156043,6500),(156044,6500),(156045,6500),(156046,6501),(156047,6501),(156048,6501),(156049,6501),(156050,6501),(156051,6501),(156052,6501),(156053,6501),(156054,6501),(156055,6501),(156056,6502),(156057,6502),(156058,6502),(156059,6502),(156060,6502),(156061,6502),(156062,6502),(156063,6502),(156064,6502),(156065,6502),(156066,6503),(156067,6503),(156068,6503),(156069,6503),(156070,6503),(156071,6503),(156072,6503),(156073,6503),(156074,6503),(156075,6503),(156076,6504),(156077,6504),(156078,6504),(156079,6504),(156080,6504),(156081,6504),(156082,6504),(156083,6504),(156084,6504),(156085,6504),(156086,6505),(156087,6505),(156088,6505),(156089,6505),(156090,6505),(156091,6505),(156092,6505),(156093,6505),(156094,6505),(156095,6505),(156096,6506),(156097,6506),(156098,6506),(156099,6506),(156100,6506),(156101,6506),(156102,6506),(156103,6506),(156104,6506),(156105,6506),(156106,6507),(156107,6507),(156108,6507),(156109,6507),(156110,6507),(156111,6507),(156112,6507),(156113,6507),(156114,6508),(156115,6508),(156116,6508),(156117,6508),(156118,6508),(156119,6508),(156120,6508),(156121,6508),(156122,6508),(156123,6508),(156124,6508),(156125,6508),(156126,6508),(156127,6508),(156128,6509),(156129,6509),(156130,6509),(156131,6509),(156132,6509),(156133,6509),(156134,6509),(156135,6509),(156136,6509),(156137,6509),(156138,6509),(156139,6509),(156140,6509),(156141,6509),(156142,6510),(156143,6510),(156144,6510),(156145,6510),(156146,6510),(156147,6510),(156148,6510),(156149,6510),(156150,6510),(156151,6510),(156152,6510),(156153,6510),(156154,6510),(156155,6510),(156156,6511),(156157,6511),(156158,6511),(156159,6511),(156160,6511),(156161,6511),(156162,6511),(156163,6511),(156164,6511),(156165,6511),(156166,6511),(156167,6511),(156168,6511),(156169,6511),(156170,6512),(156171,6512),(156172,6512),(156173,6512),(156174,6512),(156175,6512),(156176,6512),(156177,6512),(156178,6512),(156179,6512),(156180,6512),(156181,6512),(156182,6512),(156183,6512),(156184,6513),(156185,6513),(156186,6513),(156187,6513),(156188,6513),(156189,6513),(156190,6513),(156191,6513),(156192,6513),(156193,6513),(156194,6513),(156195,6513),(156196,6513),(156197,6513),(156198,6514),(156199,6514),(156200,6514),(156201,6514),(156202,6515),(156203,6515),(156204,6515),(156205,6515),(156206,6516),(156207,6516),(156208,6516),(156209,6516),(156210,6517),(156211,6517),(156212,6517),(156213,6517),(156214,6518),(156215,6518),(156216,6518),(156217,6518),(156218,6519),(156219,6519),(156220,6519),(156221,6519),(156222,6520),(156223,6520),(156224,6520),(156225,6520),(156226,6521),(156227,6521),(156228,6521),(156229,6521),(156230,6521),(156231,6521),(156232,6521),(156233,6521),(156234,6521),(156235,6521),(156236,6522),(156237,6522),(156238,6522),(156239,6522),(156240,6522),(156241,6522),(156242,6522),(156243,6522),(156244,6522),(156245,6522),(156246,6523),(156247,6523),(156248,6523),(156249,6523),(156250,6523),(156251,6523),(156252,6523),(156253,6523),(156254,6523),(156255,6523),(156256,6524),(156257,6524),(156258,6524),(156259,6524),(156260,6524),(156261,6524),(156262,6524),(156263,6524),(156264,6524),(156265,6524),(156266,6525),(156267,6525),(156268,6525),(156269,6525),(156270,6526),(156271,6526),(156272,6526),(156273,6526),(156274,6527),(156275,6527),(156276,6527),(156277,6527),(156278,6528),(156279,6528),(156280,6528),(156281,6528),(156282,6529),(156283,6529),(156284,6529),(156285,6529),(156286,6530),(156287,6530),(156288,6530),(156289,6530),(156290,6531),(156291,6531),(156292,6531),(156293,6531),(156294,6532),(156295,6532),(156296,6532),(156297,6532),(156298,6533),(156299,6533),(156300,6533),(156301,6533),(156302,6534),(156303,6534),(156304,6534),(156305,6534),(156306,6535),(156307,6535),(156308,6535),(156309,6535),(156310,6536),(156311,6536),(156312,6536),(156313,6536),(156314,6537),(156315,6537),(156316,6537),(156317,6537),(156318,6538),(156319,6538),(156320,6538),(156321,6538),(156322,6539),(156323,6539),(156324,6539),(156325,6539),(156326,6540),(156327,6540),(156328,6540),(156329,6540),(156330,6540),(156331,6540),(156332,6540),(156333,6540),(156334,6540),(156335,6540),(156336,6541),(156337,6541),(156338,6541),(156339,6541),(156340,6541),(156341,6541),(156342,6541),(156343,6541),(156344,6541),(156345,6541),(156346,6542),(156347,6542),(156348,6542),(156349,6542),(156350,6542),(156351,6542),(156352,6542),(156353,6542),(156354,6542),(156355,6542),(156356,6543),(156357,6543),(156358,6543),(156359,6543),(156360,6543),(156361,6543),(156362,6543),(156363,6543),(156364,6543),(156365,6543),(156366,6544),(156367,6544),(156368,6544),(156369,6544),(156370,6544),(156371,6544),(156372,6544),(156373,6544),(156374,6544),(156375,6544),(156376,6545),(156377,6545),(156378,6545),(156379,6545),(156380,6545),(156381,6545),(156382,6545),(156383,6545),(156384,6545),(156385,6545),(156386,6446),(156387,6446),(156388,6446),(156389,6446),(156390,6446),(156391,6446),(156392,6446),(156393,6447),(156394,6447),(156395,6447),(156396,6447),(156397,6447),(156398,6447),(156399,6447),(156400,6448),(156401,6448),(156402,6448),(156403,6448),(156404,6448),(156405,6448),(156406,6448),(156407,6449),(156408,6449),(156409,6449),(156410,6449),(156411,6449),(156412,6449),(156413,6449),(156414,6450),(156415,6450),(156416,6450),(156417,6450),(156418,6450),(156419,6450),(156420,6450),(156421,6451),(156422,6451),(156423,6451),(156424,6451),(156425,6451),(156426,6451),(156427,6451),(156428,6452),(156429,6452),(156430,6452),(156431,6452),(156432,6452),(156433,6452),(156434,6452),(156435,6453),(156436,6453),(156437,6453),(156438,6453),(156439,6453),(156440,6453),(156441,6453),(156442,6454),(156443,6454),(156444,6454),(156445,6454),(156446,6454),(156447,6454),(156448,6454),(156449,6455),(156450,6455),(156451,6455),(156452,6455),(156453,6455),(156454,6455),(156455,6455),(156456,6456),(156457,6456),(156458,6456),(156459,6456),(156460,6456),(156461,6456),(156462,6456),(156463,6457),(156464,6457),(156465,6457),(156466,6457),(156467,6457),(156468,6457),(156469,6457),(156470,6458),(156471,6458),(156472,6458),(156473,6458),(156474,6458),(156475,6458),(156476,6458),(156477,6459),(156478,6459),(156479,6459),(156480,6459),(156481,6459),(156482,6459),(156483,6459),(156484,6460),(156485,6460),(156486,6460),(156487,6460),(156488,6460),(156489,6460),(156490,6460),(156491,6461),(156492,6461),(156493,6461),(156494,6461),(156495,6461),(156496,6461),(156497,6461),(156498,6462),(156499,6462),(156500,6462),(156501,6462),(156502,6462),(156503,6462),(156504,6462),(156505,6463),(156506,6463),(156507,6463),(156508,6463),(156509,6463),(156510,6463),(156511,6463),(156512,6464),(156513,6464),(156514,6464),(156515,6464),(156516,6464),(156517,6464),(156518,6464),(156519,6465),(156520,6465),(156521,6465),(156522,6465),(156523,6465),(156524,6465),(156525,6465),(156526,6466),(156527,6466),(156528,6466),(156529,6466),(156530,6466),(156531,6466),(156532,6466),(156533,6467),(156534,6467),(156535,6467),(156536,6467),(156537,6467),(156538,6467),(156539,6467),(156540,6468),(156541,6468),(156542,6468),(156543,6468),(156544,6468),(156545,6468),(156546,6468),(156547,6469),(156548,6469),(156549,6469),(156550,6469),(156551,6469),(156552,6469),(156553,6469),(156554,6470),(156555,6470),(156556,6470),(156557,6470),(156558,6470),(156559,6470),(156560,6470),(156561,6471),(156562,6471),(156563,6471),(156564,6471),(156565,6471),(156566,6471),(156567,6471),(156568,6472),(156569,6472),(156570,6472),(156571,6472),(156572,6472),(156573,6472),(156574,6472),(156575,6473),(156576,6473),(156577,6473),(156578,6473),(156579,6473),(156580,6473),(156581,6473),(156582,6474),(156583,6474),(156584,6474),(156585,6474),(156586,6474),(156587,6474),(156588,6474),(156589,6475),(156590,6475),(156591,6475),(156592,6475),(156593,6475),(156594,6475),(156595,6475),(156596,6476),(156597,6476),(156598,6476),(156599,6476),(156600,6476),(156601,6476),(156602,6476),(156603,6477),(156604,6477),(156605,6477),(156606,6477),(156607,6477),(156608,6477),(156609,6477),(156610,6478),(156611,6478),(156612,6478),(156613,6478),(156614,6478),(156615,6478),(156616,6478),(156617,6479),(156618,6479),(156619,6479),(156620,6479),(156621,6479),(156622,6479),(156623,6479),(156624,6480),(156625,6480),(156626,6480),(156627,6480),(156628,6480),(156629,6480),(156630,6480),(156631,6481),(156632,6481),(156633,6481),(156634,6481),(156635,6481),(156636,6481),(156637,6481),(156638,6482),(156639,6482),(156640,6482),(156641,6482),(156642,6482),(156643,6482),(156644,6482),(156645,6483),(156646,6483),(156647,6483),(156648,6483),(156649,6483),(156650,6483),(156651,6483),(156652,6484),(156653,6484),(156654,6484),(156655,6484),(156656,6484),(156657,6484),(156658,6484),(156659,6485),(156660,6485),(156661,6485),(156662,6485),(156663,6485),(156664,6485),(156665,6485),(156666,6486),(156667,6486),(156668,6486),(156669,6486),(156670,6486),(156671,6486),(156672,6486),(156673,6487),(156674,6487),(156675,6487),(156676,6487),(156677,6487),(156678,6487),(156679,6487),(156680,6488),(156681,6488),(156682,6488),(156683,6488),(156684,6488),(156685,6488),(156686,6488),(156687,6489),(156688,6489),(156689,6489),(156690,6489),(156691,6489),(156692,6489),(156693,6489),(156694,6490),(156695,6490),(156696,6490),(156697,6490),(156698,6490),(156699,6490),(156700,6490),(156701,6491),(156702,6491),(156703,6491),(156704,6491),(156705,6491),(156706,6491),(156707,6491),(156708,6492),(156709,6492),(156710,6492),(156711,6493),(156712,6493),(156713,6493),(156714,6494),(156715,6494),(156716,6494),(156717,6495),(156718,6495),(156719,6495),(156720,6496),(156721,6496),(156722,6496),(156723,6497),(156724,6497),(156725,6497),(156726,6498),(156727,6498),(156728,6498),(156729,6499),(156730,6499),(156731,6499),(156732,6500),(156733,6500),(156734,6500),(156735,6501),(156736,6501),(156737,6501),(156738,6502),(156739,6502),(156740,6502),(156741,6503),(156742,6503),(156743,6503),(156744,6504),(156745,6504),(156746,6504),(156747,6505),(156748,6505),(156749,6505),(156750,6506),(156751,6506),(156752,6506),(156753,6507),(156754,6507),(156755,6507),(156756,6507),(156757,6507),(156758,6508),(156759,6508),(156760,6508),(156761,6508),(156762,6508),(156763,6508),(156764,6508),(156765,6509),(156766,6509),(156767,6509),(156768,6509),(156769,6509),(156770,6509),(156771,6509),(156772,6510),(156773,6510),(156774,6510),(156775,6510),(156776,6510),(156777,6510),(156778,6510),(156779,6511),(156780,6511),(156781,6511),(156782,6511),(156783,6511),(156784,6511),(156785,6511),(156786,6512),(156787,6512),(156788,6512),(156789,6512),(156790,6512),(156791,6512),(156792,6512),(156793,6513),(156794,6513),(156795,6513),(156796,6513),(156797,6513),(156798,6513),(156799,6513),(156800,6514),(156801,6514),(156802,6514),(156803,6514),(156804,6514),(156805,6515),(156806,6515),(156807,6515),(156808,6515),(156809,6515),(156810,6516),(156811,6516),(156812,6516),(156813,6516),(156814,6516),(156815,6517),(156816,6517),(156817,6517),(156818,6517),(156819,6517),(156820,6518),(156821,6518),(156822,6518),(156823,6518),(156824,6518),(156825,6519),(156826,6519),(156827,6519),(156828,6519),(156829,6519),(156830,6520),(156831,6520),(156832,6520),(156833,6520),(156834,6520),(156835,6521),(156836,6521),(156837,6521),(156838,6521),(156839,6521),(156840,6522),(156841,6522),(156842,6522),(156843,6522),(156844,6522),(156845,6523),(156846,6523),(156847,6523),(156848,6523),(156849,6523),(156850,6524),(156851,6524),(156852,6524),(156853,6524),(156854,6524),(156855,6525),(156856,6525),(156857,6525),(156858,6525),(156859,6525),(156860,6526),(156861,6526),(156862,6526),(156863,6526),(156864,6526),(156865,6527),(156866,6527),(156867,6527),(156868,6527),(156869,6527),(156870,6528),(156871,6528),(156872,6528),(156873,6528),(156874,6528),(156875,6529),(156876,6529),(156877,6529),(156878,6529),(156879,6529),(156880,6530),(156881,6530),(156882,6530),(156883,6530),(156884,6530),(156885,6531),(156886,6531),(156887,6531),(156888,6531),(156889,6531),(156890,6532),(156891,6532),(156892,6532),(156893,6532),(156894,6532),(156895,6533),(156896,6533),(156897,6533),(156898,6533),(156899,6533),(156900,6534),(156901,6534),(156902,6534),(156903,6534),(156904,6534),(156905,6535),(156906,6535),(156907,6535),(156908,6535),(156909,6535),(156910,6536),(156911,6536),(156912,6536),(156913,6536),(156914,6536),(156915,6537),(156916,6537),(156917,6537),(156918,6538),(156919,6538),(156920,6538),(156921,6538),(156922,6538),(156923,6539),(156924,6539),(156925,6539),(156926,6539),(156927,6539),(156928,6540),(156929,6540),(156930,6540),(156931,6540),(156932,6540),(156933,6541),(156934,6541),(156935,6541),(156936,6541),(156937,6541),(156938,6542),(156939,6542),(156940,6542),(156941,6542),(156942,6542),(156943,6543),(156944,6543),(156945,6543),(156946,6543),(156947,6543),(156948,6544),(156949,6544),(156950,6544),(156951,6544),(156952,6544),(156953,6545),(156954,6545),(156955,6545),(156956,6545),(156957,6545),(156958,6446),(156959,6446),(156960,6446),(156961,6446),(156962,6446),(156963,6447),(156964,6447),(156965,6447),(156966,6447),(156967,6447),(156968,6448),(156969,6448),(156970,6448),(156971,6448),(156972,6448),(156973,6449),(156974,6449),(156975,6449),(156976,6449),(156977,6449),(156978,6450),(156979,6450),(156980,6450),(156981,6450),(156982,6450),(156983,6451),(156984,6451),(156985,6451),(156986,6451),(156987,6451),(156988,6452),(156989,6452),(156990,6452),(156991,6452),(156992,6452),(156993,6453),(156994,6453),(156995,6453),(156996,6453),(156997,6453),(156998,6454),(156999,6454),(157000,6454),(157001,6454),(157002,6454),(157003,6455),(157004,6455),(157005,6455),(157006,6455),(157007,6455),(157008,6456),(157009,6456),(157010,6456),(157011,6456),(157012,6456),(157013,6457),(157014,6457),(157015,6457),(157016,6457),(157017,6457),(157018,6458),(157019,6458),(157020,6458),(157021,6458),(157022,6458),(157023,6459),(157024,6459),(157025,6459),(157026,6459),(157027,6459),(157028,6460),(157029,6460),(157030,6460),(157031,6460),(157032,6460),(157033,6461),(157034,6461),(157035,6461),(157036,6461),(157037,6461),(157038,6462),(157039,6462),(157040,6462),(157041,6462),(157042,6462),(157043,6463),(157044,6463),(157045,6463),(157046,6463),(157047,6463),(157048,6464),(157049,6464),(157050,6464),(157051,6464),(157052,6464),(157053,6465),(157054,6465),(157055,6465),(157056,6465),(157057,6465),(157058,6466),(157059,6466),(157060,6466),(157061,6466),(157062,6466),(157063,6467),(157064,6467),(157065,6467),(157066,6467),(157067,6467),(157068,6468),(157069,6468),(157070,6468),(157071,6468),(157072,6468),(157073,6469),(157074,6469),(157075,6469),(157076,6469),(157077,6469),(157078,6470),(157079,6470),(157080,6470),(157081,6470),(157082,6470),(157083,6471),(157084,6471),(157085,6471),(157086,6471),(157087,6471),(157088,6472),(157089,6472),(157090,6472),(157091,6472),(157092,6472),(157093,6473),(157094,6473),(157095,6473),(157096,6473),(157097,6473),(157098,6474),(157099,6474),(157100,6474),(157101,6474),(157102,6474),(157103,6475),(157104,6475),(157105,6475),(157106,6475),(157107,6475),(157108,6476),(157109,6476),(157110,6476),(157111,6476),(157112,6476),(157113,6477),(157114,6477),(157115,6477),(157116,6477),(157117,6477),(157118,6478),(157119,6478),(157120,6478),(157121,6478),(157122,6478),(157123,6479),(157124,6479),(157125,6479),(157126,6479),(157127,6479),(157128,6480),(157129,6480),(157130,6480),(157131,6480),(157132,6480),(157133,6481),(157134,6481),(157135,6481),(157136,6481),(157137,6481),(157138,6482),(157139,6482),(157140,6482),(157141,6482),(157142,6482),(157143,6483),(157144,6483),(157145,6483),(157146,6483),(157147,6483),(157148,6484),(157149,6484),(157150,6484),(157151,6484),(157152,6484),(157153,6485),(157154,6485),(157155,6485),(157156,6485),(157157,6485),(157158,6486),(157159,6486),(157160,6486),(157161,6486),(157162,6486),(157163,6487),(157164,6487),(157165,6487),(157166,6487),(157167,6487),(157168,6488),(157169,6488),(157170,6488),(157171,6488),(157172,6488),(157173,6489),(157174,6489),(157175,6489),(157176,6489),(157177,6489),(157178,6490),(157179,6490),(157180,6490),(157181,6490),(157182,6490),(157183,6491),(157184,6491),(157185,6491),(157186,6491),(157187,6491),(157188,6492),(157189,6492),(157190,6492),(157191,6492),(157192,6492),(157193,6493),(157194,6493),(157195,6493),(157196,6493),(157197,6493),(157198,6494),(157199,6494),(157200,6494),(157201,6494),(157202,6494),(157203,6495),(157204,6495),(157205,6495),(157206,6495),(157207,6495),(157208,6496),(157209,6496),(157210,6496),(157211,6496),(157212,6496),(157213,6497),(157214,6497),(157215,6497),(157216,6497),(157217,6497),(157218,6498),(157219,6498),(157220,6498),(157221,6498),(157222,6498),(157223,6499),(157224,6499),(157225,6499),(157226,6499),(157227,6499),(157228,6500),(157229,6500),(157230,6500),(157231,6500),(157232,6500),(157233,6501),(157234,6501),(157235,6501),(157236,6501),(157237,6501),(157238,6502),(157239,6502),(157240,6502),(157241,6502),(157242,6502),(157243,6503),(157244,6503),(157245,6503),(157246,6503),(157247,6503),(157248,6504),(157249,6504),(157250,6504),(157251,6504),(157252,6504),(157253,6505),(157254,6505),(157255,6505),(157256,6505),(157257,6505),(157258,6506),(157259,6506),(157260,6506),(157261,6506),(157262,6506),(157263,6507),(157264,6507),(157265,6507),(157266,6507),(157267,6507),(157268,6508),(157269,6508),(157270,6508),(157271,6508),(157272,6508),(157273,6509),(157274,6509),(157275,6509),(157276,6509),(157277,6509),(157278,6510),(157279,6510),(157280,6510),(157281,6510),(157282,6510),(157283,6511),(157284,6511),(157285,6511),(157286,6511),(157287,6511),(157288,6512),(157289,6512),(157290,6512),(157291,6512),(157292,6512),(157293,6513),(157294,6513),(157295,6513),(157296,6513),(157297,6513),(157298,6514),(157299,6514),(157300,6514),(157301,6514),(157302,6514),(157303,6515),(157304,6515),(157305,6515),(157306,6515),(157307,6515),(157308,6516),(157309,6516),(157310,6516),(157311,6516),(157312,6516),(157313,6517),(157314,6517),(157315,6517),(157316,6517),(157317,6517),(157318,6518),(157319,6518),(157320,6518),(157321,6518),(157322,6518),(157323,6519),(157324,6519),(157325,6519),(157326,6519),(157327,6519),(157328,6520),(157329,6520),(157330,6520),(157331,6520),(157332,6520),(157333,6521),(157334,6521),(157335,6521),(157336,6521),(157337,6521),(157338,6522),(157339,6522),(157340,6522),(157341,6522),(157342,6522),(157343,6523),(157344,6523),(157345,6523),(157346,6523),(157347,6523),(157348,6524),(157349,6524),(157350,6524),(157351,6524),(157352,6524),(157353,6525),(157354,6525),(157355,6525),(157356,6525),(157357,6525),(157358,6526),(157359,6526),(157360,6526),(157361,6526),(157362,6526),(157363,6527),(157364,6527),(157365,6527),(157366,6527),(157367,6527),(157368,6528),(157369,6528),(157370,6528),(157371,6528),(157372,6528),(157373,6529),(157374,6529),(157375,6529),(157376,6529),(157377,6529),(157378,6530),(157379,6530),(157380,6530),(157381,6530),(157382,6530),(157383,6531),(157384,6531),(157385,6531),(157386,6531),(157387,6531),(157388,6532),(157389,6532),(157390,6532),(157391,6532),(157392,6532),(157393,6533),(157394,6533),(157395,6533),(157396,6533),(157397,6533),(157398,6534),(157399,6534),(157400,6534),(157401,6534),(157402,6534),(157403,6535),(157404,6535),(157405,6535),(157406,6535),(157407,6535),(157408,6536),(157409,6536),(157410,6536),(157411,6536),(157412,6536),(157413,6537),(157414,6537),(157415,6537),(157416,6537),(157417,6537),(157418,6538),(157419,6538),(157420,6538),(157421,6538),(157422,6538),(157423,6539),(157424,6539),(157425,6539),(157426,6539),(157427,6539),(157428,6540),(157429,6540),(157430,6540),(157431,6540),(157432,6540),(157433,6541),(157434,6541),(157435,6541),(157436,6541),(157437,6541),(157438,6542),(157439,6542),(157440,6542),(157441,6542),(157442,6542),(157443,6543),(157444,6543),(157445,6543),(157446,6543),(157447,6543),(157448,6544),(157449,6544),(157450,6544),(157451,6544),(157452,6544),(157453,6545),(157454,6545),(157455,6545),(157456,6545),(157457,6545),(157458,6546),(157459,6547),(157460,6548),(157461,6549),(157462,6550),(157463,6551),(157464,6552),(157465,6553),(157466,6554),(157467,6555),(157468,6556),(157469,6557),(157470,6558),(157471,6559),(157472,6560),(157473,6561),(157474,6562),(157475,6563),(157476,6564),(157477,6565),(157478,6566),(157479,6567),(157480,6568),(157481,6569),(157482,6570),(157483,6571),(157484,6572),(157485,6546),(157486,6547),(157487,6548),(157488,6549),(157489,6550),(157490,6551),(157491,6552),(157492,6553),(157493,6554),(157494,6555),(157495,6556),(157496,6557),(157497,6558),(157498,6559),(157499,6560),(157500,6561),(157501,6562),(157502,6563),(157503,6564),(157504,6565),(157505,6566),(157506,6567),(157507,6568),(157508,6569),(157509,6570),(157510,6571),(157511,6572),(157512,6546),(157513,6546),(157514,6547),(157515,6547),(157516,6548),(157517,6548),(157518,6549),(157519,6549),(157520,6550),(157521,6550),(157522,6551),(157523,6551),(157524,6552),(157525,6552),(157526,6553),(157527,6553),(157528,6554),(157529,6554),(157530,6555),(157531,6555),(157532,6556),(157533,6556),(157534,6557),(157535,6557),(157536,6558),(157537,6558),(157538,6559),(157539,6559),(157540,6560),(157541,6560),(157542,6561),(157543,6561),(157544,6562),(157545,6562),(157546,6563),(157547,6563),(157548,6564),(157549,6564),(157550,6564),(157551,6565),(157552,6565),(157553,6565),(157554,6566),(157555,6566),(157556,6566),(157557,6567),(157558,6567),(157559,6567),(157560,6568),(157561,6568),(157562,6568),(157563,6569),(157564,6569),(157565,6569),(157566,6570),(157567,6570),(157568,6570),(157569,6571),(157570,6571),(157571,6571),(157572,6572),(157573,6572),(157574,6572),(157575,6546),(157576,6546),(157577,6546),(157578,6546),(157579,6546),(157580,6546),(157581,6546),(157582,6546),(157583,6546),(157584,6546),(157585,6546),(157586,6546),(157587,6546),(157588,6546),(157589,6547),(157590,6547),(157591,6547),(157592,6547),(157593,6547),(157594,6547),(157595,6547),(157596,6547),(157597,6547),(157598,6547),(157599,6547),(157600,6547),(157601,6547),(157602,6547),(157603,6548),(157604,6548),(157605,6548),(157606,6548),(157607,6548),(157608,6548),(157609,6548),(157610,6548),(157611,6548),(157612,6548),(157613,6548),(157614,6548),(157615,6548),(157616,6548),(157617,6549),(157618,6549),(157619,6549),(157620,6549),(157621,6549),(157622,6549),(157623,6549),(157624,6549),(157625,6549),(157626,6549),(157627,6549),(157628,6549),(157629,6549),(157630,6549),(157631,6550),(157632,6550),(157633,6550),(157634,6550),(157635,6550),(157636,6550),(157637,6550),(157638,6550),(157639,6550),(157640,6550),(157641,6550),(157642,6550),(157643,6550),(157644,6550),(157645,6551),(157646,6551),(157647,6551),(157648,6551),(157649,6551),(157650,6551),(157651,6551),(157652,6551),(157653,6551),(157654,6551),(157655,6551),(157656,6551),(157657,6551),(157658,6551),(157659,6552),(157660,6552),(157661,6552),(157662,6552),(157663,6552),(157664,6552),(157665,6552),(157666,6552),(157667,6552),(157668,6552),(157669,6552),(157670,6552),(157671,6552),(157672,6552),(157673,6553),(157674,6553),(157675,6553),(157676,6553),(157677,6553),(157678,6553),(157679,6553),(157680,6553),(157681,6553),(157682,6553),(157683,6553),(157684,6553),(157685,6553),(157686,6553),(157687,6554),(157688,6554),(157689,6554),(157690,6554),(157691,6554),(157692,6554),(157693,6554),(157694,6554),(157695,6554),(157696,6554),(157697,6554),(157698,6554),(157699,6554),(157700,6554),(157701,6555),(157702,6555),(157703,6555),(157704,6555),(157705,6555),(157706,6555),(157707,6555),(157708,6555),(157709,6555),(157710,6555),(157711,6555),(157712,6555),(157713,6555),(157714,6555),(157715,6556),(157716,6556),(157717,6556),(157718,6556),(157719,6556),(157720,6556),(157721,6556),(157722,6556),(157723,6556),(157724,6556),(157725,6556),(157726,6556),(157727,6556),(157728,6556),(157729,6557),(157730,6557),(157731,6557),(157732,6557),(157733,6557),(157734,6557),(157735,6557),(157736,6557),(157737,6557),(157738,6557),(157739,6557),(157740,6557),(157741,6557),(157742,6557),(157743,6558),(157744,6558),(157745,6558),(157746,6558),(157747,6558),(157748,6558),(157749,6558),(157750,6558),(157751,6558),(157752,6558),(157753,6558),(157754,6558),(157755,6558),(157756,6558),(157757,6559),(157758,6559),(157759,6559),(157760,6559),(157761,6559),(157762,6559),(157763,6559),(157764,6559),(157765,6559),(157766,6559),(157767,6559),(157768,6559),(157769,6559),(157770,6559),(157771,6560),(157772,6560),(157773,6560),(157774,6560),(157775,6560),(157776,6560),(157777,6560),(157778,6560),(157779,6560),(157780,6560),(157781,6560),(157782,6560),(157783,6560),(157784,6560),(157785,6561),(157786,6561),(157787,6561),(157788,6561),(157789,6561),(157790,6561),(157791,6561),(157792,6561),(157793,6561),(157794,6561),(157795,6561),(157796,6561),(157797,6561),(157798,6561),(157799,6562),(157800,6562),(157801,6562),(157802,6562),(157803,6562),(157804,6562),(157805,6562),(157806,6562),(157807,6562),(157808,6562),(157809,6562),(157810,6562),(157811,6562),(157812,6562),(157813,6563),(157814,6563),(157815,6563),(157816,6563),(157817,6563),(157818,6563),(157819,6563),(157820,6563),(157821,6563),(157822,6563),(157823,6563),(157824,6563),(157825,6563),(157826,6563),(157827,6564),(157828,6564),(157829,6564),(157830,6564),(157831,6564),(157832,6564),(157833,6564),(157834,6564),(157835,6564),(157836,6564),(157837,6564),(157838,6564),(157839,6564),(157840,6564),(157841,6565),(157842,6565),(157843,6565),(157844,6565),(157845,6565),(157846,6565),(157847,6565),(157848,6565),(157849,6565),(157850,6565),(157851,6565),(157852,6565),(157853,6565),(157854,6565),(157855,6566),(157856,6566),(157857,6566),(157858,6566),(157859,6566),(157860,6566),(157861,6566),(157862,6566),(157863,6566),(157864,6566),(157865,6566),(157866,6566),(157867,6566),(157868,6566),(157869,6567),(157870,6567),(157871,6567),(157872,6567),(157873,6567),(157874,6567),(157875,6567),(157876,6567),(157877,6567),(157878,6567),(157879,6567),(157880,6567),(157881,6567),(157882,6567),(157883,6568),(157884,6568),(157885,6568),(157886,6568),(157887,6568),(157888,6568),(157889,6568),(157890,6568),(157891,6568),(157892,6568),(157893,6568),(157894,6568),(157895,6568),(157896,6568),(157897,6569),(157898,6569),(157899,6569),(157900,6569),(157901,6569),(157902,6569),(157903,6569),(157904,6569),(157905,6569),(157906,6569),(157907,6569),(157908,6569),(157909,6569),(157910,6569),(157911,6570),(157912,6570),(157913,6570),(157914,6570),(157915,6570),(157916,6570),(157917,6570),(157918,6570),(157919,6570),(157920,6570),(157921,6570),(157922,6570),(157923,6570),(157924,6570),(157925,6571),(157926,6571),(157927,6571),(157928,6571),(157929,6571),(157930,6571),(157931,6571),(157932,6571),(157933,6571),(157934,6571),(157935,6571),(157936,6571),(157937,6571),(157938,6571),(157939,6572),(157940,6572),(157941,6572),(157942,6572),(157943,6572),(157944,6572),(157945,6572),(157946,6572),(157947,6572),(157948,6572),(157949,6572),(157950,6572),(157951,6572),(157952,6572),(157953,6546),(157954,6546),(157955,6546),(157956,6546),(157957,6546),(157958,6546),(157959,6546),(157960,6547),(157961,6547),(157962,6547),(157963,6547),(157964,6547),(157965,6547),(157966,6547),(157967,6548),(157968,6548),(157969,6548),(157970,6548),(157971,6548),(157972,6548),(157973,6548),(157974,6549),(157975,6549),(157976,6549),(157977,6549),(157978,6549),(157979,6549),(157980,6549),(157981,6550),(157982,6550),(157983,6550),(157984,6550),(157985,6550),(157986,6550),(157987,6550),(157988,6551),(157989,6551),(157990,6551),(157991,6551),(157992,6551),(157993,6551),(157994,6551),(157995,6552),(157996,6552),(157997,6552),(157998,6552),(157999,6552),(158000,6552),(158001,6552),(158002,6553),(158003,6553),(158004,6553),(158005,6553),(158006,6553),(158007,6553),(158008,6553),(158009,6554),(158010,6554),(158011,6554),(158012,6554),(158013,6554),(158014,6554),(158015,6554),(158016,6555),(158017,6555),(158018,6555),(158019,6555),(158020,6555),(158021,6555),(158022,6555),(158023,6556),(158024,6556),(158025,6556),(158026,6556),(158027,6556),(158028,6556),(158029,6556),(158030,6557),(158031,6557),(158032,6557),(158033,6557),(158034,6557),(158035,6557),(158036,6557),(158037,6558),(158038,6558),(158039,6558),(158040,6558),(158041,6558),(158042,6558),(158043,6558),(158044,6559),(158045,6559),(158046,6559),(158047,6559),(158048,6559),(158049,6559),(158050,6559),(158051,6560),(158052,6560),(158053,6560),(158054,6560),(158055,6560),(158056,6560),(158057,6560),(158058,6561),(158059,6561),(158060,6561),(158061,6561),(158062,6561),(158063,6561),(158064,6561),(158065,6562),(158066,6562),(158067,6562),(158068,6562),(158069,6562),(158070,6562),(158071,6562),(158072,6563),(158073,6563),(158074,6563),(158075,6563),(158076,6563),(158077,6563),(158078,6563),(158079,6564),(158080,6564),(158081,6564),(158082,6564),(158083,6564),(158084,6565),(158085,6565),(158086,6565),(158087,6565),(158088,6565),(158089,6566),(158090,6566),(158091,6566),(158092,6566),(158093,6566),(158094,6567),(158095,6567),(158096,6567),(158097,6567),(158098,6567),(158099,6568),(158100,6568),(158101,6568),(158102,6568),(158103,6568),(158104,6569),(158105,6569),(158106,6569),(158107,6569),(158108,6569),(158109,6570),(158110,6570),(158111,6570),(158112,6570),(158113,6570),(158114,6571),(158115,6571),(158116,6571),(158117,6571),(158118,6571),(158119,6572),(158120,6572),(158121,6572),(158122,6572),(158123,6572),(158124,6546),(158125,6546),(158126,6546),(158127,6546),(158128,6546),(158129,6547),(158130,6547),(158131,6547),(158132,6547),(158133,6547),(158134,6548),(158135,6548),(158136,6548),(158137,6548),(158138,6548),(158139,6549),(158140,6549),(158141,6549),(158142,6549),(158143,6549),(158144,6550),(158145,6550),(158146,6550),(158147,6550),(158148,6550),(158149,6551),(158150,6551),(158151,6551),(158152,6551),(158153,6551),(158154,6552),(158155,6552),(158156,6552),(158157,6552),(158158,6552),(158159,6553),(158160,6553),(158161,6553),(158162,6553),(158163,6553),(158164,6554),(158165,6554),(158166,6554),(158167,6554),(158168,6554),(158169,6555),(158170,6555),(158171,6555),(158172,6555),(158173,6555),(158174,6556),(158175,6556),(158176,6556),(158177,6556),(158178,6556),(158179,6557),(158180,6557),(158181,6557),(158182,6557),(158183,6557),(158184,6558),(158185,6558),(158186,6558),(158187,6558),(158188,6558),(158189,6559),(158190,6559),(158191,6559),(158192,6559),(158193,6559),(158194,6560),(158195,6560),(158196,6560),(158197,6560),(158198,6560),(158199,6561),(158200,6561),(158201,6561),(158202,6561),(158203,6561),(158204,6562),(158205,6562),(158206,6562),(158207,6562),(158208,6562),(158209,6563),(158210,6563),(158211,6563),(158212,6563),(158213,6563),(158214,6564),(158215,6564),(158216,6564),(158217,6564),(158218,6564),(158219,6565),(158220,6565),(158221,6565),(158222,6565),(158223,6565),(158224,6566),(158225,6566),(158226,6566),(158227,6566),(158228,6566),(158229,6567),(158230,6567),(158231,6567),(158232,6567),(158233,6567),(158234,6568),(158235,6568),(158236,6568),(158237,6568),(158238,6568),(158239,6569),(158240,6569),(158241,6569),(158242,6569),(158243,6569),(158244,6570),(158245,6570),(158246,6570),(158247,6570),(158248,6570),(158249,6571),(158250,6571),(158251,6571),(158252,6571),(158253,6571),(158254,6572),(158255,6572),(158256,6572),(158257,6572),(158258,6572);
/*!40000 ALTER TABLE `catalogsearch_fulltext_cl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalogsearch_recommendations`
--

DROP TABLE IF EXISTS `catalogsearch_recommendations`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `catalogsearch_recommendations` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `query_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Query ID',
  `relation_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Relation ID',
  PRIMARY KEY (`id`),
  KEY `CATALOGSEARCH_RECOMMENDATIONS_QUERY_ID_SEARCH_QUERY_QUERY_ID` (`query_id`),
  KEY `CATALOGSEARCH_RECOMMENDATIONS_RELATION_ID_SEARCH_QUERY_QUERY_ID` (`relation_id`),
  CONSTRAINT `CATALOGSEARCH_RECOMMENDATIONS_QUERY_ID_SEARCH_QUERY_QUERY_ID` FOREIGN KEY (`query_id`) REFERENCES `search_query` (`query_id`) ON DELETE CASCADE,
  CONSTRAINT `CATALOGSEARCH_RECOMMENDATIONS_RELATION_ID_SEARCH_QUERY_QUERY_ID` FOREIGN KEY (`relation_id`) REFERENCES `search_query` (`query_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Advanced Search Recommendations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalogsearch_recommendations`
--

LOCK TABLES `catalogsearch_recommendations` WRITE;
/*!40000 ALTER TABLE `catalogsearch_recommendations` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalogsearch_recommendations` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `checkout_agreement`
--

DROP TABLE IF EXISTS `checkout_agreement`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `checkout_agreement` (
  `agreement_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Agreement ID',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `content` text COMMENT 'Content',
  `content_height` varchar(25) DEFAULT NULL COMMENT 'Content Height',
  `checkbox_text` text COMMENT 'Checkbox Text',
  `is_active` smallint NOT NULL DEFAULT '0' COMMENT 'Is Active',
  `is_html` smallint NOT NULL DEFAULT '0' COMMENT 'Is Html',
  `mode` smallint NOT NULL DEFAULT '0' COMMENT 'Applied mode',
  PRIMARY KEY (`agreement_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Checkout Agreement';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `checkout_agreement`
--

LOCK TABLES `checkout_agreement` WRITE;
/*!40000 ALTER TABLE `checkout_agreement` DISABLE KEYS */;
/*!40000 ALTER TABLE `checkout_agreement` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `checkout_agreement_store`
--

DROP TABLE IF EXISTS `checkout_agreement_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `checkout_agreement_store` (
  `agreement_id` int unsigned NOT NULL COMMENT 'Agreement ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  PRIMARY KEY (`agreement_id`,`store_id`),
  KEY `CHECKOUT_AGREEMENT_STORE_STORE_ID_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `CHECKOUT_AGREEMENT_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `CHKT_AGRT_STORE_AGRT_ID_CHKT_AGRT_AGRT_ID` FOREIGN KEY (`agreement_id`) REFERENCES `checkout_agreement` (`agreement_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Checkout Agreement Store';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `checkout_agreement_store`
--

LOCK TABLES `checkout_agreement_store` WRITE;
/*!40000 ALTER TABLE `checkout_agreement_store` DISABLE KEYS */;
/*!40000 ALTER TABLE `checkout_agreement_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cisin_salesordergrid_items`
--

DROP TABLE IF EXISTS `cisin_salesordergrid_items`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cisin_salesordergrid_items` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id',
  `name` text COMMENT 'Name',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='cisin_salesordergrid_items';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cisin_salesordergrid_items`
--

LOCK TABLES `cisin_salesordergrid_items` WRITE;
/*!40000 ALTER TABLE `cisin_salesordergrid_items` DISABLE KEYS */;
/*!40000 ALTER TABLE `cisin_salesordergrid_items` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cms_block`
--

DROP TABLE IF EXISTS `cms_block`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cms_block` (
  `block_id` smallint NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `title` varchar(255) NOT NULL COMMENT 'Block Title',
  `identifier` varchar(255) NOT NULL COMMENT 'Block String Identifier',
  `content` mediumtext COMMENT 'Block Content',
  `creation_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Block Creation Time',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Block Modification Time',
  `is_active` smallint NOT NULL DEFAULT '1' COMMENT 'Is Block Active',
  PRIMARY KEY (`block_id`),
  KEY `CMS_BLOCK_IDENTIFIER` (`identifier`),
  FULLTEXT KEY `CMS_BLOCK_TITLE_IDENTIFIER_CONTENT` (`title`,`identifier`,`content`)
) ENGINE=InnoDB AUTO_INCREMENT=56 DEFAULT CHARSET=utf8mb3 COMMENT='CMS Block Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cms_block`
--

LOCK TABLES `cms_block` WRITE;
/*!40000 ALTER TABLE `cms_block` DISABLE KEYS */;
INSERT INTO `cms_block` VALUES (1,'About Banyo','About-Banyo','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;h2 class=\"text-2xl font-bold mb-4\"&gt;Welcome to Banyo - Where Quality Meets Expertise&lt;/h2&gt;\r\n&lt;p&gt;At Banyo, we bring you &lt;strong&gt;the best in bathrooms, designer fires, and kitchen products,&lt;/strong&gt; all at your fingertips. For &lt;strong&gt;over 20 years,&lt;/strong&gt; our family-run business has proudly served customers across the East Midlands and beyond. Based in Leicester, we operate from two well-established showrooms, where our expert team is dedicated to providing exceptional pre- and post-sales support.&lt;/p&gt;\r\n&lt;p&gt;Discover our commitment to quality, innovation, and customer satisfaction as we help you transform your bathroom into a personal sanctuary.&lt;/p&gt;\r\n</div>','2024-08-12 13:15:58','2024-10-14 09:57:17',1),(2,'Boss your Bathroom','Boss-your-Bathroom','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;h2 class=\"text-2xl font-bold mb-4\"&gt;The Banyo Advantage&lt;/h2&gt;\r\n&lt;p&gt;We’re the first choice for homeowners and businesses when it comes to property refurbishments, both commercial and residential. Our success comes from over two decades of industry expertise, a handpicked selection of premium products, and our commitment to delivering a seamless online and showroom experience.&lt;/p&gt;\r\n&lt;p&gt;We proudly offer high-end brands, personalized service, and expert advice to help you create spaces that truly reflect your style and needs.&lt;/p&gt;\r\n</div>','2024-08-12 13:18:27','2024-10-14 10:06:30',1),(3,'Homepage Banner slider','homepage-banner-slider','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;script&gt;\r\n        document.addEventListener(\'alpine:init\', () =&gt; {\r\n            Alpine.data(\'slider\', () =&gt; ({\r\n                currentSlide: 0,\r\n                slides: [\r\n                    {\r\n                        src: \'/media/wysiwyg/Banner-01.jpg\',\r\n                        mobileSrc: \'/media/wysiwyg/Web-03.jpg\',\r\n                        alt: \'Slide 1\'\r\n                    },\r\n                    {\r\n                        src: \'/media/wysiwyg/Banner-02.jpg\',\r\n                        mobileSrc: \'/media/wysiwyg/Web-04.jpg\',\r\n                        alt: \'Slide 2\'\r\n                    },\r\n                    {\r\n                        src: \'/media/wysiwyg/banner3.png\',\r\n                        mobileSrc: \'/media/wysiwyg/banner3.png\',\r\n                        alt: \'Slide 3\'\r\n                    },\r\n                ],\r\n                interval: null,\r\n\r\n                // Start the automatic slide show\r\n                init() {\r\n                    this.startAutoSlide();\r\n                },\r\n\r\n                // Change to the next slide\r\n                nextSlide() {\r\n                    this.currentSlide = (this.currentSlide + 1) % this.slides.length;\r\n                },\r\n\r\n                // Change to the previous slide\r\n                prevSlide() {\r\n                    this.currentSlide = (this.currentSlide - 1 + this.slides.length) % this.slides.length;\r\n                },\r\n\r\n                // Go to a specific slide\r\n                goToSlide(index) {\r\n                    this.currentSlide = index;\r\n                },\r\n\r\n                // Start automatic slide transition\r\n                startAutoSlide() {\r\n                    this.interval = setInterval(() =&gt; {\r\n                        this.nextSlide();\r\n                    }, 5000); // Change slide every 3 seconds\r\n                },\r\n\r\n                // Stop automatic slide transition\r\n                stopAutoSlide() {\r\n                    clearInterval(this.interval);\r\n                }\r\n            }));\r\n        });\r\n    &lt;/script&gt;</div>','2024-08-19 09:10:11','2024-08-23 12:01:37',1),(4,'Shop by','shop-by','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;section class=\"shop_by\"&gt;\r\n    &lt;div class=\"container p-6\"&gt;\r\n        &lt;h2 class=\"text-center text-3xl font-bold text-blue-900 mb-6 sm:text-left\"&gt;Shop by Category Test&lt;/h2&gt;\r\n        &lt;div class=\"grid lg:grid-cols-6 gap-7\"&gt;\r\n\r\n            &lt;!-- Category 1 --&gt;\r\n            &lt;div class=\"bg-white rounded-lg overflow-hidden shadow-md\"&gt;\r\n&lt;img src=\"{{media url=.renditions/wysiwyg/Bathtub.H03.2k..png}}\" alt=\"\" /&gt;\r\n\r\n                &lt;div class=\"py-2 text-center\"&gt;\r\n                    &lt;span class=\"text-sm font-semibold\"&gt;Bath&lt;/span&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;!-- Category 2 --&gt;\r\n            &lt;div class=\"bg-white rounded-lg overflow-hidden shadow-md\"&gt;\r\n&lt;img src=\"{{media url=.renditions/wysiwyg/Classic_Pedestal_Bathroom_Sink.H03.2k.png}}\" alt=\"\" /&gt;\r\n                &lt;div class=\"py-2 text-center\"&gt;\r\n                    &lt;span class=\"text-sm font-semibold\"&gt;Basins&lt;/span&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;!-- Category 3 --&gt;\r\n            &lt;div class=\"bg-white rounded-lg overflow-hidden shadow-md\"&gt;\r\n&lt;img src=\"{{media url=.renditions/wysiwyg/White_Wall_Hung_Toilet_With_Soft_Close_Seat.G03.2k.png}}\" alt=\"\" /&gt;\r\n                &lt;div class=\"py-2 text-center\"&gt;\r\n                    &lt;span class=\"text-sm font-semibold\"&gt;Toilets&lt;/span&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;!-- Category 4 --&gt;\r\n            &lt;div class=\"bg-white rounded-lg overflow-hidden shadow-md\"&gt;\r\n&lt;img src=\"{{media url=.renditions/wysiwyg/Bathroom_Classical_Style_Shower_System.H03.2k.png}}\" alt=\"\" /&gt;\r\n                &lt;div class=\"py-2 text-center\"&gt;\r\n                    &lt;span class=\"text-sm font-semibold\"&gt;Showers&lt;/span&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n\r\n            &lt;!-- Category 5--&gt;\r\n            &lt;div class=\"bg-white rounded-lg overflow-hidden shadow-md\"&gt;\r\n&lt;img src=\"{{media url=.renditions/wysiwyg/Classical_Chrome_Shower.H03.2k.png}}\" alt=\"\" /&gt;\r\n                &lt;div class=\"py-2 text-center\"&gt;\r\n                    &lt;span class=\"text-sm font-semibold\"&gt;Shower Enclosures&lt;/span&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Category 6--&gt;\r\n            &lt;div class=\"bg-white rounded-lg overflow-hidden shadow-md\"&gt;\r\n               &lt;img src=\"{{media url=.renditions/wysiwyg/Kitchen_Sink.F16.2k.png}}\" alt=\"bath\" class=\"w-full h-32 object-cover\"/&gt;\r\n                &lt;div class=\"py-2 text-center\"&gt;\r\n                    &lt;span class=\"text-sm font-semibold\"&gt;Shower Enclosures&lt;/span&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Category 7--&gt;\r\n            &lt;div class=\"bg-white rounded-lg overflow-hidden shadow-md\"&gt;\r\n               &lt;img src=\"{{media url=.renditions/wysiwyg/bath.jpeg}}\" alt=\"bath\" class=\"w-full h-32 object-cover\"/&gt;\r\n                &lt;div class=\"py-2 text-center\"&gt;\r\n                    &lt;span class=\"text-sm font-semibold\"&gt;Kitchen Sinks&lt;/span&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Category 8--&gt;\r\n            &lt;div class=\"bg-white rounded-lg overflow-hidden shadow-md\"&gt;\r\n               &lt;img src=\"{{media url=.renditions/wysiwyg/bath.jpeg}}\" alt=\"bath\" class=\"w-full h-32 object-cover\"/&gt;\r\n                &lt;div class=\"py-2 text-center\"&gt;\r\n                    &lt;span class=\"text-sm font-semibold\"&gt;Shower Enclosures&lt;/span&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Category 9--&gt;\r\n            &lt;div class=\"bg-white rounded-lg overflow-hidden shadow-md\"&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/bath.jpeg}}\" alt=\"bath\" class=\"w-full h-32 object-cover\"/&gt;\r\n                &lt;div class=\"py-2 text-center\"&gt;\r\n                    &lt;span class=\"text-sm font-semibold\"&gt;Shower Enclosures&lt;/span&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Category 10--&gt;\r\n            &lt;div class=\"bg-white rounded-lg overflow-hidden shadow-md\"&gt;\r\n            &lt;img src=\"{{media url=.renditions/wysiwyg/bath.jpeg}}\" alt=\"bath\" class=\"w-full h-32 object-cover\"/&gt;\r\n                &lt;div class=\"py-2 text-center\"&gt;\r\n                    &lt;span class=\"text-sm font-semibold\"&gt;Shower Enclosures&lt;/span&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Category 11--&gt;\r\n            &lt;div class=\"bg-white rounded-lg overflow-hidden shadow-md\"&gt;\r\n               &lt;img src=\"{{media url=.renditions/wysiwyg/bath.jpeg}}\" alt=\"bath\" class=\"w-full h-32 object-cover\"/&gt;\r\n                &lt;div class=\"py-2 text-center\"&gt;\r\n                    &lt;span class=\"text-sm font-semibold\"&gt;Shower Enclosures&lt;/span&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Category 12--&gt;\r\n            &lt;div class=\"bg-white rounded-lg overflow-hidden shadow-md\"&gt;\r\n               &lt;img src=\"{{media url=.renditions/wysiwyg/bath.jpeg}}\" alt=\"bath\" class=\"w-full h-32 object-cover\"/&gt;\r\n                &lt;div class=\"py-2 text-center\"&gt;\r\n                    &lt;span class=\"text-sm font-semibold\"&gt;Shower Enclosures&lt;/span&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n&lt;/section&gt;</div>','2024-08-20 05:55:52','2024-08-22 16:50:43',1),(5,'Homepage Decor','homepage-decor','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;section class=\"decor 2-col\"&gt;\r\n    &lt;div class=\"bg-white py-6\"&gt;\r\n        &lt;div class=\"flex\"&gt;\r\n            &lt;!-- Left Banner --&gt;\r\n            &lt;div class=\"w-1/4 bg-white shadow-md decor-left\"&gt;\r\n                &lt;h2 class=\"text-3xl font-bold text-blue-900 pb-4 sm:hidden\"&gt;Kitchen Sinks&lt;/h2&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/decor.png}}\" alt=\"\" class=\"w-full h-96 mb-4\" /&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;!-- Product Grid --&gt;\r\n            &lt;div class=\"w-3/4 pl-4 px-4 relative\"&gt;\r\n                &lt;h2 class=\"text-3xl font-bold text-blue-900 pb-4 desktop\"&gt;Test Kitchen Sinks&lt;/h2&gt;\r\n\r\n\r\n                {{widget type=\"Magento\\CatalogWidget\\Block\\Product\\ProductsList\" show_pager=\"0\" products_count=\"10\"\r\n                template=\"Magento_CatalogWidget::product/widget/content/grid.phtml\"\r\n                conditions_encoded=\"^[`1`:^[`type`:`Magento||CatalogWidget||Model||Rule||Condition||Combine`,`aggregator`:`all`,`value`:`1`,`new_child`:``^],`1--1`:^[`type`:`Magento||CatalogWidget||Model||Rule||Condition||Product`,`attribute`:`category_ids`,`operator`:`==`,`value`:`163`^]^]\"}}\r\n                &lt;div class=\"text-right mt-6 decor-btn\"&gt;\r\n                    &lt;a href=\"#\" class=\"text-blue-500 text-red-500 font-semibold\"&gt;View All&lt;/a&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n&lt;/section&gt;</div>','2024-08-20 06:00:46','2024-08-26 06:23:44',1),(6,'Homepage Bestseller','homepage-bestseller','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;section class=\"best-seller\"&gt;\r\n    &lt;div class=\"container p-6\"&gt;\r\n        &lt;h2 class=\"text-center text-3xl font-bold text-blue-900 mb-6\"&gt;Bestsellers Test&lt;/h2&gt;\r\n        &lt;div class=\"grid grid-cols-4 gap-1\"&gt;\r\n\r\n            &lt;!-- Product 1 --&gt;\r\n            &lt;div class=\"bg-white overflow-hidden shadow-md text-center\"&gt;\r\n&lt;img src=\"{{media url=.renditions/wysiwyg/kitchen1.png}}\" alt=\"\" class=\"w-full h-40 object-cover mb-4\"/&gt;\r\n                &lt;h3 class=\"text-xs font-semibold text-gray-700\"&gt;Reginox Comfort Colorado L&lt;br&gt; Integrated 1 Bowl Kitchen\r\n                    Sink&lt;/h3&gt;\r\n                &lt;p class=\"text-red-500 font-bold mt-2\"&gt;£345.99&lt;/p&gt;\r\n                &lt;div class=\"flex items-center mt-2 justify-center\"&gt;\r\n&lt;img src=\"{{media url=.renditions/wysiwyg/Star-ratings.png}}\" alt=\"\" class=\"rating\"/&gt;\r\n                    &lt;span class=\"text-sm text-gray-500 ml-2\"&gt;(454)&lt;/span&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;!-- Product 2 --&gt;\r\n            &lt;div class=\"bg-white overflow-hidden shadow-md text-center\"&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/kitchen1.png}}\" alt=\"\" class=\"w-full h-40 object-cover mb-4\"/&gt;\r\n                &lt;h3 class=\"text-xs font-semibold text-gray-700\"&gt;Reginox Comfort Colorado L&lt;br&gt; Integrated 1 Bowl Kitchen\r\n                    Sink&lt;/h3&gt;\r\n                &lt;p class=\"text-red-500 font-bold mt-2\"&gt;£345.99&lt;/p&gt;\r\n                &lt;div class=\"flex items-center mt-2 justify-center\"&gt;\r\n                    &lt;img src=\"{{media url=.renditions/wysiwyg/Star-ratings.png}}\" alt=\"\" class=\"rating\"/&gt;\r\n                    &lt;span class=\"text-sm text-gray-500 ml-2\"&gt;(454)&lt;/span&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;!-- Product 3 --&gt;\r\n            &lt;div class=\"bg-white overflow-hidden shadow-md text-center\"&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/kitchen1.png}}\" alt=\"\" class=\"w-full h-40 object-cover mb-4\"/&gt;\r\n                &lt;h3 class=\"text-xs font-semibold text-gray-700\"&gt;Reginox Comfort Colorado L&lt;br&gt; Integrated 1 Bowl Kitchen\r\n                    Sink&lt;/h3&gt;\r\n                &lt;p class=\"text-red-500 font-bold mt-2\"&gt;£345.99&lt;/p&gt;\r\n                &lt;div class=\"flex items-center mt-2 justify-center\"&gt;\r\n                    &lt;img src=\"{{media url=.renditions/wysiwyg/Star-ratings.png}}\" alt=\"\" class=\"rating\"/&gt;\r\n                    &lt;span class=\"text-sm text-gray-500 ml-2\"&gt;(454)&lt;/span&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;!-- Product 4 --&gt;\r\n            &lt;div class=\"bg-white overflow-hidden shadow-md text-center\"&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/kitchen1.png}}\" alt=\"\" class=\"w-full h-40 object-cover mb-4\"/&gt;\r\n                &lt;h3 class=\"text-xs font-semibold text-gray-700\"&gt;Reginox Comfort Colorado L&lt;br&gt; Integrated 1 Bowl Kitchen\r\n                    Sink&lt;/h3&gt;\r\n                &lt;p class=\"text-red-500 font-bold mt-2\"&gt;£345.99&lt;/p&gt;\r\n                &lt;div class=\"flex items-center mt-2 justify-center\"&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/Star-ratings.png}}\" alt=\"\" class=\"rating\"/&gt;\r\n                    &lt;span class=\"text-sm text-gray-500 ml-2\"&gt;(454)&lt;/span&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n\r\n\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n&lt;/section&gt;</div>','2024-08-20 06:31:24','2025-01-27 08:19:53',0),(7,'Homepage Comfort bath enclosures','homepage-comfort','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;section class=\"decor comfort 2-col\"&gt;\r\n    &lt;div class=\"bg-white py-6\"&gt;\r\n        &lt;div class=\"flex\"&gt;\r\n\r\n\r\n            &lt;!-- Product Grid --&gt;\r\n            &lt;div class=\"w-3/4 pl-4 px-4 relative\"&gt;\r\n                &lt;h2 class=\"text-3xl font-bold text-blue-900 pb-4 desktop\"&gt;Bath Enclosures Test&lt;/h2&gt;\r\n\r\n{{widget type=\"Magento\\CatalogWidget\\Block\\Product\\ProductsList\" show_pager=\"0\" products_count=\"10\" template=\"Magento_CatalogWidget::product/widget/content/grid.phtml\" conditions_encoded=\"^[`1`:^[`type`:`Magento||CatalogWidget||Model||Rule||Condition||Combine`,`aggregator`:`all`,`value`:`1`,`new_child`:``^],`1--1`:^[`type`:`Magento||CatalogWidget||Model||Rule||Condition||Product`,`attribute`:`category_ids`,`operator`:`==`,`value`:`164`^]^]\"}}\r\n\r\n           &lt;div class=\"text-right mt-6 decor-btn\"&gt;\r\n            &lt;a href=\"#\" class=\"text-blue-500 text-red-500 font-semibold\"&gt;View All&lt;/a&gt;\r\n        &lt;/div&gt;   \r\n            &lt;/div&gt;\r\n\r\n            &lt;!-- Right Banner --&gt;\r\n            &lt;div class=\"w-1/4 bg-white shadow-md decor-left\"&gt;\r\n                &lt;h2 class=\"text-3xl font-bold text-blue-900 pb-4 sm:hidden\"&gt;Bath Enclosures&lt;/h2&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/comfort.png}}\" alt=\"comfort\" class=\"w-full h-96 mb-4\" /&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n&lt;/section&gt;</div>','2024-08-20 06:39:50','2024-08-26 06:25:25',1),(8,'Homepage Brand','homepage-brand','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;section class=\"brand\"&gt;\r\n    &lt;div class=\"container mx-auto py-6\"&gt;\r\n        &lt;h2 class=\"text-center font-bold mb-6 text-3xl text-blue-900\"&gt;Brands Test&lt;/h2&gt;\r\n        &lt;div class=\"grid grid-cols-1 sm:grid-cols-2 md:grid-cols-3 lg:grid-cols-5 gap-9\"&gt;\r\n            &lt;!-- Brand 1 --&gt;\r\n            &lt;div class=\"block flex flex-col items-center\"&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/test_image.jpg}}\" alt=\"\" class=\"rounded-lg shadow-lg mb-4\" /&gt;\r\n                &lt;div class=\"top-brand\"&gt;\r\n\r\n                    &lt;img src=\"{{media url=.renditions/wysiwyg/1.png}}\" alt=\"Joseph Miles\" class=\"\" /&gt;\r\n                &lt;/div&gt;\r\n\r\n            &lt;/div&gt;\r\n            &lt;!-- Brand 2 --&gt;\r\n            &lt;div class=\"block flex flex-col items-center\"&gt;\r\n\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/2.png}}\" alt=\"\" class=\"rounded-lg shadow-lg mb-4\" /&gt;\r\n                &lt;div class=\"top-brand\"&gt;\r\n                    &lt;img src=\"{{media url=.renditions/wysiwyg/geberit.png}}\" alt=\"Joseph Miles\" class=\"\" /&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Brand 3 --&gt;\r\n            &lt;div class=\"block flex flex-col items-center\"&gt;\r\n\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/3.png}}\" alt=\"\" class=\"rounded-lg shadow-lg mb-4\" /&gt;\r\n                &lt;div class=\"top-brand\"&gt;\r\n                    &lt;img src=\"{{media url=.renditions/wysiwyg/crosswater.png}}\" alt=\"Joseph Miles\" class=\"\" /&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Brand 4 --&gt;\r\n            &lt;div class=\"block flex flex-col items-center\"&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/4.png}}\" alt=\"\" class=\"rounded-lg shadow-lg mb-4\" /&gt;\r\n                &lt;div class=\"top-brand\"&gt;\r\n                    &lt;img src=\"{{media url=.renditions/wysiwyg/rak.png}}\" alt=\"Joseph Miles\" class=\"\" /&gt;\r\n\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Brand 5 --&gt;\r\n            &lt;div class=\"block flex flex-col items-center\"&gt;\r\n\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/5.png}}\" alt=\"\" class=\"rounded-lg shadow-lg mb-4\" /&gt;\r\n                &lt;div class=\"top-brand\"&gt;\r\n                    &lt;img src=\"{{media url=.renditions/wysiwyg/duravit.png}}\" alt=\"Joseph Miles\" class=\"\" /&gt;\r\n\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n        &lt;div class=\"text-right mt-6 container\"&gt;\r\n            &lt;a href=\"#\" class=\"text-blue-500 text-red-500 font-semibold\"&gt;View All&lt;/a&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n&lt;/section&gt;</div>','2024-08-20 06:50:26','2025-01-27 08:22:39',0),(9,'Homepage Ideas Inspiration','homepage-ideas-inspiration','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;section class=\"ideas-inspiration py-6 bg-white\"&gt;\r\n    &lt;div class=\"container mx-auto\"&gt;\r\n        &lt;div class=\"flex justify-between items-end mb-6\"&gt;\r\n            &lt;h2 class=\"font-bold text-3xl text-blue-900\"&gt;Ideas and Inspiration&lt;/h2&gt;\r\n            &lt;a href=\"#\" class=\"text-red-500 font-semibold desktop\"&gt;See all articles&lt;/a&gt;\r\n        &lt;/div&gt;\r\n        &lt;div class=\"grid grid-cols-1 sm:grid-cols-2 lg:grid-cols-4 gap-6\"&gt;\r\n            &lt;!-- Article 1 --&gt;\r\n            &lt;div class=\"bg-white rounded-lg shadow-lg overflow-hidden\"&gt;\r\n\r\n&lt;img src=\"{{media url=.renditions/wysiwyg/test_image.jpg}}\" alt=\"\" class=\"w-full h-48 object-cover\"/&gt;\r\n                &lt;div class=\"flex justify-between items-center mb-2 date-txt px-4\"&gt;\r\n                    &lt;span class=\"text-white text-xs font-medium\"&gt;Buying Guide&lt;/span&gt;\r\n                    &lt;span class=\"text-white text-sm\"&gt;22 Aug 2024 Test&lt;/span&gt;\r\n                &lt;/div&gt;\r\n                &lt;div class=\"p-4\"&gt;\r\n\r\n                    &lt;h3 class=\"text-lg font-bold mb-2\"&gt;How to Buy a Contemporary Basin? Test&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-700 mb-4 text-xs\"&gt;Test Swapping out your fixture is a fantastic option if you want to\r\n                        upgrade your bathroom...&lt;/p&gt;\r\n                    &lt;a href=\"#\"\r\n                        class=\"inline-block text-sm px-4 py-1 text-blue-600 border border-blue-600 rounded hover:bg-blue-600 hover:text-white\"&gt;Read\r\n                        More&lt;/a&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Article 2 --&gt;\r\n            &lt;div class=\"bg-white rounded-lg shadow-lg overflow-hidden\"&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/small.jpeg}}\" alt=\"\" class=\"w-full h-48 object-cover\"/&gt;\r\n                &lt;div class=\"flex justify-between items-center mb-2 date-txt px-4\"&gt;\r\n                    &lt;span class=\"text-white font-medium text-xs\"&gt;Buying Guide&lt;/span&gt;\r\n                    &lt;span class=\"text-white text-sm\"&gt;05 Aug 2024&lt;/span&gt;\r\n                &lt;/div&gt;\r\n                &lt;div class=\"p-4\"&gt;\r\n\r\n                    &lt;h3 class=\"text-lg font-bold mb-2\"&gt;How to Buy a Contemporary Basin?&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-700 mb-4 text-xs\"&gt;Swapping out your fixture is a fantastic option if you want to\r\n                        upgrade your bathroom...&lt;/p&gt;\r\n                    &lt;a href=\"#\"\r\n                        class=\"inline-block text-sm px-4 py-1 text-blue-600 border border-blue-600 rounded hover:bg-blue-600 hover:text-white\"&gt;Read\r\n                        More&lt;/a&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Article 3 --&gt;\r\n            &lt;div class=\"bg-white rounded-lg shadow-lg overflow-hidden\"&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/small.jpeg}}\" alt=\"\" class=\"w-full h-48 object-cover\"/&gt;\r\n                &lt;div class=\"flex justify-between items-center mb-2 date-txt px-4\"&gt;\r\n                    &lt;span class=\"text-white font-medium text-xs\"&gt;Buying Guide&lt;/span&gt;\r\n                    &lt;span class=\"text-white text-sm\"&gt;05 Aug 2024&lt;/span&gt;\r\n                &lt;/div&gt;\r\n                &lt;div class=\"p-4\"&gt;\r\n\r\n                    &lt;h3 class=\"text-lg font-bold mb-2\"&gt;How to Buy a Contemporary Basin?&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-700 mb-4 text-xs\"&gt;Swapping out your fixture is a fantastic option if you want to\r\n                        upgrade your bathroom...&lt;/p&gt;\r\n                    &lt;a href=\"#\"\r\n                        class=\"inline-block text-sm px-4 py-1 text-blue-600 border border-blue-600 rounded hover:bg-blue-600 hover:text-white\"&gt;Read\r\n                        More&lt;/a&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Article 4 --&gt;\r\n            &lt;div class=\"bg-white rounded-lg shadow-lg overflow-hidden\"&gt;\r\n               &lt;img src=\"{{media url=.renditions/wysiwyg/small.jpeg}}\" alt=\"\" class=\"w-full h-48 object-cover\"/&gt;\r\n                &lt;div class=\"flex justify-between items-center mb-2 date-txt px-4\"&gt;\r\n                    &lt;span class=\"text-white font-medium text-xs\"&gt;Buying Guide&lt;/span&gt;\r\n                    &lt;span class=\"text-white text-sm\"&gt;05 Aug 2024&lt;/span&gt;\r\n                &lt;/div&gt;\r\n                &lt;div class=\"p-4\"&gt;\r\n                    &lt;h3 class=\"text-lg font-bold mb-2\"&gt;How to Buy a Contemporary Basin?&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-700 mb-4 text-xs\"&gt;Swapping out your fixture is a fantastic option if you want to\r\n                        upgrade your bathroom...&lt;/p&gt;\r\n                    &lt;a href=\"#\"\r\n                        class=\"inline-block text-sm px-4 py-1 text-blue-600 border border-blue-600 rounded hover:bg-blue-600 hover:text-white\"&gt;Read\r\n                        More&lt;/a&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n        &lt;a href=\"#\" class=\"text-red-500 font-semibold sm:hidden\"&gt;See all articles&lt;/a&gt;\r\n    &lt;/div&gt;\r\n&lt;/section&gt;</div>','2024-08-20 07:27:08','2024-10-14 09:26:53',1),(10,'Homepage Slider Content','homepage-slider-content','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"p-8 bg-blue-900 text-white absolute slider-content\"&gt;\r\n        &lt;h1 class=\"text-6xl font-bold\"&gt;&lt;span class=\"text-2xl\"&gt;Your&lt;br /&gt;&lt;/span&gt; Trade Discount&lt;/h1&gt;\r\n        &lt;p class=\"mt-1 text-3xl font-thin have-land\"&gt;Have Landed&lt;/p&gt;\r\n        &lt;p class=\"mt-2 text-2xl font-thin\"&gt;Discover Exclusive Benefits with a &lt;br /&gt;&lt;span\r\n                class=\"font-semibold underline sm:no-underline\"&gt;Trade Account&lt;/span&gt;&lt;/p&gt;\r\n        &lt;ul class=\"mt-5 space-y-2\"&gt;\r\n            &lt;li class=\"flex items-center text-xl font-thin mt-1\"&gt;\r\n                &lt;img src=\"/media/wysiwyg/1-s.svg\" alt=\"Check Icon\" class=\"w-6 h-6 mr-2\"&gt;\r\n                Great Prices\r\n            &lt;/li&gt;\r\n            &lt;li class=\"flex items-center text-xl font-thin mt-1\"&gt;\r\n                &lt;img src=\"/media/wysiwyg/2-s.svg\" alt=\"Check Icon\" class=\"w-6 h-6 mr-2\"&gt;\r\n                Exclusive Discounts\r\n            &lt;/li&gt;\r\n            &lt;li class=\"flex items-center text-xl font-thin mt-1\"&gt;\r\n                &lt;img src=\"/media/wysiwyg/3-s.svg\" alt=\"Check Icon\" class=\"w-6 h-6 mr-2\"&gt;\r\n                365 Days Exchange\r\n            &lt;/li&gt;\r\n            &lt;li class=\"flex items-center text-xl font-thin mt-1\"&gt;\r\n                &lt;img src=\"/media/wysiwyg/4-s.svg\" class=\"w-6 h-6 mr-2\"&gt;\r\n                Dedicated Account Manager\r\n            &lt;/li&gt;\r\n        &lt;/ul&gt;\r\n        &lt;a href=\"#\"\r\n            class=\"inline-block mt-6 px-4 text-white text-blue-900 font-thin rounded-md text-xl underline\"&gt;Get\r\n            Started&lt;span&gt;&lt;img src=\"/media/wysiwyg/right-arrow.svg\"\r\n                    alt=\"Check Icon\" class=\"w-6 h-6 mr-2\"&gt;&lt;/span&gt;&lt;/a&gt;\r\n    &lt;/div&gt;</div>','2024-08-20 07:42:12','2025-01-09 21:29:28',1),(11,'Blue Fast Trustpilot Promise  Desktop','blue-fast-trustpilot-promise','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"hidden sm:flex justify-between bg-white pt-2\"&gt;\r\n        &lt;!-- Fast Delivery --&gt;\r\n        &lt;div class=\"flex flex-col items-center justify-between text-white p-3\"&gt;\r\n           \r\n&lt;img src=\"/media/wysiwyg/delivery-icon.svg\" alt=\"\" /&gt;\r\n\r\n            &lt;span class=\"text-base font-semibold\"&gt;Test Fast Delivery&lt;/span&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;!-- Trustpilot --&gt;\r\n        &lt;div class=\"flex flex-col items-center justify-between text-white p-3\"&gt;\r\n&lt;img src=\"/media/wysiwyg/trust_icon.svg\" alt=\"\" /&gt;\r\n            &lt;span class=\"text-xs font-normal\"&gt;Test Trust Score 4.9 | 659 Reviews&lt;/span&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;!-- Price Match Promise --&gt;\r\n        &lt;div class=\"flex flex-col items-center justify-between text-white p-3\"&gt;    \r\n&lt;img src=\"/media/wysiwyg/promise.svg\" alt=\"\"&gt;\r\n            &lt;span class=\"text-base font-semibold\"&gt;Test Price Match Promise&lt;/span&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;</div>','2024-08-20 08:06:17','2024-08-23 10:55:39',1),(12,'Top Text mobile','top-text-mobile','<div class=\"mobile-premium\" data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;section class=\"bg-white mobile-toptext pt-1\"&gt;\r\n    &lt;div class=\"top-text pt-1 pb-1 block sm:hidden\"&gt;\r\n        &lt;p class=\"text-white text-center font-bold uppercase\"&gt;Premium Sale - Upto 50% Off12 on Venice &amp; Infinity Furniture\r\n        &lt;/p&gt;\r\n    &lt;/div&gt;\r\n&lt;/section&gt;</div>','2024-08-20 08:21:50','2025-01-28 10:34:50',1),(13,'Customer Review','customer-review','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;section class=\"customer-reviews py-7\"&gt;\r\n    &lt;div class=\"container mx-auto\"&gt;\r\n        &lt;div class=\"flex justify-center items-center mb-6\"&gt;\r\n            &lt;h2 class=\"font-bold text-3xl text-blue-900 text-center\"&gt;Customers are loving it Test&lt;/h2&gt;\r\n\r\n        &lt;/div&gt;\r\n        &lt;div class=\"grid grid-cols-1 md:grid-cols-3 gap-11\"&gt;\r\n            &lt;!-- Review 1 --&gt;\r\n            &lt;div class=\"bg-white p-6 rounded-lg shadow-lg text-center py-4 m-auto\"&gt;\r\n                &lt;div class=\"mb-4 text-2xl text-blue-900 text-center\"&gt;\r\n                    \r\n&lt;img src=\"{{media url=.renditions/wysiwyg/quote-large.png}}\" alt=\"\" class=\"mx-auto\"/&gt;\r\n                &lt;/div&gt;\r\n                &lt;p class=\"text-gray-700 mb-4 text-sm w-3/5 mx-auto\"&gt;Test The first one I found in the market that gives me a\r\n                    real experience of\r\n                    having an easy payment process.&lt;/p&gt;\r\n                &lt;div class=\"flex justify-center items-center mb-4\"&gt;\r\n                    &lt;!-- Star Rating --&gt;\r\n                    \r\n&lt;img src=\"{{media url=.renditions/wysiwyg/full-rating.png}}\" alt=\"\" /&gt;\r\n                &lt;/div&gt;\r\n                &lt;div class=\"text-lg font-bold text-blue-900\"&gt;Test Danny Dario&lt;/div&gt;\r\n                &lt;div class=\"text-gray-400 text-sm\"&gt;Test 29 August 2021&lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Review 2 --&gt;\r\n            &lt;div class=\"bg-white p-6 rounded-lg shadow-lg text-center py-4 m-auto\"&gt;\r\n                &lt;div class=\"mb-4 text-2xl text-blue-900 text-center\"&gt;\r\n                    &lt;img src=\"{{media url=.renditions/wysiwyg/quote-large.png}}\" alt=\"\" class=\"mx-auto\"/&gt;\r\n                &lt;/div&gt;\r\n                &lt;p class=\"text-gray-700 mb-4 text-sm w-3/5 mx-auto\"&gt;Test The first one I found in the market that gives me a\r\n                    real experience of\r\n                    having an easy payment process.&lt;/p&gt;\r\n                &lt;div class=\"flex justify-center items-center mb-4\"&gt;\r\n                    &lt;!-- Star Rating --&gt;\r\n              &lt;img src=\"{{media url=.renditions/wysiwyg/full-rating.png}}\" alt=\"\" /&gt;\r\n                &lt;/div&gt;\r\n                &lt;div class=\"text-lg font-bold text-blue-900\"&gt;Danny Dario&lt;/div&gt;\r\n                &lt;div class=\"text-gray-400 text-sm\"&gt;Test 29 August 2021&lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Review 3 --&gt;\r\n            &lt;div class=\"bg-white p-6 rounded-lg shadow-lg text-center py-4 m-auto\"&gt;\r\n                &lt;div class=\"mb-4 text-2xl text-blue-900 text-center\"&gt;\r\n                    &lt;img src=\"{{media url=.renditions/wysiwyg/quote-large.png}}\" alt=\"\" class=\"mx-auto\"/&gt;\r\n                &lt;/div&gt;\r\n                &lt;p class=\"text-gray-700 mb-4 text-sm w-3/5 mx-auto\"&gt;The first one I found in the market that gives me a\r\n                    real experience of\r\n                    having an easy payment process.&lt;/p&gt;\r\n                &lt;div class=\"flex justify-center items-center mb-4\"&gt;\r\n                    &lt;!-- Star Rating --&gt;\r\n                    &lt;img src=\"{{media url=.renditions/wysiwyg/full-rating.png}}\" alt=\"\" /&gt;\r\n                &lt;/div&gt;\r\n                &lt;div class=\"text-lg font-bold text-blue-900\"&gt;Danny Dario&lt;/div&gt;\r\n                &lt;div class=\"text-gray-400 text-sm\"&gt;29 August 2021&lt;/div&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n        &lt;div class=\"text-right view-all\"&gt;\r\n            &lt;a href=\"#\" class=\"text-blue-500 text-red-500 font-semibold\"&gt;View All&lt;/a&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n&lt;/section&gt;</div>','2024-08-20 08:29:15','2024-10-25 11:53:07',0),(14,'Top Text Desktop','top-text-desktop','<div class=\"mobile-premium\" data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;section class=\"top-text pt-1 pb-1 sm:block hidden\"&gt;\r\n    &lt;p class=\"text-center font-bold uppercase\"&gt;Premium Sale - Upto 50% Off on Venice &amp; Infinity Furniture 1.&lt;/p&gt;\r\n&lt;/section&gt;</div>','2024-08-20 08:35:02','2025-01-28 13:11:43',1),(15,'Decor side product','decor-side-product','<style>#html-body [data-pb-style=FAUKU8S]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"FAUKU8S\"><div data-content-type=\"products\" data-appearance=\"grid\" data-element=\"main\">{{widget type=\"Magento\\CatalogWidget\\Block\\Product\\ProductsList\" template=\"Magento_CatalogWidget::product/widget/content/grid.phtml\" anchor_text=\"\" id_path=\"\" show_pager=\"0\" products_count=\"5\" condition_option=\"category_ids\" condition_option_value=\"3\" type_name=\"Catalog Products List\" conditions_encoded=\"^[`1`:^[`aggregator`:`all`,`new_child`:``,`type`:`Magento||CatalogWidget||Model||Rule||Condition||Combine`,`value`:`1`^],`1--1`:^[`operator`:`==`,`type`:`Magento||CatalogWidget||Model||Rule||Condition||Product`,`attribute`:`category_ids`,`value`:`3`^]^]\" sort_order=\"position\"}}</div></div></div>','2024-08-20 09:47:39','2024-08-20 09:52:21',1),(16,'Renovate your bathroom','home_tab_3','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;h2 class=\"text-2xl font-bold mb-4\"&gt;Renovate your Bathroom Test&lt;/h2&gt;\r\n&lt;p&gt;Discover our &lt;strong&gt;extensive bathroom collection &lt;/strong&gt;from leading brands like &lt;strong&gt;Grohe, Matki, Bette, Franke, Hansgrohe, and more&lt;/strong&gt;. Our large showroom showcases a wide range of products, including baths, showers, basins, vanity units, and complete bathroom solutions. Whether you’re looking for &lt;strong&gt;contemporary innovations or timeless elegance&lt;/strong&gt;, we have the perfect products to suit your home. &lt;strong&gt;Visit us for inspiration and expert guidance.&lt;/strong&gt;&lt;/p&gt;\r\n\r\n</div>','2024-08-20 10:57:54','2024-10-14 10:14:20',1),(17,'Fresh New look','home_tab_4','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;h2 class=\"text-2xl font-bold mb-4\"&gt;Gas, Electric and Multi-fuel&lt;/h2&gt;\r\n&lt;p&gt;&lt;strong&gt;Banyo is your destination for fires and stoves from top brands such as Dru Fires, Gazco, Flamerite, Evonic, and others. We offer a vast selection of &lt;strong&gt;gas, electric, and multi-fuel options,&lt;/strong&gt; beautifully displayed in our showrooms for you to explore.&lt;/strong&gt; Whether you\'re adding warmth to your living space, enhancing its ambiance, or seeking an eco-friendly heating solution, our range of fires and stoves ensures that you\'ll find the perfect fit for your home.&lt;/p&gt;\r\n&lt;p&gt;&lt;strong&gt;From traditional fireplaces to sleek, modern designs&lt;/strong&gt;, we cater to all tastes, with expert advice and installation services to ensure a seamless experience from selection to setup.&lt;/p&gt;\r\n</div>','2024-08-20 10:59:28','2024-10-14 10:20:40',1),(18,'Shopping Made Easy','home_tab_5','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;h2 class=\"text-2xl font-bold mb-4\"&gt;Meeting all Requirements&lt;/h2&gt;\r\n&lt;p&gt;At Banyo, we offer a &lt;strong&gt;premium selection of kitchen sinks, taps, and appliances &lt;/strong&gt;from trusted brands like &lt;strong&gt;Franke, Blanco,&lt;/strong&gt; and more. Our &lt;strong&gt;carefully curated collection &lt;/strong&gt;combines both style and functionality, providing the perfect solutions to &lt;strong&gt;elevate your kitchen space&lt;/strong&gt;. Whether you\'re looking for sleek, modern designs or durable, high-performance appliances, we have the products to meet every kitchen requirement, from everyday essentials to standout pieces.&lt;/p&gt;\r\n&lt;p&gt;With an emphasis on &lt;strong&gt;quality and craftsmanship,&lt;/strong&gt; Banyo ensures that your kitchen not only looks stunning but also works seamlessly for your needs.&lt;/p&gt;\r\n</div>','2024-08-20 11:00:36','2024-10-14 10:31:39',1),(19,'Customer First Thinking ','home_tab_6','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;h2 class=\"text-2xl font-bold mb-4\"&gt;Proven Exceptional Service &lt;/h2&gt;\r\n&lt;p&gt;At Banyo, our customers are at the heart of everything we do. With an exceptionally high rating on TrustPilot, we take pride in our dedication to delivering outstanding service and building lasting relationships. From personalized advice to dedicated post-sales support, we ensure a seamless experience at every step of your journey. Our team is committed to listening, understanding your needs, and providing tailored solutions that consistently exceed expectations, embodying our core belief in putting customers first.&lt;/p&gt;\r\n\r\n</div>','2024-08-20 11:01:44','2024-10-14 10:42:24',1),(21,'FaqTab','faq-tab','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;!-- Tab for Desktop --&gt;\r\n&lt;div x-data=\"{ activeTab: \'all\' }\" class=\" mt-6 container desktop\"&gt;\r\n    &lt;!-- Tabs --&gt;\r\n    &lt;div class=\"flex space-x-8 border-b border-gray-200\"&gt;\r\n        &lt;button @click=\"activeTab = \'all\'\" :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'all\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            All\r\n        &lt;/button&gt;\r\n        &lt;button @click=\"activeTab = \'payment\'\" :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'payment\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            Payment\r\n        &lt;/button&gt;\r\n        &lt;button @click=\"activeTab = \'order-info\'\" :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'order-info\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            Order Info\r\n        &lt;/button&gt;\r\n        &lt;button @click=\"activeTab = \'international-order\'\"\r\n            :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'international-order\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            International Order\r\n        &lt;/button&gt;\r\n        &lt;button @click=\"activeTab = \'delivery-info\'\"\r\n            :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'delivery-info\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            Delivery Information\r\n        &lt;/button&gt;\r\n        &lt;button @click=\"activeTab = \'product\'\" :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'product\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            Product\r\n        &lt;/button&gt;\r\n        &lt;button @click=\"activeTab = \'promotion\'\" :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'promotion\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            Promotion\r\n        &lt;/button&gt;\r\n        &lt;button @click=\"activeTab = \'trade\'\" :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'trade\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            Trade\r\n        &lt;/button&gt;\r\n        &lt;button @click=\"activeTab = \'returns\'\" :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'returns\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            Returns\r\n        &lt;/button&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Tab Content --&gt;\r\n    &lt;div class=\"mt-4\"&gt;\r\n        &lt;div x-show=\"activeTab === \'all\'\"&gt;\r\n            &lt;!-- Content for All Tab --&gt;\r\n            {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-all-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;div x-show=\"activeTab === \'payment\'\"&gt;\r\n            &lt;!-- Content for Payment Tab --&gt;\r\n           {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-payment-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;div x-show=\"activeTab === \'order-info\'\"&gt;\r\n            &lt;!-- Content for Order Info Tab --&gt;\r\n          {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"Faq-order-info\"}}\r\n        &lt;/div&gt;\r\n        &lt;div x-show=\"activeTab === \'international-order\'\"&gt;\r\n            &lt;!-- Content for International Order Tab --&gt;\r\n         {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-International-order-tab\"}}\r\n        &lt;/div&gt;\r\n        &lt;div x-show=\"activeTab === \'delivery-info\'\"&gt;\r\n            &lt;!-- Content for Delivery Info Tab --&gt;\r\n            {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-delivery-option-tab\"}}\r\n        &lt;/div&gt;\r\n        &lt;div x-show=\"activeTab === \'product\'\"&gt;\r\n            &lt;!-- Content for Product Tab --&gt;\r\n           {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-product-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;div x-show=\"activeTab === \'promotion\'\"&gt;\r\n            &lt;!-- Content for Promotion Tab --&gt;\r\n           {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-promotion-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;div x-show=\"activeTab === \'trade\'\"&gt;\r\n            &lt;!-- Content for Trade Tab --&gt;\r\n    {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-trade-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;div x-show=\"activeTab === \'returns\'\"&gt;\r\n            &lt;!-- Content for Returns Tab --&gt;\r\n           {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-return-tab-content\"}}\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;!-- Accordion for mobile --&gt;\r\n\r\n&lt;div x-data=\"{ activeTab: \'all\' }\" class=\"mt-6 container mobile-faq\"&gt;\r\n    &lt;!-- Accordion for mobile --&gt;\r\n    &lt;div class=\"block lg:hidden space-y-4\"&gt;\r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-base text-gray-900\"&gt;\r\n                All\r\n                &lt;/span&gt;\r\n               &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                &lt;!-- Content for All Tab --&gt;\r\n                {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-all-tab-content\"}}\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n        \r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-base text-gray-900\"&gt;\r\n                Payment\r\n                &lt;/span&gt;\r\n                &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                &lt;!-- Content for Payment Tab --&gt;\r\n                {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-payment-tab-content\"}}\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n                &lt;span class=\"font-semibold text-base text-gray-900\"&gt;\r\n                Order Info\r\n                &lt;/span&gt;\r\n                &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                &lt;!-- Content for Order Info Tab --&gt;\r\n                {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"Faq-order-info\"}}\r\n            &lt;/div&gt;\r\n            \r\n        &lt;/div&gt;\r\n\r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n                &lt;span class=\"font-semibold text-base text-gray-900 text-gray-900\"&gt;\r\n                International Order\r\n            &lt;/span&gt;\r\n            &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                 &lt;!-- Content for International Order Tab --&gt;\r\n         {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-International-order-tab\"}}\r\n         &lt;/div&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n                &lt;span class=\"font-semibold text-base text-gray-900\"&gt;Delivery information&lt;/span&gt;\r\n               &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                &lt;!-- Content for Delivery Info Tab --&gt;\r\n            {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-delivery-option-tab\"}}\r\n        &lt;/div&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n                &lt;span class=\"font-semibold text-base text-gray-900\"&gt;Product&lt;/span&gt;\r\n                &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                 &lt;!-- Content for Product Tab --&gt;\r\n           {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-product-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;/div&gt;\r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n                &lt;span class=\"font-semibold text-base text-gray-900\"&gt;Promotion&lt;/span&gt;\r\n                &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                &lt;!-- Content for Promotion Tab --&gt;\r\n           {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-promotion-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;/div&gt;\r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n                &lt;span class=\"font-semibold text-base text-gray-900\"&gt;Trade&lt;/span&gt;\r\n              &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                &lt;!-- Content for Trade Tab --&gt;\r\n    {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-trade-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n                &lt;span class=\"font-semibold ttext-base text-gray-900\"&gt;Returns&lt;/span&gt;\r\n                &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                &lt;!-- Content for Returns Tab --&gt;\r\n           {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-return-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;/div&gt;\r\n\r\n\r\n    &lt;/div&gt;\r\n&lt;/div&gt;\r\n</div>','2024-08-23 08:40:44','2024-10-29 09:59:12',1),(22,'Banyo - Faq All Tab content','faq-all-tab-content','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"w-full flex flex-col space-y-4 mt-6\"&gt;\r\n    &lt;!-- \"How do I contact you?\" Section --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How do I contact you?&lt;/span&gt;\r\n          &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;you wish to contact us for a general enquiry, you can email us&lt;a href=\"mailto:info@banyo.co.uk\"&gt;info@banyo.co.uk&lt;/a&gt;Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;xus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- \"What are your returns address?\" Section --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;What are your returns address?&lt;/span&gt;\r\n           &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;you wish to contact us for a general enquiry, you can email us\r\n                    at &lt;a href=\"mailto:info@banyo.co.uk\"&gt;info@banyo.co.uk&lt;/a&gt;. Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;xus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Do you offer free delivery? --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;Do you offer free delivery?&lt;/span&gt;\r\n            &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;you wish to contact us for a general enquiry, you can email us\r\n                    at &lt;a href=\"mailto:info@banyo.co.uk\"&gt;info@banyo.co.uk&lt;/a&gt;. Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;xus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- How much does delivery cost? --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How much does delivery cost?&lt;/span&gt;\r\n            &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;you wish to contact us for a general enquiry, you can email us\r\n                    at &lt;a href=\"mailto:info@banyo.co.uk\"&gt;info@banyo.co.uk&lt;/a&gt;. Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;xus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Will the delivery driver call me? --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;Will the delivery driver call me?&lt;/span&gt;\r\n           &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;you wish to contact us for a general enquiry, you can email us\r\n                    at &lt;a href=\"mailto:info@banyo.co.uk\"&gt;info@banyo.co.uk&lt;/a&gt;. Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;xus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Can I still return items? --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;Can I still return items?&lt;/span&gt;\r\n           &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;you wish to contact us for a general enquiry, you can email us\r\n                    at &lt;a href=\"mailto:info@banyo.co.uk\"&gt;info@banyo.co.uk&lt;/a&gt;. Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;xus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n&lt;/div&gt;</div>','2024-08-23 08:42:42','2025-01-28 15:25:37',1),(23,'Banyo Faq - payment Tab content','faq-payment-tab-content','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"w-full flex flex-col space-y-4 mt-6\"&gt;\r\n    &lt;!-- Can I pay in Euros?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Can I pay in Euros? &lt;/span&gt;\r\n            &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    For international orders, we do advertise prices in Euros, however, Victorian Plumbing have no\r\n                    control over exchange rates that financial institutes charge. Therefore the advertised Euro price\r\n                    may change due to the chosen payment method exchange rate, as we only accept payment in Pound\r\n                    Sterling. Please be aware of this when placing an order in Euros as the quoted Euro price will be an\r\n                    estimated price. &lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Do you offer Finance? --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Do you offer Finance? &lt;/span&gt;\r\n            &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Yes, we have a range of finance options available for any purchase of over\r\n                    £250. When presented with your Payment Method options in the checkout choose Finance - this will\r\n                    direct you to an online application. Please click the link for more details: Finance Details&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Do your prices include VAT?--&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Do your prices include VAT? &lt;/span&gt;\r\n           &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Yes, all our prices include VAT.&lt;/p&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- What payment options are available?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                What payment options are available? &lt;/span&gt;\r\n           &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Our payment options include all major credit cards, as well as Paypal.&lt;/p&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- My method of payment has been declined, what now?--&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                My method of payment has been declined, what now?&lt;/span&gt;\r\n            &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;If your payment is declined, please check that you have entered all the\r\n                    information displayed on your card correctly and that all required fields have been filled in. If\r\n                    any problems persist, please contact our customer services team regarding the issue, providing as\r\n                    much detail as you can, and we will try to resolve it for you as soon as possible.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n&lt;/div&gt;</div>','2024-08-26 07:11:55','2025-01-28 15:25:05',1),(24,'Banyo Faq - order info tab','Faq-order-info','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"w-full flex flex-col space-y-4 mt-6\"&gt;\r\n\r\n    &lt;!-- Can I order an item that is not currently in stock?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Can I order an item that is not currently in stock? &lt;/span&gt;\r\n       &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Yes, our team are happy to arrange pre-orders. However, if you want to\r\n                    schedule a pre-order alongside an order of items that we do have in stock, then your shipment will\r\n                    be held until all items are ready. If you would like to arrange a split delivery, you can do so by\r\n                    calling our customer services team.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Can I order products not listed on your site?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Can I order products not listed on your site? &lt;/span&gt;\r\n           &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Yes, we are happy to help source items you may have found elsewhere.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- \"How do I contact you?\" Section --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How do I contact you?&lt;/span&gt;\r\n            &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;If you wish to contact us for a general enquiry, you can email us\r\n                    at info@banyo.co.uk. Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;Nexus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Can I collect my order from you?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;Can I collect my order from you? &lt;/span&gt;\r\n           &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;All orders can be collected from our showroom in Formby. Simply choose Collect\r\n                    from Store when prompted for your delivery choice in the checkout process. However, please be aware\r\n                    that our products are housed in an off-site warehouse, and so your product will not be able to\r\n                    collect on the same day you order.&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Once you have arranged to Collect From Store, we will contact you to let you know when your items\r\n                    arrive and are ready for collection, to save you from a wasted journey!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- How do I place my order with you?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How do I place my order with you? &lt;/span&gt;\r\n          &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;To place an order, the process is quick and easy. Simply browse the products\r\n                    you\'re interested in on our website, add the goods you want to your basket, then proceed to the\r\n                    delivery and payment pages to complete the order.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- An article is missing from my order, what do I do? --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                An article is missing from my order, what do I do? &lt;/span&gt;\r\n            &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;When you take receipt of your order, you are required to give your items a\r\n                    quick check to ensure there are no problems and that you are happy to receive the order. If you\r\n                    notice any missing items or other problems, please contact our customer services team immediately.\r\n                &lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n&lt;/div&gt;</div>','2024-08-26 07:32:41','2025-01-28 15:24:05',1),(25,'Faq International order tab','faq-International-order-tab','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"w-full flex flex-col space-y-4 mt-6\"&gt;\r\n\r\n    &lt;!-- Can I order an item that is not currently in stock?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Can I order an item that is not currently in stock? &lt;/span&gt;\r\n           &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Yes, our team are happy to arrange pre-orders. However, if you want to\r\n                    schedule a pre-order alongside an order of items that we do have in stock, then your shipment will\r\n                    be held until all items are ready. If you would like to arrange a split delivery, you can do so by\r\n                    calling our customer services team.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Can I order products not listed on your site?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Can I order products not listed on your site? &lt;/span&gt;\r\n           &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Yes, we are happy to help source items you may have found elsewhere.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- \"How do I contact you?\" Section --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How do I contact you?&lt;/span&gt;\r\n           &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;If you wish to contact us for a general enquiry, you can email us\r\n                    at info@banyo.co.uk. Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;Nexus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Can I collect my order from you?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;Can I collect my order from you? &lt;/span&gt;\r\n            &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;All orders can be collected from our showroom in Formby. Simply choose Collect\r\n                    from Store when prompted for your delivery choice in the checkout process. However, please be aware\r\n                    that our products are housed in an off-site warehouse, and so your product will not be able to\r\n                    collect on the same day you order.&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Once you have arranged to Collect From Store, we will contact you to let you know when your items\r\n                    arrive and are ready for collection, to save you from a wasted journey!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- How do I place my order with you?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How do I place my order with you? &lt;/span&gt;\r\n            &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;To place an order, the process is quick and easy. Simply browse the products\r\n                    you\'re interested in on our website, add the goods you want to your basket, then proceed to the\r\n                    delivery and payment pages to complete the order.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- An article is missing from my order, what do I do? --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                An article is missing from my order, what do I do? &lt;/span&gt;\r\n            &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;When you take receipt of your order, you are required to give your items a\r\n                    quick check to ensure there are no problems and that you are happy to receive the order. If you\r\n                    notice any missing items or other problems, please contact our customer services team immediately.\r\n                &lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n&lt;/div&gt;</div>','2024-08-26 07:34:02','2024-10-29 08:30:33',1),(26,'Banyo Faq - Delivery option Tab','faq-delivery-option-tab','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"w-full flex flex-col space-y-4 mt-6\"&gt;\r\n\r\n    &lt;!-- Can I order an item that is not currently in stock?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Can I order an item that is not currently in stock? &lt;/span&gt;\r\n           &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Yes, our team are happy to arrange pre-orders. However, if you want to\r\n                    schedule a pre-order alongside an order of items that we do have in stock, then your shipment will\r\n                    be held until all items are ready. If you would like to arrange a split delivery, you can do so by\r\n                    calling our customer services team.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Can I order products not listed on your site?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Can I order products not listed on your site? &lt;/span&gt;\r\n            &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Yes, we are happy to help source items you may have found elsewhere.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- \"How do I contact you?\" Section --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How do I contact you?&lt;/span&gt;\r\n            &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;If you wish to contact us for a general enquiry, you can email us\r\n                    at info@banyo.co.uk. Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;Nexus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Can I collect my order from you?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;Can I collect my order from you? &lt;/span&gt;\r\n           &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;All orders can be collected from our showroom in Formby. Simply choose Collect\r\n                    from Store when prompted for your delivery choice in the checkout process. However, please be aware\r\n                    that our products are housed in an off-site warehouse, and so your product will not be able to\r\n                    collect on the same day you order.&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Once you have arranged to Collect From Store, we will contact you to let you know when your items\r\n                    arrive and are ready for collection, to save you from a wasted journey!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- How do I place my order with you?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How do I place my order with you? &lt;/span&gt;\r\n          &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;To place an order, the process is quick and easy. Simply browse the products\r\n                    you\'re interested in on our website, add the goods you want to your basket, then proceed to the\r\n                    delivery and payment pages to complete the order.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- An article is missing from my order, what do I do? --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                An article is missing from my order, what do I do? &lt;/span&gt;\r\n           &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;When you take receipt of your order, you are required to give your items a\r\n                    quick check to ensure there are no problems and that you are happy to receive the order. If you\r\n                    notice any missing items or other problems, please contact our customer services team immediately.\r\n                &lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n&lt;/div&gt;</div>','2024-08-26 07:44:24','2025-01-28 15:19:34',1),(27,'Banyo Faq - Product Tab content','faq-product-tab-content','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"w-full flex flex-col space-y-4 mt-6\"&gt;\r\n\r\n    &lt;!-- Can I order an item that is not currently in stock?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Can I order an item that is not currently in stock? &lt;/span&gt;\r\n                    &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Yes, our team are happy to arrange pre-orders. However, if you want to\r\n                    schedule a pre-order alongside an order of items that we do have in stock, then your shipment will\r\n                    be held until all items are ready. If you would like to arrange a split delivery, you can do so by\r\n                    calling our customer services team.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Can I order products not listed on your site?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Can I order products not listed on your site? &lt;/span&gt;\r\n                    &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Yes, we are happy to help source items you may have found elsewhere.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- \"How do I contact you?\" Section --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How do I contact you?&lt;/span&gt;\r\n                    &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;If you wish to contact us for a general enquiry, you can email us\r\n                    at info@banyo.co.uk. Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;Nexus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Can I collect my order from you?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;Can I collect my order from you? &lt;/span&gt;\r\n                    &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;All orders can be collected from our showroom in Formby. Simply choose Collect\r\n                    from Store when prompted for your delivery choice in the checkout process. However, please be aware\r\n                    that our products are housed in an off-site warehouse, and so your product will not be able to\r\n                    collect on the same day you order.&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Once you have arranged to Collect From Store, we will contact you to let you know when your items\r\n                    arrive and are ready for collection, to save you from a wasted journey!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- How do I place my order with you?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How do I place my order with you? &lt;/span&gt;\r\n                    &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;To place an order, the process is quick and easy. Simply browse the products\r\n                    you\'re interested in on our website, add the goods you want to your basket, then proceed to the\r\n                    delivery and payment pages to complete the order.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- An article is missing from my order, what do I do? --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                An article is missing from my order, what do I do? &lt;/span&gt;\r\n                  &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;When you take receipt of your order, you are required to give your items a\r\n                    quick check to ensure there are no problems and that you are happy to receive the order. If you\r\n                    notice any missing items or other problems, please contact our customer services team immediately.\r\n                &lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n&lt;/div&gt;</div>','2024-08-26 07:50:16','2025-01-28 15:24:33',1),(28,'Banyo Faq - Promotion Tab Content','faq-promotion-tab-content','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"w-full flex flex-col space-y-4 mt-6\"&gt;\r\n\r\n    &lt;!-- Can I order an item that is not currently in stock?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Can I order an item that is not currently in stock? &lt;/span&gt;\r\n                 &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Yes, our team are happy to arrange pre-orders. However, if you want to\r\n                    schedule a pre-order alongside an order of items that we do have in stock, then your shipment will\r\n                    be held until all items are ready. If you would like to arrange a split delivery, you can do so by\r\n                    calling our customer services team.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Can I order products not listed on your site?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Can I order products not listed on your site? &lt;/span&gt;\r\n                    &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Yes, we are happy to help source items you may have found elsewhere.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- \"How do I contact you?\" Section --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How do I contact you?&lt;/span&gt;\r\n                &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;If you wish to contact us for a general enquiry, you can email us\r\n                    at info@banyo.co.uk. Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;Nexus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Can I collect my order from you?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;Can I collect my order from you? &lt;/span&gt;\r\n                    &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;All orders can be collected from our showroom in Formby. Simply choose Collect\r\n                    from Store when prompted for your delivery choice in the checkout process. However, please be aware\r\n                    that our products are housed in an off-site warehouse, and so your product will not be able to\r\n                    collect on the same day you order.&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Once you have arranged to Collect From Store, we will contact you to let you know when your items\r\n                    arrive and are ready for collection, to save you from a wasted journey!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- How do I place my order with you?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How do I place my order with you? &lt;/span&gt;\r\n                 &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;To place an order, the process is quick and easy. Simply browse the products\r\n                    you\'re interested in on our website, add the goods you want to your basket, then proceed to the\r\n                    delivery and payment pages to complete the order.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- An article is missing from my order, what do I do? --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                An article is missing from my order, what do I do? &lt;/span&gt;\r\n                   &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;When you take receipt of your order, you are required to give your items a\r\n                    quick check to ensure there are no problems and that you are happy to receive the order. If you\r\n                    notice any missing items or other problems, please contact our customer services team immediately.\r\n                &lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n&lt;/div&gt;</div>','2024-08-26 07:52:04','2025-01-28 15:26:44',0),(29,'Banyo Faq - Trade Tab Content','faq-trade-tab-content','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"w-full flex flex-col space-y-4 mt-6\"&gt;\r\n\r\n    &lt;!-- Can I order an item that is not currently in stock?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Can I order an item that is not currently in stock? &lt;/span&gt;\r\n                      &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         \r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Yes, our team are happy to arrange pre-orders. However, if you want to\r\n                    schedule a pre-order alongside an order of items that we do have in stock, then your shipment will\r\n                    be held until all items are ready. If you would like to arrange a split delivery, you can do so by\r\n                    calling our customer services team.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Can I order products not listed on your site?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Can I order products not listed on your site? &lt;/span&gt;\r\n                    &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Yes, we are happy to help source items you may have found elsewhere.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- \"How do I contact you?\" Section --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How do I contact you?&lt;/span&gt;\r\n                   &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;If you wish to contact us for a general enquiry, you can email us\r\n                    at info@banyo.co.uk. Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;Nexus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Can I collect my order from you?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;Can I collect my order from you? &lt;/span&gt;\r\n                  &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;All orders can be collected from our showroom in Formby. Simply choose Collect\r\n                    from Store when prompted for your delivery choice in the checkout process. However, please be aware\r\n                    that our products are housed in an off-site warehouse, and so your product will not be able to\r\n                    collect on the same day you order.&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Once you have arranged to Collect From Store, we will contact you to let you know when your items\r\n                    arrive and are ready for collection, to save you from a wasted journey!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- How do I place my order with you?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How do I place my order with you? &lt;/span&gt;\r\n                    &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;To place an order, the process is quick and easy. Simply browse the products\r\n                    you\'re interested in on our website, add the goods you want to your basket, then proceed to the\r\n                    delivery and payment pages to complete the order.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- An article is missing from my order, what do I do? --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                An article is missing from my order, what do I do? &lt;/span&gt;\r\n                    &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;When you take receipt of your order, you are required to give your items a\r\n                    quick check to ensure there are no problems and that you are happy to receive the order. If you\r\n                    notice any missing items or other problems, please contact our customer services team immediately.\r\n                &lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n&lt;/div&gt;</div>','2024-08-26 07:53:13','2025-01-28 15:19:02',1),(30,'Banyo Faq - Return Tab content','faq-return-tab-content','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"w-full flex flex-col space-y-4 mt-6\"&gt;\r\n\r\n    &lt;!-- Can I order an item that is not currently in nexus?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Can I order an item that is not currently in stock? &lt;/span&gt;\r\n                    &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Yes, our team are happy to arrange pre-orders. However, if you want to\r\n                    schedule a pre-order alongside an order of items that we do have in stock, then your shipment will\r\n                    be held until all items are ready. If you would like to arrange a split delivery, you can do so by\r\n                    calling our customer services team.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Can I order products not listed on your site?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                Can I order products not listed on your site? &lt;/span&gt;\r\n                   &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;Yes, we are happy to help source items you may have found elsewhere.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- \"How do I contact you?\" Section --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How do I contact you?&lt;/span&gt;\r\n                   &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;If you wish to contact us for a general enquiry, you can email us\r\n                    at info@banyo.co.uk. Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;Nexus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Can I collect my order from you?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;Can I collect my order from you? &lt;/span&gt;\r\n                   &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;All orders can be collected from our showroom in Formby. Simply choose Collect\r\n                    from Store when prompted for your delivery choice in the checkout process. However, please be aware\r\n                    that our products are housed in an off-site warehouse, and so your product will not be able to\r\n                    collect on the same day you order.&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Once you have arranged to Collect From Store, we will contact you to let you know when your items\r\n                    arrive and are ready for collection, to save you from a wasted journey!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- How do I place my order with you?  --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How do I place my order with you? &lt;/span&gt;\r\n                   &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;To place an order, the process is quick and easy. Simply browse the products\r\n                    you\'re interested in on our website, add the goods you want to your basket, then proceed to the\r\n                    delivery and payment pages to complete the order.&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- An article is missing from my order, what do I do? --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;\r\n                An article is missing from my order, what do I do? &lt;/span&gt;\r\n                  &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;When you take receipt of your order, you are required to give your items a\r\n                    quick check to ensure there are no problems and that you are happy to receive the order. If you\r\n                    notice any missing items or other problems, please contact our customer services team immediately.\r\n                &lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n&lt;/div&gt;</div>','2024-08-26 08:01:28','2025-01-28 15:18:04',1),(31,'category Related Article','related-article','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;section class=\"ideas-inspiration py-6 bg-white\"&gt;\r\n    &lt;div class=\"container mx-auto\"&gt;\r\n        &lt;div class=\"flex justify-between items-end mb-6\"&gt;\r\n            &lt;h2 class=\"font-bold text-3xl text-blue-900\"&gt;Related Articles&lt;/h2&gt;\r\n            &lt;a href=\"#\" class=\"text-red-500 font-semibold desktop\"&gt;See all articles&lt;/a&gt;\r\n        &lt;/div&gt;\r\n        &lt;div class=\"grid grid-cols-1 sm:grid-cols-2 lg:grid-cols-4 gap-6\"&gt;\r\n            &lt;!-- Article 1 --&gt;\r\n            &lt;div class=\"bg-white rounded-lg shadow-lg overflow-hidden\"&gt;\r\n\r\n&lt;img src=\"{{media url=.renditions/wysiwyg/test_image.jpg}}\" alt=\"\" class=\"w-full h-48 object-cover\"/&gt;\r\n                &lt;div class=\"flex justify-between items-center mb-2 date-txt px-4\"&gt;\r\n                    &lt;span class=\"text-white text-xs font-medium\"&gt;Buying Guide&lt;/span&gt;\r\n                    &lt;span class=\"text-white text-sm\"&gt;22 Aug 2024&lt;/span&gt;\r\n                &lt;/div&gt;\r\n                &lt;div class=\"p-4\"&gt;\r\n\r\n                    &lt;h3 class=\"text-lg font-bold mb-2\"&gt;How to Buy a Contemporary Basin?&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-700 mb-4 text-xs\"&gt;Swapping out your fixture is a fantastic option if you want to\r\n                        upgrade your bathroom...&lt;/p&gt;\r\n                    &lt;a href=\"#\"\r\n                        class=\"inline-block text-sm px-4 py-1 text-blue-600 border border-blue-600 rounded hover:bg-blue-600 hover:text-white\"&gt;Read\r\n                        More&lt;/a&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Article 2 --&gt;\r\n            &lt;div class=\"bg-white rounded-lg shadow-lg overflow-hidden\"&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/small.jpeg}}\" alt=\"\" class=\"w-full h-48 object-cover\"/&gt;\r\n                &lt;div class=\"flex justify-between items-center mb-2 date-txt px-4\"&gt;\r\n                    &lt;span class=\"text-white font-medium text-xs\"&gt;Buying Guide&lt;/span&gt;\r\n                    &lt;span class=\"text-white text-sm\"&gt;05 Aug 2024&lt;/span&gt;\r\n                &lt;/div&gt;\r\n                &lt;div class=\"p-4\"&gt;\r\n\r\n                    &lt;h3 class=\"text-lg font-bold mb-2\"&gt;How to Buy a Contemporary Basin?&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-700 mb-4 text-xs\"&gt;Swapping out your fixture is a fantastic option if you want to\r\n                        upgrade your bathroom...&lt;/p&gt;\r\n                    &lt;a href=\"#\"\r\n                        class=\"inline-block text-sm px-4 py-1 text-blue-600 border border-blue-600 rounded hover:bg-blue-600 hover:text-white\"&gt;Read\r\n                        More&lt;/a&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Article 3 --&gt;\r\n            &lt;div class=\"bg-white rounded-lg shadow-lg overflow-hidden\"&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/small.jpeg}}\" alt=\"\" class=\"w-full h-48 object-cover\"/&gt;\r\n                &lt;div class=\"flex justify-between items-center mb-2 date-txt px-4\"&gt;\r\n                    &lt;span class=\"text-white font-medium text-xs\"&gt;Buying Guide&lt;/span&gt;\r\n                    &lt;span class=\"text-white text-sm\"&gt;05 Aug 2024&lt;/span&gt;\r\n                &lt;/div&gt;\r\n                &lt;div class=\"p-4\"&gt;\r\n\r\n                    &lt;h3 class=\"text-lg font-bold mb-2\"&gt;How to Buy a Contemporary Basin?&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-700 mb-4 text-xs\"&gt;Swapping out your fixture is a fantastic option if you want to\r\n                        upgrade your bathroom...&lt;/p&gt;\r\n                    &lt;a href=\"#\"\r\n                        class=\"inline-block text-sm px-4 py-1 text-blue-600 border border-blue-600 rounded hover:bg-blue-600 hover:text-white\"&gt;Read\r\n                        More&lt;/a&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Article 4 --&gt;\r\n            &lt;div class=\"bg-white rounded-lg shadow-lg overflow-hidden\"&gt;\r\n               &lt;img src=\"{{media url=.renditions/wysiwyg/small.jpeg}}\" alt=\"\" class=\"w-full h-48 object-cover\"/&gt;\r\n                &lt;div class=\"flex justify-between items-center mb-2 date-txt px-4\"&gt;\r\n                    &lt;span class=\"text-white font-medium text-xs\"&gt;Buying Guide&lt;/span&gt;\r\n                    &lt;span class=\"text-white text-sm\"&gt;05 Aug 2024&lt;/span&gt;\r\n                &lt;/div&gt;\r\n                &lt;div class=\"p-4\"&gt;\r\n                    &lt;h3 class=\"text-lg font-bold mb-2\"&gt;How to Buy a Contemporary Basin?&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-700 mb-4 text-xs\"&gt;Swapping out your fixture is a fantastic option if you want to\r\n                        upgrade your bathroom...&lt;/p&gt;\r\n                    &lt;a href=\"#\"\r\n                        class=\"inline-block text-sm px-4 py-1 text-blue-600 border border-blue-600 rounded hover:bg-blue-600 hover:text-white\"&gt;Read\r\n                        More&lt;/a&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n        &lt;a href=\"#\" class=\"text-red-500 font-semibold sm:hidden\"&gt;See all articles&lt;/a&gt;\r\n    &lt;/div&gt;\r\n&lt;/section&gt;</div>','2024-08-30 12:10:35','2024-09-30 08:47:34',1),(32,'sidebar bottom image','sidebar-bottom-image','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"btm-sec flex flex-col\"&gt;\r\n    &lt;div class=\"buy-now my-4\"&gt;\r\n    &lt;img src=\"{{media url=.renditions/wysiwyg/sale-btm1.jpeg}}\" alt=\"\" /&gt;\r\n    &lt;/div&gt;\r\n    &lt;div class=\"read-blog my-4\"&gt;\r\n        &lt;img src=\"{{media url=.renditions/wysiwyg/side-btm.jpeg}}\" alt=\"\" /&gt;\r\n    &lt;/div&gt;\r\n    &lt;/div&gt;</div>','2024-09-04 06:28:39','2024-09-04 06:49:18',1),(33,'support popular Question','support-popular-question','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"w-full flex flex-col space-y-4 mt-6\"&gt;\r\n    &lt;!-- \"How do I contact you?\" Section --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How do I contact you?&lt;/span&gt;\r\n             &lt;span&gt;\r\n            &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n                 alt=\"Toggle Icon\" \r\n                 class=\"w-6 h-6 inline-block\"&gt;\r\n        &lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;you wish to contact us for a general enquiry, you can email us\r\n                    at info@banyo.co.uk. Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;xus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- \"What are your returns address?\" Section --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;What are your returns address?&lt;/span&gt;\r\n              &lt;span&gt;\r\n            &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n                 alt=\"Toggle Icon\" \r\n                 class=\"w-6 h-6 inline-block\"&gt;\r\n        &lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;you wish to contact us for a general enquiry, you can email us\r\n                    at info@banyo.co.uk. Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;xus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Do you offer free delivery? --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3  text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;Do you offer free delivery?&lt;/span&gt;\r\n              &lt;span&gt;\r\n            &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n                 alt=\"Toggle Icon\" \r\n                 class=\"w-6 h-6 inline-block\"&gt;\r\n        &lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;you wish to contact us for a general enquiry, you can email us\r\n                    at info@banyo.co.uk. Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;xus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- How much does delivery cost? --&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sx\"&gt;How much does delivery cost?&lt;/span&gt;\r\n             &lt;span&gt;\r\n            &lt;img x-bind:src=\"open ? \'/media/wysiwyg/minus-icon-faq.svg\' : \'/media/wysiwyg/plus-icon-faq.svg\'\" \r\n                 alt=\"Toggle Icon\" \r\n                 class=\"w-6 h-6 inline-block\"&gt;\r\n        &lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border-2 border-gray-300 rounded-t-none\"&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;you wish to contact us for a general enquiry, you can email us\r\n                    at info@banyo.co.uk. Contacting us by email is simple and we aim to answer all email queries within\r\n                    a few hours. Any emails received outside of working hours will be responded to at the soonest\r\n                    possible opportunity.\r\n                    You can also contact us by phone at 0116 274 4059. Calls are accepted during the following hours:\r\n                    8.30 am to 9.00 pm Monday to Friday and 9:00 am to 5:00 pm Saturday. Please be aware that our\r\n                    customer services team can only answer your queries between 8.30 am and 6 pm, due to our courier and\r\n                    manufacturer enquiry channels closing at that time. If you are ordering goods, the lines are open\r\n                    between 6 pm and 9 pm.\r\n                    If you wish, you can come and talk to us face to face for advice or a closer look at products by\r\n                    paying a visit to our showroom:&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base font-semibold\"&gt;xus 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n                &lt;p class=\"mb-4 text-base\"&gt;\r\n                    Alternatively, we also have numerous Social Media Profiles you can contact us on - find these in the\r\n                    footer of this page. These allow you to keep track of all our latest news, deals, and other fun\r\n                    stuff!&lt;/p&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n\r\n&lt;/div&gt;</div>','2024-09-14 10:17:27','2024-10-30 10:37:05',1),(34,'Product Delivery Option','product-delivery-option','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"bg-white rounded-lg shadow-md in-stock_sec\"&gt;\r\n  &lt;!-- In Stock and Time Message --&gt;\r\n  &lt;div class=\"flex items-center space-x-2 text-green-600 stock-time\"&gt;\r\n    &lt;img src=\"/media/wysiwyg/Tick.svg\" alt=\"\" class=\"mr-2\"&gt;\r\n  &lt;div class=\"flex align-center\"&gt;\r\n    &lt;span class=\"text-base font-semibold green-text\"&gt;In Stock - Get it Wednesday&lt;/span&gt;\r\n    &lt;span class=\"text-base text-gray-500\"&gt;Order in 2 hours and 37 minutes&lt;/span&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n  &lt;!-- PayPal Credit Message --&gt;\r\n  &lt;div class=\"mt-2 text-sm text-gray-600 flex paypal-credit\"&gt;\r\n    &lt;img src=\"/media/wysiwyg/Group_27495.png\" alt=\"\" class=\"mr-2\"&gt;\r\n    &lt;span class=\"text-base font-semibold\"&gt;0% interest for 4 months with PayPal Credit&lt;/span&gt;\r\n    &lt;a href=\"#\" class=\"text-base ml-2 text-red-500 underline\"&gt;Click for More Information&lt;/a&gt;\r\n  &lt;/div&gt;\r\n\r\n  &lt;!-- Delivery Options --&gt;\r\n  &lt;div class=\"mt-4 delivery-opt\"&gt;\r\n    &lt;div class=\"img-text flex items-start\"&gt;\r\n      &lt;img src=\"/media/wysiwyg/delivery-support.svg\" alt=\"\" class=\"mr-2\"&gt;\r\n      &lt;p class=\"text-base font-semibold\"&gt;Our Delivery Options:&lt;/p&gt;\r\n    &lt;/div&gt;\r\n    &lt;ul class=\"mt-2 space-y-1 text-gray-600\"&gt;\r\n      &lt;li class=\"flex items-center space-x-2 text-base\"&gt;\r\n        &lt;img src=\"/media/wysiwyg/dot.svg\" alt=\"\" class=\"mr-2\"&gt;\r\n      &lt;p&gt;&lt;span class=\"font-semibold\"&gt;Free Standard Delivery&lt;/span&gt; Over £499 to UK mainland&lt;/p&gt;\r\n      &lt;/li&gt;\r\n      &lt;li class=\"flex items-center space-x-2 text-base\"&gt;\r\n        &lt;img src=\"/media/wysiwyg/dot.svg\" alt=\"\" class=\"mr-2\"&gt;\r\n      &lt;p&gt;&lt;span class=\"font-semibold\"&gt;Standard Delivery &lt;/span&gt;£9.95 for 2-7 working days&lt;/p&gt;\r\n      &lt;/li&gt;\r\n      &lt;li class=\"flex items-center space-x-2 text-base\"&gt;\r\n        &lt;img src=\"/media/wysiwyg/dot.svg\" alt=\"\" class=\"mr-2\"&gt;\r\n        &lt;p&gt;&lt;span class=\"font-semibold\"&gt;Next Day Delivery&lt;/span&gt; £16.95 for delivery of Wednesday&lt;/p&gt;\r\n      &lt;/li&gt;\r\n    &lt;/ul&gt;\r\n  &lt;/div&gt;\r\n\r\n  &lt;!-- Postcode and Button\r\n  &lt;div class=\"mt-4 flex items-center space-x-2 postcode\"&gt;\r\n    &lt;input type=\"text\" placeholder=\"Enter Post Code\"\r\n      class=\"text-sm w-full px-4 py-2 border border-gray-300 rounded-lg focus:ring-2 focus:ring-blue-500\" /&gt;\r\n    &lt;button class=\"px-4 py-2 font-bold bg-blue-600 text-white rounded-lg text-sm\"&gt;\r\n      Check Delivery Cost\r\n    &lt;/button&gt;\r\n  &lt;/div&gt; --&gt;\r\n&lt;/div&gt;</div>','2024-09-16 10:07:51','2024-10-23 07:06:50',1),(35,'Product payment Accordion','product-payment-accordion','<div class=\"payment-tab-sec\" data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"w-full flex flex-col space-y-4 mt-6 payment_meth\"&gt;\r\n    &lt;div x-data=\"{ open: false }\" class=\"my-2\"&gt;\r\n        &lt;button @click=\"open = !open\"\r\n            class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-sm\"&gt;\r\n                Payment Methods We Accept &lt;/span&gt;\r\n            &lt;span x-text=\"open ? \'-\' : \'+\'\" class=\"text-2xl font-semibold\"&gt;&lt;/span&gt;\r\n        &lt;/button&gt;\r\n        &lt;div x-show=\"open\" x-collapse&gt;\r\n            &lt;div class=\"p-3 bg-white rounded-lg border border-gray-300 rounded-t-none\"&gt;\r\n                    &lt;ul class=\"flex flex-wrap items-center\"&gt;\r\n                        &lt;li&gt;&lt;img src=\"/media/wysiwyg/paypal.svg\" alt=\"\" class=\"mr-2\"&gt;&lt;/li&gt;\r\n                        &lt;li&gt;&lt;img src=\"/media/wysiwyg/visa.svg\" alt=\"\" class=\"mr-2\"&gt;&lt;/li&gt;\r\n                        &lt;li&gt;&lt;img src=\"/media/wysiwyg/maestro.svg\" alt=\"\" class=\"mr-2\"&gt;&lt;/li&gt;\r\n                        &lt;li&gt;&lt;img src=\"/media/wysiwyg/mastercard.svg\" alt=\"\" class=\"mr-2\"&gt;&lt;/li&gt;\r\n                        &lt;li&gt;&lt;img src=\"/media/wysiwyg/delta.svg\" alt=\"\" class=\"mr-2\"&gt;&lt;/li&gt;\r\n                        &lt;li&gt;&lt;img src=\"/media/wysiwyg/solo.svg\" alt=\"\" class=\"mr-2\"&gt;&lt;/li&gt;\r\n                        &lt;li&gt;&lt;img src=\"/media/wysiwyg/switch.svg\" alt=\"\" class=\"mr-2\"&gt;&lt;/li&gt;\r\n                    &lt;/ul&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n&lt;/div&gt;</div>','2024-09-17 09:43:25','2024-10-23 09:40:26',1),(37,'Nexus/About','nexus_about','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div>','2025-01-27 10:24:55','2025-01-27 10:24:55',1),(40,'Home Page Main Slider','home-page-main-slider','<style>#html-body [data-pb-style=I6T72P1]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}#html-body [data-pb-style=SJQAGD4]{min-height:500px}#html-body [data-pb-style=W25EIN3]{background-position:left top;background-size:cover;background-repeat:no-repeat;min-height:500px}#html-body [data-pb-style=V07RFG0]{min-height:500px;background-color:transparent}#html-body [data-pb-style=V67E02A]{background-position:left top;background-size:cover;background-repeat:no-repeat;min-height:500px}#html-body [data-pb-style=NJY30UM]{min-height:500px;background-color:transparent}#html-body [data-pb-style=K61AEA0]{background-position:left top;background-size:cover;background-repeat:no-repeat;min-height:500px}#html-body [data-pb-style=BYK05QK]{min-height:500px;background-color:transparent}</style><div data-content-type=\"row\" data-appearance=\"full-width\" data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"main\" data-pb-style=\"I6T72P1\"><div class=\"row-full-width-inner\" data-element=\"inner\"><div class=\"pagebuilder-slider\" data-content-type=\"slider\" data-appearance=\"default\" data-autoplay=\"true\" data-autoplay-speed=\"4000\" data-fade=\"false\" data-infinite-loop=\"true\" data-show-arrows=\"false\" data-show-dots=\"true\" data-element=\"main\" data-pb-style=\"SJQAGD4\"><div data-content-type=\"slide\" data-slide-name=\"\" data-appearance=\"poster\" data-show-button=\"never\" data-show-overlay=\"never\" data-element=\"main\"><div data-element=\"empty_link\"><div class=\"pagebuilder-slide-wrapper\" data-background-images=\"{\\&quot;desktop_image\\&quot;:\\&quot;{{media url=wysiwyg/Banner-01_2.jpg}}\\&quot;,\\&quot;mobile_image\\&quot;:\\&quot;{{media url=wysiwyg/Web-03_2.jpg}}\\&quot;}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"wrapper\" data-pb-style=\"W25EIN3\"><div class=\"pagebuilder-overlay pagebuilder-poster-overlay\" data-overlay-color=\"\" aria-label=\"\" title=\"\" data-element=\"overlay\" data-pb-style=\"V07RFG0\"><div class=\"pagebuilder-poster-content\"><div data-element=\"content\"></div></div></div></div></div></div><div data-content-type=\"slide\" data-slide-name=\"\" data-appearance=\"poster\" data-show-button=\"never\" data-show-overlay=\"never\" data-element=\"main\"><div data-element=\"empty_link\"><div class=\"pagebuilder-slide-wrapper\" data-background-images=\"{\\&quot;desktop_image\\&quot;:\\&quot;{{media url=wysiwyg/Banner-02_1.jpg}}\\&quot;}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"wrapper\" data-pb-style=\"V67E02A\"><div class=\"pagebuilder-overlay pagebuilder-poster-overlay\" data-overlay-color=\"\" aria-label=\"\" title=\"\" data-element=\"overlay\" data-pb-style=\"NJY30UM\"><div class=\"pagebuilder-poster-content\"><div data-element=\"content\"></div></div></div></div></div></div><div data-content-type=\"slide\" data-slide-name=\"\" data-appearance=\"poster\" data-show-button=\"never\" data-show-overlay=\"never\" data-element=\"main\"><div data-element=\"empty_link\"><div class=\"pagebuilder-slide-wrapper\" data-background-images=\"{\\&quot;desktop_image\\&quot;:\\&quot;{{media url=wysiwyg/banner3.jpg}}\\&quot;}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"wrapper\" data-pb-style=\"K61AEA0\"><div class=\"pagebuilder-overlay pagebuilder-poster-overlay\" data-overlay-color=\"\" aria-label=\"\" title=\"\" data-element=\"overlay\" data-pb-style=\"BYK05QK\"><div class=\"pagebuilder-poster-content\"><div data-element=\"content\"></div></div></div></div></div></div></div></div></div>','2025-01-28 11:08:39','2025-01-28 11:26:36',1),(42,'Test Slider Block','testsliderblock','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"custom-slider\"&gt;\r\n    &lt;input type=\"radio\" name=\"slider\" id=\"slide1\" checked&gt;\r\n    &lt;input type=\"radio\" name=\"slider\" id=\"slide2\"&gt;\r\n    &lt;input type=\"radio\" name=\"slider\" id=\"slide3\"&gt;\r\n\r\n    &lt;div class=\"slides\"&gt;\r\n        &lt;div class=\"slide\"&gt;\r\n            &lt;img src=\"https://hyva-staging.banyo.co.uk/media/.renditions/wysiwyg/Banner-01_2.jpg\" alt=\"\" /&gt;\r\n        &lt;/div&gt;\r\n        &lt;div class=\"slide\"&gt;\r\n            &lt;img src=\"https://hyva-staging.banyo.co.uk/media/.renditions/wysiwyg/Banner-02_1.jpg\" alt=\"\" /&gt;\r\n        &lt;/div&gt;\r\n        &lt;div class=\"slide\"&gt;\r\n            &lt;img src=\"https://hyva-staging.banyo.co.uk/media/.renditions/wysiwyg/banner3.jpg\" alt=\"\" /&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;div class=\"dots\"&gt;\r\n        &lt;label for=\"slide1\"&gt;&lt;/label&gt;\r\n        &lt;label for=\"slide2\"&gt;&lt;/label&gt;\r\n        &lt;label for=\"slide3\"&gt;&lt;/label&gt;\r\n    &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;style&gt;\r\n.custom-slider {\r\n    position: relative;\r\n    width: 100%;\r\n    max-width: 1440px; /* Fixed width */\r\n    height: 450px; /* Fixed height */\r\n    overflow: hidden;\r\n    margin: auto;\r\n    border-radius: 10px; /* Optional: Rounded corners */\r\n}\r\n\r\n.slides {\r\n    display: flex;\r\n    width: 300%;\r\n    transition: transform 0.5s ease-in-out;\r\n}\r\n\r\n.slide {\r\n    width: 100%;\r\n    flex: 0 0 100%;\r\n}\r\n\r\n.slide img {\r\n    width: 1440px;\r\n    height: 450px;\r\n    object-fit: cover; /* Ensures images fit properly */\r\n}\r\n\r\n/* Hide Radio Buttons */\r\ninput[type=\"radio\"] {\r\n    display: none;\r\n}\r\n\r\n/* Dots (Pagination) */\r\n.dots {\r\n    position: absolute;\r\n    bottom: 15px;\r\n    left: 50%;\r\n    transform: translateX(-50%);\r\n    display: flex;\r\n    gap: 10px;\r\n}\r\n\r\n.dots label {\r\n    width: 12px;\r\n    height: 12px;\r\n    background: #ccc;\r\n    border-radius: 50%;\r\n    cursor: pointer;\r\n    transition: background 0.3s;\r\n}\r\n\r\n/* Active Slide */\r\n#slide1:checked ~ .slides {\r\n    transform: translateX(0);\r\n}\r\n\r\n#slide2:checked ~ .slides {\r\n    transform: translateX(-100%);\r\n}\r\n\r\n#slide3:checked ~ .slides {\r\n    transform: translateX(-200%);\r\n}\r\n\r\n/* Active Dot */\r\n#slide1:checked ~ .dots label:nth-child(1),\r\n#slide2:checked ~ .dots label:nth-child(2),\r\n#slide3:checked ~ .dots label:nth-child(3) {\r\n    background: #002F6C;\r\n}\r\n\r\n/* Responsive Design */\r\n@media (max-width: 768px) {\r\n    .custom-slider {\r\n        max-width: 100%;\r\n        height: 250px; /* Adjust for mobile */\r\n    }\r\n    \r\n    .slide img {\r\n        width: 100%;\r\n        height: 250px;\r\n    }\r\n}\r\n&lt;/style&gt;\r\n</div>','2025-01-28 12:16:53','2025-01-28 12:54:00',1),(43,'Header Telephone Nexus Home','header_telephone_nexus_home','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"img-text\"&gt;\r\n                    &lt;p class=\"text-base font-semibold text-gray-700\"&gt;Call Us: 0116 274 444&lt;/p&gt;\r\n                    &lt;p class=\"text-sm text-gray-700\"&gt;Call us today until 5:00pm&lt;/p&gt;\r\n                &lt;/div&gt;</div>','2025-01-28 12:27:01','2025-01-28 12:33:18',1),(44,'Banyo - Header Telephone','header_telephone','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"img-text\"&gt;\r\n                    &lt;p class=\"text-base font-semibold text-gray-700\"&gt;Call Us: 0116 274 4059&lt;/p&gt;\r\n                    &lt;p class=\"text-sm text-gray-700\"&gt;Call us today until 5:00pm&lt;/p&gt;\r\n                &lt;/div&gt;</div>','2025-01-28 12:30:20','2025-01-28 15:16:50',1),(45,'Header Telephone Premierdiy Home','header_telephone_premierdiy_home','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"img-text\"&gt;\r\n                    &lt;p class=\"text-base font-semibold text-gray-700\"&gt;Call Us: 0116 274 555&lt;/p&gt;\r\n                    &lt;p class=\"text-sm text-gray-700\"&gt;Call us today until 5:00pm&lt;/p&gt;\r\n                &lt;/div&gt;</div>','2025-01-28 12:38:41','2025-01-28 12:38:41',1),(46,'Banyo - Header Topbar Text','header_topbar_text','<div class=\"mobile-premium\" data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;section class=\"top-text pt-1 pb-1 sm:block hidden\"&gt;\r\n    &lt;p class=\"text-center font-bold uppercase\"&gt;Premium Sale - Upto 40% Off on Venice &amp; Infinity Furniture 1.&lt;/p&gt;\r\n&lt;/section&gt;</div>','2025-01-28 13:04:14','2025-01-28 15:15:44',1),(47,'Header Topbar Text Nexus Home','header_topbar_text_nexus_home','<div class=\"mobile-premium\" data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;section class=\"top-text pt-1 pb-1 sm:block hidden\"&gt;\r\n    &lt;p class=\"text-center font-bold uppercase\"&gt;Premium Sale - Upto 50% Off on Venice &amp; Infinity Furniture 2.&lt;/p&gt;\r\n&lt;/section&gt;</div>','2025-01-28 13:06:41','2025-01-28 13:12:29',1),(48,'Premierdiy - Header Topbar Text','header_topbar_text_premierdiy_home','<div class=\"mobile-premium\" data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;section class=\"top-text pt-1 pb-1 sm:block hidden\"&gt;\r\n    &lt;p class=\"text-center font-bold uppercase\"&gt;Premium Sale - Upto 40% Off on Venice &amp; Infinity Furniture 3.&lt;/p&gt;\r\n&lt;/section&gt;</div>','2025-01-28 13:08:55','2025-01-28 15:34:47',1),(49,'Banyo - Homepage Banners','homepage-banner-slider1','<style>#html-body [data-pb-style=C0AREO0],#html-body [data-pb-style=K15II1C],#html-body [data-pb-style=LRDVDWT]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}#html-body [data-pb-style=MIOAFXP]{border-style:none}#html-body [data-pb-style=U0LS964],#html-body [data-pb-style=V6H9J1F]{max-width:100%;height:auto}#html-body [data-pb-style=BBJA5S4]{border-style:none}#html-body [data-pb-style=G68UPSU],#html-body [data-pb-style=S0NFYVJ]{max-width:100%;height:auto}#html-body [data-pb-style=RS4DJ48]{border-style:none}#html-body [data-pb-style=G6KGNJA],#html-body [data-pb-style=VMR3WSE]{max-width:100%;height:auto}#html-body [data-pb-style=YBVED62]{border-style:none}#html-body [data-pb-style=T83023H],#html-body [data-pb-style=WBDN91G]{max-width:100%;height:auto}@media only screen and (max-width: 768px) { #html-body [data-pb-style=BBJA5S4],#html-body [data-pb-style=MIOAFXP],#html-body [data-pb-style=RS4DJ48],#html-body [data-pb-style=YBVED62]{border-style:none} }</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"K15II1C\"><figure data-content-type=\"image\" data-appearance=\"full-width\" data-element=\"main\" data-pb-style=\"MIOAFXP\"><img class=\"pagebuilder-mobile-hidden\" src=\"{{media url=.renditions/wysiwyg/Banner-01_1.jpg}}\" alt=\"\" title=\"\" data-element=\"desktop_image\" data-pb-style=\"U0LS964\"><img class=\"pagebuilder-mobile-only\" src=\"{{media url=.renditions/wysiwyg/Banner-01_1.jpg}}\" alt=\"\" title=\"\" data-element=\"mobile_image\" data-pb-style=\"V6H9J1F\"></figure><figure data-content-type=\"image\" data-appearance=\"full-width\" data-element=\"main\" data-pb-style=\"BBJA5S4\"><img class=\"pagebuilder-mobile-hidden\" src=\"{{media url=.renditions/wysiwyg/banner3.jpg}}\" alt=\"\" title=\"\" data-element=\"desktop_image\" data-pb-style=\"G68UPSU\"><img class=\"pagebuilder-mobile-only\" src=\"{{media url=.renditions/wysiwyg/banner3.jpg}}\" alt=\"\" title=\"\" data-element=\"mobile_image\" data-pb-style=\"S0NFYVJ\"></figure></div></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"LRDVDWT\"><figure data-content-type=\"image\" data-appearance=\"full-width\" data-element=\"main\" data-pb-style=\"RS4DJ48\"><img class=\"pagebuilder-mobile-hidden\" src=\"{{media url=wysiwyg/hyva_banner_home_test_1_1.jpg}}\" alt=\"\" title=\"\" data-element=\"desktop_image\" data-pb-style=\"G6KGNJA\"><img class=\"pagebuilder-mobile-only\" src=\"{{media url=wysiwyg/hyva_banner_home_test_1_1.jpg}}\" alt=\"\" title=\"\" data-element=\"mobile_image\" data-pb-style=\"VMR3WSE\"></figure></div></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"C0AREO0\"><figure data-content-type=\"image\" data-appearance=\"full-width\" data-element=\"main\" data-pb-style=\"YBVED62\"><img class=\"pagebuilder-mobile-hidden\" src=\"{{media url=.renditions/wysiwyg/Banner-02_1.jpg}}\" alt=\"\" title=\"\" data-element=\"desktop_image\" data-pb-style=\"T83023H\"><img class=\"pagebuilder-mobile-only\" src=\"{{media url=.renditions/wysiwyg/Banner-02_1.jpg}}\" alt=\"\" title=\"\" data-element=\"mobile_image\" data-pb-style=\"WBDN91G\"></figure></div></div>','2025-01-28 13:12:52','2025-01-28 15:16:24',1),(50,'Banyo - 3 Small banners under the main home banner','fast_trustpilot_promise','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"hidden sm:flex justify-between bg-white pt-2\"&gt;\r\n        &lt;!-- Fast Delivery --&gt;\r\n        &lt;div class=\"flex flex-col items-center justify-between text-white p-3\"&gt;\r\n           \r\n&lt;img src=\"/media/wysiwyg/delivery-icon.svg\" alt=\"\" /&gt;\r\n\r\n            &lt;span class=\"text-base font-semibold\"&gt;Test Fast Delivery 1&lt;/span&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;!-- Trustpilot --&gt;\r\n        &lt;div class=\"flex flex-col items-center justify-between text-white p-3\"&gt;\r\n&lt;img src=\"/media/wysiwyg/trust_icon.svg\" alt=\"\" /&gt;\r\n            &lt;span class=\"text-xs font-normal\"&gt;Test Trust Score 4.9 | 659 Reviews 1&lt;/span&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;!-- Price Match Promise --&gt;\r\n        &lt;div class=\"flex flex-col items-center justify-between text-white p-3\"&gt;    \r\n&lt;img src=\"/media/wysiwyg/promise.svg\" alt=\"\"&gt;\r\n            &lt;span class=\"text-base font-semibold\"&gt;Test Price Match Promise 1&lt;/span&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;</div>','2025-01-28 13:20:29','2025-01-28 15:35:16',1),(51,'Nexus - 3 small banners under main home banners','fast_trustpilot_promise_nexus_home','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"hidden sm:flex justify-between bg-white pt-2\"&gt;\r\n        &lt;!-- Fast Delivery --&gt;\r\n        &lt;div class=\"flex flex-col items-center justify-between text-white p-3\"&gt;\r\n           \r\n&lt;img src=\"/media/wysiwyg/delivery-icon.svg\" alt=\"\" /&gt;\r\n\r\n            &lt;span class=\"text-base font-semibold\"&gt;Test Fast Delivery 2&lt;/span&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;!-- Trustpilot --&gt;\r\n        &lt;div class=\"flex flex-col items-center justify-between text-white p-3\"&gt;\r\n&lt;img src=\"/media/wysiwyg/trust_icon.svg\" alt=\"\" /&gt;\r\n            &lt;span class=\"text-xs font-normal\"&gt;Test Trust Score 4.9 | 659 Reviews&lt;/span&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;!-- Price Match Promise --&gt;\r\n        &lt;div class=\"flex flex-col items-center justify-between text-white p-3\"&gt;    \r\n&lt;img src=\"/media/wysiwyg/promise.svg\" alt=\"\"&gt;\r\n            &lt;span class=\"text-base font-semibold\"&gt;Test Price Match Promise&lt;/span&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;</div>','2025-01-28 13:22:45','2025-01-28 15:33:39',1),(52,'Premierdiy - 3 small banners under main Home page banners','fast_trustpilot_promise_premierdiy_home','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"hidden sm:flex justify-between bg-white pt-2\"&gt;\r\n        &lt;!-- Fast Delivery --&gt;\r\n        &lt;div class=\"flex flex-col items-center justify-between text-white p-3\"&gt;\r\n           \r\n&lt;img src=\"/media/wysiwyg/delivery-icon.svg\" alt=\"\" /&gt;\r\n\r\n            &lt;span class=\"text-base font-semibold\"&gt;Test Fast Delivery 3&lt;/span&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;!-- Trustpilot --&gt;\r\n        &lt;div class=\"flex flex-col items-center justify-between text-white p-3\"&gt;\r\n&lt;img src=\"/media/wysiwyg/trust_icon.svg\" alt=\"\" /&gt;\r\n            &lt;span class=\"text-xs font-normal\"&gt;Test Trust Score 4.9 | 659 Reviews 3&lt;/span&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;!-- Price Match Promise --&gt;\r\n        &lt;div class=\"flex flex-col items-center justify-between text-white p-3\"&gt;    \r\n&lt;img src=\"/media/wysiwyg/promise.svg\" alt=\"\"&gt;\r\n            &lt;span class=\"text-base font-semibold\"&gt;Test Price Match Promise 3&lt;/span&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;</div>','2025-01-28 13:24:15','2025-01-28 15:32:16',1),(53,'Nexus - Homepage Banners','homepage-banner-slider-nexus','<style>#html-body [data-pb-style=MCO7AI2],#html-body [data-pb-style=Y6VEKPU]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}#html-body [data-pb-style=MGO8WAH]{border-style:none}#html-body [data-pb-style=PLND33F],#html-body [data-pb-style=PQALQ6Q]{max-width:100%;height:auto}#html-body [data-pb-style=YRWFJKM]{border-style:none}#html-body [data-pb-style=HX1GH09],#html-body [data-pb-style=MWOVOM6]{max-width:100%;height:auto}#html-body [data-pb-style=KYHQGEP]{border-style:none}#html-body [data-pb-style=LKJX47F],#html-body [data-pb-style=WS4FJJ5]{max-width:100%;height:auto}@media only screen and (max-width: 768px) { #html-body [data-pb-style=KYHQGEP],#html-body [data-pb-style=MGO8WAH],#html-body [data-pb-style=YRWFJKM]{border-style:none} }</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"MCO7AI2\"><figure data-content-type=\"image\" data-appearance=\"full-width\" data-element=\"main\" data-pb-style=\"MGO8WAH\"><img class=\"pagebuilder-mobile-hidden\" src=\"{{media url=.renditions/wysiwyg/banner3.jpg}}\" alt=\"\" title=\"\" data-element=\"desktop_image\" data-pb-style=\"PQALQ6Q\"><img class=\"pagebuilder-mobile-only\" src=\"{{media url=.renditions/wysiwyg/banner3.jpg}}\" alt=\"\" title=\"\" data-element=\"mobile_image\" data-pb-style=\"PLND33F\"></figure><figure data-content-type=\"image\" data-appearance=\"full-width\" data-element=\"main\" data-pb-style=\"YRWFJKM\"><img class=\"pagebuilder-mobile-hidden\" src=\"{{media url=.renditions/wysiwyg/Banner-02_1.jpg}}\" alt=\"\" title=\"\" data-element=\"desktop_image\" data-pb-style=\"MWOVOM6\"><img class=\"pagebuilder-mobile-only\" src=\"{{media url=.renditions/wysiwyg/Banner-02_1.jpg}}\" alt=\"\" title=\"\" data-element=\"mobile_image\" data-pb-style=\"HX1GH09\"></figure></div></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"Y6VEKPU\"><figure data-content-type=\"image\" data-appearance=\"full-width\" data-element=\"main\" data-pb-style=\"KYHQGEP\"><img class=\"pagebuilder-mobile-hidden\" src=\"{{media url=wysiwyg/hyva_banner_home_test_1_2.jpg}}\" alt=\"\" title=\"\" data-element=\"desktop_image\" data-pb-style=\"LKJX47F\"><img class=\"pagebuilder-mobile-only\" src=\"{{media url=wysiwyg/hyva_banner_home_test_1_2.jpg}}\" alt=\"\" title=\"\" data-element=\"mobile_image\" data-pb-style=\"WS4FJJ5\"></figure></div></div>','2025-01-28 13:39:43','2025-01-28 15:30:42',1),(54,'Premierdiy - Homepage Banners','homepage-banner-slider-premierdiy','<style>#html-body [data-pb-style=TWPC9VX],#html-body [data-pb-style=YUQEY36]{justify-content:flex-start;display:flex;flex-direction:column;background-position:left top;background-size:cover;background-repeat:no-repeat;background-attachment:scroll}#html-body [data-pb-style=HS2UF47]{border-style:none}#html-body [data-pb-style=DGJVO7I],#html-body [data-pb-style=T648RT7]{max-width:100%;height:auto}#html-body [data-pb-style=CM2VI5Q]{border-style:none}#html-body [data-pb-style=KYCJ2VP],#html-body [data-pb-style=WXXW5TL]{max-width:100%;height:auto}#html-body [data-pb-style=W1N82UF]{border-style:none}#html-body [data-pb-style=M7SEUDN],#html-body [data-pb-style=TI5O2IE]{max-width:100%;height:auto}@media only screen and (max-width: 768px) { #html-body [data-pb-style=CM2VI5Q],#html-body [data-pb-style=HS2UF47],#html-body [data-pb-style=W1N82UF]{border-style:none} }</style><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"TWPC9VX\"><figure data-content-type=\"image\" data-appearance=\"full-width\" data-element=\"main\" data-pb-style=\"HS2UF47\"><img class=\"pagebuilder-mobile-hidden\" src=\"{{media url=.renditions/wysiwyg/Banner-02_1.jpg}}\" alt=\"\" title=\"\" data-element=\"desktop_image\" data-pb-style=\"DGJVO7I\"><img class=\"pagebuilder-mobile-only\" src=\"{{media url=.renditions/wysiwyg/Banner-02_1.jpg}}\" alt=\"\" title=\"\" data-element=\"mobile_image\" data-pb-style=\"T648RT7\"></figure><figure data-content-type=\"image\" data-appearance=\"full-width\" data-element=\"main\" data-pb-style=\"CM2VI5Q\"><img class=\"pagebuilder-mobile-hidden\" src=\"{{media url=.renditions/wysiwyg/banner3.jpg}}\" alt=\"\" title=\"\" data-element=\"desktop_image\" data-pb-style=\"WXXW5TL\"><img class=\"pagebuilder-mobile-only\" src=\"{{media url=.renditions/wysiwyg/banner3.jpg}}\" alt=\"\" title=\"\" data-element=\"mobile_image\" data-pb-style=\"KYCJ2VP\"></figure></div></div><div data-content-type=\"row\" data-appearance=\"contained\" data-element=\"main\"><div data-enable-parallax=\"0\" data-parallax-speed=\"0.5\" data-background-images=\"{}\" data-background-type=\"image\" data-video-loop=\"true\" data-video-play-only-visible=\"true\" data-video-lazy-load=\"true\" data-video-fallback-src=\"\" data-element=\"inner\" data-pb-style=\"YUQEY36\"><figure data-content-type=\"image\" data-appearance=\"full-width\" data-element=\"main\" data-pb-style=\"W1N82UF\"><img class=\"pagebuilder-mobile-hidden\" src=\"{{media url=wysiwyg/hyva_banner_home_test_1_3.jpg}}\" alt=\"\" title=\"\" data-element=\"desktop_image\" data-pb-style=\"TI5O2IE\"><img class=\"pagebuilder-mobile-only\" src=\"{{media url=wysiwyg/hyva_banner_home_test_1_3.jpg}}\" alt=\"\" title=\"\" data-element=\"mobile_image\" data-pb-style=\"M7SEUDN\"></figure></div></div>','2025-01-28 13:55:38','2025-01-28 15:32:55',1),(55,'Nexus - Faqs','nexus','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;!-- Tab for Desktop --&gt;\r\n&lt;div x-data=\"{ activeTab: \'all\' }\" class=\" mt-6 container desktop\"&gt;\r\n    &lt;!-- Tabs --&gt;\r\n    &lt;div class=\"flex space-x-8 border-b border-gray-200\"&gt;\r\n        &lt;button @click=\"activeTab = \'all\'\" :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'all\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            All\r\n        &lt;/button&gt;\r\n        &lt;button @click=\"activeTab = \'payment\'\" :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'payment\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            Payment\r\n        &lt;/button&gt;\r\n        &lt;button @click=\"activeTab = \'order-info\'\" :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'order-info\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            Order Info\r\n        &lt;/button&gt;\r\n        &lt;button @click=\"activeTab = \'international-order\'\"\r\n            :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'international-order\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            International Order\r\n        &lt;/button&gt;\r\n        &lt;button @click=\"activeTab = \'delivery-info\'\"\r\n            :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'delivery-info\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            Delivery Information\r\n        &lt;/button&gt;\r\n        &lt;button @click=\"activeTab = \'product\'\" :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'product\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            Product\r\n        &lt;/button&gt;\r\n        &lt;button @click=\"activeTab = \'promotion\'\" :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'promotion\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            Promotion\r\n        &lt;/button&gt;\r\n        &lt;button @click=\"activeTab = \'trade\'\" :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'trade\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            Trade\r\n        &lt;/button&gt;\r\n        &lt;button @click=\"activeTab = \'returns\'\" :class=\"{ \'border-b-2 border-blue-600\': activeTab === \'returns\' }\"\r\n            class=\"px-3 py-2 text-sx  font-medium\"&gt;\r\n            Returns\r\n        &lt;/button&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Tab Content --&gt;\r\n    &lt;div class=\"mt-4\"&gt;\r\n        &lt;div x-show=\"activeTab === \'all\'\"&gt;\r\n            &lt;!-- Content for All Tab --&gt;\r\n            {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-all-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;div x-show=\"activeTab === \'payment\'\"&gt;\r\n            &lt;!-- Content for Payment Tab --&gt;\r\n           {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-payment-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;div x-show=\"activeTab === \'order-info\'\"&gt;\r\n            &lt;!-- Content for Order Info Tab --&gt;\r\n          {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"Faq-order-info\"}}\r\n        &lt;/div&gt;\r\n        &lt;div x-show=\"activeTab === \'international-order\'\"&gt;\r\n            &lt;!-- Content for International Order Tab --&gt;\r\n         {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-International-order-tab\"}}\r\n        &lt;/div&gt;\r\n        &lt;div x-show=\"activeTab === \'delivery-info\'\"&gt;\r\n            &lt;!-- Content for Delivery Info Tab --&gt;\r\n            {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-delivery-option-tab\"}}\r\n        &lt;/div&gt;\r\n        &lt;div x-show=\"activeTab === \'product\'\"&gt;\r\n            &lt;!-- Content for Product Tab --&gt;\r\n           {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-product-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;div x-show=\"activeTab === \'promotion\'\"&gt;\r\n            &lt;!-- Content for Promotion Tab --&gt;\r\n           {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-promotion-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;div x-show=\"activeTab === \'trade\'\"&gt;\r\n            &lt;!-- Content for Trade Tab --&gt;\r\n    {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-trade-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;div x-show=\"activeTab === \'returns\'\"&gt;\r\n            &lt;!-- Content for Returns Tab --&gt;\r\n           {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-return-tab-content\"}}\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;!-- Accordion for mobile --&gt;\r\n\r\n&lt;div x-data=\"{ activeTab: \'all\' }\" class=\"mt-6 container mobile-faq\"&gt;\r\n    &lt;!-- Accordion for mobile --&gt;\r\n    &lt;div class=\"block lg:hidden space-y-4\"&gt;\r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-base text-gray-900\"&gt;\r\n                All\r\n                &lt;/span&gt;\r\n               &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                &lt;!-- Content for All Tab --&gt;\r\n                {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-all-tab-content\"}}\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n        \r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n            &lt;span class=\"font-semibold text-base text-gray-900\"&gt;\r\n                Payment\r\n                &lt;/span&gt;\r\n                &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                &lt;!-- Content for Payment Tab --&gt;\r\n                {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-payment-tab-content\"}}\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n                &lt;span class=\"font-semibold text-base text-gray-900\"&gt;\r\n                Order Info\r\n                &lt;/span&gt;\r\n                &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                &lt;!-- Content for Order Info Tab --&gt;\r\n                {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"Faq-order-info\"}}\r\n            &lt;/div&gt;\r\n            \r\n        &lt;/div&gt;\r\n\r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n                &lt;span class=\"font-semibold text-base text-gray-900 text-gray-900\"&gt;\r\n                International Order\r\n            &lt;/span&gt;\r\n            &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                 &lt;!-- Content for International Order Tab --&gt;\r\n         {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-International-order-tab\"}}\r\n         &lt;/div&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n                &lt;span class=\"font-semibold text-base text-gray-900\"&gt;Delivery information&lt;/span&gt;\r\n               &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                &lt;!-- Content for Delivery Info Tab --&gt;\r\n            {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-delivery-option-tab\"}}\r\n        &lt;/div&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n                &lt;span class=\"font-semibold text-base text-gray-900\"&gt;Product&lt;/span&gt;\r\n                &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                 &lt;!-- Content for Product Tab --&gt;\r\n           {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-product-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;/div&gt;\r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n                &lt;span class=\"font-semibold text-base text-gray-900\"&gt;Promotion&lt;/span&gt;\r\n                &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                &lt;!-- Content for Promotion Tab --&gt;\r\n           {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-promotion-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;/div&gt;\r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n                &lt;span class=\"font-semibold text-base text-gray-900\"&gt;Trade&lt;/span&gt;\r\n              &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                &lt;!-- Content for Trade Tab --&gt;\r\n    {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-trade-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;div x-data=\"{ open: false }\" class=\"my-2 parent\"&gt;\r\n            &lt;button @click=\"open = !open\" class=\"w-full flex justify-between items-center p-3 text-md rounded-lg border-2 border-gray-300\"&gt;\r\n                &lt;span class=\"font-semibold ttext-base text-gray-900\"&gt;Returns&lt;/span&gt;\r\n                &lt;span&gt;\r\n    &lt;img x-bind:src=\"open ? \'/media/wysiwyg/blue-minus-mobile-faq.svg\' : \'/media/wysiwyg/blue-plus-mobile-faq.svg\'\" \r\n         alt=\"Toggle Icon\" \r\n         class=\"w-6 h-6 inline-block\"&gt;\r\n&lt;/span&gt;\r\n            &lt;/button&gt;\r\n            &lt;div x-show=\"open\" x-collapse&gt;\r\n                &lt;!-- Content for Returns Tab --&gt;\r\n           {{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-return-tab-content\"}}\r\n        &lt;/div&gt;\r\n        &lt;/div&gt;\r\n\r\n\r\n    &lt;/div&gt;\r\n&lt;/div&gt;\r\n</div>','2025-01-28 14:59:53','2025-01-28 15:29:58',1);
/*!40000 ALTER TABLE `cms_block` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cms_block_store`
--

DROP TABLE IF EXISTS `cms_block_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cms_block_store` (
  `block_id` smallint NOT NULL,
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  PRIMARY KEY (`block_id`,`store_id`),
  KEY `CMS_BLOCK_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `CMS_BLOCK_STORE_BLOCK_ID_CMS_BLOCK_BLOCK_ID` FOREIGN KEY (`block_id`) REFERENCES `cms_block` (`block_id`) ON DELETE CASCADE,
  CONSTRAINT `CMS_BLOCK_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='CMS Block To Store Linkage Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cms_block_store`
--

LOCK TABLES `cms_block_store` WRITE;
/*!40000 ALTER TABLE `cms_block_store` DISABLE KEYS */;
INSERT INTO `cms_block_store` VALUES (1,0),(2,0),(5,0),(6,0),(7,0),(8,0),(9,0),(10,0),(11,0),(12,0),(13,0),(14,0),(15,0),(16,0),(17,0),(18,0),(19,0),(21,0),(31,0),(32,0),(33,0),(34,0),(35,0),(40,0),(42,0),(3,1),(4,1),(22,1),(23,1),(24,1),(25,1),(26,1),(27,1),(28,1),(29,1),(30,1),(44,1),(46,1),(49,1),(50,1),(37,3),(43,3),(47,3),(51,3),(53,3),(55,3),(45,4),(48,4),(52,4),(54,4);
/*!40000 ALTER TABLE `cms_block_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cms_page`
--

DROP TABLE IF EXISTS `cms_page`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cms_page` (
  `page_id` smallint NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `title` varchar(255) DEFAULT NULL COMMENT 'Page Title',
  `page_layout` varchar(255) DEFAULT NULL COMMENT 'Page Layout',
  `meta_keywords` text COMMENT 'Page Meta Keywords',
  `meta_description` text COMMENT 'Page Meta Description',
  `identifier` varchar(100) DEFAULT NULL COMMENT 'Page String Identifier',
  `content_heading` varchar(255) DEFAULT NULL COMMENT 'Page Content Heading',
  `content` mediumtext COMMENT 'Page Content',
  `creation_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Page Creation Time',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Page Modification Time',
  `is_active` smallint NOT NULL DEFAULT '1' COMMENT 'Is Page Active',
  `sort_order` smallint NOT NULL DEFAULT '0' COMMENT 'Page Sort Order',
  `layout_update_xml` text COMMENT 'Page Layout Update Content',
  `custom_theme` varchar(100) DEFAULT NULL COMMENT 'Page Custom Theme',
  `custom_root_template` varchar(255) DEFAULT NULL COMMENT 'Page Custom Template',
  `custom_layout_update_xml` text COMMENT 'Page Custom Layout Update Content',
  `layout_update_selected` varchar(128) DEFAULT NULL COMMENT 'Page Custom Layout File',
  `custom_theme_from` date DEFAULT NULL COMMENT 'Page Custom Theme Active From Date',
  `custom_theme_to` date DEFAULT NULL COMMENT 'Page Custom Theme Active To Date',
  `meta_title` varchar(255) DEFAULT NULL COMMENT 'Page Meta Title',
  PRIMARY KEY (`page_id`),
  KEY `CMS_PAGE_IDENTIFIER` (`identifier`),
  FULLTEXT KEY `CMS_PAGE_TITLE_META_KEYWORDS_META_DESCRIPTION_IDENTIFIER_CONTENT` (`title`,`meta_keywords`,`meta_description`,`identifier`,`content`)
) ENGINE=InnoDB AUTO_INCREMENT=31 DEFAULT CHARSET=utf8mb3 COMMENT='CMS Page Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cms_page`
--

LOCK TABLES `cms_page` WRITE;
/*!40000 ALTER TABLE `cms_page` DISABLE KEYS */;
INSERT INTO `cms_page` VALUES (1,'404 Not Found','2columns-right','Page keywords','Page description','no-route','Whoops, our bad...','<dl>\r\n<dt>The page you requested was not found, and we have a fine guess why.</dt>\r\n<dd>\r\n<ul class=\"disc\">\r\n<li>If you typed the URL directly, please make sure the spelling is correct.</li>\r\n<li>If you clicked on a link to get here, the link is outdated.</li>\r\n</ul></dd>\r\n</dl>\r\n<dl>\r\n<dt>What can you do?</dt>\r\n<dd>Have no fear, help is near! There are many ways you can get back on track with Magento Store.</dd>\r\n<dd>\r\n<ul class=\"disc\">\r\n<li><a href=\"#\" onclick=\"history.go(-1); return false;\">Go back</a> to the previous page.</li>\r\n<li>Use the search bar at the top of the page to search for your products.</li>\r\n<li>Follow these links to get you back on track!<br /><a href=\"{{store url=\"\"}}\">Store Home</a> <span class=\"separator\">|</span> <a href=\"{{store url=\"customer/account\"}}\">My Account</a></li></ul></dd></dl>\r\n','2024-08-05 09:21:14','2024-08-05 09:21:14',1,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2,'Home page','1column','','','home','Home Page','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">\r\n</div>','2024-08-05 09:21:14','2024-08-13 14:32:37',1,0,'<!--\n    <referenceContainer name=\"right\">\n        <referenceBlock name=\"catalog.compare.sidebar\" remove=\"true\" />\n    </referenceContainer>-->','','',NULL,NULL,NULL,NULL,''),(3,'Cookies','1column','','','enable-cookies','Cookies','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"bg-white px-6 text-gray-800\"&gt;\r\n\r\n        &lt;h1 class=\"text-3xl font-bold mb-4 text-blue-900\"&gt;Banyo Policy&lt;/h1&gt;\r\n        &lt;p class=\"mb-4 text-lg\"&gt;\r\n            This privacy policy sets out how Banyo.co.uk uses and protects any information that you give Banyo.co.uk\r\n            while using the website. Banyo.co.uk is committed to ensuring that your privacy is protected as we aim\r\n            to take an honest and secure approach to your data. Should we ask you to provide certain information by\r\n            which you can be identified when using Banyo.co.uk, then you can be assured that it will only be used in\r\n            accordance with this privacy statement. Banyo.co.uk may change this policy from time to time by updating\r\n            this page. You should check this page to ensure that you are happy with any changes. This policy,\r\n            alongside our Terms &amp; Conditions is designed to give you a clear, transparent view on why Banyo.co.uk\r\n            collect and process your personal details and what rights you have in relation to how Banyo.co.uk\r\n            interact with your data.&lt;/p&gt;\r\n\r\n        &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;What we collect&lt;/h2&gt;\r\n        &lt;p class=\"text-base\"&gt;\r\n            When you enter information into various forms on the Banyo.co.uk site, and 3rd party partners described\r\n            below, we store it within our secure systems to fulfil the request you have made. This data may include, but\r\n            is not limited to:\r\n        &lt;/p&gt;\r\n        &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n            &lt;li&gt;name&lt;/li&gt;\r\n            &lt;li&gt;contact information including email address&lt;/li&gt;\r\n            &lt;li&gt;demographic information such as postcode, preferences and interests&lt;/li&gt;\r\n            &lt;li&gt;other information relevant to customer surveys and/or offers&lt;/li&gt;\r\n        &lt;/ul&gt;\r\n        &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;What we do with the information we gather&lt;/h2&gt;\r\n\r\n        &lt;p class=\"text-base\"&gt;We require this information to understand your needs and provide you with a better\r\n            service, and in particular for the following reasons:&lt;/p&gt;\r\n        &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n            &lt;li&gt;Internal record keeping.&lt;/li&gt;\r\n            &lt;li&gt;We may use the information to improve our products and services.&lt;/li&gt;\r\n            &lt;li&gt;We may periodically send promotional emails about new products, special offers or other information\r\n                which we think you may find interesting using the email address which you have provided.&lt;/li&gt;\r\n            &lt;li&gt;From time to time, we may also use your information to contact you for market research purposes. We may\r\n                contact you by email, phone, fax or mail. We may use the information to customise the website according\r\n                to your interests.&lt;/li&gt;\r\n        &lt;/ul&gt;\r\n        &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Security&lt;/h2&gt;\r\n\r\n        &lt;p class=\"mb-4 text-base\"&gt;Information stored and processed by Banyo.co.uk is secure to the latest industry\r\n            standard, for example: When you input your information into our website, we transfer your information to our\r\n            secure servers via Secure Standard Layer software, known as SSL. We store your personal details on secure\r\n            servers which utilise high level security protocols.&lt;/p&gt;\r\n\r\n        &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;How we use cookies&lt;/h2&gt;\r\n        &lt;p class=\"mb-4 text-base\"&gt;A cookie is a small file which asks permission to be placed on your computer\'s hard\r\n            drive. Once you agree, the file is added and the cookie helps analyse web traffic or lets you know when you\r\n            visit a particular site. Cookies allow web applications to respond to you as an individual. The web\r\n            application can tailor its operations to your needs, likes and dislikes by gathering and remembering\r\n            information about your preferences.&lt;/p&gt;\r\n        &lt;p class=\"mb-4 text-base\"&gt;\r\n            We use traffic log cookies to identify which pages are being used. This helps us analyse data about web page\r\n            traffic and improve our website in order to tailor it to customer needs. We only use this information for\r\n            statistical analysis purposes and then the data is removed from the system.\r\n        &lt;/p&gt;\r\n        &lt;p class=\"mb-4 text-base\"&gt;\r\n            Overall, cookies help us provide you with a better website, by enabling us to monitor which pages you find\r\n            useful and which you do not. A cookie in no way gives us access to your computer or any information about\r\n            you, other than the data you choose to share with us. You can choose to accept or decline cookies. Most web\r\n            browsers automatically accept cookies, but you can usually modify your browser setting to decline cookies if\r\n            you prefer. This may prevent you from taking full advantage of the website.\r\n        &lt;/p&gt;\r\n        &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Controlling your personal information&lt;/h2&gt;\r\n\r\n        &lt;p class=\"text-base\"&gt;You may choose to restrict the collection or use of your personal information in the\r\n            following ways:&lt;/p&gt;\r\n        &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n            &lt;li&gt;whenever you are asked to fill in a form on the website, look for the box that you can click to indicate\r\n                that you do not want the information to be used by anybody for direct marketing purposes.&lt;/li&gt;\r\n            &lt;li&gt;if you have previously agreed to us using your personal information for direct marketing purposes, you\r\n                may change your mind at any time by letting us know using our Contact Us information&lt;/li&gt;\r\n        &lt;/ul&gt;\r\n        &lt;p class=\"mb-4 text-base\"&gt;We will not sell, distribute or lease your personal information to third parties\r\n            unless we have your permission or are required by law to do so. We may use your personal information to send\r\n            you promotional information about third parties which we think you may find interesting if you tell us that\r\n            you wish this to happen.\r\n            You may request details of personal information which we hold about you under the Data Protection Act 1998.\r\n            A small fee will be payable. If you would like a copy of the information held on you please email us this\r\n            request using our Contact Us information.\r\n            If you believe that any information we are holding on you is incorrect or incomplete, please write to or\r\n            email us as soon as possible, at the above address. We will promptly correct any information found to be\r\n            incorrect.&lt;/p&gt;\r\n            &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Can I opt out of \'Cookies\'?&lt;/h2&gt;\r\n            &lt;p class=\"mb-4 text-base\"&gt;You can choose a range of cookie settings in your browser. For more information on this, please visit the page below that relates to your specific browser.&lt;/p&gt;\r\n            &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n                &lt;li&gt;Google Chrome.&lt;/li&gt;\r\n                &lt;li&gt;Safari&lt;/li&gt;\r\n                &lt;li&gt;Firefox&lt;/li&gt;\r\n            &lt;/ul&gt;\r\n        &lt;/div&gt;</div>','2024-08-05 09:21:14','2024-08-23 06:58:39',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(4,'Privacy Policy','1column','','','privacy-policy','Privacy Policy','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"bg-white px-6 text-gray-800 mb-20\"&gt;\r\n    &lt;h1 class=\"text-3xl font-bold mb-4 text-blue-900\"&gt;Banyo Ltd&lt;/h1&gt;\r\n    &lt;p class=\"mb-4 text-lg\"&gt;\r\n        Banyo Ltd (\"We\") are committed to protecting and respecting your privacy.&lt;br&gt;\r\n        This policy (together with our terms of use and any other documents referred to on it) sets out the basis on\r\n        which any personal data we collect from\r\n        you,&lt;br&gt; or that you provide to us, will be processed by us.\r\n        Please read the following carefully to understand our views and practices regarding your personal data&lt;br&gt;\r\n        and how we will treat it.&lt;br&gt;\r\n        For the purposes of the Data Protection Act 1998 (the Act), the data controller is&lt;br&gt;\r\n        Banyo Ltd of 561-563 Barnabas Road,&lt;br&gt;\r\n        Leicester, LE5 4BD.&lt;br&gt;\r\n        Information we may collect from you&lt;/p&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;We may collect and process the following data about you:&lt;/h2&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n        &lt;li&gt;Information that you provide by filling in forms on our site www.banyo.co.uk (our site). This includes\r\n            information provided at the time of registering to use our site and placing orders through our site. We may\r\n            also ask you for information when you enter a competition or promotion sponsored by Banyo Ltd.&lt;/li&gt;\r\n        &lt;li&gt;Information you provide us via email or other correspondence.&lt;/li&gt;\r\n        &lt;li&gt;Details of transactions you carry out through our site and of the fulfillment of your orders.&lt;/li&gt;\r\n        &lt;li&gt;Details of your visits to our site including, but not limited to, traffic data, location data, weblogs and\r\n            other communication data, whether this is required for our own billing purposes or otherwise.&lt;/li&gt;\r\n    &lt;/ul&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;IP addresses and cookies&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;We may collect information about your computer, including where available your IP address, operating\r\n        system and browser type, for system administration and to report aggregate information to our advertisers. This\r\n        is statistical data about our users\' browsing actions and patterns, and does not identify any individual.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        For the same reason, we may obtain information about your general internet usage by using a cookie file which is\r\n        stored on the hard drive of your computer. Cookies contain information that is transferred to your computer\'s\r\n        hard drive. They help us to improve our site and to deliver a better and more personalised service.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        They enable us:\r\n    &lt;/p&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n        &lt;li&gt;\r\n            To estimate our audience size and usage pattern.&lt;/li&gt;\r\n        &lt;li&gt;To store information about your preferences, and so allow us to customize our site according to your\r\n            individual interests.&lt;/li&gt;\r\n        &lt;li&gt;To speed up your searches.&lt;/li&gt;\r\n        &lt;li&gt;To recognize you when you return to our site.&lt;/li&gt;\r\n    &lt;/ul&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;You may refuse to accept cookies by activating the setting on your browser which allows you to\r\n        refuse the setting of cookies. However, if you select this setting you may be unable to access certain parts of\r\n        our site. Unless you have adjusted your browser setting so that it will refuse cookies, our system will issue\r\n        cookies when you log on to our site.&lt;/p&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Where we store your personal data&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;The data that we collect from you may be transferred to, and stored at, a destination outside the\r\n        European Economic Area (EEA). It may also be processed by staff operating outside the EEA who work for us or for\r\n        one of our suppliers. Such staff maybe engaged in, among other things, the fulfilment of your order, the\r\n        processing of your payment details and the provision of support services. By submitting your personal data, you\r\n        agree to this transfer, storing or processing. We will take all steps reasonably necessary to ensure that your\r\n        data is treated securely and in accordance with this privacy policy.&lt;/p&gt;\r\n    &lt;p class=\"mb-4\"&gt;&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;Unfortunately, the transmission of information via the internet is not completely secure. Athough we\r\n        will do our best to protect your personal data, we cannot guarantee the security of your data transmitted to our\r\n        site; any transmission is at your own risk. Once we have received your information, we will use strict\r\n        procedures and security features to try to prevent unauthorised access.&lt;/p&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Uses made of the information&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;We use information held about you in the following ways:&lt;/p&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n        &lt;li&gt;To ensure that content from our site is presented in the most effective manner for you and for your\r\n            computer.&lt;/li&gt;\r\n        &lt;li&gt;To provide you with information, products or services that you request from us or which we feel may interest\r\n            you, where you have consented to be contacted for such purposes&lt;/li&gt;\r\n        &lt;li&gt;To carry out our obligations arising from any contracts entered into between you and us.&lt;/li&gt;\r\n        &lt;li&gt;To allow you to participate in interactive features of our service, when you choose to do so.&lt;/li&gt;\r\n        &lt;li&gt;To notify you about changes to our service.&lt;/li&gt;\r\n        &lt;li&gt;We may also use your data to provide you with information about goods and services which may be of interest\r\n            to you and we may contact you about these by post or telephone.&lt;/li&gt;\r\n        &lt;li&gt;If you are an existing customer, we will only contact you by electronic means (e-mail or SMS) with\r\n            information about goods and services similar to those which were the subject of a previous sale to you.&lt;/li&gt;\r\n        &lt;li&gt;If you are a new customer we will contact you by electronic means only if you have consented to this&lt;/li&gt;\r\n        &lt;li&gt;If you do not want us to use your data in this way, please tick the relevant box situated on the form on\r\n            which we collect your data (the order form).&lt;/li&gt;\r\n\r\n    &lt;/ul&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;We do not sell, rent or pass on any information about our customers to third parties and we do not\r\n        disclose information about identifiable individuals to our advertisers. However, we may provide them with\r\n        aggregate information about our users (for example, we may inform them that 500 men aged under 30 have clicked\r\n        on their advertisement on any given day). We may also use such aggregate information to help advertisers reach\r\n        the kind of audience they want to target (for example, women in SW1). We may make use of the personal data we\r\n        have collected from you to enable us to comply with our advertisers\' wishes by displaying their advertisement to\r\n        that target audience.&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Disclosure of your information&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;We may disclose your personal information to any member of our group, which means our subsidiaries,\r\n        our ultimate\r\n        holding company and its subsidiaries, as defined in section 736 of the UK Companies Act 1985 and which are not\r\n        treated by us as third parties.&lt;br&gt;\r\n        We in the following circumstances and notwithstanding the foregoing, we may disclose your personal information\r\n        to third parties:&lt;/p&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n        &lt;li&gt;In the event that we buy any business or assets substantially comprising a business, in which case we may\r\n            disclose your personal data to the prospective seller of such business or assets.&lt;/li&gt;\r\n        &lt;li&gt;If Banyo Ltd or substantially all of its assets are acquired by a third party, in which case personal data\r\n            held by it about its customers will be one of the transferred assets.&lt;/li&gt;\r\n        &lt;li&gt;If we are under a duty to disclose or share your personal data in order to comply with any legal obligation,\r\n            or in order to enforce or apply our terms and conditions of &lt;br&gt;supply and other agreements; or to protect\r\n            the rights, property, or safety of Banyo Ltd, our customers, or others. This includes exchanging information\r\n            with other companies &lt;br&gt;and organisations for the purposes of fraud protection and credit risk reduction.\r\n        &lt;/li&gt;\r\n    &lt;/ul&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Your rights&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;You have the right to ask us not to process your personal data for marketing purposes. We will\r\n        usually inform you (before collecting your data) if we intend to use your data &lt;br&gt;for such purposes or if we\r\n        intend to disclose your information to any third party for such purposes. You can exercise your right to prevent\r\n        such processing by checking &lt;br&gt;certain boxes on the forms we use to collect your data. You can also exercise\r\n        the right at any time by contacting us at 64 St. Barnabas Road, Leicester, LE5 4BD.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        Our site may, from time to time, contain links to and from the websites of our partner networks, advertisers and\r\n        affiliates. If you follow a link to any of these websites,&lt;br&gt; please note that these websites have their own\r\n        privacy policies and that we do not accept any responsibility or liability for these policies. Please check\r\n        these policies before &lt;br&gt;you submit any personal data to these websites&lt;/p&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Access to information&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;The Act gives you the right to access information held about you. Your right of access can be exercised in\r\n        accordance with the Act. Any access request may be subject to a fee&lt;br&gt; of £10 to meet our costs in providing\r\n        you with details of the information we hold about you.&lt;/p&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Changes to our privacy policy&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;Any changes we may make to our privacy policy in the future will be posted on this page and, where appropriate, notified to you by e-mail.&lt;/p&gt;\r\n&lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Contact&lt;/h2&gt;\r\n&lt;p class=\"mb-4 text-base\"&gt;Questions, comments and requests regarding this privacy policy are welcomed and should be addressed to 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n\r\n&lt;/div&gt;</div>','2024-08-05 09:21:14','2024-08-21 07:16:42',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(5,'Terms and Conditions','1column','','','terms-and-conditions','Terms and Conditions','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"bg-white px-6 text-gray-800\"&gt;\r\n    &lt;h1 class=\"text-3xl font-bold mb-4 text-blue-900\"&gt;Miscellaneous Provisions&lt;/h1&gt;\r\n    &lt;p class=\"mb-4 text-lg\"&gt;\r\n        This website is operated by Banyo Limited (referred to as \"Banyo/we/our/us\"). As a user of this website\r\n        (referred to as \"you/your\") you acknowledge that &lt;br&gt;any use of this website including any transactions you make\r\n        (\"use/using\") is subject to our terms and conditions below (which includes any other &lt;br&gt;important hyper-linked\r\n        sections e.g. Home delivery information, How to use this website, Returns and refunds and Privacy policy. In\r\n        addition, you will find &lt;br&gt;other useful information within Contact us and FAQs. Please:&lt;/p&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0\"&gt;\r\n        &lt;li&gt;\r\n            &lt;p class=\"mb-4 text-lg\"&gt;read through these terms and conditions carefully before using this website&lt;/p&gt;\r\n        &lt;/li&gt;\r\n        &lt;li&gt;\r\n            &lt;p class=\"mb-4 text-lg\"&gt;print a copy for future reference&lt;/p&gt;\r\n        &lt;/li&gt;\r\n        &lt;li&gt;\r\n            &lt;p class=\"mb-4 text-lg\"&gt;also read our Privacy policy section regarding your personal information.&lt;/p&gt;\r\n        &lt;/li&gt;\r\n    &lt;/ul&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;1. General&lt;/h2&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;1.1 We reserve the right to change these terms and conditions at any time. Any such\r\n        changes will take effect\r\n        when posted on the website (see date at the top) and it is your&lt;br&gt; responsibility to read the terms and\r\n        conditions on each occasion you use this website\r\n        and your continued use of the website shall signify your acceptance to be bound by&lt;br&gt; the latest terms and\r\n        conditions.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;1.2 If you are not a consumer, you confirm that you have authority to bind any business on\r\n        whose behalf you\r\n        use this website&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;1.3 We reserve the right to modify or withdraw, temporarily or permanently, this website\r\n        (or any part\r\n        thereof) with or without notice to you and we shall not be liable to you or&lt;br&gt;\r\n        any third party for any such modification or withdrawal.\r\n        The website is provided by us to you on an \"as is\" and \"as available\" basis.&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;2. Order process&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;2.1 Please see the Home delivery information and How to use this website section for\r\n        information on how to place an order. All\r\n        orders that you place on this website will be &lt;br&gt;subject to acceptance in accordance with these terms and\r\n        conditions.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        2.2 The \'confirmation\' stage sets out the final details of your order. Following this, we will send to you an\r\n        order acknowledgement e-mail detailing the products you have &lt;br&gt;ordered. Please note that this e-mail is not an\r\n        order confirmation or order acceptance from Banyo.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        2.3 Acceptance of your order and the completion of the contract between you and us will take place on dispatch\r\n        to you of the products ordered unless we have notified you &lt;br&gt;that we do not accept your order or you have\r\n        cancelled it (please refer to Returns and refunds).\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;2.4 We do not file details of your order for you to subsequently access direct on this\r\n        website, and therefore, please print out these terms and conditions and the order &lt;br&gt;acknowledgement for your\r\n        own records. If you wish to obtain specific details of your previous orders please refer to Contact us and FAQs.\r\n    &lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;3. Delivery&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;3.1 This website is only for delivery of products to customers with mainland UK and\r\n        Northern Ireland addresses. We cannot deliver to the Channel Islands, Isle of Man,&lt;br&gt; Orkney, Shetland and\r\n        Scottish Islands, BFPO addresses, or the Republic of Ireland. All goods must be signed for by an adult aged 18\r\n        years or over on delivery.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;3.2 Delivery charges and estimated timescales are specified in the Home delivery\r\n        information section and also when you place an order. We make every effort to deliver &lt;br&gt;goods within the\r\n        estimated\r\n        timescales, however delays are occasionally inevitable due to unforeseen factors and all goods and products are\r\n        subject to &lt;br&gt;availability. Banyo shall be under no liability for any delay or failure to deliver the products\r\n        within estimated timescales. We recommend that you make arrangements for &lt;br&gt;trades people to carry out work on\r\n        your\r\n        behalf only after your order has been delivered.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;3.3 Risk of loss and damage of products passes to you on the date when the products are\r\n        delivered or on the date of first attempted delivery by us.&lt;/p&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;3.4 As of TBC our delivery costs will be TBC for small items and TBC for larger items.\r\n        These delivery costs will apply across the site and supersede any delivery prices &lt;br&gt;shown in online brochures,\r\n        online leaflets and any other content.&lt;/p&gt;\r\n    &lt;p class=\"mb-4\"&gt;&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;4. Payment&lt;/h2&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;4.1 We take payment from your card at the time we receive your order, once we have checked\r\n        your card details and stock availability. Goods are subject to availability. In the &lt;br&gt;event that we are unable\r\n        to\r\n        supply the goods, we will inform you of this as soon as possible. A full refund will be given where you have\r\n        already paid for the goods.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;4.2 The price you pay is the price displayed on this website at the time we receive your\r\n        order. No other prices published by Banyo are applicable to these items. The&lt;br&gt; following exception\r\n        applies:&lt;br&gt;\r\n        While we try and ensure that all prices on our website are accurate, errors may occur. If we discover an error\r\n        in the price of goods you have ordered we will inform you as&lt;br&gt; soon as possible and give you the option of\r\n        reconfirming your order at the correct price or canceling it. If we are unable to contact you we will treat the\r\n        order as cancelled. If &lt;br&gt;you cancel and you have already paid for the goods, you will receive a full refund.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;4.3 Payment can be made by any method specified in How to use this website. For\r\n        information about secure online ordering see Secure online shopping.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;4.4 Title to any products you order on this website shall pass to you on delivery of the\r\n        products provided that we have processed and received payment in full for the &lt;br&gt;products.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;4.5 All prices include VAT (where applicable) at the applicable current rates but exclude\r\n        delivery charges, unless expressly stated otherwise (see Home delivery information &lt;br&gt;for further details)&lt;/p&gt;\r\n\r\n\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;5. Returns, cancellations and substitutions&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;5.1 We offer a 7-day money back guarantee, please refer to Returns and refunds. In the\r\n        unlikely event that you receive faulty or damaged goods, please refer to &lt;br&gt;our Returns and refunds section.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;5.2 Sometimes the product specifications from the manufacturer may change, in which case\r\n        we will do our best to offer you a substitute of the same or better quality at the &lt;br&gt;same price. If you are\r\n        not happy with the replacement you can return it in accordance with our 7-day money back guarantee. Where\r\n        applicable, you may cancel your order in &lt;br&gt;accordance with your rights under the Distance selling regulations\r\n        (see the Returns and refunds page for further details).&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;5.3 All sizes and measurements are approximate but we do try to make sure that they are as\r\n        accurate as possible.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;&lt;strong&gt; our &lt;a href=\"/returns\" class=\"underline\"&gt;Returns&lt;/a&gt;section:&lt;/strong&gt;&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;5.4 Products we are unable to cancel, refund or exchange&lt;br&gt;We cannot offer refunds or\r\n        exchanges, unless faulty or not as described, on the following items:&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;5.4.1 Products which have been personalised for you&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;5.4.2 Where a product has been specially ordered for you, unless faulty, we are unable\r\n        to refund or offer an exchange. This includes all gas fires, gas stoves, wood burning &lt;br&gt;stoves and wood and\r\n        multifuel burning stoves, which are all made to order, as well as all fires made by the manufacturers Flamerite\r\n        and Evonic. In exceptional&lt;br&gt; circumstances we may be able to accept return of these items with refund less\r\n        deduction for restocking of 35% plus carriage to the distributor or manufacturer.&lt;/p&gt;\r\n\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;6. Intellectual property&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;6.1 You acknowledge and agree that all copyright, trademarks and all other intellectual\r\n        property rights in all materials and/or content made available as part of your use of&lt;br&gt; this website shall\r\n        remain\r\n        at all times vested in us or our licensors. You are permitted to use this material only as expressly authorised\r\n        by us or our licensors.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        6.2 You acknowledge and agree that the material and content contained within this website is made available for\r\n        your personal non-commercial use only and that you may&lt;br&gt; only download such material and content for the\r\n        purpose of using this website. You further acknowledge that any other use of the material and content of this\r\n        website is &lt;br&gt;strictly prohibited and you agree not to (and agree not to assist or facilitate any third party\r\n        to) copy, reproduce, transmit, publish, display, distribute, commercially exploit or &lt;br&gt;create derivative works\r\n        of such material and content.&lt;/p&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;7. Liability and indemnity&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;7.1 Nothing in these terms and conditions excludes or limits liability for death or\r\n        personal injury caused by negligence, fraudulent misrepresentation, or any other liability&lt;br&gt; which may not\r\n        otherwise be limited or excluded under applicable law.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;7.2 Subject to section 7.1 above, Banyo will use reasonable endeavours to\r\n        verify the accuracy of any information on the site but makes no representation or warranty of any&lt;br&gt; kind\r\n        express\r\n        or implied statutory or otherwise regarding the contents or availability of the site or that it will be timely\r\n        or error-free, that defects will be corrected, or that the &lt;br&gt;site or the server that makes it available are\r\n        free\r\n        of viruses or bugs or represents the full functionality, accuracy, reliability of the website Banyo will not be\r\n        responsible or &lt;br&gt;liable to you for any loss of content or material uploaded or transmitted through the website\r\n        and Banyo accepts no liability of any kind for any loss or damage from action &lt;br&gt;taken or taken in reliance on\r\n        material or information contained on the site.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;7.3 Subject to section 7.1 above, other than as expressly provided in these terms and\r\n        conditions with respect to specific products and except for the exclusive remedies set &lt;br&gt;out at Section 5\r\n        above,\r\n        any indemnities, warranties, terms and conditions (whether express or implied) are hereby excluded to the\r\n        fullest extent permitted under applicable&lt;br&gt; law&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        7.4 Subject to section 7.1 above, Banyo will not be liable, in contract, tort (including, without limitation,\r\n        negligence), pre-contract or other representations (other than fraudulent or negligent misrepresentations) or\r\n        otherwise out of or in connection with the terms and conditions for any:&lt;/p&gt;\r\n\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n        &lt;li&gt;economic losses (including without limitation loss of revenues, data, profits, contracts, business or\r\n            anticipated savings); or&lt;/li&gt;\r\n        &lt;li&gt; loss of goodwill or reputation; or&lt;/li&gt;\r\n        &lt;li&gt;special or indirect losses&lt;/li&gt;\r\n    &lt;/ul&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;suffered or incurred by that party arising out of or in connection with the provisions of\r\n        any matter under these terms and conditions.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;7.5 Notwithstanding the above, subject to Section 7.1 Banyo\'s aggregate liability (whether\r\n        in contract, tort or otherwise) for loss or damage shall in any event be limited to a&lt;br&gt; sum equal to the\r\n        amount paid or payable by you for the product(s) in respect of one incident or series of incidents attributable\r\n        to the same clause.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;7.6 This clause 7 does not affect your statutory rights as a consumer, nor does it affect\r\n        your contract cancellation rights.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;7.7 We will take all reasonable precautions to keep the details of your order and payment\r\n        secure, but unless we are negligent, we cannot be held liable for any losses caused &lt;br&gt;as a result of\r\n        unauthorized access to information provided by you.&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;8. Miscellaneous Provisions &lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.1 The contract between us shall be governed by the laws of England and any dispute\r\n        between us will be resolved exclusively in the courts of England. English is the only &lt;br&gt;language offered for\r\n        the conclusion of the contract.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.2 We have selected our products on the basis that they will be used for domestic use\r\n        only. If you are planning to use them for business purposes please make sure that&lt;br&gt; you are covered by\r\n        appropriate insurance.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.3 Banyo shall be under no liability for any delay or failure to deliver products or\r\n        otherwise perform any obligation as specified in these terms and conditions if the same is &lt;br&gt;wholly or partly\r\n        caused whether directly or indirectly by circumstances beyond its reasonable control.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.4 To provide increased value to our customers, we may provide links to other websites or\r\n        resources for you to access at your sole discretion. You acknowledge and agree &lt;br&gt;that, as you have chosen to\r\n        enter the linked website we are not responsible for the availability of such external sites or resources, and do\r\n        not review or endorse and are not &lt;br&gt;responsible or liable, directly or indirectly, for (i) the privacy\r\n        practices of such websites, (ii) the content of such websites, including (without limitation) any\r\n        advertising,&lt;br&gt; content, products, goods or other materials or services on or available from such websites or\r\n        resources or (iii) the use to which others make of these websites or resources,&lt;br&gt; nor for any damage, loss or\r\n        offence caused or alleged to be caused by, or in connection with, the use of or reliance on any such\r\n        advertising, content, products, goods or &lt;br&gt;other materials or services available on such external websites or\r\n        resources.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.5 You may not assign or sub-contract any of your rights or obligations under these terms\r\n        and conditions or any related order for products to any third party unless agreed &lt;br&gt;upon in writing by Banyo.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.6 Banyo reserves the right to transfer, assign, novate or sub-contract the benefit of\r\n        the whole or part of any of its rights or obligations under these terms and conditions or &lt;br&gt;any related\r\n        contract to any third party.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.7 If any portion of these terms and conditions is held by any competent authority to be\r\n        invalid or unenforceable in whole or in part, the validity or enforceability of the&lt;br&gt; other sections of these\r\n        terms and conditions shall not be affected.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.8 These terms and conditions do not create or confer any rights or benefits enforceable\r\n        by any person that is not a party (within the meaning of the U.K. Contracts (Rights &lt;br&gt;of Third Parties) Act\r\n        1999) except:&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;a. Banyo (as defined below) shall have the right to enforce any rights or benefits under\r\n        these terms and conditions;&lt;br&gt;\r\n        b. Banyo shall have the right to enforce and take the benefit of the rights or benefits of any limitation or\r\n        exclusion or limitation of liability in these terms and conditions;&lt;br&gt;\r\n        c. A person who is a permitted successor or assignee under Section 8.8 above of the rights or benefits of these\r\n        terms and conditions may enforce such rights or benefits.&lt;br&gt;\r\n        d. No consent from the persons referred to in Section 8.9 is required for the parties to vary or rescind these\r\n        terms and conditions (whether or not in any way that varies or &lt;br&gt;extinguishes rights or benefits in favour of\r\n        such third parties).&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.9 No delay or failure by&nbsp;Banyo&nbsp;to exercise any powers, rights or remedies under these\r\n        terms and conditions will operate as a waiver of them nor will any single or partial &lt;br&gt;exercise of any such\r\n        powers, rights or remedies preclude any other or further exercise of them. Any waiver to be effective must be in\r\n        writing and signed by an authorised &lt;br&gt;representative of Banyo.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        8.10 These terms and conditions including the documents or other sources referred to in these terms and\r\n        conditions supersede all prior representations, understandings&lt;br&gt; and agreements between you and Banyo relating\r\n        to the use of this website (including the order of products) and sets forth the entire agreement and\r\n        understanding between&lt;br&gt; you and Banyo for your use of this website.&lt;/p&gt;\r\n        &lt;p class=\"mb-4 text-base desktop\"&gt;The Banyo website is operated by:\r\n        &lt;/p&gt;\r\n        &lt;p class=\"mb-4 text-base capitalize font-bold desktop\"&gt;Banyo Limited,&lt;br&gt;\r\n        64, St. Barnabas Road,&lt;br&gt;\r\n            Leicester&lt;br&gt;\r\n            LE5 4B\r\n        &lt;/p&gt;\r\n        &lt;p class=\"mb-4 text-base desktop\"&gt;Registered in England with company number&nbsp;3955869.&lt;/p&gt;\r\n        &lt;p class=\"mb-4 text-base desktop\"&gt;VAT Number&nbsp;754 4515 26&nbsp;&lt;/p&gt;\r\n        &lt;p class=\"mb-4 text-base desktop\"&gt;We recommend you print out a copy of these terms and conditions for your future reference.&nbsp;&nbsp;\r\nIf you have any questions regarding the&nbsp;Banyo&nbsp;website please refer to Contact Us and FAQs for more information and full contact details.&lt;/p&gt;\r\n\r\n&lt;/div&gt;</div>','2024-08-21 08:12:12','2024-10-30 10:15:39',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(6,'Careers','1column','','','careers','Careers','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"bg-white px-6 text-gray-800 custom-spc carrer-spacing\"&gt;\r\n    &lt;p class=\"mb-4 text-lg\"&gt;Excellent opportunities to join a leading established family based business within the\r\n        luxury bathroom, kitchen and independent plumbers merchants &lt;br&gt;sector. We have the following vacancies\r\n        available due to rapid growth and expansion.&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Full time bathroom and kitchen sales designer / advisor&lt;/h2&gt;\r\n    &lt;p class=\"text-base\"&gt;An exciting and varied role to include sales, designing and pricing, site visits, internal\r\n        marketing and customer networking.&lt;br&gt;\r\n        Must be enthusiastic, self-motivated with a passion to deliver great customer service. Excellent communication\r\n        and organisational skills - training will be provided. Ideal &lt;br&gt;candidate to have minimum 2 years experience in\r\n        the industry, be of smart appearance, articulate, confident, friendly and engaging with a proven track record of\r\n        selling in &lt;br&gt;this or related industry..&lt;/p&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n        &lt;li&gt;\r\n            &lt;p&gt;40 hour week – must be able to work on Saturdays (9am to 6.00pm)&lt;/p&gt;\r\n        &lt;/li&gt;\r\n        &lt;li&gt;\r\n            &lt;p class=\"mb-4\"&gt;Salary band - £20,000.00 to £25,000.00 plus benefits including performance bonus&lt;/p&gt;\r\n        &lt;/li&gt;\r\n    &lt;/ul&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Trade counter sales assistant (Two positions available)&lt;/h2&gt;\r\n\r\n    &lt;p class=\"text-base\"&gt;Looking for determined, eager and self motivated individuals who can deliver great\r\n        customer service. Experience in the plumbing trade is an advantage but not essential as &lt;br&gt;training will be\r\n        provided.&lt;/p&gt;\r\n    &lt;p class=\"text-base\"&gt;Main responsibilities of trade counter sales, advising and processing customer\r\n        requirements, telephone orders, despatching and stock control.&lt;/p&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n        &lt;li&gt;\r\n            &lt;p&gt;Full time permanent position – 8am to 6pm, 5 days a week.&lt;/p&gt;\r\n        &lt;/li&gt;\r\n        &lt;li&gt;\r\n            &lt;p&gt;Starting salary £16,000.00 to £18,000.00&lt;/p&gt;\r\n        &lt;/li&gt;\r\n    &lt;/ul&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Customer service advisor&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;This is a busy and varied role to include taking incoming calls from customers, processing\r\n        and responding in a professional manner to their requests for sales and &lt;br&gt;assistance on products. Emails and\r\n        enquiries, research projects, organising and cleansing data on the company’s crm system. Supporting the managing\r\n        director with &lt;br&gt;administrative tasks.&lt;/p&gt;\r\n    &lt;p class=\"text-base\"&gt;A passionate, dedicated individual who wants to grow and achieve personal success. Proven\r\n        track record in customer service / online sales an advantage. Ability to work to &lt;br&gt;deadlines and targets. Must\r\n        have a professional phone manner with excellent communication and IT skills.&lt;/p&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n        &lt;li&gt;\r\n            &lt;p&gt;Full time permanent position – 9am to 6pm, 5 days a week&lt;/p&gt;\r\n        &lt;/li&gt;\r\n        &lt;li&gt;\r\n            &lt;p class=\"mb-4\"&gt;Salary band - £18,000.00 to £20,000.00 plus performance related bonus&lt;/p&gt;\r\n        &lt;/li&gt;\r\n    &lt;/ul&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Bookeeper&lt;/h2&gt;\r\n    &lt;p class=\"text-base\"&gt;Bookeeper required on a full time permanent basis however there may be flexibility with hours.\r\n        At least two years minimum experience required. To assist company &lt;br&gt;accountant with full bookeeping duties.\r\n        Monday to Friday 9am to 5pm.&lt;/p&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n        &lt;li&gt;\r\n            &lt;p&gt;Salary band £15,000 - £18,000.&lt;/p&gt;\r\n        &lt;/li&gt;\r\n        &lt;li&gt;\r\n            &lt;p class=\"mb-4\"&gt;28 days paid holiday (including bank holiday)&lt;/p&gt;\r\n        &lt;/li&gt;\r\n    &lt;/ul&gt;\r\n    &lt;p class=\"mb-4\"&gt;For any of the above positions please apply via email with current cv and covering letter to&nbsp;&lt;a\r\n            href=\"mailto:recruitment@banyo.co.uk\"&gt;recruitment@banyo.co.uk&lt;/a&gt;&lt;/p&gt;\r\n&lt;/div&gt;</div>','2024-08-21 09:53:24','2024-08-21 10:29:41',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(7,'Returns','1column','','','returns','Returns','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"bg-white px-6 text-gray-800\"&gt;\r\n    &lt;h1 class=\"text-3xl font-bold mb-4 text-blue-900\"&gt;Returns Information&lt;/h1&gt;\r\n    &lt;p class=\"mb-4 text-lg\"&gt;\r\n        We hope that your purchase is exactly what you expected, however we understand that occasionally an issue may\r\n        occur with your chosen item(s). If you &lt;br&gt;change your mind for whatever reason and simply do not want any of\r\n        the\r\n        products purchased, as long as it is within 14 days of receipt of goods you may &lt;br&gt;return the goods to us as we\r\n        offer a hassle-free 14 day returns policy:&lt;br&gt; &lt;br&gt;&lt;/p&gt;\r\n        \r\n    &lt;ul class=\"list-none list-inside space-y-2 mb-4 p-8 py-0 text-lg\"&gt;\r\n        &lt;li&gt; 1. You can return your item if it is unsuitable, provided it’s unopened and in its original packaging.&lt;/li&gt;\r\n        &lt;li&gt; 2. However you (the customer) shall be responsible for the return of the product and all cost associated\r\n            with this.&lt;/li&gt;\r\n        &lt;li&gt; 3. You the customer will be responsible for our postage costs to you which will be deducted from the amount\r\n            we refund to you.&lt;/li&gt;\r\n    &lt;/ul&gt;\r\n    \r\n    &lt;p class=\"mb-4 text-lg\"&gt;&lt;br&gt;Contact our Customer Care Team by Email &lt;a href=\"mailto:returns@banyo.co.uk\"&gt;returns@banyo.co.uk&lt;/a&gt; detailing the damage with\r\n        images if appropriate to arrange a collection and a credit or &lt;br&gt;refund for the product will be issued within\r\n        14 days of receipt by us of the product.&lt;/p&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5 we-founded\"&gt;Products we are unable to cancel, refund or exchange&lt;/h2&gt;\r\n\r\n    &lt;p class=\" text-base\"&gt;We cannot offer refunds or exchanges, unless faulty or not as described, on the following\r\n        items:&lt;/p&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base personlaized\"&gt;\r\n        &lt;li&gt;Products which have been personalised for you.&lt;/li&gt;\r\n        &lt;li&gt;Where a product has been specially ordered for you, unless faulty, we are unable to refund or offer an\r\n            exchange. In exceptional circumstances we may be able to accept&lt;br&gt;\r\n            return of these items with refund less deduction for restocking of 35% plus carriage to the distributor or\r\n            manufacturer.&lt;/li&gt;\r\n    &lt;/ul&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5 received-box\"&gt;Return of Incorrect, Faulty or Damaged Goods Received&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;We ask that customers make a full inspection of all products received on the day of\r\n        delivery. We must be notified of any items that arrive faulty or damaged within 48hrs of&lt;br&gt; receipt. For this\r\n        we advise that you send an email to &lt;a href=\"mailto:returns@banyo.co.uk\"&gt;returns@banyo.co.uk&lt;/a&gt; detailing the damage with images if appropriate. This\r\n        email will be acknowledged by us and we&lt;br&gt; will advise the next steps, and contact you and either arrange\r\n        collection, ask for goods to be returned back to us or ask you to dispose of the goods. Please note, never &lt;br&gt;\r\n        dispose of goods without our notification. Should we request that you send the goods back to us, we ask that you\r\n        include a receipt for any postage costs that you may incur&lt;br&gt; so that we may refund the full cost of\r\n        postage.&lt;br&gt;Please note: All goods reported as faulty will be tested by manufacturers, if it is determined the\r\n        goods are not faulty or if the faults are deemed to be caused by damage or&lt;br&gt; abuse this will void any\r\n        warranty, goods will be returned to you and no refund or replacement issued.&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;For answers to some of the more frequently asked questions about Returns\r\n    &lt;/h2&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base font-semibold\"&gt;I would like to return an item, what do I need to do?&lt;/p&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;If you would like to return an item to us you will need to firstly email us\r\n        on &lt;a href=\"mailto:returns@banyo.co.uk\"&gt;returns@banyo.co.uk&lt;/a&gt; with your invoice number and details of the reason for return. We will then&lt;br&gt; give you\r\n        instructions of the procedure to follow. Please make sure that the purchased goods are returned to us in a as\r\n        new condition. We will require all the original boxes &lt;br&gt;and packing (including all packaging) and the goods\r\n        must\r\n        be taken care of whilst in your possession. We do ask that any goods that are in a sealed packaging and are&lt;br&gt;\r\n        clearly visible without the need to open the packaging remain unopened. No returns will be accepted if the item\r\n        is damaged or marked. We recommend using a recorded &lt;br&gt;mail service for sending any parcels. When returning\r\n        your\r\n        item please make sure to include your order number and also the reason for the return. If you would like to\r\n        return &lt;br&gt;the item to us we will arrange for your credit card / paypal account to be credited.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"text-base font-semibold\"&gt;What is your returns address?&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;Our returns address is as follows:&lt;br&gt;\r\n        Returns Department&lt;br&gt;\r\n        Banyo Ltd t/a Nexus&lt;br&gt;\r\n        International House&lt;br&gt;\r\n        64 St. Barnabas Road&lt;br&gt;\r\n        Leicester&lt;br&gt;\r\n        LE5 4BD&lt;/p&gt;\r\n    &lt;p class=\"text-base font-semibold\"&gt;Do you offer a collection service?&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;We offer a limited collection service for return of incorrect, faulty or damaged goods\r\n        only,\r\n        please contact us to confirm in each case&lt;/p&gt;\r\n    &lt;p class=\"text-base font-semibold\"&gt;\r\n        How long does the returns process take?\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        Once goods are received back to us, returns normally take about 10 working days to process.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"text-base font-semibold\"&gt;Have you any questions which we haven’t asked?&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;Our returns policy can be found on our website, however if you wish to speak to one of the\r\n        team please call our customer services team on 0116 274 4059.&lt;/p&gt;\r\n    &lt;p class=\"text-base font-semibold\"&gt;\r\n        How long will my refund take?&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;It will take 14 business days from when you contacted us to receive your refund. Once\r\n        your refund has been approved, the refund amount will be issued back to your original &lt;br&gt;payment method.&lt;br&gt;\r\n        If you contact us to arrange a refund more than 14 business days after delivery, we may be unable to provide\r\n        you with a full refund for the goods being returned.&lt;/p&gt;\r\n    &lt;p class=\"text-base font-semibold\"&gt;Will you refund the delivery charges if I return a product?&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;For return of goods that are not incorrect, faulty or damaged there is no refund of the\r\n        delivery charges from ourselves or your delivery return cost.&lt;/p&gt;\r\n\r\n&lt;/div&gt;</div>','2024-08-21 10:22:15','2024-10-29 06:49:43',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(8,'How to Order','1column','','','how-to-order','How to Order','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"bg-white px-6 text-gray-800 custom-spc carrer-spacing\"&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Place your order&lt;/h2&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n        &lt;li&gt;\r\n            &lt;p&gt;You can make an online purchase through our website and the item will be delivered straight to your door or your required address.&lt;/p&gt;\r\n        &lt;/li&gt;\r\n        &lt;li&gt;\r\n            &lt;p &gt;You can call us and our trained and experienced sales team will be happy to take your order over the phone or help you to answer any queries you may have.&lt;/p&gt;\r\n        &lt;/li&gt;\r\n        &lt;li&gt;\r\n            &lt;p class=\"mb-4\"&gt;You can visit our showroom and browse our huge range of products.&lt;/p&gt;\r\n        &lt;/li&gt;\r\n    &lt;/ul&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;&lt;strong&gt;Order processing&lt;/strong&gt;&nbsp;means your order could be at any point between the warehouse receiving it and despatching your goods.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;&lt;strong&gt;Dispatched&lt;/strong&gt;&nbsp;means your order has left our warehouse. You\'ll receive an email confirming despatch. Depending on our chosen carrier, you may receive a separate email from us that will detail how to track your order when it has left the warehouse. In the case of products such as furniture where there is a long lead time, \"Despatched\" means that you\'ve been charged for your order, and you\'ll be notified of delivery separately.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;&lt;strong&gt;Canceled&lt;/strong&gt;&nbsp;means your order has been canceled either by you or us&lt;/p&gt;\r\n&lt;/div&gt;</div>','2024-08-21 10:39:50','2024-08-21 10:44:55',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(9,'14 Day Money Back Guarantee','1column','','','14-day-money-back-guarantee','14 Day Money Back Guarantee','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"bg-white px-6 text-gray-800 custom-spc \"&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;&lt;strong&gt;Banyo&lt;/strong&gt;&nbsp;offers a 14-day money back guarantee on all of our products. That means if you\'re not 100% happy with the quality of the items you receive, you can return them&lt;br&gt; straight back to us. Exceptions are special order items or items which have been personalized for you.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;*Please notify us within 14 days of your delivery date if you wish to return any of your items by email to&nbsp;&lt;a href=\"returns@banyo.co.uk\"&gt;returns@banyo.co.uk.&lt;/a&gt; On receipt of your email, we will advise the steps &lt;br&gt;   to follow. To qualify, all we ask is that the goods are returned by you are:&lt;/p&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n        &lt;li&gt;\r\n            &lt;p&gt;Unused&lt;/p&gt;\r\n        &lt;/li&gt;\r\n        &lt;li&gt;\r\n            &lt;p&gt;Uninstalled&lt;/p&gt;\r\n        &lt;/li&gt;\r\n        &lt;li&gt;\r\n            &lt;p&gt;In the same condition as you received them&lt;/p&gt;\r\n        &lt;/li&gt;\r\n        &lt;li&gt;\r\n            &lt;p&gt;In the original packaging&lt;/p&gt;\r\n        &lt;/li&gt;\r\n    &lt;/ul&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;Providing ALL of the above has been met, your refund will be issued upon receipt of your returned item(s) to our warehouse.&lt;/p&gt;\r\n    &lt;strong class=\"mb-4 block\"&gt;Special Order or Personalized Items Excluded&lt;/strong&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;We cannot offer refunds or exchanges, unless faulty or not as described, on the following items:&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;Products which have been personalised for you.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;Where a product has been specially ordered for you, unless faulty, we are unable torefund or offer an exchange. This includes all gas fires, gas stoves, gas wall heaters, wood burning stoves and wood and multifuel burning stoves, which are all made to order, as well as all fires made by the manufacturers Flamerite and Evonic. In exceptional circumstances we may be able to accept return of these items with refund less deduction for restocking of 35% plus carriage to the distributor or manufacturer.&lt;/p&gt;\r\n&lt;/div&gt;</div>','2024-08-21 11:10:20','2024-08-21 11:39:49',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(10,'Visit Our Showroom','1column','','','visit-our-showroom','Visit Our Showroom','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"bg-white px-6 text-gray-800\"&gt;\r\n    &lt;div class=\"flex justify-between mb-8\"&gt;\r\n        &lt;div class=\"col-1\"&gt;\r\n            &lt;h1 class=\"text-3xl font-bold mb-4 text-blue-900\"&gt;Our Showroom&lt;/h1&gt;\r\n            &lt;br&gt;\r\n            &lt;p class=\"mb-4 text-lg\"&gt;\r\n                Call our customer services team on 0116 274 4059&lt;br&gt;\r\n                Monday to Friday 9 am - 6 pm&lt;br&gt;\r\n                Saturday 9am - 5pm&lt;/p&gt;\r\n            &lt;br&gt;\r\n            &lt;br&gt;\r\n            &lt;br&gt;\r\n            &lt;p class=\"mb-4 text-lg error-msg text-red-500\"&gt;Note: Calls may be recorded for training and monitoring\r\n                purposes\r\n            &lt;/p&gt;\r\n        &lt;/div&gt;\r\n        &lt;div class=\"col-1 map mt-8\"&gt;\r\n            &lt;iframe\r\n                src=\"https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2421.138744017472!2d-1.1013069240649545!3d52.6394063273832!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x487761658d3a98f9%3A0x11338722dd6d1f0c!2sNexus!5e0!3m2!1sen!2snp!4v1724239017023!5m2!1sen!2snp\"\r\n                width=\"787\" height=\"242px\" style=\"border:0;\" allowfullscreen=\"\" loading=\"lazy\"\r\n                referrerpolicy=\"no-referrer-when-downgrade\"&gt;&lt;/iframe&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;p class=\"mb-4 text-lg\"&gt;\r\n        Banyo Ltd is a family-run business, and we operate from our large, 10,000ft² Nexus showroom based in Leicester.\r\n        With an extensive range of products and displays for your home, we aim to offer you unparalleled selection,\r\n        prices and service. We have been in this location for 17 years, and have decades of shared experience in\r\n        supplying the best in bathrooms, kitchens and designer fires to thousands of satisfied customers. We also\r\n        have a trade counter, where our dedicated experts provide an unrivalled service to hundreds of local\r\n        plumbers, builders and electricians every day. Our showroom is a hub for consumers and tradespeople to discover\r\n        the latest in home design, with our large range of bathrooms, kitchens, fires and stoves.\r\n    &lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Bathrooms&lt;/h2&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;Here at Banyo, we have a large array of bathrooms on display. With bathroom displays for\r\n        all the leading brands, including Grohe, Kohler, Matki, Franke, Blanco, Ambiance\r\n        Bain, Hansgrohe, HiB, RAK, Bette, Ideal Standard and many more, you will be impressed with all we have to offer.\r\n        Our 10,000ft² showroom is a beacon of bathroom design ideas, high-quality products, and expert advice.\r\n        Whether\r\n        you need a bath, basin, shower enclosure, vanity unit, mirror cabinet, or entire bathroom installation, we are\r\n        here to fulfil your every need.&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Kitchens&lt;/h2&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;At our showroom in Leicester, we are proud to have an extensive range of kitchen units and\r\n        appliances on display. Whether you need an entire kitchen refit, a new sink, or new appliances such as\r\n        fridge-freezers and ovens, we are here to cater to your requirements. Our large showroom off Uppingham Road in\r\n        Leicester has a great selection of expertly designed kitchens on display, so please don’t hesitate to pay us\r\n        a visit to discover our collections. We supply all the leading brands, such as Franke, Blanco, Bosch, Neff,\r\n        Kohler, Reginox and Phoenix. With prices and service that can’t be beaten, come and check us out today.&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Fires&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;Banyo is proud to supply the full ranges of all leading brands of fires and stoves. We\r\n        have a large number of great fires on display in our showroom, and welcome potential customers to pay us a\r\n        visit\r\n        and see what we have to offer. We are official suppliers\r\n        of Dru, Gazco, Flamerite, Evonic, Dimplex, Valor and Flavel. We supply a range of gas, electric and\r\n        multi-fuel\r\n        fires and stoves. With a selection unrivalled in this region, please make sure to stop by to check out our great\r\n        fireplace displays.&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Trade Counter\r\n    &lt;/h2&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;Banyo is particularly proud of its busy trade counter, which provides a\r\n        superior service to local tradespeople. If you are a tradesperson working locally to Leicester, we guarantee\r\n        that you will be delighted by the knowledge and service offered by our dedicated staff. With many years of\r\n        experience, a large range of items in stock and on display, and highly competitive prices, you will not be\r\n        disappointed if you pay us a visit.&lt;/p&gt;\r\n&lt;/div&gt;</div>','2024-08-21 11:39:11','2024-09-10 09:17:16',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(11,'About Us','1column','','','about-us','','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"main-about-wrap\"&gt;\r\n    &lt;!-- First Section with Background Image and Text Overlay --&gt;\r\n    &lt;section class=\"exceptional-about\"&gt;\r\n        &lt;div class=\"relative w-full h-[300px] md:h-[400px]\"&gt;\r\n            &lt;img src=\"{{media url=.renditions/wysiwyg/luxurious-modern-living-room-with-sleek-minimalist-design-elegant-fireplace_1.png}}\"\r\n                alt=\"Living Room\" class=\"object-cover w-full h-full\" /&gt;\r\n            &lt;div class=\"absolute inset-0 bg-black bg-opacity-50 flex items-center justify-center\"&gt;\r\n                &lt;h1 class=\"text-white text-center text-2xl md:text-4xl font-bold px-4\"&gt;\r\n                    Committed to Providing Exceptional &lt;br&gt;Service and Premium Products for Two Decades.\r\n                &lt;/h1&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/section&gt;\r\n\r\n    &lt;!-- Second Section with Images and Text --&gt;\r\n    &lt;section class=\"py-16 our-sucess-lead container\"&gt;\r\n        &lt;div class=\"lead-col\"&gt;\r\n            &lt;div class=\"grid grid-cols-1 md:grid-cols-2 lg:grid-cols-3\"&gt;\r\n                &lt;div class=\"lg:col-span-1 flex items-center\"&gt;\r\n                    &lt;!-- First Image --&gt;\r\n                    &lt;div class=\"lg:col-span-1 flex mr-3\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/view-small-bathroom-with-modern-style-decor-furniture_1.png}}\"\r\n                            alt=\"Bathroom 1\" class=\"object-cover\" /&gt;\r\n                    &lt;/div&gt;\r\n\r\n                    &lt;!-- Second Image --&gt;\r\n\r\n                    &lt;div class=\"lg:col-span-1\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/Mask_group.png}}\" alt=\"Bathroom 2\"\r\n                            class=\"object-cover \" /&gt;\r\n                    &lt;/div&gt;\r\n                &lt;/div&gt;\r\n                &lt;!-- Text Content --&gt;\r\n                &lt;div class=\"lg:col-span-1 flex flex-col\"&gt;\r\n                    &lt;h2 class=\"text-2xl font-normal mb-4 font-semibold\"&gt;\r\n                        Our &lt;br&gt; &lt;br&gt; Journey to &lt;span class=\"text-blue-900 underline\"&gt;Success&lt;/span&gt;\r\n                    &lt;/h2&gt;\r\n                    &lt;p class=\"text-gray-700 mb-4 pt-4 .2xl:text-lg leading-5\"&gt;\r\n                        For the past two decades, Banyo has remained committed to providing exceptional service and\r\n                        continuing to amaze our loyal clients. As a family-run company based in the East Midlands and\r\n                        beyond, we are known for our ability to transform homes and businesses with our magic touch. Our\r\n                        two\r\n                        Leicester locations are home to a team of wise and knowledgeable experts who provide exceptional\r\n                        pre- and post-sale support.\r\n                    &lt;/p&gt;\r\n                    &lt;p class=\"text-gray-700 mb-4 .2xl:text-lg leading-5\"&gt;\r\n                        At Banyo, we have established ourselves as the premier choice for those looking to purchase\r\n                        high-quality kitchen appliances, designer fireplaces, and luxurious bathrooms. Our enthralling\r\n                        work\r\n                        has graced countless notable commercial and residential properties. However, our superlative\r\n                        E-Commerce division is the real secret to our success. Our team works tirelessly to provide a\r\n                        seamless online experience, backed by the magic of our two reputable showrooms.\r\n                    &lt;/p&gt;\r\n                    &lt;p class=\"text-gray-700 .2xl:text-lg leading-5\"&gt;\r\n                        With a wealth of experience, we take great pride in delivering an exceptional online experience\r\n                        for\r\n                        our customers. We invite you to join us on our fantastical journey and let us surprise you with\r\n                        our\r\n                        exceptional service and quality products.\r\n                    &lt;/p&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/section&gt;\r\n\r\n    &lt;!-- third section structure --&gt;\r\n    &lt;section class=\"bg-gray-100 py-16 choose-box\"&gt;\r\n        &lt;div class=\"max-w-6xl mx-auto text-center container\"&gt;\r\n            &lt;h2 class=\"text-3xl font-semibold text-gray-800\"&gt;Why Choose Us&lt;/h2&gt;\r\n            &lt;p class=\"text-gray-600 max-w-[870px] mx-auto mb-9\"&gt;\r\n                At Banyo, we understand that discerning consumers recognize the difference between good, better, and\r\n                best. That\'s why we consistently offer products that embody a perfect blend of innovation, quality, and\r\n                flawless features. Our commitment to excellence sets us apart, and here\'s why you should choose us:\r\n            &lt;/p&gt;\r\n            &lt;div class=\"grid grid-cols-1 md:grid-cols-3 lg:grid-cols-3 gap-8\"&gt;\r\n                &lt;!-- Card 1 --&gt;\r\n                &lt;div class=\"shadow-md text-center\"&gt;\r\n                    &lt;div class=\"mb-4\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/Group_27144.png}}\" alt=\"Unmatched Quality\"\r\n                            class=\"mx-auto\" /&gt;\r\n                    &lt;/div&gt;\r\n                    &lt;h3 class=\"text-xl font-semibold text-blue-900  mb-2\"&gt;Unmatched Quality&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-600\"&gt;We provide high-quality products&lt;br&gt; that elevate every room in your&lt;br&gt;\r\n                        home.&lt;/p&gt;\r\n                &lt;/div&gt;\r\n                &lt;!-- Card 2 --&gt;\r\n                &lt;div class=\"shadow-md text-center\"&gt;\r\n                    &lt;div class=\"mb-4\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/Group.png}}\" alt=\"Delivery Across the UK\"\r\n                            class=\"mx-auto\" /&gt;\r\n                    &lt;/div&gt;\r\n                    &lt;h3 class=\"text-xl font-semibold text-blue-900  mb-2\"&gt;Delivery Across the UK&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-600\"&gt;Only the finest, eco-conscious &lt;br&gt;materials make it into our&lt;br&gt; product\r\n                        lineup.\r\n                    &lt;/p&gt;\r\n                &lt;/div&gt;\r\n                &lt;!-- Card 3 --&gt;\r\n                &lt;div class=\" shadow-md text-center\"&gt;\r\n                    &lt;div class=\"mb-4\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/Group_27164.png}}\" alt=\"Innovative Designs\"\r\n                            class=\"mx-auto\" /&gt;\r\n\r\n                    &lt;/div&gt;\r\n                    &lt;h3 class=\"text-xl font-semibold text-blue-900  mb-2\"&gt;Innovative Designs&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-600\"&gt;Our products combine innovation&lt;br&gt; with flawless features for the&lt;br&gt; best\r\n                        solutions.&lt;/p&gt;\r\n                &lt;/div&gt;\r\n                &lt;!-- Card 4 --&gt;\r\n                &lt;div class=\" shadow-md text-center\"&gt;\r\n                    &lt;div class=\"mb-4\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/Group_27167.png}}\" alt=\"Trusted Relationships\"\r\n                            class=\"mx-auto\" /&gt;\r\n                    &lt;/div&gt;\r\n                    &lt;h3 class=\"text-xl font-semibold text-blue-900  mb-2 \"&gt;Trusted Relationships&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-600\"&gt;We maintain strong ties with top &lt;br&gt;brands to ensure the best for our&lt;br&gt;\r\n                        customers.&lt;/p&gt;\r\n                &lt;/div&gt;\r\n                &lt;!-- Card 5 --&gt;\r\n                &lt;div class=\"shadow-md text-center\"&gt;\r\n                    &lt;div class=\"mb-4\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/Group_27298.png}}\" alt=\"Great Value Pricing\"\r\n                            class=\"mx-auto\" /&gt;\r\n                    &lt;/div&gt;\r\n                    &lt;h3 class=\"text-xl font-semibold text-blue-900  mb-2 \"&gt;Great Value Pricing&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-600\"&gt;Only the finest, eco-conscious &lt;br&gt;materials make it into our&lt;br&gt; product\r\n                        lineup.\r\n                    &lt;/p&gt;\r\n                &lt;/div&gt;\r\n                &lt;!-- Card 6 --&gt;\r\n                &lt;div class=\" shadow-md text-center\"&gt;\r\n                    &lt;div class=\"mb-4\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/Group_27299.png}}\" alt=\"UK-Based Customer Support\"\r\n                            class=\"mx-auto\" /&gt;\r\n                    &lt;/div&gt;\r\n                    &lt;h3 class=\"text-xl font-semibold text-blue-900 mb-2 \"&gt;UK-Based Customer Support&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-600\"&gt;Our products combine innovation &lt;br&gt;with flawless features for the&lt;br&gt; best\r\n                        solutions.&lt;/p&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/section&gt;\r\n    &lt;!-- fourth section structure --&gt;\r\n    &lt;section class=\"our-journey-box\"&gt;\r\n        &lt;div class=\"px-12 py-10 text-center\"&gt;\r\n            &lt;h2 class=\"text-3xl font-bold text-gray-800\"&gt;Join our Journey&lt;/h2&gt;\r\n            &lt;p class=\"text-gray-600\"&gt;Experience Exceptional Service and Quality Products&lt;/p&gt;\r\n        &lt;/div&gt;\r\n        &lt;div class=\"flex gap-4 container\"&gt;\r\n            &lt;div class=\"w-1/3 bg-white rounded-lg shadow-md p-4\" style=\"border: 1px solid #ccc;\"&gt;\r\n                &lt;div class=\"flex justify-between items-center mb-4\"&gt;\r\n                    &lt;h3 class=\"text-xl font-bold text-gray-800\"&gt;Kevin&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/Mask_group_2_.png}}\" alt=\"Bathroom\" class=\"w-full \" /&gt;\r\n                &lt;p class=\"mt-4 text-gray-600 received\"&gt;Just received my order from Banyo, and I\'m amazed by the quality and\r\n                    service! Highly recommended.&lt;/p&gt;\r\n                &lt;p class=\"mt-2 text-gray-500 happy-customer\"&gt;#HappyCustomer&lt;/p&gt;\r\n            &lt;/div&gt;\r\n            &lt;div class=\"w-1/3 bg-white rounded-lg shadow-md p-4\" style=\"border: 1px solid #ccc;\"&gt;\r\n                &lt;div class=\"flex justify-between items-center mb-4\"&gt;\r\n                    &lt;h3 class=\"text-xl font-bold text-gray-800\"&gt;Aleena&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/Mask_group_1_.png}}\" alt=\"Kitchen\" class=\"w-full \" /&gt;\r\n                &lt;p class=\"mt-4 text-gray-600 received\"&gt;Just received my order from Banyo, and I\'m amazed by the quality and\r\n                    service! Highly recommended.&lt;/p&gt;\r\n                &lt;p class=\"mt-2 text-gray-500 happy-customer\"&gt;#HappyCustomer&lt;/p&gt;\r\n            &lt;/div&gt;\r\n            &lt;div class=\"w-1/3 bg-white rounded-lg shadow-md p-4\" style=\"border: 1px solid #ccc;\"&gt;\r\n                &lt;div class=\"flex justify-between items-center mb-4\"&gt;\r\n                    &lt;h3 class=\"text-xl font-bold text-gray-800\"&gt;Nancy&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/Mask_group_3_.png}}\" alt=\"Bathroom\" class=\"w-full\" /&gt;\r\n                &lt;p class=\"mt-4 text-gray-600 received\"&gt;Just received my order from Banyo, and I\'m amazed by the quality and\r\n                    service! Highly recommended.&lt;/p&gt;\r\n                &lt;p class=\"mt-2 text-gray-500 happy-customer\"&gt;#HappyCustomer&lt;/p&gt;\r\n            &lt;/div&gt;\r\n\r\n        &lt;/div&gt;\r\n    &lt;/section&gt;\r\n\r\n    &lt;!-- fifth section structure --&gt;\r\n    &lt;section class=\"py-16 youtube-box bg-gray-100\"&gt;\r\n        &lt;div class=\"grid grid-cols-3 container\"&gt;\r\n            &lt;div class=\"bg-gray-100 rounded-lg shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;BetteLux Silhouette - Double Ended Bath&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;div class=\"bg-gray-100 rounded-lg shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;Hansgrohe Metropol bath mixer floor standing with\r\n                        lever handle&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;div class=\" shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;Hansgrohe Metropol bath mixer floor standing with\r\n                        lever handle&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;div class=\" shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;BetteLux Silhouette - Double Ended Bath&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;div class=\" shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;Hansgrohe Metropol bath mixer floor standing with\r\n                        lever handle&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;div class=\" shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;Hansgrohe Metropol bath mixer floor standing with\r\n                        lever handle&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/section&gt;\r\n\r\n&lt;/div&gt;</div>','2024-08-21 11:50:17','2024-08-23 05:58:21',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(12,'FAQ','1column','','','faq','Frequently Asked Questions','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"faq-tab\"&gt;\r\n{{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-tab\"}}\r\n&lt;/div&gt;</div>','2024-08-23 08:04:09','2024-08-23 08:46:25',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(13,'Finance','1column','','','finance','','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;!-- first section --&gt;\r\n&lt;div class=\"p-6 container\"&gt;\r\n    &lt;div class=\"main-financial-bx\"&gt;\r\n        &lt;!-- Left Section with Text --&gt;\r\n        &lt;div class=\"md:w-3/5 py-16 desktop\"&gt;\r\n            &lt;img src=\"{{media url=.renditions/wysiwyg/paypal.png}}\" alt=\"PayPal Credit Logo\" class=\"mb-4\" /&gt;\r\n        &lt;/div&gt;\r\n        &lt;div class=\"md:w-3/5 pt-0 pb-8 mobile\"&gt;\r\n            &lt;div class=\"pay-cre flex flex-wrap items-center justify-center\"&gt;\r\n                &lt;div class=\"img my-6\"&gt;\r\n                    &lt;img src=\"{{media url=.renditions/wysiwyg/apd-feb-finance-logo-paypal_1.png}}\" alt=\"\" /&gt;\r\n                &lt;/div&gt;\r\n                &lt;div class=\"text-img \"&gt;\r\n                    &lt;p class=\"text-blue-900 font-bold text-lg\"&gt;FLEXIBLE FINANCE FOR ANY BUDGET&lt;/p&gt;\r\n                    &lt;p class=\"text-xl text-dim font-bold\"&gt;Building Credit Without A Credit Card&lt;/p&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n        &lt;div class=\"info-box-finance flex justify-between items-center flex-wrap\r\n        \"&gt;\r\n            &lt;div class=\"no-effect-boxes-col\"&gt;\r\n                &lt;p class=\"text-white mb-4 font-medium text-2xl\"&gt;\r\n                    Spread the cost of the items you need with our range of flexible finance options&lt;br&gt; to suit any\r\n                    budget\r\n                    - from names you can trust.\r\n                &lt;/p&gt;\r\n                &lt;p class=\"text-white mb-4 font-medium text-2xl\"&gt;\r\n                    You have Two Flexible Finance Options To Choose From\r\n                &lt;/p&gt;\r\n                &lt;p class=\"text-white mb-4 font-medium text-2xl\"&gt;\r\n                    Our flexible repayment options allow for large investments to be much more &lt;br&gt;manageable.\r\n                    If you spend over £99, you can spread the cost over a period of up &lt;br&gt;to 4 months.\r\n                &lt;/p&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Right Section with Image --&gt;\r\n            &lt;div class=\"md:w-2/5 flex justify-center absolute right-0 bottom-0\"&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/girl-right.png}}\" alt=\"Woman using phone\"\r\n                    class=\"w-full h-auto max-w-sm\" /&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Bottom Section --&gt;\r\n    &lt;div class=\"mt-6 paypal-finance\"&gt;\r\n        &lt;h3 class=\"text-3xl font-bold text-blue-900 mb-4\"&gt;How PayPal 0% offer works.&lt;/h3&gt;\r\n        &lt;p class=\"text-gray-700 mb-4\"&gt;\r\n            0% interest offer you can use again and again.&lt;br&gt;\r\n            PayPal 0% interest offer is better than just an introductory offer. Simply spend over £99 and you get 0%\r\n            interest for 4 months on that purchase. The great thing is you’ll automatically get 0% for 4 months\r\n            every time you spend over £99.\r\n        &lt;/p&gt;\r\n        &lt;p class=\"text-gray-700\"&gt;\r\n            It’s quick and easy to apply for PayPal Credit – all you need to do is complete a short application form\r\n            and we’ll give you a decision instantly. If approved and you accept, you’ll have a credit limit attached\r\n            to your PayPal account to start using.\r\n        &lt;/p&gt;\r\n    &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n\r\n\r\n&lt;div class=\"pt-0 py-8 container its-easy\"&gt;\r\n    &lt;!-- Section 1: How It Works --&gt;\r\n    &lt;div class=\"text-center w-10/12 mx-auto\"&gt;\r\n        &lt;h2 class=\"text-3xl font-bold mb-16 text-blue-900 mt-0\"&gt;It\'s as easy as...&lt;/h2&gt;\r\n        &lt;div class=\"grid grid-cols-5 gap-8 items-center mt-7\"&gt;\r\n            &lt;!-- Step 1 --&gt;\r\n            &lt;div class=\"text-center\"&gt;\r\n                &lt;div class=\"mb-4\"&gt;\r\n                    &lt;img src=\"/media/wysiwyg/Basket.svg\" alt=\"\" class=\"mx-auto\" /&gt;\r\n                &lt;/div&gt;\r\n                &lt;p&gt;Add any product over £99 to your basket&lt;/p&gt;\r\n            &lt;/div&gt;\r\n            &lt;div class=\"text-center image\"&gt;\r\n                &lt;div class=\"mb-4\"&gt;\r\n                    &lt;!-- Replace with an icon --&gt;\r\n                    &lt;img src=\"/media/wysiwyg/Arrow.svg\" alt=\"\" class=\"mx-auto\" /&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Step 2 --&gt;\r\n            &lt;div class=\"text-center\"&gt;\r\n                &lt;div class=\"mb-4\"&gt;\r\n                    &lt;img src=\"{{media url=.renditions/wysiwyg/Group_27495.png}}\" alt=\"\" class=\"mx-auto\" /&gt;\r\n                &lt;/div&gt;\r\n                &lt;p&gt;Select the “PayPal Credit” button in the basket&lt;/p&gt;\r\n            &lt;/div&gt;\r\n            &lt;div class=\"text-center image\"&gt;\r\n                &lt;div class=\"mb-4\"&gt;\r\n                    &lt;img src=\"/media/wysiwyg/Arrow.svg\" alt=\"\" class=\"mx-auto\" /&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Step 3 --&gt;\r\n            &lt;div class=\"text-center\"&gt;\r\n                &lt;div class=\"mb-4\"&gt;\r\n                    &lt;!-- Replace with document icon --&gt;\r\n                    &lt;img src=\"{{media url=.renditions/wysiwyg/edit.png}}\" alt=\"\" class=\"mx-auto\" /&gt;\r\n                &lt;/div&gt;\r\n                &lt;p&gt;Get an Instant Decision&lt;/p&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Section 2: Representative Example --&gt;\r\n    &lt;div class=\"representative\"&gt;\r\n        &lt;div class=\"mt-12\"&gt;\r\n            &lt;h3 class=\"text-3xl font-bold mb-6 text-blue-900 text-center\"&gt;Representative Example&lt;/h3&gt;\r\n            &lt;div class=\"overflow-x-auto\"&gt;\r\n                &lt;p class=\"text-lg text-left\"&gt;Below is an example of a £500 purchase:&lt;/p&gt;\r\n                &lt;table class=\"min-w-full border-collapse border border-gray-300 mx-auto w-full\"&gt;\r\n                    &lt;thead&gt;\r\n                        &lt;tr class=\"bg-gray-100\"&gt;\r\n                            &lt;th class=\"px-4 py-2 text-left text-lg\"&gt;Term&lt;/th&gt;\r\n                            &lt;th class=\"px-4 py-2 text-left text-lg\"&gt;Provider&lt;/th&gt;\r\n                            &lt;th class=\"px-4 py-2 text-left text-lg\"&gt;Amount&lt;/th&gt;\r\n                            &lt;th class=\"px-4 py-2 text-left text-lg\"&gt;Minimum Spend&lt;/th&gt;\r\n                            &lt;th class=\"px-4 py-2 text-left text-lg\"&gt;Deposit&lt;/th&gt;\r\n                            &lt;th class=\"px-4 py-2 text-left text-lg\"&gt;Payments&lt;/th&gt;\r\n                            &lt;th class=\"px-4 py-2 text-left text-lg\"&gt;Total Payable&lt;/th&gt;\r\n                            &lt;th class=\"px-4 py-2 text-left text-lg\"&gt;Interest Charged&lt;/th&gt;\r\n                        &lt;/tr&gt;\r\n                    &lt;/thead&gt;\r\n                    &lt;tbody&gt;\r\n                        &lt;tr&gt;\r\n                            &lt;td class=\"px-4 py-2 text-lg\"&gt;4 Month&lt;/td&gt;\r\n                            &lt;td class=\"px-4 py-2 text-lg\"&gt;PayPal&lt;/td&gt;\r\n                            &lt;td class=\"px-4 py-2 text-lg\"&gt;£500&lt;/td&gt;\r\n                            &lt;td class=\"px-4 py-2 text-lg\"&gt;£99&lt;/td&gt;\r\n                            &lt;td class=\"px-4 py-2 text-lg\"&gt;£0&lt;/td&gt;\r\n                            &lt;td class=\"px-4 py-2 text-lg\"&gt;£125&lt;/td&gt;\r\n                            &lt;td class=\"px-4 py-2 bg-blue-500 text-white font-bold text-lg\"&gt;£500&lt;/td&gt;\r\n                            &lt;td class=\"px-4 py-2 text-lg\"&gt;£0&lt;/td&gt;\r\n                        &lt;/tr&gt;\r\n                    &lt;/tbody&gt;\r\n                &lt;/table&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;!-- Section 3: Terms and Conditions --&gt;\r\n    &lt;div class=\"paypal-finance\"&gt;\r\n        &lt;div class=\"mt-8\"&gt;\r\n            &lt;h4 class=\"text-3xl font-bold mb-6 text-blue-900\"&gt;PayPal - Finance Terms and Conditions&lt;/h4&gt;\r\n            &lt;p class=\"text-lg\"&gt;\r\n                In order to be eligible for finance, you must be 18 or older in regular employment, live with someone in\r\n                regular\r\n                employment or retired,\r\n                and have been a UK resident for more than 3 years. Other conditions may apply, and we cannot guarantee\r\n                any\r\n                successful applications.\r\n                If you cancel your credit agreement and have already received your products, you will be liable to pay\r\n                us for\r\n                the\r\n                product in full\r\n                (unless your cancellation rights apply).\r\n            &lt;/p&gt;\r\n            &lt;p class=\"text-lg mt-2\"&gt;\r\n                When applying for PayPal Credit, a small authorization charge (around 50p) may be taken against your\r\n                credit or\r\n                debit card to verify your identity.\r\n                Money will not be taken from your card unless a deposit for finance is required, in which case this may\r\n                be\r\n                reserved from your account.\r\n                If your application for finance has been declined, these funds will be unavailable for up to 5 working\r\n                days.\r\n            &lt;/p&gt;\r\n            &lt;p class=\"text-lg mt-2\"&gt;\r\n                Pay monthly finance is available for up to 4 months using PayPal Credit. If you have been deemed\r\n                eligible and\r\n                your\r\n                application is successful,\r\n                you will enter into a Credit Agreement with PayPal on up to 4 months finance.\r\n            &lt;/p&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n&lt;/div&gt;\r\n&lt;hr&gt;\r\n&lt;div class=\"option-2\"&gt;\r\n    &lt;h2 class=\"text-3xl font-bold mb-6 text-blue-900 text-center uppercase\"&gt;FINANCE OPTION 2&lt;/h3&gt;\r\n        &lt;div class=\"mt-12 mb-6 container\"&gt;\r\n            &lt;h3 class=\"text-3xl font-bold mb-6 text-blue-900\"&gt;How Omni Capital 0% offer works&lt;/h3&gt;\r\n            &lt;p class=\"text-lg\"&gt;\r\n                As an alternative finance option, Omni Capital offers 12 months finance interest free and has a quick\r\n                and easy\r\n                application process. The minimum required deposit is £300 or 30% whichever is greater and a minimum\r\n                spend of\r\n                £1,000\r\n            &lt;/p&gt;\r\n        &lt;/div&gt;\r\n        &lt;div class=\"bg-blue-900 text-white py-6 sect_60\"&gt;\r\n            &lt;div class=\"w-9/12 mx-auto px-4 flex flex-col md:flex-row items-center justify-between\"&gt;\r\n\r\n                &lt;!-- Left Side: Finance Offer --&gt;\r\n                &lt;div class=\"text-center md:text-left\"&gt;\r\n                    &lt;h2 class=\"text-4xl font-bold\"&gt;60% Finance&lt;/h2&gt;\r\n                    &lt;p class=\"text-3xl mt-1\"&gt;on orders over £500&lt;/p&gt;\r\n                &lt;/div&gt;\r\n\r\n                &lt;!-- Right Side: Features --&gt;\r\n                &lt;div class=\"flex justify-between three-col space-x-8 mt-4 md:mt-0\"&gt;\r\n                    &lt;!-- Feature 1 --&gt;\r\n                    &lt;div class=\"text-center\"&gt;\r\n\r\n                        &lt;img src=\"/media/wysiwyg/payment.svg\" alt=\"\" class=\"mx-auto\" /&gt;\r\n                        &lt;p class=\"text-lg\"&gt;Spread your Payment&lt;/p&gt;\r\n                    &lt;/div&gt;\r\n\r\n                    &lt;!-- Feature 2 --&gt;\r\n                    &lt;div class=\"text-center\"&gt;\r\n\r\n                        &lt;img src=\"/media/wysiwyg/online.svg\" alt=\"\" class=\"mx-auto\" /&gt;\r\n                        &lt;p class=\"text-lg\"&gt;Instant Online Decision&lt;/p&gt;\r\n                    &lt;/div&gt;\r\n\r\n                    &lt;!-- Feature 3 --&gt;\r\n                    &lt;div class=\"text-center\"&gt;\r\n                        &lt;img src=\"/media/wysiwyg/paperless.svg\" alt=\"\" class=\"mx-auto\" /&gt;\r\n                        &lt;p class=\"text-lg\"&gt;Paperless Application&lt;/p&gt;\r\n                    &lt;/div&gt;\r\n                &lt;/div&gt;\r\n\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n\r\n        &lt;div class=\"container option-text\"&gt;\r\n            &lt;p class=\"text-lg mt-6\"&gt;\r\n                0% APR terms are offered for 6, 9 &amp; 12 month Payment Plans. Credit is provided by an external finance\r\n                company –\r\n                Omni Retail Finance. Credit is granted subject to status and is a paperless online application\r\n            &lt;/p&gt;\r\n        &lt;/div&gt;\r\n\r\n&lt;/div&gt;\r\n&lt;div class=\"payment-options\"&gt;\r\n    &lt;div class=\"mb-6 container\"&gt;\r\n        &lt;h3 class=\"text-3xl font-bold mb-6 text-blue-900\"&gt;Payment&nbsp;Options&lt;/h3&gt;\r\n        &lt;p class=\"text-lg\"&gt;\r\n            On purchases over £1,000&nbsp;Banyo&nbsp;gives you the option of having a totally&nbsp;interest FREE&nbsp;6, 9 &amp; 12 month\r\n            payment\r\n            plan. All payment plans are subject to an initial 25% deposit or £250 whatever is greater.\r\n        &lt;/p&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- ***** --&gt;\r\n\r\n    &lt;div class=\"container mx-auto\"&gt;\r\n        &lt;div class=\"flex justify-between gap-8\"&gt;\r\n\r\n            &lt;!-- Left Column: Checkout Details --&gt;\r\n            &lt;div class=\"col-span-1 w-3/12\"&gt;\r\n                &lt;!-- Order Summary Box --&gt;\r\n                &lt;div class=\"flex flex-col\"&gt;\r\n                    &lt;img src=\"{{media url=.renditions/wysiwyg/image_251.png}}\" alt=\"\" /&gt;\r\n                    &lt;img src=\"{{media url=.renditions/wysiwyg/image_252.png}}\" alt=\"\" /&gt;\r\n                &lt;/div&gt;\r\n\r\n                &lt;!-- Payment Information --&gt;\r\n                &lt;div class=\"payment_info\"&gt;\r\n                    &lt;img src=\"{{media url=.renditions/wysiwyg/image_253.png}}\" alt=\"\" /&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;!-- Right Column: Content --&gt;\r\n            &lt;div class=\"col-span-1 md:col-span-2 w-9/12\"&gt;\r\n                &lt;!-- Instant Online Decision Section --&gt;\r\n                &lt;div class=\"mb-8\"&gt;\r\n                    &lt;h2 class=\"text-3xl font-bold mb-4 text-blue-900 mt-0\"&gt;Instant Online Decision&lt;/h2&gt;\r\n                    &lt;p class=\"mb-4 text-lg\"&gt;You can complete the whole process&nbsp;online, there is&nbsp;no paperwork&nbsp;or Physical\r\n                        signature\r\n                        required. A fully paperless process, a&nbsp;Quick &amp; easy&nbsp;online application with instant\r\n                        decision.&lt;br&gt;On&nbsp;acceptance&nbsp;the process is completed with&nbsp;eSignature&nbsp;, meaning no paperwork to\r\n                        fill in, post\r\n                        or\r\n                        scan.Nexus has always strived to help its customers by keeping a vast product range at prices as\r\n                        low as\r\n                        possible. Nexus is pleased to&nbsp;introduce a brand new range of credit facilities&nbsp;to increase the\r\n                        payment\r\n                        options to our customers.&lt;br&gt;\r\n                        Maybe you are renovating, moving home or your simply looking for something new. In\r\n                        today\'s financial climate not everyone will have the disposable income to make these purchases\r\n                        all in one\r\n                        go.&lt;br&gt;This is where our credit facilities can be a big help, we have a range of different\r\n                        options available\r\n                        for you to choose from. Our credit options allow you to choose from several variants to make\r\n                        sure you\r\n                        receive a package that is right for you.&lt;br&gt; If your application is approved you will be emailed\r\n                        notification.\r\n                        You would then need to call us to make the deposit payment, Once this has been taken your order\r\n                        will then be\r\n                        processed. We will then contact you once your goods are ready for dispatch and this is the time\r\n                        that your\r\n                        finance agreement starts.&lt;br&gt; You can settle your agreement early at any time during the period\r\n                        without\r\n                        penalty\r\n                        by contacting the finance company directly and asking for a settlement amount.&lt;/p&gt;\r\n\r\n                &lt;/div&gt;\r\n\r\n                &lt;!-- Criteria Section --&gt;\r\n                &lt;div class=\"mb-8\"&gt;\r\n                    &lt;h3 class=\"text-28 font-bold mb-4\"&gt;Criteria&lt;/h3&gt;\r\n                    &lt;p class=\"text-lg\"&gt;To apply for one of our credit options you must meet the following criteria:&lt;/p&gt;\r\n                    &lt;ul class=\"list-disc list-inside text-lg\"&gt;\r\n                        &lt;li&gt;You must be over 18 years of age.&lt;/li&gt;\r\n                        &lt;li&gt;You must be a UK resident with at least 3 years continual address history.&lt;/li&gt;\r\n                        &lt;li&gt;You must be in full-time employment unless retired or living with a spouse in full-time\r\n                            employment&lt;/li&gt;\r\n                        &lt;li&gt;You must have a UK bank account capable of accepting Direct Debits.&lt;/li&gt;\r\n                        &lt;li&gt;The goods must be delivered to your home address (submitted on your application).&lt;/li&gt;\r\n                    &lt;/ul&gt;\r\n                &lt;/div&gt;\r\n\r\n                &lt;!-- Why Use Credit Section --&gt;\r\n                &lt;div class=\"mb-8\"&gt;\r\n                    &lt;h3 class=\"text-28 font-bold mb-4\"&gt;Why Use Credit?&lt;/h3&gt;\r\n                    &lt;p class=\"text-lg\"&gt;Credit is available on all purchases where the overall order value is over £500\r\n                        Choose from\r\n                        6, 9 or 12 month repayment periods. Spread the cost to minimise your monthly payments. One-stop\r\n                        shopping- no\r\n                        need to go to a bank to secure funding. Keep cash for day to day expenses. Fixed repayments?\r\n                        Your payments\r\n                        are fixed for the duration of the agreement allowing you to budget more effectively.\r\n                    &lt;/p&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n\r\n        &lt;/div&gt;\r\n        &lt;div class=\"flex justify-between gap-8\"&gt;\r\n            &lt;!-- Example Finance Option Section --&gt;\r\n            &lt;div class=\"col-span-1 md:col-span-2 w-9/12\"&gt;\r\n                &lt;div class=\"mb-8\"&gt;\r\n                    &lt;h2 class=\"text-28 font-bold mb-4\"&gt;Monthly Repayments&lt;/h2&gt;\r\n                    &lt;p class=\"mb-4 text-lg\"&gt;All monthly payments are paid by direct debit from the applicant\'s bank\r\n                        account.\r\n                        Typically the\r\n                        1st payment will be due on or around one month after the date of the finance agreement being put\r\n                        in place\r\n                        and all subsequent monthly payments will be due every month for the length of your term on that\r\n                        same day\r\n                        every month. Please have sufficient funds in place for 7 days either side of your expected 1st\r\n                        payment. We\r\n                        cannot legislate for any changes due to weekends/bank holidays.&lt;/p&gt;\r\n                &lt;/div&gt;\r\n                &lt;div class=\"mb-8\"&gt;\r\n                    &lt;h2 class=\"text-28 font-bold mb-4\"&gt;Omni Capital - Finance Terms and Conditions&lt;/h2&gt;\r\n                    &lt;p class=\"mb-4 text-lg\"&gt;In order to be eligible for finance, you must be 18 or older, in regular\r\n                        employment,\r\n                        live with\r\n                        someone in regular employment, or retired, and have been a UK resident for more than 3 years.\r\n                        Other\r\n                        conditions may apply and we cannot guarantee any successful applications. If you cancel your\r\n                        credit\r\n                        agreement and have already received your products, you will be liable to pay us for the product\r\n                        in full\r\n                        (unless your cancellation rights apply). As an alternative finance option, Omni Capital offers\r\n                        12 months\r\n                        finance interest free and has a quick and easy application process. The minimum required deposit\r\n                        is £500.\r\n                    &lt;/p&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n            &lt;div class=\"col-span-1 w-3/12\"&gt;\r\n                &lt;div class=\"right-sec\"&gt;\r\n                    &lt;h3 class=\"text-28 font-bold mb-2\"&gt;Example Options&lt;/h3&gt;\r\n                    &lt;p class=\"text-lg font-medium\"&gt;Example Finance Option (Interest Free)&lt;/p&gt;\r\n                    &lt;!-- You can replace the following table with an actual table element --&gt;\r\n                    &lt;div class=\"overflow-auto\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/image_254.png}}\" alt=\"\" /&gt;\r\n                    &lt;/div&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n&lt;/div&gt;\r\n{{block class=\"Magento\\Framework\\View\\Element\\Template\"\r\ntemplate=\"UdeyTech_CategoryHelper::custom/top-rated-product.phtml\"}}\r\n&lt;!-- ***** --&gt;\r\n&lt;/div&gt;</div>','2024-09-03 05:27:05','2024-09-12 11:31:59',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(14,'support','1column','','','support','','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"container mx-auto p-6 support-main\"&gt;\r\n  &lt;h2 class=\"text-center text-xl font-bold mb-6 text-heading\"&gt;How can we help?&lt;/h2&gt;\r\n  &lt;div class=\"grid grid-cols-1 md:grid-cols-3 lg:grid-cols-3 gap-12\"&gt;\r\n    &lt;!-- General Info Card --&gt;\r\n    &lt;div class=\"border rounded-lg p-6 shadow-md box-info\"&gt;\r\n      &lt;h3 class=\"text-lg font-semibold mb-4 flex items-center\"&gt;\r\n        &lt;img src=\"/media/wysiwyg/info.svg\" alt=\"\" class=\"mr-3\"&gt; General Info&lt;/h3&gt;\r\n      &lt;ul class=\"space-y-2\"&gt;\r\n        &lt;li&gt;&lt;a href=\"/returns\"&gt;Returns Information&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"/14-day-money-back-guarantee\"&gt;Guarantee Information&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"/finance\"&gt;Finance Information&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Product Instructions&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Delivery Information&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Showroom Information&lt;/a&gt;&lt;/li&gt;\r\n      &lt;/ul&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Before You Order Card --&gt;\r\n    &lt;div class=\"border rounded-lg p-6 shadow-md box-info\"&gt;\r\n      &lt;h3 class=\"text-lg font-semibold mb-4 flex items-center\"&gt;\r\n        &lt;img src=\"/media/wysiwyg/before.svg\" alt=\"\" class=\"mr-3\"&gt;Before You Order&lt;/h3&gt;\r\n      &lt;ul class=\"space-y-2\"&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Buying Guides&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Ideas &amp; Inspiration&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;I Have A Question About A Product&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Product Price Enquiry&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Request a Catalogue&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;General Enquiry&lt;/a&gt;&lt;/li&gt;\r\n      &lt;/ul&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Before You Delivery Card --&gt;\r\n    &lt;div class=\"border rounded-lg p-6 shadow-md box-info\"&gt;\r\n      &lt;h3 class=\"text-lg font-semibold mb-4 flex items-center\"&gt;\r\n        &lt;img src=\"/media/wysiwyg/delivery-support.svg\" alt=\"\" class=\"mr-3\"&gt;\r\n         Before You Delivery&lt;/h3&gt;\r\n      &lt;ul class=\"space-y-2\"&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Track My Order&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Cancel My Order&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Amend My Order&lt;/a&gt;&lt;/li&gt;\r\n      &lt;/ul&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Product &amp; Stock Card --&gt;\r\n    &lt;div class=\"border rounded-lg p-6 shadow-md box-info\"&gt;\r\n      &lt;h3 class=\"text-lg font-semibold mb-4 flex items-center\"&gt;\r\n        &lt;img src=\"/media/wysiwyg/product-stock.svg\" alt=\"\" class=\"mr-3\"&gt;\r\n         Product &amp; Stock&lt;/h3&gt;\r\n      &lt;ul class=\"space-y-2\"&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Return Order/Item&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Report Damaged&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Faulty Items&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Returned&lt;/a&gt;&lt;/li&gt;\r\n      &lt;/ul&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Company Info Card --&gt;\r\n    &lt;div class=\"border rounded-lg p-6 shadow-md box-info\"&gt;\r\n      &lt;h3 class=\"text-lg font-semibold mb-4 flex items-center\"&gt;\r\n        &lt;img src=\"/media/wysiwyg/cm-info.svg\" alt=\"\" class=\"mr-3\"&gt;\r\n        Company Info&lt;/h3&gt;\r\n      &lt;ul class=\"space-y-2\"&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;About Us&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Terms &amp; Conditions&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Privacy &amp; Cookies&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Customer Privacy Policy&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Careers&lt;/a&gt;&lt;/li&gt;\r\n      &lt;/ul&gt;\r\n    &lt;/div&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;div class=\"container mx-auto p-6 support-main most-popular\"&gt;\r\n  &lt;h2 class=\"text-center text-xl font-bold mb-6 text-heading\"&gt;Popular Questions&lt;/h2&gt;\r\n{{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"support-popular-question\"}}\r\n&lt;div class=\"view-btn mt-6 block text-center\"&gt;\r\n  &lt;a href=\"/faq\" class=\"text-red-500 font-semibold\"&gt;View All FAQ’s&lt;/a&gt;\r\n&lt;/div&gt;\r\n&lt;/div&gt;\r\n</div>','2024-09-14 07:27:53','2024-10-30 10:30:03',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(15,'Cart More Info','cms-full-width','','','cart-more-info','Cart More Info','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">Cart More Info</div>','2024-12-23 12:52:13','2025-01-27 09:05:51',1,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,''),(19,'Nexus Home','1column','','','home/nexus','Home Page','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\"></div>','2025-01-27 08:47:02','2025-01-27 10:23:14',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(20,'Premier Home ','1column','','','premier/home','Premier Home','','2025-01-27 08:49:00','2025-01-27 09:06:14',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(21,'Nexus About ','1column','','','about-us-nexus','About Us ','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"main-about-wrap\"&gt;\r\n    &lt;!-- First Section with Background Image and Text Overlay --&gt;\r\n    &lt;section class=\"exceptional-about\"&gt;\r\n        &lt;div class=\"relative w-full h-[300px] md:h-[400px]\"&gt;\r\n            &lt;img src=\"{{media url=.renditions/wysiwyg/luxurious-modern-living-room-with-sleek-minimalist-design-elegant-fireplace_1.png}}\"\r\n                alt=\"Living Room\" class=\"object-cover w-full h-full\" /&gt;\r\n            &lt;div class=\"absolute inset-0 bg-black bg-opacity-50 flex items-center justify-center\"&gt;\r\n                &lt;h1 class=\"text-white text-center text-2xl md:text-4xl font-bold px-4\"&gt;\r\n                    Committed to Providing Exceptional &lt;br&gt;Service and Premium Products for Two Decades.\r\n                &lt;/h1&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/section&gt;\r\n\r\n    &lt;!-- Second Section with Images and Text --&gt;\r\n    &lt;section class=\"py-16 our-sucess-lead container\"&gt;\r\n        &lt;div class=\"lead-col\"&gt;\r\n            &lt;div class=\"grid grid-cols-1 md:grid-cols-2 lg:grid-cols-3\"&gt;\r\n                &lt;div class=\"lg:col-span-1 flex items-center\"&gt;\r\n                    &lt;!-- First Image --&gt;\r\n                    &lt;div class=\"lg:col-span-1 flex mr-3\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/view-small-bathroom-with-modern-style-decor-furniture_1.png}}\"\r\n                            alt=\"Bathroom 1\" class=\"object-cover\" /&gt;\r\n                    &lt;/div&gt;\r\n\r\n                    &lt;!-- Second Image --&gt;\r\n\r\n                    &lt;div class=\"lg:col-span-1\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/Mask_group.png}}\" alt=\"Bathroom 2\"\r\n                            class=\"object-cover \" /&gt;\r\n                    &lt;/div&gt;\r\n                &lt;/div&gt;\r\n                &lt;!-- Text Content --&gt;\r\n                &lt;div class=\"lg:col-span-1 flex flex-col\"&gt;\r\n                    &lt;h2 class=\"text-2xl font-normal mb-4 font-semibold\"&gt;\r\n                        Our &lt;br&gt; &lt;br&gt; Journey to &lt;span class=\"text-blue-900 underline\"&gt;Success&lt;/span&gt;\r\n                    &lt;/h2&gt;\r\n                    &lt;p class=\"text-gray-700 mb-4 pt-4 .2xl:text-lg leading-5\"&gt;\r\n                        For the past two decades, Banyo has remained committed to providing exceptional service and\r\n                        continuing to amaze our loyal clients. As a family-run company based in the East Midlands and\r\n                        beyond, we are known for our ability to transform homes and businesses with our magic touch. Our\r\n                        two\r\n                        Leicester locations are home to a team of wise and knowledgeable experts who provide exceptional\r\n                        pre- and post-sale support.\r\n                    &lt;/p&gt;\r\n                    &lt;p class=\"text-gray-700 mb-4 .2xl:text-lg leading-5\"&gt;\r\n                        At Banyo, we have established ourselves as the premier choice for those looking to purchase\r\n                        high-quality kitchen appliances, designer fireplaces, and luxurious bathrooms. Our enthralling\r\n                        work\r\n                        has graced countless notable commercial and residential properties. However, our superlative\r\n                        E-Commerce division is the real secret to our success. Our team works tirelessly to provide a\r\n                        seamless online experience, backed by the magic of our two reputable showrooms.\r\n                    &lt;/p&gt;\r\n                    &lt;p class=\"text-gray-700 .2xl:text-lg leading-5\"&gt;\r\n                        With a wealth of experience, we take great pride in delivering an exceptional online experience\r\n                        for\r\n                        our customers. We invite you to join us on our fantastical journey and let us surprise you with\r\n                        our\r\n                        exceptional service and quality products.\r\n                    &lt;/p&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/section&gt;\r\n\r\n    &lt;!-- third section structure --&gt;\r\n    &lt;section class=\"bg-gray-100 py-16 choose-box\"&gt;\r\n        &lt;div class=\"max-w-6xl mx-auto text-center container\"&gt;\r\n            &lt;h2 class=\"text-3xl font-semibold text-gray-800\"&gt;Why Choose Us&lt;/h2&gt;\r\n            &lt;p class=\"text-gray-600 max-w-[870px] mx-auto mb-9\"&gt;\r\n                At Banyo, we understand that discerning consumers recognize the difference between good, better, and\r\n                best. That\'s why we consistently offer products that embody a perfect blend of innovation, quality, and\r\n                flawless features. Our commitment to excellence sets us apart, and here\'s why you should choose us:\r\n            &lt;/p&gt;\r\n            &lt;div class=\"grid grid-cols-1 md:grid-cols-3 lg:grid-cols-3 gap-8\"&gt;\r\n                &lt;!-- Card 1 --&gt;\r\n                &lt;div class=\"shadow-md text-center\"&gt;\r\n                    &lt;div class=\"mb-4\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/Group_27144.png}}\" alt=\"Unmatched Quality\"\r\n                            class=\"mx-auto\" /&gt;\r\n                    &lt;/div&gt;\r\n                    &lt;h3 class=\"text-xl font-semibold text-blue-900  mb-2\"&gt;Unmatched Quality&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-600\"&gt;We provide high-quality products&lt;br&gt; that elevate every room in your&lt;br&gt;\r\n                        home.&lt;/p&gt;\r\n                &lt;/div&gt;\r\n                &lt;!-- Card 2 --&gt;\r\n                &lt;div class=\"shadow-md text-center\"&gt;\r\n                    &lt;div class=\"mb-4\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/Group.png}}\" alt=\"Delivery Across the UK\"\r\n                            class=\"mx-auto\" /&gt;\r\n                    &lt;/div&gt;\r\n                    &lt;h3 class=\"text-xl font-semibold text-blue-900  mb-2\"&gt;Delivery Across the UK&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-600\"&gt;Only the finest, eco-conscious &lt;br&gt;materials make it into our&lt;br&gt; product\r\n                        lineup.\r\n                    &lt;/p&gt;\r\n                &lt;/div&gt;\r\n                &lt;!-- Card 3 --&gt;\r\n                &lt;div class=\" shadow-md text-center\"&gt;\r\n                    &lt;div class=\"mb-4\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/Group_27164.png}}\" alt=\"Innovative Designs\"\r\n                            class=\"mx-auto\" /&gt;\r\n\r\n                    &lt;/div&gt;\r\n                    &lt;h3 class=\"text-xl font-semibold text-blue-900  mb-2\"&gt;Innovative Designs&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-600\"&gt;Our products combine innovation&lt;br&gt; with flawless features for the&lt;br&gt; best\r\n                        solutions.&lt;/p&gt;\r\n                &lt;/div&gt;\r\n                &lt;!-- Card 4 --&gt;\r\n                &lt;div class=\" shadow-md text-center\"&gt;\r\n                    &lt;div class=\"mb-4\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/Group_27167.png}}\" alt=\"Trusted Relationships\"\r\n                            class=\"mx-auto\" /&gt;\r\n                    &lt;/div&gt;\r\n                    &lt;h3 class=\"text-xl font-semibold text-blue-900  mb-2 \"&gt;Trusted Relationships&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-600\"&gt;We maintain strong ties with top &lt;br&gt;brands to ensure the best for our&lt;br&gt;\r\n                        customers.&lt;/p&gt;\r\n                &lt;/div&gt;\r\n                &lt;!-- Card 5 --&gt;\r\n                &lt;div class=\"shadow-md text-center\"&gt;\r\n                    &lt;div class=\"mb-4\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/Group_27298.png}}\" alt=\"Great Value Pricing\"\r\n                            class=\"mx-auto\" /&gt;\r\n                    &lt;/div&gt;\r\n                    &lt;h3 class=\"text-xl font-semibold text-blue-900  mb-2 \"&gt;Great Value Pricing&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-600\"&gt;Only the finest, eco-conscious &lt;br&gt;materials make it into our&lt;br&gt; product\r\n                        lineup.\r\n                    &lt;/p&gt;\r\n                &lt;/div&gt;\r\n                &lt;!-- Card 6 --&gt;\r\n                &lt;div class=\" shadow-md text-center\"&gt;\r\n                    &lt;div class=\"mb-4\"&gt;\r\n                        &lt;img src=\"{{media url=.renditions/wysiwyg/Group_27299.png}}\" alt=\"UK-Based Customer Support\"\r\n                            class=\"mx-auto\" /&gt;\r\n                    &lt;/div&gt;\r\n                    &lt;h3 class=\"text-xl font-semibold text-blue-900 mb-2 \"&gt;UK-Based Customer Support&lt;/h3&gt;\r\n                    &lt;p class=\"text-gray-600\"&gt;Our products combine innovation &lt;br&gt;with flawless features for the&lt;br&gt; best\r\n                        solutions.&lt;/p&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/section&gt;\r\n    &lt;!-- fourth section structure --&gt;\r\n    &lt;section class=\"our-journey-box\"&gt;\r\n        &lt;div class=\"px-12 py-10 text-center\"&gt;\r\n            &lt;h2 class=\"text-3xl font-bold text-gray-800\"&gt;Join our Journey&lt;/h2&gt;\r\n            &lt;p class=\"text-gray-600\"&gt;Experience Exceptional Service and Quality Products&lt;/p&gt;\r\n        &lt;/div&gt;\r\n        &lt;div class=\"flex gap-4 container\"&gt;\r\n            &lt;div class=\"w-1/3 bg-white rounded-lg shadow-md p-4\" style=\"border: 1px solid #ccc;\"&gt;\r\n                &lt;div class=\"flex justify-between items-center mb-4\"&gt;\r\n                    &lt;h3 class=\"text-xl font-bold text-gray-800\"&gt;Kevin&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/Mask_group_2_.png}}\" alt=\"Bathroom\" class=\"w-full \" /&gt;\r\n                &lt;p class=\"mt-4 text-gray-600 received\"&gt;Just received my order from Banyo, and I\'m amazed by the quality and\r\n                    service! Highly recommended.&lt;/p&gt;\r\n                &lt;p class=\"mt-2 text-gray-500 happy-customer\"&gt;#HappyCustomer&lt;/p&gt;\r\n            &lt;/div&gt;\r\n            &lt;div class=\"w-1/3 bg-white rounded-lg shadow-md p-4\" style=\"border: 1px solid #ccc;\"&gt;\r\n                &lt;div class=\"flex justify-between items-center mb-4\"&gt;\r\n                    &lt;h3 class=\"text-xl font-bold text-gray-800\"&gt;Aleena&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/Mask_group_1_.png}}\" alt=\"Kitchen\" class=\"w-full \" /&gt;\r\n                &lt;p class=\"mt-4 text-gray-600 received\"&gt;Just received my order from Banyo, and I\'m amazed by the quality and\r\n                    service! Highly recommended.&lt;/p&gt;\r\n                &lt;p class=\"mt-2 text-gray-500 happy-customer\"&gt;#HappyCustomer&lt;/p&gt;\r\n            &lt;/div&gt;\r\n            &lt;div class=\"w-1/3 bg-white rounded-lg shadow-md p-4\" style=\"border: 1px solid #ccc;\"&gt;\r\n                &lt;div class=\"flex justify-between items-center mb-4\"&gt;\r\n                    &lt;h3 class=\"text-xl font-bold text-gray-800\"&gt;Nancy&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n                &lt;img src=\"{{media url=.renditions/wysiwyg/Mask_group_3_.png}}\" alt=\"Bathroom\" class=\"w-full\" /&gt;\r\n                &lt;p class=\"mt-4 text-gray-600 received\"&gt;Just received my order from Banyo, and I\'m amazed by the quality and\r\n                    service! Highly recommended.&lt;/p&gt;\r\n                &lt;p class=\"mt-2 text-gray-500 happy-customer\"&gt;#HappyCustomer&lt;/p&gt;\r\n            &lt;/div&gt;\r\n\r\n        &lt;/div&gt;\r\n    &lt;/section&gt;\r\n\r\n    &lt;!-- fifth section structure --&gt;\r\n    &lt;section class=\"py-16 youtube-box bg-gray-100\"&gt;\r\n        &lt;div class=\"grid grid-cols-3 container\"&gt;\r\n            &lt;div class=\"bg-gray-100 rounded-lg shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;BetteLux Silhouette - Double Ended Bath&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;div class=\"bg-gray-100 rounded-lg shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;Hansgrohe Metropol bath mixer floor standing with\r\n                        lever handle&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;div class=\" shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;Hansgrohe Metropol bath mixer floor standing with\r\n                        lever handle&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;div class=\" shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;BetteLux Silhouette - Double Ended Bath&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;div class=\" shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;Hansgrohe Metropol bath mixer floor standing with\r\n                        lever handle&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n\r\n            &lt;div class=\" shadow-md p-4\"&gt;\r\n                &lt;div class=\"flex flex-col items-center\"&gt;\r\n                    &lt;iframe width=\"100%\" height=\"315\"\r\n                        src=\"https://www.youtube.com/embed/o5UZbRS2nGY?si=cVQpymc37f9QCRvk\" title=\"YouTube video player\"\r\n                        frameborder=\"0\"\r\n                        allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\"\r\n                        referrerpolicy=\"strict-origin-when-cross-origin\" allowfullscreen&gt;&lt;/iframe&gt;\r\n                    &lt;h3 class=\"mt-4 text-lg font-semibold text-center\"&gt;Hansgrohe Metropol bath mixer floor standing with\r\n                        lever handle&lt;/h3&gt;\r\n                &lt;/div&gt;\r\n            &lt;/div&gt;\r\n        &lt;/div&gt;\r\n    &lt;/section&gt;\r\n\r\n&lt;/div&gt;</div>','2025-01-27 10:35:32','2025-01-27 10:50:26',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(22,'support','1column','','','support-nexus','Support ','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"container mx-auto p-6 support-main\"&gt;\r\n  &lt;h2 class=\"text-center text-xl font-bold mb-6 text-heading\"&gt;How can we help?&lt;/h2&gt;\r\n  &lt;div class=\"grid grid-cols-1 md:grid-cols-3 lg:grid-cols-3 gap-12\"&gt;\r\n    &lt;!-- General Info Card --&gt;\r\n    &lt;div class=\"border rounded-lg p-6 shadow-md box-info\"&gt;\r\n      &lt;h3 class=\"text-lg font-semibold mb-4 flex items-center\"&gt;\r\n        &lt;img src=\"/media/wysiwyg/info.svg\" alt=\"\" class=\"mr-3\"&gt; General Info&lt;/h3&gt;\r\n      &lt;ul class=\"space-y-2\"&gt;\r\n        &lt;li&gt;&lt;a href=\"/returns\"&gt;Returns Information&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"/14-day-money-back-guarantee\"&gt;Guarantee Information&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"/finance\"&gt;Finance Information&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Product Instructions&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Delivery Information&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Showroom Information&lt;/a&gt;&lt;/li&gt;\r\n      &lt;/ul&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Before You Order Card --&gt;\r\n    &lt;div class=\"border rounded-lg p-6 shadow-md box-info\"&gt;\r\n      &lt;h3 class=\"text-lg font-semibold mb-4 flex items-center\"&gt;\r\n        &lt;img src=\"/media/wysiwyg/before.svg\" alt=\"\" class=\"mr-3\"&gt;Before You Order&lt;/h3&gt;\r\n      &lt;ul class=\"space-y-2\"&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Buying Guides&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Ideas &amp; Inspiration&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;I Have A Question About A Product&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Product Price Enquiry&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Request a Catalogue&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;General Enquiry&lt;/a&gt;&lt;/li&gt;\r\n      &lt;/ul&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Before You Delivery Card --&gt;\r\n    &lt;div class=\"border rounded-lg p-6 shadow-md box-info\"&gt;\r\n      &lt;h3 class=\"text-lg font-semibold mb-4 flex items-center\"&gt;\r\n        &lt;img src=\"/media/wysiwyg/delivery-support.svg\" alt=\"\" class=\"mr-3\"&gt;\r\n         Before You Delivery&lt;/h3&gt;\r\n      &lt;ul class=\"space-y-2\"&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Track My Order&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Cancel My Order&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Amend My Order&lt;/a&gt;&lt;/li&gt;\r\n      &lt;/ul&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Product &amp; Stock Card --&gt;\r\n    &lt;div class=\"border rounded-lg p-6 shadow-md box-info\"&gt;\r\n      &lt;h3 class=\"text-lg font-semibold mb-4 flex items-center\"&gt;\r\n        &lt;img src=\"/media/wysiwyg/product-stock.svg\" alt=\"\" class=\"mr-3\"&gt;\r\n         Product &amp; Stock&lt;/h3&gt;\r\n      &lt;ul class=\"space-y-2\"&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Return Order/Item&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Report Damaged&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Faulty Items&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Returned&lt;/a&gt;&lt;/li&gt;\r\n      &lt;/ul&gt;\r\n    &lt;/div&gt;\r\n\r\n    &lt;!-- Company Info Card --&gt;\r\n    &lt;div class=\"border rounded-lg p-6 shadow-md box-info\"&gt;\r\n      &lt;h3 class=\"text-lg font-semibold mb-4 flex items-center\"&gt;\r\n        &lt;img src=\"/media/wysiwyg/cm-info.svg\" alt=\"\" class=\"mr-3\"&gt;\r\n        Company Info&lt;/h3&gt;\r\n      &lt;ul class=\"space-y-2\"&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;About Us&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Terms &amp; Conditions&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Privacy &amp; Cookies&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Customer Privacy Policy&lt;/a&gt;&lt;/li&gt;\r\n        &lt;li&gt;&lt;a href=\"#\"&gt;Careers&lt;/a&gt;&lt;/li&gt;\r\n      &lt;/ul&gt;\r\n    &lt;/div&gt;\r\n  &lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n&lt;div class=\"container mx-auto p-6 support-main most-popular\"&gt;\r\n  &lt;h2 class=\"text-center text-xl font-bold mb-6 text-heading\"&gt;Popular Questions&lt;/h2&gt;\r\n{{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"support-popular-question\"}}\r\n&lt;div class=\"view-btn mt-6 block text-center\"&gt;\r\n  &lt;a href=\"/faq\" class=\"text-red-500 font-semibold\"&gt;View All FAQ’s&lt;/a&gt;\r\n&lt;/div&gt;\r\n&lt;/div&gt;\r\n</div>','2025-01-27 10:40:33','2025-01-27 10:50:46',1,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,''),(23,'Nexus Cookies ','1column','','','nexus-cookies','Cookies ','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"bg-white px-6 text-gray-800\"&gt;\r\n\r\n        &lt;h1 class=\"text-3xl font-bold mb-4 text-blue-900\"&gt;Banyo Policy&lt;/h1&gt;\r\n        &lt;p class=\"mb-4 text-lg\"&gt;\r\n            This privacy policy sets out how Banyo.co.uk uses and protects any information that you give Banyo.co.uk\r\n            while using the website. Banyo.co.uk is committed to ensuring that your privacy is protected as we aim\r\n            to take an honest and secure approach to your data. Should we ask you to provide certain information by\r\n            which you can be identified when using Banyo.co.uk, then you can be assured that it will only be used in\r\n            accordance with this privacy statement. Banyo.co.uk may change this policy from time to time by updating\r\n            this page. You should check this page to ensure that you are happy with any changes. This policy,\r\n            alongside our Terms &amp; Conditions is designed to give you a clear, transparent view on why Banyo.co.uk\r\n            collect and process your personal details and what rights you have in relation to how Banyo.co.uk\r\n            interact with your data.&lt;/p&gt;\r\n\r\n        &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;What we collect&lt;/h2&gt;\r\n        &lt;p class=\"text-base\"&gt;\r\n            When you enter information into various forms on the Banyo.co.uk site, and 3rd party partners described\r\n            below, we store it within our secure systems to fulfil the request you have made. This data may include, but\r\n            is not limited to:\r\n        &lt;/p&gt;\r\n        &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n            &lt;li&gt;name&lt;/li&gt;\r\n            &lt;li&gt;contact information including email address&lt;/li&gt;\r\n            &lt;li&gt;demographic information such as postcode, preferences and interests&lt;/li&gt;\r\n            &lt;li&gt;other information relevant to customer surveys and/or offers&lt;/li&gt;\r\n        &lt;/ul&gt;\r\n        &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;What we do with the information we gather&lt;/h2&gt;\r\n\r\n        &lt;p class=\"text-base\"&gt;We require this information to understand your needs and provide you with a better\r\n            service, and in particular for the following reasons:&lt;/p&gt;\r\n        &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n            &lt;li&gt;Internal record keeping.&lt;/li&gt;\r\n            &lt;li&gt;We may use the information to improve our products and services.&lt;/li&gt;\r\n            &lt;li&gt;We may periodically send promotional emails about new products, special offers or other information\r\n                which we think you may find interesting using the email address which you have provided.&lt;/li&gt;\r\n            &lt;li&gt;From time to time, we may also use your information to contact you for market research purposes. We may\r\n                contact you by email, phone, fax or mail. We may use the information to customise the website according\r\n                to your interests.&lt;/li&gt;\r\n        &lt;/ul&gt;\r\n        &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Security&lt;/h2&gt;\r\n\r\n        &lt;p class=\"mb-4 text-base\"&gt;Information stored and processed by Banyo.co.uk is secure to the latest industry\r\n            standard, for example: When you input your information into our website, we transfer your information to our\r\n            secure servers via Secure Standard Layer software, known as SSL. We store your personal details on secure\r\n            servers which utilise high level security protocols.&lt;/p&gt;\r\n\r\n        &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;How we use cookies&lt;/h2&gt;\r\n        &lt;p class=\"mb-4 text-base\"&gt;A cookie is a small file which asks permission to be placed on your computer\'s hard\r\n            drive. Once you agree, the file is added and the cookie helps analyse web traffic or lets you know when you\r\n            visit a particular site. Cookies allow web applications to respond to you as an individual. The web\r\n            application can tailor its operations to your needs, likes and dislikes by gathering and remembering\r\n            information about your preferences.&lt;/p&gt;\r\n        &lt;p class=\"mb-4 text-base\"&gt;\r\n            We use traffic log cookies to identify which pages are being used. This helps us analyse data about web page\r\n            traffic and improve our website in order to tailor it to customer needs. We only use this information for\r\n            statistical analysis purposes and then the data is removed from the system.\r\n        &lt;/p&gt;\r\n        &lt;p class=\"mb-4 text-base\"&gt;\r\n            Overall, cookies help us provide you with a better website, by enabling us to monitor which pages you find\r\n            useful and which you do not. A cookie in no way gives us access to your computer or any information about\r\n            you, other than the data you choose to share with us. You can choose to accept or decline cookies. Most web\r\n            browsers automatically accept cookies, but you can usually modify your browser setting to decline cookies if\r\n            you prefer. This may prevent you from taking full advantage of the website.\r\n        &lt;/p&gt;\r\n        &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Controlling your personal information&lt;/h2&gt;\r\n\r\n        &lt;p class=\"text-base\"&gt;You may choose to restrict the collection or use of your personal information in the\r\n            following ways:&lt;/p&gt;\r\n        &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n            &lt;li&gt;whenever you are asked to fill in a form on the website, look for the box that you can click to indicate\r\n                that you do not want the information to be used by anybody for direct marketing purposes.&lt;/li&gt;\r\n            &lt;li&gt;if you have previously agreed to us using your personal information for direct marketing purposes, you\r\n                may change your mind at any time by letting us know using our Contact Us information&lt;/li&gt;\r\n        &lt;/ul&gt;\r\n        &lt;p class=\"mb-4 text-base\"&gt;We will not sell, distribute or lease your personal information to third parties\r\n            unless we have your permission or are required by law to do so. We may use your personal information to send\r\n            you promotional information about third parties which we think you may find interesting if you tell us that\r\n            you wish this to happen.\r\n            You may request details of personal information which we hold about you under the Data Protection Act 1998.\r\n            A small fee will be payable. If you would like a copy of the information held on you please email us this\r\n            request using our Contact Us information.\r\n            If you believe that any information we are holding on you is incorrect or incomplete, please write to or\r\n            email us as soon as possible, at the above address. We will promptly correct any information found to be\r\n            incorrect.&lt;/p&gt;\r\n            &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Can I opt out of \'Cookies\'?&lt;/h2&gt;\r\n            &lt;p class=\"mb-4 text-base\"&gt;You can choose a range of cookie settings in your browser. For more information on this, please visit the page below that relates to your specific browser.&lt;/p&gt;\r\n            &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n                &lt;li&gt;Google Chrome.&lt;/li&gt;\r\n                &lt;li&gt;Safari&lt;/li&gt;\r\n                &lt;li&gt;Firefox&lt;/li&gt;\r\n            &lt;/ul&gt;\r\n        &lt;/div&gt;</div>','2025-01-27 10:43:14','2025-01-27 10:50:46',1,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,''),(24,'Returns','1column','','','returns-nexus','Returns','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"bg-white px-6 text-gray-800\"&gt;\r\n    &lt;h1 class=\"text-3xl font-bold mb-4 text-blue-900\"&gt;Returns Information&lt;/h1&gt;\r\n    &lt;p class=\"mb-4 text-lg\"&gt;\r\n        We hope that your purchase is exactly what you expected, however we understand that occasionally an issue may\r\n        occur with your chosen item(s). If you &lt;br&gt;change your mind for whatever reason and simply do not want any of\r\n        the\r\n        products purchased, as long as it is within 14 days of receipt of goods you may &lt;br&gt;return the goods to us as we\r\n        offer a hassle-free 14 day returns policy:&lt;br&gt; &lt;br&gt;&lt;/p&gt;\r\n        \r\n    &lt;ul class=\"list-none list-inside space-y-2 mb-4 p-8 py-0 text-lg\"&gt;\r\n        &lt;li&gt; 1. You can return your item if it is unsuitable, provided it’s unopened and in its original packaging.&lt;/li&gt;\r\n        &lt;li&gt; 2. However you (the customer) shall be responsible for the return of the product and all cost associated\r\n            with this.&lt;/li&gt;\r\n        &lt;li&gt; 3. You the customer will be responsible for our postage costs to you which will be deducted from the amount\r\n            we refund to you.&lt;/li&gt;\r\n    &lt;/ul&gt;\r\n    \r\n    &lt;p class=\"mb-4 text-lg\"&gt;&lt;br&gt;Contact our Customer Care Team by Email &lt;a href=\"mailto:returns@banyo.co.uk\"&gt;returns@banyo.co.uk&lt;/a&gt; detailing the damage with\r\n        images if appropriate to arrange a collection and a credit or &lt;br&gt;refund for the product will be issued within\r\n        14 days of receipt by us of the product.&lt;/p&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5 we-founded\"&gt;Products we are unable to cancel, refund or exchange&lt;/h2&gt;\r\n\r\n    &lt;p class=\" text-base\"&gt;We cannot offer refunds or exchanges, unless faulty or not as described, on the following\r\n        items:&lt;/p&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base personlaized\"&gt;\r\n        &lt;li&gt;Products which have been personalised for you.&lt;/li&gt;\r\n        &lt;li&gt;Where a product has been specially ordered for you, unless faulty, we are unable to refund or offer an\r\n            exchange. In exceptional circumstances we may be able to accept&lt;br&gt;\r\n            return of these items with refund less deduction for restocking of 35% plus carriage to the distributor or\r\n            manufacturer.&lt;/li&gt;\r\n    &lt;/ul&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5 received-box\"&gt;Return of Incorrect, Faulty or Damaged Goods Received&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;We ask that customers make a full inspection of all products received on the day of\r\n        delivery. We must be notified of any items that arrive faulty or damaged within 48hrs of&lt;br&gt; receipt. For this\r\n        we advise that you send an email to &lt;a href=\"mailto:returns@banyo.co.uk\"&gt;returns@banyo.co.uk&lt;/a&gt; detailing the damage with images if appropriate. This\r\n        email will be acknowledged by us and we&lt;br&gt; will advise the next steps, and contact you and either arrange\r\n        collection, ask for goods to be returned back to us or ask you to dispose of the goods. Please note, never &lt;br&gt;\r\n        dispose of goods without our notification. Should we request that you send the goods back to us, we ask that you\r\n        include a receipt for any postage costs that you may incur&lt;br&gt; so that we may refund the full cost of\r\n        postage.&lt;br&gt;Please note: All goods reported as faulty will be tested by manufacturers, if it is determined the\r\n        goods are not faulty or if the faults are deemed to be caused by damage or&lt;br&gt; abuse this will void any\r\n        warranty, goods will be returned to you and no refund or replacement issued.&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;For answers to some of the more frequently asked questions about Returns\r\n    &lt;/h2&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base font-semibold\"&gt;I would like to return an item, what do I need to do?&lt;/p&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;If you would like to return an item to us you will need to firstly email us\r\n        on &lt;a href=\"mailto:returns@banyo.co.uk\"&gt;returns@banyo.co.uk&lt;/a&gt; with your invoice number and details of the reason for return. We will then&lt;br&gt; give you\r\n        instructions of the procedure to follow. Please make sure that the purchased goods are returned to us in a as\r\n        new condition. We will require all the original boxes &lt;br&gt;and packing (including all packaging) and the goods\r\n        must\r\n        be taken care of whilst in your possession. We do ask that any goods that are in a sealed packaging and are&lt;br&gt;\r\n        clearly visible without the need to open the packaging remain unopened. No returns will be accepted if the item\r\n        is damaged or marked. We recommend using a recorded &lt;br&gt;mail service for sending any parcels. When returning\r\n        your\r\n        item please make sure to include your order number and also the reason for the return. If you would like to\r\n        return &lt;br&gt;the item to us we will arrange for your credit card / paypal account to be credited.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"text-base font-semibold\"&gt;What is your returns address?&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;Our returns address is as follows:&lt;br&gt;\r\n        Returns Department&lt;br&gt;\r\n        Banyo Ltd t/a Nexus&lt;br&gt;\r\n        International House&lt;br&gt;\r\n        64 St. Barnabas Road&lt;br&gt;\r\n        Leicester&lt;br&gt;\r\n        LE5 4BD&lt;/p&gt;\r\n    &lt;p class=\"text-base font-semibold\"&gt;Do you offer a collection service?&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;We offer a limited collection service for return of incorrect, faulty or damaged goods\r\n        only,\r\n        please contact us to confirm in each case&lt;/p&gt;\r\n    &lt;p class=\"text-base font-semibold\"&gt;\r\n        How long does the returns process take?\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        Once goods are received back to us, returns normally take about 10 working days to process.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"text-base font-semibold\"&gt;Have you any questions which we haven’t asked?&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;Our returns policy can be found on our website, however if you wish to speak to one of the\r\n        team please call our customer services team on 0116 274 4059.&lt;/p&gt;\r\n    &lt;p class=\"text-base font-semibold\"&gt;\r\n        How long will my refund take?&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;It will take 14 business days from when you contacted us to receive your refund. Once\r\n        your refund has been approved, the refund amount will be issued back to your original &lt;br&gt;payment method.&lt;br&gt;\r\n        If you contact us to arrange a refund more than 14 business days after delivery, we may be unable to provide\r\n        you with a full refund for the goods being returned.&lt;/p&gt;\r\n    &lt;p class=\"text-base font-semibold\"&gt;Will you refund the delivery charges if I return a product?&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;For return of goods that are not incorrect, faulty or damaged there is no refund of the\r\n        delivery charges from ourselves or your delivery return cost.&lt;/p&gt;\r\n\r\n&lt;/div&gt;</div>','2025-01-27 10:46:02','2025-01-27 10:50:46',1,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,''),(25,'Terms and Conditions Nexus','1column','','','terms-and-conditions-nexus','Terms and Conditions','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"bg-white px-6 text-gray-800\"&gt;\r\n    &lt;h1 class=\"text-3xl font-bold mb-4 text-blue-900\"&gt;Miscellaneous Provisions&lt;/h1&gt;\r\n    &lt;p class=\"mb-4 text-lg\"&gt;\r\n        This website is operated by Banyo Limited (referred to as \"Banyo/we/our/us\"). As a user of this website\r\n        (referred to as \"you/your\") you acknowledge that &lt;br&gt;any use of this website including any transactions you make\r\n        (\"use/using\") is subject to our terms and conditions below (which includes any other &lt;br&gt;important hyper-linked\r\n        sections e.g. Home delivery information, How to use this website, Returns and refunds and Privacy policy. In\r\n        addition, you will find &lt;br&gt;other useful information within Contact us and FAQs. Please:&lt;/p&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0\"&gt;\r\n        &lt;li&gt;\r\n            &lt;p class=\"mb-4 text-lg\"&gt;read through these terms and conditions carefully before using this website&lt;/p&gt;\r\n        &lt;/li&gt;\r\n        &lt;li&gt;\r\n            &lt;p class=\"mb-4 text-lg\"&gt;print a copy for future reference&lt;/p&gt;\r\n        &lt;/li&gt;\r\n        &lt;li&gt;\r\n            &lt;p class=\"mb-4 text-lg\"&gt;also read our Privacy policy section regarding your personal information.&lt;/p&gt;\r\n        &lt;/li&gt;\r\n    &lt;/ul&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;1. General&lt;/h2&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;1.1 We reserve the right to change these terms and conditions at any time. Any such\r\n        changes will take effect\r\n        when posted on the website (see date at the top) and it is your&lt;br&gt; responsibility to read the terms and\r\n        conditions on each occasion you use this website\r\n        and your continued use of the website shall signify your acceptance to be bound by&lt;br&gt; the latest terms and\r\n        conditions.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;1.2 If you are not a consumer, you confirm that you have authority to bind any business on\r\n        whose behalf you\r\n        use this website&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;1.3 We reserve the right to modify or withdraw, temporarily or permanently, this website\r\n        (or any part\r\n        thereof) with or without notice to you and we shall not be liable to you or&lt;br&gt;\r\n        any third party for any such modification or withdrawal.\r\n        The website is provided by us to you on an \"as is\" and \"as available\" basis.&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;2. Order process&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;2.1 Please see the Home delivery information and How to use this website section for\r\n        information on how to place an order. All\r\n        orders that you place on this website will be &lt;br&gt;subject to acceptance in accordance with these terms and\r\n        conditions.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        2.2 The \'confirmation\' stage sets out the final details of your order. Following this, we will send to you an\r\n        order acknowledgement e-mail detailing the products you have &lt;br&gt;ordered. Please note that this e-mail is not an\r\n        order confirmation or order acceptance from Banyo.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        2.3 Acceptance of your order and the completion of the contract between you and us will take place on dispatch\r\n        to you of the products ordered unless we have notified you &lt;br&gt;that we do not accept your order or you have\r\n        cancelled it (please refer to Returns and refunds).\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;2.4 We do not file details of your order for you to subsequently access direct on this\r\n        website, and therefore, please print out these terms and conditions and the order &lt;br&gt;acknowledgement for your\r\n        own records. If you wish to obtain specific details of your previous orders please refer to Contact us and FAQs.\r\n    &lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;3. Delivery&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;3.1 This website is only for delivery of products to customers with mainland UK and\r\n        Northern Ireland addresses. We cannot deliver to the Channel Islands, Isle of Man,&lt;br&gt; Orkney, Shetland and\r\n        Scottish Islands, BFPO addresses, or the Republic of Ireland. All goods must be signed for by an adult aged 18\r\n        years or over on delivery.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;3.2 Delivery charges and estimated timescales are specified in the Home delivery\r\n        information section and also when you place an order. We make every effort to deliver &lt;br&gt;goods within the\r\n        estimated\r\n        timescales, however delays are occasionally inevitable due to unforeseen factors and all goods and products are\r\n        subject to &lt;br&gt;availability. Banyo shall be under no liability for any delay or failure to deliver the products\r\n        within estimated timescales. We recommend that you make arrangements for &lt;br&gt;trades people to carry out work on\r\n        your\r\n        behalf only after your order has been delivered.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;3.3 Risk of loss and damage of products passes to you on the date when the products are\r\n        delivered or on the date of first attempted delivery by us.&lt;/p&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;3.4 As of TBC our delivery costs will be TBC for small items and TBC for larger items.\r\n        These delivery costs will apply across the site and supersede any delivery prices &lt;br&gt;shown in online brochures,\r\n        online leaflets and any other content.&lt;/p&gt;\r\n    &lt;p class=\"mb-4\"&gt;&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;4. Payment&lt;/h2&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;4.1 We take payment from your card at the time we receive your order, once we have checked\r\n        your card details and stock availability. Goods are subject to availability. In the &lt;br&gt;event that we are unable\r\n        to\r\n        supply the goods, we will inform you of this as soon as possible. A full refund will be given where you have\r\n        already paid for the goods.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;4.2 The price you pay is the price displayed on this website at the time we receive your\r\n        order. No other prices published by Banyo are applicable to these items. The&lt;br&gt; following exception\r\n        applies:&lt;br&gt;\r\n        While we try and ensure that all prices on our website are accurate, errors may occur. If we discover an error\r\n        in the price of goods you have ordered we will inform you as&lt;br&gt; soon as possible and give you the option of\r\n        reconfirming your order at the correct price or canceling it. If we are unable to contact you we will treat the\r\n        order as cancelled. If &lt;br&gt;you cancel and you have already paid for the goods, you will receive a full refund.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;4.3 Payment can be made by any method specified in How to use this website. For\r\n        information about secure online ordering see Secure online shopping.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;4.4 Title to any products you order on this website shall pass to you on delivery of the\r\n        products provided that we have processed and received payment in full for the &lt;br&gt;products.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;4.5 All prices include VAT (where applicable) at the applicable current rates but exclude\r\n        delivery charges, unless expressly stated otherwise (see Home delivery information &lt;br&gt;for further details)&lt;/p&gt;\r\n\r\n\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;5. Returns, cancellations and substitutions&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;5.1 We offer a 7-day money back guarantee, please refer to Returns and refunds. In the\r\n        unlikely event that you receive faulty or damaged goods, please refer to &lt;br&gt;our Returns and refunds section.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;5.2 Sometimes the product specifications from the manufacturer may change, in which case\r\n        we will do our best to offer you a substitute of the same or better quality at the &lt;br&gt;same price. If you are\r\n        not happy with the replacement you can return it in accordance with our 7-day money back guarantee. Where\r\n        applicable, you may cancel your order in &lt;br&gt;accordance with your rights under the Distance selling regulations\r\n        (see the Returns and refunds page for further details).&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;5.3 All sizes and measurements are approximate but we do try to make sure that they are as\r\n        accurate as possible.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;&lt;strong&gt; our &lt;a href=\"/returns\" class=\"underline\"&gt;Returns&lt;/a&gt;section:&lt;/strong&gt;&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;5.4 Products we are unable to cancel, refund or exchange&lt;br&gt;We cannot offer refunds or\r\n        exchanges, unless faulty or not as described, on the following items:&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;5.4.1 Products which have been personalised for you&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;5.4.2 Where a product has been specially ordered for you, unless faulty, we are unable\r\n        to refund or offer an exchange. This includes all gas fires, gas stoves, wood burning &lt;br&gt;stoves and wood and\r\n        multifuel burning stoves, which are all made to order, as well as all fires made by the manufacturers Flamerite\r\n        and Evonic. In exceptional&lt;br&gt; circumstances we may be able to accept return of these items with refund less\r\n        deduction for restocking of 35% plus carriage to the distributor or manufacturer.&lt;/p&gt;\r\n\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;6. Intellectual property&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;6.1 You acknowledge and agree that all copyright, trademarks and all other intellectual\r\n        property rights in all materials and/or content made available as part of your use of&lt;br&gt; this website shall\r\n        remain\r\n        at all times vested in us or our licensors. You are permitted to use this material only as expressly authorised\r\n        by us or our licensors.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        6.2 You acknowledge and agree that the material and content contained within this website is made available for\r\n        your personal non-commercial use only and that you may&lt;br&gt; only download such material and content for the\r\n        purpose of using this website. You further acknowledge that any other use of the material and content of this\r\n        website is &lt;br&gt;strictly prohibited and you agree not to (and agree not to assist or facilitate any third party\r\n        to) copy, reproduce, transmit, publish, display, distribute, commercially exploit or &lt;br&gt;create derivative works\r\n        of such material and content.&lt;/p&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;7. Liability and indemnity&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;7.1 Nothing in these terms and conditions excludes or limits liability for death or\r\n        personal injury caused by negligence, fraudulent misrepresentation, or any other liability&lt;br&gt; which may not\r\n        otherwise be limited or excluded under applicable law.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;7.2 Subject to section 7.1 above, Banyo will use reasonable endeavours to\r\n        verify the accuracy of any information on the site but makes no representation or warranty of any&lt;br&gt; kind\r\n        express\r\n        or implied statutory or otherwise regarding the contents or availability of the site or that it will be timely\r\n        or error-free, that defects will be corrected, or that the &lt;br&gt;site or the server that makes it available are\r\n        free\r\n        of viruses or bugs or represents the full functionality, accuracy, reliability of the website Banyo will not be\r\n        responsible or &lt;br&gt;liable to you for any loss of content or material uploaded or transmitted through the website\r\n        and Banyo accepts no liability of any kind for any loss or damage from action &lt;br&gt;taken or taken in reliance on\r\n        material or information contained on the site.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;7.3 Subject to section 7.1 above, other than as expressly provided in these terms and\r\n        conditions with respect to specific products and except for the exclusive remedies set &lt;br&gt;out at Section 5\r\n        above,\r\n        any indemnities, warranties, terms and conditions (whether express or implied) are hereby excluded to the\r\n        fullest extent permitted under applicable&lt;br&gt; law&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        7.4 Subject to section 7.1 above, Banyo will not be liable, in contract, tort (including, without limitation,\r\n        negligence), pre-contract or other representations (other than fraudulent or negligent misrepresentations) or\r\n        otherwise out of or in connection with the terms and conditions for any:&lt;/p&gt;\r\n\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n        &lt;li&gt;economic losses (including without limitation loss of revenues, data, profits, contracts, business or\r\n            anticipated savings); or&lt;/li&gt;\r\n        &lt;li&gt; loss of goodwill or reputation; or&lt;/li&gt;\r\n        &lt;li&gt;special or indirect losses&lt;/li&gt;\r\n    &lt;/ul&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;suffered or incurred by that party arising out of or in connection with the provisions of\r\n        any matter under these terms and conditions.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;7.5 Notwithstanding the above, subject to Section 7.1 Banyo\'s aggregate liability (whether\r\n        in contract, tort or otherwise) for loss or damage shall in any event be limited to a&lt;br&gt; sum equal to the\r\n        amount paid or payable by you for the product(s) in respect of one incident or series of incidents attributable\r\n        to the same clause.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;7.6 This clause 7 does not affect your statutory rights as a consumer, nor does it affect\r\n        your contract cancellation rights.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;7.7 We will take all reasonable precautions to keep the details of your order and payment\r\n        secure, but unless we are negligent, we cannot be held liable for any losses caused &lt;br&gt;as a result of\r\n        unauthorized access to information provided by you.&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;8. Miscellaneous Provisions &lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.1 The contract between us shall be governed by the laws of England and any dispute\r\n        between us will be resolved exclusively in the courts of England. English is the only &lt;br&gt;language offered for\r\n        the conclusion of the contract.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.2 We have selected our products on the basis that they will be used for domestic use\r\n        only. If you are planning to use them for business purposes please make sure that&lt;br&gt; you are covered by\r\n        appropriate insurance.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.3 Banyo shall be under no liability for any delay or failure to deliver products or\r\n        otherwise perform any obligation as specified in these terms and conditions if the same is &lt;br&gt;wholly or partly\r\n        caused whether directly or indirectly by circumstances beyond its reasonable control.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.4 To provide increased value to our customers, we may provide links to other websites or\r\n        resources for you to access at your sole discretion. You acknowledge and agree &lt;br&gt;that, as you have chosen to\r\n        enter the linked website we are not responsible for the availability of such external sites or resources, and do\r\n        not review or endorse and are not &lt;br&gt;responsible or liable, directly or indirectly, for (i) the privacy\r\n        practices of such websites, (ii) the content of such websites, including (without limitation) any\r\n        advertising,&lt;br&gt; content, products, goods or other materials or services on or available from such websites or\r\n        resources or (iii) the use to which others make of these websites or resources,&lt;br&gt; nor for any damage, loss or\r\n        offence caused or alleged to be caused by, or in connection with, the use of or reliance on any such\r\n        advertising, content, products, goods or &lt;br&gt;other materials or services available on such external websites or\r\n        resources.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.5 You may not assign or sub-contract any of your rights or obligations under these terms\r\n        and conditions or any related order for products to any third party unless agreed &lt;br&gt;upon in writing by Banyo.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.6 Banyo reserves the right to transfer, assign, novate or sub-contract the benefit of\r\n        the whole or part of any of its rights or obligations under these terms and conditions or &lt;br&gt;any related\r\n        contract to any third party.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.7 If any portion of these terms and conditions is held by any competent authority to be\r\n        invalid or unenforceable in whole or in part, the validity or enforceability of the&lt;br&gt; other sections of these\r\n        terms and conditions shall not be affected.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.8 These terms and conditions do not create or confer any rights or benefits enforceable\r\n        by any person that is not a party (within the meaning of the U.K. Contracts (Rights &lt;br&gt;of Third Parties) Act\r\n        1999) except:&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;a. Banyo (as defined below) shall have the right to enforce any rights or benefits under\r\n        these terms and conditions;&lt;br&gt;\r\n        b. Banyo shall have the right to enforce and take the benefit of the rights or benefits of any limitation or\r\n        exclusion or limitation of liability in these terms and conditions;&lt;br&gt;\r\n        c. A person who is a permitted successor or assignee under Section 8.8 above of the rights or benefits of these\r\n        terms and conditions may enforce such rights or benefits.&lt;br&gt;\r\n        d. No consent from the persons referred to in Section 8.9 is required for the parties to vary or rescind these\r\n        terms and conditions (whether or not in any way that varies or &lt;br&gt;extinguishes rights or benefits in favour of\r\n        such third parties).&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;8.9 No delay or failure by&nbsp;Banyo&nbsp;to exercise any powers, rights or remedies under these\r\n        terms and conditions will operate as a waiver of them nor will any single or partial &lt;br&gt;exercise of any such\r\n        powers, rights or remedies preclude any other or further exercise of them. Any waiver to be effective must be in\r\n        writing and signed by an authorised &lt;br&gt;representative of Banyo.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        8.10 These terms and conditions including the documents or other sources referred to in these terms and\r\n        conditions supersede all prior representations, understandings&lt;br&gt; and agreements between you and Banyo relating\r\n        to the use of this website (including the order of products) and sets forth the entire agreement and\r\n        understanding between&lt;br&gt; you and Banyo for your use of this website.&lt;/p&gt;\r\n        &lt;p class=\"mb-4 text-base desktop\"&gt;The Banyo website is operated by:\r\n        &lt;/p&gt;\r\n        &lt;p class=\"mb-4 text-base capitalize font-bold desktop\"&gt;Banyo Limited,&lt;br&gt;\r\n        64, St. Barnabas Road,&lt;br&gt;\r\n            Leicester&lt;br&gt;\r\n            LE5 4B\r\n        &lt;/p&gt;\r\n        &lt;p class=\"mb-4 text-base desktop\"&gt;Registered in England with company number&nbsp;3955869.&lt;/p&gt;\r\n        &lt;p class=\"mb-4 text-base desktop\"&gt;VAT Number&nbsp;754 4515 26&nbsp;&lt;/p&gt;\r\n        &lt;p class=\"mb-4 text-base desktop\"&gt;We recommend you print out a copy of these terms and conditions for your future reference.&nbsp;&nbsp;\r\nIf you have any questions regarding the&nbsp;Banyo&nbsp;website please refer to Contact Us and FAQs for more information and full contact details.&lt;/p&gt;\r\n\r\n&lt;/div&gt;</div>','2025-01-27 10:49:11','2025-01-27 10:50:46',1,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,''),(26,'FAQs','cms-full-width','','','faq-nexus','Faqs','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"faq-tab\"&gt;\r\n{{widget type=\"Magento\\Cms\\Block\\Widget\\Block\" template=\"widget/static_block/default.phtml\" block_id=\"faq-tab\"}}\r\n&lt;/div&gt;</div>','2025-01-27 10:53:14','2025-01-27 10:53:14',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(27,'Privacy Policy Nexus','1column','','','privacy-policy-nexus','Privacy Policy ','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"bg-white px-6 text-gray-800 mb-20\"&gt;\r\n    &lt;h1 class=\"text-3xl font-bold mb-4 text-blue-900\"&gt;Banyo Ltd&lt;/h1&gt;\r\n    &lt;p class=\"mb-4 text-lg\"&gt;\r\n        Banyo Ltd (\"We\") are committed to protecting and respecting your privacy.&lt;br&gt;\r\n        This policy (together with our terms of use and any other documents referred to on it) sets out the basis on\r\n        which any personal data we collect from\r\n        you,&lt;br&gt; or that you provide to us, will be processed by us.\r\n        Please read the following carefully to understand our views and practices regarding your personal data&lt;br&gt;\r\n        and how we will treat it.&lt;br&gt;\r\n        For the purposes of the Data Protection Act 1998 (the Act), the data controller is&lt;br&gt;\r\n        Banyo Ltd of 561-563 Barnabas Road,&lt;br&gt;\r\n        Leicester, LE5 4BD.&lt;br&gt;\r\n        Information we may collect from you&lt;/p&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;We may collect and process the following data about you:&lt;/h2&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n        &lt;li&gt;Information that you provide by filling in forms on our site www.banyo.co.uk (our site). This includes\r\n            information provided at the time of registering to use our site and placing orders through our site. We may\r\n            also ask you for information when you enter a competition or promotion sponsored by Banyo Ltd.&lt;/li&gt;\r\n        &lt;li&gt;Information you provide us via email or other correspondence.&lt;/li&gt;\r\n        &lt;li&gt;Details of transactions you carry out through our site and of the fulfillment of your orders.&lt;/li&gt;\r\n        &lt;li&gt;Details of your visits to our site including, but not limited to, traffic data, location data, weblogs and\r\n            other communication data, whether this is required for our own billing purposes or otherwise.&lt;/li&gt;\r\n    &lt;/ul&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;IP addresses and cookies&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;We may collect information about your computer, including where available your IP address, operating\r\n        system and browser type, for system administration and to report aggregate information to our advertisers. This\r\n        is statistical data about our users\' browsing actions and patterns, and does not identify any individual.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        For the same reason, we may obtain information about your general internet usage by using a cookie file which is\r\n        stored on the hard drive of your computer. Cookies contain information that is transferred to your computer\'s\r\n        hard drive. They help us to improve our site and to deliver a better and more personalised service.\r\n    &lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        They enable us:\r\n    &lt;/p&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n        &lt;li&gt;\r\n            To estimate our audience size and usage pattern.&lt;/li&gt;\r\n        &lt;li&gt;To store information about your preferences, and so allow us to customize our site according to your\r\n            individual interests.&lt;/li&gt;\r\n        &lt;li&gt;To speed up your searches.&lt;/li&gt;\r\n        &lt;li&gt;To recognize you when you return to our site.&lt;/li&gt;\r\n    &lt;/ul&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;You may refuse to accept cookies by activating the setting on your browser which allows you to\r\n        refuse the setting of cookies. However, if you select this setting you may be unable to access certain parts of\r\n        our site. Unless you have adjusted your browser setting so that it will refuse cookies, our system will issue\r\n        cookies when you log on to our site.&lt;/p&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Where we store your personal data&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;The data that we collect from you may be transferred to, and stored at, a destination outside the\r\n        European Economic Area (EEA). It may also be processed by staff operating outside the EEA who work for us or for\r\n        one of our suppliers. Such staff maybe engaged in, among other things, the fulfilment of your order, the\r\n        processing of your payment details and the provision of support services. By submitting your personal data, you\r\n        agree to this transfer, storing or processing. We will take all steps reasonably necessary to ensure that your\r\n        data is treated securely and in accordance with this privacy policy.&lt;/p&gt;\r\n    &lt;p class=\"mb-4\"&gt;&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;Unfortunately, the transmission of information via the internet is not completely secure. Athough we\r\n        will do our best to protect your personal data, we cannot guarantee the security of your data transmitted to our\r\n        site; any transmission is at your own risk. Once we have received your information, we will use strict\r\n        procedures and security features to try to prevent unauthorised access.&lt;/p&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Uses made of the information&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;We use information held about you in the following ways:&lt;/p&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n        &lt;li&gt;To ensure that content from our site is presented in the most effective manner for you and for your\r\n            computer.&lt;/li&gt;\r\n        &lt;li&gt;To provide you with information, products or services that you request from us or which we feel may interest\r\n            you, where you have consented to be contacted for such purposes&lt;/li&gt;\r\n        &lt;li&gt;To carry out our obligations arising from any contracts entered into between you and us.&lt;/li&gt;\r\n        &lt;li&gt;To allow you to participate in interactive features of our service, when you choose to do so.&lt;/li&gt;\r\n        &lt;li&gt;To notify you about changes to our service.&lt;/li&gt;\r\n        &lt;li&gt;We may also use your data to provide you with information about goods and services which may be of interest\r\n            to you and we may contact you about these by post or telephone.&lt;/li&gt;\r\n        &lt;li&gt;If you are an existing customer, we will only contact you by electronic means (e-mail or SMS) with\r\n            information about goods and services similar to those which were the subject of a previous sale to you.&lt;/li&gt;\r\n        &lt;li&gt;If you are a new customer we will contact you by electronic means only if you have consented to this&lt;/li&gt;\r\n        &lt;li&gt;If you do not want us to use your data in this way, please tick the relevant box situated on the form on\r\n            which we collect your data (the order form).&lt;/li&gt;\r\n\r\n    &lt;/ul&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;We do not sell, rent or pass on any information about our customers to third parties and we do not\r\n        disclose information about identifiable individuals to our advertisers. However, we may provide them with\r\n        aggregate information about our users (for example, we may inform them that 500 men aged under 30 have clicked\r\n        on their advertisement on any given day). We may also use such aggregate information to help advertisers reach\r\n        the kind of audience they want to target (for example, women in SW1). We may make use of the personal data we\r\n        have collected from you to enable us to comply with our advertisers\' wishes by displaying their advertisement to\r\n        that target audience.&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Disclosure of your information&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;We may disclose your personal information to any member of our group, which means our subsidiaries,\r\n        our ultimate\r\n        holding company and its subsidiaries, as defined in section 736 of the UK Companies Act 1985 and which are not\r\n        treated by us as third parties.&lt;br&gt;\r\n        We in the following circumstances and notwithstanding the foregoing, we may disclose your personal information\r\n        to third parties:&lt;/p&gt;\r\n    &lt;ul class=\"list-disc list-inside space-y-2 mb-4 p-8 py-0 text-base\"&gt;\r\n        &lt;li&gt;In the event that we buy any business or assets substantially comprising a business, in which case we may\r\n            disclose your personal data to the prospective seller of such business or assets.&lt;/li&gt;\r\n        &lt;li&gt;If Banyo Ltd or substantially all of its assets are acquired by a third party, in which case personal data\r\n            held by it about its customers will be one of the transferred assets.&lt;/li&gt;\r\n        &lt;li&gt;If we are under a duty to disclose or share your personal data in order to comply with any legal obligation,\r\n            or in order to enforce or apply our terms and conditions of &lt;br&gt;supply and other agreements; or to protect\r\n            the rights, property, or safety of Banyo Ltd, our customers, or others. This includes exchanging information\r\n            with other companies &lt;br&gt;and organisations for the purposes of fraud protection and credit risk reduction.\r\n        &lt;/li&gt;\r\n    &lt;/ul&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Your rights&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;You have the right to ask us not to process your personal data for marketing purposes. We will\r\n        usually inform you (before collecting your data) if we intend to use your data &lt;br&gt;for such purposes or if we\r\n        intend to disclose your information to any third party for such purposes. You can exercise your right to prevent\r\n        such processing by checking &lt;br&gt;certain boxes on the forms we use to collect your data. You can also exercise\r\n        the right at any time by contacting us at 64 St. Barnabas Road, Leicester, LE5 4BD.&lt;/p&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;\r\n        Our site may, from time to time, contain links to and from the websites of our partner networks, advertisers and\r\n        affiliates. If you follow a link to any of these websites,&lt;br&gt; please note that these websites have their own\r\n        privacy policies and that we do not accept any responsibility or liability for these policies. Please check\r\n        these policies before &lt;br&gt;you submit any personal data to these websites&lt;/p&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Access to information&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;The Act gives you the right to access information held about you. Your right of access can be exercised in\r\n        accordance with the Act. Any access request may be subject to a fee&lt;br&gt; of £10 to meet our costs in providing\r\n        you with details of the information we hold about you.&lt;/p&gt;\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Changes to our privacy policy&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;Any changes we may make to our privacy policy in the future will be posted on this page and, where appropriate, notified to you by e-mail.&lt;/p&gt;\r\n&lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Contact&lt;/h2&gt;\r\n&lt;p class=\"mb-4 text-base\"&gt;Questions, comments and requests regarding this privacy policy are welcomed and should be addressed to 64 St. Barnabas Road Leicester LE5 4BD&lt;/p&gt;\r\n\r\n&lt;/div&gt;</div>','2025-01-27 11:42:40','2025-01-27 11:42:40',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(28,'Visit Our Showroom-Nexus','1column','','','visit-our-showroom-nexus','Visit Our Showroom','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;div class=\"bg-white px-6 text-gray-800\"&gt;\r\n    &lt;div class=\"flex justify-between mb-8\"&gt;\r\n        &lt;div class=\"col-1\"&gt;\r\n            &lt;h1 class=\"text-3xl font-bold mb-4 text-blue-900\"&gt;Our Showroom&lt;/h1&gt;\r\n            &lt;br&gt;\r\n            &lt;p class=\"mb-4 text-lg\"&gt;\r\n                Call our customer services team on 0116 274 4059&lt;br&gt;\r\n                Monday to Friday 9 am - 6 pm&lt;br&gt;\r\n                Saturday 9am - 5pm&lt;/p&gt;\r\n            &lt;br&gt;\r\n            &lt;br&gt;\r\n            &lt;br&gt;\r\n            &lt;p class=\"mb-4 text-lg error-msg text-red-500\"&gt;Note: Calls may be recorded for training and monitoring\r\n                purposes\r\n            &lt;/p&gt;\r\n        &lt;/div&gt;\r\n        &lt;div class=\"col-1 map mt-8\"&gt;\r\n            &lt;iframe\r\n                src=\"https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2421.138744017472!2d-1.1013069240649545!3d52.6394063273832!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x487761658d3a98f9%3A0x11338722dd6d1f0c!2sNexus!5e0!3m2!1sen!2snp!4v1724239017023!5m2!1sen!2snp\"\r\n                width=\"787\" height=\"242px\" style=\"border:0;\" allowfullscreen=\"\" loading=\"lazy\"\r\n                referrerpolicy=\"no-referrer-when-downgrade\"&gt;&lt;/iframe&gt;\r\n        &lt;/div&gt;\r\n    &lt;/div&gt;\r\n    &lt;p class=\"mb-4 text-lg\"&gt;\r\n        Banyo Ltd is a family-run business, and we operate from our large, 10,000ft² Nexus showroom based in Leicester.\r\n        With an extensive range of products and displays for your home, we aim to offer you unparalleled selection,\r\n        prices and service. We have been in this location for 17 years, and have decades of shared experience in\r\n        supplying the best in bathrooms, kitchens and designer fires to thousands of satisfied customers. We also\r\n        have a trade counter, where our dedicated experts provide an unrivalled service to hundreds of local\r\n        plumbers, builders and electricians every day. Our showroom is a hub for consumers and tradespeople to discover\r\n        the latest in home design, with our large range of bathrooms, kitchens, fires and stoves.\r\n    &lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Bathrooms&lt;/h2&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;Here at Banyo, we have a large array of bathrooms on display. With bathroom displays for\r\n        all the leading brands, including Grohe, Kohler, Matki, Franke, Blanco, Ambiance\r\n        Bain, Hansgrohe, HiB, RAK, Bette, Ideal Standard and many more, you will be impressed with all we have to offer.\r\n        Our 10,000ft² showroom is a beacon of bathroom design ideas, high-quality products, and expert advice.\r\n        Whether\r\n        you need a bath, basin, shower enclosure, vanity unit, mirror cabinet, or entire bathroom installation, we are\r\n        here to fulfil your every need.&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Kitchens&lt;/h2&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;At our showroom in Leicester, we are proud to have an extensive range of kitchen units and\r\n        appliances on display. Whether you need an entire kitchen refit, a new sink, or new appliances such as\r\n        fridge-freezers and ovens, we are here to cater to your requirements. Our large showroom off Uppingham Road in\r\n        Leicester has a great selection of expertly designed kitchens on display, so please don’t hesitate to pay us\r\n        a visit to discover our collections. We supply all the leading brands, such as Franke, Blanco, Bosch, Neff,\r\n        Kohler, Reginox and Phoenix. With prices and service that can’t be beaten, come and check us out today.&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Fires&lt;/h2&gt;\r\n    &lt;p class=\"mb-4 text-base\"&gt;Banyo is proud to supply the full ranges of all leading brands of fires and stoves. We\r\n        have a large number of great fires on display in our showroom, and welcome potential customers to pay us a\r\n        visit\r\n        and see what we have to offer. We are official suppliers\r\n        of Dru, Gazco, Flamerite, Evonic, Dimplex, Valor and Flavel. We supply a range of gas, electric and\r\n        multi-fuel\r\n        fires and stoves. With a selection unrivalled in this region, please make sure to stop by to check out our great\r\n        fireplace displays.&lt;/p&gt;\r\n\r\n    &lt;h2 class=\"text-2xl font-semibold my-5\"&gt;Trade Counter\r\n    &lt;/h2&gt;\r\n\r\n    &lt;p class=\"mb-4 text-base\"&gt;Banyo is particularly proud of its busy trade counter, which provides a\r\n        superior service to local tradespeople. If you are a tradesperson working locally to Leicester, we guarantee\r\n        that you will be delighted by the knowledge and service offered by our dedicated staff. With many years of\r\n        experience, a large range of items in stock and on display, and highly competitive prices, you will not be\r\n        disappointed if you pay us a visit.&lt;/p&gt;\r\n&lt;/div&gt;</div>','2025-01-27 11:44:49','2025-01-27 11:44:49',1,0,NULL,'','',NULL,NULL,NULL,NULL,''),(29,'Contact Us Nexus','cms-full-width','','','contact-us-nexus','Contact Us','<div data-content-type=\"html\" data-appearance=\"default\" data-element=\"main\">&lt;p&gt;&lt;img alt=\"Contact us\" src=\"{{media url=wysiwyg/pagesimages/Contact_Us.jpg}}\" /&gt;&lt;/p&gt;\r\n&lt;p&gt;&lt;strong&gt;Banyo&lt;/strong&gt; we believe in putting customers first and will try our very best to assist you with making your purchase or simply to giving your good advise. Please feel free to contact us without obligation.&lt;/p&gt;\r\n&lt;p&gt;&lt;span style=\"\"&gt;If you have been unable to find your answers to your questions in our FAQs then feel free to contact us by one of the following ways:&lt;/span&gt;&lt;/p&gt;\r\n&lt;p&gt;{{block class=\"Magento\\Framework\\View\\Element\\Template\" template=\"Magento_Contact::banyo-contact-form.phtml\"}}&lt;/p&gt;\r\n\r\n&lt;div id =\"contact_blick_info\"&gt;\r\n	\r\n	&lt;div class=\"cusblock csupport\"&gt;\r\n		&lt;img alt=\"\" src=\"{{media url=wysiwyg/Untitled-1_1.jpg}}\" /&gt;\r\n		&lt;h4&gt;Sales &amp; Customer Services&lt;/h4&gt;\r\n		&lt;h5&gt; Call our experts on 011 6274 4059 &lt;/h5&gt;\r\n		&lt;h6&gt;Opening hours:&lt;/h6&gt;\r\n		&lt;p&gt;Monday  to Friday  : 9am - 6pm &lt;/p&gt;\r\n		&lt;p&gt;Saturday   :  9am - 5pm &lt;/p&gt;\r\n		&lt;p&gt;&lt;strong&gt;Note:&lt;/strong&gt; Calls may be recorded for training and monitoring purposes&lt;/p&gt;\r\n	&lt;/div&gt;\r\n	\r\n	\r\n	&lt;div class=\"cusblock email\"&gt;\r\n		&lt;a href=\"mailto:info@banyo.co.uk\"&gt;&lt;img alt=\"\" src=\"{{media url=wysiwyg/email.jpg}}\" /&gt;&lt;/a&gt;\r\n		&lt;h4&gt;Email&lt;/h4&gt;\r\n		&lt;p&gt;All customer service emails are responded to on a first come first served basis. We aim to reply to all e-mails within 1 working day. Please do not re-send emails about the same issue as this will reset the date of your enquiry and put you to the bottom of the queue.&lt;/p&gt;\r\n	&lt;/div&gt;\r\n	\r\n	&lt;div class=\"cusblock livechat\"&gt;\r\n		&lt;img alt=\"\" src=\"{{media url=wysiwyg/chat.jpg}}\" /&gt;\r\n		&lt;h4&gt;Live Chat&lt;/h4&gt;\r\n		&lt;h5&gt;Need an answer quickly? &lt;/h5&gt;\r\n		&lt;h6&gt;Opening hours:&lt;/h6&gt;\r\n		&lt;p&gt;Monday  to Friday  : 9am - 6pm &lt;/p&gt;\r\n		&lt;p&gt;Saturday   :  9am - 5pm &lt;/p&gt;\r\n		&lt;p&gt;&lt;strong&gt;Note:&lt;/strong&gt;  Calls may be recorded for training and monitoring purposes &lt;/p&gt;\r\n	&lt;/div&gt;\r\n	\r\n\r\n\r\n\r\n\r\n\r\n	&lt;div class=\"cusblock socialmedia\"&gt;\r\n		&lt;img src=\"{{media url=f.jpg}}\" alt=\"\" /&gt;\r\n		&lt;h4&gt;Social Media&lt;/h4&gt;\r\n		&lt;p&gt;You can also contact us on Twitter and Facebook&lt;/p&gt;\r\n	&lt;/div&gt;\r\n	\r\n	&lt;div class=\"cusblock post\"&gt;\r\n		&lt;img alt=\"\" src=\"{{media url=wysiwyg/letter-icon.jpg}}\" /&gt;\r\n		&lt;h4&gt;Post&lt;/h4&gt;\r\n		&lt;p&gt;&lt;strong&gt;Please write to us at:&lt;/strong&gt; Nexus - 64 St. Barnabas Road, Leicester, LE5 4BD&lt;/p&gt;\r\n	&lt;/div&gt;\r\n	\r\n	&lt;div class=\"clear\"&gt;&lt;/div&gt;\r\n&lt;/div&gt;\r\n\r\n\r\n&lt;style&gt;\r\n#contact_blick_info .cusblock {\r\n    float: left;\r\n    width: 30%;\r\n    margin: 0px 15px 20px;\r\n}\r\n#contact_blick_info .cusblock img{\r\n    max-width: 20%;\r\n    margin: 0 auto;\r\n    display: block;\r\n    text-align: center;\r\n}\r\n#contact_blick_info .cusblock h4 {\r\n    text-align: center;\r\n    font-size: 16px;\r\n    display: block;\r\n}\r\n#contact_blick_info .cusblock h5 {\r\n    font-size: 14px;\r\n    text-align: center;\r\n    display: block;\r\n}\r\n#contact_blick_info .cusblock h6 {\r\n    font-size: 15px;\r\n    display: block;\r\n    text-align: center;\r\n}\r\n#contact_blick_info .cusblock p{\r\n	text-align: center;\r\n    font-size: 15px;\r\n    margin: 0 auto;\r\n    line-height: 26px;\r\n}\r\n\r\n#banyo_contact {\r\n	margin-bottom:70px;\r\n	dispay:block;\r\n}\r\n.fieldset {\r\n    border: 0px solid #c0c0c0 !important;\r\n   }\r\n   \r\n\r\n@media only screen and (max-width:1250px) {\r\n  #contact_blick_info .cusblock:nth-child(3n+1) {\r\n	  clear:both;\r\n  }\r\n}\r\n@media only screen and (max-width:970px) {\r\n  #contact_blick_info .cusblock {\r\n		clear: none;\r\n		width: 45%;\r\n		display: block;\r\n	}\r\n	#contact_blick_info .cusblock:nth-child(2n+1) {\r\n	  clear:both;\r\n	}\r\n	#contact_blick_info .cusblock:nth-child(3n+1) {\r\n	  clear:none;\r\n	}\r\n}\r\n\r\n@media only screen and (max-width:810px) {\r\n	#contact_blick_info .cusblock {\r\n		clear: both !important;\r\n		display: block;\r\n		width: 90%;\r\n		margin: 0 auto 10px;\r\n	}\r\n	#contact_blick_info .cusblock img {\r\n		max-width: 10%;\r\n	}\r\n}\r\n&lt;/style&gt;</div>','2025-01-27 13:03:55','2025-01-27 13:03:55',1,0,NULL,'','',NULL,NULL,NULL,NULL,'');
/*!40000 ALTER TABLE `cms_page` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cms_page_store`
--

DROP TABLE IF EXISTS `cms_page_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cms_page_store` (
  `page_id` smallint NOT NULL COMMENT 'Entity ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  PRIMARY KEY (`page_id`,`store_id`),
  KEY `CMS_PAGE_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `CMS_PAGE_STORE_PAGE_ID_CMS_PAGE_PAGE_ID` FOREIGN KEY (`page_id`) REFERENCES `cms_page` (`page_id`) ON DELETE CASCADE,
  CONSTRAINT `CMS_PAGE_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='CMS Page To Store Linkage Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cms_page_store`
--

LOCK TABLES `cms_page_store` WRITE;
/*!40000 ALTER TABLE `cms_page_store` DISABLE KEYS */;
INSERT INTO `cms_page_store` VALUES (1,0),(2,0),(3,0),(4,0),(5,0),(6,0),(7,0),(8,0),(9,0),(10,0),(11,0),(12,0),(13,0),(14,0),(15,0),(29,0),(20,1),(19,3),(21,3),(22,3),(23,3),(24,3),(25,3),(26,3),(27,3),(28,3);
/*!40000 ALTER TABLE `cms_page_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `core_config_data`
--

DROP TABLE IF EXISTS `core_config_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `core_config_data` (
  `config_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Config ID',
  `scope` varchar(8) NOT NULL DEFAULT 'default' COMMENT 'Config Scope',
  `scope_id` int NOT NULL DEFAULT '0' COMMENT 'Config Scope ID',
  `path` varchar(255) NOT NULL DEFAULT 'general' COMMENT 'Config Path',
  `value` text COMMENT 'Config Value',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  PRIMARY KEY (`config_id`),
  UNIQUE KEY `CORE_CONFIG_DATA_SCOPE_SCOPE_ID_PATH` (`scope`,`scope_id`,`path`)
) ENGINE=InnoDB AUTO_INCREMENT=307 DEFAULT CHARSET=utf8mb3 COMMENT='Config Data';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `core_config_data`
--

LOCK TABLES `core_config_data` WRITE;
/*!40000 ALTER TABLE `core_config_data` DISABLE KEYS */;
INSERT INTO `core_config_data` VALUES (1,'default',0,'web/seo/use_rewrites','1','2025-01-31 09:21:58'),(2,'default',0,'web/unsecure/base_url','https://hyva-staging.banyo.co.uk/','2025-01-24 12:51:32'),(3,'default',0,'general/locale/code','en_GB','2025-01-27 13:47:42'),(4,'default',0,'general/locale/timezone','America/Chicago','2024-08-05 09:21:05'),(8,'default',0,'general/region/display_all','1','2024-08-05 09:21:06'),(9,'default',0,'general/region/state_required','AL,AR,AU,BY,BO,BR,BG,CA,CL,CN,CO,CR,HR,CZ,DK,EC,EE,GR,GY,IS,IN,IT,LV,LT,MX,PY,PE,PL,PT,RO,ES,SR,SE,CH,UA,US,UY,VE','2024-09-30 08:31:45'),(10,'default',0,'catalog/category/root_id','2','2024-08-05 09:21:14'),(11,'default',0,'twofactorauth/duo/application_key','f0SnEW7NQO0dzdYiaFiSlTB6b9vmeak3caPRHTSuexYHY9v0NNOgivHOGKTeN8ZO','2024-08-05 09:21:15'),(12,'default',0,'analytics/subscription/enabled','1','2024-08-05 09:21:15'),(13,'default',0,'crontab/default/jobs/analytics_subscribe/schedule/cron_expr','0 * * * *','2024-08-05 09:21:15'),(14,'default',0,'crontab/default/jobs/analytics_collect_data/schedule/cron_expr','00 02 * * *','2024-08-05 09:21:15'),(15,'default',0,'msp_securitysuite_recaptcha/frontend/enabled','0','2024-08-05 09:21:16'),(16,'default',0,'msp_securitysuite_recaptcha/backend/enabled','0','2024-08-05 09:21:16'),(17,'default',0,'web/secure/base_url','https://hyva-staging.banyo.co.uk/','2025-01-24 13:02:48'),(18,'default',0,'dev/static/sign','0','2024-08-05 16:10:10'),(19,'default',0,'admin/usage/enabled','0','2024-08-05 16:54:27'),(20,'default',0,'design/theme/theme_id','6','2024-08-07 13:25:32'),(21,'default',0,'design/pagination/pagination_frame','5','2024-08-07 13:25:33'),(22,'default',0,'design/pagination/pagination_frame_skip',NULL,'2024-08-07 13:25:33'),(23,'default',0,'design/pagination/anchor_text_for_previous',NULL,'2024-08-07 13:25:33'),(24,'default',0,'design/pagination/anchor_text_for_next',NULL,'2024-08-07 13:25:33'),(25,'default',0,'design/head/default_title','Magento Commerce','2024-08-07 13:25:33'),(26,'default',0,'design/head/title_prefix',NULL,'2024-08-07 13:25:33'),(27,'default',0,'design/head/title_suffix',NULL,'2024-08-07 13:25:33'),(28,'default',0,'design/head/default_description',NULL,'2024-08-07 13:25:33'),(29,'default',0,'design/head/default_keywords',NULL,'2024-08-07 13:25:33'),(30,'default',0,'design/head/includes',NULL,'2024-08-07 13:25:33'),(31,'default',0,'design/head/demonotice','0','2024-08-07 13:25:33'),(32,'default',0,'design/header/logo_width',NULL,'2024-08-07 13:25:33'),(33,'default',0,'design/header/logo_height',NULL,'2024-08-07 13:25:33'),(34,'default',0,'design/header/logo_alt',NULL,'2024-08-07 13:25:33'),(35,'default',0,'design/header/welcome','Default welcome msg!','2024-08-07 13:25:33'),(36,'default',0,'design/header/translate_title','1','2024-08-07 13:25:33'),(37,'default',0,'design/footer/copyright','Copyright © 2013-present Magento, Inc. All rights reserved.','2024-08-07 13:25:33'),(38,'default',0,'design/footer/absolute_footer',NULL,'2024-08-07 13:25:33'),(39,'default',0,'design/footer/report_bugs','1','2024-08-07 13:25:33'),(40,'default',0,'design/search_engine_robots/default_robots','INDEX,FOLLOW','2024-08-07 13:25:33'),(41,'default',0,'design/search_engine_robots/custom_instructions',NULL,'2024-08-07 13:25:33'),(42,'default',0,'design/watermark/image_size',NULL,'2024-08-07 13:25:33'),(43,'default',0,'design/watermark/image_imageOpacity',NULL,'2024-08-07 13:25:33'),(44,'default',0,'design/watermark/image_position','stretch','2024-08-07 13:25:33'),(45,'default',0,'design/watermark/small_image_size',NULL,'2024-08-07 13:25:33'),(46,'default',0,'design/watermark/small_image_imageOpacity',NULL,'2024-08-07 13:25:33'),(47,'default',0,'design/watermark/small_image_position','stretch','2024-08-07 13:25:33'),(48,'default',0,'design/watermark/thumbnail_size',NULL,'2024-08-07 13:25:33'),(49,'default',0,'design/watermark/thumbnail_imageOpacity',NULL,'2024-08-07 13:25:33'),(50,'default',0,'design/watermark/thumbnail_position','stretch','2024-08-07 13:25:33'),(51,'default',0,'design/email/logo_alt',NULL,'2024-08-07 13:25:33'),(52,'default',0,'design/email/logo_width',NULL,'2024-08-07 13:25:33'),(53,'default',0,'design/email/logo_height',NULL,'2024-08-07 13:25:33'),(54,'default',0,'design/email/header_template','design_email_header_template','2024-08-07 13:25:33'),(55,'default',0,'design/email/footer_template','design_email_footer_template','2024-08-07 13:25:33'),(56,'stores',1,'design/header/logo_src','stores/1/Icon.png','2024-08-09 08:17:23'),(57,'default',0,'admin/security/admin_account_sharing','1','2024-08-20 06:18:52'),(58,'default',0,'catalog/productalert_cron/frequency','D','2024-08-22 06:42:41'),(59,'default',0,'crontab/default/jobs/catalog_product_alert/schedule/cron_expr','0 0 * * *','2024-08-22 06:42:41'),(60,'default',0,'crontab/default/jobs/catalog_product_alert/run/model',NULL,'2024-08-22 06:42:41'),(61,'default',0,'catalog/productalert_cron/time','00,00,00','2024-08-22 06:42:41'),(62,'default',0,'catalog/productalert_cron/error_email',NULL,'2024-08-22 06:42:41'),(63,'default',0,'catalog/product_video/youtube_api_key','AIzaSyAOr8C04LhKssMiWFko2KN1jU5doCAavwg','2024-10-21 05:17:11'),(64,'default',0,'catalog/price/scope','0','2024-08-22 06:42:41'),(65,'default',0,'catalog/search/engine','opensearch','2024-08-22 06:42:41'),(66,'default',0,'catalog/search/opensearch_server_hostname','localhost','2024-08-22 06:42:41'),(67,'default',0,'catalog/search/opensearch_server_port','9200','2024-08-22 06:42:41'),(68,'default',0,'catalog/search/opensearch_index_prefix','magento2','2024-08-22 06:42:41'),(69,'default',0,'catalog/search/opensearch_enable_auth','0','2024-08-22 06:42:41'),(70,'default',0,'catalog/search/opensearch_server_timeout','15','2024-08-22 06:42:41'),(71,'default',0,'catalog/search/opensearch_minimum_should_match',NULL,'2024-08-22 06:42:41'),(72,'default',0,'catalog/custom_options/use_calendar','0','2024-08-22 06:42:41'),(73,'default',0,'catalog/custom_options/year_range',',','2024-08-22 06:42:41'),(74,'default',0,'catalog/placeholder/image_placeholder',NULL,'2024-08-22 06:42:41'),(75,'default',0,'catalog/placeholder/small_image_placeholder',NULL,'2024-08-22 06:42:41'),(76,'default',0,'catalog/placeholder/thumbnail_placeholder',NULL,'2024-08-22 06:42:41'),(77,'default',0,'catalog/placeholder/swatch_image_placeholder',NULL,'2024-08-22 06:42:41'),(78,'default',0,'amasty_base/cron/feeds_refresh','40 * * * *','2024-09-03 09:32:46'),(79,'default',0,'amasty_base/cron/daily_send_system_info','57 * * * *','2024-09-03 09:32:46'),(80,'default',0,'amasty_base/cron/instance_registration','36 * * * *','2024-09-03 09:32:46'),(81,'default',0,'mageworx_settings/general/installed_data','{\"mageworx\\/module-advancedproductoptions\":{\"title\":\"Advanced Product Options Suite\",\"version\":\"2.38.3\",\"image\":\"https:\\/\\/www.mageworx.com\\/media\\/catalog\\/product\\/a\\/p\\/apo_icon.png\",\"user_guide\":\"https:\\/\\/support.mageworx.com\\/manuals\\/apo\\/\",\"url\":\"https:\\/\\/www.mageworx.com\\/magento-2-advanced-product-options-suite.html?utm_source=M2backend&utm_medium=extension&utm_campaign=recommendation\",\"marketplace_link\":\"https:\\/\\/marketplace.magento.com\\/mageworx-module-advancedproductoptions.html#bazaarvoice.reviews.tab\",\"price\":299,\"rating\":94,\"review_count\":327},\"mageworx\\/module-shippingrulesmeta\":{\"title\":\"Shipping Suite\",\"version\":\"2.11.23\",\"image\":\"https:\\/\\/www.mageworx.com\\/media\\/catalog\\/product\\/s\\/h\\/shipping_icon.png\",\"user_guide\":\"https:\\/\\/support.mageworx.com\\/manuals\\/shipping_suite\\/\",\"url\":\"https:\\/\\/www.mageworx.com\\/magento-2-shipping-suite.html?utm_source=M2backend&utm_medium=extension&utm_campaign=recommendation\",\"marketplace_link\":\"https:\\/\\/marketplace.magento.com\\/mageworx-module-shippingrulesmeta.html#bazaarvoice.reviews.tab\",\"price\":349,\"rating\":97,\"review_count\":105}}','2025-02-03 14:53:11'),(82,'default',0,'mageworx_settings/general/recommended_data','{\"mageworx\\/module-shippingrulesmeta\":{\"title\":\"Shipping Suite\",\"version\":\"2.11.23\",\"image\":\"https:\\/\\/www.mageworx.com\\/media\\/catalog\\/product\\/s\\/h\\/shipping_icon.png\",\"user_guide\":\"https:\\/\\/support.mageworx.com\\/manuals\\/shipping_suite\\/\",\"url\":\"https:\\/\\/www.mageworx.com\\/magento-2-shipping-suite.html?utm_source=M2backend&utm_medium=extension&utm_campaign=recommendation\",\"marketplace_link\":\"https:\\/\\/marketplace.magento.com\\/mageworx-module-shippingrulesmeta.html#bazaarvoice.reviews.tab\",\"price\":349,\"rating\":97,\"review_count\":105},\"mageworx\\/module-advancedproductoptions\":{\"title\":\"Advanced Product Options Suite\",\"version\":\"2.38.3\",\"image\":\"https:\\/\\/www.mageworx.com\\/media\\/catalog\\/product\\/a\\/p\\/apo_icon.png\",\"user_guide\":\"https:\\/\\/support.mageworx.com\\/manuals\\/apo\\/\",\"url\":\"https:\\/\\/www.mageworx.com\\/magento-2-advanced-product-options-suite.html?utm_source=M2backend&utm_medium=extension&utm_campaign=recommendation\",\"marketplace_link\":\"https:\\/\\/marketplace.magento.com\\/mageworx-module-advancedproductoptions.html#bazaarvoice.reviews.tab\",\"price\":299,\"rating\":94,\"review_count\":327},\"mageworx\\/module-deliverydatemeta\":{\"title\":\"Delivery Date & Time\",\"version\":\"1.21.4\",\"image\":\"https:\\/\\/www.mageworx.com\\/media\\/catalog\\/product\\/d\\/e\\/delivery_dat___time.png\",\"user_guide\":\"https:\\/\\/support.mageworx.com\\/manuals\\/delivery-date\\/\",\"url\":\"https:\\/\\/www.mageworx.com\\/delivery-date-magento-2.html?utm_source=M2backend&utm_medium=extension&utm_campaign=recommendation\",\"marketplace_link\":\"https:\\/\\/marketplace.magento.com\\/mageworx-module-deliverydatemeta.html#bazaarvoice.reviews.tab\",\"price\":179,\"rating\":97,\"review_count\":23},\"mageworx\\/module-storelocatormeta\":{\"title\":\"Affiliate\",\"version\":\"1.0.3\",\"image\":\"https:\\/\\/www.mageworx.com\\/media\\/catalog\\/product\\/a\\/f\\/affiliate_program_pro.png\",\"user_guide\":\"https:\\/\\/support.mageworx.com\\/manuals\\/affiliates\\/\",\"url\":\"https:\\/\\/www.mageworx.com\\/magento-2-affiliate-extension.html?utm_source=M2backend&utm_medium=extension&utm_campaign=recommendation\",\"marketplace_link\":\"https:\\/\\/marketplace.magento.com\\/mageworx-module-storelocatormeta.html#bazaarvoice.reviews.tab\",\"price\":0,\"rating\":0,\"review_count\":0},\"mageworx\\/module-customerpricessuite\":{\"title\":\"Customer Prices Suite\",\"version\":\"2.7.5\",\"image\":\"https:\\/\\/www.mageworx.com\\/media\\/catalog\\/product\\/_\\/u\\/_ustomer_prices_suite_icon.png\",\"user_guide\":\"https:\\/\\/support.mageworx.com\\/manuals\\/customer-prices-suite\\/\",\"url\":\"https:\\/\\/www.mageworx.com\\/customer-prices-suite-magento-2.html?utm_source=M2backend&utm_medium=extension&utm_campaign=recommendation\",\"marketplace_link\":\"https:\\/\\/marketplace.magento.com\\/mageworx-module-customerpricessuite.html#bazaarvoice.reviews.tab\",\"price\":249,\"rating\":98,\"review_count\":5}}','2025-02-03 14:53:11'),(83,'default',0,'catalog/recently_products/recently_viewed_enabled','1','2024-09-16 08:02:21'),(84,'default',0,'catalog/recently_products/show_on_pdp','1','2024-09-16 08:02:21'),(85,'default',0,'catalog/recently_products/show_on_plp','1','2024-09-16 08:02:21'),(87,'default',0,'ajaxcart/general/active','1','2024-09-17 10:42:22'),(88,'default',0,'ajaxcart/general/active_product_view','1','2024-09-17 10:42:22'),(89,'default',0,'ajaxcart/general/selector','#product-addtocart-button','2024-09-17 10:45:33'),(90,'default',0,'ajaxcart/general/popup_animation','0','2024-09-17 10:42:23'),(91,'default',0,'ajaxcart/success_popup/product_image','1','2024-09-17 10:42:23'),(92,'default',0,'ajaxcart/success_popup/product_image_size','100','2024-09-17 10:42:23'),(93,'default',0,'ajaxcart/success_popup/product_price','0','2024-09-17 10:42:23'),(94,'default',0,'ajaxcart/success_popup/continue_button','1','2024-09-17 10:42:23'),(95,'default',0,'ajaxcart/success_popup/active_countdown','1','2024-09-17 10:42:23'),(96,'default',0,'ajaxcart/success_popup/countdown_time','5','2024-09-17 10:42:23'),(97,'default',0,'ajaxcart/success_popup/mini_cart','1','2024-09-17 10:42:23'),(98,'default',0,'ajaxcart/success_popup/mini_checkout','1','2024-09-17 10:42:23'),(99,'default',0,'ajaxcart/success_popup/suggest_product','0','2024-09-17 10:42:23'),(100,'default',0,'ajaxcart/success_popup_design/button_text_color','FFFFFF','2024-09-17 10:42:23'),(101,'default',0,'ajaxcart/success_popup_design/continue_text','Continue Shopping','2024-09-17 10:42:23'),(102,'default',0,'ajaxcart/success_popup_design/continue','1979C3','2024-09-17 10:42:23'),(103,'default',0,'ajaxcart/success_popup_design/continue_hover','006BB4','2024-09-17 10:42:23'),(104,'default',0,'ajaxcart/success_popup_design/viewcart_text','View Cart','2024-09-17 10:42:23'),(105,'default',0,'ajaxcart/success_popup_design/viewcart','1979C3','2024-09-17 10:42:23'),(106,'default',0,'ajaxcart/success_popup_design/viewcart_hover','006BB4','2024-09-17 10:42:23'),(107,'default',0,'ajaxcart/quickview_popup/go_to_product','1','2024-09-17 10:42:23'),(108,'default',0,'ajaxcart/quickview_popup/additional_data','0','2024-09-17 10:42:23'),(109,'default',0,'ajaxcart/fly_to_cart/enable','0','2024-09-17 10:42:23'),(110,'default',0,'hyva_react_checkout/general/enable','1','2024-09-18 11:44:04'),(111,'default',0,'mageworx_shipping_calculator/main/enabled','1','2024-09-26 09:48:18'),(112,'default',0,'mageworx_shipping_calculator/main/calculate_on_load','1','2024-09-26 09:48:18'),(113,'default',0,'mageworx_shipping_calculator/main/calculate_by_country','0','2024-09-26 09:52:50'),(114,'default',0,'mageworx_shipping_calculator/main/country_required','1','2024-09-26 09:48:18'),(115,'default',0,'mageworx_shipping_calculator/main/calculate_by_region','0','2024-09-26 09:54:53'),(116,'default',0,'mageworx_shipping_calculator/main/region_required','1','2024-09-26 09:48:18'),(117,'default',0,'mageworx_shipping_calculator/main/calculate_by_zip','1','2024-09-26 09:48:18'),(118,'default',0,'mageworx_shipping_calculator/main/zip_required','1','2024-09-26 09:48:18'),(119,'default',0,'mageworx_shipping_calculator/main/highlight_cheapest_method','0','2024-09-26 09:48:18'),(120,'default',0,'mageworx_shipping_calculator/main/title','Estimate Shipping Methods','2024-09-26 09:48:18'),(121,'default',0,'mageworx_shipping_calculator/main/description','Update shipping information to see available shipping methods.','2024-09-26 09:48:18'),(122,'default',0,'mageworx_shipping_calculator/main/not_found_error','Sorry, there is no shipping methods available.','2024-09-26 09:48:18'),(123,'default',0,'mageworx_shipping_calculator/shipping_methods/configuration','[]','2024-09-26 09:48:18'),(124,'default',0,'general/country/default','GB','2024-09-30 08:31:45'),(125,'default',0,'general/country/destinations',NULL,'2024-09-30 08:31:45'),(126,'default',0,'general/store_information/name',NULL,'2024-09-30 08:31:45'),(127,'default',0,'general/store_information/phone',NULL,'2024-09-30 08:31:45'),(128,'default',0,'general/store_information/hours',NULL,'2024-09-30 08:31:45'),(129,'default',0,'general/store_information/country_id',NULL,'2024-09-30 08:31:45'),(130,'default',0,'general/store_information/region_id',NULL,'2024-09-30 08:31:45'),(131,'default',0,'general/store_information/postcode',NULL,'2024-09-30 08:31:45'),(132,'default',0,'general/store_information/city',NULL,'2024-09-30 08:31:45'),(133,'default',0,'general/store_information/street_line1',NULL,'2024-09-30 08:31:45'),(134,'default',0,'general/store_information/street_line2',NULL,'2024-09-30 08:31:45'),(135,'default',0,'general/store_information/merchant_vat_number',NULL,'2024-09-30 08:31:45'),(136,'default',0,'general/single_store_mode/enabled','0','2024-09-30 08:31:45'),(137,'stores',1,'design/head/includes','<style>\r\n@media screen and (min-width: 1025px) and (max-width: 1242px) and (orientation: portrait) {\r\n    .catalog-category-view .best-seller .add-cart {\r\n        width: 165px;\r\n        padding: 10px 10px;\r\n    }\r\n    .catalog-category-view .best-seller .blue-cart {\r\n        width: 25px;\r\n        height: 20px;\r\n        margin-right: 5px;\r\n    }\r\n    .catalog-category-view .best-seller .add-cart {\r\n        width: 165px;\r\n        padding: 10px 10px;\r\n        font-size: 14px;\r\n    }\r\n    .right-sec .minisearch_desktop .minisearch {\r\n        width: 225px;\r\n        position: relative;\r\n    }\r\n    .minisearch_desktop .minisearch input#search::placeholder {\r\n        opacity: 0;\r\n    }\r\n}\r\n</style>\r\n','2024-10-07 11:01:45'),(138,'default',0,'currency/fixerio/api_key',NULL,'2024-10-09 08:30:39'),(139,'default',0,'currency/fixerio/timeout','100','2024-10-09 08:30:39'),(140,'default',0,'currency/fixerio_apilayer/api_key',NULL,'2024-10-09 08:30:39'),(141,'default',0,'currency/fixerio_apilayer/timeout','100','2024-10-09 08:30:39'),(142,'default',0,'currency/currencyconverterapi/api_key',NULL,'2024-10-09 08:30:39'),(143,'default',0,'currency/currencyconverterapi/timeout','100','2024-10-09 08:30:39'),(144,'default',0,'currency/options/base','USD','2024-10-09 14:44:27'),(145,'default',0,'currency/options/default','USD','2024-10-09 14:44:27'),(146,'default',0,'currency/options/allow','USD','2024-10-09 14:44:27'),(147,'default',0,'catalog/product_video/play_if_base','1','2024-10-21 05:17:11'),(148,'stores',1,'design/header/logo_width','203','2024-10-24 07:58:53'),(149,'stores',1,'design/header/logo_height','38','2024-10-24 07:58:53'),(150,'default',0,'customer/online_customers/online_minutes_interval',NULL,'2024-11-04 11:04:34'),(151,'default',0,'customer/online_customers/section_data_lifetime','60','2024-11-04 11:04:34'),(153,'default',0,'customer/captcha/forms','user_create,user_login,user_forgotpassword,user_edit','2024-11-05 03:19:24'),(154,'default',0,'recaptcha_frontend/type_recaptcha/public_key',NULL,'2024-11-05 08:22:13'),(155,'default',0,'recaptcha_frontend/type_recaptcha/private_key',NULL,'2024-11-05 08:22:13'),(156,'default',0,'recaptcha_frontend/type_invisible/public_key',NULL,'2024-11-05 08:22:13'),(157,'default',0,'recaptcha_frontend/type_invisible/private_key',NULL,'2024-11-05 08:22:13'),(158,'default',0,'recaptcha_frontend/type_recaptcha_v3/public_key','0:3:sxYo1KSY5IJMk3Ok3fuxs9BbPc3sO42i5nLXPEnIIy4b6sSNNMvThQcoKPMDjRK7nHREenlI4GCfVwpEVoSNMpKoaLs=','2024-11-05 08:22:13'),(159,'default',0,'recaptcha_frontend/type_recaptcha_v3/private_key','0:3:a65+42ai4US/L/UqTfR66p9DKHWZjtjlWop2OjsehUIlizQEiJ125tiGuEJmrSA1/rFVOvMA4lHKWiiEonEfvJbRrqk=','2024-11-05 08:22:13'),(160,'default',0,'recaptcha_frontend/type_for/customer_login',NULL,'2024-11-05 10:31:29'),(161,'default',0,'recaptcha_frontend/type_for/customer_forgot_password',NULL,'2024-11-05 10:31:29'),(162,'default',0,'recaptcha_frontend/type_for/customer_create',NULL,'2024-11-05 10:31:29'),(163,'default',0,'mst_core/css/include_font_awesome','1','2024-12-06 06:11:34'),(164,'default',0,'carriers/flatrate/handling_fee',NULL,'2024-12-13 14:40:54'),(165,'default',0,'carriers/flatrate/specificcountry',NULL,'2024-12-13 14:40:54'),(166,'default',0,'carriers/flatrate/showmethod','0','2024-12-13 14:40:54'),(167,'default',0,'carriers/flatrate/sort_order',NULL,'2024-12-13 14:40:54'),(168,'default',0,'carriers/shipping/active','1','2024-12-13 14:40:54'),(169,'default',0,'carriers/shipping/title','Example','2024-12-13 14:40:54'),(170,'default',0,'carriers/shipping/name','MageWorx Shipping','2024-12-13 14:40:54'),(171,'default',0,'carriers/shipping/price','15.00','2024-12-13 14:40:54'),(172,'default',0,'carriers/shipping/handling_type','F','2024-12-13 14:40:54'),(173,'default',0,'carriers/shipping/handling_fee',NULL,'2024-12-13 14:40:54'),(174,'default',0,'carriers/shipping/specificerrmsg','This shipping method is not available. To use this shipping method, please contact us.','2024-12-13 14:40:54'),(175,'default',0,'carriers/shipping/sallowspecific','0','2024-12-13 14:40:54'),(176,'default',0,'carriers/shipping/specificcountry',NULL,'2024-12-13 14:40:54'),(177,'default',0,'carriers/shipping/showmethod','0','2024-12-13 14:40:54'),(178,'default',0,'carriers/shipping/sort_order',NULL,'2024-12-13 14:40:54'),(179,'default',0,'carriers/matrixrate/specificerrmsg','This shipping method is currently unavailable. If you would like to ship using this shipping method, please contact us.','2024-12-13 14:40:54'),(180,'default',0,'carriers/matrixrate/sort_order',NULL,'2024-12-13 14:40:54'),(181,'default',0,'carriers/freeshipping/free_shipping_subtotal',NULL,'2024-12-13 14:40:54'),(182,'default',0,'carriers/freeshipping/specificcountry',NULL,'2024-12-13 14:40:54'),(183,'default',0,'carriers/freeshipping/showmethod','0','2024-12-13 14:40:54'),(184,'default',0,'carriers/freeshipping/sort_order',NULL,'2024-12-13 14:40:54'),(185,'default',0,'carriers/tablerate/handling_fee',NULL,'2024-12-13 14:40:54'),(186,'default',0,'carriers/tablerate/specificcountry',NULL,'2024-12-13 14:40:54'),(187,'default',0,'carriers/tablerate/showmethod','0','2024-12-13 14:40:54'),(188,'default',0,'carriers/tablerate/sort_order',NULL,'2024-12-13 14:40:54'),(189,'default',0,'carriers/customshipping/active','0','2024-12-13 14:40:54'),(190,'default',0,'carriers/customshipping/allowfor','0','2024-12-13 14:40:54'),(191,'default',0,'carriers/customshipping/title','Custom Shipping','2024-12-13 14:40:54'),(192,'default',0,'carriers/customshipping/shipping_type','[]','2024-12-13 14:40:54'),(193,'default',0,'carriers/customshipping/specificerrmsg',NULL,'2024-12-13 14:40:55'),(194,'default',0,'carriers/customshipping/sallowspecific','0','2024-12-13 14:40:55'),(195,'default',0,'carriers/customshipping/specificcountry',NULL,'2024-12-13 14:40:55'),(196,'default',0,'carriers/customshipping/showmethod','0','2024-12-13 14:40:55'),(197,'default',0,'carriers/customshipping/sortorder',NULL,'2024-12-13 14:40:55'),(198,'default',0,'carriers/ups/shipper_number',NULL,'2024-12-13 14:40:55'),(199,'default',0,'carriers/ups/handling_fee',NULL,'2024-12-13 14:40:55'),(200,'default',0,'carriers/ups/free_shipping_enable','0','2024-12-13 14:40:55'),(201,'default',0,'carriers/ups/specificcountry',NULL,'2024-12-13 14:40:55'),(202,'default',0,'carriers/ups/showmethod','0','2024-12-13 14:40:55'),(203,'default',0,'carriers/ups/debug','0','2024-12-13 14:40:55'),(204,'default',0,'carriers/ups/sort_order',NULL,'2024-12-13 14:40:55'),(205,'default',0,'carriers/usps/userid',NULL,'2024-12-13 14:40:55'),(206,'default',0,'carriers/usps/password',NULL,'2024-12-13 14:40:55'),(207,'default',0,'carriers/usps/handling_fee',NULL,'2024-12-13 14:40:55'),(208,'default',0,'carriers/usps/free_shipping_enable','0','2024-12-13 14:40:55'),(209,'default',0,'carriers/usps/specificcountry',NULL,'2024-12-13 14:40:55'),(210,'default',0,'carriers/usps/debug','0','2024-12-13 14:40:55'),(211,'default',0,'carriers/usps/showmethod','0','2024-12-13 14:40:55'),(212,'default',0,'carriers/usps/sort_order',NULL,'2024-12-13 14:40:55'),(213,'default',0,'carriers/fedex/account',NULL,'2024-12-13 14:40:55'),(214,'default',0,'carriers/fedex/api_key',NULL,'2024-12-13 14:40:55'),(215,'default',0,'carriers/fedex/secret_key',NULL,'2024-12-13 14:40:55'),(216,'default',0,'carriers/fedex/handling_fee',NULL,'2024-12-13 14:40:55'),(217,'default',0,'carriers/fedex/residence_delivery','0','2024-12-13 14:40:55'),(218,'default',0,'carriers/fedex/smartpost_hubid',NULL,'2024-12-13 14:40:55'),(219,'default',0,'carriers/fedex/free_shipping_enable','0','2024-12-13 14:40:55'),(220,'default',0,'carriers/fedex/specificcountry',NULL,'2024-12-13 14:40:55'),(221,'default',0,'carriers/fedex/debug','0','2024-12-13 14:40:55'),(222,'default',0,'carriers/fedex/showmethod','0','2024-12-13 14:40:55'),(223,'default',0,'carriers/fedex/sort_order',NULL,'2024-12-13 14:40:55'),(224,'default',0,'carriers/dhl/id',NULL,'2024-12-13 14:40:55'),(225,'default',0,'carriers/dhl/password',NULL,'2024-12-13 14:40:55'),(226,'default',0,'carriers/dhl/handling_fee',NULL,'2024-12-13 14:40:55'),(227,'default',0,'carriers/dhl/free_method_nondoc',NULL,'2024-12-13 14:40:55'),(228,'default',0,'carriers/dhl/free_shipping_enable','0','2024-12-13 14:40:55'),(229,'default',0,'carriers/dhl/specificcountry',NULL,'2024-12-13 14:40:55'),(230,'default',0,'carriers/dhl/showmethod','0','2024-12-13 14:40:55'),(231,'default',0,'carriers/dhl/debug','0','2024-12-13 14:40:55'),(232,'default',0,'carriers/dhl/sandbox_mode','0','2024-12-13 14:40:55'),(233,'default',0,'carriers/dhl/sort_order',NULL,'2024-12-13 14:40:55'),(234,'default',0,'dev/restrict/allow_ips',NULL,'2024-12-16 09:57:53'),(235,'default',0,'dev/debug/template_hints_storefront','1','2024-12-16 09:57:53'),(236,'default',0,'dev/debug/template_hints_storefront_show_with_parameter','1','2024-12-16 09:57:53'),(237,'default',0,'dev/debug/template_hints_admin','0','2024-12-16 09:57:53'),(238,'default',0,'dev/debug/template_hints_blocks','0','2024-12-16 09:57:53'),(239,'default',0,'adobe_ims/integration/logging_enabled','0','2024-12-16 09:57:53'),(240,'default',0,'dev/template/allow_symlink','0','2024-12-16 09:57:53'),(241,'default',0,'dev/translate_inline/active','0','2024-12-16 09:57:53'),(242,'default',0,'dev/translate_inline/active_admin','0','2024-12-16 09:57:53'),(243,'default',0,'mageworx_shippingrules/main/multiple_rates_price','0','2025-01-08 07:32:57'),(244,'default',0,'mageworx_shippingrules/main/shipping_per_product','1','2025-01-08 07:32:57'),(245,'default',0,'mageworx_shippingrules/validation/advanced_postcode_validation_enabled','1','2025-01-08 07:32:57'),(246,'default',0,'mageworx_shippingrules/validation/postcode_validation_excessive_valid','1','2025-01-08 07:32:57'),(247,'default',0,'mageworx_shippingrules/validation/single_address_zone_mode','0','2025-01-08 07:32:57'),(248,'default',0,'mageworx_shippingrules/validation/extended_country_select_enabled','1','2025-01-08 07:32:57'),(249,'default',0,'mageworx_shippingrules/validation/uk_postcode_conditions','1','2025-01-08 07:32:58'),(250,'default',0,'mageworx_shippingrules/validation/customer/ignore_customer_conditions_for_visitors','0','2025-01-08 07:32:58'),(251,'default',0,'mageworx_shippingrules/shipping_methods/sort_carriers','0','2025-01-08 07:32:58'),(252,'default',0,'mageworx_shippingrules/shipping_methods/display_cheapest_rate_top','0','2025-01-08 07:32:58'),(253,'default',0,'mageworx_shippingrules/shipping_methods/rates/include_tax_in_subtotal','0','2025-01-08 07:32:58'),(254,'default',0,'mageworx_shippingrules/shipping_methods/rates/max_countries','12','2025-01-08 07:32:58'),(255,'default',0,'mageworx_shippingrules/shipping_methods/rates/max_regions','12','2025-01-08 07:32:58'),(256,'default',0,'mageworx_shippingrules/popup/enabled','0','2025-01-08 07:32:58'),(257,'default',0,'mageworx_shippingrules/popup/only_address','0','2025-01-08 07:32:58'),(258,'default',0,'mageworx_shippingrules/import/use_id','1','2025-01-08 07:32:58'),(259,'default',0,'system/full_page_cache/varnish/access_list','localhost','2025-01-13 08:43:36'),(260,'default',0,'system/full_page_cache/varnish/backend_host','localhost','2025-01-13 08:43:41'),(261,'default',0,'system/full_page_cache/varnish/backend_port','8080','2025-01-13 08:50:51'),(262,'default',0,'system/full_page_cache/varnish/grace_period','300','2025-01-13 08:53:39'),(263,'websites',1,'web/unsecure/base_url','https://hyva-staging.banyo.co.uk/','2025-01-24 13:02:13'),(264,'websites',1,'web/unsecure/base_link_url','https://hyva-staging.banyo.co.uk/','2025-01-24 13:02:22'),(265,'websites',2,'web/unsecure/base_url','https://hyva-staging.premierdiy.co.uk/','2025-01-27 15:35:22'),(266,'websites',2,'web/unsecure/base_link_url','https://hyva-staging.premierdiy.co.uk/','2025-01-27 15:35:17'),(267,'websites',2,'web/secure/base_url','https://hyva-staging.premierdiy.co.uk/','2025-01-27 15:35:12'),(268,'websites',2,'web/secure/base_link_url','https://hyva-staging.premierdiy.co.uk/','2025-01-27 15:35:26'),(269,'websites',1,'web/secure/base_url','https://hyva-staging.banyo.co.uk/','2025-01-24 13:02:25'),(270,'websites',1,'web/secure/base_link_url','https://hyva-staging.banyo.co.uk/','2025-01-24 13:02:30'),(271,'stores',3,'web/unsecure/base_url','https://hyva-staging.nexus-home.com/','2025-01-27 13:27:16'),(272,'stores',3,'web/unsecure/base_link_url','https://hyva-staging.nexus-home.com/','2025-01-27 13:27:16'),(273,'default',0,'cms/wysiwyg/use_static_urls_in_catalog','1','2025-01-27 11:39:36'),(274,'default',0,'cms/pagebuilder/enabled','1','2025-01-27 11:39:36'),(275,'default',0,'cms/pagebuilder/enable_content_preview','1','2025-01-27 11:39:36'),(276,'default',0,'cms/pagebuilder/google_maps_api_key',NULL,'2025-01-27 11:39:36'),(277,'default',0,'cms/pagebuilder/google_maps_style',NULL,'2025-01-27 11:39:36'),(278,'websites',2,'web/default/cms_home_page','premier/home','2025-01-27 13:49:21'),(279,'websites',3,'web/default/cms_home_page','home/nexus','2025-01-27 13:49:51'),(280,'stores',3,'web/secure/base_url','https://hyva-staging.nexus-home.com/','2025-01-27 15:27:57'),(281,'stores',3,'web/secure/base_link_url','https://hyva-staging.nexus-home.com/','2025-01-27 15:27:57'),(282,'stores',3,'design/header/logo_src','stores/3/logo_new.png','2025-01-27 16:58:03'),(283,'stores',4,'web/unsecure/base_url','https://hyva-staging.premierdiy.co.uk/','2025-01-28 06:58:40'),(284,'stores',4,'web/unsecure/base_link_url','https://hyva-staging.premierdiy.co.uk/','2025-01-28 06:58:40'),(285,'stores',4,'web/secure/base_url','https://hyva-staging.premierdiy.co.uk/','2025-01-28 06:58:40'),(286,'stores',4,'web/secure/base_link_url','https://hyva-staging.premierdiy.co.uk/','2025-01-28 06:58:40'),(287,'stores',2,'web/unsecure/base_url','https://hyva-staging.banyo.co.uk/','2025-01-28 06:59:21'),(288,'stores',2,'web/unsecure/base_link_url','https://hyva-staging.banyo.co.uk/','2025-01-28 06:59:21'),(289,'stores',2,'web/secure/base_url','https://hyva-staging.banyo.co.uk/','2025-01-28 06:59:21'),(290,'stores',2,'web/secure/base_link_url','https://hyva-staging.banyo.co.uk/','2025-01-28 06:59:21'),(291,'stores',4,'design/header/logo_src','stores/4/Screenshot_9.png','2025-01-28 07:15:32'),(292,'default',0,'mageworx_apo/optionhealthchecker/is_valid','1','2025-01-29 12:15:16'),(293,'default',0,'admin/security/session_lifetime','31536000','2025-01-31 07:40:15'),(294,'default',0,'web/unsecure/base_static_url',NULL,'2025-01-31 09:21:58'),(295,'default',0,'web/unsecure/base_media_url',NULL,'2025-01-31 09:21:58'),(296,'default',0,'web/secure/base_static_url',NULL,'2025-01-31 09:21:58'),(297,'default',0,'web/secure/base_media_url',NULL,'2025-01-31 09:21:58'),(298,'default',0,'web/secure/enable_hsts','0','2025-01-31 09:21:58'),(299,'default',0,'web/secure/enable_upgrade_insecure','0','2025-01-31 09:21:58'),(300,'default',0,'web/default_layouts/default_product_layout','product-full-width','2025-01-31 09:21:58'),(301,'default',0,'web/default_layouts/default_category_layout','category-full-width','2025-01-31 09:21:58'),(302,'default',0,'web/default_layouts/default_cms_layout','cms-full-width','2025-01-31 09:21:58'),(303,'default',0,'web/cookie/cookie_path',NULL,'2025-01-31 09:21:58'),(304,'default',0,'web/cookie/cookie_domain',NULL,'2025-01-31 09:21:58'),(305,'default',0,'web/cookie/cookie_httponly','1','2025-01-31 09:21:58'),(306,'default',0,'system/security/max_session_size_admin','0','2025-02-01 06:31:38');
/*!40000 ALTER TABLE `core_config_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cron_schedule`
--

DROP TABLE IF EXISTS `cron_schedule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `cron_schedule` (
  `schedule_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Schedule ID',
  `job_code` varchar(255) NOT NULL DEFAULT '0' COMMENT 'Job Code',
  `status` varchar(7) NOT NULL DEFAULT 'pending' COMMENT 'Status',
  `messages` text COMMENT 'Messages',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `scheduled_at` timestamp NULL DEFAULT NULL COMMENT 'Scheduled At',
  `executed_at` timestamp NULL DEFAULT NULL COMMENT 'Executed At',
  `finished_at` timestamp NULL DEFAULT NULL COMMENT 'Finished At',
  `mpcronschedule_email_sent` tinyint(1) DEFAULT NULL COMMENT 'Mageplaza Cron Schedule Is Mail Sent',
  PRIMARY KEY (`schedule_id`),
  KEY `CRON_SCHEDULE_JOB_CODE_STATUS_SCHEDULED_AT` (`job_code`,`status`,`scheduled_at`)
) ENGINE=InnoDB AUTO_INCREMENT=380 DEFAULT CHARSET=utf8mb3 COMMENT='Cron Schedule';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cron_schedule`
--

LOCK TABLES `cron_schedule` WRITE;
/*!40000 ALTER TABLE `cron_schedule` DISABLE KEYS */;
INSERT INTO `cron_schedule` VALUES (1,'outdated_authentication_failures_cleanup','success',NULL,'2025-02-04 10:01:24','2025-02-04 10:01:00','2025-02-04 10:01:27','2025-02-04 10:01:27',NULL),(2,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:02:00',NULL,NULL,NULL),(3,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:03:00',NULL,NULL,NULL),(4,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:04:00',NULL,NULL,NULL),(5,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:05:00',NULL,NULL,NULL),(6,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:06:00',NULL,NULL,NULL),(7,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:07:00',NULL,NULL,NULL),(8,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:08:00',NULL,NULL,NULL),(9,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:09:00',NULL,NULL,NULL),(10,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:10:00',NULL,NULL,NULL),(11,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:11:00',NULL,NULL,NULL),(12,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:12:00',NULL,NULL,NULL),(13,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:13:00',NULL,NULL,NULL),(14,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:14:00',NULL,NULL,NULL),(15,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:15:00',NULL,NULL,NULL),(16,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:16:00',NULL,NULL,NULL),(17,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:17:00',NULL,NULL,NULL),(18,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:18:00',NULL,NULL,NULL),(19,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:19:00',NULL,NULL,NULL),(20,'outdated_authentication_failures_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:20:00',NULL,NULL,NULL),(21,'catalog_product_outdated_price_values_cleanup','success',NULL,'2025-02-04 10:01:24','2025-02-04 10:01:00','2025-02-04 10:01:27','2025-02-04 10:01:27',NULL),(22,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:02:00',NULL,NULL,NULL),(23,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:03:00',NULL,NULL,NULL),(24,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:04:00',NULL,NULL,NULL),(25,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:05:00',NULL,NULL,NULL),(26,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:06:00',NULL,NULL,NULL),(27,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:07:00',NULL,NULL,NULL),(28,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:08:00',NULL,NULL,NULL),(29,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:09:00',NULL,NULL,NULL),(30,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:10:00',NULL,NULL,NULL),(31,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:11:00',NULL,NULL,NULL),(32,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:12:00',NULL,NULL,NULL),(33,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:13:00',NULL,NULL,NULL),(34,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:14:00',NULL,NULL,NULL),(35,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:15:00',NULL,NULL,NULL),(36,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:16:00',NULL,NULL,NULL),(37,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:17:00',NULL,NULL,NULL),(38,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:18:00',NULL,NULL,NULL),(39,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:19:00',NULL,NULL,NULL),(40,'catalog_product_outdated_price_values_cleanup','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:20:00',NULL,NULL,NULL),(41,'catalog_product_frontend_actions_flush','success',NULL,'2025-02-04 10:01:24','2025-02-04 10:01:00','2025-02-04 10:01:27','2025-02-04 10:01:27',NULL),(42,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:02:00',NULL,NULL,NULL),(43,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:03:00',NULL,NULL,NULL),(44,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:04:00',NULL,NULL,NULL),(45,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:05:00',NULL,NULL,NULL),(46,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:06:00',NULL,NULL,NULL),(47,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:07:00',NULL,NULL,NULL),(48,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:08:00',NULL,NULL,NULL),(49,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:09:00',NULL,NULL,NULL),(50,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:10:00',NULL,NULL,NULL),(51,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:11:00',NULL,NULL,NULL),(52,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:12:00',NULL,NULL,NULL),(53,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:13:00',NULL,NULL,NULL),(54,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:14:00',NULL,NULL,NULL),(55,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:15:00',NULL,NULL,NULL),(56,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:16:00',NULL,NULL,NULL),(57,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:17:00',NULL,NULL,NULL),(58,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:18:00',NULL,NULL,NULL),(59,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:19:00',NULL,NULL,NULL),(60,'catalog_product_frontend_actions_flush','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:20:00',NULL,NULL,NULL),(61,'catalog_product_attribute_value_synchronize','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:05:00',NULL,NULL,NULL),(62,'catalog_product_attribute_value_synchronize','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:10:00',NULL,NULL,NULL),(63,'catalog_product_attribute_value_synchronize','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:15:00',NULL,NULL,NULL),(64,'catalog_product_attribute_value_synchronize','pending',NULL,'2025-02-04 10:01:24','2025-02-04 10:20:00',NULL,NULL,NULL),(65,'sales_grid_order_async_insert','success',NULL,'2025-02-04 10:01:25','2025-02-04 10:01:00','2025-02-04 10:01:27','2025-02-04 10:01:27',NULL),(66,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:02:00',NULL,NULL,NULL),(67,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:03:00',NULL,NULL,NULL),(68,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:04:00',NULL,NULL,NULL),(69,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:05:00',NULL,NULL,NULL),(70,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:06:00',NULL,NULL,NULL),(71,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:07:00',NULL,NULL,NULL),(72,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:08:00',NULL,NULL,NULL),(73,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:09:00',NULL,NULL,NULL),(74,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:10:00',NULL,NULL,NULL),(75,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:11:00',NULL,NULL,NULL),(76,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:12:00',NULL,NULL,NULL),(77,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:13:00',NULL,NULL,NULL),(78,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:14:00',NULL,NULL,NULL),(79,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:15:00',NULL,NULL,NULL),(80,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:16:00',NULL,NULL,NULL),(81,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:17:00',NULL,NULL,NULL),(82,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:18:00',NULL,NULL,NULL),(83,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:19:00',NULL,NULL,NULL),(84,'sales_grid_order_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:20:00',NULL,NULL,NULL),(85,'sales_grid_order_invoice_async_insert','success',NULL,'2025-02-04 10:01:25','2025-02-04 10:01:00','2025-02-04 10:01:27','2025-02-04 10:01:27',NULL),(86,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:02:00',NULL,NULL,NULL),(87,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:03:00',NULL,NULL,NULL),(88,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:04:00',NULL,NULL,NULL),(89,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:05:00',NULL,NULL,NULL),(90,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:06:00',NULL,NULL,NULL),(91,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:07:00',NULL,NULL,NULL),(92,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:08:00',NULL,NULL,NULL),(93,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:09:00',NULL,NULL,NULL),(94,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:10:00',NULL,NULL,NULL),(95,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:11:00',NULL,NULL,NULL),(96,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:12:00',NULL,NULL,NULL),(97,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:13:00',NULL,NULL,NULL),(98,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:14:00',NULL,NULL,NULL),(99,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:15:00',NULL,NULL,NULL),(100,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:16:00',NULL,NULL,NULL),(101,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:17:00',NULL,NULL,NULL),(102,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:18:00',NULL,NULL,NULL),(103,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:19:00',NULL,NULL,NULL),(104,'sales_grid_order_invoice_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:20:00',NULL,NULL,NULL),(105,'sales_grid_order_shipment_async_insert','success',NULL,'2025-02-04 10:01:25','2025-02-04 10:01:00','2025-02-04 10:01:27','2025-02-04 10:01:27',NULL),(106,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:02:00',NULL,NULL,NULL),(107,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:03:00',NULL,NULL,NULL),(108,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:04:00',NULL,NULL,NULL),(109,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:05:00',NULL,NULL,NULL),(110,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:06:00',NULL,NULL,NULL),(111,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:07:00',NULL,NULL,NULL),(112,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:08:00',NULL,NULL,NULL),(113,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:09:00',NULL,NULL,NULL),(114,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:10:00',NULL,NULL,NULL),(115,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:11:00',NULL,NULL,NULL),(116,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:12:00',NULL,NULL,NULL),(117,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:13:00',NULL,NULL,NULL),(118,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:14:00',NULL,NULL,NULL),(119,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:15:00',NULL,NULL,NULL),(120,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:16:00',NULL,NULL,NULL),(121,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:17:00',NULL,NULL,NULL),(122,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:18:00',NULL,NULL,NULL),(123,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:19:00',NULL,NULL,NULL),(124,'sales_grid_order_shipment_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:20:00',NULL,NULL,NULL),(125,'sales_grid_order_creditmemo_async_insert','success',NULL,'2025-02-04 10:01:25','2025-02-04 10:01:00','2025-02-04 10:01:27','2025-02-04 10:01:27',NULL),(126,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:02:00',NULL,NULL,NULL),(127,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:03:00',NULL,NULL,NULL),(128,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:04:00',NULL,NULL,NULL),(129,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:05:00',NULL,NULL,NULL),(130,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:06:00',NULL,NULL,NULL),(131,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:07:00',NULL,NULL,NULL),(132,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:08:00',NULL,NULL,NULL),(133,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:09:00',NULL,NULL,NULL),(134,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:10:00',NULL,NULL,NULL),(135,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:11:00',NULL,NULL,NULL),(136,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:12:00',NULL,NULL,NULL),(137,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:13:00',NULL,NULL,NULL),(138,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:14:00',NULL,NULL,NULL),(139,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:15:00',NULL,NULL,NULL),(140,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:16:00',NULL,NULL,NULL),(141,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:17:00',NULL,NULL,NULL),(142,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:18:00',NULL,NULL,NULL),(143,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:19:00',NULL,NULL,NULL),(144,'sales_grid_order_creditmemo_async_insert','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:20:00',NULL,NULL,NULL),(145,'sales_send_order_emails','success',NULL,'2025-02-04 10:01:25','2025-02-04 10:01:00','2025-02-04 10:01:27','2025-02-04 10:01:27',NULL),(146,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:02:00',NULL,NULL,NULL),(147,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:03:00',NULL,NULL,NULL),(148,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:04:00',NULL,NULL,NULL),(149,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:05:00',NULL,NULL,NULL),(150,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:06:00',NULL,NULL,NULL),(151,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:07:00',NULL,NULL,NULL),(152,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:08:00',NULL,NULL,NULL),(153,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:09:00',NULL,NULL,NULL),(154,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:10:00',NULL,NULL,NULL),(155,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:11:00',NULL,NULL,NULL),(156,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:12:00',NULL,NULL,NULL),(157,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:13:00',NULL,NULL,NULL),(158,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:14:00',NULL,NULL,NULL),(159,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:15:00',NULL,NULL,NULL),(160,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:16:00',NULL,NULL,NULL),(161,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:17:00',NULL,NULL,NULL),(162,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:18:00',NULL,NULL,NULL),(163,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:19:00',NULL,NULL,NULL),(164,'sales_send_order_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:20:00',NULL,NULL,NULL),(165,'sales_send_order_invoice_emails','success',NULL,'2025-02-04 10:01:25','2025-02-04 10:01:00','2025-02-04 10:01:27','2025-02-04 10:01:27',NULL),(166,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:02:00',NULL,NULL,NULL),(167,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:03:00',NULL,NULL,NULL),(168,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:04:00',NULL,NULL,NULL),(169,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:05:00',NULL,NULL,NULL),(170,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:06:00',NULL,NULL,NULL),(171,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:07:00',NULL,NULL,NULL),(172,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:08:00',NULL,NULL,NULL),(173,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:09:00',NULL,NULL,NULL),(174,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:25','2025-02-04 10:10:00',NULL,NULL,NULL),(175,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:11:00',NULL,NULL,NULL),(176,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:12:00',NULL,NULL,NULL),(177,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:13:00',NULL,NULL,NULL),(178,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:14:00',NULL,NULL,NULL),(179,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:15:00',NULL,NULL,NULL),(180,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:16:00',NULL,NULL,NULL),(181,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:17:00',NULL,NULL,NULL),(182,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:18:00',NULL,NULL,NULL),(183,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:19:00',NULL,NULL,NULL),(184,'sales_send_order_invoice_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:20:00',NULL,NULL,NULL),(185,'sales_send_order_shipment_emails','success',NULL,'2025-02-04 10:01:26','2025-02-04 10:01:00','2025-02-04 10:01:27','2025-02-04 10:01:27',NULL),(186,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:02:00',NULL,NULL,NULL),(187,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:03:00',NULL,NULL,NULL),(188,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:04:00',NULL,NULL,NULL),(189,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:05:00',NULL,NULL,NULL),(190,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:06:00',NULL,NULL,NULL),(191,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:07:00',NULL,NULL,NULL),(192,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:08:00',NULL,NULL,NULL),(193,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:09:00',NULL,NULL,NULL),(194,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:10:00',NULL,NULL,NULL),(195,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:11:00',NULL,NULL,NULL),(196,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:12:00',NULL,NULL,NULL),(197,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:13:00',NULL,NULL,NULL),(198,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:14:00',NULL,NULL,NULL),(199,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:15:00',NULL,NULL,NULL),(200,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:16:00',NULL,NULL,NULL),(201,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:17:00',NULL,NULL,NULL),(202,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:18:00',NULL,NULL,NULL),(203,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:19:00',NULL,NULL,NULL),(204,'sales_send_order_shipment_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:20:00',NULL,NULL,NULL),(205,'sales_send_order_creditmemo_emails','success',NULL,'2025-02-04 10:01:26','2025-02-04 10:01:00','2025-02-04 10:01:27','2025-02-04 10:01:27',NULL),(206,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:02:00',NULL,NULL,NULL),(207,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:03:00',NULL,NULL,NULL),(208,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:04:00',NULL,NULL,NULL),(209,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:05:00',NULL,NULL,NULL),(210,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:06:00',NULL,NULL,NULL),(211,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:07:00',NULL,NULL,NULL),(212,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:08:00',NULL,NULL,NULL),(213,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:09:00',NULL,NULL,NULL),(214,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:10:00',NULL,NULL,NULL),(215,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:11:00',NULL,NULL,NULL),(216,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:12:00',NULL,NULL,NULL),(217,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:13:00',NULL,NULL,NULL),(218,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:14:00',NULL,NULL,NULL),(219,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:15:00',NULL,NULL,NULL),(220,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:16:00',NULL,NULL,NULL),(221,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:17:00',NULL,NULL,NULL),(222,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:18:00',NULL,NULL,NULL),(223,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:19:00',NULL,NULL,NULL),(224,'sales_send_order_creditmemo_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:20:00',NULL,NULL,NULL),(225,'newsletter_send_all','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:05:00',NULL,NULL,NULL),(226,'newsletter_send_all','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:10:00',NULL,NULL,NULL),(227,'newsletter_send_all','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:15:00',NULL,NULL,NULL),(228,'newsletter_send_all','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:20:00',NULL,NULL,NULL),(229,'captcha_delete_expired_images','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:10:00',NULL,NULL,NULL),(230,'captcha_delete_expired_images','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:20:00',NULL,NULL,NULL),(231,'inventory_in_store_pickup_sales_send_order_notified_emails','success',NULL,'2025-02-04 10:01:26','2025-02-04 10:01:00','2025-02-04 10:01:28','2025-02-04 10:01:28',NULL),(232,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:02:00',NULL,NULL,NULL),(233,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:03:00',NULL,NULL,NULL),(234,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:04:00',NULL,NULL,NULL),(235,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:05:00',NULL,NULL,NULL),(236,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:06:00',NULL,NULL,NULL),(237,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:07:00',NULL,NULL,NULL),(238,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:08:00',NULL,NULL,NULL),(239,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:09:00',NULL,NULL,NULL),(240,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:10:00',NULL,NULL,NULL),(241,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:11:00',NULL,NULL,NULL),(242,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:12:00',NULL,NULL,NULL),(243,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:13:00',NULL,NULL,NULL),(244,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:14:00',NULL,NULL,NULL),(245,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:15:00',NULL,NULL,NULL),(246,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:16:00',NULL,NULL,NULL),(247,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:17:00',NULL,NULL,NULL),(248,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:18:00',NULL,NULL,NULL),(249,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:19:00',NULL,NULL,NULL),(250,'inventory_in_store_pickup_sales_send_order_notified_emails','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:20:00',NULL,NULL,NULL),(251,'magento_newrelicreporting_cron','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:02:00',NULL,NULL,NULL),(252,'magento_newrelicreporting_cron','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:04:00',NULL,NULL,NULL),(253,'magento_newrelicreporting_cron','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:06:00',NULL,NULL,NULL),(254,'magento_newrelicreporting_cron','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:08:00',NULL,NULL,NULL),(255,'magento_newrelicreporting_cron','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:10:00',NULL,NULL,NULL),(256,'magento_newrelicreporting_cron','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:12:00',NULL,NULL,NULL),(257,'magento_newrelicreporting_cron','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:14:00',NULL,NULL,NULL),(258,'magento_newrelicreporting_cron','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:16:00',NULL,NULL,NULL),(259,'magento_newrelicreporting_cron','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:18:00',NULL,NULL,NULL),(260,'magento_newrelicreporting_cron','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:20:00',NULL,NULL,NULL),(261,'bulk_cleanup','success',NULL,'2025-02-04 10:01:26','2025-02-04 10:01:00','2025-02-04 10:01:28','2025-02-04 10:01:28',NULL),(262,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:02:00',NULL,NULL,NULL),(263,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:03:00',NULL,NULL,NULL),(264,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:04:00',NULL,NULL,NULL),(265,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:05:00',NULL,NULL,NULL),(266,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:26','2025-02-04 10:06:00',NULL,NULL,NULL),(267,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:07:00',NULL,NULL,NULL),(268,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:08:00',NULL,NULL,NULL),(269,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:09:00',NULL,NULL,NULL),(270,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:10:00',NULL,NULL,NULL),(271,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:11:00',NULL,NULL,NULL),(272,'sync_order_payment_status','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:10:00',NULL,NULL,NULL),(273,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:12:00',NULL,NULL,NULL),(274,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:13:00',NULL,NULL,NULL),(275,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:14:00',NULL,NULL,NULL),(276,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:15:00',NULL,NULL,NULL),(277,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:16:00',NULL,NULL,NULL),(278,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:17:00',NULL,NULL,NULL),(279,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:18:00',NULL,NULL,NULL),(280,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:19:00',NULL,NULL,NULL),(281,'bulk_cleanup','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:20:00',NULL,NULL,NULL),(282,'bulk_mark_incomplete_operations_as_failed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:10:00',NULL,NULL,NULL),(283,'bulk_mark_incomplete_operations_as_failed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:20:00',NULL,NULL,NULL),(284,'mollie_send_pending_payment_reminders','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:05:00',NULL,NULL,NULL),(285,'mollie_send_pending_payment_reminders','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:10:00',NULL,NULL,NULL),(286,'mollie_send_pending_payment_reminders','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:15:00',NULL,NULL,NULL),(287,'mollie_send_pending_payment_reminders','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:20:00',NULL,NULL,NULL),(288,'mollie_remove_sent_payment_reminders','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:05:00',NULL,NULL,NULL),(289,'mollie_remove_sent_payment_reminders','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:10:00',NULL,NULL,NULL),(290,'mollie_remove_sent_payment_reminders','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:15:00',NULL,NULL,NULL),(291,'mollie_remove_sent_payment_reminders','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:20:00',NULL,NULL,NULL),(292,'indexer_reindex_all_invalid','success',NULL,'2025-02-04 10:01:27','2025-02-04 10:01:00','2025-02-04 10:01:27','2025-02-04 10:01:49',NULL),(293,'indexer_reindex_all_invalid','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:02:00',NULL,NULL,NULL),(294,'indexer_reindex_all_invalid','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:03:00',NULL,NULL,NULL),(295,'indexer_reindex_all_invalid','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:04:00',NULL,NULL,NULL),(296,'indexer_update_all_views','success',NULL,'2025-02-04 10:01:27','2025-02-04 10:01:00','2025-02-04 10:01:49','2025-02-04 10:01:49',NULL),(297,'indexer_update_all_views','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:02:00',NULL,NULL,NULL),(298,'indexer_update_all_views','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:03:00',NULL,NULL,NULL),(299,'indexer_update_all_views','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:04:00',NULL,NULL,NULL),(300,'submit_payment_services_order_production_feed','success',NULL,'2025-02-04 10:01:27','2025-02-04 10:01:00','2025-02-04 10:01:28','2025-02-04 10:01:28',NULL),(301,'submit_payment_services_order_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:02:00',NULL,NULL,NULL),(302,'submit_payment_services_order_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:03:00',NULL,NULL,NULL),(303,'submit_payment_services_order_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:04:00',NULL,NULL,NULL),(304,'submit_payment_services_order_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:05:00',NULL,NULL,NULL),(305,'submit_payment_services_order_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:06:00',NULL,NULL,NULL),(306,'submit_payment_services_order_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:07:00',NULL,NULL,NULL),(307,'consumers_runner','success',NULL,'2025-02-04 10:01:27','2025-02-04 10:01:00','2025-02-04 10:01:27','2025-02-04 10:01:28',NULL),(308,'submit_payment_services_order_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:08:00',NULL,NULL,NULL),(309,'submit_payment_services_order_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:09:00',NULL,NULL,NULL),(310,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:02:00',NULL,NULL,NULL),(311,'submit_payment_services_order_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:10:00',NULL,NULL,NULL),(312,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:03:00',NULL,NULL,NULL),(313,'submit_payment_services_order_sandbox_feed','success',NULL,'2025-02-04 10:01:27','2025-02-04 10:01:00','2025-02-04 10:01:28','2025-02-04 10:01:28',NULL),(314,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:04:00',NULL,NULL,NULL),(315,'submit_payment_services_order_sandbox_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:02:00',NULL,NULL,NULL),(316,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:05:00',NULL,NULL,NULL),(317,'submit_payment_services_order_sandbox_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:03:00',NULL,NULL,NULL),(318,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:06:00',NULL,NULL,NULL),(319,'submit_payment_services_order_sandbox_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:04:00',NULL,NULL,NULL),(320,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:07:00',NULL,NULL,NULL),(321,'submit_payment_services_order_sandbox_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:05:00',NULL,NULL,NULL),(322,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:08:00',NULL,NULL,NULL),(323,'submit_payment_services_order_sandbox_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:06:00',NULL,NULL,NULL),(324,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:09:00',NULL,NULL,NULL),(325,'submit_payment_services_order_sandbox_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:07:00',NULL,NULL,NULL),(326,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:10:00',NULL,NULL,NULL),(327,'submit_payment_services_order_sandbox_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:08:00',NULL,NULL,NULL),(328,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:11:00',NULL,NULL,NULL),(329,'submit_payment_services_order_sandbox_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:09:00',NULL,NULL,NULL),(330,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:12:00',NULL,NULL,NULL),(331,'submit_payment_services_order_sandbox_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:10:00',NULL,NULL,NULL),(332,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:13:00',NULL,NULL,NULL),(333,'submit_payment_services_order_status_production_feed','success',NULL,'2025-02-04 10:01:27','2025-02-04 10:01:00','2025-02-04 10:01:28','2025-02-04 10:01:28',NULL),(334,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:14:00',NULL,NULL,NULL),(335,'submit_payment_services_order_status_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:02:00',NULL,NULL,NULL),(336,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:15:00',NULL,NULL,NULL),(337,'submit_payment_services_order_status_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:03:00',NULL,NULL,NULL),(338,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:16:00',NULL,NULL,NULL),(339,'submit_payment_services_order_status_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:04:00',NULL,NULL,NULL),(340,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:17:00',NULL,NULL,NULL),(341,'submit_payment_services_order_status_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:05:00',NULL,NULL,NULL),(342,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:18:00',NULL,NULL,NULL),(343,'submit_payment_services_order_status_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:06:00',NULL,NULL,NULL),(344,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:19:00',NULL,NULL,NULL),(345,'submit_payment_services_order_status_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:07:00',NULL,NULL,NULL),(346,'consumers_runner','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:20:00',NULL,NULL,NULL),(347,'submit_payment_services_order_status_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:08:00',NULL,NULL,NULL),(348,'submit_payment_services_order_status_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:09:00',NULL,NULL,NULL),(349,'submit_payment_services_order_status_production_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:10:00',NULL,NULL,NULL),(350,'submit_payment_services_order_status_sandbox_feed','success',NULL,'2025-02-04 10:01:27','2025-02-04 10:01:00','2025-02-04 10:01:28','2025-02-04 10:01:28',NULL),(351,'submit_payment_services_order_status_sandbox_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:02:00',NULL,NULL,NULL),(352,'submit_payment_services_order_status_sandbox_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:03:00',NULL,NULL,NULL),(353,'submit_payment_services_order_status_sandbox_feed','pending',NULL,'2025-02-04 10:01:27','2025-02-04 10:04:00',NULL,NULL,NULL),(354,'submit_payment_services_order_status_sandbox_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:05:00',NULL,NULL,NULL),(355,'submit_payment_services_order_status_sandbox_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:06:00',NULL,NULL,NULL),(356,'submit_payment_services_order_status_sandbox_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:07:00',NULL,NULL,NULL),(357,'submit_payment_services_order_status_sandbox_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:08:00',NULL,NULL,NULL),(358,'submit_payment_services_order_status_sandbox_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:09:00',NULL,NULL,NULL),(359,'submit_payment_services_order_status_sandbox_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:10:00',NULL,NULL,NULL),(360,'submit_payment_services_store_production_feed','success',NULL,'2025-02-04 10:01:28','2025-02-04 10:01:00','2025-02-04 10:01:28','2025-02-04 10:01:28',NULL),(361,'submit_payment_services_store_production_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:02:00',NULL,NULL,NULL),(362,'submit_payment_services_store_production_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:03:00',NULL,NULL,NULL),(363,'submit_payment_services_store_production_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:04:00',NULL,NULL,NULL),(364,'submit_payment_services_store_production_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:05:00',NULL,NULL,NULL),(365,'submit_payment_services_store_production_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:06:00',NULL,NULL,NULL),(366,'submit_payment_services_store_production_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:07:00',NULL,NULL,NULL),(367,'submit_payment_services_store_production_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:08:00',NULL,NULL,NULL),(368,'submit_payment_services_store_production_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:09:00',NULL,NULL,NULL),(369,'submit_payment_services_store_production_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:10:00',NULL,NULL,NULL),(370,'submit_payment_services_store_sandbox_feed','success',NULL,'2025-02-04 10:01:28','2025-02-04 10:01:00','2025-02-04 10:01:28','2025-02-04 10:01:28',NULL),(371,'submit_payment_services_store_sandbox_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:02:00',NULL,NULL,NULL),(372,'submit_payment_services_store_sandbox_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:03:00',NULL,NULL,NULL),(373,'submit_payment_services_store_sandbox_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:04:00',NULL,NULL,NULL),(374,'submit_payment_services_store_sandbox_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:05:00',NULL,NULL,NULL),(375,'submit_payment_services_store_sandbox_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:06:00',NULL,NULL,NULL),(376,'submit_payment_services_store_sandbox_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:07:00',NULL,NULL,NULL),(377,'submit_payment_services_store_sandbox_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:08:00',NULL,NULL,NULL),(378,'submit_payment_services_store_sandbox_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:09:00',NULL,NULL,NULL),(379,'submit_payment_services_store_sandbox_feed','pending',NULL,'2025-02-04 10:01:28','2025-02-04 10:10:00',NULL,NULL,NULL);
/*!40000 ALTER TABLE `cron_schedule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_address_entity`
--

DROP TABLE IF EXISTS `customer_address_entity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_address_entity` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment ID',
  `parent_id` int unsigned DEFAULT NULL COMMENT 'Parent ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `is_active` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Is Active',
  `city` varchar(255) NOT NULL COMMENT 'City',
  `company` varchar(255) DEFAULT NULL COMMENT 'Company',
  `country_id` varchar(255) NOT NULL COMMENT 'Country',
  `fax` varchar(255) DEFAULT NULL COMMENT 'Fax',
  `firstname` varchar(255) NOT NULL COMMENT 'First Name',
  `lastname` varchar(255) NOT NULL COMMENT 'Last Name',
  `middlename` varchar(255) DEFAULT NULL COMMENT 'Middle Name',
  `postcode` varchar(255) DEFAULT NULL COMMENT 'Zip/Postal Code',
  `prefix` varchar(40) DEFAULT NULL COMMENT 'Name Prefix',
  `region` varchar(255) DEFAULT NULL COMMENT 'State/Province',
  `region_id` int unsigned DEFAULT NULL COMMENT 'State/Province',
  `street` text NOT NULL COMMENT 'Street Address',
  `suffix` varchar(40) DEFAULT NULL COMMENT 'Name Suffix',
  `telephone` varchar(255) NOT NULL COMMENT 'Phone Number',
  `vat_id` varchar(255) DEFAULT NULL COMMENT 'VAT number',
  `vat_is_valid` int unsigned DEFAULT NULL COMMENT 'VAT number validity',
  `vat_request_date` varchar(255) DEFAULT NULL COMMENT 'VAT number validation request date',
  `vat_request_id` varchar(255) DEFAULT NULL COMMENT 'VAT number validation request ID',
  `vat_request_success` int unsigned DEFAULT NULL COMMENT 'VAT number validation request success',
  PRIMARY KEY (`entity_id`),
  KEY `CUSTOMER_ADDRESS_ENTITY_PARENT_ID` (`parent_id`),
  CONSTRAINT `CUSTOMER_ADDRESS_ENTITY_PARENT_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`parent_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Customer Address Entity';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_address_entity`
--

LOCK TABLES `customer_address_entity` WRITE;
/*!40000 ALTER TABLE `customer_address_entity` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer_address_entity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_address_entity_datetime`
--

DROP TABLE IF EXISTS `customer_address_entity_datetime`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_address_entity_datetime` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` datetime DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CUSTOMER_ADDRESS_ENTITY_DATETIME_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`),
  KEY `CUSTOMER_ADDRESS_ENTITY_DATETIME_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CUSTOMER_ADDRESS_ENTITY_DATETIME_ENTITY_ID_ATTRIBUTE_ID_VALUE` (`entity_id`,`attribute_id`,`value`),
  CONSTRAINT `CSTR_ADDR_ENTT_DTIME_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CSTR_ADDR_ENTT_DTIME_ENTT_ID_CSTR_ADDR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `customer_address_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Customer Address Entity Datetime';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_address_entity_datetime`
--

LOCK TABLES `customer_address_entity_datetime` WRITE;
/*!40000 ALTER TABLE `customer_address_entity_datetime` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer_address_entity_datetime` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_address_entity_decimal`
--

DROP TABLE IF EXISTS `customer_address_entity_decimal`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_address_entity_decimal` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CUSTOMER_ADDRESS_ENTITY_DECIMAL_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`),
  KEY `CUSTOMER_ADDRESS_ENTITY_DECIMAL_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CUSTOMER_ADDRESS_ENTITY_DECIMAL_ENTITY_ID_ATTRIBUTE_ID_VALUE` (`entity_id`,`attribute_id`,`value`),
  CONSTRAINT `CSTR_ADDR_ENTT_DEC_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CSTR_ADDR_ENTT_DEC_ENTT_ID_CSTR_ADDR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `customer_address_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Customer Address Entity Decimal';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_address_entity_decimal`
--

LOCK TABLES `customer_address_entity_decimal` WRITE;
/*!40000 ALTER TABLE `customer_address_entity_decimal` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer_address_entity_decimal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_address_entity_int`
--

DROP TABLE IF EXISTS `customer_address_entity_int`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_address_entity_int` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` int NOT NULL DEFAULT '0' COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CUSTOMER_ADDRESS_ENTITY_INT_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`),
  KEY `CUSTOMER_ADDRESS_ENTITY_INT_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CUSTOMER_ADDRESS_ENTITY_INT_ENTITY_ID_ATTRIBUTE_ID_VALUE` (`entity_id`,`attribute_id`,`value`),
  CONSTRAINT `CSTR_ADDR_ENTT_INT_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CSTR_ADDR_ENTT_INT_ENTT_ID_CSTR_ADDR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `customer_address_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Customer Address Entity Int';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_address_entity_int`
--

LOCK TABLES `customer_address_entity_int` WRITE;
/*!40000 ALTER TABLE `customer_address_entity_int` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer_address_entity_int` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_address_entity_text`
--

DROP TABLE IF EXISTS `customer_address_entity_text`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_address_entity_text` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` text NOT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CUSTOMER_ADDRESS_ENTITY_TEXT_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`),
  KEY `CUSTOMER_ADDRESS_ENTITY_TEXT_ATTRIBUTE_ID` (`attribute_id`),
  CONSTRAINT `CSTR_ADDR_ENTT_TEXT_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CSTR_ADDR_ENTT_TEXT_ENTT_ID_CSTR_ADDR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `customer_address_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Customer Address Entity Text';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_address_entity_text`
--

LOCK TABLES `customer_address_entity_text` WRITE;
/*!40000 ALTER TABLE `customer_address_entity_text` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer_address_entity_text` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_address_entity_varchar`
--

DROP TABLE IF EXISTS `customer_address_entity_varchar`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_address_entity_varchar` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CUSTOMER_ADDRESS_ENTITY_VARCHAR_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`),
  KEY `CUSTOMER_ADDRESS_ENTITY_VARCHAR_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CUSTOMER_ADDRESS_ENTITY_VARCHAR_ENTITY_ID_ATTRIBUTE_ID_VALUE` (`entity_id`,`attribute_id`,`value`),
  CONSTRAINT `CSTR_ADDR_ENTT_VCHR_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CSTR_ADDR_ENTT_VCHR_ENTT_ID_CSTR_ADDR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `customer_address_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Customer Address Entity Varchar';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_address_entity_varchar`
--

LOCK TABLES `customer_address_entity_varchar` WRITE;
/*!40000 ALTER TABLE `customer_address_entity_varchar` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer_address_entity_varchar` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_dummy_cl`
--

DROP TABLE IF EXISTS `customer_dummy_cl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_dummy_cl` (
  `version_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Version ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  PRIMARY KEY (`version_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='customer_dummy_cl';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_dummy_cl`
--

LOCK TABLES `customer_dummy_cl` WRITE;
/*!40000 ALTER TABLE `customer_dummy_cl` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer_dummy_cl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_eav_attribute`
--

DROP TABLE IF EXISTS `customer_eav_attribute`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_eav_attribute` (
  `attribute_id` smallint unsigned NOT NULL COMMENT 'Attribute ID',
  `is_visible` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Is Visible',
  `input_filter` varchar(255) DEFAULT NULL COMMENT 'Input Filter',
  `multiline_count` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Multiline Count',
  `validate_rules` text COMMENT 'Validate Rules',
  `is_system` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is System',
  `sort_order` int unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `data_model` varchar(255) DEFAULT NULL COMMENT 'Data Model',
  `is_used_in_grid` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Used in Grid',
  `is_visible_in_grid` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Visible in Grid',
  `is_filterable_in_grid` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Filterable in Grid',
  `is_searchable_in_grid` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Searchable in Grid',
  `grid_filter_condition_type` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Grid Filter Condition Type',
  PRIMARY KEY (`attribute_id`),
  KEY `CUSTOMER_EAV_ATTRIBUTE_SORT_ORDER` (`sort_order`),
  CONSTRAINT `CUSTOMER_EAV_ATTRIBUTE_ATTRIBUTE_ID_EAV_ATTRIBUTE_ATTRIBUTE_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Customer Eav Attribute';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_eav_attribute`
--

LOCK TABLES `customer_eav_attribute` WRITE;
/*!40000 ALTER TABLE `customer_eav_attribute` DISABLE KEYS */;
INSERT INTO `customer_eav_attribute` VALUES (1,1,NULL,0,NULL,1,10,NULL,1,1,1,0,0),(2,0,NULL,0,NULL,1,0,NULL,0,0,0,0,0),(3,1,NULL,0,NULL,1,20,NULL,1,1,0,1,0),(4,0,NULL,0,NULL,0,30,NULL,0,0,0,0,0),(5,1,'trim',0,'{\"max_text_length\":255,\"min_text_length\":1}',1,40,NULL,0,0,0,0,0),(6,0,'trim',0,NULL,0,50,NULL,0,0,0,0,0),(7,1,'trim',0,'{\"max_text_length\":255,\"min_text_length\":1}',1,60,NULL,0,0,0,0,0),(8,0,NULL,0,NULL,0,70,NULL,0,0,0,0,0),(9,1,NULL,0,'{\"input_validation\":\"email\"}',1,80,NULL,1,1,1,1,0),(10,1,NULL,0,NULL,1,25,NULL,1,1,1,0,0),(11,0,'date',0,'{\"input_validation\":\"date\"}',0,90,NULL,1,1,1,0,0),(12,0,NULL,0,NULL,1,0,NULL,0,0,0,0,0),(13,0,NULL,0,NULL,1,0,NULL,0,0,0,0,0),(14,0,NULL,0,'{\"input_validation\":\"date\"}',1,0,NULL,0,0,0,0,0),(15,0,NULL,0,NULL,1,0,NULL,0,0,0,0,0),(16,0,NULL,0,NULL,1,0,NULL,0,0,0,0,0),(17,0,NULL,0,'{\"max_text_length\":255}',0,100,NULL,1,1,0,1,0),(18,0,NULL,0,NULL,1,0,NULL,1,1,1,0,0),(19,0,NULL,0,NULL,0,0,NULL,1,1,1,0,0),(20,0,NULL,0,'[]',0,110,NULL,1,1,1,0,0),(21,1,NULL,0,NULL,1,28,NULL,0,0,0,0,0),(22,0,NULL,0,NULL,0,10,NULL,0,0,0,0,0),(23,1,'trim',0,'{\"max_text_length\":255,\"min_text_length\":1}',1,20,NULL,1,0,0,1,0),(24,0,'trim',0,NULL,0,30,NULL,0,0,0,0,0),(25,1,'trim',0,'{\"max_text_length\":255,\"min_text_length\":1}',1,40,NULL,1,0,0,1,0),(26,0,NULL,0,NULL,0,50,NULL,0,0,0,0,0),(27,1,NULL,0,'{\"max_text_length\":255,\"min_text_length\":1}',1,60,NULL,1,0,0,1,0),(28,1,NULL,2,'{\"max_text_length\":255,\"min_text_length\":1}',1,70,NULL,1,0,0,1,0),(29,1,NULL,0,'{\"max_text_length\":255,\"min_text_length\":1}',1,100,NULL,1,0,0,1,0),(30,1,NULL,0,NULL,1,80,NULL,1,1,1,0,0),(31,1,NULL,0,NULL,1,90,NULL,1,1,0,1,0),(32,1,NULL,0,NULL,1,90,NULL,0,0,0,0,0),(33,1,NULL,0,'[]',1,110,'Magento\\Customer\\Model\\Attribute\\Data\\Postcode',1,1,1,1,0),(34,1,NULL,0,'{\"max_text_length\":255,\"min_text_length\":1}',1,120,NULL,1,1,1,1,0),(35,0,NULL,0,'{\"max_text_length\":255,\"min_text_length\":1}',0,130,NULL,1,0,0,1,0),(36,1,NULL,0,NULL,1,140,NULL,0,0,0,0,0),(37,0,NULL,0,NULL,1,0,NULL,0,0,0,0,0),(38,0,NULL,0,NULL,1,0,NULL,0,0,0,0,0),(39,0,NULL,0,NULL,1,0,NULL,0,0,0,0,0),(40,0,NULL,0,NULL,1,0,NULL,0,0,0,0,0),(41,0,NULL,0,NULL,0,0,NULL,0,0,0,0,0),(42,0,NULL,0,NULL,1,0,NULL,0,0,0,0,0),(43,0,NULL,0,NULL,1,0,NULL,0,0,0,0,0),(44,0,NULL,0,NULL,1,0,NULL,0,0,0,0,0),(157,0,NULL,0,NULL,0,90,NULL,0,0,0,0,0);
/*!40000 ALTER TABLE `customer_eav_attribute` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_eav_attribute_website`
--

DROP TABLE IF EXISTS `customer_eav_attribute_website`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_eav_attribute_website` (
  `attribute_id` smallint unsigned NOT NULL COMMENT 'Attribute ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `is_visible` smallint unsigned DEFAULT NULL COMMENT 'Is Visible',
  `is_required` smallint unsigned DEFAULT NULL COMMENT 'Is Required',
  `default_value` text COMMENT 'Default Value',
  `multiline_count` smallint unsigned DEFAULT NULL COMMENT 'Multiline Count',
  PRIMARY KEY (`attribute_id`,`website_id`),
  KEY `CUSTOMER_EAV_ATTRIBUTE_WEBSITE_WEBSITE_ID` (`website_id`),
  CONSTRAINT `CSTR_EAV_ATTR_WS_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CSTR_EAV_ATTR_WS_WS_ID_STORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Customer Eav Attribute Website';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_eav_attribute_website`
--

LOCK TABLES `customer_eav_attribute_website` WRITE;
/*!40000 ALTER TABLE `customer_eav_attribute_website` DISABLE KEYS */;
INSERT INTO `customer_eav_attribute_website` VALUES (1,1,NULL,NULL,NULL,NULL),(3,1,NULL,NULL,NULL,NULL),(5,1,NULL,NULL,NULL,NULL),(6,1,NULL,NULL,NULL,NULL),(7,1,NULL,NULL,NULL,NULL),(9,1,NULL,NULL,NULL,NULL),(10,1,NULL,NULL,NULL,NULL),(11,1,NULL,NULL,NULL,NULL),(17,1,NULL,NULL,NULL,NULL),(18,1,NULL,NULL,NULL,NULL),(19,1,NULL,NULL,NULL,NULL),(20,1,NULL,NULL,NULL,NULL),(21,1,NULL,NULL,NULL,NULL),(23,1,NULL,NULL,NULL,NULL),(24,1,NULL,NULL,NULL,NULL),(25,1,NULL,NULL,NULL,NULL),(27,1,NULL,NULL,NULL,NULL),(28,1,NULL,NULL,NULL,NULL),(29,1,NULL,NULL,NULL,NULL),(30,1,NULL,NULL,NULL,NULL),(31,1,NULL,NULL,NULL,NULL),(32,1,NULL,NULL,NULL,NULL),(33,1,NULL,NULL,NULL,NULL),(34,1,NULL,NULL,NULL,NULL),(35,1,NULL,NULL,NULL,NULL),(36,1,NULL,NULL,NULL,NULL),(157,1,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `customer_eav_attribute_website` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_entity`
--

DROP TABLE IF EXISTS `customer_entity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_entity` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `website_id` smallint unsigned DEFAULT NULL COMMENT 'Website ID',
  `email` varchar(255) DEFAULT NULL COMMENT 'Email',
  `group_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Group ID',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment ID',
  `store_id` smallint unsigned DEFAULT '0' COMMENT 'Store ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `is_active` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Is Active',
  `disable_auto_group_change` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Disable automatic group change based on VAT ID',
  `created_in` varchar(255) DEFAULT NULL COMMENT 'Created From',
  `prefix` varchar(40) DEFAULT NULL COMMENT 'Name Prefix',
  `firstname` varchar(255) DEFAULT NULL COMMENT 'First Name',
  `middlename` varchar(255) DEFAULT NULL COMMENT 'Middle Name/Initial',
  `lastname` varchar(255) DEFAULT NULL COMMENT 'Last Name',
  `suffix` varchar(40) DEFAULT NULL COMMENT 'Name Suffix',
  `dob` date DEFAULT NULL COMMENT 'Date of Birth',
  `password_hash` varchar(128) DEFAULT NULL COMMENT 'Password_hash',
  `rp_token` varchar(128) DEFAULT NULL COMMENT 'Reset password token',
  `rp_token_created_at` datetime DEFAULT NULL COMMENT 'Reset password token creation time',
  `default_billing` int unsigned DEFAULT NULL COMMENT 'Default Billing Address',
  `default_shipping` int unsigned DEFAULT NULL COMMENT 'Default Shipping Address',
  `taxvat` varchar(50) DEFAULT NULL COMMENT 'Tax/VAT Number',
  `confirmation` varchar(64) DEFAULT NULL COMMENT 'Is Confirmed',
  `gender` smallint unsigned DEFAULT NULL COMMENT 'Gender',
  `failures_num` smallint DEFAULT '0' COMMENT 'Failure Number',
  `first_failure` timestamp NULL DEFAULT NULL COMMENT 'First Failure',
  `lock_expires` timestamp NULL DEFAULT NULL COMMENT 'Lock Expiration Date',
  `session_cutoff` timestamp NULL DEFAULT NULL COMMENT 'Session Cutoff Time',
  `mp_smtp_email_marketing_synced` smallint DEFAULT '0' COMMENT 'Mp SMTP Email Marketing synced',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `CUSTOMER_ENTITY_EMAIL_WEBSITE_ID` (`email`,`website_id`),
  KEY `CUSTOMER_ENTITY_STORE_ID` (`store_id`),
  KEY `CUSTOMER_ENTITY_WEBSITE_ID` (`website_id`),
  KEY `CUSTOMER_ENTITY_FIRSTNAME` (`firstname`),
  KEY `CUSTOMER_ENTITY_LASTNAME` (`lastname`),
  CONSTRAINT `CUSTOMER_ENTITY_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL,
  CONSTRAINT `CUSTOMER_ENTITY_WEBSITE_ID_STORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE SET NULL
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COMMENT='customer_entity';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_entity`
--

LOCK TABLES `customer_entity` WRITE;
/*!40000 ALTER TABLE `customer_entity` DISABLE KEYS */;
INSERT INTO `customer_entity` VALUES (1,1,'sishamsingh999@gmail.com',1,NULL,1,'2024-09-18 08:50:23','2024-11-12 09:35:06',1,0,'Default Store View',NULL,'sisham',NULL,'singh',NULL,NULL,'4a67288ec52029c48cf205cceccd6d47ada1be66afbc72aece217d0ec456b9ba:8JHcMTsN413YE7Wy1pqQBeF5Kx79YpaR:3_32_2_67108864','0:3:Nemb3+d390yhjlThFhhCfg7DlFxYJ4jfwpqaUhMI3yVMwCFOVvbPAuNg4k9FF8Fz7BI0mOMN1EzubMAi','2024-09-18 08:50:23',NULL,NULL,NULL,NULL,NULL,5,'2024-11-05 10:31:46',NULL,NULL,0);
/*!40000 ALTER TABLE `customer_entity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_entity_datetime`
--

DROP TABLE IF EXISTS `customer_entity_datetime`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_entity_datetime` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` datetime DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CUSTOMER_ENTITY_DATETIME_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`),
  KEY `CUSTOMER_ENTITY_DATETIME_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CUSTOMER_ENTITY_DATETIME_ENTITY_ID_ATTRIBUTE_ID_VALUE` (`entity_id`,`attribute_id`,`value`),
  CONSTRAINT `CUSTOMER_ENTITY_DATETIME_ATTRIBUTE_ID_EAV_ATTRIBUTE_ATTRIBUTE_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CUSTOMER_ENTITY_DATETIME_ENTITY_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Customer Entity Datetime';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_entity_datetime`
--

LOCK TABLES `customer_entity_datetime` WRITE;
/*!40000 ALTER TABLE `customer_entity_datetime` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer_entity_datetime` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_entity_decimal`
--

DROP TABLE IF EXISTS `customer_entity_decimal`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_entity_decimal` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CUSTOMER_ENTITY_DECIMAL_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`),
  KEY `CUSTOMER_ENTITY_DECIMAL_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CUSTOMER_ENTITY_DECIMAL_ENTITY_ID_ATTRIBUTE_ID_VALUE` (`entity_id`,`attribute_id`,`value`),
  CONSTRAINT `CUSTOMER_ENTITY_DECIMAL_ATTRIBUTE_ID_EAV_ATTRIBUTE_ATTRIBUTE_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CUSTOMER_ENTITY_DECIMAL_ENTITY_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Customer Entity Decimal';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_entity_decimal`
--

LOCK TABLES `customer_entity_decimal` WRITE;
/*!40000 ALTER TABLE `customer_entity_decimal` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer_entity_decimal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_entity_int`
--

DROP TABLE IF EXISTS `customer_entity_int`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_entity_int` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` int NOT NULL DEFAULT '0' COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CUSTOMER_ENTITY_INT_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`),
  KEY `CUSTOMER_ENTITY_INT_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CUSTOMER_ENTITY_INT_ENTITY_ID_ATTRIBUTE_ID_VALUE` (`entity_id`,`attribute_id`,`value`),
  CONSTRAINT `CUSTOMER_ENTITY_INT_ATTRIBUTE_ID_EAV_ATTRIBUTE_ATTRIBUTE_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CUSTOMER_ENTITY_INT_ENTITY_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Customer Entity Int';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_entity_int`
--

LOCK TABLES `customer_entity_int` WRITE;
/*!40000 ALTER TABLE `customer_entity_int` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer_entity_int` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_entity_text`
--

DROP TABLE IF EXISTS `customer_entity_text`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_entity_text` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` text NOT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CUSTOMER_ENTITY_TEXT_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`),
  KEY `CUSTOMER_ENTITY_TEXT_ATTRIBUTE_ID` (`attribute_id`),
  CONSTRAINT `CUSTOMER_ENTITY_TEXT_ATTRIBUTE_ID_EAV_ATTRIBUTE_ATTRIBUTE_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CUSTOMER_ENTITY_TEXT_ENTITY_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Customer Entity Text';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_entity_text`
--

LOCK TABLES `customer_entity_text` WRITE;
/*!40000 ALTER TABLE `customer_entity_text` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer_entity_text` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_entity_varchar`
--

DROP TABLE IF EXISTS `customer_entity_varchar`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_entity_varchar` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `CUSTOMER_ENTITY_VARCHAR_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`),
  KEY `CUSTOMER_ENTITY_VARCHAR_ATTRIBUTE_ID` (`attribute_id`),
  KEY `CUSTOMER_ENTITY_VARCHAR_ENTITY_ID_ATTRIBUTE_ID_VALUE` (`entity_id`,`attribute_id`,`value`),
  CONSTRAINT `CUSTOMER_ENTITY_VARCHAR_ATTRIBUTE_ID_EAV_ATTRIBUTE_ATTRIBUTE_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `CUSTOMER_ENTITY_VARCHAR_ENTITY_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Customer Entity Varchar';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_entity_varchar`
--

LOCK TABLES `customer_entity_varchar` WRITE;
/*!40000 ALTER TABLE `customer_entity_varchar` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer_entity_varchar` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_form_attribute`
--

DROP TABLE IF EXISTS `customer_form_attribute`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_form_attribute` (
  `form_code` varchar(32) NOT NULL COMMENT 'Form Code',
  `attribute_id` smallint unsigned NOT NULL COMMENT 'Attribute ID',
  PRIMARY KEY (`form_code`,`attribute_id`),
  KEY `CUSTOMER_FORM_ATTRIBUTE_ATTRIBUTE_ID` (`attribute_id`),
  CONSTRAINT `CUSTOMER_FORM_ATTRIBUTE_ATTRIBUTE_ID_EAV_ATTRIBUTE_ATTRIBUTE_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Customer Form Attribute';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_form_attribute`
--

LOCK TABLES `customer_form_attribute` WRITE;
/*!40000 ALTER TABLE `customer_form_attribute` DISABLE KEYS */;
INSERT INTO `customer_form_attribute` VALUES ('adminhtml_customer',1),('adminhtml_customer',3),('adminhtml_customer',4),('customer_account_create',4),('customer_account_edit',4),('adminhtml_customer',5),('customer_account_create',5),('customer_account_edit',5),('adminhtml_customer',6),('customer_account_create',6),('customer_account_edit',6),('adminhtml_customer',7),('customer_account_create',7),('customer_account_edit',7),('adminhtml_customer',8),('customer_account_create',8),('customer_account_edit',8),('adminhtml_checkout',9),('adminhtml_customer',9),('customer_account_create',9),('customer_account_edit',9),('adminhtml_checkout',10),('adminhtml_customer',10),('adminhtml_checkout',11),('adminhtml_customer',11),('customer_account_create',11),('customer_account_edit',11),('adminhtml_checkout',17),('adminhtml_customer',17),('customer_account_create',17),('customer_account_edit',17),('adminhtml_customer',19),('customer_account_create',19),('customer_account_edit',19),('adminhtml_checkout',20),('adminhtml_customer',20),('customer_account_create',20),('customer_account_edit',20),('adminhtml_customer',21),('adminhtml_customer_address',22),('customer_address_edit',22),('customer_register_address',22),('adminhtml_customer_address',23),('customer_address_edit',23),('customer_register_address',23),('adminhtml_customer_address',24),('customer_address_edit',24),('customer_register_address',24),('adminhtml_customer_address',25),('customer_address_edit',25),('customer_register_address',25),('adminhtml_customer_address',26),('customer_address_edit',26),('customer_register_address',26),('adminhtml_customer_address',27),('customer_address_edit',27),('customer_register_address',27),('adminhtml_customer_address',28),('customer_address_edit',28),('customer_register_address',28),('adminhtml_customer_address',29),('customer_address_edit',29),('customer_register_address',29),('adminhtml_customer_address',30),('customer_address_edit',30),('customer_register_address',30),('adminhtml_customer_address',31),('customer_address_edit',31),('customer_register_address',31),('adminhtml_customer_address',32),('customer_address_edit',32),('customer_register_address',32),('adminhtml_customer_address',33),('customer_address_edit',33),('customer_register_address',33),('adminhtml_customer_address',34),('customer_address_edit',34),('customer_register_address',34),('adminhtml_customer_address',35),('customer_address_edit',35),('customer_register_address',35),('adminhtml_customer_address',36),('customer_address_edit',36),('customer_register_address',36),('adminhtml_customer',157);
/*!40000 ALTER TABLE `customer_form_attribute` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_grid_flat`
--

DROP TABLE IF EXISTS `customer_grid_flat`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_grid_flat` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `name` text COMMENT 'Name',
  `email` varchar(255) DEFAULT NULL COMMENT 'Email',
  `group_id` int DEFAULT NULL COMMENT 'Group_id',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created_at',
  `website_id` int DEFAULT NULL COMMENT 'Website_id',
  `confirmation` varchar(255) DEFAULT NULL COMMENT 'Confirmation',
  `created_in` text COMMENT 'Created_in',
  `dob` date DEFAULT NULL COMMENT 'Dob',
  `gender` int DEFAULT NULL COMMENT 'Gender',
  `taxvat` varchar(255) DEFAULT NULL COMMENT 'Taxvat',
  `lock_expires` timestamp NULL DEFAULT NULL COMMENT 'Lock_expires',
  `shipping_full` text COMMENT 'Shipping_full',
  `billing_full` text COMMENT 'Billing_full',
  `billing_firstname` varchar(255) DEFAULT NULL COMMENT 'Billing_firstname',
  `billing_lastname` varchar(255) DEFAULT NULL COMMENT 'Billing_lastname',
  `billing_telephone` varchar(255) DEFAULT NULL COMMENT 'Billing_telephone',
  `billing_postcode` varchar(255) DEFAULT NULL COMMENT 'Billing_postcode',
  `billing_country_id` varchar(255) DEFAULT NULL COMMENT 'Billing_country_id',
  `billing_region` varchar(255) DEFAULT NULL COMMENT 'Billing_region',
  `billing_region_id` int DEFAULT NULL COMMENT 'Billing_region_id',
  `billing_street` varchar(255) DEFAULT NULL COMMENT 'Billing_street',
  `billing_city` varchar(255) DEFAULT NULL COMMENT 'Billing_city',
  `billing_fax` varchar(255) DEFAULT NULL COMMENT 'Billing_fax',
  `billing_vat_id` varchar(255) DEFAULT NULL COMMENT 'Billing_vat_id',
  `billing_company` varchar(255) DEFAULT NULL COMMENT 'Billing_company',
  PRIMARY KEY (`entity_id`),
  KEY `CUSTOMER_GRID_FLAT_GROUP_ID` (`group_id`),
  KEY `CUSTOMER_GRID_FLAT_CREATED_AT` (`created_at`),
  KEY `CUSTOMER_GRID_FLAT_WEBSITE_ID` (`website_id`),
  KEY `CUSTOMER_GRID_FLAT_CONFIRMATION` (`confirmation`),
  KEY `CUSTOMER_GRID_FLAT_DOB` (`dob`),
  KEY `CUSTOMER_GRID_FLAT_GENDER` (`gender`),
  KEY `CUSTOMER_GRID_FLAT_BILLING_COUNTRY_ID` (`billing_country_id`),
  FULLTEXT KEY `FTI_8746F705702DD5F6D45B8C7CE7FE9F2F` (`name`,`email`,`created_in`,`taxvat`,`shipping_full`,`billing_full`,`billing_firstname`,`billing_lastname`,`billing_telephone`,`billing_postcode`,`billing_region`,`billing_city`,`billing_fax`,`billing_company`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='customer_grid_flat';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_grid_flat`
--

LOCK TABLES `customer_grid_flat` WRITE;
/*!40000 ALTER TABLE `customer_grid_flat` DISABLE KEYS */;
INSERT INTO `customer_grid_flat` VALUES (1,'sisham singh','sishamsingh999@gmail.com',1,'2024-09-18 08:50:23',1,NULL,'Default Store View',NULL,NULL,NULL,NULL,'','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `customer_grid_flat` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_group`
--

DROP TABLE IF EXISTS `customer_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_group` (
  `customer_group_id` int unsigned NOT NULL AUTO_INCREMENT,
  `customer_group_code` varchar(32) NOT NULL COMMENT 'Customer Group Code',
  `tax_class_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Tax Class ID',
  PRIMARY KEY (`customer_group_id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COMMENT='Customer Group';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_group`
--

LOCK TABLES `customer_group` WRITE;
/*!40000 ALTER TABLE `customer_group` DISABLE KEYS */;
INSERT INTO `customer_group` VALUES (0,'NOT LOGGED IN',3),(1,'General',3),(2,'Wholesale',3),(3,'Retailer',3);
/*!40000 ALTER TABLE `customer_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_group_excluded_website`
--

DROP TABLE IF EXISTS `customer_group_excluded_website`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_group_excluded_website` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT,
  `customer_group_id` int unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Excluded Website ID from Customer Group',
  PRIMARY KEY (`entity_id`),
  KEY `CUSTOMER_GROUP_EXCLUDED_WEBSITE_CUSTOMER_GROUP_ID_WEBSITE_ID` (`customer_group_id`,`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Excluded Websites From Customer Group';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_group_excluded_website`
--

LOCK TABLES `customer_group_excluded_website` WRITE;
/*!40000 ALTER TABLE `customer_group_excluded_website` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer_group_excluded_website` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_log`
--

DROP TABLE IF EXISTS `customer_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_log` (
  `log_id` int NOT NULL AUTO_INCREMENT COMMENT 'Log ID',
  `customer_id` int NOT NULL COMMENT 'Customer ID',
  `last_login_at` timestamp NULL DEFAULT NULL COMMENT 'Last Login Time',
  `last_logout_at` timestamp NULL DEFAULT NULL COMMENT 'Last Logout Time',
  PRIMARY KEY (`log_id`),
  UNIQUE KEY `CUSTOMER_LOG_CUSTOMER_ID` (`customer_id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb3 COMMENT='Customer Log Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_log`
--

LOCK TABLES `customer_log` WRITE;
/*!40000 ALTER TABLE `customer_log` DISABLE KEYS */;
INSERT INTO `customer_log` VALUES (1,1,'2024-11-05 05:48:06',NULL);
/*!40000 ALTER TABLE `customer_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_visitor`
--

DROP TABLE IF EXISTS `customer_visitor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `customer_visitor` (
  `visitor_id` bigint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Visitor ID',
  `customer_id` int DEFAULT NULL COMMENT 'Customer ID',
  `session_id` varchar(1) DEFAULT NULL COMMENT 'Deprecated: Session ID value no longer used',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `last_visit_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Last Visit Time',
  PRIMARY KEY (`visitor_id`),
  KEY `CUSTOMER_VISITOR_CUSTOMER_ID` (`customer_id`),
  KEY `CUSTOMER_VISITOR_LAST_VISIT_AT` (`last_visit_at`)
) ENGINE=InnoDB AUTO_INCREMENT=3141 DEFAULT CHARSET=utf8mb3 COMMENT='Visitor Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_visitor`
--

LOCK TABLES `customer_visitor` WRITE;
/*!40000 ALTER TABLE `customer_visitor` DISABLE KEYS */;
INSERT INTO `customer_visitor` VALUES (1,NULL,NULL,'2024-08-05 16:52:14','2024-08-05 16:52:14'),(2,NULL,NULL,'2024-08-05 18:45:37','2024-08-05 18:45:37'),(3,NULL,NULL,'2024-08-05 19:45:54','2024-08-05 19:45:54'),(4,NULL,NULL,'2024-08-05 19:45:55','2024-08-05 19:45:55'),(5,NULL,NULL,'2024-08-05 20:07:54','2024-08-05 20:07:54'),(6,NULL,NULL,'2024-08-06 11:04:07','2024-08-06 11:04:07'),(7,NULL,NULL,'2024-08-07 06:45:46','2024-08-07 06:45:46'),(8,NULL,NULL,'2024-08-07 13:13:03','2024-08-07 13:13:03'),(9,NULL,NULL,'2024-08-07 13:24:08','2024-08-07 13:24:08'),(10,NULL,NULL,'2024-08-07 13:41:43','2024-08-07 13:41:43'),(11,NULL,NULL,'2024-08-08 09:48:39','2024-08-08 09:48:39'),(12,NULL,NULL,'2024-08-08 09:49:45','2024-08-08 09:49:45'),(13,NULL,NULL,'2024-08-08 09:59:48','2024-08-08 09:59:48'),(14,NULL,NULL,'2024-08-09 05:12:42','2024-08-09 05:12:42'),(15,NULL,NULL,'2024-08-09 05:39:55','2024-08-09 05:39:55'),(16,NULL,NULL,'2024-08-09 08:10:23','2024-08-09 08:10:23'),(17,NULL,NULL,'2024-08-09 08:17:44','2024-08-09 08:17:44'),(18,NULL,NULL,'2024-08-09 12:58:10','2024-08-09 12:58:10'),(19,NULL,NULL,'2024-08-11 14:06:02','2024-08-11 14:06:02'),(20,NULL,NULL,'2024-08-11 14:10:41','2024-08-11 14:10:41'),(21,NULL,NULL,'2024-08-11 23:42:24','2024-08-11 23:42:24'),(22,NULL,NULL,'2024-08-12 08:31:50','2024-08-12 08:31:50'),(23,NULL,NULL,'2024-08-12 08:33:15','2024-08-12 08:33:15'),(24,NULL,NULL,'2024-08-12 08:42:03','2024-08-12 08:42:03'),(25,NULL,NULL,'2024-08-12 08:46:30','2024-08-12 08:46:30'),(26,NULL,NULL,'2024-08-12 09:02:09','2024-08-12 09:02:09'),(27,NULL,NULL,'2024-08-12 09:09:22','2024-08-12 09:09:22'),(28,NULL,NULL,'2024-08-12 09:10:06','2024-08-12 09:10:06'),(29,NULL,NULL,'2024-08-12 09:21:23','2024-08-12 09:21:23'),(30,NULL,NULL,'2024-08-12 11:36:16','2024-08-12 11:36:16'),(31,NULL,NULL,'2024-08-12 11:42:30','2024-08-12 11:42:30'),(32,NULL,NULL,'2024-08-12 13:14:21','2024-08-12 13:14:21'),(33,NULL,NULL,'2024-08-12 13:17:37','2024-08-12 13:17:37'),(34,NULL,NULL,'2024-08-12 13:17:54','2024-08-12 13:17:54'),(35,NULL,NULL,'2024-08-12 13:20:33','2024-08-12 13:20:34'),(36,NULL,NULL,'2024-08-12 14:02:09','2024-08-12 14:02:09'),(37,NULL,NULL,'2024-08-13 01:14:50','2024-08-13 01:14:50'),(38,NULL,NULL,'2024-08-13 12:24:36','2024-08-13 12:24:36'),(39,NULL,NULL,'2024-08-13 12:26:34','2024-08-13 12:26:34'),(40,NULL,NULL,'2024-08-13 12:31:20','2024-08-13 12:31:20'),(41,NULL,NULL,'2024-08-13 12:34:02','2024-08-13 12:34:02'),(42,NULL,NULL,'2024-08-13 12:49:30','2024-08-13 12:49:30'),(43,NULL,NULL,'2024-08-13 12:53:09','2024-08-13 12:53:09'),(44,NULL,NULL,'2024-08-13 12:55:55','2024-08-13 12:55:55'),(45,NULL,NULL,'2024-08-13 12:56:36','2024-08-13 12:56:36'),(46,NULL,NULL,'2024-08-13 12:58:58','2024-08-13 12:58:58'),(47,NULL,NULL,'2024-08-13 13:03:42','2024-08-13 13:03:42'),(48,NULL,NULL,'2024-08-13 13:04:41','2024-08-13 13:04:42'),(49,NULL,NULL,'2024-08-13 13:10:11','2024-08-13 13:10:11'),(50,NULL,NULL,'2024-08-13 13:12:19','2024-08-13 13:12:19'),(51,NULL,NULL,'2024-08-13 13:13:11','2024-08-13 13:13:11'),(52,NULL,NULL,'2024-08-13 13:15:10','2024-08-13 13:15:10'),(53,NULL,NULL,'2024-08-13 13:16:52','2024-08-13 13:16:52'),(54,NULL,NULL,'2024-08-13 13:18:27','2024-08-13 13:18:27'),(55,NULL,NULL,'2024-08-13 13:19:40','2024-08-13 13:19:40'),(56,NULL,NULL,'2024-08-13 13:22:57','2024-08-13 13:22:57'),(57,NULL,NULL,'2024-08-13 13:35:00','2024-08-13 13:35:00'),(58,NULL,NULL,'2024-08-13 13:35:33','2024-08-13 13:35:33'),(59,NULL,NULL,'2024-08-13 13:47:16','2024-08-13 13:47:16'),(60,NULL,NULL,'2024-08-13 13:52:14','2024-08-13 13:52:14'),(61,NULL,NULL,'2024-08-13 14:18:45','2024-08-13 14:18:45'),(62,NULL,NULL,'2024-08-13 14:18:45','2024-08-13 14:18:45'),(63,NULL,NULL,'2024-08-13 14:21:16','2024-08-13 14:21:16'),(64,NULL,NULL,'2024-08-13 14:27:01','2024-08-13 14:27:01'),(65,NULL,NULL,'2024-08-13 14:31:50','2024-08-13 14:31:50'),(66,NULL,NULL,'2024-08-13 14:51:26','2024-08-13 14:51:26'),(67,NULL,NULL,'2024-08-13 15:06:29','2024-08-13 15:06:29'),(68,NULL,NULL,'2024-08-13 15:21:34','2024-08-13 15:21:34'),(69,NULL,NULL,'2024-08-13 15:46:02','2024-08-13 15:46:02'),(70,NULL,NULL,'2024-08-14 14:28:09','2024-08-14 14:28:09'),(71,NULL,NULL,'2024-08-15 06:02:17','2024-08-15 06:02:17'),(72,NULL,NULL,'2024-08-15 06:55:50','2024-08-15 06:55:50'),(73,NULL,NULL,'2024-08-15 07:00:48','2024-08-15 07:00:48'),(74,NULL,NULL,'2024-08-15 07:23:49','2024-08-15 07:23:49'),(75,NULL,NULL,'2024-08-15 07:29:16','2024-08-15 07:29:16'),(76,NULL,NULL,'2024-08-15 07:37:09','2024-08-15 07:37:09'),(77,NULL,NULL,'2024-08-15 07:44:13','2024-08-15 07:44:13'),(78,NULL,NULL,'2024-08-15 07:46:51','2024-08-15 07:46:51'),(79,NULL,NULL,'2024-08-15 08:00:45','2024-08-15 08:00:45'),(80,NULL,NULL,'2024-08-15 08:33:37','2024-08-15 08:33:37'),(81,NULL,NULL,'2024-08-15 08:51:54','2024-08-15 08:51:54'),(82,NULL,NULL,'2024-08-15 09:17:58','2024-08-15 09:17:58'),(83,NULL,NULL,'2024-08-15 09:18:19','2024-08-15 09:18:19'),(84,NULL,NULL,'2024-08-15 09:19:28','2024-08-15 09:19:29'),(85,NULL,NULL,'2024-08-15 09:20:00','2024-08-15 09:20:00'),(86,NULL,NULL,'2024-08-15 09:30:08','2024-08-15 09:30:08'),(87,NULL,NULL,'2024-08-15 09:31:16','2024-08-15 09:31:16'),(88,NULL,NULL,'2024-08-15 09:33:35','2024-08-15 09:33:35'),(89,NULL,NULL,'2024-08-15 09:34:48','2024-08-15 09:34:48'),(90,NULL,NULL,'2024-08-15 09:35:56','2024-08-15 09:35:56'),(91,NULL,NULL,'2024-08-15 09:55:09','2024-08-15 09:55:09'),(92,NULL,NULL,'2024-08-15 09:56:12','2024-08-15 09:56:12'),(93,NULL,NULL,'2024-08-15 10:02:55','2024-08-15 10:02:55'),(94,NULL,NULL,'2024-08-15 10:04:59','2024-08-15 10:04:59'),(95,NULL,NULL,'2024-08-15 10:05:36','2024-08-15 10:05:36'),(96,NULL,NULL,'2024-08-15 10:06:48','2024-08-15 10:06:48'),(97,NULL,NULL,'2024-08-15 10:10:37','2024-08-15 10:10:37'),(98,NULL,NULL,'2024-08-15 10:33:16','2024-08-15 10:33:16'),(99,NULL,NULL,'2024-08-15 10:40:23','2024-08-15 10:40:23'),(100,NULL,NULL,'2024-08-15 10:41:51','2024-08-15 10:41:51'),(101,NULL,NULL,'2024-08-15 10:45:14','2024-08-15 10:45:14'),(102,NULL,NULL,'2024-08-15 10:52:25','2024-08-15 10:52:25'),(103,NULL,NULL,'2024-08-15 10:54:10','2024-08-15 10:54:10'),(104,NULL,NULL,'2024-08-15 11:13:19','2024-08-15 11:13:19'),(105,NULL,NULL,'2024-08-15 11:20:54','2024-08-15 11:20:54'),(106,NULL,NULL,'2024-08-15 11:26:03','2024-08-15 11:26:03'),(107,NULL,NULL,'2024-08-15 11:34:00','2024-08-15 11:34:00'),(108,NULL,NULL,'2024-08-15 11:36:38','2024-08-15 11:36:38'),(109,NULL,NULL,'2024-08-15 11:52:26','2024-08-15 11:52:26'),(110,NULL,NULL,'2024-08-15 11:57:20','2024-08-15 11:57:20'),(111,NULL,NULL,'2024-08-15 11:59:18','2024-08-15 11:59:18'),(112,NULL,NULL,'2024-08-15 12:01:01','2024-08-15 12:01:01'),(113,NULL,NULL,'2024-08-15 12:03:51','2024-08-15 12:03:51'),(114,NULL,NULL,'2024-08-15 12:04:26','2024-08-15 12:04:26'),(115,NULL,NULL,'2024-08-15 12:42:54','2024-08-15 12:42:54'),(116,NULL,NULL,'2024-08-15 12:58:01','2024-08-15 12:58:01'),(117,NULL,NULL,'2024-08-15 13:17:38','2024-08-15 13:17:38'),(118,NULL,NULL,'2024-08-15 13:32:48','2024-08-15 13:32:48'),(119,NULL,NULL,'2024-08-15 13:54:12','2024-08-15 13:54:12'),(120,NULL,NULL,'2024-08-15 14:17:01','2024-08-15 14:17:01'),(121,NULL,NULL,'2024-08-15 14:46:51','2024-08-15 14:46:51'),(122,NULL,NULL,'2024-08-15 15:02:52','2024-08-15 15:02:52'),(123,NULL,NULL,'2024-08-15 15:19:20','2024-08-15 15:19:20'),(124,NULL,NULL,'2024-08-15 15:34:22','2024-08-15 15:34:22'),(125,NULL,NULL,'2024-08-15 22:23:12','2024-08-15 22:23:12'),(126,NULL,NULL,'2024-08-16 06:53:37','2024-08-16 06:53:37'),(127,NULL,NULL,'2024-08-16 07:24:52','2024-08-16 07:24:52'),(128,NULL,NULL,'2024-08-16 07:26:05','2024-08-16 07:26:06'),(129,NULL,NULL,'2024-08-16 07:31:16','2024-08-16 07:31:16'),(130,NULL,NULL,'2024-08-16 07:49:18','2024-08-16 07:49:18'),(131,NULL,NULL,'2024-08-16 07:58:41','2024-08-16 07:58:41'),(132,NULL,NULL,'2024-08-16 08:00:58','2024-08-16 08:00:58'),(133,NULL,NULL,'2024-08-16 08:09:38','2024-08-16 08:09:38'),(134,NULL,NULL,'2024-08-16 08:10:39','2024-08-16 08:10:39'),(135,NULL,NULL,'2024-08-16 08:11:10','2024-08-16 08:11:10'),(136,NULL,NULL,'2024-08-16 09:59:09','2024-08-16 09:59:09'),(137,NULL,NULL,'2024-08-16 10:15:18','2024-08-16 10:15:18'),(138,NULL,NULL,'2024-08-16 10:31:41','2024-08-16 10:31:41'),(139,NULL,NULL,'2024-08-16 10:44:13','2024-08-16 10:44:13'),(140,NULL,NULL,'2024-08-16 10:52:52','2024-08-16 10:52:53'),(141,NULL,NULL,'2024-08-16 10:55:30','2024-08-16 10:55:30'),(142,NULL,NULL,'2024-08-16 10:58:51','2024-08-16 10:58:51'),(143,NULL,NULL,'2024-08-16 11:00:19','2024-08-16 11:00:19'),(144,NULL,NULL,'2024-08-16 11:02:23','2024-08-16 11:02:23'),(145,NULL,NULL,'2024-08-16 11:13:41','2024-08-16 11:13:41'),(146,NULL,NULL,'2024-08-16 11:28:08','2024-08-16 11:28:08'),(147,NULL,NULL,'2024-08-16 11:30:27','2024-08-16 11:30:27'),(148,NULL,NULL,'2024-08-16 11:32:10','2024-08-16 11:32:10'),(149,NULL,NULL,'2024-08-16 11:34:47','2024-08-16 11:34:47'),(150,NULL,NULL,'2024-08-16 11:37:33','2024-08-16 11:37:33'),(151,NULL,NULL,'2024-08-16 11:47:54','2024-08-16 11:47:54'),(152,NULL,NULL,'2024-08-16 11:50:42','2024-08-16 11:50:42'),(153,NULL,NULL,'2024-08-16 11:56:59','2024-08-16 11:56:59'),(154,NULL,NULL,'2024-08-16 11:59:21','2024-08-16 11:59:21'),(155,NULL,NULL,'2024-08-16 12:00:58','2024-08-16 12:00:58'),(156,NULL,NULL,'2024-08-16 12:03:56','2024-08-16 12:03:56'),(157,NULL,NULL,'2024-08-16 12:07:17','2024-08-16 12:07:17'),(158,NULL,NULL,'2024-08-16 12:53:34','2024-08-16 12:53:34'),(159,NULL,NULL,'2024-08-16 13:09:14','2024-08-16 13:09:14'),(160,NULL,NULL,'2024-08-16 14:27:17','2024-08-16 14:27:18'),(161,NULL,NULL,'2024-08-16 14:50:48','2024-08-16 14:50:48'),(162,NULL,NULL,'2024-08-16 15:18:02','2024-08-16 15:18:02'),(163,NULL,NULL,'2024-08-17 03:47:48','2024-08-17 03:47:48'),(164,NULL,NULL,'2024-08-17 06:42:53','2024-08-17 06:42:53'),(165,NULL,NULL,'2024-08-17 22:47:17','2024-08-17 22:47:17'),(166,NULL,NULL,'2024-08-18 23:35:28','2024-08-18 23:35:28'),(167,NULL,NULL,'2024-08-19 00:29:50','2024-08-19 00:29:50'),(168,NULL,NULL,'2024-08-19 01:52:51','2024-08-19 01:52:51'),(169,NULL,NULL,'2024-08-19 02:07:34','2024-08-19 02:07:34'),(170,NULL,NULL,'2024-08-19 08:57:46','2024-08-19 08:57:47'),(171,NULL,NULL,'2024-08-19 09:14:46','2024-08-19 09:14:46'),(172,NULL,NULL,'2024-08-19 09:16:52','2024-08-19 09:16:52'),(173,NULL,NULL,'2024-08-19 09:17:08','2024-08-19 09:17:08'),(174,NULL,NULL,'2024-08-19 09:21:37','2024-08-19 09:21:37'),(175,NULL,NULL,'2024-08-19 09:48:31','2024-08-19 09:48:31'),(176,NULL,NULL,'2024-08-19 09:54:15','2024-08-19 09:54:15'),(177,NULL,NULL,'2024-08-19 10:05:12','2024-08-19 10:05:12'),(178,NULL,NULL,'2024-08-19 10:17:46','2024-08-19 10:17:46'),(179,NULL,NULL,'2024-08-19 10:35:56','2024-08-19 10:35:56'),(180,NULL,NULL,'2024-08-19 10:51:19','2024-08-19 10:51:19'),(181,NULL,NULL,'2024-08-19 11:14:40','2024-08-19 11:14:40'),(182,NULL,NULL,'2024-08-19 11:29:42','2024-08-19 11:29:42'),(183,NULL,NULL,'2024-08-19 12:05:06','2024-08-19 12:05:07'),(184,NULL,NULL,'2024-08-19 12:45:47','2024-08-19 12:45:47'),(185,NULL,NULL,'2024-08-19 12:45:49','2024-08-19 12:45:49'),(186,NULL,NULL,'2024-08-19 12:45:51','2024-08-19 12:45:51'),(187,NULL,NULL,'2024-08-19 13:51:06','2024-08-19 13:51:07'),(188,NULL,NULL,'2024-08-19 14:55:14','2024-08-19 14:55:14'),(189,NULL,NULL,'2024-08-19 15:06:58','2024-08-19 15:06:58'),(190,NULL,NULL,'2024-08-19 15:24:22','2024-08-19 15:24:22'),(191,NULL,NULL,'2024-08-19 15:42:31','2024-08-19 15:42:31'),(192,NULL,NULL,'2024-08-19 16:09:49','2024-08-19 16:09:49'),(193,NULL,NULL,'2024-08-20 01:22:18','2024-08-20 01:22:18'),(194,NULL,NULL,'2024-08-20 05:26:47','2024-08-20 05:26:47'),(195,NULL,NULL,'2024-08-20 05:40:50','2024-08-20 05:40:50'),(196,NULL,NULL,'2024-08-20 05:55:53','2024-08-20 05:55:53'),(197,NULL,NULL,'2024-08-20 06:10:32','2024-08-20 06:10:32'),(198,NULL,NULL,'2024-08-20 06:26:47','2024-08-20 06:26:47'),(199,NULL,NULL,'2024-08-20 06:27:35','2024-08-20 06:27:35'),(200,NULL,NULL,'2024-08-20 06:31:35','2024-08-20 06:31:35'),(201,NULL,NULL,'2024-08-20 06:46:13','2024-08-20 06:46:13'),(202,NULL,NULL,'2024-08-20 07:05:51','2024-08-20 07:05:51'),(203,NULL,NULL,'2024-08-20 07:18:40','2024-08-20 07:18:40'),(204,NULL,NULL,'2024-08-20 07:35:11','2024-08-20 07:35:11'),(205,NULL,NULL,'2024-08-20 07:38:10','2024-08-20 07:38:10'),(206,NULL,NULL,'2024-08-20 07:44:09','2024-08-20 07:44:09'),(207,NULL,NULL,'2024-08-20 07:48:53','2024-08-20 07:48:53'),(208,NULL,NULL,'2024-08-20 07:58:31','2024-08-20 07:58:31'),(209,NULL,NULL,'2024-08-20 07:59:16','2024-08-20 07:59:16'),(210,NULL,NULL,'2024-08-20 08:06:29','2024-08-20 08:06:29'),(211,NULL,NULL,'2024-08-20 08:15:21','2024-08-20 08:15:21'),(212,NULL,NULL,'2024-08-20 08:17:23','2024-08-20 08:17:23'),(213,NULL,NULL,'2024-08-20 08:24:26','2024-08-20 08:24:26'),(214,NULL,NULL,'2024-08-20 08:34:01','2024-08-20 08:34:01'),(215,NULL,NULL,'2024-08-20 09:19:05','2024-08-20 09:19:05'),(216,NULL,NULL,'2024-08-20 09:20:54','2024-08-20 09:20:54'),(217,NULL,NULL,'2024-08-20 09:43:06','2024-08-20 09:43:06'),(218,NULL,NULL,'2024-08-20 10:00:08','2024-08-20 10:00:08'),(219,NULL,NULL,'2024-08-20 10:15:28','2024-08-20 10:15:28'),(220,NULL,NULL,'2024-08-20 10:30:43','2024-08-20 10:30:43'),(221,NULL,NULL,'2024-08-20 10:33:25','2024-08-20 10:33:25'),(222,NULL,NULL,'2024-08-20 10:42:07','2024-08-20 10:42:07'),(223,NULL,NULL,'2024-08-20 10:52:36','2024-08-20 10:52:36'),(224,NULL,NULL,'2024-08-20 11:02:14','2024-08-20 11:02:14'),(225,NULL,NULL,'2024-08-20 11:12:52','2024-08-20 11:12:52'),(226,NULL,NULL,'2024-08-20 11:18:36','2024-08-20 11:18:37'),(227,NULL,NULL,'2024-08-20 11:25:45','2024-08-20 11:25:46'),(228,NULL,NULL,'2024-08-20 11:40:51','2024-08-20 11:40:51'),(229,NULL,NULL,'2024-08-20 12:04:52','2024-08-20 12:04:52'),(230,NULL,NULL,'2024-08-20 12:43:18','2024-08-20 12:43:18'),(231,NULL,NULL,'2024-08-20 12:58:49','2024-08-20 12:58:49'),(232,NULL,NULL,'2024-08-20 13:12:42','2024-08-20 13:12:42'),(233,NULL,NULL,'2024-08-20 14:13:59','2024-08-20 14:13:59'),(234,NULL,NULL,'2024-08-20 14:36:43','2024-08-20 14:36:43'),(235,NULL,NULL,'2024-08-20 15:08:02','2024-08-20 15:08:02'),(236,NULL,NULL,'2024-08-20 15:23:14','2024-08-20 15:23:14'),(237,NULL,NULL,'2024-08-20 15:38:43','2024-08-20 15:38:43'),(238,NULL,NULL,'2024-08-20 16:07:21','2024-08-20 16:07:21'),(239,NULL,NULL,'2024-08-20 16:25:13','2024-08-20 16:25:13'),(240,NULL,NULL,'2024-08-20 19:31:43','2024-08-20 19:31:43'),(241,NULL,NULL,'2024-08-20 19:31:51','2024-08-20 19:31:51'),(242,NULL,NULL,'2024-08-21 05:19:06','2024-08-21 05:19:06'),(243,NULL,NULL,'2024-08-21 06:20:06','2024-08-21 06:20:06'),(244,NULL,NULL,'2024-08-21 06:27:24','2024-08-21 06:27:24'),(245,NULL,NULL,'2024-08-21 06:45:41','2024-08-21 06:45:41'),(246,NULL,NULL,'2024-08-21 06:58:07','2024-08-21 06:58:07'),(247,NULL,NULL,'2024-08-21 07:02:47','2024-08-21 07:02:47'),(248,NULL,NULL,'2024-08-21 07:16:22','2024-08-21 07:16:22'),(249,NULL,NULL,'2024-08-21 07:45:39','2024-08-21 07:45:39'),(250,NULL,NULL,'2024-08-21 07:51:24','2024-08-21 07:51:24'),(251,NULL,NULL,'2024-08-21 07:52:21','2024-08-21 07:52:21'),(252,NULL,NULL,'2024-08-21 08:07:13','2024-08-21 08:07:13'),(253,NULL,NULL,'2024-08-21 08:11:14','2024-08-21 08:11:14'),(254,NULL,NULL,'2024-08-21 08:39:08','2024-08-21 08:39:08'),(255,NULL,NULL,'2024-08-21 09:10:59','2024-08-21 09:10:59'),(256,NULL,NULL,'2024-08-21 09:51:01','2024-08-21 09:51:01'),(257,NULL,NULL,'2024-08-21 10:03:36','2024-08-21 10:03:36'),(258,NULL,NULL,'2024-08-21 10:07:53','2024-08-21 10:07:53'),(259,NULL,NULL,'2024-08-21 10:13:43','2024-08-21 10:13:43'),(260,NULL,NULL,'2024-08-21 10:29:23','2024-08-21 10:29:23'),(261,NULL,NULL,'2024-08-21 10:35:15','2024-08-21 10:35:15'),(262,NULL,NULL,'2024-08-21 10:44:35','2024-08-21 10:44:35'),(263,NULL,NULL,'2024-08-21 10:45:24','2024-08-21 10:45:24'),(264,NULL,NULL,'2024-08-21 11:02:06','2024-08-21 11:02:06'),(265,NULL,NULL,'2024-08-21 11:07:20','2024-08-21 11:07:20'),(266,NULL,NULL,'2024-08-21 11:09:26','2024-08-21 11:09:26'),(267,NULL,NULL,'2024-08-21 11:23:47','2024-08-21 11:23:47'),(268,NULL,NULL,'2024-08-21 11:24:03','2024-08-21 11:24:03'),(269,NULL,NULL,'2024-08-21 11:39:12','2024-08-21 11:39:12'),(270,NULL,NULL,'2024-08-21 11:45:06','2024-08-21 11:45:06'),(271,NULL,NULL,'2024-08-21 11:52:58','2024-08-21 11:52:58'),(272,NULL,NULL,'2024-08-21 12:02:36','2024-08-21 12:02:36'),(273,NULL,NULL,'2024-08-21 12:05:34','2024-08-21 12:05:34'),(274,NULL,NULL,'2024-08-21 13:08:45','2024-08-21 13:08:45'),(275,NULL,NULL,'2024-08-21 15:39:21','2024-08-21 15:39:21'),(276,NULL,NULL,'2024-08-21 16:10:41','2024-08-21 16:10:41'),(277,NULL,NULL,'2024-08-22 00:36:25','2024-08-22 00:36:25'),(278,NULL,NULL,'2024-08-22 05:30:07','2024-08-22 05:30:07'),(279,NULL,NULL,'2024-08-22 05:45:43','2024-08-22 05:45:43'),(280,NULL,NULL,'2024-08-22 06:02:37','2024-08-22 06:02:37'),(281,NULL,NULL,'2024-08-22 06:22:38','2024-08-22 06:22:38'),(282,NULL,NULL,'2024-08-22 06:25:49','2024-08-22 06:25:49'),(283,NULL,NULL,'2024-08-22 06:35:25','2024-08-22 06:35:25'),(284,NULL,NULL,'2024-08-22 06:47:02','2024-08-22 06:47:02'),(285,NULL,NULL,'2024-08-22 06:47:35','2024-08-22 06:47:36'),(286,NULL,NULL,'2024-08-22 06:49:09','2024-08-22 06:49:09'),(287,NULL,NULL,'2024-08-22 07:12:29','2024-08-22 07:12:29'),(288,NULL,NULL,'2024-08-22 07:14:06','2024-08-22 07:35:17'),(289,NULL,NULL,'2024-08-22 07:20:02','2024-08-22 07:20:02'),(290,NULL,NULL,'2024-08-22 07:29:46','2024-08-22 07:29:46'),(291,NULL,NULL,'2024-08-22 07:35:13','2024-08-22 07:35:13'),(292,NULL,NULL,'2024-08-22 07:50:21','2024-08-22 07:50:21'),(293,NULL,NULL,'2024-08-22 08:05:23','2024-08-22 08:05:23'),(294,NULL,NULL,'2024-08-22 08:06:09','2024-08-22 08:06:09'),(295,NULL,NULL,'2024-08-22 08:07:37','2024-08-22 08:07:37'),(296,NULL,NULL,'2024-08-22 08:23:41','2024-08-22 08:23:41'),(297,NULL,NULL,'2024-08-22 08:29:00','2024-08-22 08:29:00'),(298,NULL,NULL,'2024-08-22 08:35:31','2024-08-22 08:35:32'),(299,NULL,NULL,'2024-08-22 09:06:26','2024-08-22 09:06:26'),(300,NULL,NULL,'2024-08-22 09:31:52','2024-08-22 09:31:52'),(301,NULL,NULL,'2024-08-22 09:40:57','2024-08-22 09:40:58'),(302,NULL,NULL,'2024-08-22 09:42:35','2024-08-22 09:42:35'),(303,NULL,NULL,'2024-08-22 09:50:32','2024-08-22 09:50:32'),(304,NULL,NULL,'2024-08-22 10:05:23','2024-08-22 10:05:23'),(305,NULL,NULL,'2024-08-22 10:05:23','2024-08-22 10:05:23'),(306,NULL,NULL,'2024-08-22 10:05:56','2024-08-22 10:05:56'),(307,NULL,NULL,'2024-08-22 10:17:08','2024-08-22 10:17:08'),(308,NULL,NULL,'2024-08-22 10:33:24','2024-08-22 10:33:24'),(309,NULL,NULL,'2024-08-22 10:34:03','2024-08-22 10:34:03'),(310,NULL,NULL,'2024-08-22 10:34:16','2024-08-22 10:34:16'),(311,NULL,NULL,'2024-08-22 10:34:43','2024-08-22 10:34:43'),(312,NULL,NULL,'2024-08-22 10:39:24','2024-08-22 10:39:24'),(313,NULL,NULL,'2024-08-22 10:43:57','2024-08-22 10:43:57'),(314,NULL,NULL,'2024-08-22 10:47:35','2024-08-22 10:47:35'),(315,NULL,NULL,'2024-08-22 10:54:31','2024-08-22 10:54:31'),(316,NULL,NULL,'2024-08-22 11:00:53','2024-08-22 11:00:53'),(317,NULL,NULL,'2024-08-22 11:06:30','2024-08-22 11:06:30'),(318,NULL,NULL,'2024-08-22 11:09:13','2024-08-22 11:09:13'),(319,NULL,NULL,'2024-08-22 11:12:13','2024-08-22 11:12:13'),(320,NULL,NULL,'2024-08-22 11:18:26','2024-08-22 11:18:26'),(321,NULL,NULL,'2024-08-22 11:24:44','2024-08-22 11:24:44'),(322,NULL,NULL,'2024-08-22 11:36:19','2024-08-22 11:36:19'),(323,NULL,NULL,'2024-08-22 13:13:00','2024-08-22 13:13:00'),(324,NULL,NULL,'2024-08-22 13:39:29','2024-08-22 13:39:29'),(325,NULL,NULL,'2024-08-22 14:24:30','2024-08-22 14:24:30'),(326,NULL,NULL,'2024-08-22 14:41:10','2024-08-22 14:41:10'),(327,NULL,NULL,'2024-08-22 14:56:53','2024-08-22 14:56:53'),(328,NULL,NULL,'2024-08-22 15:15:43','2024-08-22 15:15:43'),(329,NULL,NULL,'2024-08-22 15:31:21','2024-08-22 15:31:21'),(330,NULL,NULL,'2024-08-22 15:46:23','2024-08-22 15:46:23'),(331,NULL,NULL,'2024-08-22 16:14:06','2024-08-22 16:14:06'),(332,NULL,NULL,'2024-08-22 16:29:47','2024-08-22 16:29:47'),(333,NULL,NULL,'2024-08-22 16:50:07','2024-08-22 16:50:07'),(334,NULL,NULL,'2024-08-23 01:34:21','2024-08-23 01:34:21'),(335,NULL,NULL,'2024-08-23 04:17:25','2024-08-23 04:17:25'),(336,NULL,NULL,'2024-08-23 05:51:45','2024-08-23 05:51:45'),(337,NULL,NULL,'2024-08-23 06:06:46','2024-08-23 06:06:46'),(338,NULL,NULL,'2024-08-23 06:35:56','2024-08-23 06:35:56'),(339,NULL,NULL,'2024-08-23 06:50:56','2024-08-23 06:50:56'),(340,NULL,NULL,'2024-08-23 07:30:20','2024-08-23 07:30:20'),(341,NULL,NULL,'2024-08-23 07:47:31','2024-08-23 07:47:31'),(342,NULL,NULL,'2024-08-23 08:02:09','2024-08-23 08:02:09'),(343,NULL,NULL,'2024-08-23 08:18:35','2024-08-23 08:18:35'),(344,NULL,NULL,'2024-08-23 08:31:19','2024-08-23 08:31:19'),(345,NULL,NULL,'2024-08-23 08:46:25','2024-08-23 08:46:25'),(346,NULL,NULL,'2024-08-23 09:07:57','2024-08-23 09:07:57'),(347,NULL,NULL,'2024-08-23 10:15:05','2024-08-23 10:15:06'),(348,NULL,NULL,'2024-08-23 10:30:52','2024-08-23 10:30:52'),(349,NULL,NULL,'2024-08-23 10:35:12','2024-08-23 10:35:12'),(350,NULL,NULL,'2024-08-23 10:38:52','2024-08-23 10:38:52'),(351,NULL,NULL,'2024-08-23 10:40:54','2024-08-23 10:40:54'),(352,NULL,NULL,'2024-08-23 10:41:09','2024-08-23 10:41:09'),(353,NULL,NULL,'2024-08-23 10:48:50','2024-08-23 10:48:50'),(354,NULL,NULL,'2024-08-23 10:49:17','2024-08-23 10:49:17'),(355,NULL,NULL,'2024-08-23 10:51:15','2024-08-23 10:51:15'),(356,NULL,NULL,'2024-08-23 11:02:49','2024-08-23 11:02:49'),(357,NULL,NULL,'2024-08-23 11:07:42','2024-08-23 11:07:42'),(358,NULL,NULL,'2024-08-23 11:16:39','2024-08-23 11:16:39'),(359,NULL,NULL,'2024-08-23 11:29:18','2024-08-23 11:29:18'),(360,NULL,NULL,'2024-08-23 11:35:08','2024-08-23 11:35:08'),(361,NULL,NULL,'2024-08-23 11:41:48','2024-08-23 11:41:48'),(362,NULL,NULL,'2024-08-23 11:51:52','2024-08-23 11:51:52'),(363,NULL,NULL,'2024-08-23 11:57:44','2024-08-23 11:57:44'),(364,NULL,NULL,'2024-08-23 12:01:12','2024-08-23 12:01:12'),(365,NULL,NULL,'2024-08-23 12:08:35','2024-08-23 12:08:35'),(366,NULL,NULL,'2024-08-23 12:08:35','2024-08-23 12:08:35'),(367,NULL,NULL,'2024-08-23 12:44:49','2024-08-23 12:44:49'),(368,NULL,NULL,'2024-08-23 13:00:51','2024-08-23 13:00:51'),(369,NULL,NULL,'2024-08-23 13:15:52','2024-08-23 13:15:52'),(370,NULL,NULL,'2024-08-24 04:28:27','2024-08-24 04:28:27'),(371,NULL,NULL,'2024-08-25 04:14:55','2024-08-25 04:14:55'),(372,NULL,NULL,'2024-08-25 04:14:57','2024-08-25 04:14:57'),(373,NULL,NULL,'2024-08-25 04:14:59','2024-08-25 04:14:59'),(374,NULL,NULL,'2024-08-25 04:15:01','2024-08-25 04:15:01'),(375,NULL,NULL,'2024-08-25 04:15:03','2024-08-25 04:15:03'),(376,NULL,NULL,'2024-08-25 04:15:05','2024-08-25 04:15:05'),(377,NULL,NULL,'2024-08-25 15:27:36','2024-08-25 15:27:36'),(378,NULL,NULL,'2024-08-26 05:41:17','2024-08-26 05:41:17'),(379,NULL,NULL,'2024-08-26 05:58:31','2024-08-26 05:58:31'),(380,NULL,NULL,'2024-08-26 06:14:53','2024-08-26 06:14:53'),(381,NULL,NULL,'2024-08-26 06:22:45','2024-08-26 06:22:45'),(382,NULL,NULL,'2024-08-26 06:56:34','2024-08-26 06:56:34'),(383,NULL,NULL,'2024-08-26 07:01:00','2024-08-26 07:01:00'),(384,NULL,NULL,'2024-08-26 07:12:09','2024-08-26 07:12:09'),(385,NULL,NULL,'2024-08-26 07:16:18','2024-08-26 07:16:18'),(386,NULL,NULL,'2024-08-26 07:16:30','2024-08-26 07:17:54'),(387,NULL,NULL,'2024-08-26 07:18:38','2024-08-26 07:18:38'),(388,NULL,NULL,'2024-08-26 07:34:03','2024-08-26 07:34:03'),(389,NULL,NULL,'2024-08-26 07:44:36','2024-08-26 07:44:36'),(390,NULL,NULL,'2024-08-26 08:01:28','2024-08-26 08:01:28'),(391,NULL,NULL,'2024-08-26 08:06:33','2024-08-26 08:06:33'),(392,NULL,NULL,'2024-08-26 08:13:53','2024-08-26 08:13:53'),(393,NULL,NULL,'2024-08-26 08:21:32','2024-08-26 08:21:32'),(394,NULL,NULL,'2024-08-26 08:39:41','2024-08-26 08:39:41'),(395,NULL,NULL,'2024-08-26 09:45:05','2024-08-26 09:45:06'),(396,NULL,NULL,'2024-08-26 10:08:11','2024-08-26 10:08:11'),(397,NULL,NULL,'2024-08-26 10:13:52','2024-08-26 10:13:52'),(398,NULL,NULL,'2024-08-26 10:17:46','2024-08-26 10:17:46'),(399,NULL,NULL,'2024-08-27 00:40:56','2024-08-27 00:40:57'),(400,NULL,NULL,'2024-08-27 10:51:26','2024-08-27 10:51:26'),(401,NULL,NULL,'2024-08-27 15:24:24','2024-08-27 15:24:24'),(402,NULL,NULL,'2024-08-27 18:21:32','2024-08-27 18:21:33'),(403,NULL,NULL,'2024-08-27 19:02:36','2024-08-27 19:02:37'),(404,NULL,NULL,'2024-08-27 22:19:34','2024-08-27 22:19:34'),(405,NULL,NULL,'2024-08-27 22:19:35','2024-08-27 22:19:35'),(406,NULL,NULL,'2024-08-28 03:08:24','2024-08-28 03:08:24'),(407,NULL,NULL,'2024-08-28 03:08:33','2024-08-28 03:08:33'),(408,NULL,NULL,'2024-08-28 03:32:07','2024-08-28 03:32:07'),(409,NULL,NULL,'2024-08-28 05:52:02','2024-08-28 05:52:02'),(410,NULL,NULL,'2024-08-28 06:21:50','2024-08-28 06:21:50'),(411,NULL,NULL,'2024-08-28 06:28:16','2024-08-28 06:28:16'),(412,NULL,NULL,'2024-08-28 07:33:36','2024-08-28 07:33:36'),(413,NULL,NULL,'2024-08-28 07:42:20','2024-08-28 07:42:20'),(414,NULL,NULL,'2024-08-28 07:44:22','2024-08-28 07:44:22'),(415,NULL,NULL,'2024-08-28 07:44:23','2024-08-28 07:44:23'),(416,NULL,NULL,'2024-08-28 07:53:20','2024-08-28 07:53:20'),(417,NULL,NULL,'2024-08-28 08:08:41','2024-08-28 08:08:41'),(418,NULL,NULL,'2024-08-28 08:13:32','2024-08-28 08:13:32'),(419,NULL,NULL,'2024-08-28 09:13:45','2024-08-28 09:13:45'),(420,NULL,NULL,'2024-08-28 09:18:08','2024-08-28 09:18:08'),(421,NULL,NULL,'2024-08-28 09:27:45','2024-08-28 09:27:45'),(422,NULL,NULL,'2024-08-28 09:29:21','2024-08-28 09:29:21'),(423,NULL,NULL,'2024-08-28 09:31:39','2024-08-28 09:31:39'),(424,NULL,NULL,'2024-08-28 11:06:13','2024-08-28 11:06:13'),(425,NULL,NULL,'2024-08-28 11:29:36','2024-08-28 11:29:36'),(426,NULL,NULL,'2024-08-28 11:32:14','2024-08-28 11:32:14'),(427,NULL,NULL,'2024-08-28 11:37:10','2024-08-28 11:37:10'),(428,NULL,NULL,'2024-08-28 12:00:29','2024-08-28 12:00:29'),(429,NULL,NULL,'2024-08-28 12:04:57','2024-08-28 12:04:57'),(430,NULL,NULL,'2024-08-29 03:54:40','2024-08-29 03:54:40'),(431,NULL,NULL,'2024-08-29 05:35:18','2024-08-29 05:35:18'),(432,NULL,NULL,'2024-08-29 05:50:35','2024-08-29 05:50:35'),(433,NULL,NULL,'2024-08-29 08:11:41','2024-08-29 08:11:41'),(434,NULL,NULL,'2024-08-29 08:14:22','2024-08-29 08:14:22'),(435,NULL,NULL,'2024-08-29 08:18:37','2024-08-29 08:18:37'),(436,NULL,NULL,'2024-08-29 08:23:29','2024-08-29 08:23:29'),(437,NULL,NULL,'2024-08-29 08:24:31','2024-08-29 08:24:31'),(438,NULL,NULL,'2024-08-29 08:24:56','2024-08-29 08:24:56'),(439,NULL,NULL,'2024-08-29 08:26:57','2024-08-29 08:26:57'),(440,NULL,NULL,'2024-08-29 08:56:45','2024-08-29 08:56:45'),(441,NULL,NULL,'2024-08-29 08:58:40','2024-08-29 08:58:40'),(442,NULL,NULL,'2024-08-29 09:02:32','2024-08-29 09:02:32'),(443,NULL,NULL,'2024-08-29 09:03:17','2024-08-29 09:03:17'),(444,NULL,NULL,'2024-08-29 09:04:18','2024-08-29 09:04:19'),(445,NULL,NULL,'2024-08-29 09:06:29','2024-08-29 09:06:30'),(446,NULL,NULL,'2024-08-29 09:12:31','2024-08-29 09:12:31'),(447,NULL,NULL,'2024-08-29 09:15:40','2024-08-29 09:15:40'),(448,NULL,NULL,'2024-08-29 09:17:01','2024-08-29 09:17:01'),(449,NULL,NULL,'2024-08-29 09:17:44','2024-08-29 09:17:44'),(450,NULL,NULL,'2024-08-29 09:21:56','2024-08-29 09:21:56'),(451,NULL,NULL,'2024-08-29 09:25:21','2024-08-29 09:25:21'),(452,NULL,NULL,'2024-08-29 09:32:32','2024-08-29 09:32:32'),(453,NULL,NULL,'2024-08-29 09:35:09','2024-08-29 09:35:09'),(454,NULL,NULL,'2024-08-29 09:38:33','2024-08-29 09:38:33'),(455,NULL,NULL,'2024-08-29 09:41:08','2024-08-29 09:41:08'),(456,NULL,NULL,'2024-08-29 09:42:41','2024-08-29 09:42:41'),(457,NULL,NULL,'2024-08-29 09:50:29','2024-08-29 09:50:30'),(458,NULL,NULL,'2024-08-29 09:52:26','2024-08-29 09:52:26'),(459,NULL,NULL,'2024-08-29 09:54:51','2024-08-29 09:54:52'),(460,NULL,NULL,'2024-08-29 09:55:18','2024-08-29 09:55:18'),(461,NULL,NULL,'2024-08-29 09:57:47','2024-08-29 09:57:47'),(462,NULL,NULL,'2024-08-29 10:02:37','2024-08-29 10:02:37'),(463,NULL,NULL,'2024-08-29 10:07:45','2024-08-29 10:07:45'),(464,NULL,NULL,'2024-08-29 10:12:48','2024-08-29 10:12:48'),(465,NULL,NULL,'2024-08-29 10:14:50','2024-08-29 10:14:50'),(466,NULL,NULL,'2024-08-29 11:18:39','2024-08-29 11:18:39'),(467,NULL,NULL,'2024-08-29 11:47:52','2024-08-29 11:47:52'),(468,NULL,NULL,'2024-08-29 12:43:58','2024-08-29 12:43:58'),(469,NULL,NULL,'2024-08-29 13:04:58','2024-08-29 13:04:58'),(470,NULL,NULL,'2024-08-29 13:20:57','2024-08-29 13:20:57'),(471,NULL,NULL,'2024-08-29 13:36:25','2024-08-29 13:36:25'),(472,NULL,NULL,'2024-08-29 13:55:26','2024-08-29 13:55:26'),(473,NULL,NULL,'2024-08-29 14:11:12','2024-08-29 14:11:12'),(474,NULL,NULL,'2024-08-29 14:26:19','2024-08-29 14:26:19'),(475,NULL,NULL,'2024-08-29 14:42:06','2024-08-29 14:42:06'),(476,NULL,NULL,'2024-08-29 15:00:00','2024-08-29 15:00:00'),(477,NULL,NULL,'2024-08-29 15:16:14','2024-08-29 15:16:14'),(478,NULL,NULL,'2024-08-29 16:26:15','2024-08-29 16:26:15'),(479,NULL,NULL,'2024-08-29 17:05:15','2024-08-29 17:05:15'),(480,NULL,NULL,'2024-08-29 17:05:17','2024-08-29 17:05:17'),(481,NULL,NULL,'2024-08-29 18:37:39','2024-08-29 18:37:39'),(482,NULL,NULL,'2024-08-29 19:20:39','2024-08-29 19:20:39'),(483,NULL,NULL,'2024-08-30 05:31:28','2024-08-30 05:31:28'),(484,NULL,NULL,'2024-08-30 05:35:27','2024-08-30 05:35:27'),(485,NULL,NULL,'2024-08-30 05:43:01','2024-08-30 05:43:01'),(486,NULL,NULL,'2024-08-30 05:45:47','2024-08-30 05:45:47'),(487,NULL,NULL,'2024-08-30 06:05:13','2024-08-30 06:05:13'),(488,NULL,NULL,'2024-08-30 06:14:23','2024-08-30 06:14:23'),(489,NULL,NULL,'2024-08-30 06:17:29','2024-08-30 06:17:29'),(490,NULL,NULL,'2024-08-30 06:22:08','2024-08-30 06:22:08'),(491,NULL,NULL,'2024-08-30 06:24:00','2024-08-30 06:24:00'),(492,NULL,NULL,'2024-08-30 06:27:14','2024-08-30 06:27:14'),(493,NULL,NULL,'2024-08-30 06:36:37','2024-08-30 06:36:37'),(494,NULL,NULL,'2024-08-30 06:52:18','2024-08-30 06:52:18'),(495,NULL,NULL,'2024-08-30 06:52:54','2024-08-30 06:52:54'),(496,NULL,NULL,'2024-08-30 06:53:22','2024-08-30 06:53:22'),(497,NULL,NULL,'2024-08-30 07:05:27','2024-08-30 07:05:28'),(498,NULL,NULL,'2024-08-30 07:07:41','2024-08-30 07:07:41'),(499,NULL,NULL,'2024-08-30 07:10:37','2024-08-30 07:10:37'),(500,NULL,NULL,'2024-08-30 07:15:49','2024-08-30 07:15:49'),(501,NULL,NULL,'2024-08-30 07:16:19','2024-08-30 07:16:19'),(502,NULL,NULL,'2024-08-30 07:21:47','2024-08-30 07:21:47'),(503,NULL,NULL,'2024-08-30 07:36:55','2024-08-30 07:36:55'),(504,NULL,NULL,'2024-08-30 07:39:42','2024-08-30 07:39:42'),(505,NULL,NULL,'2024-08-30 07:42:16','2024-08-30 07:42:16'),(506,NULL,NULL,'2024-08-30 07:47:06','2024-08-30 07:47:06'),(507,NULL,NULL,'2024-08-30 07:49:47','2024-08-30 07:49:47'),(508,NULL,NULL,'2024-08-30 07:49:59','2024-08-30 07:49:59'),(509,NULL,NULL,'2024-08-30 07:54:15','2024-08-30 07:54:15'),(510,NULL,NULL,'2024-08-30 07:54:32','2024-08-30 07:54:32'),(511,NULL,NULL,'2024-08-30 07:56:23','2024-08-30 07:56:23'),(512,NULL,NULL,'2024-08-30 07:57:51','2024-08-30 07:57:51'),(513,NULL,NULL,'2024-08-30 08:01:27','2024-08-30 08:01:27'),(514,NULL,NULL,'2024-08-30 08:05:31','2024-08-30 08:05:31'),(515,NULL,NULL,'2024-08-30 08:15:43','2024-08-30 08:15:43'),(516,NULL,NULL,'2024-08-30 08:16:47','2024-08-30 08:16:47'),(517,NULL,NULL,'2024-08-30 08:17:07','2024-08-30 08:17:08'),(518,NULL,NULL,'2024-08-30 08:21:31','2024-08-30 08:21:31'),(519,NULL,NULL,'2024-08-30 08:22:16','2024-08-30 08:22:16'),(520,NULL,NULL,'2024-08-30 08:23:54','2024-08-30 08:23:54'),(521,NULL,NULL,'2024-08-30 08:28:30','2024-08-30 08:28:30'),(522,NULL,NULL,'2024-08-30 08:30:02','2024-08-30 08:30:02'),(523,NULL,NULL,'2024-08-30 08:32:17','2024-08-30 08:32:17'),(524,NULL,NULL,'2024-08-30 08:34:06','2024-08-30 08:34:06'),(525,NULL,NULL,'2024-08-30 08:38:29','2024-08-30 08:38:29'),(526,NULL,NULL,'2024-08-30 09:17:30','2024-08-30 09:17:30'),(527,NULL,NULL,'2024-08-30 09:31:15','2024-08-30 09:31:15'),(528,NULL,NULL,'2024-08-30 09:34:10','2024-08-30 09:34:10'),(529,NULL,NULL,'2024-08-30 09:37:15','2024-08-30 09:37:15'),(530,NULL,NULL,'2024-08-30 09:37:32','2024-08-30 09:37:32'),(531,NULL,NULL,'2024-08-30 09:40:53','2024-08-30 09:40:53'),(532,NULL,NULL,'2024-08-30 09:47:03','2024-08-30 09:47:03'),(533,NULL,NULL,'2024-08-30 09:47:26','2024-08-30 09:47:26'),(534,NULL,NULL,'2024-08-30 09:51:37','2024-08-30 09:51:37'),(535,NULL,NULL,'2024-08-30 11:15:49','2024-08-30 11:15:49'),(536,NULL,NULL,'2024-08-30 11:44:48','2024-08-30 11:44:48'),(537,NULL,NULL,'2024-08-30 11:55:46','2024-08-30 11:55:46'),(538,NULL,NULL,'2024-08-30 12:00:35','2024-08-30 12:00:36'),(539,NULL,NULL,'2024-08-30 12:03:54','2024-08-30 12:03:54'),(540,NULL,NULL,'2024-08-30 12:04:13','2024-08-30 12:04:13'),(541,NULL,NULL,'2024-08-30 12:07:29','2024-08-30 12:07:29'),(542,NULL,NULL,'2024-08-30 12:07:50','2024-08-30 12:07:50'),(543,NULL,NULL,'2024-08-30 12:08:19','2024-08-30 12:08:42'),(544,NULL,NULL,'2024-08-30 12:13:29','2024-08-30 12:13:29'),(545,NULL,NULL,'2024-08-30 12:16:18','2024-08-30 12:16:18'),(546,NULL,NULL,'2024-08-30 12:21:53','2024-08-30 12:21:53'),(547,NULL,NULL,'2024-08-30 12:22:23','2024-08-30 12:22:23'),(548,NULL,NULL,'2024-08-30 12:34:36','2024-08-30 12:34:36'),(549,NULL,NULL,'2024-08-30 15:33:20','2024-08-30 15:33:20'),(550,NULL,NULL,'2024-08-30 20:51:55','2024-08-30 20:51:55'),(551,NULL,NULL,'2024-08-30 22:35:07','2024-08-30 22:35:07'),(552,NULL,NULL,'2024-08-31 12:15:46','2024-08-31 12:15:46'),(553,NULL,NULL,'2024-08-31 12:15:48','2024-08-31 12:15:48'),(554,NULL,NULL,'2024-08-31 12:15:50','2024-08-31 12:15:50'),(555,NULL,NULL,'2024-08-31 12:15:53','2024-08-31 12:15:53'),(556,NULL,NULL,'2024-08-31 12:15:55','2024-08-31 12:15:55'),(557,NULL,NULL,'2024-08-31 12:15:56','2024-08-31 12:15:56'),(558,NULL,NULL,'2024-08-31 12:15:58','2024-08-31 12:15:58'),(559,NULL,NULL,'2024-08-31 12:16:00','2024-08-31 12:16:00'),(560,NULL,NULL,'2024-08-31 12:16:02','2024-08-31 12:16:02'),(561,NULL,NULL,'2024-08-31 12:16:03','2024-08-31 12:16:03'),(562,NULL,NULL,'2024-08-31 12:16:07','2024-08-31 12:16:07'),(563,NULL,NULL,'2024-08-31 12:16:09','2024-08-31 12:16:09'),(564,NULL,NULL,'2024-08-31 12:16:15','2024-08-31 12:16:15'),(565,NULL,NULL,'2024-08-31 12:16:17','2024-08-31 12:16:17'),(566,NULL,NULL,'2024-08-31 12:16:19','2024-08-31 12:16:19'),(567,NULL,NULL,'2024-08-31 12:16:20','2024-08-31 12:16:20'),(568,NULL,NULL,'2024-08-31 12:16:22','2024-08-31 12:16:22'),(569,NULL,NULL,'2024-08-31 12:16:24','2024-08-31 12:16:24'),(570,NULL,NULL,'2024-08-31 12:16:25','2024-08-31 12:16:25'),(571,NULL,NULL,'2024-08-31 12:16:28','2024-08-31 12:16:28'),(572,NULL,NULL,'2024-08-31 12:16:30','2024-08-31 12:16:30'),(573,NULL,NULL,'2024-08-31 12:16:32','2024-08-31 12:16:32'),(574,NULL,NULL,'2024-08-31 12:16:34','2024-08-31 12:16:34'),(575,NULL,NULL,'2024-08-31 12:16:35','2024-08-31 12:16:35'),(576,NULL,NULL,'2024-08-31 12:16:37','2024-08-31 12:16:37'),(577,NULL,NULL,'2024-08-31 12:16:38','2024-08-31 12:16:39'),(578,NULL,NULL,'2024-08-31 12:16:40','2024-08-31 12:16:40'),(579,NULL,NULL,'2024-08-31 12:16:46','2024-08-31 12:16:46'),(580,NULL,NULL,'2024-08-31 12:16:48','2024-08-31 12:16:48'),(581,NULL,NULL,'2024-08-31 12:16:50','2024-08-31 12:16:50'),(582,NULL,NULL,'2024-08-31 12:16:52','2024-08-31 12:16:52'),(583,NULL,NULL,'2024-08-31 12:16:53','2024-08-31 12:16:54'),(584,NULL,NULL,'2024-08-31 12:16:55','2024-08-31 12:16:55'),(585,NULL,NULL,'2024-08-31 12:16:57','2024-08-31 12:16:57'),(586,NULL,NULL,'2024-08-31 12:16:59','2024-08-31 12:16:59'),(587,NULL,NULL,'2024-08-31 12:17:00','2024-08-31 12:17:00'),(588,NULL,NULL,'2024-08-31 12:17:02','2024-08-31 12:17:02'),(589,NULL,NULL,'2024-08-31 12:17:04','2024-08-31 12:17:04'),(590,NULL,NULL,'2024-08-31 12:17:08','2024-08-31 12:17:08'),(591,NULL,NULL,'2024-08-31 12:17:10','2024-08-31 12:17:11'),(592,NULL,NULL,'2024-08-31 12:17:15','2024-08-31 12:17:15'),(593,NULL,NULL,'2024-08-31 12:17:17','2024-08-31 12:17:17'),(594,NULL,NULL,'2024-08-31 12:17:19','2024-08-31 12:17:19'),(595,NULL,NULL,'2024-08-31 12:17:21','2024-08-31 12:17:21'),(596,NULL,NULL,'2024-08-31 12:17:23','2024-08-31 12:17:23'),(597,NULL,NULL,'2024-08-31 12:17:24','2024-08-31 12:17:24'),(598,NULL,NULL,'2024-08-31 12:17:26','2024-08-31 12:17:26'),(599,NULL,NULL,'2024-08-31 12:17:28','2024-08-31 12:17:28'),(600,NULL,NULL,'2024-08-31 12:17:29','2024-08-31 12:17:29'),(601,NULL,NULL,'2024-09-01 12:33:24','2024-09-01 12:33:24'),(602,NULL,NULL,'2024-09-01 12:52:20','2024-09-01 12:52:20'),(603,NULL,NULL,'2024-09-01 16:13:33','2024-09-01 16:13:33'),(604,NULL,NULL,'2024-09-01 16:46:41','2024-09-01 16:46:41'),(605,NULL,NULL,'2024-09-01 21:10:52','2024-09-01 21:10:52'),(606,NULL,NULL,'2024-09-02 05:56:34','2024-09-02 05:56:34'),(607,NULL,NULL,'2024-09-02 06:00:07','2024-09-02 06:00:07'),(608,NULL,NULL,'2024-09-02 06:17:53','2024-09-02 06:17:53'),(609,NULL,NULL,'2024-09-02 06:24:15','2024-09-02 06:24:15'),(610,NULL,NULL,'2024-09-02 06:26:14','2024-09-02 06:26:14'),(611,NULL,NULL,'2024-09-02 06:27:29','2024-09-02 06:27:29'),(612,NULL,NULL,'2024-09-02 06:31:44','2024-09-02 06:31:44'),(613,NULL,NULL,'2024-09-02 06:48:05','2024-09-02 06:48:05'),(614,NULL,NULL,'2024-09-02 06:48:29','2024-09-02 06:48:29'),(615,NULL,NULL,'2024-09-02 06:52:47','2024-09-02 06:52:47'),(616,NULL,NULL,'2024-09-02 07:03:08','2024-09-02 07:03:08'),(617,NULL,NULL,'2024-09-02 07:03:44','2024-09-02 07:03:44'),(618,NULL,NULL,'2024-09-02 07:21:24','2024-09-02 07:21:24'),(619,NULL,NULL,'2024-09-02 07:27:31','2024-09-02 07:27:31'),(620,NULL,NULL,'2024-09-02 07:40:54','2024-09-02 07:40:54'),(621,NULL,NULL,'2024-09-02 07:42:02','2024-09-02 07:42:02'),(622,NULL,NULL,'2024-09-02 09:29:50','2024-09-02 09:29:50'),(623,NULL,NULL,'2024-09-02 10:03:05','2024-09-02 10:03:05'),(624,NULL,NULL,'2024-09-02 10:41:42','2024-09-02 10:41:42'),(625,NULL,NULL,'2024-09-02 10:45:41','2024-09-02 10:45:41'),(626,NULL,NULL,'2024-09-02 10:53:11','2024-09-02 10:53:11'),(627,NULL,NULL,'2024-09-02 10:56:12','2024-09-02 10:56:12'),(628,NULL,NULL,'2024-09-02 10:58:09','2024-09-02 10:58:09'),(629,NULL,NULL,'2024-09-02 10:59:25','2024-09-02 10:59:25'),(630,NULL,NULL,'2024-09-02 11:00:41','2024-09-02 11:00:41'),(631,NULL,NULL,'2024-09-02 11:02:14','2024-09-02 11:02:14'),(632,NULL,NULL,'2024-09-02 11:03:25','2024-09-02 11:03:25'),(633,NULL,NULL,'2024-09-02 11:07:46','2024-09-02 11:07:46'),(634,NULL,NULL,'2024-09-02 11:11:50','2024-09-02 11:11:50'),(635,NULL,NULL,'2024-09-02 11:12:58','2024-09-02 11:12:58'),(636,NULL,NULL,'2024-09-02 11:37:48','2024-09-02 11:37:48'),(637,NULL,NULL,'2024-09-02 11:57:58','2024-09-02 12:11:10'),(638,NULL,NULL,'2024-09-02 11:58:17','2024-09-02 11:58:17'),(639,NULL,NULL,'2024-09-02 13:19:32','2024-09-02 13:19:32'),(640,NULL,NULL,'2024-09-02 13:37:58','2024-09-02 13:37:58'),(641,NULL,NULL,'2024-09-02 13:53:30','2024-09-02 13:53:30'),(642,NULL,NULL,'2024-09-02 14:09:12','2024-09-02 14:09:12'),(643,NULL,NULL,'2024-09-02 14:24:28','2024-09-02 14:24:28'),(644,NULL,NULL,'2024-09-02 14:39:36','2024-09-02 14:39:36'),(645,NULL,NULL,'2024-09-02 14:55:10','2024-09-02 14:55:10'),(646,NULL,NULL,'2024-09-02 18:20:38','2024-09-02 18:20:38'),(647,NULL,NULL,'2024-09-03 05:22:05','2024-09-03 05:22:05'),(648,NULL,NULL,'2024-09-03 05:53:36','2024-09-03 05:53:36'),(649,NULL,NULL,'2024-09-03 06:00:29','2024-09-03 06:00:29'),(650,NULL,NULL,'2024-09-03 06:08:01','2024-09-03 06:08:01'),(651,NULL,NULL,'2024-09-03 06:12:43','2024-09-03 06:12:44'),(652,NULL,NULL,'2024-09-03 06:15:19','2024-09-03 06:15:19'),(653,NULL,NULL,'2024-09-03 06:29:41','2024-09-03 06:29:41'),(654,NULL,NULL,'2024-09-03 06:38:49','2024-09-03 06:38:50'),(655,NULL,NULL,'2024-09-03 06:40:57','2024-09-03 06:40:57'),(656,NULL,NULL,'2024-09-03 06:46:31','2024-09-03 06:46:31'),(657,NULL,NULL,'2024-09-03 06:53:24','2024-09-03 06:53:24'),(658,NULL,NULL,'2024-09-03 07:05:04','2024-09-03 07:05:04'),(659,NULL,NULL,'2024-09-03 07:06:03','2024-09-03 07:06:03'),(660,NULL,NULL,'2024-09-03 07:07:41','2024-09-03 07:07:41'),(661,NULL,NULL,'2024-09-03 07:09:21','2024-09-03 07:09:21'),(662,NULL,NULL,'2024-09-03 07:15:46','2024-09-03 07:15:46'),(663,NULL,NULL,'2024-09-03 07:26:27','2024-09-03 07:26:27'),(664,NULL,NULL,'2024-09-03 07:27:19','2024-09-03 07:27:19'),(665,NULL,NULL,'2024-09-03 07:29:53','2024-09-03 07:29:53'),(666,NULL,NULL,'2024-09-03 07:41:05','2024-09-03 07:41:05'),(667,NULL,NULL,'2024-09-03 07:44:06','2024-09-03 07:44:06'),(668,NULL,NULL,'2024-09-03 07:55:31','2024-09-03 07:55:31'),(669,NULL,NULL,'2024-09-03 11:51:13','2024-09-03 11:51:13'),(670,NULL,NULL,'2024-09-03 12:13:19','2024-09-03 12:13:19'),(671,NULL,NULL,'2024-09-03 12:42:23','2024-09-03 12:42:23'),(672,NULL,NULL,'2024-09-03 12:57:41','2024-09-03 12:57:41'),(673,NULL,NULL,'2024-09-03 13:13:08','2024-09-03 13:13:08'),(674,NULL,NULL,'2024-09-03 13:28:10','2024-09-03 13:28:10'),(675,NULL,NULL,'2024-09-03 13:52:45','2024-09-03 13:52:45'),(676,NULL,NULL,'2024-09-03 14:23:53','2024-09-03 14:23:53'),(677,NULL,NULL,'2024-09-03 14:38:58','2024-09-03 14:38:58'),(678,NULL,NULL,'2024-09-03 14:55:49','2024-09-03 14:55:49'),(679,NULL,NULL,'2024-09-03 15:16:29','2024-09-03 15:16:29'),(680,NULL,NULL,'2024-09-03 19:45:43','2024-09-03 19:45:43'),(681,NULL,NULL,'2024-09-04 06:02:57','2024-09-04 06:02:57'),(682,NULL,NULL,'2024-09-04 06:25:51','2024-09-04 06:25:51'),(683,NULL,NULL,'2024-09-04 06:39:27','2024-09-04 06:39:27'),(684,NULL,NULL,'2024-09-04 06:49:28','2024-09-04 06:49:28'),(685,NULL,NULL,'2024-09-04 06:49:58','2024-09-04 06:49:58'),(686,NULL,NULL,'2024-09-04 07:09:41','2024-09-04 07:09:41'),(687,NULL,NULL,'2024-09-04 07:18:51','2024-09-04 07:18:51'),(688,NULL,NULL,'2024-09-04 07:21:05','2024-09-04 07:21:05'),(689,NULL,NULL,'2024-09-04 07:23:17','2024-09-04 07:23:17'),(690,NULL,NULL,'2024-09-04 07:28:46','2024-09-04 07:28:46'),(691,NULL,NULL,'2024-09-04 07:36:23','2024-09-04 07:36:23'),(692,NULL,NULL,'2024-09-04 07:38:13','2024-09-04 07:38:13'),(693,NULL,NULL,'2024-09-04 07:43:40','2024-09-04 07:43:40'),(694,NULL,NULL,'2024-09-04 07:51:27','2024-09-04 07:51:27'),(695,NULL,NULL,'2024-09-04 08:01:39','2024-09-04 08:01:39'),(696,NULL,NULL,'2024-09-04 08:07:48','2024-09-04 08:07:48'),(697,NULL,NULL,'2024-09-04 08:09:37','2024-09-04 08:09:37'),(698,NULL,NULL,'2024-09-04 08:15:45','2024-09-04 08:15:45'),(699,NULL,NULL,'2024-09-04 08:17:20','2024-09-04 08:17:20'),(700,NULL,NULL,'2024-09-04 08:24:26','2024-09-04 08:24:26'),(701,NULL,NULL,'2024-09-04 08:28:17','2024-09-04 08:28:17'),(702,NULL,NULL,'2024-09-04 08:40:14','2024-09-04 08:40:14'),(703,NULL,NULL,'2024-09-04 09:04:09','2024-09-04 09:04:09'),(704,NULL,NULL,'2024-09-04 09:19:35','2024-09-04 09:19:35'),(705,NULL,NULL,'2024-09-04 10:22:05','2024-09-04 10:22:05'),(706,NULL,NULL,'2024-09-04 10:23:20','2024-09-04 10:23:20'),(707,NULL,NULL,'2024-09-04 10:27:32','2024-09-04 10:27:32'),(708,NULL,NULL,'2024-09-04 10:51:48','2024-09-04 10:51:48'),(709,NULL,NULL,'2024-09-04 10:55:18','2024-09-04 10:55:18'),(710,NULL,NULL,'2024-09-04 10:57:56','2024-09-04 10:57:56'),(711,NULL,NULL,'2024-09-04 11:02:22','2024-09-04 11:02:22'),(712,NULL,NULL,'2024-09-04 11:03:24','2024-09-04 11:03:25'),(713,NULL,NULL,'2024-09-04 11:15:00','2024-09-04 11:15:00'),(714,NULL,NULL,'2024-09-04 11:22:23','2024-09-04 11:22:23'),(715,NULL,NULL,'2024-09-04 13:50:22','2024-09-04 13:50:22'),(716,NULL,NULL,'2024-09-04 14:06:33','2024-09-04 14:06:33'),(717,NULL,NULL,'2024-09-04 14:21:52','2024-09-04 14:21:52'),(718,NULL,NULL,'2024-09-04 14:37:22','2024-09-04 14:37:22'),(719,NULL,NULL,'2024-09-04 14:59:17','2024-09-04 14:59:17'),(720,NULL,NULL,'2024-09-04 21:39:58','2024-09-04 21:39:58'),(721,NULL,NULL,'2024-09-04 21:39:59','2024-09-04 21:39:59'),(722,NULL,NULL,'2024-09-05 06:39:08','2024-09-05 06:39:08'),(723,NULL,NULL,'2024-09-05 07:03:15','2024-09-05 07:03:15'),(724,NULL,NULL,'2024-09-05 07:08:51','2024-09-05 07:08:51'),(725,NULL,NULL,'2024-09-05 07:17:05','2024-09-05 07:17:05'),(726,NULL,NULL,'2024-09-05 07:20:31','2024-09-05 07:20:31'),(727,NULL,NULL,'2024-09-05 07:25:44','2024-09-05 07:25:44'),(728,NULL,NULL,'2024-09-05 07:28:51','2024-09-05 07:28:51'),(729,NULL,NULL,'2024-09-05 07:32:52','2024-09-05 07:32:52'),(730,NULL,NULL,'2024-09-05 07:51:25','2024-09-05 07:51:25'),(731,NULL,NULL,'2024-09-05 07:54:15','2024-09-05 07:54:15'),(732,NULL,NULL,'2024-09-05 08:04:41','2024-09-05 08:04:41'),(733,NULL,NULL,'2024-09-05 08:12:16','2024-09-05 08:12:16'),(734,NULL,NULL,'2024-09-05 08:23:12','2024-09-05 08:23:12'),(735,NULL,NULL,'2024-09-05 09:00:18','2024-09-05 09:00:18'),(736,NULL,NULL,'2024-09-05 09:01:40','2024-09-05 09:01:40'),(737,NULL,NULL,'2024-09-05 09:17:44','2024-09-05 09:17:44'),(738,NULL,NULL,'2024-09-05 09:45:26','2024-09-05 09:45:27'),(739,NULL,NULL,'2024-09-05 09:49:39','2024-09-05 09:49:39'),(740,NULL,NULL,'2024-09-05 09:52:25','2024-09-05 09:52:25'),(741,NULL,NULL,'2024-09-05 09:56:24','2024-09-05 09:56:24'),(742,NULL,NULL,'2024-09-05 10:34:03','2024-09-05 10:34:03'),(743,NULL,NULL,'2024-09-05 10:41:41','2024-09-05 10:41:41'),(744,NULL,NULL,'2024-09-05 10:57:06','2024-09-05 10:57:06'),(745,NULL,NULL,'2024-09-05 11:16:05','2024-09-05 11:16:05'),(746,NULL,NULL,'2024-09-05 11:40:31','2024-09-05 11:40:31'),(747,NULL,NULL,'2024-09-05 11:57:29','2024-09-05 11:57:29'),(748,NULL,NULL,'2024-09-05 12:17:18','2024-09-05 12:17:18'),(749,NULL,NULL,'2024-09-05 12:48:48','2024-09-05 12:48:49'),(750,NULL,NULL,'2024-09-05 13:00:06','2024-09-05 13:00:07'),(751,NULL,NULL,'2024-09-05 13:04:34','2024-09-05 13:04:34'),(752,NULL,NULL,'2024-09-05 13:19:38','2024-09-05 13:19:38'),(753,NULL,NULL,'2024-09-05 13:25:53','2024-09-05 13:25:53'),(754,NULL,NULL,'2024-09-05 13:36:37','2024-09-05 13:36:37'),(755,NULL,NULL,'2024-09-05 13:48:05','2024-09-05 13:48:05'),(756,NULL,NULL,'2024-09-05 14:05:17','2024-09-05 14:05:17'),(757,NULL,NULL,'2024-09-05 14:23:25','2024-09-05 14:23:25'),(758,NULL,NULL,'2024-09-05 14:40:05','2024-09-05 14:40:05'),(759,NULL,NULL,'2024-09-05 14:55:15','2024-09-05 14:55:15'),(760,NULL,NULL,'2024-09-05 17:25:11','2024-09-05 17:25:11'),(761,NULL,NULL,'2024-09-05 18:31:54','2024-09-05 18:31:54'),(762,NULL,NULL,'2024-09-05 20:17:49','2024-09-05 20:17:49'),(763,NULL,NULL,'2024-09-05 22:51:17','2024-09-05 22:51:17'),(764,NULL,NULL,'2024-09-06 07:09:56','2024-09-06 07:09:56'),(765,NULL,NULL,'2024-09-06 07:41:37','2024-09-06 07:41:37'),(766,NULL,NULL,'2024-09-06 07:58:42','2024-09-06 07:58:42'),(767,NULL,NULL,'2024-09-06 08:14:25','2024-09-06 08:14:25'),(768,NULL,NULL,'2024-09-06 09:01:15','2024-09-06 09:01:15'),(769,NULL,NULL,'2024-09-06 09:18:50','2024-09-06 09:18:50'),(770,NULL,NULL,'2024-09-06 22:15:22','2024-09-06 22:15:22'),(771,NULL,NULL,'2024-09-07 01:22:27','2024-09-07 01:22:27'),(772,NULL,NULL,'2024-09-07 05:08:38','2024-09-07 05:08:38'),(773,NULL,NULL,'2024-09-07 05:39:19','2024-09-07 05:39:19'),(774,NULL,NULL,'2024-09-07 06:52:31','2024-09-07 06:52:31'),(775,NULL,NULL,'2024-09-07 06:57:18','2024-09-07 06:57:18'),(776,NULL,NULL,'2024-09-07 09:57:07','2024-09-07 09:57:07'),(777,NULL,NULL,'2024-09-07 15:23:16','2024-09-07 15:23:16'),(778,NULL,NULL,'2024-09-07 15:46:08','2024-09-07 15:46:09'),(779,NULL,NULL,'2024-09-08 20:24:16','2024-09-08 20:24:16'),(780,NULL,NULL,'2024-09-08 23:11:15','2024-09-08 23:11:15'),(781,NULL,NULL,'2024-09-09 01:06:04','2024-09-09 01:06:04'),(782,NULL,NULL,'2024-09-09 05:38:51','2024-09-09 05:38:51'),(783,NULL,NULL,'2024-09-09 06:27:52','2024-09-09 06:27:52'),(784,NULL,NULL,'2024-09-09 06:38:48','2024-09-09 06:38:48'),(785,NULL,NULL,'2024-09-09 06:51:02','2024-09-09 06:51:02'),(786,NULL,NULL,'2024-09-09 08:02:21','2024-09-09 08:02:21'),(787,NULL,NULL,'2024-09-09 08:10:57','2024-09-09 08:10:57'),(788,NULL,NULL,'2024-09-09 08:27:05','2024-09-09 08:27:05'),(789,NULL,NULL,'2024-09-09 08:27:27','2024-09-09 08:27:27'),(790,NULL,NULL,'2024-09-09 08:53:33','2024-09-09 08:53:33'),(791,NULL,NULL,'2024-09-09 09:56:02','2024-09-09 09:56:02'),(792,NULL,NULL,'2024-09-09 09:57:28','2024-09-09 09:57:28'),(793,NULL,NULL,'2024-09-09 10:00:19','2024-09-09 10:00:19'),(794,NULL,NULL,'2024-09-09 10:02:09','2024-09-09 10:02:09'),(795,NULL,NULL,'2024-09-09 10:02:28','2024-09-09 10:02:28'),(796,NULL,NULL,'2024-09-09 10:13:45','2024-09-09 10:13:45'),(797,NULL,NULL,'2024-09-09 10:14:07','2024-09-09 10:14:07'),(798,NULL,NULL,'2024-09-09 10:18:32','2024-09-09 10:18:32'),(799,NULL,NULL,'2024-09-09 10:27:25','2024-09-09 10:27:25'),(800,NULL,NULL,'2024-09-09 10:46:21','2024-09-09 10:46:21'),(801,NULL,NULL,'2024-09-09 10:47:08','2024-09-09 10:47:08'),(802,NULL,NULL,'2024-09-09 11:03:28','2024-09-09 11:03:28'),(803,NULL,NULL,'2024-09-09 11:04:47','2024-09-09 11:04:47'),(804,NULL,NULL,'2024-09-09 11:25:42','2024-09-09 11:25:42'),(805,NULL,NULL,'2024-09-09 11:35:26','2024-09-09 11:35:26'),(806,NULL,NULL,'2024-09-09 11:45:52','2024-09-09 11:45:53'),(807,NULL,NULL,'2024-09-09 11:49:43','2024-09-09 11:49:43'),(808,NULL,NULL,'2024-09-09 11:56:17','2024-09-09 11:56:17'),(809,NULL,NULL,'2024-09-09 12:00:58','2024-09-09 12:00:58'),(810,NULL,NULL,'2024-09-09 14:31:16','2024-09-09 14:31:16'),(811,NULL,NULL,'2024-09-09 15:23:09','2024-09-09 15:23:09'),(812,NULL,NULL,'2024-09-09 17:01:39','2024-09-09 17:01:39'),(813,NULL,NULL,'2024-09-10 05:25:26','2024-09-10 05:25:26'),(814,NULL,NULL,'2024-09-10 05:27:02','2024-09-10 05:27:02'),(815,NULL,NULL,'2024-09-10 05:33:21','2024-09-10 05:33:21'),(816,NULL,NULL,'2024-09-10 05:35:23','2024-09-10 05:35:23'),(817,NULL,NULL,'2024-09-10 05:37:40','2024-09-10 05:37:40'),(818,NULL,NULL,'2024-09-10 05:40:15','2024-09-10 05:40:15'),(819,NULL,NULL,'2024-09-10 05:51:46','2024-09-10 05:51:46'),(820,NULL,NULL,'2024-09-10 05:52:02','2024-09-10 05:52:02'),(821,NULL,NULL,'2024-09-10 06:05:15','2024-09-10 06:05:15'),(822,NULL,NULL,'2024-09-10 06:05:50','2024-09-10 06:05:50'),(823,NULL,NULL,'2024-09-10 06:07:59','2024-09-10 06:07:59'),(824,NULL,NULL,'2024-09-10 06:13:42','2024-09-10 06:13:42'),(825,NULL,NULL,'2024-09-10 06:19:39','2024-09-10 06:19:39'),(826,NULL,NULL,'2024-09-10 06:19:58','2024-09-10 06:19:58'),(827,NULL,NULL,'2024-09-10 06:26:02','2024-09-10 06:26:02'),(828,NULL,NULL,'2024-09-10 07:07:07','2024-09-10 07:07:07'),(829,NULL,NULL,'2024-09-10 07:11:19','2024-09-10 07:11:19'),(830,NULL,NULL,'2024-09-10 07:17:45','2024-09-10 07:17:45'),(831,NULL,NULL,'2024-09-10 07:20:15','2024-09-10 07:20:15'),(832,NULL,NULL,'2024-09-10 07:22:13','2024-09-10 07:22:13'),(833,NULL,NULL,'2024-09-10 07:23:39','2024-09-10 07:23:39'),(834,NULL,NULL,'2024-09-10 07:24:35','2024-09-10 07:24:35'),(835,NULL,NULL,'2024-09-10 07:32:57','2024-09-10 07:32:57'),(836,NULL,NULL,'2024-09-10 07:35:16','2024-09-10 07:35:16'),(837,NULL,NULL,'2024-09-10 07:38:12','2024-09-10 07:38:12'),(838,NULL,NULL,'2024-09-10 07:40:23','2024-09-10 07:40:23'),(839,NULL,NULL,'2024-09-10 07:55:27','2024-09-10 07:55:27'),(840,NULL,NULL,'2024-09-10 07:57:04','2024-09-10 07:57:04'),(841,NULL,NULL,'2024-09-10 08:00:16','2024-09-10 08:00:16'),(842,NULL,NULL,'2024-09-10 08:06:58','2024-09-10 08:06:58'),(843,NULL,NULL,'2024-09-10 08:07:17','2024-09-10 08:07:17'),(844,NULL,NULL,'2024-09-10 08:13:38','2024-09-10 08:13:38'),(845,NULL,NULL,'2024-09-10 08:13:55','2024-09-10 08:13:55'),(846,NULL,NULL,'2024-09-10 08:17:42','2024-09-10 08:17:42'),(847,NULL,NULL,'2024-09-10 08:21:33','2024-09-10 08:21:33'),(848,NULL,NULL,'2024-09-10 08:24:50','2024-09-10 08:24:50'),(849,NULL,NULL,'2024-09-10 08:28:30','2024-09-10 08:28:31'),(850,NULL,NULL,'2024-09-10 08:30:56','2024-09-10 08:30:56'),(851,NULL,NULL,'2024-09-10 08:37:13','2024-09-10 08:37:13'),(852,NULL,NULL,'2024-09-10 09:11:38','2024-09-10 09:11:38'),(853,NULL,NULL,'2024-09-10 09:35:01','2024-09-10 09:35:01'),(854,NULL,NULL,'2024-09-10 10:05:25','2024-09-10 10:05:25'),(855,NULL,NULL,'2024-09-10 11:19:00','2024-09-10 11:19:00'),(856,NULL,NULL,'2024-09-10 12:17:38','2024-09-10 12:17:38'),(857,NULL,NULL,'2024-09-10 15:58:07','2024-09-10 15:58:07'),(858,NULL,NULL,'2024-09-10 17:01:37','2024-09-10 17:01:37'),(859,NULL,NULL,'2024-09-10 17:21:05','2024-09-10 17:21:05'),(860,NULL,NULL,'2024-09-11 00:43:21','2024-09-11 00:43:22'),(861,NULL,NULL,'2024-09-11 05:37:42','2024-09-11 05:37:42'),(862,NULL,NULL,'2024-09-11 08:14:27','2024-09-11 08:14:27'),(863,NULL,NULL,'2024-09-11 08:16:51','2024-09-11 08:16:51'),(864,NULL,NULL,'2024-09-11 08:43:35','2024-09-11 08:43:35'),(865,NULL,NULL,'2024-09-11 08:58:24','2024-09-11 08:58:24'),(866,NULL,NULL,'2024-09-11 09:23:05','2024-09-11 09:23:05'),(867,NULL,NULL,'2024-09-11 09:36:34','2024-09-11 09:36:34'),(868,NULL,NULL,'2024-09-11 09:57:36','2024-09-11 09:57:36'),(869,NULL,NULL,'2024-09-11 10:01:09','2024-09-11 10:01:09'),(870,NULL,NULL,'2024-09-11 10:11:59','2024-09-11 10:11:59'),(871,NULL,NULL,'2024-09-11 10:14:41','2024-09-11 10:14:41'),(872,NULL,NULL,'2024-09-11 10:30:51','2024-09-11 10:30:51'),(873,NULL,NULL,'2024-09-11 10:33:24','2024-09-11 10:33:24'),(874,NULL,NULL,'2024-09-11 10:38:37','2024-09-11 10:38:37'),(875,NULL,NULL,'2024-09-11 11:44:46','2024-09-11 11:44:46'),(876,NULL,NULL,'2024-09-11 11:54:42','2024-09-11 11:54:42'),(877,NULL,NULL,'2024-09-11 17:19:01','2024-09-11 17:19:01'),(878,NULL,NULL,'2024-09-11 20:09:33','2024-09-11 20:09:33'),(879,NULL,NULL,'2024-09-11 23:04:13','2024-09-11 23:04:13'),(880,NULL,NULL,'2024-09-12 03:00:22','2024-09-12 03:00:22'),(881,NULL,NULL,'2024-09-12 03:00:23','2024-09-12 03:00:23'),(882,NULL,NULL,'2024-09-12 05:20:53','2024-09-12 05:20:53'),(883,NULL,NULL,'2024-09-12 05:41:00','2024-09-12 05:41:00'),(884,NULL,NULL,'2024-09-12 05:46:51','2024-09-12 05:46:51'),(885,NULL,NULL,'2024-09-12 06:01:53','2024-09-12 06:01:53'),(886,NULL,NULL,'2024-09-12 06:08:24','2024-09-12 06:08:24'),(887,NULL,NULL,'2024-09-12 06:50:49','2024-09-12 06:50:49'),(888,NULL,NULL,'2024-09-12 07:32:27','2024-09-12 07:32:27'),(889,NULL,NULL,'2024-09-12 07:56:46','2024-09-12 07:56:46'),(890,NULL,NULL,'2024-09-12 07:59:34','2024-09-12 07:59:34'),(891,NULL,NULL,'2024-09-12 07:59:44','2024-09-12 07:59:44'),(892,NULL,NULL,'2024-09-12 09:28:28','2024-09-12 09:28:28'),(893,NULL,NULL,'2024-09-12 09:44:52','2024-09-12 09:44:52'),(894,NULL,NULL,'2024-09-12 11:07:00','2024-09-12 11:07:00'),(895,NULL,NULL,'2024-09-12 11:19:53','2024-09-12 11:19:53'),(896,NULL,NULL,'2024-09-12 11:33:34','2024-09-12 11:33:34'),(897,NULL,NULL,'2024-09-12 19:54:49','2024-09-12 19:54:49'),(898,NULL,NULL,'2024-09-13 04:04:15','2024-09-13 04:04:15'),(899,NULL,NULL,'2024-09-13 05:31:02','2024-09-13 05:31:02'),(900,NULL,NULL,'2024-09-13 06:31:15','2024-09-13 06:31:15'),(901,NULL,NULL,'2024-09-13 06:47:34','2024-09-13 06:47:34'),(902,NULL,NULL,'2024-09-13 06:50:15','2024-09-13 06:50:15'),(903,NULL,NULL,'2024-09-13 06:51:16','2024-09-13 06:51:16'),(904,NULL,NULL,'2024-09-13 06:51:54','2024-09-13 06:51:54'),(905,NULL,NULL,'2024-09-13 06:52:13','2024-09-13 06:52:13'),(906,NULL,NULL,'2024-09-13 06:53:32','2024-09-13 06:53:32'),(907,NULL,NULL,'2024-09-13 06:55:25','2024-09-13 06:55:25'),(908,NULL,NULL,'2024-09-13 06:57:38','2024-09-13 06:57:38'),(909,NULL,NULL,'2024-09-13 06:58:25','2024-09-13 06:58:25'),(910,NULL,NULL,'2024-09-13 14:54:08','2024-09-13 14:54:08'),(911,NULL,NULL,'2024-09-13 18:00:46','2024-09-13 18:00:46'),(912,NULL,NULL,'2024-09-14 02:56:48','2024-09-14 02:56:48'),(913,NULL,NULL,'2024-09-14 05:03:41','2024-09-14 05:03:41'),(914,NULL,NULL,'2024-09-14 07:25:07','2024-09-14 07:25:07'),(915,NULL,NULL,'2024-09-14 07:28:20','2024-09-14 07:28:21'),(916,NULL,NULL,'2024-09-14 07:39:35','2024-09-14 07:39:35'),(917,NULL,NULL,'2024-09-14 07:47:38','2024-09-14 07:47:38'),(918,NULL,NULL,'2024-09-14 08:03:10','2024-09-14 08:03:10'),(919,NULL,NULL,'2024-09-14 08:06:46','2024-09-14 08:06:46'),(920,NULL,NULL,'2024-09-14 08:08:40','2024-09-14 08:08:40'),(921,NULL,NULL,'2024-09-14 08:25:54','2024-09-14 08:25:54'),(922,NULL,NULL,'2024-09-14 08:29:22','2024-09-14 08:29:22'),(923,NULL,NULL,'2024-09-14 08:32:13','2024-09-14 08:32:13'),(924,NULL,NULL,'2024-09-14 08:33:51','2024-09-14 08:33:51'),(925,NULL,NULL,'2024-09-14 08:34:15','2024-09-14 08:34:15'),(926,NULL,NULL,'2024-09-14 08:37:30','2024-09-14 08:37:30'),(927,NULL,NULL,'2024-09-14 09:05:27','2024-09-14 09:05:27'),(928,NULL,NULL,'2024-09-14 09:22:14','2024-09-14 09:22:14'),(929,NULL,NULL,'2024-09-14 09:22:58','2024-09-14 09:22:59'),(930,NULL,NULL,'2024-09-14 09:30:26','2024-09-14 09:30:26'),(931,NULL,NULL,'2024-09-14 09:34:59','2024-09-14 09:34:59'),(932,NULL,NULL,'2024-09-14 09:37:27','2024-09-14 09:37:27'),(933,NULL,NULL,'2024-09-14 09:48:22','2024-09-14 09:48:22'),(934,NULL,NULL,'2024-09-14 09:48:46','2024-09-14 09:48:46'),(935,NULL,NULL,'2024-09-14 10:09:20','2024-09-14 10:09:20'),(936,NULL,NULL,'2024-09-14 10:12:47','2024-09-14 10:12:47'),(937,NULL,NULL,'2024-09-14 10:23:58','2024-09-14 10:23:58'),(938,NULL,NULL,'2024-09-14 10:26:33','2024-09-14 10:26:33'),(939,NULL,NULL,'2024-09-14 10:28:36','2024-09-14 10:28:36'),(940,NULL,NULL,'2024-09-14 11:10:54','2024-09-14 11:10:54'),(941,NULL,NULL,'2024-09-14 16:22:30','2024-09-14 16:22:30'),(942,NULL,NULL,'2024-09-14 21:17:18','2024-09-14 21:17:18'),(943,NULL,NULL,'2024-09-15 07:12:23','2024-09-15 07:12:23'),(944,NULL,NULL,'2024-09-15 16:02:53','2024-09-15 16:02:53'),(945,NULL,NULL,'2024-09-16 05:35:49','2024-09-16 05:35:49'),(946,NULL,NULL,'2024-09-16 06:30:54','2024-09-16 06:30:54'),(947,NULL,NULL,'2024-09-16 07:40:25','2024-09-16 07:40:25'),(948,NULL,NULL,'2024-09-16 07:57:08','2024-09-16 07:57:08'),(949,NULL,NULL,'2024-09-16 08:00:45','2024-09-16 08:00:45'),(950,NULL,NULL,'2024-09-16 08:02:23','2024-09-16 08:02:23'),(951,NULL,NULL,'2024-09-16 08:04:40','2024-09-16 08:04:40'),(952,NULL,NULL,'2024-09-16 08:05:24','2024-09-16 08:05:24'),(953,NULL,NULL,'2024-09-16 08:06:27','2024-09-16 08:06:27'),(954,NULL,NULL,'2024-09-16 08:07:48','2024-09-16 08:07:48'),(955,NULL,NULL,'2024-09-16 08:18:05','2024-09-16 08:18:05'),(956,NULL,NULL,'2024-09-16 08:23:55','2024-09-16 08:23:55'),(957,NULL,NULL,'2024-09-16 08:54:20','2024-09-16 08:54:20'),(958,NULL,NULL,'2024-09-16 09:13:21','2024-09-16 09:13:21'),(959,NULL,NULL,'2024-09-16 09:28:23','2024-09-16 09:28:23'),(960,NULL,NULL,'2024-09-16 09:34:32','2024-09-16 09:34:32'),(961,NULL,NULL,'2024-09-16 09:36:11','2024-09-16 09:36:11'),(962,NULL,NULL,'2024-09-16 09:37:55','2024-09-16 09:37:55'),(963,NULL,NULL,'2024-09-16 09:45:29','2024-09-16 09:45:29'),(964,NULL,NULL,'2024-09-16 09:49:04','2024-09-16 09:49:05'),(965,NULL,NULL,'2024-09-16 09:57:29','2024-09-16 09:57:29'),(966,NULL,NULL,'2024-09-16 10:03:38','2024-09-16 10:03:38'),(967,NULL,NULL,'2024-09-16 10:13:36','2024-09-16 10:13:36'),(968,NULL,NULL,'2024-09-16 10:20:29','2024-09-16 10:20:29'),(969,NULL,NULL,'2024-09-16 10:37:19','2024-09-16 10:37:19'),(970,NULL,NULL,'2024-09-16 10:52:59','2024-09-16 10:52:59'),(971,NULL,NULL,'2024-09-16 10:56:25','2024-09-16 10:56:25'),(972,NULL,NULL,'2024-09-16 11:02:12','2024-09-16 11:02:12'),(973,NULL,NULL,'2024-09-16 11:06:33','2024-09-16 11:06:33'),(974,NULL,NULL,'2024-09-16 11:18:17','2024-09-16 11:18:17'),(975,NULL,NULL,'2024-09-16 11:29:09','2024-09-16 11:29:09'),(976,NULL,NULL,'2024-09-16 11:33:26','2024-09-16 11:33:26'),(977,NULL,NULL,'2024-09-16 11:46:45','2024-09-16 11:46:45'),(978,NULL,NULL,'2024-09-16 11:49:47','2024-09-16 11:49:47'),(979,NULL,NULL,'2024-09-16 11:54:00','2024-09-16 11:54:00'),(980,NULL,NULL,'2024-09-16 12:13:56','2024-09-16 12:13:56'),(981,NULL,NULL,'2024-09-16 12:46:23','2024-09-16 12:46:23'),(982,NULL,NULL,'2024-09-16 13:01:46','2024-09-16 13:01:46'),(983,NULL,NULL,'2024-09-16 13:46:23','2024-09-16 13:46:23'),(984,NULL,NULL,'2024-09-16 14:03:19','2024-09-16 14:03:19'),(985,NULL,NULL,'2024-09-16 14:20:37','2024-09-16 14:20:37'),(986,NULL,NULL,'2024-09-16 15:00:03','2024-09-16 15:00:03'),(987,NULL,NULL,'2024-09-16 15:16:21','2024-09-16 15:16:21'),(988,NULL,NULL,'2024-09-16 19:46:53','2024-09-16 19:46:53'),(989,NULL,NULL,'2024-09-17 05:41:00','2024-09-17 05:41:00'),(990,NULL,NULL,'2024-09-17 09:14:12','2024-09-17 09:14:12'),(991,NULL,NULL,'2024-09-17 09:40:40','2024-09-17 09:40:40'),(992,NULL,NULL,'2024-09-17 10:37:15','2024-09-17 10:37:15'),(993,NULL,NULL,'2024-09-17 10:39:11','2024-09-17 10:49:53'),(994,NULL,NULL,'2024-09-17 10:42:36','2024-09-17 10:42:36'),(995,NULL,NULL,'2024-09-17 10:45:25','2024-09-17 10:45:25'),(996,NULL,NULL,'2024-09-17 10:49:39','2024-09-17 10:49:39'),(997,NULL,NULL,'2024-09-17 11:21:26','2024-09-17 11:22:22'),(998,NULL,NULL,'2024-09-17 11:44:47','2024-09-17 11:44:47'),(999,NULL,NULL,'2024-09-17 16:38:58','2024-09-17 16:38:58'),(1000,NULL,NULL,'2024-09-17 23:55:36','2024-09-17 23:55:36'),(1001,NULL,NULL,'2024-09-18 06:55:04','2024-09-18 06:55:04'),(1002,NULL,NULL,'2024-09-18 07:14:11','2024-09-18 07:14:11'),(1003,NULL,NULL,'2024-09-18 07:17:10','2024-09-18 07:17:10'),(1004,NULL,NULL,'2024-09-18 07:36:25','2024-09-18 07:36:25'),(1005,NULL,NULL,'2024-09-18 07:40:13','2024-09-18 07:40:13'),(1006,NULL,NULL,'2024-09-18 08:11:09','2024-09-18 08:11:09'),(1007,NULL,NULL,'2024-09-18 08:13:09','2024-09-18 08:13:09'),(1008,NULL,NULL,'2024-09-18 08:29:19','2024-09-18 08:29:19'),(1009,1,NULL,'2024-09-18 08:43:14','2024-09-18 10:52:08'),(1010,NULL,NULL,'2024-09-18 08:53:29','2024-09-18 08:53:29'),(1011,NULL,NULL,'2024-09-18 09:09:12','2024-09-18 09:09:12'),(1012,NULL,NULL,'2024-09-18 09:21:04','2024-09-18 09:21:04'),(1013,NULL,NULL,'2024-09-18 09:26:34','2024-09-18 09:26:34'),(1014,NULL,NULL,'2024-09-18 11:08:15','2024-09-18 12:09:24'),(1015,NULL,NULL,'2024-09-18 11:15:51','2024-09-18 11:15:51'),(1016,NULL,NULL,'2024-09-18 11:36:00','2024-09-18 11:36:00'),(1017,NULL,NULL,'2024-09-18 11:39:43','2024-09-18 11:39:44'),(1018,NULL,NULL,'2024-09-18 11:43:31','2024-09-18 11:43:31'),(1019,NULL,NULL,'2024-09-18 11:43:46','2024-09-18 11:43:46'),(1020,NULL,NULL,'2024-09-18 11:43:54','2024-09-18 11:43:54'),(1021,NULL,NULL,'2024-09-18 11:44:12','2024-09-18 11:44:13'),(1022,NULL,NULL,'2024-09-18 12:04:29','2024-09-18 12:04:29'),(1023,NULL,NULL,'2024-09-18 12:06:14','2024-09-18 12:06:14'),(1024,NULL,NULL,'2024-09-18 12:22:11','2024-09-18 12:22:11'),(1025,NULL,NULL,'2024-09-18 13:32:55','2024-09-18 13:32:55'),(1026,NULL,NULL,'2024-09-18 13:48:13','2024-09-18 13:48:13'),(1027,NULL,NULL,'2024-09-18 14:32:57','2024-09-18 14:32:57'),(1028,NULL,NULL,'2024-09-18 15:37:56','2024-09-18 15:37:56'),(1029,NULL,NULL,'2024-09-18 16:19:03','2024-09-18 16:19:04'),(1030,NULL,NULL,'2024-09-18 16:52:33','2024-09-18 16:52:33'),(1031,NULL,NULL,'2024-09-18 17:08:29','2024-09-18 17:08:29'),(1032,NULL,NULL,'2024-09-18 17:47:39','2024-09-18 17:47:39'),(1033,NULL,NULL,'2024-09-18 22:37:46','2024-09-18 22:37:46'),(1034,NULL,NULL,'2024-09-19 05:11:19','2024-09-19 05:11:19'),(1035,1,NULL,'2024-09-19 05:14:29','2024-09-19 09:04:31'),(1036,NULL,NULL,'2024-09-19 05:42:58','2024-09-19 05:42:58'),(1037,NULL,NULL,'2024-09-19 07:43:33','2024-09-19 07:43:33'),(1038,NULL,NULL,'2024-09-19 07:55:02','2024-09-19 07:55:02'),(1039,NULL,NULL,'2024-09-19 08:04:14','2024-09-19 08:04:14'),(1040,NULL,NULL,'2024-09-19 08:09:20','2024-09-19 08:09:20'),(1041,NULL,NULL,'2024-09-19 08:12:04','2024-09-19 08:12:04'),(1042,NULL,NULL,'2024-09-19 08:16:35','2024-09-19 08:16:35'),(1043,NULL,NULL,'2024-09-19 08:17:23','2024-09-19 08:17:23'),(1044,NULL,NULL,'2024-09-19 08:20:56','2024-09-19 08:20:57'),(1045,NULL,NULL,'2024-09-19 08:52:32','2024-09-19 08:52:32'),(1046,NULL,NULL,'2024-09-19 09:02:41','2024-09-19 09:02:41'),(1047,NULL,NULL,'2024-09-19 09:03:09','2024-09-19 09:03:09'),(1048,NULL,NULL,'2024-09-19 09:30:58','2024-09-19 09:30:58'),(1049,NULL,NULL,'2024-09-19 09:41:36','2024-09-19 09:42:50'),(1050,1,NULL,'2024-09-19 09:43:37','2024-09-19 11:24:07'),(1051,NULL,NULL,'2024-09-19 10:08:46','2024-09-19 10:08:46'),(1052,NULL,NULL,'2024-09-19 10:52:11','2024-09-19 10:52:11'),(1053,NULL,NULL,'2024-09-19 10:55:44','2024-09-19 10:55:44'),(1054,NULL,NULL,'2024-09-19 10:57:19','2024-09-19 10:57:19'),(1055,NULL,NULL,'2024-09-19 11:05:34','2024-09-19 11:05:34'),(1056,NULL,NULL,'2024-09-19 11:08:29','2024-09-19 11:08:29'),(1057,NULL,NULL,'2024-09-19 11:09:41','2024-09-19 11:09:41'),(1058,NULL,NULL,'2024-09-19 11:13:50','2024-09-19 11:13:50'),(1059,NULL,NULL,'2024-09-19 11:16:13','2024-09-19 11:16:13'),(1060,NULL,NULL,'2024-09-19 11:25:12','2024-09-19 11:25:12'),(1061,NULL,NULL,'2024-09-19 11:27:15','2024-09-19 11:27:15'),(1062,NULL,NULL,'2024-09-19 11:40:12','2024-09-19 11:40:12'),(1063,NULL,NULL,'2024-09-19 11:42:37','2024-09-19 11:42:37'),(1064,NULL,NULL,'2024-09-19 12:05:06','2024-09-19 12:05:06'),(1065,NULL,NULL,'2024-09-19 12:20:54','2024-09-19 12:20:54'),(1066,NULL,NULL,'2024-09-19 12:36:04','2024-09-19 12:36:04'),(1067,NULL,NULL,'2024-09-19 12:51:08','2024-09-19 12:51:08'),(1068,NULL,NULL,'2024-09-19 13:31:56','2024-09-19 13:31:56'),(1069,NULL,NULL,'2024-09-19 13:47:35','2024-09-19 13:47:35'),(1070,NULL,NULL,'2024-09-19 13:54:46','2024-09-19 13:54:46'),(1071,NULL,NULL,'2024-09-19 13:54:47','2024-09-19 13:54:47'),(1072,NULL,NULL,'2024-09-19 14:05:37','2024-09-19 14:05:37'),(1073,NULL,NULL,'2024-09-19 15:14:27','2024-09-19 15:14:27'),(1074,NULL,NULL,'2024-09-19 16:16:27','2024-09-19 16:16:27'),(1075,NULL,NULL,'2024-09-20 03:45:46','2024-09-20 03:45:46'),(1076,NULL,NULL,'2024-09-20 05:08:51','2024-09-20 05:09:12'),(1077,NULL,NULL,'2024-09-20 05:24:03','2024-09-20 05:24:03'),(1078,NULL,NULL,'2024-09-20 05:26:00','2024-09-20 05:42:54'),(1079,NULL,NULL,'2024-09-20 06:09:05','2024-09-20 06:09:05'),(1080,NULL,NULL,'2024-09-20 06:09:22','2024-09-20 06:09:46'),(1081,NULL,NULL,'2024-09-20 06:41:11','2024-09-20 07:11:42'),(1082,NULL,NULL,'2024-09-20 09:44:37','2024-09-20 09:44:50'),(1083,NULL,NULL,'2024-09-20 14:03:09','2024-09-20 14:03:34'),(1084,NULL,NULL,'2024-09-21 05:43:26','2024-09-21 05:52:16'),(1085,NULL,NULL,'2024-09-21 09:13:19','2024-09-21 09:41:18'),(1086,NULL,NULL,'2024-09-21 16:41:09','2024-09-21 16:41:09'),(1087,NULL,NULL,'2024-09-21 20:32:45','2024-09-21 20:32:45'),(1088,NULL,NULL,'2024-09-21 21:10:13','2024-09-21 21:10:13'),(1089,NULL,NULL,'2024-09-21 21:10:17','2024-09-21 21:10:17'),(1090,NULL,NULL,'2024-09-22 00:39:04','2024-09-22 00:39:04'),(1091,NULL,NULL,'2024-09-22 04:20:26','2024-09-22 04:20:26'),(1092,NULL,NULL,'2024-09-22 04:20:27','2024-09-22 04:20:27'),(1093,NULL,NULL,'2024-09-22 04:35:33','2024-09-22 04:35:33'),(1094,NULL,NULL,'2024-09-22 10:24:33','2024-09-22 10:24:33'),(1095,NULL,NULL,'2024-09-22 10:24:34','2024-09-22 10:24:34'),(1096,NULL,NULL,'2024-09-22 11:01:40','2024-09-22 11:01:40'),(1097,NULL,NULL,'2024-09-22 12:36:53','2024-09-22 12:36:53'),(1098,NULL,NULL,'2024-09-23 00:40:17','2024-09-23 00:40:17'),(1099,NULL,NULL,'2024-09-23 00:40:22','2024-09-23 00:40:22'),(1100,NULL,NULL,'2024-09-23 05:18:52','2024-09-23 05:44:39'),(1101,NULL,NULL,'2024-09-23 06:28:34','2024-09-23 06:33:35'),(1102,NULL,NULL,'2024-09-23 07:26:11','2024-09-23 07:26:11'),(1103,NULL,NULL,'2024-09-23 07:50:11','2024-09-23 07:50:11'),(1104,NULL,NULL,'2024-09-23 07:57:28','2024-09-23 07:57:28'),(1105,NULL,NULL,'2024-09-23 08:02:23','2024-09-23 08:15:16'),(1106,NULL,NULL,'2024-09-23 08:30:28','2024-09-23 08:30:28'),(1107,NULL,NULL,'2024-09-23 09:22:31','2024-09-23 09:22:31'),(1108,NULL,NULL,'2024-09-23 09:33:32','2024-09-23 09:33:50'),(1109,NULL,NULL,'2024-09-23 10:15:06','2024-09-23 12:11:08'),(1110,NULL,NULL,'2024-09-23 12:26:02','2024-09-23 12:26:02'),(1111,NULL,NULL,'2024-09-23 12:41:03','2024-09-23 12:41:03'),(1112,NULL,NULL,'2024-09-23 12:56:17','2024-09-23 12:56:17'),(1113,NULL,NULL,'2024-09-23 13:26:20','2024-09-23 13:26:20'),(1114,NULL,NULL,'2024-09-23 13:42:25','2024-09-23 13:42:25'),(1115,NULL,NULL,'2024-09-23 13:59:06','2024-09-23 13:59:06'),(1116,NULL,NULL,'2024-09-23 14:15:08','2024-09-23 14:15:08'),(1117,NULL,NULL,'2024-09-23 14:40:18','2024-09-23 14:40:18'),(1118,NULL,NULL,'2024-09-23 14:55:23','2024-09-23 14:55:23'),(1119,NULL,NULL,'2024-09-23 15:25:40','2024-09-23 15:25:40'),(1120,NULL,NULL,'2024-09-23 15:40:43','2024-09-23 15:40:43'),(1121,NULL,NULL,'2024-09-23 15:41:28','2024-09-23 15:41:28'),(1122,NULL,NULL,'2024-09-23 20:03:00','2024-09-23 20:03:00'),(1123,NULL,NULL,'2024-09-24 05:51:28','2024-09-24 05:51:28'),(1124,NULL,NULL,'2024-09-24 06:55:08','2024-09-24 06:55:08'),(1125,NULL,NULL,'2024-09-24 06:56:30','2024-09-24 06:56:30'),(1126,NULL,NULL,'2024-09-24 07:06:45','2024-09-24 07:06:45'),(1127,NULL,NULL,'2024-09-24 07:22:25','2024-09-24 07:22:25'),(1128,NULL,NULL,'2024-09-24 07:26:17','2024-09-24 07:26:17'),(1129,NULL,NULL,'2024-09-24 07:27:06','2024-09-24 07:27:06'),(1130,NULL,NULL,'2024-09-24 07:32:54','2024-09-24 07:32:54'),(1131,NULL,NULL,'2024-09-24 07:32:54','2024-09-24 07:32:54'),(1132,NULL,NULL,'2024-09-24 07:38:40','2024-09-24 07:38:40'),(1133,NULL,NULL,'2024-09-24 07:56:44','2024-09-24 07:56:44'),(1134,NULL,NULL,'2024-09-24 07:57:43','2024-09-24 07:57:43'),(1135,NULL,NULL,'2024-09-24 08:02:34','2024-09-24 08:02:34'),(1136,NULL,NULL,'2024-09-24 08:46:23','2024-09-24 08:46:23'),(1137,NULL,NULL,'2024-09-24 09:01:30','2024-09-24 09:01:30'),(1138,NULL,NULL,'2024-09-24 09:14:27','2024-09-24 09:14:27'),(1139,NULL,NULL,'2024-09-24 09:15:14','2024-09-24 09:15:14'),(1140,NULL,NULL,'2024-09-24 09:15:40','2024-09-24 09:15:40'),(1141,NULL,NULL,'2024-09-24 09:16:06','2024-09-24 09:16:06'),(1142,NULL,NULL,'2024-09-24 09:17:34','2024-09-24 09:17:34'),(1143,NULL,NULL,'2024-09-24 09:21:30','2024-09-24 09:21:31'),(1144,NULL,NULL,'2024-09-24 10:10:20','2024-09-24 10:29:26'),(1145,NULL,NULL,'2024-09-24 10:41:44','2024-09-24 10:41:44'),(1146,NULL,NULL,'2024-09-24 11:22:54','2024-09-24 11:22:54'),(1147,NULL,NULL,'2024-09-24 11:47:54','2024-09-24 11:48:08'),(1148,NULL,NULL,'2024-09-24 15:05:44','2024-09-24 15:05:44'),(1149,NULL,NULL,'2024-09-24 17:28:15','2024-09-24 17:28:15'),(1150,NULL,NULL,'2024-09-24 19:00:43','2024-09-24 19:00:43'),(1151,NULL,NULL,'2024-09-25 05:09:19','2024-09-25 06:14:19'),(1152,1,NULL,'2024-09-25 08:20:00','2024-09-25 08:20:02'),(1153,NULL,NULL,'2024-09-25 09:24:25','2024-09-25 09:24:25'),(1154,NULL,NULL,'2024-09-25 09:50:00','2024-09-25 09:50:00'),(1155,NULL,NULL,'2024-09-25 10:08:50','2024-09-25 10:08:50'),(1156,NULL,NULL,'2024-09-25 10:56:59','2024-09-25 10:57:01'),(1157,NULL,NULL,'2024-09-25 15:09:18','2024-09-25 15:10:16'),(1158,NULL,NULL,'2024-09-25 16:20:10','2024-09-25 16:20:10'),(1159,NULL,NULL,'2024-09-25 22:03:15','2024-09-25 22:03:15'),(1160,NULL,NULL,'2024-09-25 22:03:15','2024-09-25 22:03:15'),(1161,NULL,NULL,'2024-09-25 22:36:20','2024-09-25 22:36:20'),(1162,NULL,NULL,'2024-09-26 09:46:52','2024-09-26 09:46:52'),(1163,NULL,NULL,'2024-09-26 09:48:42','2024-09-26 09:48:42'),(1164,NULL,NULL,'2024-09-26 09:53:02','2024-09-26 09:53:02'),(1165,NULL,NULL,'2024-09-26 09:55:17','2024-09-26 09:55:17'),(1166,NULL,NULL,'2024-09-26 09:59:01','2024-09-26 09:59:01'),(1167,NULL,NULL,'2024-09-26 10:00:36','2024-09-26 10:00:36'),(1168,NULL,NULL,'2024-09-26 22:41:01','2024-09-26 22:41:01'),(1169,NULL,NULL,'2024-09-27 00:28:30','2024-09-27 00:28:30'),(1170,NULL,NULL,'2024-09-27 07:46:26','2024-09-27 07:46:26'),(1171,NULL,NULL,'2024-09-27 07:46:26','2024-09-27 07:46:26'),(1172,NULL,NULL,'2024-09-27 08:15:04','2024-09-27 08:15:04'),(1173,NULL,NULL,'2024-09-27 08:36:48','2024-09-27 08:36:48'),(1174,NULL,NULL,'2024-09-27 15:21:16','2024-09-27 15:21:16'),(1175,NULL,NULL,'2024-09-27 20:19:21','2024-09-27 20:19:21'),(1176,NULL,NULL,'2024-09-28 00:23:41','2024-09-28 00:23:41'),(1177,NULL,NULL,'2024-09-28 00:23:42','2024-09-28 00:23:42'),(1178,NULL,NULL,'2024-09-28 01:28:01','2024-09-28 01:28:01'),(1179,NULL,NULL,'2024-09-28 01:31:21','2024-09-28 01:31:21'),(1180,NULL,NULL,'2024-09-28 09:20:59','2024-09-28 09:20:59'),(1181,NULL,NULL,'2024-09-28 09:23:44','2024-09-28 09:23:44'),(1182,NULL,NULL,'2024-09-28 09:26:22','2024-09-28 09:26:22'),(1183,NULL,NULL,'2024-09-28 09:29:13','2024-09-28 09:29:13'),(1184,NULL,NULL,'2024-09-28 23:07:31','2024-09-28 23:07:31'),(1185,NULL,NULL,'2024-09-28 23:20:53','2024-09-28 23:20:53'),(1186,NULL,NULL,'2024-09-29 03:13:46','2024-09-29 03:13:46'),(1187,NULL,NULL,'2024-09-29 05:17:09','2024-09-29 05:17:09'),(1188,NULL,NULL,'2024-09-29 15:23:53','2024-09-29 15:23:53'),(1189,NULL,NULL,'2024-09-30 08:30:31','2024-09-30 08:30:31'),(1190,NULL,NULL,'2024-09-30 08:32:18','2024-09-30 08:32:18'),(1191,NULL,NULL,'2024-09-30 08:47:45','2024-09-30 08:47:45'),(1192,NULL,NULL,'2024-09-30 11:28:34','2024-09-30 11:28:34'),(1193,NULL,NULL,'2024-09-30 16:51:47','2024-09-30 16:51:47'),(1194,NULL,NULL,'2024-09-30 22:26:45','2024-09-30 22:26:45'),(1195,NULL,NULL,'2024-09-30 23:08:47','2024-09-30 23:08:47'),(1196,NULL,NULL,'2024-10-01 07:52:35','2024-10-01 07:52:35'),(1197,NULL,NULL,'2024-10-01 08:04:26','2024-10-01 08:04:26'),(1198,NULL,NULL,'2024-10-01 08:05:06','2024-10-01 08:05:06'),(1199,NULL,NULL,'2024-10-01 08:06:37','2024-10-01 08:06:37'),(1200,NULL,NULL,'2024-10-01 08:23:35','2024-10-01 08:23:35'),(1201,NULL,NULL,'2024-10-01 08:31:02','2024-10-01 08:31:02'),(1202,NULL,NULL,'2024-10-01 09:29:44','2024-10-01 09:29:44'),(1203,NULL,NULL,'2024-10-01 09:33:55','2024-10-01 09:33:55'),(1204,NULL,NULL,'2024-10-01 09:40:11','2024-10-01 09:40:11'),(1205,NULL,NULL,'2024-10-01 12:14:36','2024-10-01 12:14:36'),(1206,NULL,NULL,'2024-10-01 15:12:47','2024-10-01 15:12:47'),(1207,NULL,NULL,'2024-10-01 17:04:01','2024-10-01 17:04:01'),(1208,NULL,NULL,'2024-10-02 02:05:22','2024-10-02 02:05:22'),(1209,NULL,NULL,'2024-10-02 05:37:35','2024-10-02 05:37:35'),(1210,NULL,NULL,'2024-10-02 15:27:47','2024-10-02 15:27:47'),(1211,NULL,NULL,'2024-10-02 15:43:58','2024-10-02 15:43:58'),(1212,NULL,NULL,'2024-10-02 23:02:33','2024-10-02 23:02:33'),(1213,NULL,NULL,'2024-10-03 08:00:51','2024-10-03 08:00:51'),(1214,NULL,NULL,'2024-10-03 08:15:53','2024-10-03 08:15:53'),(1215,NULL,NULL,'2024-10-03 09:01:30','2024-10-03 09:01:30'),(1216,NULL,NULL,'2024-10-03 09:17:10','2024-10-03 09:17:10'),(1217,NULL,NULL,'2024-10-03 09:32:38','2024-10-03 09:32:38'),(1218,NULL,NULL,'2024-10-03 09:33:46','2024-10-03 09:33:46'),(1219,NULL,NULL,'2024-10-03 09:51:11','2024-10-03 09:51:11'),(1220,NULL,NULL,'2024-10-03 09:51:44','2024-10-03 09:51:44'),(1221,NULL,NULL,'2024-10-03 10:00:47','2024-10-03 10:00:47'),(1222,NULL,NULL,'2024-10-03 10:02:06','2024-10-03 10:02:06'),(1223,NULL,NULL,'2024-10-03 10:11:05','2024-10-03 10:11:05'),(1224,NULL,NULL,'2024-10-03 10:13:11','2024-10-03 10:13:11'),(1225,NULL,NULL,'2024-10-03 10:22:40','2024-10-03 10:22:40'),(1226,NULL,NULL,'2024-10-03 10:23:58','2024-10-03 10:23:58'),(1227,NULL,NULL,'2024-10-03 10:25:44','2024-10-03 10:25:44'),(1228,NULL,NULL,'2024-10-03 11:56:22','2024-10-03 11:56:22'),(1229,NULL,NULL,'2024-10-03 11:59:04','2024-10-03 11:59:04'),(1230,NULL,NULL,'2024-10-03 12:15:24','2024-10-03 12:15:24'),(1231,NULL,NULL,'2024-10-03 12:31:45','2024-10-03 12:31:45'),(1232,NULL,NULL,'2024-10-03 12:47:00','2024-10-03 12:47:00'),(1233,NULL,NULL,'2024-10-03 13:35:41','2024-10-03 13:35:41'),(1234,NULL,NULL,'2024-10-03 13:51:26','2024-10-03 13:51:26'),(1235,NULL,NULL,'2024-10-03 14:26:01','2024-10-03 14:26:01'),(1236,NULL,NULL,'2024-10-03 14:30:53','2024-10-03 14:30:53'),(1237,NULL,NULL,'2024-10-03 14:32:34','2024-10-03 14:32:34'),(1238,NULL,NULL,'2024-10-03 14:58:19','2024-10-03 14:58:19'),(1239,NULL,NULL,'2024-10-03 15:00:34','2024-10-03 15:00:34'),(1240,NULL,NULL,'2024-10-03 15:11:49','2024-10-03 15:11:49'),(1241,NULL,NULL,'2024-10-03 18:09:40','2024-10-03 18:09:40'),(1242,NULL,NULL,'2024-10-04 05:58:00','2024-10-04 05:58:00'),(1243,NULL,NULL,'2024-10-04 06:34:53','2024-10-04 06:34:53'),(1244,NULL,NULL,'2024-10-04 06:50:50','2024-10-04 06:50:50'),(1245,NULL,NULL,'2024-10-04 07:29:59','2024-10-04 07:29:59'),(1246,NULL,NULL,'2024-10-04 07:45:00','2024-10-04 07:45:00'),(1247,NULL,NULL,'2024-10-04 08:03:13','2024-10-04 08:03:13'),(1248,NULL,NULL,'2024-10-04 09:37:19','2024-10-04 09:37:19'),(1249,NULL,NULL,'2024-10-04 11:25:25','2024-10-04 11:25:25'),(1250,NULL,NULL,'2024-10-04 12:03:50','2024-10-04 12:03:50'),(1251,NULL,NULL,'2024-10-04 12:18:52','2024-10-04 12:18:52'),(1252,NULL,NULL,'2024-10-04 12:37:24','2024-10-04 12:37:24'),(1253,NULL,NULL,'2024-10-04 13:26:13','2024-10-04 13:26:13'),(1254,NULL,NULL,'2024-10-04 13:41:34','2024-10-04 13:41:34'),(1255,NULL,NULL,'2024-10-04 13:56:43','2024-10-04 13:56:43'),(1256,NULL,NULL,'2024-10-04 14:17:27','2024-10-04 14:17:27'),(1257,NULL,NULL,'2024-10-04 14:32:35','2024-10-04 14:32:35'),(1258,NULL,NULL,'2024-10-04 21:26:49','2024-10-04 21:26:49'),(1259,NULL,NULL,'2024-10-04 21:26:57','2024-10-04 21:26:57'),(1260,NULL,NULL,'2024-10-05 10:06:24','2024-10-05 10:06:24'),(1261,NULL,NULL,'2024-10-05 15:12:50','2024-10-05 15:12:50'),(1262,NULL,NULL,'2024-10-05 15:33:44','2024-10-05 15:33:44'),(1263,NULL,NULL,'2024-10-06 09:24:50','2024-10-06 09:24:50'),(1264,NULL,NULL,'2024-10-07 06:48:52','2024-10-07 06:48:52'),(1265,NULL,NULL,'2024-10-07 07:04:03','2024-10-07 07:04:03'),(1266,NULL,NULL,'2024-10-07 07:05:26','2024-10-07 07:05:26'),(1267,NULL,NULL,'2024-10-07 07:19:41','2024-10-07 07:19:41'),(1268,NULL,NULL,'2024-10-07 07:23:09','2024-10-07 07:23:09'),(1269,NULL,NULL,'2024-10-07 07:27:53','2024-10-07 07:27:53'),(1270,NULL,NULL,'2024-10-07 07:40:14','2024-10-07 07:40:14'),(1271,NULL,NULL,'2024-10-07 07:43:50','2024-10-07 07:43:50'),(1272,NULL,NULL,'2024-10-07 08:01:38','2024-10-07 08:01:38'),(1273,NULL,NULL,'2024-10-07 08:18:00','2024-10-07 08:18:00'),(1274,NULL,NULL,'2024-10-07 08:21:23','2024-10-07 08:21:23'),(1275,NULL,NULL,'2024-10-07 08:22:12','2024-10-07 08:22:12'),(1276,NULL,NULL,'2024-10-07 08:24:41','2024-10-07 08:24:41'),(1277,NULL,NULL,'2024-10-07 08:25:46','2024-10-07 08:25:46'),(1278,NULL,NULL,'2024-10-07 09:01:22','2024-10-07 09:01:22'),(1279,NULL,NULL,'2024-10-07 09:16:39','2024-10-07 09:16:39'),(1280,NULL,NULL,'2024-10-07 09:32:15','2024-10-07 09:32:15'),(1281,NULL,NULL,'2024-10-07 09:44:31','2024-10-07 09:44:31'),(1282,NULL,NULL,'2024-10-07 09:46:20','2024-10-07 09:46:20'),(1283,NULL,NULL,'2024-10-07 09:56:00','2024-10-07 09:56:01'),(1284,NULL,NULL,'2024-10-07 10:11:44','2024-10-07 10:11:44'),(1285,NULL,NULL,'2024-10-07 10:16:36','2024-10-07 10:16:36'),(1286,NULL,NULL,'2024-10-07 10:58:34','2024-10-07 10:58:34'),(1287,NULL,NULL,'2024-10-07 11:20:45','2024-10-07 11:20:45'),(1288,NULL,NULL,'2024-10-07 11:28:17','2024-10-07 11:28:17'),(1289,NULL,NULL,'2024-10-07 11:54:25','2024-10-07 11:54:25'),(1290,NULL,NULL,'2024-10-07 11:56:20','2024-10-07 11:56:20'),(1291,NULL,NULL,'2024-10-07 12:05:27','2024-10-07 12:05:27'),(1292,NULL,NULL,'2024-10-07 12:20:32','2024-10-07 12:20:32'),(1293,NULL,NULL,'2024-10-07 12:37:10','2024-10-07 12:37:10'),(1294,NULL,NULL,'2024-10-07 13:22:19','2024-10-07 13:22:19'),(1295,NULL,NULL,'2024-10-07 13:37:26','2024-10-07 13:37:26'),(1296,NULL,NULL,'2024-10-07 13:55:54','2024-10-07 13:55:54'),(1297,NULL,NULL,'2024-10-07 13:58:18','2024-10-07 13:58:18'),(1298,NULL,NULL,'2024-10-07 14:12:13','2024-10-07 14:12:13'),(1299,NULL,NULL,'2024-10-07 14:27:18','2024-10-07 14:27:18'),(1300,NULL,NULL,'2024-10-07 14:39:36','2024-10-07 14:39:36'),(1301,NULL,NULL,'2024-10-07 14:49:02','2024-10-07 14:49:02'),(1302,NULL,NULL,'2024-10-07 15:16:08','2024-10-07 15:16:08'),(1303,NULL,NULL,'2024-10-07 20:47:16','2024-10-07 20:47:16'),(1304,NULL,NULL,'2024-10-07 20:49:21','2024-10-07 20:49:21'),(1305,NULL,NULL,'2024-10-07 20:51:56','2024-10-07 20:51:56'),(1306,NULL,NULL,'2024-10-08 08:30:48','2024-10-08 08:30:48'),(1307,NULL,NULL,'2024-10-08 08:53:18','2024-10-08 08:53:18'),(1308,NULL,NULL,'2024-10-08 08:56:44','2024-10-08 08:56:44'),(1309,NULL,NULL,'2024-10-08 09:25:10','2024-10-08 09:25:10'),(1310,NULL,NULL,'2024-10-08 10:05:42','2024-10-08 10:05:42'),(1311,NULL,NULL,'2024-10-08 10:59:47','2024-10-08 10:59:47'),(1312,NULL,NULL,'2024-10-08 11:10:24','2024-10-08 11:10:24'),(1313,NULL,NULL,'2024-10-08 11:11:44','2024-10-08 11:11:44'),(1314,NULL,NULL,'2024-10-08 11:16:43','2024-10-08 11:16:43'),(1315,NULL,NULL,'2024-10-08 11:25:14','2024-10-08 11:25:15'),(1316,NULL,NULL,'2024-10-08 11:30:19','2024-10-08 11:30:19'),(1317,NULL,NULL,'2024-10-08 11:52:53','2024-10-08 11:52:53'),(1318,NULL,NULL,'2024-10-08 12:08:03','2024-10-08 12:08:03'),(1319,NULL,NULL,'2024-10-08 12:23:07','2024-10-08 12:23:07'),(1320,NULL,NULL,'2024-10-08 13:05:46','2024-10-08 13:05:46'),(1321,NULL,NULL,'2024-10-08 13:30:25','2024-10-08 13:30:25'),(1322,NULL,NULL,'2024-10-08 14:12:44','2024-10-08 14:12:44'),(1323,NULL,NULL,'2024-10-08 14:34:06','2024-10-08 14:34:06'),(1324,NULL,NULL,'2024-10-09 08:28:07','2024-10-09 08:28:07'),(1325,NULL,NULL,'2024-10-09 14:42:01','2024-10-09 14:42:01'),(1326,NULL,NULL,'2024-10-09 15:53:44','2024-10-09 15:53:44'),(1327,NULL,NULL,'2024-10-09 15:55:39','2024-10-09 15:55:39'),(1328,NULL,NULL,'2024-10-10 02:17:40','2024-10-10 02:17:40'),(1329,NULL,NULL,'2024-10-10 08:11:14','2024-10-10 08:11:14'),(1330,NULL,NULL,'2024-10-10 09:37:44','2024-10-10 09:37:44'),(1331,NULL,NULL,'2024-10-10 19:25:31','2024-10-10 19:25:31'),(1332,NULL,NULL,'2024-10-11 05:03:12','2024-10-11 05:03:12'),(1333,NULL,NULL,'2024-10-11 08:26:28','2024-10-11 08:26:28'),(1334,NULL,NULL,'2024-10-11 15:10:36','2024-10-11 15:10:36'),(1335,NULL,NULL,'2024-10-11 20:48:56','2024-10-11 20:48:56'),(1336,NULL,NULL,'2024-10-12 03:44:56','2024-10-12 03:44:56'),(1337,NULL,NULL,'2024-10-12 03:44:57','2024-10-12 03:44:57'),(1338,NULL,NULL,'2024-10-12 14:22:32','2024-10-12 14:22:32'),(1339,NULL,NULL,'2024-10-12 16:11:56','2024-10-12 16:11:56'),(1340,NULL,NULL,'2024-10-12 18:03:14','2024-10-12 18:03:14'),(1341,NULL,NULL,'2024-10-12 19:41:35','2024-10-12 19:41:35'),(1342,NULL,NULL,'2024-10-12 20:10:02','2024-10-12 20:10:02'),(1343,NULL,NULL,'2024-10-12 20:55:34','2024-10-12 20:55:34'),(1344,NULL,NULL,'2024-10-12 21:12:14','2024-10-12 21:12:14'),(1345,NULL,NULL,'2024-10-12 23:50:08','2024-10-12 23:50:09'),(1346,NULL,NULL,'2024-10-13 00:07:02','2024-10-13 00:07:02'),(1347,NULL,NULL,'2024-10-13 00:57:22','2024-10-13 00:57:22'),(1348,NULL,NULL,'2024-10-13 01:59:31','2024-10-13 01:59:31'),(1349,NULL,NULL,'2024-10-13 15:12:20','2024-10-13 15:12:20'),(1350,NULL,NULL,'2024-10-14 04:26:32','2024-10-14 04:26:32'),(1351,NULL,NULL,'2024-10-14 06:18:55','2024-10-14 06:18:55'),(1352,NULL,NULL,'2024-10-14 06:40:31','2024-10-14 06:40:31'),(1353,NULL,NULL,'2024-10-14 06:46:22','2024-10-14 06:46:22'),(1354,NULL,NULL,'2024-10-14 06:47:45','2024-10-14 06:47:45'),(1355,NULL,NULL,'2024-10-14 06:52:24','2024-10-14 06:52:24'),(1356,NULL,NULL,'2024-10-14 07:32:16','2024-10-14 07:32:17'),(1357,NULL,NULL,'2024-10-14 08:26:22','2024-10-14 08:26:22'),(1358,NULL,NULL,'2024-10-14 08:30:33','2024-10-14 08:30:33'),(1359,NULL,NULL,'2024-10-14 08:34:09','2024-10-14 08:34:09'),(1360,NULL,NULL,'2024-10-14 08:40:56','2024-10-14 08:40:56'),(1361,NULL,NULL,'2024-10-14 09:25:34','2024-10-14 09:25:34'),(1362,NULL,NULL,'2024-10-14 09:50:11','2024-10-14 09:50:11'),(1363,NULL,NULL,'2024-10-14 09:58:07','2024-10-14 09:58:07'),(1364,NULL,NULL,'2024-10-14 10:03:41','2024-10-14 10:03:41'),(1365,NULL,NULL,'2024-10-14 10:08:16','2024-10-14 10:08:16'),(1366,NULL,NULL,'2024-10-14 10:16:24','2024-10-14 10:16:24'),(1367,NULL,NULL,'2024-10-14 10:22:41','2024-10-14 10:22:41'),(1368,NULL,NULL,'2024-10-14 10:39:53','2024-10-14 10:39:53'),(1369,NULL,NULL,'2024-10-14 11:41:54','2024-10-14 11:41:54'),(1370,NULL,NULL,'2024-10-14 12:33:48','2024-10-14 12:33:48'),(1371,NULL,NULL,'2024-10-14 12:33:55','2024-10-14 12:33:55'),(1372,NULL,NULL,'2024-10-14 12:33:57','2024-10-14 12:33:57'),(1373,NULL,NULL,'2024-10-14 12:34:00','2024-10-14 12:34:00'),(1374,NULL,NULL,'2024-10-14 12:34:02','2024-10-14 12:34:02'),(1375,NULL,NULL,'2024-10-14 12:34:04','2024-10-14 12:34:04'),(1376,NULL,NULL,'2024-10-14 12:34:05','2024-10-14 12:34:05'),(1377,NULL,NULL,'2024-10-14 12:34:07','2024-10-14 12:34:07'),(1378,NULL,NULL,'2024-10-14 12:34:09','2024-10-14 12:34:09'),(1379,NULL,NULL,'2024-10-14 12:34:11','2024-10-14 12:34:11'),(1380,NULL,NULL,'2024-10-14 12:34:14','2024-10-14 12:34:14'),(1381,NULL,NULL,'2024-10-14 12:34:16','2024-10-14 12:34:16'),(1382,NULL,NULL,'2024-10-14 12:34:19','2024-10-14 12:34:19'),(1383,NULL,NULL,'2024-10-14 12:34:21','2024-10-14 12:34:21'),(1384,NULL,NULL,'2024-10-14 12:34:23','2024-10-14 12:34:23'),(1385,NULL,NULL,'2024-10-14 12:34:26','2024-10-14 12:34:26'),(1386,NULL,NULL,'2024-10-14 12:34:29','2024-10-14 12:34:29'),(1387,NULL,NULL,'2024-10-14 12:34:32','2024-10-14 12:34:32'),(1388,NULL,NULL,'2024-10-14 12:34:44','2024-10-14 12:34:44'),(1389,NULL,NULL,'2024-10-14 12:34:49','2024-10-14 12:34:49'),(1390,NULL,NULL,'2024-10-15 05:58:03','2024-10-15 05:58:03'),(1391,NULL,NULL,'2024-10-15 06:00:45','2024-10-15 06:00:45'),(1392,NULL,NULL,'2024-10-15 08:21:22','2024-10-15 08:21:22'),(1393,NULL,NULL,'2024-10-15 09:38:15','2024-10-15 09:38:15'),(1394,NULL,NULL,'2024-10-15 09:46:46','2024-10-15 09:46:46'),(1395,NULL,NULL,'2024-10-15 10:30:49','2024-10-15 10:30:49'),(1396,NULL,NULL,'2024-10-15 15:14:38','2024-10-15 15:14:38'),(1397,NULL,NULL,'2024-10-16 03:12:13','2024-10-16 03:12:13'),(1398,NULL,NULL,'2024-10-16 09:26:22','2024-10-16 09:26:22'),(1399,NULL,NULL,'2024-10-16 10:02:41','2024-10-16 10:02:41'),(1400,NULL,NULL,'2024-10-16 17:30:20','2024-10-16 17:30:21'),(1401,NULL,NULL,'2024-10-17 02:26:27','2024-10-17 02:26:27'),(1402,NULL,NULL,'2024-10-17 06:53:08','2024-10-17 06:53:08'),(1403,NULL,NULL,'2024-10-17 06:57:48','2024-10-17 06:57:48'),(1404,NULL,NULL,'2024-10-17 07:57:30','2024-10-17 07:57:30'),(1405,NULL,NULL,'2024-10-17 07:57:33','2024-10-17 07:57:33'),(1406,NULL,NULL,'2024-10-17 07:58:22','2024-10-17 07:58:22'),(1407,NULL,NULL,'2024-10-17 08:24:52','2024-10-17 08:24:52'),(1408,NULL,NULL,'2024-10-17 10:12:08','2024-10-17 10:12:08'),(1409,NULL,NULL,'2024-10-17 10:13:47','2024-10-17 10:13:47'),(1410,NULL,NULL,'2024-10-17 10:18:01','2024-10-17 10:18:01'),(1411,NULL,NULL,'2024-10-17 10:21:06','2024-10-17 10:21:06'),(1412,NULL,NULL,'2024-10-17 10:21:53','2024-10-17 10:21:53'),(1413,NULL,NULL,'2024-10-17 10:26:24','2024-10-17 10:26:24'),(1414,NULL,NULL,'2024-10-17 14:53:11','2024-10-17 14:53:11'),(1415,NULL,NULL,'2024-10-17 15:45:09','2024-10-17 15:45:10'),(1416,NULL,NULL,'2024-10-17 20:41:19','2024-10-17 20:41:19'),(1417,NULL,NULL,'2024-10-18 03:20:11','2024-10-18 03:20:11'),(1418,NULL,NULL,'2024-10-18 05:47:49','2024-10-18 05:47:49'),(1419,NULL,NULL,'2024-10-18 05:50:29','2024-10-18 05:50:29'),(1420,NULL,NULL,'2024-10-18 06:46:26','2024-10-18 06:46:26'),(1421,NULL,NULL,'2024-10-18 07:13:04','2024-10-18 07:13:04'),(1422,NULL,NULL,'2024-10-18 07:28:08','2024-10-18 07:28:08'),(1423,NULL,NULL,'2024-10-18 07:59:45','2024-10-18 07:59:45'),(1424,NULL,NULL,'2024-10-18 08:03:06','2024-10-18 08:03:07'),(1425,NULL,NULL,'2024-10-18 08:13:42','2024-10-18 08:13:42'),(1426,NULL,NULL,'2024-10-18 08:18:45','2024-10-18 08:18:45'),(1427,NULL,NULL,'2024-10-18 08:21:38','2024-10-18 08:21:38'),(1428,NULL,NULL,'2024-10-18 08:29:13','2024-10-18 08:29:13'),(1429,NULL,NULL,'2024-10-18 10:42:39','2024-10-18 10:42:39'),(1430,NULL,NULL,'2024-10-18 10:46:13','2024-10-18 10:46:13'),(1431,NULL,NULL,'2024-10-18 10:49:30','2024-10-18 10:49:30'),(1432,NULL,NULL,'2024-10-18 11:09:29','2024-10-18 11:09:29'),(1433,NULL,NULL,'2024-10-18 11:47:35','2024-10-18 11:47:35'),(1434,NULL,NULL,'2024-10-18 12:14:59','2024-10-18 12:14:59'),(1435,NULL,NULL,'2024-10-18 13:45:28','2024-10-18 13:45:28'),(1436,NULL,NULL,'2024-10-18 14:16:24','2024-10-18 14:16:24'),(1437,NULL,NULL,'2024-10-18 14:58:11','2024-10-18 14:58:11'),(1438,NULL,NULL,'2024-10-18 15:14:08','2024-10-18 15:14:08'),(1439,NULL,NULL,'2024-10-18 15:29:19','2024-10-18 15:29:19'),(1440,NULL,NULL,'2024-10-19 13:08:19','2024-10-19 13:08:19'),(1441,NULL,NULL,'2024-10-19 15:58:52','2024-10-19 15:58:52'),(1442,NULL,NULL,'2024-10-19 20:38:45','2024-10-19 20:38:45'),(1443,NULL,NULL,'2024-10-19 23:01:39','2024-10-19 23:01:39'),(1444,NULL,NULL,'2024-10-19 23:01:48','2024-10-19 23:01:48'),(1445,NULL,NULL,'2024-10-20 15:01:40','2024-10-20 15:01:40'),(1446,NULL,NULL,'2024-10-21 05:16:25','2024-10-21 05:16:25'),(1447,NULL,NULL,'2024-10-21 05:17:38','2024-10-21 05:17:38'),(1448,NULL,NULL,'2024-10-21 05:36:03','2024-10-21 05:36:03'),(1449,NULL,NULL,'2024-10-21 05:52:41','2024-10-21 05:52:41'),(1450,NULL,NULL,'2024-10-21 07:09:12','2024-10-21 07:09:12'),(1451,NULL,NULL,'2024-10-21 07:17:25','2024-10-21 07:17:25'),(1452,NULL,NULL,'2024-10-21 07:22:40','2024-10-21 07:22:40'),(1453,NULL,NULL,'2024-10-21 07:25:14','2024-10-21 07:25:14'),(1454,NULL,NULL,'2024-10-21 07:29:43','2024-10-21 07:29:43'),(1455,NULL,NULL,'2024-10-21 07:31:15','2024-10-21 07:31:15'),(1456,NULL,NULL,'2024-10-21 07:33:37','2024-10-21 07:33:37'),(1457,NULL,NULL,'2024-10-21 07:36:50','2024-10-21 07:36:50'),(1458,NULL,NULL,'2024-10-21 07:38:45','2024-10-21 07:38:45'),(1459,NULL,NULL,'2024-10-21 07:40:21','2024-10-21 07:40:21'),(1460,NULL,NULL,'2024-10-21 07:43:16','2024-10-21 07:43:17'),(1461,NULL,NULL,'2024-10-21 07:46:45','2024-10-21 07:46:45'),(1462,NULL,NULL,'2024-10-21 07:47:33','2024-10-21 07:47:33'),(1463,NULL,NULL,'2024-10-21 07:53:48','2024-10-21 07:53:48'),(1464,NULL,NULL,'2024-10-21 07:55:30','2024-10-21 07:55:30'),(1465,NULL,NULL,'2024-10-21 08:02:33','2024-10-21 08:02:33'),(1466,NULL,NULL,'2024-10-21 08:03:41','2024-10-21 08:03:41'),(1467,NULL,NULL,'2024-10-21 08:13:28','2024-10-21 08:13:28'),(1468,NULL,NULL,'2024-10-21 08:25:58','2024-10-21 08:25:58'),(1469,NULL,NULL,'2024-10-21 09:00:31','2024-10-21 09:00:31'),(1470,NULL,NULL,'2024-10-21 09:18:57','2024-10-21 09:18:57'),(1471,NULL,NULL,'2024-10-21 09:41:28','2024-10-21 09:41:28'),(1472,NULL,NULL,'2024-10-21 10:10:33','2024-10-21 10:10:33'),(1473,NULL,NULL,'2024-10-21 10:17:07','2024-10-21 10:17:07'),(1474,NULL,NULL,'2024-10-21 10:40:20','2024-10-21 10:40:20'),(1475,NULL,NULL,'2024-10-21 10:46:58','2024-10-21 10:46:58'),(1476,NULL,NULL,'2024-10-21 10:57:52','2024-10-21 10:57:52'),(1477,NULL,NULL,'2024-10-21 11:10:08','2024-10-21 11:10:08'),(1478,NULL,NULL,'2024-10-21 11:37:13','2024-10-21 11:37:13'),(1479,NULL,NULL,'2024-10-21 12:07:42','2024-10-21 12:07:42'),(1480,NULL,NULL,'2024-10-21 12:48:14','2024-10-21 12:48:14'),(1481,NULL,NULL,'2024-10-21 13:19:11','2024-10-21 13:19:11'),(1482,NULL,NULL,'2024-10-21 13:35:15','2024-10-21 13:35:15'),(1483,NULL,NULL,'2024-10-21 14:07:14','2024-10-21 14:07:14'),(1484,NULL,NULL,'2024-10-21 14:52:40','2024-10-21 14:52:40'),(1485,NULL,NULL,'2024-10-21 15:10:59','2024-10-21 15:10:59'),(1486,NULL,NULL,'2024-10-21 16:24:18','2024-10-21 16:24:18'),(1487,NULL,NULL,'2024-10-22 07:17:59','2024-10-22 07:17:59'),(1488,NULL,NULL,'2024-10-22 07:38:33','2024-10-22 07:38:33'),(1489,NULL,NULL,'2024-10-22 08:00:49','2024-10-22 08:00:49'),(1490,NULL,NULL,'2024-10-22 08:09:55','2024-10-22 08:09:55'),(1491,NULL,NULL,'2024-10-22 08:10:37','2024-10-22 08:10:37'),(1492,NULL,NULL,'2024-10-22 08:54:00','2024-10-22 08:54:00'),(1493,NULL,NULL,'2024-10-22 09:18:01','2024-10-22 09:18:01'),(1494,NULL,NULL,'2024-10-22 10:14:45','2024-10-22 10:14:45'),(1495,NULL,NULL,'2024-10-22 13:10:49','2024-10-22 13:10:49'),(1496,NULL,NULL,'2024-10-22 13:27:13','2024-10-22 13:27:13'),(1497,NULL,NULL,'2024-10-22 13:45:24','2024-10-22 13:45:24'),(1498,NULL,NULL,'2024-10-22 14:07:57','2024-10-22 14:07:57'),(1499,NULL,NULL,'2024-10-22 14:28:08','2024-10-22 14:28:08'),(1500,NULL,NULL,'2024-10-22 14:49:14','2024-10-22 14:49:14'),(1501,NULL,NULL,'2024-10-22 15:10:32','2024-10-22 15:10:32'),(1502,NULL,NULL,'2024-10-22 15:37:45','2024-10-22 15:37:45'),(1503,NULL,NULL,'2024-10-23 06:12:10','2024-10-23 06:12:10'),(1504,NULL,NULL,'2024-10-23 06:22:20','2024-10-23 06:22:20'),(1505,NULL,NULL,'2024-10-23 06:23:57','2024-10-23 06:23:57'),(1506,NULL,NULL,'2024-10-23 06:41:12','2024-10-23 06:41:12'),(1507,NULL,NULL,'2024-10-23 06:45:00','2024-10-23 06:45:00'),(1508,NULL,NULL,'2024-10-23 06:52:09','2024-10-23 06:52:10'),(1509,NULL,NULL,'2024-10-23 06:54:15','2024-10-23 06:54:15'),(1510,NULL,NULL,'2024-10-23 07:07:01','2024-10-23 07:07:01'),(1511,NULL,NULL,'2024-10-23 07:10:30','2024-10-23 07:10:31'),(1512,NULL,NULL,'2024-10-23 07:17:25','2024-10-23 07:17:25'),(1513,NULL,NULL,'2024-10-23 07:27:25','2024-10-23 07:27:25'),(1514,NULL,NULL,'2024-10-23 07:31:10','2024-10-23 07:31:10'),(1515,NULL,NULL,'2024-10-23 07:37:04','2024-10-23 07:37:04'),(1516,NULL,NULL,'2024-10-23 07:39:11','2024-10-23 07:39:11'),(1517,NULL,NULL,'2024-10-23 07:46:22','2024-10-23 07:46:22'),(1518,NULL,NULL,'2024-10-23 07:47:28','2024-10-23 07:47:29'),(1519,NULL,NULL,'2024-10-23 07:49:39','2024-10-23 07:49:39'),(1520,NULL,NULL,'2024-10-23 07:57:03','2024-10-23 07:57:03'),(1521,NULL,NULL,'2024-10-23 08:03:52','2024-10-23 08:03:52'),(1522,NULL,NULL,'2024-10-23 09:00:35','2024-10-23 09:00:35'),(1523,NULL,NULL,'2024-10-23 09:24:47','2024-10-23 09:24:47'),(1524,NULL,NULL,'2024-10-23 09:39:51','2024-10-23 09:39:51'),(1525,NULL,NULL,'2024-10-23 09:42:33','2024-10-23 09:42:33'),(1526,NULL,NULL,'2024-10-23 10:00:58','2024-10-23 10:00:58'),(1527,NULL,NULL,'2024-10-23 10:04:51','2024-10-23 10:04:51'),(1528,NULL,NULL,'2024-10-23 10:08:19','2024-10-23 10:08:19'),(1529,NULL,NULL,'2024-10-23 10:17:36','2024-10-23 10:17:36'),(1530,NULL,NULL,'2024-10-23 10:18:15','2024-10-23 10:18:15'),(1531,NULL,NULL,'2024-10-23 10:25:40','2024-10-23 10:25:40'),(1532,NULL,NULL,'2024-10-23 10:32:54','2024-10-23 10:32:54'),(1533,NULL,NULL,'2024-10-23 10:34:16','2024-10-23 10:34:16'),(1534,NULL,NULL,'2024-10-23 10:39:10','2024-10-23 10:39:10'),(1535,NULL,NULL,'2024-10-23 10:40:15','2024-10-23 10:40:15'),(1536,NULL,NULL,'2024-10-23 11:09:14','2024-10-23 11:09:14'),(1537,NULL,NULL,'2024-10-23 11:40:58','2024-10-23 11:40:58'),(1538,NULL,NULL,'2024-10-23 13:25:08','2024-10-23 13:25:08'),(1539,NULL,NULL,'2024-10-23 13:46:03','2024-10-23 13:46:03'),(1540,NULL,NULL,'2024-10-23 14:01:17','2024-10-23 14:01:17'),(1541,NULL,NULL,'2024-10-23 14:32:39','2024-10-23 14:32:39'),(1542,NULL,NULL,'2024-10-23 14:48:55','2024-10-23 14:48:55'),(1543,NULL,NULL,'2024-10-23 15:02:20','2024-10-23 15:02:20'),(1544,NULL,NULL,'2024-10-23 15:04:33','2024-10-23 15:04:34'),(1545,NULL,NULL,'2024-10-24 06:22:03','2024-10-24 06:22:03'),(1546,NULL,NULL,'2024-10-24 07:51:26','2024-10-24 07:51:26'),(1547,NULL,NULL,'2024-10-24 08:04:12','2024-10-24 08:04:12'),(1548,NULL,NULL,'2024-10-24 08:05:20','2024-10-24 08:05:20'),(1549,NULL,NULL,'2024-10-24 08:11:30','2024-10-24 08:11:30'),(1550,NULL,NULL,'2024-10-24 08:17:29','2024-10-24 08:17:29'),(1551,NULL,NULL,'2024-10-24 08:21:08','2024-10-24 08:21:09'),(1552,NULL,NULL,'2024-10-24 08:24:31','2024-10-24 08:24:31'),(1553,NULL,NULL,'2024-10-24 08:27:45','2024-10-24 08:27:45'),(1554,NULL,NULL,'2024-10-24 09:18:15','2024-10-24 09:18:15'),(1555,NULL,NULL,'2024-10-24 09:33:23','2024-10-24 09:33:23'),(1556,NULL,NULL,'2024-10-24 09:43:05','2024-10-24 09:43:05'),(1557,NULL,NULL,'2024-10-24 10:01:20','2024-10-24 10:01:20'),(1558,NULL,NULL,'2024-10-24 10:10:17','2024-10-24 10:10:17'),(1559,NULL,NULL,'2024-10-24 10:17:02','2024-10-24 10:17:02'),(1560,NULL,NULL,'2024-10-24 10:36:39','2024-10-24 10:36:39'),(1561,NULL,NULL,'2024-10-24 10:37:34','2024-10-24 10:37:34'),(1562,NULL,NULL,'2024-10-24 11:37:33','2024-10-24 11:37:33'),(1563,NULL,NULL,'2024-10-24 11:44:22','2024-10-24 11:44:22'),(1564,NULL,NULL,'2024-10-24 11:48:19','2024-10-24 11:48:19'),(1565,NULL,NULL,'2024-10-24 12:02:23','2024-10-24 12:02:23'),(1566,NULL,NULL,'2024-10-24 12:22:47','2024-10-24 12:22:47'),(1567,NULL,NULL,'2024-10-24 12:47:09','2024-10-24 12:47:09'),(1568,NULL,NULL,'2024-10-24 13:02:38','2024-10-24 13:02:38'),(1569,NULL,NULL,'2024-10-24 13:18:00','2024-10-24 13:18:00'),(1570,NULL,NULL,'2024-10-24 13:36:55','2024-10-24 13:36:55'),(1571,NULL,NULL,'2024-10-24 13:59:17','2024-10-24 13:59:17'),(1572,NULL,NULL,'2024-10-24 14:46:26','2024-10-24 14:46:26'),(1573,NULL,NULL,'2024-10-24 15:02:48','2024-10-24 15:02:48'),(1574,NULL,NULL,'2024-10-24 15:22:48','2024-10-24 15:22:48'),(1575,NULL,NULL,'2024-10-24 15:42:25','2024-10-24 15:42:25'),(1576,NULL,NULL,'2024-10-24 23:00:16','2024-10-24 23:00:16'),(1577,NULL,NULL,'2024-10-25 07:02:15','2024-10-25 07:43:23'),(1578,NULL,NULL,'2024-10-25 07:07:54','2024-10-25 07:07:54'),(1579,NULL,NULL,'2024-10-25 07:19:41','2024-10-25 07:19:41'),(1580,NULL,NULL,'2024-10-25 07:27:47','2024-10-25 07:27:48'),(1581,NULL,NULL,'2024-10-25 07:43:04','2024-10-25 07:43:04'),(1582,NULL,NULL,'2024-10-25 07:55:03','2024-10-25 07:55:04'),(1583,NULL,NULL,'2024-10-25 09:30:14','2024-10-25 09:30:14'),(1584,NULL,NULL,'2024-10-25 09:38:54','2024-10-25 09:38:54'),(1585,NULL,NULL,'2024-10-25 09:44:56','2024-10-25 09:44:56'),(1586,NULL,NULL,'2024-10-25 09:45:36','2024-10-25 09:45:36'),(1587,NULL,NULL,'2024-10-25 09:46:30','2024-10-25 09:46:30'),(1588,NULL,NULL,'2024-10-25 11:21:31','2024-10-25 11:21:31'),(1589,NULL,NULL,'2024-10-25 11:52:06','2024-10-25 11:52:06'),(1590,NULL,NULL,'2024-10-25 12:22:05','2024-10-25 12:22:05'),(1591,NULL,NULL,'2024-10-25 12:35:48','2024-10-25 12:35:48'),(1592,NULL,NULL,'2024-10-25 12:53:10','2024-10-25 12:53:10'),(1593,NULL,NULL,'2024-10-25 13:14:57','2024-10-25 13:14:57'),(1594,NULL,NULL,'2024-10-25 13:36:16','2024-10-25 13:36:16'),(1595,NULL,NULL,'2024-10-25 14:05:49','2024-10-25 14:05:49'),(1596,NULL,NULL,'2024-10-25 14:23:04','2024-10-25 14:23:04'),(1597,NULL,NULL,'2024-10-25 14:47:20','2024-10-25 14:47:20'),(1598,NULL,NULL,'2024-10-25 23:37:58','2024-10-25 23:37:58'),(1599,NULL,NULL,'2024-10-27 00:04:30','2024-10-27 00:04:30'),(1600,NULL,NULL,'2024-10-27 01:08:09','2024-10-27 01:08:09'),(1601,NULL,NULL,'2024-10-27 07:27:56','2024-10-27 07:27:56'),(1602,NULL,NULL,'2024-10-27 07:27:56','2024-10-27 07:27:56'),(1603,NULL,NULL,'2024-10-27 12:38:41','2024-10-27 12:38:41'),(1604,NULL,NULL,'2024-10-27 15:18:20','2024-10-27 15:18:20'),(1605,NULL,NULL,'2024-10-27 18:27:07','2024-10-27 18:27:07'),(1606,NULL,NULL,'2024-10-27 21:28:54','2024-10-27 21:28:54'),(1607,NULL,NULL,'2024-10-27 23:00:05','2024-10-27 23:00:05'),(1608,NULL,NULL,'2024-10-27 23:49:34','2024-10-27 23:49:34'),(1609,NULL,NULL,'2024-10-28 00:14:30','2024-10-28 00:14:30'),(1610,NULL,NULL,'2024-10-28 00:23:35','2024-10-28 00:23:35'),(1611,NULL,NULL,'2024-10-28 01:16:02','2024-10-28 01:16:02'),(1612,NULL,NULL,'2024-10-28 04:58:48','2024-10-28 04:58:48'),(1613,NULL,NULL,'2024-10-28 06:51:33','2024-10-28 06:51:33'),(1614,NULL,NULL,'2024-10-28 06:57:55','2024-10-28 06:57:55'),(1615,NULL,NULL,'2024-10-28 07:02:14','2024-10-28 07:02:14'),(1616,NULL,NULL,'2024-10-28 07:03:34','2024-10-28 07:03:34'),(1617,NULL,NULL,'2024-10-28 07:06:40','2024-10-28 07:06:40'),(1618,NULL,NULL,'2024-10-28 07:07:51','2024-10-28 07:07:51'),(1619,NULL,NULL,'2024-10-28 07:13:17','2024-10-28 07:13:17'),(1620,NULL,NULL,'2024-10-28 07:23:05','2024-10-28 07:23:05'),(1621,NULL,NULL,'2024-10-28 07:31:42','2024-10-28 07:31:42'),(1622,NULL,NULL,'2024-10-28 07:38:08','2024-10-28 07:38:08'),(1623,NULL,NULL,'2024-10-28 07:45:37','2024-10-28 07:45:37'),(1624,NULL,NULL,'2024-10-28 07:48:24','2024-10-28 07:48:24'),(1625,NULL,NULL,'2024-10-28 08:41:08','2024-10-28 08:41:08'),(1626,NULL,NULL,'2024-10-28 08:55:23','2024-10-28 08:55:23'),(1627,NULL,NULL,'2024-10-28 10:19:37','2024-10-28 10:19:37'),(1628,NULL,NULL,'2024-10-28 10:25:48','2024-10-28 10:25:48'),(1629,NULL,NULL,'2024-10-28 10:47:51','2024-10-28 10:47:51'),(1630,NULL,NULL,'2024-10-28 11:39:25','2024-10-28 11:39:25'),(1631,NULL,NULL,'2024-10-28 11:40:05','2024-10-28 11:40:05'),(1632,NULL,NULL,'2024-10-28 12:18:28','2024-10-28 12:18:28'),(1633,NULL,NULL,'2024-10-29 05:27:35','2024-10-29 05:27:35'),(1634,NULL,NULL,'2024-10-29 05:45:49','2024-10-29 05:45:49'),(1635,NULL,NULL,'2024-10-29 06:00:49','2024-10-29 06:00:49'),(1636,NULL,NULL,'2024-10-29 06:02:44','2024-10-29 06:02:44'),(1637,NULL,NULL,'2024-10-29 06:47:52','2024-10-29 06:47:52'),(1638,NULL,NULL,'2024-10-29 06:49:56','2024-10-29 06:49:56'),(1639,NULL,NULL,'2024-10-29 06:54:03','2024-10-29 06:54:03'),(1640,NULL,NULL,'2024-10-29 07:49:08','2024-10-29 07:49:08'),(1641,NULL,NULL,'2024-10-29 08:05:08','2024-10-29 08:05:08'),(1642,NULL,NULL,'2024-10-29 08:17:02','2024-10-29 08:17:03'),(1643,NULL,NULL,'2024-10-29 08:18:30','2024-10-29 08:18:30'),(1644,NULL,NULL,'2024-10-29 08:24:16','2024-10-29 08:24:16'),(1645,NULL,NULL,'2024-10-29 08:26:47','2024-10-29 08:26:47'),(1646,NULL,NULL,'2024-10-29 08:31:57','2024-10-29 08:31:57'),(1647,NULL,NULL,'2024-10-29 09:39:40','2024-10-29 09:39:40'),(1648,NULL,NULL,'2024-10-29 09:44:59','2024-10-29 09:44:59'),(1649,NULL,NULL,'2024-10-29 09:49:41','2024-10-29 09:49:41'),(1650,NULL,NULL,'2024-10-29 09:51:59','2024-10-29 09:51:59'),(1651,NULL,NULL,'2024-10-29 09:59:23','2024-10-29 09:59:23'),(1652,NULL,NULL,'2024-10-29 10:31:42','2024-10-29 10:31:42'),(1653,NULL,NULL,'2024-10-29 10:35:28','2024-10-29 10:35:28'),(1654,NULL,NULL,'2024-10-29 10:37:40','2024-10-29 10:37:40'),(1655,NULL,NULL,'2024-10-29 11:00:48','2024-10-29 11:00:48'),(1656,NULL,NULL,'2024-10-29 11:15:27','2024-10-29 11:15:27'),(1657,NULL,NULL,'2024-10-29 11:22:41','2024-10-29 11:22:41'),(1658,NULL,NULL,'2024-10-29 11:43:23','2024-10-29 11:43:23'),(1659,NULL,NULL,'2024-10-29 12:00:32','2024-10-29 12:00:32'),(1660,NULL,NULL,'2024-10-29 12:16:56','2024-10-29 12:16:56'),(1661,NULL,NULL,'2024-10-29 12:51:10','2024-10-29 12:51:10'),(1662,NULL,NULL,'2024-10-29 13:12:35','2024-10-29 13:12:35'),(1663,NULL,NULL,'2024-10-29 15:17:41','2024-10-29 15:17:41'),(1664,NULL,NULL,'2024-10-29 16:35:04','2024-10-29 16:35:04'),(1665,NULL,NULL,'2024-10-30 01:16:19','2024-10-30 01:16:19'),(1666,NULL,NULL,'2024-10-30 07:17:47','2024-10-30 07:17:47'),(1667,NULL,NULL,'2024-10-30 07:18:31','2024-10-30 07:18:31'),(1668,NULL,NULL,'2024-10-30 07:27:55','2024-10-30 07:27:55'),(1669,NULL,NULL,'2024-10-30 07:42:26','2024-10-30 07:42:26'),(1670,NULL,NULL,'2024-10-30 07:43:32','2024-10-30 07:43:32'),(1671,NULL,NULL,'2024-10-30 07:46:36','2024-10-30 07:46:36'),(1672,NULL,NULL,'2024-10-30 07:55:33','2024-10-30 07:55:33'),(1673,NULL,NULL,'2024-10-30 08:36:29','2024-10-30 08:36:29'),(1674,NULL,NULL,'2024-10-30 08:46:39','2024-10-30 08:46:39'),(1675,NULL,NULL,'2024-10-30 10:00:14','2024-10-30 10:00:14'),(1676,NULL,NULL,'2024-10-30 10:15:39','2024-10-30 10:15:39'),(1677,NULL,NULL,'2024-10-30 10:27:12','2024-10-30 10:27:12'),(1678,NULL,NULL,'2024-10-30 10:34:35','2024-10-30 10:34:35'),(1679,NULL,NULL,'2024-10-30 10:37:22','2024-10-30 10:37:22'),(1680,NULL,NULL,'2024-10-30 10:37:57','2024-10-30 10:37:57'),(1681,NULL,NULL,'2024-10-30 11:50:59','2024-10-30 11:50:59'),(1682,NULL,NULL,'2024-10-30 11:51:00','2024-10-30 11:51:00'),(1683,NULL,NULL,'2024-10-30 23:10:48','2024-10-30 23:10:48'),(1684,NULL,NULL,'2024-10-30 23:10:49','2024-10-30 23:10:49'),(1685,NULL,NULL,'2024-10-31 06:43:22','2024-10-31 06:43:22'),(1686,NULL,NULL,'2024-10-31 07:13:19','2024-10-31 07:13:19'),(1687,NULL,NULL,'2024-10-31 07:38:40','2024-10-31 07:38:40'),(1688,NULL,NULL,'2024-10-31 07:57:09','2024-10-31 07:57:09'),(1689,NULL,NULL,'2024-10-31 08:24:33','2024-10-31 08:24:33'),(1690,NULL,NULL,'2024-10-31 09:02:16','2024-10-31 09:02:16'),(1691,NULL,NULL,'2024-10-31 09:18:07','2024-10-31 09:18:07'),(1692,NULL,NULL,'2024-10-31 09:34:19','2024-10-31 09:34:19'),(1693,NULL,NULL,'2024-10-31 09:49:24','2024-10-31 09:49:24'),(1694,NULL,NULL,'2024-10-31 11:23:38','2024-10-31 11:23:38'),(1695,NULL,NULL,'2024-10-31 11:47:50','2024-10-31 11:47:50'),(1696,NULL,NULL,'2024-10-31 12:15:14','2024-10-31 12:15:15'),(1697,NULL,NULL,'2024-10-31 12:43:31','2024-10-31 12:43:31'),(1698,NULL,NULL,'2024-10-31 13:11:59','2024-10-31 13:11:59'),(1699,NULL,NULL,'2024-10-31 13:28:08','2024-10-31 13:28:09'),(1700,NULL,NULL,'2024-10-31 13:43:29','2024-10-31 13:43:29'),(1701,NULL,NULL,'2024-10-31 14:08:36','2024-10-31 14:08:36'),(1702,NULL,NULL,'2024-10-31 15:06:34','2024-10-31 15:06:34'),(1703,NULL,NULL,'2024-10-31 21:46:53','2024-10-31 21:46:53'),(1704,NULL,NULL,'2024-10-31 23:44:03','2024-10-31 23:44:03'),(1705,NULL,NULL,'2024-11-01 01:16:27','2024-11-01 01:16:27'),(1706,NULL,NULL,'2024-11-01 01:16:28','2024-11-01 01:16:28'),(1707,NULL,NULL,'2024-11-01 07:33:41','2024-11-01 07:33:41'),(1708,NULL,NULL,'2024-11-01 08:06:39','2024-11-01 08:06:39'),(1709,NULL,NULL,'2024-11-01 11:09:58','2024-11-01 11:09:58'),(1710,NULL,NULL,'2024-11-01 11:44:26','2024-11-01 11:44:26'),(1711,NULL,NULL,'2024-11-01 12:00:56','2024-11-01 12:00:56'),(1712,NULL,NULL,'2024-11-01 12:11:09','2024-11-01 12:11:09'),(1713,NULL,NULL,'2024-11-01 12:15:59','2024-11-01 12:15:59'),(1714,NULL,NULL,'2024-11-01 12:38:12','2024-11-01 12:38:12'),(1715,NULL,NULL,'2024-11-01 13:04:09','2024-11-01 13:04:09'),(1716,NULL,NULL,'2024-11-01 13:43:24','2024-11-01 13:43:24'),(1717,NULL,NULL,'2024-11-01 16:02:20','2024-11-01 16:02:20'),(1718,NULL,NULL,'2024-11-02 11:43:35','2024-11-02 11:43:35'),(1719,NULL,NULL,'2024-11-02 20:01:00','2024-11-02 20:01:00'),(1720,NULL,NULL,'2024-11-03 01:56:03','2024-11-03 01:56:03'),(1721,NULL,NULL,'2024-11-03 04:51:11','2024-11-03 04:51:11'),(1722,NULL,NULL,'2024-11-03 06:23:22','2024-11-03 06:23:22'),(1723,NULL,NULL,'2024-11-03 08:53:17','2024-11-03 08:53:17'),(1724,NULL,NULL,'2024-11-03 15:18:08','2024-11-03 15:18:08'),(1725,NULL,NULL,'2024-11-03 22:15:59','2024-11-03 22:15:59'),(1726,NULL,NULL,'2024-11-03 22:16:00','2024-11-03 22:16:00'),(1727,NULL,NULL,'2024-11-04 05:17:57','2024-11-04 05:17:57'),(1728,NULL,NULL,'2024-11-04 05:31:40','2024-11-04 05:31:40'),(1729,NULL,NULL,'2024-11-04 07:35:40','2024-11-04 07:35:40'),(1730,NULL,NULL,'2024-11-04 07:52:57','2024-11-04 07:52:57'),(1731,NULL,NULL,'2024-11-04 11:01:03','2024-11-04 11:01:03'),(1732,NULL,NULL,'2024-11-04 11:03:00','2024-11-04 11:03:00'),(1733,NULL,NULL,'2024-11-04 11:04:35','2024-11-04 11:04:35'),(1734,NULL,NULL,'2024-11-04 11:05:07','2024-11-04 11:05:07'),(1735,NULL,NULL,'2024-11-04 11:05:42','2024-11-04 11:05:42'),(1736,NULL,NULL,'2024-11-04 11:06:53','2024-11-04 11:06:53'),(1737,NULL,NULL,'2024-11-04 11:48:24','2024-11-04 11:48:24'),(1738,NULL,NULL,'2024-11-04 13:46:58','2024-11-04 13:46:58'),(1739,NULL,NULL,'2024-11-04 13:46:59','2024-11-04 13:46:59'),(1740,NULL,NULL,'2024-11-04 13:47:01','2024-11-04 13:47:01'),(1741,NULL,NULL,'2024-11-04 13:47:03','2024-11-04 13:47:03'),(1742,NULL,NULL,'2024-11-04 13:47:05','2024-11-04 13:47:05'),(1743,NULL,NULL,'2024-11-04 13:47:07','2024-11-04 13:47:07'),(1744,NULL,NULL,'2024-11-04 13:47:09','2024-11-04 13:47:09'),(1745,NULL,NULL,'2024-11-04 13:47:11','2024-11-04 13:47:11'),(1746,NULL,NULL,'2024-11-04 13:47:13','2024-11-04 13:47:13'),(1747,NULL,NULL,'2024-11-04 13:47:15','2024-11-04 13:47:15'),(1748,NULL,NULL,'2024-11-05 03:17:11','2024-11-05 03:17:11'),(1749,NULL,NULL,'2024-11-05 03:26:11','2024-11-05 03:26:11'),(1750,NULL,NULL,'2024-11-05 05:28:00','2024-11-05 05:28:00'),(1751,1,NULL,'2024-11-05 05:48:05','2024-11-05 05:48:06'),(1752,NULL,NULL,'2024-11-05 06:49:04','2024-11-05 06:49:04'),(1753,NULL,NULL,'2024-11-05 06:50:44','2024-11-05 06:50:44'),(1754,NULL,NULL,'2024-11-05 07:23:08','2024-11-05 07:23:08'),(1755,NULL,NULL,'2024-11-05 07:23:11','2024-11-05 07:23:11'),(1756,NULL,NULL,'2024-11-05 07:23:12','2024-11-05 07:23:12'),(1757,NULL,NULL,'2024-11-05 07:23:14','2024-11-05 07:23:14'),(1758,NULL,NULL,'2024-11-05 07:23:16','2024-11-05 07:23:16'),(1759,NULL,NULL,'2024-11-05 07:23:18','2024-11-05 07:23:18'),(1760,NULL,NULL,'2024-11-05 07:23:20','2024-11-05 07:23:20'),(1761,NULL,NULL,'2024-11-05 07:23:22','2024-11-05 07:23:22'),(1762,NULL,NULL,'2024-11-05 07:23:24','2024-11-05 07:23:24'),(1763,NULL,NULL,'2024-11-05 07:23:26','2024-11-05 07:23:26'),(1764,NULL,NULL,'2024-11-05 07:23:28','2024-11-05 07:23:28'),(1765,NULL,NULL,'2024-11-05 07:23:30','2024-11-05 07:23:30'),(1766,NULL,NULL,'2024-11-05 07:23:32','2024-11-05 07:23:32'),(1767,NULL,NULL,'2024-11-05 07:23:34','2024-11-05 07:23:34'),(1768,NULL,NULL,'2024-11-05 07:23:35','2024-11-05 07:23:35'),(1769,NULL,NULL,'2024-11-05 07:23:37','2024-11-05 07:23:37'),(1770,NULL,NULL,'2024-11-05 07:23:39','2024-11-05 07:23:39'),(1771,NULL,NULL,'2024-11-05 07:23:41','2024-11-05 07:23:41'),(1772,NULL,NULL,'2024-11-05 07:23:43','2024-11-05 07:23:43'),(1773,NULL,NULL,'2024-11-05 07:23:46','2024-11-05 07:23:46'),(1774,NULL,NULL,'2024-11-05 07:23:48','2024-11-05 07:23:48'),(1775,NULL,NULL,'2024-11-05 07:23:49','2024-11-05 07:23:49'),(1776,NULL,NULL,'2024-11-05 07:23:52','2024-11-05 07:23:52'),(1777,NULL,NULL,'2024-11-05 07:23:53','2024-11-05 07:23:53'),(1778,NULL,NULL,'2024-11-05 07:23:55','2024-11-05 07:23:55'),(1779,NULL,NULL,'2024-11-05 07:23:56','2024-11-05 07:23:56'),(1780,NULL,NULL,'2024-11-05 07:23:58','2024-11-05 07:23:58'),(1781,NULL,NULL,'2024-11-05 07:24:00','2024-11-05 07:24:00'),(1782,NULL,NULL,'2024-11-05 07:24:01','2024-11-05 07:24:02'),(1783,NULL,NULL,'2024-11-05 07:24:03','2024-11-05 07:24:03'),(1784,NULL,NULL,'2024-11-05 07:24:05','2024-11-05 07:24:05'),(1785,NULL,NULL,'2024-11-05 07:24:07','2024-11-05 07:24:07'),(1786,NULL,NULL,'2024-11-05 07:24:09','2024-11-05 07:24:09'),(1787,NULL,NULL,'2024-11-05 07:24:10','2024-11-05 07:24:10'),(1788,NULL,NULL,'2024-11-05 07:24:12','2024-11-05 07:24:12'),(1789,NULL,NULL,'2024-11-05 07:24:14','2024-11-05 07:24:14'),(1790,NULL,NULL,'2024-11-05 07:24:16','2024-11-05 07:24:16'),(1791,NULL,NULL,'2024-11-05 08:19:21','2024-11-05 08:19:21'),(1792,NULL,NULL,'2024-11-05 08:22:40','2024-11-05 08:22:40'),(1793,NULL,NULL,'2024-11-05 08:23:18','2024-11-05 08:23:18'),(1794,NULL,NULL,'2024-11-05 10:14:22','2024-11-05 10:14:22'),(1795,NULL,NULL,'2024-11-05 10:16:31','2024-11-05 10:16:31'),(1796,NULL,NULL,'2024-11-05 10:20:22','2024-11-05 10:20:22'),(1797,NULL,NULL,'2024-11-05 10:20:44','2024-11-05 10:20:44'),(1798,NULL,NULL,'2024-11-05 10:21:02','2024-11-05 10:21:02'),(1799,NULL,NULL,'2024-11-05 10:21:03','2024-11-05 10:21:03'),(1800,NULL,NULL,'2024-11-05 10:30:26','2024-11-05 10:30:26'),(1801,NULL,NULL,'2024-11-05 10:31:46','2024-11-05 10:31:46'),(1802,NULL,NULL,'2024-11-05 10:32:05','2024-11-05 11:17:03'),(1803,NULL,NULL,'2024-11-05 10:38:26','2024-11-05 10:38:26'),(1804,NULL,NULL,'2024-11-05 14:48:49','2024-11-05 14:48:49'),(1805,NULL,NULL,'2024-11-05 17:26:10','2024-11-05 17:26:10'),(1806,NULL,NULL,'2024-11-05 19:12:27','2024-11-05 19:12:27'),(1807,NULL,NULL,'2024-11-06 05:10:47','2024-11-06 05:10:47'),(1808,NULL,NULL,'2024-11-06 05:11:02','2024-11-06 06:03:42'),(1809,NULL,NULL,'2024-11-06 09:30:35','2024-11-06 09:30:35'),(1810,NULL,NULL,'2024-11-06 09:46:18','2024-11-06 09:46:18'),(1811,NULL,NULL,'2024-11-06 14:17:01','2024-11-06 14:17:01'),(1812,NULL,NULL,'2024-11-06 21:57:06','2024-11-06 21:57:11'),(1813,NULL,NULL,'2024-11-07 04:32:11','2024-11-07 04:32:20'),(1814,NULL,NULL,'2024-11-07 05:08:47','2024-11-07 05:08:47'),(1815,NULL,NULL,'2024-11-07 12:19:48','2024-11-07 12:19:48'),(1816,NULL,NULL,'2024-11-07 13:06:27','2024-11-07 13:06:27'),(1817,NULL,NULL,'2024-11-07 15:45:44','2024-11-07 15:45:44'),(1818,NULL,NULL,'2024-11-08 01:38:20','2024-11-08 01:38:20'),(1819,NULL,NULL,'2024-11-08 11:48:36','2024-11-08 11:48:36'),(1820,NULL,NULL,'2024-11-08 16:06:52','2024-11-08 16:06:52'),(1821,NULL,NULL,'2024-11-08 21:17:58','2024-11-08 21:17:58'),(1822,NULL,NULL,'2024-11-08 21:40:40','2024-11-08 21:40:40'),(1823,NULL,NULL,'2024-11-08 22:24:09','2024-11-08 22:24:09'),(1824,NULL,NULL,'2024-11-09 01:57:39','2024-11-09 01:57:39'),(1825,NULL,NULL,'2024-11-09 08:13:26','2024-11-09 08:13:26'),(1826,NULL,NULL,'2024-11-09 11:18:57','2024-11-09 11:18:57'),(1827,NULL,NULL,'2024-11-09 11:26:59','2024-11-09 11:26:59'),(1828,NULL,NULL,'2024-11-09 17:08:30','2024-11-09 17:08:30'),(1829,NULL,NULL,'2024-11-09 18:21:20','2024-11-09 18:21:20'),(1830,NULL,NULL,'2024-11-09 18:42:39','2024-11-09 18:42:39'),(1831,NULL,NULL,'2024-11-09 20:13:58','2024-11-09 20:13:58'),(1832,NULL,NULL,'2024-11-10 01:48:19','2024-11-10 01:48:19'),(1833,NULL,NULL,'2024-11-10 05:11:23','2024-11-10 05:11:23'),(1834,NULL,NULL,'2024-11-10 10:53:31','2024-11-10 10:53:31'),(1835,NULL,NULL,'2024-11-10 11:38:01','2024-11-10 11:38:01'),(1836,NULL,NULL,'2024-11-10 14:14:33','2024-11-10 14:14:34'),(1837,NULL,NULL,'2024-11-10 19:42:10','2024-11-10 19:42:10'),(1838,NULL,NULL,'2024-11-10 23:18:16','2024-11-10 23:18:16'),(1839,NULL,NULL,'2024-11-11 04:55:55','2024-11-11 04:55:55'),(1840,NULL,NULL,'2024-11-11 05:31:40','2024-11-11 08:05:47'),(1841,NULL,NULL,'2024-11-11 05:52:14','2024-11-11 09:03:45'),(1842,NULL,NULL,'2024-11-11 05:54:06','2024-11-11 05:54:06'),(1843,NULL,NULL,'2024-11-11 06:31:10','2024-11-11 06:31:10'),(1844,NULL,NULL,'2024-11-11 06:31:11','2024-11-11 06:31:11'),(1845,NULL,NULL,'2024-11-11 07:24:43','2024-11-11 07:24:43'),(1846,NULL,NULL,'2024-11-11 08:11:32','2024-11-11 08:25:57'),(1847,NULL,NULL,'2024-11-11 08:17:40','2024-11-11 08:17:40'),(1848,NULL,NULL,'2024-11-11 08:50:00','2024-11-11 08:50:15'),(1849,NULL,NULL,'2024-11-11 09:14:08','2024-11-11 09:14:08'),(1850,NULL,NULL,'2024-11-11 10:01:17','2024-11-11 10:24:21'),(1851,NULL,NULL,'2024-11-11 10:05:23','2024-11-11 10:05:23'),(1852,NULL,NULL,'2024-11-11 11:07:35','2024-11-11 11:07:35'),(1853,NULL,NULL,'2024-11-11 11:07:51','2024-11-11 11:07:51'),(1854,NULL,NULL,'2024-11-11 11:55:34','2024-11-11 11:55:34'),(1855,NULL,NULL,'2024-11-11 12:36:03','2024-11-11 12:36:03'),(1856,NULL,NULL,'2024-11-11 13:21:08','2024-11-11 13:21:08'),(1857,NULL,NULL,'2024-11-11 14:29:35','2024-11-11 14:29:35'),(1858,NULL,NULL,'2024-11-11 15:26:17','2024-11-11 15:26:17'),(1859,NULL,NULL,'2024-11-11 15:35:10','2024-11-11 15:35:10'),(1860,NULL,NULL,'2024-11-11 16:44:55','2024-11-11 16:44:55'),(1861,NULL,NULL,'2024-11-11 16:44:56','2024-11-11 16:44:56'),(1862,NULL,NULL,'2024-11-11 22:19:15','2024-11-11 22:19:15'),(1863,NULL,NULL,'2024-11-11 23:06:46','2024-11-11 23:06:46'),(1864,NULL,NULL,'2024-11-12 01:52:44','2024-11-12 01:52:44'),(1865,NULL,NULL,'2024-11-12 05:44:39','2024-11-12 07:27:35'),(1866,NULL,NULL,'2024-11-12 07:09:22','2024-11-12 07:09:22'),(1867,NULL,NULL,'2024-11-12 07:09:23','2024-11-12 07:09:23'),(1868,NULL,NULL,'2024-11-12 07:09:25','2024-11-12 07:09:25'),(1869,NULL,NULL,'2024-11-12 07:09:27','2024-11-12 07:09:27'),(1870,NULL,NULL,'2024-11-12 07:09:28','2024-11-12 07:09:28'),(1871,NULL,NULL,'2024-11-12 07:09:30','2024-11-12 07:09:30'),(1872,NULL,NULL,'2024-11-12 07:09:32','2024-11-12 07:09:32'),(1873,NULL,NULL,'2024-11-12 07:09:34','2024-11-12 07:09:34'),(1874,NULL,NULL,'2024-11-12 07:09:36','2024-11-12 07:09:36'),(1875,NULL,NULL,'2024-11-12 07:09:38','2024-11-12 07:09:38'),(1876,NULL,NULL,'2024-11-12 07:09:40','2024-11-12 07:09:40'),(1877,NULL,NULL,'2024-11-12 07:09:42','2024-11-12 07:09:42'),(1878,NULL,NULL,'2024-11-12 07:09:44','2024-11-12 07:09:44'),(1879,NULL,NULL,'2024-11-12 07:09:46','2024-11-12 07:09:46'),(1880,NULL,NULL,'2024-11-12 07:09:48','2024-11-12 07:09:48'),(1881,NULL,NULL,'2024-11-12 07:09:49','2024-11-12 07:09:49'),(1882,NULL,NULL,'2024-11-12 07:09:51','2024-11-12 07:09:51'),(1883,NULL,NULL,'2024-11-12 07:09:53','2024-11-12 07:09:53'),(1884,NULL,NULL,'2024-11-12 07:09:55','2024-11-12 07:09:55'),(1885,NULL,NULL,'2024-11-12 07:09:57','2024-11-12 07:09:57'),(1886,NULL,NULL,'2024-11-12 07:09:58','2024-11-12 07:09:59'),(1887,NULL,NULL,'2024-11-12 07:10:02','2024-11-12 07:10:02'),(1888,NULL,NULL,'2024-11-12 07:10:05','2024-11-12 07:10:05'),(1889,NULL,NULL,'2024-11-12 07:22:57','2024-11-12 07:22:57'),(1890,NULL,NULL,'2024-11-12 07:25:48','2024-11-12 07:25:48'),(1891,NULL,NULL,'2024-11-12 07:31:08','2024-11-12 07:31:08'),(1892,NULL,NULL,'2024-11-12 07:33:08','2024-11-12 07:33:08'),(1893,NULL,NULL,'2024-11-12 08:06:22','2024-11-12 08:06:22'),(1894,NULL,NULL,'2024-11-12 08:07:39','2024-11-12 08:07:39'),(1895,NULL,NULL,'2024-11-12 08:14:25','2024-11-12 08:14:25'),(1896,NULL,NULL,'2024-11-12 08:21:17','2024-11-12 08:21:17'),(1897,NULL,NULL,'2024-11-12 08:24:40','2024-11-12 08:24:40'),(1898,NULL,NULL,'2024-11-12 09:03:55','2024-11-12 09:03:55'),(1899,NULL,NULL,'2024-11-12 09:18:47','2024-11-12 09:18:51'),(1900,NULL,NULL,'2024-11-12 09:24:57','2024-11-12 09:24:57'),(1901,NULL,NULL,'2024-11-12 09:35:06','2024-11-12 09:35:06'),(1902,NULL,NULL,'2024-11-12 09:54:56','2024-11-12 09:54:56'),(1903,NULL,NULL,'2024-11-12 09:58:11','2024-11-12 09:58:11'),(1904,NULL,NULL,'2024-11-12 09:58:33','2024-11-12 09:58:35'),(1905,NULL,NULL,'2024-11-12 10:00:17','2024-11-12 10:00:17'),(1906,NULL,NULL,'2024-11-12 10:02:38','2024-11-12 10:02:38'),(1907,NULL,NULL,'2024-11-12 10:17:36','2024-11-12 10:17:37'),(1908,NULL,NULL,'2024-11-12 10:38:13','2024-11-12 10:38:13'),(1909,NULL,NULL,'2024-11-12 10:38:49','2024-11-12 10:38:49'),(1910,NULL,NULL,'2024-11-12 10:43:28','2024-11-12 10:43:28'),(1911,NULL,NULL,'2024-11-12 10:46:31','2024-11-12 10:46:31'),(1912,NULL,NULL,'2024-11-12 11:02:19','2024-11-12 11:02:20'),(1913,NULL,NULL,'2024-11-12 16:13:15','2024-11-12 16:13:15'),(1914,NULL,NULL,'2024-11-12 18:10:32','2024-11-12 18:10:32'),(1915,NULL,NULL,'2024-11-12 19:48:37','2024-11-12 19:48:37'),(1916,NULL,NULL,'2024-11-12 21:10:37','2024-11-12 21:10:37'),(1917,NULL,NULL,'2024-11-12 21:10:43','2024-11-12 21:10:44'),(1918,NULL,NULL,'2024-11-13 01:19:30','2024-11-13 01:19:30'),(1919,NULL,NULL,'2024-11-13 04:42:16','2024-11-13 04:42:16'),(1920,NULL,NULL,'2024-11-13 05:17:42','2024-11-13 05:18:24'),(1921,NULL,NULL,'2024-11-13 07:37:45','2024-11-13 07:37:45'),(1922,NULL,NULL,'2024-11-13 09:55:27','2024-11-13 09:55:27'),(1923,NULL,NULL,'2024-11-13 13:40:29','2024-11-13 13:40:29'),(1924,NULL,NULL,'2024-11-13 15:57:19','2024-11-13 15:57:19'),(1925,NULL,NULL,'2024-11-13 16:54:48','2024-11-13 16:54:48'),(1926,NULL,NULL,'2024-11-13 18:46:28','2024-11-13 18:46:28'),(1927,NULL,NULL,'2024-11-13 22:25:26','2024-11-13 22:25:26'),(1928,NULL,NULL,'2024-11-14 03:45:26','2024-11-14 03:45:26'),(1929,NULL,NULL,'2024-11-14 07:29:52','2024-11-14 07:29:52'),(1930,NULL,NULL,'2024-11-14 09:41:41','2024-11-14 09:41:41'),(1931,NULL,NULL,'2024-11-14 12:30:15','2024-11-14 12:30:15'),(1932,NULL,NULL,'2024-11-14 13:26:05','2024-11-14 13:26:05'),(1933,NULL,NULL,'2024-11-14 15:57:04','2024-11-14 15:57:04'),(1934,NULL,NULL,'2024-11-14 16:13:32','2024-11-14 16:13:32'),(1935,NULL,NULL,'2024-11-14 20:49:20','2024-11-14 20:49:20'),(1936,NULL,NULL,'2024-11-14 21:22:12','2024-11-14 21:22:12'),(1937,NULL,NULL,'2024-11-14 23:26:23','2024-11-14 23:26:23'),(1938,NULL,NULL,'2024-11-15 01:00:01','2024-11-15 01:00:01'),(1939,NULL,NULL,'2024-11-15 03:26:31','2024-11-15 03:26:31'),(1940,NULL,NULL,'2024-11-15 06:23:36','2024-11-15 06:23:36'),(1941,NULL,NULL,'2024-11-15 10:03:48','2024-11-15 10:03:48'),(1942,NULL,NULL,'2024-11-15 14:43:07','2024-11-15 14:43:07'),(1943,NULL,NULL,'2024-11-15 16:15:20','2024-11-15 16:15:20'),(1944,NULL,NULL,'2024-11-15 18:28:18','2024-11-15 18:28:18'),(1945,NULL,NULL,'2024-11-15 18:57:22','2024-11-15 18:57:22'),(1946,NULL,NULL,'2024-11-15 19:25:44','2024-11-15 19:25:44'),(1947,NULL,NULL,'2024-11-15 19:25:45','2024-11-15 19:25:45'),(1948,NULL,NULL,'2024-11-15 19:25:45','2024-11-15 19:25:45'),(1949,NULL,NULL,'2024-11-15 19:25:46','2024-11-15 19:25:46'),(1950,NULL,NULL,'2024-11-15 23:31:07','2024-11-15 23:31:07'),(1951,NULL,NULL,'2024-11-16 03:36:46','2024-11-16 03:36:46'),(1952,NULL,NULL,'2024-11-16 14:00:41','2024-11-16 14:00:41'),(1953,NULL,NULL,'2024-11-17 11:47:30','2024-11-17 11:47:30'),(1954,NULL,NULL,'2024-11-17 16:56:06','2024-11-17 16:56:06'),(1955,NULL,NULL,'2024-11-17 22:31:25','2024-11-17 22:31:25'),(1956,NULL,NULL,'2024-11-18 05:08:27','2024-11-18 05:08:27'),(1957,NULL,NULL,'2024-11-18 12:58:12','2024-11-18 12:58:12'),(1958,NULL,NULL,'2024-11-18 12:58:12','2024-11-18 12:58:12'),(1959,NULL,NULL,'2024-11-18 12:58:13','2024-11-18 12:58:13'),(1960,NULL,NULL,'2024-11-18 12:58:14','2024-11-18 12:58:14'),(1961,NULL,NULL,'2024-11-18 12:58:14','2024-11-18 12:58:14'),(1962,NULL,NULL,'2024-11-18 12:58:15','2024-11-18 12:58:15'),(1963,NULL,NULL,'2024-11-18 12:58:15','2024-11-18 12:58:15'),(1964,NULL,NULL,'2024-11-18 12:58:16','2024-11-18 12:58:16'),(1965,NULL,NULL,'2024-11-18 12:58:17','2024-11-18 12:58:17'),(1966,NULL,NULL,'2024-11-18 12:58:17','2024-11-18 12:58:17'),(1967,NULL,NULL,'2024-11-18 13:04:56','2024-11-18 13:04:56'),(1968,NULL,NULL,'2024-11-18 14:28:46','2024-11-18 14:28:46'),(1969,NULL,NULL,'2024-11-18 16:02:10','2024-11-18 16:02:10'),(1970,NULL,NULL,'2024-11-18 16:02:32','2024-11-18 16:02:32'),(1971,NULL,NULL,'2024-11-18 16:27:24','2024-11-18 16:27:24'),(1972,NULL,NULL,'2024-11-18 17:19:54','2024-11-18 17:19:54'),(1973,NULL,NULL,'2024-11-18 17:19:54','2024-11-18 17:19:54'),(1974,NULL,NULL,'2024-11-18 17:47:45','2024-11-18 17:47:45'),(1975,NULL,NULL,'2024-11-18 23:56:34','2024-11-18 23:56:34'),(1976,NULL,NULL,'2024-11-19 04:05:35','2024-11-19 04:05:35'),(1977,NULL,NULL,'2024-11-19 05:30:14','2024-11-19 05:30:14'),(1978,NULL,NULL,'2024-11-19 10:57:09','2024-11-19 10:57:09'),(1979,NULL,NULL,'2024-11-19 10:59:28','2024-11-19 10:59:28'),(1980,NULL,NULL,'2024-11-19 11:19:54','2024-11-19 11:19:54'),(1981,NULL,NULL,'2024-11-19 14:14:39','2024-11-19 14:14:39'),(1982,NULL,NULL,'2024-11-19 14:14:40','2024-11-19 14:14:40'),(1983,NULL,NULL,'2024-11-19 16:51:03','2024-11-19 16:51:03'),(1984,NULL,NULL,'2024-11-19 17:44:56','2024-11-19 17:44:56'),(1985,NULL,NULL,'2024-11-20 04:57:27','2024-11-20 04:57:27'),(1986,NULL,NULL,'2024-11-20 11:51:56','2024-11-20 11:51:56'),(1987,NULL,NULL,'2024-11-20 22:59:56','2024-11-20 22:59:56'),(1988,NULL,NULL,'2024-11-20 23:57:56','2024-11-20 23:57:56'),(1989,NULL,NULL,'2024-11-21 06:55:38','2024-11-21 06:55:38'),(1990,NULL,NULL,'2024-11-21 17:18:10','2024-11-21 17:18:10'),(1991,NULL,NULL,'2024-11-21 18:21:30','2024-11-21 18:21:30'),(1992,NULL,NULL,'2024-11-22 00:48:21','2024-11-22 00:48:21'),(1993,NULL,NULL,'2024-11-22 08:54:30','2024-11-22 08:54:30'),(1994,NULL,NULL,'2024-11-22 08:54:31','2024-11-22 08:54:31'),(1995,NULL,NULL,'2024-11-22 11:15:02','2024-11-22 11:15:02'),(1996,NULL,NULL,'2024-11-22 13:38:58','2024-11-22 13:38:58'),(1997,NULL,NULL,'2024-11-22 16:57:43','2024-11-22 16:57:43'),(1998,NULL,NULL,'2024-11-22 17:28:37','2024-11-22 17:28:37'),(1999,NULL,NULL,'2024-11-22 18:25:28','2024-11-22 18:25:28'),(2000,NULL,NULL,'2024-11-22 20:51:08','2024-11-22 20:51:08'),(2001,NULL,NULL,'2024-11-22 23:28:37','2024-11-22 23:28:37'),(2002,NULL,NULL,'2024-11-23 10:47:36','2024-11-23 10:47:36'),(2003,NULL,NULL,'2024-11-23 11:05:00','2024-11-23 11:05:00'),(2004,NULL,NULL,'2024-11-23 12:30:52','2024-11-23 12:30:52'),(2005,NULL,NULL,'2024-11-23 18:04:31','2024-11-23 18:04:31'),(2006,NULL,NULL,'2024-11-23 18:54:00','2024-11-23 18:54:00'),(2007,NULL,NULL,'2024-11-24 06:10:54','2024-11-24 06:10:54'),(2008,NULL,NULL,'2024-11-24 14:00:12','2024-11-24 14:00:12'),(2009,NULL,NULL,'2024-11-24 20:12:32','2024-11-24 20:12:32'),(2010,NULL,NULL,'2024-11-25 00:39:02','2024-11-25 00:39:02'),(2011,NULL,NULL,'2024-11-25 07:28:56','2024-11-25 07:28:56'),(2012,NULL,NULL,'2024-11-25 16:25:25','2024-11-25 16:25:25'),(2013,NULL,NULL,'2024-11-25 18:31:53','2024-11-25 18:31:53'),(2014,NULL,NULL,'2024-11-26 00:57:37','2024-11-26 00:57:37'),(2015,NULL,NULL,'2024-11-26 01:35:14','2024-11-26 01:35:14'),(2016,NULL,NULL,'2024-11-26 02:11:53','2024-11-26 02:11:53'),(2017,NULL,NULL,'2024-11-26 02:37:09','2024-11-26 02:37:09'),(2018,NULL,NULL,'2024-11-26 05:43:42','2024-11-26 05:43:42'),(2019,NULL,NULL,'2024-11-26 05:43:43','2024-11-26 05:43:43'),(2020,NULL,NULL,'2024-11-26 13:15:46','2024-11-26 13:15:46'),(2021,NULL,NULL,'2024-11-26 19:49:45','2024-11-26 19:49:45'),(2022,NULL,NULL,'2024-11-26 19:56:26','2024-11-26 19:56:26'),(2023,NULL,NULL,'2024-11-26 21:15:22','2024-11-26 21:15:22'),(2024,NULL,NULL,'2024-11-26 22:02:00','2024-11-26 22:02:00'),(2025,NULL,NULL,'2024-11-27 02:47:35','2024-11-27 02:47:35'),(2026,NULL,NULL,'2024-11-27 07:04:13','2024-11-27 07:04:13'),(2027,NULL,NULL,'2024-11-27 09:05:18','2024-11-27 09:05:18'),(2028,NULL,NULL,'2024-11-27 10:08:34','2024-11-27 10:08:34'),(2029,NULL,NULL,'2024-11-27 14:40:37','2024-11-27 14:40:37'),(2030,NULL,NULL,'2024-11-27 17:06:54','2024-11-27 17:06:54'),(2031,NULL,NULL,'2024-11-28 02:07:37','2024-11-28 02:07:37'),(2032,NULL,NULL,'2024-11-28 02:50:28','2024-11-28 02:50:28'),(2033,NULL,NULL,'2024-11-28 08:39:13','2024-11-28 08:39:13'),(2034,NULL,NULL,'2024-11-28 08:52:57','2024-11-28 08:52:57'),(2035,NULL,NULL,'2024-11-28 13:01:04','2024-11-28 13:01:04'),(2036,NULL,NULL,'2024-11-28 18:28:40','2024-11-28 18:28:40'),(2037,NULL,NULL,'2024-11-28 19:43:21','2024-11-28 19:43:21'),(2038,NULL,NULL,'2024-11-28 22:01:47','2024-11-28 22:01:47'),(2039,NULL,NULL,'2024-11-28 22:52:56','2024-11-28 22:52:56'),(2040,NULL,NULL,'2024-11-29 03:24:21','2024-11-29 03:24:21'),(2041,NULL,NULL,'2024-11-29 05:06:05','2024-11-29 05:06:05'),(2042,NULL,NULL,'2024-11-29 08:30:19','2024-11-29 08:30:19'),(2043,NULL,NULL,'2024-11-29 09:25:53','2024-11-29 09:25:53'),(2044,NULL,NULL,'2024-11-29 13:55:45','2024-11-29 13:55:45'),(2045,NULL,NULL,'2024-11-29 17:46:50','2024-11-29 17:46:50'),(2046,NULL,NULL,'2024-11-29 21:13:36','2024-11-29 21:13:36'),(2047,NULL,NULL,'2024-11-30 00:09:43','2024-11-30 00:09:43'),(2048,NULL,NULL,'2024-11-30 00:48:21','2024-11-30 00:48:21'),(2049,NULL,NULL,'2024-11-30 08:25:52','2024-11-30 08:25:52'),(2050,NULL,NULL,'2024-11-30 16:22:40','2024-11-30 16:22:40'),(2051,NULL,NULL,'2024-11-30 16:34:23','2024-11-30 16:34:23'),(2052,NULL,NULL,'2024-12-01 02:41:20','2024-12-01 02:41:20'),(2053,NULL,NULL,'2024-12-01 03:15:10','2024-12-01 03:15:10'),(2054,NULL,NULL,'2024-12-01 09:52:35','2024-12-01 09:52:35'),(2055,NULL,NULL,'2024-12-01 10:06:23','2024-12-01 10:06:23'),(2056,NULL,NULL,'2024-12-01 10:55:45','2024-12-01 10:55:45'),(2057,NULL,NULL,'2024-12-01 15:31:30','2024-12-01 15:31:30'),(2058,NULL,NULL,'2024-12-01 20:42:15','2024-12-01 20:42:15'),(2059,NULL,NULL,'2024-12-01 22:44:50','2024-12-01 22:44:50'),(2060,NULL,NULL,'2024-12-02 04:17:12','2024-12-02 04:17:12'),(2061,NULL,NULL,'2024-12-02 15:28:24','2024-12-02 15:28:24'),(2062,NULL,NULL,'2024-12-02 23:03:00','2024-12-02 23:03:00'),(2063,NULL,NULL,'2024-12-03 09:55:16','2024-12-03 09:55:16'),(2064,NULL,NULL,'2024-12-03 13:28:44','2024-12-03 13:28:44'),(2065,NULL,NULL,'2024-12-03 15:04:38','2024-12-03 15:04:38'),(2066,NULL,NULL,'2024-12-03 16:40:04','2024-12-03 16:40:04'),(2067,NULL,NULL,'2024-12-03 17:33:51','2024-12-03 17:33:51'),(2068,NULL,NULL,'2024-12-03 18:43:26','2024-12-03 18:43:26'),(2069,NULL,NULL,'2024-12-03 18:43:27','2024-12-03 18:43:27'),(2070,NULL,NULL,'2024-12-04 04:06:56','2024-12-04 04:06:56'),(2071,NULL,NULL,'2024-12-04 04:09:10','2024-12-04 04:09:10'),(2072,NULL,NULL,'2024-12-04 04:35:26','2024-12-04 04:35:26'),(2073,NULL,NULL,'2024-12-04 06:15:00','2024-12-04 06:15:00'),(2074,NULL,NULL,'2024-12-04 06:30:28','2024-12-04 06:30:28'),(2075,NULL,NULL,'2024-12-04 09:01:39','2024-12-04 09:01:39'),(2076,NULL,NULL,'2024-12-04 10:52:17','2024-12-04 10:52:17'),(2077,NULL,NULL,'2024-12-04 11:07:07','2024-12-04 11:07:07'),(2078,NULL,NULL,'2024-12-04 12:03:53','2024-12-04 12:03:53'),(2079,NULL,NULL,'2024-12-04 12:18:55','2024-12-04 12:18:55'),(2080,NULL,NULL,'2024-12-04 13:37:50','2024-12-04 13:37:50'),(2081,NULL,NULL,'2024-12-04 13:50:54','2024-12-04 13:50:54'),(2082,NULL,NULL,'2024-12-04 22:44:23','2024-12-04 22:44:23'),(2083,NULL,NULL,'2024-12-05 05:22:31','2024-12-05 05:22:31'),(2084,NULL,NULL,'2024-12-05 07:27:37','2024-12-05 07:27:37'),(2085,NULL,NULL,'2024-12-05 08:58:37','2024-12-05 08:58:37'),(2086,NULL,NULL,'2024-12-05 10:45:53','2024-12-05 10:45:53'),(2087,NULL,NULL,'2024-12-05 11:59:22','2024-12-05 11:59:22'),(2088,NULL,NULL,'2024-12-05 12:36:01','2024-12-05 12:36:01'),(2089,NULL,NULL,'2024-12-05 12:36:30','2024-12-05 12:36:30'),(2090,NULL,NULL,'2024-12-05 14:11:00','2024-12-05 14:11:00'),(2091,NULL,NULL,'2024-12-05 16:16:55','2024-12-05 16:16:55'),(2092,NULL,NULL,'2024-12-05 16:23:00','2024-12-05 16:23:00'),(2093,NULL,NULL,'2024-12-05 23:27:14','2024-12-05 23:27:14'),(2094,NULL,NULL,'2024-12-06 05:34:22','2024-12-06 05:34:22'),(2095,NULL,NULL,'2024-12-06 05:45:15','2024-12-06 05:45:15'),(2096,NULL,NULL,'2024-12-06 10:34:07','2024-12-06 10:34:07'),(2097,NULL,NULL,'2024-12-06 15:47:31','2024-12-06 15:47:31'),(2098,NULL,NULL,'2024-12-06 18:11:32','2024-12-06 18:11:32'),(2099,NULL,NULL,'2024-12-06 22:06:20','2024-12-06 22:06:20'),(2100,NULL,NULL,'2024-12-06 22:06:20','2024-12-06 22:06:20'),(2101,NULL,NULL,'2024-12-07 04:11:47','2024-12-07 04:11:47'),(2102,NULL,NULL,'2024-12-07 10:22:58','2024-12-07 10:22:58'),(2103,NULL,NULL,'2024-12-07 18:19:16','2024-12-07 18:19:17'),(2104,NULL,NULL,'2024-12-08 08:54:47','2024-12-08 08:54:47'),(2105,NULL,NULL,'2024-12-08 22:25:10','2024-12-08 22:25:11'),(2106,NULL,NULL,'2024-12-09 05:58:06','2024-12-09 05:58:06'),(2107,NULL,NULL,'2024-12-09 09:15:25','2024-12-09 09:20:17'),(2108,NULL,NULL,'2024-12-09 11:59:00','2024-12-09 11:59:00'),(2109,NULL,NULL,'2024-12-09 16:44:14','2024-12-09 16:44:14'),(2110,NULL,NULL,'2024-12-10 08:18:35','2024-12-10 08:28:46'),(2111,NULL,NULL,'2024-12-10 13:44:51','2024-12-10 13:44:51'),(2112,NULL,NULL,'2024-12-10 15:25:35','2024-12-10 15:25:35'),(2113,NULL,NULL,'2024-12-11 00:52:58','2024-12-11 00:52:58'),(2114,NULL,NULL,'2024-12-11 01:23:10','2024-12-11 01:23:10'),(2115,NULL,NULL,'2024-12-11 05:17:23','2024-12-11 05:17:24'),(2116,NULL,NULL,'2024-12-11 05:17:24','2024-12-11 05:17:24'),(2117,NULL,NULL,'2024-12-11 06:06:11','2024-12-11 06:06:11'),(2118,NULL,NULL,'2024-12-11 08:10:42','2024-12-11 08:10:42'),(2119,NULL,NULL,'2024-12-11 10:38:09','2024-12-11 10:38:09'),(2120,NULL,NULL,'2024-12-11 10:59:14','2024-12-11 10:59:14'),(2121,NULL,NULL,'2024-12-11 11:09:30','2024-12-11 11:09:30'),(2122,NULL,NULL,'2024-12-11 11:39:59','2024-12-11 11:39:59'),(2123,NULL,NULL,'2024-12-11 11:46:10','2024-12-11 11:46:10'),(2124,NULL,NULL,'2024-12-11 14:48:03','2024-12-11 14:48:03'),(2125,NULL,NULL,'2024-12-11 17:40:53','2024-12-11 17:40:53'),(2126,NULL,NULL,'2024-12-11 18:38:37','2024-12-11 18:38:37'),(2127,NULL,NULL,'2024-12-11 19:28:43','2024-12-11 19:28:43'),(2128,NULL,NULL,'2024-12-12 20:05:18','2024-12-12 20:05:18'),(2129,NULL,NULL,'2024-12-13 07:49:56','2024-12-13 07:49:56'),(2130,NULL,NULL,'2024-12-13 14:37:36','2024-12-13 14:37:36'),(2131,NULL,NULL,'2024-12-13 14:37:51','2024-12-13 14:41:12'),(2132,NULL,NULL,'2024-12-13 18:07:34','2024-12-13 18:07:34'),(2133,NULL,NULL,'2024-12-13 18:36:44','2024-12-13 18:36:44'),(2134,NULL,NULL,'2024-12-14 07:05:49','2024-12-14 07:05:49'),(2135,NULL,NULL,'2024-12-14 09:33:20','2024-12-14 09:33:20'),(2136,NULL,NULL,'2024-12-14 09:33:22','2024-12-14 09:33:22'),(2137,NULL,NULL,'2024-12-14 09:33:23','2024-12-14 09:33:23'),(2138,NULL,NULL,'2024-12-14 09:33:24','2024-12-14 09:33:24'),(2139,NULL,NULL,'2024-12-14 09:33:26','2024-12-14 09:33:26'),(2140,NULL,NULL,'2024-12-14 09:33:27','2024-12-14 09:33:27'),(2141,NULL,NULL,'2024-12-14 09:33:29','2024-12-14 09:33:29'),(2142,NULL,NULL,'2024-12-14 09:33:30','2024-12-14 09:33:30'),(2143,NULL,NULL,'2024-12-14 14:32:03','2024-12-14 14:32:03'),(2144,NULL,NULL,'2024-12-14 14:32:04','2024-12-14 14:32:04'),(2145,NULL,NULL,'2024-12-14 14:32:06','2024-12-14 14:32:06'),(2146,NULL,NULL,'2024-12-14 14:32:07','2024-12-14 14:32:07'),(2147,NULL,NULL,'2024-12-14 14:32:09','2024-12-14 14:32:09'),(2148,NULL,NULL,'2024-12-14 14:32:10','2024-12-14 14:32:10'),(2149,NULL,NULL,'2024-12-14 14:32:11','2024-12-14 14:32:11'),(2150,NULL,NULL,'2024-12-14 14:32:13','2024-12-14 14:32:13'),(2151,NULL,NULL,'2024-12-14 14:32:14','2024-12-14 14:32:14'),(2152,NULL,NULL,'2024-12-14 14:32:16','2024-12-14 14:32:16'),(2153,NULL,NULL,'2024-12-14 17:57:41','2024-12-14 17:57:41'),(2154,NULL,NULL,'2024-12-14 21:21:42','2024-12-14 21:21:42'),(2155,NULL,NULL,'2024-12-14 21:52:25','2024-12-14 21:52:25'),(2156,NULL,NULL,'2024-12-15 05:20:23','2024-12-15 05:20:23'),(2157,NULL,NULL,'2024-12-15 05:20:23','2024-12-15 05:20:23'),(2158,NULL,NULL,'2024-12-15 14:45:18','2024-12-15 14:45:18'),(2159,NULL,NULL,'2024-12-15 16:03:50','2024-12-15 16:03:50'),(2160,NULL,NULL,'2024-12-15 17:07:32','2024-12-15 17:07:32'),(2161,NULL,NULL,'2024-12-15 17:07:33','2024-12-15 17:07:33'),(2162,NULL,NULL,'2024-12-15 17:07:34','2024-12-15 17:07:34'),(2163,NULL,NULL,'2024-12-15 17:07:36','2024-12-15 17:07:36'),(2164,NULL,NULL,'2024-12-15 17:07:38','2024-12-15 17:07:38'),(2165,NULL,NULL,'2024-12-15 17:07:39','2024-12-15 17:07:39'),(2166,NULL,NULL,'2024-12-15 17:07:41','2024-12-15 17:07:41'),(2167,NULL,NULL,'2024-12-15 17:07:42','2024-12-15 17:07:42'),(2168,NULL,NULL,'2024-12-15 17:07:44','2024-12-15 17:07:44'),(2169,NULL,NULL,'2024-12-15 17:07:45','2024-12-15 17:07:45'),(2170,NULL,NULL,'2024-12-16 09:39:05','2024-12-16 09:39:05'),(2171,NULL,NULL,'2024-12-16 09:57:22','2024-12-16 09:57:22'),(2172,NULL,NULL,'2024-12-16 09:58:08','2024-12-16 09:58:08'),(2173,NULL,NULL,'2024-12-16 14:56:07','2024-12-16 14:56:07'),(2174,NULL,NULL,'2024-12-16 14:56:08','2024-12-16 14:56:08'),(2175,NULL,NULL,'2024-12-16 14:56:10','2024-12-16 14:56:10'),(2176,NULL,NULL,'2024-12-16 14:56:11','2024-12-16 14:56:11'),(2177,NULL,NULL,'2024-12-16 14:56:13','2024-12-16 14:56:13'),(2178,NULL,NULL,'2024-12-16 14:56:14','2024-12-16 14:56:14'),(2179,NULL,NULL,'2024-12-16 14:56:16','2024-12-16 14:56:16'),(2180,NULL,NULL,'2024-12-16 14:56:17','2024-12-16 14:56:17'),(2181,NULL,NULL,'2024-12-16 14:56:18','2024-12-16 14:56:18'),(2182,NULL,NULL,'2024-12-16 14:56:20','2024-12-16 14:56:20'),(2183,NULL,NULL,'2024-12-16 23:14:45','2024-12-16 23:14:45'),(2184,NULL,NULL,'2024-12-17 09:18:57','2024-12-17 09:18:57'),(2185,NULL,NULL,'2024-12-17 09:30:22','2024-12-17 09:30:52'),(2186,NULL,NULL,'2024-12-17 10:03:44','2024-12-17 10:03:44'),(2187,NULL,NULL,'2024-12-17 10:29:08','2024-12-17 10:29:08'),(2188,NULL,NULL,'2024-12-17 10:41:04','2024-12-17 10:42:42'),(2189,NULL,NULL,'2024-12-17 10:45:10','2024-12-17 10:46:29'),(2190,NULL,NULL,'2024-12-17 10:48:30','2024-12-17 10:48:30'),(2191,NULL,NULL,'2024-12-17 11:20:57','2024-12-17 11:20:57'),(2192,NULL,NULL,'2024-12-17 13:01:35','2024-12-17 13:01:35'),(2193,NULL,NULL,'2024-12-17 16:32:37','2024-12-17 16:32:37'),(2194,NULL,NULL,'2024-12-17 16:32:37','2024-12-17 16:32:37'),(2195,NULL,NULL,'2024-12-17 16:32:38','2024-12-17 16:32:38'),(2196,NULL,NULL,'2024-12-17 16:32:39','2024-12-17 16:32:39'),(2197,NULL,NULL,'2024-12-17 16:32:40','2024-12-17 16:32:40'),(2198,NULL,NULL,'2024-12-17 16:32:40','2024-12-17 16:32:40'),(2199,NULL,NULL,'2024-12-17 16:32:41','2024-12-17 16:32:41'),(2200,NULL,NULL,'2024-12-17 16:32:42','2024-12-17 16:32:42'),(2201,NULL,NULL,'2024-12-17 16:32:42','2024-12-17 16:32:42'),(2202,NULL,NULL,'2024-12-17 16:32:43','2024-12-17 16:32:43'),(2203,NULL,NULL,'2024-12-17 20:34:21','2024-12-17 20:34:21'),(2204,NULL,NULL,'2024-12-17 23:15:07','2024-12-17 23:15:07'),(2205,NULL,NULL,'2024-12-18 00:37:58','2024-12-18 00:37:58'),(2206,NULL,NULL,'2024-12-18 00:57:23','2024-12-18 00:57:23'),(2207,NULL,NULL,'2024-12-18 02:28:52','2024-12-18 02:28:52'),(2208,NULL,NULL,'2024-12-18 09:25:21','2024-12-18 10:19:39'),(2209,NULL,NULL,'2024-12-18 13:44:07','2024-12-18 13:44:07'),(2210,NULL,NULL,'2024-12-18 16:06:22','2024-12-18 16:06:22'),(2211,NULL,NULL,'2024-12-18 16:06:23','2024-12-18 16:06:23'),(2212,NULL,NULL,'2024-12-19 02:12:05','2024-12-19 02:12:05'),(2213,NULL,NULL,'2024-12-19 04:55:31','2024-12-19 04:55:31'),(2214,NULL,NULL,'2024-12-19 09:01:43','2024-12-19 09:01:43'),(2215,NULL,NULL,'2024-12-19 09:11:32','2024-12-19 09:11:32'),(2216,NULL,NULL,'2024-12-19 12:21:21','2024-12-19 12:21:21'),(2217,NULL,NULL,'2024-12-19 13:53:41','2024-12-19 13:53:41'),(2218,NULL,NULL,'2024-12-19 15:33:27','2024-12-19 15:33:27'),(2219,NULL,NULL,'2024-12-19 15:58:18','2024-12-19 15:58:18'),(2220,NULL,NULL,'2024-12-19 18:42:30','2024-12-19 18:42:30'),(2221,NULL,NULL,'2024-12-19 20:54:30','2024-12-19 20:54:30'),(2222,NULL,NULL,'2024-12-20 01:19:06','2024-12-20 01:19:06'),(2223,NULL,NULL,'2024-12-20 04:31:25','2024-12-20 04:31:25'),(2224,NULL,NULL,'2024-12-20 07:15:30','2024-12-20 07:15:30'),(2225,NULL,NULL,'2024-12-20 09:10:57','2024-12-20 09:10:57'),(2226,NULL,NULL,'2024-12-20 11:20:27','2024-12-20 11:20:27'),(2227,NULL,NULL,'2024-12-20 23:29:44','2024-12-20 23:29:44'),(2228,NULL,NULL,'2024-12-22 11:49:44','2024-12-22 11:49:44'),(2229,NULL,NULL,'2024-12-23 06:07:32','2024-12-23 06:07:32'),(2230,NULL,NULL,'2024-12-23 06:59:47','2024-12-23 06:59:47'),(2231,NULL,NULL,'2024-12-23 08:53:02','2024-12-23 09:11:45'),(2232,NULL,NULL,'2024-12-23 09:32:28','2024-12-23 09:52:46'),(2233,NULL,NULL,'2024-12-23 10:39:39','2024-12-23 10:39:39'),(2234,NULL,NULL,'2024-12-23 11:01:53','2024-12-23 11:50:09'),(2235,NULL,NULL,'2024-12-23 11:17:57','2024-12-23 11:17:57'),(2236,NULL,NULL,'2024-12-23 11:49:50','2024-12-23 11:49:50'),(2237,NULL,NULL,'2024-12-23 12:46:14','2024-12-23 13:06:11'),(2238,NULL,NULL,'2024-12-23 12:50:00','2024-12-23 12:50:00'),(2239,NULL,NULL,'2024-12-23 13:05:34','2024-12-23 13:07:29'),(2240,NULL,NULL,'2024-12-23 14:53:10','2024-12-23 14:53:10'),(2241,NULL,NULL,'2024-12-24 04:56:45','2024-12-24 04:56:45'),(2242,NULL,NULL,'2024-12-24 07:21:47','2024-12-24 07:21:47'),(2243,NULL,NULL,'2024-12-24 08:33:00','2024-12-24 08:33:00'),(2244,NULL,NULL,'2024-12-24 11:11:34','2024-12-24 11:11:34'),(2245,NULL,NULL,'2024-12-24 13:23:39','2024-12-24 13:23:39'),(2246,NULL,NULL,'2024-12-24 21:10:34','2024-12-24 21:10:34'),(2247,NULL,NULL,'2024-12-24 22:06:44','2024-12-24 22:06:44'),(2248,NULL,NULL,'2024-12-24 22:58:28','2024-12-24 22:58:28'),(2249,NULL,NULL,'2024-12-25 03:57:16','2024-12-25 03:57:16'),(2250,NULL,NULL,'2024-12-25 20:36:38','2024-12-25 20:36:38'),(2251,NULL,NULL,'2024-12-25 20:36:41','2024-12-25 20:36:41'),(2252,NULL,NULL,'2024-12-25 20:36:43','2024-12-25 20:36:43'),(2253,NULL,NULL,'2024-12-25 20:36:45','2024-12-25 20:36:45'),(2254,NULL,NULL,'2024-12-25 20:36:48','2024-12-25 20:36:48'),(2255,NULL,NULL,'2024-12-25 20:36:51','2024-12-25 20:36:51'),(2256,NULL,NULL,'2024-12-25 20:36:53','2024-12-25 20:36:53'),(2257,NULL,NULL,'2024-12-25 20:36:58','2024-12-25 20:36:58'),(2258,NULL,NULL,'2024-12-25 20:37:02','2024-12-25 20:37:02'),(2259,NULL,NULL,'2024-12-25 20:37:04','2024-12-25 20:37:04'),(2260,NULL,NULL,'2024-12-25 20:37:06','2024-12-25 20:37:06'),(2261,NULL,NULL,'2024-12-25 20:37:09','2024-12-25 20:37:09'),(2262,NULL,NULL,'2024-12-25 20:37:11','2024-12-25 20:37:11'),(2263,NULL,NULL,'2024-12-25 20:37:14','2024-12-25 20:37:14'),(2264,NULL,NULL,'2024-12-25 20:37:16','2024-12-25 20:37:16'),(2265,NULL,NULL,'2024-12-25 20:37:19','2024-12-25 20:37:19'),(2266,NULL,NULL,'2024-12-25 20:37:21','2024-12-25 20:37:21'),(2267,NULL,NULL,'2024-12-25 20:37:23','2024-12-25 20:37:23'),(2268,NULL,NULL,'2024-12-25 20:37:34','2024-12-25 20:37:34'),(2269,NULL,NULL,'2024-12-25 20:37:40','2024-12-25 20:37:40'),(2270,NULL,NULL,'2024-12-25 20:37:45','2024-12-25 20:37:45'),(2271,NULL,NULL,'2024-12-25 20:37:50','2024-12-25 20:37:50'),(2272,NULL,NULL,'2024-12-25 20:37:55','2024-12-25 20:37:55'),(2273,NULL,NULL,'2024-12-25 20:38:00','2024-12-25 20:38:00'),(2274,NULL,NULL,'2024-12-25 20:38:05','2024-12-25 20:38:05'),(2275,NULL,NULL,'2024-12-25 20:38:10','2024-12-25 20:38:10'),(2276,NULL,NULL,'2024-12-25 20:38:15','2024-12-25 20:38:15'),(2277,NULL,NULL,'2024-12-25 20:38:20','2024-12-25 20:38:20'),(2278,NULL,NULL,'2024-12-25 20:38:26','2024-12-25 20:38:26'),(2279,NULL,NULL,'2024-12-25 20:38:31','2024-12-25 20:38:31'),(2280,NULL,NULL,'2024-12-25 20:38:37','2024-12-25 20:38:37'),(2281,NULL,NULL,'2024-12-25 20:38:41','2024-12-25 20:38:41'),(2282,NULL,NULL,'2024-12-25 20:38:46','2024-12-25 20:38:46'),(2283,NULL,NULL,'2024-12-25 20:38:51','2024-12-25 20:38:51'),(2284,NULL,NULL,'2024-12-25 20:38:57','2024-12-25 20:38:57'),(2285,NULL,NULL,'2024-12-25 20:39:01','2024-12-25 20:39:01'),(2286,NULL,NULL,'2024-12-25 20:39:06','2024-12-25 20:39:06'),(2287,NULL,NULL,'2024-12-25 20:39:12','2024-12-25 20:39:12'),(2288,NULL,NULL,'2024-12-25 20:39:16','2024-12-25 20:39:16'),(2289,NULL,NULL,'2024-12-25 20:39:20','2024-12-25 20:39:21'),(2290,NULL,NULL,'2024-12-25 20:39:25','2024-12-25 20:39:25'),(2291,NULL,NULL,'2024-12-25 20:39:30','2024-12-25 20:39:30'),(2292,NULL,NULL,'2024-12-25 20:39:35','2024-12-25 20:39:35'),(2293,NULL,NULL,'2024-12-25 20:39:40','2024-12-25 20:39:40'),(2294,NULL,NULL,'2024-12-25 20:39:44','2024-12-25 20:39:44'),(2295,NULL,NULL,'2024-12-25 20:39:49','2024-12-25 20:39:49'),(2296,NULL,NULL,'2024-12-25 20:39:54','2024-12-25 20:39:54'),(2297,NULL,NULL,'2024-12-25 20:40:02','2024-12-25 20:40:02'),(2298,NULL,NULL,'2024-12-25 20:40:07','2024-12-25 20:40:07'),(2299,NULL,NULL,'2024-12-25 20:40:12','2024-12-25 20:40:12'),(2300,NULL,NULL,'2024-12-25 20:40:18','2024-12-25 20:40:18'),(2301,NULL,NULL,'2024-12-25 21:38:35','2024-12-25 21:38:35'),(2302,NULL,NULL,'2024-12-26 05:57:00','2024-12-26 05:57:00'),(2303,NULL,NULL,'2024-12-26 05:57:08','2024-12-26 05:57:08'),(2304,NULL,NULL,'2024-12-27 00:41:24','2024-12-27 00:41:24'),(2305,NULL,NULL,'2024-12-27 03:14:50','2024-12-27 03:14:50'),(2306,NULL,NULL,'2024-12-27 03:14:50','2024-12-27 03:14:51'),(2307,NULL,NULL,'2024-12-27 12:51:28','2024-12-27 12:52:30'),(2308,NULL,NULL,'2024-12-27 12:54:03','2024-12-27 12:54:03'),(2309,NULL,NULL,'2024-12-27 13:12:24','2024-12-27 13:12:25'),(2310,NULL,NULL,'2024-12-27 13:54:46','2024-12-27 14:01:05'),(2311,NULL,NULL,'2024-12-27 14:37:11','2024-12-27 14:37:11'),(2312,NULL,NULL,'2024-12-27 14:52:12','2024-12-27 14:52:12'),(2313,NULL,NULL,'2024-12-28 03:16:29','2024-12-28 03:16:29'),(2314,NULL,NULL,'2024-12-28 04:21:21','2024-12-28 04:21:21'),(2315,NULL,NULL,'2024-12-28 09:18:55','2024-12-28 09:18:55'),(2316,NULL,NULL,'2025-01-03 07:20:03','2025-01-03 07:20:03'),(2317,NULL,NULL,'2025-01-03 12:22:21','2025-01-03 12:22:22'),(2318,NULL,NULL,'2025-01-03 12:31:29','2025-01-03 12:31:29'),(2319,NULL,NULL,'2025-01-04 01:29:45','2025-01-04 01:29:45'),(2320,NULL,NULL,'2025-01-04 04:54:03','2025-01-04 04:54:03'),(2321,NULL,NULL,'2025-01-04 16:12:17','2025-01-04 16:12:17'),(2322,NULL,NULL,'2025-01-05 04:06:45','2025-01-05 04:06:45'),(2323,NULL,NULL,'2025-01-05 04:06:47','2025-01-05 04:06:47'),(2324,NULL,NULL,'2025-01-05 16:42:50','2025-01-05 16:42:50'),(2325,NULL,NULL,'2025-01-06 02:40:56','2025-01-06 02:40:56'),(2326,NULL,NULL,'2025-01-06 07:09:04','2025-01-06 07:09:04'),(2327,NULL,NULL,'2025-01-06 08:02:20','2025-01-06 08:02:20'),(2328,NULL,NULL,'2025-01-06 08:55:14','2025-01-06 08:55:14'),(2329,NULL,NULL,'2025-01-06 09:12:28','2025-01-06 09:12:28'),(2330,NULL,NULL,'2025-01-06 09:40:31','2025-01-06 09:40:31'),(2331,NULL,NULL,'2025-01-06 10:19:00','2025-01-06 11:05:47'),(2332,NULL,NULL,'2025-01-06 10:20:37','2025-01-06 10:20:37'),(2333,NULL,NULL,'2025-01-06 11:01:22','2025-01-06 11:01:22'),(2334,NULL,NULL,'2025-01-06 11:07:06','2025-01-06 11:07:06'),(2335,NULL,NULL,'2025-01-06 11:34:51','2025-01-06 11:34:51'),(2336,NULL,NULL,'2025-01-06 13:20:58','2025-01-06 13:20:58'),(2337,NULL,NULL,'2025-01-06 15:25:09','2025-01-06 15:25:09'),(2338,NULL,NULL,'2025-01-07 07:25:57','2025-01-07 07:25:57'),(2339,NULL,NULL,'2025-01-07 07:43:02','2025-01-07 07:43:02'),(2340,NULL,NULL,'2025-01-07 08:22:39','2025-01-07 08:22:39'),(2341,NULL,NULL,'2025-01-07 11:53:46','2025-01-07 11:53:46'),(2342,NULL,NULL,'2025-01-07 13:11:09','2025-01-07 13:11:09'),(2343,NULL,NULL,'2025-01-07 13:18:31','2025-01-07 15:17:46'),(2344,NULL,NULL,'2025-01-07 13:24:13','2025-01-07 13:24:13'),(2345,NULL,NULL,'2025-01-07 13:26:27','2025-01-07 13:26:27'),(2346,NULL,NULL,'2025-01-07 13:29:58','2025-01-07 13:29:58'),(2347,NULL,NULL,'2025-01-07 13:36:52','2025-01-07 13:36:52'),(2348,NULL,NULL,'2025-01-07 13:52:32','2025-01-07 13:52:32'),(2349,NULL,NULL,'2025-01-07 14:42:34','2025-01-07 14:42:34'),(2350,NULL,NULL,'2025-01-07 14:57:43','2025-01-07 14:57:43'),(2351,NULL,NULL,'2025-01-07 15:15:35','2025-01-07 15:15:35'),(2352,NULL,NULL,'2025-01-07 15:34:04','2025-01-07 15:34:04'),(2353,NULL,NULL,'2025-01-07 19:13:02','2025-01-07 19:13:02'),(2354,NULL,NULL,'2025-01-08 07:24:11','2025-01-08 07:24:11'),(2355,NULL,NULL,'2025-01-08 07:39:16','2025-01-08 07:39:16'),(2356,NULL,NULL,'2025-01-08 08:45:35','2025-01-08 08:45:35'),(2357,NULL,NULL,'2025-01-08 09:26:16','2025-01-08 09:26:16'),(2358,NULL,NULL,'2025-01-08 10:00:37','2025-01-08 10:00:37'),(2359,NULL,NULL,'2025-01-08 10:16:51','2025-01-08 10:16:51'),(2360,NULL,NULL,'2025-01-08 12:57:12','2025-01-08 12:57:12'),(2361,NULL,NULL,'2025-01-08 19:12:25','2025-01-08 19:12:25'),(2362,NULL,NULL,'2025-01-08 19:20:06','2025-01-08 19:20:07'),(2363,NULL,NULL,'2025-01-09 07:59:35','2025-01-09 07:59:35'),(2364,NULL,NULL,'2025-01-09 09:39:27','2025-01-09 09:39:27'),(2365,NULL,NULL,'2025-01-09 09:59:38','2025-01-09 09:59:38'),(2366,NULL,NULL,'2025-01-09 21:06:21','2025-01-09 21:06:21'),(2367,NULL,NULL,'2025-01-09 21:26:39','2025-01-09 21:26:39'),(2368,NULL,NULL,'2025-01-09 23:30:17','2025-01-09 23:30:17'),(2369,NULL,NULL,'2025-01-09 23:30:17','2025-01-09 23:30:17'),(2370,NULL,NULL,'2025-01-10 03:19:26','2025-01-10 03:19:26'),(2371,NULL,NULL,'2025-01-10 03:19:27','2025-01-10 03:19:27'),(2372,NULL,NULL,'2025-01-10 05:55:27','2025-01-10 05:55:27'),(2373,NULL,NULL,'2025-01-10 07:32:25','2025-01-10 07:32:25'),(2374,NULL,NULL,'2025-01-10 09:23:05','2025-01-10 09:23:05'),(2375,NULL,NULL,'2025-01-10 09:41:47','2025-01-10 09:41:47'),(2376,NULL,NULL,'2025-01-10 10:48:45','2025-01-10 10:48:45'),(2377,NULL,NULL,'2025-01-10 11:02:31','2025-01-10 11:02:31'),(2378,NULL,NULL,'2025-01-10 13:22:32','2025-01-10 13:22:32'),(2379,NULL,NULL,'2025-01-10 13:32:07','2025-01-10 13:32:07'),(2380,NULL,NULL,'2025-01-10 13:40:33','2025-01-10 13:40:33'),(2381,NULL,NULL,'2025-01-10 16:56:53','2025-01-10 16:56:53'),(2382,NULL,NULL,'2025-01-10 16:56:54','2025-01-10 16:56:54'),(2383,NULL,NULL,'2025-01-10 16:56:55','2025-01-10 16:56:55'),(2384,NULL,NULL,'2025-01-10 16:57:07','2025-01-10 16:57:07'),(2385,NULL,NULL,'2025-01-10 16:57:08','2025-01-10 16:57:08'),(2386,NULL,NULL,'2025-01-10 16:57:09','2025-01-10 16:57:09'),(2387,NULL,NULL,'2025-01-10 17:46:27','2025-01-10 17:46:27'),(2388,NULL,NULL,'2025-01-11 07:03:38','2025-01-11 07:03:38'),(2389,NULL,NULL,'2025-01-11 07:09:37','2025-01-11 07:09:37'),(2390,NULL,NULL,'2025-01-11 07:58:27','2025-01-11 07:58:27'),(2391,NULL,NULL,'2025-01-11 15:26:50','2025-01-11 15:26:50'),(2392,NULL,NULL,'2025-01-13 07:22:53','2025-01-13 07:22:53'),(2393,NULL,NULL,'2025-01-13 08:31:35','2025-01-13 08:31:35'),(2394,NULL,NULL,'2025-01-13 08:46:46','2025-01-13 08:46:46'),(2395,NULL,NULL,'2025-01-13 09:04:17','2025-01-13 09:04:18'),(2396,NULL,NULL,'2025-01-13 09:15:55','2025-01-13 09:15:55'),(2397,NULL,NULL,'2025-01-13 09:54:21','2025-01-13 09:54:21'),(2398,NULL,NULL,'2025-01-13 12:14:45','2025-01-13 12:14:46'),(2399,NULL,NULL,'2025-01-13 12:21:46','2025-01-13 12:21:46'),(2400,NULL,NULL,'2025-01-13 12:21:47','2025-01-13 12:21:47'),(2401,NULL,NULL,'2025-01-13 12:22:03','2025-01-13 12:22:03'),(2402,NULL,NULL,'2025-01-13 12:22:08','2025-01-13 12:22:08'),(2403,NULL,NULL,'2025-01-13 12:23:15','2025-01-13 12:23:15'),(2404,NULL,NULL,'2025-01-13 12:23:20','2025-01-13 12:23:20'),(2405,NULL,NULL,'2025-01-13 12:23:23','2025-01-13 12:23:23'),(2406,NULL,NULL,'2025-01-13 12:23:41','2025-01-13 12:23:41'),(2407,NULL,NULL,'2025-01-13 12:24:08','2025-01-13 12:24:08'),(2408,NULL,NULL,'2025-01-13 12:24:12','2025-01-13 12:24:12'),(2409,NULL,NULL,'2025-01-13 12:26:57','2025-01-13 12:26:57'),(2410,NULL,NULL,'2025-01-13 13:23:35','2025-01-13 13:23:35'),(2411,NULL,NULL,'2025-01-13 16:07:32','2025-01-13 16:07:32'),(2412,NULL,NULL,'2025-01-13 19:06:55','2025-01-13 19:06:55'),(2413,NULL,NULL,'2025-01-14 09:40:15','2025-01-14 09:40:15'),(2414,NULL,NULL,'2025-01-15 03:09:46','2025-01-15 03:09:46'),(2415,NULL,NULL,'2025-01-15 06:29:06','2025-01-15 06:29:06'),(2416,NULL,NULL,'2025-01-15 11:01:07','2025-01-15 11:01:07'),(2417,NULL,NULL,'2025-01-15 13:01:33','2025-01-15 13:01:33'),(2418,NULL,NULL,'2025-01-15 15:56:40','2025-01-15 15:56:40'),(2419,NULL,NULL,'2025-01-16 01:14:15','2025-01-16 01:14:16'),(2420,NULL,NULL,'2025-01-16 01:14:18','2025-01-16 01:14:18'),(2421,NULL,NULL,'2025-01-16 01:14:20','2025-01-16 01:14:20'),(2422,NULL,NULL,'2025-01-16 01:14:23','2025-01-16 01:14:23'),(2423,NULL,NULL,'2025-01-16 01:14:26','2025-01-16 01:14:26'),(2424,NULL,NULL,'2025-01-16 01:14:28','2025-01-16 01:14:28'),(2425,NULL,NULL,'2025-01-16 01:14:31','2025-01-16 01:14:31'),(2426,NULL,NULL,'2025-01-16 01:14:33','2025-01-16 01:14:33'),(2427,NULL,NULL,'2025-01-16 01:14:35','2025-01-16 01:14:35'),(2428,NULL,NULL,'2025-01-16 01:14:37','2025-01-16 01:14:37'),(2429,NULL,NULL,'2025-01-16 01:14:39','2025-01-16 01:14:39'),(2430,NULL,NULL,'2025-01-16 01:14:42','2025-01-16 01:14:42'),(2431,NULL,NULL,'2025-01-16 01:16:32','2025-01-16 01:16:32'),(2432,NULL,NULL,'2025-01-16 01:16:34','2025-01-16 01:16:34'),(2433,NULL,NULL,'2025-01-16 01:16:35','2025-01-16 01:16:36'),(2434,NULL,NULL,'2025-01-16 01:16:38','2025-01-16 01:16:38'),(2435,NULL,NULL,'2025-01-16 01:16:40','2025-01-16 01:16:40'),(2436,NULL,NULL,'2025-01-16 01:16:42','2025-01-16 01:16:42'),(2437,NULL,NULL,'2025-01-16 01:16:44','2025-01-16 01:16:44'),(2438,NULL,NULL,'2025-01-16 01:16:45','2025-01-16 01:16:45'),(2439,NULL,NULL,'2025-01-16 01:16:47','2025-01-16 01:16:47'),(2440,NULL,NULL,'2025-01-16 01:16:49','2025-01-16 01:16:49'),(2441,NULL,NULL,'2025-01-16 01:16:51','2025-01-16 01:16:51'),(2442,NULL,NULL,'2025-01-16 01:16:52','2025-01-16 01:16:52'),(2443,NULL,NULL,'2025-01-17 05:50:47','2025-01-17 05:50:47'),(2444,NULL,NULL,'2025-01-17 07:54:53','2025-01-17 07:54:53'),(2445,NULL,NULL,'2025-01-17 07:54:55','2025-01-17 07:54:55'),(2446,NULL,NULL,'2025-01-17 07:54:57','2025-01-17 07:54:57'),(2447,NULL,NULL,'2025-01-17 07:54:59','2025-01-17 07:54:59'),(2448,NULL,NULL,'2025-01-17 07:55:01','2025-01-17 07:55:01'),(2449,NULL,NULL,'2025-01-17 07:55:03','2025-01-17 07:55:03'),(2450,NULL,NULL,'2025-01-17 07:55:05','2025-01-17 07:55:05'),(2451,NULL,NULL,'2025-01-17 07:55:07','2025-01-17 07:55:07'),(2452,NULL,NULL,'2025-01-17 07:55:09','2025-01-17 07:55:09'),(2453,NULL,NULL,'2025-01-17 07:55:10','2025-01-17 07:55:10'),(2454,NULL,NULL,'2025-01-17 20:08:10','2025-01-17 20:08:10'),(2455,NULL,NULL,'2025-01-17 20:08:10','2025-01-17 20:08:10'),(2456,NULL,NULL,'2025-01-18 00:05:48','2025-01-18 00:05:48'),(2457,NULL,NULL,'2025-01-18 16:07:44','2025-01-18 16:07:44'),(2458,NULL,NULL,'2025-01-20 13:59:00','2025-01-20 13:59:00'),(2459,NULL,NULL,'2025-01-20 14:42:51','2025-01-20 14:42:51'),(2460,NULL,NULL,'2025-01-20 15:09:11','2025-01-20 15:09:11'),(2461,NULL,NULL,'2025-01-20 15:25:37','2025-01-20 15:25:37'),(2462,NULL,NULL,'2025-01-20 18:07:53','2025-01-20 18:07:53'),(2463,NULL,NULL,'2025-01-20 18:30:42','2025-01-20 18:30:42'),(2464,NULL,NULL,'2025-01-21 07:45:53','2025-01-21 07:45:53'),(2465,NULL,NULL,'2025-01-21 13:12:12','2025-01-21 13:12:13'),(2466,NULL,NULL,'2025-01-22 01:55:56','2025-01-22 01:55:56'),(2467,NULL,NULL,'2025-01-22 06:06:09','2025-01-22 06:06:12'),(2468,NULL,NULL,'2025-01-22 06:08:46','2025-01-22 06:08:46'),(2469,NULL,NULL,'2025-01-22 08:11:07','2025-01-22 08:11:07'),(2470,NULL,NULL,'2025-01-22 09:25:07','2025-01-22 09:25:07'),(2471,NULL,NULL,'2025-01-22 09:31:48','2025-01-22 09:31:49'),(2472,NULL,NULL,'2025-01-22 09:53:09','2025-01-22 09:53:09'),(2473,NULL,NULL,'2025-01-22 10:37:13','2025-01-22 10:37:13'),(2474,NULL,NULL,'2025-01-22 14:58:24','2025-01-22 14:58:24'),(2475,NULL,NULL,'2025-01-23 10:27:56','2025-01-23 10:27:56'),(2476,NULL,NULL,'2025-01-23 10:43:21','2025-01-23 10:43:21'),(2477,NULL,NULL,'2025-01-23 10:58:45','2025-01-23 10:58:45'),(2478,NULL,NULL,'2025-01-23 11:40:30','2025-01-23 11:40:30'),(2479,NULL,NULL,'2025-01-23 12:00:01','2025-01-23 12:00:01'),(2480,NULL,NULL,'2025-01-23 12:36:42','2025-01-23 12:36:42'),(2481,NULL,NULL,'2025-01-23 12:38:16','2025-01-23 12:38:16'),(2482,NULL,NULL,'2025-01-23 12:59:35','2025-01-23 12:59:35'),(2483,NULL,NULL,'2025-01-23 13:01:17','2025-01-23 13:01:17'),(2484,NULL,NULL,'2025-01-23 13:19:04','2025-01-23 13:19:04'),(2485,NULL,NULL,'2025-01-23 13:34:21','2025-01-23 13:34:21'),(2486,NULL,NULL,'2025-01-23 13:43:40','2025-01-23 13:43:40'),(2487,NULL,NULL,'2025-01-23 23:36:40','2025-01-23 23:36:40'),(2488,NULL,NULL,'2025-01-24 00:24:20','2025-01-24 00:24:20'),(2489,NULL,NULL,'2025-01-24 05:02:54','2025-01-24 05:02:54'),(2490,NULL,NULL,'2025-01-24 09:15:30','2025-01-24 09:15:30'),(2491,NULL,NULL,'2025-01-24 09:30:36','2025-01-24 09:30:36'),(2492,NULL,NULL,'2025-01-24 09:49:26','2025-01-24 09:49:26'),(2493,NULL,NULL,'2025-01-24 10:36:12','2025-01-24 10:36:12'),(2494,NULL,NULL,'2025-01-24 10:51:40','2025-01-24 10:51:40'),(2495,NULL,NULL,'2025-01-24 11:31:07','2025-01-24 11:31:07'),(2496,NULL,NULL,'2025-01-24 11:50:16','2025-01-24 11:50:16'),(2497,NULL,NULL,'2025-01-24 12:21:16','2025-01-24 12:21:16'),(2498,NULL,NULL,'2025-01-24 13:39:26','2025-01-24 13:39:26'),(2499,NULL,NULL,'2025-01-24 13:56:09','2025-01-24 13:56:09'),(2500,NULL,NULL,'2025-01-24 15:48:44','2025-01-24 15:48:44'),(2501,NULL,NULL,'2025-01-24 15:58:29','2025-01-24 15:58:29'),(2502,NULL,NULL,'2025-01-26 00:30:38','2025-01-26 00:30:38'),(2503,NULL,NULL,'2025-01-26 03:56:36','2025-01-26 03:56:36'),(2504,NULL,NULL,'2025-01-26 06:07:27','2025-01-26 06:07:27'),(2505,NULL,NULL,'2025-01-26 16:59:10','2025-01-26 16:59:10'),(2506,NULL,NULL,'2025-01-27 04:14:18','2025-01-27 04:14:18'),(2507,NULL,NULL,'2025-01-27 06:35:33','2025-01-27 06:35:33'),(2508,NULL,NULL,'2025-01-27 06:51:38','2025-01-27 06:51:38'),(2509,NULL,NULL,'2025-01-27 07:57:17','2025-01-27 07:57:17'),(2510,NULL,NULL,'2025-01-27 08:19:07','2025-01-27 08:19:07'),(2511,NULL,NULL,'2025-01-27 08:21:43','2025-01-27 08:21:43'),(2512,NULL,NULL,'2025-01-27 08:38:54','2025-01-27 08:38:54'),(2513,NULL,NULL,'2025-01-27 08:54:37','2025-01-27 08:54:37'),(2514,NULL,NULL,'2025-01-27 09:04:17','2025-01-27 09:04:17'),(2515,NULL,NULL,'2025-01-27 09:04:28','2025-01-27 09:04:28'),(2516,NULL,NULL,'2025-01-27 10:16:24','2025-01-27 10:16:24'),(2517,NULL,NULL,'2025-01-27 10:32:54','2025-01-27 10:32:54'),(2518,NULL,NULL,'2025-01-27 10:47:58','2025-01-27 10:47:58'),(2519,NULL,NULL,'2025-01-27 11:03:44','2025-01-27 11:03:44'),(2520,NULL,NULL,'2025-01-27 11:14:30','2025-01-27 11:14:30'),(2521,NULL,NULL,'2025-01-27 11:22:18','2025-01-27 11:22:18'),(2522,NULL,NULL,'2025-01-27 11:27:20','2025-01-27 11:27:20'),(2523,NULL,NULL,'2025-01-27 11:29:48','2025-01-27 11:29:48'),(2524,NULL,NULL,'2025-01-27 11:44:59','2025-01-27 11:44:59'),(2525,NULL,NULL,'2025-01-27 12:00:00','2025-01-27 12:00:00'),(2526,NULL,NULL,'2025-01-27 12:15:43','2025-01-27 12:15:43'),(2527,NULL,NULL,'2025-01-27 12:56:17','2025-01-27 12:56:17'),(2528,NULL,NULL,'2025-01-27 13:25:59','2025-01-27 13:25:59'),(2529,NULL,NULL,'2025-01-27 13:35:12','2025-01-27 13:35:12'),(2530,NULL,NULL,'2025-01-27 14:03:21','2025-01-27 14:03:21'),(2531,NULL,NULL,'2025-01-27 15:20:54','2025-01-27 15:20:54'),(2532,NULL,NULL,'2025-01-27 15:34:00','2025-01-27 15:34:00'),(2533,NULL,NULL,'2025-01-27 15:35:42','2025-01-27 15:35:42'),(2534,NULL,NULL,'2025-01-27 15:58:06','2025-01-27 15:58:06'),(2535,NULL,NULL,'2025-01-27 16:28:15','2025-01-27 16:28:15'),(2536,NULL,NULL,'2025-01-27 16:29:44','2025-01-27 16:29:44'),(2537,NULL,NULL,'2025-01-27 16:45:13','2025-01-27 16:45:13'),(2538,NULL,NULL,'2025-01-27 19:01:46','2025-01-27 19:01:46'),(2539,NULL,NULL,'2025-01-28 02:22:31','2025-01-28 02:22:31'),(2540,NULL,NULL,'2025-01-28 04:24:30','2025-01-28 04:24:30'),(2541,NULL,NULL,'2025-01-28 06:09:49','2025-01-28 06:09:49'),(2542,NULL,NULL,'2025-01-28 06:37:33','2025-01-28 06:37:33'),(2543,NULL,NULL,'2025-01-28 06:55:21','2025-01-28 06:55:21'),(2544,NULL,NULL,'2025-01-28 07:07:23','2025-01-28 07:07:23'),(2545,NULL,NULL,'2025-01-28 07:16:12','2025-01-28 07:16:12'),(2546,NULL,NULL,'2025-01-28 07:37:42','2025-01-28 07:37:42'),(2547,NULL,NULL,'2025-01-28 08:19:05','2025-01-28 08:19:05'),(2548,NULL,NULL,'2025-01-28 08:38:37','2025-01-28 08:38:37'),(2549,NULL,NULL,'2025-01-28 08:39:16','2025-01-28 08:42:34'),(2550,NULL,NULL,'2025-01-28 09:05:22','2025-01-28 09:05:22'),(2551,NULL,NULL,'2025-01-28 09:05:47','2025-01-28 09:05:48'),(2552,NULL,NULL,'2025-01-28 09:07:05','2025-01-28 09:07:05'),(2553,NULL,NULL,'2025-01-28 09:07:16','2025-01-28 09:07:16'),(2554,NULL,NULL,'2025-01-28 09:07:32','2025-01-28 09:07:32'),(2555,NULL,NULL,'2025-01-28 09:08:06','2025-01-28 09:08:06'),(2556,NULL,NULL,'2025-01-28 09:14:17','2025-01-28 09:14:17'),(2557,NULL,NULL,'2025-01-28 09:14:26','2025-01-28 09:14:26'),(2558,NULL,NULL,'2025-01-28 09:29:38','2025-01-28 09:29:38'),(2559,NULL,NULL,'2025-01-28 09:29:46','2025-01-28 09:29:46'),(2560,NULL,NULL,'2025-01-28 09:30:06','2025-01-28 09:30:06'),(2561,NULL,NULL,'2025-01-28 09:34:28','2025-01-28 09:34:28'),(2562,NULL,NULL,'2025-01-28 09:35:03','2025-01-28 09:35:03'),(2563,NULL,NULL,'2025-01-28 09:35:07','2025-01-28 09:35:07'),(2564,NULL,NULL,'2025-01-28 09:35:29','2025-01-28 09:35:29'),(2565,NULL,NULL,'2025-01-28 09:35:31','2025-01-28 09:35:31'),(2566,NULL,NULL,'2025-01-28 09:37:48','2025-01-28 09:37:48'),(2567,NULL,NULL,'2025-01-28 09:38:21','2025-01-28 09:38:21'),(2568,NULL,NULL,'2025-01-28 09:39:27','2025-01-28 09:39:27'),(2569,NULL,NULL,'2025-01-28 09:39:33','2025-01-28 09:39:33'),(2570,NULL,NULL,'2025-01-28 09:44:11','2025-01-28 09:44:11'),(2571,NULL,NULL,'2025-01-28 09:44:32','2025-01-28 09:44:32'),(2572,NULL,NULL,'2025-01-28 09:44:48','2025-01-28 09:44:48'),(2573,NULL,NULL,'2025-01-28 09:44:59','2025-01-28 09:44:59'),(2574,NULL,NULL,'2025-01-28 09:45:08','2025-01-28 09:45:08'),(2575,NULL,NULL,'2025-01-28 09:45:13','2025-01-28 09:45:13'),(2576,NULL,NULL,'2025-01-28 09:45:18','2025-01-28 09:45:18'),(2577,NULL,NULL,'2025-01-28 09:45:40','2025-01-28 09:45:40'),(2578,NULL,NULL,'2025-01-28 09:45:55','2025-01-28 09:45:55'),(2579,NULL,NULL,'2025-01-28 09:46:00','2025-01-28 09:46:00'),(2580,NULL,NULL,'2025-01-28 09:46:03','2025-01-28 09:46:03'),(2581,NULL,NULL,'2025-01-28 09:46:07','2025-01-28 09:46:07'),(2582,NULL,NULL,'2025-01-28 09:46:13','2025-01-28 09:46:13'),(2583,NULL,NULL,'2025-01-28 09:46:16','2025-01-28 09:46:16'),(2584,NULL,NULL,'2025-01-28 09:46:30','2025-01-28 09:46:30'),(2585,NULL,NULL,'2025-01-28 09:48:35','2025-01-28 09:48:35'),(2586,NULL,NULL,'2025-01-28 09:48:39','2025-01-28 09:48:39'),(2587,NULL,NULL,'2025-01-28 09:48:59','2025-01-28 09:48:59'),(2588,NULL,NULL,'2025-01-28 09:49:04','2025-01-28 09:49:04'),(2589,NULL,NULL,'2025-01-28 09:49:42','2025-01-28 09:49:42'),(2590,NULL,NULL,'2025-01-28 09:49:47','2025-01-28 09:49:47'),(2591,NULL,NULL,'2025-01-28 09:51:53','2025-01-28 09:51:53'),(2592,NULL,NULL,'2025-01-28 09:51:57','2025-01-28 09:51:57'),(2593,NULL,NULL,'2025-01-28 09:52:11','2025-01-28 09:52:11'),(2594,NULL,NULL,'2025-01-28 09:52:19','2025-01-28 09:52:19'),(2595,NULL,NULL,'2025-01-28 09:52:38','2025-01-28 09:52:38'),(2596,NULL,NULL,'2025-01-28 09:52:46','2025-01-28 09:52:46'),(2597,NULL,NULL,'2025-01-28 09:53:34','2025-01-28 09:53:34'),(2598,NULL,NULL,'2025-01-28 09:53:38','2025-01-28 09:53:38'),(2599,NULL,NULL,'2025-01-28 09:54:47','2025-01-28 09:54:47'),(2600,NULL,NULL,'2025-01-28 09:54:52','2025-01-28 09:54:52'),(2601,NULL,NULL,'2025-01-28 09:55:10','2025-01-28 09:55:10'),(2602,NULL,NULL,'2025-01-28 09:55:18','2025-01-28 09:55:18'),(2603,NULL,NULL,'2025-01-28 09:55:28','2025-01-28 09:55:28'),(2604,NULL,NULL,'2025-01-28 09:55:36','2025-01-28 09:55:36'),(2605,NULL,NULL,'2025-01-28 09:55:46','2025-01-28 09:55:46'),(2606,NULL,NULL,'2025-01-28 09:56:20','2025-01-28 09:56:20'),(2607,NULL,NULL,'2025-01-28 09:56:24','2025-01-28 09:56:24'),(2608,NULL,NULL,'2025-01-28 09:56:27','2025-01-28 09:56:27'),(2609,NULL,NULL,'2025-01-28 09:56:30','2025-01-28 09:56:30'),(2610,NULL,NULL,'2025-01-28 09:56:30','2025-01-28 09:56:31'),(2611,NULL,NULL,'2025-01-28 09:56:33','2025-01-28 09:56:33'),(2612,NULL,NULL,'2025-01-28 09:56:37','2025-01-28 09:56:37'),(2613,NULL,NULL,'2025-01-28 09:56:45','2025-01-28 09:56:45'),(2614,NULL,NULL,'2025-01-28 09:56:54','2025-01-28 09:56:54'),(2615,NULL,NULL,'2025-01-28 09:57:01','2025-01-28 09:57:01'),(2616,NULL,NULL,'2025-01-28 09:57:13','2025-01-28 09:57:14'),(2617,NULL,NULL,'2025-01-28 09:57:17','2025-01-28 09:57:17'),(2618,NULL,NULL,'2025-01-28 09:57:30','2025-01-28 09:57:30'),(2619,NULL,NULL,'2025-01-28 09:57:34','2025-01-28 09:57:34'),(2620,NULL,NULL,'2025-01-28 09:57:48','2025-01-28 09:57:48'),(2621,NULL,NULL,'2025-01-28 09:57:52','2025-01-28 09:57:52'),(2622,NULL,NULL,'2025-01-28 09:57:55','2025-01-28 09:57:55'),(2623,NULL,NULL,'2025-01-28 09:57:57','2025-01-28 09:57:57'),(2624,NULL,NULL,'2025-01-28 09:58:02','2025-01-28 09:58:02'),(2625,NULL,NULL,'2025-01-28 09:58:02','2025-01-28 09:58:02'),(2626,NULL,NULL,'2025-01-28 09:58:50','2025-01-28 09:58:50'),(2627,NULL,NULL,'2025-01-28 09:58:53','2025-01-28 09:58:53'),(2628,NULL,NULL,'2025-01-28 09:58:58','2025-01-28 09:58:58'),(2629,NULL,NULL,'2025-01-28 09:59:01','2025-01-28 09:59:01'),(2630,NULL,NULL,'2025-01-28 09:59:13','2025-01-28 09:59:13'),(2631,NULL,NULL,'2025-01-28 09:59:19','2025-01-28 09:59:19'),(2632,NULL,NULL,'2025-01-28 09:59:23','2025-01-28 09:59:23'),(2633,NULL,NULL,'2025-01-28 09:59:33','2025-01-28 09:59:33'),(2634,NULL,NULL,'2025-01-28 09:59:36','2025-01-28 09:59:36'),(2635,NULL,NULL,'2025-01-28 09:59:43','2025-01-28 09:59:43'),(2636,NULL,NULL,'2025-01-28 09:59:47','2025-01-28 09:59:47'),(2637,NULL,NULL,'2025-01-28 10:00:06','2025-01-28 10:00:06'),(2638,NULL,NULL,'2025-01-28 10:00:15','2025-01-28 10:00:15'),(2639,NULL,NULL,'2025-01-28 10:00:44','2025-01-28 10:00:44'),(2640,NULL,NULL,'2025-01-28 10:00:53','2025-01-28 10:00:53'),(2641,NULL,NULL,'2025-01-28 10:01:13','2025-01-28 10:01:13'),(2642,NULL,NULL,'2025-01-28 10:02:38','2025-01-28 10:02:38'),(2643,NULL,NULL,'2025-01-28 10:02:48','2025-01-28 10:02:48'),(2644,NULL,NULL,'2025-01-28 10:03:20','2025-01-28 10:03:20'),(2645,NULL,NULL,'2025-01-28 10:03:24','2025-01-28 10:03:24'),(2646,NULL,NULL,'2025-01-28 10:27:20','2025-01-28 10:27:20'),(2647,NULL,NULL,'2025-01-28 10:27:42','2025-01-28 10:27:42'),(2648,NULL,NULL,'2025-01-28 10:27:47','2025-01-28 10:27:47'),(2649,NULL,NULL,'2025-01-28 10:27:51','2025-01-28 10:27:51'),(2650,NULL,NULL,'2025-01-28 10:28:12','2025-01-28 10:28:12'),(2651,NULL,NULL,'2025-01-28 10:28:20','2025-01-28 10:28:20'),(2652,NULL,NULL,'2025-01-28 10:30:33','2025-01-28 10:30:33'),(2653,NULL,NULL,'2025-01-28 10:30:38','2025-01-28 10:30:38'),(2654,NULL,NULL,'2025-01-28 10:31:44','2025-01-28 10:31:44'),(2655,NULL,NULL,'2025-01-28 10:31:50','2025-01-28 10:31:50'),(2656,NULL,NULL,'2025-01-28 10:31:55','2025-01-28 10:31:55'),(2657,NULL,NULL,'2025-01-28 10:31:59','2025-01-28 10:31:59'),(2658,NULL,NULL,'2025-01-28 10:31:59','2025-01-28 10:31:59'),(2659,NULL,NULL,'2025-01-28 10:32:05','2025-01-28 10:32:05'),(2660,NULL,NULL,'2025-01-28 10:32:07','2025-01-28 10:32:08'),(2661,NULL,NULL,'2025-01-28 10:32:11','2025-01-28 10:32:11'),(2662,NULL,NULL,'2025-01-28 10:32:21','2025-01-28 10:32:21'),(2663,NULL,NULL,'2025-01-28 10:32:24','2025-01-28 10:32:24'),(2664,NULL,NULL,'2025-01-28 10:32:29','2025-01-28 10:32:29'),(2665,NULL,NULL,'2025-01-28 10:32:31','2025-01-28 10:32:31'),(2666,NULL,NULL,'2025-01-28 10:32:32','2025-01-28 10:32:32'),(2667,NULL,NULL,'2025-01-28 10:32:38','2025-01-28 10:32:38'),(2668,NULL,NULL,'2025-01-28 10:32:42','2025-01-28 10:32:42'),(2669,NULL,NULL,'2025-01-28 10:32:57','2025-01-28 10:32:57'),(2670,NULL,NULL,'2025-01-28 10:33:02','2025-01-28 10:33:02'),(2671,NULL,NULL,'2025-01-28 10:33:28','2025-01-28 10:33:28'),(2672,NULL,NULL,'2025-01-28 10:33:36','2025-01-28 10:33:36'),(2673,NULL,NULL,'2025-01-28 10:34:01','2025-01-28 10:34:01'),(2674,NULL,NULL,'2025-01-28 10:34:07','2025-01-28 10:34:07'),(2675,NULL,NULL,'2025-01-28 10:34:11','2025-01-28 10:34:11'),(2676,NULL,NULL,'2025-01-28 10:34:14','2025-01-28 10:34:14'),(2677,NULL,NULL,'2025-01-28 10:34:25','2025-01-28 10:34:25'),(2678,NULL,NULL,'2025-01-28 10:34:36','2025-01-28 10:34:36'),(2679,NULL,NULL,'2025-01-28 10:34:58','2025-01-28 10:34:58'),(2680,NULL,NULL,'2025-01-28 10:35:09','2025-01-28 10:35:09'),(2681,NULL,NULL,'2025-01-28 10:35:16','2025-01-28 10:35:16'),(2682,NULL,NULL,'2025-01-28 10:35:19','2025-01-28 10:35:19'),(2683,NULL,NULL,'2025-01-28 10:35:40','2025-01-28 10:35:40'),(2684,NULL,NULL,'2025-01-28 10:35:47','2025-01-28 10:35:47'),(2685,NULL,NULL,'2025-01-28 10:35:59','2025-01-28 10:35:59'),(2686,NULL,NULL,'2025-01-28 10:36:26','2025-01-28 10:36:26'),(2687,NULL,NULL,'2025-01-28 10:38:00','2025-01-28 10:38:00'),(2688,NULL,NULL,'2025-01-28 10:38:33','2025-01-28 10:38:33'),(2689,NULL,NULL,'2025-01-28 10:40:43','2025-01-28 10:40:43'),(2690,NULL,NULL,'2025-01-28 10:40:48','2025-01-28 10:40:48'),(2691,NULL,NULL,'2025-01-28 10:41:08','2025-01-28 10:41:08'),(2692,NULL,NULL,'2025-01-28 10:41:13','2025-01-28 10:41:13'),(2693,NULL,NULL,'2025-01-28 10:41:38','2025-01-28 10:41:38'),(2694,NULL,NULL,'2025-01-28 10:41:45','2025-01-28 10:41:45'),(2695,NULL,NULL,'2025-01-28 10:41:52','2025-01-28 10:41:52'),(2696,NULL,NULL,'2025-01-28 10:41:56','2025-01-28 10:41:56'),(2697,NULL,NULL,'2025-01-28 10:42:02','2025-01-28 10:42:02'),(2698,NULL,NULL,'2025-01-28 10:42:11','2025-01-28 10:42:11'),(2699,NULL,NULL,'2025-01-28 10:43:21','2025-01-28 10:43:21'),(2700,NULL,NULL,'2025-01-28 10:43:26','2025-01-28 10:43:26'),(2701,NULL,NULL,'2025-01-28 10:45:20','2025-01-28 10:45:20'),(2702,NULL,NULL,'2025-01-28 10:45:24','2025-01-28 10:45:24'),(2703,NULL,NULL,'2025-01-28 10:45:30','2025-01-28 10:45:31'),(2704,NULL,NULL,'2025-01-28 10:45:49','2025-01-28 10:45:49'),(2705,NULL,NULL,'2025-01-28 10:45:53','2025-01-28 10:45:53'),(2706,NULL,NULL,'2025-01-28 10:49:46','2025-01-28 10:49:46'),(2707,NULL,NULL,'2025-01-28 10:49:50','2025-01-28 10:49:50'),(2708,NULL,NULL,'2025-01-28 10:50:07','2025-01-28 10:50:07'),(2709,NULL,NULL,'2025-01-28 10:50:16','2025-01-28 10:50:16'),(2710,NULL,NULL,'2025-01-28 10:50:44','2025-01-28 10:50:44'),(2711,NULL,NULL,'2025-01-28 10:50:53','2025-01-28 10:50:53'),(2712,NULL,NULL,'2025-01-28 10:52:43','2025-01-28 10:52:43'),(2713,NULL,NULL,'2025-01-28 10:52:49','2025-01-28 10:52:49'),(2714,NULL,NULL,'2025-01-28 10:52:51','2025-01-28 10:52:51'),(2715,NULL,NULL,'2025-01-28 10:56:37','2025-01-28 10:56:37'),(2716,NULL,NULL,'2025-01-28 10:56:45','2025-01-28 10:56:45'),(2717,NULL,NULL,'2025-01-28 10:58:58','2025-01-28 10:58:58'),(2718,NULL,NULL,'2025-01-28 10:59:16','2025-01-28 10:59:16'),(2719,NULL,NULL,'2025-01-28 10:59:19','2025-01-28 10:59:19'),(2720,NULL,NULL,'2025-01-28 10:59:23','2025-01-28 10:59:23'),(2721,NULL,NULL,'2025-01-28 10:59:37','2025-01-28 10:59:37'),(2722,NULL,NULL,'2025-01-28 10:59:44','2025-01-28 10:59:44'),(2723,NULL,NULL,'2025-01-28 11:04:45','2025-01-28 11:04:45'),(2724,NULL,NULL,'2025-01-28 11:04:49','2025-01-28 11:04:49'),(2725,NULL,NULL,'2025-01-28 11:05:33','2025-01-28 11:05:33'),(2726,NULL,NULL,'2025-01-28 11:05:37','2025-01-28 11:05:37'),(2727,NULL,NULL,'2025-01-28 11:05:42','2025-01-28 11:05:42'),(2728,NULL,NULL,'2025-01-28 11:06:01','2025-01-28 11:06:01'),(2729,NULL,NULL,'2025-01-28 11:07:32','2025-01-28 11:07:32'),(2730,NULL,NULL,'2025-01-28 11:07:41','2025-01-28 11:07:41'),(2731,NULL,NULL,'2025-01-28 11:07:46','2025-01-28 11:07:46'),(2732,NULL,NULL,'2025-01-28 11:07:53','2025-01-28 11:07:53'),(2733,NULL,NULL,'2025-01-28 11:07:58','2025-01-28 11:07:58'),(2734,NULL,NULL,'2025-01-28 11:08:08','2025-01-28 11:08:08'),(2735,NULL,NULL,'2025-01-28 11:08:16','2025-01-28 11:08:16'),(2736,NULL,NULL,'2025-01-28 11:08:20','2025-01-28 11:08:20'),(2737,NULL,NULL,'2025-01-28 11:08:45','2025-01-28 11:08:45'),(2738,NULL,NULL,'2025-01-28 11:09:09','2025-01-28 11:09:10'),(2739,NULL,NULL,'2025-01-28 11:11:07','2025-01-28 11:11:07'),(2740,NULL,NULL,'2025-01-28 11:11:15','2025-01-28 11:11:15'),(2741,NULL,NULL,'2025-01-28 11:11:28','2025-01-28 11:11:28'),(2742,NULL,NULL,'2025-01-28 11:11:32','2025-01-28 11:11:32'),(2743,NULL,NULL,'2025-01-28 11:11:36','2025-01-28 11:11:36'),(2744,NULL,NULL,'2025-01-28 11:12:04','2025-01-28 11:12:04'),(2745,NULL,NULL,'2025-01-28 11:12:43','2025-01-28 11:12:43'),(2746,NULL,NULL,'2025-01-28 11:13:16','2025-01-28 11:13:16'),(2747,NULL,NULL,'2025-01-28 11:13:24','2025-01-28 11:13:24'),(2748,NULL,NULL,'2025-01-28 11:13:52','2025-01-28 11:13:52'),(2749,NULL,NULL,'2025-01-28 11:14:54','2025-01-28 11:14:54'),(2750,NULL,NULL,'2025-01-28 11:15:02','2025-01-28 11:15:03'),(2751,NULL,NULL,'2025-01-28 11:15:44','2025-01-28 11:15:44'),(2752,NULL,NULL,'2025-01-28 11:15:47','2025-01-28 11:15:47'),(2753,NULL,NULL,'2025-01-28 11:15:52','2025-01-28 11:15:52'),(2754,NULL,NULL,'2025-01-28 11:16:20','2025-01-28 11:16:20'),(2755,NULL,NULL,'2025-01-28 11:16:44','2025-01-28 11:16:44'),(2756,NULL,NULL,'2025-01-28 11:17:26','2025-01-28 11:17:27'),(2757,NULL,NULL,'2025-01-28 11:19:07','2025-01-28 11:19:07'),(2758,NULL,NULL,'2025-01-28 11:19:11','2025-01-28 11:19:11'),(2759,NULL,NULL,'2025-01-28 11:19:56','2025-01-28 11:19:56'),(2760,NULL,NULL,'2025-01-28 11:19:58','2025-01-28 11:19:58'),(2761,NULL,NULL,'2025-01-28 11:22:11','2025-01-28 11:22:11'),(2762,NULL,NULL,'2025-01-28 11:22:16','2025-01-28 11:22:16'),(2763,NULL,NULL,'2025-01-28 11:22:30','2025-01-28 11:22:30'),(2764,NULL,NULL,'2025-01-28 11:22:38','2025-01-28 11:22:38'),(2765,NULL,NULL,'2025-01-28 11:23:42','2025-01-28 11:23:42'),(2766,NULL,NULL,'2025-01-28 11:23:50','2025-01-28 11:23:50'),(2767,NULL,NULL,'2025-01-28 11:24:21','2025-01-28 11:24:21'),(2768,NULL,NULL,'2025-01-28 11:24:27','2025-01-28 11:24:27'),(2769,NULL,NULL,'2025-01-28 11:25:15','2025-01-28 11:25:15'),(2770,NULL,NULL,'2025-01-28 11:25:19','2025-01-28 11:25:19'),(2771,NULL,NULL,'2025-01-28 11:25:46','2025-01-28 11:25:46'),(2772,NULL,NULL,'2025-01-28 11:26:05','2025-01-28 11:26:05'),(2773,NULL,NULL,'2025-01-28 11:26:42','2025-01-28 11:26:42'),(2774,NULL,NULL,'2025-01-28 11:26:47','2025-01-28 11:26:47'),(2775,NULL,NULL,'2025-01-28 11:27:17','2025-01-28 11:27:17'),(2776,NULL,NULL,'2025-01-28 11:31:08','2025-01-28 11:31:08'),(2777,NULL,NULL,'2025-01-28 11:35:24','2025-01-28 11:35:24'),(2778,NULL,NULL,'2025-01-28 11:35:28','2025-01-28 11:35:28'),(2779,NULL,NULL,'2025-01-28 11:35:30','2025-01-28 11:35:30'),(2780,NULL,NULL,'2025-01-28 11:35:39','2025-01-28 11:35:39'),(2781,NULL,NULL,'2025-01-28 11:35:47','2025-01-28 11:35:47'),(2782,NULL,NULL,'2025-01-28 11:37:30','2025-01-28 11:37:30'),(2783,NULL,NULL,'2025-01-28 11:37:38','2025-01-28 11:37:38'),(2784,NULL,NULL,'2025-01-28 11:37:51','2025-01-28 11:37:51'),(2785,NULL,NULL,'2025-01-28 11:38:18','2025-01-28 11:38:18'),(2786,NULL,NULL,'2025-01-28 11:38:24','2025-01-28 11:38:24'),(2787,NULL,NULL,'2025-01-28 11:38:54','2025-01-28 11:38:54'),(2788,NULL,NULL,'2025-01-28 11:39:50','2025-01-28 11:39:50'),(2789,NULL,NULL,'2025-01-28 11:39:55','2025-01-28 11:39:55'),(2790,NULL,NULL,'2025-01-28 11:40:11','2025-01-28 11:40:11'),(2791,NULL,NULL,'2025-01-28 11:40:22','2025-01-28 11:40:22'),(2792,NULL,NULL,'2025-01-28 11:41:30','2025-01-28 11:41:30'),(2793,NULL,NULL,'2025-01-28 11:41:57','2025-01-28 11:41:57'),(2794,NULL,NULL,'2025-01-28 11:45:15','2025-01-28 11:45:15'),(2795,NULL,NULL,'2025-01-28 11:45:46','2025-01-28 11:45:46'),(2796,NULL,NULL,'2025-01-28 11:46:08','2025-01-28 11:46:08'),(2797,NULL,NULL,'2025-01-28 11:46:36','2025-01-28 11:46:36'),(2798,NULL,NULL,'2025-01-28 11:47:36','2025-01-28 11:47:36'),(2799,NULL,NULL,'2025-01-28 11:47:43','2025-01-28 11:47:43'),(2800,NULL,NULL,'2025-01-28 11:47:45','2025-01-28 11:47:45'),(2801,NULL,NULL,'2025-01-28 11:48:20','2025-01-28 11:48:20'),(2802,NULL,NULL,'2025-01-28 11:48:32','2025-01-28 11:48:32'),(2803,NULL,NULL,'2025-01-28 11:48:57','2025-01-28 11:48:57'),(2804,NULL,NULL,'2025-01-28 11:49:32','2025-01-28 11:49:32'),(2805,NULL,NULL,'2025-01-28 11:49:34','2025-01-28 11:49:34'),(2806,NULL,NULL,'2025-01-28 11:49:42','2025-01-28 11:49:42'),(2807,NULL,NULL,'2025-01-28 11:49:45','2025-01-28 11:49:45'),(2808,NULL,NULL,'2025-01-28 11:49:47','2025-01-28 11:49:47'),(2809,NULL,NULL,'2025-01-28 11:50:18','2025-01-28 11:50:18'),(2810,NULL,NULL,'2025-01-28 11:50:47','2025-01-28 11:50:47'),(2811,NULL,NULL,'2025-01-28 11:51:28','2025-01-28 11:51:28'),(2812,NULL,NULL,'2025-01-28 11:51:46','2025-01-28 11:51:46'),(2813,NULL,NULL,'2025-01-28 11:52:21','2025-01-28 11:52:21'),(2814,NULL,NULL,'2025-01-28 11:52:49','2025-01-28 11:52:49'),(2815,NULL,NULL,'2025-01-28 11:53:02','2025-01-28 11:53:02'),(2816,NULL,NULL,'2025-01-28 11:53:31','2025-01-28 11:53:31'),(2817,NULL,NULL,'2025-01-28 11:54:40','2025-01-28 11:54:40'),(2818,NULL,NULL,'2025-01-28 11:55:08','2025-01-28 11:55:08'),(2819,NULL,NULL,'2025-01-28 11:55:43','2025-01-28 11:55:43'),(2820,NULL,NULL,'2025-01-28 11:55:46','2025-01-28 11:55:47'),(2821,NULL,NULL,'2025-01-28 11:56:19','2025-01-28 11:56:19'),(2822,NULL,NULL,'2025-01-28 11:56:24','2025-01-28 11:56:24'),(2823,NULL,NULL,'2025-01-28 11:56:28','2025-01-28 11:56:28'),(2824,NULL,NULL,'2025-01-28 11:56:39','2025-01-28 11:56:39'),(2825,NULL,NULL,'2025-01-28 11:57:00','2025-01-28 11:57:00'),(2826,NULL,NULL,'2025-01-28 11:57:10','2025-01-28 11:57:10'),(2827,NULL,NULL,'2025-01-28 11:57:17','2025-01-28 11:57:17'),(2828,NULL,NULL,'2025-01-28 11:57:33','2025-01-28 11:57:33'),(2829,NULL,NULL,'2025-01-28 11:57:36','2025-01-28 11:57:36'),(2830,NULL,NULL,'2025-01-28 11:57:39','2025-01-28 11:57:39'),(2831,NULL,NULL,'2025-01-28 11:57:48','2025-01-28 11:57:48'),(2832,NULL,NULL,'2025-01-28 11:57:53','2025-01-28 11:57:53'),(2833,NULL,NULL,'2025-01-28 11:57:56','2025-01-28 11:57:56'),(2834,NULL,NULL,'2025-01-28 11:58:16','2025-01-28 11:58:16'),(2835,NULL,NULL,'2025-01-28 11:58:19','2025-01-28 11:58:19'),(2836,NULL,NULL,'2025-01-28 11:58:24','2025-01-28 11:58:24'),(2837,NULL,NULL,'2025-01-28 11:59:39','2025-01-28 11:59:39'),(2838,NULL,NULL,'2025-01-28 11:59:45','2025-01-28 11:59:45'),(2839,NULL,NULL,'2025-01-28 11:59:50','2025-01-28 11:59:50'),(2840,NULL,NULL,'2025-01-28 11:59:56','2025-01-28 11:59:56'),(2841,NULL,NULL,'2025-01-28 12:00:49','2025-01-28 12:00:49'),(2842,NULL,NULL,'2025-01-28 12:00:54','2025-01-28 12:00:54'),(2843,NULL,NULL,'2025-01-28 12:01:08','2025-01-28 12:01:08'),(2844,NULL,NULL,'2025-01-28 12:01:12','2025-01-28 12:01:12'),(2845,NULL,NULL,'2025-01-28 12:01:19','2025-01-28 12:01:19'),(2846,NULL,NULL,'2025-01-28 12:01:47','2025-01-28 12:01:47'),(2847,NULL,NULL,'2025-01-28 12:03:47','2025-01-28 12:03:47'),(2848,NULL,NULL,'2025-01-28 12:03:52','2025-01-28 12:03:52'),(2849,NULL,NULL,'2025-01-28 12:04:25','2025-01-28 12:04:25'),(2850,NULL,NULL,'2025-01-28 12:04:27','2025-01-28 12:04:27'),(2851,NULL,NULL,'2025-01-28 12:05:12','2025-01-28 12:05:12'),(2852,NULL,NULL,'2025-01-28 12:05:17','2025-01-28 12:05:17'),(2853,NULL,NULL,'2025-01-28 12:05:23','2025-01-28 12:05:23'),(2854,NULL,NULL,'2025-01-28 12:05:44','2025-01-28 12:05:44'),(2855,NULL,NULL,'2025-01-28 12:06:56','2025-01-28 12:06:56'),(2856,NULL,NULL,'2025-01-28 12:07:03','2025-01-28 12:07:03'),(2857,NULL,NULL,'2025-01-28 12:07:29','2025-01-28 12:07:29'),(2858,NULL,NULL,'2025-01-28 12:07:35','2025-01-28 12:07:36'),(2859,NULL,NULL,'2025-01-28 12:07:37','2025-01-28 12:07:37'),(2860,NULL,NULL,'2025-01-28 12:07:43','2025-01-28 12:07:44'),(2861,NULL,NULL,'2025-01-28 12:08:10','2025-01-28 12:08:10'),(2862,NULL,NULL,'2025-01-28 12:08:15','2025-01-28 12:08:15'),(2863,NULL,NULL,'2025-01-28 12:08:30','2025-01-28 12:08:31'),(2864,NULL,NULL,'2025-01-28 12:08:35','2025-01-28 12:08:35'),(2865,NULL,NULL,'2025-01-28 12:08:48','2025-01-28 12:08:48'),(2866,NULL,NULL,'2025-01-28 12:08:57','2025-01-28 12:08:57'),(2867,NULL,NULL,'2025-01-28 12:09:52','2025-01-28 12:09:53'),(2868,NULL,NULL,'2025-01-28 12:09:58','2025-01-28 12:09:58'),(2869,NULL,NULL,'2025-01-28 12:10:09','2025-01-28 12:10:09'),(2870,NULL,NULL,'2025-01-28 12:10:13','2025-01-28 12:10:13'),(2871,NULL,NULL,'2025-01-28 12:10:49','2025-01-28 12:10:49'),(2872,NULL,NULL,'2025-01-28 12:10:55','2025-01-28 12:10:55'),(2873,NULL,NULL,'2025-01-28 12:11:13','2025-01-28 12:11:13'),(2874,NULL,NULL,'2025-01-28 12:11:17','2025-01-28 12:11:17'),(2875,NULL,NULL,'2025-01-28 12:12:20','2025-01-28 12:12:20'),(2876,NULL,NULL,'2025-01-28 12:12:26','2025-01-28 12:12:26'),(2877,NULL,NULL,'2025-01-28 12:12:37','2025-01-28 12:12:37'),(2878,NULL,NULL,'2025-01-28 12:13:11','2025-01-28 12:13:11'),(2879,NULL,NULL,'2025-01-28 12:13:51','2025-01-28 12:13:51'),(2880,NULL,NULL,'2025-01-28 12:14:11','2025-01-28 12:14:11'),(2881,NULL,NULL,'2025-01-28 12:14:16','2025-01-28 12:14:16'),(2882,NULL,NULL,'2025-01-28 12:14:17','2025-01-28 12:14:17'),(2883,NULL,NULL,'2025-01-28 12:14:19','2025-01-28 12:14:19'),(2884,NULL,NULL,'2025-01-28 12:14:27','2025-01-28 12:14:28'),(2885,NULL,NULL,'2025-01-28 12:14:30','2025-01-28 12:14:30'),(2886,NULL,NULL,'2025-01-28 12:14:33','2025-01-28 12:14:33'),(2887,NULL,NULL,'2025-01-28 12:14:37','2025-01-28 12:14:37'),(2888,NULL,NULL,'2025-01-28 12:14:43','2025-01-28 12:14:43'),(2889,NULL,NULL,'2025-01-28 12:14:45','2025-01-28 12:14:45'),(2890,NULL,NULL,'2025-01-28 12:14:46','2025-01-28 12:14:46'),(2891,NULL,NULL,'2025-01-28 12:14:49','2025-01-28 12:14:49'),(2892,NULL,NULL,'2025-01-28 12:14:59','2025-01-28 12:14:59'),(2893,NULL,NULL,'2025-01-28 12:15:08','2025-01-28 12:15:08'),(2894,NULL,NULL,'2025-01-28 12:16:28','2025-01-28 12:16:28'),(2895,NULL,NULL,'2025-01-28 12:16:37','2025-01-28 12:16:37'),(2896,NULL,NULL,'2025-01-28 12:17:02','2025-01-28 12:17:02'),(2897,NULL,NULL,'2025-01-28 12:17:05','2025-01-28 12:17:05'),(2898,NULL,NULL,'2025-01-28 12:17:08','2025-01-28 12:17:08'),(2899,NULL,NULL,'2025-01-28 12:17:16','2025-01-28 12:17:16'),(2900,NULL,NULL,'2025-01-28 12:17:19','2025-01-28 12:17:19'),(2901,NULL,NULL,'2025-01-28 12:17:24','2025-01-28 12:17:24'),(2902,NULL,NULL,'2025-01-28 12:17:39','2025-01-28 12:17:39'),(2903,NULL,NULL,'2025-01-28 12:17:44','2025-01-28 12:17:44'),(2904,NULL,NULL,'2025-01-28 12:17:47','2025-01-28 12:17:47'),(2905,NULL,NULL,'2025-01-28 12:18:02','2025-01-28 12:18:02'),(2906,NULL,NULL,'2025-01-28 12:18:07','2025-01-28 12:18:07'),(2907,NULL,NULL,'2025-01-28 12:18:08','2025-01-28 12:18:08'),(2908,NULL,NULL,'2025-01-28 12:18:12','2025-01-28 12:18:12'),(2909,NULL,NULL,'2025-01-28 12:18:14','2025-01-28 12:18:14'),(2910,NULL,NULL,'2025-01-28 12:18:19','2025-01-28 12:18:19'),(2911,NULL,NULL,'2025-01-28 12:18:38','2025-01-28 12:18:38'),(2912,NULL,NULL,'2025-01-28 12:18:44','2025-01-28 12:18:44'),(2913,NULL,NULL,'2025-01-28 12:19:12','2025-01-28 12:19:12'),(2914,NULL,NULL,'2025-01-28 12:20:22','2025-01-28 12:20:22'),(2915,NULL,NULL,'2025-01-28 12:20:28','2025-01-28 12:20:28'),(2916,NULL,NULL,'2025-01-28 12:20:31','2025-01-28 12:20:31'),(2917,NULL,NULL,'2025-01-28 12:20:37','2025-01-28 12:20:37'),(2918,NULL,NULL,'2025-01-28 12:20:39','2025-01-28 12:20:39'),(2919,NULL,NULL,'2025-01-28 12:20:42','2025-01-28 12:20:42'),(2920,NULL,NULL,'2025-01-28 12:20:43','2025-01-28 12:20:43'),(2921,NULL,NULL,'2025-01-28 12:20:50','2025-01-28 12:20:50'),(2922,NULL,NULL,'2025-01-28 12:21:18','2025-01-28 12:21:18'),(2923,NULL,NULL,'2025-01-28 12:21:21','2025-01-28 12:21:21'),(2924,NULL,NULL,'2025-01-28 12:21:30','2025-01-28 12:21:30'),(2925,NULL,NULL,'2025-01-28 12:21:58','2025-01-28 12:21:58'),(2926,NULL,NULL,'2025-01-28 12:22:59','2025-01-28 12:22:59'),(2927,NULL,NULL,'2025-01-28 12:31:15','2025-01-28 12:31:15'),(2928,NULL,NULL,'2025-01-28 12:34:33','2025-01-28 12:34:33'),(2929,NULL,NULL,'2025-01-28 12:36:05','2025-01-28 12:36:05'),(2930,NULL,NULL,'2025-01-28 12:36:46','2025-01-28 12:36:46'),(2931,NULL,NULL,'2025-01-28 12:39:45','2025-01-28 12:39:45'),(2932,NULL,NULL,'2025-01-28 12:55:42','2025-01-28 12:55:42'),(2933,NULL,NULL,'2025-01-28 13:10:47','2025-01-28 13:10:47'),(2934,NULL,NULL,'2025-01-28 13:13:37','2025-01-28 13:13:37'),(2935,NULL,NULL,'2025-01-28 13:30:43','2025-01-28 13:30:43'),(2936,NULL,NULL,'2025-01-28 13:38:00','2025-01-28 13:38:00'),(2937,NULL,NULL,'2025-01-28 13:46:42','2025-01-28 13:46:42'),(2938,NULL,NULL,'2025-01-28 13:50:06','2025-01-28 13:50:06'),(2939,NULL,NULL,'2025-01-28 13:55:49','2025-01-28 13:55:49'),(2940,NULL,NULL,'2025-01-28 14:29:47','2025-01-28 14:29:47'),(2941,NULL,NULL,'2025-01-28 14:44:50','2025-01-28 14:44:50'),(2942,NULL,NULL,'2025-01-28 14:59:54','2025-01-28 14:59:54'),(2943,NULL,NULL,'2025-01-28 15:14:55','2025-01-28 15:14:55'),(2944,NULL,NULL,'2025-01-28 15:29:59','2025-01-28 15:29:59'),(2945,NULL,NULL,'2025-01-28 15:55:10','2025-01-28 15:55:10'),(2946,NULL,NULL,'2025-01-28 16:02:09','2025-01-28 16:02:09'),(2947,NULL,NULL,'2025-01-29 06:53:37','2025-01-29 06:53:37'),(2948,NULL,NULL,'2025-01-29 07:34:41','2025-01-29 07:34:41'),(2949,NULL,NULL,'2025-01-29 07:50:01','2025-01-29 07:50:01'),(2950,NULL,NULL,'2025-01-29 08:16:07','2025-01-29 08:16:07'),(2951,NULL,NULL,'2025-01-29 09:17:45','2025-01-29 09:17:45'),(2952,NULL,NULL,'2025-01-29 10:05:54','2025-01-29 10:05:54'),(2953,NULL,NULL,'2025-01-29 10:22:03','2025-01-29 10:22:03'),(2954,NULL,NULL,'2025-01-29 10:30:28','2025-01-29 10:30:28'),(2955,NULL,NULL,'2025-01-29 10:30:37','2025-01-29 10:30:37'),(2956,NULL,NULL,'2025-01-29 10:30:48','2025-01-29 10:30:48'),(2957,NULL,NULL,'2025-01-29 10:30:56','2025-01-29 10:30:56'),(2958,NULL,NULL,'2025-01-29 10:48:17','2025-01-29 10:48:17'),(2959,NULL,NULL,'2025-01-29 10:48:18','2025-01-29 10:48:18'),(2960,NULL,NULL,'2025-01-29 11:41:12','2025-01-29 11:41:12'),(2961,NULL,NULL,'2025-01-29 11:42:34','2025-01-29 11:42:34'),(2962,NULL,NULL,'2025-01-29 11:54:33','2025-01-29 11:54:34'),(2963,NULL,NULL,'2025-01-29 12:10:59','2025-01-29 12:10:59'),(2964,NULL,NULL,'2025-01-29 12:17:15','2025-01-29 12:17:15'),(2965,NULL,NULL,'2025-01-29 12:38:28','2025-01-29 12:38:28'),(2966,NULL,NULL,'2025-01-29 12:47:21','2025-01-29 12:47:21'),(2967,NULL,NULL,'2025-01-29 13:17:17','2025-01-29 13:17:17'),(2968,NULL,NULL,'2025-01-29 13:20:55','2025-01-29 13:20:55'),(2969,NULL,NULL,'2025-01-29 13:49:44','2025-01-29 13:49:44'),(2970,NULL,NULL,'2025-01-29 13:56:39','2025-01-29 13:56:42'),(2971,NULL,NULL,'2025-01-29 14:50:23','2025-01-29 14:50:23'),(2972,NULL,NULL,'2025-01-29 14:50:33','2025-01-29 14:50:33'),(2973,NULL,NULL,'2025-01-29 14:50:57','2025-01-29 14:50:57'),(2974,NULL,NULL,'2025-01-29 14:51:04','2025-01-29 14:51:04'),(2975,NULL,NULL,'2025-01-29 14:51:08','2025-01-29 14:51:08'),(2976,NULL,NULL,'2025-01-29 14:51:14','2025-01-29 14:51:14'),(2977,NULL,NULL,'2025-01-29 14:51:22','2025-01-29 14:51:22'),(2978,NULL,NULL,'2025-01-29 14:51:31','2025-01-29 14:51:31'),(2979,NULL,NULL,'2025-01-29 14:51:35','2025-01-29 14:51:35'),(2980,NULL,NULL,'2025-01-29 14:55:46','2025-01-29 14:55:46'),(2981,NULL,NULL,'2025-01-29 14:55:52','2025-01-29 14:55:52'),(2982,NULL,NULL,'2025-01-29 15:01:15','2025-01-29 15:01:15'),(2983,NULL,NULL,'2025-01-29 15:01:21','2025-01-29 15:01:22'),(2984,NULL,NULL,'2025-01-29 15:06:49','2025-01-29 15:06:49'),(2985,NULL,NULL,'2025-01-29 15:10:55','2025-01-29 15:10:55'),(2986,NULL,NULL,'2025-01-29 15:11:03','2025-01-29 15:11:03'),(2987,NULL,NULL,'2025-01-29 15:11:07','2025-01-29 15:11:08'),(2988,NULL,NULL,'2025-01-29 15:11:13','2025-01-29 15:11:13'),(2989,NULL,NULL,'2025-01-29 15:11:14','2025-01-29 15:11:14'),(2990,NULL,NULL,'2025-01-29 15:11:18','2025-01-29 15:11:18'),(2991,NULL,NULL,'2025-01-29 15:11:25','2025-01-29 15:11:25'),(2992,NULL,NULL,'2025-01-29 15:12:37','2025-01-29 15:12:37'),(2993,NULL,NULL,'2025-01-29 15:12:49','2025-01-29 15:12:49'),(2994,NULL,NULL,'2025-01-29 15:12:53','2025-01-29 15:12:53'),(2995,NULL,NULL,'2025-01-29 15:13:22','2025-01-29 15:13:22'),(2996,NULL,NULL,'2025-01-29 15:14:02','2025-01-29 15:14:02'),(2997,NULL,NULL,'2025-01-29 15:14:06','2025-01-29 15:14:06'),(2998,NULL,NULL,'2025-01-29 15:17:27','2025-01-29 15:17:27'),(2999,NULL,NULL,'2025-01-29 15:17:34','2025-01-29 15:17:35'),(3000,NULL,NULL,'2025-01-29 15:18:46','2025-01-29 15:18:46'),(3001,NULL,NULL,'2025-01-29 15:21:14','2025-01-29 15:21:14'),(3002,NULL,NULL,'2025-01-29 15:24:23','2025-01-29 15:24:23'),(3003,NULL,NULL,'2025-01-29 15:24:35','2025-01-29 15:24:35'),(3004,NULL,NULL,'2025-01-29 15:25:01','2025-01-29 15:25:01'),(3005,NULL,NULL,'2025-01-29 15:30:14','2025-01-29 15:30:15'),(3006,NULL,NULL,'2025-01-29 15:39:19','2025-01-29 15:39:35'),(3007,NULL,NULL,'2025-01-29 15:45:01','2025-01-29 15:45:01'),(3008,NULL,NULL,'2025-01-29 16:02:55','2025-01-29 16:02:55'),(3009,NULL,NULL,'2025-01-30 07:42:37','2025-01-30 07:42:37'),(3010,NULL,NULL,'2025-01-30 13:11:06','2025-01-30 13:11:06'),(3011,NULL,NULL,'2025-01-30 15:02:43','2025-01-30 15:02:43'),(3012,NULL,NULL,'2025-01-30 15:17:51','2025-01-30 15:17:51'),(3013,NULL,NULL,'2025-01-30 17:15:47','2025-01-30 17:15:47'),(3014,NULL,NULL,'2025-01-31 05:35:07','2025-01-31 05:35:07'),(3015,NULL,NULL,'2025-01-31 05:56:26','2025-01-31 05:56:27'),(3016,NULL,NULL,'2025-01-31 07:39:17','2025-01-31 07:39:17'),(3017,NULL,NULL,'2025-01-31 07:56:12','2025-01-31 07:56:12'),(3018,NULL,NULL,'2025-01-31 08:00:15','2025-01-31 08:01:00'),(3019,NULL,NULL,'2025-01-31 08:58:01','2025-01-31 08:58:01'),(3020,NULL,NULL,'2025-01-31 09:01:32','2025-01-31 09:01:32'),(3021,NULL,NULL,'2025-01-31 09:07:54','2025-01-31 09:07:54'),(3022,NULL,NULL,'2025-01-31 09:09:54','2025-01-31 09:09:54'),(3023,NULL,NULL,'2025-01-31 09:16:18','2025-01-31 09:16:18'),(3024,NULL,NULL,'2025-01-31 09:44:02','2025-01-31 09:44:02'),(3025,NULL,NULL,'2025-01-31 10:03:52','2025-01-31 10:03:52'),(3026,NULL,NULL,'2025-01-31 10:05:19','2025-01-31 10:05:19'),(3027,NULL,NULL,'2025-01-31 10:06:05','2025-01-31 10:06:05'),(3028,NULL,NULL,'2025-01-31 10:07:12','2025-01-31 10:07:12'),(3029,NULL,NULL,'2025-01-31 10:07:49','2025-01-31 10:07:49'),(3030,NULL,NULL,'2025-01-31 10:07:49','2025-01-31 10:07:49'),(3031,NULL,NULL,'2025-01-31 10:15:08','2025-01-31 10:15:08'),(3032,NULL,NULL,'2025-01-31 10:16:24','2025-01-31 10:16:24'),(3033,NULL,NULL,'2025-01-31 10:16:46','2025-01-31 10:16:46'),(3034,NULL,NULL,'2025-01-31 10:16:59','2025-01-31 10:16:59'),(3035,NULL,NULL,'2025-01-31 10:17:39','2025-01-31 10:17:39'),(3036,NULL,NULL,'2025-01-31 10:25:21','2025-01-31 10:25:21'),(3037,NULL,NULL,'2025-01-31 10:40:42','2025-01-31 10:40:42'),(3038,NULL,NULL,'2025-01-31 10:41:20','2025-01-31 10:41:20'),(3039,NULL,NULL,'2025-01-31 10:41:52','2025-01-31 10:41:52'),(3040,NULL,NULL,'2025-01-31 10:42:51','2025-01-31 10:42:51'),(3041,NULL,NULL,'2025-01-31 10:44:36','2025-01-31 10:44:36'),(3042,NULL,NULL,'2025-01-31 10:53:00','2025-01-31 10:53:00'),(3043,NULL,NULL,'2025-01-31 10:53:19','2025-01-31 10:53:19'),(3044,NULL,NULL,'2025-01-31 11:35:48','2025-01-31 11:35:48'),(3045,NULL,NULL,'2025-01-31 12:59:59','2025-01-31 12:59:59'),(3046,NULL,NULL,'2025-02-01 05:11:41','2025-02-01 05:11:41'),(3047,NULL,NULL,'2025-02-01 05:16:56','2025-02-01 05:16:56'),(3048,NULL,NULL,'2025-02-01 05:22:23','2025-02-01 05:22:23'),(3049,NULL,NULL,'2025-02-01 05:24:12','2025-02-01 05:24:12'),(3050,NULL,NULL,'2025-02-01 05:25:25','2025-02-01 05:25:25'),(3051,NULL,NULL,'2025-02-01 05:25:55','2025-02-01 05:25:55'),(3052,NULL,NULL,'2025-02-01 05:29:16','2025-02-01 05:29:16'),(3053,NULL,NULL,'2025-02-01 05:33:26','2025-02-01 05:33:26'),(3054,NULL,NULL,'2025-02-01 06:30:27','2025-02-01 06:30:27'),(3055,NULL,NULL,'2025-02-01 06:40:24','2025-02-01 06:40:24'),(3056,NULL,NULL,'2025-02-01 06:45:07','2025-02-01 06:45:07'),(3057,NULL,NULL,'2025-02-01 11:19:30','2025-02-01 11:19:30'),(3058,NULL,NULL,'2025-02-01 11:30:23','2025-02-01 11:30:23'),(3059,NULL,NULL,'2025-02-02 02:55:52','2025-02-02 02:55:52'),(3060,NULL,NULL,'2025-02-02 18:49:09','2025-02-02 18:49:09'),(3061,NULL,NULL,'2025-02-03 05:32:57','2025-02-03 05:32:57'),(3062,NULL,NULL,'2025-02-03 05:58:20','2025-02-03 05:58:20'),(3063,NULL,NULL,'2025-02-03 06:16:51','2025-02-03 06:16:51'),(3064,NULL,NULL,'2025-02-03 07:02:56','2025-02-03 07:02:56'),(3065,NULL,NULL,'2025-02-03 08:10:57','2025-02-03 08:10:57'),(3066,NULL,NULL,'2025-02-03 08:37:21','2025-02-03 08:37:21'),(3067,NULL,NULL,'2025-02-03 08:48:22','2025-02-03 08:48:22'),(3068,NULL,NULL,'2025-02-03 08:48:24','2025-02-03 08:48:25'),(3069,NULL,NULL,'2025-02-03 08:48:26','2025-02-03 08:48:26'),(3070,NULL,NULL,'2025-02-03 08:48:28','2025-02-03 08:48:28'),(3071,NULL,NULL,'2025-02-03 08:48:29','2025-02-03 08:48:29'),(3072,NULL,NULL,'2025-02-03 08:48:53','2025-02-03 08:48:53'),(3073,NULL,NULL,'2025-02-03 08:48:56','2025-02-03 08:48:56'),(3074,NULL,NULL,'2025-02-03 08:48:58','2025-02-03 08:48:58'),(3075,NULL,NULL,'2025-02-03 08:51:15','2025-02-03 08:51:15'),(3076,NULL,NULL,'2025-02-03 09:07:23','2025-02-03 09:07:23'),(3077,NULL,NULL,'2025-02-03 09:38:38','2025-02-03 09:38:39'),(3078,NULL,NULL,'2025-02-03 09:39:56','2025-02-03 09:39:56'),(3079,NULL,NULL,'2025-02-03 09:42:45','2025-02-03 09:42:45'),(3080,NULL,NULL,'2025-02-03 09:45:45','2025-02-03 09:45:45'),(3081,NULL,NULL,'2025-02-03 09:46:43','2025-02-03 09:46:43'),(3082,NULL,NULL,'2025-02-03 09:54:42','2025-02-03 09:54:42'),(3083,NULL,NULL,'2025-02-03 09:55:49','2025-02-03 09:55:49'),(3084,NULL,NULL,'2025-02-03 09:57:49','2025-02-03 09:57:49'),(3085,NULL,NULL,'2025-02-03 12:23:15','2025-02-03 12:23:15'),(3086,NULL,NULL,'2025-02-03 17:13:29','2025-02-03 17:13:29'),(3087,NULL,NULL,'2025-02-04 00:31:53','2025-02-04 00:31:53'),(3088,NULL,NULL,'2025-02-04 06:52:03','2025-02-04 06:52:13'),(3089,NULL,NULL,'2025-02-04 07:38:05','2025-02-04 07:38:05'),(3090,NULL,NULL,'2025-02-04 07:41:14','2025-02-04 07:41:14'),(3091,NULL,NULL,'2025-02-04 07:42:57','2025-02-04 07:42:57'),(3092,NULL,NULL,'2025-02-04 07:45:49','2025-02-04 07:45:49'),(3093,NULL,NULL,'2025-02-04 07:50:14','2025-02-04 07:50:14'),(3094,NULL,NULL,'2025-02-04 07:51:24','2025-02-04 07:51:24'),(3095,NULL,NULL,'2025-02-04 07:51:29','2025-02-04 07:51:29'),(3096,NULL,NULL,'2025-02-04 07:54:32','2025-02-04 07:54:32'),(3097,NULL,NULL,'2025-02-04 07:54:32','2025-02-04 07:54:32'),(3098,NULL,NULL,'2025-02-04 07:55:42','2025-02-04 07:55:42'),(3099,NULL,NULL,'2025-02-04 07:55:51','2025-02-04 07:55:51'),(3100,NULL,NULL,'2025-02-04 08:00:18','2025-02-04 08:00:18'),(3101,NULL,NULL,'2025-02-04 08:08:04','2025-02-04 08:08:04'),(3102,NULL,NULL,'2025-02-04 08:11:33','2025-02-04 08:11:33'),(3103,NULL,NULL,'2025-02-04 08:13:50','2025-02-04 08:13:50'),(3104,NULL,NULL,'2025-02-04 08:13:50','2025-02-04 08:13:50'),(3105,NULL,NULL,'2025-02-04 08:15:23','2025-02-04 08:15:23'),(3106,NULL,NULL,'2025-02-04 08:15:34','2025-02-04 08:15:34'),(3107,NULL,NULL,'2025-02-04 08:22:14','2025-02-04 08:22:14'),(3108,NULL,NULL,'2025-02-04 08:30:47','2025-02-04 08:30:47'),(3109,NULL,NULL,'2025-02-04 10:02:10','2025-02-04 10:02:10'),(3110,NULL,NULL,'2025-02-04 10:17:33','2025-02-04 10:17:33'),(3111,NULL,NULL,'2025-02-04 11:28:01','2025-02-04 11:28:02'),(3112,NULL,NULL,'2025-02-04 11:29:32','2025-02-04 11:29:32'),(3113,NULL,NULL,'2025-02-04 12:54:52','2025-02-04 12:54:52'),(3114,NULL,NULL,'2025-02-04 19:37:23','2025-02-04 19:37:23'),(3115,NULL,NULL,'2025-02-05 05:07:22','2025-02-05 05:07:22'),(3116,NULL,NULL,'2025-02-05 05:12:41','2025-02-05 05:12:41'),(3117,NULL,NULL,'2025-02-05 05:59:33','2025-02-05 05:59:33'),(3118,NULL,NULL,'2025-02-05 06:02:21','2025-02-05 06:02:21'),(3119,NULL,NULL,'2025-02-05 06:25:22','2025-02-05 06:25:22'),(3120,NULL,NULL,'2025-02-05 06:26:33','2025-02-05 06:26:33'),(3121,NULL,NULL,'2025-02-05 06:27:52','2025-02-05 06:27:52'),(3122,NULL,NULL,'2025-02-05 06:37:22','2025-02-05 06:37:22'),(3123,NULL,NULL,'2025-02-05 06:43:34','2025-02-05 06:43:34'),(3124,NULL,NULL,'2025-02-05 06:46:57','2025-02-05 06:46:57'),(3125,NULL,NULL,'2025-02-05 06:47:09','2025-02-05 06:47:09'),(3126,NULL,NULL,'2025-02-05 06:48:19','2025-02-05 06:48:19'),(3127,NULL,NULL,'2025-02-05 07:01:35','2025-02-05 07:01:35'),(3128,NULL,NULL,'2025-02-05 07:03:23','2025-02-05 07:03:23'),(3129,NULL,NULL,'2025-02-05 07:04:23','2025-02-05 07:04:23'),(3130,NULL,NULL,'2025-02-05 07:06:02','2025-02-05 07:06:02'),(3131,NULL,NULL,'2025-02-05 07:17:49','2025-02-05 07:17:50'),(3132,NULL,NULL,'2025-02-05 07:18:56','2025-02-05 07:18:56'),(3133,NULL,NULL,'2025-02-05 07:22:50','2025-02-05 07:22:50'),(3134,NULL,NULL,'2025-02-05 07:26:58','2025-02-05 07:26:58'),(3135,NULL,NULL,'2025-02-05 07:35:28','2025-02-05 07:35:28'),(3136,NULL,NULL,'2025-02-05 07:43:52','2025-02-05 07:43:52'),(3137,NULL,NULL,'2025-02-05 07:44:00','2025-02-05 07:44:00'),(3138,NULL,NULL,'2025-02-05 07:44:45','2025-02-05 07:44:46'),(3139,NULL,NULL,'2025-02-05 07:47:01','2025-02-05 07:47:01'),(3140,NULL,NULL,'2025-02-05 07:47:14','2025-02-05 07:47:14');
/*!40000 ALTER TABLE `customer_visitor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `data_exporter_uuid`
--

DROP TABLE IF EXISTS `data_exporter_uuid`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `data_exporter_uuid` (
  `uuid` varchar(36) NOT NULL COMMENT 'Entity UUID',
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `type` varchar(36) NOT NULL COMMENT 'Entity type',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Created At',
  PRIMARY KEY (`uuid`),
  UNIQUE KEY `DATA_EXPORTER_UUID_ENTITY_ID_TYPE` (`entity_id`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Data Export Items UUID References Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `data_exporter_uuid`
--

LOCK TABLES `data_exporter_uuid` WRITE;
/*!40000 ALTER TABLE `data_exporter_uuid` DISABLE KEYS */;
/*!40000 ALTER TABLE `data_exporter_uuid` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `design_change`
--

DROP TABLE IF EXISTS `design_change`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `design_change` (
  `design_change_id` int NOT NULL AUTO_INCREMENT COMMENT 'Design Change ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `design` varchar(255) DEFAULT NULL COMMENT 'Design',
  `date_from` date DEFAULT NULL COMMENT 'First Date of Design Activity',
  `date_to` date DEFAULT NULL COMMENT 'Last Date of Design Activity',
  PRIMARY KEY (`design_change_id`),
  KEY `DESIGN_CHANGE_STORE_ID` (`store_id`),
  CONSTRAINT `DESIGN_CHANGE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Design Changes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `design_change`
--

LOCK TABLES `design_change` WRITE;
/*!40000 ALTER TABLE `design_change` DISABLE KEYS */;
/*!40000 ALTER TABLE `design_change` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `design_config_dummy_cl`
--

DROP TABLE IF EXISTS `design_config_dummy_cl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `design_config_dummy_cl` (
  `version_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Version ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  PRIMARY KEY (`version_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='design_config_dummy_cl';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `design_config_dummy_cl`
--

LOCK TABLES `design_config_dummy_cl` WRITE;
/*!40000 ALTER TABLE `design_config_dummy_cl` DISABLE KEYS */;
/*!40000 ALTER TABLE `design_config_dummy_cl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `design_config_grid_flat`
--

DROP TABLE IF EXISTS `design_config_grid_flat`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `design_config_grid_flat` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `store_website_id` int DEFAULT NULL COMMENT 'Store_website_id',
  `store_group_id` int DEFAULT NULL COMMENT 'Store_group_id',
  `store_id` int DEFAULT NULL COMMENT 'Store_id',
  `theme_theme_id` varchar(255) DEFAULT NULL COMMENT 'Theme_theme_id',
  PRIMARY KEY (`entity_id`),
  KEY `DESIGN_CONFIG_GRID_FLAT_STORE_WEBSITE_ID` (`store_website_id`),
  KEY `DESIGN_CONFIG_GRID_FLAT_STORE_GROUP_ID` (`store_group_id`),
  KEY `DESIGN_CONFIG_GRID_FLAT_STORE_ID` (`store_id`),
  FULLTEXT KEY `DESIGN_CONFIG_GRID_FLAT_THEME_THEME_ID` (`theme_theme_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='design_config_grid_flat';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `design_config_grid_flat`
--

LOCK TABLES `design_config_grid_flat` WRITE;
/*!40000 ALTER TABLE `design_config_grid_flat` DISABLE KEYS */;
INSERT INTO `design_config_grid_flat` VALUES (0,NULL,NULL,NULL,'6'),(1,1,NULL,NULL,'6'),(2,1,1,1,'6'),(3,1,4,5,'6'),(4,2,NULL,NULL,'6'),(5,2,2,2,'6'),(6,3,NULL,NULL,'6'),(7,3,5,3,'6'),(8,4,NULL,NULL,'6'),(9,4,6,4,'6');
/*!40000 ALTER TABLE `design_config_grid_flat` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `directory_country`
--

DROP TABLE IF EXISTS `directory_country`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `directory_country` (
  `country_id` varchar(2) NOT NULL COMMENT 'Country ID in ISO-2',
  `iso2_code` varchar(2) DEFAULT NULL COMMENT 'Country ISO-2 format',
  `iso3_code` varchar(3) DEFAULT NULL COMMENT 'Country ISO-3',
  PRIMARY KEY (`country_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Directory Country';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `directory_country`
--

LOCK TABLES `directory_country` WRITE;
/*!40000 ALTER TABLE `directory_country` DISABLE KEYS */;
INSERT INTO `directory_country` VALUES ('AD','AD','AND'),('AE','AE','ARE'),('AF','AF','AFG'),('AG','AG','ATG'),('AI','AI','AIA'),('AL','AL','ALB'),('AM','AM','ARM'),('AN','AN','ANT'),('AO','AO','AGO'),('AQ','AQ','ATA'),('AR','AR','ARG'),('AS','AS','ASM'),('AT','AT','AUT'),('AU','AU','AUS'),('AW','AW','ABW'),('AX','AX','ALA'),('AZ','AZ','AZE'),('BA','BA','BIH'),('BB','BB','BRB'),('BD','BD','BGD'),('BE','BE','BEL'),('BF','BF','BFA'),('BG','BG','BGR'),('BH','BH','BHR'),('BI','BI','BDI'),('BJ','BJ','BEN'),('BL','BL','BLM'),('BM','BM','BMU'),('BN','BN','BRN'),('BO','BO','BOL'),('BQ','BQ','BES'),('BR','BR','BRA'),('BS','BS','BHS'),('BT','BT','BTN'),('BV','BV','BVT'),('BW','BW','BWA'),('BY','BY','BLR'),('BZ','BZ','BLZ'),('CA','CA','CAN'),('CC','CC','CCK'),('CD','CD','COD'),('CF','CF','CAF'),('CG','CG','COG'),('CH','CH','CHE'),('CI','CI','CIV'),('CK','CK','COK'),('CL','CL','CHL'),('CM','CM','CMR'),('CN','CN','CHN'),('CO','CO','COL'),('CR','CR','CRI'),('CU','CU','CUB'),('CV','CV','CPV'),('CW','CW','CUW'),('CX','CX','CXR'),('CY','CY','CYP'),('CZ','CZ','CZE'),('DE','DE','DEU'),('DJ','DJ','DJI'),('DK','DK','DNK'),('DM','DM','DMA'),('DO','DO','DOM'),('DZ','DZ','DZA'),('EC','EC','ECU'),('EE','EE','EST'),('EG','EG','EGY'),('EH','EH','ESH'),('ER','ER','ERI'),('ES','ES','ESP'),('ET','ET','ETH'),('FI','FI','FIN'),('FJ','FJ','FJI'),('FK','FK','FLK'),('FM','FM','FSM'),('FO','FO','FRO'),('FR','FR','FRA'),('GA','GA','GAB'),('GB','GB','GBR'),('GD','GD','GRD'),('GE','GE','GEO'),('GF','GF','GUF'),('GG','GG','GGY'),('GH','GH','GHA'),('GI','GI','GIB'),('GL','GL','GRL'),('GM','GM','GMB'),('GN','GN','GIN'),('GP','GP','GLP'),('GQ','GQ','GNQ'),('GR','GR','GRC'),('GS','GS','SGS'),('GT','GT','GTM'),('GU','GU','GUM'),('GW','GW','GNB'),('GY','GY','GUY'),('HK','HK','HKG'),('HM','HM','HMD'),('HN','HN','HND'),('HR','HR','HRV'),('HT','HT','HTI'),('HU','HU','HUN'),('ID','ID','IDN'),('IE','IE','IRL'),('IL','IL','ISR'),('IM','IM','IMN'),('IN','IN','IND'),('IO','IO','IOT'),('IQ','IQ','IRQ'),('IR','IR','IRN'),('IS','IS','ISL'),('IT','IT','ITA'),('JE','JE','JEY'),('JM','JM','JAM'),('JO','JO','JOR'),('JP','JP','JPN'),('KE','KE','KEN'),('KG','KG','KGZ'),('KH','KH','KHM'),('KI','KI','KIR'),('KM','KM','COM'),('KN','KN','KNA'),('KP','KP','PRK'),('KR','KR','KOR'),('KW','KW','KWT'),('KY','KY','CYM'),('KZ','KZ','KAZ'),('LA','LA','LAO'),('LB','LB','LBN'),('LC','LC','LCA'),('LI','LI','LIE'),('LK','LK','LKA'),('LR','LR','LBR'),('LS','LS','LSO'),('LT','LT','LTU'),('LU','LU','LUX'),('LV','LV','LVA'),('LY','LY','LBY'),('MA','MA','MAR'),('MC','MC','MCO'),('MD','MD','MDA'),('ME','ME','MNE'),('MF','MF','MAF'),('MG','MG','MDG'),('MH','MH','MHL'),('MK','MK','MKD'),('ML','ML','MLI'),('MM','MM','MMR'),('MN','MN','MNG'),('MO','MO','MAC'),('MP','MP','MNP'),('MQ','MQ','MTQ'),('MR','MR','MRT'),('MS','MS','MSR'),('MT','MT','MLT'),('MU','MU','MUS'),('MV','MV','MDV'),('MW','MW','MWI'),('MX','MX','MEX'),('MY','MY','MYS'),('MZ','MZ','MOZ'),('NA','NA','NAM'),('NC','NC','NCL'),('NE','NE','NER'),('NF','NF','NFK'),('NG','NG','NGA'),('NI','NI','NIC'),('NL','NL','NLD'),('NO','NO','NOR'),('NP','NP','NPL'),('NR','NR','NRU'),('NU','NU','NIU'),('NZ','NZ','NZL'),('OM','OM','OMN'),('PA','PA','PAN'),('PE','PE','PER'),('PF','PF','PYF'),('PG','PG','PNG'),('PH','PH','PHL'),('PK','PK','PAK'),('PL','PL','POL'),('PM','PM','SPM'),('PN','PN','PCN'),('PS','PS','PSE'),('PT','PT','PRT'),('PW','PW','PLW'),('PY','PY','PRY'),('QA','QA','QAT'),('RE','RE','REU'),('RO','RO','ROU'),('RS','RS','SRB'),('RU','RU','RUS'),('RW','RW','RWA'),('SA','SA','SAU'),('SB','SB','SLB'),('SC','SC','SYC'),('SD','SD','SDN'),('SE','SE','SWE'),('SG','SG','SGP'),('SH','SH','SHN'),('SI','SI','SVN'),('SJ','SJ','SJM'),('SK','SK','SVK'),('SL','SL','SLE'),('SM','SM','SMR'),('SN','SN','SEN'),('SO','SO','SOM'),('SR','SR','SUR'),('ST','ST','STP'),('SV','SV','SLV'),('SX','SX','SXM'),('SY','SY','SYR'),('SZ','SZ','SWZ'),('TC','TC','TCA'),('TD','TD','TCD'),('TF','TF','ATF'),('TG','TG','TGO'),('TH','TH','THA'),('TJ','TJ','TJK'),('TK','TK','TKL'),('TL','TL','TLS'),('TM','TM','TKM'),('TN','TN','TUN'),('TO','TO','TON'),('TR','TR','TUR'),('TT','TT','TTO'),('TV','TV','TUV'),('TW','TW','TWN'),('TZ','TZ','TZA'),('UA','UA','UKR'),('UG','UG','UGA'),('UM','UM','UMI'),('US','US','USA'),('UY','UY','URY'),('UZ','UZ','UZB'),('VA','VA','VAT'),('VC','VC','VCT'),('VE','VE','VEN'),('VG','VG','VGB'),('VI','VI','VIR'),('VN','VN','VNM'),('VU','VU','VUT'),('WF','WF','WLF'),('WS','WS','WSM'),('XK','XK','XKX'),('YE','YE','YEM'),('YT','YT','MYT'),('ZA','ZA','ZAF'),('ZM','ZM','ZMB'),('ZW','ZW','ZWE');
/*!40000 ALTER TABLE `directory_country` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `directory_country_format`
--

DROP TABLE IF EXISTS `directory_country_format`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `directory_country_format` (
  `country_format_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Country Format ID',
  `country_id` varchar(2) DEFAULT NULL COMMENT 'Country ID in ISO-2',
  `type` varchar(30) DEFAULT NULL COMMENT 'Country Format Type',
  `format` text NOT NULL COMMENT 'Country Format',
  PRIMARY KEY (`country_format_id`),
  UNIQUE KEY `DIRECTORY_COUNTRY_FORMAT_COUNTRY_ID_TYPE` (`country_id`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Directory Country Format';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `directory_country_format`
--

LOCK TABLES `directory_country_format` WRITE;
/*!40000 ALTER TABLE `directory_country_format` DISABLE KEYS */;
/*!40000 ALTER TABLE `directory_country_format` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `directory_country_region`
--

DROP TABLE IF EXISTS `directory_country_region`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `directory_country_region` (
  `region_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Region ID',
  `country_id` varchar(4) NOT NULL DEFAULT '0' COMMENT 'Country ID in ISO-2',
  `code` varchar(32) DEFAULT NULL COMMENT 'Region code',
  `default_name` varchar(255) DEFAULT NULL COMMENT 'Region Name',
  PRIMARY KEY (`region_id`),
  KEY `DIRECTORY_COUNTRY_REGION_COUNTRY_ID` (`country_id`)
) ENGINE=InnoDB AUTO_INCREMENT=1157 DEFAULT CHARSET=utf8mb3 COMMENT='Directory Country Region';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `directory_country_region`
--

LOCK TABLES `directory_country_region` WRITE;
/*!40000 ALTER TABLE `directory_country_region` DISABLE KEYS */;
INSERT INTO `directory_country_region` VALUES (1,'US','AL','Alabama'),(2,'US','AK','Alaska'),(3,'US','AS','American Samoa'),(4,'US','AZ','Arizona'),(5,'US','AR','Arkansas'),(6,'US','AE','Armed Forces Africa'),(7,'US','AA','Armed Forces Americas'),(8,'US','AE','Armed Forces Canada'),(9,'US','AE','Armed Forces Europe'),(10,'US','AE','Armed Forces Middle East'),(11,'US','AP','Armed Forces Pacific'),(12,'US','CA','California'),(13,'US','CO','Colorado'),(14,'US','CT','Connecticut'),(15,'US','DE','Delaware'),(16,'US','DC','District of Columbia'),(17,'US','FM','Federated States Of Micronesia'),(18,'US','FL','Florida'),(19,'US','GA','Georgia'),(20,'US','GU','Guam'),(21,'US','HI','Hawaii'),(22,'US','ID','Idaho'),(23,'US','IL','Illinois'),(24,'US','IN','Indiana'),(25,'US','IA','Iowa'),(26,'US','KS','Kansas'),(27,'US','KY','Kentucky'),(28,'US','LA','Louisiana'),(29,'US','ME','Maine'),(30,'US','MH','Marshall Islands'),(31,'US','MD','Maryland'),(32,'US','MA','Massachusetts'),(33,'US','MI','Michigan'),(34,'US','MN','Minnesota'),(35,'US','MS','Mississippi'),(36,'US','MO','Missouri'),(37,'US','MT','Montana'),(38,'US','NE','Nebraska'),(39,'US','NV','Nevada'),(40,'US','NH','New Hampshire'),(41,'US','NJ','New Jersey'),(42,'US','NM','New Mexico'),(43,'US','NY','New York'),(44,'US','NC','North Carolina'),(45,'US','ND','North Dakota'),(46,'US','MP','Northern Mariana Islands'),(47,'US','OH','Ohio'),(48,'US','OK','Oklahoma'),(49,'US','OR','Oregon'),(50,'US','PW','Palau'),(51,'US','PA','Pennsylvania'),(52,'US','PR','Puerto Rico'),(53,'US','RI','Rhode Island'),(54,'US','SC','South Carolina'),(55,'US','SD','South Dakota'),(56,'US','TN','Tennessee'),(57,'US','TX','Texas'),(58,'US','UT','Utah'),(59,'US','VT','Vermont'),(60,'US','VI','Virgin Islands'),(61,'US','VA','Virginia'),(62,'US','WA','Washington'),(63,'US','WV','West Virginia'),(64,'US','WI','Wisconsin'),(65,'US','WY','Wyoming'),(66,'CA','AB','Alberta'),(67,'CA','BC','British Columbia'),(68,'CA','MB','Manitoba'),(69,'CA','NL','Newfoundland and Labrador'),(70,'CA','NB','New Brunswick'),(71,'CA','NS','Nova Scotia'),(72,'CA','NT','Northwest Territories'),(73,'CA','NU','Nunavut'),(74,'CA','ON','Ontario'),(75,'CA','PE','Prince Edward Island'),(76,'CA','QC','Quebec'),(77,'CA','SK','Saskatchewan'),(78,'CA','YT','Yukon Territory'),(79,'DE','NDS','Niedersachsen'),(80,'DE','BAW','Baden-Württemberg'),(81,'DE','BAY','Bayern'),(82,'DE','BER','Berlin'),(83,'DE','BRG','Brandenburg'),(84,'DE','BRE','Bremen'),(85,'DE','HAM','Hamburg'),(86,'DE','HES','Hessen'),(87,'DE','MEC','Mecklenburg-Vorpommern'),(88,'DE','NRW','Nordrhein-Westfalen'),(89,'DE','RHE','Rheinland-Pfalz'),(90,'DE','SAR','Saarland'),(91,'DE','SAS','Sachsen'),(92,'DE','SAC','Sachsen-Anhalt'),(93,'DE','SCN','Schleswig-Holstein'),(94,'DE','THE','Thüringen'),(95,'AT','WI','Wien'),(96,'AT','NO','Niederösterreich'),(97,'AT','OO','Oberösterreich'),(98,'AT','SB','Salzburg'),(99,'AT','KN','Kärnten'),(100,'AT','ST','Steiermark'),(101,'AT','TI','Tirol'),(102,'AT','BL','Burgenland'),(103,'AT','VB','Vorarlberg'),(104,'CH','AG','Aargau'),(105,'CH','AI','Appenzell Innerrhoden'),(106,'CH','AR','Appenzell Ausserrhoden'),(107,'CH','BE','Bern'),(108,'CH','BL','Basel-Landschaft'),(109,'CH','BS','Basel-Stadt'),(110,'CH','FR','Friburg'),(111,'CH','GE','Geneva'),(112,'CH','GL','Glarus'),(113,'CH','GR','Graubünden'),(114,'CH','JU','Jura'),(115,'CH','LU','Lucerne'),(116,'CH','NE','Neuchâtel'),(117,'CH','NW','Nidwalden'),(118,'CH','OW','Obwalden'),(119,'CH','SG','St. Gallen'),(120,'CH','SH','Schaffhausen'),(121,'CH','SO','Solothurn'),(122,'CH','SZ','Schwyz'),(123,'CH','TG','Thurgau'),(124,'CH','TI','Ticino'),(125,'CH','UR','Uri'),(126,'CH','VD','Vaud'),(127,'CH','VS','Wallis'),(128,'CH','ZG','Zug'),(129,'CH','ZH','Zürich'),(130,'ES','A Coruсa','A Coruña'),(131,'ES','Alava','Alava'),(132,'ES','Albacete','Albacete'),(133,'ES','Alicante','Alicante'),(134,'ES','Almeria','Almeria'),(135,'ES','Asturias','Asturias'),(136,'ES','Avila','Avila'),(137,'ES','Badajoz','Badajoz'),(138,'ES','Baleares','Baleares'),(139,'ES','Barcelona','Barcelona'),(140,'ES','Burgos','Burgos'),(141,'ES','Caceres','Caceres'),(142,'ES','Cadiz','Cadiz'),(143,'ES','Cantabria','Cantabria'),(144,'ES','Castellon','Castellon'),(145,'ES','Ceuta','Ceuta'),(146,'ES','Ciudad Real','Ciudad Real'),(147,'ES','Cordoba','Cordoba'),(148,'ES','Cuenca','Cuenca'),(149,'ES','Girona','Girona'),(150,'ES','Granada','Granada'),(151,'ES','Guadalajara','Guadalajara'),(152,'ES','Guipuzcoa','Guipuzcoa'),(153,'ES','Huelva','Huelva'),(154,'ES','Huesca','Huesca'),(155,'ES','Jaen','Jaen'),(156,'ES','La Rioja','La Rioja'),(157,'ES','Las Palmas','Las Palmas'),(158,'ES','Leon','Leon'),(159,'ES','Lleida','Lleida'),(160,'ES','Lugo','Lugo'),(161,'ES','Madrid','Madrid'),(162,'ES','Malaga','Malaga'),(163,'ES','Melilla','Melilla'),(164,'ES','Murcia','Murcia'),(165,'ES','Navarra','Navarra'),(166,'ES','Ourense','Ourense'),(167,'ES','Palencia','Palencia'),(168,'ES','Pontevedra','Pontevedra'),(169,'ES','Salamanca','Salamanca'),(170,'ES','Santa Cruz de Tenerife','Santa Cruz de Tenerife'),(171,'ES','Segovia','Segovia'),(172,'ES','Sevilla','Sevilla'),(173,'ES','Soria','Soria'),(174,'ES','Tarragona','Tarragona'),(175,'ES','Teruel','Teruel'),(176,'ES','Toledo','Toledo'),(177,'ES','Valencia','Valencia'),(178,'ES','Valladolid','Valladolid'),(179,'ES','Vizcaya','Vizcaya'),(180,'ES','Zamora','Zamora'),(181,'ES','Zaragoza','Zaragoza'),(182,'FR','1','Ain'),(183,'FR','2','Aisne'),(184,'FR','3','Allier'),(185,'FR','4','Alpes-de-Haute-Provence'),(186,'FR','5','Hautes-Alpes'),(187,'FR','6','Alpes-Maritimes'),(188,'FR','7','Ardèche'),(189,'FR','8','Ardennes'),(190,'FR','9','Ariège'),(191,'FR','10','Aube'),(192,'FR','11','Aude'),(193,'FR','12','Aveyron'),(194,'FR','13','Bouches-du-Rhône'),(195,'FR','14','Calvados'),(196,'FR','15','Cantal'),(197,'FR','16','Charente'),(198,'FR','17','Charente-Maritime'),(199,'FR','18','Cher'),(200,'FR','19','Corrèze'),(201,'FR','2A','Corse-du-Sud'),(202,'FR','2B','Haute-Corse'),(203,'FR','21','Côte-d\'Or'),(204,'FR','22','Côtes-d\'Armor'),(205,'FR','23','Creuse'),(206,'FR','24','Dordogne'),(207,'FR','25','Doubs'),(208,'FR','26','Drôme'),(209,'FR','27','Eure'),(210,'FR','28','Eure-et-Loir'),(211,'FR','29','Finistère'),(212,'FR','30','Gard'),(213,'FR','31','Haute-Garonne'),(214,'FR','32','Gers'),(215,'FR','33','Gironde'),(216,'FR','34','Hérault'),(217,'FR','35','Ille-et-Vilaine'),(218,'FR','36','Indre'),(219,'FR','37','Indre-et-Loire'),(220,'FR','38','Isère'),(221,'FR','39','Jura'),(222,'FR','40','Landes'),(223,'FR','41','Loir-et-Cher'),(224,'FR','42','Loire'),(225,'FR','43','Haute-Loire'),(226,'FR','44','Loire-Atlantique'),(227,'FR','45','Loiret'),(228,'FR','46','Lot'),(229,'FR','47','Lot-et-Garonne'),(230,'FR','48','Lozère'),(231,'FR','49','Maine-et-Loire'),(232,'FR','50','Manche'),(233,'FR','51','Marne'),(234,'FR','52','Haute-Marne'),(235,'FR','53','Mayenne'),(236,'FR','54','Meurthe-et-Moselle'),(237,'FR','55','Meuse'),(238,'FR','56','Morbihan'),(239,'FR','57','Moselle'),(240,'FR','58','Nièvre'),(241,'FR','59','Nord'),(242,'FR','60','Oise'),(243,'FR','61','Orne'),(244,'FR','62','Pas-de-Calais'),(245,'FR','63','Puy-de-Dôme'),(246,'FR','64','Pyrénées-Atlantiques'),(247,'FR','65','Hautes-Pyrénées'),(248,'FR','66','Pyrénées-Orientales'),(249,'FR','67','Bas-Rhin'),(250,'FR','68','Haut-Rhin'),(251,'FR','69','Rhône'),(252,'FR','70','Haute-Saône'),(253,'FR','71','Saône-et-Loire'),(254,'FR','72','Sarthe'),(255,'FR','73','Savoie'),(256,'FR','74','Haute-Savoie'),(257,'FR','75','Paris'),(258,'FR','76','Seine-Maritime'),(259,'FR','77','Seine-et-Marne'),(260,'FR','78','Yvelines'),(261,'FR','79','Deux-Sèvres'),(262,'FR','80','Somme'),(263,'FR','81','Tarn'),(264,'FR','82','Tarn-et-Garonne'),(265,'FR','83','Var'),(266,'FR','84','Vaucluse'),(267,'FR','85','Vendée'),(268,'FR','86','Vienne'),(269,'FR','87','Haute-Vienne'),(270,'FR','88','Vosges'),(271,'FR','89','Yonne'),(272,'FR','90','Territoire-de-Belfort'),(273,'FR','91','Essonne'),(274,'FR','92','Hauts-de-Seine'),(275,'FR','93','Seine-Saint-Denis'),(276,'FR','94','Val-de-Marne'),(277,'FR','95','Val-d\'Oise'),(278,'RO','AB','Alba'),(279,'RO','AR','Arad'),(280,'RO','AG','Argeş'),(281,'RO','BC','Bacău'),(282,'RO','BH','Bihor'),(283,'RO','BN','Bistriţa-Năsăud'),(284,'RO','BT','Botoşani'),(285,'RO','BV','Braşov'),(286,'RO','BR','Brăila'),(287,'RO','B','Bucureşti'),(288,'RO','BZ','Buzău'),(289,'RO','CS','Caraş-Severin'),(290,'RO','CL','Călăraşi'),(291,'RO','CJ','Cluj'),(292,'RO','CT','Constanţa'),(293,'RO','CV','Covasna'),(294,'RO','DB','Dâmboviţa'),(295,'RO','DJ','Dolj'),(296,'RO','GL','Galaţi'),(297,'RO','GR','Giurgiu'),(298,'RO','GJ','Gorj'),(299,'RO','HR','Harghita'),(300,'RO','HD','Hunedoara'),(301,'RO','IL','Ialomiţa'),(302,'RO','IS','Iaşi'),(303,'RO','IF','Ilfov'),(304,'RO','MM','Maramureş'),(305,'RO','MH','Mehedinţi'),(306,'RO','MS','Mureş'),(307,'RO','NT','Neamţ'),(308,'RO','OT','Olt'),(309,'RO','PH','Prahova'),(310,'RO','SM','Satu-Mare'),(311,'RO','SJ','Sălaj'),(312,'RO','SB','Sibiu'),(313,'RO','SV','Suceava'),(314,'RO','TR','Teleorman'),(315,'RO','TM','Timiş'),(316,'RO','TL','Tulcea'),(317,'RO','VS','Vaslui'),(318,'RO','VL','Vâlcea'),(319,'RO','VN','Vrancea'),(320,'FI','Lappi','Lappi'),(321,'FI','Pohjois-Pohjanmaa','Pohjois-Pohjanmaa'),(322,'FI','Kainuu','Kainuu'),(323,'FI','Pohjois-Karjala','Pohjois-Karjala'),(324,'FI','Pohjois-Savo','Pohjois-Savo'),(325,'FI','Etelä-Savo','Etelä-Savo'),(326,'FI','Etelä-Pohjanmaa','Etelä-Pohjanmaa'),(327,'FI','Pohjanmaa','Pohjanmaa'),(328,'FI','Pirkanmaa','Pirkanmaa'),(329,'FI','Satakunta','Satakunta'),(330,'FI','Keski-Pohjanmaa','Keski-Pohjanmaa'),(331,'FI','Keski-Suomi','Keski-Suomi'),(332,'FI','Varsinais-Suomi','Varsinais-Suomi'),(333,'FI','Etelä-Karjala','Etelä-Karjala'),(334,'FI','Päijät-Häme','Päijät-Häme'),(335,'FI','Kanta-Häme','Kanta-Häme'),(336,'FI','Uusimaa','Uusimaa'),(337,'FI','Itä-Uusimaa','Itä-Uusimaa'),(338,'FI','Kymenlaakso','Kymenlaakso'),(339,'FI','Ahvenanmaa','Ahvenanmaa'),(340,'EE','EE-37','Harjumaa'),(341,'EE','EE-39','Hiiumaa'),(342,'EE','EE-44','Ida-Virumaa'),(343,'EE','EE-49','Jõgevamaa'),(344,'EE','EE-51','Järvamaa'),(345,'EE','EE-57','Läänemaa'),(346,'EE','EE-59','Lääne-Virumaa'),(347,'EE','EE-65','Põlvamaa'),(348,'EE','EE-67','Pärnumaa'),(349,'EE','EE-70','Raplamaa'),(350,'EE','EE-74','Saaremaa'),(351,'EE','EE-78','Tartumaa'),(352,'EE','EE-82','Valgamaa'),(353,'EE','EE-84','Viljandimaa'),(354,'EE','EE-86','Võrumaa'),(355,'LV','LV-DGV','Daugavpils'),(356,'LV','LV-JEL','Jelgava'),(357,'LV','Jēkabpils','Jēkabpils'),(358,'LV','LV-JUR','Jūrmala'),(359,'LV','LV-LPX','Liepāja'),(360,'LV','LV-LE','Liepājas novads'),(361,'LV','LV-REZ','Rēzekne'),(362,'LV','LV-RIX','Rīga'),(363,'LV','LV-RI','Rīgas novads'),(364,'LV','Valmiera','Valmiera'),(365,'LV','LV-VEN','Ventspils'),(366,'LV','Aglonas novads','Aglonas novads'),(367,'LV','LV-AI','Aizkraukles novads'),(368,'LV','Aizputes novads','Aizputes novads'),(369,'LV','Aknīstes novads','Aknīstes novads'),(370,'LV','Alojas novads','Alojas novads'),(371,'LV','Alsungas novads','Alsungas novads'),(372,'LV','LV-AL','Alūksnes novads'),(373,'LV','Amatas novads','Amatas novads'),(374,'LV','Apes novads','Apes novads'),(375,'LV','Auces novads','Auces novads'),(376,'LV','Babītes novads','Babītes novads'),(377,'LV','Baldones novads','Baldones novads'),(378,'LV','Baltinavas novads','Baltinavas novads'),(379,'LV','LV-BL','Balvu novads'),(380,'LV','LV-BU','Bauskas novads'),(381,'LV','Beverīnas novads','Beverīnas novads'),(382,'LV','Brocēnu novads','Brocēnu novads'),(383,'LV','Burtnieku novads','Burtnieku novads'),(384,'LV','Carnikavas novads','Carnikavas novads'),(385,'LV','Cesvaines novads','Cesvaines novads'),(386,'LV','Ciblas novads','Ciblas novads'),(387,'LV','LV-CE','Cēsu novads'),(388,'LV','Dagdas novads','Dagdas novads'),(389,'LV','LV-DA','Daugavpils novads'),(390,'LV','LV-DO','Dobeles novads'),(391,'LV','Dundagas novads','Dundagas novads'),(392,'LV','Durbes novads','Durbes novads'),(393,'LV','Engures novads','Engures novads'),(394,'LV','Garkalnes novads','Garkalnes novads'),(395,'LV','Grobiņas novads','Grobiņas novads'),(396,'LV','LV-GU','Gulbenes novads'),(397,'LV','Iecavas novads','Iecavas novads'),(398,'LV','Ikšķiles novads','Ikšķiles novads'),(399,'LV','Ilūkstes novads','Ilūkstes novads'),(400,'LV','Inčukalna novads','Inčukalna novads'),(401,'LV','Jaunjelgavas novads','Jaunjelgavas novads'),(402,'LV','Jaunpiebalgas novads','Jaunpiebalgas novads'),(403,'LV','Jaunpils novads','Jaunpils novads'),(404,'LV','LV-JL','Jelgavas novads'),(405,'LV','LV-JK','Jēkabpils novads'),(406,'LV','Kandavas novads','Kandavas novads'),(407,'LV','Kokneses novads','Kokneses novads'),(408,'LV','Krimuldas novads','Krimuldas novads'),(409,'LV','Krustpils novads','Krustpils novads'),(410,'LV','LV-KR','Krāslavas novads'),(411,'LV','LV-KU','Kuldīgas novads'),(412,'LV','Kārsavas novads','Kārsavas novads'),(413,'LV','Lielvārdes novads','Lielvārdes novads'),(414,'LV','LV-LM','Limbažu novads'),(415,'LV','Lubānas novads','Lubānas novads'),(416,'LV','LV-LU','Ludzas novads'),(417,'LV','Līgatnes novads','Līgatnes novads'),(418,'LV','Līvānu novads','Līvānu novads'),(419,'LV','LV-MA','Madonas novads'),(420,'LV','Mazsalacas novads','Mazsalacas novads'),(421,'LV','Mālpils novads','Mālpils novads'),(422,'LV','Mārupes novads','Mārupes novads'),(423,'LV','Naukšēnu novads','Naukšēnu novads'),(424,'LV','Neretas novads','Neretas novads'),(425,'LV','Nīcas novads','Nīcas novads'),(426,'LV','LV-OG','Ogres novads'),(427,'LV','Olaines novads','Olaines novads'),(428,'LV','Ozolnieku novads','Ozolnieku novads'),(429,'LV','LV-PR','Preiļu novads'),(430,'LV','Priekules novads','Priekules novads'),(431,'LV','Priekuļu novads','Priekuļu novads'),(432,'LV','Pārgaujas novads','Pārgaujas novads'),(433,'LV','Pāvilostas novads','Pāvilostas novads'),(434,'LV','Pļaviņu novads','Pļaviņu novads'),(435,'LV','Raunas novads','Raunas novads'),(436,'LV','Riebiņu novads','Riebiņu novads'),(437,'LV','Rojas novads','Rojas novads'),(438,'LV','Ropažu novads','Ropažu novads'),(439,'LV','Rucavas novads','Rucavas novads'),(440,'LV','Rugāju novads','Rugāju novads'),(441,'LV','Rundāles novads','Rundāles novads'),(442,'LV','LV-RE','Rēzeknes novads'),(443,'LV','Rūjienas novads','Rūjienas novads'),(444,'LV','Salacgrīvas novads','Salacgrīvas novads'),(445,'LV','Salas novads','Salas novads'),(446,'LV','Salaspils novads','Salaspils novads'),(447,'LV','LV-SA','Saldus novads'),(448,'LV','Saulkrastu novads','Saulkrastu novads'),(449,'LV','Siguldas novads','Siguldas novads'),(450,'LV','Skrundas novads','Skrundas novads'),(451,'LV','Skrīveru novads','Skrīveru novads'),(452,'LV','Smiltenes novads','Smiltenes novads'),(453,'LV','Stopiņu novads','Stopiņu novads'),(454,'LV','Strenču novads','Strenču novads'),(455,'LV','Sējas novads','Sējas novads'),(456,'LV','LV-TA','Talsu novads'),(457,'LV','LV-TU','Tukuma novads'),(458,'LV','Tērvetes novads','Tērvetes novads'),(459,'LV','Vaiņodes novads','Vaiņodes novads'),(460,'LV','LV-VK','Valkas novads'),(461,'LV','LV-VM','Valmieras novads'),(462,'LV','Varakļānu novads','Varakļānu novads'),(463,'LV','Vecpiebalgas novads','Vecpiebalgas novads'),(464,'LV','Vecumnieku novads','Vecumnieku novads'),(465,'LV','LV-VE','Ventspils novads'),(466,'LV','Viesītes novads','Viesītes novads'),(467,'LV','Viļakas novads','Viļakas novads'),(468,'LV','Viļānu novads','Viļānu novads'),(469,'LV','Vārkavas novads','Vārkavas novads'),(470,'LV','Zilupes novads','Zilupes novads'),(471,'LV','Ādažu novads','Ādažu novads'),(472,'LV','Ērgļu novads','Ērgļu novads'),(473,'LV','Ķeguma novads','Ķeguma novads'),(474,'LV','Ķekavas novads','Ķekavas novads'),(475,'LT','LT-AL','Alytaus Apskritis'),(476,'LT','LT-KU','Kauno Apskritis'),(477,'LT','LT-KL','Klaipėdos Apskritis'),(478,'LT','LT-MR','Marijampolės Apskritis'),(479,'LT','LT-PN','Panevėžio Apskritis'),(480,'LT','LT-SA','Šiaulių Apskritis'),(481,'LT','LT-TA','Tauragės Apskritis'),(482,'LT','LT-TE','Telšių Apskritis'),(483,'LT','LT-UT','Utenos Apskritis'),(484,'LT','LT-VL','Vilniaus Apskritis'),(485,'BR','AC','Acre'),(486,'BR','AL','Alagoas'),(487,'BR','AP','Amapá'),(488,'BR','AM','Amazonas'),(489,'BR','BA','Bahia'),(490,'BR','CE','Ceará'),(491,'BR','ES','Espírito Santo'),(492,'BR','GO','Goiás'),(493,'BR','MA','Maranhão'),(494,'BR','MT','Mato Grosso'),(495,'BR','MS','Mato Grosso do Sul'),(496,'BR','MG','Minas Gerais'),(497,'BR','PA','Pará'),(498,'BR','PB','Paraíba'),(499,'BR','PR','Paraná'),(500,'BR','PE','Pernambuco'),(501,'BR','PI','Piauí'),(502,'BR','RJ','Rio de Janeiro'),(503,'BR','RN','Rio Grande do Norte'),(504,'BR','RS','Rio Grande do Sul'),(505,'BR','RO','Rondônia'),(506,'BR','RR','Roraima'),(507,'BR','SC','Santa Catarina'),(508,'BR','SP','São Paulo'),(509,'BR','SE','Sergipe'),(510,'BR','TO','Tocantins'),(511,'BR','DF','Distrito Federal'),(512,'AL','AL-01','Berat'),(513,'AL','AL-09','Dibër'),(514,'AL','AL-02','Durrës'),(515,'AL','AL-03','Elbasan'),(516,'AL','AL-04','Fier'),(517,'AL','AL-05','Gjirokastër'),(518,'AL','AL-06','Korçë'),(519,'AL','AL-07','Kukës'),(520,'AL','AL-08','Lezhë'),(521,'AL','AL-10','Shkodër'),(522,'AL','AL-11','Tiranë'),(523,'AL','AL-12','Vlorë'),(524,'AR','AR-C','Ciudad Autónoma de Buenos Aires'),(525,'AR','AR-B','Buenos Aires'),(526,'AR','AR-K','Catamarca'),(527,'AR','AR-H','Chaco'),(528,'AR','AR-U','Chubut'),(529,'AR','AR-X','Córdoba'),(530,'AR','AR-W','Corrientes'),(531,'AR','AR-E','Entre Ríos'),(532,'AR','AR-P','Formosa'),(533,'AR','AR-Y','Jujuy'),(534,'AR','AR-L','La Pampa'),(535,'AR','AR-F','La Rioja'),(536,'AR','AR-M','Mendoza'),(537,'AR','AR-N','Misiones'),(538,'AR','AR-Q','Neuquén'),(539,'AR','AR-R','Río Negro'),(540,'AR','AR-A','Salta'),(541,'AR','AR-J','San Juan'),(542,'AR','AR-D','San Luis'),(543,'AR','AR-Z','Santa Cruz'),(544,'AR','AR-S','Santa Fe'),(545,'AR','AR-G','Santiago del Estero'),(546,'AR','AR-V','Tierra del Fuego'),(547,'AR','AR-T','Tucumán'),(548,'HR','HR-01','Zagrebačka županija'),(549,'HR','HR-02','Krapinsko-zagorska županija'),(550,'HR','HR-03','Sisačko-moslavačka županija'),(551,'HR','HR-04','Karlovačka županija'),(552,'HR','HR-05','Varaždinska županija'),(553,'HR','HR-06','Koprivničko-križevačka županija'),(554,'HR','HR-07','Bjelovarsko-bilogorska županija'),(555,'HR','HR-08','Primorsko-goranska županija'),(556,'HR','HR-09','Ličko-senjska županija'),(557,'HR','HR-10','Virovitičko-podravska županija'),(558,'HR','HR-11','Požeško-slavonska županija'),(559,'HR','HR-12','Brodsko-posavska županija'),(560,'HR','HR-13','Zadarska županija'),(561,'HR','HR-14','Osječko-baranjska županija'),(562,'HR','HR-15','Šibensko-kninska županija'),(563,'HR','HR-16','Vukovarsko-srijemska županija'),(564,'HR','HR-17','Splitsko-dalmatinska županija'),(565,'HR','HR-18','Istarska županija'),(566,'HR','HR-19','Dubrovačko-neretvanska županija'),(567,'HR','HR-20','Međimurska županija'),(568,'HR','HR-21','Grad Zagreb'),(569,'IN','AN','Andaman and Nicobar Islands'),(570,'IN','AP','Andhra Pradesh'),(571,'IN','AR','Arunachal Pradesh'),(572,'IN','AS','Assam'),(573,'IN','BR','Bihar'),(574,'IN','CH','Chandigarh'),(575,'IN','CT','Chhattisgarh'),(576,'IN','DN','Dadra and Nagar Haveli'),(577,'IN','DD','Daman and Diu'),(578,'IN','DL','Delhi'),(579,'IN','GA','Goa'),(580,'IN','GJ','Gujarat'),(581,'IN','HR','Haryana'),(582,'IN','HP','Himachal Pradesh'),(583,'IN','JK','Jammu and Kashmir'),(584,'IN','JH','Jharkhand'),(585,'IN','KA','Karnataka'),(586,'IN','KL','Kerala'),(587,'IN','LD','Lakshadweep'),(588,'IN','MP','Madhya Pradesh'),(589,'IN','MH','Maharashtra'),(590,'IN','MN','Manipur'),(591,'IN','ML','Meghalaya'),(592,'IN','MZ','Mizoram'),(593,'IN','NL','Nagaland'),(594,'IN','OR','Odisha'),(595,'IN','PY','Puducherry'),(596,'IN','PB','Punjab'),(597,'IN','RJ','Rajasthan'),(598,'IN','SK','Sikkim'),(599,'IN','TN','Tamil Nadu'),(600,'IN','TG','Telangana'),(601,'IN','TR','Tripura'),(602,'IN','UP','Uttar Pradesh'),(603,'IN','UT','Uttarakhand'),(604,'IN','WB','West Bengal'),(605,'AU','ACT','Australian Capital Territory'),(606,'AU','NSW','New South Wales'),(607,'AU','VIC','Victoria'),(608,'AU','QLD','Queensland'),(609,'AU','SA','South Australia'),(610,'AU','TAS','Tasmania'),(611,'AU','WA','Western Australia'),(612,'AU','NT','Northern Territory'),(613,'BY','BY-BR','Bresckaja voblasć'),(614,'BY','BY-HO','Homieĺskaja voblasć'),(615,'BY','BY-HM','Horad Minsk'),(616,'BY','BY-HR','Hrodzienskaja voblasć'),(617,'BY','BY-MA','Mahilioŭskaja voblasć'),(618,'BY','BY-MI','Minskaja voblasć'),(619,'BY','BY-VI','Viciebskaja voblasć'),(620,'BE','VAN','Antwerpen'),(621,'BE','WBR','Brabant wallon'),(622,'BE','BRU','Brussels-Capital Region'),(623,'BE','WHT','Hainaut'),(624,'BE','VLI','Limburg'),(625,'BE','WLG','Liège'),(626,'BE','WLX','Luxembourg'),(627,'BE','WNA','Namur'),(628,'BE','VOV','Oost-Vlaanderen'),(629,'BE','VBR','Vlaams-Brabant'),(630,'BE','VWV','West-Vlaanderen'),(631,'BO','BO-C','Cochabamba'),(632,'BO','BO-H','Chuquisaca'),(633,'BO','BO-B','El Beni'),(634,'BO','BO-L','La Paz'),(635,'BO','BO-O','Oruro'),(636,'BO','BO-N','Pando'),(637,'BO','BO-P','Potosí'),(638,'BO','BO-S','Santa Cruz'),(639,'BO','BO-T','Tarija'),(640,'BG','BG-01','Blagoevgrad'),(641,'BG','BG-02','Burgas'),(642,'BG','BG-03','Varna'),(643,'BG','BG-04','Veliko Tarnovo'),(644,'BG','BG-05','Vidin'),(645,'BG','BG-06','Vratsa'),(646,'BG','BG-07','Gabrovo'),(647,'BG','BG-08','Dobrich'),(648,'BG','BG-09','Kardzhali'),(649,'BG','BG-10','Kyustendil'),(650,'BG','BG-11','Lovech'),(651,'BG','BG-12','Montana'),(652,'BG','BG-13','Pazardzhik'),(653,'BG','BG-14','Pernik'),(654,'BG','BG-15','Pleven'),(655,'BG','BG-16','Plovdiv'),(656,'BG','BG-17','Razgrad'),(657,'BG','BG-18','Ruse'),(658,'BG','BG-19','Silistra'),(659,'BG','BG-20','Sliven'),(660,'BG','BG-21','Smolyan'),(661,'BG','BG-22','Sofia City'),(662,'BG','BG-23','Sofia Province'),(663,'BG','BG-24','Stara Zagora'),(664,'BG','BG-25','Targovishte'),(665,'BG','BG-26','Haskovo'),(666,'BG','BG-27','Shumen'),(667,'BG','BG-28','Yambol'),(668,'CL','CL-AI','Aisén del General Carlos Ibañez del Campo'),(669,'CL','CL-AN','Antofagasta'),(670,'CL','CL-AP','Arica y Parinacota'),(671,'CL','CL-AR','La Araucanía'),(672,'CL','CL-AT','Atacama'),(673,'CL','CL-BI','Biobío'),(674,'CL','CL-CO','Coquimbo'),(675,'CL','CL-LI','Libertador General Bernardo O\'Higgins'),(676,'CL','CL-LL','Los Lagos'),(677,'CL','CL-LR','Los Ríos'),(678,'CL','CL-MA','Magallanes'),(679,'CL','CL-ML','Maule'),(680,'CL','CL-NB','Ñuble'),(681,'CL','CL-RM','Región Metropolitana de Santiago'),(682,'CL','CL-TA','Tarapacá'),(683,'CL','CL-VS','Valparaíso'),(684,'CN','CN-AH','Anhui Sheng'),(685,'CN','CN-BJ','Beijing Shi'),(686,'CN','CN-CQ','Chongqing Shi'),(687,'CN','CN-FJ','Fujian Sheng'),(688,'CN','CN-GS','Gansu Sheng'),(689,'CN','CN-GD','Guangdong Sheng'),(690,'CN','CN-GX','Guangxi Zhuangzu Zizhiqu'),(691,'CN','CN-GZ','Guizhou Sheng'),(692,'CN','CN-HI','Hainan Sheng'),(693,'CN','CN-HE','Hebei Sheng'),(694,'CN','CN-HL','Heilongjiang Sheng'),(695,'CN','CN-HA','Henan Sheng'),(696,'CN','CN-HK','Hong Kong SAR'),(697,'CN','CN-HB','Hubei Sheng'),(698,'CN','CN-HN','Hunan Sheng'),(699,'CN','CN-JS','Jiangsu Sheng'),(700,'CN','CN-JX','Jiangxi Sheng'),(701,'CN','CN-JL','Jilin Sheng'),(702,'CN','CN-LN','Liaoning Sheng'),(703,'CN','CN-MO','Macao SAR'),(704,'CN','CN-NM','Nei Mongol Zizhiqu'),(705,'CN','CN-NX','Ningxia Huizi Zizhiqu'),(706,'CN','CN-QH','Qinghai Sheng'),(707,'CN','CN-SN','Shaanxi Sheng'),(708,'CN','CN-SD','Shandong Sheng'),(709,'CN','CN-SH','Shanghai Shi'),(710,'CN','CN-SX','Shanxi Sheng'),(711,'CN','CN-SC','Sichuan Sheng'),(712,'CN','CN-TW','Taiwan Sheng'),(713,'CN','CN-TJ','Tianjin Shi'),(714,'CN','CN-XJ','Xinjiang Uygur Zizhiqu'),(715,'CN','CN-XZ','Xizang Zizhiqu'),(716,'CN','CN-YN','Yunnan Sheng'),(717,'CN','CN-ZJ','Zhejiang Sheng'),(718,'CO','CO-AMA','Amazonas'),(719,'CO','CO-ANT','Antioquia'),(720,'CO','CO-ARA','Arauca'),(721,'CO','CO-ATL','Atlántico'),(722,'CO','CO-BOL','Bolívar'),(723,'CO','CO-BOY','Boyacá'),(724,'CO','CO-CAL','Caldas'),(725,'CO','CO-CAQ','Caquetá'),(726,'CO','CO-CAS','Casanare'),(727,'CO','CO-CAU','Cauca'),(728,'CO','CO-CES','Cesar'),(729,'CO','CO-CHO','Chocó'),(730,'CO','CO-COR','Córdoba'),(731,'CO','CO-CUN','Cundinamarca'),(732,'CO','CO-GUA','Guainía'),(733,'CO','CO-GUV','Guaviare'),(734,'CO','CO-HUL','Huila'),(735,'CO','CO-LAG','La Guajira'),(736,'CO','CO-MAG','Magdalena'),(737,'CO','CO-MET','Meta'),(738,'CO','CO-NAR','Nariño'),(739,'CO','CO-NSA','Norte de Santander'),(740,'CO','CO-PUT','Putumayo'),(741,'CO','CO-QUI','Quindío'),(742,'CO','CO-RIS','Risaralda'),(743,'CO','CO-SAP','San Andrés y Providencia'),(744,'CO','CO-SAN','Santander'),(745,'CO','CO-SUC','Sucre'),(746,'CO','CO-TOL','Tolima'),(747,'CO','CO-VAC','Valle del Cauca'),(748,'CO','CO-VAU','Vaupés'),(749,'CO','CO-VID','Vichada'),(750,'CR','CR-SJ','San José'),(751,'CR','CR-AL','Alajuela'),(752,'CR','CR-CA','Cartago'),(753,'CR','CR-HE','Heredia'),(754,'CR','CR-GU','Guanacaste'),(755,'CR','CR-PU','Puntarenas'),(756,'CR','CR-LI','Limón'),(757,'CZ','CZ-10','Praha, Hlavní město'),(758,'CZ','CZ-20','Středočeský kraj'),(759,'CZ','CZ-31','Jihočeský kraj'),(760,'CZ','CZ-32','Plzeňský kraj'),(761,'CZ','CZ-41','Karlovarský kraj'),(762,'CZ','CZ-42','Ústecký kraj'),(763,'CZ','CZ-51','Liberecký kraj'),(764,'CZ','CZ-52','Královéhradecký kraj'),(765,'CZ','CZ-53','Pardubický kraj'),(766,'CZ','CZ-63','Kraj Vysočina'),(767,'CZ','CZ-64','Jihomoravský kraj'),(768,'CZ','CZ-71','Olomoucký kraj'),(769,'CZ','CZ-72','Zlínský kraj'),(770,'CZ','CZ-80','Moravskoslezský kraj'),(771,'DK','DK-84','Hovedstaden'),(772,'DK','DK-82','Midtjylland'),(773,'DK','DK-81','Nordjylland'),(774,'DK','DK-85','Sjælland'),(775,'DK','DK-83','Syddanmark'),(776,'EC','EC-A','Azuay'),(777,'EC','EC-B','Bolívar'),(778,'EC','EC-F','Cañar'),(779,'EC','EC-C','Carchi'),(780,'EC','EC-H','Chimborazo'),(781,'EC','EC-X','Cotopaxi'),(782,'EC','EC-O','El Oro'),(783,'EC','EC-E','Esmeraldas'),(784,'EC','EC-W','Galápagos'),(785,'EC','EC-G','Guayas'),(786,'EC','EC-I','Imbabura'),(787,'EC','EC-L','Loja'),(788,'EC','EC-R','Los Ríos'),(789,'EC','EC-M','Manabí'),(790,'EC','EC-S','Morona Santiago'),(791,'EC','EC-N','Napo'),(792,'EC','EC-D','Orellana'),(793,'EC','EC-Y','Pastaza'),(794,'EC','EC-P','Pichincha'),(795,'EC','EC-SE','Santa Elena'),(796,'EC','EC-SD','Santo Domingo de los Tsáchilas'),(797,'EC','EC-U','Sucumbíos'),(798,'EC','EC-T','Tungurahua'),(799,'EC','EC-Z','Zamora Chinchipe'),(800,'GR','GR-A','Anatolikí Makedonía kai Thráki'),(801,'GR','GR-I','Attikí'),(802,'GR','GR-G','Dytikí Elláda'),(803,'GR','GR-C','Dytikí Makedonía'),(804,'GR','GR-F','Ionía Nísia'),(805,'GR','GR-D','Ípeiros'),(806,'GR','GR-B','Kentrikí Makedonía'),(807,'GR','GR-M','Kríti'),(808,'GR','GR-L','Nótio Aigaío'),(809,'GR','GR-J','Pelopónnisos'),(810,'GR','GR-H','Stereá Elláda'),(811,'GR','GR-E','Thessalía'),(812,'GR','GR-K','Vóreio Aigaío'),(813,'GR','GR-69','Ágion Óros'),(814,'GY','GY-BA','Barima-Waini'),(815,'GY','GY-CU','Cuyuni-Mazaruni'),(816,'GY','GY-DE','Demerara-Mahaica'),(817,'GY','GY-EB','East Berbice-Corentyne'),(818,'GY','GY-ES','Essequibo Islands-West Demerara'),(819,'GY','GY-MA','Mahaica-Berbice'),(820,'GY','GY-PM','Pomeroon-Supenaam'),(821,'GY','GY-PT','Potaro-Siparuni'),(822,'GY','GY-UD','Upper Demerara-Berbice'),(823,'GY','GY-UT','Upper Takutu-Upper Essequibo'),(824,'IS','IS-01','Höfuðborgarsvæði'),(825,'IS','IS-02','Suðurnes'),(826,'IS','IS-03','Vesturland'),(827,'IS','IS-04','Vestfirðir'),(828,'IS','IS-05','Norðurland vestra'),(829,'IS','IS-06','Norðurland eystra'),(830,'IS','IS-07','Austurland'),(831,'IS','IS-08','Suðurland'),(832,'IT','AG','Agrigento'),(833,'IT','AL','Alessandria'),(834,'IT','AN','Ancona'),(835,'IT','AO','Aosta'),(836,'IT','AQ','L\'Aquila'),(837,'IT','AR','Arezzo'),(838,'IT','AP','Ascoli-Piceno'),(839,'IT','AT','Asti'),(840,'IT','AV','Avellino'),(841,'IT','BA','Bari'),(842,'IT','BT','Barletta-Andria-Trani'),(843,'IT','BL','Belluno'),(844,'IT','BN','Benevento'),(845,'IT','BG','Bergamo'),(846,'IT','BI','Biella'),(847,'IT','BO','Bologna'),(848,'IT','BZ','Bolzano'),(849,'IT','BS','Brescia'),(850,'IT','BR','Brindisi'),(851,'IT','CA','Cagliari'),(852,'IT','CL','Caltanissetta'),(853,'IT','CB','Campobasso'),(854,'IT','CI','Carbonia Iglesias'),(855,'IT','CE','Caserta'),(856,'IT','CT','Catania'),(857,'IT','CZ','Catanzaro'),(858,'IT','CH','Chieti'),(859,'IT','CO','Como'),(860,'IT','CS','Cosenza'),(861,'IT','CR','Cremona'),(862,'IT','KR','Crotone'),(863,'IT','CN','Cuneo'),(864,'IT','EN','Enna'),(865,'IT','FM','Fermo'),(866,'IT','FE','Ferrara'),(867,'IT','FI','Firenze'),(868,'IT','FG','Foggia'),(869,'IT','FC','Forli-Cesena'),(870,'IT','FR','Frosinone'),(871,'IT','GE','Genova'),(872,'IT','GO','Gorizia'),(873,'IT','GR','Grosseto'),(874,'IT','IM','Imperia'),(875,'IT','IS','Isernia'),(876,'IT','SP','La-Spezia'),(877,'IT','LT','Latina'),(878,'IT','LE','Lecce'),(879,'IT','LC','Lecco'),(880,'IT','LI','Livorno'),(881,'IT','LO','Lodi'),(882,'IT','LU','Lucca'),(883,'IT','MC','Macerata'),(884,'IT','MN','Mantova'),(885,'IT','MS','Massa-Carrara'),(886,'IT','MT','Matera'),(887,'IT','VS','Medio Campidano'),(888,'IT','ME','Messina'),(889,'IT','MI','Milano'),(890,'IT','MO','Modena'),(891,'IT','MB','Monza-Brianza'),(892,'IT','NA','Napoli'),(893,'IT','NO','Novara'),(894,'IT','NU','Nuoro'),(895,'IT','OG','Ogliastra'),(896,'IT','OT','Olbia Tempio'),(897,'IT','OR','Oristano'),(898,'IT','PD','Padova'),(899,'IT','PA','Palermo'),(900,'IT','PR','Parma'),(901,'IT','PV','Pavia'),(902,'IT','PG','Perugia'),(903,'IT','PU','Pesaro-Urbino'),(904,'IT','PE','Pescara'),(905,'IT','PC','Piacenza'),(906,'IT','PI','Pisa'),(907,'IT','PT','Pistoia'),(908,'IT','PN','Pordenone'),(909,'IT','PZ','Potenza'),(910,'IT','PO','Prato'),(911,'IT','RG','Ragusa'),(912,'IT','RA','Ravenna'),(913,'IT','RC','Reggio-Calabria'),(914,'IT','RE','Reggio-Emilia'),(915,'IT','RI','Rieti'),(916,'IT','RN','Rimini'),(917,'IT','RM','Roma'),(918,'IT','RO','Rovigo'),(919,'IT','SA','Salerno'),(920,'IT','SS','Sassari'),(921,'IT','SV','Savona'),(922,'IT','SI','Siena'),(923,'IT','SR','Siracusa'),(924,'IT','SO','Sondrio'),(925,'IT','TA','Taranto'),(926,'IT','TE','Teramo'),(927,'IT','TR','Terni'),(928,'IT','TO','Torino'),(929,'IT','TP','Trapani'),(930,'IT','TN','Trento'),(931,'IT','TV','Treviso'),(932,'IT','TS','Trieste'),(933,'IT','UD','Udine'),(934,'IT','VA','Varese'),(935,'IT','VE','Venezia'),(936,'IT','VB','Verbania'),(937,'IT','VC','Vercelli'),(938,'IT','VR','Verona'),(939,'IT','VV','Vibo-Valentia'),(940,'IT','VI','Vicenza'),(941,'IT','VT','Viterbo'),(942,'MX','AGU','Aguascalientes'),(943,'MX','BCN','Baja California'),(944,'MX','BCS','Baja California Sur'),(945,'MX','CAM','Campeche'),(946,'MX','CHP','Chiapas'),(947,'MX','CHH','Chihuahua'),(948,'MX','CMX','Ciudad de México'),(949,'MX','COA','Coahuila'),(950,'MX','COL','Colima'),(951,'MX','DUR','Durango'),(952,'MX','MEX','Estado de México'),(953,'MX','GUA','Guanajuato'),(954,'MX','GRO','Guerrero'),(955,'MX','HID','Hidalgo'),(956,'MX','JAL','Jalisco'),(957,'MX','MIC','Michoacán'),(958,'MX','MOR','Morelos'),(959,'MX','NAY','Nayarit'),(960,'MX','NLE','Nuevo León'),(961,'MX','OAX','Oaxaca'),(962,'MX','PUE','Puebla'),(963,'MX','QUE','Querétaro'),(964,'MX','ROO','Quintana Roo'),(965,'MX','SLP','San Luis Potosí'),(966,'MX','SIN','Sinaloa'),(967,'MX','SON','Sonora'),(968,'MX','TAB','Tabasco'),(969,'MX','TAM','Tamaulipas'),(970,'MX','TLA','Tlaxcala'),(971,'MX','VER','Veracruz'),(972,'MX','YUC','Yucatán'),(973,'MX','ZAC','Zacatecas'),(974,'PY','PY-ASU','Asunción'),(975,'PY','PY-16','Alto Paraguay'),(976,'PY','PY-10','Alto Paraná'),(977,'PY','PY-13','Amambay'),(978,'PY','PY-19','Boquerón'),(979,'PY','PY-5','Caaguazú'),(980,'PY','PY-6','Caazapá'),(981,'PY','PY-14','Canindeyú'),(982,'PY','PY-11','Central'),(983,'PY','PY-1','Concepción'),(984,'PY','PY-3','Cordillera'),(985,'PY','PY-4','Guairá'),(986,'PY','PY-7','Itapúa'),(987,'PY','PY-8','Misiones'),(988,'PY','PY-12','Ñeembucú'),(989,'PY','PY-9','Paraguarí'),(990,'PY','PY-15','Presidente Hayes'),(991,'PY','PY-2','San Pedro'),(992,'PE','PE-LMA','Municipalidad Metropolitana de Lima'),(993,'PE','PE-AMA','Amazonas'),(994,'PE','PE-ANC','Ancash'),(995,'PE','PE-APU','Apurímac'),(996,'PE','PE-ARE','Arequipa'),(997,'PE','PE-AYA','Ayacucho'),(998,'PE','PE-CAJ','Cajamarca'),(999,'PE','PE-CUS','Cusco'),(1000,'PE','PE-CAL','El Callao'),(1001,'PE','PE-HUV','Huancavelica'),(1002,'PE','PE-HUC','Huánuco'),(1003,'PE','PE-ICA','Ica'),(1004,'PE','PE-JUN','Junín'),(1005,'PE','PE-LAL','La Libertad'),(1006,'PE','PE-LAM','Lambayeque'),(1007,'PE','PE-LIM','Lima'),(1008,'PE','PE-LOR','Loreto'),(1009,'PE','PE-MDD','Madre de Dios'),(1010,'PE','PE-MOQ','Moquegua'),(1011,'PE','PE-PAS','Pasco'),(1012,'PE','PE-PIU','Piura'),(1013,'PE','PE-PUN','Puno'),(1014,'PE','PE-SAM','San Martín'),(1015,'PE','PE-TAC','Tacna'),(1016,'PE','PE-TUM','Tumbes'),(1017,'PE','PE-UCA','Ucayali'),(1018,'PL','PL-02','dolnośląskie'),(1019,'PL','PL-04','kujawsko-pomorskie'),(1020,'PL','PL-06','lubelskie'),(1021,'PL','PL-08','lubuskie'),(1022,'PL','PL-10','łódzkie'),(1023,'PL','PL-12','małopolskie'),(1024,'PL','PL-14','mazowieckie'),(1025,'PL','PL-16','opolskie'),(1026,'PL','PL-18','podkarpackie'),(1027,'PL','PL-20','podlaskie'),(1028,'PL','PL-22','pomorskie'),(1029,'PL','PL-24','śląskie'),(1030,'PL','PL-26','świętokrzyskie'),(1031,'PL','PL-28','warmińsko-mazurskie'),(1032,'PL','PL-30','wielkopolskie'),(1033,'PL','PL-32','zachodniopomorskie'),(1034,'PT','PT-01','Aveiro'),(1035,'PT','PT-02','Beja'),(1036,'PT','PT-03','Braga'),(1037,'PT','PT-04','Bragança'),(1038,'PT','PT-05','Castelo Branco'),(1039,'PT','PT-06','Coimbra'),(1040,'PT','PT-07','Évora'),(1041,'PT','PT-08','Faro'),(1042,'PT','PT-09','Guarda'),(1043,'PT','PT-10','Leiria'),(1044,'PT','PT-11','Lisboa'),(1045,'PT','PT-12','Portalegre'),(1046,'PT','PT-13','Porto'),(1047,'PT','PT-14','Santarém'),(1048,'PT','PT-15','Setúbal'),(1049,'PT','PT-16','Viana do Castelo'),(1050,'PT','PT-17','Vila Real'),(1051,'PT','PT-18','Viseu'),(1052,'PT','PT-20','Região Autónoma dos Açores'),(1053,'PT','PT-30','Região Autónoma da Madeira'),(1054,'SR','SR-BR','Brokopondo'),(1055,'SR','SR-CM','Commewijne'),(1056,'SR','SR-CR','Coronie'),(1057,'SR','SR-MA','Marowijne'),(1058,'SR','SR-NI','Nickerie'),(1059,'SR','SR-PR','Para'),(1060,'SR','SR-PM','Paramaribo'),(1061,'SR','SR-SA','Saramacca'),(1062,'SR','SR-SI','Sipaliwini'),(1063,'SR','SR-WA','Wanica'),(1064,'SE','SE-K','Blekinge län'),(1065,'SE','SE-W','Dalarnas län'),(1066,'SE','SE-I','Gotlands län'),(1067,'SE','SE-X','Gävleborgs län'),(1068,'SE','SE-N','Hallands län'),(1069,'SE','SE-Z','Jämtlands län'),(1070,'SE','SE-F','Jönköpings län'),(1071,'SE','SE-H','Kalmar län'),(1072,'SE','SE-G','Kronobergs län'),(1073,'SE','SE-BD','Norrbottens län'),(1074,'SE','SE-M','Skåne län'),(1075,'SE','SE-AB','Stockholms län'),(1076,'SE','SE-D','Södermanlands län'),(1077,'SE','SE-C','Uppsala län'),(1078,'SE','SE-S','Värmlands län'),(1079,'SE','SE-AC','Västerbottens län'),(1080,'SE','SE-Y','Västernorrlands län'),(1081,'SE','SE-U','Västmanlands län'),(1082,'SE','SE-O','Västra Götalands län'),(1083,'SE','SE-T','Örebro län'),(1084,'SE','SE-E','Östergötlands län'),(1085,'UA','UA-71','Cherkaska oblast'),(1086,'UA','UA-74','Chernihivska oblast'),(1087,'UA','UA-77','Chernivetska oblast'),(1088,'UA','UA-12','Dnipropetrovska oblast'),(1089,'UA','UA-14','Donetska oblast'),(1090,'UA','UA-26','Ivano-Frankivska oblast'),(1091,'UA','UA-63','Kharkivska oblast'),(1092,'UA','UA-65','Khersonska oblast'),(1093,'UA','UA-68','Khmelnytska oblast'),(1094,'UA','UA-35','Kirovohradska oblast'),(1095,'UA','UA-32','Kyivska oblast'),(1096,'UA','UA-09','Luhanska oblast'),(1097,'UA','UA-46','Lvivska oblast'),(1098,'UA','UA-48','Mykolaivska oblast'),(1099,'UA','UA-51','Odeska oblast'),(1100,'UA','UA-53','Poltavska oblast'),(1101,'UA','UA-56','Rivnenska oblast'),(1102,'UA','UA-59','Sumska oblast'),(1103,'UA','UA-61','Ternopilska oblast'),(1104,'UA','UA-05','Vinnytska oblast'),(1105,'UA','UA-07','Volynska oblast'),(1106,'UA','UA-21','Zakarpatska oblast'),(1107,'UA','UA-23','Zaporizka oblast'),(1108,'UA','UA-18','Zhytomyrska oblast'),(1109,'UA','UA-43','Avtonomna Respublika Krym'),(1110,'UA','UA-30','Kyiv'),(1111,'UA','UA-40','Sevastopol'),(1112,'UY','UY-AR','Artigas'),(1113,'UY','UY-CA','Canelones'),(1114,'UY','UY-CL','Cerro Largo'),(1115,'UY','UY-CO','Colonia'),(1116,'UY','UY-DU','Durazno'),(1117,'UY','UY-FS','Flores'),(1118,'UY','UY-FD','Florida'),(1119,'UY','UY-LA','Lavalleja'),(1120,'UY','UY-MA','Maldonado'),(1121,'UY','UY-MO','Montevideo'),(1122,'UY','UY-PA','Paysandu'),(1123,'UY','UY-RN','Río Negro'),(1124,'UY','UY-RV','Rivera'),(1125,'UY','UY-RO','Rocha'),(1126,'UY','UY-SA','Salto'),(1127,'UY','UY-SJ','San José'),(1128,'UY','UY-SO','Soriano'),(1129,'UY','UY-TA','Tacuarembó'),(1130,'UY','UY-TT','Treinta y Tres'),(1131,'VE','VE-W','Dependencias Federales'),(1132,'VE','VE-A','Distrito Capital'),(1133,'VE','VE-Z','Amazonas'),(1134,'VE','VE-B','Anzoátegui'),(1135,'VE','VE-C','Apure'),(1136,'VE','VE-D','Aragua'),(1137,'VE','VE-E','Barinas'),(1138,'VE','VE-F','Bolívar'),(1139,'VE','VE-G','Carabobo'),(1140,'VE','VE-H','Cojedes'),(1141,'VE','VE-Y','Delta Amacuro'),(1142,'VE','VE-I','Falcón'),(1143,'VE','VE-J','Guárico'),(1144,'VE','VE-K','Lara'),(1145,'VE','VE-L','Mérida'),(1146,'VE','VE-M','Miranda'),(1147,'VE','VE-N','Monagas'),(1148,'VE','VE-O','Nueva Esparta'),(1149,'VE','VE-P','Portuguesa'),(1150,'VE','VE-R','Sucre'),(1151,'VE','VE-S','Táchira'),(1152,'VE','VE-T','Trujillo'),(1153,'VE','VE-X','Vargas'),(1154,'VE','VE-U','Yaracuy'),(1155,'VE','VE-V','Zulia'),(1156,'IN','LA','Ladakh');
/*!40000 ALTER TABLE `directory_country_region` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `directory_country_region_name`
--

DROP TABLE IF EXISTS `directory_country_region_name`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `directory_country_region_name` (
  `locale` varchar(16) NOT NULL COMMENT 'Locale',
  `region_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Region ID',
  `name` varchar(255) DEFAULT NULL COMMENT 'Region Name',
  PRIMARY KEY (`locale`,`region_id`),
  KEY `DIRECTORY_COUNTRY_REGION_NAME_REGION_ID` (`region_id`),
  CONSTRAINT `DIR_COUNTRY_REGION_NAME_REGION_ID_DIR_COUNTRY_REGION_REGION_ID` FOREIGN KEY (`region_id`) REFERENCES `directory_country_region` (`region_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Directory Country Region Name';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `directory_country_region_name`
--

LOCK TABLES `directory_country_region_name` WRITE;
/*!40000 ALTER TABLE `directory_country_region_name` DISABLE KEYS */;
INSERT INTO `directory_country_region_name` VALUES ('en_US',1,'Alabama'),('en_US',2,'Alaska'),('en_US',3,'American Samoa'),('en_US',4,'Arizona'),('en_US',5,'Arkansas'),('en_US',6,'Armed Forces Africa'),('en_US',7,'Armed Forces Americas'),('en_US',8,'Armed Forces Canada'),('en_US',9,'Armed Forces Europe'),('en_US',10,'Armed Forces Middle East'),('en_US',11,'Armed Forces Pacific'),('en_US',12,'California'),('en_US',13,'Colorado'),('en_US',14,'Connecticut'),('en_US',15,'Delaware'),('en_US',16,'District of Columbia'),('en_US',17,'Federated States Of Micronesia'),('en_US',18,'Florida'),('en_US',19,'Georgia'),('en_US',20,'Guam'),('en_US',21,'Hawaii'),('en_US',22,'Idaho'),('en_US',23,'Illinois'),('en_US',24,'Indiana'),('en_US',25,'Iowa'),('en_US',26,'Kansas'),('en_US',27,'Kentucky'),('en_US',28,'Louisiana'),('en_US',29,'Maine'),('en_US',30,'Marshall Islands'),('en_US',31,'Maryland'),('en_US',32,'Massachusetts'),('en_US',33,'Michigan'),('en_US',34,'Minnesota'),('en_US',35,'Mississippi'),('en_US',36,'Missouri'),('en_US',37,'Montana'),('en_US',38,'Nebraska'),('en_US',39,'Nevada'),('en_US',40,'New Hampshire'),('en_US',41,'New Jersey'),('en_US',42,'New Mexico'),('en_US',43,'New York'),('en_US',44,'North Carolina'),('en_US',45,'North Dakota'),('en_US',46,'Northern Mariana Islands'),('en_US',47,'Ohio'),('en_US',48,'Oklahoma'),('en_US',49,'Oregon'),('en_US',50,'Palau'),('en_US',51,'Pennsylvania'),('en_US',52,'Puerto Rico'),('en_US',53,'Rhode Island'),('en_US',54,'South Carolina'),('en_US',55,'South Dakota'),('en_US',56,'Tennessee'),('en_US',57,'Texas'),('en_US',58,'Utah'),('en_US',59,'Vermont'),('en_US',60,'Virgin Islands'),('en_US',61,'Virginia'),('en_US',62,'Washington'),('en_US',63,'West Virginia'),('en_US',64,'Wisconsin'),('en_US',65,'Wyoming'),('en_US',66,'Alberta'),('en_US',67,'British Columbia'),('en_US',68,'Manitoba'),('en_US',69,'Newfoundland and Labrador'),('en_US',70,'New Brunswick'),('en_US',71,'Nova Scotia'),('en_US',72,'Northwest Territories'),('en_US',73,'Nunavut'),('en_US',74,'Ontario'),('en_US',75,'Prince Edward Island'),('en_US',76,'Quebec'),('en_US',77,'Saskatchewan'),('en_US',78,'Yukon Territory'),('en_US',79,'Niedersachsen'),('en_US',80,'Baden-Württemberg'),('en_US',81,'Bayern'),('en_US',82,'Berlin'),('en_US',83,'Brandenburg'),('en_US',84,'Bremen'),('en_US',85,'Hamburg'),('en_US',86,'Hessen'),('en_US',87,'Mecklenburg-Vorpommern'),('en_US',88,'Nordrhein-Westfalen'),('en_US',89,'Rheinland-Pfalz'),('en_US',90,'Saarland'),('en_US',91,'Sachsen'),('en_US',92,'Sachsen-Anhalt'),('en_US',93,'Schleswig-Holstein'),('en_US',94,'Thüringen'),('en_US',95,'Wien'),('en_US',96,'Niederösterreich'),('en_US',97,'Oberösterreich'),('en_US',98,'Salzburg'),('en_US',99,'Kärnten'),('en_US',100,'Steiermark'),('en_US',101,'Tirol'),('en_US',102,'Burgenland'),('en_US',103,'Vorarlberg'),('en_US',104,'Aargau'),('en_US',105,'Appenzell Innerrhoden'),('en_US',106,'Appenzell Ausserrhoden'),('en_US',107,'Bern'),('en_US',108,'Basel-Landschaft'),('en_US',109,'Basel-Stadt'),('en_US',110,'Friburg'),('en_US',111,'Geneva'),('en_US',112,'Glarus'),('en_US',113,'Graubünden'),('en_US',114,'Jura'),('en_US',115,'Lucerne'),('en_US',116,'Neuchâtel'),('en_US',117,'Nidwalden'),('en_US',118,'Obwalden'),('en_US',119,'St. Gallen'),('en_US',120,'Schaffhausen'),('en_US',121,'Solothurn'),('en_US',122,'Schwyz'),('en_US',123,'Thurgau'),('en_US',124,'Ticino'),('en_US',125,'Uri'),('en_US',126,'Vaud'),('en_US',127,'Wallis'),('en_US',128,'Zug'),('en_US',129,'Zürich'),('en_US',130,'A Coruña'),('en_US',131,'Alava'),('en_US',132,'Albacete'),('en_US',133,'Alicante'),('en_US',134,'Almeria'),('en_US',135,'Asturias'),('en_US',136,'Avila'),('en_US',137,'Badajoz'),('en_US',138,'Baleares'),('en_US',139,'Barcelona'),('en_US',140,'Burgos'),('en_US',141,'Caceres'),('en_US',142,'Cadiz'),('en_US',143,'Cantabria'),('en_US',144,'Castellon'),('en_US',145,'Ceuta'),('en_US',146,'Ciudad Real'),('en_US',147,'Cordoba'),('en_US',148,'Cuenca'),('en_US',149,'Girona'),('en_US',150,'Granada'),('en_US',151,'Guadalajara'),('en_US',152,'Guipuzcoa'),('en_US',153,'Huelva'),('en_US',154,'Huesca'),('en_US',155,'Jaen'),('en_US',156,'La Rioja'),('en_US',157,'Las Palmas'),('en_US',158,'Leon'),('en_US',159,'Lleida'),('en_US',160,'Lugo'),('en_US',161,'Madrid'),('en_US',162,'Malaga'),('en_US',163,'Melilla'),('en_US',164,'Murcia'),('en_US',165,'Navarra'),('en_US',166,'Ourense'),('en_US',167,'Palencia'),('en_US',168,'Pontevedra'),('en_US',169,'Salamanca'),('en_US',170,'Santa Cruz de Tenerife'),('en_US',171,'Segovia'),('en_US',172,'Sevilla'),('en_US',173,'Soria'),('en_US',174,'Tarragona'),('en_US',175,'Teruel'),('en_US',176,'Toledo'),('en_US',177,'Valencia'),('en_US',178,'Valladolid'),('en_US',179,'Vizcaya'),('en_US',180,'Zamora'),('en_US',181,'Zaragoza'),('en_US',182,'Ain'),('en_US',183,'Aisne'),('en_US',184,'Allier'),('en_US',185,'Alpes-de-Haute-Provence'),('en_US',186,'Hautes-Alpes'),('en_US',187,'Alpes-Maritimes'),('en_US',188,'Ardèche'),('en_US',189,'Ardennes'),('en_US',190,'Ariège'),('en_US',191,'Aube'),('en_US',192,'Aude'),('en_US',193,'Aveyron'),('en_US',194,'Bouches-du-Rhône'),('en_US',195,'Calvados'),('en_US',196,'Cantal'),('en_US',197,'Charente'),('en_US',198,'Charente-Maritime'),('en_US',199,'Cher'),('en_US',200,'Corrèze'),('en_US',201,'Corse-du-Sud'),('en_US',202,'Haute-Corse'),('en_US',203,'Côte-d\'Or'),('en_US',204,'Côtes-d\'Armor'),('en_US',205,'Creuse'),('en_US',206,'Dordogne'),('en_US',207,'Doubs'),('en_US',208,'Drôme'),('en_US',209,'Eure'),('en_US',210,'Eure-et-Loir'),('en_US',211,'Finistère'),('en_US',212,'Gard'),('en_US',213,'Haute-Garonne'),('en_US',214,'Gers'),('en_US',215,'Gironde'),('en_US',216,'Hérault'),('en_US',217,'Ille-et-Vilaine'),('en_US',218,'Indre'),('en_US',219,'Indre-et-Loire'),('en_US',220,'Isère'),('en_US',221,'Jura'),('en_US',222,'Landes'),('en_US',223,'Loir-et-Cher'),('en_US',224,'Loire'),('en_US',225,'Haute-Loire'),('en_US',226,'Loire-Atlantique'),('en_US',227,'Loiret'),('en_US',228,'Lot'),('en_US',229,'Lot-et-Garonne'),('en_US',230,'Lozère'),('en_US',231,'Maine-et-Loire'),('en_US',232,'Manche'),('en_US',233,'Marne'),('en_US',234,'Haute-Marne'),('en_US',235,'Mayenne'),('en_US',236,'Meurthe-et-Moselle'),('en_US',237,'Meuse'),('en_US',238,'Morbihan'),('en_US',239,'Moselle'),('en_US',240,'Nièvre'),('en_US',241,'Nord'),('en_US',242,'Oise'),('en_US',243,'Orne'),('en_US',244,'Pas-de-Calais'),('en_US',245,'Puy-de-Dôme'),('en_US',246,'Pyrénées-Atlantiques'),('en_US',247,'Hautes-Pyrénées'),('en_US',248,'Pyrénées-Orientales'),('en_US',249,'Bas-Rhin'),('en_US',250,'Haut-Rhin'),('en_US',251,'Rhône'),('en_US',252,'Haute-Saône'),('en_US',253,'Saône-et-Loire'),('en_US',254,'Sarthe'),('en_US',255,'Savoie'),('en_US',256,'Haute-Savoie'),('en_US',257,'Paris'),('en_US',258,'Seine-Maritime'),('en_US',259,'Seine-et-Marne'),('en_US',260,'Yvelines'),('en_US',261,'Deux-Sèvres'),('en_US',262,'Somme'),('en_US',263,'Tarn'),('en_US',264,'Tarn-et-Garonne'),('en_US',265,'Var'),('en_US',266,'Vaucluse'),('en_US',267,'Vendée'),('en_US',268,'Vienne'),('en_US',269,'Haute-Vienne'),('en_US',270,'Vosges'),('en_US',271,'Yonne'),('en_US',272,'Territoire-de-Belfort'),('en_US',273,'Essonne'),('en_US',274,'Hauts-de-Seine'),('en_US',275,'Seine-Saint-Denis'),('en_US',276,'Val-de-Marne'),('en_US',277,'Val-d\'Oise'),('en_US',278,'Alba'),('en_US',279,'Arad'),('en_US',280,'Argeş'),('en_US',281,'Bacău'),('en_US',282,'Bihor'),('en_US',283,'Bistriţa-Năsăud'),('en_US',284,'Botoşani'),('en_US',285,'Braşov'),('en_US',286,'Brăila'),('en_US',287,'Bucureşti'),('en_US',288,'Buzău'),('en_US',289,'Caraş-Severin'),('en_US',290,'Călăraşi'),('en_US',291,'Cluj'),('en_US',292,'Constanţa'),('en_US',293,'Covasna'),('en_US',294,'Dâmboviţa'),('en_US',295,'Dolj'),('en_US',296,'Galaţi'),('en_US',297,'Giurgiu'),('en_US',298,'Gorj'),('en_US',299,'Harghita'),('en_US',300,'Hunedoara'),('en_US',301,'Ialomiţa'),('en_US',302,'Iaşi'),('en_US',303,'Ilfov'),('en_US',304,'Maramureş'),('en_US',305,'Mehedinţi'),('en_US',306,'Mureş'),('en_US',307,'Neamţ'),('en_US',308,'Olt'),('en_US',309,'Prahova'),('en_US',310,'Satu-Mare'),('en_US',311,'Sălaj'),('en_US',312,'Sibiu'),('en_US',313,'Suceava'),('en_US',314,'Teleorman'),('en_US',315,'Timiş'),('en_US',316,'Tulcea'),('en_US',317,'Vaslui'),('en_US',318,'Vâlcea'),('en_US',319,'Vrancea'),('en_US',320,'Lappi'),('en_US',321,'Pohjois-Pohjanmaa'),('en_US',322,'Kainuu'),('en_US',323,'Pohjois-Karjala'),('en_US',324,'Pohjois-Savo'),('en_US',325,'Etelä-Savo'),('en_US',326,'Etelä-Pohjanmaa'),('en_US',327,'Pohjanmaa'),('en_US',328,'Pirkanmaa'),('en_US',329,'Satakunta'),('en_US',330,'Keski-Pohjanmaa'),('en_US',331,'Keski-Suomi'),('en_US',332,'Varsinais-Suomi'),('en_US',333,'Etelä-Karjala'),('en_US',334,'Päijät-Häme'),('en_US',335,'Kanta-Häme'),('en_US',336,'Uusimaa'),('en_US',337,'Itä-Uusimaa'),('en_US',338,'Kymenlaakso'),('en_US',339,'Ahvenanmaa'),('en_US',340,'Harjumaa'),('en_US',341,'Hiiumaa'),('en_US',342,'Ida-Virumaa'),('en_US',343,'Jõgevamaa'),('en_US',344,'Järvamaa'),('en_US',345,'Läänemaa'),('en_US',346,'Lääne-Virumaa'),('en_US',347,'Põlvamaa'),('en_US',348,'Pärnumaa'),('en_US',349,'Raplamaa'),('en_US',350,'Saaremaa'),('en_US',351,'Tartumaa'),('en_US',352,'Valgamaa'),('en_US',353,'Viljandimaa'),('en_US',354,'Võrumaa'),('en_US',355,'Daugavpils'),('en_US',356,'Jelgava'),('en_US',357,'Jēkabpils'),('en_US',358,'Jūrmala'),('en_US',359,'Liepāja'),('en_US',360,'Liepājas novads'),('en_US',361,'Rēzekne'),('en_US',362,'Rīga'),('en_US',363,'Rīgas novads'),('en_US',364,'Valmiera'),('en_US',365,'Ventspils'),('en_US',366,'Aglonas novads'),('en_US',367,'Aizkraukles novads'),('en_US',368,'Aizputes novads'),('en_US',369,'Aknīstes novads'),('en_US',370,'Alojas novads'),('en_US',371,'Alsungas novads'),('en_US',372,'Alūksnes novads'),('en_US',373,'Amatas novads'),('en_US',374,'Apes novads'),('en_US',375,'Auces novads'),('en_US',376,'Babītes novads'),('en_US',377,'Baldones novads'),('en_US',378,'Baltinavas novads'),('en_US',379,'Balvu novads'),('en_US',380,'Bauskas novads'),('en_US',381,'Beverīnas novads'),('en_US',382,'Brocēnu novads'),('en_US',383,'Burtnieku novads'),('en_US',384,'Carnikavas novads'),('en_US',385,'Cesvaines novads'),('en_US',386,'Ciblas novads'),('en_US',387,'Cēsu novads'),('en_US',388,'Dagdas novads'),('en_US',389,'Daugavpils novads'),('en_US',390,'Dobeles novads'),('en_US',391,'Dundagas novads'),('en_US',392,'Durbes novads'),('en_US',393,'Engures novads'),('en_US',394,'Garkalnes novads'),('en_US',395,'Grobiņas novads'),('en_US',396,'Gulbenes novads'),('en_US',397,'Iecavas novads'),('en_US',398,'Ikšķiles novads'),('en_US',399,'Ilūkstes novads'),('en_US',400,'Inčukalna novads'),('en_US',401,'Jaunjelgavas novads'),('en_US',402,'Jaunpiebalgas novads'),('en_US',403,'Jaunpils novads'),('en_US',404,'Jelgavas novads'),('en_US',405,'Jēkabpils novads'),('en_US',406,'Kandavas novads'),('en_US',407,'Kokneses novads'),('en_US',408,'Krimuldas novads'),('en_US',409,'Krustpils novads'),('en_US',410,'Krāslavas novads'),('en_US',411,'Kuldīgas novads'),('en_US',412,'Kārsavas novads'),('en_US',413,'Lielvārdes novads'),('en_US',414,'Limbažu novads'),('en_US',415,'Lubānas novads'),('en_US',416,'Ludzas novads'),('en_US',417,'Līgatnes novads'),('en_US',418,'Līvānu novads'),('en_US',419,'Madonas novads'),('en_US',420,'Mazsalacas novads'),('en_US',421,'Mālpils novads'),('en_US',422,'Mārupes novads'),('en_US',423,'Naukšēnu novads'),('en_US',424,'Neretas novads'),('en_US',425,'Nīcas novads'),('en_US',426,'Ogres novads'),('en_US',427,'Olaines novads'),('en_US',428,'Ozolnieku novads'),('en_US',429,'Preiļu novads'),('en_US',430,'Priekules novads'),('en_US',431,'Priekuļu novads'),('en_US',432,'Pārgaujas novads'),('en_US',433,'Pāvilostas novads'),('en_US',434,'Pļaviņu novads'),('en_US',435,'Raunas novads'),('en_US',436,'Riebiņu novads'),('en_US',437,'Rojas novads'),('en_US',438,'Ropažu novads'),('en_US',439,'Rucavas novads'),('en_US',440,'Rugāju novads'),('en_US',441,'Rundāles novads'),('en_US',442,'Rēzeknes novads'),('en_US',443,'Rūjienas novads'),('en_US',444,'Salacgrīvas novads'),('en_US',445,'Salas novads'),('en_US',446,'Salaspils novads'),('en_US',447,'Saldus novads'),('en_US',448,'Saulkrastu novads'),('en_US',449,'Siguldas novads'),('en_US',450,'Skrundas novads'),('en_US',451,'Skrīveru novads'),('en_US',452,'Smiltenes novads'),('en_US',453,'Stopiņu novads'),('en_US',454,'Strenču novads'),('en_US',455,'Sējas novads'),('en_US',456,'Talsu novads'),('en_US',457,'Tukuma novads'),('en_US',458,'Tērvetes novads'),('en_US',459,'Vaiņodes novads'),('en_US',460,'Valkas novads'),('en_US',461,'Valmieras novads'),('en_US',462,'Varakļānu novads'),('en_US',463,'Vecpiebalgas novads'),('en_US',464,'Vecumnieku novads'),('en_US',465,'Ventspils novads'),('en_US',466,'Viesītes novads'),('en_US',467,'Viļakas novads'),('en_US',468,'Viļānu novads'),('en_US',469,'Vārkavas novads'),('en_US',470,'Zilupes novads'),('en_US',471,'Ādažu novads'),('en_US',472,'Ērgļu novads'),('en_US',473,'Ķeguma novads'),('en_US',474,'Ķekavas novads'),('en_US',475,'Alytaus Apskritis'),('en_US',476,'Kauno Apskritis'),('en_US',477,'Klaipėdos Apskritis'),('en_US',478,'Marijampolės Apskritis'),('en_US',479,'Panevėžio Apskritis'),('en_US',480,'Šiaulių Apskritis'),('en_US',481,'Tauragės Apskritis'),('en_US',482,'Telšių Apskritis'),('en_US',483,'Utenos Apskritis'),('en_US',484,'Vilniaus Apskritis'),('en_US',485,'Acre'),('en_US',486,'Alagoas'),('en_US',487,'Amapá'),('en_US',488,'Amazonas'),('en_US',489,'Bahia'),('en_US',490,'Ceará'),('en_US',491,'Espírito Santo'),('en_US',492,'Goiás'),('en_US',493,'Maranhão'),('en_US',494,'Mato Grosso'),('en_US',495,'Mato Grosso do Sul'),('en_US',496,'Minas Gerais'),('en_US',497,'Pará'),('en_US',498,'Paraíba'),('en_US',499,'Paraná'),('en_US',500,'Pernambuco'),('en_US',501,'Piauí'),('en_US',502,'Rio de Janeiro'),('en_US',503,'Rio Grande do Norte'),('en_US',504,'Rio Grande do Sul'),('en_US',505,'Rondônia'),('en_US',506,'Roraima'),('en_US',507,'Santa Catarina'),('en_US',508,'São Paulo'),('en_US',509,'Sergipe'),('en_US',510,'Tocantins'),('en_US',511,'Distrito Federal'),('en_US',512,'Berat'),('en_US',513,'Dibër'),('en_US',514,'Durrës'),('en_US',515,'Elbasan'),('en_US',516,'Fier'),('en_US',517,'Gjirokastër'),('en_US',518,'Korçë'),('en_US',519,'Kukës'),('en_US',520,'Lezhë'),('en_US',521,'Shkodër'),('en_US',522,'Tiranë'),('en_US',523,'Vlorë'),('en_US',524,'Ciudad Autónoma de Buenos Aires'),('en_US',525,'Buenos Aires'),('en_US',526,'Catamarca'),('en_US',527,'Chaco'),('en_US',528,'Chubut'),('en_US',529,'Córdoba'),('en_US',530,'Corrientes'),('en_US',531,'Entre Ríos'),('en_US',532,'Formosa'),('en_US',533,'Jujuy'),('en_US',534,'La Pampa'),('en_US',535,'La Rioja'),('en_US',536,'Mendoza'),('en_US',537,'Misiones'),('en_US',538,'Neuquén'),('en_US',539,'Río Negro'),('en_US',540,'Salta'),('en_US',541,'San Juan'),('en_US',542,'San Luis'),('en_US',543,'Santa Cruz'),('en_US',544,'Santa Fe'),('en_US',545,'Santiago del Estero'),('en_US',546,'Tierra del Fuego'),('en_US',547,'Tucumán'),('en_US',548,'Zagrebačka županija'),('en_US',549,'Krapinsko-zagorska županija'),('en_US',550,'Sisačko-moslavačka županija'),('en_US',551,'Karlovačka županija'),('en_US',552,'Varaždinska županija'),('en_US',553,'Koprivničko-križevačka županija'),('en_US',554,'Bjelovarsko-bilogorska županija'),('en_US',555,'Primorsko-goranska županija'),('en_US',556,'Ličko-senjska županija'),('en_US',557,'Virovitičko-podravska županija'),('en_US',558,'Požeško-slavonska županija'),('en_US',559,'Brodsko-posavska županija'),('en_US',560,'Zadarska županija'),('en_US',561,'Osječko-baranjska županija'),('en_US',562,'Šibensko-kninska županija'),('en_US',563,'Vukovarsko-srijemska županija'),('en_US',564,'Splitsko-dalmatinska županija'),('en_US',565,'Istarska županija'),('en_US',566,'Dubrovačko-neretvanska županija'),('en_US',567,'Međimurska županija'),('en_US',568,'Grad Zagreb'),('en_US',569,'Andaman and Nicobar Islands'),('en_US',570,'Andhra Pradesh'),('en_US',571,'Arunachal Pradesh'),('en_US',572,'Assam'),('en_US',573,'Bihar'),('en_US',574,'Chandigarh'),('en_US',575,'Chhattisgarh'),('en_US',576,'Dadra and Nagar Haveli'),('en_US',577,'Daman and Diu'),('en_US',578,'Delhi'),('en_US',579,'Goa'),('en_US',580,'Gujarat'),('en_US',581,'Haryana'),('en_US',582,'Himachal Pradesh'),('en_US',583,'Jammu and Kashmir'),('en_US',584,'Jharkhand'),('en_US',585,'Karnataka'),('en_US',586,'Kerala'),('en_US',587,'Lakshadweep'),('en_US',588,'Madhya Pradesh'),('en_US',589,'Maharashtra'),('en_US',590,'Manipur'),('en_US',591,'Meghalaya'),('en_US',592,'Mizoram'),('en_US',593,'Nagaland'),('en_US',594,'Odisha'),('en_US',595,'Puducherry'),('en_US',596,'Punjab'),('en_US',597,'Rajasthan'),('en_US',598,'Sikkim'),('en_US',599,'Tamil Nadu'),('en_US',600,'Telangana'),('en_US',601,'Tripura'),('en_US',602,'Uttar Pradesh'),('en_US',603,'Uttarakhand'),('en_US',604,'West Bengal'),('en_US',605,'Australian Capital Territory'),('en_US',606,'New South Wales'),('en_US',607,'Victoria'),('en_US',608,'Queensland'),('en_US',609,'South Australia'),('en_US',610,'Tasmania'),('en_US',611,'Western Australia'),('en_US',612,'Northern Territory'),('en_US',613,'Bresckaja voblasć'),('en_US',614,'Homieĺskaja voblasć'),('en_US',615,'Horad Minsk'),('en_US',616,'Hrodzienskaja voblasć'),('en_US',617,'Mahilioŭskaja voblasć'),('en_US',618,'Minskaja voblasć'),('en_US',619,'Viciebskaja voblasć'),('en_US',620,'Antwerpen'),('en_US',621,'Brabant wallon'),('en_US',622,'Brussels-Capital Region'),('en_US',623,'Hainaut'),('en_US',624,'Limburg'),('en_US',625,'Liège'),('en_US',626,'Luxembourg'),('en_US',627,'Namur'),('en_US',628,'Oost-Vlaanderen'),('en_US',629,'Vlaams-Brabant'),('en_US',630,'West-Vlaanderen'),('en_US',631,'Cochabamba'),('en_US',632,'Chuquisaca'),('en_US',633,'El Beni'),('en_US',634,'La Paz'),('en_US',635,'Oruro'),('en_US',636,'Pando'),('en_US',637,'Potosí'),('en_US',638,'Santa Cruz'),('en_US',639,'Tarija'),('en_US',640,'Blagoevgrad'),('en_US',641,'Burgas'),('en_US',642,'Varna'),('en_US',643,'Veliko Tarnovo'),('en_US',644,'Vidin'),('en_US',645,'Vratsa'),('en_US',646,'Gabrovo'),('en_US',647,'Dobrich'),('en_US',648,'Kardzhali'),('en_US',649,'Kyustendil'),('en_US',650,'Lovech'),('en_US',651,'Montana'),('en_US',652,'Pazardzhik'),('en_US',653,'Pernik'),('en_US',654,'Pleven'),('en_US',655,'Plovdiv'),('en_US',656,'Razgrad'),('en_US',657,'Ruse'),('en_US',658,'Silistra'),('en_US',659,'Sliven'),('en_US',660,'Smolyan'),('en_US',661,'Sofia City'),('en_US',662,'Sofia Province'),('en_US',663,'Stara Zagora'),('en_US',664,'Targovishte'),('en_US',665,'Haskovo'),('en_US',666,'Shumen'),('en_US',667,'Yambol'),('en_US',668,'Aisén del General Carlos Ibañez del Campo'),('en_US',669,'Antofagasta'),('en_US',670,'Arica y Parinacota'),('en_US',671,'La Araucanía'),('en_US',672,'Atacama'),('en_US',673,'Biobío'),('en_US',674,'Coquimbo'),('en_US',675,'Libertador General Bernardo O\'Higgins'),('en_US',676,'Los Lagos'),('en_US',677,'Los Ríos'),('en_US',678,'Magallanes'),('en_US',679,'Maule'),('en_US',680,'Ñuble'),('en_US',681,'Región Metropolitana de Santiago'),('en_US',682,'Tarapacá'),('en_US',683,'Valparaíso'),('en_US',684,'Anhui Sheng'),('en_US',685,'Beijing Shi'),('en_US',686,'Chongqing Shi'),('en_US',687,'Fujian Sheng'),('en_US',688,'Gansu Sheng'),('en_US',689,'Guangdong Sheng'),('en_US',690,'Guangxi Zhuangzu Zizhiqu'),('en_US',691,'Guizhou Sheng'),('en_US',692,'Hainan Sheng'),('en_US',693,'Hebei Sheng'),('en_US',694,'Heilongjiang Sheng'),('en_US',695,'Henan Sheng'),('en_US',696,'Hong Kong SAR'),('en_US',697,'Hubei Sheng'),('en_US',698,'Hunan Sheng'),('en_US',699,'Jiangsu Sheng'),('en_US',700,'Jiangxi Sheng'),('en_US',701,'Jilin Sheng'),('en_US',702,'Liaoning Sheng'),('en_US',703,'Macao SAR'),('en_US',704,'Nei Mongol Zizhiqu'),('en_US',705,'Ningxia Huizi Zizhiqu'),('en_US',706,'Qinghai Sheng'),('en_US',707,'Shaanxi Sheng'),('en_US',708,'Shandong Sheng'),('en_US',709,'Shanghai Shi'),('en_US',710,'Shanxi Sheng'),('en_US',711,'Sichuan Sheng'),('en_US',712,'Taiwan Sheng'),('en_US',713,'Tianjin Shi'),('en_US',714,'Xinjiang Uygur Zizhiqu'),('en_US',715,'Xizang Zizhiqu'),('en_US',716,'Yunnan Sheng'),('en_US',717,'Zhejiang Sheng'),('en_US',718,'Amazonas'),('en_US',719,'Antioquia'),('en_US',720,'Arauca'),('en_US',721,'Atlántico'),('en_US',722,'Bolívar'),('en_US',723,'Boyacá'),('en_US',724,'Caldas'),('en_US',725,'Caquetá'),('en_US',726,'Casanare'),('en_US',727,'Cauca'),('en_US',728,'Cesar'),('en_US',729,'Chocó'),('en_US',730,'Córdoba'),('en_US',731,'Cundinamarca'),('en_US',732,'Guainía'),('en_US',733,'Guaviare'),('en_US',734,'Huila'),('en_US',735,'La Guajira'),('en_US',736,'Magdalena'),('en_US',737,'Meta'),('en_US',738,'Nariño'),('en_US',739,'Norte de Santander'),('en_US',740,'Putumayo'),('en_US',741,'Quindío'),('en_US',742,'Risaralda'),('en_US',743,'San Andrés y Providencia'),('en_US',744,'Santander'),('en_US',745,'Sucre'),('en_US',746,'Tolima'),('en_US',747,'Valle del Cauca'),('en_US',748,'Vaupés'),('en_US',749,'Vichada'),('en_US',750,'San José'),('en_US',751,'Alajuela'),('en_US',752,'Cartago'),('en_US',753,'Heredia'),('en_US',754,'Guanacaste'),('en_US',755,'Puntarenas'),('en_US',756,'Limón'),('en_US',757,'Praha, Hlavní město'),('en_US',758,'Středočeský kraj'),('en_US',759,'Jihočeský kraj'),('en_US',760,'Plzeňský kraj'),('en_US',761,'Karlovarský kraj'),('en_US',762,'Ústecký kraj'),('en_US',763,'Liberecký kraj'),('en_US',764,'Královéhradecký kraj'),('en_US',765,'Pardubický kraj'),('en_US',766,'Kraj Vysočina'),('en_US',767,'Jihomoravský kraj'),('en_US',768,'Olomoucký kraj'),('en_US',769,'Zlínský kraj'),('en_US',770,'Moravskoslezský kraj'),('en_US',771,'Hovedstaden'),('en_US',772,'Midtjylland'),('en_US',773,'Nordjylland'),('en_US',774,'Sjælland'),('en_US',775,'Syddanmark'),('en_US',776,'Azuay'),('en_US',777,'Bolívar'),('en_US',778,'Cañar'),('en_US',779,'Carchi'),('en_US',780,'Chimborazo'),('en_US',781,'Cotopaxi'),('en_US',782,'El Oro'),('en_US',783,'Esmeraldas'),('en_US',784,'Galápagos'),('en_US',785,'Guayas'),('en_US',786,'Imbabura'),('en_US',787,'Loja'),('en_US',788,'Los Ríos'),('en_US',789,'Manabí'),('en_US',790,'Morona Santiago'),('en_US',791,'Napo'),('en_US',792,'Orellana'),('en_US',793,'Pastaza'),('en_US',794,'Pichincha'),('en_US',795,'Santa Elena'),('en_US',796,'Santo Domingo de los Tsáchilas'),('en_US',797,'Sucumbíos'),('en_US',798,'Tungurahua'),('en_US',799,'Zamora Chinchipe'),('en_US',800,'Anatolikí Makedonía kai Thráki'),('en_US',801,'Attikí'),('en_US',802,'Dytikí Elláda'),('en_US',803,'Dytikí Makedonía'),('en_US',804,'Ionía Nísia'),('en_US',805,'Ípeiros'),('en_US',806,'Kentrikí Makedonía'),('en_US',807,'Kríti'),('en_US',808,'Nótio Aigaío'),('en_US',809,'Pelopónnisos'),('en_US',810,'Stereá Elláda'),('en_US',811,'Thessalía'),('en_US',812,'Vóreio Aigaío'),('en_US',813,'Ágion Óros'),('en_US',814,'Barima-Waini'),('en_US',815,'Cuyuni-Mazaruni'),('en_US',816,'Demerara-Mahaica'),('en_US',817,'East Berbice-Corentyne'),('en_US',818,'Essequibo Islands-West Demerara'),('en_US',819,'Mahaica-Berbice'),('en_US',820,'Pomeroon-Supenaam'),('en_US',821,'Potaro-Siparuni'),('en_US',822,'Upper Demerara-Berbice'),('en_US',823,'Upper Takutu-Upper Essequibo'),('en_US',824,'Höfuðborgarsvæði'),('en_US',825,'Suðurnes'),('en_US',826,'Vesturland'),('en_US',827,'Vestfirðir'),('en_US',828,'Norðurland vestra'),('en_US',829,'Norðurland eystra'),('en_US',830,'Austurland'),('en_US',831,'Suðurland'),('en_US',832,'Agrigento'),('en_US',833,'Alessandria'),('en_US',834,'Ancona'),('en_US',835,'Aosta'),('en_US',836,'L\'Aquila'),('en_US',837,'Arezzo'),('en_US',838,'Ascoli-Piceno'),('en_US',839,'Asti'),('en_US',840,'Avellino'),('en_US',841,'Bari'),('en_US',842,'Barletta-Andria-Trani'),('en_US',843,'Belluno'),('en_US',844,'Benevento'),('en_US',845,'Bergamo'),('en_US',846,'Biella'),('en_US',847,'Bologna'),('en_US',848,'Bolzano'),('en_US',849,'Brescia'),('en_US',850,'Brindisi'),('en_US',851,'Cagliari'),('en_US',852,'Caltanissetta'),('en_US',853,'Campobasso'),('en_US',854,'Carbonia Iglesias'),('en_US',855,'Caserta'),('en_US',856,'Catania'),('en_US',857,'Catanzaro'),('en_US',858,'Chieti'),('en_US',859,'Como'),('en_US',860,'Cosenza'),('en_US',861,'Cremona'),('en_US',862,'Crotone'),('en_US',863,'Cuneo'),('en_US',864,'Enna'),('en_US',865,'Fermo'),('en_US',866,'Ferrara'),('en_US',867,'Firenze'),('en_US',868,'Foggia'),('en_US',869,'Forli-Cesena'),('en_US',870,'Frosinone'),('en_US',871,'Genova'),('en_US',872,'Gorizia'),('en_US',873,'Grosseto'),('en_US',874,'Imperia'),('en_US',875,'Isernia'),('en_US',876,'La-Spezia'),('en_US',877,'Latina'),('en_US',878,'Lecce'),('en_US',879,'Lecco'),('en_US',880,'Livorno'),('en_US',881,'Lodi'),('en_US',882,'Lucca'),('en_US',883,'Macerata'),('en_US',884,'Mantova'),('en_US',885,'Massa-Carrara'),('en_US',886,'Matera'),('en_US',887,'Medio Campidano'),('en_US',888,'Messina'),('en_US',889,'Milano'),('en_US',890,'Modena'),('en_US',891,'Monza-Brianza'),('en_US',892,'Napoli'),('en_US',893,'Novara'),('en_US',894,'Nuoro'),('en_US',895,'Ogliastra'),('en_US',896,'Olbia Tempio'),('en_US',897,'Oristano'),('en_US',898,'Padova'),('en_US',899,'Palermo'),('en_US',900,'Parma'),('en_US',901,'Pavia'),('en_US',902,'Perugia'),('en_US',903,'Pesaro-Urbino'),('en_US',904,'Pescara'),('en_US',905,'Piacenza'),('en_US',906,'Pisa'),('en_US',907,'Pistoia'),('en_US',908,'Pordenone'),('en_US',909,'Potenza'),('en_US',910,'Prato'),('en_US',911,'Ragusa'),('en_US',912,'Ravenna'),('en_US',913,'Reggio-Calabria'),('en_US',914,'Reggio-Emilia'),('en_US',915,'Rieti'),('en_US',916,'Rimini'),('en_US',917,'Roma'),('en_US',918,'Rovigo'),('en_US',919,'Salerno'),('en_US',920,'Sassari'),('en_US',921,'Savona'),('en_US',922,'Siena'),('en_US',923,'Siracusa'),('en_US',924,'Sondrio'),('en_US',925,'Taranto'),('en_US',926,'Teramo'),('en_US',927,'Terni'),('en_US',928,'Torino'),('en_US',929,'Trapani'),('en_US',930,'Trento'),('en_US',931,'Treviso'),('en_US',932,'Trieste'),('en_US',933,'Udine'),('en_US',934,'Varese'),('en_US',935,'Venezia'),('en_US',936,'Verbania'),('en_US',937,'Vercelli'),('en_US',938,'Verona'),('en_US',939,'Vibo-Valentia'),('en_US',940,'Vicenza'),('en_US',941,'Viterbo'),('en_US',942,'Aguascalientes'),('en_US',943,'Baja California'),('en_US',944,'Baja California Sur'),('en_US',945,'Campeche'),('en_US',946,'Chiapas'),('en_US',947,'Chihuahua'),('en_US',948,'Ciudad de México'),('en_US',949,'Coahuila'),('en_US',950,'Colima'),('en_US',951,'Durango'),('en_US',952,'Estado de México'),('en_US',953,'Guanajuato'),('en_US',954,'Guerrero'),('en_US',955,'Hidalgo'),('en_US',956,'Jalisco'),('en_US',957,'Michoacán'),('en_US',958,'Morelos'),('en_US',959,'Nayarit'),('en_US',960,'Nuevo León'),('en_US',961,'Oaxaca'),('en_US',962,'Puebla'),('en_US',963,'Querétaro'),('en_US',964,'Quintana Roo'),('en_US',965,'San Luis Potosí'),('en_US',966,'Sinaloa'),('en_US',967,'Sonora'),('en_US',968,'Tabasco'),('en_US',969,'Tamaulipas'),('en_US',970,'Tlaxcala'),('en_US',971,'Veracruz'),('en_US',972,'Yucatán'),('en_US',973,'Zacatecas'),('en_US',974,'Asunción'),('en_US',975,'Alto Paraguay'),('en_US',976,'Alto Paraná'),('en_US',977,'Amambay'),('en_US',978,'Boquerón'),('en_US',979,'Caaguazú'),('en_US',980,'Caazapá'),('en_US',981,'Canindeyú'),('en_US',982,'Central'),('en_US',983,'Concepción'),('en_US',984,'Cordillera'),('en_US',985,'Guairá'),('en_US',986,'Itapúa'),('en_US',987,'Misiones'),('en_US',988,'Ñeembucú'),('en_US',989,'Paraguarí'),('en_US',990,'Presidente Hayes'),('en_US',991,'San Pedro'),('en_US',992,'Municipalidad Metropolitana de Lima'),('en_US',993,'Amazonas'),('en_US',994,'Ancash'),('en_US',995,'Apurímac'),('en_US',996,'Arequipa'),('en_US',997,'Ayacucho'),('en_US',998,'Cajamarca'),('en_US',999,'Cusco'),('en_US',1000,'El Callao'),('en_US',1001,'Huancavelica'),('en_US',1002,'Huánuco'),('en_US',1003,'Ica'),('en_US',1004,'Junín'),('en_US',1005,'La Libertad'),('en_US',1006,'Lambayeque'),('en_US',1007,'Lima'),('en_US',1008,'Loreto'),('en_US',1009,'Madre de Dios'),('en_US',1010,'Moquegua'),('en_US',1011,'Pasco'),('en_US',1012,'Piura'),('en_US',1013,'Puno'),('en_US',1014,'San Martín'),('en_US',1015,'Tacna'),('en_US',1016,'Tumbes'),('en_US',1017,'Ucayali'),('en_US',1018,'dolnośląskie'),('en_US',1019,'kujawsko-pomorskie'),('en_US',1020,'lubelskie'),('en_US',1021,'lubuskie'),('en_US',1022,'łódzkie'),('en_US',1023,'małopolskie'),('en_US',1024,'mazowieckie'),('en_US',1025,'opolskie'),('en_US',1026,'podkarpackie'),('en_US',1027,'podlaskie'),('en_US',1028,'pomorskie'),('en_US',1029,'śląskie'),('en_US',1030,'świętokrzyskie'),('en_US',1031,'warmińsko-mazurskie'),('en_US',1032,'wielkopolskie'),('en_US',1033,'zachodniopomorskie'),('en_US',1034,'Aveiro'),('en_US',1035,'Beja'),('en_US',1036,'Braga'),('en_US',1037,'Bragança'),('en_US',1038,'Castelo Branco'),('en_US',1039,'Coimbra'),('en_US',1040,'Évora'),('en_US',1041,'Faro'),('en_US',1042,'Guarda'),('en_US',1043,'Leiria'),('en_US',1044,'Lisboa'),('en_US',1045,'Portalegre'),('en_US',1046,'Porto'),('en_US',1047,'Santarém'),('en_US',1048,'Setúbal'),('en_US',1049,'Viana do Castelo'),('en_US',1050,'Vila Real'),('en_US',1051,'Viseu'),('en_US',1052,'Região Autónoma dos Açores'),('en_US',1053,'Região Autónoma da Madeira'),('en_US',1054,'Brokopondo'),('en_US',1055,'Commewijne'),('en_US',1056,'Coronie'),('en_US',1057,'Marowijne'),('en_US',1058,'Nickerie'),('en_US',1059,'Para'),('en_US',1060,'Paramaribo'),('en_US',1061,'Saramacca'),('en_US',1062,'Sipaliwini'),('en_US',1063,'Wanica'),('en_US',1064,'Blekinge län'),('en_US',1065,'Dalarnas län'),('en_US',1066,'Gotlands län'),('en_US',1067,'Gävleborgs län'),('en_US',1068,'Hallands län'),('en_US',1069,'Jämtlands län'),('en_US',1070,'Jönköpings län'),('en_US',1071,'Kalmar län'),('en_US',1072,'Kronobergs län'),('en_US',1073,'Norrbottens län'),('en_US',1074,'Skåne län'),('en_US',1075,'Stockholms län'),('en_US',1076,'Södermanlands län'),('en_US',1077,'Uppsala län'),('en_US',1078,'Värmlands län'),('en_US',1079,'Västerbottens län'),('en_US',1080,'Västernorrlands län'),('en_US',1081,'Västmanlands län'),('en_US',1082,'Västra Götalands län'),('en_US',1083,'Örebro län'),('en_US',1084,'Östergötlands län'),('en_US',1085,'Cherkaska oblast'),('en_US',1086,'Chernihivska oblast'),('en_US',1087,'Chernivetska oblast'),('en_US',1088,'Dnipropetrovska oblast'),('en_US',1089,'Donetska oblast'),('en_US',1090,'Ivano-Frankivska oblast'),('en_US',1091,'Kharkivska oblast'),('en_US',1092,'Khersonska oblast'),('en_US',1093,'Khmelnytska oblast'),('en_US',1094,'Kirovohradska oblast'),('en_US',1095,'Kyivska oblast'),('en_US',1096,'Luhanska oblast'),('en_US',1097,'Lvivska oblast'),('en_US',1098,'Mykolaivska oblast'),('en_US',1099,'Odeska oblast'),('en_US',1100,'Poltavska oblast'),('en_US',1101,'Rivnenska oblast'),('en_US',1102,'Sumska oblast'),('en_US',1103,'Ternopilska oblast'),('en_US',1104,'Vinnytska oblast'),('en_US',1105,'Volynska oblast'),('en_US',1106,'Zakarpatska oblast'),('en_US',1107,'Zaporizka oblast'),('en_US',1108,'Zhytomyrska oblast'),('en_US',1109,'Avtonomna Respublika Krym'),('en_US',1110,'Kyiv'),('en_US',1111,'Sevastopol'),('en_US',1112,'Artigas'),('en_US',1113,'Canelones'),('en_US',1114,'Cerro Largo'),('en_US',1115,'Colonia'),('en_US',1116,'Durazno'),('en_US',1117,'Flores'),('en_US',1118,'Florida'),('en_US',1119,'Lavalleja'),('en_US',1120,'Maldonado'),('en_US',1121,'Montevideo'),('en_US',1122,'Paysandu'),('en_US',1123,'Río Negro'),('en_US',1124,'Rivera'),('en_US',1125,'Rocha'),('en_US',1126,'Salto'),('en_US',1127,'San José'),('en_US',1128,'Soriano'),('en_US',1129,'Tacuarembó'),('en_US',1130,'Treinta y Tres'),('en_US',1131,'Dependencias Federales'),('en_US',1132,'Distrito Capital'),('en_US',1133,'Amazonas'),('en_US',1134,'Anzoátegui'),('en_US',1135,'Apure'),('en_US',1136,'Aragua'),('en_US',1137,'Barinas'),('en_US',1138,'Bolívar'),('en_US',1139,'Carabobo'),('en_US',1140,'Cojedes'),('en_US',1141,'Delta Amacuro'),('en_US',1142,'Falcón'),('en_US',1143,'Guárico'),('en_US',1144,'Lara'),('en_US',1145,'Mérida'),('en_US',1146,'Miranda'),('en_US',1147,'Monagas'),('en_US',1148,'Nueva Esparta'),('en_US',1149,'Portuguesa'),('en_US',1150,'Sucre'),('en_US',1151,'Táchira'),('en_US',1152,'Trujillo'),('en_US',1153,'Vargas'),('en_US',1154,'Yaracuy'),('en_US',1155,'Zulia'),('en_US',1156,'Ladakh');
/*!40000 ALTER TABLE `directory_country_region_name` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `directory_currency_rate`
--

DROP TABLE IF EXISTS `directory_currency_rate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `directory_currency_rate` (
  `currency_from` varchar(3) NOT NULL COMMENT 'Currency Code Convert From',
  `currency_to` varchar(3) NOT NULL COMMENT 'Currency Code Convert To',
  `rate` decimal(24,12) NOT NULL DEFAULT '0.000000000000' COMMENT 'Currency Conversion Rate',
  PRIMARY KEY (`currency_from`,`currency_to`),
  KEY `DIRECTORY_CURRENCY_RATE_CURRENCY_TO` (`currency_to`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Directory Currency Rate';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `directory_currency_rate`
--

LOCK TABLES `directory_currency_rate` WRITE;
/*!40000 ALTER TABLE `directory_currency_rate` DISABLE KEYS */;
INSERT INTO `directory_currency_rate` VALUES ('EUR','EUR',1.000000000000),('EUR','USD',1.415000000000),('USD','EUR',0.706700000000),('USD','USD',1.000000000000);
/*!40000 ALTER TABLE `directory_currency_rate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `downloadable_link`
--

DROP TABLE IF EXISTS `downloadable_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `downloadable_link` (
  `link_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Link ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `sort_order` int unsigned NOT NULL DEFAULT '0' COMMENT 'Sort order',
  `number_of_downloads` int DEFAULT NULL COMMENT 'Number of downloads',
  `is_shareable` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Shareable flag',
  `link_url` varchar(255) DEFAULT NULL COMMENT 'Link Url',
  `link_file` varchar(255) DEFAULT NULL COMMENT 'Link File',
  `link_type` varchar(20) DEFAULT NULL COMMENT 'Link Type',
  `sample_url` varchar(255) DEFAULT NULL COMMENT 'Sample Url',
  `sample_file` varchar(255) DEFAULT NULL COMMENT 'Sample File',
  `sample_type` varchar(20) DEFAULT NULL COMMENT 'Sample Type',
  PRIMARY KEY (`link_id`),
  KEY `DOWNLOADABLE_LINK_PRODUCT_ID_SORT_ORDER` (`product_id`,`sort_order`),
  CONSTRAINT `DOWNLOADABLE_LINK_PRODUCT_ID_CATALOG_PRODUCT_ENTITY_ENTITY_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Downloadable Link Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `downloadable_link`
--

LOCK TABLES `downloadable_link` WRITE;
/*!40000 ALTER TABLE `downloadable_link` DISABLE KEYS */;
/*!40000 ALTER TABLE `downloadable_link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `downloadable_link_price`
--

DROP TABLE IF EXISTS `downloadable_link_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `downloadable_link_price` (
  `price_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Price ID',
  `link_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Link ID',
  `website_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID',
  `price` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Price',
  PRIMARY KEY (`price_id`),
  KEY `DOWNLOADABLE_LINK_PRICE_LINK_ID` (`link_id`),
  KEY `DOWNLOADABLE_LINK_PRICE_WEBSITE_ID` (`website_id`),
  CONSTRAINT `DOWNLOADABLE_LINK_PRICE_LINK_ID_DOWNLOADABLE_LINK_LINK_ID` FOREIGN KEY (`link_id`) REFERENCES `downloadable_link` (`link_id`) ON DELETE CASCADE,
  CONSTRAINT `DOWNLOADABLE_LINK_PRICE_WEBSITE_ID_STORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Downloadable Link Price Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `downloadable_link_price`
--

LOCK TABLES `downloadable_link_price` WRITE;
/*!40000 ALTER TABLE `downloadable_link_price` DISABLE KEYS */;
/*!40000 ALTER TABLE `downloadable_link_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `downloadable_link_purchased`
--

DROP TABLE IF EXISTS `downloadable_link_purchased`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `downloadable_link_purchased` (
  `purchased_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Purchased ID',
  `order_id` int unsigned DEFAULT '0' COMMENT 'Order ID',
  `order_increment_id` varchar(50) DEFAULT NULL COMMENT 'Order Increment ID',
  `order_item_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Order Item ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Date of creation',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Date of modification',
  `customer_id` int unsigned DEFAULT '0' COMMENT 'Customer ID',
  `product_name` varchar(255) DEFAULT NULL COMMENT 'Product name',
  `product_sku` varchar(255) DEFAULT NULL COMMENT 'Product sku',
  `link_section_title` varchar(255) DEFAULT NULL COMMENT 'Link_section_title',
  PRIMARY KEY (`purchased_id`),
  KEY `DOWNLOADABLE_LINK_PURCHASED_ORDER_ID` (`order_id`),
  KEY `DOWNLOADABLE_LINK_PURCHASED_ORDER_ITEM_ID` (`order_item_id`),
  KEY `DOWNLOADABLE_LINK_PURCHASED_CUSTOMER_ID` (`customer_id`),
  CONSTRAINT `DL_LNK_PURCHASED_CSTR_ID_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE SET NULL,
  CONSTRAINT `DOWNLOADABLE_LINK_PURCHASED_ORDER_ID_SALES_ORDER_ENTITY_ID` FOREIGN KEY (`order_id`) REFERENCES `sales_order` (`entity_id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Downloadable Link Purchased Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `downloadable_link_purchased`
--

LOCK TABLES `downloadable_link_purchased` WRITE;
/*!40000 ALTER TABLE `downloadable_link_purchased` DISABLE KEYS */;
/*!40000 ALTER TABLE `downloadable_link_purchased` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `downloadable_link_purchased_item`
--

DROP TABLE IF EXISTS `downloadable_link_purchased_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `downloadable_link_purchased_item` (
  `item_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Item ID',
  `purchased_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Purchased ID',
  `order_item_id` int unsigned DEFAULT '0' COMMENT 'Order Item ID',
  `product_id` int unsigned DEFAULT '0' COMMENT 'Product ID',
  `link_hash` varchar(255) DEFAULT NULL COMMENT 'Link hash',
  `number_of_downloads_bought` int unsigned NOT NULL DEFAULT '0' COMMENT 'Number of downloads bought',
  `number_of_downloads_used` int unsigned NOT NULL DEFAULT '0' COMMENT 'Number of downloads used',
  `link_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Link ID',
  `link_title` varchar(255) DEFAULT NULL COMMENT 'Link Title',
  `is_shareable` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Shareable Flag',
  `link_url` varchar(255) DEFAULT NULL COMMENT 'Link Url',
  `link_file` varchar(255) DEFAULT NULL COMMENT 'Link File',
  `link_type` varchar(255) DEFAULT NULL COMMENT 'Link Type',
  `status` varchar(50) DEFAULT NULL COMMENT 'Status',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Creation Time',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Update Time',
  PRIMARY KEY (`item_id`),
  KEY `DOWNLOADABLE_LINK_PURCHASED_ITEM_LINK_HASH` (`link_hash`),
  KEY `DOWNLOADABLE_LINK_PURCHASED_ITEM_ORDER_ITEM_ID` (`order_item_id`),
  KEY `DOWNLOADABLE_LINK_PURCHASED_ITEM_PURCHASED_ID` (`purchased_id`),
  CONSTRAINT `DL_LNK_PURCHASED_ITEM_ORDER_ITEM_ID_SALES_ORDER_ITEM_ITEM_ID` FOREIGN KEY (`order_item_id`) REFERENCES `sales_order_item` (`item_id`) ON DELETE SET NULL,
  CONSTRAINT `DL_LNK_PURCHASED_ITEM_PURCHASED_ID_DL_LNK_PURCHASED_PURCHASED_ID` FOREIGN KEY (`purchased_id`) REFERENCES `downloadable_link_purchased` (`purchased_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Downloadable Link Purchased Item Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `downloadable_link_purchased_item`
--

LOCK TABLES `downloadable_link_purchased_item` WRITE;
/*!40000 ALTER TABLE `downloadable_link_purchased_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `downloadable_link_purchased_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `downloadable_link_title`
--

DROP TABLE IF EXISTS `downloadable_link_title`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `downloadable_link_title` (
  `title_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Title ID',
  `link_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Link ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title',
  PRIMARY KEY (`title_id`),
  UNIQUE KEY `DOWNLOADABLE_LINK_TITLE_LINK_ID_STORE_ID` (`link_id`,`store_id`),
  KEY `DOWNLOADABLE_LINK_TITLE_STORE_ID` (`store_id`),
  CONSTRAINT `DOWNLOADABLE_LINK_TITLE_LINK_ID_DOWNLOADABLE_LINK_LINK_ID` FOREIGN KEY (`link_id`) REFERENCES `downloadable_link` (`link_id`) ON DELETE CASCADE,
  CONSTRAINT `DOWNLOADABLE_LINK_TITLE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Link Title Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `downloadable_link_title`
--

LOCK TABLES `downloadable_link_title` WRITE;
/*!40000 ALTER TABLE `downloadable_link_title` DISABLE KEYS */;
/*!40000 ALTER TABLE `downloadable_link_title` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `downloadable_sample`
--

DROP TABLE IF EXISTS `downloadable_sample`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `downloadable_sample` (
  `sample_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Sample ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `sample_url` varchar(255) DEFAULT NULL COMMENT 'Sample URL',
  `sample_file` varchar(255) DEFAULT NULL COMMENT 'Sample file',
  `sample_type` varchar(20) DEFAULT NULL COMMENT 'Sample Type',
  `sort_order` int unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  PRIMARY KEY (`sample_id`),
  KEY `DOWNLOADABLE_SAMPLE_PRODUCT_ID` (`product_id`),
  CONSTRAINT `DOWNLOADABLE_SAMPLE_PRODUCT_ID_CATALOG_PRODUCT_ENTITY_ENTITY_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Downloadable Sample Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `downloadable_sample`
--

LOCK TABLES `downloadable_sample` WRITE;
/*!40000 ALTER TABLE `downloadable_sample` DISABLE KEYS */;
/*!40000 ALTER TABLE `downloadable_sample` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `downloadable_sample_title`
--

DROP TABLE IF EXISTS `downloadable_sample_title`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `downloadable_sample_title` (
  `title_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Title ID',
  `sample_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Sample ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title',
  PRIMARY KEY (`title_id`),
  UNIQUE KEY `DOWNLOADABLE_SAMPLE_TITLE_SAMPLE_ID_STORE_ID` (`sample_id`,`store_id`),
  KEY `DOWNLOADABLE_SAMPLE_TITLE_STORE_ID` (`store_id`),
  CONSTRAINT `DL_SAMPLE_TTL_SAMPLE_ID_DL_SAMPLE_SAMPLE_ID` FOREIGN KEY (`sample_id`) REFERENCES `downloadable_sample` (`sample_id`) ON DELETE CASCADE,
  CONSTRAINT `DOWNLOADABLE_SAMPLE_TITLE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Downloadable Sample Title Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `downloadable_sample_title`
--

LOCK TABLES `downloadable_sample_title` WRITE;
/*!40000 ALTER TABLE `downloadable_sample_title` DISABLE KEYS */;
/*!40000 ALTER TABLE `downloadable_sample_title` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_attribute`
--

DROP TABLE IF EXISTS `eav_attribute`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_attribute` (
  `attribute_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Attribute ID',
  `entity_type_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_code` varchar(255) NOT NULL COMMENT 'Attribute Code',
  `attribute_model` varchar(255) DEFAULT NULL COMMENT 'Attribute Model',
  `backend_model` varchar(255) DEFAULT NULL COMMENT 'Backend Model',
  `backend_type` varchar(8) NOT NULL DEFAULT 'static' COMMENT 'Backend Type',
  `backend_table` varchar(255) DEFAULT NULL COMMENT 'Backend Table',
  `frontend_model` varchar(255) DEFAULT NULL COMMENT 'Frontend Model',
  `frontend_input` varchar(50) DEFAULT NULL COMMENT 'Frontend Input',
  `frontend_label` varchar(255) DEFAULT NULL COMMENT 'Frontend Label',
  `frontend_class` varchar(255) DEFAULT NULL COMMENT 'Frontend Class',
  `source_model` varchar(255) DEFAULT NULL COMMENT 'Source Model',
  `is_required` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Defines Is Required',
  `is_user_defined` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Defines Is User Defined',
  `default_value` text COMMENT 'Default Value',
  `is_unique` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Defines Is Unique',
  `note` varchar(255) DEFAULT NULL COMMENT 'Note',
  PRIMARY KEY (`attribute_id`),
  UNIQUE KEY `EAV_ATTRIBUTE_ENTITY_TYPE_ID_ATTRIBUTE_CODE` (`entity_type_id`,`attribute_code`),
  KEY `EAV_ATTRIBUTE_FRONTEND_INPUT_ENTITY_TYPE_ID_IS_USER_DEFINED` (`frontend_input`,`entity_type_id`,`is_user_defined`),
  CONSTRAINT `EAV_ATTRIBUTE_ENTITY_TYPE_ID_EAV_ENTITY_TYPE_ENTITY_TYPE_ID` FOREIGN KEY (`entity_type_id`) REFERENCES `eav_entity_type` (`entity_type_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=208 DEFAULT CHARSET=utf8mb3 COMMENT='Eav Attribute';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_attribute`
--

LOCK TABLES `eav_attribute` WRITE;
/*!40000 ALTER TABLE `eav_attribute` DISABLE KEYS */;
INSERT INTO `eav_attribute` VALUES (1,1,'website_id',NULL,'Magento\\Customer\\Model\\Customer\\Attribute\\Backend\\Website','static',NULL,NULL,'select','Associate to Website',NULL,'Magento\\Customer\\Model\\Customer\\Attribute\\Source\\Website',1,0,NULL,0,NULL),(2,1,'store_id',NULL,'Magento\\Customer\\Model\\Customer\\Attribute\\Backend\\Store','static',NULL,NULL,'select','Create In',NULL,'Magento\\Customer\\Model\\Customer\\Attribute\\Source\\Store',1,0,NULL,0,NULL),(3,1,'created_in',NULL,NULL,'static',NULL,NULL,'text','Created From',NULL,NULL,0,0,NULL,0,NULL),(4,1,'prefix',NULL,NULL,'static',NULL,NULL,'text','Name Prefix',NULL,NULL,0,0,NULL,0,NULL),(5,1,'firstname',NULL,NULL,'static',NULL,NULL,'text','First Name',NULL,NULL,1,0,NULL,0,NULL),(6,1,'middlename',NULL,NULL,'static',NULL,NULL,'text','Middle Name/Initial',NULL,NULL,0,0,NULL,0,NULL),(7,1,'lastname',NULL,NULL,'static',NULL,NULL,'text','Last Name',NULL,NULL,1,0,NULL,0,NULL),(8,1,'suffix',NULL,NULL,'static',NULL,NULL,'text','Name Suffix',NULL,NULL,0,0,NULL,0,NULL),(9,1,'email',NULL,NULL,'static',NULL,NULL,'text','Email',NULL,NULL,1,0,NULL,0,NULL),(10,1,'group_id',NULL,NULL,'static',NULL,NULL,'select','Group',NULL,'Magento\\Customer\\Model\\Customer\\Attribute\\Source\\Group',1,0,NULL,0,NULL),(11,1,'dob',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\Datetime','static',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Frontend\\Datetime','date','Date of Birth',NULL,NULL,0,0,NULL,0,NULL),(12,1,'password_hash',NULL,'Magento\\Customer\\Model\\Customer\\Attribute\\Backend\\Password','static',NULL,NULL,'hidden',NULL,NULL,NULL,0,0,NULL,0,NULL),(13,1,'rp_token',NULL,NULL,'static',NULL,NULL,'hidden',NULL,NULL,NULL,0,0,NULL,0,NULL),(14,1,'rp_token_created_at',NULL,NULL,'static',NULL,NULL,'date',NULL,NULL,NULL,0,0,NULL,0,NULL),(15,1,'default_billing',NULL,'Magento\\Customer\\Model\\Customer\\Attribute\\Backend\\Billing','static',NULL,NULL,'text','Default Billing Address',NULL,NULL,0,0,NULL,0,NULL),(16,1,'default_shipping',NULL,'Magento\\Customer\\Model\\Customer\\Attribute\\Backend\\Shipping','static',NULL,NULL,'text','Default Shipping Address',NULL,NULL,0,0,NULL,0,NULL),(17,1,'taxvat',NULL,NULL,'static',NULL,NULL,'text','Tax/VAT Number',NULL,NULL,0,0,NULL,0,NULL),(18,1,'confirmation',NULL,NULL,'static',NULL,NULL,'text','Is Confirmed',NULL,NULL,0,0,NULL,0,NULL),(19,1,'created_at',NULL,NULL,'static',NULL,NULL,'date','Created At',NULL,NULL,0,0,NULL,0,NULL),(20,1,'gender',NULL,NULL,'static',NULL,NULL,'select','Gender',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,0,NULL,0,NULL),(21,1,'disable_auto_group_change','Magento\\Customer\\Model\\Attribute','Magento\\Customer\\Model\\Attribute\\Backend\\Data\\Boolean','static',NULL,NULL,'boolean','Disable Automatic Group Change Based on VAT ID',NULL,NULL,0,0,NULL,0,NULL),(22,2,'prefix',NULL,NULL,'static',NULL,NULL,'text','Name Prefix',NULL,NULL,0,0,NULL,0,NULL),(23,2,'firstname',NULL,NULL,'static',NULL,NULL,'text','First Name',NULL,NULL,1,0,NULL,0,NULL),(24,2,'middlename',NULL,NULL,'static',NULL,NULL,'text','Middle Name/Initial',NULL,NULL,0,0,NULL,0,NULL),(25,2,'lastname',NULL,NULL,'static',NULL,NULL,'text','Last Name',NULL,NULL,1,0,NULL,0,NULL),(26,2,'suffix',NULL,NULL,'static',NULL,NULL,'text','Name Suffix',NULL,NULL,0,0,NULL,0,NULL),(27,2,'company',NULL,NULL,'static',NULL,NULL,'text','Company',NULL,NULL,0,0,NULL,0,NULL),(28,2,'street',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\DefaultBackend','static',NULL,NULL,'multiline','Street Address',NULL,NULL,1,0,NULL,0,NULL),(29,2,'city',NULL,NULL,'static',NULL,NULL,'text','City',NULL,NULL,1,0,NULL,0,NULL),(30,2,'country_id',NULL,NULL,'static',NULL,NULL,'select','Country',NULL,'Magento\\Customer\\Model\\ResourceModel\\Address\\Attribute\\Source\\Country',1,0,NULL,0,NULL),(31,2,'region',NULL,'Magento\\Customer\\Model\\ResourceModel\\Address\\Attribute\\Backend\\Region','static',NULL,NULL,'text','State/Province',NULL,NULL,0,0,NULL,0,NULL),(32,2,'region_id',NULL,NULL,'static',NULL,NULL,'hidden','State/Province',NULL,'Magento\\Customer\\Model\\ResourceModel\\Address\\Attribute\\Source\\Region',0,0,NULL,0,NULL),(33,2,'postcode',NULL,NULL,'static',NULL,NULL,'text','Zip/Postal Code',NULL,NULL,0,0,NULL,0,NULL),(34,2,'telephone',NULL,NULL,'static',NULL,NULL,'text','Phone Number',NULL,NULL,1,0,NULL,0,NULL),(35,2,'fax',NULL,NULL,'static',NULL,NULL,'text','Fax',NULL,NULL,0,0,NULL,0,NULL),(36,2,'vat_id','Magento\\Customer\\Model\\Attribute',NULL,'static',NULL,NULL,'text','VAT Number',NULL,NULL,0,0,NULL,0,NULL),(37,2,'vat_is_valid',NULL,NULL,'static',NULL,NULL,'text','VAT number validity',NULL,NULL,0,0,NULL,0,NULL),(38,2,'vat_request_id',NULL,NULL,'static',NULL,NULL,'text','VAT number validation request ID',NULL,NULL,0,0,NULL,0,NULL),(39,2,'vat_request_date',NULL,NULL,'static',NULL,NULL,'text','VAT number validation request date',NULL,NULL,0,0,NULL,0,NULL),(40,2,'vat_request_success',NULL,NULL,'static',NULL,NULL,'text','VAT number validation request success',NULL,NULL,0,0,NULL,0,NULL),(41,1,'updated_at',NULL,NULL,'static',NULL,NULL,'date','Updated At',NULL,NULL,0,0,NULL,0,NULL),(42,1,'failures_num',NULL,NULL,'static',NULL,NULL,'hidden','Failures Number',NULL,NULL,0,0,NULL,0,NULL),(43,1,'first_failure',NULL,NULL,'static',NULL,NULL,'date','First Failure Date',NULL,NULL,0,0,NULL,0,NULL),(44,1,'lock_expires',NULL,NULL,'static',NULL,NULL,'date','Failures Number',NULL,NULL,0,0,NULL,0,NULL),(45,3,'name',NULL,NULL,'varchar',NULL,NULL,'text','Name',NULL,NULL,1,0,NULL,0,NULL),(46,3,'is_active',NULL,NULL,'int',NULL,NULL,'select','Is Active',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',1,0,NULL,0,NULL),(47,3,'description',NULL,NULL,'text',NULL,NULL,'textarea','Description',NULL,NULL,0,0,NULL,0,NULL),(48,3,'image',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Backend\\Image','varchar',NULL,NULL,'image','Image',NULL,NULL,0,0,NULL,0,NULL),(49,3,'meta_title',NULL,NULL,'varchar',NULL,NULL,'text','Page Title',NULL,NULL,0,0,NULL,0,NULL),(50,3,'meta_keywords',NULL,NULL,'text',NULL,NULL,'textarea','Meta Keywords',NULL,NULL,0,0,NULL,0,NULL),(51,3,'meta_description',NULL,NULL,'text',NULL,NULL,'textarea','Meta Description',NULL,NULL,0,0,NULL,0,NULL),(52,3,'display_mode',NULL,NULL,'varchar',NULL,NULL,'select','Display Mode',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Source\\Mode',0,0,NULL,0,NULL),(53,3,'landing_page',NULL,NULL,'int',NULL,NULL,'select','CMS Block',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Source\\Page',0,0,NULL,0,NULL),(54,3,'is_anchor',NULL,NULL,'int',NULL,NULL,'select','Is Anchor',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',0,0,'1',0,NULL),(55,3,'path',NULL,NULL,'static',NULL,NULL,'text','Path',NULL,NULL,0,0,NULL,0,NULL),(56,3,'position',NULL,NULL,'static',NULL,NULL,'text','Position',NULL,NULL,0,0,NULL,0,NULL),(57,3,'all_children',NULL,NULL,'text',NULL,NULL,'text',NULL,NULL,NULL,0,0,NULL,0,NULL),(58,3,'path_in_store',NULL,NULL,'text',NULL,NULL,'text',NULL,NULL,NULL,0,0,NULL,0,NULL),(59,3,'children',NULL,NULL,'text',NULL,NULL,'text',NULL,NULL,NULL,0,0,NULL,0,NULL),(60,3,'custom_design',NULL,NULL,'varchar',NULL,NULL,'select','Custom Design',NULL,'Magento\\Theme\\Model\\Theme\\Source\\Theme',0,0,NULL,0,NULL),(61,3,'custom_design_from','Magento\\Catalog\\Model\\ResourceModel\\Eav\\Attribute','Magento\\Catalog\\Model\\Attribute\\Backend\\Startdate','datetime',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Frontend\\Datetime','date','Active From',NULL,NULL,0,0,NULL,0,NULL),(62,3,'custom_design_to',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\Datetime','datetime',NULL,NULL,'date','Active To',NULL,NULL,0,0,NULL,0,NULL),(63,3,'page_layout',NULL,NULL,'varchar',NULL,NULL,'select','Page Layout',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Source\\Layout',0,0,NULL,0,NULL),(64,3,'custom_layout_update',NULL,'Magento\\Catalog\\Model\\Attribute\\Backend\\Customlayoutupdate','text',NULL,NULL,'textarea','Custom Layout Update',NULL,NULL,0,0,NULL,0,NULL),(65,3,'level',NULL,NULL,'static',NULL,NULL,'text','Level',NULL,NULL,0,0,NULL,0,NULL),(66,3,'children_count',NULL,NULL,'static',NULL,NULL,'text','Children Count',NULL,NULL,0,0,NULL,0,NULL),(67,3,'available_sort_by',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Backend\\Sortby','text',NULL,NULL,'multiselect','Available Product Listing Sort By',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Source\\Sortby',1,0,NULL,0,NULL),(68,3,'default_sort_by',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Backend\\Sortby','varchar',NULL,NULL,'select','Default Product Listing Sort By',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Source\\Sortby',1,0,NULL,0,NULL),(69,3,'include_in_menu',NULL,NULL,'int',NULL,NULL,'select','Include in Navigation Menu',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',1,0,'1',0,NULL),(70,3,'custom_use_parent_settings',NULL,NULL,'int',NULL,NULL,'select','Use Parent Category Settings',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',0,0,NULL,0,NULL),(71,3,'custom_apply_to_products',NULL,NULL,'int',NULL,NULL,'select','Apply To Products',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',0,0,NULL,0,NULL),(72,3,'filter_price_range',NULL,NULL,'decimal',NULL,NULL,'text','Layered Navigation Price Step',NULL,NULL,0,0,NULL,0,NULL),(73,4,'name','Magento\\Catalog\\Model\\ResourceModel\\Eav\\Attribute',NULL,'varchar',NULL,NULL,'text','Product Name','validate-length maximum-length-255',NULL,1,0,NULL,0,NULL),(74,4,'sku','Magento\\Catalog\\Model\\ResourceModel\\Eav\\Attribute','Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Sku','static',NULL,NULL,'text','SKU','validate-length maximum-length-64',NULL,1,0,NULL,1,NULL),(75,4,'description',NULL,NULL,'text',NULL,NULL,'textarea','Description',NULL,NULL,0,0,NULL,0,NULL),(76,4,'short_description',NULL,NULL,'text',NULL,NULL,'textarea','Short Description',NULL,NULL,0,0,NULL,0,NULL),(77,4,'price',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Price','decimal',NULL,NULL,'price','Price',NULL,NULL,1,0,NULL,0,NULL),(78,4,'special_price','Magento\\Catalog\\Model\\ResourceModel\\Eav\\Attribute','Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Price','decimal',NULL,NULL,'price','Special Price',NULL,NULL,0,0,NULL,0,NULL),(79,4,'special_from_date',NULL,'Magento\\Catalog\\Model\\Attribute\\Backend\\Startdate','datetime',NULL,NULL,'date','Special Price From Date',NULL,NULL,0,0,NULL,0,NULL),(80,4,'special_to_date',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\Datetime','datetime',NULL,NULL,'date','Special Price To Date',NULL,NULL,0,0,NULL,0,NULL),(81,4,'cost',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Price','decimal',NULL,NULL,'price','Cost',NULL,NULL,0,1,NULL,0,NULL),(82,4,'weight',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Weight','decimal',NULL,NULL,'weight','Weight',NULL,NULL,0,0,NULL,0,NULL),(83,4,'manufacturer',NULL,NULL,'int',NULL,NULL,'select','Manufacturer',NULL,NULL,0,1,NULL,0,NULL),(84,4,'meta_title',NULL,NULL,'varchar',NULL,NULL,'text','Meta Title',NULL,NULL,0,0,NULL,0,NULL),(85,4,'meta_keyword',NULL,NULL,'text',NULL,NULL,'textarea','Meta Keywords',NULL,NULL,0,0,NULL,0,NULL),(86,4,'meta_description',NULL,NULL,'varchar',NULL,NULL,'textarea','Meta Description',NULL,NULL,0,0,NULL,0,'Maximum 255 chars. Meta Description should optimally be between 150-160 characters'),(87,4,'image',NULL,NULL,'varchar',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Frontend\\Image','media_image','Base',NULL,NULL,0,0,NULL,0,NULL),(88,4,'small_image',NULL,NULL,'varchar',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Frontend\\Image','media_image','Small',NULL,NULL,0,0,NULL,0,NULL),(89,4,'thumbnail',NULL,NULL,'varchar',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Frontend\\Image','media_image','Thumbnail',NULL,NULL,0,0,NULL,0,NULL),(90,4,'media_gallery',NULL,NULL,'static',NULL,NULL,'gallery','Media Gallery',NULL,NULL,0,0,NULL,0,NULL),(91,4,'old_id',NULL,NULL,'int',NULL,NULL,'text',NULL,NULL,NULL,0,0,NULL,0,NULL),(92,4,'tier_price',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Tierprice','decimal',NULL,NULL,'text','Tier Price',NULL,NULL,0,0,NULL,0,NULL),(93,4,'color',NULL,NULL,'int',NULL,NULL,'select','Color',NULL,NULL,0,1,'',0,NULL),(94,4,'news_from_date',NULL,'Magento\\Catalog\\Model\\Attribute\\Backend\\Startdate','datetime',NULL,NULL,'date','Set Product as New from Date',NULL,NULL,0,0,NULL,0,NULL),(95,4,'news_to_date',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\Datetime','datetime',NULL,NULL,'date','Set Product as New to Date',NULL,NULL,0,0,NULL,0,NULL),(96,4,'gallery',NULL,NULL,'varchar',NULL,NULL,'gallery','Image Gallery',NULL,NULL,0,0,NULL,0,NULL),(97,4,'status',NULL,NULL,'int',NULL,NULL,'select','Enable Product',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Source\\Status',0,0,'1',0,NULL),(98,4,'minimal_price','Magento\\Catalog\\Model\\ResourceModel\\Eav\\Attribute','Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Price','decimal',NULL,NULL,'price','Minimal Price',NULL,NULL,0,0,NULL,0,NULL),(99,4,'visibility',NULL,NULL,'int',NULL,NULL,'select','Visibility',NULL,'Magento\\Catalog\\Model\\Product\\Visibility',0,0,'4',0,NULL),(100,4,'custom_design',NULL,NULL,'varchar',NULL,NULL,'select','New Theme',NULL,'Magento\\Theme\\Model\\Theme\\Source\\Theme',0,0,NULL,0,NULL),(101,4,'custom_design_from',NULL,'Magento\\Catalog\\Model\\Attribute\\Backend\\Startdate','datetime',NULL,NULL,'date','Active From',NULL,NULL,0,0,NULL,0,NULL),(102,4,'custom_design_to',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\Datetime','datetime',NULL,NULL,'date','Active To',NULL,NULL,0,0,NULL,0,NULL),(103,4,'custom_layout_update',NULL,'Magento\\Catalog\\Model\\Attribute\\Backend\\Customlayoutupdate','text',NULL,NULL,'textarea','Layout Update XML',NULL,NULL,0,0,NULL,0,NULL),(104,4,'page_layout',NULL,NULL,'varchar',NULL,NULL,'select','Layout',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Source\\Layout',0,0,NULL,0,NULL),(105,4,'category_ids',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Category','static',NULL,NULL,'text','Categories',NULL,NULL,0,0,NULL,0,NULL),(106,4,'options_container',NULL,NULL,'varchar',NULL,NULL,'select','Display Product Options In',NULL,'Magento\\Catalog\\Model\\Entity\\Product\\Attribute\\Design\\Options\\Container',0,0,'container2',0,NULL),(107,4,'required_options',NULL,NULL,'static',NULL,NULL,'text',NULL,NULL,NULL,0,0,NULL,0,NULL),(108,4,'has_options',NULL,NULL,'static',NULL,NULL,'text',NULL,NULL,NULL,0,0,NULL,0,NULL),(109,4,'image_label',NULL,NULL,'varchar',NULL,NULL,'text','Image Label',NULL,NULL,0,0,NULL,0,NULL),(110,4,'small_image_label',NULL,NULL,'varchar',NULL,NULL,'text','Small Image Label',NULL,NULL,0,0,NULL,0,NULL),(111,4,'thumbnail_label',NULL,NULL,'varchar',NULL,NULL,'text','Thumbnail Label',NULL,NULL,0,0,NULL,0,NULL),(112,4,'created_at',NULL,NULL,'static',NULL,NULL,'date',NULL,NULL,NULL,1,0,NULL,0,NULL),(113,4,'updated_at',NULL,NULL,'static',NULL,NULL,'date',NULL,NULL,NULL,1,0,NULL,0,NULL),(114,4,'country_of_manufacture',NULL,NULL,'varchar',NULL,NULL,'select','Country of Manufacture',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Source\\Countryofmanufacture',0,0,NULL,0,NULL),(115,4,'quantity_and_stock_status',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Stock','int',NULL,NULL,'select','Quantity',NULL,'Magento\\CatalogInventory\\Model\\Source\\Stock',0,0,'1',0,NULL),(116,4,'custom_layout',NULL,NULL,'varchar',NULL,NULL,'select','New Layout',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Source\\Layout',0,0,NULL,0,NULL),(117,4,'custom_layout_update_file',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\LayoutUpdate','varchar',NULL,NULL,'select','Custom Layout Update',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Source\\LayoutUpdate',0,0,NULL,0,NULL),(118,3,'custom_layout_update_file',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Backend\\LayoutUpdate','varchar',NULL,NULL,'select','Custom Layout Update',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Source\\LayoutUpdate',0,0,NULL,0,NULL),(119,3,'url_key',NULL,NULL,'varchar',NULL,NULL,'text','URL Key',NULL,NULL,0,0,NULL,0,NULL),(120,3,'url_path',NULL,NULL,'varchar',NULL,NULL,'text',NULL,NULL,NULL,0,0,NULL,0,NULL),(121,4,'url_key',NULL,NULL,'varchar',NULL,NULL,'text','URL Key','validate-trailing-hyphen',NULL,0,0,NULL,0,NULL),(122,4,'url_path',NULL,NULL,'varchar',NULL,NULL,'text',NULL,NULL,NULL,0,0,NULL,0,NULL),(123,4,'msrp','Magento\\Catalog\\Model\\ResourceModel\\Eav\\Attribute','Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Price','decimal',NULL,NULL,'price','Minimum Advertised Price',NULL,NULL,0,0,NULL,0,NULL),(124,4,'msrp_display_actual_price_type',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Boolean','varchar',NULL,NULL,'select','Display Actual Price',NULL,'Magento\\Msrp\\Model\\Product\\Attribute\\Source\\Type\\Price',0,0,'0',0,NULL),(125,4,'links_purchased_separately',NULL,NULL,'int',NULL,NULL,NULL,'Links can be purchased separately',NULL,NULL,1,0,NULL,0,NULL),(126,4,'samples_title',NULL,NULL,'varchar',NULL,NULL,NULL,'Samples title',NULL,NULL,1,0,NULL,0,NULL),(127,4,'links_title',NULL,NULL,'varchar',NULL,NULL,NULL,'Links title',NULL,NULL,1,0,NULL,0,NULL),(128,4,'links_exist',NULL,NULL,'int',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,0,NULL),(129,4,'price_type',NULL,NULL,'int',NULL,NULL,'boolean','Dynamic Price',NULL,NULL,1,0,'0',0,NULL),(130,4,'sku_type',NULL,NULL,'int',NULL,NULL,'boolean','Dynamic SKU',NULL,NULL,1,0,'0',0,NULL),(131,4,'weight_type',NULL,NULL,'int',NULL,NULL,'boolean','Dynamic Weight',NULL,NULL,1,0,'0',0,NULL),(132,4,'price_view',NULL,NULL,'int',NULL,NULL,'select','Price View',NULL,'Magento\\Bundle\\Model\\Product\\Attribute\\Source\\Price\\View',1,0,NULL,0,NULL),(133,4,'shipment_type',NULL,NULL,'int',NULL,NULL,'select','Ship Bundle Items',NULL,'Magento\\Bundle\\Model\\Product\\Attribute\\Source\\Shipment\\Type',1,0,'0',0,NULL),(134,4,'gift_message_available',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Boolean','varchar',NULL,NULL,'select','Allow Gift Message',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Source\\Boolean',0,0,NULL,0,NULL),(135,4,'swatch_image',NULL,NULL,'varchar',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Frontend\\Image','media_image','Swatch',NULL,NULL,0,0,NULL,0,NULL),(136,4,'tax_class_id',NULL,NULL,'int',NULL,NULL,'select','Tax Class',NULL,'Magento\\Tax\\Model\\TaxClass\\Source\\Product',0,0,'2',0,NULL),(137,3,'first_tab',NULL,NULL,'text',NULL,NULL,'textarea','First Tab',NULL,NULL,0,1,NULL,0,NULL),(138,3,'second_tab',NULL,NULL,'text',NULL,NULL,'textarea','Second Tab',NULL,NULL,0,1,NULL,0,NULL),(139,3,'third_tab',NULL,NULL,'text',NULL,NULL,'textarea','Third Tab',NULL,NULL,0,1,NULL,0,NULL),(140,4,'kitchen_sinks',NULL,NULL,'int',NULL,NULL,'boolean','Kitchen Sinks',NULL,NULL,0,1,'0',0,NULL),(141,4,'bestsellers',NULL,NULL,'int',NULL,NULL,'boolean','Bestsellers',NULL,NULL,0,1,'0',0,NULL),(142,4,'bath_enclosures',NULL,NULL,'int',NULL,NULL,'boolean','Bath Enclosures',NULL,NULL,0,1,'0',0,NULL),(143,4,'whirlpool_baths',NULL,NULL,'int',NULL,NULL,'boolean','Whirlpool Baths',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',0,1,'0',0,NULL),(144,4,'shower_baths',NULL,NULL,'int',NULL,NULL,'boolean','Shower Baths',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',0,1,'0',0,NULL),(145,4,'product_faq',NULL,NULL,'text',NULL,NULL,'textarea','Question And Answer',NULL,NULL,0,1,NULL,0,NULL),(146,4,'product_dimensions',NULL,NULL,'text',NULL,NULL,'textarea','Product Dimensions',NULL,NULL,0,1,NULL,0,NULL),(147,4,'top_rated',NULL,NULL,'int',NULL,NULL,'boolean','Top Rated',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',0,1,'0',0,NULL),(148,4,'available_shipping_methods',NULL,'MageWorx\\ShippingRules\\Model\\Attribute\\Backend\\AvailableShippingMethods','text',NULL,'MageWorx\\ShippingRules\\Model\\Attribute\\Frontend\\AvailableShippingMethods','multiselect','Available Shipping Methods',NULL,'MageWorx\\ShippingRules\\Model\\Attribute\\Source\\AvailableShippingMethods',0,0,NULL,0,NULL),(149,4,'bss_productattachment',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','varchar',NULL,NULL,'multiselect','File Attachment',NULL,'Bss\\ProductAttachment\\Model\\Attribute\\Source\\File',0,0,NULL,0,NULL),(150,4,'hide_shipping_calculator',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Boolean','int',NULL,NULL,'boolean','Hide Shipping Calculator',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Source\\Boolean',0,0,'0',0,NULL),(151,3,'hide_shipping_calculator',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Backend\\Boolean','int',NULL,NULL,'boolean','Hide Shipping Calculator',NULL,'Magento\\Catalog\\Model\\Product\\Attribute\\Source\\Boolean',0,0,'0',0,NULL),(152,4,'heat_output',NULL,NULL,'varchar',NULL,NULL,'text','Heat Output',NULL,NULL,0,1,NULL,0,NULL),(153,3,'category_custom_editorup',NULL,NULL,'text',NULL,NULL,'textarea','Category Bottom content',NULL,NULL,0,1,NULL,0,NULL),(155,4,'imegamedia_finance_filter',NULL,NULL,'text',NULL,NULL,'text','Imegamedia Finance Filter',NULL,NULL,0,0,NULL,0,NULL),(156,4,'price_per_unit',NULL,NULL,'text',NULL,NULL,'text','Price Per Unit',NULL,NULL,0,0,'0',0,NULL),(157,1,'mp_smtp_is_synced',NULL,NULL,'int',NULL,NULL,'hidden','Mp SMTP is synced',NULL,NULL,0,0,NULL,0,NULL),(158,3,'magic_label',NULL,NULL,'varchar',NULL,NULL,'text','Label','validate-length maximum-length-255',NULL,0,0,NULL,0,'Example: New,Hot,... Maximum 255 chars'),(159,3,'magic_thumbnail',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Backend\\Image','varchar',NULL,NULL,'image','Thumbnail',NULL,NULL,0,0,NULL,0,NULL),(160,3,'magic_image',NULL,'Magento\\Catalog\\Model\\Category\\Attribute\\Backend\\Image','varchar',NULL,NULL,'image','Image',NULL,NULL,0,0,NULL,0,NULL),(161,4,'featured',NULL,NULL,'int',NULL,NULL,'boolean','Featured Product',NULL,NULL,0,1,NULL,0,NULL),(162,4,'product_brand',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','varchar',NULL,NULL,'multiselect','Product Brand',NULL,'Ves\\Brand\\Model\\Brandlist',0,1,NULL,0,NULL),(163,3,'is_home',NULL,NULL,'int',NULL,NULL,'boolean','Is Home Category',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Boolean',0,0,'0',0,NULL),(164,4,'pressure_bar',NULL,NULL,'int',NULL,NULL,'select','pressure_bar',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(165,4,'offer',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Offer',NULL,NULL,0,1,'',0,NULL),(166,4,'cabinet_width',NULL,NULL,'int',NULL,NULL,'select','Cabinet Width',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(167,4,'material',NULL,NULL,'int',NULL,NULL,'select','Material',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(168,4,'mount_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Mount Type',NULL,NULL,0,1,'',0,NULL),(169,4,'number_of_bowls',NULL,NULL,'int',NULL,NULL,'select','Number of Bowls',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(170,4,'products_by_category',NULL,NULL,'int',NULL,NULL,'select','products_by_category',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(171,4,'bath_length',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Bath Length',NULL,NULL,0,1,'',0,NULL),(172,4,'bath_style',NULL,NULL,'int',NULL,NULL,'select','Bath Style',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(173,4,'bath_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect',' Bath Type',NULL,NULL,0,1,'',0,NULL),(174,4,'glass_thickness',NULL,NULL,'int',NULL,NULL,'select','Glass Thickness',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(175,4,'tap_style',NULL,NULL,'int',NULL,NULL,'select','Tap Style',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(176,4,'tap_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Tap type',NULL,NULL,0,1,'',0,NULL),(177,4,'basin_width',NULL,NULL,'int',NULL,NULL,'select','Basin Width',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(178,4,'basin_depth',NULL,NULL,'int',NULL,NULL,'select','Basin Depth',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(179,4,'flush_type',NULL,NULL,'int',NULL,NULL,'select','Flush Type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(180,4,'toilet_width',NULL,NULL,'int',NULL,NULL,'select','Toilet Width',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(181,4,'toilet_style',NULL,NULL,'int',NULL,NULL,'select','Toilet Style',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(182,4,'toilet_projection',NULL,NULL,'int',NULL,NULL,'select','Toilet Projection',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(183,4,'toilet_full_height',NULL,NULL,'int',NULL,NULL,'select','Toilet Full Height',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(184,4,'installation',NULL,NULL,'int',NULL,NULL,'select','Installation',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(185,4,'fuel_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Fuel Type',NULL,NULL,0,1,'',0,NULL),(186,4,'colour',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Colour',NULL,NULL,0,1,'',0,NULL),(187,4,'built_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Built Type',NULL,NULL,0,1,'',0,NULL),(188,4,'oven_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Oven Type',NULL,NULL,0,1,'',0,NULL),(189,4,'cleaning',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Cleaning',NULL,NULL,0,1,'',0,NULL),(190,4,'size',NULL,NULL,'int',NULL,NULL,'select','Size',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(191,4,'number_of_cooking_zones',NULL,NULL,'int',NULL,NULL,'select','Number of Cooking Zones',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(192,4,'hoods_type',NULL,NULL,'int',NULL,NULL,'select','Hoods Type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(193,4,'hob_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Hob Type',NULL,NULL,0,1,'',0,NULL),(194,4,'hoods_width_mm',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Hoods Width (mm)',NULL,NULL,0,1,'',0,NULL),(195,4,'fire_width',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Fire Width',NULL,NULL,0,1,'',0,NULL),(196,4,'fire_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Fire Type',NULL,NULL,0,1,'',0,NULL),(197,4,'fire_style',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect',' Fire Style',NULL,NULL,0,1,'',0,NULL),(198,4,'fire_frontage',NULL,NULL,'int',NULL,NULL,'select','Fire Frontage',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(199,4,'fit_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Fit type',NULL,NULL,0,1,'',0,NULL),(200,4,'features',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Features',NULL,NULL,0,1,'',0,NULL),(201,4,'height',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Height',NULL,NULL,0,1,'',0,NULL),(202,4,'defrost_type',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Defrost Type',NULL,NULL,0,1,'',0,NULL),(203,4,'unit_width',NULL,NULL,'int',NULL,NULL,'select','Unit Width',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Source\\Table',0,1,'',0,NULL),(204,4,'configuration',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Configuration',NULL,NULL,0,1,'',0,NULL),(205,4,'radiator_style',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Radiator Style',NULL,NULL,0,1,'',0,NULL),(206,4,'output_btu',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Output (BTU)',NULL,NULL,0,1,'',0,NULL),(207,4,'radiator_height',NULL,'Magento\\Eav\\Model\\Entity\\Attribute\\Backend\\ArrayBackend','text',NULL,NULL,'multiselect','Radiator Height',NULL,NULL,0,1,'',0,NULL);
/*!40000 ALTER TABLE `eav_attribute` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_attribute_group`
--

DROP TABLE IF EXISTS `eav_attribute_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_attribute_group` (
  `attribute_group_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Attribute Group ID',
  `attribute_set_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Set ID',
  `attribute_group_name` varchar(255) DEFAULT NULL COMMENT 'Attribute Group Name',
  `sort_order` smallint NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `default_id` smallint unsigned DEFAULT '0' COMMENT 'Default ID',
  `attribute_group_code` varchar(255) NOT NULL COMMENT 'Attribute Group Code',
  `tab_group_code` varchar(255) DEFAULT NULL COMMENT 'Tab Group Code',
  PRIMARY KEY (`attribute_group_id`),
  UNIQUE KEY `EAV_ATTRIBUTE_GROUP_ATTRIBUTE_SET_ID_ATTRIBUTE_GROUP_CODE` (`attribute_set_id`,`attribute_group_code`),
  UNIQUE KEY `EAV_ATTRIBUTE_GROUP_ATTRIBUTE_SET_ID_ATTRIBUTE_GROUP_NAME` (`attribute_set_id`,`attribute_group_name`),
  KEY `EAV_ATTRIBUTE_GROUP_ATTRIBUTE_SET_ID_SORT_ORDER` (`attribute_set_id`,`sort_order`),
  CONSTRAINT `EAV_ATTR_GROUP_ATTR_SET_ID_EAV_ATTR_SET_ATTR_SET_ID` FOREIGN KEY (`attribute_set_id`) REFERENCES `eav_attribute_set` (`attribute_set_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=601 DEFAULT CHARSET=utf8mb3 COMMENT='Eav Attribute Group';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_attribute_group`
--

LOCK TABLES `eav_attribute_group` WRITE;
/*!40000 ALTER TABLE `eav_attribute_group` DISABLE KEYS */;
INSERT INTO `eav_attribute_group` VALUES (1,1,'General',1,1,'general',NULL),(2,2,'General',1,1,'general',NULL),(3,3,'General',10,1,'general',NULL),(4,3,'General Information',2,0,'general-information',NULL),(5,3,'Display Settings',20,0,'display-settings',NULL),(6,3,'Custom Design',30,0,'custom-design',NULL),(7,4,'General',1,1,'product-details','basic'),(8,4,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(9,4,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(10,4,'Images',4,0,'image-management','basic'),(11,4,'Design',7,0,'design','advanced'),(12,4,'Autosettings',9,0,'autosettings','advanced'),(13,4,'Content',2,0,'content','basic'),(14,4,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(15,5,'General',1,1,'general',NULL),(16,6,'General',1,1,'general',NULL),(17,7,'General',1,1,'general',NULL),(18,8,'General',1,1,'general',NULL),(19,4,'Bundle Items',3,0,'bundle-items',NULL),(20,4,'Gift Options',10,0,'gift-options',NULL),(21,3,'Custom Category Group',31,0,'custom-category-group',NULL),(22,4,'Attributes',11,0,'attributes',NULL),(23,4,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(24,3,'Magiccart',32,0,'magiccart',NULL),(25,9,'mageworx-dynamic-options',12,0,'mageworx-dynamic-options',NULL),(26,9,'Attributes',11,0,'attributes',NULL),(27,9,'Gift Options',10,0,'gift-options',NULL),(28,9,'Autosettings',9,0,'autosettings','advanced'),(29,9,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(30,9,'Design',7,0,'design','advanced'),(31,9,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(32,9,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(33,9,'Images',4,0,'image-management','basic'),(34,9,'Bundle Items',3,0,'bundle-items',NULL),(35,9,'Content',2,0,'content','basic'),(36,9,'General',1,1,'product-details','basic'),(37,10,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(38,10,'Attributes',11,0,'attributes',NULL),(39,10,'Gift Options',10,0,'gift-options',NULL),(40,10,'Autosettings',9,0,'autosettings','advanced'),(41,10,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(42,10,'Design',7,0,'design','advanced'),(43,10,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(44,10,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(45,10,'Images',4,0,'image-management','basic'),(46,10,'Bundle Items',3,0,'bundle-items',NULL),(47,10,'Content',2,0,'content','basic'),(48,10,'General',1,1,'product-details','basic'),(49,11,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(50,11,'Attributes',11,0,'attributes',NULL),(51,11,'Gift Options',10,0,'gift-options',NULL),(52,11,'Autosettings',9,0,'autosettings','advanced'),(53,11,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(54,11,'Design',7,0,'design','advanced'),(55,11,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(56,11,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(57,11,'Images',4,0,'image-management','basic'),(58,11,'Bundle Items',3,0,'bundle-items',NULL),(59,11,'Content',2,0,'content','basic'),(60,11,'General',1,1,'product-details','basic'),(85,14,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(86,14,'Attributes',11,0,'attributes',NULL),(87,14,'Gift Options',10,0,'gift-options',NULL),(88,14,'Autosettings',9,0,'autosettings','advanced'),(89,14,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(90,14,'Design',7,0,'design','advanced'),(91,14,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(92,14,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(93,14,'Images',4,0,'image-management','basic'),(94,14,'Bundle Items',3,0,'bundle-items',NULL),(95,14,'Content',2,0,'content','basic'),(96,14,'General',1,1,'product-details','basic'),(97,15,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(98,15,'Attributes',11,0,'attributes',NULL),(99,15,'Gift Options',10,0,'gift-options',NULL),(100,15,'Autosettings',9,0,'autosettings','advanced'),(101,15,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(102,15,'Design',7,0,'design','advanced'),(103,15,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(104,15,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(105,15,'Images',4,0,'image-management','basic'),(106,15,'Bundle Items',3,0,'bundle-items',NULL),(107,15,'Content',2,0,'content','basic'),(108,15,'General',1,1,'product-details','basic'),(109,16,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(110,16,'Attributes',11,0,'attributes',NULL),(111,16,'Gift Options',10,0,'gift-options',NULL),(112,16,'Autosettings',9,0,'autosettings','advanced'),(113,16,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(114,16,'Design',7,0,'design','advanced'),(115,16,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(116,16,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(117,16,'Images',4,0,'image-management','basic'),(118,16,'Bundle Items',3,0,'bundle-items',NULL),(119,16,'Content',2,0,'content','basic'),(120,16,'General',1,1,'product-details','basic'),(121,17,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(122,17,'Attributes',11,0,'attributes',NULL),(123,17,'Gift Options',10,0,'gift-options',NULL),(124,17,'Autosettings',9,0,'autosettings','advanced'),(125,17,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(126,17,'Design',7,0,'design','advanced'),(127,17,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(128,17,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(129,17,'Images',4,0,'image-management','basic'),(130,17,'Bundle Items',3,0,'bundle-items',NULL),(131,17,'Content',2,0,'content','basic'),(132,17,'General',1,1,'product-details','basic'),(133,18,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(134,18,'Attributes',11,0,'attributes',NULL),(135,18,'Gift Options',10,0,'gift-options',NULL),(136,18,'Autosettings',9,0,'autosettings','advanced'),(137,18,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(138,18,'Design',7,0,'design','advanced'),(139,18,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(140,18,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(141,18,'Images',4,0,'image-management','basic'),(142,18,'Bundle Items',3,0,'bundle-items',NULL),(143,18,'Content',2,0,'content','basic'),(144,18,'General',1,1,'product-details','basic'),(145,19,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(146,19,'Attributes',11,0,'attributes',NULL),(147,19,'Gift Options',10,0,'gift-options',NULL),(148,19,'Autosettings',9,0,'autosettings','advanced'),(149,19,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(150,19,'Design',7,0,'design','advanced'),(151,19,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(152,19,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(153,19,'Images',4,0,'image-management','basic'),(154,19,'Bundle Items',3,0,'bundle-items',NULL),(155,19,'Content',2,0,'content','basic'),(156,19,'General',1,1,'product-details','basic'),(157,20,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(158,20,'Attributes',11,0,'attributes',NULL),(159,20,'Gift Options',10,0,'gift-options',NULL),(160,20,'Autosettings',9,0,'autosettings','advanced'),(161,20,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(162,20,'Design',7,0,'design','advanced'),(163,20,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(164,20,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(165,20,'Images',4,0,'image-management','basic'),(166,20,'Bundle Items',3,0,'bundle-items',NULL),(167,20,'Content',2,0,'content','basic'),(168,20,'General',1,1,'product-details','basic'),(169,21,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(170,21,'Attributes',11,0,'attributes',NULL),(171,21,'Gift Options',10,0,'gift-options',NULL),(172,21,'Autosettings',9,0,'autosettings','advanced'),(173,21,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(174,21,'Design',7,0,'design','advanced'),(175,21,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(176,21,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(177,21,'Images',4,0,'image-management','basic'),(178,21,'Bundle Items',3,0,'bundle-items',NULL),(179,21,'Content',2,0,'content','basic'),(180,21,'General',1,1,'product-details','basic'),(181,22,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(182,22,'Attributes',11,0,'attributes',NULL),(183,22,'Gift Options',10,0,'gift-options',NULL),(184,22,'Autosettings',9,0,'autosettings','advanced'),(185,22,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(186,22,'Design',7,0,'design','advanced'),(187,22,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(188,22,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(189,22,'Images',4,0,'image-management','basic'),(190,22,'Bundle Items',3,0,'bundle-items',NULL),(191,22,'Content',2,0,'content','basic'),(192,22,'General',1,1,'product-details','basic'),(193,23,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(194,23,'Attributes',11,0,'attributes',NULL),(195,23,'Gift Options',10,0,'gift-options',NULL),(196,23,'Autosettings',9,0,'autosettings','advanced'),(197,23,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(198,23,'Design',7,0,'design','advanced'),(199,23,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(200,23,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(201,23,'Images',4,0,'image-management','basic'),(202,23,'Bundle Items',3,0,'bundle-items',NULL),(203,23,'Content',2,0,'content','basic'),(204,23,'General',1,1,'product-details','basic'),(205,24,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(206,24,'Attributes',11,0,'attributes',NULL),(207,24,'Gift Options',10,0,'gift-options',NULL),(208,24,'Autosettings',9,0,'autosettings','advanced'),(209,24,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(210,24,'Design',7,0,'design','advanced'),(211,24,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(212,24,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(213,24,'Images',4,0,'image-management','basic'),(214,24,'Bundle Items',3,0,'bundle-items',NULL),(215,24,'Content',2,0,'content','basic'),(216,24,'General',1,1,'product-details','basic'),(217,25,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(218,25,'Attributes',11,0,'attributes',NULL),(219,25,'Gift Options',10,0,'gift-options',NULL),(220,25,'Autosettings',9,0,'autosettings','advanced'),(221,25,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(222,25,'Design',7,0,'design','advanced'),(223,25,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(224,25,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(225,25,'Images',4,0,'image-management','basic'),(226,25,'Bundle Items',3,0,'bundle-items',NULL),(227,25,'Content',2,0,'content','basic'),(228,25,'General',1,1,'product-details','basic'),(229,26,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(230,26,'Attributes',11,0,'attributes',NULL),(231,26,'Gift Options',10,0,'gift-options',NULL),(232,26,'Autosettings',9,0,'autosettings','advanced'),(233,26,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(234,26,'Design',7,0,'design','advanced'),(235,26,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(236,26,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(237,26,'Images',4,0,'image-management','basic'),(238,26,'Bundle Items',3,0,'bundle-items',NULL),(239,26,'Content',2,0,'content','basic'),(240,26,'General',1,1,'product-details','basic'),(241,27,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(242,27,'Attributes',11,0,'attributes',NULL),(243,27,'Gift Options',10,0,'gift-options',NULL),(244,27,'Autosettings',9,0,'autosettings','advanced'),(245,27,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(246,27,'Design',7,0,'design','advanced'),(247,27,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(248,27,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(249,27,'Images',4,0,'image-management','basic'),(250,27,'Bundle Items',3,0,'bundle-items',NULL),(251,27,'Content',2,0,'content','basic'),(252,27,'General',1,1,'product-details','basic'),(253,28,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(254,28,'Attributes',11,0,'attributes',NULL),(255,28,'Gift Options',10,0,'gift-options',NULL),(256,28,'Autosettings',9,0,'autosettings','advanced'),(257,28,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(258,28,'Design',7,0,'design','advanced'),(259,28,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(260,28,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(261,28,'Images',4,0,'image-management','basic'),(262,28,'Bundle Items',3,0,'bundle-items',NULL),(263,28,'Content',2,0,'content','basic'),(264,28,'General',1,1,'product-details','basic'),(265,29,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(266,29,'Attributes',11,0,'attributes',NULL),(267,29,'Gift Options',10,0,'gift-options',NULL),(268,29,'Autosettings',9,0,'autosettings','advanced'),(269,29,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(270,29,'Design',7,0,'design','advanced'),(271,29,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(272,29,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(273,29,'Images',4,0,'image-management','basic'),(274,29,'Bundle Items',3,0,'bundle-items',NULL),(275,29,'Content',2,0,'content','basic'),(276,29,'General',1,1,'product-details','basic'),(277,30,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(278,30,'Attributes',11,0,'attributes',NULL),(279,30,'Gift Options',10,0,'gift-options',NULL),(280,30,'Autosettings',9,0,'autosettings','advanced'),(281,30,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(282,30,'Design',7,0,'design','advanced'),(283,30,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(284,30,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(285,30,'Images',4,0,'image-management','basic'),(286,30,'Bundle Items',3,0,'bundle-items',NULL),(287,30,'Content',2,0,'content','basic'),(288,30,'General',1,1,'product-details','basic'),(289,31,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(290,31,'Attributes',11,0,'attributes',NULL),(291,31,'Gift Options',10,0,'gift-options',NULL),(292,31,'Autosettings',9,0,'autosettings','advanced'),(293,31,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(294,31,'Design',7,0,'design','advanced'),(295,31,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(296,31,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(297,31,'Images',4,0,'image-management','basic'),(298,31,'Bundle Items',3,0,'bundle-items',NULL),(299,31,'Content',2,0,'content','basic'),(300,31,'General',1,1,'product-details','basic'),(301,32,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(302,32,'Attributes',11,0,'attributes',NULL),(303,32,'Gift Options',10,0,'gift-options',NULL),(304,32,'Autosettings',9,0,'autosettings','advanced'),(305,32,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(306,32,'Design',7,0,'design','advanced'),(307,32,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(308,32,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(309,32,'Images',4,0,'image-management','basic'),(310,32,'Bundle Items',3,0,'bundle-items',NULL),(311,32,'Content',2,0,'content','basic'),(312,32,'General',1,1,'product-details','basic'),(313,33,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(314,33,'Attributes',11,0,'attributes',NULL),(315,33,'Gift Options',10,0,'gift-options',NULL),(316,33,'Autosettings',9,0,'autosettings','advanced'),(317,33,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(318,33,'Design',7,0,'design','advanced'),(319,33,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(320,33,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(321,33,'Images',4,0,'image-management','basic'),(322,33,'Bundle Items',3,0,'bundle-items',NULL),(323,33,'Content',2,0,'content','basic'),(324,33,'General',1,1,'product-details','basic'),(325,34,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(326,34,'Attributes',11,0,'attributes',NULL),(327,34,'Gift Options',10,0,'gift-options',NULL),(328,34,'Autosettings',9,0,'autosettings','advanced'),(329,34,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(330,34,'Design',7,0,'design','advanced'),(331,34,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(332,34,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(333,34,'Images',4,0,'image-management','basic'),(334,34,'Bundle Items',3,0,'bundle-items',NULL),(335,34,'Content',2,0,'content','basic'),(336,34,'General',1,1,'product-details','basic'),(337,35,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(338,35,'Attributes',11,0,'attributes',NULL),(339,35,'Gift Options',10,0,'gift-options',NULL),(340,35,'Autosettings',9,0,'autosettings','advanced'),(341,35,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(342,35,'Design',7,0,'design','advanced'),(343,35,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(344,35,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(345,35,'Images',4,0,'image-management','basic'),(346,35,'Bundle Items',3,0,'bundle-items',NULL),(347,35,'Content',2,0,'content','basic'),(348,35,'General',1,1,'product-details','basic'),(349,36,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(350,36,'Attributes',11,0,'attributes',NULL),(351,36,'Gift Options',10,0,'gift-options',NULL),(352,36,'Autosettings',9,0,'autosettings','advanced'),(353,36,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(354,36,'Design',7,0,'design','advanced'),(355,36,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(356,36,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(357,36,'Images',4,0,'image-management','basic'),(358,36,'Bundle Items',3,0,'bundle-items',NULL),(359,36,'Content',2,0,'content','basic'),(360,36,'General',1,1,'product-details','basic'),(361,37,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(362,37,'Attributes',11,0,'attributes',NULL),(363,37,'Gift Options',10,0,'gift-options',NULL),(364,37,'Autosettings',9,0,'autosettings','advanced'),(365,37,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(366,37,'Design',7,0,'design','advanced'),(367,37,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(368,37,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(369,37,'Images',4,0,'image-management','basic'),(370,37,'Bundle Items',3,0,'bundle-items',NULL),(371,37,'Content',2,0,'content','basic'),(372,37,'General',1,1,'product-details','basic'),(373,38,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(374,38,'Attributes',11,0,'attributes',NULL),(375,38,'Gift Options',10,0,'gift-options',NULL),(376,38,'Autosettings',9,0,'autosettings','advanced'),(377,38,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(378,38,'Design',7,0,'design','advanced'),(379,38,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(380,38,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(381,38,'Images',4,0,'image-management','basic'),(382,38,'Bundle Items',3,0,'bundle-items',NULL),(383,38,'Content',2,0,'content','basic'),(384,38,'General',1,1,'product-details','basic'),(385,39,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(386,39,'Attributes',11,0,'attributes',NULL),(387,39,'Gift Options',10,0,'gift-options',NULL),(388,39,'Autosettings',9,0,'autosettings','advanced'),(389,39,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(390,39,'Design',7,0,'design','advanced'),(391,39,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(392,39,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(393,39,'Images',4,0,'image-management','basic'),(394,39,'Bundle Items',3,0,'bundle-items',NULL),(395,39,'Content',2,0,'content','basic'),(396,39,'General',1,1,'product-details','basic'),(397,40,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(398,40,'Attributes',11,0,'attributes',NULL),(399,40,'Gift Options',10,0,'gift-options',NULL),(400,40,'Autosettings',9,0,'autosettings','advanced'),(401,40,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(402,40,'Design',7,0,'design','advanced'),(403,40,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(404,40,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(405,40,'Images',4,0,'image-management','basic'),(406,40,'Bundle Items',3,0,'bundle-items',NULL),(407,40,'Content',2,0,'content','basic'),(408,40,'General',1,1,'product-details','basic'),(409,41,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(410,41,'Attributes',11,0,'attributes',NULL),(411,41,'Gift Options',10,0,'gift-options',NULL),(412,41,'Autosettings',9,0,'autosettings','advanced'),(413,41,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(414,41,'Design',7,0,'design','advanced'),(415,41,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(416,41,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(417,41,'Images',4,0,'image-management','basic'),(418,41,'Bundle Items',3,0,'bundle-items',NULL),(419,41,'Content',2,0,'content','basic'),(420,41,'General',1,1,'product-details','basic'),(421,42,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(422,42,'Attributes',11,0,'attributes',NULL),(423,42,'Gift Options',10,0,'gift-options',NULL),(424,42,'Autosettings',9,0,'autosettings','advanced'),(425,42,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(426,42,'Design',7,0,'design','advanced'),(427,42,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(428,42,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(429,42,'Images',4,0,'image-management','basic'),(430,42,'Bundle Items',3,0,'bundle-items',NULL),(431,42,'Content',2,0,'content','basic'),(432,42,'General',1,1,'product-details','basic'),(433,43,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(434,43,'Attributes',11,0,'attributes',NULL),(435,43,'Gift Options',10,0,'gift-options',NULL),(436,43,'Autosettings',9,0,'autosettings','advanced'),(437,43,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(438,43,'Design',7,0,'design','advanced'),(439,43,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(440,43,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(441,43,'Images',4,0,'image-management','basic'),(442,43,'Bundle Items',3,0,'bundle-items',NULL),(443,43,'Content',2,0,'content','basic'),(444,43,'General',1,1,'product-details','basic'),(445,44,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(446,44,'Attributes',11,0,'attributes',NULL),(447,44,'Gift Options',10,0,'gift-options',NULL),(448,44,'Autosettings',9,0,'autosettings','advanced'),(449,44,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(450,44,'Design',7,0,'design','advanced'),(451,44,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(452,44,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(453,44,'Images',4,0,'image-management','basic'),(454,44,'Bundle Items',3,0,'bundle-items',NULL),(455,44,'Content',2,0,'content','basic'),(456,44,'General',1,1,'product-details','basic'),(457,45,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(458,45,'Attributes',11,0,'attributes',NULL),(459,45,'Gift Options',10,0,'gift-options',NULL),(460,45,'Autosettings',9,0,'autosettings','advanced'),(461,45,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(462,45,'Design',7,0,'design','advanced'),(463,45,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(464,45,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(465,45,'Images',4,0,'image-management','basic'),(466,45,'Bundle Items',3,0,'bundle-items',NULL),(467,45,'Content',2,0,'content','basic'),(468,45,'General',1,1,'product-details','basic'),(469,46,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(470,46,'Attributes',11,0,'attributes',NULL),(471,46,'Gift Options',10,0,'gift-options',NULL),(472,46,'Autosettings',9,0,'autosettings','advanced'),(473,46,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(474,46,'Design',7,0,'design','advanced'),(475,46,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(476,46,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(477,46,'Images',4,0,'image-management','basic'),(478,46,'Bundle Items',3,0,'bundle-items',NULL),(479,46,'Content',2,0,'content','basic'),(480,46,'General',1,1,'product-details','basic'),(481,47,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(482,47,'Attributes',11,0,'attributes',NULL),(483,47,'Gift Options',10,0,'gift-options',NULL),(484,47,'Autosettings',9,0,'autosettings','advanced'),(485,47,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(486,47,'Design',7,0,'design','advanced'),(487,47,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(488,47,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(489,47,'Images',4,0,'image-management','basic'),(490,47,'Bundle Items',3,0,'bundle-items',NULL),(491,47,'Content',2,0,'content','basic'),(492,47,'General',1,1,'product-details','basic'),(493,48,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(494,48,'Attributes',11,0,'attributes',NULL),(495,48,'Gift Options',10,0,'gift-options',NULL),(496,48,'Autosettings',9,0,'autosettings','advanced'),(497,48,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(498,48,'Design',7,0,'design','advanced'),(499,48,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(500,48,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(501,48,'Images',4,0,'image-management','basic'),(502,48,'Bundle Items',3,0,'bundle-items',NULL),(503,48,'Content',2,0,'content','basic'),(504,48,'General',1,1,'product-details','basic'),(505,49,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(506,49,'Attributes',11,0,'attributes',NULL),(507,49,'Gift Options',10,0,'gift-options',NULL),(508,49,'Autosettings',9,0,'autosettings','advanced'),(509,49,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(510,49,'Design',7,0,'design','advanced'),(511,49,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(512,49,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(513,49,'Images',4,0,'image-management','basic'),(514,49,'Bundle Items',3,0,'bundle-items',NULL),(515,49,'Content',2,0,'content','basic'),(516,49,'General',1,1,'product-details','basic'),(517,50,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(518,50,'Attributes',11,0,'attributes',NULL),(519,50,'Gift Options',10,0,'gift-options',NULL),(520,50,'Autosettings',9,0,'autosettings','advanced'),(521,50,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(522,50,'Design',7,0,'design','advanced'),(523,50,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(524,50,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(525,50,'Images',4,0,'image-management','basic'),(526,50,'Bundle Items',3,0,'bundle-items',NULL),(527,50,'Content',2,0,'content','basic'),(528,50,'General',1,1,'product-details','basic'),(529,51,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(530,51,'Attributes',11,0,'attributes',NULL),(531,51,'Gift Options',10,0,'gift-options',NULL),(532,51,'Autosettings',9,0,'autosettings','advanced'),(533,51,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(534,51,'Design',7,0,'design','advanced'),(535,51,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(536,51,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(537,51,'Images',4,0,'image-management','basic'),(538,51,'Bundle Items',3,0,'bundle-items',NULL),(539,51,'Content',2,0,'content','basic'),(540,51,'General',1,1,'product-details','basic'),(541,52,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(542,52,'Attributes',11,0,'attributes',NULL),(543,52,'Gift Options',10,0,'gift-options',NULL),(544,52,'Autosettings',9,0,'autosettings','advanced'),(545,52,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(546,52,'Design',7,0,'design','advanced'),(547,52,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(548,52,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(549,52,'Images',4,0,'image-management','basic'),(550,52,'Bundle Items',3,0,'bundle-items',NULL),(551,52,'Content',2,0,'content','basic'),(552,52,'General',1,1,'product-details','basic'),(553,53,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(554,53,'Attributes',11,0,'attributes',NULL),(555,53,'Gift Options',10,0,'gift-options',NULL),(556,53,'Autosettings',9,0,'autosettings','advanced'),(557,53,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(558,53,'Design',7,0,'design','advanced'),(559,53,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(560,53,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(561,53,'Images',4,0,'image-management','basic'),(562,53,'Bundle Items',3,0,'bundle-items',NULL),(563,53,'Content',2,0,'content','basic'),(564,53,'General',1,1,'product-details','basic'),(565,54,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(566,54,'Attributes',11,0,'attributes',NULL),(567,54,'Gift Options',10,0,'gift-options',NULL),(568,54,'Autosettings',9,0,'autosettings','advanced'),(569,54,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(570,54,'Design',7,0,'design','advanced'),(571,54,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(572,54,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(573,54,'Images',4,0,'image-management','basic'),(574,54,'Bundle Items',3,0,'bundle-items',NULL),(575,54,'Content',2,0,'content','basic'),(576,54,'General',1,1,'product-details','basic'),(577,55,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(578,55,'Attributes',11,0,'attributes',NULL),(579,55,'Gift Options',10,0,'gift-options',NULL),(580,55,'Autosettings',9,0,'autosettings','advanced'),(581,55,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(582,55,'Design',7,0,'design','advanced'),(583,55,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(584,55,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(585,55,'Images',4,0,'image-management','basic'),(586,55,'Bundle Items',3,0,'bundle-items',NULL),(587,55,'Content',2,0,'content','basic'),(588,55,'General',1,1,'product-details','basic'),(589,56,'mageworx-dynamic-options',40,0,'mageworx-dynamic-options',NULL),(590,56,'Attributes',11,0,'attributes',NULL),(591,56,'Gift Options',10,0,'gift-options',NULL),(592,56,'Autosettings',9,0,'autosettings','advanced'),(593,56,'Schedule Design Update',8,0,'schedule-design-update','advanced'),(594,56,'Design',7,0,'design','advanced'),(595,56,'Advanced Pricing',6,0,'advanced-pricing','advanced'),(596,56,'Search Engine Optimization',5,0,'search-engine-optimization','basic'),(597,56,'Images',4,0,'image-management','basic'),(598,56,'Bundle Items',3,0,'bundle-items',NULL),(599,56,'Content',2,0,'content','basic'),(600,56,'General',1,1,'product-details','basic');
/*!40000 ALTER TABLE `eav_attribute_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_attribute_label`
--

DROP TABLE IF EXISTS `eav_attribute_label`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_attribute_label` (
  `attribute_label_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Attribute Label ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`attribute_label_id`),
  KEY `EAV_ATTRIBUTE_LABEL_STORE_ID` (`store_id`),
  KEY `EAV_ATTRIBUTE_LABEL_ATTRIBUTE_ID_STORE_ID` (`attribute_id`,`store_id`),
  CONSTRAINT `EAV_ATTRIBUTE_LABEL_ATTRIBUTE_ID_EAV_ATTRIBUTE_ATTRIBUTE_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_ATTRIBUTE_LABEL_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Eav Attribute Label';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_attribute_label`
--

LOCK TABLES `eav_attribute_label` WRITE;
/*!40000 ALTER TABLE `eav_attribute_label` DISABLE KEYS */;
/*!40000 ALTER TABLE `eav_attribute_label` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_attribute_option`
--

DROP TABLE IF EXISTS `eav_attribute_option`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_attribute_option` (
  `option_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `sort_order` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  PRIMARY KEY (`option_id`),
  KEY `EAV_ATTRIBUTE_OPTION_ATTRIBUTE_ID` (`attribute_id`),
  CONSTRAINT `EAV_ATTRIBUTE_OPTION_ATTRIBUTE_ID_EAV_ATTRIBUTE_ATTRIBUTE_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=451 DEFAULT CHARSET=utf8mb3 COMMENT='Eav Attribute Option';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_attribute_option`
--

LOCK TABLES `eav_attribute_option` WRITE;
/*!40000 ALTER TABLE `eav_attribute_option` DISABLE KEYS */;
INSERT INTO `eav_attribute_option` VALUES (1,20,0),(2,20,1),(3,20,3),(4,93,1),(5,93,2),(6,93,3),(7,164,1),(8,164,2),(9,164,3),(10,164,4),(11,164,5),(12,164,6),(13,164,7),(14,164,8),(15,164,9),(16,164,10),(17,164,11),(18,164,12),(19,164,13),(20,165,1),(21,165,2),(22,165,3),(23,165,4),(24,166,1),(25,166,2),(26,166,3),(27,166,4),(28,166,5),(29,166,6),(30,166,7),(31,166,8),(32,166,9),(33,166,10),(34,166,11),(35,166,12),(36,166,13),(37,166,14),(38,166,15),(39,166,16),(40,166,17),(41,166,18),(42,167,1),(43,167,2),(44,167,3),(45,167,4),(46,167,5),(47,167,6),(48,167,7),(49,167,8),(50,167,9),(51,167,10),(52,167,11),(53,167,12),(54,167,13),(55,167,14),(56,167,15),(57,167,16),(58,167,17),(59,167,18),(60,167,19),(61,167,20),(62,168,1),(63,168,2),(64,168,3),(65,168,4),(66,168,5),(67,168,6),(68,168,7),(69,168,8),(70,168,9),(71,168,10),(72,168,11),(73,168,12),(74,169,1),(75,169,2),(76,169,3),(77,169,4),(78,169,5),(79,170,1),(80,170,2),(81,170,3),(82,170,4),(83,170,5),(84,170,6),(85,170,7),(86,170,8),(87,170,9),(88,170,10),(89,170,11),(90,170,12),(91,170,13),(92,170,14),(93,170,15),(94,170,16),(95,170,17),(96,170,18),(97,170,19),(98,170,20),(99,170,21),(100,170,22),(101,170,23),(102,170,24),(103,170,25),(104,170,26),(105,170,27),(106,170,28),(107,170,29),(108,170,30),(109,170,31),(110,171,1),(111,171,2),(112,171,3),(113,171,4),(114,171,5),(115,172,1),(116,172,2),(117,172,3),(118,172,4),(119,173,1),(120,173,2),(121,173,3),(122,173,4),(123,173,5),(124,173,6),(125,173,7),(126,174,1),(127,174,2),(128,174,3),(129,174,4),(130,174,5),(131,174,6),(132,175,1),(133,175,2),(134,175,3),(135,175,4),(136,175,5),(137,175,6),(138,175,7),(139,175,8),(140,175,9),(141,175,10),(142,175,11),(143,176,1),(144,176,2),(145,176,3),(146,176,4),(147,176,5),(148,176,6),(149,176,7),(150,176,8),(151,176,9),(152,176,10),(153,176,11),(154,176,12),(155,176,13),(156,176,14),(157,176,15),(158,177,1),(159,177,2),(160,177,3),(161,177,4),(162,177,5),(163,177,6),(164,177,7),(165,177,8),(166,177,9),(167,177,10),(168,177,11),(169,178,1),(170,178,2),(171,178,3),(172,178,4),(173,179,1),(174,179,2),(175,179,3),(176,179,4),(177,180,1),(178,180,2),(179,180,3),(180,180,4),(181,180,5),(182,180,6),(183,180,7),(184,181,1),(185,181,2),(186,181,3),(187,181,4),(188,182,1),(189,182,2),(190,182,3),(191,182,4),(192,182,5),(193,182,6),(194,182,7),(195,183,1),(196,183,2),(197,183,3),(198,183,4),(199,183,5),(200,183,6),(201,183,7),(202,183,8),(203,184,1),(204,184,2),(205,184,3),(206,184,4),(207,184,5),(208,184,6),(209,184,7),(210,184,8),(211,184,9),(212,184,10),(213,184,11),(214,184,12),(215,184,13),(216,184,14),(217,184,15),(218,184,16),(219,184,17),(220,184,18),(221,184,19),(222,184,20),(223,184,21),(224,185,1),(225,185,2),(226,185,3),(227,185,4),(228,185,5),(229,185,6),(230,186,1),(231,186,2),(232,186,3),(233,186,4),(234,186,5),(235,186,6),(236,186,7),(237,186,8),(238,186,9),(239,186,10),(240,186,11),(241,186,12),(242,186,13),(243,186,14),(244,186,15),(245,186,16),(246,186,17),(247,186,18),(248,186,19),(249,186,20),(250,186,21),(251,186,22),(252,186,23),(253,186,24),(254,186,25),(255,186,26),(256,186,27),(257,186,28),(258,186,29),(259,186,30),(260,186,31),(261,186,32),(262,186,33),(263,186,34),(264,186,35),(265,186,36),(266,186,37),(267,186,38),(268,186,39),(269,187,1),(270,187,2),(271,188,1),(272,188,2),(273,188,3),(274,188,4),(275,188,5),(276,188,6),(277,188,7),(278,189,1),(279,189,2),(280,189,3),(281,189,4),(282,189,5),(283,189,6),(284,189,7),(285,190,1),(286,190,2),(287,190,3),(288,190,4),(289,190,5),(290,190,6),(291,190,7),(292,190,8),(293,190,9),(294,190,10),(295,190,11),(296,190,12),(297,190,13),(298,190,14),(299,190,15),(300,190,16),(301,190,17),(302,190,18),(303,190,19),(304,190,20),(305,190,21),(306,190,22),(307,190,23),(308,190,24),(309,190,25),(310,190,26),(311,190,27),(312,190,28),(313,190,29),(314,190,30),(315,190,31),(316,191,1),(317,191,2),(318,191,3),(319,191,4),(320,191,5),(321,192,1),(322,192,2),(323,192,3),(324,192,4),(325,192,5),(326,192,6),(327,192,7),(328,192,8),(329,193,1),(330,193,2),(331,193,3),(332,193,4),(333,193,5),(334,193,6),(335,193,7),(336,193,8),(337,193,9),(338,194,1),(339,194,2),(340,194,3),(341,194,4),(342,194,5),(343,194,6),(344,194,7),(345,194,8),(346,194,9),(347,194,10),(348,194,11),(349,194,12),(350,194,13),(351,194,14),(352,195,1),(353,195,2),(354,195,3),(355,195,4),(356,195,5),(357,195,6),(358,195,7),(359,195,8),(360,195,9),(361,195,10),(362,195,11),(363,195,12),(364,195,13),(365,195,14),(366,196,1),(367,196,2),(368,196,3),(369,197,1),(370,197,2),(371,197,3),(372,197,4),(373,197,5),(374,197,6),(375,197,7),(376,197,8),(377,197,9),(378,197,10),(379,197,11),(380,197,12),(381,198,1),(382,198,2),(383,199,1),(384,199,2),(385,199,3),(386,199,4),(387,199,5),(388,199,6),(389,200,1),(390,200,2),(391,200,3),(392,200,4),(393,200,5),(394,201,1),(395,201,2),(396,201,3),(397,201,4),(398,201,5),(399,201,6),(400,201,7),(401,201,8),(402,201,9),(403,201,10),(404,202,1),(405,202,2),(406,202,3),(407,202,4),(408,203,1),(409,203,2),(410,203,3),(411,203,4),(412,203,5),(413,203,6),(414,203,7),(415,203,8),(416,203,9),(417,203,10),(418,203,11),(419,204,1),(420,204,2),(421,204,3),(422,204,4),(423,204,5),(424,204,6),(425,204,7),(426,204,8),(427,204,9),(428,204,10),(429,205,1),(430,205,2),(431,206,1),(432,206,2),(433,206,3),(434,206,4),(435,206,5),(436,206,6),(437,206,7),(438,206,8),(439,206,9),(440,206,10),(441,206,11),(442,207,1),(443,207,2),(444,207,3),(445,207,4),(446,207,5),(447,207,6),(448,207,7),(449,207,8),(450,207,9);
/*!40000 ALTER TABLE `eav_attribute_option` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_attribute_option_swatch`
--

DROP TABLE IF EXISTS `eav_attribute_option_swatch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_attribute_option_swatch` (
  `swatch_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Swatch ID',
  `option_id` int unsigned NOT NULL COMMENT 'Option ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `type` smallint unsigned NOT NULL COMMENT 'Swatch type: 0 - text, 1 - visual color, 2 - visual image',
  `value` varchar(255) DEFAULT NULL COMMENT 'Swatch Value',
  PRIMARY KEY (`swatch_id`),
  UNIQUE KEY `EAV_ATTRIBUTE_OPTION_SWATCH_STORE_ID_OPTION_ID` (`store_id`,`option_id`),
  KEY `EAV_ATTR_OPT_SWATCH_OPT_ID_EAV_ATTR_OPT_OPT_ID` (`option_id`),
  KEY `EAV_ATTRIBUTE_OPTION_SWATCH_SWATCH_ID` (`swatch_id`),
  CONSTRAINT `EAV_ATTR_OPT_SWATCH_OPT_ID_EAV_ATTR_OPT_OPT_ID` FOREIGN KEY (`option_id`) REFERENCES `eav_attribute_option` (`option_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_ATTRIBUTE_OPTION_SWATCH_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COMMENT='Magento Swatches table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_attribute_option_swatch`
--

LOCK TABLES `eav_attribute_option_swatch` WRITE;
/*!40000 ALTER TABLE `eav_attribute_option_swatch` DISABLE KEYS */;
INSERT INTO `eav_attribute_option_swatch` VALUES (1,4,0,1,'#e61912'),(2,5,0,1,'#000000'),(3,6,0,1,'#43bd33');
/*!40000 ALTER TABLE `eav_attribute_option_swatch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_attribute_option_value`
--

DROP TABLE IF EXISTS `eav_attribute_option_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_attribute_option_value` (
  `value_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `option_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value',
  PRIMARY KEY (`value_id`),
  KEY `EAV_ATTRIBUTE_OPTION_VALUE_OPTION_ID` (`option_id`),
  KEY `EAV_ATTRIBUTE_OPTION_VALUE_STORE_ID` (`store_id`),
  CONSTRAINT `EAV_ATTR_OPT_VAL_OPT_ID_EAV_ATTR_OPT_OPT_ID` FOREIGN KEY (`option_id`) REFERENCES `eav_attribute_option` (`option_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_ATTRIBUTE_OPTION_VALUE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=454 DEFAULT CHARSET=utf8mb3 COMMENT='Eav Attribute Option Value';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_attribute_option_value`
--

LOCK TABLES `eav_attribute_option_value` WRITE;
/*!40000 ALTER TABLE `eav_attribute_option_value` DISABLE KEYS */;
INSERT INTO `eav_attribute_option_value` VALUES (1,1,0,'Male'),(2,2,0,'Female'),(3,3,0,'Not Specified'),(7,4,0,'Red'),(8,5,0,'black'),(9,6,0,'green'),(10,7,0,'0.1'),(11,8,0,'0.2'),(12,9,0,'0.3'),(13,10,0,'1'),(14,11,0,'2'),(15,12,0,'3'),(16,13,0,'4'),(17,14,0,'5'),(18,15,0,'6'),(19,16,0,'0.5'),(20,17,0,'0.8'),(21,18,0,'1.5'),(22,19,0,'1.8'),(23,20,0,'Deals'),(24,21,0,'Clearance'),(25,22,0,'Best Sellers'),(26,23,0,'Popular Ranges'),(27,24,0,'1000mm'),(28,25,0,'1200mm'),(29,26,0,'200mm'),(30,27,0,'300mm'),(31,28,0,'365mm'),(32,29,0,'400mm'),(33,30,0,'450mm'),(34,31,0,'500mm'),(35,32,0,'550mm'),(36,33,0,'600mm'),(37,34,0,'700mm'),(38,35,0,'800mm'),(39,36,0,'900mm'),(40,37,0,'1000mm & Above'),(41,38,0,'370mm'),(42,39,0,'340mm'),(43,40,0,'595mm'),(44,41,0,'470mm'),(45,42,0,'Acrylic'),(46,43,0,'Aluminium'),(47,44,0,'Cast Iron'),(48,45,0,'Ceramic'),(49,46,0,'Fragranite'),(50,47,0,'Idealform'),(51,48,0,'Idealform Plus'),(52,49,0,'Lithocast'),(53,50,0,'Sentec'),(54,51,0,'Silgranit'),(55,52,0,'Silver Metallic Lacquer '),(56,53,0,'Solid Surface'),(57,54,0,'Stainless Steel'),(58,55,0,'Steel'),(59,56,0,'Super Steel'),(60,57,0,'Tectonite'),(61,58,0,'Vitreous China'),(62,59,0,'Sentec Solid Surface'),(63,60,0,'Cian solid surface'),(64,61,0,'Granite'),(65,62,0,'Inset Sinks'),(66,63,0,'Drop In Sinks'),(67,64,0,'Drop-on Sinks'),(68,65,0,'Undermount Sinks'),(69,66,0,'Flushmount Sinks'),(70,67,0,'Slim-top Sinks'),(71,68,0,'Corner Sinks'),(72,69,0,'Deck Mounted'),(73,70,0,'Floor Standing'),(74,71,0,'Wall Mounted'),(75,72,0,'Fully integrated'),(76,73,0,'Semi Integrated'),(77,74,0,'Half Bowl'),(78,75,0,'Single Bowl'),(79,76,0,'Double Bowl'),(80,77,0,'1&1/2 Bowl'),(81,78,0,'2&1/2 Bowl'),(82,79,0,'Toilets'),(83,80,0,'Urinal'),(84,81,0,'Bidets'),(85,82,0,'Basins'),(86,83,0,'Bathroom Suites'),(87,84,0,'Furniture'),(88,85,0,'Baths'),(89,86,0,'Mirrors'),(90,87,0,'Mirror Cabinets'),(91,88,0,'Shower Doors'),(92,89,0,'Shower Enclosures'),(93,90,0,'Quadrant'),(94,91,0,'Wetroom Panles'),(95,92,0,'Shower Trays'),(96,93,0,'Shower Valves'),(97,94,0,'Radiators'),(98,95,0,'Kitchen Sinks'),(99,96,0,'Kitchen Taps'),(100,97,0,'Bath Screens'),(101,98,0,'Complete Showers'),(102,99,0,'Shower Panels'),(103,100,0,'Concealed Cisterns'),(104,101,0,'Bathroom Taps'),(105,102,0,'Bathroom Fans'),(106,103,0,'Frames'),(107,104,0,'Plates'),(108,105,0,'Lights'),(109,106,0,'Enclosure Side panels'),(110,107,0,'PVC Panels'),(111,108,0,'Accessories'),(112,109,0,'Toilet Seats'),(113,110,0,'Upto 1599'),(114,111,0,'1600 - 1699'),(115,112,0,'1700 - 1799'),(116,113,0,'1800 - 1899'),(117,114,0,'1900 & Above'),(118,115,0,'Double Ended'),(119,116,0,'Rectangular'),(120,117,0,'Single Ended'),(121,118,0,'Foot Ended'),(122,119,0,'Corner'),(123,120,0,'Free Standing'),(124,121,0,'Oval'),(125,122,0,'Rectangular'),(126,123,0,'Shower Baths'),(127,124,0,'Traditional'),(128,125,0,'Whirlpool'),(129,126,0,'5 mm'),(130,127,0,'6 mm'),(131,128,0,'8 mm'),(132,129,0,'4 mm'),(133,130,0,'7 mm'),(134,131,0,'10 mm'),(135,132,0,'2 Hole Taps'),(136,133,0,'4 Hole Taps'),(137,134,0,'3 Hole Taps'),(138,135,0,'5 Hole Taps'),(139,136,0,'Single Lever'),(140,137,0,'Double Lever'),(141,138,0,'Double Handle'),(142,139,0,'Cross Head'),(143,140,0,'Traditional'),(144,141,0,'Push Button'),(145,142,0,'Sensor Taps'),(146,143,0,'Bath Mixer Taps'),(147,144,0,'Bath Spouts'),(148,145,0,'Deck Mounted'),(149,146,0,'Filter Flow Taps'),(150,147,0,'Free Standing'),(151,148,0,'Spray Taps'),(152,149,0,'Swivel Spout Taps'),(153,150,0,'Wall Mounted'),(154,151,0,'Bath / Shower Mixer Taps'),(155,152,0,'Hot and Cold Taps'),(156,153,0,'Bath Fillers'),(157,154,0,'Floor Standing Taps'),(158,155,0,'Bath Shower Mixers'),(159,156,0,'Bath Shower Mixers With Kit'),(160,157,0,'Pull Out Taps'),(161,158,0,'0-399'),(162,159,0,'400-499'),(163,160,0,'500-599'),(164,161,0,'600-699'),(165,162,0,'700-799'),(166,163,0,'800-899'),(167,164,0,'900-999'),(168,165,0,'1000-1099'),(169,166,0,'1100-1199'),(170,167,0,'1200-1299'),(171,168,0,'1300-1399'),(172,169,0,'0-499'),(173,170,0,'500-549'),(174,171,0,'550-599'),(175,172,0,'600-649'),(176,173,0,'Chain Pull'),(177,174,0,'Lever'),(178,175,0,'Push Button'),(179,176,0,'Rimless'),(180,177,0,'0-399'),(181,178,0,'400-499'),(182,179,0,'500-549'),(183,180,0,'550-599'),(184,181,0,'600-649'),(185,182,0,'650-699'),(186,183,0,'700-799'),(187,184,0,'Modern'),(188,185,0,'Traditional'),(189,186,0,'Special Needs'),(190,187,0,'Rimless'),(191,188,0,'0-499'),(192,189,0,'500-549'),(193,190,0,'550-599'),(194,191,0,'600-649'),(195,192,0,'650-699'),(196,193,0,'700-799'),(197,194,0,'800-899'),(198,195,0,'0-399'),(199,196,0,'400-499'),(200,197,0,'500-549'),(201,198,0,'550-599'),(202,199,0,'600-649'),(203,200,0,'650-699'),(204,201,0,'700-799'),(205,202,0,'800 & Above'),(206,203,0,'Inset sinks'),(207,204,0,'Drop In sinks'),(208,205,0,'Drop-on sinks'),(209,206,0,'Top-mounted sinks'),(210,207,0,'Slim-top sinks'),(211,208,0,'Flushmount sinks'),(212,209,0,'Undermount sinks'),(213,210,0,'Belfast sinks'),(214,211,0,'Corner Sinks'),(215,212,0,'Sink modules'),(216,213,0,'Sit-on'),(217,214,0,'Flush fit sinks'),(218,215,0,'Floor Standing'),(219,216,0,'Back To Wall'),(220,217,0,'Close Coupled'),(221,218,0,'Wall Hung'),(222,219,0,'Ceiling'),(223,220,0,'Wall Mounted'),(224,221,0,'Deck Mounted'),(225,222,0,'Free Standing Taps'),(226,223,0,'Digital Taps'),(227,224,0,'Central Heating'),(228,225,0,'Gas'),(229,226,0,'Electric'),(230,227,0,'Wood'),(231,228,0,'Multi-Fuel'),(232,229,0,'Dual Fuel'),(233,230,0,'Black'),(234,231,0,'Black Glass'),(235,232,0,'High Gloss Black'),(236,233,0,'Matt Black'),(237,234,0,'Anthracite'),(238,235,0,'Textured Anthracite'),(239,236,0,'Textured Metallic Dark Grey'),(240,237,0,'White'),(241,238,0,'Chrome'),(242,239,0,'Polished'),(243,240,0,'Brushed'),(244,241,0,'Brushed Steel'),(245,242,0,'Aluminium Brushed'),(246,243,0,'Stainless Steel'),(247,244,0,'Silver'),(248,245,0,'Satin'),(249,246,0,'Grey'),(250,247,0,'Titane'),(251,248,0,'Volcanic'),(252,249,0,'High Gloss Silver'),(253,250,0,'Anodised Aluminium'),(254,251,0,'Beige Quartz'),(255,252,0,'Brown Quartz'),(256,253,0,'Champagne'),(257,254,0,'Etched Brass'),(258,255,0,'Etched Copper'),(259,256,0,'Marron'),(260,257,0,'Matt Anodised'),(261,258,0,'Mirror'),(262,259,0,'Polished Anodised'),(263,260,0,'Red'),(264,261,0,'Black Enamel'),(265,262,0,'White Enamel'),(266,263,0,'Inox Easyclean'),(267,264,0,'SS Trim'),(268,265,0,'Colour'),(269,266,0,'Black with Steel Trim'),(270,267,0,'White with Steel Trim'),(271,268,0,'Matt Copper'),(272,269,0,'Built in'),(273,270,0,'Built under'),(274,271,0,'Single Ovens'),(275,272,0,'Double Ovens'),(276,273,0,'Compact Ovens'),(277,274,0,'Steam Ovens'),(278,275,0,'Slide & Hide Ovens'),(279,276,0,'Microwave Ovens'),(280,277,0,'Compact Microwave Ovens'),(281,278,0,'Easyclean'),(282,279,0,'Active Clean'),(283,280,0,'EcoClean'),(284,281,0,'Pyrolytic'),(285,282,0,'Hydrolytic'),(286,283,0,'Enamel Coating'),(287,284,0,'Easy Clean Enamel'),(288,285,0,'140mm'),(289,286,0,'290mm'),(290,287,0,'300mm'),(291,288,0,'Upto 300mm'),(292,289,0,'370mm'),(293,290,0,'396mm'),(294,291,0,'400mm'),(295,292,0,'450mm'),(296,293,0,'1000mm'),(297,294,0,'1200mm'),(298,295,0,'1400mm'),(299,296,0,'1700mm'),(300,297,0,'500mm'),(301,298,0,'520mm'),(302,299,0,'530mm'),(303,300,0,'550mm'),(304,301,0,'580mm'),(305,302,0,'590mm'),(306,303,0,'600mm'),(307,304,0,'700mm'),(308,305,0,'750mm'),(309,306,0,'800mm'),(310,307,0,'830mm'),(311,308,0,'850mm'),(312,309,0,'870mm'),(313,310,0,'890mm'),(314,311,0,'900mm'),(315,312,0,'122/54'),(316,313,0,'177/54'),(317,314,0,'176/91'),(318,315,0,'102/54'),(319,316,0,'1 or 2'),(320,317,0,'3'),(321,318,0,'4'),(322,319,0,'5'),(323,320,0,'6'),(324,321,0,'Ceiling Hoods'),(325,322,0,'Telescopic Hoods'),(326,323,0,'Canopy Hoods'),(327,324,0,'Integrated Hoods'),(328,325,0,'Chimney Hoods'),(329,326,0,'Downdrafts'),(330,327,0,'Island Hoods'),(331,328,0,'Steam Hoods'),(332,329,0,'Gas Hobs'),(333,330,0,'Gas on Glass'),(334,331,0,'Ceramic Hobs'),(335,332,0,'Induction Hobs'),(336,333,0,'Flex Induction Hobs'),(337,334,0,'Venting Hobs'),(338,335,0,'Domino Hobs'),(339,336,0,'Teppan Yaki'),(340,337,0,'Sealed Plate Electric Hobs'),(341,338,0,'Upto 400mm'),(342,339,0,'500mm'),(343,340,0,'600mm'),(344,341,0,'650mm'),(345,342,0,'700mm'),(346,343,0,'750mm'),(347,344,0,'800mm'),(348,345,0,'850mm'),(349,346,0,'900mm'),(350,347,0,'1000mm'),(351,348,0,'1100mm'),(352,349,0,'1200mm'),(353,350,0,'1600mm'),(354,351,0,'1800mm'),(355,352,0,'200 - 299mm'),(356,353,0,'300 - 399mm'),(357,354,0,'400 - 499mm'),(358,355,0,'500 - 599mm'),(359,356,0,'600 - 699mm'),(360,357,0,'700 - 799mm'),(361,358,0,'800 - 899mm'),(362,359,0,'900 - 999mm'),(363,360,0,'1000 - 1099mm'),(364,361,0,'1100 - 1199mm'),(365,362,0,'1200 - 1299mm'),(366,363,0,'1300 - 1399mm'),(367,364,0,'1400 - 1499mm'),(368,365,0,'1500 & Above'),(369,366,0,'Conventional Flue Fires'),(370,367,0,'Balanced Flue Fires'),(371,368,0,'Flueless Fires'),(372,369,0,'Front View Fires'),(373,370,0,'2 Sided Fires'),(374,371,0,'3 Sided Fires'),(375,372,0,'Tunnel Fires'),(376,373,0,'Modern Fires'),(377,374,0,'Traditional Fires'),(378,375,0,'Stoves'),(379,376,0,'Inset Fires'),(380,377,0,'Outset Fires'),(381,378,0,'Wall mounted Fires'),(382,379,0,'Corner Fires'),(383,380,0,'Free Standing Fires'),(384,381,0,'Glass Fronted'),(385,382,0,'Open Fronted'),(386,383,0,'Built in Fridges'),(387,384,0,'Built under Fridges'),(388,385,0,'Built in Freezers'),(389,386,0,'Built under Freezer'),(390,387,0,'Built in Fridge Freezers'),(391,388,0,'American Style Fridge Freezers'),(392,389,0,'50/50'),(393,390,0,'70/30'),(394,391,0,'60/40'),(395,392,0,'Icebox'),(396,393,0,'Larder'),(397,394,0,'71 cm'),(398,395,0,'82 cm'),(399,396,0,'87 cm'),(400,397,0,'88 cm'),(401,398,0,'102 cm'),(402,399,0,'122 cm'),(403,400,0,'140 cm'),(404,401,0,'144 cm'),(405,402,0,'177 cm'),(406,403,0,'193.5 cm'),(407,404,0,'Automatic Defrost'),(408,405,0,'Manual Defrost'),(409,406,0,'Frost Free'),(410,407,0,'Low Frost'),(411,408,0,'200-299mm'),(412,409,0,'300-399mm'),(413,410,0,'400-499mm'),(414,411,0,'500-599mm'),(415,412,0,'600-699mm'),(416,413,0,'700-799mm'),(417,414,0,'800-899mm'),(418,415,0,'900-999mm'),(419,416,0,'1000-1099mm'),(420,417,0,'1100-1199mm'),(421,418,0,'1200 & Above'),(422,419,0,'2 Column'),(423,420,0,'3 Column'),(424,421,0,'4 Column'),(425,422,0,'6 Column'),(426,423,0,'Single Panel'),(427,424,0,'Double Panel'),(428,425,0,'Vertical'),(429,426,0,'Horizontal'),(430,427,0,'Straight'),(431,428,0,'Curved'),(432,429,0,'Modern'),(433,430,0,'Traditional'),(434,431,0,'0 - 999 BTU'),(435,432,0,'1000 - 1999 BTU'),(436,433,0,'2000 - 2999 BTU'),(437,434,0,'3000 - 3999 BTU'),(438,435,0,'4000 - 4999 BTU'),(439,436,0,'5000 - 5999 BTU'),(440,437,0,'6000 - 6999 BTU'),(441,438,0,'7000 - 7999 BTU'),(442,439,0,'8000 - 8999 BTU'),(443,440,0,'9000 - 9999 BTU'),(444,441,0,'10000 & Above'),(445,442,0,'0 - 399mm'),(446,443,0,'400 - 499mm'),(447,444,0,'500 - 599mm'),(448,445,0,'600 - 799mm'),(449,446,0,'800 - 999mm'),(450,447,0,'1000 - 1299mm'),(451,448,0,'1300 - 1599mm'),(452,449,0,'1600 - 1799mm'),(453,450,0,'1800 & above');
/*!40000 ALTER TABLE `eav_attribute_option_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_attribute_set`
--

DROP TABLE IF EXISTS `eav_attribute_set`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_attribute_set` (
  `attribute_set_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Attribute Set ID',
  `entity_type_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_set_name` varchar(255) DEFAULT NULL COMMENT 'Attribute Set Name',
  `sort_order` smallint NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  PRIMARY KEY (`attribute_set_id`),
  UNIQUE KEY `EAV_ATTRIBUTE_SET_ENTITY_TYPE_ID_ATTRIBUTE_SET_NAME` (`entity_type_id`,`attribute_set_name`),
  KEY `EAV_ATTRIBUTE_SET_ENTITY_TYPE_ID_SORT_ORDER` (`entity_type_id`,`sort_order`),
  CONSTRAINT `EAV_ATTRIBUTE_SET_ENTITY_TYPE_ID_EAV_ENTITY_TYPE_ENTITY_TYPE_ID` FOREIGN KEY (`entity_type_id`) REFERENCES `eav_entity_type` (`entity_type_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=57 DEFAULT CHARSET=utf8mb3 COMMENT='Eav Attribute Set';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_attribute_set`
--

LOCK TABLES `eav_attribute_set` WRITE;
/*!40000 ALTER TABLE `eav_attribute_set` DISABLE KEYS */;
INSERT INTO `eav_attribute_set` VALUES (1,1,'Default',2),(2,2,'Default',2),(3,3,'Default',1),(4,4,'Default',1),(5,5,'Default',1),(6,6,'Default',1),(7,7,'Default',1),(8,8,'Default',1),(9,4,'Basin Taps',0),(10,4,'Basins',0),(11,4,'Kitchen Sinks',0),(14,4,'Bath Accessories',0),(15,4,'Bath Screen',0),(16,4,'Bath Taps',0),(17,4,'Bathroom Accessories',0),(18,4,'Bathroom Fans',0),(19,4,'Baths',0),(20,4,'Bidet Taps',0),(21,4,'Bidets',0),(22,4,'Coffee Machines',0),(23,4,'Complete Showers',0),(24,4,'Concealed Cisterns',0),(25,4,'Dishwashers',0),(26,4,'Enclosure Side panels',0),(27,4,'Enclosures & doors',0),(28,4,'Fire Accessories',0),(29,4,'Fires',0),(30,4,'Frames',0),(31,4,'Fridge Freezers',0),(32,4,'Furniture',0),(33,4,'Gas Heaters',0),(34,4,'Heating',0),(35,4,'Heating Accessories',0),(36,4,'Hobs',0),(37,4,'Hoods',0),(38,4,'Kitchen Accessories',0),(39,4,'Kitchen Taps',0),(40,4,'Lights',0),(41,4,'Mirror Cabinets',0),(42,4,'Mirrors',0),(43,4,'Ovens',0),(44,4,'Panel Accessories',0),(45,4,'Plates',0),(46,4,'PVC Panels',0),(47,4,'Shower Accessories',0),(48,4,'Shower panels',0),(49,4,'Shower Trays',0),(50,4,'Shower Valves',0),(51,4,'Stove',0),(52,4,'Toilets',0),(53,4,'Warming  Drawers',0),(54,4,'Washing & dryers',0),(55,4,'Wetroom Panel',0),(56,4,'Wine Cooler',0);
/*!40000 ALTER TABLE `eav_attribute_set` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_entity`
--

DROP TABLE IF EXISTS `eav_entity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_entity` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `entity_type_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_set_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Set ID',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment ID',
  `parent_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Parent ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `is_active` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Defines Is Entity Active',
  PRIMARY KEY (`entity_id`),
  KEY `EAV_ENTITY_ENTITY_TYPE_ID` (`entity_type_id`),
  KEY `EAV_ENTITY_STORE_ID` (`store_id`),
  CONSTRAINT `EAV_ENTITY_ENTITY_TYPE_ID_EAV_ENTITY_TYPE_ENTITY_TYPE_ID` FOREIGN KEY (`entity_type_id`) REFERENCES `eav_entity_type` (`entity_type_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_ENTITY_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Eav Entity';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_entity`
--

LOCK TABLES `eav_entity` WRITE;
/*!40000 ALTER TABLE `eav_entity` DISABLE KEYS */;
/*!40000 ALTER TABLE `eav_entity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_entity_attribute`
--

DROP TABLE IF EXISTS `eav_entity_attribute`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_entity_attribute` (
  `entity_attribute_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Attribute ID',
  `entity_type_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_set_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Set ID',
  `attribute_group_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Group ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `sort_order` smallint NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  PRIMARY KEY (`entity_attribute_id`),
  UNIQUE KEY `EAV_ENTITY_ATTRIBUTE_ATTRIBUTE_SET_ID_ATTRIBUTE_ID` (`attribute_set_id`,`attribute_id`),
  UNIQUE KEY `EAV_ENTITY_ATTRIBUTE_ATTRIBUTE_GROUP_ID_ATTRIBUTE_ID` (`attribute_group_id`,`attribute_id`),
  KEY `EAV_ENTITY_ATTRIBUTE_ATTRIBUTE_SET_ID_SORT_ORDER` (`attribute_set_id`,`sort_order`),
  KEY `EAV_ENTITY_ATTRIBUTE_ATTRIBUTE_ID` (`attribute_id`),
  CONSTRAINT `EAV_ENTITY_ATTRIBUTE_ATTRIBUTE_ID_EAV_ATTRIBUTE_ATTRIBUTE_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_ENTT_ATTR_ATTR_GROUP_ID_EAV_ATTR_GROUP_ATTR_GROUP_ID` FOREIGN KEY (`attribute_group_id`) REFERENCES `eav_attribute_group` (`attribute_group_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=4086 DEFAULT CHARSET=utf8mb3 COMMENT='Eav Entity Attributes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_entity_attribute`
--

LOCK TABLES `eav_entity_attribute` WRITE;
/*!40000 ALTER TABLE `eav_entity_attribute` DISABLE KEYS */;
INSERT INTO `eav_entity_attribute` VALUES (1,1,1,1,1,10),(2,1,1,1,2,20),(3,1,1,1,3,20),(4,1,1,1,4,30),(5,1,1,1,5,40),(6,1,1,1,6,50),(7,1,1,1,7,60),(8,1,1,1,8,70),(9,1,1,1,9,80),(10,1,1,1,10,25),(11,1,1,1,11,90),(12,1,1,1,12,81),(13,1,1,1,13,115),(14,1,1,1,14,120),(15,1,1,1,15,82),(16,1,1,1,16,83),(17,1,1,1,17,100),(18,1,1,1,18,0),(19,1,1,1,19,0),(20,1,1,1,20,110),(21,1,1,1,21,28),(22,2,2,2,22,10),(23,2,2,2,23,20),(24,2,2,2,24,30),(25,2,2,2,25,40),(26,2,2,2,26,50),(27,2,2,2,27,60),(28,2,2,2,28,70),(29,2,2,2,29,100),(30,2,2,2,30,80),(31,2,2,2,31,90),(32,2,2,2,32,90),(33,2,2,2,33,110),(34,2,2,2,34,120),(35,2,2,2,35,130),(36,2,2,2,36,140),(37,2,2,2,37,132),(38,2,2,2,38,133),(39,2,2,2,39,134),(40,2,2,2,40,135),(41,1,1,1,41,87),(42,1,1,1,42,100),(43,1,1,1,43,110),(44,1,1,1,44,120),(45,3,3,4,45,1),(46,3,3,4,46,2),(47,3,3,4,47,4),(48,3,3,4,48,5),(49,3,3,4,49,6),(50,3,3,4,50,7),(51,3,3,4,51,8),(52,3,3,5,52,10),(53,3,3,5,53,20),(54,3,3,5,54,30),(55,3,3,4,55,12),(56,3,3,4,56,13),(57,3,3,4,57,14),(58,3,3,4,58,15),(59,3,3,4,59,16),(60,3,3,6,60,10),(61,3,3,6,61,30),(62,3,3,6,62,40),(63,3,3,6,63,50),(64,3,3,6,64,60),(65,3,3,4,65,24),(66,3,3,4,66,25),(67,3,3,5,67,40),(68,3,3,5,68,50),(69,3,3,4,69,10),(70,3,3,6,70,5),(71,3,3,6,71,6),(72,3,3,5,72,51),(90,4,4,7,91,6),(96,4,4,8,98,8),(101,4,4,11,103,10),(105,4,4,7,107,14),(106,4,4,7,108,15),(107,4,4,7,109,16),(108,4,4,7,110,17),(109,4,4,7,111,18),(110,4,4,7,112,19),(111,4,4,7,113,20),(116,3,3,6,118,51),(117,3,3,4,119,3),(118,3,3,4,120,17),(120,4,4,7,122,11),(123,4,4,7,125,111),(124,4,4,7,126,112),(125,4,4,7,127,113),(126,4,4,7,128,114),(135,3,3,21,137,100),(136,3,3,21,138,110),(137,3,3,21,139,120),(253,3,3,3,151,1),(254,4,4,7,73,2),(255,4,4,7,74,3),(256,4,4,7,77,5),(257,4,4,7,82,9),(258,4,4,7,93,23),(259,4,4,7,94,13),(260,4,4,7,95,14),(261,4,4,7,97,1),(262,4,4,7,99,11),(263,4,4,7,105,12),(264,4,4,7,114,22),(265,4,4,7,115,8),(266,4,4,7,129,6),(267,4,4,7,130,4),(268,4,4,7,131,10),(269,4,4,7,136,7),(270,4,4,7,140,15),(271,4,4,7,141,19),(272,4,4,7,142,16),(273,4,4,7,143,17),(274,4,4,7,144,18),(275,4,4,7,147,20),(276,4,4,7,148,24),(277,4,4,7,149,25),(278,4,4,7,150,26),(279,4,4,7,152,21),(280,4,4,13,75,2),(281,4,4,13,76,1),(282,4,4,13,145,3),(283,4,4,13,146,4),(284,4,4,19,133,1),(285,4,4,10,87,1),(286,4,4,10,88,2),(287,4,4,10,89,3),(288,4,4,10,90,5),(289,4,4,10,96,6),(290,4,4,10,135,4),(291,4,4,9,84,2),(292,4,4,9,85,3),(293,4,4,9,86,4),(294,4,4,9,121,1),(295,4,4,8,78,1),(296,4,4,8,79,2),(297,4,4,8,80,3),(298,4,4,8,81,4),(299,4,4,8,92,5),(300,4,4,8,123,6),(301,4,4,8,124,7),(302,4,4,8,132,8),(303,4,4,11,104,1),(304,4,4,11,106,2),(305,4,4,11,117,3),(306,4,4,14,100,3),(307,4,4,14,101,1),(308,4,4,14,102,2),(309,4,4,14,116,4),(310,4,4,20,134,1),(311,3,3,4,153,11),(312,4,4,7,154,115),(313,4,4,7,155,116),(314,4,4,23,156,20),(318,3,3,24,158,1),(319,3,3,24,159,2),(320,3,3,24,160,3),(321,4,4,7,161,117),(322,4,4,7,162,100),(324,1,1,1,157,90),(325,3,3,4,163,333),(335,4,9,30,103,10),(343,4,9,31,98,8),(365,4,9,36,91,6),(372,4,9,36,122,11),(376,4,9,36,107,14),(377,4,9,36,108,15),(379,4,9,36,109,16),(381,4,9,36,110,17),(383,4,9,36,111,18),(385,4,9,36,112,19),(387,4,9,36,113,20),(396,4,9,36,125,111),(397,4,9,36,126,112),(398,4,9,36,127,113),(399,4,9,36,128,114),(402,4,10,37,156,20),(403,4,10,39,134,1),(404,4,10,41,101,1),(405,4,10,41,102,2),(406,4,10,41,100,3),(407,4,10,41,116,4),(408,4,10,42,104,1),(409,4,10,42,106,2),(410,4,10,42,117,3),(411,4,10,42,103,10),(412,4,10,43,78,1),(413,4,10,43,79,2),(414,4,10,43,80,3),(415,4,10,43,81,4),(416,4,10,43,92,5),(417,4,10,43,123,6),(418,4,10,43,124,7),(419,4,10,43,98,8),(420,4,10,43,132,8),(421,4,10,44,121,1),(422,4,10,44,84,2),(423,4,10,44,85,3),(424,4,10,44,86,4),(425,4,10,45,87,1),(426,4,10,45,88,2),(427,4,10,45,89,3),(428,4,10,45,135,4),(429,4,10,45,90,5),(430,4,10,45,96,6),(431,4,10,46,133,1),(432,4,10,47,76,1),(433,4,10,47,75,2),(434,4,10,47,145,3),(435,4,10,47,146,4),(436,4,10,48,97,1),(437,4,10,48,73,2),(438,4,10,48,74,3),(439,4,10,48,130,4),(440,4,10,48,77,5),(441,4,10,48,91,6),(442,4,10,48,129,6),(443,4,10,48,136,7),(444,4,10,48,115,8),(445,4,10,48,82,9),(446,4,10,48,131,10),(447,4,10,48,99,11),(448,4,10,48,122,11),(449,4,10,48,105,12),(450,4,10,48,94,13),(451,4,10,48,95,14),(452,4,10,48,107,14),(453,4,10,48,108,15),(454,4,10,48,140,15),(455,4,10,48,109,16),(456,4,10,48,142,16),(457,4,10,48,110,17),(458,4,10,48,143,17),(459,4,10,48,111,18),(460,4,10,48,144,18),(461,4,10,48,112,19),(462,4,10,48,141,19),(463,4,10,48,113,20),(464,4,10,48,147,20),(465,4,10,48,152,21),(466,4,10,48,114,22),(467,4,10,48,93,23),(468,4,10,48,148,24),(469,4,10,48,149,25),(470,4,10,48,150,26),(471,4,10,48,162,100),(472,4,10,48,125,111),(473,4,10,48,126,112),(474,4,10,48,127,113),(475,4,10,48,128,114),(476,4,10,48,155,116),(477,4,10,48,161,117),(534,4,9,36,73,2),(535,4,9,36,74,3),(536,4,9,36,77,5),(537,4,9,36,82,9),(538,4,9,36,94,13),(539,4,9,36,95,14),(540,4,9,36,97,1),(541,4,9,36,99,11),(542,4,9,36,105,12),(543,4,9,36,114,17),(544,4,9,36,115,8),(545,4,9,36,129,6),(546,4,9,36,130,4),(547,4,9,36,131,10),(548,4,9,36,136,7),(549,4,9,36,141,15),(550,4,9,36,147,16),(551,4,9,36,148,18),(552,4,9,36,149,19),(553,4,9,36,150,20),(554,4,9,36,155,22),(555,4,9,36,161,23),(556,4,9,36,162,21),(557,4,9,35,75,2),(558,4,9,35,76,1),(559,4,9,35,145,3),(560,4,9,35,146,4),(561,4,9,34,133,1),(562,4,9,33,87,1),(563,4,9,33,88,2),(564,4,9,33,89,3),(565,4,9,33,90,5),(566,4,9,33,96,6),(567,4,9,33,135,4),(568,4,9,32,84,2),(569,4,9,32,85,3),(570,4,9,32,86,4),(571,4,9,32,121,1),(572,4,9,31,78,1),(573,4,9,31,79,2),(574,4,9,31,80,3),(575,4,9,31,81,4),(576,4,9,31,92,5),(577,4,9,31,123,6),(578,4,9,31,124,7),(579,4,9,31,132,8),(580,4,9,30,104,1),(581,4,9,30,106,2),(582,4,9,30,117,3),(583,4,9,29,100,3),(584,4,9,29,101,1),(585,4,9,29,102,2),(586,4,9,29,116,4),(587,4,9,27,134,1),(588,4,9,26,140,1),(589,4,9,25,156,1),(590,4,11,49,156,20),(591,4,11,51,134,1),(592,4,11,53,101,1),(593,4,11,53,102,2),(594,4,11,53,100,3),(595,4,11,53,116,4),(596,4,11,54,104,1),(597,4,11,54,106,2),(598,4,11,54,117,3),(599,4,11,54,103,10),(600,4,11,55,78,1),(601,4,11,55,79,2),(602,4,11,55,80,3),(603,4,11,55,81,4),(604,4,11,55,92,5),(605,4,11,55,123,6),(606,4,11,55,124,7),(607,4,11,55,98,8),(608,4,11,55,132,8),(609,4,11,56,121,1),(610,4,11,56,84,2),(611,4,11,56,85,3),(612,4,11,56,86,4),(613,4,11,57,87,1),(614,4,11,57,88,2),(615,4,11,57,89,3),(616,4,11,57,135,4),(617,4,11,57,90,5),(618,4,11,57,96,6),(619,4,11,58,133,1),(620,4,11,59,76,1),(621,4,11,59,75,2),(622,4,11,59,145,3),(623,4,11,59,146,4),(624,4,11,60,97,1),(625,4,11,60,73,2),(626,4,11,60,74,3),(627,4,11,60,130,4),(628,4,11,60,77,5),(629,4,11,60,91,6),(630,4,11,60,129,6),(631,4,11,60,136,7),(632,4,11,60,115,8),(633,4,11,60,82,9),(634,4,11,60,131,10),(635,4,11,60,99,11),(636,4,11,60,122,11),(637,4,11,60,105,12),(638,4,11,60,94,13),(639,4,11,60,95,14),(640,4,11,60,107,14),(641,4,11,60,108,15),(642,4,11,60,140,15),(643,4,11,60,109,16),(644,4,11,60,142,16),(645,4,11,60,110,17),(646,4,11,60,143,17),(647,4,11,60,111,18),(648,4,11,60,144,18),(649,4,11,60,112,19),(650,4,11,60,141,19),(651,4,11,60,113,20),(652,4,11,60,147,20),(653,4,11,60,152,21),(654,4,11,60,114,22),(655,4,11,60,93,23),(656,4,11,60,148,24),(657,4,11,60,149,25),(658,4,11,60,150,26),(659,4,11,60,162,100),(660,4,11,60,125,111),(661,4,11,60,126,112),(662,4,11,60,127,113),(663,4,11,60,128,114),(664,4,11,60,155,116),(665,4,11,60,161,117),(818,4,14,85,156,20),(819,4,14,87,134,1),(820,4,14,89,101,1),(821,4,14,89,102,2),(822,4,14,89,100,3),(823,4,14,89,116,4),(824,4,14,90,104,1),(825,4,14,90,106,2),(826,4,14,90,117,3),(827,4,14,90,103,10),(828,4,14,91,78,1),(829,4,14,91,79,2),(830,4,14,91,80,3),(831,4,14,91,81,4),(832,4,14,91,92,5),(833,4,14,91,123,6),(834,4,14,91,124,7),(835,4,14,91,98,8),(836,4,14,91,132,8),(837,4,14,92,121,1),(838,4,14,92,84,2),(839,4,14,92,85,3),(840,4,14,92,86,4),(841,4,14,93,87,1),(842,4,14,93,88,2),(843,4,14,93,89,3),(844,4,14,93,135,4),(845,4,14,93,90,5),(846,4,14,93,96,6),(847,4,14,94,133,1),(848,4,14,95,76,1),(849,4,14,95,75,2),(850,4,14,95,145,3),(851,4,14,95,146,4),(852,4,14,96,97,1),(853,4,14,96,73,2),(854,4,14,96,74,3),(855,4,14,96,130,4),(856,4,14,96,77,5),(857,4,14,96,91,6),(858,4,14,96,129,6),(859,4,14,96,136,7),(860,4,14,96,115,8),(861,4,14,96,82,9),(862,4,14,96,131,10),(863,4,14,96,99,11),(864,4,14,96,122,11),(865,4,14,96,105,12),(866,4,14,96,94,13),(867,4,14,96,95,14),(868,4,14,96,107,14),(869,4,14,96,108,15),(870,4,14,96,140,15),(871,4,14,96,109,16),(872,4,14,96,142,16),(873,4,14,96,110,17),(874,4,14,96,143,17),(875,4,14,96,111,18),(876,4,14,96,144,18),(877,4,14,96,112,19),(878,4,14,96,141,19),(879,4,14,96,113,20),(880,4,14,96,147,20),(881,4,14,96,152,21),(882,4,14,96,114,22),(883,4,14,96,93,23),(884,4,14,96,148,24),(885,4,14,96,149,25),(886,4,14,96,150,26),(887,4,14,96,162,100),(888,4,14,96,125,111),(889,4,14,96,126,112),(890,4,14,96,127,113),(891,4,14,96,128,114),(892,4,14,96,155,116),(893,4,14,96,161,117),(894,4,15,97,156,20),(895,4,15,99,134,1),(896,4,15,101,101,1),(897,4,15,101,102,2),(898,4,15,101,100,3),(899,4,15,101,116,4),(900,4,15,102,104,1),(901,4,15,102,106,2),(902,4,15,102,117,3),(903,4,15,102,103,10),(904,4,15,103,78,1),(905,4,15,103,79,2),(906,4,15,103,80,3),(907,4,15,103,81,4),(908,4,15,103,92,5),(909,4,15,103,123,6),(910,4,15,103,124,7),(911,4,15,103,98,8),(912,4,15,103,132,8),(913,4,15,104,121,1),(914,4,15,104,84,2),(915,4,15,104,85,3),(916,4,15,104,86,4),(917,4,15,105,87,1),(918,4,15,105,88,2),(919,4,15,105,89,3),(920,4,15,105,135,4),(921,4,15,105,90,5),(922,4,15,105,96,6),(923,4,15,106,133,1),(924,4,15,107,76,1),(925,4,15,107,75,2),(926,4,15,107,145,3),(927,4,15,107,146,4),(928,4,15,108,97,1),(929,4,15,108,73,2),(930,4,15,108,74,3),(931,4,15,108,130,4),(932,4,15,108,77,5),(933,4,15,108,91,6),(934,4,15,108,129,6),(935,4,15,108,136,7),(936,4,15,108,115,8),(937,4,15,108,82,9),(938,4,15,108,131,10),(939,4,15,108,99,11),(940,4,15,108,122,11),(941,4,15,108,105,12),(942,4,15,108,94,13),(943,4,15,108,95,14),(944,4,15,108,107,14),(945,4,15,108,108,15),(946,4,15,108,140,15),(947,4,15,108,109,16),(948,4,15,108,142,16),(949,4,15,108,110,17),(950,4,15,108,143,17),(951,4,15,108,111,18),(952,4,15,108,144,18),(953,4,15,108,112,19),(954,4,15,108,141,19),(955,4,15,108,113,20),(956,4,15,108,147,20),(957,4,15,108,152,21),(958,4,15,108,114,22),(959,4,15,108,93,23),(960,4,15,108,148,24),(961,4,15,108,149,25),(962,4,15,108,150,26),(963,4,15,108,162,100),(964,4,15,108,125,111),(965,4,15,108,126,112),(966,4,15,108,127,113),(967,4,15,108,128,114),(968,4,15,108,155,116),(969,4,15,108,161,117),(970,4,16,109,156,20),(971,4,16,111,134,1),(972,4,16,113,101,1),(973,4,16,113,102,2),(974,4,16,113,100,3),(975,4,16,113,116,4),(976,4,16,114,104,1),(977,4,16,114,106,2),(978,4,16,114,117,3),(979,4,16,114,103,10),(980,4,16,115,78,1),(981,4,16,115,79,2),(982,4,16,115,80,3),(983,4,16,115,81,4),(984,4,16,115,92,5),(985,4,16,115,123,6),(986,4,16,115,124,7),(987,4,16,115,98,8),(988,4,16,115,132,8),(989,4,16,116,121,1),(990,4,16,116,84,2),(991,4,16,116,85,3),(992,4,16,116,86,4),(993,4,16,117,87,1),(994,4,16,117,88,2),(995,4,16,117,89,3),(996,4,16,117,135,4),(997,4,16,117,90,5),(998,4,16,117,96,6),(999,4,16,118,133,1),(1000,4,16,119,76,1),(1001,4,16,119,75,2),(1002,4,16,119,145,3),(1003,4,16,119,146,4),(1004,4,16,120,97,1),(1005,4,16,120,73,2),(1006,4,16,120,74,3),(1007,4,16,120,130,4),(1008,4,16,120,77,5),(1009,4,16,120,91,6),(1010,4,16,120,129,6),(1011,4,16,120,136,7),(1012,4,16,120,115,8),(1013,4,16,120,82,9),(1014,4,16,120,131,10),(1015,4,16,120,99,11),(1016,4,16,120,122,11),(1017,4,16,120,105,12),(1018,4,16,120,94,13),(1019,4,16,120,95,14),(1020,4,16,120,107,14),(1021,4,16,120,108,15),(1022,4,16,120,140,15),(1023,4,16,120,109,16),(1024,4,16,120,142,16),(1025,4,16,120,110,17),(1026,4,16,120,143,17),(1027,4,16,120,111,18),(1028,4,16,120,144,18),(1029,4,16,120,112,19),(1030,4,16,120,141,19),(1031,4,16,120,113,20),(1032,4,16,120,147,20),(1033,4,16,120,152,21),(1034,4,16,120,114,22),(1035,4,16,120,93,23),(1036,4,16,120,148,24),(1037,4,16,120,149,25),(1038,4,16,120,150,26),(1039,4,16,120,162,100),(1040,4,16,120,125,111),(1041,4,16,120,126,112),(1042,4,16,120,127,113),(1043,4,16,120,128,114),(1044,4,16,120,155,116),(1045,4,16,120,161,117),(1046,4,17,121,156,20),(1047,4,17,123,134,1),(1048,4,17,125,101,1),(1049,4,17,125,102,2),(1050,4,17,125,100,3),(1051,4,17,125,116,4),(1052,4,17,126,104,1),(1053,4,17,126,106,2),(1054,4,17,126,117,3),(1055,4,17,126,103,10),(1056,4,17,127,78,1),(1057,4,17,127,79,2),(1058,4,17,127,80,3),(1059,4,17,127,81,4),(1060,4,17,127,92,5),(1061,4,17,127,123,6),(1062,4,17,127,124,7),(1063,4,17,127,98,8),(1064,4,17,127,132,8),(1065,4,17,128,121,1),(1066,4,17,128,84,2),(1067,4,17,128,85,3),(1068,4,17,128,86,4),(1069,4,17,129,87,1),(1070,4,17,129,88,2),(1071,4,17,129,89,3),(1072,4,17,129,135,4),(1073,4,17,129,90,5),(1074,4,17,129,96,6),(1075,4,17,130,133,1),(1076,4,17,131,76,1),(1077,4,17,131,75,2),(1078,4,17,131,145,3),(1079,4,17,131,146,4),(1080,4,17,132,97,1),(1081,4,17,132,73,2),(1082,4,17,132,74,3),(1083,4,17,132,130,4),(1084,4,17,132,77,5),(1085,4,17,132,91,6),(1086,4,17,132,129,6),(1087,4,17,132,136,7),(1088,4,17,132,115,8),(1089,4,17,132,82,9),(1090,4,17,132,131,10),(1091,4,17,132,99,11),(1092,4,17,132,122,11),(1093,4,17,132,105,12),(1094,4,17,132,94,13),(1095,4,17,132,95,14),(1096,4,17,132,107,14),(1097,4,17,132,108,15),(1098,4,17,132,140,15),(1099,4,17,132,109,16),(1100,4,17,132,142,16),(1101,4,17,132,110,17),(1102,4,17,132,143,17),(1103,4,17,132,111,18),(1104,4,17,132,144,18),(1105,4,17,132,112,19),(1106,4,17,132,141,19),(1107,4,17,132,113,20),(1108,4,17,132,147,20),(1109,4,17,132,152,21),(1110,4,17,132,114,22),(1111,4,17,132,93,23),(1112,4,17,132,148,24),(1113,4,17,132,149,25),(1114,4,17,132,150,26),(1115,4,17,132,162,100),(1116,4,17,132,125,111),(1117,4,17,132,126,112),(1118,4,17,132,127,113),(1119,4,17,132,128,114),(1120,4,17,132,155,116),(1121,4,17,132,161,117),(1122,4,18,133,156,20),(1123,4,18,135,134,1),(1124,4,18,137,101,1),(1125,4,18,137,102,2),(1126,4,18,137,100,3),(1127,4,18,137,116,4),(1128,4,18,138,104,1),(1129,4,18,138,106,2),(1130,4,18,138,117,3),(1131,4,18,138,103,10),(1132,4,18,139,78,1),(1133,4,18,139,79,2),(1134,4,18,139,80,3),(1135,4,18,139,81,4),(1136,4,18,139,92,5),(1137,4,18,139,123,6),(1138,4,18,139,124,7),(1139,4,18,139,98,8),(1140,4,18,139,132,8),(1141,4,18,140,121,1),(1142,4,18,140,84,2),(1143,4,18,140,85,3),(1144,4,18,140,86,4),(1145,4,18,141,87,1),(1146,4,18,141,88,2),(1147,4,18,141,89,3),(1148,4,18,141,135,4),(1149,4,18,141,90,5),(1150,4,18,141,96,6),(1151,4,18,142,133,1),(1152,4,18,143,76,1),(1153,4,18,143,75,2),(1154,4,18,143,145,3),(1155,4,18,143,146,4),(1156,4,18,144,97,1),(1157,4,18,144,73,2),(1158,4,18,144,74,3),(1159,4,18,144,130,4),(1160,4,18,144,77,5),(1161,4,18,144,91,6),(1162,4,18,144,129,6),(1163,4,18,144,136,7),(1164,4,18,144,115,8),(1165,4,18,144,82,9),(1166,4,18,144,131,10),(1167,4,18,144,99,11),(1168,4,18,144,122,11),(1169,4,18,144,105,12),(1170,4,18,144,94,13),(1171,4,18,144,95,14),(1172,4,18,144,107,14),(1173,4,18,144,108,15),(1174,4,18,144,140,15),(1175,4,18,144,109,16),(1176,4,18,144,142,16),(1177,4,18,144,110,17),(1178,4,18,144,143,17),(1179,4,18,144,111,18),(1180,4,18,144,144,18),(1181,4,18,144,112,19),(1182,4,18,144,141,19),(1183,4,18,144,113,20),(1184,4,18,144,147,20),(1185,4,18,144,152,21),(1186,4,18,144,114,22),(1187,4,18,144,93,23),(1188,4,18,144,148,24),(1189,4,18,144,149,25),(1190,4,18,144,150,26),(1191,4,18,144,162,100),(1192,4,18,144,125,111),(1193,4,18,144,126,112),(1194,4,18,144,127,113),(1195,4,18,144,128,114),(1196,4,18,144,155,116),(1197,4,18,144,161,117),(1198,4,19,145,156,20),(1199,4,19,147,134,1),(1200,4,19,149,101,1),(1201,4,19,149,102,2),(1202,4,19,149,100,3),(1203,4,19,149,116,4),(1204,4,19,150,104,1),(1205,4,19,150,106,2),(1206,4,19,150,117,3),(1207,4,19,150,103,10),(1208,4,19,151,78,1),(1209,4,19,151,79,2),(1210,4,19,151,80,3),(1211,4,19,151,81,4),(1212,4,19,151,92,5),(1213,4,19,151,123,6),(1214,4,19,151,124,7),(1215,4,19,151,98,8),(1216,4,19,151,132,8),(1217,4,19,152,121,1),(1218,4,19,152,84,2),(1219,4,19,152,85,3),(1220,4,19,152,86,4),(1221,4,19,153,87,1),(1222,4,19,153,88,2),(1223,4,19,153,89,3),(1224,4,19,153,135,4),(1225,4,19,153,90,5),(1226,4,19,153,96,6),(1227,4,19,154,133,1),(1228,4,19,155,76,1),(1229,4,19,155,75,2),(1230,4,19,155,145,3),(1231,4,19,155,146,4),(1232,4,19,156,97,1),(1233,4,19,156,73,2),(1234,4,19,156,74,3),(1235,4,19,156,130,4),(1236,4,19,156,77,5),(1237,4,19,156,91,6),(1238,4,19,156,129,6),(1239,4,19,156,136,7),(1240,4,19,156,115,8),(1241,4,19,156,82,9),(1242,4,19,156,131,10),(1243,4,19,156,99,11),(1244,4,19,156,122,11),(1245,4,19,156,105,12),(1246,4,19,156,94,13),(1247,4,19,156,95,14),(1248,4,19,156,107,14),(1249,4,19,156,108,15),(1250,4,19,156,140,15),(1251,4,19,156,109,16),(1252,4,19,156,142,16),(1253,4,19,156,110,17),(1254,4,19,156,143,17),(1255,4,19,156,111,18),(1256,4,19,156,144,18),(1257,4,19,156,112,19),(1258,4,19,156,141,19),(1259,4,19,156,113,20),(1260,4,19,156,147,20),(1261,4,19,156,152,21),(1262,4,19,156,114,22),(1263,4,19,156,93,23),(1264,4,19,156,148,24),(1265,4,19,156,149,25),(1266,4,19,156,150,26),(1267,4,19,156,162,100),(1268,4,19,156,125,111),(1269,4,19,156,126,112),(1270,4,19,156,127,113),(1271,4,19,156,128,114),(1272,4,19,156,155,116),(1273,4,19,156,161,117),(1274,4,20,157,156,20),(1275,4,20,159,134,1),(1276,4,20,161,101,1),(1277,4,20,161,102,2),(1278,4,20,161,100,3),(1279,4,20,161,116,4),(1280,4,20,162,104,1),(1281,4,20,162,106,2),(1282,4,20,162,117,3),(1283,4,20,162,103,10),(1284,4,20,163,78,1),(1285,4,20,163,79,2),(1286,4,20,163,80,3),(1287,4,20,163,81,4),(1288,4,20,163,92,5),(1289,4,20,163,123,6),(1290,4,20,163,124,7),(1291,4,20,163,98,8),(1292,4,20,163,132,8),(1293,4,20,164,121,1),(1294,4,20,164,84,2),(1295,4,20,164,85,3),(1296,4,20,164,86,4),(1297,4,20,165,87,1),(1298,4,20,165,88,2),(1299,4,20,165,89,3),(1300,4,20,165,135,4),(1301,4,20,165,90,5),(1302,4,20,165,96,6),(1303,4,20,166,133,1),(1304,4,20,167,76,1),(1305,4,20,167,75,2),(1306,4,20,167,145,3),(1307,4,20,167,146,4),(1308,4,20,168,97,1),(1309,4,20,168,73,2),(1310,4,20,168,74,3),(1311,4,20,168,130,4),(1312,4,20,168,77,5),(1313,4,20,168,91,6),(1314,4,20,168,129,6),(1315,4,20,168,136,7),(1316,4,20,168,115,8),(1317,4,20,168,82,9),(1318,4,20,168,131,10),(1319,4,20,168,99,11),(1320,4,20,168,122,11),(1321,4,20,168,105,12),(1322,4,20,168,94,13),(1323,4,20,168,95,14),(1324,4,20,168,107,14),(1325,4,20,168,108,15),(1326,4,20,168,140,15),(1327,4,20,168,109,16),(1328,4,20,168,142,16),(1329,4,20,168,110,17),(1330,4,20,168,143,17),(1331,4,20,168,111,18),(1332,4,20,168,144,18),(1333,4,20,168,112,19),(1334,4,20,168,141,19),(1335,4,20,168,113,20),(1336,4,20,168,147,20),(1337,4,20,168,152,21),(1338,4,20,168,114,22),(1339,4,20,168,93,23),(1340,4,20,168,148,24),(1341,4,20,168,149,25),(1342,4,20,168,150,26),(1343,4,20,168,162,100),(1344,4,20,168,125,111),(1345,4,20,168,126,112),(1346,4,20,168,127,113),(1347,4,20,168,128,114),(1348,4,20,168,155,116),(1349,4,20,168,161,117),(1350,4,21,169,156,20),(1351,4,21,171,134,1),(1352,4,21,173,101,1),(1353,4,21,173,102,2),(1354,4,21,173,100,3),(1355,4,21,173,116,4),(1356,4,21,174,104,1),(1357,4,21,174,106,2),(1358,4,21,174,117,3),(1359,4,21,174,103,10),(1360,4,21,175,78,1),(1361,4,21,175,79,2),(1362,4,21,175,80,3),(1363,4,21,175,81,4),(1364,4,21,175,92,5),(1365,4,21,175,123,6),(1366,4,21,175,124,7),(1367,4,21,175,98,8),(1368,4,21,175,132,8),(1369,4,21,176,121,1),(1370,4,21,176,84,2),(1371,4,21,176,85,3),(1372,4,21,176,86,4),(1373,4,21,177,87,1),(1374,4,21,177,88,2),(1375,4,21,177,89,3),(1376,4,21,177,135,4),(1377,4,21,177,90,5),(1378,4,21,177,96,6),(1379,4,21,178,133,1),(1380,4,21,179,76,1),(1381,4,21,179,75,2),(1382,4,21,179,145,3),(1383,4,21,179,146,4),(1384,4,21,180,97,1),(1385,4,21,180,73,2),(1386,4,21,180,74,3),(1387,4,21,180,130,4),(1388,4,21,180,77,5),(1389,4,21,180,91,6),(1390,4,21,180,129,6),(1391,4,21,180,136,7),(1392,4,21,180,115,8),(1393,4,21,180,82,9),(1394,4,21,180,131,10),(1395,4,21,180,99,11),(1396,4,21,180,122,11),(1397,4,21,180,105,12),(1398,4,21,180,94,13),(1399,4,21,180,95,14),(1400,4,21,180,107,14),(1401,4,21,180,108,15),(1402,4,21,180,140,15),(1403,4,21,180,109,16),(1404,4,21,180,142,16),(1405,4,21,180,110,17),(1406,4,21,180,143,17),(1407,4,21,180,111,18),(1408,4,21,180,144,18),(1409,4,21,180,112,19),(1410,4,21,180,141,19),(1411,4,21,180,113,20),(1412,4,21,180,147,20),(1413,4,21,180,152,21),(1414,4,21,180,114,22),(1415,4,21,180,93,23),(1416,4,21,180,148,24),(1417,4,21,180,149,25),(1418,4,21,180,150,26),(1419,4,21,180,162,100),(1420,4,21,180,125,111),(1421,4,21,180,126,112),(1422,4,21,180,127,113),(1423,4,21,180,128,114),(1424,4,21,180,155,116),(1425,4,21,180,161,117),(1426,4,22,181,156,20),(1427,4,22,183,134,1),(1428,4,22,185,101,1),(1429,4,22,185,102,2),(1430,4,22,185,100,3),(1431,4,22,185,116,4),(1432,4,22,186,104,1),(1433,4,22,186,106,2),(1434,4,22,186,117,3),(1435,4,22,186,103,10),(1436,4,22,187,78,1),(1437,4,22,187,79,2),(1438,4,22,187,80,3),(1439,4,22,187,81,4),(1440,4,22,187,92,5),(1441,4,22,187,123,6),(1442,4,22,187,124,7),(1443,4,22,187,98,8),(1444,4,22,187,132,8),(1445,4,22,188,121,1),(1446,4,22,188,84,2),(1447,4,22,188,85,3),(1448,4,22,188,86,4),(1449,4,22,189,87,1),(1450,4,22,189,88,2),(1451,4,22,189,89,3),(1452,4,22,189,135,4),(1453,4,22,189,90,5),(1454,4,22,189,96,6),(1455,4,22,190,133,1),(1456,4,22,191,76,1),(1457,4,22,191,75,2),(1458,4,22,191,145,3),(1459,4,22,191,146,4),(1460,4,22,192,97,1),(1461,4,22,192,73,2),(1462,4,22,192,74,3),(1463,4,22,192,130,4),(1464,4,22,192,77,5),(1465,4,22,192,91,6),(1466,4,22,192,129,6),(1467,4,22,192,136,7),(1468,4,22,192,115,8),(1469,4,22,192,82,9),(1470,4,22,192,131,10),(1471,4,22,192,99,11),(1472,4,22,192,122,11),(1473,4,22,192,105,12),(1474,4,22,192,94,13),(1475,4,22,192,95,14),(1476,4,22,192,107,14),(1477,4,22,192,108,15),(1478,4,22,192,140,15),(1479,4,22,192,109,16),(1480,4,22,192,142,16),(1481,4,22,192,110,17),(1482,4,22,192,143,17),(1483,4,22,192,111,18),(1484,4,22,192,144,18),(1485,4,22,192,112,19),(1486,4,22,192,141,19),(1487,4,22,192,113,20),(1488,4,22,192,147,20),(1489,4,22,192,152,21),(1490,4,22,192,114,22),(1491,4,22,192,93,23),(1492,4,22,192,148,24),(1493,4,22,192,149,25),(1494,4,22,192,150,26),(1495,4,22,192,162,100),(1496,4,22,192,125,111),(1497,4,22,192,126,112),(1498,4,22,192,127,113),(1499,4,22,192,128,114),(1500,4,22,192,155,116),(1501,4,22,192,161,117),(1502,4,23,193,156,20),(1503,4,23,195,134,1),(1504,4,23,197,101,1),(1505,4,23,197,102,2),(1506,4,23,197,100,3),(1507,4,23,197,116,4),(1508,4,23,198,104,1),(1509,4,23,198,106,2),(1510,4,23,198,117,3),(1511,4,23,198,103,10),(1512,4,23,199,78,1),(1513,4,23,199,79,2),(1514,4,23,199,80,3),(1515,4,23,199,81,4),(1516,4,23,199,92,5),(1517,4,23,199,123,6),(1518,4,23,199,124,7),(1519,4,23,199,98,8),(1520,4,23,199,132,8),(1521,4,23,200,121,1),(1522,4,23,200,84,2),(1523,4,23,200,85,3),(1524,4,23,200,86,4),(1525,4,23,201,87,1),(1526,4,23,201,88,2),(1527,4,23,201,89,3),(1528,4,23,201,135,4),(1529,4,23,201,90,5),(1530,4,23,201,96,6),(1531,4,23,202,133,1),(1532,4,23,203,76,1),(1533,4,23,203,75,2),(1534,4,23,203,145,3),(1535,4,23,203,146,4),(1536,4,23,204,97,1),(1537,4,23,204,73,2),(1538,4,23,204,74,3),(1539,4,23,204,130,4),(1540,4,23,204,77,5),(1541,4,23,204,91,6),(1542,4,23,204,129,6),(1543,4,23,204,136,7),(1544,4,23,204,115,8),(1545,4,23,204,82,9),(1546,4,23,204,131,10),(1547,4,23,204,99,11),(1548,4,23,204,122,11),(1549,4,23,204,105,12),(1550,4,23,204,94,13),(1551,4,23,204,95,14),(1552,4,23,204,107,14),(1553,4,23,204,108,15),(1554,4,23,204,140,15),(1555,4,23,204,109,16),(1556,4,23,204,142,16),(1557,4,23,204,110,17),(1558,4,23,204,143,17),(1559,4,23,204,111,18),(1560,4,23,204,144,18),(1561,4,23,204,112,19),(1562,4,23,204,141,19),(1563,4,23,204,113,20),(1564,4,23,204,147,20),(1565,4,23,204,152,21),(1566,4,23,204,114,22),(1567,4,23,204,93,23),(1568,4,23,204,148,24),(1569,4,23,204,149,25),(1570,4,23,204,150,26),(1571,4,23,204,162,100),(1572,4,23,204,125,111),(1573,4,23,204,126,112),(1574,4,23,204,127,113),(1575,4,23,204,128,114),(1576,4,23,204,155,116),(1577,4,23,204,161,117),(1578,4,24,205,156,20),(1579,4,24,207,134,1),(1580,4,24,209,101,1),(1581,4,24,209,102,2),(1582,4,24,209,100,3),(1583,4,24,209,116,4),(1584,4,24,210,104,1),(1585,4,24,210,106,2),(1586,4,24,210,117,3),(1587,4,24,210,103,10),(1588,4,24,211,78,1),(1589,4,24,211,79,2),(1590,4,24,211,80,3),(1591,4,24,211,81,4),(1592,4,24,211,92,5),(1593,4,24,211,123,6),(1594,4,24,211,124,7),(1595,4,24,211,98,8),(1596,4,24,211,132,8),(1597,4,24,212,121,1),(1598,4,24,212,84,2),(1599,4,24,212,85,3),(1600,4,24,212,86,4),(1601,4,24,213,87,1),(1602,4,24,213,88,2),(1603,4,24,213,89,3),(1604,4,24,213,135,4),(1605,4,24,213,90,5),(1606,4,24,213,96,6),(1607,4,24,214,133,1),(1608,4,24,215,76,1),(1609,4,24,215,75,2),(1610,4,24,215,145,3),(1611,4,24,215,146,4),(1612,4,24,216,97,1),(1613,4,24,216,73,2),(1614,4,24,216,74,3),(1615,4,24,216,130,4),(1616,4,24,216,77,5),(1617,4,24,216,91,6),(1618,4,24,216,129,6),(1619,4,24,216,136,7),(1620,4,24,216,115,8),(1621,4,24,216,82,9),(1622,4,24,216,131,10),(1623,4,24,216,99,11),(1624,4,24,216,122,11),(1625,4,24,216,105,12),(1626,4,24,216,94,13),(1627,4,24,216,95,14),(1628,4,24,216,107,14),(1629,4,24,216,108,15),(1630,4,24,216,140,15),(1631,4,24,216,109,16),(1632,4,24,216,142,16),(1633,4,24,216,110,17),(1634,4,24,216,143,17),(1635,4,24,216,111,18),(1636,4,24,216,144,18),(1637,4,24,216,112,19),(1638,4,24,216,141,19),(1639,4,24,216,113,20),(1640,4,24,216,147,20),(1641,4,24,216,152,21),(1642,4,24,216,114,22),(1643,4,24,216,93,23),(1644,4,24,216,148,24),(1645,4,24,216,149,25),(1646,4,24,216,150,26),(1647,4,24,216,162,100),(1648,4,24,216,125,111),(1649,4,24,216,126,112),(1650,4,24,216,127,113),(1651,4,24,216,128,114),(1652,4,24,216,155,116),(1653,4,24,216,161,117),(1654,4,25,217,156,20),(1655,4,25,219,134,1),(1656,4,25,221,101,1),(1657,4,25,221,102,2),(1658,4,25,221,100,3),(1659,4,25,221,116,4),(1660,4,25,222,104,1),(1661,4,25,222,106,2),(1662,4,25,222,117,3),(1663,4,25,222,103,10),(1664,4,25,223,78,1),(1665,4,25,223,79,2),(1666,4,25,223,80,3),(1667,4,25,223,81,4),(1668,4,25,223,92,5),(1669,4,25,223,123,6),(1670,4,25,223,124,7),(1671,4,25,223,98,8),(1672,4,25,223,132,8),(1673,4,25,224,121,1),(1674,4,25,224,84,2),(1675,4,25,224,85,3),(1676,4,25,224,86,4),(1677,4,25,225,87,1),(1678,4,25,225,88,2),(1679,4,25,225,89,3),(1680,4,25,225,135,4),(1681,4,25,225,90,5),(1682,4,25,225,96,6),(1683,4,25,226,133,1),(1684,4,25,227,76,1),(1685,4,25,227,75,2),(1686,4,25,227,145,3),(1687,4,25,227,146,4),(1688,4,25,228,97,1),(1689,4,25,228,73,2),(1690,4,25,228,74,3),(1691,4,25,228,130,4),(1692,4,25,228,77,5),(1693,4,25,228,91,6),(1694,4,25,228,129,6),(1695,4,25,228,136,7),(1696,4,25,228,115,8),(1697,4,25,228,82,9),(1698,4,25,228,131,10),(1699,4,25,228,99,11),(1700,4,25,228,122,11),(1701,4,25,228,105,12),(1702,4,25,228,94,13),(1703,4,25,228,95,14),(1704,4,25,228,107,14),(1705,4,25,228,108,15),(1706,4,25,228,140,15),(1707,4,25,228,109,16),(1708,4,25,228,142,16),(1709,4,25,228,110,17),(1710,4,25,228,143,17),(1711,4,25,228,111,18),(1712,4,25,228,144,18),(1713,4,25,228,112,19),(1714,4,25,228,141,19),(1715,4,25,228,113,20),(1716,4,25,228,147,20),(1717,4,25,228,152,21),(1718,4,25,228,114,22),(1719,4,25,228,93,23),(1720,4,25,228,148,24),(1721,4,25,228,149,25),(1722,4,25,228,150,26),(1723,4,25,228,162,100),(1724,4,25,228,125,111),(1725,4,25,228,126,112),(1726,4,25,228,127,113),(1727,4,25,228,128,114),(1728,4,25,228,155,116),(1729,4,25,228,161,117),(1730,4,26,229,156,20),(1731,4,26,231,134,1),(1732,4,26,233,101,1),(1733,4,26,233,102,2),(1734,4,26,233,100,3),(1735,4,26,233,116,4),(1736,4,26,234,104,1),(1737,4,26,234,106,2),(1738,4,26,234,117,3),(1739,4,26,234,103,10),(1740,4,26,235,78,1),(1741,4,26,235,79,2),(1742,4,26,235,80,3),(1743,4,26,235,81,4),(1744,4,26,235,92,5),(1745,4,26,235,123,6),(1746,4,26,235,124,7),(1747,4,26,235,98,8),(1748,4,26,235,132,8),(1749,4,26,236,121,1),(1750,4,26,236,84,2),(1751,4,26,236,85,3),(1752,4,26,236,86,4),(1753,4,26,237,87,1),(1754,4,26,237,88,2),(1755,4,26,237,89,3),(1756,4,26,237,135,4),(1757,4,26,237,90,5),(1758,4,26,237,96,6),(1759,4,26,238,133,1),(1760,4,26,239,76,1),(1761,4,26,239,75,2),(1762,4,26,239,145,3),(1763,4,26,239,146,4),(1764,4,26,240,97,1),(1765,4,26,240,73,2),(1766,4,26,240,74,3),(1767,4,26,240,130,4),(1768,4,26,240,77,5),(1769,4,26,240,91,6),(1770,4,26,240,129,6),(1771,4,26,240,136,7),(1772,4,26,240,115,8),(1773,4,26,240,82,9),(1774,4,26,240,131,10),(1775,4,26,240,99,11),(1776,4,26,240,122,11),(1777,4,26,240,105,12),(1778,4,26,240,94,13),(1779,4,26,240,95,14),(1780,4,26,240,107,14),(1781,4,26,240,108,15),(1782,4,26,240,140,15),(1783,4,26,240,109,16),(1784,4,26,240,142,16),(1785,4,26,240,110,17),(1786,4,26,240,143,17),(1787,4,26,240,111,18),(1788,4,26,240,144,18),(1789,4,26,240,112,19),(1790,4,26,240,141,19),(1791,4,26,240,113,20),(1792,4,26,240,147,20),(1793,4,26,240,152,21),(1794,4,26,240,114,22),(1795,4,26,240,93,23),(1796,4,26,240,148,24),(1797,4,26,240,149,25),(1798,4,26,240,150,26),(1799,4,26,240,162,100),(1800,4,26,240,125,111),(1801,4,26,240,126,112),(1802,4,26,240,127,113),(1803,4,26,240,128,114),(1804,4,26,240,155,116),(1805,4,26,240,161,117),(1806,4,27,241,156,20),(1807,4,27,243,134,1),(1808,4,27,245,101,1),(1809,4,27,245,102,2),(1810,4,27,245,100,3),(1811,4,27,245,116,4),(1812,4,27,246,104,1),(1813,4,27,246,106,2),(1814,4,27,246,117,3),(1815,4,27,246,103,10),(1816,4,27,247,78,1),(1817,4,27,247,79,2),(1818,4,27,247,80,3),(1819,4,27,247,81,4),(1820,4,27,247,92,5),(1821,4,27,247,123,6),(1822,4,27,247,124,7),(1823,4,27,247,98,8),(1824,4,27,247,132,8),(1825,4,27,248,121,1),(1826,4,27,248,84,2),(1827,4,27,248,85,3),(1828,4,27,248,86,4),(1829,4,27,249,87,1),(1830,4,27,249,88,2),(1831,4,27,249,89,3),(1832,4,27,249,135,4),(1833,4,27,249,90,5),(1834,4,27,249,96,6),(1835,4,27,250,133,1),(1836,4,27,251,76,1),(1837,4,27,251,75,2),(1838,4,27,251,145,3),(1839,4,27,251,146,4),(1840,4,27,252,97,1),(1841,4,27,252,73,2),(1842,4,27,252,74,3),(1843,4,27,252,130,4),(1844,4,27,252,77,5),(1845,4,27,252,91,6),(1846,4,27,252,129,6),(1847,4,27,252,136,7),(1848,4,27,252,115,8),(1849,4,27,252,82,9),(1850,4,27,252,131,10),(1851,4,27,252,99,11),(1852,4,27,252,122,11),(1853,4,27,252,105,12),(1854,4,27,252,94,13),(1855,4,27,252,95,14),(1856,4,27,252,107,14),(1857,4,27,252,108,15),(1858,4,27,252,140,15),(1859,4,27,252,109,16),(1860,4,27,252,142,16),(1861,4,27,252,110,17),(1862,4,27,252,143,17),(1863,4,27,252,111,18),(1864,4,27,252,144,18),(1865,4,27,252,112,19),(1866,4,27,252,141,19),(1867,4,27,252,113,20),(1868,4,27,252,147,20),(1869,4,27,252,152,21),(1870,4,27,252,114,22),(1871,4,27,252,93,23),(1872,4,27,252,148,24),(1873,4,27,252,149,25),(1874,4,27,252,150,26),(1875,4,27,252,162,100),(1876,4,27,252,125,111),(1877,4,27,252,126,112),(1878,4,27,252,127,113),(1879,4,27,252,128,114),(1880,4,27,252,155,116),(1881,4,27,252,161,117),(1882,4,28,253,156,20),(1883,4,28,255,134,1),(1884,4,28,257,101,1),(1885,4,28,257,102,2),(1886,4,28,257,100,3),(1887,4,28,257,116,4),(1888,4,28,258,104,1),(1889,4,28,258,106,2),(1890,4,28,258,117,3),(1891,4,28,258,103,10),(1892,4,28,259,78,1),(1893,4,28,259,79,2),(1894,4,28,259,80,3),(1895,4,28,259,81,4),(1896,4,28,259,92,5),(1897,4,28,259,123,6),(1898,4,28,259,124,7),(1899,4,28,259,98,8),(1900,4,28,259,132,8),(1901,4,28,260,121,1),(1902,4,28,260,84,2),(1903,4,28,260,85,3),(1904,4,28,260,86,4),(1905,4,28,261,87,1),(1906,4,28,261,88,2),(1907,4,28,261,89,3),(1908,4,28,261,135,4),(1909,4,28,261,90,5),(1910,4,28,261,96,6),(1911,4,28,262,133,1),(1912,4,28,263,76,1),(1913,4,28,263,75,2),(1914,4,28,263,145,3),(1915,4,28,263,146,4),(1916,4,28,264,97,1),(1917,4,28,264,73,2),(1918,4,28,264,74,3),(1919,4,28,264,130,4),(1920,4,28,264,77,5),(1921,4,28,264,91,6),(1922,4,28,264,129,6),(1923,4,28,264,136,7),(1924,4,28,264,115,8),(1925,4,28,264,82,9),(1926,4,28,264,131,10),(1927,4,28,264,99,11),(1928,4,28,264,122,11),(1929,4,28,264,105,12),(1930,4,28,264,94,13),(1931,4,28,264,95,14),(1932,4,28,264,107,14),(1933,4,28,264,108,15),(1934,4,28,264,140,15),(1935,4,28,264,109,16),(1936,4,28,264,142,16),(1937,4,28,264,110,17),(1938,4,28,264,143,17),(1939,4,28,264,111,18),(1940,4,28,264,144,18),(1941,4,28,264,112,19),(1942,4,28,264,141,19),(1943,4,28,264,113,20),(1944,4,28,264,147,20),(1945,4,28,264,152,21),(1946,4,28,264,114,22),(1947,4,28,264,93,23),(1948,4,28,264,148,24),(1949,4,28,264,149,25),(1950,4,28,264,150,26),(1951,4,28,264,162,100),(1952,4,28,264,125,111),(1953,4,28,264,126,112),(1954,4,28,264,127,113),(1955,4,28,264,128,114),(1956,4,28,264,155,116),(1957,4,28,264,161,117),(1958,4,29,265,156,20),(1959,4,29,267,134,1),(1960,4,29,269,101,1),(1961,4,29,269,102,2),(1962,4,29,269,100,3),(1963,4,29,269,116,4),(1964,4,29,270,104,1),(1965,4,29,270,106,2),(1966,4,29,270,117,3),(1967,4,29,270,103,10),(1968,4,29,271,78,1),(1969,4,29,271,79,2),(1970,4,29,271,80,3),(1971,4,29,271,81,4),(1972,4,29,271,92,5),(1973,4,29,271,123,6),(1974,4,29,271,124,7),(1975,4,29,271,98,8),(1976,4,29,271,132,8),(1977,4,29,272,121,1),(1978,4,29,272,84,2),(1979,4,29,272,85,3),(1980,4,29,272,86,4),(1981,4,29,273,87,1),(1982,4,29,273,88,2),(1983,4,29,273,89,3),(1984,4,29,273,135,4),(1985,4,29,273,90,5),(1986,4,29,273,96,6),(1987,4,29,274,133,1),(1988,4,29,275,76,1),(1989,4,29,275,75,2),(1990,4,29,275,145,3),(1991,4,29,275,146,4),(1992,4,29,276,97,1),(1993,4,29,276,73,2),(1994,4,29,276,74,3),(1995,4,29,276,130,4),(1996,4,29,276,77,5),(1997,4,29,276,91,6),(1998,4,29,276,129,6),(1999,4,29,276,136,7),(2000,4,29,276,115,8),(2001,4,29,276,82,9),(2002,4,29,276,131,10),(2003,4,29,276,99,11),(2004,4,29,276,122,11),(2005,4,29,276,105,12),(2006,4,29,276,94,13),(2007,4,29,276,95,14),(2008,4,29,276,107,14),(2009,4,29,276,108,15),(2010,4,29,276,140,15),(2011,4,29,276,109,16),(2012,4,29,276,142,16),(2013,4,29,276,110,17),(2014,4,29,276,143,17),(2015,4,29,276,111,18),(2016,4,29,276,144,18),(2017,4,29,276,112,19),(2018,4,29,276,141,19),(2019,4,29,276,113,20),(2020,4,29,276,147,20),(2021,4,29,276,152,21),(2022,4,29,276,114,22),(2023,4,29,276,93,23),(2024,4,29,276,148,24),(2025,4,29,276,149,25),(2026,4,29,276,150,26),(2027,4,29,276,162,100),(2028,4,29,276,125,111),(2029,4,29,276,126,112),(2030,4,29,276,127,113),(2031,4,29,276,128,114),(2032,4,29,276,155,116),(2033,4,29,276,161,117),(2034,4,30,277,156,20),(2035,4,30,279,134,1),(2036,4,30,281,101,1),(2037,4,30,281,102,2),(2038,4,30,281,100,3),(2039,4,30,281,116,4),(2040,4,30,282,104,1),(2041,4,30,282,106,2),(2042,4,30,282,117,3),(2043,4,30,282,103,10),(2044,4,30,283,78,1),(2045,4,30,283,79,2),(2046,4,30,283,80,3),(2047,4,30,283,81,4),(2048,4,30,283,92,5),(2049,4,30,283,123,6),(2050,4,30,283,124,7),(2051,4,30,283,98,8),(2052,4,30,283,132,8),(2053,4,30,284,121,1),(2054,4,30,284,84,2),(2055,4,30,284,85,3),(2056,4,30,284,86,4),(2057,4,30,285,87,1),(2058,4,30,285,88,2),(2059,4,30,285,89,3),(2060,4,30,285,135,4),(2061,4,30,285,90,5),(2062,4,30,285,96,6),(2063,4,30,286,133,1),(2064,4,30,287,76,1),(2065,4,30,287,75,2),(2066,4,30,287,145,3),(2067,4,30,287,146,4),(2068,4,30,288,97,1),(2069,4,30,288,73,2),(2070,4,30,288,74,3),(2071,4,30,288,130,4),(2072,4,30,288,77,5),(2073,4,30,288,91,6),(2074,4,30,288,129,6),(2075,4,30,288,136,7),(2076,4,30,288,115,8),(2077,4,30,288,82,9),(2078,4,30,288,131,10),(2079,4,30,288,99,11),(2080,4,30,288,122,11),(2081,4,30,288,105,12),(2082,4,30,288,94,13),(2083,4,30,288,95,14),(2084,4,30,288,107,14),(2085,4,30,288,108,15),(2086,4,30,288,140,15),(2087,4,30,288,109,16),(2088,4,30,288,142,16),(2089,4,30,288,110,17),(2090,4,30,288,143,17),(2091,4,30,288,111,18),(2092,4,30,288,144,18),(2093,4,30,288,112,19),(2094,4,30,288,141,19),(2095,4,30,288,113,20),(2096,4,30,288,147,20),(2097,4,30,288,152,21),(2098,4,30,288,114,22),(2099,4,30,288,93,23),(2100,4,30,288,148,24),(2101,4,30,288,149,25),(2102,4,30,288,150,26),(2103,4,30,288,162,100),(2104,4,30,288,125,111),(2105,4,30,288,126,112),(2106,4,30,288,127,113),(2107,4,30,288,128,114),(2108,4,30,288,155,116),(2109,4,30,288,161,117),(2110,4,31,289,156,20),(2111,4,31,291,134,1),(2112,4,31,293,101,1),(2113,4,31,293,102,2),(2114,4,31,293,100,3),(2115,4,31,293,116,4),(2116,4,31,294,104,1),(2117,4,31,294,106,2),(2118,4,31,294,117,3),(2119,4,31,294,103,10),(2120,4,31,295,78,1),(2121,4,31,295,79,2),(2122,4,31,295,80,3),(2123,4,31,295,81,4),(2124,4,31,295,92,5),(2125,4,31,295,123,6),(2126,4,31,295,124,7),(2127,4,31,295,98,8),(2128,4,31,295,132,8),(2129,4,31,296,121,1),(2130,4,31,296,84,2),(2131,4,31,296,85,3),(2132,4,31,296,86,4),(2133,4,31,297,87,1),(2134,4,31,297,88,2),(2135,4,31,297,89,3),(2136,4,31,297,135,4),(2137,4,31,297,90,5),(2138,4,31,297,96,6),(2139,4,31,298,133,1),(2140,4,31,299,76,1),(2141,4,31,299,75,2),(2142,4,31,299,145,3),(2143,4,31,299,146,4),(2144,4,31,300,97,1),(2145,4,31,300,73,2),(2146,4,31,300,74,3),(2147,4,31,300,130,4),(2148,4,31,300,77,5),(2149,4,31,300,91,6),(2150,4,31,300,129,6),(2151,4,31,300,136,7),(2152,4,31,300,115,8),(2153,4,31,300,82,9),(2154,4,31,300,131,10),(2155,4,31,300,99,11),(2156,4,31,300,122,11),(2157,4,31,300,105,12),(2158,4,31,300,94,13),(2159,4,31,300,95,14),(2160,4,31,300,107,14),(2161,4,31,300,108,15),(2162,4,31,300,140,15),(2163,4,31,300,109,16),(2164,4,31,300,142,16),(2165,4,31,300,110,17),(2166,4,31,300,143,17),(2167,4,31,300,111,18),(2168,4,31,300,144,18),(2169,4,31,300,112,19),(2170,4,31,300,141,19),(2171,4,31,300,113,20),(2172,4,31,300,147,20),(2173,4,31,300,152,21),(2174,4,31,300,114,22),(2175,4,31,300,93,23),(2176,4,31,300,148,24),(2177,4,31,300,149,25),(2178,4,31,300,150,26),(2179,4,31,300,162,100),(2180,4,31,300,125,111),(2181,4,31,300,126,112),(2182,4,31,300,127,113),(2183,4,31,300,128,114),(2184,4,31,300,155,116),(2185,4,31,300,161,117),(2186,4,32,301,156,20),(2187,4,32,303,134,1),(2188,4,32,305,101,1),(2189,4,32,305,102,2),(2190,4,32,305,100,3),(2191,4,32,305,116,4),(2192,4,32,306,104,1),(2193,4,32,306,106,2),(2194,4,32,306,117,3),(2195,4,32,306,103,10),(2196,4,32,307,78,1),(2197,4,32,307,79,2),(2198,4,32,307,80,3),(2199,4,32,307,81,4),(2200,4,32,307,92,5),(2201,4,32,307,123,6),(2202,4,32,307,124,7),(2203,4,32,307,98,8),(2204,4,32,307,132,8),(2205,4,32,308,121,1),(2206,4,32,308,84,2),(2207,4,32,308,85,3),(2208,4,32,308,86,4),(2209,4,32,309,87,1),(2210,4,32,309,88,2),(2211,4,32,309,89,3),(2212,4,32,309,135,4),(2213,4,32,309,90,5),(2214,4,32,309,96,6),(2215,4,32,310,133,1),(2216,4,32,311,76,1),(2217,4,32,311,75,2),(2218,4,32,311,145,3),(2219,4,32,311,146,4),(2220,4,32,312,97,1),(2221,4,32,312,73,2),(2222,4,32,312,74,3),(2223,4,32,312,130,4),(2224,4,32,312,77,5),(2225,4,32,312,91,6),(2226,4,32,312,129,6),(2227,4,32,312,136,7),(2228,4,32,312,115,8),(2229,4,32,312,82,9),(2230,4,32,312,131,10),(2231,4,32,312,99,11),(2232,4,32,312,122,11),(2233,4,32,312,105,12),(2234,4,32,312,94,13),(2235,4,32,312,95,14),(2236,4,32,312,107,14),(2237,4,32,312,108,15),(2238,4,32,312,140,15),(2239,4,32,312,109,16),(2240,4,32,312,142,16),(2241,4,32,312,110,17),(2242,4,32,312,143,17),(2243,4,32,312,111,18),(2244,4,32,312,144,18),(2245,4,32,312,112,19),(2246,4,32,312,141,19),(2247,4,32,312,113,20),(2248,4,32,312,147,20),(2249,4,32,312,152,21),(2250,4,32,312,114,22),(2251,4,32,312,93,23),(2252,4,32,312,148,24),(2253,4,32,312,149,25),(2254,4,32,312,150,26),(2255,4,32,312,162,100),(2256,4,32,312,125,111),(2257,4,32,312,126,112),(2258,4,32,312,127,113),(2259,4,32,312,128,114),(2260,4,32,312,155,116),(2261,4,32,312,161,117),(2262,4,33,313,156,20),(2263,4,33,315,134,1),(2264,4,33,317,101,1),(2265,4,33,317,102,2),(2266,4,33,317,100,3),(2267,4,33,317,116,4),(2268,4,33,318,104,1),(2269,4,33,318,106,2),(2270,4,33,318,117,3),(2271,4,33,318,103,10),(2272,4,33,319,78,1),(2273,4,33,319,79,2),(2274,4,33,319,80,3),(2275,4,33,319,81,4),(2276,4,33,319,92,5),(2277,4,33,319,123,6),(2278,4,33,319,124,7),(2279,4,33,319,98,8),(2280,4,33,319,132,8),(2281,4,33,320,121,1),(2282,4,33,320,84,2),(2283,4,33,320,85,3),(2284,4,33,320,86,4),(2285,4,33,321,87,1),(2286,4,33,321,88,2),(2287,4,33,321,89,3),(2288,4,33,321,135,4),(2289,4,33,321,90,5),(2290,4,33,321,96,6),(2291,4,33,322,133,1),(2292,4,33,323,76,1),(2293,4,33,323,75,2),(2294,4,33,323,145,3),(2295,4,33,323,146,4),(2296,4,33,324,97,1),(2297,4,33,324,73,2),(2298,4,33,324,74,3),(2299,4,33,324,130,4),(2300,4,33,324,77,5),(2301,4,33,324,91,6),(2302,4,33,324,129,6),(2303,4,33,324,136,7),(2304,4,33,324,115,8),(2305,4,33,324,82,9),(2306,4,33,324,131,10),(2307,4,33,324,99,11),(2308,4,33,324,122,11),(2309,4,33,324,105,12),(2310,4,33,324,94,13),(2311,4,33,324,95,14),(2312,4,33,324,107,14),(2313,4,33,324,108,15),(2314,4,33,324,140,15),(2315,4,33,324,109,16),(2316,4,33,324,142,16),(2317,4,33,324,110,17),(2318,4,33,324,143,17),(2319,4,33,324,111,18),(2320,4,33,324,144,18),(2321,4,33,324,112,19),(2322,4,33,324,141,19),(2323,4,33,324,113,20),(2324,4,33,324,147,20),(2325,4,33,324,152,21),(2326,4,33,324,114,22),(2327,4,33,324,93,23),(2328,4,33,324,148,24),(2329,4,33,324,149,25),(2330,4,33,324,150,26),(2331,4,33,324,162,100),(2332,4,33,324,125,111),(2333,4,33,324,126,112),(2334,4,33,324,127,113),(2335,4,33,324,128,114),(2336,4,33,324,155,116),(2337,4,33,324,161,117),(2338,4,34,325,156,20),(2339,4,34,327,134,1),(2340,4,34,329,101,1),(2341,4,34,329,102,2),(2342,4,34,329,100,3),(2343,4,34,329,116,4),(2344,4,34,330,104,1),(2345,4,34,330,106,2),(2346,4,34,330,117,3),(2347,4,34,330,103,10),(2348,4,34,331,78,1),(2349,4,34,331,79,2),(2350,4,34,331,80,3),(2351,4,34,331,81,4),(2352,4,34,331,92,5),(2353,4,34,331,123,6),(2354,4,34,331,124,7),(2355,4,34,331,98,8),(2356,4,34,331,132,8),(2357,4,34,332,121,1),(2358,4,34,332,84,2),(2359,4,34,332,85,3),(2360,4,34,332,86,4),(2361,4,34,333,87,1),(2362,4,34,333,88,2),(2363,4,34,333,89,3),(2364,4,34,333,135,4),(2365,4,34,333,90,5),(2366,4,34,333,96,6),(2367,4,34,334,133,1),(2368,4,34,335,76,1),(2369,4,34,335,75,2),(2370,4,34,335,145,3),(2371,4,34,335,146,4),(2372,4,34,336,97,1),(2373,4,34,336,73,2),(2374,4,34,336,74,3),(2375,4,34,336,130,4),(2376,4,34,336,77,5),(2377,4,34,336,91,6),(2378,4,34,336,129,6),(2379,4,34,336,136,7),(2380,4,34,336,115,8),(2381,4,34,336,82,9),(2382,4,34,336,131,10),(2383,4,34,336,99,11),(2384,4,34,336,122,11),(2385,4,34,336,105,12),(2386,4,34,336,94,13),(2387,4,34,336,95,14),(2388,4,34,336,107,14),(2389,4,34,336,108,15),(2390,4,34,336,140,15),(2391,4,34,336,109,16),(2392,4,34,336,142,16),(2393,4,34,336,110,17),(2394,4,34,336,143,17),(2395,4,34,336,111,18),(2396,4,34,336,144,18),(2397,4,34,336,112,19),(2398,4,34,336,141,19),(2399,4,34,336,113,20),(2400,4,34,336,147,20),(2401,4,34,336,152,21),(2402,4,34,336,114,22),(2403,4,34,336,93,23),(2404,4,34,336,148,24),(2405,4,34,336,149,25),(2406,4,34,336,150,26),(2407,4,34,336,162,100),(2408,4,34,336,125,111),(2409,4,34,336,126,112),(2410,4,34,336,127,113),(2411,4,34,336,128,114),(2412,4,34,336,155,116),(2413,4,34,336,161,117),(2414,4,35,337,156,20),(2415,4,35,339,134,1),(2416,4,35,341,101,1),(2417,4,35,341,102,2),(2418,4,35,341,100,3),(2419,4,35,341,116,4),(2420,4,35,342,104,1),(2421,4,35,342,106,2),(2422,4,35,342,117,3),(2423,4,35,342,103,10),(2424,4,35,343,78,1),(2425,4,35,343,79,2),(2426,4,35,343,80,3),(2427,4,35,343,81,4),(2428,4,35,343,92,5),(2429,4,35,343,123,6),(2430,4,35,343,124,7),(2431,4,35,343,98,8),(2432,4,35,343,132,8),(2433,4,35,344,121,1),(2434,4,35,344,84,2),(2435,4,35,344,85,3),(2436,4,35,344,86,4),(2437,4,35,345,87,1),(2438,4,35,345,88,2),(2439,4,35,345,89,3),(2440,4,35,345,135,4),(2441,4,35,345,90,5),(2442,4,35,345,96,6),(2443,4,35,346,133,1),(2444,4,35,347,76,1),(2445,4,35,347,75,2),(2446,4,35,347,145,3),(2447,4,35,347,146,4),(2448,4,35,348,97,1),(2449,4,35,348,73,2),(2450,4,35,348,74,3),(2451,4,35,348,130,4),(2452,4,35,348,77,5),(2453,4,35,348,91,6),(2454,4,35,348,129,6),(2455,4,35,348,136,7),(2456,4,35,348,115,8),(2457,4,35,348,82,9),(2458,4,35,348,131,10),(2459,4,35,348,99,11),(2460,4,35,348,122,11),(2461,4,35,348,105,12),(2462,4,35,348,94,13),(2463,4,35,348,95,14),(2464,4,35,348,107,14),(2465,4,35,348,108,15),(2466,4,35,348,140,15),(2467,4,35,348,109,16),(2468,4,35,348,142,16),(2469,4,35,348,110,17),(2470,4,35,348,143,17),(2471,4,35,348,111,18),(2472,4,35,348,144,18),(2473,4,35,348,112,19),(2474,4,35,348,141,19),(2475,4,35,348,113,20),(2476,4,35,348,147,20),(2477,4,35,348,152,21),(2478,4,35,348,114,22),(2479,4,35,348,93,23),(2480,4,35,348,148,24),(2481,4,35,348,149,25),(2482,4,35,348,150,26),(2483,4,35,348,162,100),(2484,4,35,348,125,111),(2485,4,35,348,126,112),(2486,4,35,348,127,113),(2487,4,35,348,128,114),(2488,4,35,348,155,116),(2489,4,35,348,161,117),(2490,4,36,349,156,20),(2491,4,36,351,134,1),(2492,4,36,353,101,1),(2493,4,36,353,102,2),(2494,4,36,353,100,3),(2495,4,36,353,116,4),(2496,4,36,354,104,1),(2497,4,36,354,106,2),(2498,4,36,354,117,3),(2499,4,36,354,103,10),(2500,4,36,355,78,1),(2501,4,36,355,79,2),(2502,4,36,355,80,3),(2503,4,36,355,81,4),(2504,4,36,355,92,5),(2505,4,36,355,123,6),(2506,4,36,355,124,7),(2507,4,36,355,98,8),(2508,4,36,355,132,8),(2509,4,36,356,121,1),(2510,4,36,356,84,2),(2511,4,36,356,85,3),(2512,4,36,356,86,4),(2513,4,36,357,87,1),(2514,4,36,357,88,2),(2515,4,36,357,89,3),(2516,4,36,357,135,4),(2517,4,36,357,90,5),(2518,4,36,357,96,6),(2519,4,36,358,133,1),(2520,4,36,359,76,1),(2521,4,36,359,75,2),(2522,4,36,359,145,3),(2523,4,36,359,146,4),(2524,4,36,360,97,1),(2525,4,36,360,73,2),(2526,4,36,360,74,3),(2527,4,36,360,130,4),(2528,4,36,360,77,5),(2529,4,36,360,91,6),(2530,4,36,360,129,6),(2531,4,36,360,136,7),(2532,4,36,360,115,8),(2533,4,36,360,82,9),(2534,4,36,360,131,10),(2535,4,36,360,99,11),(2536,4,36,360,122,11),(2537,4,36,360,105,12),(2538,4,36,360,94,13),(2539,4,36,360,95,14),(2540,4,36,360,107,14),(2541,4,36,360,108,15),(2542,4,36,360,140,15),(2543,4,36,360,109,16),(2544,4,36,360,142,16),(2545,4,36,360,110,17),(2546,4,36,360,143,17),(2547,4,36,360,111,18),(2548,4,36,360,144,18),(2549,4,36,360,112,19),(2550,4,36,360,141,19),(2551,4,36,360,113,20),(2552,4,36,360,147,20),(2553,4,36,360,152,21),(2554,4,36,360,114,22),(2555,4,36,360,93,23),(2556,4,36,360,148,24),(2557,4,36,360,149,25),(2558,4,36,360,150,26),(2559,4,36,360,162,100),(2560,4,36,360,125,111),(2561,4,36,360,126,112),(2562,4,36,360,127,113),(2563,4,36,360,128,114),(2564,4,36,360,155,116),(2565,4,36,360,161,117),(2566,4,37,361,156,20),(2567,4,37,363,134,1),(2568,4,37,365,101,1),(2569,4,37,365,102,2),(2570,4,37,365,100,3),(2571,4,37,365,116,4),(2572,4,37,366,104,1),(2573,4,37,366,106,2),(2574,4,37,366,117,3),(2575,4,37,366,103,10),(2576,4,37,367,78,1),(2577,4,37,367,79,2),(2578,4,37,367,80,3),(2579,4,37,367,81,4),(2580,4,37,367,92,5),(2581,4,37,367,123,6),(2582,4,37,367,124,7),(2583,4,37,367,98,8),(2584,4,37,367,132,8),(2585,4,37,368,121,1),(2586,4,37,368,84,2),(2587,4,37,368,85,3),(2588,4,37,368,86,4),(2589,4,37,369,87,1),(2590,4,37,369,88,2),(2591,4,37,369,89,3),(2592,4,37,369,135,4),(2593,4,37,369,90,5),(2594,4,37,369,96,6),(2595,4,37,370,133,1),(2596,4,37,371,76,1),(2597,4,37,371,75,2),(2598,4,37,371,145,3),(2599,4,37,371,146,4),(2600,4,37,372,97,1),(2601,4,37,372,73,2),(2602,4,37,372,74,3),(2603,4,37,372,130,4),(2604,4,37,372,77,5),(2605,4,37,372,91,6),(2606,4,37,372,129,6),(2607,4,37,372,136,7),(2608,4,37,372,115,8),(2609,4,37,372,82,9),(2610,4,37,372,131,10),(2611,4,37,372,99,11),(2612,4,37,372,122,11),(2613,4,37,372,105,12),(2614,4,37,372,94,13),(2615,4,37,372,95,14),(2616,4,37,372,107,14),(2617,4,37,372,108,15),(2618,4,37,372,140,15),(2619,4,37,372,109,16),(2620,4,37,372,142,16),(2621,4,37,372,110,17),(2622,4,37,372,143,17),(2623,4,37,372,111,18),(2624,4,37,372,144,18),(2625,4,37,372,112,19),(2626,4,37,372,141,19),(2627,4,37,372,113,20),(2628,4,37,372,147,20),(2629,4,37,372,152,21),(2630,4,37,372,114,22),(2631,4,37,372,93,23),(2632,4,37,372,148,24),(2633,4,37,372,149,25),(2634,4,37,372,150,26),(2635,4,37,372,162,100),(2636,4,37,372,125,111),(2637,4,37,372,126,112),(2638,4,37,372,127,113),(2639,4,37,372,128,114),(2640,4,37,372,155,116),(2641,4,37,372,161,117),(2642,4,38,373,156,20),(2643,4,38,375,134,1),(2644,4,38,377,101,1),(2645,4,38,377,102,2),(2646,4,38,377,100,3),(2647,4,38,377,116,4),(2648,4,38,378,104,1),(2649,4,38,378,106,2),(2650,4,38,378,117,3),(2651,4,38,378,103,10),(2652,4,38,379,78,1),(2653,4,38,379,79,2),(2654,4,38,379,80,3),(2655,4,38,379,81,4),(2656,4,38,379,92,5),(2657,4,38,379,123,6),(2658,4,38,379,124,7),(2659,4,38,379,98,8),(2660,4,38,379,132,8),(2661,4,38,380,121,1),(2662,4,38,380,84,2),(2663,4,38,380,85,3),(2664,4,38,380,86,4),(2665,4,38,381,87,1),(2666,4,38,381,88,2),(2667,4,38,381,89,3),(2668,4,38,381,135,4),(2669,4,38,381,90,5),(2670,4,38,381,96,6),(2671,4,38,382,133,1),(2672,4,38,383,76,1),(2673,4,38,383,75,2),(2674,4,38,383,145,3),(2675,4,38,383,146,4),(2676,4,38,384,97,1),(2677,4,38,384,73,2),(2678,4,38,384,74,3),(2679,4,38,384,130,4),(2680,4,38,384,77,5),(2681,4,38,384,91,6),(2682,4,38,384,129,6),(2683,4,38,384,136,7),(2684,4,38,384,115,8),(2685,4,38,384,82,9),(2686,4,38,384,131,10),(2687,4,38,384,99,11),(2688,4,38,384,122,11),(2689,4,38,384,105,12),(2690,4,38,384,94,13),(2691,4,38,384,95,14),(2692,4,38,384,107,14),(2693,4,38,384,108,15),(2694,4,38,384,140,15),(2695,4,38,384,109,16),(2696,4,38,384,142,16),(2697,4,38,384,110,17),(2698,4,38,384,143,17),(2699,4,38,384,111,18),(2700,4,38,384,144,18),(2701,4,38,384,112,19),(2702,4,38,384,141,19),(2703,4,38,384,113,20),(2704,4,38,384,147,20),(2705,4,38,384,152,21),(2706,4,38,384,114,22),(2707,4,38,384,93,23),(2708,4,38,384,148,24),(2709,4,38,384,149,25),(2710,4,38,384,150,26),(2711,4,38,384,162,100),(2712,4,38,384,125,111),(2713,4,38,384,126,112),(2714,4,38,384,127,113),(2715,4,38,384,128,114),(2716,4,38,384,155,116),(2717,4,38,384,161,117),(2718,4,39,385,156,20),(2719,4,39,387,134,1),(2720,4,39,389,101,1),(2721,4,39,389,102,2),(2722,4,39,389,100,3),(2723,4,39,389,116,4),(2724,4,39,390,104,1),(2725,4,39,390,106,2),(2726,4,39,390,117,3),(2727,4,39,390,103,10),(2728,4,39,391,78,1),(2729,4,39,391,79,2),(2730,4,39,391,80,3),(2731,4,39,391,81,4),(2732,4,39,391,92,5),(2733,4,39,391,123,6),(2734,4,39,391,124,7),(2735,4,39,391,98,8),(2736,4,39,391,132,8),(2737,4,39,392,121,1),(2738,4,39,392,84,2),(2739,4,39,392,85,3),(2740,4,39,392,86,4),(2741,4,39,393,87,1),(2742,4,39,393,88,2),(2743,4,39,393,89,3),(2744,4,39,393,135,4),(2745,4,39,393,90,5),(2746,4,39,393,96,6),(2747,4,39,394,133,1),(2748,4,39,395,76,1),(2749,4,39,395,75,2),(2750,4,39,395,145,3),(2751,4,39,395,146,4),(2752,4,39,396,97,1),(2753,4,39,396,73,2),(2754,4,39,396,74,3),(2755,4,39,396,130,4),(2756,4,39,396,77,5),(2757,4,39,396,91,6),(2758,4,39,396,129,6),(2759,4,39,396,136,7),(2760,4,39,396,115,8),(2761,4,39,396,82,9),(2762,4,39,396,131,10),(2763,4,39,396,99,11),(2764,4,39,396,122,11),(2765,4,39,396,105,12),(2766,4,39,396,94,13),(2767,4,39,396,95,14),(2768,4,39,396,107,14),(2769,4,39,396,108,15),(2770,4,39,396,140,15),(2771,4,39,396,109,16),(2772,4,39,396,142,16),(2773,4,39,396,110,17),(2774,4,39,396,143,17),(2775,4,39,396,111,18),(2776,4,39,396,144,18),(2777,4,39,396,112,19),(2778,4,39,396,141,19),(2779,4,39,396,113,20),(2780,4,39,396,147,20),(2781,4,39,396,152,21),(2782,4,39,396,114,22),(2783,4,39,396,93,23),(2784,4,39,396,148,24),(2785,4,39,396,149,25),(2786,4,39,396,150,26),(2787,4,39,396,162,100),(2788,4,39,396,125,111),(2789,4,39,396,126,112),(2790,4,39,396,127,113),(2791,4,39,396,128,114),(2792,4,39,396,155,116),(2793,4,39,396,161,117),(2794,4,40,397,156,20),(2795,4,40,399,134,1),(2796,4,40,401,101,1),(2797,4,40,401,102,2),(2798,4,40,401,100,3),(2799,4,40,401,116,4),(2800,4,40,402,104,1),(2801,4,40,402,106,2),(2802,4,40,402,117,3),(2803,4,40,402,103,10),(2804,4,40,403,78,1),(2805,4,40,403,79,2),(2806,4,40,403,80,3),(2807,4,40,403,81,4),(2808,4,40,403,92,5),(2809,4,40,403,123,6),(2810,4,40,403,124,7),(2811,4,40,403,98,8),(2812,4,40,403,132,8),(2813,4,40,404,121,1),(2814,4,40,404,84,2),(2815,4,40,404,85,3),(2816,4,40,404,86,4),(2817,4,40,405,87,1),(2818,4,40,405,88,2),(2819,4,40,405,89,3),(2820,4,40,405,135,4),(2821,4,40,405,90,5),(2822,4,40,405,96,6),(2823,4,40,406,133,1),(2824,4,40,407,76,1),(2825,4,40,407,75,2),(2826,4,40,407,145,3),(2827,4,40,407,146,4),(2828,4,40,408,97,1),(2829,4,40,408,73,2),(2830,4,40,408,74,3),(2831,4,40,408,130,4),(2832,4,40,408,77,5),(2833,4,40,408,91,6),(2834,4,40,408,129,6),(2835,4,40,408,136,7),(2836,4,40,408,115,8),(2837,4,40,408,82,9),(2838,4,40,408,131,10),(2839,4,40,408,99,11),(2840,4,40,408,122,11),(2841,4,40,408,105,12),(2842,4,40,408,94,13),(2843,4,40,408,95,14),(2844,4,40,408,107,14),(2845,4,40,408,108,15),(2846,4,40,408,140,15),(2847,4,40,408,109,16),(2848,4,40,408,142,16),(2849,4,40,408,110,17),(2850,4,40,408,143,17),(2851,4,40,408,111,18),(2852,4,40,408,144,18),(2853,4,40,408,112,19),(2854,4,40,408,141,19),(2855,4,40,408,113,20),(2856,4,40,408,147,20),(2857,4,40,408,152,21),(2858,4,40,408,114,22),(2859,4,40,408,93,23),(2860,4,40,408,148,24),(2861,4,40,408,149,25),(2862,4,40,408,150,26),(2863,4,40,408,162,100),(2864,4,40,408,125,111),(2865,4,40,408,126,112),(2866,4,40,408,127,113),(2867,4,40,408,128,114),(2868,4,40,408,155,116),(2869,4,40,408,161,117),(2870,4,41,409,156,20),(2871,4,41,411,134,1),(2872,4,41,413,101,1),(2873,4,41,413,102,2),(2874,4,41,413,100,3),(2875,4,41,413,116,4),(2876,4,41,414,104,1),(2877,4,41,414,106,2),(2878,4,41,414,117,3),(2879,4,41,414,103,10),(2880,4,41,415,78,1),(2881,4,41,415,79,2),(2882,4,41,415,80,3),(2883,4,41,415,81,4),(2884,4,41,415,92,5),(2885,4,41,415,123,6),(2886,4,41,415,124,7),(2887,4,41,415,98,8),(2888,4,41,415,132,8),(2889,4,41,416,121,1),(2890,4,41,416,84,2),(2891,4,41,416,85,3),(2892,4,41,416,86,4),(2893,4,41,417,87,1),(2894,4,41,417,88,2),(2895,4,41,417,89,3),(2896,4,41,417,135,4),(2897,4,41,417,90,5),(2898,4,41,417,96,6),(2899,4,41,418,133,1),(2900,4,41,419,76,1),(2901,4,41,419,75,2),(2902,4,41,419,145,3),(2903,4,41,419,146,4),(2904,4,41,420,97,1),(2905,4,41,420,73,2),(2906,4,41,420,74,3),(2907,4,41,420,130,4),(2908,4,41,420,77,5),(2909,4,41,420,91,6),(2910,4,41,420,129,6),(2911,4,41,420,136,7),(2912,4,41,420,115,8),(2913,4,41,420,82,9),(2914,4,41,420,131,10),(2915,4,41,420,99,11),(2916,4,41,420,122,11),(2917,4,41,420,105,12),(2918,4,41,420,94,13),(2919,4,41,420,95,14),(2920,4,41,420,107,14),(2921,4,41,420,108,15),(2922,4,41,420,140,15),(2923,4,41,420,109,16),(2924,4,41,420,142,16),(2925,4,41,420,110,17),(2926,4,41,420,143,17),(2927,4,41,420,111,18),(2928,4,41,420,144,18),(2929,4,41,420,112,19),(2930,4,41,420,141,19),(2931,4,41,420,113,20),(2932,4,41,420,147,20),(2933,4,41,420,152,21),(2934,4,41,420,114,22),(2935,4,41,420,93,23),(2936,4,41,420,148,24),(2937,4,41,420,149,25),(2938,4,41,420,150,26),(2939,4,41,420,162,100),(2940,4,41,420,125,111),(2941,4,41,420,126,112),(2942,4,41,420,127,113),(2943,4,41,420,128,114),(2944,4,41,420,155,116),(2945,4,41,420,161,117),(2946,4,42,421,156,20),(2947,4,42,423,134,1),(2948,4,42,425,101,1),(2949,4,42,425,102,2),(2950,4,42,425,100,3),(2951,4,42,425,116,4),(2952,4,42,426,104,1),(2953,4,42,426,106,2),(2954,4,42,426,117,3),(2955,4,42,426,103,10),(2956,4,42,427,78,1),(2957,4,42,427,79,2),(2958,4,42,427,80,3),(2959,4,42,427,81,4),(2960,4,42,427,92,5),(2961,4,42,427,123,6),(2962,4,42,427,124,7),(2963,4,42,427,98,8),(2964,4,42,427,132,8),(2965,4,42,428,121,1),(2966,4,42,428,84,2),(2967,4,42,428,85,3),(2968,4,42,428,86,4),(2969,4,42,429,87,1),(2970,4,42,429,88,2),(2971,4,42,429,89,3),(2972,4,42,429,135,4),(2973,4,42,429,90,5),(2974,4,42,429,96,6),(2975,4,42,430,133,1),(2976,4,42,431,76,1),(2977,4,42,431,75,2),(2978,4,42,431,145,3),(2979,4,42,431,146,4),(2980,4,42,432,97,1),(2981,4,42,432,73,2),(2982,4,42,432,74,3),(2983,4,42,432,130,4),(2984,4,42,432,77,5),(2985,4,42,432,91,6),(2986,4,42,432,129,6),(2987,4,42,432,136,7),(2988,4,42,432,115,8),(2989,4,42,432,82,9),(2990,4,42,432,131,10),(2991,4,42,432,99,11),(2992,4,42,432,122,11),(2993,4,42,432,105,12),(2994,4,42,432,94,13),(2995,4,42,432,95,14),(2996,4,42,432,107,14),(2997,4,42,432,108,15),(2998,4,42,432,140,15),(2999,4,42,432,109,16),(3000,4,42,432,142,16),(3001,4,42,432,110,17),(3002,4,42,432,143,17),(3003,4,42,432,111,18),(3004,4,42,432,144,18),(3005,4,42,432,112,19),(3006,4,42,432,141,19),(3007,4,42,432,113,20),(3008,4,42,432,147,20),(3009,4,42,432,152,21),(3010,4,42,432,114,22),(3011,4,42,432,93,23),(3012,4,42,432,148,24),(3013,4,42,432,149,25),(3014,4,42,432,150,26),(3015,4,42,432,162,100),(3016,4,42,432,125,111),(3017,4,42,432,126,112),(3018,4,42,432,127,113),(3019,4,42,432,128,114),(3020,4,42,432,155,116),(3021,4,42,432,161,117),(3022,4,43,433,156,20),(3023,4,43,435,134,1),(3024,4,43,437,101,1),(3025,4,43,437,102,2),(3026,4,43,437,100,3),(3027,4,43,437,116,4),(3028,4,43,438,104,1),(3029,4,43,438,106,2),(3030,4,43,438,117,3),(3031,4,43,438,103,10),(3032,4,43,439,78,1),(3033,4,43,439,79,2),(3034,4,43,439,80,3),(3035,4,43,439,81,4),(3036,4,43,439,92,5),(3037,4,43,439,123,6),(3038,4,43,439,124,7),(3039,4,43,439,98,8),(3040,4,43,439,132,8),(3041,4,43,440,121,1),(3042,4,43,440,84,2),(3043,4,43,440,85,3),(3044,4,43,440,86,4),(3045,4,43,441,87,1),(3046,4,43,441,88,2),(3047,4,43,441,89,3),(3048,4,43,441,135,4),(3049,4,43,441,90,5),(3050,4,43,441,96,6),(3051,4,43,442,133,1),(3052,4,43,443,76,1),(3053,4,43,443,75,2),(3054,4,43,443,145,3),(3055,4,43,443,146,4),(3056,4,43,444,97,1),(3057,4,43,444,73,2),(3058,4,43,444,74,3),(3059,4,43,444,130,4),(3060,4,43,444,77,5),(3061,4,43,444,91,6),(3062,4,43,444,129,6),(3063,4,43,444,136,7),(3064,4,43,444,115,8),(3065,4,43,444,82,9),(3066,4,43,444,131,10),(3067,4,43,444,99,11),(3068,4,43,444,122,11),(3069,4,43,444,105,12),(3070,4,43,444,94,13),(3071,4,43,444,95,14),(3072,4,43,444,107,14),(3073,4,43,444,108,15),(3074,4,43,444,140,15),(3075,4,43,444,109,16),(3076,4,43,444,142,16),(3077,4,43,444,110,17),(3078,4,43,444,143,17),(3079,4,43,444,111,18),(3080,4,43,444,144,18),(3081,4,43,444,112,19),(3082,4,43,444,141,19),(3083,4,43,444,113,20),(3084,4,43,444,147,20),(3085,4,43,444,152,21),(3086,4,43,444,114,22),(3087,4,43,444,93,23),(3088,4,43,444,148,24),(3089,4,43,444,149,25),(3090,4,43,444,150,26),(3091,4,43,444,162,100),(3092,4,43,444,125,111),(3093,4,43,444,126,112),(3094,4,43,444,127,113),(3095,4,43,444,128,114),(3096,4,43,444,155,116),(3097,4,43,444,161,117),(3098,4,44,445,156,20),(3099,4,44,447,134,1),(3100,4,44,449,101,1),(3101,4,44,449,102,2),(3102,4,44,449,100,3),(3103,4,44,449,116,4),(3104,4,44,450,104,1),(3105,4,44,450,106,2),(3106,4,44,450,117,3),(3107,4,44,450,103,10),(3108,4,44,451,78,1),(3109,4,44,451,79,2),(3110,4,44,451,80,3),(3111,4,44,451,81,4),(3112,4,44,451,92,5),(3113,4,44,451,123,6),(3114,4,44,451,124,7),(3115,4,44,451,98,8),(3116,4,44,451,132,8),(3117,4,44,452,121,1),(3118,4,44,452,84,2),(3119,4,44,452,85,3),(3120,4,44,452,86,4),(3121,4,44,453,87,1),(3122,4,44,453,88,2),(3123,4,44,453,89,3),(3124,4,44,453,135,4),(3125,4,44,453,90,5),(3126,4,44,453,96,6),(3127,4,44,454,133,1),(3128,4,44,455,76,1),(3129,4,44,455,75,2),(3130,4,44,455,145,3),(3131,4,44,455,146,4),(3132,4,44,456,97,1),(3133,4,44,456,73,2),(3134,4,44,456,74,3),(3135,4,44,456,130,4),(3136,4,44,456,77,5),(3137,4,44,456,91,6),(3138,4,44,456,129,6),(3139,4,44,456,136,7),(3140,4,44,456,115,8),(3141,4,44,456,82,9),(3142,4,44,456,131,10),(3143,4,44,456,99,11),(3144,4,44,456,122,11),(3145,4,44,456,105,12),(3146,4,44,456,94,13),(3147,4,44,456,95,14),(3148,4,44,456,107,14),(3149,4,44,456,108,15),(3150,4,44,456,140,15),(3151,4,44,456,109,16),(3152,4,44,456,142,16),(3153,4,44,456,110,17),(3154,4,44,456,143,17),(3155,4,44,456,111,18),(3156,4,44,456,144,18),(3157,4,44,456,112,19),(3158,4,44,456,141,19),(3159,4,44,456,113,20),(3160,4,44,456,147,20),(3161,4,44,456,152,21),(3162,4,44,456,114,22),(3163,4,44,456,93,23),(3164,4,44,456,148,24),(3165,4,44,456,149,25),(3166,4,44,456,150,26),(3167,4,44,456,162,100),(3168,4,44,456,125,111),(3169,4,44,456,126,112),(3170,4,44,456,127,113),(3171,4,44,456,128,114),(3172,4,44,456,155,116),(3173,4,44,456,161,117),(3174,4,45,457,156,20),(3175,4,45,459,134,1),(3176,4,45,461,101,1),(3177,4,45,461,102,2),(3178,4,45,461,100,3),(3179,4,45,461,116,4),(3180,4,45,462,104,1),(3181,4,45,462,106,2),(3182,4,45,462,117,3),(3183,4,45,462,103,10),(3184,4,45,463,78,1),(3185,4,45,463,79,2),(3186,4,45,463,80,3),(3187,4,45,463,81,4),(3188,4,45,463,92,5),(3189,4,45,463,123,6),(3190,4,45,463,124,7),(3191,4,45,463,98,8),(3192,4,45,463,132,8),(3193,4,45,464,121,1),(3194,4,45,464,84,2),(3195,4,45,464,85,3),(3196,4,45,464,86,4),(3197,4,45,465,87,1),(3198,4,45,465,88,2),(3199,4,45,465,89,3),(3200,4,45,465,135,4),(3201,4,45,465,90,5),(3202,4,45,465,96,6),(3203,4,45,466,133,1),(3204,4,45,467,76,1),(3205,4,45,467,75,2),(3206,4,45,467,145,3),(3207,4,45,467,146,4),(3208,4,45,468,97,1),(3209,4,45,468,73,2),(3210,4,45,468,74,3),(3211,4,45,468,130,4),(3212,4,45,468,77,5),(3213,4,45,468,91,6),(3214,4,45,468,129,6),(3215,4,45,468,136,7),(3216,4,45,468,115,8),(3217,4,45,468,82,9),(3218,4,45,468,131,10),(3219,4,45,468,99,11),(3220,4,45,468,122,11),(3221,4,45,468,105,12),(3222,4,45,468,94,13),(3223,4,45,468,95,14),(3224,4,45,468,107,14),(3225,4,45,468,108,15),(3226,4,45,468,140,15),(3227,4,45,468,109,16),(3228,4,45,468,142,16),(3229,4,45,468,110,17),(3230,4,45,468,143,17),(3231,4,45,468,111,18),(3232,4,45,468,144,18),(3233,4,45,468,112,19),(3234,4,45,468,141,19),(3235,4,45,468,113,20),(3236,4,45,468,147,20),(3237,4,45,468,152,21),(3238,4,45,468,114,22),(3239,4,45,468,93,23),(3240,4,45,468,148,24),(3241,4,45,468,149,25),(3242,4,45,468,150,26),(3243,4,45,468,162,100),(3244,4,45,468,125,111),(3245,4,45,468,126,112),(3246,4,45,468,127,113),(3247,4,45,468,128,114),(3248,4,45,468,155,116),(3249,4,45,468,161,117),(3250,4,46,469,156,20),(3251,4,46,471,134,1),(3252,4,46,473,101,1),(3253,4,46,473,102,2),(3254,4,46,473,100,3),(3255,4,46,473,116,4),(3256,4,46,474,104,1),(3257,4,46,474,106,2),(3258,4,46,474,117,3),(3259,4,46,474,103,10),(3260,4,46,475,78,1),(3261,4,46,475,79,2),(3262,4,46,475,80,3),(3263,4,46,475,81,4),(3264,4,46,475,92,5),(3265,4,46,475,123,6),(3266,4,46,475,124,7),(3267,4,46,475,98,8),(3268,4,46,475,132,8),(3269,4,46,476,121,1),(3270,4,46,476,84,2),(3271,4,46,476,85,3),(3272,4,46,476,86,4),(3273,4,46,477,87,1),(3274,4,46,477,88,2),(3275,4,46,477,89,3),(3276,4,46,477,135,4),(3277,4,46,477,90,5),(3278,4,46,477,96,6),(3279,4,46,478,133,1),(3280,4,46,479,76,1),(3281,4,46,479,75,2),(3282,4,46,479,145,3),(3283,4,46,479,146,4),(3284,4,46,480,97,1),(3285,4,46,480,73,2),(3286,4,46,480,74,3),(3287,4,46,480,130,4),(3288,4,46,480,77,5),(3289,4,46,480,91,6),(3290,4,46,480,129,6),(3291,4,46,480,136,7),(3292,4,46,480,115,8),(3293,4,46,480,82,9),(3294,4,46,480,131,10),(3295,4,46,480,99,11),(3296,4,46,480,122,11),(3297,4,46,480,105,12),(3298,4,46,480,94,13),(3299,4,46,480,95,14),(3300,4,46,480,107,14),(3301,4,46,480,108,15),(3302,4,46,480,140,15),(3303,4,46,480,109,16),(3304,4,46,480,142,16),(3305,4,46,480,110,17),(3306,4,46,480,143,17),(3307,4,46,480,111,18),(3308,4,46,480,144,18),(3309,4,46,480,112,19),(3310,4,46,480,141,19),(3311,4,46,480,113,20),(3312,4,46,480,147,20),(3313,4,46,480,152,21),(3314,4,46,480,114,22),(3315,4,46,480,93,23),(3316,4,46,480,148,24),(3317,4,46,480,149,25),(3318,4,46,480,150,26),(3319,4,46,480,162,100),(3320,4,46,480,125,111),(3321,4,46,480,126,112),(3322,4,46,480,127,113),(3323,4,46,480,128,114),(3324,4,46,480,155,116),(3325,4,46,480,161,117),(3326,4,47,481,156,20),(3327,4,47,483,134,1),(3328,4,47,485,101,1),(3329,4,47,485,102,2),(3330,4,47,485,100,3),(3331,4,47,485,116,4),(3332,4,47,486,104,1),(3333,4,47,486,106,2),(3334,4,47,486,117,3),(3335,4,47,486,103,10),(3336,4,47,487,78,1),(3337,4,47,487,79,2),(3338,4,47,487,80,3),(3339,4,47,487,81,4),(3340,4,47,487,92,5),(3341,4,47,487,123,6),(3342,4,47,487,124,7),(3343,4,47,487,98,8),(3344,4,47,487,132,8),(3345,4,47,488,121,1),(3346,4,47,488,84,2),(3347,4,47,488,85,3),(3348,4,47,488,86,4),(3349,4,47,489,87,1),(3350,4,47,489,88,2),(3351,4,47,489,89,3),(3352,4,47,489,135,4),(3353,4,47,489,90,5),(3354,4,47,489,96,6),(3355,4,47,490,133,1),(3356,4,47,491,76,1),(3357,4,47,491,75,2),(3358,4,47,491,145,3),(3359,4,47,491,146,4),(3360,4,47,492,97,1),(3361,4,47,492,73,2),(3362,4,47,492,74,3),(3363,4,47,492,130,4),(3364,4,47,492,77,5),(3365,4,47,492,91,6),(3366,4,47,492,129,6),(3367,4,47,492,136,7),(3368,4,47,492,115,8),(3369,4,47,492,82,9),(3370,4,47,492,131,10),(3371,4,47,492,99,11),(3372,4,47,492,122,11),(3373,4,47,492,105,12),(3374,4,47,492,94,13),(3375,4,47,492,95,14),(3376,4,47,492,107,14),(3377,4,47,492,108,15),(3378,4,47,492,140,15),(3379,4,47,492,109,16),(3380,4,47,492,142,16),(3381,4,47,492,110,17),(3382,4,47,492,143,17),(3383,4,47,492,111,18),(3384,4,47,492,144,18),(3385,4,47,492,112,19),(3386,4,47,492,141,19),(3387,4,47,492,113,20),(3388,4,47,492,147,20),(3389,4,47,492,152,21),(3390,4,47,492,114,22),(3391,4,47,492,93,23),(3392,4,47,492,148,24),(3393,4,47,492,149,25),(3394,4,47,492,150,26),(3395,4,47,492,162,100),(3396,4,47,492,125,111),(3397,4,47,492,126,112),(3398,4,47,492,127,113),(3399,4,47,492,128,114),(3400,4,47,492,155,116),(3401,4,47,492,161,117),(3402,4,48,493,156,20),(3403,4,48,495,134,1),(3404,4,48,497,101,1),(3405,4,48,497,102,2),(3406,4,48,497,100,3),(3407,4,48,497,116,4),(3408,4,48,498,104,1),(3409,4,48,498,106,2),(3410,4,48,498,117,3),(3411,4,48,498,103,10),(3412,4,48,499,78,1),(3413,4,48,499,79,2),(3414,4,48,499,80,3),(3415,4,48,499,81,4),(3416,4,48,499,92,5),(3417,4,48,499,123,6),(3418,4,48,499,124,7),(3419,4,48,499,98,8),(3420,4,48,499,132,8),(3421,4,48,500,121,1),(3422,4,48,500,84,2),(3423,4,48,500,85,3),(3424,4,48,500,86,4),(3425,4,48,501,87,1),(3426,4,48,501,88,2),(3427,4,48,501,89,3),(3428,4,48,501,135,4),(3429,4,48,501,90,5),(3430,4,48,501,96,6),(3431,4,48,502,133,1),(3432,4,48,503,76,1),(3433,4,48,503,75,2),(3434,4,48,503,145,3),(3435,4,48,503,146,4),(3436,4,48,504,97,1),(3437,4,48,504,73,2),(3438,4,48,504,74,3),(3439,4,48,504,130,4),(3440,4,48,504,77,5),(3441,4,48,504,91,6),(3442,4,48,504,129,6),(3443,4,48,504,136,7),(3444,4,48,504,115,8),(3445,4,48,504,82,9),(3446,4,48,504,131,10),(3447,4,48,504,99,11),(3448,4,48,504,122,11),(3449,4,48,504,105,12),(3450,4,48,504,94,13),(3451,4,48,504,95,14),(3452,4,48,504,107,14),(3453,4,48,504,108,15),(3454,4,48,504,140,15),(3455,4,48,504,109,16),(3456,4,48,504,142,16),(3457,4,48,504,110,17),(3458,4,48,504,143,17),(3459,4,48,504,111,18),(3460,4,48,504,144,18),(3461,4,48,504,112,19),(3462,4,48,504,141,19),(3463,4,48,504,113,20),(3464,4,48,504,147,20),(3465,4,48,504,152,21),(3466,4,48,504,114,22),(3467,4,48,504,93,23),(3468,4,48,504,148,24),(3469,4,48,504,149,25),(3470,4,48,504,150,26),(3471,4,48,504,162,100),(3472,4,48,504,125,111),(3473,4,48,504,126,112),(3474,4,48,504,127,113),(3475,4,48,504,128,114),(3476,4,48,504,155,116),(3477,4,48,504,161,117),(3478,4,49,505,156,20),(3479,4,49,507,134,1),(3480,4,49,509,101,1),(3481,4,49,509,102,2),(3482,4,49,509,100,3),(3483,4,49,509,116,4),(3484,4,49,510,104,1),(3485,4,49,510,106,2),(3486,4,49,510,117,3),(3487,4,49,510,103,10),(3488,4,49,511,78,1),(3489,4,49,511,79,2),(3490,4,49,511,80,3),(3491,4,49,511,81,4),(3492,4,49,511,92,5),(3493,4,49,511,123,6),(3494,4,49,511,124,7),(3495,4,49,511,98,8),(3496,4,49,511,132,8),(3497,4,49,512,121,1),(3498,4,49,512,84,2),(3499,4,49,512,85,3),(3500,4,49,512,86,4),(3501,4,49,513,87,1),(3502,4,49,513,88,2),(3503,4,49,513,89,3),(3504,4,49,513,135,4),(3505,4,49,513,90,5),(3506,4,49,513,96,6),(3507,4,49,514,133,1),(3508,4,49,515,76,1),(3509,4,49,515,75,2),(3510,4,49,515,145,3),(3511,4,49,515,146,4),(3512,4,49,516,97,1),(3513,4,49,516,73,2),(3514,4,49,516,74,3),(3515,4,49,516,130,4),(3516,4,49,516,77,5),(3517,4,49,516,91,6),(3518,4,49,516,129,6),(3519,4,49,516,136,7),(3520,4,49,516,115,8),(3521,4,49,516,82,9),(3522,4,49,516,131,10),(3523,4,49,516,99,11),(3524,4,49,516,122,11),(3525,4,49,516,105,12),(3526,4,49,516,94,13),(3527,4,49,516,95,14),(3528,4,49,516,107,14),(3529,4,49,516,108,15),(3530,4,49,516,140,15),(3531,4,49,516,109,16),(3532,4,49,516,142,16),(3533,4,49,516,110,17),(3534,4,49,516,143,17),(3535,4,49,516,111,18),(3536,4,49,516,144,18),(3537,4,49,516,112,19),(3538,4,49,516,141,19),(3539,4,49,516,113,20),(3540,4,49,516,147,20),(3541,4,49,516,152,21),(3542,4,49,516,114,22),(3543,4,49,516,93,23),(3544,4,49,516,148,24),(3545,4,49,516,149,25),(3546,4,49,516,150,26),(3547,4,49,516,162,100),(3548,4,49,516,125,111),(3549,4,49,516,126,112),(3550,4,49,516,127,113),(3551,4,49,516,128,114),(3552,4,49,516,155,116),(3553,4,49,516,161,117),(3554,4,50,517,156,20),(3555,4,50,519,134,1),(3556,4,50,521,101,1),(3557,4,50,521,102,2),(3558,4,50,521,100,3),(3559,4,50,521,116,4),(3560,4,50,522,104,1),(3561,4,50,522,106,2),(3562,4,50,522,117,3),(3563,4,50,522,103,10),(3564,4,50,523,78,1),(3565,4,50,523,79,2),(3566,4,50,523,80,3),(3567,4,50,523,81,4),(3568,4,50,523,92,5),(3569,4,50,523,123,6),(3570,4,50,523,124,7),(3571,4,50,523,98,8),(3572,4,50,523,132,8),(3573,4,50,524,121,1),(3574,4,50,524,84,2),(3575,4,50,524,85,3),(3576,4,50,524,86,4),(3577,4,50,525,87,1),(3578,4,50,525,88,2),(3579,4,50,525,89,3),(3580,4,50,525,135,4),(3581,4,50,525,90,5),(3582,4,50,525,96,6),(3583,4,50,526,133,1),(3584,4,50,527,76,1),(3585,4,50,527,75,2),(3586,4,50,527,145,3),(3587,4,50,527,146,4),(3588,4,50,528,97,1),(3589,4,50,528,73,2),(3590,4,50,528,74,3),(3591,4,50,528,130,4),(3592,4,50,528,77,5),(3593,4,50,528,91,6),(3594,4,50,528,129,6),(3595,4,50,528,136,7),(3596,4,50,528,115,8),(3597,4,50,528,82,9),(3598,4,50,528,131,10),(3599,4,50,528,99,11),(3600,4,50,528,122,11),(3601,4,50,528,105,12),(3602,4,50,528,94,13),(3603,4,50,528,95,14),(3604,4,50,528,107,14),(3605,4,50,528,108,15),(3606,4,50,528,140,15),(3607,4,50,528,109,16),(3608,4,50,528,142,16),(3609,4,50,528,110,17),(3610,4,50,528,143,17),(3611,4,50,528,111,18),(3612,4,50,528,144,18),(3613,4,50,528,112,19),(3614,4,50,528,141,19),(3615,4,50,528,113,20),(3616,4,50,528,147,20),(3617,4,50,528,152,21),(3618,4,50,528,114,22),(3619,4,50,528,93,23),(3620,4,50,528,148,24),(3621,4,50,528,149,25),(3622,4,50,528,150,26),(3623,4,50,528,162,100),(3624,4,50,528,125,111),(3625,4,50,528,126,112),(3626,4,50,528,127,113),(3627,4,50,528,128,114),(3628,4,50,528,155,116),(3629,4,50,528,161,117),(3630,4,51,529,156,20),(3631,4,51,531,134,1),(3632,4,51,533,101,1),(3633,4,51,533,102,2),(3634,4,51,533,100,3),(3635,4,51,533,116,4),(3636,4,51,534,104,1),(3637,4,51,534,106,2),(3638,4,51,534,117,3),(3639,4,51,534,103,10),(3640,4,51,535,78,1),(3641,4,51,535,79,2),(3642,4,51,535,80,3),(3643,4,51,535,81,4),(3644,4,51,535,92,5),(3645,4,51,535,123,6),(3646,4,51,535,124,7),(3647,4,51,535,98,8),(3648,4,51,535,132,8),(3649,4,51,536,121,1),(3650,4,51,536,84,2),(3651,4,51,536,85,3),(3652,4,51,536,86,4),(3653,4,51,537,87,1),(3654,4,51,537,88,2),(3655,4,51,537,89,3),(3656,4,51,537,135,4),(3657,4,51,537,90,5),(3658,4,51,537,96,6),(3659,4,51,538,133,1),(3660,4,51,539,76,1),(3661,4,51,539,75,2),(3662,4,51,539,145,3),(3663,4,51,539,146,4),(3664,4,51,540,97,1),(3665,4,51,540,73,2),(3666,4,51,540,74,3),(3667,4,51,540,130,4),(3668,4,51,540,77,5),(3669,4,51,540,91,6),(3670,4,51,540,129,6),(3671,4,51,540,136,7),(3672,4,51,540,115,8),(3673,4,51,540,82,9),(3674,4,51,540,131,10),(3675,4,51,540,99,11),(3676,4,51,540,122,11),(3677,4,51,540,105,12),(3678,4,51,540,94,13),(3679,4,51,540,95,14),(3680,4,51,540,107,14),(3681,4,51,540,108,15),(3682,4,51,540,140,15),(3683,4,51,540,109,16),(3684,4,51,540,142,16),(3685,4,51,540,110,17),(3686,4,51,540,143,17),(3687,4,51,540,111,18),(3688,4,51,540,144,18),(3689,4,51,540,112,19),(3690,4,51,540,141,19),(3691,4,51,540,113,20),(3692,4,51,540,147,20),(3693,4,51,540,152,21),(3694,4,51,540,114,22),(3695,4,51,540,93,23),(3696,4,51,540,148,24),(3697,4,51,540,149,25),(3698,4,51,540,150,26),(3699,4,51,540,162,100),(3700,4,51,540,125,111),(3701,4,51,540,126,112),(3702,4,51,540,127,113),(3703,4,51,540,128,114),(3704,4,51,540,155,116),(3705,4,51,540,161,117),(3706,4,52,541,156,20),(3707,4,52,543,134,1),(3708,4,52,545,101,1),(3709,4,52,545,102,2),(3710,4,52,545,100,3),(3711,4,52,545,116,4),(3712,4,52,546,104,1),(3713,4,52,546,106,2),(3714,4,52,546,117,3),(3715,4,52,546,103,10),(3716,4,52,547,78,1),(3717,4,52,547,79,2),(3718,4,52,547,80,3),(3719,4,52,547,81,4),(3720,4,52,547,92,5),(3721,4,52,547,123,6),(3722,4,52,547,124,7),(3723,4,52,547,98,8),(3724,4,52,547,132,8),(3725,4,52,548,121,1),(3726,4,52,548,84,2),(3727,4,52,548,85,3),(3728,4,52,548,86,4),(3729,4,52,549,87,1),(3730,4,52,549,88,2),(3731,4,52,549,89,3),(3732,4,52,549,135,4),(3733,4,52,549,90,5),(3734,4,52,549,96,6),(3735,4,52,550,133,1),(3736,4,52,551,76,1),(3737,4,52,551,75,2),(3738,4,52,551,145,3),(3739,4,52,551,146,4),(3740,4,52,552,97,1),(3741,4,52,552,73,2),(3742,4,52,552,74,3),(3743,4,52,552,130,4),(3744,4,52,552,77,5),(3745,4,52,552,91,6),(3746,4,52,552,129,6),(3747,4,52,552,136,7),(3748,4,52,552,115,8),(3749,4,52,552,82,9),(3750,4,52,552,131,10),(3751,4,52,552,99,11),(3752,4,52,552,122,11),(3753,4,52,552,105,12),(3754,4,52,552,94,13),(3755,4,52,552,95,14),(3756,4,52,552,107,14),(3757,4,52,552,108,15),(3758,4,52,552,140,15),(3759,4,52,552,109,16),(3760,4,52,552,142,16),(3761,4,52,552,110,17),(3762,4,52,552,143,17),(3763,4,52,552,111,18),(3764,4,52,552,144,18),(3765,4,52,552,112,19),(3766,4,52,552,141,19),(3767,4,52,552,113,20),(3768,4,52,552,147,20),(3769,4,52,552,152,21),(3770,4,52,552,114,22),(3771,4,52,552,93,23),(3772,4,52,552,148,24),(3773,4,52,552,149,25),(3774,4,52,552,150,26),(3775,4,52,552,162,100),(3776,4,52,552,125,111),(3777,4,52,552,126,112),(3778,4,52,552,127,113),(3779,4,52,552,128,114),(3780,4,52,552,155,116),(3781,4,52,552,161,117),(3782,4,53,553,156,20),(3783,4,53,555,134,1),(3784,4,53,557,101,1),(3785,4,53,557,102,2),(3786,4,53,557,100,3),(3787,4,53,557,116,4),(3788,4,53,558,104,1),(3789,4,53,558,106,2),(3790,4,53,558,117,3),(3791,4,53,558,103,10),(3792,4,53,559,78,1),(3793,4,53,559,79,2),(3794,4,53,559,80,3),(3795,4,53,559,81,4),(3796,4,53,559,92,5),(3797,4,53,559,123,6),(3798,4,53,559,124,7),(3799,4,53,559,98,8),(3800,4,53,559,132,8),(3801,4,53,560,121,1),(3802,4,53,560,84,2),(3803,4,53,560,85,3),(3804,4,53,560,86,4),(3805,4,53,561,87,1),(3806,4,53,561,88,2),(3807,4,53,561,89,3),(3808,4,53,561,135,4),(3809,4,53,561,90,5),(3810,4,53,561,96,6),(3811,4,53,562,133,1),(3812,4,53,563,76,1),(3813,4,53,563,75,2),(3814,4,53,563,145,3),(3815,4,53,563,146,4),(3816,4,53,564,97,1),(3817,4,53,564,73,2),(3818,4,53,564,74,3),(3819,4,53,564,130,4),(3820,4,53,564,77,5),(3821,4,53,564,91,6),(3822,4,53,564,129,6),(3823,4,53,564,136,7),(3824,4,53,564,115,8),(3825,4,53,564,82,9),(3826,4,53,564,131,10),(3827,4,53,564,99,11),(3828,4,53,564,122,11),(3829,4,53,564,105,12),(3830,4,53,564,94,13),(3831,4,53,564,95,14),(3832,4,53,564,107,14),(3833,4,53,564,108,15),(3834,4,53,564,140,15),(3835,4,53,564,109,16),(3836,4,53,564,142,16),(3837,4,53,564,110,17),(3838,4,53,564,143,17),(3839,4,53,564,111,18),(3840,4,53,564,144,18),(3841,4,53,564,112,19),(3842,4,53,564,141,19),(3843,4,53,564,113,20),(3844,4,53,564,147,20),(3845,4,53,564,152,21),(3846,4,53,564,114,22),(3847,4,53,564,93,23),(3848,4,53,564,148,24),(3849,4,53,564,149,25),(3850,4,53,564,150,26),(3851,4,53,564,162,100),(3852,4,53,564,125,111),(3853,4,53,564,126,112),(3854,4,53,564,127,113),(3855,4,53,564,128,114),(3856,4,53,564,155,116),(3857,4,53,564,161,117),(3858,4,54,565,156,20),(3859,4,54,567,134,1),(3860,4,54,569,101,1),(3861,4,54,569,102,2),(3862,4,54,569,100,3),(3863,4,54,569,116,4),(3864,4,54,570,104,1),(3865,4,54,570,106,2),(3866,4,54,570,117,3),(3867,4,54,570,103,10),(3868,4,54,571,78,1),(3869,4,54,571,79,2),(3870,4,54,571,80,3),(3871,4,54,571,81,4),(3872,4,54,571,92,5),(3873,4,54,571,123,6),(3874,4,54,571,124,7),(3875,4,54,571,98,8),(3876,4,54,571,132,8),(3877,4,54,572,121,1),(3878,4,54,572,84,2),(3879,4,54,572,85,3),(3880,4,54,572,86,4),(3881,4,54,573,87,1),(3882,4,54,573,88,2),(3883,4,54,573,89,3),(3884,4,54,573,135,4),(3885,4,54,573,90,5),(3886,4,54,573,96,6),(3887,4,54,574,133,1),(3888,4,54,575,76,1),(3889,4,54,575,75,2),(3890,4,54,575,145,3),(3891,4,54,575,146,4),(3892,4,54,576,97,1),(3893,4,54,576,73,2),(3894,4,54,576,74,3),(3895,4,54,576,130,4),(3896,4,54,576,77,5),(3897,4,54,576,91,6),(3898,4,54,576,129,6),(3899,4,54,576,136,7),(3900,4,54,576,115,8),(3901,4,54,576,82,9),(3902,4,54,576,131,10),(3903,4,54,576,99,11),(3904,4,54,576,122,11),(3905,4,54,576,105,12),(3906,4,54,576,94,13),(3907,4,54,576,95,14),(3908,4,54,576,107,14),(3909,4,54,576,108,15),(3910,4,54,576,140,15),(3911,4,54,576,109,16),(3912,4,54,576,142,16),(3913,4,54,576,110,17),(3914,4,54,576,143,17),(3915,4,54,576,111,18),(3916,4,54,576,144,18),(3917,4,54,576,112,19),(3918,4,54,576,141,19),(3919,4,54,576,113,20),(3920,4,54,576,147,20),(3921,4,54,576,152,21),(3922,4,54,576,114,22),(3923,4,54,576,93,23),(3924,4,54,576,148,24),(3925,4,54,576,149,25),(3926,4,54,576,150,26),(3927,4,54,576,162,100),(3928,4,54,576,125,111),(3929,4,54,576,126,112),(3930,4,54,576,127,113),(3931,4,54,576,128,114),(3932,4,54,576,155,116),(3933,4,54,576,161,117),(3934,4,55,577,156,20),(3935,4,55,579,134,1),(3936,4,55,581,101,1),(3937,4,55,581,102,2),(3938,4,55,581,100,3),(3939,4,55,581,116,4),(3940,4,55,582,104,1),(3941,4,55,582,106,2),(3942,4,55,582,117,3),(3943,4,55,582,103,10),(3944,4,55,583,78,1),(3945,4,55,583,79,2),(3946,4,55,583,80,3),(3947,4,55,583,81,4),(3948,4,55,583,92,5),(3949,4,55,583,123,6),(3950,4,55,583,124,7),(3951,4,55,583,98,8),(3952,4,55,583,132,8),(3953,4,55,584,121,1),(3954,4,55,584,84,2),(3955,4,55,584,85,3),(3956,4,55,584,86,4),(3957,4,55,585,87,1),(3958,4,55,585,88,2),(3959,4,55,585,89,3),(3960,4,55,585,135,4),(3961,4,55,585,90,5),(3962,4,55,585,96,6),(3963,4,55,586,133,1),(3964,4,55,587,76,1),(3965,4,55,587,75,2),(3966,4,55,587,145,3),(3967,4,55,587,146,4),(3968,4,55,588,97,1),(3969,4,55,588,73,2),(3970,4,55,588,74,3),(3971,4,55,588,130,4),(3972,4,55,588,77,5),(3973,4,55,588,91,6),(3974,4,55,588,129,6),(3975,4,55,588,136,7),(3976,4,55,588,115,8),(3977,4,55,588,82,9),(3978,4,55,588,131,10),(3979,4,55,588,99,11),(3980,4,55,588,122,11),(3981,4,55,588,105,12),(3982,4,55,588,94,13),(3983,4,55,588,95,14),(3984,4,55,588,107,14),(3985,4,55,588,108,15),(3986,4,55,588,140,15),(3987,4,55,588,109,16),(3988,4,55,588,142,16),(3989,4,55,588,110,17),(3990,4,55,588,143,17),(3991,4,55,588,111,18),(3992,4,55,588,144,18),(3993,4,55,588,112,19),(3994,4,55,588,141,19),(3995,4,55,588,113,20),(3996,4,55,588,147,20),(3997,4,55,588,152,21),(3998,4,55,588,114,22),(3999,4,55,588,93,23),(4000,4,55,588,148,24),(4001,4,55,588,149,25),(4002,4,55,588,150,26),(4003,4,55,588,162,100),(4004,4,55,588,125,111),(4005,4,55,588,126,112),(4006,4,55,588,127,113),(4007,4,55,588,128,114),(4008,4,55,588,155,116),(4009,4,55,588,161,117),(4010,4,56,589,156,20),(4011,4,56,591,134,1),(4012,4,56,593,101,1),(4013,4,56,593,102,2),(4014,4,56,593,100,3),(4015,4,56,593,116,4),(4016,4,56,594,104,1),(4017,4,56,594,106,2),(4018,4,56,594,117,3),(4019,4,56,594,103,10),(4020,4,56,595,78,1),(4021,4,56,595,79,2),(4022,4,56,595,80,3),(4023,4,56,595,81,4),(4024,4,56,595,92,5),(4025,4,56,595,123,6),(4026,4,56,595,124,7),(4027,4,56,595,98,8),(4028,4,56,595,132,8),(4029,4,56,596,121,1),(4030,4,56,596,84,2),(4031,4,56,596,85,3),(4032,4,56,596,86,4),(4033,4,56,597,87,1),(4034,4,56,597,88,2),(4035,4,56,597,89,3),(4036,4,56,597,135,4),(4037,4,56,597,90,5),(4038,4,56,597,96,6),(4039,4,56,598,133,1),(4040,4,56,599,76,1),(4041,4,56,599,75,2),(4042,4,56,599,145,3),(4043,4,56,599,146,4),(4044,4,56,600,97,1),(4045,4,56,600,73,2),(4046,4,56,600,74,3),(4047,4,56,600,130,4),(4048,4,56,600,77,5),(4049,4,56,600,91,6),(4050,4,56,600,129,6),(4051,4,56,600,136,7),(4052,4,56,600,115,8),(4053,4,56,600,82,9),(4054,4,56,600,131,10),(4055,4,56,600,99,11),(4056,4,56,600,122,11),(4057,4,56,600,105,12),(4058,4,56,600,94,13),(4059,4,56,600,95,14),(4060,4,56,600,107,14),(4061,4,56,600,108,15),(4062,4,56,600,140,15),(4063,4,56,600,109,16),(4064,4,56,600,142,16),(4065,4,56,600,110,17),(4066,4,56,600,143,17),(4067,4,56,600,111,18),(4068,4,56,600,144,18),(4069,4,56,600,112,19),(4070,4,56,600,141,19),(4071,4,56,600,113,20),(4072,4,56,600,147,20),(4073,4,56,600,152,21),(4074,4,56,600,114,22),(4075,4,56,600,93,23),(4076,4,56,600,148,24),(4077,4,56,600,149,25),(4078,4,56,600,150,26),(4079,4,56,600,162,100),(4080,4,56,600,125,111),(4081,4,56,600,126,112),(4082,4,56,600,127,113),(4083,4,56,600,128,114),(4084,4,56,600,155,116),(4085,4,56,600,161,117);
/*!40000 ALTER TABLE `eav_entity_attribute` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_entity_datetime`
--

DROP TABLE IF EXISTS `eav_entity_datetime`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_entity_datetime` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `entity_type_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` datetime DEFAULT NULL COMMENT 'Attribute Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `EAV_ENTITY_DATETIME_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `EAV_ENTITY_DATETIME_STORE_ID` (`store_id`),
  KEY `EAV_ENTITY_DATETIME_ATTRIBUTE_ID_VALUE` (`attribute_id`,`value`),
  KEY `EAV_ENTITY_DATETIME_ENTITY_TYPE_ID_VALUE` (`entity_type_id`,`value`),
  CONSTRAINT `EAV_ENTITY_DATETIME_ENTITY_ID_EAV_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `eav_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_ENTITY_DATETIME_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_ENTT_DTIME_ENTT_TYPE_ID_EAV_ENTT_TYPE_ENTT_TYPE_ID` FOREIGN KEY (`entity_type_id`) REFERENCES `eav_entity_type` (`entity_type_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Eav Entity Value Prefix';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_entity_datetime`
--

LOCK TABLES `eav_entity_datetime` WRITE;
/*!40000 ALTER TABLE `eav_entity_datetime` DISABLE KEYS */;
/*!40000 ALTER TABLE `eav_entity_datetime` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_entity_decimal`
--

DROP TABLE IF EXISTS `eav_entity_decimal`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_entity_decimal` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `entity_type_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Attribute Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `EAV_ENTITY_DECIMAL_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `EAV_ENTITY_DECIMAL_STORE_ID` (`store_id`),
  KEY `EAV_ENTITY_DECIMAL_ATTRIBUTE_ID_VALUE` (`attribute_id`,`value`),
  KEY `EAV_ENTITY_DECIMAL_ENTITY_TYPE_ID_VALUE` (`entity_type_id`,`value`),
  CONSTRAINT `EAV_ENTITY_DECIMAL_ENTITY_ID_EAV_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `eav_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_ENTITY_DECIMAL_ENTITY_TYPE_ID_EAV_ENTITY_TYPE_ENTITY_TYPE_ID` FOREIGN KEY (`entity_type_id`) REFERENCES `eav_entity_type` (`entity_type_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_ENTITY_DECIMAL_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Eav Entity Value Prefix';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_entity_decimal`
--

LOCK TABLES `eav_entity_decimal` WRITE;
/*!40000 ALTER TABLE `eav_entity_decimal` DISABLE KEYS */;
/*!40000 ALTER TABLE `eav_entity_decimal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_entity_int`
--

DROP TABLE IF EXISTS `eav_entity_int`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_entity_int` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `entity_type_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` int NOT NULL DEFAULT '0' COMMENT 'Attribute Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `EAV_ENTITY_INT_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `EAV_ENTITY_INT_STORE_ID` (`store_id`),
  KEY `EAV_ENTITY_INT_ATTRIBUTE_ID_VALUE` (`attribute_id`,`value`),
  KEY `EAV_ENTITY_INT_ENTITY_TYPE_ID_VALUE` (`entity_type_id`,`value`),
  CONSTRAINT `EAV_ENTITY_INT_ENTITY_ID_EAV_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `eav_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_ENTITY_INT_ENTITY_TYPE_ID_EAV_ENTITY_TYPE_ENTITY_TYPE_ID` FOREIGN KEY (`entity_type_id`) REFERENCES `eav_entity_type` (`entity_type_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_ENTITY_INT_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Eav Entity Value Prefix';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_entity_int`
--

LOCK TABLES `eav_entity_int` WRITE;
/*!40000 ALTER TABLE `eav_entity_int` DISABLE KEYS */;
/*!40000 ALTER TABLE `eav_entity_int` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_entity_store`
--

DROP TABLE IF EXISTS `eav_entity_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_entity_store` (
  `entity_store_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Store ID',
  `entity_type_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `increment_prefix` varchar(20) DEFAULT NULL COMMENT 'Increment Prefix',
  `increment_last_id` varchar(50) DEFAULT NULL COMMENT 'Last Incremented ID',
  PRIMARY KEY (`entity_store_id`),
  KEY `EAV_ENTITY_STORE_ENTITY_TYPE_ID` (`entity_type_id`),
  KEY `EAV_ENTITY_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `EAV_ENTITY_STORE_ENTITY_TYPE_ID_EAV_ENTITY_TYPE_ENTITY_TYPE_ID` FOREIGN KEY (`entity_type_id`) REFERENCES `eav_entity_type` (`entity_type_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_ENTITY_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Eav Entity Store';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_entity_store`
--

LOCK TABLES `eav_entity_store` WRITE;
/*!40000 ALTER TABLE `eav_entity_store` DISABLE KEYS */;
/*!40000 ALTER TABLE `eav_entity_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_entity_text`
--

DROP TABLE IF EXISTS `eav_entity_text`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_entity_text` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `entity_type_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` text NOT NULL COMMENT 'Attribute Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `EAV_ENTITY_TEXT_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `EAV_ENTITY_TEXT_ENTITY_TYPE_ID` (`entity_type_id`),
  KEY `EAV_ENTITY_TEXT_ATTRIBUTE_ID` (`attribute_id`),
  KEY `EAV_ENTITY_TEXT_STORE_ID` (`store_id`),
  CONSTRAINT `EAV_ENTITY_TEXT_ENTITY_ID_EAV_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `eav_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_ENTITY_TEXT_ENTITY_TYPE_ID_EAV_ENTITY_TYPE_ENTITY_TYPE_ID` FOREIGN KEY (`entity_type_id`) REFERENCES `eav_entity_type` (`entity_type_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_ENTITY_TEXT_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Eav Entity Value Prefix';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_entity_text`
--

LOCK TABLES `eav_entity_text` WRITE;
/*!40000 ALTER TABLE `eav_entity_text` DISABLE KEYS */;
/*!40000 ALTER TABLE `eav_entity_text` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_entity_type`
--

DROP TABLE IF EXISTS `eav_entity_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_entity_type` (
  `entity_type_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Type ID',
  `entity_type_code` varchar(50) NOT NULL COMMENT 'Entity Type Code',
  `entity_model` varchar(255) NOT NULL COMMENT 'Entity Model',
  `attribute_model` varchar(255) DEFAULT NULL COMMENT 'Attribute Model',
  `entity_table` varchar(255) DEFAULT NULL COMMENT 'Entity Table',
  `value_table_prefix` varchar(255) DEFAULT NULL COMMENT 'Value Table Prefix',
  `entity_id_field` varchar(255) DEFAULT NULL COMMENT 'Entity ID Field',
  `is_data_sharing` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Defines Is Data Sharing',
  `data_sharing_key` varchar(100) DEFAULT 'default' COMMENT 'Data Sharing Key',
  `default_attribute_set_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Default Attribute Set ID',
  `increment_model` varchar(255) DEFAULT NULL COMMENT 'Increment Model',
  `increment_per_store` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Increment Per Store',
  `increment_pad_length` smallint unsigned NOT NULL DEFAULT '8' COMMENT 'Increment Pad Length',
  `increment_pad_char` varchar(1) NOT NULL DEFAULT '0' COMMENT 'Increment Pad Char',
  `additional_attribute_table` varchar(255) DEFAULT NULL COMMENT 'Additional Attribute Table',
  `entity_attribute_collection` varchar(255) DEFAULT NULL COMMENT 'Entity Attribute Collection',
  PRIMARY KEY (`entity_type_id`),
  KEY `EAV_ENTITY_TYPE_ENTITY_TYPE_CODE` (`entity_type_code`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8mb3 COMMENT='Eav Entity Type';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_entity_type`
--

LOCK TABLES `eav_entity_type` WRITE;
/*!40000 ALTER TABLE `eav_entity_type` DISABLE KEYS */;
INSERT INTO `eav_entity_type` VALUES (1,'customer','Magento\\Customer\\Model\\ResourceModel\\Customer','Magento\\Customer\\Model\\Attribute','customer_entity',NULL,NULL,1,'default',1,'Magento\\Eav\\Model\\Entity\\Increment\\NumericValue',0,8,'0','customer_eav_attribute','Magento\\Customer\\Model\\ResourceModel\\Attribute\\Collection'),(2,'customer_address','Magento\\Customer\\Model\\ResourceModel\\Address','Magento\\Customer\\Model\\Attribute','customer_address_entity',NULL,NULL,1,'default',2,NULL,0,8,'0','customer_eav_attribute','Magento\\Customer\\Model\\ResourceModel\\Address\\Attribute\\Collection'),(3,'catalog_category','Magento\\Catalog\\Model\\ResourceModel\\Category','Magento\\Catalog\\Model\\ResourceModel\\Eav\\Attribute','catalog_category_entity',NULL,NULL,1,'default',3,NULL,0,8,'0','catalog_eav_attribute','Magento\\Catalog\\Model\\ResourceModel\\Category\\Attribute\\Collection'),(4,'catalog_product','Magento\\Catalog\\Model\\ResourceModel\\Product','Magento\\Catalog\\Model\\ResourceModel\\Eav\\Attribute','catalog_product_entity',NULL,NULL,1,'default',4,NULL,0,8,'0','catalog_eav_attribute','Magento\\Catalog\\Model\\ResourceModel\\Product\\Attribute\\Collection'),(5,'order','Magento\\Sales\\Model\\ResourceModel\\Order',NULL,'sales_order',NULL,NULL,1,'default',5,'Magento\\Eav\\Model\\Entity\\Increment\\NumericValue',1,8,'0',NULL,NULL),(6,'invoice','Magento\\Sales\\Model\\ResourceModel\\Order\\Invoice',NULL,'sales_invoice',NULL,NULL,1,'default',6,'Magento\\Eav\\Model\\Entity\\Increment\\NumericValue',1,8,'0',NULL,NULL),(7,'creditmemo','Magento\\Sales\\Model\\ResourceModel\\Order\\Creditmemo',NULL,'sales_creditmemo',NULL,NULL,1,'default',7,'Magento\\Eav\\Model\\Entity\\Increment\\NumericValue',1,8,'0',NULL,NULL),(8,'shipment','Magento\\Sales\\Model\\ResourceModel\\Order\\Shipment',NULL,'sales_shipment',NULL,NULL,1,'default',8,'Magento\\Eav\\Model\\Entity\\Increment\\NumericValue',1,8,'0',NULL,NULL);
/*!40000 ALTER TABLE `eav_entity_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_entity_varchar`
--

DROP TABLE IF EXISTS `eav_entity_varchar`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_entity_varchar` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `entity_type_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` varchar(255) DEFAULT NULL COMMENT 'Attribute Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `EAV_ENTITY_VARCHAR_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`),
  KEY `EAV_ENTITY_VARCHAR_STORE_ID` (`store_id`),
  KEY `EAV_ENTITY_VARCHAR_ATTRIBUTE_ID_VALUE` (`attribute_id`,`value`),
  KEY `EAV_ENTITY_VARCHAR_ENTITY_TYPE_ID_VALUE` (`entity_type_id`,`value`),
  CONSTRAINT `EAV_ENTITY_VARCHAR_ENTITY_ID_EAV_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `eav_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_ENTITY_VARCHAR_ENTITY_TYPE_ID_EAV_ENTITY_TYPE_ENTITY_TYPE_ID` FOREIGN KEY (`entity_type_id`) REFERENCES `eav_entity_type` (`entity_type_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_ENTITY_VARCHAR_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Eav Entity Value Prefix';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_entity_varchar`
--

LOCK TABLES `eav_entity_varchar` WRITE;
/*!40000 ALTER TABLE `eav_entity_varchar` DISABLE KEYS */;
/*!40000 ALTER TABLE `eav_entity_varchar` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_form_element`
--

DROP TABLE IF EXISTS `eav_form_element`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_form_element` (
  `element_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Element ID',
  `type_id` smallint unsigned NOT NULL COMMENT 'Type ID',
  `fieldset_id` smallint unsigned DEFAULT NULL COMMENT 'Fieldset ID',
  `attribute_id` smallint unsigned NOT NULL COMMENT 'Attribute ID',
  `sort_order` int NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  PRIMARY KEY (`element_id`),
  UNIQUE KEY `EAV_FORM_ELEMENT_TYPE_ID_ATTRIBUTE_ID` (`type_id`,`attribute_id`),
  KEY `EAV_FORM_ELEMENT_FIELDSET_ID` (`fieldset_id`),
  KEY `EAV_FORM_ELEMENT_ATTRIBUTE_ID` (`attribute_id`),
  CONSTRAINT `EAV_FORM_ELEMENT_ATTRIBUTE_ID_EAV_ATTRIBUTE_ATTRIBUTE_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_FORM_ELEMENT_FIELDSET_ID_EAV_FORM_FIELDSET_FIELDSET_ID` FOREIGN KEY (`fieldset_id`) REFERENCES `eav_form_fieldset` (`fieldset_id`) ON DELETE SET NULL,
  CONSTRAINT `EAV_FORM_ELEMENT_TYPE_ID_EAV_FORM_TYPE_TYPE_ID` FOREIGN KEY (`type_id`) REFERENCES `eav_form_type` (`type_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=43 DEFAULT CHARSET=utf8mb3 COMMENT='Eav Form Element';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_form_element`
--

LOCK TABLES `eav_form_element` WRITE;
/*!40000 ALTER TABLE `eav_form_element` DISABLE KEYS */;
INSERT INTO `eav_form_element` VALUES (1,1,NULL,23,0),(2,1,NULL,25,1),(3,1,NULL,27,2),(4,1,NULL,9,3),(5,1,NULL,28,4),(6,1,NULL,29,5),(7,1,NULL,31,6),(8,1,NULL,33,7),(9,1,NULL,30,8),(10,1,NULL,34,9),(11,1,NULL,35,10),(12,2,NULL,23,0),(13,2,NULL,25,1),(14,2,NULL,27,2),(15,2,NULL,9,3),(16,2,NULL,28,4),(17,2,NULL,29,5),(18,2,NULL,31,6),(19,2,NULL,33,7),(20,2,NULL,30,8),(21,2,NULL,34,9),(22,2,NULL,35,10),(23,3,NULL,23,0),(24,3,NULL,25,1),(25,3,NULL,27,2),(26,3,NULL,28,3),(27,3,NULL,29,4),(28,3,NULL,31,5),(29,3,NULL,33,6),(30,3,NULL,30,7),(31,3,NULL,34,8),(32,3,NULL,35,9),(33,4,NULL,23,0),(34,4,NULL,25,1),(35,4,NULL,27,2),(36,4,NULL,28,3),(37,4,NULL,29,4),(38,4,NULL,31,5),(39,4,NULL,33,6),(40,4,NULL,30,7),(41,4,NULL,34,8),(42,4,NULL,35,9);
/*!40000 ALTER TABLE `eav_form_element` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_form_fieldset`
--

DROP TABLE IF EXISTS `eav_form_fieldset`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_form_fieldset` (
  `fieldset_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Fieldset ID',
  `type_id` smallint unsigned NOT NULL COMMENT 'Type ID',
  `code` varchar(64) NOT NULL COMMENT 'Code',
  `sort_order` int NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  PRIMARY KEY (`fieldset_id`),
  UNIQUE KEY `EAV_FORM_FIELDSET_TYPE_ID_CODE` (`type_id`,`code`),
  CONSTRAINT `EAV_FORM_FIELDSET_TYPE_ID_EAV_FORM_TYPE_TYPE_ID` FOREIGN KEY (`type_id`) REFERENCES `eav_form_type` (`type_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Eav Form Fieldset';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_form_fieldset`
--

LOCK TABLES `eav_form_fieldset` WRITE;
/*!40000 ALTER TABLE `eav_form_fieldset` DISABLE KEYS */;
/*!40000 ALTER TABLE `eav_form_fieldset` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_form_fieldset_label`
--

DROP TABLE IF EXISTS `eav_form_fieldset_label`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_form_fieldset_label` (
  `fieldset_id` smallint unsigned NOT NULL COMMENT 'Fieldset ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `label` varchar(255) NOT NULL COMMENT 'Label',
  PRIMARY KEY (`fieldset_id`,`store_id`),
  KEY `EAV_FORM_FIELDSET_LABEL_STORE_ID` (`store_id`),
  CONSTRAINT `EAV_FORM_FIELDSET_LABEL_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_FORM_FSET_LBL_FSET_ID_EAV_FORM_FSET_FSET_ID` FOREIGN KEY (`fieldset_id`) REFERENCES `eav_form_fieldset` (`fieldset_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Eav Form Fieldset Label';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_form_fieldset_label`
--

LOCK TABLES `eav_form_fieldset_label` WRITE;
/*!40000 ALTER TABLE `eav_form_fieldset_label` DISABLE KEYS */;
/*!40000 ALTER TABLE `eav_form_fieldset_label` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_form_type`
--

DROP TABLE IF EXISTS `eav_form_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_form_type` (
  `type_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Type ID',
  `code` varchar(64) NOT NULL COMMENT 'Code',
  `label` varchar(255) NOT NULL COMMENT 'Label',
  `is_system` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is System',
  `theme` varchar(64) DEFAULT NULL COMMENT 'Theme',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  PRIMARY KEY (`type_id`),
  UNIQUE KEY `EAV_FORM_TYPE_CODE_THEME_STORE_ID` (`code`,`theme`,`store_id`),
  KEY `EAV_FORM_TYPE_STORE_ID` (`store_id`),
  CONSTRAINT `EAV_FORM_TYPE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COMMENT='Eav Form Type';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_form_type`
--

LOCK TABLES `eav_form_type` WRITE;
/*!40000 ALTER TABLE `eav_form_type` DISABLE KEYS */;
INSERT INTO `eav_form_type` VALUES (1,'checkout_onepage_register','checkout_onepage_register',1,'',0),(2,'checkout_onepage_register_guest','checkout_onepage_register_guest',1,'',0),(3,'checkout_onepage_billing_address','checkout_onepage_billing_address',1,'',0),(4,'checkout_onepage_shipping_address','checkout_onepage_shipping_address',1,'',0);
/*!40000 ALTER TABLE `eav_form_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eav_form_type_entity`
--

DROP TABLE IF EXISTS `eav_form_type_entity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `eav_form_type_entity` (
  `type_id` smallint unsigned NOT NULL COMMENT 'Type ID',
  `entity_type_id` smallint unsigned NOT NULL COMMENT 'Entity Type ID',
  PRIMARY KEY (`type_id`,`entity_type_id`),
  KEY `EAV_FORM_TYPE_ENTITY_ENTITY_TYPE_ID` (`entity_type_id`),
  CONSTRAINT `EAV_FORM_TYPE_ENTITY_TYPE_ID_EAV_FORM_TYPE_TYPE_ID` FOREIGN KEY (`type_id`) REFERENCES `eav_form_type` (`type_id`) ON DELETE CASCADE,
  CONSTRAINT `EAV_FORM_TYPE_ENTT_ENTT_TYPE_ID_EAV_ENTT_TYPE_ENTT_TYPE_ID` FOREIGN KEY (`entity_type_id`) REFERENCES `eav_entity_type` (`entity_type_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Eav Form Type Entity';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eav_form_type_entity`
--

LOCK TABLES `eav_form_type_entity` WRITE;
/*!40000 ALTER TABLE `eav_form_type_entity` DISABLE KEYS */;
INSERT INTO `eav_form_type_entity` VALUES (1,1),(2,1),(1,2),(2,2),(3,2),(4,2);
/*!40000 ALTER TABLE `eav_form_type_entity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `email_template`
--

DROP TABLE IF EXISTS `email_template`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `email_template` (
  `template_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Template ID',
  `template_code` varchar(150) NOT NULL COMMENT 'Template Name',
  `template_text` text NOT NULL COMMENT 'Template Content',
  `template_styles` text COMMENT 'Templste Styles',
  `template_type` int unsigned DEFAULT NULL COMMENT 'Template Type',
  `template_subject` varchar(200) NOT NULL COMMENT 'Template Subject',
  `template_sender_name` varchar(200) DEFAULT NULL COMMENT 'Template Sender Name',
  `template_sender_email` varchar(200) DEFAULT NULL COMMENT 'Template Sender Email',
  `added_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Date of Template Creation',
  `modified_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Date of Template Modification',
  `orig_template_code` varchar(200) DEFAULT NULL COMMENT 'Original Template Code',
  `orig_template_variables` text COMMENT 'Original Template Variables',
  `is_legacy` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Should the template render in legacy mode',
  PRIMARY KEY (`template_id`),
  UNIQUE KEY `EMAIL_TEMPLATE_TEMPLATE_CODE` (`template_code`),
  KEY `EMAIL_TEMPLATE_ADDED_AT` (`added_at`),
  KEY `EMAIL_TEMPLATE_MODIFIED_AT` (`modified_at`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Email Templates';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `email_template`
--

LOCK TABLES `email_template` WRITE;
/*!40000 ALTER TABLE `email_template` DISABLE KEYS */;
/*!40000 ALTER TABLE `email_template` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `flag`
--

DROP TABLE IF EXISTS `flag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `flag` (
  `flag_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Flag Id',
  `flag_code` varchar(255) NOT NULL COMMENT 'Flag Code',
  `state` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Flag State',
  `flag_data` mediumtext COMMENT 'Flag Data',
  `last_update` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Date of Last Flag Update',
  PRIMARY KEY (`flag_id`),
  KEY `FLAG_LAST_UPDATE` (`last_update`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8mb3 COMMENT='Flag';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flag`
--

LOCK TABLES `flag` WRITE;
/*!40000 ALTER TABLE `flag` DISABLE KEYS */;
INSERT INTO `flag` VALUES (1,'analytics_link_attempts_reverse_counter',0,'24','2024-08-05 09:21:15'),(2,'feed_metadata_salesOrders',0,'{\"lockedBy\":\"full reindex(legacy)(615799)\"}','2025-02-05 07:30:48'),(3,'feed_metadata_salesOrderStatuses',0,'{\"lockedBy\":\"full reindex(legacy)(615799)\"}','2025-02-05 07:30:48'),(4,'feed_metadata_stores',0,'{\"lockedBy\":\"full reindex(legacy)(615799)\"}','2025-02-05 07:30:48'),(5,'config_hash',0,'{\"system\":\"2be88ca4242c76e8253ac62474851065032d6833\"}','2024-09-18 11:44:05'),(6,'m48169',0,'\"eyJzdGF0dXMiOiJhY3RpdmUiLCJtZXNzYWdlIjoiIiwiZmxhZyI6InJlYWwiLCJ0aW1lIjoxNzM4NzM1OTkzfQ==\"','2025-02-05 06:13:13'),(7,'m42849',0,'\"eyJzdGF0dXMiOiJhY3RpdmUiLCJtZXNzYWdlIjoiIiwiZmxhZyI6InJlYWwiLCJ0aW1lIjoxNzM4NzM1OTkzfQ==\"','2025-02-05 06:13:13');
/*!40000 ALTER TABLE `flag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gift_message`
--

DROP TABLE IF EXISTS `gift_message`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `gift_message` (
  `gift_message_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'GiftMessage ID',
  `customer_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer ID',
  `sender` varchar(255) DEFAULT NULL COMMENT 'Sender',
  `recipient` varchar(255) DEFAULT NULL COMMENT 'Registrant',
  `message` text COMMENT 'Message',
  PRIMARY KEY (`gift_message_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Gift Message';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gift_message`
--

LOCK TABLES `gift_message` WRITE;
/*!40000 ALTER TABLE `gift_message` DISABLE KEYS */;
/*!40000 ALTER TABLE `gift_message` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `googleoptimizer_code`
--

DROP TABLE IF EXISTS `googleoptimizer_code`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `googleoptimizer_code` (
  `code_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Google experiment code ID',
  `entity_id` int unsigned NOT NULL COMMENT 'Optimized entity ID product ID or catalog ID',
  `entity_type` varchar(50) DEFAULT NULL COMMENT 'Optimized entity type',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `experiment_script` text COMMENT 'Google experiment script',
  PRIMARY KEY (`code_id`),
  UNIQUE KEY `GOOGLEOPTIMIZER_CODE_STORE_ID_ENTITY_ID_ENTITY_TYPE` (`store_id`,`entity_id`,`entity_type`),
  CONSTRAINT `GOOGLEOPTIMIZER_CODE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Google Experiment code';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `googleoptimizer_code`
--

LOCK TABLES `googleoptimizer_code` WRITE;
/*!40000 ALTER TABLE `googleoptimizer_code` DISABLE KEYS */;
/*!40000 ALTER TABLE `googleoptimizer_code` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `import_history`
--

DROP TABLE IF EXISTS `import_history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `import_history` (
  `history_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'History record ID',
  `started_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Started at',
  `user_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'User ID',
  `imported_file` varchar(255) DEFAULT NULL COMMENT 'Imported file',
  `execution_time` varchar(255) DEFAULT NULL COMMENT 'Execution time',
  `summary` varchar(255) DEFAULT NULL COMMENT 'Summary',
  `error_file` varchar(255) NOT NULL COMMENT 'Imported file with errors',
  PRIMARY KEY (`history_id`)
) ENGINE=InnoDB AUTO_INCREMENT=141 DEFAULT CHARSET=utf8mb3 COMMENT='Import history table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `import_history`
--

LOCK TABLES `import_history` WRITE;
/*!40000 ALTER TABLE `import_history` DISABLE KEYS */;
INSERT INTO `import_history` VALUES (1,'2024-08-12 09:02:32',1,'1723453352_export_catalog_product_20240812_045647.csv','Validation',NULL,'1723453352_export_catalog_product_20240812_045647_error_report.csv'),(2,'2024-08-12 09:04:25',1,'1723453465_export_catalog_product_20240812_045647.csv','Validation',NULL,'1723453465_export_catalog_product_20240812_045647_error_report.csv'),(3,'2024-08-12 09:04:53',1,'1723453493_catalog_product.csv','00:00:03','Created: 6, Updated: 0, Deleted: 0',''),(4,'2024-08-15 09:56:33',2,'1723715793_Bette 1 product upload new magento 15-08-2024.csv','Validation',NULL,'1723715793_Bette 1 product upload new magento 15-08-2024_error_report.csv'),(5,'2024-08-15 10:03:17',2,'1723716197_Bette 1 product upload new magento 15-08-2024.csv','Validation',NULL,'1723716197_Bette 1 product upload new magento 15-08-2024_error_report.csv'),(6,'2024-08-15 10:06:34',2,'1723716394_Bette 1 product upload new magento 15-08-2024.csv','Validation',NULL,''),(7,'2024-08-15 10:07:16',2,'1723716436_Bette 1 product upload new magento 15-08-2024.csv','Validation',NULL,''),(8,'2024-08-15 10:07:20',2,'1723716440_Bette 1 product upload new magento 15-08-2024.csv','Validation',NULL,''),(9,'2024-08-15 10:07:25',2,'1723716445_Bette 1 product upload new magento 15-08-2024.csv','Validation',NULL,''),(10,'2024-08-15 10:07:59',2,'1723716479_catalog_product.csv','Validation',NULL,''),(11,'2024-08-15 10:24:18',2,'1723717458_Bette 1 product upload new magento 15-08-2024.csv','Validation',NULL,''),(12,'2024-08-15 10:34:35',1,'1723718075_Bette 1 product upload new magento 15-08-2024.csv','Validation',NULL,''),(13,'2024-08-15 10:43:33',1,'1723718613_Bette 1 product upload new magento 15-08-2024.csv','Validation',NULL,''),(14,'2024-08-15 10:54:34',1,'1723719274_Bette 1 product upload new magento 15-08-2024.csv','Validation',NULL,''),(15,'2024-08-15 11:37:26',1,'1723721846_Bette 1 product upload new magento 15-08-2024.csv','00:00:05','Created: 1, Updated: 0, Deleted: 0',''),(16,'2024-08-15 11:39:24',1,'1723721964_Bette 1 product upload new magento 15-08-2024.csv','Validation',NULL,''),(17,'2024-08-15 11:59:29',2,'1723723169_Bette 1 product upload new magento 15-08-2024.csv','Validation',NULL,''),(18,'2024-08-15 13:17:58',2,'1723727878_BATHROOM category products BANYO to new magento 15-08-2024.csv','Validation',NULL,'1723727878_BATHROOM category products BANYO to new magento 15-08-2024_error_report.csv'),(19,'2024-08-15 13:18:02',2,'1723727882_BATHROOM category products BANYO to new magento 15-08-2024.csv','Validation',NULL,'1723727882_BATHROOM category products BANYO to new magento 15-08-2024_error_report.csv'),(20,'2024-08-15 13:18:37',2,'1723727917_BATHROOM category products BANYO to new magento 15-08-2024.csv','00:01:49','Created: 273, Updated: 1, Deleted: 0',''),(21,'2024-08-16 07:26:04',2,'1723793164_catalog_product.csv','Validation',NULL,''),(22,'2024-08-16 07:26:20',2,'1723793180_catalog_product.csv','Validation',NULL,''),(23,'2024-08-16 07:49:43',2,'1723794583_catalog_product.csv','Validation',NULL,''),(24,'2024-08-16 07:50:03',2,'1723794603_catalog_product.csv','Validation',NULL,''),(25,'2024-08-16 07:50:58',2,'1723794658_catalog_product.csv','Validation',NULL,''),(26,'2024-08-16 08:04:31',2,'1723795471_catalog_product.csv','Validation',NULL,''),(27,'2024-08-16 08:05:27',2,'1723795527_1723727917_BATHROOM category products BANYO to new magento 15-08-2024.csv','Validation',NULL,''),(28,'2024-08-16 08:09:34',2,'1723795774_catalog_product.csv','Validation',NULL,''),(29,'2024-08-16 08:10:21',2,'1723795821_catalog_product.csv','Validation',NULL,''),(30,'2024-08-16 11:37:21',1,'1723808241_Bette 1 product upload new magento 15-08-2024.csv','Validation',NULL,''),(31,'2024-08-19 09:09:14',2,'1724058554_catalog_product.csv','Validation',NULL,''),(32,'2024-08-19 09:09:43',2,'1724058583_catalog_product.csv','Validation',NULL,''),(33,'2024-08-19 09:49:11',2,'1724060951_test 1.csv','Validation',NULL,''),(34,'2024-08-19 10:22:27',2,'1724062947_test new.csv','Validation',NULL,''),(35,'2024-08-19 10:22:49',2,'1724062969_test new114141416565498431321- 5453453357 (fsd) 16464.csv','Validation',NULL,''),(36,'2024-08-19 10:29:34',2,'1724063374_test new.csv','Validation',NULL,''),(37,'2024-08-19 10:36:07',2,'1724063767_test new.csv','Validation',NULL,''),(38,'2024-08-19 10:37:51',2,'1724063871_Bath _Basin _Bidet_Kitechen_Taps attribites set products 19-08-2024.csv','Validation',NULL,''),(39,'2024-08-19 10:39:27',2,'1724063967_Bath-Basin-Bidet-Kitechen-Taps attribites set products 19-08-2024.csv','Validation',NULL,''),(40,'2024-08-19 10:39:43',2,'1724063983_Bath-Basin-Bidet-Kitechen-Taps attribites set 859 products banyo to magento 19-08-2024.csv','Validation',NULL,''),(41,'2024-08-19 10:41:15',2,'1724064075_Bath-Basin-Bidet-Kitechen-Taps attribites set products banyo to magento 19-08-2024.csv','00:00:15','Created: 859, Updated: 0, Deleted: 0',''),(42,'2024-08-19 10:51:55',2,'1724064715_Bath Taps, Basin Taps, Bidet Taps-products move banyo to new magento 15-08-2024.csv','Validation',NULL,''),(43,'2024-08-19 14:55:44',2,'1724079344_Basins-Bidets-Bath Screen-Bathroom Fans-Bathroom Acce-Bath Acce-attribites set products banyo to magento 19-08-2024.csv','Validation',NULL,''),(44,'2024-08-19 14:57:16',2,'1724079436_Basins-Bidets-Bath Screen-Bathroom Fans-Bathroom Acce-Bath Acce-attribites set products banyo to magento 19-08-2024.csv','Validation',NULL,''),(45,'2024-08-19 14:57:24',2,'1724079444_Basins-Bidets-Bath Screen-Bathroom Fans-Bathroom Acce-Bath Acce-attribites set products banyo to magento 19-08-2024.csv','Validation',NULL,''),(46,'2024-08-19 14:57:32',2,'1724079452_catalog_product.csv','Validation',NULL,''),(47,'2024-08-19 14:57:53',2,'1724079473_Basins-Bidets-Bath Screen-Bathroom Fans-Bathroom Acce-Bath Acce-attribites set products banyo to magento 19-08-2024.csv','Validation',NULL,''),(48,'2024-08-19 14:59:24',2,'1724079564_Basins-Bidets-Bath Screen-Bathroom Fans-Bathroom Acce-Bath Acce-attribites set products banyo to magento 19-08-2024.csv','Validation',NULL,''),(49,'2024-08-19 16:10:06',2,'1724083806_Basins-Bidets-Bath Screen-Bathroom Fans-Bathroom Acce-Bath Acce-attribites set products banyo to magento 19-08-2024.csv','Validation',NULL,''),(50,'2024-08-19 16:11:27',2,'1724083887_Basins-Bidets-Bath Screen-Bathroom Fans-Bathroom Acce-Bath Acce-attribites set products banyo to magento 19-08-2024.csv','Validation',NULL,''),(51,'2024-08-19 16:11:59',2,'1724083919_Basins-Bidets-Bath Screen-Bathroom Fans-Bathroom Acce-Bath Acce-attribites set products banyo to magento 19-08-2024.csv','Validation',NULL,''),(52,'2024-08-20 07:27:59',2,'1724138879_Basins-Bidets-Bath Screen-Bathroom Fans-Bathroom Acce-Bath Acce-attribites set products banyo to magento 19-08-2024.csv','Validation',NULL,''),(53,'2024-08-20 07:40:12',2,'1724139612_Basins-Bidets-Bath Screen-Bathroom Fans-Bathroom Acce-Bath Acce-attribites set products banyo to magento 19-08-2024.csv','Validation',NULL,''),(54,'2024-08-20 08:02:35',2,'1724140955_Basins-Bidets-Bath Screen-Bathroom Fans-Bathroom Acce-Bath Acce-attribites set products banyo to magento 19-08-2024.csv','00:00:08','Created: 11, Updated: 0, Deleted: 0','1724140955_Basins-Bidets-Bath Screen-Bathroom Fans-Bathroom Acce-Bath Acce-attribites set products banyo to magento 19-08-2024_error_report.csv'),(55,'2024-08-20 09:56:20',2,'1724147780_Concealed-Cisterns-Frames-Complete Showers-Furniture-Hoods-Enclosures & Doors-Coffee Machines-Hobs-Fridge Freezers-Dishwashers attribites set products banyo to new magento 20-08-2024.csv','Validation',NULL,'1724147780_Concealed-Cisterns-Frames-Complete Showers-Furniture-Hoods-Enclosures & Doors-Coffee Machines-Hobs-Fridge Freezers-Dishwashers attribites set products banyo to new magento 20-08-2024_error_report.csv'),(56,'2024-08-20 09:56:32',2,'1724147792_14.csv','Validation',NULL,'1724147792_14_error_report.csv'),(57,'2024-08-20 09:59:51',2,'1724147991_catalog_product.csv','Validation',NULL,''),(58,'2024-08-20 10:00:47',2,'1724148047_Concealed-Cisterns-Frames-Complete Showers-Furniture-Hoods-Enclosures & Doors-Coffee Machines-Hobs-Fridge Freezers-Dishwashers attribites set products banyo to new magento 20-08-2024.csv','Validation',NULL,'1724148047_Concealed-Cisterns-Frames-Complete Showers-Furniture-Hoods-Enclosures & Doors-Coffee Machines-Hobs-Fridge Freezers-Dishwashers attribites set products banyo to new magento 20-08-2024_error_report.csv'),(59,'2024-08-20 10:02:41',2,'1724148161_Concealed-Cisterns-Frames-Complete Showers-Furniture-Hoods-Enclosures & Doors-Coffee Machines-Hobs-Fridge Freezers-Dishwashers attribites set products banyo to new magento 20-08-2024.csv','Validation',NULL,'1724148161_Concealed-Cisterns-Frames-Complete Showers-Furniture-Hoods-Enclosures & Doors-Coffee Machines-Hobs-Fridge Freezers-Dishwashers attribites set products banyo to new magento 20-08-2024_error_report.csv'),(60,'2024-08-20 10:04:32',2,'1724148272_Concealed-Cisterns-Frames-Complete Showers-Furniture-Hoods-Enclosures & Doors-Coffee Machines-Hobs-Fridge Freezers-Dishwashers attribites set products banyo to new magento 20-08-2024.csv','Validation',NULL,''),(61,'2024-08-20 10:05:35',2,'1724148335_Concealed-Cisterns-Frames-Complete Showers-Furniture-Hoods-Enclosures & Doors-Coffee Machines-Hobs-Fridge Freezers-Dishwashers attribites set products banyo to new magento 20-08-2024.csv','00:00:08','Created: 11, Updated: 0, Deleted: 0','1724148335_Concealed-Cisterns-Frames-Complete Showers-Furniture-Hoods-Enclosures & Doors-Coffee Machines-Hobs-Fridge Freezers-Dishwashers attribites set products banyo to new magento 20-08-2024_error_report.csv'),(62,'2024-08-20 10:07:02',2,'1724148422_Concealed-Cisterns-Frames-Complete Showers-Furniture-Hoods-Enclosures & Doors-Coffee Machines-Hobs-Fridge Freezers-Dishwashers attribites set products banyo to new magento 20-08-2024.csv','Validation',NULL,''),(63,'2024-08-20 11:39:41',2,'1724153981_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024.csv','Validation',NULL,''),(64,'2024-08-20 11:41:13',2,'1724154073_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024.csv','Validation',NULL,''),(65,'2024-08-20 11:51:23',2,'1724154683_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024.csv','Validation',NULL,''),(66,'2024-08-20 11:51:39',2,'1724154699_catalog_product.csv','Validation',NULL,''),(67,'2024-08-20 11:52:00',2,'1724154720_catalog_product.csv','Validation',NULL,''),(68,'2024-08-20 11:52:30',2,'1724154750_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024.csv','Validation',NULL,''),(69,'2024-08-20 11:52:47',2,'1724154767_catalog_product.csv','Validation',NULL,''),(70,'2024-08-20 11:53:31',2,'1724154811_catalog_product.csv','Validation',NULL,''),(71,'2024-08-20 11:53:44',2,'1724154824_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024.csv','Validation',NULL,''),(72,'2024-08-20 12:07:12',2,'1724155632_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024 test.csv','Validation',NULL,''),(73,'2024-08-20 12:12:43',2,'1724155963_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024 test.csv','Validation',NULL,''),(74,'2024-08-20 12:13:17',2,'1724155997_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024 test.csv','Validation',NULL,''),(75,'2024-08-20 12:15:53',2,'1724156153_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024 test 2.csv','Validation',NULL,''),(76,'2024-08-20 12:18:51',2,'1724156331_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024.csv','Validation',NULL,''),(77,'2024-08-20 12:19:36',2,'1724156376_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,''),(78,'2024-08-20 12:19:45',2,'1724156385_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,''),(79,'2024-08-20 12:19:50',2,'1724156390_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024 File-2.csv','Validation',NULL,''),(80,'2024-08-20 12:45:57',2,'1724157957_catalog_product.csv','Validation',NULL,''),(81,'2024-08-20 12:46:51',2,'1724158011_catalog_product.csv','Validation',NULL,''),(82,'2024-08-20 12:48:50',2,'1724158130_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,'1724158130_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1_error_report.csv'),(83,'2024-08-20 12:57:32',2,'1724158652_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,'1724158652_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1_error_report.csv'),(84,'2024-08-20 12:59:02',2,'1724158742_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,'1724158742_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1_error_report.csv'),(85,'2024-08-20 13:00:48',2,'1724158848_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,'1724158848_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1_error_report.csv'),(86,'2024-08-20 13:01:33',2,'1724158893_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,''),(87,'2024-08-20 13:01:59',2,'1724158919_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,'1724158919_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1_error_report.csv'),(88,'2024-08-20 13:04:49',2,'1724159089_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-2.csv','Validation',NULL,''),(89,'2024-08-20 14:16:45',2,'1724163405_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,'1724163405_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-1_error_report.csv'),(90,'2024-08-20 14:36:57',2,'1724164617_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,''),(91,'2024-08-20 14:37:35',2,'1724164655_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-2.csv','Validation',NULL,''),(92,'2024-08-20 15:08:31',2,'1724166511_Shower Accessories-Shower Valves-Toilets-Shower Trays-Stove-Warming  Drawers-Wetroom Panel-Wine Cooler-Washing & dryers-Shower panels- attribute set products banyo to new magento 20-05-2024.csv','Validation',NULL,'1724166511_Shower Accessories-Shower Valves-Toilets-Shower Trays-Stove-Warming  Drawers-Wetroom Panel-Wine Cooler-Washing & dryers-Shower panels- attribute set products banyo to new magento 20-05-2024_error_report.csv'),(93,'2024-08-20 15:10:07',2,'1724166607_Shower Accessories-Shower Valves-Toilets-Shower Trays-Stove-Warming  Drawers-Wetroom Panel-Wine Cooler-Washing & dryers-Shower panels- attribute set products banyo to new magento 20-05-2024.csv','Validation',NULL,'1724166607_Shower Accessories-Shower Valves-Toilets-Shower Trays-Stove-Warming  Drawers-Wetroom Panel-Wine Cooler-Washing & dryers-Shower panels- attribute set products banyo to new magento 20-05-2024_error_report.csv'),(94,'2024-08-20 15:11:00',2,'1724166660_Shower Accessories-Shower Valves-Toilets-Shower Trays-Stove-Warming  Drawers-Wetroom Panel-Wine Cooler-Washing & dryers-Shower panels- attribute set products banyo to new magento 20-05-2024.csv','00:00:09','Created: 11, Updated: 0, Deleted: 0','1724166660_Shower Accessories-Shower Valves-Toilets-Shower Trays-Stove-Warming  Drawers-Wetroom Panel-Wine Cooler-Washing & dryers-Shower panels- attribute set products banyo to new magento 20-05-2024_error_report.csv'),(95,'2024-08-20 15:15:13',2,'1724166913_test Shower Accessories-Shower Valves-Toilets-Shower Trays-Stove-Warming  Drawers-Wetroom Panel-Wine Cooler-Washing & dryers-Shower panels- attribute set products banyo to new test magento 20-05-2024.csv','Validation',NULL,''),(96,'2024-08-20 15:15:53',2,'1724166953_Shower Accessories-Shower Valves-Toilets-Shower Trays-Stove-Warming  Drawers-Wetroom Panel-Wine Cooler-Washing & dryers-Shower panels- attribute set products no image path banyo to new test magento 20-05-2024.csv','00:00:21','Created: 636, Updated: 11, Deleted: 0',''),(97,'2024-08-20 15:20:19',2,'1724167219_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,'1724167219_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-1_error_report.csv'),(98,'2024-08-20 15:20:44',2,'1724167244_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,'1724167244_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-1_error_report.csv'),(99,'2024-08-20 15:22:27',2,'1724167347_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-1.csv','00:00:08','Created: 11, Updated: 0, Deleted: 0','1724167347_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-1_error_report.csv'),(100,'2024-08-20 15:23:05',2,'1724167385_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,''),(101,'2024-08-20 15:23:26',2,'1724167406_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-1.csv','00:00:15','Created: 487, Updated: 11, Deleted: 0',''),(102,'2024-08-20 15:24:24',2,'1724167464_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-2.csv','Validation',NULL,''),(103,'2024-08-20 15:24:28',2,'1724167468_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-2.csv','Validation',NULL,''),(104,'2024-08-20 15:25:08',2,'1724167508_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-2.csv','00:00:07','Created: 11, Updated: 0, Deleted: 0','1724167508_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-2_error_report.csv'),(105,'2024-08-20 15:26:03',2,'1724167563_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-2.csv','Validation',NULL,''),(106,'2024-08-20 15:26:22',2,'1724167582_Kitchen Accessories-Plates-Kitchen Sinks-Mirror Cabinets-Lights-Mirrors-Ovens-PVC Panels attribites set products banyo to new magento 20-08-2024 File-2.csv','00:00:11','Created: 300, Updated: 11, Deleted: 0',''),(107,'2024-08-20 15:28:05',2,'1724167685_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,'1724167685_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1_error_report.csv'),(108,'2024-08-20 15:28:45',2,'1724167725_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,'1724167725_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1_error_report.csv'),(109,'2024-08-20 15:29:37',2,'1724167777_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,'1724167777_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1_error_report.csv'),(110,'2024-08-20 15:37:27',2,'1724168247_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1.csv','00:00:13','Created: 547, Updated: 0, Deleted: 0',''),(111,'2024-08-20 15:37:55',2,'1724168275_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-2.csv','00:00:30','Created: 546, Updated: 0, Deleted: 0',''),(112,'2024-08-20 15:42:27',2,'1724168547_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024-test.csv','Validation',NULL,'1724168547_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024-test_error_report.csv'),(113,'2024-08-20 15:45:57',2,'1724168757_Heating, Heating Accessories attribites set products banyo to new magento 20-08-2024 File-1.csv','00:00:26','Created: 0, Updated: 547, Deleted: 0',''),(114,'2024-08-20 16:11:05',2,'1724170265_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024 File-1.csv','Validation',NULL,''),(115,'2024-08-20 16:12:31',2,'1724170351_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024.csv','Validation',NULL,''),(116,'2024-08-20 16:13:35',2,'1724170415_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024.csv','Validation',NULL,''),(117,'2024-08-20 16:14:57',2,'1724170497_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024 File-1.csv','00:00:18','Created: 499, Updated: 0, Deleted: 0',''),(118,'2024-08-20 16:15:29',2,'1724170529_Fires, Fire Accessories, Gas Heaters attribites set products banyo to new magento 20-08-2024 File-2.csv','00:00:24','Created: 277, Updated: 0, Deleted: 0',''),(119,'2024-08-20 16:17:54',2,'1724170674_Concealed-Cisterns-Frames-Complete Showers-Furniture-Hoods-Enclosures & Doors-Coffee Machines-Hobs-Fridge Freezers-Dishwashers attribites set products banyo to new magento 20-08-2024.csv','00:00:34','Created: 780, Updated: 11, Deleted: 0',''),(120,'2024-08-20 16:24:08',2,'1724171048_Basins-Bidets-Bath Screen-Bathroom Fans-Bathroom Acce-Bath Acce-attribites set products banyo to magento 19-08-2024.csv','00:00:19','Created: 482, Updated: 11, Deleted: 0',''),(121,'2024-08-23 10:31:20',1,'1724409080_Bette child produts sku update in (other option section) banyo 23-08-2024.csv','Validation',NULL,'1724409080_Bette child produts sku update in (other option section) banyo 23-08-2024_error_report.csv'),(122,'2024-08-23 10:32:34',1,'1724409154_Bette child produts sku update in (other option section) new banyo 23-08-2024 .csv','Validation',NULL,''),(123,'2024-12-17 09:19:39',1,'1734427179_bosch oven new product 13-12-2024.csv','Validation',NULL,'1734427179_bosch oven new product 13-12-2024_error_report.csv'),(124,'2025-01-27 12:16:55',5,'1737980215_rak 1 product add in new upgrated & hyva magento (nexus) 27-01-2025.csv','00:00:04','Created: 0, Updated: 1, Deleted: 0',''),(125,'2025-01-31 16:11:10',5,'1738339870_kitchen sinks csv file 311 instock products 31-01-2025.csv','Validation',NULL,'1738339870_kitchen sinks csv file 311 instock products 31-01-2025_error_report.csv'),(126,'2025-01-31 16:12:55',5,'1738339975_kitchen sinks csv file 311 instock products 31-01-2025.csv','Validation',NULL,'1738339975_kitchen sinks csv file 311 instock products 31-01-2025_error_report.csv'),(127,'2025-02-03 07:27:15',5,'1738567635_1723727917_BATHROOM category products BANYO to new magento 15-08-2024.csv','00:00:10','Created: 274, Updated: 0, Deleted: 0',''),(128,'2025-02-03 08:18:44',5,'1738570724_Kitchen sinks csv file 311 instock products 31-01-2025 (1).csv','Validation',NULL,'1738570724_Kitchen sinks csv file 311 instock products 31-01-2025 (1)_error_report.csv'),(129,'2025-02-03 08:22:54',5,'1738570974_Kitchen sinks csv file 311 instock products 03-02-2025.csv','Validation',NULL,'1738570974_Kitchen sinks csv file 311 instock products 03-02-2025_error_report.csv'),(130,'2025-02-03 08:24:35',5,'1738571075_Kitchen sinks csv file 311 instock products 03-02-2025.csv','00:02:22','Created: 311, Updated: 0, Deleted: 0',''),(131,'2025-02-04 10:22:05',5,'1738664525_Kitchen sink 311 proudcts add in nexus live to (hyda staging nexus) 04-02-2025.csv','Validation',NULL,'1738664525_Kitchen sink 311 proudcts add in nexus live to (hyda staging nexus) 04-02-2025_error_report.csv'),(132,'2025-02-04 11:22:44',5,'1738668164_Kitchen sink 311 proudcts add in nexus live to (hyda staging nexus) 04-02-2025.csv','Validation',NULL,'1738668164_Kitchen sink 311 proudcts add in nexus live to (hyda staging nexus) 04-02-2025_error_report.csv'),(133,'2025-02-04 11:23:39',5,'1738668219_Kitchen sink 311 proudcts add in nexus live to (hyda staging nexus) 04-02-2025.csv','Validation',NULL,'1738668219_Kitchen sink 311 proudcts add in nexus live to (hyda staging nexus) 04-02-2025_error_report.csv'),(134,'2025-02-04 12:40:10',5,'1738672810_227 baths products add in banyo to hyva banyo staging 04-02-2025.csv','Validation',NULL,'1738672810_227 baths products add in banyo to hyva banyo staging 04-02-2025_error_report.csv'),(135,'2025-02-04 12:42:45',5,'1738672965_227 baths products add in banyo to hyva banyo staging 04-02-2025.csv','Validation',NULL,'1738672965_227 baths products add in banyo to hyva banyo staging 04-02-2025_error_report.csv'),(136,'2025-02-04 12:43:13',5,'1738672993_227 baths products add in banyo to hyva banyo staging 04-02-2025.csv','00:00:14','Created: 11, Updated: 0, Deleted: 0','1738672993_227 baths products add in banyo to hyva banyo staging 04-02-2025_error_report.csv'),(137,'2025-02-04 13:40:19',5,'1738676419_227 baths products add in banyo to hyva nexus staging 04-02-2025.csv','Validation',NULL,'1738676419_227 baths products add in banyo to hyva nexus staging 04-02-2025_error_report.csv'),(138,'2025-02-04 13:42:59',5,'1738676579_227 baths products add in banyo to hyva nexus staging 04-02-2025.csv','Validation',NULL,'1738676579_227 baths products add in banyo to hyva nexus staging 04-02-2025_error_report.csv'),(139,'2025-02-04 13:46:18',5,'1738676778_227 baths products add in banyo to hyva banyo staging 04-02-2025.csv','00:00:11','Created: 216, Updated: 11, Deleted: 0',''),(140,'2025-02-04 13:47:13',5,'1738676833_227 baths products add in banyo to hyva nexus staging 04-02-2025.csv','Validation',NULL,'1738676833_227 baths products add in banyo to hyva nexus staging 04-02-2025_error_report.csv');
/*!40000 ALTER TABLE `import_history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `importexport_importdata`
--

DROP TABLE IF EXISTS `importexport_importdata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `importexport_importdata` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `entity` varchar(50) NOT NULL COMMENT 'Entity',
  `behavior` varchar(10) NOT NULL DEFAULT 'append' COMMENT 'Behavior',
  `data` longtext COMMENT 'Data',
  `is_processed` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Is Row Processed',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'timestamp of last update',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=382 DEFAULT CHARSET=utf8mb3 COMMENT='Import Data Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `importexport_importdata`
--

LOCK TABLES `importexport_importdata` WRITE;
/*!40000 ALTER TABLE `importexport_importdata` DISABLE KEYS */;
/*!40000 ALTER TABLE `importexport_importdata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `indexer_state`
--

DROP TABLE IF EXISTS `indexer_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `indexer_state` (
  `state_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Indexer State ID',
  `indexer_id` varchar(255) DEFAULT NULL COMMENT 'Indexer ID',
  `status` varchar(16) DEFAULT 'invalid' COMMENT 'Indexer Status',
  `updated` datetime DEFAULT NULL COMMENT 'Indexer Status',
  `hash_config` varchar(32) NOT NULL COMMENT 'Hash of indexer config',
  PRIMARY KEY (`state_id`),
  KEY `INDEXER_STATE_INDEXER_ID` (`indexer_id`)
) ENGINE=InnoDB AUTO_INCREMENT=18 DEFAULT CHARSET=utf8mb3 COMMENT='Indexer State';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `indexer_state`
--

LOCK TABLES `indexer_state` WRITE;
/*!40000 ALTER TABLE `indexer_state` DISABLE KEYS */;
INSERT INTO `indexer_state` VALUES (1,'design_config_grid','valid','2025-02-05 07:30:36','04d9175016b40c8773d67969364fb4d2'),(2,'customer_grid','valid','2025-02-05 07:30:36','75ddd7d1d209602dedda65e11e139ca6'),(3,'catalog_category_product','valid','2025-02-05 07:30:38','4727077e2c539d8c497060feabe93e2d'),(4,'catalog_product_category','valid','2025-02-05 07:30:38','86c5b144bc85d4e37c6b6c7f9b8b0512'),(5,'catalogrule_rule','valid','2025-02-05 07:30:38','14dd218cb707454c524710ea0df0d802'),(6,'catalog_product_attribute','valid','2025-02-05 07:30:39','7ad18c06e69205b4a83e8df132887030'),(7,'cataloginventory_stock','valid','2025-02-05 07:30:39','55c805c06b574b51be85fb3bf14d0434'),(8,'inventory','valid','2025-02-05 07:30:39','c1e7a69b6745ad2e5512c5ae71a06e2b'),(9,'catalogrule_product','valid','2025-02-05 07:30:38','b0ed7ea82b55dd026ba4115b303ecefe'),(10,'catalog_product_price','valid','2025-02-05 07:30:41','17f90eac44dac966e4abe41007140d47'),(11,'catalogsearch_fulltext','valid','2025-02-05 07:30:48','3f60a2e4ebcb65c04a916fb1f9f17963'),(12,'sales_order_data_exporter','valid','2025-02-05 07:30:48','8fea55ffc42afe8d1e9b17b19d0a4ed4'),(13,'sales_order_status_data_exporter','valid','2025-02-05 07:30:48','cae841efb05c99f6be75d8adb8dbf054'),(14,'store_data_exporter','valid','2025-02-05 07:30:49','6db54ef11c62535bd628c2ad642bbf97'),(17,'bss_product_label','valid','2025-02-05 07:30:49','7b00d23b9f648e49b04bdb0fe8fb408e');
/*!40000 ALTER TABLE `indexer_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `integration`
--

DROP TABLE IF EXISTS `integration`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `integration` (
  `integration_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Integration ID',
  `name` varchar(255) NOT NULL COMMENT 'Integration name is displayed in the admin interface',
  `email` varchar(255) NOT NULL COMMENT 'Email address of the contact person',
  `endpoint` varchar(255) DEFAULT NULL COMMENT 'Endpoint for posting consumer credentials',
  `status` smallint unsigned NOT NULL COMMENT 'Integration status',
  `consumer_id` int unsigned DEFAULT NULL COMMENT 'Oauth consumer',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Creation Time',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Update Time',
  `setup_type` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Integration type - manual or config file',
  `identity_link_url` varchar(255) DEFAULT NULL COMMENT 'Identity linking Url',
  PRIMARY KEY (`integration_id`),
  UNIQUE KEY `INTEGRATION_NAME` (`name`),
  UNIQUE KEY `INTEGRATION_CONSUMER_ID` (`consumer_id`),
  CONSTRAINT `INTEGRATION_CONSUMER_ID_OAUTH_CONSUMER_ENTITY_ID` FOREIGN KEY (`consumer_id`) REFERENCES `oauth_consumer` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='integration';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `integration`
--

LOCK TABLES `integration` WRITE;
/*!40000 ALTER TABLE `integration` DISABLE KEYS */;
/*!40000 ALTER TABLE `integration` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventory_cl`
--

DROP TABLE IF EXISTS `inventory_cl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `inventory_cl` (
  `version_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Version ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  PRIMARY KEY (`version_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10506 DEFAULT CHARSET=utf8mb3 COMMENT='inventory_cl';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventory_cl`
--

LOCK TABLES `inventory_cl` WRITE;
/*!40000 ALTER TABLE `inventory_cl` DISABLE KEYS */;
INSERT INTO `inventory_cl` VALUES (1,1),(2,2),(3,3),(4,4),(5,5),(6,6),(7,7),(8,8),(9,9),(10,10),(11,11),(12,12),(13,13),(14,14),(15,15),(16,16),(17,17),(18,18),(19,19),(20,20),(21,21),(22,22),(23,23),(24,24),(25,25),(26,26),(27,27),(28,28),(29,29),(30,30),(31,31),(32,32),(33,33),(34,34),(35,35),(36,36),(37,37),(38,38),(39,39),(40,40),(41,41),(42,42),(43,43),(44,44),(45,45),(46,46),(47,47),(48,48),(49,49),(50,50),(51,51),(52,52),(53,53),(54,54),(55,55),(56,56),(57,57),(58,58),(59,59),(60,60),(61,61),(62,62),(63,63),(64,64),(65,65),(66,66),(67,67),(68,68),(69,69),(70,70),(71,71),(72,72),(73,73),(74,74),(75,75),(76,76),(77,77),(78,78),(79,79),(80,80),(81,81),(82,82),(83,83),(84,84),(85,85),(86,86),(87,87),(88,88),(89,89),(90,90),(91,91),(92,92),(93,93),(94,94),(95,95),(96,96),(97,97),(98,98),(99,99),(100,100),(101,101),(102,102),(103,103),(104,104),(105,105),(106,106),(107,107),(108,108),(109,109),(110,110),(111,111),(112,112),(113,113),(114,114),(115,115),(116,116),(117,117),(118,118),(119,119),(120,120),(121,121),(122,122),(123,123),(124,124),(125,125),(126,126),(127,127),(128,128),(129,129),(130,130),(131,131),(132,132),(133,133),(134,134),(135,135),(136,136),(137,137),(138,138),(139,139),(140,140),(141,141),(142,142),(143,143),(144,144),(145,145),(146,146),(147,147),(148,148),(149,149),(150,150),(151,151),(152,152),(153,153),(154,154),(155,155),(156,156),(157,157),(158,158),(159,159),(160,160),(161,161),(162,162),(163,163),(164,164),(165,165),(166,166),(167,167),(168,168),(169,169),(170,170),(171,171),(172,172),(173,173),(174,174),(175,175),(176,176),(177,177),(178,178),(179,179),(180,180),(181,181),(182,182),(183,183),(184,184),(185,185),(186,186),(187,187),(188,188),(189,189),(190,190),(191,191),(192,192),(193,193),(194,194),(195,195),(196,196),(197,197),(198,198),(199,199),(200,200),(201,201),(202,202),(203,203),(204,204),(205,205),(206,206),(207,207),(208,208),(209,209),(210,210),(211,211),(212,212),(213,213),(214,214),(215,215),(216,216),(217,217),(218,218),(219,219),(220,220),(221,221),(222,222),(223,223),(224,224),(225,225),(226,226),(227,227),(228,228),(229,229),(230,230),(231,231),(232,232),(233,233),(234,234),(235,235),(236,236),(237,237),(238,238),(239,239),(240,240),(241,241),(242,242),(243,243),(244,244),(245,245),(246,246),(247,247),(248,248),(249,249),(250,250),(251,251),(252,252),(253,253),(254,254),(255,255),(256,256),(257,257),(258,258),(259,259),(260,260),(261,261),(262,262),(263,263),(264,264),(265,265),(266,266),(267,267),(268,268),(269,269),(270,270),(271,271),(272,272),(273,273),(274,274),(275,275),(276,276),(277,277),(278,278),(279,279),(280,280),(281,281),(282,282),(283,283),(284,284),(285,285),(286,286),(287,287),(288,288),(289,289),(290,290),(291,291),(292,292),(293,293),(294,294),(295,295),(296,296),(297,297),(298,298),(299,299),(300,300),(301,301),(302,302),(303,303),(304,304),(305,305),(306,306),(307,307),(308,308),(309,309),(310,310),(311,311),(312,312),(313,313),(314,314),(315,315),(316,316),(317,317),(318,318),(319,319),(320,320),(321,321),(322,322),(323,323),(324,324),(325,325),(326,326),(327,327),(328,328),(329,329),(330,330),(331,331),(332,332),(333,333),(334,334),(335,335),(336,336),(337,337),(338,338),(339,339),(340,340),(341,341),(342,342),(343,343),(344,344),(345,345),(346,346),(347,347),(348,348),(349,349),(350,350),(351,351),(352,352),(353,353),(354,354),(355,355),(356,356),(357,357),(358,358),(359,359),(360,360),(361,361),(362,362),(363,363),(364,364),(365,365),(366,366),(367,367),(368,368),(369,369),(370,370),(371,371),(372,372),(373,373),(374,374),(375,375),(376,376),(377,377),(378,378),(379,379),(380,380),(381,381),(382,382),(383,383),(384,384),(385,385),(386,386),(387,387),(388,388),(389,389),(390,390),(391,391),(392,392),(393,393),(394,394),(395,395),(396,396),(397,397),(398,398),(399,399),(400,400),(401,401),(402,402),(403,403),(404,404),(405,405),(406,406),(407,407),(408,408),(409,409),(410,410),(411,411),(412,412),(413,413),(414,414),(415,415),(416,416),(417,417),(418,418),(419,419),(420,420),(421,421),(422,422),(423,423),(424,424),(425,425),(426,426),(427,427),(428,428),(429,429),(430,430),(431,431),(432,432),(433,433),(434,434),(435,435),(436,436),(437,437),(438,438),(439,439),(440,440),(441,441),(442,442),(443,443),(444,444),(445,445),(446,446),(447,447),(448,448),(449,449),(450,450),(451,451),(452,452),(453,453),(454,454),(455,455),(456,456),(457,457),(458,458),(459,459),(460,460),(461,461),(462,462),(463,463),(464,464),(465,465),(466,466),(467,467),(468,468),(469,469),(470,470),(471,471),(472,472),(473,473),(474,474),(475,475),(476,476),(477,477),(478,478),(479,479),(480,480),(481,481),(482,482),(483,483),(484,484),(485,485),(486,486),(487,487),(488,488),(489,489),(490,490),(491,491),(492,492),(493,493),(494,494),(495,495),(496,496),(497,497),(498,498),(499,499),(500,500),(501,501),(502,502),(503,503),(504,504),(505,505),(506,506),(507,507),(508,508),(509,509),(510,510),(511,511),(512,512),(513,513),(514,514),(515,515),(516,516),(517,517),(518,518),(519,519),(520,520),(521,521),(522,522),(523,523),(524,524),(525,525),(526,526),(527,527),(528,528),(529,529),(530,530),(531,531),(532,532),(533,533),(534,534),(535,535),(536,536),(537,537),(538,538),(539,539),(540,540),(541,541),(542,542),(543,543),(544,544),(545,545),(546,546),(547,547),(548,548),(549,549),(550,550),(551,551),(552,552),(553,553),(554,554),(555,555),(556,556),(557,557),(558,558),(559,559),(560,560),(561,561),(562,562),(563,563),(564,564),(565,565),(566,566),(567,567),(568,568),(569,569),(570,570),(571,571),(572,572),(573,573),(574,574),(575,575),(576,576),(577,577),(578,578),(579,579),(580,580),(581,581),(582,582),(583,583),(584,584),(585,585),(586,586),(587,587),(588,588),(589,589),(590,590),(591,591),(592,592),(593,593),(594,594),(595,595),(596,596),(597,597),(598,598),(599,599),(600,600),(601,601),(602,602),(603,603),(604,604),(605,605),(606,606),(607,607),(608,608),(609,609),(610,610),(611,611),(612,612),(613,613),(614,614),(615,615),(616,616),(617,617),(618,618),(619,619),(620,620),(621,621),(622,622),(623,623),(624,624),(625,625),(626,626),(627,627),(628,628),(629,629),(630,630),(631,631),(632,632),(633,633),(634,634),(635,635),(636,636),(637,637),(638,638),(639,639),(640,640),(641,641),(642,642),(643,643),(644,644),(645,645),(646,646),(647,647),(648,648),(649,649),(650,650),(651,651),(652,652),(653,653),(654,654),(655,655),(656,656),(657,657),(658,658),(659,659),(660,660),(661,661),(662,662),(663,663),(664,664),(665,665),(666,666),(667,667),(668,668),(669,669),(670,670),(671,671),(672,672),(673,673),(674,674),(675,675),(676,676),(677,677),(678,678),(679,679),(680,680),(681,681),(682,682),(683,683),(684,684),(685,685),(686,686),(687,687),(688,688),(689,689),(690,690),(691,691),(692,692),(693,693),(694,694),(695,695),(696,696),(697,697),(698,698),(699,699),(700,700),(701,701),(702,702),(703,703),(704,704),(705,705),(706,706),(707,707),(708,708),(709,709),(710,710),(711,711),(712,712),(713,713),(714,714),(715,715),(716,716),(717,717),(718,718),(719,719),(720,720),(721,721),(722,722),(723,723),(724,724),(725,725),(726,726),(727,727),(728,728),(729,729),(730,730),(731,731),(732,732),(733,733),(734,734),(735,735),(736,736),(737,737),(738,738),(739,739),(740,740),(741,741),(742,742),(743,743),(744,744),(745,745),(746,746),(747,747),(748,748),(749,749),(750,750),(751,751),(752,752),(753,753),(754,754),(755,755),(756,756),(757,757),(758,758),(759,759),(760,760),(761,761),(762,762),(763,763),(764,764),(765,765),(766,766),(767,767),(768,768),(769,769),(770,770),(771,771),(772,772),(773,773),(774,774),(775,775),(776,776),(777,777),(778,778),(779,779),(780,780),(781,781),(782,782),(783,783),(784,784),(785,785),(786,786),(787,787),(788,788),(789,789),(790,790),(791,791),(792,792),(793,793),(794,794),(795,795),(796,796),(797,797),(798,798),(799,799),(800,800),(801,801),(802,802),(803,803),(804,804),(805,805),(806,806),(807,807),(808,808),(809,809),(810,810),(811,811),(812,812),(813,813),(814,814),(815,815),(816,816),(817,817),(818,818),(819,819),(820,820),(821,821),(822,822),(823,823),(824,824),(825,825),(826,826),(827,827),(828,828),(829,829),(830,830),(831,831),(832,832),(833,833),(834,834),(835,835),(836,836),(837,837),(838,838),(839,839),(840,840),(841,841),(842,842),(843,843),(844,844),(845,845),(846,846),(847,847),(848,848),(849,849),(850,850),(851,851),(852,852),(853,853),(854,854),(855,855),(856,856),(857,857),(858,858),(859,859),(860,860),(861,861),(862,862),(863,863),(864,864),(865,865),(866,866),(867,867),(868,868),(869,869),(870,870),(871,871),(872,872),(873,873),(874,874),(875,875),(876,876),(877,877),(878,878),(879,879),(880,880),(881,881),(882,882),(883,883),(884,884),(885,885),(886,886),(887,887),(888,888),(889,889),(890,890),(891,891),(892,892),(893,893),(894,894),(895,895),(896,896),(897,897),(898,898),(899,899),(900,900),(901,901),(902,902),(903,903),(904,904),(905,905),(906,906),(907,907),(908,908),(909,909),(910,910),(911,911),(912,912),(913,913),(914,914),(915,915),(916,916),(917,917),(918,918),(919,919),(920,920),(921,921),(922,922),(923,923),(924,924),(925,925),(926,926),(927,927),(928,928),(929,929),(930,930),(931,931),(932,932),(933,933),(934,934),(935,935),(936,936),(937,937),(938,938),(939,939),(940,940),(941,941),(942,942),(943,943),(944,944),(945,945),(946,946),(947,947),(948,948),(949,949),(950,950),(951,951),(952,952),(953,953),(954,954),(955,955),(956,956),(957,957),(958,958),(959,959),(960,960),(961,961),(962,962),(963,963),(964,964),(965,965),(966,966),(967,967),(968,968),(969,969),(970,970),(971,971),(972,972),(973,973),(974,974),(975,975),(976,976),(977,977),(978,978),(979,979),(980,980),(981,981),(982,982),(983,983),(984,984),(985,985),(986,986),(987,987),(988,988),(989,989),(990,990),(991,991),(992,992),(993,993),(994,994),(995,995),(996,996),(997,997),(998,998),(999,999),(1000,1000),(1001,1001),(1002,1002),(1003,1003),(1004,1004),(1005,1005),(1006,1006),(1007,1007),(1008,1008),(1009,1009),(1010,1010),(1011,1011),(1012,1012),(1013,1013),(1014,1014),(1015,1015),(1016,1016),(1017,1017),(1018,1018),(1019,1019),(1020,1020),(1021,1021),(1022,1022),(1023,1023),(1024,1024),(1025,1025),(1026,1026),(1027,1027),(1028,1028),(1029,1029),(1030,1030),(1031,1031),(1032,1032),(1033,1033),(1034,1034),(1035,1035),(1036,1036),(1037,1037),(1038,1038),(1039,1039),(1040,1040),(1041,1041),(1042,1042),(1043,1043),(1044,1044),(1045,1045),(1046,1046),(1047,1047),(1048,1048),(1049,1049),(1050,1050),(1051,1051),(1052,1052),(1053,1053),(1054,1054),(1055,1055),(1056,1056),(1057,1057),(1058,1058),(1059,1059),(1060,1060),(1061,1061),(1062,1062),(1063,1063),(1064,1064),(1065,1065),(1066,1066),(1067,1067),(1068,1068),(1069,1069),(1070,1070),(1071,1071),(1072,1072),(1073,1073),(1074,1074),(1075,1075),(1076,1076),(1077,1077),(1078,1078),(1079,1079),(1080,1080),(1081,1081),(1082,1082),(1083,1083),(1084,1084),(1085,1085),(1086,1086),(1087,1087),(1088,1088),(1089,1089),(1090,1090),(1091,1091),(1092,1092),(1093,1093),(1094,1094),(1095,1095),(1096,1096),(1097,1097),(1098,1098),(1099,1099),(1100,1100),(1101,1101),(1102,1102),(1103,1103),(1104,1104),(1105,1105),(1106,1106),(1107,1107),(1108,1108),(1109,1109),(1110,1110),(1111,1111),(1112,1112),(1113,1113),(1114,1114),(1115,1115),(1116,1116),(1117,1117),(1118,1118),(1119,1119),(1120,1120),(1121,1121),(1122,1122),(1123,1123),(1124,1124),(1125,1125),(1126,1126),(1127,1127),(1128,1128),(1129,1129),(1130,1130),(1131,1131),(1132,1132),(1133,1133),(1134,1134),(1135,1135),(1136,1136),(1137,1137),(1138,1138),(1139,1139),(1140,1140),(1141,1141),(1142,1142),(1143,1143),(1144,1144),(1145,1145),(1146,1146),(1147,1147),(1148,1148),(1149,1149),(1150,1150),(1151,1151),(1152,1152),(1153,1153),(1154,1154),(1155,1155),(1156,1156),(1157,1157),(1158,1158),(1159,1159),(1160,1160),(1161,1161),(1162,1162),(1163,1163),(1164,1163),(1165,1164),(1166,1164),(1167,1165),(1168,1165),(1169,1166),(1170,1167),(1171,1168),(1172,1169),(1173,1170),(1174,1171),(1175,1172),(1176,1173),(1177,1174),(1178,1175),(1179,1176),(1180,1177),(1181,1178),(1182,1179),(1183,1180),(1184,1181),(1185,1182),(1186,1183),(1187,1184),(1188,1185),(1189,1186),(1190,1187),(1191,1188),(1192,1189),(1193,1190),(1194,1191),(1195,1192),(1196,1193),(1197,1194),(1198,1195),(1199,1196),(1200,1197),(1201,1198),(1202,1199),(1203,1200),(1204,1201),(1205,1202),(1206,1203),(1207,1204),(1208,1205),(1209,1206),(1210,1207),(1211,1208),(1212,1209),(1213,1210),(1214,1211),(1215,1212),(1216,1213),(1217,1214),(1218,1215),(1219,1216),(1220,1217),(1221,1218),(1222,1219),(1223,1220),(1224,1221),(1225,1222),(1226,1223),(1227,1224),(1228,1225),(1229,1226),(1230,1227),(1231,1228),(1232,1229),(1233,1230),(1234,1231),(1235,1232),(1236,1233),(1237,1234),(1238,1235),(1239,1236),(1240,1237),(1241,1238),(1242,1239),(1243,1240),(1244,1241),(1245,1242),(1246,1243),(1247,1244),(1248,1245),(1249,1246),(1250,1247),(1251,1248),(1252,1249),(1253,1250),(1254,1251),(1255,1252),(1256,1253),(1257,1254),(1258,1255),(1259,1256),(1260,1257),(1261,1258),(1262,1259),(1263,1260),(1264,1261),(1265,1262),(1266,1263),(1267,1264),(1268,1265),(1269,1266),(1270,1267),(1271,1268),(1272,1269),(1273,1270),(1274,1271),(1275,1272),(1276,1273),(1277,1274),(1278,1275),(1279,1276),(1280,1277),(1281,1278),(1282,1279),(1283,1280),(1284,1281),(1285,1282),(1286,1283),(1287,1284),(1288,1285),(1289,1286),(1290,1287),(1291,1288),(1292,1289),(1293,1290),(1294,1291),(1295,1292),(1296,1293),(1297,1294),(1298,1295),(1299,1296),(1300,1297),(1301,1298),(1302,1299),(1303,1300),(1304,1301),(1305,1302),(1306,1303),(1307,1304),(1308,1305),(1309,1306),(1310,1307),(1311,1308),(1312,1309),(1313,1310),(1314,1311),(1315,1312),(1316,1313),(1317,1314),(1318,1315),(1319,1316),(1320,1317),(1321,1318),(1322,1319),(1323,1320),(1324,1321),(1325,1322),(1326,1323),(1327,1324),(1328,1325),(1329,1326),(1330,1327),(1331,1328),(1332,1329),(1333,1330),(1334,1331),(1335,1332),(1336,1333),(1337,1334),(1338,1335),(1339,1336),(1340,1337),(1341,1338),(1342,1339),(1343,1340),(1344,1341),(1345,1342),(1346,1343),(1347,1344),(1348,1345),(1349,1346),(1350,1347),(1351,1348),(1352,1349),(1353,1350),(1354,1351),(1355,1352),(1356,1353),(1357,1354),(1358,1355),(1359,1356),(1360,1357),(1361,1358),(1362,1359),(1363,1360),(1364,1361),(1365,1362),(1366,1363),(1367,1364),(1368,1365),(1369,1366),(1370,1367),(1371,1368),(1372,1369),(1373,1370),(1374,1371),(1375,1372),(1376,1373),(1377,1374),(1378,1375),(1379,1376),(1380,1377),(1381,1378),(1382,1379),(1383,1380),(1384,1381),(1385,1382),(1386,1383),(1387,1384),(1388,1385),(1389,1386),(1390,1387),(1391,1388),(1392,1389),(1393,1390),(1394,1391),(1395,1392),(1396,1393),(1397,1394),(1398,1395),(1399,1396),(1400,1397),(1401,1398),(1402,1399),(1403,1400),(1404,1401),(1405,1402),(1406,1403),(1407,1404),(1408,1405),(1409,1406),(1410,1407),(1411,1408),(1412,1409),(1413,1410),(1414,1411),(1415,1412),(1416,1413),(1417,1414),(1418,1415),(1419,1416),(1420,1417),(1421,1418),(1422,1419),(1423,1420),(1424,1421),(1425,1422),(1426,1423),(1427,1424),(1428,1425),(1429,1426),(1430,1427),(1431,1428),(1432,1429),(1433,1430),(1434,1431),(1435,1432),(1436,1433),(1437,1434),(1438,1435),(1439,1436),(1440,1437),(1441,1438),(1442,1439),(1443,1440),(1444,1441),(1445,1442),(1446,1443),(1447,1444),(1448,1445),(1449,1446),(1450,1447),(1451,1448),(1452,1449),(1453,1450),(1454,1451),(1455,1452),(1456,1453),(1457,1454),(1458,1455),(1459,1456),(1460,1457),(1461,1458),(1462,1459),(1463,1460),(1464,1461),(1465,1462),(1466,1463),(1467,1464),(1468,1465),(1469,1466),(1470,1467),(1471,1468),(1472,1469),(1473,1470),(1474,1471),(1475,1472),(1476,1473),(1477,1474),(1478,1475),(1479,1476),(1480,1477),(1481,1478),(1482,1479),(1483,1480),(1484,1481),(1485,1482),(1486,1483),(1487,1484),(1488,1485),(1489,1486),(1490,1487),(1491,1488),(1492,1489),(1493,1490),(1494,1491),(1495,1492),(1496,1493),(1497,1494),(1498,1495),(1499,1496),(1500,1497),(1501,1498),(1502,1499),(1503,1500),(1504,1501),(1505,1502),(1506,1503),(1507,1504),(1508,1505),(1509,1506),(1510,1507),(1511,1508),(1512,1509),(1513,1510),(1514,1511),(1515,1512),(1516,1513),(1517,1514),(1518,1515),(1519,1516),(1520,1517),(1521,1518),(1522,1519),(1523,1520),(1524,1521),(1525,1522),(1526,1523),(1527,1524),(1528,1525),(1529,1526),(1530,1527),(1531,1528),(1532,1529),(1533,1530),(1534,1531),(1535,1532),(1536,1533),(1537,1534),(1538,1535),(1539,1536),(1540,1537),(1541,1538),(1542,1539),(1543,1540),(1544,1541),(1545,1542),(1546,1543),(1547,1544),(1548,1545),(1549,1546),(1550,1547),(1551,1548),(1552,1549),(1553,1550),(1554,1551),(1555,1552),(1556,1553),(1557,1554),(1558,1555),(1559,1556),(1560,1557),(1561,1558),(1562,1559),(1563,1560),(1564,1561),(1565,1562),(1566,1563),(1567,1564),(1568,1565),(1569,1566),(1570,1567),(1571,1568),(1572,1569),(1573,1570),(1574,1571),(1575,1572),(1576,1573),(1577,1574),(1578,1575),(1579,1576),(1580,1577),(1581,1578),(1582,1579),(1583,1580),(1584,1581),(1585,1582),(1586,1583),(1587,1584),(1588,1585),(1589,1586),(1590,1587),(1591,1588),(1592,1589),(1593,1590),(1594,1591),(1595,1592),(1596,1593),(1597,1594),(1598,1595),(1599,1596),(1600,1597),(1601,1598),(1602,1599),(1603,1600),(1604,1601),(1605,1602),(1606,1603),(1607,1604),(1608,1605),(1609,1606),(1610,1607),(1611,1608),(1612,1609),(1613,1610),(1614,1611),(1615,1612),(1616,1613),(1617,1614),(1618,1615),(1619,1616),(1620,1617),(1621,1618),(1622,1619),(1623,1620),(1624,1621),(1625,1622),(1626,1623),(1627,1624),(1628,1625),(1629,1626),(1630,1627),(1631,1628),(1632,1629),(1633,1630),(1634,1631),(1635,1632),(1636,1633),(1637,1634),(1638,1635),(1639,1636),(1640,1637),(1641,1638),(1642,1639),(1643,1640),(1644,1641),(1645,1642),(1646,1643),(1647,1644),(1648,1645),(1649,1646),(1650,1647),(1651,1648),(1652,1649),(1653,1650),(1654,1651),(1655,1652),(1656,1653),(1657,1654),(1658,1655),(1659,1656),(1660,1657),(1661,1658),(1662,1659),(1663,1660),(1664,1661),(1665,1662),(1666,1663),(1667,1664),(1668,1665),(1669,1666),(1670,1667),(1671,1668),(1672,1669),(1673,1670),(1674,1671),(1675,1672),(1676,1673),(1677,1674),(1678,1675),(1679,1676),(1680,1677),(1681,1678),(1682,1679),(1683,1680),(1684,1681),(1685,1682),(1686,1683),(1687,1684),(1688,1685),(1689,1686),(1690,1687),(1691,1688),(1692,1689),(1693,1690),(1694,1691),(1695,1692),(1696,1693),(1697,1694),(1698,1695),(1699,1696),(1700,1697),(1701,1698),(1702,1699),(1703,1700),(1704,1701),(1705,1702),(1706,1703),(1707,1704),(1708,1705),(1709,1706),(1710,1707),(1711,1708),(1712,1709),(1713,1710),(1714,1711),(1715,1712),(1716,1713),(1717,1714),(1718,1715),(1719,1716),(1720,1717),(1721,1718),(1722,1719),(1723,1720),(1724,1721),(1725,1722),(1726,1723),(1727,1724),(1728,1725),(1729,1726),(1730,1727),(1731,1728),(1732,1729),(1733,1730),(1734,1731),(1735,1732),(1736,1733),(1737,1734),(1738,1735),(1739,1736),(1740,1737),(1741,1738),(1742,1739),(1743,1740),(1744,1741),(1745,1742),(1746,1743),(1747,1744),(1748,1745),(1749,1746),(1750,1747),(1751,1748),(1752,1749),(1753,1750),(1754,1751),(1755,1752),(1756,1753),(1757,1754),(1758,1755),(1759,1756),(1760,1757),(1761,1758),(1762,1759),(1763,1760),(1764,1761),(1765,1762),(1766,1763),(1767,1764),(1768,1765),(1769,1766),(1770,1767),(1771,1768),(1772,1769),(1773,1770),(1774,1771),(1775,1772),(1776,1773),(1777,1774),(1778,1775),(1779,1776),(1780,1777),(1781,1778),(1782,1779),(1783,1780),(1784,1781),(1785,1782),(1786,1783),(1787,1784),(1788,1785),(1789,1786),(1790,1787),(1791,1788),(1792,1789),(1793,1790),(1794,1791),(1795,1792),(1796,1793),(1797,1794),(1798,1795),(1799,1796),(1800,1797),(1801,1798),(1802,1799),(1803,1800),(1804,1801),(1805,1802),(1806,1803),(1807,1804),(1808,1805),(1809,1806),(1810,1807),(1811,1808),(1812,1809),(1813,1810),(1814,1811),(1815,1812),(1816,1813),(1817,1814),(1818,1815),(1819,1816),(1820,1817),(1821,1818),(1822,1819),(1823,1820),(1824,1821),(1825,1822),(1826,1823),(1827,1824),(1828,1825),(1829,1826),(1830,1827),(1831,1828),(1832,1829),(1833,1830),(1834,1831),(1835,1832),(1836,1833),(1837,1834),(1838,1835),(1839,1836),(1840,1837),(1841,1838),(1842,1839),(1843,1840),(1844,1841),(1845,1842),(1846,1843),(1847,1844),(1848,1845),(1849,1846),(1850,1847),(1851,1848),(1852,1849),(1853,1850),(1854,1851),(1855,1852),(1856,1853),(1857,1854),(1858,1855),(1859,1856),(1860,1857),(1861,1858),(1862,1859),(1863,1860),(1864,1861),(1865,1862),(1866,1863),(1867,1864),(1868,1865),(1869,1866),(1870,1867),(1871,1868),(1872,1869),(1873,1870),(1874,1871),(1875,1872),(1876,1873),(1877,1874),(1878,1875),(1879,1876),(1880,1877),(1881,1878),(1882,1879),(1883,1880),(1884,1881),(1885,1882),(1886,1883),(1887,1884),(1888,1885),(1889,1886),(1890,1887),(1891,1888),(1892,1889),(1893,1890),(1894,1891),(1895,1892),(1896,1893),(1897,1894),(1898,1895),(1899,1896),(1900,1897),(1901,1898),(1902,1899),(1903,1900),(1904,1901),(1905,1902),(1906,1903),(1907,1904),(1908,1905),(1909,1906),(1910,1907),(1911,1908),(1912,1909),(1913,1910),(1914,1911),(1915,1912),(1916,1913),(1917,1914),(1918,1915),(1919,1916),(1920,1917),(1921,1918),(1922,1919),(1923,1920),(1924,1921),(1925,1922),(1926,1923),(1927,1924),(1928,1925),(1929,1926),(1930,1927),(1931,1928),(1932,1929),(1933,1930),(1934,1931),(1935,1932),(1936,1933),(1937,1934),(1938,1935),(1939,1936),(1940,1937),(1941,1938),(1942,1939),(1943,1940),(1944,1941),(1945,1942),(1946,1943),(1947,1944),(1948,1945),(1949,1946),(1950,1947),(1951,1948),(1952,1949),(1953,1950),(1954,1951),(1955,1952),(1956,1953),(1957,1954),(1958,1955),(1959,1956),(1960,1957),(1961,1958),(1962,1959),(1963,1960),(1964,1961),(1965,1962),(1966,1963),(1967,1964),(1968,1965),(1969,1966),(1970,1967),(1971,1968),(1972,1969),(1973,1970),(1974,1971),(1975,1972),(1976,1973),(1977,1974),(1978,1975),(1979,1976),(1980,1977),(1981,1978),(1982,1979),(1983,1980),(1984,1981),(1985,1982),(1986,1983),(1987,1984),(1988,1985),(1989,1986),(1990,1987),(1991,1988),(1992,1989),(1993,1990),(1994,1991),(1995,1992),(1996,1993),(1997,1994),(1998,1995),(1999,1996),(2000,1997),(2001,1998),(2002,1999),(2003,2000),(2004,2001),(2005,2002),(2006,2003),(2007,2004),(2008,2005),(2009,2006),(2010,2007),(2011,2008),(2012,2009),(2013,2010),(2014,2011),(2015,2012),(2016,2013),(2017,2014),(2018,2015),(2019,2016),(2020,2017),(2021,2018),(2022,2019),(2023,2020),(2024,2021),(2025,2022),(2026,2023),(2027,2024),(2028,2025),(2029,2026),(2030,2027),(2031,2028),(2032,2029),(2033,2030),(2034,2031),(2035,2032),(2036,2033),(2037,2034),(2038,2035),(2039,2036),(2040,2037),(2041,2038),(2042,2039),(2043,2040),(2044,2041),(2045,2042),(2046,2043),(2047,2044),(2048,2045),(2049,2046),(2050,2047),(2051,2048),(2052,2049),(2053,2050),(2054,2051),(2055,2052),(2056,2053),(2057,2054),(2058,2055),(2059,2056),(2060,2057),(2061,2058),(2062,2059),(2063,2060),(2064,2061),(2065,2062),(2066,2063),(2067,2064),(2068,2065),(2069,2066),(2070,2067),(2071,2068),(2072,2069),(2073,2070),(2074,2071),(2075,2072),(2076,2073),(2077,2074),(2078,2075),(2079,2076),(2080,2077),(2081,2078),(2082,2079),(2083,2080),(2084,2081),(2085,2082),(2086,2083),(2087,2084),(2088,2085),(2089,2086),(2090,2087),(2091,2088),(2092,2089),(2093,2090),(2094,2091),(2095,2092),(2096,2093),(2097,2094),(2098,2095),(2099,2096),(2100,2097),(2101,2098),(2102,2099),(2103,2100),(2104,2101),(2105,2102),(2106,2103),(2107,2104),(2108,2105),(2109,2106),(2110,2107),(2111,2108),(2112,2109),(2113,2110),(2114,2111),(2115,2112),(2116,2113),(2117,2114),(2118,2115),(2119,2116),(2120,2117),(2121,2118),(2122,2119),(2123,2120),(2124,2121),(2125,2122),(2126,2123),(2127,2124),(2128,2125),(2129,2126),(2130,2127),(2131,2128),(2132,2129),(2133,2130),(2134,2131),(2135,2132),(2136,2133),(2137,2134),(2138,2135),(2139,2136),(2140,2137),(2141,2138),(2142,2139),(2143,2140),(2144,2141),(2145,2142),(2146,2143),(2147,2144),(2148,2145),(2149,2146),(2150,2147),(2151,2148),(2152,2149),(2153,2150),(2154,2151),(2155,2152),(2156,2153),(2157,2154),(2158,2155),(2159,2156),(2160,2157),(2161,2158),(2162,2159),(2163,2160),(2164,2161),(2165,2162),(2166,2163),(2167,2164),(2168,2165),(2169,2166),(2170,2167),(2171,2168),(2172,2169),(2173,2170),(2174,2171),(2175,2172),(2176,2173),(2177,2174),(2178,2175),(2179,2176),(2180,2177),(2181,2178),(2182,2179),(2183,2180),(2184,2181),(2185,2182),(2186,2183),(2187,2184),(2188,2185),(2189,2186),(2190,2187),(2191,2188),(2192,2189),(2193,2190),(2194,2191),(2195,2192),(2196,2193),(2197,2194),(2198,2195),(2199,2196),(2200,2197),(2201,2198),(2202,2199),(2203,2200),(2204,2201),(2205,2202),(2206,2203),(2207,2204),(2208,2205),(2209,2206),(2210,2207),(2211,2208),(2212,2209),(2213,2210),(2214,2211),(2215,2212),(2216,2213),(2217,2214),(2218,2215),(2219,2216),(2220,2217),(2221,2218),(2222,2219),(2223,2220),(2224,2221),(2225,2222),(2226,2223),(2227,2224),(2228,2225),(2229,2226),(2230,2227),(2231,2228),(2232,2229),(2233,2230),(2234,2231),(2235,2232),(2236,2233),(2237,2234),(2238,2235),(2239,2236),(2240,2237),(2241,2238),(2242,2239),(2243,2240),(2244,2241),(2245,2242),(2246,2243),(2247,2244),(2248,2245),(2249,2246),(2250,2247),(2251,2248),(2252,2249),(2253,2250),(2254,2251),(2255,2252),(2256,2253),(2257,2254),(2258,2255),(2259,2256),(2260,2257),(2261,2258),(2262,2259),(2263,2260),(2264,2261),(2265,2262),(2266,2263),(2267,2264),(2268,2265),(2269,2266),(2270,2267),(2271,2268),(2272,2269),(2273,2270),(2274,2271),(2275,2272),(2276,2273),(2277,2274),(2278,2275),(2279,2276),(2280,2277),(2281,2278),(2282,2279),(2283,2280),(2284,2281),(2285,2282),(2286,2283),(2287,2284),(2288,2285),(2289,2286),(2290,2287),(2291,2288),(2292,2289),(2293,2290),(2294,2291),(2295,2292),(2296,2293),(2297,2294),(2298,2295),(2299,2296),(2300,2297),(2301,2298),(2302,2299),(2303,2300),(2304,2301),(2305,2302),(2306,2303),(2307,2304),(2308,2305),(2309,2306),(2310,2307),(2311,2308),(2312,2309),(2313,2310),(2314,2311),(2315,2312),(2316,2313),(2317,2314),(2318,2315),(2319,2316),(2320,2317),(2321,2318),(2322,2319),(2323,2320),(2324,2321),(2325,2322),(2326,2323),(2327,2324),(2328,2325),(2329,2326),(2330,2327),(2331,2328),(2332,2329),(2333,2330),(2334,2331),(2335,2332),(2336,2333),(2337,2334),(2338,2335),(2339,2336),(2340,2337),(2341,2338),(2342,2339),(2343,2340),(2344,2341),(2345,2342),(2346,2343),(2347,2344),(2348,2345),(2349,2346),(2350,2347),(2351,2348),(2352,2349),(2353,2350),(2354,2351),(2355,2352),(2356,2353),(2357,2354),(2358,2355),(2359,2356),(2360,2357),(2361,2358),(2362,2359),(2363,2360),(2364,2361),(2365,2362),(2366,2363),(2367,2364),(2368,2365),(2369,2366),(2370,2367),(2371,2368),(2372,2369),(2373,2370),(2374,2371),(2375,2372),(2376,2373),(2377,2374),(2378,2375),(2379,2376),(2380,2377),(2381,2378),(2382,2379),(2383,2380),(2384,2381),(2385,2382),(2386,2383),(2387,2384),(2388,2385),(2389,2386),(2390,2387),(2391,2388),(2392,2389),(2393,2390),(2394,2391),(2395,2392),(2396,2393),(2397,2394),(2398,2395),(2399,2396),(2400,2397),(2401,2398),(2402,2399),(2403,2400),(2404,2401),(2405,2402),(2406,2403),(2407,2404),(2408,2405),(2409,2406),(2410,2407),(2411,2408),(2412,2409),(2413,2410),(2414,2411),(2415,2412),(2416,2413),(2417,2414),(2418,2415),(2419,2416),(2420,2417),(2421,2418),(2422,2419),(2423,2420),(2424,2421),(2425,2422),(2426,2423),(2427,2424),(2428,2425),(2429,2426),(2430,2427),(2431,2428),(2432,2429),(2433,2430),(2434,2431),(2435,2432),(2436,2433),(2437,2434),(2438,2435),(2439,2436),(2440,2437),(2441,2438),(2442,2439),(2443,2440),(2444,2441),(2445,2442),(2446,2443),(2447,2444),(2448,2445),(2449,2446),(2450,2447),(2451,2448),(2452,2449),(2453,2450),(2454,2451),(2455,2452),(2456,2453),(2457,2454),(2458,2455),(2459,2456),(2460,2457),(2461,2458),(2462,2459),(2463,2460),(2464,2461),(2465,2462),(2466,2463),(2467,2464),(2468,2465),(2469,2466),(2470,2467),(2471,2468),(2472,2469),(2473,2470),(2474,2471),(2475,2472),(2476,2473),(2477,2474),(2478,2475),(2479,2476),(2480,2477),(2481,2478),(2482,2479),(2483,2480),(2484,2481),(2485,2482),(2486,2483),(2487,2484),(2488,2485),(2489,2486),(2490,2487),(2491,2488),(2492,2489),(2493,2490),(2494,2491),(2495,2492),(2496,2493),(2497,2494),(2498,2495),(2499,2496),(2500,2497),(2501,2498),(2502,2499),(2503,2500),(2504,2501),(2505,2502),(2506,2503),(2507,2504),(2508,2505),(2509,2506),(2510,2507),(2511,2508),(2512,2509),(2513,2510),(2514,2511),(2515,2512),(2516,2513),(2517,2514),(2518,2515),(2519,2516),(2520,2517),(2521,2518),(2522,2519),(2523,2520),(2524,2521),(2525,2522),(2526,2523),(2527,2524),(2528,2525),(2529,2526),(2530,2527),(2531,2528),(2532,2529),(2533,2530),(2534,2531),(2535,2532),(2536,2533),(2537,2534),(2538,2535),(2539,2536),(2540,2537),(2541,2538),(2542,2539),(2543,2540),(2544,2541),(2545,2542),(2546,2543),(2547,2544),(2548,2545),(2549,2546),(2550,2547),(2551,2548),(2552,2549),(2553,2550),(2554,2551),(2555,2552),(2556,2553),(2557,2554),(2558,2555),(2559,2556),(2560,2557),(2561,2558),(2562,2559),(2563,2560),(2564,2561),(2565,2562),(2566,2563),(2567,2564),(2568,2565),(2569,2566),(2570,2567),(2571,2568),(2572,2569),(2573,2570),(2574,2571),(2575,2572),(2576,2573),(2577,2574),(2578,2575),(2579,2576),(2580,2577),(2581,2578),(2582,2579),(2583,2580),(2584,2581),(2585,2582),(2586,2583),(2587,2584),(2588,2585),(2589,2586),(2590,2587),(2591,2588),(2592,2589),(2593,2590),(2594,2591),(2595,2592),(2596,2593),(2597,2594),(2598,2595),(2599,2596),(2600,2597),(2601,2598),(2602,2599),(2603,2600),(2604,2601),(2605,2602),(2606,2603),(2607,2604),(2608,2605),(2609,2606),(2610,2607),(2611,2608),(2612,2609),(2613,2610),(2614,2611),(2615,2612),(2616,2613),(2617,2614),(2618,2615),(2619,2616),(2620,2617),(2621,2618),(2622,2619),(2623,2620),(2624,2621),(2625,2622),(2626,2623),(2627,2624),(2628,2625),(2629,2626),(2630,2627),(2631,2628),(2632,2629),(2633,2630),(2634,2631),(2635,2632),(2636,2633),(2637,2634),(2638,2635),(2639,2636),(2640,2637),(2641,2638),(2642,2639),(2643,2640),(2644,2641),(2645,2642),(2646,2643),(2647,2644),(2648,2645),(2649,2646),(2650,2647),(2651,2648),(2652,2649),(2653,2650),(2654,2651),(2655,2652),(2656,2653),(2657,2654),(2658,2655),(2659,2656),(2660,2657),(2661,2658),(2662,2659),(2663,2660),(2664,2661),(2665,2662),(2666,2663),(2667,2664),(2668,2665),(2669,2666),(2670,2667),(2671,2668),(2672,2669),(2673,2670),(2674,2671),(2675,2672),(2676,2673),(2677,2674),(2678,2675),(2679,2676),(2680,2677),(2681,2678),(2682,2679),(2683,2680),(2684,2681),(2685,2682),(2686,2683),(2687,2684),(2688,2685),(2689,2686),(2690,2687),(2691,2688),(2692,2689),(2693,2690),(2694,2691),(2695,2692),(2696,2693),(2697,2694),(2698,2695),(2699,2696),(2700,2697),(2701,2698),(2702,2699),(2703,2700),(2704,2701),(2705,2702),(2706,2703),(2707,2704),(2708,2705),(2709,2706),(2710,2707),(2711,2708),(2712,2709),(2713,2710),(2714,2711),(2715,2712),(2716,2713),(2717,2714),(2718,2715),(2719,2716),(2720,2717),(2721,2718),(2722,2719),(2723,2720),(2724,2721),(2725,2722),(2726,2723),(2727,2724),(2728,2725),(2729,2726),(2730,2727),(2731,2728),(2732,2729),(2733,2730),(2734,2731),(2735,2732),(2736,2733),(2737,2734),(2738,2735),(2739,2736),(2740,2737),(2741,2738),(2742,2739),(2743,2740),(2744,2741),(2745,2742),(2746,2743),(2747,2744),(2748,2745),(2749,2746),(2750,2747),(2751,2748),(2752,2749),(2753,2750),(2754,2751),(2755,2752),(2756,2753),(2757,2754),(2758,2755),(2759,2756),(2760,2757),(2761,2758),(2762,2759),(2763,2760),(2764,2761),(2765,2762),(2766,2763),(2767,2764),(2768,2765),(2769,2766),(2770,2767),(2771,2768),(2772,2769),(2773,2770),(2774,2771),(2775,2772),(2776,2773),(2777,2774),(2778,2775),(2779,2776),(2780,2777),(2781,2778),(2782,2779),(2783,2780),(2784,2781),(2785,2782),(2786,2783),(2787,2784),(2788,2785),(2789,2786),(2790,2787),(2791,2788),(2792,2789),(2793,2790),(2794,2791),(2795,2792),(2796,2793),(2797,2794),(2798,2795),(2799,2796),(2800,2797),(2801,2798),(2802,2799),(2803,2800),(2804,2801),(2805,2802),(2806,2803),(2807,2804),(2808,2805),(2809,2806),(2810,2807),(2811,2808),(2812,2809),(2813,2810),(2814,2811),(2815,2812),(2816,2813),(2817,2814),(2818,2815),(2819,2816),(2820,2817),(2821,2818),(2822,2819),(2823,2820),(2824,2821),(2825,2822),(2826,2823),(2827,2824),(2828,2825),(2829,2826),(2830,2827),(2831,2828),(2832,2829),(2833,2830),(2834,2831),(2835,2832),(2836,2833),(2837,2834),(2838,2835),(2839,2836),(2840,2837),(2841,2838),(2842,2839),(2843,2840),(2844,2841),(2845,2842),(2846,2843),(2847,2844),(2848,2845),(2849,2846),(2850,2847),(2851,2848),(2852,2849),(2853,2850),(2854,2851),(2855,2852),(2856,2853),(2857,2854),(2858,2855),(2859,2856),(2860,2857),(2861,2858),(2862,2859),(2863,2860),(2864,2861),(2865,2862),(2866,2863),(2867,2864),(2868,2865),(2869,2866),(2870,2867),(2871,2868),(2872,2869),(2873,2870),(2874,2871),(2875,2872),(2876,2873),(2877,2874),(2878,2875),(2879,2876),(2880,2877),(2881,2878),(2882,2879),(2883,2880),(2884,2881),(2885,2882),(2886,2883),(2887,2884),(2888,2885),(2889,2886),(2890,2887),(2891,2888),(2892,2889),(2893,2890),(2894,2891),(2895,2892),(2896,2893),(2897,2894),(2898,2895),(2899,2896),(2900,2897),(2901,2898),(2902,2899),(2903,2900),(2904,2901),(2905,2902),(2906,2903),(2907,2904),(2908,2905),(2909,2906),(2910,2907),(2911,2908),(2912,2909),(2913,2910),(2914,2911),(2915,2912),(2916,2913),(2917,2914),(2918,2915),(2919,2916),(2920,2917),(2921,2918),(2922,2919),(2923,2920),(2924,2921),(2925,2922),(2926,2923),(2927,2924),(2928,2925),(2929,2926),(2930,2927),(2931,2928),(2932,2929),(2933,2930),(2934,2931),(2935,2932),(2936,2933),(2937,2934),(2938,2935),(2939,2936),(2940,2937),(2941,2938),(2942,2939),(2943,2940),(2944,2941),(2945,2942),(2946,2943),(2947,2944),(2948,2945),(2949,2946),(2950,2947),(2951,2948),(2952,2949),(2953,2950),(2954,2951),(2955,2952),(2956,2953),(2957,2954),(2958,2955),(2959,2956),(2960,2957),(2961,2958),(2962,2959),(2963,2960),(2964,2961),(2965,2962),(2966,2963),(2967,2964),(2968,2965),(2969,2966),(2970,2967),(2971,2968),(2972,2969),(2973,2970),(2974,2971),(2975,2972),(2976,2973),(2977,2974),(2978,2975),(2979,2976),(2980,2977),(2981,2978),(2982,2979),(2983,2980),(2984,2981),(2985,2982),(2986,2983),(2987,2984),(2988,2985),(2989,2986),(2990,2987),(2991,2988),(2992,2989),(2993,2990),(2994,2991),(2995,2992),(2996,2993),(2997,2994),(2998,2995),(2999,2996),(3000,2997),(3001,2998),(3002,2999),(3003,3000),(3004,3001),(3005,3002),(3006,3003),(3007,3004),(3008,3005),(3009,3006),(3010,3007),(3011,3008),(3012,3009),(3013,3010),(3014,3011),(3015,3012),(3016,3013),(3017,3014),(3018,3015),(3019,3016),(3020,3017),(3021,3018),(3022,3019),(3023,3020),(3024,3021),(3025,3022),(3026,3023),(3027,3024),(3028,3025),(3029,3026),(3030,3027),(3031,3028),(3032,3029),(3033,3030),(3034,3031),(3035,3032),(3036,3033),(3037,3034),(3038,3035),(3039,3036),(3040,3037),(3041,3038),(3042,3039),(3043,3040),(3044,3041),(3045,3042),(3046,3043),(3047,3044),(3048,3045),(3049,3046),(3050,3047),(3051,3048),(3052,3049),(3053,3050),(3054,3051),(3055,3052),(3056,3053),(3057,3054),(3058,3055),(3059,3056),(3060,3057),(3061,3058),(3062,3059),(3063,3060),(3064,3061),(3065,3062),(3066,3063),(3067,3064),(3068,3065),(3069,3066),(3070,3067),(3071,3068),(3072,3069),(3073,3070),(3074,3071),(3075,3072),(3076,3073),(3077,3074),(3078,3075),(3079,3076),(3080,3077),(3081,3078),(3082,3079),(3083,3080),(3084,3081),(3085,3082),(3086,3083),(3087,3084),(3088,3085),(3089,3086),(3090,3087),(3091,3088),(3092,3089),(3093,3090),(3094,3091),(3095,3092),(3096,3093),(3097,3094),(3098,3095),(3099,3096),(3100,3097),(3101,3098),(3102,3099),(3103,3100),(3104,3101),(3105,3102),(3106,3103),(3107,3104),(3108,3105),(3109,3106),(3110,3107),(3111,3108),(3112,3109),(3113,3110),(3114,3111),(3115,3112),(3116,3113),(3117,3114),(3118,3115),(3119,3116),(3120,3117),(3121,3118),(3122,3119),(3123,3120),(3124,3121),(3125,3122),(3126,3123),(3127,3124),(3128,3125),(3129,3126),(3130,3127),(3131,3128),(3132,3129),(3133,3130),(3134,3131),(3135,3132),(3136,3133),(3137,3134),(3138,3135),(3139,3136),(3140,3137),(3141,3138),(3142,3139),(3143,3140),(3144,3141),(3145,3142),(3146,3143),(3147,3144),(3148,3145),(3149,3146),(3150,3147),(3151,3148),(3152,3149),(3153,3150),(3154,3151),(3155,3152),(3156,3153),(3157,3154),(3158,3155),(3159,3156),(3160,3157),(3161,3158),(3162,3159),(3163,3160),(3164,3161),(3165,3162),(3166,3163),(3167,3164),(3168,3165),(3169,3166),(3170,3167),(3171,3168),(3172,3169),(3173,3170),(3174,3171),(3175,3172),(3176,3173),(3177,3174),(3178,3175),(3179,3176),(3180,3177),(3181,3178),(3182,3179),(3183,3180),(3184,3181),(3185,3182),(3186,3183),(3187,3184),(3188,3185),(3189,3186),(3190,3187),(3191,3188),(3192,3189),(3193,3190),(3194,3191),(3195,3192),(3196,3193),(3197,3194),(3198,3195),(3199,3196),(3200,3197),(3201,3198),(3202,3199),(3203,3200),(3204,3201),(3205,3202),(3206,3203),(3207,3204),(3208,3205),(3209,3206),(3210,3207),(3211,3208),(3212,3209),(3213,3210),(3214,3211),(3215,3212),(3216,3213),(3217,3214),(3218,3215),(3219,3216),(3220,3217),(3221,3218),(3222,3219),(3223,3220),(3224,3221),(3225,3222),(3226,3223),(3227,3224),(3228,3225),(3229,3226),(3230,3227),(3231,3228),(3232,3229),(3233,3230),(3234,3231),(3235,3232),(3236,3233),(3237,3234),(3238,3235),(3239,3236),(3240,3237),(3241,3238),(3242,3239),(3243,3240),(3244,3241),(3245,3242),(3246,3243),(3247,3244),(3248,3245),(3249,3246),(3250,3247),(3251,3248),(3252,3249),(3253,3250),(3254,3251),(3255,3252),(3256,3253),(3257,3254),(3258,3255),(3259,3256),(3260,3257),(3261,3258),(3262,3259),(3263,3260),(3264,3261),(3265,3262),(3266,3263),(3267,3264),(3268,3265),(3269,3266),(3270,3267),(3271,3268),(3272,3269),(3273,3270),(3274,3271),(3275,3272),(3276,3273),(3277,3274),(3278,3275),(3279,3276),(3280,3277),(3281,3278),(3282,3279),(3283,3280),(3284,3281),(3285,3282),(3286,3283),(3287,3284),(3288,3285),(3289,3286),(3290,3287),(3291,3288),(3292,3289),(3293,3290),(3294,3291),(3295,3292),(3296,3293),(3297,3294),(3298,3295),(3299,3296),(3300,3297),(3301,3298),(3302,3299),(3303,3300),(3304,3301),(3305,3302),(3306,3303),(3307,3304),(3308,3305),(3309,3306),(3310,3307),(3311,3308),(3312,3309),(3313,3310),(3314,3311),(3315,3312),(3316,3313),(3317,3314),(3318,3315),(3319,3316),(3320,3317),(3321,3318),(3322,3319),(3323,3320),(3324,3321),(3325,3322),(3326,3323),(3327,3324),(3328,3325),(3329,3326),(3330,3327),(3331,3328),(3332,3329),(3333,3330),(3334,3331),(3335,3332),(3336,3333),(3337,3334),(3338,3335),(3339,3336),(3340,3337),(3341,3338),(3342,3339),(3343,3340),(3344,3341),(3345,3342),(3346,3343),(3347,3344),(3348,3345),(3349,3346),(3350,3347),(3351,3348),(3352,3349),(3353,3350),(3354,3351),(3355,3352),(3356,3353),(3357,3354),(3358,3355),(3359,3356),(3360,3357),(3361,3358),(3362,3359),(3363,3360),(3364,3361),(3365,3362),(3366,3363),(3367,3364),(3368,3365),(3369,3366),(3370,3367),(3371,3368),(3372,3369),(3373,3370),(3374,3371),(3375,3372),(3376,3373),(3377,3374),(3378,3375),(3379,3376),(3380,3377),(3381,3378),(3382,3379),(3383,3380),(3384,3381),(3385,3382),(3386,3383),(3387,3384),(3388,3385),(3389,3386),(3390,3387),(3391,3388),(3392,3389),(3393,3390),(3394,3391),(3395,3392),(3396,3393),(3397,3394),(3398,3395),(3399,3396),(3400,3397),(3401,3398),(3402,3399),(3403,3400),(3404,3401),(3405,3402),(3406,3403),(3407,3404),(3408,3405),(3409,3406),(3410,3407),(3411,3408),(3412,3409),(3413,3410),(3414,3411),(3415,3412),(3416,3413),(3417,3414),(3418,3415),(3419,3416),(3420,3417),(3421,3418),(3422,3419),(3423,3420),(3424,3421),(3425,3422),(3426,3423),(3427,3424),(3428,3425),(3429,3426),(3430,3427),(3431,3428),(3432,3429),(3433,3430),(3434,3431),(3435,3432),(3436,3433),(3437,3434),(3438,3435),(3439,3436),(3440,3437),(3441,3438),(3442,3439),(3443,3440),(3444,3441),(3445,3442),(3446,3443),(3447,3444),(3448,3445),(3449,3446),(3450,3447),(3451,3448),(3452,3449),(3453,3450),(3454,3451),(3455,3452),(3456,3453),(3457,3454),(3458,3455),(3459,3456),(3460,3457),(3461,3458),(3462,3459),(3463,3460),(3464,3461),(3465,3462),(3466,3463),(3467,3464),(3468,3465),(3469,3466),(3470,3467),(3471,3468),(3472,3469),(3473,3470),(3474,3471),(3475,3472),(3476,3473),(3477,3474),(3478,3475),(3479,3476),(3480,3477),(3481,3478),(3482,3479),(3483,3480),(3484,3481),(3485,3482),(3486,3483),(3487,3484),(3488,3485),(3489,3486),(3490,3487),(3491,3488),(3492,3489),(3493,3490),(3494,3491),(3495,3492),(3496,3493),(3497,3494),(3498,3495),(3499,3496),(3500,3497),(3501,3498),(3502,3499),(3503,3500),(3504,3501),(3505,3502),(3506,3503),(3507,3504),(3508,3505),(3509,3506),(3510,3507),(3511,3508),(3512,3509),(3513,3510),(3514,3511),(3515,3512),(3516,3513),(3517,3514),(3518,3515),(3519,3516),(3520,3517),(3521,3518),(3522,3519),(3523,3520),(3524,3521),(3525,3522),(3526,3523),(3527,3524),(3528,3525),(3529,3526),(3530,3527),(3531,3528),(3532,3529),(3533,3530),(3534,3531),(3535,3532),(3536,3533),(3537,3534),(3538,3535),(3539,3536),(3540,3537),(3541,3538),(3542,3539),(3543,3540),(3544,3541),(3545,3542),(3546,3543),(3547,3544),(3548,3545),(3549,3546),(3550,3547),(3551,3548),(3552,3549),(3553,3550),(3554,3551),(3555,3552),(3556,3553),(3557,3554),(3558,3555),(3559,3556),(3560,3557),(3561,3558),(3562,3559),(3563,3560),(3564,3561),(3565,3562),(3566,3563),(3567,3564),(3568,3565),(3569,3566),(3570,3567),(3571,3568),(3572,3569),(3573,3570),(3574,3571),(3575,3572),(3576,3573),(3577,3574),(3578,3575),(3579,3576),(3580,3577),(3581,3578),(3582,3579),(3583,3580),(3584,3581),(3585,3582),(3586,3583),(3587,3584),(3588,3585),(3589,3586),(3590,3587),(3591,3588),(3592,3589),(3593,3590),(3594,3591),(3595,3592),(3596,3593),(3597,3594),(3598,3595),(3599,3596),(3600,3597),(3601,3598),(3602,3599),(3603,3600),(3604,3601),(3605,3602),(3606,3603),(3607,3604),(3608,3605),(3609,3606),(3610,3607),(3611,3608),(3612,3609),(3613,3610),(3614,3611),(3615,3612),(3616,3613),(3617,3614),(3618,3615),(3619,3616),(3620,3617),(3621,3618),(3622,3619),(3623,3620),(3624,3621),(3625,3622),(3626,3623),(3627,3624),(3628,3625),(3629,3626),(3630,3627),(3631,3628),(3632,3629),(3633,3630),(3634,3631),(3635,3632),(3636,3633),(3637,3634),(3638,3635),(3639,3636),(3640,3637),(3641,3638),(3642,3639),(3643,3640),(3644,3641),(3645,3642),(3646,3643),(3647,3644),(3648,3645),(3649,3646),(3650,3647),(3651,3648),(3652,3649),(3653,3650),(3654,3651),(3655,3652),(3656,3653),(3657,3654),(3658,3655),(3659,3656),(3660,3657),(3661,3658),(3662,3659),(3663,3660),(3664,3661),(3665,3662),(3666,3663),(3667,3664),(3668,3665),(3669,3666),(3670,3667),(3671,3668),(3672,3669),(3673,3670),(3674,3671),(3675,3672),(3676,3673),(3677,3674),(3678,3675),(3679,3676),(3680,3677),(3681,3678),(3682,3679),(3683,3680),(3684,3681),(3685,3682),(3686,3683),(3687,3684),(3688,3685),(3689,3686),(3690,3687),(3691,3688),(3692,3689),(3693,3690),(3694,3691),(3695,3692),(3696,3693),(3697,3694),(3698,3695),(3699,3696),(3700,3697),(3701,3698),(3702,3699),(3703,3700),(3704,3701),(3705,3702),(3706,3703),(3707,3704),(3708,3705),(3709,3706),(3710,3707),(3711,3708),(3712,3709),(3713,3710),(3714,3711),(3715,3712),(3716,3713),(3717,3714),(3718,3715),(3719,3716),(3720,3717),(3721,3718),(3722,3719),(3723,3720),(3724,3721),(3725,3722),(3726,3723),(3727,3724),(3728,3725),(3729,3726),(3730,3727),(3731,3728),(3732,3729),(3733,3730),(3734,3731),(3735,3732),(3736,3733),(3737,3734),(3738,3735),(3739,3736),(3740,3737),(3741,3738),(3742,3739),(3743,3740),(3744,3741),(3745,3742),(3746,3743),(3747,3744),(3748,3745),(3749,3746),(3750,3747),(3751,3748),(3752,3749),(3753,3750),(3754,3751),(3755,3752),(3756,3753),(3757,3754),(3758,3755),(3759,3756),(3760,3757),(3761,3758),(3762,3759),(3763,3760),(3764,3761),(3765,3762),(3766,3763),(3767,3764),(3768,3765),(3769,3766),(3770,3767),(3771,3768),(3772,3769),(3773,3770),(3774,3771),(3775,3772),(3776,3773),(3777,3774),(3778,3775),(3779,3776),(3780,3777),(3781,3778),(3782,3779),(3783,3780),(3784,3781),(3785,3782),(3786,3783),(3787,3784),(3788,3785),(3789,3786),(3790,3787),(3791,3788),(3792,3789),(3793,3790),(3794,3791),(3795,3792),(3796,3793),(3797,3794),(3798,3795),(3799,3796),(3800,3797),(3801,3798),(3802,3799),(3803,3800),(3804,3801),(3805,3802),(3806,3803),(3807,3804),(3808,3805),(3809,3806),(3810,3807),(3811,3808),(3812,3809),(3813,3810),(3814,3811),(3815,3812),(3816,3813),(3817,3814),(3818,3815),(3819,3816),(3820,3817),(3821,3818),(3822,3819),(3823,3820),(3824,3821),(3825,3822),(3826,3823),(3827,3824),(3828,3825),(3829,3826),(3830,3827),(3831,3828),(3832,3829),(3833,3830),(3834,3831),(3835,3832),(3836,3833),(3837,3834),(3838,3835),(3839,3836),(3840,3837),(3841,3838),(3842,3839),(3843,3840),(3844,3841),(3845,3842),(3846,3843),(3847,3844),(3848,3845),(3849,3846),(3850,3847),(3851,3848),(3852,3849),(3853,3850),(3854,3851),(3855,3852),(3856,3853),(3857,3854),(3858,3855),(3859,3856),(3860,3857),(3861,3858),(3862,3859),(3863,3860),(3864,3861),(3865,3862),(3866,3863),(3867,3864),(3868,3865),(3869,3866),(3870,3867),(3871,3868),(3872,3869),(3873,3870),(3874,3871),(3875,3872),(3876,3873),(3877,3874),(3878,3875),(3879,3876),(3880,3877),(3881,3878),(3882,3879),(3883,3880),(3884,3881),(3885,3882),(3886,3883),(3887,3884),(3888,3885),(3889,3886),(3890,3887),(3891,3888),(3892,3889),(3893,3890),(3894,3891),(3895,3892),(3896,3893),(3897,3894),(3898,3895),(3899,3896),(3900,3897),(3901,3898),(3902,3899),(3903,3900),(3904,3901),(3905,3902),(3906,3903),(3907,3904),(3908,3905),(3909,3906),(3910,3907),(3911,3908),(3912,3909),(3913,3910),(3914,3911),(3915,3912),(3916,3913),(3917,3914),(3918,3915),(3919,3916),(3920,3917),(3921,3918),(3922,3919),(3923,3920),(3924,3921),(3925,3922),(3926,3923),(3927,3924),(3928,3925),(3929,3926),(3930,3927),(3931,3928),(3932,3929),(3933,3930),(3934,3931),(3935,3932),(3936,3933),(3937,3934),(3938,3935),(3939,3936),(3940,3937),(3941,3938),(3942,3939),(3943,3940),(3944,3941),(3945,3942),(3946,3943),(3947,3944),(3948,3945),(3949,3946),(3950,3947),(3951,3948),(3952,3949),(3953,3950),(3954,3951),(3955,3952),(3956,3953),(3957,3954),(3958,3955),(3959,3956),(3960,3957),(3961,3958),(3962,3959),(3963,3960),(3964,3961),(3965,3962),(3966,3963),(3967,3964),(3968,3965),(3969,3966),(3970,3967),(3971,3968),(3972,3969),(3973,3970),(3974,3971),(3975,3972),(3976,3973),(3977,3974),(3978,3975),(3979,3976),(3980,3977),(3981,3978),(3982,3979),(3983,3980),(3984,3981),(3985,3982),(3986,3983),(3987,3984),(3988,3985),(3989,3986),(3990,3987),(3991,3988),(3992,3989),(3993,3990),(3994,3991),(3995,3992),(3996,3993),(3997,3994),(3998,3995),(3999,3996),(4000,3997),(4001,3998),(4002,3999),(4003,4000),(4004,4001),(4005,4002),(4006,4003),(4007,4004),(4008,4005),(4009,4006),(4010,4007),(4011,4008),(4012,4009),(4013,4010),(4014,4011),(4015,4012),(4016,4013),(4017,4014),(4018,4015),(4019,4016),(4020,4017),(4021,4018),(4022,4019),(4023,4020),(4024,4021),(4025,4022),(4026,4023),(4027,4024),(4028,4025),(4029,4026),(4030,4027),(4031,4028),(4032,4029),(4033,4030),(4034,4031),(4035,4032),(4036,4033),(4037,4034),(4038,4035),(4039,4036),(4040,4037),(4041,4038),(4042,4039),(4043,4040),(4044,4041),(4045,4042),(4046,4043),(4047,4044),(4048,4045),(4049,4046),(4050,4047),(4051,4048),(4052,4049),(4053,4050),(4054,4051),(4055,4052),(4056,4053),(4057,4054),(4058,4055),(4059,4056),(4060,4057),(4061,4058),(4062,4059),(4063,4060),(4064,4061),(4065,4062),(4066,4063),(4067,4064),(4068,4065),(4069,4066),(4070,4067),(4071,4068),(4072,4069),(4073,4070),(4074,4071),(4075,4072),(4076,4073),(4077,4074),(4078,4075),(4079,4076),(4080,4077),(4081,4078),(4082,4079),(4083,4080),(4084,4081),(4085,4082),(4086,4083),(4087,4084),(4088,4085),(4089,4086),(4090,4087),(4091,4088),(4092,4089),(4093,4090),(4094,4091),(4095,4092),(4096,4093),(4097,4094),(4098,4095),(4099,4096),(4100,4097),(4101,4098),(4102,4099),(4103,4100),(4104,4101),(4105,4102),(4106,4103),(4107,4104),(4108,4105),(4109,4106),(4110,4107),(4111,4108),(4112,4109),(4113,4110),(4114,4111),(4115,4112),(4116,4113),(4117,4114),(4118,4115),(4119,4116),(4120,4117),(4121,4118),(4122,4119),(4123,4120),(4124,4121),(4125,4122),(4126,4123),(4127,4124),(4128,4125),(4129,4126),(4130,4127),(4131,4128),(4132,4129),(4133,4130),(4134,4131),(4135,4132),(4136,4133),(4137,4134),(4138,4135),(4139,4136),(4140,4137),(4141,4138),(4142,4139),(4143,4140),(4144,4141),(4145,4142),(4146,4143),(4147,4144),(4148,4145),(4149,4146),(4150,4147),(4151,4148),(4152,4149),(4153,4150),(4154,4151),(4155,4152),(4156,4153),(4157,4154),(4158,4155),(4159,4156),(4160,4157),(4161,4158),(4162,4159),(4163,4160),(4164,4161),(4165,4162),(4166,4163),(4167,4164),(4168,4165),(4169,4166),(4170,4167),(4171,4168),(4172,4169),(4173,4170),(4174,4171),(4175,4172),(4176,4173),(4177,4174),(4178,4175),(4179,4176),(4180,4177),(4181,4178),(4182,4179),(4183,4180),(4184,4181),(4185,4182),(4186,4183),(4187,4184),(4188,4185),(4189,4186),(4190,4187),(4191,4188),(4192,4189),(4193,4190),(4194,4191),(4195,4192),(4196,4193),(4197,4194),(4198,4195),(4199,4196),(4200,4197),(4201,4198),(4202,4199),(4203,4200),(4204,4201),(4205,4202),(4206,4203),(4207,4204),(4208,4205),(4209,4206),(4210,4207),(4211,4208),(4212,4209),(4213,4210),(4214,4211),(4215,4212),(4216,4213),(4217,4214),(4218,4215),(4219,4216),(4220,4217),(4221,4218),(4222,4219),(4223,4220),(4224,4221),(4225,4222),(4226,4223),(4227,4224),(4228,4225),(4229,4226),(4230,4227),(4231,4228),(4232,4229),(4233,4230),(4234,4231),(4235,4232),(4236,4233),(4237,4234),(4238,4235),(4239,4236),(4240,4237),(4241,4238),(4242,4239),(4243,4240),(4244,4241),(4245,4242),(4246,4243),(4247,4244),(4248,4245),(4249,4246),(4250,4247),(4251,4248),(4252,4249),(4253,4250),(4254,4251),(4255,4252),(4256,4253),(4257,4254),(4258,4255),(4259,4256),(4260,4257),(4261,4258),(4262,4259),(4263,4260),(4264,4261),(4265,4262),(4266,4263),(4267,4264),(4268,4265),(4269,4266),(4270,4267),(4271,4268),(4272,4269),(4273,4270),(4274,4271),(4275,4272),(4276,4273),(4277,4274),(4278,4275),(4279,4276),(4280,4277),(4281,4278),(4282,4279),(4283,4280),(4284,4281),(4285,4282),(4286,4283),(4287,4284),(4288,4285),(4289,4286),(4290,4287),(4291,4288),(4292,4289),(4293,4290),(4294,4291),(4295,4292),(4296,4293),(4297,4294),(4298,4295),(4299,4296),(4300,4297),(4301,4298),(4302,4299),(4303,4300),(4304,4301),(4305,4302),(4306,4303),(4307,4304),(4308,4305),(4309,4306),(4310,4307),(4311,4308),(4312,4309),(4313,4310),(4314,4311),(4315,4312),(4316,4313),(4317,4314),(4318,4315),(4319,4316),(4320,4317),(4321,4318),(4322,4319),(4323,4320),(4324,4321),(4325,4322),(4326,4323),(4327,4324),(4328,4325),(4329,4326),(4330,4327),(4331,4328),(4332,4329),(4333,4330),(4334,4331),(4335,4332),(4336,4333),(4337,4334),(4338,4335),(4339,4336),(4340,4337),(4341,4338),(4342,4339),(4343,4340),(4344,4341),(4345,4342),(4346,4343),(4347,4344),(4348,4345),(4349,4346),(4350,4347),(4351,4348),(4352,4349),(4353,4350),(4354,4351),(4355,4352),(4356,4353),(4357,4354),(4358,4355),(4359,4356),(4360,4357),(4361,4358),(4362,4359),(4363,4360),(4364,4361),(4365,4362),(4366,4363),(4367,4364),(4368,4365),(4369,4366),(4370,4367),(4371,4368),(4372,4369),(4373,4370),(4374,4371),(4375,4372),(4376,4373),(4377,4374),(4378,4375),(4379,4376),(4380,4377),(4381,4378),(4382,4379),(4383,4380),(4384,4381),(4385,4382),(4386,4383),(4387,4384),(4388,4385),(4389,4386),(4390,4387),(4391,4388),(4392,4389),(4393,4390),(4394,4391),(4395,4392),(4396,4393),(4397,4394),(4398,4395),(4399,4396),(4400,4397),(4401,4398),(4402,4399),(4403,4400),(4404,4401),(4405,4402),(4406,4403),(4407,4404),(4408,4405),(4409,4406),(4410,4407),(4411,4408),(4412,4409),(4413,4410),(4414,4411),(4415,4412),(4416,4413),(4417,4414),(4418,4415),(4419,4416),(4420,4417),(4421,4418),(4422,4419),(4423,4420),(4424,4421),(4425,4422),(4426,4423),(4427,4424),(4428,4425),(4429,4426),(4430,4427),(4431,4428),(4432,4429),(4433,4430),(4434,4431),(4435,4432),(4436,4433),(4437,4434),(4438,4435),(4439,4436),(4440,4437),(4441,4438),(4442,4439),(4443,4440),(4444,4441),(4445,4442),(4446,4443),(4447,4444),(4448,4445),(4449,4446),(4450,4447),(4451,4448),(4452,4449),(4453,4450),(4454,4451),(4455,4452),(4456,4453),(4457,4454),(4458,4455),(4459,4456),(4460,4457),(4461,4458),(4462,4459),(4463,4460),(4464,4461),(4465,4462),(4466,4463),(4467,4464),(4468,4465),(4469,4466),(4470,4467),(4471,4468),(4472,4469),(4473,4470),(4474,4471),(4475,4472),(4476,4473),(4477,4474),(4478,4475),(4479,4476),(4480,4477),(4481,4478),(4482,4479),(4483,4480),(4484,4481),(4485,4482),(4486,4483),(4487,4484),(4488,4485),(4489,4486),(4490,4487),(4491,4488),(4492,4489),(4493,4490),(4494,4491),(4495,4492),(4496,4493),(4497,4494),(4498,4495),(4499,4496),(4500,4497),(4501,4498),(4502,4499),(4503,4500),(4504,4501),(4505,4502),(4506,4503),(4507,4504),(4508,4505),(4509,4506),(4510,4507),(4511,4508),(4512,4509),(4513,4510),(4514,4511),(4515,4512),(4516,4513),(4517,4514),(4518,4515),(4519,4516),(4520,4517),(4521,4518),(4522,4519),(4523,4520),(4524,4521),(4525,4522),(4526,4523),(4527,4524),(4528,4525),(4529,4526),(4530,4527),(4531,4528),(4532,4529),(4533,4530),(4534,4531),(4535,4532),(4536,4533),(4537,4534),(4538,4535),(4539,4536),(4540,4537),(4541,4538),(4542,4539),(4543,4540),(4544,4541),(4545,4542),(4546,4543),(4547,4544),(4548,4545),(4549,4546),(4550,4547),(4551,4548),(4552,4549),(4553,4550),(4554,4551),(4555,4552),(4556,4553),(4557,4554),(4558,4555),(4559,4556),(4560,4557),(4561,4558),(4562,4559),(4563,4560),(4564,4561),(4565,4562),(4566,4563),(4567,4564),(4568,4565),(4569,4566),(4570,4567),(4571,4568),(4572,4569),(4573,4570),(4574,4571),(4575,4572),(4576,4573),(4577,4574),(4578,4575),(4579,4576),(4580,4577),(4581,4578),(4582,4579),(4583,4580),(4584,4581),(4585,4582),(4586,4583),(4587,4584),(4588,4585),(4589,4586),(4590,4587),(4591,4588),(4592,4589),(4593,4590),(4594,4591),(4595,4592),(4596,4593),(4597,4594),(4598,4595),(4599,4596),(4600,4597),(4601,4598),(4602,4599),(4603,4600),(4604,4601),(4605,4602),(4606,4603),(4607,4604),(4608,4605),(4609,4606),(4610,4607),(4611,4608),(4612,4609),(4613,4610),(4614,4611),(4615,4612),(4616,4613),(4617,4614),(4618,4615),(4619,4616),(4620,4617),(4621,4618),(4622,4619),(4623,4620),(4624,4621),(4625,4622),(4626,4623),(4627,4624),(4628,4625),(4629,4626),(4630,4627),(4631,4628),(4632,4629),(4633,4630),(4634,4631),(4635,4632),(4636,4633),(4637,4634),(4638,4635),(4639,4636),(4640,4637),(4641,4638),(4642,4639),(4643,4640),(4644,4641),(4645,4642),(4646,4643),(4647,4644),(4648,4645),(4649,4646),(4650,4647),(4651,4648),(4652,4649),(4653,4650),(4654,4651),(4655,4652),(4656,4653),(4657,4654),(4658,4655),(4659,4656),(4660,4657),(4661,4658),(4662,4659),(4663,4660),(4664,4661),(4665,4662),(4666,4663),(4667,4664),(4668,4665),(4669,4666),(4670,4667),(4671,4668),(4672,4669),(4673,4670),(4674,4671),(4675,4672),(4676,4673),(4677,4674),(4678,4675),(4679,4676),(4680,4677),(4681,4678),(4682,4679),(4683,4680),(4684,4681),(4685,4682),(4686,4683),(4687,4684),(4688,4685),(4689,4686),(4690,4687),(4691,4688),(4692,4689),(4693,4690),(4694,4691),(4695,4692),(4696,4693),(4697,4694),(4698,4695),(4699,4696),(4700,4697),(4701,4698),(4702,4699),(4703,4700),(4704,4701),(4705,4702),(4706,4703),(4707,4704),(4708,4705),(4709,4706),(4710,4707),(4711,4708),(4712,4709),(4713,4710),(4714,4711),(4715,4712),(4716,4713),(4717,4714),(4718,4715),(4719,4716),(4720,4717),(4721,4718),(4722,4719),(4723,4720),(4724,4721),(4725,4722),(4726,4723),(4727,4724),(4728,4725),(4729,4726),(4730,4727),(4731,4728),(4732,4729),(4733,4730),(4734,4731),(4735,4732),(4736,4733),(4737,4734),(4738,4735),(4739,4736),(4740,4737),(4741,4738),(4742,4739),(4743,4740),(4744,4741),(4745,4742),(4746,4743),(4747,4744),(4748,4745),(4749,4746),(4750,4747),(4751,4748),(4752,4749),(4753,4750),(4754,4751),(4755,4752),(4756,4753),(4757,4754),(4758,4755),(4759,4756),(4760,4757),(4761,4758),(4762,4759),(4763,4760),(4764,4761),(4765,4762),(4766,4763),(4767,4764),(4768,4765),(4769,4766),(4770,4767),(4771,4768),(4772,4769),(4773,4770),(4774,4771),(4775,4772),(4776,4773),(4777,4774),(4778,4775),(4779,4776),(4780,4777),(4781,4778),(4782,4779),(4783,4780),(4784,4781),(4785,4782),(4786,4783),(4787,4784),(4788,4785),(4789,4786),(4790,4787),(4791,4788),(4792,4789),(4793,4790),(4794,4791),(4795,4792),(4796,4793),(4797,4794),(4798,4795),(4799,4796),(4800,4797),(4801,4798),(4802,4799),(4803,4800),(4804,4801),(4805,4802),(4806,4803),(4807,4804),(4808,4805),(4809,4806),(4810,4807),(4811,4808),(4812,4809),(4813,4810),(4814,4811),(4815,4812),(4816,4813),(4817,4814),(4818,4815),(4819,4816),(4820,4817),(4821,4818),(4822,4819),(4823,4820),(4824,4821),(4825,4822),(4826,4823),(4827,4824),(4828,4825),(4829,4826),(4830,4827),(4831,4828),(4832,4829),(4833,4830),(4834,4831),(4835,4832),(4836,4833),(4837,4834),(4838,4835),(4839,4836),(4840,4837),(4841,4838),(4842,4839),(4843,4840),(4844,4841),(4845,4842),(4846,4843),(4847,4844),(4848,4845),(4849,4846),(4850,4847),(4851,4848),(4852,4849),(4853,4850),(4854,4851),(4855,4852),(4856,4853),(4857,4854),(4858,4855),(4859,4856),(4860,4857),(4861,4858),(4862,4859),(4863,4860),(4864,4861),(4865,4862),(4866,4863),(4867,4864),(4868,4865),(4869,4866),(4870,4867),(4871,4868),(4872,4869),(4873,4870),(4874,4871),(4875,4872),(4876,4873),(4877,4874),(4878,4875),(4879,4876),(4880,4877),(4881,4878),(4882,4879),(4883,4880),(4884,4881),(4885,4882),(4886,4883),(4887,4884),(4888,4885),(4889,4886),(4890,4887),(4891,4888),(4892,4889),(4893,4890),(4894,4891),(4895,4892),(4896,4893),(4897,4894),(4898,4895),(4899,4896),(4900,4897),(4901,4898),(4902,4899),(4903,4900),(4904,4901),(4905,4902),(4906,4903),(4907,4904),(4908,4905),(4909,4906),(4910,4907),(4911,4908),(4912,4909),(4913,4910),(4914,4911),(4915,4912),(4916,4913),(4917,4914),(4918,4915),(4919,4916),(4920,4917),(4921,4918),(4922,4919),(4923,4920),(4924,4921),(4925,4922),(4926,4923),(4927,4924),(4928,4925),(4929,4926),(4930,4927),(4931,4928),(4932,4929),(4933,4930),(4934,4931),(4935,4932),(4936,4933),(4937,4934),(4938,4935),(4939,4936),(4940,4937),(4941,4938),(4942,4939),(4943,4940),(4944,4941),(4945,4942),(4946,4943),(4947,4944),(4948,4945),(4949,4946),(4950,4947),(4951,4948),(4952,4949),(4953,4950),(4954,4951),(4955,4952),(4956,4953),(4957,4954),(4958,4955),(4959,4956),(4960,4957),(4961,4958),(4962,4959),(4963,4960),(4964,4961),(4965,4962),(4966,4963),(4967,4964),(4968,4965),(4969,4966),(4970,4967),(4971,4968),(4972,4969),(4973,4970),(4974,4971),(4975,4972),(4976,4973),(4977,4974),(4978,4975),(4979,4976),(4980,4977),(4981,4978),(4982,4979),(4983,4980),(4984,4981),(4985,4982),(4986,4983),(4987,4984),(4988,4985),(4989,4986),(4990,4987),(4991,4988),(4992,4989),(4993,4990),(4994,4991),(4995,4992),(4996,4993),(4997,4994),(4998,4995),(4999,4996),(5000,4997),(5001,4998),(5002,4999),(5003,5000),(5004,5001),(5005,5002),(5006,5003),(5007,5004),(5008,5005),(5009,5006),(5010,5007),(5011,5008),(5012,5009),(5013,5010),(5014,5011),(5015,5012),(5016,5013),(5017,5014),(5018,5015),(5019,5016),(5020,5017),(5021,5018),(5022,5019),(5023,5020),(5024,5021),(5025,5022),(5026,5023),(5027,5024),(5028,5025),(5029,5026),(5030,5027),(5031,5028),(5032,5029),(5033,5030),(5034,5031),(5035,5032),(5036,5033),(5037,5034),(5038,5035),(5039,5036),(5040,5037),(5041,5038),(5042,5039),(5043,5040),(5044,5041),(5045,5042),(5046,5043),(5047,5044),(5048,5045),(5049,5046),(5050,5047),(5051,5048),(5052,5049),(5053,5050),(5054,5051),(5055,5052),(5056,5053),(5057,5054),(5058,5055),(5059,5056),(5060,5057),(5061,5058),(5062,5059),(5063,5060),(5064,5061),(5065,5062),(5066,5063),(5067,5064),(5068,5065),(5069,5066),(5070,5067),(5071,5068),(5072,5069),(5073,5070),(5074,5071),(5075,5072),(5076,5073),(5077,5074),(5078,5075),(5079,5076),(5080,5077),(5081,5078),(5082,5079),(5083,5080),(5084,5081),(5085,5082),(5086,5083),(5087,5084),(5088,5085),(5089,5086),(5090,5087),(5091,5088),(5092,5089),(5093,5090),(5094,5091),(5095,5092),(5096,5093),(5097,5094),(5098,5095),(5099,5096),(5100,5097),(5101,5098),(5102,5099),(5103,5100),(5104,5101),(5105,5102),(5106,5103),(5107,5104),(5108,5105),(5109,5106),(5110,5107),(5111,5108),(5112,5109),(5113,5110),(5114,5111),(5115,5112),(5116,5113),(5117,5114),(5118,5115),(5119,5116),(5120,5117),(5121,5118),(5122,5119),(5123,5120),(5124,5121),(5125,5122),(5126,5123),(5127,5124),(5128,5125),(5129,5126),(5130,5127),(5131,5128),(5132,5129),(5133,5130),(5134,5131),(5135,5132),(5136,5133),(5137,5134),(5138,5135),(5139,5136),(5140,5137),(5141,5138),(5142,5139),(5143,5140),(5144,5141),(5145,5142),(5146,5143),(5147,5144),(5148,5145),(5149,5146),(5150,5147),(5151,5148),(5152,5149),(5153,5150),(5154,5151),(5155,5152),(5156,5153),(5157,5154),(5158,5155),(5159,5156),(5160,5157),(5161,5158),(5162,5159),(5163,5160),(5164,5161),(5165,5162),(5166,5163),(5167,5164),(5168,5165),(5169,5166),(5170,5167),(5171,5168),(5172,5169),(5173,5170),(5174,5171),(5175,5172),(5176,5173),(5177,5174),(5178,5175),(5179,5176),(5180,5177),(5181,5178),(5182,5179),(5183,5180),(5184,5181),(5185,5182),(5186,5183),(5187,5184),(5188,5185),(5189,5186),(5190,5187),(5191,5188),(5192,5189),(5193,5190),(5194,5191),(5195,5192),(5196,5193),(5197,5194),(5198,5195),(5199,5196),(5200,5197),(5201,5198),(5202,5199),(5203,5200),(5204,5201),(5205,5202),(5206,5203),(5207,5204),(5208,5205),(5209,5206),(5210,5207),(5211,5208),(5212,5209),(5213,5210),(5214,5211),(5215,5212),(5216,5213),(5217,5214),(5218,5215),(5219,5216),(5220,5217),(5221,5218),(5222,5219),(5223,5220),(5224,5221),(5225,5222),(5226,5223),(5227,5224),(5228,5225),(5229,5226),(5230,5227),(5231,5228),(5232,5229),(5233,5230),(5234,5231),(5235,5232),(5236,5233),(5237,5234),(5238,5235),(5239,5236),(5240,5237),(5241,5238),(5242,5239),(5243,5240),(5244,5241),(5245,5242),(5246,5243),(5247,5244),(5248,5245),(5249,5246),(5250,5247),(5251,5248),(5252,5249),(5253,5250),(5254,5251),(5255,5252),(5256,5253),(5257,5254),(5258,5255),(5259,5256),(5260,5257),(5261,5258),(5262,5259),(5263,5260),(5264,5261),(5265,5262),(5266,5263),(5267,5264),(5268,5265),(5269,5266),(5270,5267),(5271,5268),(5272,5269),(5273,5270),(5274,5271),(5275,5272),(5276,5273),(5277,5274),(5278,5275),(5279,5276),(5280,5277),(5281,5278),(5282,5279),(5283,5280),(5284,5281),(5285,5282),(5286,5283),(5287,5284),(5288,5285),(5289,5286),(5290,5287),(5291,5288),(5292,5289),(5293,5290),(5294,5291),(5295,5292),(5296,5293),(5297,5294),(5298,5295),(5299,5296),(5300,5297),(5301,5298),(5302,5299),(5303,5300),(5304,5301),(5305,5302),(5306,5303),(5307,5304),(5308,5305),(5309,5306),(5310,5307),(5311,5308),(5312,5309),(5313,5310),(5314,5311),(5315,5312),(5316,5313),(5317,5314),(5318,5315),(5319,5316),(5320,5317),(5321,5318),(5322,5319),(5323,5320),(5324,5321),(5325,5322),(5326,5323),(5327,5324),(5328,5325),(5329,5326),(5330,5327),(5331,5328),(5332,5329),(5333,5330),(5334,5331),(5335,5332),(5336,5333),(5337,5334),(5338,5335),(5339,5336),(5340,5337),(5341,5338),(5342,5339),(5343,5340),(5344,5341),(5345,5342),(5346,5343),(5347,5344),(5348,5345),(5349,5346),(5350,5347),(5351,5348),(5352,5349),(5353,5350),(5354,5351),(5355,5352),(5356,5353),(5357,5354),(5358,5355),(5359,5356),(5360,5357),(5361,5358),(5362,5359),(5363,5360),(5364,5361),(5365,5362),(5366,5363),(5367,5364),(5368,5365),(5369,5366),(5370,5367),(5371,5368),(5372,5369),(5373,5370),(5374,5371),(5375,5372),(5376,5373),(5377,5374),(5378,5375),(5379,5376),(5380,5377),(5381,5378),(5382,5379),(5383,5380),(5384,5381),(5385,5382),(5386,5383),(5387,5384),(5388,5385),(5389,5386),(5390,5387),(5391,5388),(5392,5389),(5393,5390),(5394,5391),(5395,5392),(5396,5393),(5397,5394),(5398,5395),(5399,5396),(5400,5397),(5401,5398),(5402,5399),(5403,5400),(5404,5401),(5405,5402),(5406,5403),(5407,5404),(5408,5405),(5409,5406),(5410,5407),(5411,5408),(5412,5409),(5413,5410),(5414,5411),(5415,5412),(5416,5413),(5417,5414),(5418,5415),(5419,5416),(5420,5417),(5421,5418),(5422,5419),(5423,5420),(5424,5421),(5425,5422),(5426,5423),(5427,5424),(5428,5425),(5429,5426),(5430,5427),(5431,5428),(5432,5429),(5433,5430),(5434,5431),(5435,5432),(5436,5433),(5437,5434),(5438,5435),(5439,5436),(5440,5437),(5441,5438),(5442,5439),(5443,5440),(5444,5441),(5445,5442),(5446,5443),(5447,5444),(5448,5445),(5449,5446),(5450,5447),(5451,5448),(5452,5449),(5453,5450),(5454,5451),(5455,5452),(5456,5453),(5457,5454),(5458,5455),(5459,5456),(5460,5457),(5461,5458),(5462,5459),(5463,5460),(5464,5461),(5465,5462),(5466,5463),(5467,5464),(5468,5465),(5469,5466),(5470,5467),(5471,5468),(5472,5469),(5473,5470),(5474,5471),(5475,5472),(5476,5473),(5477,5474),(5478,5475),(5479,5476),(5480,5477),(5481,5478),(5482,5479),(5483,5480),(5484,5481),(5485,5482),(5486,5483),(5487,5484),(5488,5485),(5489,5486),(5490,5487),(5491,5488),(5492,5489),(5493,5490),(5494,5491),(5495,5492),(5496,5493),(5497,5494),(5498,5495),(5499,5496),(5500,5497),(5501,5498),(5502,5499),(5503,5500),(5504,5501),(5505,5502),(5506,5503),(5507,5504),(5508,5505),(5509,5506),(5510,5507),(5511,5508),(5512,5509),(5513,5510),(5514,5511),(5515,5512),(5516,5513),(5517,5514),(5518,5515),(5519,5516),(5520,5517),(5521,5518),(5522,5519),(5523,5520),(5524,5521),(5525,5522),(5526,5523),(5527,5524),(5528,5525),(5529,5526),(5530,5527),(5531,5528),(5532,5529),(5533,5530),(5534,5531),(5535,5532),(5536,5533),(5537,5534),(5538,5535),(5539,5536),(5540,5537),(5541,5538),(5542,5539),(5543,5540),(5544,5541),(5545,5542),(5546,5543),(5547,5544),(5548,5545),(5549,5546),(5550,5547),(5551,5548),(5552,5549),(5553,5550),(5554,5551),(5555,5552),(5556,5553),(5557,5554),(5558,5555),(5559,5556),(5560,5557),(5561,5558),(5562,5559),(5563,5560),(5564,5561),(5565,5562),(5566,5563),(5567,5564),(5568,5565),(5569,5566),(5570,5567),(5571,5568),(5572,5569),(5573,5570),(5574,5571),(5575,5572),(5576,5573),(5577,5574),(5578,5575),(5579,5576),(5580,5577),(5581,5578),(5582,5579),(5583,5580),(5584,5581),(5585,5582),(5586,5583),(5587,5584),(5588,5585),(5589,5586),(5590,5587),(5591,5588),(5592,5589),(5593,5590),(5594,5591),(5595,5592),(5596,5593),(5597,5594),(5598,5595),(5599,5596),(5600,5597),(5601,5598),(5602,5599),(5603,5600),(5604,5601),(5605,5602),(5606,5603),(5607,5604),(5608,5605),(5609,5606),(5610,5607),(5611,5608),(5612,5609),(5613,5610),(5614,5611),(5615,5612),(5616,5613),(5617,5614),(5618,5615),(5619,5616),(5620,5617),(5621,5618),(5622,5619),(5623,5620),(5624,5621),(5625,5622),(5626,5623),(5627,5624),(5628,5625),(5629,5626),(5630,5627),(5631,5628),(5632,5629),(5633,5630),(5634,5631),(5635,5632),(5636,5633),(5637,5634),(5638,5635),(5639,5636),(5640,5637),(5641,5638),(5642,5639),(5643,5640),(5644,5641),(5645,5642),(5646,5643),(5647,5644),(5648,5645),(5649,5646),(5650,5647),(5651,5648),(5652,5649),(5653,5650),(5654,5651),(5655,5652),(5656,5653),(5657,5654),(5658,5655),(5659,5656),(5660,5657),(5661,5658),(5662,5659),(5663,5660),(5664,5661),(5665,5662),(5666,5663),(5667,5664),(5668,5665),(5669,5666),(5670,5667),(5671,5668),(5672,5669),(5673,5670),(5674,5671),(5675,5672),(5676,5673),(5677,5674),(5678,5675),(5679,5676),(5680,5677),(5681,5678),(5682,5679),(5683,5680),(5684,5681),(5685,5682),(5686,5683),(5687,5684),(5688,5685),(5689,5686),(5690,5687),(5691,5688),(5692,5689),(5693,5690),(5694,5691),(5695,5692),(5696,5693),(5697,5694),(5698,5695),(5699,5696),(5700,5697),(5701,5698),(5702,5699),(5703,5700),(5704,5701),(5705,5702),(5706,5703),(5707,5704),(5708,5705),(5709,5706),(5710,5707),(5711,5708),(5712,5709),(5713,5710),(5714,5711),(5715,5712),(5716,5713),(5717,5714),(5718,5715),(5719,5716),(5720,5717),(5721,5718),(5722,5719),(5723,5720),(5724,5721),(5725,5722),(5726,5723),(5727,5724),(5728,5725),(5729,5726),(5730,5727),(5731,5728),(5732,5729),(5733,5730),(5734,5731),(5735,5732),(5736,5733),(5737,5734),(5738,5735),(5739,5736),(5740,5737),(5741,5738),(5742,5739),(5743,5740),(5744,5741),(5745,5742),(5746,5743),(5747,5744),(5748,5745),(5749,5746),(5750,5747),(5751,5748),(5752,5749),(5753,5750),(5754,5751),(5755,5752),(5756,5753),(5757,5754),(5758,5754),(5759,5755),(5760,5756),(5761,5757),(5762,5754),(5763,5754),(5764,5758),(5765,5759),(5766,5760),(5767,1165),(5768,4894),(5769,1162),(5770,5761),(5771,1954),(5772,1955),(5773,1956),(5774,2006),(5775,2009),(5776,2017),(5777,2019),(5778,2020),(5779,2036),(5780,2048),(5781,2055),(5782,2058),(5783,2061),(5784,2073),(5785,2076),(5786,2077),(5787,2078),(5788,2087),(5789,2089),(5790,2090),(5791,2092),(5792,2099),(5793,2100),(5794,2102),(5795,2109),(5796,2112),(5797,2118),(5798,2121),(5799,2155),(5800,2156),(5801,2157),(5802,2159),(5803,2160),(5804,2161),(5805,2162),(5806,5762),(5807,2166),(5808,2167),(5809,2170),(5810,2172),(5811,2173),(5812,2178),(5813,2180),(5814,2182),(5815,2199),(5816,2203),(5817,2204),(5818,2227),(5819,2228),(5820,2254),(5821,2298),(5822,2433),(5823,2434),(5824,2439),(5825,2443),(5826,2445),(5827,2446),(5828,2447),(5829,2448),(5830,5763),(5831,2469),(5832,2475),(5833,2476),(5834,2477),(5835,2478),(5836,2482),(5837,2485),(5838,2492),(5839,2496),(5840,2514),(5841,2549),(5842,2554),(5843,2555),(5844,2556),(5845,2566),(5846,2583),(5847,2586),(5848,2587),(5849,2616),(5850,2617),(5851,2618),(5852,2619),(5853,1),(5854,2),(5855,3),(5856,4),(5857,5),(5858,6),(5859,7),(5860,8),(5861,9),(5862,10),(5863,11),(5864,12),(5865,13),(5866,14),(5867,15),(5868,16),(5869,17),(5870,18),(5871,19),(5872,20),(5873,21),(5874,22),(5875,23),(5876,24),(5877,25),(5878,26),(5879,27),(5880,28),(5881,29),(5882,30),(5883,31),(5884,32),(5885,33),(5886,34),(5887,35),(5888,36),(5889,37),(5890,38),(5891,39),(5892,40),(5893,41),(5894,42),(5895,43),(5896,44),(5897,45),(5898,46),(5899,47),(5900,48),(5901,49),(5902,50),(5903,51),(5904,52),(5905,53),(5906,54),(5907,55),(5908,56),(5909,57),(5910,58),(5911,59),(5912,60),(5913,61),(5914,62),(5915,63),(5916,64),(5917,65),(5918,66),(5919,67),(5920,68),(5921,69),(5922,70),(5923,71),(5924,72),(5925,73),(5926,74),(5927,75),(5928,76),(5929,77),(5930,78),(5931,79),(5932,80),(5933,81),(5934,82),(5935,83),(5936,84),(5937,85),(5938,86),(5939,87),(5940,88),(5941,89),(5942,90),(5943,91),(5944,92),(5945,93),(5946,94),(5947,95),(5948,96),(5949,97),(5950,98),(5951,99),(5952,100),(5953,101),(5954,102),(5955,103),(5956,104),(5957,105),(5958,106),(5959,107),(5960,108),(5961,109),(5962,110),(5963,111),(5964,112),(5965,113),(5966,114),(5967,115),(5968,116),(5969,117),(5970,118),(5971,119),(5972,120),(5973,121),(5974,122),(5975,123),(5976,124),(5977,125),(5978,126),(5979,127),(5980,128),(5981,129),(5982,130),(5983,131),(5984,132),(5985,133),(5986,134),(5987,135),(5988,136),(5989,137),(5990,138),(5991,139),(5992,140),(5993,141),(5994,142),(5995,143),(5996,144),(5997,145),(5998,146),(5999,147),(6000,148),(6001,149),(6002,150),(6003,151),(6004,152),(6005,153),(6006,154),(6007,155),(6008,156),(6009,157),(6010,158),(6011,159),(6012,160),(6013,161),(6014,162),(6015,163),(6016,164),(6017,165),(6018,166),(6019,167),(6020,168),(6021,169),(6022,170),(6023,171),(6024,172),(6025,173),(6026,174),(6027,175),(6028,176),(6029,177),(6030,178),(6031,179),(6032,180),(6033,181),(6034,182),(6035,183),(6036,184),(6037,185),(6038,186),(6039,187),(6040,188),(6041,189),(6042,190),(6043,191),(6044,192),(6045,193),(6046,194),(6047,195),(6048,196),(6049,197),(6050,198),(6051,199),(6052,200),(6053,201),(6054,202),(6055,203),(6056,204),(6057,205),(6058,206),(6059,207),(6060,208),(6061,209),(6062,210),(6063,211),(6064,212),(6065,213),(6066,214),(6067,215),(6068,216),(6069,217),(6070,218),(6071,219),(6072,220),(6073,221),(6074,222),(6075,223),(6076,224),(6077,225),(6078,226),(6079,227),(6080,228),(6081,229),(6082,230),(6083,231),(6084,232),(6085,233),(6086,234),(6087,235),(6088,236),(6089,237),(6090,238),(6091,239),(6092,240),(6093,241),(6094,242),(6095,243),(6096,244),(6097,245),(6098,246),(6099,247),(6100,248),(6101,249),(6102,250),(6103,251),(6104,252),(6105,253),(6106,254),(6107,255),(6108,256),(6109,257),(6110,258),(6111,259),(6112,260),(6113,261),(6114,262),(6115,263),(6116,264),(6117,265),(6118,266),(6119,267),(6120,268),(6121,269),(6122,270),(6123,271),(6124,272),(6125,273),(6126,274),(6127,275),(6128,276),(6129,277),(6130,278),(6131,279),(6132,280),(6133,281),(6134,282),(6135,283),(6136,284),(6137,285),(6138,286),(6139,287),(6140,288),(6141,289),(6142,290),(6143,291),(6144,292),(6145,293),(6146,294),(6147,295),(6148,296),(6149,297),(6150,298),(6151,299),(6152,300),(6153,301),(6154,302),(6155,303),(6156,304),(6157,305),(6158,306),(6159,307),(6160,308),(6161,309),(6162,310),(6163,311),(6164,312),(6165,313),(6166,314),(6167,315),(6168,316),(6169,317),(6170,318),(6171,319),(6172,320),(6173,321),(6174,322),(6175,323),(6176,324),(6177,325),(6178,326),(6179,327),(6180,328),(6181,329),(6182,330),(6183,331),(6184,332),(6185,333),(6186,334),(6187,335),(6188,336),(6189,337),(6190,338),(6191,339),(6192,340),(6193,341),(6194,342),(6195,343),(6196,344),(6197,345),(6198,346),(6199,347),(6200,348),(6201,349),(6202,350),(6203,351),(6204,352),(6205,353),(6206,354),(6207,355),(6208,356),(6209,357),(6210,358),(6211,359),(6212,360),(6213,361),(6214,362),(6215,363),(6216,364),(6217,365),(6218,366),(6219,367),(6220,368),(6221,369),(6222,370),(6223,371),(6224,372),(6225,373),(6226,374),(6227,375),(6228,376),(6229,377),(6230,378),(6231,379),(6232,380),(6233,381),(6234,382),(6235,383),(6236,384),(6237,385),(6238,386),(6239,387),(6240,388),(6241,389),(6242,390),(6243,391),(6244,392),(6245,393),(6246,394),(6247,395),(6248,396),(6249,397),(6250,398),(6251,399),(6252,400),(6253,401),(6254,402),(6255,403),(6256,404),(6257,405),(6258,406),(6259,407),(6260,408),(6261,409),(6262,410),(6263,411),(6264,412),(6265,413),(6266,414),(6267,415),(6268,416),(6269,417),(6270,418),(6271,419),(6272,420),(6273,421),(6274,422),(6275,423),(6276,424),(6277,425),(6278,426),(6279,427),(6280,428),(6281,429),(6282,430),(6283,431),(6284,432),(6285,433),(6286,434),(6287,435),(6288,436),(6289,437),(6290,438),(6291,439),(6292,440),(6293,441),(6294,442),(6295,443),(6296,444),(6297,445),(6298,446),(6299,447),(6300,448),(6301,449),(6302,450),(6303,451),(6304,452),(6305,453),(6306,454),(6307,455),(6308,456),(6309,457),(6310,458),(6311,459),(6312,460),(6313,461),(6314,462),(6315,463),(6316,464),(6317,465),(6318,466),(6319,467),(6320,468),(6321,469),(6322,470),(6323,471),(6324,472),(6325,473),(6326,474),(6327,475),(6328,476),(6329,477),(6330,478),(6331,479),(6332,480),(6333,481),(6334,482),(6335,483),(6336,484),(6337,485),(6338,486),(6339,487),(6340,488),(6341,489),(6342,490),(6343,491),(6344,492),(6345,493),(6346,494),(6347,495),(6348,496),(6349,497),(6350,498),(6351,499),(6352,500),(6353,501),(6354,502),(6355,503),(6356,504),(6357,505),(6358,506),(6359,507),(6360,508),(6361,509),(6362,510),(6363,511),(6364,512),(6365,513),(6366,514),(6367,515),(6368,516),(6369,517),(6370,518),(6371,519),(6372,520),(6373,521),(6374,522),(6375,523),(6376,524),(6377,525),(6378,526),(6379,527),(6380,528),(6381,529),(6382,530),(6383,531),(6384,532),(6385,533),(6386,534),(6387,535),(6388,536),(6389,537),(6390,538),(6391,539),(6392,540),(6393,541),(6394,542),(6395,543),(6396,544),(6397,545),(6398,546),(6399,547),(6400,548),(6401,549),(6402,550),(6403,551),(6404,552),(6405,553),(6406,554),(6407,555),(6408,556),(6409,557),(6410,558),(6411,559),(6412,560),(6413,561),(6414,562),(6415,563),(6416,564),(6417,565),(6418,566),(6419,567),(6420,568),(6421,569),(6422,570),(6423,571),(6424,572),(6425,573),(6426,574),(6427,575),(6428,576),(6429,577),(6430,578),(6431,579),(6432,580),(6433,581),(6434,582),(6435,583),(6436,584),(6437,585),(6438,586),(6439,587),(6440,588),(6441,589),(6442,590),(6443,591),(6444,592),(6445,593),(6446,594),(6447,595),(6448,596),(6449,597),(6450,598),(6451,599),(6452,600),(6453,601),(6454,602),(6455,603),(6456,604),(6457,605),(6458,606),(6459,607),(6460,608),(6461,609),(6462,610),(6463,611),(6464,612),(6465,613),(6466,614),(6467,615),(6468,616),(6469,617),(6470,618),(6471,619),(6472,620),(6473,621),(6474,622),(6475,623),(6476,624),(6477,625),(6478,626),(6479,627),(6480,628),(6481,629),(6482,630),(6483,631),(6484,632),(6485,633),(6486,634),(6487,635),(6488,636),(6489,637),(6490,638),(6491,639),(6492,640),(6493,641),(6494,642),(6495,643),(6496,644),(6497,645),(6498,646),(6499,647),(6500,648),(6501,649),(6502,650),(6503,651),(6504,652),(6505,653),(6506,654),(6507,655),(6508,656),(6509,657),(6510,658),(6511,659),(6512,660),(6513,661),(6514,662),(6515,663),(6516,664),(6517,665),(6518,666),(6519,667),(6520,668),(6521,669),(6522,670),(6523,671),(6524,672),(6525,673),(6526,674),(6527,675),(6528,676),(6529,677),(6530,678),(6531,679),(6532,680),(6533,681),(6534,682),(6535,683),(6536,684),(6537,685),(6538,686),(6539,687),(6540,688),(6541,689),(6542,690),(6543,691),(6544,692),(6545,693),(6546,694),(6547,695),(6548,696),(6549,697),(6550,698),(6551,699),(6552,700),(6553,701),(6554,702),(6555,703),(6556,704),(6557,705),(6558,706),(6559,707),(6560,708),(6561,709),(6562,710),(6563,711),(6564,712),(6565,713),(6566,714),(6567,715),(6568,716),(6569,717),(6570,718),(6571,719),(6572,720),(6573,721),(6574,722),(6575,723),(6576,724),(6577,725),(6578,726),(6579,727),(6580,728),(6581,729),(6582,730),(6583,731),(6584,732),(6585,733),(6586,734),(6587,735),(6588,736),(6589,737),(6590,738),(6591,739),(6592,740),(6593,741),(6594,742),(6595,743),(6596,744),(6597,745),(6598,746),(6599,747),(6600,748),(6601,749),(6602,750),(6603,751),(6604,752),(6605,753),(6606,754),(6607,755),(6608,756),(6609,757),(6610,758),(6611,759),(6612,760),(6613,761),(6614,762),(6615,763),(6616,764),(6617,765),(6618,766),(6619,767),(6620,768),(6621,769),(6622,770),(6623,771),(6624,772),(6625,773),(6626,774),(6627,775),(6628,776),(6629,777),(6630,778),(6631,779),(6632,780),(6633,781),(6634,782),(6635,783),(6636,784),(6637,785),(6638,786),(6639,787),(6640,788),(6641,789),(6642,790),(6643,791),(6644,792),(6645,793),(6646,794),(6647,795),(6648,796),(6649,797),(6650,798),(6651,799),(6652,800),(6653,801),(6654,802),(6655,803),(6656,804),(6657,805),(6658,806),(6659,807),(6660,808),(6661,809),(6662,810),(6663,811),(6664,812),(6665,813),(6666,814),(6667,815),(6668,816),(6669,817),(6670,818),(6671,819),(6672,820),(6673,821),(6674,822),(6675,823),(6676,824),(6677,825),(6678,826),(6679,827),(6680,828),(6681,829),(6682,830),(6683,831),(6684,832),(6685,833),(6686,834),(6687,835),(6688,836),(6689,837),(6690,838),(6691,839),(6692,840),(6693,841),(6694,842),(6695,843),(6696,844),(6697,845),(6698,846),(6699,847),(6700,848),(6701,849),(6702,850),(6703,851),(6704,852),(6705,853),(6706,854),(6707,855),(6708,856),(6709,857),(6710,858),(6711,859),(6712,860),(6713,861),(6714,862),(6715,863),(6716,864),(6717,865),(6718,866),(6719,867),(6720,868),(6721,869),(6722,870),(6723,871),(6724,872),(6725,873),(6726,874),(6727,875),(6728,876),(6729,877),(6730,878),(6731,879),(6732,880),(6733,881),(6734,882),(6735,883),(6736,884),(6737,885),(6738,886),(6739,887),(6740,888),(6741,889),(6742,890),(6743,891),(6744,892),(6745,893),(6746,894),(6747,895),(6748,896),(6749,897),(6750,898),(6751,899),(6752,900),(6753,901),(6754,902),(6755,903),(6756,904),(6757,905),(6758,906),(6759,907),(6760,908),(6761,909),(6762,910),(6763,911),(6764,912),(6765,913),(6766,914),(6767,915),(6768,916),(6769,917),(6770,918),(6771,919),(6772,920),(6773,921),(6774,922),(6775,923),(6776,924),(6777,925),(6778,926),(6779,927),(6780,928),(6781,929),(6782,930),(6783,931),(6784,932),(6785,933),(6786,934),(6787,935),(6788,936),(6789,937),(6790,938),(6791,939),(6792,940),(6793,941),(6794,942),(6795,943),(6796,944),(6797,945),(6798,946),(6799,947),(6800,948),(6801,949),(6802,950),(6803,951),(6804,952),(6805,953),(6806,954),(6807,955),(6808,956),(6809,957),(6810,958),(6811,959),(6812,960),(6813,961),(6814,962),(6815,963),(6816,964),(6817,965),(6818,966),(6819,967),(6820,968),(6821,969),(6822,970),(6823,971),(6824,972),(6825,973),(6826,974),(6827,975),(6828,976),(6829,977),(6830,978),(6831,979),(6832,980),(6833,981),(6834,982),(6835,983),(6836,984),(6837,985),(6838,986),(6839,987),(6840,988),(6841,989),(6842,990),(6843,991),(6844,992),(6845,993),(6846,994),(6847,995),(6848,996),(6849,997),(6850,998),(6851,999),(6852,1000),(6853,1001),(6854,1002),(6855,1003),(6856,1004),(6857,1005),(6858,1006),(6859,1007),(6860,1008),(6861,1009),(6862,1010),(6863,1011),(6864,1012),(6865,1013),(6866,1014),(6867,1015),(6868,1016),(6869,1017),(6870,1018),(6871,1019),(6872,1020),(6873,1021),(6874,1022),(6875,1023),(6876,1024),(6877,1025),(6878,1026),(6879,1027),(6880,1028),(6881,1029),(6882,1030),(6883,1031),(6884,1032),(6885,1033),(6886,1034),(6887,1035),(6888,1036),(6889,1037),(6890,1038),(6891,1039),(6892,1040),(6893,1041),(6894,1042),(6895,1043),(6896,1044),(6897,1045),(6898,1046),(6899,1047),(6900,1048),(6901,1049),(6902,1050),(6903,1051),(6904,1052),(6905,1053),(6906,1054),(6907,1055),(6908,1056),(6909,1057),(6910,1058),(6911,1059),(6912,1060),(6913,1061),(6914,1062),(6915,1063),(6916,1064),(6917,1065),(6918,1066),(6919,1067),(6920,1068),(6921,1069),(6922,1070),(6923,1071),(6924,1072),(6925,1073),(6926,1074),(6927,1075),(6928,1076),(6929,1077),(6930,1078),(6931,1079),(6932,1080),(6933,1081),(6934,1082),(6935,1083),(6936,1084),(6937,1085),(6938,1086),(6939,1087),(6940,1088),(6941,1089),(6942,1090),(6943,1091),(6944,1092),(6945,1093),(6946,1094),(6947,1095),(6948,1096),(6949,1097),(6950,1098),(6951,1099),(6952,1100),(6953,1101),(6954,1102),(6955,1103),(6956,1104),(6957,1105),(6958,1106),(6959,1107),(6960,1108),(6961,1109),(6962,1110),(6963,1111),(6964,1112),(6965,1113),(6966,1114),(6967,1115),(6968,1116),(6969,1117),(6970,1118),(6971,5753),(6972,1120),(6973,1121),(6974,1122),(6975,1123),(6976,1124),(6977,1125),(6978,1126),(6979,1127),(6980,1128),(6981,1129),(6982,1130),(6983,1131),(6984,1132),(6985,1133),(6986,1134),(6987,1135),(6988,1136),(6989,1137),(6990,1138),(6991,1139),(6992,1140),(6993,1141),(6994,1142),(6995,1143),(6996,1144),(6997,1145),(6998,1146),(6999,1147),(7000,1148),(7001,1149),(7002,1150),(7003,1151),(7004,1152),(7005,1153),(7006,1154),(7007,1155),(7008,1156),(7009,1157),(7010,1158),(7011,1159),(7012,1160),(7013,1161),(7014,1162),(7015,1163),(7016,1164),(7017,1165),(7018,1166),(7019,1167),(7020,1168),(7021,1169),(7022,1170),(7023,1171),(7024,1172),(7025,1173),(7026,1174),(7027,1175),(7028,1176),(7029,1177),(7030,1178),(7031,1179),(7032,1180),(7033,1181),(7034,1182),(7035,1183),(7036,1184),(7037,1185),(7038,1186),(7039,1187),(7040,1188),(7041,1189),(7042,1190),(7043,1191),(7044,1192),(7045,1193),(7046,1194),(7047,1195),(7048,1196),(7049,1197),(7050,1198),(7051,1199),(7052,1200),(7053,1201),(7054,1202),(7055,1203),(7056,1204),(7057,1205),(7058,1206),(7059,1207),(7060,1208),(7061,1209),(7062,1210),(7063,1211),(7064,1212),(7065,1213),(7066,1214),(7067,1215),(7068,1216),(7069,1217),(7070,1218),(7071,1219),(7072,1220),(7073,1221),(7074,1222),(7075,1223),(7076,1224),(7077,1225),(7078,1226),(7079,1227),(7080,1228),(7081,1229),(7082,1230),(7083,1231),(7084,1232),(7085,1233),(7086,1234),(7087,1235),(7088,1236),(7089,1237),(7090,1238),(7091,1239),(7092,1240),(7093,1241),(7094,1242),(7095,1243),(7096,1244),(7097,1245),(7098,1246),(7099,1247),(7100,1248),(7101,1249),(7102,1250),(7103,1251),(7104,1252),(7105,1253),(7106,1254),(7107,1255),(7108,1256),(7109,1257),(7110,1258),(7111,1259),(7112,1260),(7113,1261),(7114,1262),(7115,1263),(7116,1264),(7117,1265),(7118,1266),(7119,1267),(7120,1268),(7121,1269),(7122,1270),(7123,1271),(7124,1272),(7125,1273),(7126,1274),(7127,1275),(7128,1276),(7129,1277),(7130,1278),(7131,1279),(7132,1280),(7133,1281),(7134,1282),(7135,1283),(7136,1284),(7137,1285),(7138,1286),(7139,1287),(7140,1288),(7141,1289),(7142,1290),(7143,1291),(7144,1292),(7145,1293),(7146,1294),(7147,1295),(7148,1296),(7149,1297),(7150,1298),(7151,1299),(7152,1300),(7153,1301),(7154,1302),(7155,1303),(7156,1304),(7157,1305),(7158,1306),(7159,1307),(7160,1308),(7161,1309),(7162,1310),(7163,1311),(7164,1312),(7165,1313),(7166,1314),(7167,1315),(7168,1316),(7169,1317),(7170,1318),(7171,1319),(7172,1320),(7173,1321),(7174,1322),(7175,1323),(7176,1324),(7177,1325),(7178,1326),(7179,1327),(7180,1328),(7181,1329),(7182,1330),(7183,1331),(7184,1332),(7185,1333),(7186,1334),(7187,1335),(7188,1336),(7189,1337),(7190,1338),(7191,1339),(7192,1340),(7193,1341),(7194,1342),(7195,1343),(7196,1344),(7197,1345),(7198,1346),(7199,1347),(7200,1348),(7201,1349),(7202,1350),(7203,1351),(7204,1352),(7205,1353),(7206,1354),(7207,1355),(7208,1356),(7209,1357),(7210,1358),(7211,1359),(7212,1360),(7213,1361),(7214,1362),(7215,1363),(7216,1364),(7217,1365),(7218,1366),(7219,1367),(7220,1368),(7221,1369),(7222,1370),(7223,1371),(7224,1372),(7225,1373),(7226,1374),(7227,1375),(7228,1376),(7229,1377),(7230,1378),(7231,1379),(7232,1380),(7233,1381),(7234,1382),(7235,1383),(7236,1384),(7237,1385),(7238,1386),(7239,1387),(7240,1388),(7241,1389),(7242,1390),(7243,1391),(7244,1392),(7245,1393),(7246,1394),(7247,1395),(7248,1396),(7249,1397),(7250,1398),(7251,1399),(7252,1400),(7253,1401),(7254,1402),(7255,1403),(7256,1404),(7257,1405),(7258,1406),(7259,1407),(7260,1408),(7261,1409),(7262,1410),(7263,1411),(7264,1412),(7265,1413),(7266,1414),(7267,1415),(7268,1416),(7269,1417),(7270,1418),(7271,1419),(7272,1420),(7273,1421),(7274,1422),(7275,1423),(7276,1424),(7277,1425),(7278,1426),(7279,1427),(7280,1428),(7281,1429),(7282,1430),(7283,1431),(7284,1432),(7285,1433),(7286,1434),(7287,1435),(7288,1436),(7289,1437),(7290,1438),(7291,1439),(7292,1440),(7293,1441),(7294,1442),(7295,1443),(7296,1444),(7297,1445),(7298,1446),(7299,1447),(7300,1448),(7301,1449),(7302,1450),(7303,1451),(7304,1452),(7305,1453),(7306,1454),(7307,1455),(7308,1456),(7309,1457),(7310,1458),(7311,1459),(7312,1460),(7313,1461),(7314,1462),(7315,1463),(7316,1464),(7317,1465),(7318,1466),(7319,1467),(7320,1468),(7321,1469),(7322,1470),(7323,1471),(7324,1472),(7325,1473),(7326,1474),(7327,1475),(7328,1476),(7329,1477),(7330,1478),(7331,1479),(7332,1480),(7333,1481),(7334,1482),(7335,1483),(7336,1484),(7337,1485),(7338,1486),(7339,1487),(7340,1488),(7341,1489),(7342,1490),(7343,1491),(7344,1492),(7345,1493),(7346,1494),(7347,1495),(7348,1496),(7349,1497),(7350,1498),(7351,1499),(7352,1500),(7353,1501),(7354,1502),(7355,1503),(7356,1504),(7357,1505),(7358,1506),(7359,1507),(7360,1508),(7361,1509),(7362,1510),(7363,1511),(7364,1512),(7365,1513),(7366,1514),(7367,1515),(7368,1516),(7369,1517),(7370,1518),(7371,1519),(7372,1520),(7373,1521),(7374,1522),(7375,1523),(7376,1524),(7377,1525),(7378,1526),(7379,1527),(7380,1528),(7381,1529),(7382,1530),(7383,1531),(7384,1532),(7385,1533),(7386,1534),(7387,1535),(7388,1536),(7389,1537),(7390,1538),(7391,1539),(7392,1540),(7393,1541),(7394,1542),(7395,1543),(7396,1544),(7397,1545),(7398,1546),(7399,1547),(7400,1548),(7401,1549),(7402,1550),(7403,1551),(7404,1552),(7405,1553),(7406,1554),(7407,1555),(7408,1556),(7409,1557),(7410,1558),(7411,1559),(7412,1560),(7413,1561),(7414,1562),(7415,1563),(7416,1564),(7417,1565),(7418,1566),(7419,1567),(7420,1568),(7421,1569),(7422,1570),(7423,1571),(7424,1572),(7425,1573),(7426,1574),(7427,1575),(7428,1576),(7429,1577),(7430,1578),(7431,1579),(7432,1580),(7433,1581),(7434,1582),(7435,1583),(7436,1584),(7437,1585),(7438,1586),(7439,1587),(7440,1588),(7441,1589),(7442,1590),(7443,1591),(7444,1592),(7445,1593),(7446,1594),(7447,1595),(7448,1596),(7449,1597),(7450,1598),(7451,1599),(7452,1600),(7453,1601),(7454,1602),(7455,1603),(7456,1604),(7457,1605),(7458,1606),(7459,1607),(7460,1608),(7461,1609),(7462,1610),(7463,1611),(7464,1612),(7465,1613),(7466,1614),(7467,1615),(7468,1616),(7469,1617),(7470,1618),(7471,1619),(7472,1620),(7473,1621),(7474,1622),(7475,1623),(7476,1624),(7477,1625),(7478,1626),(7479,1627),(7480,1628),(7481,1629),(7482,1630),(7483,1631),(7484,1632),(7485,1633),(7486,1634),(7487,1635),(7488,1636),(7489,1637),(7490,1638),(7491,1639),(7492,1640),(7493,1641),(7494,1642),(7495,1643),(7496,1644),(7497,1645),(7498,1646),(7499,1647),(7500,1648),(7501,1649),(7502,1650),(7503,1651),(7504,1652),(7505,1653),(7506,1654),(7507,1655),(7508,1656),(7509,1657),(7510,1658),(7511,1659),(7512,1660),(7513,1661),(7514,1662),(7515,1663),(7516,1664),(7517,1665),(7518,1666),(7519,1667),(7520,1668),(7521,1669),(7522,1670),(7523,1671),(7524,1672),(7525,1673),(7526,1674),(7527,1675),(7528,1676),(7529,1677),(7530,1678),(7531,1679),(7532,1680),(7533,1681),(7534,1682),(7535,1683),(7536,1684),(7537,1685),(7538,1686),(7539,1687),(7540,1688),(7541,1689),(7542,1690),(7543,1691),(7544,1692),(7545,1693),(7546,1694),(7547,1695),(7548,1696),(7549,1697),(7550,1698),(7551,1699),(7552,1700),(7553,1701),(7554,1702),(7555,1703),(7556,1704),(7557,1705),(7558,1706),(7559,1707),(7560,1708),(7561,1709),(7562,1710),(7563,1711),(7564,1712),(7565,1713),(7566,1714),(7567,1715),(7568,1716),(7569,1717),(7570,1718),(7571,1719),(7572,1720),(7573,1721),(7574,1722),(7575,1723),(7576,1724),(7577,1725),(7578,1726),(7579,1727),(7580,1728),(7581,1729),(7582,1730),(7583,1731),(7584,1732),(7585,1733),(7586,1734),(7587,1735),(7588,1736),(7589,1737),(7590,1738),(7591,1739),(7592,1740),(7593,1741),(7594,1742),(7595,1743),(7596,1744),(7597,1745),(7598,1746),(7599,1747),(7600,1748),(7601,1749),(7602,1750),(7603,1751),(7604,1752),(7605,1753),(7606,1754),(7607,1755),(7608,1756),(7609,1757),(7610,1758),(7611,1759),(7612,1760),(7613,1761),(7614,1762),(7615,1763),(7616,1764),(7617,1765),(7618,1766),(7619,1767),(7620,1768),(7621,1769),(7622,1770),(7623,1771),(7624,1772),(7625,1773),(7626,1774),(7627,1775),(7628,1776),(7629,1777),(7630,1778),(7631,1779),(7632,1780),(7633,1781),(7634,1782),(7635,1783),(7636,1784),(7637,1785),(7638,1786),(7639,1787),(7640,1788),(7641,1789),(7642,1790),(7643,1791),(7644,1792),(7645,1793),(7646,1794),(7647,1795),(7648,1796),(7649,1797),(7650,1798),(7651,1799),(7652,1800),(7653,1801),(7654,1802),(7655,1803),(7656,1804),(7657,1805),(7658,1806),(7659,1807),(7660,1808),(7661,1809),(7662,1810),(7663,1811),(7664,1812),(7665,1813),(7666,1814),(7667,1815),(7668,1816),(7669,1817),(7670,1818),(7671,1819),(7672,1820),(7673,1821),(7674,1822),(7675,1823),(7676,1824),(7677,1825),(7678,1826),(7679,1827),(7680,1828),(7681,1829),(7682,1830),(7683,1831),(7684,1832),(7685,1833),(7686,1834),(7687,1835),(7688,1836),(7689,1837),(7690,1838),(7691,1839),(7692,1840),(7693,1841),(7694,1842),(7695,1843),(7696,1844),(7697,1845),(7698,1846),(7699,1847),(7700,1848),(7701,1849),(7702,1850),(7703,1851),(7704,1852),(7705,1853),(7706,1854),(7707,1855),(7708,1856),(7709,1857),(7710,1858),(7711,1859),(7712,1860),(7713,1861),(7714,1862),(7715,1863),(7716,1864),(7717,1865),(7718,1866),(7719,1867),(7720,1868),(7721,1869),(7722,1870),(7723,1871),(7724,1872),(7725,1873),(7726,1874),(7727,1875),(7728,1876),(7729,1877),(7730,1878),(7731,1879),(7732,1880),(7733,1881),(7734,1882),(7735,1883),(7736,1884),(7737,1885),(7738,1886),(7739,1887),(7740,1888),(7741,1889),(7742,1890),(7743,1891),(7744,1892),(7745,1893),(7746,1894),(7747,1895),(7748,1896),(7749,1897),(7750,1898),(7751,1899),(7752,1900),(7753,1901),(7754,1902),(7755,1903),(7756,1904),(7757,1905),(7758,1906),(7759,1907),(7760,1908),(7761,1909),(7762,1910),(7763,1911),(7764,1912),(7765,1913),(7766,1914),(7767,1915),(7768,1916),(7769,1917),(7770,1918),(7771,1919),(7772,1920),(7773,1921),(7774,1922),(7775,1923),(7776,1924),(7777,1925),(7778,1926),(7779,1927),(7780,1928),(7781,1929),(7782,1930),(7783,1931),(7784,1932),(7785,1933),(7786,1934),(7787,1935),(7788,1936),(7789,1937),(7790,1938),(7791,1939),(7792,1940),(7793,1941),(7794,1942),(7795,1943),(7796,1944),(7797,1945),(7798,1946),(7799,1947),(7800,1948),(7801,1949),(7802,1950),(7803,1951),(7804,1952),(7805,1953),(7806,1954),(7807,1955),(7808,1956),(7809,1957),(7810,1958),(7811,1959),(7812,1960),(7813,1961),(7814,1962),(7815,1963),(7816,1964),(7817,1965),(7818,1966),(7819,1967),(7820,1968),(7821,1969),(7822,1970),(7823,1971),(7824,1972),(7825,1973),(7826,1974),(7827,1975),(7828,1976),(7829,1977),(7830,1978),(7831,1979),(7832,1980),(7833,1981),(7834,1982),(7835,1983),(7836,1984),(7837,1985),(7838,1986),(7839,1987),(7840,1988),(7841,1989),(7842,1990),(7843,1991),(7844,1992),(7845,1993),(7846,1994),(7847,1995),(7848,1996),(7849,1997),(7850,1998),(7851,1999),(7852,2000),(7853,2001),(7854,2002),(7855,2003),(7856,2004),(7857,2005),(7858,2006),(7859,2007),(7860,2008),(7861,2009),(7862,2010),(7863,2011),(7864,2012),(7865,2013),(7866,2014),(7867,2015),(7868,2016),(7869,2017),(7870,2018),(7871,2019),(7872,2020),(7873,2021),(7874,2022),(7875,2023),(7876,2024),(7877,2025),(7878,2026),(7879,2027),(7880,2028),(7881,2029),(7882,2030),(7883,2031),(7884,2032),(7885,2033),(7886,2034),(7887,2035),(7888,2036),(7889,2037),(7890,2038),(7891,2039),(7892,2040),(7893,2041),(7894,2042),(7895,2043),(7896,2044),(7897,2045),(7898,2046),(7899,2047),(7900,2048),(7901,2049),(7902,2050),(7903,2051),(7904,2052),(7905,2053),(7906,2054),(7907,2055),(7908,2056),(7909,2057),(7910,2058),(7911,2059),(7912,2060),(7913,2061),(7914,2062),(7915,2063),(7916,2064),(7917,2065),(7918,2066),(7919,2067),(7920,2068),(7921,2069),(7922,2070),(7923,2071),(7924,2072),(7925,2073),(7926,2074),(7927,2075),(7928,2076),(7929,2077),(7930,2078),(7931,2079),(7932,2080),(7933,2081),(7934,2082),(7935,2083),(7936,2084),(7937,2085),(7938,2086),(7939,2087),(7940,2088),(7941,2089),(7942,2090),(7943,2091),(7944,2092),(7945,2093),(7946,2094),(7947,2095),(7948,2096),(7949,2097),(7950,2098),(7951,2099),(7952,2100),(7953,2101),(7954,2102),(7955,2103),(7956,2104),(7957,2105),(7958,2106),(7959,2107),(7960,2108),(7961,2109),(7962,2110),(7963,2111),(7964,2112),(7965,2113),(7966,2114),(7967,2115),(7968,2116),(7969,2117),(7970,2118),(7971,2119),(7972,2120),(7973,2121),(7974,2122),(7975,2123),(7976,2124),(7977,2125),(7978,2126),(7979,2127),(7980,2128),(7981,2129),(7982,2130),(7983,2131),(7984,2132),(7985,2133),(7986,2134),(7987,2135),(7988,2136),(7989,2137),(7990,2138),(7991,2139),(7992,2140),(7993,2141),(7994,2142),(7995,2143),(7996,2144),(7997,2145),(7998,2146),(7999,2147),(8000,2148),(8001,2149),(8002,2150),(8003,2151),(8004,2152),(8005,2153),(8006,2154),(8007,2155),(8008,2156),(8009,2157),(8010,2158),(8011,2159),(8012,2160),(8013,2161),(8014,2162),(8015,2163),(8016,2164),(8017,2165),(8018,2166),(8019,2167),(8020,2168),(8021,2169),(8022,2170),(8023,2171),(8024,2172),(8025,2173),(8026,2174),(8027,2175),(8028,2176),(8029,2177),(8030,2178),(8031,2179),(8032,2180),(8033,2181),(8034,2182),(8035,2183),(8036,2184),(8037,2185),(8038,2186),(8039,2187),(8040,2188),(8041,2189),(8042,2190),(8043,2191),(8044,2192),(8045,2193),(8046,2194),(8047,2195),(8048,2196),(8049,2197),(8050,2198),(8051,2199),(8052,2200),(8053,2201),(8054,2202),(8055,2203),(8056,2204),(8057,2205),(8058,2206),(8059,2207),(8060,2208),(8061,2209),(8062,2210),(8063,2211),(8064,2212),(8065,2213),(8066,2214),(8067,2215),(8068,2216),(8069,2217),(8070,2218),(8071,2219),(8072,2220),(8073,2221),(8074,2222),(8075,2223),(8076,2224),(8077,2225),(8078,2226),(8079,2227),(8080,2228),(8081,2229),(8082,2230),(8083,2231),(8084,2232),(8085,2233),(8086,2234),(8087,2235),(8088,2236),(8089,2237),(8090,2238),(8091,2239),(8092,2240),(8093,2241),(8094,2242),(8095,2243),(8096,2244),(8097,2245),(8098,2246),(8099,2247),(8100,2248),(8101,2249),(8102,2250),(8103,2251),(8104,2252),(8105,2253),(8106,2254),(8107,2255),(8108,2256),(8109,2257),(8110,2258),(8111,2259),(8112,2260),(8113,2261),(8114,2262),(8115,2263),(8116,2264),(8117,2265),(8118,2266),(8119,2267),(8120,2268),(8121,2269),(8122,2270),(8123,2271),(8124,2272),(8125,2273),(8126,2274),(8127,2275),(8128,2276),(8129,2277),(8130,2278),(8131,2279),(8132,2280),(8133,2281),(8134,2282),(8135,2283),(8136,2284),(8137,2285),(8138,2286),(8139,2287),(8140,2288),(8141,2289),(8142,2290),(8143,2291),(8144,2292),(8145,2293),(8146,2294),(8147,2295),(8148,2296),(8149,2297),(8150,2298),(8151,2299),(8152,2300),(8153,2301),(8154,2302),(8155,2303),(8156,2304),(8157,2305),(8158,2306),(8159,2307),(8160,2308),(8161,2309),(8162,2310),(8163,2311),(8164,2312),(8165,2313),(8166,2314),(8167,2315),(8168,2316),(8169,2317),(8170,2318),(8171,2319),(8172,2320),(8173,2321),(8174,2322),(8175,2323),(8176,2324),(8177,2325),(8178,2326),(8179,2327),(8180,2328),(8181,2329),(8182,2330),(8183,2331),(8184,2332),(8185,2333),(8186,2334),(8187,2335),(8188,2336),(8189,2337),(8190,2338),(8191,2339),(8192,2340),(8193,2341),(8194,2342),(8195,2343),(8196,2344),(8197,2345),(8198,2346),(8199,2347),(8200,2348),(8201,2349),(8202,2350),(8203,2351),(8204,2352),(8205,2353),(8206,2354),(8207,2355),(8208,2356),(8209,2357),(8210,2358),(8211,2359),(8212,2360),(8213,2361),(8214,2362),(8215,2363),(8216,2364),(8217,2365),(8218,2366),(8219,2367),(8220,2368),(8221,2369),(8222,2370),(8223,2371),(8224,2372),(8225,2373),(8226,2374),(8227,2375),(8228,2376),(8229,2377),(8230,2378),(8231,2379),(8232,2380),(8233,2381),(8234,2382),(8235,2383),(8236,2384),(8237,2385),(8238,2386),(8239,2387),(8240,2388),(8241,2389),(8242,2390),(8243,2391),(8244,2392),(8245,2393),(8246,2394),(8247,2395),(8248,2396),(8249,2397),(8250,2398),(8251,2399),(8252,2400),(8253,2401),(8254,2402),(8255,2403),(8256,2404),(8257,2405),(8258,2406),(8259,2407),(8260,2408),(8261,2409),(8262,2410),(8263,2411),(8264,2412),(8265,2413),(8266,2414),(8267,2415),(8268,2416),(8269,2417),(8270,2418),(8271,2419),(8272,2420),(8273,2421),(8274,2422),(8275,2423),(8276,2424),(8277,2425),(8278,2426),(8279,2427),(8280,2428),(8281,2429),(8282,2430),(8283,2431),(8284,2432),(8285,2433),(8286,2434),(8287,2435),(8288,2436),(8289,2437),(8290,2438),(8291,2439),(8292,2440),(8293,2441),(8294,2442),(8295,2443),(8296,2444),(8297,2445),(8298,2446),(8299,2447),(8300,2448),(8301,2449),(8302,2450),(8303,2451),(8304,2452),(8305,2453),(8306,2454),(8307,2455),(8308,2456),(8309,2457),(8310,2458),(8311,2459),(8312,2460),(8313,2461),(8314,2462),(8315,2463),(8316,2464),(8317,2465),(8318,2466),(8319,2467),(8320,2468),(8321,2469),(8322,2470),(8323,2471),(8324,2472),(8325,2473),(8326,2474),(8327,2475),(8328,2476),(8329,2477),(8330,2478),(8331,2479),(8332,2480),(8333,2481),(8334,2482),(8335,2483),(8336,2484),(8337,2485),(8338,2486),(8339,2487),(8340,2488),(8341,2489),(8342,2490),(8343,2491),(8344,2492),(8345,2493),(8346,2494),(8347,2495),(8348,2496),(8349,2497),(8350,2498),(8351,2499),(8352,2500),(8353,2501),(8354,2502),(8355,2503),(8356,2504),(8357,2505),(8358,2506),(8359,2507),(8360,2508),(8361,2509),(8362,2510),(8363,2511),(8364,2512),(8365,2513),(8366,2514),(8367,2515),(8368,2516),(8369,2517),(8370,2518),(8371,2519),(8372,2520),(8373,2521),(8374,2522),(8375,2523),(8376,2524),(8377,2525),(8378,2526),(8379,2527),(8380,2528),(8381,2529),(8382,2530),(8383,2531),(8384,2532),(8385,2533),(8386,2534),(8387,2535),(8388,2536),(8389,2537),(8390,2538),(8391,2539),(8392,2540),(8393,2541),(8394,2542),(8395,2543),(8396,2544),(8397,2545),(8398,2546),(8399,2547),(8400,2548),(8401,2549),(8402,2550),(8403,2551),(8404,2552),(8405,2553),(8406,2554),(8407,2555),(8408,2556),(8409,2557),(8410,2558),(8411,2559),(8412,2560),(8413,2561),(8414,2562),(8415,2563),(8416,2564),(8417,2565),(8418,2566),(8419,2567),(8420,2568),(8421,2569),(8422,2570),(8423,2571),(8424,2572),(8425,2573),(8426,2574),(8427,2575),(8428,2576),(8429,2577),(8430,2578),(8431,2579),(8432,2580),(8433,2581),(8434,2582),(8435,2583),(8436,2584),(8437,2585),(8438,2586),(8439,2587),(8440,2588),(8441,2589),(8442,2590),(8443,2591),(8444,2592),(8445,2593),(8446,2594),(8447,2595),(8448,2596),(8449,2597),(8450,2598),(8451,2599),(8452,2600),(8453,2601),(8454,2602),(8455,2603),(8456,2604),(8457,2605),(8458,2606),(8459,2607),(8460,2608),(8461,2609),(8462,2610),(8463,2611),(8464,2612),(8465,2613),(8466,2614),(8467,2615),(8468,2616),(8469,2617),(8470,2618),(8471,2619),(8472,2620),(8473,2621),(8474,2622),(8475,2623),(8476,2624),(8477,2625),(8478,2626),(8479,2627),(8480,2628),(8481,2629),(8482,2630),(8483,2631),(8484,2632),(8485,2633),(8486,2634),(8487,2635),(8488,2636),(8489,2637),(8490,2638),(8491,2639),(8492,2640),(8493,2641),(8494,2642),(8495,2643),(8496,2644),(8497,2645),(8498,2646),(8499,2647),(8500,2648),(8501,2649),(8502,2650),(8503,2651),(8504,2652),(8505,2653),(8506,2654),(8507,2655),(8508,2656),(8509,2657),(8510,2658),(8511,2659),(8512,2660),(8513,2661),(8514,2662),(8515,2663),(8516,2664),(8517,2665),(8518,2666),(8519,2667),(8520,2668),(8521,2669),(8522,2670),(8523,2671),(8524,2672),(8525,2673),(8526,2674),(8527,2675),(8528,2676),(8529,2677),(8530,2678),(8531,2679),(8532,2680),(8533,2681),(8534,2682),(8535,2683),(8536,2684),(8537,2685),(8538,2686),(8539,2687),(8540,2688),(8541,2689),(8542,2690),(8543,2691),(8544,2692),(8545,2693),(8546,2694),(8547,2695),(8548,2696),(8549,2697),(8550,2698),(8551,2699),(8552,2700),(8553,2701),(8554,2702),(8555,2703),(8556,2704),(8557,2705),(8558,2706),(8559,2707),(8560,2708),(8561,2709),(8562,2710),(8563,2711),(8564,2712),(8565,2713),(8566,2714),(8567,2715),(8568,2716),(8569,2717),(8570,2718),(8571,2719),(8572,2720),(8573,2721),(8574,2722),(8575,2723),(8576,2724),(8577,2725),(8578,2726),(8579,2727),(8580,2728),(8581,2729),(8582,2730),(8583,2731),(8584,2732),(8585,2733),(8586,2734),(8587,2735),(8588,2736),(8589,2737),(8590,2738),(8591,2739),(8592,2740),(8593,2741),(8594,2742),(8595,2743),(8596,2744),(8597,2745),(8598,2746),(8599,2747),(8600,2748),(8601,2749),(8602,2750),(8603,2751),(8604,2752),(8605,2753),(8606,2754),(8607,2755),(8608,2756),(8609,2757),(8610,2758),(8611,2759),(8612,2760),(8613,2761),(8614,2762),(8615,2763),(8616,2764),(8617,2765),(8618,2766),(8619,2767),(8620,2768),(8621,2769),(8622,2770),(8623,2771),(8624,2772),(8625,2773),(8626,2774),(8627,2775),(8628,2776),(8629,2777),(8630,2778),(8631,2779),(8632,2780),(8633,2781),(8634,2782),(8635,2783),(8636,2784),(8637,2785),(8638,2786),(8639,2787),(8640,2788),(8641,2789),(8642,2790),(8643,2791),(8644,2792),(8645,2793),(8646,2794),(8647,2795),(8648,2796),(8649,2797),(8650,2798),(8651,2799),(8652,2800),(8653,2801),(8654,2802),(8655,2803),(8656,2804),(8657,2805),(8658,2806),(8659,2807),(8660,2808),(8661,2809),(8662,2810),(8663,2811),(8664,2812),(8665,2813),(8666,2814),(8667,2815),(8668,2816),(8669,2817),(8670,2818),(8671,2819),(8672,2820),(8673,2821),(8674,2822),(8675,2823),(8676,2824),(8677,2825),(8678,2826),(8679,2827),(8680,2828),(8681,2829),(8682,2830),(8683,2831),(8684,2832),(8685,2833),(8686,2834),(8687,2835),(8688,2836),(8689,2837),(8690,2838),(8691,2839),(8692,2840),(8693,2841),(8694,2842),(8695,2843),(8696,2844),(8697,2845),(8698,2846),(8699,2847),(8700,2848),(8701,2849),(8702,2850),(8703,2851),(8704,2852),(8705,2853),(8706,2854),(8707,2855),(8708,2856),(8709,2857),(8710,2858),(8711,2859),(8712,2860),(8713,2861),(8714,2862),(8715,2863),(8716,2864),(8717,2865),(8718,2866),(8719,2867),(8720,2868),(8721,2869),(8722,2870),(8723,2871),(8724,2872),(8725,2873),(8726,2874),(8727,2875),(8728,2876),(8729,2877),(8730,2878),(8731,2879),(8732,2880),(8733,2881),(8734,2882),(8735,2883),(8736,2884),(8737,2885),(8738,2886),(8739,2887),(8740,2888),(8741,2889),(8742,2890),(8743,2891),(8744,2892),(8745,2893),(8746,2894),(8747,2895),(8748,2896),(8749,2897),(8750,2898),(8751,2899),(8752,2900),(8753,2901),(8754,2902),(8755,2903),(8756,2904),(8757,2905),(8758,2906),(8759,2907),(8760,2908),(8761,2909),(8762,2910),(8763,2911),(8764,2912),(8765,2913),(8766,2914),(8767,2915),(8768,2916),(8769,2917),(8770,2918),(8771,2919),(8772,2920),(8773,2921),(8774,2922),(8775,2923),(8776,2924),(8777,2925),(8778,2926),(8779,2927),(8780,2928),(8781,2929),(8782,2930),(8783,2931),(8784,2932),(8785,2933),(8786,2934),(8787,2935),(8788,2936),(8789,2937),(8790,2938),(8791,2939),(8792,2940),(8793,2941),(8794,2942),(8795,2943),(8796,2944),(8797,2945),(8798,2946),(8799,2947),(8800,2948),(8801,2949),(8802,2950),(8803,2951),(8804,2952),(8805,2953),(8806,2954),(8807,2955),(8808,2956),(8809,2957),(8810,2958),(8811,2959),(8812,2960),(8813,2961),(8814,2962),(8815,2963),(8816,2964),(8817,2965),(8818,2966),(8819,2967),(8820,2968),(8821,2969),(8822,2970),(8823,2971),(8824,2972),(8825,2973),(8826,2974),(8827,2975),(8828,2976),(8829,2977),(8830,2978),(8831,2979),(8832,2980),(8833,2981),(8834,2982),(8835,2983),(8836,2984),(8837,2985),(8838,2986),(8839,2987),(8840,2988),(8841,2989),(8842,2990),(8843,2991),(8844,2992),(8845,2993),(8846,2994),(8847,2995),(8848,2996),(8849,2997),(8850,2998),(8851,2999),(8852,3000),(8853,3001),(8854,3002),(8855,3003),(8856,3004),(8857,3005),(8858,3006),(8859,3007),(8860,3008),(8861,3009),(8862,3010),(8863,3011),(8864,3012),(8865,3013),(8866,3014),(8867,3015),(8868,3016),(8869,3017),(8870,3018),(8871,3019),(8872,3020),(8873,3021),(8874,3022),(8875,3023),(8876,3024),(8877,3025),(8878,3026),(8879,3027),(8880,3028),(8881,3029),(8882,3030),(8883,3031),(8884,3032),(8885,3033),(8886,3034),(8887,3035),(8888,3036),(8889,3037),(8890,3038),(8891,3039),(8892,3040),(8893,3041),(8894,3042),(8895,3043),(8896,3044),(8897,3045),(8898,3046),(8899,3047),(8900,3048),(8901,3049),(8902,3050),(8903,3051),(8904,3052),(8905,3053),(8906,3054),(8907,3055),(8908,3056),(8909,3057),(8910,3058),(8911,3059),(8912,3060),(8913,3061),(8914,3062),(8915,3063),(8916,3064),(8917,3065),(8918,3066),(8919,3067),(8920,3068),(8921,3069),(8922,3070),(8923,3071),(8924,3072),(8925,3073),(8926,3074),(8927,3075),(8928,3076),(8929,3077),(8930,3078),(8931,3079),(8932,3080),(8933,3081),(8934,3082),(8935,3083),(8936,3084),(8937,3085),(8938,3086),(8939,3087),(8940,3088),(8941,3089),(8942,3090),(8943,3091),(8944,3092),(8945,3093),(8946,3094),(8947,3095),(8948,3096),(8949,3097),(8950,3098),(8951,3099),(8952,3100),(8953,3101),(8954,3102),(8955,3103),(8956,3104),(8957,3105),(8958,3106),(8959,3107),(8960,3108),(8961,3109),(8962,3110),(8963,3111),(8964,3112),(8965,3113),(8966,3114),(8967,3115),(8968,3116),(8969,3117),(8970,3118),(8971,3119),(8972,3120),(8973,3121),(8974,3122),(8975,3123),(8976,3124),(8977,3125),(8978,3126),(8979,3127),(8980,3128),(8981,3129),(8982,3130),(8983,3131),(8984,3132),(8985,3133),(8986,3134),(8987,3135),(8988,3136),(8989,3137),(8990,3138),(8991,3139),(8992,3140),(8993,3141),(8994,3142),(8995,3143),(8996,3144),(8997,3145),(8998,3146),(8999,3147),(9000,3148),(9001,3149),(9002,3150),(9003,3151),(9004,3152),(9005,3153),(9006,3154),(9007,3155),(9008,3156),(9009,3157),(9010,3158),(9011,3159),(9012,3160),(9013,3161),(9014,3162),(9015,3163),(9016,3164),(9017,3165),(9018,3166),(9019,3167),(9020,3168),(9021,3169),(9022,3170),(9023,3171),(9024,3172),(9025,3173),(9026,3174),(9027,3175),(9028,3176),(9029,3177),(9030,3178),(9031,3179),(9032,3180),(9033,3181),(9034,3182),(9035,3183),(9036,3184),(9037,3185),(9038,3186),(9039,3187),(9040,3188),(9041,3189),(9042,3190),(9043,3191),(9044,3192),(9045,3193),(9046,3194),(9047,3195),(9048,3196),(9049,3197),(9050,3198),(9051,3199),(9052,3200),(9053,3201),(9054,3202),(9055,3203),(9056,3204),(9057,3205),(9058,3206),(9059,3207),(9060,3208),(9061,3209),(9062,3210),(9063,3211),(9064,3212),(9065,3213),(9066,3214),(9067,3215),(9068,3216),(9069,3217),(9070,3218),(9071,3219),(9072,3220),(9073,3221),(9074,3222),(9075,3223),(9076,3224),(9077,3225),(9078,3226),(9079,3227),(9080,3228),(9081,3229),(9082,3230),(9083,3231),(9084,3232),(9085,3233),(9086,3234),(9087,3235),(9088,3236),(9089,3237),(9090,3238),(9091,3239),(9092,3240),(9093,3241),(9094,3242),(9095,3243),(9096,3244),(9097,3245),(9098,3246),(9099,3247),(9100,3248),(9101,3249),(9102,3250),(9103,3251),(9104,3252),(9105,3253),(9106,3254),(9107,3255),(9108,3256),(9109,3257),(9110,3258),(9111,3259),(9112,3260),(9113,3261),(9114,3262),(9115,3263),(9116,3264),(9117,3265),(9118,3266),(9119,3267),(9120,3268),(9121,3269),(9122,3270),(9123,3271),(9124,3272),(9125,3273),(9126,3274),(9127,3275),(9128,3276),(9129,3277),(9130,3278),(9131,3279),(9132,3280),(9133,3281),(9134,3282),(9135,3283),(9136,3284),(9137,3285),(9138,3286),(9139,3287),(9140,3288),(9141,3289),(9142,3290),(9143,3291),(9144,3292),(9145,3293),(9146,3294),(9147,3295),(9148,3296),(9149,3297),(9150,3298),(9151,3299),(9152,3300),(9153,3301),(9154,3302),(9155,3303),(9156,3304),(9157,3305),(9158,3306),(9159,3307),(9160,3308),(9161,3309),(9162,3310),(9163,3311),(9164,3312),(9165,3313),(9166,3314),(9167,3315),(9168,3316),(9169,3317),(9170,3318),(9171,3319),(9172,3320),(9173,3321),(9174,3322),(9175,3323),(9176,3324),(9177,3325),(9178,3326),(9179,3327),(9180,3328),(9181,3329),(9182,3330),(9183,3331),(9184,3332),(9185,3333),(9186,3334),(9187,3335),(9188,3336),(9189,3337),(9190,3338),(9191,3339),(9192,3340),(9193,3341),(9194,3342),(9195,3343),(9196,3344),(9197,3345),(9198,3346),(9199,3347),(9200,3348),(9201,3349),(9202,3350),(9203,3351),(9204,3352),(9205,3353),(9206,3354),(9207,3355),(9208,3356),(9209,3357),(9210,3358),(9211,3359),(9212,3360),(9213,3361),(9214,3362),(9215,3363),(9216,3364),(9217,3365),(9218,3366),(9219,3367),(9220,3368),(9221,3369),(9222,3370),(9223,3371),(9224,3372),(9225,3373),(9226,3374),(9227,3375),(9228,3376),(9229,3377),(9230,3378),(9231,3379),(9232,3380),(9233,3381),(9234,3382),(9235,3383),(9236,3384),(9237,3385),(9238,3386),(9239,3387),(9240,3388),(9241,3389),(9242,3390),(9243,3391),(9244,3392),(9245,3393),(9246,3394),(9247,3395),(9248,3396),(9249,3397),(9250,3398),(9251,3399),(9252,3400),(9253,3401),(9254,3402),(9255,3403),(9256,3404),(9257,3405),(9258,3406),(9259,3407),(9260,3408),(9261,3409),(9262,3410),(9263,3411),(9264,3412),(9265,3413),(9266,3414),(9267,3415),(9268,3416),(9269,3417),(9270,3418),(9271,3419),(9272,3420),(9273,3421),(9274,3422),(9275,3423),(9276,3424),(9277,3425),(9278,3426),(9279,3427),(9280,3428),(9281,3429),(9282,3430),(9283,3431),(9284,3432),(9285,3433),(9286,3434),(9287,3435),(9288,3436),(9289,3437),(9290,3438),(9291,3439),(9292,3440),(9293,3441),(9294,3442),(9295,3443),(9296,3444),(9297,3445),(9298,3446),(9299,3447),(9300,3448),(9301,3449),(9302,3450),(9303,3451),(9304,3452),(9305,3453),(9306,3454),(9307,3455),(9308,3456),(9309,3457),(9310,3458),(9311,3459),(9312,3460),(9313,3461),(9314,3462),(9315,3463),(9316,3464),(9317,3465),(9318,3466),(9319,3467),(9320,3468),(9321,3469),(9322,3470),(9323,3471),(9324,3472),(9325,3473),(9326,3474),(9327,3475),(9328,3476),(9329,3477),(9330,3478),(9331,3479),(9332,3480),(9333,3481),(9334,3482),(9335,3483),(9336,3484),(9337,3485),(9338,3486),(9339,3487),(9340,3488),(9341,3489),(9342,3490),(9343,3491),(9344,3492),(9345,3493),(9346,3494),(9347,3495),(9348,3496),(9349,3497),(9350,3498),(9351,3499),(9352,3500),(9353,3501),(9354,3502),(9355,3503),(9356,3504),(9357,3505),(9358,3506),(9359,3507),(9360,3508),(9361,3509),(9362,3510),(9363,3511),(9364,3512),(9365,3513),(9366,3514),(9367,3515),(9368,3516),(9369,3517),(9370,3518),(9371,3519),(9372,3520),(9373,3521),(9374,3522),(9375,3523),(9376,3524),(9377,3525),(9378,3526),(9379,3527),(9380,3528),(9381,3529),(9382,3530),(9383,3531),(9384,3532),(9385,3533),(9386,3534),(9387,3535),(9388,3536),(9389,3537),(9390,3538),(9391,3539),(9392,3540),(9393,3541),(9394,3542),(9395,3543),(9396,3544),(9397,3545),(9398,3546),(9399,3547),(9400,3548),(9401,3549),(9402,3550),(9403,3551),(9404,3552),(9405,3553),(9406,3554),(9407,3555),(9408,3556),(9409,3557),(9410,3558),(9411,3559),(9412,3560),(9413,3561),(9414,3562),(9415,3563),(9416,3564),(9417,3565),(9418,3566),(9419,3567),(9420,3568),(9421,3569),(9422,3570),(9423,3571),(9424,3572),(9425,3573),(9426,3574),(9427,3575),(9428,3576),(9429,3577),(9430,3578),(9431,3579),(9432,3580),(9433,3581),(9434,3582),(9435,3583),(9436,3584),(9437,3585),(9438,3586),(9439,3587),(9440,3588),(9441,3589),(9442,3590),(9443,3591),(9444,3592),(9445,3593),(9446,3594),(9447,3595),(9448,3596),(9449,3597),(9450,3598),(9451,3599),(9452,3600),(9453,3601),(9454,3602),(9455,3603),(9456,3604),(9457,3605),(9458,3606),(9459,3607),(9460,3608),(9461,3609),(9462,3610),(9463,3611),(9464,3612),(9465,3613),(9466,3614),(9467,3615),(9468,3616),(9469,3617),(9470,3618),(9471,3619),(9472,3620),(9473,3621),(9474,3622),(9475,3623),(9476,3624),(9477,3625),(9478,3626),(9479,3627),(9480,3628),(9481,3629),(9482,3630),(9483,3631),(9484,3632),(9485,3633),(9486,3634),(9487,3635),(9488,3636),(9489,3637),(9490,3638),(9491,3639),(9492,3640),(9493,3641),(9494,3642),(9495,3643),(9496,3644),(9497,3645),(9498,3646),(9499,3647),(9500,3648),(9501,3649),(9502,3650),(9503,3651),(9504,3652),(9505,3653),(9506,3654),(9507,3655),(9508,3656),(9509,3657),(9510,3658),(9511,3659),(9512,3660),(9513,3661),(9514,3662),(9515,3663),(9516,3664),(9517,3665),(9518,3666),(9519,3667),(9520,3668),(9521,3669),(9522,3670),(9523,3671),(9524,3672),(9525,3673),(9526,3674),(9527,3675),(9528,3676),(9529,3677),(9530,3678),(9531,3679),(9532,3680),(9533,3681),(9534,3682),(9535,3683),(9536,3684),(9537,3685),(9538,3686),(9539,3687),(9540,3688),(9541,3689),(9542,3690),(9543,3691),(9544,3692),(9545,3693),(9546,3694),(9547,3695),(9548,3696),(9549,3697),(9550,3698),(9551,3699),(9552,3700),(9553,3701),(9554,3702),(9555,3703),(9556,3704),(9557,3705),(9558,3706),(9559,3707),(9560,3708),(9561,3709),(9562,3710),(9563,3711),(9564,3712),(9565,3713),(9566,3714),(9567,3715),(9568,3716),(9569,3717),(9570,3718),(9571,3719),(9572,3720),(9573,3721),(9574,3722),(9575,3723),(9576,3724),(9577,3725),(9578,3726),(9579,3727),(9580,3728),(9581,3729),(9582,3730),(9583,3731),(9584,3732),(9585,3733),(9586,3734),(9587,3735),(9588,3736),(9589,3737),(9590,3738),(9591,3739),(9592,3740),(9593,3741),(9594,3742),(9595,3743),(9596,3744),(9597,3745),(9598,3746),(9599,3747),(9600,3748),(9601,3749),(9602,3750),(9603,3751),(9604,3752),(9605,3753),(9606,3754),(9607,3755),(9608,3756),(9609,3757),(9610,3758),(9611,3759),(9612,3760),(9613,3761),(9614,3762),(9615,3763),(9616,3764),(9617,3765),(9618,3766),(9619,3767),(9620,3768),(9621,3769),(9622,3770),(9623,3771),(9624,3772),(9625,3773),(9626,3774),(9627,3775),(9628,3776),(9629,3777),(9630,3778),(9631,3779),(9632,3780),(9633,3781),(9634,3782),(9635,3783),(9636,3784),(9637,3785),(9638,3786),(9639,3787),(9640,3788),(9641,3789),(9642,3790),(9643,3791),(9644,3792),(9645,3793),(9646,3794),(9647,3795),(9648,3796),(9649,3797),(9650,3798),(9651,3799),(9652,3800),(9653,3801),(9654,3802),(9655,3803),(9656,3804),(9657,3805),(9658,3806),(9659,3807),(9660,3808),(9661,3809),(9662,3810),(9663,3811),(9664,3812),(9665,3813),(9666,3814),(9667,3815),(9668,3816),(9669,3817),(9670,3818),(9671,3819),(9672,3820),(9673,3821),(9674,3822),(9675,3823),(9676,3824),(9677,3825),(9678,3826),(9679,3827),(9680,3828),(9681,3829),(9682,3830),(9683,3831),(9684,3832),(9685,3833),(9686,3834),(9687,3835),(9688,3836),(9689,3837),(9690,3838),(9691,3839),(9692,3840),(9693,3841),(9694,3842),(9695,3843),(9696,3844),(9697,3845),(9698,3846),(9699,3847),(9700,3848),(9701,3849),(9702,3850),(9703,3851),(9704,3852),(9705,3853),(9706,3854),(9707,3855),(9708,3856),(9709,3857),(9710,3858),(9711,3859),(9712,3860),(9713,3861),(9714,3862),(9715,3863),(9716,3864),(9717,3865),(9718,3866),(9719,3867),(9720,3868),(9721,3869),(9722,3870),(9723,3871),(9724,3872),(9725,3873),(9726,3874),(9727,3875),(9728,3876),(9729,3877),(9730,3878),(9731,3879),(9732,3880),(9733,3881),(9734,3882),(9735,3883),(9736,3884),(9737,3885),(9738,3886),(9739,3887),(9740,3888),(9741,3889),(9742,3890),(9743,3891),(9744,3892),(9745,3893),(9746,3894),(9747,3895),(9748,3896),(9749,3897),(9750,3898),(9751,3899),(9752,3900),(9753,3901),(9754,3902),(9755,3903),(9756,3904),(9757,3905),(9758,3906),(9759,3907),(9760,3908),(9761,3909),(9762,3910),(9763,3911),(9764,3912),(9765,3913),(9766,3914),(9767,3915),(9768,3916),(9769,3917),(9770,3918),(9771,3919),(9772,3920),(9773,3921),(9774,3922),(9775,3923),(9776,3924),(9777,3925),(9778,3926),(9779,3927),(9780,3928),(9781,3929),(9782,3930),(9783,3931),(9784,3932),(9785,3933),(9786,3934),(9787,3935),(9788,3936),(9789,3937),(9790,3938),(9791,3939),(9792,3940),(9793,3941),(9794,3942),(9795,3943),(9796,3944),(9797,3945),(9798,3946),(9799,3947),(9800,3948),(9801,3949),(9802,3950),(9803,3951),(9804,3952),(9805,3953),(9806,3954),(9807,3955),(9808,3956),(9809,3957),(9810,3958),(9811,3959),(9812,3960),(9813,3961),(9814,3962),(9815,3963),(9816,3964),(9817,3965),(9818,3966),(9819,3967),(9820,3968),(9821,3969),(9822,3970),(9823,3971),(9824,3972),(9825,3973),(9826,3974),(9827,3975),(9828,3976),(9829,3977),(9830,3978),(9831,3979),(9832,3980),(9833,3981),(9834,3982),(9835,3983),(9836,3984),(9837,3985),(9838,3986),(9839,3987),(9840,3988),(9841,3989),(9842,3990),(9843,3991),(9844,3992),(9845,3993),(9846,3994),(9847,3995),(9848,3996),(9849,3997),(9850,3998),(9851,3999),(9852,4000),(9853,4001),(9854,4002),(9855,4003),(9856,4004),(9857,4005),(9858,4006),(9859,4007),(9860,4008),(9861,4009),(9862,4010),(9863,4011),(9864,4012),(9865,4013),(9866,4014),(9867,4015),(9868,4016),(9869,4017),(9870,4018),(9871,4019),(9872,4020),(9873,4021),(9874,4022),(9875,4023),(9876,4024),(9877,4025),(9878,4026),(9879,4027),(9880,4028),(9881,4029),(9882,4030),(9883,4031),(9884,4032),(9885,4033),(9886,4034),(9887,4035),(9888,4036),(9889,4037),(9890,4038),(9891,4039),(9892,4040),(9893,4041),(9894,4042),(9895,4043),(9896,4044),(9897,4045),(9898,4046),(9899,4047),(9900,4048),(9901,4049),(9902,4050),(9903,4051),(9904,4052),(9905,4053),(9906,4054),(9907,4055),(9908,4056),(9909,4057),(9910,4058),(9911,4059),(9912,4060),(9913,4061),(9914,4062),(9915,4063),(9916,4064),(9917,4065),(9918,4066),(9919,4067),(9920,4068),(9921,4069),(9922,4070),(9923,4071),(9924,4072),(9925,4073),(9926,4074),(9927,4075),(9928,4076),(9929,4077),(9930,4078),(9931,4079),(9932,4080),(9933,4081),(9934,4082),(9935,4083),(9936,4084),(9937,4085),(9938,4086),(9939,4087),(9940,4088),(9941,4089),(9942,4090),(9943,4091),(9944,4092),(9945,4093),(9946,4094),(9947,4095),(9948,4096),(9949,4097),(9950,4098),(9951,4099),(9952,4100),(9953,4101),(9954,4102),(9955,4103),(9956,4104),(9957,4105),(9958,4106),(9959,4107),(9960,4108),(9961,4109),(9962,4110),(9963,4111),(9964,4112),(9965,4113),(9966,4114),(9967,4115),(9968,4116),(9969,4117),(9970,4118),(9971,4119),(9972,4120),(9973,4121),(9974,4122),(9975,4123),(9976,4124),(9977,4125),(9978,4126),(9979,4127),(9980,4128),(9981,4129),(9982,4130),(9983,4131),(9984,4132),(9985,4133),(9986,4134),(9987,4135),(9988,4136),(9989,4137),(9990,4138),(9991,4139),(9992,4140),(9993,4141),(9994,4142),(9995,4143),(9996,4144),(9997,4145),(9998,4146),(9999,4147),(10000,4148),(10001,4149),(10002,4150),(10003,4151),(10004,4152),(10005,4153),(10006,4154),(10007,4155),(10008,4156),(10009,4157),(10010,4158),(10011,4159),(10012,4160),(10013,4161),(10014,4162),(10015,4163),(10016,4164),(10017,4165),(10018,4166),(10019,4167),(10020,4168),(10021,4169),(10022,4170),(10023,4171),(10024,4172),(10025,4173),(10026,4174),(10027,4175),(10028,4176),(10029,4177),(10030,4178),(10031,4179),(10032,4180),(10033,4181),(10034,4182),(10035,4183),(10036,4184),(10037,4185),(10038,4186),(10039,4187),(10040,4188),(10041,4189),(10042,4190),(10043,4191),(10044,4192),(10045,4193),(10046,4194),(10047,4195),(10048,4196),(10049,4197),(10050,4198),(10051,4199),(10052,4200),(10053,4201),(10054,4202),(10055,4203),(10056,4204),(10057,4205),(10058,4206),(10059,4207),(10060,4208),(10061,4209),(10062,4210),(10063,4211),(10064,4212),(10065,4213),(10066,4214),(10067,4215),(10068,4216),(10069,4217),(10070,4218),(10071,4219),(10072,4220),(10073,4221),(10074,4222),(10075,4223),(10076,4224),(10077,4225),(10078,4226),(10079,4227),(10080,4228),(10081,4229),(10082,4230),(10083,4231),(10084,4232),(10085,4233),(10086,4234),(10087,4235),(10088,4236),(10089,4237),(10090,4238),(10091,4239),(10092,4240),(10093,4241),(10094,4242),(10095,4243),(10096,4244),(10097,4245),(10098,4246),(10099,4247),(10100,4248),(10101,4249),(10102,4250),(10103,4251),(10104,4252),(10105,4253),(10106,4254),(10107,4255),(10108,4256),(10109,4257),(10110,4258),(10111,4259),(10112,4260),(10113,4261),(10114,4262),(10115,4263),(10116,4264),(10117,4265),(10118,4266),(10119,4267),(10120,4268),(10121,4269),(10122,4270),(10123,4271),(10124,4272),(10125,4273),(10126,4274),(10127,4275),(10128,4276),(10129,4277),(10130,4278),(10131,4279),(10132,4280),(10133,4281),(10134,4282),(10135,4283),(10136,4284),(10137,4285),(10138,4286),(10139,4287),(10140,4288),(10141,4289),(10142,4290),(10143,4291),(10144,4292),(10145,4293),(10146,4294),(10147,4295),(10148,4296),(10149,4297),(10150,4298),(10151,4299),(10152,4300),(10153,4301),(10154,4302),(10155,4303),(10156,4304),(10157,4305),(10158,4306),(10159,4307),(10160,4308),(10161,4309),(10162,4310),(10163,4311),(10164,4312),(10165,4313),(10166,4314),(10167,4315),(10168,4316),(10169,4317),(10170,4318),(10171,4319),(10172,4320),(10173,4321),(10174,4322),(10175,4323),(10176,4324),(10177,4325),(10178,4326),(10179,4327),(10180,4328),(10181,4329),(10182,4330),(10183,4331),(10184,4332),(10185,4333),(10186,4334),(10187,4335),(10188,4336),(10189,4337),(10190,4338),(10191,4339),(10192,4340),(10193,4341),(10194,4342),(10195,4343),(10196,4344),(10197,4345),(10198,4346),(10199,4347),(10200,4348),(10201,4349),(10202,4350),(10203,4351),(10204,4352),(10205,4353),(10206,4354),(10207,4355),(10208,4356),(10209,4357),(10210,4358),(10211,4359),(10212,4360),(10213,4361),(10214,4362),(10215,4363),(10216,4364),(10217,4365),(10218,4366),(10219,4367),(10220,4368),(10221,4369),(10222,4370),(10223,4371),(10224,4372),(10225,4373),(10226,4374),(10227,4375),(10228,4376),(10229,4377),(10230,4378),(10231,4379),(10232,4380),(10233,4381),(10234,4382),(10235,4383),(10236,4384),(10237,4385),(10238,4386),(10239,4387),(10240,4388),(10241,4389),(10242,4390),(10243,4391),(10244,4392),(10245,4393),(10246,4394),(10247,4395),(10248,4396),(10249,4397),(10250,4398),(10251,4399),(10252,4400),(10253,4401),(10254,4402),(10255,4403),(10256,4404),(10257,4405),(10258,4406),(10259,4407),(10260,4408),(10261,4409),(10262,4410),(10263,4411),(10264,4412),(10265,4413),(10266,4414),(10267,4415),(10268,4416),(10269,4417),(10270,4418),(10271,4419),(10272,4420),(10273,4421),(10274,4422),(10275,4423),(10276,4424),(10277,4425),(10278,5764),(10279,5765),(10280,5766),(10281,5767),(10282,5768),(10283,5769),(10284,5770),(10285,5771),(10286,5772),(10287,5773),(10288,5774),(10289,5775),(10290,5776),(10291,5777),(10292,5778),(10293,5779),(10294,5780),(10295,5781),(10296,5782),(10297,5783),(10298,5784),(10299,5785),(10300,5786),(10301,5787),(10302,5788),(10303,5789),(10304,5790),(10305,5791),(10306,5792),(10307,5793),(10308,5794),(10309,5795),(10310,5796),(10311,5797),(10312,5798),(10313,5799),(10314,5800),(10315,5801),(10316,5802),(10317,5803),(10318,5804),(10319,5805),(10320,5806),(10321,5807),(10322,5808),(10323,5809),(10324,5810),(10325,5811),(10326,5812),(10327,5813),(10328,5814),(10329,5815),(10330,5816),(10331,5817),(10332,5818),(10333,5819),(10334,5820),(10335,5821),(10336,5822),(10337,5823),(10338,5824),(10339,5825),(10340,5826),(10341,5827),(10342,5828),(10343,5829),(10344,5830),(10345,5831),(10346,5832),(10347,5833),(10348,5834),(10349,5835),(10350,5836),(10351,5837),(10352,5838),(10353,5839),(10354,5840),(10355,5841),(10356,5842),(10357,5843),(10358,5844),(10359,5845),(10360,5846),(10361,5847),(10362,5848),(10363,5849),(10364,5850),(10365,5851),(10366,5852),(10367,5853),(10368,5854),(10369,5855),(10370,5856),(10371,5857),(10372,5858),(10373,5859),(10374,5860),(10375,5861),(10376,5862),(10377,5863),(10378,5864),(10379,5865),(10380,5866),(10381,5867),(10382,5868),(10383,5869),(10384,5870),(10385,5871),(10386,5872),(10387,5873),(10388,5874),(10389,5875),(10390,5876),(10391,5877),(10392,5878),(10393,5879),(10394,5880),(10395,5881),(10396,5882),(10397,5883),(10398,5884),(10399,5885),(10400,5886),(10401,5887),(10402,5888),(10403,5889),(10404,5890),(10405,5891),(10406,5892),(10407,5893),(10408,5894),(10409,5895),(10410,5896),(10411,5897),(10412,5898),(10413,5899),(10414,5900),(10415,5901),(10416,5902),(10417,5903),(10418,5904),(10419,5905),(10420,5906),(10421,5907),(10422,5908),(10423,5909),(10424,5910),(10425,5911),(10426,5912),(10427,5913),(10428,5914),(10429,5915),(10430,5916),(10431,5917),(10432,5918),(10433,5919),(10434,5920),(10435,5921),(10436,5922),(10437,5923),(10438,5924),(10439,5925),(10440,5926),(10441,5927),(10442,5928),(10443,5929),(10444,5930),(10445,5931),(10446,5932),(10447,5933),(10448,5934),(10449,5935),(10450,5936),(10451,5937),(10452,5938),(10453,5939),(10454,5940),(10455,5941),(10456,5942),(10457,5943),(10458,5944),(10459,5945),(10460,5946),(10461,5947),(10462,5948),(10463,5949),(10464,5950),(10465,5951),(10466,5952),(10467,5953),(10468,5954),(10469,5955),(10470,5956),(10471,5957),(10472,5958),(10473,5959),(10474,5960),(10475,5961),(10476,5962),(10477,5963),(10478,5964),(10479,5965),(10480,5966),(10481,5967),(10482,5968),(10483,5969),(10484,5970),(10485,5971),(10486,5972),(10487,5973),(10488,5974),(10489,5975),(10490,5976),(10491,5977),(10492,5978),(10493,5979),(10494,5980),(10495,5981),(10496,5982),(10497,5983),(10498,5984),(10499,5985),(10500,5986),(10501,5987),(10502,5988),(10503,5989),(10504,5990),(10505,5991);
/*!40000 ALTER TABLE `inventory_cl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventory_geoname`
--

DROP TABLE IF EXISTS `inventory_geoname`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `inventory_geoname` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'entity id',
  `country_code` varchar(64) NOT NULL,
  `postcode` varchar(64) NOT NULL,
  `city` varchar(180) NOT NULL,
  `region` varchar(100) NOT NULL,
  `province` varchar(64) NOT NULL,
  `latitude` double NOT NULL,
  `longitude` double NOT NULL,
  PRIMARY KEY (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventory_geoname`
--

LOCK TABLES `inventory_geoname` WRITE;
/*!40000 ALTER TABLE `inventory_geoname` DISABLE KEYS */;
/*!40000 ALTER TABLE `inventory_geoname` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventory_low_stock_notification_configuration`
--

DROP TABLE IF EXISTS `inventory_low_stock_notification_configuration`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `inventory_low_stock_notification_configuration` (
  `source_code` varchar(255) NOT NULL,
  `sku` varchar(64) NOT NULL,
  `notify_stock_qty` decimal(12,4) DEFAULT NULL,
  PRIMARY KEY (`source_code`,`sku`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventory_low_stock_notification_configuration`
--

LOCK TABLES `inventory_low_stock_notification_configuration` WRITE;
/*!40000 ALTER TABLE `inventory_low_stock_notification_configuration` DISABLE KEYS */;
INSERT INTO `inventory_low_stock_notification_configuration` VALUES ('default','122.0606.948',NULL),('default','DWQ96DM50B',NULL),('default','FMY PRO 907 FM',NULL),('default','FPJ 625 V',NULL),('default','FTLN H45 X/BK GLASS A90 FRK',NULL),('default','FTMY AH BK MATT F90',NULL),('default','FVAD A90 BK MATT',NULL),('default','FVAS A80 BK Z1',NULL),('default','SMD6EDX57G',NULL),('default','SMD6TCX00E',NULL),('default','SMD6ZCX60G',NULL),('default','SMD8YCX03G',NULL),('default','SMV6ZCX01G',NULL),('default','SPV4EMX21G',NULL),('default','test-configurable',NULL),('default','test-configurable-black',NULL),('default','test-configurable-green',NULL),('default','test-configurable-Red',NULL),('default','test-product',NULL),('default','VARCT36001AWHA',NULL),('default','Vessels Basin',NULL),('default','Zentrum Basin',NULL);
/*!40000 ALTER TABLE `inventory_low_stock_notification_configuration` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventory_order_notification`
--

DROP TABLE IF EXISTS `inventory_order_notification`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `inventory_order_notification` (
  `order_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Order ID',
  `notification_sent` smallint NOT NULL COMMENT 'Has Notification Been Sent For Order',
  `send_notification` smallint NOT NULL COMMENT 'Should Notification Be Send For Order',
  PRIMARY KEY (`order_id`),
  CONSTRAINT `INVENTORY_ORDER_NOTIFICATION_ORDER_ID_SALES_ORDER_ENTITY_ID` FOREIGN KEY (`order_id`) REFERENCES `sales_order` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventory_order_notification`
--

LOCK TABLES `inventory_order_notification` WRITE;
/*!40000 ALTER TABLE `inventory_order_notification` DISABLE KEYS */;
/*!40000 ALTER TABLE `inventory_order_notification` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventory_pickup_location_order`
--

DROP TABLE IF EXISTS `inventory_pickup_location_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `inventory_pickup_location_order` (
  `order_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Order ID',
  `pickup_location_code` varchar(255) NOT NULL COMMENT 'Pickup Location Code',
  PRIMARY KEY (`order_id`),
  CONSTRAINT `INVENTORY_PICKUP_LOCATION_ORDER_ORDER_ID_SALES_ORDER_ENTITY_ID` FOREIGN KEY (`order_id`) REFERENCES `sales_order` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventory_pickup_location_order`
--

LOCK TABLES `inventory_pickup_location_order` WRITE;
/*!40000 ALTER TABLE `inventory_pickup_location_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `inventory_pickup_location_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventory_pickup_location_quote_address`
--

DROP TABLE IF EXISTS `inventory_pickup_location_quote_address`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `inventory_pickup_location_quote_address` (
  `address_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Quote Address ID',
  `pickup_location_code` varchar(255) NOT NULL COMMENT 'Pickup Location Code',
  PRIMARY KEY (`address_id`),
  CONSTRAINT `INV_PICKUP_LOCATION_QUOTE_ADDR_ADDR_ID_QUOTE_ADDR_ADDR_ID` FOREIGN KEY (`address_id`) REFERENCES `quote_address` (`address_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventory_pickup_location_quote_address`
--

LOCK TABLES `inventory_pickup_location_quote_address` WRITE;
/*!40000 ALTER TABLE `inventory_pickup_location_quote_address` DISABLE KEYS */;
/*!40000 ALTER TABLE `inventory_pickup_location_quote_address` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventory_reservation`
--

DROP TABLE IF EXISTS `inventory_reservation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `inventory_reservation` (
  `reservation_id` int unsigned NOT NULL AUTO_INCREMENT,
  `stock_id` int unsigned NOT NULL,
  `sku` varchar(64) NOT NULL,
  `quantity` decimal(10,4) NOT NULL DEFAULT '0.0000',
  `metadata` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`reservation_id`),
  KEY `INVENTORY_RESERVATION_STOCK_ID_SKU_QUANTITY` (`stock_id`,`sku`,`quantity`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventory_reservation`
--

LOCK TABLES `inventory_reservation` WRITE;
/*!40000 ALTER TABLE `inventory_reservation` DISABLE KEYS */;
INSERT INTO `inventory_reservation` VALUES (1,1,'test-configurable',-1.0000,'{\"event_type\":\"order_placed\",\"object_type\":\"order\",\"object_id\":\"\",\"object_increment_id\":\"000000001\"}'),(2,1,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink',-1.0000,'{\"event_type\":\"order_placed\",\"object_type\":\"order\",\"object_id\":\"\",\"object_increment_id\":\"000000002\"}'),(3,1,'FVAS A80 BK Z1',-1.0000,'{\"event_type\":\"order_placed\",\"object_type\":\"order\",\"object_id\":\"\",\"object_increment_id\":\"000000003\"}'),(4,1,'FVAS A80 BK Z1',1.0000,'{\"event_type\":\"shipment_created\",\"object_type\":\"order\",\"object_id\":\"1\",\"object_increment_id\":\"000000003\"}'),(5,1,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink',-1.0000,'{\"event_type\":\"order_placed\",\"object_type\":\"order\",\"object_id\":\"\",\"object_increment_id\":\"000000004\"}'),(6,1,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink',-1.0000,'{\"event_type\":\"order_placed\",\"object_type\":\"order\",\"object_id\":\"\",\"object_increment_id\":\"000000005\"}'),(7,1,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink',-1.0000,'{\"event_type\":\"order_placed\",\"object_type\":\"order\",\"object_id\":\"\",\"object_increment_id\":\"000000005-1\"}'),(8,1,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink',1.0000,'{\"event_type\":\"order_canceled\",\"object_type\":\"order\",\"object_id\":\"3\",\"object_increment_id\":\"000000005\"}'),(9,1,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink',1.0000,'{\"event_type\":\"shipment_created\",\"object_type\":\"order\",\"object_id\":\"4\",\"object_increment_id\":\"000000005-1\"}');
/*!40000 ALTER TABLE `inventory_reservation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventory_shipment_source`
--

DROP TABLE IF EXISTS `inventory_shipment_source`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `inventory_shipment_source` (
  `shipment_id` int unsigned NOT NULL,
  `source_code` varchar(255) NOT NULL,
  PRIMARY KEY (`shipment_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventory_shipment_source`
--

LOCK TABLES `inventory_shipment_source` WRITE;
/*!40000 ALTER TABLE `inventory_shipment_source` DISABLE KEYS */;
INSERT INTO `inventory_shipment_source` VALUES (1,'default'),(2,'default');
/*!40000 ALTER TABLE `inventory_shipment_source` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventory_source`
--

DROP TABLE IF EXISTS `inventory_source`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `inventory_source` (
  `source_code` varchar(255) NOT NULL,
  `name` varchar(255) NOT NULL,
  `enabled` smallint unsigned NOT NULL DEFAULT '1',
  `description` text,
  `latitude` decimal(8,6) DEFAULT NULL,
  `longitude` decimal(9,6) DEFAULT NULL,
  `country_id` varchar(2) NOT NULL,
  `region_id` int unsigned DEFAULT NULL,
  `region` varchar(255) DEFAULT NULL,
  `city` varchar(255) DEFAULT NULL,
  `street` varchar(255) DEFAULT NULL,
  `postcode` varchar(255) NOT NULL,
  `contact_name` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `phone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `use_default_carrier_config` smallint unsigned NOT NULL DEFAULT '1',
  `is_pickup_location_active` tinyint(1) NOT NULL DEFAULT '0',
  `frontend_name` varchar(255) DEFAULT '',
  `frontend_description` text,
  PRIMARY KEY (`source_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventory_source`
--

LOCK TABLES `inventory_source` WRITE;
/*!40000 ALTER TABLE `inventory_source` DISABLE KEYS */;
INSERT INTO `inventory_source` VALUES ('default','Default Source',1,'Default Source',0.000000,0.000000,'US',NULL,NULL,NULL,NULL,'00000',NULL,NULL,NULL,NULL,1,0,'',NULL);
/*!40000 ALTER TABLE `inventory_source` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventory_source_carrier_link`
--

DROP TABLE IF EXISTS `inventory_source_carrier_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `inventory_source_carrier_link` (
  `link_id` int unsigned NOT NULL AUTO_INCREMENT,
  `source_code` varchar(255) NOT NULL,
  `carrier_code` varchar(255) NOT NULL,
  `position` smallint unsigned DEFAULT NULL,
  PRIMARY KEY (`link_id`),
  KEY `INV_SOURCE_CARRIER_LNK_SOURCE_CODE_INV_SOURCE_SOURCE_CODE` (`source_code`),
  CONSTRAINT `INV_SOURCE_CARRIER_LNK_SOURCE_CODE_INV_SOURCE_SOURCE_CODE` FOREIGN KEY (`source_code`) REFERENCES `inventory_source` (`source_code`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventory_source_carrier_link`
--

LOCK TABLES `inventory_source_carrier_link` WRITE;
/*!40000 ALTER TABLE `inventory_source_carrier_link` DISABLE KEYS */;
/*!40000 ALTER TABLE `inventory_source_carrier_link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventory_source_item`
--

DROP TABLE IF EXISTS `inventory_source_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `inventory_source_item` (
  `source_item_id` int unsigned NOT NULL AUTO_INCREMENT,
  `source_code` varchar(255) NOT NULL,
  `sku` varchar(64) NOT NULL,
  `quantity` decimal(12,4) NOT NULL DEFAULT '0.0000',
  `status` smallint unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`source_item_id`),
  UNIQUE KEY `INVENTORY_SOURCE_ITEM_SOURCE_CODE_SKU` (`source_code`,`sku`),
  KEY `INVENTORY_SOURCE_ITEM_SKU_SOURCE_CODE_QUANTITY` (`sku`,`source_code`,`quantity`),
  CONSTRAINT `INVENTORY_SOURCE_ITEM_SOURCE_CODE_INVENTORY_SOURCE_SOURCE_CODE` FOREIGN KEY (`source_code`) REFERENCES `inventory_source` (`source_code`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=5992 DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventory_source_item`
--

LOCK TABLES `inventory_source_item` WRITE;
/*!40000 ALTER TABLE `inventory_source_item` DISABLE KEYS */;
INSERT INTO `inventory_source_item` VALUES (1119,'default','THAMES CH',100.0000,1),(4426,'default','Trisore 100',500.0000,1),(4427,'default','Trisore 140',500.0000,1),(4428,'default','Tuva',1.0000,1),(4429,'default','Tyrell',1.0000,1),(4430,'default','Tyrus 22',500.0000,1),(4431,'default','TYRUS-16',499.0000,1),(4432,'default','UK795870',499.0000,1),(4433,'default','UK796107',499.0000,1),(4434,'default','V-1V-87h',500.0000,1),(4435,'default','V-2L-68h',500.0000,1),(4436,'default','V-2L-80h V-2R-80h',500.0000,1),(4437,'default','Valor Excelsior S/E Slimline',500.0000,1),(4438,'default','Valor Homeflame Dream HE',494.0000,1),(4439,'default','Valor Trueflame',498.0000,1),(4440,'default','Valter',1.0000,1),(4441,'default','Varia 1V H2O',500.0000,1),(4442,'default','Varia 1V H2O XL',500.0000,1),(4443,'default','Varia 1V H2O XXL',500.0000,1),(4444,'default','Varia 1V-100h',500.0000,1),(4445,'default','Varia 1Vh H2O XXL',500.0000,1),(4446,'default','Varia 2L-100h Varia 2R-100h',500.0000,1),(4447,'default','Varia 2L-55h Varia 2R-55h',500.0000,1),(4448,'default','Varia 2L-80h Varia 2R-80h',500.0000,1),(4449,'default','Varia 2Lh Varia 2Rh',500.0000,1),(4450,'default','Varia A-FDh',500.0000,1),(4451,'default','Varia AS-2',500.0000,1),(4452,'default','Varia AS-3RLh',499.0000,1),(4453,'default','Varia AS-FDh-2',500.0000,1),(4454,'default','Varia B-120h',500.0000,1),(4455,'default','Varia B-FDh',500.0000,1),(4456,'default','Varia Sh',500.0000,1),(4457,'default','VERADA',499.0000,1),(4458,'default','Vidar Triple EA',500.0000,1),(4459,'default','Vidar Wall EA',500.0000,1),(4460,'default','Vision Electric',500.0000,1),(4461,'default','Vision Medium Gas Stove',500.0000,1),(4462,'default','Vision Midi Gas Stove',500.0000,1),(4463,'default','Vision Midi RF / BF',500.0000,1),(4464,'default','Vision Midi RF / CF',500.0000,1),(4465,'default','Vision Midi TF / BF',500.0000,1),(4466,'default','Vision Midi TF / CF',500.0000,1),(4467,'default','Vision Small Gas Stove',500.0000,1),(4468,'default','Vivente',500.0000,1),(4469,'default','Vogue Midi',500.0000,1),(4470,'default','Vogue Midi / BF',500.0000,1),(4471,'default','Vogue Midi BF',500.0000,1),(4472,'default','Vogue Midi CF',500.0000,1),(4473,'default','Vogue Midi Electric',500.0000,1),(4474,'default','Vogue Midi T / BF',500.0000,1),(4475,'default','Vogue Midi T / CF',500.0000,1),(4476,'default','Vogue Midi T Electric',499.0000,1),(4477,'default','Vogue Midline BF',500.0000,1),(4478,'default','Vogue Midline CF',500.0000,1),(4479,'default','Westfield',1.0000,1),(4480,'default','WLL20',493.0000,1),(4481,'default','ART 10-02',498.0000,1),(4482,'default','ART 2-01',489.0000,1),(4483,'default','ART 3-01',500.0000,1),(4484,'default','ART 4-01',493.0000,1),(4485,'default','ART 5-01',500.0000,1),(4486,'default','ART 6-01',500.0000,1),(4487,'default','ART 8-02',492.0000,1),(4488,'default','Style 3-01',493.0000,1),(4489,'default','Style 4-01',500.0000,1),(4490,'default','Style 5-01',500.0000,1),(4491,'default','111.495.00.1',100.0000,1),(4492,'default','111.543.00.1',100.0000,1),(4493,'default','111.544.00.1',100.0000,1),(4494,'default','111.545.00.1',100.0000,1),(4495,'default','111.622.00.1',100.0000,1),(4496,'default','111.623.00.1',100.0000,1),(4497,'default','111.671.00.1',100.0000,1),(4498,'default','111.676.00.1',100.0000,1),(4499,'default','111.790.00.1',100.0000,1),(4500,'default','27036',100.0000,1),(4501,'default','27037',100.0000,1),(4502,'default','27038',100.0000,1),(4503,'default','27039',100.0000,1),(4504,'default','27112',100.0000,1),(4505,'default','27113',100.0000,1),(4506,'default','27115000',100.0000,1),(4507,'default','27116000',100.0000,1),(4508,'default','27117000',100.0000,1),(4509,'default','27129',100.0000,1),(4510,'default','27133',100.0000,1),(4511,'default','27185000',100.0000,1),(4512,'default','27188000',100.0000,1),(4513,'default','27222000',100.0000,1),(4514,'default','27223000',100.0000,1),(4515,'default','27247400',100.0000,1),(4516,'default','27248400',100.0000,1),(4517,'default','27282',100.0000,1),(4518,'default','27283',100.0000,1),(4519,'default','27286',100.0000,1),(4520,'default','27288',100.0000,1),(4521,'default','27296001',100.0000,1),(4522,'default','27812400',100.0000,1),(4523,'default','27813400',100.0000,1),(4524,'default','27922000',100.0000,1),(4525,'default','27964000',100.0000,1),(4526,'default','38526000',100.0000,1),(4527,'default','38528001',100.0000,1),(4528,'default','38541000',100.0000,1),(4529,'default','38543000',100.0000,1),(4530,'default','38661000',100.0000,1),(4531,'default','38761000',100.0000,1),(4532,'default','38772001',100.0000,1),(4533,'default','38868000',100.0000,1),(4534,'default','38947000',100.0000,1),(4535,'default','39053000',100.0000,1),(4536,'default','39054000',100.0000,1),(4537,'default','458.132.00.1',100.0000,1),(4538,'default','6656S003-5336',100.0000,1),(4539,'default','851230806',100.0000,1),(4540,'default','851356',100.0000,1),(4541,'default','851357',100.0000,1),(4542,'default','851358',100.0000,1),(4543,'default','855831',100.0000,1),(4544,'default','855832',100.0000,1),(4545,'default','855833',100.0000,1),(4546,'default','855834',100.0000,1),(4547,'default','855837',100.0000,1),(4548,'default','855838',100.0000,1),(4549,'default','855839',100.0000,1),(4550,'default','855842',100.0000,1),(4551,'default','855843',100.0000,1),(4552,'default','855844',100.0000,1),(4553,'default','855847',100.0000,1),(4554,'default','855848',100.0000,1),(4555,'default','855849',100.0000,1),(4556,'default','855852806',100.0000,1),(4557,'default','855854806',100.0000,1),(4558,'default','855865',100.0000,1),(4559,'default','855866',100.0000,1),(4560,'default','855873',100.0000,1),(4561,'default','856577',100.0000,1),(4562,'default','856660',100.0000,1),(4563,'default','856746001',100.0000,1),(4564,'default','856881',100.0000,1),(4565,'default','856883',100.0000,1),(4566,'default','A3115',100.0000,1),(4567,'default','A3116',100.0000,1),(4568,'default','A3117',100.0000,1),(4569,'default','A3118',100.0000,1),(4570,'default','A3530',100.0000,1),(4571,'default','A3531',100.0000,1),(4572,'default','A3606',100.0000,1),(4573,'default','ADELE-60',100.0000,1),(4574,'default','ADELE-90',100.0000,1),(4575,'default','ALPHA-60-BLK',100.0000,1),(4576,'default','ALPHA-90-BLK',100.0000,1),(4577,'default','AM312',100.0000,1),(4578,'default','APLOMB-BLK-60',100.0000,1),(4579,'default','APLOMB-BLK-90',100.0000,1),(4580,'default','APLOMB-WH-60',100.0000,1),(4581,'default','APLOMB-WH-90',100.0000,1),(4582,'default','AQBD10',100.0000,1),(4583,'default','AQBD11',100.0000,1),(4584,'default','AQBD12',100.0000,1),(4585,'default','AQBD76',100.0000,1),(4586,'default','AQBD8',100.0000,1),(4587,'default','AQBD9',100.0000,1),(4588,'default','AQSE1',100.0000,1),(4589,'default','AQSL10',100.0000,1),(4590,'default','AQSL11',100.0000,1),(4591,'default','AQSL12',100.0000,1),(4592,'default','AQSL14',100.0000,1),(4593,'default','AQSL15',100.0000,1),(4594,'default','AQSL16',100.0000,1),(4595,'default','AQSL17',100.0000,1),(4596,'default','AQSLD14',100.0000,1),(4597,'default','AQSLD15',100.0000,1),(4598,'default','AQSLD16',100.0000,1),(4599,'default','AQSLD17',100.0000,1),(4600,'default','AQU108',100.0000,1),(4601,'default','AQU109',100.0000,1),(4602,'default','AQU128',100.0000,1),(4603,'default','AQU129',100.0000,1),(4604,'default','AQU769',100.0000,1),(4605,'default','AQUAVITAE2-50',100.0000,1),(4606,'default','AQUAVITAE2-60',100.0000,1),(4607,'default','AQUAVITAE2-90',100.0000,1),(4608,'default','AQUD2',100.0000,1),(4609,'default','ASCENT-60',100.0000,1),(4610,'default','ASCENT-80',100.0000,1),(4611,'default','ASCENT-90',100.0000,1),(4612,'default','AST',100.0000,1),(4613,'default','ATMOS 604',100.0000,1),(4614,'default','ATMOS 904',100.0000,1),(4615,'default','BOXIN-HE-120',100.0000,1),(4616,'default','BOXIN-HE-60',100.0000,1),(4617,'default','BOXIN-HE-90',100.0000,1),(4618,'default','BOXIN-LX-120',100.0000,1),(4619,'default','BOXIN-LX-60',100.0000,1),(4620,'default','BOXIN-LX-90',100.0000,1),(4621,'default','C17KS61H0',100.0000,1),(4622,'default','CONURIPAK1',100.0000,1),(4623,'default','CONURIPAK2',100.0000,1),(4624,'default','CONURIPAK3',100.0000,1),(4625,'default','CRUISE-60',100.0000,1),(4626,'default','CRUISE-90',100.0000,1),(4627,'default','CT636LES6',100.0000,1),(4628,'default','CTL636ES6',100.0000,1),(4629,'default','D46BR22N1B',100.0000,1),(4630,'default','D46ED22N1B',100.0000,1),(4631,'default','D46ML54N1B',100.0000,1),(4632,'default','D49ED22N1B',100.0000,1),(4633,'default','D49ML54N1B',100.0000,1),(4634,'default','D49PU54X1B',100.0000,1),(4635,'default','D51NAA1C0B',100.0000,1),(4636,'default','D55MH56N0B',100.0000,1),(4637,'default','D5655X1GB',100.0000,1),(4638,'default','D57MH56N0B',100.0000,1),(4639,'default','D57ML67N1B',100.0000,1),(4640,'default','D5855X1GB',100.0000,1),(4641,'default','D61MAC1X0B',100.0000,1),(4642,'default','D62BBC0N0B',100.0000,1),(4643,'default','D62PBC0N0B',100.0000,1),(4644,'default','D62QBC0N0B',100.0000,1),(4645,'default','D64ABC0N0B',100.0000,1),(4646,'default','D64BHM1N0B',100.0000,1),(4647,'default','D64GBC0N0B',100.0000,1),(4648,'default','D64MAC1X0B',100.0000,1),(4649,'default','D64QFM1N0B',100.0000,1),(4650,'default','D65BMP5N0B',100.0000,1),(4651,'default','D65IEE1S0B',100.0000,1),(4652,'default','D65IHM1S0B',100.0000,1),(4653,'default','D65IHM1S2B',100.0000,1),(4654,'default','D72PBC0N0B',100.0000,1),(4655,'default','D85IEE1S0B',100.0000,1),(4656,'default','D92BBC0N0B',100.0000,1),(4657,'default','D92PBC0N0B',100.0000,1),(4658,'default','D92QBC0N0B',100.0000,1),(4659,'default','D94ABC0N0B',100.0000,1),(4660,'default','D94AFM1N0B',100.0000,1),(4661,'default','D94BHM1N0B',100.0000,1),(4662,'default','D94GBC0N0B',100.0000,1),(4663,'default','D94QFM1N0B',100.0000,1),(4664,'default','D95BMP5N0B',100.0000,1),(4665,'default','D95FRM1S0B',100.0000,1),(4666,'default','D96BMV5N5B',100.0000,1),(4667,'default','D96IKW1S0B',100.0000,1),(4668,'default','DEM63AC00B',100.0000,1),(4669,'default','DEM66AC00B',100.0000,1),(4670,'default','DFM063W56B',100.0000,1),(4671,'default','DFS067A51B',100.0000,1),(4672,'default','DFS097A51B',100.0000,1),(4673,'default','DHL555BLGB',100.0000,1),(4674,'default','DHL575CGB',100.0000,1),(4675,'default','DHL785CGB',100.0000,1),(4676,'default','DIB98JQ50B',100.0000,1),(4677,'default','DIVA-CLASSIC',100.0000,1),(4678,'default','DIVA-HM',100.0000,1),(4679,'default','DIVA-ROCK',100.0000,1),(4680,'default','DLN53AA70B',100.0000,1),(4681,'default','DOLCE-COPPER-CH',100.0000,1),(4682,'default','DOLCE-IRON-CH',100.0000,1),(4683,'default','DOLCE-IV',100.0000,1),(4684,'default','DOLCE-PELX-CH',100.0000,1),(4685,'default','DOLCE-UMB',100.0000,1),(4686,'default','DOLCE-WH',100.0000,1),(4687,'default','DRC97AQ50B',100.0000,1),(4688,'default','DUL63CC50B',100.0000,1),(4689,'default','DWA64BC50B',100.0000,1),(4690,'default','DWA66DM50B',100.0000,1),(4691,'default','DWA94BC50B',100.0000,1),(4692,'default','DWA96DM50B',100.0000,1),(4693,'default','DWB64BC50B',100.0000,1),(4694,'default','DWB66DM50B',100.0000,1),(4695,'default','DWB68JQ50B',100.0000,1),(4696,'default','DWB94BC50B',100.0000,1),(4697,'default','DWB96DM50B',100.0000,1),(4698,'default','DWF97RV60B',100.0000,1),(4699,'default','DWG64BC50B',100.0000,1),(4700,'default','DWG94BC50B',100.0000,1),(4701,'default','DWK67CM60B',100.0000,1),(4702,'default','DWK67EM60B',100.0000,1),(4703,'default','DWK87CM60B',100.0000,1),(4704,'default','DWK87EM60B',100.0000,1),(4705,'default','DWK97JQ60B',100.0000,1),(4706,'default','DWK98PR60B',100.0000,1),(4707,'default','DWP64BC50B',100.0000,1),(4708,'default','DWP74BC50B',100.0000,1),(4709,'default','DWP94BC50B',100.0000,1),(4710,'default','DWQ64BC50B',100.0000,1),(4711,'default','DWQ66DM50B',100.0000,1),(4712,'default','DWQ94BC50B',100.0000,1),(4713,'default','DWQ96DM50B',100.0000,1),(4714,'default','EB6B5PB60',100.0000,1),(4715,'default','EC6A5HC90',100.0000,1),(4716,'default','EC6A5PB90',100.0000,1),(4717,'default','EC7A5RB90',100.0000,1),(4718,'default','ECS',100.0000,1),(4719,'default','ED651FSB5E',100.0000,1),(4720,'default','ED711FQ15E',100.0000,1),(4721,'default','ED851FQ15E',100.0000,1),(4722,'default','ED851FWB5E',100.0000,1),(4723,'default','EG7B5QB90',100.0000,1),(4724,'default','EH601FEB1E',100.0000,1),(4725,'default','EH611BE15E',100.0000,1),(4726,'default','EH645FEB1E',100.0000,1),(4727,'default','EH801FVB1E',100.0000,1),(4728,'default','EH811BE15E',100.0000,1),(4729,'default','EH845FVB1E',100.0000,1),(4730,'default','EHCL',100.0000,1),(4731,'default','Elica Acuta',100.0000,1),(4732,'default','Elica Adele',100.0000,1),(4733,'default','Elica Adele Island',100.0000,1),(4734,'default','Elica Alpha',100.0000,1),(4735,'default','Elica Aplomb',100.0000,1),(4736,'default','Elica Aquavitae 2.0',100.0000,1),(4737,'default','Elica Ascent',100.0000,1),(4738,'default','Elica Ascent Urban',100.0000,1),(4739,'default','Elica Bio',100.0000,1),(4740,'default','Elica Bio Island',100.0000,1),(4741,'default','Elica Bloom',100.0000,1),(4742,'default','Elica Bloom Lux',100.0000,1),(4743,'default','Elica Box In Lux',100.0000,1),(4744,'default','Elica Boxin HE',100.0000,1),(4745,'default','Elica Cloud Seven',100.0000,1),(4746,'default','Elica Cruise',100.0000,1),(4747,'default','Elica Diva',100.0000,1),(4748,'default','Elica Dolce',100.0000,1),(4749,'default','Elica Easy Ux',100.0000,1),(4750,'default','Elica Elite 14',100.0000,1),(4751,'default','Elica Elite 35',100.0000,1),(4752,'default','Elica Era',100.0000,1),(4753,'default','Elica Era HE',100.0000,1),(4754,'default','Elica Era Lux',100.0000,1),(4755,'default','Elica Fold',100.0000,1),(4756,'default','Elica Fold Stainless Steel',100.0000,1),(4757,'default','Elica Galaxy Island LED',100.0000,1),(4758,'default','Elica Galaxy LED',100.0000,1),(4759,'default','Elica Get Up',100.0000,1),(4760,'default','Elica Haiku',100.0000,1),(4761,'default','Elica Haiku Island',100.0000,1),(4762,'default','Elica HiLight',100.0000,1),(4763,'default','Elica Ikona',100.0000,1),(4764,'default','Elica Illusion Plus',100.0000,1),(4765,'default','Elica Integrata',100.0000,1),(4766,'default','Elica Interstellar',100.0000,1),(4767,'default','Elica Io Air',100.0000,1),(4768,'default','Elica Juno',100.0000,1),(4769,'default','Elica Krea',100.0000,1),(4770,'default','Elica Lane',100.0000,1),(4771,'default','Elica Lever',100.0000,1),(4772,'default','Elica Lullaby',100.0000,1),(4773,'default','Elica Majestic No Drip',100.0000,1),(4774,'default','Elica Meteorite',100.0000,1),(4775,'default','Elica Meteorite Island',100.0000,1),(4776,'default','Elica Mini Io',100.0000,1),(4777,'default','Elica Nikola Tesla Fit',100.0000,1),(4778,'default','Elica Nikola Tesla Flame',100.0000,1),(4779,'default','Elica Nikola Tesla Libra',100.0000,1),(4780,'default','Elica Nikola Tesla Switch',100.0000,1),(4781,'default','Elica Nuance',100.0000,1),(4782,'default','Elica Pandora External',100.0000,1),(4783,'default','Elica Pandora Internal',100.0000,1),(4784,'default','Elica Pearl',100.0000,1),(4785,'default','Elica Pix',100.0000,1),(4786,'default','Elica Plat',100.0000,1),(4787,'default','Elica Reef A',100.0000,1),(4788,'default','Elica Reef A Island',100.0000,1),(4789,'default','Elica Rules',100.0000,1),(4790,'default','Elica Shining',100.0000,1),(4791,'default','Elica Shy',100.0000,1),(4792,'default','Elica Sklock S 2.0',100.0000,1),(4793,'default','Elica Sleek 2',100.0000,1),(4794,'default','Elica Stone',100.0000,1),(4795,'default','Elica Super Plat',100.0000,1),(4796,'default','Elica Tamaya 2',100.0000,1),(4797,'default','Elica Thin',100.0000,1),(4798,'default','Elica Thin Island',100.0000,1),(4799,'default','Elica Tonda',100.0000,1),(4800,'default','Elica Tribe A',100.0000,1),(4801,'default','Elica Tribe Island A',100.0000,1),(4802,'default','Elica Tube Island Pro',100.0000,1),(4803,'default','Elica Wave Ux',100.0000,1),(4804,'default','Elica Yin Island',100.0000,1),(4805,'default','ELITE14-LED-60',100.0000,1),(4806,'default','ELITE14-LED-90',100.0000,1),(4807,'default','ELITE35-60',100.0000,1),(4808,'default','ELITE35-90',100.0000,1),(4809,'default','EP6A6HB20',100.0000,1),(4810,'default','EP7A6QB90',100.0000,1),(4811,'default','EP9A6SB90',100.0000,1),(4812,'default','EPC',100.0000,1),(4813,'default','EPHC',100.0000,1),(4814,'default','EPI',100.0000,1),(4815,'default','EPIC',100.0000,1),(4816,'default','EPQ',100.0000,1),(4817,'default','EPR',100.0000,1),(4818,'default','EPSC',100.0000,1),(4819,'default','EPSR',100.0000,1),(4820,'default','EPST',100.0000,1),(4821,'default','EPW',100.0000,1),(4822,'default','EPWC',100.0000,1),(4823,'default','ER9A6SB70',100.0000,1),(4824,'default','ERA-HE-SS-60',100.0000,1),(4825,'default','ERA-HE-SS-80',100.0000,1),(4826,'default','ERA-LUX-BLK-60',100.0000,1),(4827,'default','ERA-LUX-BLK-80',100.0000,1),(4828,'default','ERA-LUX-SS-60',100.0000,1),(4829,'default','ERA-LUX-SS-80',100.0000,1),(4830,'default','ERA-LUX-WH-60',100.0000,1),(4831,'default','ERA-LUX-WH-80',100.0000,1),(4832,'default','ERA-STD-60',100.0000,1),(4833,'default','ERA-STD-80',100.0000,1),(4834,'default','ERBD76',100.0000,1),(4835,'default','ERBD80',100.0000,1),(4836,'default','ERBD90',100.0000,1),(4837,'default','ERCE7676',100.0000,1),(4838,'default','ERPD70',100.0000,1),(4839,'default','ERQ8',100.0000,1),(4840,'default','ERQ9',100.0000,1),(4841,'default','ERSL10',100.0000,1),(4842,'default','ERSL12',100.0000,1),(4843,'default','ET475FYB1E',100.0000,1),(4844,'default','EU631FEB1E',100.0000,1),(4845,'default','EWCL',100.0000,1),(4846,'default','EX275FXB1E',100.0000,1),(4847,'default','EX375FXB1E',100.0000,1),(4848,'default','EX651FEC1E',100.0000,1),(4849,'default','EX675LXV1E',100.0000,1),(4850,'default','EX851FVC1E',100.0000,1),(4851,'default','EX879FVC1E',100.0000,1),(4852,'default','EX975LVV1E',100.0000,1),(4853,'default','EXPURIPAK1',100.0000,1),(4854,'default','EXPURIPAK2',100.0000,1),(4855,'default','EXPURIPAK3',100.0000,1),(4856,'default','EZ977KZY1E',100.0000,1),(4857,'default','FDF EV8 60',100.0000,1),(4858,'default','FDF EV8 70 XS',100.0000,1),(4859,'default','FDF EV8 90',100.0000,1),(4860,'default','FDW 908 IB XS',100.0000,1),(4861,'default','FFI 622 GR',100.0000,1),(4862,'default','FGC 625 XS',100.0000,1),(4863,'default','FGC 925 XS',100.0000,1),(4864,'default','FGL 625 XS',100.0000,1),(4865,'default','FGL 925 I XS NP',100.0000,1),(4866,'default','FGL 925 XS',100.0000,1),(4867,'default','FJO 624 XS',100.0000,1),(4868,'default','FJO 924 XS',100.0000,1),(4869,'default','FKAS A80 BK Z1',100.0000,1),(4870,'default','FMA 2.0 PRO 807 BK',100.0000,1),(4871,'default','FMA 2.0 PRO 907 BK',100.0000,1),(4872,'default','FMA 839 HI',100.0000,1),(4873,'default','FMY 839 HI',100.0000,1),(4874,'default','FMY PER PRO BK F90',100.0000,1),(4875,'default','FMY PRO 907 FM',100.0000,1),(4876,'default','FPJ 625 V',100.0000,1),(4877,'default','FS04RAK12C',100.0000,1),(4878,'default','FS04RAK82TF',100.0000,1),(4879,'default','FS04RAK8C',100.0000,1),(4880,'default','FS04RAKC',100.0000,1),(4881,'default','FS04RAKCAB',100.0000,1),(4882,'default','FS04RAKCAB0',100.0000,1),(4883,'default','FS05RAK8C',100.0000,1),(4884,'default','FS09RAKC',100.0000,1),(4885,'default','FS09RAKC1',100.0000,1),(4886,'default','FS12RAK12C',100.0000,1),(4887,'default','FS12RAK82TF',100.0000,1),(4888,'default','FS12RAK8C',100.0000,1),(4889,'default','FS12RAKCAB',100.0000,1),(4890,'default','FS12RAKCAB0',100.0000,1),(4891,'default','FTLN H45 X/BK GLASS A90 FRK',100.0000,1),(4892,'default','FTMY AH BK MATT F90',100.0000,1),(4893,'default','FVAD A90 BK MATT',100.0000,1),(4894,'default','FVAS A80 BK Z1',99.0000,1),(4895,'default','FVMY AH BK F90 UK',100.0000,1),(4896,'default','G4344XFF0G',100.0000,1),(4897,'default','Geberit Delta 12cm',100.0000,1),(4898,'default','GI1113FE0',100.0000,1),(4899,'default','GI11VAFE0',100.0000,1),(4900,'default','GI1216DE0',100.0000,1),(4901,'default','GI21VAFE0',100.0000,1),(4902,'default','GI7416CE0',100.0000,1),(4903,'default','GI7813EF0G',100.0000,1),(4904,'default','GI7815CE0G',100.0000,1),(4905,'default','GI81NAEF0G',100.0000,1),(4906,'default','GI81NHCE0G',100.0000,1),(4907,'default','GIN81AEF0G',100.0000,1),(4908,'default','GIN81HCE0G',100.0000,1),(4909,'default','GIV21AFE0',100.0000,1),(4910,'default','GU15DAFF0G',100.0000,1),(4911,'default','GUD15AFF0G',100.0000,1),(4912,'default','HAIKU-120-BLK',100.0000,1),(4913,'default','HAIKU-120-SS',100.0000,1),(4914,'default','HAIKU-120-WH',100.0000,1),(4915,'default','HAIKU-32-BLK',100.0000,1),(4916,'default','HAIKU-32-SS',100.0000,1),(4917,'default','HAIKU-32-WH',100.0000,1),(4918,'default','HAIKU-60-BLK',100.0000,1),(4919,'default','HAIKU-60-SS',100.0000,1),(4920,'default','HAIKU-60-WH',100.0000,1),(4921,'default','HAIKU-90-BLK',100.0000,1),(4922,'default','HAIKU-90-SS',100.0000,1),(4923,'default','HAIKU-90-WH',100.0000,1),(4924,'default','HAIKU-ISL-120-BLK',100.0000,1),(4925,'default','HAIKU-ISL-120-SS',100.0000,1),(4926,'default','HAIKU-ISL-120-WH',100.0000,1),(4927,'default','HAIKU-ISL-180-BLK',100.0000,1),(4928,'default','HAIKU-ISL-180-SS',100.0000,1),(4929,'default','HAIKU-ISL-180-WH',100.0000,1),(4930,'default','HAIKU-ISL-32-BLK',100.0000,1),(4931,'default','HAIKU-ISL-32-SS',100.0000,1),(4932,'default','HAIKU-ISL-32-WH',100.0000,1),(4933,'default','HIB Blend',100.0000,1),(4934,'default','HILIGHT-GLS-16',100.0000,1),(4935,'default','HILIGHT-GLS-30',100.0000,1),(4936,'default','HILIGHT-X-16-BLK',100.0000,1),(4937,'default','HILIGHT-X-16-SS',100.0000,1),(4938,'default','HILIGHT-X-16-WH',100.0000,1),(4939,'default','HILIGHT-X-30-BLK',100.0000,1),(4940,'default','HILIGHT-X-30-SS',100.0000,1),(4941,'default','HILIGHT-X-30-WH',100.0000,1),(4942,'default','Hinged Shower',100.0000,1),(4943,'default','I14RBQ8W0',100.0000,1),(4944,'default','I25CBS8W0B',100.0000,1),(4945,'default','I94CAQ6N0B',100.0000,1),(4946,'default','I95CAP6N1B',100.0000,1),(4947,'default','I95CAQ6N0B',100.0000,1),(4948,'default','I95CAQ6W0B',100.0000,1),(4949,'default','I95CBS8W0B',100.0000,1),(4950,'default','I95GBE2N0B',100.0000,1),(4951,'default','I96BMP5N0B',100.0000,1),(4952,'default','I96BMV5N5B',100.0000,1),(4953,'default','I97CPS8W5B',100.0000,1),(4954,'default','I98WMM1S1B',100.0000,1),(4955,'default','IC',100.0000,1),(4956,'default','ICT',100.0000,1),(4957,'default','ILLUS-PLS-16-BK',100.0000,1),(4958,'default','ILLUS-PLS-16-CS',100.0000,1),(4959,'default','ILLUS-PLS-16-WH',100.0000,1),(4960,'default','ILLUS-PLS-30-BK',100.0000,1),(4961,'default','ILLUS-PLS-30-CS',100.0000,1),(4962,'default','ILLUS-PLS-30-WH',100.0000,1),(4963,'default','INTERSTELLAR-B',100.0000,1),(4964,'default','INTERSTELLAR-C',100.0000,1),(4965,'default','IO-AIR-BLK',100.0000,1),(4966,'default','IO-AIR-WH',100.0000,1),(4967,'default','IQT',100.0000,1),(4968,'default','IR',100.0000,1),(4969,'default','IRT',100.0000,1),(4970,'default','JOYTS120',100.0000,1),(4971,'default','K4316XFF0G',100.0000,1),(4972,'default','K4336XFF0G',100.0000,1),(4973,'default','KA3923IE0G',100.0000,1),(4974,'default','KAD93VBFPG',100.0000,1),(4975,'default','KAG93AIEPG',100.0000,1),(4976,'default','KAI93VIFPG',100.0000,1),(4977,'default','KAN93VIFPG',100.0000,1),(4978,'default','KFF96PIEP',100.0000,1),(4979,'default','KI1213DD0',100.0000,1),(4980,'default','KI1413FD0',100.0000,1),(4981,'default','KI1812SF0G',100.0000,1),(4982,'default','KI1813FE0G',100.0000,1),(4983,'default','KI2822SF0G',100.0000,1),(4984,'default','KI2823FF0G',100.0000,1),(4985,'default','KI5862SE0G',100.0000,1),(4986,'default','KI5871SF0G',100.0000,1),(4987,'default','KI5872FE0G',100.0000,1),(4988,'default','KI5872SE0G',100.0000,1),(4989,'default','KI6863FE0G',100.0000,1),(4990,'default','KI6873FE0G',100.0000,1),(4991,'default','KI7863DF0G',100.0000,1),(4992,'default','KI81RADE0G',100.0000,1),(4993,'default','KI81RAFE0G',100.0000,1),(4994,'default','KI81RVSF0G',100.0000,1),(4995,'default','KI82LAFF0',100.0000,1),(4996,'default','KI86SAFE0G',100.0000,1),(4997,'default','KI86VVFE0G',100.0000,1),(4998,'default','KI87SAFE0G',100.0000,1),(4999,'default','KI87VVFE0G',100.0000,1),(5000,'default','KI87VVSE0G',100.0000,1),(5001,'default','KI8816DE0',100.0000,1),(5002,'default','KI8865DE0',100.0000,1),(5003,'default','KIF81PFE0',100.0000,1),(5004,'default','KIF82PFF0',100.0000,1),(5005,'default','KIF86PFE0',100.0000,1),(5006,'default','KIL82AFF0G',100.0000,1),(5007,'default','KIL82VSF0',100.0000,1),(5008,'default','KIN86AFF0G',100.0000,1),(5009,'default','KIR81AFE0G',100.0000,1),(5010,'default','KIR81VSF0G',100.0000,1),(5011,'default','KIS86AFE0G',100.0000,1),(5012,'default','KIS87AFE0G',100.0000,1),(5013,'default','KIV86VSE0G',100.0000,1),(5014,'default','KIV87NSF0G',100.0000,1),(5015,'default','KIV87VFE0G',100.0000,1),(5016,'default','KIV87VSE0G',100.0000,1),(5017,'default','KREA-LX-90-SS',100.0000,1),(5018,'default','KREA-ST-60-SS',100.0000,1),(5019,'default','KU15LAFF0G',100.0000,1),(5020,'default','KU15RAFF0G',100.0000,1),(5021,'default','KU20WVHF0G',100.0000,1),(5022,'default','KU21RVFE0G',100.0000,1),(5023,'default','KU21WAHG0G',100.0000,1),(5024,'default','KUL15AFF0G',100.0000,1),(5025,'default','KUR15AFF0G',100.0000,1),(5026,'default','KUW20VHF0G',100.0000,1),(5027,'default','KUW21AHG0G',100.0000,1),(5028,'default','L6205EO',100.0000,1),(5029,'default','L6283EO',100.0000,1),(5030,'default','L6284EO',100.0000,1),(5031,'default','L6285EO',100.0000,1),(5032,'default','L6286EO',100.0000,1),(5033,'default','L6287EO',100.0000,1),(5034,'default','L6289EO',100.0000,1),(5035,'default','L6290EO',100.0000,1),(5036,'default','L6617EO',100.0000,1),(5037,'default','LANE-60',100.0000,1),(5038,'default','LANE-80',100.0000,1),(5039,'default','LB53NAA30B',100.0000,1),(5040,'default','LB55565GB',100.0000,1),(5041,'default','LB57574GB',100.0000,1),(5042,'default','LB75565GB',100.0000,1),(5043,'default','LB78574GB',100.0000,1),(5044,'default','LB79585MGB',100.0000,1),(5045,'default','LC64BBC50B',100.0000,1),(5046,'default','LC64PBC50B',100.0000,1),(5047,'default','LC67AFM50B',100.0000,1),(5048,'default','LC67BHM50B',100.0000,1),(5049,'default','LC67KHM60B',100.0000,1),(5050,'default','LC67QFM50B',100.0000,1),(5051,'default','LC77BHM50B',100.0000,1),(5052,'default','LC87KHM60B',100.0000,1),(5053,'default','LC91BUV50B',100.0000,1),(5054,'default','LC91KWW60B',100.0000,1),(5055,'default','LC94BBC50B',100.0000,1),(5056,'default','LC94PBC50B',100.0000,1),(5057,'default','LC97AFM50B',100.0000,1),(5058,'default','LC97BHM50B',100.0000,1),(5059,'default','LC97QFM50B',100.0000,1),(5060,'default','LE63MAC00B',100.0000,1),(5061,'default','LE66MAC00B',100.0000,1),(5062,'default','LEVER-120',100.0000,1),(5063,'default','LEVER-60',100.0000,1),(5064,'default','LEVER-90',100.0000,1),(5065,'default','LF91BUV50B',100.0000,1),(5066,'default','LF97GBM50B',100.0000,1),(5067,'default','LI64MA531B',100.0000,1),(5068,'default','LI94MA531B',100.0000,1),(5069,'default','LI97SA561B',100.0000,1),(5070,'default','LR96CAQ50B',100.0000,1),(5071,'default','LR97CAP21B',100.0000,1),(5072,'default','LR97CAQ50B',100.0000,1),(5073,'default','LULL-AT-NAT-DO',100.0000,1),(5074,'default','LULL-AT-NAT-RC',100.0000,1),(5075,'default','LULL-AT-WW-DO',100.0000,1),(5076,'default','LULL-AT-WW-RC',100.0000,1),(5077,'default','M1000Q-E8',100.0000,1),(5078,'default','M1000SS-E8',100.0000,1),(5079,'default','M1080Q-E8',100.0000,1),(5080,'default','M1100SS-E8',100.0000,1),(5081,'default','M1200SS-E8',100.0000,1),(5082,'default','M1280Q-E8',100.0000,1),(5083,'default','M1290Q-E8',100.0000,1),(5084,'default','M1400SS-E8',100.0000,1),(5085,'default','M800Q-E8',100.0000,1),(5086,'default','M900Q-E8',100.0000,1),(5087,'default','M9080Q-E8',100.0000,1),(5088,'default','MAJ-ND-BLK-60',100.0000,1),(5089,'default','MAJ-ND-BLK-90',100.0000,1),(5090,'default','Matki-MTM',100.0000,1),(5091,'default','METEORITE-120',100.0000,1),(5092,'default','METEORITE-90',100.0000,1),(5093,'default','MH70-E8',100.0000,1),(5094,'default','MH76-E8',100.0000,1),(5095,'default','MH80-E8',100.0000,1),(5096,'default','MH90-E8',100.0000,1),(5097,'default','MOC',100.0000,1),(5098,'default','MOPC',100.0000,1),(5099,'default','MOPR',100.0000,1),(5100,'default','MOQP',100.0000,1),(5101,'default','MOSC',100.0000,1),(5102,'default','MOSR',100.0000,1),(5103,'default','MOWP',100.0000,1),(5104,'default','MOWV',100.0000,1),(5105,'default','N74TD00N0',100.0000,1),(5106,'default','Nikola Tesla One',100.0000,1),(5107,'default','Nikola Tesla One HP',100.0000,1),(5108,'default','Nikola Tesla Prime',100.0000,1),(5109,'default','Nikola Tesla Prime Plus',100.0000,1),(5110,'default','NRXC',100.0000,1),(5111,'default','NRXO',100.0000,1),(5112,'default','NRXS',100.0000,1),(5113,'default','NRXSC',100.0000,1),(5114,'default','NUANCE-DRYWALL',100.0000,1),(5115,'default','NUANCE-PAINT',100.0000,1),(5116,'default','NWCC',100.0000,1),(5117,'default','NWCC1290',100.0000,1),(5118,'default','NWPC',100.0000,1),(5119,'default','NWSR',100.0000,1),(5120,'default','NWSR1290',100.0000,1),(5121,'default','Pacific Pivot Shower Door',100.0000,1),(5122,'default','PBP6B2B60',100.0000,1),(5123,'default','PBP6B5B60',100.0000,1),(5124,'default','PBP6B6B60',100.0000,1),(5125,'default','PCH6A5B90',100.0000,1),(5126,'default','PCI6A5B90',100.0000,1),(5127,'default','PCP6A5B90',100.0000,1),(5128,'default','PCP6A6B90',100.0000,1),(5129,'default','PCQ7A5B90',100.0000,1),(5130,'default','PCR9A5B90',100.0000,1),(5131,'default','PCS7A5B90',100.0000,1),(5132,'default','PEARL-BLK',100.0000,1),(5133,'default','PEARL-SS',100.0000,1),(5134,'default','PEARL-WH',100.0000,1),(5135,'default','PEARL-WH-MATT',100.0000,1),(5136,'default','PGP6B5B60',100.0000,1),(5137,'default','PGP6B5B90',100.0000,1),(5138,'default','PGQ7B5B90',100.0000,1),(5139,'default','PIB375FB1E',100.0000,1),(5140,'default','PIE611B15E',100.0000,1),(5141,'default','PIE811B15E',100.0000,1),(5142,'default','PIV851FB1E',100.0000,1),(5143,'default','PLAT-BLK-55',100.0000,1),(5144,'default','PLAT-BLK-80',100.0000,1),(5145,'default','PLAT-WH-55',100.0000,1),(5146,'default','PLAT-WH-80',100.0000,1),(5147,'default','PNP6B6B90',100.0000,1),(5148,'default','PPP6A6B90',100.0000,1),(5149,'default','PPQ7A6B90',100.0000,1),(5150,'default','PPS9A6B90',100.0000,1),(5151,'default','PRC133',100.0000,1),(5152,'default','PRC134',100.0000,1),(5153,'default','PRC135',100.0000,1),(5154,'default','PRC141',100.0000,1),(5155,'default','PRC143',100.0000,1),(5156,'default','PRC153',100.0000,1),(5157,'default','PRC163',100.0000,1),(5158,'default','PRC171',100.0000,1),(5159,'default','PVQ651FC5E',100.0000,1),(5160,'default','PVQ731F15E',100.0000,1),(5161,'default','PVW851FB5E',100.0000,1),(5162,'default','PXE651FC1E',100.0000,1),(5163,'default','PXV851FC1E',100.0000,1),(5164,'default','PXV875DV1E',100.0000,1),(5165,'default','PXX675DV1E',100.0000,1),(5166,'default','PXX875D67E',100.0000,1),(5167,'default','PXX975KW1E',100.0000,1),(5168,'default','PXY875KW1E',100.0000,1),(5169,'default','REEF-A-60',100.0000,1),(5170,'default','REEF-A-90',100.0000,1),(5171,'default','Regular Cistern',100.0000,1),(5172,'default','RULES-BLK-120',100.0000,1),(5173,'default','RULES-BLK-60',100.0000,1),(5174,'default','RULES-BLK-90',100.0000,1),(5175,'default','RULES-DKT-120',100.0000,1),(5176,'default','RULES-DKT-60',100.0000,1),(5177,'default','RULES-DKT-90',100.0000,1),(5178,'default','S153HAX02G',100.0000,1),(5179,'default','S187ECX23G',100.0000,1),(5180,'default','S187ZCX43G',100.0000,1),(5181,'default','S189YCX02E',100.0000,1),(5182,'default','S875HKX20G',100.0000,1),(5183,'default','SAT001',100.0000,1),(5184,'default','SKLOCK-S-60-2.0',100.0000,1),(5185,'default','SKLOCK-S-90-2.0',100.0000,1),(5186,'default','SLEEK2.0-SS-60',100.0000,1),(5187,'default','SLEEK2.0-SS-80',100.0000,1),(5188,'default','SLEEK2.0-WH-60',100.0000,1),(5189,'default','SLEEK2.0-WH-80',100.0000,1),(5190,'default','SMD6EDX57G',100.0000,1),(5191,'default','SMD6TCX00E',100.0000,1),(5192,'default','SMD6ZCX60G',100.0000,1),(5193,'default','SMD8YCX03G',100.0000,1),(5194,'default','SMV6ZCX01G',100.0000,1),(5195,'default','SN85EX69CG',100.0000,1),(5196,'default','SN95ZX61CG',100.0000,1),(5197,'default','SPV4EMX21G',100.0000,1),(5198,'default','SR93EX20MG',100.0000,1),(5199,'default','SR93EX24MG',100.0000,1),(5200,'default','STONE',100.0000,1),(5201,'default','STONE-WH',100.0000,1),(5202,'default','T26BB59N0',100.0000,1),(5203,'default','T26BR46N0',100.0000,1),(5204,'default','T26BR46S0',100.0000,1),(5205,'default','T26BR46W0',100.0000,1),(5206,'default','T26CB49S0',100.0000,1),(5207,'default','T26CS49S0',100.0000,1),(5208,'default','T26DS49N0',100.0000,1),(5209,'default','T26DS49S0',100.0000,1),(5210,'default','T26DS59N0',100.0000,1),(5211,'default','T27BB59N0',100.0000,1),(5212,'default','T27CS59S0',100.0000,1),(5213,'default','T27DS59N0',100.0000,1),(5214,'default','T27DS59S0',100.0000,1),(5215,'default','T27DS79N0',100.0000,1),(5216,'default','T29DS69N0',100.0000,1),(5217,'default','T36FB40X0',100.0000,1),(5218,'default','T36FB41X0G',100.0000,1),(5219,'default','T46CB4AX2',100.0000,1),(5220,'default','T46FD53X2',100.0000,1),(5221,'default','T46PD53X2',100.0000,1),(5222,'default','T47TD7BN2',100.0000,1),(5223,'default','T48CB1AX2',100.0000,1),(5224,'default','T48FD23X2',100.0000,1),(5225,'default','T48PD23X2',100.0000,1),(5226,'default','T48TD7BN2',100.0000,1),(5227,'default','T56FD50X0',100.0000,1),(5228,'default','T56FT60X0',100.0000,1),(5229,'default','T58FD20X0',100.0000,1),(5230,'default','T58FT20X0',100.0000,1),(5231,'default','T58TL6EN2',100.0000,1),(5232,'default','T59FT50X0',100.0000,1),(5233,'default','T59TF6RN0',100.0000,1),(5234,'default','T59TS5RN0',100.0000,1),(5235,'default','T59TS61N0',100.0000,1),(5236,'default','T68TF6RN0',100.0000,1),(5237,'default','T68TS6RN0',100.0000,1),(5238,'default','TAMAYA2.0-60',100.0000,1),(5239,'default','TAMAYA2.0-90',100.0000,1),(5240,'default','THIN-120',100.0000,1),(5241,'default','THIN-60',100.0000,1),(5242,'default','THIN-70',100.0000,1),(5243,'default','THIN-90',100.0000,1),(5244,'default','TONDA-60',100.0000,1),(5245,'default','TONDA-90',100.0000,1),(5246,'default','TRIBE-A-60',100.0000,1),(5247,'default','TRIBE-A-90',100.0000,1),(5248,'default','VTFW450',100.0000,1),(5249,'default','VTWW450',100.0000,1),(5250,'default','WRSB1200',100.0000,1),(5251,'default','WRSB1400',100.0000,1),(5252,'default','WRSB250',100.0000,1),(5253,'default','WRSB700',100.0000,1),(5254,'default','WRSB800',100.0000,1),(5255,'default','WRSB900',100.0000,1),(5256,'default','XTY006',100.0000,1),(5257,'default','XTY007',100.0000,1),(5258,'default','XTY011M03',100.0000,1),(5259,'default','XTY6M01',100.0000,1),(5260,'default','XTY6M02',100.0000,1),(5261,'default','XTY6M03',100.0000,1),(5262,'default','XTY6T01',100.0000,1),(5263,'default','XTY6T02',100.0000,1),(5264,'default','XTY6T03',100.0000,1),(5265,'default','XTY8M01',100.0000,1),(5266,'default','XTY8M02',100.0000,1),(5267,'default','XTY8M03',100.0000,1),(5268,'default','XTY8T01',100.0000,1),(5269,'default','XTY8T02',100.0000,1),(5270,'default','XTY8T03',100.0000,1),(5271,'default','28939000',100.0000,1),(5272,'default','28990000',100.0000,1),(5273,'default','28991000',100.0000,1),(5274,'default','29032000',100.0000,1),(5275,'default','327248000',100.0000,1),(5276,'default','327474000',100.0000,1),(5277,'default','327789000',100.0000,1),(5278,'default','357474000',100.0000,1),(5279,'default','357475000',100.0000,1),(5280,'default','357477000',100.0000,1),(5281,'default','357640000',100.0000,1),(5282,'default','37762SH0',100.0000,1),(5283,'default','37945SH0',100.0000,1),(5284,'default','38422000',100.0000,1),(5285,'default','4170B003',100.0000,1),(5286,'default','500.782.01.2',100.0000,1),(5287,'default','5270L003-0999',100.0000,1),(5288,'default','5272L003',100.0000,1),(5289,'default','5474B003-0618',100.0000,1),(5290,'default','5500L003',100.0000,1),(5291,'default','5501L003',100.0000,1),(5292,'default','5502L003',100.0000,1),(5293,'default','5503L003',100.0000,1),(5294,'default','5504L003',100.0000,1),(5295,'default','5509L003-0288',100.0000,1),(5296,'default','5521B003-0001',100.0000,1),(5297,'default','5524B003',100.0000,1),(5298,'default','5635B003-0001',100.0000,1),(5299,'default','5750L003',100.0000,1),(5300,'default','5751L003',100.0000,1),(5301,'default','58140180',100.0000,1),(5302,'default','6069B003-0012',100.0000,1),(5303,'default','7275L003-0001',100.0000,1),(5304,'default','7276L003-0001',100.0000,1),(5305,'default','7277L003-0001',100.0000,1),(5306,'default','7278L003-0001',100.0000,1),(5307,'default','77-003-001',100.0000,1),(5308,'default','77-003-009',100.0000,1),(5309,'default','8013SC005',100.0000,1),(5310,'default','80152',100.0000,1),(5311,'default','80153200B',100.0000,1),(5312,'default','801782004',100.0000,1),(5313,'default','80178C004',100.0000,1),(5314,'default','8019B',100.0000,1),(5315,'default','801B2200B',100.0000,1),(5316,'default','801B5200B',100.0000,1),(5317,'default','801B8200B',100.0000,1),(5318,'default','801D1',100.0000,1),(5319,'default','801D30001',100.0000,1),(5320,'default','890080200',100.0000,1),(5321,'default','94-003-001',100.0000,1),(5322,'default','94-003-009',100.0000,1),(5323,'default','A3027',100.0000,1),(5324,'default','A304',100.0000,1),(5325,'default','A3041',100.0000,1),(5326,'default','A3043',100.0000,1),(5327,'default','A3064',100.0000,1),(5328,'default','A3082',100.0000,1),(5329,'default','A3088',100.0000,1),(5330,'default','A3150G',100.0000,1),(5331,'default','A3181',100.0000,1),(5332,'default','A321',100.0000,1),(5333,'default','A3211',100.0000,1),(5334,'default','A3220',100.0000,1),(5335,'default','A3221',100.0000,1),(5336,'default','A3238',100.0000,1),(5337,'default','A3245',100.0000,1),(5338,'default','A32599400U',100.0000,1),(5339,'default','A32599500U',100.0000,1),(5340,'default','A32599600U',100.0000,1),(5341,'default','A32599800U',100.0000,1),(5342,'default','A325999000',100.0000,1),(5343,'default','A3263',100.0000,1),(5344,'default','A3264',100.0000,1),(5345,'default','A3270A0',100.0000,1),(5346,'default','A3270A1',100.0000,1),(5347,'default','A3270M0004',100.0000,1),(5348,'default','A3270M1004',100.0000,1),(5349,'default','A3270MA004',100.0000,1),(5350,'default','A3270MB004',100.0000,1),(5351,'default','A354',100.0000,1),(5352,'default','A355',100.0000,1),(5353,'default','A357527000',100.0000,1),(5354,'default','A3600',100.0000,1),(5355,'default','A371',100.0000,1),(5356,'default','A383',100.0000,1),(5357,'default','A505400000',100.0000,1),(5358,'default','A525220603',100.0000,1),(5359,'default','A9115AA',100.0000,1),(5360,'default','A9116AA',100.0000,1),(5361,'default','A9122AA',100.0000,1),(5362,'default','A9123AA',100.0000,1),(5363,'default','A9127AA',100.0000,1),(5364,'default','A9129AA',100.0000,1),(5365,'default','A9130AA',100.0000,1),(5366,'default','A9132AA',100.0000,1),(5367,'default','ACC001',100.0000,1),(5368,'default','AL0101AWHA',100.0000,1),(5369,'default','Arlo 550 Basin',100.0000,1),(5370,'default','ARM01',100.0000,1),(5371,'default','ARM03',100.0000,1),(5372,'default','ARM06',100.0000,1),(5373,'default','ARM07',100.0000,1),(5374,'default','ARM12',100.0000,1),(5375,'default','ARM13',100.0000,1),(5376,'default','ARM15',100.0000,1),(5377,'default','ARM16',100.0000,1),(5378,'default','B080-901',100.0000,1),(5379,'default','B090-901',100.0000,1),(5380,'default','B110-901',100.0000,1),(5381,'default','B120-901',100.0000,1),(5382,'default','B122-901',100.0000,1),(5383,'default','B270-000',100.0000,1),(5384,'default','B57-0245',100.0000,1),(5385,'default','B600',100.0000,1),(5386,'default','B604',100.0000,1),(5387,'default','B606',100.0000,1),(5388,'default','B640-000',100.0000,1),(5389,'default','B641-000',100.0000,1),(5390,'default','BDJ002',100.0000,1),(5391,'default','BEB060-901',100.0000,1),(5392,'default','BEB23-1500',100.0000,1),(5393,'default','BS000000',100.0000,1),(5394,'default','BS000001',100.0000,1),(5395,'default','BS04600',100.0000,1),(5396,'default','BS500CP',100.0000,1),(5397,'default','BS600CP',100.0000,1),(5398,'default','BS700CP',100.0000,1),(5399,'default','BST26053',100.0000,1),(5400,'default','BST26059',100.0000,1),(5401,'default','CCT004',100.0000,1),(5402,'default','Chancery 500 Basin',100.0000,1),(5403,'default','CIV002',100.0000,1),(5404,'default','CIV004',100.0000,1),(5405,'default','CIV005',100.0000,1),(5406,'default','CLG004',100.0000,1),(5407,'default','CLW003',100.0000,1),(5408,'default','CM0101AWHA',100.0000,1),(5409,'default','CML002',100.0000,1),(5410,'default','CO0601AWHA',100.0000,1),(5411,'default','CO0701AWHA',100.0000,1),(5412,'default','CO0801AWHA',100.0000,1),(5413,'default','CO0901AWHA',100.0000,1),(5414,'default','CO0902AWHA',100.0000,1),(5415,'default','CO1004AWHA',100.0000,1),(5416,'default','CO2401AWHA',100.0000,1),(5417,'default','CO2601AWHA',100.0000,1),(5418,'default','CO2801AWHA',100.0000,1),(5419,'default','CO2901NCHAWHA',100.0000,1),(5420,'default','Concept Sphere Semi-Countertop',100.0000,1),(5421,'default','CPC023',100.0000,1),(5422,'default','CPC024',100.0000,1),(5423,'default','CPV002',100.0000,1),(5424,'default','CPV003',100.0000,1),(5425,'default','CPV004',100.0000,1),(5426,'default','CSS002',100.0000,1),(5427,'default','CSS003',100.0000,1),(5428,'default','DC0101AWHA',100.0000,1),(5429,'default','E308',100.0000,1),(5430,'default','E309',100.0000,1),(5431,'default','E310201',100.0000,1),(5432,'default','E347',100.0000,1),(5433,'default','E348',100.0000,1),(5434,'default','E353',100.0000,1),(5435,'default','E500401',100.0000,1),(5436,'default','E500601',100.0000,1),(5437,'default','E500801',100.0000,1),(5438,'default','E501101',100.0000,1),(5439,'default','E501301',100.0000,1),(5440,'default','E501501',100.0000,1),(5441,'default','E502301',100.0000,1),(5442,'default','E502401',100.0000,1),(5443,'default','E502601',100.0000,1),(5444,'default','E502701',100.0000,1),(5445,'default','E784201',100.0000,1),(5446,'default','E785201',100.0000,1),(5447,'default','E788101',100.0000,1),(5448,'default','E794301',100.0000,1),(5449,'default','E797601',100.0000,1),(5450,'default','E803101',100.0000,1),(5451,'default','EA329',100.0000,1),(5452,'default','EA370',100.0000,1),(5453,'default','EA381',100.0000,1),(5454,'default','EA384',100.0000,1),(5455,'default','EA385',100.0000,1),(5456,'default','EFB1100 GG',100.0000,1),(5457,'default','EHW300HP',100.0000,1),(5458,'default','EK310',100.0000,1),(5459,'default','EPB900',100.0000,1),(5460,'default','EPD',100.0000,1),(5461,'default','EPH',100.0000,1),(5462,'default','EPS',100.0000,1),(5463,'default','ER03',100.0000,1),(5464,'default','ER07',100.0000,1),(5465,'default','ERSBS0',100.0000,1),(5466,'default','ERSS1',100.0000,1),(5467,'default','ERSSQ',100.0000,1),(5468,'default','Hansgrohe Flexaplus S',100.0000,1),(5469,'default','HAR07AWHA',100.0000,1),(5470,'default','HAR08AWHA',100.0000,1),(5471,'default','HAR101AWHA',100.0000,1),(5472,'default','HAR102AWHA',100.0000,1),(5473,'default','HAR14AWHA',100.0000,1),(5474,'default','HEAD01',100.0000,1),(5475,'default','HEAD16',100.0000,1),(5476,'default','HEAD21',100.0000,1),(5477,'default','HEAD26',100.0000,1),(5478,'default','HEAD45',100.0000,1),(5479,'default','HEAD46',100.0000,1),(5480,'default','HEAD47',100.0000,1),(5481,'default','HEAD48',100.0000,1),(5482,'default','HEAD49',100.0000,1),(5483,'default','HEAD50',100.0000,1),(5484,'default','HEAD58',100.0000,1),(5485,'default','HEAD66',100.0000,1),(5486,'default','HEAD80',100.0000,1),(5487,'default','HEAD81',100.0000,1),(5488,'default','HEAD82',100.0000,1),(5489,'default','HG AddStoris',100.0000,1),(5490,'default','HIB 31100',100.0000,1),(5491,'default','HIB 31200',100.0000,1),(5492,'default','HIB 31300',100.0000,1),(5493,'default','HIB 31400',100.0000,1),(5494,'default','HIB 31500',100.0000,1),(5495,'default','HIB 31600',100.0000,1),(5496,'default','HIB 31700',100.0000,1),(5497,'default','HIB 31800',100.0000,1),(5498,'default','HIB 32200',100.0000,1),(5499,'default','HIB 32300',100.0000,1),(5500,'default','HIB 32600',100.0000,1),(5501,'default','HIB 32700',100.0000,1),(5502,'default','HIB 32800',100.0000,1),(5503,'default','HIB 32900',100.0000,1),(5504,'default','HIB 33100',100.0000,1),(5505,'default','HIB 33200',100.0000,1),(5506,'default','HIB 33300',100.0000,1),(5507,'default','HIB 33400',100.0000,1),(5508,'default','HIB 33500',100.0000,1),(5509,'default','HIB 33600',100.0000,1),(5510,'default','HIB 33700',100.0000,1),(5511,'default','HIB 33800',100.0000,1),(5512,'default','HIB 33900',100.0000,1),(5513,'default','HIB 34000',100.0000,1),(5514,'default','HIB 34500',100.0000,1),(5515,'default','HIB 34600',100.0000,1),(5516,'default','HIB 34700',100.0000,1),(5517,'default','HIB 34800',100.0000,1),(5518,'default','HIB Minimalist',100.0000,1),(5519,'default','HIB Vanya',100.0000,1),(5520,'default','HO302',100.0000,1),(5521,'default','HO306',100.0000,1),(5522,'default','HO307',100.0000,1),(5523,'default','HO310',100.0000,1),(5524,'default','HR Round Plate',100.0000,1),(5525,'default','L6210AA',100.0000,1),(5526,'default','LA371',100.0000,1),(5527,'default','LA380',100.0000,1),(5528,'default','LA386',100.0000,1),(5529,'default','LL306',100.0000,1),(5530,'default','LL308',100.0000,1),(5531,'default','Luna 420 Basin',100.0000,1),(5532,'default','Luna 520 Basin',100.0000,1),(5533,'default','Maya 550 Basin',100.0000,1),(5534,'default','Maya 650 Basin',100.0000,1),(5535,'default','Maya 850 Basin',100.0000,1),(5536,'default','Memoria Seat',100.0000,1),(5537,'default','Milton Wash Basin',100.0000,1),(5538,'default','MORBD2015AWHA',100.0000,1),(5539,'default','MORBD2100AWHA',100.0000,1),(5540,'default','MORCT5400AWHA',100.0000,1),(5541,'default','MORSR5501AWHA',100.0000,1),(5542,'default','MORWB5001AWHA',100.0000,1),(5543,'default','MORWB5501AWHA',100.0000,1),(5544,'default','MORWB6001AWHA',100.0000,1),(5545,'default','MORWB6501AWHA',100.0000,1),(5546,'default','MP0101AWHA',100.0000,1),(5547,'default','MP0701AWHA',100.0000,1),(5548,'default','MP0901AWHA',100.0000,1),(5549,'default','MP09AWHA',100.0000,1),(5550,'default','MP18AWHA',100.0000,1),(5551,'default','NBBS1',100.0000,1),(5552,'default','NBBSR1',100.0000,1),(5553,'default','NBV005',100.0000,1),(5554,'default','NBV006',100.0000,1),(5555,'default','NBV102',100.0000,1),(5556,'default','NBV106',100.0000,1),(5557,'default','NBV124',100.0000,1),(5558,'default','NCA104',100.0000,1),(5559,'default','NCG300',100.0000,1),(5560,'default','NCG400',100.0000,1),(5561,'default','NCS0',100.0000,1),(5562,'default','NCS1',100.0000,1),(5563,'default','NCS809',100.0000,1),(5564,'default','NCS829',100.0000,1),(5565,'default','NCSR1',100.0000,1),(5566,'default','NCT102',100.0000,1),(5567,'default','NCU862',100.0000,1),(5568,'default','NCU932',100.0000,1),(5569,'default','NCU942',100.0000,1),(5570,'default','NLS199',100.0000,1),(5571,'default','NOVA30',100.0000,1),(5572,'default','NSBS2',100.0000,1),(5573,'default','NSBS3',100.0000,1),(5574,'default','NSBSR1',100.0000,1),(5575,'default','NSS1',100.0000,1),(5576,'default','NSS2',100.0000,1),(5577,'default','NSS6BP',100.0000,1),(5578,'default','NSSQ',100.0000,1),(5579,'default','NSSQ1',100.0000,1),(5580,'default','NSSQ7',100.0000,1),(5581,'default','NSSQBF',100.0000,1),(5582,'default','NSSQR',100.0000,1),(5583,'default','NSSQR2',100.0000,1),(5584,'default','NSSR1',100.0000,1),(5585,'default','NSSR2',100.0000,1),(5586,'default','NTS002',100.0000,1),(5587,'default','NTS010',100.0000,1),(5588,'default','NTS302',100.0000,1),(5589,'default','NTS303',100.0000,1),(5590,'default','Nuie Harmony Basin',100.0000,1),(5591,'default','OC04AWHA',100.0000,1),(5592,'default','OC116AWHA',100.0000,1),(5593,'default','OC123AWHA',100.0000,1),(5594,'default','OC137AWHA',100.0000,1),(5595,'default','OC143AWHA',100.0000,1),(5596,'default','OC160AWHA',100.0000,1),(5597,'default','OC161AWHA',100.0000,1),(5598,'default','OC17AWHA',100.0000,1),(5599,'default','OC36AWHA',100.0000,1),(5600,'default','OC37AAWHA',100.0000,1),(5601,'default','OC67AWHA',100.0000,1),(5602,'default','OC69AWHA',100.0000,1),(5603,'default','OC71AWHA',100.0000,1),(5604,'default','OC72AWHA',100.0000,1),(5605,'default','ORG0701AWHA',100.0000,1),(5606,'default','ORG0801AWHA',100.0000,1),(5607,'default','ORG14AWHA',100.0000,1),(5608,'default','ORG2601AWHA',100.0000,1),(5609,'default','RAK Moon 1-TH',100.0000,1),(5610,'default','RAK Morning 1-TH',100.0000,1),(5611,'default','RAK Resort 1-TH',100.0000,1),(5612,'default','RAK Resort Slimline',100.0000,1),(5613,'default','RAK Rosa UC',100.0000,1),(5614,'default','RAK Tonique 1-TH',100.0000,1),(5615,'default','Rak Variant Elongated Oval',100.0000,1),(5616,'default','Rak Variant Oval',100.0000,1),(5617,'default','Rak Variant Rectangular',100.0000,1),(5618,'default','Rak Variant Round',100.0000,1),(5619,'default','Rak Variant Square',100.0000,1),(5620,'default','RAK Washington 1-TH',100.0000,1),(5621,'default','RAKC17124',100.0000,1),(5622,'default','RAKC17149',100.0000,1),(5623,'default','RAKC17151',100.0000,1),(5624,'default','RAKC17153',100.0000,1),(5625,'default','RAKC17158',100.0000,1),(5626,'default','RAKC17159',100.0000,1),(5627,'default','RAKC17160',100.0000,1),(5628,'default','RAKC17190',100.0000,1),(5629,'default','RAKC17194',100.0000,1),(5630,'default','RAKCCW',100.0000,1),(5631,'default','RAKCCW0',100.0000,1),(5632,'default','RAKCCW003',100.0000,1),(5633,'default','RAKCCW004',100.0000,1),(5634,'default','RAKCCW005',100.0000,1),(5635,'default','RAKCOM953C',100.0000,1),(5636,'default','RAKCUB9901',100.0000,1),(5637,'default','RAKCUB9902',100.0000,1),(5638,'default','RAKCUB9903',100.0000,1),(5639,'default','RAKCUB9905',100.0000,1),(5640,'default','RAKCUB9906',100.0000,1),(5641,'default','RAKCUB9907',100.0000,1),(5642,'default','RAKCUB9908',100.0000,1),(5643,'default','RAKCUB9909',100.0000,1),(5644,'default','RAKCUB9910',100.0000,1),(5645,'default','RAKCUB9912',100.0000,1),(5646,'default','RAKCUB9914',100.0000,1),(5647,'default','RAKGRB99',100.0000,1),(5648,'default','RAKGRB9920',100.0000,1),(5649,'default','RAKGRB9925',100.0000,1),(5650,'default','RAKHAR99',100.0000,1),(5651,'default','RAKHAR9901',100.0000,1),(5652,'default','RAKHAR9902',100.0000,1),(5653,'default','RAKHAR9909',100.0000,1),(5654,'default','RAKHAR9912',100.0000,1),(5655,'default','RAKL9022',100.0000,1),(5656,'default','RAKL9023',100.0000,1),(5657,'default','RAKL9025',100.0000,1),(5658,'default','RAKOP10626',100.0000,1),(5659,'default','RAKRBTP002',100.0000,1),(5660,'default','RAKREPGW15',100.0000,1),(5661,'default','RAKSBTP001',100.0000,1),(5662,'default','RAKSPH9901',100.0000,1),(5663,'default','RAKSPH9902',100.0000,1),(5664,'default','RAKSPH9903',100.0000,1),(5665,'default','RAKSPH9905',100.0000,1),(5666,'default','RAKSPH9906',100.0000,1),(5667,'default','RAKSPH9907',100.0000,1),(5668,'default','RAKSPH9908',100.0000,1),(5669,'default','RAKSPH9909',100.0000,1),(5670,'default','RAKSPH9910',100.0000,1),(5671,'default','RAKSPH9912',100.0000,1),(5672,'default','RAKSPH9914',100.0000,1),(5673,'default','Relax Cushion',100.0000,1),(5674,'default','Richmond 500 Basin',100.0000,1),(5675,'default','Richmond 500 Comfort Basin',100.0000,1),(5676,'default','Richmond 560 Basin',100.0000,1),(5677,'default','Richmond 560 Comfort Basin',100.0000,1),(5678,'default','Richmond 600 Basin',100.0000,1),(5679,'default','Richmond 600 Comfort Basin',100.0000,1),(5680,'default','Roca Laura 520mm',100.0000,1),(5681,'default','Roca Laura 560mm',100.0000,1),(5682,'default','RST0101AWHA',100.0000,1),(5683,'default','RST0501AWHA',100.0000,1),(5684,'default','RST0701AWHA',100.0000,1),(5685,'default','RST0801AWHA',100.0000,1),(5686,'default','RST1001AWHA',100.0000,1),(5687,'default','RST14AWHA',100.0000,1),(5688,'default','RST2601AWHA',100.0000,1),(5689,'default','S20 Seat',100.0000,1),(5690,'default','SE0101AWHA',100.0000,1),(5691,'default','SE0501AWHA',100.0000,1),(5692,'default','SE0901AWHA',100.0000,1),(5693,'default','SE0902AWHA',100.0000,1),(5694,'default','SE0904AWHA',100.0000,1),(5695,'default','SE20AWHA',100.0000,1),(5696,'default','Serenada Seat',100.0000,1),(5697,'default','SM0101AWHA',100.0000,1),(5698,'default','SM0501AWHA',100.0000,1),(5699,'default','SM0701AWHA',100.0000,1),(5700,'default','SM0901AWHA',100.0000,1),(5701,'default','SP14AWHA',100.0000,1),(5702,'default','STB700',100.0000,1),(5703,'default','STB800',100.0000,1),(5704,'default','STY069',100.0000,1),(5705,'default','STY070',100.0000,1),(5706,'default','STY072',100.0000,1),(5707,'default','T9923EO',100.0000,1),(5708,'default','T9924EO',100.0000,1),(5709,'default','TQ0701AWHA',100.0000,1),(5710,'default','TQ0801AWHA',100.0000,1),(5711,'default','TQ0901AWHA',100.0000,1),(5712,'default','TQ14AWHA',100.0000,1),(5713,'default','VARCT13600AWHA',100.0000,1),(5714,'default','VARCT14201AWHA',100.0000,1),(5715,'default','VARCT25000AWHA',100.0000,1),(5716,'default','VARCT25001AWHA',100.0000,1),(5717,'default','VARCT36000AWHA',100.0000,1),(5718,'default','VARCT36001AWHA',100.0000,1),(5719,'default','VARCT43600AWHA',100.0000,1),(5720,'default','VARCT44201AWHA',100.0000,1),(5721,'default','VARCT55500AWHA',100.0000,1),(5722,'default','VARCT55501AWHA',100.0000,1),(5723,'default','VARDI13600AWHA',100.0000,1),(5724,'default','VARDI14201AWHA',100.0000,1),(5725,'default','VARDI25000AWHA',100.0000,1),(5726,'default','VARDI25001AWHA',100.0000,1),(5727,'default','VARDI36000AWHA',100.0000,1),(5728,'default','VARDI36001AWHA',100.0000,1),(5729,'default','VARDI43600AWHA',100.0000,1),(5730,'default','VARDI44201AWHA',100.0000,1),(5731,'default','VARDI55500AWHA',100.0000,1),(5732,'default','VARDI55501AWHA',100.0000,1),(5733,'default','VARUC13600AWHA',100.0000,1),(5734,'default','VARUC25000AWHA',100.0000,1),(5735,'default','VARUC36000AWHA',100.0000,1),(5736,'default','VARUC43600AWHA',100.0000,1),(5737,'default','VARUC55500AWHA',100.0000,1),(5738,'default','Vessels Basin',100.0000,1),(5739,'default','WRSC070',100.0000,1),(5740,'default','WRSC080',100.0000,1),(5741,'default','WRSC090',100.0000,1),(5742,'default','WRSC10',100.0000,1),(5743,'default','WRSC12',100.0000,1),(5744,'default','WRSC14',100.0000,1),(5745,'default','WT0101AWHA',100.0000,1),(5746,'default','WT0401AWHA',100.0000,1),(5747,'default','WT0701AWHA',100.0000,1),(5748,'default','WT07AWHA',100.0000,1),(5749,'default','WT0801AWHA',100.0000,1),(5750,'default','Z0007521',100.0000,1),(5751,'default','Z0008669',100.0000,1),(5752,'default','Zentrum Basin',100.0000,1),(5754,'default','test-configurable',100000.0000,1),(5755,'default','test-configurable-Red',1000.0000,1),(5756,'default','test-configurable-black',1000.0000,1),(5757,'default','test-configurable-green',1000.0000,1),(5758,'default','Reginox Comfort Colorado L Integrated 1 Bowl Kitchen',100.0000,1),(5759,'default','Reginox Comfort C',100.0000,1),(5760,'default','Reginox Comfort Colorado L Integrated 1 Bow',100.0000,1),(5761,'default','test-product',10.0000,1),(5762,'default','Colorado Comfort',496.0000,1),(5763,'default','MTG 651-100',1.0000,1),(5764,'default','122.0606.948',472.0000,1),(5765,'default','Balmoral',100.0000,1),(5766,'default','Bolton 1690',500.0000,1),(5767,'default','Bolton 1805',498.0000,1),(5768,'default','Chatsworth',500.0000,1),(5769,'default','Ebony',500.0000,1),(5770,'default','Hexham',500.0000,1),(5771,'default','Kensington 1495',500.0000,1),(5772,'default','Kensington 1695',500.0000,1),(5773,'default','Lambeth',498.0000,1),(5774,'default','Melrose',498.0000,1),(5775,'default','Melrose FA',100.0000,1),(5776,'default','Onyx',500.0000,1),(5777,'default','Opal',500.0000,1),(5778,'default','Orlando 1380',500.0000,1),(5779,'default','Quartz',500.0000,1),(5780,'default','Ruby',500.0000,1),(5781,'default','Sunstone',500.0000,1),(5782,'default','Westminster 1490',500.0000,1),(5783,'default','Westminster 1860',500.0000,1),(5784,'default','Woburn 1490',500.0000,1),(5785,'default','Woburn 1675',500.0000,1),(5786,'default','Woburn 1765',500.0000,1),(5787,'default','NBA209',500.0000,1),(5788,'default','NBA210',500.0000,1),(5789,'default','NBA214',500.0000,1),(5790,'default','NBA605',500.0000,1),(5791,'default','NBA607',500.0000,1),(5792,'default','NBA609',500.0000,1),(5793,'default','NBA610',500.0000,1),(5794,'default','NBA614',500.0000,1),(5795,'default','NBA405',500.0000,1),(5796,'default','NBA407',500.0000,1),(5797,'default','NBA409',500.0000,1),(5798,'default','NBA410',500.0000,1),(5799,'default','NBA414',500.0000,1),(5800,'default','NBA509',500.0000,1),(5801,'default','NBA510',500.0000,1),(5802,'default','NBA514',500.0000,1),(5803,'default','BT58AWHA',500.0000,1),(5804,'default','BT55AAWHA',499.0000,1),(5805,'default','BT57AWHA',500.0000,1),(5806,'default','BT01AAWHA',500.0000,1),(5807,'default','2370J 2370K',500.0000,1),(5808,'default','24717000',499.0000,1),(5809,'default','24719000',500.0000,1),(5810,'default','24718000',500.0000,1),(5811,'default','Bette Classic',491.0000,1),(5812,'default','Bette Comodo with Side Overflow',495.0000,1),(5813,'default','Bette Duett',500.0000,1),(5814,'default','Bette Free',500.0000,1),(5815,'default','Bette Ocean Lowline',500.0000,1),(5816,'default','Bette One',495.0000,1),(5817,'default','Bette One Relax',498.0000,1),(5818,'default','Bette Starlet Flair Oval',500.0000,1),(5819,'default','Bette Starlet IV Silhouette',500.0000,1),(5820,'default','Bette Starlet Oval',500.0000,1),(5821,'default','Bette Starlet V',500.0000,1),(5822,'default','2.21E+03',500.0000,1),(5823,'default','2375L3000',499.0000,1),(5824,'default','1080-000',475.0000,1),(5825,'default','1180-000',494.0000,1),(5826,'default','1200-000',481.0000,1),(5827,'default','1210-000',483.0000,1),(5828,'default','1220-000',490.0000,1),(5829,'default','1230-000',497.0000,1),(5830,'default','1240-000',490.0000,1),(5831,'default','1250-000',493.0000,1),(5832,'default','1270-000',486.0000,1),(5833,'default','1271-000',478.0000,1),(5834,'default','1272-000',488.0000,1),(5835,'default','1300-000',474.0000,1),(5836,'default','1380-000',485.0000,1),(5837,'default','1430-000',493.0000,1),(5838,'default','1450-000',485.0000,1),(5839,'default','1630-000',482.0000,1),(5840,'default','1730-000',474.0000,1),(5841,'default','1830-000',497.0000,1),(5842,'default','2540-000',466.0000,1),(5843,'default','2560-000',493.0000,1),(5844,'default','2590-000',497.0000,1),(5845,'default','3060-000',485.0000,1),(5846,'default','3110-000',483.0000,1),(5847,'default','3323-000',498.0000,1),(5848,'default','3324-000',500.0000,1),(5849,'default','3325-000',498.0000,1),(5850,'default','2940-000',488.0000,1),(5851,'default','3410-000',493.0000,1),(5852,'default','3411-000',477.0000,1),(5853,'default','3412-000',496.0000,1),(5854,'default','3413-000',498.0000,1),(5855,'default','3420-000T',496.0000,1),(5856,'default','3431-000',495.0000,1),(5857,'default','3432-000',493.0000,1),(5858,'default','3433-000',492.0000,1),(5859,'default','2949-000',485.0000,1),(5860,'default','2948-000',487.0000,1),(5861,'default','2941-000',485.0000,1),(5862,'default','3560-000',485.0000,1),(5863,'default','2942-000',487.0000,1),(5864,'default','2943-000',485.0000,1),(5865,'default','2944-000',453.0000,1),(5866,'default','3650-000',496.0000,1),(5867,'default','3660-000',496.0000,1),(5868,'default','2946-000',496.0000,1),(5869,'default','2947-000',477.0000,1),(5870,'default','3760-000',494.0000,1),(5871,'default','2950-000',494.0000,1),(5872,'default','3860-000',497.0000,1),(5873,'default','8772-000',499.0000,1),(5874,'default','8773-000',500.0000,1),(5875,'default','8774-000',498.0000,1),(5876,'default','8775-000',496.0000,1),(5877,'default','2700-000',500.0000,1),(5878,'default','2720-000',500.0000,1),(5879,'default','2680-000',499.0000,1),(5880,'default','2740-000',498.0000,1),(5881,'default','2745-000',500.0000,1),(5882,'default','2951-000',477.0000,1),(5883,'default','2945-000',454.0000,1),(5884,'default','6650-000CERVK',499.0000,1),(5885,'default','6660-000CERVK',500.0000,1),(5886,'default','6670-000CERVK',500.0000,1),(5887,'default','6680-000CELVK',500.0000,1),(5888,'default','6690-000CELVK',500.0000,1),(5889,'default','6700-000CELVK',500.0000,1),(5890,'default','8856-000',475.0000,1),(5891,'default','8842-000',498.0000,1),(5892,'default','8859-000',460.0000,1),(5893,'default','8850-000',479.0000,1),(5894,'default','8765-000',482.0000,1),(5895,'default','8852-000',458.0000,1),(5896,'default','8854-000',459.0000,1),(5897,'default','8831-000',498.0000,1),(5898,'default','8836-000',497.0000,1),(5899,'default','8833-000',495.0000,1),(5900,'default','8835-000',489.0000,1),(5901,'default','8839-000',498.0000,1),(5902,'default','3480-000CFXXK',500.0000,1),(5903,'default','3820-000',499.0000,1),(5904,'default','RAK-Cloud Bath',500.0000,1),(5905,'default','BT54AWHA',500.0000,1),(5906,'default','KABATH/WL',500.0000,1),(5907,'default','BT56AWHA',500.0000,1),(5908,'default','RAKWTNBAT1770/WL',500.0000,1),(5909,'default','RAKWTNBAT1775/WL',500.0000,1),(5910,'default','RAK-Washington',500.0000,1),(5911,'default','NBB001',500.0000,1),(5912,'default','NBB002',500.0000,1),(5913,'default','NBB003',500.0000,1),(5914,'default','NBB004',500.0000,1),(5915,'default','NLB109',500.0000,1),(5916,'default','NLB110',500.0000,1),(5917,'default','NLB114',500.0000,1),(5918,'default','RE1701C2',500.0000,1),(5919,'default','RL1490C2',500.0000,1),(5920,'default','RL1501C2',500.0000,1),(5921,'default','RL1690C2',500.0000,1),(5922,'default','RL1705C2',500.0000,1),(5923,'default','RL1707T',500.0000,1),(5924,'default','RLF1500C2',500.0000,1),(5925,'default','RLF1700C2',499.0000,1),(5926,'default','1252-000',498.0000,1),(5927,'default','Bette Select Overflow',500.0000,1),(5928,'default','Bette Form Steel Bath',490.0000,1),(5929,'default','Bette Labette',494.0000,1),(5930,'default','Bette Ocean',494.0000,1),(5931,'default','Bette Set',487.0000,1),(5932,'default','Bette Starlet',483.0000,1),(5933,'default','3310-000',494.0000,1),(5934,'default','3311-000',495.0000,1),(5935,'default','3312-000',492.0000,1),(5936,'default','3313-000',495.0000,1),(5937,'default','3314-000',494.0000,1),(5938,'default','6677-000CERVK',495.0000,1),(5939,'default','6720-000CELVK',495.0000,1),(5940,'default','1620-000',493.0000,1),(5941,'default','1643-000',495.0000,1),(5942,'default','1641-000',494.0000,1),(5943,'default','1642-000',495.0000,1),(5944,'default','1266-000',494.0000,1),(5945,'default','1268-000',494.0000,1),(5946,'default','1267-000',494.0000,1),(5947,'default','1269-000',495.0000,1),(5948,'default','1265-000',493.0000,1),(5949,'default','3108-000',486.0000,1),(5950,'default','3109-000',495.0000,1),(5951,'default','3111-000',495.0000,1),(5952,'default','3112-000',494.0000,1),(5953,'default','1273-000',494.0000,1),(5954,'default','1631-000',495.0000,1),(5955,'default','Bette Select',495.0000,1),(5956,'default','Bette Comodo',495.0000,1),(5957,'default','1253-000',495.0000,1),(5958,'default','1251-000',493.0000,1),(5959,'default','3020-000',493.0000,1),(5960,'default','3100-000',494.0000,1),(5961,'default','6829-000',494.0000,1),(5962,'default','6830-000',494.0000,1),(5963,'default','6831-000',495.0000,1),(5964,'default','6832-000',495.0000,1),(5965,'default','Balance Bath',500.0000,1),(5966,'default','55230001000',500.0000,1),(5967,'default','55210001000',500.0000,1),(5968,'default','55180001000',500.0000,1),(5969,'default','Neon Rectangular Bath',500.0000,1),(5970,'default','52510001000',500.0000,1),(5971,'default','52520001000',500.0000,1),(5972,'default','52660001000',500.0000,1),(5973,'default','52530001000',500.0000,1),(5974,'default','52280001000',500.0000,1),(5975,'default','Neon Shower Bath',500.0000,1),(5976,'default','52540001000',500.0000,1),(5977,'default','Optima Bath',500.0000,1),(5978,'default','50800001000',500.0000,1),(5979,'default','50810001000',500.0000,1),(5980,'default','50820001000',500.0000,1),(5981,'default','52430001000',500.0000,1),(5982,'default','54300001000',500.0000,1),(5983,'default','WBS1585',500.0000,1),(5984,'default','WBS1685',500.0000,1),(5985,'default','WBS1785',500.0000,1),(5986,'default','WBB1585',500.0000,1),(5987,'default','WBB1785',500.0000,1),(5988,'default','WBP1585',500.0000,1),(5989,'default','WBP1685',500.0000,1),(5990,'default','WBP1785',500.0000,1),(5991,'default','3473-000',496.0000,1);
/*!40000 ALTER TABLE `inventory_source_item` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_inventory_source_item_after_insert` AFTER INSERT ON `inventory_source_item` FOR EACH ROW BEGIN
INSERT IGNORE INTO `inventory_cl` (`entity_id`) VALUES (NEW.`source_item_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_inventory_source_item_after_update` AFTER UPDATE ON `inventory_source_item` FOR EACH ROW BEGIN
IF (NOT(NEW.`source_item_id` <=> OLD.`source_item_id`) OR NOT(NEW.`source_code` <=> OLD.`source_code`) OR NOT(NEW.`sku` <=> OLD.`sku`) OR NOT(NEW.`quantity` <=> OLD.`quantity`) OR NOT(NEW.`status` <=> OLD.`status`)) THEN INSERT IGNORE INTO `inventory_cl` (`entity_id`) VALUES (NEW.`source_item_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_inventory_source_item_after_delete` AFTER DELETE ON `inventory_source_item` FOR EACH ROW BEGIN
INSERT IGNORE INTO `inventory_cl` (`entity_id`) VALUES (OLD.`source_item_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `inventory_source_stock_link`
--

DROP TABLE IF EXISTS `inventory_source_stock_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `inventory_source_stock_link` (
  `link_id` int unsigned NOT NULL AUTO_INCREMENT,
  `stock_id` int unsigned NOT NULL,
  `source_code` varchar(255) NOT NULL,
  `priority` smallint unsigned NOT NULL,
  PRIMARY KEY (`link_id`),
  UNIQUE KEY `INVENTORY_SOURCE_STOCK_LINK_STOCK_ID_SOURCE_CODE` (`stock_id`,`source_code`),
  KEY `INV_SOURCE_STOCK_LNK_SOURCE_CODE_INV_SOURCE_SOURCE_CODE` (`source_code`),
  KEY `INVENTORY_SOURCE_STOCK_LINK_STOCK_ID_PRIORITY` (`stock_id`,`priority`),
  CONSTRAINT `INV_SOURCE_STOCK_LNK_SOURCE_CODE_INV_SOURCE_SOURCE_CODE` FOREIGN KEY (`source_code`) REFERENCES `inventory_source` (`source_code`) ON DELETE CASCADE,
  CONSTRAINT `INVENTORY_SOURCE_STOCK_LINK_STOCK_ID_INVENTORY_STOCK_STOCK_ID` FOREIGN KEY (`stock_id`) REFERENCES `inventory_stock` (`stock_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventory_source_stock_link`
--

LOCK TABLES `inventory_source_stock_link` WRITE;
/*!40000 ALTER TABLE `inventory_source_stock_link` DISABLE KEYS */;
INSERT INTO `inventory_source_stock_link` VALUES (1,1,'default',1);
/*!40000 ALTER TABLE `inventory_source_stock_link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventory_stock`
--

DROP TABLE IF EXISTS `inventory_stock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `inventory_stock` (
  `stock_id` int unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`stock_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventory_stock`
--

LOCK TABLES `inventory_stock` WRITE;
/*!40000 ALTER TABLE `inventory_stock` DISABLE KEYS */;
INSERT INTO `inventory_stock` VALUES (1,'Default Stock');
/*!40000 ALTER TABLE `inventory_stock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Temporary view structure for view `inventory_stock_1`
--

DROP TABLE IF EXISTS `inventory_stock_1`;
/*!50001 DROP VIEW IF EXISTS `inventory_stock_1`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `inventory_stock_1` AS SELECT 
 1 AS `product_id`,
 1 AS `website_id`,
 1 AS `stock_id`,
 1 AS `quantity`,
 1 AS `is_salable`,
 1 AS `sku`*/;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `inventory_stock_sales_channel`
--

DROP TABLE IF EXISTS `inventory_stock_sales_channel`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `inventory_stock_sales_channel` (
  `type` varchar(64) NOT NULL,
  `code` varchar(64) NOT NULL,
  `stock_id` int unsigned NOT NULL,
  PRIMARY KEY (`type`,`code`),
  KEY `INVENTORY_STOCK_SALES_CHANNEL_STOCK_ID_INVENTORY_STOCK_STOCK_ID` (`stock_id`),
  CONSTRAINT `INVENTORY_STOCK_SALES_CHANNEL_STOCK_ID_INVENTORY_STOCK_STOCK_ID` FOREIGN KEY (`stock_id`) REFERENCES `inventory_stock` (`stock_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventory_stock_sales_channel`
--

LOCK TABLES `inventory_stock_sales_channel` WRITE;
/*!40000 ALTER TABLE `inventory_stock_sales_channel` DISABLE KEYS */;
INSERT INTO `inventory_stock_sales_channel` VALUES ('website','base',1),('website','nexus_home',1),('website','premierdiy',1),('website','premierdiy_home',1);
/*!40000 ALTER TABLE `inventory_stock_sales_channel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `jwt_auth_revoked`
--

DROP TABLE IF EXISTS `jwt_auth_revoked`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `jwt_auth_revoked` (
  `user_type_id` int unsigned NOT NULL COMMENT 'User Type ID',
  `user_id` int unsigned NOT NULL COMMENT 'User ID',
  `revoke_before` bigint unsigned NOT NULL COMMENT 'Not accepting tokens issued before this timestamp',
  PRIMARY KEY (`user_type_id`,`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Holds revoked JWT authentication data';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `jwt_auth_revoked`
--

LOCK TABLES `jwt_auth_revoked` WRITE;
/*!40000 ALTER TABLE `jwt_auth_revoked` DISABLE KEYS */;
/*!40000 ALTER TABLE `jwt_auth_revoked` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `layout_link`
--

DROP TABLE IF EXISTS `layout_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `layout_link` (
  `layout_link_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Link ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `theme_id` int unsigned NOT NULL COMMENT 'Theme ID',
  `layout_update_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Layout Update ID',
  `is_temporary` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Defines whether Layout Update is Temporary',
  PRIMARY KEY (`layout_link_id`),
  KEY `LAYOUT_LINK_THEME_ID_THEME_THEME_ID` (`theme_id`),
  KEY `LAYOUT_LINK_LAYOUT_UPDATE_ID` (`layout_update_id`),
  KEY `LAYOUT_LINK_STORE_ID_THEME_ID_LAYOUT_UPDATE_ID_IS_TEMPORARY` (`store_id`,`theme_id`,`layout_update_id`,`is_temporary`),
  CONSTRAINT `LAYOUT_LINK_LAYOUT_UPDATE_ID_LAYOUT_UPDATE_LAYOUT_UPDATE_ID` FOREIGN KEY (`layout_update_id`) REFERENCES `layout_update` (`layout_update_id`) ON DELETE CASCADE,
  CONSTRAINT `LAYOUT_LINK_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `LAYOUT_LINK_THEME_ID_THEME_THEME_ID` FOREIGN KEY (`theme_id`) REFERENCES `theme` (`theme_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Layout Link';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `layout_link`
--

LOCK TABLES `layout_link` WRITE;
/*!40000 ALTER TABLE `layout_link` DISABLE KEYS */;
/*!40000 ALTER TABLE `layout_link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `layout_update`
--

DROP TABLE IF EXISTS `layout_update`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `layout_update` (
  `layout_update_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Layout Update ID',
  `handle` varchar(255) DEFAULT NULL COMMENT 'Handle',
  `xml` text COMMENT 'Xml',
  `sort_order` smallint NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `updated_at` timestamp NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP COMMENT 'Last Update Timestamp',
  PRIMARY KEY (`layout_update_id`),
  KEY `LAYOUT_UPDATE_HANDLE` (`handle`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Layout Updates';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `layout_update`
--

LOCK TABLES `layout_update` WRITE;
/*!40000 ALTER TABLE `layout_update` DISABLE KEYS */;
/*!40000 ALTER TABLE `layout_update` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `login_as_customer`
--

DROP TABLE IF EXISTS `login_as_customer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `login_as_customer` (
  `secret` varchar(64) NOT NULL COMMENT 'Login Secret',
  `customer_id` int NOT NULL COMMENT 'Customer ID',
  `admin_id` int NOT NULL COMMENT 'Admin ID',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Creation Time',
  PRIMARY KEY (`secret`),
  KEY `LOGIN_AS_CUSTOMER_CREATED_AT` (`created_at`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magento Login as Customer Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `login_as_customer`
--

LOCK TABLES `login_as_customer` WRITE;
/*!40000 ALTER TABLE `login_as_customer` DISABLE KEYS */;
/*!40000 ALTER TABLE `login_as_customer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `login_as_customer_assistance_allowed`
--

DROP TABLE IF EXISTS `login_as_customer_assistance_allowed`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `login_as_customer_assistance_allowed` (
  `customer_id` int unsigned NOT NULL COMMENT 'Customer ID',
  PRIMARY KEY (`customer_id`),
  CONSTRAINT `LOGIN_AS_CSTR_ASSISTANCE_ALLOWED_CSTR_ID_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magento Login as Customer Assistance Allowed Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `login_as_customer_assistance_allowed`
--

LOCK TABLES `login_as_customer_assistance_allowed` WRITE;
/*!40000 ALTER TABLE `login_as_customer_assistance_allowed` DISABLE KEYS */;
/*!40000 ALTER TABLE `login_as_customer_assistance_allowed` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magefan_blog_category`
--

DROP TABLE IF EXISTS `magefan_blog_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magefan_blog_category` (
  `category_id` int NOT NULL AUTO_INCREMENT COMMENT 'Category ID',
  `title` varchar(255) DEFAULT NULL COMMENT 'Category Title',
  `meta_title` varchar(255) DEFAULT NULL COMMENT 'Category Meta Title',
  `meta_keywords` text COMMENT 'Category Meta Keywords',
  `meta_description` text COMMENT 'Category Meta Description',
  `meta_robots` varchar(255) DEFAULT NULL COMMENT 'Default Robots',
  `identifier` varchar(100) DEFAULT NULL COMMENT 'Category String Identifier',
  `content_heading` varchar(255) DEFAULT NULL COMMENT 'Category Content Heading',
  `content` mediumtext COMMENT 'Category Content',
  `path` varchar(255) DEFAULT NULL COMMENT 'Category Path',
  `position` smallint NOT NULL COMMENT 'Category Position',
  `posts_sort_by` smallint NOT NULL DEFAULT '0' COMMENT 'Post Sort By',
  `include_in_menu` smallint DEFAULT NULL COMMENT 'Category In Menu',
  `include_in_sidebar_tree` varchar(255) DEFAULT '1' COMMENT 'Category In Sidebar Tree',
  `is_active` smallint NOT NULL DEFAULT '1' COMMENT 'Is Category Active',
  `display_mode` smallint NOT NULL DEFAULT '0' COMMENT 'Display Mode',
  `page_layout` varchar(255) DEFAULT NULL COMMENT 'Post Layout',
  `layout_update_xml` text COMMENT 'Post Layout Update Content',
  `custom_theme` varchar(100) DEFAULT NULL COMMENT 'Post Custom Theme',
  `custom_layout` varchar(255) DEFAULT NULL COMMENT 'Post Custom Template',
  `custom_layout_update_xml` text COMMENT 'Post Custom Layout Update Content',
  `custom_theme_from` date DEFAULT NULL COMMENT 'Post Custom Theme Active From Date',
  `custom_theme_to` date DEFAULT NULL COMMENT 'Post Custom Theme Active To Date',
  `posts_per_page` int DEFAULT NULL COMMENT 'Posts Per Page',
  `posts_list_template` varchar(100) DEFAULT NULL COMMENT 'Posts List Template',
  PRIMARY KEY (`category_id`),
  KEY `MAGEFAN_BLOG_CATEGORY_IDENTIFIER` (`identifier`),
  KEY `MAGEFAN_BLOG_CATEGORY_INCLUDE_IN_MENU` (`include_in_menu`),
  KEY `MAGEFAN_BLOG_CATEGORY_IS_ACTIVE` (`is_active`),
  KEY `MAGEFAN_BLOG_CATEGORY_INCLUDE_IN_SIDEBAR_TREE` (`include_in_sidebar_tree`),
  FULLTEXT KEY `FTI_B76AD11A0A06CC3327BA3A86A016134F` (`title`,`meta_keywords`,`meta_description`,`identifier`,`content`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magefan Blog Category Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magefan_blog_category`
--

LOCK TABLES `magefan_blog_category` WRITE;
/*!40000 ALTER TABLE `magefan_blog_category` DISABLE KEYS */;
/*!40000 ALTER TABLE `magefan_blog_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magefan_blog_category_store`
--

DROP TABLE IF EXISTS `magefan_blog_category_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magefan_blog_category_store` (
  `category_id` int NOT NULL COMMENT 'Category ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  PRIMARY KEY (`category_id`,`store_id`),
  KEY `MAGEFAN_BLOG_CATEGORY_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `MAGEFAN_BLOG_CATEGORY_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEFAN_BLOG_CTGR_STORE_CTGR_ID_MAGEFAN_BLOG_CTGR_CTGR_ID` FOREIGN KEY (`category_id`) REFERENCES `magefan_blog_category` (`category_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magefan Blog Category To Store Linkage Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magefan_blog_category_store`
--

LOCK TABLES `magefan_blog_category_store` WRITE;
/*!40000 ALTER TABLE `magefan_blog_category_store` DISABLE KEYS */;
/*!40000 ALTER TABLE `magefan_blog_category_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magefan_blog_comment`
--

DROP TABLE IF EXISTS `magefan_blog_comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magefan_blog_comment` (
  `comment_id` int NOT NULL AUTO_INCREMENT COMMENT 'Comment ID',
  `parent_id` int NOT NULL COMMENT 'Parent Comment ID',
  `post_id` int NOT NULL COMMENT 'Post ID',
  `customer_id` int DEFAULT NULL COMMENT 'Customer ID',
  `admin_id` int DEFAULT NULL COMMENT 'Admin User ID',
  `status` smallint NOT NULL COMMENT 'Comment status',
  `author_type` smallint NOT NULL COMMENT 'Author Type',
  `author_nickname` varchar(255) NOT NULL COMMENT 'Comment Author Nickname',
  `author_email` varchar(255) DEFAULT NULL COMMENT 'Comment Author Email',
  `text` mediumtext COMMENT 'Text',
  `creation_time` timestamp NULL DEFAULT NULL COMMENT 'Comment Creation Time',
  `update_time` timestamp NULL DEFAULT NULL COMMENT 'Comment Update Time',
  PRIMARY KEY (`comment_id`),
  KEY `MAGEFAN_BLOG_COMMENT_PARENT_ID` (`parent_id`),
  KEY `MAGEFAN_BLOG_COMMENT_POST_ID` (`post_id`),
  KEY `MAGEFAN_BLOG_COMMENT_CUSTOMER_ID` (`customer_id`),
  KEY `MAGEFAN_BLOG_COMMENT_ADMIN_ID` (`admin_id`),
  KEY `MAGEFAN_BLOG_COMMENT_STATUS` (`status`),
  CONSTRAINT `MAGEFAN_BLOG_COMMENT_POST_ID_MAGEFAN_BLOG_POST_POST_ID` FOREIGN KEY (`post_id`) REFERENCES `magefan_blog_post` (`post_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='magefan_blog_comment';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magefan_blog_comment`
--

LOCK TABLES `magefan_blog_comment` WRITE;
/*!40000 ALTER TABLE `magefan_blog_comment` DISABLE KEYS */;
/*!40000 ALTER TABLE `magefan_blog_comment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magefan_blog_post`
--

DROP TABLE IF EXISTS `magefan_blog_post`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magefan_blog_post` (
  `post_id` int NOT NULL AUTO_INCREMENT COMMENT 'Post ID',
  `title` varchar(255) DEFAULT NULL COMMENT 'Post Title',
  `meta_title` varchar(255) DEFAULT NULL COMMENT 'Post Meta Title',
  `meta_keywords` text COMMENT 'Post Meta Keywords',
  `meta_description` text COMMENT 'Post Meta Description',
  `meta_robots` varchar(255) DEFAULT NULL COMMENT 'Default Robots',
  `structure_data_type` smallint NOT NULL DEFAULT '0' COMMENT 'Rich Snippet / Structured Data',
  `identifier` varchar(100) DEFAULT NULL COMMENT 'Post String Identifier',
  `og_title` varchar(255) DEFAULT NULL COMMENT 'Post OG Title',
  `og_description` varchar(255) DEFAULT NULL COMMENT 'Post OG Description',
  `og_img` varchar(255) DEFAULT NULL COMMENT 'Post OG Img',
  `og_type` varchar(255) DEFAULT NULL COMMENT 'Post OG Type',
  `content_heading` varchar(255) DEFAULT NULL COMMENT 'Post Content Heading',
  `content` mediumtext COMMENT 'Post Content',
  `creation_time` timestamp NULL DEFAULT NULL COMMENT 'Post Creation Time',
  `update_time` timestamp NULL DEFAULT NULL COMMENT 'Post Modification Time',
  `publish_time` timestamp NULL DEFAULT NULL COMMENT 'Post Publish Time',
  `is_active` smallint NOT NULL DEFAULT '1' COMMENT 'Is Post Active',
  `include_in_recent` smallint NOT NULL DEFAULT '1' COMMENT 'Include in Recent Posts',
  `position` smallint NOT NULL DEFAULT '0' COMMENT 'Position',
  `featured_img` varchar(255) DEFAULT NULL COMMENT 'Thumbnail Image',
  `featured_img_alt` varchar(255) DEFAULT NULL COMMENT 'Featured Image Alt',
  `author_id` int DEFAULT NULL COMMENT 'Author ID',
  `page_layout` varchar(255) DEFAULT NULL COMMENT 'Post Layout',
  `layout_update_xml` text COMMENT 'Post Layout Update Content',
  `custom_theme` varchar(100) DEFAULT NULL COMMENT 'Post Custom Theme',
  `custom_layout` varchar(255) DEFAULT NULL COMMENT 'Post Custom Template',
  `custom_layout_update_xml` text COMMENT 'Post Custom Layout Update Content',
  `custom_theme_from` date DEFAULT NULL COMMENT 'Post Custom Theme Active From Date',
  `custom_theme_to` date DEFAULT NULL COMMENT 'Post Custom Theme Active To Date',
  `media_gallery` mediumtext COMMENT 'Media Gallery',
  `secret` varchar(32) DEFAULT NULL COMMENT 'Post Secret',
  `views_count` int DEFAULT NULL COMMENT 'Post Views Count',
  `reading_time` int DEFAULT NULL COMMENT 'Post Reading Time',
  `is_recent_posts_skip` smallint DEFAULT NULL COMMENT 'Is Post Skipped From Recent Posts',
  `short_content` mediumtext COMMENT 'Post Short Content',
  `comments_count` int DEFAULT NULL COMMENT 'Post Comment Counts',
  PRIMARY KEY (`post_id`),
  KEY `MAGEFAN_BLOG_POST_IDENTIFIER` (`identifier`),
  KEY `MAGEFAN_BLOG_POST_AUTHOR_ID` (`author_id`),
  KEY `MAGEFAN_BLOG_POST_VIEWS_COUNT` (`views_count`),
  KEY `MAGEFAN_BLOG_POST_IS_RECENT_POSTS_SKIP` (`is_recent_posts_skip`),
  KEY `MAGEFAN_BLOG_POST_IS_ACTIVE` (`is_active`),
  KEY `MAGEFAN_BLOG_POST_INCLUDE_IN_RECENT` (`include_in_recent`),
  KEY `MAGEFAN_BLOG_POST_PUBLISH_TIME` (`publish_time`),
  FULLTEXT KEY `FTI_A5DB7871E89B230F74EDFBECEB4659FA` (`title`,`meta_keywords`,`meta_description`,`identifier`,`content`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COMMENT='Magefan Blog Post Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magefan_blog_post`
--

LOCK TABLES `magefan_blog_post` WRITE;
/*!40000 ALTER TABLE `magefan_blog_post` DISABLE KEYS */;
INSERT INTO `magefan_blog_post` VALUES (1,'Magento 2 Blog Post Sample',NULL,'magento 2 blog sample','Magento 2 blog default post.',NULL,0,'magento-2-blog-post-sample',NULL,NULL,NULL,NULL,'Magento 2 Blog Post Sample','<p>Welcome to  extension by .\n                        This is your first post. Edit or delete it, then start blogging!\n                </p>','2024-11-14 04:26:02','2024-11-14 04:26:02','2024-11-14 04:26:02',1,1,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0);
/*!40000 ALTER TABLE `magefan_blog_post` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magefan_blog_post_category`
--

DROP TABLE IF EXISTS `magefan_blog_post_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magefan_blog_post_category` (
  `post_id` int NOT NULL COMMENT 'Post ID',
  `category_id` int NOT NULL COMMENT 'Category ID',
  PRIMARY KEY (`post_id`,`category_id`),
  KEY `MAGEFAN_BLOG_POST_CATEGORY_CATEGORY_ID` (`category_id`),
  CONSTRAINT `MAGEFAN_BLOG_POST_CATEGORY_POST_ID_MAGEFAN_BLOG_POST_POST_ID` FOREIGN KEY (`post_id`) REFERENCES `magefan_blog_post` (`post_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEFAN_BLOG_POST_CTGR_CTGR_ID_MAGEFAN_BLOG_CTGR_CTGR_ID` FOREIGN KEY (`category_id`) REFERENCES `magefan_blog_category` (`category_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magefan Blog Post To Category Linkage Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magefan_blog_post_category`
--

LOCK TABLES `magefan_blog_post_category` WRITE;
/*!40000 ALTER TABLE `magefan_blog_post_category` DISABLE KEYS */;
/*!40000 ALTER TABLE `magefan_blog_post_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magefan_blog_post_relatedpost`
--

DROP TABLE IF EXISTS `magefan_blog_post_relatedpost`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magefan_blog_post_relatedpost` (
  `post_id` int NOT NULL COMMENT 'Post ID',
  `related_id` int NOT NULL COMMENT 'Related Post ID',
  `position` int NOT NULL COMMENT 'Position',
  PRIMARY KEY (`post_id`,`related_id`),
  KEY `MAGEFAN_BLOG_POST_RELATEDPRODUCT_RELATED_ID` (`related_id`),
  CONSTRAINT `FK_9F26E983FE1D7D7063B61D3F3C8D1104` FOREIGN KEY (`post_id`) REFERENCES `magefan_blog_post` (`post_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEFAN_BLOG_POST_RELATEDPRD1_POST_ID_MAGEFAN_BLOG_POST_POST_ID` FOREIGN KEY (`post_id`) REFERENCES `magefan_blog_post` (`post_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magefan Blog Post To Post Linkage Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magefan_blog_post_relatedpost`
--

LOCK TABLES `magefan_blog_post_relatedpost` WRITE;
/*!40000 ALTER TABLE `magefan_blog_post_relatedpost` DISABLE KEYS */;
/*!40000 ALTER TABLE `magefan_blog_post_relatedpost` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magefan_blog_post_relatedproduct`
--

DROP TABLE IF EXISTS `magefan_blog_post_relatedproduct`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magefan_blog_post_relatedproduct` (
  `post_id` int NOT NULL COMMENT 'Post ID',
  `related_id` int unsigned NOT NULL COMMENT 'Related Product ID',
  `position` int NOT NULL COMMENT 'Position',
  PRIMARY KEY (`post_id`,`related_id`),
  KEY `MAGEFAN_BLOG_POST_RELATEDPRODUCT_RELATED_ID` (`related_id`),
  CONSTRAINT `MAGEFAN_BLOG_POST_RELATEDPRD_POST_ID_MAGEFAN_BLOG_POST_POST_ID` FOREIGN KEY (`post_id`) REFERENCES `magefan_blog_post` (`post_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEFAN_BLOG_POST_RELATEDPRD_RELATED_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`related_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magefan Blog Post To Product Linkage Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magefan_blog_post_relatedproduct`
--

LOCK TABLES `magefan_blog_post_relatedproduct` WRITE;
/*!40000 ALTER TABLE `magefan_blog_post_relatedproduct` DISABLE KEYS */;
/*!40000 ALTER TABLE `magefan_blog_post_relatedproduct` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magefan_blog_post_store`
--

DROP TABLE IF EXISTS `magefan_blog_post_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magefan_blog_post_store` (
  `post_id` int NOT NULL COMMENT 'Post ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  PRIMARY KEY (`post_id`,`store_id`),
  KEY `MAGEFAN_BLOG_POST_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `MAGEFAN_BLOG_POST_STORE_POST_ID_MAGEFAN_BLOG_POST_POST_ID` FOREIGN KEY (`post_id`) REFERENCES `magefan_blog_post` (`post_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEFAN_BLOG_POST_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magefan Blog Post To Store Linkage Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magefan_blog_post_store`
--

LOCK TABLES `magefan_blog_post_store` WRITE;
/*!40000 ALTER TABLE `magefan_blog_post_store` DISABLE KEYS */;
INSERT INTO `magefan_blog_post_store` VALUES (1,0);
/*!40000 ALTER TABLE `magefan_blog_post_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magefan_blog_post_tag`
--

DROP TABLE IF EXISTS `magefan_blog_post_tag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magefan_blog_post_tag` (
  `post_id` int NOT NULL COMMENT 'Post ID',
  `tag_id` int NOT NULL COMMENT 'Tag ID',
  PRIMARY KEY (`post_id`,`tag_id`),
  KEY `MAGEFAN_BLOG_POST_TAG_TAG_ID` (`tag_id`),
  CONSTRAINT `MAGEFAN_BLOG_POST_TAG_POST_ID_MAGEFAN_BLOG_POST_POST_ID` FOREIGN KEY (`post_id`) REFERENCES `magefan_blog_post` (`post_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEFAN_BLOG_POST_TAG_TAG_ID_MAGEFAN_BLOG_TAG_TAG_ID` FOREIGN KEY (`tag_id`) REFERENCES `magefan_blog_tag` (`tag_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magefan Blog Post To Category Linkage Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magefan_blog_post_tag`
--

LOCK TABLES `magefan_blog_post_tag` WRITE;
/*!40000 ALTER TABLE `magefan_blog_post_tag` DISABLE KEYS */;
/*!40000 ALTER TABLE `magefan_blog_post_tag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magefan_blog_tag`
--

DROP TABLE IF EXISTS `magefan_blog_tag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magefan_blog_tag` (
  `tag_id` int NOT NULL AUTO_INCREMENT COMMENT 'Tag ID',
  `title` varchar(255) DEFAULT NULL COMMENT 'Tag Title',
  `meta_robots` varchar(255) DEFAULT NULL COMMENT 'Tag Default Robots',
  `meta_description` varchar(255) DEFAULT NULL COMMENT 'Tag Meta Description',
  `meta_keywords` varchar(255) DEFAULT NULL COMMENT 'Tag Meta Keywords',
  `meta_title` varchar(255) DEFAULT NULL COMMENT 'Tag Meta Title',
  `identifier` varchar(100) DEFAULT NULL COMMENT 'Tag String Identifier',
  `page_layout` varchar(255) DEFAULT NULL COMMENT 'Tag Layout',
  `is_active` smallint NOT NULL DEFAULT '1' COMMENT 'Is Tag Active',
  `content` mediumtext COMMENT 'Tag Content',
  `layout_update_xml` text COMMENT 'Tag Layout Update Content',
  `custom_theme` varchar(100) DEFAULT NULL COMMENT 'Tag Custom Theme',
  `custom_layout` varchar(255) DEFAULT NULL COMMENT 'Tag Custom Template',
  `custom_layout_update_xml` text COMMENT 'Tag Custom Layout Update Content',
  `custom_theme_from` date DEFAULT NULL COMMENT 'Tag Custom Theme Active From Date',
  `custom_theme_to` date DEFAULT NULL COMMENT 'Tag Custom Theme Active To Date',
  `posts_per_page` int DEFAULT NULL COMMENT 'Posts Per Page',
  `posts_list_template` varchar(100) DEFAULT NULL COMMENT 'Posts List Template',
  PRIMARY KEY (`tag_id`),
  KEY `MAGEFAN_BLOG_TAG_IDENTIFIER` (`identifier`),
  KEY `MAGEFAN_BLOG_TAG_IS_ACTIVE` (`is_active`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magefan Blog Tag Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magefan_blog_tag`
--

LOCK TABLES `magefan_blog_tag` WRITE;
/*!40000 ALTER TABLE `magefan_blog_tag` DISABLE KEYS */;
/*!40000 ALTER TABLE `magefan_blog_tag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magefan_blog_tag_store`
--

DROP TABLE IF EXISTS `magefan_blog_tag_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magefan_blog_tag_store` (
  `tag_id` int NOT NULL COMMENT 'Tag ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  PRIMARY KEY (`tag_id`,`store_id`),
  KEY `MAGEFAN_BLOG_TAG_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `MAGEFAN_BLOG_TAG_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEFAN_BLOG_TAG_STORE_TAG_ID_MAGEFAN_BLOG_TAG_TAG_ID` FOREIGN KEY (`tag_id`) REFERENCES `magefan_blog_tag` (`tag_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magefan Blog Tag To Store Linkage Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magefan_blog_tag_store`
--

LOCK TABLES `magefan_blog_tag_store` WRITE;
/*!40000 ALTER TABLE `magefan_blog_tag_store` DISABLE KEYS */;
/*!40000 ALTER TABLE `magefan_blog_tag_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magento_acknowledged_bulk`
--

DROP TABLE IF EXISTS `magento_acknowledged_bulk`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magento_acknowledged_bulk` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Internal ID',
  `bulk_uuid` varbinary(39) DEFAULT NULL COMMENT 'Related Bulk UUID',
  PRIMARY KEY (`id`),
  UNIQUE KEY `MAGENTO_ACKNOWLEDGED_BULK_BULK_UUID` (`bulk_uuid`),
  CONSTRAINT `MAGENTO_ACKNOWLEDGED_BULK_BULK_UUID_MAGENTO_BULK_UUID` FOREIGN KEY (`bulk_uuid`) REFERENCES `magento_bulk` (`uuid`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COMMENT='Bulk that was viewed by user from notification area';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magento_acknowledged_bulk`
--

LOCK TABLES `magento_acknowledged_bulk` WRITE;
/*!40000 ALTER TABLE `magento_acknowledged_bulk` DISABLE KEYS */;
INSERT INTO `magento_acknowledged_bulk` VALUES (1,_binary '5f5b46fe-7a22-4d92-b9b8-df488e2258d8'),(2,_binary '8c0075cd-dfa7-40e2-a1ff-01eb5ae8793c'),(4,_binary '94a31f6b-e45b-495f-a9c5-f58c4f32525a'),(3,_binary 'aae32a43-5716-408b-b5c9-1ccd37898c08');
/*!40000 ALTER TABLE `magento_acknowledged_bulk` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magento_bulk`
--

DROP TABLE IF EXISTS `magento_bulk`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magento_bulk` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Bulk Internal ID (must not be exposed)',
  `uuid` varbinary(39) DEFAULT NULL COMMENT 'Bulk UUID (can be exposed to reference bulk entity)',
  `user_id` int unsigned DEFAULT NULL COMMENT 'ID of the WebAPI user that performed an action',
  `user_type` int DEFAULT NULL COMMENT 'Which type of user',
  `description` varchar(255) DEFAULT NULL COMMENT 'Bulk Description',
  `operation_count` int unsigned NOT NULL COMMENT 'Total number of operations scheduled within this bulk',
  `start_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Bulk start time',
  PRIMARY KEY (`id`),
  UNIQUE KEY `MAGENTO_BULK_UUID` (`uuid`),
  KEY `MAGENTO_BULK_USER_ID` (`user_id`),
  KEY `MAGENTO_BULK_START_TIME` (`start_time`)
) ENGINE=InnoDB AUTO_INCREMENT=42 DEFAULT CHARSET=utf8mb3 COMMENT='Bulk entity that represents set of related asynchronous operations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magento_bulk`
--

LOCK TABLES `magento_bulk` WRITE;
/*!40000 ALTER TABLE `magento_bulk` DISABLE KEYS */;
INSERT INTO `magento_bulk` VALUES (37,_binary 'f54a0cb6-84c7-481e-a7a3-e6d67e036b22',1,2,'Synchronize website specific attributes values',1,'2024-12-11 11:06:53'),(38,_binary '8c0075cd-dfa7-40e2-a1ff-01eb5ae8793c',5,2,'Synchronize website specific attributes values',1,'2025-01-24 13:59:15'),(39,_binary 'aae32a43-5716-408b-b5c9-1ccd37898c08',5,2,'Synchronize website specific attributes values',1,'2025-01-28 06:56:54'),(40,_binary '94a31f6b-e45b-495f-a9c5-f58c4f32525a',5,2,'Synchronize website specific attributes values',1,'2025-02-03 08:24:01'),(41,_binary '5f5b46fe-7a22-4d92-b9b8-df488e2258d8',5,2,'Update attributes for 20 selected products',1,'2025-02-04 09:55:24');
/*!40000 ALTER TABLE `magento_bulk` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magento_login_as_customer_log`
--

DROP TABLE IF EXISTS `magento_login_as_customer_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magento_login_as_customer_log` (
  `log_id` int NOT NULL AUTO_INCREMENT COMMENT 'Log Id',
  `time` timestamp NULL DEFAULT NULL COMMENT 'Event Date',
  `user_id` int unsigned DEFAULT NULL COMMENT 'User Id',
  `user_name` varchar(40) DEFAULT NULL COMMENT 'User Name',
  `customer_id` int unsigned DEFAULT NULL COMMENT 'Customer Id',
  `customer_email` varchar(40) DEFAULT NULL COMMENT 'Customer email',
  PRIMARY KEY (`log_id`),
  KEY `MAGENTO_LOGIN_AS_CUSTOMER_LOG_USER_ID` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Login as Customer Logging';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magento_login_as_customer_log`
--

LOCK TABLES `magento_login_as_customer_log` WRITE;
/*!40000 ALTER TABLE `magento_login_as_customer_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `magento_login_as_customer_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magento_operation`
--

DROP TABLE IF EXISTS `magento_operation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magento_operation` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Operation ID',
  `operation_key` int unsigned DEFAULT NULL COMMENT 'Operation Key',
  `bulk_uuid` varbinary(39) DEFAULT NULL COMMENT 'Related Bulk UUID',
  `topic_name` varchar(255) DEFAULT NULL COMMENT 'Name of the related message queue topic',
  `serialized_data` blob COMMENT 'Data (serialized) required to perform an operation',
  `result_serialized_data` blob COMMENT 'Result data (serialized) after perform an operation',
  `status` smallint DEFAULT '0' COMMENT 'Operation status (OPEN | COMPLETE | RETRIABLY_FAILED | NOT_RETRIABLY_FAILED)',
  `error_code` smallint DEFAULT NULL COMMENT 'Code of the error that appeared during operation execution (used to aggregate related failed operations)',
  `result_message` varchar(255) DEFAULT NULL COMMENT 'Operation result message',
  `started_at` timestamp NULL DEFAULT NULL COMMENT 'Datetime the operation started processing',
  PRIMARY KEY (`id`),
  KEY `MAGENTO_OPERATION_BULK_UUID_ERROR_CODE` (`bulk_uuid`,`error_code`),
  KEY `MAGENTO_OPERATION_STATUS_STARTED_AT` (`status`,`started_at`),
  CONSTRAINT `MAGENTO_OPERATION_BULK_UUID_MAGENTO_BULK_UUID` FOREIGN KEY (`bulk_uuid`) REFERENCES `magento_bulk` (`uuid`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=42 DEFAULT CHARSET=utf8mb3 COMMENT='Operation entity';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magento_operation`
--

LOCK TABLES `magento_operation` WRITE;
/*!40000 ALTER TABLE `magento_operation` DISABLE KEYS */;
INSERT INTO `magento_operation` VALUES (18,NULL,_binary 'f54a0cb6-84c7-481e-a7a3-e6d67e036b22','catalog_website_attribute_value_sync',_binary '{\"store_id\":2}',NULL,1,NULL,NULL,NULL),(22,NULL,_binary '8c0075cd-dfa7-40e2-a1ff-01eb5ae8793c','catalog_website_attribute_value_sync',_binary '{\"store_id\":3}',NULL,1,NULL,NULL,NULL),(27,NULL,_binary 'aae32a43-5716-408b-b5c9-1ccd37898c08','catalog_website_attribute_value_sync',_binary '{\"store_id\":4}',NULL,1,NULL,NULL,NULL),(34,NULL,_binary '94a31f6b-e45b-495f-a9c5-f58c4f32525a','catalog_website_attribute_value_sync',_binary '{\"store_id\":5}',NULL,1,NULL,NULL,NULL),(41,NULL,_binary '5f5b46fe-7a22-4d92-b9b8-df488e2258d8','product_action_attribute.website.update',_binary '{\"meta_information\":\"Update website assign\",\"product_ids\":[\"5760\",\"6035\",\"6036\",\"6037\",\"6038\",\"6039\",\"6040\",\"6041\",\"6042\",\"6043\",\"6044\",\"6045\",\"6046\",\"6047\",\"6048\",\"6049\",\"6050\",\"6051\",\"6052\",\"6053\"],\"store_id\":0,\"website_id\":\"0\",\"attributes\":{\"website_assign\":[\"1\",\"2\",\"3\",\"4\"],\"website_detach\":[]}}',NULL,1,NULL,NULL,NULL);
/*!40000 ALTER TABLE `magento_operation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageplaza_fbt_product_link`
--

DROP TABLE IF EXISTS `mageplaza_fbt_product_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageplaza_fbt_product_link` (
  `link_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Link ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `linked_product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Linked Product ID',
  `position` int NOT NULL DEFAULT '0' COMMENT 'Position',
  PRIMARY KEY (`link_id`),
  UNIQUE KEY `MAGEPLAZA_FBT_PRODUCT_LINK_PRODUCT_ID_LINKED_PRODUCT_ID` (`product_id`,`linked_product_id`),
  KEY `MAGEPLAZA_FBT_PRODUCT_LINK_PRODUCT_ID` (`product_id`),
  KEY `MAGEPLAZA_FBT_PRODUCT_LINK_LINKED_PRODUCT_ID` (`linked_product_id`),
  CONSTRAINT `MAGEPLAZA_FBT_PRD_LNK_LNKED_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`linked_product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEPLAZA_FBT_PRD_LNK_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Frequently Bought Together Product To Product Linkage Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageplaza_fbt_product_link`
--

LOCK TABLES `mageplaza_fbt_product_link` WRITE;
/*!40000 ALTER TABLE `mageplaza_fbt_product_link` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageplaza_fbt_product_link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageplaza_smtp_abandonedcart`
--

DROP TABLE IF EXISTS `mageplaza_smtp_abandonedcart`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageplaza_smtp_abandonedcart` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Log Id',
  `log_ids` varchar(255) DEFAULT NULL COMMENT 'Log Ids',
  `token` varchar(255) DEFAULT NULL COMMENT 'Token',
  `quote_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Quote Id',
  `status` smallint NOT NULL COMMENT 'Status',
  `created_at` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  PRIMARY KEY (`id`),
  KEY `MAGEPLAZA_SMTP_ABANDONEDCART_QUOTE_ID_QUOTE_ENTITY_ID` (`quote_id`),
  CONSTRAINT `MAGEPLAZA_SMTP_ABANDONEDCART_QUOTE_ID_QUOTE_ENTITY_ID` FOREIGN KEY (`quote_id`) REFERENCES `quote` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='SMTP Abandoned Cart';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageplaza_smtp_abandonedcart`
--

LOCK TABLES `mageplaza_smtp_abandonedcart` WRITE;
/*!40000 ALTER TABLE `mageplaza_smtp_abandonedcart` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageplaza_smtp_abandonedcart` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageplaza_smtp_log`
--

DROP TABLE IF EXISTS `mageplaza_smtp_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageplaza_smtp_log` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Log ID',
  `subject` varchar(255) DEFAULT NULL COMMENT 'Email Subject',
  `email_content` text COMMENT 'Email Content',
  `status` smallint NOT NULL COMMENT 'Status',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `sender` varchar(255) DEFAULT NULL COMMENT 'Sender',
  `recipient` varchar(255) DEFAULT NULL COMMENT 'Recipient',
  `cc` varchar(255) DEFAULT NULL COMMENT 'Cc',
  `bcc` varchar(255) DEFAULT NULL COMMENT 'Bcc',
  PRIMARY KEY (`id`),
  KEY `MAGEPLAZA_SMTP_LOG_STATUS` (`status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='mageplaza_smtp_log';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageplaza_smtp_log`
--

LOCK TABLES `mageplaza_smtp_log` WRITE;
/*!40000 ALTER TABLE `mageplaza_smtp_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageplaza_smtp_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magepsycho_massimporterpro_import_data`
--

DROP TABLE IF EXISTS `magepsycho_massimporterpro_import_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magepsycho_massimporterpro_import_data` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id',
  `entity` varchar(50) NOT NULL COMMENT 'Entity',
  `behavior` varchar(10) NOT NULL DEFAULT 'append' COMMENT 'Behavior',
  `data` longtext COMMENT 'Data',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MIP Import Data Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magepsycho_massimporterpro_import_data`
--

LOCK TABLES `magepsycho_massimporterpro_import_data` WRITE;
/*!40000 ALTER TABLE `magepsycho_massimporterpro_import_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `magepsycho_massimporterpro_import_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magepsycho_massimporterpro_import_history`
--

DROP TABLE IF EXISTS `magepsycho_massimporterpro_import_history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magepsycho_massimporterpro_import_history` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'History Record Id',
  `started_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Started At',
  `entity` varchar(50) NOT NULL COMMENT 'Entity',
  `imported_via` varchar(50) NOT NULL COMMENT 'Imported Via',
  `import_source` varchar(50) NOT NULL COMMENT 'Import Source',
  `user_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'User ID',
  `imported_file` varchar(255) DEFAULT NULL COMMENT 'Imported File',
  `execution_time` varchar(255) DEFAULT NULL COMMENT 'Execution Time',
  `summary` varchar(255) DEFAULT NULL COMMENT 'Summary',
  `error_file` varchar(255) NOT NULL COMMENT 'Imported File with Errors',
  PRIMARY KEY (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Import history table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magepsycho_massimporterpro_import_history`
--

LOCK TABLES `magepsycho_massimporterpro_import_history` WRITE;
/*!40000 ALTER TABLE `magepsycho_massimporterpro_import_history` DISABLE KEYS */;
/*!40000 ALTER TABLE `magepsycho_massimporterpro_import_history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_dynamic_options`
--

DROP TABLE IF EXISTS `mageworx_dynamic_options`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_dynamic_options` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `product_id` int unsigned NOT NULL COMMENT 'Product ID',
  `option_id` int unsigned NOT NULL COMMENT 'Option ID',
  `step` decimal(10,2) unsigned DEFAULT NULL COMMENT 'Step',
  `min_value` decimal(10,2) unsigned DEFAULT NULL COMMENT 'Min Value',
  `max_value` decimal(10,2) unsigned DEFAULT NULL COMMENT 'Max Value',
  `measurement_unit` varchar(255) NOT NULL DEFAULT 'meters' COMMENT 'Measurement Unit',
  PRIMARY KEY (`id`),
  UNIQUE KEY `MAGEWORX_DYNAMIC_OPTIONS_PRODUCT_ID_OPTION_ID` (`product_id`,`option_id`),
  KEY `MAGEWORX_DYNAMIC_OPTIONS_OPTION_ID` (`option_id`),
  CONSTRAINT `MAGEWORX_DYNAMIC_OPTS_OPT_ID_CAT_PRD_OPT_OPT_ID` FOREIGN KEY (`option_id`) REFERENCES `catalog_product_option` (`option_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Mageworx Dynamic Options Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_dynamic_options`
--

LOCK TABLES `mageworx_dynamic_options` WRITE;
/*!40000 ALTER TABLE `mageworx_dynamic_options` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_dynamic_options` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_option_dependency`
--

DROP TABLE IF EXISTS `mageworx_option_dependency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_option_dependency` (
  `dependency_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Dependency Id',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product Id',
  `group_id` int unsigned DEFAULT NULL COMMENT 'Group Id',
  `dp_child_option_id` int NOT NULL DEFAULT '0',
  `dp_child_option_type_id` int NOT NULL DEFAULT '0',
  `dp_parent_option_id` int NOT NULL DEFAULT '0',
  `dp_parent_option_type_id` int NOT NULL DEFAULT '0',
  `is_processed_dp_columns` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Processed New Columns',
  PRIMARY KEY (`dependency_id`),
  KEY `MAGEWORX_OPTION_DEPENDENCY_DP_CHILD_OPTION_ID` (`dp_child_option_id`),
  KEY `MAGEWORX_OPTION_DEPENDENCY_DP_CHILD_OPTION_TYPE_ID` (`dp_child_option_type_id`),
  KEY `MAGEWORX_OPTION_DEPENDENCY_DP_PARENT_OPTION_ID` (`dp_parent_option_id`),
  KEY `MAGEWORX_OPTION_DEPENDENCY_DP_PARENT_OPTION_TYPE_ID` (`dp_parent_option_type_id`),
  KEY `MAGEWORX_OPT_DEPENDENCY_PRD_ID_CAT_PRD_ENTT_ENTT_ID` (`product_id`),
  CONSTRAINT `MAGEWORX_OPT_DEPENDENCY_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_option_dependency`
--

LOCK TABLES `mageworx_option_dependency` WRITE;
/*!40000 ALTER TABLE `mageworx_option_dependency` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_option_dependency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optionadvancedpricing_option_type_special_price`
--

DROP TABLE IF EXISTS `mageworx_optionadvancedpricing_option_type_special_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optionadvancedpricing_option_type_special_price` (
  `option_type_special_price_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type Special Price ID',
  `mageworx_option_type_id` varchar(40) DEFAULT 'null' COMMENT 'MageWorx Option Type ID',
  `option_type_id` int unsigned NOT NULL COMMENT 'Option Type ID',
  `customer_group_id` int unsigned NOT NULL COMMENT 'Customer Group ID',
  `price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Special Price',
  `price_type` varchar(40) NOT NULL DEFAULT 'fixed' COMMENT 'Special Price Type (fixed, percentage_discount)',
  `comment` varchar(255) NOT NULL DEFAULT '' COMMENT 'Special Price Comment',
  `date_from` date DEFAULT NULL COMMENT 'Special Price Date From',
  `date_to` date DEFAULT NULL COMMENT 'Special Price Date To',
  PRIMARY KEY (`option_type_special_price_id`),
  KEY `MAGEWORX_OPTADVANCEDPRICING_OPT_TYPE_SPECIAL_PRICE_OPT_TYPE_ID` (`option_type_id`),
  CONSTRAINT `FK_22F5BC49C97D769B8BC23E3B4B42BF1C` FOREIGN KEY (`option_type_id`) REFERENCES `catalog_product_option_type_value` (`option_type_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optionadvancedpricing_option_type_special_price`
--

LOCK TABLES `mageworx_optionadvancedpricing_option_type_special_price` WRITE;
/*!40000 ALTER TABLE `mageworx_optionadvancedpricing_option_type_special_price` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optionadvancedpricing_option_type_special_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optionadvancedpricing_option_type_tier_price`
--

DROP TABLE IF EXISTS `mageworx_optionadvancedpricing_option_type_tier_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optionadvancedpricing_option_type_tier_price` (
  `option_type_tier_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type Special Price ID',
  `mageworx_option_type_id` varchar(40) DEFAULT 'null' COMMENT 'MageWorx Option Type ID',
  `option_type_id` int unsigned NOT NULL COMMENT 'Option Type ID',
  `customer_group_id` int unsigned NOT NULL COMMENT 'Customer Group ID',
  `qty` int unsigned NOT NULL COMMENT 'Tier Price Qty',
  `price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Special Price',
  `price_type` varchar(40) NOT NULL DEFAULT 'fixed' COMMENT 'Tier Price Type (fixed, percentage_discount)',
  `date_from` date DEFAULT NULL COMMENT 'Tier Price Date From',
  `date_to` date DEFAULT NULL COMMENT 'Tier Price Date To',
  PRIMARY KEY (`option_type_tier_id`),
  KEY `MAGEWORX_OPTADVANCEDPRICING_OPT_TYPE_TIER_PRICE_OPT_TYPE_ID` (`option_type_id`),
  CONSTRAINT `FK_934663E91DD45B9A64075FDF3E9E73E3` FOREIGN KEY (`option_type_id`) REFERENCES `catalog_product_option_type_value` (`option_type_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optionadvancedpricing_option_type_tier_price`
--

LOCK TABLES `mageworx_optionadvancedpricing_option_type_tier_price` WRITE;
/*!40000 ALTER TABLE `mageworx_optionadvancedpricing_option_type_tier_price` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optionadvancedpricing_option_type_tier_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optionbase_product_attributes`
--

DROP TABLE IF EXISTS `mageworx_optionbase_product_attributes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optionbase_product_attributes` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `dependency_rules` mediumtext NOT NULL COMMENT 'Dependency Rules (Added by MageWorx_OptionDependency)',
  `hidden_dependents` text NOT NULL COMMENT 'Precalculated Hidden Dependents (Added by MageWorx_OptionDependency)',
  `absolute_price` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Absolute Price Flag',
  `absolute_weight` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Absolute Weight Flag',
  `absolute_cost` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Absolute Cost Flag',
  `hide_additional_product_price` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Hide Additional Product Price Flag',
  `shareable_link` varchar(20) NOT NULL DEFAULT 'use_config' COMMENT 'Shareable Link (added by MageWorx_OptionFeatures)',
  `sku_policy` varchar(20) NOT NULL DEFAULT 'use_config' COMMENT 'SKU Policy (added by MageWorx Option Sku Policy)',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `MAGEWORX_OPTIONBASE_PRODUCT_ATTRIBUTES_PRODUCT_ID` (`product_id`),
  CONSTRAINT `MAGEWORX_OPTBASE_PRD_ATTRS_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optionbase_product_attributes`
--

LOCK TABLES `mageworx_optionbase_product_attributes` WRITE;
/*!40000 ALTER TABLE `mageworx_optionbase_product_attributes` DISABLE KEYS */;
INSERT INTO `mageworx_optionbase_product_attributes` VALUES (2,5760,'[]','{\"hidden_options\":[],\"hidden_values\":[],\"preselected_values\":[]}',0,0,0,0,'use_config','use_config'),(10,6036,'[]','{\"hidden_options\":[],\"hidden_values\":[],\"preselected_values\":[]}',0,0,0,0,'use_config','use_config'),(11,6035,'[]','{\"hidden_options\":[],\"hidden_values\":[],\"preselected_values\":[]}',0,0,0,0,'use_config','use_config');
/*!40000 ALTER TABLE `mageworx_optionbase_product_attributes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optionfeatures_option_description`
--

DROP TABLE IF EXISTS `mageworx_optionfeatures_option_description`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optionfeatures_option_description` (
  `option_description_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Description ID',
  `mageworx_option_id` varchar(40) DEFAULT 'null' COMMENT 'MageWorx Option ID',
  `option_id` int unsigned DEFAULT NULL COMMENT 'Option  ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `description` text COMMENT 'Description',
  PRIMARY KEY (`option_description_id`),
  UNIQUE KEY `MAGEWORX_OPTIONFEATURES_OPTION_DESCRIPTION_OPTION_ID_STORE_ID` (`option_id`,`store_id`),
  KEY `MAGEWORX_OPTIONFEATURES_OPTION_DESCRIPTION_STORE_ID` (`store_id`),
  KEY `MAGEWORX_OPTIONFEATURES_OPTION_DESCRIPTION_OPTION_ID` (`option_id`),
  CONSTRAINT `MAGEWORX_OPTFEATURES_OPT_DESCRIPTION_OPT_ID_CAT_PRD_OPT_OPT_ID` FOREIGN KEY (`option_id`) REFERENCES `catalog_product_option` (`option_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_OPTFEATURES_OPT_DESCRIPTION_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optionfeatures_option_description`
--

LOCK TABLES `mageworx_optionfeatures_option_description` WRITE;
/*!40000 ALTER TABLE `mageworx_optionfeatures_option_description` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optionfeatures_option_description` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optionfeatures_option_type_description`
--

DROP TABLE IF EXISTS `mageworx_optionfeatures_option_type_description`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optionfeatures_option_type_description` (
  `option_type_description_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type Description ID',
  `mageworx_option_type_id` varchar(40) DEFAULT 'null' COMMENT 'MageWorx Option Type ID',
  `option_type_id` int unsigned DEFAULT NULL COMMENT 'Option Type ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `description` text COMMENT 'Description',
  PRIMARY KEY (`option_type_description_id`),
  UNIQUE KEY `MAGEWORX_OPTFEATURES_OPT_TYPE_DESCRIPTION_OPT_TYPE_ID_STORE_ID` (`option_type_id`,`store_id`),
  KEY `MAGEWORX_OPTIONFEATURES_OPTION_TYPE_DESCRIPTION_STORE_ID` (`store_id`),
  KEY `MAGEWORX_OPTIONFEATURES_OPTION_TYPE_DESCRIPTION_OPTION_TYPE_ID` (`option_type_id`),
  CONSTRAINT `FK_2C15EADD1DD5D6C5E0E61DDFB5C2981B` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_316CA178C7252B45EA5232F8B6DD4437` FOREIGN KEY (`option_type_id`) REFERENCES `catalog_product_option_type_value` (`option_type_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optionfeatures_option_type_description`
--

LOCK TABLES `mageworx_optionfeatures_option_type_description` WRITE;
/*!40000 ALTER TABLE `mageworx_optionfeatures_option_type_description` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optionfeatures_option_type_description` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optionfeatures_option_type_image`
--

DROP TABLE IF EXISTS `mageworx_optionfeatures_option_type_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optionfeatures_option_type_image` (
  `option_type_id` int unsigned DEFAULT NULL COMMENT 'Option Type ID',
  `option_type_image_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type Image ID',
  `mageworx_option_type_id` varchar(40) DEFAULT '0' COMMENT 'MageWorx Option Type ID',
  `media_type` varchar(32) DEFAULT 'image' COMMENT 'Media Type',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value',
  `title_text` varchar(255) DEFAULT NULL COMMENT 'Title Text',
  `sort_order` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `base_image` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Base Image',
  `tooltip_image` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Tooltip Image',
  `overlay_image` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Overlay Image',
  `color` varchar(6) DEFAULT NULL COMMENT 'color',
  `replace_main_gallery_image` smallint DEFAULT '0' COMMENT 'Use for replacement of the main image in the product gallery (product view page)',
  `disabled` smallint NOT NULL DEFAULT '0' COMMENT 'Should be displayed this image in the Option Gallery or not?',
  PRIMARY KEY (`option_type_image_id`),
  KEY `MAGEWORX_OPTIONFEATURES_OPTION_TYPE_IMAGE_OPTION_TYPE_ID` (`option_type_id`),
  KEY `MAGEWORX_OPTFEATURES_OPT_TYPE_IMAGE_OPT_TYPE_ID_TOOLTIP_IMAGE` (`option_type_id`,`tooltip_image`),
  KEY `MAGEWORX_OPTFEATURES_OPT_TYPE_IMAGE_OPT_TYPE_ID_BASE_IMAGE` (`option_type_id`,`base_image`),
  CONSTRAINT `FK_5DE1F80CFFC2267A0C0FCAF990DCFFBE` FOREIGN KEY (`option_type_id`) REFERENCES `catalog_product_option_type_value` (`option_type_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optionfeatures_option_type_image`
--

LOCK TABLES `mageworx_optionfeatures_option_type_image` WRITE;
/*!40000 ALTER TABLE `mageworx_optionfeatures_option_type_image` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optionfeatures_option_type_image` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optionfeatures_option_type_is_default`
--

DROP TABLE IF EXISTS `mageworx_optionfeatures_option_type_is_default`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optionfeatures_option_type_is_default` (
  `option_type_id` int unsigned DEFAULT NULL COMMENT 'Option Type ID',
  `option_type_is_default_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Is Default ID',
  `mageworx_option_type_id` varchar(40) DEFAULT 'null' COMMENT 'MageWorx Option Type ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `is_default` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Is Default',
  PRIMARY KEY (`option_type_is_default_id`),
  UNIQUE KEY `MAGEWORX_OPTFEATURES_OPT_TYPE_IS_DEFAULT_OPT_TYPE_ID_STORE_ID` (`option_type_id`,`store_id`),
  KEY `MAGEWORX_OPTIONFEATURES_OPTION_TYPE_IS_DEFAULT_OPTION_TYPE_ID` (`option_type_id`),
  KEY `MAGEWORX_OPTIONFEATURES_OPTION_TYPE_IS_DEFAULT_STORE_ID` (`store_id`),
  CONSTRAINT `FK_DA48580A57EF3BBF8C9869E3ACE0E38A` FOREIGN KEY (`option_type_id`) REFERENCES `catalog_product_option_type_value` (`option_type_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_OPTFEATURES_OPT_TYPE_IS_DEFAULT_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optionfeatures_option_type_is_default`
--

LOCK TABLES `mageworx_optionfeatures_option_type_is_default` WRITE;
/*!40000 ALTER TABLE `mageworx_optionfeatures_option_type_is_default` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optionfeatures_option_type_is_default` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_group`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_group` (
  `dependency_rules` mediumtext NOT NULL COMMENT 'Dependency Rules (Added by MageWorx_OptionDependency)',
  `hidden_dependents` text NOT NULL COMMENT 'Precalculated Hidden Dependents (Added by MageWorx_OptionDependency)',
  `absolute_price` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Absolute Price Flag',
  `absolute_weight` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Absolute Weight Flag',
  `absolute_cost` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Absolute Cost Flag',
  `hide_additional_product_price` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Hide Additional Product Price Flag',
  `shareable_link` varchar(20) NOT NULL DEFAULT 'use_config' COMMENT 'Shareable Link (added by MageWorx_OptionFeatures)',
  `group_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Group ID',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Title',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Last Modify Date',
  `is_active` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Active',
  `sku_policy` varchar(20) NOT NULL DEFAULT 'use_config' COMMENT 'SKU Policy (added by MageWorx Option Sku Policy)',
  PRIMARY KEY (`group_id`),
  FULLTEXT KEY `MAGEWORX_OPTIONTEMPLATES_GROUP_TITLE` (`title`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_group`
--

LOCK TABLES `mageworx_optiontemplates_group` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_group_option`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_group_option`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_group_option` (
  `option_title_id` varchar(255) NOT NULL COMMENT 'Option Title Identifier (added by MageWorx Option Dependency)',
  `dependency_type` smallint NOT NULL DEFAULT '0' COMMENT 'Option Dependency Type (added by MageWorx Option Dependency)',
  `qty_input` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Qty Input Flag (added by MageWorx_OptionFeatures)',
  `one_time` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'One Time Option Flag (added by MageWorx_OptionFeatures)',
  `div_class` varchar(255) NOT NULL COMMENT 'Option Div Class (added by MageWorx_OptionFeatures)',
  `mageworx_option_gallery` smallint NOT NULL DEFAULT '0' COMMENT 'MageWorx option gallery display type (added by MageWorx_OptionFeatures)',
  `mageworx_option_image_mode` smallint NOT NULL DEFAULT '0' COMMENT 'Option image mode (added by MageWorx_OptionFeatures)',
  `selection_limit_from` smallint NOT NULL DEFAULT '0' COMMENT 'Option Selection Limit From (added by MageWorx_OptionFeatures)',
  `selection_limit_to` smallint NOT NULL DEFAULT '0' COMMENT 'Option Selection Limit To (added by MageWorx_OptionFeatures)',
  `is_hidden` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Is Hidden Flag (added by MageWorx_OptionFeatures)',
  `group_option_id` int unsigned DEFAULT NULL COMMENT 'Group Option Id (added by MageWorx OptionTemplates)',
  `option_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option ID',
  `group_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Group ID',
  `type` varchar(50) NOT NULL DEFAULT '0' COMMENT 'Type',
  `is_require` int unsigned NOT NULL DEFAULT '1' COMMENT 'Is Required',
  `sku` varchar(64) DEFAULT NULL COMMENT 'SKU',
  `max_characters` int unsigned DEFAULT NULL COMMENT 'Max Characters',
  `file_extension` varchar(50) DEFAULT NULL COMMENT 'File Extension',
  `image_size_x` smallint unsigned DEFAULT NULL COMMENT 'Image Size X',
  `image_size_y` smallint unsigned DEFAULT NULL COMMENT 'Image Size Y',
  `sort_order` int unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `sku_policy` varchar(20) NOT NULL DEFAULT 'use_config' COMMENT 'SKU Policy (added by MageWorx Option Sku Policy)',
  `is_swatch` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Is Swatch Flag (added by MageWorx Option Swatches)',
  `is_all_groups` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'ALL Customer Group ID (added by MageWorx Option Visibility)',
  `is_all_websites` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'ALL Store ID (added by MageWorx Option Visibility)',
  `disabled` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Disabled (added by MageWorx Option Visibility)',
  `disabled_by_values` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Disabled by values (added by MageWorx Option Visibility)',
  `hide_product_page_value_price` int unsigned NOT NULL DEFAULT '0' COMMENT 'Hide Value Price On Product Page(added by MageWorx_OptionFeatures)',
  PRIMARY KEY (`option_id`),
  KEY `MAGEWORX_OPTIONTEMPLATES_GROUP_OPTION_GROUP_ID` (`group_id`),
  CONSTRAINT `FK_DC60D8B1D794DC19AB4DC78EAA931FC7` FOREIGN KEY (`group_id`) REFERENCES `mageworx_optiontemplates_group` (`group_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_group_option`
--

LOCK TABLES `mageworx_optiontemplates_group_option` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_group_option_customer_group`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_group_option_customer_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_group_option_customer_group` (
  `visibility_customer_group_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Visibility Customer Group Id',
  `mageworx_option_id` varchar(40) DEFAULT 'null' COMMENT 'MageWorx Option ID',
  `option_id` int unsigned NOT NULL COMMENT 'Option ID',
  `customer_group_id` int unsigned NOT NULL COMMENT 'Customer Group ID',
  PRIMARY KEY (`visibility_customer_group_id`),
  KEY `MAGEWORX_OPTIONTEMPLATES_GROUP_OPTION_CUSTOMER_GROUP_OPTION_ID` (`option_id`),
  KEY `MAGEWORX_OPTTEMPLATES_GROUP_OPT_CSTR_GROUP_CSTR_GROUP_ID` (`customer_group_id`),
  CONSTRAINT `FK_40667043B67EFCB20405D0A50A33E6F6` FOREIGN KEY (`customer_group_id`) REFERENCES `customer_group` (`customer_group_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_5BE4FABB3D14EB28DABA32BF243D7558` FOREIGN KEY (`option_id`) REFERENCES `mageworx_optiontemplates_group_option` (`option_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Mageworx OptionVisibiity Option Customer Group Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_group_option_customer_group`
--

LOCK TABLES `mageworx_optiontemplates_group_option_customer_group` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_customer_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_customer_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_group_option_dependency`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_group_option_dependency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_group_option_dependency` (
  `dependency_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Dependency Id',
  `group_id` int unsigned DEFAULT NULL COMMENT 'Group Id',
  `dp_child_option_id` int NOT NULL DEFAULT '0',
  `dp_child_option_type_id` int NOT NULL DEFAULT '0',
  `dp_parent_option_id` int NOT NULL DEFAULT '0',
  `dp_parent_option_type_id` int NOT NULL DEFAULT '0',
  `is_processed_dp_columns` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Processed New Columns',
  PRIMARY KEY (`dependency_id`),
  KEY `MAGEWORX_OPTTEMPLATES_GROUP_OPT_DEPENDENCY_DP_CHILD_OPT_ID` (`dp_child_option_id`),
  KEY `MAGEWORX_OPTTEMPLATES_GROUP_OPT_DEPENDENCY_DP_CHILD_OPT_TYPE_ID` (`dp_child_option_type_id`),
  KEY `MAGEWORX_OPTTEMPLATES_GROUP_OPT_DEPENDENCY_DP_PARENT_OPT_ID` (`dp_parent_option_id`),
  KEY `MAGEWORX_OPTTEMPLATES_GROUP_OPT_DEPENDENCY_DP_PARENT_OPT_TYPE_ID` (`dp_parent_option_type_id`),
  KEY `FK_0B9E3FED5115BCB4E62DCC7309BC43FA` (`group_id`),
  CONSTRAINT `FK_0B9E3FED5115BCB4E62DCC7309BC43FA` FOREIGN KEY (`group_id`) REFERENCES `mageworx_optiontemplates_group` (`group_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_group_option_dependency`
--

LOCK TABLES `mageworx_optiontemplates_group_option_dependency` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_dependency` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_dependency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_group_option_description`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_group_option_description`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_group_option_description` (
  `option_description_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Description ID',
  `mageworx_option_id` varchar(40) DEFAULT 'null' COMMENT 'MageWorx Option ID',
  `option_id` int unsigned DEFAULT NULL COMMENT 'Option  ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `description` text COMMENT 'Description',
  PRIMARY KEY (`option_description_id`),
  UNIQUE KEY `MAGEWORX_OPTTEMPLATES_GROUP_OPT_DESCRIPTION_OPT_ID_STORE_ID` (`option_id`,`store_id`),
  KEY `MAGEWORX_OPTIONTEMPLATES_GROUP_OPTION_DESCRIPTION_STORE_ID` (`store_id`),
  KEY `MAGEWORX_OPTIONTEMPLATES_GROUP_OPTION_DESCRIPTION_OPTION_ID` (`option_id`),
  CONSTRAINT `FK_2884BAC1F673B5DF1ED4C8215B62AA3C` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_800FAB6FDCF4333C814626331172D2FC` FOREIGN KEY (`option_id`) REFERENCES `mageworx_optiontemplates_group_option` (`option_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_group_option_description`
--

LOCK TABLES `mageworx_optiontemplates_group_option_description` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_description` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_description` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_group_option_price`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_group_option_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_group_option_price` (
  `option_price_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Price ID',
  `option_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Price',
  `price_type` varchar(7) NOT NULL DEFAULT 'fixed' COMMENT 'Price Type',
  PRIMARY KEY (`option_price_id`),
  UNIQUE KEY `MAGEWORX_OPTIONTEMPLATES_GROUP_OPTION_PRICE_OPTION_ID_STORE_ID` (`option_id`,`store_id`),
  KEY `MAGEWORX_OPTTEMPLATES_GROUP_OPT_PRICE_STORE_ID_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `FK_00D4622D353DCA693DCF7D22F432250E` FOREIGN KEY (`option_id`) REFERENCES `mageworx_optiontemplates_group_option` (`option_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_OPTTEMPLATES_GROUP_OPT_PRICE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_group_option_price`
--

LOCK TABLES `mageworx_optiontemplates_group_option_price` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_price` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_group_option_store_view`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_group_option_store_view`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_group_option_store_view` (
  `visibility_store_view_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Visibility Customer Store View Id',
  `mageworx_option_id` varchar(40) DEFAULT 'null' COMMENT 'MageWorx Option ID',
  `option_id` int unsigned NOT NULL COMMENT 'Option ID',
  `customer_store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  PRIMARY KEY (`visibility_store_view_id`),
  KEY `MAGEWORX_OPTIONTEMPLATES_GROUP_OPTION_STORE_VIEW_OPTION_ID` (`option_id`),
  KEY `MAGEWORX_OPTTEMPLATES_GROUP_OPT_STORE_VIEW_CSTR_STORE_ID` (`customer_store_id`),
  CONSTRAINT `FK_1100129657A3EE2C2C213C9DC14C1B6B` FOREIGN KEY (`customer_store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_A4C45D05B947889BEF1D1ED6F4945011` FOREIGN KEY (`option_id`) REFERENCES `mageworx_optiontemplates_group_option` (`option_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Mageworx OptionVisibiity Option Store View Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_group_option_store_view`
--

LOCK TABLES `mageworx_optiontemplates_group_option_store_view` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_store_view` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_store_view` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_group_option_title`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_group_option_title`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_group_option_title` (
  `option_title_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Title ID',
  `option_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Title',
  PRIMARY KEY (`option_title_id`),
  UNIQUE KEY `MAGEWORX_OPTIONTEMPLATES_GROUP_OPTION_TITLE_OPTION_ID_STORE_ID` (`option_id`,`store_id`),
  KEY `MAGEWORX_OPTTEMPLATES_GROUP_OPT_TTL_STORE_ID_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `FK_004C7FAA0F575AFAFA2F57A46D8704EF` FOREIGN KEY (`option_id`) REFERENCES `mageworx_optiontemplates_group_option` (`option_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_OPTTEMPLATES_GROUP_OPT_TTL_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_group_option_title`
--

LOCK TABLES `mageworx_optiontemplates_group_option_title` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_title` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_title` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_group_option_type_description`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_group_option_type_description`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_group_option_type_description` (
  `option_type_description_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type Description ID',
  `mageworx_option_type_id` varchar(40) DEFAULT 'null' COMMENT 'MageWorx Option Type ID',
  `option_type_id` int unsigned DEFAULT NULL COMMENT 'Option Type ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `description` text COMMENT 'Description',
  PRIMARY KEY (`option_type_description_id`),
  UNIQUE KEY `UNQ_560609FCF73D09F50F60F68EA57409CB` (`option_type_id`,`store_id`),
  KEY `MAGEWORX_OPTIONTEMPLATES_GROUP_OPTION_TYPE_DESCRIPTION_STORE_ID` (`store_id`),
  KEY `MAGEWORX_OPTTEMPLATES_GROUP_OPT_TYPE_DESCRIPTION_OPT_TYPE_ID` (`option_type_id`),
  CONSTRAINT `FK_BF65877C6389E239BB64912F69C7B6BF` FOREIGN KEY (`option_type_id`) REFERENCES `mageworx_optiontemplates_group_option_type_value` (`option_type_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_E3A8F608DAF40C59653BFE8D3EAAB55B` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_group_option_type_description`
--

LOCK TABLES `mageworx_optiontemplates_group_option_type_description` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_type_description` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_type_description` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_group_option_type_image`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_group_option_type_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_group_option_type_image` (
  `option_type_id` int unsigned DEFAULT NULL COMMENT 'Option Type ID',
  `option_type_image_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type Image ID',
  `mageworx_option_type_id` varchar(40) DEFAULT NULL COMMENT 'MageWorx Option Type ID',
  `media_type` varchar(32) DEFAULT 'image' COMMENT 'Media Type',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value',
  `title_text` varchar(255) DEFAULT NULL COMMENT 'Title Text',
  `sort_order` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `base_image` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Base Image',
  `tooltip_image` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Tooltip Image',
  `overlay_image` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Overlay Image',
  `color` varchar(6) DEFAULT NULL COMMENT 'color',
  `replace_main_gallery_image` smallint DEFAULT '0' COMMENT 'Use for replacement of the main image in the product gallery (product view page)',
  `disabled` smallint NOT NULL DEFAULT '0' COMMENT 'Should be displayed this image in the Option Gallery or not?',
  PRIMARY KEY (`option_type_image_id`),
  KEY `MAGEWORX_OPTIONTEMPLATES_GROUP_OPTION_TYPE_IMAGE_OPTION_TYPE_ID` (`option_type_id`),
  KEY `IDX_4E59E98E8571D1EA41ECFA6F5E4F3C8E` (`option_type_id`,`tooltip_image`),
  KEY `IDX_482108B2DF793B7997DBFE07E76B3640` (`option_type_id`,`base_image`),
  CONSTRAINT `FK_F4DBA4CB917B82187359E4224CEF536E` FOREIGN KEY (`option_type_id`) REFERENCES `mageworx_optiontemplates_group_option_type_value` (`option_type_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_group_option_type_image`
--

LOCK TABLES `mageworx_optiontemplates_group_option_type_image` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_type_image` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_type_image` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_group_option_type_is_default`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_group_option_type_is_default`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_group_option_type_is_default` (
  `option_type_id` int unsigned DEFAULT NULL COMMENT 'Option Type ID',
  `option_type_is_default_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Is Default ID',
  `mageworx_option_type_id` varchar(40) DEFAULT 'null' COMMENT 'MageWorx Option Type ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `is_default` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Is Default',
  PRIMARY KEY (`option_type_is_default_id`),
  UNIQUE KEY `UNQ_B5FAE5E8F28BC20FA3A148DDBA244953` (`option_type_id`,`store_id`),
  KEY `FK_EFC9D6E5DEC2DE48973499377E932B7B` (`store_id`),
  KEY `MAGEWORX_OPTTEMPLATES_GROUP_OPT_TYPE_IS_DEFAULT_OPT_TYPE_ID` (`option_type_id`),
  CONSTRAINT `FK_45B50DCDC4F73ADB5D432A6CAA99CCAD` FOREIGN KEY (`option_type_id`) REFERENCES `mageworx_optiontemplates_group_option_type_value` (`option_type_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_EFC9D6E5DEC2DE48973499377E932B7B` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_group_option_type_is_default`
--

LOCK TABLES `mageworx_optiontemplates_group_option_type_is_default` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_type_is_default` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_type_is_default` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_group_option_type_price`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_group_option_type_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_group_option_type_price` (
  `option_type_price_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type Price ID',
  `option_type_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option Type ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Price',
  `price_type` varchar(7) NOT NULL DEFAULT 'fixed' COMMENT 'Price Type',
  PRIMARY KEY (`option_type_price_id`),
  UNIQUE KEY `MAGEWORX_OPTTEMPLATES_GROUP_OPT_TYPE_PRICE_OPT_TYPE_ID_STORE_ID` (`option_type_id`,`store_id`),
  KEY `MAGEWORX_OPTIONTEMPLATES_GROUP_OPTION_TYPE_PRICE_STORE_ID` (`store_id`),
  CONSTRAINT `FK_398A135CCDF9AF3B2387D1790E1104BD` FOREIGN KEY (`option_type_id`) REFERENCES `mageworx_optiontemplates_group_option_type_value` (`option_type_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_7F1E68C9B19BB522C109EA8934F907F7` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_group_option_type_price`
--

LOCK TABLES `mageworx_optiontemplates_group_option_type_price` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_type_price` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_type_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_group_option_type_special_price`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_group_option_type_special_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_group_option_type_special_price` (
  `option_type_special_price_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type Special Price ID',
  `mageworx_option_type_id` varchar(40) DEFAULT 'null' COMMENT 'MageWorx Option Type ID',
  `option_type_id` int unsigned NOT NULL COMMENT 'Option Type ID',
  `customer_group_id` int unsigned NOT NULL COMMENT 'Customer Group ID',
  `price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Special Price',
  `price_type` varchar(40) NOT NULL DEFAULT 'fixed' COMMENT 'Special Price Type (fixed, percentage_discount)',
  `comment` varchar(255) NOT NULL DEFAULT '' COMMENT 'Special Price Comment',
  `date_from` date DEFAULT NULL COMMENT 'Special Price Date From',
  `date_to` date DEFAULT NULL COMMENT 'Special Price Date To',
  PRIMARY KEY (`option_type_special_price_id`),
  KEY `MAGEWORX_OPTTEMPLATES_GROUP_OPT_TYPE_SPECIAL_PRICE_OPT_TYPE_ID` (`option_type_id`),
  CONSTRAINT `FK_B988D9F4DF3153448C14E4AF7EB95EBB` FOREIGN KEY (`option_type_id`) REFERENCES `mageworx_optiontemplates_group_option_type_value` (`option_type_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_group_option_type_special_price`
--

LOCK TABLES `mageworx_optiontemplates_group_option_type_special_price` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_type_special_price` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_type_special_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_group_option_type_tier_price`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_group_option_type_tier_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_group_option_type_tier_price` (
  `option_type_tier_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type Special Price ID',
  `mageworx_option_type_id` varchar(40) DEFAULT 'null' COMMENT 'MageWorx Option Type ID',
  `option_type_id` int unsigned NOT NULL COMMENT 'Option Type ID',
  `customer_group_id` int unsigned NOT NULL COMMENT 'Customer Group ID',
  `qty` int unsigned NOT NULL COMMENT 'Tier Price Qty',
  `price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Special Price',
  `price_type` varchar(40) NOT NULL DEFAULT 'fixed' COMMENT 'Special Price Type (fixed, percentage_discount)',
  `date_from` date DEFAULT NULL COMMENT 'Special Price Date From',
  `date_to` date DEFAULT NULL COMMENT 'Special Price Date To',
  PRIMARY KEY (`option_type_tier_id`),
  KEY `MAGEWORX_OPTTEMPLATES_GROUP_OPT_TYPE_TIER_PRICE_OPT_TYPE_ID` (`option_type_id`),
  CONSTRAINT `FK_DA19DBEE57764D5642212445FCFB79E5` FOREIGN KEY (`option_type_id`) REFERENCES `mageworx_optiontemplates_group_option_type_value` (`option_type_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_group_option_type_tier_price`
--

LOCK TABLES `mageworx_optiontemplates_group_option_type_tier_price` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_type_tier_price` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_type_tier_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_group_option_type_title`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_group_option_type_title`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_group_option_type_title` (
  `option_type_title_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type Title ID',
  `option_type_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option Type ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Title',
  PRIMARY KEY (`option_type_title_id`),
  UNIQUE KEY `MAGEWORX_OPTTEMPLATES_GROUP_OPT_TYPE_TTL_OPT_TYPE_ID_STORE_ID` (`option_type_id`,`store_id`),
  KEY `MAGEWORX_OPTIONTEMPLATES_GROUP_OPTION_TYPE_TITLE_STORE_ID` (`store_id`),
  CONSTRAINT `FK_4C345341417258E6E959982F889747E3` FOREIGN KEY (`option_type_id`) REFERENCES `mageworx_optiontemplates_group_option_type_value` (`option_type_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_OPTTEMPLATES_GROUP_OPT_TYPE_TTL_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_group_option_type_title`
--

LOCK TABLES `mageworx_optiontemplates_group_option_type_title` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_type_title` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_type_title` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_group_option_type_value`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_group_option_type_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_group_option_type_value` (
  `option_type_title_id` varchar(255) NOT NULL COMMENT 'Option Type Title Identifier (added by MageWorx Option Dependency)',
  `dependency_type` smallint NOT NULL DEFAULT '0' COMMENT 'Option Type Dependency Type (added by MageWorx Option Dependency)',
  `cost` decimal(10,2) DEFAULT NULL COMMENT 'Cost (added by MageWorx_OptionFeatures)',
  `weight` decimal(20,6) DEFAULT NULL COMMENT 'Weight (added by MageWorx_OptionFeatures)',
  `weight_type` varchar(7) NOT NULL DEFAULT 'fixed' COMMENT 'Type weight (added by MageWorx_OptionFeatures)',
  `qty_multiplier` int unsigned NOT NULL DEFAULT '0' COMMENT 'Qty Multiplier (added by MageWorx_OptionFeatures)',
  `load_linked_product` int unsigned NOT NULL DEFAULT '0' COMMENT 'Load Linked Product (added by MageWorx_OptionFeatures)',
  `group_option_value_id` int unsigned DEFAULT NULL COMMENT 'Group Option Value Id (added by MageWorx OptionTemplates)',
  `option_type_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type ID',
  `option_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `sku` varchar(64) DEFAULT NULL COMMENT 'SKU',
  `sort_order` int unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `manage_stock` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Manage Stock (added by MageWorx OptionInventory)',
  `qty` decimal(10,2) DEFAULT NULL COMMENT 'Option Value Qty (added by MageWorx OptionInventory)',
  `disabled` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Disabled (added by MageWorx Option Visibility)',
  `sku_is_valid` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Sku Is Valid (added by MageWorx OptionLink)',
  PRIMARY KEY (`option_type_id`),
  KEY `MAGEWORX_OPTIONTEMPLATES_GROUP_OPTION_TYPE_VALUE_OPTION_ID` (`option_id`),
  CONSTRAINT `FK_2824EF45181E5380DD45A8FBE726180A` FOREIGN KEY (`option_id`) REFERENCES `mageworx_optiontemplates_group_option` (`option_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_group_option_type_value`
--

LOCK TABLES `mageworx_optiontemplates_group_option_type_value` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_type_value` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_group_option_type_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optiontemplates_relation`
--

DROP TABLE IF EXISTS `mageworx_optiontemplates_relation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optiontemplates_relation` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `group_id` int unsigned NOT NULL COMMENT 'Group ID',
  `product_id` int unsigned NOT NULL COMMENT 'Product ID',
  `option_id` int unsigned NOT NULL COMMENT 'Option ID',
  `is_changed` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Is Changed Flag',
  PRIMARY KEY (`id`),
  UNIQUE KEY `MAGEWORX_OPTIONTEMPLATES_RELATION_GROUP_ID_PRODUCT_ID` (`group_id`,`product_id`),
  KEY `MAGEWORX_OPTTEMPLATES_RELATION_PRD_ID_CAT_PRD_ENTT_ENTT_ID` (`product_id`),
  CONSTRAINT `FK_8020B13F0E7B338F40D654D6635A2BEB` FOREIGN KEY (`group_id`) REFERENCES `mageworx_optiontemplates_group` (`group_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_OPTTEMPLATES_RELATION_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optiontemplates_relation`
--

LOCK TABLES `mageworx_optiontemplates_relation` WRITE;
/*!40000 ALTER TABLE `mageworx_optiontemplates_relation` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optiontemplates_relation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optionvisibility_option_customer_group`
--

DROP TABLE IF EXISTS `mageworx_optionvisibility_option_customer_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optionvisibility_option_customer_group` (
  `visibility_customer_group_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Visibility Customer Group Id',
  `mageworx_option_id` varchar(40) DEFAULT 'null' COMMENT 'MageWorx Option ID',
  `option_id` int unsigned NOT NULL COMMENT 'Option ID',
  `customer_group_id` int unsigned NOT NULL COMMENT 'Customer Group ID',
  PRIMARY KEY (`visibility_customer_group_id`),
  KEY `MAGEWORX_OPTIONVISIBILITY_OPTION_CUSTOMER_GROUP_OPTION_ID` (`option_id`),
  KEY `MAGEWORX_OPTVISIBILITY_OPT_CSTR_GROUP_CSTR_GROUP_ID` (`customer_group_id`),
  CONSTRAINT `FK_B800BD1C991F6DB7E66B7201531A8FC4` FOREIGN KEY (`customer_group_id`) REFERENCES `customer_group` (`customer_group_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_OPTVISIBILITY_OPT_CSTR_GROUP_OPT_ID_CAT_PRD_OPT_OPT_ID` FOREIGN KEY (`option_id`) REFERENCES `catalog_product_option` (`option_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Mageworx OptionVisibiity Option Customer Group Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optionvisibility_option_customer_group`
--

LOCK TABLES `mageworx_optionvisibility_option_customer_group` WRITE;
/*!40000 ALTER TABLE `mageworx_optionvisibility_option_customer_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optionvisibility_option_customer_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_optionvisibility_option_store_view`
--

DROP TABLE IF EXISTS `mageworx_optionvisibility_option_store_view`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_optionvisibility_option_store_view` (
  `visibility_store_view_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Visibility Customer Store View Id',
  `mageworx_option_id` varchar(40) DEFAULT NULL COMMENT 'MageWorx Option ID',
  `option_id` int unsigned NOT NULL COMMENT 'Option ID',
  `customer_store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  PRIMARY KEY (`visibility_store_view_id`),
  KEY `MAGEWORX_OPTIONVISIBILITY_OPTION_STORE_VIEW_OPTION_ID` (`option_id`),
  KEY `MAGEWORX_OPTIONVISIBILITY_OPTION_STORE_VIEW_CUSTOMER_STORE_ID` (`customer_store_id`),
  CONSTRAINT `FK_8672FBF782C85D4318BC6611709598CD` FOREIGN KEY (`customer_store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_OPTVISIBILITY_OPT_STORE_VIEW_OPT_ID_CAT_PRD_OPT_OPT_ID` FOREIGN KEY (`option_id`) REFERENCES `catalog_product_option` (`option_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Mageworx OptionVisibiity Option Store View Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_optionvisibility_option_store_view`
--

LOCK TABLES `mageworx_optionvisibility_option_store_view` WRITE;
/*!40000 ALTER TABLE `mageworx_optionvisibility_option_store_view` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_optionvisibility_option_store_view` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules`
--

DROP TABLE IF EXISTS `mageworx_shippingrules`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules` (
  `rule_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rule Id',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `description` text COMMENT 'Description',
  `from_date` date DEFAULT NULL COMMENT 'From',
  `to_date` date DEFAULT NULL COMMENT 'To',
  `days_of_week` text COMMENT 'Days of Week (Available On)',
  `is_active` smallint NOT NULL DEFAULT '0' COMMENT 'Is Active',
  `conditions_serialized` mediumtext COMMENT 'Conditions Serialized',
  `actions_serialized` mediumtext COMMENT 'Actions Serialized',
  `stop_rules_processing` smallint NOT NULL DEFAULT '1' COMMENT 'Stop Rules Processing',
  `shipping_methods` text COMMENT 'Shipping Methods',
  `disabled_shipping_methods` text COMMENT 'Disabled Shipping Methods',
  `enabled_shipping_methods` text COMMENT 'Enabled Shipping Methods',
  `sort_order` int unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order (Priority)',
  `action_type` text COMMENT 'Action Type',
  `simple_action` text COMMENT 'Simple Action',
  `amount` mediumtext COMMENT 'Amount',
  `time_from` int DEFAULT NULL COMMENT 'Time From',
  `time_to` int DEFAULT NULL COMMENT 'Time To',
  `use_time` smallint DEFAULT NULL COMMENT 'Use or not time flag',
  `time_enabled` smallint DEFAULT NULL COMMENT 'Time Range is enabled or disabled time',
  `display_error_message` smallint DEFAULT '0' COMMENT 'Display or not the disabled methods error message',
  `error_message` varchar(255) DEFAULT NULL COMMENT 'Disabled methods error message',
  `store_errmsgs` text COMMENT 'Store Specific Error Messages (serialized)',
  `changed_titles` mediumtext COMMENT 'Shipping Methods Changed Titles',
  `min_price_shipping_methods` text NOT NULL COMMENT 'Shipping Methods Which will be affected by min-price action',
  `display_all_methods_having_min_price` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'If enabled, all shipping methods with the same min price will be shown.',
  PRIMARY KEY (`rule_id`),
  KEY `MAGEWORX_SHIPPINGRULES_IS_ACTIVE_SORT_ORDER_TO_DATE_FROM_DATE` (`is_active`,`sort_order`,`to_date`,`from_date`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COMMENT='Shippingrules';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules`
--

LOCK TABLES `mageworx_shippingrules` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules` DISABLE KEYS */;
INSERT INTO `mageworx_shippingrules` VALUES (2,'Van Delivery','gazco',NULL,NULL,'0,1,2,3,4,5,6',1,'{\"type\":\"MageWorx\\\\ShippingRules\\\\Model\\\\Rule\\\\Condition\\\\Combine\",\"attribute\":null,\"operator\":null,\"value\":\"1\",\"is_value_processed\":null,\"aggregator\":\"all\",\"conditions\":[{\"type\":\"MageWorx\\\\ShippingRules\\\\Model\\\\Rule\\\\Condition\\\\Product\\\\Found\",\"attribute\":null,\"operator\":null,\"value\":\"1\",\"is_value_processed\":null,\"aggregator\":\"all\",\"conditions\":[{\"type\":\"MageWorx\\\\ShippingRules\\\\Model\\\\Rule\\\\Condition\\\\Product\",\"attribute\":\"category_ids\",\"operator\":\"()\",\"value\":\"15,203,209,219\",\"is_value_processed\":false,\"attribute_scope\":\"\"}]},{\"type\":\"MageWorx\\\\ShippingRules\\\\Model\\\\Rule\\\\Condition\\\\Address\",\"attribute\":\"uk_area\",\"operator\":\"()\",\"value\":\"LE,CV,NG\",\"is_value_processed\":false}]}','{\"type\":\"MageWorx\\\\ShippingRules\\\\Model\\\\Rule\\\\Condition\\\\Product\\\\Combine\",\"attribute\":null,\"operator\":null,\"value\":\"1\",\"is_value_processed\":null,\"aggregator\":\"all\"}',0,'null','[\"dhl_2\",\"dhl_5\",\"dhl_6\",\"dhl_7\",\"dhl_9\",\"dhl_B\",\"dhl_C\",\"dhl_D\",\"dhl_U\",\"dhl_K\",\"dhl_L\",\"dhl_G\",\"dhl_W\",\"dhl_I\",\"dhl_N\",\"dhl_O\",\"dhl_R\",\"dhl_S\",\"dhl_T\",\"dhl_X\",\"dhl_1\",\"dhl_3\",\"dhl_4\",\"dhl_8\",\"dhl_P\",\"dhl_Q\",\"dhl_E\",\"dhl_F\",\"dhl_H\",\"dhl_J\",\"dhl_M\",\"dhl_V\",\"dhl_Y\",\"fedex_EUROPE_FIRST_INTERNATIONAL_PRIORITY\",\"fedex_FEDEX_1_DAY_FREIGHT\",\"fedex_FEDEX_2_DAY_FREIGHT\",\"fedex_FEDEX_2_DAY\",\"fedex_FEDEX_2_DAY_AM\",\"fedex_FEDEX_3_DAY_FREIGHT\",\"fedex_FEDEX_EXPRESS_SAVER\",\"fedex_FEDEX_GROUND\",\"fedex_FIRST_OVERNIGHT\",\"fedex_GROUND_HOME_DELIVERY\",\"fedex_INTERNATIONAL_ECONOMY\",\"fedex_INTERNATIONAL_ECONOMY_FREIGHT\",\"fedex_INTERNATIONAL_FIRST\",\"fedex_INTERNATIONAL_GROUND\",\"fedex_INTERNATIONAL_PRIORITY\",\"fedex_INTERNATIONAL_PRIORITY_FREIGHT\",\"fedex_PRIORITY_OVERNIGHT\",\"fedex_SMART_POST\",\"fedex_STANDARD_OVERNIGHT\",\"fedex_FEDEX_FREIGHT\",\"fedex_FEDEX_NATIONAL_FREIGHT\",\"instore_pickup\",\"flatrate_flatrate\",\"tablerate_bestway\",\"freeshipping_freeshipping\",\"ups_01\",\"ups_02\",\"ups_03\",\"ups_07\",\"ups_08\",\"ups_11\",\"ups_12\",\"ups_14\",\"ups_54\",\"ups_59\",\"ups_65\",\"usps_0_FCLE\",\"usps_0_FCL\",\"usps_0_FCP\",\"usps_1\",\"usps_2\",\"usps_3\",\"usps_4\",\"usps_6\",\"usps_7\",\"usps_13\",\"usps_16\",\"usps_17\",\"usps_22\",\"usps_23\",\"usps_25\",\"usps_27\",\"usps_28\",\"usps_33\",\"usps_34\",\"usps_35\",\"usps_36\",\"usps_37\",\"usps_42\",\"usps_43\",\"usps_53\",\"usps_57\",\"usps_61\",\"usps_INT_1\",\"usps_INT_2\",\"usps_INT_4\",\"usps_INT_6\",\"usps_INT_7\",\"usps_INT_8\",\"usps_INT_9\",\"usps_INT_10\",\"usps_INT_11\",\"usps_INT_12\",\"usps_INT_13\",\"usps_INT_14\",\"usps_INT_15\",\"usps_INT_16\",\"usps_INT_20\",\"usps_1058\",\"usps_4058\",\"usps_6058\",\"usps_2058\",\"usps_4096\",\"usps_1096\",\"usps_2096\",\"usps_6096\",\"shipping_shipping\",\"customshipping_customshipping\",\"matrixrate_matrixrate\"]','null',0,'[\"disable\"]',NULL,'{\"fixed_overwrite_amount\":{\"value\":\"0\",\"sort\":\"0\"},\"percent_overwrite_amount\":{\"value\":\"0\",\"sort\":\"0\"},\"fixed_overwrite_product\":{\"value\":\"0\",\"sort\":\"0\"},\"percent_overwrite_product\":{\"value\":\"0\",\"sort\":\"0\"},\"fixed_overwrite_xproduct\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"fixed_overwrite_perxproduct\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"percent_overwrite_perxproduct\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"fixed_overwrite_item\":{\"value\":\"0\",\"sort\":\"0\"},\"percent_overwrite_item\":{\"value\":\"0\",\"sort\":\"0\"},\"fixed_overwrite_xitem\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"fixed_overwrite_weight\":{\"value\":\"0\",\"sort\":\"0\"},\"percent_overwrite_weight\":{\"value\":\"0\",\"sort\":\"0\"},\"fixed_overwrite_xweightaftery\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":{\"x\":\"\",\"y\":\"\"}},\"percent_overwrite_xweightaftery\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":{\"x\":\"\",\"y\":\"\"}},\"fixed_overwrite_xweight\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"percent_overwrite_xweight\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"fixed_overwrite_perxweight\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"percent_overwrite_perxweight\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"fixed_surcharge_amount\":{\"value\":\"0\",\"sort\":\"0\"},\"percent_surcharge_amount\":{\"value\":\"0\",\"sort\":\"0\"},\"fixed_surcharge_product\":{\"value\":\"0\",\"sort\":\"0\"},\"percent_surcharge_product\":{\"value\":\"0\",\"sort\":\"0\"},\"fixed_surcharge_xproduct\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"fixed_surcharge_perxproduct\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"percent_surcharge_perxproduct\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"fixed_surcharge_item\":{\"value\":\"0\",\"sort\":\"0\"},\"percent_surcharge_item\":{\"value\":\"0\",\"sort\":\"0\"},\"fixed_surcharge_xitem\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"fixed_surcharge_weight\":{\"value\":\"0\",\"sort\":\"0\"},\"percent_surcharge_weight\":{\"value\":\"0\",\"sort\":\"0\"},\"fixed_surcharge_xweightaftery\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":{\"x\":\"\",\"y\":\"\"}},\"percent_surcharge_xweightaftery\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":{\"x\":\"\",\"y\":\"\"}},\"fixed_surcharge_xweight\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"percent_surcharge_xweight\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"fixed_surcharge_perxweight\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"percent_surcharge_perxweight\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"fixed_discount_amount\":{\"value\":\"0\",\"sort\":\"0\"},\"percent_discount_amount\":{\"value\":\"0\",\"sort\":\"0\"},\"fixed_discount_product\":{\"value\":\"0\",\"sort\":\"0\"},\"percent_discount_product\":{\"value\":\"0\",\"sort\":\"0\"},\"fixed_discount_xproduct\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"fixed_discount_perxproduct\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"percent_discount_perxproduct\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"fixed_discount_item\":{\"value\":\"0\",\"sort\":\"0\"},\"percent_discount_item\":{\"value\":\"0\",\"sort\":\"0\"},\"fixed_discount_xitem\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"fixed_discount_weight\":{\"value\":\"0\",\"sort\":\"0\"},\"percent_discount_weight\":{\"value\":\"0\",\"sort\":\"0\"},\"fixed_discount_xweightaftery\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":{\"x\":\"\",\"y\":\"\"}},\"percent_discount_xweightaftery\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":{\"x\":\"\",\"y\":\"\"}},\"fixed_discount_xweight\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"percent_discount_xweight\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"fixed_discount_perxweight\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"},\"percent_discount_perxweight\":{\"value\":\"0\",\"sort\":\"0\",\"condition\":\"\"}}',0,0,0,0,0,NULL,'{\"1\":\"\",\"2\":\"\"}','null','null',0),(3,'Hidding all Methods ','Hidding all Methods ',NULL,NULL,'0,1,2,3,4,5,6',1,'{\"type\":\"MageWorx\\\\ShippingRules\\\\Model\\\\Rule\\\\Condition\\\\Combine\",\"attribute\":null,\"operator\":null,\"value\":\"1\",\"is_value_processed\":null,\"aggregator\":\"all\",\"conditions\":[{\"type\":\"MageWorx\\\\ShippingRules\\\\Model\\\\Rule\\\\Condition\\\\Address\",\"attribute\":\"uk_area\",\"operator\":\"()\",\"value\":\"\",\"is_value_processed\":false}]}','{\"type\":\"MageWorx\\\\ShippingRules\\\\Model\\\\Rule\\\\Condition\\\\Product\\\\Combine\",\"attribute\":null,\"operator\":null,\"value\":\"1\",\"is_value_processed\":null,\"aggregator\":\"all\"}',0,'null','[\"dhl_2\",\"dhl_5\",\"dhl_6\",\"dhl_7\",\"dhl_9\",\"dhl_B\",\"dhl_C\",\"dhl_D\",\"dhl_U\",\"dhl_K\",\"dhl_L\",\"dhl_G\",\"dhl_W\",\"dhl_I\",\"dhl_N\",\"dhl_O\",\"dhl_R\",\"dhl_S\",\"dhl_T\",\"dhl_X\",\"dhl_1\",\"dhl_3\",\"dhl_4\",\"dhl_8\",\"dhl_P\",\"dhl_Q\",\"dhl_E\",\"dhl_F\",\"dhl_H\",\"dhl_J\",\"dhl_M\",\"dhl_V\",\"dhl_Y\",\"fedex_EUROPE_FIRST_INTERNATIONAL_PRIORITY\",\"fedex_FEDEX_1_DAY_FREIGHT\",\"fedex_FEDEX_2_DAY_FREIGHT\",\"fedex_FEDEX_2_DAY\",\"fedex_FEDEX_2_DAY_AM\",\"fedex_FEDEX_3_DAY_FREIGHT\",\"fedex_FEDEX_EXPRESS_SAVER\",\"fedex_FEDEX_GROUND\",\"fedex_FIRST_OVERNIGHT\",\"fedex_GROUND_HOME_DELIVERY\",\"fedex_INTERNATIONAL_ECONOMY\",\"fedex_INTERNATIONAL_ECONOMY_FREIGHT\",\"fedex_INTERNATIONAL_FIRST\",\"fedex_INTERNATIONAL_GROUND\",\"fedex_INTERNATIONAL_PRIORITY\",\"fedex_INTERNATIONAL_PRIORITY_FREIGHT\",\"fedex_PRIORITY_OVERNIGHT\",\"fedex_SMART_POST\",\"fedex_STANDARD_OVERNIGHT\",\"fedex_FEDEX_FREIGHT\",\"fedex_FEDEX_NATIONAL_FREIGHT\",\"instore_pickup\",\"flatrate_flatrate\",\"tablerate_bestway\",\"freeshipping_freeshipping\",\"ups_01\",\"ups_02\",\"ups_03\",\"ups_07\",\"ups_08\",\"ups_11\",\"ups_12\",\"ups_14\",\"ups_54\",\"ups_59\",\"ups_65\",\"usps_0_FCLE\",\"usps_0_FCL\",\"usps_0_FCP\",\"usps_1\",\"usps_2\",\"usps_3\",\"usps_4\",\"usps_6\",\"usps_7\",\"usps_13\",\"usps_16\",\"usps_17\",\"usps_22\",\"usps_23\",\"usps_25\",\"usps_27\",\"usps_28\",\"usps_33\",\"usps_34\",\"usps_35\",\"usps_36\",\"usps_37\",\"usps_42\",\"usps_43\",\"usps_53\",\"usps_57\",\"usps_61\",\"usps_INT_1\",\"usps_INT_2\",\"usps_INT_4\",\"usps_INT_6\",\"usps_INT_7\",\"usps_INT_8\",\"usps_INT_9\",\"usps_INT_10\",\"usps_INT_11\",\"usps_INT_12\",\"usps_INT_13\",\"usps_INT_14\",\"usps_INT_15\",\"usps_INT_16\",\"usps_INT_20\",\"usps_1058\",\"usps_4058\",\"usps_6058\",\"usps_2058\",\"usps_4096\",\"usps_1096\",\"usps_2096\",\"usps_6096\",\"shipping_shipping\",\"customshipping_customshipping\",\"matrixrate_matrixrate\",\"gazco_gazcofire\"]','null',0,'[\"disable\"]',NULL,'{\"fixed_overwrite_amount\":{\"value\":\"\",\"sort\":\"\"},\"percent_overwrite_amount\":{\"value\":\"\",\"sort\":\"\"},\"fixed_overwrite_product\":{\"value\":\"\",\"sort\":\"\"},\"percent_overwrite_product\":{\"value\":\"\",\"sort\":\"\"},\"fixed_overwrite_xproduct\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"fixed_overwrite_perxproduct\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"percent_overwrite_perxproduct\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"fixed_overwrite_item\":{\"value\":\"\",\"sort\":\"\"},\"percent_overwrite_item\":{\"value\":\"\",\"sort\":\"\"},\"fixed_overwrite_xitem\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"fixed_overwrite_weight\":{\"value\":\"\",\"sort\":\"\"},\"percent_overwrite_weight\":{\"value\":\"\",\"sort\":\"\"},\"fixed_overwrite_xweightaftery\":{\"value\":\"\",\"sort\":\"\",\"condition\":{\"x\":\"\",\"y\":\"\"}},\"percent_overwrite_xweightaftery\":{\"value\":\"\",\"sort\":\"\",\"condition\":{\"x\":\"\",\"y\":\"\"}},\"fixed_overwrite_xweight\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"percent_overwrite_xweight\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"fixed_overwrite_perxweight\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"percent_overwrite_perxweight\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"fixed_surcharge_amount\":{\"value\":\"\",\"sort\":\"\"},\"percent_surcharge_amount\":{\"value\":\"\",\"sort\":\"\"},\"fixed_surcharge_product\":{\"value\":\"\",\"sort\":\"\"},\"percent_surcharge_product\":{\"value\":\"\",\"sort\":\"\"},\"fixed_surcharge_xproduct\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"fixed_surcharge_perxproduct\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"percent_surcharge_perxproduct\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"fixed_surcharge_item\":{\"value\":\"\",\"sort\":\"\"},\"percent_surcharge_item\":{\"value\":\"\",\"sort\":\"\"},\"fixed_surcharge_xitem\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"fixed_surcharge_weight\":{\"value\":\"\",\"sort\":\"\"},\"percent_surcharge_weight\":{\"value\":\"\",\"sort\":\"\"},\"fixed_surcharge_xweightaftery\":{\"value\":\"\",\"sort\":\"\",\"condition\":{\"x\":\"\",\"y\":\"\"}},\"percent_surcharge_xweightaftery\":{\"value\":\"\",\"sort\":\"\",\"condition\":{\"x\":\"\",\"y\":\"\"}},\"fixed_surcharge_xweight\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"percent_surcharge_xweight\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"fixed_surcharge_perxweight\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"percent_surcharge_perxweight\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"fixed_discount_amount\":{\"value\":\"\",\"sort\":\"\"},\"percent_discount_amount\":{\"value\":\"\",\"sort\":\"\"},\"fixed_discount_product\":{\"value\":\"\",\"sort\":\"\"},\"percent_discount_product\":{\"value\":\"\",\"sort\":\"\"},\"fixed_discount_xproduct\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"fixed_discount_perxproduct\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"percent_discount_perxproduct\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"fixed_discount_item\":{\"value\":\"\",\"sort\":\"\"},\"percent_discount_item\":{\"value\":\"\",\"sort\":\"\"},\"fixed_discount_xitem\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"fixed_discount_weight\":{\"value\":\"\",\"sort\":\"\"},\"percent_discount_weight\":{\"value\":\"\",\"sort\":\"\"},\"fixed_discount_xweightaftery\":{\"value\":\"\",\"sort\":\"\",\"condition\":{\"x\":\"\",\"y\":\"\"}},\"percent_discount_xweightaftery\":{\"value\":\"\",\"sort\":\"\",\"condition\":{\"x\":\"\",\"y\":\"\"}},\"fixed_discount_xweight\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"percent_discount_xweight\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"fixed_discount_perxweight\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"},\"percent_discount_perxweight\":{\"value\":\"\",\"sort\":\"\",\"condition\":\"\"}}',0,0,0,0,0,NULL,'{\"1\":\"\",\"2\":\"\"}','null','null',0);
/*!40000 ALTER TABLE `mageworx_shippingrules` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_carrier`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_carrier`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_carrier` (
  `carrier_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id',
  `carrier_code` varchar(64) DEFAULT NULL COMMENT 'Carrier Code',
  `active` smallint NOT NULL DEFAULT '0' COMMENT 'Is Active',
  `sallowspecific` smallint NOT NULL DEFAULT '0' COMMENT 'sallowspecific',
  `model` varchar(47) DEFAULT 'MageWorx\\ShippingRules\\Model\\Carrier\\Artificial' COMMENT 'Corresponding Model',
  `name` text COMMENT 'Carrier Name',
  `title` text COMMENT 'Carrier Title',
  `type` text COMMENT 'Carrier Type',
  `specificerrmsg` text COMMENT 'Carrier Error Message',
  `price` decimal(12,2) DEFAULT NULL COMMENT 'Default Price',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Creation Time',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Update Time',
  `sort_order` int unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  PRIMARY KEY (`carrier_id`),
  UNIQUE KEY `MAGEWORX_SHIPPINGRULES_CARRIER_CARRIER_CODE` (`carrier_code`),
  KEY `MAGEWORX_SHIPPINGRULES_CARRIER_CARRIER_ID` (`carrier_id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COMMENT='Artificial Carriers Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_carrier`
--

LOCK TABLES `mageworx_shippingrules_carrier` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_carrier` DISABLE KEYS */;
INSERT INTO `mageworx_shippingrules_carrier` VALUES (2,'gazco',1,0,'MageWorx\\ShippingRules\\Model\\Carrier\\Artificial','Gazco (Fire) ','Van Delivery',NULL,NULL,0.00,'2025-01-08 07:27:58','2025-01-08 07:27:58',0);
/*!40000 ALTER TABLE `mageworx_shippingrules_carrier` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_carrier_label`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_carrier_label`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_carrier_label` (
  `label_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Label Id',
  `carrier_id` int unsigned NOT NULL COMMENT 'Carrier Id',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store Id',
  `label` varchar(255) DEFAULT NULL COMMENT 'Label',
  PRIMARY KEY (`label_id`),
  UNIQUE KEY `MAGEWORX_SHIPPINGRULES_CARRIER_LABEL_CARRIER_ID_STORE_ID` (`carrier_id`,`store_id`),
  KEY `MAGEWORX_SHIPPINGRULES_CARRIER_LABEL_STORE_ID` (`store_id`),
  CONSTRAINT `FK_5CB5F5698DC3800C85BAF92DBF744485` FOREIGN KEY (`carrier_id`) REFERENCES `mageworx_shippingrules_carrier` (`carrier_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_SHIPPINGRULES_CARRIER_LABEL_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules Carrier Label';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_carrier_label`
--

LOCK TABLES `mageworx_shippingrules_carrier_label` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_carrier_label` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_carrier_label` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_carrier_store`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_carrier_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_carrier_store` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity Id',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store View Id',
  PRIMARY KEY (`entity_id`,`store_id`),
  KEY `MAGEWORX_SHIPPINGRULES_CARRIER_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `FK_0CD9EC57ACEE72A357C020EDCAAFA5D6` FOREIGN KEY (`entity_id`) REFERENCES `mageworx_shippingrules_carrier` (`carrier_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_SHIPPINGRULES_CARRIER_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules Entity To Stores Relations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_carrier_store`
--

LOCK TABLES `mageworx_shippingrules_carrier_store` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_carrier_store` DISABLE KEYS */;
INSERT INTO `mageworx_shippingrules_carrier_store` VALUES (2,0);
/*!40000 ALTER TABLE `mageworx_shippingrules_carrier_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_customer_group`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_customer_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_customer_group` (
  `rule_id` int unsigned NOT NULL COMMENT 'Rule Id',
  `customer_group_id` int unsigned NOT NULL COMMENT 'Customer Group Id',
  PRIMARY KEY (`rule_id`,`customer_group_id`),
  KEY `MAGEWORX_SHIPPINGRULES_CUSTOMER_GROUP_CUSTOMER_GROUP_ID` (`customer_group_id`),
  CONSTRAINT `FK_9B03D94DEF68FED61E6DEF8F3BF0C117` FOREIGN KEY (`customer_group_id`) REFERENCES `customer_group` (`customer_group_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_SHPPRULES_CSTR_GROUP_RULE_ID_MAGEWORX_SHPPRULES_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `mageworx_shippingrules` (`rule_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules To Customer Groups Relations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_customer_group`
--

LOCK TABLES `mageworx_shippingrules_customer_group` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_customer_group` DISABLE KEYS */;
INSERT INTO `mageworx_shippingrules_customer_group` VALUES (2,0),(3,0),(2,1),(3,1),(2,2),(3,2),(2,3),(3,3);
/*!40000 ALTER TABLE `mageworx_shippingrules_customer_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_extended_regions`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_extended_regions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_extended_regions` (
  `region_id` int unsigned NOT NULL COMMENT 'Region Id',
  `is_active` int NOT NULL DEFAULT '0' COMMENT 'Is Active',
  `is_custom` int NOT NULL DEFAULT '0' COMMENT 'Custom Region created using module',
  PRIMARY KEY (`region_id`),
  CONSTRAINT `FK_138DA0B3C4EDF5F7E5EFC05453029B68` FOREIGN KEY (`region_id`) REFERENCES `directory_country_region` (`region_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Suite: Extended Regions Data Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_extended_regions`
--

LOCK TABLES `mageworx_shippingrules_extended_regions` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_extended_regions` DISABLE KEYS */;
INSERT INTO `mageworx_shippingrules_extended_regions` VALUES (1,1,0),(2,1,0),(3,1,0),(4,1,0),(5,1,0),(6,1,0),(7,1,0),(8,1,0),(9,1,0),(10,1,0),(11,1,0),(12,1,0),(13,1,0),(14,1,0),(15,1,0),(16,1,0),(17,1,0),(18,1,0),(19,1,0),(20,1,0),(21,1,0),(22,1,0),(23,1,0),(24,1,0),(25,1,0),(26,1,0),(27,1,0),(28,1,0),(29,1,0),(30,1,0),(31,1,0),(32,1,0),(33,1,0),(34,1,0),(35,1,0),(36,1,0),(37,1,0),(38,1,0),(39,1,0),(40,1,0),(41,1,0),(42,1,0),(43,1,0),(44,1,0),(45,1,0),(46,1,0),(47,1,0),(48,1,0),(49,1,0),(50,1,0),(51,1,0),(52,1,0),(53,1,0),(54,1,0),(55,1,0),(56,1,0),(57,1,0),(58,1,0),(59,1,0),(60,1,0),(61,1,0),(62,1,0),(63,1,0),(64,1,0),(65,1,0),(66,1,0),(67,1,0),(68,1,0),(69,1,0),(70,1,0),(71,1,0),(72,1,0),(73,1,0),(74,1,0),(75,1,0),(76,1,0),(77,1,0),(78,1,0),(79,1,0),(80,1,0),(81,1,0),(82,1,0),(83,1,0),(84,1,0),(85,1,0),(86,1,0),(87,1,0),(88,1,0),(89,1,0),(90,1,0),(91,1,0),(92,1,0),(93,1,0),(94,1,0),(95,1,0),(96,1,0),(97,1,0),(98,1,0),(99,1,0),(100,1,0),(101,1,0),(102,1,0),(103,1,0),(104,1,0),(105,1,0),(106,1,0),(107,1,0),(108,1,0),(109,1,0),(110,1,0),(111,1,0),(112,1,0),(113,1,0),(114,1,0),(115,1,0),(116,1,0),(117,1,0),(118,1,0),(119,1,0),(120,1,0),(121,1,0),(122,1,0),(123,1,0),(124,1,0),(125,1,0),(126,1,0),(127,1,0),(128,1,0),(129,1,0),(130,1,0),(131,1,0),(132,1,0),(133,1,0),(134,1,0),(135,1,0),(136,1,0),(137,1,0),(138,1,0),(139,1,0),(140,1,0),(141,1,0),(142,1,0),(143,1,0),(144,1,0),(145,1,0),(146,1,0),(147,1,0),(148,1,0),(149,1,0),(150,1,0),(151,1,0),(152,1,0),(153,1,0),(154,1,0),(155,1,0),(156,1,0),(157,1,0),(158,1,0),(159,1,0),(160,1,0),(161,1,0),(162,1,0),(163,1,0),(164,1,0),(165,1,0),(166,1,0),(167,1,0),(168,1,0),(169,1,0),(170,1,0),(171,1,0),(172,1,0),(173,1,0),(174,1,0),(175,1,0),(176,1,0),(177,1,0),(178,1,0),(179,1,0),(180,1,0),(181,1,0),(182,1,0),(183,1,0),(184,1,0),(185,1,0),(186,1,0),(187,1,0),(188,1,0),(189,1,0),(190,1,0),(191,1,0),(192,1,0),(193,1,0),(194,1,0),(195,1,0),(196,1,0),(197,1,0),(198,1,0),(199,1,0),(200,1,0),(201,1,0),(202,1,0),(203,1,0),(204,1,0),(205,1,0),(206,1,0),(207,1,0),(208,1,0),(209,1,0),(210,1,0),(211,1,0),(212,1,0),(213,1,0),(214,1,0),(215,1,0),(216,1,0),(217,1,0),(218,1,0),(219,1,0),(220,1,0),(221,1,0),(222,1,0),(223,1,0),(224,1,0),(225,1,0),(226,1,0),(227,1,0),(228,1,0),(229,1,0),(230,1,0),(231,1,0),(232,1,0),(233,1,0),(234,1,0),(235,1,0),(236,1,0),(237,1,0),(238,1,0),(239,1,0),(240,1,0),(241,1,0),(242,1,0),(243,1,0),(244,1,0),(245,1,0),(246,1,0),(247,1,0),(248,1,0),(249,1,0),(250,1,0),(251,1,0),(252,1,0),(253,1,0),(254,1,0),(255,1,0),(256,1,0),(257,1,0),(258,1,0),(259,1,0),(260,1,0),(261,1,0),(262,1,0),(263,1,0),(264,1,0),(265,1,0),(266,1,0),(267,1,0),(268,1,0),(269,1,0),(270,1,0),(271,1,0),(272,1,0),(273,1,0),(274,1,0),(275,1,0),(276,1,0),(277,1,0),(278,1,0),(279,1,0),(280,1,0),(281,1,0),(282,1,0),(283,1,0),(284,1,0),(285,1,0),(286,1,0),(287,1,0),(288,1,0),(289,1,0),(290,1,0),(291,1,0),(292,1,0),(293,1,0),(294,1,0),(295,1,0),(296,1,0),(297,1,0),(298,1,0),(299,1,0),(300,1,0),(301,1,0),(302,1,0),(303,1,0),(304,1,0),(305,1,0),(306,1,0),(307,1,0),(308,1,0),(309,1,0),(310,1,0),(311,1,0),(312,1,0),(313,1,0),(314,1,0),(315,1,0),(316,1,0),(317,1,0),(318,1,0),(319,1,0),(320,1,0),(321,1,0),(322,1,0),(323,1,0),(324,1,0),(325,1,0),(326,1,0),(327,1,0),(328,1,0),(329,1,0),(330,1,0),(331,1,0),(332,1,0),(333,1,0),(334,1,0),(335,1,0),(336,1,0),(337,1,0),(338,1,0),(339,1,0),(340,1,0),(341,1,0),(342,1,0),(343,1,0),(344,1,0),(345,1,0),(346,1,0),(347,1,0),(348,1,0),(349,1,0),(350,1,0),(351,1,0),(352,1,0),(353,1,0),(354,1,0),(355,1,0),(356,1,0),(357,1,0),(358,1,0),(359,1,0),(360,1,0),(361,1,0),(362,1,0),(363,1,0),(364,1,0),(365,1,0),(366,1,0),(367,1,0),(368,1,0),(369,1,0),(370,1,0),(371,1,0),(372,1,0),(373,1,0),(374,1,0),(375,1,0),(376,1,0),(377,1,0),(378,1,0),(379,1,0),(380,1,0),(381,1,0),(382,1,0),(383,1,0),(384,1,0),(385,1,0),(386,1,0),(387,1,0),(388,1,0),(389,1,0),(390,1,0),(391,1,0),(392,1,0),(393,1,0),(394,1,0),(395,1,0),(396,1,0),(397,1,0),(398,1,0),(399,1,0),(400,1,0),(401,1,0),(402,1,0),(403,1,0),(404,1,0),(405,1,0),(406,1,0),(407,1,0),(408,1,0),(409,1,0),(410,1,0),(411,1,0),(412,1,0),(413,1,0),(414,1,0),(415,1,0),(416,1,0),(417,1,0),(418,1,0),(419,1,0),(420,1,0),(421,1,0),(422,1,0),(423,1,0),(424,1,0),(425,1,0),(426,1,0),(427,1,0),(428,1,0),(429,1,0),(430,1,0),(431,1,0),(432,1,0),(433,1,0),(434,1,0),(435,1,0),(436,1,0),(437,1,0),(438,1,0),(439,1,0),(440,1,0),(441,1,0),(442,1,0),(443,1,0),(444,1,0),(445,1,0),(446,1,0),(447,1,0),(448,1,0),(449,1,0),(450,1,0),(451,1,0),(452,1,0),(453,1,0),(454,1,0),(455,1,0),(456,1,0),(457,1,0),(458,1,0),(459,1,0),(460,1,0),(461,1,0),(462,1,0),(463,1,0),(464,1,0),(465,1,0),(466,1,0),(467,1,0),(468,1,0),(469,1,0),(470,1,0),(471,1,0),(472,1,0),(473,1,0),(474,1,0),(475,1,0),(476,1,0),(477,1,0),(478,1,0),(479,1,0),(480,1,0),(481,1,0),(482,1,0),(483,1,0),(484,1,0),(485,1,0),(486,1,0),(487,1,0),(488,1,0),(489,1,0),(490,1,0),(491,1,0),(492,1,0),(493,1,0),(494,1,0),(495,1,0),(496,1,0),(497,1,0),(498,1,0),(499,1,0),(500,1,0),(501,1,0),(502,1,0),(503,1,0),(504,1,0),(505,1,0),(506,1,0),(507,1,0),(508,1,0),(509,1,0),(510,1,0),(511,1,0),(512,1,0),(513,1,0),(514,1,0),(515,1,0),(516,1,0),(517,1,0),(518,1,0),(519,1,0),(520,1,0),(521,1,0),(522,1,0),(523,1,0),(524,1,0),(525,1,0),(526,1,0),(527,1,0),(528,1,0),(529,1,0),(530,1,0),(531,1,0),(532,1,0),(533,1,0),(534,1,0),(535,1,0),(536,1,0),(537,1,0),(538,1,0),(539,1,0),(540,1,0),(541,1,0),(542,1,0),(543,1,0),(544,1,0),(545,1,0),(546,1,0),(547,1,0),(548,1,0),(549,1,0),(550,1,0),(551,1,0),(552,1,0),(553,1,0),(554,1,0),(555,1,0),(556,1,0),(557,1,0),(558,1,0),(559,1,0),(560,1,0),(561,1,0),(562,1,0),(563,1,0),(564,1,0),(565,1,0),(566,1,0),(567,1,0),(568,1,0),(569,1,0),(570,1,0),(571,1,0),(572,1,0),(573,1,0),(574,1,0),(575,1,0),(576,1,0),(577,1,0),(578,1,0),(579,1,0),(580,1,0),(581,1,0),(582,1,0),(583,1,0),(584,1,0),(585,1,0),(586,1,0),(587,1,0),(588,1,0),(589,1,0),(590,1,0),(591,1,0),(592,1,0),(593,1,0),(594,1,0),(595,1,0),(596,1,0),(597,1,0),(598,1,0),(599,1,0),(600,1,0),(601,1,0),(602,1,0),(603,1,0),(604,1,0),(605,1,0),(606,1,0),(607,1,0),(608,1,0),(609,1,0),(610,1,0),(611,1,0),(612,1,0),(613,1,0),(614,1,0),(615,1,0),(616,1,0),(617,1,0),(618,1,0),(619,1,0),(620,1,0),(621,1,0),(622,1,0),(623,1,0),(624,1,0),(625,1,0),(626,1,0),(627,1,0),(628,1,0),(629,1,0),(630,1,0),(631,1,0),(632,1,0),(633,1,0),(634,1,0),(635,1,0),(636,1,0),(637,1,0),(638,1,0),(639,1,0),(640,1,0),(641,1,0),(642,1,0),(643,1,0),(644,1,0),(645,1,0),(646,1,0),(647,1,0),(648,1,0),(649,1,0),(650,1,0),(651,1,0),(652,1,0),(653,1,0),(654,1,0),(655,1,0),(656,1,0),(657,1,0),(658,1,0),(659,1,0),(660,1,0),(661,1,0),(662,1,0),(663,1,0),(664,1,0),(665,1,0),(666,1,0),(667,1,0),(668,1,0),(669,1,0),(670,1,0),(671,1,0),(672,1,0),(673,1,0),(674,1,0),(675,1,0),(676,1,0),(677,1,0),(678,1,0),(679,1,0),(680,1,0),(681,1,0),(682,1,0),(683,1,0),(684,1,0),(685,1,0),(686,1,0),(687,1,0),(688,1,0),(689,1,0),(690,1,0),(691,1,0),(692,1,0),(693,1,0),(694,1,0),(695,1,0),(696,1,0),(697,1,0),(698,1,0),(699,1,0),(700,1,0),(701,1,0),(702,1,0),(703,1,0),(704,1,0),(705,1,0),(706,1,0),(707,1,0),(708,1,0),(709,1,0),(710,1,0),(711,1,0),(712,1,0),(713,1,0),(714,1,0),(715,1,0),(716,1,0),(717,1,0),(718,1,0),(719,1,0),(720,1,0),(721,1,0),(722,1,0),(723,1,0),(724,1,0),(725,1,0),(726,1,0),(727,1,0),(728,1,0),(729,1,0),(730,1,0),(731,1,0),(732,1,0),(733,1,0),(734,1,0),(735,1,0),(736,1,0),(737,1,0),(738,1,0),(739,1,0),(740,1,0),(741,1,0),(742,1,0),(743,1,0),(744,1,0),(745,1,0),(746,1,0),(747,1,0),(748,1,0),(749,1,0),(750,1,0),(751,1,0),(752,1,0),(753,1,0),(754,1,0),(755,1,0),(756,1,0),(757,1,0),(758,1,0),(759,1,0),(760,1,0),(761,1,0),(762,1,0),(763,1,0),(764,1,0),(765,1,0),(766,1,0),(767,1,0),(768,1,0),(769,1,0),(770,1,0),(771,1,0),(772,1,0),(773,1,0),(774,1,0),(775,1,0),(776,1,0),(777,1,0),(778,1,0),(779,1,0),(780,1,0),(781,1,0),(782,1,0),(783,1,0),(784,1,0),(785,1,0),(786,1,0),(787,1,0),(788,1,0),(789,1,0),(790,1,0),(791,1,0),(792,1,0),(793,1,0),(794,1,0),(795,1,0),(796,1,0),(797,1,0),(798,1,0),(799,1,0),(800,1,0),(801,1,0),(802,1,0),(803,1,0),(804,1,0),(805,1,0),(806,1,0),(807,1,0),(808,1,0),(809,1,0),(810,1,0),(811,1,0),(812,1,0),(813,1,0),(814,1,0),(815,1,0),(816,1,0),(817,1,0),(818,1,0),(819,1,0),(820,1,0),(821,1,0),(822,1,0),(823,1,0),(824,1,0),(825,1,0),(826,1,0),(827,1,0),(828,1,0),(829,1,0),(830,1,0),(831,1,0),(832,1,0),(833,1,0),(834,1,0),(835,1,0),(836,1,0),(837,1,0),(838,1,0),(839,1,0),(840,1,0),(841,1,0),(842,1,0),(843,1,0),(844,1,0),(845,1,0),(846,1,0),(847,1,0),(848,1,0),(849,1,0),(850,1,0),(851,1,0),(852,1,0),(853,1,0),(854,1,0),(855,1,0),(856,1,0),(857,1,0),(858,1,0),(859,1,0),(860,1,0),(861,1,0),(862,1,0),(863,1,0),(864,1,0),(865,1,0),(866,1,0),(867,1,0),(868,1,0),(869,1,0),(870,1,0),(871,1,0),(872,1,0),(873,1,0),(874,1,0),(875,1,0),(876,1,0),(877,1,0),(878,1,0),(879,1,0),(880,1,0),(881,1,0),(882,1,0),(883,1,0),(884,1,0),(885,1,0),(886,1,0),(887,1,0),(888,1,0),(889,1,0),(890,1,0),(891,1,0),(892,1,0),(893,1,0),(894,1,0),(895,1,0),(896,1,0),(897,1,0),(898,1,0),(899,1,0),(900,1,0),(901,1,0),(902,1,0),(903,1,0),(904,1,0),(905,1,0),(906,1,0),(907,1,0),(908,1,0),(909,1,0),(910,1,0),(911,1,0),(912,1,0),(913,1,0),(914,1,0),(915,1,0),(916,1,0),(917,1,0),(918,1,0),(919,1,0),(920,1,0),(921,1,0),(922,1,0),(923,1,0),(924,1,0),(925,1,0),(926,1,0),(927,1,0),(928,1,0),(929,1,0),(930,1,0),(931,1,0),(932,1,0),(933,1,0),(934,1,0),(935,1,0),(936,1,0),(937,1,0),(938,1,0),(939,1,0),(940,1,0),(941,1,0),(942,1,0),(943,1,0),(944,1,0),(945,1,0),(946,1,0),(947,1,0),(948,1,0),(949,1,0),(950,1,0),(951,1,0),(952,1,0),(953,1,0),(954,1,0),(955,1,0),(956,1,0),(957,1,0),(958,1,0),(959,1,0),(960,1,0),(961,1,0),(962,1,0),(963,1,0),(964,1,0),(965,1,0),(966,1,0),(967,1,0),(968,1,0),(969,1,0),(970,1,0),(971,1,0),(972,1,0),(973,1,0),(974,1,0),(975,1,0),(976,1,0),(977,1,0),(978,1,0),(979,1,0),(980,1,0),(981,1,0),(982,1,0),(983,1,0),(984,1,0),(985,1,0),(986,1,0),(987,1,0),(988,1,0),(989,1,0),(990,1,0),(991,1,0),(992,1,0),(993,1,0),(994,1,0),(995,1,0),(996,1,0),(997,1,0),(998,1,0),(999,1,0),(1000,1,0),(1001,1,0),(1002,1,0),(1003,1,0),(1004,1,0),(1005,1,0),(1006,1,0),(1007,1,0),(1008,1,0),(1009,1,0),(1010,1,0),(1011,1,0),(1012,1,0),(1013,1,0),(1014,1,0),(1015,1,0),(1016,1,0),(1017,1,0),(1018,1,0),(1019,1,0),(1020,1,0),(1021,1,0),(1022,1,0),(1023,1,0),(1024,1,0),(1025,1,0),(1026,1,0),(1027,1,0),(1028,1,0),(1029,1,0),(1030,1,0),(1031,1,0),(1032,1,0),(1033,1,0),(1034,1,0),(1035,1,0),(1036,1,0),(1037,1,0),(1038,1,0),(1039,1,0),(1040,1,0),(1041,1,0),(1042,1,0),(1043,1,0),(1044,1,0),(1045,1,0),(1046,1,0),(1047,1,0),(1048,1,0),(1049,1,0),(1050,1,0),(1051,1,0),(1052,1,0),(1053,1,0),(1054,1,0),(1055,1,0),(1056,1,0),(1057,1,0),(1058,1,0),(1059,1,0),(1060,1,0),(1061,1,0),(1062,1,0),(1063,1,0),(1064,1,0),(1065,1,0),(1066,1,0),(1067,1,0),(1068,1,0),(1069,1,0),(1070,1,0),(1071,1,0),(1072,1,0),(1073,1,0),(1074,1,0),(1075,1,0),(1076,1,0),(1077,1,0),(1078,1,0),(1079,1,0),(1080,1,0),(1081,1,0),(1082,1,0),(1083,1,0),(1084,1,0),(1085,1,0),(1086,1,0),(1087,1,0),(1088,1,0),(1089,1,0),(1090,1,0),(1091,1,0),(1092,1,0),(1093,1,0),(1094,1,0),(1095,1,0),(1096,1,0),(1097,1,0),(1098,1,0),(1099,1,0),(1100,1,0),(1101,1,0),(1102,1,0),(1103,1,0),(1104,1,0),(1105,1,0),(1106,1,0),(1107,1,0),(1108,1,0),(1109,1,0),(1110,1,0),(1111,1,0),(1112,1,0),(1113,1,0),(1114,1,0),(1115,1,0),(1116,1,0),(1117,1,0),(1118,1,0),(1119,1,0),(1120,1,0),(1121,1,0),(1122,1,0),(1123,1,0),(1124,1,0),(1125,1,0),(1126,1,0),(1127,1,0),(1128,1,0),(1129,1,0),(1130,1,0),(1131,1,0),(1132,1,0),(1133,1,0),(1134,1,0),(1135,1,0),(1136,1,0),(1137,1,0),(1138,1,0),(1139,1,0),(1140,1,0),(1141,1,0),(1142,1,0),(1143,1,0),(1144,1,0),(1145,1,0),(1146,1,0),(1147,1,0),(1148,1,0),(1149,1,0),(1150,1,0),(1151,1,0),(1152,1,0),(1153,1,0),(1154,1,0),(1155,1,0),(1156,1,0);
/*!40000 ALTER TABLE `mageworx_shippingrules_extended_regions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_extended_zone`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_extended_zone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_extended_zone` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id',
  `priority` int NOT NULL DEFAULT '0' COMMENT 'Priority (Sort Order)',
  `is_active` int NOT NULL DEFAULT '0' COMMENT 'Is Active',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `description` text COMMENT 'Description',
  `image` varchar(255) DEFAULT NULL COMMENT 'Image',
  `countries_id` text NOT NULL COMMENT 'Countries',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Creation Time',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Update Time',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `MAGEWORX_SHIPPINGRULES_EXTENDED_ZONE_NAME` (`name`),
  KEY `MAGEWORX_SHIPPINGRULES_EXTENDED_ZONE_ENTITY_ID` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Zones Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_extended_zone`
--

LOCK TABLES `mageworx_shippingrules_extended_zone` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_extended_zone` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_extended_zone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_extended_zone_labels`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_extended_zone_labels`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_extended_zone_labels` (
  `label_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Label Id',
  `zone_id` int unsigned NOT NULL COMMENT 'Zone Id',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store Id',
  `label` varchar(255) DEFAULT NULL COMMENT 'Label',
  PRIMARY KEY (`label_id`),
  UNIQUE KEY `MAGEWORX_SHIPPINGRULES_EXTENDED_ZONE_LABELS_ZONE_ID_STORE_ID` (`zone_id`,`store_id`),
  KEY `MAGEWORX_SHIPPINGRULES_EXTENDED_ZONE_LABELS_STORE_ID` (`store_id`),
  CONSTRAINT `FK_CDDB3B09AD4CF22C93AD0C468A82B223` FOREIGN KEY (`zone_id`) REFERENCES `mageworx_shippingrules_extended_zone` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_SHPPRULES_EXTENDED_ZONE_LBLS_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules Pop-up Zones Label';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_extended_zone_labels`
--

LOCK TABLES `mageworx_shippingrules_extended_zone_labels` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_extended_zone_labels` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_extended_zone_labels` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_extended_zone_store`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_extended_zone_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_extended_zone_store` (
  `zone_id` int unsigned NOT NULL COMMENT 'Pop-up Zone Id',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store View Id',
  PRIMARY KEY (`zone_id`,`store_id`),
  KEY `MAGEWORX_SHIPPINGRULES_EXTENDED_ZONE_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `FK_C490BA33012FB4789D657FD24B4263B6` FOREIGN KEY (`zone_id`) REFERENCES `mageworx_shippingrules_extended_zone` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_SHPPRULES_EXTENDED_ZONE_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Pop-up Zones To Stores Relations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_extended_zone_store`
--

LOCK TABLES `mageworx_shippingrules_extended_zone_store` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_extended_zone_store` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_extended_zone_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_method_edt_store_specific_message`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_method_edt_store_specific_message`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_method_edt_store_specific_message` (
  `message_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Label Id',
  `method_id` int unsigned NOT NULL COMMENT 'Method Id',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store Id',
  `message` varchar(255) DEFAULT NULL COMMENT 'Message',
  PRIMARY KEY (`message_id`),
  UNIQUE KEY `UNQ_6E9A553B99F1243D7F2B215C7B19114E` (`method_id`,`store_id`),
  KEY `MAGEWORX_SHPPRULES_METHOD_EDT_STORE_SPECIFIC_MESSAGE_STORE_ID` (`store_id`),
  CONSTRAINT `FK_1C71A6389129223B8E617D8C444F4156` FOREIGN KEY (`method_id`) REFERENCES `mageworx_shippingrules_methods` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_31A76D915F4B9105F45D20EFAB45998D` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules Estimated Delivery Time store specific message';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_method_edt_store_specific_message`
--

LOCK TABLES `mageworx_shippingrules_method_edt_store_specific_message` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_method_edt_store_specific_message` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_method_edt_store_specific_message` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_methods`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_methods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_methods` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id',
  `code` varchar(64) DEFAULT NULL COMMENT 'Method Code',
  `active` smallint NOT NULL DEFAULT '0' COMMENT 'Is Active',
  `title` text COMMENT 'Method Title',
  `price` decimal(14,4) DEFAULT NULL,
  `cost` decimal(14,4) DEFAULT NULL,
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Creation Time',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Update Time',
  `disabled_without_valid_rates` smallint DEFAULT NULL COMMENT 'Method without any valid rate should be disabled',
  `max_price_threshold` decimal(14,4) DEFAULT NULL,
  `min_price_threshold` decimal(14,4) DEFAULT NULL,
  `ignore_virtual_products_price` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Ignore price of virtual products in cart',
  `use_price_with_discount` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Use subtotal with discount in price condition of the Rate',
  `multiple_rates_price` smallint DEFAULT NULL COMMENT 'Multiple Rates price calculation type',
  `replaceable_title` smallint NOT NULL DEFAULT '1' COMMENT 'Replace title from valid rate',
  `description` text COMMENT 'Method description',
  `show_description` smallint NOT NULL DEFAULT '0' COMMENT 'Show description on the frontend flag',
  `image` varchar(255) DEFAULT NULL COMMENT 'Method image',
  `show_image` smallint NOT NULL DEFAULT '0' COMMENT 'Show image on the frontend flag',
  `replaceable_estimated_delivery_time` smallint NOT NULL DEFAULT '1' COMMENT 'Replace Estimated delivery time from a valid rate',
  `estimated_delivery_time_min` decimal(12,2) DEFAULT NULL COMMENT 'Estimated delivery time Min',
  `estimated_delivery_time_max` decimal(12,2) DEFAULT NULL COMMENT 'Estimated delivery time Max',
  `estimated_delivery_time_display_type` smallint NOT NULL DEFAULT '0' COMMENT 'Estimated delivery time data type: Days or Hours',
  `estimated_delivery_time_message` varchar(255) DEFAULT NULL COMMENT 'Estimated delivery time message to display on front-end',
  `show_estimated_delivery_time` smallint NOT NULL DEFAULT '0' COMMENT 'Show estimated delivery time on the frontend flag',
  `allow_free_shipping` smallint NOT NULL DEFAULT '0' COMMENT 'Allow Free Shipping flag (by third-party modules as sales rule)',
  `carrier_code` varchar(64) NOT NULL COMMENT 'Carrier Code (relation)',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `MAGEWORX_SHIPPINGRULES_METHODS_CODE_CARRIER_CODE` (`code`,`carrier_code`),
  KEY `FK_BB67FE8B044EF3B3B15D1E0DD3C2668E` (`carrier_code`),
  KEY `MAGEWORX_SHIPPINGRULES_METHODS_ENTITY_ID` (`entity_id`),
  KEY `MAGEWORX_SHIPPINGRULES_METHODS_CODE` (`code`),
  CONSTRAINT `FK_BB67FE8B044EF3B3B15D1E0DD3C2668E` FOREIGN KEY (`carrier_code`) REFERENCES `mageworx_shippingrules_carrier` (`carrier_code`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COMMENT='Artificial Carriers Methods Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_methods`
--

LOCK TABLES `mageworx_shippingrules_methods` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_methods` DISABLE KEYS */;
INSERT INTO `mageworx_shippingrules_methods` VALUES (2,'gazcofire',1,'Shipping Test ',45.0000,23.0000,'2025-01-08 07:28:53','2025-01-08 07:28:53',0,0.0000,0.0000,0,0,0,1,NULL,0,NULL,0,0,5.00,7.00,0,NULL,0,0,'gazco');
/*!40000 ALTER TABLE `mageworx_shippingrules_methods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_methods_label`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_methods_label`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_methods_label` (
  `label_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Label Id',
  `method_id` int unsigned NOT NULL COMMENT 'Method Id',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store Id',
  `label` varchar(255) DEFAULT NULL COMMENT 'Label',
  PRIMARY KEY (`label_id`),
  UNIQUE KEY `MAGEWORX_SHIPPINGRULES_METHODS_LABEL_METHOD_ID_STORE_ID` (`method_id`,`store_id`),
  KEY `MAGEWORX_SHIPPINGRULES_METHODS_LABEL_STORE_ID` (`store_id`),
  CONSTRAINT `FK_C91E0C78029DE8FF286E437CDA63694F` FOREIGN KEY (`method_id`) REFERENCES `mageworx_shippingrules_methods` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_SHIPPINGRULES_METHODS_LABEL_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules Method Label';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_methods_label`
--

LOCK TABLES `mageworx_shippingrules_methods_label` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_methods_label` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_methods_label` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_methods_store`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_methods_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_methods_store` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity Id',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store View Id',
  PRIMARY KEY (`entity_id`,`store_id`),
  KEY `MAGEWORX_SHIPPINGRULES_METHODS_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `FK_4DA04BD791FC9A30CAD1C7FD9BBB89EF` FOREIGN KEY (`entity_id`) REFERENCES `mageworx_shippingrules_methods` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_SHIPPINGRULES_METHODS_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules Entity To Stores Relations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_methods_store`
--

LOCK TABLES `mageworx_shippingrules_methods_store` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_methods_store` DISABLE KEYS */;
INSERT INTO `mageworx_shippingrules_methods_store` VALUES (2,0);
/*!40000 ALTER TABLE `mageworx_shippingrules_methods_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_rates`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_rates`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_rates` (
  `rate_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id',
  `priority` int NOT NULL DEFAULT '0' COMMENT 'Priority',
  `active` smallint NOT NULL DEFAULT '0' COMMENT 'Is Active',
  `rate_method_price` smallint NOT NULL DEFAULT '0' COMMENT 'Rate price calculation type',
  `title` text COMMENT 'Rate Title',
  `price_from` decimal(14,4) DEFAULT NULL,
  `price_to` decimal(14,4) DEFAULT NULL,
  `qty_from` decimal(14,4) DEFAULT NULL,
  `qty_to` decimal(14,4) DEFAULT NULL,
  `weight_from` decimal(14,4) DEFAULT NULL,
  `weight_to` decimal(14,4) DEFAULT NULL,
  `price` decimal(14,4) DEFAULT NULL,
  `price_per_product` decimal(14,4) DEFAULT NULL,
  `price_per_item` decimal(14,4) DEFAULT NULL,
  `price_percent_per_product` decimal(14,4) DEFAULT NULL,
  `price_percent_per_item` decimal(14,4) DEFAULT NULL,
  `item_price_percent` decimal(14,4) DEFAULT NULL,
  `price_per_weight` decimal(14,4) DEFAULT NULL,
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Creation Time',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Update Time',
  `estimated_delivery_time_min` decimal(12,2) DEFAULT NULL COMMENT 'Estimated delivery time Min',
  `estimated_delivery_time_max` decimal(12,2) DEFAULT NULL COMMENT 'Estimated delivery time Max',
  `method_code` varchar(64) NOT NULL COMMENT 'Method Code (relation)',
  `rate_code` varchar(64) DEFAULT NULL COMMENT 'Rate Code',
  `zip_format` varchar(32) NOT NULL DEFAULT 'numeric' COMMENT 'Zip Code Format',
  `zip_validation_mode` int NOT NULL DEFAULT '0' COMMENT 'Zip Validation Mode',
  PRIMARY KEY (`rate_id`),
  UNIQUE KEY `MAGEWORX_SHIPPINGRULES_RATES_RATE_CODE` (`rate_code`),
  KEY `FK_E1961EF89461BD2F33816CBAF777F7BA` (`method_code`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_RATE_ID` (`rate_id`),
  CONSTRAINT `FK_E1961EF89461BD2F33816CBAF777F7BA` FOREIGN KEY (`method_code`) REFERENCES `mageworx_shippingrules_methods` (`code`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Method Rates Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_rates`
--

LOCK TABLES `mageworx_shippingrules_rates` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_rates_country`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_rates_country`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_rates_country` (
  `rate_id` int unsigned NOT NULL COMMENT 'Rate Id',
  `country_code` varchar(8) NOT NULL COMMENT 'Country Code',
  PRIMARY KEY (`rate_id`,`country_code`),
  CONSTRAINT `FK_5A291E1902774958099959F18A63A064` FOREIGN KEY (`rate_id`) REFERENCES `mageworx_shippingrules_rates` (`rate_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules Rates & Countries Relations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_rates_country`
--

LOCK TABLES `mageworx_shippingrules_rates_country` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_country` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_country` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_rates_dump`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_rates_dump`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_rates_dump` (
  `rate_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Id',
  `priority` int NOT NULL DEFAULT '0' COMMENT 'Priority',
  `active` smallint NOT NULL DEFAULT '0' COMMENT 'Is Active',
  `rate_method_price` smallint NOT NULL DEFAULT '0' COMMENT 'Rate price calculation type',
  `title` text COMMENT 'Rate Title',
  `price_from` decimal(14,4) DEFAULT NULL,
  `price_to` decimal(14,4) DEFAULT NULL,
  `qty_from` decimal(14,4) DEFAULT NULL,
  `qty_to` decimal(14,4) DEFAULT NULL,
  `weight_from` decimal(14,4) DEFAULT NULL,
  `weight_to` decimal(14,4) DEFAULT NULL,
  `price` decimal(14,4) DEFAULT NULL,
  `price_per_product` decimal(14,4) DEFAULT NULL,
  `price_per_item` decimal(14,4) DEFAULT NULL,
  `price_percent_per_product` decimal(14,4) DEFAULT NULL,
  `price_percent_per_item` decimal(14,4) DEFAULT NULL,
  `item_price_percent` decimal(14,4) DEFAULT NULL,
  `price_per_weight` decimal(14,4) DEFAULT NULL,
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Creation Time',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Update Time',
  `estimated_delivery_time_min` decimal(12,2) DEFAULT NULL COMMENT 'Estimated delivery time Min',
  `estimated_delivery_time_max` decimal(12,2) DEFAULT NULL COMMENT 'Estimated delivery time Max',
  `method_code` varchar(64) NOT NULL COMMENT 'Method Code (relation)',
  `rate_code` varchar(64) DEFAULT NULL COMMENT 'Rate Code',
  `zip_format` varchar(32) NOT NULL DEFAULT 'numeric' COMMENT 'Zip Code Format',
  `zip_validation_mode` int NOT NULL DEFAULT '0' COMMENT 'Zip Validation Mode'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_rates_dump`
--

LOCK TABLES `mageworx_shippingrules_rates_dump` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_dump` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_dump` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_rates_label`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_rates_label`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_rates_label` (
  `label_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Label Id',
  `rate_id` int unsigned NOT NULL COMMENT 'Rate Id',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store Id',
  `label` varchar(255) DEFAULT NULL COMMENT 'Label',
  PRIMARY KEY (`label_id`),
  UNIQUE KEY `MAGEWORX_SHIPPINGRULES_RATES_LABEL_RATE_ID_STORE_ID` (`rate_id`,`store_id`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_LABEL_STORE_ID` (`store_id`),
  CONSTRAINT `FK_5FB101362556A17015F9AA5FFF0667B5` FOREIGN KEY (`rate_id`) REFERENCES `mageworx_shippingrules_rates` (`rate_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_SHIPPINGRULES_RATES_LABEL_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules Rate Labels';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_rates_label`
--

LOCK TABLES `mageworx_shippingrules_rates_label` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_label` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_label` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_rates_region`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_rates_region`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_rates_region` (
  `rate_id` int unsigned NOT NULL COMMENT 'Rate Id',
  `region` varchar(64) NOT NULL COMMENT 'Region',
  PRIMARY KEY (`rate_id`,`region`),
  CONSTRAINT `FK_F60B217C2E46CF0CAEF15878A0FD5FB0` FOREIGN KEY (`rate_id`) REFERENCES `mageworx_shippingrules_rates` (`rate_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules Rates & Region Relations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_rates_region`
--

LOCK TABLES `mageworx_shippingrules_rates_region` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_region` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_region` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_rates_region_id`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_rates_region_id`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_rates_region_id` (
  `rate_id` int unsigned NOT NULL COMMENT 'Rate Id',
  `region_id` int unsigned NOT NULL COMMENT 'Region Id',
  PRIMARY KEY (`rate_id`,`region_id`),
  CONSTRAINT `FK_9BE408B5A883474E44936EB06A246F8E` FOREIGN KEY (`rate_id`) REFERENCES `mageworx_shippingrules_rates` (`rate_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules Rates & Region Ids Relations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_rates_region_id`
--

LOCK TABLES `mageworx_shippingrules_rates_region_id` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_region_id` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_region_id` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_rates_store`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_rates_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_rates_store` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity Id',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store View Id',
  PRIMARY KEY (`entity_id`,`store_id`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `FK_418629243AD087E35776BDDC6A5869A1` FOREIGN KEY (`entity_id`) REFERENCES `mageworx_shippingrules_rates` (`rate_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_SHIPPINGRULES_RATES_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules Entity To Stores Relations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_rates_store`
--

LOCK TABLES `mageworx_shippingrules_rates_store` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_store` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_rates_zips`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_rates_zips`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_rates_zips` (
  `rate_id` int unsigned NOT NULL COMMENT 'Rate Id',
  `zip` varchar(18) NOT NULL COMMENT 'Zip',
  `inverted` tinyint(1) NOT NULL COMMENT 'Is zip inverted (Not In)',
  PRIMARY KEY (`rate_id`,`zip`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_ZIP` (`zip`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_INVERTED` (`inverted`),
  CONSTRAINT `FK_CFA3AFD72F9D487760886F2D3BD67ED7` FOREIGN KEY (`rate_id`) REFERENCES `mageworx_shippingrules_rates` (`rate_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules Zips to Rates Relations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_rates_zips`
--

LOCK TABLES `mageworx_shippingrules_rates_zips` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_zips` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_zips` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_rates_zips_diapason_alphanumeric`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_rates_zips_diapason_alphanumeric`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_rates_zips_diapason_alphanumeric` (
  `rate_id` int unsigned NOT NULL COMMENT 'Rate Id',
  `from` varchar(12) NOT NULL COMMENT 'Zip From',
  `to` varchar(12) NOT NULL COMMENT 'Zip To',
  `inverted` tinyint(1) NOT NULL COMMENT 'Is diapason inverted (Not In)',
  PRIMARY KEY (`rate_id`,`from`,`to`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_ALPHANUMERIC_INVERTED` (`inverted`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_ALPHANUMERIC_FROM` (`from`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_ALPHANUMERIC_TO` (`to`),
  CONSTRAINT `FK_2583E58E3E1031E961F36DE132BC91C7` FOREIGN KEY (`rate_id`) REFERENCES `mageworx_shippingrules_rates` (`rate_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules Zips From-To/Rate Relations Table for (Numeric format)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_rates_zips_diapason_alphanumeric`
--

LOCK TABLES `mageworx_shippingrules_rates_zips_diapason_alphanumeric` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_zips_diapason_alphanumeric` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_zips_diapason_alphanumeric` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_rates_zips_diapason_nl`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_rates_zips_diapason_nl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_rates_zips_diapason_nl` (
  `rate_id` int unsigned NOT NULL COMMENT 'Rate Id',
  `from` varchar(8) NOT NULL COMMENT 'Zip From Link',
  `to` varchar(8) NOT NULL COMMENT 'Zip To Link',
  `from_digit_part` int DEFAULT NULL COMMENT 'From Digit Part Of Zip',
  `from_letter_part` varchar(2) DEFAULT NULL COMMENT 'From Letter Part Of Zip',
  `to_digit_part` int DEFAULT NULL COMMENT 'To Digit Part Of Zip',
  `to_letter_part` varchar(2) DEFAULT NULL COMMENT 'To Letter Part Of Zip',
  `inverted` tinyint(1) NOT NULL COMMENT 'Is diapason inverted (Not In)',
  PRIMARY KEY (`rate_id`,`from`,`to`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_NL_INVERTED` (`inverted`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_NL_FROM_DIGIT_PART` (`from_digit_part`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_NL_FROM_LETTER_PART` (`from_letter_part`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_NL_TO_DIGIT_PART` (`to_digit_part`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_NL_TO_LETTER_PART` (`to_letter_part`),
  CONSTRAINT `FK_9F9DBC58FBD7B7F199E34CC121582DEB` FOREIGN KEY (`rate_id`) REFERENCES `mageworx_shippingrules_rates` (`rate_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules Zips From-To/Rate Relations Table for (Numeric format)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_rates_zips_diapason_nl`
--

LOCK TABLES `mageworx_shippingrules_rates_zips_diapason_nl` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_zips_diapason_nl` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_zips_diapason_nl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_rates_zips_diapason_numeric`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_rates_zips_diapason_numeric`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_rates_zips_diapason_numeric` (
  `rate_id` int unsigned NOT NULL COMMENT 'Rate Id',
  `from` int NOT NULL COMMENT 'Zip From',
  `to` int NOT NULL COMMENT 'Zip To',
  `inverted` tinyint(1) NOT NULL COMMENT 'Is diapason inverted (Not In)',
  PRIMARY KEY (`rate_id`,`from`,`to`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_NUMERIC_INVERTED` (`inverted`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_NUMERIC_FROM` (`from`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_NUMERIC_TO` (`to`),
  CONSTRAINT `FK_8B74DC3471C96A8CA70832BB6A261F3F` FOREIGN KEY (`rate_id`) REFERENCES `mageworx_shippingrules_rates` (`rate_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules Zips From-To/Rate Relations Table for (Numeric format)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_rates_zips_diapason_numeric`
--

LOCK TABLES `mageworx_shippingrules_rates_zips_diapason_numeric` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_zips_diapason_numeric` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_zips_diapason_numeric` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_rates_zips_diapason_uk`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_rates_zips_diapason_uk`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_rates_zips_diapason_uk` (
  `rate_id` int unsigned NOT NULL COMMENT 'Rate Id',
  `from` varchar(8) NOT NULL COMMENT 'Zip From As Is',
  `to` varchar(8) NOT NULL COMMENT 'Zip To As Is',
  `from_area` varchar(2) DEFAULT NULL COMMENT 'From UK Zip Area',
  `from_district_number` int DEFAULT NULL COMMENT 'From UK Zip District (Numeric Part)',
  `from_district_letter` varchar(1) DEFAULT NULL COMMENT 'From UK Zip District (Letter Part)',
  `from_sector` int DEFAULT NULL COMMENT 'From UK Zip Sector',
  `from_unit` varchar(2) DEFAULT NULL COMMENT 'From UK Zip Unit',
  `to_area` varchar(2) DEFAULT NULL COMMENT 'To UK Zip Area',
  `to_district_number` int DEFAULT NULL COMMENT 'To UK Zip District (Numeric Part)',
  `to_district_letter` varchar(1) DEFAULT NULL COMMENT 'To UK Zip District (Letter Part)',
  `to_sector` int DEFAULT NULL COMMENT 'To UK Zip Sector',
  `to_unit` varchar(2) DEFAULT NULL COMMENT 'To UK Zip Unit',
  `inverted` tinyint(1) NOT NULL COMMENT 'Is diapason inverted (Not In)',
  PRIMARY KEY (`rate_id`,`from`,`to`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_UK_INVERTED` (`inverted`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_UK_FROM_AREA` (`from_area`),
  KEY `MAGEWORX_SHPPRULES_RATES_ZIPS_DIAPASON_UK_FROM_DISTRICT_NUMBER` (`from_district_number`),
  KEY `MAGEWORX_SHPPRULES_RATES_ZIPS_DIAPASON_UK_FROM_DISTRICT_LETTER` (`from_district_letter`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_UK_FROM_SECTOR` (`from_sector`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_UK_FROM_UNIT` (`from_unit`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_UK_TO_AREA` (`to_area`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_UK_TO_DISTRICT_NUMBER` (`to_district_number`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_UK_TO_DISTRICT_LETTER` (`to_district_letter`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_UK_TO_SECTOR` (`to_sector`),
  KEY `MAGEWORX_SHIPPINGRULES_RATES_ZIPS_DIAPASON_UK_TO_UNIT` (`to_unit`),
  CONSTRAINT `FK_74CF65D3ED66ED496DFE699F4EFE2672` FOREIGN KEY (`rate_id`) REFERENCES `mageworx_shippingrules_rates` (`rate_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules Zips From-To/Rate Relations Table for (Numeric format)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_rates_zips_diapason_uk`
--

LOCK TABLES `mageworx_shippingrules_rates_zips_diapason_uk` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_zips_diapason_uk` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_rates_zips_diapason_uk` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_store`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_store` (
  `rule_id` int unsigned NOT NULL COMMENT 'Rule Id',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store View Id',
  PRIMARY KEY (`rule_id`,`store_id`),
  KEY `MAGEWORX_SHIPPINGRULES_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `MAGEWORX_SHIPPINGRULES_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_SHPPRULES_STORE_RULE_ID_MAGEWORX_SHPPRULES_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `mageworx_shippingrules` (`rule_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Rules To Stores Relations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_store`
--

LOCK TABLES `mageworx_shippingrules_store` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_store` DISABLE KEYS */;
INSERT INTO `mageworx_shippingrules_store` VALUES (2,0),(3,1);
/*!40000 ALTER TABLE `mageworx_shippingrules_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_zone`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_zone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_zone` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id',
  `priority` int NOT NULL DEFAULT '0' COMMENT 'Priority',
  `is_active` int NOT NULL DEFAULT '0' COMMENT 'Is Active',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `description` text COMMENT 'Description',
  `conditions_serialized` mediumtext COMMENT 'Conditions Serialized',
  `default_shipping_method` varchar(255) DEFAULT NULL COMMENT 'Default Shipping Method',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Creation Time',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Update Time',
  PRIMARY KEY (`entity_id`),
  KEY `MAGEWORX_SHIPPINGRULES_ZONE_ENTITY_ID` (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Zones Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_zone`
--

LOCK TABLES `mageworx_shippingrules_zone` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_zone` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_zone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mageworx_shippingrules_zone_store`
--

DROP TABLE IF EXISTS `mageworx_shippingrules_zone_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mageworx_shippingrules_zone_store` (
  `zone_id` int unsigned NOT NULL COMMENT 'Zone Id',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store View Id',
  PRIMARY KEY (`zone_id`,`store_id`),
  KEY `MAGEWORX_SHIPPINGRULES_ZONE_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `FK_2274E462724480C9EE0A77F075BBA545` FOREIGN KEY (`zone_id`) REFERENCES `mageworx_shippingrules_zone` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `MAGEWORX_SHIPPINGRULES_ZONE_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='MageWorx Shipping Zones To Stores Relations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mageworx_shippingrules_zone_store`
--

LOCK TABLES `mageworx_shippingrules_zone_store` WRITE;
/*!40000 ALTER TABLE `mageworx_shippingrules_zone_store` DISABLE KEYS */;
/*!40000 ALTER TABLE `mageworx_shippingrules_zone_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magiccart_lookbook`
--

DROP TABLE IF EXISTS `magiccart_lookbook`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magiccart_lookbook` (
  `lookbook_id` int NOT NULL AUTO_INCREMENT COMMENT 'Lookbook ID',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title',
  `identifier` varchar(255) DEFAULT NULL COMMENT 'Identifier',
  `type_id` smallint NOT NULL DEFAULT '1' COMMENT 'Type',
  `link` varchar(255) DEFAULT NULL COMMENT 'Link',
  `image` varchar(255) DEFAULT NULL COMMENT 'Image',
  `options` text COMMENT 'options',
  `stores` varchar(255) DEFAULT NULL COMMENT 'Stores',
  `order` int NOT NULL DEFAULT '0' COMMENT 'Order',
  `status` smallint NOT NULL DEFAULT '1' COMMENT 'Status',
  PRIMARY KEY (`lookbook_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magiccart Lookbook';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magiccart_lookbook`
--

LOCK TABLES `magiccart_lookbook` WRITE;
/*!40000 ALTER TABLE `magiccart_lookbook` DISABLE KEYS */;
/*!40000 ALTER TABLE `magiccart_lookbook` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magiccart_magicmenu`
--

DROP TABLE IF EXISTS `magiccart_magicmenu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magiccart_magicmenu` (
  `magicmenu_id` int NOT NULL AUTO_INCREMENT COMMENT 'Magicmenu ID',
  `cat_id` varchar(255) DEFAULT NULL COMMENT 'Category Id',
  `cat_col` varchar(255) DEFAULT NULL COMMENT 'Columns category',
  `cat_proportion` int NOT NULL DEFAULT '0' COMMENT 'Proportion category',
  `top` varchar(255) DEFAULT NULL COMMENT 'Category content top',
  `right` varchar(255) DEFAULT NULL COMMENT 'Category content right',
  `right_proportion` int NOT NULL DEFAULT '0' COMMENT 'Proportion category content right',
  `bottom` varchar(255) DEFAULT NULL COMMENT 'Category content bottom',
  `left` varchar(255) DEFAULT NULL COMMENT 'Category content right',
  `left_proportion` int NOT NULL DEFAULT '0' COMMENT 'Proportion category content left',
  `name` varchar(255) DEFAULT NULL COMMENT 'Extra menu name',
  `magic_label` varchar(255) DEFAULT NULL COMMENT 'Extra menu label',
  `link` varchar(255) DEFAULT NULL COMMENT 'Extra menu link',
  `ext_content` text COMMENT 'Extra menu content',
  `extra` smallint NOT NULL DEFAULT '0' COMMENT 'Is Extra',
  `stores` varchar(255) DEFAULT NULL COMMENT 'Stores',
  `order` int NOT NULL DEFAULT '0' COMMENT 'Order',
  `status` smallint NOT NULL DEFAULT '1' COMMENT 'Status',
  PRIMARY KEY (`magicmenu_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magiccart Magicmenu';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magiccart_magicmenu`
--

LOCK TABLES `magiccart_magicmenu` WRITE;
/*!40000 ALTER TABLE `magiccart_magicmenu` DISABLE KEYS */;
/*!40000 ALTER TABLE `magiccart_magicmenu` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magiccart_magicproduct`
--

DROP TABLE IF EXISTS `magiccart_magicproduct`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magiccart_magicproduct` (
  `magicproduct_id` int NOT NULL AUTO_INCREMENT COMMENT 'Magicproduct ID',
  `title` varchar(255) NOT NULL COMMENT 'Title',
  `identifier` varchar(255) DEFAULT NULL COMMENT 'Identifier',
  `type_id` smallint NOT NULL DEFAULT '1' COMMENT 'Type',
  `config` mediumtext COMMENT 'Config',
  `status` smallint NOT NULL DEFAULT '1' COMMENT 'Status',
  PRIMARY KEY (`magicproduct_id`),
  KEY `MAGICPRODUCT_IDENTIFIER_IDENTIFIER` (`identifier`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magiccart Magicproduct';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magiccart_magicproduct`
--

LOCK TABLES `magiccart_magicproduct` WRITE;
/*!40000 ALTER TABLE `magiccart_magicproduct` DISABLE KEYS */;
/*!40000 ALTER TABLE `magiccart_magicproduct` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magiccart_magicslider`
--

DROP TABLE IF EXISTS `magiccart_magicslider`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magiccart_magicslider` (
  `magicslider_id` int NOT NULL AUTO_INCREMENT COMMENT 'Magicslider ID',
  `title` varchar(255) NOT NULL COMMENT 'Title',
  `identifier` varchar(255) DEFAULT NULL COMMENT 'Identifier',
  `config` mediumtext COMMENT 'Config',
  `status` smallint NOT NULL DEFAULT '1' COMMENT 'Status',
  `created_time` datetime DEFAULT NULL COMMENT 'Created Time',
  `update_time` datetime DEFAULT NULL COMMENT 'Update Time',
  PRIMARY KEY (`magicslider_id`),
  KEY `MAGICSLIDER_ID_MAGICSLIDER_ID` (`magicslider_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magiccart Magicslider';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magiccart_magicslider`
--

LOCK TABLES `magiccart_magicslider` WRITE;
/*!40000 ALTER TABLE `magiccart_magicslider` DISABLE KEYS */;
/*!40000 ALTER TABLE `magiccart_magicslider` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magiccart_shopbrand`
--

DROP TABLE IF EXISTS `magiccart_shopbrand`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magiccart_shopbrand` (
  `shopbrand_id` int NOT NULL AUTO_INCREMENT COMMENT 'Brand ID',
  `title` varchar(255) NOT NULL COMMENT 'Title',
  `urlkey` varchar(255) DEFAULT NULL COMMENT 'Urlkey',
  `meta_key` varchar(255) DEFAULT NULL COMMENT 'Meta_key',
  `meta_description` varchar(255) DEFAULT NULL COMMENT 'Meta_description',
  `option_id` varchar(255) DEFAULT NULL COMMENT 'Option_id',
  `image` varchar(255) DEFAULT NULL COMMENT 'Image',
  `product_ids` mediumtext COMMENT 'product_ids',
  `stores` varchar(255) DEFAULT NULL COMMENT 'Stores',
  `description` varchar(255) DEFAULT NULL COMMENT 'Description',
  `order` smallint NOT NULL DEFAULT '0' COMMENT 'Order',
  `status` smallint NOT NULL DEFAULT '1' COMMENT 'Status',
  PRIMARY KEY (`shopbrand_id`),
  KEY `SHOPBRAND_ID_SHOPBRAND_ID` (`shopbrand_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magiccart Shopbrand';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magiccart_shopbrand`
--

LOCK TABLES `magiccart_shopbrand` WRITE;
/*!40000 ALTER TABLE `magiccart_shopbrand` DISABLE KEYS */;
/*!40000 ALTER TABLE `magiccart_shopbrand` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magiccart_testimonial`
--

DROP TABLE IF EXISTS `magiccart_testimonial`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `magiccart_testimonial` (
  `testimonial_id` int NOT NULL AUTO_INCREMENT COMMENT 'Testimonial ID',
  `name` varchar(255) NOT NULL COMMENT 'Name',
  `image` varchar(255) DEFAULT NULL COMMENT 'Image',
  `text` mediumtext COMMENT 'product_ids',
  `company` varchar(255) DEFAULT NULL COMMENT 'Company',
  `email` varchar(255) DEFAULT NULL COMMENT 'Email',
  `website` varchar(255) DEFAULT NULL COMMENT 'Website',
  `rating_summary` smallint NOT NULL DEFAULT '5' COMMENT 'Rating Summary',
  `stores` varchar(255) DEFAULT '0' COMMENT 'Stores',
  `order` smallint NOT NULL DEFAULT '0' COMMENT 'Order',
  `status` smallint NOT NULL DEFAULT '1' COMMENT 'Status',
  `created_time` datetime DEFAULT NULL COMMENT 'Created Time',
  `update_time` datetime DEFAULT NULL COMMENT 'Update Time',
  PRIMARY KEY (`testimonial_id`),
  KEY `TESTIMONIAL_ID_TESTIMONIAL_ID` (`testimonial_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Magiccart Testimonial';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magiccart_testimonial`
--

LOCK TABLES `magiccart_testimonial` WRITE;
/*!40000 ALTER TABLE `magiccart_testimonial` DISABLE KEYS */;
/*!40000 ALTER TABLE `magiccart_testimonial` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `maxmind_country_regions`
--

DROP TABLE IF EXISTS `maxmind_country_regions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `maxmind_country_regions` (
  `relation_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Relation ID',
  `region_id` varchar(255) DEFAULT NULL COMMENT 'Region ID',
  `country_id` varchar(3) NOT NULL COMMENT 'Country ID',
  `country_name` varchar(255) DEFAULT NULL COMMENT 'Country Name',
  PRIMARY KEY (`relation_id`),
  UNIQUE KEY `MAXMIND_COUNTRY_REGIONS_REGION_ID_COUNTRY_ID` (`region_id`,`country_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2665 DEFAULT CHARSET=utf8mb3 COMMENT='Maxmind Country Regions Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `maxmind_country_regions`
--

LOCK TABLES `maxmind_country_regions` WRITE;
/*!40000 ALTER TABLE `maxmind_country_regions` DISABLE KEYS */;
INSERT INTO `maxmind_country_regions` VALUES (1,'Andorra la Vella','AD','Andorra'),(2,'Canillo','AD','Andorra'),(3,'Encamp','AD','Andorra'),(4,'Escaldes-Engordany','AD','Andorra'),(5,'La Massana','AD','Andorra'),(6,'Ordino','AD','Andorra'),(7,'Sant Julià de Loria','AD','Andorra'),(8,'Abu Dhabi','AE','United Arab Emirates'),(9,'Ajman','AE','United Arab Emirates'),(10,'Al Fujayrah','AE','United Arab Emirates'),(11,'Ash Shariqah','AE','United Arab Emirates'),(12,'Dubai','AE','United Arab Emirates'),(13,'Ra\'s al Khaymah','AE','United Arab Emirates'),(14,'Herat','AF','Afghanistan'),(15,'Kabul','AF','Afghanistan'),(16,'Kandahar','AF','Afghanistan'),(17,'Zabul','AF','Afghanistan'),(18,'Barbuda','AG','Antigua and Barbuda'),(19,'Parish of Saint George','AG','Antigua and Barbuda'),(20,'Parish of Saint John','AG','Antigua and Barbuda'),(21,'Parish of Saint Mary','AG','Antigua and Barbuda'),(22,'Parish of Saint Paul','AG','Antigua and Barbuda'),(23,'Parish of Saint Peter','AG','Antigua and Barbuda'),(24,'Parish of Saint Philip','AG','Antigua and Barbuda'),(25,NULL,'AI','Anguilla'),(26,'Qarku i Beratit','AL','Albania'),(27,'Qarku i Dibres','AL','Albania'),(28,'Qarku i Durresit','AL','Albania'),(29,'Qarku i Elbasanit','AL','Albania'),(30,'Qarku i Fierit','AL','Albania'),(31,'Qarku i Gjirokastres','AL','Albania'),(32,'Qarku i Korces','AL','Albania'),(33,'Qarku i Kukesit','AL','Albania'),(34,'Qarku i Lezhes','AL','Albania'),(35,'Qarku i Shkodres','AL','Albania'),(36,'Qarku i Tiranes','AL','Albania'),(37,'Qarku i Vlores','AL','Albania'),(38,'Aragatsotn Province','AM','Armenia'),(39,'Ararat Province','AM','Armenia'),(40,'Armavir Province','AM','Armenia'),(41,'Gegharkunik Province','AM','Armenia'),(42,'Kotayk Province','AM','Armenia'),(43,'Lori Province','AM','Armenia'),(44,'Shirak Province','AM','Armenia'),(45,'Syunik Province','AM','Armenia'),(46,'Tavush Province','AM','Armenia'),(47,'Yerevan','AM','Armenia'),(48,'Bengo Province','AO','Angola'),(49,'Benguela','AO','Angola'),(50,'Bíe','AO','Angola'),(51,'Cabinda','AO','Angola'),(52,'Cuando Cobango','AO','Angola'),(53,'Cuanza Norte Province','AO','Angola'),(54,'Cunene Province','AO','Angola'),(55,'Huambo','AO','Angola'),(56,'Luanda Norte','AO','Angola'),(57,'Luanda Province','AO','Angola'),(58,'Lunda Sul','AO','Angola'),(59,'Malanje Province','AO','Angola'),(60,'Moxico','AO','Angola'),(61,'Namibe Province','AO','Angola'),(62,'Uíge','AO','Angola'),(63,NULL,'AQ','Antarctica'),(64,'Buenos Aires','AR','Argentina'),(65,'Buenos Aires F.D.','AR','Argentina'),(66,'Catamarca Province','AR','Argentina'),(67,'Chaco Province','AR','Argentina'),(68,'Chubut Province','AR','Argentina'),(69,'Cordoba Province','AR','Argentina'),(70,'Corrientes Province','AR','Argentina'),(71,'Entre Ríos Province','AR','Argentina'),(72,'Formosa Province','AR','Argentina'),(73,'Jujuy Province','AR','Argentina'),(74,'La Pampa Province','AR','Argentina'),(75,'La Rioja Province','AR','Argentina'),(76,'Mendoza Province','AR','Argentina'),(77,'Misiones Province','AR','Argentina'),(78,'Neuquén Province','AR','Argentina'),(79,'Río Negro Province','AR','Argentina'),(80,'Salta Province','AR','Argentina'),(81,'San Juan Province','AR','Argentina'),(82,'San Luis Province','AR','Argentina'),(83,'Santa Cruz Province','AR','Argentina'),(84,'Santa Fe Province','AR','Argentina'),(85,'Santiago del Estero Province','AR','Argentina'),(86,'Tierra del Fuego Province','AR','Argentina'),(87,'Tucumán Province','AR','Argentina'),(88,'Eastern District','AS','American Samoa'),(89,'Burgenland','AT','Austria'),(90,'Carinthia','AT','Austria'),(91,'Lower Austria','AT','Austria'),(92,'Salzburg','AT','Austria'),(93,'Styria','AT','Austria'),(94,'Tyrol','AT','Austria'),(95,'Upper Austria','AT','Austria'),(96,'Vienna','AT','Austria'),(97,'Vorarlberg','AT','Austria'),(98,'Australian Capital Territory','AU','Australia'),(99,'New South Wales','AU','Australia'),(100,'Northern Territory','AU','Australia'),(101,'Queensland','AU','Australia'),(102,'South Australia','AU','Australia'),(103,'Tasmania','AU','Australia'),(104,'Victoria','AU','Australia'),(105,'Western Australia','AU','Australia'),(106,NULL,'AW','Aruba'),(107,NULL,'AX','Åland'),(108,'Baku City','AZ','Azerbaijan'),(109,'Imishli Rayon','AZ','Azerbaijan'),(110,'Nakhichevan','AZ','Azerbaijan'),(111,'Qusar Rayon','AZ','Azerbaijan'),(112,'Sabirabad Rayon','AZ','Azerbaijan'),(113,'Sumqayit City','AZ','Azerbaijan'),(114,'Brčko','BA','Bosnia and Herzegovina'),(115,'Federation of Bosnia and Herzegovina','BA','Bosnia and Herzegovina'),(116,'Republic of Srspka','BA','Bosnia and Herzegovina'),(117,'Christ Church','BB','Barbados'),(118,'Saint Andrew','BB','Barbados'),(119,'Saint George','BB','Barbados'),(120,'Saint James','BB','Barbados'),(121,'Saint Joseph','BB','Barbados'),(122,'Saint Lucy','BB','Barbados'),(123,'Saint Michael','BB','Barbados'),(124,'Saint Philip','BB','Barbados'),(125,'Saint Thomas','BB','Barbados'),(126,'Barisal Division','BD','Bangladesh'),(127,'Chittagong','BD','Bangladesh'),(128,'Dhaka Division','BD','Bangladesh'),(129,'Khulna Division','BD','Bangladesh'),(130,'Rajshahi Division','BD','Bangladesh'),(131,'Rangpur Division','BD','Bangladesh'),(132,'Sylhet Division','BD','Bangladesh'),(133,'Brussels Capital','BE','Belgium'),(134,'Flanders','BE','Belgium'),(135,'Wallonia','BE','Belgium'),(136,'Cascades Region','BF','Burkina Faso'),(137,'Centre','BF','Burkina Faso'),(138,'Hauts-Bassins','BF','Burkina Faso'),(139,'Blagoevgrad','BG','Bulgaria'),(140,'Burgas','BG','Bulgaria'),(141,'Gabrovo','BG','Bulgaria'),(142,'Haskovo','BG','Bulgaria'),(143,'Lovech','BG','Bulgaria'),(144,'Oblast Dobrich','BG','Bulgaria'),(145,'Oblast Kardzhali','BG','Bulgaria'),(146,'Oblast Kyustendil','BG','Bulgaria'),(147,'Oblast Montana','BG','Bulgaria'),(148,'Oblast Pleven','BG','Bulgaria'),(149,'Oblast Razgrad','BG','Bulgaria'),(150,'Oblast Ruse','BG','Bulgaria'),(151,'Oblast Shumen','BG','Bulgaria'),(152,'Oblast Silistra','BG','Bulgaria'),(153,'Oblast Sliven','BG','Bulgaria'),(154,'Oblast Smolyan','BG','Bulgaria'),(155,'Oblast Stara Zagora','BG','Bulgaria'),(156,'Oblast Targovishte','BG','Bulgaria'),(157,'Oblast Veliko Tarnovo','BG','Bulgaria'),(158,'Oblast Vidin','BG','Bulgaria'),(159,'Oblast Vratsa','BG','Bulgaria'),(160,'Oblast Yambol','BG','Bulgaria'),(161,'Pazardzhik','BG','Bulgaria'),(162,'Pernik','BG','Bulgaria'),(163,'Plovdiv','BG','Bulgaria'),(164,'Sofia Province','BG','Bulgaria'),(165,'Sofia-Capital','BG','Bulgaria'),(166,'Varna','BG','Bulgaria'),(167,'Central Governorate','BH','Bahrain'),(168,'Manama','BH','Bahrain'),(169,'Muharraq','BH','Bahrain'),(170,'Southern Governorate','BH','Bahrain'),(171,'Bujumbura Mairie Province','BI','Burundi'),(172,'Atlantique Department','BJ','Benin'),(173,'Littoral','BJ','Benin'),(174,NULL,'BL','Saint-Barthélemy'),(175,'Hamilton city','BM','Bermuda'),(176,'Saint George','BM','Bermuda'),(177,'Sandys Parish','BM','Bermuda'),(178,'Belait District','BN','Brunei'),(179,'Brunei and Muara District','BN','Brunei'),(180,'Temburong District','BN','Brunei'),(181,'Tutong District','BN','Brunei'),(182,'Departamento de Chuquisaca','BO','Bolivia'),(183,'Departamento de Cochabamba','BO','Bolivia'),(184,'Departamento de La Paz','BO','Bolivia'),(185,'Departamento de Pando','BO','Bolivia'),(186,'Departamento de Potosi','BO','Bolivia'),(187,'Departamento de Santa Cruz','BO','Bolivia'),(188,'Departamento de Tarija','BO','Bolivia'),(189,'El Beni','BO','Bolivia'),(190,'Oruro','BO','Bolivia'),(191,'Bonaire','BQ','Bonaire, Sint Eustatius, and Saba'),(192,'Saba','BQ','Bonaire, Sint Eustatius, and Saba'),(193,'Acre','BR','Brazil'),(194,'Alagoas','BR','Brazil'),(195,'Amapa','BR','Brazil'),(196,'Amazonas','BR','Brazil'),(197,'Bahia','BR','Brazil'),(198,'Ceara','BR','Brazil'),(199,'Espirito Santo','BR','Brazil'),(200,'Federal District','BR','Brazil'),(201,'Goias','BR','Brazil'),(202,'Maranhao','BR','Brazil'),(203,'Mato Grosso','BR','Brazil'),(204,'Mato Grosso do Sul','BR','Brazil'),(205,'Minas Gerais','BR','Brazil'),(206,'Para','BR','Brazil'),(207,'Parana','BR','Brazil'),(208,'Paraíba','BR','Brazil'),(209,'Pernambuco','BR','Brazil'),(210,'Piaui','BR','Brazil'),(211,'Rio Grande do Norte','BR','Brazil'),(212,'Rio Grande do Sul','BR','Brazil'),(213,'Rio de Janeiro','BR','Brazil'),(214,'Rondonia','BR','Brazil'),(215,'Roraima','BR','Brazil'),(216,'Santa Catarina','BR','Brazil'),(217,'Sao Paulo','BR','Brazil'),(218,'Sergipe','BR','Brazil'),(219,'Tocantins','BR','Brazil'),(220,'Bimini','BS','Bahamas'),(221,'Central Abaco District','BS','Bahamas'),(222,'City of Freeport District','BS','Bahamas'),(223,'Harbour Island','BS','Bahamas'),(224,'New Providence District','BS','Bahamas'),(225,'North Andros District','BS','Bahamas'),(226,'North Eleuthera','BS','Bahamas'),(227,'Chukha District','BT','Bhutan'),(228,'Mongar District','BT','Bhutan'),(229,'Thimphu Dzongkhag','BT','Bhutan'),(230,'Central District','BW','Botswana'),(231,'Kweneng District','BW','Botswana'),(232,'North-East','BW','Botswana'),(233,'North-West','BW','Botswana'),(234,'South-East','BW','Botswana'),(235,'Brest','BY','Belarus'),(236,'Gomel','BY','Belarus'),(237,'Grodnenskaya','BY','Belarus'),(238,'Minsk','BY','Belarus'),(239,'Minsk City','BY','Belarus'),(240,'Mogilev','BY','Belarus'),(241,'Vitebsk','BY','Belarus'),(242,'Belize District','BZ','Belize'),(243,'Cayo District','BZ','Belize'),(244,'Corozal District','BZ','Belize'),(245,'Orange Walk District','BZ','Belize'),(246,'Stann Creek District','BZ','Belize'),(247,'Toledo District','BZ','Belize'),(248,'Alberta','CA','Canada'),(249,'British Columbia','CA','Canada'),(250,'Manitoba','CA','Canada'),(251,'New Brunswick','CA','Canada'),(252,'Newfoundland and Labrador','CA','Canada'),(253,'Northwest Territories','CA','Canada'),(254,'Nova Scotia','CA','Canada'),(255,'Nunavut','CA','Canada'),(256,'Ontario','CA','Canada'),(257,'Prince Edward Island','CA','Canada'),(258,'Quebec','CA','Canada'),(259,'Saskatchewan','CA','Canada'),(260,'Yukon','CA','Canada'),(261,NULL,'CC','Cocos [Keeling] Islands'),(262,'Bas-Congo','CD','Congo'),(263,'Katanga Province','CD','Congo'),(264,'Kinshasa City','CD','Congo'),(265,'Nord Kivu','CD','Congo'),(266,'South Kivu Province','CD','Congo'),(267,'Bangui','CF','Central African Republic'),(268,'Mbomou','CF','Central African Republic'),(269,'Brazzaville','CG','Republic of the Congo'),(270,'Pointe-Noire','CG','Republic of the Congo'),(271,'Sangha','CG','Republic of the Congo'),(272,'Aargau','CH','Switzerland'),(273,'Appenzell Ausserrhoden','CH','Switzerland'),(274,'Appenzell Innerrhoden','CH','Switzerland'),(275,'Basel-City','CH','Switzerland'),(276,'Basel-Landschaft','CH','Switzerland'),(277,'Bern','CH','Switzerland'),(278,'Fribourg','CH','Switzerland'),(279,'Geneva','CH','Switzerland'),(280,'Glarus','CH','Switzerland'),(281,'Grisons','CH','Switzerland'),(282,'Jura','CH','Switzerland'),(283,'Lucerne','CH','Switzerland'),(284,'Neuchâtel','CH','Switzerland'),(285,'Nidwalden','CH','Switzerland'),(286,'Obwalden','CH','Switzerland'),(287,'Saint Gallen','CH','Switzerland'),(288,'Schaffhausen','CH','Switzerland'),(289,'Schwyz','CH','Switzerland'),(290,'Solothurn','CH','Switzerland'),(291,'Thurgau','CH','Switzerland'),(292,'Ticino','CH','Switzerland'),(293,'Uri','CH','Switzerland'),(294,'Valais','CH','Switzerland'),(295,'Vaud','CH','Switzerland'),(296,'Zug','CH','Switzerland'),(297,'Zurich','CH','Switzerland'),(298,'Abidjan','CI','Ivory Coast'),(299,'Comoe','CI','Ivory Coast'),(300,'District des Montagnes','CI','Ivory Coast'),(301,'Sassandra-Marahoue','CI','Ivory Coast'),(302,NULL,'CK','Cook Islands'),(303,'Antofagasta','CL','Chile'),(304,'Atacama','CL','Chile'),(305,'Aysen','CL','Chile'),(306,'Coquimbo','CL','Chile'),(307,'Los Lagos','CL','Chile'),(308,'Maule','CL','Chile'),(309,'Region de Arica y Parinacota','CL','Chile'),(310,'Region de Los Rios','CL','Chile'),(311,'Region de Magallanes y de la Antartica Chilena','CL','Chile'),(312,'Region de Valparaiso','CL','Chile'),(313,'Region de la Araucania','CL','Chile'),(314,'Region del Biobio','CL','Chile'),(315,'Region del Libertador General Bernardo O\'Higgins','CL','Chile'),(316,'Santiago Metropolitan','CL','Chile'),(317,'Tarapacá','CL','Chile'),(318,'Adamaoua Region','CM','Cameroon'),(319,'Centre','CM','Cameroon'),(320,'Littoral','CM','Cameroon'),(321,'North Region','CM','Cameroon'),(322,'North-West Region','CM','Cameroon'),(323,'South','CM','Cameroon'),(324,'South-West Region','CM','Cameroon'),(325,'West Region','CM','Cameroon'),(326,'Anhui','CN','China'),(327,'Beijing','CN','China'),(328,'Chongqing','CN','China'),(329,'Fujian','CN','China'),(330,'Gansu','CN','China'),(331,'Guangdong','CN','China'),(332,'Guangxi Zhuang Autonomous Region','CN','China'),(333,'Guizhou','CN','China'),(334,'Hainan','CN','China'),(335,'Hebei','CN','China'),(336,'Heilongjiang','CN','China'),(337,'Henan','CN','China'),(338,'Hubei','CN','China'),(339,'Hunan','CN','China'),(340,'Inner Mongolia Autonomous Region','CN','China'),(341,'Jiangsu','CN','China'),(342,'Jiangxi','CN','China'),(343,'Jilin','CN','China'),(344,'Liaoning','CN','China'),(345,'Ningsia Hui Autonomous Region','CN','China'),(346,'Qinghai','CN','China'),(347,'Shaanxi','CN','China'),(348,'Shandong','CN','China'),(349,'Shanghai','CN','China'),(350,'Shanxi','CN','China'),(351,'Sichuan','CN','China'),(352,'Tianjin','CN','China'),(353,'Tibet Autonomous Region','CN','China'),(354,'Xinjiang Uyghur Autonomous Region','CN','China'),(355,'Yunnan','CN','China'),(356,'Zhejiang','CN','China'),(357,'Amazonas','CO','Colombia'),(358,'Antioquia','CO','Colombia'),(359,'Atlántico','CO','Colombia'),(360,'Bogota D.C.','CO','Colombia'),(361,'Cundinamarca','CO','Colombia'),(362,'Departamento de Bolivar','CO','Colombia'),(363,'Departamento de Boyaca','CO','Colombia'),(364,'Departamento de Caldas','CO','Colombia'),(365,'Departamento de Casanare','CO','Colombia'),(366,'Departamento de Cordoba','CO','Colombia'),(367,'Departamento de La Guajira','CO','Colombia'),(368,'Departamento de Narino','CO','Colombia'),(369,'Departamento de Norte de Santander','CO','Colombia'),(370,'Departamento de Risaralda','CO','Colombia'),(371,'Departamento de Santander','CO','Colombia'),(372,'Departamento de Sucre','CO','Colombia'),(373,'Departamento de Tolima','CO','Colombia'),(374,'Departamento del Caqueta','CO','Colombia'),(375,'Departamento del Cauca','CO','Colombia'),(376,'Departamento del Cesar','CO','Colombia'),(377,'Departamento del Choco','CO','Colombia'),(378,'Departamento del Guainia','CO','Colombia'),(379,'Departamento del Guaviare','CO','Colombia'),(380,'Departamento del Huila','CO','Colombia'),(381,'Departamento del Magdalena','CO','Colombia'),(382,'Departamento del Meta','CO','Colombia'),(383,'Departamento del Valle del Cauca','CO','Colombia'),(384,'Departamento del Vichada','CO','Colombia'),(385,'Providencia y Santa Catalina, Departamento de Archipielago de San Andres','CO','Colombia'),(386,'Quindio Department','CO','Colombia'),(387,'Provincia de Alajuela','CR','Costa Rica'),(388,'Provincia de Cartago','CR','Costa Rica'),(389,'Provincia de Guanacaste','CR','Costa Rica'),(390,'Provincia de Heredia','CR','Costa Rica'),(391,'Provincia de Limon','CR','Costa Rica'),(392,'Provincia de Puntarenas','CR','Costa Rica'),(393,'Provincia de San Jose','CR','Costa Rica'),(394,'La Habana','CU','Cuba'),(395,'Provincia de Camagueey','CU','Cuba'),(396,'Provincia de Ciego de Avila','CU','Cuba'),(397,'Provincia de Matanzas','CU','Cuba'),(398,'Provincia de Villa Clara','CU','Cuba'),(399,'Ribeira Grande','CV','Cape Verde'),(400,'Ribeira Grande de Santiago','CV','Cape Verde'),(401,'São Domingos','CV','Cape Verde'),(402,NULL,'CW','Curaçao'),(403,NULL,'CX','Christmas Island'),(404,'Ammochostos','CY','Cyprus'),(405,'Keryneia','CY','Cyprus'),(406,'Larnaka','CY','Cyprus'),(407,'Limassol','CY','Cyprus'),(408,'Nicosia','CY','Cyprus'),(409,'Pafos','CY','Cyprus'),(410,'Central Bohemia','CZ','Czechia'),(411,'Hlavni mesto Praha','CZ','Czechia'),(412,'Jihocesky kraj','CZ','Czechia'),(413,'Karlovarsky kraj','CZ','Czechia'),(414,'Kraj Vysocina','CZ','Czechia'),(415,'Kralovehradecky kraj','CZ','Czechia'),(416,'Liberecky kraj','CZ','Czechia'),(417,'Moravskoslezsky kraj','CZ','Czechia'),(418,'Olomoucky kraj','CZ','Czechia'),(419,'Pardubicky kraj','CZ','Czechia'),(420,'Plzensky kraj','CZ','Czechia'),(421,'South Moravian','CZ','Czechia'),(422,'Ustecky kraj','CZ','Czechia'),(423,'Zlín','CZ','Czechia'),(424,'Baden-Württemberg Region','DE','Germany'),(425,'Bavaria','DE','Germany'),(426,'Brandenburg','DE','Germany'),(427,'Bremen','DE','Germany'),(428,'Hamburg','DE','Germany'),(429,'Hesse','DE','Germany'),(430,'Land Berlin','DE','Germany'),(431,'Lower Saxony','DE','Germany'),(432,'Mecklenburg-Vorpommern','DE','Germany'),(433,'North Rhine-Westphalia','DE','Germany'),(434,'Rheinland-Pfalz','DE','Germany'),(435,'Saarland','DE','Germany'),(436,'Saxony','DE','Germany'),(437,'Saxony-Anhalt','DE','Germany'),(438,'Schleswig-Holstein','DE','Germany'),(439,'Thuringia','DE','Germany'),(440,NULL,'DJ','Djibouti'),(441,'Capital Region','DK','Denmark'),(442,'Central Jutland','DK','Denmark'),(443,'North Denmark','DK','Denmark'),(444,'South Denmark','DK','Denmark'),(445,'Zealand','DK','Denmark'),(446,'Saint Andrew','DM','Dominica'),(447,'Saint David','DM','Dominica'),(448,'Saint George','DM','Dominica'),(449,'Saint John','DM','Dominica'),(450,'Saint Patrick','DM','Dominica'),(451,'Saint Paul','DM','Dominica'),(452,'Nacional','DO','Dominican Republic'),(453,'Provincia Duarte','DO','Dominican Republic'),(454,'Provincia Espaillat','DO','Dominican Republic'),(455,'Provincia Sanchez Ramirez','DO','Dominican Republic'),(456,'Provincia de Barahona','DO','Dominican Republic'),(457,'Provincia de El Seibo','DO','Dominican Republic'),(458,'Provincia de Hato Mayor','DO','Dominican Republic'),(459,'Provincia de Hermanas Mirabal','DO','Dominican Republic'),(460,'Provincia de Independencia','DO','Dominican Republic'),(461,'Provincia de La Altagracia','DO','Dominican Republic'),(462,'Provincia de La Romana','DO','Dominican Republic'),(463,'Provincia de La Vega','DO','Dominican Republic'),(464,'Provincia de Monsenor Nouel','DO','Dominican Republic'),(465,'Provincia de Monte Cristi','DO','Dominican Republic'),(466,'Provincia de Monte Plata','DO','Dominican Republic'),(467,'Provincia de Pedernales','DO','Dominican Republic'),(468,'Provincia de Peravia','DO','Dominican Republic'),(469,'Provincia de San Cristobal','DO','Dominican Republic'),(470,'Provincia de San Jose de Ocoa','DO','Dominican Republic'),(471,'Provincia de San Juan','DO','Dominican Republic'),(472,'Provincia de San Pedro de Macoris','DO','Dominican Republic'),(473,'Provincia de Santiago','DO','Dominican Republic'),(474,'Provincia de Santiago Rodriguez','DO','Dominican Republic'),(475,'Provincia de Santo Domingo','DO','Dominican Republic'),(476,'Puerto Plata','DO','Dominican Republic'),(477,'Adrar','DZ','Algeria'),(478,'Algiers','DZ','Algeria'),(479,'Annaba','DZ','Algeria'),(480,'Aïn Defla','DZ','Algeria'),(481,'Aïn Témouchent','DZ','Algeria'),(482,'Batna','DZ','Algeria'),(483,'Biskra','DZ','Algeria'),(484,'Blida','DZ','Algeria'),(485,'Bouira','DZ','Algeria'),(486,'Boumerdes','DZ','Algeria'),(487,'Béchar','DZ','Algeria'),(488,'Béjaïa','DZ','Algeria'),(489,'Chlef','DZ','Algeria'),(490,'Constantine','DZ','Algeria'),(491,'Djelfa','DZ','Algeria'),(492,'El Bayadh','DZ','Algeria'),(493,'El Tarf','DZ','Algeria'),(494,'Ghardaia','DZ','Algeria'),(495,'Guelma','DZ','Algeria'),(496,'Illizi','DZ','Algeria'),(497,'Jijel','DZ','Algeria'),(498,'Khenchela','DZ','Algeria'),(499,'Laghouat','DZ','Algeria'),(500,'M\'Sila','DZ','Algeria'),(501,'Mascara','DZ','Algeria'),(502,'Medea','DZ','Algeria'),(503,'Mila','DZ','Algeria'),(504,'Mostaganem','DZ','Algeria'),(505,'Naama','DZ','Algeria'),(506,'Oran','DZ','Algeria'),(507,'Ouargla','DZ','Algeria'),(508,'Oum el Bouaghi','DZ','Algeria'),(509,'Relizane','DZ','Algeria'),(510,'Saida','DZ','Algeria'),(511,'Sidi Bel Abbès','DZ','Algeria'),(512,'Skikda','DZ','Algeria'),(513,'Sétif','DZ','Algeria'),(514,'Tamanrasset','DZ','Algeria'),(515,'Tiaret','DZ','Algeria'),(516,'Tindouf','DZ','Algeria'),(517,'Tipaza','DZ','Algeria'),(518,'Tissemsilt','DZ','Algeria'),(519,'Tizi Ouzou','DZ','Algeria'),(520,'Tlemcen','DZ','Algeria'),(521,'Provincia de Bolivar','EC','Ecuador'),(522,'Provincia de Cotopaxi','EC','Ecuador'),(523,'Provincia de El Oro','EC','Ecuador'),(524,'Provincia de Esmeraldas','EC','Ecuador'),(525,'Provincia de Francisco de Orellana','EC','Ecuador'),(526,'Provincia de Imbabura','EC','Ecuador'),(527,'Provincia de Loja','EC','Ecuador'),(528,'Provincia de Los Rios','EC','Ecuador'),(529,'Provincia de Manabi','EC','Ecuador'),(530,'Provincia de Morona-Santiago','EC','Ecuador'),(531,'Provincia de Napo','EC','Ecuador'),(532,'Provincia de Pichincha','EC','Ecuador'),(533,'Provincia de Santa Elena','EC','Ecuador'),(534,'Provincia de Santo Domingo de los Tsachilas','EC','Ecuador'),(535,'Provincia de Sucumbios','EC','Ecuador'),(536,'Provincia de Zamora-Chinchipe','EC','Ecuador'),(537,'Provincia del Azuay','EC','Ecuador'),(538,'Provincia del Canar','EC','Ecuador'),(539,'Provincia del Carchi','EC','Ecuador'),(540,'Provincia del Chimborazo','EC','Ecuador'),(541,'Provincia del Guayas','EC','Ecuador'),(542,'Provincia del Pastaza','EC','Ecuador'),(543,'Provincia del Tungurahua','EC','Ecuador'),(544,'Harjumaa','EE','Estonia'),(545,'Hiiumaa','EE','Estonia'),(546,'Ida-Virumaa','EE','Estonia'),(547,'Järvamaa','EE','Estonia'),(548,'Jõgevamaa','EE','Estonia'),(549,'Lääne','EE','Estonia'),(550,'Lääne-Virumaa','EE','Estonia'),(551,'Pärnumaa','EE','Estonia'),(552,'Põlvamaa','EE','Estonia'),(553,'Raplamaa','EE','Estonia'),(554,'Saare','EE','Estonia'),(555,'Tartu','EE','Estonia'),(556,'Valgamaa','EE','Estonia'),(557,'Viljandimaa','EE','Estonia'),(558,'Võrumaa','EE','Estonia'),(559,'Alexandria','EG','Egypt'),(560,'Aswan','EG','Egypt'),(561,'Asyut','EG','Egypt'),(562,'Beheira','EG','Egypt'),(563,'Beni Suweif','EG','Egypt'),(564,'Cairo Governorate','EG','Egypt'),(565,'Dakahlia','EG','Egypt'),(566,'Damietta Governorate','EG','Egypt'),(567,'Faiyum','EG','Egypt'),(568,'Gharbia','EG','Egypt'),(569,'Giza','EG','Egypt'),(570,'Ismailia Governorate','EG','Egypt'),(571,'Kafr el-Sheikh','EG','Egypt'),(572,'Luxor','EG','Egypt'),(573,'Minya','EG','Egypt'),(574,'Monufia','EG','Egypt'),(575,'North Sinai','EG','Egypt'),(576,'Port Said','EG','Egypt'),(577,'Qalyubia','EG','Egypt'),(578,'Qena','EG','Egypt'),(579,'Red Sea','EG','Egypt'),(580,'Sharqia','EG','Egypt'),(581,'Sohag','EG','Egypt'),(582,'Suez','EG','Egypt'),(583,'Maekel Region','ER','Eritrea'),(584,'Andalusia','ES','Spain'),(585,'Aragon','ES','Spain'),(586,'Balearic Islands','ES','Spain'),(587,'Basque Country','ES','Spain'),(588,'Canary Islands','ES','Spain'),(589,'Cantabria','ES','Spain'),(590,'Castille and León','ES','Spain'),(591,'Castille-La Mancha','ES','Spain'),(592,'Catalonia','ES','Spain'),(593,'Ceuta','ES','Spain'),(594,'Extremadura','ES','Spain'),(595,'Galicia','ES','Spain'),(596,'La Rioja','ES','Spain'),(597,'Madrid','ES','Spain'),(598,'Melilla','ES','Spain'),(599,'Murcia','ES','Spain'),(600,'Navarre','ES','Spain'),(601,'Principality of Asturias','ES','Spain'),(602,'Valencia','ES','Spain'),(603,'Addis Ababa','ET','Ethiopia'),(604,'Afar Region','ET','Ethiopia'),(605,'Amhara','ET','Ethiopia'),(606,'Bīnshangul Gumuz','ET','Ethiopia'),(607,'Dire Dawa','ET','Ethiopia'),(608,'Gambela','ET','Ethiopia'),(609,'Harari Region','ET','Ethiopia'),(610,'Oromiya','ET','Ethiopia'),(611,'Somali','ET','Ethiopia'),(612,'Southern Nations, Nationalities, and People\'s Region','ET','Ethiopia'),(613,'Tigray','ET','Ethiopia'),(614,'Central Finland','FI','Finland'),(615,'Central Ostrobothnia','FI','Finland'),(616,'Haeme','FI','Finland'),(617,'Kainuu','FI','Finland'),(618,'Kymenlaakso','FI','Finland'),(619,'Lapland','FI','Finland'),(620,'Lapponia','FI','Finland'),(621,'North Karelia','FI','Finland'),(622,'Northern Ostrobothnia','FI','Finland'),(623,'Northern Savo','FI','Finland'),(624,'Päijänne Tavastia','FI','Finland'),(625,'Satakunta','FI','Finland'),(626,'South Karelia','FI','Finland'),(627,'Southern Ostrobothnia','FI','Finland'),(628,'Southern Savonia','FI','Finland'),(629,'Southwest Finland','FI','Finland'),(630,'Uusimaa','FI','Finland'),(631,'Western Finland','FI','Finland'),(632,'Central','FJ','Fiji'),(633,'Western','FJ','Fiji'),(634,NULL,'FK','Falkland Islands'),(635,'State of Yap','FM','Federated States of Micronesia'),(636,NULL,'FO','Faroe Islands'),(637,'Ain','FR','France'),(638,'Aisne','FR','France'),(639,'Allier','FR','France'),(640,'Ardennes','FR','France'),(641,'Ardèche','FR','France'),(642,'Ariège','FR','France'),(643,'Aube','FR','France'),(644,'Aude','FR','France'),(645,'Aveyron','FR','France'),(646,'Bas-Rhin','FR','France'),(647,'Brittany','FR','France'),(648,'Calvados','FR','France'),(649,'Cantal','FR','France'),(650,'Centre','FR','France'),(651,'Charente','FR','France'),(652,'Charente-Maritime','FR','France'),(653,'Corrèze','FR','France'),(654,'Corsica','FR','France'),(655,'Cote d\'Or','FR','France'),(656,'Creuse','FR','France'),(657,'Deux-Sèvres','FR','France'),(658,'Dordogne','FR','France'),(659,'Doubs','FR','France'),(660,'Drôme','FR','France'),(661,'Eure','FR','France'),(662,'Gard','FR','France'),(663,'Gers','FR','France'),(664,'Gironde','FR','France'),(665,'Haut-Rhin','FR','France'),(666,'Haute-Loire','FR','France'),(667,'Haute-Marne','FR','France'),(668,'Haute-Savoie','FR','France'),(669,'Haute-Saône','FR','France'),(670,'Haute-Vienne','FR','France'),(671,'Hautes-Pyrénées','FR','France'),(672,'Hérault','FR','France'),(673,'Isère','FR','France'),(674,'Jura','FR','France'),(675,'Landes','FR','France'),(676,'Loire','FR','France'),(677,'Lot','FR','France'),(678,'Lot-et-Garonne','FR','France'),(679,'Lozère','FR','France'),(680,'Manche','FR','France'),(681,'Marne','FR','France'),(682,'Meurthe et Moselle','FR','France'),(683,'Meuse','FR','France'),(684,'Moselle','FR','France'),(685,'Nièvre','FR','France'),(686,'North','FR','France'),(687,'Oise','FR','France'),(688,'Orne','FR','France'),(689,'Pas-de-Calais','FR','France'),(690,'Pays de la Loire','FR','France'),(691,'Provence-Alpes-Côte d\'Azur','FR','France'),(692,'Puy-de-Dôme','FR','France'),(693,'Pyrénées-Atlantiques','FR','France'),(694,'Pyrénées-Orientales','FR','France'),(695,'Rhône','FR','France'),(696,'Savoy','FR','France'),(697,'Saône-et-Loire','FR','France'),(698,'Seine-Maritime','FR','France'),(699,'Somme','FR','France'),(700,'Tarn','FR','France'),(701,'Tarn-et-Garonne','FR','France'),(702,'Territoire de Belfort','FR','France'),(703,'Upper Garonne','FR','France'),(704,'Vienne','FR','France'),(705,'Vosges','FR','France'),(706,'Yonne','FR','France'),(707,'Île-de-France','FR','France'),(708,'Estuaire','GA','Gabon'),(709,'Haut-Ogooué','GA','Gabon'),(710,'Moyen-Ogooué','GA','Gabon'),(711,'Ngouni','GA','Gabon'),(712,'Ogooué-Maritime','GA','Gabon'),(713,'England','GB','United Kingdom'),(714,'Northern Ireland','GB','United Kingdom'),(715,'Scotland','GB','United Kingdom'),(716,'Wales','GB','United Kingdom'),(717,'Saint Andrew','GD','Grenada'),(718,'Saint George','GD','Grenada'),(719,'Saint Mark','GD','Grenada'),(720,'Saint Patrick','GD','Grenada'),(721,'Abkhazia','GE','Georgia'),(722,'Ajaria','GE','Georgia'),(723,'Guria','GE','Georgia'),(724,'Imereti','GE','Georgia'),(725,'K\'alak\'i T\'bilisi','GE','Georgia'),(726,'Kakheti','GE','Georgia'),(727,'Mtskheta-Mtianeti','GE','Georgia'),(728,'Racha-Lechkhumi and Kvemo Svaneti','GE','Georgia'),(729,'Samegrelo and Zemo Svaneti','GE','Georgia'),(730,'Shida Kartli','GE','Georgia'),(731,NULL,'GF','French Guiana'),(732,NULL,'GG','Guernsey'),(733,'Ashanti Region','GH','Ghana'),(734,'Brong-Ahafo','GH','Ghana'),(735,'Central Region','GH','Ghana'),(736,'Eastern Region','GH','Ghana'),(737,'Greater Accra Region','GH','Ghana'),(738,'Upper East Region','GH','Ghana'),(739,'Upper West Region','GH','Ghana'),(740,'Volta Region','GH','Ghana'),(741,'Western Region','GH','Ghana'),(742,NULL,'GI','Gibraltar'),(743,'Kujalleq','GL','Greenland'),(744,'Qaasuitsup','GL','Greenland'),(745,'Qeqqata','GL','Greenland'),(746,'Sermersooq','GL','Greenland'),(747,'City of Banjul','GM','Gambia'),(748,'Western Division','GM','Gambia'),(749,'Boke Region','GN','Guinea'),(750,'Conakry Region','GN','Guinea'),(751,'Faranah','GN','Guinea'),(752,'Kankan Region','GN','Guinea'),(753,'Kindia','GN','Guinea'),(754,'Labe Region','GN','Guinea'),(755,'Mamou Region','GN','Guinea'),(756,'Nzerekore Region','GN','Guinea'),(757,NULL,'GP','Guadeloupe'),(758,'Bioko Norte','GQ','Equatorial Guinea'),(759,'Wele-Nzas','GQ','Equatorial Guinea'),(760,'Attica','GR','Greece'),(761,'Central Greece','GR','Greece'),(762,'Central Macedonia','GR','Greece'),(763,'Crete','GR','Greece'),(764,'East Macedonia and Thrace','GR','Greece'),(765,'Epirus','GR','Greece'),(766,'Ionian Islands','GR','Greece'),(767,'North Aegean','GR','Greece'),(768,'Peloponnese','GR','Greece'),(769,'South Aegean','GR','Greece'),(770,'Thessaly','GR','Greece'),(771,'West Greece','GR','Greece'),(772,'West Macedonia','GR','Greece'),(773,NULL,'GS','South Georgia and the South Sandwich Islands'),(774,'Departamento de Alta Verapaz','GT','Guatemala'),(775,'Departamento de Chimaltenango','GT','Guatemala'),(776,'Departamento de Escuintla','GT','Guatemala'),(777,'Departamento de Guatemala','GT','Guatemala'),(778,'Departamento de Huehuetenango','GT','Guatemala'),(779,'Departamento de Jalapa','GT','Guatemala'),(780,'Departamento de Jutiapa','GT','Guatemala'),(781,'Departamento de Quetzaltenango','GT','Guatemala'),(782,'Departamento de Retalhuleu','GT','Guatemala'),(783,'Departamento de Sacatepequez','GT','Guatemala'),(784,'Departamento de Zacapa','GT','Guatemala'),(785,'Suchitepeque','GT','Guatemala'),(786,NULL,'GU','Guam'),(787,'Bissau','GW','Guinea-Bissau'),(788,'Bolama and Bijagos','GW','Guinea-Bissau'),(789,'Cacheu Region','GW','Guinea-Bissau'),(790,'Demerara-Mahaica Region','GY','Guyana'),(791,'East Berbice-Corentyne Region','GY','Guyana'),(792,'Upper Demerara-Berbice Region','GY','Guyana'),(793,'Central and Western District','HK','Hong Kong'),(794,'Eastern','HK','Hong Kong'),(795,'Kowloon City','HK','Hong Kong'),(796,'North','HK','Hong Kong'),(797,'Sha Tin','HK','Hong Kong'),(798,'Sham Shui Po','HK','Hong Kong'),(799,'Southern','HK','Hong Kong'),(800,'Wanchai','HK','Hong Kong'),(801,'Wong Tai Sin','HK','Hong Kong'),(802,'Yau Tsim Mong','HK','Hong Kong'),(803,'Yuen Long District','HK','Hong Kong'),(804,'Bay Islands','HN','Honduras'),(805,'Departamento de Atlantida','HN','Honduras'),(806,'Departamento de Choluteca','HN','Honduras'),(807,'Departamento de Colon','HN','Honduras'),(808,'Departamento de Comayagua','HN','Honduras'),(809,'Departamento de Copan','HN','Honduras'),(810,'Departamento de Cortes','HN','Honduras'),(811,'Departamento de El Paraiso','HN','Honduras'),(812,'Departamento de Francisco Morazan','HN','Honduras'),(813,'Departamento de Gracias a Dios','HN','Honduras'),(814,'Departamento de La Paz','HN','Honduras'),(815,'Departamento de Lempira','HN','Honduras'),(816,'Departamento de Olancho','HN','Honduras'),(817,'Departamento de Santa Barbara','HN','Honduras'),(818,'Departamento de Valle','HN','Honduras'),(819,'Departamento de Yoro','HN','Honduras'),(820,'Bjelovarsko-Bilogorska Zupanija','HR','Croatia'),(821,'City of Zagreb','HR','Croatia'),(822,'Dubrovacko-Neretvanska Zupanija','HR','Croatia'),(823,'Istarska Zupanija','HR','Croatia'),(824,'Karlovacka Zupanija','HR','Croatia'),(825,'Koprivnicko-Krizevacka Zupanija','HR','Croatia'),(826,'Krapinsko-Zagorska Zupanija','HR','Croatia'),(827,'Licko-Senjska Zupanija','HR','Croatia'),(828,'Megimurska Zupanija','HR','Croatia'),(829,'Osjecko-Baranjska Zupanija','HR','Croatia'),(830,'Pozesko-Slavonska Zupanija','HR','Croatia'),(831,'Primorsko-Goranska Zupanija','HR','Croatia'),(832,'Sibensko-Kninska Zupanija','HR','Croatia'),(833,'Sisacko-Moslavacka Zupanija','HR','Croatia'),(834,'Slavonski Brod-Posavina','HR','Croatia'),(835,'Splitsko-Dalmatinska Zupanija','HR','Croatia'),(836,'Varazdinska Zupanija','HR','Croatia'),(837,'Viroviticko-Podravska Zupanija','HR','Croatia'),(838,'Vukovar-Sirmium','HR','Croatia'),(839,'Zadarska Zupanija','HR','Croatia'),(840,'Zagreb County','HR','Croatia'),(841,'Departement de l\'Ouest','HT','Haiti'),(842,'Nord','HT','Haiti'),(843,'Sud','HT','Haiti'),(844,'Sud-Est','HT','Haiti'),(845,'Baranya','HU','Hungary'),(846,'Bekes','HU','Hungary'),(847,'Borsod-Abaúj-Zemplén','HU','Hungary'),(848,'Budapest','HU','Hungary'),(849,'Bács-Kiskun','HU','Hungary'),(850,'Csongrad megye','HU','Hungary'),(851,'Fejér','HU','Hungary'),(852,'Győr-Moson-Sopron','HU','Hungary'),(853,'Hajdú-Bihar','HU','Hungary'),(854,'Heves megye','HU','Hungary'),(855,'Jász-Nagykun-Szolnok','HU','Hungary'),(856,'Komárom-Esztergom','HU','Hungary'),(857,'Nograd megye','HU','Hungary'),(858,'Pest megye','HU','Hungary'),(859,'Somogy megye','HU','Hungary'),(860,'Szabolcs-Szatmár-Bereg','HU','Hungary'),(861,'Tolna megye','HU','Hungary'),(862,'Vas','HU','Hungary'),(863,'Veszprem megye','HU','Hungary'),(864,'Zala','HU','Hungary'),(865,'Aceh','ID','Indonesia'),(866,'Bali','ID','Indonesia'),(867,'Bangka–Belitung Islands','ID','Indonesia'),(868,'Banten','ID','Indonesia'),(869,'Bengkulu','ID','Indonesia'),(870,'Central Java','ID','Indonesia'),(871,'Central Kalimantan','ID','Indonesia'),(872,'Central Sulawesi','ID','Indonesia'),(873,'East Java','ID','Indonesia'),(874,'East Kalimantan','ID','Indonesia'),(875,'East Nusa Tenggara','ID','Indonesia'),(876,'Gorontalo','ID','Indonesia'),(877,'Jakarta','ID','Indonesia'),(878,'Jambi','ID','Indonesia'),(879,'Lampung','ID','Indonesia'),(880,'Maluku','ID','Indonesia'),(881,'North Kalimantan','ID','Indonesia'),(882,'North Maluku','ID','Indonesia'),(883,'North Sulawesi','ID','Indonesia'),(884,'North Sumatra','ID','Indonesia'),(885,'Papua','ID','Indonesia'),(886,'Riau','ID','Indonesia'),(887,'Riau Islands','ID','Indonesia'),(888,'South Kalimantan','ID','Indonesia'),(889,'South Sulawesi','ID','Indonesia'),(890,'South Sumatra','ID','Indonesia'),(891,'Southeast Sulawesi','ID','Indonesia'),(892,'West Java','ID','Indonesia'),(893,'West Kalimantan','ID','Indonesia'),(894,'West Nusa Tenggara','ID','Indonesia'),(895,'West Sulawesi','ID','Indonesia'),(896,'West Sumatra','ID','Indonesia'),(897,'Yogyakarta','ID','Indonesia'),(898,'Connaught','IE','Ireland'),(899,'Leinster','IE','Ireland'),(900,'Munster','IE','Ireland'),(901,'Ulster','IE','Ireland'),(902,'Central District','IL','Israel'),(903,'Haifa','IL','Israel'),(904,'Jerusalem','IL','Israel'),(905,'Northern District','IL','Israel'),(906,'Southern District','IL','Israel'),(907,'Tel Aviv','IL','Israel'),(908,NULL,'IM','Isle of Man'),(909,'Andhra Pradesh','IN','India'),(910,'Arunachal Pradesh','IN','India'),(911,'Assam','IN','India'),(912,'Bihar','IN','India'),(913,'Chandigarh','IN','India'),(914,'Chhattisgarh','IN','India'),(915,'Dadra and Nagar Haveli','IN','India'),(916,'Daman and Diu','IN','India'),(917,'Goa','IN','India'),(918,'Gujarat','IN','India'),(919,'Haryana','IN','India'),(920,'Himachal Pradesh','IN','India'),(921,'Jharkhand','IN','India'),(922,'Karnataka','IN','India'),(923,'Kashmir','IN','India'),(924,'Kerala','IN','India'),(925,'Laccadives','IN','India'),(926,'Madhya Pradesh','IN','India'),(927,'Maharashtra','IN','India'),(928,'Manipur','IN','India'),(929,'Meghalaya','IN','India'),(930,'Mizoram','IN','India'),(931,'Nagaland','IN','India'),(932,'National Capital Territory of Delhi','IN','India'),(933,'Odisha','IN','India'),(934,'Punjab','IN','India'),(935,'Rajasthan','IN','India'),(936,'Sikkim','IN','India'),(937,'Tamil Nadu','IN','India'),(938,'Telangana','IN','India'),(939,'Tripura','IN','India'),(940,'Union Territory of Andaman and Nicobar Islands','IN','India'),(941,'Union Territory of Puducherry','IN','India'),(942,'Uttar Pradesh','IN','India'),(943,'Uttarakhand','IN','India'),(944,'West Bengal','IN','India'),(945,NULL,'IO','British Indian Ocean Territory'),(946,'An Najaf','IQ','Iraq'),(947,'Anbar','IQ','Iraq'),(948,'Basra Governorate','IQ','Iraq'),(949,'Mayorality of Baghdad','IQ','Iraq'),(950,'Maysan','IQ','Iraq'),(951,'Muhafazat Arbil','IQ','Iraq'),(952,'Muhafazat Babil','IQ','Iraq'),(953,'Muhafazat Karbala\'','IQ','Iraq'),(954,'Muhafazat Kirkuk','IQ','Iraq'),(955,'Muhafazat Ninawa','IQ','Iraq'),(956,'Muhafazat Wasit','IQ','Iraq'),(957,'Muhafazat as Sulaymaniyah','IQ','Iraq'),(958,'Alborz','IR','Iran'),(959,'Bushehr','IR','Iran'),(960,'East Azerbaijan','IR','Iran'),(961,'Fars','IR','Iran'),(962,'Hormozgan','IR','Iran'),(963,'Isfahan','IR','Iran'),(964,'Kerman','IR','Iran'),(965,'Khuzestan','IR','Iran'),(966,'Markazi','IR','Iran'),(967,'Māzandarān','IR','Iran'),(968,'Ostan-e Ardabil','IR','Iran'),(969,'Ostan-e Azarbayjan-e Gharbi','IR','Iran'),(970,'Ostan-e Chahar Mahal va Bakhtiari','IR','Iran'),(971,'Ostan-e Gilan','IR','Iran'),(972,'Ostan-e Golestan','IR','Iran'),(973,'Ostan-e Hamadan','IR','Iran'),(974,'Ostan-e Ilam','IR','Iran'),(975,'Ostan-e Kermanshah','IR','Iran'),(976,'Ostan-e Khorasan-e Shomali','IR','Iran'),(977,'Ostan-e Kordestan','IR','Iran'),(978,'Ostan-e Qazvin','IR','Iran'),(979,'Ostan-e Tehran','IR','Iran'),(980,'Razavi Khorasan','IR','Iran'),(981,'Semnān','IR','Iran'),(982,'Sistan and Baluchestan','IR','Iran'),(983,'Yazd','IR','Iran'),(984,'Zanjan','IR','Iran'),(985,'Capital Region','IS','Iceland'),(986,'East','IS','Iceland'),(987,'Northeast','IS','Iceland'),(988,'Northwest','IS','Iceland'),(989,'South','IS','Iceland'),(990,'Southern Peninsula','IS','Iceland'),(991,'West','IS','Iceland'),(992,'Westfjords','IS','Iceland'),(993,'Abruzzo','IT','Italy'),(994,'Aosta Valley','IT','Italy'),(995,'Apulia','IT','Italy'),(996,'Basilicate','IT','Italy'),(997,'Calabria','IT','Italy'),(998,'Campania','IT','Italy'),(999,'Emilia-Romagna','IT','Italy'),(1000,'Friuli Venezia Giulia','IT','Italy'),(1001,'Latium','IT','Italy'),(1002,'Liguria','IT','Italy'),(1003,'Lombardy','IT','Italy'),(1004,'Molise','IT','Italy'),(1005,'Piedmont','IT','Italy'),(1006,'Sardinia','IT','Italy'),(1007,'Sicily','IT','Italy'),(1008,'The Marches','IT','Italy'),(1009,'Trentino-Alto Adige','IT','Italy'),(1010,'Tuscany','IT','Italy'),(1011,'Umbria','IT','Italy'),(1012,'Veneto','IT','Italy'),(1013,NULL,'JE','Jersey'),(1014,'Clarendon','JM','Jamaica'),(1015,'Kingston','JM','Jamaica'),(1016,'Manchester','JM','Jamaica'),(1017,'Parish of Saint Ann','JM','Jamaica'),(1018,'Portland','JM','Jamaica'),(1019,'Saint Catherine','JM','Jamaica'),(1020,'Saint Elizabeth','JM','Jamaica'),(1021,'Saint James','JM','Jamaica'),(1022,'Saint Mary','JM','Jamaica'),(1023,'Saint Thomas','JM','Jamaica'),(1024,'Westmoreland','JM','Jamaica'),(1025,'Ajloun','JO','Hashemite Kingdom of Jordan'),(1026,'Amman Governorate','JO','Hashemite Kingdom of Jordan'),(1027,'Aqaba','JO','Hashemite Kingdom of Jordan'),(1028,'Balqa','JO','Hashemite Kingdom of Jordan'),(1029,'Irbid','JO','Hashemite Kingdom of Jordan'),(1030,'Jerash','JO','Hashemite Kingdom of Jordan'),(1031,'Karak','JO','Hashemite Kingdom of Jordan'),(1032,'Madaba','JO','Hashemite Kingdom of Jordan'),(1033,'Mafraq','JO','Hashemite Kingdom of Jordan'),(1034,'Ma’an','JO','Hashemite Kingdom of Jordan'),(1035,'Tafielah','JO','Hashemite Kingdom of Jordan'),(1036,'Zarqa','JO','Hashemite Kingdom of Jordan'),(1037,'Aichi','JP','Japan'),(1038,'Akita','JP','Japan'),(1039,'Aomori','JP','Japan'),(1040,'Chiba','JP','Japan'),(1041,'Ehime','JP','Japan'),(1042,'Fukui','JP','Japan'),(1043,'Fukuoka','JP','Japan'),(1044,'Fukushima-ken','JP','Japan'),(1045,'Gifu','JP','Japan'),(1046,'Gunma','JP','Japan'),(1047,'Hiroshima','JP','Japan'),(1048,'Hokkaido','JP','Japan'),(1049,'Hyōgo','JP','Japan'),(1050,'Ibaraki','JP','Japan'),(1051,'Ishikawa','JP','Japan'),(1052,'Iwate','JP','Japan'),(1053,'Kagawa','JP','Japan'),(1054,'Kagoshima','JP','Japan'),(1055,'Kanagawa','JP','Japan'),(1056,'Kochi','JP','Japan'),(1057,'Kumamoto','JP','Japan'),(1058,'Kyoto','JP','Japan'),(1059,'Mie','JP','Japan'),(1060,'Miyagi','JP','Japan'),(1061,'Miyazaki','JP','Japan'),(1062,'Nagano','JP','Japan'),(1063,'Nagasaki','JP','Japan'),(1064,'Nara','JP','Japan'),(1065,'Niigata','JP','Japan'),(1066,'Oita','JP','Japan'),(1067,'Okayama','JP','Japan'),(1068,'Okinawa','JP','Japan'),(1069,'Saga Prefecture','JP','Japan'),(1070,'Saitama','JP','Japan'),(1071,'Shiga Prefecture','JP','Japan'),(1072,'Shimane','JP','Japan'),(1073,'Shizuoka','JP','Japan'),(1074,'Tochigi','JP','Japan'),(1075,'Tokushima','JP','Japan'),(1076,'Tokyo','JP','Japan'),(1077,'Tottori','JP','Japan'),(1078,'Toyama','JP','Japan'),(1079,'Wakayama','JP','Japan'),(1080,'Yamagata','JP','Japan'),(1081,'Yamaguchi','JP','Japan'),(1082,'Yamanashi','JP','Japan'),(1083,'Ōsaka','JP','Japan'),(1084,'Bomet District','KE','Kenya'),(1085,'Garissa District','KE','Kenya'),(1086,'Homa Bay District','KE','Kenya'),(1087,'Kericho District','KE','Kenya'),(1088,'Kiambu District','KE','Kenya'),(1089,'Kilifi District','KE','Kenya'),(1090,'Kisii District','KE','Kenya'),(1091,'Kisumu','KE','Kenya'),(1092,'Kwale District','KE','Kenya'),(1093,'Mandera District','KE','Kenya'),(1094,'Mombasa District','KE','Kenya'),(1095,'Murang\'a District','KE','Kenya'),(1096,'Nairobi Province','KE','Kenya'),(1097,'Nakuru District','KE','Kenya'),(1098,'Nyeri District','KE','Kenya'),(1099,'Siaya District','KE','Kenya'),(1100,'Tharaka District','KE','Kenya'),(1101,'Trans Nzoia District','KE','Kenya'),(1102,'Uasin Gishu','KE','Kenya'),(1103,'Batken','KG','Kyrgyzstan'),(1104,'Chuyskaya Oblast\'','KG','Kyrgyzstan'),(1105,'Gorod Bishkek','KG','Kyrgyzstan'),(1106,'Issyk-Kul Region','KG','Kyrgyzstan'),(1107,'Jalal-Abad oblast','KG','Kyrgyzstan'),(1108,'Naryn oblast','KG','Kyrgyzstan'),(1109,'Osh Oblasty','KG','Kyrgyzstan'),(1110,'Talas','KG','Kyrgyzstan'),(1111,'Banteay Meanchey','KH','Cambodia'),(1112,'Battambang','KH','Cambodia'),(1113,'Kandal','KH','Cambodia'),(1114,'Phnom Penh','KH','Cambodia'),(1115,'Preah Sihanouk','KH','Cambodia'),(1116,'Gilbert Islands','KI','Kiribati'),(1117,'Grande Comore','KM','Comoros'),(1118,'Ndzuwani','KM','Comoros'),(1119,'Saint George Basseterre','KN','Saint Kitts and Nevis'),(1120,'Saint Mary Cayon','KN','Saint Kitts and Nevis'),(1121,'Saint Paul Charlestown','KN','Saint Kitts and Nevis'),(1122,'Chagang-do','KP','North Korea'),(1123,'Pyongyang','KP','North Korea'),(1124,'Busan','KR','Republic of Korea'),(1125,'Chungcheongbuk-do','KR','Republic of Korea'),(1126,'Chungcheongnam-do','KR','Republic of Korea'),(1127,'Daegu','KR','Republic of Korea'),(1128,'Daejeon','KR','Republic of Korea'),(1129,'Gangwon-do','KR','Republic of Korea'),(1130,'Gwangju','KR','Republic of Korea'),(1131,'Gyeonggi-do','KR','Republic of Korea'),(1132,'Gyeongsangbuk-do','KR','Republic of Korea'),(1133,'Gyeongsangnam-do','KR','Republic of Korea'),(1134,'Incheon','KR','Republic of Korea'),(1135,'Jeju-do','KR','Republic of Korea'),(1136,'Jeollabuk-do','KR','Republic of Korea'),(1137,'Jeollanam-do','KR','Republic of Korea'),(1138,'Seoul','KR','Republic of Korea'),(1139,'Ulsan','KR','Republic of Korea'),(1140,'Al Asimah','KW','Kuwait'),(1141,'Al Aḩmadī','KW','Kuwait'),(1142,'Al Farwaniyah','KW','Kuwait'),(1143,'Hawalli','KW','Kuwait'),(1144,NULL,'KY','Cayman Islands'),(1145,'Aktyubinskaya Oblast\'','KZ','Kazakhstan'),(1146,'Almaty Oblysy','KZ','Kazakhstan'),(1147,'Almaty Qalasy','KZ','Kazakhstan'),(1148,'Aqmola Oblysy','KZ','Kazakhstan'),(1149,'Astana Qalasy','KZ','Kazakhstan'),(1150,'Atyrau Oblysy','KZ','Kazakhstan'),(1151,'East Kazakhstan','KZ','Kazakhstan'),(1152,'Mangistauskaya Oblast\'','KZ','Kazakhstan'),(1153,'Pavlodar Oblysy','KZ','Kazakhstan'),(1154,'Qaraghandy Oblysy','KZ','Kazakhstan'),(1155,'Qostanay Oblysy','KZ','Kazakhstan'),(1156,'Qyzylorda Oblysy','KZ','Kazakhstan'),(1157,'Severo-Kazakhstanskaya Oblast\'','KZ','Kazakhstan'),(1158,'Yuzhno-Kazakhstanskaya Oblast\'','KZ','Kazakhstan'),(1159,'Zapadno-Kazakhstanskaya Oblast\'','KZ','Kazakhstan'),(1160,'Zhambyl Oblysy','KZ','Kazakhstan'),(1161,'Khammouan','LA','Laos'),(1162,'Vientiane','LA','Laos'),(1163,'Beyrouth','LB','Lebanon'),(1164,'Mohafazat Aakkar','LB','Lebanon'),(1165,'Mohafazat Baalbek-Hermel','LB','Lebanon'),(1166,'Mohafazat Liban-Nord','LB','Lebanon'),(1167,'Mohafazat Mont-Liban','LB','Lebanon'),(1168,'South Governorate','LB','Lebanon'),(1169,'Anse-la-Raye','LC','Saint Lucia'),(1170,'Castries Quarter','LC','Saint Lucia'),(1171,'Choiseul Quarter','LC','Saint Lucia'),(1172,'Dennery Quarter','LC','Saint Lucia'),(1173,'Gros-Islet','LC','Saint Lucia'),(1174,'Laborie Quarter','LC','Saint Lucia'),(1175,'Micoud Quarter','LC','Saint Lucia'),(1176,'Quarter of Dauphin','LC','Saint Lucia'),(1177,'Quarter of Praslin','LC','Saint Lucia'),(1178,'Soufriere','LC','Saint Lucia'),(1179,'Vieux-Fort','LC','Saint Lucia'),(1180,'Balzers','LI','Liechtenstein'),(1181,'Eschen','LI','Liechtenstein'),(1182,'Gemeinde Gamprin','LI','Liechtenstein'),(1183,'Mauren','LI','Liechtenstein'),(1184,'Ruggell','LI','Liechtenstein'),(1185,'Schaan','LI','Liechtenstein'),(1186,'Schellenberg','LI','Liechtenstein'),(1187,'Triesen','LI','Liechtenstein'),(1188,'Triesenberg','LI','Liechtenstein'),(1189,'Vaduz','LI','Liechtenstein'),(1190,'Central Province','LK','Sri Lanka'),(1191,'Eastern Province','LK','Sri Lanka'),(1192,'North Central Province','LK','Sri Lanka'),(1193,'North Western Province','LK','Sri Lanka'),(1194,'Province of Sabaragamuwa','LK','Sri Lanka'),(1195,'Province of Uva','LK','Sri Lanka'),(1196,'Southern Province','LK','Sri Lanka'),(1197,'Western Province','LK','Sri Lanka'),(1198,'Montserrado County','LR','Liberia'),(1199,'Nimba County','LR','Liberia'),(1200,'Berea','LS','Lesotho'),(1201,'Leribe','LS','Lesotho'),(1202,'Maseru','LS','Lesotho'),(1203,'Alytus County','LT','Republic of Lithuania'),(1204,'Kaunas County','LT','Republic of Lithuania'),(1205,'Klaipėda County','LT','Republic of Lithuania'),(1206,'Marijampolė County','LT','Republic of Lithuania'),(1207,'Panevėžys','LT','Republic of Lithuania'),(1208,'Tauragė County','LT','Republic of Lithuania'),(1209,'Telšiai County','LT','Republic of Lithuania'),(1210,'Utena County','LT','Republic of Lithuania'),(1211,'Vilnius County','LT','Republic of Lithuania'),(1212,'Šiauliai County','LT','Republic of Lithuania'),(1213,'District de Diekirch','LU','Luxembourg'),(1214,'District de Grevenmacher','LU','Luxembourg'),(1215,'District de Luxembourg','LU','Luxembourg'),(1216,'Aizkraukles Rajons','LV','Latvia'),(1217,'Aizpute','LV','Latvia'),(1218,'Aloja','LV','Latvia'),(1219,'Babīte','LV','Latvia'),(1220,'Baldone','LV','Latvia'),(1221,'Balvu Novads','LV','Latvia'),(1222,'Bauskas Novads','LV','Latvia'),(1223,'Brocēni','LV','Latvia'),(1224,'Burtnieki','LV','Latvia'),(1225,'Carnikava','LV','Latvia'),(1226,'Cesu Novads','LV','Latvia'),(1227,'Daugavpils','LV','Latvia'),(1228,'Daugavpils municipality','LV','Latvia'),(1229,'Dobeles Rajons','LV','Latvia'),(1230,'Dundaga','LV','Latvia'),(1231,'Engure','LV','Latvia'),(1232,'Garkalne','LV','Latvia'),(1233,'Grobiņa','LV','Latvia'),(1234,'Gulbenes Rajons','LV','Latvia'),(1235,'Ikšķile','LV','Latvia'),(1236,'Inčukalns','LV','Latvia'),(1237,'Jaunpiebalga','LV','Latvia'),(1238,'Jelgava','LV','Latvia'),(1239,'Jelgavas Rajons','LV','Latvia'),(1240,'Jurmala','LV','Latvia'),(1241,'Jēkabpils Municipality','LV','Latvia'),(1242,'Kandava','LV','Latvia'),(1243,'Koknese','LV','Latvia'),(1244,'Kuldigas Rajons','LV','Latvia'),(1245,'Lecava','LV','Latvia'),(1246,'Lielvārde','LV','Latvia'),(1247,'Liepaja','LV','Latvia'),(1248,'Limbazu Rajons','LV','Latvia'),(1249,'Ludzas Rajons','LV','Latvia'),(1250,'Līvāni','LV','Latvia'),(1251,'Madona Municipality','LV','Latvia'),(1252,'Mārupe','LV','Latvia'),(1253,'Ogre','LV','Latvia'),(1254,'Olaine','LV','Latvia'),(1255,'Ozolnieku Novads','LV','Latvia'),(1256,'Plavinu Novads','LV','Latvia'),(1257,'Preili Municipality','LV','Latvia'),(1258,'Rezekne','LV','Latvia'),(1259,'Riga','LV','Latvia'),(1260,'Rojas Novads','LV','Latvia'),(1261,'Ropazu Novads','LV','Latvia'),(1262,'Rugaju Novads','LV','Latvia'),(1263,'Rujienas Novads','LV','Latvia'),(1264,'Salacgrivas Novads','LV','Latvia'),(1265,'Salaspils Novads','LV','Latvia'),(1266,'Saldus Municipality','LV','Latvia'),(1267,'Saulkrastu Novads','LV','Latvia'),(1268,'Siguldas Novads','LV','Latvia'),(1269,'Skrundas Novads','LV','Latvia'),(1270,'Stopinu Novads','LV','Latvia'),(1271,'Talsi Municipality','LV','Latvia'),(1272,'Tukuma Rajons','LV','Latvia'),(1273,'Vainodes Novads','LV','Latvia'),(1274,'Valka Municipality','LV','Latvia'),(1275,'Valmiera District','LV','Latvia'),(1276,'Varaklanu Novads','LV','Latvia'),(1277,'Ventspils','LV','Latvia'),(1278,'Viesites Novads','LV','Latvia'),(1279,'Zilupes Novads','LV','Latvia'),(1280,'Ādaži','LV','Latvia'),(1281,'Ķegums','LV','Latvia'),(1282,'Ķekava','LV','Latvia'),(1283,'Sha\'biyat Banghazi','LY','Libya'),(1284,'Sha\'biyat Misratah','LY','Libya'),(1285,'Sha\'biyat Sabha','LY','Libya'),(1286,'Sha`biyat Nalut','LY','Libya'),(1287,'Tripoli','LY','Libya'),(1288,'Chaouia-Ouardigha','MA','Morocco'),(1289,'Doukkala-Abda','MA','Morocco'),(1290,'Gharb-Chrarda-Beni Hssen','MA','Morocco'),(1291,'Guelmim-Es Semara','MA','Morocco'),(1292,'Laayoune-Boujdour-Sakia El Hamra','MA','Morocco'),(1293,'Marrakech-Tensift-Al Haouz','MA','Morocco'),(1294,'Oriental','MA','Morocco'),(1295,'Oued-Ed-Dahab','MA','Morocco'),(1296,'Region de Fes-Boulemane','MA','Morocco'),(1297,'Region de Meknes-Tafilalet','MA','Morocco'),(1298,'Region de Rabat-Sale-Zemmour-Zaer','MA','Morocco'),(1299,'Region de Souss-Massa-Draa','MA','Morocco'),(1300,'Region de Tanger-Tetouan','MA','Morocco'),(1301,'Region du Grand Casablanca','MA','Morocco'),(1302,'Tadla-Azilal','MA','Morocco'),(1303,'Taza-Al Hoceima-Taounate','MA','Morocco'),(1304,NULL,'MC','Monaco'),(1305,'Anenii Noi','MD','Republic of Moldova'),(1306,'Basarabeasca','MD','Republic of Moldova'),(1307,'Briceni','MD','Republic of Moldova'),(1308,'Cahul','MD','Republic of Moldova'),(1309,'Cantemir','MD','Republic of Moldova'),(1310,'Cimişlia','MD','Republic of Moldova'),(1311,'Criuleni','MD','Republic of Moldova'),(1312,'Donduşeni','MD','Republic of Moldova'),(1313,'Drochia','MD','Republic of Moldova'),(1314,'Floreşti','MD','Republic of Moldova'),(1315,'Făleşti','MD','Republic of Moldova'),(1316,'Gagauzia','MD','Republic of Moldova'),(1317,'Glodeni','MD','Republic of Moldova'),(1318,'Hînceşti','MD','Republic of Moldova'),(1319,'Laloveni','MD','Republic of Moldova'),(1320,'Leova','MD','Republic of Moldova'),(1321,'Municipiul Balti','MD','Republic of Moldova'),(1322,'Municipiul Bender','MD','Republic of Moldova'),(1323,'Municipiul Chisinau','MD','Republic of Moldova'),(1324,'Nisporeni','MD','Republic of Moldova'),(1325,'Orhei','MD','Republic of Moldova'),(1326,'Raionul Causeni','MD','Republic of Moldova'),(1327,'Raionul Dubasari','MD','Republic of Moldova'),(1328,'Raionul Edineţ','MD','Republic of Moldova'),(1329,'Raionul Ocniţa','MD','Republic of Moldova'),(1330,'Raionul Soroca','MD','Republic of Moldova'),(1331,'Raionul Stefan Voda','MD','Republic of Moldova'),(1332,'Rezina','MD','Republic of Moldova'),(1333,'Rîşcani','MD','Republic of Moldova'),(1334,'Strășeni','MD','Republic of Moldova'),(1335,'Sîngerei','MD','Republic of Moldova'),(1336,'Taraclia','MD','Republic of Moldova'),(1337,'Teleneşti','MD','Republic of Moldova'),(1338,'Ungheni','MD','Republic of Moldova'),(1339,'Unitatea Teritoriala din Stinga Nistrului','MD','Republic of Moldova'),(1340,'Şoldăneşti','MD','Republic of Moldova'),(1341,'Berane','ME','Montenegro'),(1342,'Budva','ME','Montenegro'),(1343,'Danilovgrad','ME','Montenegro'),(1344,'Herceg Novi','ME','Montenegro'),(1345,'Kotor','ME','Montenegro'),(1346,'Podgorica','ME','Montenegro'),(1347,'Ulcinj','ME','Montenegro'),(1348,NULL,'MF','Saint Martin'),(1349,NULL,'MG','Madagascar'),(1350,'Majuro Atoll','MH','Marshall Islands'),(1351,'Bitola','MK','Macedonia'),(1352,'Bogdanci','MK','Macedonia'),(1353,'Bogovinje','MK','Macedonia'),(1354,'Debar','MK','Macedonia'),(1355,'Demir Hisar','MK','Macedonia'),(1356,'Gevgelija','MK','Macedonia'),(1357,'Gostivar','MK','Macedonia'),(1358,'Gradsko','MK','Macedonia'),(1359,'Kavadarci','MK','Macedonia'),(1360,'Kisela Voda','MK','Macedonia'),(1361,'Kratovo','MK','Macedonia'),(1362,'Kumanovo','MK','Macedonia'),(1363,'Makedonski Brod','MK','Macedonia'),(1364,'Negotino','MK','Macedonia'),(1365,'Novo Selo','MK','Macedonia'),(1366,'Ohrid','MK','Macedonia'),(1367,'Opstina Karpos','MK','Macedonia'),(1368,'Opstina Kicevo','MK','Macedonia'),(1369,'Opstina Kocani','MK','Macedonia'),(1370,'Opstina Lipkovo','MK','Macedonia'),(1371,'Opstina Probistip','MK','Macedonia'),(1372,'Opstina Radovis','MK','Macedonia'),(1373,'Opstina Stip','MK','Macedonia'),(1374,'Opstina Vrapciste','MK','Macedonia'),(1375,'Prilep','MK','Macedonia'),(1376,'Resen Municipality','MK','Macedonia'),(1377,'Struga','MK','Macedonia'),(1378,'Strumica','MK','Macedonia'),(1379,'Tetovo','MK','Macedonia'),(1380,'Valandovo Municipality','MK','Macedonia'),(1381,'Veles','MK','Macedonia'),(1382,'Bamako Region','ML','Mali'),(1383,'Kayah State','MM','Myanmar [Burma]'),(1384,'Magway Region','MM','Myanmar [Burma]'),(1385,'Mandalay Region','MM','Myanmar [Burma]'),(1386,'Yangon Region','MM','Myanmar [Burma]'),(1387,'Arhangay Aymag','MN','Mongolia'),(1388,'Bayan-OElgiy Aymag','MN','Mongolia'),(1389,'Bayanhongor Aymag','MN','Mongolia'),(1390,'Central Aimak','MN','Mongolia'),(1391,'East Gobi Aymag','MN','Mongolia'),(1392,'Govi-Altay Aymag','MN','Mongolia'),(1393,'Govi-Sumber','MN','Mongolia'),(1394,'Hentiy Aymag','MN','Mongolia'),(1395,'Hovd','MN','Mongolia'),(1396,'Hovsgol Aymag','MN','Mongolia'),(1397,'Middle Govĭ','MN','Mongolia'),(1398,'Selenge Aymag','MN','Mongolia'),(1399,'Suhbaatar Aymag','MN','Mongolia'),(1400,'Ulaanbaatar Hot','MN','Mongolia'),(1401,'Ömnögovĭ','MN','Mongolia'),(1402,'Övörhangay','MN','Mongolia'),(1403,NULL,'MO','Macao'),(1404,'Saipan','MP','Northern Mariana Islands'),(1405,NULL,'MQ','Martinique'),(1406,'District de Nouakchott','MR','Mauritania'),(1407,NULL,'MS','Montserrat'),(1408,'Attard','MT','Malta'),(1409,'Balzan','MT','Malta'),(1410,'Birkirkara','MT','Malta'),(1411,'Birzebbuga','MT','Malta'),(1412,'Bormla','MT','Malta'),(1413,'Ghajnsielem','MT','Malta'),(1414,'Hal Gharghur','MT','Malta'),(1415,'Hal Ghaxaq','MT','Malta'),(1416,'Haz-Zabbar','MT','Malta'),(1417,'Haz-Zebbug','MT','Malta'),(1418,'Il-Belt Valletta','MT','Malta'),(1419,'Il-Birgu','MT','Malta'),(1420,'Il-Fgura','MT','Malta'),(1421,'Il-Furjana','MT','Malta'),(1422,'Il-Gudja','MT','Malta'),(1423,'Il-Gzira','MT','Malta'),(1424,'Il-Hamrun','MT','Malta'),(1425,'Il-Kalkara','MT','Malta'),(1426,'Il-Marsa','MT','Malta'),(1427,'Il-Mellieha','MT','Malta'),(1428,'Il-Mosta','MT','Malta'),(1429,'Il-Munxar','MT','Malta'),(1430,'Il-Qala','MT','Malta'),(1431,'Il-Qrendi','MT','Malta'),(1432,'In-Naxxar','MT','Malta'),(1433,'Ir-Rabat','MT','Malta'),(1434,'Is-Siggiewi','MT','Malta'),(1435,'Is-Swieqi','MT','Malta'),(1436,'Ix-Xaghra','MT','Malta'),(1437,'Ix-Xewkija','MT','Malta'),(1438,'Iz-Zebbug','MT','Malta'),(1439,'Iz-Zejtun','MT','Malta'),(1440,'Iz-Zurrieq','MT','Malta'),(1441,'Kirkop','MT','Malta'),(1442,'L-Gharb','MT','Malta'),(1443,'L-Ghasri','MT','Malta'),(1444,'L-Iklin','MT','Malta'),(1445,'L-Imdina','MT','Malta'),(1446,'L-Imgarr','MT','Malta'),(1447,'L-Imqabba','MT','Malta'),(1448,'L-Imsida','MT','Malta'),(1449,'L-Imtarfa','MT','Malta'),(1450,'L-Isla','MT','Malta'),(1451,'Lija','MT','Malta'),(1452,'Luqa','MT','Malta'),(1453,'Marsaskala','MT','Malta'),(1454,'Marsaxlokk','MT','Malta'),(1455,'Paola','MT','Malta'),(1456,'Qormi','MT','Malta'),(1457,'Safi','MT','Malta'),(1458,'Saint John','MT','Malta'),(1459,'Saint Julian','MT','Malta'),(1460,'Saint Lawrence','MT','Malta'),(1461,'Saint Lucia','MT','Malta'),(1462,'Saint Paul’s Bay','MT','Malta'),(1463,'Saint Venera','MT','Malta'),(1464,'Sannat','MT','Malta'),(1465,'Ta\' Xbiex','MT','Malta'),(1466,'Tal-Pieta','MT','Malta'),(1467,'Tarxien','MT','Malta'),(1468,'Tas-Sliema','MT','Malta'),(1469,'Victoria','MT','Malta'),(1470,'Black River District','MU','Mauritius'),(1471,'Flacq District','MU','Mauritius'),(1472,'Moka District','MU','Mauritius'),(1473,'Pamplemousses District','MU','Mauritius'),(1474,'Plaines Wilhems District','MU','Mauritius'),(1475,'Port Louis District','MU','Mauritius'),(1476,'Riviere du Rempart District','MU','Mauritius'),(1477,'Rodrigues','MU','Mauritius'),(1478,'Savanne District','MU','Mauritius'),(1479,'Kaafu Atoll','MV','Maldives'),(1480,'Central Region','MW','Malawi'),(1481,'Northern Region','MW','Malawi'),(1482,'Southern Region','MW','Malawi'),(1483,'Aguascalientes','MX','Mexico'),(1484,'Baja California Sur','MX','Mexico'),(1485,'Campeche','MX','Mexico'),(1486,'Chiapas','MX','Mexico'),(1487,'Chihuahua','MX','Mexico'),(1488,'Coahuila','MX','Mexico'),(1489,'Colima','MX','Mexico'),(1490,'Durango','MX','Mexico'),(1491,'Estado de Baja California','MX','Mexico'),(1492,'Estado de Mexico','MX','Mexico'),(1493,'Guanajuato','MX','Mexico'),(1494,'Guerrero','MX','Mexico'),(1495,'Hidalgo','MX','Mexico'),(1496,'Jalisco','MX','Mexico'),(1497,'Mexico City','MX','Mexico'),(1498,'Michoacán','MX','Mexico'),(1499,'Morelos','MX','Mexico'),(1500,'Nayarit','MX','Mexico'),(1501,'Nuevo León','MX','Mexico'),(1502,'Oaxaca','MX','Mexico'),(1503,'Puebla','MX','Mexico'),(1504,'Querétaro','MX','Mexico'),(1505,'Quintana Roo','MX','Mexico'),(1506,'San Luis Potosí','MX','Mexico'),(1507,'Sinaloa','MX','Mexico'),(1508,'Sonora','MX','Mexico'),(1509,'Tabasco','MX','Mexico'),(1510,'Tamaulipas','MX','Mexico'),(1511,'Tlaxcala','MX','Mexico'),(1512,'Veracruz','MX','Mexico'),(1513,'Yucatán','MX','Mexico'),(1514,'Zacatecas','MX','Mexico'),(1515,'Johor','MY','Malaysia'),(1516,'Kedah','MY','Malaysia'),(1517,'Kelantan','MY','Malaysia'),(1518,'Kuala Lumpur','MY','Malaysia'),(1519,'Labuan','MY','Malaysia'),(1520,'Melaka','MY','Malaysia'),(1521,'Negeri Sembilan','MY','Malaysia'),(1522,'Pahang','MY','Malaysia'),(1523,'Penang','MY','Malaysia'),(1524,'Perak','MY','Malaysia'),(1525,'Perlis','MY','Malaysia'),(1526,'Putrajaya','MY','Malaysia'),(1527,'Sabah','MY','Malaysia'),(1528,'Sarawak','MY','Malaysia'),(1529,'Selangor','MY','Malaysia'),(1530,'Terengganu','MY','Malaysia'),(1531,'Cabo Delgado Province','MZ','Mozambique'),(1532,'Cidade de Maputo','MZ','Mozambique'),(1533,'Gaza Province','MZ','Mozambique'),(1534,'Inhambane Province','MZ','Mozambique'),(1535,'Manica Province','MZ','Mozambique'),(1536,'Maputo Province','MZ','Mozambique'),(1537,'Nampula','MZ','Mozambique'),(1538,'Niassa Province','MZ','Mozambique'),(1539,'Provincia de Zambezia','MZ','Mozambique'),(1540,'Sofala Province','MZ','Mozambique'),(1541,'Tete','MZ','Mozambique'),(1542,'Erongo','NA','Namibia'),(1543,'Karas','NA','Namibia'),(1544,'Kavango East','NA','Namibia'),(1545,'Khomas','NA','Namibia'),(1546,'Kunene','NA','Namibia'),(1547,'Omaheke','NA','Namibia'),(1548,'Omusati','NA','Namibia'),(1549,'Oshana','NA','Namibia'),(1550,'Oshikoto','NA','Namibia'),(1551,'Otjozondjupa','NA','Namibia'),(1552,'Zambezi Region','NA','Namibia'),(1553,'South Province','NC','New Caledonia'),(1554,'Niamey','NE','Niger'),(1555,NULL,'NF','Norfolk Island'),(1556,'Abia State','NG','Nigeria'),(1557,'Adamawa','NG','Nigeria'),(1558,'Akwa Ibom State','NG','Nigeria'),(1559,'Anambra','NG','Nigeria'),(1560,'Bauchi','NG','Nigeria'),(1561,'Bayelsa State','NG','Nigeria'),(1562,'Cross River State','NG','Nigeria'),(1563,'Delta','NG','Nigeria'),(1564,'Ebonyi State','NG','Nigeria'),(1565,'Edo','NG','Nigeria'),(1566,'Ekiti State','NG','Nigeria'),(1567,'Enugu State','NG','Nigeria'),(1568,'Federal Capital Territory','NG','Nigeria'),(1569,'Gombe State','NG','Nigeria'),(1570,'Imo State','NG','Nigeria'),(1571,'Kaduna State','NG','Nigeria'),(1572,'Kano State','NG','Nigeria'),(1573,'Katsina State','NG','Nigeria'),(1574,'Kebbi State','NG','Nigeria'),(1575,'Kogi State','NG','Nigeria'),(1576,'Kwara State','NG','Nigeria'),(1577,'Lagos','NG','Nigeria'),(1578,'Nasarawa State','NG','Nigeria'),(1579,'Niger State','NG','Nigeria'),(1580,'Ogun State','NG','Nigeria'),(1581,'Ondo State','NG','Nigeria'),(1582,'Osun State','NG','Nigeria'),(1583,'Oyo State','NG','Nigeria'),(1584,'Plateau State','NG','Nigeria'),(1585,'Rivers State','NG','Nigeria'),(1586,'Sokoto State','NG','Nigeria'),(1587,'Taraba State','NG','Nigeria'),(1588,'Yobe State','NG','Nigeria'),(1589,'Zamfara State','NG','Nigeria'),(1590,'Departamento de Boaco','NI','Nicaragua'),(1591,'Departamento de Carazo','NI','Nicaragua'),(1592,'Departamento de Chinandega','NI','Nicaragua'),(1593,'Departamento de Chontales','NI','Nicaragua'),(1594,'Departamento de Esteli','NI','Nicaragua'),(1595,'Departamento de Granada','NI','Nicaragua'),(1596,'Departamento de Jinotega','NI','Nicaragua'),(1597,'Departamento de Leon','NI','Nicaragua'),(1598,'Departamento de Managua','NI','Nicaragua'),(1599,'Departamento de Masaya','NI','Nicaragua'),(1600,'Departamento de Matagalpa','NI','Nicaragua'),(1601,'Departamento de Nueva Segovia','NI','Nicaragua'),(1602,'Departamento de Rivas','NI','Nicaragua'),(1603,'Region Autonoma Atlantico Sur','NI','Nicaragua'),(1604,'Friesland','NL','Netherlands'),(1605,'Groningen','NL','Netherlands'),(1606,'Limburg','NL','Netherlands'),(1607,'North Brabant','NL','Netherlands'),(1608,'North Holland','NL','Netherlands'),(1609,'Provincie Drenthe','NL','Netherlands'),(1610,'Provincie Flevoland','NL','Netherlands'),(1611,'Provincie Gelderland','NL','Netherlands'),(1612,'Provincie Overijssel','NL','Netherlands'),(1613,'Provincie Utrecht','NL','Netherlands'),(1614,'Provincie Zeeland','NL','Netherlands'),(1615,'South Holland','NL','Netherlands'),(1616,'Akershus','NO','Norway'),(1617,'Aust-Agder','NO','Norway'),(1618,'Buskerud','NO','Norway'),(1619,'Finnmark Fylke','NO','Norway'),(1620,'Hedmark','NO','Norway'),(1621,'Hordaland Fylke','NO','Norway'),(1622,'More og Romsdal fylke','NO','Norway'),(1623,'Nord-Trondelag Fylke','NO','Norway'),(1624,'Nordland Fylke','NO','Norway'),(1625,'Oppland','NO','Norway'),(1626,'Oslo County','NO','Norway'),(1627,'Rogaland Fylke','NO','Norway'),(1628,'Sogn og Fjordane Fylke','NO','Norway'),(1629,'Sor-Trondelag Fylke','NO','Norway'),(1630,'Telemark','NO','Norway'),(1631,'Troms Fylke','NO','Norway'),(1632,'Vest-Agder Fylke','NO','Norway'),(1633,'Vestfold','NO','Norway'),(1634,'Østfold','NO','Norway'),(1635,'Central Region','NP','Nepal'),(1636,'Eastern Region','NP','Nepal'),(1637,'Far Western','NP','Nepal'),(1638,'Western Region','NP','Nepal'),(1639,'Anabar','NR','Nauru'),(1640,NULL,'NU','Niue'),(1641,'Auckland','NZ','New Zealand'),(1642,'Bay of Plenty Region','NZ','New Zealand'),(1643,'Canterbury','NZ','New Zealand'),(1644,'Chatham Islands','NZ','New Zealand'),(1645,'Gisborne','NZ','New Zealand'),(1646,'Hawke\'s Bay','NZ','New Zealand'),(1647,'Manawatu-Wanganui','NZ','New Zealand'),(1648,'Marlborough','NZ','New Zealand'),(1649,'Nelson','NZ','New Zealand'),(1650,'Northland Region','NZ','New Zealand'),(1651,'Otago','NZ','New Zealand'),(1652,'Southland','NZ','New Zealand'),(1653,'Taranaki','NZ','New Zealand'),(1654,'Tasman','NZ','New Zealand'),(1655,'Waikato','NZ','New Zealand'),(1656,'Wellington','NZ','New Zealand'),(1657,'West Coast','NZ','New Zealand'),(1658,'Al Batinah North Governorate','OM','Oman'),(1659,'Muhafazat Masqat','OM','Oman'),(1660,'Muhafazat Zufar','OM','Oman'),(1661,'Muhafazat ad Dakhiliyah','OM','Oman'),(1662,'Embera-Wounaan','PA','Panama'),(1663,'Guna Yala','PA','Panama'),(1664,'Ngoebe-Bugle','PA','Panama'),(1665,'Provincia de Bocas del Toro','PA','Panama'),(1666,'Provincia de Chiriqui','PA','Panama'),(1667,'Provincia de Cocle','PA','Panama'),(1668,'Provincia de Colon','PA','Panama'),(1669,'Provincia de Herrera','PA','Panama'),(1670,'Provincia de Los Santos','PA','Panama'),(1671,'Provincia de Panama','PA','Panama'),(1672,'Provincia de Veraguas','PA','Panama'),(1673,'Provincia del Darien','PA','Panama'),(1674,'Amazonas','PE','Peru'),(1675,'Ancash','PE','Peru'),(1676,'Apurimac','PE','Peru'),(1677,'Arequipa','PE','Peru'),(1678,'Ayacucho','PE','Peru'),(1679,'Cajamarca','PE','Peru'),(1680,'Callao','PE','Peru'),(1681,'Cusco','PE','Peru'),(1682,'Departamento de Moquegua','PE','Peru'),(1683,'Huancavelica','PE','Peru'),(1684,'Ica','PE','Peru'),(1685,'Junín Region','PE','Peru'),(1686,'La Libertad','PE','Peru'),(1687,'Lambayeque','PE','Peru'),(1688,'Lima region','PE','Peru'),(1689,'Loreto','PE','Peru'),(1690,'Pasco Region','PE','Peru'),(1691,'Piura','PE','Peru'),(1692,'Provincia de Lima','PE','Peru'),(1693,'Puno','PE','Peru'),(1694,'Region de Huanuco','PE','Peru'),(1695,'Region de San Martin','PE','Peru'),(1696,'Tacna','PE','Peru'),(1697,'Tumbes','PE','Peru'),(1698,'Ucayali','PE','Peru'),(1699,'Iles du Vent','PF','French Polynesia'),(1700,'Leeward Islands','PF','French Polynesia'),(1701,'Bougainville','PG','Papua New Guinea'),(1702,'Central Province','PG','Papua New Guinea'),(1703,'Chimbu Province','PG','Papua New Guinea'),(1704,'East New Britain Province','PG','Papua New Guinea'),(1705,'East Sepik Province','PG','Papua New Guinea'),(1706,'Eastern Highlands Province','PG','Papua New Guinea'),(1707,'Enga Province','PG','Papua New Guinea'),(1708,'Gulf Province','PG','Papua New Guinea'),(1709,'Madang Province','PG','Papua New Guinea'),(1710,'Manus Province','PG','Papua New Guinea'),(1711,'Milne Bay Province','PG','Papua New Guinea'),(1712,'Morobe Province','PG','Papua New Guinea'),(1713,'National Capital','PG','Papua New Guinea'),(1714,'New Ireland','PG','Papua New Guinea'),(1715,'Northern Province','PG','Papua New Guinea'),(1716,'Southern Highlands Province','PG','Papua New Guinea'),(1717,'West New Britain Province','PG','Papua New Guinea'),(1718,'West Sepik Province','PG','Papua New Guinea'),(1719,'Western Highlands Province','PG','Papua New Guinea'),(1720,'Western Province','PG','Papua New Guinea'),(1721,'Autonomous Region in Muslim Mindanao','PH','Philippines'),(1722,'Bicol','PH','Philippines'),(1723,'Cagayan Valley','PH','Philippines'),(1724,'Calabarzon','PH','Philippines'),(1725,'Caraga','PH','Philippines'),(1726,'Central Luzon','PH','Philippines'),(1727,'Central Visayas','PH','Philippines'),(1728,'Cordillera','PH','Philippines'),(1729,'Davao','PH','Philippines'),(1730,'Eastern Visayas','PH','Philippines'),(1731,'Ilocos','PH','Philippines'),(1732,'Mimaropa','PH','Philippines'),(1733,'National Capital Region','PH','Philippines'),(1734,'Northern Mindanao','PH','Philippines'),(1735,'Soccsksargen','PH','Philippines'),(1736,'Western Visayas','PH','Philippines'),(1737,'Zamboanga Peninsula','PH','Philippines'),(1738,'Azad Kashmir','PK','Pakistan'),(1739,'Balochistan','PK','Pakistan'),(1740,'Federally Administered Tribal Areas','PK','Pakistan'),(1741,'Gilgit-Baltistan','PK','Pakistan'),(1742,'Islamabad Capital Territory','PK','Pakistan'),(1743,'Khyber Pakhtunkhwa','PK','Pakistan'),(1744,'Punjab','PK','Pakistan'),(1745,'Sindh','PK','Pakistan'),(1746,'Greater Poland Voivodeship','PL','Poland'),(1747,'Kujawsko-Pomorskie','PL','Poland'),(1748,'Lesser Poland Voivodeship','PL','Poland'),(1749,'Lower Silesian Voivodeship','PL','Poland'),(1750,'Lublin Voivodeship','PL','Poland'),(1751,'Lubusz','PL','Poland'),(1752,'Masovian Voivodeship','PL','Poland'),(1753,'Opole Voivodeship','PL','Poland'),(1754,'Podlasie','PL','Poland'),(1755,'Pomeranian Voivodeship','PL','Poland'),(1756,'Silesian Voivodeship','PL','Poland'),(1757,'Subcarpathian Voivodeship','PL','Poland'),(1758,'Warmian-Masurian Voivodeship','PL','Poland'),(1759,'West Pomeranian Voivodeship','PL','Poland'),(1760,'Łódź Voivodeship','PL','Poland'),(1761,'Świętokrzyskie','PL','Poland'),(1762,'Commune de Miquelon-Langlade','PM','Saint Pierre and Miquelon'),(1763,'Commune de Saint-Pierre','PM','Saint Pierre and Miquelon'),(1764,NULL,'PN','Pitcairn Islands'),(1765,NULL,'PR','Puerto Rico'),(1766,NULL,'PS','Palestine'),(1767,'Aveiro','PT','Portugal'),(1768,'Azores','PT','Portugal'),(1769,'Beja','PT','Portugal'),(1770,'Braga','PT','Portugal'),(1771,'Bragança','PT','Portugal'),(1772,'Castelo Branco','PT','Portugal'),(1773,'Coimbra','PT','Portugal'),(1774,'Faro','PT','Portugal'),(1775,'Guarda','PT','Portugal'),(1776,'Leiria','PT','Portugal'),(1777,'Lisbon','PT','Portugal'),(1778,'Madeira','PT','Portugal'),(1779,'Portalegre','PT','Portugal'),(1780,'Porto','PT','Portugal'),(1781,'Santarém','PT','Portugal'),(1782,'Setúbal','PT','Portugal'),(1783,'Viana do Castelo','PT','Portugal'),(1784,'Vila Real','PT','Portugal'),(1785,'Viseu','PT','Portugal'),(1786,'Évora','PT','Portugal'),(1787,NULL,'PW','Palau'),(1788,'Asuncion','PY','Paraguay'),(1789,'Departamento Central','PY','Paraguay'),(1790,'Departamento de Alto Paraguay','PY','Paraguay'),(1791,'Departamento de Boqueron','PY','Paraguay'),(1792,'Departamento de Caazapa','PY','Paraguay'),(1793,'Departamento de Itapua','PY','Paraguay'),(1794,'Departamento de Misiones','PY','Paraguay'),(1795,'Departamento de Paraguari','PY','Paraguay'),(1796,'Departamento de la Cordillera','PY','Paraguay'),(1797,'Departamento del Alto Parana','PY','Paraguay'),(1798,'Departamento del Amambay','PY','Paraguay'),(1799,'Al Wakrah','QA','Qatar'),(1800,'Baladiyat Umm Salal','QA','Qatar'),(1801,'Baladiyat ad Dawhah','QA','Qatar'),(1802,'Baladiyat al Khawr wa adh Dhakhirah','QA','Qatar'),(1803,'Baladiyat ar Rayyan','QA','Qatar'),(1804,'Baladiyat ash Shamal','QA','Qatar'),(1805,NULL,'RE','Réunion'),(1806,'Arad','RO','Romania'),(1807,'Bihor','RO','Romania'),(1808,'Bucuresti','RO','Romania'),(1809,'Constanta','RO','Romania'),(1810,'Covasna','RO','Romania'),(1811,'Dolj','RO','Romania'),(1812,'Giurgiu','RO','Romania'),(1813,'Gorj','RO','Romania'),(1814,'Harghita','RO','Romania'),(1815,'Hunedoara','RO','Romania'),(1816,'Ilfov','RO','Romania'),(1817,'Judetul Alba','RO','Romania'),(1818,'Judetul Arges','RO','Romania'),(1819,'Judetul Bacau','RO','Romania'),(1820,'Judetul Bistrita-Nasaud','RO','Romania'),(1821,'Judetul Botosani','RO','Romania'),(1822,'Judetul Braila','RO','Romania'),(1823,'Judetul Brasov','RO','Romania'),(1824,'Judetul Buzau','RO','Romania'),(1825,'Judetul Calarasi','RO','Romania'),(1826,'Judetul Caras-Severin','RO','Romania'),(1827,'Judetul Cluj','RO','Romania'),(1828,'Judetul Dambovita','RO','Romania'),(1829,'Judetul Galati','RO','Romania'),(1830,'Judetul Ialomita','RO','Romania'),(1831,'Judetul Iasi','RO','Romania'),(1832,'Judetul Mehedinti','RO','Romania'),(1833,'Judetul Mures','RO','Romania'),(1834,'Judetul Neamt','RO','Romania'),(1835,'Judetul Salaj','RO','Romania'),(1836,'Judetul Sibiu','RO','Romania'),(1837,'Judetul Timis','RO','Romania'),(1838,'Judetul Valcea','RO','Romania'),(1839,'Maramureş','RO','Romania'),(1840,'Olt County','RO','Romania'),(1841,'Prahova','RO','Romania'),(1842,'Satu Mare','RO','Romania'),(1843,'Suceava','RO','Romania'),(1844,'Teleorman','RO','Romania'),(1845,'Tulcea','RO','Romania'),(1846,'Vaslui','RO','Romania'),(1847,'Vrancea','RO','Romania'),(1848,'Vojvodina','RS','Serbia'),(1849,'Altai Krai','RU','Russia'),(1850,'Altai Republic','RU','Russia'),(1851,'Amurskaya Oblast\'','RU','Russia'),(1852,'Arkhangelskaya','RU','Russia'),(1853,'Astrakhanskaya Oblast\'','RU','Russia'),(1854,'Bashkortostan','RU','Russia'),(1855,'Belgorodskaya Oblast\'','RU','Russia'),(1856,'Bryanskaya Oblast\'','RU','Russia'),(1857,'Chechnya','RU','Russia'),(1858,'Chelyabinsk','RU','Russia'),(1859,'Chukotskiy Avtonomnyy Okrug','RU','Russia'),(1860,'Chuvashia','RU','Russia'),(1861,'Dagestan','RU','Russia'),(1862,'Irkutskaya Oblast\'','RU','Russia'),(1863,'Ivanovskaya Oblast\'','RU','Russia'),(1864,'Jewish Autonomous Oblast','RU','Russia'),(1865,'Kabardino-Balkarskaya Respublika','RU','Russia'),(1866,'Kaliningradskaya Oblast\'','RU','Russia'),(1867,'Kalmykiya','RU','Russia'),(1868,'Kaluzhskaya Oblast\'','RU','Russia'),(1869,'Kamtchatski Kray','RU','Russia'),(1870,'Karachayevo-Cherkesiya','RU','Russia'),(1871,'Kemerovskaya Oblast\'','RU','Russia'),(1872,'Khabarovsk Krai','RU','Russia'),(1873,'Khanty-Mansiyskiy Avtonomnyy Okrug-Yugra','RU','Russia'),(1874,'Kirovskaya Oblast\'','RU','Russia'),(1875,'Komi Republic','RU','Russia'),(1876,'Kostromskaya Oblast\'','RU','Russia'),(1877,'Krasnodarskiy Kray','RU','Russia'),(1878,'Krasnoyarskiy Kray','RU','Russia'),(1879,'Kurganskaya Oblast\'','RU','Russia'),(1880,'Kurskaya Oblast\'','RU','Russia'),(1881,'Leningradskaya Oblast\'','RU','Russia'),(1882,'Lipetskaya Oblast\'','RU','Russia'),(1883,'Magadanskaya Oblast\'','RU','Russia'),(1884,'Moscow','RU','Russia'),(1885,'Moscow Oblast','RU','Russia'),(1886,'Murmansk','RU','Russia'),(1887,'Nenetskiy Avtonomnyy Okrug','RU','Russia'),(1888,'Nizhegorodskaya Oblast\'','RU','Russia'),(1889,'North Ossetia','RU','Russia'),(1890,'Novgorodskaya Oblast\'','RU','Russia'),(1891,'Novosibirskaya Oblast\'','RU','Russia'),(1892,'Omskaya Oblast\'','RU','Russia'),(1893,'Orenburgskaya Oblast\'','RU','Russia'),(1894,'Orlovskaya Oblast\'','RU','Russia'),(1895,'Penzenskaya Oblast\'','RU','Russia'),(1896,'Perm Krai','RU','Russia'),(1897,'Primorskiy Kray','RU','Russia'),(1898,'Pskovskaya Oblast\'','RU','Russia'),(1899,'Republic of Karelia','RU','Russia'),(1900,'Respublika Adygeya','RU','Russia'),(1901,'Respublika Buryatiya','RU','Russia'),(1902,'Respublika Ingushetiya','RU','Russia'),(1903,'Respublika Khakasiya','RU','Russia'),(1904,'Respublika Mariy-El','RU','Russia'),(1905,'Respublika Mordoviya','RU','Russia'),(1906,'Respublika Sakha (Yakutiya)','RU','Russia'),(1907,'Respublika Tyva','RU','Russia'),(1908,'Rostov Oblast','RU','Russia'),(1909,'Ryazanskaya Oblast\'','RU','Russia'),(1910,'Sakhalinskaya Oblast\'','RU','Russia'),(1911,'Samarskaya Oblast\'','RU','Russia'),(1912,'Saratovskaya Oblast\'','RU','Russia'),(1913,'Smolenskaya Oblast\'','RU','Russia'),(1914,'St.-Petersburg','RU','Russia'),(1915,'Stavropol\'skiy Kray','RU','Russia'),(1916,'Sverdlovskaya Oblast\'','RU','Russia'),(1917,'Tambovskaya Oblast\'','RU','Russia'),(1918,'Tatarstan','RU','Russia'),(1919,'Tomskaya Oblast\'','RU','Russia'),(1920,'Transbaikal Territory','RU','Russia'),(1921,'Tul\'skaya Oblast\'','RU','Russia'),(1922,'Tverskaya Oblast\'','RU','Russia'),(1923,'Tyumenskaya Oblast\'','RU','Russia'),(1924,'Udmurtskaya Respublika','RU','Russia'),(1925,'Ulyanovsk Oblast','RU','Russia'),(1926,'Vladimirskaya Oblast\'','RU','Russia'),(1927,'Volgogradskaya Oblast\'','RU','Russia'),(1928,'Vologodskaya Oblast\'','RU','Russia'),(1929,'Voronezhskaya Oblast\'','RU','Russia'),(1930,'Yamalo-Nenetskiy Avtonomnyy Okrug','RU','Russia'),(1931,'Yaroslavskaya Oblast\'','RU','Russia'),(1932,'Kigali','RW','Rwanda'),(1933,'\'Asir','SA','Saudi Arabia'),(1934,'Al Bahah','SA','Saudi Arabia'),(1935,'Al Madinah al Munawwarah','SA','Saudi Arabia'),(1936,'Al-Qassim','SA','Saudi Arabia'),(1937,'Ar Riyāḑ','SA','Saudi Arabia'),(1938,'Eastern Province','SA','Saudi Arabia'),(1939,'Hai\'l Region','SA','Saudi Arabia'),(1940,'Jizan','SA','Saudi Arabia'),(1941,'Makkah Province','SA','Saudi Arabia'),(1942,'Najran','SA','Saudi Arabia'),(1943,'Tabuk','SA','Saudi Arabia'),(1944,'Guadalcanal Province','SB','Solomon Islands'),(1945,'English River','SC','Seychelles'),(1946,'Takamaka','SC','Seychelles'),(1947,'Khartoum','SD','Sudan'),(1948,'Southern Kordofan','SD','Sudan'),(1949,'Blekinge','SE','Sweden'),(1950,'Dalarna','SE','Sweden'),(1951,'Gotland','SE','Sweden'),(1952,'Gävleborg','SE','Sweden'),(1953,'Halland','SE','Sweden'),(1954,'Jämtland','SE','Sweden'),(1955,'Jönköping','SE','Sweden'),(1956,'Kalmar','SE','Sweden'),(1957,'Kronoberg','SE','Sweden'),(1958,'Norrbotten','SE','Sweden'),(1959,'Skåne','SE','Sweden'),(1960,'Stockholm','SE','Sweden'),(1961,'Södermanland','SE','Sweden'),(1962,'Uppsala','SE','Sweden'),(1963,'Värmland','SE','Sweden'),(1964,'Västerbotten','SE','Sweden'),(1965,'Västernorrland','SE','Sweden'),(1966,'Västmanland','SE','Sweden'),(1967,'Västra Götaland','SE','Sweden'),(1968,'Örebro','SE','Sweden'),(1969,'Östergötland','SE','Sweden'),(1970,'Central Singapore Community Development Council','SG','Singapore'),(1971,'North East Community Development Region','SG','Singapore'),(1972,'North West Community Development Council','SG','Singapore'),(1973,'South West Community Development Council','SG','Singapore'),(1974,NULL,'SH','Saint Helena'),(1975,'Beltinci','SI','Slovenia'),(1976,'Bohinj','SI','Slovenia'),(1977,'Borovnica','SI','Slovenia'),(1978,'Brda','SI','Slovenia'),(1979,'Brezovica','SI','Slovenia'),(1980,'Cankova','SI','Slovenia'),(1981,'Celje','SI','Slovenia'),(1982,'Cerknica','SI','Slovenia'),(1983,'Cerkno','SI','Slovenia'),(1984,'Cerkvenjak','SI','Slovenia'),(1985,'Cirkulane','SI','Slovenia'),(1986,'Destrnik','SI','Slovenia'),(1987,'Dobrova-Polhov Gradec','SI','Slovenia'),(1988,'Dol pri Ljubljani','SI','Slovenia'),(1989,'Dolenjske Toplice','SI','Slovenia'),(1990,'Dravograd','SI','Slovenia'),(1991,'Duplek','SI','Slovenia'),(1992,'Gorenja Vas-Poljane','SI','Slovenia'),(1993,'Gornja Radgona','SI','Slovenia'),(1994,'Gornji Grad','SI','Slovenia'),(1995,'Gornji Petrovci','SI','Slovenia'),(1996,'Grosuplje','SI','Slovenia'),(1997,'Hajdina','SI','Slovenia'),(1998,'Horjul','SI','Slovenia'),(1999,'Hrastnik','SI','Slovenia'),(2000,'Hrpelje-Kozina','SI','Slovenia'),(2001,'Idrija','SI','Slovenia'),(2002,'Ig','SI','Slovenia'),(2003,'Ilirska Bistrica','SI','Slovenia'),(2004,'Izola','SI','Slovenia'),(2005,'Jesenice','SI','Slovenia'),(2006,'Kamnik','SI','Slovenia'),(2007,'Komen','SI','Slovenia'),(2008,'Koper','SI','Slovenia'),(2009,'Kostanjevica na Krki','SI','Slovenia'),(2010,'Kostel','SI','Slovenia'),(2011,'Kranj','SI','Slovenia'),(2012,'Kranjska Gora','SI','Slovenia'),(2013,'Kuzma','SI','Slovenia'),(2014,'Lenart','SI','Slovenia'),(2015,'Lendava','SI','Slovenia'),(2016,'Litija','SI','Slovenia'),(2017,'Ljubljana','SI','Slovenia'),(2018,'Ljubno','SI','Slovenia'),(2019,'Ljutomer','SI','Slovenia'),(2020,'Logatec','SI','Slovenia'),(2021,'Log–Dragomer','SI','Slovenia'),(2022,'Lovrenc na Pohorju','SI','Slovenia'),(2023,'Lukovica','SI','Slovenia'),(2024,'Makole','SI','Slovenia'),(2025,'Maribor','SI','Slovenia'),(2026,'Markovci','SI','Slovenia'),(2027,'Medvode','SI','Slovenia'),(2028,'Mestna Obcina Novo mesto','SI','Slovenia'),(2029,'Metlika','SI','Slovenia'),(2030,'Miren-Kostanjevica','SI','Slovenia'),(2031,'Mislinja','SI','Slovenia'),(2032,'Mokronog-Trebelno','SI','Slovenia'),(2033,'Mozirje','SI','Slovenia'),(2034,'Municipality of Cerklje na Gorenjskem','SI','Slovenia'),(2035,'Municipality of Dobrna','SI','Slovenia'),(2036,'Municipality of Šentjur','SI','Slovenia'),(2037,'Murska Sobota','SI','Slovenia'),(2038,'Naklo','SI','Slovenia'),(2039,'Nova Gorica','SI','Slovenia'),(2040,'Obcina Ajdovscina','SI','Slovenia'),(2041,'Obcina Apace','SI','Slovenia'),(2042,'Obcina Bled','SI','Slovenia'),(2043,'Obcina Brezice','SI','Slovenia'),(2044,'Obcina Crna na Koroskem','SI','Slovenia'),(2045,'Obcina Crnomelj','SI','Slovenia'),(2046,'Obcina Domzale','SI','Slovenia'),(2047,'Obcina Gorisnica','SI','Slovenia'),(2048,'Obcina Hoce-Slivnica','SI','Slovenia'),(2049,'Obcina Ivancna Gorica','SI','Slovenia'),(2050,'Obcina Jursinci','SI','Slovenia'),(2051,'Obcina Kidricevo','SI','Slovenia'),(2052,'Obcina Kobarid','SI','Slovenia'),(2053,'Obcina Kocevje','SI','Slovenia'),(2054,'Obcina Krsko','SI','Slovenia'),(2055,'Obcina Lasko','SI','Slovenia'),(2056,'Obcina Loska Dolina','SI','Slovenia'),(2057,'Obcina Majsperk','SI','Slovenia'),(2058,'Obcina Menges','SI','Slovenia'),(2059,'Obcina Mezica','SI','Slovenia'),(2060,'Obcina Miklavz na Dravskem Polju','SI','Slovenia'),(2061,'Obcina Moravce','SI','Slovenia'),(2062,'Obcina Ormoz','SI','Slovenia'),(2063,'Obcina Poljcane','SI','Slovenia'),(2064,'Obcina Race-Fram','SI','Slovenia'),(2065,'Obcina Radece','SI','Slovenia'),(2066,'Obcina Ravne na Koroskem','SI','Slovenia'),(2067,'Obcina Razkrizje','SI','Slovenia'),(2068,'Obcina Recica ob Savinji','SI','Slovenia'),(2069,'Obcina Rogaska Slatina','SI','Slovenia'),(2070,'Obcina Rogasovci','SI','Slovenia'),(2071,'Obcina Ruse','SI','Slovenia'),(2072,'Obcina Semic','SI','Slovenia'),(2073,'Obcina Sempeter-Vrtojba','SI','Slovenia'),(2074,'Obcina Sencur','SI','Slovenia'),(2075,'Obcina Sentilj','SI','Slovenia'),(2076,'Obcina Sentjernej','SI','Slovenia'),(2077,'Obcina Sezana','SI','Slovenia'),(2078,'Obcina Skofljica','SI','Slovenia'),(2079,'Obcina Smartno ob Paki','SI','Slovenia'),(2080,'Obcina Smartno pri Litiji','SI','Slovenia'),(2081,'Obcina Sostanj','SI','Slovenia'),(2082,'Obcina Store','SI','Slovenia'),(2083,'Obcina Straza','SI','Slovenia'),(2084,'Obcina Tisina','SI','Slovenia'),(2085,'Obcina Tolmin','SI','Slovenia'),(2086,'Obcina Trzic','SI','Slovenia'),(2087,'Obcina Velike Lasce','SI','Slovenia'),(2088,'Obcina Zalec','SI','Slovenia'),(2089,'Obcina Zelezniki','SI','Slovenia'),(2090,'Obcina Zirovnica','SI','Slovenia'),(2091,'Obcina Zrece','SI','Slovenia'),(2092,'Obcina Zuzemberk','SI','Slovenia'),(2093,'Odranci','SI','Slovenia'),(2094,'Osilnica','SI','Slovenia'),(2095,'Pesnica','SI','Slovenia'),(2096,'Piran','SI','Slovenia'),(2097,'Pivka','SI','Slovenia'),(2098,'Podlehnik','SI','Slovenia'),(2099,'Polzela','SI','Slovenia'),(2100,'Postojna','SI','Slovenia'),(2101,'Preddvor','SI','Slovenia'),(2102,'Prevalje','SI','Slovenia'),(2103,'Ptuj','SI','Slovenia'),(2104,'Puconci','SI','Slovenia'),(2105,'Radlje ob Dravi','SI','Slovenia'),(2106,'Radovljica','SI','Slovenia'),(2107,'Ribnica','SI','Slovenia'),(2108,'Selnica ob Dravi','SI','Slovenia'),(2109,'Sevnica','SI','Slovenia'),(2110,'Slovenj Gradec','SI','Slovenia'),(2111,'Slovenska Bistrica','SI','Slovenia'),(2112,'Slovenske Konjice','SI','Slovenia'),(2113,'Sveta Ana','SI','Slovenia'),(2114,'Tabor','SI','Slovenia'),(2115,'Trbovlje','SI','Slovenia'),(2116,'Trebnje','SI','Slovenia'),(2117,'Trzin','SI','Slovenia'),(2118,'Velenje','SI','Slovenia'),(2119,'Videm','SI','Slovenia'),(2120,'Vipava','SI','Slovenia'),(2121,'Vransko','SI','Slovenia'),(2122,'Zagorje ob Savi','SI','Slovenia'),(2123,'Škofja Loka','SI','Slovenia'),(2124,'Jan Mayen','SJ','Svalbard and Jan Mayen'),(2125,'Svalbard','SJ','Svalbard and Jan Mayen'),(2126,'Banskobystricky kraj','SK','Slovak Republic'),(2127,'Bratislavsky kraj','SK','Slovak Republic'),(2128,'Kosicky kraj','SK','Slovak Republic'),(2129,'Nitriansky kraj','SK','Slovak Republic'),(2130,'Presovsky kraj','SK','Slovak Republic'),(2131,'Trenciansky kraj','SK','Slovak Republic'),(2132,'Trnavsky kraj','SK','Slovak Republic'),(2133,'Zilinsky kraj','SK','Slovak Republic'),(2134,'Western Area','SL','Sierra Leone'),(2135,'Castello di Borgo Maggiore','SM','San Marino'),(2136,'Castello di Faetano','SM','San Marino'),(2137,'Castello di San Marino Citta','SM','San Marino'),(2138,'Serravalle','SM','San Marino'),(2139,'Dakar','SN','Senegal'),(2140,'Fatick','SN','Senegal'),(2141,'Kaolack','SN','Senegal'),(2142,'Kolda','SN','Senegal'),(2143,'Louga','SN','Senegal'),(2144,'Region de Kaffrine','SN','Senegal'),(2145,'Region de Kedougou','SN','Senegal'),(2146,'Region de Sedhiou','SN','Senegal'),(2147,'Saint-Louis','SN','Senegal'),(2148,'Tambacounda','SN','Senegal'),(2149,'Banaadir','SO','Somalia'),(2150,'Gedo','SO','Somalia'),(2151,'Woqooyi Galbeed','SO','Somalia'),(2152,'Distrikt Brokopondo','SR','Suriname'),(2153,'Distrikt Commewijne','SR','Suriname'),(2154,'Distrikt Coronie','SR','Suriname'),(2155,'Distrikt Marowijne','SR','Suriname'),(2156,'Distrikt Nickerie','SR','Suriname'),(2157,'Distrikt Para','SR','Suriname'),(2158,'Distrikt Paramaribo','SR','Suriname'),(2159,'Distrikt Saramacca','SR','Suriname'),(2160,'Distrikt Sipaliwini','SR','Suriname'),(2161,'Distrikt Wanica','SR','Suriname'),(2162,'Central Equatoria','SS','South Sudan'),(2163,'Principe','ST','São Tomé and Príncipe'),(2164,'São Tomé Island','ST','São Tomé and Príncipe'),(2165,'Departamento de Ahuachapan','SV','El Salvador'),(2166,'Departamento de Cabanas','SV','El Salvador'),(2167,'Departamento de Chalatenango','SV','El Salvador'),(2168,'Departamento de Cuscatlan','SV','El Salvador'),(2169,'Departamento de La Libertad','SV','El Salvador'),(2170,'Departamento de La Paz','SV','El Salvador'),(2171,'Departamento de La Union','SV','El Salvador'),(2172,'Departamento de Morazan','SV','El Salvador'),(2173,'Departamento de San Miguel','SV','El Salvador'),(2174,'Departamento de San Salvador','SV','El Salvador'),(2175,'Departamento de San Vicente','SV','El Salvador'),(2176,'Departamento de Santa Ana','SV','El Salvador'),(2177,'Departamento de Sonsonate','SV','El Salvador'),(2178,'Departamento de Usulutan','SV','El Salvador'),(2179,NULL,'SX','Sint Maarten'),(2180,'Aleppo Governorate','SY','Syria'),(2181,'As-Suwayda Governorate','SY','Syria'),(2182,'Damascus Governorate','SY','Syria'),(2183,'Hama Governorate','SY','Syria'),(2184,'Latakia Governorate','SY','Syria'),(2185,'Quneitra Governorate','SY','Syria'),(2186,'Hhohho District','SZ','Swaziland'),(2187,'Lubombo District','SZ','Swaziland'),(2188,'Manzini District','SZ','Swaziland'),(2189,NULL,'TC','Turks and Caicos Islands'),(2190,'Chari-Baguirmi Region','TD','Chad'),(2191,'Hadjer-Lamis','TD','Chad'),(2192,'Logone Occidental Region','TD','Chad'),(2193,'Ouadaï','TD','Chad'),(2194,NULL,'TF','French Southern Territories'),(2195,'Maritime','TG','Togo'),(2196,'Bangkok','TH','Thailand'),(2197,'Changwat Amnat Charoen','TH','Thailand'),(2198,'Changwat Ang Thong','TH','Thailand'),(2199,'Changwat Bueng Kan','TH','Thailand'),(2200,'Changwat Buriram','TH','Thailand'),(2201,'Changwat Chachoengsao','TH','Thailand'),(2202,'Changwat Chai Nat','TH','Thailand'),(2203,'Changwat Chaiyaphum','TH','Thailand'),(2204,'Changwat Chanthaburi','TH','Thailand'),(2205,'Changwat Chiang Rai','TH','Thailand'),(2206,'Changwat Chon Buri','TH','Thailand'),(2207,'Changwat Chumphon','TH','Thailand'),(2208,'Changwat Kalasin','TH','Thailand'),(2209,'Changwat Kamphaeng Phet','TH','Thailand'),(2210,'Changwat Kanchanaburi','TH','Thailand'),(2211,'Changwat Khon Kaen','TH','Thailand'),(2212,'Changwat Krabi','TH','Thailand'),(2213,'Changwat Lampang','TH','Thailand'),(2214,'Changwat Lamphun','TH','Thailand'),(2215,'Changwat Loei','TH','Thailand'),(2216,'Changwat Lop Buri','TH','Thailand'),(2217,'Changwat Mae Hong Son','TH','Thailand'),(2218,'Changwat Maha Sarakham','TH','Thailand'),(2219,'Changwat Mukdahan','TH','Thailand'),(2220,'Changwat Nakhon Nayok','TH','Thailand'),(2221,'Changwat Nakhon Pathom','TH','Thailand'),(2222,'Changwat Nakhon Phanom','TH','Thailand'),(2223,'Changwat Nakhon Ratchasima','TH','Thailand'),(2224,'Changwat Nakhon Sawan','TH','Thailand'),(2225,'Changwat Nakhon Si Thammarat','TH','Thailand'),(2226,'Changwat Nan','TH','Thailand'),(2227,'Changwat Narathiwat','TH','Thailand'),(2228,'Changwat Nong Bua Lamphu','TH','Thailand'),(2229,'Changwat Nong Khai','TH','Thailand'),(2230,'Changwat Nonthaburi','TH','Thailand'),(2231,'Changwat Pathum Thani','TH','Thailand'),(2232,'Changwat Pattani','TH','Thailand'),(2233,'Changwat Phangnga','TH','Thailand'),(2234,'Changwat Phatthalung','TH','Thailand'),(2235,'Changwat Phayao','TH','Thailand'),(2236,'Changwat Phetchabun','TH','Thailand'),(2237,'Changwat Phetchaburi','TH','Thailand'),(2238,'Changwat Phichit','TH','Thailand'),(2239,'Changwat Phitsanulok','TH','Thailand'),(2240,'Changwat Phra Nakhon Si Ayutthaya','TH','Thailand'),(2241,'Changwat Phrae','TH','Thailand'),(2242,'Changwat Prachin Buri','TH','Thailand'),(2243,'Changwat Prachuap Khiri Khan','TH','Thailand'),(2244,'Changwat Ranong','TH','Thailand'),(2245,'Changwat Ratchaburi','TH','Thailand'),(2246,'Changwat Rayong','TH','Thailand'),(2247,'Changwat Roi Et','TH','Thailand'),(2248,'Changwat Sa Kaeo','TH','Thailand'),(2249,'Changwat Sakon Nakhon','TH','Thailand'),(2250,'Changwat Samut Prakan','TH','Thailand'),(2251,'Changwat Samut Sakhon','TH','Thailand'),(2252,'Changwat Samut Songkhram','TH','Thailand'),(2253,'Changwat Sara Buri','TH','Thailand'),(2254,'Changwat Satun','TH','Thailand'),(2255,'Changwat Sing Buri','TH','Thailand'),(2256,'Changwat Sisaket','TH','Thailand'),(2257,'Changwat Songkhla','TH','Thailand'),(2258,'Changwat Sukhothai','TH','Thailand'),(2259,'Changwat Suphan Buri','TH','Thailand'),(2260,'Changwat Surat Thani','TH','Thailand'),(2261,'Changwat Surin','TH','Thailand'),(2262,'Changwat Tak','TH','Thailand'),(2263,'Changwat Trang','TH','Thailand'),(2264,'Changwat Trat','TH','Thailand'),(2265,'Changwat Ubon Ratchathani','TH','Thailand'),(2266,'Changwat Udon Thani','TH','Thailand'),(2267,'Changwat Uthai Thani','TH','Thailand'),(2268,'Changwat Uttaradit','TH','Thailand'),(2269,'Changwat Yala','TH','Thailand'),(2270,'Changwat Yasothon','TH','Thailand'),(2271,'Chiang Mai Province','TH','Thailand'),(2272,'Phuket','TH','Thailand'),(2273,'Gorno-Badakhshan','TJ','Tajikistan'),(2274,'Viloyati Sughd','TJ','Tajikistan'),(2275,'Nukunonu','TK','Tokelau'),(2276,'Dili','TL','East Timor'),(2277,'Ahal','TM','Turkmenistan'),(2278,'Gafsa','TN','Tunisia'),(2279,'Gouvernorat de Beja','TN','Tunisia'),(2280,'Gouvernorat de Ben Arous','TN','Tunisia'),(2281,'Gouvernorat de Bizerte','TN','Tunisia'),(2282,'Gouvernorat de Gabes','TN','Tunisia'),(2283,'Gouvernorat de Kairouan','TN','Tunisia'),(2284,'Gouvernorat de Kasserine','TN','Tunisia'),(2285,'Gouvernorat de Kef','TN','Tunisia'),(2286,'Gouvernorat de Mahdia','TN','Tunisia'),(2287,'Gouvernorat de Monastir','TN','Tunisia'),(2288,'Gouvernorat de Nabeul','TN','Tunisia'),(2289,'Gouvernorat de Sfax','TN','Tunisia'),(2290,'Gouvernorat de Sidi Bouzid','TN','Tunisia'),(2291,'Gouvernorat de Siliana','TN','Tunisia'),(2292,'Gouvernorat de Sousse','TN','Tunisia'),(2293,'Gouvernorat de Tozeur','TN','Tunisia'),(2294,'Gouvernorat de Tunis','TN','Tunisia'),(2295,'Gouvernorat de Zaghouan','TN','Tunisia'),(2296,'Gouvernorat de l\'Ariana','TN','Tunisia'),(2297,'Tataouine','TN','Tunisia'),(2298,'Vava\'u','TO','Tonga'),(2299,'Adana','TR','Turkey'),(2300,'Adiyaman','TR','Turkey'),(2301,'Afyonkarahisar','TR','Turkey'),(2302,'Aksaray','TR','Turkey'),(2303,'Amasya','TR','Turkey'),(2304,'Ankara','TR','Turkey'),(2305,'Antalya','TR','Turkey'),(2306,'Ardahan','TR','Turkey'),(2307,'Artvin','TR','Turkey'),(2308,'Aydın','TR','Turkey'),(2309,'Ağrı','TR','Turkey'),(2310,'Balıkesir','TR','Turkey'),(2311,'Bartın','TR','Turkey'),(2312,'Batman','TR','Turkey'),(2313,'Bayburt','TR','Turkey'),(2314,'Bilecik','TR','Turkey'),(2315,'Bingöl','TR','Turkey'),(2316,'Bitlis','TR','Turkey'),(2317,'Bolu','TR','Turkey'),(2318,'Burdur','TR','Turkey'),(2319,'Bursa','TR','Turkey'),(2320,'Denizli','TR','Turkey'),(2321,'Diyarbakir','TR','Turkey'),(2322,'Duezce','TR','Turkey'),(2323,'Edirne','TR','Turkey'),(2324,'Elazığ','TR','Turkey'),(2325,'Erzincan','TR','Turkey'),(2326,'Erzurum','TR','Turkey'),(2327,'Eskişehir','TR','Turkey'),(2328,'Gaziantep','TR','Turkey'),(2329,'Giresun','TR','Turkey'),(2330,'Guemueshane','TR','Turkey'),(2331,'Hakkâri','TR','Turkey'),(2332,'Hatay','TR','Turkey'),(2333,'Isparta','TR','Turkey'),(2334,'Istanbul','TR','Turkey'),(2335,'Izmir','TR','Turkey'),(2336,'Iğdır','TR','Turkey'),(2337,'Kahramanmaraş','TR','Turkey'),(2338,'Karabuek','TR','Turkey'),(2339,'Karaman','TR','Turkey'),(2340,'Kars','TR','Turkey'),(2341,'Kastamonu','TR','Turkey'),(2342,'Kayseri','TR','Turkey'),(2343,'Kilis','TR','Turkey'),(2344,'Kocaeli','TR','Turkey'),(2345,'Konya','TR','Turkey'),(2346,'Kütahya','TR','Turkey'),(2347,'Kırklareli','TR','Turkey'),(2348,'Kırıkkale','TR','Turkey'),(2349,'Kırşehir','TR','Turkey'),(2350,'Malatya','TR','Turkey'),(2351,'Manisa','TR','Turkey'),(2352,'Mardin','TR','Turkey'),(2353,'Mersin','TR','Turkey'),(2354,'Muğla','TR','Turkey'),(2355,'Muş','TR','Turkey'),(2356,'Nevsehir','TR','Turkey'),(2357,'Nigde','TR','Turkey'),(2358,'Ordu','TR','Turkey'),(2359,'Osmaniye','TR','Turkey'),(2360,'Rize','TR','Turkey'),(2361,'Sakarya','TR','Turkey'),(2362,'Samsun','TR','Turkey'),(2363,'Siirt','TR','Turkey'),(2364,'Sinop','TR','Turkey'),(2365,'Sivas','TR','Turkey'),(2366,'Tekirdağ','TR','Turkey'),(2367,'Tokat','TR','Turkey'),(2368,'Trabzon','TR','Turkey'),(2369,'Tunceli','TR','Turkey'),(2370,'Uşak','TR','Turkey'),(2371,'Van','TR','Turkey'),(2372,'Yalova','TR','Turkey'),(2373,'Yozgat','TR','Turkey'),(2374,'Zonguldak','TR','Turkey'),(2375,'Çanakkale','TR','Turkey'),(2376,'Çankırı','TR','Turkey'),(2377,'Çorum','TR','Turkey'),(2378,'Şanlıurfa','TR','Turkey'),(2379,'Şırnak','TR','Turkey'),(2380,'Borough of Arima','TT','Trinidad and Tobago'),(2381,'Chaguanas','TT','Trinidad and Tobago'),(2382,'City of Port of Spain','TT','Trinidad and Tobago'),(2383,'City of San Fernando','TT','Trinidad and Tobago'),(2384,'Couva-Tabaquite-Talparo','TT','Trinidad and Tobago'),(2385,'Diego Martin','TT','Trinidad and Tobago'),(2386,'Eastern Tobago','TT','Trinidad and Tobago'),(2387,'Mayaro','TT','Trinidad and Tobago'),(2388,'Penal/Debe','TT','Trinidad and Tobago'),(2389,'Point Fortin','TT','Trinidad and Tobago'),(2390,'Princes Town','TT','Trinidad and Tobago'),(2391,'San Juan/Laventille','TT','Trinidad and Tobago'),(2392,'Sangre Grande','TT','Trinidad and Tobago'),(2393,'Siparia','TT','Trinidad and Tobago'),(2394,'Tobago','TT','Trinidad and Tobago'),(2395,'Tunapuna/Piarco','TT','Trinidad and Tobago'),(2396,'Funafuti','TV','Tuvalu'),(2397,'Vaitupu','TV','Tuvalu'),(2398,'Changhua','TW','Taiwan'),(2399,'Chiayi','TW','Taiwan'),(2400,'Hsinchu','TW','Taiwan'),(2401,'Hsinchu County','TW','Taiwan'),(2402,'Hualien','TW','Taiwan'),(2403,'Kaohsiung','TW','Taiwan'),(2404,'Keelung','TW','Taiwan'),(2405,'Miaoli','TW','Taiwan'),(2406,'Nantou','TW','Taiwan'),(2407,'New Taipei','TW','Taiwan'),(2408,'Pingtung','TW','Taiwan'),(2409,'Taichung City','TW','Taiwan'),(2410,'Tainan','TW','Taiwan'),(2411,'Taitung','TW','Taiwan'),(2412,'Taoyuan','TW','Taiwan'),(2413,'Yilan','TW','Taiwan'),(2414,'Yunlin County','TW','Taiwan'),(2415,'Arusha','TZ','Tanzania'),(2416,'Dar es Salaam Region','TZ','Tanzania'),(2417,'Dodoma','TZ','Tanzania'),(2418,'Iringa','TZ','Tanzania'),(2419,'Kagera','TZ','Tanzania'),(2420,'Kigoma','TZ','Tanzania'),(2421,'Kilimanjaro','TZ','Tanzania'),(2422,'Lindi','TZ','Tanzania'),(2423,'Manyara','TZ','Tanzania'),(2424,'Mara','TZ','Tanzania'),(2425,'Mbeya','TZ','Tanzania'),(2426,'Morogoro','TZ','Tanzania'),(2427,'Mtwara','TZ','Tanzania'),(2428,'Mwanza','TZ','Tanzania'),(2429,'Pemba North','TZ','Tanzania'),(2430,'Pemba South','TZ','Tanzania'),(2431,'Pwani','TZ','Tanzania'),(2432,'Rukwa','TZ','Tanzania'),(2433,'Ruvuma','TZ','Tanzania'),(2434,'Shinyanga','TZ','Tanzania'),(2435,'Singida','TZ','Tanzania'),(2436,'Tabora','TZ','Tanzania'),(2437,'Tanga','TZ','Tanzania'),(2438,'Zanzibar Central/South','TZ','Tanzania'),(2439,'Zanzibar North','TZ','Tanzania'),(2440,'Zanzibar Urban/West','TZ','Tanzania'),(2441,'Cherkas\'ka Oblast\'','UA','Ukraine'),(2442,'Chernihiv','UA','Ukraine'),(2443,'Chernivtsi','UA','Ukraine'),(2444,'Dnipropetrovska Oblast\'','UA','Ukraine'),(2445,'Donets\'ka Oblast\'','UA','Ukraine'),(2446,'Gorod Sevastopol','UA','Ukraine'),(2447,'Ivano-Frankivs\'ka Oblast\'','UA','Ukraine'),(2448,'Kharkivs\'ka Oblast\'','UA','Ukraine'),(2449,'Khersons\'ka Oblast\'','UA','Ukraine'),(2450,'Khmel\'nyts\'ka Oblast\'','UA','Ukraine'),(2451,'Kirovohrads\'ka Oblast\'','UA','Ukraine'),(2452,'Kyiv City','UA','Ukraine'),(2453,'Kyiv Oblast','UA','Ukraine'),(2454,'L\'vivs\'ka Oblast\'','UA','Ukraine'),(2455,'Luhans\'ka Oblast\'','UA','Ukraine'),(2456,'Mykolayivs\'ka Oblast\'','UA','Ukraine'),(2457,'Odessa','UA','Ukraine'),(2458,'Poltavs\'ka Oblast\'','UA','Ukraine'),(2459,'Republic of Crimea','UA','Ukraine'),(2460,'Rivnens\'ka Oblast\'','UA','Ukraine'),(2461,'Sums\'ka Oblast\'','UA','Ukraine'),(2462,'Ternopil\'s\'ka Oblast\'','UA','Ukraine'),(2463,'Vinnyts\'ka Oblast\'','UA','Ukraine'),(2464,'Volyns\'ka Oblast\'','UA','Ukraine'),(2465,'Zakarpattia Oblast','UA','Ukraine'),(2466,'Zaporizhia','UA','Ukraine'),(2467,'Zhytomyrs\'ka Oblast\'','UA','Ukraine'),(2468,'Central Region','UG','Uganda'),(2469,NULL,'UM','U.S. Minor Outlying Islands'),(2470,'Alabama','US','United States'),(2471,'Alaska','US','United States'),(2472,'Arizona','US','United States'),(2473,'Arkansas','US','United States'),(2474,'California','US','United States'),(2475,'Colorado','US','United States'),(2476,'Connecticut','US','United States'),(2477,'Delaware','US','United States'),(2478,'District of Columbia','US','United States'),(2479,'Florida','US','United States'),(2480,'Georgia','US','United States'),(2481,'Hawaii','US','United States'),(2482,'Idaho','US','United States'),(2483,'Illinois','US','United States'),(2484,'Indiana','US','United States'),(2485,'Iowa','US','United States'),(2486,'Kansas','US','United States'),(2487,'Kentucky','US','United States'),(2488,'Louisiana','US','United States'),(2489,'Maine','US','United States'),(2490,'Maryland','US','United States'),(2491,'Massachusetts','US','United States'),(2492,'Michigan','US','United States'),(2493,'Minnesota','US','United States'),(2494,'Mississippi','US','United States'),(2495,'Missouri','US','United States'),(2496,'Montana','US','United States'),(2497,'Nebraska','US','United States'),(2498,'Nevada','US','United States'),(2499,'New Hampshire','US','United States'),(2500,'New Jersey','US','United States'),(2501,'New Mexico','US','United States'),(2502,'New York','US','United States'),(2503,'North Carolina','US','United States'),(2504,'North Dakota','US','United States'),(2505,'Ohio','US','United States'),(2506,'Oklahoma','US','United States'),(2507,'Oregon','US','United States'),(2508,'Pennsylvania','US','United States'),(2509,'Rhode Island','US','United States'),(2510,'South Carolina','US','United States'),(2511,'South Dakota','US','United States'),(2512,'Tennessee','US','United States'),(2513,'Texas','US','United States'),(2514,'Utah','US','United States'),(2515,'Vermont','US','United States'),(2516,'Virginia','US','United States'),(2517,'Washington','US','United States'),(2518,'West Virginia','US','United States'),(2519,'Wisconsin','US','United States'),(2520,'Wyoming','US','United States'),(2521,'Artigas','UY','Uruguay'),(2522,'Canelones','UY','Uruguay'),(2523,'Cerro Largo','UY','Uruguay'),(2524,'Colonia','UY','Uruguay'),(2525,'Departamento de Montevideo','UY','Uruguay'),(2526,'Departamento de Paysandu','UY','Uruguay'),(2527,'Departamento de Rio Negro','UY','Uruguay'),(2528,'Departamento de Rivera','UY','Uruguay'),(2529,'Departamento de San Jose','UY','Uruguay'),(2530,'Departamento de Tacuarembo','UY','Uruguay'),(2531,'Florida','UY','Uruguay'),(2532,'Lavalleja','UY','Uruguay'),(2533,'Maldonado','UY','Uruguay'),(2534,'Soriano','UY','Uruguay'),(2535,'Qashqadaryo','UZ','Uzbekistan'),(2536,'Samarqand Viloyati','UZ','Uzbekistan'),(2537,'Toshkent Shahri','UZ','Uzbekistan'),(2538,NULL,'VA','Vatican City'),(2539,'Grenadines','VC','Saint Vincent and the Grenadines'),(2540,'Parish of Charlotte','VC','Saint Vincent and the Grenadines'),(2541,'Parish of Saint George','VC','Saint Vincent and the Grenadines'),(2542,'Amazonas','VE','Venezuela'),(2543,'Anzoátegui','VE','Venezuela'),(2544,'Apure','VE','Venezuela'),(2545,'Aragua','VE','Venezuela'),(2546,'Barinas','VE','Venezuela'),(2547,'Bolívar','VE','Venezuela'),(2548,'Capital','VE','Venezuela'),(2549,'Carabobo','VE','Venezuela'),(2550,'Cojedes','VE','Venezuela'),(2551,'Delta Amacuro','VE','Venezuela'),(2552,'Dependencias Federales','VE','Venezuela'),(2553,'Estado Trujillo','VE','Venezuela'),(2554,'Falcón','VE','Venezuela'),(2555,'Guárico','VE','Venezuela'),(2556,'Lara','VE','Venezuela'),(2557,'Miranda','VE','Venezuela'),(2558,'Monagas','VE','Venezuela'),(2559,'Mérida','VE','Venezuela'),(2560,'Nueva Esparta','VE','Venezuela'),(2561,'Portuguesa','VE','Venezuela'),(2562,'Sucre','VE','Venezuela'),(2563,'Táchira','VE','Venezuela'),(2564,'Vargas','VE','Venezuela'),(2565,'Yaracuy','VE','Venezuela'),(2566,'Zulia','VE','Venezuela'),(2567,NULL,'VG','British Virgin Islands'),(2568,'Saint Croix Island','VI','U.S. Virgin Islands'),(2569,'Saint John Island','VI','U.S. Virgin Islands'),(2570,'Saint Thomas Island','VI','U.S. Virgin Islands'),(2571,'An Giang','VN','Vietnam'),(2572,'Dak Nong','VN','Vietnam'),(2573,'Gia Lai','VN','Vietnam'),(2574,'Hau Giang','VN','Vietnam'),(2575,'Ho Chi Minh City','VN','Vietnam'),(2576,'Kon Tum','VN','Vietnam'),(2577,'Long An','VN','Vietnam'),(2578,'Thanh Pho Can Tho','VN','Vietnam'),(2579,'Thanh Pho GJa Nang','VN','Vietnam'),(2580,'Thanh Pho Ha Noi','VN','Vietnam'),(2581,'Thanh Pho Hai Phong','VN','Vietnam'),(2582,'Tinh Ba Ria-Vung Tau','VN','Vietnam'),(2583,'Tinh Bac Giang','VN','Vietnam'),(2584,'Tinh Bac Lieu','VN','Vietnam'),(2585,'Tinh Bac Ninh','VN','Vietnam'),(2586,'Tinh Ben Tre','VN','Vietnam'),(2587,'Tinh Binh Duong','VN','Vietnam'),(2588,'Tinh Binh GJinh','VN','Vietnam'),(2589,'Tinh Binh Thuan','VN','Vietnam'),(2590,'Tinh Ca Mau','VN','Vietnam'),(2591,'Tinh Cao Bang','VN','Vietnam'),(2592,'Tinh Dien Bien','VN','Vietnam'),(2593,'Tinh GJak Lak','VN','Vietnam'),(2594,'Tinh GJong Nai','VN','Vietnam'),(2595,'Tinh GJong Thap','VN','Vietnam'),(2596,'Tinh Ha Giang','VN','Vietnam'),(2597,'Tinh Ha Nam','VN','Vietnam'),(2598,'Tinh Ha Tinh','VN','Vietnam'),(2599,'Tinh Hai Duong','VN','Vietnam'),(2600,'Tinh Hoa Binh','VN','Vietnam'),(2601,'Tinh Hung Yen','VN','Vietnam'),(2602,'Tinh Khanh Hoa','VN','Vietnam'),(2603,'Tinh Kien Giang','VN','Vietnam'),(2604,'Tinh Lai Chau','VN','Vietnam'),(2605,'Tinh Lam GJong','VN','Vietnam'),(2606,'Tinh Lang Son','VN','Vietnam'),(2607,'Tinh Lao Cai','VN','Vietnam'),(2608,'Tinh Nam GJinh','VN','Vietnam'),(2609,'Tinh Nghe An','VN','Vietnam'),(2610,'Tinh Ninh Binh','VN','Vietnam'),(2611,'Tinh Phu Tho','VN','Vietnam'),(2612,'Tinh Phu Yen','VN','Vietnam'),(2613,'Tinh Quang Binh','VN','Vietnam'),(2614,'Tinh Quang Nam','VN','Vietnam'),(2615,'Tinh Quang Ngai','VN','Vietnam'),(2616,'Tinh Quang Tri','VN','Vietnam'),(2617,'Tinh Soc Trang','VN','Vietnam'),(2618,'Tinh Son La','VN','Vietnam'),(2619,'Tinh Tay Ninh','VN','Vietnam'),(2620,'Tinh Thai Binh','VN','Vietnam'),(2621,'Tinh Thai Nguyen','VN','Vietnam'),(2622,'Tinh Thanh Hoa','VN','Vietnam'),(2623,'Tinh Thua Thien-Hue','VN','Vietnam'),(2624,'Tinh Tien Giang','VN','Vietnam'),(2625,'Tinh Tra Vinh','VN','Vietnam'),(2626,'Tinh Tuyen Quang','VN','Vietnam'),(2627,'Tinh Vinh Long','VN','Vietnam'),(2628,'Tinh Vinh Phuc','VN','Vietnam'),(2629,'Tinh Yen Bai','VN','Vietnam'),(2630,'Penama Province','VU','Vanuatu'),(2631,'Shefa Province','VU','Vanuatu'),(2632,NULL,'WF','Wallis and Futuna'),(2633,'Atua','WS','Samoa'),(2634,'Tuamasaga','WS','Samoa'),(2635,NULL,'XK','Kosovo'),(2636,'Aden','YE','Yemen'),(2637,'Dhamār','YE','Yemen'),(2638,'Muhafazat Hadramawt','YE','Yemen'),(2639,'Muhafazat al Hudaydah','YE','Yemen'),(2640,'Sanaa','YE','Yemen'),(2641,NULL,'YT','Mayotte'),(2642,'Eastern Cape','ZA','South Africa'),(2643,'Gauteng','ZA','South Africa'),(2644,'KwaZulu-Natal','ZA','South Africa'),(2645,'Limpopo','ZA','South Africa'),(2646,'Mpumalanga','ZA','South Africa'),(2647,'Province of North West','ZA','South Africa'),(2648,'Northern Cape','ZA','South Africa'),(2649,'Orange Free State','ZA','South Africa'),(2650,'Province of the Western Cape','ZA','South Africa'),(2651,'Copperbelt','ZM','Zambia'),(2652,'Luapula Province','ZM','Zambia'),(2653,'Lusaka Province','ZM','Zambia'),(2654,'Muchinga Province','ZM','Zambia'),(2655,'North-Western Province','ZM','Zambia'),(2656,'Northern Province','ZM','Zambia'),(2657,'Southern Province','ZM','Zambia'),(2658,'Western Province','ZM','Zambia'),(2659,'Bulawayo','ZW','Zimbabwe'),(2660,'Harare','ZW','Zimbabwe'),(2661,'Mashonaland West','ZW','Zimbabwe'),(2662,'Matabeleland North','ZW','Zimbabwe'),(2663,'Matabeleland South Province','ZW','Zimbabwe'),(2664,'Midlands Province','ZW','Zimbabwe');
/*!40000 ALTER TABLE `maxmind_country_regions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `media_content_asset`
--

DROP TABLE IF EXISTS `media_content_asset`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `media_content_asset` (
  `asset_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `entity_type` varchar(255) NOT NULL COMMENT 'Content type',
  `entity_id` varchar(255) NOT NULL COMMENT 'Content entity id',
  `field` varchar(255) NOT NULL COMMENT 'Content field',
  PRIMARY KEY (`entity_type`,`entity_id`,`field`,`asset_id`),
  KEY `MEDIA_CONTENT_ASSET_ASSET_ID` (`asset_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Relation between media content and media asset';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `media_content_asset`
--

LOCK TABLES `media_content_asset` WRITE;
/*!40000 ALTER TABLE `media_content_asset` DISABLE KEYS */;
INSERT INTO `media_content_asset` VALUES (10,'cms_block','4','content'),(11,'cms_block','6','content'),(12,'cms_block','5','content'),(13,'cms_block','6','content'),(14,'cms_block','7','content'),(16,'cms_block','8','content'),(17,'cms_block','8','content'),(18,'cms_block','8','content'),(19,'cms_block','8','content'),(20,'cms_block','8','content'),(21,'cms_block','8','content'),(22,'cms_block','8','content'),(23,'cms_block','8','content'),(25,'cms_block','8','content'),(26,'cms_block','31','content'),(26,'cms_block','9','content'),(29,'cms_block','13','content'),(30,'cms_block','13','content'),(36,'cms_page','11','content'),(36,'cms_page','21','content'),(37,'cms_page','11','content'),(37,'cms_page','21','content'),(38,'cms_page','11','content'),(38,'cms_page','21','content'),(39,'cms_page','11','content'),(39,'cms_page','21','content'),(40,'cms_page','11','content'),(40,'cms_page','21','content'),(41,'cms_page','11','content'),(41,'cms_page','21','content'),(42,'cms_page','11','content'),(42,'cms_page','21','content'),(43,'cms_page','11','content'),(43,'cms_page','21','content'),(44,'cms_page','11','content'),(44,'cms_page','21','content'),(45,'cms_page','11','content'),(45,'cms_page','21','content'),(46,'cms_page','11','content'),(46,'cms_page','21','content'),(47,'cms_page','11','content'),(47,'cms_page','21','content'),(48,'cms_block','4','content'),(49,'cms_block','4','content'),(50,'cms_block','4','content'),(51,'cms_block','4','content'),(52,'cms_block','4','content'),(53,'cms_block','4','content'),(55,'catalog_category','4','image'),(57,'catalog_category','6','image'),(61,'catalog_category','10','image'),(62,'catalog_category','11','image'),(65,'cms_block','31','content'),(65,'cms_block','8','content'),(65,'cms_block','9','content'),(72,'catalog_category','37','image'),(73,'catalog_category','46','image'),(74,'catalog_category','51','image'),(75,'catalog_category','54','image'),(76,'catalog_category','57','image'),(77,'catalog_category','62','image'),(80,'catalog_category','3','description'),(80,'catalog_category','37','description'),(80,'catalog_category','38','description'),(82,'catalog_category','3','description'),(82,'catalog_category','37','description'),(82,'catalog_category','38','description'),(83,'catalog_category','3','description'),(83,'catalog_category','37','description'),(83,'catalog_category','38','description'),(84,'catalog_category','3','description'),(84,'catalog_category','37','description'),(84,'catalog_category','38','description'),(85,'catalog_category','3','description'),(85,'catalog_category','37','description'),(85,'catalog_category','38','description'),(88,'catalog_category','38','image'),(97,'cms_page','13','content'),(98,'cms_page','13','content'),(99,'cms_block','32','content'),(100,'cms_block','32','content'),(102,'cms_page','13','content'),(103,'cms_block','34','content'),(103,'cms_page','13','content'),(104,'cms_page','13','content'),(105,'cms_page','13','content'),(106,'cms_page','13','content'),(107,'cms_page','13','content'),(108,'cms_page','13','content'),(109,'catalog_category','203','image'),(110,'cms_block','49','content'),(112,'cms_block','40','content'),(112,'cms_block','42','content'),(113,'cms_block','40','content'),(113,'cms_block','42','content'),(113,'cms_block','49','content'),(113,'cms_block','53','content'),(113,'cms_block','54','content'),(114,'cms_block','40','content'),(114,'cms_block','42','content'),(114,'cms_block','49','content'),(114,'cms_block','53','content'),(114,'cms_block','54','content'),(115,'cms_block','40','content'),(119,'cms_block','53','content'),(120,'cms_block','54','content');
/*!40000 ALTER TABLE `media_content_asset` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `media_gallery_asset`
--

DROP TABLE IF EXISTS `media_gallery_asset`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `media_gallery_asset` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `path` text COMMENT 'Path',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title',
  `description` text COMMENT 'Description',
  `source` varchar(255) DEFAULT NULL COMMENT 'Source',
  `hash` varchar(255) DEFAULT NULL COMMENT 'File hash',
  `content_type` varchar(255) DEFAULT NULL COMMENT 'Content Type',
  `width` int unsigned NOT NULL DEFAULT '0' COMMENT 'Width',
  `height` int unsigned NOT NULL DEFAULT '0' COMMENT 'Height',
  `size` int unsigned NOT NULL COMMENT 'Asset file size in bytes',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  PRIMARY KEY (`id`),
  KEY `MEDIA_GALLERY_ASSET_ID` (`id`),
  FULLTEXT KEY `MEDIA_GALLERY_ASSET_TITLE` (`title`)
) ENGINE=InnoDB AUTO_INCREMENT=121 DEFAULT CHARSET=utf8mb3 COMMENT='Media Gallery Asset';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `media_gallery_asset`
--

LOCK TABLES `media_gallery_asset` WRITE;
/*!40000 ALTER TABLE `media_gallery_asset` DISABLE KEYS */;
INSERT INTO `media_gallery_asset` VALUES (1,'wysiwyg/Icon.png','Icon',NULL,'Local','0c865a25115c4d30e493475f048240dea10f826a','image/png',203,38,3681,'2024-08-11 14:07:11','2024-08-11 14:07:11'),(2,'wysiwyg/XMLID_7_.png','XMLID_7_',NULL,'Local','f8dd8c7bee837d4a00bfef3590d8400b460f728a','image/png',38,33,1097,'2024-08-11 14:08:53','2024-08-11 14:08:53'),(5,'wysiwyg/pexels-binyamin-mellish-106399.jpg','pexels-binyamin-mellish-106399',NULL,'Local','d7fb76ed3a6d4ff5b2b0a615452e4a7d2d4fa321','image/jpg',1280,853,135901,'2024-08-19 11:27:35','2024-08-19 11:27:35'),(6,'wysiwyg/pexels-binyamin-mellish-106399_1.jpg','pexels-binyamin-mellish-106399_1',NULL,'Local','ef97f9397778846a5e43b5bcda76021a1ff5ec54','image/jpg',200,133,6345,'2024-08-19 11:30:17','2024-08-19 11:30:17'),(8,'wysiwyg/slider1.jpeg','slider1',NULL,'Local','c0f750496f6c15d490a54ef421b35ced0d68f85e','image/jpeg',2440,746,141621,'2024-08-19 15:42:01','2024-08-19 15:42:01'),(9,'wysiwyg/slider1-mobile.jpeg','slider1-mobile',NULL,'Local','90eefa574d8afd20211c25a5652fe89601a32b57','image/jpeg',1639,2460,249758,'2024-08-19 15:42:02','2024-08-19 15:42:02'),(10,'wysiwyg/bath.jpeg','bath',NULL,'Local','c62d816e80dd166a6adb462cc72128e6d0cf01ec','image/jpeg',4096,4096,779401,'2024-08-20 06:04:40','2024-08-20 06:04:40'),(11,'wysiwyg/kitchen1.png','kitchen1',NULL,'Local','684ac9c14179bd2a2ef89395b256c5b0f4c5ee2d','image/png',1080,1080,237082,'2024-08-20 06:15:41','2024-08-20 06:15:41'),(12,'wysiwyg/decor.png','decor',NULL,'Local','8622c2bd4bc1fd6320f49a249107453e6ee4637c','image/png',1080,1920,846055,'2024-08-20 06:15:42','2024-08-20 06:15:42'),(13,'wysiwyg/Star-ratings.png','Star-ratings',NULL,'Local','9029dd2100e35272eff58e965ec835c817b517d8','image/png',87,13,921,'2024-08-20 06:21:13','2024-08-20 06:21:13'),(14,'wysiwyg/comfort.png','comfort',NULL,'Local','19daf9ffbdf7640c12591a3e7cd240238d148203','image/png',1080,1920,223616,'2024-08-20 06:41:06','2024-08-20 06:41:06'),(15,'wysiwyg/bathroom.png','bathroom',NULL,'Local','b8d86eb2df3fc8cd1627dfae2d76abd638a04d58','image/png',1000,765,148191,'2024-08-20 06:41:07','2024-08-20 06:41:07'),(16,'wysiwyg/2.png','2',NULL,'Local','6d4125036f0c1693a2ca175c6b2f856ad67e9195','image/png',1100,737,229469,'2024-08-20 07:06:51','2024-08-20 07:06:51'),(17,'wysiwyg/4.png','4',NULL,'Local','41a007d725805ab256d337ed7f7d404fbf3f1c01','image/png',1192,507,140829,'2024-08-20 07:06:53','2024-08-20 07:06:53'),(18,'wysiwyg/3.png','3',NULL,'Local','71dbd43c4b1612d21c78c92fc76891ec8136442a','image/png',1200,1200,374402,'2024-08-20 07:06:53','2024-08-20 07:06:53'),(19,'wysiwyg/1.png','1',NULL,'Local','12fb0e95e75d345e5b55de41dc54dc99e0be81f9','image/png',2000,2000,676230,'2024-08-20 07:06:58','2024-08-20 07:06:58'),(20,'wysiwyg/5.png','5',NULL,'Local','c017487c6b55f8d085cec71614ab58a30cd06d59','image/png',1920,1080,311890,'2024-08-20 07:07:00','2024-08-20 07:07:00'),(21,'wysiwyg/crosswater.png','crosswater',NULL,'Local','63b8c6cc88dad6da5c1b6df6675a71f2029eef21','image/png',108,51,3941,'2024-08-20 07:12:08','2024-08-20 07:12:08'),(22,'wysiwyg/duravit.png','duravit',NULL,'Local','a0fee8154b896ae9bd4306a2c70a001f45b648fa','image/png',108,51,5747,'2024-08-20 07:12:08','2024-08-20 07:12:08'),(23,'wysiwyg/geberit.png','geberit',NULL,'Local','f9eac635080b0a4ab0660bb6a71492e0e6822cf4','image/png',108,51,3950,'2024-08-20 07:12:08','2024-08-20 07:12:08'),(24,'wysiwyg/joseph.png','joseph',NULL,'Local','2499aec5480eb052b819294958fd70b117b1610b','image/png',107,51,3604,'2024-08-20 07:12:08','2024-08-20 07:12:08'),(25,'wysiwyg/rak.png','rak',NULL,'Local','c815116c74adff12d6192ad3452d5e8c0b55ad3c','image/png',108,51,4114,'2024-08-20 07:12:08','2024-08-20 07:12:08'),(26,'wysiwyg/small.jpeg','small',NULL,'Local','e26c1c9b2651cb1c0b407fed4756e8acf3a982eb','image/jpeg',4096,2731,239824,'2024-08-20 07:29:04','2024-08-20 07:29:04'),(27,'wysiwyg/delivery_icon_1.png','delivery_icon_1',NULL,'Local','1e37d71e0885c8b58f98e58f19c91d7079b4d34f','image/png',73,50,1718,'2024-08-20 08:14:04','2024-08-20 08:14:04'),(28,'wysiwyg/trust_icon_1.png','trust_icon_1',NULL,'Local','4a9b3387431cd80dbbe39ec20ca84ec92c2c45a3','image/png',148,58,2549,'2024-08-20 08:14:43','2024-08-20 08:14:43'),(29,'wysiwyg/quote-large.png','quote-large',NULL,'Local','42831363953b2798b2366b460a59a73274e0d953','image/png',40,26,766,'2024-08-20 08:27:06','2024-08-20 08:27:06'),(30,'wysiwyg/full-rating.png','full-rating',NULL,'Local','975cf9a3f1177942e929cbd700b56f3aeb38e3c9','image/png',124,21,592,'2024-08-20 08:30:06','2024-08-20 08:30:06'),(31,'catalog/category/bath.jpeg','bath',NULL,'Local','c62d816e80dd166a6adb462cc72128e6d0cf01ec','image/jpeg',4096,4096,779401,'2024-08-20 11:19:10','2024-08-20 11:19:10'),(32,'wysiwyg/Banner-01.jpg','Banner-01',NULL,'Local','e142948e898e30cc99f0e79ea6e6e0829687cf17','image/jpg',1441,441,90832,'2024-08-21 11:11:04','2024-08-21 11:11:04'),(33,'wysiwyg/Banner-02.jpg','Banner-02',NULL,'Local','8ce3f3054c6c2de443d5bfd59b920efaae8bc93d','image/jpg',1441,441,71644,'2024-08-21 11:11:08','2024-08-21 11:11:08'),(34,'wysiwyg/Web-03.jpg','Web-03',NULL,'Local','fc1f37745b57ef99d8e3fc90c03aa7dbb15652f9','image/jpg',814,526,70523,'2024-08-21 11:38:45','2024-08-21 11:38:45'),(35,'wysiwyg/Web-04.jpg','Web-04',NULL,'Local','c651c4cf58f07df3655efed6c9bbe46ab468b026','image/jpg',814,526,58145,'2024-08-21 11:38:46','2024-08-21 11:38:46'),(36,'wysiwyg/Group_27164.png','Group_27164',NULL,'Local','29cd03abe4d1348f2e5acd0777a8dbc2eeeff8a3','image/png',51,64,2316,'2024-08-21 11:49:30','2024-08-21 11:49:30'),(37,'wysiwyg/Group_27144.png','Group_27144',NULL,'Local','b45eea4a2effc628135ca62e72bfec9c6d9a9ca5','image/png',50,64,2823,'2024-08-21 11:49:30','2024-08-21 11:49:30'),(38,'wysiwyg/Group_27167.png','Group_27167',NULL,'Local','c032a81cb226151781f2b0bb886e76b210071638','image/png',69,62,2292,'2024-08-21 11:49:31','2024-08-21 11:49:31'),(39,'wysiwyg/Group_27298.png','Group_27298',NULL,'Local','a50978349a538c6ecd27b5fcfee754a22381ae79','image/png',64,64,2273,'2024-08-21 11:49:31','2024-08-21 11:49:31'),(40,'wysiwyg/Group_27299.png','Group_27299',NULL,'Local','4ba67fd21ff9884ea7552aff8ce65e433140de8d','image/png',59,64,2693,'2024-08-21 11:49:31','2024-08-21 11:49:31'),(41,'wysiwyg/Group.png','Group',NULL,'Local','900e61db5d7df48404d10da96ba7b7a375aedd4d','image/png',86,55,1677,'2024-08-21 11:49:31','2024-08-21 11:49:31'),(42,'wysiwyg/Mask_group_1_.png','Mask_group_1_',NULL,'Local','ac53d11f3afcca20180612d34f019c115fb34b97','image/png',382,251,124421,'2024-08-21 11:49:32','2024-08-21 11:49:32'),(43,'wysiwyg/Mask_group_3_.png','Mask_group_3_',NULL,'Local','e2f893c52600a502d8e001aec8df63e073a61fd9','image/png',382,251,158842,'2024-08-21 11:49:32','2024-08-21 11:49:32'),(44,'wysiwyg/Mask_group.png','Mask_group',NULL,'Local','ddbd7331445ace6971bcb5f962ae3af23533dc55','image/png',288,413,177515,'2024-08-21 11:49:32','2024-08-21 11:49:32'),(45,'wysiwyg/view-small-bathroom-with-modern-style-decor-furniture_1.png','view-small-bathroom-with-modern-style-decor-furniture_1',NULL,'Local','4f079b00d0432c1c5b24b234cb8f715f0e8ae504','image/png',288,413,178636,'2024-08-21 11:49:34','2024-08-21 11:49:34'),(46,'wysiwyg/luxurious-modern-living-room-with-sleek-minimalist-design-elegant-fireplace_1.png','luxurious-modern-living-room-with-sleek-minimalist-design-elegant-fireplace_1',NULL,'Local','f3476615787a4a6bdf726693400d4e732e7ff254','image/png',1440,441,1200564,'2024-08-21 11:49:35','2024-08-21 11:49:35'),(47,'wysiwyg/Mask_group_2_.png','Mask_group_2_',NULL,'Local','84cc6697483828d72f6b0439e1a44a3265b8b3af','image/png',382,251,186784,'2024-08-21 11:49:35','2024-08-21 11:49:35'),(48,'wysiwyg/Bathtub.H03.2k..png','Bathtub.H03.2k.',NULL,'Local','29856d434f2e76d12955560f1b76b3c733ed8418','image/png',2048,2048,3209251,'2024-08-21 11:59:12','2024-08-21 11:59:12'),(49,'wysiwyg/White_Wall_Hung_Toilet_With_Soft_Close_Seat.G03.2k.png','White_Wall_Hung_Toilet_With_Soft_Close_Seat.G03.2k',NULL,'Local','c188056e79d3962e62666b8c1c0432f347ac1a16','image/png',2048,2048,6338255,'2024-08-21 11:59:47','2024-08-21 11:59:47'),(50,'wysiwyg/Classic_Pedestal_Bathroom_Sink.H03.2k.png','Classic_Pedestal_Bathroom_Sink.H03.2k',NULL,'Local','8d8aef0f16d1ae6ca574d3b9406fb75fbf9bc560','image/png',2048,2048,5315029,'2024-08-21 11:59:58','2024-08-21 11:59:58'),(51,'wysiwyg/Bathroom_Classical_Style_Shower_System.H03.2k.png','Bathroom_Classical_Style_Shower_System.H03.2k',NULL,'Local','f802a8a019ea2052a450c2b4858833e044e8b2e7','image/png',2048,2048,2184322,'2024-08-21 12:00:19','2024-08-21 12:00:19'),(52,'wysiwyg/Classical_Chrome_Shower.H03.2k.png','Classical_Chrome_Shower.H03.2k',NULL,'Local','ed1e202bab1ae1c11c2935c32300e30e257cb98f','image/png',2048,2048,4650371,'2024-08-21 12:00:48','2024-08-21 12:00:48'),(53,'wysiwyg/Kitchen_Sink.F16.2k.png','Kitchen_Sink.F16.2k',NULL,'Local','45d278ad443403978a55d5e83c924e54eeaed1b8','image/png',2048,2048,3122759,'2024-08-21 12:01:21','2024-08-21 12:01:21'),(54,'catalog/category/bath_1.jpeg','bath_1',NULL,'Local','c62d816e80dd166a6adb462cc72128e6d0cf01ec','image/jpeg',4096,4096,779401,'2024-08-22 09:33:08','2024-08-22 09:33:08'),(55,'catalog/category/enclosures.jpeg','enclosures',NULL,'Local','ff29d12313f8412dd68d91e3d2dfa63f1a93d95d','image/jpeg',3300,3300,572752,'2024-08-22 10:03:19','2024-08-22 10:03:19'),(56,'catalog/category/kitchen-sink.jpeg','kitchen-sink',NULL,'Local','148e8c76b12b7c981853ac86db4de01745169eec','image/jpeg',3000,3000,258946,'2024-08-22 10:04:02','2024-08-22 10:04:02'),(57,'catalog/category/fires.jpg','fires',NULL,'Local','4a350905e9f7bb9f5ba18a03dc81d41935f4a43f','image/jpg',235,235,16854,'2024-08-22 10:09:36','2024-08-22 10:09:36'),(58,'catalog/category/designer-radiator.jpeg','designer-radiator',NULL,'Local','17d40ce29da6815c3af5614be9161bb776b2713d','image/jpeg',4096,4096,389067,'2024-08-22 10:12:59','2024-08-22 10:12:59'),(59,'catalog/category/taps.jpeg','taps',NULL,'Local','5db19319598fdc4eb063daf5f0aa8cf4986565e5','image/jpeg',4096,4096,1963092,'2024-08-22 10:13:39','2024-08-22 10:13:39'),(60,'catalog/category/showers.jpeg','showers',NULL,'Local','9f86ec08fab70ec8ca9e2e6d8a2e869e0e01327f','image/jpeg',4096,4096,1501177,'2024-08-22 10:15:50','2024-08-22 10:15:50'),(61,'catalog/category/bathroom-accesories.jpeg','bathroom-accesories',NULL,'Local','664d30e4bf65c3abdca7462e62becb76a9339a25','image/jpeg',2500,2500,178554,'2024-08-22 10:16:52','2024-08-22 10:16:52'),(62,'catalog/category/kitchen1_1.png','kitchen1_1',NULL,'Local','684ac9c14179bd2a2ef89395b256c5b0f4c5ee2d','image/png',1080,1080,237082,'2024-08-22 10:18:18','2024-08-22 10:18:18'),(63,'catalog/category/joseph.png','joseph',NULL,'Local','2499aec5480eb052b819294958fd70b117b1610b','image/png',107,51,3604,'2024-08-22 10:19:35','2024-08-22 10:19:35'),(64,'catalog/category/towel-rails.jpeg','towel-rails',NULL,'Local','1bb8c3d9fd599507ea75f6a895cc4855d041500b','image/jpeg',4096,4096,505489,'2024-08-22 10:20:51','2024-08-22 10:20:51'),(65,'wysiwyg/test_image.jpg','test_image',NULL,'Local','055dc3ac9f1caa9ebff5de0d65fc57f1c8a12423','image/jpg',1000,1000,403254,'2024-08-22 14:59:21','2024-08-22 14:59:21'),(68,'wysiwyg/banner3.png','banner3',NULL,'Local','535b5fb38b62e7470980d8021f77563352d09f59','image/png',1440,441,61994,'2024-08-23 10:25:32','2024-08-23 10:25:32'),(69,'catalog/category/kitchen-sink_1.jpeg','kitchen-sink_1',NULL,'Local','148e8c76b12b7c981853ac86db4de01745169eec','image/jpeg',3000,3000,258946,'2024-08-23 10:33:10','2024-08-23 10:33:10'),(70,'catalog/category/straight-bath.png','straight-bath',NULL,'Local','d469443e8341ddbccfc2ffb579bb7c24c5d1ef6b','image/png',1024,1024,251623,'2024-08-29 05:38:07','2024-08-29 05:38:07'),(71,'catalog/category/counter-top_1.png','counter-top_1',NULL,'Local','c0a378572f0ea6be7b84c7dc918dbe06178d9e96','image/png',1280,1024,231464,'2024-08-29 05:41:44','2024-08-29 05:41:44'),(72,'catalog/category/shower-bath.png','shower-bath',NULL,'Local','7e09f33918189b5057b3c4e6032aea168ce86201','image/png',1000,1000,259326,'2024-08-29 05:49:40','2024-08-29 05:49:40'),(73,'catalog/category/straight-bath_1.png','straight-bath_1',NULL,'Local','d469443e8341ddbccfc2ffb579bb7c24c5d1ef6b','image/png',1024,1024,251623,'2024-08-29 05:50:35','2024-08-29 05:50:35'),(74,'catalog/category/counter-top_1_1.png','counter-top_1_1',NULL,'Local','c0a378572f0ea6be7b84c7dc918dbe06178d9e96','image/png',1280,1024,231464,'2024-08-29 05:51:38','2024-08-29 05:51:38'),(75,'catalog/category/straight-bath_2.png','straight-bath_2',NULL,'Local','d469443e8341ddbccfc2ffb579bb7c24c5d1ef6b','image/png',1024,1024,251623,'2024-08-29 05:52:03','2024-08-29 05:52:03'),(76,'catalog/category/whirlpool-bath.png','whirlpool-bath',NULL,'Local','122294cf21e8657d329f21687d72260fca8fefce','image/png',1000,679,111951,'2024-08-29 05:53:01','2024-08-29 05:53:01'),(77,'catalog/category/counter-top_1_2.png','counter-top_1_2',NULL,'Local','c0a378572f0ea6be7b84c7dc918dbe06178d9e96','image/png',1280,1024,231464,'2024-08-29 05:53:49','2024-08-29 05:53:49'),(78,'catalog/category/bathroom-menu.jpeg','bathroom-menu',NULL,'Local','7948d666d911130b2e80b84efd5c96f721598a47','image/jpeg',4096,2731,295097,'2024-08-29 09:16:59','2024-08-29 09:16:59'),(80,'wysiwyg/bath-tub.png','bath-tub',NULL,'Local','d15380dbb64cf0cde9e182aec6e6055c1669fb77','image/png',726,376,170334,'2024-08-30 07:03:50','2024-08-30 07:03:50'),(82,'wysiwyg/bath2.png','bath2',NULL,'Local','68c62200387ee65338b7c996a2f5ecb27f19915b','image/png',582,348,168223,'2024-08-30 08:04:28','2024-08-30 08:04:28'),(83,'wysiwyg/bath3.png','bath3',NULL,'Local','45089d3daecb238ed3e80f3d506757cc26bbabf7','image/png',582,348,408808,'2024-08-30 08:27:46','2024-08-30 08:27:46'),(84,'wysiwyg/bath5.png','bath5',NULL,'Local','0607209dfecdb2e59053cbfd97eb3393b617c1b8','image/png',582,348,260135,'2024-08-30 09:29:03','2024-08-30 09:29:03'),(85,'wysiwyg/bath4.png','bath4',NULL,'Local','59247a4a71a954c0aff9ea72dc40235d1d3d8694','image/png',582,348,354866,'2024-08-30 09:30:15','2024-08-30 09:30:15'),(86,'wysiwyg/play.png','play',NULL,'Local','72353f8deeb703b941e74fb09bf735f271968858','image/png',100,72,1380,'2024-08-30 12:10:19','2024-08-30 12:10:19'),(87,'wysiwyg/video1.png','video1',NULL,'Local','6c3d743e658ead319e8ffdaedb18b142b6a98659','image/png',444,250,172510,'2024-08-30 12:10:33','2024-08-30 12:10:33'),(88,'catalog/category/bathroom-menu_1.jpeg','bathroom-menu_1',NULL,'Local','7948d666d911130b2e80b84efd5c96f721598a47','image/jpeg',4096,2731,295097,'2024-09-02 06:48:05','2024-09-02 06:48:05'),(89,'wysiwyg/cartbox.png','cartbox',NULL,'Local','c036c4fd2b2f052ed7c2c5b2e853f5df523053bc','image/png',80,71,1470,'2024-09-03 05:54:58','2024-09-03 05:54:58'),(90,'wysiwyg/arrow.png','arrow',NULL,'Local','de4badedfe8ad550b75bf636bbb54c496be80ae6','image/png',98,64,2107,'2024-09-03 05:54:58','2024-09-03 05:54:58'),(91,'wysiwyg/document-bx.png','document-bx',NULL,'Local','2b2c8dfb9900994df127b83976ee9e9103f80eea','image/png',70,70,2367,'2024-09-03 05:54:58','2024-09-03 05:54:58'),(92,'wysiwyg/infobx.png','infobx',NULL,'Local','7f421cc02f5e8a09677451fdfcce85239c12f851','image/png',35,56,925,'2024-09-03 05:54:58','2024-09-03 05:54:58'),(93,'wysiwyg/moneybx.png','moneybx',NULL,'Local','8679e4efc8754dcf6429daa5ba82162319cf0d02','image/png',58,54,1552,'2024-09-03 05:54:58','2024-09-03 05:54:58'),(94,'wysiwyg/paypal-logo.png','paypal-logo',NULL,'Local','b0e9e67a8a88f8efd52adeea2de5a14d16956903','image/png',59,70,1299,'2024-09-03 05:54:59','2024-09-03 05:54:59'),(95,'wysiwyg/Group_27532.png','Group_27532',NULL,'Local','ce2ff3c4d811749c7fed38d1aea6799279790896','image/png',428,851,147125,'2024-09-03 05:54:59','2024-09-03 05:54:59'),(96,'wysiwyg/swipebx.png','swipebx',NULL,'Local','a4e0338cd25f94fc7a2e9e34af6e28b1e5146e33','image/png',54,54,1295,'2024-09-03 05:54:59','2024-09-03 05:54:59'),(97,'wysiwyg/paypal.png','paypal',NULL,'Local','1a7a52646c87035b4d02ef867d4d1465b42a31e2','image/png',952,97,55355,'2024-09-03 05:54:59','2024-09-03 05:54:59'),(98,'wysiwyg/girl-right.png','girl-right',NULL,'Local','3c66032e8c0607383ff68d1e6c639cd0385baa13','image/png',307,466,228143,'2024-09-03 05:55:06','2024-09-03 05:55:06'),(99,'wysiwyg/sale-btm1.jpeg','sale-btm1',NULL,'Local','d1baacb81d6cf79f6bad9c62ee980bc51d7af93f','image/jpeg',2304,4096,314698,'2024-09-04 06:37:03','2024-09-04 06:37:03'),(100,'wysiwyg/side-btm.jpeg','side-btm',NULL,'Local','37107aab9c9f4872aed441425d982a18e9752c05','image/jpeg',2304,4096,244248,'2024-09-04 06:37:23','2024-09-04 06:37:23'),(101,'catalog/category/kitchen-sink_2.jpeg','kitchen-sink_2',NULL,'Local','148e8c76b12b7c981853ac86db4de01745169eec','image/jpeg',3000,3000,258946,'2024-09-07 06:56:19','2024-09-07 06:56:19'),(102,'wysiwyg/edit.png','edit',NULL,'Local','2b2c8dfb9900994df127b83976ee9e9103f80eea','image/png',70,70,2367,'2024-09-09 06:48:46','2024-09-09 06:48:46'),(103,'wysiwyg/Group_27495.png','paypal-img','','Local','b0e9e67a8a88f8efd52adeea2de5a14d16956903','image/png',59,70,1299,'2024-09-09 06:48:46','2024-09-09 06:49:10'),(104,'wysiwyg/image_254.png','image_254',NULL,'Local','7314a7dca5c19af1fa32ed5504cf8e51de31142f','image/png',411,522,133475,'2024-09-10 07:16:19','2024-09-10 07:16:19'),(105,'wysiwyg/image_251.png','image_251',NULL,'Local','e924fc71068c1a21169cf00731c38e15bd3d0904','image/png',428,145,8264,'2024-09-10 07:16:33','2024-09-10 07:16:33'),(106,'wysiwyg/image_252.png','image_252',NULL,'Local','b653418e042fdb08c8b02ed0e09da9f21759f448','image/png',428,178,17007,'2024-09-10 07:16:33','2024-09-10 07:16:33'),(107,'wysiwyg/image_253.png','image_253',NULL,'Local','127af93df950183bb961eee5b2581e417558331d','image/png',428,528,121610,'2024-09-10 07:16:34','2024-09-10 07:16:34'),(108,'wysiwyg/apd-feb-finance-logo-paypal_1.png','apd-feb-finance-logo-paypal_1',NULL,'Local','6b62040641bd09f5478b819335ee96f1e5147c5d','image/png',129,46,12505,'2024-09-12 11:18:28','2024-09-12 11:18:28'),(109,'catalog/category/kitchen-sink_3.jpeg','kitchen-sink_3',NULL,'Local','148e8c76b12b7c981853ac86db4de01745169eec','image/jpeg',3000,3000,258946,'2024-10-15 09:46:05','2024-10-15 09:46:05'),(110,'wysiwyg/Banner-01_1.jpg','Banner-01_1',NULL,'Local','21cbbfb2059ab366abc2d2b6f924cef8116814c6','image/jpg',1441,441,539506,'2025-01-28 11:01:48','2025-01-28 11:01:48'),(111,'wysiwyg/Web-03_1.jpg','Web-03_1',NULL,'Local','e428c6418190c5616cc1b2467aff8bf4f9a322a3','image/jpg',814,526,391193,'2025-01-28 11:04:11','2025-01-28 11:04:11'),(112,'wysiwyg/Banner-01_2.jpg','Banner-01_2',NULL,'Local','21cbbfb2059ab366abc2d2b6f924cef8116814c6','image/jpg',1441,441,539506,'2025-01-28 11:09:55','2025-01-28 11:09:55'),(113,'wysiwyg/Banner-02_1.jpg','Banner-02_1',NULL,'Local','acda7634bf6aa7d3f5d26e7e4732c9b7367f1494','image/jpg',1441,441,452560,'2025-01-28 11:10:45','2025-01-28 11:10:45'),(114,'wysiwyg/banner3.jpg','banner3',NULL,'Local','3926cb99b5047b4f5290f83e8f3e5777760df60c','image/jpg',1440,441,149801,'2025-01-28 11:15:20','2025-01-28 11:15:20'),(115,'wysiwyg/Web-03_2.jpg','Web-03_2',NULL,'Local','e428c6418190c5616cc1b2467aff8bf4f9a322a3','image/jpg',814,526,391193,'2025-01-28 11:23:31','2025-01-28 11:23:31'),(116,'wysiwyg/Banner-01_3.jpg','Banner-01_3',NULL,'Local','21cbbfb2059ab366abc2d2b6f924cef8116814c6','image/jpg',1441,441,539506,'2025-01-28 12:12:05','2025-01-28 12:12:05'),(117,'wysiwyg/hyva_banner_home_test_1.jpg','hyva_banner_home_test_1',NULL,'Local','7ecbab8383115378a8862d5c109a098d0ae2f615','image/jpg',1000,306,229106,'2025-01-28 14:38:14','2025-01-28 14:38:14'),(118,'wysiwyg/hyva_banner_home_test_1_1.jpg','hyva_banner_home_test_1_1',NULL,'Local','7ecbab8383115378a8862d5c109a098d0ae2f615','image/jpg',1000,306,229106,'2025-01-28 14:39:24','2025-01-28 14:39:24'),(119,'wysiwyg/hyva_banner_home_test_1_2.jpg','hyva_banner_home_test_1_2',NULL,'Local','7ecbab8383115378a8862d5c109a098d0ae2f615','image/jpg',1000,306,229106,'2025-01-28 14:42:00','2025-01-28 14:42:00'),(120,'wysiwyg/hyva_banner_home_test_1_3.jpg','hyva_banner_home_test_1_3',NULL,'Local','7ecbab8383115378a8862d5c109a098d0ae2f615','image/jpg',1000,306,229106,'2025-01-28 14:45:11','2025-01-28 14:45:11');
/*!40000 ALTER TABLE `media_gallery_asset` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `media_gallery_asset_keyword`
--

DROP TABLE IF EXISTS `media_gallery_asset_keyword`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `media_gallery_asset_keyword` (
  `keyword_id` int unsigned NOT NULL COMMENT 'Keyword Id',
  `asset_id` int unsigned NOT NULL COMMENT 'Asset ID',
  PRIMARY KEY (`keyword_id`,`asset_id`),
  KEY `MEDIA_GALLERY_ASSET_KEYWORD_ASSET_ID` (`asset_id`),
  KEY `MEDIA_GALLERY_ASSET_KEYWORD_KEYWORD_ID` (`keyword_id`),
  CONSTRAINT `MEDIA_GALLERY_ASSET_KEYWORD_ASSET_ID_MEDIA_GALLERY_ASSET_ID` FOREIGN KEY (`asset_id`) REFERENCES `media_gallery_asset` (`id`) ON DELETE CASCADE,
  CONSTRAINT `MEDIA_GALLERY_ASSET_KEYWORD_KEYWORD_ID_MEDIA_GALLERY_KEYWORD_ID` FOREIGN KEY (`keyword_id`) REFERENCES `media_gallery_keyword` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Media Gallery Asset Keyword';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `media_gallery_asset_keyword`
--

LOCK TABLES `media_gallery_asset_keyword` WRITE;
/*!40000 ALTER TABLE `media_gallery_asset_keyword` DISABLE KEYS */;
/*!40000 ALTER TABLE `media_gallery_asset_keyword` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `media_gallery_keyword`
--

DROP TABLE IF EXISTS `media_gallery_keyword`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `media_gallery_keyword` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Keyword ID',
  `keyword` varchar(255) NOT NULL COMMENT 'Keyword',
  PRIMARY KEY (`id`),
  UNIQUE KEY `MEDIA_GALLERY_KEYWORD_KEYWORD` (`keyword`),
  KEY `MEDIA_GALLERY_KEYWORD_ID` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Media Gallery Keyword';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `media_gallery_keyword`
--

LOCK TABLES `media_gallery_keyword` WRITE;
/*!40000 ALTER TABLE `media_gallery_keyword` DISABLE KEYS */;
/*!40000 ALTER TABLE `media_gallery_keyword` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mollie_apikey_fallback`
--

DROP TABLE IF EXISTS `mollie_apikey_fallback`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mollie_apikey_fallback` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `apikey` varchar(255) NOT NULL COMMENT 'API Key',
  `mode` varchar(255) NOT NULL COMMENT 'Mode',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  PRIMARY KEY (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Save previous API keys for fallback reasons';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mollie_apikey_fallback`
--

LOCK TABLES `mollie_apikey_fallback` WRITE;
/*!40000 ALTER TABLE `mollie_apikey_fallback` DISABLE KEYS */;
/*!40000 ALTER TABLE `mollie_apikey_fallback` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mollie_order_lines`
--

DROP TABLE IF EXISTS `mollie_order_lines`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mollie_order_lines` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `item_id` bigint unsigned NOT NULL DEFAULT '0' COMMENT 'Item ID',
  `line_id` varchar(255) NOT NULL COMMENT 'Line ID',
  `order_id` bigint unsigned NOT NULL DEFAULT '0' COMMENT 'Order Id',
  `type` varchar(255) NOT NULL COMMENT 'Type',
  `sku` varchar(255) NOT NULL COMMENT 'Sku',
  `qty_ordered` int unsigned NOT NULL DEFAULT '0' COMMENT 'Qty Ordered',
  `qty_paid` int unsigned NOT NULL DEFAULT '0' COMMENT 'Qty Paid',
  `qty_canceled` int unsigned NOT NULL DEFAULT '0' COMMENT 'Qty Canceled',
  `qty_shipped` int unsigned NOT NULL DEFAULT '0' COMMENT 'Qty Shipped',
  `qty_refunded` int unsigned NOT NULL DEFAULT '0' COMMENT 'Qty Refunded',
  `unit_price` decimal(12,2) NOT NULL,
  `discount_amount` decimal(12,2) NOT NULL,
  `total_amount` decimal(12,2) NOT NULL,
  `vat_rate` decimal(12,2) NOT NULL,
  `vat_amount` decimal(12,2) NOT NULL,
  `currency` varchar(3) NOT NULL COMMENT 'Currency',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  PRIMARY KEY (`id`),
  KEY `MOLLIE_ORDER_LINES_ITEM_ID` (`item_id`),
  KEY `MOLLIE_ORDER_LINES_LINE_ID` (`line_id`),
  KEY `MOLLIE_ORDER_LINES_ORDER_ID` (`order_id`),
  KEY `MOLLIE_ORDER_LINES_TYPE` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='mollie_order_lines Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mollie_order_lines`
--

LOCK TABLES `mollie_order_lines` WRITE;
/*!40000 ALTER TABLE `mollie_order_lines` DISABLE KEYS */;
/*!40000 ALTER TABLE `mollie_order_lines` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mollie_payment_customer`
--

DROP TABLE IF EXISTS `mollie_payment_customer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mollie_payment_customer` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `customer_id` int unsigned NOT NULL COMMENT 'Customer ID',
  `mollie_customer_id` varchar(255) DEFAULT NULL COMMENT 'Mollie Customer Id',
  PRIMARY KEY (`entity_id`),
  KEY `MOLLIE_PAYMENT_CUSTOMER_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` (`customer_id`),
  CONSTRAINT `MOLLIE_PAYMENT_CUSTOMER_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='mollie_payment_customer Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mollie_payment_customer`
--

LOCK TABLES `mollie_payment_customer` WRITE;
/*!40000 ALTER TABLE `mollie_payment_customer` DISABLE KEYS */;
/*!40000 ALTER TABLE `mollie_payment_customer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mollie_payment_paymenttoken`
--

DROP TABLE IF EXISTS `mollie_payment_paymenttoken`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mollie_payment_paymenttoken` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `cart_id` int unsigned NOT NULL COMMENT 'Cart ID',
  `order_id` int unsigned DEFAULT NULL COMMENT 'Order ID',
  `token` varchar(32) DEFAULT NULL COMMENT 'Token',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `MOLLIE_PAYMENT_PAYMENTTOKEN_TOKEN` (`token`),
  KEY `MOLLIE_PAYMENT_PAYMENTTOKEN_CART_ID_QUOTE_ENTITY_ID` (`cart_id`),
  KEY `MOLLIE_PAYMENT_PAYMENTTOKEN_ORDER_ID_SALES_ORDER_ENTITY_ID` (`order_id`),
  CONSTRAINT `MOLLIE_PAYMENT_PAYMENTTOKEN_CART_ID_QUOTE_ENTITY_ID` FOREIGN KEY (`cart_id`) REFERENCES `quote` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `MOLLIE_PAYMENT_PAYMENTTOKEN_ORDER_ID_SALES_ORDER_ENTITY_ID` FOREIGN KEY (`order_id`) REFERENCES `sales_order` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='mollie_payment_paymenttoken Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mollie_payment_paymenttoken`
--

LOCK TABLES `mollie_payment_paymenttoken` WRITE;
/*!40000 ALTER TABLE `mollie_payment_paymenttoken` DISABLE KEYS */;
/*!40000 ALTER TABLE `mollie_payment_paymenttoken` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mollie_payment_transaction_to_order`
--

DROP TABLE IF EXISTS `mollie_payment_transaction_to_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mollie_payment_transaction_to_order` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'entity_id',
  `transaction_id` varchar(255) DEFAULT NULL COMMENT 'transaction_id',
  `order_id` int DEFAULT NULL COMMENT 'order_id',
  `skipped` int NOT NULL DEFAULT '0' COMMENT 'skipped',
  `redirected` int NOT NULL DEFAULT '0' COMMENT 'redirected',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  PRIMARY KEY (`entity_id`),
  KEY `MOLLIE_PAYMENT_TRANSACTION_TO_ORDER_TRANSACTION_ID` (`transaction_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='TRANSACTIONTOORDERs';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mollie_payment_transaction_to_order`
--

LOCK TABLES `mollie_payment_transaction_to_order` WRITE;
/*!40000 ALTER TABLE `mollie_payment_transaction_to_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `mollie_payment_transaction_to_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mollie_pending_payment_reminder`
--

DROP TABLE IF EXISTS `mollie_pending_payment_reminder`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mollie_pending_payment_reminder` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `customer_id` int DEFAULT NULL COMMENT 'Customer ID',
  `hash` varchar(255) DEFAULT NULL COMMENT 'Unique hash',
  `order_id` bigint unsigned NOT NULL DEFAULT '0' COMMENT 'Order Id',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `MOLLIE_PENDING_PAYMENT_REMINDER_ORDER_ID` (`order_id`),
  KEY `MOLLIE_PENDING_PAYMENT_REMINDER_HASH` (`hash`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='mollie_pending_payment_reminder Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mollie_pending_payment_reminder`
--

LOCK TABLES `mollie_pending_payment_reminder` WRITE;
/*!40000 ALTER TABLE `mollie_pending_payment_reminder` DISABLE KEYS */;
/*!40000 ALTER TABLE `mollie_pending_payment_reminder` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mollie_sent_payment_reminder`
--

DROP TABLE IF EXISTS `mollie_sent_payment_reminder`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mollie_sent_payment_reminder` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `order_id` bigint unsigned NOT NULL DEFAULT '0' COMMENT 'Order Id',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `MOLLIE_SENT_PAYMENT_REMINDER_ORDER_ID` (`order_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='mollie_sent_payment_reminder Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mollie_sent_payment_reminder`
--

LOCK TABLES `mollie_sent_payment_reminder` WRITE;
/*!40000 ALTER TABLE `mollie_sent_payment_reminder` DISABLE KEYS */;
/*!40000 ALTER TABLE `mollie_sent_payment_reminder` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mst_brand_page`
--

DROP TABLE IF EXISTS `mst_brand_page`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mst_brand_page` (
  `brand_page_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Brand Page Id',
  `attribute_option_id` int NOT NULL DEFAULT '0' COMMENT 'Brand Option Id',
  `attribute_id` int NOT NULL DEFAULT '0' COMMENT 'Brand Id',
  `is_active` int unsigned NOT NULL DEFAULT '0' COMMENT 'Brand Id',
  `url_key` varchar(255) DEFAULT NULL COMMENT 'Url Key',
  `logo` varchar(255) DEFAULT NULL COMMENT 'Logo',
  `brand_title` text COMMENT 'Brand title',
  `brand_description` text COMMENT 'Brand description',
  `meta_title` varchar(255) DEFAULT NULL COMMENT 'Meta title',
  `meta_keyword` varchar(255) DEFAULT NULL COMMENT 'Keyword',
  `meta_description` varchar(255) DEFAULT NULL COMMENT 'Meta description',
  `seo_description` text COMMENT 'SEO description',
  `seo_position` varchar(255) DEFAULT NULL COMMENT 'SEO description position',
  `robots` varchar(255) DEFAULT NULL COMMENT 'Robots',
  `canonical` varchar(255) DEFAULT NULL COMMENT 'Canonical',
  `banner_alt` varchar(255) DEFAULT NULL COMMENT 'Banner Alt',
  `banner_title` varchar(255) DEFAULT NULL COMMENT 'Banner Title',
  `banner` varchar(255) DEFAULT NULL COMMENT 'Banner',
  `banner_position` varchar(255) DEFAULT NULL COMMENT 'Banner position',
  `is_show_in_brand_slider` int NOT NULL DEFAULT '0' COMMENT 'Show in Brand Slider',
  `slider_position` int NOT NULL DEFAULT '10' COMMENT 'Slider Position',
  `brand_short_description` text COMMENT 'Brand Short Description',
  `store_ids` varchar(255) DEFAULT NULL COMMENT 'Stores',
  PRIMARY KEY (`brand_page_id`),
  FULLTEXT KEY `MST_BRAND_PAGE_BRAND_TITLE` (`brand_title`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='mst_brand_page';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mst_brand_page`
--

LOCK TABLES `mst_brand_page` WRITE;
/*!40000 ALTER TABLE `mst_brand_page` DISABLE KEYS */;
/*!40000 ALTER TABLE `mst_brand_page` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mst_brand_page_store`
--

DROP TABLE IF EXISTS `mst_brand_page_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mst_brand_page_store` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id',
  `brand_page_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Brand Page Id',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store Id',
  `brand_title` text COMMENT 'Brand title',
  `brand_description` text COMMENT 'Brand description',
  `brand_short_description` text COMMENT 'Brand Short Description',
  `brand_display_mode` varchar(255) DEFAULT NULL COMMENT 'Display Mode',
  `brand_cms_block` varchar(255) DEFAULT NULL COMMENT 'CMS Block',
  `meta_title` varchar(255) DEFAULT NULL COMMENT 'Meta title',
  `meta_keyword` varchar(255) DEFAULT NULL COMMENT 'Keyword',
  `meta_description` varchar(255) DEFAULT NULL COMMENT 'Meta description',
  `seo_description` text COMMENT 'SEO description',
  `seo_position` varchar(255) DEFAULT NULL COMMENT 'SEO description position',
  `robots` varchar(255) DEFAULT NULL COMMENT 'Robots',
  `canonical` varchar(255) DEFAULT NULL COMMENT 'Canonical',
  PRIMARY KEY (`id`),
  KEY `MST_BRAND_PAGE_STORE_STORE_ID` (`store_id`),
  KEY `MST_BRAND_PAGE_STORE_BRAND_PAGE_ID` (`brand_page_id`),
  CONSTRAINT `MST_BRAND_PAGE_STORE_BRAND_PAGE_ID_MST_BRAND_PAGE_BRAND_PAGE_ID` FOREIGN KEY (`brand_page_id`) REFERENCES `mst_brand_page` (`brand_page_id`) ON DELETE CASCADE,
  CONSTRAINT `MST_BRAND_PAGE_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='mst_brand_page_store';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mst_brand_page_store`
--

LOCK TABLES `mst_brand_page_store` WRITE;
/*!40000 ALTER TABLE `mst_brand_page_store` DISABLE KEYS */;
/*!40000 ALTER TABLE `mst_brand_page_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mst_core_urlrewrite`
--

DROP TABLE IF EXISTS `mst_core_urlrewrite`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mst_core_urlrewrite` (
  `urlrewrite_id` int NOT NULL AUTO_INCREMENT COMMENT 'Url Rewrite Id',
  `url_key` varchar(255) NOT NULL COMMENT 'Url Key',
  `module` varchar(255) NOT NULL COMMENT 'Module',
  `type` varchar(255) NOT NULL COMMENT 'Type',
  `entity_id` int unsigned NOT NULL COMMENT 'Entity Id',
  `store_id` int NOT NULL DEFAULT '0' COMMENT 'Store ID',
  PRIMARY KEY (`urlrewrite_id`),
  UNIQUE KEY `MST_CORE_URLREWRITE_MODULE_TYPE_ENTITY_ID_STORE_ID` (`module`,`type`,`entity_id`,`store_id`),
  UNIQUE KEY `MST_CORE_URLREWRITE_URL_KEY_MODULE_STORE_ID` (`url_key`,`module`,`store_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='mst_core_urlrewrite';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mst_core_urlrewrite`
--

LOCK TABLES `mst_core_urlrewrite` WRITE;
/*!40000 ALTER TABLE `mst_core_urlrewrite` DISABLE KEYS */;
/*!40000 ALTER TABLE `mst_core_urlrewrite` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mst_landing_page`
--

DROP TABLE IF EXISTS `mst_landing_page`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mst_landing_page` (
  `page_id` bigint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Page ID',
  `name` text COMMENT 'Name',
  `store_ids` varchar(255) NOT NULL COMMENT 'Store IDs',
  `is_active` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Active',
  `url_key` text COMMENT 'URL Key',
  `page_title` text COMMENT 'Page Title',
  `meta_title` text COMMENT 'Meta Title',
  `meta_description` text COMMENT 'Meta Description',
  `meta_tags` text COMMENT 'Meta Tags',
  `description` text COMMENT 'Description',
  `top_block` int DEFAULT NULL COMMENT 'Top CMS Block',
  `bottom_block` int DEFAULT NULL COMMENT 'Bottom CMS Block',
  `layout_update` text COMMENT 'Layout Update Xml',
  `categories` text COMMENT 'Categories',
  `search_term` text COMMENT 'Categories',
  PRIMARY KEY (`page_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Landing Page';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mst_landing_page`
--

LOCK TABLES `mst_landing_page` WRITE;
/*!40000 ALTER TABLE `mst_landing_page` DISABLE KEYS */;
/*!40000 ALTER TABLE `mst_landing_page` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mst_landing_page_filter`
--

DROP TABLE IF EXISTS `mst_landing_page_filter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mst_landing_page_filter` (
  `filter_id` bigint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Filter ID',
  `page_id` bigint unsigned NOT NULL COMMENT 'Page ID',
  `attribute_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `attribute_code` text COMMENT 'Attribute Code',
  `option_ids` text COMMENT 'Option IDs',
  PRIMARY KEY (`filter_id`),
  KEY `MST_LANDING_PAGE_FILTER_ATTRIBUTE_ID_EAV_ATTRIBUTE_ATTRIBUTE_ID` (`attribute_id`),
  CONSTRAINT `MST_LANDING_PAGE_FILTER_ATTRIBUTE_ID_EAV_ATTRIBUTE_ATTRIBUTE_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Landing Page Filters';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mst_landing_page_filter`
--

LOCK TABLES `mst_landing_page_filter` WRITE;
/*!40000 ALTER TABLE `mst_landing_page_filter` DISABLE KEYS */;
/*!40000 ALTER TABLE `mst_landing_page_filter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mst_landing_page_store`
--

DROP TABLE IF EXISTS `mst_landing_page_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mst_landing_page_store` (
  `entity_id` bigint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Page ID',
  `page_id` bigint unsigned NOT NULL COMMENT 'Page ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store Id',
  `name` text COMMENT 'Name',
  `is_active` tinyint(1) DEFAULT '0' COMMENT 'Active',
  `url_key` text COMMENT 'URL Key',
  `page_title` text COMMENT 'Page Title',
  `meta_title` text COMMENT 'Meta Title',
  `meta_description` text COMMENT 'Meta Description',
  `meta_tags` text COMMENT 'Meta Tags',
  `description` text COMMENT 'Description',
  `top_block` int DEFAULT NULL COMMENT 'Top CMS Block',
  `bottom_block` int DEFAULT NULL COMMENT 'Bottom CMS Block',
  `layout_update` text COMMENT 'Layout Update Xml',
  `search_term` text COMMENT 'Categories',
  PRIMARY KEY (`entity_id`),
  KEY `MST_LANDING_PAGE_STORE_STORE_ID` (`store_id`),
  KEY `MST_LANDING_PAGE_STORE_PAGE_ID` (`page_id`),
  CONSTRAINT `MST_LANDING_PAGE_STORE_PAGE_ID_MST_LANDING_PAGE_PAGE_ID` FOREIGN KEY (`page_id`) REFERENCES `mst_landing_page` (`page_id`) ON DELETE CASCADE,
  CONSTRAINT `MST_LANDING_PAGE_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Page settings for stores';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mst_landing_page_store`
--

LOCK TABLES `mst_landing_page_store` WRITE;
/*!40000 ALTER TABLE `mst_landing_page_store` DISABLE KEYS */;
/*!40000 ALTER TABLE `mst_landing_page_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mst_navigation_attribute_config`
--

DROP TABLE IF EXISTS `mst_navigation_attribute_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mst_navigation_attribute_config` (
  `config_id` int NOT NULL AUTO_INCREMENT,
  `attribute_id` int DEFAULT NULL,
  `attribute_code` varchar(255) DEFAULT NULL,
  `config` mediumtext COMMENT 'Config',
  PRIMARY KEY (`config_id`)
) ENGINE=InnoDB AUTO_INCREMENT=46 DEFAULT CHARSET=utf8mb3 COMMENT='Attribute setting table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mst_navigation_attribute_config`
--

LOCK TABLES `mst_navigation_attribute_config` WRITE;
/*!40000 ALTER TABLE `mst_navigation_attribute_config` DISABLE KEYS */;
INSERT INTO `mst_navigation_attribute_config` VALUES (1,162,'product_brand','{\"category_visibility_mode\":\"all\",\"options_sort_by\":\"position\",\"alphabetical_index\":false,\"display_mode\":\"label\",\"value_template\":\"\",\"is_show_search_box\":false,\"enable_multiselect\":null,\"multiselect_logic\":0,\"tooltip\":\"\"}'),(2,0,'pressure_bar',NULL),(3,0,'offer',NULL),(4,0,'cabinet_width',NULL),(5,0,'material',NULL),(6,0,'mount_type',NULL),(7,0,'number_of_bowls',NULL),(8,0,'products_by_category',NULL),(9,0,'bath_length',NULL),(10,0,'bath_style',NULL),(11,0,'bath_type',NULL),(12,0,'glass_thickness',NULL),(13,0,'tap_style',NULL),(14,0,'tap_type',NULL),(15,0,'basin_width',NULL),(16,0,'basin_depth',NULL),(17,0,'flush_type',NULL),(18,0,'toilet_width',NULL),(19,0,'toilet_style',NULL),(20,0,'toilet_projection',NULL),(21,0,'toilet_full_height',NULL),(22,0,'installation',NULL),(23,0,'fuel_type',NULL),(24,0,'colour',NULL),(25,0,'built_type',NULL),(26,0,'oven_type',NULL),(27,0,'cleaning',NULL),(28,0,'size',NULL),(29,0,'number_of_cooking_zones',NULL),(30,0,'hoods_type',NULL),(31,0,'hob_type',NULL),(32,0,'hoods_width_mm',NULL),(33,0,'fire_width',NULL),(34,0,'fire_type',NULL),(35,0,'fire_style',NULL),(36,0,'fire_frontage',NULL),(37,0,'fit_type',NULL),(38,0,'features',NULL),(39,0,'height',NULL),(40,0,'defrost_type',NULL),(41,0,'unit_width',NULL),(42,0,'configuration',NULL),(43,0,'radiator_style',NULL),(44,0,'output_btu',NULL),(45,0,'radiator_height',NULL);
/*!40000 ALTER TABLE `mst_navigation_attribute_config` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mst_navigation_grouped_option`
--

DROP TABLE IF EXISTS `mst_navigation_grouped_option`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mst_navigation_grouped_option` (
  `group_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'group_id',
  `is_active` int NOT NULL DEFAULT '1' COMMENT 'is_active',
  `position` int unsigned NOT NULL DEFAULT '0' COMMENT 'position',
  `title` text NOT NULL COMMENT 'title',
  `code` varchar(255) NOT NULL COMMENT 'code',
  `swatch_type` int unsigned NOT NULL DEFAULT '0' COMMENT 'swatch_type',
  `swatch_value` text COMMENT 'swatch_value',
  `attribute_code` varchar(255) NOT NULL COMMENT 'attribute_code',
  `attribute_value_ids` text NOT NULL COMMENT 'attribute_value_ids',
  PRIMARY KEY (`group_id`),
  KEY `MST_NAVIGATION_GROUPED_OPTION_ATTRIBUTE_CODE` (`attribute_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Grouped Options';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mst_navigation_grouped_option`
--

LOCK TABLES `mst_navigation_grouped_option` WRITE;
/*!40000 ALTER TABLE `mst_navigation_grouped_option` DISABLE KEYS */;
/*!40000 ALTER TABLE `mst_navigation_grouped_option` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mst_seo_filter_attribute_config`
--

DROP TABLE IF EXISTS `mst_seo_filter_attribute_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mst_seo_filter_attribute_config` (
  `config_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Config Id',
  `attribute_code` varchar(120) NOT NULL COMMENT 'Attribute Code',
  `attribute_status` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Attribute SEO Status',
  PRIMARY KEY (`config_id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COMMENT='SeoFilter Attribute Config';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mst_seo_filter_attribute_config`
--

LOCK TABLES `mst_seo_filter_attribute_config` WRITE;
/*!40000 ALTER TABLE `mst_seo_filter_attribute_config` DISABLE KEYS */;
INSERT INTO `mst_seo_filter_attribute_config` VALUES (1,'product_brand',1);
/*!40000 ALTER TABLE `mst_seo_filter_attribute_config` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mst_seo_filter_rewrite`
--

DROP TABLE IF EXISTS `mst_seo_filter_rewrite`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mst_seo_filter_rewrite` (
  `rewrite_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rewrite Id',
  `attribute_code` varchar(120) NOT NULL COMMENT 'Attribute Code',
  `option` varchar(120) DEFAULT NULL COMMENT 'Option',
  `rewrite` varchar(120) NOT NULL COMMENT 'Rewrite',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store Id',
  PRIMARY KEY (`rewrite_id`),
  UNIQUE KEY `MST_SEO_FILTER_REWRITE_ATTRIBUTE_CODE_OPTION_STORE_ID` (`attribute_code`,`option`,`store_id`),
  KEY `MST_SEO_FILTER_REWRITE_STORE_ID` (`store_id`),
  KEY `MST_SEO_FILTER_REWRITE_OPTION` (`option`)
) ENGINE=InnoDB AUTO_INCREMENT=1418 DEFAULT CHARSET=utf8mb3 COMMENT='SeoFilter Rewrites';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mst_seo_filter_rewrite`
--

LOCK TABLES `mst_seo_filter_rewrite` WRITE;
/*!40000 ALTER TABLE `mst_seo_filter_rewrite` DISABLE KEYS */;
INSERT INTO `mst_seo_filter_rewrite` VALUES (1,'price',NULL,'price',1),(2,'price',NULL,'price',4),(3,'price',NULL,'price',3),(4,'product_brand',NULL,'product_brand',1),(5,'product_brand',NULL,'product_brand',2),(6,'product_brand',NULL,'product_brand',3),(7,'product_brand',NULL,'product_brand',4),(8,'pressure_bar',NULL,'pressure_bar',1),(9,'pressure_bar',NULL,'pressure_bar',2),(10,'pressure_bar',NULL,'pressure_bar',3),(11,'pressure_bar',NULL,'pressure_bar',4),(12,'pressure_bar','7','01',1),(13,'pressure_bar','7','01',2),(14,'pressure_bar','7','01',3),(15,'pressure_bar','7','01',4),(16,'pressure_bar','8','02',1),(17,'pressure_bar','8','02',2),(18,'pressure_bar','8','02',3),(19,'pressure_bar','8','02',4),(20,'pressure_bar','9','03',1),(21,'pressure_bar','9','03',2),(22,'pressure_bar','9','03',3),(23,'pressure_bar','9','03',4),(24,'pressure_bar','10','1',1),(25,'pressure_bar','10','1',2),(26,'pressure_bar','10','1',3),(27,'pressure_bar','10','1',4),(28,'pressure_bar','11','2',1),(29,'pressure_bar','11','2',2),(30,'pressure_bar','11','2',3),(31,'pressure_bar','11','2',4),(32,'pressure_bar','12','3',1),(33,'pressure_bar','12','3',2),(34,'pressure_bar','12','3',3),(35,'pressure_bar','12','3',4),(36,'pressure_bar','13','4',1),(37,'pressure_bar','13','4',2),(38,'pressure_bar','13','4',3),(39,'pressure_bar','13','4',4),(40,'pressure_bar','14','5',1),(41,'pressure_bar','14','5',2),(42,'pressure_bar','14','5',3),(43,'pressure_bar','14','5',4),(44,'pressure_bar','15','6',1),(45,'pressure_bar','15','6',2),(46,'pressure_bar','15','6',3),(47,'pressure_bar','15','6',4),(48,'pressure_bar','16','05',1),(49,'pressure_bar','16','05',2),(50,'pressure_bar','16','05',3),(51,'pressure_bar','16','05',4),(52,'pressure_bar','17','08',1),(53,'pressure_bar','17','08',2),(54,'pressure_bar','17','08',3),(55,'pressure_bar','17','08',4),(56,'pressure_bar','18','15',1),(57,'pressure_bar','18','15',2),(58,'pressure_bar','18','15',3),(59,'pressure_bar','18','15',4),(60,'pressure_bar','19','18',1),(61,'pressure_bar','19','18',2),(62,'pressure_bar','19','18',3),(63,'pressure_bar','19','18',4),(64,'number_of_bowls',NULL,'number_of_bowls',1),(65,'number_of_bowls',NULL,'number_of_bowls',2),(66,'number_of_bowls',NULL,'number_of_bowls',3),(67,'number_of_bowls',NULL,'number_of_bowls',4),(68,'number_of_bowls','74','halfbowl',1),(69,'number_of_bowls','74','halfbowl',2),(70,'number_of_bowls','74','halfbowl',3),(71,'number_of_bowls','74','halfbowl',4),(72,'number_of_bowls','75','singlebowl',1),(73,'number_of_bowls','75','singlebowl',2),(74,'number_of_bowls','75','singlebowl',3),(75,'number_of_bowls','75','singlebowl',4),(76,'number_of_bowls','76','doublebowl',1),(77,'number_of_bowls','76','doublebowl',2),(78,'number_of_bowls','76','doublebowl',3),(79,'number_of_bowls','76','doublebowl',4),(80,'number_of_bowls','77','112bowl',1),(81,'number_of_bowls','77','112bowl',2),(82,'number_of_bowls','77','112bowl',3),(83,'number_of_bowls','77','112bowl',4),(84,'number_of_bowls','78','212bowl',1),(85,'number_of_bowls','78','212bowl',2),(86,'number_of_bowls','78','212bowl',3),(87,'number_of_bowls','78','212bowl',4),(88,'kitchen_sinks',NULL,'kitchen_sinks',1),(89,'kitchen_sinks',NULL,'kitchen_sinks',2),(90,'kitchen_sinks',NULL,'kitchen_sinks',3),(91,'kitchen_sinks',NULL,'kitchen_sinks',4),(92,'price',NULL,'price',5),(93,'material',NULL,'material',1),(94,'material',NULL,'material',2),(95,'material',NULL,'material',3),(96,'material',NULL,'material',4),(97,'material',NULL,'material',5),(98,'material','42','acrylic',1),(99,'material','42','acrylic',2),(100,'material','42','acrylic',3),(101,'material','42','acrylic',4),(102,'material','42','acrylic',5),(103,'material','43','aluminium',1),(104,'material','43','aluminium',2),(105,'material','43','aluminium',3),(106,'material','43','aluminium',4),(107,'material','43','aluminium',5),(108,'material','44','castiron',1),(109,'material','44','castiron',2),(110,'material','44','castiron',3),(111,'material','44','castiron',4),(112,'material','44','castiron',5),(113,'material','45','ceramic',1),(114,'material','45','ceramic',2),(115,'material','45','ceramic',3),(116,'material','45','ceramic',4),(117,'material','45','ceramic',5),(118,'material','46','fragranite',1),(119,'material','46','fragranite',2),(120,'material','46','fragranite',3),(121,'material','46','fragranite',4),(122,'material','46','fragranite',5),(123,'material','47','idealform',1),(124,'material','47','idealform',2),(125,'material','47','idealform',3),(126,'material','47','idealform',4),(127,'material','47','idealform',5),(128,'material','48','idealformplus',1),(129,'material','48','idealformplus',2),(130,'material','48','idealformplus',3),(131,'material','48','idealformplus',4),(132,'material','48','idealformplus',5),(133,'material','49','lithocast',1),(134,'material','49','lithocast',2),(135,'material','49','lithocast',3),(136,'material','49','lithocast',4),(137,'material','49','lithocast',5),(138,'material','50','sentec',1),(139,'material','50','sentec',2),(140,'material','50','sentec',3),(141,'material','50','sentec',4),(142,'material','50','sentec',5),(143,'material','51','silgranit',1),(144,'material','51','silgranit',2),(145,'material','51','silgranit',3),(146,'material','51','silgranit',4),(147,'material','51','silgranit',5),(148,'material','52','silvermetalliclacquer',1),(149,'material','52','silvermetalliclacquer',2),(150,'material','52','silvermetalliclacquer',3),(151,'material','52','silvermetalliclacquer',4),(152,'material','52','silvermetalliclacquer',5),(153,'material','53','solidsurface',1),(154,'material','53','solidsurface',2),(155,'material','53','solidsurface',3),(156,'material','53','solidsurface',4),(157,'material','53','solidsurface',5),(158,'material','54','stainlesssteel',1),(159,'material','54','stainlesssteel',2),(160,'material','54','stainlesssteel',3),(161,'material','54','stainlesssteel',4),(162,'material','54','stainlesssteel',5),(163,'material','55','steel',1),(164,'material','55','steel',2),(165,'material','55','steel',3),(166,'material','55','steel',4),(167,'material','55','steel',5),(168,'material','56','supersteel',1),(169,'material','56','supersteel',2),(170,'material','56','supersteel',3),(171,'material','56','supersteel',4),(172,'material','56','supersteel',5),(173,'material','57','tectonite',1),(174,'material','57','tectonite',2),(175,'material','57','tectonite',3),(176,'material','57','tectonite',4),(177,'material','57','tectonite',5),(178,'material','58','vitreouschina',1),(179,'material','58','vitreouschina',2),(180,'material','58','vitreouschina',3),(181,'material','58','vitreouschina',4),(182,'material','58','vitreouschina',5),(183,'material','59','sentecsolidsurface',1),(184,'material','59','sentecsolidsurface',2),(185,'material','59','sentecsolidsurface',3),(186,'material','59','sentecsolidsurface',4),(187,'material','59','sentecsolidsurface',5),(188,'material','60','ciansolidsurface',1),(189,'material','60','ciansolidsurface',2),(190,'material','60','ciansolidsurface',3),(191,'material','60','ciansolidsurface',4),(192,'material','60','ciansolidsurface',5),(193,'material','61','granite',1),(194,'material','61','granite',2),(195,'material','61','granite',3),(196,'material','61','granite',4),(197,'material','61','granite',5),(198,'bath_type',NULL,'bath_type',1),(199,'bath_type',NULL,'bath_type',2),(200,'bath_type',NULL,'bath_type',3),(201,'bath_type',NULL,'bath_type',4),(202,'bath_type',NULL,'bath_type',5),(203,'bath_type','119','corner',1),(204,'bath_type','119','corner',2),(205,'bath_type','119','corner',3),(206,'bath_type','119','corner',4),(207,'bath_type','119','corner',5),(208,'bath_type','120','freestanding',1),(209,'bath_type','120','freestanding',2),(210,'bath_type','120','freestanding',3),(211,'bath_type','120','freestanding',4),(212,'bath_type','120','freestanding',5),(213,'bath_type','121','oval',1),(214,'bath_type','121','oval',2),(215,'bath_type','121','oval',3),(216,'bath_type','121','oval',4),(217,'bath_type','121','oval',5),(218,'bath_type','122','rectangular',1),(219,'bath_type','122','rectangular',2),(220,'bath_type','122','rectangular',3),(221,'bath_type','122','rectangular',4),(222,'bath_type','122','rectangular',5),(223,'bath_type','123','showerbaths',1),(224,'bath_type','123','showerbaths',2),(225,'bath_type','123','showerbaths',3),(226,'bath_type','123','showerbaths',4),(227,'bath_type','123','showerbaths',5),(228,'bath_type','124','traditional',1),(229,'bath_type','124','traditional',2),(230,'bath_type','124','traditional',3),(231,'bath_type','124','traditional',4),(232,'bath_type','124','traditional',5),(233,'bath_type','125','whirlpool',1),(234,'bath_type','125','whirlpool',2),(235,'bath_type','125','whirlpool',3),(236,'bath_type','125','whirlpool',4),(237,'bath_type','125','whirlpool',5),(238,'mount_type',NULL,'mount_type',1),(239,'mount_type',NULL,'mount_type',2),(240,'mount_type',NULL,'mount_type',3),(241,'mount_type',NULL,'mount_type',4),(242,'mount_type',NULL,'mount_type',5),(243,'mount_type','62','insetsinks',1),(244,'mount_type','62','insetsinks',2),(245,'mount_type','62','insetsinks',3),(246,'mount_type','62','insetsinks',4),(247,'mount_type','62','insetsinks',5),(248,'mount_type','63','dropinsinks',1),(249,'mount_type','63','dropinsinks',2),(250,'mount_type','63','dropinsinks',3),(251,'mount_type','63','dropinsinks',4),(252,'mount_type','63','dropinsinks',5),(253,'mount_type','64','droponsinks',1),(254,'mount_type','64','droponsinks',2),(255,'mount_type','64','droponsinks',3),(256,'mount_type','64','droponsinks',4),(257,'mount_type','64','droponsinks',5),(258,'mount_type','65','undermountsinks',1),(259,'mount_type','65','undermountsinks',2),(260,'mount_type','65','undermountsinks',3),(261,'mount_type','65','undermountsinks',4),(262,'mount_type','65','undermountsinks',5),(263,'mount_type','66','flushmountsinks',1),(264,'mount_type','66','flushmountsinks',2),(265,'mount_type','66','flushmountsinks',3),(266,'mount_type','66','flushmountsinks',4),(267,'mount_type','66','flushmountsinks',5),(268,'mount_type','67','slimtopsinks',1),(269,'mount_type','67','slimtopsinks',2),(270,'mount_type','67','slimtopsinks',3),(271,'mount_type','67','slimtopsinks',4),(272,'mount_type','67','slimtopsinks',5),(273,'mount_type','68','cornersinks',1),(274,'mount_type','68','cornersinks',2),(275,'mount_type','68','cornersinks',3),(276,'mount_type','68','cornersinks',4),(277,'mount_type','68','cornersinks',5),(278,'mount_type','69','deckmounted',1),(279,'mount_type','69','deckmounted',2),(280,'mount_type','69','deckmounted',3),(281,'mount_type','69','deckmounted',4),(282,'mount_type','69','deckmounted',5),(283,'mount_type','70','floorstanding',1),(284,'mount_type','70','floorstanding',2),(285,'mount_type','70','floorstanding',3),(286,'mount_type','70','floorstanding',4),(287,'mount_type','70','floorstanding',5),(288,'mount_type','71','wallmounted',1),(289,'mount_type','71','wallmounted',2),(290,'mount_type','71','wallmounted',3),(291,'mount_type','71','wallmounted',4),(292,'mount_type','71','wallmounted',5),(293,'mount_type','72','fullyintegrated',1),(294,'mount_type','72','fullyintegrated',2),(295,'mount_type','72','fullyintegrated',3),(296,'mount_type','72','fullyintegrated',4),(297,'mount_type','72','fullyintegrated',5),(298,'mount_type','73','semiintegrated',1),(299,'mount_type','73','semiintegrated',2),(300,'mount_type','73','semiintegrated',3),(301,'mount_type','73','semiintegrated',4),(302,'mount_type','73','semiintegrated',5),(303,'pressure_bar',NULL,'pressure_bar',5),(304,'pressure_bar','7','01',5),(305,'pressure_bar','8','02',5),(306,'pressure_bar','9','03',5),(307,'pressure_bar','10','1',5),(308,'pressure_bar','11','2',5),(309,'pressure_bar','12','3',5),(310,'pressure_bar','13','4',5),(311,'pressure_bar','14','5',5),(312,'pressure_bar','15','6',5),(313,'pressure_bar','16','05',5),(314,'pressure_bar','17','08',5),(315,'pressure_bar','18','15',5),(316,'pressure_bar','19','18',5),(317,'kitchen_sinks',NULL,'kitchen_sinks',5),(318,'flush_type',NULL,'flush_type',1),(319,'flush_type',NULL,'flush_type',2),(320,'flush_type',NULL,'flush_type',3),(321,'flush_type',NULL,'flush_type',4),(322,'flush_type',NULL,'flush_type',5),(323,'flush_type','173','chainpull',1),(324,'flush_type','173','chainpull',2),(325,'flush_type','173','chainpull',3),(326,'flush_type','173','chainpull',4),(327,'flush_type','173','chainpull',5),(328,'flush_type','174','lever',1),(329,'flush_type','174','lever',2),(330,'flush_type','174','lever',3),(331,'flush_type','174','lever',4),(332,'flush_type','174','lever',5),(333,'flush_type','175','pushbutton',1),(334,'flush_type','175','pushbutton',2),(335,'flush_type','175','pushbutton',3),(336,'flush_type','175','pushbutton',4),(337,'flush_type','175','pushbutton',5),(338,'flush_type','176','rimless',1),(339,'flush_type','176','rimless',2),(340,'flush_type','176','rimless',3),(341,'flush_type','176','rimless',4),(342,'flush_type','176','rimless',5),(343,'bath_length',NULL,'bath_length',1),(344,'bath_length',NULL,'bath_length',2),(345,'bath_length',NULL,'bath_length',3),(346,'bath_length',NULL,'bath_length',4),(347,'bath_length',NULL,'bath_length',5),(348,'bath_length','110','upto1599',1),(349,'bath_length','110','upto1599',2),(350,'bath_length','110','upto1599',3),(351,'bath_length','110','upto1599',4),(352,'bath_length','110','upto1599',5),(353,'bath_length','111','16001699',1),(354,'bath_length','111','16001699',2),(355,'bath_length','111','16001699',3),(356,'bath_length','111','16001699',4),(357,'bath_length','111','16001699',5),(358,'bath_length','112','17001799',1),(359,'bath_length','112','17001799',2),(360,'bath_length','112','17001799',3),(361,'bath_length','112','17001799',4),(362,'bath_length','112','17001799',5),(363,'bath_length','113','18001899',1),(364,'bath_length','113','18001899',2),(365,'bath_length','113','18001899',3),(366,'bath_length','113','18001899',4),(367,'bath_length','113','18001899',5),(368,'bath_length','114','1900above',1),(369,'bath_length','114','1900above',2),(370,'bath_length','114','1900above',3),(371,'bath_length','114','1900above',4),(372,'bath_length','114','1900above',5),(373,'bath_style',NULL,'bath_style',1),(374,'bath_style',NULL,'bath_style',2),(375,'bath_style',NULL,'bath_style',3),(376,'bath_style',NULL,'bath_style',4),(377,'bath_style',NULL,'bath_style',5),(378,'bath_style','115','doubleended',1),(379,'bath_style','115','doubleended',2),(380,'bath_style','115','doubleended',3),(381,'bath_style','115','doubleended',4),(382,'bath_style','115','doubleended',5),(383,'bath_style','116','rectangular_1',1),(384,'bath_style','116','rectangular_1',2),(385,'bath_style','116','rectangular_1',3),(386,'bath_style','116','rectangular_1',4),(387,'bath_style','116','rectangular_1',5),(388,'bath_style','117','singleended',1),(389,'bath_style','117','singleended',2),(390,'bath_style','117','singleended',3),(391,'bath_style','117','singleended',4),(392,'bath_style','117','singleended',5),(393,'bath_style','118','footended',1),(394,'bath_style','118','footended',2),(395,'bath_style','118','footended',3),(396,'bath_style','118','footended',4),(397,'bath_style','118','footended',5),(398,'basin_depth',NULL,'basin_depth',1),(399,'basin_depth',NULL,'basin_depth',2),(400,'basin_depth',NULL,'basin_depth',3),(401,'basin_depth',NULL,'basin_depth',4),(402,'basin_depth',NULL,'basin_depth',5),(403,'basin_depth','169','0499',1),(404,'basin_depth','169','0499',2),(405,'basin_depth','169','0499',3),(406,'basin_depth','169','0499',4),(407,'basin_depth','169','0499',5),(408,'basin_depth','170','500549',1),(409,'basin_depth','170','500549',2),(410,'basin_depth','170','500549',3),(411,'basin_depth','170','500549',4),(412,'basin_depth','170','500549',5),(413,'basin_depth','171','550599',1),(414,'basin_depth','171','550599',2),(415,'basin_depth','171','550599',3),(416,'basin_depth','171','550599',4),(417,'basin_depth','171','550599',5),(418,'basin_depth','172','600649',1),(419,'basin_depth','172','600649',2),(420,'basin_depth','172','600649',3),(421,'basin_depth','172','600649',4),(422,'basin_depth','172','600649',5),(423,'basin_width',NULL,'basin_width',1),(424,'basin_width',NULL,'basin_width',2),(425,'basin_width',NULL,'basin_width',3),(426,'basin_width',NULL,'basin_width',4),(427,'basin_width',NULL,'basin_width',5),(428,'basin_width','158','0399',1),(429,'basin_width','158','0399',2),(430,'basin_width','158','0399',3),(431,'basin_width','158','0399',4),(432,'basin_width','158','0399',5),(433,'basin_width','159','400499',1),(434,'basin_width','159','400499',2),(435,'basin_width','159','400499',3),(436,'basin_width','159','400499',4),(437,'basin_width','159','400499',5),(438,'basin_width','160','500599',1),(439,'basin_width','160','500599',2),(440,'basin_width','160','500599',3),(441,'basin_width','160','500599',4),(442,'basin_width','160','500599',5),(443,'basin_width','161','600699',1),(444,'basin_width','161','600699',2),(445,'basin_width','161','600699',3),(446,'basin_width','161','600699',4),(447,'basin_width','161','600699',5),(448,'basin_width','162','700799',1),(449,'basin_width','162','700799',2),(450,'basin_width','162','700799',3),(451,'basin_width','162','700799',4),(452,'basin_width','162','700799',5),(453,'basin_width','163','800899',1),(454,'basin_width','163','800899',2),(455,'basin_width','163','800899',3),(456,'basin_width','163','800899',4),(457,'basin_width','163','800899',5),(458,'basin_width','164','900999',1),(459,'basin_width','164','900999',2),(460,'basin_width','164','900999',3),(461,'basin_width','164','900999',4),(462,'basin_width','164','900999',5),(463,'basin_width','165','10001099',1),(464,'basin_width','165','10001099',2),(465,'basin_width','165','10001099',3),(466,'basin_width','165','10001099',4),(467,'basin_width','165','10001099',5),(468,'basin_width','166','11001199',1),(469,'basin_width','166','11001199',2),(470,'basin_width','166','11001199',3),(471,'basin_width','166','11001199',4),(472,'basin_width','166','11001199',5),(473,'basin_width','167','12001299',1),(474,'basin_width','167','12001299',2),(475,'basin_width','167','12001299',3),(476,'basin_width','167','12001299',4),(477,'basin_width','167','12001299',5),(478,'basin_width','168','13001399',1),(479,'basin_width','168','13001399',2),(480,'basin_width','168','13001399',3),(481,'basin_width','168','13001399',4),(482,'basin_width','168','13001399',5),(483,'toilet_full_height',NULL,'toilet_full_height',1),(484,'toilet_full_height',NULL,'toilet_full_height',2),(485,'toilet_full_height',NULL,'toilet_full_height',3),(486,'toilet_full_height',NULL,'toilet_full_height',4),(487,'toilet_full_height',NULL,'toilet_full_height',5),(488,'toilet_full_height','195','0399_1',1),(489,'toilet_full_height','195','0399_1',2),(490,'toilet_full_height','195','0399_1',3),(491,'toilet_full_height','195','0399_1',4),(492,'toilet_full_height','195','0399_1',5),(493,'toilet_full_height','196','400499_1',1),(494,'toilet_full_height','196','400499_1',2),(495,'toilet_full_height','196','400499_1',3),(496,'toilet_full_height','196','400499_1',4),(497,'toilet_full_height','196','400499_1',5),(498,'toilet_full_height','197','500549_1',1),(499,'toilet_full_height','197','500549_1',2),(500,'toilet_full_height','197','500549_1',3),(501,'toilet_full_height','197','500549_1',4),(502,'toilet_full_height','197','500549_1',5),(503,'toilet_full_height','198','550599_1',1),(504,'toilet_full_height','198','550599_1',2),(505,'toilet_full_height','198','550599_1',3),(506,'toilet_full_height','198','550599_1',4),(507,'toilet_full_height','198','550599_1',5),(508,'toilet_full_height','199','600649_1',1),(509,'toilet_full_height','199','600649_1',2),(510,'toilet_full_height','199','600649_1',3),(511,'toilet_full_height','199','600649_1',4),(512,'toilet_full_height','199','600649_1',5),(513,'toilet_full_height','200','650699',1),(514,'toilet_full_height','200','650699',2),(515,'toilet_full_height','200','650699',3),(516,'toilet_full_height','200','650699',4),(517,'toilet_full_height','200','650699',5),(518,'toilet_full_height','201','700799_1',1),(519,'toilet_full_height','201','700799_1',2),(520,'toilet_full_height','201','700799_1',3),(521,'toilet_full_height','201','700799_1',4),(522,'toilet_full_height','201','700799_1',5),(523,'toilet_full_height','202','800above',1),(524,'toilet_full_height','202','800above',2),(525,'toilet_full_height','202','800above',3),(526,'toilet_full_height','202','800above',4),(527,'toilet_full_height','202','800above',5),(528,'toilet_projection',NULL,'toilet_projection',1),(529,'toilet_projection',NULL,'toilet_projection',2),(530,'toilet_projection',NULL,'toilet_projection',3),(531,'toilet_projection',NULL,'toilet_projection',4),(532,'toilet_projection',NULL,'toilet_projection',5),(533,'toilet_projection','188','0499_1',1),(534,'toilet_projection','188','0499_1',2),(535,'toilet_projection','188','0499_1',3),(536,'toilet_projection','188','0499_1',4),(537,'toilet_projection','188','0499_1',5),(538,'toilet_projection','189','500549_2',1),(539,'toilet_projection','189','500549_2',2),(540,'toilet_projection','189','500549_2',3),(541,'toilet_projection','189','500549_2',4),(542,'toilet_projection','189','500549_2',5),(543,'toilet_projection','190','550599_2',1),(544,'toilet_projection','190','550599_2',2),(545,'toilet_projection','190','550599_2',3),(546,'toilet_projection','190','550599_2',4),(547,'toilet_projection','190','550599_2',5),(548,'toilet_projection','191','600649_2',1),(549,'toilet_projection','191','600649_2',2),(550,'toilet_projection','191','600649_2',3),(551,'toilet_projection','191','600649_2',4),(552,'toilet_projection','191','600649_2',5),(553,'toilet_projection','192','650699_1',1),(554,'toilet_projection','192','650699_1',2),(555,'toilet_projection','192','650699_1',3),(556,'toilet_projection','192','650699_1',4),(557,'toilet_projection','192','650699_1',5),(558,'toilet_projection','193','700799_2',1),(559,'toilet_projection','193','700799_2',2),(560,'toilet_projection','193','700799_2',3),(561,'toilet_projection','193','700799_2',4),(562,'toilet_projection','193','700799_2',5),(563,'toilet_projection','194','800899_1',1),(564,'toilet_projection','194','800899_1',2),(565,'toilet_projection','194','800899_1',3),(566,'toilet_projection','194','800899_1',4),(567,'toilet_projection','194','800899_1',5),(568,'toilet_style',NULL,'toilet_style',1),(569,'toilet_style',NULL,'toilet_style',2),(570,'toilet_style',NULL,'toilet_style',3),(571,'toilet_style',NULL,'toilet_style',4),(572,'toilet_style',NULL,'toilet_style',5),(573,'toilet_style','184','modern',1),(574,'toilet_style','184','modern',2),(575,'toilet_style','184','modern',3),(576,'toilet_style','184','modern',4),(577,'toilet_style','184','modern',5),(578,'toilet_style','185','traditional_1',1),(579,'toilet_style','185','traditional_1',2),(580,'toilet_style','185','traditional_1',3),(581,'toilet_style','185','traditional_1',4),(582,'toilet_style','185','traditional_1',5),(583,'toilet_style','186','specialneeds',1),(584,'toilet_style','186','specialneeds',2),(585,'toilet_style','186','specialneeds',3),(586,'toilet_style','186','specialneeds',4),(587,'toilet_style','186','specialneeds',5),(588,'toilet_style','187','rimless_1',1),(589,'toilet_style','187','rimless_1',2),(590,'toilet_style','187','rimless_1',3),(591,'toilet_style','187','rimless_1',4),(592,'toilet_style','187','rimless_1',5),(593,'toilet_width',NULL,'toilet_width',1),(594,'toilet_width',NULL,'toilet_width',2),(595,'toilet_width',NULL,'toilet_width',3),(596,'toilet_width',NULL,'toilet_width',4),(597,'toilet_width',NULL,'toilet_width',5),(598,'toilet_width','177','0399_2',1),(599,'toilet_width','177','0399_2',2),(600,'toilet_width','177','0399_2',3),(601,'toilet_width','177','0399_2',4),(602,'toilet_width','177','0399_2',5),(603,'toilet_width','178','400499_2',1),(604,'toilet_width','178','400499_2',2),(605,'toilet_width','178','400499_2',3),(606,'toilet_width','178','400499_2',4),(607,'toilet_width','178','400499_2',5),(608,'toilet_width','179','500549_3',1),(609,'toilet_width','179','500549_3',2),(610,'toilet_width','179','500549_3',3),(611,'toilet_width','179','500549_3',4),(612,'toilet_width','179','500549_3',5),(613,'toilet_width','180','550599_3',1),(614,'toilet_width','180','550599_3',2),(615,'toilet_width','180','550599_3',3),(616,'toilet_width','180','550599_3',4),(617,'toilet_width','180','550599_3',5),(618,'toilet_width','181','600649_3',1),(619,'toilet_width','181','600649_3',2),(620,'toilet_width','181','600649_3',3),(621,'toilet_width','181','600649_3',4),(622,'toilet_width','181','600649_3',5),(623,'toilet_width','182','650699_2',1),(624,'toilet_width','182','650699_2',2),(625,'toilet_width','182','650699_2',3),(626,'toilet_width','182','650699_2',4),(627,'toilet_width','182','650699_2',5),(628,'toilet_width','183','700799_3',1),(629,'toilet_width','183','700799_3',2),(630,'toilet_width','183','700799_3',3),(631,'toilet_width','183','700799_3',4),(632,'toilet_width','183','700799_3',5),(633,'installation',NULL,'installation',1),(634,'installation',NULL,'installation',2),(635,'installation',NULL,'installation',3),(636,'installation',NULL,'installation',4),(637,'installation',NULL,'installation',5),(638,'installation','203','insetsinks_1',1),(639,'installation','203','insetsinks_1',2),(640,'installation','203','insetsinks_1',3),(641,'installation','203','insetsinks_1',4),(642,'installation','203','insetsinks_1',5),(643,'installation','204','dropinsinks_1',1),(644,'installation','204','dropinsinks_1',2),(645,'installation','204','dropinsinks_1',3),(646,'installation','204','dropinsinks_1',4),(647,'installation','204','dropinsinks_1',5),(648,'installation','205','droponsinks_1',1),(649,'installation','205','droponsinks_1',2),(650,'installation','205','droponsinks_1',3),(651,'installation','205','droponsinks_1',4),(652,'installation','205','droponsinks_1',5),(653,'installation','206','topmountedsinks',1),(654,'installation','206','topmountedsinks',2),(655,'installation','206','topmountedsinks',3),(656,'installation','206','topmountedsinks',4),(657,'installation','206','topmountedsinks',5),(658,'installation','207','slimtopsinks_1',1),(659,'installation','207','slimtopsinks_1',2),(660,'installation','207','slimtopsinks_1',3),(661,'installation','207','slimtopsinks_1',4),(662,'installation','207','slimtopsinks_1',5),(663,'installation','208','flushmountsinks_1',1),(664,'installation','208','flushmountsinks_1',2),(665,'installation','208','flushmountsinks_1',3),(666,'installation','208','flushmountsinks_1',4),(667,'installation','208','flushmountsinks_1',5),(668,'installation','209','undermountsinks_1',1),(669,'installation','209','undermountsinks_1',2),(670,'installation','209','undermountsinks_1',3),(671,'installation','209','undermountsinks_1',4),(672,'installation','209','undermountsinks_1',5),(673,'installation','210','belfastsinks',1),(674,'installation','210','belfastsinks',2),(675,'installation','210','belfastsinks',3),(676,'installation','210','belfastsinks',4),(677,'installation','210','belfastsinks',5),(678,'installation','211','cornersinks_1',1),(679,'installation','211','cornersinks_1',2),(680,'installation','211','cornersinks_1',3),(681,'installation','211','cornersinks_1',4),(682,'installation','211','cornersinks_1',5),(683,'installation','212','sinkmodules',1),(684,'installation','212','sinkmodules',2),(685,'installation','212','sinkmodules',3),(686,'installation','212','sinkmodules',4),(687,'installation','212','sinkmodules',5),(688,'installation','213','siton',1),(689,'installation','213','siton',2),(690,'installation','213','siton',3),(691,'installation','213','siton',4),(692,'installation','213','siton',5),(693,'installation','214','flushfitsinks',1),(694,'installation','214','flushfitsinks',2),(695,'installation','214','flushfitsinks',3),(696,'installation','214','flushfitsinks',4),(697,'installation','214','flushfitsinks',5),(698,'installation','215','floorstanding_1',1),(699,'installation','215','floorstanding_1',2),(700,'installation','215','floorstanding_1',3),(701,'installation','215','floorstanding_1',4),(702,'installation','215','floorstanding_1',5),(703,'installation','216','backtowall',1),(704,'installation','216','backtowall',2),(705,'installation','216','backtowall',3),(706,'installation','216','backtowall',4),(707,'installation','216','backtowall',5),(708,'installation','217','closecoupled',1),(709,'installation','217','closecoupled',2),(710,'installation','217','closecoupled',3),(711,'installation','217','closecoupled',4),(712,'installation','217','closecoupled',5),(713,'installation','218','wallhung',1),(714,'installation','218','wallhung',2),(715,'installation','218','wallhung',3),(716,'installation','218','wallhung',4),(717,'installation','218','wallhung',5),(718,'installation','219','ceiling',1),(719,'installation','219','ceiling',2),(720,'installation','219','ceiling',3),(721,'installation','219','ceiling',4),(722,'installation','219','ceiling',5),(723,'installation','220','wallmounted_1',1),(724,'installation','220','wallmounted_1',2),(725,'installation','220','wallmounted_1',3),(726,'installation','220','wallmounted_1',4),(727,'installation','220','wallmounted_1',5),(728,'installation','221','deckmounted_1',1),(729,'installation','221','deckmounted_1',2),(730,'installation','221','deckmounted_1',3),(731,'installation','221','deckmounted_1',4),(732,'installation','221','deckmounted_1',5),(733,'installation','222','freestandingtaps',1),(734,'installation','222','freestandingtaps',2),(735,'installation','222','freestandingtaps',3),(736,'installation','222','freestandingtaps',4),(737,'installation','222','freestandingtaps',5),(738,'installation','223','digitaltaps',1),(739,'installation','223','digitaltaps',2),(740,'installation','223','digitaltaps',3),(741,'installation','223','digitaltaps',4),(742,'installation','223','digitaltaps',5),(743,'glass_thickness',NULL,'glass_thickness',1),(744,'glass_thickness',NULL,'glass_thickness',2),(745,'glass_thickness',NULL,'glass_thickness',3),(746,'glass_thickness',NULL,'glass_thickness',4),(747,'glass_thickness',NULL,'glass_thickness',5),(748,'glass_thickness','126','5mm',1),(749,'glass_thickness','126','5mm',2),(750,'glass_thickness','126','5mm',3),(751,'glass_thickness','126','5mm',4),(752,'glass_thickness','126','5mm',5),(753,'glass_thickness','127','6mm',1),(754,'glass_thickness','127','6mm',2),(755,'glass_thickness','127','6mm',3),(756,'glass_thickness','127','6mm',4),(757,'glass_thickness','127','6mm',5),(758,'glass_thickness','128','8mm',1),(759,'glass_thickness','128','8mm',2),(760,'glass_thickness','128','8mm',3),(761,'glass_thickness','128','8mm',4),(762,'glass_thickness','128','8mm',5),(763,'glass_thickness','129','4mm',1),(764,'glass_thickness','129','4mm',2),(765,'glass_thickness','129','4mm',3),(766,'glass_thickness','129','4mm',4),(767,'glass_thickness','129','4mm',5),(768,'glass_thickness','130','7mm',1),(769,'glass_thickness','130','7mm',2),(770,'glass_thickness','130','7mm',3),(771,'glass_thickness','130','7mm',4),(772,'glass_thickness','130','7mm',5),(773,'glass_thickness','131','10mm',1),(774,'glass_thickness','131','10mm',2),(775,'glass_thickness','131','10mm',3),(776,'glass_thickness','131','10mm',4),(777,'glass_thickness','131','10mm',5),(778,'tap_type',NULL,'tap_type',1),(779,'tap_type',NULL,'tap_type',2),(780,'tap_type',NULL,'tap_type',3),(781,'tap_type',NULL,'tap_type',4),(782,'tap_type',NULL,'tap_type',5),(783,'tap_type','143','bathmixertaps',1),(784,'tap_type','143','bathmixertaps',2),(785,'tap_type','143','bathmixertaps',3),(786,'tap_type','143','bathmixertaps',4),(787,'tap_type','143','bathmixertaps',5),(788,'tap_type','144','bathspouts',1),(789,'tap_type','144','bathspouts',2),(790,'tap_type','144','bathspouts',3),(791,'tap_type','144','bathspouts',4),(792,'tap_type','144','bathspouts',5),(793,'tap_type','145','deckmounted_2',1),(794,'tap_type','145','deckmounted_2',2),(795,'tap_type','145','deckmounted_2',3),(796,'tap_type','145','deckmounted_2',4),(797,'tap_type','145','deckmounted_2',5),(798,'tap_type','146','filterflowtaps',1),(799,'tap_type','146','filterflowtaps',2),(800,'tap_type','146','filterflowtaps',3),(801,'tap_type','146','filterflowtaps',4),(802,'tap_type','146','filterflowtaps',5),(803,'tap_type','147','freestanding_1',1),(804,'tap_type','147','freestanding_1',2),(805,'tap_type','147','freestanding_1',3),(806,'tap_type','147','freestanding_1',4),(807,'tap_type','147','freestanding_1',5),(808,'tap_type','148','spraytaps',1),(809,'tap_type','148','spraytaps',2),(810,'tap_type','148','spraytaps',3),(811,'tap_type','148','spraytaps',4),(812,'tap_type','148','spraytaps',5),(813,'tap_type','149','swivelspouttaps',1),(814,'tap_type','149','swivelspouttaps',2),(815,'tap_type','149','swivelspouttaps',3),(816,'tap_type','149','swivelspouttaps',4),(817,'tap_type','149','swivelspouttaps',5),(818,'tap_type','150','wallmounted_2',1),(819,'tap_type','150','wallmounted_2',2),(820,'tap_type','150','wallmounted_2',3),(821,'tap_type','150','wallmounted_2',4),(822,'tap_type','150','wallmounted_2',5),(823,'tap_type','151','bathshowermixertaps',1),(824,'tap_type','151','bathshowermixertaps',2),(825,'tap_type','151','bathshowermixertaps',3),(826,'tap_type','151','bathshowermixertaps',4),(827,'tap_type','151','bathshowermixertaps',5),(828,'tap_type','152','hotandcoldtaps',1),(829,'tap_type','152','hotandcoldtaps',2),(830,'tap_type','152','hotandcoldtaps',3),(831,'tap_type','152','hotandcoldtaps',4),(832,'tap_type','152','hotandcoldtaps',5),(833,'tap_type','153','bathfillers',1),(834,'tap_type','153','bathfillers',2),(835,'tap_type','153','bathfillers',3),(836,'tap_type','153','bathfillers',4),(837,'tap_type','153','bathfillers',5),(838,'tap_type','154','floorstandingtaps',1),(839,'tap_type','154','floorstandingtaps',2),(840,'tap_type','154','floorstandingtaps',3),(841,'tap_type','154','floorstandingtaps',4),(842,'tap_type','154','floorstandingtaps',5),(843,'tap_type','155','bathshowermixers',1),(844,'tap_type','155','bathshowermixers',2),(845,'tap_type','155','bathshowermixers',3),(846,'tap_type','155','bathshowermixers',4),(847,'tap_type','155','bathshowermixers',5),(848,'tap_type','156','bathshowermixerswithkit',1),(849,'tap_type','156','bathshowermixerswithkit',2),(850,'tap_type','156','bathshowermixerswithkit',3),(851,'tap_type','156','bathshowermixerswithkit',4),(852,'tap_type','156','bathshowermixerswithkit',5),(853,'tap_type','157','pullouttaps',1),(854,'tap_type','157','pullouttaps',2),(855,'tap_type','157','pullouttaps',3),(856,'tap_type','157','pullouttaps',4),(857,'tap_type','157','pullouttaps',5),(858,'tap_style',NULL,'tap_style',1),(859,'tap_style',NULL,'tap_style',2),(860,'tap_style',NULL,'tap_style',3),(861,'tap_style',NULL,'tap_style',4),(862,'tap_style',NULL,'tap_style',5),(863,'tap_style','132','2holetaps',1),(864,'tap_style','132','2holetaps',2),(865,'tap_style','132','2holetaps',3),(866,'tap_style','132','2holetaps',4),(867,'tap_style','132','2holetaps',5),(868,'tap_style','133','4holetaps',1),(869,'tap_style','133','4holetaps',2),(870,'tap_style','133','4holetaps',3),(871,'tap_style','133','4holetaps',4),(872,'tap_style','133','4holetaps',5),(873,'tap_style','134','3holetaps',1),(874,'tap_style','134','3holetaps',2),(875,'tap_style','134','3holetaps',3),(876,'tap_style','134','3holetaps',4),(877,'tap_style','134','3holetaps',5),(878,'tap_style','135','5holetaps',1),(879,'tap_style','135','5holetaps',2),(880,'tap_style','135','5holetaps',3),(881,'tap_style','135','5holetaps',4),(882,'tap_style','135','5holetaps',5),(883,'tap_style','136','singlelever',1),(884,'tap_style','136','singlelever',2),(885,'tap_style','136','singlelever',3),(886,'tap_style','136','singlelever',4),(887,'tap_style','136','singlelever',5),(888,'tap_style','137','doublelever',1),(889,'tap_style','137','doublelever',2),(890,'tap_style','137','doublelever',3),(891,'tap_style','137','doublelever',4),(892,'tap_style','137','doublelever',5),(893,'tap_style','138','doublehandle',1),(894,'tap_style','138','doublehandle',2),(895,'tap_style','138','doublehandle',3),(896,'tap_style','138','doublehandle',4),(897,'tap_style','138','doublehandle',5),(898,'tap_style','139','crosshead',1),(899,'tap_style','139','crosshead',2),(900,'tap_style','139','crosshead',3),(901,'tap_style','139','crosshead',4),(902,'tap_style','139','crosshead',5),(903,'tap_style','140','traditional_2',1),(904,'tap_style','140','traditional_2',2),(905,'tap_style','140','traditional_2',3),(906,'tap_style','140','traditional_2',4),(907,'tap_style','140','traditional_2',5),(908,'tap_style','141','pushbutton_1',1),(909,'tap_style','141','pushbutton_1',2),(910,'tap_style','141','pushbutton_1',3),(911,'tap_style','141','pushbutton_1',4),(912,'tap_style','141','pushbutton_1',5),(913,'tap_style','142','sensortaps',1),(914,'tap_style','142','sensortaps',2),(915,'tap_style','142','sensortaps',3),(916,'tap_style','142','sensortaps',4),(917,'tap_style','142','sensortaps',5),(918,'fuel_type',NULL,'fuel_type',1),(919,'fuel_type',NULL,'fuel_type',2),(920,'fuel_type',NULL,'fuel_type',3),(921,'fuel_type',NULL,'fuel_type',4),(922,'fuel_type',NULL,'fuel_type',5),(923,'fuel_type','224','centralheating',1),(924,'fuel_type','224','centralheating',2),(925,'fuel_type','224','centralheating',3),(926,'fuel_type','224','centralheating',4),(927,'fuel_type','224','centralheating',5),(928,'fuel_type','225','gas',1),(929,'fuel_type','225','gas',2),(930,'fuel_type','225','gas',3),(931,'fuel_type','225','gas',4),(932,'fuel_type','225','gas',5),(933,'fuel_type','226','electric',1),(934,'fuel_type','226','electric',2),(935,'fuel_type','226','electric',3),(936,'fuel_type','226','electric',4),(937,'fuel_type','226','electric',5),(938,'fuel_type','227','wood',1),(939,'fuel_type','227','wood',2),(940,'fuel_type','227','wood',3),(941,'fuel_type','227','wood',4),(942,'fuel_type','227','wood',5),(943,'fuel_type','228','multifuel',1),(944,'fuel_type','228','multifuel',2),(945,'fuel_type','228','multifuel',3),(946,'fuel_type','228','multifuel',4),(947,'fuel_type','228','multifuel',5),(948,'fuel_type','229','dualfuel',1),(949,'fuel_type','229','dualfuel',2),(950,'fuel_type','229','dualfuel',3),(951,'fuel_type','229','dualfuel',4),(952,'fuel_type','229','dualfuel',5),(953,'colour',NULL,'colour',1),(954,'colour',NULL,'colour',2),(955,'colour',NULL,'colour',3),(956,'colour',NULL,'colour',4),(957,'colour',NULL,'colour',5),(958,'colour','230','black',1),(959,'colour','230','black',2),(960,'colour','230','black',3),(961,'colour','230','black',4),(962,'colour','230','black',5),(963,'colour','231','blackglass',1),(964,'colour','231','blackglass',2),(965,'colour','231','blackglass',3),(966,'colour','231','blackglass',4),(967,'colour','231','blackglass',5),(968,'colour','232','highglossblack',1),(969,'colour','232','highglossblack',2),(970,'colour','232','highglossblack',3),(971,'colour','232','highglossblack',4),(972,'colour','232','highglossblack',5),(973,'colour','233','mattblack',1),(974,'colour','233','mattblack',2),(975,'colour','233','mattblack',3),(976,'colour','233','mattblack',4),(977,'colour','233','mattblack',5),(978,'colour','234','anthracite',1),(979,'colour','234','anthracite',2),(980,'colour','234','anthracite',3),(981,'colour','234','anthracite',4),(982,'colour','234','anthracite',5),(983,'colour','235','texturedanthracite',1),(984,'colour','235','texturedanthracite',2),(985,'colour','235','texturedanthracite',3),(986,'colour','235','texturedanthracite',4),(987,'colour','235','texturedanthracite',5),(988,'colour','236','texturedmetallicdarkgrey',1),(989,'colour','236','texturedmetallicdarkgrey',2),(990,'colour','236','texturedmetallicdarkgrey',3),(991,'colour','236','texturedmetallicdarkgrey',4),(992,'colour','236','texturedmetallicdarkgrey',5),(993,'colour','237','white',1),(994,'colour','237','white',2),(995,'colour','237','white',3),(996,'colour','237','white',4),(997,'colour','237','white',5),(998,'colour','238','chrome',1),(999,'colour','238','chrome',2),(1000,'colour','238','chrome',3),(1001,'colour','238','chrome',4),(1002,'colour','238','chrome',5),(1003,'colour','239','polished',1),(1004,'colour','239','polished',2),(1005,'colour','239','polished',3),(1006,'colour','239','polished',4),(1007,'colour','239','polished',5),(1008,'colour','240','brushed',1),(1009,'colour','240','brushed',2),(1010,'colour','240','brushed',3),(1011,'colour','240','brushed',4),(1012,'colour','240','brushed',5),(1013,'colour','241','brushedsteel',1),(1014,'colour','241','brushedsteel',2),(1015,'colour','241','brushedsteel',3),(1016,'colour','241','brushedsteel',4),(1017,'colour','241','brushedsteel',5),(1018,'colour','242','aluminiumbrushed',1),(1019,'colour','242','aluminiumbrushed',2),(1020,'colour','242','aluminiumbrushed',3),(1021,'colour','242','aluminiumbrushed',4),(1022,'colour','242','aluminiumbrushed',5),(1023,'colour','243','stainlesssteel_1',1),(1024,'colour','243','stainlesssteel_1',2),(1025,'colour','243','stainlesssteel_1',3),(1026,'colour','243','stainlesssteel_1',4),(1027,'colour','243','stainlesssteel_1',5),(1028,'colour','244','silver',1),(1029,'colour','244','silver',2),(1030,'colour','244','silver',3),(1031,'colour','244','silver',4),(1032,'colour','244','silver',5),(1033,'colour','245','satin',1),(1034,'colour','245','satin',2),(1035,'colour','245','satin',3),(1036,'colour','245','satin',4),(1037,'colour','245','satin',5),(1038,'colour','246','grey',1),(1039,'colour','246','grey',2),(1040,'colour','246','grey',3),(1041,'colour','246','grey',4),(1042,'colour','246','grey',5),(1043,'colour','247','titane',1),(1044,'colour','247','titane',2),(1045,'colour','247','titane',3),(1046,'colour','247','titane',4),(1047,'colour','247','titane',5),(1048,'colour','248','volcanic',1),(1049,'colour','248','volcanic',2),(1050,'colour','248','volcanic',3),(1051,'colour','248','volcanic',4),(1052,'colour','248','volcanic',5),(1053,'colour','249','highglosssilver',1),(1054,'colour','249','highglosssilver',2),(1055,'colour','249','highglosssilver',3),(1056,'colour','249','highglosssilver',4),(1057,'colour','249','highglosssilver',5),(1058,'colour','250','anodisedaluminium',1),(1059,'colour','250','anodisedaluminium',2),(1060,'colour','250','anodisedaluminium',3),(1061,'colour','250','anodisedaluminium',4),(1062,'colour','250','anodisedaluminium',5),(1063,'colour','251','beigequartz',1),(1064,'colour','251','beigequartz',2),(1065,'colour','251','beigequartz',3),(1066,'colour','251','beigequartz',4),(1067,'colour','251','beigequartz',5),(1068,'colour','252','brownquartz',1),(1069,'colour','252','brownquartz',2),(1070,'colour','252','brownquartz',3),(1071,'colour','252','brownquartz',4),(1072,'colour','252','brownquartz',5),(1073,'colour','253','champagne',1),(1074,'colour','253','champagne',2),(1075,'colour','253','champagne',3),(1076,'colour','253','champagne',4),(1077,'colour','253','champagne',5),(1078,'colour','254','etchedbrass',1),(1079,'colour','254','etchedbrass',2),(1080,'colour','254','etchedbrass',3),(1081,'colour','254','etchedbrass',4),(1082,'colour','254','etchedbrass',5),(1083,'colour','255','etchedcopper',1),(1084,'colour','255','etchedcopper',2),(1085,'colour','255','etchedcopper',3),(1086,'colour','255','etchedcopper',4),(1087,'colour','255','etchedcopper',5),(1088,'colour','256','marron',1),(1089,'colour','256','marron',2),(1090,'colour','256','marron',3),(1091,'colour','256','marron',4),(1092,'colour','256','marron',5),(1093,'colour','257','mattanodised',1),(1094,'colour','257','mattanodised',2),(1095,'colour','257','mattanodised',3),(1096,'colour','257','mattanodised',4),(1097,'colour','257','mattanodised',5),(1098,'colour','258','mirror',1),(1099,'colour','258','mirror',2),(1100,'colour','258','mirror',3),(1101,'colour','258','mirror',4),(1102,'colour','258','mirror',5),(1103,'colour','259','polishedanodised',1),(1104,'colour','259','polishedanodised',2),(1105,'colour','259','polishedanodised',3),(1106,'colour','259','polishedanodised',4),(1107,'colour','259','polishedanodised',5),(1108,'colour','260','red',1),(1109,'colour','260','red',2),(1110,'colour','260','red',3),(1111,'colour','260','red',4),(1112,'colour','260','red',5),(1113,'colour','261','blackenamel',1),(1114,'colour','261','blackenamel',2),(1115,'colour','261','blackenamel',3),(1116,'colour','261','blackenamel',4),(1117,'colour','261','blackenamel',5),(1118,'colour','262','whiteenamel',1),(1119,'colour','262','whiteenamel',2),(1120,'colour','262','whiteenamel',3),(1121,'colour','262','whiteenamel',4),(1122,'colour','262','whiteenamel',5),(1123,'colour','263','inoxeasyclean',1),(1124,'colour','263','inoxeasyclean',2),(1125,'colour','263','inoxeasyclean',3),(1126,'colour','263','inoxeasyclean',4),(1127,'colour','263','inoxeasyclean',5),(1128,'colour','264','sstrim',1),(1129,'colour','264','sstrim',2),(1130,'colour','264','sstrim',3),(1131,'colour','264','sstrim',4),(1132,'colour','264','sstrim',5),(1133,'colour','265','colour_1',1),(1134,'colour','265','colour_1',2),(1135,'colour','265','colour_1',3),(1136,'colour','265','colour_1',4),(1137,'colour','265','colour_1',5),(1138,'colour','266','blackwithsteeltrim',1),(1139,'colour','266','blackwithsteeltrim',2),(1140,'colour','266','blackwithsteeltrim',3),(1141,'colour','266','blackwithsteeltrim',4),(1142,'colour','266','blackwithsteeltrim',5),(1143,'colour','267','whitewithsteeltrim',1),(1144,'colour','267','whitewithsteeltrim',2),(1145,'colour','267','whitewithsteeltrim',3),(1146,'colour','267','whitewithsteeltrim',4),(1147,'colour','267','whitewithsteeltrim',5),(1148,'colour','268','mattcopper',1),(1149,'colour','268','mattcopper',2),(1150,'colour','268','mattcopper',3),(1151,'colour','268','mattcopper',4),(1152,'colour','268','mattcopper',5),(1153,'built_type',NULL,'built_type',1),(1154,'built_type',NULL,'built_type',2),(1155,'built_type',NULL,'built_type',3),(1156,'built_type',NULL,'built_type',4),(1157,'built_type',NULL,'built_type',5),(1158,'built_type','269','builtin',1),(1159,'built_type','269','builtin',2),(1160,'built_type','269','builtin',3),(1161,'built_type','269','builtin',4),(1162,'built_type','269','builtin',5),(1163,'built_type','270','builtunder',1),(1164,'built_type','270','builtunder',2),(1165,'built_type','270','builtunder',3),(1166,'built_type','270','builtunder',4),(1167,'built_type','270','builtunder',5),(1168,'oven_type',NULL,'oven_type',1),(1169,'oven_type',NULL,'oven_type',2),(1170,'oven_type',NULL,'oven_type',3),(1171,'oven_type',NULL,'oven_type',4),(1172,'oven_type',NULL,'oven_type',5),(1173,'oven_type','271','singleovens',1),(1174,'oven_type','271','singleovens',2),(1175,'oven_type','271','singleovens',3),(1176,'oven_type','271','singleovens',4),(1177,'oven_type','271','singleovens',5),(1178,'oven_type','272','doubleovens',1),(1179,'oven_type','272','doubleovens',2),(1180,'oven_type','272','doubleovens',3),(1181,'oven_type','272','doubleovens',4),(1182,'oven_type','272','doubleovens',5),(1183,'oven_type','273','compactovens',1),(1184,'oven_type','273','compactovens',2),(1185,'oven_type','273','compactovens',3),(1186,'oven_type','273','compactovens',4),(1187,'oven_type','273','compactovens',5),(1188,'oven_type','274','steamovens',1),(1189,'oven_type','274','steamovens',2),(1190,'oven_type','274','steamovens',3),(1191,'oven_type','274','steamovens',4),(1192,'oven_type','274','steamovens',5),(1193,'oven_type','275','slidehideovens',1),(1194,'oven_type','275','slidehideovens',2),(1195,'oven_type','275','slidehideovens',3),(1196,'oven_type','275','slidehideovens',4),(1197,'oven_type','275','slidehideovens',5),(1198,'oven_type','276','microwaveovens',1),(1199,'oven_type','276','microwaveovens',2),(1200,'oven_type','276','microwaveovens',3),(1201,'oven_type','276','microwaveovens',4),(1202,'oven_type','276','microwaveovens',5),(1203,'oven_type','277','compactmicrowaveovens',1),(1204,'oven_type','277','compactmicrowaveovens',2),(1205,'oven_type','277','compactmicrowaveovens',3),(1206,'oven_type','277','compactmicrowaveovens',4),(1207,'oven_type','277','compactmicrowaveovens',5),(1208,'size',NULL,'size',1),(1209,'size',NULL,'size',2),(1210,'size',NULL,'size',3),(1211,'size',NULL,'size',4),(1212,'size',NULL,'size',5),(1213,'size','285','140mm',1),(1214,'size','285','140mm',2),(1215,'size','285','140mm',3),(1216,'size','285','140mm',4),(1217,'size','285','140mm',5),(1218,'size','286','290mm',1),(1219,'size','286','290mm',2),(1220,'size','286','290mm',3),(1221,'size','286','290mm',4),(1222,'size','286','290mm',5),(1223,'size','287','300mm',1),(1224,'size','287','300mm',2),(1225,'size','287','300mm',3),(1226,'size','287','300mm',4),(1227,'size','287','300mm',5),(1228,'size','288','upto300mm',1),(1229,'size','288','upto300mm',2),(1230,'size','288','upto300mm',3),(1231,'size','288','upto300mm',4),(1232,'size','288','upto300mm',5),(1233,'size','289','370mm',1),(1234,'size','289','370mm',2),(1235,'size','289','370mm',3),(1236,'size','289','370mm',4),(1237,'size','289','370mm',5),(1238,'size','290','396mm',1),(1239,'size','290','396mm',2),(1240,'size','290','396mm',3),(1241,'size','290','396mm',4),(1242,'size','290','396mm',5),(1243,'size','291','400mm',1),(1244,'size','291','400mm',2),(1245,'size','291','400mm',3),(1246,'size','291','400mm',4),(1247,'size','291','400mm',5),(1248,'size','292','450mm',1),(1249,'size','292','450mm',2),(1250,'size','292','450mm',3),(1251,'size','292','450mm',4),(1252,'size','292','450mm',5),(1253,'size','293','1000mm',1),(1254,'size','293','1000mm',2),(1255,'size','293','1000mm',3),(1256,'size','293','1000mm',4),(1257,'size','293','1000mm',5),(1258,'size','294','1200mm',1),(1259,'size','294','1200mm',2),(1260,'size','294','1200mm',3),(1261,'size','294','1200mm',4),(1262,'size','294','1200mm',5),(1263,'size','295','1400mm',1),(1264,'size','295','1400mm',2),(1265,'size','295','1400mm',3),(1266,'size','295','1400mm',4),(1267,'size','295','1400mm',5),(1268,'size','296','1700mm',1),(1269,'size','296','1700mm',2),(1270,'size','296','1700mm',3),(1271,'size','296','1700mm',4),(1272,'size','296','1700mm',5),(1273,'size','297','500mm',1),(1274,'size','297','500mm',2),(1275,'size','297','500mm',3),(1276,'size','297','500mm',4),(1277,'size','297','500mm',5),(1278,'size','298','520mm',1),(1279,'size','298','520mm',2),(1280,'size','298','520mm',3),(1281,'size','298','520mm',4),(1282,'size','298','520mm',5),(1283,'size','299','530mm',1),(1284,'size','299','530mm',2),(1285,'size','299','530mm',3),(1286,'size','299','530mm',4),(1287,'size','299','530mm',5),(1288,'size','300','550mm',1),(1289,'size','300','550mm',2),(1290,'size','300','550mm',3),(1291,'size','300','550mm',4),(1292,'size','300','550mm',5),(1293,'size','301','580mm',1),(1294,'size','301','580mm',2),(1295,'size','301','580mm',3),(1296,'size','301','580mm',4),(1297,'size','301','580mm',5),(1298,'size','302','590mm',1),(1299,'size','302','590mm',2),(1300,'size','302','590mm',3),(1301,'size','302','590mm',4),(1302,'size','302','590mm',5),(1303,'size','303','600mm',1),(1304,'size','303','600mm',2),(1305,'size','303','600mm',3),(1306,'size','303','600mm',4),(1307,'size','303','600mm',5),(1308,'size','304','700mm',1),(1309,'size','304','700mm',2),(1310,'size','304','700mm',3),(1311,'size','304','700mm',4),(1312,'size','304','700mm',5),(1313,'size','305','750mm',1),(1314,'size','305','750mm',2),(1315,'size','305','750mm',3),(1316,'size','305','750mm',4),(1317,'size','305','750mm',5),(1318,'size','306','800mm',1),(1319,'size','306','800mm',2),(1320,'size','306','800mm',3),(1321,'size','306','800mm',4),(1322,'size','306','800mm',5),(1323,'size','307','830mm',1),(1324,'size','307','830mm',2),(1325,'size','307','830mm',3),(1326,'size','307','830mm',4),(1327,'size','307','830mm',5),(1328,'size','308','850mm',1),(1329,'size','308','850mm',2),(1330,'size','308','850mm',3),(1331,'size','308','850mm',4),(1332,'size','308','850mm',5),(1333,'size','309','870mm',1),(1334,'size','309','870mm',2),(1335,'size','309','870mm',3),(1336,'size','309','870mm',4),(1337,'size','309','870mm',5),(1338,'size','310','890mm',1),(1339,'size','310','890mm',2),(1340,'size','310','890mm',3),(1341,'size','310','890mm',4),(1342,'size','310','890mm',5),(1343,'size','311','900mm',1),(1344,'size','311','900mm',2),(1345,'size','311','900mm',3),(1346,'size','311','900mm',4),(1347,'size','311','900mm',5),(1348,'size','312','12254',1),(1349,'size','312','12254',2),(1350,'size','312','12254',3),(1351,'size','312','12254',4),(1352,'size','312','12254',5),(1353,'size','313','17754',1),(1354,'size','313','17754',2),(1355,'size','313','17754',3),(1356,'size','313','17754',4),(1357,'size','313','17754',5),(1358,'size','314','17691',1),(1359,'size','314','17691',2),(1360,'size','314','17691',3),(1361,'size','314','17691',4),(1362,'size','314','17691',5),(1363,'size','315','10254',1),(1364,'size','315','10254',2),(1365,'size','315','10254',3),(1366,'size','315','10254',4),(1367,'size','315','10254',5),(1368,'cleaning',NULL,'cleaning',1),(1369,'cleaning',NULL,'cleaning',2),(1370,'cleaning',NULL,'cleaning',3),(1371,'cleaning',NULL,'cleaning',4),(1372,'cleaning',NULL,'cleaning',5),(1373,'cleaning','278','easyclean',1),(1374,'cleaning','278','easyclean',2),(1375,'cleaning','278','easyclean',3),(1376,'cleaning','278','easyclean',4),(1377,'cleaning','278','easyclean',5),(1378,'cleaning','279','activeclean',1),(1379,'cleaning','279','activeclean',2),(1380,'cleaning','279','activeclean',3),(1381,'cleaning','279','activeclean',4),(1382,'cleaning','279','activeclean',5),(1383,'cleaning','280','ecoclean',1),(1384,'cleaning','280','ecoclean',2),(1385,'cleaning','280','ecoclean',3),(1386,'cleaning','280','ecoclean',4),(1387,'cleaning','280','ecoclean',5),(1388,'cleaning','281','pyrolytic',1),(1389,'cleaning','281','pyrolytic',2),(1390,'cleaning','281','pyrolytic',3),(1391,'cleaning','281','pyrolytic',4),(1392,'cleaning','281','pyrolytic',5),(1393,'cleaning','282','hydrolytic',1),(1394,'cleaning','282','hydrolytic',2),(1395,'cleaning','282','hydrolytic',3),(1396,'cleaning','282','hydrolytic',4),(1397,'cleaning','282','hydrolytic',5),(1398,'cleaning','283','enamelcoating',1),(1399,'cleaning','283','enamelcoating',2),(1400,'cleaning','283','enamelcoating',3),(1401,'cleaning','283','enamelcoating',4),(1402,'cleaning','283','enamelcoating',5),(1403,'cleaning','284','easycleanenamel',1),(1404,'cleaning','284','easycleanenamel',2),(1405,'cleaning','284','easycleanenamel',3),(1406,'cleaning','284','easycleanenamel',4),(1407,'cleaning','284','easycleanenamel',5),(1408,'heat_output',NULL,'heat_output',1),(1409,'heat_output',NULL,'heat_output',2),(1410,'heat_output',NULL,'heat_output',3),(1411,'heat_output',NULL,'heat_output',4),(1412,'heat_output',NULL,'heat_output',5),(1413,'category_ids',NULL,'category',1),(1414,'category_ids',NULL,'category',2),(1415,'category_ids',NULL,'category',3),(1416,'category_ids',NULL,'category',4),(1417,'category_ids',NULL,'category',5);
/*!40000 ALTER TABLE `mst_seo_filter_rewrite` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mview_state`
--

DROP TABLE IF EXISTS `mview_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `mview_state` (
  `state_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'View State ID',
  `view_id` varchar(255) DEFAULT NULL COMMENT 'View ID',
  `mode` varchar(16) DEFAULT 'disabled' COMMENT 'View Mode',
  `status` varchar(16) DEFAULT 'idle' COMMENT 'View Status',
  `updated` datetime DEFAULT NULL COMMENT 'View updated time',
  `version_id` int unsigned DEFAULT NULL COMMENT 'View Version ID',
  PRIMARY KEY (`state_id`),
  KEY `MVIEW_STATE_VIEW_ID` (`view_id`),
  KEY `MVIEW_STATE_MODE` (`mode`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8mb3 COMMENT='View State';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mview_state`
--

LOCK TABLES `mview_state` WRITE;
/*!40000 ALTER TABLE `mview_state` DISABLE KEYS */;
INSERT INTO `mview_state` VALUES (1,'sales_order_data_exporter','enabled','idle','2025-02-05 07:30:48',33),(2,'sales_order_status_data_exporter','enabled','idle','2025-02-05 07:30:48',12),(3,'store_data_exporter','enabled','idle','2025-02-05 07:30:49',24),(4,'design_config_dummy','enabled','idle','2025-02-05 07:30:36',0),(5,'customer_dummy','enabled','idle','2025-02-05 07:30:36',0),(6,'catalog_category_product','enabled','idle','2025-02-05 07:30:38',10023),(7,'catalog_product_category','enabled','idle','2025-02-05 07:30:38',64895),(8,'catalogrule_rule','enabled','idle','2025-02-05 07:30:38',0),(9,'catalog_product_attribute','enabled','idle','2025-02-05 07:30:39',92907),(10,'cataloginventory_stock','enabled','idle','2025-02-05 07:30:39',35940),(11,'inventory','enabled','idle','2025-02-05 07:30:39',10505),(12,'catalogrule_product','enabled','idle','2025-02-05 07:30:38',151573),(13,'catalog_product_price','enabled','idle','2025-02-05 07:30:41',68240),(14,'catalogsearch_fulltext','enabled','idle','2025-02-05 07:30:48',158258);
/*!40000 ALTER TABLE `mview_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `newsletter_problem`
--

DROP TABLE IF EXISTS `newsletter_problem`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `newsletter_problem` (
  `problem_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Problem ID',
  `subscriber_id` int unsigned DEFAULT NULL COMMENT 'Subscriber ID',
  `queue_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Queue ID',
  `problem_error_code` int unsigned DEFAULT '0' COMMENT 'Problem Error Code',
  `problem_error_text` varchar(200) DEFAULT NULL COMMENT 'Problem Error Text',
  PRIMARY KEY (`problem_id`),
  KEY `NEWSLETTER_PROBLEM_SUBSCRIBER_ID` (`subscriber_id`),
  KEY `NEWSLETTER_PROBLEM_QUEUE_ID` (`queue_id`),
  CONSTRAINT `NEWSLETTER_PROBLEM_QUEUE_ID_NEWSLETTER_QUEUE_QUEUE_ID` FOREIGN KEY (`queue_id`) REFERENCES `newsletter_queue` (`queue_id`) ON DELETE CASCADE,
  CONSTRAINT `NLTTR_PROBLEM_SUBSCRIBER_ID_NLTTR_SUBSCRIBER_SUBSCRIBER_ID` FOREIGN KEY (`subscriber_id`) REFERENCES `newsletter_subscriber` (`subscriber_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Newsletter Problems';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `newsletter_problem`
--

LOCK TABLES `newsletter_problem` WRITE;
/*!40000 ALTER TABLE `newsletter_problem` DISABLE KEYS */;
/*!40000 ALTER TABLE `newsletter_problem` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `newsletter_queue`
--

DROP TABLE IF EXISTS `newsletter_queue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `newsletter_queue` (
  `queue_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Queue ID',
  `template_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Template ID',
  `newsletter_type` int DEFAULT NULL COMMENT 'Newsletter Type',
  `newsletter_text` text COMMENT 'Newsletter Text',
  `newsletter_styles` text COMMENT 'Newsletter Styles',
  `newsletter_subject` varchar(200) DEFAULT NULL COMMENT 'Newsletter Subject',
  `newsletter_sender_name` varchar(200) DEFAULT NULL COMMENT 'Newsletter Sender Name',
  `newsletter_sender_email` varchar(200) DEFAULT NULL COMMENT 'Newsletter Sender Email',
  `queue_status` int unsigned NOT NULL DEFAULT '0' COMMENT 'Queue Status',
  `queue_start_at` timestamp NULL DEFAULT NULL COMMENT 'Queue Start At',
  `queue_finish_at` timestamp NULL DEFAULT NULL COMMENT 'Queue Finish At',
  PRIMARY KEY (`queue_id`),
  KEY `NEWSLETTER_QUEUE_TEMPLATE_ID` (`template_id`),
  CONSTRAINT `NEWSLETTER_QUEUE_TEMPLATE_ID_NEWSLETTER_TEMPLATE_TEMPLATE_ID` FOREIGN KEY (`template_id`) REFERENCES `newsletter_template` (`template_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Newsletter Queue';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `newsletter_queue`
--

LOCK TABLES `newsletter_queue` WRITE;
/*!40000 ALTER TABLE `newsletter_queue` DISABLE KEYS */;
/*!40000 ALTER TABLE `newsletter_queue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `newsletter_queue_link`
--

DROP TABLE IF EXISTS `newsletter_queue_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `newsletter_queue_link` (
  `queue_link_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Queue Link ID',
  `queue_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Queue ID',
  `subscriber_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Subscriber ID',
  `letter_sent_at` timestamp NULL DEFAULT NULL COMMENT 'Letter Sent At',
  PRIMARY KEY (`queue_link_id`),
  KEY `NEWSLETTER_QUEUE_LINK_SUBSCRIBER_ID` (`subscriber_id`),
  KEY `NEWSLETTER_QUEUE_LINK_QUEUE_ID_LETTER_SENT_AT` (`queue_id`,`letter_sent_at`),
  CONSTRAINT `NEWSLETTER_QUEUE_LINK_QUEUE_ID_NEWSLETTER_QUEUE_QUEUE_ID` FOREIGN KEY (`queue_id`) REFERENCES `newsletter_queue` (`queue_id`) ON DELETE CASCADE,
  CONSTRAINT `NLTTR_QUEUE_LNK_SUBSCRIBER_ID_NLTTR_SUBSCRIBER_SUBSCRIBER_ID` FOREIGN KEY (`subscriber_id`) REFERENCES `newsletter_subscriber` (`subscriber_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Newsletter Queue Link';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `newsletter_queue_link`
--

LOCK TABLES `newsletter_queue_link` WRITE;
/*!40000 ALTER TABLE `newsletter_queue_link` DISABLE KEYS */;
/*!40000 ALTER TABLE `newsletter_queue_link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `newsletter_queue_store_link`
--

DROP TABLE IF EXISTS `newsletter_queue_store_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `newsletter_queue_store_link` (
  `queue_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Queue ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  PRIMARY KEY (`queue_id`,`store_id`),
  KEY `NEWSLETTER_QUEUE_STORE_LINK_STORE_ID` (`store_id`),
  CONSTRAINT `NEWSLETTER_QUEUE_STORE_LINK_QUEUE_ID_NEWSLETTER_QUEUE_QUEUE_ID` FOREIGN KEY (`queue_id`) REFERENCES `newsletter_queue` (`queue_id`) ON DELETE CASCADE,
  CONSTRAINT `NEWSLETTER_QUEUE_STORE_LINK_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Newsletter Queue Store Link';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `newsletter_queue_store_link`
--

LOCK TABLES `newsletter_queue_store_link` WRITE;
/*!40000 ALTER TABLE `newsletter_queue_store_link` DISABLE KEYS */;
/*!40000 ALTER TABLE `newsletter_queue_store_link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `newsletter_subscriber`
--

DROP TABLE IF EXISTS `newsletter_subscriber`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `newsletter_subscriber` (
  `subscriber_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Subscriber ID',
  `store_id` smallint unsigned DEFAULT '0' COMMENT 'Store ID',
  `change_status_at` timestamp NULL DEFAULT NULL COMMENT 'Change Status At',
  `customer_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer ID',
  `subscriber_email` varchar(150) DEFAULT NULL COMMENT 'Subscriber Email',
  `subscriber_status` int NOT NULL DEFAULT '0' COMMENT 'Subscriber Status',
  `subscriber_confirm_code` varchar(32) DEFAULT 'NULL' COMMENT 'Subscriber Confirm Code',
  `mp_smtp_email_marketing_synced` smallint DEFAULT '0' COMMENT 'Mp SMTP Email Marketing synced',
  PRIMARY KEY (`subscriber_id`),
  KEY `NEWSLETTER_SUBSCRIBER_CUSTOMER_ID` (`customer_id`),
  KEY `NEWSLETTER_SUBSCRIBER_STORE_ID` (`store_id`),
  KEY `NEWSLETTER_SUBSCRIBER_SUBSCRIBER_EMAIL` (`subscriber_email`),
  CONSTRAINT `NEWSLETTER_SUBSCRIBER_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COMMENT='newsletter_subscriber';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `newsletter_subscriber`
--

LOCK TABLES `newsletter_subscriber` WRITE;
/*!40000 ALTER TABLE `newsletter_subscriber` DISABLE KEYS */;
INSERT INTO `newsletter_subscriber` VALUES (1,1,'2024-08-12 14:02:09',0,'sdfg@gmail.com',1,'5vy9glla5ozrmqfv06ynlxtsclbdblgs',0),(2,1,'2024-08-27 10:51:26',0,'breakdealsdxb@gmail.com',1,'tns7nm19gtzumcvbdqwtavpukythupg0',0),(3,1,'2024-12-23 11:36:43',0,'zohaib.gulfam@nexus-home.com',1,'hmgz1r58t06e4qeew5f6zu8vwfzpu9gy',0);
/*!40000 ALTER TABLE `newsletter_subscriber` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `newsletter_template`
--

DROP TABLE IF EXISTS `newsletter_template`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `newsletter_template` (
  `template_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Template ID',
  `template_code` varchar(150) DEFAULT NULL COMMENT 'Template Code',
  `template_text` text COMMENT 'Template Text',
  `template_styles` text COMMENT 'Template Styles',
  `template_type` int unsigned DEFAULT NULL COMMENT 'Template Type',
  `template_subject` varchar(200) DEFAULT NULL COMMENT 'Template Subject',
  `template_sender_name` varchar(200) DEFAULT NULL COMMENT 'Template Sender Name',
  `template_sender_email` varchar(200) DEFAULT NULL COMMENT 'Template Sender Email',
  `template_actual` smallint unsigned DEFAULT '1' COMMENT 'Template Actual',
  `added_at` timestamp NULL DEFAULT NULL COMMENT 'Added At',
  `modified_at` timestamp NULL DEFAULT NULL COMMENT 'Modified At',
  `is_legacy` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Should the template render in legacy mode',
  PRIMARY KEY (`template_id`),
  KEY `NEWSLETTER_TEMPLATE_TEMPLATE_ACTUAL` (`template_actual`),
  KEY `NEWSLETTER_TEMPLATE_ADDED_AT` (`added_at`),
  KEY `NEWSLETTER_TEMPLATE_MODIFIED_AT` (`modified_at`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Newsletter Template';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `newsletter_template`
--

LOCK TABLES `newsletter_template` WRITE;
/*!40000 ALTER TABLE `newsletter_template` DISABLE KEYS */;
/*!40000 ALTER TABLE `newsletter_template` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oauth_consumer`
--

DROP TABLE IF EXISTS `oauth_consumer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `oauth_consumer` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `name` varchar(255) NOT NULL COMMENT 'Name of consumer',
  `key` varchar(32) NOT NULL COMMENT 'Key code',
  `secret` varchar(128) NOT NULL COMMENT 'Secret code',
  `callback_url` text COMMENT 'Callback URL',
  `rejected_callback_url` text NOT NULL COMMENT 'Rejected callback URL',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `OAUTH_CONSUMER_KEY` (`key`),
  UNIQUE KEY `OAUTH_CONSUMER_SECRET` (`secret`),
  KEY `OAUTH_CONSUMER_CREATED_AT` (`created_at`),
  KEY `OAUTH_CONSUMER_UPDATED_AT` (`updated_at`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='OAuth Consumers';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oauth_consumer`
--

LOCK TABLES `oauth_consumer` WRITE;
/*!40000 ALTER TABLE `oauth_consumer` DISABLE KEYS */;
/*!40000 ALTER TABLE `oauth_consumer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oauth_nonce`
--

DROP TABLE IF EXISTS `oauth_nonce`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `oauth_nonce` (
  `nonce` varchar(32) NOT NULL COMMENT 'Nonce String',
  `timestamp` int unsigned NOT NULL COMMENT 'Nonce Timestamp',
  `consumer_id` int unsigned NOT NULL COMMENT 'Consumer ID',
  PRIMARY KEY (`nonce`,`consumer_id`),
  KEY `OAUTH_NONCE_CONSUMER_ID_OAUTH_CONSUMER_ENTITY_ID` (`consumer_id`),
  KEY `OAUTH_NONCE_TIMESTAMP` (`timestamp`),
  CONSTRAINT `OAUTH_NONCE_CONSUMER_ID_OAUTH_CONSUMER_ENTITY_ID` FOREIGN KEY (`consumer_id`) REFERENCES `oauth_consumer` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='OAuth Nonce';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oauth_nonce`
--

LOCK TABLES `oauth_nonce` WRITE;
/*!40000 ALTER TABLE `oauth_nonce` DISABLE KEYS */;
/*!40000 ALTER TABLE `oauth_nonce` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oauth_token`
--

DROP TABLE IF EXISTS `oauth_token`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `oauth_token` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `consumer_id` int unsigned DEFAULT NULL COMMENT 'Oauth Consumer ID',
  `admin_id` int unsigned DEFAULT NULL COMMENT 'Admin user ID',
  `customer_id` int unsigned DEFAULT NULL COMMENT 'Customer user ID',
  `type` varchar(16) NOT NULL COMMENT 'Token Type',
  `token` varchar(32) NOT NULL COMMENT 'Token',
  `secret` varchar(128) NOT NULL COMMENT 'Token Secret',
  `verifier` varchar(32) DEFAULT NULL COMMENT 'Token Verifier',
  `callback_url` text NOT NULL COMMENT 'Token Callback URL',
  `revoked` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Token revoked',
  `authorized` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Token authorized',
  `user_type` int DEFAULT NULL COMMENT 'User type',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Token creation timestamp',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `OAUTH_TOKEN_TOKEN` (`token`),
  KEY `OAUTH_TOKEN_ADMIN_ID_ADMIN_USER_USER_ID` (`admin_id`),
  KEY `OAUTH_TOKEN_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` (`customer_id`),
  KEY `OAUTH_TOKEN_CONSUMER_ID` (`consumer_id`),
  KEY `OAUTH_TOKEN_CREATED_AT` (`created_at`),
  CONSTRAINT `OAUTH_TOKEN_ADMIN_ID_ADMIN_USER_USER_ID` FOREIGN KEY (`admin_id`) REFERENCES `admin_user` (`user_id`) ON DELETE CASCADE,
  CONSTRAINT `OAUTH_TOKEN_CONSUMER_ID_OAUTH_CONSUMER_ENTITY_ID` FOREIGN KEY (`consumer_id`) REFERENCES `oauth_consumer` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `OAUTH_TOKEN_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='OAuth Tokens';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oauth_token`
--

LOCK TABLES `oauth_token` WRITE;
/*!40000 ALTER TABLE `oauth_token` DISABLE KEYS */;
/*!40000 ALTER TABLE `oauth_token` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `oauth_token_request_log`
--

DROP TABLE IF EXISTS `oauth_token_request_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `oauth_token_request_log` (
  `log_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Log ID',
  `user_name` varchar(255) NOT NULL COMMENT 'Customer email or admin login',
  `user_type` smallint unsigned NOT NULL COMMENT 'User type (admin or customer)',
  `failures_count` smallint unsigned DEFAULT '0' COMMENT 'Number of failed authentication attempts in a row',
  `lock_expires_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Lock expiration time',
  PRIMARY KEY (`log_id`),
  UNIQUE KEY `OAUTH_TOKEN_REQUEST_LOG_USER_NAME_USER_TYPE` (`user_name`,`user_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Log of token request authentication failures.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `oauth_token_request_log`
--

LOCK TABLES `oauth_token_request_log` WRITE;
/*!40000 ALTER TABLE `oauth_token_request_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `oauth_token_request_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pagebuilder_template`
--

DROP TABLE IF EXISTS `pagebuilder_template`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `pagebuilder_template` (
  `template_id` int NOT NULL AUTO_INCREMENT COMMENT 'Template ID Auto Increment',
  `name` varchar(1024) NOT NULL COMMENT 'Template Name',
  `preview_image` varchar(1024) DEFAULT NULL COMMENT 'Template Preview Image',
  `template` longtext NOT NULL COMMENT 'Master Format HTML',
  `created_for` varchar(255) DEFAULT NULL COMMENT 'Created For',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Creation Time',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Update Time',
  PRIMARY KEY (`template_id`),
  FULLTEXT KEY `PAGEBUILDER_TEMPLATE_NAME` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Page Builder Templates';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pagebuilder_template`
--

LOCK TABLES `pagebuilder_template` WRITE;
/*!40000 ALTER TABLE `pagebuilder_template` DISABLE KEYS */;
/*!40000 ALTER TABLE `pagebuilder_template` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `password_reset_request_event`
--

DROP TABLE IF EXISTS `password_reset_request_event`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `password_reset_request_event` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `request_type` smallint unsigned NOT NULL COMMENT 'Type of the event under a security control',
  `account_reference` varchar(255) DEFAULT NULL COMMENT 'An identifier for existing account or another target',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Timestamp when the event occurs',
  `ip` varchar(15) NOT NULL COMMENT 'Remote user IP',
  PRIMARY KEY (`id`),
  KEY `PASSWORD_RESET_REQUEST_EVENT_ACCOUNT_REFERENCE` (`account_reference`),
  KEY `PASSWORD_RESET_REQUEST_EVENT_CREATED_AT` (`created_at`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Password Reset Request Event under a security control';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `password_reset_request_event`
--

LOCK TABLES `password_reset_request_event` WRITE;
/*!40000 ALTER TABLE `password_reset_request_event` DISABLE KEYS */;
/*!40000 ALTER TABLE `password_reset_request_event` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `patch_list`
--

DROP TABLE IF EXISTS `patch_list`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `patch_list` (
  `patch_id` int NOT NULL AUTO_INCREMENT COMMENT 'Patch Auto Increment',
  `patch_name` varchar(1024) NOT NULL COMMENT 'Patch Class Name',
  PRIMARY KEY (`patch_id`)
) ENGINE=InnoDB AUTO_INCREMENT=248 DEFAULT CHARSET=utf8mb3 COMMENT='List of data/schema patches';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `patch_list`
--

LOCK TABLES `patch_list` WRITE;
/*!40000 ALTER TABLE `patch_list` DISABLE KEYS */;
INSERT INTO `patch_list` VALUES (1,'Magento\\Store\\Setup\\Patch\\Schema\\InitializeStoresAndWebsites'),(2,'Magento\\Catalog\\Setup\\Patch\\Schema\\EnableSegmentation'),(3,'Magento\\CatalogRule\\Setup\\Patch\\Schema\\CleanUpProductPriceReplicaTable'),(4,'Magento\\TwoFactorAuth\\Setup\\Patch\\Schema\\CopyTablesFromOldModule'),(5,'Magento\\Bundle\\Setup\\Patch\\Schema\\UpdateBundleRelatedSchema'),(6,'Magento\\InventoryCatalog\\Setup\\Patch\\Schema\\CreateLegacyStockStatusView'),(7,'Magento\\InventoryCatalog\\Setup\\Patch\\Schema\\InitializeDefaultStock'),(8,'Magento\\InventoryCatalog\\Setup\\Patch\\Schema\\UpdateInventorySourceItem'),(9,'Magento\\InventoryCatalog\\Setup\\Patch\\Schema\\ReindexDefaultSource'),(10,'Magento\\InventorySales\\Setup\\Patch\\Schema\\InitializeWebsiteDefaultSock'),(11,'Magento\\Review\\Setup\\Patch\\Schema\\AddUniqueConstraintToReviewEntitySummary'),(12,'Magento\\Store\\Setup\\Patch\\Data\\DisableSid'),(13,'Magento\\Store\\Setup\\Patch\\Data\\UpdateStoreGroupCodes'),(14,'Magento\\Config\\Setup\\Patch\\Data\\RemoveTinymceConfig'),(15,'Magento\\Config\\Setup\\Patch\\Data\\UnsetTinymce3'),(16,'Magento\\Config\\Setup\\Patch\\Data\\UpdateClassAliases'),(17,'Magento\\Directory\\Setup\\Patch\\Data\\InitializeDirectoryData'),(18,'Magento\\Directory\\Setup\\Patch\\Data\\AddCountriesCaribbeanCuracaoKosovoSintMaarten'),(19,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForAlbania'),(20,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForArgentina'),(21,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForCroatia'),(22,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForIndia'),(23,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForAustralia'),(24,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForBelarus'),(25,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForBelgium'),(26,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForBolivia'),(27,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForBulgaria'),(28,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForChile'),(29,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForChina'),(30,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForColombia'),(31,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForCostaRica'),(32,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForCzechia'),(33,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForDenmark'),(34,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForEcuador'),(35,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForGreece'),(36,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForGuyana'),(37,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForIceland'),(38,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForItaly'),(39,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForMexico'),(40,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForParaguay'),(41,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForPeru'),(42,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForPoland'),(43,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForPortugal'),(44,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForSuriname'),(45,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForSweden'),(46,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForUkraine'),(47,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForUruguay'),(48,'Magento\\Directory\\Setup\\Patch\\Data\\AddDataForVenezuela'),(49,'Magento\\Directory\\Setup\\Patch\\Data\\AddRegionsForIndia'),(50,'Magento\\Directory\\Setup\\Patch\\Data\\UpdateRegionNamesForSwitzerland'),(51,'Magento\\Theme\\Setup\\Patch\\Data\\RegisterThemes'),(52,'Magento\\Theme\\Setup\\Patch\\Data\\ConvertSerializedData'),(53,'Magento\\Security\\Setup\\Patch\\Data\\SessionIDColumnCleanUp'),(54,'Magento\\User\\Setup\\Patch\\Data\\UpgradePasswordHashes'),(55,'Magento\\User\\Setup\\Patch\\Data\\UpgradeSerializedFields'),(56,'Magento\\Authorization\\Setup\\Patch\\Data\\InitializeAuthRoles'),(57,'Magento\\Eav\\Setup\\Patch\\Data\\InitializeAttributeModels'),(58,'Magento\\Customer\\Setup\\Patch\\Data\\DefaultCustomerGroupsAndAttributes'),(59,'Magento\\Customer\\Setup\\Patch\\Data\\UpdateCustomerAttributesMetadata'),(60,'Magento\\Customer\\Setup\\Patch\\Data\\AddNonSpecifiedGenderAttributeOption'),(61,'Magento\\Customer\\Setup\\Patch\\Data\\UpdateIdentifierCustomerAttributesVisibility'),(62,'Magento\\Customer\\Setup\\Patch\\Data\\AddCustomerUpdatedAtAttribute'),(63,'Magento\\Customer\\Setup\\Patch\\Data\\UpgradePasswordHashAndAddress'),(64,'Magento\\Customer\\Setup\\Patch\\Data\\RemoveCheckoutRegisterAndUpdateAttributes'),(65,'Magento\\Customer\\Setup\\Patch\\Data\\AddSecurityTrackingAttributes'),(66,'Magento\\Customer\\Setup\\Patch\\Data\\UpdateAutocompleteOnStorefrontConfigPath'),(67,'Magento\\Customer\\Setup\\Patch\\Data\\MigrateStoresAllowedCountriesToWebsite'),(68,'Magento\\Customer\\Setup\\Patch\\Data\\ConvertValidationRulesFromSerializedToJson'),(69,'Magento\\Customer\\Setup\\Patch\\Data\\SessionIDColumnCleanUp'),(70,'Magento\\Customer\\Setup\\Patch\\Data\\UpdateCustomerAddressAttributesSortOrder'),(71,'Magento\\Customer\\Setup\\Patch\\Data\\UpdateVATNumber'),(72,'Magento\\Customer\\Setup\\Patch\\Data\\UpdateCustomerAttributeInputFilters'),(73,'Magento\\Customer\\Setup\\Patch\\Data\\UpdateDefaultCustomerGroupInConfig'),(74,'Magento\\Indexer\\Setup\\Patch\\Data\\InitializeIndexerState'),(75,'Magento\\Cms\\Setup\\Patch\\Data\\CreateDefaultPages'),(76,'Magento\\Cms\\Setup\\Patch\\Data\\UpdatePrivacyPolicyPage'),(77,'Magento\\Cms\\Setup\\Patch\\Data\\ConvertWidgetConditionsToJson'),(78,'Magento\\Integration\\Setup\\Patch\\Data\\RemoveInactiveTokens'),(79,'Magento\\Integration\\Setup\\Patch\\Data\\UpgradeConsumerSecret'),(80,'Magento\\Integration\\Setup\\Patch\\Data\\UpgradeOauthToken'),(81,'Magento\\Catalog\\Setup\\Patch\\Data\\InstallDefaultCategories'),(82,'Magento\\Catalog\\Setup\\Patch\\Data\\SetNewResourceModelsPaths'),(83,'Magento\\Catalog\\Setup\\Patch\\Data\\UpdateDefaultAttributeValue'),(84,'Magento\\Catalog\\Setup\\Patch\\Data\\UpdateMediaAttributesBackendTypes'),(85,'Magento\\Catalog\\Setup\\Patch\\Data\\UpdateProductAttributes'),(86,'Magento\\Catalog\\Setup\\Patch\\Data\\UpdateProductMetaDescription'),(87,'Magento\\Catalog\\Setup\\Patch\\Data\\ChangePriceAttributeDefaultScope'),(88,'Magento\\Catalog\\Setup\\Patch\\Data\\DisallowUsingHtmlForProductName'),(89,'Magento\\Catalog\\Setup\\Patch\\Data\\EnableDirectiveParsing'),(90,'Magento\\Catalog\\Setup\\Patch\\Data\\EnableSegmentation'),(91,'Magento\\Catalog\\Setup\\Patch\\Data\\UpdateCustomLayoutAttributes'),(92,'Magento\\Catalog\\Setup\\Patch\\Data\\UpdateMultiselectAttributesBackendTypes'),(93,'Magento\\Catalog\\Setup\\Patch\\Data\\UpdateProductDescriptionOrder'),(94,'Magento\\CatalogUrlRewrite\\Setup\\Patch\\Data\\CreateUrlAttributes'),(95,'Magento\\Catalog\\Setup\\Patch\\Data\\UpdateProductUrlKey'),(96,'Magento\\Catalog\\Setup\\Patch\\Data\\UpgradeWidgetData'),(97,'Magento\\Catalog\\Setup\\Patch\\Data\\UpgradeWebsiteAttributes'),(98,'Magento\\CatalogInventory\\Setup\\Patch\\Data\\CreateDefaultStock'),(99,'Magento\\CatalogInventory\\Setup\\Patch\\Data\\UpdateStockItemsWebsite'),(100,'Magento\\CatalogInventory\\Setup\\Patch\\Data\\ConvertSerializedDataToJson'),(101,'Magento\\CatalogRule\\Setup\\Patch\\Data\\UpdateClassAliasesForCatalogRules'),(102,'Magento\\CatalogRule\\Setup\\Patch\\Data\\ConvertSerializedDataToJson'),(103,'Magento\\Msrp\\Setup\\Patch\\Data\\InitializeMsrpAttributes'),(104,'Magento\\Msrp\\Setup\\Patch\\Data\\ChangeMsrpAttributeLabel'),(105,'Magento\\Msrp\\Setup\\Patch\\Data\\ChangePriceAttributeDefaultScope'),(106,'Magento\\CatalogSearch\\Setup\\Patch\\Data\\MySQLSearchRemovalNotification'),(107,'Magento\\CatalogSearch\\Setup\\Patch\\Data\\SetInitialSearchWeightForAttributes'),(108,'Magento\\CatalogUrlRewrite\\Setup\\Patch\\Data\\UpdateUrlKeyForProducts'),(109,'Magento\\CatalogUrlRewrite\\Setup\\Patch\\Data\\UpdateUrlKeySearchable'),(110,'Magento\\Quote\\Setup\\Patch\\Data\\InstallEntityTypes'),(111,'Magento\\Quote\\Setup\\Patch\\Data\\ConvertSerializedDataToJson'),(112,'Magento\\Quote\\Setup\\Patch\\Data\\WishlistDataCleanUp'),(113,'Magento\\MediaGalleryUi\\Setup\\Patch\\Data\\AddMediaGalleryPermissions'),(114,'Magento\\TwoFactorAuth\\Setup\\Patch\\Data\\CopyConfigFromOldModule'),(115,'Magento\\TwoFactorAuth\\Setup\\Patch\\Data\\EncryptConfiguration'),(116,'Magento\\TwoFactorAuth\\Setup\\Patch\\Data\\EncryptGoogleSecrets'),(117,'Magento\\TwoFactorAuth\\Setup\\Patch\\Data\\EncryptSecrets'),(118,'Magento\\TwoFactorAuth\\Setup\\Patch\\Data\\GenerateDuoSecurityKey'),(119,'Magento\\TwoFactorAuth\\Setup\\Patch\\Data\\PopulateCountryTable'),(120,'Magento\\TwoFactorAuth\\Setup\\Patch\\Data\\ResetU2fConfig'),(121,'Magento\\Sales\\Setup\\Patch\\Data\\InstallOrderStatusesAndInitialSalesConfig'),(122,'Magento\\Sales\\Setup\\Patch\\Data\\UpdateEntityTypes'),(123,'Magento\\Sales\\Setup\\Patch\\Data\\ConvertSerializedDataToJson'),(124,'Magento\\Sales\\Setup\\Patch\\Data\\FillQuoteAddressIdInSalesOrderAddress'),(125,'Magento\\Sales\\Setup\\Patch\\Data\\UpdateEntityTypeModelForInvoice'),(126,'Magento\\Sales\\Setup\\Patch\\Data\\WishlistDataCleanUp'),(127,'Magento\\Checkout\\Setup\\Patch\\Data\\PrepareInitialCheckoutConfiguration'),(128,'Magento\\Widget\\Setup\\Patch\\Data\\UpgradeModelInstanceClassAliases'),(129,'Magento\\Widget\\Setup\\Patch\\Data\\ConvertSerializedData'),(130,'Magento\\Analytics\\Setup\\Patch\\Data\\PrepareInitialConfig'),(131,'Magento\\Analytics\\Setup\\Patch\\Data\\ActivateDataCollection'),(132,'Magento\\Downloadable\\Setup\\Patch\\Data\\AddDownloadableHostsConfig'),(133,'Magento\\Downloadable\\Setup\\Patch\\Data\\InstallDownloadableAttributes'),(134,'Magento\\Downloadable\\Setup\\Patch\\Data\\UpdateLinksExistDefaultAttributeValue'),(135,'Magento\\Newsletter\\Setup\\Patch\\Data\\FlagLegacyTemplates'),(136,'Magento\\Dhl\\Setup\\Patch\\Data\\PrepareShipmentDays'),(137,'Magento\\Bundle\\Setup\\Patch\\Data\\ApplyAttributesUpdate'),(138,'Magento\\Bundle\\Setup\\Patch\\Data\\UpdateBundleRelatedEntityTypes'),(139,'Magento\\Elasticsearch\\Setup\\Patch\\Data\\InvalidateIndex'),(140,'Magento\\Email\\Setup\\Patch\\Data\\FlagLegacyTemplates'),(141,'Magento\\EncryptionKey\\Setup\\Patch\\Data\\SodiumChachaPatch'),(142,'Magento\\Fedex\\Setup\\Patch\\Data\\ConfigureFedexDefaults'),(143,'Magento\\GiftMessage\\Setup\\Patch\\Data\\AddGiftMessageAttributes'),(144,'Magento\\GiftMessage\\Setup\\Patch\\Data\\MoveGiftMessageToGiftOptionsGroup'),(145,'Magento\\GiftMessage\\Setup\\Patch\\Data\\UpdateGiftMessageAttribute'),(146,'Magento\\GroupedProduct\\Setup\\Patch\\Data\\InitializeGroupedProductLinks'),(147,'Magento\\GroupedProduct\\Setup\\Patch\\Data\\UpdateProductRelations'),(148,'Magento\\ConfigurableProduct\\Setup\\Patch\\Data\\InstallInitialConfigurableAttributes'),(149,'Magento\\ConfigurableProduct\\Setup\\Patch\\Data\\UpdateManufacturerAttribute'),(150,'Magento\\ConfigurableProduct\\Setup\\Patch\\Data\\UpdateTierPriceAttribute'),(151,'Magento\\InventoryLowQuantityNotification\\Setup\\Patch\\Data\\MigrateCatalogInventoryNotifyStockQuantityData'),(152,'Magento\\Reports\\Setup\\Patch\\Data\\InitializeReportEntityTypesAndPages'),(153,'Magento\\Reports\\Setup\\Patch\\Data\\ReportDisableNotification'),(154,'Magento\\SalesRule\\Setup\\Patch\\Data\\PrepareRuleModelSerializedData'),(155,'Magento\\SalesRule\\Setup\\Patch\\Data\\ConvertSerializedDataToJson'),(156,'Magento\\SalesRule\\Setup\\Patch\\Data\\FillSalesRuleProductAttributeTable'),(157,'Magento\\PageBuilder\\Setup\\Patch\\Data\\UpdateProductAttribute'),(158,'Magento\\PageBuilder\\Setup\\Patch\\Data\\UpgradePageBuilderStripStyles'),(159,'Magento\\Vault\\Setup\\Patch\\Data\\SetCreditCardAsDefaultTokenType'),(160,'Magento\\Paypal\\Setup\\Patch\\Data\\AddPaypalOrderStatuses'),(161,'Magento\\Paypal\\Setup\\Patch\\Data\\UpdateBmltoPayLater'),(162,'Magento\\Paypal\\Setup\\Patch\\Data\\UpdatePaypalCreditOption'),(163,'Magento\\Paypal\\Setup\\Patch\\Data\\UpdateSmartButtonLabel'),(164,'Magento\\Paypal\\Setup\\Patch\\Data\\UpdateSmartButtonSize'),(165,'Magento\\ServicesId\\Setup\\Patch\\Data\\RemoveKeySetEncryptedConfigFlag'),(166,'Magento\\ReCaptchaMigration\\Setup\\Patch\\Data\\MigrateConfigToRecaptchaModules'),(167,'Magento\\Review\\Setup\\Patch\\Data\\InitReviewStatusesAndData'),(168,'Magento\\OfflineShipping\\Setup\\Patch\\Data\\UpdateQuoteShippingAddresses'),(169,'Magento\\OfflineShipping\\Setup\\Patch\\Data\\UpdateShippingTablerate'),(170,'Magento\\UrlRewrite\\Setup\\Patch\\Data\\ConvertSerializedDataToJson'),(171,'Magento\\Swatches\\Setup\\Patch\\Data\\AddSwatchImageAttribute'),(172,'Magento\\Swatches\\Setup\\Patch\\Data\\AddSwatchImageToDefaultAttribtueSet'),(173,'Magento\\Swatches\\Setup\\Patch\\Data\\UpdateAdminTextSwatchValues'),(174,'Magento\\Swatches\\Setup\\Patch\\Data\\ConvertAdditionalDataToJson'),(175,'Magento\\Tax\\Setup\\Patch\\Data\\AddTaxAttributeAndTaxClasses'),(176,'Magento\\Tax\\Setup\\Patch\\Data\\UpdateTaxClassAttributeVisibility'),(177,'Magento\\Tax\\Setup\\Patch\\Data\\UpdateTaxRegionId'),(178,'Magento\\SampleData\\Setup\\Patch\\Data\\ClearSampleDataState'),(179,'Magento\\Usps\\Setup\\Patch\\Data\\UpdateAllowedMethods'),(180,'Magento\\Weee\\Setup\\Patch\\Data\\InitQuoteAndOrderAttributes'),(181,'Magento\\CurrencySymbol\\Setup\\Patch\\Data\\ConvertSerializedCustomCurrencySymbolToJson'),(182,'Magento\\Wishlist\\Setup\\Patch\\Data\\ConvertSerializedData'),(183,'Magento\\Wishlist\\Setup\\Patch\\Data\\WishlistDataCleanUp'),(184,'Hyva\\LumaCheckout\\Setup\\Patch\\Data\\AddCustomerAjaxLoginPathFallback'),(185,'Hyva\\LumaCheckout\\Setup\\Patch\\Data\\MigrateConfigSettings'),(187,'UdeyTech\\CategoryHelper\\Setup\\Patch\\Data\\AddKitchenSinksAndBestsellersAttributes'),(188,'UdeyTech\\CategoryHelper\\Setup\\Patch\\Data\\AddCustomCategoryAttribute'),(189,'Amasty\\Base\\Setup\\Patch\\Data\\MoveInstanceAndScheduleFlagData'),(190,'Amasty\\Base\\Setup\\Patch\\Data\\MoveInstanceHashFlagData'),(191,'Amasty\\Base\\Setup\\Patch\\Data\\MoveSystemValuesToFlags'),(192,'Amasty\\Base\\Setup\\Patch\\Data\\RefreshFeedData'),(193,'Amasty\\Base\\Setup\\Patch\\Data\\UpdateCronExpressions'),(194,'Amasty\\Base\\Setup\\Patch\\Data\\UpdateResourceConfigPatch'),(195,'Amasty\\CustomTabs\\Setup\\Patch\\Data\\AddTabAnchors'),(196,'UdeyTech\\CategoryHelper\\Setup\\Patch\\Data\\AddFaqAttribute'),(197,'MageWorx\\ShippingRules\\Setup\\Patch\\Schema\\TransferData260'),(198,'MageWorx\\GeoIP\\Setup\\Patch\\Data\\MoveMaxMindDataToDb'),(199,'MageWorx\\ShippingRules\\Setup\\Patch\\Data\\AddDefaultValuesForDefaultRegions160'),(200,'MageWorx\\ShippingRules\\Setup\\Patch\\Data\\AddShippingPerProductAttributes240'),(201,'MageWorx\\ShippingRules\\Setup\\Patch\\Data\\ConvertSerializedDataToJson'),(202,'MageWorx\\ShippingRules\\Setup\\Patch\\Data\\CreateRatesCodesFromIds207'),(203,'Bss\\FBT\\Setup\\Patch\\Data\\UpdateData'),(204,'Bss\\ProductAttachment\\Setup\\Patch\\Data\\InstallProductAttributeData'),(205,'MageWorx\\ShippingCalculatorBase\\Setup\\Patch\\Data\\AddHideShippingCalculatorAttribute'),(206,'MageWorx\\OptionBase\\Setup\\Patch\\Schema\\DropTrigger'),(207,'MageWorx\\OptionBase\\Setup\\Patch\\Schema\\InstallForeignKey'),(208,'MageWorx\\OptionBase\\Setup\\Patch\\Schema\\RenameProductAttributesTable'),(209,'MageWorx\\OptionBase\\Setup\\Patch\\Schema\\SortTableColumns'),(210,'MageWorx\\OptionFeatures\\Setup\\Patch\\Schema\\SortTableColumns'),(211,'MageWorx\\OptionDependency\\Setup\\Patch\\Schema\\InstallForeignKey'),(212,'MageWorx\\OptionDependency\\Setup\\Patch\\Schema\\InstallOldColumns'),(213,'MageWorx\\OptionDependency\\Setup\\Patch\\Data\\ConvertMageWorxIds'),(214,'MageWorx\\OptionDependency\\Setup\\Patch\\Schema\\MoveOptionIdsDataToNewColumns'),(215,'MageWorx\\OptionDependency\\Setup\\Patch\\Schema\\RemoveUnusedIdColumns'),(216,'MageWorx\\OptionDependency\\Setup\\Patch\\Schema\\SortTableColumns'),(217,'MageWorx\\OptionTemplates\\Setup\\Patch\\Schema\\DropTrigger'),(218,'MageWorx\\OptionTemplates\\Setup\\Patch\\Schema\\SortTableColumns'),(219,'MageWorx\\OptionAdvancedPricing\\Setup\\Patch\\Schema\\SortTableColumns'),(220,'MageWorx\\OptionVisibility\\Setup\\Patch\\Schema\\SortTableColumns'),(221,'HTCMage\\FixAdminEmailTemplate\\Setup\\Patch\\Data\\LegacyColumnChange'),(222,'MageWorx\\OptionFeatures\\Setup\\Patch\\Data\\ConvertMageWorxIds'),(223,'MageWorx\\OptionFeatures\\Setup\\Patch\\Data\\UpdateCoreConfigData'),(224,'MageWorx\\DynamicOptionsBase\\Setup\\Patch\\Data\\AddPricePerUnitAttribute'),(225,'MageWorx\\DynamicOptionsBase\\Setup\\Patch\\Data\\UpdatePricePerUnitAttribute'),(226,'MageWorx\\OptionDependency\\Setup\\Patch\\Data\\UpdateCoreConfigData'),(227,'MageWorx\\OptionDependency\\Setup\\Patch\\Data\\UpdateInitialStatesData'),(228,'MageWorx\\OptionLink\\Setup\\Patch\\Data\\UpdateCoreConfigData'),(229,'MageWorx\\OptionLink\\Setup\\Patch\\Data\\UpdateSkuIsValidData'),(230,'MageWorx\\OptionTemplates\\Setup\\Patch\\Data\\UpdateCoreConfigData'),(231,'MageWorx\\OptionInventory\\Setup\\Patch\\Data\\UpdateCoreConfigData'),(232,'MageWorx\\OptionAdvancedPricing\\Setup\\Patch\\Data\\ConvertMageWorxIds'),(233,'MageWorx\\OptionSwatches\\Setup\\Patch\\Data\\UpdateSwatchSize'),(234,'MageWorx\\OptionVisibility\\Setup\\Patch\\Data\\ConvertMageWorxIds'),(235,'Mageplaza\\Smtp\\Setup\\Patch\\Data\\UpgradeAttributeData'),(236,'Mirasvit\\Core\\Setup\\Patch\\Data\\IncludeFontAwesome'),(237,'Mirasvit\\Brand\\Setup\\Patch\\Data\\MigrateBrandsPatch'),(238,'MageWorx\\OptionDependency\\Setup\\Patch\\Data\\UpdatingDependencyRuleAccordingToNewLogicPatch'),(239,'MageWorx\\OptionHealthChecker\\Setup\\Patch\\Data\\DataCleaner'),(240,'Magefan\\Community\\Setup\\Patch\\Data\\UpdateWelcomeBlogPost'),(241,'Mollie\\Payment\\Setup\\Patch\\Data\\ChangeSecondChanceEmailTemplatePath'),(242,'Mollie\\Payment\\Setup\\Patch\\Data\\EncryptApiKeys'),(243,'Mollie\\Payment\\Setup\\Patch\\Data\\EncryptFallbackKeys'),(244,'Mollie\\Payment\\Setup\\Patch\\Data\\RemoveBitcoinConfiguration'),(245,'Mollie\\Payment\\Setup\\Patch\\Data\\RemoveInghomepayConfiguration'),(246,'Mollie\\Payment\\Setup\\Patch\\Data\\RenameMealVoucherToVoucher'),(247,'Mollie\\Payment\\Setup\\Patch\\Data\\UpdateCustomerReturnUrl');
/*!40000 ALTER TABLE `patch_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `payment_gateway_wallets`
--

DROP TABLE IF EXISTS `payment_gateway_wallets`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `payment_gateway_wallets` (
  `merchant_id` text NOT NULL COMMENT 'Merchant ID',
  `customer_email` varchar(100) NOT NULL COMMENT 'Customer email',
  `wallet_id` varchar(100) NOT NULL COMMENT 'Wallet Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Payment Gateway Wallets Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `payment_gateway_wallets`
--

LOCK TABLES `payment_gateway_wallets` WRITE;
/*!40000 ALTER TABLE `payment_gateway_wallets` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_gateway_wallets` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `payment_services_order_data_production_submitted_hash`
--

DROP TABLE IF EXISTS `payment_services_order_data_production_submitted_hash`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `payment_services_order_data_production_submitted_hash` (
  `identifier` varchar(64) NOT NULL COMMENT 'Order identifier',
  `feed_hash` varchar(64) NOT NULL COMMENT 'feed_hash',
  `submitted_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Submitted At',
  PRIMARY KEY (`identifier`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Payment Services Order Feed Storage';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `payment_services_order_data_production_submitted_hash`
--

LOCK TABLES `payment_services_order_data_production_submitted_hash` WRITE;
/*!40000 ALTER TABLE `payment_services_order_data_production_submitted_hash` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_services_order_data_production_submitted_hash` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `payment_services_order_data_sandbox_submitted_hash`
--

DROP TABLE IF EXISTS `payment_services_order_data_sandbox_submitted_hash`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `payment_services_order_data_sandbox_submitted_hash` (
  `identifier` varchar(64) NOT NULL COMMENT 'Order identifier',
  `feed_hash` varchar(64) NOT NULL COMMENT 'feed_hash',
  `submitted_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Submitted At',
  PRIMARY KEY (`identifier`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Payment Services Order Feed Storage';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `payment_services_order_data_sandbox_submitted_hash`
--

LOCK TABLES `payment_services_order_data_sandbox_submitted_hash` WRITE;
/*!40000 ALTER TABLE `payment_services_order_data_sandbox_submitted_hash` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_services_order_data_sandbox_submitted_hash` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `payment_services_order_status_data_prod_submitted_hash`
--

DROP TABLE IF EXISTS `payment_services_order_status_data_prod_submitted_hash`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `payment_services_order_status_data_prod_submitted_hash` (
  `identifier` varchar(64) NOT NULL COMMENT 'Order Status identifier',
  `feed_hash` varchar(64) NOT NULL COMMENT 'feed_hash',
  `submitted_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Submitted At',
  PRIMARY KEY (`identifier`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Payment Services Order Status Feed Storage';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `payment_services_order_status_data_prod_submitted_hash`
--

LOCK TABLES `payment_services_order_status_data_prod_submitted_hash` WRITE;
/*!40000 ALTER TABLE `payment_services_order_status_data_prod_submitted_hash` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_services_order_status_data_prod_submitted_hash` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `payment_services_order_status_data_sandbox_submitted_hash`
--

DROP TABLE IF EXISTS `payment_services_order_status_data_sandbox_submitted_hash`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `payment_services_order_status_data_sandbox_submitted_hash` (
  `identifier` varchar(64) NOT NULL COMMENT 'Order Status identifier',
  `feed_hash` varchar(64) NOT NULL COMMENT 'feed_hash',
  `submitted_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Submitted At',
  PRIMARY KEY (`identifier`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Payment Services Order Status Feed Storage';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `payment_services_order_status_data_sandbox_submitted_hash`
--

LOCK TABLES `payment_services_order_status_data_sandbox_submitted_hash` WRITE;
/*!40000 ALTER TABLE `payment_services_order_status_data_sandbox_submitted_hash` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_services_order_status_data_sandbox_submitted_hash` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `payment_services_store_data_production_submitted_hash`
--

DROP TABLE IF EXISTS `payment_services_store_data_production_submitted_hash`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `payment_services_store_data_production_submitted_hash` (
  `identifier` varchar(64) NOT NULL COMMENT 'Store identifier',
  `feed_hash` varchar(64) NOT NULL COMMENT 'feed_hash',
  `submitted_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Submitted At',
  PRIMARY KEY (`identifier`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Payment Services Store Feed Storage';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `payment_services_store_data_production_submitted_hash`
--

LOCK TABLES `payment_services_store_data_production_submitted_hash` WRITE;
/*!40000 ALTER TABLE `payment_services_store_data_production_submitted_hash` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_services_store_data_production_submitted_hash` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `payment_services_store_data_sandbox_submitted_hash`
--

DROP TABLE IF EXISTS `payment_services_store_data_sandbox_submitted_hash`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `payment_services_store_data_sandbox_submitted_hash` (
  `identifier` varchar(64) NOT NULL COMMENT 'Store identifier',
  `feed_hash` varchar(64) NOT NULL COMMENT 'feed_hash',
  `submitted_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Submitted At',
  PRIMARY KEY (`identifier`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Payment Services Store Feed Storage';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `payment_services_store_data_sandbox_submitted_hash`
--

LOCK TABLES `payment_services_store_data_sandbox_submitted_hash` WRITE;
/*!40000 ALTER TABLE `payment_services_store_data_sandbox_submitted_hash` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_services_store_data_sandbox_submitted_hash` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `paypal_billing_agreement`
--

DROP TABLE IF EXISTS `paypal_billing_agreement`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `paypal_billing_agreement` (
  `agreement_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Agreement ID',
  `customer_id` int unsigned NOT NULL COMMENT 'Customer ID',
  `method_code` varchar(32) NOT NULL COMMENT 'Method Code',
  `reference_id` varchar(32) NOT NULL COMMENT 'Reference ID',
  `status` varchar(20) NOT NULL COMMENT 'Status',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `agreement_label` varchar(255) DEFAULT NULL COMMENT 'Agreement Label',
  PRIMARY KEY (`agreement_id`),
  KEY `PAYPAL_BILLING_AGREEMENT_CUSTOMER_ID` (`customer_id`),
  KEY `PAYPAL_BILLING_AGREEMENT_STORE_ID` (`store_id`),
  CONSTRAINT `PAYPAL_BILLING_AGREEMENT_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `PAYPAL_BILLING_AGREEMENT_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Billing Agreement';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `paypal_billing_agreement`
--

LOCK TABLES `paypal_billing_agreement` WRITE;
/*!40000 ALTER TABLE `paypal_billing_agreement` DISABLE KEYS */;
/*!40000 ALTER TABLE `paypal_billing_agreement` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `paypal_billing_agreement_order`
--

DROP TABLE IF EXISTS `paypal_billing_agreement_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `paypal_billing_agreement_order` (
  `agreement_id` int unsigned NOT NULL COMMENT 'Agreement ID',
  `order_id` int unsigned NOT NULL COMMENT 'Order ID',
  PRIMARY KEY (`agreement_id`,`order_id`),
  KEY `PAYPAL_BILLING_AGREEMENT_ORDER_ORDER_ID` (`order_id`),
  CONSTRAINT `PAYPAL_BILLING_AGREEMENT_ORDER_ORDER_ID_SALES_ORDER_ENTITY_ID` FOREIGN KEY (`order_id`) REFERENCES `sales_order` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `PAYPAL_BILLING_AGRT_ORDER_AGRT_ID_PAYPAL_BILLING_AGRT_AGRT_ID` FOREIGN KEY (`agreement_id`) REFERENCES `paypal_billing_agreement` (`agreement_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Billing Agreement Order';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `paypal_billing_agreement_order`
--

LOCK TABLES `paypal_billing_agreement_order` WRITE;
/*!40000 ALTER TABLE `paypal_billing_agreement_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `paypal_billing_agreement_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `paypal_cert`
--

DROP TABLE IF EXISTS `paypal_cert`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `paypal_cert` (
  `cert_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Cert ID',
  `website_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID',
  `content` text COMMENT 'Content',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  PRIMARY KEY (`cert_id`),
  KEY `PAYPAL_CERT_WEBSITE_ID` (`website_id`),
  CONSTRAINT `PAYPAL_CERT_WEBSITE_ID_STORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Paypal Certificate Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `paypal_cert`
--

LOCK TABLES `paypal_cert` WRITE;
/*!40000 ALTER TABLE `paypal_cert` DISABLE KEYS */;
/*!40000 ALTER TABLE `paypal_cert` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `paypal_payment_transaction`
--

DROP TABLE IF EXISTS `paypal_payment_transaction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `paypal_payment_transaction` (
  `transaction_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `txn_id` varchar(100) DEFAULT NULL COMMENT 'Txn ID',
  `additional_information` blob COMMENT 'Additional Information',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  PRIMARY KEY (`transaction_id`),
  UNIQUE KEY `PAYPAL_PAYMENT_TRANSACTION_TXN_ID` (`txn_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='PayPal Payflow Link Payment Transaction';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `paypal_payment_transaction`
--

LOCK TABLES `paypal_payment_transaction` WRITE;
/*!40000 ALTER TABLE `paypal_payment_transaction` DISABLE KEYS */;
/*!40000 ALTER TABLE `paypal_payment_transaction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `paypal_settlement_report`
--

DROP TABLE IF EXISTS `paypal_settlement_report`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `paypal_settlement_report` (
  `report_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Report ID',
  `report_date` date DEFAULT NULL COMMENT 'Report Date',
  `account_id` varchar(64) DEFAULT NULL COMMENT 'Account ID',
  `filename` varchar(24) DEFAULT NULL COMMENT 'Filename',
  `last_modified` timestamp NULL DEFAULT NULL COMMENT 'Last Modified',
  PRIMARY KEY (`report_id`),
  UNIQUE KEY `PAYPAL_SETTLEMENT_REPORT_REPORT_DATE_ACCOUNT_ID` (`report_date`,`account_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Paypal Settlement Report Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `paypal_settlement_report`
--

LOCK TABLES `paypal_settlement_report` WRITE;
/*!40000 ALTER TABLE `paypal_settlement_report` DISABLE KEYS */;
/*!40000 ALTER TABLE `paypal_settlement_report` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `paypal_settlement_report_row`
--

DROP TABLE IF EXISTS `paypal_settlement_report_row`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `paypal_settlement_report_row` (
  `row_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Row ID',
  `report_id` int unsigned NOT NULL COMMENT 'Report ID',
  `transaction_id` varchar(19) DEFAULT NULL COMMENT 'Transaction ID',
  `invoice_id` varchar(127) DEFAULT NULL COMMENT 'Invoice ID',
  `paypal_reference_id` varchar(19) DEFAULT NULL COMMENT 'Paypal Reference ID',
  `paypal_reference_id_type` varchar(3) DEFAULT NULL COMMENT 'Paypal Reference ID Type',
  `transaction_event_code` varchar(5) DEFAULT NULL COMMENT 'Transaction Event Code',
  `transaction_initiation_date` timestamp NULL DEFAULT NULL COMMENT 'Transaction Initiation Date',
  `transaction_completion_date` timestamp NULL DEFAULT NULL COMMENT 'Transaction Completion Date',
  `transaction_debit_or_credit` varchar(2) NOT NULL DEFAULT 'CR' COMMENT 'Transaction Debit Or Credit',
  `gross_transaction_amount` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Gross Transaction Amount',
  `gross_transaction_currency` varchar(3) DEFAULT NULL COMMENT 'Gross Transaction Currency',
  `fee_debit_or_credit` varchar(2) DEFAULT NULL COMMENT 'Fee Debit Or Credit',
  `fee_amount` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Fee Amount',
  `fee_currency` varchar(3) DEFAULT NULL COMMENT 'Fee Currency',
  `custom_field` varchar(255) DEFAULT NULL COMMENT 'Custom Field',
  `consumer_id` varchar(127) DEFAULT NULL COMMENT 'Consumer ID',
  `payment_tracking_id` varchar(255) DEFAULT NULL COMMENT 'Payment Tracking ID',
  `store_id` varchar(50) DEFAULT NULL COMMENT 'Store ID',
  PRIMARY KEY (`row_id`),
  KEY `PAYPAL_SETTLEMENT_REPORT_ROW_REPORT_ID` (`report_id`),
  CONSTRAINT `FK_E183E488F593E0DE10C6EBFFEBAC9B55` FOREIGN KEY (`report_id`) REFERENCES `paypal_settlement_report` (`report_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Paypal Settlement Report Row Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `paypal_settlement_report_row`
--

LOCK TABLES `paypal_settlement_report_row` WRITE;
/*!40000 ALTER TABLE `paypal_settlement_report_row` DISABLE KEYS */;
/*!40000 ALTER TABLE `paypal_settlement_report_row` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `persistent_session`
--

DROP TABLE IF EXISTS `persistent_session`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `persistent_session` (
  `persistent_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Session ID',
  `key` varchar(50) NOT NULL COMMENT 'Unique cookie key',
  `customer_id` int unsigned DEFAULT NULL COMMENT 'Customer ID',
  `website_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID',
  `info` text COMMENT 'Session Data',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  PRIMARY KEY (`persistent_id`),
  UNIQUE KEY `PERSISTENT_SESSION_KEY` (`key`),
  UNIQUE KEY `PERSISTENT_SESSION_CUSTOMER_ID` (`customer_id`),
  KEY `PERSISTENT_SESSION_WEBSITE_ID_STORE_WEBSITE_WEBSITE_ID` (`website_id`),
  KEY `PERSISTENT_SESSION_UPDATED_AT` (`updated_at`),
  CONSTRAINT `PERSISTENT_SESSION_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `PERSISTENT_SESSION_WEBSITE_ID_STORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Persistent Session';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `persistent_session`
--

LOCK TABLES `persistent_session` WRITE;
/*!40000 ALTER TABLE `persistent_session` DISABLE KEYS */;
/*!40000 ALTER TABLE `persistent_session` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_alert_price`
--

DROP TABLE IF EXISTS `product_alert_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `product_alert_price` (
  `alert_price_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Product alert price ID',
  `customer_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `price` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Price amount',
  `website_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID',
  `store_id` smallint unsigned DEFAULT '0' COMMENT 'Store ID',
  `add_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Product alert add date',
  `last_send_date` timestamp NULL DEFAULT NULL COMMENT 'Product alert last send date',
  `send_count` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Product alert send count',
  `status` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Product alert status',
  PRIMARY KEY (`alert_price_id`),
  KEY `PRODUCT_ALERT_PRICE_CUSTOMER_ID` (`customer_id`),
  KEY `PRODUCT_ALERT_PRICE_PRODUCT_ID` (`product_id`),
  KEY `PRODUCT_ALERT_PRICE_WEBSITE_ID` (`website_id`),
  KEY `PRODUCT_ALERT_PRICE_STORE_ID` (`store_id`),
  CONSTRAINT `PRODUCT_ALERT_PRICE_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `PRODUCT_ALERT_PRICE_PRODUCT_ID_CATALOG_PRODUCT_ENTITY_ENTITY_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `PRODUCT_ALERT_PRICE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `PRODUCT_ALERT_PRICE_WEBSITE_ID_STORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Product Alert Price';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `product_alert_price`
--

LOCK TABLES `product_alert_price` WRITE;
/*!40000 ALTER TABLE `product_alert_price` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_alert_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_alert_stock`
--

DROP TABLE IF EXISTS `product_alert_stock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `product_alert_stock` (
  `alert_stock_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Product alert stock ID',
  `customer_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `website_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID',
  `store_id` smallint unsigned DEFAULT '0' COMMENT 'Store ID',
  `add_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Product alert add date',
  `send_date` timestamp NULL DEFAULT NULL COMMENT 'Product alert send date',
  `send_count` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Send Count',
  `status` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Product alert status',
  PRIMARY KEY (`alert_stock_id`),
  KEY `PRODUCT_ALERT_STOCK_CUSTOMER_ID` (`customer_id`),
  KEY `PRODUCT_ALERT_STOCK_PRODUCT_ID` (`product_id`),
  KEY `PRODUCT_ALERT_STOCK_WEBSITE_ID` (`website_id`),
  KEY `PRODUCT_ALERT_STOCK_STORE_ID` (`store_id`),
  CONSTRAINT `PRODUCT_ALERT_STOCK_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `PRODUCT_ALERT_STOCK_PRODUCT_ID_CATALOG_PRODUCT_ENTITY_ENTITY_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `PRODUCT_ALERT_STOCK_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `PRODUCT_ALERT_STOCK_WEBSITE_ID_STORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Product Alert Stock';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `product_alert_stock`
--

LOCK TABLES `product_alert_stock` WRITE;
/*!40000 ALTER TABLE `product_alert_stock` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_alert_stock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `queue`
--

DROP TABLE IF EXISTS `queue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `queue` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Queue ID',
  `name` varchar(255) DEFAULT NULL COMMENT 'Queue name',
  PRIMARY KEY (`id`),
  UNIQUE KEY `QUEUE_NAME` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=23 DEFAULT CHARSET=utf8mb3 COMMENT='Table storing unique queues';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `queue`
--

LOCK TABLES `queue` WRITE;
/*!40000 ALTER TABLE `queue` DISABLE KEYS */;
INSERT INTO `queue` VALUES (21,'async.operations.all'),(4,'catalog_website_attribute_value_sync'),(17,'codegenerator'),(6,'export'),(12,'inventory.indexer.sourceItem'),(13,'inventory.indexer.stock'),(8,'inventory.mass.update'),(9,'inventory.reservations.cleanup'),(10,'inventory.reservations.update'),(11,'inventory.reservations.updateSalabilityStatus'),(7,'inventory.source.items.cleanup'),(14,'media.content.synchronization'),(15,'media.gallery.renditions.update'),(16,'media.gallery.synchronization'),(5,'media.storage.catalog.image.resize'),(22,'mollie.transaction.processor'),(2,'product_action_attribute.update'),(3,'product_action_attribute.website.update'),(20,'product_alert.queue'),(19,'sales.rule.quote.trigger.recollect'),(18,'sales.rule.update.coupon.usage'),(1,'saveConfig');
/*!40000 ALTER TABLE `queue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `queue_lock`
--

DROP TABLE IF EXISTS `queue_lock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `queue_lock` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Message ID',
  `message_code` varchar(255) NOT NULL DEFAULT '' COMMENT 'Message Code',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Created At',
  PRIMARY KEY (`id`),
  UNIQUE KEY `QUEUE_LOCK_MESSAGE_CODE` (`message_code`)
) ENGINE=InnoDB AUTO_INCREMENT=4478 DEFAULT CHARSET=utf8mb3 COMMENT='Messages that were processed are inserted here to be locked.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `queue_lock`
--

LOCK TABLES `queue_lock` WRITE;
/*!40000 ALTER TABLE `queue_lock` DISABLE KEYS */;
INSERT INTO `queue_lock` VALUES (1,'df236a2a08d27cd4405ebc06b709a8cc','2025-02-04 10:01:29'),(2,'cd5a83f103a559fddecc21fbd5807014','2025-02-04 10:01:30'),(13,'74c5440da1642389642cbc6630ab31b3','2025-02-04 10:01:31'),(16,'4936819684a5677508367b89a3c74a7e','2025-02-04 10:01:31'),(19,'2db225fbad56b53c06792c08b03a90e9','2025-02-04 10:01:31'),(21,'5a3775ac7a615ee7650cd8ff5f78fa09','2025-02-04 10:01:31'),(22,'4547f2d839c376880c672a097e03776d','2025-02-04 10:01:31'),(25,'2296c44df1e2bbb07f25d4a3ebfd68fa','2025-02-04 10:01:31'),(27,'54605e40b7332af9c4fbd6945b149bcb','2025-02-04 10:01:31'),(29,'a89007a28fcb9e104c10f2e635d52398','2025-02-04 10:01:31'),(30,'59eff25eb730556df415c3fd2c1efb3f','2025-02-04 10:01:31'),(33,'8b3b1df13bb6a0701a181ca1dc4b954f','2025-02-04 10:01:31'),(34,'a2f92eddf410afe1ae5f20d4e62dc63c','2025-02-04 10:01:31'),(36,'23d09ce4846596863161db3d45745b12','2025-02-04 10:01:31'),(39,'cbfb3115059c60cc75d686e93cc8a8f8','2025-02-04 10:01:31'),(41,'be2461ff82d79378e95a07c4433b0dbb','2025-02-04 10:01:31'),(42,'db003c09125ec8e046698e9dec66cfd5','2025-02-04 10:01:31'),(44,'f59facbfdfacdfa41e326c2eab5264c3','2025-02-04 10:01:31'),(46,'6ae9e06f9ad1e40325df57d41cd95f8e','2025-02-04 10:01:32'),(48,'a70a65be80374b4682c4c865cefc9f14','2025-02-04 10:01:32'),(51,'3c627d6314cffc81efa02a0b99ca5303','2025-02-04 10:01:32'),(54,'963f82cf7c5448fbd557fc1f8ce82032','2025-02-04 10:01:32'),(56,'df3890b37164eb7e58e07f94fffa0132','2025-02-04 10:01:32'),(60,'f9dd4113ef828d21b6cec61e27dc1edf','2025-02-04 10:01:32'),(61,'8f776323160bb9c8c65ef875833c83cd','2025-02-04 10:01:32'),(62,'8f8417b5a4eb0d71ebdeca627bf5b1e1','2025-02-04 10:01:32'),(63,'ea4fa57821a7cfccb5d96499579ea24a','2025-02-04 10:01:32'),(64,'d2a286ad6d6743e8e459a4fe276b9859','2025-02-04 10:01:32'),(65,'f3a9c4d5870be7e52fe2188ace325fad','2025-02-04 10:01:32'),(66,'31ae3a328f18ec6bc5c152018e1a45ed','2025-02-04 10:01:32'),(67,'e464fa67893d5722ef3420c19804eb04','2025-02-04 10:01:32'),(68,'decf1aa29b5c00c8970c04fe97c0d4e8','2025-02-04 10:01:32'),(69,'f2f286d2f99a014a89d6e4350fa2defa','2025-02-04 10:01:32'),(70,'15013a20f4a420e663158cd367027e4e','2025-02-04 10:01:33'),(71,'0439509367e85bc859065e263bd32fff','2025-02-04 10:01:33'),(72,'eb79fee708654cd2c9e7fb0f09aed743','2025-02-04 10:01:33'),(73,'ac57afb1bd79dc379cae760a68391eee','2025-02-04 10:01:33'),(74,'120bf2636d5892055f7619cf36a528c4','2025-02-04 10:01:33'),(75,'97865c674c6187c557d71cebf5738335','2025-02-04 10:01:33'),(76,'a25da426e3898a5a6a7dd2d643a8d007','2025-02-04 10:01:33'),(77,'5454073f5e0e1dc99d82cd332dc4f55b','2025-02-04 10:01:33'),(78,'78add86e043035e86f7f0d867a214298','2025-02-04 10:01:33'),(79,'0144711b022e30a4c502414d421dd6a5','2025-02-04 10:01:33'),(80,'5565fe7c9b910f9f6af1a51a0e7d39da','2025-02-04 10:01:33'),(81,'4df8b9367c22d6ebe703ea56aa4a5aa3','2025-02-04 10:01:33'),(82,'123abff71637356c6231e65998eb3ab7','2025-02-04 10:01:33'),(83,'1b82de231c0e81bbd17e0fa5ee458edd','2025-02-04 10:01:33'),(84,'a253c4995a44ae95defee626d16df901','2025-02-04 10:01:33'),(85,'5c329b51e0e177b2411f618c75bf0e14','2025-02-04 10:01:33'),(86,'78fb5c9c63214832ac5dccf4f94389e2','2025-02-04 10:01:33'),(87,'96a44b0d4c94170e3f2ba7ee15f5f564','2025-02-04 10:01:33'),(88,'ec1b1a1e406c474110482f5540fb2508','2025-02-04 10:01:33'),(89,'a4140c10f5bb0453c167acb23ed77019','2025-02-04 10:01:33'),(90,'a7bed77daf268ee6242c0f7eba7b09ad','2025-02-04 10:01:34'),(91,'d283b661e29f2cf59e5de6ca1f43f657','2025-02-04 10:01:34'),(92,'2ecfb158f13ef6b28e69737a6943c0d6','2025-02-04 10:01:34'),(93,'35a8fe5adbfbfaadecf5b8359d8e07c8','2025-02-04 10:01:34'),(94,'dbe79f38d221da38a9381d76e7d2a1c8','2025-02-04 10:01:34'),(95,'b9998be2917608e1c7e498993520deae','2025-02-04 10:01:34'),(96,'842c2f501fe5b2cbad5ee85714661d66','2025-02-04 10:01:34'),(97,'a82edd89ea0e6d651fff8f37ec1b89f3','2025-02-04 10:01:34'),(98,'10dff6d9aa750dafa818a9a78ba85a6c','2025-02-04 10:01:34'),(99,'c7c9b52e2d476742a0c9ac71031c6e9c','2025-02-04 10:01:34'),(100,'469156650024ffda1eeb20a8dfed626f','2025-02-04 10:01:34'),(101,'52236bc4dbb14e21aeb64fbf365277dc','2025-02-04 10:01:34'),(102,'fe9da55b32510e412af7e94ffbe022ba','2025-02-04 10:01:34'),(103,'ae89e6a488ae382d66743f7542366a80','2025-02-04 10:01:34'),(104,'be14c737f10d3e26c2f50f907db0478d','2025-02-04 10:01:34'),(105,'ccd53107443ce3db856c1a00868405a1','2025-02-04 10:01:34'),(106,'1c38e871139066a5192264c2d8d2155d','2025-02-04 10:01:34'),(107,'0808a3e0865e40419425b2401fae2828','2025-02-04 10:01:34'),(108,'cc4713dbb2e6270d03fed3843cf485c7','2025-02-04 10:01:35'),(109,'99a01195c8fb976ec5464c4e4d35f060','2025-02-04 10:01:35'),(110,'2cbb74373e4db1e00822cce26c71bc59','2025-02-04 10:01:35'),(111,'382d517112297fcab345ee9bdbca32bc','2025-02-04 10:01:35'),(112,'4c98fe088e044ccf46db0ebcf3453c82','2025-02-04 10:01:35'),(113,'90d6c92ca39a832310939abb3ddf27d4','2025-02-04 10:01:35'),(114,'685e3313069ec71b922e4139a1b6e041','2025-02-04 10:01:35'),(115,'523bfc6d9190b87140a8140668e6a808','2025-02-04 10:01:35'),(116,'55bc5d0c10136bf905bb8ee88c906ba4','2025-02-04 10:01:35'),(117,'71624ce16de133c7fc733cb3423a45fb','2025-02-04 10:01:35'),(118,'e251f25117abcd1d79b69083cbf02dc8','2025-02-04 10:01:35'),(119,'b84491e4260e361457c2f6cf3dc322f9','2025-02-04 10:01:35'),(120,'7ff0df259a5cc1ad0fb7b76fb83f5d24','2025-02-04 10:01:36'),(121,'212c3f286aa84e9429773fc47b4f5e4c','2025-02-04 10:01:36'),(122,'d29c01e29bb1b7f41842ca1193f021f0','2025-02-04 10:01:36'),(123,'534edd25c39ded7695090d1ecb188398','2025-02-04 10:01:36'),(124,'75a0a8bebed4c81eb3d7c7b397eb4104','2025-02-04 10:01:36'),(125,'c3ec96f2868c39965c6cf4157b61dd58','2025-02-04 10:01:36'),(126,'bd965dc86e38930d87541b446ec54162','2025-02-04 10:01:36'),(127,'32f6f7138800739a401e9ecae9b994fd','2025-02-04 10:01:36'),(128,'9c36ba5b93814d0870c3da4fd00bf4fa','2025-02-04 10:01:37'),(129,'9cd3e9eedbc9dad70535c8c3c04d1f52','2025-02-04 10:01:37'),(130,'5eb1b721e0f22115270d6e55727aa96d','2025-02-04 10:01:37'),(131,'02e629ed38c3f732ebfb78432eb45307','2025-02-04 10:01:37'),(132,'b99a754344b1e90144d474db76fdd665','2025-02-04 10:01:37'),(133,'f264162733f56e3196c2b8f438d2b6eb','2025-02-04 10:01:37'),(134,'4c16012305a26d952cdbb08dc89d6217','2025-02-04 10:01:37'),(135,'145bcf1b3ae17fe57c6abf6da4f05f20','2025-02-04 10:01:37'),(136,'b8383ae47ec659aee45632905db56ba8','2025-02-04 10:01:37'),(137,'11bb97f38da99af6952334ba8a308ddc','2025-02-04 10:01:37'),(138,'5092222689bf31a8e090dce6d2e0c4e0','2025-02-04 10:01:38'),(139,'ef4aaa42407dfee1ed1aeb7f530e9a24','2025-02-04 10:01:38'),(140,'ced00cd627b382347cf9cea66c18bdca','2025-02-04 10:01:38'),(141,'2d31761637c0d97acd5416ac495b53cb','2025-02-04 10:01:38'),(142,'27677d24e4e8b7f2ff5b11e927b4a51d','2025-02-04 10:01:38'),(143,'c12fd119bb991e4f88a35f75729a8c83','2025-02-04 10:01:38'),(144,'6518e2463a9619809f2e8cf78a5dd543','2025-02-04 10:01:38'),(145,'09a2c81fe4a2c93d17016d089adbf55a','2025-02-04 10:01:38'),(146,'bb425652f1c2db5f10359131d35c54e5','2025-02-04 10:01:38'),(147,'ff959b1942124b006306368b8895fd2a','2025-02-04 10:01:38'),(148,'52fe3fb0ab16222b51ada9ceefc2ed18','2025-02-04 10:01:38'),(149,'78b321fb2097668fc20854c72afa10c6','2025-02-04 10:01:38'),(150,'5ea7c74fe4f2327d82582912f03e1ed8','2025-02-04 10:01:38'),(151,'8d82346fff73081d44905eae5bb6dddb','2025-02-04 10:01:38'),(152,'74d903900e7edd6a5837797e44b3dea9','2025-02-04 10:01:38'),(153,'8afcb2475456548deaa76ff4a457c015','2025-02-04 10:01:39'),(154,'f8cd445126ffda2180c0a976e7a322e6','2025-02-04 10:01:39'),(155,'ceaeb63a67e2e74a8fbda9bf40710d43','2025-02-04 10:01:39'),(156,'ddbfa5206e837aa47521b1f11ae4316e','2025-02-04 10:01:39'),(157,'d549f0347b664c756d09dc0461767470','2025-02-04 10:01:39'),(158,'f1d7840bea6d4a6f6d0c01263419359f','2025-02-04 10:01:39'),(159,'4b895211e382778fbf5fa2ad54b2f8ba','2025-02-04 10:01:39'),(160,'5d5ae75260ce293e282da1a7f6b3651b','2025-02-04 10:01:39'),(161,'dff8a8d269ce32f7770e1946e0bc7f9f','2025-02-04 10:01:39'),(162,'552e0543a29500b371a11b1d75af138e','2025-02-04 10:01:39'),(163,'7b29db440ccabbc982bdf473e8703738','2025-02-04 10:01:39'),(164,'b832ea90da6c32173ab3751fda92a780','2025-02-04 10:01:39'),(165,'cb3ef64af1941cfce22db033a5ece153','2025-02-04 10:01:39'),(166,'d3acb7f418ae11b6c56269cdef0563aa','2025-02-04 10:01:39'),(167,'44826453a884b66891a9df0155269d8f','2025-02-04 10:01:40'),(168,'90e38a32affea24b3823300a69d47730','2025-02-04 10:01:40'),(169,'421b0bfa0ee1cb879aad5fdb6366b067','2025-02-04 10:01:40'),(170,'0181d46f04f683c545b575a99e0e4eda','2025-02-04 10:01:40'),(171,'a6d3222624682e82a071f988248c042b','2025-02-04 10:01:40'),(172,'2a54fdcd14bc6b58c6766e9c34b8d418','2025-02-04 10:01:40'),(173,'2030117aca3ba3ec4d918ec4dbf4ddfb','2025-02-04 10:01:40'),(174,'663ca4c73e524e9c6010f1eaf6ccca89','2025-02-04 10:01:40'),(175,'9a6fd2d068e43a7b41917493109bfd02','2025-02-04 10:01:40'),(176,'56a5e9fa0ea8224c3eb497963fe6410a','2025-02-04 10:01:40'),(177,'890d4d006fd715544054d6c964399dab','2025-02-04 10:01:40'),(178,'b74b8da146004a084035e8526ce398e9','2025-02-04 10:01:40'),(179,'191f902af18ae2cb6a0f7a7277a1315b','2025-02-04 10:01:40'),(180,'6c1af345c6783b9786aa8f313150b0cd','2025-02-04 10:01:41'),(181,'fc69046dced04a13f5d55681200783ab','2025-02-04 10:01:41'),(182,'fb1abc2c88383bf5638ff11e9cb7b345','2025-02-04 10:01:41'),(183,'c07e2ea8da6a2efb62620e6a45171f69','2025-02-04 10:01:41'),(184,'da03ac2be23c137f1c233eb22483df03','2025-02-04 10:01:41'),(185,'958a26f856dc597d1ecc377acb6ba973','2025-02-04 10:01:41'),(186,'4279ef436bb8c40e6e371ed310aa3734','2025-02-04 10:01:41'),(187,'7ac2605c152f39933423790e59eb23f1','2025-02-04 10:01:41'),(188,'8ce3f226fff556428aa726a9a787b1be','2025-02-04 10:01:41'),(189,'e6e16dc373d594410f25b33c5a74c08d','2025-02-04 10:01:41'),(190,'ca337f46710be355cda92f4d40ab3d49','2025-02-04 10:01:41'),(191,'ec63c718f293fd9a74e7282a5a5c77d8','2025-02-04 10:01:41'),(192,'9738e1147d1b57db411f9458f600d134','2025-02-04 10:01:41'),(193,'4b6a9db72f66218aa79dd8f8300a77c1','2025-02-04 10:01:41'),(194,'46f8ef7626be30bd9df6afab907c5650','2025-02-04 10:01:41'),(195,'fbeb8d0b2536ff96e0efd91fb6ed58e1','2025-02-04 10:01:42'),(196,'87838cdd81d3d4b43413e823a8e0a61d','2025-02-04 10:01:42'),(197,'337fcf821524d69db8345d4494c1b10c','2025-02-04 10:01:42'),(198,'3f236b71941245ceee3c74fb0b80695c','2025-02-04 10:01:42'),(199,'48f01b64ae702370bbedb22d9f46f197','2025-02-04 10:01:42'),(200,'6ca33cf9154ce43c36159f7b13bbe849','2025-02-04 10:01:42'),(201,'9e7cdd469172372d9bad0b8e4df7f26d','2025-02-04 10:01:42'),(202,'993de778118351d23a83d930fb15bbbf','2025-02-04 10:01:42'),(203,'57ca9d5b7e29633b1e30315049ee5bd5','2025-02-04 10:01:42'),(204,'71abd655683045ad316caae19546cf82','2025-02-04 10:01:42'),(205,'6d8dca2b14001630a38996164c82f126','2025-02-04 10:01:42'),(206,'eee82e1a7cefe61df9f19c018a3cb40e','2025-02-04 10:01:42'),(207,'eb33e3b88f668b6b4125aaee845aff7d','2025-02-04 10:01:42'),(208,'28172b659e061453d4bd017fa04e145b','2025-02-04 10:01:42'),(209,'d5c5761d24908e6c100c1dbfa08719e5','2025-02-04 10:01:42'),(210,'7eabed0d57ae0106b15069ff2867b40d','2025-02-04 10:01:42'),(211,'1c41b14dedad63842cce4d7ab5c18ad6','2025-02-04 10:01:42'),(212,'4f99e226fa6fb9037d8003cdaef20741','2025-02-04 10:01:43'),(213,'51c8ed763a99c384a6873f530331e2c1','2025-02-04 10:01:43'),(214,'aecd7574486d9d96963cf353e88deed0','2025-02-04 10:01:43'),(215,'48814be879211449ee22970468befab7','2025-02-04 10:01:43'),(216,'dc1b522f72e96aede6ec336e9fb8be38','2025-02-04 10:01:43'),(217,'db47379325c400bdf8592625c234d3bf','2025-02-04 10:01:43'),(218,'f933d2ec64fecf281e6d7800d836aaa0','2025-02-04 10:01:43'),(219,'212b09759a3c77b001c1550ce40fbabc','2025-02-04 10:01:43'),(220,'9c045a38d005c92714e756fa479f528f','2025-02-04 10:01:43'),(221,'382498b9f26bf280db6cae79aa82fc94','2025-02-04 10:01:43'),(222,'a3f96627d59a6cf9792d9f8b1f5a2872','2025-02-04 10:01:43'),(223,'b13a1e738bb8a6ab545355753b57b7f3','2025-02-04 10:01:43'),(224,'ba417e5bdd21d3d82edb0b32258193a1','2025-02-04 10:01:43'),(225,'616ffaae78d5393303adb24cb6108421','2025-02-04 10:01:43'),(226,'86e5270ecee31a3a12427285b41f3b56','2025-02-04 10:01:43'),(227,'44d7591d8ec6f191ef9bc17f653e9d8c','2025-02-04 10:01:43'),(228,'326a92f84a43ee4e08c17a80a8afb04f','2025-02-04 10:01:43'),(229,'da637b1057c6e1d394be3bdd118bfd0f','2025-02-04 10:01:43'),(230,'188841ec0911b5aae411ce69381d8d82','2025-02-04 10:01:43'),(231,'1e58430e098163a817e2e918bf1d04de','2025-02-04 10:01:43'),(232,'bef5482edf21f8c81d633e966c811874','2025-02-04 10:01:43'),(233,'1538f81543e21a25421369fad4b05cb7','2025-02-04 10:01:43'),(234,'d0bebf88a02f7f387cc1e75f4ac08e6d','2025-02-04 10:01:44'),(235,'0bbfcd0b68cb70ff940465402ac9dc81','2025-02-04 10:01:44'),(236,'aea061a05de265611d09ed10a93386e0','2025-02-04 10:01:44'),(237,'415730de90323395524e48a44f4681ea','2025-02-04 10:01:44'),(238,'9e942a5559801c542059bef7e146793b','2025-02-04 10:01:44'),(239,'f2a4c0f29a97cea1f5198f5e05b24e62','2025-02-04 10:01:44'),(240,'565bc942291e27212d0b5c15639056a0','2025-02-04 10:01:44'),(241,'f42f6f4efee7222c0b76c3a8770af2c2','2025-02-04 10:01:44'),(242,'520fd6d1833c411e44343a9fd2e60a18','2025-02-04 10:01:44'),(243,'bb3d8cc859ed210570ad0e6ce72a1a68','2025-02-04 10:01:44'),(244,'774e52dc5e65fb8b785ffa5bd164a4aa','2025-02-04 10:01:44'),(245,'4484cb821e90dbcd1be155ada8534cb8','2025-02-04 10:01:44'),(246,'5672dbb2969972451dbee55d8d64687e','2025-02-04 10:01:44'),(247,'c56b08c6b875ab0cda6bbec0e9e563f8','2025-02-04 10:01:44'),(248,'785180d3a0a784691aaa96db75ce52e8','2025-02-04 10:01:44'),(249,'0e938b0e1ca1052768606fe087393e11','2025-02-04 10:01:44'),(250,'5ad75f2c0b074817651c05a012c86d2a','2025-02-04 10:01:44'),(251,'e27a9e41e78ab75f10e439996131b2e5','2025-02-04 10:01:44'),(252,'41e9911f1933caa58cc85919ccef7af7','2025-02-04 10:01:44'),(253,'c9a329552964e67ab17f182c7978554a','2025-02-04 10:01:44'),(254,'8de73a3b9293ba669837c8ddc271a26b','2025-02-04 10:01:45'),(255,'3edf11eb645440f0035e0df7f9063d2c','2025-02-04 10:01:45'),(256,'136adba67eeae60dc78a56192bd0b7e8','2025-02-04 10:01:45'),(257,'310c99a539e3992a65f31b4fe280a5fb','2025-02-04 10:01:45'),(258,'691f1dfab40c438b1fe497fbef2899a8','2025-02-04 10:01:45'),(259,'a0cd11a1ccae9aabf9a02ff18ecea55a','2025-02-04 10:01:45'),(260,'6c1b74822b8e50e74c0ccea86cadf437','2025-02-04 10:01:45'),(261,'2aecd6c53946c1e859a19f07d815df76','2025-02-04 10:01:45'),(262,'fa01b9c7dd03eed96bc1a3c215eda214','2025-02-04 10:01:45'),(263,'e20c1d369a10b582ca5ac8234a72e171','2025-02-04 10:01:45'),(264,'7933c9da5a58eb3ca5a5f62d0c867d50','2025-02-04 10:01:45'),(265,'01cd89ae83f76aa46ee0606d7cb2020f','2025-02-04 10:01:45'),(266,'fb612c6468fe4d5afb81c7bac68177fb','2025-02-04 10:01:45'),(267,'de5b3ac8ff8894dadcab3dab1c258104','2025-02-04 10:01:45'),(268,'48912df3e8f029207649299ed22bb61e','2025-02-04 10:01:45'),(269,'11780289aa302b4e57112dbb36dfd36c','2025-02-04 10:01:45'),(270,'b9bfc615aabfdaa010f2663c0703e812','2025-02-04 10:01:45'),(271,'abc1dd46ce94f12110796ef7b4a10c9e','2025-02-04 10:01:45'),(272,'7799deeb1f35edc46fcdcd891835414e','2025-02-04 10:01:45'),(273,'53063a3645da69caa9aa7a33df33eac3','2025-02-04 10:01:45'),(274,'30d9427b33b3ee52f2c204e4dc5a9f49','2025-02-04 10:01:46'),(275,'af58b6632fd921e5de5c6bb27ba83eda','2025-02-04 10:01:46'),(276,'e2c67807c8a681fbd4967daa9afcddd4','2025-02-04 10:01:46'),(277,'f33db9ca89ce6ae9a95722256138e89e','2025-02-04 10:01:46'),(278,'adbe09691f849621a9e2dc73540909ed','2025-02-04 10:01:46'),(279,'8a3b5dd541d5bd0244588099b917ff58','2025-02-04 10:01:46'),(280,'c31f4f32c010ef7f81e2235a910fc44a','2025-02-04 10:01:46'),(281,'65af23ec47c1a29d4acbbc970b9b838b','2025-02-04 10:01:46'),(282,'21b393301ead0eda071be551e18ec9b8','2025-02-04 10:01:46'),(283,'1098afd3d1fe850d1d32a83e46f2d1fc','2025-02-04 10:01:46'),(284,'5df7ad01822a7cc1aa919ad0e688e20a','2025-02-04 10:01:46'),(285,'c02de10c8aa89f211927af190c4c9f93','2025-02-04 10:01:46'),(286,'1c495dccb5f721d4696caa2689de8cf3','2025-02-04 10:01:46'),(287,'a343729ee827546a482ea1ae8f642f90','2025-02-04 10:01:46'),(288,'aee4626813ca7994f92fed5c126fdc0c','2025-02-04 10:01:46'),(289,'05d1eef7e756e1ecbf089be498623b32','2025-02-04 10:01:46'),(290,'de00ad99d7986339920e3918c44f26d1','2025-02-04 10:01:46'),(291,'7e93955dc10ad84a330003bd030b6701','2025-02-04 10:01:46'),(292,'9388c5d38ecb7941260f63bac9ffe8f7','2025-02-04 10:01:46'),(293,'f3c0964ae3910e16b88c4a754f144925','2025-02-04 10:01:46'),(294,'8fcca71d0e3d202db49a35f359d46b93','2025-02-04 10:01:46'),(295,'7e6678c1683e6ec54e627abc17096aa9','2025-02-04 10:01:46'),(296,'7cc05a641a8d9158c2b5a91c9182d9e5','2025-02-04 10:01:46'),(297,'c5ffd2008b95c9e8603c0297ddd9646d','2025-02-04 10:01:46'),(298,'bba060195ddecfd4f5c27e5c496b970d','2025-02-04 10:01:47'),(299,'ea92f95b09891d5d6636e4a40eb2391b','2025-02-04 10:01:47'),(300,'1ca1c58e127ab51fcd486da9979b9118','2025-02-04 10:01:47'),(301,'184b60b0d178841b3b9b894c4be7d5cf','2025-02-04 10:01:47'),(302,'7892b5458821daf70e6e4f9f9bb2980d','2025-02-04 10:01:47'),(303,'da4b81d17c4020e1a170ed09323c567b','2025-02-04 10:01:47'),(304,'df2725a8c89a2cc6a6247ec87ec7ecdc','2025-02-04 10:01:47'),(305,'46a150465906313c5c40478972e49d4f','2025-02-04 10:01:47'),(306,'2d2325de88e72f9f9b4924d983911796','2025-02-04 10:01:47'),(307,'0c511b281428e8e7d0aa3fa98c07867e','2025-02-04 10:01:47'),(308,'0eec06bb05ebf9540cd48bf182732fe9','2025-02-04 10:01:47'),(309,'e6bb2061f1cf797f6e485ff16a9d991d','2025-02-04 10:01:47'),(310,'97405f4f00b7f8e2065bc6797c2a359c','2025-02-04 10:01:47'),(311,'643b4dc5e46c39a320ad2361801fe438','2025-02-04 10:01:47'),(312,'23b040226fcc9741f5196489d16dce59','2025-02-04 10:01:47'),(313,'8a9a58bbaa9ef55d7ba173f207706fc6','2025-02-04 10:01:47'),(314,'b86d9086aed4c8b9c6c2ef9e2276817e','2025-02-04 10:01:47'),(315,'c14ef6f4bb3c3341a95b7d35d208d29c','2025-02-04 10:01:47'),(316,'6d27916e289cd5fbd8d0b794e926dad2','2025-02-04 10:01:47'),(317,'fa24a9641960109ae6a580158a777894','2025-02-04 10:01:47'),(318,'ad64343a6084fbf96383e4dc0c774e45','2025-02-04 10:01:47'),(319,'679ab2c4789cb2bcd8e5958e36463035','2025-02-04 10:01:47'),(320,'a7d636bf6c546b3c034f8ce460a87d9c','2025-02-04 10:01:47'),(321,'6e93ebd116b49941fc30637825d994ea','2025-02-04 10:01:47'),(322,'8b4e18bf60d33e6c2fe0b1fbcbd2565f','2025-02-04 10:01:47'),(323,'6dd5a3f08443cc200ccfa49de9def574','2025-02-04 10:01:47'),(324,'cc507ea42ed436f257311650bc9d39f5','2025-02-04 10:01:48'),(325,'11a80f6e49e1782d7fecbbbf18aa61f8','2025-02-04 10:01:48'),(326,'d561e46c1ca24fecc4a574731a9a49e2','2025-02-04 10:01:48'),(327,'8099ebfd2532f2d691da4bc0f8d7e36d','2025-02-04 10:01:48'),(328,'f6212ceddca33a18a896f6e2e428403b','2025-02-04 10:01:48'),(329,'2f030057e900c2a0473a51009f22f7d8','2025-02-04 10:01:48'),(330,'5aaa6386c1c87e42abc086680681c563','2025-02-04 10:01:48'),(331,'44d379d5685e43d4ab99c00a7ff6221b','2025-02-04 10:01:48'),(332,'986d3263d7912270993a41ffa2ecaa8e','2025-02-04 10:01:48'),(333,'1554931ffeb76414b03c3d9b176b52a3','2025-02-04 10:01:48'),(334,'3e25b4576a039742c6f2e98c02888ba9','2025-02-04 10:01:48'),(335,'d040f0ebe90392146b6126af61689801','2025-02-04 10:01:48'),(336,'2a4f2a6472f95e6ff6b5908725d90822','2025-02-04 10:01:48'),(337,'8eea434b0de7e206466724f5e126d2ee','2025-02-04 10:01:48'),(338,'e25574705bdde3b85d94ec870f23502c','2025-02-04 10:01:48'),(339,'c7c4b587a39ce37c2ec1113ba2ec15bb','2025-02-04 10:01:48'),(340,'801c8839149b1caaee5acdda32a24de6','2025-02-04 10:01:48'),(341,'ec8a17ccfffb0c00ef002f09d9f505f8','2025-02-04 10:01:48'),(342,'999e8d41dc065d0645a89a892f081b86','2025-02-04 10:01:48'),(343,'920459e79a2ce009ff23ef91db6da5a0','2025-02-04 10:01:48'),(344,'9892dbfa917a316b534a297d08418816','2025-02-04 10:01:48'),(345,'6860f6416f86789a563d22973d08401d','2025-02-04 10:01:48'),(346,'0f8ea07a71227f879ddcd120113c0e34','2025-02-04 10:01:48'),(347,'28494ab9326c25c4a36cc467cfedab19','2025-02-04 10:01:48'),(348,'6dc538969b1b5e5546bfd5b033c3f1c9','2025-02-04 10:01:48'),(349,'60981c1d64eb468535bf2c93898fc5d5','2025-02-04 10:01:48'),(350,'959b6f21e8b1ef394ec3be41f457b842','2025-02-04 10:01:48'),(351,'64fd1c3381aa752374070bc9cb4d4531','2025-02-04 10:01:48'),(352,'0bd80356ffec966e85441a31354c5cf0','2025-02-04 10:01:48'),(353,'825fda5660abb66a8a20a37e3f2a89c8','2025-02-04 10:01:48'),(354,'f2c3b72137e35d3ea82d394d1dd5c441','2025-02-04 10:01:48'),(355,'9de5ef28b4f82185f1546122b030cfa5','2025-02-04 10:01:48'),(356,'f0776bf40b6d5c4cc73f1849e280abae','2025-02-04 10:01:48'),(357,'cee0caae358d20fc3dfe217d639965d2','2025-02-04 10:01:49'),(358,'3963566e2e7de2253c4e2a9fa57c21bd','2025-02-04 10:01:49'),(359,'0b9faf6649565c8fe2835f5c9098ff2b','2025-02-04 10:01:49'),(360,'aa48afa7497170808b096860a71a93ef','2025-02-04 10:01:49'),(361,'39c5b7636fa853c4f2e00f7da0dcfd42','2025-02-04 10:01:49'),(362,'29845ab5627bd2901b7d3d351f40dbd8','2025-02-04 10:01:49'),(363,'30985c5f3d3fc565e32d522f3921be8d','2025-02-04 10:01:49'),(364,'270cba5793e7f31e8c1a1fa8a354d208','2025-02-04 10:01:49'),(365,'bb7df67ca8979ea7f40a29746d2f564f','2025-02-04 10:01:49'),(366,'bb5e4793264887417604fd606be78f09','2025-02-04 10:01:49'),(367,'d2116ecb1c88c7bbd800b5c954359a14','2025-02-04 10:01:49'),(368,'3375b5ef3284b75a9695c41ee1871fc8','2025-02-04 10:01:49'),(369,'29eacbaaa31cfc111423d69026dfa8c3','2025-02-04 10:01:49'),(370,'1921b1d5ea74bd74e61c4beba6cc08d3','2025-02-04 10:01:49'),(371,'79d1d0bca4ecbaf790d5d9d66529d215','2025-02-04 10:01:49'),(372,'4e268dc6d12c114c9d2725b7f6e56b8f','2025-02-04 10:01:49'),(373,'ad2191ff476a2ed42c4f2426debad6de','2025-02-04 10:01:49'),(374,'6182b996395a303c3d2f721f75986c71','2025-02-04 10:01:49'),(375,'c7b2452a458ea114374e8be3b96e65af','2025-02-04 10:01:49'),(376,'7b8c7499a5d2f8d0ddacc036c178c16c','2025-02-04 10:01:49'),(377,'ccf7d592ccab014778176130f2b03b98','2025-02-04 10:01:49'),(378,'5016c64c90b8865ea495bdb091bd912c','2025-02-04 10:01:49'),(379,'729da0e422de9d57e5572d420744671f','2025-02-04 10:01:49'),(380,'0e42d18fe1246999fceb5fc2a0322cb1','2025-02-04 10:01:49'),(381,'316bb77a5c0b4982f345500621abb323','2025-02-04 10:01:49'),(382,'a876f8eefc77afdc5ddbc010c05439f5','2025-02-04 10:01:49'),(383,'104d469fac1b53da5da915b766c14399','2025-02-04 10:01:49'),(384,'2d2fdbadf73772294fea4672f89988f9','2025-02-04 10:01:49'),(385,'bff2f6606438a41e8b41aeb0c25522fb','2025-02-04 10:01:49'),(386,'b8ac83fd0d7503ff1f15189fc193c1e3','2025-02-04 10:01:49'),(387,'a58b490f23aafc6ac2d33a241baf9aa9','2025-02-04 10:01:49'),(388,'b42881c16d90c5672c41a7f1a80520d0','2025-02-04 10:01:50'),(389,'2910bc69be152d3210be679148f3d99b','2025-02-04 10:01:50'),(390,'f78853f35af01356e979a87b52948bfd','2025-02-04 10:01:50'),(391,'3a66ac1b246420609e00d7a780a80a44','2025-02-04 10:01:50'),(392,'f6e444fc65d95187b134d0e8aa24036a','2025-02-04 10:01:50'),(393,'7ab54ad4caf73221a86496a140acecf3','2025-02-04 10:01:50'),(394,'b93103d826ba0dfab0690fdfe9b194da','2025-02-04 10:01:50'),(395,'b2112c24851e8185ffbd106cd37bdbef','2025-02-04 10:01:50'),(396,'5b06572a99679fe8ec9de45d3a079796','2025-02-04 10:01:50'),(397,'a9a1a75c3bbc46b1df49f5a47f2b3da6','2025-02-04 10:01:50'),(398,'9ba7897b32fdc8f1985f1057ead40808','2025-02-04 10:01:50'),(399,'56568b34d8f0759672189942c143d2cd','2025-02-04 10:01:50'),(400,'f56979f4a0ac468fe9b1c4c7ece1cfb0','2025-02-04 10:01:50'),(401,'3d62d17612f1dae4f957a538c1925ed7','2025-02-04 10:01:50'),(402,'fe75e0514ff38c92de3f4a89c30f75b0','2025-02-04 10:01:50'),(403,'6998f1e3fb7a0b5046309db9baa79fb2','2025-02-04 10:01:50'),(404,'ba74d49bfe7f923ae10aee4874af00e1','2025-02-04 10:01:50'),(405,'2223c87c56e09319b3e024ab02b5d197','2025-02-04 10:01:50'),(406,'de9fef8b24af695d762ec2dc3a8065c5','2025-02-04 10:01:50'),(407,'1bcef33d1a56a3da0031cb978f7c7ec8','2025-02-04 10:01:50'),(408,'cdf2766c93e38f169d91be0971341848','2025-02-04 10:01:50'),(409,'d65d6a1367d334d3feae3d7090d22ca0','2025-02-04 10:01:50'),(410,'d212d6dc4a09a349e271fa25d1d71b18','2025-02-04 10:01:50'),(411,'71dd499f9adb23d9546e8987e31bf631','2025-02-04 10:01:50'),(412,'893227e9cfe014a402c40251143014b7','2025-02-04 10:01:50'),(413,'c564270c80b1918e7316109fbf0f7604','2025-02-04 10:01:50'),(414,'e389c61b41a1a5caa49be963d6c5a401','2025-02-04 10:01:50'),(415,'6ea02c56d858dc316c6b8ddc18738f4d','2025-02-04 10:01:50'),(416,'1fbeb7dff01ba95b138fa09b33de1e05','2025-02-04 10:01:50'),(417,'1f3c977820b271206b9362e2eb472c9a','2025-02-04 10:01:50'),(418,'7efc9ecfcad58b3e6d6b656bf73f52ed','2025-02-04 10:01:50'),(419,'31883469d390382faa8c9690d5a241ee','2025-02-04 10:01:50'),(420,'48155b7f7e0b73e90bd443cfa5149640','2025-02-04 10:01:50'),(421,'52cd762ef30d7a1eed40adb2711e6960','2025-02-04 10:01:51'),(422,'9f42db3628de3a370292edf1cd36341c','2025-02-04 10:01:51'),(423,'9581b866121a03737b8b3fc0c00025d1','2025-02-04 10:01:51'),(424,'d8d7604e3d69412f731e4db8a8c7e6a5','2025-02-04 10:01:51'),(425,'983368b5873e801d2f0a3bf82ab84479','2025-02-04 10:01:51'),(426,'7f40a71a3682774786dd5a3cd7ea0b82','2025-02-04 10:01:51'),(427,'ba13c7a7344babfc2985cf4e6e366aa6','2025-02-04 10:01:51'),(428,'60f48d556f276323fdfb428f23ca4e92','2025-02-04 10:01:51'),(429,'37e6aeb10c20ce2c822bb28dc1751c17','2025-02-04 10:01:51'),(430,'938e60d36073eacca198ac2a8b62a852','2025-02-04 10:01:51'),(431,'dc12192cf3a1357a936baf3caddfbfd6','2025-02-04 10:01:51'),(432,'057f9ef7bdbecedcd875c73944e17174','2025-02-04 10:01:51'),(433,'351662bbd28a0e88915f3590ec07d54a','2025-02-04 10:01:51'),(434,'725521f383eb01351d23861b302baa45','2025-02-04 10:01:51'),(435,'faf464021cf93976cfd77cfe5fc9dbbe','2025-02-04 10:01:51'),(436,'e7625bde87a43bfba018f36de9a733e4','2025-02-04 10:01:51'),(437,'d4c71b35d8cf891aa05dc70537a4564c','2025-02-04 10:01:51'),(438,'0a7b69d91c3e6de33e36a82bb0e401fc','2025-02-04 10:01:51'),(439,'e9012edd437fd16323c4c17174895630','2025-02-04 10:01:51'),(440,'35eb5ec9cc4d8e9125d0c4291d2a34a7','2025-02-04 10:01:51'),(441,'e765ec11b4e6c7b128a11eaf8348bd5a','2025-02-04 10:01:51'),(442,'7ac55f0ec67c9dc9f8b74427f2b22fd1','2025-02-04 10:01:51'),(443,'bf1f5d4c345a0d5959db6a7e33857406','2025-02-04 10:01:51'),(444,'cf55cc176dc1b73d58f3bab3ede0d8bb','2025-02-04 10:01:51'),(445,'89d86ba5c4a810afdbaf77ec46b1a479','2025-02-04 10:01:51'),(446,'bf70b4ddbd7ec0841f68960e291113d2','2025-02-04 10:01:51'),(447,'64bc06801e7796051a4962ca9faa6361','2025-02-04 10:01:51'),(448,'ee81e0c5238b35569558f5c3174bc79a','2025-02-04 10:01:51'),(449,'75a0a6c26bf8cab003d53815f86c357f','2025-02-04 10:01:51'),(450,'96d73ffc5def4c7d4789fd98ee4478ab','2025-02-04 10:01:51'),(451,'baf6bc7fde9980501526203a465d81d8','2025-02-04 10:01:51'),(452,'e024cb11653a9d12f6326aaf9b134d04','2025-02-04 10:01:51'),(453,'76ee2d59b40633d3ca42a621b961b20b','2025-02-04 10:01:51'),(454,'8dbfa946d5a7e2734b7a9707c7b9bfd2','2025-02-04 10:01:51'),(455,'726fc5db89fc0f8a74d2551992811313','2025-02-04 10:01:51'),(456,'d4071bebd381ae89b1f21995a08fab00','2025-02-04 10:01:51'),(457,'bc50d2ef4b336cbadd325e662a6b51f6','2025-02-04 10:01:52'),(458,'9521cbcf97ab72acc4b306d6802b0237','2025-02-04 10:01:52'),(459,'3d7734f7b5e2fc4bb1ffbe00550e4b1d','2025-02-04 10:01:52'),(460,'43f6d5ab33c6657c8ed6496829f63121','2025-02-04 10:01:52'),(461,'ae090663d530266cc30df5ada13173b3','2025-02-04 10:01:52'),(462,'080464ef52567aefed1c0fecef8eef54','2025-02-04 10:01:52'),(463,'d61691ee1e6091b2124bca99c2a33ee2','2025-02-04 10:01:52'),(464,'213b5b529349038510110597b1b31856','2025-02-04 10:01:52'),(465,'fb57ce40ac0d44ce4dc9fb67bcf1538b','2025-02-04 10:01:52'),(466,'7753b69bcf330a9850e40ed16aed9d4b','2025-02-04 10:01:52'),(467,'d471e5c5e5a9171634c7c21b9460f5fb','2025-02-04 10:01:52'),(468,'63704d73eb03b36a08b9ad34055f15ac','2025-02-04 10:01:52'),(469,'d29d3437943862e6ddce4d151509dcd2','2025-02-04 10:01:52'),(470,'caee3779068300899d88f6fd8dbdfcad','2025-02-04 10:01:52'),(471,'00dcc6482788ffe1d180004a2d8bc10b','2025-02-04 10:01:52'),(472,'4bacc2fc3a60d0d126a7b668bf9d4f4b','2025-02-04 10:01:52'),(473,'01b089f447d2ba676ce92783f3cdf316','2025-02-04 10:01:52'),(474,'782dc6453e6fd8ca48ceafbba83fd6bc','2025-02-04 10:01:52'),(475,'d117ddc3dfff36ebb9e023bf81065e54','2025-02-04 10:01:52'),(476,'9ccda94f7a8e0b705aa0ece120d83581','2025-02-04 10:01:52'),(477,'cf6485c8d309e5b1fbda3461dca280af','2025-02-04 10:01:52'),(478,'7e422f284caf8ce9bc72df35d18c26ff','2025-02-04 10:01:52'),(479,'dd93675d5f4c011f069d43b717581b93','2025-02-04 10:01:52'),(480,'b427ae753021641db888782edd63c2d6','2025-02-04 10:01:52'),(481,'1661703b87af80930f3a7b549ce64e6b','2025-02-04 10:01:52'),(482,'b7d6aa9427dde42cf9fdead075b34f5d','2025-02-04 10:01:52'),(483,'01f16ab99bd1e2bf0390034773fa5725','2025-02-04 10:01:52'),(484,'8c26b6f4ada20d54f98b07772050b184','2025-02-04 10:01:52'),(485,'992128d9b61bfdf409029f01547769e3','2025-02-04 10:01:52'),(486,'cfa0bcde553cefa695a4611e3d65b6f0','2025-02-04 10:01:52'),(487,'13ebe92891db58e652bdd7b17db4df3b','2025-02-04 10:01:52'),(488,'fc2c650de82c82e9dee968de35214aa2','2025-02-04 10:01:52'),(489,'b0e65fcdabd12d34bf524680c2583045','2025-02-04 10:01:52'),(490,'0814e9d80f60ab0d676d9299fc5bdaf1','2025-02-04 10:01:52'),(491,'21f19943fc386242f530a201ac61a29b','2025-02-04 10:01:53'),(492,'24a78b212b55f10c30db7a5fa466ffd1','2025-02-04 10:01:53'),(493,'9d2cc89051da1ffdc6e44ee8e3c6d2c9','2025-02-04 10:01:53'),(494,'f8382ba90461e28f0cd472a54529b52d','2025-02-04 10:01:53'),(495,'bb573f3e28bd153d53797aefe1f44ac3','2025-02-04 10:01:53'),(496,'6b7b8aff0dd1c32f177da4dda9708037','2025-02-04 10:01:53'),(497,'6192434a68c66a230da9cc8a307bb3c1','2025-02-04 10:01:53'),(498,'9dd731dadef7c8334fa4a03ba63af563','2025-02-04 10:01:53'),(499,'9b3bf8f982120db03ca6a32d1485bedc','2025-02-04 10:01:53'),(500,'ca5e4052a7d7bc3ca00c31a8e5fab0ad','2025-02-04 10:01:53'),(501,'60c81276619dbf61c4c1ee67f22ec823','2025-02-04 10:01:53'),(502,'daf53979eb8156e059e27333c83d7602','2025-02-04 10:01:53'),(503,'8443b902127d26e3e765aca334b408a0','2025-02-04 10:01:53'),(504,'70c060a9a7b1bdcd1716a74a32c61790','2025-02-04 10:01:53'),(505,'908735f4209b42863ce6dd11231ac6ef','2025-02-04 10:01:53'),(506,'2fd8f4d2ffdaef52acf80fc6167b2648','2025-02-04 10:01:53'),(507,'bef039c951cd23d15ac1f3ee853fd6b5','2025-02-04 10:01:53'),(508,'17d4e06d18ced62651a30cd278d8b955','2025-02-04 10:01:53'),(509,'6a58bb216b6a8674dc72f616feda8f83','2025-02-04 10:01:53'),(510,'aa01cc6d52524b05c42cf6adc00278f6','2025-02-04 10:01:53'),(511,'c05f8d91619fc10e15668a448b534713','2025-02-04 10:01:53'),(512,'adad005253c89b0b4f568567194dd0de','2025-02-04 10:01:53'),(513,'4eaeee3004b2e51387a184c5af084cba','2025-02-04 10:01:53'),(514,'87e54913f2214a4dca29ab2545f8829f','2025-02-04 10:01:53'),(515,'1041cd10044ca8e238efe9b730322c14','2025-02-04 10:01:53'),(516,'887802b0223758c2e4183f010dac545d','2025-02-04 10:01:53'),(517,'5b21a8e235a5da8274ecd2361361b88e','2025-02-04 10:01:53'),(518,'914f84cbdaca93bc8fc9c66a3286e6df','2025-02-04 10:01:53'),(519,'01f5c5d2ef67334a7fd32b74f4f37130','2025-02-04 10:01:53'),(520,'7ea8cb5896bb1ce8c69ab77af22e5f35','2025-02-04 10:01:53'),(521,'a30595b46e9c6256b4a4f9978adcab27','2025-02-04 10:01:53'),(522,'70614e388d28d8817e6192fdbfe5bbbe','2025-02-04 10:01:53'),(523,'5fa6cee0358021ee39f2b5ae2fdbf176','2025-02-04 10:01:53'),(524,'052e9f382c844a403c17cff9cc9a71de','2025-02-04 10:01:53'),(525,'f368f7560b720c76d204f545c0212890','2025-02-04 10:01:53'),(526,'f980dbd56145cbd51fe0687789291f89','2025-02-04 10:01:53'),(527,'9526f635f19a1d1328f5543d0abf486f','2025-02-04 10:01:53'),(528,'e2f56ab4274feb9e192c02dda2792f30','2025-02-04 10:01:53'),(529,'6143ee4f9426c505d9b8c1f25d4b7734','2025-02-04 10:01:53'),(530,'5c03f477721b0f9c3b705edb563106df','2025-02-04 10:01:54'),(531,'1e799566adca0733553a05058c7ea8d2','2025-02-04 10:01:54'),(532,'58a7d54973afcb44a1d1168f07efbe55','2025-02-04 10:01:54'),(533,'a39651b2fa20d77f80492115d8a77d7e','2025-02-04 10:01:54'),(534,'3d39592992eefcdf6e3cc95e6a524c59','2025-02-04 10:01:54'),(535,'d5eaefcf6c729d5fef1041ae5223c2de','2025-02-04 10:01:54'),(536,'e3cbe42443cbb980de6507d82a8d654d','2025-02-04 10:01:54'),(537,'27347ea08f3add05dfff3b1d473c0dfe','2025-02-04 10:01:54'),(538,'5d14c14ad7946127b26bab67faccbec2','2025-02-04 10:01:54'),(539,'886ae2d735d10b4d3a50d2b30f92f5d9','2025-02-04 10:01:54'),(540,'c9a02cf0cf33ea309a1e49dba4c5cc3e','2025-02-04 10:01:54'),(541,'3d27adc979e55d268c3e24468aaf3a0c','2025-02-04 10:01:54'),(542,'5ef8926e69ab3aa6bf5db95f0b4901ab','2025-02-04 10:01:54'),(543,'fbcb488ba62e367f03bfd163c255337c','2025-02-04 10:01:54'),(544,'594570090205a630c4a878b121e29a79','2025-02-04 10:01:54'),(545,'620431a672fa23e470f62435fcbb6258','2025-02-04 10:01:54'),(546,'82413d05f4ec8c1c3f9c061f66372578','2025-02-04 10:01:54'),(547,'0637ddf02f539df9531b2335e73df19e','2025-02-04 10:01:54'),(548,'58008d2db1e6513b91ba39e46dac0da5','2025-02-04 10:01:54'),(549,'19b1ad9cce77ccfc39fc94ae62579c27','2025-02-04 10:01:54'),(550,'9a2d5e60f9498a1dd7da1cc09bfe5633','2025-02-04 10:01:54'),(551,'c85cd88bc4e4634d2e1e4fb967a15fda','2025-02-04 10:01:54'),(552,'c897f162f07223dd7093777c6eb415ca','2025-02-04 10:01:54'),(553,'42b81ae1f0bdb09db43ff5f5c2afe67e','2025-02-04 10:01:54'),(554,'985bebff9510eaa78bef0711f0936b26','2025-02-04 10:01:54'),(555,'c5ff57e994b928fa3ad4fe86a5de4784','2025-02-04 10:01:54'),(556,'a901fd36aa6766a2d8c640d617c760c9','2025-02-04 10:01:54'),(557,'847810750dae0917062763f23d877341','2025-02-04 10:01:54'),(558,'1e2cc05fb8d87db7ad867ef2b544204b','2025-02-04 10:01:54'),(559,'009703ebfdeafe9d9fe278f6b6658687','2025-02-04 10:01:54'),(560,'301a5abf03e331bf3551f909f74c51ae','2025-02-04 10:01:54'),(561,'ce7830acbef5b765bcc129a09b9fc0c0','2025-02-04 10:01:54'),(562,'3271c1c068bf418868a31b384dd86eb7','2025-02-04 10:01:54'),(563,'e1cb84c2c211a3908c4d8f83015fcf30','2025-02-04 10:01:54'),(564,'c7b573b907de10c678a762b8d33f2ee8','2025-02-04 10:01:54'),(565,'2b89af3f64cfb88185a7832756db5847','2025-02-04 10:01:54'),(566,'d262126adc2309ab37c0e58e0ea52652','2025-02-04 10:01:54'),(567,'395966d040aa97bf5f4e0caa0e88e9c3','2025-02-04 10:01:54'),(568,'4fe2710163e8183d54824c88d7fc698a','2025-02-04 10:01:54'),(569,'d0805592fd1460aa051babb86c121853','2025-02-04 10:01:55'),(570,'a896e53d797fa7c88d6e7fca59820941','2025-02-04 10:01:55'),(571,'e6ed6830a38b9f75b2d3beb2e779caca','2025-02-04 10:01:55'),(572,'8b4ef502061bb215879d2e551c005fa8','2025-02-04 10:01:55'),(573,'349dcbe7f6154a144cdbec530a292aec','2025-02-04 10:01:55'),(574,'fa2f045fe4df4ce69799e686de9c4e07','2025-02-04 10:01:55'),(575,'7427af7edfc13b1b793aba48ef9d25d9','2025-02-04 10:01:55'),(576,'a22d7520e948559bc53c5e7d1ea4608b','2025-02-04 10:01:55'),(577,'f940d288d4c2252dbd1691f4adac8d28','2025-02-04 10:01:55'),(578,'601f02a7ab4748208cece852f521b294','2025-02-04 10:01:55'),(579,'5b67381aa70483a7bbaac9fd2d101f96','2025-02-04 10:01:55'),(580,'877cf2f54944d43c7bd3e0cd87b565ea','2025-02-04 10:01:55'),(581,'8472b13d0a9f207a07c92a1667d8833a','2025-02-04 10:01:55'),(582,'c34e89ae84063c05334e9ada2aedae0a','2025-02-04 10:01:55'),(583,'03ec84df3c894489c44da63180f512af','2025-02-04 10:01:55'),(584,'2ef24da2747096668f85fed8a6088e9b','2025-02-04 10:01:55'),(585,'6957bc69d635e88b597808dc3812031b','2025-02-04 10:01:55'),(586,'81b85da1ac6e60759e6386216a34412f','2025-02-04 10:01:55'),(587,'3f62d39a2d765a54c6febda4d5569210','2025-02-04 10:01:55'),(588,'cf69e26949c5e7d452935ad110413f70','2025-02-04 10:01:55'),(589,'9d603ba8352fac2da775b8d2d339cfe6','2025-02-04 10:01:55'),(590,'5c37d2dc63bc8a1e850fa9e3386217cd','2025-02-04 10:01:55'),(591,'d6aae3315477424f0092b7cd3bdd81fa','2025-02-04 10:01:55'),(592,'e93d314c4fe44b09178903e7b54d7a45','2025-02-04 10:01:55'),(593,'68a215f7ad8cdfc6043c5eb9b58e1560','2025-02-04 10:01:55'),(594,'458ce6f06507ea18c95599452bbaa097','2025-02-04 10:01:55'),(595,'3058a14f3ecc81ec6d6df5bb6f1aa781','2025-02-04 10:01:55'),(596,'826126147da86c25b04609d6c6a4ca4b','2025-02-04 10:01:55'),(597,'a40a0e9a181cae199b39fcb4614cc583','2025-02-04 10:01:55'),(598,'0f68e649390d80995811205e9f8165de','2025-02-04 10:01:55'),(599,'a8a75541fa56a16bfaf218f96bac1669','2025-02-04 10:01:55'),(600,'28d53455c412d344b26981333e6f0119','2025-02-04 10:01:55'),(601,'c9ad37564363cc3178663d84c89f049d','2025-02-04 10:01:55'),(602,'d39fbbf0232dad158bc3ceca0c478a8a','2025-02-04 10:01:55'),(603,'256cc855f7adeca37314a6b8d9348c6c','2025-02-04 10:01:56'),(604,'f0610848d160d08fa7b2e82563f7a756','2025-02-04 10:01:56'),(605,'528da3b924de942a5b8e372dc71ed532','2025-02-04 10:01:56'),(606,'a2e05a9e99b56baf6934f99f41575cc2','2025-02-04 10:01:56'),(607,'af36e16648024f0acd66d56bae2984d8','2025-02-04 10:01:56'),(608,'2d70b77fa44a6b48b588c6329818492b','2025-02-04 10:01:56'),(609,'f269a9ba6302589374b87c003a1b4c73','2025-02-04 10:01:56'),(610,'43b142e4969a20acf2de7b760eba6fb7','2025-02-04 10:01:56'),(611,'f6f0e4dbd07ae48ae221686b357d4c7d','2025-02-04 10:01:56'),(612,'4c9a9a7e11013aee4c51dd8a2daf1bc9','2025-02-04 10:01:56'),(613,'5575cb6abc595b71508d46032ce1b01d','2025-02-04 10:01:56'),(614,'de5d3995dbe8ffb0a494a522ea75bf58','2025-02-04 10:01:56'),(615,'24348e83bc976b775784a7165f44aba3','2025-02-04 10:01:56'),(616,'cbe1b0097cce4861a7ba9965d6c61262','2025-02-04 10:01:56'),(617,'1b20aae3241cf8be83d85b99ee329028','2025-02-04 10:01:56'),(618,'8b0e83152ca3e6bdfefa64b4e3011285','2025-02-04 10:01:56'),(619,'98ac17a8f49ddc314b651c2b1bcbdd4a','2025-02-04 10:01:56'),(620,'40bf7d67de17fc08927474f634d78330','2025-02-04 10:01:56'),(621,'37f645f842ebfb20ac11864702b27843','2025-02-04 10:01:56'),(622,'f4272669a16a4d3cde03e5754eb9d462','2025-02-04 10:01:56'),(623,'4426b9dc3cfc68b0e9016c05bc35680c','2025-02-04 10:01:56'),(624,'de5229076f5e5cee8f915bfa66334724','2025-02-04 10:01:56'),(625,'da8fc6efdfb5d6020b0c5af3ad1ce48b','2025-02-04 10:01:56'),(626,'65a9b294167e8d4b252f475a2658ae86','2025-02-04 10:01:56'),(627,'01979c2608c51a1983b36a88177d6833','2025-02-04 10:01:56'),(628,'e449dfd44fc426ff23709b3b9b318b50','2025-02-04 10:01:56'),(629,'c69dc7174964eee0310b9c7dc952ee51','2025-02-04 10:01:56'),(630,'1f4f5293e91e4938322a9993e463ab7d','2025-02-04 10:01:56'),(631,'7387af53b8c462112c1f2b75347af180','2025-02-04 10:01:56'),(632,'97b6f9b1229e42cea3ba844e5de3e43c','2025-02-04 10:01:56'),(633,'c9c28a439ca48b1b027a331ac0f768b4','2025-02-04 10:01:56'),(634,'42bf15cb189f36a3a42fca06d1b41507','2025-02-04 10:01:56'),(635,'ac3455b907def2edb08ae0843a9c0efd','2025-02-04 10:01:56'),(636,'60c534cb90519a0f90a8250ce82ae1ae','2025-02-04 10:01:56'),(637,'7ab5fa8a13a1a64395daf41f40bdad53','2025-02-04 10:01:56'),(638,'caecf0bce1c8224d31c614e63bcad415','2025-02-04 10:01:57'),(639,'fa2a693abc9fbdd7f3a951dc2a73137c','2025-02-04 10:01:57'),(640,'3383e19741716236d9be1bba970447e7','2025-02-04 10:01:57'),(641,'0691fdf66bc859f284955667c07c07b5','2025-02-04 10:01:57'),(642,'bcfd1fabf9a8f98e340f641a55ac14c9','2025-02-04 10:01:57'),(643,'d5902df32e362a2b9b887cf2bfc0e9c0','2025-02-04 10:01:57'),(644,'9169b2e6828962f67917c489f3f6d0cc','2025-02-04 10:01:57'),(645,'b4119a93c34c92edf9e4e514c14170b5','2025-02-04 10:01:57'),(646,'7037e18255b016c28d06139e84544182','2025-02-04 10:01:57'),(647,'a1741740a20b1a7772a5fb7beba57578','2025-02-04 10:01:57'),(648,'c4d6950bb102c972b0dffbd8a60999d1','2025-02-04 10:01:57'),(649,'1fd6ce9dcf62412acbe9c756876f330b','2025-02-04 10:01:57'),(650,'8c57aa566efb13a7699e72c2e7f3b8e5','2025-02-04 10:01:57'),(651,'7495f1f29c4daea1fca2576e508c896d','2025-02-04 10:01:57'),(652,'6219e07eee30f604aebbe2aeff9ed475','2025-02-04 10:01:57'),(653,'2c01bfa8ad67888cb65ab85451800864','2025-02-04 10:01:57'),(654,'268aef0789a7e84c7b37fdc07271cd03','2025-02-04 10:01:57'),(655,'250430d305224ebf1154162fe44f1641','2025-02-04 10:01:57'),(656,'700ac9f72b8f5479e2170c3c794671cb','2025-02-04 10:01:57'),(657,'5e5ee397d4c9fdb712e433963684b55b','2025-02-04 10:01:57'),(658,'8e47c82af769103883d53d5227aaab99','2025-02-04 10:01:57'),(659,'2c23618b3eba330c7e4f0ee558e46f98','2025-02-04 10:01:57'),(660,'114e8903e163141dfaa9f7f718613316','2025-02-04 10:01:57'),(661,'513c6896d1aaec6ee2fc774f32e4f602','2025-02-04 10:01:57'),(662,'2c2d72c7fe2fb33f7e4fc62ccbc14195','2025-02-04 10:01:57'),(663,'84b4bdb0206d49ba933a87c6ceb9ea4f','2025-02-04 10:01:58'),(664,'c78716b1c8ed038566661f19725298bf','2025-02-04 10:01:58'),(665,'9ff287ffe78a92c0da9fdbb233cc3b06','2025-02-04 10:01:58'),(666,'9df437040dc73c6c3ca05c927db0820f','2025-02-04 10:01:58'),(667,'11d0e009ec38155adbf8c33b9b6988f9','2025-02-04 10:01:58'),(668,'3b1d81aedc9815b2358a0fd55d14c4ff','2025-02-04 10:01:58'),(669,'07fbb79a833d1df05f8b150f8eee50bf','2025-02-04 10:01:58'),(670,'df0d9663038ec3ad551c3402386321e9','2025-02-04 10:01:58'),(671,'429150cb0f725d029664d0f21713b23b','2025-02-04 10:01:58'),(672,'ec8145798554fbe7b9b9393467d4e1cc','2025-02-04 10:01:58'),(673,'d92a949bd738fa476be8c9bb7c19a4eb','2025-02-04 10:01:58'),(674,'518635f889fbd09f123889628b31d213','2025-02-04 10:01:58'),(675,'408aa4dc0ad5d7a857eb0534bf7cdf27','2025-02-04 10:01:58'),(676,'0e5c158958ff9da2690f3c166b147775','2025-02-04 10:01:58'),(677,'33addfb2fd0a9224d8f7ae27800d7d84','2025-02-04 10:01:58'),(678,'6f1e71072849f5fe77aaf6106894b3d9','2025-02-04 10:01:58'),(679,'21cbda5cd00269f30bccb9ed7b462536','2025-02-04 10:01:59'),(680,'b6fe189d77dff1e347dfa26ac7f48820','2025-02-04 10:01:59'),(681,'5427d8a1732bbaf598f42746e5f91ca1','2025-02-04 10:01:59'),(682,'940b7b53db4a0065362a55aa363fc63a','2025-02-04 10:01:59'),(683,'dcff73e59b4c2ab599626fef160b672b','2025-02-04 10:01:59'),(684,'9511db39de5048c8dba2e59eb8919a39','2025-02-04 10:01:59'),(685,'b1fbad6771eb87d00d0d4abcdf8e894e','2025-02-04 10:01:59'),(686,'9729f9de3d0fb554a8531963c5f4ebd1','2025-02-04 10:01:59'),(687,'1297d436d71d50ad4a863cc24fd8fcd5','2025-02-04 10:01:59'),(688,'6adc112d4e2a77e94eae4cf9926b7b90','2025-02-04 10:01:59'),(689,'7c18fc91e2d919a4eac19edb5877775b','2025-02-04 10:01:59'),(690,'f6303a4bc343ece346ab7b928afd1db8','2025-02-04 10:01:59'),(691,'44f07597f77ab2c07e4159f973fa7ecd','2025-02-04 10:01:59'),(692,'2522252c51a41a69bc6a6ca53a81977f','2025-02-04 10:01:59'),(693,'7c3753895f58df2a9e3b6e5f148d8287','2025-02-04 10:01:59'),(694,'93838fc4e87c738671c39c6647ca7a17','2025-02-04 10:01:59'),(695,'8e4063d3b0a881b63c621022987a7249','2025-02-04 10:01:59'),(696,'c4ef159c785fab5f6ecca170beb61fc5','2025-02-04 10:02:00'),(697,'babae89af9debf0579f191d3d4449084','2025-02-04 10:02:00'),(698,'1c317d30ed3468f4eb0bfa29b4e0e93c','2025-02-04 10:02:00'),(699,'7f6bc8ed66e5b6a6bfe069815a1cbdaa','2025-02-04 10:02:00'),(700,'432ebea323924a9aba446c2553e6f9f5','2025-02-04 10:02:00'),(701,'f01c30afefa73fb7e5330456b1776695','2025-02-04 10:02:00'),(702,'d2b0d678d5dcd8c0107d4bf5bc949a37','2025-02-04 10:02:00'),(703,'aae8d548d6d75e2af928f8991611efd4','2025-02-04 10:02:00'),(704,'143453448a4e8698d0b4ac255202cfa8','2025-02-04 10:02:00'),(705,'04d09181e4d2e44c37a6c8f825dc4e46','2025-02-04 10:02:00'),(706,'4ec93cd95256dcc2f44b4201f170424a','2025-02-04 10:02:00'),(707,'0a43d066b9cede4bec88f0cf19fef801','2025-02-04 10:02:00'),(708,'63e00df960c67147ea87cb20dafed13d','2025-02-04 10:02:00'),(709,'0ae92175127b87acc527e136d2e6281a','2025-02-04 10:02:00'),(710,'bca4d46eaf26ce8559d53b3191afdcb8','2025-02-04 10:02:00'),(711,'c0811109efae3b3c432f99e38899baf7','2025-02-04 10:02:00'),(712,'02c029c3c9f98048e82a6479d0c0409d','2025-02-04 10:02:00'),(713,'7129fbd1b368a91f7a3f1a3cd5f3fa50','2025-02-04 10:02:00'),(714,'08d6754b66e7c4197fcabc940645316e','2025-02-04 10:02:01'),(715,'6c48bccb61b3f9b39c4ebe6114c45017','2025-02-04 10:02:01'),(716,'99ca8d0a54618a3ab75564d1bdf7ee25','2025-02-04 10:02:01'),(717,'25fd053018b350396f3128201c0eacae','2025-02-04 10:02:01'),(718,'1b40ac0be49b9e5cbfbfb86f99b11107','2025-02-04 10:02:01'),(719,'026ff969c64780f620e9526b04f97ae0','2025-02-04 10:02:01'),(720,'9263e20fa55ae610a4573ad40971e028','2025-02-04 10:02:01'),(721,'dee7807bc853902009e10baab4fd582e','2025-02-04 10:02:01'),(722,'a59b942efd6ff63e75be8436219ae4b0','2025-02-04 10:02:01'),(723,'97662c21d0cc3dff045800dadf84e968','2025-02-04 10:02:01'),(724,'bae7f5847818e1a14310a6f581d38fdb','2025-02-04 10:02:01'),(725,'f19c1bf187f122b8e75007712fc77964','2025-02-04 10:02:01'),(726,'f1ff45619c8115924fd2cb3849a8afc5','2025-02-04 10:02:01'),(727,'145047daf42db7cd11d5746019f22340','2025-02-04 10:02:01'),(728,'9352304b1bd7a33618e73ed07da51895','2025-02-04 10:02:01'),(729,'9be17b94ffd7c0a450c1c8e91ff52f7f','2025-02-04 10:02:02'),(730,'6786f7b01478ab3496b49f6f85e3298c','2025-02-04 10:02:02'),(731,'246b42d5950e6aa0998625291a7df002','2025-02-04 10:02:02'),(732,'329af33fbeb7bfe999b3711c8c8e2554','2025-02-04 10:02:02'),(733,'25414d058d18f00be96ffa87ead5bbc0','2025-02-04 10:02:02'),(734,'cd1919fd5175dd67fe5f3cf033546e26','2025-02-04 10:02:02'),(735,'27c54b8dae7e80a22ef5d3b3f6e7a6f8','2025-02-04 10:02:02'),(736,'4f729958e94258f1e084044567cae446','2025-02-04 10:02:02'),(737,'32a4fb2b9e5989ca15b952861cd0bac4','2025-02-04 10:02:02'),(738,'37312690610d404097163a070bdabb54','2025-02-04 10:02:02'),(739,'aec194592f0f416be9cfc0a333a1e186','2025-02-04 10:02:02'),(740,'4eedb5c5b3a485fbc79459a1d71a58f0','2025-02-04 10:02:02'),(741,'18739918402b3ec731f44de50eb4d34f','2025-02-04 10:02:02'),(742,'6342af4ed2fa276ccaede1339ead5527','2025-02-04 10:02:02'),(743,'040470a2ac71f7e3878664a5be5e8661','2025-02-04 10:02:02'),(744,'46f634f9f9a3606acf8d99ae9ed9c4e5','2025-02-04 10:02:02'),(745,'f847ded7fe244118fde70d2fbd473403','2025-02-04 10:02:02'),(746,'67d9505f0c2baf96e5cd11996d96ab23','2025-02-04 10:02:02'),(747,'473c9f77c7c4646cff31d175026e7317','2025-02-04 10:02:02'),(748,'b4c526f3b17fa5a613dca2fadef86975','2025-02-04 10:02:02'),(749,'9ccb520edaae4c4d685ae408887e5f3b','2025-02-04 10:02:02'),(750,'f413f80bf97b6a1b0a33cab6d8522c0e','2025-02-04 10:02:02'),(751,'31f707d536495f443d554c6e1102a0d8','2025-02-04 10:02:03'),(752,'51a2db59b3068045341e2d3785f49286','2025-02-04 10:02:03'),(753,'b622773b82b6539ac7ad45509367d518','2025-02-04 10:02:03'),(754,'8da6c9ae45979cc0d0cfbc6e6e6c6ea7','2025-02-04 10:02:03'),(755,'15f298ff56af21ce48d7ffcf13365a76','2025-02-04 10:02:03'),(756,'ca38386300a2b8df26e99ef92dec1f07','2025-02-04 10:02:03'),(757,'6f585df26b9d42a2d92386bfe4faf441','2025-02-04 10:02:03'),(758,'4222697bf6be7f67bcd3fe9f3a9cc74e','2025-02-04 10:02:03'),(759,'5aa52d23bf4916d25d9d376d0e156e1c','2025-02-04 10:02:03'),(760,'4528d69d464f3597082d8d6b88ae2da9','2025-02-04 10:02:03'),(761,'d5e8c0cd15dbf0b7e56cd0878f962289','2025-02-04 10:02:03'),(762,'00033015695337f59e82978a866c3cec','2025-02-04 10:02:03'),(763,'200bab26a46ef089c5f5a01dd1a29237','2025-02-04 10:02:03'),(764,'54c0e6089702852d3aee3ca731fe1a5c','2025-02-04 10:02:03'),(765,'fd33837b45ddfda150c50147b7fd9bd4','2025-02-04 10:02:03'),(766,'b14397fca547568d99d599716fd8d3a4','2025-02-04 10:02:03'),(767,'60c264305cd143c5dd11e07b3c03eaab','2025-02-04 10:02:03'),(768,'a8a796c356d960766240fe9b0af3bf35','2025-02-04 10:02:03'),(769,'6ecd9d6bb29e3a88cfc55990a084a626','2025-02-04 10:02:03'),(770,'76025f4748adbe53d3cc7279fcc97216','2025-02-04 10:02:03'),(771,'0fa098591195e4f285bd7d7da3221d5a','2025-02-04 10:02:03'),(772,'6c921bd8d6cd30d6a153475f26849aa2','2025-02-04 10:02:03'),(773,'b7d40652a98b62e5fcb6a2655c8959a7','2025-02-04 10:02:03'),(774,'7aa426acb0020b3c562ab165fd7eb0d8','2025-02-04 10:02:03'),(775,'cc62a31e56b9fd1ed1ed933be06865ad','2025-02-04 10:02:03'),(776,'a9587d8d0b7521bf3a61ff5adf7c596c','2025-02-04 10:02:03'),(777,'af16a47b42b3a68c679e08c85f0036fe','2025-02-04 10:02:03'),(778,'eb79413ec0569231c34dacaeb6966f98','2025-02-04 10:02:03'),(779,'c002e60a782182f4c2966f40fd749beb','2025-02-04 10:02:03'),(780,'3a33ccf867488c708c26103959c59ae0','2025-02-04 10:02:03'),(781,'db041e01e03e22eda574a3aec7463d34','2025-02-04 10:02:03'),(782,'acb7b0eda4464a8b7a75d18866e9526a','2025-02-04 10:02:03'),(783,'7fcd1be35cfecc4aa1e21a07f90bd8b2','2025-02-04 10:02:04'),(784,'6cee1c48f7020524509adf1fe45fdaa7','2025-02-04 10:02:04'),(785,'4b4e24d5632b756299d534a3acf24a73','2025-02-04 10:02:04'),(786,'200cf06c412f334720e417a5ef75dfaa','2025-02-04 10:02:04'),(787,'3c1379d59205ac4908d4423e0f61192d','2025-02-04 10:02:04'),(788,'a67311f7f35ada982e9e229cad809907','2025-02-04 10:02:04'),(789,'24d1fc0abc77fde73ab21d12ddc89db6','2025-02-04 10:02:04'),(790,'a5342b7081243116b1ed5f492072a8f7','2025-02-04 10:02:04'),(791,'049810cc38b1eb23571875817eec86c2','2025-02-04 10:02:04'),(792,'bce7f0e58dac26582e14eaba251bdb7b','2025-02-04 10:02:04'),(793,'0bfa8bedbf7d9db37c6c8bdcb0b106a4','2025-02-04 10:02:04'),(794,'6904e6e42e240dd3c9c142d57483ee97','2025-02-04 10:02:04'),(795,'23ecd563d95fc88d8f16cb2e99fbc5e5','2025-02-04 10:02:04'),(796,'6259d236c592ea3bf5eaeaf5e5d014fb','2025-02-04 10:02:04'),(797,'0618e22aa51c24f7e8fee2845a0b4e52','2025-02-04 10:02:04'),(798,'b24a1aeea867cb8234f3533ceb179f69','2025-02-04 10:02:04'),(799,'01c05fbfed40494a6c075f766e602868','2025-02-04 10:02:04'),(800,'4aac782ceb29eb304a40e6915eb5ecc2','2025-02-04 10:02:04'),(801,'44e55ec2464a7782480879335b0ea9b1','2025-02-04 10:02:04'),(802,'4aa5a8aae8986102a42522b83ac48c9e','2025-02-04 10:02:04'),(803,'fba9c968815ea766694c97a3c0eef89c','2025-02-04 10:02:04'),(804,'76a53a79a8b92a0fd811a9e0ead6a159','2025-02-04 10:02:04'),(805,'8a29400deee4899932897713a32fabae','2025-02-04 10:02:04'),(806,'9c40f79890ed29a3dfed3610a9356047','2025-02-04 10:02:04'),(807,'032fb8aab4e420ab04c48c24d93f809c','2025-02-04 10:02:04'),(808,'f74a639b6bb3dda46c275fb9f4e37f07','2025-02-04 10:02:04'),(809,'adccd1d2252283e508567354c9516edf','2025-02-04 10:02:04'),(810,'406ac3e4187df0544d7757c33203a016','2025-02-04 10:02:04'),(811,'e74f60494b5bfe2ac0e2842a4aa0339e','2025-02-04 10:02:04'),(812,'8071ca8a140c972f7a119cf4d0814440','2025-02-04 10:02:04'),(813,'8573aaa6ed01f707e5f8682b863ee0f6','2025-02-04 10:02:04'),(814,'a4e0122e77dd84ed1ab0fa83a02cdd7d','2025-02-04 10:02:04'),(815,'7538701fea1ecf4d04939f46924aab14','2025-02-04 10:02:05'),(816,'12c86bea5f7515b722ceccb1c4f119f8','2025-02-04 10:02:05'),(817,'9b67159ab454fe8807659b86c33827f9','2025-02-04 10:02:05'),(818,'b1de1345adc73c4d47135a271dbcffd7','2025-02-04 10:02:05'),(819,'7c6b9f4d1e1a36bbb3d441a79159dea0','2025-02-04 10:02:05'),(820,'cb51d3d4914e025935ffbcfbe042e74e','2025-02-04 10:02:05'),(821,'8af82f1d075c3d5b05128021e651402d','2025-02-04 10:02:05'),(822,'762d0ce8a594ddc4c822fe3de6303e3f','2025-02-04 10:02:05'),(823,'0e60b88b8106e18e3a96aa9448092584','2025-02-04 10:02:05'),(824,'12c475a8909e2e7f0f229dde1c57cd69','2025-02-04 10:02:05'),(825,'d72055ee06d2644dff0a443b447ec04a','2025-02-04 10:02:05'),(826,'4d581292f19a2c6db673f9ea08224bfd','2025-02-04 10:02:05'),(827,'4d4be279c3531d7f93ffd7d247ef6620','2025-02-04 10:02:05'),(828,'d9826817683ffdfc8f6561df3a3f8ff0','2025-02-04 10:02:05'),(829,'b728daba0067863ffc1cb5697ccd7982','2025-02-04 10:02:05'),(830,'c4de54e133ae586bb541d6ac5522dd61','2025-02-04 10:02:05'),(831,'522eac2484797ff004032adf4f8ce84d','2025-02-04 10:02:05'),(832,'00f4a18d378a282fd034c426449f07c5','2025-02-04 10:02:05'),(833,'e01985e9a18e2f1c6a7b0d46e08dea6a','2025-02-04 10:02:05'),(834,'9d78b53266655a7facca390dfb0b44bd','2025-02-04 10:02:05'),(835,'671d936d03043d62da837219402031ec','2025-02-04 10:02:05'),(836,'be5bb72d52c4ece88ffc65280f8ca07d','2025-02-04 10:02:05'),(837,'43870f09d2877c3ce676d6879000192f','2025-02-04 10:02:05'),(838,'675f6b8c5237a43ea5dcdbe26e3992cc','2025-02-04 10:02:05'),(839,'c0a836e8598c8c27972dff28bff2732f','2025-02-04 10:02:05'),(840,'988b11a4a1b60594a21b637f1a7fd5be','2025-02-04 10:02:05'),(841,'847b92923799f2406c6bdad8e412b229','2025-02-04 10:02:06'),(842,'9fb797c3551970e1382f31feca29df1f','2025-02-04 10:02:06'),(843,'c62164b566f83b613440caacbebad820','2025-02-04 10:02:06'),(844,'08bb2d380d4f8eed28f8aae4b77d4af6','2025-02-04 10:02:06'),(845,'628b0fbfc11e37f22809e0489d0fb35f','2025-02-04 10:02:06'),(846,'1ed34a9a9b2aee546ed810c2aba899f4','2025-02-04 10:02:06'),(847,'b08651380a28c6896d15978f990bc052','2025-02-04 10:02:06'),(848,'6ce8ab73baf58b9480978a1eb72e983f','2025-02-04 10:02:06'),(849,'6e711e60a764820572054c04daa21ba7','2025-02-04 10:02:06'),(850,'e215f1841eac87292176a496c2b126e4','2025-02-04 10:02:06'),(851,'731aa3a5fd91f7459785d9625cf7bda3','2025-02-04 10:02:06'),(852,'7f67657c761a4da372439f6103234617','2025-02-04 10:02:06'),(853,'1309c7c32549f2c7d9a6898a5b550782','2025-02-04 10:02:06'),(854,'6b4666f0009bb58adb3c5d164b0a23dd','2025-02-04 10:02:06'),(855,'082116e4f8f9c49054789960b35dac1d','2025-02-04 10:02:06'),(856,'fc94742dce76aa9a03107cb2d086ac1d','2025-02-04 10:02:06'),(857,'9739b41b595a5f5608cd6fb37a7dd759','2025-02-04 10:02:06'),(858,'b764a6c6705d4b753810fe1eb5186c40','2025-02-04 10:02:06'),(859,'c2b1d8607d4870c4f4ee81a5eca204f4','2025-02-04 10:02:06'),(860,'0120d9d2dde0a43d2641dc253f2f79a4','2025-02-04 10:02:06'),(861,'0070531ad9b360f631d90a6f01b948c9','2025-02-04 10:02:06'),(862,'35211a3d027386af2ff631003e7d1dcf','2025-02-04 10:02:06'),(863,'6cc4cab43e43b57d81a38902309d0b0e','2025-02-04 10:02:06'),(864,'2af62a740fea8300925e23156e7f7e85','2025-02-04 10:02:06'),(865,'1be61046c2f74629db10ad5c848fb3de','2025-02-04 10:02:06'),(866,'a5c901aca0f965a8f5e071fbc7fc890c','2025-02-04 10:02:06'),(867,'55023c50d9bb8640cde12f8ac1e1e928','2025-02-04 10:02:06'),(868,'10fe6e3f476027f366280ead62a89d96','2025-02-04 10:02:06'),(869,'8562799e2f8b60e0ada01a7f7219b9b7','2025-02-04 10:02:06'),(870,'86b3acf30ab60d7e15e3e18b681b4a40','2025-02-04 10:02:06'),(871,'d302401d0dbcb7fba49ebaf72a1371cd','2025-02-04 10:02:06'),(872,'6c82379e9d6ae1e7a39f2cebe8a0f9a5','2025-02-04 10:02:06'),(873,'ee0b8cafd272398c87320729bd488299','2025-02-04 10:02:06'),(874,'1beebf1aec6c2fd4b0c06b3a115df00a','2025-02-04 10:02:06'),(875,'8b4c696fdedc893548c4f102897693ec','2025-02-04 10:02:07'),(876,'822ffd98e5649910d0d8711431e2134d','2025-02-04 10:02:07'),(877,'53698a3b4084befef0539c41a77a6e52','2025-02-04 10:02:07'),(878,'e0576d043ae8c95035ca1688bb2c020a','2025-02-04 10:02:07'),(879,'b9673f9a20a8aa5869dc6294d2878c64','2025-02-04 10:02:07'),(880,'b3c5dacb86c80bdc2787c0e997ff5efe','2025-02-04 10:02:07'),(881,'e42315d0ffc865520d14d3589557ad2e','2025-02-04 10:02:07'),(882,'35fa455230b4ee797a1debd9813bdee1','2025-02-04 10:02:07'),(883,'bc5badf5285fe31bf530504185ef3ce3','2025-02-04 10:02:07'),(884,'006406da87cde1955572a138b7e79d8b','2025-02-04 10:02:07'),(885,'628d6858dfabd2712f04b41cf563de28','2025-02-04 10:02:07'),(886,'3c4944f92a88284df9cb8e1854d69e30','2025-02-04 10:02:07'),(887,'7502ea2e4e109125523c15347484a114','2025-02-04 10:02:07'),(888,'efa13d2f69fa8bf61f410caf1a5bfbae','2025-02-04 10:02:07'),(889,'65a165fa0526623335a1448bc37a4f67','2025-02-04 10:02:07'),(890,'5f49b4fb62b97b6892875ccdbded87ac','2025-02-04 10:02:07'),(891,'0481cb0508a7f17d78b79a39d4c736dd','2025-02-04 10:02:07'),(892,'4ecd921aa6dbcb887d9a8566f70cd233','2025-02-04 10:02:07'),(893,'dd37cc63aea2dd033af962ad2f12a6c2','2025-02-04 10:02:07'),(894,'0e7bdb70c13d6e33b38adb85bff4bcaa','2025-02-04 10:02:07'),(895,'7bc512f9c7217048d19507aea5a4c5d3','2025-02-04 10:02:07'),(896,'507c912828baaac234924ac31b02715c','2025-02-04 10:02:07'),(897,'04cfe8bee2944bb28a61f97e7e5069a5','2025-02-04 10:02:07'),(898,'145b1d0e34bb61f46aa1fe1d75a54028','2025-02-04 10:02:07'),(899,'be115859bdd5239e9862dd87820357b6','2025-02-04 10:02:07'),(900,'dfff3c53af53e1789620d0be6c33e1e0','2025-02-04 10:02:07'),(901,'3cf71da0c12c08523229e0eb27f0acd6','2025-02-04 10:02:07'),(902,'d7b683684dead1b2aa93a0991d594cd0','2025-02-04 10:02:07'),(903,'06c36631d8dd6e7ca2d2c660a19b6463','2025-02-04 10:02:07'),(904,'0752c190c6740f872dbd95ae6bfb16cf','2025-02-04 10:02:07'),(905,'122516ddbca70fa1773c46ab105836c8','2025-02-04 10:02:07'),(906,'8f39a0d6dc4a8e4b3deb5e2dd86572ab','2025-02-04 10:02:07'),(907,'a3f3695dbe22b07e95bc7eeb058dcc8d','2025-02-04 10:02:08'),(908,'1b2e703b4774522b7b7cec2328661e08','2025-02-04 10:02:08'),(909,'e7da834fd4091c8198016281c305efad','2025-02-04 10:02:08'),(910,'d028132626097a1e5302935d5c54a8b6','2025-02-04 10:02:08'),(911,'d1bd6fbb57f19b2e135196ce6a2c0243','2025-02-04 10:02:08'),(912,'38c1e415a7b1c4b60bb5928f31808567','2025-02-04 10:02:08'),(913,'2af88a9c781303fae15f05353cfe5330','2025-02-04 10:02:08'),(914,'ca8280ec4afad348f00b3068b74fa30d','2025-02-04 10:02:08'),(915,'04b701393fd4e5e6918ac470eb7e28bc','2025-02-04 10:02:08'),(916,'34fa868a14ed68b882be167d6a05f02c','2025-02-04 10:02:08'),(917,'e96fb9cea838ca3533ced5e1218929ca','2025-02-04 10:02:08'),(918,'313a4cb0c181e6dd00d8e3b4feb72c93','2025-02-04 10:02:08'),(919,'3ec6b8240836b51f61d125b9bf89240b','2025-02-04 10:02:08'),(920,'f1084561360e7012a0ae6a853693c476','2025-02-04 10:02:08'),(921,'e9088330251041c161484bd6016f0e65','2025-02-04 10:02:08'),(922,'4e8c238a07f3c84a1250ef99db9ba281','2025-02-04 10:02:08'),(923,'1dff87634a3bb15a5b229ad10bef2738','2025-02-04 10:02:08'),(924,'fc6371d2fff27414db30f378deeb75a6','2025-02-04 10:02:08'),(925,'f85c892575265c62707c4a893ece4c77','2025-02-04 10:02:08'),(926,'6d1fe47423701ba19867453b7715815d','2025-02-04 10:02:08'),(927,'b19427e993466e302f99b7303fe621e3','2025-02-04 10:02:08'),(928,'a53941a9866bb55b214c29ecf1828aad','2025-02-04 10:02:08'),(929,'f8b399c64efdab73c7e5754c2fc2ee8b','2025-02-04 10:02:08'),(930,'c3ff1297bb60c8d90818344e97e120ca','2025-02-04 10:02:08'),(931,'6287346513d90397fad2c5d93436b762','2025-02-04 10:02:08'),(932,'9804796645a9adf95e7e9c39aa9ea627','2025-02-04 10:02:08'),(933,'3a6e2aac7d7842ad7526be5b9ef8f882','2025-02-04 10:02:08'),(934,'cebf9b44be0289747fbbda22e039a242','2025-02-04 10:02:08'),(935,'bd4a0799ee1e20616e9732d9be4f8f1d','2025-02-04 10:02:08'),(936,'a94b46a12367859d58c55e7d552c46a0','2025-02-04 10:02:08'),(937,'5cef4accc5f7692733f4e03409cadf38','2025-02-04 10:02:09'),(938,'985fdcc75e65f9459ab68c2e00f0657e','2025-02-04 10:02:09'),(939,'1e1331c2f4cc2e268f5c7a4ca4b189ce','2025-02-04 10:02:09'),(940,'23d4ea9485427598ca89564aa98b95e1','2025-02-04 10:02:09'),(941,'f6147db0eb70be026f6644f7cb2812b6','2025-02-04 10:02:09'),(942,'5ced47637cbd6fdec545d82c15c98c80','2025-02-04 10:02:09'),(943,'273155adefc80e86268daf4896a44aed','2025-02-04 10:02:09'),(944,'93fa5900491a78dec59b9a5c3bf0b689','2025-02-04 10:02:09'),(945,'252762673f9b0d5b6628616c78b647e9','2025-02-04 10:02:09'),(946,'ab14055796e071e8095df194d6f8b4a8','2025-02-04 10:02:09'),(947,'045bd250a2c33dcd2063093b2550488a','2025-02-04 10:02:09'),(948,'5c3aa5bf0f1f5338417589d65c81f880','2025-02-04 10:02:09'),(949,'cbeb28e07ce3fb651286a5b3d53850a2','2025-02-04 10:02:09'),(950,'b7ae11820750b9863c3c166381c00a9f','2025-02-04 10:02:09'),(951,'f9908b9be13bd025f020e6fac5488cdd','2025-02-04 10:02:09'),(952,'a1fe803b1dc776792fef24ad9ef9d55c','2025-02-04 10:02:09'),(953,'0666c973b3f8fe08e79c3324d1d0f412','2025-02-04 10:02:09'),(954,'07ed44ea45114d1decbf8da13c20da94','2025-02-04 10:02:09'),(955,'25426534e114df142d58c3d8dce5a44e','2025-02-04 10:02:09'),(956,'aaf3fcaa60213a0e00e8f60d82ebe7d0','2025-02-04 10:02:09'),(957,'bc58aec3908261e145470fd99acf8f86','2025-02-04 10:02:09'),(958,'70398096e4c5e82530e9b2cef5488c25','2025-02-04 10:02:09'),(959,'22fee79d1c4acf216cf66c423e114a9b','2025-02-04 10:02:09'),(960,'ce07615c97804c9979e5348bb42d9827','2025-02-04 10:02:09'),(961,'3a3c94862a2d72595ec52cf9baa04792','2025-02-04 10:02:09'),(962,'8ee8aff37c75cccf93ca65c2219d8462','2025-02-04 10:02:09'),(963,'08926c4a5eb37abe7729b263558cb76f','2025-02-04 10:02:09'),(964,'9a32c22f8370fe237b7d4be9ce7c7b41','2025-02-04 10:02:09'),(965,'08db0227d196e56297b198e982fcf5f1','2025-02-04 10:02:09'),(966,'8c0fb946b3e8a92186fcbb0352369847','2025-02-04 10:02:09'),(967,'4480c068c0fd8986660c2acec57c33ef','2025-02-04 10:02:09'),(968,'af268f93c50a5ad0790f59c86fe6a68b','2025-02-04 10:02:09'),(969,'2fa7d789131fadede01b2b81f495e515','2025-02-04 10:02:09'),(970,'eb29c38f5d5132b01f08b40c7ace6469','2025-02-04 10:02:09'),(971,'38a23d71e72c83af8c60250bb1d1e94e','2025-02-04 10:02:09'),(972,'f80696b4a81f508de604b36cacfdd3fa','2025-02-04 10:02:10'),(973,'ee3fac7ba7fffc4e5377a1996ed4eec3','2025-02-04 10:02:10'),(974,'6ef49b496d82de0e498e97c392bac441','2025-02-04 10:02:10'),(975,'be1eb08608589b816e30a30f51b3ad5e','2025-02-04 10:02:10'),(976,'50687abdc4126d8e66a605ca68752fef','2025-02-04 10:02:10'),(977,'f26f6f501933626e9a6b2321bdafdcdb','2025-02-04 10:02:10'),(978,'238baa21235d83d3991100a6fddc2d99','2025-02-04 10:02:10'),(979,'198f0ec39b18189dfc18adde522b27a7','2025-02-04 10:02:10'),(980,'a0320e266e0653518b33a89fff9286e1','2025-02-04 10:02:10'),(981,'03d0997066095f43cfe41b85ee6c837e','2025-02-04 10:02:10'),(982,'1713b808aaa76871e68d6b00eb20a5e0','2025-02-04 10:02:10'),(983,'6af1a80d8b7bfa94b01f462e2d54b92b','2025-02-04 10:02:10'),(984,'add5a48fb2d00a5a347825b8311165f9','2025-02-04 10:02:10'),(985,'711aa85ec461c6024a5b1970dcd26fe3','2025-02-04 10:02:10'),(986,'eb20d79f8015a93a2ead257f39e69357','2025-02-04 10:02:10'),(987,'ad6239fae7f36063b3c043105a715ada','2025-02-04 10:02:10'),(988,'55edcea21089945dfaa2352a1eee38e0','2025-02-04 10:02:10'),(989,'32c3b1a03573cfd49f8f2ca964d434b0','2025-02-04 10:02:10'),(990,'d02a2e411c6768a7210b9c8c9ef6ac66','2025-02-04 10:02:10'),(991,'4e0047f6eaaee3d397b603c6ab981da4','2025-02-04 10:02:10'),(992,'c43011feb2bb5780bca649b144b42bac','2025-02-04 10:02:10'),(993,'e7c05a4e6315d35c82b2b387ea1ef635','2025-02-04 10:02:10'),(994,'c5a056ad05819bc54ae58713a890e203','2025-02-04 10:02:10'),(995,'1fd5e0642ff87f3c822fcac7e09b6718','2025-02-04 10:02:10'),(996,'2462b0a55f465ccdb325655ce1602835','2025-02-04 10:02:10'),(997,'c2a567cce4ad1360c52a49518476c087','2025-02-04 10:02:10'),(998,'f0044307da309f2f9cd78e6db1448a85','2025-02-04 10:02:10'),(999,'bec352abd55928c8c1edc207cdae7a49','2025-02-04 10:02:10'),(1000,'5c9c33dcb61af9c49d09a99921e7ef03','2025-02-04 10:02:10'),(1001,'b951584fff1ebecef38126c37a61b9cb','2025-02-04 10:02:10'),(1002,'82ff73ff7548090bb189e08bff116d82','2025-02-04 10:02:10'),(1003,'23971fae6804bf19084dbc29c8c48f50','2025-02-04 10:02:10'),(1004,'60fcc853fc835d4cc2208fb81c7e812b','2025-02-04 10:02:10'),(1005,'420fa4f20c1de98ab2a8194a1a1eda8d','2025-02-04 10:02:11'),(1006,'4724a049960fde9b7b4ee1f856826d4d','2025-02-04 10:02:11'),(1007,'ec8f59f1940e7235b752f67216acce17','2025-02-04 10:02:11'),(1008,'0a5ae343c31807d8effdde364022f004','2025-02-04 10:02:11'),(1009,'c845ef969512f3e6e095c1b3b75713dc','2025-02-04 10:02:11'),(1010,'c69f4a00c8b15202de9d76fae49fc32a','2025-02-04 10:02:11'),(1011,'5f7be32dd91a8c1cf35bed67e96a4422','2025-02-04 10:02:11'),(1012,'8fcbc60219bd2d03909b4972bf580c91','2025-02-04 10:02:11'),(1013,'30a722d50331d0ea5265f1c947f68ccd','2025-02-04 10:02:11'),(1014,'182c46d4fceb99c0c25044b576f2203b','2025-02-04 10:02:11'),(1015,'e040bfa3b3ab6ff4eab90a61f351f869','2025-02-04 10:02:11'),(1016,'4cc2154c1922e5011ae58233706fba6b','2025-02-04 10:02:11'),(1017,'7bac6814312d443fa5add59b5775f40c','2025-02-04 10:02:11'),(1018,'73a81b184b552348f5bbefdddf64c3ae','2025-02-04 10:02:11'),(1019,'f3b31a98e6d1f67bf3fcb4da4c2fa6a6','2025-02-04 10:02:11'),(1020,'ba5ee5cf2da10d5051ea358af6df9135','2025-02-04 10:02:11'),(1021,'39930766965b93683223147f59635da1','2025-02-04 10:02:11'),(1022,'d328212d7659a1d77bc68a8258ff9691','2025-02-04 10:02:11'),(1023,'1fae47ed1694593091d740679f24581e','2025-02-04 10:02:11'),(1024,'77844cd78794b391db4921e726c253d6','2025-02-04 10:02:11'),(1025,'b634a22176661b77f6858b2881477436','2025-02-04 10:02:11'),(1026,'46c410c40406b4bf7256ac32c3f14e54','2025-02-04 10:02:11'),(1027,'a7f185ab2565a2611dde3a8194d55908','2025-02-04 10:02:11'),(1028,'bef88179943798bf3c1c12048e2db72a','2025-02-04 10:02:11'),(1029,'e64bdfa6403e02cd89e6f3d222a4f563','2025-02-04 10:02:11'),(1030,'1736f9f323ab7cdaa90e777677399113','2025-02-04 10:02:11'),(1031,'e5620d6ff1d5d7537d3c6f40a7de8a27','2025-02-04 10:02:11'),(1032,'c886560451aa333fdfb743edf2183207','2025-02-04 10:02:11'),(1033,'185562ea3e3ab6913fc19ec06bd9c845','2025-02-04 10:02:11'),(1034,'0b62d974df1656fb836cef9adb205dc9','2025-02-04 10:02:11'),(1035,'5c476f0781a65ea75c9e6f927e7704c1','2025-02-04 10:02:11'),(1036,'2e01a1c82f29539e9d8c3c80c6d08b03','2025-02-04 10:02:11'),(1037,'22bc258a23ce4d055cb81ff141600080','2025-02-04 10:02:11'),(1038,'7690178aadcc229965455670637f6942','2025-02-04 10:02:12'),(1039,'b69f2ad3f870c1333630ffed2ec3007e','2025-02-04 10:02:12'),(1040,'ab1d15a7fca848ef456e21a79b3e640e','2025-02-04 10:02:12'),(1041,'6c2c4b4ec9e73037e45ddfa67814a628','2025-02-04 10:02:12'),(1042,'8fe58065d0babdde35cf584287716bfe','2025-02-04 10:02:12'),(1043,'16a075cb40f8161f36475c9cd470104c','2025-02-04 10:02:12'),(1044,'9505ed612c04ebd5d33c7e3e0f67586c','2025-02-04 10:02:12'),(1045,'0356a06346955998f50162e1311ce944','2025-02-04 10:02:12'),(1046,'8397f72c0fc99679afa651566445f1c0','2025-02-04 10:02:12'),(1047,'bd9779d458b557b26388f334219aa2ca','2025-02-04 10:02:12'),(1048,'7dcdc270fa3570c43359fffa608d4c73','2025-02-04 10:02:12'),(1049,'956dfb4fb9b91e623b017a1fcf5e44e1','2025-02-04 10:02:12'),(1050,'0dc28e23a27eb5c186b24602591b2195','2025-02-04 10:02:12'),(1051,'11b594d28d311c4dde91af94db6886b4','2025-02-04 10:02:12'),(1052,'eeb79463aae71894afeb34e468dddcf0','2025-02-04 10:02:12'),(1053,'7ee8f7bf72b2fc3213b7472f68826d34','2025-02-04 10:02:12'),(1054,'8bc99639ef69cc83973b2e11016c041d','2025-02-04 10:02:12'),(1055,'951536d4158ae15640546fcc5fd5ee2a','2025-02-04 10:02:12'),(1056,'e6f53de9bc482c2da3dfb7b880b321d5','2025-02-04 10:02:12'),(1057,'7da49b7283557b1c4f978e4e7f2890df','2025-02-04 10:02:12'),(1058,'7c8e2f2d1e35a994025c0350a108cbef','2025-02-04 10:02:12'),(1059,'76c7260369eebb542be4dc9f53b9193c','2025-02-04 10:02:12'),(1060,'567fee5f7a1fabc23baccd857f1d210a','2025-02-04 10:02:12'),(1061,'2f98d18bac9a5f587a69747f5454ebb4','2025-02-04 10:02:12'),(1062,'5925cb8cd4bfe19a45c47c5c8c39dc2b','2025-02-04 10:02:12'),(1063,'d0151d39ecb8176ac4ae89ec7a372682','2025-02-04 10:02:12'),(1064,'5e5d48219a5254022b5449f939ab9b08','2025-02-04 10:02:12'),(1065,'5f8f3c37125e4c3ddea4d2a9f1076319','2025-02-04 10:02:12'),(1066,'c95ef8ba32ef1e41efe88db86bede245','2025-02-04 10:02:12'),(1067,'cbd452ff6e2288ba2784c2ab7b62533e','2025-02-04 10:02:12'),(1068,'aea9cc615d41dae75c33505d68525bd1','2025-02-04 10:02:12'),(1069,'2a8aec3a3e8fd36b651486550a07df5d','2025-02-04 10:02:12'),(1070,'3f5bfa447a67c55a20d062c78203c487','2025-02-04 10:02:12'),(1071,'4ea56ec62c51ef9b4d26ee4e928a925c','2025-02-04 10:02:12'),(1072,'3bebc1dc91a572475b991c3ec5e98177','2025-02-04 10:02:12'),(1073,'8178af383e75acecf86201b1c421aa65','2025-02-04 10:02:12'),(1074,'79ea128f75bc0ff83769b3405ff30358','2025-02-04 10:02:13'),(1075,'c753d40a3f7b4cd427702c6f7ab8fd60','2025-02-04 10:02:13'),(1076,'fe775644198704b2a63b97e65314ab4c','2025-02-04 10:02:13'),(1077,'53256b3ee3c18fe4ab713aea754bdd0e','2025-02-04 10:02:13'),(1078,'1fbec0960479eea5ee1623aa564368f2','2025-02-04 10:02:13'),(1079,'e8569f283797a2b98d57365dcca5ff07','2025-02-04 10:02:13'),(1080,'4e9b33b42eb2889d365b7454126d3644','2025-02-04 10:02:13'),(1081,'9618a6cad7609c50166d7028b6cf6dc3','2025-02-04 10:02:13'),(1082,'38a73d17b35dad3563d2cef3f3808c47','2025-02-04 10:02:13'),(1083,'01464427e5a15a47b6e700938708baa2','2025-02-04 10:02:13'),(1084,'b5f683bbad8ccb307dff4ccb7fec9ee3','2025-02-04 10:02:13'),(1085,'854a689dd23411086dd67ef359d07519','2025-02-04 10:02:13'),(1086,'b01b07a6bb08f39926721af44f010b95','2025-02-04 10:02:13'),(1087,'45b03c026538aa1c537a717477eb79da','2025-02-04 10:02:13'),(1088,'093a16f9edac5b4828a97ee90c54558f','2025-02-04 10:02:13'),(1089,'8f3167c0a6aa458ad4c42a9a6e0fc057','2025-02-04 10:02:13'),(1090,'9f0adb2b6f0cd8555de6ae358dc7af39','2025-02-04 10:02:13'),(1091,'ed193dab20fbd774573838c143ed6705','2025-02-04 10:02:13'),(1092,'c643de62b43072f8aa3c7a709b58edae','2025-02-04 10:02:13'),(1093,'b2fcd8336716641b99e80f5ca7b61ce7','2025-02-04 10:02:13'),(1094,'02ebcfe65d83a309f5ef2ce87eff850d','2025-02-04 10:02:13'),(1095,'29a9f92cbfea8e130792de7ebeb59dba','2025-02-04 10:02:13'),(1096,'6a4c9e2657bb48b513ac659b02598b07','2025-02-04 10:02:13'),(1097,'d45dcbcbd30f16a007563f2624076861','2025-02-04 10:02:13'),(1098,'ca876e9e7a7f01e53ddaa5b6d435224c','2025-02-04 10:02:13'),(1099,'e38485af59beb1792cc226f070f2c283','2025-02-04 10:02:13'),(1100,'2164088f9ca1b46c0b788d6cca77fc2e','2025-02-04 10:02:13'),(1101,'6a95dbea34e0feeda44505e77f80b095','2025-02-04 10:02:13'),(1102,'63c2de2b742fa6f5257c3428c37e79e9','2025-02-04 10:02:13'),(1103,'c0d60e2fe65c947e050138d963910ca7','2025-02-04 10:02:13'),(1104,'d496b87f98c0331f4760f68e2553a815','2025-02-04 10:02:13'),(1105,'841538199de0a11de0bf172b0f4ca385','2025-02-04 10:02:13'),(1106,'1249bc0789d8f203bbeb02eae9e98909','2025-02-04 10:02:13'),(1107,'87904f5510f768be80a089a547489cb9','2025-02-04 10:02:13'),(1108,'acc31a47eeba1347bad9e66d0360dd0f','2025-02-04 10:02:14'),(1109,'a043693b5256fc4e62ce125fa1ef125c','2025-02-04 10:02:14'),(1110,'d58473b509cc11a362b7c6ffda2f36aa','2025-02-04 10:02:14'),(1111,'925af32199ef095bdb048d6d6a704f24','2025-02-04 10:02:14'),(1112,'e47f06e18a4cb1c4b774f34e8fe2e33c','2025-02-04 10:02:14'),(1113,'35b100f7ef94469d14aab3a4e558d73e','2025-02-04 10:02:14'),(1114,'eca207b5a4d8153e3e09ad88f38abbb6','2025-02-04 10:02:14'),(1115,'a6cc883f3fac818d977a75267fd35c51','2025-02-04 10:02:14'),(1116,'9e3563783fc0b64e8d1dbb406a084321','2025-02-04 10:02:14'),(1117,'2f3b8030bb6aabebeb5e7178d4eebb54','2025-02-04 10:02:14'),(1118,'92f214cd1b4f156362ba8a3ff4a9047e','2025-02-04 10:02:14'),(1119,'c1d18d6635592caa5d1880a99d536589','2025-02-04 10:02:14'),(1120,'1a64204652f5c1677b8fb243976fa240','2025-02-04 10:02:14'),(1121,'b99e727a4cc4bc191ae9035d3c0bd0e5','2025-02-04 10:02:14'),(1122,'1ef9719fa95edb5e380f70c074741339','2025-02-04 10:02:14'),(1123,'d54928abc4d8f4873005342dbfa255b7','2025-02-04 10:02:14'),(1124,'a9b05c5e7d02f21309153cc37f660800','2025-02-04 10:02:14'),(1125,'ceb5ac42113b7423ea455a920e12f94e','2025-02-04 10:02:14'),(1126,'7c5ad76415573576d373484be05d696a','2025-02-04 10:02:14'),(1127,'393acebe42e7549f6118c6aff3e417f7','2025-02-04 10:02:14'),(1128,'d0316d92e6373c7852969e78bcfb94bd','2025-02-04 10:02:14'),(1129,'b5aa8560fa721ad8a32395721c2bb6d3','2025-02-04 10:02:14'),(1130,'c601be38915736886314057144e96ac6','2025-02-04 10:02:14'),(1131,'4b8ad68eec4eb0a379e557eead6d34e7','2025-02-04 10:02:14'),(1132,'d1d07fd65aa5ddf6d17a0b3012db99ba','2025-02-04 10:02:14'),(1133,'28f0a9189b2a5e3f1a3bf5370bd0d0ac','2025-02-04 10:02:14'),(1134,'5230ed294842f510d7ffae5705ad4c82','2025-02-04 10:02:14'),(1135,'6e594251517c9bfa45a55bd012c1df47','2025-02-04 10:02:14'),(1136,'a30ec0c3eb3727a87b9669848de6821e','2025-02-04 10:02:14'),(1137,'edcbadd2e44f857ae1a0712bd2c2ce18','2025-02-04 10:02:14'),(1138,'9d273f2a71b63775a64fa5610a325f4f','2025-02-04 10:02:14'),(1139,'bd8a04c198c249fd33b01e5df06c5d35','2025-02-04 10:02:14'),(1140,'dcf45fc69667ce04553030a163b43475','2025-02-04 10:02:14'),(1141,'81decb24a8a12f90c574b1573c8e8df9','2025-02-04 10:02:14'),(1142,'deec72e2405140a1a896594ae6256a45','2025-02-04 10:02:14'),(1143,'d51c5a0e7369580310dc9cc0c8b45f7b','2025-02-04 10:02:14'),(1144,'e4d09fffe156ec4fa0fe97212bd644b3','2025-02-04 10:02:14'),(1145,'a3999d5a812c1dc258b9aed5d20941a0','2025-02-04 10:02:15'),(1146,'dc80e19d857c44d2a98050cf27b9fe87','2025-02-04 10:02:15'),(1147,'c128071c2da0b7ca144d69fdb6da5b88','2025-02-04 10:02:15'),(1148,'750a96a08a0dbf75ceec47ef5b8fc370','2025-02-04 10:02:15'),(1149,'dce132eb7bb3c9aec5b4285df0c2a423','2025-02-04 10:02:15'),(1150,'4bca0ba98f9fafdcc10331904cf6ed1c','2025-02-04 10:02:15'),(1151,'b45af71bfc05d71e57c083746ae07eb2','2025-02-04 10:02:15'),(1152,'4191e9bd55de79b77c14fee867b049a7','2025-02-04 10:02:15'),(1153,'b500892dcae98d0e5f2394cb9c00850c','2025-02-04 10:02:15'),(1154,'67d57cb14661f00fd617e6d728121065','2025-02-04 10:02:15'),(1155,'3f948069add4befab622201f388b00f5','2025-02-04 10:02:15'),(1156,'1bc7f1cfb95c160e0d074385def31324','2025-02-04 10:02:15'),(1157,'a3103a1222cf2ee764f53dbd11c89be3','2025-02-04 10:02:15'),(1158,'e67d01ea67708e27815f2077fb1ea515','2025-02-04 10:02:15'),(1159,'e7756f72f5b1e0a9e74ed6bb63df1230','2025-02-04 10:02:15'),(1160,'916525147f6fdb6f6b4af9acea13f67e','2025-02-04 10:02:15'),(1161,'9ec1ac66de3713af9d30809c68470c0f','2025-02-04 10:02:15'),(1162,'3e1c5b1a71e893d02f54a4e5da2c5997','2025-02-04 10:02:15'),(1163,'d916962e92082aa8b637ad7db26a97ff','2025-02-04 10:02:15'),(1164,'907cfb7d6b7ad6a322d543bfdc13263d','2025-02-04 10:02:15'),(1165,'9d619475d3eb68c08ddb6a94c9f94d4a','2025-02-04 10:02:15'),(1166,'14f6e1e5ea6644d2589b2746d8806db5','2025-02-04 10:02:15'),(1167,'527f7ccc1325b84bbc1b9cea6ec9666a','2025-02-04 10:02:15'),(1168,'a621ba34bc46d339a4ce1f7693631ded','2025-02-04 10:02:15'),(1169,'9547207394ddecf06ee83e891174b95a','2025-02-04 10:02:15'),(1170,'48ee32142448b50d7276f40a25d77c40','2025-02-04 10:02:15'),(1171,'cb459949fa10c1e909e91b2d7425e4fc','2025-02-04 10:02:15'),(1172,'f013fb782267a8e06f5504aa1419c65e','2025-02-04 10:02:15'),(1173,'0a3c27e8c2d691b976e03a18efdc2053','2025-02-04 10:02:15'),(1174,'aa54ef53baf4d7b6554b9a694c22f7fd','2025-02-04 10:02:15'),(1175,'070568b651b86b2292d6c6a866f4005c','2025-02-04 10:02:15'),(1176,'fe28fb4a9188689de2975cbdd9acea29','2025-02-04 10:02:15'),(1177,'f528abbe3740b8d73e168fe14527accd','2025-02-04 10:02:15'),(1178,'0659aa8d907e46c95c973a3f14e432f0','2025-02-04 10:02:15'),(1179,'31482466a25ecd098673e513ad620392','2025-02-04 10:02:15'),(1180,'caa9ff760a3c4330695fc4a741c89941','2025-02-04 10:02:15'),(1181,'3d79c6c3dc18c53765ddefd397715006','2025-02-04 10:02:15'),(1182,'6db8041beed14271b20360fff8705c4c','2025-02-04 10:02:15'),(1183,'bc0582e598f5c90d2f86da88ae534601','2025-02-04 10:02:16'),(1184,'160598c8b80278f0da5a4ef52c2993db','2025-02-04 10:02:16'),(1185,'1362026ad4ef641a70567e9043acd9c2','2025-02-04 10:02:16'),(1186,'2d61c6f579da70160cc84f33fb0e4e52','2025-02-04 10:02:16'),(1187,'792e1756544b89f2cd156b5b0ba69694','2025-02-04 10:02:16'),(1188,'f2a82bfce9ddfcb18e666bf892989630','2025-02-04 10:02:16'),(1189,'a26ad8f16fae8b9c670098e628ac5c6c','2025-02-04 10:02:16'),(1190,'30e5561c8f07222efecad4cca3ad8f3e','2025-02-04 10:02:16'),(1191,'ff8641250787f3c965c66c2f203a012a','2025-02-04 10:02:16'),(1192,'d56c44fcb5e1e0756605222974eb84f2','2025-02-04 10:02:16'),(1193,'b43234455aa017cb99a982e576837d53','2025-02-04 10:02:16'),(1194,'b0d51658454566b144ad43bb22b7179d','2025-02-04 10:02:16'),(1195,'cef81fb9a4f9541c065f30062a568b8e','2025-02-04 10:02:16'),(1196,'ec2429800d28b3e65e8d7a15f566d7b6','2025-02-04 10:02:16'),(1197,'c99641f16a6609a09b59fd7c316b2d74','2025-02-04 10:02:16'),(1198,'a1dfbbc2910965825fedf592040fe4ff','2025-02-04 10:02:16'),(1199,'a3d40bdc78967cbb5eadcb620fe94281','2025-02-04 10:02:16'),(1200,'0eebbc134e20a940e588c7e42b32d076','2025-02-04 10:02:16'),(1201,'f8c742997f490a4590179ff9ad8c619b','2025-02-04 10:02:16'),(1202,'44c9dd37396789dfd56857bd32442347','2025-02-04 10:02:16'),(1203,'33c3309010c8a820fc99838f25a4930d','2025-02-04 10:02:16'),(1204,'b6474641781766b4a45f1d42637a7ae6','2025-02-04 10:02:16'),(1205,'256d8eee19e5c73e25f4e8aad656f1b8','2025-02-04 10:02:16'),(1206,'cf2a4ad27557e2135cc3579912f6763f','2025-02-04 10:02:16'),(1207,'d1a5f8397903cc298e715acb111df54f','2025-02-04 10:02:16'),(1208,'cf07524a02efc7b83c33e6776f7ce2eb','2025-02-04 10:02:16'),(1209,'6e2ff127479085c3d38d8ce94611e572','2025-02-04 10:02:16'),(1210,'2b2ef98f64dc4ee1be1c2b71fe386e51','2025-02-04 10:02:16'),(1211,'8a7138da1b845a045994cf587881dfff','2025-02-04 10:02:16'),(1212,'8c7c9c267f25b136c5fcf33e0c5fdb99','2025-02-04 10:02:16'),(1213,'13e3795867050efc226bbf98992f785f','2025-02-04 10:02:16'),(1214,'814a50d0514acf1f247708d46a129a3a','2025-02-04 10:02:16'),(1215,'7761e91eb48b8495d36ba96308a9a8c7','2025-02-04 10:02:16'),(1216,'184a10be27dfa459edaade399913b4db','2025-02-04 10:02:16'),(1217,'253b7974336c1af2384b22afc01aca8f','2025-02-04 10:02:16'),(1218,'6907b4618206a9da13cc37ccf0ce439c','2025-02-04 10:02:17'),(1219,'0bfb53f84c9ec17dcb945628c9383dfa','2025-02-04 10:02:17'),(1220,'e78d53097636d9d41598ec3cf908f5de','2025-02-04 10:02:17'),(1221,'667c625f868871012fabb39080caff04','2025-02-04 10:02:17'),(1222,'1fa0e3f244e578e0b5ee89e478fab35a','2025-02-04 10:02:17'),(1223,'d50c6437ae922ab5ac72adf497a54a88','2025-02-04 10:02:17'),(1224,'98e03a75862641eb436cfd1f6561e8c1','2025-02-04 10:02:17'),(1225,'b94b167a66948b7033b5eba8550d7699','2025-02-04 10:02:17'),(1226,'ea18843d56a22113bcea806452687ebf','2025-02-04 10:02:17'),(1227,'b37dae05968481ecedfc8993d389e2b6','2025-02-04 10:02:17'),(1228,'f2c6e7177391b127afc76e16367cf93b','2025-02-04 10:02:17'),(1229,'bf202c75c9856dfce2b950e009cb122a','2025-02-04 10:02:17'),(1230,'ca90792823f39b7904d1aae66014923e','2025-02-04 10:02:17'),(1231,'d94b709e462d9bc5aaf09fb565b12582','2025-02-04 10:02:17'),(1232,'0a154724cec8d4edc2f43195c926cc71','2025-02-04 10:02:17'),(1233,'073f035bcfaf3010df5f0a0841a9902d','2025-02-04 10:02:17'),(1234,'d1520eb385af42d89ccd71c95f3a7b26','2025-02-04 10:02:17'),(1235,'e8bc93c636b7c20a07629ae4ec7eee61','2025-02-04 10:02:17'),(1236,'196357bc09637e7ab1f54e7a444521cc','2025-02-04 10:02:17'),(1237,'d36502548b7c82c33fe74bc58326ceac','2025-02-04 10:02:17'),(1238,'c57b03291cb1729df80fd7e3fd96bf71','2025-02-04 10:02:17'),(1239,'78d56e9d900416e5faaed4e6e5762486','2025-02-04 10:02:17'),(1240,'491f0b9befd604e8d9ee8fc13e85a967','2025-02-04 10:02:17'),(1241,'ea13b18c52c127e979765706ac5b47a8','2025-02-04 10:02:17'),(1242,'7725af9f9ea544a3ba4021409afcf6b4','2025-02-04 10:02:17'),(1243,'072d50d7dfa2e2826ebeb659eeac3dbf','2025-02-04 10:02:17'),(1244,'8593340e29dc356656b28269d2a40fae','2025-02-04 10:02:17'),(1245,'60b0472253ac77244ab8768b86acfbcb','2025-02-04 10:02:17'),(1246,'7b83054c3ab2bc39ba6a343a7c2f43c2','2025-02-04 10:02:17'),(1247,'41c764073e84bd9bdfc8fbe267d68837','2025-02-04 10:02:17'),(1248,'3c049d0e73b7f77c67b1ef884872150e','2025-02-04 10:02:17'),(1249,'54283e7a5f1502cf5066600b4ddd1aa3','2025-02-04 10:02:17'),(1250,'d78be58e05afab57ab28749b6344a583','2025-02-04 10:02:17'),(1251,'d3fba33cd438f48b96d514fc4aea3517','2025-02-04 10:02:17'),(1252,'d0e6b2066b149463734d22ab72ead4ed','2025-02-04 10:02:17'),(1253,'d39452d0ae3bb3d49b92689a9b61627a','2025-02-04 10:02:17'),(1254,'31d20742f9c16ec693e8796ce689c286','2025-02-04 10:02:17'),(1255,'7cacd3638ea64f4525983fc41dbdc8f4','2025-02-04 10:02:17'),(1256,'c569114930e246dc6d085ea60b4c30b4','2025-02-04 10:02:17'),(1257,'d6a8e812120a7039e95d018d431ebcfa','2025-02-04 10:02:17'),(1258,'85ab032007800cf2c1ccd7cfea4a0212','2025-02-04 10:02:17'),(1259,'d76cbbd8b980340a60cd56878ca0183d','2025-02-04 10:02:17'),(1260,'faf5408636f86c4225adb121adc55ff2','2025-02-04 10:02:18'),(1261,'7bd5414ce5424cc6782c6768f0ef8dde','2025-02-04 10:02:18'),(1262,'6c3df75f31f56d4f579e8b550fd4fd9e','2025-02-04 10:02:18'),(1263,'f8900ebf4f8030df4b151efeee5a6d5e','2025-02-04 10:02:18'),(1264,'625ec8f8bcae3765059db2068f8bc3f3','2025-02-04 10:02:18'),(1265,'53a66278832094476876e6f371d237b4','2025-02-04 10:02:18'),(1266,'792a0cfc7e2b7260774e2d3bdf71e254','2025-02-04 10:02:18'),(1267,'dacc8bdf20de73458d7c43d42c93715e','2025-02-04 10:02:18'),(1268,'c4a7a20907848478cbc3ada8152f2302','2025-02-04 10:02:18'),(1269,'1a6c29b2f5f027cfadb956bb27542c10','2025-02-04 10:02:18'),(1270,'79e91200e63ae54da06f647c6102fa3c','2025-02-04 10:02:18'),(1271,'737e885844a4deb41dca1efcc42df2a8','2025-02-04 10:02:18'),(1272,'4c5d05d508717e8ae5af987e8d9e272c','2025-02-04 10:02:18'),(1273,'5288c4ecf19f3aa4ec36c612bf3b4762','2025-02-04 10:02:18'),(1274,'da7d358a1d9871c4f570f9d5e30f791a','2025-02-04 10:02:18'),(1275,'00ea941b248e91f801afe843ed79b256','2025-02-04 10:02:18'),(1276,'a3d6f3b37e1e738ca9ac508c3315fc19','2025-02-04 10:02:18'),(1277,'9f2d63c44a73f11c3ba76e3be93cc3fb','2025-02-04 10:02:18'),(1278,'3a88724b725d4bb0d96d0a294d47d764','2025-02-04 10:02:18'),(1279,'430823dcb427e91934f9f24db8bb481e','2025-02-04 10:02:18'),(1280,'8678e569585e3610eee4515b279b6cf1','2025-02-04 10:02:18'),(1281,'524b9d10b993af75211c6c3fa3090f8a','2025-02-04 10:02:18'),(1282,'c291cc8983c76269b81c56dc81d8da1f','2025-02-04 10:02:18'),(1283,'6ac45b6129a388e6052524a6b7f91bca','2025-02-04 10:02:18'),(1284,'885975df7745474ff74169fa1701b3cc','2025-02-04 10:02:18'),(1285,'7a574df4f951b8e175915d28741a111b','2025-02-04 10:02:18'),(1286,'89646effe8f5d222a63debef0636772f','2025-02-04 10:02:18'),(1287,'93eb2fcffa71a4e080bd4068d19cb59f','2025-02-04 10:02:18'),(1288,'8e5b95ae5dcdded4957329888ceccc53','2025-02-04 10:02:18'),(1289,'309f46902bb71eae0f6223a9472314c9','2025-02-04 10:02:18'),(1290,'abb2f3098a5a573a16391b702588cea2','2025-02-04 10:02:18'),(1291,'3e7d1fb1549b3c9e119463f6820c7af1','2025-02-04 10:02:18'),(1292,'946b434f4a26cc3e5b4c24805397b05f','2025-02-04 10:02:18'),(1293,'0d6de4f2f5e9ad07a5ae54d253baaf24','2025-02-04 10:02:18'),(1294,'f92fe816eb48341d142bf85d88992369','2025-02-04 10:02:18'),(1295,'b695edf82c5e80e69a287171da96e2ff','2025-02-04 10:02:18'),(1296,'633bfe96961ee647caece78b0d2138a9','2025-02-04 10:02:18'),(1297,'ae1397f21b68b037af3e2ad441fd64d1','2025-02-04 10:02:18'),(1298,'db49461b8f1aa8e0e7df1e20c104a5b9','2025-02-04 10:02:18'),(1299,'52c2d427a6e8d7ecfa6c5f25ac7ee35c','2025-02-04 10:02:18'),(1300,'fc10f4da405008e00dce8a31ae863d17','2025-02-04 10:02:19'),(1301,'52d20df6da3012f425fd21ace2e414d9','2025-02-04 10:02:19'),(1302,'9116dfc635a082495b03278101100799','2025-02-04 10:02:19'),(1303,'8dfb0c1ace3bdece22168f0f2ecc92e4','2025-02-04 10:02:19'),(1304,'5da8d1e52f046a869e30424b68a7358f','2025-02-04 10:02:19'),(1305,'3fd73affb8764d29c08f5dccbd09ff31','2025-02-04 10:02:19'),(1306,'daceb7c9e550d552620973a5289e55c7','2025-02-04 10:02:19'),(1307,'f14243a510b96b62a4973313df4b586e','2025-02-04 10:02:19'),(1308,'58e7f012766dfbc2276f3286fd142057','2025-02-04 10:02:19'),(1309,'ab692e28dc28b9258b25f6030d24f62a','2025-02-04 10:02:19'),(1310,'de387c1f0d5d6175993bcf880658a17e','2025-02-04 10:02:19'),(1311,'a4c74e5dfe4fe46784e1597a81f599cf','2025-02-04 10:02:19'),(1312,'2c71fdfc180c54fe68044f9a449efc93','2025-02-04 10:02:19'),(1313,'a30bd3848abfb52c351bd18d7197baf6','2025-02-04 10:02:19'),(1314,'4078e229d3f5c859cc08897e7242e55d','2025-02-04 10:02:19'),(1315,'f8cf10124e5fb3b5a0e3d92de854a5b5','2025-02-04 10:02:19'),(1316,'f82cac072a7d75fa46dbcad4e6687159','2025-02-04 10:02:19'),(1317,'9ecdc98ac534d2f7e0e977f47e32b9dc','2025-02-04 10:02:19'),(1318,'d8bc184ea8c43ca574501890b3b383ae','2025-02-04 10:02:19'),(1319,'4c784a13790ff5d51105a6383a60ecc5','2025-02-04 10:02:19'),(1320,'ea1662646f97d4b00fa40a59957e0ef1','2025-02-04 10:02:19'),(1321,'074b3c01857b1e65bd066f90e0fe5617','2025-02-04 10:02:19'),(1322,'92fffe65d5464373a8c6b91b7005b536','2025-02-04 10:02:19'),(1323,'813f865c561df3b3f413346283b2b135','2025-02-04 10:02:19'),(1324,'8c1f05f6104fff1c1945fcf38f7833b6','2025-02-04 10:02:19'),(1325,'98478853f6bd27a767691fe6e514dfb1','2025-02-04 10:02:19'),(1326,'4afd9f25cb6ac86341c094f79191227f','2025-02-04 10:02:19'),(1327,'267cf1a0782104a038ac8ba6ffcff292','2025-02-04 10:02:19'),(1328,'eb2eff8dc3014b8af269b1f040b6440f','2025-02-04 10:02:19'),(1329,'37dd55e84cc7fef6137edaa7ea8674ba','2025-02-04 10:02:19'),(1330,'9660007b20e25e44a2dc86cc41a9ecc8','2025-02-04 10:02:19'),(1331,'61d37d98ac136f1790cacc86b8e4ffbf','2025-02-04 10:02:19'),(1332,'1d218808e54c629529738f607b20c546','2025-02-04 10:02:19'),(1333,'1f3a5dd4bad530b2d059b19b24f556bd','2025-02-04 10:02:19'),(1334,'97713ffde7195dc8766ae00cff06ecd7','2025-02-04 10:02:19'),(1335,'bebe27f4203fa0bf07ecc73132f9e24c','2025-02-04 10:02:19'),(1336,'f79e74f1a356691ef31108fe547e7359','2025-02-04 10:02:19'),(1337,'13b098aa58a08b0af511968d57335f71','2025-02-04 10:02:20'),(1338,'4893b2f2ede985fd0cd0504a688c9acc','2025-02-04 10:02:20'),(1339,'a893cb63d4ceb70aa844fa43cb3acc63','2025-02-04 10:02:20'),(1340,'ac7c22e161a19691613f26deb2988dce','2025-02-04 10:02:20'),(1341,'9acc9c78dc149b5c40ca3638cc11d489','2025-02-04 10:02:20'),(1342,'1f79e4a8b84d2052df162156e5d1c8ce','2025-02-04 10:02:20'),(1343,'13e75bbd0cee226bdc5b78ba5dc66504','2025-02-04 10:02:20'),(1344,'e681e2fb8b36028c7fd05578516c0eca','2025-02-04 10:02:20'),(1345,'785cdd3e56130367eea2bd3dff34d18b','2025-02-04 10:02:20'),(1346,'985c66564c5eaff746890b4e5deabaf1','2025-02-04 10:02:20'),(1347,'c9d124a8a61742e33e95012ef236b58f','2025-02-04 10:02:20'),(1348,'5e5f209617d248f7173e380868f2e002','2025-02-04 10:02:20'),(1349,'2f8c45eb4dc8bb377d09a868b2ccc39e','2025-02-04 10:02:20'),(1350,'c6262938a68060e14f317c5da4337274','2025-02-04 10:02:20'),(1351,'c9b9d4aaf510b6da01e928483162422d','2025-02-04 10:02:20'),(1352,'bfd0f6226de781ef283dbf6d455f410b','2025-02-04 10:02:20'),(1353,'2dfe231bb04310ec6573dce50b9fb928','2025-02-04 10:02:20'),(1354,'08273fdf4c3e518e751295da87444ba0','2025-02-04 10:02:21'),(1355,'82a10910a431cacbc517d3edaf0b70a8','2025-02-04 10:02:21'),(1356,'d9fea8be855d20e328b072fd461d1982','2025-02-04 10:02:21'),(1357,'35a53c3f35e677ed0b41ef498a6f6037','2025-02-04 10:02:21'),(1358,'abeb504a3df20b9ca2fd832d4bf8a128','2025-02-04 10:02:21'),(1359,'1b83bf940ee47beec338c0fb6a5a85aa','2025-02-04 10:02:21'),(1360,'cfc7d36b9b22c3ddedad3afa5d7c412f','2025-02-04 10:02:21'),(1361,'b76ef221c50c42a7651de6ab01d33e41','2025-02-04 10:02:21'),(1362,'636e433979cf37d430fd5b4acff12d2f','2025-02-04 10:02:21'),(1363,'2f06a3197196f3f0a80d2624bd10b1cb','2025-02-04 10:02:21'),(1364,'97fd4613ec8eb60c49377688c4972c09','2025-02-04 10:02:21'),(1365,'9670760c48ecb666bab65f7909a31a04','2025-02-04 10:02:21'),(1366,'8f987e63aadd3d3c02593fb80e4dca71','2025-02-04 10:02:21'),(1367,'5f9ec7a164e30af199b29c08c0992e61','2025-02-04 10:02:21'),(1368,'807f5b68ebdb30eacac130ab3704d357','2025-02-04 10:02:21'),(1369,'b421235f466120757ba4fddead1141e0','2025-02-04 10:02:21'),(1370,'e3d4e48a41952b2f87599087f26afcca','2025-02-04 10:02:21'),(1371,'cc800ba04b9a376bed645435572c6dc1','2025-02-04 10:02:22'),(1372,'66defb7c92a524d1cd88489527f7a9fd','2025-02-04 10:02:22'),(1373,'ad6627df97fce7d2177f12936e59487c','2025-02-04 10:02:22'),(1374,'a1b47aa5af4310eee7e3ff7be5ff26ce','2025-02-04 10:02:22'),(1375,'575ccad39c98ad90f1b079f3a1cdf81e','2025-02-04 10:02:22'),(1376,'2985c5eddd0b45a461fe9d61f54daa0f','2025-02-04 10:02:22'),(1377,'14a514e28ddac1da8b7aacd0b56a231d','2025-02-04 10:02:22'),(1378,'b061770b8925d8dcbde0e96150f946f3','2025-02-04 10:02:22'),(1379,'57d50e2227fb4a6c787e3577e823a7c5','2025-02-04 10:02:22'),(1380,'1aa9ea9100be602a6d310d5764a41868','2025-02-04 10:02:22'),(1381,'236e88fa74861a734d9efbfb6799ff60','2025-02-04 10:02:22'),(1382,'eeb78f0ab587021e0f2d5606d300ad8f','2025-02-04 10:02:22'),(1383,'518dcd1066d19aadeb7a2ee7b071affd','2025-02-04 10:02:22'),(1384,'2007b01efc672547188267f010582f2c','2025-02-04 10:02:22'),(1385,'fbc8e6a12261d7e1161ab23efa38c5e1','2025-02-04 10:02:23'),(1386,'93efaa49ec51b11d8b126805b2b92dfc','2025-02-04 10:02:23'),(1387,'ec0b6e932a43a1f34478a47f62ad4e64','2025-02-04 10:02:23'),(1388,'064574ef62af721b5df9c79e877388f0','2025-02-04 10:02:23'),(1389,'6694dba62a4ea658db30cca0b4a7cfe9','2025-02-04 10:02:23'),(1390,'3f25a341ee548eb7e19747275c2b1684','2025-02-04 10:02:23'),(1391,'6d9488d02841088886fa469b751bf541','2025-02-04 10:02:23'),(1392,'a78429ad9302d7c3b7102ab738d64aad','2025-02-04 10:02:23'),(1393,'168b38f5b6bb441c3142f30b167a1aaf','2025-02-04 10:02:23'),(1394,'cd9a79268661ee157662aed0fca8f3fc','2025-02-04 10:02:23'),(1395,'2ffd64949cb7f4613f571ff439b7d24d','2025-02-04 10:02:23'),(1396,'358aec436a3f6ad3d9065ff343596c90','2025-02-04 10:02:23'),(1397,'21090c8f83db3e6ba0c695bd26809fc6','2025-02-04 10:02:23'),(1398,'5f3cad9807af29351427eb7a686132b2','2025-02-04 10:02:23'),(1399,'c6333bedbc1d3ae1b4b2d067cfb3ce77','2025-02-04 10:02:23'),(1400,'848712bbf219d63caf78abbde05542b7','2025-02-04 10:02:24'),(1401,'842e3129f9f3ba2132de23f97b6e830e','2025-02-04 10:02:24'),(1402,'898ee76937b76d68f0b984285b5808d8','2025-02-04 10:02:24'),(1403,'5c5f4b5dc0a02e8f538d7c22e450f0ce','2025-02-04 10:02:24'),(1404,'f12a7e4d4309ef1e372663f96edeb025','2025-02-04 10:02:24'),(1405,'e9d4c56199422ccc7f3f63c818ff4ee7','2025-02-04 10:02:24'),(1406,'06f914fea4f643ac5a3b31bffdd29f1d','2025-02-04 10:02:24'),(1407,'2a80e77cc250a28b5b1fa82eaf73a836','2025-02-04 10:02:24'),(1408,'f844f4273cb3aa22fa7e4d8f798544bc','2025-02-04 10:02:24'),(1409,'f29a79452b799e74c37014567fcbeb88','2025-02-04 10:02:24'),(1410,'75f9204f365153e7f85ef259b9acf1d4','2025-02-04 10:02:24'),(1411,'610f9d996bafb06c954360994119abbd','2025-02-04 10:02:24'),(1412,'d7cb7b7df30b8f39591d992e8d5c1b4c','2025-02-04 10:02:24'),(1413,'635a7f1ba76912898e15b339814f27d6','2025-02-04 10:02:24'),(1414,'933cf09053a57c3533a8096b9fa81271','2025-02-04 10:02:24'),(1415,'f2b58b77c89b7ded1cd08683d235e47b','2025-02-04 10:02:24'),(1416,'bf27d078ec77f269f16c169d36e0ebd5','2025-02-04 10:02:24'),(1417,'e2a54140a146def0c8e2decc24b86f0b','2025-02-04 10:02:24'),(1418,'b99094cc5c74287f1f589b083c2f5572','2025-02-04 10:02:25'),(1419,'a1945b75bbbe0cd45be95a03ad15811b','2025-02-04 10:02:25'),(1420,'01ed5e22581acabefa555094d4f0fafc','2025-02-04 10:02:25'),(1421,'c6cb1b9a8f773b245284433c7f77e19f','2025-02-04 10:02:25'),(1422,'ef566b3304a145b292fb9f81c71c4cec','2025-02-04 10:02:25'),(1423,'02556540671075f977ee1f9794f6436b','2025-02-04 10:02:25'),(1424,'bc415b8051a3a39200a93c195c4669c6','2025-02-04 10:02:25'),(1425,'399c0627f83b07a0434200d90e225b10','2025-02-04 10:02:25'),(1426,'7a2e75f707b4f67c352e2ea64de590cd','2025-02-04 10:02:25'),(1427,'c8605a2b9f5583989aae6c74107cd5ef','2025-02-04 10:02:25'),(1428,'28b8bb58d91094e93c85f959b917b6a1','2025-02-04 10:02:25'),(1429,'f5051919cd5aaf184e3493fb7b686f83','2025-02-04 10:02:25'),(1430,'d3b46feae1e0d4442f263ea5321d9605','2025-02-04 10:02:25'),(1431,'bd2d819bc88c180fb341a44c62458c47','2025-02-04 10:02:25'),(1432,'5db7c4e6d1948811b9077e1700da02a6','2025-02-04 10:02:25'),(1433,'ffd34e6297a17a07413d11f4c8fe889a','2025-02-04 10:02:25'),(1434,'56f069e5efc742fc2467d9e783e1b444','2025-02-04 10:02:25'),(1435,'b7f9e0dad648b457f0bb682795fed7f1','2025-02-04 10:02:25'),(1436,'ec0a6ec5294c49273cd7889c0de28818','2025-02-04 10:02:25'),(1437,'5b617a3bc2c6c059b2f1ce323e98b9a3','2025-02-04 10:02:25'),(1438,'7e003916c441ffe73db11bec57eff2a8','2025-02-04 10:02:25'),(1439,'9669f996472cda758e5b5962a6fb5b07','2025-02-04 10:02:25'),(1440,'b19570460b265035a582677f6c8ca97b','2025-02-04 10:02:25'),(1441,'5c9dbea86d30284f607359386e9e7652','2025-02-04 10:02:26'),(1442,'69679292ff19f86cb015d40f7436e24d','2025-02-04 10:02:26'),(1443,'a5f776657fbfcfe19a08ffb0677e9507','2025-02-04 10:02:26'),(1444,'902d1d1234ca9e6134db901f95e02797','2025-02-04 10:02:26'),(1445,'1d041dcc26f3dfacf99bd2ca5e2fbe3d','2025-02-04 10:02:26'),(1446,'9d0143c7de96960749e88a134d03731a','2025-02-04 10:02:26'),(1447,'d4b4055a464a0a25b17e30733700fd3d','2025-02-04 10:02:26'),(1448,'da2c19e7c3a6c146524a04d770c90631','2025-02-04 10:02:26'),(1449,'a36323f8f158fa7536f0ca2e8b8a0df7','2025-02-04 10:02:26'),(1450,'8253706c74b1b1f9a30e7f66ba08941c','2025-02-04 10:02:26'),(1451,'8452d43bc47cba42de58ffea85c434b3','2025-02-04 10:02:26'),(1452,'3ba0330b717b823ae0bedbbe0736aa07','2025-02-04 10:02:26'),(1453,'ec86b079b6fbd77f89f29bb4724b9605','2025-02-04 10:02:26'),(1454,'a08b41fa38aa1b9fed2b3a708b1e5256','2025-02-04 10:02:26'),(1455,'39307bc6a846165a1f7925822af819d4','2025-02-04 10:02:26'),(1456,'427f3fedbd92fdd1862d782870c81db3','2025-02-04 10:02:26'),(1457,'068afe76035d7473f44a24024c3a54d2','2025-02-04 10:02:26'),(1458,'f99869dd7f69729de7ff99620ecab9cf','2025-02-04 10:02:26'),(1459,'e3250d69d818de8f7b8fbe52c3387767','2025-02-04 10:02:26'),(1460,'bfb1b6e8609e34c98cbffcf24f913cff','2025-02-04 10:02:26'),(1461,'9bb42e8900d169c95198416a9cc4e327','2025-02-04 10:02:26'),(1462,'f5ef148eb0273ecff5dae339eddb66c2','2025-02-04 10:02:26'),(1463,'1f1a8a7fffbee04a1c78b0dfa70f2e9c','2025-02-04 10:02:26'),(1464,'19a4e8d0d44b6e170e0140fbad620367','2025-02-04 10:02:26'),(1465,'9b5539a0ca4d8565734b7487ecde8789','2025-02-04 10:02:26'),(1466,'cc70349b3165eb99881e7a8a8c086d1a','2025-02-04 10:02:27'),(1467,'164c6b0b8cae0510063bb88579dc7765','2025-02-04 10:02:27'),(1468,'5ea57059b23cab135da34162615314f8','2025-02-04 10:02:27'),(1469,'def6a9397bfc770f7c57be3f63e9c683','2025-02-04 10:02:27'),(1470,'41d38597c754c8a37263f033fc6aa26b','2025-02-04 10:02:27'),(1471,'2149d5ab060c5a3ca7da5ec56867e00a','2025-02-04 10:02:27'),(1472,'db8e52cbc98d1f8c8209db24002d94bd','2025-02-04 10:02:27'),(1473,'108a346214b2a4ec74831f32766710e2','2025-02-04 10:02:27'),(1474,'9079aac4d11b4a69b6f9a63867e5cf9c','2025-02-04 10:02:27'),(1475,'7c320ba6e2d5adaac57396ba40340945','2025-02-04 10:02:27'),(1476,'93927d3473d3eec4d4e4cfdf202ab952','2025-02-04 10:02:27'),(1477,'4c0b3b971a79cc91117b1e20e579135c','2025-02-04 10:02:27'),(1478,'ee269c3032e820317644913a79fc38cf','2025-02-04 10:02:27'),(1479,'8d5038a9d60ecc847cd5e03c2036c8c6','2025-02-04 10:02:27'),(1480,'64af0e5dfda1a1ce01a0b5d4100d31e8','2025-02-04 10:02:27'),(1481,'da7f64ff38afe26616329c56caeb6300','2025-02-04 10:02:27'),(1482,'c639d2b970270b317f111bf06c669a12','2025-02-04 10:02:27'),(1483,'6ea4f6c93b90b186183dc0d3dec3cb78','2025-02-04 10:02:27'),(1484,'4a86e6f01a06ffb5706b9c137e7d83e3','2025-02-04 10:02:27'),(1485,'d0744b649bb712729ccb3e68c46a0bb3','2025-02-04 10:02:27'),(1486,'02cf12c0f6a9c814973e6cce90350f5a','2025-02-04 10:02:27'),(1487,'804606f6a95d324b5647040996498f14','2025-02-04 10:02:27'),(1488,'b8c91bb8ef8572ace25344c1eae294b9','2025-02-04 10:02:27'),(1489,'1ce2f90b1506952fc9925d20f0aea50e','2025-02-04 10:02:27'),(1490,'7c5784f6256f88961fc14bacbb90ae15','2025-02-04 10:02:27'),(1491,'861951213fab189aae1f8f2b2bb5b4a8','2025-02-04 10:02:27'),(1492,'5c3e928ac6b71e8863f3ed60d8967fa6','2025-02-04 10:02:27'),(1493,'538a32ba4f6b39ddae67a94e2fe0b76b','2025-02-04 10:02:27'),(1494,'69b656938f6bac78407feba732c8bff1','2025-02-04 10:02:27'),(1495,'8d95acfc3d7081cdb77485c286ade0fa','2025-02-04 10:02:28'),(1496,'4919675f0f023384caa2e36adabec310','2025-02-04 10:02:28'),(1497,'e88c987cd3e2945e5c77abfe93538ed2','2025-02-04 10:02:28'),(1498,'ac600101d4ce1525c3c8f1cefb0ae6c4','2025-02-04 10:02:28'),(1499,'28a8f2219947aedc6686845ae31d0399','2025-02-04 10:02:28'),(1500,'f8f1f808be9272e098ad234341e55dad','2025-02-04 10:02:28'),(1501,'222cc701c986840e0a7ccee3421e620a','2025-02-04 10:02:28'),(1502,'21e1bd65467a748b2a9f762bb5a61b59','2025-02-04 10:02:28'),(1503,'1a450b688a5d5c1f7a9f72956b61d462','2025-02-04 10:02:28'),(1504,'a00f1156922a464f995e81ce89b4faad','2025-02-04 10:02:28'),(1505,'58bda92608cd5faf5f2466339093f91c','2025-02-04 10:02:28'),(1506,'71dcbb89b5c4b865fc91a809acbaf553','2025-02-04 10:02:28'),(1507,'958b0e17cc0643beba6c910a1043440b','2025-02-04 10:02:28'),(1508,'bc6a47381eb4e09e3d7f56ff84480e0a','2025-02-04 10:02:28'),(1509,'2f3cad19bd36727c6bf074ea97cdc148','2025-02-04 10:02:28'),(1510,'3413e8961246c8d568f0e3ceeddd9a3d','2025-02-04 10:02:28'),(1511,'7e79cc5f40bb10a13339c7d75b4cf98e','2025-02-04 10:02:28'),(1512,'fe7fe848cd1c07968519903470f319e8','2025-02-04 10:02:28'),(1513,'5146a168c8f40eb053eb6cc6d0188075','2025-02-04 10:02:28'),(1514,'ec3bf2e508784fb5c41d936b9e3e93f2','2025-02-04 10:02:28'),(1515,'c45cbd5b60e08c3015a55882fa318151','2025-02-04 10:02:28'),(1516,'5a5898d8e8f04186a92d2b9ec0362083','2025-02-04 10:02:28'),(1517,'7aacb38b28af10ec72e672a66bc55f85','2025-02-04 10:02:28'),(1518,'a0a1f0f79e3bd8911bca23fc29dcc171','2025-02-04 10:02:28'),(1519,'a97c7164fcebdd8e13965f1cf425a7d8','2025-02-04 10:02:28'),(1520,'0c41a07719aa52ce61cc49c3ae6babe3','2025-02-04 10:02:28'),(1521,'ed3c92a66eb8893c1b6e6282e314d6e6','2025-02-04 10:02:28'),(1522,'2248f24714036d945f05c1a52bec42cb','2025-02-04 10:02:28'),(1523,'d221420829b311a2e10363416660c93e','2025-02-04 10:02:28'),(1524,'2ba5910b130b87e49b70db2d2011a4f5','2025-02-04 10:02:28'),(1525,'045583ac8d902f350a1556396a4a29a0','2025-02-04 10:02:28'),(1526,'fc4ca48fff2fa2ea508776213a6697c8','2025-02-04 10:02:28'),(1527,'907dfc7d0723aeb279d5e63fc9e26df1','2025-02-04 10:02:28'),(1528,'63ba8582021e1102c47de0abcbb5242d','2025-02-04 10:02:28'),(1529,'9881ded16af5772aec6075662addee3f','2025-02-04 10:02:28'),(1530,'1211065822aaec779a531ac7a895b79f','2025-02-04 10:02:29'),(1531,'1615f8894760d1637b8b4800ab2e3f67','2025-02-04 10:02:29'),(1532,'f7dd0f4b892f93f897c4eb09f0bc2ed8','2025-02-04 10:02:29'),(1533,'fedcc0afef4fa897fdf5de51f916b4ea','2025-02-04 10:02:29'),(1534,'2ef0d1591d16ccf531497dc2c239ca65','2025-02-04 10:02:29'),(1535,'15e5657eb9d81b7f21e99b81db589228','2025-02-04 10:02:29'),(1536,'1e1108447ecf9d80c34c6587f4acc143','2025-02-04 10:02:29'),(1537,'5db001bd9f768928e93b07f620900dc1','2025-02-04 10:02:29'),(1538,'b096e1245c38315df90de4a640365737','2025-02-04 10:02:29'),(1539,'40362bf72dc33808746c4982a6d50675','2025-02-04 10:02:29'),(1540,'7900c0f3f164e71a13cea8915699225f','2025-02-04 10:02:29'),(1541,'b92ca668425e338a2c907e880dc8a867','2025-02-04 10:02:29'),(1542,'0a7a1d1cbd2adeb4e4f5a8fff649470c','2025-02-04 10:02:29'),(1543,'1c4d33e6d3cdca22eb3f2a8ffb3f29bc','2025-02-04 10:02:29'),(1544,'2b22519f80e2757766383deb6955b767','2025-02-04 10:02:29'),(1545,'41f46e9f9f9d70f9239a38b7877665a7','2025-02-04 10:02:29'),(1546,'624639395e4348e026f3f87913e700fc','2025-02-04 10:02:29'),(1547,'3b52126095d7b3c4ad68d1bb5da3eb53','2025-02-04 10:02:29'),(1548,'2fdfc6570c7ad37f8fcb5b7120e9f8ce','2025-02-04 10:02:29'),(1549,'5dfd5b1838eb8471f4ec8e046ebfccba','2025-02-04 10:02:29'),(1550,'af6a9c713af51fe9aaa01a217b79ac21','2025-02-04 10:02:29'),(1551,'6311d8d28ffe11e0d6e3e89fcc4c5e46','2025-02-04 10:02:29'),(1552,'1ce10e6d4b5c4580e115a9f560c6c399','2025-02-04 10:02:29'),(1553,'3ae7ba77f4efc0148feba2b29cf1abe1','2025-02-04 10:02:29'),(1554,'fdbd796b09bf0137fc63714360120299','2025-02-04 10:02:29'),(1555,'acc74cfe1b75afeeb3aec243542dd898','2025-02-04 10:02:29'),(1556,'5fefcd044c995a48891514ef3a0ce2bd','2025-02-04 10:02:29'),(1557,'57e7f2837b87f7b1714d65c034224a46','2025-02-04 10:02:29'),(1558,'18c80720ce5d2b7d7225d2885f3d78de','2025-02-04 10:02:29'),(1559,'2bc6f674dc44e1f82cd3b1222e971380','2025-02-04 10:02:29'),(1560,'a55be34328aa8851eda336c0d2b218b0','2025-02-04 10:02:29'),(1561,'3b9294d80401eef787198500fef3aadb','2025-02-04 10:02:29'),(1562,'235cb3e74910f0f6712fbd1c121c7696','2025-02-04 10:02:29'),(1563,'409cc2e638abba631193fcce2d294efa','2025-02-04 10:02:29'),(1564,'4419e9ab887fea1445a55acb9bd7b41d','2025-02-04 10:02:29'),(1565,'b03887f8e2ea73272cbb357953bc34be','2025-02-04 10:02:30'),(1566,'c407e9210bb2dd5b900aab935056df16','2025-02-04 10:02:30'),(1567,'cde4174ff276598e576158631b9be33e','2025-02-04 10:02:30'),(1568,'06c895f696f04e175717ee544c2a9aee','2025-02-04 10:02:30'),(1569,'720e62ce29bd8ecd5847ebef86108e19','2025-02-04 10:02:30'),(1570,'e94e179413730a11ebc223a983999431','2025-02-04 10:02:30'),(1571,'65eddbdb1e1743aeb74c6ff10ac07db7','2025-02-04 10:02:30'),(1572,'0cd98504da8165b4c89a34b12e4d2c45','2025-02-04 10:02:30'),(1573,'e1ad8ba843cc1d74f13df73c2cc9a4fb','2025-02-04 10:02:30'),(1574,'e43c956f63b718082a15355c94fc460b','2025-02-04 10:02:30'),(1575,'576e9e280cd975dede2ca270804b41f3','2025-02-04 10:02:30'),(1576,'34d103b233eacb23b5999e7823d33c45','2025-02-04 10:02:30'),(1577,'944265a63cfb50318b90d3fb07715461','2025-02-04 10:02:30'),(1578,'c6af6be83fea5f280873e4dbc2e63cfe','2025-02-04 10:02:30'),(1579,'0e770eb9100fd3c8d41343879cea1784','2025-02-04 10:02:30'),(1580,'325dd75a4ca667ee1407ca3585f56d7f','2025-02-04 10:02:30'),(1581,'db9da9df1d0512744586634962fc9452','2025-02-04 10:02:30'),(1582,'864ab1d734a028ecde44c7c9ae6c436a','2025-02-04 10:02:30'),(1583,'46da5bebb38164c50e65167738eddae5','2025-02-04 10:02:30'),(1584,'2d44dd9d020648e22c2939ed4114cf9a','2025-02-04 10:02:30'),(1585,'b6b3005569b3f1df221ce908a98cfaee','2025-02-04 10:02:30'),(1586,'4ba768316f4ecb952907b115e027fa04','2025-02-04 10:02:30'),(1587,'25b7fe997f0dca9f470f3fa87a672576','2025-02-04 10:02:30'),(1588,'4e9e2646418fb39101e61feca5e0afca','2025-02-04 10:02:30'),(1589,'a3ee7e709a32b5d0a13bdd6efe1040a8','2025-02-04 10:02:30'),(1590,'f07341ecf9ec8e7168789312937f053c','2025-02-04 10:02:30'),(1591,'3eb12346e9644d5ac20681ff6f0fbcdc','2025-02-04 10:02:30'),(1592,'d86e9a38f8593d7ff80d38c5bc4a649d','2025-02-04 10:02:30'),(1593,'f98997839e327ae07d665913b1719a7c','2025-02-04 10:02:30'),(1594,'9372b8659e6b9ea4ec4be8c0673b3cb5','2025-02-04 10:02:30'),(1595,'84755836fa2b178eea74698ef6184044','2025-02-04 10:02:30'),(1596,'e6237e765e8a9a1c032979c5c25b028f','2025-02-04 10:02:30'),(1597,'7568bafe3a3164c8d3d277a8d8fe2cda','2025-02-04 10:02:30'),(1598,'da51044fa12d2fc701938503cfed62e3','2025-02-04 10:02:30'),(1599,'8eb315109fa00403cf6b967dd72b8eef','2025-02-04 10:02:31'),(1600,'d75b9a5e9e293759bc59fdc142603972','2025-02-04 10:02:31'),(1601,'f7e73e0b6c2061e2dcc53e62f022eaa9','2025-02-04 10:02:31'),(1602,'3f568fcd2c99ad942294c47fe41fd9f2','2025-02-04 10:02:31'),(1603,'0eba6980c109fcc3f45012a3be805afa','2025-02-04 10:02:31'),(1604,'ea21380f4b1db1e94effa4370be5f0a1','2025-02-04 10:02:31'),(1605,'6f9db335baec076014a166835f459cdb','2025-02-04 10:02:31'),(1606,'73890cc31e6b0be7f6a78a11e5cdd281','2025-02-04 10:02:31'),(1607,'585999de57387a4b8668c2e67609697d','2025-02-04 10:02:31'),(1608,'49d68d844fab048e24aa9591eca1af20','2025-02-04 10:02:31'),(1609,'4ab4109fa77a5a161eab55236e746b0c','2025-02-04 10:02:31'),(1610,'dd85ee6a61bed66e7d77d0a9a6bb7e5e','2025-02-04 10:02:31'),(1611,'32c812536056d67432dd180982c9c63b','2025-02-04 10:02:31'),(1612,'23ad0306f76f4f55f7704c224d7d7036','2025-02-04 10:02:31'),(1613,'d75d8c202e188ff3e3f0fd7ddf09df5f','2025-02-04 10:02:31'),(1614,'1de772ed4121659e1020c126126c57c3','2025-02-04 10:02:31'),(1615,'6d7418d33713114464d5d8ebc31187e6','2025-02-04 10:02:31'),(1616,'2486687a73a392ee6459feb890baaa17','2025-02-04 10:02:31'),(1617,'8ee046ae2c93d54ccd57e21cbf432888','2025-02-04 10:02:31'),(1618,'df88b3a24f8c8c8b2dc151ba61b51192','2025-02-04 10:02:31'),(1619,'6bff8b66d1233416cb883c6ef2ede0d5','2025-02-04 10:02:31'),(1620,'e7dbde387407b7203d951256d37d9fa3','2025-02-04 10:02:31'),(1621,'37e04755d37e133a1b898a1a00ef9776','2025-02-04 10:02:31'),(1622,'6fb7d95eec9ce559e1ba602be359b2cc','2025-02-04 10:02:31'),(1623,'0adc2d56447a86f17304f90cd784f93e','2025-02-04 10:02:31'),(1624,'8a452812a2705edf2cee47b5f3bc94c8','2025-02-04 10:02:31'),(1625,'b395b1644d6ad506c70e3283a05138f5','2025-02-04 10:02:31'),(1626,'fd89ce98b80d4c9418e749d83391c788','2025-02-04 10:02:31'),(1627,'02d36375a22d500d47b3ef1d145c9a75','2025-02-04 10:02:31'),(1628,'2407988d21c20dbbbdbd7be057685d84','2025-02-04 10:02:31'),(1629,'9e4289be81f02fc2de3cff64f719063e','2025-02-04 10:02:31'),(1630,'70bd79bdf4b6b83dd95a606ff7e3aad7','2025-02-04 10:02:31'),(1631,'7478aa8d991b188591fb2b60b93c2f9a','2025-02-04 10:02:31'),(1632,'6c2536d82fab16e82e8737448560c09a','2025-02-04 10:02:31'),(1633,'218c93101a6c4ec6032964fb4deb3c70','2025-02-04 10:02:32'),(1634,'bab9f4a69d89c945bcac3fd5b23e68e7','2025-02-04 10:02:32'),(1635,'6e5e14986de13f80d666acb5593db3f2','2025-02-04 10:02:32'),(1636,'4b5da5417d924c4485e7aac2d8d0a1db','2025-02-04 10:02:32'),(1637,'a8dcde344a7ec4e37b4525d6c7ef0913','2025-02-04 10:02:32'),(1638,'4232a76e0ae2ab38dc0dc686cd819aa0','2025-02-04 10:02:32'),(1639,'9c9311f94308672c3ee5d90a2651a67c','2025-02-04 10:02:32'),(1640,'415a3d354cdfe4551e65d0e6846261ca','2025-02-04 10:02:32'),(1641,'3aa09a5ae290038c76c8e86842ca97be','2025-02-04 10:02:32'),(1642,'fc49127c00785f77465cc990ed7f650e','2025-02-04 10:02:32'),(1643,'d71c4d33895522f4fd83242df97279b3','2025-02-04 10:02:32'),(1644,'ec0d489ed50cc0a7a3eb02ae18cdd2eb','2025-02-04 10:02:32'),(1645,'680b57e4d193a54fc41b6680e4830f33','2025-02-04 10:02:32'),(1646,'4221c65a50a79a93e4ea9e148107cc41','2025-02-04 10:02:32'),(1647,'53126e4636610650f0eb33eb69e3afe5','2025-02-04 10:02:32'),(1648,'1bcc06da885f2669d66f456622ce8a07','2025-02-04 10:02:32'),(1649,'f57e8819059eff4eb3b53b3080c05ca9','2025-02-04 10:02:32'),(1650,'36bd1b698fa2a0431e4772eb056135cc','2025-02-04 10:02:32'),(1651,'31b10ec497acd165513572ddf3c80cb5','2025-02-04 10:02:32'),(1652,'3e70402b8a758621993c8562bf952bed','2025-02-04 10:02:32'),(1653,'d723de3a316938624929f18065f98e34','2025-02-04 10:02:32'),(1654,'8cc52bf9f2dc9acbf4ecf947f146f5ca','2025-02-04 10:02:32'),(1655,'d7575f3786e8d208d1addf83df18c653','2025-02-04 10:02:32'),(1656,'791bc4667097213d5c19b2ab074003c2','2025-02-04 10:02:32'),(1657,'8ef25f2e0d5378274d2b155416bf2e32','2025-02-04 10:02:32'),(1658,'6d5c574dedb955455eb5fd91f9b6273f','2025-02-04 10:02:32'),(1659,'667f6246631e9887cc75005b851e3d5a','2025-02-04 10:02:32'),(1660,'7d3c00d363f79da0ce1c8e5a863b5291','2025-02-04 10:02:32'),(1661,'8420b232a714d0111ad4b4bbe6d6a6db','2025-02-04 10:02:32'),(1662,'f294b113963cb46253dbe0fd5905f2bf','2025-02-04 10:02:32'),(1663,'ac55588c8880aefc7777babace3e6037','2025-02-04 10:02:32'),(1664,'bca00f8dea606859bc5488d6799700a7','2025-02-04 10:02:32'),(1665,'6ac1e4409a824d5827aab3dfd7ca366e','2025-02-04 10:02:32'),(1666,'ed54deddf7cd00334bf1e6729a304591','2025-02-04 10:02:32'),(1667,'a3b4d1dd77cc80e9631aec2c5899b9f0','2025-02-04 10:02:32'),(1668,'38106c3df143f655ebf69c094cc2a843','2025-02-04 10:02:32'),(1669,'aa48341b193ce2a038a83dacae66dbed','2025-02-04 10:02:32'),(1670,'08d6b1387bd142b55e0ef88241965d88','2025-02-04 10:02:32'),(1671,'76cd6c815f8d94a67a6bd862e27177f4','2025-02-04 10:02:32'),(1672,'d2a09bb211f13a008a893358b51326f5','2025-02-04 10:02:33'),(1673,'0d55fa4c2b7e7520a8ec070f45d54fab','2025-02-04 10:02:33'),(1674,'4725c936374c72ddcafce7fea967d284','2025-02-04 10:02:33'),(1675,'d97087510a1ecd3c828938b2f9b51532','2025-02-04 10:02:33'),(1676,'82d14ebb68e83ef590e53dd3f5caaee3','2025-02-04 10:02:33'),(1677,'ea8fea25463ae64360d83661659a71a0','2025-02-04 10:02:33'),(1678,'7961038de7bc63f35039da2919027434','2025-02-04 10:02:33'),(1679,'584984d172b2f68ef271137a9d6a4823','2025-02-04 10:02:33'),(1680,'40be5ffaf90f56818539c2210d03a5bc','2025-02-04 10:02:33'),(1681,'eb3200530cb502683e86e5563d9b5b77','2025-02-04 10:02:33'),(1682,'cdcc8cb7c39bcdf23ebdccb7c19ba198','2025-02-04 10:02:33'),(1683,'fde5a682e98b7b30749d8ce4f639218c','2025-02-04 10:02:33'),(1684,'8e734217a7fb104034eb8eec62ea91b7','2025-02-04 10:02:33'),(1685,'4dba4575c70189f1629b30e340452787','2025-02-04 10:02:33'),(1686,'c246a0a9fa29b612b6f398b3cead0628','2025-02-04 10:02:33'),(1687,'b4e8c14b82b872a7d42720cd2967cb9b','2025-02-04 10:02:33'),(1688,'7f11aaf02ec96c9c16a802976b94e45e','2025-02-04 10:02:33'),(1689,'0e0dc2fdd171ba4460e2ee0511e9fd3b','2025-02-04 10:02:33'),(1690,'c503bc4e1caf49aea710116da8d520d4','2025-02-04 10:02:33'),(1691,'45b2ff2f9be0fc9e8e3f9101f0312798','2025-02-04 10:02:33'),(1692,'70d61584ae0375b8a74c972348879562','2025-02-04 10:02:33'),(1693,'5e8e5af5d5894a652b0c497255122f8d','2025-02-04 10:02:33'),(1694,'d8bd8593ad4739a8f8b3194446951b14','2025-02-04 10:02:33'),(1695,'aa0fa9cbd278ce92b4ff62c67253eec0','2025-02-04 10:02:33'),(1696,'bc09a0fe4c0ba7b8aba82adca9af2a3d','2025-02-04 10:02:33'),(1697,'cecc5a91fe3166e6c4787c73b8c19235','2025-02-04 10:02:33'),(1698,'1d2d1d42a7d4fab9d888aad8a658ab77','2025-02-04 10:02:33'),(1699,'3f6a6d2195c75324c824ac970a1de6e5','2025-02-04 10:02:33'),(1700,'7b97033b7cd1586b83abdc146c3eb172','2025-02-04 10:02:33'),(1701,'6c60fcdee5fe72ddfd2dc11eb6723411','2025-02-04 10:02:33'),(1702,'ab0fe8c7ce9e62f5eab8aea034317c12','2025-02-04 10:02:33'),(1703,'0ac04761325bc20de0485e5ac4b677b1','2025-02-04 10:02:33'),(1704,'142cf54822e6b1c0a5186f1e82f64e9f','2025-02-04 10:02:33'),(1705,'fcbf0539a94766d4e4f01684f8f70259','2025-02-04 10:02:33'),(1706,'684d2533eb380f7f460be54aa5ba7384','2025-02-04 10:02:33'),(1707,'21a218c29bba56f809e1ed78e76def8f','2025-02-04 10:02:34'),(1708,'055b8b74203bd51e0c04064cef3d800a','2025-02-04 10:02:34'),(1709,'e56ee08eabf760db6329962149db974d','2025-02-04 10:02:34'),(1710,'c30109e76deec4a634892421f1eda340','2025-02-04 10:02:34'),(1711,'fb8761b837ed6db7757ae053469e0b80','2025-02-04 10:02:34'),(1712,'8135bd6c3a3a03a9a200126a2253ca4d','2025-02-04 10:02:34'),(1713,'b654cfa7ac63e9d47def6ff109410700','2025-02-04 10:02:34'),(1714,'14032e75b7778e773dd628e9e83b4c8d','2025-02-04 10:02:34'),(1715,'0878b553ceed60dfe7d6b3c99544fda9','2025-02-04 10:02:34'),(1716,'529dc91bc3c1ae07ac7d01576a9695f4','2025-02-04 10:02:34'),(1717,'c591cc78c0255358d7a74ea684aab1a8','2025-02-04 10:02:34'),(1718,'d9c965830ce5fc7dbeb0efe1a3bf2d17','2025-02-04 10:02:34'),(1719,'e905466031f17313583ec4dae94c7c90','2025-02-04 10:02:34'),(1720,'fc16c036f2c944399fe3476cb7f54e87','2025-02-04 10:02:34'),(1721,'effda1000edb67c4de29606072ec0d0c','2025-02-04 10:02:34'),(1722,'05aa10b7e0ea0990b7e0625628569eda','2025-02-04 10:02:34'),(1723,'131550b969149180b67a228f3b9ccb29','2025-02-04 10:02:34'),(1724,'3cd0c3644a4034fab278990b29a9fcc5','2025-02-04 10:02:34'),(1725,'e1b5a2e8f5f71b0fd89cdc8fc4908f42','2025-02-04 10:02:34'),(1726,'2b9e470bff1c95c4b81f09b6e534e1f9','2025-02-04 10:02:34'),(1727,'582baccb3a9bc96e05e4ae680d92a059','2025-02-04 10:02:34'),(1728,'1467a1b8fe310ed93bf535ee90138b3a','2025-02-04 10:02:34'),(1729,'16948a65207cbe9dd401ff963d8308d6','2025-02-04 10:02:34'),(1730,'d30814fb465ceacd54a80512f58627bc','2025-02-04 10:02:34'),(1731,'e9df777897a1bd5839c07b6896aa3640','2025-02-04 10:02:34'),(1732,'6525fb69df94d5b29283cb3843ba0f08','2025-02-04 10:02:34'),(1733,'ce0bc3ebd683e5299e38879afaa3d4fa','2025-02-04 10:02:34'),(1734,'4c8833ad8caac69232cdd55dd43cffc0','2025-02-04 10:02:34'),(1735,'fefd3bbbc315fdd6bbf1b488046bac97','2025-02-04 10:02:34'),(1736,'4382033dd7f240164658a177c16984d8','2025-02-04 10:02:34'),(1737,'88226fb3e2f2780d6a3264522229b64f','2025-02-04 10:02:34'),(1738,'abe6d1778a90218b7a216cf1b5afedad','2025-02-04 10:02:34'),(1739,'baae5c29b17793355fc22ebf85b50b4a','2025-02-04 10:02:34'),(1740,'61f606f55268d8426ebe23eff4a2b9de','2025-02-04 10:02:34'),(1741,'81efc3ae3d48788b27c86290a4d71279','2025-02-04 10:02:35'),(1742,'0693a9737f69659c2d4641ec03506b7e','2025-02-04 10:02:35'),(1743,'eedacceccfcfe67427833335bc689a00','2025-02-04 10:02:35'),(1744,'88f2bd7ca10e56586de5166c4b272529','2025-02-04 10:02:35'),(1745,'9b4dcc8ccbef68d3cf22ae024d14e0e0','2025-02-04 10:02:35'),(1746,'d237f21daae7abcf8392ded7ec474b71','2025-02-04 10:02:35'),(1747,'603b7f6651c2edacd1c97dbe57a47535','2025-02-04 10:02:35'),(1748,'24a44b6f795a46ba7d7358c9970e8836','2025-02-04 10:02:35'),(1749,'78b31d9c35fd5c3203451c89404a1cdb','2025-02-04 10:02:35'),(1750,'d346ab2f6da8890c20e2cff741863a1a','2025-02-04 10:02:35'),(1751,'0a9eb66733077ab3c06ac7ea2741197e','2025-02-04 10:02:35'),(1752,'b63d8494a83cd1a97c59fe093673c6a1','2025-02-04 10:02:35'),(1753,'e467387a5e389144f2f27d109362d498','2025-02-04 10:02:35'),(1754,'3dc23f7b55ee4520cae977a6213bf4e7','2025-02-04 10:02:35'),(1755,'605e71fa925b780bf2434258452dd70c','2025-02-04 10:02:35'),(1756,'e312fc70f5d078f62d4c41820de861ad','2025-02-04 10:02:35'),(1757,'f738b12f5f5fd83009e06ac48d455df9','2025-02-04 10:02:35'),(1758,'0978dc416cee9b35a6b14ae9bedacb7f','2025-02-04 10:02:35'),(1759,'bc6078e668ce0f31801410285e42bedc','2025-02-04 10:02:35'),(1760,'90f19ae7ec6e66d51c0797c39b58ece9','2025-02-04 10:02:35'),(1761,'c215a567c87bac4dabaa77fd3704a95c','2025-02-04 10:02:35'),(1762,'e5ec2b566deac12f12842b2ce4a29759','2025-02-04 10:02:35'),(1763,'28d14ac67cff4fcd07253202600d0f09','2025-02-04 10:02:35'),(1764,'9f120dde4108e5523baaf96d8f2f0cd2','2025-02-04 10:02:35'),(1765,'9e39788d46b6827cad99bb8e819c82bf','2025-02-04 10:02:35'),(1766,'48498fdaa20cb70d252018d28b28b414','2025-02-04 10:02:35'),(1767,'dea3b01e2df09941a719278b88f317e7','2025-02-04 10:02:35'),(1768,'e0f4ddae3f3eea9c1178dab3089fa15e','2025-02-04 10:02:35'),(1769,'591a3d39eda803a2053be29b11cc5a67','2025-02-04 10:02:35'),(1770,'5edd99d763dfb4e55759bfcf6a553c15','2025-02-04 10:02:35'),(1771,'b9962d7daa4ed54264630fad52f2b43b','2025-02-04 10:02:35'),(1772,'8a605beb182706d779fb1244bea1be28','2025-02-04 10:02:35'),(1773,'80af18e9c54e64268d51c303327984a3','2025-02-04 10:02:35'),(1774,'e01a43be8427f94a4d50fdf336d68eeb','2025-02-04 10:02:35'),(1775,'d4c07cee23bd54da09cef714a446c3d5','2025-02-04 10:02:35'),(1776,'4709f92d2e715523431f57f7bd4beccc','2025-02-04 10:02:36'),(1777,'99062a4146e4f620b07894c94d68cf36','2025-02-04 10:02:36'),(1778,'a00f4ee5d04a6f3e2b2594ac6e4d2cc4','2025-02-04 10:02:36'),(1779,'237a0449c98a4ba77d7a3b18915baf15','2025-02-04 10:02:36'),(1780,'3d2a0f1944763b003f38f35317d0be5a','2025-02-04 10:02:36'),(1781,'c2cf2a53e8346c352e649d09f8468738','2025-02-04 10:02:36'),(1782,'5cca2c4a76f98aeb034c89f8eebbb2c2','2025-02-04 10:02:36'),(1783,'ce484c684ff2a45ecab2af099b99e646','2025-02-04 10:02:36'),(1784,'5f9c44f04f547bc8139b934d5d34bf8d','2025-02-04 10:02:36'),(1785,'f87b4da1874d3ce5dfa74521eb451a85','2025-02-04 10:02:36'),(1786,'a52331698ad4834a68f41a21ebd61c10','2025-02-04 10:02:36'),(1787,'ca9b3a374050b8d911bfa8522c432467','2025-02-04 10:02:36'),(1788,'06b2f0e6c725f8f4b351455e4f3c4dee','2025-02-04 10:02:36'),(1789,'6174da9b950368195a7d50073c4d6a29','2025-02-04 10:02:36'),(1790,'f4f0e0f66841befe05022f9b25287eaf','2025-02-04 10:02:36'),(1791,'f380e8aff25d5447e950eae2e0cb53e7','2025-02-04 10:02:36'),(1792,'f0d60b776f7a8a21fd8855789e8e453a','2025-02-04 10:02:36'),(1793,'1d6ddab4c3fd0976d47bcb7a05e7fcdc','2025-02-04 10:02:36'),(1794,'a0f3b6317b68d4c4403efe000cb19f51','2025-02-04 10:02:36'),(1795,'482aa27a057bc24041c9f4f6b68fb782','2025-02-04 10:02:36'),(1796,'ac97ce716f91bd14506f390c2fc06d49','2025-02-04 10:02:36'),(1797,'be4eb5bf81c712b211851c54e9d6bae2','2025-02-04 10:02:36'),(1798,'64d1df14e41ebc64a4b0984be0ec4424','2025-02-04 10:02:36'),(1799,'5ca71327079a3e651c70e62daea1c4ca','2025-02-04 10:02:36'),(1800,'8e43cfae63898dbf406d3860fb9ba2fa','2025-02-04 10:02:36'),(1801,'75385b163c8194fccbd44ce4c5742938','2025-02-04 10:02:36'),(1802,'2bc7c587c1c3039b8e8e5f859a9f0911','2025-02-04 10:02:36'),(1803,'bc7f58f0588b632ae495835f4277642d','2025-02-04 10:02:36'),(1804,'72763a907b284d505628b99d9ac94739','2025-02-04 10:02:36'),(1805,'b17daac7364b0f508d26b534d045939d','2025-02-04 10:02:36'),(1806,'5f8f939ba646d6c393e5c2bbb6619d1d','2025-02-04 10:02:36'),(1807,'411f1e8eb634ef08ff346e31b5ace763','2025-02-04 10:02:36'),(1808,'5fb9943c6b6eb61f38c71e413791d85f','2025-02-04 10:02:36'),(1809,'61c15cb9fca1f4ac8e69d37a40eed4a3','2025-02-04 10:02:36'),(1810,'d2a59959e4486ea9719665d79f265016','2025-02-04 10:02:37'),(1811,'348ce631196c32b46dc2e6ced300d6a7','2025-02-04 10:02:37'),(1812,'944b482aa233cb157af75d7bce93c177','2025-02-04 10:02:37'),(1813,'131d7634f95ccfcf505215d9c42637e9','2025-02-04 10:02:37'),(1814,'49e08de24797d51a384714620a8af2b1','2025-02-04 10:02:37'),(1815,'c130f5bf269a2d4a9023d4ee29830f73','2025-02-04 10:02:37'),(1816,'5c1297b3c9d1eb78ee15ef8529b38b11','2025-02-04 10:02:37'),(1817,'ce7415ed36dbb96af3a4bfa63f960950','2025-02-04 10:02:37'),(1818,'722f79dee213a8ee1ce5cde31cc57fdd','2025-02-04 10:02:37'),(1819,'f56cb8420568eec05b7ca878513d70a0','2025-02-04 10:02:37'),(1820,'e1e04f32b25533d1cafcd4ac2e97dd02','2025-02-04 10:02:37'),(1821,'db0cb9300fcd5d912a27b2e5a82b50c2','2025-02-04 10:02:37'),(1822,'8fcd39ef0e1935386902a96df06a6a39','2025-02-04 10:02:37'),(1823,'6a35fb5ef0429eb9b1c3669f72473b4c','2025-02-04 10:02:37'),(1824,'377124e99aa76ec47c98f676fdb4119b','2025-02-04 10:02:37'),(1825,'8e4dd9767f9589457b300734ea0aed45','2025-02-04 10:02:37'),(1826,'41caccf5f0af5893bed990491e495cdf','2025-02-04 10:02:37'),(1827,'888ad58ed9f25e33334c6c365f1f5e94','2025-02-04 10:02:37'),(1828,'4402d8dc069feb58f57459bd87c458cd','2025-02-04 10:02:37'),(1829,'333669105ffffdffe4466f8bbc1b062e','2025-02-04 10:02:37'),(1830,'240fd09944933a19aadb20f45015d652','2025-02-04 10:02:37'),(1831,'ffd4a2a17586dd8fc22d5a25d962ddc3','2025-02-04 10:02:37'),(1832,'c21367efdf8d8efd3491a6959226b68a','2025-02-04 10:02:37'),(1833,'693fc13cbd0316219874b0251e741eb8','2025-02-04 10:02:37'),(1834,'7df6a4d4eea3b7224f6cac61b09fe20b','2025-02-04 10:02:37'),(1835,'6e54a38bfe6c88604112f1735b573309','2025-02-04 10:02:37'),(1836,'16132df4a121341a0f793335d662d663','2025-02-04 10:02:37'),(1837,'b97110256abe8ddb3901601224455ea3','2025-02-04 10:02:37'),(1838,'67c666e7e87b63209e7a3f265b63a521','2025-02-04 10:02:37'),(1839,'a9bd815093af1041d1c7c830f3b0f3c1','2025-02-04 10:02:37'),(1840,'8c5211841585af31e819128b5ff3a7ec','2025-02-04 10:02:37'),(1841,'6f2821cf0b8c3ee8a9f9c30fc7522af6','2025-02-04 10:02:37'),(1842,'224b1e4ffbb9d1daf0d4c18f2e3f8bba','2025-02-04 10:02:37'),(1843,'1a2b424ca287fe45cfbd02272ac3e8ca','2025-02-04 10:02:37'),(1844,'677f5a9fc86340523a77229b2add7fa7','2025-02-04 10:02:37'),(1845,'ae39dd126cac680b22b6f1568999795b','2025-02-04 10:02:37'),(1846,'19a6c7e817d3eeff25465aae157a304a','2025-02-04 10:02:37'),(1847,'a3666c2692b1e1a624dd9628b9eb1e4f','2025-02-04 10:02:37'),(1848,'1051133ffe854dfa635ca59fe835f0eb','2025-02-04 10:02:38'),(1849,'fae2d2b26be43b55a1dea1ecddf81eff','2025-02-04 10:02:38'),(1850,'615ebe35042ae70f22992f2f490ec043','2025-02-04 10:02:38'),(1851,'43bf8f1d5e659dcf4c2c6803b6d1ae46','2025-02-04 10:02:38'),(1852,'75a7f94fdd6d347d9b2b433822e40568','2025-02-04 10:02:38'),(1853,'8b1878e61c04575c3b99c9a6b6df1536','2025-02-04 10:02:38'),(1854,'e83ae392119b916129f61f21b6043ec1','2025-02-04 10:02:38'),(1855,'84516e8c4896130fcb9d0471549bfce5','2025-02-04 10:02:38'),(1856,'d9c0d59f7f070f6cd36e1f5a547fb0a5','2025-02-04 10:02:38'),(1857,'aa5b69063c8d30b6c662bea78da5f0b4','2025-02-04 10:02:38'),(1858,'4d0cce493b33c526f0451f180cfd0ad4','2025-02-04 10:02:38'),(1859,'d5542bb11dd838798a82cd61046e5974','2025-02-04 10:02:38'),(1860,'164818eb1e49a629ac7954446803c23a','2025-02-04 10:02:38'),(1861,'d06646f9db64c25bbc5526beb506bde7','2025-02-04 10:02:38'),(1862,'54a4e5cfed4b26ae2ccc73fccd3f7210','2025-02-04 10:02:38'),(1863,'9e8e38cbe6584f0530168de8e4237c5a','2025-02-04 10:02:38'),(1864,'ded5fe718ab97473033232a2a8e30373','2025-02-04 10:02:38'),(1865,'0c7d9367ca3bb00a5b2f904d265ab08f','2025-02-04 10:02:38'),(1866,'50d7e86d5422a8bef4e09f0708f8645c','2025-02-04 10:02:38'),(1867,'930dd2bdda6bc5d7bbad302d99efa4e7','2025-02-04 10:02:38'),(1868,'bbd633f227addb8c81b400ce6a27634e','2025-02-04 10:02:38'),(1869,'94cc97a10f797f34865cdca09b03d482','2025-02-04 10:02:38'),(1870,'cde9e9bf8dacf80e5f3aa6b304a627ae','2025-02-04 10:02:38'),(1871,'15fba7c8f67d363e0714c740cc36137a','2025-02-04 10:02:38'),(1872,'f1de0227a3f4e79275331a4bd3db51b7','2025-02-04 10:02:38'),(1873,'614db8013b1a56092ca78827b93454e1','2025-02-04 10:02:38'),(1874,'f690bd828d0ad5a60e5db9c612e8bc7e','2025-02-04 10:02:38'),(1875,'3d20a8001bb52c384e1841b88952839f','2025-02-04 10:02:38'),(1876,'d2b1a5646a7939a254dd51238429c1d3','2025-02-04 10:02:38'),(1877,'151280e9812174f3676f1b54d5a3a3a3','2025-02-04 10:02:38'),(1878,'ba1e970a089754a72590848f2adc911d','2025-02-04 10:02:38'),(1879,'77d2b651f426ca1d0b4c2be8f304a7ea','2025-02-04 10:02:38'),(1880,'a943f6ebd85bf3af6932818d1aec6e4b','2025-02-04 10:02:38'),(1881,'9a2872ff5c3a4ee711b34255d7eb30e1','2025-02-04 10:02:38'),(1882,'2c4ae28a7366cfec04bcbc82485762ff','2025-02-04 10:02:38'),(1883,'a222d2d5307b3d46f7f079b80024f965','2025-02-04 10:02:38'),(1884,'18ae03679c1f2a5120bbcca84d782898','2025-02-04 10:02:38'),(1885,'7943901f9446ac65464c4855ed1b70b2','2025-02-04 10:02:38'),(1886,'79301c05308dd682c1be2b9cf1fa06cf','2025-02-04 10:02:38'),(1887,'c5e85d7bf83d2501ca90eb8f485b5e5f','2025-02-04 10:02:38'),(1888,'01fa83bf198c3483fa1ce7015f2a4414','2025-02-04 10:02:39'),(1889,'1455913676fbb94fd42e256ad5bf397d','2025-02-04 10:02:39'),(1890,'1174e0b0dd98db2121b30b5ba4ad1920','2025-02-04 10:02:39'),(1891,'798d39dacdcc960d955d2ec2891a4663','2025-02-04 10:02:39'),(1892,'3d84c34ba64c9a857446fb3dde007a06','2025-02-04 10:02:39'),(1893,'ea0ea8c53613dbb0c9e24c47b42cde10','2025-02-04 10:02:39'),(1894,'a030ba0575cc026877c20e0a8a667460','2025-02-04 10:02:39'),(1895,'2c0c29c50332f69bc3c85bc0ae3b2efa','2025-02-04 10:02:39'),(1896,'9b2270d99f2ce2d7867f88db2dfdbe07','2025-02-04 10:02:39'),(1897,'690f599afd602779b71e38d38df513e2','2025-02-04 10:02:39'),(1898,'4d59c11dc224b5082a310d8c72eb2ef6','2025-02-04 10:02:39'),(1899,'74b5502627dde2a614f691659241cdd2','2025-02-04 10:02:39'),(1900,'c259d973a3ef22422a27b95d39c35940','2025-02-04 10:02:39'),(1901,'0466f1b78f770eca01c9ed4f9f5bf7f8','2025-02-04 10:02:39'),(1902,'72c5fb156025967e6c7d2eed5003743b','2025-02-04 10:02:39'),(1903,'6325e1ac9c59036e0f32f94afaa5f5ba','2025-02-04 10:02:39'),(1904,'80b59f550d1e8679cc25e98e23961b70','2025-02-04 10:02:39'),(1905,'4539e0864c6514083e46730491b62a3e','2025-02-04 10:02:39'),(1906,'7f8440fa47ad1683ea1cf58bce7e837e','2025-02-04 10:02:39'),(1907,'fae8b10f66f336c10aa0dea50f8ed679','2025-02-04 10:02:39'),(1908,'8fe637d63d1d8af611501c49c9ada34d','2025-02-04 10:02:39'),(1909,'afd8c5d444cef60bd3ce89f0c9bfa71b','2025-02-04 10:02:39'),(1910,'806db01b3fed897659e7a7c9752cf703','2025-02-04 10:02:39'),(1911,'3c09e509affc986302f9ff4728e13c20','2025-02-04 10:02:39'),(1912,'60043484c66760f0b9b3f397b7ce610c','2025-02-04 10:02:39'),(1913,'2b49dfbdd44e636effc8e2f1cd7a2f9f','2025-02-04 10:02:39'),(1914,'3fb67c19336a3a51847218a9c444dc10','2025-02-04 10:02:39'),(1915,'03f0ff2d56acfba6c577277bc0f6e761','2025-02-04 10:02:39'),(1916,'e50412a9b47285f762006eb3886fb55c','2025-02-04 10:02:39'),(1917,'62310ba45b12cff59d4161840cf6b444','2025-02-04 10:02:39'),(1918,'6d67653eb6ca550c7034393f4dea41d1','2025-02-04 10:02:39'),(1919,'c90cb21c8fdeddf17bcfeda9622a4c99','2025-02-04 10:02:39'),(1920,'c3bf2ff0e244a87a8b1c31bb5a434986','2025-02-04 10:02:39'),(1921,'300a292f2a30be343048cf6477b97604','2025-02-04 10:02:39'),(1922,'fbc73334c1ee6e446f430717c7c4f607','2025-02-04 10:02:39'),(1923,'00d69969626c8e1280a406ddebb07179','2025-02-04 10:02:39'),(1924,'fe2f68f2499d8fbafa785753e60fb3c0','2025-02-04 10:02:39'),(1925,'4537118975a27a6b679f6d1a635ef084','2025-02-04 10:02:39'),(1926,'a36eee780978e481d23118420f9d49f4','2025-02-04 10:02:40'),(1927,'b9dcf62b51d90af8b7f0ffc35ffa2cce','2025-02-04 10:02:40'),(1928,'498d900507690747419722b76b7e2743','2025-02-04 10:02:40'),(1929,'07cc933df46a23bcab595daf6cbdeabf','2025-02-04 10:02:40'),(1930,'3fa2542a257111d9ef3c9255e0d0648e','2025-02-04 10:02:40'),(1931,'16017e99bd81088eb7624f5ed291f517','2025-02-04 10:02:40'),(1932,'bfd8f6de810bf5197ed0c6e32b0fc436','2025-02-04 10:02:40'),(1933,'0e86dc2e1801991ae570c6b617e90bf6','2025-02-04 10:02:40'),(1934,'9bda6f7b6200caae26a45a43057f4886','2025-02-04 10:02:40'),(1935,'b819df9cb7c8241ea33e862eeb96f31e','2025-02-04 10:02:40'),(1936,'b567112444271657c4a9f26c796cbd31','2025-02-04 10:02:40'),(1937,'edf325af7f2e75f226bba2797702c71c','2025-02-04 10:02:40'),(1938,'00560b69234e19614d7dae98d8a31ffe','2025-02-04 10:02:40'),(1939,'1f740dfee6d83f92b5598130924859b0','2025-02-04 10:02:40'),(1940,'573d35e487be0c9cff0e770137a7177c','2025-02-04 10:02:40'),(1941,'90d9a1f79772e17eccda605795639fca','2025-02-04 10:02:40'),(1942,'da71826c52dc4ec366dc9e4b2e9d7bbb','2025-02-04 10:02:40'),(1943,'612c965dd35975e47fe36a7e0430f853','2025-02-04 10:02:40'),(1944,'82397b063a2cea2b78ad5add1ce52cc5','2025-02-04 10:02:40'),(1945,'b07abd873c4c8fbf022327fcd7b36896','2025-02-04 10:02:40'),(1946,'b962d970fc7f8eeaa8f7c96132debbc3','2025-02-04 10:02:40'),(1947,'1f4612da34c6bf0c092dbad5c6636152','2025-02-04 10:02:40'),(1948,'3262ae8cac8920b0be1d3b3dc8a7c55f','2025-02-04 10:02:40'),(1949,'6bd818234ce03acede8a549cc01274df','2025-02-04 10:02:40'),(1950,'22c0fdc8a92eb5a071ef5532c1a35eb3','2025-02-04 10:02:40'),(1951,'ae4dddf5442a28a474690929ce7d487a','2025-02-04 10:02:40'),(1952,'944d363504fda302c2c0fee65c7e0999','2025-02-04 10:02:40'),(1953,'650b461ef2e63a3cdd553aa082f51b6e','2025-02-04 10:02:40'),(1954,'987d4de7f83f7e149769d19b32a2f5b1','2025-02-04 10:02:40'),(1955,'1f91fef6b2da962b0c5d7f77789d1a82','2025-02-04 10:02:40'),(1956,'d060a4b203af5416cea8ad904d387a91','2025-02-04 10:02:40'),(1957,'bff57fe4ddaee5a3721da2bae832f887','2025-02-04 10:02:40'),(1958,'6fb471287cf79ba09b0e79919e634a3c','2025-02-04 10:02:40'),(1959,'0352a2b6c11381b6fb7d56dcf52533ba','2025-02-04 10:02:40'),(1960,'b3399deb2146028897384d88238ca1bd','2025-02-04 10:02:40'),(1961,'093dd97fabe884345d9aa5508a6d3106','2025-02-04 10:02:40'),(1962,'b8f2f4b924595fa3f22f0942b62595ec','2025-02-04 10:02:40'),(1963,'412d7ffabcd518523803464f84a145c8','2025-02-04 10:02:40'),(1964,'cb6c550a161bd1c613b4834cbf2065ae','2025-02-04 10:02:40'),(1965,'a93396d1602e99918a307d6e1f427607','2025-02-04 10:02:40'),(1966,'5b0b12c3d45c8c165750a5fd76404782','2025-02-04 10:02:40'),(1967,'61b79c4ff311170d236947888e7e63b1','2025-02-04 10:02:41'),(1968,'80bf55775ee2f7bfb13269a4e28d50dd','2025-02-04 10:02:41'),(1969,'19f1a69afabef9f7685321b5ddd2b043','2025-02-04 10:02:41'),(1970,'e22a165a2623d87d6f971bb0c510bbc5','2025-02-04 10:02:41'),(1971,'5bce43d3e5e48c678e32362f85d46b7b','2025-02-04 10:02:41'),(1972,'e6eada689dee58e6c0c916b967d12f0c','2025-02-04 10:02:41'),(1973,'aaab3308cb751c2b443cea2b75badbe7','2025-02-04 10:02:41'),(1974,'ca0e41ffa7cf12c4111b60316f8459bf','2025-02-04 10:02:41'),(1975,'58c8a5f667241bf8fd50762ca4881277','2025-02-04 10:02:41'),(1976,'9e7f467557ece76e0d4d8b53cd6e98ca','2025-02-04 10:02:41'),(1977,'c4c045063acc14500615529e7e05e8d5','2025-02-04 10:02:41'),(1978,'82e9eb32445c3c4f50a23ed727975a72','2025-02-04 10:02:41'),(1979,'5ea7cc52288139d911c06a31f7505250','2025-02-04 10:02:41'),(1980,'f3067a2fc32e1a2a449b0db8f10f132f','2025-02-04 10:02:41'),(1981,'d5e8e72595019aaff1b0c366aa3231ff','2025-02-04 10:02:41'),(1982,'351fa57b67384947e107ca8e2d1757af','2025-02-04 10:02:41'),(1983,'f08bc7b5649fdfd9fd04e8dc838db98a','2025-02-04 10:02:41'),(1984,'70c92631bc5356630812e4a966ed9f73','2025-02-04 10:02:41'),(1985,'dc82958593f2c977b4cc3964e3048c03','2025-02-04 10:02:41'),(1986,'d74fd60621409eda28232cb7772e5972','2025-02-04 10:02:41'),(1987,'92fd9da5aabcf72da9c4bf126d9e42f3','2025-02-04 10:02:41'),(1988,'e15df85fb4c94b8df7dfd75a1051368d','2025-02-04 10:02:41'),(1989,'d15b279364c66077a4853469a35e72b4','2025-02-04 10:02:41'),(1990,'ceea9b9b0d56292972499028577a826a','2025-02-04 10:02:41'),(1991,'785005525a8263f9203dedf7eed0b138','2025-02-04 10:02:41'),(1992,'01e61aad8cf278e042e502e3a96adfa4','2025-02-04 10:02:41'),(1993,'6e74ec2f2d41013d1c8616451a8c9480','2025-02-04 10:02:41'),(1994,'162601f852a4fdec23f0de5ce3709058','2025-02-04 10:02:41'),(1995,'7a90c0761323f24593da056236721b22','2025-02-04 10:02:41'),(1996,'ce55364f9e842fcf5255248d15221822','2025-02-04 10:02:41'),(1997,'37fe9f1c4c69bd0f960f6b64a82fde40','2025-02-04 10:02:41'),(1998,'29b7e91e0c992ba19b2b529d14e661bf','2025-02-04 10:02:41'),(1999,'c39dee5f8b058d61dd9149ddcaa0043c','2025-02-04 10:02:41'),(2000,'94994e6d1dfa579257adb4a19444f8e2','2025-02-04 10:02:41'),(2001,'916ec00db32a9bea3fb15c1fcc87ff8e','2025-02-04 10:02:41'),(2002,'d895d878a063d3716cdda0174a4d42e6','2025-02-04 10:02:41'),(2003,'b7b5cb83c52daaa863df9789f5565912','2025-02-04 10:02:41'),(2004,'f7097709b6cd96959b0bb27d5546cc5d','2025-02-04 10:02:41'),(2005,'fdadabad255af65fd575f0d7ccb2dab0','2025-02-04 10:02:41'),(2006,'e5f634057f47a1a2bc7e2df936f848cf','2025-02-04 10:02:41'),(2007,'bea3d5a353c4bc9df75519149104804b','2025-02-04 10:02:41'),(2008,'b3b6b6644741c4c1e162131ae8991ec0','2025-02-04 10:02:41'),(2009,'288549d15fd745b2c1d581c1d1c460e3','2025-02-04 10:02:42'),(2010,'ec2d0bdff1c44c4f282475b340523b9f','2025-02-04 10:02:42'),(2011,'95b55e4f6fd3f1a58b008d59b6a0f34d','2025-02-04 10:02:42'),(2012,'cd9b4117bf2c5a21a3129f14862e2a3d','2025-02-04 10:02:42'),(2013,'accf3bd58a36f53609cd974896d1a9e5','2025-02-04 10:02:42'),(2014,'4477bd98ccb230176a1c8a8810cc7580','2025-02-04 10:02:42'),(2015,'4665dbd3d5c8b2c88e24f51bee7f9d61','2025-02-04 10:02:42'),(2016,'89b9ab06295653823897e0c023ef1f49','2025-02-04 10:02:42'),(2017,'b00fe44dc6cf39746352e02f75827246','2025-02-04 10:02:42'),(2018,'90e134ad0842d6df3d0879b9424fd9ef','2025-02-04 10:02:42'),(2019,'7c95b1342653768d1d69fe4acda8f209','2025-02-04 10:02:42'),(2020,'e8fd974d22d28d58d04ce1081ad78095','2025-02-04 10:02:42'),(2021,'92bfc6d5c8a6accb313204bd22dd343b','2025-02-04 10:02:42'),(2022,'e95b13ea8e8ab00d289cdf3bc29594e4','2025-02-04 10:02:42'),(2023,'5f4db4a613dade3dfc6663d33f240e13','2025-02-04 10:02:42'),(2024,'6745aa41543254f882a7e03f1883a23e','2025-02-04 10:02:42'),(2025,'7582d6187bf49a3333b1c1bc452cccdd','2025-02-04 10:02:42'),(2026,'2a72e9db63c90f8dc58661babd137276','2025-02-04 10:02:42'),(2027,'f685d665acbd3568658ce9922b5469eb','2025-02-04 10:02:42'),(2028,'1f28e02d0d7768c38bfb184c8f079760','2025-02-04 10:02:42'),(2029,'02a18e2050a15ae82ba8f8d0a345f9c7','2025-02-04 10:02:42'),(2030,'41c0e2b63ff4adb0b5a8d116f75df9d9','2025-02-04 10:02:42'),(2031,'2f1561600b431d3102cff5f91bda577c','2025-02-04 10:02:42'),(2032,'ca559e6238f7de6ef24f37a1ed629118','2025-02-04 10:02:42'),(2033,'120ed1e4cffba9921f19645446acba0f','2025-02-04 10:02:42'),(2034,'5e30fa5dc93d0008c4ac7c5cfdf44921','2025-02-04 10:02:42'),(2035,'1d4881f1c6c94c3c8652d9a5dad64b9f','2025-02-04 10:02:42'),(2036,'02e4eb0d50e65f7786a485497495fc5f','2025-02-04 10:02:42'),(2037,'b63bfa15b9b066ee97cae0b598bbfb60','2025-02-04 10:02:42'),(2038,'16b8aeab5e1b51681b8e7d3f18d23df6','2025-02-04 10:02:42'),(2039,'0a8eb83dffbeb7a8719d8fd556ca2a9f','2025-02-04 10:02:42'),(2040,'e235fc2cf5a3926b105925108ef14067','2025-02-04 10:02:42'),(2041,'19a636c017ac4ce5b9494fdabf97528c','2025-02-04 10:02:42'),(2042,'f35416855635ba498b56febe08e7b1f0','2025-02-04 10:02:42'),(2043,'ba31257ff5666d5a7d1c355a6602b171','2025-02-04 10:02:42'),(2044,'9c022ae41fa717b8090f26d54f240ab8','2025-02-04 10:02:42'),(2045,'a266ad915371d607d222a2ef9fbfc5a2','2025-02-04 10:02:42'),(2046,'bac6d15376c6686f912fdc39c9eb31cf','2025-02-04 10:02:43'),(2047,'394cb88333082339327fe9463219f67b','2025-02-04 10:02:43'),(2048,'f00a179054231b18df8dbdc3d24c2a5e','2025-02-04 10:02:43'),(2049,'6982b960effbf2e12ec63b958701bf70','2025-02-04 10:02:43'),(2050,'f8e96cd6f6e8d9bd117b9460f9548ee1','2025-02-04 10:02:43'),(2051,'4c1bf10e3e1d680a5c24d454f1037475','2025-02-04 10:02:43'),(2052,'b27ab3cb07aba5eb3fd91a9d8e424277','2025-02-04 10:02:43'),(2053,'52e502a0bce333b1b0af7d5c0823e435','2025-02-04 10:02:43'),(2054,'bc1ba51e2dd3adc091ca855bb930d8ce','2025-02-04 10:02:43'),(2055,'af80a42c76aba73f635c36b0c434f3ae','2025-02-04 10:02:43'),(2056,'7e720a515ebad28713b23858f612a04e','2025-02-04 10:02:43'),(2057,'90d923e758adb57285102b3f9f7df9a7','2025-02-04 10:02:43'),(2058,'ece1558ee6c2f7c9db26909f83a0215b','2025-02-04 10:02:43'),(2059,'3397c2050f9639e7989df76848ab5cf8','2025-02-04 10:02:43'),(2060,'c5309d1ee5f243fa1d1d48042434db8a','2025-02-04 10:02:43'),(2061,'7a51358be80e40503ef8ce25a476373b','2025-02-04 10:02:43'),(2062,'b9756aee7bcc08936fda63b4781e2884','2025-02-04 10:02:43'),(2063,'4b2bcc003991a343da8d378749210d94','2025-02-04 10:02:43'),(2064,'2d196bc752ab1ce17c400e970e5ab919','2025-02-04 10:02:43'),(2065,'5f4db99dcfcb7ff972e805523e045b55','2025-02-04 10:02:43'),(2066,'6556bdea14392fe0945275e11b4b8c30','2025-02-04 10:02:43'),(2067,'583800fa48a3cd87d47b4132e733af6b','2025-02-04 10:02:43'),(2068,'d2d4a00003877b1e436f83f2a694f290','2025-02-04 10:02:43'),(2069,'fb499cc3a878eed827c52f18ae5cbeb3','2025-02-04 10:02:43'),(2070,'0052cdda85915d75b0c6843299916007','2025-02-04 10:02:43'),(2071,'76580a553a52eace6571c8ee61d56081','2025-02-04 10:02:43'),(2072,'ac3912bcc6a6be7e4ebe05ee7a87a63d','2025-02-04 10:02:43'),(2073,'bcfb35027bc368516474208ba2c321e7','2025-02-04 10:02:43'),(2074,'62dc76d0fe9e81a9f1aa19a8afd67ca5','2025-02-04 10:02:43'),(2075,'68b531b27f6b9623309acdc406ae9c83','2025-02-04 10:02:43'),(2076,'e01903dbe902a9e4520cdd1be80d0178','2025-02-04 10:02:43'),(2077,'6dff928541cb65b7e5548fcbc44e9e81','2025-02-04 10:02:43'),(2078,'294fb2ee504db2a565a5ef5dd3e2a830','2025-02-04 10:02:43'),(2079,'d64c5a0088399798e985b6b6892534fb','2025-02-04 10:02:43'),(2080,'776f71bed81708c5c1d50e0569d4478c','2025-02-04 10:02:43'),(2081,'8589a1f4f5854fe286668a1f19d40274','2025-02-04 10:02:43'),(2082,'76fafae39b87b9d671ab051903969dc9','2025-02-04 10:02:44'),(2083,'9fa5855bd61c0c5960275b64e7f8f971','2025-02-04 10:02:44'),(2084,'29ce4dd9685e8accd98b74809ef85a22','2025-02-04 10:02:44'),(2085,'32f5ca8b9124ec5c30d3cb4042beb785','2025-02-04 10:02:44'),(2086,'b82f1cb9a9ed5f5c3cae161fb510efa0','2025-02-04 10:02:44'),(2087,'3fef99c44c8ed70af23c98ae68f846a5','2025-02-04 10:02:44'),(2088,'a994e2b510d55f832d538effd744e8af','2025-02-04 10:02:44'),(2089,'db8b0dc70b8ff7612594a929d6fb9a94','2025-02-04 10:02:44'),(2090,'49963b3b3fe66d5372819d3d2d5b843b','2025-02-04 10:02:44'),(2091,'eda058df8889b01d30da01f02e4a2375','2025-02-04 10:02:44'),(2092,'828388352bfbe86e70bc40fae214e4c4','2025-02-04 10:02:44'),(2093,'3b2a430da0eb7c8acfec12b487ae39fb','2025-02-04 10:02:44'),(2094,'4da45986ef605de62a44f9aede27284c','2025-02-04 10:02:44'),(2095,'35e26a09d4d510789742c91d8f17d7ed','2025-02-04 10:02:44'),(2096,'2e5f25bb99ec2b4409cc1a1131e8655f','2025-02-04 10:02:44'),(2097,'7e5780e1d135cc761f7877c3dcda99ca','2025-02-04 10:02:44'),(2098,'052b6a0a06796907832f917639c7ba1e','2025-02-04 10:02:44'),(2099,'44210ef2c710510a7f4f7b410c3d659c','2025-02-04 10:02:44'),(2100,'ae858f3d10175c66a073d8badcd1d7b0','2025-02-04 10:02:44'),(2101,'ef8eb533f0f4c783855a2daa6c8adcff','2025-02-04 10:02:44'),(2102,'c4da1ca9dd488a5626e8a4225550402a','2025-02-04 10:02:44'),(2103,'b43c30a2458d56e8c2657244100341ee','2025-02-04 10:02:44'),(2104,'efa086d103635f1492679b2228c11954','2025-02-04 10:02:44'),(2105,'d007476a5f108c33436f819786fd86e6','2025-02-04 10:02:44'),(2106,'ab83d5d80196fe13d038c89f5cec859a','2025-02-04 10:02:44'),(2107,'8902ce4b4e67284664c42893f6f5c995','2025-02-04 10:02:44'),(2108,'0b0ffbdcb5ad4041400a19dfb1542c78','2025-02-04 10:02:44'),(2109,'aecfb46ed8a486c11a5c48250c48c660','2025-02-04 10:02:44'),(2110,'65b604e8f6d688667a67ca2ded26d092','2025-02-04 10:02:44'),(2111,'0866953aa361a5656f3aeb0cf2b58824','2025-02-04 10:02:44'),(2112,'e45c3e4474df2d7b8048246b9543cae1','2025-02-04 10:02:44'),(2113,'f2c69c43657e3f8a0b5aa5747cd5966e','2025-02-04 10:02:44'),(2114,'dfe706ec6dd4d58c3d6238656a926508','2025-02-04 10:02:44'),(2115,'55bde2124852989efd2692ad68cbe09d','2025-02-04 10:02:44'),(2116,'9d0fc28952045fda53355034d0c8bcb9','2025-02-04 10:02:44'),(2117,'4d0aeae7b9daf5f158bf223b4aec3d29','2025-02-04 10:02:44'),(2118,'4d752903019416af9d938c3603dc6739','2025-02-04 10:02:44'),(2119,'b9a2131f56152eba25b674d9df39f36c','2025-02-04 10:02:44'),(2120,'0ed9929c007f4cf6ec63875122ded9a2','2025-02-04 10:02:44'),(2121,'e22edb1f74cdcf94fb3a053fa4cef118','2025-02-04 10:02:45'),(2122,'4988dd3fa1126e15dc178094746ce8a1','2025-02-04 10:02:45'),(2123,'69a3d72d79a8635c5525af4f68247f98','2025-02-04 10:02:45'),(2124,'789e715b936f3c25d3f5bc4996e1cdff','2025-02-04 10:02:45'),(2125,'e6db8cd16607f96d7255c2ea94fcef32','2025-02-04 10:02:45'),(2126,'991120b13d64664ecd114fcfed15d0c7','2025-02-04 10:02:45'),(2127,'ccad46a41c515c9315e38305ecc018a6','2025-02-04 10:02:45'),(2128,'87983e216a2c71322c78f758a2609271','2025-02-04 10:02:45'),(2129,'8a6bcafce61f59218808bc7ca6975ef5','2025-02-04 10:02:45'),(2130,'ea99fb5f9fa337b624a9f78bb5600567','2025-02-04 10:02:45'),(2131,'9ae3f03a2b62b367a5b3465b18d02dbc','2025-02-04 10:02:45'),(2132,'0c36a779bd12ae8ba673af921cc6c14e','2025-02-04 10:02:45'),(2133,'91d39f1d623faeda3e41ef44cf4a9ae8','2025-02-04 10:02:45'),(2134,'a532076a7d1ec4411089fc2891655923','2025-02-04 10:02:45'),(2135,'a7bdf9f6ad41de4051976905616c45ae','2025-02-04 10:02:45'),(2136,'0661e938c2aa6ca6daa308a7e217906f','2025-02-04 10:02:45'),(2137,'bb6bbed3b6e37c5dc7a59da8dda97cb9','2025-02-04 10:02:45'),(2138,'cc2bf10e7acf216f2dce4d337c0ad818','2025-02-04 10:02:45'),(2139,'9198b9a18256ddef14601a677a4932ec','2025-02-04 10:02:45'),(2140,'a80f013606afc00610219b2c1ffe7db5','2025-02-04 10:02:45'),(2141,'d59be959b4b4dc6b43e6633e105cf977','2025-02-04 10:02:45'),(2142,'82230800ed162865f8ac90fd83de8016','2025-02-04 10:02:45'),(2143,'a31c8659279d30b191274be4371c3949','2025-02-04 10:02:45'),(2144,'ee6dedd0ca2054addaaebf4d55546c91','2025-02-04 10:02:45'),(2145,'f13be0ab46faa4b4b1a06092aed622f0','2025-02-04 10:02:45'),(2146,'8341332fd5a0b17848d13d12b6a16c9b','2025-02-04 10:02:45'),(2147,'67f743ab1c1708b72171a7098df9998b','2025-02-04 10:02:45'),(2148,'ab876f6c00adbb388e19e0834cb1bf72','2025-02-04 10:02:45'),(2149,'af9f81df886dc49b6763a3fa620284c5','2025-02-04 10:02:45'),(2150,'7f5a76d58eb962855a133e0dc97e39f5','2025-02-04 10:02:45'),(2151,'3613fe76e16688d1efd04d6eb0d2c28f','2025-02-04 10:02:45'),(2152,'0098c78ed44a4995c28b4113b5a06033','2025-02-04 10:02:45'),(2153,'4b6274140dc9072f9471f6f405dd4280','2025-02-04 10:02:45'),(2154,'e2a114440f5cba016f9f1b7232d1c50a','2025-02-04 10:02:45'),(2155,'45ebce5601254537faf40b8d718f6eea','2025-02-04 10:02:45'),(2156,'b8b0380d5627573ac0bd0ac6edc285ca','2025-02-04 10:02:45'),(2157,'d12214808d12a6b52ebe6b6fa00926d3','2025-02-04 10:02:46'),(2158,'a6fd0fc067bdd9dced1b2b8c1ec2a7f1','2025-02-04 10:02:46'),(2159,'005e1fc0640b78eb64ab6f4251ac4629','2025-02-04 10:02:46'),(2160,'3b37a86e658e68619c0654b9054d6431','2025-02-04 10:02:46'),(2161,'7adfe92cf47c3068657427ba4be64b44','2025-02-04 10:02:46'),(2162,'1d7c0fea8ced17b61ff83cdf994b266f','2025-02-04 10:02:46'),(2163,'36c20df939080c9f5b5e8856c4ed8933','2025-02-04 10:02:46'),(2164,'199caf0275d2fbf38a8c3a2623b2eac2','2025-02-04 10:02:46'),(2165,'89cb92e496c2c26cd5fdc5b212b77169','2025-02-04 10:02:46'),(2166,'5b003aaddf6bee7deda26ff65371b8c1','2025-02-04 10:02:46'),(2167,'726b441550b5c6ac026bad0319fff8b4','2025-02-04 10:02:46'),(2168,'fdb8b27c179fa7b304703e52fe809cb2','2025-02-04 10:02:46'),(2169,'3fc6fdc685a05d8c8122120527d65d31','2025-02-04 10:02:46'),(2170,'5fc3af2021cc5585149d812da567e4b8','2025-02-04 10:02:46'),(2171,'8540b7baec3e60871e4295ad30d4f87b','2025-02-04 10:02:46'),(2172,'e721abfab52b08e77a214ee267660bad','2025-02-04 10:02:46'),(2173,'e16bed28c58e2dbc57cb01539fa6c0ac','2025-02-04 10:02:46'),(2174,'14da46f234f927d484824ef9b96a6e61','2025-02-04 10:02:46'),(2175,'31c512ef5a4515e24be1983d5ecf9be4','2025-02-04 10:02:46'),(2176,'dc2c689f9954390864623ccb6098efa0','2025-02-04 10:02:46'),(2177,'e677ffe5b5776cb1e6b82ce114cab0cf','2025-02-04 10:02:46'),(2178,'a5b1884c0e06bb257ae3de23514b579f','2025-02-04 10:02:46'),(2179,'8ea8092d6c56ed08b512b2ac88d01c5b','2025-02-04 10:02:46'),(2180,'29718d40d1bec1a64f81dfe8e0d9b75f','2025-02-04 10:02:46'),(2181,'4b79dcc691cb48dad6e550c2232bd782','2025-02-04 10:02:46'),(2182,'ea64cf1b58a80d35f6880e7d5bbf82e9','2025-02-04 10:02:46'),(2183,'d0dae2363fecf883113f8e0dceb7308e','2025-02-04 10:02:46'),(2184,'b357228326a0264f0d5edf65472384f7','2025-02-04 10:02:47'),(2185,'135aec01b131dbd8cc2a7c9fe37af96e','2025-02-04 10:02:47'),(2186,'6c7f1daf9cb760eddb14f41985f43a5a','2025-02-04 10:02:47'),(2187,'a5c1f8cf03ced3c794e75b2ae05c0a3b','2025-02-04 10:02:47'),(2188,'8d7f0f6bba431009975f352ea1127349','2025-02-04 10:02:47'),(2189,'545d08c8fcb5018d3d0ba931156e1adb','2025-02-04 10:02:47'),(2190,'a6f56716544ff747b2f5f8532cac2e26','2025-02-04 10:02:47'),(2191,'ca217203aa7e0488cca2746dc07dfe65','2025-02-04 10:02:47'),(2192,'580a37b7abf84cdbaa5c255b44e1f2e1','2025-02-04 10:02:47'),(2193,'793c1544fc93309aa9e2b0374afcd75e','2025-02-04 10:02:47'),(2194,'da830a53008272531c1249cf4578e3df','2025-02-04 10:02:47'),(2195,'30cddc226036fe9e740a55732da7f8ff','2025-02-04 10:02:47'),(2196,'f7a571979860c974c35f50b967de7619','2025-02-04 10:02:47'),(2197,'3a15a5c9a37d29c5bab853747e833bf7','2025-02-04 10:02:47'),(2198,'0f063c06ca2e79681a6dc758b147836c','2025-02-04 10:02:47'),(2199,'670067a2a26f94d35344244f76f6ad65','2025-02-04 10:02:47'),(2200,'f21fd774b333ec9d7edd1dab4da19c91','2025-02-04 10:02:47'),(2201,'ce1b8e193180d6d458841a2cf4de7f67','2025-02-04 10:02:48'),(2202,'cc6f0b91d2607d7ada8895e184732de3','2025-02-04 10:02:48'),(2203,'f01bfed9cc6961e60d141aa2ba4e6f10','2025-02-04 10:02:48'),(2204,'8332f603b6d75be27322194ae3c43806','2025-02-04 10:02:48'),(2205,'6e42e3361c7d131ff537c37abbcd8795','2025-02-04 10:02:48'),(2206,'36fa557af0b55f480fe0c185d8e72eda','2025-02-04 10:02:48'),(2207,'886c9d1623ca1f4e008dfb3a00c4c2f6','2025-02-04 10:02:48'),(2208,'e685c47c1ce7d0af7ae82b1970810739','2025-02-04 10:02:48'),(2209,'c4204209d1d6735b185f591e6d3a8513','2025-02-04 10:02:48'),(2210,'afde7190ce9d2f7c3f65674ecedd3026','2025-02-04 10:02:48'),(2211,'50b4a0083c8a2b83a079acf9a8f1c42f','2025-02-04 10:02:48'),(2212,'e85496f77645bf1f22e86bef081550c1','2025-02-04 10:02:48'),(2213,'20fe120f84fc846398dd35f43f3ca672','2025-02-04 10:02:48'),(2214,'6839d8749096ec773b281c4c02055562','2025-02-04 10:02:48'),(2215,'894d9cab8f5d60ec7a7b12fc9355c74f','2025-02-04 10:02:48'),(2216,'2ae6c70f3cb379043baea3abeedc9e4c','2025-02-04 10:02:48'),(2217,'7ae669af862bbe4737ce32741729362a','2025-02-04 10:02:48'),(2218,'7345db45a5bd704cfc9102451b2253d0','2025-02-04 10:02:49'),(2219,'97f2a1df5c549ddaa8a2211bd8a45006','2025-02-04 10:02:49'),(2220,'4fbcc7ec553a61a2f082ce5bca178ea5','2025-02-04 10:02:49'),(2221,'5f8d3559dd886ae730df49c825e2a689','2025-02-04 10:02:49'),(2222,'3524ebb96a71728fbd7b7d118de235ca','2025-02-04 10:02:49'),(2223,'2b95a30b12c16b7eee315ac30d0039a2','2025-02-04 10:02:49'),(2224,'8880cf76177978f609fff9b14dfe333b','2025-02-04 10:02:49'),(2225,'df4d795ee00403c20d94f7dc99ad1dc6','2025-02-04 10:02:49'),(2226,'e59c6554f4b27490194e2c189f9bc3ca','2025-02-04 10:02:49'),(2227,'f05ce9af71da884aa155ed74c867e9c9','2025-02-04 10:02:49'),(2228,'7db2bd7802e9455f31c0f1b337b2f55d','2025-02-04 10:02:49'),(2229,'f147f2f32233e8a508d0361f3b692d8b','2025-02-04 10:02:49'),(2230,'e0ace9a9ef6f4937ce963f9adfcfea02','2025-02-04 10:02:49'),(2231,'8c9125af0abfe4a74fdaa16fe4acb582','2025-02-04 10:02:49'),(2232,'511476933c61d5af6bb0a786377f5b52','2025-02-04 10:02:50'),(2233,'fd0ca26fdf0faf0203d173dcfa85de86','2025-02-04 10:02:50'),(2234,'57e374e93c1ebb2afbc9ca06210f88e6','2025-02-04 10:02:50'),(2235,'79e4b5c1a5106fa6a6911590801d36a0','2025-02-04 10:02:50'),(2236,'0e0a642118e2c1427f177a77af8a41bf','2025-02-04 10:02:50'),(2237,'474efcfab5f55491cb059c90e57cce24','2025-02-04 10:02:50'),(2238,'c3075752614793abe8093494726d6d26','2025-02-04 10:02:50'),(2239,'1661b5ff5d0ba8cf1c41bc5155cab5e6','2025-02-04 10:02:50'),(2240,'83d56f569ff85e6dbe28eb77a79a600f','2025-02-04 10:02:50'),(2241,'4dfe8d4caf87d815d607b59ddb202077','2025-02-04 10:02:50'),(2242,'2416e0cf3bb041b25795d65a57135209','2025-02-04 10:02:50'),(2243,'8516d71f58a1f3a8dd840df4c6c8014e','2025-02-04 10:02:50'),(2244,'3ebbd7312c89663c82d3e0f8e2cf28eb','2025-02-04 10:02:50'),(2245,'a97275bad91b461a9c1ac4a4424399b6','2025-02-04 10:02:50'),(2246,'b1d9572731031a8161592bd3bdd33fed','2025-02-04 10:02:50'),(2247,'beb1c44d84cff31d40e16a6d42439ea2','2025-02-04 10:02:50'),(2248,'86f9b44e8f8cd9a9d4fddc8639416806','2025-02-04 10:02:50'),(2249,'da52d56c103910271a26f99b5ca159ca','2025-02-04 10:02:50'),(2250,'0edf655a54c10a87421cf830e6ae7b99','2025-02-04 10:02:50'),(2251,'f8c12f997dea7275811a3fc6023917cd','2025-02-04 10:02:51'),(2252,'95895696a17b31d5f9a48b6443fc21ab','2025-02-04 10:02:51'),(2253,'57ca31cd9a614be4266dbfb18cc7dace','2025-02-04 10:02:51'),(2254,'99c368193b5e2f573401c302ee9c1efa','2025-02-04 10:02:51'),(2255,'6b092cb7458c78dbed77faad515aabf5','2025-02-04 10:02:51'),(2256,'54b08b003b8bf992377e6134979c733a','2025-02-04 10:02:51'),(2257,'d21ed0dae9c4f81a0066e2fa50fedcf3','2025-02-04 10:02:51'),(2258,'c537bc6bcbc6c4f75e50870c692c2a03','2025-02-04 10:02:51'),(2259,'7cb3eff9024af4747d610e419aa6f59f','2025-02-04 10:02:51'),(2260,'27add0bbf49796429cf740239da8cfbf','2025-02-04 10:02:51'),(2261,'8460a5064f97f92a79adbd604b2be889','2025-02-04 10:02:51'),(2262,'a964762d7e66032e9dc3dd1f7335af53','2025-02-04 10:02:51'),(2263,'dfc3738556296cad9bfff2fa0b9d23f5','2025-02-04 10:02:51'),(2264,'c1589b160bd31ff4dc06435cf398b6aa','2025-02-04 10:02:51'),(2265,'1b4647619f361cbcb45fe38ce25c6a42','2025-02-04 10:02:51'),(2266,'57e198fd20f5efc73dc3ddc93a5b00e3','2025-02-04 10:02:51'),(2267,'16fa40cdea407c281cd7b8cda46045e8','2025-02-04 10:02:51'),(2268,'4b30bab8c3b25f905525b4fa0433a20b','2025-02-04 10:02:51'),(2269,'f0543cd3501d03319de1d321802a8934','2025-02-04 10:02:51'),(2270,'f21bf1e011ed6365976f4118bf17b077','2025-02-04 10:02:51'),(2271,'db1d860beb9461c55545dbdbe86c6f23','2025-02-04 10:02:51'),(2272,'43a202164c6ebc37825a9a41f9ef3514','2025-02-04 10:02:51'),(2273,'860a81ab20d5502bffbb1edf72df7135','2025-02-04 10:02:51'),(2274,'208912a55696991d69f7b1a2276ef39f','2025-02-04 10:02:52'),(2275,'3cf476feb7ce587582785e68b797a9a6','2025-02-04 10:02:52'),(2276,'285965a3d21695763c7cd04441fb79a0','2025-02-04 10:02:52'),(2277,'2f472be7981c924b53b7f4f631a73f05','2025-02-04 10:02:52'),(2278,'f1bd2cb4fee4b82a5703c12d98884192','2025-02-04 10:02:52'),(2279,'15e4379c1ed4b28d1ab9024410d8d503','2025-02-04 10:02:52'),(2280,'f59b7b4d3083ce5a3af0afe29aeef7a1','2025-02-04 10:02:52'),(2281,'360c226df171d5a132e52ff7fd822213','2025-02-04 10:02:52'),(2282,'6b9101845f1d4d1a62a1d9e0b71bd332','2025-02-04 10:02:52'),(2283,'db4a59863544d902a600904064332033','2025-02-04 10:02:52'),(2284,'6c0c7cebd4fc648e49f73923775293c9','2025-02-04 10:02:52'),(2285,'2cc686c10639be25a4ff6b4209199419','2025-02-04 10:02:52'),(2286,'800bd9588bd6978a7a35c09ee79e19ad','2025-02-04 10:02:52'),(2287,'0972259b86690b4f40d627ee9c16356e','2025-02-04 10:02:52'),(2288,'99685aeaa0ced4aa3eba446a611de6e6','2025-02-04 10:02:52'),(2289,'310f0d98e4e6c54c7a268983c1dd864f','2025-02-04 10:02:52'),(2290,'235c40d028de5dfc792ee058f3b193d1','2025-02-04 10:02:52'),(2291,'5823886ac9d2fee994ca807e953dd37b','2025-02-04 10:02:52'),(2292,'e32929b0f517354c1c9461277a9e85ca','2025-02-04 10:02:52'),(2293,'2333dbc129e86c51747746766738d09a','2025-02-04 10:02:52'),(2294,'657476aaec91e9d8e2ab016a8453465d','2025-02-04 10:02:52'),(2295,'b450629a049ef08cd047e3ac3a766600','2025-02-04 10:02:52'),(2296,'68563082f0069e8e8fbc197afef02446','2025-02-04 10:02:52'),(2297,'7b858052efaf90067d9c4d4e33fb71a1','2025-02-04 10:02:52'),(2298,'7c578bc04e533f84c4494017860770a9','2025-02-04 10:02:52'),(2299,'e1fbf78c265e5a6adca2f55466c2a4e4','2025-02-04 10:02:52'),(2300,'868998fb0df6b4e8b49ffe7324af5b4d','2025-02-04 10:02:52'),(2301,'11636c2864e1a3dfcf44aa739c0392bf','2025-02-04 10:02:52'),(2302,'4e6abe4efc8e8755f8afbfb0114aa97f','2025-02-04 10:02:52'),(2303,'a0b92cace415086bc8338a8657d721b7','2025-02-04 10:02:52'),(2304,'971fb2537481b4da76b709a57254093a','2025-02-04 10:02:53'),(2305,'a94e044018b4a97b175177d9f2046f22','2025-02-04 10:02:53'),(2306,'492cd11db41ebf7b87e16cf237593bab','2025-02-04 10:02:53'),(2307,'96bac034009365853cb9af03e2149199','2025-02-04 10:02:53'),(2308,'21a7d07349f8fb03bec76e45ffcb8d4c','2025-02-04 10:02:53'),(2309,'dc1a280b1f1ad83692caa4fd7fceae6d','2025-02-04 10:02:53'),(2310,'519480c90c7b6d913b66f43beafe2efe','2025-02-04 10:02:53'),(2311,'d585273414b9240ff670b0e92f6ea800','2025-02-04 10:02:53'),(2312,'32d2ab60f5e1f708dc9b1b27838c4380','2025-02-04 10:02:53'),(2313,'46a5d9e49c72e34df5c199768929dc64','2025-02-04 10:02:53'),(2314,'eb76e0716b6ed6604a3b2e4f06787924','2025-02-04 10:02:53'),(2315,'53fd27104ca688d12ba7096e76a5c961','2025-02-04 10:02:53'),(2316,'6f3542fc78ce693d7bb0bca4f788d2cd','2025-02-04 10:02:53'),(2317,'977e3cfe755feb7a1508486bfc6fbed7','2025-02-04 10:02:53'),(2318,'6a97f790904aba133116c5a4fc3dd075','2025-02-04 10:02:53'),(2319,'b118ace4001de8e0bf1387b13bdbd249','2025-02-04 10:02:53'),(2320,'9214c159cdfa66d2fff449a96b90b8a4','2025-02-04 10:02:53'),(2321,'95893f02c843dca4a796f6626acaaebd','2025-02-04 10:02:53'),(2322,'fd5496794de72cf4628de9a054f0a202','2025-02-04 10:02:53'),(2323,'44fae6b981cf2b4ea01f2f6a209c2678','2025-02-04 10:02:53'),(2324,'b297d087c5b56a850118226090af391f','2025-02-04 10:02:53'),(2325,'e0c53af8b215f4c447076ce7c75117a9','2025-02-04 10:02:53'),(2326,'7c9b6423d2076cc0d97484bf7ea577e9','2025-02-04 10:02:53'),(2327,'621f4892deb66b36849c942546aff6ae','2025-02-04 10:02:53'),(2328,'70a71736fd44cbfc4048f0f09805c5fc','2025-02-04 10:02:53'),(2329,'8765bfb9268e695be3adb13b123eb49c','2025-02-04 10:02:53'),(2330,'4c7095b971964655e2bdfa05aba611f1','2025-02-04 10:02:53'),(2331,'af4c747062469adcd7895d011afb23f9','2025-02-04 10:02:53'),(2332,'6674b102cad79de1d0bc2ff4b6fb8d51','2025-02-04 10:02:53'),(2333,'fe77a4415f1fac2b1be3f88d0001eb4c','2025-02-04 10:02:53'),(2334,'6888070250f91a96d2a30e06a922f3cc','2025-02-04 10:02:53'),(2335,'6df85e79e6748c533b5d4d4aadb85e60','2025-02-04 10:02:53'),(2336,'768602113261fb8127c117a4fc3b017a','2025-02-04 10:02:54'),(2337,'0ed041c301b1881c23ee2a33601a22b8','2025-02-04 10:02:54'),(2338,'bf86148a12fc9104945351c126fd608b','2025-02-04 10:02:54'),(2339,'c190c02f2963f35bec62dd0d9755a30a','2025-02-04 10:02:54'),(2340,'92fc0cb98002903ce8ee9827f72e5887','2025-02-04 10:02:54'),(2341,'203bc0e4897280922d5f398d4cf48425','2025-02-04 10:02:54'),(2342,'56e970e246d11fd37e7b2c9655a386eb','2025-02-04 10:02:54'),(2343,'58101c3aa2fac1784ce93d4a8b75ead2','2025-02-04 10:02:54'),(2344,'a35a396fbe1e0a03b9442aaaadef80be','2025-02-04 10:02:54'),(2345,'43ef01cf6b0620a790cb4089c09b83aa','2025-02-04 10:02:54'),(2346,'f277ea540b7edba2bf07e7ceffb4ac2e','2025-02-04 10:02:54'),(2347,'b213c344fc229b9de96a925d0cdb3a16','2025-02-04 10:02:54'),(2348,'24848bf8945b8b614411479bb6895f26','2025-02-04 10:02:54'),(2349,'d242748092a0283097cf291749753665','2025-02-04 10:02:54'),(2350,'e2c4afe8501e8a891d3b48ea94919397','2025-02-04 10:02:54'),(2351,'94dbcedf796eed715f765856325c5caf','2025-02-04 10:02:54'),(2352,'73ac5549d807eae8748795d1102fa8fa','2025-02-04 10:02:54'),(2353,'9fa1e9aa7d3ab3a4079e0272b8697aae','2025-02-04 10:02:54'),(2354,'51fa832a65301600e4a4e16ee6033a33','2025-02-04 10:02:54'),(2355,'7971ea95aabc862de9ca85fdee03d184','2025-02-04 10:02:54'),(2356,'97e1917585ab26c6dbeeb08533af4fff','2025-02-04 10:02:54'),(2357,'67c59890b4f1e43171761c8de6f531c6','2025-02-04 10:02:54'),(2358,'4686df9c91766b1ee710c5fe9069faf1','2025-02-04 10:02:54'),(2359,'1288f95c2c5be692480b27e7ac253127','2025-02-04 10:02:54'),(2360,'c5b74324f2f3f0a7de44f7b0d96ee1c4','2025-02-04 10:02:54'),(2361,'41f11af98c9f11fa58998a921fcc7fa6','2025-02-04 10:02:54'),(2362,'5f744b9d43ceb0f9c0a74820162ea147','2025-02-04 10:02:54'),(2363,'f7d496fd4e7048968989d51057ae86c0','2025-02-04 10:02:54'),(2364,'b7a3f3471b98bef308a1c1c3191beafd','2025-02-04 10:02:54'),(2365,'ae27c379461492e27d1c4bcb49cb0cee','2025-02-04 10:02:54'),(2366,'f5208190070751a0794e5c9f8a5d2201','2025-02-04 10:02:54'),(2367,'f956c3eedeb677f2d6ff3d85062d51a1','2025-02-04 10:02:54'),(2368,'f23ca7e872be20c1106d6c83fca3b4b9','2025-02-04 10:02:54'),(2369,'4b81f77e62db01da49e49425c6398607','2025-02-04 10:02:54'),(2370,'01c6cfb1b1667bfd64dfa0191c29996d','2025-02-04 10:02:55'),(2371,'2169d8e85b574fa93c6cef410107dbda','2025-02-04 10:02:55'),(2372,'9011b5e4cc3d2aac4f62046c39297d4a','2025-02-04 10:02:55'),(2373,'542d4d318591f830d69592fbad01106e','2025-02-04 10:02:55'),(2374,'d60a4362cc1db9a7b8cc4773fc9dd149','2025-02-04 10:02:55'),(2375,'67af18465ad077be1b458cae1c0e3235','2025-02-04 10:02:55'),(2376,'1173504ae6ef13eb4eced99a89eb99d5','2025-02-04 10:02:55'),(2377,'c20df76d97452747ba8828af189b96c2','2025-02-04 10:02:55'),(2378,'69768559f375150a7b1ac69ff0dd20a8','2025-02-04 10:02:55'),(2379,'35f8a9451b1bc93487af2197c0d98397','2025-02-04 10:02:55'),(2380,'2323f21a52895f17aaa7661fc803b28d','2025-02-04 10:02:55'),(2381,'d72749beb5eb38e986b531333fbd697f','2025-02-04 10:02:55'),(2382,'3a323e5b59a5da2ad2c753b88a7675d0','2025-02-04 10:02:55'),(2383,'d7371e9607db74579c35d4ec6a5b0413','2025-02-04 10:02:55'),(2384,'e34fb9f6cf043770e1c9e5efcc623a8b','2025-02-04 10:02:55'),(2385,'e895fa478ac1d98ffb80e22be634ee85','2025-02-04 10:02:55'),(2386,'5e29fb7107cee8a1c697fc08a0f36d34','2025-02-04 10:02:55'),(2387,'50c077f1e3aa85d6e08ddf3e5067dddd','2025-02-04 10:02:55'),(2388,'cbb4eae70b2be16d4c387b4ef1f8c918','2025-02-04 10:02:55'),(2389,'25bce8f4e569553a1395da0f398c2a88','2025-02-04 10:02:55'),(2390,'993d03ccaeac0f347d04502fac13edae','2025-02-04 10:02:55'),(2391,'2d0defe6143643174dd9a48e0daa24c7','2025-02-04 10:02:55'),(2392,'44932c4ee1c7ae0a950260378092b221','2025-02-04 10:02:55'),(2393,'1f538e213813884b8eaef8bf1c0ba5cc','2025-02-04 10:02:55'),(2394,'86ecd9bb9bba7f8b250c471558e57aaa','2025-02-04 10:02:55'),(2395,'d91694f7f115fc0c39135c7d358efa43','2025-02-04 10:02:55'),(2396,'678fada65b2c5013a898a0c9da1da6f0','2025-02-04 10:02:55'),(2397,'e512edaf00e1d7378ca645fd10f1d507','2025-02-04 10:02:55'),(2398,'57412dfeaf9a49f8c1a1884279929e63','2025-02-04 10:02:55'),(2399,'68ab5f29c80ebda9e98a84bfc36cd15f','2025-02-04 10:02:55'),(2400,'9845591b97f69c78e3219c54e30730d1','2025-02-04 10:02:55'),(2401,'8b68fcf29da8376fb82e7cd840e2a404','2025-02-04 10:02:55'),(2402,'f99db30915dd4db786673074735579ef','2025-02-04 10:02:55'),(2403,'918dfc98bbc51769061364243b2b9eb5','2025-02-04 10:02:55'),(2404,'a24f3b8dcb6cc00892bda4a63f45a3cb','2025-02-04 10:02:55'),(2405,'9ab91e32d2c518c375b200f8e15f662f','2025-02-04 10:02:55'),(2406,'96cc2f156307234b1fe18082fd13e04f','2025-02-04 10:02:55'),(2407,'1aedbd1dc2251b4c0fda415466b53c5c','2025-02-04 10:02:55'),(2408,'a0d5ec5164eb43bddd14f1996c8a25b8','2025-02-04 10:02:55'),(2409,'14932098efab0870d543cb6d09cca91e','2025-02-04 10:02:55'),(2410,'e0f71444a2d9bdaecfb3172a92ca63ed','2025-02-04 10:02:56'),(2411,'5c8aa9ae4ffeef385cabca18a79d49b7','2025-02-04 10:02:56'),(2412,'c57bf188a35f905fb35fcc68c8db2c35','2025-02-04 10:02:56'),(2413,'66707de758292cadbc0f2bc533cbc666','2025-02-04 10:02:56'),(2414,'ccb2e452871fd4b18c5dd802a0413cac','2025-02-04 10:02:56'),(2415,'7420d03d18ee0401edd530131789a3ed','2025-02-04 10:02:56'),(2416,'68c88c01510f4b5d1a62cc255464e9e8','2025-02-04 10:02:56'),(2417,'ac5d722ec88ec3beee400dcd1679e0b9','2025-02-04 10:02:56'),(2418,'bc746bf2566cbc9dbd12ba0d810445db','2025-02-04 10:02:56'),(2419,'5ae5fb7b32cd832c9132e3d23e190b5b','2025-02-04 10:02:56'),(2420,'e0a39253357ac4060b27ac02a4859e08','2025-02-04 10:02:56'),(2421,'9608d7bd8c8cd088a3293c4614d11144','2025-02-04 10:02:56'),(2422,'b30caf0c6c432ef2b97639ac9f8fa75a','2025-02-04 10:02:56'),(2423,'d37961aa7d157d9b4f2f316202b03df4','2025-02-04 10:02:56'),(2424,'1b04231f814217a654ca244662df81d5','2025-02-04 10:02:56'),(2425,'eba8b13362e022916ddbf5a7847649a8','2025-02-04 10:02:56'),(2426,'f171b056a74cb73be222af1e80b64412','2025-02-04 10:02:56'),(2427,'b1b18de3e868e10bf8192d41a98128bc','2025-02-04 10:02:56'),(2428,'c041703fee5bb4238e9bebd76ac8c75f','2025-02-04 10:02:56'),(2429,'f2c654078a99eb26cb1f9937308cbb48','2025-02-04 10:02:56'),(2430,'57ec46c6c1dddff6f98594c44bf93d35','2025-02-04 10:02:56'),(2431,'9345b19a88b9583b7dbf5a59a8553562','2025-02-04 10:02:56'),(2432,'cc9e3aad4cd65a0455b6ede520ceea56','2025-02-04 10:02:56'),(2433,'0a68919f14a86c8d9ae15933fbe5e3d8','2025-02-04 10:02:56'),(2434,'1d4fad22b31de50bc400372708eefc5b','2025-02-04 10:02:56'),(2435,'240d6554096bd97a24f4dc76cffce2bd','2025-02-04 10:02:56'),(2436,'bf1cadaeeb7aa148e7c45bf88a3d7a13','2025-02-04 10:02:56'),(2437,'5f702e40cfbb8a114d609a62b1a3635b','2025-02-04 10:02:56'),(2438,'4a9e3512e88aab71529e168a25378b26','2025-02-04 10:02:56'),(2439,'7c350fdadddd0e118abb598aa030ecc2','2025-02-04 10:02:56'),(2440,'b12f087b0073a9fb5a05475750961336','2025-02-04 10:02:56'),(2441,'8342a79b2735abe1f6acc0287054acee','2025-02-04 10:02:56'),(2442,'d4d67eeb25751fb5a18a0c79ba9ea5f2','2025-02-04 10:02:56'),(2443,'89e927eb04256d954f047e3b14b161ac','2025-02-04 10:02:56'),(2444,'983b4bbd4df33843cb2cb3d5edd989ad','2025-02-04 10:02:56'),(2445,'a54ef541540107606ac4f5c179e04c8d','2025-02-04 10:02:56'),(2446,'5a0e6035a3d79d2e0596c9816763e8cc','2025-02-04 10:02:56'),(2447,'b642f3455ce3c66e42d61a117a4d4e26','2025-02-04 10:02:57'),(2448,'e4010475e0514f8e1e68c06f8ad2d680','2025-02-04 10:02:57'),(2449,'c061c1a4df5dbe29c2c8a9379323d722','2025-02-04 10:02:57'),(2450,'4c227c38edceee6adf600387d3450edb','2025-02-04 10:02:57'),(2451,'203b98cba8340b1a652210a1f5a8ea68','2025-02-04 10:02:57'),(2452,'3a5f957e00f41c32ac2f0aa4b32512b6','2025-02-04 10:02:57'),(2453,'bf095ef6160465106fac713998ccc66d','2025-02-04 10:02:57'),(2454,'0ad004aecbc104a8bc2c116bc44d5b15','2025-02-04 10:02:57'),(2455,'a25d2105a2b7108d162e147cc4958144','2025-02-04 10:02:57'),(2456,'48277485ddc5d6aaaa0e7e307be4157a','2025-02-04 10:02:57'),(2457,'ebea9bd625019971ce8b05ee6a03fea1','2025-02-04 10:02:57'),(2458,'29ef3d4ef7e43d7617f90156bc82570d','2025-02-04 10:02:57'),(2459,'b73037827195456db256f87753c65182','2025-02-04 10:02:57'),(2460,'0de5ff828b8ee3ed6d71c7d17653eb6a','2025-02-04 10:02:57'),(2461,'673a3e5324ffcb995fa9de26cae8e62c','2025-02-04 10:02:57'),(2462,'6cf007f07ec92d118134efbeb9ca5ab4','2025-02-04 10:02:57'),(2463,'3f4e4edaa1ebca98db2b8784527cc138','2025-02-04 10:02:57'),(2464,'e1cda0a8950615a47e899273a10c2ecb','2025-02-04 10:02:57'),(2465,'2902058ca23acc38ede1d863e92f7f2c','2025-02-04 10:02:57'),(2466,'4538f19e8d44c7b05cc7f52759513887','2025-02-04 10:02:57'),(2467,'eec216470119b673106792c6fab1f271','2025-02-04 10:02:57'),(2468,'fd910c7d58d2d47808966e3d5f5ce30f','2025-02-04 10:02:57'),(2469,'9707f87ad24bfcaa4df492ab363050d9','2025-02-04 10:02:57'),(2470,'ba724d75d8fc16145a350422c1e007e0','2025-02-04 10:02:57'),(2471,'fed96f0953bfadb12419a16872e64c76','2025-02-04 10:02:57'),(2472,'57cbbe592fd393af1af48460a13ad43c','2025-02-04 10:02:57'),(2473,'c16576bcf38c8d2abc9ee4458b57b7a8','2025-02-04 10:02:57'),(2474,'9cccbd09e734ceef94481bdf7231ed85','2025-02-04 10:02:57'),(2475,'aa72ba2f66f261f782fbe4a665edf001','2025-02-04 10:02:57'),(2476,'303780638926975d6cf0e10243b6488e','2025-02-04 10:02:57'),(2477,'184a7bf84e375af816739f07ef3f4aa1','2025-02-04 10:02:57'),(2478,'29f7b5492ae83b84be15b5c013387499','2025-02-04 10:02:57'),(2479,'48ab483277f4c70361b4ef16c5ccb382','2025-02-04 10:02:57'),(2480,'c72a80acfa8ad4f4175f9b33419382e1','2025-02-04 10:02:57'),(2481,'470f02808c013340d9b9faa29054865c','2025-02-04 10:02:57'),(2482,'73df65ffbd91b30948c668a7b29fc89a','2025-02-04 10:02:57'),(2483,'c5282b7bd0c44174db8a93304c82fbd2','2025-02-04 10:02:57'),(2484,'f33d8e8d42219f281c9baa1afbd7dd59','2025-02-04 10:02:57'),(2485,'294e6f0317e3c50587032c3bb9196589','2025-02-04 10:02:57'),(2486,'5c9d48386a5668ccf3ddcd776b988e71','2025-02-04 10:02:57'),(2487,'0d33d0521d6412c54e52301763de2965','2025-02-04 10:02:57'),(2488,'e4edcfca1d0905ba2610fd0a072f5812','2025-02-04 10:02:58'),(2489,'7bafb6c07bb071e2dca0197259860fde','2025-02-04 10:02:58'),(2490,'384e198fd1794993355ccdfd5f59b0d6','2025-02-04 10:02:58'),(2491,'fb65ef171665ed1f8c3b697e42f78d8e','2025-02-04 10:02:58'),(2492,'10fa19224f7c37e11a0e68aaea476df7','2025-02-04 10:02:58'),(2493,'8860c11e3651b8b00b6a0c4222c7d6f2','2025-02-04 10:02:58'),(2494,'92f947d02f7017cefcb2f3db6e1a74dc','2025-02-04 10:02:58'),(2495,'b2e967927555ddd23ac74c1f02d07730','2025-02-04 10:02:58'),(2496,'a4709e88c5016fb987c36110b3a97d75','2025-02-04 10:02:58'),(2497,'cef91b0bab8815b089c50f4ebfbbcfcc','2025-02-04 10:02:58'),(2498,'5b4a6137ac5a7cf6d681dc7390496863','2025-02-04 10:02:58'),(2499,'905e9baace1565b923c357b108c4ab27','2025-02-04 10:02:58'),(2500,'67e3c3c41935174d65bb4e608ec62e9e','2025-02-04 10:02:58'),(2501,'b2d938018684cfc19e581a14f078f73d','2025-02-04 10:02:58'),(2502,'042782688e6d9c10182daeb1dc3eca04','2025-02-04 10:02:58'),(2503,'bfcb4ce1400071584deb562889dd46da','2025-02-04 10:02:58'),(2504,'53012a764e22d119786f560b9af7324e','2025-02-04 10:02:58'),(2505,'8f1e5a58512e8206be78666a34d6f05c','2025-02-04 10:02:58'),(2506,'9188a484d190ce9333d5b74b79a4ca2c','2025-02-04 10:02:58'),(2507,'25bef56ce699fd50a468024f58df5357','2025-02-04 10:02:58'),(2508,'e65a0365c7e85ae08092d1268532e0c7','2025-02-04 10:02:58'),(2509,'6978d9e0ccd1a1bf7e0e877200bf5b78','2025-02-04 10:02:58'),(2510,'3af5f9e58d68dc8fbf999661751aa516','2025-02-04 10:02:58'),(2511,'1da2c382f7236b0033b2abe6cbefdf70','2025-02-04 10:02:58'),(2512,'8c0ca33472a5c94c422a469e6048bfa7','2025-02-04 10:02:58'),(2513,'cd55b6293062c6b013132057d76702f8','2025-02-04 10:02:58'),(2514,'eb27e081a0fe6e5d82e05bba91b91e27','2025-02-04 10:02:58'),(2515,'bd8afdcd0d4780921a76b453447ee421','2025-02-04 10:02:58'),(2516,'162da94d0f965b4ba292c298c208627f','2025-02-04 10:02:58'),(2517,'69d8db029c33cee4744d3514ce858afa','2025-02-04 10:02:58'),(2518,'229bf071acc83d22137a309d8f6ef301','2025-02-04 10:02:58'),(2519,'d23b2497577679b1762ff3a5a0968f3d','2025-02-04 10:02:58'),(2520,'ce13037aedd5a15d4a4eb2fd8e851508','2025-02-04 10:02:58'),(2521,'6f834dd80a98898c5b11133a890c05cf','2025-02-04 10:02:58'),(2522,'9103b46180b823fd57401fd84860a678','2025-02-04 10:02:58'),(2523,'dd7961c1ab611bf83a9a388d0eefff3c','2025-02-04 10:02:58'),(2524,'981f30451c0472fc6be1618a4f1622f7','2025-02-04 10:02:58'),(2525,'365de49b6890ef61cbf2f6d8caa2c50a','2025-02-04 10:02:58'),(2526,'748ef7c18057c8d0c1e9ea5b87d2e107','2025-02-04 10:02:58'),(2527,'ada4ad7d21a86b71a0efb8d1bb3fe246','2025-02-04 10:02:58'),(2528,'7c2ce81f94ce620de7755a38a33ba484','2025-02-04 10:02:59'),(2529,'590f95286c2e0818d77c6e6bd329a994','2025-02-04 10:02:59'),(2530,'750676b77a6aa677c78ef6d6ece945c8','2025-02-04 10:02:59'),(2531,'16c9617da3e053ac9932212489667bb5','2025-02-04 10:02:59'),(2532,'e025deef5594f6eb86f42f6ef0b22aa7','2025-02-04 10:02:59'),(2533,'033f3a791096c9c73f1826426259a296','2025-02-04 10:02:59'),(2534,'71b6369a0787e555c6f3784211d047f4','2025-02-04 10:02:59'),(2535,'cefd976cba5122568f05f4a146eda885','2025-02-04 10:02:59'),(2536,'909ff640ec4d2a6651447b1e9af3f1c5','2025-02-04 10:02:59'),(2537,'1f8a3e9b85c5735ea612491defad76a8','2025-02-04 10:02:59'),(2538,'10854feab018fc074d3ad8b152facce1','2025-02-04 10:02:59'),(2539,'6c5130fca14167c42d54a42605a4e7d4','2025-02-04 10:02:59'),(2540,'22e8a511d45e5696183a03e3a607bc3f','2025-02-04 10:02:59'),(2541,'85a4518c9c97bad4fdb56ad57d6cb67b','2025-02-04 10:02:59'),(2542,'5840ce35cce5f5fbf33ad1843af75479','2025-02-04 10:02:59'),(2543,'ee628caa0f3374a54c6c14d15fb6af7e','2025-02-04 10:02:59'),(2544,'001f619e41a80aabe0548994897c9b3a','2025-02-04 10:02:59'),(2545,'848cfa1a7002fe51ea2dd6694cf250ac','2025-02-04 10:02:59'),(2546,'15c7ace3c1bbe191a9059dfae8efc29c','2025-02-04 10:02:59'),(2547,'68a6e1078b4c71e1fd05abf60273ec9b','2025-02-04 10:02:59'),(2548,'b9e5e302762023cc993dfb49d21e1e21','2025-02-04 10:02:59'),(2549,'276483bb7df7b4dd8c3596635ef3b4d2','2025-02-04 10:02:59'),(2550,'b98753e85e61d36608fe76dff28fd57f','2025-02-04 10:02:59'),(2551,'488b8d2ae9c1b20116d9eaa2e4f30544','2025-02-04 10:02:59'),(2552,'c9f86654eb3350e27d9aa46d98a51d03','2025-02-04 10:02:59'),(2553,'e918c58bdba3c48623b57fb774dd1d05','2025-02-04 10:02:59'),(2554,'fde7d4c87a552ca63e1f6521b74acdd0','2025-02-04 10:02:59'),(2555,'f87a41130d765f39539bdc2a28f52afe','2025-02-04 10:02:59'),(2556,'487746ca40e39096932e669b4161e27a','2025-02-04 10:02:59'),(2557,'aec9be496e506fb4a1b2a7b0c49ecbf7','2025-02-04 10:02:59'),(2558,'7e782ffb631f3441f80e1d02133dcfa7','2025-02-04 10:02:59'),(2559,'3bcb9d624ec2df8b9ad8f219d50b5d44','2025-02-04 10:02:59'),(2560,'161ffef59b7b41ca6772c8229e1602bb','2025-02-04 10:02:59'),(2561,'2662396412106325e3f43f1b6773e247','2025-02-04 10:02:59'),(2562,'535f9564a51b1cb0aa33b2b25e492fdc','2025-02-04 10:02:59'),(2563,'1e61a01f52444e8b0b26cf7c774fbde3','2025-02-04 10:02:59'),(2564,'870c797af875d9f7e6365ac0549a1eef','2025-02-04 10:03:00'),(2565,'da270f6ae045ef43f9b4e045c48827d6','2025-02-04 10:03:00'),(2566,'06efae78134e11cf829e1b0c0bfa9376','2025-02-04 10:03:00'),(2567,'549a46520c208bc763acee3728487312','2025-02-04 10:03:00'),(2568,'cdd6e7fac512f11ab3d5ed0d02abfaf6','2025-02-04 10:03:00'),(2569,'082c29e7a0b13cb5e3633c6b8c4ee565','2025-02-04 10:03:00'),(2570,'c4e370b3c9071860b220f4000d72cb83','2025-02-04 10:03:00'),(2571,'e49fc97604332a27616dfbe934170b9f','2025-02-04 10:03:00'),(2572,'eb53a6b440621f7e56850f8121881af3','2025-02-04 10:03:00'),(2573,'024df6c4cfd898456a0bd6d529889b36','2025-02-04 10:03:00'),(2574,'19def20326047aa4ea18267f368fa3b8','2025-02-04 10:03:00'),(2575,'7c7a6fca39bbfb2f07c9660b03f0d534','2025-02-04 10:03:00'),(2576,'38a94531573908e058a41c7c4ff657cd','2025-02-04 10:03:00'),(2577,'9124c582d542513d979373221b7952b8','2025-02-04 10:03:00'),(2578,'99454b051de696b0c5db25792777a550','2025-02-04 10:03:00'),(2579,'d4e55d975e2c26d94a38b23d29b3b106','2025-02-04 10:03:00'),(2580,'a22114bdcac4b58607cc244d614d814d','2025-02-04 10:03:00'),(2581,'5f9796e96787c4f0fb282a2aae5ca64c','2025-02-04 10:03:00'),(2582,'36719cf4732a5cdb7f9cb42e8bb48493','2025-02-04 10:03:00'),(2583,'6c770eded73cfe6d98cfa6710ca33f2b','2025-02-04 10:03:00'),(2584,'a64165c6d7f12cd22fb7480a390c218f','2025-02-04 10:03:00'),(2585,'7e2bf9e193b67060ac34a5693f50bb07','2025-02-04 10:03:00'),(2586,'639dca599d04477aa8b62ceb15bfb547','2025-02-04 10:03:00'),(2587,'cd1a7b3704bbee9f4d491d0d6ae132ef','2025-02-04 10:03:00'),(2588,'bb32bf01420854d4e8edc02e89451e72','2025-02-04 10:03:00'),(2589,'2ad0b6739fec7781d89c2cfd9e157267','2025-02-04 10:03:00'),(2590,'9b39fbb157fbcd8f400405e53d847d0f','2025-02-04 10:03:00'),(2591,'660e4bdb5b1bfafb92f37eebd1c10594','2025-02-04 10:03:00'),(2592,'28134bfe225ac4202260048f5f4b5b23','2025-02-04 10:03:00'),(2593,'429c919dab6ae7bcc8f1bbca0667f2b2','2025-02-04 10:03:00'),(2594,'e30350462da2aa1d3cae7dd868d45dbf','2025-02-04 10:03:00'),(2595,'594584223de01c8cdfa27e319cbdb7b4','2025-02-04 10:03:00'),(2596,'8e75b8eff156ba31832397f2393755f1','2025-02-04 10:03:00'),(2597,'b937d7d7c71171c5ce93e7e091f497b8','2025-02-04 10:03:00'),(2598,'091e4343ce3a6a2edacb41cf6c4f3712','2025-02-04 10:03:00'),(2599,'dabf12ddb9ae3265c7ec2c59d671cc0c','2025-02-04 10:03:01'),(2600,'3b340025bcc200706e77d77123fe28e7','2025-02-04 10:03:01'),(2601,'f9b6844217c49124ade41876defdd642','2025-02-04 10:03:01'),(2602,'58c6d031cf90f8b8b870452d19651111','2025-02-04 10:03:01'),(2603,'b3d85bd6bed9acc4e0bd81b58c2f6bfa','2025-02-04 10:03:01'),(2604,'5a42016752f350c370631def951e6054','2025-02-04 10:03:01'),(2605,'4c3de6dc7f0969c926990f0c7f9594cd','2025-02-04 10:03:01'),(2606,'b39aaf3ef74159497da358dd025d5539','2025-02-04 10:03:01'),(2607,'49f4ef61fbe5c7592326176ec9a4652a','2025-02-04 10:03:01'),(2608,'873770d9038c958f42a3a8c0a3119b08','2025-02-04 10:03:01'),(2609,'4f636ac6d8d5c1b3fd9d2d01f9c84b36','2025-02-04 10:03:01'),(2610,'15181b0cff81da2c75a6ee187b68ffd9','2025-02-04 10:03:01'),(2611,'8b3adf4a507e0b7199ecebfd15f04f4b','2025-02-04 10:03:01'),(2612,'9e1acd32a8f07072da1f6f42a9a4f230','2025-02-04 10:03:01'),(2613,'991312c6b87dabca3ba715396ee55a11','2025-02-04 10:03:01'),(2614,'3d806db71dcfd75ff9de51db0feaee16','2025-02-04 10:03:01'),(2615,'e1d5992c4ede689c5c03d9c754761b27','2025-02-04 10:03:01'),(2616,'9ab6b86acd18bfb94773c1bdb986246f','2025-02-04 10:03:01'),(2617,'051e8741e6226ae2dc19b96a2534b1d9','2025-02-04 10:03:01'),(2618,'1bbbb43e5bd149e872bbd3bedee02c83','2025-02-04 10:03:01'),(2619,'3aba7ae77ff98610ca4bbe50cc778528','2025-02-04 10:03:01'),(2620,'1081c126cffffaf1ba794ec7af1eefe7','2025-02-04 10:03:01'),(2621,'c68589faf63a18f22c275cec0fff4457','2025-02-04 10:03:01'),(2622,'e66e6a374983e2a81746fe03c2d55ca9','2025-02-04 10:03:01'),(2623,'362041e53c5f7485b93d9acc96627974','2025-02-04 10:03:01'),(2624,'76657e7af4ef6be62a9af8fb9fd83e35','2025-02-04 10:03:01'),(2625,'2cef53785d0632e492d203a1df238c6a','2025-02-04 10:03:01'),(2626,'3484d53afb9955d09f4574aa963cd78e','2025-02-04 10:03:01'),(2627,'109b1a3d10aedf7782a81482b20b0dc2','2025-02-04 10:03:01'),(2628,'ac0ad45d6e7ff00d2d799abc225c6f8a','2025-02-04 10:03:01'),(2629,'1a3887d912543ee851c76eddd4c056c6','2025-02-04 10:03:01'),(2630,'97185919dc555d88927ee03f4e841666','2025-02-04 10:03:01'),(2631,'05ab3ea0615a2590d0352157c1d96364','2025-02-04 10:03:01'),(2632,'7c6717dd14aa5d72be16b98f45b9ebb7','2025-02-04 10:03:01'),(2633,'bb4c9763e2e2ad04b38925bc808a1ab7','2025-02-04 10:03:01'),(2634,'183ce23b3386b46c5b7e4b25fed6cc56','2025-02-04 10:03:01'),(2635,'e0e8e959a26fb231b47d5d6b3540b9da','2025-02-04 10:03:01'),(2636,'92ba5ab7ee8434e4f943b5b487de357c','2025-02-04 10:03:02'),(2637,'fabe2bfdbfdcf4a2c3316f368716f7e9','2025-02-04 10:03:02'),(2638,'731dcaca0c0aad3c0faaea33f6c32f44','2025-02-04 10:03:02'),(2639,'7cbc2c44f63186c53e72cf075b87ac0a','2025-02-04 10:03:02'),(2640,'72f8aa409f9954232525523a329ccabe','2025-02-04 10:03:02'),(2641,'43c4de2b3f2d765c9ad5e9bc06ee5e57','2025-02-04 10:03:02'),(2642,'c89bbbce6eb295fd6780f6ae52a5eef5','2025-02-04 10:03:02'),(2643,'8f71d596f1fb5e5eb800256299528a89','2025-02-04 10:03:02'),(2644,'711501511e40c4084b71171f0ecf608a','2025-02-04 10:03:02'),(2645,'c0493e973757ff224e9482fc7a9fdd46','2025-02-04 10:03:02'),(2646,'c7ddacf11f5f13ba0a7c1c6fb43b3fdf','2025-02-04 10:03:02'),(2647,'34e5215e9f842274aa7a1ddaf1d35867','2025-02-04 10:03:02'),(2648,'19e92e8304d7e7edc8d7149f17db515f','2025-02-04 10:03:02'),(2649,'e1381c52a209114bfe1dd93bbfb98c37','2025-02-04 10:03:02'),(2650,'4df528198593796c52acfbade019f7fa','2025-02-04 10:03:02'),(2651,'6eb20e6a8577b7804fdd4dee665808f4','2025-02-04 10:03:02'),(2652,'5db7c9bec91dc95abea974493525f79f','2025-02-04 10:03:02'),(2653,'d2c530065f9f3d52845e8b4c5851a4a2','2025-02-04 10:03:02'),(2654,'5f89bd7172d36e118449fd3a387ca21b','2025-02-04 10:03:02'),(2655,'422ea63f7678b45fb4ca5fd2681400d3','2025-02-04 10:03:02'),(2656,'27614b3cbdcf1dad1973464ef40b081c','2025-02-04 10:03:02'),(2657,'940a0408a904f2093577c7079698b470','2025-02-04 10:03:02'),(2658,'10aa9289550b2ab7d4ab9c5b0ea0fe98','2025-02-04 10:03:02'),(2659,'9f6f3f122e4350605009196965582f40','2025-02-04 10:03:02'),(2660,'75f8fa9c689e169610464aca77a8a31e','2025-02-04 10:03:02'),(2661,'c362b918b3c7a332dc8d26be456fda95','2025-02-04 10:03:02'),(2662,'582418ad25cd5d0081a9a2e5783defd7','2025-02-04 10:03:02'),(2663,'b393475446586fd9e8be76861c3b189d','2025-02-04 10:03:02'),(2664,'6c7d4dcc6bd75d5b290b2625e0ab9af3','2025-02-04 10:03:02'),(2665,'b53b1c244f9c2da87323da61047aa706','2025-02-04 10:03:02'),(2666,'bcc96115c16a9d7f9f732bbd872570f9','2025-02-04 10:03:02'),(2667,'6ba43b3d5bd5340343a44ba1cc628b23','2025-02-04 10:03:02'),(2668,'27e8239be7ddd277985e5903b7233124','2025-02-04 10:03:02'),(2669,'33cb823ab437c397eb358d20ff2e39fc','2025-02-04 10:03:02'),(2670,'b7a5ef93bea8adc88cd6b08a6c997b52','2025-02-04 10:03:02'),(2671,'72932d833ecfbec6c85037eb54db8a9b','2025-02-04 10:03:03'),(2672,'4872bb8f96db8f4ba28309014fe4d646','2025-02-04 10:03:03'),(2673,'40d7765f1df951f492cd4ec1e1051eb8','2025-02-04 10:03:03'),(2674,'ff78ff51062682fd36349c30732c5d8d','2025-02-04 10:03:03'),(2675,'726e96b47acfce315be6e7ab05cf611e','2025-02-04 10:03:03'),(2676,'2a59f0b13dc5473f54340c160a4109f9','2025-02-04 10:03:03'),(2677,'1ec8bebb411a9bd2db448b3ae0b7df0d','2025-02-04 10:03:03'),(2678,'66c0825faa93b38637c64ed876565121','2025-02-04 10:03:03'),(2679,'a97633a3113de05715289262d7a82ed8','2025-02-04 10:03:03'),(2680,'2323f2a45de12f1afac0139e73ff9aee','2025-02-04 10:03:03'),(2681,'58d4919e053c57b97ad76804ef69a58d','2025-02-04 10:03:03'),(2682,'7066f3623b4d1de38e2e152fa98ff005','2025-02-04 10:03:03'),(2683,'f2bd700bcd74301681067906518721ce','2025-02-04 10:03:03'),(2684,'03f99c29e3bf96a9f0699acaebe5a43b','2025-02-04 10:03:03'),(2685,'a8d3150949f7373b885c530b1814be4a','2025-02-04 10:03:03'),(2686,'3904358303c27381c07c71aba99c0bce','2025-02-04 10:03:03'),(2687,'d1535f2f9dd15f7833a22696c1f14ef3','2025-02-04 10:03:03'),(2688,'7b6849d7055ebe3ee724f70d0b240623','2025-02-04 10:03:03'),(2689,'fa55ebe951037cba0b75c092e1b1955a','2025-02-04 10:03:03'),(2690,'973a7aa3608fe18f2eee6fee73026790','2025-02-04 10:03:03'),(2691,'e0c6d6c325a5c1c44214be2f205b12ad','2025-02-04 10:03:03'),(2692,'be73b797a776d1bbc6bf5d235147f786','2025-02-04 10:03:03'),(2693,'ecca36b0908fc2451649804ea5d6ce7c','2025-02-04 10:03:03'),(2694,'bc15d6fdf39eacc285196606011b5417','2025-02-04 10:03:03'),(2695,'40ebcd46a3d280cf8a19d6cd719ed6ac','2025-02-04 10:03:03'),(2696,'3cb4195b6498785792c7a69e42d0f735','2025-02-04 10:03:03'),(2697,'a753899b9dca22cc3bc87194da240f8c','2025-02-04 10:03:03'),(2698,'646ab45c48806f99c8617a32d9ad344d','2025-02-04 10:03:03'),(2699,'3292c671a7b2d63f5ec9a6e3e6b81468','2025-02-04 10:03:03'),(2700,'c9730c2b7a5d1383eed7fb8968632004','2025-02-04 10:03:03'),(2701,'f2ea1d5faa63a92f69b688c5528f7d1d','2025-02-04 10:03:03'),(2702,'a12c88e6e3980096261c0db5e071b204','2025-02-04 10:03:03'),(2703,'9af02d502351281b4955ced6ddc9f91c','2025-02-04 10:03:03'),(2704,'f706d4c3d253babeb7e2332636a4a1a9','2025-02-04 10:03:03'),(2705,'21c9a16f4798b04345884c097c731540','2025-02-04 10:03:03'),(2706,'389c05d3ce91e6b17adec04470beb4ba','2025-02-04 10:03:03'),(2707,'e29d5051f42016b4ac56f8ecf171f188','2025-02-04 10:03:03'),(2708,'3f47353666ed5e7d454071091fd1ed7c','2025-02-04 10:03:03'),(2709,'d1c6adea3e9a131296d86f3118872727','2025-02-04 10:03:03'),(2710,'8794bf253c208fef24dc4d41d0356db8','2025-02-04 10:03:04'),(2711,'af2bcbc65aae3ab63b0a6a50ee799da2','2025-02-04 10:03:04'),(2712,'a50f8dca9b1ef69f61416b9b51ea6ce8','2025-02-04 10:03:04'),(2713,'90eec9422ca342e3507f61c62e6e4a47','2025-02-04 10:03:04'),(2714,'d9de5c7829c3341493389df7abcec734','2025-02-04 10:03:04'),(2715,'f333bec6e8379c480a16c8166d775af2','2025-02-04 10:03:04'),(2716,'9a11508903662120a1ad82ad010f4df5','2025-02-04 10:03:04'),(2717,'271838816ff9d5ad536ef004e6a5e755','2025-02-04 10:03:04'),(2718,'8beef74357cd11915c1c0518b5182c8d','2025-02-04 10:03:04'),(2719,'cb2b9eee4ad6b6ed01d87992bd6470e0','2025-02-04 10:03:04'),(2720,'532be9bf22f80e6d2f53bafaad327e8a','2025-02-04 10:03:04'),(2721,'a926b7d57155832fd3a34aa8ccedd60e','2025-02-04 10:03:04'),(2722,'525c0f669d2c0f6e1d3c45db0b985355','2025-02-04 10:03:04'),(2723,'458a810898f90a54afb386945cc36c49','2025-02-04 10:03:04'),(2724,'25fc9bd6310182a3cb1f5c6f59fd69bd','2025-02-04 10:03:04'),(2725,'7d92eb315f0f58019e4ff75c9492559d','2025-02-04 10:03:04'),(2726,'cdcba4a4872021a0e413e1ecf360820a','2025-02-04 10:03:04'),(2727,'ffa643bd502f874ac8e695ebdc272b68','2025-02-04 10:03:04'),(2728,'1a1cb90791b235025c63b72381a3b3d4','2025-02-04 10:03:04'),(2729,'4cd5f46ff5ff5b2c8733ee9fbefe885f','2025-02-04 10:03:04'),(2730,'ed95c80fedcf834f5abeaa8540573fda','2025-02-04 10:03:04'),(2731,'0ca75a4cb05f5da4e704006136de5bb6','2025-02-04 10:03:04'),(2732,'a8991f274bba3d09e72ed6dbda2710eb','2025-02-04 10:03:04'),(2733,'bb5d0f9c54ea26828d0c2df38625836c','2025-02-04 10:03:04'),(2734,'4aab4ec1a7c3499620211455d2fd648a','2025-02-04 10:03:04'),(2735,'08efa328e8f030f97cad9c6fed6f6645','2025-02-04 10:03:04'),(2736,'cd7ccee73be4be27dc12978a00bce6ba','2025-02-04 10:03:04'),(2737,'1eb0c1f8346a203c7fa18a14b2bd66ad','2025-02-04 10:03:04'),(2738,'088d6a29d4a19fa7565ab7dbef7298fa','2025-02-04 10:03:04'),(2739,'a42a223334dedbccd9eaa06822d5afc6','2025-02-04 10:03:04'),(2740,'7d38baf5d75f1fb3245f1b073826fe2b','2025-02-04 10:03:04'),(2741,'5821aa3013330bb722dd25052dfd3048','2025-02-04 10:03:04'),(2742,'d529b5b46c859c5fe19ce28319a680cd','2025-02-04 10:03:04'),(2743,'358a5c5d4b2324dc23870fa42ccc4e95','2025-02-04 10:03:04'),(2744,'b1fce99f6eb7fc43886c74bf6d69e4de','2025-02-04 10:03:04'),(2745,'cee2613e77dd63b4c48276cf4f09b714','2025-02-04 10:03:04'),(2746,'c62fa10468e50bf30675e45dbeac0cca','2025-02-04 10:03:04'),(2747,'84fe513d32e0fa4759f854491934035c','2025-02-04 10:03:04'),(2748,'706086f20bdbb9bfe12cb6b67ba0c3f1','2025-02-04 10:03:05'),(2749,'90f5f5dbcdc9b911e42f70d28e77cca7','2025-02-04 10:03:05'),(2750,'d8083a79e18fdf64315564b6f8bbf5ba','2025-02-04 10:03:05'),(2751,'39feaec2c6d87eac833fa6f3ce4837a2','2025-02-04 10:03:05'),(2752,'b6334dcd7ee88befcc815107a0b3bbc6','2025-02-04 10:03:05'),(2753,'ff29f80a8879ee1dd1bbc823406aeafa','2025-02-04 10:03:05'),(2754,'940abf51314259e48d1d6500a0fe84b9','2025-02-04 10:03:05'),(2755,'14ba8083be7fd669370cad9e509cf4f7','2025-02-04 10:03:05'),(2756,'2e16919cb00e1309290b4c71574d1061','2025-02-04 10:03:05'),(2757,'7d4e5e39517fe39f639135c7237cf402','2025-02-04 10:03:05'),(2758,'eab0be057401faedb2000c23085aa10e','2025-02-04 10:03:05'),(2759,'4c9a7b2ce3222c500023f2c8352f5c4a','2025-02-04 10:03:05'),(2760,'dff8f1b960f68eaa89f28bfa333224cd','2025-02-04 10:03:05'),(2761,'5ef5a828db819f064561f6239075202d','2025-02-04 10:03:05'),(2762,'2eeac601b8e140d2fd1a8e72e95bfd73','2025-02-04 10:03:05'),(2763,'f4a94b8511fbd8fadc69a86f576591e2','2025-02-04 10:03:05'),(2764,'8f5a36d671ed3601016fefc1816272db','2025-02-04 10:03:05'),(2765,'66267d6973202cfaa7b786178c5dc836','2025-02-04 10:03:05'),(2766,'4f6181fbde6bb4ab4c151a2a14b4a8ab','2025-02-04 10:03:05'),(2767,'ba221cef61a9ee7f0cbd171dd2866705','2025-02-04 10:03:05'),(2768,'096405683894bacdec12538c2a8342a0','2025-02-04 10:03:05'),(2769,'01637851e19a16a7ab3dd7de53fb2af8','2025-02-04 10:03:05'),(2770,'97fae72fd7824db30d45647ad63d6dd2','2025-02-04 10:03:05'),(2771,'d71129d47ba2232d649a272c493ecc81','2025-02-04 10:03:05'),(2772,'a272bb2d857cd9e910b1336cb9cff21f','2025-02-04 10:03:05'),(2773,'071712b8aa59e4b5961df0f6f05d61fa','2025-02-04 10:03:05'),(2774,'4e9c40a5937afb93c84184927e86eab4','2025-02-04 10:03:05'),(2775,'ad338a4f5135a420203ac2aa3f97b191','2025-02-04 10:03:05'),(2776,'070baa55eaf0eac2dac231f097b71b9d','2025-02-04 10:03:05'),(2777,'50545cfe21a64243876c57dcda763173','2025-02-04 10:03:05'),(2778,'70aac1538227a0919ae1f6be2e1dd06c','2025-02-04 10:03:05'),(2779,'971f7d064054bb7a6361589965fbe00d','2025-02-04 10:03:05'),(2780,'5de0aba3a713617e8f500389f9bb27e9','2025-02-04 10:03:05'),(2781,'6427d1c13a4fd11cae40321b84b5c660','2025-02-04 10:03:05'),(2782,'e8202e1b997e0a23d70bbd06c419d638','2025-02-04 10:03:05'),(2783,'af148ff172c31a61f5bfcb687f73904a','2025-02-04 10:03:05'),(2784,'b506a25e5c9ab7ef008ab3c14fc611f1','2025-02-04 10:03:05'),(2785,'210c55eca6fab2c84e6d6e093be4dda1','2025-02-04 10:03:06'),(2786,'04055d95efad6c09480825a6a43e6cf4','2025-02-04 10:03:06'),(2787,'f7dd956faa1aebe72605cf02e354d3e0','2025-02-04 10:03:06'),(2788,'f6ac1cd51490fa6d3908cba48943d249','2025-02-04 10:03:06'),(2789,'bda9eeff624e7a6b6dd68ec7cc8e03b2','2025-02-04 10:03:06'),(2790,'8c55a8a4e2955a1cc2cd8bde67f9d511','2025-02-04 10:03:06'),(2791,'ad5142b8cb4f57f0fb4207efeeb2d77c','2025-02-04 10:03:06'),(2792,'7d31f051abd6c5b9da53101e21bf2801','2025-02-04 10:03:06'),(2793,'6f00893c2769b748a3b08c0d37f7ceda','2025-02-04 10:03:06'),(2794,'7dcbffee3b4b06456f5bdf23e290113d','2025-02-04 10:03:06'),(2795,'cbb5a4fa572efa8fbe046693eefa1bee','2025-02-04 10:03:06'),(2796,'8ee4222e9fd80a38a0d37a93861e689f','2025-02-04 10:03:06'),(2797,'ad515b15a80adf97b1bb547dbcb30a51','2025-02-04 10:03:06'),(2798,'02542e0c42f6b9a585deb67772ac55d7','2025-02-04 10:03:06'),(2799,'735426fa6afe256f92479e8921b3e2ad','2025-02-04 10:03:06'),(2800,'3a524de450f951b96f850e83e3ece430','2025-02-04 10:03:06'),(2801,'42850c47fc6dfebef7009c9069ad8714','2025-02-04 10:03:06'),(2802,'db5d3615128310272c3660ed0f0c257f','2025-02-04 10:03:06'),(2803,'e20b1e09f10848659aba35faa0a7af48','2025-02-04 10:03:06'),(2804,'9a9438d6f32719e51097580fec7fce81','2025-02-04 10:03:06'),(2805,'63ff335e08f5a95475d59adba431c757','2025-02-04 10:03:06'),(2806,'04543c7131b9719fac63431cc722bbd4','2025-02-04 10:03:06'),(2807,'ed4f0fdfbf2579ec68b671ff40343d9b','2025-02-04 10:03:06'),(2808,'0b63596ef24a09e2e06d0a157a4c49c7','2025-02-04 10:03:06'),(2809,'229ccdf0351f50c0388c2fed4d2f6039','2025-02-04 10:03:06'),(2810,'2e6e08f7f4bd269eef3ca865f07457ed','2025-02-04 10:03:06'),(2811,'83e90522918d2c3f742757029f60ea94','2025-02-04 10:03:06'),(2812,'772a117faeed24d78d5d8505350959b6','2025-02-04 10:03:06'),(2813,'5442640a051736b94fe50bcbf9d870fd','2025-02-04 10:03:06'),(2814,'3be1c84e8d6db8c6c9a423427060b82e','2025-02-04 10:03:06'),(2815,'7dc54b98e98c47025a5ae03ac0588527','2025-02-04 10:03:06'),(2816,'0fb392d2cdee2a0eae5d6a1ebacca73f','2025-02-04 10:03:06'),(2817,'3f0690098c08e7c40bce86adcdc63648','2025-02-04 10:03:06'),(2818,'6fd30ecde99f0261f0afbfdec78cf51c','2025-02-04 10:03:06'),(2819,'15d9af4fc551f7c9ec8a09a72c75d175','2025-02-04 10:03:06'),(2820,'923331917ff8f7a7c46d1c17cb0f8a87','2025-02-04 10:03:06'),(2821,'198927f2ba5e210e1e0fae3ecdcee537','2025-02-04 10:03:06'),(2822,'78399f0b81861a9cabcb1c3cc5b61430','2025-02-04 10:03:06'),(2823,'24ae00a8aeda1a79ff87f5c849b1a88b','2025-02-04 10:03:06'),(2824,'a27ff1304f6ccbeed2b37a6f0c9cf5f5','2025-02-04 10:03:07'),(2825,'2f5032caec0a5bfe3acde2de63f0c084','2025-02-04 10:03:07'),(2826,'babf9d787dcdbc77afcd8c74c5cf9fc2','2025-02-04 10:03:07'),(2827,'729ec59c6bb75d7997c516034c94bd0f','2025-02-04 10:03:07'),(2828,'3829b6b7480e5d60ae26d469dc3e56e1','2025-02-04 10:03:07'),(2829,'76e648769ddf88b9405ae96e70aa1cfe','2025-02-04 10:03:07'),(2830,'5de96926a0082485e81846727ea950ca','2025-02-04 10:03:07'),(2831,'0e83cf07a9396890f79703b680be189e','2025-02-04 10:03:07'),(2832,'0b2de6484e241fe8e7bb50a6ba9092d8','2025-02-04 10:03:07'),(2833,'b81ae245be151d29b32b3e2cc09d0d3a','2025-02-04 10:03:07'),(2834,'a7c399e64ee88d9f184956798a20bd74','2025-02-04 10:03:07'),(2835,'fc9cc6a5e1ac637f4c93be0a4b3b0e5e','2025-02-04 10:03:07'),(2836,'7d3fcccc30cf49d663e0d205715e92cf','2025-02-04 10:03:07'),(2837,'64c0c3a923c92f61336ace7d8555d160','2025-02-04 10:03:07'),(2838,'f18c72d7cd80fc252defb1ab0c7f7f88','2025-02-04 10:03:07'),(2839,'4da6aa877987ee87aabd5e10c09d55c5','2025-02-04 10:03:07'),(2840,'2820aebdee6f1930dab4dd89746fcfcd','2025-02-04 10:03:07'),(2841,'65f75c89879764eb9d5de8bca9ba0b53','2025-02-04 10:03:07'),(2842,'388b4921aad04a9d8126afa2567f99fe','2025-02-04 10:03:07'),(2843,'631a9ccec080e54b3fea433e38c2b7dd','2025-02-04 10:03:07'),(2844,'1e978cf9825efe72f16496bf1fe89d97','2025-02-04 10:03:07'),(2845,'9ac5761c58c9a9e3bf028885b27eeaf8','2025-02-04 10:03:07'),(2846,'fe69f3dd42c9499c97c6a0f449f3b8b5','2025-02-04 10:03:07'),(2847,'11a47043b9d2025da812cbfdb72d053f','2025-02-04 10:03:07'),(2848,'008b7154b49a67c2cf7b38020cae664a','2025-02-04 10:03:07'),(2849,'eecdfdc7a8c01c89b69272be565b04a5','2025-02-04 10:03:07'),(2850,'98108e4219f15d1aedfc26d1501a8cdf','2025-02-04 10:03:07'),(2851,'504467cca1cc01ba0a1dd4c1b3977b45','2025-02-04 10:03:07'),(2852,'e5d7b401db18e0a51168ce2c8a5259ce','2025-02-04 10:03:07'),(2853,'10fe1145f3a0ecb886d507f17e184b9b','2025-02-04 10:03:07'),(2854,'86dc38e27ee32cf80447bf40c1159a35','2025-02-04 10:03:07'),(2855,'e03c89657fbaa950c90f45b2e9c66285','2025-02-04 10:03:07'),(2856,'408fa46d82700ad40f905e09042d031c','2025-02-04 10:03:07'),(2857,'47db2fed3bcca6ddc88c1a37d117e6cf','2025-02-04 10:03:07'),(2858,'eec01d600386f68570496400161c19fe','2025-02-04 10:03:07'),(2859,'8edeefa7e26edf64af1c165a5b14feca','2025-02-04 10:03:07'),(2860,'1db8aaa77b4724b395a1b9deee98ec6f','2025-02-04 10:03:07'),(2861,'4b91687295c7c7813add87bc3056ae88','2025-02-04 10:03:07'),(2862,'a4bdcec08f7dab43fb2bdab6875977f7','2025-02-04 10:03:07'),(2863,'84178b5311c7485d098d1927f54e3289','2025-02-04 10:03:07'),(2864,'ac8ddb6997578ec9c1b59028bc97d0c6','2025-02-04 10:03:08'),(2865,'613ce76bcaf584a6b4a5d1166d4f27dd','2025-02-04 10:03:08'),(2866,'7a812697622047e4eef0c5b476a04033','2025-02-04 10:03:08'),(2867,'92a1743c24a3a2a67b9e15826cd6bca6','2025-02-04 10:03:08'),(2868,'b643b768109d847558674d4c359bad23','2025-02-04 10:03:08'),(2869,'5f27f57df693bc7feeab523e287b124e','2025-02-04 10:03:08'),(2870,'12f50794466301e5d9d5c82c245c41b8','2025-02-04 10:03:08'),(2871,'087685a7d1278f2086948dfa561508e9','2025-02-04 10:03:08'),(2872,'10ad4f3adb202481833b8f643a7fe29a','2025-02-04 10:03:08'),(2873,'fd1b5467a6f667fb202ef9268c070ce8','2025-02-04 10:03:08'),(2874,'d27452ebd25593df378d6d135ca8f273','2025-02-04 10:03:08'),(2875,'52acd8d75c9e1ea7de1323079df66730','2025-02-04 10:03:08'),(2876,'d26ee97642b59358d7a4ec65eb48ec3c','2025-02-04 10:03:08'),(2877,'1b79cbdfc66358ba3355ccfc4912e498','2025-02-04 10:03:08'),(2878,'dec726f0350b3ac2af3606eb9c515a6f','2025-02-04 10:03:08'),(2879,'c19cefeae3f41386273ffc7c2b4b8f09','2025-02-04 10:03:08'),(2880,'c953c80d7123ab34bed623f7f90aa78d','2025-02-04 10:03:08'),(2881,'60e03fa41cef941fb1d02bc976deafa4','2025-02-04 10:03:08'),(2882,'8645194181ba86d2cb6236f4c495a90d','2025-02-04 10:03:08'),(2883,'409deefcc5b29a66fc19166e9e550a19','2025-02-04 10:03:08'),(2884,'e77157a4bcb85ac8b277c486625ce3fe','2025-02-04 10:03:08'),(2885,'938e620adb27ed47df480093db9bd618','2025-02-04 10:03:08'),(2886,'6b2277716df99643cc9b9dc5fe3ff5b0','2025-02-04 10:03:08'),(2887,'77fe9c0622cb35875d3c6ac823429f84','2025-02-04 10:03:08'),(2888,'c6766bf22a7f39018dc6a3adb432cc2a','2025-02-04 10:03:08'),(2889,'c7bab1be122565a4a82375cfc0f32370','2025-02-04 10:03:08'),(2890,'632b51e17b44a1ae5e0dbe737bbf75c9','2025-02-04 10:03:08'),(2891,'e85a43bd71861ca712cc6705498bc9c2','2025-02-04 10:03:08'),(2892,'7bd9f5e181530e44970b4f377d5b9e6d','2025-02-04 10:03:08'),(2893,'078f97d7c066bc199bd978afe57555fe','2025-02-04 10:03:08'),(2894,'83df36e343e19ae26c84bc5dc76215ac','2025-02-04 10:03:08'),(2895,'512afc4a7ab4fe1f2e284faff907d5d5','2025-02-04 10:03:08'),(2896,'6645cd44a343ea5f9901927b016c2930','2025-02-04 10:03:08'),(2897,'bf8c988835c0cf141c5310e47c7ca5d2','2025-02-04 10:03:08'),(2898,'af5b33da8f9dd65b407fd3cc5286843e','2025-02-04 10:03:08'),(2899,'b15185d1d6196e12a438532f92ce89c2','2025-02-04 10:03:09'),(2900,'000edb0937aa96bcafabd4b0ef5bc0d4','2025-02-04 10:03:09'),(2901,'7143d93cb5c3b917f9a6fd223101629c','2025-02-04 10:03:09'),(2902,'26601d4b42e6e3ad9bb16f62f81ce974','2025-02-04 10:03:09'),(2903,'5eeb8cdb4953dffc4415705fe0bd5ef6','2025-02-04 10:03:09'),(2904,'3f81afd4ca4b99fe1aff59b94cc29228','2025-02-04 10:03:09'),(2905,'f1b478990614115edd6c870840288ca2','2025-02-04 10:03:09'),(2906,'128caeeab417ad67ed998f2f93e37fcb','2025-02-04 10:03:09'),(2907,'2b79053a7c1dbd2f091cde5098417ef4','2025-02-04 10:03:09'),(2908,'b4461fde16a9a86ebe6b5ada4f6afefc','2025-02-04 10:03:09'),(2909,'3d1ea65d4d0156068b6813deb9269bdc','2025-02-04 10:03:09'),(2910,'a93e0aac67014a39c2060c82d1b7440a','2025-02-04 10:03:09'),(2911,'d5809dd5b4e31cae372d3baea23977a2','2025-02-04 10:03:09'),(2912,'ce7373b9014590a4a1ea60755b8bc642','2025-02-04 10:03:09'),(2913,'d1a00ce539b7e8e7c41dfbf25c17ffda','2025-02-04 10:03:09'),(2914,'a70684b112a9be00db6b8c3bc1aa9928','2025-02-04 10:03:10'),(2915,'c8de802c4df07888fe3c7a87c92d699f','2025-02-04 10:03:10'),(2916,'d6bbebc36ba4146730f4428546928bf0','2025-02-04 10:03:10'),(2917,'6fc5954f30ef2dbee48aa6d44fbcc40e','2025-02-04 10:03:10'),(2918,'d89abf473bbf5df6e53f9644933825ee','2025-02-04 10:03:10'),(2919,'a56d791526ff9b6cbd9e56c0c2d65414','2025-02-04 10:03:10'),(2920,'585b2492dc3675b72e1c34dd380d31f8','2025-02-04 10:03:10'),(2921,'75245430aeeca57e01400f62541a1507','2025-02-04 10:03:10'),(2922,'edf2f801d6f153e4b1a728935b356ed8','2025-02-04 10:03:10'),(2923,'b5dd8622997cf8db2d8ecbaaf3d34b4d','2025-02-04 10:03:10'),(2924,'b604f7d46f4e88cb00c6f25fd2f89b8a','2025-02-04 10:03:10'),(2925,'7352910327c6898f0ef2c6151754382e','2025-02-04 10:03:10'),(2926,'ac55303184834f21b7cb2db8591d41f7','2025-02-04 10:03:10'),(2927,'66ff7afcb6a75d7d941070a3367bebfb','2025-02-04 10:03:10'),(2928,'f5a6666c5e0f4ec94ac6c63eb911556a','2025-02-04 10:03:10'),(2929,'332479050f970411bfc85c14e6dbf22e','2025-02-04 10:03:10'),(2930,'65ff535ed5ba7a9614ba63aa31840411','2025-02-04 10:03:11'),(2931,'0efb0a8d5ae4d1e59b89a4987bb3f62e','2025-02-04 10:03:11'),(2932,'65715616021b5636ff7d00c97aee2f9a','2025-02-04 10:03:11'),(2933,'79bfcf839cdd7f341385e5b02e8d43cb','2025-02-04 10:03:11'),(2934,'9999d4ff378bcc32e8bd942844fd717f','2025-02-04 10:03:11'),(2935,'c88cb489ea4f4152254d8c71e2723966','2025-02-04 10:03:11'),(2936,'55b9d57c4e589f65eb6ce903f8fbfc57','2025-02-04 10:03:11'),(2937,'5e46f0e4e543ea678c397a02d4ce9c3e','2025-02-04 10:03:11'),(2938,'6c260a4ef790b5a6a118e08319fbe3e4','2025-02-04 10:03:11'),(2939,'46fe6ffa3abac0a02d7c00074190f0f6','2025-02-04 10:03:11'),(2940,'d85b558c84b6f5298912363c175cd1fe','2025-02-04 10:03:11'),(2941,'ef35f260a2fec5a9a9ff00e41a0984d7','2025-02-04 10:03:11'),(2942,'0de870f2713c6cac22a6b81e4885f982','2025-02-04 10:03:11'),(2943,'b2662c9462768fe1f2b0e5ecd3e28081','2025-02-04 10:03:11'),(2944,'b209b0b0364a644c29ffbfb489982b1b','2025-02-04 10:03:11'),(2945,'36dbc164fa9d29ffb7dc9a3ae0e74a3e','2025-02-04 10:03:11'),(2946,'daaf8864a7ca9aaa08b794ce475369f9','2025-02-04 10:03:11'),(2947,'242c246bed0db8f57480e7c3f017bc67','2025-02-04 10:03:12'),(2948,'dbf001d38cb24357363d35c69e55a3a2','2025-02-04 10:03:12'),(2949,'1409d3adb0490d9f9b7dd9c3122be994','2025-02-04 10:03:12'),(2950,'bd8578d52abcd777af32ab0868f482c0','2025-02-04 10:03:12'),(2951,'428b0e40961d4446c6732da6d1ab743f','2025-02-04 10:03:12'),(2952,'b8e4131e214f523edb32334e7f359ac9','2025-02-04 10:03:12'),(2953,'ebb9b49f8855c8b6db22bd2c11e999d4','2025-02-04 10:03:12'),(2954,'c910046c0289223c597c7443a56cc891','2025-02-04 10:03:12'),(2955,'9b455a9566e2218ee793e67d52331a55','2025-02-04 10:03:12'),(2956,'ff36e7a74dec8e8fa206af5c1b9eb8c2','2025-02-04 10:03:12'),(2957,'96ace339a4aa1576b12bf12514741cfb','2025-02-04 10:03:12'),(2958,'4bafa72df03ad2b1d44dfeca372f7ce8','2025-02-04 10:03:12'),(2959,'bd0af93cdbaf2a8cf4325d28129d0dfe','2025-02-04 10:03:12'),(2960,'449868c5c763dcc73f90806a1d66a051','2025-02-04 10:03:12'),(2961,'2150079e62018f946113e63a58f1b006','2025-02-04 10:03:12'),(2962,'fff8797214dee48ebe13c9ad90f9b690','2025-02-04 10:03:12'),(2963,'1310f15927ca5b4c846b2f6dc7991fc0','2025-02-04 10:03:13'),(2964,'e4e7741341c71cc3d0f1df6028bddc40','2025-02-04 10:03:13'),(2965,'ada8a4fcb1746ae6716773411ad9a3f1','2025-02-04 10:03:13'),(2966,'4f2e4ea412c2a6581d7fdf46618d2f84','2025-02-04 10:03:13'),(2967,'0ec117ec8c90992ba609af466779c2f3','2025-02-04 10:03:13'),(2968,'b101c57c15e15304958ca2347fa58bf0','2025-02-04 10:03:13'),(2969,'48773852a2f3fc03dadae26012ffb481','2025-02-04 10:03:13'),(2970,'759a09fde3c4acf7135b04fbdc3a8cf0','2025-02-04 10:03:13'),(2971,'1ec652c6c260ad0af3be9f79fba2bdd5','2025-02-04 10:03:13'),(2972,'ec9aebbc7ee981c7fc7893f060342404','2025-02-04 10:03:13'),(2973,'4115e413d0f3f2de96e41e872e0b2b02','2025-02-04 10:03:13'),(2974,'8721059b137881e1f1a41970274a6746','2025-02-04 10:03:13'),(2975,'30724c56755a78b64cf7f0d558a9dcbb','2025-02-04 10:03:13'),(2976,'4d4fa99fdef122eafeb5f743448875bb','2025-02-04 10:03:13'),(2977,'6b509a9967c0417e3e6b4e7aec750855','2025-02-04 10:03:13'),(2978,'a725e534aa0a70e712d79fa1859962ab','2025-02-04 10:03:13'),(2979,'05d7b0c6dae5c395661e56a18c6d84e3','2025-02-04 10:03:13'),(2980,'8a5bec404e8804253f17bb683f744cea','2025-02-04 10:03:13'),(2981,'85ce7df64ab00e5fe757b4e9c892be03','2025-02-04 10:03:13'),(2982,'bf9dc5d8284b34816db34eb7c295d405','2025-02-04 10:03:13'),(2983,'4a0fe6d351b9a112d714b3500251c1c6','2025-02-04 10:03:13'),(2984,'98205fd4aec41078639aca796efd281d','2025-02-04 10:03:14'),(2985,'eace8a64625c6f4f7dc2b33b0fa07551','2025-02-04 10:03:14'),(2986,'3cb077759c5725cc892018b59f35230d','2025-02-04 10:03:14'),(2987,'0ce618fa35bf1678314126b30065ffac','2025-02-04 10:03:14'),(2988,'f2ca27bca087e3a96cdb1b4ba472cf03','2025-02-04 10:03:14'),(2989,'459ab449e5914a8feeb40a003c5055f8','2025-02-04 10:03:14'),(2990,'ebd7dc9b043f00a4876f8c1ba3085269','2025-02-04 10:03:14'),(2991,'e322073f0f599f9dc13343cdd142735e','2025-02-04 10:03:14'),(2992,'22ed6fcd64b9c907993f34a468e71ed0','2025-02-04 10:03:14'),(2993,'418f23fc69142e81ec5ac94259d4a500','2025-02-04 10:03:14'),(2994,'322a976e335e2b598f130eac3b2ab1de','2025-02-04 10:03:14'),(2995,'94fa24582dbeec7d28e23a31cd52399c','2025-02-04 10:03:14'),(2996,'910c19d91eda7c0efcc95948cd5b6397','2025-02-04 10:03:14'),(2997,'306bc7505da56810d2e2aa440144214c','2025-02-04 10:03:14'),(2998,'01a3f68fee9732449f1b581a730fa5a8','2025-02-04 10:03:14'),(2999,'4dbd73bff807d4fa0f07a0ab86e38b10','2025-02-04 10:03:14'),(3000,'c26d8b1544733392a6c2e16c03a4ab3a','2025-02-04 10:03:14'),(3001,'9224cb27590a9b903d7767c4880fac6e','2025-02-04 10:03:14'),(3002,'e07891ba67b061077d3078b6c70217c3','2025-02-04 10:03:14'),(3003,'2688581e25573903acf5e1886485b7d0','2025-02-04 10:03:14'),(3004,'0fe8cd990f9152f74451604fc18c63ee','2025-02-04 10:03:14'),(3005,'114fbc213cd95aa887c4d494660e57a2','2025-02-04 10:03:14'),(3006,'8ea522b1aac8a64a07e4aa7a8eb37fce','2025-02-04 10:03:14'),(3007,'e84c3e674b3feea27ebf9d38d6cc94c6','2025-02-04 10:03:14'),(3008,'41c0661e17cf04bbd893adb3f2d8168f','2025-02-04 10:03:14'),(3009,'8f7e5484f7fd367f0f34c8003c937d25','2025-02-04 10:03:14'),(3010,'dfc02104b2d30bcaa6508852b56b1123','2025-02-04 10:03:14'),(3011,'e28775911350efb26f87d1acd062ccba','2025-02-04 10:03:14'),(3012,'30bcc87dcd43692eceaf385d34ce79d8','2025-02-04 10:03:15'),(3013,'383db84ab2dbbc013749c16026c36ffe','2025-02-04 10:03:15'),(3014,'b3e130ffa89a6c4f78330d915433c175','2025-02-04 10:03:15'),(3015,'8f2dcc1ef6b229a390aa73d2a9fa6889','2025-02-04 10:03:15'),(3016,'1fb1810ab1b2d88a7b04c10c1283ef9e','2025-02-04 10:03:15'),(3017,'3f9bfd489c0585f8102f0fad7c59d85a','2025-02-04 10:03:15'),(3018,'290f512f0c662692137c7d01d978514c','2025-02-04 10:03:15'),(3019,'fd440ce9196f57e04db61af4245e12d2','2025-02-04 10:03:15'),(3020,'45740f40befce61196c715c1c2c0b80c','2025-02-04 10:03:15'),(3021,'09cd41b996b5b9bd46d91b702427d11e','2025-02-04 10:03:15'),(3022,'2800171b4f69affb421662eaadc60e57','2025-02-04 10:03:15'),(3023,'6da1fa8c4f18aa21f7793f324f359c08','2025-02-04 10:03:15'),(3024,'84b8034d39433ca717a07803520c924c','2025-02-04 10:03:15'),(3025,'37e624c51dac1b45383dcbb8b7dac75d','2025-02-04 10:03:15'),(3026,'23b5f0bb89919c0b790536796cbf2789','2025-02-04 10:03:15'),(3027,'781834ef323722e9a6c5253ad40e2116','2025-02-04 10:03:15'),(3028,'ef909b54c7caffd379e7b4dabeeb199e','2025-02-04 10:03:15'),(3029,'709059f261662b7c522cbfe6c88f38be','2025-02-04 10:03:15'),(3030,'5cef3b27d6da0e08988db825a4781c6d','2025-02-04 10:03:15'),(3031,'1be254d78d0bcc92c0ce713987340667','2025-02-04 10:03:15'),(3032,'955ffff96fb413de3a4268aa0c651a2c','2025-02-04 10:03:15'),(3033,'b11635f40ab4be06193e6e76da90ef34','2025-02-04 10:03:15'),(3034,'f7e4e2770eb0c8057222db97f0fd81cc','2025-02-04 10:03:15'),(3035,'8624650f01483984c49718389d7ad7f9','2025-02-04 10:03:15'),(3036,'a420390f29d2bd80b291f60bb44b9b00','2025-02-04 10:03:15'),(3037,'332909e39eaebdec07f6c8a066de95fd','2025-02-04 10:03:15'),(3038,'562de413e9a0eedf292bcbc47a2e0841','2025-02-04 10:03:15'),(3039,'cd618010f5ccb8387361f4644eeb6b31','2025-02-04 10:03:15'),(3040,'d78ebe170c5d9396547cd70665018345','2025-02-04 10:03:15'),(3041,'30590d55fb75d2637b34e0b0f62160c6','2025-02-04 10:03:15'),(3042,'36dc511a28bf6c250a9d03763f265cf6','2025-02-04 10:03:15'),(3043,'5813056a15afc3b73d3c8e56b0c2efcb','2025-02-04 10:03:16'),(3044,'a9c35898dc1ba91848068f01efb120f1','2025-02-04 10:03:16'),(3045,'4d8a1f5e45c3eda05564b5467d74c465','2025-02-04 10:03:16'),(3046,'8a7aae25740dc9ae0072b23a15cec716','2025-02-04 10:03:16'),(3047,'c3fe42d50626a8fc332bc845a79b0765','2025-02-04 10:03:16'),(3048,'e2ff421969831a8798b3d1792d634af2','2025-02-04 10:03:16'),(3049,'6a1aeef980607a3f2adefd84dd8c81e9','2025-02-04 10:03:16'),(3050,'2229e13deb53429b2891f4fb2863483c','2025-02-04 10:03:16'),(3051,'b4817270f54e5f7acbcc0f3f8e2f6ad2','2025-02-04 10:03:16'),(3052,'41d701cffd07a3d1a1e6d4627f7d3c18','2025-02-04 10:03:16'),(3053,'f0077076a9a9c48391d178f9d1069074','2025-02-04 10:03:16'),(3054,'24007089b6128a898dadede921ee700f','2025-02-04 10:03:16'),(3055,'676d65843b696aad965ef96cf09659c0','2025-02-04 10:03:16'),(3056,'205b5d9f3c63b3ff462dd3b9999854ec','2025-02-04 10:03:16'),(3057,'29ccfba33095d0eb1d6e37cfc626c2ee','2025-02-04 10:03:16'),(3058,'a9624548d98e4eb64c00a656be1f0b2f','2025-02-04 10:03:16'),(3059,'117d23cdab849cb1fd3d35784899ca05','2025-02-04 10:03:16'),(3060,'50188c269b8292443d7032f48aabeb18','2025-02-04 10:03:16'),(3061,'b27508ed15b0e96080ba5528a42b968c','2025-02-04 10:03:16'),(3062,'213f70daa4dee52fc7ef1bd4fe461f0e','2025-02-04 10:03:16'),(3063,'182b0ef7ea6da6962047eed2f7b16580','2025-02-04 10:03:16'),(3064,'bdf9fe7b4f63e6abd909e9302fdbe426','2025-02-04 10:03:16'),(3065,'ae3ec0c9ed6576db82bb1b47a7cb54bd','2025-02-04 10:03:16'),(3066,'3d6f9f9dc48226e96a878bf7b16753c4','2025-02-04 10:03:16'),(3067,'fd468863729563e1b9c000aff0146b08','2025-02-04 10:03:16'),(3068,'e3416e6bd63af3b2ccf5c01cb13d108b','2025-02-04 10:03:16'),(3069,'01369aab483225c83a6cd1dcf9135296','2025-02-04 10:03:16'),(3070,'8248e97297058f7b3feb6de487b48b8a','2025-02-04 10:03:16'),(3071,'7f1e0c76ea5e9a23469f0bc8629f066d','2025-02-04 10:03:16'),(3072,'e5639fcc51779f170470cdbdbce8be13','2025-02-04 10:03:16'),(3073,'8d0eae530cb87ad5ae321c99ce1a5aec','2025-02-04 10:03:16'),(3074,'3ada92340b1c00417f27558c89d03d5f','2025-02-04 10:03:16'),(3075,'342636945ca7fde2d52cfa81b59c0aec','2025-02-04 10:03:16'),(3076,'f14cc4003a25bf7e23c2a61a141ff739','2025-02-04 10:03:17'),(3077,'d9d4e190c12b2f29d0444ca2fa730e21','2025-02-04 10:03:17'),(3078,'a65dd00b1c5c451d0156439a389418d6','2025-02-04 10:03:17'),(3079,'f8056f3d8513329481ede97ca0608f68','2025-02-04 10:03:17'),(3080,'098a21c9d8c4b62c47e83b8808773e9e','2025-02-04 10:03:17'),(3081,'44708eacdccaac7068c3d5190207ffb8','2025-02-04 10:03:17'),(3082,'ae63494727208bdc6484dd2f84b90258','2025-02-04 10:03:17'),(3083,'6467c4d783f218f3ed8a22bdc943707e','2025-02-04 10:03:17'),(3084,'95e15479cd05cfbfae675b25397a7fa7','2025-02-04 10:03:17'),(3085,'02ff3fda3b392a286669bd339dd0801a','2025-02-04 10:03:17'),(3086,'a884007cd2b5238ad7437894539dc48d','2025-02-04 10:03:17'),(3087,'d70cad7216a0bfd6de44a6c0643ea7b6','2025-02-04 10:03:17'),(3088,'753e6809e22964fa239ef465a3151ef1','2025-02-04 10:03:17'),(3089,'a46860c54c35dba024b89aeada08fc0d','2025-02-04 10:03:17'),(3090,'20fdf0eaa3f6d2e56f1e7f5e7e1e6655','2025-02-04 10:03:17'),(3091,'8a0bc9705c001da9baab45528310a19b','2025-02-04 10:03:17'),(3092,'08412cda98b93fd83598ff7602413aee','2025-02-04 10:03:17'),(3093,'b9e97b5e9e9d1d9a8ff297ccca2cc703','2025-02-04 10:03:17'),(3094,'d565045e1236deeacbbcbc21d298634b','2025-02-04 10:03:17'),(3095,'2183142594b0a15213871ccacf4b40c0','2025-02-04 10:03:17'),(3096,'d3b2689452b4eff10b951da5904935c3','2025-02-04 10:03:17'),(3097,'f13b54d6142e701e0adca1a38ec8340b','2025-02-04 10:03:17'),(3098,'e1e22f1cb8105d3f7118e2ff74307d74','2025-02-04 10:03:17'),(3099,'a9c1bc7979a7fce59bd60f6a14860c38','2025-02-04 10:03:17'),(3100,'a1b4efa706eee40de7313adcd7abad3a','2025-02-04 10:03:17'),(3101,'7d58d0eb0f0f68199dca27cfea002db4','2025-02-04 10:03:17'),(3102,'3de2cee9e1abb6b7f177072e3e8963d7','2025-02-04 10:03:17'),(3103,'64b3b82d62a9f82ff0470e69641891a5','2025-02-04 10:03:17'),(3104,'5a48fcb42d5bb3e9a59ff3a93905cfcb','2025-02-04 10:03:17'),(3105,'d8f7027d4993a0927cead89447ae37fd','2025-02-04 10:03:17'),(3106,'404689644bc215390a769d7091d56339','2025-02-04 10:03:17'),(3107,'39155e75cde4ca5b0d2f57e5532c388a','2025-02-04 10:03:17'),(3108,'8f863e5f4608ff1999b9e275589dc164','2025-02-04 10:03:17'),(3109,'e9f73f000649c0e7b6cd546286d2fb8a','2025-02-04 10:03:17'),(3110,'a776bab77378db38ca48bddbcea6ce8f','2025-02-04 10:03:17'),(3111,'0e68dd524e8bba0ac03236909d487299','2025-02-04 10:03:18'),(3112,'cfc1f2bad8ee3d63ce34d2acf6a17083','2025-02-04 10:03:18'),(3113,'d5c702009fb3f818d70e6b841cfe059f','2025-02-04 10:03:18'),(3114,'3e4d91550573f475d1ee32b03ba55461','2025-02-04 10:03:18'),(3115,'8ef9d37a4c8d418735afaa95fb93ed79','2025-02-04 10:03:18'),(3116,'1ea1caba80519302ed8e36dc9946090e','2025-02-04 10:03:18'),(3117,'6efbd13c6851de4f657780a8040fae8a','2025-02-04 10:03:18'),(3118,'11653dfad8577d797f706d8c185c9d9c','2025-02-04 10:03:18'),(3119,'1bd9947b3ee62320c0771a58fe58fb63','2025-02-04 10:03:18'),(3120,'f71da4a85863f8a2d05c08061a1fb25a','2025-02-04 10:03:18'),(3121,'71965984ddb8eab2ea3c173639abf919','2025-02-04 10:03:18'),(3122,'6071f3d3aa5f566ee4840bd7bbda2aa5','2025-02-04 10:03:18'),(3123,'0d3aed98052878e7a7051e7bf57ad78e','2025-02-04 10:03:18'),(3124,'6609e911d955c27550571a37e6a00512','2025-02-04 10:03:18'),(3125,'850560c645951ccbe30184a586088eb4','2025-02-04 10:03:18'),(3126,'3936e1d77831b983da7be95a0b8a026b','2025-02-04 10:03:18'),(3127,'c76c950c4364f7640a92cbc811a0f01c','2025-02-04 10:03:18'),(3128,'0d62b1ccbc4bb485584c2b8d0ea9e955','2025-02-04 10:03:18'),(3129,'2a753a21aedff2576364522ade690601','2025-02-04 10:03:18'),(3130,'b2c182849e5464f9c73bcd1ce141f015','2025-02-04 10:03:18'),(3131,'cd9a9ae20e68b7840431976550030173','2025-02-04 10:03:18'),(3132,'9956873bc0325885f4b790111c69fc12','2025-02-04 10:03:18'),(3133,'117907f5b0107e81b3725fb189e9f992','2025-02-04 10:03:18'),(3134,'9651730934e398aec39d8a5ad781addf','2025-02-04 10:03:18'),(3135,'9039637cef6311e89bee65d4ea217fae','2025-02-04 10:03:18'),(3136,'23c1fa03cd6ae1b772900af0c621ac33','2025-02-04 10:03:18'),(3137,'d1352a5deebfe8e0b44905bc7f422ea9','2025-02-04 10:03:18'),(3138,'afddd3c55e2e3ac4648ea18185f1d4b2','2025-02-04 10:03:18'),(3139,'65518953ea6a0647eba7b834accb3b11','2025-02-04 10:03:18'),(3140,'1bd3419c846ffce1402abd6638f13abf','2025-02-04 10:03:18'),(3141,'63ee60b061684079a245a5e3b1b59491','2025-02-04 10:03:18'),(3142,'2c81ff9754e073b4c7024a7bf7d39d9b','2025-02-04 10:03:18'),(3143,'4d050f27299f844a4d5c35b991c2b91b','2025-02-04 10:03:18'),(3144,'2c5cd29339bfb52c336e9f6ce1166dbc','2025-02-04 10:03:18'),(3145,'211ccbf72f088b3e3ade5de249b73f83','2025-02-04 10:03:18'),(3146,'87650d227c1aae15025f0c6f421f3ae6','2025-02-04 10:03:18'),(3147,'6f464ccacb53a0f6bae57bf3eb5eb2a0','2025-02-04 10:03:18'),(3148,'25aa4817542a3829f345298d7117b936','2025-02-04 10:03:18'),(3149,'a0b4a444b8b11fb06aa4374fa8afced3','2025-02-04 10:03:19'),(3150,'f947b295de46168dac00dde590440d66','2025-02-04 10:03:19'),(3151,'dca4ff84c104f0563deec290bceedb91','2025-02-04 10:03:19'),(3152,'c7af7e2d5bed9829ce93bc93c3e138a7','2025-02-04 10:03:19'),(3153,'05158f999626a72df05b4f1e2dfd3419','2025-02-04 10:03:19'),(3154,'e74b52d783d3a9172d73e3c912cf3ceb','2025-02-04 10:03:19'),(3155,'79c233c644d44abcf06435f284246bd2','2025-02-04 10:03:19'),(3156,'67b29094191af599fcf91b24e6e1885d','2025-02-04 10:03:19'),(3157,'81000b2bb3b4b6d6d48248460a8fa898','2025-02-04 10:03:19'),(3158,'df3b4a634812b30eaefa19acf7832dae','2025-02-04 10:03:19'),(3159,'7ffc7acc528d763d93e77933d0dedf96','2025-02-04 10:03:19'),(3160,'5812a30b612d5b63262b6ffbd30437e0','2025-02-04 10:03:19'),(3161,'71151367743bcfe8ef8dfc989616b011','2025-02-04 10:03:19'),(3162,'8954dc08ebd565f75a4359d902502af6','2025-02-04 10:03:19'),(3163,'db4f766b13b41f461b9e94f664a2e6bd','2025-02-04 10:03:19'),(3164,'7cde0224eae2306173e2e74d81f0f145','2025-02-04 10:03:19'),(3165,'1c01317240738637e69b0d9fd24cbc1d','2025-02-04 10:03:19'),(3166,'660afb061f33cd2682eeeca2702abc6e','2025-02-04 10:03:19'),(3167,'d50b29d48b438ae581a887c33943f2c7','2025-02-04 10:03:19'),(3168,'c8ad9786a0efeacbbc41b6588788b5db','2025-02-04 10:03:19'),(3169,'534783330f0e57c23de183ed4279d005','2025-02-04 10:03:19'),(3170,'d2325c322b72b944be62c3128d6aa46a','2025-02-04 10:03:19'),(3171,'e965c858fe4091e31cd555076ff68400','2025-02-04 10:03:19'),(3172,'3b3500e4f68c1f988a728ddbc3718b9a','2025-02-04 10:03:19'),(3173,'a83d0fe8a454fc3f119c988585de69de','2025-02-04 10:03:19'),(3174,'f8e03684e2aff1ebdfe57e6b3fdcacd8','2025-02-04 10:03:19'),(3175,'aba5236f3ad975dc78f6598683bca58b','2025-02-04 10:03:19'),(3176,'3f5c306ab78de0804655dfd225ed886e','2025-02-04 10:03:19'),(3177,'24728c6e9c5b3ea281177bfcb3ee9529','2025-02-04 10:03:19'),(3178,'5fee600cb1155c480eed352fef07bf74','2025-02-04 10:03:19'),(3179,'ec5ecfe321084c685fa2aa2bb8f8f060','2025-02-04 10:03:19'),(3180,'d11608fb0be44c8ccaf8e6f1ef42bcd5','2025-02-04 10:03:19'),(3181,'a167f0b1085b36b228a243e59c297725','2025-02-04 10:03:19'),(3182,'c60f989be66e3ca452fdbd7d22a5e6eb','2025-02-04 10:03:19'),(3183,'3f104b2027426a00e60484d1058099d6','2025-02-04 10:03:19'),(3184,'9a38fa7feff9fd9240f741903320fa3c','2025-02-04 10:03:20'),(3185,'27d75678a0a67c5a2c1c1c01bbbfdede','2025-02-04 10:03:20'),(3186,'b832c8cdca083ac4a1b2fb92dd46c645','2025-02-04 10:03:20'),(3187,'5be13bf28e5ae150de248698515b2d5d','2025-02-04 10:03:20'),(3188,'5cc6621395c69ac123354712eb678677','2025-02-04 10:03:20'),(3189,'6a7650ce148c1c6ec8e0716c9f2db421','2025-02-04 10:03:20'),(3190,'09e5cebf0434a12fbacab9ec4aa56eb4','2025-02-04 10:03:20'),(3191,'a813784c8efd6814af5fc156fc75bf7f','2025-02-04 10:03:20'),(3192,'9bffe3149cb357e263f8842c436ba366','2025-02-04 10:03:20'),(3193,'892e74d6aafb984a6b5fb497d548b0ac','2025-02-04 10:03:20'),(3194,'1266eae537f1dbbef2c18ba1f6a6df28','2025-02-04 10:03:20'),(3195,'0792ed359a7095192d2c10731e3e8346','2025-02-04 10:03:20'),(3196,'ffabbdefbb843764074f367dc014b0c4','2025-02-04 10:03:20'),(3197,'c29e0fd2e9ffe73bbce5fe5629d7f074','2025-02-04 10:03:20'),(3198,'d1cf16da410462d8edba0ba4cf11173d','2025-02-04 10:03:20'),(3199,'d98e6bd7b1ca1ed417cdd3e8f741e261','2025-02-04 10:03:20'),(3200,'265a9452e2a7be61cf0c6c32027cdab8','2025-02-04 10:03:20'),(3201,'cae779a6676d7c52f2d06e5e0425c7c1','2025-02-04 10:03:20'),(3202,'241ac50ece7af71b4958be18241250cc','2025-02-04 10:03:20'),(3203,'90713ec2d633d42e5b435fb667b9fc04','2025-02-04 10:03:20'),(3204,'a45b8d64b86f4fd749d1d59ff60a5df5','2025-02-04 10:03:20'),(3205,'966c34078ab2b7bd245072eb173e62a3','2025-02-04 10:03:20'),(3206,'57ba155cd6219e8664534b0c8b26248a','2025-02-04 10:03:20'),(3207,'09829ebdc04e3ecbab3475adcbb7073e','2025-02-04 10:03:20'),(3208,'dcdc8306711a287229d7e944bf30bdf4','2025-02-04 10:03:20'),(3209,'bef49d0a6d105b001752327d19013b65','2025-02-04 10:03:20'),(3210,'cf7171d9f7e75a5efd7820f34d466503','2025-02-04 10:03:20'),(3211,'600a0160e45650003d425a2df84d84cb','2025-02-04 10:03:20'),(3212,'795bd8bfce8d5ead2eb92b998137391c','2025-02-04 10:03:20'),(3213,'060d9043f9b03873371776c9c59a1e99','2025-02-04 10:03:20'),(3214,'2928cbe91f485b21f08e9f7ae2864e96','2025-02-04 10:03:20'),(3215,'43ad49a9ea04645edd705b88db156aea','2025-02-04 10:03:20'),(3216,'660a17b98aedcf53b7a52340a27b669f','2025-02-04 10:03:20'),(3217,'531c2f431e98d087c94591b6424204f1','2025-02-04 10:03:20'),(3218,'45633d6c6b0f709ba39931e259d79fed','2025-02-04 10:03:20'),(3219,'c39d3231d61e618427a1d5be42f50123','2025-02-04 10:03:20'),(3220,'201357b7677bf292486af75b34102229','2025-02-04 10:03:20'),(3221,'5f263907d59714c82840e55a8116e75d','2025-02-04 10:03:20'),(3222,'a5549941e6becd79fe6e743e8a02e081','2025-02-04 10:03:20'),(3223,'1fd1edb9bffef358d7cf2e2db36a8b9d','2025-02-04 10:03:21'),(3224,'025dc5831febb49f36a6accf6242aadc','2025-02-04 10:03:21'),(3225,'67cc5019c04798e3c70b4ffb82d5d6f1','2025-02-04 10:03:21'),(3226,'b9a632ada6502375e4eebbedc02c35f4','2025-02-04 10:03:21'),(3227,'719db56c9327cf218792a415d0445e4c','2025-02-04 10:03:21'),(3228,'e80505c1c24e359e6afdf4b10e0dd680','2025-02-04 10:03:21'),(3229,'1dcb9128a20d783f51ba66242fa27dca','2025-02-04 10:03:21'),(3230,'75fe70131a73a381b176b81211ffbce8','2025-02-04 10:03:21'),(3231,'1164e0e032076f727e085052f903defc','2025-02-04 10:03:21'),(3232,'b88492c5c1257cbf0beffc6327e8f3ed','2025-02-04 10:03:21'),(3233,'4e143f1e6a7a03a6d4abf16c0ce20c66','2025-02-04 10:03:21'),(3234,'4dd85039aead8f518ae6576ca7b8cc4c','2025-02-04 10:03:21'),(3235,'8d124fd3470386178084e59e48987a3f','2025-02-04 10:03:21'),(3236,'3d2ba128db638b5febc9dc8f1fb686ed','2025-02-04 10:03:21'),(3237,'1bc9ccb60ec842863cde23c28162ce3e','2025-02-04 10:03:21'),(3238,'201ee7ef40ea9b27af631d86a11ceea2','2025-02-04 10:03:21'),(3239,'e87d557b3ac45b511b7e5729e4d7d0f0','2025-02-04 10:03:21'),(3240,'9b0b162deb0017fb0eaa5c815b3b8174','2025-02-04 10:03:21'),(3241,'321011aa9eb1e335c6936df8882b7a95','2025-02-04 10:03:21'),(3242,'d686a663174457a292c77a2f2fb7d807','2025-02-04 10:03:21'),(3243,'b4b89bd75e6d01865ce613258df09f1a','2025-02-04 10:03:21'),(3244,'af6434a891db5d5fb036711da65c464a','2025-02-04 10:03:21'),(3245,'60021e4aba68bf8e7ef78bd1c0dce7d1','2025-02-04 10:03:21'),(3246,'3c04b05b327bc5c31f8888a73e937891','2025-02-04 10:03:21'),(3247,'a504275cc8857a2ed933afe368dc2a7f','2025-02-04 10:03:21'),(3248,'841fc92c5c1c42d53607491bdc60f9a2','2025-02-04 10:03:21'),(3249,'f2f9d7ce6c6981794be6e3555b105bea','2025-02-04 10:03:21'),(3250,'b7e845275cdad97ee1a4224c7b601f1b','2025-02-04 10:03:21'),(3251,'fc7208262fc0c5cf43bfc88f3ba087c6','2025-02-04 10:03:21'),(3252,'0cb149ce1f84f0bbabcb94b63212154d','2025-02-04 10:03:21'),(3253,'51e4e6036babb1b70a2e6c60905e5aef','2025-02-04 10:03:21'),(3254,'a4220b49fef99c843139a8b34227705d','2025-02-04 10:03:21'),(3255,'f01213c29fb84c61e7e9188a5152f884','2025-02-04 10:03:21'),(3256,'c92c45e4210cd59863e135d486a8c4a1','2025-02-04 10:03:21'),(3257,'40b8b420e809a5a9e52a3ef9d201a0d9','2025-02-04 10:03:21'),(3258,'9bd7fb4175f52371f106012872d7a8bf','2025-02-04 10:03:21'),(3259,'74bec9b525702682e9b0233adba50f3e','2025-02-04 10:03:21'),(3260,'6d988b828fae87d9a88e4fb3cab26713','2025-02-04 10:03:21'),(3261,'009d97fc3c779690245f2495c35c7bff','2025-02-04 10:03:22'),(3262,'7375b05d2c796c93cf8799354ab3c0f9','2025-02-04 10:03:22'),(3263,'47326002fe85d8888e51aa3025259498','2025-02-04 10:03:22'),(3264,'0ef64c02d96a1e0d4083e9cb571d0b78','2025-02-04 10:03:22'),(3265,'0873e48ac3da663907e9a86d15674ca3','2025-02-04 10:03:22'),(3266,'12c4c65494407c2046fba5111c906191','2025-02-04 10:03:22'),(3267,'e5ae29bf4e4bd43d9d2c027894454830','2025-02-04 10:03:22'),(3268,'3182750064bd5f8637aaa6247f3abfea','2025-02-04 10:03:22'),(3269,'3c7f9fdf1d4f7ad968e00d932203788c','2025-02-04 10:03:22'),(3270,'ef434d2ed72c763576143ca50510c498','2025-02-04 10:03:22'),(3271,'0258e142ed852b89cbbc476325cefff1','2025-02-04 10:03:22'),(3272,'196b61f893a78a2731bb7d5a70ff584f','2025-02-04 10:03:22'),(3273,'12bb275fd4069fe1724a616aed4b5405','2025-02-04 10:03:22'),(3274,'7f5dbd42e195a038c20bac67466a11c9','2025-02-04 10:03:22'),(3275,'a1e21271805127ac49179d16bfc41523','2025-02-04 10:03:22'),(3276,'ab17524f5e8978d88df979cff85c7e77','2025-02-04 10:03:22'),(3277,'4f036cb27ded3d4073e71df1e12c7831','2025-02-04 10:03:22'),(3278,'46d060175b3470a88b30606e27343777','2025-02-04 10:03:22'),(3279,'59ba79b7021cbd041abcf137763bdb6a','2025-02-04 10:03:22'),(3280,'31e6ae7077714c1979b366e941b60808','2025-02-04 10:03:22'),(3281,'4f6c1f9755ec0bbc59983332932c880f','2025-02-04 10:03:22'),(3282,'2efeb1d1999ea88cab45ce3b6ae9fae9','2025-02-04 10:03:22'),(3283,'1c688c8e343a55f0222af47845a39ee1','2025-02-04 10:03:22'),(3284,'40c072951984ec7dfb84cc30c1677f02','2025-02-04 10:03:22'),(3285,'628dbe15fd755e01d98f37b852394db9','2025-02-04 10:03:22'),(3286,'f9cc142e5ce3eb2f6d23c5717e03609c','2025-02-04 10:03:22'),(3287,'0ed9a2521c15b9273d4e6707ff4000ff','2025-02-04 10:03:22'),(3288,'f3c1a2fd427ebbbd871fabb7de5cec03','2025-02-04 10:03:22'),(3289,'c77cbeee5fca26ceabbd9a7c4a40e347','2025-02-04 10:03:22'),(3290,'94c006db5faed6a974ec675469b77d48','2025-02-04 10:03:22'),(3291,'e49d6782d40bccde7a91de241fda750a','2025-02-04 10:03:22'),(3292,'d12fd3d9159bee29ab4ae74381342c89','2025-02-04 10:03:22'),(3293,'5cdc5f84ec048b1c251f40eea840c732','2025-02-04 10:03:22'),(3294,'7ca4e05c74a380a599d74a0d2e9bbafb','2025-02-04 10:03:22'),(3295,'f97d5bcd2467baaff543177751a1a8db','2025-02-04 10:03:22'),(3296,'56afc99ef9e73854621b8554056c5ae6','2025-02-04 10:03:22'),(3297,'4ee3354d49fbfdcd489e86c4e529a3cc','2025-02-04 10:03:23'),(3298,'6a0487d899a89c005175a884dc29dce3','2025-02-04 10:03:23'),(3299,'b5d909e499af1c009a3713427ff041a0','2025-02-04 10:03:23'),(3300,'f6a44964c0409a28ed0dbb66baee1665','2025-02-04 10:03:23'),(3301,'939c284dc0a628aa15b630ad868c360a','2025-02-04 10:03:23'),(3302,'7881ff2cdcc80fd583f6b17a26ae48b8','2025-02-04 10:03:23'),(3303,'b892d9138c2dd9ac2c4dc85cd24d5ad5','2025-02-04 10:03:23'),(3304,'727e0585b5a884c338ad1a7d8656b864','2025-02-04 10:03:23'),(3305,'95f8b28984c8deb76733b70c91df363b','2025-02-04 10:03:23'),(3306,'acba0edb742af9ca0e3ef3153f6aeb77','2025-02-04 10:03:23'),(3307,'5fdcccb8b8fcb79870fee20ce322bf94','2025-02-04 10:03:23'),(3308,'85d82f1b21c5c50aeb7d91ee9d1ea290','2025-02-04 10:03:23'),(3309,'c7227e4db0b587d305f9b9c58cb769b6','2025-02-04 10:03:23'),(3310,'502a7fa040e7a7a20f0b7819ea042b8a','2025-02-04 10:03:23'),(3311,'d8c324809ae9660b8a1f82e33ea72e26','2025-02-04 10:03:23'),(3312,'b3ac5f0107ba54a71891c3df8d6e5a1e','2025-02-04 10:03:23'),(3313,'6889118010f276586387cec9dddb2a92','2025-02-04 10:03:23'),(3314,'adffccca0550c4abe885f9b3a2dcf90a','2025-02-04 10:03:23'),(3315,'f0d47148da98cf0d99f00a819139a229','2025-02-04 10:03:23'),(3316,'00d99bb22f14ba600885c9d78c4f228a','2025-02-04 10:03:23'),(3317,'9cc188120749991cfd41cb6eadec83bc','2025-02-04 10:03:23'),(3318,'4b70d209b0b068e12b3e8a71699290da','2025-02-04 10:03:23'),(3319,'d323b614c55b5ce44669a00d37c71ed2','2025-02-04 10:03:23'),(3320,'421913a6db942f4b5d6fc501bfd75500','2025-02-04 10:03:23'),(3321,'94031091a224888f0c69745a9b51f04e','2025-02-04 10:03:23'),(3322,'2dec1e2914f0dae1e91261afaa1e340c','2025-02-04 10:03:23'),(3323,'3184cd86742906ca9b6c152eadf09b36','2025-02-04 10:03:23'),(3324,'9040b23dee8de2acb95c71c107df23fe','2025-02-04 10:03:23'),(3325,'56365b6cd801f61b71ac62fd3d08bf36','2025-02-04 10:03:23'),(3326,'65500969d7ede1a64f29491a3f654dd0','2025-02-04 10:03:23'),(3327,'f80da00e2db54c18dc774bb837b76ffc','2025-02-04 10:03:23'),(3328,'b9431b2289700eff971e2712469e10a3','2025-02-04 10:03:23'),(3329,'44b5570733209e91b3ecfaf4632929e6','2025-02-04 10:03:23'),(3330,'b0c630d79f8f1ba8e5200137132634be','2025-02-04 10:03:23'),(3331,'8332fff01c105778f9e3126996628a27','2025-02-04 10:03:23'),(3332,'f0e14b0600b9328937c8fe88ae9fa951','2025-02-04 10:03:23'),(3333,'1ecc354608f6d40aed273c8736757e57','2025-02-04 10:03:23'),(3334,'b2ee85c08b75559b6a2f63fb27701656','2025-02-04 10:03:23'),(3335,'60471eaa8f8d69d741a8f20b0fa6d8d2','2025-02-04 10:03:23'),(3336,'aa5210847ea5be9844236eb874fc7333','2025-02-04 10:03:23'),(3337,'7a4ef944106fb40eba9f1905e2861044','2025-02-04 10:03:24'),(3338,'5c81648fbbc243a2492aa0e1a9f07ef7','2025-02-04 10:03:24'),(3339,'c128d4362a73f4f86cb0892ff9a33e38','2025-02-04 10:03:24'),(3340,'e7748137d6df6a6b2cc94cdbf90453e9','2025-02-04 10:03:24'),(3341,'e7df3849f52d7582210a96caf831c4fa','2025-02-04 10:03:24'),(3342,'559189cc2fb6cc675905bab4c851adb7','2025-02-04 10:03:24'),(3343,'2e718e7ea887cb540e8d3c9d9642e4ef','2025-02-04 10:03:24'),(3344,'9418c3de599bc508f8b21dc56eece471','2025-02-04 10:03:24'),(3345,'e16f752124c9c58efd6d6bee137633fb','2025-02-04 10:03:24'),(3346,'ddf11ffdeefd8dde58b46f0cd11e7f2a','2025-02-04 10:03:24'),(3347,'30672f740f47ed84ef8912713be072bc','2025-02-04 10:03:24'),(3348,'b8d6e8e01f334dd3bc003e7b8bdba0d6','2025-02-04 10:03:24'),(3349,'3fd0339f7b93675e93c4055f1663088d','2025-02-04 10:03:24'),(3350,'d36efb496ba73c8848c0f0859c756d5d','2025-02-04 10:03:24'),(3351,'b69a6e022db17b38d6604efdc73cf792','2025-02-04 10:03:24'),(3352,'4f7a1eccd35ce39b3463a132f484b950','2025-02-04 10:03:24'),(3353,'f5fe4e63e0ecc315ca27c08f26449247','2025-02-04 10:03:24'),(3354,'6e9eff5c21af199016629106abe8b136','2025-02-04 10:03:24'),(3355,'75bd6b5d322e66c4b6db994a45c836a7','2025-02-04 10:03:24'),(3356,'8781d66ee46ee1a022563734eb650494','2025-02-04 10:03:24'),(3357,'66b44e45a4a1c8794918c7144f0d5fa2','2025-02-04 10:03:24'),(3358,'60f87a7ba332793d51d63298c31adb10','2025-02-04 10:03:24'),(3359,'e3472c9f0e525fe5595f6fb0f46cfa60','2025-02-04 10:03:24'),(3360,'754834ebf163a7f8b7eaf8d3217e89f0','2025-02-04 10:03:24'),(3361,'e4e880a11d25b4fa764516c15cc4b9db','2025-02-04 10:03:24'),(3362,'d03f5d36d8d44f34ac9b0b9d09139b6b','2025-02-04 10:03:24'),(3363,'9dcfcc76728e7be2308f08a5dd5e828e','2025-02-04 10:03:24'),(3364,'75c58a1179c01f6ac6c16bebc764255a','2025-02-04 10:03:24'),(3365,'be6743334fb8cd4076947456b6bdd1e1','2025-02-04 10:03:24'),(3366,'810be860cbffc655cf4df986c10ce80f','2025-02-04 10:03:24'),(3367,'c3bf506065bff64b5353d9163e79c039','2025-02-04 10:03:24'),(3368,'d5e405e8671474419afa24b23d708ca5','2025-02-04 10:03:24'),(3369,'f83602f5962a76bc2637d50f076b937d','2025-02-04 10:03:24'),(3370,'ee6a2110a6829a18f2fa777abce7676b','2025-02-04 10:03:24'),(3371,'28b753f45b71584eaafc3ea4aec0d604','2025-02-04 10:03:24'),(3372,'ee79929bdd33499025a0012e167868fb','2025-02-04 10:03:24'),(3373,'eb2d654647a6322d3080bfee0667d972','2025-02-04 10:03:25'),(3374,'be95cdf31dc9a00a913faa06ee6952b5','2025-02-04 10:03:25'),(3375,'e8ef6ea883acb21993fc7804303c8bb2','2025-02-04 10:03:25'),(3376,'eba6995ab465400c4643466d11469f51','2025-02-04 10:03:25'),(3377,'bd082a970177971f240a33e0ac1e3556','2025-02-04 10:03:25'),(3378,'84fe0f6d9f7ca815e5e43afcad1ff154','2025-02-04 10:03:25'),(3379,'ed0dd2ed61a4e99a3aa8cac0f024bd18','2025-02-04 10:03:25'),(3380,'a620bc8fe2838b9f523226cf914a61bd','2025-02-04 10:03:25'),(3381,'7d8c0af9b7915adc0cd2a4c347a92b0b','2025-02-04 10:03:25'),(3382,'2fb4450fbc59247ff05363c71e11f8e5','2025-02-04 10:03:25'),(3383,'560983f7fc36c910028bb3f3e33bf030','2025-02-04 10:03:25'),(3384,'6d1e44cfe792169b74d2025005e61e47','2025-02-04 10:03:25'),(3385,'4cf38007babe97e2b5241b9039f3ecd7','2025-02-04 10:03:25'),(3386,'18a4d82960c5a418fe2180a72c18a243','2025-02-04 10:03:25'),(3387,'927acf0c885ba17046e7039488f6c4cb','2025-02-04 10:03:25'),(3388,'8448892e0d8bfa64fc9e522cb0415554','2025-02-04 10:03:25'),(3389,'d142642bf16a6be36ac4ee5cb19933f6','2025-02-04 10:03:25'),(3390,'7cd9e7bee4e2b1ff5ee0e09043b69495','2025-02-04 10:03:25'),(3391,'fc6e901e6dc3fee80be18097dd056e4b','2025-02-04 10:03:25'),(3392,'d78d1603b69d39048456086399593f93','2025-02-04 10:03:25'),(3393,'f665bede3eafca969fbf70dc5d8cced6','2025-02-04 10:03:25'),(3394,'e0d644b5f8deadd579ac1f059f396c4c','2025-02-04 10:03:25'),(3395,'938343b2b46b95a5723b1208f5af199e','2025-02-04 10:03:25'),(3396,'3ddc1974f2d81b0c393572bcfe25d7ca','2025-02-04 10:03:25'),(3397,'47059472024805edb17f064e4c1fe698','2025-02-04 10:03:25'),(3398,'f288a760786efcd586dc14517dadb944','2025-02-04 10:03:25'),(3399,'87fde84452df03f84b81811b48bdf8f8','2025-02-04 10:03:25'),(3400,'27ae4bf97803d1a80b292e338cc8c827','2025-02-04 10:03:25'),(3401,'d6f1f459c0682f48a5b3a7832b609e1b','2025-02-04 10:03:25'),(3402,'fab84049ac94cd81bc53d85b3200c48e','2025-02-04 10:03:25'),(3403,'d3a48f260fc75a5cf0106711f265801e','2025-02-04 10:03:25'),(3404,'d505ccddd5983932422090a3c5878836','2025-02-04 10:03:25'),(3405,'762dcfcc6c453170e58a47d7a140772f','2025-02-04 10:03:25'),(3406,'eff23601aa27bd01920cd48b3d8b662e','2025-02-04 10:03:25'),(3407,'9e2c06b501a687e2a0d4e005ca76bfe5','2025-02-04 10:03:25'),(3408,'39981dfa60d177759a8f0f669e4427be','2025-02-04 10:03:26'),(3409,'4aee61eeee707ac5683e2caf48f0d3f9','2025-02-04 10:03:26'),(3410,'bb36fa4dd64790681db45a2f48a50b7d','2025-02-04 10:03:26'),(3411,'b955a7ab9f515dd4f92d701247371aba','2025-02-04 10:03:26'),(3412,'d1e82d4c36827dda6ee1c3e228b7411d','2025-02-04 10:03:26'),(3413,'9b876b9b504a1cd103e8b4c25a066720','2025-02-04 10:03:26'),(3414,'30569a1fd65ea6251468c7a1dabae478','2025-02-04 10:03:26'),(3415,'c070236fe28f8f3757354e31ca125f5a','2025-02-04 10:03:26'),(3416,'f2f823ecc87bf64095c1d775e5112a66','2025-02-04 10:03:26'),(3417,'3a1227c6a3171883baac159bd8898179','2025-02-04 10:03:26'),(3418,'ec080cc9dcaca57a3963dfa5a1963072','2025-02-04 10:03:26'),(3419,'9e56b1bfc1959a0844f516a6291a01cd','2025-02-04 10:03:26'),(3420,'faa826736db3b5efb89082da8cd548dd','2025-02-04 10:03:26'),(3421,'c80a7d2071e5d9d8e412493b12723ee2','2025-02-04 10:03:26'),(3422,'40635d36c69b268d075a29155caed357','2025-02-04 10:03:26'),(3423,'4adaae7997bd1c82a6b5a50b25c97aad','2025-02-04 10:03:26'),(3424,'546106b6e2ed332618f59b347dc2a68c','2025-02-04 10:03:26'),(3425,'312f9d3c963f3b5a78a1d530ccf6aeb0','2025-02-04 10:03:26'),(3426,'45a9af26f03e34abf264d092996aa48c','2025-02-04 10:03:26'),(3427,'a7e93f69ee887ea92ad3f4acdd2b79c5','2025-02-04 10:03:26'),(3428,'5e5be4e6cf7a124815a5c8ab9db614d8','2025-02-04 10:03:26'),(3429,'738546330e1c10b6f4a43325e4fc925b','2025-02-04 10:03:26'),(3430,'dbcb22f5775c436ec2bfbde57ccaa7ca','2025-02-04 10:03:26'),(3431,'eb048cb8d5996b14c93388461aaccdd3','2025-02-04 10:03:26'),(3432,'b589d29c09bf9a4f87464204dde95c53','2025-02-04 10:03:26'),(3433,'98ec341e26692eaffdad9d413992bf3f','2025-02-04 10:03:26'),(3434,'5c83d0a7bc156eadd3aa9affe3a69e4b','2025-02-04 10:03:26'),(3435,'8b9e67b91fd53d07b402da99b36a404b','2025-02-04 10:03:26'),(3436,'41500359c38d4da289a020ff90689ae2','2025-02-04 10:03:26'),(3437,'4336344fb4a70ffdd6441a1a75be02aa','2025-02-04 10:03:26'),(3438,'0b612d237542faec1232c891e8ac2647','2025-02-04 10:03:26'),(3439,'a5e4d6745650f8f98eb177a7c75de10b','2025-02-04 10:03:26'),(3440,'b1ab7fe88a91e1deb9d3282f9adb68e4','2025-02-04 10:03:26'),(3441,'781b9ff8020ce5953b66c88a23edaf8a','2025-02-04 10:03:26'),(3442,'8954d024b8dcf87c085486a8c19dcbeb','2025-02-04 10:03:26'),(3443,'a360311c95ad02a545f1e65ee18d9d24','2025-02-04 10:03:26'),(3444,'3307bbc72a022ac3b9d5399fa0f68fa1','2025-02-04 10:03:27'),(3445,'6401178e2a76c74176d00e14f14fc569','2025-02-04 10:03:27'),(3446,'e673800648a1f50523055f2ce4ad0dbd','2025-02-04 10:03:27'),(3447,'1ff5c4a736c68cf539dc3edda6dec26b','2025-02-04 10:03:27'),(3448,'0fd2a9bc975d9747a0ab2a7979695c0e','2025-02-04 10:03:27'),(3449,'82ddcf79cbaf3f30c0bfe636da35f525','2025-02-04 10:03:27'),(3450,'07fe7ce1961d8edfaa13edf08205aa6c','2025-02-04 10:03:27'),(3451,'7fee7776dd78593c1b780ab9f1ca8bac','2025-02-04 10:03:27'),(3452,'08f1ce3ad8a14e2c6615592f63d601dc','2025-02-04 10:03:27'),(3453,'e0a6d7f1ea6e88117c19ed14e3ae97b8','2025-02-04 10:03:27'),(3454,'fdf8ac5018f9c84d4bb6a006d3418c30','2025-02-04 10:03:27'),(3455,'550caaf73e86296f2bc2d3018f33bb15','2025-02-04 10:03:27'),(3456,'d06e10cf8568b30127c3d1ad11f983e0','2025-02-04 10:03:27'),(3457,'48b6737eb84f937f2a3b0c378737b259','2025-02-04 10:03:27'),(3458,'ab383a60dde8c5e98908b3c36260a745','2025-02-04 10:03:27'),(3459,'db595bcf838d661f39542c32bf7b4f06','2025-02-04 10:03:27'),(3460,'83515b9d09130c6d1d34fe4863131680','2025-02-04 10:03:27'),(3461,'ca5cbbb038e9478ced0b2d7fc9191d64','2025-02-04 10:03:27'),(3462,'1e0ab2c25772ae2a3b7596aa699648f5','2025-02-04 10:03:27'),(3463,'3cc886fc6d935fe72566d8ef1d02efaa','2025-02-04 10:03:27'),(3464,'7b0f27e6cd7bf6d0f34a938265f16a4c','2025-02-04 10:03:27'),(3465,'96bc562d470b57a97e8b2655f6aae208','2025-02-04 10:03:27'),(3466,'a2528aa7e259f32bddb7b9198879e5d7','2025-02-04 10:03:27'),(3467,'dd92db7ddeb0688005d5f9a37934fa5a','2025-02-04 10:03:27'),(3468,'03304bb641a83d077480b53964ca3233','2025-02-04 10:03:27'),(3469,'9c30a20a500fd1ee56b3739acfb2ae90','2025-02-04 10:03:27'),(3470,'fc2f108e2a673054cc6e282a72c9ce62','2025-02-04 10:03:27'),(3471,'c3f93e433864c14e151e2d719944e33d','2025-02-04 10:03:27'),(3472,'2e137144435eceadf295be24c2aa2ce9','2025-02-04 10:03:27'),(3473,'2e4e148cc183fa6d829391faa94bd5c7','2025-02-04 10:03:27'),(3474,'f04054bafd0aa1f1090dfa20cfeb1eee','2025-02-04 10:03:27'),(3475,'24970ed0c6deadc9897dd327aff71039','2025-02-04 10:03:27'),(3476,'d11abd75c51ea724b169bf9f237697c9','2025-02-04 10:03:27'),(3477,'a8e17107f173e8599193bd8149fd793a','2025-02-04 10:03:27'),(3478,'aed4e976e26747310c7684fe6c4a745e','2025-02-04 10:03:27'),(3479,'cfebbf996ef35d4b1484fff55d824a60','2025-02-04 10:03:27'),(3480,'c9ba306162cbc38533015cf643dd98e8','2025-02-04 10:03:28'),(3481,'148d76675f422767cbe8cb885348aea5','2025-02-04 10:03:28'),(3482,'e9bfcb515ce805a59ac827b1fe2a9132','2025-02-04 10:03:28'),(3483,'e8d30ce4b86556da3bacd7f18ece73b8','2025-02-04 10:03:28'),(3484,'021963aed29e3ec6af3c350ea223b14a','2025-02-04 10:03:28'),(3485,'92c2bd61cdf98b22afd57700be4a2a09','2025-02-04 10:03:28'),(3486,'5ffa966a36e0cc6d48e54cbfb25be7a1','2025-02-04 10:03:28'),(3487,'01443e62b7c5aac64c06294f699d4216','2025-02-04 10:03:28'),(3488,'6516b7ec9a43ad63d682df6778499ccd','2025-02-04 10:03:28'),(3489,'07c71f232f14ad1a9fadc54cfb55d496','2025-02-04 10:03:28'),(3490,'e1b2bca8ef08c23de7bbb0c537f8ba12','2025-02-04 10:03:28'),(3491,'7a88119ddf6421f445f3556c70811bd9','2025-02-04 10:03:28'),(3492,'505e8a4754ffcc4a201ae3fe93eaca79','2025-02-04 10:03:28'),(3493,'6cc31a2fa0e4bd85339e9f9366c485d0','2025-02-04 10:03:28'),(3494,'c404e6ab7c333949b22fcc9f645f737d','2025-02-04 10:03:28'),(3495,'9d0b117d883e1c15df0f0732e4806424','2025-02-04 10:03:28'),(3496,'8732b7fe73d468e9f3104adf7a335823','2025-02-04 10:03:28'),(3497,'0d3179b07c204323d3e1e414efbfa87e','2025-02-04 10:03:28'),(3498,'0542f91214cf08a8033e84f43ebbd2a8','2025-02-04 10:03:28'),(3499,'1deb8999eb638bdd69adf53319d2e551','2025-02-04 10:03:28'),(3500,'d4c59774876cfcd6a016eac29f6e9084','2025-02-04 10:03:28'),(3501,'c1f8af83514076be30277fc7c20177b9','2025-02-04 10:03:28'),(3502,'c94158cbfae169058454e0ba889c00e7','2025-02-04 10:03:28'),(3503,'6766c60b4c8af51d4e071ff4c5240ea0','2025-02-04 10:03:28'),(3504,'5d9a89abbdada90151850ea7d8278daa','2025-02-04 10:03:28'),(3505,'2b28a39a3f231987b363bea195f52183','2025-02-04 10:03:28'),(3506,'bd5fb7c320d3bd32d081e5d0d4622dc3','2025-02-04 10:03:28'),(3507,'47896110adfa5e7f4e0770ae63f969ce','2025-02-04 10:03:28'),(3508,'5baebb5302d4ac78609b5b1b6206dd06','2025-02-04 10:03:28'),(3509,'e309b9350baf965b02f17b89ea9b9111','2025-02-04 10:03:28'),(3510,'4537f01ab03d16e9d88bfc4ffc635594','2025-02-04 10:03:28'),(3511,'7b9c86f33cd07ffc3c3b49859622c3c3','2025-02-04 10:03:28'),(3512,'17a0f993e440b9a3fd410779786e4c1c','2025-02-04 10:03:28'),(3513,'191f0c9c36223179ccd3675210c3a893','2025-02-04 10:03:28'),(3514,'19235cc2e028a22cd509ce86e245ff0d','2025-02-04 10:03:28'),(3515,'10020684af55821989595540aa2cc0c4','2025-02-04 10:03:28'),(3516,'295bfa37203c7af0d7660a3e02f87e26','2025-02-04 10:03:29'),(3517,'5a227303b408f8912796c730deb01418','2025-02-04 10:03:29'),(3518,'2defedb387db54b4ce53c988a0214485','2025-02-04 10:03:29'),(3519,'93e2fa9c10ce878c5de33e0826399cf5','2025-02-04 10:03:29'),(3520,'a8480319fbb932959855386479955918','2025-02-04 10:03:29'),(3521,'6871587a6f61f989c7e88b7c578f91a8','2025-02-04 10:03:29'),(3522,'d8ac53159ed9b6fdf5ce65f48d39ef14','2025-02-04 10:03:29'),(3523,'9cf4ad2aee49d4b0320d42ad5ffeb201','2025-02-04 10:03:29'),(3524,'2aa9ebc05675af65258a2fec03e5c55d','2025-02-04 10:03:29'),(3525,'0d407d17e8dee84ea0d1ec9950dd289e','2025-02-04 10:03:29'),(3526,'19598e9f03144bc38d1c00813f7e2f06','2025-02-04 10:03:29'),(3527,'fd7825b67b7e822580668f67946ba209','2025-02-04 10:03:29'),(3528,'ceb2f57e7b13331118f2490d65fa6b96','2025-02-04 10:03:29'),(3529,'30d6eaa6dc171e9e1f4875a3ed5e05d3','2025-02-04 10:03:29'),(3530,'f1601b89fb65e17b4ca14e9ef29a4a1b','2025-02-04 10:03:29'),(3531,'1ffca5d1043b9aab21ed4d77f613236a','2025-02-04 10:03:29'),(3532,'4770ed7048aacb67f64d1dcf489aa2c7','2025-02-04 10:03:29'),(3533,'90d49e5b4368b3529ed70c102aa6002c','2025-02-04 10:03:29'),(3534,'02c5f7ecfe7126fd31bd15359aa53c22','2025-02-04 10:03:29'),(3535,'3201742665e9ca21110241d1e43df592','2025-02-04 10:03:29'),(3536,'cab24e408aa4b8f07e0e7ef17eb5864d','2025-02-04 10:03:29'),(3537,'0e3bad35ff1d28257f3aef554e61adba','2025-02-04 10:03:29'),(3538,'f8810f823192409cfd7a94b980d22fb2','2025-02-04 10:03:29'),(3539,'f4b1b54902758e5d8ffce5a8a4936a24','2025-02-04 10:03:29'),(3540,'389966f421d515d376bbe0ba1ccf4506','2025-02-04 10:03:29'),(3541,'bd7f1e35ce8b3e5c0aa35e6be8dc3865','2025-02-04 10:03:29'),(3542,'2b19a4aa83c27135e8221c3a581cc2ca','2025-02-04 10:03:29'),(3543,'5c40e41224a79967473a361085c34456','2025-02-04 10:03:29'),(3544,'f1a635b6930c9b2966c8174a6cf19fd3','2025-02-04 10:03:29'),(3545,'b97bf0a488c0823cf9d226532c071d59','2025-02-04 10:03:29'),(3546,'6b857123261f959a6383d0965ce241fd','2025-02-04 10:03:29'),(3547,'4db9f55f7b71346c1e085f13694da2c7','2025-02-04 10:03:29'),(3548,'0fb6c7e379ad003957fd1ae2925760f3','2025-02-04 10:03:29'),(3549,'8d314f23c235b6a6033f3930aa1c1afd','2025-02-04 10:03:29'),(3550,'368e33b52a0911749dab0bea2d1ae06b','2025-02-04 10:03:29'),(3551,'3e6a1e14a98ef715019ec253fac2e603','2025-02-04 10:03:29'),(3552,'7fb567d0e004e5c0c9f578aed35980f8','2025-02-04 10:03:29'),(3553,'8187b4c3178bd6958c6f6d7431433278','2025-02-04 10:03:29'),(3554,'fa41e5c9684ab8d0609c42c8c401b41b','2025-02-04 10:03:30'),(3555,'81f81ad6e63df752446f34844a1810ef','2025-02-04 10:03:30'),(3556,'fed1a8dcb741de2be0d57daa62b9cd9d','2025-02-04 10:03:30'),(3557,'5b3799995af3350227cd40b847763773','2025-02-04 10:03:30'),(3558,'96e07d0b65784d2f932da21a817e78d6','2025-02-04 10:03:30'),(3559,'3b1f231801e7c94ec19561fe1142aea1','2025-02-04 10:03:30'),(3560,'2e1eefe48ffd4cc4c3c476bb57831848','2025-02-04 10:03:30'),(3561,'fa2089d699ebb3db88a1f3c1c90d6f9c','2025-02-04 10:03:30'),(3562,'2555f0f3a6727b9e3c5d358b51afaa6d','2025-02-04 10:03:30'),(3563,'b425ac3de0c1fd64e9817c5ecb5b4a47','2025-02-04 10:03:30'),(3564,'72c8cf165b260bad8b7bae78add14491','2025-02-04 10:03:30'),(3565,'37c134626e6c859d9d6ecdc5ccb3a194','2025-02-04 10:03:30'),(3566,'f1fdfba3c253666e00eb1dc741dae174','2025-02-04 10:03:30'),(3567,'3b205b4a8c2ccf8add2e28fc1c54f0cd','2025-02-04 10:03:30'),(3568,'30306b1195fcbc1fc52bba1bb360d52d','2025-02-04 10:03:30'),(3569,'250b5bc318417a9ac2eace739aa4344f','2025-02-04 10:03:30'),(3570,'ebf05b6b9ea234e5d1504ba747c328ff','2025-02-04 10:03:30'),(3571,'ca50a30e1cba65f6cb486791250a9ac1','2025-02-04 10:03:30'),(3572,'915cdd6316f5cfa2ed892779f3e6f428','2025-02-04 10:03:30'),(3573,'e0b19439f9617281feecfc77559a881a','2025-02-04 10:03:30'),(3574,'14567410d3e3e8c334d8b10ec7c882a1','2025-02-04 10:03:30'),(3575,'7e9800bcf00731ce04ac4cd287ed399b','2025-02-04 10:03:30'),(3576,'330a7e81925ddbe723e8eba2124c6402','2025-02-04 10:03:30'),(3577,'06e979d52b43d139219a170623fa796f','2025-02-04 10:03:30'),(3578,'bc50b2ff2aa703aa2d06b17cd162cddb','2025-02-04 10:03:30'),(3579,'69cd7fde5fdf7c13a36f19f54835dab0','2025-02-04 10:03:30'),(3580,'3c2b2a8b81cde5c637006b6b2717cd62','2025-02-04 10:03:30'),(3581,'2d3f385f483f0229764a05a9cb139287','2025-02-04 10:03:30'),(3582,'86c68c86a3759aa319cdff45b63f0547','2025-02-04 10:03:30'),(3583,'169ca52ddae8e550957485a466b924d6','2025-02-04 10:03:30'),(3584,'6b574cdc419cb74228b002f332da793f','2025-02-04 10:03:30'),(3585,'08e5d7663f5ab36b73116d52d683acf7','2025-02-04 10:03:30'),(3586,'d3132c736b14b7f8455f65b7c82d45e0','2025-02-04 10:03:30'),(3587,'18d86d08559b75cf6c897651b663ae9a','2025-02-04 10:03:30'),(3588,'1ffd0dbb0fefed74289e34dcd86554f3','2025-02-04 10:03:30'),(3589,'5cccb6575439d14d7d2289c5e66efdd0','2025-02-04 10:03:30'),(3590,'1864f1f82f3518eeb26b40fd03be833f','2025-02-04 10:03:31'),(3591,'424acea4df584d2aa34d85648593b6c0','2025-02-04 10:03:31'),(3592,'bbf7571a4d156fbe5ca48741b2045e1e','2025-02-04 10:03:31'),(3593,'a84ae3f77d279580caccaff1cb2fa8d3','2025-02-04 10:03:31'),(3594,'e53117f14ce0c0580e4cb156d8885477','2025-02-04 10:03:31'),(3595,'19e37dfb66d4361070089cd496dc7181','2025-02-04 10:03:31'),(3596,'8a1bcad9020bdc80a46519a78e252d2b','2025-02-04 10:03:31'),(3597,'8c1424415e9f5fc6ffbe1394e4457708','2025-02-04 10:03:31'),(3598,'87bf68d2db2bf684c5b2d878f1187ff5','2025-02-04 10:03:31'),(3599,'538ee9471b78c3d3c54568a21b173d3a','2025-02-04 10:03:31'),(3600,'3086fce4dfcbbc16f6e50d4ace3c12e8','2025-02-04 10:03:31'),(3601,'8f4c2f3999281a5390ea8b410e9ccff4','2025-02-04 10:03:31'),(3602,'148eb60dcd9d23a964969cd686c34e7c','2025-02-04 10:03:31'),(3603,'b558e0f32ef94dc31508d25c3c2ca005','2025-02-04 10:03:31'),(3604,'a619a7adfaa6235496eb995edf054f35','2025-02-04 10:03:31'),(3605,'a2cafd004b684c1b238ac785141e65b5','2025-02-04 10:03:31'),(3606,'301535a23ad07763e15bed4f8069ea11','2025-02-04 10:03:31'),(3607,'b7aaac8bf4005008c17619e4aee9d3d2','2025-02-04 10:03:31'),(3608,'b046aec41af1952b2073701b8e36ea48','2025-02-04 10:03:31'),(3609,'3c5bd4403eae9e8e20a900915c18e7cd','2025-02-04 10:03:31'),(3610,'4cfce48d5f87f3abdb64e720279e7340','2025-02-04 10:03:31'),(3611,'f383e21cc9e8e28641f949db39777150','2025-02-04 10:03:31'),(3612,'a08aa436d6478de5bd22176fad3f2422','2025-02-04 10:03:31'),(3613,'2504966f974a361a10711813d999bd61','2025-02-04 10:03:31'),(3614,'d0c85f17ec752626e9d3c0ceaf1a9d87','2025-02-04 10:03:31'),(3615,'79cc93c4c902438906b70c1130e3a4ec','2025-02-04 10:03:31'),(3616,'aacd292845ad89a8d5322c9fe70dc851','2025-02-04 10:03:31'),(3617,'866692c3c5c38ef004ce8a762d11b66f','2025-02-04 10:03:31'),(3618,'fafd80b6e76f6d48516f5b5201376c27','2025-02-04 10:03:31'),(3619,'ebe49d4a9f6a8eb402728daaa9c7b92b','2025-02-04 10:03:32'),(3620,'8007e09a77c58d78d1ff46eb55c2ce7e','2025-02-04 10:03:32'),(3621,'52ee9c000c1f8e4f36a11bcf01da2b0a','2025-02-04 10:03:32'),(3622,'bc6f592d1a583fd211134f866ef77a43','2025-02-04 10:03:32'),(3623,'123eb797729986e7fa8218c47cccf3cc','2025-02-04 10:03:32'),(3624,'83c5be003cab84f358037de34303a9d3','2025-02-04 10:03:32'),(3625,'5ae5262c9cc899a0b4cd6f020166ae0b','2025-02-04 10:03:32'),(3626,'0305d863288150ef79214a7c797b5483','2025-02-04 10:03:32'),(3627,'1dafd182b07c2e6cf21e7b57ec2a118b','2025-02-04 10:03:32'),(3628,'81e9a5889433252cefc69c67c6d25efe','2025-02-04 10:03:32'),(3629,'d87d79c2cb6cd6953f40d62bed9b8278','2025-02-04 10:03:32'),(3630,'d806cc9e08982ae4727a12cf01fd922c','2025-02-04 10:03:32'),(3631,'8f6da192729a01d2445aa16287102ad4','2025-02-04 10:03:32'),(3632,'ddcc8ea9cd8db4a749389a4189b498d8','2025-02-04 10:03:32'),(3633,'c0b3beec9ef8020313c4b1f6f29bf0a2','2025-02-04 10:03:32'),(3634,'28a59ec2eaca9584cd7b34c5904bc3ac','2025-02-04 10:03:32'),(3635,'aff7d98eca70c8d61635f365f1ac8978','2025-02-04 10:03:33'),(3636,'f36a553a6d6ec574dd96eca3b3c41c0d','2025-02-04 10:03:33'),(3637,'125a2a2820e19adb78306ff087201157','2025-02-04 10:03:33'),(3638,'f3b92e9ab7008639124bd1d9ab0b71ab','2025-02-04 10:03:33'),(3639,'e3100da2b149b2dae7d8105c912a14e9','2025-02-04 10:03:33'),(3640,'39e41da3388163e1143abc306e2c3bc1','2025-02-04 10:03:33'),(3641,'bcc7435ff18c76da3dbaafeb98bddab0','2025-02-04 10:03:33'),(3642,'2dd9525455611520905ca806750695c0','2025-02-04 10:03:33'),(3643,'eb4c16e4b9ad35764fd9e8d71c8a59a7','2025-02-04 10:03:33'),(3644,'167cd42c044c56485ed9fa9498b93f88','2025-02-04 10:03:33'),(3645,'68b4f9cc98d2f63515295e3a4e1c1e9c','2025-02-04 10:03:33'),(3646,'e7a14a5b5d0e6c2ac83d7586e0e8b2f5','2025-02-04 10:03:33'),(3647,'a16a5376d827d8fcb7a91cbf724cf1b3','2025-02-04 10:03:33'),(3648,'3940865cad6a16f267a23dfe7c75984c','2025-02-04 10:03:33'),(3649,'2eed270b0bc2423da23fb4bc044501f4','2025-02-04 10:03:33'),(3650,'d1717faf78904e497c0bbb3c752212fc','2025-02-04 10:03:33'),(3651,'7003a90d470a8f11d0f105fcc918a121','2025-02-04 10:03:34'),(3652,'4201a864224e1332c38a2f6bfa78bf63','2025-02-04 10:03:34'),(3653,'54ab065e3581caa299f3fce8c9ebfe5a','2025-02-04 10:03:34'),(3654,'1748430c6aed6390438de5d7a77de7bc','2025-02-04 10:03:34'),(3655,'bafe0b108074528ecd8b79cd0208e61f','2025-02-04 10:03:34'),(3656,'b9a30cba29446141adef1039a16fee6e','2025-02-04 10:03:34'),(3657,'131207a5dcdfe128f1ef989dfef27b48','2025-02-04 10:03:34'),(3658,'8056f5730e6b30eb1e15992a336431fd','2025-02-04 10:03:34'),(3659,'64f80bf075e081c8dec872a5924847fc','2025-02-04 10:03:34'),(3660,'246d7ca93664c9b78618e261fb12fa56','2025-02-04 10:03:34'),(3661,'cf9a1c0fbf4c6a1af72777673628b660','2025-02-04 10:03:34'),(3662,'cc3ff6a17897dc3a6ec3f96618072529','2025-02-04 10:03:34'),(3663,'43d6e7dd942f83f2fe099aa2018c58c4','2025-02-04 10:03:34'),(3664,'4a1efab573859073ab67614232dbeb0e','2025-02-04 10:03:34'),(3665,'ab708381ed7e46733e851494eff0b625','2025-02-04 10:03:34'),(3666,'ee401d3bcb7c3646ea024f3d7961c803','2025-02-04 10:03:34'),(3667,'6e29e88c972c2b0c245d73db9e738eaf','2025-02-04 10:03:35'),(3668,'825a7cdeaa2573cec9f6e18744521a54','2025-02-04 10:03:35'),(3669,'da16ab31e100f6ce81a590e301130298','2025-02-04 10:03:35'),(3670,'067a4cc76b229b381aff90c501e8de9d','2025-02-04 10:03:35'),(3671,'6582b20a8060a0c7d23e1025474f3899','2025-02-04 10:03:35'),(3672,'7f4e577bd9289b1cb3f8e4c5b5b2e0ea','2025-02-04 10:03:35'),(3673,'6d19206d703ac8cfc73d72b5303c8b9d','2025-02-04 10:03:35'),(3674,'e675d13b3787e6ff3a5cdd04d19f40f6','2025-02-04 10:03:35'),(3675,'06fb025d2f4c012f0dccaa4cd2d59e34','2025-02-04 10:03:35'),(3676,'fdeabb4bedde2667bcb534dccfe7da92','2025-02-04 10:03:35'),(3677,'00c69ea1bb6943f5ee89c399f76a8d9d','2025-02-04 10:03:35'),(3678,'0655c95ec17eeaed7b1be9e638cb867c','2025-02-04 10:03:35'),(3679,'75cbad1276fb572ce75dd88ed32eccb5','2025-02-04 10:03:35'),(3680,'e79613b40327386419db0f57c451be55','2025-02-04 10:03:35'),(3681,'fcd3dc1112ce20d3b8fe0a013e047519','2025-02-04 10:03:36'),(3682,'3082fc7822981d329b0aecc06b220bdf','2025-02-04 10:03:36'),(3683,'9fdd22e87cad2a9cf6f368f83a1adc15','2025-02-04 10:03:36'),(3684,'a6cae68bad06b63e73cdb70b958cb936','2025-02-04 10:03:36'),(3685,'ea3d86745741e3ccfbd3d86aeebf2392','2025-02-04 10:03:36'),(3686,'44735a575f971e400fed72def2908ba9','2025-02-04 10:03:36'),(3687,'3fa1f396bc6929c24f13f3248094df69','2025-02-04 10:03:36'),(3688,'d7b79925715acf0685eaae0f752be7e8','2025-02-04 10:03:36'),(3689,'b89174a08e8e3f106c1482e4b5bfef9e','2025-02-04 10:03:36'),(3690,'42a85cb077ad8cdae0c45c7f1c2a0b60','2025-02-04 10:03:36'),(3691,'54cefbb5670464a67d6da0177a0a31b2','2025-02-04 10:03:36'),(3692,'1b7014512510d02bac6541eb28d102e3','2025-02-04 10:03:36'),(3693,'52c86a6b21568a9452c894bcbe4b66b9','2025-02-04 10:03:36'),(3694,'c37bbb29687d87e89989b7ba904f6050','2025-02-04 10:03:36'),(3695,'02a603af1247f6b74c835f1ba9b4af80','2025-02-04 10:03:36'),(3696,'2beba7644ff0ce7bbd0f86ddccb93748','2025-02-04 10:03:36'),(3697,'f2ea833f3025f09bc7f8a07a4290f8b5','2025-02-04 10:03:36'),(3698,'2ab3ad0db4932fc70dc7ff96b56ec5a7','2025-02-04 10:03:36'),(3699,'ef8296d48f2ed3c6f87a27f7e332b932','2025-02-04 10:03:36'),(3700,'2c519fa331bf94004706b4579de5e04f','2025-02-04 10:03:37'),(3701,'c54c3a3f02dd096829aa4756c75a0553','2025-02-04 10:03:37'),(3702,'cfbbd8d2c1b9f60d71b4533fbc4c6242','2025-02-04 10:03:37'),(3703,'eda52fd30eb5348498a827f7b483724e','2025-02-04 10:03:37'),(3704,'cb21d99feac77cd2627c4fa812bc01ee','2025-02-04 10:03:37'),(3705,'176558158f5e7177892ad8b3645a6c8f','2025-02-04 10:03:37'),(3706,'ab7687fce0445e495afd706ce3a7ad42','2025-02-04 10:03:37'),(3707,'d5d9efb9dc0f2d792fc4fd6a1cb4153e','2025-02-04 10:03:37'),(3708,'3f72ed1b72a1fba3149dd85db051b8c6','2025-02-04 10:03:37'),(3709,'ee54337c8c311bf6fc2c5b568515b58a','2025-02-04 10:03:37'),(3710,'1b0d4be8abf225e39f25b2e7ff973dc4','2025-02-04 10:03:37'),(3711,'616c3e44671d0cc44e3f5b3566b778ec','2025-02-04 10:03:37'),(3712,'56b88ff2083eb9702d99d7893df7472a','2025-02-04 10:03:37'),(3713,'48dff27fa1508918a715e783065db08c','2025-02-04 10:03:37'),(3714,'a5416c516e5b2aceb027ea251bf44df4','2025-02-04 10:03:37'),(3715,'d21d5e4b0d11519a026e188dab4e6840','2025-02-04 10:03:37'),(3716,'709bd6304516c1bd9f17f4a48567ad0d','2025-02-04 10:03:37'),(3717,'fc650e01980d3da1279b50a1e24f79e7','2025-02-04 10:03:37'),(3718,'6f4f56209a5565bdc3169aa1fa762b19','2025-02-04 10:03:37'),(3719,'766731b41fdd461f6cbfcc44102e7004','2025-02-04 10:03:37'),(3720,'d361298d66747070153c789cd26c1cf2','2025-02-04 10:03:37'),(3721,'8bb85bd84f5529148c43baa72e7c6c13','2025-02-04 10:03:37'),(3722,'d4487cc7ca963d78fb808eddee9c1720','2025-02-04 10:03:37'),(3723,'7adee0ed7cfebf7c072af5bcb5c62f10','2025-02-04 10:03:37'),(3724,'8de12709fa5940b9a8ac6361e1a08c33','2025-02-04 10:03:37'),(3725,'a2c3277f232f9be6685689893ff4deb2','2025-02-04 10:03:37'),(3726,'2a34a0d4ced43c6497539b25f62a5fcb','2025-02-04 10:03:38'),(3727,'b891b6fda12125c8e4933e72cbd69c07','2025-02-04 10:03:38'),(3728,'81d395794cd2d94112704565e794b5b9','2025-02-04 10:03:38'),(3729,'7b624a1dc896fc9490c0b85895397021','2025-02-04 10:03:38'),(3730,'cd4e61d6d73278f4ce83b5aadd71f563','2025-02-04 10:03:38'),(3731,'9feb154ce686559eaf8e6034b4a8606e','2025-02-04 10:03:38'),(3732,'7975289395471a3ff7a291e1736dcf56','2025-02-04 10:03:38'),(3733,'ec411286f43ca699842b94990890a4b4','2025-02-04 10:03:38'),(3734,'4b401a0300ebf787ca24fb58e868be69','2025-02-04 10:03:38'),(3735,'81d48435ccb49c8b4315b0d93e81a67d','2025-02-04 10:03:38'),(3736,'6d59c9e8ea639a7024c792fd6ed53322','2025-02-04 10:03:38'),(3737,'4c34bd81073388d024e1a63d069cfa30','2025-02-04 10:03:38'),(3738,'b5ab4dc01e1ee99612134b403c821658','2025-02-04 10:03:38'),(3739,'37d31fb0064d01803c3a0af4c1976db6','2025-02-04 10:03:38'),(3740,'91f025470c266393786e322b4fb91db5','2025-02-04 10:03:38'),(3741,'96dc11e38aab85c268cc7689cc46c790','2025-02-04 10:03:38'),(3742,'7b3f1ef96bb541bbb8cc9b5464919167','2025-02-04 10:03:38'),(3743,'60a145245df248f57f014575f771896a','2025-02-04 10:03:38'),(3744,'0347e9637b6bed879e42d16756ce7bb6','2025-02-04 10:03:38'),(3745,'3b0547996b6dd85cf4af44c72f6b5128','2025-02-04 10:03:38'),(3746,'a56ca29a2b1441e4f1bcb1c75ad9905c','2025-02-04 10:03:38'),(3747,'98b958b286efdb6ec93cbfdc111cfe5b','2025-02-04 10:03:38'),(3748,'972e42ecceee864bd9d74bde4a3e4342','2025-02-04 10:03:38'),(3749,'bfb48dbe1cac5a823d277af8de412e03','2025-02-04 10:03:38'),(3750,'d6a11a66a6902ca824c5886bbc006866','2025-02-04 10:03:38'),(3751,'d5926aeb8aaf3be324c1c28c045a4db4','2025-02-04 10:03:38'),(3752,'ab644e8fd33a11d96c6417edee854b23','2025-02-04 10:03:38'),(3753,'ad24e1f524e86ec82a95f96eb749906a','2025-02-04 10:03:38'),(3754,'699adef31ed8031e16e6de10d1b5c726','2025-02-04 10:03:38'),(3755,'cf57c513eec82c0fb50ea3dd43ccabb1','2025-02-04 10:03:38'),(3756,'7ab8b20753f55795688ee6924758160e','2025-02-04 10:03:38'),(3757,'dcb101a6c65e9b29cfd4a9112e9fa46d','2025-02-04 10:03:39'),(3758,'0453016bc83ffaa0d5776996a594d182','2025-02-04 10:03:39'),(3759,'29be0dd3cc8306a63e527452f7f52161','2025-02-04 10:03:39'),(3760,'ff48bbc549ff243f6e53c82310c79700','2025-02-04 10:03:39'),(3761,'49a08a8509f53a8b8355b219ef93ab93','2025-02-04 10:03:39'),(3762,'d2c20d4c514a57cef34a9534c97ffb78','2025-02-04 10:03:39'),(3763,'aadc808bc735293622e4d3ed6da97aa8','2025-02-04 10:03:39'),(3764,'2c767e2949488e6ed4c1453e8842cc70','2025-02-04 10:03:39'),(3765,'6d8999106d5043738d4f5f1cbb32b64f','2025-02-04 10:03:39'),(3766,'fb64ade5d87a625d923ed1a764b94878','2025-02-04 10:03:39'),(3767,'e39984a96d1e296158c1b72f36ef2919','2025-02-04 10:03:39'),(3768,'c41eb5b7c1584b253cedd5f36500ae2a','2025-02-04 10:03:39'),(3769,'620383f00c0651127d56d4d1765fc505','2025-02-04 10:03:39'),(3770,'3f09a53ed5a0e06d1aea8f968f116bf1','2025-02-04 10:03:39'),(3771,'26bbf59cf462f4c6d1322ad5e8caa5a6','2025-02-04 10:03:39'),(3772,'f2d7db2d1355f63c0e378dc129382158','2025-02-04 10:03:39'),(3773,'880e79eb452d4c2ef1f16018572ce2f3','2025-02-04 10:03:39'),(3774,'081e9641259cdcbd7eb3c479aa25c1ca','2025-02-04 10:03:39'),(3775,'a06fd28f3553aafbd87cb114b373448d','2025-02-04 10:03:39'),(3776,'d51e11bc8a4f698a28ea85415f6a6cd6','2025-02-04 10:03:39'),(3777,'5cb431a5b1015f1afa1359c33ba00079','2025-02-04 10:03:39'),(3778,'4a96a1b1d634c5150f874e2f24d63d09','2025-02-04 10:03:39'),(3779,'249adc3cc937fe061a89d24fb40d220d','2025-02-04 10:03:39'),(3780,'371afe8dbc4d0d02bc8edc7da1ea6a24','2025-02-04 10:03:39'),(3781,'d22adda0a8682e01d16ed28642dfe15f','2025-02-04 10:03:39'),(3782,'62a5921e88fb00f3f09093b002d0c672','2025-02-04 10:03:39'),(3783,'2c3966123cb5a22d26b4b605d45560be','2025-02-04 10:03:39'),(3784,'8d354eb7fa93c81e31d84e7bef650571','2025-02-04 10:03:39'),(3785,'64f2c16647e4c82b52302c5f33c979ac','2025-02-04 10:03:39'),(3786,'9d97a7306c72a73fbff897766c2a8c80','2025-02-04 10:03:39'),(3787,'41bc5661006257062787bc44fec79fcb','2025-02-04 10:03:39'),(3788,'6d66e1a5033ec8f7e1ddbb26ea847ba0','2025-02-04 10:03:39'),(3789,'53060ff63a9d5fda3718c04db70d4749','2025-02-04 10:03:39'),(3790,'5e8335d20b8484558d6b504bc7ccfa96','2025-02-04 10:03:39'),(3791,'64d8004477d7eb443db99501b59da642','2025-02-04 10:03:39'),(3792,'5cf4afc161a08d2315ef55b8d7aee864','2025-02-04 10:03:40'),(3793,'8293c9e17e9b02e43e0aa3e8840b290a','2025-02-04 10:03:40'),(3794,'6d8b1411019ce526cfb70b2499b4764e','2025-02-04 10:03:40'),(3795,'c3a42334d4378a8c493c75af230bf003','2025-02-04 10:03:40'),(3796,'4adff0618f2f5be51f853686c3bbc93a','2025-02-04 10:03:40'),(3797,'32cbe9acc4ab9619f7b937f5592a3ccf','2025-02-04 10:03:40'),(3798,'5f30f48cad91c9c76cbb668470aac2fe','2025-02-04 10:03:40'),(3799,'fd48f435a13fa9039c793936ab1b5576','2025-02-04 10:03:40'),(3800,'7de0893f517e764446294b180c795c7e','2025-02-04 10:03:40'),(3801,'c729277d24bdd553057f31d664263be4','2025-02-04 10:03:40'),(3802,'3ba8e64da80a664c1be603424f3f4b01','2025-02-04 10:03:40'),(3803,'a11bd7d638ba1fe6a142211c6dac0e6c','2025-02-04 10:03:40'),(3804,'d4ef827d28325fb527f7fb55b0353079','2025-02-04 10:03:40'),(3805,'14ff16f0de6828abba717b086d60a99f','2025-02-04 10:03:40'),(3806,'db33abc245a05b21f991d27a824e82af','2025-02-04 10:03:40'),(3807,'e1c0565c6bb9b96b83acf9d5a8417294','2025-02-04 10:03:40'),(3808,'8c812644544070a51f439be6c72a9db8','2025-02-04 10:03:40'),(3809,'505b4c0b23052273f3963c0a9acb6f57','2025-02-04 10:03:40'),(3810,'5bb6d3be8fe823fe746e20348a639dc1','2025-02-04 10:03:40'),(3811,'9d731a9dac10dcdee621a0519e1b90b1','2025-02-04 10:03:40'),(3812,'206bc0b2239de2df99d3034ff01ef373','2025-02-04 10:03:40'),(3813,'e4377a9cc4f3045974648ed339e76680','2025-02-04 10:03:40'),(3814,'81c081e16f4cb237e522d5dcc7bc8b31','2025-02-04 10:03:40'),(3815,'7f79885e203355202145fb318028e85a','2025-02-04 10:03:40'),(3816,'3b27102c095c61a30fa4a840d77bbe82','2025-02-04 10:03:40'),(3817,'3b4bf0533fd07faffcf49b3cad0b89d9','2025-02-04 10:03:40'),(3818,'125f2b2f93df4bf0cc8d824800817641','2025-02-04 10:03:40'),(3819,'715548ce836532f4ed47972523f2ace4','2025-02-04 10:03:40'),(3820,'b75386aeceea1320c1d72067e170e6f0','2025-02-04 10:03:40'),(3821,'9eb65d88a001a3cd9a3ca311257a155f','2025-02-04 10:03:40'),(3822,'3d460ae2bdd30e22bc8767a4bbfd1d3e','2025-02-04 10:03:40'),(3823,'fd936c81bb08a4b4114f911f14daa8f2','2025-02-04 10:03:40'),(3824,'ea693b97fc8eb3ba6a15d214b1d733d2','2025-02-04 10:03:41'),(3825,'37877340748dd7fff332f54295bd8831','2025-02-04 10:03:41'),(3826,'9d04c06361f7ad4306cfdf3c69d3752d','2025-02-04 10:03:41'),(3827,'2581699532930263184f7c7c20e13b66','2025-02-04 10:03:41'),(3828,'6ec24f0479671edd0453be14ca53b461','2025-02-04 10:03:41'),(3829,'f6150be9ed8d83afab1c08b355f5dccc','2025-02-04 10:03:41'),(3830,'2dbac5c70b9c7e2ebf44c478bebb610d','2025-02-04 10:03:41'),(3831,'6e53169d196ac61451fe75d8c222b8d4','2025-02-04 10:03:41'),(3832,'460e38004dc13b5a999d3f3762bbcda7','2025-02-04 10:03:41'),(3833,'e7788820863535c156ed7f78a6df12ec','2025-02-04 10:03:41'),(3834,'a845bcc8c6266af3f1c43320eb2514b3','2025-02-04 10:03:41'),(3835,'75854d44e65a1d8e3add2f08d986c643','2025-02-04 10:03:41'),(3836,'5fb700dbb6e61953a4a54778c5b5a883','2025-02-04 10:03:41'),(3837,'85ab1410b0d3d0e5a766bec2b233c75f','2025-02-04 10:03:41'),(3838,'5514d997ca50629601c9c90b771285fb','2025-02-04 10:03:41'),(3839,'62671fe2ed333a79cfbaff7c59cefeb6','2025-02-04 10:03:41'),(3840,'7dd1d9c72011f8b55f7809411d4eab2f','2025-02-04 10:03:41'),(3841,'5ff94aa91742abae3d8aff02f764c6d4','2025-02-04 10:03:41'),(3842,'0d0ba302019797e4fc5e55090c019cb9','2025-02-04 10:03:41'),(3843,'ceaaa5836cbf4ea68ebd9e989773f71a','2025-02-04 10:03:41'),(3844,'b057371ddb3fe8454ab79e100221d3da','2025-02-04 10:03:41'),(3845,'2c3a25f9b0caef02af5cd72104f0adec','2025-02-04 10:03:41'),(3846,'f9285b7de3a0f5a4a49ff926fc745b9f','2025-02-04 10:03:41'),(3847,'e993e7eaa990cedd5fd8669a216d029c','2025-02-04 10:03:41'),(3848,'2aaa7651c09a3ed85f4b067ed2614ab6','2025-02-04 10:03:41'),(3849,'7fe454ce4e446421041b2387551aa3f6','2025-02-04 10:03:41'),(3850,'c96315f84abb6977284c98b00d6e6027','2025-02-04 10:03:41'),(3851,'34c8150a84445475bd772daae796c1a7','2025-02-04 10:03:41'),(3852,'5ad2bad27ebe012370c694d799143c57','2025-02-04 10:03:41'),(3853,'6af922448f502165a8d0e5f7da427168','2025-02-04 10:03:41'),(3854,'fc2bed49d983cb1fdba730b13c624c73','2025-02-04 10:03:41'),(3855,'da6b3f7a16b1814aba6c4cc2224751b7','2025-02-04 10:03:41'),(3856,'25d89788e302c79d5258a54f683c77cb','2025-02-04 10:03:41'),(3857,'6b156460e9d07cd1382e581ca4d173e9','2025-02-04 10:03:42'),(3858,'b75301a124553ad67b15b57994e76863','2025-02-04 10:03:42'),(3859,'4c390291c2b42f8f5af0eba5a0415ebe','2025-02-04 10:03:42'),(3860,'781ff8c6101b11ece8efc17a9a7e8fab','2025-02-04 10:03:42'),(3861,'3c254d46a18c49939839eea538921a31','2025-02-04 10:03:42'),(3862,'92b127f1ff65f75db0ad026988b00892','2025-02-04 10:03:42'),(3863,'48244eb2d30ea1b25a6160af92b98970','2025-02-04 10:03:42'),(3864,'771fb1e6eaab7f31f7b0f3cd83107bc7','2025-02-04 10:03:42'),(3865,'4ce771641defc30c6a31d8f097890db8','2025-02-04 10:03:42'),(3866,'02851cca679904f2f443d3391786d1d4','2025-02-04 10:03:42'),(3867,'39ccb5804e72ce326de79d9e4f82482f','2025-02-04 10:03:42'),(3868,'5685706435a5fbd7317eb6690e4897eb','2025-02-04 10:03:42'),(3869,'01138c01b154c8ab93efa934751d7e01','2025-02-04 10:03:42'),(3870,'f0f522af7a470a16b91cc973a36324e6','2025-02-04 10:03:42'),(3871,'e5159c9318e5f0429e5e4455cbecd726','2025-02-04 10:03:42'),(3872,'7fb515af92736f687b271136732d0b6c','2025-02-04 10:03:42'),(3873,'55f78474296b401e844f433ff7fd592a','2025-02-04 10:03:42'),(3874,'7ad36e1a8f61dcd34bd39d6bbd34b597','2025-02-04 10:03:42'),(3875,'14033f6c7b371e2a806b3ba022cd7411','2025-02-04 10:03:42'),(3876,'d475ac1f906d175e103a50f20695db75','2025-02-04 10:03:42'),(3877,'ef7bee82fe92aa613fb2fea6bf063b10','2025-02-04 10:03:42'),(3878,'16c5fcc01909e0646910d2c0c1ff40a4','2025-02-04 10:03:42'),(3879,'f27ae654f6c38a33f5f37378a8e97bd3','2025-02-04 10:03:42'),(3880,'e521c2a87a93ab0c930359261071f8eb','2025-02-04 10:03:42'),(3881,'98d81e323f00de776b2e7161de33c2f6','2025-02-04 10:03:42'),(3882,'bfc943c0a323c48932de23fc6adb7f89','2025-02-04 10:03:42'),(3883,'4c8c920f3913b51d63663efc9a438205','2025-02-04 10:03:42'),(3884,'0c8c78eeba0f8844e7c19097fd28072d','2025-02-04 10:03:42'),(3885,'e2fe2576e4e5b8669e49beee89d59e3e','2025-02-04 10:03:42'),(3886,'e2b0a8dae47ae7e4886789d5d74ab878','2025-02-04 10:03:42'),(3887,'f2e6b477d20ec7784c258246b5a42887','2025-02-04 10:03:42'),(3888,'cea86c70fb34338edfda32d6311849fb','2025-02-04 10:03:42'),(3889,'6f5c446009705c97cd75b99fede42536','2025-02-04 10:03:42'),(3890,'e5ea089d6bc24987c69441e22705650b','2025-02-04 10:03:42'),(3891,'dd0259f7317cdf1dd2a7540a23c52dc7','2025-02-04 10:03:42'),(3892,'0c294e05b48f9420434a06ae5daf78d8','2025-02-04 10:03:42'),(3893,'d0d1ac84b2788c33ed5db5d04820bc7d','2025-02-04 10:03:42'),(3894,'c0ac8873d35bfec9bd9f1eee2b073c3b','2025-02-04 10:03:42'),(3895,'76f0a65a568900e622a4f8be23361420','2025-02-04 10:03:42'),(3896,'fd46c881105af42b0b9aa1ecc6c0ec38','2025-02-04 10:03:43'),(3897,'268f3f49beab9d956340af6257981747','2025-02-04 10:03:43'),(3898,'8ce4520cd39b06d53bcf707ab4bcde87','2025-02-04 10:03:43'),(3899,'e789e1ad8e717fb7a5ab53415a7afcb6','2025-02-04 10:03:43'),(3900,'ef3abc53c0265e86fda1e2a403ea6735','2025-02-04 10:03:43'),(3901,'99ecdaf1d6da5d5285a27b884efa2d68','2025-02-04 10:03:43'),(3902,'cce9bce60d3da6a31361020fbfad4591','2025-02-04 10:03:43'),(3903,'2b59049a9665385e050ae17cbb89b19a','2025-02-04 10:03:43'),(3904,'f2535ab4f712f5e72a2cb9b60ced455f','2025-02-04 10:03:43'),(3905,'9f5b203aba7c42eea0c6038c905c221c','2025-02-04 10:03:43'),(3906,'9a96457a778d3cf5b345cb7d0a0f9bb4','2025-02-04 10:03:43'),(3907,'b449573a979894cc07383886a7344f59','2025-02-04 10:03:43'),(3908,'711ac81a7df1e07b802ed8edfa4f47f7','2025-02-04 10:03:43'),(3909,'730aefa76b2ef6b8e2aa2cb794a6dca5','2025-02-04 10:03:43'),(3910,'9ec05c41d1258c198691e892cf670c5a','2025-02-04 10:03:43'),(3911,'3f5d920f3e907324d1b542241c7cc829','2025-02-04 10:03:43'),(3912,'5b7e3b06051b224504cf8c0ed9bad037','2025-02-04 10:03:43'),(3913,'3eee1c9f1d1f72987ed91bcb71a3d71a','2025-02-04 10:03:43'),(3914,'d700030cace4e5fa370b5accdc66d5a8','2025-02-04 10:03:43'),(3915,'297d37685c1ea4c60e2d1eef3c2c9eae','2025-02-04 10:03:43'),(3916,'e16d6acef38bf2d8953e3d5baeb7d752','2025-02-04 10:03:43'),(3917,'4405a2220ace459e5c0d3b9adb9f17a0','2025-02-04 10:03:43'),(3918,'de750e28df416d7e3699d12e417e8808','2025-02-04 10:03:43'),(3919,'59b3c0edd78f992ef3d3190c7867f64d','2025-02-04 10:03:43'),(3920,'c98b7952d8c33cd8c84a3eb3dd209a94','2025-02-04 10:03:43'),(3921,'3e28997291a5cfda14e427eb2dced68a','2025-02-04 10:03:43'),(3922,'eb98f2cb3c2bc1092e944275242d15ce','2025-02-04 10:03:43'),(3923,'894a360c08f71861d3a932ef159adf55','2025-02-04 10:03:43'),(3924,'aeb7f39e1f0d3625f329432e7ee27a4d','2025-02-04 10:03:43'),(3925,'691d915b2b8e3bdc7474934cc799fae5','2025-02-04 10:03:43'),(3926,'0ec669a3a1d6cc1f63c0969abbe45fec','2025-02-04 10:03:43'),(3927,'958d6880de8a560c5a21e4c303294b0e','2025-02-04 10:03:43'),(3928,'e0818d8b06926f666ce9612f1e06b418','2025-02-04 10:03:43'),(3929,'f8e8b889047721dd1fd309375efa9558','2025-02-04 10:03:43'),(3930,'87097770528e0f80726a02f28ae33485','2025-02-04 10:03:43'),(3931,'d6180f072234d5151dc818a9d209c948','2025-02-04 10:03:43'),(3932,'412312c2a3f62a9b78b7cef50f76b857','2025-02-04 10:03:43'),(3933,'cb1b3ff1028df753d4d2a40c0d772a8d','2025-02-04 10:03:44'),(3934,'d7de494207fddd9c1b97e5198f9a2714','2025-02-04 10:03:44'),(3935,'7bf976871b808fe9f4776c9b1dd5a815','2025-02-04 10:03:44'),(3936,'4e7b2c9ad37571ed3341a4203735ba4f','2025-02-04 10:03:44'),(3937,'23f618602b1b815633d746b1a1ed4e3f','2025-02-04 10:03:44'),(3938,'052a340d793f9c8d939284ba29c1a625','2025-02-04 10:03:44'),(3939,'5987d838016e5f6e6505b3b4d8564843','2025-02-04 10:03:44'),(3940,'3976c3257e748b919c39300ab9532e24','2025-02-04 10:03:44'),(3941,'bdb09b4e65fe8f9aee67ce0843d4d501','2025-02-04 10:03:44'),(3942,'2f18f8033be1e68bb251a6792c48123f','2025-02-04 10:03:44'),(3943,'c58804bd9653b49ef5211b043f5e8ec3','2025-02-04 10:03:44'),(3944,'ad643bf544b8fb9b7ca690a70d4580c9','2025-02-04 10:03:44'),(3945,'74b739d73efb27cd688dd57481b021f8','2025-02-04 10:03:44'),(3946,'9b88147511327e1ea37fbd07b5fd9d33','2025-02-04 10:03:44'),(3947,'4512e0ffc7dc39bb46f8201876fd882f','2025-02-04 10:03:44'),(3948,'0369ecc34dbcb3d8c30d26b45a8524fa','2025-02-04 10:03:44'),(3949,'c5ab03e8cd44bcc2c7c844c4b842ab74','2025-02-04 10:03:44'),(3950,'7b00d88941c23af4d65a7adc699bf966','2025-02-04 10:03:44'),(3951,'bcd2a96f0287c1c71ea26c593ddc2642','2025-02-04 10:03:44'),(3952,'c95736b1579890306c6ee88c2266fb47','2025-02-04 10:03:44'),(3953,'cf317ae48131b1cfaab90c370075602e','2025-02-04 10:03:44'),(3954,'7202bf1e34575f5992a2dd9807efc317','2025-02-04 10:03:44'),(3955,'899f131184f9d48cbee8c2d331877742','2025-02-04 10:03:44'),(3956,'f01ad0a90eaf0846d15df5692eece914','2025-02-04 10:03:44'),(3957,'ad26fe96bc53fd0f9a2ea13a9261600a','2025-02-04 10:03:44'),(3958,'6dd3ac6ee475bd1049f2d40618a5582e','2025-02-04 10:03:44'),(3959,'59bedd98b9b2a703f2345d71ed4785aa','2025-02-04 10:03:44'),(3960,'04e0099c5199994c18362bcb16d33d54','2025-02-04 10:03:44'),(3961,'f8e7c44517783762a79d49178cb051a8','2025-02-04 10:03:44'),(3962,'2df3f8d1c208489230a654beb8793805','2025-02-04 10:03:44'),(3963,'963bc2b52211f2eada939f208a668965','2025-02-04 10:03:44'),(3964,'b2cb64e44fb6e084c74ed42950087b1b','2025-02-04 10:03:44'),(3965,'49aee20169487dca16c1562e187522a1','2025-02-04 10:03:44'),(3966,'ddabb1596cab7b2e283895d0a0f0b415','2025-02-04 10:03:44'),(3967,'1118981ef0b627189a382f934cc2b846','2025-02-04 10:03:44'),(3968,'c2d8264820cf9c06ad78264336223d74','2025-02-04 10:03:44'),(3969,'97551de09c593c5dededf692631a572e','2025-02-04 10:03:44'),(3970,'846430176da16cc72faafef25ad1c2e4','2025-02-04 10:03:44'),(3971,'797ee92db695c4ec6372a5eaeaa5c539','2025-02-04 10:03:44'),(3972,'0ddb3275acf5f3e86ed97bb065cf221d','2025-02-04 10:03:45'),(3973,'9353d43cf5b183bd1ffcdf8d450d3a51','2025-02-04 10:03:45'),(3974,'da9cd80881175796a75b6b8da248f44c','2025-02-04 10:03:45'),(3975,'9324f23c7a7ee219a645c56805038fb0','2025-02-04 10:03:45'),(3976,'a4d2cb3932d863fec4813431e1271c27','2025-02-04 10:03:45'),(3977,'093c7986e2343c97c9484e48a4ce1ee7','2025-02-04 10:03:45'),(3978,'dec71c578ad96902efeafa6189d24a47','2025-02-04 10:03:45'),(3979,'0be10d00e520047fd191c9213641383a','2025-02-04 10:03:45'),(3980,'cb994d178c2da84adbb4e00fd10508c9','2025-02-04 10:03:45'),(3981,'1e6658aca0a675d2fc9ecc47a29c85a2','2025-02-04 10:03:45'),(3982,'b65d845026041818c6331d6dad8968e7','2025-02-04 10:03:45'),(3983,'4b76bbe4ca9a8b1cb902cdb2d437cf97','2025-02-04 10:03:45'),(3984,'28666d4b56b1f80b72191a4446bbffb9','2025-02-04 10:03:45'),(3985,'7d7978069b4b72b12b8a823802f5f5df','2025-02-04 10:03:45'),(3986,'ce3443708409956ae0981ce37698c5e5','2025-02-04 10:03:45'),(3987,'65bcc6e5cadbb2af9d7fcac0a365200a','2025-02-04 10:03:45'),(3988,'ce9442bbafd08c982b7ef90f67dae8e5','2025-02-04 10:03:45'),(3989,'c97c8d9b7d13d71dea687f86074d9675','2025-02-04 10:03:45'),(3990,'6d1f8a0567f1ec92351d4f49cb185dcf','2025-02-04 10:03:45'),(3991,'00a936f8533ca19789cf38d74d6dea55','2025-02-04 10:03:45'),(3992,'902c1e781c4d47a6f3d25994f2b42811','2025-02-04 10:03:45'),(3993,'a2ffb15c96f5238a8e461dc8b0ad580f','2025-02-04 10:03:45'),(3994,'89014247d8de1ed8c630d7a53586f085','2025-02-04 10:03:45'),(3995,'dce63b25ec0d55bd77abdc241e72473d','2025-02-04 10:03:45'),(3996,'5b2506fcc0b7a5b30e00b7a4ddd78ff7','2025-02-04 10:03:45'),(3997,'42642110c61a872c60467d44080ec2c7','2025-02-04 10:03:45'),(3998,'1b9b16746bebb42328032793cc0e4507','2025-02-04 10:03:45'),(3999,'532c51e4d2f3b9df37a9a8b2a8407d43','2025-02-04 10:03:45'),(4000,'d0011ec7c84a6d0a1d04988171acbe4d','2025-02-04 10:03:45'),(4001,'f0b61e96288de2f248dfd4d50ab5ace1','2025-02-04 10:03:45'),(4002,'32caeae1adcafe11fe6c1004c6012c19','2025-02-04 10:03:45'),(4003,'7be9fda5705a239e837bf62f843fc501','2025-02-04 10:03:45'),(4004,'72d6b87d41c9029f4d5edcabb5843256','2025-02-04 10:03:45'),(4005,'83bd29d9a40836d8e920876f6e100358','2025-02-04 10:03:45'),(4006,'4ba00e9e382451b744eb02493bfe6911','2025-02-04 10:03:45'),(4007,'91b349aaed750c595f69ca780ad85b8a','2025-02-04 10:03:45'),(4008,'6abad69c0aaadad88a0a21f3795ba35b','2025-02-04 10:03:46'),(4009,'da68f6480bfa880466525d5fed19de52','2025-02-04 10:03:46'),(4010,'30807d645f05d7bb235038d0c25542e8','2025-02-04 10:03:46'),(4011,'bd6b8b535abbe1932b2bf1e95ee6dbcb','2025-02-04 10:03:46'),(4012,'ebad3d02cb8a664f79170545a13c1f6b','2025-02-04 10:03:46'),(4013,'2a67b30a065e85eab30606c292821f6b','2025-02-04 10:03:46'),(4014,'4852a6a2176139516fb289c6adff2e34','2025-02-04 10:03:46'),(4015,'a40b1eebd54cc0b2d46eb2cba6154f1b','2025-02-04 10:03:46'),(4016,'e353861f66adfd4b4858bed4ce4bb758','2025-02-04 10:03:46'),(4017,'e901499f547685b935bfd49d4cf31b2d','2025-02-04 10:03:46'),(4018,'36c8f1cc974ffceb2857407f255e4199','2025-02-04 10:03:46'),(4019,'3b878a5fe2d74da1a938988601206d5f','2025-02-04 10:03:46'),(4020,'3e5b47e94a90625c8f1ab073f8b6a35c','2025-02-04 10:03:46'),(4021,'cae9c7272ab69c9b70b2b9445f499ad2','2025-02-04 10:03:46'),(4022,'5e0278e9c6d7b75c0ecdcbc3ad1034a8','2025-02-04 10:03:46'),(4023,'392777e905adeed8c00ffacb3a560248','2025-02-04 10:03:46'),(4024,'ff7aff03e67dc86c5d3bfa0f71a43d26','2025-02-04 10:03:46'),(4025,'d95516966cff51ce158fd8577d40089c','2025-02-04 10:03:46'),(4026,'34fc2b9b6918eb42bb1812b3ffcd8f80','2025-02-04 10:03:46'),(4027,'289a67c3c848eca2a9dec3ad215beb44','2025-02-04 10:03:46'),(4028,'cb8c0f44ddf9860f5792681e28f11d72','2025-02-04 10:03:46'),(4029,'45d51a5a4d782ebb945c3da2733a73d2','2025-02-04 10:03:46'),(4030,'f628187d4958eea548bf88cb2aec50d3','2025-02-04 10:03:46'),(4031,'6c165403ccf0ed405a65e3b7a6ee71b8','2025-02-04 10:03:46'),(4032,'6d4365e52421072284092e96fdca5d7a','2025-02-04 10:03:46'),(4033,'ceef19ac434f95afac98008d005b0101','2025-02-04 10:03:46'),(4034,'4ac292a419bf2e9bf8d78db1f544163c','2025-02-04 10:03:46'),(4035,'298bde33d17546457fdb772ac14fe0a0','2025-02-04 10:03:46'),(4036,'2a3f85a1f55a0898f4d6e50a2584c38f','2025-02-04 10:03:46'),(4037,'10cdefbc125370ba7deff671ff33e693','2025-02-04 10:03:46'),(4038,'f33d67be1ab4a554e2a78ed127d4a059','2025-02-04 10:03:46'),(4039,'3013149a7cc226729618ca0cf31fd24f','2025-02-04 10:03:46'),(4040,'c42237220fd49d31761242dd0e8c8e89','2025-02-04 10:03:46'),(4041,'420b5d16f4a3aaec2eb0954b41cb408a','2025-02-04 10:03:46'),(4042,'89e814f5cdcbdf6ed65529c32beed665','2025-02-04 10:03:46'),(4043,'e12fed7df9b486ad7bbbcb33a86a60b4','2025-02-04 10:03:47'),(4044,'ec84ac1a5c4d6630751e40d74d8f274f','2025-02-04 10:03:47'),(4045,'8e0a3563f86f525b8cf38fc43b294dc7','2025-02-04 10:03:47'),(4046,'5216e0973e0f10108a046d06997cf061','2025-02-04 10:03:47'),(4047,'333c3f6119ae66c7fac1602df20ea669','2025-02-04 10:03:47'),(4048,'5ae299973c30afcb84b6aa4769384a6d','2025-02-04 10:03:47'),(4049,'dec6eda1ea7d32fe80123c390b581fb5','2025-02-04 10:03:47'),(4050,'a69c98ff29b7a227cd5c9acc95162f78','2025-02-04 10:03:47'),(4051,'5376b04735ce5e22d9cff7c1725e5a19','2025-02-04 10:03:47'),(4052,'10025deeab175a770b3a0e66d5db1b1b','2025-02-04 10:03:47'),(4053,'ee46919ab7690ccf7cf725f6b8ae8ad3','2025-02-04 10:03:47'),(4054,'0757020b2561f2d072fb35b4578a7b83','2025-02-04 10:03:47'),(4055,'7f6134e50a9fc34e740719bee06ebb98','2025-02-04 10:03:47'),(4056,'5c0784bcb3d12eba4772ca028bfde870','2025-02-04 10:03:47'),(4057,'089ca493fe26cfd393a42e09fbbf0977','2025-02-04 10:03:47'),(4058,'0310554c265e342545fff0bb87af9395','2025-02-04 10:03:47'),(4059,'c902f93c24c629a7440fafc06c7382eb','2025-02-04 10:03:47'),(4060,'519b955b0e08656de4a87df186762e1f','2025-02-04 10:03:47'),(4061,'a2b686c1b415490d98e6b72156d32889','2025-02-04 10:03:47'),(4062,'4d1a91da101dd58c55bb228f2731f81d','2025-02-04 10:03:47'),(4063,'e04388019a5bc4ad8691d8f4d26e679f','2025-02-04 10:03:47'),(4064,'8236aa857ab272502c7ec52b46a3b47a','2025-02-04 10:03:47'),(4065,'995f594a6ce47a8f9381cbeda16a2edd','2025-02-04 10:03:47'),(4066,'fe71298036bc721d7e72f9dd77b44439','2025-02-04 10:03:47'),(4067,'46f11a7dbc5574c12728315595d5bc55','2025-02-04 10:03:47'),(4068,'485f5a47d5071a00f474d689cc0519f5','2025-02-04 10:03:47'),(4069,'ccb1106cc33bac09a657da3617477654','2025-02-04 10:03:47'),(4070,'f4373850b1a1ebd04ec6d5dbc312265b','2025-02-04 10:03:47'),(4071,'07b9de2f1240c3dbc47eb80eddf7a48b','2025-02-04 10:03:47'),(4072,'f9c0a5f7de6ca5378977e698ac430637','2025-02-04 10:03:47'),(4073,'c92c5d0180ecb52560866a36067952c1','2025-02-04 10:03:47'),(4074,'434385aea88211de10d22d8da9b0ed07','2025-02-04 10:03:47'),(4075,'4f4cf0cf1b14cba202d52bbe777cfdc6','2025-02-04 10:03:47'),(4076,'50ed91ba573293bd922270a56c4b1909','2025-02-04 10:03:47'),(4077,'004639eb126dc6a7fde0542938cb3919','2025-02-04 10:03:47'),(4078,'d349beaf102adeaf357d0065823d3b77','2025-02-04 10:03:47'),(4079,'403de1185c952d8f8d243479f7845f06','2025-02-04 10:03:47'),(4080,'b886f9c1d13b416928d6c057540e692d','2025-02-04 10:03:47'),(4081,'763068cc4070ae78e51f065ad4d4bf8e','2025-02-04 10:03:47'),(4082,'3c282ebcc03a6f5653991f84d3cf6be1','2025-02-04 10:03:48'),(4083,'6e08d95d61c642d925ba446cac777988','2025-02-04 10:03:48'),(4084,'cbe6ee585eba4a7b39d51c81b7cdd691','2025-02-04 10:03:48'),(4085,'3834182f5966cd96f98500b36f38535f','2025-02-04 10:03:48'),(4086,'1f8c949d19f26a4ea5c0fd54777b9bff','2025-02-04 10:03:48'),(4087,'b81591df692ab52710039cf008132481','2025-02-04 10:03:48'),(4088,'0c6b640a8a7f6e1b651e2a118b043385','2025-02-04 10:03:48'),(4089,'cc0d9ddbb7a3d61e3230402130cc9c2f','2025-02-04 10:03:48'),(4090,'eaa95b82f8ad25e93b04ed2f70db1321','2025-02-04 10:03:48'),(4091,'3aabb1ee4d29c30a09eb8c1afab85c76','2025-02-04 10:03:48'),(4092,'d6fd56f669e32bf500b877f5ddc46aca','2025-02-04 10:03:48'),(4093,'071b006f430749dc9a48c8c795b4cf19','2025-02-04 10:03:48'),(4094,'f0f5af22bba4a08bad91c299e768f886','2025-02-04 10:03:48'),(4095,'a5159eff93c13be53d66a47246c2bac2','2025-02-04 10:03:48'),(4096,'b5b73563c8627241cad73a86b762cae3','2025-02-04 10:03:48'),(4097,'29d04ed2c45b07daa721298891e2d831','2025-02-04 10:03:48'),(4098,'2b2744bdb3d07fc26e59ba1998c2f639','2025-02-04 10:03:48'),(4099,'38a142373df606f2364ac70b2df723c3','2025-02-04 10:03:48'),(4100,'dc9a8d6b8023a9bc4dd00caa714ca54d','2025-02-04 10:03:48'),(4101,'b3bab645a8dbabf119d85f2531d3d37c','2025-02-04 10:03:48'),(4102,'e5edce877067be7eb491dc158a4ed2f4','2025-02-04 10:03:48'),(4103,'619b3b0bd466a8130cccfcc953a496c9','2025-02-04 10:03:48'),(4104,'c9db7140e7edb1b5209fecb94a835c1a','2025-02-04 10:03:48'),(4105,'e127f2805d82a282ec5d8399e6a9052e','2025-02-04 10:03:48'),(4106,'44b92e038aa2ab10ac303eb7a154c0be','2025-02-04 10:03:48'),(4107,'77fa34ef7b396c8c8166a3943fdc6014','2025-02-04 10:03:48'),(4108,'4cc2fb481826a79a84aadef17e63805f','2025-02-04 10:03:48'),(4109,'edd0ae63fa76324009b1de2d19448bdb','2025-02-04 10:03:48'),(4110,'f822e89d88f9ddd3cffc4832ce4e2685','2025-02-04 10:03:48'),(4111,'0eef8e6f5bc1178b5dd1ff20d842f6de','2025-02-04 10:03:48'),(4112,'765491b3fed28fa30992c849241783ec','2025-02-04 10:03:48'),(4113,'ce085bf2751cce9a096ffdee22835d77','2025-02-04 10:03:48'),(4114,'3ffe4047f1328435832f653d94bf5912','2025-02-04 10:03:48'),(4115,'c513e36d9f373df856c51cb3e99242f3','2025-02-04 10:03:48'),(4116,'99a767ac6b47c0841649af82f5f7d330','2025-02-04 10:03:48'),(4117,'d6f8dc319612a540d70016e0972aa369','2025-02-04 10:03:48'),(4118,'d9844d8378266fe8b67ecd3cc419e7a6','2025-02-04 10:03:48'),(4119,'993f26d2a010e69db0f0f613c246b0fc','2025-02-04 10:03:48'),(4120,'acb74b1d95ffa1d51757fafceaa992f0','2025-02-04 10:03:48'),(4121,'c7b7c021e5c74ca04c8616f73dfc1874','2025-02-04 10:03:48'),(4122,'bf6f060d188916aa1ed637ff33dcb26b','2025-02-04 10:03:49'),(4123,'5b8dcd147ecb1dc1c1c4db541927d2c9','2025-02-04 10:03:49'),(4124,'30c78c9738cbcf59739b5902401f6423','2025-02-04 10:03:49'),(4125,'ffb2869de5d01c8592915f0ef104eb64','2025-02-04 10:03:49'),(4126,'4d5f56963e583bcc263d24c1c526f488','2025-02-04 10:03:49'),(4127,'168f23720f055421cddbf63ae4522135','2025-02-04 10:03:49'),(4128,'0a89495a971810cfa885f32dbb1a7bb0','2025-02-04 10:03:49'),(4129,'535397e933c2d9e5059d7c058ad4c3b5','2025-02-04 10:03:49'),(4130,'eeecffbeaace8ebc2c36c444923754c8','2025-02-04 10:03:49'),(4131,'51ea442d9f7805473b0c000f7cfdb826','2025-02-04 10:03:49'),(4132,'5b858df2be99c9ec4fdb5902bbb52e83','2025-02-04 10:03:49'),(4133,'3f9f788b82cb108d86d323a0fde999b1','2025-02-04 10:03:49'),(4134,'f2f6e8a3980974876c61f88597aa12c1','2025-02-04 10:03:49'),(4135,'2b5a19a60a01b7b9f92c6e0bf0f8a5a0','2025-02-04 10:03:49'),(4136,'34032188f1f511825aa97af0c19c74b3','2025-02-04 10:03:49'),(4137,'fae5e0b8d85eaad16b3c6dfd9b9c40c2','2025-02-04 10:03:49'),(4138,'3fbfb18aba9bf76407cb921dae2d9dc7','2025-02-04 10:03:49'),(4139,'8020bded88351555bfe9018893a85eaf','2025-02-04 10:03:49'),(4140,'fe00e8ad85197ca8171aaef8a1e897bf','2025-02-04 10:03:49'),(4141,'9f72cf98ddf4e111e08694d0dc3a6a00','2025-02-04 10:03:49'),(4142,'de191543d85aba903dbae3b0b848feeb','2025-02-04 10:03:49'),(4143,'4224f2c0ba0591bff89679de7ffffeb8','2025-02-04 10:03:49'),(4144,'f197c5eb23a635ade1748ef2c8253427','2025-02-04 10:03:49'),(4145,'f442891a66678d171da009072a3a837e','2025-02-04 10:03:49'),(4146,'e299fb5076ed797ced838b083dbddb71','2025-02-04 10:03:49'),(4147,'38425926e8cbf4a604ed16d3364d851b','2025-02-04 10:03:49'),(4148,'347ad088d32f8f6e02c8043528825ed8','2025-02-04 10:03:49'),(4149,'ede465ffd77e0e0e739473bcc7890f2c','2025-02-04 10:03:49'),(4150,'cd13bc0cd031da586ba845a28e6758f4','2025-02-04 10:03:49'),(4151,'907a8156f870b86ca706f35141b6990b','2025-02-04 10:03:49'),(4152,'e24238222429909b9fae493140f79b35','2025-02-04 10:03:49'),(4153,'62cf942d8b61d5fe9c67459c67973aa6','2025-02-04 10:03:49'),(4154,'af241bf16a3f7978fae21bfe983929f7','2025-02-04 10:03:49'),(4155,'182f2e32e76135adbc3850ccdb96a26b','2025-02-04 10:03:49'),(4156,'9365ae9d9534b8a94aefe7dca737eb55','2025-02-04 10:03:49'),(4157,'b640c863e3456f18ebbb50df22dca791','2025-02-04 10:03:49'),(4158,'cf1b62f01d3a73eedb2fe04fd1cd52b4','2025-02-04 10:03:50'),(4159,'e1f62df54d09b6a64e9fd26bae79bfea','2025-02-04 10:03:50'),(4160,'a9e89cfe0a5de443990ae81167cf07f6','2025-02-04 10:03:50'),(4161,'39ec52a523807a3d0d146d2860dcb0cc','2025-02-04 10:03:50'),(4162,'ea4fcc9a74a0dad5c397e794fc0412c1','2025-02-04 10:03:50'),(4163,'10570a6daffea1d2083e09c57b21b0a9','2025-02-04 10:03:50'),(4164,'78b3d295b61f2536b60a7dc9895a0d9e','2025-02-04 10:03:50'),(4165,'5d386ff307b4da7d257b4da50dca5e7a','2025-02-04 10:03:50'),(4166,'9021578e36b693ad0303c8c986862c18','2025-02-04 10:03:50'),(4167,'0e1bd9f6685bad55e107abee71b3ecf7','2025-02-04 10:03:50'),(4168,'4a23e5a7a92faf5a2ffe18ba0b109028','2025-02-04 10:03:50'),(4169,'320b228126b298b190a772cdbc83d5a5','2025-02-04 10:03:50'),(4170,'c6cf396aaa5e7a70810f84e1ea7ceabb','2025-02-04 10:03:50'),(4171,'e5b262a301c22ebb96df6573d69b795e','2025-02-04 10:03:50'),(4172,'230733b0278eb8b76a4d55a4f8afb4e8','2025-02-04 10:03:50'),(4173,'163e530b611ae8047234c54866c8073d','2025-02-04 10:03:50'),(4174,'451bda4b50e8d2aab86b63ecc1520184','2025-02-04 10:03:50'),(4175,'0509e573936e3e18c88e0431dfab89df','2025-02-04 10:03:50'),(4176,'c7fb00ab91d3079b0b4203f6854c535e','2025-02-04 10:03:50'),(4177,'ed454a59be214fd806278065c376a8dc','2025-02-04 10:03:50'),(4178,'9729919a8856466657aff1ba5a0aec63','2025-02-04 10:03:50'),(4179,'7f3ba4f9f8ced233fbefcd513fae0f4f','2025-02-04 10:03:50'),(4180,'3fc2987b4dc7e43f00d9be00dbeacc85','2025-02-04 10:03:50'),(4181,'2b16bfd8ae24981f691aad45e1bd5c9f','2025-02-04 10:03:50'),(4182,'cd8ef35956cf80700c0bbd8506750213','2025-02-04 10:03:50'),(4183,'d846f51d610e7e5f2a76282158defcf8','2025-02-04 10:03:50'),(4184,'4501ba4e3c15aecb3284d4c64dbe7919','2025-02-04 10:03:50'),(4185,'d966972ea7644752e4dc0d80b03fe075','2025-02-04 10:03:50'),(4186,'ea715a44a3b94983168155d34f315ba4','2025-02-04 10:03:50'),(4187,'5e7776419fa1551ed3b7d2fdb7ba23ab','2025-02-04 10:03:50'),(4188,'db53031128fb5e4c1b78a7c613d09023','2025-02-04 10:03:50'),(4189,'09b610bbe7ebcb0ba01ead8ce77d3ddd','2025-02-04 10:03:50'),(4190,'3099dfe628d9452ab60368f32fa0a847','2025-02-04 10:03:50'),(4191,'e09cdcb2f72ee2adbb9ec3f38c22a1d4','2025-02-04 10:03:50'),(4192,'d3c5e68d0775d3e228fa858095cc1a58','2025-02-04 10:03:50'),(4193,'3da1f997400b6a62cc76e86724109d0d','2025-02-04 10:03:50'),(4194,'90c1c9475635bf7030e765df04322da1','2025-02-04 10:03:50'),(4195,'0c0d5747f80971810010ad660a377d1c','2025-02-04 10:03:50'),(4196,'53a58afba24b6e554f8b7bffe1154e54','2025-02-04 10:03:50'),(4197,'1f54782ee585a9ea903d94e3a27256e7','2025-02-04 10:03:51'),(4198,'a8da927dedcb44acaaf56281f06d7391','2025-02-04 10:03:51'),(4199,'e5090905edd4d7444e8e936fb169b0b4','2025-02-04 10:03:51'),(4200,'ab540481cb07f4a29210a98cc5d5c8df','2025-02-04 10:03:51'),(4201,'1c548caa974e834f29ecc51c7182a05b','2025-02-04 10:03:51'),(4202,'3feade43945af2156b50774ae01f8d00','2025-02-04 10:03:51'),(4203,'6d9dbb28f4203132520fc369a47c0fbd','2025-02-04 10:03:51'),(4204,'25857a6f535613782e306944c3c7109f','2025-02-04 10:03:51'),(4205,'37663ed1d9d514355f59356d5702cb50','2025-02-04 10:03:51'),(4206,'f76eed97c167de6d8317985fe3173655','2025-02-04 10:03:51'),(4207,'2a6c9708bde115725896dc18b7b3e33e','2025-02-04 10:03:51'),(4208,'cfb5752eb936b737195c9fafc83d75b5','2025-02-04 10:03:51'),(4209,'bd065dee9d0a9210c6e3bb9cfb55f63a','2025-02-04 10:03:51'),(4210,'4a0a5bc64872dd925d899015e6c9844d','2025-02-04 10:03:51'),(4211,'080707edbbf7b0f6ac2f6301f7613670','2025-02-04 10:03:51'),(4212,'7591caf4dd18126ff68e69525b09bd9f','2025-02-04 10:03:51'),(4213,'fd993f5c56342d71082cd5dffeeb873b','2025-02-04 10:03:51'),(4214,'895b29ca810af6407a43eee838c050fc','2025-02-04 10:03:51'),(4215,'c638864dcd32e2f0408481d85eebc052','2025-02-04 10:03:51'),(4216,'fc33669d84352d8b50f550d53431b93a','2025-02-04 10:03:51'),(4217,'5f5289b1b07f421af98acedd3fca2167','2025-02-04 10:03:51'),(4218,'4cc2e5346de73bc049c7026c6fc5295e','2025-02-04 10:03:51'),(4219,'ffea841409e6aa9729c68ab7d608df22','2025-02-04 10:03:51'),(4220,'faec5655ba8d84e4f4849977bff986ae','2025-02-04 10:03:51'),(4221,'0bd52e64e180711c43b38a29f4f5c0c7','2025-02-04 10:03:51'),(4222,'3c7366f83c13fceb82d831485a26ad24','2025-02-04 10:03:51'),(4223,'f2000cbc7ec0034a91c0a78052ed5896','2025-02-04 10:03:51'),(4224,'8b0c62d10e2f95b4fd9c755df622f874','2025-02-04 10:03:51'),(4225,'8049794dff0b91e7c8b60b4585decf7b','2025-02-04 10:03:51'),(4226,'12137dd22f31b7078bc62b9ca910c2ea','2025-02-04 10:03:51'),(4227,'21e6fd5733865618e25895e1e4918d6b','2025-02-04 10:03:51'),(4228,'ab681c07ccb5848b36d28adba8e94d67','2025-02-04 10:03:51'),(4229,'cd80da5d6d9eb3024015aecf9f4c715d','2025-02-04 10:03:51'),(4230,'e5679d5af4b7a94dcf6a21385ffc6351','2025-02-04 10:03:51'),(4231,'4f987b21b6a01c043f968924c7282085','2025-02-04 10:03:51'),(4232,'ead76fca1f3aac41cfa8c64d1296e6e7','2025-02-04 10:03:51'),(4233,'778b009eacc9ceee704e16e76813c765','2025-02-04 10:03:52'),(4234,'0fed476a8d7855ceb92e8ba3d527e6c3','2025-02-04 10:03:52'),(4235,'3c9ebd476431d8bdd73434a09f764235','2025-02-04 10:03:52'),(4236,'c43c340deb7255839db9710302c31058','2025-02-04 10:03:52'),(4237,'df3a6a096982e4e168ab83a49a9ed62e','2025-02-04 10:03:52'),(4238,'25ebca7f101bf0d0c8b7885152fc1af7','2025-02-04 10:03:52'),(4239,'4c0cf3be0edb3462dd3f717d535dab6b','2025-02-04 10:03:52'),(4240,'fa8be71e9d5371a4cb58aa6248dcbe6c','2025-02-04 10:03:52'),(4241,'b91c0e0b9f40c0e3df9407868e80826e','2025-02-04 10:03:52'),(4242,'eed6b97b5ec36502c94b3f4a95e3ab4d','2025-02-04 10:03:52'),(4243,'eff8bc7b7c0b054cf31d5de9874872a8','2025-02-04 10:03:52'),(4244,'ce3b94296d540d40393774d5bc6d9e2e','2025-02-04 10:03:52'),(4245,'378bb57c372ad1a78021fa0988390450','2025-02-04 10:03:52'),(4246,'ae491a00545bfc181b73dc11fb59cdfa','2025-02-04 10:03:52'),(4247,'8c27010616b6c7408d256ac3e9dd1f0f','2025-02-04 10:03:52'),(4248,'5f086a38d09e2a019ecf5f72d774af83','2025-02-04 10:03:52'),(4249,'341ce436f5e623db33ccec3f004f0aff','2025-02-04 10:03:52'),(4250,'b596f28c38bb9b1af53adfee875926a4','2025-02-04 10:03:52'),(4251,'c7d70577ebee0b17927c85980fbc8e37','2025-02-04 10:03:52'),(4252,'08e3b8e765d43339da9cf3fffa9dcc1e','2025-02-04 10:03:52'),(4253,'8701914b04ab58c279ce5b7b9b716c78','2025-02-04 10:03:52'),(4254,'7ff7b2741959949e2fbdd102780f58f0','2025-02-04 10:03:52'),(4255,'45fa384e2c947b7da64010cc288e4a51','2025-02-04 10:03:52'),(4256,'86d32c7c4f560d14ad150b7b7bcb4fff','2025-02-04 10:03:52'),(4257,'776cf7c0a78fbfadb344edd04fa4c1a4','2025-02-04 10:03:52'),(4258,'8df219a3e9d0875f1f9ead1cb2400c43','2025-02-04 10:03:52'),(4259,'48e2a22456ba5be738d7f6db91dc8fc8','2025-02-04 10:03:52'),(4260,'508ce5106402976f29f32412b1a10ca4','2025-02-04 10:03:52'),(4261,'bad5968a12597ceeb05e138a66cd9006','2025-02-04 10:03:52'),(4262,'3a2e779ef368f724987f7f4afce302dc','2025-02-04 10:03:52'),(4263,'13966e0a1381f413a8fac121ea523a4d','2025-02-04 10:03:52'),(4264,'edd7ec0e05d9282f34c3df64a7abcf91','2025-02-04 10:03:52'),(4265,'225b8628a78370e968be8c1933a91e17','2025-02-04 10:03:52'),(4266,'780937d8574b55862b340175107e418b','2025-02-04 10:03:52'),(4267,'48b16839ca63e82d16d2d559f80aa252','2025-02-04 10:03:52'),(4268,'ed8b6a44bb008dab4444de5711fcd73e','2025-02-04 10:03:53'),(4269,'db9881b28fd155be718f568beff472eb','2025-02-04 10:03:53'),(4270,'c9e8872df196e6b3d47203b00bd23d89','2025-02-04 10:03:53'),(4271,'ef2d7d6fc2ada21a3519737d82b14936','2025-02-04 10:03:53'),(4272,'546456fc9729120a2f569d0d2c91b137','2025-02-04 10:03:53'),(4273,'01df0a4dddcbf88ce6bce50087ff9fc0','2025-02-04 10:03:53'),(4274,'066cee1be9547df6e7fb31f2084449b9','2025-02-04 10:03:53'),(4275,'8a48dcb4276bae2a14f463e5f399a3be','2025-02-04 10:03:53'),(4276,'588729f589eb172a41cb9d3d98529f65','2025-02-04 10:03:53'),(4277,'d48e0afdd8aba012cff9a2fa7255c4a2','2025-02-04 10:03:53'),(4278,'cb4c0e8b2dd05c329da31cf8c1bccf64','2025-02-04 10:03:53'),(4279,'a7f22e5c8248248b32d225c35ccc358f','2025-02-04 10:03:53'),(4280,'ee4e66e06677a458cb39f450cc68ef64','2025-02-04 10:03:53'),(4281,'eeecd69b92c876727e1044e9d43a7b63','2025-02-04 10:03:53'),(4282,'707aa90113fbbc3125d94f6d665c48ef','2025-02-04 10:03:53'),(4283,'6972844ac12002db17f2be760002ec9e','2025-02-04 10:03:53'),(4284,'61a72ec6dda4537f2bf7b057e108d934','2025-02-04 10:03:53'),(4285,'0d026cb248ff926e803170ee376395b9','2025-02-04 10:03:53'),(4286,'79f5d72ea4d9620140fefdfe7ca2ae83','2025-02-04 10:03:53'),(4287,'5e0f9a0a362a2f9f6f75a55902927c7c','2025-02-04 10:03:53'),(4288,'15a6137eacefc52ecf7b4c18bd074b52','2025-02-04 10:03:53'),(4289,'c5d6e439b5e038b96b69013a8c56ee5d','2025-02-04 10:03:53'),(4290,'80da949bc2ae38c6ca31fb1660471010','2025-02-04 10:03:53'),(4291,'564523f3bf346a3d5d4e79f97cf63030','2025-02-04 10:03:53'),(4292,'62693761dbbbff6a68d1bc0fc56bceac','2025-02-04 10:03:53'),(4293,'98757b8da12e82824fe7dd8b366c0161','2025-02-04 10:03:53'),(4294,'317db2475884e668513f28c20a78270f','2025-02-04 10:03:53'),(4295,'aa44318349be112df157c3f9654c0f2e','2025-02-04 10:03:53'),(4296,'f079ad1330941bea2cc6a42dc96fbdd5','2025-02-04 10:03:53'),(4297,'29a7769a5c524bd587edeba555204fc6','2025-02-04 10:03:53'),(4298,'a8d49a1181dcbee88a6ea4c6b9d70f01','2025-02-04 10:03:53'),(4299,'6fe197ff6bccaf828996abeca1b19ab5','2025-02-04 10:03:53'),(4300,'7b2981d14ffce520f446abb2a700861a','2025-02-04 10:03:53'),(4301,'6eb7cb7e20ddd494c047880b5c45fc8e','2025-02-04 10:03:53'),(4302,'c9b02c556fd0677c43cc5b9a2ad60945','2025-02-04 10:03:53'),(4303,'12415ae9102a43ac4a4d0f897e4d6110','2025-02-04 10:03:53'),(4304,'4bab3eb32433b648b4e527887d48f2a8','2025-02-04 10:03:53'),(4305,'b4e2d8a4feb674974aeac3f36b29daa0','2025-02-04 10:03:53'),(4306,'1ce3fe538ec9423ac40a8fced36e0451','2025-02-04 10:03:53'),(4307,'6ad860db930b7f4c68497cc1a41a1fb3','2025-02-04 10:03:54'),(4308,'e290fec0ac551947c81d1460ca05bf0e','2025-02-04 10:03:54'),(4309,'51d8b235e46263d0b2745b3d258abbaf','2025-02-04 10:03:54'),(4310,'bfa9b0d202e1b7de7bec30f7f058a4e4','2025-02-04 10:03:54'),(4311,'a3524bb1763de235cd50c972015d4afa','2025-02-04 10:03:54'),(4312,'70607b5b1011e393d677dbeb90534bd0','2025-02-04 10:03:54'),(4313,'7c03852e326fbe1f8ebd13db2602b084','2025-02-04 10:03:54'),(4314,'5f2b9dc8b24f40f4780fcf4adfd3650f','2025-02-04 10:03:54'),(4315,'d731b71109c036233d80dba6b4bfce40','2025-02-04 10:03:54'),(4316,'aaed74beda424eb2714ae18265665c2c','2025-02-04 10:03:54'),(4317,'c354a8357fbf942b83ce910edc28d584','2025-02-04 10:03:54'),(4318,'42ec633eb24a639ff00d31c0b996d4a4','2025-02-04 10:03:54'),(4319,'6bf12cfe0e214fba77b5220f5e909299','2025-02-04 10:03:54'),(4320,'e542d51bd5924d1897e75fe4a7f896be','2025-02-04 10:03:54'),(4321,'2528f366054fc17cdd07b253086f84c1','2025-02-04 10:03:54'),(4322,'a88227b738b9c52058736d5b6f007e5d','2025-02-04 10:03:54'),(4323,'f231836448b8c1173b08751deb60fe02','2025-02-04 10:03:54'),(4324,'1d34c9750dbfd680a0b08d6271a7f8d5','2025-02-04 10:03:54'),(4325,'9e4de99674639a318afd659d761ad8d9','2025-02-04 10:03:54'),(4326,'a48a727e3dab5e08da53c67c5f0760ab','2025-02-04 10:03:54'),(4327,'9b5241045a165784a6d165c26f75747f','2025-02-04 10:03:54'),(4328,'a6f92a4a8af8d187fc7977e9e0a77ec5','2025-02-04 10:03:54'),(4329,'901192dee3a8d0dff8dc4993f8d0a763','2025-02-04 10:03:54'),(4330,'0338f2125e9bc53f10d9869b887167ac','2025-02-04 10:03:54'),(4331,'2a16a548b8bb288e9a8e3816ebe1d388','2025-02-04 10:03:54'),(4332,'c42718e6caef45dd857c8d64805decf8','2025-02-04 10:03:54'),(4333,'d537d52423d32c80e7cb8e26328c28ae','2025-02-04 10:03:54'),(4334,'9f9741e5ead45c89dc407030f47ac4e7','2025-02-04 10:03:54'),(4335,'2590536d9780c0117ac55adf14306a35','2025-02-04 10:03:54'),(4336,'5a964ebb8ca031399ffc9ea35b4e4aae','2025-02-04 10:03:54'),(4337,'983380c7cb14294032094c9802e08a2f','2025-02-04 10:03:54'),(4338,'67b6d58ef746ae4fcd0b827971088b44','2025-02-04 10:03:54'),(4339,'d96484980c8b57925ef49640b01c40bb','2025-02-04 10:03:54'),(4340,'9255a146a5932823db0cdab5daad4a76','2025-02-04 10:03:55'),(4341,'e78df775fb3c66d94900e0e28e7882e6','2025-02-04 10:03:55'),(4342,'4c714d425dcbdfcc4b7969594bcf7244','2025-02-04 10:03:55'),(4343,'8727e1adc3b65579ac2804499d455c1e','2025-02-04 10:03:55'),(4344,'b493d2049625e535f71d99273db9df73','2025-02-04 10:03:55'),(4345,'9d7175609eb750ea688b594e1fd536f8','2025-02-04 10:03:55'),(4346,'9e812f195cba6b78f8e2c5b14129b699','2025-02-04 10:03:55'),(4347,'f4c42aebb0f932d026217c8611425ea9','2025-02-04 10:03:55'),(4348,'1b334db5c6d5479067cfce878f27652c','2025-02-04 10:03:55'),(4349,'1e8d0be04a04cec1ae6ddf337852bf4c','2025-02-04 10:03:55'),(4350,'71de1ec965b282c17be6f482250e3893','2025-02-04 10:03:55'),(4351,'affd8c51c7f703c9e13414e42e1b0c87','2025-02-04 10:03:55'),(4352,'df5b1d999341311549d4d8df405b0bbe','2025-02-04 10:03:55'),(4353,'0417c596ee0bd43afb8e47e4cc86b1a7','2025-02-04 10:03:55'),(4354,'05f7badabbf0668cae71a7c91a50ba7a','2025-02-04 10:03:55'),(4355,'6ce70bafe0a6d49ee0702faa6cc434c1','2025-02-04 10:03:55'),(4356,'abdf6194636ad986c0106913abbc0ae7','2025-02-04 10:03:56'),(4357,'e481a2c409058cc6fc4bfb97d7652998','2025-02-04 10:03:56'),(4358,'b8eaf361e2f9a584eaadac80e89baa1a','2025-02-04 10:03:56'),(4359,'5930dfe6beb4d515209de763d8211b1c','2025-02-04 10:03:56'),(4360,'b11edce45c6261d1878d520eadb308c3','2025-02-04 10:03:56'),(4361,'d5192c3061a9d60cc18a13276222635a','2025-02-04 10:03:56'),(4362,'6b6e163eca669f83f02986ecd8844f97','2025-02-04 10:03:56'),(4363,'c8a7ba9b6563028babf93f306c4312b5','2025-02-04 10:03:56'),(4364,'977d4b948f8c75ef7a93a6c2d8bdc6eb','2025-02-04 10:03:56'),(4365,'ef11d395b071e64c20dbada4513c2dd7','2025-02-04 10:03:56'),(4366,'2756e991c355e703bfbcfb7ba871553a','2025-02-04 10:03:56'),(4367,'645b3cc3475bdcfd09044dac269c7c63','2025-02-04 10:03:56'),(4368,'f5406cdbccb4ef3daff8160e1a7055d4','2025-02-04 10:03:56'),(4369,'44403e5e11c8100c8b85fd2a3a4b5829','2025-02-04 10:03:56'),(4370,'50a08242597fbe9cc183b47d9945a9f2','2025-02-04 10:03:56'),(4371,'24d99d691478433ee2a5a691ec48377c','2025-02-04 10:03:56'),(4372,'86714053a1d2a3a6b922b321c7cb2327','2025-02-04 10:03:57'),(4373,'05d11a1a514ac9c876b29e6a34552d57','2025-02-04 10:03:57'),(4374,'e3799e0ed96103974ccf49b7c6015458','2025-02-04 10:03:57'),(4375,'e1ab66d61b23fb429c9aa89b46f57205','2025-02-04 10:03:57'),(4376,'539cc70b239439c74a69e174aacab9fa','2025-02-04 10:03:57'),(4377,'d8d38f093182f907966e59780eb18070','2025-02-04 10:03:57'),(4378,'d68219b9bb3411979a915798c80fdb62','2025-02-04 10:03:57'),(4379,'c1da93f2c65a72e1bc7278aae8bdb066','2025-02-04 10:03:57'),(4380,'27ca8261a5046c4b2080380eaee7b8d5','2025-02-04 10:03:57'),(4381,'630790189d984b29d76cef4830cd26df','2025-02-04 10:03:57'),(4382,'4cc3767d666424793e991d8255e9bf22','2025-02-04 10:03:57'),(4383,'2e79873ed9999fbcac16abeff453103a','2025-02-04 10:03:57'),(4384,'4e3a2ae40eab03d8ac70f2137b026305','2025-02-04 10:03:57'),(4385,'30ae2372ac54ba2f1639400fb136f570','2025-02-04 10:03:57'),(4386,'43ba3bd0aeb977e26cd5e9912de9c5a3','2025-02-04 10:03:57'),(4387,'8942bf145a8f6c54ce958be6fb23d857','2025-02-04 10:03:57'),(4388,'9f386fc48898e604f1dce32a7acdd92c','2025-02-04 10:03:57'),(4389,'72b6a77accf05f1e8e7b41825c6fa600','2025-02-04 10:03:57'),(4390,'e26e9ee21d7313a6335509cd94cec341','2025-02-04 10:03:58'),(4391,'89ee00bfdc2bf47fb5b3f2180f63ee37','2025-02-04 10:03:58'),(4392,'a4c498916ee898ecb353e66a9ed245b8','2025-02-04 10:03:58'),(4393,'801493551dbf8c99d0f96685f49d49eb','2025-02-04 10:03:58'),(4394,'3b238865b2b0df9b92d7efad03aa7e7c','2025-02-04 10:03:58'),(4395,'146e1c60d1996071ff605bf9c9623b33','2025-02-04 10:03:58'),(4396,'8de07e01dcc11e34246560e2d23c3491','2025-02-04 10:03:58'),(4397,'5aa88d611e025b8edaf466a00e2d7c7b','2025-02-04 10:03:58'),(4398,'17d982fa5745dab0098a8e54c0ba8542','2025-02-04 10:03:58'),(4399,'e7dca8f0ce2567c29958c753b5cbf267','2025-02-04 10:03:58'),(4400,'a845cdf27092959df5be539dc83c0ba9','2025-02-04 10:03:58'),(4401,'9715c4250d9b88708c9d82f3de251939','2025-02-04 10:03:58'),(4402,'64ed1f08d04a329625ba57b7e7cf1aaa','2025-02-04 10:03:58'),(4403,'dbf9eaeed5cddd94ad05067a1e062199','2025-02-04 10:03:58'),(4404,'5c66454dd1d03c2158d56050f037f331','2025-02-04 10:03:58'),(4405,'1de0b6ede81d0fef512fd23dd33f9886','2025-02-04 10:03:58'),(4406,'6fa6291bb397eebaa6fff866c62a7e04','2025-02-04 10:03:58'),(4407,'44d924be3d34fd93873bf173106b4faa','2025-02-04 10:03:58'),(4408,'2de77b2a23fa4a3ae910158d4c9bb51a','2025-02-04 10:03:58'),(4409,'5879478425e292e9e94877d64c7449c1','2025-02-04 10:03:59'),(4410,'f79f0376740abbcead0e2b5b0934174a','2025-02-04 10:03:59'),(4411,'1f35887d4876fe44ff520a344b473e59','2025-02-04 10:03:59'),(4412,'ba53c6c43a1822f32c8366b78566f195','2025-02-04 10:03:59'),(4413,'78763352eaef90ab264c03a92d4ec41a','2025-02-04 10:03:59'),(4414,'02334ca13432e1e9dd0c80eddba41f4b','2025-02-04 10:03:59'),(4415,'fc3cb026b2d704f84e2115886b1fbcdb','2025-02-04 10:03:59'),(4416,'1b05defadaac01cb0794e8dc13ed6204','2025-02-04 10:03:59'),(4417,'2f157c73ad9c4b019e9ee302b9e55806','2025-02-04 10:03:59'),(4418,'72e5daa4b26adef2b9c2783f19aeef5e','2025-02-04 10:03:59'),(4419,'e184421fb6000b3304f3b1dcd1f1f3a1','2025-02-04 10:03:59'),(4420,'ed6b4d715ff9030560867168627dd161','2025-02-04 10:03:59'),(4421,'1205e9df500d30529d84b59ab12b8b81','2025-02-04 10:03:59'),(4422,'9565c23abf9b2f7048dee2dc2bf91a7f','2025-02-04 10:03:59'),(4423,'98c61389996e17900bfdd367ff3db073','2025-02-04 10:03:59'),(4424,'ade766ad59d388ceef234e209b8f6f49','2025-02-04 10:03:59'),(4425,'0647177cf475521dda640aee1b0f2ac4','2025-02-04 10:03:59'),(4426,'231f33c8cbbfc48241c737ccbe1a143d','2025-02-04 10:03:59'),(4427,'d45f11511627e9618f03927cf0129066','2025-02-04 10:03:59'),(4428,'e3722a8bed8ef8a4ac3a9c720db9d36a','2025-02-04 10:03:59'),(4429,'f40239014209b3a463b3b2b3fa50a837','2025-02-04 10:03:59'),(4430,'0cb3f70e763edca6d32fe5569a7f89cb','2025-02-04 10:03:59'),(4431,'87c133fbc3fff46d8f2f5968011c275d','2025-02-04 10:03:59'),(4432,'6baefe7b3c928cdbe42bd81c55ff966f','2025-02-04 10:03:59'),(4433,'d349424079793c5975b4cfaf7a322ece','2025-02-04 10:04:00'),(4434,'39af7c70d2a275a0f5579f791b33688a','2025-02-04 10:04:00'),(4435,'8802e9bda2201f1c346c76bc7f1af573','2025-02-04 10:04:00'),(4436,'64889bb9d35ac008f421c3872b754bcf','2025-02-04 10:04:00'),(4437,'166c652e5752c24aa5499372ca7f84b6','2025-02-04 10:04:00'),(4438,'166b1df8deb5d4c803264ae311e2f1a1','2025-02-04 10:04:00'),(4439,'1636d8e2e4b8cbfb463c8428762b71bc','2025-02-04 10:04:00'),(4440,'5823b31c16b76b9bdcfa97e0e91e5aed','2025-02-04 10:04:00'),(4441,'69ee59c7c4c0195cacbc9fa3889b257b','2025-02-04 10:04:00'),(4442,'9f756b75c266433ffb8e137b53f6fd89','2025-02-04 10:04:00'),(4443,'6b9f67647b42192da005038b10e3855c','2025-02-04 10:04:00'),(4444,'8136ad9d2712bd3d26d8dc181d58fa18','2025-02-04 10:04:00'),(4445,'2ff4e65befba7bd56c68322d4a5773c8','2025-02-04 10:04:00'),(4446,'091e1bb4a95f5d36c0d828230f2e8d63','2025-02-04 10:04:00'),(4447,'ce88ef34e428b5f9f05c4255189ae3d7','2025-02-04 10:04:00'),(4448,'402266db92690e63bbd188d6bb7205bb','2025-02-04 10:04:00'),(4449,'2d64d8a28334f43f41e9449acb2ed18a','2025-02-04 10:04:00'),(4450,'7be01528d11690d376c8f126003d2969','2025-02-04 10:04:00'),(4451,'b7b863c3e63988fcc0c3f5216b5f5405','2025-02-04 10:04:00'),(4452,'aab3a004751439a22d19596e8d6d477e','2025-02-04 10:04:00'),(4453,'dfe0731e63eaaf5135aa04e5f4aca052','2025-02-04 10:04:00'),(4454,'b803db2bb2ae4152d063a10d79901b5a','2025-02-04 10:04:00'),(4455,'81665c2133a42e09ceabf91c363d32c7','2025-02-04 10:04:00'),(4456,'cc0a83fe46ad61ca42e60488cc6972a3','2025-02-04 10:04:00'),(4457,'4011bde9162ded0fb537e83fee783aa0','2025-02-04 10:04:00'),(4458,'2e6f5a3c2c36cb140dbbed188c93c0c9','2025-02-04 10:04:00'),(4459,'733aa26b8450f6de9d1587115e7c0311','2025-02-04 10:04:00'),(4460,'25538c7dca9c6c14bfd067ed06993a20','2025-02-04 10:04:01'),(4461,'f1acfee555499e570e0c2da090090321','2025-02-04 10:04:01'),(4462,'9e0bcabb9b6639ff1c104c9e3a279df4','2025-02-04 10:04:01'),(4463,'65ea0dba0d1d2c208ebc1cdeafb688ef','2025-02-04 10:04:01'),(4464,'c4707df3f9b36adb6281e91f9c7446fa','2025-02-04 10:04:01'),(4465,'3492438dbf4629f7c77c71b1131ad4a0','2025-02-04 10:04:01'),(4466,'2af4e3d12484a3f5262b68c1e18656c1','2025-02-04 10:04:01'),(4467,'f81af1eceb187de358723fc9284451a6','2025-02-04 10:04:01'),(4468,'5aec7edbb4d4dcd5d78387b5bed9eb34','2025-02-04 10:04:01'),(4469,'067c04d23825a7af96ebe023cfe681b4','2025-02-04 10:04:01'),(4470,'41532762f95c6126a9151fd3e6b252fe','2025-02-04 10:04:01'),(4471,'fa5b531355a58f5c3948c875ec32325e','2025-02-04 10:04:01'),(4472,'e36db09d21e9e811f3022ef7e1aeae8a','2025-02-04 10:04:01'),(4473,'dc055ceef9890a7f8ec0b2f104131699','2025-02-04 10:04:01'),(4474,'1d5df708546e1c72e0a40ea3c6965456','2025-02-04 10:04:01'),(4475,'3c4e96f2ad6cc90d204830c05784d612','2025-02-04 10:04:01'),(4476,'3085579d96270618ab11c822a72973db','2025-02-04 10:04:01'),(4477,'b7d93c97cbc56e6d3ccf76d9242626b7','2025-02-04 10:04:01');
/*!40000 ALTER TABLE `queue_lock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `queue_message`
--

DROP TABLE IF EXISTS `queue_message`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `queue_message` (
  `id` bigint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Message ID',
  `topic_name` varchar(255) DEFAULT NULL COMMENT 'Message topic',
  `body` longtext COMMENT 'Message body',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6086 DEFAULT CHARSET=utf8mb3 COMMENT='Queue messages';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `queue_message`
--

LOCK TABLES `queue_message` WRITE;
/*!40000 ALTER TABLE `queue_message` DISABLE KEYS */;
INSERT INTO `queue_message` VALUES (1,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"7a61d31e-f460-4285-a7db-16e682bcc426\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/k\\\\\\/i\\\\\\/kitchen1_1.png\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(2,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"70174ea3-3cb0-4790-9ea1-2a671070d4de\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/k\\\\\\/i\\\\\\/kitchen1_1.png\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(3,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"84222566-4444-402d-814e-c4d09dc42eca\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/k\\\\\\/i\\\\\\/kitchen1_1_1.png\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(4,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"5ce6379c-4ce4-4fd7-a5bb-d8a2fa768095\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/b\\\\\\/a\\\\\\/bathroom.png\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(5,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"5b87788a-bdd8-42b6-bd9e-7768b64e86f0\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/b\\\\\\/a\\\\\\/bathroom-mirror.jpeg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(6,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"5b2570ad-402e-4e9d-bbaa-a2373e457153\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/k\\\\\\/i\\\\\\/kitchen-sink.jpeg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(7,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"c9c7fda7-dc31-48af-addd-f01338e65cff\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/v\\\\\\/i\\\\\\/vitra-7278l003-0001.jpg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(8,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"045fc267-5ba2-4a96-af82-64572823541a\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/h\\\\\\/u\\\\\\/hudson-reed-nbv160.jpg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(9,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"0a77aef8-c885-4ac3-8758-1514b466bad1\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/b\\\\\\/o\\\\\\/bosch_dwq96dm50b.jpg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(10,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"3167c505-47d9-4715-9307-ea22165c4b98\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/b\\\\\\/o\\\\\\/bosch_spv4emx21g.jpg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(11,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"c2d86db9-7b70-42e6-987b-72392cdc9a64\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/s\\\\\\/m\\\\\\/smv6zcx01g.jpg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(12,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"2611e3ef-9688-4044-b2ae-32e998e71dd6\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/b\\\\\\/o\\\\\\/bosch-smd8ycx03g-1.jpg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(13,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"2fe8a314-b923-4fd6-bb74-6461ee964704\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/1\\\\\\/_\\\\\\/1_4_2.jpg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(14,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"44da8518-867a-481e-ad72-0985c8fafb24\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/b\\\\\\/o\\\\\\/bosch-smd6tcx00e.jpg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(15,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"3ede2243-03ef-43bc-a35e-94adfe4ff744\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/b\\\\\\/o\\\\\\/bosch-smd6edx57g.jpg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(16,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"edeab16c-c6a3-4b4f-8f03-ca8b06da7401\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/f\\\\\\/r\\\\\\/franke-fpj-625-v-stainless_steel.jpg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(17,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"24384935-d798-424c-869f-bef6c0f75b50\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/f\\\\\\/r\\\\\\/franke_330.0657.418-1.jpg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(18,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"9fda6487-0da9-4692-8475-04ffc0612827\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/f\\\\\\/r\\\\\\/franke_330.0657.270-1.jpg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(19,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"b1ba6022-ee1b-4fcd-a172-7b7b57a75f20\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/f\\\\\\/r\\\\\\/franke_325.0657.267-1_1.jpg.tmp\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(20,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"acc54c4e-35db-45f7-9734-d1e5e80193ec\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/f\\\\\\/r\\\\\\/franke_330.0682.352-1_1.jpg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(21,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"566f6825-0fe2-4b38-b442-20d0d887bede\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/f\\\\\\/r\\\\\\/franke_325.0679.323-1_2.jpg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(22,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"3fc2a972-75ec-4ae3-855a-924e6c2932b6\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/f\\\\\\/r\\\\\\/franke_325.0657.267-1_6.jpg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(23,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"17fe0262-99e4-4e76-b535-9022d727df1e\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/k\\\\\\/i\\\\\\/kitchen1_1.png.tmp\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(24,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"2c63ffb2-ef30-417b-81ad-0ac377829a29\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/b\\\\\\/a\\\\\\/basins.jpeg\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(25,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"315b5cdb-dccd-44f6-9e4f-725e992aa5ca\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/k\\\\\\/i\\\\\\/kitchen1_2.png\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(26,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"85bbe3ca-a93f-4bb2-b6c3-4c6f3b253a83\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/k\\\\\\/i\\\\\\/kitchen1_3.png\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(27,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"c398bbc3-17e4-452d-9d60-50ddef565529\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/b\\\\\\/a\\\\\\/bath4.png.tmp\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(28,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"55cbd1ad-ff9c-4d36-b0b9-8ff68e346b61\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/s\\\\\\/h\\\\\\/shower-bath.png\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(29,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"4dd716ed-32a7-4835-9b63-07c824f0d509\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/s\\\\\\/t\\\\\\/straight-bath.png\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(30,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"f479c798-da00-4419-8f62-d43249b3ce03\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/s\\\\\\/h\\\\\\/shower-bath_1.png\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(31,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"f2870037-80e8-487f-baba-a772223f74dd\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/s\\\\\\/h\\\\\\/shower-bath_2.png\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(32,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"d951a05c-4069-448b-aa83-5d0d860f9efc\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/s\\\\\\/t\\\\\\/straight-bath_1.png\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(33,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"ecb4fd88-87e8-4fc8-9e5d-22e21fd2b3b2\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/s\\\\\\/h\\\\\\/shower-bath_3.png\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(34,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"b077c2c5-6f55-458d-9ffd-5aede252f57c\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/s\\\\\\/h\\\\\\/shower-bath_3.png\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(35,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"ddfb44ca-71f3-46ff-a596-11a592644e73\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/a\\\\\\/c\\\\\\/access-baths-indiana-1-1_1_2.png\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(36,'media.storage.catalog.image.resize','{\"id\":null,\"bulk_uuid\":\"aeb2b460-be6d-4094-9812-d4a337fc711f\",\"topic_name\":\"media.storage.catalog.image.resize\",\"serialized_data\":\"{\\\"filename\\\":\\\"\\\\\\/k\\\\\\/i\\\\\\/kitchen1_1_1_2.png\\\"}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(37,'inventory.reservations.updateSalabilityStatus','{\"skus\":[\"test-configurable\"],\"stock\":1}'),(38,'catalog_website_attribute_value_sync','{\"id\":null,\"bulk_uuid\":\"f54a0cb6-84c7-481e-a7a3-e6d67e036b22\",\"topic_name\":\"catalog_website_attribute_value_sync\",\"serialized_data\":\"{\\\"store_id\\\":2}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(39,'inventory.reservations.updateSalabilityStatus','{\"skus\":[\"Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink\"],\"stock\":1}'),(40,'inventory.reservations.updateSalabilityStatus','{\"skus\":[\"FVAS A80 BK Z1\"],\"stock\":1}'),(41,'inventory.reservations.updateSalabilityStatus','{\"skus\":[\"FVAS A80 BK Z1\"],\"stock\":1}'),(42,'catalog_website_attribute_value_sync','{\"id\":null,\"bulk_uuid\":\"8c0075cd-dfa7-40e2-a1ff-01eb5ae8793c\",\"topic_name\":\"catalog_website_attribute_value_sync\",\"serialized_data\":\"{\\\"store_id\\\":3}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(43,'import_export.export','{\"skip_attr\":[],\"file_name\":\"catalog_product_20250127_112116.csv\",\"file_format\":\"csv\",\"content_type\":\"text\\/csv\",\"entity\":\"catalog_product\",\"export_filter\":\"{\\\"bath_enclosures\\\":[\\\"\\\",\\\"\\\"],\\\"bestsellers\\\":[\\\"\\\",\\\"\\\"],\\\"category_ids\\\":\\\"\\\",\\\"color\\\":\\\"\\\",\\\"cost\\\":[\\\"\\\",\\\"\\\"],\\\"country_of_manufacture\\\":\\\"\\\",\\\"created_at\\\":[\\\"\\\",\\\"\\\"],\\\"custom_design\\\":\\\"\\\",\\\"custom_design_from\\\":[\\\"\\\",\\\"\\\"],\\\"custom_design_to\\\":[\\\"\\\",\\\"\\\"],\\\"custom_layout\\\":\\\"\\\",\\\"custom_layout_update\\\":\\\"\\\",\\\"custom_layout_update_file\\\":\\\"\\\",\\\"description\\\":\\\"\\\",\\\"featured\\\":[\\\"\\\",\\\"\\\"],\\\"gallery\\\":\\\"\\\",\\\"gift_message_available\\\":\\\"\\\",\\\"has_options\\\":\\\"\\\",\\\"heat_output\\\":\\\"\\\",\\\"hide_shipping_calculator\\\":\\\"\\\",\\\"image\\\":\\\"\\\",\\\"image_label\\\":\\\"\\\",\\\"imegamedia_finance_filter\\\":\\\"\\\",\\\"kitchen_sinks\\\":[\\\"\\\",\\\"\\\"],\\\"links_exist\\\":[\\\"\\\",\\\"\\\"],\\\"links_purchased_separately\\\":[\\\"\\\",\\\"\\\"],\\\"links_title\\\":\\\"\\\",\\\"media_gallery\\\":\\\"\\\",\\\"meta_description\\\":\\\"\\\",\\\"meta_keyword\\\":\\\"\\\",\\\"meta_title\\\":\\\"\\\",\\\"minimal_price\\\":[\\\"\\\",\\\"\\\"],\\\"msrp\\\":[\\\"\\\",\\\"\\\"],\\\"msrp_display_actual_price_type\\\":\\\"\\\",\\\"name\\\":\\\"\\\",\\\"news_from_date\\\":[\\\"\\\",\\\"\\\"],\\\"news_to_date\\\":[\\\"\\\",\\\"\\\"],\\\"old_id\\\":[\\\"\\\",\\\"\\\"],\\\"options_container\\\":\\\"\\\",\\\"page_layout\\\":\\\"\\\",\\\"price\\\":[\\\"\\\",\\\"\\\"],\\\"price_per_unit\\\":\\\"\\\",\\\"price_type\\\":[\\\"\\\",\\\"\\\"],\\\"price_view\\\":\\\"\\\",\\\"product_dimensions\\\":\\\"\\\",\\\"product_faq\\\":\\\"\\\",\\\"quantity_and_stock_status\\\":\\\"\\\",\\\"required_options\\\":\\\"\\\",\\\"samples_title\\\":\\\"\\\",\\\"shipment_type\\\":\\\"\\\",\\\"short_description\\\":\\\"\\\",\\\"shower_baths\\\":\\\"\\\",\\\"sku\\\":\\\"\\\",\\\"sku_type\\\":[\\\"\\\",\\\"\\\"],\\\"small_image\\\":\\\"\\\",\\\"small_image_label\\\":\\\"\\\",\\\"special_from_date\\\":[\\\"\\\",\\\"\\\"],\\\"special_price\\\":[\\\"\\\",\\\"\\\"],\\\"special_to_date\\\":[\\\"\\\",\\\"\\\"],\\\"status\\\":\\\"\\\",\\\"swatch_image\\\":\\\"\\\",\\\"tax_class_id\\\":\\\"\\\",\\\"thumbnail\\\":\\\"\\\",\\\"thumbnail_label\\\":\\\"\\\",\\\"tier_price\\\":[\\\"\\\",\\\"\\\"],\\\"top_rated\\\":\\\"\\\",\\\"updated_at\\\":[\\\"\\\",\\\"\\\"],\\\"url_key\\\":\\\"\\\",\\\"url_path\\\":\\\"\\\",\\\"visibility\\\":\\\"\\\",\\\"weight\\\":[\\\"\\\",\\\"\\\"],\\\"weight_type\\\":[\\\"\\\",\\\"\\\"],\\\"whirlpool_baths\\\":\\\"\\\"}\"}'),(44,'import_export.export','{\"skip_attr\":[],\"file_name\":\"catalog_product_20250127_112117.csv\",\"file_format\":\"csv\",\"content_type\":\"text\\/csv\",\"entity\":\"catalog_product\",\"export_filter\":\"{\\\"bath_enclosures\\\":[\\\"\\\",\\\"\\\"],\\\"bestsellers\\\":[\\\"\\\",\\\"\\\"],\\\"category_ids\\\":\\\"\\\",\\\"color\\\":\\\"\\\",\\\"cost\\\":[\\\"\\\",\\\"\\\"],\\\"country_of_manufacture\\\":\\\"\\\",\\\"created_at\\\":[\\\"\\\",\\\"\\\"],\\\"custom_design\\\":\\\"\\\",\\\"custom_design_from\\\":[\\\"\\\",\\\"\\\"],\\\"custom_design_to\\\":[\\\"\\\",\\\"\\\"],\\\"custom_layout\\\":\\\"\\\",\\\"custom_layout_update\\\":\\\"\\\",\\\"custom_layout_update_file\\\":\\\"\\\",\\\"description\\\":\\\"\\\",\\\"featured\\\":[\\\"\\\",\\\"\\\"],\\\"gallery\\\":\\\"\\\",\\\"gift_message_available\\\":\\\"\\\",\\\"has_options\\\":\\\"\\\",\\\"heat_output\\\":\\\"\\\",\\\"hide_shipping_calculator\\\":\\\"\\\",\\\"image\\\":\\\"\\\",\\\"image_label\\\":\\\"\\\",\\\"imegamedia_finance_filter\\\":\\\"\\\",\\\"kitchen_sinks\\\":[\\\"\\\",\\\"\\\"],\\\"links_exist\\\":[\\\"\\\",\\\"\\\"],\\\"links_purchased_separately\\\":[\\\"\\\",\\\"\\\"],\\\"links_title\\\":\\\"\\\",\\\"media_gallery\\\":\\\"\\\",\\\"meta_description\\\":\\\"\\\",\\\"meta_keyword\\\":\\\"\\\",\\\"meta_title\\\":\\\"\\\",\\\"minimal_price\\\":[\\\"\\\",\\\"\\\"],\\\"msrp\\\":[\\\"\\\",\\\"\\\"],\\\"msrp_display_actual_price_type\\\":\\\"\\\",\\\"name\\\":\\\"\\\",\\\"news_from_date\\\":[\\\"\\\",\\\"\\\"],\\\"news_to_date\\\":[\\\"\\\",\\\"\\\"],\\\"old_id\\\":[\\\"\\\",\\\"\\\"],\\\"options_container\\\":\\\"\\\",\\\"page_layout\\\":\\\"\\\",\\\"price\\\":[\\\"\\\",\\\"\\\"],\\\"price_per_unit\\\":\\\"\\\",\\\"price_type\\\":[\\\"\\\",\\\"\\\"],\\\"price_view\\\":\\\"\\\",\\\"product_dimensions\\\":\\\"\\\",\\\"product_faq\\\":\\\"\\\",\\\"quantity_and_stock_status\\\":\\\"\\\",\\\"required_options\\\":\\\"\\\",\\\"samples_title\\\":\\\"\\\",\\\"shipment_type\\\":\\\"\\\",\\\"short_description\\\":\\\"\\\",\\\"shower_baths\\\":\\\"\\\",\\\"sku\\\":\\\"\\\",\\\"sku_type\\\":[\\\"\\\",\\\"\\\"],\\\"small_image\\\":\\\"\\\",\\\"small_image_label\\\":\\\"\\\",\\\"special_from_date\\\":[\\\"\\\",\\\"\\\"],\\\"special_price\\\":[\\\"\\\",\\\"\\\"],\\\"special_to_date\\\":[\\\"\\\",\\\"\\\"],\\\"status\\\":\\\"\\\",\\\"swatch_image\\\":\\\"\\\",\\\"tax_class_id\\\":\\\"\\\",\\\"thumbnail\\\":\\\"\\\",\\\"thumbnail_label\\\":\\\"\\\",\\\"tier_price\\\":[\\\"\\\",\\\"\\\"],\\\"top_rated\\\":\\\"\\\",\\\"updated_at\\\":[\\\"\\\",\\\"\\\"],\\\"url_key\\\":\\\"\\\",\\\"url_path\\\":\\\"\\\",\\\"visibility\\\":\\\"\\\",\\\"weight\\\":[\\\"\\\",\\\"\\\"],\\\"weight_type\\\":[\\\"\\\",\\\"\\\"],\\\"whirlpool_baths\\\":\\\"\\\"}\"}'),(45,'catalog_website_attribute_value_sync','{\"id\":null,\"bulk_uuid\":\"aae32a43-5716-408b-b5c9-1ccd37898c08\",\"topic_name\":\"catalog_website_attribute_value_sync\",\"serialized_data\":\"{\\\"store_id\\\":4}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(46,'inventory.reservations.updateSalabilityStatus','{\"skus\":[\"Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink\"],\"stock\":1}'),(47,'inventory.reservations.updateSalabilityStatus','{\"skus\":[\"Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink\"],\"stock\":1}'),(48,'inventory.reservations.updateSalabilityStatus','{\"skus\":[\"Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink\"],\"stock\":1}'),(49,'inventory.reservations.updateSalabilityStatus','{\"skus\":[\"Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink\"],\"stock\":1}'),(50,'inventory.reservations.updateSalabilityStatus','{\"skus\":[\"Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink\"],\"stock\":1}'),(51,'inventory.source.items.cleanup','[\"24-WG085\"]'),(52,'inventory.source.items.cleanup','[\"24-WG086\"]'),(53,'inventory.source.items.cleanup','[\"24-WG087\"]'),(54,'inventory.source.items.cleanup','[\"24-WG085_Group\"]'),(55,'inventory.source.items.cleanup','[\"24-WG085-bundle-dynamic\"]'),(56,'inventory.source.items.cleanup','[\"24-WG085-bundle-fixed\"]'),(57,'inventory.source.items.cleanup','[\"1080-000\"]'),(58,'inventory.source.items.cleanup','[\"1180-000\"]'),(59,'inventory.source.items.cleanup','[\"1200-000\"]'),(60,'inventory.source.items.cleanup','[\"1210-000\"]'),(61,'inventory.source.items.cleanup','[\"1220-000\"]'),(62,'inventory.source.items.cleanup','[\"1230-000\"]'),(63,'inventory.source.items.cleanup','[\"1240-000\"]'),(64,'inventory.source.items.cleanup','[\"1250-000\"]'),(65,'inventory.source.items.cleanup','[\"1251-000\"]'),(66,'inventory.source.items.cleanup','[\"1252-000\"]'),(67,'inventory.source.items.cleanup','[\"1253-000\"]'),(68,'inventory.source.items.cleanup','[\"1265-000\"]'),(69,'inventory.source.items.cleanup','[\"1266-000\"]'),(70,'inventory.source.items.cleanup','[\"1267-000\"]'),(71,'inventory.source.items.cleanup','[\"1268-000\"]'),(72,'inventory.source.items.cleanup','[\"1269-000\"]'),(73,'inventory.source.items.cleanup','[\"1270-000\"]'),(74,'inventory.source.items.cleanup','[\"1271-000\"]'),(75,'inventory.source.items.cleanup','[\"1272-000\"]'),(76,'inventory.source.items.cleanup','[\"1273-000\"]'),(77,'inventory.source.items.cleanup','[\"1300-000\"]'),(78,'inventory.source.items.cleanup','[\"1380-000\"]'),(79,'inventory.source.items.cleanup','[\"1430-000\"]'),(80,'inventory.source.items.cleanup','[\"1450-000\"]'),(81,'inventory.source.items.cleanup','[\"1620-000\"]'),(82,'inventory.source.items.cleanup','[\"1630-000\"]'),(83,'inventory.source.items.cleanup','[\"1631-000\"]'),(84,'inventory.source.items.cleanup','[\"1641-000\"]'),(85,'inventory.source.items.cleanup','[\"1642-000\"]'),(86,'inventory.source.items.cleanup','[\"1643-000\"]'),(87,'inventory.source.items.cleanup','[\"1730-000\"]'),(88,'inventory.source.items.cleanup','[\"1830-000\"]'),(89,'inventory.source.items.cleanup','[\"2.21E+03\"]'),(90,'inventory.source.items.cleanup','[\"2370J 2370K\"]'),(91,'inventory.source.items.cleanup','[\"2375L3000\"]'),(92,'inventory.source.items.cleanup','[\"24717000\"]'),(93,'inventory.source.items.cleanup','[\"24718000\"]'),(94,'inventory.source.items.cleanup','[\"24719000\"]'),(95,'inventory.source.items.cleanup','[\"2540-000\"]'),(96,'inventory.source.items.cleanup','[\"2560-000\"]'),(97,'inventory.source.items.cleanup','[\"2590-000\"]'),(98,'inventory.source.items.cleanup','[\"2680-000\"]'),(99,'inventory.source.items.cleanup','[\"2700-000\"]'),(100,'inventory.source.items.cleanup','[\"2720-000\"]'),(101,'inventory.source.items.cleanup','[\"2740-000\"]'),(102,'inventory.source.items.cleanup','[\"2745-000\"]'),(103,'inventory.source.items.cleanup','[\"2940-000\"]'),(104,'inventory.source.items.cleanup','[\"2941-000\"]'),(105,'inventory.source.items.cleanup','[\"2942-000\"]'),(106,'inventory.source.items.cleanup','[\"2943-000\"]'),(107,'inventory.source.items.cleanup','[\"2944-000\"]'),(108,'inventory.source.items.cleanup','[\"2945-000\"]'),(109,'inventory.source.items.cleanup','[\"2946-000\"]'),(110,'inventory.source.items.cleanup','[\"2947-000\"]'),(111,'inventory.source.items.cleanup','[\"2948-000\"]'),(112,'inventory.source.items.cleanup','[\"2949-000\"]'),(113,'inventory.source.items.cleanup','[\"2950-000\"]'),(114,'inventory.source.items.cleanup','[\"2951-000\"]'),(115,'inventory.source.items.cleanup','[\"3020-000\"]'),(116,'inventory.source.items.cleanup','[\"3060-000\"]'),(117,'inventory.source.items.cleanup','[\"3100-000\"]'),(118,'inventory.source.items.cleanup','[\"3108-000\"]'),(119,'inventory.source.items.cleanup','[\"3109-000\"]'),(120,'inventory.source.items.cleanup','[\"3110-000\"]'),(121,'inventory.source.items.cleanup','[\"3111-000\"]'),(122,'inventory.source.items.cleanup','[\"3112-000\"]'),(123,'inventory.source.items.cleanup','[\"3310-000\"]'),(124,'inventory.source.items.cleanup','[\"3311-000\"]'),(125,'inventory.source.items.cleanup','[\"3312-000\"]'),(126,'inventory.source.items.cleanup','[\"3313-000\"]'),(127,'inventory.source.items.cleanup','[\"3314-000\"]'),(128,'inventory.source.items.cleanup','[\"3323-000\"]'),(129,'inventory.source.items.cleanup','[\"3324-000\"]'),(130,'inventory.source.items.cleanup','[\"3325-000\"]'),(131,'inventory.source.items.cleanup','[\"3410-000\"]'),(132,'inventory.source.items.cleanup','[\"3411-000\"]'),(133,'inventory.source.items.cleanup','[\"3412-000\"]'),(134,'inventory.source.items.cleanup','[\"3413-000\"]'),(135,'inventory.source.items.cleanup','[\"3420-000T\"]'),(136,'inventory.source.items.cleanup','[\"3431-000\"]'),(137,'inventory.source.items.cleanup','[\"3432-000\"]'),(138,'inventory.source.items.cleanup','[\"3433-000\"]'),(139,'inventory.source.items.cleanup','[\"3473-000\"]'),(140,'inventory.source.items.cleanup','[\"3560-000\"]'),(141,'inventory.source.items.cleanup','[\"3650-000\"]'),(142,'inventory.source.items.cleanup','[\"3660-000\"]'),(143,'inventory.source.items.cleanup','[\"3760-000\"]'),(144,'inventory.source.items.cleanup','[\"3820-000\"]'),(145,'inventory.source.items.cleanup','[\"3860-000\"]'),(146,'inventory.source.items.cleanup','[\"50800001000\"]'),(147,'inventory.source.items.cleanup','[\"50810001000\"]'),(148,'inventory.source.items.cleanup','[\"50820001000\"]'),(149,'inventory.source.items.cleanup','[\"52280001000\"]'),(150,'inventory.source.items.cleanup','[\"52430001000\"]'),(151,'inventory.source.items.cleanup','[\"52510001000\"]'),(152,'inventory.source.items.cleanup','[\"52520001000\"]'),(153,'inventory.source.items.cleanup','[\"52530001000\"]'),(154,'inventory.source.items.cleanup','[\"52540001000\"]'),(155,'inventory.source.items.cleanup','[\"52660001000\"]'),(156,'inventory.source.items.cleanup','[\"54300001000\"]'),(157,'inventory.source.items.cleanup','[\"55180001000\"]'),(158,'inventory.source.items.cleanup','[\"55210001000\"]'),(159,'inventory.source.items.cleanup','[\"55230001000\"]'),(160,'inventory.source.items.cleanup','[\"6650-000CERVK\"]'),(161,'inventory.source.items.cleanup','[\"6660-000CERVK\"]'),(162,'inventory.source.items.cleanup','[\"6670-000CERVK\"]'),(163,'inventory.source.items.cleanup','[\"6677-000CERVK\"]'),(164,'inventory.source.items.cleanup','[\"6680-000CELVK\"]'),(165,'inventory.source.items.cleanup','[\"6690-000CELVK\"]'),(166,'inventory.source.items.cleanup','[\"6700-000CELVK\"]'),(167,'inventory.source.items.cleanup','[\"6720-000CELVK\"]'),(168,'inventory.source.items.cleanup','[\"6829-000\"]'),(169,'inventory.source.items.cleanup','[\"6830-000\"]'),(170,'inventory.source.items.cleanup','[\"6831-000\"]'),(171,'inventory.source.items.cleanup','[\"6832-000\"]'),(172,'inventory.source.items.cleanup','[\"8765-000\"]'),(173,'inventory.source.items.cleanup','[\"8772-000\"]'),(174,'inventory.source.items.cleanup','[\"8773-000\"]'),(175,'inventory.source.items.cleanup','[\"8774-000\"]'),(176,'inventory.source.items.cleanup','[\"8775-000\"]'),(177,'inventory.source.items.cleanup','[\"8831-000\"]'),(178,'inventory.source.items.cleanup','[\"8833-000\"]'),(179,'inventory.source.items.cleanup','[\"8835-000\"]'),(180,'inventory.source.items.cleanup','[\"8836-000\"]'),(181,'inventory.source.items.cleanup','[\"8839-000\"]'),(182,'inventory.source.items.cleanup','[\"8842-000\"]'),(183,'inventory.source.items.cleanup','[\"8850-000\"]'),(184,'inventory.source.items.cleanup','[\"8852-000\"]'),(185,'inventory.source.items.cleanup','[\"8854-000\"]'),(186,'inventory.source.items.cleanup','[\"8856-000\"]'),(187,'inventory.source.items.cleanup','[\"8859-000\"]'),(188,'inventory.source.items.cleanup','[\"Balance Bath\"]'),(189,'inventory.source.items.cleanup','[\"Balmoral\"]'),(190,'inventory.source.items.cleanup','[\"BE3480-000CFXXK\"]'),(191,'inventory.source.items.cleanup','[\"Bette Classic\"]'),(192,'inventory.source.items.cleanup','[\"Bette Comodo\"]'),(193,'inventory.source.items.cleanup','[\"Bette Comodo with Side Overflow\"]'),(194,'inventory.source.items.cleanup','[\"Bette Duett\"]'),(195,'inventory.source.items.cleanup','[\"Bette Form Steel Bath\"]'),(196,'inventory.source.items.cleanup','[\"Bette Free\"]'),(197,'inventory.source.items.cleanup','[\"Bette Labette\"]'),(198,'inventory.source.items.cleanup','[\"Bette Ocean\"]'),(199,'inventory.source.items.cleanup','[\"Bette Ocean Lowline\"]'),(200,'inventory.source.items.cleanup','[\"Bette One\"]'),(201,'inventory.source.items.cleanup','[\"Bette One Relax\"]'),(202,'inventory.source.items.cleanup','[\"Bette Select\"]'),(203,'inventory.source.items.cleanup','[\"Bette Select Overflow\"]'),(204,'inventory.source.items.cleanup','[\"Bette Set\"]'),(205,'inventory.source.items.cleanup','[\"Bette Starlet\"]'),(206,'inventory.source.items.cleanup','[\"Bette Starlet Flair Oval\"]'),(207,'inventory.source.items.cleanup','[\"Bette Starlet IV Silhouette\"]'),(208,'inventory.source.items.cleanup','[\"Bette Starlet Oval\"]'),(209,'inventory.source.items.cleanup','[\"Bette Starlet V\"]'),(210,'inventory.source.items.cleanup','[\"Bolton 1690\"]'),(211,'inventory.source.items.cleanup','[\"Bolton 1805\"]'),(212,'inventory.source.items.cleanup','[\"BS0170201\"]'),(213,'inventory.source.items.cleanup','[\"BT01AAWHA\"]'),(214,'inventory.source.items.cleanup','[\"BT54AWHA\"]'),(215,'inventory.source.items.cleanup','[\"BT55AAWHA\"]'),(216,'inventory.source.items.cleanup','[\"BT56AWHA\"]'),(217,'inventory.source.items.cleanup','[\"BT57AWHA\"]'),(218,'inventory.source.items.cleanup','[\"BT58AWHA\"]'),(219,'inventory.source.items.cleanup','[\"Chatsworth\"]'),(220,'inventory.source.items.cleanup','[\"Ebony\"]'),(221,'inventory.source.items.cleanup','[\"Hexham\"]'),(222,'inventory.source.items.cleanup','[\"KABATH\\/WL\"]'),(223,'inventory.source.items.cleanup','[\"Kensington 1495\"]'),(224,'inventory.source.items.cleanup','[\"Kensington 1695\"]'),(225,'inventory.source.items.cleanup','[\"Kingswood 1750\"]'),(226,'inventory.source.items.cleanup','[\"KL111500010001\"]'),(227,'inventory.source.items.cleanup','[\"KL111600010001\"]'),(228,'inventory.source.items.cleanup','[\"KL111700010001\"]'),(229,'inventory.source.items.cleanup','[\"KL111700200001\"]'),(230,'inventory.source.items.cleanup','[\"KL111800010001\"]'),(231,'inventory.source.items.cleanup','[\"KL111800200001\"]'),(232,'inventory.source.items.cleanup','[\"KL112200010001\"]'),(233,'inventory.source.items.cleanup','[\"KL112500010001\"]'),(234,'inventory.source.items.cleanup','[\"KL112600010001\"]'),(235,'inventory.source.items.cleanup','[\"KL112800010001\"]'),(236,'inventory.source.items.cleanup','[\"KL112900010001\"]'),(237,'inventory.source.items.cleanup','[\"KL220300010001\"]'),(238,'inventory.source.items.cleanup','[\"KL224600010001\"]'),(239,'inventory.source.items.cleanup','[\"KL225200010001\"]'),(240,'inventory.source.items.cleanup','[\"KL233000010001\"]'),(241,'inventory.source.items.cleanup','[\"KL233100010001\"]'),(242,'inventory.source.items.cleanup','[\"KL233200010001\"]'),(243,'inventory.source.items.cleanup','[\"KL234400010001\"]'),(244,'inventory.source.items.cleanup','[\"KL235000010001\"]'),(245,'inventory.source.items.cleanup','[\"KL235100010001\"]'),(246,'inventory.source.items.cleanup','[\"KL235200010001\"]'),(247,'inventory.source.items.cleanup','[\"KL235300010001\"]'),(248,'inventory.source.items.cleanup','[\"KL266300010001\"]'),(249,'inventory.source.items.cleanup','[\"KL266400010001\"]'),(250,'inventory.source.items.cleanup','[\"KL266500010001\"]'),(251,'inventory.source.items.cleanup','[\"KL267400010001\"]'),(252,'inventory.source.items.cleanup','[\"KL267600010001\"]'),(253,'inventory.source.items.cleanup','[\"KL267800010001\"]'),(254,'inventory.source.items.cleanup','[\"KL272400010001\"]'),(255,'inventory.source.items.cleanup','[\"KL272500010001\"]'),(256,'inventory.source.items.cleanup','[\"KL274700010001\"]'),(257,'inventory.source.items.cleanup','[\"KL274800010001\"]'),(258,'inventory.source.items.cleanup','[\"KL274900010001\"]'),(259,'inventory.source.items.cleanup','[\"KL275000010001\"]'),(260,'inventory.source.items.cleanup','[\"KL275100010001\"]'),(261,'inventory.source.items.cleanup','[\"KL290300010001\"]'),(262,'inventory.source.items.cleanup','[\"KL290500010001\"]'),(263,'inventory.source.items.cleanup','[\"KL290700010001\"]'),(264,'inventory.source.items.cleanup','[\"KL290900010001\"]'),(265,'inventory.source.items.cleanup','[\"KL291000010001\"]'),(266,'inventory.source.items.cleanup','[\"KL291200010001\"]'),(267,'inventory.source.items.cleanup','[\"KL291300010001\"]'),(268,'inventory.source.items.cleanup','[\"KL291400010001\"]'),(269,'inventory.source.items.cleanup','[\"KL291500010001\"]'),(270,'inventory.source.items.cleanup','[\"KL292600010001\"]'),(271,'inventory.source.items.cleanup','[\"Lambeth\"]'),(272,'inventory.source.items.cleanup','[\"Melrose\"]'),(273,'inventory.source.items.cleanup','[\"Melrose FA\"]'),(274,'inventory.source.items.cleanup','[\"NBA209\"]'),(275,'inventory.source.items.cleanup','[\"NBA210\"]'),(276,'inventory.source.items.cleanup','[\"NBA214\"]'),(277,'inventory.source.items.cleanup','[\"NBA405\"]'),(278,'inventory.source.items.cleanup','[\"NBA407\"]'),(279,'inventory.source.items.cleanup','[\"NBA409\"]'),(280,'inventory.source.items.cleanup','[\"NBA410\"]'),(281,'inventory.source.items.cleanup','[\"NBA414\"]'),(282,'inventory.source.items.cleanup','[\"NBA509\"]'),(283,'inventory.source.items.cleanup','[\"NBA510\"]'),(284,'inventory.source.items.cleanup','[\"NBA514\"]'),(285,'inventory.source.items.cleanup','[\"NBA605\"]'),(286,'inventory.source.items.cleanup','[\"NBA607\"]'),(287,'inventory.source.items.cleanup','[\"NBA609\"]'),(288,'inventory.source.items.cleanup','[\"NBA610\"]'),(289,'inventory.source.items.cleanup','[\"NBA614\"]'),(290,'inventory.source.items.cleanup','[\"NBB001\"]'),(291,'inventory.source.items.cleanup','[\"NBB002\"]'),(292,'inventory.source.items.cleanup','[\"NBB003\"]'),(293,'inventory.source.items.cleanup','[\"NBB004\"]'),(294,'inventory.source.items.cleanup','[\"Neon Rectangular Bath\"]'),(295,'inventory.source.items.cleanup','[\"Neon Shower Bath\"]'),(296,'inventory.source.items.cleanup','[\"NLB109\"]'),(297,'inventory.source.items.cleanup','[\"NLB110\"]'),(298,'inventory.source.items.cleanup','[\"NLB114\"]'),(299,'inventory.source.items.cleanup','[\"Onyx\"]'),(300,'inventory.source.items.cleanup','[\"Opal\"]'),(301,'inventory.source.items.cleanup','[\"Optima Bath\"]'),(302,'inventory.source.items.cleanup','[\"Orlando 1380\"]'),(303,'inventory.source.items.cleanup','[\"Quartz\"]'),(304,'inventory.source.items.cleanup','[\"RAK-Cloud Bath\"]'),(305,'inventory.source.items.cleanup','[\"RAK-Washington\"]'),(306,'inventory.source.items.cleanup','[\"RAKWTNBAT1770\\/WL\"]'),(307,'inventory.source.items.cleanup','[\"RAKWTNBAT1775\\/WL\"]'),(308,'inventory.source.items.cleanup','[\"RE1701C2\"]'),(309,'inventory.source.items.cleanup','[\"RL1490C2\"]'),(310,'inventory.source.items.cleanup','[\"RL1501C2\"]'),(311,'inventory.source.items.cleanup','[\"RL1690C2\"]'),(312,'inventory.source.items.cleanup','[\"RL1705C2\"]'),(313,'inventory.source.items.cleanup','[\"RL1707T\"]'),(314,'inventory.source.items.cleanup','[\"RLF1500C2\"]'),(315,'inventory.source.items.cleanup','[\"RLF1700C2\"]'),(316,'inventory.source.items.cleanup','[\"Ruby\"]'),(317,'inventory.source.items.cleanup','[\"Sunstone\"]'),(318,'inventory.source.items.cleanup','[\"WBB1585\"]'),(319,'inventory.source.items.cleanup','[\"WBB1785\"]'),(320,'inventory.source.items.cleanup','[\"WBP1585\"]'),(321,'inventory.source.items.cleanup','[\"WBP1685\"]'),(322,'inventory.source.items.cleanup','[\"WBP1785\"]'),(323,'inventory.source.items.cleanup','[\"WBS1585\"]'),(324,'inventory.source.items.cleanup','[\"WBS1685\"]'),(325,'inventory.source.items.cleanup','[\"WBS1785\"]'),(326,'inventory.source.items.cleanup','[\"Westminster 1490\"]'),(327,'inventory.source.items.cleanup','[\"Westminster 1860\"]'),(328,'inventory.source.items.cleanup','[\"Woburn 1490\"]'),(329,'inventory.source.items.cleanup','[\"Woburn 1675\"]'),(330,'inventory.source.items.cleanup','[\"Woburn 1765\"]'),(331,'inventory.source.items.cleanup','[\"115.0046.694\"]'),(332,'inventory.source.items.cleanup','[\"115.0046.695\"]'),(333,'inventory.source.items.cleanup','[\"115.0049.940\"]'),(334,'inventory.source.items.cleanup','[\"115.0049.989\"]'),(335,'inventory.source.items.cleanup','[\"115.0049.990\"]'),(336,'inventory.source.items.cleanup','[\"115.0050.044\"]'),(337,'inventory.source.items.cleanup','[\"115.0051.172\"]'),(338,'inventory.source.items.cleanup','[\"115.0061.579\"]'),(339,'inventory.source.items.cleanup','[\"115.0250.326\"]'),(340,'inventory.source.items.cleanup','[\"115.0250.327\"]'),(341,'inventory.source.items.cleanup','[\"115.0251.257\"]'),(342,'inventory.source.items.cleanup','[\"115.0280.225\"]'),(343,'inventory.source.items.cleanup','[\"115.0280.227\"]'),(344,'inventory.source.items.cleanup','[\"115.0311.211\"]'),(345,'inventory.source.items.cleanup','[\"115.0311.215\"]'),(346,'inventory.source.items.cleanup','[\"115.0364.026\"]'),(347,'inventory.source.items.cleanup','[\"115.0391.460\"]'),(348,'inventory.source.items.cleanup','[\"115.0393.974\"]'),(349,'inventory.source.items.cleanup','[\"115.0393.976\"]'),(350,'inventory.source.items.cleanup','[\"115.0523.286\"]'),(351,'inventory.source.items.cleanup','[\"115.0567.593\"]'),(352,'inventory.source.items.cleanup','[\"115.0567.594\"]'),(353,'inventory.source.items.cleanup','[\"115.0567.596\"]'),(354,'inventory.source.items.cleanup','[\"115.0567.598\"]'),(355,'inventory.source.items.cleanup','[\"115.0567.599\"]'),(356,'inventory.source.items.cleanup','[\"115.0567.600\"]'),(357,'inventory.source.items.cleanup','[\"115.0567.654\"]'),(358,'inventory.source.items.cleanup','[\"115.0605.458\"]'),(359,'inventory.source.items.cleanup','[\"115.0605.460\"]'),(360,'inventory.source.items.cleanup','[\"115.0605.461\"]'),(361,'inventory.source.items.cleanup','[\"115.0605.462\"]'),(362,'inventory.source.items.cleanup','[\"115.0625.185\"]'),(363,'inventory.source.items.cleanup','[\"115.0625.187\"]'),(364,'inventory.source.items.cleanup','[\"115.0625.188\"]'),(365,'inventory.source.items.cleanup','[\"115.0625.190\"]'),(366,'inventory.source.items.cleanup','[\"115.0635.794\"]'),(367,'inventory.source.items.cleanup','[\"115.0637.111\"]'),(368,'inventory.source.items.cleanup','[\"115.0637.112\"]'),(369,'inventory.source.items.cleanup','[\"115.0638.826\"]'),(370,'inventory.source.items.cleanup','[\"115.0638.827\"]'),(371,'inventory.source.items.cleanup','[\"115.0638.841\"]'),(372,'inventory.source.items.cleanup','[\"115.0638.846\"]'),(373,'inventory.source.items.cleanup','[\"115.0638.861\"]'),(374,'inventory.source.items.cleanup','[\"115.0653.298\"]'),(375,'inventory.source.items.cleanup','[\"115.0653.371\"]'),(376,'inventory.source.items.cleanup','[\"115.0653.379\"]'),(377,'inventory.source.items.cleanup','[\"115.0653.382\"]'),(378,'inventory.source.items.cleanup','[\"115.0653.395\"]'),(379,'inventory.source.items.cleanup','[\"115.0653.398\"]'),(380,'inventory.source.items.cleanup','[\"115.0653.401\"]'),(381,'inventory.source.items.cleanup','[\"115.0653.404\"]'),(382,'inventory.source.items.cleanup','[\"115.0659.322\"]'),(383,'inventory.source.items.cleanup','[\"115.0659.348\"]'),(384,'inventory.source.items.cleanup','[\"115.0689.095\"]'),(385,'inventory.source.items.cleanup','[\"115.0689.097\"]'),(386,'inventory.source.items.cleanup','[\"115.0689.617\"]'),(387,'inventory.source.items.cleanup','[\"115.0689.693\"]'),(388,'inventory.source.items.cleanup','[\"115.0690.598\"]'),(389,'inventory.source.items.cleanup','[\"115.0691.515\"]'),(390,'inventory.source.items.cleanup','[\"115.0691.517\"]'),(391,'inventory.source.items.cleanup','[\"120.0615.357\"]'),(392,'inventory.source.items.cleanup','[\"120.0615.447\"]'),(393,'inventory.source.items.cleanup','[\"120.0615.451\"]'),(394,'inventory.source.items.cleanup','[\"120.0621.228\"]'),(395,'inventory.source.items.cleanup','[\"120.0621.229\"]'),(396,'inventory.source.items.cleanup','[\"120.0621.230\"]'),(397,'inventory.source.items.cleanup','[\"120.0621.313\"]'),(398,'inventory.source.items.cleanup','[\"13111000\"]'),(399,'inventory.source.items.cleanup','[\"13112000\"]'),(400,'inventory.source.items.cleanup','[\"13113000\"]'),(401,'inventory.source.items.cleanup','[\"13114000\"]'),(402,'inventory.source.items.cleanup','[\"13115000\"]'),(403,'inventory.source.items.cleanup','[\"13116000\"]'),(404,'inventory.source.items.cleanup','[\"13117000\"]'),(405,'inventory.source.items.cleanup','[\"13122000\"]'),(406,'inventory.source.items.cleanup','[\"13123000\"]'),(407,'inventory.source.items.cleanup','[\"1314\"]'),(408,'inventory.source.items.cleanup','[\"13151\"]'),(409,'inventory.source.items.cleanup','[\"13161000\"]'),(410,'inventory.source.items.cleanup','[\"13171\"]'),(411,'inventory.source.items.cleanup','[\"13201000\"]'),(412,'inventory.source.items.cleanup','[\"13242000\"]'),(413,'inventory.source.items.cleanup','[\"13261000\"]'),(414,'inventory.source.items.cleanup','[\"13264000\"]'),(415,'inventory.source.items.cleanup','[\"13280001\"]'),(416,'inventory.source.items.cleanup','[\"13303000\"]'),(417,'inventory.source.items.cleanup','[\"13304000\"]'),(418,'inventory.source.items.cleanup','[\"13319000\"]'),(419,'inventory.source.items.cleanup','[\"13341IG0\"]'),(420,'inventory.source.items.cleanup','[\"13414000\"]'),(421,'inventory.source.items.cleanup','[\"13423000\"]'),(422,'inventory.source.items.cleanup','[\"13425\"]'),(423,'inventory.source.items.cleanup','[\"14495000\"]'),(424,'inventory.source.items.cleanup','[\"14820000\"]'),(425,'inventory.source.items.cleanup','[\"14821000\"]'),(426,'inventory.source.items.cleanup','[\"14822000\"]'),(427,'inventory.source.items.cleanup','[\"15705000\"]'),(428,'inventory.source.items.cleanup','[\"15706000\"]'),(429,'inventory.source.items.cleanup','[\"15707000\"]'),(430,'inventory.source.items.cleanup','[\"15708000\"]'),(431,'inventory.source.items.cleanup','[\"15734400\"]'),(432,'inventory.source.items.cleanup','[\"15735400\"]'),(433,'inventory.source.items.cleanup','[\"15737400\"]'),(434,'inventory.source.items.cleanup','[\"15738\"]'),(435,'inventory.source.items.cleanup','[\"15741000\"]'),(436,'inventory.source.items.cleanup','[\"15742000\"]'),(437,'inventory.source.items.cleanup','[\"15743000\"]'),(438,'inventory.source.items.cleanup','[\"15744000\"]'),(439,'inventory.source.items.cleanup','[\"15747000\"]'),(440,'inventory.source.items.cleanup','[\"15748000\"]'),(441,'inventory.source.items.cleanup','[\"15756000\"]'),(442,'inventory.source.items.cleanup','[\"15757000\"]'),(443,'inventory.source.items.cleanup','[\"15758000\"]'),(444,'inventory.source.items.cleanup','[\"15761000\"]'),(445,'inventory.source.items.cleanup','[\"15765000\"]'),(446,'inventory.source.items.cleanup','[\"15767000\"]'),(447,'inventory.source.items.cleanup','[\"15768000\"]'),(448,'inventory.source.items.cleanup','[\"19285001\"]'),(449,'inventory.source.items.cleanup','[\"19286001\"]'),(450,'inventory.source.items.cleanup','[\"19287001\"]'),(451,'inventory.source.items.cleanup','[\"19309000\"]'),(452,'inventory.source.items.cleanup','[\"19316000\"]'),(453,'inventory.source.items.cleanup','[\"19345001\"]'),(454,'inventory.source.items.cleanup','[\"19346001\"]'),(455,'inventory.source.items.cleanup','[\"19381000\"]'),(456,'inventory.source.items.cleanup','[\"19382000\"]'),(457,'inventory.source.items.cleanup','[\"19383000\"]'),(458,'inventory.source.items.cleanup','[\"19386000\"]'),(459,'inventory.source.items.cleanup','[\"19388000\"]'),(460,'inventory.source.items.cleanup','[\"19408001\"]'),(461,'inventory.source.items.cleanup','[\"19450002\"]'),(462,'inventory.source.items.cleanup','[\"19451002\"]'),(463,'inventory.source.items.cleanup','[\"19507002\"]'),(464,'inventory.source.items.cleanup','[\"19549002\"]'),(465,'inventory.source.items.cleanup','[\"19571002\"]'),(466,'inventory.source.items.cleanup','[\"19573002\"]'),(467,'inventory.source.items.cleanup','[\"19575001\"]'),(468,'inventory.source.items.cleanup','[\"19578001\"]'),(469,'inventory.source.items.cleanup','[\"19895000\"]'),(470,'inventory.source.items.cleanup','[\"19896000\"]'),(471,'inventory.source.items.cleanup','[\"19898000\"]'),(472,'inventory.source.items.cleanup','[\"19919000\"]'),(473,'inventory.source.items.cleanup','[\"19919IG0\"]'),(474,'inventory.source.items.cleanup','[\"19920000\"]'),(475,'inventory.source.items.cleanup','[\"19920IG0\"]'),(476,'inventory.source.items.cleanup','[\"19929000\"]'),(477,'inventory.source.items.cleanup','[\"19929IG0\"]'),(478,'inventory.source.items.cleanup','[\"19930000\"]'),(479,'inventory.source.items.cleanup','[\"19930IG0\"]'),(480,'inventory.source.items.cleanup','[\"19936000\"]'),(481,'inventory.source.items.cleanup','[\"19948000\"]'),(482,'inventory.source.items.cleanup','[\"19967001\"]'),(483,'inventory.source.items.cleanup','[\"19968000\"]'),(484,'inventory.source.items.cleanup','[\"19968LS0\"]'),(485,'inventory.source.items.cleanup','[\"19969LS0\"]'),(486,'inventory.source.items.cleanup','[\"19976001\"]'),(487,'inventory.source.items.cleanup','[\"20181000\"]'),(488,'inventory.source.items.cleanup','[\"20187000\"]'),(489,'inventory.source.items.cleanup','[\"20208002\"]'),(490,'inventory.source.items.cleanup','[\"20216001\"]'),(491,'inventory.source.items.cleanup','[\"20296001\"]'),(492,'inventory.source.items.cleanup','[\"20299001\"]'),(493,'inventory.source.items.cleanup','[\"20301000\"]'),(494,'inventory.source.items.cleanup','[\"20348000\"]'),(495,'inventory.source.items.cleanup','[\"20351000\"]'),(496,'inventory.source.items.cleanup','[\"20389000\"]'),(497,'inventory.source.items.cleanup','[\"20414000\"]'),(498,'inventory.source.items.cleanup','[\"20414IG0\"]'),(499,'inventory.source.items.cleanup','[\"20415IG0\"]'),(500,'inventory.source.items.cleanup','[\"21107000\"]'),(501,'inventory.source.items.cleanup','[\"21107IG0\"]'),(502,'inventory.source.items.cleanup','[\"23029000\"]'),(503,'inventory.source.items.cleanup','[\"23037002\"]'),(504,'inventory.source.items.cleanup','[\"23039002\"]'),(505,'inventory.source.items.cleanup','[\"23049002\"]'),(506,'inventory.source.items.cleanup','[\"23055002\"]'),(507,'inventory.source.items.cleanup','[\"23064000\"]'),(508,'inventory.source.items.cleanup','[\"23106001\"]'),(509,'inventory.source.items.cleanup','[\"23135000\"]'),(510,'inventory.source.items.cleanup','[\"23140000\"]'),(511,'inventory.source.items.cleanup','[\"23141000\"]'),(512,'inventory.source.items.cleanup','[\"23145000\"]'),(513,'inventory.source.items.cleanup','[\"23297000\"]'),(514,'inventory.source.items.cleanup','[\"23303000\"]'),(515,'inventory.source.items.cleanup','[\"23310000\"]'),(516,'inventory.source.items.cleanup','[\"23310IG0\"]'),(517,'inventory.source.items.cleanup','[\"23313000\"]'),(518,'inventory.source.items.cleanup','[\"23313IG0\"]'),(519,'inventory.source.items.cleanup','[\"23315000\"]'),(520,'inventory.source.items.cleanup','[\"23315IG0\"]'),(521,'inventory.source.items.cleanup','[\"23316IG0\"]'),(522,'inventory.source.items.cleanup','[\"23317000\"]'),(523,'inventory.source.items.cleanup','[\"23317IG0\"]'),(524,'inventory.source.items.cleanup','[\"23318000\"]'),(525,'inventory.source.items.cleanup','[\"23318IG0\"]'),(526,'inventory.source.items.cleanup','[\"23323001\"]'),(527,'inventory.source.items.cleanup','[\"23324001\"]'),(528,'inventory.source.items.cleanup','[\"23325000\"]'),(529,'inventory.source.items.cleanup','[\"23327000\"]'),(530,'inventory.source.items.cleanup','[\"23330000\"]'),(531,'inventory.source.items.cleanup','[\"23334000\"]'),(532,'inventory.source.items.cleanup','[\"23337000\"]'),(533,'inventory.source.items.cleanup','[\"2337420E\"]'),(534,'inventory.source.items.cleanup','[\"2337700E\"]'),(535,'inventory.source.items.cleanup','[\"23379001\"]'),(536,'inventory.source.items.cleanup','[\"2338010E\"]'),(537,'inventory.source.items.cleanup','[\"2338220E\"]'),(538,'inventory.source.items.cleanup','[\"2338510E\"]'),(539,'inventory.source.items.cleanup','[\"2338720E\"]'),(540,'inventory.source.items.cleanup','[\"2338920E\"]'),(541,'inventory.source.items.cleanup','[\"2339000E\"]'),(542,'inventory.source.items.cleanup','[\"2339200E\"]'),(543,'inventory.source.items.cleanup','[\"2339410E\"]'),(544,'inventory.source.items.cleanup','[\"2339600E\"]'),(545,'inventory.source.items.cleanup','[\"23406000\"]'),(546,'inventory.source.items.cleanup','[\"23425000\"]'),(547,'inventory.source.items.cleanup','[\"23427000\"]'),(548,'inventory.source.items.cleanup','[\"23428000\"]'),(549,'inventory.source.items.cleanup','[\"23428LS0\"]'),(550,'inventory.source.items.cleanup','[\"23430000\"]'),(551,'inventory.source.items.cleanup','[\"23430LS0\"]'),(552,'inventory.source.items.cleanup','[\"23431LS0\"]'),(553,'inventory.source.items.cleanup','[\"23432000\"]'),(554,'inventory.source.items.cleanup','[\"23444000\"]'),(555,'inventory.source.items.cleanup','[\"23445000\"]'),(556,'inventory.source.items.cleanup','[\"23446000\"]'),(557,'inventory.source.items.cleanup','[\"23447000\"]'),(558,'inventory.source.items.cleanup','[\"23448002\"]'),(559,'inventory.source.items.cleanup','[\"23449002\"]'),(560,'inventory.source.items.cleanup','[\"23450001\"]'),(561,'inventory.source.items.cleanup','[\"23451001\"]'),(562,'inventory.source.items.cleanup','[\"23462001\"]'),(563,'inventory.source.items.cleanup','[\"23463001\"]'),(564,'inventory.source.items.cleanup','[\"23491001\"]'),(565,'inventory.source.items.cleanup','[\"23537002\"]'),(566,'inventory.source.items.cleanup','[\"23541001\"]'),(567,'inventory.source.items.cleanup','[\"23726003\"]'),(568,'inventory.source.items.cleanup','[\"24036LS0\"]'),(569,'inventory.source.items.cleanup','[\"25102000\"]'),(570,'inventory.source.items.cleanup','[\"25104000\"]'),(571,'inventory.source.items.cleanup','[\"25109000\"]'),(572,'inventory.source.items.cleanup','[\"25113000\"]'),(573,'inventory.source.items.cleanup','[\"25128000\"]'),(574,'inventory.source.items.cleanup','[\"25129000\"]'),(575,'inventory.source.items.cleanup','[\"25136000\"]'),(576,'inventory.source.items.cleanup','[\"25137000\"]'),(577,'inventory.source.items.cleanup','[\"30189000\"]'),(578,'inventory.source.items.cleanup','[\"30193000\"]'),(579,'inventory.source.items.cleanup','[\"30269000\"]'),(580,'inventory.source.items.cleanup','[\"30269DC0\"]'),(581,'inventory.source.items.cleanup','[\"30270000\"]'),(582,'inventory.source.items.cleanup','[\"30270DC0\"]'),(583,'inventory.source.items.cleanup','[\"3108\"]'),(584,'inventory.source.items.cleanup','[\"31081000\"]'),(585,'inventory.source.items.cleanup','[\"31082000\"]'),(586,'inventory.source.items.cleanup','[\"31084000\"]'),(587,'inventory.source.items.cleanup','[\"31085000\"]'),(588,'inventory.source.items.cleanup','[\"31086000\"]'),(589,'inventory.source.items.cleanup','[\"31087000\"]'),(590,'inventory.source.items.cleanup','[\"31088000\"]'),(591,'inventory.source.items.cleanup','[\"31121000\"]'),(592,'inventory.source.items.cleanup','[\"31130000\"]'),(593,'inventory.source.items.cleanup','[\"31166000\"]'),(594,'inventory.source.items.cleanup','[\"31171000\"]'),(595,'inventory.source.items.cleanup','[\"31172000\"]'),(596,'inventory.source.items.cleanup','[\"31173000\"]'),(597,'inventory.source.items.cleanup','[\"31174000\"]'),(598,'inventory.source.items.cleanup','[\"31183000\"]'),(599,'inventory.source.items.cleanup','[\"31184000\"]'),(600,'inventory.source.items.cleanup','[\"31185000\"]'),(601,'inventory.source.items.cleanup','[\"31186000\"]'),(602,'inventory.source.items.cleanup','[\"31187000\"]'),(603,'inventory.source.items.cleanup','[\"31190000\"]'),(604,'inventory.source.items.cleanup','[\"31203000\"]'),(605,'inventory.source.items.cleanup','[\"31204000\"]'),(606,'inventory.source.items.cleanup','[\"31251000\"]'),(607,'inventory.source.items.cleanup','[\"31255000\"]'),(608,'inventory.source.items.cleanup','[\"31280000\"]'),(609,'inventory.source.items.cleanup','[\"31285000\"]'),(610,'inventory.source.items.cleanup','[\"31379000\"]'),(611,'inventory.source.items.cleanup','[\"31442000\"]'),(612,'inventory.source.items.cleanup','[\"31451000\"]'),(613,'inventory.source.items.cleanup','[\"31454000\"]'),(614,'inventory.source.items.cleanup','[\"31471000\"]'),(615,'inventory.source.items.cleanup','[\"31480000\"]'),(616,'inventory.source.items.cleanup','[\"31482000\"]'),(617,'inventory.source.items.cleanup','[\"31484000\"]'),(618,'inventory.source.items.cleanup','[\"31487000\"]'),(619,'inventory.source.items.cleanup','[\"31493000\"]'),(620,'inventory.source.items.cleanup','[\"31494000\"]'),(621,'inventory.source.items.cleanup','[\"31509000\"]'),(622,'inventory.source.items.cleanup','[\"31513000\"]'),(623,'inventory.source.items.cleanup','[\"31517000\"]'),(624,'inventory.source.items.cleanup','[\"31518000\"]'),(625,'inventory.source.items.cleanup','[\"31519000\"]'),(626,'inventory.source.items.cleanup','[\"31539000\"]'),(627,'inventory.source.items.cleanup','[\"31603000\"]'),(628,'inventory.source.items.cleanup','[\"31604000\"]'),(629,'inventory.source.items.cleanup','[\"31607000\"]'),(630,'inventory.source.items.cleanup','[\"31608000\"]'),(631,'inventory.source.items.cleanup','[\"31609000\"]'),(632,'inventory.source.items.cleanup','[\"31621000\"]'),(633,'inventory.source.items.cleanup','[\"31685000\"]'),(634,'inventory.source.items.cleanup','[\"31686000\"]'),(635,'inventory.source.items.cleanup','[\"3173\"]'),(636,'inventory.source.items.cleanup','[\"31730000\"]'),(637,'inventory.source.items.cleanup','[\"31803000\"]'),(638,'inventory.source.items.cleanup','[\"31806000\"]'),(639,'inventory.source.items.cleanup','[\"31815000\"]'),(640,'inventory.source.items.cleanup','[\"31816000\"]'),(641,'inventory.source.items.cleanup','[\"31823000\"]'),(642,'inventory.source.items.cleanup','[\"31825000\"]'),(643,'inventory.source.items.cleanup','[\"3191\"]'),(644,'inventory.source.items.cleanup','[\"31913000\"]'),(645,'inventory.source.items.cleanup','[\"31917000\"]'),(646,'inventory.source.items.cleanup','[\"31920000\"]'),(647,'inventory.source.items.cleanup','[\"31922000\"]'),(648,'inventory.source.items.cleanup','[\"31923000\"]'),(649,'inventory.source.items.cleanup','[\"31926000\"]'),(650,'inventory.source.items.cleanup','[\"31927000\"]'),(651,'inventory.source.items.cleanup','[\"31928000\"]'),(652,'inventory.source.items.cleanup','[\"31930000\"]'),(653,'inventory.source.items.cleanup','[\"31931000\"]'),(654,'inventory.source.items.cleanup','[\"31938000\"]'),(655,'inventory.source.items.cleanup','[\"31940000\"]'),(656,'inventory.source.items.cleanup','[\"31945000\"]'),(657,'inventory.source.items.cleanup','[\"31946000\"]'),(658,'inventory.source.items.cleanup','[\"31947000\"]'),(659,'inventory.source.items.cleanup','[\"31948000\"]'),(660,'inventory.source.items.cleanup','[\"31952000\"]'),(661,'inventory.source.items.cleanup','[\"32067000\"]'),(662,'inventory.source.items.cleanup','[\"32080000\"]'),(663,'inventory.source.items.cleanup','[\"32168000\"]'),(664,'inventory.source.items.cleanup','[\"32193000\"]'),(665,'inventory.source.items.cleanup','[\"32208001\"]'),(666,'inventory.source.items.cleanup','[\"32211001\"]'),(667,'inventory.source.items.cleanup','[\"32259002\"]'),(668,'inventory.source.items.cleanup','[\"32321002\"]'),(669,'inventory.source.items.cleanup','[\"32322002\"]'),(670,'inventory.source.items.cleanup','[\"3246720L\"]'),(671,'inventory.source.items.cleanup','[\"32468003\"]'),(672,'inventory.source.items.cleanup','[\"3246820L\"]'),(673,'inventory.source.items.cleanup','[\"3246920E\"]'),(674,'inventory.source.items.cleanup','[\"32488000\"]'),(675,'inventory.source.items.cleanup','[\"32488DC0\"]'),(676,'inventory.source.items.cleanup','[\"32531000\"]'),(677,'inventory.source.items.cleanup','[\"32532000\"]'),(678,'inventory.source.items.cleanup','[\"32540000\"]'),(679,'inventory.source.items.cleanup','[\"32542000\"]'),(680,'inventory.source.items.cleanup','[\"32543000\"]'),(681,'inventory.source.items.cleanup','[\"32548000\"]'),(682,'inventory.source.items.cleanup','[\"32553002\"]'),(683,'inventory.source.items.cleanup','[\"32618002\"]'),(684,'inventory.source.items.cleanup','[\"32629002\"]'),(685,'inventory.source.items.cleanup','[\"32638000\"]'),(686,'inventory.source.items.cleanup','[\"32661003\"]'),(687,'inventory.source.items.cleanup','[\"32663003\"]'),(688,'inventory.source.items.cleanup','[\"32757000\"]'),(689,'inventory.source.items.cleanup','[\"32786000\"]'),(690,'inventory.source.items.cleanup','[\"3282400L\"]'),(691,'inventory.source.items.cleanup','[\"3282500E\"]'),(692,'inventory.source.items.cleanup','[\"3282500L\"]'),(693,'inventory.source.items.cleanup','[\"32831000\"]'),(694,'inventory.source.items.cleanup','[\"32832000\"]'),(695,'inventory.source.items.cleanup','[\"32839000\"]'),(696,'inventory.source.items.cleanup','[\"32842000\"]'),(697,'inventory.source.items.cleanup','[\"32898001\"]'),(698,'inventory.source.items.cleanup','[\"32918000\"]'),(699,'inventory.source.items.cleanup','[\"32926002\"]'),(700,'inventory.source.items.cleanup','[\"32929002\"]'),(701,'inventory.source.items.cleanup','[\"32935001\"]'),(702,'inventory.source.items.cleanup','[\"32950000\"]'),(703,'inventory.source.items.cleanup','[\"33155002\"]'),(704,'inventory.source.items.cleanup','[\"33188002\"]'),(705,'inventory.source.items.cleanup','[\"3319020E\"]'),(706,'inventory.source.items.cleanup','[\"33244002\"]'),(707,'inventory.source.items.cleanup','[\"33265002\"]'),(708,'inventory.source.items.cleanup','[\"3326520L\"]'),(709,'inventory.source.items.cleanup','[\"33281002\"]'),(710,'inventory.source.items.cleanup','[\"3328120E\"]'),(711,'inventory.source.items.cleanup','[\"33300002\"]'),(712,'inventory.source.items.cleanup','[\"33390002\"]'),(713,'inventory.source.items.cleanup','[\"33412002\"]'),(714,'inventory.source.items.cleanup','[\"33565002\"]'),(715,'inventory.source.items.cleanup','[\"33569002\"]'),(716,'inventory.source.items.cleanup','[\"33590002\"]'),(717,'inventory.source.items.cleanup','[\"33591002\"]'),(718,'inventory.source.items.cleanup','[\"33628001\"]'),(719,'inventory.source.items.cleanup','[\"33636001\"]'),(720,'inventory.source.items.cleanup','[\"33770002\"]'),(721,'inventory.source.items.cleanup','[\"33850000\"]'),(722,'inventory.source.items.cleanup','[\"33977002\"]'),(723,'inventory.source.items.cleanup','[\"34170001\"]'),(724,'inventory.source.items.cleanup','[\"34294001\"]'),(725,'inventory.source.items.cleanup','[\"34448000\"]'),(726,'inventory.source.items.cleanup','[\"34466001\"]'),(727,'inventory.source.items.cleanup','[\"34469001\"]'),(728,'inventory.source.items.cleanup','[\"34484001\"]'),(729,'inventory.source.items.cleanup','[\"34508000\"]'),(730,'inventory.source.items.cleanup','[\"34509000\"]'),(731,'inventory.source.items.cleanup','[\"454803\"]'),(732,'inventory.source.items.cleanup','[\"516672\"]'),(733,'inventory.source.items.cleanup','[\"516688\"]'),(734,'inventory.source.items.cleanup','[\"516692\"]'),(735,'inventory.source.items.cleanup','[\"516697\"]'),(736,'inventory.source.items.cleanup','[\"517621\"]'),(737,'inventory.source.items.cleanup','[\"518406\"]'),(738,'inventory.source.items.cleanup','[\"518434\"]'),(739,'inventory.source.items.cleanup','[\"518813\"]'),(740,'inventory.source.items.cleanup','[\"520764\"]'),(741,'inventory.source.items.cleanup','[\"520766\"]'),(742,'inventory.source.items.cleanup','[\"520840\"]'),(743,'inventory.source.items.cleanup','[\"521267\"]'),(744,'inventory.source.items.cleanup','[\"521277\"]'),(745,'inventory.source.items.cleanup','[\"521476\"]'),(746,'inventory.source.items.cleanup','[\"521547\"]'),(747,'inventory.source.items.cleanup','[\"523118\"]'),(748,'inventory.source.items.cleanup','[\"523120\"]'),(749,'inventory.source.items.cleanup','[\"523121\"]'),(750,'inventory.source.items.cleanup','[\"523122\"]'),(751,'inventory.source.items.cleanup','[\"523123\"]'),(752,'inventory.source.items.cleanup','[\"523128\"]'),(753,'inventory.source.items.cleanup','[\"523286\"]'),(754,'inventory.source.items.cleanup','[\"524287\"]'),(755,'inventory.source.items.cleanup','[\"524813\"]'),(756,'inventory.source.items.cleanup','[\"525198\"]'),(757,'inventory.source.items.cleanup','[\"525333\"]'),(758,'inventory.source.items.cleanup','[\"525335\"]'),(759,'inventory.source.items.cleanup','[\"525791\"]'),(760,'inventory.source.items.cleanup','[\"525793\"]'),(761,'inventory.source.items.cleanup','[\"525806\"]'),(762,'inventory.source.items.cleanup','[\"525807\"]'),(763,'inventory.source.items.cleanup','[\"526142\"]'),(764,'inventory.source.items.cleanup','[\"526143\"]'),(765,'inventory.source.items.cleanup','[\"526148\"]'),(766,'inventory.source.items.cleanup','[\"526241\"]'),(767,'inventory.source.items.cleanup','[\"526242\"]'),(768,'inventory.source.items.cleanup','[\"526311\"]'),(769,'inventory.source.items.cleanup','[\"526361\"]'),(770,'inventory.source.items.cleanup','[\"526405\"]'),(771,'inventory.source.items.cleanup','[\"526560\"]'),(772,'inventory.source.items.cleanup','[\"526614\"]'),(773,'inventory.source.items.cleanup','[\"526615\"]'),(774,'inventory.source.items.cleanup','[\"526616\"]'),(775,'inventory.source.items.cleanup','[\"526635\"]'),(776,'inventory.source.items.cleanup','[\"526649\"]'),(777,'inventory.source.items.cleanup','[\"526657\"]'),(778,'inventory.source.items.cleanup','[\"526660\"]'),(779,'inventory.source.items.cleanup','[\"526665\"]'),(780,'inventory.source.items.cleanup','[\"526668\"]'),(781,'inventory.source.items.cleanup','[\"526669\"]'),(782,'inventory.source.items.cleanup','[\"526677\"]'),(783,'inventory.source.items.cleanup','[\"526679\"]'),(784,'inventory.source.items.cleanup','[\"526681\"]'),(785,'inventory.source.items.cleanup','[\"526683\"]'),(786,'inventory.source.items.cleanup','[\"526684\"]'),(787,'inventory.source.items.cleanup','[\"526689\"]'),(788,'inventory.source.items.cleanup','[\"526702\"]'),(789,'inventory.source.items.cleanup','[\"526703\"]'),(790,'inventory.source.items.cleanup','[\"526704\"]'),(791,'inventory.source.items.cleanup','[\"526707\"]'),(792,'inventory.source.items.cleanup','[\"526959\"]'),(793,'inventory.source.items.cleanup','[\"527462\"]'),(794,'inventory.source.items.cleanup','[\"527463\"]'),(795,'inventory.source.items.cleanup','[\"527466\"]'),(796,'inventory.source.items.cleanup','[\"527467\"]'),(797,'inventory.source.items.cleanup','[\"527656\"]'),(798,'inventory.source.items.cleanup','[\"527731\"]'),(799,'inventory.source.items.cleanup','[\"527733\"]'),(800,'inventory.source.items.cleanup','[\"5A0109C02\"]'),(801,'inventory.source.items.cleanup','[\"5A0143C00\"]'),(802,'inventory.source.items.cleanup','[\"5A4743C00\"]'),(803,'inventory.source.items.cleanup','[\"5A6060C00\"]'),(804,'inventory.source.items.cleanup','[\"7107\"]'),(805,'inventory.source.items.cleanup','[\"71071010\"]'),(806,'inventory.source.items.cleanup','[\"71072000 71073000\"]'),(807,'inventory.source.items.cleanup','[\"71077000\"]'),(808,'inventory.source.items.cleanup','[\"71078000\"]'),(809,'inventory.source.items.cleanup','[\"7109\"]'),(810,'inventory.source.items.cleanup','[\"71095000\"]'),(811,'inventory.source.items.cleanup','[\"7110\"]'),(812,'inventory.source.items.cleanup','[\"71102000 71103000\"]'),(813,'inventory.source.items.cleanup','[\"71104000\"]'),(814,'inventory.source.items.cleanup','[\"71105000\"]'),(815,'inventory.source.items.cleanup','[\"71107000\"]'),(816,'inventory.source.items.cleanup','[\"71120000\"]'),(817,'inventory.source.items.cleanup','[\"7113\"]'),(818,'inventory.source.items.cleanup','[\"71133000\"]'),(819,'inventory.source.items.cleanup','[\"71170000\"]'),(820,'inventory.source.items.cleanup','[\"71171000\"]'),(821,'inventory.source.items.cleanup','[\"71200000\"]'),(822,'inventory.source.items.cleanup','[\"71204000\"]'),(823,'inventory.source.items.cleanup','[\"7122\"]'),(824,'inventory.source.items.cleanup','[\"71220000\"]'),(825,'inventory.source.items.cleanup','[\"71225000\"]'),(826,'inventory.source.items.cleanup','[\"71243000\"]'),(827,'inventory.source.items.cleanup','[\"71263000\"]'),(828,'inventory.source.items.cleanup','[\"71280000\"]'),(829,'inventory.source.items.cleanup','[\"71286000\"]'),(830,'inventory.source.items.cleanup','[\"71290000\"]'),(831,'inventory.source.items.cleanup','[\"71310000\"]'),(832,'inventory.source.items.cleanup','[\"71311000\"]'),(833,'inventory.source.items.cleanup','[\"71312000\"]'),(834,'inventory.source.items.cleanup','[\"71313000\"]'),(835,'inventory.source.items.cleanup','[\"71314000\"]'),(836,'inventory.source.items.cleanup','[\"71315000\"]'),(837,'inventory.source.items.cleanup','[\"71400000\"]'),(838,'inventory.source.items.cleanup','[\"71401000\"]'),(839,'inventory.source.items.cleanup','[\"71405000\"]'),(840,'inventory.source.items.cleanup','[\"71406000\"]'),(841,'inventory.source.items.cleanup','[\"71407000\"]'),(842,'inventory.source.items.cleanup','[\"71409000\"]'),(843,'inventory.source.items.cleanup','[\"71410000\"]'),(844,'inventory.source.items.cleanup','[\"71430000\"]'),(845,'inventory.source.items.cleanup','[\"71474000\"]'),(846,'inventory.source.items.cleanup','[\"71550670\"]'),(847,'inventory.source.items.cleanup','[\"71551670\"]'),(848,'inventory.source.items.cleanup','[\"71600000\"]'),(849,'inventory.source.items.cleanup','[\"71601000\"]'),(850,'inventory.source.items.cleanup','[\"71605000\"]'),(851,'inventory.source.items.cleanup','[\"71606000\"]'),(852,'inventory.source.items.cleanup','[\"71607000\"]'),(853,'inventory.source.items.cleanup','[\"71630000\"]'),(854,'inventory.source.items.cleanup','[\"71666000\"]'),(855,'inventory.source.items.cleanup','[\"71700000\"]'),(856,'inventory.source.items.cleanup','[\"71701000 71702000\"]'),(857,'inventory.source.items.cleanup','[\"71703000 71704000\"]'),(858,'inventory.source.items.cleanup','[\"71705000\"]'),(859,'inventory.source.items.cleanup','[\"71706000\"]'),(860,'inventory.source.items.cleanup','[\"71710000\"]'),(861,'inventory.source.items.cleanup','[\"71711000 71712000\"]'),(862,'inventory.source.items.cleanup','[\"71713000 71714000\"]'),(863,'inventory.source.items.cleanup','[\"71715000\"]'),(864,'inventory.source.items.cleanup','[\"7172\"]'),(865,'inventory.source.items.cleanup','[\"71729000\"]'),(866,'inventory.source.items.cleanup','[\"71730000\"]'),(867,'inventory.source.items.cleanup','[\"71731000\"]'),(868,'inventory.source.items.cleanup','[\"71732000\"]'),(869,'inventory.source.items.cleanup','[\"71733000\"]'),(870,'inventory.source.items.cleanup','[\"71734000\"]'),(871,'inventory.source.items.cleanup','[\"71740000\"]'),(872,'inventory.source.items.cleanup','[\"71745000\"]'),(873,'inventory.source.items.cleanup','[\"71746000\"]'),(874,'inventory.source.items.cleanup','[\"71747000\"]'),(875,'inventory.source.items.cleanup','[\"71748000\"]'),(876,'inventory.source.items.cleanup','[\"71750000\"]'),(877,'inventory.source.items.cleanup','[\"71752000\"]'),(878,'inventory.source.items.cleanup','[\"71753000\"]'),(879,'inventory.source.items.cleanup','[\"71754000 71755000\"]'),(880,'inventory.source.items.cleanup','[\"71760000\"]'),(881,'inventory.source.items.cleanup','[\"71765000\"]'),(882,'inventory.source.items.cleanup','[\"71766000\"]'),(883,'inventory.source.items.cleanup','[\"71768000\"]'),(884,'inventory.source.items.cleanup','[\"71830000\"]'),(885,'inventory.source.items.cleanup','[\"71832000\"]'),(886,'inventory.source.items.cleanup','[\"71833000\"]'),(887,'inventory.source.items.cleanup','[\"71835000\"]'),(888,'inventory.source.items.cleanup','[\"71836000\"]'),(889,'inventory.source.items.cleanup','[\"71837000\"]'),(890,'inventory.source.items.cleanup','[\"71839000\"]'),(891,'inventory.source.items.cleanup','[\"72010000\"]'),(892,'inventory.source.items.cleanup','[\"72013000 72014000\"]'),(893,'inventory.source.items.cleanup','[\"72017000\"]'),(894,'inventory.source.items.cleanup','[\"72020000 72021000\"]'),(895,'inventory.source.items.cleanup','[\"72022000 72023000\"]'),(896,'inventory.source.items.cleanup','[\"72024000 72025000\"]'),(897,'inventory.source.items.cleanup','[\"72031000 72032000\"]'),(898,'inventory.source.items.cleanup','[\"7204\"]'),(899,'inventory.source.items.cleanup','[\"72040000 72041000\"]'),(900,'inventory.source.items.cleanup','[\"72105000\"]'),(901,'inventory.source.items.cleanup','[\"7211\"]'),(902,'inventory.source.items.cleanup','[\"72110000\"]'),(903,'inventory.source.items.cleanup','[\"72111000\"]'),(904,'inventory.source.items.cleanup','[\"72113000\"]'),(905,'inventory.source.items.cleanup','[\"72200000\"]'),(906,'inventory.source.items.cleanup','[\"72290000\"]'),(907,'inventory.source.items.cleanup','[\"72400000\"]'),(908,'inventory.source.items.cleanup','[\"72401000\"]'),(909,'inventory.source.items.cleanup','[\"72405000\"]'),(910,'inventory.source.items.cleanup','[\"72406000\"]'),(911,'inventory.source.items.cleanup','[\"72410000\"]'),(912,'inventory.source.items.cleanup','[\"72412000\"]'),(913,'inventory.source.items.cleanup','[\"72416000\"]'),(914,'inventory.source.items.cleanup','[\"72417000\"]'),(915,'inventory.source.items.cleanup','[\"72419000\"]'),(916,'inventory.source.items.cleanup','[\"72600000\"]'),(917,'inventory.source.items.cleanup','[\"72605000\"]'),(918,'inventory.source.items.cleanup','[\"72606000\"]'),(919,'inventory.source.items.cleanup','[\"73317000\"]'),(920,'inventory.source.items.cleanup','[\"74532000\"]'),(921,'inventory.source.items.cleanup','[\"74540000\"]'),(922,'inventory.source.items.cleanup','[\"74548000\"]'),(923,'inventory.source.items.cleanup','[\"A41984VUK\"]'),(924,'inventory.source.items.cleanup','[\"A41986VUK\"]'),(925,'inventory.source.items.cleanup','[\"A41988VUK\"]'),(926,'inventory.source.items.cleanup','[\"A41990VUK\"]'),(927,'inventory.source.items.cleanup','[\"A42362VUK\"]'),(928,'inventory.source.items.cleanup','[\"A42410VUK\"]'),(929,'inventory.source.items.cleanup','[\"A42416VUK\"]'),(930,'inventory.source.items.cleanup','[\"A42440VUK\"]'),(931,'inventory.source.items.cleanup','[\"A42441VUK\"]'),(932,'inventory.source.items.cleanup','[\"A5A3025C00\"]'),(933,'inventory.source.items.cleanup','[\"A5A3043C00\"]'),(934,'inventory.source.items.cleanup','[\"A5A3090C0R\"]'),(935,'inventory.source.items.cleanup','[\"A5A3125C00\"]'),(936,'inventory.source.items.cleanup','[\"A5A3209C0R\"]'),(937,'inventory.source.items.cleanup','[\"A5A3225C0R\"]'),(938,'inventory.source.items.cleanup','[\"A5A323AC00\"]'),(939,'inventory.source.items.cleanup','[\"A5A3260C0R\"]'),(940,'inventory.source.items.cleanup','[\"A5A3290C0R\"]'),(941,'inventory.source.items.cleanup','[\"A5A3296C0R\"]'),(942,'inventory.source.items.cleanup','[\"A5A3590C00\"]'),(943,'inventory.source.items.cleanup','[\"A5A3596C00\"]'),(944,'inventory.source.items.cleanup','[\"A5A3790C0R\"]'),(945,'inventory.source.items.cleanup','[\"A5A3990C0R\"]'),(946,'inventory.source.items.cleanup','[\"A5A3A3AC00\"]'),(947,'inventory.source.items.cleanup','[\"A5A3B4BC00\"]'),(948,'inventory.source.items.cleanup','[\"A5A3D90C0R\"]'),(949,'inventory.source.items.cleanup','[\"A5A3F01C00\"]'),(950,'inventory.source.items.cleanup','[\"A5A3L09C00\"]'),(951,'inventory.source.items.cleanup','[\"A5A444BC00\"]'),(952,'inventory.source.items.cleanup','[\"A5A6025C00\"]'),(953,'inventory.source.items.cleanup','[\"Active Semi-Pro\"]'),(954,'inventory.source.items.cleanup','[\"Active Twist L Dual\"]'),(955,'inventory.source.items.cleanup','[\"Active Twist L Spout\"]'),(956,'inventory.source.items.cleanup','[\"Amur\"]'),(957,'inventory.source.items.cleanup','[\"Atlas Neo\"]'),(958,'inventory.source.items.cleanup','[\"AURORA CH\"]'),(959,'inventory.source.items.cleanup','[\"BC301DL\"]'),(960,'inventory.source.items.cleanup','[\"BC301DX\"]'),(961,'inventory.source.items.cleanup','[\"BC301HL\"]'),(962,'inventory.source.items.cleanup','[\"BC301HX\"]'),(963,'inventory.source.items.cleanup','[\"BC302DL\"]'),(964,'inventory.source.items.cleanup','[\"BC302DX\"]'),(965,'inventory.source.items.cleanup','[\"BC302HX\"]'),(966,'inventory.source.items.cleanup','[\"BC303DL\"]'),(967,'inventory.source.items.cleanup','[\"BC303DLWM\"]'),(968,'inventory.source.items.cleanup','[\"BC303DX\"]'),(969,'inventory.source.items.cleanup','[\"BC303DXWM\"]'),(970,'inventory.source.items.cleanup','[\"BC303HL\"]'),(971,'inventory.source.items.cleanup','[\"BC303HLWM\"]'),(972,'inventory.source.items.cleanup','[\"BC303HX\"]'),(973,'inventory.source.items.cleanup','[\"BC303HXWM\"]'),(974,'inventory.source.items.cleanup','[\"BC304DL\"]'),(975,'inventory.source.items.cleanup','[\"BC304DLWM\"]'),(976,'inventory.source.items.cleanup','[\"BC304DX\"]'),(977,'inventory.source.items.cleanup','[\"BC304DXWM\"]'),(978,'inventory.source.items.cleanup','[\"BC304HL\"]'),(979,'inventory.source.items.cleanup','[\"BC304HLWM\"]'),(980,'inventory.source.items.cleanup','[\"BC304HX\"]'),(981,'inventory.source.items.cleanup','[\"BC304HXWM\"]'),(982,'inventory.source.items.cleanup','[\"BC305DL\"]'),(983,'inventory.source.items.cleanup','[\"BC305DX\"]'),(984,'inventory.source.items.cleanup','[\"BC305HL\"]'),(985,'inventory.source.items.cleanup','[\"BC305HX\"]'),(986,'inventory.source.items.cleanup','[\"BC306DL\"]'),(987,'inventory.source.items.cleanup','[\"BC306DX\"]'),(988,'inventory.source.items.cleanup','[\"BC306HL\"]'),(989,'inventory.source.items.cleanup','[\"BC306HX\"]'),(990,'inventory.source.items.cleanup','[\"BC307DL\"]'),(991,'inventory.source.items.cleanup','[\"BC307DX\"]'),(992,'inventory.source.items.cleanup','[\"BC307HL\"]'),(993,'inventory.source.items.cleanup','[\"BC307HX\"]'),(994,'inventory.source.items.cleanup','[\"BC309DL\"]'),(995,'inventory.source.items.cleanup','[\"BC309DX\"]'),(996,'inventory.source.items.cleanup','[\"BC309HL\"]'),(997,'inventory.source.items.cleanup','[\"BC309HX\"]'),(998,'inventory.source.items.cleanup','[\"BC317DL\"]'),(999,'inventory.source.items.cleanup','[\"BC317DX\"]'),(1000,'inventory.source.items.cleanup','[\"BC317HL\"]'),(1001,'inventory.source.items.cleanup','[\"BC317HX\"]'),(1002,'inventory.source.items.cleanup','[\"BC401DL\"]'),(1003,'inventory.source.items.cleanup','[\"BC401DX\"]'),(1004,'inventory.source.items.cleanup','[\"BC401HL\"]'),(1005,'inventory.source.items.cleanup','[\"BC401HX\"]'),(1006,'inventory.source.items.cleanup','[\"BC402DL\"]'),(1007,'inventory.source.items.cleanup','[\"BC402DX\"]'),(1008,'inventory.source.items.cleanup','[\"BC402HL\"]'),(1009,'inventory.source.items.cleanup','[\"BC402HX\"]'),(1010,'inventory.source.items.cleanup','[\"BC403DL\"]'),(1011,'inventory.source.items.cleanup','[\"BC403DLWM\"]'),(1012,'inventory.source.items.cleanup','[\"BC403DX\"]'),(1013,'inventory.source.items.cleanup','[\"BC403DXWM\"]'),(1014,'inventory.source.items.cleanup','[\"BC403HL\"]'),(1015,'inventory.source.items.cleanup','[\"BC403HLWM\"]'),(1016,'inventory.source.items.cleanup','[\"BC403HX\"]'),(1017,'inventory.source.items.cleanup','[\"BC403HXWM\"]'),(1018,'inventory.source.items.cleanup','[\"BC404DL\"]'),(1019,'inventory.source.items.cleanup','[\"BC404DLWM\"]'),(1020,'inventory.source.items.cleanup','[\"BC404DX\"]'),(1021,'inventory.source.items.cleanup','[\"BC404DXWM\"]'),(1022,'inventory.source.items.cleanup','[\"BC404HL\"]'),(1023,'inventory.source.items.cleanup','[\"BC404HLWM\"]'),(1024,'inventory.source.items.cleanup','[\"BC404HX\"]'),(1025,'inventory.source.items.cleanup','[\"BC404HXWM\"]'),(1026,'inventory.source.items.cleanup','[\"BC405DL\"]'),(1027,'inventory.source.items.cleanup','[\"BC405DX\"]'),(1028,'inventory.source.items.cleanup','[\"BC405HL\"]'),(1029,'inventory.source.items.cleanup','[\"BC405HX\"]'),(1030,'inventory.source.items.cleanup','[\"BC406DL\"]'),(1031,'inventory.source.items.cleanup','[\"BC406DX\"]'),(1032,'inventory.source.items.cleanup','[\"BC406HL\"]'),(1033,'inventory.source.items.cleanup','[\"BC406HX\"]'),(1034,'inventory.source.items.cleanup','[\"BC407DL\"]'),(1035,'inventory.source.items.cleanup','[\"BC407DX\"]'),(1036,'inventory.source.items.cleanup','[\"BC407HL\"]'),(1037,'inventory.source.items.cleanup','[\"BC407HX\"]'),(1038,'inventory.source.items.cleanup','[\"BC409DL\"]'),(1039,'inventory.source.items.cleanup','[\"BC409DX\"]'),(1040,'inventory.source.items.cleanup','[\"BC409HL\"]'),(1041,'inventory.source.items.cleanup','[\"BC409HX\"]'),(1042,'inventory.source.items.cleanup','[\"BC417DL\"]'),(1043,'inventory.source.items.cleanup','[\"BC417DX\"]'),(1044,'inventory.source.items.cleanup','[\"BC417HL\"]'),(1045,'inventory.source.items.cleanup','[\"BC417HX\"]'),(1046,'inventory.source.items.cleanup','[\"Blanco Camia - 525334\"]'),(1047,'inventory.source.items.cleanup','[\"Blanco Carena-S\"]'),(1048,'inventory.source.items.cleanup','[\"Blanco Linee-S\"]'),(1049,'inventory.source.items.cleanup','[\"Blanco Linus - 514019\"]'),(1050,'inventory.source.items.cleanup','[\"Blanco Linus S - 512402\"]'),(1051,'inventory.source.items.cleanup','[\"Blanco Mida-S\"]'),(1052,'inventory.source.items.cleanup','[\"Blanco Mili - 524709\"]'),(1053,'inventory.source.items.cleanup','[\"Blanco Vicus\"]'),(1054,'inventory.source.items.cleanup','[\"BROOKLYN CH\"]'),(1055,'inventory.source.items.cleanup','[\"Catris-S Flexo\"]'),(1056,'inventory.source.items.cleanup','[\"CD324\"]'),(1057,'inventory.source.items.cleanup','[\"DRI303\"]'),(1058,'inventory.source.items.cleanup','[\"DRI304\"]'),(1059,'inventory.source.items.cleanup','[\"DRI305\"]'),(1060,'inventory.source.items.cleanup','[\"DRI328\"]'),(1061,'inventory.source.items.cleanup','[\"DRI370\"]'),(1062,'inventory.source.items.cleanup','[\"ELBE\"]'),(1063,'inventory.source.items.cleanup','[\"FJ311\"]'),(1064,'inventory.source.items.cleanup','[\"FJ313\"]'),(1065,'inventory.source.items.cleanup','[\"FJ314\"]'),(1066,'inventory.source.items.cleanup','[\"FJ317\"]'),(1067,'inventory.source.items.cleanup','[\"FJ318\"]'),(1068,'inventory.source.items.cleanup','[\"FJ319\"]'),(1069,'inventory.source.items.cleanup','[\"Genesis\"]'),(1070,'inventory.source.items.cleanup','[\"Hansgrohe Focus Care 70\"]'),(1071,'inventory.source.items.cleanup','[\"Hansgrohe Rebris S\"]'),(1072,'inventory.source.items.cleanup','[\"Hansgrohe Talis E 240\"]'),(1073,'inventory.source.items.cleanup','[\"Hansgrohe Talis S 80\"]'),(1074,'inventory.source.items.cleanup','[\"HIB Atlas\"]'),(1075,'inventory.source.items.cleanup','[\"I303X\"]'),(1076,'inventory.source.items.cleanup','[\"I304X\"]'),(1077,'inventory.source.items.cleanup','[\"I305X\"]'),(1078,'inventory.source.items.cleanup','[\"I306X\"]'),(1079,'inventory.source.items.cleanup','[\"I307X\"]'),(1080,'inventory.source.items.cleanup','[\"I315X\"]'),(1081,'inventory.source.items.cleanup','[\"I321XE\"]'),(1082,'inventory.source.items.cleanup','[\"I328X\"]'),(1083,'inventory.source.items.cleanup','[\"I345X\"]'),(1084,'inventory.source.items.cleanup','[\"Kano\"]'),(1085,'inventory.source.items.cleanup','[\"Kano S - 521503\"]'),(1086,'inventory.source.items.cleanup','[\"Livia S - 521288\"]'),(1087,'inventory.source.items.cleanup','[\"MARTA CH\"]'),(1088,'inventory.source.items.cleanup','[\"Mila S - 519810\"]'),(1089,'inventory.source.items.cleanup','[\"Minimax S Basin Tap\"]'),(1090,'inventory.source.items.cleanup','[\"PK328\"]'),(1091,'inventory.source.items.cleanup','[\"PK350\"]'),(1092,'inventory.source.items.cleanup','[\"PK370\"]'),(1093,'inventory.source.items.cleanup','[\"PN300\"]'),(1094,'inventory.source.items.cleanup','[\"PN321\"]'),(1095,'inventory.source.items.cleanup','[\"PN322\"]'),(1096,'inventory.source.items.cleanup','[\"PN380\"]'),(1097,'inventory.source.items.cleanup','[\"PN381\"]'),(1098,'inventory.source.items.cleanup','[\"PN386\"]'),(1099,'inventory.source.items.cleanup','[\"RAK710111\"]'),(1100,'inventory.source.items.cleanup','[\"RAK710141\"]'),(1101,'inventory.source.items.cleanup','[\"RAK71021\"]'),(1102,'inventory.source.items.cleanup','[\"RAK710822\"]'),(1103,'inventory.source.items.cleanup','[\"RAK710922\"]'),(1104,'inventory.source.items.cleanup','[\"RAKBAS3001\"]'),(1105,'inventory.source.items.cleanup','[\"RAKBAS3002\"]'),(1106,'inventory.source.items.cleanup','[\"RAKBAS3004\"]'),(1107,'inventory.source.items.cleanup','[\"RAKBAS3005\"]'),(1108,'inventory.source.items.cleanup','[\"RAKCOM3004\"]'),(1109,'inventory.source.items.cleanup','[\"RAKCOM3005\"]'),(1110,'inventory.source.items.cleanup','[\"RAKCOM902C\"]'),(1111,'inventory.source.items.cleanup','[\"RAKCOM903C\"]'),(1112,'inventory.source.items.cleanup','[\"RAKCOM904C\"]'),(1113,'inventory.source.items.cleanup','[\"RAKCOM905C\"]'),(1114,'inventory.source.items.cleanup','[\"RAKCOM906C\"]'),(1115,'inventory.source.items.cleanup','[\"RAKCUB3001\"]'),(1116,'inventory.source.items.cleanup','[\"RAKKIT001\"]'),(1117,'inventory.source.items.cleanup','[\"RAKKIT002\"]'),(1118,'inventory.source.items.cleanup','[\"RAKKIT003\"]'),(1119,'inventory.source.items.cleanup','[\"RAKKIT004\"]'),(1120,'inventory.source.items.cleanup','[\"RAKKIT005\"]'),(1121,'inventory.source.items.cleanup','[\"RAKKIT008\"]'),(1122,'inventory.source.items.cleanup','[\"RAKKIT010\"]'),(1123,'inventory.source.items.cleanup','[\"RAKKIT011\"]'),(1124,'inventory.source.items.cleanup','[\"RAKKIT012\"]'),(1125,'inventory.source.items.cleanup','[\"RAKKIT013\"]'),(1126,'inventory.source.items.cleanup','[\"RAKMET3001\"]'),(1127,'inventory.source.items.cleanup','[\"RAKMET3002\"]'),(1128,'inventory.source.items.cleanup','[\"RAKMET3004\"]'),(1129,'inventory.source.items.cleanup','[\"RAKMET3005\"]'),(1130,'inventory.source.items.cleanup','[\"RAKORI3004\"]'),(1131,'inventory.source.items.cleanup','[\"RAKORI3005\"]'),(1132,'inventory.source.items.cleanup','[\"RAKS6003001\"]'),(1133,'inventory.source.items.cleanup','[\"RAKS6003004\"]'),(1134,'inventory.source.items.cleanup','[\"RAKS6003005\"]'),(1135,'inventory.source.items.cleanup','[\"RAKSUM3001\"]'),(1136,'inventory.source.items.cleanup','[\"RAKSUM3004\"]'),(1137,'inventory.source.items.cleanup','[\"RAKSUM3005\"]'),(1138,'inventory.source.items.cleanup','[\"RAKTON3001\"]'),(1139,'inventory.source.items.cleanup','[\"RAKTON3004\"]'),(1140,'inventory.source.items.cleanup','[\"RAKWFC3001\"]'),(1141,'inventory.source.items.cleanup','[\"RAKWFF3001\"]'),(1142,'inventory.source.items.cleanup','[\"Reginox Hudson\"]'),(1143,'inventory.source.items.cleanup','[\"SOA303\"]'),(1144,'inventory.source.items.cleanup','[\"SOA304\"]'),(1145,'inventory.source.items.cleanup','[\"SOA305\"]'),(1146,'inventory.source.items.cleanup','[\"SOA328\"]'),(1147,'inventory.source.items.cleanup','[\"SOA345\"]'),(1148,'inventory.source.items.cleanup','[\"SOA370\"]'),(1149,'inventory.source.items.cleanup','[\"Solid Basin Tap\"]'),(1150,'inventory.source.items.cleanup','[\"SOT303\"]'),(1151,'inventory.source.items.cleanup','[\"SOT304\"]'),(1152,'inventory.source.items.cleanup','[\"SOT305\"]'),(1153,'inventory.source.items.cleanup','[\"SOT328\"]'),(1154,'inventory.source.items.cleanup','[\"SOT345\"]'),(1155,'inventory.source.items.cleanup','[\"SOT370\"]'),(1156,'inventory.source.items.cleanup','[\"Talis Select S 100\"]'),(1157,'inventory.source.items.cleanup','[\"TEL315\"]'),(1158,'inventory.source.items.cleanup','[\"TEL317\"]'),(1159,'inventory.source.items.cleanup','[\"TEL334S\"]'),(1160,'inventory.source.items.cleanup','[\"TEL337\"]'),(1161,'inventory.source.items.cleanup','[\"TEL353\"]'),(1162,'inventory.source.items.cleanup','[\"TEL354\"]'),(1163,'inventory.source.items.cleanup','[\"TEX315\"]'),(1164,'inventory.source.items.cleanup','[\"TEX317\"]'),(1165,'inventory.source.items.cleanup','[\"TEX334S\"]'),(1166,'inventory.source.items.cleanup','[\"TEX337\"]'),(1167,'inventory.source.items.cleanup','[\"TEX353\"]'),(1168,'inventory.source.items.cleanup','[\"TEX354\"]'),(1169,'inventory.source.items.cleanup','[\"THAMES CH II\"]'),(1170,'inventory.source.items.cleanup','[\"TIW315\"]'),(1171,'inventory.source.items.cleanup','[\"TIW317\"]'),(1172,'inventory.source.items.cleanup','[\"TIW334\"]'),(1173,'inventory.source.items.cleanup','[\"TIW337\"]'),(1174,'inventory.source.items.cleanup','[\"TIW353\"]'),(1175,'inventory.source.items.cleanup','[\"TIW354\"]'),(1176,'inventory.source.items.cleanup','[\"TSI303\"]'),(1177,'inventory.source.items.cleanup','[\"TSI304\"]'),(1178,'inventory.source.items.cleanup','[\"TSI305\"]'),(1179,'inventory.source.items.cleanup','[\"TSI307\"]'),(1180,'inventory.source.items.cleanup','[\"TSI315\"]'),(1181,'inventory.source.items.cleanup','[\"TWS007\"]'),(1182,'inventory.source.items.cleanup','[\"TWS009\"]'),(1183,'inventory.source.items.cleanup','[\"Vicus Bridge Double Lever\"]'),(1184,'inventory.source.items.cleanup','[\"WIL303\"]'),(1185,'inventory.source.items.cleanup','[\"WIL304\"]'),(1186,'inventory.source.items.cleanup','[\"WIL305\"]'),(1187,'inventory.source.items.cleanup','[\"WIL328\"]'),(1188,'inventory.source.items.cleanup','[\"WIL345\"]'),(1189,'inventory.source.items.cleanup','[\"WIL370\"]'),(1190,'inventory.source.items.cleanup','[\"115-003-006\"]'),(1191,'inventory.source.items.cleanup','[\"124-003-001\"]'),(1192,'inventory.source.items.cleanup','[\"124-003-009\"]'),(1193,'inventory.source.items.cleanup','[\"124-003R009\"]'),(1194,'inventory.source.items.cleanup','[\"150.688.21.1\"]'),(1195,'inventory.source.items.cleanup','[\"150.712.21.1\"]'),(1196,'inventory.source.items.cleanup','[\"150.771.21.1\"]'),(1197,'inventory.source.items.cleanup','[\"150.772.21.1\"]'),(1198,'inventory.source.items.cleanup','[\"151.039.21.1\"]'),(1199,'inventory.source.items.cleanup','[\"177-003-001\"]'),(1200,'inventory.source.items.cleanup','[\"177-003-009\"]'),(1201,'inventory.source.items.cleanup','[\"109.041.00.1\"]'),(1202,'inventory.source.items.cleanup','[\"109.105.00.1\"]'),(1203,'inventory.source.items.cleanup','[\"109.205.00.1\"]'),(1204,'inventory.source.items.cleanup','[\"109.309.00.5\"]'),(1205,'inventory.source.items.cleanup','[\"109.721.00.2\"]'),(1206,'inventory.source.items.cleanup','[\"109.792.00.1\"]'),(1207,'inventory.source.items.cleanup','[\"111.207.00.2\"]'),(1208,'inventory.source.items.cleanup','[\"111.260.00.3\"]'),(1209,'inventory.source.items.cleanup','[\"111.352.00.5\"]'),(1210,'inventory.source.items.cleanup','[\"111.493.00.1\"]'),(1211,'inventory.source.items.cleanup','[\"111.494.00.1\"]'),(1212,'inventory.source.items.cleanup','[\"Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink\"]'),(1213,'inventory.source.items.cleanup','[\"Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink-1\"]'),(1214,'inventory.source.items.cleanup','[\"Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink-1-1\"]'),(1215,'inventory.source.items.cleanup','[\"Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink-1-1-1\"]'),(1216,'inventory.source.items.cleanup','[\"13233180\"]'),(1217,'inventory.source.items.cleanup','[\"13244180\"]'),(1218,'inventory.source.items.cleanup','[\"13437180\"]'),(1219,'inventory.source.items.cleanup','[\"13439180\"]'),(1220,'inventory.source.items.cleanup','[\"13444180\"]'),(1221,'inventory.source.items.cleanup','[\"13596000\"]'),(1222,'inventory.source.items.cleanup','[\"13597000\"]'),(1223,'inventory.source.items.cleanup','[\"13620180\"]'),(1224,'inventory.source.items.cleanup','[\"13622180\"]'),(1225,'inventory.source.items.cleanup','[\"15736400\"]'),(1226,'inventory.source.items.cleanup','[\"15745000\"]'),(1227,'inventory.source.items.cleanup','[\"15755000\"]'),(1228,'inventory.source.items.cleanup','[\"15760000\"]'),(1229,'inventory.source.items.cleanup','[\"15762000\"]'),(1230,'inventory.source.items.cleanup','[\"15763000\"]'),(1231,'inventory.source.items.cleanup','[\"15764000\"]'),(1232,'inventory.source.items.cleanup','[\"1800180\"]'),(1233,'inventory.source.items.cleanup','[\"1850180\"]'),(1234,'inventory.source.items.cleanup','[\"18700000\"]'),(1235,'inventory.source.items.cleanup','[\"19334000\"]'),(1236,'inventory.source.items.cleanup','[\"19384000\"]'),(1237,'inventory.source.items.cleanup','[\"19470000\"]'),(1238,'inventory.source.items.cleanup','[\"19590000\"]'),(1239,'inventory.source.items.cleanup','[\"19792000\"]'),(1240,'inventory.source.items.cleanup','[\"19796000\"]'),(1241,'inventory.source.items.cleanup','[\"19887000\"]'),(1242,'inventory.source.items.cleanup','[\"19910000\"]'),(1243,'inventory.source.items.cleanup','[\"19944IG0\"]'),(1244,'inventory.source.items.cleanup','[\"23319000\"]'),(1245,'inventory.source.items.cleanup','[\"24001400\"]'),(1246,'inventory.source.items.cleanup','[\"24002400\"]'),(1247,'inventory.source.items.cleanup','[\"24003400\"]'),(1248,'inventory.source.items.cleanup','[\"24004400\"]'),(1249,'inventory.source.items.cleanup','[\"24005400\"]'),(1250,'inventory.source.items.cleanup','[\"24006400\"]'),(1251,'inventory.source.items.cleanup','[\"24007400\"]'),(1252,'inventory.source.items.cleanup','[\"24011400\"]'),(1253,'inventory.source.items.cleanup','[\"24012400\"]'),(1254,'inventory.source.items.cleanup','[\"24013400\"]'),(1255,'inventory.source.items.cleanup','[\"24014400\"]'),(1256,'inventory.source.items.cleanup','[\"24015400\"]'),(1257,'inventory.source.items.cleanup','[\"24016400\"]'),(1258,'inventory.source.items.cleanup','[\"26037000\"]'),(1259,'inventory.source.items.cleanup','[\"26037IG0\"]'),(1260,'inventory.source.items.cleanup','[\"26079000\"]'),(1261,'inventory.source.items.cleanup','[\"26220000\"]'),(1262,'inventory.source.items.cleanup','[\"26221000\"]'),(1263,'inventory.source.items.cleanup','[\"26320000\"]'),(1264,'inventory.source.items.cleanup','[\"26323000\"]'),(1265,'inventory.source.items.cleanup','[\"26324\"]'),(1266,'inventory.source.items.cleanup','[\"26326000\"]'),(1267,'inventory.source.items.cleanup','[\"26330400\"]'),(1268,'inventory.source.items.cleanup','[\"26331400\"]'),(1269,'inventory.source.items.cleanup','[\"26332400\"]'),(1270,'inventory.source.items.cleanup','[\"26333400\"]'),(1271,'inventory.source.items.cleanup','[\"26334400\"]'),(1272,'inventory.source.items.cleanup','[\"26336400\"]'),(1273,'inventory.source.items.cleanup','[\"26410400\"]'),(1274,'inventory.source.items.cleanup','[\"26411400\"]'),(1275,'inventory.source.items.cleanup','[\"26412400\"]'),(1276,'inventory.source.items.cleanup','[\"26413400\"]'),(1277,'inventory.source.items.cleanup','[\"26420400\"]'),(1278,'inventory.source.items.cleanup','[\"26425400\"]'),(1279,'inventory.source.items.cleanup','[\"26464000\"]'),(1280,'inventory.source.items.cleanup','[\"26465000\"]'),(1281,'inventory.source.items.cleanup','[\"26466\"]'),(1282,'inventory.source.items.cleanup','[\"26467\"]'),(1283,'inventory.source.items.cleanup','[\"26469000\"]'),(1284,'inventory.source.items.cleanup','[\"26470\"]'),(1285,'inventory.source.items.cleanup','[\"26471180\"]'),(1286,'inventory.source.items.cleanup','[\"26472000\"]'),(1287,'inventory.source.items.cleanup','[\"26481000\"]'),(1288,'inventory.source.items.cleanup','[\"26519000\"]'),(1289,'inventory.source.items.cleanup','[\"26520\"]'),(1290,'inventory.source.items.cleanup','[\"26521000\"]'),(1291,'inventory.source.items.cleanup','[\"26521400\"]'),(1292,'inventory.source.items.cleanup','[\"26522\"]'),(1293,'inventory.source.items.cleanup','[\"26523000\"]'),(1294,'inventory.source.items.cleanup','[\"26524\"]'),(1295,'inventory.source.items.cleanup','[\"26528\"]'),(1296,'inventory.source.items.cleanup','[\"26530000\"]'),(1297,'inventory.source.items.cleanup','[\"26530400\"]'),(1298,'inventory.source.items.cleanup','[\"26531\"]'),(1299,'inventory.source.items.cleanup','[\"26532400\"]'),(1300,'inventory.source.items.cleanup','[\"26533400\"]'),(1301,'inventory.source.items.cleanup','[\"26534400\"]'),(1302,'inventory.source.items.cleanup','[\"26535400\"]'),(1303,'inventory.source.items.cleanup','[\"26536400\"]'),(1304,'inventory.source.items.cleanup','[\"26537400\"]'),(1305,'inventory.source.items.cleanup','[\"26538400\"]'),(1306,'inventory.source.items.cleanup','[\"26539400\"]'),(1307,'inventory.source.items.cleanup','[\"26550\"]'),(1308,'inventory.source.items.cleanup','[\"26551\"]'),(1309,'inventory.source.items.cleanup','[\"26553400\"]'),(1310,'inventory.source.items.cleanup','[\"26554400\"]'),(1311,'inventory.source.items.cleanup','[\"26555400\"]'),(1312,'inventory.source.items.cleanup','[\"26560400\"]'),(1313,'inventory.source.items.cleanup','[\"26561400\"]'),(1314,'inventory.source.items.cleanup','[\"26562400\"]'),(1315,'inventory.source.items.cleanup','[\"26563400\"]'),(1316,'inventory.source.items.cleanup','[\"26564400\"]'),(1317,'inventory.source.items.cleanup','[\"26565400\"]'),(1318,'inventory.source.items.cleanup','[\"26566400\"]'),(1319,'inventory.source.items.cleanup','[\"26570400\"]'),(1320,'inventory.source.items.cleanup','[\"26571400\"]'),(1321,'inventory.source.items.cleanup','[\"26572400\"]'),(1322,'inventory.source.items.cleanup','[\"26573400\"]'),(1323,'inventory.source.items.cleanup','[\"26574400\"]'),(1324,'inventory.source.items.cleanup','[\"26575400\"]'),(1325,'inventory.source.items.cleanup','[\"26580400\"]'),(1326,'inventory.source.items.cleanup','[\"26581400\"]'),(1327,'inventory.source.items.cleanup','[\"26582400\"]'),(1328,'inventory.source.items.cleanup','[\"26583400\"]'),(1329,'inventory.source.items.cleanup','[\"26584400\"]'),(1330,'inventory.source.items.cleanup','[\"26585400\"]'),(1331,'inventory.source.items.cleanup','[\"26586400\"]'),(1332,'inventory.source.items.cleanup','[\"26590400\"]'),(1333,'inventory.source.items.cleanup','[\"26591400\"]'),(1334,'inventory.source.items.cleanup','[\"26592400\"]'),(1335,'inventory.source.items.cleanup','[\"26593400\"]'),(1336,'inventory.source.items.cleanup','[\"26594400\"]'),(1337,'inventory.source.items.cleanup','[\"26595400\"]'),(1338,'inventory.source.items.cleanup','[\"26600000\"]'),(1339,'inventory.source.items.cleanup','[\"26601000\"]'),(1340,'inventory.source.items.cleanup','[\"26604000\"]'),(1341,'inventory.source.items.cleanup','[\"26605000\"]'),(1342,'inventory.source.items.cleanup','[\"26606000\"]'),(1343,'inventory.source.items.cleanup','[\"26620\"]'),(1344,'inventory.source.items.cleanup','[\"26621\"]'),(1345,'inventory.source.items.cleanup','[\"26622\"]'),(1346,'inventory.source.items.cleanup','[\"26623\"]'),(1347,'inventory.source.items.cleanup','[\"26626\"]'),(1348,'inventory.source.items.cleanup','[\"26630\"]'),(1349,'inventory.source.items.cleanup','[\"26631\"]'),(1350,'inventory.source.items.cleanup','[\"26632000\"]'),(1351,'inventory.source.items.cleanup','[\"26633000\"]'),(1352,'inventory.source.items.cleanup','[\"26720\"]'),(1353,'inventory.source.items.cleanup','[\"26721\"]'),(1354,'inventory.source.items.cleanup','[\"26722000\"]'),(1355,'inventory.source.items.cleanup','[\"26723000\"]'),(1356,'inventory.source.items.cleanup','[\"26724000\"]'),(1357,'inventory.source.items.cleanup','[\"26725000\"]'),(1358,'inventory.source.items.cleanup','[\"26726000\"]'),(1359,'inventory.source.items.cleanup','[\"26727000\"]'),(1360,'inventory.source.items.cleanup','[\"26800400\"]'),(1361,'inventory.source.items.cleanup','[\"26801400\"]'),(1362,'inventory.source.items.cleanup','[\"26802400\"]'),(1363,'inventory.source.items.cleanup','[\"26803400\"]'),(1364,'inventory.source.items.cleanup','[\"26804400\"]'),(1365,'inventory.source.items.cleanup','[\"26805400\"]'),(1366,'inventory.source.items.cleanup','[\"26806400\"]'),(1367,'inventory.source.items.cleanup','[\"26810400\"]'),(1368,'inventory.source.items.cleanup','[\"26811400\"]'),(1369,'inventory.source.items.cleanup','[\"26812400\"]'),(1370,'inventory.source.items.cleanup','[\"26813400\"]'),(1371,'inventory.source.items.cleanup','[\"26814400\"]'),(1372,'inventory.source.items.cleanup','[\"26815400\"]'),(1373,'inventory.source.items.cleanup','[\"26816400\"]'),(1374,'inventory.source.items.cleanup','[\"27055000\"]'),(1375,'inventory.source.items.cleanup','[\"27062000\"]'),(1376,'inventory.source.items.cleanup','[\"27067000\"]'),(1377,'inventory.source.items.cleanup','[\"27076000\"]'),(1378,'inventory.source.items.cleanup','[\"27134000\"]'),(1379,'inventory.source.items.cleanup','[\"27136001\"]'),(1380,'inventory.source.items.cleanup','[\"27220000\"]'),(1381,'inventory.source.items.cleanup','[\"27221000\"]'),(1382,'inventory.source.items.cleanup','[\"27224000\"]'),(1383,'inventory.source.items.cleanup','[\"27225001\"]'),(1384,'inventory.source.items.cleanup','[\"27230001\"]'),(1385,'inventory.source.items.cleanup','[\"27231001\"]'),(1386,'inventory.source.items.cleanup','[\"27239000\"]'),(1387,'inventory.source.items.cleanup','[\"27243001\"]'),(1388,'inventory.source.items.cleanup','[\"27253000\"]'),(1389,'inventory.source.items.cleanup','[\"27256001\"]'),(1390,'inventory.source.items.cleanup','[\"27274000\"]'),(1391,'inventory.source.items.cleanup','[\"27286000\"]'),(1392,'inventory.source.items.cleanup','[\"27337\"]'),(1393,'inventory.source.items.cleanup','[\"27354000\"]'),(1394,'inventory.source.items.cleanup','[\"27367000\"]'),(1395,'inventory.source.items.cleanup','[\"27369000\"]'),(1396,'inventory.source.items.cleanup','[\"27370000\"]'),(1397,'inventory.source.items.cleanup','[\"27371000\"]'),(1398,'inventory.source.items.cleanup','[\"27375000\"]'),(1399,'inventory.source.items.cleanup','[\"27378\"]'),(1400,'inventory.source.items.cleanup','[\"27380000\"]'),(1401,'inventory.source.items.cleanup','[\"27381000\"]'),(1402,'inventory.source.items.cleanup','[\"27400000\"]'),(1403,'inventory.source.items.cleanup','[\"27409800\"]'),(1404,'inventory.source.items.cleanup','[\"27411000\"]'),(1405,'inventory.source.items.cleanup','[\"27412000\"]'),(1406,'inventory.source.items.cleanup','[\"27413000\"]'),(1407,'inventory.source.items.cleanup','[\"27438000\"]'),(1408,'inventory.source.items.cleanup','[\"27446000\"]'),(1409,'inventory.source.items.cleanup','[\"27461000\"]'),(1410,'inventory.source.items.cleanup','[\"27463000\"]'),(1411,'inventory.source.items.cleanup','[\"27474000\"]'),(1412,'inventory.source.items.cleanup','[\"27475000\"]'),(1413,'inventory.source.items.cleanup','[\"27477000\"]'),(1414,'inventory.source.items.cleanup','[\"27478000\"]'),(1415,'inventory.source.items.cleanup','[\"27479000\"]'),(1416,'inventory.source.items.cleanup','[\"27492000\"]'),(1417,'inventory.source.items.cleanup','[\"27493000\"]'),(1418,'inventory.source.items.cleanup','[\"27494000\"]'),(1419,'inventory.source.items.cleanup','[\"27499000\"]'),(1420,'inventory.source.items.cleanup','[\"27500000\"]'),(1421,'inventory.source.items.cleanup','[\"27521000\"]'),(1422,'inventory.source.items.cleanup','[\"27522000\"]'),(1423,'inventory.source.items.cleanup','[\"27523000\"]'),(1424,'inventory.source.items.cleanup','[\"27524000\"]'),(1425,'inventory.source.items.cleanup','[\"27558000\"]'),(1426,'inventory.source.items.cleanup','[\"27576000\"]'),(1427,'inventory.source.items.cleanup','[\"27577000\"]'),(1428,'inventory.source.items.cleanup','[\"27596000\"]'),(1429,'inventory.source.items.cleanup','[\"27652000\"]'),(1430,'inventory.source.items.cleanup','[\"27671000\"]'),(1431,'inventory.source.items.cleanup','[\"27698000\"]'),(1432,'inventory.source.items.cleanup','[\"27699000\"]'),(1433,'inventory.source.items.cleanup','[\"27700000\"]'),(1434,'inventory.source.items.cleanup','[\"27702000\"]'),(1435,'inventory.source.items.cleanup','[\"27703000\"]'),(1436,'inventory.source.items.cleanup','[\"27704000\"]'),(1437,'inventory.source.items.cleanup','[\"27705000\"]'),(1438,'inventory.source.items.cleanup','[\"27707000\"]'),(1439,'inventory.source.items.cleanup','[\"27717000\"]'),(1440,'inventory.source.items.cleanup','[\"27724000\"]'),(1441,'inventory.source.items.cleanup','[\"27728000\"]'),(1442,'inventory.source.items.cleanup','[\"27762000\"]'),(1443,'inventory.source.items.cleanup','[\"27763000\"]'),(1444,'inventory.source.items.cleanup','[\"27764000\"]'),(1445,'inventory.source.items.cleanup','[\"27766000\"]'),(1446,'inventory.source.items.cleanup','[\"27784000\"]'),(1447,'inventory.source.items.cleanup','[\"27802000\"]'),(1448,'inventory.source.items.cleanup','[\"27803\"]'),(1449,'inventory.source.items.cleanup','[\"27841000\"]'),(1450,'inventory.source.items.cleanup','[\"27857\"]'),(1451,'inventory.source.items.cleanup','[\"27863000\"]'),(1452,'inventory.source.items.cleanup','[\"27884001\"]'),(1453,'inventory.source.items.cleanup','[\"27888000\"]'),(1454,'inventory.source.items.cleanup','[\"27889000\"]'),(1455,'inventory.source.items.cleanup','[\"27892000\"]'),(1456,'inventory.source.items.cleanup','[\"27911000\"]'),(1457,'inventory.source.items.cleanup','[\"27969000\"]'),(1458,'inventory.source.items.cleanup','[\"27970000\"]'),(1459,'inventory.source.items.cleanup','[\"27970IG0\"]'),(1460,'inventory.source.items.cleanup','[\"27974000\"]'),(1461,'inventory.source.items.cleanup','[\"27974IG0\"]'),(1462,'inventory.source.items.cleanup','[\"27978000\"]'),(1463,'inventory.source.items.cleanup','[\"27978IG0\"]'),(1464,'inventory.source.items.cleanup','[\"27982000\"]'),(1465,'inventory.source.items.cleanup','[\"27986000\"]'),(1466,'inventory.source.items.cleanup','[\"27986IG0\"]'),(1467,'inventory.source.items.cleanup','[\"27993000\"]'),(1468,'inventory.source.items.cleanup','[\"27993IG0\"]'),(1469,'inventory.source.items.cleanup','[\"28034000\"]'),(1470,'inventory.source.items.cleanup','[\"28132000\"]'),(1471,'inventory.source.items.cleanup','[\"28134000\"]'),(1472,'inventory.source.items.cleanup','[\"28136000\"]'),(1473,'inventory.source.items.cleanup','[\"28167000\"]'),(1474,'inventory.source.items.cleanup','[\"28168000\"]'),(1475,'inventory.source.items.cleanup','[\"28169000\"]'),(1476,'inventory.source.items.cleanup','[\"28233000\"]'),(1477,'inventory.source.items.cleanup','[\"28262000\"]'),(1478,'inventory.source.items.cleanup','[\"28264000\"]'),(1479,'inventory.source.items.cleanup','[\"28265000\"]'),(1480,'inventory.source.items.cleanup','[\"28266000\"]'),(1481,'inventory.source.items.cleanup','[\"28272000\"]'),(1482,'inventory.source.items.cleanup','[\"28274000\"]'),(1483,'inventory.source.items.cleanup','[\"28276000\"]'),(1484,'inventory.source.items.cleanup','[\"28276800\"]'),(1485,'inventory.source.items.cleanup','[\"28331000\"]'),(1486,'inventory.source.items.cleanup','[\"28341000\"]'),(1487,'inventory.source.items.cleanup','[\"28361000\"]'),(1488,'inventory.source.items.cleanup','[\"28368000\"]'),(1489,'inventory.source.items.cleanup','[\"28369000\"]'),(1490,'inventory.source.items.cleanup','[\"28384000\"]'),(1491,'inventory.source.items.cleanup','[\"28389000\"]'),(1492,'inventory.source.items.cleanup','[\"28414180\"]'),(1493,'inventory.source.items.cleanup','[\"28417000\"]'),(1494,'inventory.source.items.cleanup','[\"28423000\"]'),(1495,'inventory.source.items.cleanup','[\"28424000\"]'),(1496,'inventory.source.items.cleanup','[\"28425000\"]'),(1497,'inventory.source.items.cleanup','[\"28467000\"]'),(1498,'inventory.source.items.cleanup','[\"28496000\"]'),(1499,'inventory.source.items.cleanup','[\"28497000\"]'),(1500,'inventory.source.items.cleanup','[\"28561000\"]'),(1501,'inventory.source.items.cleanup','[\"28562000\"]'),(1502,'inventory.source.items.cleanup','[\"28563000\"]'),(1503,'inventory.source.items.cleanup','[\"28576000\"]'),(1504,'inventory.source.items.cleanup','[\"28585000\"]'),(1505,'inventory.source.items.cleanup','[\"28587000\"]'),(1506,'inventory.source.items.cleanup','[\"28587400\"]'),(1507,'inventory.source.items.cleanup','[\"28588\"]'),(1508,'inventory.source.items.cleanup','[\"28626000\"]'),(1509,'inventory.source.items.cleanup','[\"28628000\"]'),(1510,'inventory.source.items.cleanup','[\"28678000\"]'),(1511,'inventory.source.items.cleanup','[\"28680000\"]'),(1512,'inventory.source.items.cleanup','[\"28684000\"]'),(1513,'inventory.source.items.cleanup','[\"28690000\"]'),(1514,'inventory.source.items.cleanup','[\"28724000\"]'),(1515,'inventory.source.items.cleanup','[\"28769001\"]'),(1516,'inventory.source.items.cleanup','[\"28778000\"]'),(1517,'inventory.source.items.cleanup','[\"28796000\"]'),(1518,'inventory.source.items.cleanup','[\"28982000\"]'),(1519,'inventory.source.items.cleanup','[\"31741180\"]'),(1520,'inventory.source.items.cleanup','[\"32635000\"]'),(1521,'inventory.source.items.cleanup','[\"32706000\"]'),(1522,'inventory.source.items.cleanup','[\"33769000\"]'),(1523,'inventory.source.items.cleanup','[\"342640000 341643000\"]'),(1524,'inventory.source.items.cleanup','[\"342642000 341645000\"]'),(1525,'inventory.source.items.cleanup','[\"342737000 34173C000\"]'),(1526,'inventory.source.items.cleanup','[\"34273700H 34173C000\"]'),(1527,'inventory.source.items.cleanup','[\"34299700U 34199C00F\"]'),(1528,'inventory.source.items.cleanup','[\"34630300S\"]'),(1529,'inventory.source.items.cleanup','[\"346477000\"]'),(1530,'inventory.source.items.cleanup','[\"34647L000\"]'),(1531,'inventory.source.items.cleanup','[\"346527000\"]'),(1532,'inventory.source.items.cleanup','[\"346537000\"]'),(1533,'inventory.source.items.cleanup','[\"34664L000\"]'),(1534,'inventory.source.items.cleanup','[\"346997000\"]'),(1535,'inventory.source.items.cleanup','[\"347396000\"]'),(1536,'inventory.source.items.cleanup','[\"34747C00U\"]'),(1537,'inventory.source.items.cleanup','[\"347615000\"]'),(1538,'inventory.source.items.cleanup','[\"35031000\"]'),(1539,'inventory.source.items.cleanup','[\"35050000\"]'),(1540,'inventory.source.items.cleanup','[\"36309000\"]'),(1541,'inventory.source.items.cleanup','[\"36356000\"]'),(1542,'inventory.source.items.cleanup','[\"38796000\"]'),(1543,'inventory.source.items.cleanup','[\"38805000\"]'),(1544,'inventory.source.items.cleanup','[\"39056000\"]'),(1545,'inventory.source.items.cleanup','[\"4164B003-0075\"]'),(1546,'inventory.source.items.cleanup','[\"500.377.01.7\"]'),(1547,'inventory.source.items.cleanup','[\"5111L003-0075\"]'),(1548,'inventory.source.items.cleanup','[\"5119B003-0075\"]'),(1549,'inventory.source.items.cleanup','[\"5138B003-0075\"]'),(1550,'inventory.source.items.cleanup','[\"5293L003-0075 - 5422B003-5395\"]'),(1551,'inventory.source.items.cleanup','[\"5505L003-0101\"]'),(1552,'inventory.source.items.cleanup','[\"5507L003-0101 77-003-001\"]'),(1553,'inventory.source.items.cleanup','[\"5512L003-0585 - 5514S003-5284\"]'),(1554,'inventory.source.items.cleanup','[\"5513L003-0075 5514S003-5284\"]'),(1555,'inventory.source.items.cleanup','[\"5520L003-0075\"]'),(1556,'inventory.source.items.cleanup','[\"5676B003-0075\"]'),(1557,'inventory.source.items.cleanup','[\"5780L003-7200 5783S003-5325\"]'),(1558,'inventory.source.items.cleanup','[\"5781L003-7200 5783S003-5325\"]'),(1559,'inventory.source.items.cleanup','[\"5785L003-0075 94-003-001\"]'),(1560,'inventory.source.items.cleanup','[\"5789B003-0075 5783S003-5325\"]'),(1561,'inventory.source.items.cleanup','[\"5813B003-0075\"]'),(1562,'inventory.source.items.cleanup','[\"6468L003-0353\"]'),(1563,'inventory.source.items.cleanup','[\"6875L003-0075\"]'),(1564,'inventory.source.items.cleanup','[\"7672B003-6203\"]'),(1565,'inventory.source.items.cleanup','[\"893301000\"]'),(1566,'inventory.source.items.cleanup','[\"893302000\"]'),(1567,'inventory.source.items.cleanup','[\"893303000\"]'),(1568,'inventory.source.items.cleanup','[\"A3003\"]'),(1569,'inventory.source.items.cleanup','[\"A3003V\"]'),(1570,'inventory.source.items.cleanup','[\"A3007\"]'),(1571,'inventory.source.items.cleanup','[\"A3023\"]'),(1572,'inventory.source.items.cleanup','[\"A3033\"]'),(1573,'inventory.source.items.cleanup','[\"A3040\"]'),(1574,'inventory.source.items.cleanup','[\"A3056\"]'),(1575,'inventory.source.items.cleanup','[\"A3057\"]'),(1576,'inventory.source.items.cleanup','[\"A3057E\"]'),(1577,'inventory.source.items.cleanup','[\"A3077\"]'),(1578,'inventory.source.items.cleanup','[\"A3089E\"]'),(1579,'inventory.source.items.cleanup','[\"A3091E\"]'),(1580,'inventory.source.items.cleanup','[\"A3092C\"]'),(1581,'inventory.source.items.cleanup','[\"A3099E\"]'),(1582,'inventory.source.items.cleanup','[\"A313\"]'),(1583,'inventory.source.items.cleanup','[\"A3167\"]'),(1584,'inventory.source.items.cleanup','[\"A3200\"]'),(1585,'inventory.source.items.cleanup','[\"A3201\"]'),(1586,'inventory.source.items.cleanup','[\"A3273A\"]'),(1587,'inventory.source.items.cleanup','[\"A3420A7000 A3410AC000\"]'),(1588,'inventory.source.items.cleanup','[\"A3420B9000 A3410BC000\"]'),(1589,'inventory.source.items.cleanup','[\"A3420N7000 A3410NC00F\"]'),(1590,'inventory.source.items.cleanup','[\"A3420N8000 A3410NC00F\"]'),(1591,'inventory.source.items.cleanup','[\"A342477000 A34147D00F\"]'),(1592,'inventory.source.items.cleanup','[\"A342479000 A34147D00F\"]'),(1593,'inventory.source.items.cleanup','[\"A342526000 A341520000\"]'),(1594,'inventory.source.items.cleanup','[\"A34299B00U A34199D00F\"]'),(1595,'inventory.source.items.cleanup','[\"A34299L000 A34199C00F\"]'),(1596,'inventory.source.items.cleanup','[\"A3440A9000\"]'),(1597,'inventory.source.items.cleanup','[\"A3460B7000\"]'),(1598,'inventory.source.items.cleanup','[\"A3460NL000\"]'),(1599,'inventory.source.items.cleanup','[\"A346528000\"]'),(1600,'inventory.source.items.cleanup','[\"A34678L000\"]'),(1601,'inventory.source.items.cleanup','[\"A346998000\"]'),(1602,'inventory.source.items.cleanup','[\"A34699L000\"]'),(1603,'inventory.source.items.cleanup','[\"A3470B7000\"]'),(1604,'inventory.source.items.cleanup','[\"A3470N7000\"]'),(1605,'inventory.source.items.cleanup','[\"A347737000\"]'),(1606,'inventory.source.items.cleanup','[\"A347996000\"]'),(1607,'inventory.source.items.cleanup','[\"A3788\"]'),(1608,'inventory.source.items.cleanup','[\"A391\"]'),(1609,'inventory.source.items.cleanup','[\"A393\"]'),(1610,'inventory.source.items.cleanup','[\"A803060002\"]'),(1611,'inventory.source.items.cleanup','[\"A803061002\"]'),(1612,'inventory.source.items.cleanup','[\"ARM22\"]'),(1613,'inventory.source.items.cleanup','[\"ART3207\"]'),(1614,'inventory.source.items.cleanup','[\"ART3210\"]'),(1615,'inventory.source.items.cleanup','[\"ART3211\"]'),(1616,'inventory.source.items.cleanup','[\"ART3212\"]'),(1617,'inventory.source.items.cleanup','[\"B57-0372\"]'),(1618,'inventory.source.items.cleanup','[\"BHC801\"]'),(1619,'inventory.source.items.cleanup','[\"BHC802\"]'),(1620,'inventory.source.items.cleanup','[\"BHC803\"]'),(1621,'inventory.source.items.cleanup','[\"BHC804\"]'),(1622,'inventory.source.items.cleanup','[\"BHC805\"]'),(1623,'inventory.source.items.cleanup','[\"BHC806\"]'),(1624,'inventory.source.items.cleanup','[\"BHC807\"]'),(1625,'inventory.source.items.cleanup','[\"BI510CNR0B\"]'),(1626,'inventory.source.items.cleanup','[\"BI630CNS1B\"]'),(1627,'inventory.source.items.cleanup','[\"BI630DNS1B\"]'),(1628,'inventory.source.items.cleanup','[\"BI710D1B1B\"]'),(1629,'inventory.source.items.cleanup','[\"BIC510NB0\"]'),(1630,'inventory.source.items.cleanup','[\"BIC510NS0B\"]'),(1631,'inventory.source.items.cleanup','[\"BIC630NB1B\"]'),(1632,'inventory.source.items.cleanup','[\"BIC630NS1B\"]'),(1633,'inventory.source.items.cleanup','[\"BID630NS1B\"]'),(1634,'inventory.source.items.cleanup','[\"BTW002\"]'),(1635,'inventory.source.items.cleanup','[\"BTW005\"]'),(1636,'inventory.source.items.cleanup','[\"BTW006\"]'),(1637,'inventory.source.items.cleanup','[\"BW002\"]'),(1638,'inventory.source.items.cleanup','[\"CBL006\"]'),(1639,'inventory.source.items.cleanup','[\"CBW001\"]'),(1640,'inventory.source.items.cleanup','[\"CBW002\"]'),(1641,'inventory.source.items.cleanup','[\"CCL008\"]'),(1642,'inventory.source.items.cleanup','[\"CCR014\"]'),(1643,'inventory.source.items.cleanup','[\"CCR022\"]'),(1644,'inventory.source.items.cleanup','[\"CCR023\"]'),(1645,'inventory.source.items.cleanup','[\"CCR033\"]'),(1646,'inventory.source.items.cleanup','[\"CCR034\"]'),(1647,'inventory.source.items.cleanup','[\"CCR035\"]'),(1648,'inventory.source.items.cleanup','[\"CCR036\"]'),(1649,'inventory.source.items.cleanup','[\"CCR037\"]'),(1650,'inventory.source.items.cleanup','[\"CCT001\"]'),(1651,'inventory.source.items.cleanup','[\"CCT002\"]'),(1652,'inventory.source.items.cleanup','[\"CCT003\"]'),(1653,'inventory.source.items.cleanup','[\"CHM003\"]'),(1654,'inventory.source.items.cleanup','[\"CHM005\"]'),(1655,'inventory.source.items.cleanup','[\"CKN003\"]'),(1656,'inventory.source.items.cleanup','[\"CLG003\"]'),(1657,'inventory.source.items.cleanup','[\"CLT007\"]'),(1658,'inventory.source.items.cleanup','[\"CLW001\"]'),(1659,'inventory.source.items.cleanup','[\"CLW002\"]'),(1660,'inventory.source.items.cleanup','[\"CMA009\"]'),(1661,'inventory.source.items.cleanup','[\"CO17AWHA\"]'),(1662,'inventory.source.items.cleanup','[\"CO20AWHA\"]'),(1663,'inventory.source.items.cleanup','[\"CO21AWHA\"]'),(1664,'inventory.source.items.cleanup','[\"CO23AWHA\"]'),(1665,'inventory.source.items.cleanup','[\"CO2601AWHA - CO17AWHA - RAKSEAT010\"]'),(1666,'inventory.source.items.cleanup','[\"CO27AWHA - RAKSEAT010\"]'),(1667,'inventory.source.items.cleanup','[\"CO32AWHA\\/SC\"]'),(1668,'inventory.source.items.cleanup','[\"CPA005\"]'),(1669,'inventory.source.items.cleanup','[\"CPA008\"]'),(1670,'inventory.source.items.cleanup','[\"CPA027\"]'),(1671,'inventory.source.items.cleanup','[\"CPC001\"]'),(1672,'inventory.source.items.cleanup','[\"CPC020\"]'),(1673,'inventory.source.items.cleanup','[\"CPC027\"]'),(1674,'inventory.source.items.cleanup','[\"CPV005\"]'),(1675,'inventory.source.items.cleanup','[\"CPV006\"]'),(1676,'inventory.source.items.cleanup','[\"CRT004\"]'),(1677,'inventory.source.items.cleanup','[\"CSS004\"]'),(1678,'inventory.source.items.cleanup','[\"DOCMP100\"]'),(1679,'inventory.source.items.cleanup','[\"Ellesmere EC4 Compact\"]'),(1680,'inventory.source.items.cleanup','[\"Ellesmere EC5 S E\"]'),(1681,'inventory.source.items.cleanup','[\"Ellesmere EC5 S G\"]'),(1682,'inventory.source.items.cleanup','[\"Ellesmere EC5 S MF\"]'),(1683,'inventory.source.items.cleanup','[\"Ellesmere EC5 W E\"]'),(1684,'inventory.source.items.cleanup','[\"Ellesmere EC5 W G\"]'),(1685,'inventory.source.items.cleanup','[\"Ellesmere EC5 W MF\"]'),(1686,'inventory.source.items.cleanup','[\"Esse 105\"]'),(1687,'inventory.source.items.cleanup','[\"Esse 155\"]'),(1688,'inventory.source.items.cleanup','[\"Esse 175 B\"]'),(1689,'inventory.source.items.cleanup','[\"Esse 175 F\"]'),(1690,'inventory.source.items.cleanup','[\"Esse 500SE\"]'),(1691,'inventory.source.items.cleanup','[\"Esse 525 SE\"]'),(1692,'inventory.source.items.cleanup','[\"Esse 550 SE\"]'),(1693,'inventory.source.items.cleanup','[\"Esse 705\"]'),(1694,'inventory.source.items.cleanup','[\"Esse 755\"]'),(1695,'inventory.source.items.cleanup','[\"Esse 775\"]'),(1696,'inventory.source.items.cleanup','[\"Esse Bakeheart\"]'),(1697,'inventory.source.items.cleanup','[\"Esse Ironheart\"]'),(1698,'inventory.source.items.cleanup','[\"Esse Warmheart\"]'),(1699,'inventory.source.items.cleanup','[\"Esse Warmheart S\"]'),(1700,'inventory.source.items.cleanup','[\"EWFP\"]'),(1701,'inventory.source.items.cleanup','[\"EWL\"]'),(1702,'inventory.source.items.cleanup','[\"EWP\"]'),(1703,'inventory.source.items.cleanup','[\"EWPH\"]'),(1704,'inventory.source.items.cleanup','[\"HAR13AWHA - YFG108C\"]'),(1705,'inventory.source.items.cleanup','[\"HAR17AWHA - YFG108C\"]'),(1706,'inventory.source.items.cleanup','[\"HAR18AWHA - YFG108C\"]'),(1707,'inventory.source.items.cleanup','[\"HAR19AWHA - YFG108C\"]'),(1708,'inventory.source.items.cleanup','[\"HR Offset Quadrant Trays\"]'),(1709,'inventory.source.items.cleanup','[\"HR Quadrant Trays\"]'),(1710,'inventory.source.items.cleanup','[\"HR Square Trays\"]'),(1711,'inventory.source.items.cleanup','[\"ITY315\"]'),(1712,'inventory.source.items.cleanup','[\"ITY316\"]'),(1713,'inventory.source.items.cleanup','[\"ITY317\"]'),(1714,'inventory.source.items.cleanup','[\"JTY004\"]'),(1715,'inventory.source.items.cleanup','[\"JTY025\"]'),(1716,'inventory.source.items.cleanup','[\"JTY026\"]'),(1717,'inventory.source.items.cleanup','[\"JTY034\"]'),(1718,'inventory.source.items.cleanup','[\"JTY301\"]'),(1719,'inventory.source.items.cleanup','[\"JTY302\"]'),(1720,'inventory.source.items.cleanup','[\"JTY303\"]'),(1721,'inventory.source.items.cleanup','[\"JTY311\"]'),(1722,'inventory.source.items.cleanup','[\"JTY316\"]'),(1723,'inventory.source.items.cleanup','[\"JTY375\"]'),(1724,'inventory.source.items.cleanup','[\"JTY386\"]'),(1725,'inventory.source.items.cleanup','[\"KRI3023\"]'),(1726,'inventory.source.items.cleanup','[\"KRI3207\"]'),(1727,'inventory.source.items.cleanup','[\"KRI3210\"]'),(1728,'inventory.source.items.cleanup','[\"KRI3211\"]'),(1729,'inventory.source.items.cleanup','[\"KU9202HF0G\"]'),(1730,'inventory.source.items.cleanup','[\"KU9213HG0G\"]'),(1731,'inventory.source.items.cleanup','[\"Ludlow EC5 S E\"]'),(1732,'inventory.source.items.cleanup','[\"Ludlow EC5 S G\"]'),(1733,'inventory.source.items.cleanup','[\"Ludlow EC5 S MF\"]'),(1734,'inventory.source.items.cleanup','[\"Ludlow EC5 W E\"]'),(1735,'inventory.source.items.cleanup','[\"Ludlow EC5 W G\"]'),(1736,'inventory.source.items.cleanup','[\"Ludlow EC5 W MF\"]'),(1737,'inventory.source.items.cleanup','[\"Matki-CL\"]'),(1738,'inventory.source.items.cleanup','[\"Matki-CLC\"]'),(1739,'inventory.source.items.cleanup','[\"Matki-CLL\"]'),(1740,'inventory.source.items.cleanup','[\"Matki-CLQ\"]'),(1741,'inventory.source.items.cleanup','[\"Matki-FL\"]'),(1742,'inventory.source.items.cleanup','[\"Matki-MF\"]'),(1743,'inventory.source.items.cleanup','[\"Matki-MP\"]'),(1744,'inventory.source.items.cleanup','[\"Matki-SC\"]'),(1745,'inventory.source.items.cleanup','[\"Matki-SL\"]'),(1746,'inventory.source.items.cleanup','[\"Matki-SLF\"]'),(1747,'inventory.source.items.cleanup','[\"Matki-SN\"]'),(1748,'inventory.source.items.cleanup','[\"Matki-SR\"]'),(1749,'inventory.source.items.cleanup','[\"Matki-SU\"]'),(1750,'inventory.source.items.cleanup','[\"MOTR\"]'),(1751,'inventory.source.items.cleanup','[\"MOWHP\"]'),(1752,'inventory.source.items.cleanup','[\"MOWR\"]'),(1753,'inventory.source.items.cleanup','[\"MOWT\"]'),(1754,'inventory.source.items.cleanup','[\"MOWW\"]'),(1755,'inventory.source.items.cleanup','[\"MP12AWHA - RAKSEAT016\"]'),(1756,'inventory.source.items.cleanup','[\"MP13AWHA - RAKSEAT016\"]'),(1757,'inventory.source.items.cleanup','[\"MP16AWHA - RAKSEAT016\"]'),(1758,'inventory.source.items.cleanup','[\"N17HH10N0B\"]'),(1759,'inventory.source.items.cleanup','[\"N17HH11N0B\"]'),(1760,'inventory.source.items.cleanup','[\"N17HH20N0B\"]'),(1761,'inventory.source.items.cleanup','[\"N17XH10N0\"]'),(1762,'inventory.source.items.cleanup','[\"N17ZH10N0\"]'),(1763,'inventory.source.items.cleanup','[\"N1AHA01N0B\"]'),(1764,'inventory.source.items.cleanup','[\"N1AHA02N0B\"]'),(1765,'inventory.source.items.cleanup','[\"NCG306\"]'),(1766,'inventory.source.items.cleanup','[\"NCG340\"]'),(1767,'inventory.source.items.cleanup','[\"NCG350\"]'),(1768,'inventory.source.items.cleanup','[\"NCG406\"]'),(1769,'inventory.source.items.cleanup','[\"NCG440\"]'),(1770,'inventory.source.items.cleanup','[\"NCG450\"]'),(1771,'inventory.source.items.cleanup','[\"NCG506\"]'),(1772,'inventory.source.items.cleanup','[\"NCG540\"]'),(1773,'inventory.source.items.cleanup','[\"NCG550\"]'),(1774,'inventory.source.items.cleanup','[\"NCG650\"]'),(1775,'inventory.source.items.cleanup','[\"NCG850\"]'),(1776,'inventory.source.items.cleanup','[\"NCS140\"]'),(1777,'inventory.source.items.cleanup','[\"NCS150\"]'),(1778,'inventory.source.items.cleanup','[\"NCS250\"]'),(1779,'inventory.source.items.cleanup','[\"NCS251\"]'),(1780,'inventory.source.items.cleanup','[\"NCS286\"]'),(1781,'inventory.source.items.cleanup','[\"NCS296\"]'),(1782,'inventory.source.items.cleanup','[\"NCS500\"]'),(1783,'inventory.source.items.cleanup','[\"NCS806\"]'),(1784,'inventory.source.items.cleanup','[\"NCS856\"]'),(1785,'inventory.source.items.cleanup','[\"NCT140\"]'),(1786,'inventory.source.items.cleanup','[\"NCU900C\"]'),(1787,'inventory.source.items.cleanup','[\"NWPR\"]'),(1788,'inventory.source.items.cleanup','[\"NWSF\"]'),(1789,'inventory.source.items.cleanup','[\"OC13AAWHA\"]'),(1790,'inventory.source.items.cleanup','[\"Offset Quadrant Shower Tray\"]'),(1791,'inventory.source.items.cleanup','[\"ORG12AWHA - YFG109C\"]'),(1792,'inventory.source.items.cleanup','[\"ORI62CNRPAKNS - YFG109C\"]'),(1793,'inventory.source.items.cleanup','[\"Quadrant Shower Tray\"]'),(1794,'inventory.source.items.cleanup','[\"QUEV51\"]'),(1795,'inventory.source.items.cleanup','[\"QUEV52\"]'),(1796,'inventory.source.items.cleanup','[\"QUEV53\"]'),(1797,'inventory.source.items.cleanup','[\"QUEV56\"]'),(1798,'inventory.source.items.cleanup','[\"R8580X3GB\"]'),(1799,'inventory.source.items.cleanup','[\"Raindance Shower panel\"]'),(1800,'inventory.source.items.cleanup','[\"Rectangular Shower Tray NTP00\"]'),(1801,'inventory.source.items.cleanup','[\"REI3407\"]'),(1802,'inventory.source.items.cleanup','[\"REI3410\"]'),(1803,'inventory.source.items.cleanup','[\"REI3411\"]'),(1804,'inventory.source.items.cleanup','[\"REI3417\"]'),(1805,'inventory.source.items.cleanup','[\"REI3607\"]'),(1806,'inventory.source.items.cleanup','[\"REI3610\"]'),(1807,'inventory.source.items.cleanup','[\"REI3611\"]'),(1808,'inventory.source.items.cleanup','[\"REI3617\"]'),(1809,'inventory.source.items.cleanup','[\"RFBR\"]'),(1810,'inventory.source.items.cleanup','[\"RFST\"]'),(1811,'inventory.source.items.cleanup','[\"RND3207\"]'),(1812,'inventory.source.items.cleanup','[\"RND3210\"]'),(1813,'inventory.source.items.cleanup','[\"Roca Colina\"]'),(1814,'inventory.source.items.cleanup','[\"RST19AWHA - RAKSEAT006\"]'),(1815,'inventory.source.items.cleanup','[\"RST23AWHA - RAKSEAT006\"]'),(1816,'inventory.source.items.cleanup','[\"RST23AWHA - RAKSEAT012\"]'),(1817,'inventory.source.items.cleanup','[\"SE13AWHA - RAKSEAT014\"]'),(1818,'inventory.source.items.cleanup','[\"SE13AWHA - RAKSEAT017\"]'),(1819,'inventory.source.items.cleanup','[\"SE16AWHA - RAKSEAT014\"]'),(1820,'inventory.source.items.cleanup','[\"SE17AWHA - RAKSEAT014\"]'),(1821,'inventory.source.items.cleanup','[\"SE17AWHA - RAKSEAT017\"]'),(1822,'inventory.source.items.cleanup','[\"SE19AWHA\"]'),(1823,'inventory.source.items.cleanup','[\"Shower Waste\"]'),(1824,'inventory.source.items.cleanup','[\"SM16AWHA - RAKSEAT005\"]'),(1825,'inventory.source.items.cleanup','[\"SM16AWHA - SM0701AWHA - RAKSEAT005\"]'),(1826,'inventory.source.items.cleanup','[\"SP17AWHA\"]'),(1827,'inventory.source.items.cleanup','[\"SP18AWHA\"]'),(1828,'inventory.source.items.cleanup','[\"SQR3207\"]'),(1829,'inventory.source.items.cleanup','[\"SQR3210\"]'),(1830,'inventory.source.items.cleanup','[\"Square Shower Tray\"]'),(1831,'inventory.source.items.cleanup','[\"STY042\"]'),(1832,'inventory.source.items.cleanup','[\"STY059\"]'),(1833,'inventory.source.items.cleanup','[\"TQ13AWHA - RAKSEAT015\"]'),(1834,'inventory.source.items.cleanup','[\"TQ18AWHA - RAKSEAT015\"]'),(1835,'inventory.source.items.cleanup','[\"TQ18AWHA - TQ0801AWHA - RAKSEAT015\"]'),(1836,'inventory.source.items.cleanup','[\"TSVT002\"]'),(1837,'inventory.source.items.cleanup','[\"TSVT003\"]'),(1838,'inventory.source.items.cleanup','[\"TSVT101\"]'),(1839,'inventory.source.items.cleanup','[\"TSVT102\"]'),(1840,'inventory.source.items.cleanup','[\"TSVT103\"]'),(1841,'inventory.source.items.cleanup','[\"V6320X2GB\"]'),(1842,'inventory.source.items.cleanup','[\"V6540X2GB\"]'),(1843,'inventory.source.items.cleanup','[\"VBS001\"]'),(1844,'inventory.source.items.cleanup','[\"VBS009\"]'),(1845,'inventory.source.items.cleanup','[\"VBS023\"]'),(1846,'inventory.source.items.cleanup','[\"VitrA Matrix\"]'),(1847,'inventory.source.items.cleanup','[\"Vitra Milton cc pan\"]'),(1848,'inventory.source.items.cleanup','[\"VNA341U8GB\"]'),(1849,'inventory.source.items.cleanup','[\"VSQ1\"]'),(1850,'inventory.source.items.cleanup','[\"VSQ2\"]'),(1851,'inventory.source.items.cleanup','[\"VSQ3\"]'),(1852,'inventory.source.items.cleanup','[\"VSQ4\"]'),(1853,'inventory.source.items.cleanup','[\"WIW28301GB\"]'),(1854,'inventory.source.items.cleanup','[\"WIW28501GB\"]'),(1855,'inventory.source.items.cleanup','[\"WK14D322GB\"]'),(1856,'inventory.source.items.cleanup','[\"WK14D542GB\"]'),(1857,'inventory.source.items.cleanup','[\"WK14D543GB\"]'),(1858,'inventory.source.items.cleanup','[\"WKD28352GB\"]'),(1859,'inventory.source.items.cleanup','[\"WKD28542GB\"]'),(1860,'inventory.source.items.cleanup','[\"WN34A1U8GB\"]'),(1861,'inventory.source.items.cleanup','[\"WN54C2ATGB\"]'),(1862,'inventory.source.items.cleanup','[\"WT20AWHA - RAKWTNSEAT\"]'),(1863,'inventory.source.items.cleanup','[\"112.0030.882\"]'),(1864,'inventory.source.items.cleanup','[\"112.0040.821\"]'),(1865,'inventory.source.items.cleanup','[\"112.0050.988\"]'),(1866,'inventory.source.items.cleanup','[\"112.0052.536\"]'),(1867,'inventory.source.items.cleanup','[\"112.0057.850\"]'),(1868,'inventory.source.items.cleanup','[\"112.0059.946\"]'),(1869,'inventory.source.items.cleanup','[\"112.0066.060\"]'),(1870,'inventory.source.items.cleanup','[\"112.0075.642\"]'),(1871,'inventory.source.items.cleanup','[\"112.0080.355\"]'),(1872,'inventory.source.items.cleanup','[\"112.0083.810\"]'),(1873,'inventory.source.items.cleanup','[\"112.0175.520\"]'),(1874,'inventory.source.items.cleanup','[\"112.0188.651\"]'),(1875,'inventory.source.items.cleanup','[\"112.0188.653\"]'),(1876,'inventory.source.items.cleanup','[\"112.0250.014\"]'),(1877,'inventory.source.items.cleanup','[\"112.0256.867\"]'),(1878,'inventory.source.items.cleanup','[\"112.0342.598\"]'),(1879,'inventory.source.items.cleanup','[\"112.0357.743\"]'),(1880,'inventory.source.items.cleanup','[\"112.0384.902\"]'),(1881,'inventory.source.items.cleanup','[\"112.0384.903\"]'),(1882,'inventory.source.items.cleanup','[\"112.0461.942\"]'),(1883,'inventory.source.items.cleanup','[\"112.0520.938\"]'),(1884,'inventory.source.items.cleanup','[\"112.0591.081\"]'),(1885,'inventory.source.items.cleanup','[\"112.0659.398\"]'),(1886,'inventory.source.items.cleanup','[\"115.08\"]'),(1887,'inventory.source.items.cleanup','[\"115.080.JQ.1\"]'),(1888,'inventory.source.items.cleanup','[\"115.080.KH.1\"]'),(1889,'inventory.source.items.cleanup','[\"115.080.KJ.1\"]'),(1890,'inventory.source.items.cleanup','[\"115.080.KK.1\"]'),(1891,'inventory.source.items.cleanup','[\"115.080.KL.1\"]'),(1892,'inventory.source.items.cleanup','[\"115.080.KM.1\"]'),(1893,'inventory.source.items.cleanup','[\"115.081\"]'),(1894,'inventory.source.items.cleanup','[\"115.081.GH.1\"]'),(1895,'inventory.source.items.cleanup','[\"115.081.JK.1\"]'),(1896,'inventory.source.items.cleanup','[\"115.081.SI.1\"]'),(1897,'inventory.source.items.cleanup','[\"115.081.SJ.1\"]'),(1898,'inventory.source.items.cleanup','[\"115.085\"]'),(1899,'inventory.source.items.cleanup','[\"115.085.JQ.1\"]'),(1900,'inventory.source.items.cleanup','[\"115.085.KH.1\"]'),(1901,'inventory.source.items.cleanup','[\"115.085.KJ.1\"]'),(1902,'inventory.source.items.cleanup','[\"115.085.KK.1\"]'),(1903,'inventory.source.items.cleanup','[\"115.085.KL.1\"]'),(1904,'inventory.source.items.cleanup','[\"115.085.KM.1\"]'),(1905,'inventory.source.items.cleanup','[\"115.089.SJ.1\"]'),(1906,'inventory.source.items.cleanup','[\"115.09\"]'),(1907,'inventory.source.items.cleanup','[\"115.105.11.1\"]'),(1908,'inventory.source.items.cleanup','[\"115.105.21.1\"]'),(1909,'inventory.source.items.cleanup','[\"115.105.46.1\"]'),(1910,'inventory.source.items.cleanup','[\"115.125\"]'),(1911,'inventory.source.items.cleanup','[\"115.125.21.1\"]'),(1912,'inventory.source.items.cleanup','[\"115.135\"]'),(1913,'inventory.source.items.cleanup','[\"115.135.11.1\"]'),(1914,'inventory.source.items.cleanup','[\"115.135.21.1\"]'),(1915,'inventory.source.items.cleanup','[\"115.135.46.1\"]'),(1916,'inventory.source.items.cleanup','[\"115.228.11.1\"]'),(1917,'inventory.source.items.cleanup','[\"115.228.21.1\"]'),(1918,'inventory.source.items.cleanup','[\"115.228.46.1\"]'),(1919,'inventory.source.items.cleanup','[\"115.24\"]'),(1920,'inventory.source.items.cleanup','[\"115.240.KH.1\"]'),(1921,'inventory.source.items.cleanup','[\"115.240.KJ.1\"]'),(1922,'inventory.source.items.cleanup','[\"115.240.KK.1\"]'),(1923,'inventory.source.items.cleanup','[\"115.240.KL.1\"]'),(1924,'inventory.source.items.cleanup','[\"115.240.KM.1\"]'),(1925,'inventory.source.items.cleanup','[\"115.260.21.1\"]'),(1926,'inventory.source.items.cleanup','[\"115.260.46.1\"]'),(1927,'inventory.source.items.cleanup','[\"115.758.KH.5\"]'),(1928,'inventory.source.items.cleanup','[\"115.758.KJ.5\"]'),(1929,'inventory.source.items.cleanup','[\"115.758.KN.5\"]'),(1930,'inventory.source.items.cleanup','[\"115.770.11.5\"]'),(1931,'inventory.source.items.cleanup','[\"115.770.21.5\"]'),(1932,'inventory.source.items.cleanup','[\"115.770.DT.5\"]'),(1933,'inventory.source.items.cleanup','[\"115.770.DW.5\"]'),(1934,'inventory.source.items.cleanup','[\"115.770.KA.5\"]'),(1935,'inventory.source.items.cleanup','[\"115.787.SN.5\"]'),(1936,'inventory.source.items.cleanup','[\"115.788\"]'),(1937,'inventory.source.items.cleanup','[\"115.788.00.2\"]'),(1938,'inventory.source.items.cleanup','[\"115.788.11.2\"]'),(1939,'inventory.source.items.cleanup','[\"115.788.21.2\"]'),(1940,'inventory.source.items.cleanup','[\"115.788.DW.2\"]'),(1941,'inventory.source.items.cleanup','[\"115.788.GH.2\"]'),(1942,'inventory.source.items.cleanup','[\"115.788.JK.2\"]'),(1943,'inventory.source.items.cleanup','[\"115.788.JL.2\"]'),(1944,'inventory.source.items.cleanup','[\"115.788.JM.2\"]'),(1945,'inventory.source.items.cleanup','[\"115.788.JV.2\"]'),(1946,'inventory.source.items.cleanup','[\"115.788.JX.2\"]'),(1947,'inventory.source.items.cleanup','[\"115.788.SD.2\"]'),(1948,'inventory.source.items.cleanup','[\"115.882\"]'),(1949,'inventory.source.items.cleanup','[\"115.882.01.1\"]'),(1950,'inventory.source.items.cleanup','[\"115.882.11.1\"]'),(1951,'inventory.source.items.cleanup','[\"115.882.14.1\"]'),(1952,'inventory.source.items.cleanup','[\"115.882.16.1\"]'),(1953,'inventory.source.items.cleanup','[\"115.882.DW.1\"]'),(1954,'inventory.source.items.cleanup','[\"115.882.JQ.1\"]'),(1955,'inventory.source.items.cleanup','[\"115.882.JT.1\"]'),(1956,'inventory.source.items.cleanup','[\"115.882.KH.1\"]'),(1957,'inventory.source.items.cleanup','[\"115.882.KJ.1\"]'),(1958,'inventory.source.items.cleanup','[\"115.882.KK.1\"]'),(1959,'inventory.source.items.cleanup','[\"115.882.KL.1\"]'),(1960,'inventory.source.items.cleanup','[\"115.882.KM.1\"]'),(1961,'inventory.source.items.cleanup','[\"115.882.KN.1\"]'),(1962,'inventory.source.items.cleanup','[\"115.882.SN.1\"]'),(1963,'inventory.source.items.cleanup','[\"115.883\"]'),(1964,'inventory.source.items.cleanup','[\"115.883.01.1\"]'),(1965,'inventory.source.items.cleanup','[\"115.883.11.1\"]'),(1966,'inventory.source.items.cleanup','[\"115.883.14.1\"]'),(1967,'inventory.source.items.cleanup','[\"115.883.16.1\"]'),(1968,'inventory.source.items.cleanup','[\"115.883.DW.1\"]'),(1969,'inventory.source.items.cleanup','[\"115.883.JQ.1\"]'),(1970,'inventory.source.items.cleanup','[\"115.883.JT.1\"]'),(1971,'inventory.source.items.cleanup','[\"115.883.KH.1\"]'),(1972,'inventory.source.items.cleanup','[\"115.883.KJ.1\"]'),(1973,'inventory.source.items.cleanup','[\"115.883.KK.1\"]'),(1974,'inventory.source.items.cleanup','[\"115.883.Km.1\"]'),(1975,'inventory.source.items.cleanup','[\"115.884.00.1\"]'),(1976,'inventory.source.items.cleanup','[\"115.884.JL.1\"]'),(1977,'inventory.source.items.cleanup','[\"115.884.JM.1\"]'),(1978,'inventory.source.items.cleanup','[\"115.884.SI.1\"]'),(1979,'inventory.source.items.cleanup','[\"115.884.SJ.1\"]'),(1980,'inventory.source.items.cleanup','[\"115.889.SN.1\"]'),(1981,'inventory.source.items.cleanup','[\"115.893.14.1\"]'),(1982,'inventory.source.items.cleanup','[\"115.893.JT.1\"]'),(1983,'inventory.source.items.cleanup','[\"115.893.KJ.1\"]'),(1984,'inventory.source.items.cleanup','[\"115.893.KX.1\"]'),(1985,'inventory.source.items.cleanup','[\"115.893.KY.1\"]'),(1986,'inventory.source.items.cleanup','[\"115.906.SN.1\"]'),(1987,'inventory.source.items.cleanup','[\"115.907.KN.1\"]'),(1988,'inventory.source.items.cleanup','[\"115.908.KJ.1\"]'),(1989,'inventory.source.items.cleanup','[\"116.015.KK.1\"]'),(1990,'inventory.source.items.cleanup','[\"116.017\"]'),(1991,'inventory.source.items.cleanup','[\"116.017.KH.1\"]'),(1992,'inventory.source.items.cleanup','[\"116.017.KJ.1\"]'),(1993,'inventory.source.items.cleanup','[\"116.017.KK.1\"]'),(1994,'inventory.source.items.cleanup','[\"116.017.KM.1\"]'),(1995,'inventory.source.items.cleanup','[\"116.027\"]'),(1996,'inventory.source.items.cleanup','[\"116.027.KH.1\"]'),(1997,'inventory.source.items.cleanup','[\"116.027.KJ.1\"]'),(1998,'inventory.source.items.cleanup','[\"116.027.KM.1\"]'),(1999,'inventory.source.items.cleanup','[\"116.027.KX.1\"]'),(2000,'inventory.source.items.cleanup','[\"121.0150.144\"]'),(2001,'inventory.source.items.cleanup','[\"121.0150.145\"]'),(2002,'inventory.source.items.cleanup','[\"121.0150.146\"]'),(2003,'inventory.source.items.cleanup','[\"122.0606.948\"]'),(2004,'inventory.source.items.cleanup','[\"122.0606.949\"]'),(2005,'inventory.source.items.cleanup','[\"122.0606.969\"]'),(2006,'inventory.source.items.cleanup','[\"122.0607.061\"]'),(2007,'inventory.source.items.cleanup','[\"122.0607.085\"]'),(2008,'inventory.source.items.cleanup','[\"124.0532.229\"]'),(2009,'inventory.source.items.cleanup','[\"12SL366A\"]'),(2010,'inventory.source.items.cleanup','[\"12SL366C1\"]'),(2011,'inventory.source.items.cleanup','[\"12SL380\"]'),(2012,'inventory.source.items.cleanup','[\"12SL704HP\"]'),(2013,'inventory.source.items.cleanup','[\"12SL801\"]'),(2014,'inventory.source.items.cleanup','[\"12SL802\"]'),(2015,'inventory.source.items.cleanup','[\"133.0026.896\"]'),(2016,'inventory.source.items.cleanup','[\"134.0035.042\"]'),(2017,'inventory.source.items.cleanup','[\"134.0473.235\"]'),(2018,'inventory.source.items.cleanup','[\"134.0473.236\"]'),(2019,'inventory.source.items.cleanup','[\"134.0473.237\"]'),(2020,'inventory.source.items.cleanup','[\"134.0473.238\"]'),(2021,'inventory.source.items.cleanup','[\"134.0483.704\"]'),(2022,'inventory.source.items.cleanup','[\"210521\"]'),(2023,'inventory.source.items.cleanup','[\"218421\"]'),(2024,'inventory.source.items.cleanup','[\"220574\"]'),(2025,'inventory.source.items.cleanup','[\"220736\"]'),(2026,'inventory.source.items.cleanup','[\"223297\"]'),(2027,'inventory.source.items.cleanup','[\"224787\"]'),(2028,'inventory.source.items.cleanup','[\"225362\"]'),(2029,'inventory.source.items.cleanup','[\"227689\"]'),(2030,'inventory.source.items.cleanup','[\"227692\"]'),(2031,'inventory.source.items.cleanup','[\"227697\"]'),(2032,'inventory.source.items.cleanup','[\"227699\"]'),(2033,'inventory.source.items.cleanup','[\"230700\"]'),(2034,'inventory.source.items.cleanup','[\"230734\"]'),(2035,'inventory.source.items.cleanup','[\"231396\"]'),(2036,'inventory.source.items.cleanup','[\"234795\"]'),(2037,'inventory.source.items.cleanup','[\"235236\"]'),(2038,'inventory.source.items.cleanup','[\"235844\"]'),(2039,'inventory.source.items.cleanup','[\"235866\"]'),(2040,'inventory.source.items.cleanup','[\"235906\"]'),(2041,'inventory.source.items.cleanup','[\"240729\"]'),(2042,'inventory.source.items.cleanup','[\"38505000\"]'),(2043,'inventory.source.items.cleanup','[\"38506000\"]'),(2044,'inventory.source.items.cleanup','[\"38732000\"]'),(2045,'inventory.source.items.cleanup','[\"38732BR0\"]'),(2046,'inventory.source.items.cleanup','[\"38732SD0\"]'),(2047,'inventory.source.items.cleanup','[\"38765000\"]'),(2048,'inventory.source.items.cleanup','[\"38776SD0\"]'),(2049,'inventory.source.items.cleanup','[\"38809000\"]'),(2050,'inventory.source.items.cleanup','[\"38859XG0\"]'),(2051,'inventory.source.items.cleanup','[\"38861000\"]'),(2052,'inventory.source.items.cleanup','[\"389160A0\"]'),(2053,'inventory.source.items.cleanup','[\"450748\"]'),(2054,'inventory.source.items.cleanup','[\"450762\"]'),(2055,'inventory.source.items.cleanup','[\"450835\"]'),(2056,'inventory.source.items.cleanup','[\"450836\"]'),(2057,'inventory.source.items.cleanup','[\"450841\"]'),(2058,'inventory.source.items.cleanup','[\"450929\"]'),(2059,'inventory.source.items.cleanup','[\"452613\"]'),(2060,'inventory.source.items.cleanup','[\"452614\"]'),(2061,'inventory.source.items.cleanup','[\"452615\"]'),(2062,'inventory.source.items.cleanup','[\"453364\"]'),(2063,'inventory.source.items.cleanup','[\"453605\"]'),(2064,'inventory.source.items.cleanup','[\"453606\"]'),(2065,'inventory.source.items.cleanup','[\"453630\"]'),(2066,'inventory.source.items.cleanup','[\"453631\"]'),(2067,'inventory.source.items.cleanup','[\"453665\"]'),(2068,'inventory.source.items.cleanup','[\"454729\"]'),(2069,'inventory.source.items.cleanup','[\"454730\"]'),(2070,'inventory.source.items.cleanup','[\"454795\"]'),(2071,'inventory.source.items.cleanup','[\"456438\"]'),(2072,'inventory.source.items.cleanup','[\"456439\"]'),(2073,'inventory.source.items.cleanup','[\"456440\"]'),(2074,'inventory.source.items.cleanup','[\"456449\"]'),(2075,'inventory.source.items.cleanup','[\"456453\"]'),(2076,'inventory.source.items.cleanup','[\"49400\"]'),(2077,'inventory.source.items.cleanup','[\"49500\"]'),(2078,'inventory.source.items.cleanup','[\"49600\"]'),(2079,'inventory.source.items.cleanup','[\"49700\"]'),(2080,'inventory.source.items.cleanup','[\"50500\"]'),(2081,'inventory.source.items.cleanup','[\"50600\"]'),(2082,'inventory.source.items.cleanup','[\"50700\"]'),(2083,'inventory.source.items.cleanup','[\"513306\"]'),(2084,'inventory.source.items.cleanup','[\"51400\"]'),(2085,'inventory.source.items.cleanup','[\"514238\"]'),(2086,'inventory.source.items.cleanup','[\"514486\"]'),(2087,'inventory.source.items.cleanup','[\"514544\"]'),(2088,'inventory.source.items.cleanup','[\"514647\"]'),(2089,'inventory.source.items.cleanup','[\"51500\"]'),(2090,'inventory.source.items.cleanup','[\"51600\"]'),(2091,'inventory.source.items.cleanup','[\"517666\"]'),(2092,'inventory.source.items.cleanup','[\"51800\"]'),(2093,'inventory.source.items.cleanup','[\"518497\"]'),(2094,'inventory.source.items.cleanup','[\"51900\"]'),(2095,'inventory.source.items.cleanup','[\"52000\"]'),(2096,'inventory.source.items.cleanup','[\"52100\"]'),(2097,'inventory.source.items.cleanup','[\"521559\"]'),(2098,'inventory.source.items.cleanup','[\"521560\"]'),(2099,'inventory.source.items.cleanup','[\"521565\"]'),(2100,'inventory.source.items.cleanup','[\"521571\"]'),(2101,'inventory.source.items.cleanup','[\"521573\"]'),(2102,'inventory.source.items.cleanup','[\"521575\"]'),(2103,'inventory.source.items.cleanup','[\"521576\"]'),(2104,'inventory.source.items.cleanup','[\"521577\"]'),(2105,'inventory.source.items.cleanup','[\"521580\"]'),(2106,'inventory.source.items.cleanup','[\"521581\"]'),(2107,'inventory.source.items.cleanup','[\"521589\"]'),(2108,'inventory.source.items.cleanup','[\"521591\"]'),(2109,'inventory.source.items.cleanup','[\"521593\"]'),(2110,'inventory.source.items.cleanup','[\"521596\"]'),(2111,'inventory.source.items.cleanup','[\"521618\"]'),(2112,'inventory.source.items.cleanup','[\"521748\"]'),(2113,'inventory.source.items.cleanup','[\"521840\"]'),(2114,'inventory.source.items.cleanup','[\"521841\"]'),(2115,'inventory.source.items.cleanup','[\"522103\"]'),(2116,'inventory.source.items.cleanup','[\"522951\"]'),(2117,'inventory.source.items.cleanup','[\"522952\"]'),(2118,'inventory.source.items.cleanup','[\"522953\"]'),(2119,'inventory.source.items.cleanup','[\"522955\"]'),(2120,'inventory.source.items.cleanup','[\"522957\"]'),(2121,'inventory.source.items.cleanup','[\"522959\"]'),(2122,'inventory.source.items.cleanup','[\"522961\"]'),(2123,'inventory.source.items.cleanup','[\"522963\"]'),(2124,'inventory.source.items.cleanup','[\"522965\"]'),(2125,'inventory.source.items.cleanup','[\"522967\"]'),(2126,'inventory.source.items.cleanup','[\"522969\"]'),(2127,'inventory.source.items.cleanup','[\"522971\"]'),(2128,'inventory.source.items.cleanup','[\"522983\"]'),(2129,'inventory.source.items.cleanup','[\"522985\"]'),(2130,'inventory.source.items.cleanup','[\"522987\"]'),(2131,'inventory.source.items.cleanup','[\"523098\"]'),(2132,'inventory.source.items.cleanup','[\"523099\"]'),(2133,'inventory.source.items.cleanup','[\"523386\"]'),(2134,'inventory.source.items.cleanup','[\"523387\"]'),(2135,'inventory.source.items.cleanup','[\"523667\"]'),(2136,'inventory.source.items.cleanup','[\"523726\"]'),(2137,'inventory.source.items.cleanup','[\"523733\"]'),(2138,'inventory.source.items.cleanup','[\"523741\"]'),(2139,'inventory.source.items.cleanup','[\"524270\"]'),(2140,'inventory.source.items.cleanup','[\"524272\"]'),(2141,'inventory.source.items.cleanup','[\"524274\"]'),(2142,'inventory.source.items.cleanup','[\"525149\"]'),(2143,'inventory.source.items.cleanup','[\"525156\"]'),(2144,'inventory.source.items.cleanup','[\"525163\"]'),(2145,'inventory.source.items.cleanup','[\"525164\"]'),(2146,'inventory.source.items.cleanup','[\"525165\"]'),(2147,'inventory.source.items.cleanup','[\"525244\"]'),(2148,'inventory.source.items.cleanup','[\"525245\"]'),(2149,'inventory.source.items.cleanup','[\"525246\"]'),(2150,'inventory.source.items.cleanup','[\"525247\"]'),(2151,'inventory.source.items.cleanup','[\"525249\"]'),(2152,'inventory.source.items.cleanup','[\"525327\"]'),(2153,'inventory.source.items.cleanup','[\"525328\"]'),(2154,'inventory.source.items.cleanup','[\"525330\"]'),(2155,'inventory.source.items.cleanup','[\"526113\"]'),(2156,'inventory.source.items.cleanup','[\"526115\"]'),(2157,'inventory.source.items.cleanup','[\"526117\"]'),(2158,'inventory.source.items.cleanup','[\"526120\"]'),(2159,'inventory.source.items.cleanup','[\"526122\"]'),(2160,'inventory.source.items.cleanup','[\"526125\"]'),(2161,'inventory.source.items.cleanup','[\"526243\"]'),(2162,'inventory.source.items.cleanup','[\"526244\"]'),(2163,'inventory.source.items.cleanup','[\"526305\"]'),(2164,'inventory.source.items.cleanup','[\"526306\"]'),(2165,'inventory.source.items.cleanup','[\"526308\"]'),(2166,'inventory.source.items.cleanup','[\"526350\"]'),(2167,'inventory.source.items.cleanup','[\"526351\"]'),(2168,'inventory.source.items.cleanup','[\"526352\"]'),(2169,'inventory.source.items.cleanup','[\"526354\"]'),(2170,'inventory.source.items.cleanup','[\"527834\"]'),(2171,'inventory.source.items.cleanup','[\"527835\"]'),(2172,'inventory.source.items.cleanup','[\"53500\"]'),(2173,'inventory.source.items.cleanup','[\"53600\"]'),(2174,'inventory.source.items.cleanup','[\"53800\"]'),(2175,'inventory.source.items.cleanup','[\"53900\"]'),(2176,'inventory.source.items.cleanup','[\"710\"]'),(2177,'inventory.source.items.cleanup','[\"720\"]'),(2178,'inventory.source.items.cleanup','[\"730\"]'),(2179,'inventory.source.items.cleanup','[\"740\"]'),(2180,'inventory.source.items.cleanup','[\"750\"]'),(2181,'inventory.source.items.cleanup','[\"760\"]'),(2182,'inventory.source.items.cleanup','[\"770\"]'),(2183,'inventory.source.items.cleanup','[\"78610000\"]'),(2184,'inventory.source.items.cleanup','[\"78710000\"]'),(2185,'inventory.source.items.cleanup','[\"78730000\"]'),(2186,'inventory.source.items.cleanup','[\"78731000\"]'),(2187,'inventory.source.items.cleanup','[\"78732000\"]'),(2188,'inventory.source.items.cleanup','[\"78733000\"]'),(2189,'inventory.source.items.cleanup','[\"78748000\"]'),(2190,'inventory.source.items.cleanup','[\"78749000\"]'),(2191,'inventory.source.items.cleanup','[\"78750000\"]'),(2192,'inventory.source.items.cleanup','[\"78751000\"]'),(2193,'inventory.source.items.cleanup','[\"78752000\"]'),(2194,'inventory.source.items.cleanup','[\"78757000\"]'),(2195,'inventory.source.items.cleanup','[\"78758000\"]'),(2196,'inventory.source.items.cleanup','[\"78759000\"]'),(2197,'inventory.source.items.cleanup','[\"79000000\"]'),(2198,'inventory.source.items.cleanup','[\"79210000\"]'),(2199,'inventory.source.items.cleanup','[\"79310000\"]'),(2200,'inventory.source.items.cleanup','[\"79400000\"]'),(2201,'inventory.source.items.cleanup','[\"79510000\"]'),(2202,'inventory.source.items.cleanup','[\"79520000\"]'),(2203,'inventory.source.items.cleanup','[\"79530000\"]'),(2204,'inventory.source.items.cleanup','[\"Active Soap Dispenser\"]'),(2205,'inventory.source.items.cleanup','[\"ADIRA 45 S\"]'),(2206,'inventory.source.items.cleanup','[\"ADIRA 6S\"]'),(2207,'inventory.source.items.cleanup','[\"ADIRA XL 6S\"]'),(2208,'inventory.source.items.cleanup','[\"AGX 611-100\"]'),(2209,'inventory.source.items.cleanup','[\"AGX 611-78\"]'),(2210,'inventory.source.items.cleanup','[\"AGX 611-860\"]'),(2211,'inventory.source.items.cleanup','[\"AGX 651\"]'),(2212,'inventory.source.items.cleanup','[\"AHK 611\"]'),(2213,'inventory.source.items.cleanup','[\"ALASKA MBR\"]'),(2214,'inventory.source.items.cleanup','[\"ALPHA 10\"]'),(2215,'inventory.source.items.cleanup','[\"Andano 340\\/180-IF\"]'),(2216,'inventory.source.items.cleanup','[\"Andano 340\\/180-U\"]'),(2217,'inventory.source.items.cleanup','[\"Andano 500\\/180-U\"]'),(2218,'inventory.source.items.cleanup','[\"Andano XL 6 S-IF\"]'),(2219,'inventory.source.items.cleanup','[\"Andano XL 6 S-IF Compact\"]'),(2220,'inventory.source.items.cleanup','[\"ARX 110 17\"]'),(2221,'inventory.source.items.cleanup','[\"ARX 110 17-D\"]'),(2222,'inventory.source.items.cleanup','[\"ARX 110 33\"]'),(2223,'inventory.source.items.cleanup','[\"ARX 110 35\"]'),(2224,'inventory.source.items.cleanup','[\"ARX 160\"]'),(2225,'inventory.source.items.cleanup','[\"ARX 160-D\"]'),(2226,'inventory.source.items.cleanup','[\"Atlantis Sp H Nof\"]'),(2227,'inventory.source.items.cleanup','[\"Atlas Neo Soap Dispenser\"]'),(2228,'inventory.source.items.cleanup','[\"AXIA III 6 S\"]'),(2229,'inventory.source.items.cleanup','[\"AXIA III XL 6 S\"]'),(2230,'inventory.source.items.cleanup','[\"AXIS III 6 S-IF\"]'),(2231,'inventory.source.items.cleanup','[\"AZG 611 78\"]'),(2232,'inventory.source.items.cleanup','[\"AZG 621\"]'),(2233,'inventory.source.items.cleanup','[\"AZG 651\"]'),(2234,'inventory.source.items.cleanup','[\"AZN 611-100\"]'),(2235,'inventory.source.items.cleanup','[\"AZN 611-86\"]'),(2236,'inventory.source.items.cleanup','[\"AZN 651\"]'),(2237,'inventory.source.items.cleanup','[\"B17CR32N1B\"]'),(2238,'inventory.source.items.cleanup','[\"B27CR22N1B\"]'),(2239,'inventory.source.items.cleanup','[\"B3ACE4HN0B\"]'),(2240,'inventory.source.items.cleanup','[\"B47CR32N0B\"]'),(2241,'inventory.source.items.cleanup','[\"B47FS22N0\"]'),(2242,'inventory.source.items.cleanup','[\"B47VR32N0B\"]'),(2243,'inventory.source.items.cleanup','[\"B48FT78N2\"]'),(2244,'inventory.source.items.cleanup','[\"B57CR22N0B\"]'),(2245,'inventory.source.items.cleanup','[\"B57CS22N0\"]'),(2246,'inventory.source.items.cleanup','[\"B57CS24H0B\"]'),(2247,'inventory.source.items.cleanup','[\"B57VR22N0B\"]'),(2248,'inventory.source.items.cleanup','[\"B57VS22N0\"]'),(2249,'inventory.source.items.cleanup','[\"BAK 710\"]'),(2250,'inventory.source.items.cleanup','[\"BE634LGS1B\"]'),(2251,'inventory.source.items.cleanup','[\"BEL523MS0B\"]'),(2252,'inventory.source.items.cleanup','[\"BEL553MS0B\"]'),(2253,'inventory.source.items.cleanup','[\"BELFAST 90MM\"]'),(2254,'inventory.source.items.cleanup','[\"BEST 450\"]'),(2255,'inventory.source.items.cleanup','[\"BEST 475\"]'),(2256,'inventory.source.items.cleanup','[\"BEST 480\"]'),(2257,'inventory.source.items.cleanup','[\"Beta 20 Bap Kg H Nof\"]'),(2258,'inventory.source.items.cleanup','[\"BF525LMS0B\"]'),(2259,'inventory.source.items.cleanup','[\"BF555LMS0B\"]'),(2260,'inventory.source.items.cleanup','[\"BF634LGS1B\"]'),(2261,'inventory.source.items.cleanup','[\"BFG 611-78\"]'),(2262,'inventory.source.items.cleanup','[\"BFG 611-970\"]'),(2263,'inventory.source.items.cleanup','[\"BFG 651\"]'),(2264,'inventory.source.items.cleanup','[\"BFL523MB0B\"]'),(2265,'inventory.source.items.cleanup','[\"BFL523MS0B\"]'),(2266,'inventory.source.items.cleanup','[\"BFL523MW0B\"]'),(2267,'inventory.source.items.cleanup','[\"BFL553MB0B\"]'),(2268,'inventory.source.items.cleanup','[\"BFL553MS0B\"]'),(2269,'inventory.source.items.cleanup','[\"BFL634GB1B\"]'),(2270,'inventory.source.items.cleanup','[\"BFL634GS1B\"]'),(2271,'inventory.source.items.cleanup','[\"Blanco Lato\"]'),(2272,'inventory.source.items.cleanup','[\"Blanco Livia\"]'),(2273,'inventory.source.items.cleanup','[\"Box Center BWX 120-41-27\"]'),(2274,'inventory.source.items.cleanup','[\"BWX 220 41-27\"]'),(2275,'inventory.source.items.cleanup','[\"BWX 220 54-27\"]'),(2276,'inventory.source.items.cleanup','[\"BXX 110 16\"]'),(2277,'inventory.source.items.cleanup','[\"BXX 110 40\"]'),(2278,'inventory.source.items.cleanup','[\"BXX 110 50\"]'),(2279,'inventory.source.items.cleanup','[\"BXX 110 54\"]'),(2280,'inventory.source.items.cleanup','[\"BXX 110 68\"]'),(2281,'inventory.source.items.cleanup','[\"BXX 160-34-16\"]'),(2282,'inventory.source.items.cleanup','[\"C17GR00N0B\"]'),(2283,'inventory.source.items.cleanup','[\"C17GR01N0B\"]'),(2284,'inventory.source.items.cleanup','[\"C17MR02N0B\"]'),(2285,'inventory.source.items.cleanup','[\"C17MS22N0\"]'),(2286,'inventory.source.items.cleanup','[\"C17UR02N0B\"]'),(2287,'inventory.source.items.cleanup','[\"C17WR00N0B\"]'),(2288,'inventory.source.items.cleanup','[\"C17WR01N0B\"]'),(2289,'inventory.source.items.cleanup','[\"C28MT27H0B\"]'),(2290,'inventory.source.items.cleanup','[\"C28MT27N1\"]'),(2291,'inventory.source.items.cleanup','[\"C803\"]'),(2292,'inventory.source.items.cleanup','[\"C804\"]'),(2293,'inventory.source.items.cleanup','[\"C811\"]'),(2294,'inventory.source.items.cleanup','[\"C815\"]'),(2295,'inventory.source.items.cleanup','[\"CD634GAS0B\"]'),(2296,'inventory.source.items.cleanup','[\"CE732GXB1B\"]'),(2297,'inventory.source.items.cleanup','[\"CENTURIO L 1.5\"]'),(2298,'inventory.source.items.cleanup','[\"CENTURIO L 10\"]'),(2299,'inventory.source.items.cleanup','[\"Centurio L 20\"]'),(2300,'inventory.source.items.cleanup','[\"Centurio L 30\"]'),(2301,'inventory.source.items.cleanup','[\"CFA634GS1B\"]'),(2302,'inventory.source.items.cleanup','[\"Claron 340\\/180-IF\"]'),(2303,'inventory.source.items.cleanup','[\"Claron 340\\/180-U\"]'),(2304,'inventory.source.items.cleanup','[\"Claron 550-U\"]'),(2305,'inventory.source.items.cleanup','[\"Classic 40 S\"]'),(2306,'inventory.source.items.cleanup','[\"CM633GBS1B\"]'),(2307,'inventory.source.items.cleanup','[\"CM656GBS1B\"]'),(2308,'inventory.source.items.cleanup','[\"CMA583MB0B\"]'),(2309,'inventory.source.items.cleanup','[\"CMA583MS0B\"]'),(2310,'inventory.source.items.cleanup','[\"CMG633BB1B\"]'),(2311,'inventory.source.items.cleanup','[\"CMG633BS1B\"]'),(2312,'inventory.source.items.cleanup','[\"CMG778NB1\"]'),(2313,'inventory.source.items.cleanup','[\"COLLECTIS 6 S\"]'),(2314,'inventory.source.items.cleanup','[\"Delta II\"]'),(2315,'inventory.source.items.cleanup','[\"DHZ2701\"]'),(2316,'inventory.source.items.cleanup','[\"DHZ5275\"]'),(2317,'inventory.source.items.cleanup','[\"DHZ5605\"]'),(2318,'inventory.source.items.cleanup','[\"DHZ6551\"]'),(2319,'inventory.source.items.cleanup','[\"DHZ7305\"]'),(2320,'inventory.source.items.cleanup','[\"DIPLOMAT 1.5 ECO\"]'),(2321,'inventory.source.items.cleanup','[\"DIPLOMAT 10 ECO\"]'),(2322,'inventory.source.items.cleanup','[\"Divon II 5 S-IF\"]'),(2323,'inventory.source.items.cleanup','[\"Divon II 6 S-IF\"]'),(2324,'inventory.source.items.cleanup','[\"Divon II 8 S-IF\"]'),(2325,'inventory.source.items.cleanup','[\"Drilled Mirror\"]'),(2326,'inventory.source.items.cleanup','[\"DSZ4920\"]'),(2327,'inventory.source.items.cleanup','[\"EASY150\"]'),(2328,'inventory.source.items.cleanup','[\"EGO 400\"]'),(2329,'inventory.source.items.cleanup','[\"EGO 475\"]'),(2330,'inventory.source.items.cleanup','[\"EGO 480\"]'),(2331,'inventory.source.items.cleanup','[\"ELK 611\"]'),(2332,'inventory.source.items.cleanup','[\"ELK 651\"]'),(2333,'inventory.source.items.cleanup','[\"ELON 45 S\"]'),(2334,'inventory.source.items.cleanup','[\"ELON XL 6 S\"]'),(2335,'inventory.source.items.cleanup','[\"ETAGON 500-U\"]'),(2336,'inventory.source.items.cleanup','[\"Etagon 6\"]'),(2337,'inventory.source.items.cleanup','[\"Etagon 700-U Silgranit\"]'),(2338,'inventory.source.items.cleanup','[\"Etagon 8\"]'),(2339,'inventory.source.items.cleanup','[\"FS04RAKCPB8C\"]'),(2340,'inventory.source.items.cleanup','[\"FS04RAKCPM8C\"]'),(2341,'inventory.source.items.cleanup','[\"FS04RAKWHRE8C\"]'),(2342,'inventory.source.items.cleanup','[\"FSG 111\"]'),(2343,'inventory.source.items.cleanup','[\"FSRAKPPL00\"]'),(2344,'inventory.source.items.cleanup','[\"GAK 611\"]'),(2345,'inventory.source.items.cleanup','[\"GAK 651\"]'),(2346,'inventory.source.items.cleanup','[\"GALICIA\"]'),(2347,'inventory.source.items.cleanup','[\"GAX 611\"]'),(2348,'inventory.source.items.cleanup','[\"GAX 621\"]'),(2349,'inventory.source.items.cleanup','[\"GSD 02 SD\"]'),(2350,'inventory.source.items.cleanup','[\"HARLEM 10\"]'),(2351,'inventory.source.items.cleanup','[\"HARLEM 15\"]'),(2352,'inventory.source.items.cleanup','[\"HB457G0B0\"]'),(2353,'inventory.source.items.cleanup','[\"HB478GCB0S\"]'),(2354,'inventory.source.items.cleanup','[\"HB632GBS1B\"]'),(2355,'inventory.source.items.cleanup','[\"HB672GBS1B\"]'),(2356,'inventory.source.items.cleanup','[\"HB678GBS6B\"]'),(2357,'inventory.source.items.cleanup','[\"HBG634BB1B\"]'),(2358,'inventory.source.items.cleanup','[\"HBG634BS1B\"]'),(2359,'inventory.source.items.cleanup','[\"HBG674BB1B\"]'),(2360,'inventory.source.items.cleanup','[\"HBG674BS1B\"]'),(2361,'inventory.source.items.cleanup','[\"HBG6764B1\"]'),(2362,'inventory.source.items.cleanup','[\"HBS534BB0B\"]'),(2363,'inventory.source.items.cleanup','[\"HBS534BS0B\"]'),(2364,'inventory.source.items.cleanup','[\"HBS534BW0B\"]'),(2365,'inventory.source.items.cleanup','[\"HBS573BB0B\"]'),(2366,'inventory.source.items.cleanup','[\"HBS573BS0B\"]'),(2367,'inventory.source.items.cleanup','[\"HEZ390012\"]'),(2368,'inventory.source.items.cleanup','[\"HEZ390512\"]'),(2369,'inventory.source.items.cleanup','[\"HEZ390522\"]'),(2370,'inventory.source.items.cleanup','[\"HEZ394301\"]'),(2371,'inventory.source.items.cleanup','[\"HEZ631070\"]'),(2372,'inventory.source.items.cleanup','[\"HEZ634000\"]'),(2373,'inventory.source.items.cleanup','[\"HIB 0680\"]'),(2374,'inventory.source.items.cleanup','[\"HIB 0690\"]'),(2375,'inventory.source.items.cleanup','[\"HIB 21100\"]'),(2376,'inventory.source.items.cleanup','[\"HIB 21200\"]'),(2377,'inventory.source.items.cleanup','[\"HIB 21300\"]'),(2378,'inventory.source.items.cleanup','[\"HIB 21400\"]'),(2379,'inventory.source.items.cleanup','[\"HIB 21500\"]'),(2380,'inventory.source.items.cleanup','[\"HIB 44600\"]'),(2381,'inventory.source.items.cleanup','[\"HIB 44700\"]'),(2382,'inventory.source.items.cleanup','[\"HIB 44900\"]'),(2383,'inventory.source.items.cleanup','[\"HIB 45000\"]'),(2384,'inventory.source.items.cleanup','[\"HIB 45100\"]'),(2385,'inventory.source.items.cleanup','[\"HIB 45200\"]'),(2386,'inventory.source.items.cleanup','[\"HIB 45300\"]'),(2387,'inventory.source.items.cleanup','[\"HIB 46000\"]'),(2388,'inventory.source.items.cleanup','[\"HIB 46100\"]'),(2389,'inventory.source.items.cleanup','[\"HIB 46200\"]'),(2390,'inventory.source.items.cleanup','[\"HIB 46300\"]'),(2391,'inventory.source.items.cleanup','[\"HIB 46400\"]'),(2392,'inventory.source.items.cleanup','[\"HIB 46500\"]'),(2393,'inventory.source.items.cleanup','[\"HIB 46600\"]'),(2394,'inventory.source.items.cleanup','[\"HIB 47000\"]'),(2395,'inventory.source.items.cleanup','[\"HIB 47100\"]'),(2396,'inventory.source.items.cleanup','[\"HIB 47200\"]'),(2397,'inventory.source.items.cleanup','[\"HIB 47300\"]'),(2398,'inventory.source.items.cleanup','[\"HIB 47600\"]'),(2399,'inventory.source.items.cleanup','[\"HIB 47700\"]'),(2400,'inventory.source.items.cleanup','[\"HIB 47800\"]'),(2401,'inventory.source.items.cleanup','[\"HIB 47900\"]'),(2402,'inventory.source.items.cleanup','[\"HIB 48000\"]'),(2403,'inventory.source.items.cleanup','[\"HIB 48100\"]'),(2404,'inventory.source.items.cleanup','[\"HIB 48200\"]'),(2405,'inventory.source.items.cleanup','[\"HIB 61504000\"]'),(2406,'inventory.source.items.cleanup','[\"HIB 61701500\"]'),(2407,'inventory.source.items.cleanup','[\"HIB 63504000\"]'),(2408,'inventory.source.items.cleanup','[\"HIB 63604000\"]'),(2409,'inventory.source.items.cleanup','[\"HIB 76029800\"]'),(2410,'inventory.source.items.cleanup','[\"HIB 76030000\"]'),(2411,'inventory.source.items.cleanup','[\"HIB 76060500\"]'),(2412,'inventory.source.items.cleanup','[\"HIB 76700000\"]'),(2413,'inventory.source.items.cleanup','[\"HIB 76800000\"]'),(2414,'inventory.source.items.cleanup','[\"HIB 76900000\"]'),(2415,'inventory.source.items.cleanup','[\"HIB 77305000\"]'),(2416,'inventory.source.items.cleanup','[\"HIB 78100000\"]'),(2417,'inventory.source.items.cleanup','[\"HIB 78300000\"]'),(2418,'inventory.source.items.cleanup','[\"HIB 78400000\"]'),(2419,'inventory.source.items.cleanup','[\"HIB 78500000\"]'),(2420,'inventory.source.items.cleanup','[\"HIB 78600000\"]'),(2421,'inventory.source.items.cleanup','[\"HIB 78700000\"]'),(2422,'inventory.source.items.cleanup','[\"HIB 79100000\"]'),(2423,'inventory.source.items.cleanup','[\"HIB 79200000\"]'),(2424,'inventory.source.items.cleanup','[\"HIB 79300000\"]'),(2425,'inventory.source.items.cleanup','[\"HIB Arena\"]'),(2426,'inventory.source.items.cleanup','[\"HIB Arte Non\"]'),(2427,'inventory.source.items.cleanup','[\"HIB Aura\"]'),(2428,'inventory.source.items.cleanup','[\"HIB Beam\"]'),(2429,'inventory.source.items.cleanup','[\"HIB Bevelled 4mm Mirror\"]'),(2430,'inventory.source.items.cleanup','[\"HIB Boundary\"]'),(2431,'inventory.source.items.cleanup','[\"HIB Connect 50\"]'),(2432,'inventory.source.items.cleanup','[\"HIB Dimension\"]'),(2433,'inventory.source.items.cleanup','[\"HIB Drilled 4mm\"]'),(2434,'inventory.source.items.cleanup','[\"HIB Element\"]'),(2435,'inventory.source.items.cleanup','[\"HIB Frontier\"]'),(2436,'inventory.source.items.cleanup','[\"HIB Globe Plus\"]'),(2437,'inventory.source.items.cleanup','[\"HIB Solas\"]'),(2438,'inventory.source.items.cleanup','[\"HIB Solstice\"]'),(2439,'inventory.source.items.cleanup','[\"HIB Sound\"]'),(2440,'inventory.source.items.cleanup','[\"HIB Theme\"]'),(2441,'inventory.source.items.cleanup','[\"HIB Trim\"]'),(2442,'inventory.source.items.cleanup','[\"HLAGD53N0B\"]'),(2443,'inventory.source.items.cleanup','[\"HLAWD23N0B\"]'),(2444,'inventory.source.items.cleanup','[\"HLAWD53N0B\"]'),(2445,'inventory.source.items.cleanup','[\"HLAWD53W0B\"]'),(2446,'inventory.source.items.cleanup','[\"HN678GES6B\"]'),(2447,'inventory.source.items.cleanup','[\"HZ390011\"]'),(2448,'inventory.source.items.cleanup','[\"HZ390012\"]'),(2449,'inventory.source.items.cleanup','[\"HZ390512\"]'),(2450,'inventory.source.items.cleanup','[\"HZ390522\"]'),(2451,'inventory.source.items.cleanup','[\"HZ394301\"]'),(2452,'inventory.source.items.cleanup','[\"HZ634000\"]'),(2453,'inventory.source.items.cleanup','[\"HZ634080\"]'),(2454,'inventory.source.items.cleanup','[\"HZ636000\"]'),(2455,'inventory.source.items.cleanup','[\"HZ638100\"]'),(2456,'inventory.source.items.cleanup','[\"HZ638170\"]'),(2457,'inventory.source.items.cleanup','[\"HZ638300\"]'),(2458,'inventory.source.items.cleanup','[\"HZ638370\"]'),(2459,'inventory.source.items.cleanup','[\"HZ638D30\"]'),(2460,'inventory.source.items.cleanup','[\"HZ66X600\"]'),(2461,'inventory.source.items.cleanup','[\"J1ACE2HN0B\"]'),(2462,'inventory.source.items.cleanup','[\"J1ACE4HN0B\"]'),(2463,'inventory.source.items.cleanup','[\"JOYMC04001\"]'),(2464,'inventory.source.items.cleanup','[\"JOYMC06002\"]'),(2465,'inventory.source.items.cleanup','[\"JOYMC08002\"]'),(2466,'inventory.source.items.cleanup','[\"JOYMC10003\"]'),(2467,'inventory.source.items.cleanup','[\"JOYMR04068LED\"]'),(2468,'inventory.source.items.cleanup','[\"JOYMR04068STD\"]'),(2469,'inventory.source.items.cleanup','[\"JOYMR06068LED\"]'),(2470,'inventory.source.items.cleanup','[\"JOYMR06068STD\"]'),(2471,'inventory.source.items.cleanup','[\"JOYMR08068LED\"]'),(2472,'inventory.source.items.cleanup','[\"JOYMR08068STD\"]'),(2473,'inventory.source.items.cleanup','[\"JOYMR10068LED\"]'),(2474,'inventory.source.items.cleanup','[\"JOYMR10068STD\"]'),(2475,'inventory.source.items.cleanup','[\"JOYMR12068LED\"]'),(2476,'inventory.source.items.cleanup','[\"JOYMR12068STD\"]'),(2477,'inventory.source.items.cleanup','[\"JOYTB6000CR\"]'),(2478,'inventory.source.items.cleanup','[\"JOYUSBRCCR\"]'),(2479,'inventory.source.items.cleanup','[\"Jumbo\"]'),(2480,'inventory.source.items.cleanup','[\"KANSAS 40X40 L\"]'),(2481,'inventory.source.items.cleanup','[\"KANSAS 50X40 L\"]'),(2482,'inventory.source.items.cleanup','[\"KBK 110 40\"]'),(2483,'inventory.source.items.cleanup','[\"KBK 110 50\"]'),(2484,'inventory.source.items.cleanup','[\"KBK 160\"]'),(2485,'inventory.source.items.cleanup','[\"KIT0148450A\"]'),(2486,'inventory.source.items.cleanup','[\"KNG 110 37\"]'),(2487,'inventory.source.items.cleanup','[\"KNG 110 52\"]'),(2488,'inventory.source.items.cleanup','[\"KNG 110 62\"]'),(2489,'inventory.source.items.cleanup','[\"KNG 120\"]'),(2490,'inventory.source.items.cleanup','[\"L18 3016 OKG\"]'),(2491,'inventory.source.items.cleanup','[\"L18 3440 OKG\"]'),(2492,'inventory.source.items.cleanup','[\"L18 390 OKG\"]'),(2493,'inventory.source.items.cleanup','[\"LAX 110 45\"]'),(2494,'inventory.source.items.cleanup','[\"LAX 110 50\"]'),(2495,'inventory.source.items.cleanup','[\"LAX 110 50-41\"]'),(2496,'inventory.source.items.cleanup','[\"LAX 120 36-36\"]'),(2497,'inventory.source.items.cleanup','[\"LAX 120 45-30\"]'),(2498,'inventory.source.items.cleanup','[\"LAX 160 36-16\"]'),(2499,'inventory.source.items.cleanup','[\"Led Panel Light\"]'),(2500,'inventory.source.items.cleanup','[\"LEGRA 45 S\"]'),(2501,'inventory.source.items.cleanup','[\"LEGRA 6\"]'),(2502,'inventory.source.items.cleanup','[\"LEGRA 6 S\"]'),(2503,'inventory.source.items.cleanup','[\"LEGRA XL 6 S\"]'),(2504,'inventory.source.items.cleanup','[\"LQ093\"]'),(2505,'inventory.source.items.cleanup','[\"LQ094\"]'),(2506,'inventory.source.items.cleanup','[\"LQ50\"]'),(2507,'inventory.source.items.cleanup','[\"MATARO2\"]'),(2508,'inventory.source.items.cleanup','[\"MB535A0S0B\"]'),(2509,'inventory.source.items.cleanup','[\"MB557G5S0B\"]'),(2510,'inventory.source.items.cleanup','[\"MBA5350S0B\"]'),(2511,'inventory.source.items.cleanup','[\"MBA5575S0B\"]'),(2512,'inventory.source.items.cleanup','[\"MBS533BB0B\"]'),(2513,'inventory.source.items.cleanup','[\"MBS533BS0B\"]'),(2514,'inventory.source.items.cleanup','[\"MBS533BW0B\"]'),(2515,'inventory.source.items.cleanup','[\"Metra 45 S\"]'),(2516,'inventory.source.items.cleanup','[\"Metra 5 S\"]'),(2517,'inventory.source.items.cleanup','[\"Metra 6\"]'),(2518,'inventory.source.items.cleanup','[\"Metra 6 S\"]'),(2519,'inventory.source.items.cleanup','[\"Metra 8 S\"]'),(2520,'inventory.source.items.cleanup','[\"Metra 9 E\"]'),(2521,'inventory.source.items.cleanup','[\"Metra XL 6 S\"]'),(2522,'inventory.source.items.cleanup','[\"MIAMI 40X40\"]'),(2523,'inventory.source.items.cleanup','[\"MIAMI 50X40\"]'),(2524,'inventory.source.items.cleanup','[\"Minister Reversible\"]'),(2525,'inventory.source.items.cleanup','[\"MQX 110 50\"]'),(2526,'inventory.source.items.cleanup','[\"MQX 110 82\"]'),(2527,'inventory.source.items.cleanup','[\"MRG 110-37\"]'),(2528,'inventory.source.items.cleanup','[\"MRG 110-52\"]'),(2529,'inventory.source.items.cleanup','[\"MRG 110-72\"]'),(2530,'inventory.source.items.cleanup','[\"MRG 160-34-15\"]'),(2531,'inventory.source.items.cleanup','[\"MRX 210-19\"]'),(2532,'inventory.source.items.cleanup','[\"MRX 210-34\"]'),(2533,'inventory.source.items.cleanup','[\"MRX 210-45\"]'),(2534,'inventory.source.items.cleanup','[\"MRX 210-70\"]'),(2535,'inventory.source.items.cleanup','[\"MRX 211\"]'),(2536,'inventory.source.items.cleanup','[\"MRX 220 34-34\"]'),(2537,'inventory.source.items.cleanup','[\"MRX 251\"]'),(2538,'inventory.source.items.cleanup','[\"MRX 260 34-19\"]'),(2539,'inventory.source.items.cleanup','[\"MULTA 102\"]'),(2540,'inventory.source.items.cleanup','[\"MULTA 105\"]'),(2541,'inventory.source.items.cleanup','[\"MULTA 130\"]'),(2542,'inventory.source.items.cleanup','[\"Mythos MYX 160 34-16\"]'),(2543,'inventory.source.items.cleanup','[\"Mythos MYX 160 50-16\"]'),(2544,'inventory.source.items.cleanup','[\"Mythos MYX 210-34\"]'),(2545,'inventory.source.items.cleanup','[\"Mythos MYX 210-45\"]'),(2546,'inventory.source.items.cleanup','[\"Mythos MYX 210-55\"]'),(2547,'inventory.source.items.cleanup','[\"Mythos MYX 210-70\"]'),(2548,'inventory.source.items.cleanup','[\"MYX 210 TPL\"]'),(2549,'inventory.source.items.cleanup','[\"MYX 211\"]'),(2550,'inventory.source.items.cleanup','[\"MYX 251\"]'),(2551,'inventory.source.items.cleanup','[\"NAYA 6\"]'),(2552,'inventory.source.items.cleanup','[\"NAYA XL 9\"]'),(2553,'inventory.source.items.cleanup','[\"NB535ABS0B\"]'),(2554,'inventory.source.items.cleanup','[\"NBS533BB0B\"]'),(2555,'inventory.source.items.cleanup','[\"NBS533BS0B\"]'),(2556,'inventory.source.items.cleanup','[\"NEW YORK 18X40 L\"]'),(2557,'inventory.source.items.cleanup','[\"NEW YORK 18X40+34X40\"]'),(2558,'inventory.source.items.cleanup','[\"NEW YORK 34X40 L\"]'),(2559,'inventory.source.items.cleanup','[\"NEW YORK 34X40+18X40\"]'),(2560,'inventory.source.items.cleanup','[\"NEW YORK 40X40 L\"]'),(2561,'inventory.source.items.cleanup','[\"NEW YORK 50X40 L\"]'),(2562,'inventory.source.items.cleanup','[\"NEW YORK 50X40+18X40\"]'),(2563,'inventory.source.items.cleanup','[\"NEX 211\"]'),(2564,'inventory.source.items.cleanup','[\"NEX 251\"]'),(2565,'inventory.source.items.cleanup','[\"NVC118\"]'),(2566,'inventory.source.items.cleanup','[\"NVM113\"]'),(2567,'inventory.source.items.cleanup','[\"OC162AWHA\"]'),(2568,'inventory.source.items.cleanup','[\"OC163AWHA\"]'),(2569,'inventory.source.items.cleanup','[\"OC164AWHA\"]'),(2570,'inventory.source.items.cleanup','[\"OC165AWHA\"]'),(2571,'inventory.source.items.cleanup','[\"OHIO 18X40 L\"]'),(2572,'inventory.source.items.cleanup','[\"OHIO 18X40+50X40 L\"]'),(2573,'inventory.source.items.cleanup','[\"OHIO 40X40 L\"]'),(2574,'inventory.source.items.cleanup','[\"OHIO 40X40 TW\"]'),(2575,'inventory.source.items.cleanup','[\"OHIO 50X40 L\"]'),(2576,'inventory.source.items.cleanup','[\"OHIO 50X40 TW\"]'),(2577,'inventory.source.items.cleanup','[\"OHIO 50X40+18X40 L\"]'),(2578,'inventory.source.items.cleanup','[\"OHIO 80X42 L\"]'),(2579,'inventory.source.items.cleanup','[\"OID 611-94\"]'),(2580,'inventory.source.items.cleanup','[\"OID 651\"]'),(2581,'inventory.source.items.cleanup','[\"PANAMA\"]'),(2582,'inventory.source.items.cleanup','[\"QUADRA 100\"]'),(2583,'inventory.source.items.cleanup','[\"QUADRA 105\"]'),(2584,'inventory.source.items.cleanup','[\"QUADRA 130\"]'),(2585,'inventory.source.items.cleanup','[\"QUADRA 50\"]'),(2586,'inventory.source.items.cleanup','[\"R18 2330\"]'),(2587,'inventory.source.items.cleanup','[\"RAK5146RK46\"]'),(2588,'inventory.source.items.cleanup','[\"RAK5146RK57\"]'),(2589,'inventory.source.items.cleanup','[\"RBX 610\"]'),(2590,'inventory.source.items.cleanup','[\"RD100 A\\/S\"]'),(2591,'inventory.source.items.cleanup','[\"RD50\"]'),(2592,'inventory.source.items.cleanup','[\"RD60\"]'),(2593,'inventory.source.items.cleanup','[\"REGENT 10 LUXA\"]'),(2594,'inventory.source.items.cleanup','[\"REGIDRAIN R\"]'),(2595,'inventory.source.items.cleanup','[\"RIO\"]'),(2596,'inventory.source.items.cleanup','[\"RIO SP H NOF\"]'),(2597,'inventory.source.items.cleanup','[\"RL 301 CW\"]'),(2598,'inventory.source.items.cleanup','[\"RL 304 CW\"]'),(2599,'inventory.source.items.cleanup','[\"RL 401 CB\"]'),(2600,'inventory.source.items.cleanup','[\"RL 501 CW\"]'),(2601,'inventory.source.items.cleanup','[\"RL 504 CW\"]'),(2602,'inventory.source.items.cleanup','[\"Rondo\"]'),(2603,'inventory.source.items.cleanup','[\"SKX 611-86\"]'),(2604,'inventory.source.items.cleanup','[\"SKX 651\"]'),(2605,'inventory.source.items.cleanup','[\"SOLIS 340\\/180-U\"]'),(2606,'inventory.source.items.cleanup','[\"Sona 5 S\"]'),(2607,'inventory.source.items.cleanup','[\"Sona 6 S\"]'),(2608,'inventory.source.items.cleanup','[\"Sona XL 6 S\"]'),(2609,'inventory.source.items.cleanup','[\"Sphere 60 Illuminated Mirror\"]'),(2610,'inventory.source.items.cleanup','[\"SUBLINE 160-U\"]'),(2611,'inventory.source.items.cleanup','[\"Subline 320-U\"]'),(2612,'inventory.source.items.cleanup','[\"Subline 340\\/160-U\"]'),(2613,'inventory.source.items.cleanup','[\"Subline 350\\/350-U\"]'),(2614,'inventory.source.items.cleanup','[\"Subline 400-U\"]'),(2615,'inventory.source.items.cleanup','[\"SUBLINE 430\\/270-U\"]'),(2616,'inventory.source.items.cleanup','[\"Subline 480\\/320-U\"]'),(2617,'inventory.source.items.cleanup','[\"Subline 500-IF\"]'),(2618,'inventory.source.items.cleanup','[\"Subline 500-IF\\/A\"]'),(2619,'inventory.source.items.cleanup','[\"Subline 500-U\"]'),(2620,'inventory.source.items.cleanup','[\"Subline 700-U\"]'),(2621,'inventory.source.items.cleanup','[\"Subline 700-U PuraDur\"]'),(2622,'inventory.source.items.cleanup','[\"Subline 800-U\"]'),(2623,'inventory.source.items.cleanup','[\"TEXAS 18X40 L\"]'),(2624,'inventory.source.items.cleanup','[\"TEXAS 30X40 L\"]'),(2625,'inventory.source.items.cleanup','[\"TEXAS 40X40 L\"]'),(2626,'inventory.source.items.cleanup','[\"TEXAS 50X40 L\"]'),(2627,'inventory.source.items.cleanup','[\"U1ACE2HN0B\"]'),(2628,'inventory.source.items.cleanup','[\"U1ACE2HW0B\"]'),(2629,'inventory.source.items.cleanup','[\"U1ACE5HN0B\"]'),(2630,'inventory.source.items.cleanup','[\"U1ACI5HN0B\"]'),(2631,'inventory.source.items.cleanup','[\"U2ACM7HN0B\"]'),(2632,'inventory.source.items.cleanup','[\"VBK 110 21\"]'),(2633,'inventory.source.items.cleanup','[\"VBK 110 33\"]'),(2634,'inventory.source.items.cleanup','[\"VBK 110 50\"]'),(2635,'inventory.source.items.cleanup','[\"VBK 160\"]'),(2636,'inventory.source.items.cleanup','[\"VBK 710\"]'),(2637,'inventory.source.items.cleanup','[\"VBK 720\"]'),(2638,'inventory.source.items.cleanup','[\"VINTERA XL 9\"]'),(2639,'inventory.source.items.cleanup','[\"Z11CR10X0\"]'),(2640,'inventory.source.items.cleanup','[\"Z11SZ00X0\"]'),(2641,'inventory.source.items.cleanup','[\"Z11SZ60X0\"]'),(2642,'inventory.source.items.cleanup','[\"Z11SZ80X0\"]'),(2643,'inventory.source.items.cleanup','[\"Z11SZ90X0\"]'),(2644,'inventory.source.items.cleanup','[\"Z11TC10X0\"]'),(2645,'inventory.source.items.cleanup','[\"Z11TC16X0\"]'),(2646,'inventory.source.items.cleanup','[\"Z11TF36X0\"]'),(2647,'inventory.source.items.cleanup','[\"Z11TI15X0\"]'),(2648,'inventory.source.items.cleanup','[\"Z12CM10A0\"]'),(2649,'inventory.source.items.cleanup','[\"Z13CV06S0\"]'),(2650,'inventory.source.items.cleanup','[\"Z13TC10X0\"]'),(2651,'inventory.source.items.cleanup','[\"Z2471X0\"]'),(2652,'inventory.source.items.cleanup','[\"Z2472X0\"]'),(2653,'inventory.source.items.cleanup','[\"Z5135X3\"]'),(2654,'inventory.source.items.cleanup','[\"Z5138X5\"]'),(2655,'inventory.source.items.cleanup','[\"Z54TL60X0\"]'),(2656,'inventory.source.items.cleanup','[\"Z5865N0\"]'),(2657,'inventory.source.items.cleanup','[\"Z5875N0\"]'),(2658,'inventory.source.items.cleanup','[\"Z5895N0\"]'),(2659,'inventory.source.items.cleanup','[\"Z92WWY9X2\"]'),(2660,'inventory.source.items.cleanup','[\"Z9410X1\"]'),(2661,'inventory.source.items.cleanup','[\"Z9415X1\"]'),(2662,'inventory.source.items.cleanup','[\"Z9416X2\"]'),(2663,'inventory.source.items.cleanup','[\"Z9417X2\"]'),(2664,'inventory.source.items.cleanup','[\"Z9914X0\"]'),(2665,'inventory.source.items.cleanup','[\"Zerox 340\\/180-U\"]'),(2666,'inventory.source.items.cleanup','[\"Zia 45 S\"]'),(2667,'inventory.source.items.cleanup','[\"Zia 5 S\"]'),(2668,'inventory.source.items.cleanup','[\"Zia 6 S\"]'),(2669,'inventory.source.items.cleanup','[\"ZIA 9 E\"]'),(2670,'inventory.source.items.cleanup','[\"ZIA XL 6 S\"]'),(2671,'inventory.source.items.cleanup','[\"ZIA XL 6 S Compact\"]'),(2672,'inventory.source.items.cleanup','[\"2\\/C154\"]'),(2673,'inventory.source.items.cleanup','[\"2\\/C156\"]'),(2674,'inventory.source.items.cleanup','[\"2\\/C158\"]'),(2675,'inventory.source.items.cleanup','[\"2\\/C184\"]'),(2676,'inventory.source.items.cleanup','[\"2\\/C186\"]'),(2677,'inventory.source.items.cleanup','[\"2\\/C188\"]'),(2678,'inventory.source.items.cleanup','[\"2\\/C513\"]'),(2679,'inventory.source.items.cleanup','[\"2\\/C517\"]'),(2680,'inventory.source.items.cleanup','[\"2\\/C522\"]'),(2681,'inventory.source.items.cleanup','[\"2\\/C526\"]'),(2682,'inventory.source.items.cleanup','[\"2\\/C613\"]'),(2683,'inventory.source.items.cleanup','[\"2\\/C617\"]'),(2684,'inventory.source.items.cleanup','[\"2\\/C622\"]'),(2685,'inventory.source.items.cleanup','[\"2\\/C626\"]'),(2686,'inventory.source.items.cleanup','[\"3\\/C154\"]'),(2687,'inventory.source.items.cleanup','[\"3\\/C156\"]'),(2688,'inventory.source.items.cleanup','[\"3\\/C158\"]'),(2689,'inventory.source.items.cleanup','[\"3\\/C184\"]'),(2690,'inventory.source.items.cleanup','[\"3\\/C186\"]'),(2691,'inventory.source.items.cleanup','[\"3\\/C188\"]'),(2692,'inventory.source.items.cleanup','[\"3\\/C322\"]'),(2693,'inventory.source.items.cleanup','[\"3\\/C326\"]'),(2694,'inventory.source.items.cleanup','[\"3\\/C330\"]'),(2695,'inventory.source.items.cleanup','[\"3\\/C513\"]'),(2696,'inventory.source.items.cleanup','[\"3\\/C517\"]'),(2697,'inventory.source.items.cleanup','[\"3\\/C522\"]'),(2698,'inventory.source.items.cleanup','[\"3\\/C526\"]'),(2699,'inventory.source.items.cleanup','[\"3\\/C530\"]'),(2700,'inventory.source.items.cleanup','[\"3\\/C613\"]'),(2701,'inventory.source.items.cleanup','[\"3\\/C617\"]'),(2702,'inventory.source.items.cleanup','[\"3\\/C622\"]'),(2703,'inventory.source.items.cleanup','[\"3\\/C626\"]'),(2704,'inventory.source.items.cleanup','[\"3\\/C630\"]'),(2705,'inventory.source.items.cleanup','[\"3050-30\"]'),(2706,'inventory.source.items.cleanup','[\"3060-14\"]'),(2707,'inventory.source.items.cleanup','[\"3060-30\"]'),(2708,'inventory.source.items.cleanup','[\"4\\/C322\"]'),(2709,'inventory.source.items.cleanup','[\"4\\/C326\"]'),(2710,'inventory.source.items.cleanup','[\"4\\/C330\"]'),(2711,'inventory.source.items.cleanup','[\"4\\/C513\"]'),(2712,'inventory.source.items.cleanup','[\"4\\/C517\"]'),(2713,'inventory.source.items.cleanup','[\"4\\/C522\"]'),(2714,'inventory.source.items.cleanup','[\"4\\/C526\"]'),(2715,'inventory.source.items.cleanup','[\"4\\/C530\"]'),(2716,'inventory.source.items.cleanup','[\"4\\/C613\"]'),(2717,'inventory.source.items.cleanup','[\"4\\/C617\"]'),(2718,'inventory.source.items.cleanup','[\"4\\/C622\"]'),(2719,'inventory.source.items.cleanup','[\"4\\/C626\"]'),(2720,'inventory.source.items.cleanup','[\"4\\/C630\"]'),(2721,'inventory.source.items.cleanup','[\"A-BLV180030D\"]'),(2722,'inventory.source.items.cleanup','[\"A-BLV180030S\"]'),(2723,'inventory.source.items.cleanup','[\"A-BLV180041D\"]'),(2724,'inventory.source.items.cleanup','[\"A-BLV180041S\"]'),(2725,'inventory.source.items.cleanup','[\"A-BLV180051D\"]'),(2726,'inventory.source.items.cleanup','[\"A-BLV180051S\"]'),(2727,'inventory.source.items.cleanup','[\"A-BTN115WP\"]'),(2728,'inventory.source.items.cleanup','[\"A-VCR060040D\"]'),(2729,'inventory.source.items.cleanup','[\"A-VCR060040S\"]'),(2730,'inventory.source.items.cleanup','[\"A-VCR060060D\"]'),(2731,'inventory.source.items.cleanup','[\"A-VCR060060S\"]'),(2732,'inventory.source.items.cleanup','[\"A-VCR060080D\"]'),(2733,'inventory.source.items.cleanup','[\"A-VCR060080S\"]'),(2734,'inventory.source.items.cleanup','[\"A-VCR060100D\"]'),(2735,'inventory.source.items.cleanup','[\"A-VCR060100S\"]'),(2736,'inventory.source.items.cleanup','[\"A-VCR060120D\"]'),(2737,'inventory.source.items.cleanup','[\"A-VCR060120S\"]'),(2738,'inventory.source.items.cleanup','[\"A-VCR060140D\"]'),(2739,'inventory.source.items.cleanup','[\"A-VCR060140S\"]'),(2740,'inventory.source.items.cleanup','[\"A-VCR180030D\"]'),(2741,'inventory.source.items.cleanup','[\"A-VCR180030S\"]'),(2742,'inventory.source.items.cleanup','[\"A-VCR180040D\"]'),(2743,'inventory.source.items.cleanup','[\"A-VCR180040S\"]'),(2744,'inventory.source.items.cleanup','[\"A-VCR180050D\"]'),(2745,'inventory.source.items.cleanup','[\"A-VCR180050S\"]'),(2746,'inventory.source.items.cleanup','[\"A-VRL0755\"]'),(2747,'inventory.source.items.cleanup','[\"A-VRL1195\"]'),(2748,'inventory.source.items.cleanup','[\"A-VRL1555\"]'),(2749,'inventory.source.items.cleanup','[\"ACC005\"]'),(2750,'inventory.source.items.cleanup','[\"ACCS\\/TP\"]'),(2751,'inventory.source.items.cleanup','[\"ADA1150200021STP\"]'),(2752,'inventory.source.items.cleanup','[\"ADO0500100012STP\"]'),(2753,'inventory.source.items.cleanup','[\"Adora Vertical\"]'),(2754,'inventory.source.items.cleanup','[\"Aeon Abacus\"]'),(2755,'inventory.source.items.cleanup','[\"Aeon Acheron\"]'),(2756,'inventory.source.items.cleanup','[\"Aeon Alien\"]'),(2757,'inventory.source.items.cleanup','[\"Aeon Armada\"]'),(2758,'inventory.source.items.cleanup','[\"Aeon Atilla\"]'),(2759,'inventory.source.items.cleanup','[\"Aeon Bamboo\"]'),(2760,'inventory.source.items.cleanup','[\"Aeon Bamboo Corner\"]'),(2761,'inventory.source.items.cleanup','[\"Aeon Bolero\"]'),(2762,'inventory.source.items.cleanup','[\"Aeon Bosporus\"]'),(2763,'inventory.source.items.cleanup','[\"Aeon Cat Ladder\"]'),(2764,'inventory.source.items.cleanup','[\"Aeon Cengiz\"]'),(2765,'inventory.source.items.cleanup','[\"Aeon Clipper\"]'),(2766,'inventory.source.items.cleanup','[\"Aeon Coffer\"]'),(2767,'inventory.source.items.cleanup','[\"Aeon Combe\"]'),(2768,'inventory.source.items.cleanup','[\"Aeon Dalya E\"]'),(2769,'inventory.source.items.cleanup','[\"Aeon Dalya L\"]'),(2770,'inventory.source.items.cleanup','[\"Aeon Elixir\"]'),(2771,'inventory.source.items.cleanup','[\"Aeon Ellips\"]'),(2772,'inventory.source.items.cleanup','[\"Aeon Fatih\"]'),(2773,'inventory.source.items.cleanup','[\"Aeon Gallipoli\"]'),(2774,'inventory.source.items.cleanup','[\"Aeon Grandeur\"]'),(2775,'inventory.source.items.cleanup','[\"Aeon Helio\"]'),(2776,'inventory.source.items.cleanup','[\"Aeon Honeycomb\"]'),(2777,'inventory.source.items.cleanup','[\"Aeon Imza\"]'),(2778,'inventory.source.items.cleanup','[\"Aeon Kaptan\"]'),(2779,'inventory.source.items.cleanup','[\"Aeon Kare E\"]'),(2780,'inventory.source.items.cleanup','[\"Aeon Karnak\"]'),(2781,'inventory.source.items.cleanup','[\"Aeon Linx\"]'),(2782,'inventory.source.items.cleanup','[\"Aeon Lokum\"]'),(2783,'inventory.source.items.cleanup','[\"Aeon Marbella\"]'),(2784,'inventory.source.items.cleanup','[\"Aeon Maze\"]'),(2785,'inventory.source.items.cleanup','[\"Aeon Meridien\"]'),(2786,'inventory.source.items.cleanup','[\"Aeon Mystic L\"]'),(2787,'inventory.source.items.cleanup','[\"Aeon Panacea\"]'),(2788,'inventory.source.items.cleanup','[\"Aeon Pegasus\"]'),(2789,'inventory.source.items.cleanup','[\"Aeon Rende\"]'),(2790,'inventory.source.items.cleanup','[\"Aeon S-Type\"]'),(2791,'inventory.source.items.cleanup','[\"Aeon Serhad\"]'),(2792,'inventory.source.items.cleanup','[\"Aeon Serif\"]'),(2793,'inventory.source.items.cleanup','[\"Aeon Siesta\"]'),(2794,'inventory.source.items.cleanup','[\"Aeon Skuall\"]'),(2795,'inventory.source.items.cleanup','[\"Aeon Sofi\"]'),(2796,'inventory.source.items.cleanup','[\"Aeon Speira\"]'),(2797,'inventory.source.items.cleanup','[\"Aeon Stanza\"]'),(2798,'inventory.source.items.cleanup','[\"Aeon Sumela\"]'),(2799,'inventory.source.items.cleanup','[\"Aeon Tempest\"]'),(2800,'inventory.source.items.cleanup','[\"Aeon Tora\"]'),(2801,'inventory.source.items.cleanup','[\"Aeon Trogon\"]'),(2802,'inventory.source.items.cleanup','[\"Aeon Truva\"]'),(2803,'inventory.source.items.cleanup','[\"Aeon Tubo\"]'),(2804,'inventory.source.items.cleanup','[\"Aeon Tudor\"]'),(2805,'inventory.source.items.cleanup','[\"Aeon Wave Horizontal\"]'),(2806,'inventory.source.items.cleanup','[\"Aeon Wave Vertical\"]'),(2807,'inventory.source.items.cleanup','[\"Aeon Windsor\"]'),(2808,'inventory.source.items.cleanup','[\"Aeon Zenith\"]'),(2809,'inventory.source.items.cleanup','[\"Aeon Zig Zag\"]'),(2810,'inventory.source.items.cleanup','[\"AJA0600045001\"]'),(2811,'inventory.source.items.cleanup','[\"AJA0600045002\"]'),(2812,'inventory.source.items.cleanup','[\"ALD0500080006CHR\"]'),(2813,'inventory.source.items.cleanup','[\"ALD0500120009CHR\"]'),(2814,'inventory.source.items.cleanup','[\"ALD0500160012CHR\"]'),(2815,'inventory.source.items.cleanup','[\"Aldo Vertical Steel\"]'),(2816,'inventory.source.items.cleanup','[\"ALE-050-036\\/F\"]'),(2817,'inventory.source.items.cleanup','[\"ALE-075-046\\/F\"]'),(2818,'inventory.source.items.cleanup','[\"ALE-100-056\\/F\"]'),(2819,'inventory.source.items.cleanup','[\"ALE-125-076\\/F\"]'),(2820,'inventory.source.items.cleanup','[\"ALE-150-086\\/F\"]'),(2821,'inventory.source.items.cleanup','[\"ALE-200-116\\/F\"]'),(2822,'inventory.source.items.cleanup','[\"ALI0500100015STP\"]'),(2823,'inventory.source.items.cleanup','[\"Alura\"]'),(2824,'inventory.source.items.cleanup','[\"ARE0500090004MRP\"]'),(2825,'inventory.source.items.cleanup','[\"ARE0500090004STP\"]'),(2826,'inventory.source.items.cleanup','[\"ARE0500120006MRP\"]'),(2827,'inventory.source.items.cleanup','[\"ARE0500120006STP\"]'),(2828,'inventory.source.items.cleanup','[\"ARE0500150008MRP\"]'),(2829,'inventory.source.items.cleanup','[\"ARE0500150008STP\"]'),(2830,'inventory.source.items.cleanup','[\"ARL0500100008STP\"]'),(2831,'inventory.source.items.cleanup','[\"Artena Double Panel\"]'),(2832,'inventory.source.items.cleanup','[\"Ax Spa\"]'),(2833,'inventory.source.items.cleanup','[\"BAR0500050001MRP\"]'),(2834,'inventory.source.items.cleanup','[\"BAR0500050001STP\"]'),(2835,'inventory.source.items.cleanup','[\"BAR0500100002MRP\"]'),(2836,'inventory.source.items.cleanup','[\"BAR0500100002STP\"]'),(2837,'inventory.source.items.cleanup','[\"BAR0500150003MRP\"]'),(2838,'inventory.source.items.cleanup','[\"BAR0500150003STP\"]'),(2839,'inventory.source.items.cleanup','[\"BCK0450092004MRP\"]'),(2840,'inventory.source.items.cleanup','[\"BCK0450092004STP\"]'),(2841,'inventory.source.items.cleanup','[\"BCK0450140006MRP\"]'),(2842,'inventory.source.items.cleanup','[\"BCK0450140006STP\"]'),(2843,'inventory.source.items.cleanup','[\"Blitz Super\"]'),(2844,'inventory.source.items.cleanup','[\"Bonera Horizontal\"]'),(2845,'inventory.source.items.cleanup','[\"Bonera Vertical Steel\"]'),(2846,'inventory.source.items.cleanup','[\"Camden Traditional\"]'),(2847,'inventory.source.items.cleanup','[\"CAP905\"]'),(2848,'inventory.source.items.cleanup','[\"Capelli Vertical\"]'),(2849,'inventory.source.items.cleanup','[\"Carisa Aren\"]'),(2850,'inventory.source.items.cleanup','[\"Carisa Baro\"]'),(2851,'inventory.source.items.cleanup','[\"Carisa Beck\"]'),(2852,'inventory.source.items.cleanup','[\"Carisa Castor\"]'),(2853,'inventory.source.items.cleanup','[\"Carisa Clash\"]'),(2854,'inventory.source.items.cleanup','[\"Carisa Domino\"]'),(2855,'inventory.source.items.cleanup','[\"Carisa Dora\"]'),(2856,'inventory.source.items.cleanup','[\"Carisa Halo\"]'),(2857,'inventory.source.items.cleanup','[\"Carisa Keops\"]'),(2858,'inventory.source.items.cleanup','[\"Carisa Link\"]'),(2859,'inventory.source.items.cleanup','[\"Carisa Motion\"]'),(2860,'inventory.source.items.cleanup','[\"Carisa Nile\"]'),(2861,'inventory.source.items.cleanup','[\"Carisa Pan\"]'),(2862,'inventory.source.items.cleanup','[\"Carisa Paros\"]'),(2863,'inventory.source.items.cleanup','[\"Carisa Piano\"]'),(2864,'inventory.source.items.cleanup','[\"Carisa Quadro V\"]'),(2865,'inventory.source.items.cleanup','[\"Carisa Ruma\"]'),(2866,'inventory.source.items.cleanup','[\"Carisa Sophia Mirror\"]'),(2867,'inventory.source.items.cleanup','[\"Carisa Sophia Xl\"]'),(2868,'inventory.source.items.cleanup','[\"Carisa Step Mirror\"]'),(2869,'inventory.source.items.cleanup','[\"Carisa Tallis Xl\"]'),(2870,'inventory.source.items.cleanup','[\"Carisa Versailles\"]'),(2871,'inventory.source.items.cleanup','[\"Carpi Towel Rail\"]'),(2872,'inventory.source.items.cleanup','[\"CAS0560085002MRP\"]'),(2873,'inventory.source.items.cleanup','[\"CAS0560085002STP\"]'),(2874,'inventory.source.items.cleanup','[\"CAS0560130003MRP\"]'),(2875,'inventory.source.items.cleanup','[\"CAS0560130003STP\"]'),(2876,'inventory.source.items.cleanup','[\"CAS0560175004MRP\"]'),(2877,'inventory.source.items.cleanup','[\"CAS0560175004STP\"]'),(2878,'inventory.source.items.cleanup','[\"Cavo Vertical\"]'),(2879,'inventory.source.items.cleanup','[\"Celico Vertical\"]'),(2880,'inventory.source.items.cleanup','[\"Claro Vertical Steel\"]'),(2881,'inventory.source.items.cleanup','[\"CLS0450092004MRP\"]'),(2882,'inventory.source.items.cleanup','[\"CLS0450092004STP\"]'),(2883,'inventory.source.items.cleanup','[\"Colona 2 Column Horizontal\"]'),(2884,'inventory.source.items.cleanup','[\"Colona 2 Column Vertical\"]'),(2885,'inventory.source.items.cleanup','[\"Colona 3 Column Horizontal\"]'),(2886,'inventory.source.items.cleanup','[\"Colona 3 Column Vertical\"]'),(2887,'inventory.source.items.cleanup','[\"Colona 4 Column Horizontal\"]'),(2888,'inventory.source.items.cleanup','[\"Coneva Horizontal\"]'),(2889,'inventory.source.items.cleanup','[\"Coneva Vertical\"]'),(2890,'inventory.source.items.cleanup','[\"DE-ARG0805\"]'),(2891,'inventory.source.items.cleanup','[\"DE-ARG1205\"]'),(2892,'inventory.source.items.cleanup','[\"DE-ORN7555P\"]'),(2893,'inventory.source.items.cleanup','[\"Deno Vertical\"]'),(2894,'inventory.source.items.cleanup','[\"DOM0800128006MRP\"]'),(2895,'inventory.source.items.cleanup','[\"DOM0800128006STP\"]'),(2896,'inventory.source.items.cleanup','[\"DOR0290180003MATC\"]'),(2897,'inventory.source.items.cleanup','[\"DOR0290180003TXLG\"]'),(2898,'inventory.source.items.cleanup','[\"DOR0390180004MATC\"]'),(2899,'inventory.source.items.cleanup','[\"DOR0390180004TXLG\"]'),(2900,'inventory.source.items.cleanup','[\"DOR0490180005MATC\"]'),(2901,'inventory.source.items.cleanup','[\"DOR0490180005TXLG\"]'),(2902,'inventory.source.items.cleanup','[\"ECL0500088003MRP\"]'),(2903,'inventory.source.items.cleanup','[\"ECL0500088003STP\"]'),(2904,'inventory.source.items.cleanup','[\"ECL0500137006MRP\"]'),(2905,'inventory.source.items.cleanup','[\"ECL0500137006STP\"]'),(2906,'inventory.source.items.cleanup','[\"ECLIPSE\"]'),(2907,'inventory.source.items.cleanup','[\"ECS50\"]'),(2908,'inventory.source.items.cleanup','[\"Egna Vertical\"]'),(2909,'inventory.source.items.cleanup','[\"ELB0370080003TXB\"]'),(2910,'inventory.source.items.cleanup','[\"ELB0370080003TXW\"]'),(2911,'inventory.source.items.cleanup','[\"ELF0995030008TXW\"]'),(2912,'inventory.source.items.cleanup','[\"ELF1245030010TXW\"]'),(2913,'inventory.source.items.cleanup','[\"Elisa Vertical\"]'),(2914,'inventory.source.items.cleanup','[\"Elite Horizontal\"]'),(2915,'inventory.source.items.cleanup','[\"Elite Vertical\"]'),(2916,'inventory.source.items.cleanup','[\"ELM\\/S\"]'),(2917,'inventory.source.items.cleanup','[\"ELM\\/T\"]'),(2918,'inventory.source.items.cleanup','[\"ELT0295180004W\"]'),(2919,'inventory.source.items.cleanup','[\"ELT0370180005W\"]'),(2920,'inventory.source.items.cleanup','[\"ELT0445180006W\"]'),(2921,'inventory.source.items.cleanup','[\"ELT0595060008W\"]'),(2922,'inventory.source.items.cleanup','[\"ELT0745060010W\"]'),(2923,'inventory.source.items.cleanup','[\"ELT0895060012W\"]'),(2924,'inventory.source.items.cleanup','[\"ELT1045060014W\"]'),(2925,'inventory.source.items.cleanup','[\"ELT1195060016W\"]'),(2926,'inventory.source.items.cleanup','[\"ELV0370180003TXB\"]'),(2927,'inventory.source.items.cleanup','[\"ELV0370180003TXW\"]'),(2928,'inventory.source.items.cleanup','[\"ELV0495180004TXB\"]'),(2929,'inventory.source.items.cleanup','[\"ELV0495180004TXW\"]'),(2930,'inventory.source.items.cleanup','[\"ELV0745060006TXB\"]'),(2931,'inventory.source.items.cleanup','[\"ELV0745060006TXW\"]'),(2932,'inventory.source.items.cleanup','[\"ELV0995060008TXB\"]'),(2933,'inventory.source.items.cleanup','[\"ELV0995060008TXW\"]'),(2934,'inventory.source.items.cleanup','[\"ELV1245060010TXB\"]'),(2935,'inventory.source.items.cleanup','[\"ELV1245060010TXW\"]'),(2936,'inventory.source.items.cleanup','[\"Elvino Bath\"]'),(2937,'inventory.source.items.cleanup','[\"Elvino Floor\"]'),(2938,'inventory.source.items.cleanup','[\"ELVINO H\"]'),(2939,'inventory.source.items.cleanup','[\"ELVINO V\"]'),(2940,'inventory.source.items.cleanup','[\"Entice Vertical\"]'),(2941,'inventory.source.items.cleanup','[\"Eos Curved\"]'),(2942,'inventory.source.items.cleanup','[\"ETG0500035005CHR\"]'),(2943,'inventory.source.items.cleanup','[\"FAME\"]'),(2944,'inventory.source.items.cleanup','[\"FBA404\"]'),(2945,'inventory.source.items.cleanup','[\"Flat Double Panel\"]'),(2946,'inventory.source.items.cleanup','[\"Flat Single Panel\"]'),(2947,'inventory.source.items.cleanup','[\"Flat Steel Double Panel\"]'),(2948,'inventory.source.items.cleanup','[\"Flat Vertical Single Panel\"]'),(2949,'inventory.source.items.cleanup','[\"Florina Chrome\"]'),(2950,'inventory.source.items.cleanup','[\"Floris\"]'),(2951,'inventory.source.items.cleanup','[\"FLR0500080006CHR\"]'),(2952,'inventory.source.items.cleanup','[\"FLR0500100008CHR\"]'),(2953,'inventory.source.items.cleanup','[\"FLR0500120010CHR\"]'),(2954,'inventory.source.items.cleanup','[\"GA807\"]'),(2955,'inventory.source.items.cleanup','[\"GAI0355180004TXW\"]'),(2956,'inventory.source.items.cleanup','[\"GAI0430180005TXW\"]'),(2957,'inventory.source.items.cleanup','[\"GAI0505180006TXW\"]'),(2958,'inventory.source.items.cleanup','[\"GAI0730060009TXW\"]'),(2959,'inventory.source.items.cleanup','[\"GAI0880060011TXW\"]'),(2960,'inventory.source.items.cleanup','[\"GAI1030060013TXW\"]'),(2961,'inventory.source.items.cleanup','[\"GAIA H\"]'),(2962,'inventory.source.items.cleanup','[\"GAIA V\"]'),(2963,'inventory.source.items.cleanup','[\"HAL0400093003MRP\"]'),(2964,'inventory.source.items.cleanup','[\"HAL0400093003STP\"]'),(2965,'inventory.source.items.cleanup','[\"HAL0400147005MRP\"]'),(2966,'inventory.source.items.cleanup','[\"HAL0400147005STP\"]'),(2967,'inventory.source.items.cleanup','[\"Helin Vertical\"]'),(2968,'inventory.source.items.cleanup','[\"HK38\"]'),(2969,'inventory.source.items.cleanup','[\"HL311\"]'),(2970,'inventory.source.items.cleanup','[\"HL312\"]'),(2971,'inventory.source.items.cleanup','[\"HL316\"]'),(2972,'inventory.source.items.cleanup','[\"HL318\"]'),(2973,'inventory.source.items.cleanup','[\"HL335\"]'),(2974,'inventory.source.items.cleanup','[\"HL336\"]'),(2975,'inventory.source.items.cleanup','[\"HL354\"]'),(2976,'inventory.source.items.cleanup','[\"HL355\"]'),(2977,'inventory.source.items.cleanup','[\"HL375\"]'),(2978,'inventory.source.items.cleanup','[\"HL376\"]'),(2979,'inventory.source.items.cleanup','[\"HL382\"]'),(2980,'inventory.source.items.cleanup','[\"HL396\"]'),(2981,'inventory.source.items.cleanup','[\"HLA36\"]'),(2982,'inventory.source.items.cleanup','[\"HLA72\"]'),(2983,'inventory.source.items.cleanup','[\"HLA74\"]'),(2984,'inventory.source.items.cleanup','[\"HLA78\"]'),(2985,'inventory.source.items.cleanup','[\"HLA79\"]'),(2986,'inventory.source.items.cleanup','[\"HLA84\"]'),(2987,'inventory.source.items.cleanup','[\"HLA94\"]'),(2988,'inventory.source.items.cleanup','[\"HLA95\"]'),(2989,'inventory.source.items.cleanup','[\"HLW41\"]'),(2990,'inventory.source.items.cleanup','[\"HLW43\"]'),(2991,'inventory.source.items.cleanup','[\"HLW44\"]'),(2992,'inventory.source.items.cleanup','[\"HT300\"]'),(2993,'inventory.source.items.cleanup','[\"HT301\"]'),(2994,'inventory.source.items.cleanup','[\"HT324\"]'),(2995,'inventory.source.items.cleanup','[\"HTD06\"]'),(2996,'inventory.source.items.cleanup','[\"HX3\"]'),(2997,'inventory.source.items.cleanup','[\"HX303\"]'),(2998,'inventory.source.items.cleanup','[\"HX304\"]'),(2999,'inventory.source.items.cleanup','[\"HX305\"]'),(3000,'inventory.source.items.cleanup','[\"HX306\"]'),(3001,'inventory.source.items.cleanup','[\"HX308\"]'),(3002,'inventory.source.items.cleanup','[\"HX309\"]'),(3003,'inventory.source.items.cleanup','[\"HX311\"]'),(3004,'inventory.source.items.cleanup','[\"HX312\"]'),(3005,'inventory.source.items.cleanup','[\"IBIZA\"]'),(3006,'inventory.source.items.cleanup','[\"IBZ0500044003MRP\"]'),(3007,'inventory.source.items.cleanup','[\"IBZ0500044003STP\"]'),(3008,'inventory.source.items.cleanup','[\"IBZ0500077005MRP\"]'),(3009,'inventory.source.items.cleanup','[\"IBZ0500077005STP\"]'),(3010,'inventory.source.items.cleanup','[\"IBZ0500113007MRP\"]'),(3011,'inventory.source.items.cleanup','[\"IBZ0500113007STP\"]'),(3012,'inventory.source.items.cleanup','[\"IVO0500100007STP\"]'),(3013,'inventory.source.items.cleanup','[\"KEO0600060020MRP\"]'),(3014,'inventory.source.items.cleanup','[\"KEO0600060020STP\"]'),(3015,'inventory.source.items.cleanup','[\"KEO0700070024MRP\"]'),(3016,'inventory.source.items.cleanup','[\"KEO0700070024STP\"]'),(3017,'inventory.source.items.cleanup','[\"KEO0800080028MRP\"]'),(3018,'inventory.source.items.cleanup','[\"KEO0800080028STP\"]'),(3019,'inventory.source.items.cleanup','[\"Klaro Designer\"]'),(3020,'inventory.source.items.cleanup','[\"Klaro Electric\"]'),(3021,'inventory.source.items.cleanup','[\"KLH-058-100\"]'),(3022,'inventory.source.items.cleanup','[\"KLH-058-120\"]'),(3023,'inventory.source.items.cleanup','[\"KLH-058-140\"]'),(3024,'inventory.source.items.cleanup','[\"KLHD-058-100\"]'),(3025,'inventory.source.items.cleanup','[\"KLHD-058-120\"]'),(3026,'inventory.source.items.cleanup','[\"Kreon Vertical\"]'),(3027,'inventory.source.items.cleanup','[\"LA108\"]'),(3028,'inventory.source.items.cleanup','[\"Lago Steel\"]'),(3029,'inventory.source.items.cleanup','[\"LDR005\"]'),(3030,'inventory.source.items.cleanup','[\"LDR009\"]'),(3031,'inventory.source.items.cleanup','[\"LNK0240083003MRP\"]'),(3032,'inventory.source.items.cleanup','[\"LNK0240083003STP\"]'),(3033,'inventory.source.items.cleanup','[\"LNK0240130005MRP\"]'),(3034,'inventory.source.items.cleanup','[\"LNK0240130005STP\"]'),(3035,'inventory.source.items.cleanup','[\"LNK0240183507MRP\"]'),(3036,'inventory.source.items.cleanup','[\"LNK0240183507STP\"]'),(3037,'inventory.source.items.cleanup','[\"Lovere Vertical\"]'),(3038,'inventory.source.items.cleanup','[\"MAD400\"]'),(3039,'inventory.source.items.cleanup','[\"Marco Steel\"]'),(3040,'inventory.source.items.cleanup','[\"Matera Vertical\"]'),(3041,'inventory.source.items.cleanup','[\"Mayra Horizontal\"]'),(3042,'inventory.source.items.cleanup','[\"Mayra Vertical\"]'),(3043,'inventory.source.items.cleanup','[\"MEH-030-140\"]'),(3044,'inventory.source.items.cleanup','[\"MEH-050-140\"]'),(3045,'inventory.source.items.cleanup','[\"MEH-050-160\"]'),(3046,'inventory.source.items.cleanup','[\"MEH-060-090\"]'),(3047,'inventory.source.items.cleanup','[\"MEH-080-050\"]'),(3048,'inventory.source.items.cleanup','[\"MET-080-040\"]'),(3049,'inventory.source.items.cleanup','[\"MET-080-050\"]'),(3050,'inventory.source.items.cleanup','[\"MET-080-060\"]'),(3051,'inventory.source.items.cleanup','[\"MET-120-040\"]'),(3052,'inventory.source.items.cleanup','[\"MET-120-050\"]'),(3053,'inventory.source.items.cleanup','[\"MET-120-060\"]'),(3054,'inventory.source.items.cleanup','[\"MET-150-040\"]'),(3055,'inventory.source.items.cleanup','[\"MET-150-050\"]'),(3056,'inventory.source.items.cleanup','[\"MET-180-050\"]'),(3057,'inventory.source.items.cleanup','[\"MET-180-060\"]'),(3058,'inventory.source.items.cleanup','[\"MEV-180-030\"]'),(3059,'inventory.source.items.cleanup','[\"MEV-180-040\"]'),(3060,'inventory.source.items.cleanup','[\"MEV-180-050\"]'),(3061,'inventory.source.items.cleanup','[\"MEV-200-050\"]'),(3062,'inventory.source.items.cleanup','[\"Mina Vertical\"]'),(3063,'inventory.source.items.cleanup','[\"MIS0320180005MRP\"]'),(3064,'inventory.source.items.cleanup','[\"MIS0320180005STP\"]'),(3065,'inventory.source.items.cleanup','[\"MIS0385180006MRP\"]'),(3066,'inventory.source.items.cleanup','[\"MIS0385180006STP\"]'),(3067,'inventory.source.items.cleanup','[\"MIS0450180007MRP\"]'),(3068,'inventory.source.items.cleanup','[\"MIS0450180007STP\"]'),(3069,'inventory.source.items.cleanup','[\"Mistral\"]'),(3070,'inventory.source.items.cleanup','[\"MNZ0280180003TXB\"]'),(3071,'inventory.source.items.cleanup','[\"MNZ0280180003TXW\"]'),(3072,'inventory.source.items.cleanup','[\"MNZ0375180004TXB\"]'),(3073,'inventory.source.items.cleanup','[\"MNZ0375180004TXW\"]'),(3074,'inventory.source.items.cleanup','[\"MNZ0470060005TXB\"]'),(3075,'inventory.source.items.cleanup','[\"MNZ0470060005TXW\"]'),(3076,'inventory.source.items.cleanup','[\"MNZ0470180005TXB\"]'),(3077,'inventory.source.items.cleanup','[\"MNZ0470180005TXW\"]'),(3078,'inventory.source.items.cleanup','[\"MNZ0660060007TXB\"]'),(3079,'inventory.source.items.cleanup','[\"MNZ0660060007TXW\"]'),(3080,'inventory.source.items.cleanup','[\"MNZ0850060009TXB\"]'),(3081,'inventory.source.items.cleanup','[\"MNZ0850060009TXW\"]'),(3082,'inventory.source.items.cleanup','[\"MNZ1040060011TXB\"]'),(3083,'inventory.source.items.cleanup','[\"MNZ1040060011TXW\"]'),(3084,'inventory.source.items.cleanup','[\"MNZ1230060013TXB\"]'),(3085,'inventory.source.items.cleanup','[\"MNZ1230060013TXW\"]'),(3086,'inventory.source.items.cleanup','[\"MONZA S H\"]'),(3087,'inventory.source.items.cleanup','[\"MONZA S V\"]'),(3088,'inventory.source.items.cleanup','[\"MOT0390180005TXA\"]'),(3089,'inventory.source.items.cleanup','[\"MOT0550180007TXA\"]'),(3090,'inventory.source.items.cleanup','[\"MOT0630060008TXA\"]'),(3091,'inventory.source.items.cleanup','[\"MOT0950060012TXA\"]'),(3092,'inventory.source.items.cleanup','[\"MTY022\"]'),(3093,'inventory.source.items.cleanup','[\"MTY10\"]'),(3094,'inventory.source.items.cleanup','[\"MYR0270180004CHR\"]'),(3095,'inventory.source.items.cleanup','[\"MYR0420180006CHR\"]'),(3096,'inventory.source.items.cleanup','[\"MYR0720055010CHR\"]'),(3097,'inventory.source.items.cleanup','[\"MYR1020055014CHR\"]'),(3098,'inventory.source.items.cleanup','[\"NEMO S H\"]'),(3099,'inventory.source.items.cleanup','[\"NEMO S V\"]'),(3100,'inventory.source.items.cleanup','[\"Nerox D- Panel\"]'),(3101,'inventory.source.items.cleanup','[\"Nerox S- Panel\"]'),(3102,'inventory.source.items.cleanup','[\"Neva Chrome Single Panel\"]'),(3103,'inventory.source.items.cleanup','[\"Neva Double Panel\"]'),(3104,'inventory.source.items.cleanup','[\"Neva Single Panel\"]'),(3105,'inventory.source.items.cleanup','[\"Neva Vertical\"]'),(3106,'inventory.source.items.cleanup','[\"NIL0400080012CHR\"]'),(3107,'inventory.source.items.cleanup','[\"NIL0400120018CHR\"]'),(3108,'inventory.source.items.cleanup','[\"NIL0400160024CHR\"]'),(3109,'inventory.source.items.cleanup','[\"NIL0500080012CHR\"]'),(3110,'inventory.source.items.cleanup','[\"NIL0500120018CHR\"]'),(3111,'inventory.source.items.cleanup','[\"NIL0500160024CHR\"]'),(3112,'inventory.source.items.cleanup','[\"NIL0600080012CHR\"]'),(3113,'inventory.source.items.cleanup','[\"NIL0600120018CHR\"]'),(3114,'inventory.source.items.cleanup','[\"NIL0600160024CHR\"]'),(3115,'inventory.source.items.cleanup','[\"NIX0205180002TXB\"]'),(3116,'inventory.source.items.cleanup','[\"NIX0205180002TXW\"]'),(3117,'inventory.source.items.cleanup','[\"NIX0415180004TXB\"]'),(3118,'inventory.source.items.cleanup','[\"NIX0415180004TXW\"]'),(3119,'inventory.source.items.cleanup','[\"NIX0625060006TXB\"]'),(3120,'inventory.source.items.cleanup','[\"NIX0625060006TXW\"]'),(3121,'inventory.source.items.cleanup','[\"NIX0835060008TXB\"]'),(3122,'inventory.source.items.cleanup','[\"NIX0835060008TXW\"]'),(3123,'inventory.source.items.cleanup','[\"NIX1045060010TXB\"]'),(3124,'inventory.source.items.cleanup','[\"NIX1045060010TXW\"]'),(3125,'inventory.source.items.cleanup','[\"NIX1255060012TXB\"]'),(3126,'inventory.source.items.cleanup','[\"NIX1255060012TXW\"]'),(3127,'inventory.source.items.cleanup','[\"NIXIE BATH\"]'),(3128,'inventory.source.items.cleanup','[\"NIXIE H\"]'),(3129,'inventory.source.items.cleanup','[\"NIXIE V\"]'),(3130,'inventory.source.items.cleanup','[\"NMO0280180003TXB\"]'),(3131,'inventory.source.items.cleanup','[\"NMO0280180003TXW\"]'),(3132,'inventory.source.items.cleanup','[\"NMO0375180004TXB\"]'),(3133,'inventory.source.items.cleanup','[\"NMO0375180004TXW\"]'),(3134,'inventory.source.items.cleanup','[\"NMO0470060005TXB\"]'),(3135,'inventory.source.items.cleanup','[\"NMO0470060005TXW\"]'),(3136,'inventory.source.items.cleanup','[\"NMO0470180005TXB\"]'),(3137,'inventory.source.items.cleanup','[\"NMO0470180005TXW\"]'),(3138,'inventory.source.items.cleanup','[\"NMO0660060007TXB\"]'),(3139,'inventory.source.items.cleanup','[\"NMO0660060007TXW\"]'),(3140,'inventory.source.items.cleanup','[\"NMO0850060009TXB\"]'),(3141,'inventory.source.items.cleanup','[\"NMO0850060009TXW\"]'),(3142,'inventory.source.items.cleanup','[\"NMO1040060011TXB\"]'),(3143,'inventory.source.items.cleanup','[\"NMO1040060011TXW\"]'),(3144,'inventory.source.items.cleanup','[\"NMO1230060013TXB\"]'),(3145,'inventory.source.items.cleanup','[\"NMO1230060013TXW\"]'),(3146,'inventory.source.items.cleanup','[\"NXB0205120002TXB\"]'),(3147,'inventory.source.items.cleanup','[\"NXB0205120002TXW\"]'),(3148,'inventory.source.items.cleanup','[\"NXB0205150002TXB\"]'),(3149,'inventory.source.items.cleanup','[\"NXB0205150002TXW\"]'),(3150,'inventory.source.items.cleanup','[\"NXB0205180002TXB\"]'),(3151,'inventory.source.items.cleanup','[\"NXB0205180002TXW\"]'),(3152,'inventory.source.items.cleanup','[\"Osimo Vertical\"]'),(3153,'inventory.source.items.cleanup','[\"OTT0315180004TXW\"]'),(3154,'inventory.source.items.cleanup','[\"OTT0395180005TXW\"]'),(3155,'inventory.source.items.cleanup','[\"OTT0475180006TXW\"]'),(3156,'inventory.source.items.cleanup','[\"OTT0795060010TXW\"]'),(3157,'inventory.source.items.cleanup','[\"OTT0955060012TXW\"]'),(3158,'inventory.source.items.cleanup','[\"OTTO H\"]'),(3159,'inventory.source.items.cleanup','[\"OTTO V\"]'),(3160,'inventory.source.items.cleanup','[\"PAN0740110015MRP\"]'),(3161,'inventory.source.items.cleanup','[\"PAN0740110015STP\"]'),(3162,'inventory.source.items.cleanup','[\"PAR0500090004MRP\"]'),(3163,'inventory.source.items.cleanup','[\"PAR0500090004STP\"]'),(3164,'inventory.source.items.cleanup','[\"PAR0500120006MRP\"]'),(3165,'inventory.source.items.cleanup','[\"PAR0500120006STP\"]'),(3166,'inventory.source.items.cleanup','[\"PAR0500150008MRP\"]'),(3167,'inventory.source.items.cleanup','[\"PAR0500150008STP\"]'),(3168,'inventory.source.items.cleanup','[\"PETS46\"]'),(3169,'inventory.source.items.cleanup','[\"PIA1130050019MRP\"]'),(3170,'inventory.source.items.cleanup','[\"PIA1130050019STP\"]'),(3171,'inventory.source.items.cleanup','[\"PIA1130060019MRP\"]'),(3172,'inventory.source.items.cleanup','[\"PIA1130060019STP\"]'),(3173,'inventory.source.items.cleanup','[\"QUA0280161003TXW\"]'),(3174,'inventory.source.items.cleanup','[\"QUA0470180005TXW\"]'),(3175,'inventory.source.items.cleanup','[\"Quaro Spa\"]'),(3176,'inventory.source.items.cleanup','[\"Reina Alento\"]'),(3177,'inventory.source.items.cleanup','[\"Reina Aliano\"]'),(3178,'inventory.source.items.cleanup','[\"Reina Arbori\"]'),(3179,'inventory.source.items.cleanup','[\"Reina Arbori A\\/W\"]'),(3180,'inventory.source.items.cleanup','[\"Reina Arden\"]'),(3181,'inventory.source.items.cleanup','[\"Reina Arnage\"]'),(3182,'inventory.source.items.cleanup','[\"Reina Belbo\"]'),(3183,'inventory.source.items.cleanup','[\"Reina Belva Vertical-DP\"]'),(3184,'inventory.source.items.cleanup','[\"Reina Belva Vertical-SP\"]'),(3185,'inventory.source.items.cleanup','[\"Reina Bolca\"]'),(3186,'inventory.source.items.cleanup','[\"Reina Casina Horizontal-DP\"]'),(3187,'inventory.source.items.cleanup','[\"Reina Casina Horizontal-SP\"]'),(3188,'inventory.source.items.cleanup','[\"Reina Casina Vertical-DP\"]'),(3189,'inventory.source.items.cleanup','[\"Reina Casina Vertical-SP\"]'),(3190,'inventory.source.items.cleanup','[\"Reina Chisa\"]'),(3191,'inventory.source.items.cleanup','[\"Reina Dimaro\"]'),(3192,'inventory.source.items.cleanup','[\"Reina Elvina 2\"]'),(3193,'inventory.source.items.cleanup','[\"Reina Fano\"]'),(3194,'inventory.source.items.cleanup','[\"Reina Fermo\"]'),(3195,'inventory.source.items.cleanup','[\"Reina Fiore\"]'),(3196,'inventory.source.items.cleanup','[\"Reina Grace\"]'),(3197,'inventory.source.items.cleanup','[\"Reina Grosso\"]'),(3198,'inventory.source.items.cleanup','[\"Reina Misa\"]'),(3199,'inventory.source.items.cleanup','[\"Reina Nardo\"]'),(3200,'inventory.source.items.cleanup','[\"Reina Nevah-DP\"]'),(3201,'inventory.source.items.cleanup','[\"Reina Nevah-SP\"]'),(3202,'inventory.source.items.cleanup','[\"Reina Nola\"]'),(3203,'inventory.source.items.cleanup','[\"Reina Radiator Valve\"]'),(3204,'inventory.source.items.cleanup','[\"Reina Rezzo\"]'),(3205,'inventory.source.items.cleanup','[\"Reina Rima\"]'),(3206,'inventory.source.items.cleanup','[\"Reina Serpe\"]'),(3207,'inventory.source.items.cleanup','[\"Reina Todi\"]'),(3208,'inventory.source.items.cleanup','[\"Reina Trento\"]'),(3209,'inventory.source.items.cleanup','[\"Reina Veroli\"]'),(3210,'inventory.source.items.cleanup','[\"Reina Vicari Horizontal-DP\"]'),(3211,'inventory.source.items.cleanup','[\"Reina Vicari Horizontal-SP\"]'),(3212,'inventory.source.items.cleanup','[\"Reina Vicari Vertical-DP\"]'),(3213,'inventory.source.items.cleanup','[\"Reina Vicari Vertical-SP\"]'),(3214,'inventory.source.items.cleanup','[\"Revive 1500\"]'),(3215,'inventory.source.items.cleanup','[\"Revive 1800mm\"]'),(3216,'inventory.source.items.cleanup','[\"Revive 236mm\"]'),(3217,'inventory.source.items.cleanup','[\"Rione Double Panel\"]'),(3218,'inventory.source.items.cleanup','[\"Rione Single Panel\"]'),(3219,'inventory.source.items.cleanup','[\"RND-ALC01\"]'),(3220,'inventory.source.items.cleanup','[\"RND-ALN5050\"]'),(3221,'inventory.source.items.cleanup','[\"RND-ALN5100\"]'),(3222,'inventory.source.items.cleanup','[\"RND-AN418\"]'),(3223,'inventory.source.items.cleanup','[\"RND-ARB082A\"]'),(3224,'inventory.source.items.cleanup','[\"RND-ARB082C\"]'),(3225,'inventory.source.items.cleanup','[\"RND-ARB082W\"]'),(3226,'inventory.source.items.cleanup','[\"RND-ARB113A\"]'),(3227,'inventory.source.items.cleanup','[\"RND-ARB113C\"]'),(3228,'inventory.source.items.cleanup','[\"RND-ARB113W\"]'),(3229,'inventory.source.items.cleanup','[\"RND-ARB151A\"]'),(3230,'inventory.source.items.cleanup','[\"RND-ARB151C\"]'),(3231,'inventory.source.items.cleanup','[\"RND-ARB151W\"]'),(3232,'inventory.source.items.cleanup','[\"RND-BNR3218\"]'),(3233,'inventory.source.items.cleanup','[\"RND-BNR4518\"]'),(3234,'inventory.source.items.cleanup','[\"RND-BO1\"]'),(3235,'inventory.source.items.cleanup','[\"RND-CHS082A\"]'),(3236,'inventory.source.items.cleanup','[\"RND-CHS082C\"]'),(3237,'inventory.source.items.cleanup','[\"RND-CHS082W\"]'),(3238,'inventory.source.items.cleanup','[\"RND-CHS113A\"]'),(3239,'inventory.source.items.cleanup','[\"RND-CHS113C\"]'),(3240,'inventory.source.items.cleanup','[\"RND-CHS113W\"]'),(3241,'inventory.source.items.cleanup','[\"RND-CLR3090\"]'),(3242,'inventory.source.items.cleanup','[\"RND-CLR3120\"]'),(3243,'inventory.source.items.cleanup','[\"RND-CLR3160\"]'),(3244,'inventory.source.items.cleanup','[\"RND-CM01\"]'),(3245,'inventory.source.items.cleanup','[\"RND-CM02\"]'),(3246,'inventory.source.items.cleanup','[\"RND-CNV05044W\"]'),(3247,'inventory.source.items.cleanup','[\"RND-CNV05058W\"]'),(3248,'inventory.source.items.cleanup','[\"RND-CNV05079W\"]'),(3249,'inventory.source.items.cleanup','[\"RND-CNV05100W\"]'),(3250,'inventory.source.items.cleanup','[\"RND-CNV05121W\"]'),(3251,'inventory.source.items.cleanup','[\"RND-CNV18030W\"]'),(3252,'inventory.source.items.cleanup','[\"RND-CNV18037W\"]'),(3253,'inventory.source.items.cleanup','[\"RND-CNV18044W\"]'),(3254,'inventory.source.items.cleanup','[\"RND-CRP3080\"]'),(3255,'inventory.source.items.cleanup','[\"RND-CRP3120\"]'),(3256,'inventory.source.items.cleanup','[\"RND-CRP4080\"]'),(3257,'inventory.source.items.cleanup','[\"RND-CRP4120\"]'),(3258,'inventory.source.items.cleanup','[\"RND-CRP5095\"]'),(3259,'inventory.source.items.cleanup','[\"RND-DMR176\"]'),(3260,'inventory.source.items.cleanup','[\"RND-DMR176A\"]'),(3261,'inventory.source.items.cleanup','[\"RND-DMR176W\"]'),(3262,'inventory.source.items.cleanup','[\"RND-ES510\"]'),(3263,'inventory.source.items.cleanup','[\"RND-ES515\"]'),(3264,'inventory.source.items.cleanup','[\"RND-EV503\"]'),(3265,'inventory.source.items.cleanup','[\"RND-FL06W\"]'),(3266,'inventory.source.items.cleanup','[\"RND-FL06WD\"]'),(3267,'inventory.source.items.cleanup','[\"RND-FL08W\"]'),(3268,'inventory.source.items.cleanup','[\"RND-FL08WD\"]'),(3269,'inventory.source.items.cleanup','[\"RND-FL11W\"]'),(3270,'inventory.source.items.cleanup','[\"RND-FL11WD\"]'),(3271,'inventory.source.items.cleanup','[\"RND-FL14W\"]'),(3272,'inventory.source.items.cleanup','[\"RND-FL14WD\"]'),(3273,'inventory.source.items.cleanup','[\"RND-FL163W\"]'),(3274,'inventory.source.items.cleanup','[\"RND-FL163WD\"]'),(3275,'inventory.source.items.cleanup','[\"RND-FL164W\"]'),(3276,'inventory.source.items.cleanup','[\"RND-FL164WD\"]'),(3277,'inventory.source.items.cleanup','[\"RND-FL165W\"]'),(3278,'inventory.source.items.cleanup','[\"RND-FL165WD\"]'),(3279,'inventory.source.items.cleanup','[\"RND-FL166W\"]'),(3280,'inventory.source.items.cleanup','[\"RND-FL166WD\"]'),(3281,'inventory.source.items.cleanup','[\"RND-FL167W\"]'),(3282,'inventory.source.items.cleanup','[\"RND-FL167WD\"]'),(3283,'inventory.source.items.cleanup','[\"RND-FL17W\"]'),(3284,'inventory.source.items.cleanup','[\"RND-FL17WD\"]'),(3285,'inventory.source.items.cleanup','[\"RND-FL183W\"]'),(3286,'inventory.source.items.cleanup','[\"RND-FL183WD\"]'),(3287,'inventory.source.items.cleanup','[\"RND-FL184W\"]'),(3288,'inventory.source.items.cleanup','[\"RND-FL184WD\"]'),(3289,'inventory.source.items.cleanup','[\"RND-FL185W\"]'),(3290,'inventory.source.items.cleanup','[\"RND-FL185WD\"]'),(3291,'inventory.source.items.cleanup','[\"RND-FL186W\"]'),(3292,'inventory.source.items.cleanup','[\"RND-FL186WD\"]'),(3293,'inventory.source.items.cleanup','[\"RND-FL187W\"]'),(3294,'inventory.source.items.cleanup','[\"RND-FL187WD\"]'),(3295,'inventory.source.items.cleanup','[\"RND-FR508\"]'),(3296,'inventory.source.items.cleanup','[\"RND-FR508A\"]'),(3297,'inventory.source.items.cleanup','[\"RND-FR512\"]'),(3298,'inventory.source.items.cleanup','[\"RND-FR512A\"]'),(3299,'inventory.source.items.cleanup','[\"RND-FR515\"]'),(3300,'inventory.source.items.cleanup','[\"RND-FR515A\"]'),(3301,'inventory.source.items.cleanup','[\"RND-GRC078A\"]'),(3302,'inventory.source.items.cleanup','[\"RND-GRC078C\"]'),(3303,'inventory.source.items.cleanup','[\"RND-GRC078W\"]'),(3304,'inventory.source.items.cleanup','[\"RND-GRC114A\"]'),(3305,'inventory.source.items.cleanup','[\"RND-GRC114C\"]'),(3306,'inventory.source.items.cleanup','[\"RND-GRC114W\"]'),(3307,'inventory.source.items.cleanup','[\"RND-HB1284\"]'),(3308,'inventory.source.items.cleanup','[\"RND-HB456\"]'),(3309,'inventory.source.items.cleanup','[\"RND-HB588\"]'),(3310,'inventory.source.items.cleanup','[\"RND-HB852\"]'),(3311,'inventory.source.items.cleanup','[\"RND-HB984\"]'),(3312,'inventory.source.items.cleanup','[\"RND-HNV10\"]'),(3313,'inventory.source.items.cleanup','[\"RND-HNV10C\"]'),(3314,'inventory.source.items.cleanup','[\"RND-HNV10D\"]'),(3315,'inventory.source.items.cleanup','[\"RND-HNV14\"]'),(3316,'inventory.source.items.cleanup','[\"RND-HNV14C\"]'),(3317,'inventory.source.items.cleanup','[\"RND-HNV14D\"]'),(3318,'inventory.source.items.cleanup','[\"RND-HNV17\"]'),(3319,'inventory.source.items.cleanup','[\"RND-HNV17C\"]'),(3320,'inventory.source.items.cleanup','[\"RND-HNV17D\"]'),(3321,'inventory.source.items.cleanup','[\"RND-HNV20\"]'),(3322,'inventory.source.items.cleanup','[\"RND-HNV20C\"]'),(3323,'inventory.source.items.cleanup','[\"RND-HNV20D\"]'),(3324,'inventory.source.items.cleanup','[\"RND-HNV7\"]'),(3325,'inventory.source.items.cleanup','[\"RND-HNV7C\"]'),(3326,'inventory.source.items.cleanup','[\"RND-HNV7D\"]'),(3327,'inventory.source.items.cleanup','[\"RND-LE418\"]'),(3328,'inventory.source.items.cleanup','[\"RND-LG1\"]'),(3329,'inventory.source.items.cleanup','[\"RND-LG2\"]'),(3330,'inventory.source.items.cleanup','[\"RND-MC5080\"]'),(3331,'inventory.source.items.cleanup','[\"RND-MC5110\"]'),(3332,'inventory.source.items.cleanup','[\"RND-MC5140\"]'),(3333,'inventory.source.items.cleanup','[\"RND-MTR5077\"]'),(3334,'inventory.source.items.cleanup','[\"RND-MTR5077A\"]'),(3335,'inventory.source.items.cleanup','[\"RND-MTR5099\"]'),(3336,'inventory.source.items.cleanup','[\"RND-MTR5099A\"]'),(3337,'inventory.source.items.cleanup','[\"RND-MTR5141\"]'),(3338,'inventory.source.items.cleanup','[\"RND-MTR5141A\"]'),(3339,'inventory.source.items.cleanup','[\"RND-NRD081045\"]'),(3340,'inventory.source.items.cleanup','[\"RND-NRD081055\"]'),(3341,'inventory.source.items.cleanup','[\"RND-NRD120045\"]'),(3342,'inventory.source.items.cleanup','[\"RND-NRD120055\"]'),(3343,'inventory.source.items.cleanup','[\"RND-NV2315W\"]'),(3344,'inventory.source.items.cleanup','[\"RND-NV2315WD\"]'),(3345,'inventory.source.items.cleanup','[\"RND-NV2318W\"]'),(3346,'inventory.source.items.cleanup','[\"RND-NV2318WD\"]'),(3347,'inventory.source.items.cleanup','[\"RND-NV2915W\"]'),(3348,'inventory.source.items.cleanup','[\"RND-NV2915WD\"]'),(3349,'inventory.source.items.cleanup','[\"RND-NV2918W\"]'),(3350,'inventory.source.items.cleanup','[\"RND-NV2918WD\"]'),(3351,'inventory.source.items.cleanup','[\"RND-NV3515W\"]'),(3352,'inventory.source.items.cleanup','[\"RND-NV3515WD\"]'),(3353,'inventory.source.items.cleanup','[\"RND-NV3518W\"]'),(3354,'inventory.source.items.cleanup','[\"RND-NV3518WD\"]'),(3355,'inventory.source.items.cleanup','[\"RND-NV4115W\"]'),(3356,'inventory.source.items.cleanup','[\"RND-NV4115WD\"]'),(3357,'inventory.source.items.cleanup','[\"RND-NV4118W\"]'),(3358,'inventory.source.items.cleanup','[\"RND-NV4118WD\"]'),(3359,'inventory.source.items.cleanup','[\"RND-NV4715W\"]'),(3360,'inventory.source.items.cleanup','[\"RND-NV4715WD\"]'),(3361,'inventory.source.items.cleanup','[\"RND-NV4718W\"]'),(3362,'inventory.source.items.cleanup','[\"RND-NV4718WD\"]'),(3363,'inventory.source.items.cleanup','[\"RND-NV5315W\"]'),(3364,'inventory.source.items.cleanup','[\"RND-NV5315WD\"]'),(3365,'inventory.source.items.cleanup','[\"RND-NV5318W\"]'),(3366,'inventory.source.items.cleanup','[\"RND-NV5318WD\"]'),(3367,'inventory.source.items.cleanup','[\"RND-NVH210D\"]'),(3368,'inventory.source.items.cleanup','[\"RND-NVH210S\"]'),(3369,'inventory.source.items.cleanup','[\"RND-NVH212D\"]'),(3370,'inventory.source.items.cleanup','[\"RND-NVH212S\"]'),(3371,'inventory.source.items.cleanup','[\"RND-NVH214D\"]'),(3372,'inventory.source.items.cleanup','[\"RND-NVH214S\"]'),(3373,'inventory.source.items.cleanup','[\"RND-NVH506D\"]'),(3374,'inventory.source.items.cleanup','[\"RND-NVH506S\"]'),(3375,'inventory.source.items.cleanup','[\"RND-NVH508D\"]'),(3376,'inventory.source.items.cleanup','[\"RND-NVH508S\"]'),(3377,'inventory.source.items.cleanup','[\"RND-NVH510D\"]'),(3378,'inventory.source.items.cleanup','[\"RND-NVH510S\"]'),(3379,'inventory.source.items.cleanup','[\"RND-NVH512D\"]'),(3380,'inventory.source.items.cleanup','[\"RND-NVH512S\"]'),(3381,'inventory.source.items.cleanup','[\"RND-NVH514D\"]'),(3382,'inventory.source.items.cleanup','[\"RND-NVH514S\"]'),(3383,'inventory.source.items.cleanup','[\"RND-OSM2918\"]'),(3384,'inventory.source.items.cleanup','[\"RND-OSM4318\"]'),(3385,'inventory.source.items.cleanup','[\"RND-OSM5718\"]'),(3386,'inventory.source.items.cleanup','[\"RND-OXF01\"]'),(3387,'inventory.source.items.cleanup','[\"RND-PNZ1165\"]'),(3388,'inventory.source.items.cleanup','[\"RND-PNZ485\"]'),(3389,'inventory.source.items.cleanup','[\"RND-PNZ655\"]'),(3390,'inventory.source.items.cleanup','[\"RND-PNZ825\"]'),(3391,'inventory.source.items.cleanup','[\"RND-PNZ995\"]'),(3392,'inventory.source.items.cleanup','[\"RND-RC8\"]'),(3393,'inventory.source.items.cleanup','[\"RND-REZ074045\"]'),(3394,'inventory.source.items.cleanup','[\"RND-REZ074055\"]'),(3395,'inventory.source.items.cleanup','[\"RND-REZ110045\"]'),(3396,'inventory.source.items.cleanup','[\"RND-REZ110055\"]'),(3397,'inventory.source.items.cleanup','[\"RND-REZ146045\"]'),(3398,'inventory.source.items.cleanup','[\"RND-REZ146055\"]'),(3399,'inventory.source.items.cleanup','[\"RND-RNE1000\"]'),(3400,'inventory.source.items.cleanup','[\"RND-RNE1000D\"]'),(3401,'inventory.source.items.cleanup','[\"RND-RNE1200\"]'),(3402,'inventory.source.items.cleanup','[\"RND-RNE1200D\"]'),(3403,'inventory.source.items.cleanup','[\"RND-RNE400\"]'),(3404,'inventory.source.items.cleanup','[\"RND-RNE400D\"]'),(3405,'inventory.source.items.cleanup','[\"RND-RNE600\"]'),(3406,'inventory.source.items.cleanup','[\"RND-RNE600D\"]'),(3407,'inventory.source.items.cleanup','[\"RND-RNE800\"]'),(3408,'inventory.source.items.cleanup','[\"RND-RNE800D\"]'),(3409,'inventory.source.items.cleanup','[\"RND-SLN04703W\"]'),(3410,'inventory.source.items.cleanup','[\"RND-SLN06004W\"]'),(3411,'inventory.source.items.cleanup','[\"RND-SLN06006W\"]'),(3412,'inventory.source.items.cleanup','[\"RND-SLN06008W\"]'),(3413,'inventory.source.items.cleanup','[\"RND-SLN06010W\"]'),(3414,'inventory.source.items.cleanup','[\"RND-SLN06012W\"]'),(3415,'inventory.source.items.cleanup','[\"RND-SLN06014W\"]'),(3416,'inventory.source.items.cleanup','[\"RND-SLN07703W\"]'),(3417,'inventory.source.items.cleanup','[\"RND-SLN11703W\"]'),(3418,'inventory.source.items.cleanup','[\"RND-SLN11704W\"]'),(3419,'inventory.source.items.cleanup','[\"RND-SLN11705W\"]'),(3420,'inventory.source.items.cleanup','[\"RND-SLN14703W\"]'),(3421,'inventory.source.items.cleanup','[\"RND-SLN14704W\"]'),(3422,'inventory.source.items.cleanup','[\"RND-SLN14705W\"]'),(3423,'inventory.source.items.cleanup','[\"RND-SLN17703W\"]'),(3424,'inventory.source.items.cleanup','[\"RND-SLN17704W\"]'),(3425,'inventory.source.items.cleanup','[\"RND-SLN17705W\"]'),(3426,'inventory.source.items.cleanup','[\"RND-SRN3080\"]'),(3427,'inventory.source.items.cleanup','[\"RND-SRN3120\"]'),(3428,'inventory.source.items.cleanup','[\"RND-SRN5050\"]'),(3429,'inventory.source.items.cleanup','[\"RND-SRN5080\"]'),(3430,'inventory.source.items.cleanup','[\"RND-SRN5120\"]'),(3431,'inventory.source.items.cleanup','[\"RND-SRP0275\"]'),(3432,'inventory.source.items.cleanup','[\"RND-SRP0275A\"]'),(3433,'inventory.source.items.cleanup','[\"RND-SRP0515\"]'),(3434,'inventory.source.items.cleanup','[\"RND-SRP0515A\"]'),(3435,'inventory.source.items.cleanup','[\"RND-SS508\"]'),(3436,'inventory.source.items.cleanup','[\"RND-SS511\"]'),(3437,'inventory.source.items.cleanup','[\"RND-SS515\"]'),(3438,'inventory.source.items.cleanup','[\"RND-TEN6130\"]'),(3439,'inventory.source.items.cleanup','[\"RND-TRT5095\"]'),(3440,'inventory.source.items.cleanup','[\"RND-TRT5130\"]'),(3441,'inventory.source.items.cleanup','[\"RND-VIC01\"]'),(3442,'inventory.source.items.cleanup','[\"RND-VST075C\"]'),(3443,'inventory.source.items.cleanup','[\"RND-VST113C\"]'),(3444,'inventory.source.items.cleanup','[\"RND-VST146C\"]'),(3445,'inventory.source.items.cleanup','[\"RNS-AD5080\"]'),(3446,'inventory.source.items.cleanup','[\"RNS-AD5110\"]'),(3447,'inventory.source.items.cleanup','[\"RNS-ALT072\"]'),(3448,'inventory.source.items.cleanup','[\"RNS-ALT112\"]'),(3449,'inventory.source.items.cleanup','[\"RNS-ALT145\"]'),(3450,'inventory.source.items.cleanup','[\"RNS-ARD5050\"]'),(3451,'inventory.source.items.cleanup','[\"RNS-ARD5100\"]'),(3452,'inventory.source.items.cleanup','[\"RNS-AT908D\"]'),(3453,'inventory.source.items.cleanup','[\"RNS-AT912D\"]'),(3454,'inventory.source.items.cleanup','[\"RNS-BLB082\"]'),(3455,'inventory.source.items.cleanup','[\"RNS-BLB118\"]'),(3456,'inventory.source.items.cleanup','[\"RNS-BLB154\"]'),(3457,'inventory.source.items.cleanup','[\"RNS-BV8030\"]'),(3458,'inventory.source.items.cleanup','[\"RNS-CLI5058\"]'),(3459,'inventory.source.items.cleanup','[\"RNS-CLI5100\"]'),(3460,'inventory.source.items.cleanup','[\"RNS-CLI5141\"]'),(3461,'inventory.source.items.cleanup','[\"RNS-CV505\"]'),(3462,'inventory.source.items.cleanup','[\"RNS-CV508\"]'),(3463,'inventory.source.items.cleanup','[\"RNS-CV512\"]'),(3464,'inventory.source.items.cleanup','[\"RNS-CV515\"]'),(3465,'inventory.source.items.cleanup','[\"RNS-DE505\"]'),(3466,'inventory.source.items.cleanup','[\"RNS-DE510\"]'),(3467,'inventory.source.items.cleanup','[\"RNS-DE515\"]'),(3468,'inventory.source.items.cleanup','[\"RNS-EGN5077P\"]'),(3469,'inventory.source.items.cleanup','[\"RNS-EGN5125P\"]'),(3470,'inventory.source.items.cleanup','[\"RNS-EGN5149P\"]'),(3471,'inventory.source.items.cleanup','[\"RNS-ELO066\"]'),(3472,'inventory.source.items.cleanup','[\"RNS-ENT5077\"]'),(3473,'inventory.source.items.cleanup','[\"RNS-ENT5120\"]'),(3474,'inventory.source.items.cleanup','[\"RNS-ENT5170\"]'),(3475,'inventory.source.items.cleanup','[\"RNS-ES5043\"]'),(3476,'inventory.source.items.cleanup','[\"RNS-ES5072\"]'),(3477,'inventory.source.items.cleanup','[\"RNS-ES5120\"]'),(3478,'inventory.source.items.cleanup','[\"RNS-ES5150\"]'),(3479,'inventory.source.items.cleanup','[\"RNS-ES6043\"]'),(3480,'inventory.source.items.cleanup','[\"RNS-ES6072\"]'),(3481,'inventory.source.items.cleanup','[\"RNS-ES6120\"]'),(3482,'inventory.source.items.cleanup','[\"RNS-ES6150\"]'),(3483,'inventory.source.items.cleanup','[\"RNS-GRS0855P\"]'),(3484,'inventory.source.items.cleanup','[\"RNS-GRS1255P\"]'),(3485,'inventory.source.items.cleanup','[\"RNS-GRS1655P\"]'),(3486,'inventory.source.items.cleanup','[\"RNS-HLN5082\"]'),(3487,'inventory.source.items.cleanup','[\"RNS-HLN5112\"]'),(3488,'inventory.source.items.cleanup','[\"RNS-HLN5153\"]'),(3489,'inventory.source.items.cleanup','[\"RNS-LN3060\"]'),(3490,'inventory.source.items.cleanup','[\"RNS-LN35072\"]'),(3491,'inventory.source.items.cleanup','[\"RNS-LN35120\"]'),(3492,'inventory.source.items.cleanup','[\"RNS-LN35150\"]'),(3493,'inventory.source.items.cleanup','[\"RNS-LN5043\"]'),(3494,'inventory.source.items.cleanup','[\"RNS-LN5072\"]'),(3495,'inventory.source.items.cleanup','[\"RNS-LN5120\"]'),(3496,'inventory.source.items.cleanup','[\"RNS-LN5150\"]'),(3497,'inventory.source.items.cleanup','[\"RNS-LN6043\"]'),(3498,'inventory.source.items.cleanup','[\"RNS-LN6072\"]'),(3499,'inventory.source.items.cleanup','[\"RNS-LN6120\"]'),(3500,'inventory.source.items.cleanup','[\"RNS-LN6150\"]'),(3501,'inventory.source.items.cleanup','[\"RNS-LVR5069P\"]'),(3502,'inventory.source.items.cleanup','[\"RNS-LVR5096P\"]'),(3503,'inventory.source.items.cleanup','[\"RNS-LVR5123P\"]'),(3504,'inventory.source.items.cleanup','[\"RNS-MN48075\"]'),(3505,'inventory.source.items.cleanup','[\"RNS-MN48117\"]'),(3506,'inventory.source.items.cleanup','[\"RNS-MSA072\"]'),(3507,'inventory.source.items.cleanup','[\"RNS-MSA112\"]'),(3508,'inventory.source.items.cleanup','[\"RNS-MSA145\"]'),(3509,'inventory.source.items.cleanup','[\"RNS-NRX1805\"]'),(3510,'inventory.source.items.cleanup','[\"RNS-NRX1805D\"]'),(3511,'inventory.source.items.cleanup','[\"RNS-NRX1807\"]'),(3512,'inventory.source.items.cleanup','[\"RNS-NRX1807D\"]'),(3513,'inventory.source.items.cleanup','[\"RNS-NRX1835\"]'),(3514,'inventory.source.items.cleanup','[\"RNS-NRX1835D\"]'),(3515,'inventory.source.items.cleanup','[\"RNS-NRX1847\"]'),(3516,'inventory.source.items.cleanup','[\"RNS-NRX1847D\"]'),(3517,'inventory.source.items.cleanup','[\"RNS-NRX1853\"]'),(3518,'inventory.source.items.cleanup','[\"RNS-NRX1853D\"]'),(3519,'inventory.source.items.cleanup','[\"RNS-NRX607\"]'),(3520,'inventory.source.items.cleanup','[\"RNS-NRX607D\"]'),(3521,'inventory.source.items.cleanup','[\"RNS-NRX610\"]'),(3522,'inventory.source.items.cleanup','[\"RNS-NRX610D\"]'),(3523,'inventory.source.items.cleanup','[\"RNS-NRX614\"]'),(3524,'inventory.source.items.cleanup','[\"RNS-NRX614D\"]'),(3525,'inventory.source.items.cleanup','[\"RNS-NRX617\"]'),(3526,'inventory.source.items.cleanup','[\"RNS-NRX617D\"]'),(3527,'inventory.source.items.cleanup','[\"RNS-NRX620\"]'),(3528,'inventory.source.items.cleanup','[\"RNS-NRX620D\"]'),(3529,'inventory.source.items.cleanup','[\"RNS-PZ610\"]'),(3530,'inventory.source.items.cleanup','[\"RNS-RIE612\"]'),(3531,'inventory.source.items.cleanup','[\"RNS-RMA078P\"]'),(3532,'inventory.source.items.cleanup','[\"RNS-RMA102P\"]'),(3533,'inventory.source.items.cleanup','[\"RNS-RMA126P\"]'),(3534,'inventory.source.items.cleanup','[\"RNS-RMA150P\"]'),(3535,'inventory.source.items.cleanup','[\"RNS-SC508\"]'),(3536,'inventory.source.items.cleanup','[\"RNS-SC512\"]'),(3537,'inventory.source.items.cleanup','[\"RNS-SC515\"]'),(3538,'inventory.source.items.cleanup','[\"RNS-SQR4545\"]'),(3539,'inventory.source.items.cleanup','[\"RNS-TR503\"]'),(3540,'inventory.source.items.cleanup','[\"RO-060-100\"]'),(3541,'inventory.source.items.cleanup','[\"RO-070-050\"]'),(3542,'inventory.source.items.cleanup','[\"RO-100-050\"]'),(3543,'inventory.source.items.cleanup','[\"RO-120-050\"]'),(3544,'inventory.source.items.cleanup','[\"RO-150-050\"]'),(3545,'inventory.source.items.cleanup','[\"RO-180-050\"]'),(3546,'inventory.source.items.cleanup','[\"RO-180-060\"]'),(3547,'inventory.source.items.cleanup','[\"RO-180-080\"]'),(3548,'inventory.source.items.cleanup','[\"ROFL-080-055\"]'),(3549,'inventory.source.items.cleanup','[\"ROFL-120-055\"]'),(3550,'inventory.source.items.cleanup','[\"ROFL-170-055\"]'),(3551,'inventory.source.items.cleanup','[\"ROFR-080-055\"]'),(3552,'inventory.source.items.cleanup','[\"ROFR-120-055 - ROFL-120-055\"]'),(3553,'inventory.source.items.cleanup','[\"ROFR-170-055\"]'),(3554,'inventory.source.items.cleanup','[\"ROH-059-100\"]'),(3555,'inventory.source.items.cleanup','[\"ROH-059-120\"]'),(3556,'inventory.source.items.cleanup','[\"ROH-059-140\"]'),(3557,'inventory.source.items.cleanup','[\"ROHD-059-060\"]'),(3558,'inventory.source.items.cleanup','[\"ROHD-059-080\"]'),(3559,'inventory.source.items.cleanup','[\"ROHD-059-100\"]'),(3560,'inventory.source.items.cleanup','[\"ROHD-059-120\"]'),(3561,'inventory.source.items.cleanup','[\"ROHL-059-060\"]'),(3562,'inventory.source.items.cleanup','[\"ROHL-059-080\"]'),(3563,'inventory.source.items.cleanup','[\"ROHL-059-100\"]'),(3564,'inventory.source.items.cleanup','[\"ROHL-059-120\"]'),(3565,'inventory.source.items.cleanup','[\"ROM-180-067\"]'),(3566,'inventory.source.items.cleanup','[\"ROV-180-029\"]'),(3567,'inventory.source.items.cleanup','[\"ROV-180-037\"]'),(3568,'inventory.source.items.cleanup','[\"ROV-180-044\"]'),(3569,'inventory.source.items.cleanup','[\"ROV-180-051\"]'),(3570,'inventory.source.items.cleanup','[\"ROV-180-059\"]'),(3571,'inventory.source.items.cleanup','[\"ROV-180-066\"]'),(3572,'inventory.source.items.cleanup','[\"ROVD-180-029\"]'),(3573,'inventory.source.items.cleanup','[\"ROVD-180-037\"]'),(3574,'inventory.source.items.cleanup','[\"ROVD-180-044\"]'),(3575,'inventory.source.items.cleanup','[\"ROVD-180-051\"]'),(3576,'inventory.source.items.cleanup','[\"ROVD-180-059\"]'),(3577,'inventory.source.items.cleanup','[\"ROVD-180-066\"]'),(3578,'inventory.source.items.cleanup','[\"RUM0400085002MRP\"]'),(3579,'inventory.source.items.cleanup','[\"RUM0400085002STP\"]'),(3580,'inventory.source.items.cleanup','[\"RUM0400130003MRP\"]'),(3581,'inventory.source.items.cleanup','[\"RUM0400130003STP\"]'),(3582,'inventory.source.items.cleanup','[\"RUM0400175004MRP\"]'),(3583,'inventory.source.items.cleanup','[\"RUM0400175004STP\"]'),(3584,'inventory.source.items.cleanup','[\"RV006\"]'),(3585,'inventory.source.items.cleanup','[\"RV007\"]'),(3586,'inventory.source.items.cleanup','[\"RV009\"]'),(3587,'inventory.source.items.cleanup','[\"SARP H\"]'),(3588,'inventory.source.items.cleanup','[\"SARP V\"]'),(3589,'inventory.source.items.cleanup','[\"Scalo Vertical\"]'),(3590,'inventory.source.items.cleanup','[\"Serena Designer Vertical\"]'),(3591,'inventory.source.items.cleanup','[\"Sesia Vertical\"]'),(3592,'inventory.source.items.cleanup','[\"Slimline Vertical Steel\"]'),(3593,'inventory.source.items.cleanup','[\"SNW0600060005STP\"]'),(3594,'inventory.source.items.cleanup','[\"SOH0500071506PLS\"]'),(3595,'inventory.source.items.cleanup','[\"SOH0500122511PLS\"]'),(3596,'inventory.source.items.cleanup','[\"SOH0500148013PLS\"]'),(3597,'inventory.source.items.cleanup','[\"SOH0500173515PLS\"]'),(3598,'inventory.source.items.cleanup','[\"SOHO\"]'),(3599,'inventory.source.items.cleanup','[\"SOM0415180010TXB\"]'),(3600,'inventory.source.items.cleanup','[\"SOM0415180010TXW\"]'),(3601,'inventory.source.items.cleanup','[\"SOP0331180008TXB\"]'),(3602,'inventory.source.items.cleanup','[\"SOP0331180008TXW\"]'),(3603,'inventory.source.items.cleanup','[\"SOP0415180010TXB\"]'),(3604,'inventory.source.items.cleanup','[\"SOP0415180010TXW\"]'),(3605,'inventory.source.items.cleanup','[\"SOP0499060012TXB\"]'),(3606,'inventory.source.items.cleanup','[\"SOP0499060012TXW\"]'),(3607,'inventory.source.items.cleanup','[\"SOP0667060016TXB\"]'),(3608,'inventory.source.items.cleanup','[\"SOP0667060016TXW\"]'),(3609,'inventory.source.items.cleanup','[\"SOP0835060020TXB\"]'),(3610,'inventory.source.items.cleanup','[\"SOP0835060020TXW\"]'),(3611,'inventory.source.items.cleanup','[\"Sophia Horizontal\"]'),(3612,'inventory.source.items.cleanup','[\"Sophia Vertical\"]'),(3613,'inventory.source.items.cleanup','[\"SRP0260180005MRP\"]'),(3614,'inventory.source.items.cleanup','[\"SRP0260180005STP\"]'),(3615,'inventory.source.items.cleanup','[\"SRP0370180007MRP\"]'),(3616,'inventory.source.items.cleanup','[\"SRP0370180007STP\"]'),(3617,'inventory.source.items.cleanup','[\"SRP0590060011MRP\"]'),(3618,'inventory.source.items.cleanup','[\"SRP0590060011STP\"]'),(3619,'inventory.source.items.cleanup','[\"SRP0810060015MRP\"]'),(3620,'inventory.source.items.cleanup','[\"SRP0810060015STP\"]'),(3621,'inventory.source.items.cleanup','[\"STEP\"]'),(3622,'inventory.source.items.cleanup','[\"Step Horizontal\"]'),(3623,'inventory.source.items.cleanup','[\"STGI-060-045\"]'),(3624,'inventory.source.items.cleanup','[\"STGI-060-100\"]'),(3625,'inventory.source.items.cleanup','[\"STGI-080-030\"]'),(3626,'inventory.source.items.cleanup','[\"STGI-080-045\"]'),(3627,'inventory.source.items.cleanup','[\"STGI-120-030\"]'),(3628,'inventory.source.items.cleanup','[\"STGI-120-045\"]'),(3629,'inventory.source.items.cleanup','[\"STGI-120-060\"]'),(3630,'inventory.source.items.cleanup','[\"STGI-170-045\"]'),(3631,'inventory.source.items.cleanup','[\"STM0375180004PLS\"]'),(3632,'inventory.source.items.cleanup','[\"STM0470180005PLS\"]'),(3633,'inventory.source.items.cleanup','[\"STNI-170-045\"]'),(3634,'inventory.source.items.cleanup','[\"STP0280180003TXW\"]'),(3635,'inventory.source.items.cleanup','[\"STP0375180004TXW\"]'),(3636,'inventory.source.items.cleanup','[\"STP0470060005TXW\"]'),(3637,'inventory.source.items.cleanup','[\"STP0470180005TXW\"]'),(3638,'inventory.source.items.cleanup','[\"STP0660060007TXW\"]'),(3639,'inventory.source.items.cleanup','[\"STP0850060009TXW\"]'),(3640,'inventory.source.items.cleanup','[\"STP1040060011TXW\"]'),(3641,'inventory.source.items.cleanup','[\"STP1230060013TXW\"]'),(3642,'inventory.source.items.cleanup','[\"SUB-060-045\"]'),(3643,'inventory.source.items.cleanup','[\"SUB-130-045\"]'),(3644,'inventory.source.items.cleanup','[\"SUB-130-060\"]'),(3645,'inventory.source.items.cleanup','[\"SUB-150-045\"]'),(3646,'inventory.source.items.cleanup','[\"SUB-150-060\"]'),(3647,'inventory.source.items.cleanup','[\"SUB-180-045\"]'),(3648,'inventory.source.items.cleanup','[\"SUB-180-060\"]'),(3649,'inventory.source.items.cleanup','[\"SUBC-130-045\"]'),(3650,'inventory.source.items.cleanup','[\"SUBC-130-060\"]'),(3651,'inventory.source.items.cleanup','[\"SUBC-150-045\"]'),(3652,'inventory.source.items.cleanup','[\"SUBC-180-045\"]'),(3653,'inventory.source.items.cleanup','[\"SUBC-180-060\"]'),(3654,'inventory.source.items.cleanup','[\"SUBI-060-045\"]'),(3655,'inventory.source.items.cleanup','[\"SUBI-130-045\"]'),(3656,'inventory.source.items.cleanup','[\"SUBI-130-060\"]'),(3657,'inventory.source.items.cleanup','[\"SUBI-150-045\"]'),(3658,'inventory.source.items.cleanup','[\"SUBI-150-060\"]'),(3659,'inventory.source.items.cleanup','[\"SUBI-180-060\"]'),(3660,'inventory.source.items.cleanup','[\"SXL1800033108TXB\"]'),(3661,'inventory.source.items.cleanup','[\"SXL1800033108TXW\"]'),(3662,'inventory.source.items.cleanup','[\"SXL1800041510TXB\"]'),(3663,'inventory.source.items.cleanup','[\"SXL1800041510TXW\"]'),(3664,'inventory.source.items.cleanup','[\"TAL0500078003MRP\"]'),(3665,'inventory.source.items.cleanup','[\"TAL0500078003STP\"]'),(3666,'inventory.source.items.cleanup','[\"TAL0500104004MRP\"]'),(3667,'inventory.source.items.cleanup','[\"TAL0500104004STP\"]'),(3668,'inventory.source.items.cleanup','[\"TAL0500130005MRP\"]'),(3669,'inventory.source.items.cleanup','[\"TAL0500130005STP\"]'),(3670,'inventory.source.items.cleanup','[\"TALENT\"]'),(3671,'inventory.source.items.cleanup','[\"Tallis Horizontal\"]'),(3672,'inventory.source.items.cleanup','[\"Tallis Vertical\"]'),(3673,'inventory.source.items.cleanup','[\"TBA404\"]'),(3674,'inventory.source.items.cleanup','[\"TLD0350180006TXB\"]'),(3675,'inventory.source.items.cleanup','[\"TLD0350180006TXW\"]'),(3676,'inventory.source.items.cleanup','[\"TLD0470180008TXB\"]'),(3677,'inventory.source.items.cleanup','[\"TLD0470180008TXW\"]'),(3678,'inventory.source.items.cleanup','[\"TLD0710060012TXB\"]'),(3679,'inventory.source.items.cleanup','[\"TLD0710060012TXW\"]'),(3680,'inventory.source.items.cleanup','[\"TLD0950060016TXB\"]'),(3681,'inventory.source.items.cleanup','[\"TLD0950060016TXW\"]'),(3682,'inventory.source.items.cleanup','[\"TLD1190060020TXB\"]'),(3683,'inventory.source.items.cleanup','[\"TLD1190060020TXW\"]'),(3684,'inventory.source.items.cleanup','[\"TLL0350180006TXB\"]'),(3685,'inventory.source.items.cleanup','[\"TLL0350180006TXW\"]'),(3686,'inventory.source.items.cleanup','[\"TLL0470180008TXB\"]'),(3687,'inventory.source.items.cleanup','[\"TLL0470180008TXW\"]'),(3688,'inventory.source.items.cleanup','[\"TLL0710060012TXB\"]'),(3689,'inventory.source.items.cleanup','[\"TLL0710060012TXW\"]'),(3690,'inventory.source.items.cleanup','[\"TLL0950060016TXB\"]'),(3691,'inventory.source.items.cleanup','[\"TLL0950060016TXW\"]'),(3692,'inventory.source.items.cleanup','[\"TLL1190060020TXB\"]'),(3693,'inventory.source.items.cleanup','[\"TLL1190060020TXW\"]'),(3694,'inventory.source.items.cleanup','[\"TXD1800035006TXW\"]'),(3695,'inventory.source.items.cleanup','[\"TXD1800047008TXW\"]'),(3696,'inventory.source.items.cleanup','[\"TXL1800035006TXW\"]'),(3697,'inventory.source.items.cleanup','[\"TXL1800047008TXW\"]'),(3698,'inventory.source.items.cleanup','[\"Vasto Vertical\"]'),(3699,'inventory.source.items.cleanup','[\"VCT0500095005CHR\"]'),(3700,'inventory.source.items.cleanup','[\"VCT0500134007CHR\"]'),(3701,'inventory.source.items.cleanup','[\"VER0370100008MRP\"]'),(3702,'inventory.source.items.cleanup','[\"VER0370100008STP\"]'),(3703,'inventory.source.items.cleanup','[\"VER0370150008MRP\"]'),(3704,'inventory.source.items.cleanup','[\"VER0370150008STP\"]'),(3705,'inventory.source.items.cleanup','[\"VER0370180008MRP\"]'),(3706,'inventory.source.items.cleanup','[\"VER0370180008STP\"]'),(3707,'inventory.source.items.cleanup','[\"VER0370200008MRP\"]'),(3708,'inventory.source.items.cleanup','[\"VER0370200008STP\"]'),(3709,'inventory.source.items.cleanup','[\"VES0295180004TXB\"]'),(3710,'inventory.source.items.cleanup','[\"VES0295180004TXW\"]'),(3711,'inventory.source.items.cleanup','[\"VES0370180005TXB\"]'),(3712,'inventory.source.items.cleanup','[\"VES0370180005TXW\"]'),(3713,'inventory.source.items.cleanup','[\"VES0445180006TXB\"]'),(3714,'inventory.source.items.cleanup','[\"VES0445180006TXW\"]'),(3715,'inventory.source.items.cleanup','[\"VES0745060010TXB\"]'),(3716,'inventory.source.items.cleanup','[\"VES0745060010TXW\"]'),(3717,'inventory.source.items.cleanup','[\"VES0895060012TXB\"]'),(3718,'inventory.source.items.cleanup','[\"VES0895060012TXW\"]'),(3719,'inventory.source.items.cleanup','[\"VES1045060014TXB\"]'),(3720,'inventory.source.items.cleanup','[\"VES1045060014TXW\"]'),(3721,'inventory.source.items.cleanup','[\"VESTA H\"]'),(3722,'inventory.source.items.cleanup','[\"VESTA V\"]'),(3723,'inventory.source.items.cleanup','[\"Victoria\"]'),(3724,'inventory.source.items.cleanup','[\"VIV0500100007\"]'),(3725,'inventory.source.items.cleanup','[\"VLV-BRT\\/A VLV-BRT\\/S\"]'),(3726,'inventory.source.items.cleanup','[\"VLV-CRVA\"]'),(3727,'inventory.source.items.cleanup','[\"VLV-LGEAA VLV-LGEAS\"]'),(3728,'inventory.source.items.cleanup','[\"VLV-LGEB\"]'),(3729,'inventory.source.items.cleanup','[\"VLV-LGECA VLV-LGECS\"]'),(3730,'inventory.source.items.cleanup','[\"VLV-PRT\\/A VLV-PRT\\/S\"]'),(3731,'inventory.source.items.cleanup','[\"VLV-PRT\\/AA VLV-PRT\\/SA\"]'),(3732,'inventory.source.items.cleanup','[\"VLV-PRT\\/AB VLV-PRT\\/SB\"]'),(3733,'inventory.source.items.cleanup','[\"VLV-PRT\\/AW VLV-PRT\\/SW\"]'),(3734,'inventory.source.items.cleanup','[\"VTG0650065003CHR\"]'),(3735,'inventory.source.items.cleanup','[\"VTG0650080008CHR\"]'),(3736,'inventory.source.items.cleanup','[\"YA-090-050\"]'),(3737,'inventory.source.items.cleanup','[\"YA-130-040\"]'),(3738,'inventory.source.items.cleanup','[\"YA-130-050\"]'),(3739,'inventory.source.items.cleanup','[\"YA-130-060\"]'),(3740,'inventory.source.items.cleanup','[\"YA-170-040\"]'),(3741,'inventory.source.items.cleanup','[\"YA-170-050\"]'),(3742,'inventory.source.items.cleanup','[\"YA-170-060\"]'),(3743,'inventory.source.items.cleanup','[\"YAC-090-050\"]'),(3744,'inventory.source.items.cleanup','[\"YAC-130-040\"]'),(3745,'inventory.source.items.cleanup','[\"YAC-130-050\"]'),(3746,'inventory.source.items.cleanup','[\"YAC-130-060\"]'),(3747,'inventory.source.items.cleanup','[\"YAC-170-040\"]'),(3748,'inventory.source.items.cleanup','[\"YAC-170-050\"]'),(3749,'inventory.source.items.cleanup','[\"YAC-170-060\"]'),(3750,'inventory.source.items.cleanup','[\"YAD-130-060\"]'),(3751,'inventory.source.items.cleanup','[\"ZA-048-040\"]'),(3752,'inventory.source.items.cleanup','[\"ZA-080-050\"]'),(3753,'inventory.source.items.cleanup','[\"ZA-120-050\"]'),(3754,'inventory.source.items.cleanup','[\"ZA-120-060\"]'),(3755,'inventory.source.items.cleanup','[\"ZA-150-040\"]'),(3756,'inventory.source.items.cleanup','[\"ZA-150-050\"]'),(3757,'inventory.source.items.cleanup','[\"ZA-180-050\"]'),(3758,'inventory.source.items.cleanup','[\"ZAD-150-050\"]'),(3759,'inventory.source.items.cleanup','[\"ZAD-180-050\"]'),(3760,'inventory.source.items.cleanup','[\"ZAD-180-060\"]'),(3761,'inventory.source.items.cleanup','[\"ZAHD-061-140\"]'),(3762,'inventory.source.items.cleanup','[\"ZAV-180-061\"]'),(3763,'inventory.source.items.cleanup','[\"Zehnder Kleo\"]'),(3764,'inventory.source.items.cleanup','[\"Zehnder Ribbon\"]'),(3765,'inventory.source.items.cleanup','[\"05347A1\"]'),(3766,'inventory.source.items.cleanup','[\"05956D7\"]'),(3767,'inventory.source.items.cleanup','[\"100\\/150mm\"]'),(3768,'inventory.source.items.cleanup','[\"103772\"]'),(3769,'inventory.source.items.cleanup','[\"109104\"]'),(3770,'inventory.source.items.cleanup','[\"109105\"]'),(3771,'inventory.source.items.cleanup','[\"10912\"]'),(3772,'inventory.source.items.cleanup','[\"109132\"]'),(3773,'inventory.source.items.cleanup','[\"109136\"]'),(3774,'inventory.source.items.cleanup','[\"10965\"]'),(3775,'inventory.source.items.cleanup','[\"109655\"]'),(3776,'inventory.source.items.cleanup','[\"109657\"]'),(3777,'inventory.source.items.cleanup','[\"109659\"]'),(3778,'inventory.source.items.cleanup','[\"109665\"]'),(3779,'inventory.source.items.cleanup','[\"109672\"]'),(3780,'inventory.source.items.cleanup','[\"109702CP\"]'),(3781,'inventory.source.items.cleanup','[\"109705BB\"]'),(3782,'inventory.source.items.cleanup','[\"10971\"]'),(3783,'inventory.source.items.cleanup','[\"109723BB\"]'),(3784,'inventory.source.items.cleanup','[\"109727BS\"]'),(3785,'inventory.source.items.cleanup','[\"109736\"]'),(3786,'inventory.source.items.cleanup','[\"109737\"]'),(3787,'inventory.source.items.cleanup','[\"109738BK\"]'),(3788,'inventory.source.items.cleanup','[\"10975\"]'),(3789,'inventory.source.items.cleanup','[\"109752\"]'),(3790,'inventory.source.items.cleanup','[\"109754\"]'),(3791,'inventory.source.items.cleanup','[\"10976\"]'),(3792,'inventory.source.items.cleanup','[\"10976 HE\"]'),(3793,'inventory.source.items.cleanup','[\"109764\"]'),(3794,'inventory.source.items.cleanup','[\"109767\"]'),(3795,'inventory.source.items.cleanup','[\"10977\"]'),(3796,'inventory.source.items.cleanup','[\"109773\"]'),(3797,'inventory.source.items.cleanup','[\"109779\"]'),(3798,'inventory.source.items.cleanup','[\"109780\"]'),(3799,'inventory.source.items.cleanup','[\"109781\"]'),(3800,'inventory.source.items.cleanup','[\"109947BC\"]'),(3801,'inventory.source.items.cleanup','[\"11000\"]'),(3802,'inventory.source.items.cleanup','[\"110000\"]'),(3803,'inventory.source.items.cleanup','[\"110001\"]'),(3804,'inventory.source.items.cleanup','[\"110002\"]'),(3805,'inventory.source.items.cleanup','[\"110003BS\"]'),(3806,'inventory.source.items.cleanup','[\"110005SR\"]'),(3807,'inventory.source.items.cleanup','[\"11001\"]'),(3808,'inventory.source.items.cleanup','[\"110010\"]'),(3809,'inventory.source.items.cleanup','[\"110012\"]'),(3810,'inventory.source.items.cleanup','[\"110015\"]'),(3811,'inventory.source.items.cleanup','[\"110017BS\"]'),(3812,'inventory.source.items.cleanup','[\"110018SR\"]'),(3813,'inventory.source.items.cleanup','[\"110028\"]'),(3814,'inventory.source.items.cleanup','[\"11003\"]'),(3815,'inventory.source.items.cleanup','[\"11003 HE\"]'),(3816,'inventory.source.items.cleanup','[\"130\\/200mm\"]'),(3817,'inventory.source.items.cleanup','[\"142942\"]'),(3818,'inventory.source.items.cleanup','[\"14294201\"]'),(3819,'inventory.source.items.cleanup','[\"14300501\"]'),(3820,'inventory.source.items.cleanup','[\"14300601\"]'),(3821,'inventory.source.items.cleanup','[\"14300701\"]'),(3822,'inventory.source.items.cleanup','[\"143356\"]'),(3823,'inventory.source.items.cleanup','[\"143395WT\"]'),(3824,'inventory.source.items.cleanup','[\"143411BK\"]'),(3825,'inventory.source.items.cleanup','[\"14343101\"]'),(3826,'inventory.source.items.cleanup','[\"22069\"]'),(3827,'inventory.source.items.cleanup','[\"22351\"]'),(3828,'inventory.source.items.cleanup','[\"22392\"]'),(3829,'inventory.source.items.cleanup','[\"22401\"]'),(3830,'inventory.source.items.cleanup','[\"22432\"]'),(3831,'inventory.source.items.cleanup','[\"22651\"]'),(3832,'inventory.source.items.cleanup','[\"22653\"]'),(3833,'inventory.source.items.cleanup','[\"22989\"]'),(3834,'inventory.source.items.cleanup','[\"234-872 Designio2\"]'),(3835,'inventory.source.items.cleanup','[\"234-872 Evoke Glass\"]'),(3836,'inventory.source.items.cleanup','[\"234-872 Verve XS\"]'),(3837,'inventory.source.items.cleanup','[\"240 e\"]'),(3838,'inventory.source.items.cleanup','[\"24031\"]'),(3839,'inventory.source.items.cleanup','[\"24087\"]'),(3840,'inventory.source.items.cleanup','[\"24088\"]'),(3841,'inventory.source.items.cleanup','[\"24089\"]'),(3842,'inventory.source.items.cleanup','[\"24090\"]'),(3843,'inventory.source.items.cleanup','[\"24092\"]'),(3844,'inventory.source.items.cleanup','[\"24093\"]'),(3845,'inventory.source.items.cleanup','[\"24097\"]'),(3846,'inventory.source.items.cleanup','[\"24102\"]'),(3847,'inventory.source.items.cleanup','[\"24103\"]'),(3848,'inventory.source.items.cleanup','[\"24104\"]'),(3849,'inventory.source.items.cleanup','[\"24105\"]'),(3850,'inventory.source.items.cleanup','[\"24106\"]'),(3851,'inventory.source.items.cleanup','[\"24107\"]'),(3852,'inventory.source.items.cleanup','[\"24109\"]'),(3853,'inventory.source.items.cleanup','[\"24135\"]'),(3854,'inventory.source.items.cleanup','[\"24136\"]'),(3855,'inventory.source.items.cleanup','[\"24145\"]'),(3856,'inventory.source.items.cleanup','[\"24147\"]'),(3857,'inventory.source.items.cleanup','[\"24148\"]'),(3858,'inventory.source.items.cleanup','[\"24150\"]'),(3859,'inventory.source.items.cleanup','[\"24152\"]'),(3860,'inventory.source.items.cleanup','[\"24153\"]'),(3861,'inventory.source.items.cleanup','[\"24155\"]'),(3862,'inventory.source.items.cleanup','[\"24158\"]'),(3863,'inventory.source.items.cleanup','[\"24159\"]'),(3864,'inventory.source.items.cleanup','[\"24162\"]'),(3865,'inventory.source.items.cleanup','[\"24163\"]'),(3866,'inventory.source.items.cleanup','[\"24166\"]'),(3867,'inventory.source.items.cleanup','[\"24167\"]'),(3868,'inventory.source.items.cleanup','[\"24176\"]'),(3869,'inventory.source.items.cleanup','[\"24180\"]'),(3870,'inventory.source.items.cleanup','[\"24181\"]'),(3871,'inventory.source.items.cleanup','[\"24189\"]'),(3872,'inventory.source.items.cleanup','[\"24190\"]'),(3873,'inventory.source.items.cleanup','[\"24354\"]'),(3874,'inventory.source.items.cleanup','[\"26271\"]'),(3875,'inventory.source.items.cleanup','[\"26280\"]'),(3876,'inventory.source.items.cleanup','[\"26438\"]'),(3877,'inventory.source.items.cleanup','[\"533901\"]'),(3878,'inventory.source.items.cleanup','[\"534101\"]'),(3879,'inventory.source.items.cleanup','[\"534701\"]'),(3880,'inventory.source.items.cleanup','[\"534771\"]'),(3881,'inventory.source.items.cleanup','[\"534781\"]'),(3882,'inventory.source.items.cleanup','[\"576161\"]'),(3883,'inventory.source.items.cleanup','[\"595603\"]'),(3884,'inventory.source.items.cleanup','[\"595661\"]'),(3885,'inventory.source.items.cleanup','[\"6010-BA 6010-BO\"]'),(3886,'inventory.source.items.cleanup','[\"62851\"]'),(3887,'inventory.source.items.cleanup','[\"62852\"]'),(3888,'inventory.source.items.cleanup','[\"62853\"]'),(3889,'inventory.source.items.cleanup','[\"62854\"]'),(3890,'inventory.source.items.cleanup','[\"62855\"]'),(3891,'inventory.source.items.cleanup','[\"62858\"]'),(3892,'inventory.source.items.cleanup','[\"62948\"]'),(3893,'inventory.source.items.cleanup','[\"634-808\"]'),(3894,'inventory.source.items.cleanup','[\"634-846\"]'),(3895,'inventory.source.items.cleanup','[\"634-889\"]'),(3896,'inventory.source.items.cleanup','[\"85026\"]'),(3897,'inventory.source.items.cleanup','[\"8508\"]'),(3898,'inventory.source.items.cleanup','[\"8524\"]'),(3899,'inventory.source.items.cleanup','[\"8526\"]'),(3900,'inventory.source.items.cleanup','[\"8529\"]'),(3901,'inventory.source.items.cleanup','[\"928-315\"]'),(3902,'inventory.source.items.cleanup','[\"999-003\"]'),(3903,'inventory.source.items.cleanup','[\"999-016\"]'),(3904,'inventory.source.items.cleanup','[\"999-062\"]'),(3905,'inventory.source.items.cleanup','[\"999-072\"]'),(3906,'inventory.source.items.cleanup','[\"999-105\"]'),(3907,'inventory.source.items.cleanup','[\"999-130\"]'),(3908,'inventory.source.items.cleanup','[\"999-201\"]'),(3909,'inventory.source.items.cleanup','[\"999-235\"]'),(3910,'inventory.source.items.cleanup','[\"Aaren\"]'),(3911,'inventory.source.items.cleanup','[\"Ah-4S\"]'),(3912,'inventory.source.items.cleanup','[\"Alente\"]'),(3913,'inventory.source.items.cleanup','[\"Alisio\"]'),(3914,'inventory.source.items.cleanup','[\"Alisio 1150\"]'),(3915,'inventory.source.items.cleanup','[\"Alisio 1550\"]'),(3916,'inventory.source.items.cleanup','[\"Alisio 1850\"]'),(3917,'inventory.source.items.cleanup','[\"Alisio 850\"]'),(3918,'inventory.source.items.cleanup','[\"ALM20E\"]'),(3919,'inventory.source.items.cleanup','[\"AMATHUS\"]'),(3920,'inventory.source.items.cleanup','[\"Ambiente A8 Tunnel\"]'),(3921,'inventory.source.items.cleanup','[\"Architect Series\"]'),(3922,'inventory.source.items.cleanup','[\"Arlo 16\"]'),(3923,'inventory.source.items.cleanup','[\"Arlo 22\"]'),(3924,'inventory.source.items.cleanup','[\"ART20\"]'),(3925,'inventory.source.items.cleanup','[\"Arte 3RL-100h\"]'),(3926,'inventory.source.items.cleanup','[\"Arte 3RL-60h\"]'),(3927,'inventory.source.items.cleanup','[\"Arte 3RL-80h\"]'),(3928,'inventory.source.items.cleanup','[\"Arte Bh\"]'),(3929,'inventory.source.items.cleanup','[\"Arte U70h\"]'),(3930,'inventory.source.items.cleanup','[\"Arte U90h\"]'),(3931,'inventory.source.items.cleanup','[\"Asta\"]'),(3932,'inventory.source.items.cleanup','[\"Aste 5 Low EA\"]'),(3933,'inventory.source.items.cleanup','[\"Attora\"]'),(3934,'inventory.source.items.cleanup','[\"AUB20\"]'),(3935,'inventory.source.items.cleanup','[\"Aubade 600\"]'),(3936,'inventory.source.items.cleanup','[\"Avesta\"]'),(3937,'inventory.source.items.cleanup','[\"Balanced Flue Kit\"]'),(3938,'inventory.source.items.cleanup','[\"Banff 3\"]'),(3939,'inventory.source.items.cleanup','[\"BCH20\"]'),(3940,'inventory.source.items.cleanup','[\"Bend 45\"]'),(3941,'inventory.source.items.cleanup','[\"Bergen\"]'),(3942,'inventory.source.items.cleanup','[\"Bh-4S\"]'),(3943,'inventory.source.items.cleanup','[\"Bidore 100\"]'),(3944,'inventory.source.items.cleanup','[\"Bidore 140\"]'),(3945,'inventory.source.items.cleanup','[\"Bidore 240H\"]'),(3946,'inventory.source.items.cleanup','[\"Black Huntingdon 20 BF\"]'),(3947,'inventory.source.items.cleanup','[\"Black Huntingdon 20 CF\"]'),(3948,'inventory.source.items.cleanup','[\"Black Huntingdon 40 BF\"]'),(3949,'inventory.source.items.cleanup','[\"Black Huntingdon 40 CF\"]'),(3950,'inventory.source.items.cleanup','[\"Bonham 10\"]'),(3951,'inventory.source.items.cleanup','[\"Bonham 7\"]'),(3952,'inventory.source.items.cleanup','[\"Bonham 9\"]'),(3953,'inventory.source.items.cleanup','[\"Bora Corner\"]'),(3954,'inventory.source.items.cleanup','[\"Braemar\"]'),(3955,'inventory.source.items.cleanup','[\"BRG20\"]'),(3956,'inventory.source.items.cleanup','[\"Broadway\"]'),(3957,'inventory.source.items.cleanup','[\"BROOKLYN\"]'),(3958,'inventory.source.items.cleanup','[\"Canto 200\"]'),(3959,'inventory.source.items.cleanup','[\"Caress Contemporary\"]'),(3960,'inventory.source.items.cleanup','[\"Carron 5\\\" 135 Deg\"]'),(3961,'inventory.source.items.cleanup','[\"Carron 5\\\" 600mm Without Sweeping Access\"]'),(3962,'inventory.source.items.cleanup','[\"Carron 5\\\" 900mm Without Sweeping Access\"]'),(3963,'inventory.source.items.cleanup','[\"CAS1000\"]'),(3964,'inventory.source.items.cleanup','[\"CAS400NH\"]'),(3965,'inventory.source.items.cleanup','[\"CAS500\"]'),(3966,'inventory.source.items.cleanup','[\"Cassette 600\"]'),(3967,'inventory.source.items.cleanup','[\"CDW15XHD\"]'),(3968,'inventory.source.items.cleanup','[\"Circo\"]'),(3969,'inventory.source.items.cleanup','[\"CISCO 22\"]'),(3970,'inventory.source.items.cleanup','[\"CISCO EXTREME 16\"]'),(3971,'inventory.source.items.cleanup','[\"CISCO EXTREME 22\"]'),(3972,'inventory.source.items.cleanup','[\"CISCO-16\"]'),(3973,'inventory.source.items.cleanup','[\"Club 100 e\"]'),(3974,'inventory.source.items.cleanup','[\"Club 140 3\\/S\"]'),(3975,'inventory.source.items.cleanup','[\"Club 140 C\"]'),(3976,'inventory.source.items.cleanup','[\"Club 140 F\"]'),(3977,'inventory.source.items.cleanup','[\"Club 140 RD\"]'),(3978,'inventory.source.items.cleanup','[\"Club 140 T\"]'),(3979,'inventory.source.items.cleanup','[\"Club 150 e\"]'),(3980,'inventory.source.items.cleanup','[\"Club 180 e\"]'),(3981,'inventory.source.items.cleanup','[\"Club 240 C\"]'),(3982,'inventory.source.items.cleanup','[\"Club 240 e\"]'),(3983,'inventory.source.items.cleanup','[\"Club 240 F\"]'),(3984,'inventory.source.items.cleanup','[\"Club 240 RD\"]'),(3985,'inventory.source.items.cleanup','[\"Club 240 T\"]'),(3986,'inventory.source.items.cleanup','[\"Club 80H e\"]'),(3987,'inventory.source.items.cleanup','[\"Club Kudos e\"]'),(3988,'inventory.source.items.cleanup','[\"Club Ovation e\"]'),(3989,'inventory.source.items.cleanup','[\"Compton 1000\"]'),(3990,'inventory.source.items.cleanup','[\"Compton 2\"]'),(3991,'inventory.source.items.cleanup','[\"Cosmo\"]'),(3992,'inventory.source.items.cleanup','[\"Cosmo Tunnel\"]'),(3993,'inventory.source.items.cleanup','[\"Creative 1000 SL\"]'),(3994,'inventory.source.items.cleanup','[\"Creative 1030\"]'),(3995,'inventory.source.items.cleanup','[\"Creative 1030 DS\"]'),(3996,'inventory.source.items.cleanup','[\"Creative 1250\"]'),(3997,'inventory.source.items.cleanup','[\"Creative 1250 SL\"]'),(3998,'inventory.source.items.cleanup','[\"Creative 1250 XT\"]'),(3999,'inventory.source.items.cleanup','[\"Creative 1500\"]'),(4000,'inventory.source.items.cleanup','[\"Creative 1500 SL\"]'),(4001,'inventory.source.items.cleanup','[\"Creative 1500 XT\"]'),(4002,'inventory.source.items.cleanup','[\"Creative 1800\"]'),(4003,'inventory.source.items.cleanup','[\"Creative 1800 XT\"]'),(4004,'inventory.source.items.cleanup','[\"Creative 2400\"]'),(4005,'inventory.source.items.cleanup','[\"Creative 500\"]'),(4006,'inventory.source.items.cleanup','[\"Creative 600 SL\"]'),(4007,'inventory.source.items.cleanup','[\"Creative 650\"]'),(4008,'inventory.source.items.cleanup','[\"Creative 700 SL\"]'),(4009,'inventory.source.items.cleanup','[\"Creative 750\"]'),(4010,'inventory.source.items.cleanup','[\"Creative 800\"]'),(4011,'inventory.source.items.cleanup','[\"Creative 810 DS\"]'),(4012,'inventory.source.items.cleanup','[\"Crenshaw\"]'),(4013,'inventory.source.items.cleanup','[\"CRS20\"]'),(4014,'inventory.source.items.cleanup','[\"Cubo L\"]'),(4015,'inventory.source.items.cleanup','[\"Cubo S\"]'),(4016,'inventory.source.items.cleanup','[\"Cupido 50\"]'),(4017,'inventory.source.items.cleanup','[\"Cupido 60 CF\"]'),(4018,'inventory.source.items.cleanup','[\"Cupido 70\"]'),(4019,'inventory.source.items.cleanup','[\"Cupido 70 CF\"]'),(4020,'inventory.source.items.cleanup','[\"CVL20N\"]'),(4021,'inventory.source.items.cleanup','[\"Detroit\"]'),(4022,'inventory.source.items.cleanup','[\"Diablo Next\"]'),(4023,'inventory.source.items.cleanup','[\"Dik Geurts Folke\"]'),(4024,'inventory.source.items.cleanup','[\"DNV20\"]'),(4025,'inventory.source.items.cleanup','[\"Dream S\\/Line\"]'),(4026,'inventory.source.items.cleanup','[\"Dream Slimline\"]'),(4027,'inventory.source.items.cleanup','[\"DRU 44MF\"]'),(4028,'inventory.source.items.cleanup','[\"DRU 55CB\"]'),(4029,'inventory.source.items.cleanup','[\"DRU 64CB\"]'),(4030,'inventory.source.items.cleanup','[\"DRU 78CB\"]'),(4031,'inventory.source.items.cleanup','[\"DRU Maestro 60\\/2 Eco\"]'),(4032,'inventory.source.items.cleanup','[\"DRU Maestro 60\\/3 Eco\"]'),(4033,'inventory.source.items.cleanup','[\"DRU Maestro 60\\/3 Module\"]'),(4034,'inventory.source.items.cleanup','[\"Dru Maestro 75 Tall\"]'),(4035,'inventory.source.items.cleanup','[\"DRU Maestro 75 Tall Tunnel\"]'),(4036,'inventory.source.items.cleanup','[\"DRU Virtuo 75\"]'),(4037,'inventory.source.items.cleanup','[\"DRU Virtuo 80\\/2\"]'),(4038,'inventory.source.items.cleanup','[\"DRU Virtuo 80\\/3\"]'),(4039,'inventory.source.items.cleanup','[\"Dumfries\"]'),(4040,'inventory.source.items.cleanup','[\"e1000\"]'),(4041,'inventory.source.items.cleanup','[\"e1000gf\"]'),(4042,'inventory.source.items.cleanup','[\"e1030\"]'),(4043,'inventory.source.items.cleanup','[\"e1030ds\"]'),(4044,'inventory.source.items.cleanup','[\"E1250\"]'),(4045,'inventory.source.items.cleanup','[\"e1500\"]'),(4046,'inventory.source.items.cleanup','[\"e1560\"]'),(4047,'inventory.source.items.cleanup','[\"e1800\"]'),(4048,'inventory.source.items.cleanup','[\"E2400\"]'),(4049,'inventory.source.items.cleanup','[\"e500\"]'),(4050,'inventory.source.items.cleanup','[\"e600\"]'),(4051,'inventory.source.items.cleanup','[\"e600gf\"]'),(4052,'inventory.source.items.cleanup','[\"E630\"]'),(4053,'inventory.source.items.cleanup','[\"e640gf\"]'),(4054,'inventory.source.items.cleanup','[\"e700\"]'),(4055,'inventory.source.items.cleanup','[\"e700gf\"]'),(4056,'inventory.source.items.cleanup','[\"e710\"]'),(4057,'inventory.source.items.cleanup','[\"E730\"]'),(4058,'inventory.source.items.cleanup','[\"e800\"]'),(4059,'inventory.source.items.cleanup','[\"e810\"]'),(4060,'inventory.source.items.cleanup','[\"E810DS\"]'),(4061,'inventory.source.items.cleanup','[\"e900gf\"]'),(4062,'inventory.source.items.cleanup','[\"eko 1011\"]'),(4063,'inventory.source.items.cleanup','[\"eko 1060\"]'),(4064,'inventory.source.items.cleanup','[\"Eko 1070\"]'),(4065,'inventory.source.items.cleanup','[\"Eko 1080\"]'),(4066,'inventory.source.items.cleanup','[\"eko 1090\"]'),(4067,'inventory.source.items.cleanup','[\"eko 1110\"]'),(4068,'inventory.source.items.cleanup','[\"Eko 1120\"]'),(4069,'inventory.source.items.cleanup','[\"eko 1190\"]'),(4070,'inventory.source.items.cleanup','[\"eko 1200\"]'),(4071,'inventory.source.items.cleanup','[\"eko 3010\"]'),(4072,'inventory.source.items.cleanup','[\"eko 3015 Fingerslide\"]'),(4073,'inventory.source.items.cleanup','[\"eko 3020\"]'),(4074,'inventory.source.items.cleanup','[\"eko 3025 Fingerslide\"]'),(4075,'inventory.source.items.cleanup','[\"eko 3030\"]'),(4076,'inventory.source.items.cleanup','[\"eko 3035 Fingerslide\"]'),(4077,'inventory.source.items.cleanup','[\"eko 3040\"]'),(4078,'inventory.source.items.cleanup','[\"eko 3060\"]'),(4079,'inventory.source.items.cleanup','[\"eko 3065 Fingerslide\"]'),(4080,'inventory.source.items.cleanup','[\"eko 3080\"]'),(4081,'inventory.source.items.cleanup','[\"eko 3085 Fingerslide\"]'),(4082,'inventory.source.items.cleanup','[\"eko 4010\"]'),(4083,'inventory.source.items.cleanup','[\"eko 4015 Fingerslide\"]'),(4084,'inventory.source.items.cleanup','[\"eko 5060\"]'),(4085,'inventory.source.items.cleanup','[\"eko 5070\"]'),(4086,'inventory.source.items.cleanup','[\"eko 5090\"]'),(4087,'inventory.source.items.cleanup','[\"eko 5510\"]'),(4088,'inventory.source.items.cleanup','[\"Ellipse\"]'),(4089,'inventory.source.items.cleanup','[\"Ellister\"]'),(4090,'inventory.source.items.cleanup','[\"Elore\"]'),(4091,'inventory.source.items.cleanup','[\"Emberglow\"]'),(4092,'inventory.source.items.cleanup','[\"Empire 2\"]'),(4093,'inventory.source.items.cleanup','[\"Ennio\"]'),(4094,'inventory.source.items.cleanup','[\"Espire 150\"]'),(4095,'inventory.source.items.cleanup','[\"EV4i\"]'),(4096,'inventory.source.items.cleanup','[\"EV4i4\"]'),(4097,'inventory.source.items.cleanup','[\"EV6i\"]'),(4098,'inventory.source.items.cleanup','[\"EV6i4\"]'),(4099,'inventory.source.items.cleanup','[\"EV8s\"]'),(4100,'inventory.source.items.cleanup','[\"Evonic Colorado\"]'),(4101,'inventory.source.items.cleanup','[\"Evonic Nebraska\"]'),(4102,'inventory.source.items.cleanup','[\"Excelsior High Efficiency\"]'),(4103,'inventory.source.items.cleanup','[\"Excelsior Slimline\"]'),(4104,'inventory.source.items.cleanup','[\"Exo 1000\"]'),(4105,'inventory.source.items.cleanup','[\"Exo 1500\"]'),(4106,'inventory.source.items.cleanup','[\"Exor\"]'),(4107,'inventory.source.items.cleanup','[\"Floor Plate\"]'),(4108,'inventory.source.items.cleanup','[\"Flue Elbows\"]'),(4109,'inventory.source.items.cleanup','[\"Fuora Q\"]'),(4110,'inventory.source.items.cleanup','[\"Fuora R\"]'),(4111,'inventory.source.items.cleanup','[\"Galileo\"]'),(4112,'inventory.source.items.cleanup','[\"Gazco Huntingdon 30\"]'),(4113,'inventory.source.items.cleanup','[\"Gazco Huntingdon 40\"]'),(4114,'inventory.source.items.cleanup','[\"Gazco Kit\"]'),(4115,'inventory.source.items.cleanup','[\"Gazco Riva2 400\"]'),(4116,'inventory.source.items.cleanup','[\"Gazco Riva2 500HL\"]'),(4117,'inventory.source.items.cleanup','[\"Gazco Riva2 600 \\/ BF\"]'),(4118,'inventory.source.items.cleanup','[\"Gazco Riva2 600 \\/ CF\"]'),(4119,'inventory.source.items.cleanup','[\"Gazco Riva2 600HL\"]'),(4120,'inventory.source.items.cleanup','[\"Gazco Stockton\"]'),(4121,'inventory.source.items.cleanup','[\"Gilmour 10\"]'),(4122,'inventory.source.items.cleanup','[\"Gilmour 6\"]'),(4123,'inventory.source.items.cleanup','[\"Gilmour 7\"]'),(4124,'inventory.source.items.cleanup','[\"Gilmour 9\"]'),(4125,'inventory.source.items.cleanup','[\"Glazer 1000\"]'),(4126,'inventory.source.items.cleanup','[\"Glazer 1300\"]'),(4127,'inventory.source.items.cleanup','[\"Glazer 1500\"]'),(4128,'inventory.source.items.cleanup','[\"Glazer 1800\"]'),(4129,'inventory.source.items.cleanup','[\"Glencoe\"]'),(4130,'inventory.source.items.cleanup','[\"Global 100 BF\"]'),(4131,'inventory.source.items.cleanup','[\"Global 100 Corner BF\"]'),(4132,'inventory.source.items.cleanup','[\"Global 100 Triple\"]'),(4133,'inventory.source.items.cleanup','[\"Global 120 BF\"]'),(4134,'inventory.source.items.cleanup','[\"Global 120 Corner BF\"]'),(4135,'inventory.source.items.cleanup','[\"Global 120 Triple\"]'),(4136,'inventory.source.items.cleanup','[\"Global 55XT BF\"]'),(4137,'inventory.source.items.cleanup','[\"Global 55XT Cavity BF\"]'),(4138,'inventory.source.items.cleanup','[\"Global 55XT CF-01\"]'),(4139,'inventory.source.items.cleanup','[\"Global 60 Corner\"]'),(4140,'inventory.source.items.cleanup','[\"Global 70XT BF-01\"]'),(4141,'inventory.source.items.cleanup','[\"Global 70XT CF\"]'),(4142,'inventory.source.items.cleanup','[\"Gotham 1300\"]'),(4143,'inventory.source.items.cleanup','[\"Gotham 600\"]'),(4144,'inventory.source.items.cleanup','[\"Gotham 750S\"]'),(4145,'inventory.source.items.cleanup','[\"Gotham 750T\"]'),(4146,'inventory.source.items.cleanup','[\"GOTHAM 900\"]'),(4147,'inventory.source.items.cleanup','[\"Gotham 900 Wall Mounted\"]'),(4148,'inventory.source.items.cleanup','[\"Halden\"]'),(4149,'inventory.source.items.cleanup','[\"Halmstad\"]'),(4150,'inventory.source.items.cleanup','[\"Halo 1000 SL\"]'),(4151,'inventory.source.items.cleanup','[\"Halo 1030\"]'),(4152,'inventory.source.items.cleanup','[\"Halo 1030 DS\"]'),(4153,'inventory.source.items.cleanup','[\"Halo 1250\"]'),(4154,'inventory.source.items.cleanup','[\"Halo 1250 SL\"]'),(4155,'inventory.source.items.cleanup','[\"Halo 1250 XT\"]'),(4156,'inventory.source.items.cleanup','[\"Halo 1500\"]'),(4157,'inventory.source.items.cleanup','[\"Halo 1500 SL\"]'),(4158,'inventory.source.items.cleanup','[\"Halo 1500 XT\"]'),(4159,'inventory.source.items.cleanup','[\"Halo 1800\"]'),(4160,'inventory.source.items.cleanup','[\"Halo 1800 XT\"]'),(4161,'inventory.source.items.cleanup','[\"Halo 2400\"]'),(4162,'inventory.source.items.cleanup','[\"Halo 500\"]'),(4163,'inventory.source.items.cleanup','[\"Halo 600 SL\"]'),(4164,'inventory.source.items.cleanup','[\"Halo 650\"]'),(4165,'inventory.source.items.cleanup','[\"Halo 700 SL\"]'),(4166,'inventory.source.items.cleanup','[\"Halo 750\"]'),(4167,'inventory.source.items.cleanup','[\"Halo 800\"]'),(4168,'inventory.source.items.cleanup','[\"Halo 810 DS\"]'),(4169,'inventory.source.items.cleanup','[\"HPD001\"]'),(4170,'inventory.source.items.cleanup','[\"HUDSON\"]'),(4171,'inventory.source.items.cleanup','[\"Huntingdon 20 Electric\"]'),(4172,'inventory.source.items.cleanup','[\"Huntingdon 20 Gas Stove\"]'),(4173,'inventory.source.items.cleanup','[\"Huntingdon 30 Gas\"]'),(4174,'inventory.source.items.cleanup','[\"Huntingdon 40\"]'),(4175,'inventory.source.items.cleanup','[\"Imperium\"]'),(4176,'inventory.source.items.cleanup','[\"Inglewood\"]'),(4177,'inventory.source.items.cleanup','[\"Instyle 1000 EA\"]'),(4178,'inventory.source.items.cleanup','[\"Instyle 500 EA\"]'),(4179,'inventory.source.items.cleanup','[\"Instyle 550 EA\"]'),(4180,'inventory.source.items.cleanup','[\"Instyle 600 EA\"]'),(4181,'inventory.source.items.cleanup','[\"Instyle 600V Next\"]'),(4182,'inventory.source.items.cleanup','[\"Instyle 650 EA\"]'),(4183,'inventory.source.items.cleanup','[\"Instyle 700 EA\"]'),(4184,'inventory.source.items.cleanup','[\"Instyle 700V Next\"]'),(4185,'inventory.source.items.cleanup','[\"Instyle 800 EA\"]'),(4186,'inventory.source.items.cleanup','[\"Instyle 800V Next\"]'),(4187,'inventory.source.items.cleanup','[\"Instyle Corner\"]'),(4188,'inventory.source.items.cleanup','[\"Instyle Corner Slim 660\\/495\"]'),(4189,'inventory.source.items.cleanup','[\"Instyle Corner Slim 660\\/570\"]'),(4190,'inventory.source.items.cleanup','[\"Instyle Triple 660 Low\"]'),(4191,'inventory.source.items.cleanup','[\"Instyle Tunnel\"]'),(4192,'inventory.source.items.cleanup','[\"Iona 1000\"]'),(4193,'inventory.source.items.cleanup','[\"Iona 1500\"]'),(4194,'inventory.source.items.cleanup','[\"IOWA\"]'),(4195,'inventory.source.items.cleanup','[\"Ivar 5 High\"]'),(4196,'inventory.source.items.cleanup','[\"Ivar 5 Store\"]'),(4197,'inventory.source.items.cleanup','[\"Ivar 5-01 Low\"]'),(4198,'inventory.source.items.cleanup','[\"Ivar 8 Low\"]'),(4199,'inventory.source.items.cleanup','[\"Ivar 8 Store\"]'),(4200,'inventory.source.items.cleanup','[\"Jaeger 1020\"]'),(4201,'inventory.source.items.cleanup','[\"Jaeger 1360 Omni2\"]'),(4202,'inventory.source.items.cleanup','[\"Jannik Large-01\"]'),(4203,'inventory.source.items.cleanup','[\"Jannik Medium High\"]'),(4204,'inventory.source.items.cleanup','[\"Jannik Medium Low\"]'),(4205,'inventory.source.items.cleanup','[\"Kallan\"]'),(4206,'inventory.source.items.cleanup','[\"Kalle EA\"]'),(4207,'inventory.source.items.cleanup','[\"Kalmar Ceramic\"]'),(4208,'inventory.source.items.cleanup','[\"Kalmar MDF\"]'),(4209,'inventory.source.items.cleanup','[\"Kalmar Quartz\"]'),(4210,'inventory.source.items.cleanup','[\"Kansas\"]'),(4211,'inventory.source.items.cleanup','[\"Karlstad\"]'),(4212,'inventory.source.items.cleanup','[\"Kayden Suite\"]'),(4213,'inventory.source.items.cleanup','[\"Kepler 22\"]'),(4214,'inventory.source.items.cleanup','[\"Kibo\"]'),(4215,'inventory.source.items.cleanup','[\"Kibo GF\"]'),(4216,'inventory.source.items.cleanup','[\"Kiruna\"]'),(4217,'inventory.source.items.cleanup','[\"Kudos\"]'),(4218,'inventory.source.items.cleanup','[\"Lars 1000\"]'),(4219,'inventory.source.items.cleanup','[\"Lindstrom DS\"]'),(4220,'inventory.source.items.cleanup','[\"Linear L 800\"]'),(4221,'inventory.source.items.cleanup','[\"Linear M 700\"]'),(4222,'inventory.source.items.cleanup','[\"Linear Module M\"]'),(4223,'inventory.source.items.cleanup','[\"Linear Module XS\"]'),(4224,'inventory.source.items.cleanup','[\"Linear XL 900\"]'),(4225,'inventory.source.items.cleanup','[\"Linear XS 500\"]'),(4226,'inventory.source.items.cleanup','[\"Linnea\"]'),(4227,'inventory.source.items.cleanup','[\"Lita\"]'),(4228,'inventory.source.items.cleanup','[\"Locanda 175\"]'),(4229,'inventory.source.items.cleanup','[\"Logic HE Convector Manual \\/ BF\"]'),(4230,'inventory.source.items.cleanup','[\"Logic HE Convector Manual \\/ CF\"]'),(4231,'inventory.source.items.cleanup','[\"Logic HE Convector Remote \\/ BF\"]'),(4232,'inventory.source.items.cleanup','[\"Logic HE Convector Remote \\/ CF\"]'),(4233,'inventory.source.items.cleanup','[\"Logic HE Convector Slide \\/ BF\"]'),(4234,'inventory.source.items.cleanup','[\"Logic HE Convector Slide \\/ CF\"]'),(4235,'inventory.source.items.cleanup','[\"Logic Hotbox Manual\"]'),(4236,'inventory.source.items.cleanup','[\"Logic Hotbox Remote\"]'),(4237,'inventory.source.items.cleanup','[\"Logic TM Convector Manual\"]'),(4238,'inventory.source.items.cleanup','[\"Logic TM Convector Remote\"]'),(4239,'inventory.source.items.cleanup','[\"Logic TM Convector Slide\"]'),(4240,'inventory.source.items.cleanup','[\"Logic2 Arts\"]'),(4241,'inventory.source.items.cleanup','[\"Logic2 Chartwell\"]'),(4242,'inventory.source.items.cleanup','[\"Logic2 Wave\"]'),(4243,'inventory.source.items.cleanup','[\"Lucius 140\"]'),(4244,'inventory.source.items.cleanup','[\"Lucius 240H\"]'),(4245,'inventory.source.items.cleanup','[\"Lugo 70\\/2\"]'),(4246,'inventory.source.items.cleanup','[\"Lugo 70\\/3\"]'),(4247,'inventory.source.items.cleanup','[\"Lugo 80\\/2\"]'),(4248,'inventory.source.items.cleanup','[\"Lugo 80\\/3\"]'),(4249,'inventory.source.items.cleanup','[\"LUMA 1200\"]'),(4250,'inventory.source.items.cleanup','[\"LUMA 1360\"]'),(4251,'inventory.source.items.cleanup','[\"LUMA 900\"]'),(4252,'inventory.source.items.cleanup','[\"Lungo 2\"]'),(4253,'inventory.source.items.cleanup','[\"M-80h-4S\"]'),(4254,'inventory.source.items.cleanup','[\"Maestro 100\"]'),(4255,'inventory.source.items.cleanup','[\"Maestro 105\\/2\"]'),(4256,'inventory.source.items.cleanup','[\"Maestro 105\\/3\"]'),(4257,'inventory.source.items.cleanup','[\"Maestro 75\"]'),(4258,'inventory.source.items.cleanup','[\"Maestro 75 Tunnel\"]'),(4259,'inventory.source.items.cleanup','[\"Maestro 75XTU\"]'),(4260,'inventory.source.items.cleanup','[\"Maestro 80\\/2\"]'),(4261,'inventory.source.items.cleanup','[\"Maestro 80\\/3\"]'),(4262,'inventory.source.items.cleanup','[\"Majestic Decorative\"]'),(4263,'inventory.source.items.cleanup','[\"Malmo\"]'),(4264,'inventory.source.items.cleanup','[\"Mariner\"]'),(4265,'inventory.source.items.cleanup','[\"Marlborough2\"]'),(4266,'inventory.source.items.cleanup','[\"Marlborough2 Balanced Stove\"]'),(4267,'inventory.source.items.cleanup','[\"Marlborough2 Conventional Stove\"]'),(4268,'inventory.source.items.cleanup','[\"Masquerade Full Depth\"]'),(4269,'inventory.source.items.cleanup','[\"Masquerade S\\/E Slimline\"]'),(4270,'inventory.source.items.cleanup','[\"Masquerade Slimline\"]'),(4271,'inventory.source.items.cleanup','[\"MEMPHIS\"]'),(4272,'inventory.source.items.cleanup','[\"Metro 100XT Tunnel\"]'),(4273,'inventory.source.items.cleanup','[\"Metro 100XT-41\"]'),(4274,'inventory.source.items.cleanup','[\"Metro 100XT\\/2\"]'),(4275,'inventory.source.items.cleanup','[\"Metro 100XT\\/3\"]'),(4276,'inventory.source.items.cleanup','[\"Metro 100XTL\"]'),(4277,'inventory.source.items.cleanup','[\"Metro 100XTU\"]'),(4278,'inventory.source.items.cleanup','[\"Metro 130XT Tunnel\"]'),(4279,'inventory.source.items.cleanup','[\"Metro 130XT-41\"]'),(4280,'inventory.source.items.cleanup','[\"Metro 130XT\\/2\"]'),(4281,'inventory.source.items.cleanup','[\"Metro 130XT\\/3\"]'),(4282,'inventory.source.items.cleanup','[\"Metro 130XTL\"]'),(4283,'inventory.source.items.cleanup','[\"Metro 150XT\"]'),(4284,'inventory.source.items.cleanup','[\"Metro 150XT Tunnel\"]'),(4285,'inventory.source.items.cleanup','[\"Metro 200XT\"]'),(4286,'inventory.source.items.cleanup','[\"Metro 200XT Tunnel\"]'),(4287,'inventory.source.items.cleanup','[\"Metro 80XT\"]'),(4288,'inventory.source.items.cleanup','[\"Metro 80XT Tunnel\"]'),(4289,'inventory.source.items.cleanup','[\"Midi Midline Electric\"]'),(4290,'inventory.source.items.cleanup','[\"Midi T Wall Mounted \\/ BF\"]'),(4291,'inventory.source.items.cleanup','[\"Midi T Wall Mounted Electric\"]'),(4292,'inventory.source.items.cleanup','[\"Midori\"]'),(4293,'inventory.source.items.cleanup','[\"Mini 2LRh-51\"]'),(4294,'inventory.source.items.cleanup','[\"Mini S-FDh\"]'),(4295,'inventory.source.items.cleanup','[\"Mini Sh\"]'),(4296,'inventory.source.items.cleanup','[\"Mirada\"]'),(4297,'inventory.source.items.cleanup','[\"MMZ15\"]'),(4298,'inventory.source.items.cleanup','[\"Modivar 5\"]'),(4299,'inventory.source.items.cleanup','[\"Modore 100\"]'),(4300,'inventory.source.items.cleanup','[\"Modore 140\"]'),(4301,'inventory.source.items.cleanup','[\"Modore 140 O\"]'),(4302,'inventory.source.items.cleanup','[\"Modore 185\"]'),(4303,'inventory.source.items.cleanup','[\"Modore 240\"]'),(4304,'inventory.source.items.cleanup','[\"Modore 240H\"]'),(4305,'inventory.source.items.cleanup','[\"Modore 75H\"]'),(4306,'inventory.source.items.cleanup','[\"Modore 75H O\"]'),(4307,'inventory.source.items.cleanup','[\"Moro\"]'),(4308,'inventory.source.items.cleanup','[\"Motala\"]'),(4309,'inventory.source.items.cleanup','[\"MRB20\"]'),(4310,'inventory.source.items.cleanup','[\"Murano\"]'),(4311,'inventory.source.items.cleanup','[\"MZT20BL-E\"]'),(4312,'inventory.source.items.cleanup','[\"MZT20E\"]'),(4313,'inventory.source.items.cleanup','[\"Nessa\"]'),(4314,'inventory.source.items.cleanup','[\"Newton 10\"]'),(4315,'inventory.source.items.cleanup','[\"Newton 6\"]'),(4316,'inventory.source.items.cleanup','[\"Newton 7\"]'),(4317,'inventory.source.items.cleanup','[\"Newton 9\"]'),(4318,'inventory.source.items.cleanup','[\"Nimbus\"]'),(4319,'inventory.source.items.cleanup','[\"Novaro\"]'),(4320,'inventory.source.items.cleanup','[\"OKT20\"]'),(4321,'inventory.source.items.cleanup','[\"Omniglide 1300\"]'),(4322,'inventory.source.items.cleanup','[\"Omniglide 600\"]'),(4323,'inventory.source.items.cleanup','[\"OMNIGLIDE 900\"]'),(4324,'inventory.source.items.cleanup','[\"Ovation\"]'),(4325,'inventory.source.items.cleanup','[\"Paco\"]'),(4326,'inventory.source.items.cleanup','[\"Passo Eco Wave\"]'),(4327,'inventory.source.items.cleanup','[\"Passo L\"]'),(4328,'inventory.source.items.cleanup','[\"Passo S\"]'),(4329,'inventory.source.items.cleanup','[\"Passo XS\"]'),(4330,'inventory.source.items.cleanup','[\"Passo XS Style\"]'),(4331,'inventory.source.items.cleanup','[\"Passo XS Tripod\"]'),(4332,'inventory.source.items.cleanup','[\"Petrus Slimline\"]'),(4333,'inventory.source.items.cleanup','[\"Petrus Slimline Fire\"]'),(4334,'inventory.source.items.cleanup','[\"PGF10\"]'),(4335,'inventory.source.items.cleanup','[\"PGF20\"]'),(4336,'inventory.source.items.cleanup','[\"PHANTOM\"]'),(4337,'inventory.source.items.cleanup','[\"Piko H2O\"]'),(4338,'inventory.source.items.cleanup','[\"Piko L\"]'),(4339,'inventory.source.items.cleanup','[\"Piko S\"]'),(4340,'inventory.source.items.cleanup','[\"Piko S steel\"]'),(4341,'inventory.source.items.cleanup','[\"PNN20\"]'),(4342,'inventory.source.items.cleanup','[\"Polo\"]'),(4343,'inventory.source.items.cleanup','[\"Portree\"]'),(4344,'inventory.source.items.cleanup','[\"Premium A-3RL-60h\"]'),(4345,'inventory.source.items.cleanup','[\"Premium A-3RL-80h\"]'),(4346,'inventory.source.items.cleanup','[\"Premium A-U70h\"]'),(4347,'inventory.source.items.cleanup','[\"Prostyle 1000\"]'),(4348,'inventory.source.items.cleanup','[\"Prostyle 500\"]'),(4349,'inventory.source.items.cleanup','[\"Prostyle 550\"]'),(4350,'inventory.source.items.cleanup','[\"Prostyle 600\"]'),(4351,'inventory.source.items.cleanup','[\"Prostyle 650\"]'),(4352,'inventory.source.items.cleanup','[\"Prostyle 700\"]'),(4353,'inventory.source.items.cleanup','[\"Prostyle 800\"]'),(4354,'inventory.source.items.cleanup','[\"Prostyle Tunnel\"]'),(4355,'inventory.source.items.cleanup','[\"Radiance Inset Edge\"]'),(4356,'inventory.source.items.cleanup','[\"Raylia\"]'),(4357,'inventory.source.items.cleanup','[\"Reflex 105 \\/ BF\"]'),(4358,'inventory.source.items.cleanup','[\"Reflex 105 \\/ CF\"]'),(4359,'inventory.source.items.cleanup','[\"Reflex 75T \\/ BF\"]'),(4360,'inventory.source.items.cleanup','[\"Reflex 75T \\/ CF\"]'),(4361,'inventory.source.items.cleanup','[\"Reflex 75T-2\"]'),(4362,'inventory.source.items.cleanup','[\"Reflex 75T-3\"]'),(4363,'inventory.source.items.cleanup','[\"Regan 16\"]'),(4364,'inventory.source.items.cleanup','[\"REGAN 22\"]'),(4365,'inventory.source.items.cleanup','[\"Ridlington\"]'),(4366,'inventory.source.items.cleanup','[\"Riva2 500 \\/ BF\"]'),(4367,'inventory.source.items.cleanup','[\"Riva2 500 \\/ CF\"]'),(4368,'inventory.source.items.cleanup','[\"Riva2 750HL \\/ BF\"]'),(4369,'inventory.source.items.cleanup','[\"Riva2 750HL \\/ CF\"]'),(4370,'inventory.source.items.cleanup','[\"Rivera\"]'),(4371,'inventory.source.items.cleanup','[\"Rivera 125\"]'),(4372,'inventory.source.items.cleanup','[\"Rivera 150\"]'),(4373,'inventory.source.items.cleanup','[\"Rivera 175\"]'),(4374,'inventory.source.items.cleanup','[\"Rivera 200\"]'),(4375,'inventory.source.items.cleanup','[\"Romina\"]'),(4376,'inventory.source.items.cleanup','[\"RVACB100BHT\"]'),(4377,'inventory.source.items.cleanup','[\"RVACB120BHT\"]'),(4378,'inventory.source.items.cleanup','[\"RVACB140BHT\"]'),(4379,'inventory.source.items.cleanup','[\"RVACB180BHT\"]'),(4380,'inventory.source.items.cleanup','[\"RVACB45BHT\"]'),(4381,'inventory.source.items.cleanup','[\"RVACLB100BHT\"]'),(4382,'inventory.source.items.cleanup','[\"RVACLB120BHT\"]'),(4383,'inventory.source.items.cleanup','[\"RVACLB140BHT\"]'),(4384,'inventory.source.items.cleanup','[\"RVACLB180BHT\"]'),(4385,'inventory.source.items.cleanup','[\"RVACLB45BHT\"]'),(4386,'inventory.source.items.cleanup','[\"SCR20\"]'),(4387,'inventory.source.items.cleanup','[\"Senso L\"]'),(4388,'inventory.source.items.cleanup','[\"Senso L Fashion\"]'),(4389,'inventory.source.items.cleanup','[\"Senso L Klassik\"]'),(4390,'inventory.source.items.cleanup','[\"Sh-4S\"]'),(4391,'inventory.source.items.cleanup','[\"Sholus\"]'),(4392,'inventory.source.items.cleanup','[\"Sino City\"]'),(4393,'inventory.source.items.cleanup','[\"Sino L\"]'),(4394,'inventory.source.items.cleanup','[\"Sirus\"]'),(4395,'inventory.source.items.cleanup','[\"Skara\"]'),(4396,'inventory.source.items.cleanup','[\"Sky L F\"]'),(4397,'inventory.source.items.cleanup','[\"Sky L T\"]'),(4398,'inventory.source.items.cleanup','[\"Sky L T O\"]'),(4399,'inventory.source.items.cleanup','[\"Sky M F\"]'),(4400,'inventory.source.items.cleanup','[\"Sky M F O\"]'),(4401,'inventory.source.items.cleanup','[\"Sky M T\"]'),(4402,'inventory.source.items.cleanup','[\"Sky M T O\"]'),(4403,'inventory.source.items.cleanup','[\"Sky S F\"]'),(4404,'inventory.source.items.cleanup','[\"Sky S F O\"]'),(4405,'inventory.source.items.cleanup','[\"Sky S T\"]'),(4406,'inventory.source.items.cleanup','[\"Sky S T O\"]'),(4407,'inventory.source.items.cleanup','[\"SNG20\"]'),(4408,'inventory.source.items.cleanup','[\"Solace\"]'),(4409,'inventory.source.items.cleanup','[\"Soren 5 Low\"]'),(4410,'inventory.source.items.cleanup','[\"SP16\"]'),(4411,'inventory.source.items.cleanup','[\"Staton\"]'),(4412,'inventory.source.items.cleanup','[\"Stockton 2 \\/ BF\"]'),(4413,'inventory.source.items.cleanup','[\"Stockton 5 \\/ BF\"]'),(4414,'inventory.source.items.cleanup','[\"Stockton Gas Stove \\/ BF\"]'),(4415,'inventory.source.items.cleanup','[\"Stockton Medium \\/ BF\"]'),(4416,'inventory.source.items.cleanup','[\"Stockton Stove \\/ CF\"]'),(4417,'inventory.source.items.cleanup','[\"Stora DS\"]'),(4418,'inventory.source.items.cleanup','[\"STR 100-30 S SUITE\"]'),(4419,'inventory.source.items.cleanup','[\"STR 100-30 XS SUITE\"]'),(4420,'inventory.source.items.cleanup','[\"STR 100-39 TRU SUITE\"]'),(4421,'inventory.source.items.cleanup','[\"STR 100-44XT SUITE\"]'),(4422,'inventory.source.items.cleanup','[\"STR 125-30 S SUITE\"]'),(4423,'inventory.source.items.cleanup','[\"STR 125-39 TRU SUITE\"]'),(4424,'inventory.source.items.cleanup','[\"STR 125-44XT SUITE\"]'),(4425,'inventory.source.items.cleanup','[\"STR 75-30 XS Suite\"]'),(4426,'inventory.source.items.cleanup','[\"STRATUS 100-30 S\"]'),(4427,'inventory.source.items.cleanup','[\"STRATUS 100-30 XS\"]'),(4428,'inventory.source.items.cleanup','[\"STRATUS 100-39 TRU\"]'),(4429,'inventory.source.items.cleanup','[\"STRATUS 100-44 XT\"]'),(4430,'inventory.source.items.cleanup','[\"STRATUS 125-30 S\"]'),(4431,'inventory.source.items.cleanup','[\"STRATUS 125-39 TRU\"]'),(4432,'inventory.source.items.cleanup','[\"STRATUS 125-44 XT\"]'),(4433,'inventory.source.items.cleanup','[\"Stratus 3 Sided\"]'),(4434,'inventory.source.items.cleanup','[\"Stratus 3 Sided Plus Suite\"]'),(4435,'inventory.source.items.cleanup','[\"Stratus 75-30 XS\"]'),(4436,'inventory.source.items.cleanup','[\"Stratus Slim 100\"]'),(4437,'inventory.source.items.cleanup','[\"Stratus Slim 100 Plus Suite\"]'),(4438,'inventory.source.items.cleanup','[\"Stratus Slim 125\"]'),(4439,'inventory.source.items.cleanup','[\"Stratus Slim 125 Plus Suite\"]'),(4440,'inventory.source.items.cleanup','[\"Studio 1 Freestanding \\/ BF\"]'),(4441,'inventory.source.items.cleanup','[\"Studio 1 Freestanding \\/ CF\"]'),(4442,'inventory.source.items.cleanup','[\"Studio 1 Glass Fronted \\/ BF\"]'),(4443,'inventory.source.items.cleanup','[\"Studio 1 Glass Fronted \\/ CF\"]'),(4444,'inventory.source.items.cleanup','[\"Studio 1 Slimline \\/ BF\"]'),(4445,'inventory.source.items.cleanup','[\"Studio 2 Duplex\"]'),(4446,'inventory.source.items.cleanup','[\"Studio 2 Freestanding \\/ BF\"]'),(4447,'inventory.source.items.cleanup','[\"Studio 2 Freestanding \\/ CF\"]'),(4448,'inventory.source.items.cleanup','[\"Studio 2 Glass Fronted \\/ BF\"]'),(4449,'inventory.source.items.cleanup','[\"Studio 2 Glass Fronted \\/ CF\"]'),(4450,'inventory.source.items.cleanup','[\"Studio 2 Slimline \\/ BF\"]'),(4451,'inventory.source.items.cleanup','[\"Studio 3 Glass Fronted \\/ BF\"]'),(4452,'inventory.source.items.cleanup','[\"Summum 100 3\\/S\"]'),(4453,'inventory.source.items.cleanup','[\"Summum 100 C\"]'),(4454,'inventory.source.items.cleanup','[\"Summum 100 F\"]'),(4455,'inventory.source.items.cleanup','[\"Summum 140 3\\/S\"]'),(4456,'inventory.source.items.cleanup','[\"Summum 140 4\\/S\"]'),(4457,'inventory.source.items.cleanup','[\"Summum 140 C\"]'),(4458,'inventory.source.items.cleanup','[\"Summum 140 F\"]'),(4459,'inventory.source.items.cleanup','[\"Summum 140 RD\"]'),(4460,'inventory.source.items.cleanup','[\"Summum 140 T\"]'),(4461,'inventory.source.items.cleanup','[\"Summum 190 C\"]'),(4462,'inventory.source.items.cleanup','[\"Summum 190 F\"]'),(4463,'inventory.source.items.cleanup','[\"Summum 70 3\\/S\"]'),(4464,'inventory.source.items.cleanup','[\"Summum 70 C\"]'),(4465,'inventory.source.items.cleanup','[\"Summum 70 F\"]'),(4466,'inventory.source.items.cleanup','[\"Telisa\"]'),(4467,'inventory.source.items.cleanup','[\"Tenore 140\"]'),(4468,'inventory.source.items.cleanup','[\"Tenore 240\"]'),(4469,'inventory.source.items.cleanup','[\"Tenore 240H\"]'),(4470,'inventory.source.items.cleanup','[\"Terminal Kits\"]'),(4471,'inventory.source.items.cleanup','[\"Thoren\"]'),(4472,'inventory.source.items.cleanup','[\"TNG20\"]'),(4473,'inventory.source.items.cleanup','[\"Topaz\"]'),(4474,'inventory.source.items.cleanup','[\"Torridon\"]'),(4475,'inventory.source.items.cleanup','[\"Trio\"]'),(4476,'inventory.source.items.cleanup','[\"Trisore 100\"]'),(4477,'inventory.source.items.cleanup','[\"Trisore 140\"]'),(4478,'inventory.source.items.cleanup','[\"Tuva\"]'),(4479,'inventory.source.items.cleanup','[\"Tyrell\"]'),(4480,'inventory.source.items.cleanup','[\"Tyrus 22\"]'),(4481,'inventory.source.items.cleanup','[\"TYRUS-16\"]'),(4482,'inventory.source.items.cleanup','[\"UK795870\"]'),(4483,'inventory.source.items.cleanup','[\"UK796107\"]'),(4484,'inventory.source.items.cleanup','[\"V-1V-87h\"]'),(4485,'inventory.source.items.cleanup','[\"V-2L-68h\"]'),(4486,'inventory.source.items.cleanup','[\"V-2L-80h V-2R-80h\"]'),(4487,'inventory.source.items.cleanup','[\"Valor Excelsior S\\/E Slimline\"]'),(4488,'inventory.source.items.cleanup','[\"Valor Homeflame Dream HE\"]'),(4489,'inventory.source.items.cleanup','[\"Valor Trueflame\"]'),(4490,'inventory.source.items.cleanup','[\"Valter\"]'),(4491,'inventory.source.items.cleanup','[\"Varia 1V H2O\"]'),(4492,'inventory.source.items.cleanup','[\"Varia 1V H2O XL\"]'),(4493,'inventory.source.items.cleanup','[\"Varia 1V H2O XXL\"]'),(4494,'inventory.source.items.cleanup','[\"Varia 1V-100h\"]'),(4495,'inventory.source.items.cleanup','[\"Varia 1Vh H2O XXL\"]'),(4496,'inventory.source.items.cleanup','[\"Varia 2L-100h Varia 2R-100h\"]'),(4497,'inventory.source.items.cleanup','[\"Varia 2L-55h Varia 2R-55h\"]'),(4498,'inventory.source.items.cleanup','[\"Varia 2L-80h Varia 2R-80h\"]'),(4499,'inventory.source.items.cleanup','[\"Varia 2Lh Varia 2Rh\"]'),(4500,'inventory.source.items.cleanup','[\"Varia A-FDh\"]'),(4501,'inventory.source.items.cleanup','[\"Varia AS-2\"]'),(4502,'inventory.source.items.cleanup','[\"Varia AS-3RLh\"]'),(4503,'inventory.source.items.cleanup','[\"Varia AS-FDh-2\"]'),(4504,'inventory.source.items.cleanup','[\"Varia B-120h\"]'),(4505,'inventory.source.items.cleanup','[\"Varia B-FDh\"]'),(4506,'inventory.source.items.cleanup','[\"Varia Sh\"]'),(4507,'inventory.source.items.cleanup','[\"VERADA\"]'),(4508,'inventory.source.items.cleanup','[\"Vidar Triple EA\"]'),(4509,'inventory.source.items.cleanup','[\"Vidar Wall EA\"]'),(4510,'inventory.source.items.cleanup','[\"Vision Electric\"]'),(4511,'inventory.source.items.cleanup','[\"Vision Medium Gas Stove\"]'),(4512,'inventory.source.items.cleanup','[\"Vision Midi Gas Stove\"]'),(4513,'inventory.source.items.cleanup','[\"Vision Midi RF \\/ BF\"]'),(4514,'inventory.source.items.cleanup','[\"Vision Midi RF \\/ CF\"]'),(4515,'inventory.source.items.cleanup','[\"Vision Midi TF \\/ BF\"]'),(4516,'inventory.source.items.cleanup','[\"Vision Midi TF \\/ CF\"]'),(4517,'inventory.source.items.cleanup','[\"Vision Small Gas Stove\"]'),(4518,'inventory.source.items.cleanup','[\"Vivente\"]'),(4519,'inventory.source.items.cleanup','[\"Vogue Midi\"]'),(4520,'inventory.source.items.cleanup','[\"Vogue Midi \\/ BF\"]'),(4521,'inventory.source.items.cleanup','[\"Vogue Midi BF\"]'),(4522,'inventory.source.items.cleanup','[\"Vogue Midi CF\"]'),(4523,'inventory.source.items.cleanup','[\"Vogue Midi Electric\"]'),(4524,'inventory.source.items.cleanup','[\"Vogue Midi T \\/ BF\"]'),(4525,'inventory.source.items.cleanup','[\"Vogue Midi T \\/ CF\"]'),(4526,'inventory.source.items.cleanup','[\"Vogue Midi T Electric\"]'),(4527,'inventory.source.items.cleanup','[\"Vogue Midline BF\"]'),(4528,'inventory.source.items.cleanup','[\"Vogue Midline CF\"]'),(4529,'inventory.source.items.cleanup','[\"Westfield\"]'),(4530,'inventory.source.items.cleanup','[\"WLL20\"]'),(4531,'inventory.source.items.cleanup','[\"ART 10-02\"]'),(4532,'inventory.source.items.cleanup','[\"ART 2-01\"]'),(4533,'inventory.source.items.cleanup','[\"ART 3-01\"]'),(4534,'inventory.source.items.cleanup','[\"ART 4-01\"]'),(4535,'inventory.source.items.cleanup','[\"ART 5-01\"]'),(4536,'inventory.source.items.cleanup','[\"ART 6-01\"]'),(4537,'inventory.source.items.cleanup','[\"ART 8-02\"]'),(4538,'inventory.source.items.cleanup','[\"Style 3-01\"]'),(4539,'inventory.source.items.cleanup','[\"Style 4-01\"]'),(4540,'inventory.source.items.cleanup','[\"Style 5-01\"]'),(4541,'inventory.source.items.cleanup','[\"111.495.00.1\"]'),(4542,'inventory.source.items.cleanup','[\"111.543.00.1\"]'),(4543,'inventory.source.items.cleanup','[\"111.544.00.1\"]'),(4544,'inventory.source.items.cleanup','[\"111.545.00.1\"]'),(4545,'inventory.source.items.cleanup','[\"111.622.00.1\"]'),(4546,'inventory.source.items.cleanup','[\"111.623.00.1\"]'),(4547,'inventory.source.items.cleanup','[\"111.671.00.1\"]'),(4548,'inventory.source.items.cleanup','[\"111.676.00.1\"]'),(4549,'inventory.source.items.cleanup','[\"111.790.00.1\"]'),(4550,'inventory.source.items.cleanup','[\"27036\"]'),(4551,'inventory.source.items.cleanup','[\"27037\"]'),(4552,'inventory.source.items.cleanup','[\"27038\"]'),(4553,'inventory.source.items.cleanup','[\"27039\"]'),(4554,'inventory.source.items.cleanup','[\"27112\"]'),(4555,'inventory.source.items.cleanup','[\"27113\"]'),(4556,'inventory.source.items.cleanup','[\"27115000\"]'),(4557,'inventory.source.items.cleanup','[\"27116000\"]'),(4558,'inventory.source.items.cleanup','[\"27117000\"]'),(4559,'inventory.source.items.cleanup','[\"27129\"]'),(4560,'inventory.source.items.cleanup','[\"27133\"]'),(4561,'inventory.source.items.cleanup','[\"27185000\"]'),(4562,'inventory.source.items.cleanup','[\"27188000\"]'),(4563,'inventory.source.items.cleanup','[\"27222000\"]'),(4564,'inventory.source.items.cleanup','[\"27223000\"]'),(4565,'inventory.source.items.cleanup','[\"27247400\"]'),(4566,'inventory.source.items.cleanup','[\"27248400\"]'),(4567,'inventory.source.items.cleanup','[\"27282\"]'),(4568,'inventory.source.items.cleanup','[\"27283\"]'),(4569,'inventory.source.items.cleanup','[\"27286\"]'),(4570,'inventory.source.items.cleanup','[\"27288\"]'),(4571,'inventory.source.items.cleanup','[\"27296001\"]'),(4572,'inventory.source.items.cleanup','[\"27812400\"]'),(4573,'inventory.source.items.cleanup','[\"27813400\"]'),(4574,'inventory.source.items.cleanup','[\"27922000\"]'),(4575,'inventory.source.items.cleanup','[\"27964000\"]'),(4576,'inventory.source.items.cleanup','[\"38526000\"]'),(4577,'inventory.source.items.cleanup','[\"38528001\"]'),(4578,'inventory.source.items.cleanup','[\"38541000\"]'),(4579,'inventory.source.items.cleanup','[\"38543000\"]'),(4580,'inventory.source.items.cleanup','[\"38661000\"]'),(4581,'inventory.source.items.cleanup','[\"38761000\"]'),(4582,'inventory.source.items.cleanup','[\"38772001\"]'),(4583,'inventory.source.items.cleanup','[\"38868000\"]'),(4584,'inventory.source.items.cleanup','[\"38947000\"]'),(4585,'inventory.source.items.cleanup','[\"39053000\"]'),(4586,'inventory.source.items.cleanup','[\"39054000\"]'),(4587,'inventory.source.items.cleanup','[\"458.132.00.1\"]'),(4588,'inventory.source.items.cleanup','[\"6656S003-5336\"]'),(4589,'inventory.source.items.cleanup','[\"851230806\"]'),(4590,'inventory.source.items.cleanup','[\"851356\"]'),(4591,'inventory.source.items.cleanup','[\"851357\"]'),(4592,'inventory.source.items.cleanup','[\"851358\"]'),(4593,'inventory.source.items.cleanup','[\"855831\"]'),(4594,'inventory.source.items.cleanup','[\"855832\"]'),(4595,'inventory.source.items.cleanup','[\"855833\"]'),(4596,'inventory.source.items.cleanup','[\"855834\"]'),(4597,'inventory.source.items.cleanup','[\"855837\"]'),(4598,'inventory.source.items.cleanup','[\"855838\"]'),(4599,'inventory.source.items.cleanup','[\"855839\"]'),(4600,'inventory.source.items.cleanup','[\"855842\"]'),(4601,'inventory.source.items.cleanup','[\"855843\"]'),(4602,'inventory.source.items.cleanup','[\"855844\"]'),(4603,'inventory.source.items.cleanup','[\"855847\"]'),(4604,'inventory.source.items.cleanup','[\"855848\"]'),(4605,'inventory.source.items.cleanup','[\"855849\"]'),(4606,'inventory.source.items.cleanup','[\"855852806\"]'),(4607,'inventory.source.items.cleanup','[\"855854806\"]'),(4608,'inventory.source.items.cleanup','[\"855865\"]'),(4609,'inventory.source.items.cleanup','[\"855866\"]'),(4610,'inventory.source.items.cleanup','[\"855873\"]'),(4611,'inventory.source.items.cleanup','[\"856577\"]'),(4612,'inventory.source.items.cleanup','[\"856660\"]'),(4613,'inventory.source.items.cleanup','[\"856746001\"]'),(4614,'inventory.source.items.cleanup','[\"856881\"]'),(4615,'inventory.source.items.cleanup','[\"856883\"]'),(4616,'inventory.source.items.cleanup','[\"A3115\"]'),(4617,'inventory.source.items.cleanup','[\"A3116\"]'),(4618,'inventory.source.items.cleanup','[\"A3117\"]'),(4619,'inventory.source.items.cleanup','[\"A3118\"]'),(4620,'inventory.source.items.cleanup','[\"A3530\"]'),(4621,'inventory.source.items.cleanup','[\"A3531\"]'),(4622,'inventory.source.items.cleanup','[\"A3606\"]'),(4623,'inventory.source.items.cleanup','[\"ADELE-60\"]'),(4624,'inventory.source.items.cleanup','[\"ADELE-90\"]'),(4625,'inventory.source.items.cleanup','[\"ALPHA-60-BLK\"]'),(4626,'inventory.source.items.cleanup','[\"ALPHA-90-BLK\"]'),(4627,'inventory.source.items.cleanup','[\"AM312\"]'),(4628,'inventory.source.items.cleanup','[\"APLOMB-BLK-60\"]'),(4629,'inventory.source.items.cleanup','[\"APLOMB-BLK-90\"]'),(4630,'inventory.source.items.cleanup','[\"APLOMB-WH-60\"]'),(4631,'inventory.source.items.cleanup','[\"APLOMB-WH-90\"]'),(4632,'inventory.source.items.cleanup','[\"AQBD10\"]'),(4633,'inventory.source.items.cleanup','[\"AQBD11\"]'),(4634,'inventory.source.items.cleanup','[\"AQBD12\"]'),(4635,'inventory.source.items.cleanup','[\"AQBD76\"]'),(4636,'inventory.source.items.cleanup','[\"AQBD8\"]'),(4637,'inventory.source.items.cleanup','[\"AQBD9\"]'),(4638,'inventory.source.items.cleanup','[\"AQSE1\"]'),(4639,'inventory.source.items.cleanup','[\"AQSL10\"]'),(4640,'inventory.source.items.cleanup','[\"AQSL11\"]'),(4641,'inventory.source.items.cleanup','[\"AQSL12\"]'),(4642,'inventory.source.items.cleanup','[\"AQSL14\"]'),(4643,'inventory.source.items.cleanup','[\"AQSL15\"]'),(4644,'inventory.source.items.cleanup','[\"AQSL16\"]'),(4645,'inventory.source.items.cleanup','[\"AQSL17\"]'),(4646,'inventory.source.items.cleanup','[\"AQSLD14\"]'),(4647,'inventory.source.items.cleanup','[\"AQSLD15\"]'),(4648,'inventory.source.items.cleanup','[\"AQSLD16\"]'),(4649,'inventory.source.items.cleanup','[\"AQSLD17\"]'),(4650,'inventory.source.items.cleanup','[\"AQU108\"]'),(4651,'inventory.source.items.cleanup','[\"AQU109\"]'),(4652,'inventory.source.items.cleanup','[\"AQU128\"]'),(4653,'inventory.source.items.cleanup','[\"AQU129\"]'),(4654,'inventory.source.items.cleanup','[\"AQU769\"]'),(4655,'inventory.source.items.cleanup','[\"AQUAVITAE2-50\"]'),(4656,'inventory.source.items.cleanup','[\"AQUAVITAE2-60\"]'),(4657,'inventory.source.items.cleanup','[\"AQUAVITAE2-90\"]'),(4658,'inventory.source.items.cleanup','[\"AQUD2\"]'),(4659,'inventory.source.items.cleanup','[\"ASCENT-60\"]'),(4660,'inventory.source.items.cleanup','[\"ASCENT-80\"]'),(4661,'inventory.source.items.cleanup','[\"ASCENT-90\"]'),(4662,'inventory.source.items.cleanup','[\"AST\"]'),(4663,'inventory.source.items.cleanup','[\"ATMOS 604\"]'),(4664,'inventory.source.items.cleanup','[\"ATMOS 904\"]'),(4665,'inventory.source.items.cleanup','[\"BOXIN-HE-120\"]'),(4666,'inventory.source.items.cleanup','[\"BOXIN-HE-60\"]'),(4667,'inventory.source.items.cleanup','[\"BOXIN-HE-90\"]'),(4668,'inventory.source.items.cleanup','[\"BOXIN-LX-120\"]'),(4669,'inventory.source.items.cleanup','[\"BOXIN-LX-60\"]'),(4670,'inventory.source.items.cleanup','[\"BOXIN-LX-90\"]'),(4671,'inventory.source.items.cleanup','[\"C17KS61H0\"]'),(4672,'inventory.source.items.cleanup','[\"CONURIPAK1\"]'),(4673,'inventory.source.items.cleanup','[\"CONURIPAK2\"]'),(4674,'inventory.source.items.cleanup','[\"CONURIPAK3\"]'),(4675,'inventory.source.items.cleanup','[\"CRUISE-60\"]'),(4676,'inventory.source.items.cleanup','[\"CRUISE-90\"]'),(4677,'inventory.source.items.cleanup','[\"CT636LES6\"]'),(4678,'inventory.source.items.cleanup','[\"CTL636ES6\"]'),(4679,'inventory.source.items.cleanup','[\"D46BR22N1B\"]'),(4680,'inventory.source.items.cleanup','[\"D46ED22N1B\"]'),(4681,'inventory.source.items.cleanup','[\"D46ML54N1B\"]'),(4682,'inventory.source.items.cleanup','[\"D49ED22N1B\"]'),(4683,'inventory.source.items.cleanup','[\"D49ML54N1B\"]'),(4684,'inventory.source.items.cleanup','[\"D49PU54X1B\"]'),(4685,'inventory.source.items.cleanup','[\"D51NAA1C0B\"]'),(4686,'inventory.source.items.cleanup','[\"D55MH56N0B\"]'),(4687,'inventory.source.items.cleanup','[\"D5655X1GB\"]'),(4688,'inventory.source.items.cleanup','[\"D57MH56N0B\"]'),(4689,'inventory.source.items.cleanup','[\"D57ML67N1B\"]'),(4690,'inventory.source.items.cleanup','[\"D5855X1GB\"]'),(4691,'inventory.source.items.cleanup','[\"D61MAC1X0B\"]'),(4692,'inventory.source.items.cleanup','[\"D62BBC0N0B\"]'),(4693,'inventory.source.items.cleanup','[\"D62PBC0N0B\"]'),(4694,'inventory.source.items.cleanup','[\"D62QBC0N0B\"]'),(4695,'inventory.source.items.cleanup','[\"D64ABC0N0B\"]'),(4696,'inventory.source.items.cleanup','[\"D64BHM1N0B\"]'),(4697,'inventory.source.items.cleanup','[\"D64GBC0N0B\"]'),(4698,'inventory.source.items.cleanup','[\"D64MAC1X0B\"]'),(4699,'inventory.source.items.cleanup','[\"D64QFM1N0B\"]'),(4700,'inventory.source.items.cleanup','[\"D65BMP5N0B\"]'),(4701,'inventory.source.items.cleanup','[\"D65IEE1S0B\"]'),(4702,'inventory.source.items.cleanup','[\"D65IHM1S0B\"]'),(4703,'inventory.source.items.cleanup','[\"D65IHM1S2B\"]'),(4704,'inventory.source.items.cleanup','[\"D72PBC0N0B\"]'),(4705,'inventory.source.items.cleanup','[\"D85IEE1S0B\"]'),(4706,'inventory.source.items.cleanup','[\"D92BBC0N0B\"]'),(4707,'inventory.source.items.cleanup','[\"D92PBC0N0B\"]'),(4708,'inventory.source.items.cleanup','[\"D92QBC0N0B\"]'),(4709,'inventory.source.items.cleanup','[\"D94ABC0N0B\"]'),(4710,'inventory.source.items.cleanup','[\"D94AFM1N0B\"]'),(4711,'inventory.source.items.cleanup','[\"D94BHM1N0B\"]'),(4712,'inventory.source.items.cleanup','[\"D94GBC0N0B\"]'),(4713,'inventory.source.items.cleanup','[\"D94QFM1N0B\"]'),(4714,'inventory.source.items.cleanup','[\"D95BMP5N0B\"]'),(4715,'inventory.source.items.cleanup','[\"D95FRM1S0B\"]'),(4716,'inventory.source.items.cleanup','[\"D96BMV5N5B\"]'),(4717,'inventory.source.items.cleanup','[\"D96IKW1S0B\"]'),(4718,'inventory.source.items.cleanup','[\"DEM63AC00B\"]'),(4719,'inventory.source.items.cleanup','[\"DEM66AC00B\"]'),(4720,'inventory.source.items.cleanup','[\"DFM063W56B\"]'),(4721,'inventory.source.items.cleanup','[\"DFS067A51B\"]'),(4722,'inventory.source.items.cleanup','[\"DFS097A51B\"]'),(4723,'inventory.source.items.cleanup','[\"DHL555BLGB\"]'),(4724,'inventory.source.items.cleanup','[\"DHL575CGB\"]'),(4725,'inventory.source.items.cleanup','[\"DHL785CGB\"]'),(4726,'inventory.source.items.cleanup','[\"DIB98JQ50B\"]'),(4727,'inventory.source.items.cleanup','[\"DIVA-CLASSIC\"]'),(4728,'inventory.source.items.cleanup','[\"DIVA-HM\"]'),(4729,'inventory.source.items.cleanup','[\"DIVA-ROCK\"]'),(4730,'inventory.source.items.cleanup','[\"DLN53AA70B\"]'),(4731,'inventory.source.items.cleanup','[\"DOLCE-COPPER-CH\"]'),(4732,'inventory.source.items.cleanup','[\"DOLCE-IRON-CH\"]'),(4733,'inventory.source.items.cleanup','[\"DOLCE-IV\"]'),(4734,'inventory.source.items.cleanup','[\"DOLCE-PELX-CH\"]'),(4735,'inventory.source.items.cleanup','[\"DOLCE-UMB\"]'),(4736,'inventory.source.items.cleanup','[\"DOLCE-WH\"]'),(4737,'inventory.source.items.cleanup','[\"DRC97AQ50B\"]'),(4738,'inventory.source.items.cleanup','[\"DUL63CC50B\"]'),(4739,'inventory.source.items.cleanup','[\"DWA64BC50B\"]'),(4740,'inventory.source.items.cleanup','[\"DWA66DM50B\"]'),(4741,'inventory.source.items.cleanup','[\"DWA94BC50B\"]'),(4742,'inventory.source.items.cleanup','[\"DWA96DM50B\"]'),(4743,'inventory.source.items.cleanup','[\"DWB64BC50B\"]'),(4744,'inventory.source.items.cleanup','[\"DWB66DM50B\"]'),(4745,'inventory.source.items.cleanup','[\"DWB68JQ50B\"]'),(4746,'inventory.source.items.cleanup','[\"DWB94BC50B\"]'),(4747,'inventory.source.items.cleanup','[\"DWB96DM50B\"]'),(4748,'inventory.source.items.cleanup','[\"DWF97RV60B\"]'),(4749,'inventory.source.items.cleanup','[\"DWG64BC50B\"]'),(4750,'inventory.source.items.cleanup','[\"DWG94BC50B\"]'),(4751,'inventory.source.items.cleanup','[\"DWK67CM60B\"]'),(4752,'inventory.source.items.cleanup','[\"DWK67EM60B\"]'),(4753,'inventory.source.items.cleanup','[\"DWK87CM60B\"]'),(4754,'inventory.source.items.cleanup','[\"DWK87EM60B\"]'),(4755,'inventory.source.items.cleanup','[\"DWK97JQ60B\"]'),(4756,'inventory.source.items.cleanup','[\"DWK98PR60B\"]'),(4757,'inventory.source.items.cleanup','[\"DWP64BC50B\"]'),(4758,'inventory.source.items.cleanup','[\"DWP74BC50B\"]'),(4759,'inventory.source.items.cleanup','[\"DWP94BC50B\"]'),(4760,'inventory.source.items.cleanup','[\"DWQ64BC50B\"]'),(4761,'inventory.source.items.cleanup','[\"DWQ66DM50B\"]'),(4762,'inventory.source.items.cleanup','[\"DWQ94BC50B\"]'),(4763,'inventory.source.items.cleanup','[\"DWQ96DM50B\"]'),(4764,'inventory.source.items.cleanup','[\"EB6B5PB60\"]'),(4765,'inventory.source.items.cleanup','[\"EC6A5HC90\"]'),(4766,'inventory.source.items.cleanup','[\"EC6A5PB90\"]'),(4767,'inventory.source.items.cleanup','[\"EC7A5RB90\"]'),(4768,'inventory.source.items.cleanup','[\"ECS\"]'),(4769,'inventory.source.items.cleanup','[\"ED651FSB5E\"]'),(4770,'inventory.source.items.cleanup','[\"ED711FQ15E\"]'),(4771,'inventory.source.items.cleanup','[\"ED851FQ15E\"]'),(4772,'inventory.source.items.cleanup','[\"ED851FWB5E\"]'),(4773,'inventory.source.items.cleanup','[\"EG7B5QB90\"]'),(4774,'inventory.source.items.cleanup','[\"EH601FEB1E\"]'),(4775,'inventory.source.items.cleanup','[\"EH611BE15E\"]'),(4776,'inventory.source.items.cleanup','[\"EH645FEB1E\"]'),(4777,'inventory.source.items.cleanup','[\"EH801FVB1E\"]'),(4778,'inventory.source.items.cleanup','[\"EH811BE15E\"]'),(4779,'inventory.source.items.cleanup','[\"EH845FVB1E\"]'),(4780,'inventory.source.items.cleanup','[\"EHCL\"]'),(4781,'inventory.source.items.cleanup','[\"Elica Acuta\"]'),(4782,'inventory.source.items.cleanup','[\"Elica Adele\"]'),(4783,'inventory.source.items.cleanup','[\"Elica Adele Island\"]'),(4784,'inventory.source.items.cleanup','[\"Elica Alpha\"]'),(4785,'inventory.source.items.cleanup','[\"Elica Aplomb\"]'),(4786,'inventory.source.items.cleanup','[\"Elica Aquavitae 2.0\"]'),(4787,'inventory.source.items.cleanup','[\"Elica Ascent\"]'),(4788,'inventory.source.items.cleanup','[\"Elica Ascent Urban\"]'),(4789,'inventory.source.items.cleanup','[\"Elica Bio\"]'),(4790,'inventory.source.items.cleanup','[\"Elica Bio Island\"]'),(4791,'inventory.source.items.cleanup','[\"Elica Bloom\"]'),(4792,'inventory.source.items.cleanup','[\"Elica Bloom Lux\"]'),(4793,'inventory.source.items.cleanup','[\"Elica Box In Lux\"]'),(4794,'inventory.source.items.cleanup','[\"Elica Boxin HE\"]'),(4795,'inventory.source.items.cleanup','[\"Elica Cloud Seven\"]'),(4796,'inventory.source.items.cleanup','[\"Elica Cruise\"]'),(4797,'inventory.source.items.cleanup','[\"Elica Diva\"]'),(4798,'inventory.source.items.cleanup','[\"Elica Dolce\"]'),(4799,'inventory.source.items.cleanup','[\"Elica Easy Ux\"]'),(4800,'inventory.source.items.cleanup','[\"Elica Elite 14\"]'),(4801,'inventory.source.items.cleanup','[\"Elica Elite 35\"]'),(4802,'inventory.source.items.cleanup','[\"Elica Era\"]'),(4803,'inventory.source.items.cleanup','[\"Elica Era HE\"]'),(4804,'inventory.source.items.cleanup','[\"Elica Era Lux\"]'),(4805,'inventory.source.items.cleanup','[\"Elica Fold\"]'),(4806,'inventory.source.items.cleanup','[\"Elica Fold Stainless Steel\"]'),(4807,'inventory.source.items.cleanup','[\"Elica Galaxy Island LED\"]'),(4808,'inventory.source.items.cleanup','[\"Elica Galaxy LED\"]'),(4809,'inventory.source.items.cleanup','[\"Elica Get Up\"]'),(4810,'inventory.source.items.cleanup','[\"Elica Haiku\"]'),(4811,'inventory.source.items.cleanup','[\"Elica Haiku Island\"]'),(4812,'inventory.source.items.cleanup','[\"Elica HiLight\"]'),(4813,'inventory.source.items.cleanup','[\"Elica Ikona\"]'),(4814,'inventory.source.items.cleanup','[\"Elica Illusion Plus\"]'),(4815,'inventory.source.items.cleanup','[\"Elica Integrata\"]'),(4816,'inventory.source.items.cleanup','[\"Elica Interstellar\"]'),(4817,'inventory.source.items.cleanup','[\"Elica Io Air\"]'),(4818,'inventory.source.items.cleanup','[\"Elica Juno\"]'),(4819,'inventory.source.items.cleanup','[\"Elica Krea\"]'),(4820,'inventory.source.items.cleanup','[\"Elica Lane\"]'),(4821,'inventory.source.items.cleanup','[\"Elica Lever\"]'),(4822,'inventory.source.items.cleanup','[\"Elica Lullaby\"]'),(4823,'inventory.source.items.cleanup','[\"Elica Majestic No Drip\"]'),(4824,'inventory.source.items.cleanup','[\"Elica Meteorite\"]'),(4825,'inventory.source.items.cleanup','[\"Elica Meteorite Island\"]'),(4826,'inventory.source.items.cleanup','[\"Elica Mini Io\"]'),(4827,'inventory.source.items.cleanup','[\"Elica Nikola Tesla Fit\"]'),(4828,'inventory.source.items.cleanup','[\"Elica Nikola Tesla Flame\"]'),(4829,'inventory.source.items.cleanup','[\"Elica Nikola Tesla Libra\"]'),(4830,'inventory.source.items.cleanup','[\"Elica Nikola Tesla Switch\"]'),(4831,'inventory.source.items.cleanup','[\"Elica Nuance\"]'),(4832,'inventory.source.items.cleanup','[\"Elica Pandora External\"]'),(4833,'inventory.source.items.cleanup','[\"Elica Pandora Internal\"]'),(4834,'inventory.source.items.cleanup','[\"Elica Pearl\"]'),(4835,'inventory.source.items.cleanup','[\"Elica Pix\"]'),(4836,'inventory.source.items.cleanup','[\"Elica Plat\"]'),(4837,'inventory.source.items.cleanup','[\"Elica Reef A\"]'),(4838,'inventory.source.items.cleanup','[\"Elica Reef A Island\"]'),(4839,'inventory.source.items.cleanup','[\"Elica Rules\"]'),(4840,'inventory.source.items.cleanup','[\"Elica Shining\"]'),(4841,'inventory.source.items.cleanup','[\"Elica Shy\"]'),(4842,'inventory.source.items.cleanup','[\"Elica Sklock S 2.0\"]'),(4843,'inventory.source.items.cleanup','[\"Elica Sleek 2\"]'),(4844,'inventory.source.items.cleanup','[\"Elica Stone\"]'),(4845,'inventory.source.items.cleanup','[\"Elica Super Plat\"]'),(4846,'inventory.source.items.cleanup','[\"Elica Tamaya 2\"]'),(4847,'inventory.source.items.cleanup','[\"Elica Thin\"]'),(4848,'inventory.source.items.cleanup','[\"Elica Thin Island\"]'),(4849,'inventory.source.items.cleanup','[\"Elica Tonda\"]'),(4850,'inventory.source.items.cleanup','[\"Elica Tribe A\"]'),(4851,'inventory.source.items.cleanup','[\"Elica Tribe Island A\"]'),(4852,'inventory.source.items.cleanup','[\"Elica Tube Island Pro\"]'),(4853,'inventory.source.items.cleanup','[\"Elica Wave Ux\"]'),(4854,'inventory.source.items.cleanup','[\"Elica Yin Island\"]'),(4855,'inventory.source.items.cleanup','[\"ELITE14-LED-60\"]'),(4856,'inventory.source.items.cleanup','[\"ELITE14-LED-90\"]'),(4857,'inventory.source.items.cleanup','[\"ELITE35-60\"]'),(4858,'inventory.source.items.cleanup','[\"ELITE35-90\"]'),(4859,'inventory.source.items.cleanup','[\"EP6A6HB20\"]'),(4860,'inventory.source.items.cleanup','[\"EP7A6QB90\"]'),(4861,'inventory.source.items.cleanup','[\"EP9A6SB90\"]'),(4862,'inventory.source.items.cleanup','[\"EPC\"]'),(4863,'inventory.source.items.cleanup','[\"EPHC\"]'),(4864,'inventory.source.items.cleanup','[\"EPI\"]'),(4865,'inventory.source.items.cleanup','[\"EPIC\"]'),(4866,'inventory.source.items.cleanup','[\"EPQ\"]'),(4867,'inventory.source.items.cleanup','[\"EPR\"]'),(4868,'inventory.source.items.cleanup','[\"EPSC\"]'),(4869,'inventory.source.items.cleanup','[\"EPSR\"]'),(4870,'inventory.source.items.cleanup','[\"EPST\"]'),(4871,'inventory.source.items.cleanup','[\"EPW\"]'),(4872,'inventory.source.items.cleanup','[\"EPWC\"]'),(4873,'inventory.source.items.cleanup','[\"ER9A6SB70\"]'),(4874,'inventory.source.items.cleanup','[\"ERA-HE-SS-60\"]'),(4875,'inventory.source.items.cleanup','[\"ERA-HE-SS-80\"]'),(4876,'inventory.source.items.cleanup','[\"ERA-LUX-BLK-60\"]'),(4877,'inventory.source.items.cleanup','[\"ERA-LUX-BLK-80\"]'),(4878,'inventory.source.items.cleanup','[\"ERA-LUX-SS-60\"]'),(4879,'inventory.source.items.cleanup','[\"ERA-LUX-SS-80\"]'),(4880,'inventory.source.items.cleanup','[\"ERA-LUX-WH-60\"]'),(4881,'inventory.source.items.cleanup','[\"ERA-LUX-WH-80\"]'),(4882,'inventory.source.items.cleanup','[\"ERA-STD-60\"]'),(4883,'inventory.source.items.cleanup','[\"ERA-STD-80\"]'),(4884,'inventory.source.items.cleanup','[\"ERBD76\"]'),(4885,'inventory.source.items.cleanup','[\"ERBD80\"]'),(4886,'inventory.source.items.cleanup','[\"ERBD90\"]'),(4887,'inventory.source.items.cleanup','[\"ERCE7676\"]'),(4888,'inventory.source.items.cleanup','[\"ERPD70\"]'),(4889,'inventory.source.items.cleanup','[\"ERQ8\"]'),(4890,'inventory.source.items.cleanup','[\"ERQ9\"]'),(4891,'inventory.source.items.cleanup','[\"ERSL10\"]'),(4892,'inventory.source.items.cleanup','[\"ERSL12\"]'),(4893,'inventory.source.items.cleanup','[\"ET475FYB1E\"]'),(4894,'inventory.source.items.cleanup','[\"EU631FEB1E\"]'),(4895,'inventory.source.items.cleanup','[\"EWCL\"]'),(4896,'inventory.source.items.cleanup','[\"EX275FXB1E\"]'),(4897,'inventory.source.items.cleanup','[\"EX375FXB1E\"]'),(4898,'inventory.source.items.cleanup','[\"EX651FEC1E\"]'),(4899,'inventory.source.items.cleanup','[\"EX675LXV1E\"]'),(4900,'inventory.source.items.cleanup','[\"EX851FVC1E\"]'),(4901,'inventory.source.items.cleanup','[\"EX879FVC1E\"]'),(4902,'inventory.source.items.cleanup','[\"EX975LVV1E\"]'),(4903,'inventory.source.items.cleanup','[\"EXPURIPAK1\"]'),(4904,'inventory.source.items.cleanup','[\"EXPURIPAK2\"]'),(4905,'inventory.source.items.cleanup','[\"EXPURIPAK3\"]'),(4906,'inventory.source.items.cleanup','[\"EZ977KZY1E\"]'),(4907,'inventory.source.items.cleanup','[\"FDF EV8 60\"]'),(4908,'inventory.source.items.cleanup','[\"FDF EV8 70 XS\"]'),(4909,'inventory.source.items.cleanup','[\"FDF EV8 90\"]'),(4910,'inventory.source.items.cleanup','[\"FDW 908 IB XS\"]'),(4911,'inventory.source.items.cleanup','[\"FFI 622 GR\"]'),(4912,'inventory.source.items.cleanup','[\"FGC 625 XS\"]'),(4913,'inventory.source.items.cleanup','[\"FGC 925 XS\"]'),(4914,'inventory.source.items.cleanup','[\"FGL 625 XS\"]'),(4915,'inventory.source.items.cleanup','[\"FGL 925 I XS NP\"]'),(4916,'inventory.source.items.cleanup','[\"FGL 925 XS\"]'),(4917,'inventory.source.items.cleanup','[\"FJO 624 XS\"]'),(4918,'inventory.source.items.cleanup','[\"FJO 924 XS\"]'),(4919,'inventory.source.items.cleanup','[\"FKAS A80 BK Z1\"]'),(4920,'inventory.source.items.cleanup','[\"FMA 2.0 PRO 807 BK\"]'),(4921,'inventory.source.items.cleanup','[\"FMA 2.0 PRO 907 BK\"]'),(4922,'inventory.source.items.cleanup','[\"FMA 839 HI\"]'),(4923,'inventory.source.items.cleanup','[\"FMY 839 HI\"]'),(4924,'inventory.source.items.cleanup','[\"FMY PER PRO BK F90\"]'),(4925,'inventory.source.items.cleanup','[\"FMY PRO 907 FM\"]'),(4926,'inventory.source.items.cleanup','[\"FPJ 625 V\"]'),(4927,'inventory.source.items.cleanup','[\"FS04RAK12C\"]'),(4928,'inventory.source.items.cleanup','[\"FS04RAK82TF\"]'),(4929,'inventory.source.items.cleanup','[\"FS04RAK8C\"]'),(4930,'inventory.source.items.cleanup','[\"FS04RAKC\"]'),(4931,'inventory.source.items.cleanup','[\"FS04RAKCAB\"]'),(4932,'inventory.source.items.cleanup','[\"FS04RAKCAB0\"]'),(4933,'inventory.source.items.cleanup','[\"FS05RAK8C\"]'),(4934,'inventory.source.items.cleanup','[\"FS09RAKC\"]'),(4935,'inventory.source.items.cleanup','[\"FS09RAKC1\"]'),(4936,'inventory.source.items.cleanup','[\"FS12RAK12C\"]'),(4937,'inventory.source.items.cleanup','[\"FS12RAK82TF\"]'),(4938,'inventory.source.items.cleanup','[\"FS12RAK8C\"]'),(4939,'inventory.source.items.cleanup','[\"FS12RAKCAB\"]'),(4940,'inventory.source.items.cleanup','[\"FS12RAKCAB0\"]'),(4941,'inventory.source.items.cleanup','[\"FTLN H45 X\\/BK GLASS A90 FRK\"]'),(4942,'inventory.source.items.cleanup','[\"FTMY AH BK MATT F90\"]'),(4943,'inventory.source.items.cleanup','[\"FVAD A90 BK MATT\"]'),(4944,'inventory.source.items.cleanup','[\"FVAS A80 BK Z1\"]'),(4945,'inventory.source.items.cleanup','[\"FVMY AH BK F90 UK\"]'),(4946,'inventory.source.items.cleanup','[\"G4344XFF0G\"]'),(4947,'inventory.source.items.cleanup','[\"Geberit Delta 12cm\"]'),(4948,'inventory.source.items.cleanup','[\"GI1113FE0\"]'),(4949,'inventory.source.items.cleanup','[\"GI11VAFE0\"]'),(4950,'inventory.source.items.cleanup','[\"GI1216DE0\"]'),(4951,'inventory.source.items.cleanup','[\"GI21VAFE0\"]'),(4952,'inventory.source.items.cleanup','[\"GI7416CE0\"]'),(4953,'inventory.source.items.cleanup','[\"GI7813EF0G\"]'),(4954,'inventory.source.items.cleanup','[\"GI7815CE0G\"]'),(4955,'inventory.source.items.cleanup','[\"GI81NAEF0G\"]'),(4956,'inventory.source.items.cleanup','[\"GI81NHCE0G\"]'),(4957,'inventory.source.items.cleanup','[\"GIN81AEF0G\"]'),(4958,'inventory.source.items.cleanup','[\"GIN81HCE0G\"]'),(4959,'inventory.source.items.cleanup','[\"GIV21AFE0\"]'),(4960,'inventory.source.items.cleanup','[\"GU15DAFF0G\"]'),(4961,'inventory.source.items.cleanup','[\"GUD15AFF0G\"]'),(4962,'inventory.source.items.cleanup','[\"HAIKU-120-BLK\"]'),(4963,'inventory.source.items.cleanup','[\"HAIKU-120-SS\"]'),(4964,'inventory.source.items.cleanup','[\"HAIKU-120-WH\"]'),(4965,'inventory.source.items.cleanup','[\"HAIKU-32-BLK\"]'),(4966,'inventory.source.items.cleanup','[\"HAIKU-32-SS\"]'),(4967,'inventory.source.items.cleanup','[\"HAIKU-32-WH\"]'),(4968,'inventory.source.items.cleanup','[\"HAIKU-60-BLK\"]'),(4969,'inventory.source.items.cleanup','[\"HAIKU-60-SS\"]'),(4970,'inventory.source.items.cleanup','[\"HAIKU-60-WH\"]'),(4971,'inventory.source.items.cleanup','[\"HAIKU-90-BLK\"]'),(4972,'inventory.source.items.cleanup','[\"HAIKU-90-SS\"]'),(4973,'inventory.source.items.cleanup','[\"HAIKU-90-WH\"]'),(4974,'inventory.source.items.cleanup','[\"HAIKU-ISL-120-BLK\"]'),(4975,'inventory.source.items.cleanup','[\"HAIKU-ISL-120-SS\"]'),(4976,'inventory.source.items.cleanup','[\"HAIKU-ISL-120-WH\"]'),(4977,'inventory.source.items.cleanup','[\"HAIKU-ISL-180-BLK\"]'),(4978,'inventory.source.items.cleanup','[\"HAIKU-ISL-180-SS\"]'),(4979,'inventory.source.items.cleanup','[\"HAIKU-ISL-180-WH\"]'),(4980,'inventory.source.items.cleanup','[\"HAIKU-ISL-32-BLK\"]'),(4981,'inventory.source.items.cleanup','[\"HAIKU-ISL-32-SS\"]'),(4982,'inventory.source.items.cleanup','[\"HAIKU-ISL-32-WH\"]'),(4983,'inventory.source.items.cleanup','[\"HIB Blend\"]'),(4984,'inventory.source.items.cleanup','[\"HILIGHT-GLS-16\"]'),(4985,'inventory.source.items.cleanup','[\"HILIGHT-GLS-30\"]'),(4986,'inventory.source.items.cleanup','[\"HILIGHT-X-16-BLK\"]'),(4987,'inventory.source.items.cleanup','[\"HILIGHT-X-16-SS\"]'),(4988,'inventory.source.items.cleanup','[\"HILIGHT-X-16-WH\"]'),(4989,'inventory.source.items.cleanup','[\"HILIGHT-X-30-BLK\"]'),(4990,'inventory.source.items.cleanup','[\"HILIGHT-X-30-SS\"]'),(4991,'inventory.source.items.cleanup','[\"HILIGHT-X-30-WH\"]'),(4992,'inventory.source.items.cleanup','[\"Hinged Shower\"]'),(4993,'inventory.source.items.cleanup','[\"I14RBQ8W0\"]'),(4994,'inventory.source.items.cleanup','[\"I25CBS8W0B\"]'),(4995,'inventory.source.items.cleanup','[\"I94CAQ6N0B\"]'),(4996,'inventory.source.items.cleanup','[\"I95CAP6N1B\"]'),(4997,'inventory.source.items.cleanup','[\"I95CAQ6N0B\"]'),(4998,'inventory.source.items.cleanup','[\"I95CAQ6W0B\"]'),(4999,'inventory.source.items.cleanup','[\"I95CBS8W0B\"]'),(5000,'inventory.source.items.cleanup','[\"I95GBE2N0B\"]'),(5001,'inventory.source.items.cleanup','[\"I96BMP5N0B\"]'),(5002,'inventory.source.items.cleanup','[\"I96BMV5N5B\"]'),(5003,'inventory.source.items.cleanup','[\"I97CPS8W5B\"]'),(5004,'inventory.source.items.cleanup','[\"I98WMM1S1B\"]'),(5005,'inventory.source.items.cleanup','[\"IC\"]'),(5006,'inventory.source.items.cleanup','[\"ICT\"]'),(5007,'inventory.source.items.cleanup','[\"ILLUS-PLS-16-BK\"]'),(5008,'inventory.source.items.cleanup','[\"ILLUS-PLS-16-CS\"]'),(5009,'inventory.source.items.cleanup','[\"ILLUS-PLS-16-WH\"]'),(5010,'inventory.source.items.cleanup','[\"ILLUS-PLS-30-BK\"]'),(5011,'inventory.source.items.cleanup','[\"ILLUS-PLS-30-CS\"]'),(5012,'inventory.source.items.cleanup','[\"ILLUS-PLS-30-WH\"]'),(5013,'inventory.source.items.cleanup','[\"INTERSTELLAR-B\"]'),(5014,'inventory.source.items.cleanup','[\"INTERSTELLAR-C\"]'),(5015,'inventory.source.items.cleanup','[\"IO-AIR-BLK\"]'),(5016,'inventory.source.items.cleanup','[\"IO-AIR-WH\"]'),(5017,'inventory.source.items.cleanup','[\"IQT\"]'),(5018,'inventory.source.items.cleanup','[\"IR\"]'),(5019,'inventory.source.items.cleanup','[\"IRT\"]'),(5020,'inventory.source.items.cleanup','[\"JOYTS120\"]'),(5021,'inventory.source.items.cleanup','[\"K4316XFF0G\"]'),(5022,'inventory.source.items.cleanup','[\"K4336XFF0G\"]'),(5023,'inventory.source.items.cleanup','[\"KA3923IE0G\"]'),(5024,'inventory.source.items.cleanup','[\"KAD93VBFPG\"]'),(5025,'inventory.source.items.cleanup','[\"KAG93AIEPG\"]'),(5026,'inventory.source.items.cleanup','[\"KAI93VIFPG\"]'),(5027,'inventory.source.items.cleanup','[\"KAN93VIFPG\"]'),(5028,'inventory.source.items.cleanup','[\"KFF96PIEP\"]'),(5029,'inventory.source.items.cleanup','[\"KI1213DD0\"]'),(5030,'inventory.source.items.cleanup','[\"KI1413FD0\"]'),(5031,'inventory.source.items.cleanup','[\"KI1812SF0G\"]'),(5032,'inventory.source.items.cleanup','[\"KI1813FE0G\"]'),(5033,'inventory.source.items.cleanup','[\"KI2822SF0G\"]'),(5034,'inventory.source.items.cleanup','[\"KI2823FF0G\"]'),(5035,'inventory.source.items.cleanup','[\"KI5862SE0G\"]'),(5036,'inventory.source.items.cleanup','[\"KI5871SF0G\"]'),(5037,'inventory.source.items.cleanup','[\"KI5872FE0G\"]'),(5038,'inventory.source.items.cleanup','[\"KI5872SE0G\"]'),(5039,'inventory.source.items.cleanup','[\"KI6863FE0G\"]'),(5040,'inventory.source.items.cleanup','[\"KI6873FE0G\"]'),(5041,'inventory.source.items.cleanup','[\"KI7863DF0G\"]'),(5042,'inventory.source.items.cleanup','[\"KI81RADE0G\"]'),(5043,'inventory.source.items.cleanup','[\"KI81RAFE0G\"]'),(5044,'inventory.source.items.cleanup','[\"KI81RVSF0G\"]'),(5045,'inventory.source.items.cleanup','[\"KI82LAFF0\"]'),(5046,'inventory.source.items.cleanup','[\"KI86SAFE0G\"]'),(5047,'inventory.source.items.cleanup','[\"KI86VVFE0G\"]'),(5048,'inventory.source.items.cleanup','[\"KI87SAFE0G\"]'),(5049,'inventory.source.items.cleanup','[\"KI87VVFE0G\"]'),(5050,'inventory.source.items.cleanup','[\"KI87VVSE0G\"]'),(5051,'inventory.source.items.cleanup','[\"KI8816DE0\"]'),(5052,'inventory.source.items.cleanup','[\"KI8865DE0\"]'),(5053,'inventory.source.items.cleanup','[\"KIF81PFE0\"]'),(5054,'inventory.source.items.cleanup','[\"KIF82PFF0\"]'),(5055,'inventory.source.items.cleanup','[\"KIF86PFE0\"]'),(5056,'inventory.source.items.cleanup','[\"KIL82AFF0G\"]'),(5057,'inventory.source.items.cleanup','[\"KIL82VSF0\"]'),(5058,'inventory.source.items.cleanup','[\"KIN86AFF0G\"]'),(5059,'inventory.source.items.cleanup','[\"KIR81AFE0G\"]'),(5060,'inventory.source.items.cleanup','[\"KIR81VSF0G\"]'),(5061,'inventory.source.items.cleanup','[\"KIS86AFE0G\"]'),(5062,'inventory.source.items.cleanup','[\"KIS87AFE0G\"]'),(5063,'inventory.source.items.cleanup','[\"KIV86VSE0G\"]'),(5064,'inventory.source.items.cleanup','[\"KIV87NSF0G\"]'),(5065,'inventory.source.items.cleanup','[\"KIV87VFE0G\"]'),(5066,'inventory.source.items.cleanup','[\"KIV87VSE0G\"]'),(5067,'inventory.source.items.cleanup','[\"KREA-LX-90-SS\"]'),(5068,'inventory.source.items.cleanup','[\"KREA-ST-60-SS\"]'),(5069,'inventory.source.items.cleanup','[\"KU15LAFF0G\"]'),(5070,'inventory.source.items.cleanup','[\"KU15RAFF0G\"]'),(5071,'inventory.source.items.cleanup','[\"KU20WVHF0G\"]'),(5072,'inventory.source.items.cleanup','[\"KU21RVFE0G\"]'),(5073,'inventory.source.items.cleanup','[\"KU21WAHG0G\"]'),(5074,'inventory.source.items.cleanup','[\"KUL15AFF0G\"]'),(5075,'inventory.source.items.cleanup','[\"KUR15AFF0G\"]'),(5076,'inventory.source.items.cleanup','[\"KUW20VHF0G\"]'),(5077,'inventory.source.items.cleanup','[\"KUW21AHG0G\"]'),(5078,'inventory.source.items.cleanup','[\"L6205EO\"]'),(5079,'inventory.source.items.cleanup','[\"L6283EO\"]'),(5080,'inventory.source.items.cleanup','[\"L6284EO\"]'),(5081,'inventory.source.items.cleanup','[\"L6285EO\"]'),(5082,'inventory.source.items.cleanup','[\"L6286EO\"]'),(5083,'inventory.source.items.cleanup','[\"L6287EO\"]'),(5084,'inventory.source.items.cleanup','[\"L6289EO\"]'),(5085,'inventory.source.items.cleanup','[\"L6290EO\"]'),(5086,'inventory.source.items.cleanup','[\"L6617EO\"]'),(5087,'inventory.source.items.cleanup','[\"LANE-60\"]'),(5088,'inventory.source.items.cleanup','[\"LANE-80\"]'),(5089,'inventory.source.items.cleanup','[\"LB53NAA30B\"]'),(5090,'inventory.source.items.cleanup','[\"LB55565GB\"]'),(5091,'inventory.source.items.cleanup','[\"LB57574GB\"]'),(5092,'inventory.source.items.cleanup','[\"LB75565GB\"]'),(5093,'inventory.source.items.cleanup','[\"LB78574GB\"]'),(5094,'inventory.source.items.cleanup','[\"LB79585MGB\"]'),(5095,'inventory.source.items.cleanup','[\"LC64BBC50B\"]'),(5096,'inventory.source.items.cleanup','[\"LC64PBC50B\"]'),(5097,'inventory.source.items.cleanup','[\"LC67AFM50B\"]'),(5098,'inventory.source.items.cleanup','[\"LC67BHM50B\"]'),(5099,'inventory.source.items.cleanup','[\"LC67KHM60B\"]'),(5100,'inventory.source.items.cleanup','[\"LC67QFM50B\"]'),(5101,'inventory.source.items.cleanup','[\"LC77BHM50B\"]'),(5102,'inventory.source.items.cleanup','[\"LC87KHM60B\"]'),(5103,'inventory.source.items.cleanup','[\"LC91BUV50B\"]'),(5104,'inventory.source.items.cleanup','[\"LC91KWW60B\"]'),(5105,'inventory.source.items.cleanup','[\"LC94BBC50B\"]'),(5106,'inventory.source.items.cleanup','[\"LC94PBC50B\"]'),(5107,'inventory.source.items.cleanup','[\"LC97AFM50B\"]'),(5108,'inventory.source.items.cleanup','[\"LC97BHM50B\"]'),(5109,'inventory.source.items.cleanup','[\"LC97QFM50B\"]'),(5110,'inventory.source.items.cleanup','[\"LE63MAC00B\"]'),(5111,'inventory.source.items.cleanup','[\"LE66MAC00B\"]'),(5112,'inventory.source.items.cleanup','[\"LEVER-120\"]'),(5113,'inventory.source.items.cleanup','[\"LEVER-60\"]'),(5114,'inventory.source.items.cleanup','[\"LEVER-90\"]'),(5115,'inventory.source.items.cleanup','[\"LF91BUV50B\"]'),(5116,'inventory.source.items.cleanup','[\"LF97GBM50B\"]'),(5117,'inventory.source.items.cleanup','[\"LI64MA531B\"]'),(5118,'inventory.source.items.cleanup','[\"LI94MA531B\"]'),(5119,'inventory.source.items.cleanup','[\"LI97SA561B\"]'),(5120,'inventory.source.items.cleanup','[\"LR96CAQ50B\"]'),(5121,'inventory.source.items.cleanup','[\"LR97CAP21B\"]'),(5122,'inventory.source.items.cleanup','[\"LR97CAQ50B\"]'),(5123,'inventory.source.items.cleanup','[\"LULL-AT-NAT-DO\"]'),(5124,'inventory.source.items.cleanup','[\"LULL-AT-NAT-RC\"]'),(5125,'inventory.source.items.cleanup','[\"LULL-AT-WW-DO\"]'),(5126,'inventory.source.items.cleanup','[\"LULL-AT-WW-RC\"]'),(5127,'inventory.source.items.cleanup','[\"M1000Q-E8\"]'),(5128,'inventory.source.items.cleanup','[\"M1000SS-E8\"]'),(5129,'inventory.source.items.cleanup','[\"M1080Q-E8\"]'),(5130,'inventory.source.items.cleanup','[\"M1100SS-E8\"]'),(5131,'inventory.source.items.cleanup','[\"M1200SS-E8\"]'),(5132,'inventory.source.items.cleanup','[\"M1280Q-E8\"]'),(5133,'inventory.source.items.cleanup','[\"M1290Q-E8\"]'),(5134,'inventory.source.items.cleanup','[\"M1400SS-E8\"]'),(5135,'inventory.source.items.cleanup','[\"M800Q-E8\"]'),(5136,'inventory.source.items.cleanup','[\"M900Q-E8\"]'),(5137,'inventory.source.items.cleanup','[\"M9080Q-E8\"]'),(5138,'inventory.source.items.cleanup','[\"MAJ-ND-BLK-60\"]'),(5139,'inventory.source.items.cleanup','[\"MAJ-ND-BLK-90\"]'),(5140,'inventory.source.items.cleanup','[\"Matki-MTM\"]'),(5141,'inventory.source.items.cleanup','[\"METEORITE-120\"]'),(5142,'inventory.source.items.cleanup','[\"METEORITE-90\"]'),(5143,'inventory.source.items.cleanup','[\"MH70-E8\"]'),(5144,'inventory.source.items.cleanup','[\"MH76-E8\"]'),(5145,'inventory.source.items.cleanup','[\"MH80-E8\"]'),(5146,'inventory.source.items.cleanup','[\"MH90-E8\"]'),(5147,'inventory.source.items.cleanup','[\"MOC\"]'),(5148,'inventory.source.items.cleanup','[\"MOPC\"]'),(5149,'inventory.source.items.cleanup','[\"MOPR\"]'),(5150,'inventory.source.items.cleanup','[\"MOQP\"]'),(5151,'inventory.source.items.cleanup','[\"MOSC\"]'),(5152,'inventory.source.items.cleanup','[\"MOSR\"]'),(5153,'inventory.source.items.cleanup','[\"MOWP\"]'),(5154,'inventory.source.items.cleanup','[\"MOWV\"]'),(5155,'inventory.source.items.cleanup','[\"N74TD00N0\"]'),(5156,'inventory.source.items.cleanup','[\"Nikola Tesla One\"]'),(5157,'inventory.source.items.cleanup','[\"Nikola Tesla One HP\"]'),(5158,'inventory.source.items.cleanup','[\"Nikola Tesla Prime\"]'),(5159,'inventory.source.items.cleanup','[\"Nikola Tesla Prime Plus\"]'),(5160,'inventory.source.items.cleanup','[\"NRXC\"]'),(5161,'inventory.source.items.cleanup','[\"NRXO\"]'),(5162,'inventory.source.items.cleanup','[\"NRXS\"]'),(5163,'inventory.source.items.cleanup','[\"NRXSC\"]'),(5164,'inventory.source.items.cleanup','[\"NUANCE-DRYWALL\"]'),(5165,'inventory.source.items.cleanup','[\"NUANCE-PAINT\"]'),(5166,'inventory.source.items.cleanup','[\"NWCC\"]'),(5167,'inventory.source.items.cleanup','[\"NWCC1290\"]'),(5168,'inventory.source.items.cleanup','[\"NWPC\"]'),(5169,'inventory.source.items.cleanup','[\"NWSR\"]'),(5170,'inventory.source.items.cleanup','[\"NWSR1290\"]'),(5171,'inventory.source.items.cleanup','[\"Pacific Pivot Shower Door\"]'),(5172,'inventory.source.items.cleanup','[\"PBP6B2B60\"]'),(5173,'inventory.source.items.cleanup','[\"PBP6B5B60\"]'),(5174,'inventory.source.items.cleanup','[\"PBP6B6B60\"]'),(5175,'inventory.source.items.cleanup','[\"PCH6A5B90\"]'),(5176,'inventory.source.items.cleanup','[\"PCI6A5B90\"]'),(5177,'inventory.source.items.cleanup','[\"PCP6A5B90\"]'),(5178,'inventory.source.items.cleanup','[\"PCP6A6B90\"]'),(5179,'inventory.source.items.cleanup','[\"PCQ7A5B90\"]'),(5180,'inventory.source.items.cleanup','[\"PCR9A5B90\"]'),(5181,'inventory.source.items.cleanup','[\"PCS7A5B90\"]'),(5182,'inventory.source.items.cleanup','[\"PEARL-BLK\"]'),(5183,'inventory.source.items.cleanup','[\"PEARL-SS\"]'),(5184,'inventory.source.items.cleanup','[\"PEARL-WH\"]'),(5185,'inventory.source.items.cleanup','[\"PEARL-WH-MATT\"]'),(5186,'inventory.source.items.cleanup','[\"PGP6B5B60\"]'),(5187,'inventory.source.items.cleanup','[\"PGP6B5B90\"]'),(5188,'inventory.source.items.cleanup','[\"PGQ7B5B90\"]'),(5189,'inventory.source.items.cleanup','[\"PIB375FB1E\"]'),(5190,'inventory.source.items.cleanup','[\"PIE611B15E\"]'),(5191,'inventory.source.items.cleanup','[\"PIE811B15E\"]'),(5192,'inventory.source.items.cleanup','[\"PIV851FB1E\"]'),(5193,'inventory.source.items.cleanup','[\"PLAT-BLK-55\"]'),(5194,'inventory.source.items.cleanup','[\"PLAT-BLK-80\"]'),(5195,'inventory.source.items.cleanup','[\"PLAT-WH-55\"]'),(5196,'inventory.source.items.cleanup','[\"PLAT-WH-80\"]'),(5197,'inventory.source.items.cleanup','[\"PNP6B6B90\"]'),(5198,'inventory.source.items.cleanup','[\"PPP6A6B90\"]'),(5199,'inventory.source.items.cleanup','[\"PPQ7A6B90\"]'),(5200,'inventory.source.items.cleanup','[\"PPS9A6B90\"]'),(5201,'inventory.source.items.cleanup','[\"PRC133\"]'),(5202,'inventory.source.items.cleanup','[\"PRC134\"]'),(5203,'inventory.source.items.cleanup','[\"PRC135\"]'),(5204,'inventory.source.items.cleanup','[\"PRC141\"]'),(5205,'inventory.source.items.cleanup','[\"PRC143\"]'),(5206,'inventory.source.items.cleanup','[\"PRC153\"]'),(5207,'inventory.source.items.cleanup','[\"PRC163\"]'),(5208,'inventory.source.items.cleanup','[\"PRC171\"]'),(5209,'inventory.source.items.cleanup','[\"PVQ651FC5E\"]'),(5210,'inventory.source.items.cleanup','[\"PVQ731F15E\"]'),(5211,'inventory.source.items.cleanup','[\"PVW851FB5E\"]'),(5212,'inventory.source.items.cleanup','[\"PXE651FC1E\"]'),(5213,'inventory.source.items.cleanup','[\"PXV851FC1E\"]'),(5214,'inventory.source.items.cleanup','[\"PXV875DV1E\"]'),(5215,'inventory.source.items.cleanup','[\"PXX675DV1E\"]'),(5216,'inventory.source.items.cleanup','[\"PXX875D67E\"]'),(5217,'inventory.source.items.cleanup','[\"PXX975KW1E\"]'),(5218,'inventory.source.items.cleanup','[\"PXY875KW1E\"]'),(5219,'inventory.source.items.cleanup','[\"REEF-A-60\"]'),(5220,'inventory.source.items.cleanup','[\"REEF-A-90\"]'),(5221,'inventory.source.items.cleanup','[\"Regular Cistern\"]'),(5222,'inventory.source.items.cleanup','[\"RULES-BLK-120\"]'),(5223,'inventory.source.items.cleanup','[\"RULES-BLK-60\"]'),(5224,'inventory.source.items.cleanup','[\"RULES-BLK-90\"]'),(5225,'inventory.source.items.cleanup','[\"RULES-DKT-120\"]'),(5226,'inventory.source.items.cleanup','[\"RULES-DKT-60\"]'),(5227,'inventory.source.items.cleanup','[\"RULES-DKT-90\"]'),(5228,'inventory.source.items.cleanup','[\"S153HAX02G\"]'),(5229,'inventory.source.items.cleanup','[\"S187ECX23G\"]'),(5230,'inventory.source.items.cleanup','[\"S187ZCX43G\"]'),(5231,'inventory.source.items.cleanup','[\"S189YCX02E\"]'),(5232,'inventory.source.items.cleanup','[\"S875HKX20G\"]'),(5233,'inventory.source.items.cleanup','[\"SAT001\"]'),(5234,'inventory.source.items.cleanup','[\"SKLOCK-S-60-2.0\"]'),(5235,'inventory.source.items.cleanup','[\"SKLOCK-S-90-2.0\"]'),(5236,'inventory.source.items.cleanup','[\"SLEEK2.0-SS-60\"]'),(5237,'inventory.source.items.cleanup','[\"SLEEK2.0-SS-80\"]'),(5238,'inventory.source.items.cleanup','[\"SLEEK2.0-WH-60\"]'),(5239,'inventory.source.items.cleanup','[\"SLEEK2.0-WH-80\"]'),(5240,'inventory.source.items.cleanup','[\"SMD6EDX57G\"]'),(5241,'inventory.source.items.cleanup','[\"SMD6TCX00E\"]'),(5242,'inventory.source.items.cleanup','[\"SMD6ZCX60G\"]'),(5243,'inventory.source.items.cleanup','[\"SMD8YCX03G\"]'),(5244,'inventory.source.items.cleanup','[\"SMV6ZCX01G\"]'),(5245,'inventory.source.items.cleanup','[\"SN85EX69CG\"]'),(5246,'inventory.source.items.cleanup','[\"SN95ZX61CG\"]'),(5247,'inventory.source.items.cleanup','[\"SPV4EMX21G\"]'),(5248,'inventory.source.items.cleanup','[\"SR93EX20MG\"]'),(5249,'inventory.source.items.cleanup','[\"SR93EX24MG\"]'),(5250,'inventory.source.items.cleanup','[\"STONE\"]'),(5251,'inventory.source.items.cleanup','[\"STONE-WH\"]'),(5252,'inventory.source.items.cleanup','[\"T26BB59N0\"]'),(5253,'inventory.source.items.cleanup','[\"T26BR46N0\"]'),(5254,'inventory.source.items.cleanup','[\"T26BR46S0\"]'),(5255,'inventory.source.items.cleanup','[\"T26BR46W0\"]'),(5256,'inventory.source.items.cleanup','[\"T26CB49S0\"]'),(5257,'inventory.source.items.cleanup','[\"T26CS49S0\"]'),(5258,'inventory.source.items.cleanup','[\"T26DS49N0\"]'),(5259,'inventory.source.items.cleanup','[\"T26DS49S0\"]'),(5260,'inventory.source.items.cleanup','[\"T26DS59N0\"]'),(5261,'inventory.source.items.cleanup','[\"T27BB59N0\"]'),(5262,'inventory.source.items.cleanup','[\"T27CS59S0\"]'),(5263,'inventory.source.items.cleanup','[\"T27DS59N0\"]'),(5264,'inventory.source.items.cleanup','[\"T27DS59S0\"]'),(5265,'inventory.source.items.cleanup','[\"T27DS79N0\"]'),(5266,'inventory.source.items.cleanup','[\"T29DS69N0\"]'),(5267,'inventory.source.items.cleanup','[\"T36FB40X0\"]'),(5268,'inventory.source.items.cleanup','[\"T36FB41X0G\"]'),(5269,'inventory.source.items.cleanup','[\"T46CB4AX2\"]'),(5270,'inventory.source.items.cleanup','[\"T46FD53X2\"]'),(5271,'inventory.source.items.cleanup','[\"T46PD53X2\"]'),(5272,'inventory.source.items.cleanup','[\"T47TD7BN2\"]'),(5273,'inventory.source.items.cleanup','[\"T48CB1AX2\"]'),(5274,'inventory.source.items.cleanup','[\"T48FD23X2\"]'),(5275,'inventory.source.items.cleanup','[\"T48PD23X2\"]'),(5276,'inventory.source.items.cleanup','[\"T48TD7BN2\"]'),(5277,'inventory.source.items.cleanup','[\"T56FD50X0\"]'),(5278,'inventory.source.items.cleanup','[\"T56FT60X0\"]'),(5279,'inventory.source.items.cleanup','[\"T58FD20X0\"]'),(5280,'inventory.source.items.cleanup','[\"T58FT20X0\"]'),(5281,'inventory.source.items.cleanup','[\"T58TL6EN2\"]'),(5282,'inventory.source.items.cleanup','[\"T59FT50X0\"]'),(5283,'inventory.source.items.cleanup','[\"T59TF6RN0\"]'),(5284,'inventory.source.items.cleanup','[\"T59TS5RN0\"]'),(5285,'inventory.source.items.cleanup','[\"T59TS61N0\"]'),(5286,'inventory.source.items.cleanup','[\"T68TF6RN0\"]'),(5287,'inventory.source.items.cleanup','[\"T68TS6RN0\"]'),(5288,'inventory.source.items.cleanup','[\"TAMAYA2.0-60\"]'),(5289,'inventory.source.items.cleanup','[\"TAMAYA2.0-90\"]'),(5290,'inventory.source.items.cleanup','[\"THIN-120\"]'),(5291,'inventory.source.items.cleanup','[\"THIN-60\"]'),(5292,'inventory.source.items.cleanup','[\"THIN-70\"]'),(5293,'inventory.source.items.cleanup','[\"THIN-90\"]'),(5294,'inventory.source.items.cleanup','[\"TONDA-60\"]'),(5295,'inventory.source.items.cleanup','[\"TONDA-90\"]'),(5296,'inventory.source.items.cleanup','[\"TRIBE-A-60\"]'),(5297,'inventory.source.items.cleanup','[\"TRIBE-A-90\"]'),(5298,'inventory.source.items.cleanup','[\"VTFW450\"]'),(5299,'inventory.source.items.cleanup','[\"VTWW450\"]'),(5300,'inventory.source.items.cleanup','[\"WRSB1200\"]'),(5301,'inventory.source.items.cleanup','[\"WRSB1400\"]'),(5302,'inventory.source.items.cleanup','[\"WRSB250\"]'),(5303,'inventory.source.items.cleanup','[\"WRSB700\"]'),(5304,'inventory.source.items.cleanup','[\"WRSB800\"]'),(5305,'inventory.source.items.cleanup','[\"WRSB900\"]'),(5306,'inventory.source.items.cleanup','[\"XTY006\"]'),(5307,'inventory.source.items.cleanup','[\"XTY007\"]'),(5308,'inventory.source.items.cleanup','[\"XTY011M03\"]'),(5309,'inventory.source.items.cleanup','[\"XTY6M01\"]'),(5310,'inventory.source.items.cleanup','[\"XTY6M02\"]'),(5311,'inventory.source.items.cleanup','[\"XTY6M03\"]'),(5312,'inventory.source.items.cleanup','[\"XTY6T01\"]'),(5313,'inventory.source.items.cleanup','[\"XTY6T02\"]'),(5314,'inventory.source.items.cleanup','[\"XTY6T03\"]'),(5315,'inventory.source.items.cleanup','[\"XTY8M01\"]'),(5316,'inventory.source.items.cleanup','[\"XTY8M02\"]'),(5317,'inventory.source.items.cleanup','[\"XTY8M03\"]'),(5318,'inventory.source.items.cleanup','[\"XTY8T01\"]'),(5319,'inventory.source.items.cleanup','[\"XTY8T02\"]'),(5320,'inventory.source.items.cleanup','[\"XTY8T03\"]'),(5321,'inventory.source.items.cleanup','[\"28939000\"]'),(5322,'inventory.source.items.cleanup','[\"28990000\"]'),(5323,'inventory.source.items.cleanup','[\"28991000\"]'),(5324,'inventory.source.items.cleanup','[\"29032000\"]'),(5325,'inventory.source.items.cleanup','[\"327248000\"]'),(5326,'inventory.source.items.cleanup','[\"327474000\"]'),(5327,'inventory.source.items.cleanup','[\"327789000\"]'),(5328,'inventory.source.items.cleanup','[\"357474000\"]'),(5329,'inventory.source.items.cleanup','[\"357475000\"]'),(5330,'inventory.source.items.cleanup','[\"357477000\"]'),(5331,'inventory.source.items.cleanup','[\"357640000\"]'),(5332,'inventory.source.items.cleanup','[\"37762SH0\"]'),(5333,'inventory.source.items.cleanup','[\"37945SH0\"]'),(5334,'inventory.source.items.cleanup','[\"38422000\"]'),(5335,'inventory.source.items.cleanup','[\"4170B003\"]'),(5336,'inventory.source.items.cleanup','[\"500.782.01.2\"]'),(5337,'inventory.source.items.cleanup','[\"5270L003-0999\"]'),(5338,'inventory.source.items.cleanup','[\"5272L003\"]'),(5339,'inventory.source.items.cleanup','[\"5474B003-0618\"]'),(5340,'inventory.source.items.cleanup','[\"5500L003\"]'),(5341,'inventory.source.items.cleanup','[\"5501L003\"]'),(5342,'inventory.source.items.cleanup','[\"5502L003\"]'),(5343,'inventory.source.items.cleanup','[\"5503L003\"]'),(5344,'inventory.source.items.cleanup','[\"5504L003\"]'),(5345,'inventory.source.items.cleanup','[\"5509L003-0288\"]'),(5346,'inventory.source.items.cleanup','[\"5521B003-0001\"]'),(5347,'inventory.source.items.cleanup','[\"5524B003\"]'),(5348,'inventory.source.items.cleanup','[\"5635B003-0001\"]'),(5349,'inventory.source.items.cleanup','[\"5750L003\"]'),(5350,'inventory.source.items.cleanup','[\"5751L003\"]'),(5351,'inventory.source.items.cleanup','[\"58140180\"]'),(5352,'inventory.source.items.cleanup','[\"6069B003-0012\"]'),(5353,'inventory.source.items.cleanup','[\"7275L003-0001\"]'),(5354,'inventory.source.items.cleanup','[\"7276L003-0001\"]'),(5355,'inventory.source.items.cleanup','[\"7277L003-0001\"]'),(5356,'inventory.source.items.cleanup','[\"7278L003-0001\"]'),(5357,'inventory.source.items.cleanup','[\"77-003-001\"]'),(5358,'inventory.source.items.cleanup','[\"77-003-009\"]'),(5359,'inventory.source.items.cleanup','[\"8013SC005\"]'),(5360,'inventory.source.items.cleanup','[\"80152\"]'),(5361,'inventory.source.items.cleanup','[\"80153200B\"]'),(5362,'inventory.source.items.cleanup','[\"801782004\"]'),(5363,'inventory.source.items.cleanup','[\"80178C004\"]'),(5364,'inventory.source.items.cleanup','[\"8019B\"]'),(5365,'inventory.source.items.cleanup','[\"801B2200B\"]'),(5366,'inventory.source.items.cleanup','[\"801B5200B\"]'),(5367,'inventory.source.items.cleanup','[\"801B8200B\"]'),(5368,'inventory.source.items.cleanup','[\"801D1\"]'),(5369,'inventory.source.items.cleanup','[\"801D30001\"]'),(5370,'inventory.source.items.cleanup','[\"890080200\"]'),(5371,'inventory.source.items.cleanup','[\"94-003-001\"]'),(5372,'inventory.source.items.cleanup','[\"94-003-009\"]'),(5373,'inventory.source.items.cleanup','[\"A3027\"]'),(5374,'inventory.source.items.cleanup','[\"A304\"]'),(5375,'inventory.source.items.cleanup','[\"A3041\"]'),(5376,'inventory.source.items.cleanup','[\"A3043\"]'),(5377,'inventory.source.items.cleanup','[\"A3064\"]'),(5378,'inventory.source.items.cleanup','[\"A3082\"]'),(5379,'inventory.source.items.cleanup','[\"A3088\"]'),(5380,'inventory.source.items.cleanup','[\"A3150G\"]'),(5381,'inventory.source.items.cleanup','[\"A3181\"]'),(5382,'inventory.source.items.cleanup','[\"A321\"]'),(5383,'inventory.source.items.cleanup','[\"A3211\"]'),(5384,'inventory.source.items.cleanup','[\"A3220\"]'),(5385,'inventory.source.items.cleanup','[\"A3221\"]'),(5386,'inventory.source.items.cleanup','[\"A3238\"]'),(5387,'inventory.source.items.cleanup','[\"A3245\"]'),(5388,'inventory.source.items.cleanup','[\"A32599400U\"]'),(5389,'inventory.source.items.cleanup','[\"A32599500U\"]'),(5390,'inventory.source.items.cleanup','[\"A32599600U\"]'),(5391,'inventory.source.items.cleanup','[\"A32599800U\"]'),(5392,'inventory.source.items.cleanup','[\"A325999000\"]'),(5393,'inventory.source.items.cleanup','[\"A3263\"]'),(5394,'inventory.source.items.cleanup','[\"A3264\"]'),(5395,'inventory.source.items.cleanup','[\"A3270A0\"]'),(5396,'inventory.source.items.cleanup','[\"A3270A1\"]'),(5397,'inventory.source.items.cleanup','[\"A3270M0004\"]'),(5398,'inventory.source.items.cleanup','[\"A3270M1004\"]'),(5399,'inventory.source.items.cleanup','[\"A3270MA004\"]'),(5400,'inventory.source.items.cleanup','[\"A3270MB004\"]'),(5401,'inventory.source.items.cleanup','[\"A354\"]'),(5402,'inventory.source.items.cleanup','[\"A355\"]'),(5403,'inventory.source.items.cleanup','[\"A357527000\"]'),(5404,'inventory.source.items.cleanup','[\"A3600\"]'),(5405,'inventory.source.items.cleanup','[\"A371\"]'),(5406,'inventory.source.items.cleanup','[\"A383\"]'),(5407,'inventory.source.items.cleanup','[\"A505400000\"]'),(5408,'inventory.source.items.cleanup','[\"A525220603\"]'),(5409,'inventory.source.items.cleanup','[\"A9115AA\"]'),(5410,'inventory.source.items.cleanup','[\"A9116AA\"]'),(5411,'inventory.source.items.cleanup','[\"A9122AA\"]'),(5412,'inventory.source.items.cleanup','[\"A9123AA\"]'),(5413,'inventory.source.items.cleanup','[\"A9127AA\"]'),(5414,'inventory.source.items.cleanup','[\"A9129AA\"]'),(5415,'inventory.source.items.cleanup','[\"A9130AA\"]'),(5416,'inventory.source.items.cleanup','[\"A9132AA\"]'),(5417,'inventory.source.items.cleanup','[\"ACC001\"]'),(5418,'inventory.source.items.cleanup','[\"AL0101AWHA\"]'),(5419,'inventory.source.items.cleanup','[\"Arlo 550 Basin\"]'),(5420,'inventory.source.items.cleanup','[\"ARM01\"]'),(5421,'inventory.source.items.cleanup','[\"ARM03\"]'),(5422,'inventory.source.items.cleanup','[\"ARM06\"]'),(5423,'inventory.source.items.cleanup','[\"ARM07\"]'),(5424,'inventory.source.items.cleanup','[\"ARM12\"]'),(5425,'inventory.source.items.cleanup','[\"ARM13\"]'),(5426,'inventory.source.items.cleanup','[\"ARM15\"]'),(5427,'inventory.source.items.cleanup','[\"ARM16\"]'),(5428,'inventory.source.items.cleanup','[\"B080-901\"]'),(5429,'inventory.source.items.cleanup','[\"B090-901\"]'),(5430,'inventory.source.items.cleanup','[\"B110-901\"]'),(5431,'inventory.source.items.cleanup','[\"B120-901\"]'),(5432,'inventory.source.items.cleanup','[\"B122-901\"]'),(5433,'inventory.source.items.cleanup','[\"B270-000\"]'),(5434,'inventory.source.items.cleanup','[\"B57-0245\"]'),(5435,'inventory.source.items.cleanup','[\"B600\"]'),(5436,'inventory.source.items.cleanup','[\"B604\"]'),(5437,'inventory.source.items.cleanup','[\"B606\"]'),(5438,'inventory.source.items.cleanup','[\"B640-000\"]'),(5439,'inventory.source.items.cleanup','[\"B641-000\"]'),(5440,'inventory.source.items.cleanup','[\"BDJ002\"]'),(5441,'inventory.source.items.cleanup','[\"BEB060-901\"]'),(5442,'inventory.source.items.cleanup','[\"BEB23-1500\"]'),(5443,'inventory.source.items.cleanup','[\"BS000000\"]'),(5444,'inventory.source.items.cleanup','[\"BS000001\"]'),(5445,'inventory.source.items.cleanup','[\"BS04600\"]'),(5446,'inventory.source.items.cleanup','[\"BS500CP\"]'),(5447,'inventory.source.items.cleanup','[\"BS600CP\"]'),(5448,'inventory.source.items.cleanup','[\"BS700CP\"]'),(5449,'inventory.source.items.cleanup','[\"BST26053\"]'),(5450,'inventory.source.items.cleanup','[\"BST26059\"]'),(5451,'inventory.source.items.cleanup','[\"CCT004\"]'),(5452,'inventory.source.items.cleanup','[\"Chancery 500 Basin\"]'),(5453,'inventory.source.items.cleanup','[\"CIV002\"]'),(5454,'inventory.source.items.cleanup','[\"CIV004\"]'),(5455,'inventory.source.items.cleanup','[\"CIV005\"]'),(5456,'inventory.source.items.cleanup','[\"CLG004\"]'),(5457,'inventory.source.items.cleanup','[\"CLW003\"]'),(5458,'inventory.source.items.cleanup','[\"CM0101AWHA\"]'),(5459,'inventory.source.items.cleanup','[\"CML002\"]'),(5460,'inventory.source.items.cleanup','[\"CO0601AWHA\"]'),(5461,'inventory.source.items.cleanup','[\"CO0701AWHA\"]'),(5462,'inventory.source.items.cleanup','[\"CO0801AWHA\"]'),(5463,'inventory.source.items.cleanup','[\"CO0901AWHA\"]'),(5464,'inventory.source.items.cleanup','[\"CO0902AWHA\"]'),(5465,'inventory.source.items.cleanup','[\"CO1004AWHA\"]'),(5466,'inventory.source.items.cleanup','[\"CO2401AWHA\"]'),(5467,'inventory.source.items.cleanup','[\"CO2601AWHA\"]'),(5468,'inventory.source.items.cleanup','[\"CO2801AWHA\"]'),(5469,'inventory.source.items.cleanup','[\"CO2901NCHAWHA\"]'),(5470,'inventory.source.items.cleanup','[\"Concept Sphere Semi-Countertop\"]'),(5471,'inventory.source.items.cleanup','[\"CPC023\"]'),(5472,'inventory.source.items.cleanup','[\"CPC024\"]'),(5473,'inventory.source.items.cleanup','[\"CPV002\"]'),(5474,'inventory.source.items.cleanup','[\"CPV003\"]'),(5475,'inventory.source.items.cleanup','[\"CPV004\"]'),(5476,'inventory.source.items.cleanup','[\"CSS002\"]'),(5477,'inventory.source.items.cleanup','[\"CSS003\"]'),(5478,'inventory.source.items.cleanup','[\"DC0101AWHA\"]'),(5479,'inventory.source.items.cleanup','[\"E308\"]'),(5480,'inventory.source.items.cleanup','[\"E309\"]'),(5481,'inventory.source.items.cleanup','[\"E310201\"]'),(5482,'inventory.source.items.cleanup','[\"E347\"]'),(5483,'inventory.source.items.cleanup','[\"E348\"]'),(5484,'inventory.source.items.cleanup','[\"E353\"]'),(5485,'inventory.source.items.cleanup','[\"E500401\"]'),(5486,'inventory.source.items.cleanup','[\"E500601\"]'),(5487,'inventory.source.items.cleanup','[\"E500801\"]'),(5488,'inventory.source.items.cleanup','[\"E501101\"]'),(5489,'inventory.source.items.cleanup','[\"E501301\"]'),(5490,'inventory.source.items.cleanup','[\"E501501\"]'),(5491,'inventory.source.items.cleanup','[\"E502301\"]'),(5492,'inventory.source.items.cleanup','[\"E502401\"]'),(5493,'inventory.source.items.cleanup','[\"E502601\"]'),(5494,'inventory.source.items.cleanup','[\"E502701\"]'),(5495,'inventory.source.items.cleanup','[\"E784201\"]'),(5496,'inventory.source.items.cleanup','[\"E785201\"]'),(5497,'inventory.source.items.cleanup','[\"E788101\"]'),(5498,'inventory.source.items.cleanup','[\"E794301\"]'),(5499,'inventory.source.items.cleanup','[\"E797601\"]'),(5500,'inventory.source.items.cleanup','[\"E803101\"]'),(5501,'inventory.source.items.cleanup','[\"EA329\"]'),(5502,'inventory.source.items.cleanup','[\"EA370\"]'),(5503,'inventory.source.items.cleanup','[\"EA381\"]'),(5504,'inventory.source.items.cleanup','[\"EA384\"]'),(5505,'inventory.source.items.cleanup','[\"EA385\"]'),(5506,'inventory.source.items.cleanup','[\"EFB1100 GG\"]'),(5507,'inventory.source.items.cleanup','[\"EHW300HP\"]'),(5508,'inventory.source.items.cleanup','[\"EK310\"]'),(5509,'inventory.source.items.cleanup','[\"EPB900\"]'),(5510,'inventory.source.items.cleanup','[\"EPD\"]'),(5511,'inventory.source.items.cleanup','[\"EPH\"]'),(5512,'inventory.source.items.cleanup','[\"EPS\"]'),(5513,'inventory.source.items.cleanup','[\"ER03\"]'),(5514,'inventory.source.items.cleanup','[\"ER07\"]'),(5515,'inventory.source.items.cleanup','[\"ERSBS0\"]'),(5516,'inventory.source.items.cleanup','[\"ERSS1\"]'),(5517,'inventory.source.items.cleanup','[\"ERSSQ\"]'),(5518,'inventory.source.items.cleanup','[\"Hansgrohe Flexaplus S\"]'),(5519,'inventory.source.items.cleanup','[\"HAR07AWHA\"]'),(5520,'inventory.source.items.cleanup','[\"HAR08AWHA\"]'),(5521,'inventory.source.items.cleanup','[\"HAR101AWHA\"]'),(5522,'inventory.source.items.cleanup','[\"HAR102AWHA\"]'),(5523,'inventory.source.items.cleanup','[\"HAR14AWHA\"]'),(5524,'inventory.source.items.cleanup','[\"HEAD01\"]'),(5525,'inventory.source.items.cleanup','[\"HEAD16\"]'),(5526,'inventory.source.items.cleanup','[\"HEAD21\"]'),(5527,'inventory.source.items.cleanup','[\"HEAD26\"]'),(5528,'inventory.source.items.cleanup','[\"HEAD45\"]'),(5529,'inventory.source.items.cleanup','[\"HEAD46\"]'),(5530,'inventory.source.items.cleanup','[\"HEAD47\"]'),(5531,'inventory.source.items.cleanup','[\"HEAD48\"]'),(5532,'inventory.source.items.cleanup','[\"HEAD49\"]'),(5533,'inventory.source.items.cleanup','[\"HEAD50\"]'),(5534,'inventory.source.items.cleanup','[\"HEAD58\"]'),(5535,'inventory.source.items.cleanup','[\"HEAD66\"]'),(5536,'inventory.source.items.cleanup','[\"HEAD80\"]'),(5537,'inventory.source.items.cleanup','[\"HEAD81\"]'),(5538,'inventory.source.items.cleanup','[\"HEAD82\"]'),(5539,'inventory.source.items.cleanup','[\"HG AddStoris\"]'),(5540,'inventory.source.items.cleanup','[\"HIB 31100\"]'),(5541,'inventory.source.items.cleanup','[\"HIB 31200\"]'),(5542,'inventory.source.items.cleanup','[\"HIB 31300\"]'),(5543,'inventory.source.items.cleanup','[\"HIB 31400\"]'),(5544,'inventory.source.items.cleanup','[\"HIB 31500\"]'),(5545,'inventory.source.items.cleanup','[\"HIB 31600\"]'),(5546,'inventory.source.items.cleanup','[\"HIB 31700\"]'),(5547,'inventory.source.items.cleanup','[\"HIB 31800\"]'),(5548,'inventory.source.items.cleanup','[\"HIB 32200\"]'),(5549,'inventory.source.items.cleanup','[\"HIB 32300\"]'),(5550,'inventory.source.items.cleanup','[\"HIB 32600\"]'),(5551,'inventory.source.items.cleanup','[\"HIB 32700\"]'),(5552,'inventory.source.items.cleanup','[\"HIB 32800\"]'),(5553,'inventory.source.items.cleanup','[\"HIB 32900\"]'),(5554,'inventory.source.items.cleanup','[\"HIB 33100\"]'),(5555,'inventory.source.items.cleanup','[\"HIB 33200\"]'),(5556,'inventory.source.items.cleanup','[\"HIB 33300\"]'),(5557,'inventory.source.items.cleanup','[\"HIB 33400\"]'),(5558,'inventory.source.items.cleanup','[\"HIB 33500\"]'),(5559,'inventory.source.items.cleanup','[\"HIB 33600\"]'),(5560,'inventory.source.items.cleanup','[\"HIB 33700\"]'),(5561,'inventory.source.items.cleanup','[\"HIB 33800\"]'),(5562,'inventory.source.items.cleanup','[\"HIB 33900\"]'),(5563,'inventory.source.items.cleanup','[\"HIB 34000\"]'),(5564,'inventory.source.items.cleanup','[\"HIB 34500\"]'),(5565,'inventory.source.items.cleanup','[\"HIB 34600\"]'),(5566,'inventory.source.items.cleanup','[\"HIB 34700\"]'),(5567,'inventory.source.items.cleanup','[\"HIB 34800\"]'),(5568,'inventory.source.items.cleanup','[\"HIB Minimalist\"]'),(5569,'inventory.source.items.cleanup','[\"HIB Vanya\"]'),(5570,'inventory.source.items.cleanup','[\"HO302\"]'),(5571,'inventory.source.items.cleanup','[\"HO306\"]'),(5572,'inventory.source.items.cleanup','[\"HO307\"]'),(5573,'inventory.source.items.cleanup','[\"HO310\"]'),(5574,'inventory.source.items.cleanup','[\"HR Round Plate\"]'),(5575,'inventory.source.items.cleanup','[\"L6210AA\"]'),(5576,'inventory.source.items.cleanup','[\"LA371\"]'),(5577,'inventory.source.items.cleanup','[\"LA380\"]'),(5578,'inventory.source.items.cleanup','[\"LA386\"]'),(5579,'inventory.source.items.cleanup','[\"LL306\"]'),(5580,'inventory.source.items.cleanup','[\"LL308\"]'),(5581,'inventory.source.items.cleanup','[\"Luna 420 Basin\"]'),(5582,'inventory.source.items.cleanup','[\"Luna 520 Basin\"]'),(5583,'inventory.source.items.cleanup','[\"Maya 550 Basin\"]'),(5584,'inventory.source.items.cleanup','[\"Maya 650 Basin\"]'),(5585,'inventory.source.items.cleanup','[\"Maya 850 Basin\"]'),(5586,'inventory.source.items.cleanup','[\"Memoria Seat\"]'),(5587,'inventory.source.items.cleanup','[\"Milton Wash Basin\"]'),(5588,'inventory.source.items.cleanup','[\"MORBD2015AWHA\"]'),(5589,'inventory.source.items.cleanup','[\"MORBD2100AWHA\"]'),(5590,'inventory.source.items.cleanup','[\"MORCT5400AWHA\"]'),(5591,'inventory.source.items.cleanup','[\"MORSR5501AWHA\"]'),(5592,'inventory.source.items.cleanup','[\"MORWB5001AWHA\"]'),(5593,'inventory.source.items.cleanup','[\"MORWB5501AWHA\"]'),(5594,'inventory.source.items.cleanup','[\"MORWB6001AWHA\"]'),(5595,'inventory.source.items.cleanup','[\"MORWB6501AWHA\"]'),(5596,'inventory.source.items.cleanup','[\"MP0101AWHA\"]'),(5597,'inventory.source.items.cleanup','[\"MP0701AWHA\"]'),(5598,'inventory.source.items.cleanup','[\"MP0901AWHA\"]'),(5599,'inventory.source.items.cleanup','[\"MP09AWHA\"]'),(5600,'inventory.source.items.cleanup','[\"MP18AWHA\"]'),(5601,'inventory.source.items.cleanup','[\"NBBS1\"]'),(5602,'inventory.source.items.cleanup','[\"NBBSR1\"]'),(5603,'inventory.source.items.cleanup','[\"NBV005\"]'),(5604,'inventory.source.items.cleanup','[\"NBV006\"]'),(5605,'inventory.source.items.cleanup','[\"NBV102\"]'),(5606,'inventory.source.items.cleanup','[\"NBV106\"]'),(5607,'inventory.source.items.cleanup','[\"NBV124\"]'),(5608,'inventory.source.items.cleanup','[\"NCA104\"]'),(5609,'inventory.source.items.cleanup','[\"NCG300\"]'),(5610,'inventory.source.items.cleanup','[\"NCG400\"]'),(5611,'inventory.source.items.cleanup','[\"NCS0\"]'),(5612,'inventory.source.items.cleanup','[\"NCS1\"]'),(5613,'inventory.source.items.cleanup','[\"NCS809\"]'),(5614,'inventory.source.items.cleanup','[\"NCS829\"]'),(5615,'inventory.source.items.cleanup','[\"NCSR1\"]'),(5616,'inventory.source.items.cleanup','[\"NCT102\"]'),(5617,'inventory.source.items.cleanup','[\"NCU862\"]'),(5618,'inventory.source.items.cleanup','[\"NCU932\"]'),(5619,'inventory.source.items.cleanup','[\"NCU942\"]'),(5620,'inventory.source.items.cleanup','[\"NLS199\"]'),(5621,'inventory.source.items.cleanup','[\"NOVA30\"]'),(5622,'inventory.source.items.cleanup','[\"NSBS2\"]'),(5623,'inventory.source.items.cleanup','[\"NSBS3\"]'),(5624,'inventory.source.items.cleanup','[\"NSBSR1\"]'),(5625,'inventory.source.items.cleanup','[\"NSS1\"]'),(5626,'inventory.source.items.cleanup','[\"NSS2\"]'),(5627,'inventory.source.items.cleanup','[\"NSS6BP\"]'),(5628,'inventory.source.items.cleanup','[\"NSSQ\"]'),(5629,'inventory.source.items.cleanup','[\"NSSQ1\"]'),(5630,'inventory.source.items.cleanup','[\"NSSQ7\"]'),(5631,'inventory.source.items.cleanup','[\"NSSQBF\"]'),(5632,'inventory.source.items.cleanup','[\"NSSQR\"]'),(5633,'inventory.source.items.cleanup','[\"NSSQR2\"]'),(5634,'inventory.source.items.cleanup','[\"NSSR1\"]'),(5635,'inventory.source.items.cleanup','[\"NSSR2\"]'),(5636,'inventory.source.items.cleanup','[\"NTS002\"]'),(5637,'inventory.source.items.cleanup','[\"NTS010\"]'),(5638,'inventory.source.items.cleanup','[\"NTS302\"]'),(5639,'inventory.source.items.cleanup','[\"NTS303\"]'),(5640,'inventory.source.items.cleanup','[\"Nuie Harmony Basin\"]'),(5641,'inventory.source.items.cleanup','[\"OC04AWHA\"]'),(5642,'inventory.source.items.cleanup','[\"OC116AWHA\"]'),(5643,'inventory.source.items.cleanup','[\"OC123AWHA\"]'),(5644,'inventory.source.items.cleanup','[\"OC137AWHA\"]'),(5645,'inventory.source.items.cleanup','[\"OC143AWHA\"]'),(5646,'inventory.source.items.cleanup','[\"OC160AWHA\"]'),(5647,'inventory.source.items.cleanup','[\"OC161AWHA\"]'),(5648,'inventory.source.items.cleanup','[\"OC17AWHA\"]'),(5649,'inventory.source.items.cleanup','[\"OC36AWHA\"]'),(5650,'inventory.source.items.cleanup','[\"OC37AAWHA\"]'),(5651,'inventory.source.items.cleanup','[\"OC67AWHA\"]'),(5652,'inventory.source.items.cleanup','[\"OC69AWHA\"]'),(5653,'inventory.source.items.cleanup','[\"OC71AWHA\"]'),(5654,'inventory.source.items.cleanup','[\"OC72AWHA\"]'),(5655,'inventory.source.items.cleanup','[\"ORG0701AWHA\"]'),(5656,'inventory.source.items.cleanup','[\"ORG0801AWHA\"]'),(5657,'inventory.source.items.cleanup','[\"ORG14AWHA\"]'),(5658,'inventory.source.items.cleanup','[\"ORG2601AWHA\"]'),(5659,'inventory.source.items.cleanup','[\"RAK Moon 1-TH\"]'),(5660,'inventory.source.items.cleanup','[\"RAK Morning 1-TH\"]'),(5661,'inventory.source.items.cleanup','[\"RAK Resort 1-TH\"]'),(5662,'inventory.source.items.cleanup','[\"RAK Resort Slimline\"]'),(5663,'inventory.source.items.cleanup','[\"RAK Rosa UC\"]'),(5664,'inventory.source.items.cleanup','[\"RAK Tonique 1-TH\"]'),(5665,'inventory.source.items.cleanup','[\"Rak Variant Elongated Oval\"]'),(5666,'inventory.source.items.cleanup','[\"Rak Variant Oval\"]'),(5667,'inventory.source.items.cleanup','[\"Rak Variant Rectangular\"]'),(5668,'inventory.source.items.cleanup','[\"Rak Variant Round\"]'),(5669,'inventory.source.items.cleanup','[\"Rak Variant Square\"]'),(5670,'inventory.source.items.cleanup','[\"RAK Washington 1-TH\"]'),(5671,'inventory.source.items.cleanup','[\"RAKC17124\"]'),(5672,'inventory.source.items.cleanup','[\"RAKC17149\"]'),(5673,'inventory.source.items.cleanup','[\"RAKC17151\"]'),(5674,'inventory.source.items.cleanup','[\"RAKC17153\"]'),(5675,'inventory.source.items.cleanup','[\"RAKC17158\"]'),(5676,'inventory.source.items.cleanup','[\"RAKC17159\"]'),(5677,'inventory.source.items.cleanup','[\"RAKC17160\"]'),(5678,'inventory.source.items.cleanup','[\"RAKC17190\"]'),(5679,'inventory.source.items.cleanup','[\"RAKC17194\"]'),(5680,'inventory.source.items.cleanup','[\"RAKCCW\"]'),(5681,'inventory.source.items.cleanup','[\"RAKCCW0\"]'),(5682,'inventory.source.items.cleanup','[\"RAKCCW003\"]'),(5683,'inventory.source.items.cleanup','[\"RAKCCW004\"]'),(5684,'inventory.source.items.cleanup','[\"RAKCCW005\"]'),(5685,'inventory.source.items.cleanup','[\"RAKCOM953C\"]'),(5686,'inventory.source.items.cleanup','[\"RAKCUB9901\"]'),(5687,'inventory.source.items.cleanup','[\"RAKCUB9902\"]'),(5688,'inventory.source.items.cleanup','[\"RAKCUB9903\"]'),(5689,'inventory.source.items.cleanup','[\"RAKCUB9905\"]'),(5690,'inventory.source.items.cleanup','[\"RAKCUB9906\"]'),(5691,'inventory.source.items.cleanup','[\"RAKCUB9907\"]'),(5692,'inventory.source.items.cleanup','[\"RAKCUB9908\"]'),(5693,'inventory.source.items.cleanup','[\"RAKCUB9909\"]'),(5694,'inventory.source.items.cleanup','[\"RAKCUB9910\"]'),(5695,'inventory.source.items.cleanup','[\"RAKCUB9912\"]'),(5696,'inventory.source.items.cleanup','[\"RAKCUB9914\"]'),(5697,'inventory.source.items.cleanup','[\"RAKGRB99\"]'),(5698,'inventory.source.items.cleanup','[\"RAKGRB9920\"]'),(5699,'inventory.source.items.cleanup','[\"RAKGRB9925\"]'),(5700,'inventory.source.items.cleanup','[\"RAKHAR99\"]'),(5701,'inventory.source.items.cleanup','[\"RAKHAR9901\"]'),(5702,'inventory.source.items.cleanup','[\"RAKHAR9902\"]'),(5703,'inventory.source.items.cleanup','[\"RAKHAR9909\"]'),(5704,'inventory.source.items.cleanup','[\"RAKHAR9912\"]'),(5705,'inventory.source.items.cleanup','[\"RAKL9022\"]'),(5706,'inventory.source.items.cleanup','[\"RAKL9023\"]'),(5707,'inventory.source.items.cleanup','[\"RAKL9025\"]'),(5708,'inventory.source.items.cleanup','[\"RAKOP10626\"]'),(5709,'inventory.source.items.cleanup','[\"RAKRBTP002\"]'),(5710,'inventory.source.items.cleanup','[\"RAKREPGW15\"]'),(5711,'inventory.source.items.cleanup','[\"RAKSBTP001\"]'),(5712,'inventory.source.items.cleanup','[\"RAKSPH9901\"]'),(5713,'inventory.source.items.cleanup','[\"RAKSPH9902\"]'),(5714,'inventory.source.items.cleanup','[\"RAKSPH9903\"]'),(5715,'inventory.source.items.cleanup','[\"RAKSPH9905\"]'),(5716,'inventory.source.items.cleanup','[\"RAKSPH9906\"]'),(5717,'inventory.source.items.cleanup','[\"RAKSPH9907\"]'),(5718,'inventory.source.items.cleanup','[\"RAKSPH9908\"]'),(5719,'inventory.source.items.cleanup','[\"RAKSPH9909\"]'),(5720,'inventory.source.items.cleanup','[\"RAKSPH9910\"]'),(5721,'inventory.source.items.cleanup','[\"RAKSPH9912\"]'),(5722,'inventory.source.items.cleanup','[\"RAKSPH9914\"]'),(5723,'inventory.source.items.cleanup','[\"Relax Cushion\"]'),(5724,'inventory.source.items.cleanup','[\"Richmond 500 Basin\"]'),(5725,'inventory.source.items.cleanup','[\"Richmond 500 Comfort Basin\"]'),(5726,'inventory.source.items.cleanup','[\"Richmond 560 Basin\"]'),(5727,'inventory.source.items.cleanup','[\"Richmond 560 Comfort Basin\"]'),(5728,'inventory.source.items.cleanup','[\"Richmond 600 Basin\"]'),(5729,'inventory.source.items.cleanup','[\"Richmond 600 Comfort Basin\"]'),(5730,'inventory.source.items.cleanup','[\"Roca Laura 520mm\"]'),(5731,'inventory.source.items.cleanup','[\"Roca Laura 560mm\"]'),(5732,'inventory.source.items.cleanup','[\"RST0101AWHA\"]'),(5733,'inventory.source.items.cleanup','[\"RST0501AWHA\"]'),(5734,'inventory.source.items.cleanup','[\"RST0701AWHA\"]'),(5735,'inventory.source.items.cleanup','[\"RST0801AWHA\"]'),(5736,'inventory.source.items.cleanup','[\"RST1001AWHA\"]'),(5737,'inventory.source.items.cleanup','[\"RST14AWHA\"]'),(5738,'inventory.source.items.cleanup','[\"RST2601AWHA\"]'),(5739,'inventory.source.items.cleanup','[\"S20 Seat\"]'),(5740,'inventory.source.items.cleanup','[\"SE0101AWHA\"]'),(5741,'inventory.source.items.cleanup','[\"SE0501AWHA\"]'),(5742,'inventory.source.items.cleanup','[\"SE0901AWHA\"]'),(5743,'inventory.source.items.cleanup','[\"SE0902AWHA\"]'),(5744,'inventory.source.items.cleanup','[\"SE0904AWHA\"]'),(5745,'inventory.source.items.cleanup','[\"SE20AWHA\"]'),(5746,'inventory.source.items.cleanup','[\"Serenada Seat\"]'),(5747,'inventory.source.items.cleanup','[\"SM0101AWHA\"]'),(5748,'inventory.source.items.cleanup','[\"SM0501AWHA\"]'),(5749,'inventory.source.items.cleanup','[\"SM0701AWHA\"]'),(5750,'inventory.source.items.cleanup','[\"SM0901AWHA\"]'),(5751,'inventory.source.items.cleanup','[\"SP14AWHA\"]'),(5752,'inventory.source.items.cleanup','[\"STB700\"]'),(5753,'inventory.source.items.cleanup','[\"STB800\"]'),(5754,'inventory.source.items.cleanup','[\"STY069\"]'),(5755,'inventory.source.items.cleanup','[\"STY070\"]'),(5756,'inventory.source.items.cleanup','[\"STY072\"]'),(5757,'inventory.source.items.cleanup','[\"T9923EO\"]'),(5758,'inventory.source.items.cleanup','[\"T9924EO\"]'),(5759,'inventory.source.items.cleanup','[\"TQ0701AWHA\"]'),(5760,'inventory.source.items.cleanup','[\"TQ0801AWHA\"]'),(5761,'inventory.source.items.cleanup','[\"TQ0901AWHA\"]'),(5762,'inventory.source.items.cleanup','[\"TQ14AWHA\"]'),(5763,'inventory.source.items.cleanup','[\"VARCT13600AWHA\"]'),(5764,'inventory.source.items.cleanup','[\"VARCT14201AWHA\"]'),(5765,'inventory.source.items.cleanup','[\"VARCT25000AWHA\"]'),(5766,'inventory.source.items.cleanup','[\"VARCT25001AWHA\"]'),(5767,'inventory.source.items.cleanup','[\"VARCT36000AWHA\"]'),(5768,'inventory.source.items.cleanup','[\"VARCT36001AWHA\"]'),(5769,'inventory.source.items.cleanup','[\"VARCT43600AWHA\"]'),(5770,'inventory.source.items.cleanup','[\"VARCT44201AWHA\"]'),(5771,'inventory.source.items.cleanup','[\"VARCT55500AWHA\"]'),(5772,'inventory.source.items.cleanup','[\"VARCT55501AWHA\"]'),(5773,'inventory.source.items.cleanup','[\"VARDI13600AWHA\"]'),(5774,'inventory.source.items.cleanup','[\"VARDI14201AWHA\"]'),(5775,'inventory.source.items.cleanup','[\"VARDI25000AWHA\"]'),(5776,'inventory.source.items.cleanup','[\"VARDI25001AWHA\"]'),(5777,'inventory.source.items.cleanup','[\"VARDI36000AWHA\"]'),(5778,'inventory.source.items.cleanup','[\"VARDI36001AWHA\"]'),(5779,'inventory.source.items.cleanup','[\"VARDI43600AWHA\"]'),(5780,'inventory.source.items.cleanup','[\"VARDI44201AWHA\"]'),(5781,'inventory.source.items.cleanup','[\"VARDI55500AWHA\"]'),(5782,'inventory.source.items.cleanup','[\"VARDI55501AWHA\"]'),(5783,'inventory.source.items.cleanup','[\"VARUC13600AWHA\"]'),(5784,'inventory.source.items.cleanup','[\"VARUC25000AWHA\"]'),(5785,'inventory.source.items.cleanup','[\"VARUC36000AWHA\"]'),(5786,'inventory.source.items.cleanup','[\"VARUC43600AWHA\"]'),(5787,'inventory.source.items.cleanup','[\"VARUC55500AWHA\"]'),(5788,'inventory.source.items.cleanup','[\"Vessels Basin\"]'),(5789,'inventory.source.items.cleanup','[\"WRSC070\"]'),(5790,'inventory.source.items.cleanup','[\"WRSC080\"]'),(5791,'inventory.source.items.cleanup','[\"WRSC090\"]'),(5792,'inventory.source.items.cleanup','[\"WRSC10\"]'),(5793,'inventory.source.items.cleanup','[\"WRSC12\"]'),(5794,'inventory.source.items.cleanup','[\"WRSC14\"]'),(5795,'inventory.source.items.cleanup','[\"WT0101AWHA\"]'),(5796,'inventory.source.items.cleanup','[\"WT0401AWHA\"]'),(5797,'inventory.source.items.cleanup','[\"WT0701AWHA\"]'),(5798,'inventory.source.items.cleanup','[\"WT07AWHA\"]'),(5799,'inventory.source.items.cleanup','[\"WT0801AWHA\"]'),(5800,'inventory.source.items.cleanup','[\"Z0007521\"]'),(5801,'inventory.source.items.cleanup','[\"Z0008669\"]'),(5802,'inventory.source.items.cleanup','[\"Zentrum Basin\"]'),(5803,'inventory.source.items.cleanup','[\"test-configurable\"]'),(5804,'inventory.source.items.cleanup','[\"test-configurable-Red\"]'),(5805,'inventory.source.items.cleanup','[\"test-configurable-black\"]'),(5806,'inventory.source.items.cleanup','[\"test-configurable-green\"]'),(5807,'inventory.source.items.cleanup','[\"Reginox Comfort Colorado L Integrated 1 Bowl Kitchen\"]'),(5808,'inventory.source.items.cleanup','[\"Reginox Comfort C\"]'),(5809,'inventory.source.items.cleanup','[\"Reginox Comfort Colorado L Integrated 1 Bow\"]'),(5810,'catalog_website_attribute_value_sync','{\"id\":null,\"bulk_uuid\":\"94a31f6b-e45b-495f-a9c5-f58c4f32525a\",\"topic_name\":\"catalog_website_attribute_value_sync\",\"serialized_data\":\"{\\\"store_id\\\":5}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}'),(5811,'inventory.source.items.cleanup','[\"1080-000\"]'),(5812,'inventory.source.items.cleanup','[\"1180-000\"]'),(5813,'inventory.source.items.cleanup','[\"1200-000\"]'),(5814,'inventory.source.items.cleanup','[\"1210-000\"]'),(5815,'inventory.source.items.cleanup','[\"1220-000\"]'),(5816,'inventory.source.items.cleanup','[\"1230-000\"]'),(5817,'inventory.source.items.cleanup','[\"1240-000\"]'),(5818,'inventory.source.items.cleanup','[\"1250-000\"]'),(5819,'inventory.source.items.cleanup','[\"1251-000\"]'),(5820,'inventory.source.items.cleanup','[\"1252-000\"]'),(5821,'inventory.source.items.cleanup','[\"1253-000\"]'),(5822,'inventory.source.items.cleanup','[\"1265-000\"]'),(5823,'inventory.source.items.cleanup','[\"1266-000\"]'),(5824,'inventory.source.items.cleanup','[\"1267-000\"]'),(5825,'inventory.source.items.cleanup','[\"1268-000\"]'),(5826,'inventory.source.items.cleanup','[\"1269-000\"]'),(5827,'inventory.source.items.cleanup','[\"1270-000\"]'),(5828,'inventory.source.items.cleanup','[\"1271-000\"]'),(5829,'inventory.source.items.cleanup','[\"1272-000\"]'),(5830,'inventory.source.items.cleanup','[\"1273-000\"]'),(5831,'inventory.source.items.cleanup','[\"1300-000\"]'),(5832,'inventory.source.items.cleanup','[\"1380-000\"]'),(5833,'inventory.source.items.cleanup','[\"1430-000\"]'),(5834,'inventory.source.items.cleanup','[\"1450-000\"]'),(5835,'inventory.source.items.cleanup','[\"1620-000\"]'),(5836,'inventory.source.items.cleanup','[\"1630-000\"]'),(5837,'inventory.source.items.cleanup','[\"1631-000\"]'),(5838,'inventory.source.items.cleanup','[\"1641-000\"]'),(5839,'inventory.source.items.cleanup','[\"1642-000\"]'),(5840,'inventory.source.items.cleanup','[\"1643-000\"]'),(5841,'inventory.source.items.cleanup','[\"1730-000\"]'),(5842,'inventory.source.items.cleanup','[\"1830-000\"]'),(5843,'inventory.source.items.cleanup','[\"2.21E+03\"]'),(5844,'inventory.source.items.cleanup','[\"2370J 2370K\"]'),(5845,'inventory.source.items.cleanup','[\"2375L3000\"]'),(5846,'inventory.source.items.cleanup','[\"24717000\"]'),(5847,'inventory.source.items.cleanup','[\"24718000\"]'),(5848,'inventory.source.items.cleanup','[\"24719000\"]'),(5849,'inventory.source.items.cleanup','[\"2540-000\"]'),(5850,'inventory.source.items.cleanup','[\"2560-000\"]'),(5851,'inventory.source.items.cleanup','[\"2590-000\"]'),(5852,'inventory.source.items.cleanup','[\"2680-000\"]'),(5853,'inventory.source.items.cleanup','[\"2700-000\"]'),(5854,'inventory.source.items.cleanup','[\"2720-000\"]'),(5855,'inventory.source.items.cleanup','[\"2740-000\"]'),(5856,'inventory.source.items.cleanup','[\"2745-000\"]'),(5857,'inventory.source.items.cleanup','[\"2940-000\"]'),(5858,'inventory.source.items.cleanup','[\"2941-000\"]'),(5859,'inventory.source.items.cleanup','[\"2942-000\"]'),(5860,'inventory.source.items.cleanup','[\"2943-000\"]'),(5861,'inventory.source.items.cleanup','[\"2944-000\"]'),(5862,'inventory.source.items.cleanup','[\"2945-000\"]'),(5863,'inventory.source.items.cleanup','[\"2946-000\"]'),(5864,'inventory.source.items.cleanup','[\"2947-000\"]'),(5865,'inventory.source.items.cleanup','[\"2948-000\"]'),(5866,'inventory.source.items.cleanup','[\"2949-000\"]'),(5867,'inventory.source.items.cleanup','[\"2950-000\"]'),(5868,'inventory.source.items.cleanup','[\"2951-000\"]'),(5869,'inventory.source.items.cleanup','[\"3020-000\"]'),(5870,'inventory.source.items.cleanup','[\"3060-000\"]'),(5871,'inventory.source.items.cleanup','[\"3100-000\"]'),(5872,'inventory.source.items.cleanup','[\"3108-000\"]'),(5873,'inventory.source.items.cleanup','[\"3109-000\"]'),(5874,'inventory.source.items.cleanup','[\"3110-000\"]'),(5875,'inventory.source.items.cleanup','[\"3111-000\"]'),(5876,'inventory.source.items.cleanup','[\"3112-000\"]'),(5877,'inventory.source.items.cleanup','[\"3310-000\"]'),(5878,'inventory.source.items.cleanup','[\"3311-000\"]'),(5879,'inventory.source.items.cleanup','[\"3312-000\"]'),(5880,'inventory.source.items.cleanup','[\"3313-000\"]'),(5881,'inventory.source.items.cleanup','[\"3314-000\"]'),(5882,'inventory.source.items.cleanup','[\"3323-000\"]'),(5883,'inventory.source.items.cleanup','[\"3324-000\"]'),(5884,'inventory.source.items.cleanup','[\"3325-000\"]'),(5885,'inventory.source.items.cleanup','[\"3410-000\"]'),(5886,'inventory.source.items.cleanup','[\"3411-000\"]'),(5887,'inventory.source.items.cleanup','[\"3412-000\"]'),(5888,'inventory.source.items.cleanup','[\"3413-000\"]'),(5889,'inventory.source.items.cleanup','[\"3420-000T\"]'),(5890,'inventory.source.items.cleanup','[\"3431-000\"]'),(5891,'inventory.source.items.cleanup','[\"3432-000\"]'),(5892,'inventory.source.items.cleanup','[\"3433-000\"]'),(5893,'inventory.source.items.cleanup','[\"3473-000\"]'),(5894,'inventory.source.items.cleanup','[\"3560-000\"]'),(5895,'inventory.source.items.cleanup','[\"3650-000\"]'),(5896,'inventory.source.items.cleanup','[\"3660-000\"]'),(5897,'inventory.source.items.cleanup','[\"3760-000\"]'),(5898,'inventory.source.items.cleanup','[\"3820-000\"]'),(5899,'inventory.source.items.cleanup','[\"3860-000\"]'),(5900,'inventory.source.items.cleanup','[\"50800001000\"]'),(5901,'inventory.source.items.cleanup','[\"50810001000\"]'),(5902,'inventory.source.items.cleanup','[\"50820001000\"]'),(5903,'inventory.source.items.cleanup','[\"52280001000\"]'),(5904,'inventory.source.items.cleanup','[\"52430001000\"]'),(5905,'inventory.source.items.cleanup','[\"52510001000\"]'),(5906,'inventory.source.items.cleanup','[\"52520001000\"]'),(5907,'inventory.source.items.cleanup','[\"52530001000\"]'),(5908,'inventory.source.items.cleanup','[\"52540001000\"]'),(5909,'inventory.source.items.cleanup','[\"52660001000\"]'),(5910,'inventory.source.items.cleanup','[\"54300001000\"]'),(5911,'inventory.source.items.cleanup','[\"55180001000\"]'),(5912,'inventory.source.items.cleanup','[\"55210001000\"]'),(5913,'inventory.source.items.cleanup','[\"55230001000\"]'),(5914,'inventory.source.items.cleanup','[\"6650-000CERVK\"]'),(5915,'inventory.source.items.cleanup','[\"6660-000CERVK\"]'),(5916,'inventory.source.items.cleanup','[\"6670-000CERVK\"]'),(5917,'inventory.source.items.cleanup','[\"6677-000CERVK\"]'),(5918,'inventory.source.items.cleanup','[\"6680-000CELVK\"]'),(5919,'inventory.source.items.cleanup','[\"6690-000CELVK\"]'),(5920,'inventory.source.items.cleanup','[\"6700-000CELVK\"]'),(5921,'inventory.source.items.cleanup','[\"6720-000CELVK\"]'),(5922,'inventory.source.items.cleanup','[\"6829-000\"]'),(5923,'inventory.source.items.cleanup','[\"6830-000\"]'),(5924,'inventory.source.items.cleanup','[\"6831-000\"]'),(5925,'inventory.source.items.cleanup','[\"6832-000\"]'),(5926,'inventory.source.items.cleanup','[\"8765-000\"]'),(5927,'inventory.source.items.cleanup','[\"8772-000\"]'),(5928,'inventory.source.items.cleanup','[\"8773-000\"]'),(5929,'inventory.source.items.cleanup','[\"8774-000\"]'),(5930,'inventory.source.items.cleanup','[\"8775-000\"]'),(5931,'inventory.source.items.cleanup','[\"8831-000\"]'),(5932,'inventory.source.items.cleanup','[\"8833-000\"]'),(5933,'inventory.source.items.cleanup','[\"8835-000\"]'),(5934,'inventory.source.items.cleanup','[\"8836-000\"]'),(5935,'inventory.source.items.cleanup','[\"8839-000\"]'),(5936,'inventory.source.items.cleanup','[\"8842-000\"]'),(5937,'inventory.source.items.cleanup','[\"8850-000\"]'),(5938,'inventory.source.items.cleanup','[\"8852-000\"]'),(5939,'inventory.source.items.cleanup','[\"8854-000\"]'),(5940,'inventory.source.items.cleanup','[\"8856-000\"]'),(5941,'inventory.source.items.cleanup','[\"8859-000\"]'),(5942,'inventory.source.items.cleanup','[\"Balance Bath\"]'),(5943,'inventory.source.items.cleanup','[\"Balmoral\"]'),(5944,'inventory.source.items.cleanup','[\"BE3480-000CFXXK\"]'),(5945,'inventory.source.items.cleanup','[\"Bette Classic\"]'),(5946,'inventory.source.items.cleanup','[\"Bette Comodo\"]'),(5947,'inventory.source.items.cleanup','[\"Bette Comodo with Side Overflow\"]'),(5948,'inventory.source.items.cleanup','[\"Bette Duett\"]'),(5949,'inventory.source.items.cleanup','[\"Bette Form Steel Bath\"]'),(5950,'inventory.source.items.cleanup','[\"Bette Free\"]'),(5951,'inventory.source.items.cleanup','[\"Bette Labette\"]'),(5952,'inventory.source.items.cleanup','[\"Bette Ocean\"]'),(5953,'inventory.source.items.cleanup','[\"Bette Ocean Lowline\"]'),(5954,'inventory.source.items.cleanup','[\"Bette One\"]'),(5955,'inventory.source.items.cleanup','[\"Bette One Relax\"]'),(5956,'inventory.source.items.cleanup','[\"Bette Select\"]'),(5957,'inventory.source.items.cleanup','[\"Bette Select Overflow\"]'),(5958,'inventory.source.items.cleanup','[\"Bette Set\"]'),(5959,'inventory.source.items.cleanup','[\"Bette Starlet\"]'),(5960,'inventory.source.items.cleanup','[\"Bette Starlet Flair Oval\"]'),(5961,'inventory.source.items.cleanup','[\"Bette Starlet IV Silhouette\"]'),(5962,'inventory.source.items.cleanup','[\"Bette Starlet Oval\"]'),(5963,'inventory.source.items.cleanup','[\"Bette Starlet V\"]'),(5964,'inventory.source.items.cleanup','[\"Bolton 1690\"]'),(5965,'inventory.source.items.cleanup','[\"Bolton 1805\"]'),(5966,'inventory.source.items.cleanup','[\"BS0170201\"]'),(5967,'inventory.source.items.cleanup','[\"BT01AAWHA\"]'),(5968,'inventory.source.items.cleanup','[\"BT54AWHA\"]'),(5969,'inventory.source.items.cleanup','[\"BT55AAWHA\"]'),(5970,'inventory.source.items.cleanup','[\"BT56AWHA\"]'),(5971,'inventory.source.items.cleanup','[\"BT57AWHA\"]'),(5972,'inventory.source.items.cleanup','[\"BT58AWHA\"]'),(5973,'inventory.source.items.cleanup','[\"Chatsworth\"]'),(5974,'inventory.source.items.cleanup','[\"Ebony\"]'),(5975,'inventory.source.items.cleanup','[\"Hexham\"]'),(5976,'inventory.source.items.cleanup','[\"KABATH\\/WL\"]'),(5977,'inventory.source.items.cleanup','[\"Kensington 1495\"]'),(5978,'inventory.source.items.cleanup','[\"Kensington 1695\"]'),(5979,'inventory.source.items.cleanup','[\"Kingswood 1750\"]'),(5980,'inventory.source.items.cleanup','[\"KL111500010001\"]'),(5981,'inventory.source.items.cleanup','[\"KL111600010001\"]'),(5982,'inventory.source.items.cleanup','[\"KL111700010001\"]'),(5983,'inventory.source.items.cleanup','[\"KL111700200001\"]'),(5984,'inventory.source.items.cleanup','[\"KL111800010001\"]'),(5985,'inventory.source.items.cleanup','[\"KL111800200001\"]'),(5986,'inventory.source.items.cleanup','[\"KL112200010001\"]'),(5987,'inventory.source.items.cleanup','[\"KL112500010001\"]'),(5988,'inventory.source.items.cleanup','[\"KL112600010001\"]'),(5989,'inventory.source.items.cleanup','[\"KL112800010001\"]'),(5990,'inventory.source.items.cleanup','[\"KL112900010001\"]'),(5991,'inventory.source.items.cleanup','[\"KL220300010001\"]'),(5992,'inventory.source.items.cleanup','[\"KL224600010001\"]'),(5993,'inventory.source.items.cleanup','[\"KL225200010001\"]'),(5994,'inventory.source.items.cleanup','[\"KL233000010001\"]'),(5995,'inventory.source.items.cleanup','[\"KL233100010001\"]'),(5996,'inventory.source.items.cleanup','[\"KL233200010001\"]'),(5997,'inventory.source.items.cleanup','[\"KL234400010001\"]'),(5998,'inventory.source.items.cleanup','[\"KL235000010001\"]'),(5999,'inventory.source.items.cleanup','[\"KL235100010001\"]'),(6000,'inventory.source.items.cleanup','[\"KL235200010001\"]'),(6001,'inventory.source.items.cleanup','[\"KL235300010001\"]'),(6002,'inventory.source.items.cleanup','[\"KL266300010001\"]'),(6003,'inventory.source.items.cleanup','[\"KL266400010001\"]'),(6004,'inventory.source.items.cleanup','[\"KL266500010001\"]'),(6005,'inventory.source.items.cleanup','[\"KL267400010001\"]'),(6006,'inventory.source.items.cleanup','[\"KL267600010001\"]'),(6007,'inventory.source.items.cleanup','[\"KL267800010001\"]'),(6008,'inventory.source.items.cleanup','[\"KL272400010001\"]'),(6009,'inventory.source.items.cleanup','[\"KL272500010001\"]'),(6010,'inventory.source.items.cleanup','[\"KL274700010001\"]'),(6011,'inventory.source.items.cleanup','[\"KL274800010001\"]'),(6012,'inventory.source.items.cleanup','[\"KL274900010001\"]'),(6013,'inventory.source.items.cleanup','[\"KL275000010001\"]'),(6014,'inventory.source.items.cleanup','[\"KL275100010001\"]'),(6015,'inventory.source.items.cleanup','[\"KL290300010001\"]'),(6016,'inventory.source.items.cleanup','[\"KL290500010001\"]'),(6017,'inventory.source.items.cleanup','[\"KL290700010001\"]'),(6018,'inventory.source.items.cleanup','[\"KL290900010001\"]'),(6019,'inventory.source.items.cleanup','[\"KL291000010001\"]'),(6020,'inventory.source.items.cleanup','[\"KL291200010001\"]'),(6021,'inventory.source.items.cleanup','[\"KL291300010001\"]'),(6022,'inventory.source.items.cleanup','[\"KL291400010001\"]'),(6023,'inventory.source.items.cleanup','[\"KL291500010001\"]'),(6024,'inventory.source.items.cleanup','[\"KL292600010001\"]'),(6025,'inventory.source.items.cleanup','[\"Lambeth\"]'),(6026,'inventory.source.items.cleanup','[\"Melrose\"]'),(6027,'inventory.source.items.cleanup','[\"Melrose FA\"]'),(6028,'inventory.source.items.cleanup','[\"NBA209\"]'),(6029,'inventory.source.items.cleanup','[\"NBA210\"]'),(6030,'inventory.source.items.cleanup','[\"NBA214\"]'),(6031,'inventory.source.items.cleanup','[\"NBA405\"]'),(6032,'inventory.source.items.cleanup','[\"NBA407\"]'),(6033,'inventory.source.items.cleanup','[\"NBA409\"]'),(6034,'inventory.source.items.cleanup','[\"NBA410\"]'),(6035,'inventory.source.items.cleanup','[\"NBA414\"]'),(6036,'inventory.source.items.cleanup','[\"NBA509\"]'),(6037,'inventory.source.items.cleanup','[\"NBA510\"]'),(6038,'inventory.source.items.cleanup','[\"NBA514\"]'),(6039,'inventory.source.items.cleanup','[\"NBA605\"]'),(6040,'inventory.source.items.cleanup','[\"NBA607\"]'),(6041,'inventory.source.items.cleanup','[\"NBA609\"]'),(6042,'inventory.source.items.cleanup','[\"NBA610\"]'),(6043,'inventory.source.items.cleanup','[\"NBA614\"]'),(6044,'inventory.source.items.cleanup','[\"NBB001\"]'),(6045,'inventory.source.items.cleanup','[\"NBB002\"]'),(6046,'inventory.source.items.cleanup','[\"NBB003\"]'),(6047,'inventory.source.items.cleanup','[\"NBB004\"]'),(6048,'inventory.source.items.cleanup','[\"Neon Rectangular Bath\"]'),(6049,'inventory.source.items.cleanup','[\"Neon Shower Bath\"]'),(6050,'inventory.source.items.cleanup','[\"NLB109\"]'),(6051,'inventory.source.items.cleanup','[\"NLB110\"]'),(6052,'inventory.source.items.cleanup','[\"NLB114\"]'),(6053,'inventory.source.items.cleanup','[\"Onyx\"]'),(6054,'inventory.source.items.cleanup','[\"Opal\"]'),(6055,'inventory.source.items.cleanup','[\"Optima Bath\"]'),(6056,'inventory.source.items.cleanup','[\"Orlando 1380\"]'),(6057,'inventory.source.items.cleanup','[\"Quartz\"]'),(6058,'inventory.source.items.cleanup','[\"RAK-Cloud Bath\"]'),(6059,'inventory.source.items.cleanup','[\"RAK-Washington\"]'),(6060,'inventory.source.items.cleanup','[\"RAKWTNBAT1770\\/WL\"]'),(6061,'inventory.source.items.cleanup','[\"RAKWTNBAT1775\\/WL\"]'),(6062,'inventory.source.items.cleanup','[\"RE1701C2\"]'),(6063,'inventory.source.items.cleanup','[\"RL1490C2\"]'),(6064,'inventory.source.items.cleanup','[\"RL1501C2\"]'),(6065,'inventory.source.items.cleanup','[\"RL1690C2\"]'),(6066,'inventory.source.items.cleanup','[\"RL1705C2\"]'),(6067,'inventory.source.items.cleanup','[\"RL1707T\"]'),(6068,'inventory.source.items.cleanup','[\"RLF1500C2\"]'),(6069,'inventory.source.items.cleanup','[\"RLF1700C2\"]'),(6070,'inventory.source.items.cleanup','[\"Ruby\"]'),(6071,'inventory.source.items.cleanup','[\"Sunstone\"]'),(6072,'inventory.source.items.cleanup','[\"WBB1585\"]'),(6073,'inventory.source.items.cleanup','[\"WBB1785\"]'),(6074,'inventory.source.items.cleanup','[\"WBP1585\"]'),(6075,'inventory.source.items.cleanup','[\"WBP1685\"]'),(6076,'inventory.source.items.cleanup','[\"WBP1785\"]'),(6077,'inventory.source.items.cleanup','[\"WBS1585\"]'),(6078,'inventory.source.items.cleanup','[\"WBS1685\"]'),(6079,'inventory.source.items.cleanup','[\"WBS1785\"]'),(6080,'inventory.source.items.cleanup','[\"Westminster 1490\"]'),(6081,'inventory.source.items.cleanup','[\"Westminster 1860\"]'),(6082,'inventory.source.items.cleanup','[\"Woburn 1490\"]'),(6083,'inventory.source.items.cleanup','[\"Woburn 1675\"]'),(6084,'inventory.source.items.cleanup','[\"Woburn 1765\"]'),(6085,'product_action_attribute.website.update','{\"id\":null,\"bulk_uuid\":\"5f5b46fe-7a22-4d92-b9b8-df488e2258d8\",\"topic_name\":\"product_action_attribute.website.update\",\"serialized_data\":\"{\\\"meta_information\\\":\\\"Update website assign\\\",\\\"product_ids\\\":[\\\"5760\\\",\\\"6035\\\",\\\"6036\\\",\\\"6037\\\",\\\"6038\\\",\\\"6039\\\",\\\"6040\\\",\\\"6041\\\",\\\"6042\\\",\\\"6043\\\",\\\"6044\\\",\\\"6045\\\",\\\"6046\\\",\\\"6047\\\",\\\"6048\\\",\\\"6049\\\",\\\"6050\\\",\\\"6051\\\",\\\"6052\\\",\\\"6053\\\"],\\\"store_id\\\":0,\\\"website_id\\\":\\\"0\\\",\\\"attributes\\\":{\\\"website_assign\\\":[\\\"1\\\",\\\"2\\\",\\\"3\\\",\\\"4\\\"],\\\"website_detach\\\":[]}}\",\"result_serialized_data\":null,\"status\":4,\"result_message\":null,\"error_code\":null}');
/*!40000 ALTER TABLE `queue_message` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `queue_message_status`
--

DROP TABLE IF EXISTS `queue_message_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `queue_message_status` (
  `id` bigint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Relation ID',
  `queue_id` int unsigned NOT NULL COMMENT 'Queue ID',
  `message_id` bigint unsigned NOT NULL COMMENT 'Message ID',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `status` smallint unsigned NOT NULL COMMENT 'Message status in particular queue',
  `number_of_trials` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Number of trials to processed failed message processing',
  PRIMARY KEY (`id`),
  UNIQUE KEY `QUEUE_MESSAGE_STATUS_QUEUE_ID_MESSAGE_ID` (`queue_id`,`message_id`),
  KEY `QUEUE_MESSAGE_STATUS_MESSAGE_ID_QUEUE_MESSAGE_ID` (`message_id`),
  KEY `QUEUE_MESSAGE_STATUS_STATUS_UPDATED_AT` (`status`,`updated_at`),
  CONSTRAINT `QUEUE_MESSAGE_STATUS_MESSAGE_ID_QUEUE_MESSAGE_ID` FOREIGN KEY (`message_id`) REFERENCES `queue_message` (`id`) ON DELETE CASCADE,
  CONSTRAINT `QUEUE_MESSAGE_STATUS_QUEUE_ID_QUEUE_ID` FOREIGN KEY (`queue_id`) REFERENCES `queue` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=6086 DEFAULT CHARSET=utf8mb3 COMMENT='Relation table to keep associations between queues and messages';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `queue_message_status`
--

LOCK TABLES `queue_message_status` WRITE;
/*!40000 ALTER TABLE `queue_message_status` DISABLE KEYS */;
INSERT INTO `queue_message_status` VALUES (1,5,1,'2025-02-04 10:01:30',6,0),(2,5,2,'2025-02-04 10:01:30',6,0),(3,5,3,'2025-02-04 10:01:30',6,0),(4,5,4,'2025-02-04 10:01:31',6,0),(5,5,5,'2025-02-04 10:01:31',6,0),(6,5,6,'2025-02-04 10:01:31',6,0),(7,5,7,'2025-02-04 10:01:31',6,0),(8,5,8,'2025-02-04 10:01:31',6,0),(9,5,9,'2025-02-04 10:01:31',6,0),(10,5,10,'2025-02-04 10:01:31',6,0),(11,5,11,'2025-02-04 10:01:31',6,0),(12,5,12,'2025-02-04 10:01:31',6,0),(13,5,13,'2025-02-04 10:01:31',6,0),(14,5,14,'2025-02-04 10:01:31',6,0),(15,5,15,'2025-02-04 10:01:31',6,0),(16,5,16,'2025-02-04 10:01:31',6,0),(17,5,17,'2025-02-04 10:01:31',6,0),(18,5,18,'2025-02-04 10:01:31',6,0),(19,5,19,'2025-02-04 10:01:31',6,0),(20,5,20,'2025-02-04 10:01:31',6,0),(21,5,21,'2025-02-04 10:01:31',6,0),(22,5,22,'2025-02-04 10:01:31',6,0),(23,5,23,'2025-02-04 10:01:31',6,0),(24,5,24,'2025-02-04 10:01:31',6,0),(25,5,25,'2025-02-04 10:01:31',6,0),(26,5,26,'2025-02-04 10:01:31',6,0),(27,5,27,'2025-02-04 10:01:32',6,0),(28,5,28,'2025-02-04 10:01:32',6,0),(29,5,29,'2025-02-04 10:01:32',6,0),(30,5,30,'2025-02-04 10:01:32',6,0),(31,5,31,'2025-02-04 10:01:32',6,0),(32,5,32,'2025-02-04 10:01:32',6,0),(33,5,33,'2025-02-04 10:01:32',6,0),(34,5,34,'2025-02-04 10:01:32',6,0),(35,5,35,'2025-02-04 10:01:32',6,0),(36,5,36,'2025-02-04 10:01:32',6,0),(37,11,37,'2025-02-04 10:01:32',4,0),(38,4,38,'2025-02-04 10:01:31',4,0),(39,11,39,'2025-02-04 10:01:32',4,0),(40,11,40,'2025-02-04 10:01:32',4,0),(41,11,41,'2025-02-04 10:01:33',4,0),(42,4,42,'2025-02-04 10:01:31',4,0),(43,6,43,'2025-02-04 10:01:34',4,0),(44,6,44,'2025-02-04 10:01:37',4,0),(45,4,45,'2025-02-04 10:01:31',4,0),(46,11,46,'2025-02-04 10:01:33',4,0),(47,11,47,'2025-02-04 10:01:33',4,0),(48,11,48,'2025-02-04 10:01:33',4,0),(49,11,49,'2025-02-04 10:01:33',4,0),(50,11,50,'2025-02-04 10:01:33',4,0),(51,7,51,'2025-02-04 10:01:31',4,0),(52,7,52,'2025-02-04 10:01:31',4,0),(53,7,53,'2025-02-04 10:01:31',4,0),(54,7,54,'2025-02-04 10:01:31',4,0),(55,7,55,'2025-02-04 10:01:31',4,0),(56,7,56,'2025-02-04 10:01:31',4,0),(57,7,57,'2025-02-04 10:01:31',4,0),(58,7,58,'2025-02-04 10:01:31',4,0),(59,7,59,'2025-02-04 10:01:31',4,0),(60,7,60,'2025-02-04 10:01:31',4,0),(61,7,61,'2025-02-04 10:01:31',4,0),(62,7,62,'2025-02-04 10:01:32',4,0),(63,7,63,'2025-02-04 10:01:32',4,0),(64,7,64,'2025-02-04 10:01:32',4,0),(65,7,65,'2025-02-04 10:01:32',4,0),(66,7,66,'2025-02-04 10:01:32',4,0),(67,7,67,'2025-02-04 10:01:32',4,0),(68,7,68,'2025-02-04 10:01:32',4,0),(69,7,69,'2025-02-04 10:01:32',4,0),(70,7,70,'2025-02-04 10:01:32',4,0),(71,7,71,'2025-02-04 10:01:32',4,0),(72,7,72,'2025-02-04 10:01:32',4,0),(73,7,73,'2025-02-04 10:01:32',4,0),(74,7,74,'2025-02-04 10:01:32',4,0),(75,7,75,'2025-02-04 10:01:33',4,0),(76,7,76,'2025-02-04 10:01:33',4,0),(77,7,77,'2025-02-04 10:01:33',4,0),(78,7,78,'2025-02-04 10:01:33',4,0),(79,7,79,'2025-02-04 10:01:33',4,0),(80,7,80,'2025-02-04 10:01:33',4,0),(81,7,81,'2025-02-04 10:01:33',4,0),(82,7,82,'2025-02-04 10:01:33',4,0),(83,7,83,'2025-02-04 10:01:33',4,0),(84,7,84,'2025-02-04 10:01:33',4,0),(85,7,85,'2025-02-04 10:01:33',4,0),(86,7,86,'2025-02-04 10:01:33',4,0),(87,7,87,'2025-02-04 10:01:33',4,0),(88,7,88,'2025-02-04 10:01:34',4,0),(89,7,89,'2025-02-04 10:01:34',4,0),(90,7,90,'2025-02-04 10:01:34',4,0),(91,7,91,'2025-02-04 10:01:34',4,0),(92,7,92,'2025-02-04 10:01:34',4,0),(93,7,93,'2025-02-04 10:01:34',4,0),(94,7,94,'2025-02-04 10:01:34',4,0),(95,7,95,'2025-02-04 10:01:34',4,0),(96,7,96,'2025-02-04 10:01:34',4,0),(97,7,97,'2025-02-04 10:01:34',4,0),(98,7,98,'2025-02-04 10:01:34',4,0),(99,7,99,'2025-02-04 10:01:34',4,0),(100,7,100,'2025-02-04 10:01:34',4,0),(101,7,101,'2025-02-04 10:01:34',4,0),(102,7,102,'2025-02-04 10:01:34',4,0),(103,7,103,'2025-02-04 10:01:34',4,0),(104,7,104,'2025-02-04 10:01:34',4,0),(105,7,105,'2025-02-04 10:01:34',4,0),(106,7,106,'2025-02-04 10:01:35',4,0),(107,7,107,'2025-02-04 10:01:35',4,0),(108,7,108,'2025-02-04 10:01:35',4,0),(109,7,109,'2025-02-04 10:01:35',4,0),(110,7,110,'2025-02-04 10:01:35',4,0),(111,7,111,'2025-02-04 10:01:35',4,0),(112,7,112,'2025-02-04 10:01:35',4,0),(113,7,113,'2025-02-04 10:01:35',4,0),(114,7,114,'2025-02-04 10:01:35',4,0),(115,7,115,'2025-02-04 10:01:35',4,0),(116,7,116,'2025-02-04 10:01:35',4,0),(117,7,117,'2025-02-04 10:01:36',4,0),(118,7,118,'2025-02-04 10:01:36',4,0),(119,7,119,'2025-02-04 10:01:36',4,0),(120,7,120,'2025-02-04 10:01:36',4,0),(121,7,121,'2025-02-04 10:01:36',4,0),(122,7,122,'2025-02-04 10:01:36',4,0),(123,7,123,'2025-02-04 10:01:36',4,0),(124,7,124,'2025-02-04 10:01:36',4,0),(125,7,125,'2025-02-04 10:01:36',4,0),(126,7,126,'2025-02-04 10:01:37',4,0),(127,7,127,'2025-02-04 10:01:37',4,0),(128,7,128,'2025-02-04 10:01:37',4,0),(129,7,129,'2025-02-04 10:01:37',4,0),(130,7,130,'2025-02-04 10:01:37',4,0),(131,7,131,'2025-02-04 10:01:37',4,0),(132,7,132,'2025-02-04 10:01:37',4,0),(133,7,133,'2025-02-04 10:01:37',4,0),(134,7,134,'2025-02-04 10:01:37',4,0),(135,7,135,'2025-02-04 10:01:37',4,0),(136,7,136,'2025-02-04 10:01:38',4,0),(137,7,137,'2025-02-04 10:01:38',4,0),(138,7,138,'2025-02-04 10:01:38',4,0),(139,7,139,'2025-02-04 10:01:38',4,0),(140,7,140,'2025-02-04 10:01:38',4,0),(141,7,141,'2025-02-04 10:01:38',4,0),(142,7,142,'2025-02-04 10:01:38',4,0),(143,7,143,'2025-02-04 10:01:38',4,0),(144,7,144,'2025-02-04 10:01:38',4,0),(145,7,145,'2025-02-04 10:01:38',4,0),(146,7,146,'2025-02-04 10:01:38',4,0),(147,7,147,'2025-02-04 10:01:38',4,0),(148,7,148,'2025-02-04 10:01:38',4,0),(149,7,149,'2025-02-04 10:01:38',4,0),(150,7,150,'2025-02-04 10:01:39',4,0),(151,7,151,'2025-02-04 10:01:39',4,0),(152,7,152,'2025-02-04 10:01:39',4,0),(153,7,153,'2025-02-04 10:01:39',4,0),(154,7,154,'2025-02-04 10:01:39',4,0),(155,7,155,'2025-02-04 10:01:39',4,0),(156,7,156,'2025-02-04 10:01:39',4,0),(157,7,157,'2025-02-04 10:01:39',4,0),(158,7,158,'2025-02-04 10:01:39',4,0),(159,7,159,'2025-02-04 10:01:39',4,0),(160,7,160,'2025-02-04 10:01:39',4,0),(161,7,161,'2025-02-04 10:01:39',4,0),(162,7,162,'2025-02-04 10:01:39',4,0),(163,7,163,'2025-02-04 10:01:39',4,0),(164,7,164,'2025-02-04 10:01:39',4,0),(165,7,165,'2025-02-04 10:01:40',4,0),(166,7,166,'2025-02-04 10:01:40',4,0),(167,7,167,'2025-02-04 10:01:40',4,0),(168,7,168,'2025-02-04 10:01:40',4,0),(169,7,169,'2025-02-04 10:01:40',4,0),(170,7,170,'2025-02-04 10:01:40',4,0),(171,7,171,'2025-02-04 10:01:40',4,0),(172,7,172,'2025-02-04 10:01:40',4,0),(173,7,173,'2025-02-04 10:01:40',4,0),(174,7,174,'2025-02-04 10:01:40',4,0),(175,7,175,'2025-02-04 10:01:40',4,0),(176,7,176,'2025-02-04 10:01:40',4,0),(177,7,177,'2025-02-04 10:01:41',4,0),(178,7,178,'2025-02-04 10:01:41',4,0),(179,7,179,'2025-02-04 10:01:41',4,0),(180,7,180,'2025-02-04 10:01:41',4,0),(181,7,181,'2025-02-04 10:01:41',4,0),(182,7,182,'2025-02-04 10:01:41',4,0),(183,7,183,'2025-02-04 10:01:41',4,0),(184,7,184,'2025-02-04 10:01:41',4,0),(185,7,185,'2025-02-04 10:01:41',4,0),(186,7,186,'2025-02-04 10:01:41',4,0),(187,7,187,'2025-02-04 10:01:41',4,0),(188,7,188,'2025-02-04 10:01:41',4,0),(189,7,189,'2025-02-04 10:01:41',4,0),(190,7,190,'2025-02-04 10:01:41',4,0),(191,7,191,'2025-02-04 10:01:41',4,0),(192,7,192,'2025-02-04 10:01:41',4,0),(193,7,193,'2025-02-04 10:01:42',4,0),(194,7,194,'2025-02-04 10:01:42',4,0),(195,7,195,'2025-02-04 10:01:42',4,0),(196,7,196,'2025-02-04 10:01:42',4,0),(197,7,197,'2025-02-04 10:01:42',4,0),(198,7,198,'2025-02-04 10:01:42',4,0),(199,7,199,'2025-02-04 10:01:42',4,0),(200,7,200,'2025-02-04 10:01:42',4,0),(201,7,201,'2025-02-04 10:01:42',4,0),(202,7,202,'2025-02-04 10:01:42',4,0),(203,7,203,'2025-02-04 10:01:42',4,0),(204,7,204,'2025-02-04 10:01:42',4,0),(205,7,205,'2025-02-04 10:01:42',4,0),(206,7,206,'2025-02-04 10:01:42',4,0),(207,7,207,'2025-02-04 10:01:42',4,0),(208,7,208,'2025-02-04 10:01:42',4,0),(209,7,209,'2025-02-04 10:01:42',4,0),(210,7,210,'2025-02-04 10:01:43',4,0),(211,7,211,'2025-02-04 10:01:43',4,0),(212,7,212,'2025-02-04 10:01:43',4,0),(213,7,213,'2025-02-04 10:01:43',4,0),(214,7,214,'2025-02-04 10:01:43',4,0),(215,7,215,'2025-02-04 10:01:43',4,0),(216,7,216,'2025-02-04 10:01:43',4,0),(217,7,217,'2025-02-04 10:01:43',4,0),(218,7,218,'2025-02-04 10:01:43',4,0),(219,7,219,'2025-02-04 10:01:43',4,0),(220,7,220,'2025-02-04 10:01:43',4,0),(221,7,221,'2025-02-04 10:01:43',4,0),(222,7,222,'2025-02-04 10:01:43',4,0),(223,7,223,'2025-02-04 10:01:43',4,0),(224,7,224,'2025-02-04 10:01:43',4,0),(225,7,225,'2025-02-04 10:01:43',4,0),(226,7,226,'2025-02-04 10:01:43',4,0),(227,7,227,'2025-02-04 10:01:43',4,0),(228,7,228,'2025-02-04 10:01:43',4,0),(229,7,229,'2025-02-04 10:01:43',4,0),(230,7,230,'2025-02-04 10:01:43',4,0),(231,7,231,'2025-02-04 10:01:44',4,0),(232,7,232,'2025-02-04 10:01:44',4,0),(233,7,233,'2025-02-04 10:01:44',4,0),(234,7,234,'2025-02-04 10:01:44',4,0),(235,7,235,'2025-02-04 10:01:44',4,0),(236,7,236,'2025-02-04 10:01:44',4,0),(237,7,237,'2025-02-04 10:01:44',4,0),(238,7,238,'2025-02-04 10:01:44',4,0),(239,7,239,'2025-02-04 10:01:44',4,0),(240,7,240,'2025-02-04 10:01:44',4,0),(241,7,241,'2025-02-04 10:01:44',4,0),(242,7,242,'2025-02-04 10:01:44',4,0),(243,7,243,'2025-02-04 10:01:44',4,0),(244,7,244,'2025-02-04 10:01:44',4,0),(245,7,245,'2025-02-04 10:01:44',4,0),(246,7,246,'2025-02-04 10:01:44',4,0),(247,7,247,'2025-02-04 10:01:44',4,0),(248,7,248,'2025-02-04 10:01:44',4,0),(249,7,249,'2025-02-04 10:01:44',4,0),(250,7,250,'2025-02-04 10:01:44',4,0),(251,7,251,'2025-02-04 10:01:44',4,0),(252,7,252,'2025-02-04 10:01:45',4,0),(253,7,253,'2025-02-04 10:01:45',4,0),(254,7,254,'2025-02-04 10:01:45',4,0),(255,7,255,'2025-02-04 10:01:45',4,0),(256,7,256,'2025-02-04 10:01:45',4,0),(257,7,257,'2025-02-04 10:01:45',4,0),(258,7,258,'2025-02-04 10:01:45',4,0),(259,7,259,'2025-02-04 10:01:45',4,0),(260,7,260,'2025-02-04 10:01:45',4,0),(261,7,261,'2025-02-04 10:01:45',4,0),(262,7,262,'2025-02-04 10:01:45',4,0),(263,7,263,'2025-02-04 10:01:45',4,0),(264,7,264,'2025-02-04 10:01:45',4,0),(265,7,265,'2025-02-04 10:01:45',4,0),(266,7,266,'2025-02-04 10:01:45',4,0),(267,7,267,'2025-02-04 10:01:45',4,0),(268,7,268,'2025-02-04 10:01:45',4,0),(269,7,269,'2025-02-04 10:01:45',4,0),(270,7,270,'2025-02-04 10:01:45',4,0),(271,7,271,'2025-02-04 10:01:45',4,0),(272,7,272,'2025-02-04 10:01:46',4,0),(273,7,273,'2025-02-04 10:01:46',4,0),(274,7,274,'2025-02-04 10:01:46',4,0),(275,7,275,'2025-02-04 10:01:46',4,0),(276,7,276,'2025-02-04 10:01:46',4,0),(277,7,277,'2025-02-04 10:01:46',4,0),(278,7,278,'2025-02-04 10:01:46',4,0),(279,7,279,'2025-02-04 10:01:46',4,0),(280,7,280,'2025-02-04 10:01:46',4,0),(281,7,281,'2025-02-04 10:01:46',4,0),(282,7,282,'2025-02-04 10:01:46',4,0),(283,7,283,'2025-02-04 10:01:46',4,0),(284,7,284,'2025-02-04 10:01:46',4,0),(285,7,285,'2025-02-04 10:01:46',4,0),(286,7,286,'2025-02-04 10:01:46',4,0),(287,7,287,'2025-02-04 10:01:46',4,0),(288,7,288,'2025-02-04 10:01:46',4,0),(289,7,289,'2025-02-04 10:01:46',4,0),(290,7,290,'2025-02-04 10:01:46',4,0),(291,7,291,'2025-02-04 10:01:46',4,0),(292,7,292,'2025-02-04 10:01:46',4,0),(293,7,293,'2025-02-04 10:01:46',4,0),(294,7,294,'2025-02-04 10:01:46',4,0),(295,7,295,'2025-02-04 10:01:47',4,0),(296,7,296,'2025-02-04 10:01:47',4,0),(297,7,297,'2025-02-04 10:01:47',4,0),(298,7,298,'2025-02-04 10:01:47',4,0),(299,7,299,'2025-02-04 10:01:47',4,0),(300,7,300,'2025-02-04 10:01:47',4,0),(301,7,301,'2025-02-04 10:01:47',4,0),(302,7,302,'2025-02-04 10:01:47',4,0),(303,7,303,'2025-02-04 10:01:47',4,0),(304,7,304,'2025-02-04 10:01:47',4,0),(305,7,305,'2025-02-04 10:01:47',4,0),(306,7,306,'2025-02-04 10:01:47',4,0),(307,7,307,'2025-02-04 10:01:47',4,0),(308,7,308,'2025-02-04 10:01:47',4,0),(309,7,309,'2025-02-04 10:01:47',4,0),(310,7,310,'2025-02-04 10:01:47',4,0),(311,7,311,'2025-02-04 10:01:47',4,0),(312,7,312,'2025-02-04 10:01:47',4,0),(313,7,313,'2025-02-04 10:01:47',4,0),(314,7,314,'2025-02-04 10:01:47',4,0),(315,7,315,'2025-02-04 10:01:47',4,0),(316,7,316,'2025-02-04 10:01:47',4,0),(317,7,317,'2025-02-04 10:01:47',4,0),(318,7,318,'2025-02-04 10:01:47',4,0),(319,7,319,'2025-02-04 10:01:47',4,0),(320,7,320,'2025-02-04 10:01:47',4,0),(321,7,321,'2025-02-04 10:01:47',4,0),(322,7,322,'2025-02-04 10:01:48',4,0),(323,7,323,'2025-02-04 10:01:48',4,0),(324,7,324,'2025-02-04 10:01:48',4,0),(325,7,325,'2025-02-04 10:01:48',4,0),(326,7,326,'2025-02-04 10:01:48',4,0),(327,7,327,'2025-02-04 10:01:48',4,0),(328,7,328,'2025-02-04 10:01:48',4,0),(329,7,329,'2025-02-04 10:01:48',4,0),(330,7,330,'2025-02-04 10:01:48',4,0),(331,7,331,'2025-02-04 10:01:48',4,0),(332,7,332,'2025-02-04 10:01:48',4,0),(333,7,333,'2025-02-04 10:01:48',4,0),(334,7,334,'2025-02-04 10:01:48',4,0),(335,7,335,'2025-02-04 10:01:48',4,0),(336,7,336,'2025-02-04 10:01:48',4,0),(337,7,337,'2025-02-04 10:01:48',4,0),(338,7,338,'2025-02-04 10:01:48',4,0),(339,7,339,'2025-02-04 10:01:48',4,0),(340,7,340,'2025-02-04 10:01:48',4,0),(341,7,341,'2025-02-04 10:01:48',4,0),(342,7,342,'2025-02-04 10:01:48',4,0),(343,7,343,'2025-02-04 10:01:48',4,0),(344,7,344,'2025-02-04 10:01:48',4,0),(345,7,345,'2025-02-04 10:01:48',4,0),(346,7,346,'2025-02-04 10:01:48',4,0),(347,7,347,'2025-02-04 10:01:48',4,0),(348,7,348,'2025-02-04 10:01:48',4,0),(349,7,349,'2025-02-04 10:01:48',4,0),(350,7,350,'2025-02-04 10:01:48',4,0),(351,7,351,'2025-02-04 10:01:48',4,0),(352,7,352,'2025-02-04 10:01:48',4,0),(353,7,353,'2025-02-04 10:01:48',4,0),(354,7,354,'2025-02-04 10:01:49',4,0),(355,7,355,'2025-02-04 10:01:49',4,0),(356,7,356,'2025-02-04 10:01:49',4,0),(357,7,357,'2025-02-04 10:01:49',4,0),(358,7,358,'2025-02-04 10:01:49',4,0),(359,7,359,'2025-02-04 10:01:49',4,0),(360,7,360,'2025-02-04 10:01:49',4,0),(361,7,361,'2025-02-04 10:01:49',4,0),(362,7,362,'2025-02-04 10:01:49',4,0),(363,7,363,'2025-02-04 10:01:49',4,0),(364,7,364,'2025-02-04 10:01:49',4,0),(365,7,365,'2025-02-04 10:01:49',4,0),(366,7,366,'2025-02-04 10:01:49',4,0),(367,7,367,'2025-02-04 10:01:49',4,0),(368,7,368,'2025-02-04 10:01:49',4,0),(369,7,369,'2025-02-04 10:01:49',4,0),(370,7,370,'2025-02-04 10:01:49',4,0),(371,7,371,'2025-02-04 10:01:49',4,0),(372,7,372,'2025-02-04 10:01:49',4,0),(373,7,373,'2025-02-04 10:01:49',4,0),(374,7,374,'2025-02-04 10:01:49',4,0),(375,7,375,'2025-02-04 10:01:49',4,0),(376,7,376,'2025-02-04 10:01:49',4,0),(377,7,377,'2025-02-04 10:01:49',4,0),(378,7,378,'2025-02-04 10:01:49',4,0),(379,7,379,'2025-02-04 10:01:49',4,0),(380,7,380,'2025-02-04 10:01:49',4,0),(381,7,381,'2025-02-04 10:01:49',4,0),(382,7,382,'2025-02-04 10:01:49',4,0),(383,7,383,'2025-02-04 10:01:49',4,0),(384,7,384,'2025-02-04 10:01:49',4,0),(385,7,385,'2025-02-04 10:01:49',4,0),(386,7,386,'2025-02-04 10:01:50',4,0),(387,7,387,'2025-02-04 10:01:50',4,0),(388,7,388,'2025-02-04 10:01:50',4,0),(389,7,389,'2025-02-04 10:01:50',4,0),(390,7,390,'2025-02-04 10:01:50',4,0),(391,7,391,'2025-02-04 10:01:50',4,0),(392,7,392,'2025-02-04 10:01:50',4,0),(393,7,393,'2025-02-04 10:01:50',4,0),(394,7,394,'2025-02-04 10:01:50',4,0),(395,7,395,'2025-02-04 10:01:50',4,0),(396,7,396,'2025-02-04 10:01:50',4,0),(397,7,397,'2025-02-04 10:01:50',4,0),(398,7,398,'2025-02-04 10:01:50',4,0),(399,7,399,'2025-02-04 10:01:50',4,0),(400,7,400,'2025-02-04 10:01:50',4,0),(401,7,401,'2025-02-04 10:01:50',4,0),(402,7,402,'2025-02-04 10:01:50',4,0),(403,7,403,'2025-02-04 10:01:50',4,0),(404,7,404,'2025-02-04 10:01:50',4,0),(405,7,405,'2025-02-04 10:01:50',4,0),(406,7,406,'2025-02-04 10:01:50',4,0),(407,7,407,'2025-02-04 10:01:50',4,0),(408,7,408,'2025-02-04 10:01:50',4,0),(409,7,409,'2025-02-04 10:01:50',4,0),(410,7,410,'2025-02-04 10:01:50',4,0),(411,7,411,'2025-02-04 10:01:50',4,0),(412,7,412,'2025-02-04 10:01:50',4,0),(413,7,413,'2025-02-04 10:01:50',4,0),(414,7,414,'2025-02-04 10:01:50',4,0),(415,7,415,'2025-02-04 10:01:50',4,0),(416,7,416,'2025-02-04 10:01:50',4,0),(417,7,417,'2025-02-04 10:01:50',4,0),(418,7,418,'2025-02-04 10:01:50',4,0),(419,7,419,'2025-02-04 10:01:51',4,0),(420,7,420,'2025-02-04 10:01:51',4,0),(421,7,421,'2025-02-04 10:01:51',4,0),(422,7,422,'2025-02-04 10:01:51',4,0),(423,7,423,'2025-02-04 10:01:51',4,0),(424,7,424,'2025-02-04 10:01:51',4,0),(425,7,425,'2025-02-04 10:01:51',4,0),(426,7,426,'2025-02-04 10:01:51',4,0),(427,7,427,'2025-02-04 10:01:51',4,0),(428,7,428,'2025-02-04 10:01:51',4,0),(429,7,429,'2025-02-04 10:01:51',4,0),(430,7,430,'2025-02-04 10:01:51',4,0),(431,7,431,'2025-02-04 10:01:51',4,0),(432,7,432,'2025-02-04 10:01:51',4,0),(433,7,433,'2025-02-04 10:01:51',4,0),(434,7,434,'2025-02-04 10:01:51',4,0),(435,7,435,'2025-02-04 10:01:51',4,0),(436,7,436,'2025-02-04 10:01:51',4,0),(437,7,437,'2025-02-04 10:01:51',4,0),(438,7,438,'2025-02-04 10:01:51',4,0),(439,7,439,'2025-02-04 10:01:51',4,0),(440,7,440,'2025-02-04 10:01:51',4,0),(441,7,441,'2025-02-04 10:01:51',4,0),(442,7,442,'2025-02-04 10:01:51',4,0),(443,7,443,'2025-02-04 10:01:51',4,0),(444,7,444,'2025-02-04 10:01:51',4,0),(445,7,445,'2025-02-04 10:01:51',4,0),(446,7,446,'2025-02-04 10:01:51',4,0),(447,7,447,'2025-02-04 10:01:51',4,0),(448,7,448,'2025-02-04 10:01:51',4,0),(449,7,449,'2025-02-04 10:01:51',4,0),(450,7,450,'2025-02-04 10:01:51',4,0),(451,7,451,'2025-02-04 10:01:51',4,0),(452,7,452,'2025-02-04 10:01:51',4,0),(453,7,453,'2025-02-04 10:01:51',4,0),(454,7,454,'2025-02-04 10:01:51',4,0),(455,7,455,'2025-02-04 10:01:52',4,0),(456,7,456,'2025-02-04 10:01:52',4,0),(457,7,457,'2025-02-04 10:01:52',4,0),(458,7,458,'2025-02-04 10:01:52',4,0),(459,7,459,'2025-02-04 10:01:52',4,0),(460,7,460,'2025-02-04 10:01:52',4,0),(461,7,461,'2025-02-04 10:01:52',4,0),(462,7,462,'2025-02-04 10:01:52',4,0),(463,7,463,'2025-02-04 10:01:52',4,0),(464,7,464,'2025-02-04 10:01:52',4,0),(465,7,465,'2025-02-04 10:01:52',4,0),(466,7,466,'2025-02-04 10:01:52',4,0),(467,7,467,'2025-02-04 10:01:52',4,0),(468,7,468,'2025-02-04 10:01:52',4,0),(469,7,469,'2025-02-04 10:01:52',4,0),(470,7,470,'2025-02-04 10:01:52',4,0),(471,7,471,'2025-02-04 10:01:52',4,0),(472,7,472,'2025-02-04 10:01:52',4,0),(473,7,473,'2025-02-04 10:01:52',4,0),(474,7,474,'2025-02-04 10:01:52',4,0),(475,7,475,'2025-02-04 10:01:52',4,0),(476,7,476,'2025-02-04 10:01:52',4,0),(477,7,477,'2025-02-04 10:01:52',4,0),(478,7,478,'2025-02-04 10:01:52',4,0),(479,7,479,'2025-02-04 10:01:52',4,0),(480,7,480,'2025-02-04 10:01:52',4,0),(481,7,481,'2025-02-04 10:01:52',4,0),(482,7,482,'2025-02-04 10:01:52',4,0),(483,7,483,'2025-02-04 10:01:52',4,0),(484,7,484,'2025-02-04 10:01:52',4,0),(485,7,485,'2025-02-04 10:01:52',4,0),(486,7,486,'2025-02-04 10:01:52',4,0),(487,7,487,'2025-02-04 10:01:52',4,0),(488,7,488,'2025-02-04 10:01:52',4,0),(489,7,489,'2025-02-04 10:01:53',4,0),(490,7,490,'2025-02-04 10:01:53',4,0),(491,7,491,'2025-02-04 10:01:53',4,0),(492,7,492,'2025-02-04 10:01:53',4,0),(493,7,493,'2025-02-04 10:01:53',4,0),(494,7,494,'2025-02-04 10:01:53',4,0),(495,7,495,'2025-02-04 10:01:53',4,0),(496,7,496,'2025-02-04 10:01:53',4,0),(497,7,497,'2025-02-04 10:01:53',4,0),(498,7,498,'2025-02-04 10:01:53',4,0),(499,7,499,'2025-02-04 10:01:53',4,0),(500,7,500,'2025-02-04 10:01:53',4,0),(501,7,501,'2025-02-04 10:01:53',4,0),(502,7,502,'2025-02-04 10:01:53',4,0),(503,7,503,'2025-02-04 10:01:53',4,0),(504,7,504,'2025-02-04 10:01:53',4,0),(505,7,505,'2025-02-04 10:01:53',4,0),(506,7,506,'2025-02-04 10:01:53',4,0),(507,7,507,'2025-02-04 10:01:53',4,0),(508,7,508,'2025-02-04 10:01:53',4,0),(509,7,509,'2025-02-04 10:01:53',4,0),(510,7,510,'2025-02-04 10:01:53',4,0),(511,7,511,'2025-02-04 10:01:53',4,0),(512,7,512,'2025-02-04 10:01:53',4,0),(513,7,513,'2025-02-04 10:01:53',4,0),(514,7,514,'2025-02-04 10:01:53',4,0),(515,7,515,'2025-02-04 10:01:53',4,0),(516,7,516,'2025-02-04 10:01:53',4,0),(517,7,517,'2025-02-04 10:01:53',4,0),(518,7,518,'2025-02-04 10:01:53',4,0),(519,7,519,'2025-02-04 10:01:53',4,0),(520,7,520,'2025-02-04 10:01:53',4,0),(521,7,521,'2025-02-04 10:01:53',4,0),(522,7,522,'2025-02-04 10:01:53',4,0),(523,7,523,'2025-02-04 10:01:53',4,0),(524,7,524,'2025-02-04 10:01:53',4,0),(525,7,525,'2025-02-04 10:01:53',4,0),(526,7,526,'2025-02-04 10:01:53',4,0),(527,7,527,'2025-02-04 10:01:53',4,0),(528,7,528,'2025-02-04 10:01:54',4,0),(529,7,529,'2025-02-04 10:01:54',4,0),(530,7,530,'2025-02-04 10:01:54',4,0),(531,7,531,'2025-02-04 10:01:54',4,0),(532,7,532,'2025-02-04 10:01:54',4,0),(533,7,533,'2025-02-04 10:01:54',4,0),(534,7,534,'2025-02-04 10:01:54',4,0),(535,7,535,'2025-02-04 10:01:54',4,0),(536,7,536,'2025-02-04 10:01:54',4,0),(537,7,537,'2025-02-04 10:01:54',4,0),(538,7,538,'2025-02-04 10:01:54',4,0),(539,7,539,'2025-02-04 10:01:54',4,0),(540,7,540,'2025-02-04 10:01:54',4,0),(541,7,541,'2025-02-04 10:01:54',4,0),(542,7,542,'2025-02-04 10:01:54',4,0),(543,7,543,'2025-02-04 10:01:54',4,0),(544,7,544,'2025-02-04 10:01:54',4,0),(545,7,545,'2025-02-04 10:01:54',4,0),(546,7,546,'2025-02-04 10:01:54',4,0),(547,7,547,'2025-02-04 10:01:54',4,0),(548,7,548,'2025-02-04 10:01:54',4,0),(549,7,549,'2025-02-04 10:01:54',4,0),(550,7,550,'2025-02-04 10:01:54',4,0),(551,7,551,'2025-02-04 10:01:54',4,0),(552,7,552,'2025-02-04 10:01:54',4,0),(553,7,553,'2025-02-04 10:01:54',4,0),(554,7,554,'2025-02-04 10:01:54',4,0),(555,7,555,'2025-02-04 10:01:54',4,0),(556,7,556,'2025-02-04 10:01:54',4,0),(557,7,557,'2025-02-04 10:01:54',4,0),(558,7,558,'2025-02-04 10:01:54',4,0),(559,7,559,'2025-02-04 10:01:54',4,0),(560,7,560,'2025-02-04 10:01:54',4,0),(561,7,561,'2025-02-04 10:01:54',4,0),(562,7,562,'2025-02-04 10:01:54',4,0),(563,7,563,'2025-02-04 10:01:54',4,0),(564,7,564,'2025-02-04 10:01:54',4,0),(565,7,565,'2025-02-04 10:01:54',4,0),(566,7,566,'2025-02-04 10:01:54',4,0),(567,7,567,'2025-02-04 10:01:55',4,0),(568,7,568,'2025-02-04 10:01:55',4,0),(569,7,569,'2025-02-04 10:01:55',4,0),(570,7,570,'2025-02-04 10:01:55',4,0),(571,7,571,'2025-02-04 10:01:55',4,0),(572,7,572,'2025-02-04 10:01:55',4,0),(573,7,573,'2025-02-04 10:01:55',4,0),(574,7,574,'2025-02-04 10:01:55',4,0),(575,7,575,'2025-02-04 10:01:55',4,0),(576,7,576,'2025-02-04 10:01:55',4,0),(577,7,577,'2025-02-04 10:01:55',4,0),(578,7,578,'2025-02-04 10:01:55',4,0),(579,7,579,'2025-02-04 10:01:55',4,0),(580,7,580,'2025-02-04 10:01:55',4,0),(581,7,581,'2025-02-04 10:01:55',4,0),(582,7,582,'2025-02-04 10:01:55',4,0),(583,7,583,'2025-02-04 10:01:55',4,0),(584,7,584,'2025-02-04 10:01:55',4,0),(585,7,585,'2025-02-04 10:01:55',4,0),(586,7,586,'2025-02-04 10:01:55',4,0),(587,7,587,'2025-02-04 10:01:55',4,0),(588,7,588,'2025-02-04 10:01:55',4,0),(589,7,589,'2025-02-04 10:01:55',4,0),(590,7,590,'2025-02-04 10:01:55',4,0),(591,7,591,'2025-02-04 10:01:55',4,0),(592,7,592,'2025-02-04 10:01:55',4,0),(593,7,593,'2025-02-04 10:01:55',4,0),(594,7,594,'2025-02-04 10:01:55',4,0),(595,7,595,'2025-02-04 10:01:55',4,0),(596,7,596,'2025-02-04 10:01:55',4,0),(597,7,597,'2025-02-04 10:01:55',4,0),(598,7,598,'2025-02-04 10:01:55',4,0),(599,7,599,'2025-02-04 10:01:55',4,0),(600,7,600,'2025-02-04 10:01:56',4,0),(601,7,601,'2025-02-04 10:01:56',4,0),(602,7,602,'2025-02-04 10:01:56',4,0),(603,7,603,'2025-02-04 10:01:56',4,0),(604,7,604,'2025-02-04 10:01:56',4,0),(605,7,605,'2025-02-04 10:01:56',4,0),(606,7,606,'2025-02-04 10:01:56',4,0),(607,7,607,'2025-02-04 10:01:56',4,0),(608,7,608,'2025-02-04 10:01:56',4,0),(609,7,609,'2025-02-04 10:01:56',4,0),(610,7,610,'2025-02-04 10:01:56',4,0),(611,7,611,'2025-02-04 10:01:56',4,0),(612,7,612,'2025-02-04 10:01:56',4,0),(613,7,613,'2025-02-04 10:01:56',4,0),(614,7,614,'2025-02-04 10:01:56',4,0),(615,7,615,'2025-02-04 10:01:56',4,0),(616,7,616,'2025-02-04 10:01:56',4,0),(617,7,617,'2025-02-04 10:01:56',4,0),(618,7,618,'2025-02-04 10:01:56',4,0),(619,7,619,'2025-02-04 10:01:56',4,0),(620,7,620,'2025-02-04 10:01:56',4,0),(621,7,621,'2025-02-04 10:01:56',4,0),(622,7,622,'2025-02-04 10:01:56',4,0),(623,7,623,'2025-02-04 10:01:56',4,0),(624,7,624,'2025-02-04 10:01:56',4,0),(625,7,625,'2025-02-04 10:01:56',4,0),(626,7,626,'2025-02-04 10:01:56',4,0),(627,7,627,'2025-02-04 10:01:56',4,0),(628,7,628,'2025-02-04 10:01:56',4,0),(629,7,629,'2025-02-04 10:01:56',4,0),(630,7,630,'2025-02-04 10:01:56',4,0),(631,7,631,'2025-02-04 10:01:56',4,0),(632,7,632,'2025-02-04 10:01:56',4,0),(633,7,633,'2025-02-04 10:01:56',4,0),(634,7,634,'2025-02-04 10:01:56',4,0),(635,7,635,'2025-02-04 10:01:56',4,0),(636,7,636,'2025-02-04 10:01:57',4,0),(637,7,637,'2025-02-04 10:01:57',4,0),(638,7,638,'2025-02-04 10:01:57',4,0),(639,7,639,'2025-02-04 10:01:57',4,0),(640,7,640,'2025-02-04 10:01:57',4,0),(641,7,641,'2025-02-04 10:01:57',4,0),(642,7,642,'2025-02-04 10:01:57',4,0),(643,7,643,'2025-02-04 10:01:57',4,0),(644,7,644,'2025-02-04 10:01:57',4,0),(645,7,645,'2025-02-04 10:01:57',4,0),(646,7,646,'2025-02-04 10:01:57',4,0),(647,7,647,'2025-02-04 10:01:57',4,0),(648,7,648,'2025-02-04 10:01:57',4,0),(649,7,649,'2025-02-04 10:01:57',4,0),(650,7,650,'2025-02-04 10:01:57',4,0),(651,7,651,'2025-02-04 10:01:57',4,0),(652,7,652,'2025-02-04 10:01:57',4,0),(653,7,653,'2025-02-04 10:01:57',4,0),(654,7,654,'2025-02-04 10:01:57',4,0),(655,7,655,'2025-02-04 10:01:57',4,0),(656,7,656,'2025-02-04 10:01:57',4,0),(657,7,657,'2025-02-04 10:01:57',4,0),(658,7,658,'2025-02-04 10:01:57',4,0),(659,7,659,'2025-02-04 10:01:57',4,0),(660,7,660,'2025-02-04 10:01:57',4,0),(661,7,661,'2025-02-04 10:01:58',4,0),(662,7,662,'2025-02-04 10:01:58',4,0),(663,7,663,'2025-02-04 10:01:58',4,0),(664,7,664,'2025-02-04 10:01:58',4,0),(665,7,665,'2025-02-04 10:01:58',4,0),(666,7,666,'2025-02-04 10:01:58',4,0),(667,7,667,'2025-02-04 10:01:58',4,0),(668,7,668,'2025-02-04 10:01:58',4,0),(669,7,669,'2025-02-04 10:01:58',4,0),(670,7,670,'2025-02-04 10:01:58',4,0),(671,7,671,'2025-02-04 10:01:58',4,0),(672,7,672,'2025-02-04 10:01:58',4,0),(673,7,673,'2025-02-04 10:01:58',4,0),(674,7,674,'2025-02-04 10:01:58',4,0),(675,7,675,'2025-02-04 10:01:58',4,0),(676,7,676,'2025-02-04 10:01:59',4,0),(677,7,677,'2025-02-04 10:01:59',4,0),(678,7,678,'2025-02-04 10:01:59',4,0),(679,7,679,'2025-02-04 10:01:59',4,0),(680,7,680,'2025-02-04 10:01:59',4,0),(681,7,681,'2025-02-04 10:01:59',4,0),(682,7,682,'2025-02-04 10:01:59',4,0),(683,7,683,'2025-02-04 10:01:59',4,0),(684,7,684,'2025-02-04 10:01:59',4,0),(685,7,685,'2025-02-04 10:01:59',4,0),(686,7,686,'2025-02-04 10:01:59',4,0),(687,7,687,'2025-02-04 10:01:59',4,0),(688,7,688,'2025-02-04 10:01:59',4,0),(689,7,689,'2025-02-04 10:01:59',4,0),(690,7,690,'2025-02-04 10:01:59',4,0),(691,7,691,'2025-02-04 10:01:59',4,0),(692,7,692,'2025-02-04 10:01:59',4,0),(693,7,693,'2025-02-04 10:01:59',4,0),(694,7,694,'2025-02-04 10:02:00',4,0),(695,7,695,'2025-02-04 10:02:00',4,0),(696,7,696,'2025-02-04 10:02:00',4,0),(697,7,697,'2025-02-04 10:02:00',4,0),(698,7,698,'2025-02-04 10:02:00',4,0),(699,7,699,'2025-02-04 10:02:00',4,0),(700,7,700,'2025-02-04 10:02:00',4,0),(701,7,701,'2025-02-04 10:02:00',4,0),(702,7,702,'2025-02-04 10:02:00',4,0),(703,7,703,'2025-02-04 10:02:00',4,0),(704,7,704,'2025-02-04 10:02:00',4,0),(705,7,705,'2025-02-04 10:02:00',4,0),(706,7,706,'2025-02-04 10:02:00',4,0),(707,7,707,'2025-02-04 10:02:00',4,0),(708,7,708,'2025-02-04 10:02:00',4,0),(709,7,709,'2025-02-04 10:02:00',4,0),(710,7,710,'2025-02-04 10:02:00',4,0),(711,7,711,'2025-02-04 10:02:00',4,0),(712,7,712,'2025-02-04 10:02:01',4,0),(713,7,713,'2025-02-04 10:02:01',4,0),(714,7,714,'2025-02-04 10:02:01',4,0),(715,7,715,'2025-02-04 10:02:01',4,0),(716,7,716,'2025-02-04 10:02:01',4,0),(717,7,717,'2025-02-04 10:02:01',4,0),(718,7,718,'2025-02-04 10:02:01',4,0),(719,7,719,'2025-02-04 10:02:01',4,0),(720,7,720,'2025-02-04 10:02:01',4,0),(721,7,721,'2025-02-04 10:02:01',4,0),(722,7,722,'2025-02-04 10:02:01',4,0),(723,7,723,'2025-02-04 10:02:01',4,0),(724,7,724,'2025-02-04 10:02:01',4,0),(725,7,725,'2025-02-04 10:02:01',4,0),(726,7,726,'2025-02-04 10:02:01',4,0),(727,7,727,'2025-02-04 10:02:02',4,0),(728,7,728,'2025-02-04 10:02:02',4,0),(729,7,729,'2025-02-04 10:02:02',4,0),(730,7,730,'2025-02-04 10:02:02',4,0),(731,7,731,'2025-02-04 10:02:02',4,0),(732,7,732,'2025-02-04 10:02:02',4,0),(733,7,733,'2025-02-04 10:02:02',4,0),(734,7,734,'2025-02-04 10:02:02',4,0),(735,7,735,'2025-02-04 10:02:02',4,0),(736,7,736,'2025-02-04 10:02:02',4,0),(737,7,737,'2025-02-04 10:02:02',4,0),(738,7,738,'2025-02-04 10:02:02',4,0),(739,7,739,'2025-02-04 10:02:02',4,0),(740,7,740,'2025-02-04 10:02:02',4,0),(741,7,741,'2025-02-04 10:02:02',4,0),(742,7,742,'2025-02-04 10:02:02',4,0),(743,7,743,'2025-02-04 10:02:02',4,0),(744,7,744,'2025-02-04 10:02:02',4,0),(745,7,745,'2025-02-04 10:02:02',4,0),(746,7,746,'2025-02-04 10:02:02',4,0),(747,7,747,'2025-02-04 10:02:02',4,0),(748,7,748,'2025-02-04 10:02:02',4,0),(749,7,749,'2025-02-04 10:02:03',4,0),(750,7,750,'2025-02-04 10:02:03',4,0),(751,7,751,'2025-02-04 10:02:03',4,0),(752,7,752,'2025-02-04 10:02:03',4,0),(753,7,753,'2025-02-04 10:02:03',4,0),(754,7,754,'2025-02-04 10:02:03',4,0),(755,7,755,'2025-02-04 10:02:03',4,0),(756,7,756,'2025-02-04 10:02:03',4,0),(757,7,757,'2025-02-04 10:02:03',4,0),(758,7,758,'2025-02-04 10:02:03',4,0),(759,7,759,'2025-02-04 10:02:03',4,0),(760,7,760,'2025-02-04 10:02:03',4,0),(761,7,761,'2025-02-04 10:02:03',4,0),(762,7,762,'2025-02-04 10:02:03',4,0),(763,7,763,'2025-02-04 10:02:03',4,0),(764,7,764,'2025-02-04 10:02:03',4,0),(765,7,765,'2025-02-04 10:02:03',4,0),(766,7,766,'2025-02-04 10:02:03',4,0),(767,7,767,'2025-02-04 10:02:03',4,0),(768,7,768,'2025-02-04 10:02:03',4,0),(769,7,769,'2025-02-04 10:02:03',4,0),(770,7,770,'2025-02-04 10:02:03',4,0),(771,7,771,'2025-02-04 10:02:03',4,0),(772,7,772,'2025-02-04 10:02:03',4,0),(773,7,773,'2025-02-04 10:02:03',4,0),(774,7,774,'2025-02-04 10:02:03',4,0),(775,7,775,'2025-02-04 10:02:03',4,0),(776,7,776,'2025-02-04 10:02:03',4,0),(777,7,777,'2025-02-04 10:02:03',4,0),(778,7,778,'2025-02-04 10:02:03',4,0),(779,7,779,'2025-02-04 10:02:03',4,0),(780,7,780,'2025-02-04 10:02:03',4,0),(781,7,781,'2025-02-04 10:02:04',4,0),(782,7,782,'2025-02-04 10:02:04',4,0),(783,7,783,'2025-02-04 10:02:04',4,0),(784,7,784,'2025-02-04 10:02:04',4,0),(785,7,785,'2025-02-04 10:02:04',4,0),(786,7,786,'2025-02-04 10:02:04',4,0),(787,7,787,'2025-02-04 10:02:04',4,0),(788,7,788,'2025-02-04 10:02:04',4,0),(789,7,789,'2025-02-04 10:02:04',4,0),(790,7,790,'2025-02-04 10:02:04',4,0),(791,7,791,'2025-02-04 10:02:04',4,0),(792,7,792,'2025-02-04 10:02:04',4,0),(793,7,793,'2025-02-04 10:02:04',4,0),(794,7,794,'2025-02-04 10:02:04',4,0),(795,7,795,'2025-02-04 10:02:04',4,0),(796,7,796,'2025-02-04 10:02:04',4,0),(797,7,797,'2025-02-04 10:02:04',4,0),(798,7,798,'2025-02-04 10:02:04',4,0),(799,7,799,'2025-02-04 10:02:04',4,0),(800,7,800,'2025-02-04 10:02:04',4,0),(801,7,801,'2025-02-04 10:02:04',4,0),(802,7,802,'2025-02-04 10:02:04',4,0),(803,7,803,'2025-02-04 10:02:04',4,0),(804,7,804,'2025-02-04 10:02:04',4,0),(805,7,805,'2025-02-04 10:02:04',4,0),(806,7,806,'2025-02-04 10:02:04',4,0),(807,7,807,'2025-02-04 10:02:04',4,0),(808,7,808,'2025-02-04 10:02:04',4,0),(809,7,809,'2025-02-04 10:02:04',4,0),(810,7,810,'2025-02-04 10:02:04',4,0),(811,7,811,'2025-02-04 10:02:04',4,0),(812,7,812,'2025-02-04 10:02:05',4,0),(813,7,813,'2025-02-04 10:02:05',4,0),(814,7,814,'2025-02-04 10:02:05',4,0),(815,7,815,'2025-02-04 10:02:05',4,0),(816,7,816,'2025-02-04 10:02:05',4,0),(817,7,817,'2025-02-04 10:02:05',4,0),(818,7,818,'2025-02-04 10:02:05',4,0),(819,7,819,'2025-02-04 10:02:05',4,0),(820,7,820,'2025-02-04 10:02:05',4,0),(821,7,821,'2025-02-04 10:02:05',4,0),(822,7,822,'2025-02-04 10:02:05',4,0),(823,7,823,'2025-02-04 10:02:05',4,0),(824,7,824,'2025-02-04 10:02:05',4,0),(825,7,825,'2025-02-04 10:02:05',4,0),(826,7,826,'2025-02-04 10:02:05',4,0),(827,7,827,'2025-02-04 10:02:05',4,0),(828,7,828,'2025-02-04 10:02:05',4,0),(829,7,829,'2025-02-04 10:02:05',4,0),(830,7,830,'2025-02-04 10:02:05',4,0),(831,7,831,'2025-02-04 10:02:05',4,0),(832,7,832,'2025-02-04 10:02:05',4,0),(833,7,833,'2025-02-04 10:02:05',4,0),(834,7,834,'2025-02-04 10:02:05',4,0),(835,7,835,'2025-02-04 10:02:05',4,0),(836,7,836,'2025-02-04 10:02:05',4,0),(837,7,837,'2025-02-04 10:02:05',4,0),(838,7,838,'2025-02-04 10:02:05',4,0),(839,7,839,'2025-02-04 10:02:06',4,0),(840,7,840,'2025-02-04 10:02:06',4,0),(841,7,841,'2025-02-04 10:02:06',4,0),(842,7,842,'2025-02-04 10:02:06',4,0),(843,7,843,'2025-02-04 10:02:06',4,0),(844,7,844,'2025-02-04 10:02:06',4,0),(845,7,845,'2025-02-04 10:02:06',4,0),(846,7,846,'2025-02-04 10:02:06',4,0),(847,7,847,'2025-02-04 10:02:06',4,0),(848,7,848,'2025-02-04 10:02:06',4,0),(849,7,849,'2025-02-04 10:02:06',4,0),(850,7,850,'2025-02-04 10:02:06',4,0),(851,7,851,'2025-02-04 10:02:06',4,0),(852,7,852,'2025-02-04 10:02:06',4,0),(853,7,853,'2025-02-04 10:02:06',4,0),(854,7,854,'2025-02-04 10:02:06',4,0),(855,7,855,'2025-02-04 10:02:06',4,0),(856,7,856,'2025-02-04 10:02:06',4,0),(857,7,857,'2025-02-04 10:02:06',4,0),(858,7,858,'2025-02-04 10:02:06',4,0),(859,7,859,'2025-02-04 10:02:06',4,0),(860,7,860,'2025-02-04 10:02:06',4,0),(861,7,861,'2025-02-04 10:02:06',4,0),(862,7,862,'2025-02-04 10:02:06',4,0),(863,7,863,'2025-02-04 10:02:06',4,0),(864,7,864,'2025-02-04 10:02:06',4,0),(865,7,865,'2025-02-04 10:02:06',4,0),(866,7,866,'2025-02-04 10:02:06',4,0),(867,7,867,'2025-02-04 10:02:06',4,0),(868,7,868,'2025-02-04 10:02:06',4,0),(869,7,869,'2025-02-04 10:02:06',4,0),(870,7,870,'2025-02-04 10:02:06',4,0),(871,7,871,'2025-02-04 10:02:06',4,0),(872,7,872,'2025-02-04 10:02:06',4,0),(873,7,873,'2025-02-04 10:02:07',4,0),(874,7,874,'2025-02-04 10:02:07',4,0),(875,7,875,'2025-02-04 10:02:07',4,0),(876,7,876,'2025-02-04 10:02:07',4,0),(877,7,877,'2025-02-04 10:02:07',4,0),(878,7,878,'2025-02-04 10:02:07',4,0),(879,7,879,'2025-02-04 10:02:07',4,0),(880,7,880,'2025-02-04 10:02:07',4,0),(881,7,881,'2025-02-04 10:02:07',4,0),(882,7,882,'2025-02-04 10:02:07',4,0),(883,7,883,'2025-02-04 10:02:07',4,0),(884,7,884,'2025-02-04 10:02:07',4,0),(885,7,885,'2025-02-04 10:02:07',4,0),(886,7,886,'2025-02-04 10:02:07',4,0),(887,7,887,'2025-02-04 10:02:07',4,0),(888,7,888,'2025-02-04 10:02:07',4,0),(889,7,889,'2025-02-04 10:02:07',4,0),(890,7,890,'2025-02-04 10:02:07',4,0),(891,7,891,'2025-02-04 10:02:07',4,0),(892,7,892,'2025-02-04 10:02:07',4,0),(893,7,893,'2025-02-04 10:02:07',4,0),(894,7,894,'2025-02-04 10:02:07',4,0),(895,7,895,'2025-02-04 10:02:07',4,0),(896,7,896,'2025-02-04 10:02:07',4,0),(897,7,897,'2025-02-04 10:02:07',4,0),(898,7,898,'2025-02-04 10:02:07',4,0),(899,7,899,'2025-02-04 10:02:07',4,0),(900,7,900,'2025-02-04 10:02:07',4,0),(901,7,901,'2025-02-04 10:02:07',4,0),(902,7,902,'2025-02-04 10:02:07',4,0),(903,7,903,'2025-02-04 10:02:07',4,0),(904,7,904,'2025-02-04 10:02:07',4,0),(905,7,905,'2025-02-04 10:02:08',4,0),(906,7,906,'2025-02-04 10:02:08',4,0),(907,7,907,'2025-02-04 10:02:08',4,0),(908,7,908,'2025-02-04 10:02:08',4,0),(909,7,909,'2025-02-04 10:02:08',4,0),(910,7,910,'2025-02-04 10:02:08',4,0),(911,7,911,'2025-02-04 10:02:08',4,0),(912,7,912,'2025-02-04 10:02:08',4,0),(913,7,913,'2025-02-04 10:02:08',4,0),(914,7,914,'2025-02-04 10:02:08',4,0),(915,7,915,'2025-02-04 10:02:08',4,0),(916,7,916,'2025-02-04 10:02:08',4,0),(917,7,917,'2025-02-04 10:02:08',4,0),(918,7,918,'2025-02-04 10:02:08',4,0),(919,7,919,'2025-02-04 10:02:08',4,0),(920,7,920,'2025-02-04 10:02:08',4,0),(921,7,921,'2025-02-04 10:02:08',4,0),(922,7,922,'2025-02-04 10:02:08',4,0),(923,7,923,'2025-02-04 10:02:08',4,0),(924,7,924,'2025-02-04 10:02:08',4,0),(925,7,925,'2025-02-04 10:02:08',4,0),(926,7,926,'2025-02-04 10:02:08',4,0),(927,7,927,'2025-02-04 10:02:08',4,0),(928,7,928,'2025-02-04 10:02:08',4,0),(929,7,929,'2025-02-04 10:02:08',4,0),(930,7,930,'2025-02-04 10:02:08',4,0),(931,7,931,'2025-02-04 10:02:08',4,0),(932,7,932,'2025-02-04 10:02:08',4,0),(933,7,933,'2025-02-04 10:02:08',4,0),(934,7,934,'2025-02-04 10:02:09',4,0),(935,7,935,'2025-02-04 10:02:09',4,0),(936,7,936,'2025-02-04 10:02:09',4,0),(937,7,937,'2025-02-04 10:02:09',4,0),(938,7,938,'2025-02-04 10:02:09',4,0),(939,7,939,'2025-02-04 10:02:09',4,0),(940,7,940,'2025-02-04 10:02:09',4,0),(941,7,941,'2025-02-04 10:02:09',4,0),(942,7,942,'2025-02-04 10:02:09',4,0),(943,7,943,'2025-02-04 10:02:09',4,0),(944,7,944,'2025-02-04 10:02:09',4,0),(945,7,945,'2025-02-04 10:02:09',4,0),(946,7,946,'2025-02-04 10:02:09',4,0),(947,7,947,'2025-02-04 10:02:09',4,0),(948,7,948,'2025-02-04 10:02:09',4,0),(949,7,949,'2025-02-04 10:02:09',4,0),(950,7,950,'2025-02-04 10:02:09',4,0),(951,7,951,'2025-02-04 10:02:09',4,0),(952,7,952,'2025-02-04 10:02:09',4,0),(953,7,953,'2025-02-04 10:02:09',4,0),(954,7,954,'2025-02-04 10:02:09',4,0),(955,7,955,'2025-02-04 10:02:09',4,0),(956,7,956,'2025-02-04 10:02:09',4,0),(957,7,957,'2025-02-04 10:02:09',4,0),(958,7,958,'2025-02-04 10:02:09',4,0),(959,7,959,'2025-02-04 10:02:09',4,0),(960,7,960,'2025-02-04 10:02:09',4,0),(961,7,961,'2025-02-04 10:02:09',4,0),(962,7,962,'2025-02-04 10:02:09',4,0),(963,7,963,'2025-02-04 10:02:09',4,0),(964,7,964,'2025-02-04 10:02:09',4,0),(965,7,965,'2025-02-04 10:02:09',4,0),(966,7,966,'2025-02-04 10:02:09',4,0),(967,7,967,'2025-02-04 10:02:09',4,0),(968,7,968,'2025-02-04 10:02:09',4,0),(969,7,969,'2025-02-04 10:02:10',4,0),(970,7,970,'2025-02-04 10:02:10',4,0),(971,7,971,'2025-02-04 10:02:10',4,0),(972,7,972,'2025-02-04 10:02:10',4,0),(973,7,973,'2025-02-04 10:02:10',4,0),(974,7,974,'2025-02-04 10:02:10',4,0),(975,7,975,'2025-02-04 10:02:10',4,0),(976,7,976,'2025-02-04 10:02:10',4,0),(977,7,977,'2025-02-04 10:02:10',4,0),(978,7,978,'2025-02-04 10:02:10',4,0),(979,7,979,'2025-02-04 10:02:10',4,0),(980,7,980,'2025-02-04 10:02:10',4,0),(981,7,981,'2025-02-04 10:02:10',4,0),(982,7,982,'2025-02-04 10:02:10',4,0),(983,7,983,'2025-02-04 10:02:10',4,0),(984,7,984,'2025-02-04 10:02:10',4,0),(985,7,985,'2025-02-04 10:02:10',4,0),(986,7,986,'2025-02-04 10:02:10',4,0),(987,7,987,'2025-02-04 10:02:10',4,0),(988,7,988,'2025-02-04 10:02:10',4,0),(989,7,989,'2025-02-04 10:02:10',4,0),(990,7,990,'2025-02-04 10:02:10',4,0),(991,7,991,'2025-02-04 10:02:10',4,0),(992,7,992,'2025-02-04 10:02:10',4,0),(993,7,993,'2025-02-04 10:02:10',4,0),(994,7,994,'2025-02-04 10:02:10',4,0),(995,7,995,'2025-02-04 10:02:10',4,0),(996,7,996,'2025-02-04 10:02:10',4,0),(997,7,997,'2025-02-04 10:02:10',4,0),(998,7,998,'2025-02-04 10:02:10',4,0),(999,7,999,'2025-02-04 10:02:10',4,0),(1000,7,1000,'2025-02-04 10:02:10',4,0),(1001,7,1001,'2025-02-04 10:02:10',4,0),(1002,7,1002,'2025-02-04 10:02:10',4,0),(1003,7,1003,'2025-02-04 10:02:11',4,0),(1004,7,1004,'2025-02-04 10:02:11',4,0),(1005,7,1005,'2025-02-04 10:02:11',4,0),(1006,7,1006,'2025-02-04 10:02:11',4,0),(1007,7,1007,'2025-02-04 10:02:11',4,0),(1008,7,1008,'2025-02-04 10:02:11',4,0),(1009,7,1009,'2025-02-04 10:02:11',4,0),(1010,7,1010,'2025-02-04 10:02:11',4,0),(1011,7,1011,'2025-02-04 10:02:11',4,0),(1012,7,1012,'2025-02-04 10:02:11',4,0),(1013,7,1013,'2025-02-04 10:02:11',4,0),(1014,7,1014,'2025-02-04 10:02:11',4,0),(1015,7,1015,'2025-02-04 10:02:11',4,0),(1016,7,1016,'2025-02-04 10:02:11',4,0),(1017,7,1017,'2025-02-04 10:02:11',4,0),(1018,7,1018,'2025-02-04 10:02:11',4,0),(1019,7,1019,'2025-02-04 10:02:11',4,0),(1020,7,1020,'2025-02-04 10:02:11',4,0),(1021,7,1021,'2025-02-04 10:02:11',4,0),(1022,7,1022,'2025-02-04 10:02:11',4,0),(1023,7,1023,'2025-02-04 10:02:11',4,0),(1024,7,1024,'2025-02-04 10:02:11',4,0),(1025,7,1025,'2025-02-04 10:02:11',4,0),(1026,7,1026,'2025-02-04 10:02:11',4,0),(1027,7,1027,'2025-02-04 10:02:11',4,0),(1028,7,1028,'2025-02-04 10:02:11',4,0),(1029,7,1029,'2025-02-04 10:02:11',4,0),(1030,7,1030,'2025-02-04 10:02:11',4,0),(1031,7,1031,'2025-02-04 10:02:11',4,0),(1032,7,1032,'2025-02-04 10:02:11',4,0),(1033,7,1033,'2025-02-04 10:02:11',4,0),(1034,7,1034,'2025-02-04 10:02:11',4,0),(1035,7,1035,'2025-02-04 10:02:11',4,0),(1036,7,1036,'2025-02-04 10:02:12',4,0),(1037,7,1037,'2025-02-04 10:02:12',4,0),(1038,7,1038,'2025-02-04 10:02:12',4,0),(1039,7,1039,'2025-02-04 10:02:12',4,0),(1040,7,1040,'2025-02-04 10:02:12',4,0),(1041,7,1041,'2025-02-04 10:02:12',4,0),(1042,7,1042,'2025-02-04 10:02:12',4,0),(1043,7,1043,'2025-02-04 10:02:12',4,0),(1044,7,1044,'2025-02-04 10:02:12',4,0),(1045,7,1045,'2025-02-04 10:02:12',4,0),(1046,7,1046,'2025-02-04 10:02:12',4,0),(1047,7,1047,'2025-02-04 10:02:12',4,0),(1048,7,1048,'2025-02-04 10:02:12',4,0),(1049,7,1049,'2025-02-04 10:02:12',4,0),(1050,7,1050,'2025-02-04 10:02:12',4,0),(1051,7,1051,'2025-02-04 10:02:12',4,0),(1052,7,1052,'2025-02-04 10:02:12',4,0),(1053,7,1053,'2025-02-04 10:02:12',4,0),(1054,7,1054,'2025-02-04 10:02:12',4,0),(1055,7,1055,'2025-02-04 10:02:12',4,0),(1056,7,1056,'2025-02-04 10:02:12',4,0),(1057,7,1057,'2025-02-04 10:02:12',4,0),(1058,7,1058,'2025-02-04 10:02:12',4,0),(1059,7,1059,'2025-02-04 10:02:12',4,0),(1060,7,1060,'2025-02-04 10:02:12',4,0),(1061,7,1061,'2025-02-04 10:02:12',4,0),(1062,7,1062,'2025-02-04 10:02:12',4,0),(1063,7,1063,'2025-02-04 10:02:12',4,0),(1064,7,1064,'2025-02-04 10:02:12',4,0),(1065,7,1065,'2025-02-04 10:02:12',4,0),(1066,7,1066,'2025-02-04 10:02:12',4,0),(1067,7,1067,'2025-02-04 10:02:12',4,0),(1068,7,1068,'2025-02-04 10:02:12',4,0),(1069,7,1069,'2025-02-04 10:02:12',4,0),(1070,7,1070,'2025-02-04 10:02:12',4,0),(1071,7,1071,'2025-02-04 10:02:12',4,0),(1072,7,1072,'2025-02-04 10:02:13',4,0),(1073,7,1073,'2025-02-04 10:02:13',4,0),(1074,7,1074,'2025-02-04 10:02:13',4,0),(1075,7,1075,'2025-02-04 10:02:13',4,0),(1076,7,1076,'2025-02-04 10:02:13',4,0),(1077,7,1077,'2025-02-04 10:02:13',4,0),(1078,7,1078,'2025-02-04 10:02:13',4,0),(1079,7,1079,'2025-02-04 10:02:13',4,0),(1080,7,1080,'2025-02-04 10:02:13',4,0),(1081,7,1081,'2025-02-04 10:02:13',4,0),(1082,7,1082,'2025-02-04 10:02:13',4,0),(1083,7,1083,'2025-02-04 10:02:13',4,0),(1084,7,1084,'2025-02-04 10:02:13',4,0),(1085,7,1085,'2025-02-04 10:02:13',4,0),(1086,7,1086,'2025-02-04 10:02:13',4,0),(1087,7,1087,'2025-02-04 10:02:13',4,0),(1088,7,1088,'2025-02-04 10:02:13',4,0),(1089,7,1089,'2025-02-04 10:02:13',4,0),(1090,7,1090,'2025-02-04 10:02:13',4,0),(1091,7,1091,'2025-02-04 10:02:13',4,0),(1092,7,1092,'2025-02-04 10:02:13',4,0),(1093,7,1093,'2025-02-04 10:02:13',4,0),(1094,7,1094,'2025-02-04 10:02:13',4,0),(1095,7,1095,'2025-02-04 10:02:13',4,0),(1096,7,1096,'2025-02-04 10:02:13',4,0),(1097,7,1097,'2025-02-04 10:02:13',4,0),(1098,7,1098,'2025-02-04 10:02:13',4,0),(1099,7,1099,'2025-02-04 10:02:13',4,0),(1100,7,1100,'2025-02-04 10:02:13',4,0),(1101,7,1101,'2025-02-04 10:02:13',4,0),(1102,7,1102,'2025-02-04 10:02:13',4,0),(1103,7,1103,'2025-02-04 10:02:13',4,0),(1104,7,1104,'2025-02-04 10:02:13',4,0),(1105,7,1105,'2025-02-04 10:02:13',4,0),(1106,7,1106,'2025-02-04 10:02:14',4,0),(1107,7,1107,'2025-02-04 10:02:14',4,0),(1108,7,1108,'2025-02-04 10:02:14',4,0),(1109,7,1109,'2025-02-04 10:02:14',4,0),(1110,7,1110,'2025-02-04 10:02:14',4,0),(1111,7,1111,'2025-02-04 10:02:14',4,0),(1112,7,1112,'2025-02-04 10:02:14',4,0),(1113,7,1113,'2025-02-04 10:02:14',4,0),(1114,7,1114,'2025-02-04 10:02:14',4,0),(1115,7,1115,'2025-02-04 10:02:14',4,0),(1116,7,1116,'2025-02-04 10:02:14',4,0),(1117,7,1117,'2025-02-04 10:02:14',4,0),(1118,7,1118,'2025-02-04 10:02:14',4,0),(1119,7,1119,'2025-02-04 10:02:14',4,0),(1120,7,1120,'2025-02-04 10:02:14',4,0),(1121,7,1121,'2025-02-04 10:02:14',4,0),(1122,7,1122,'2025-02-04 10:02:14',4,0),(1123,7,1123,'2025-02-04 10:02:14',4,0),(1124,7,1124,'2025-02-04 10:02:14',4,0),(1125,7,1125,'2025-02-04 10:02:14',4,0),(1126,7,1126,'2025-02-04 10:02:14',4,0),(1127,7,1127,'2025-02-04 10:02:14',4,0),(1128,7,1128,'2025-02-04 10:02:14',4,0),(1129,7,1129,'2025-02-04 10:02:14',4,0),(1130,7,1130,'2025-02-04 10:02:14',4,0),(1131,7,1131,'2025-02-04 10:02:14',4,0),(1132,7,1132,'2025-02-04 10:02:14',4,0),(1133,7,1133,'2025-02-04 10:02:14',4,0),(1134,7,1134,'2025-02-04 10:02:14',4,0),(1135,7,1135,'2025-02-04 10:02:14',4,0),(1136,7,1136,'2025-02-04 10:02:14',4,0),(1137,7,1137,'2025-02-04 10:02:14',4,0),(1138,7,1138,'2025-02-04 10:02:14',4,0),(1139,7,1139,'2025-02-04 10:02:14',4,0),(1140,7,1140,'2025-02-04 10:02:14',4,0),(1141,7,1141,'2025-02-04 10:02:14',4,0),(1142,7,1142,'2025-02-04 10:02:14',4,0),(1143,7,1143,'2025-02-04 10:02:15',4,0),(1144,7,1144,'2025-02-04 10:02:15',4,0),(1145,7,1145,'2025-02-04 10:02:15',4,0),(1146,7,1146,'2025-02-04 10:02:15',4,0),(1147,7,1147,'2025-02-04 10:02:15',4,0),(1148,7,1148,'2025-02-04 10:02:15',4,0),(1149,7,1149,'2025-02-04 10:02:15',4,0),(1150,7,1150,'2025-02-04 10:02:15',4,0),(1151,7,1151,'2025-02-04 10:02:15',4,0),(1152,7,1152,'2025-02-04 10:02:15',4,0),(1153,7,1153,'2025-02-04 10:02:15',4,0),(1154,7,1154,'2025-02-04 10:02:15',4,0),(1155,7,1155,'2025-02-04 10:02:15',4,0),(1156,7,1156,'2025-02-04 10:02:15',4,0),(1157,7,1157,'2025-02-04 10:02:15',4,0),(1158,7,1158,'2025-02-04 10:02:15',4,0),(1159,7,1159,'2025-02-04 10:02:15',4,0),(1160,7,1160,'2025-02-04 10:02:15',4,0),(1161,7,1161,'2025-02-04 10:02:15',4,0),(1162,7,1162,'2025-02-04 10:02:15',4,0),(1163,7,1163,'2025-02-04 10:02:15',4,0),(1164,7,1164,'2025-02-04 10:02:15',4,0),(1165,7,1165,'2025-02-04 10:02:15',4,0),(1166,7,1166,'2025-02-04 10:02:15',4,0),(1167,7,1167,'2025-02-04 10:02:15',4,0),(1168,7,1168,'2025-02-04 10:02:15',4,0),(1169,7,1169,'2025-02-04 10:02:15',4,0),(1170,7,1170,'2025-02-04 10:02:15',4,0),(1171,7,1171,'2025-02-04 10:02:15',4,0),(1172,7,1172,'2025-02-04 10:02:15',4,0),(1173,7,1173,'2025-02-04 10:02:15',4,0),(1174,7,1174,'2025-02-04 10:02:15',4,0),(1175,7,1175,'2025-02-04 10:02:15',4,0),(1176,7,1176,'2025-02-04 10:02:15',4,0),(1177,7,1177,'2025-02-04 10:02:15',4,0),(1178,7,1178,'2025-02-04 10:02:15',4,0),(1179,7,1179,'2025-02-04 10:02:15',4,0),(1180,7,1180,'2025-02-04 10:02:16',4,0),(1181,7,1181,'2025-02-04 10:02:16',4,0),(1182,7,1182,'2025-02-04 10:02:16',4,0),(1183,7,1183,'2025-02-04 10:02:16',4,0),(1184,7,1184,'2025-02-04 10:02:16',4,0),(1185,7,1185,'2025-02-04 10:02:16',4,0),(1186,7,1186,'2025-02-04 10:02:16',4,0),(1187,7,1187,'2025-02-04 10:02:16',4,0),(1188,7,1188,'2025-02-04 10:02:16',4,0),(1189,7,1189,'2025-02-04 10:02:16',4,0),(1190,7,1190,'2025-02-04 10:02:16',4,0),(1191,7,1191,'2025-02-04 10:02:16',4,0),(1192,7,1192,'2025-02-04 10:02:16',4,0),(1193,7,1193,'2025-02-04 10:02:16',4,0),(1194,7,1194,'2025-02-04 10:02:16',4,0),(1195,7,1195,'2025-02-04 10:02:16',4,0),(1196,7,1196,'2025-02-04 10:02:16',4,0),(1197,7,1197,'2025-02-04 10:02:16',4,0),(1198,7,1198,'2025-02-04 10:02:16',4,0),(1199,7,1199,'2025-02-04 10:02:16',4,0),(1200,7,1200,'2025-02-04 10:02:16',4,0),(1201,7,1201,'2025-02-04 10:02:16',4,0),(1202,7,1202,'2025-02-04 10:02:16',4,0),(1203,7,1203,'2025-02-04 10:02:16',4,0),(1204,7,1204,'2025-02-04 10:02:16',4,0),(1205,7,1205,'2025-02-04 10:02:16',4,0),(1206,7,1206,'2025-02-04 10:02:16',4,0),(1207,7,1207,'2025-02-04 10:02:16',4,0),(1208,7,1208,'2025-02-04 10:02:16',4,0),(1209,7,1209,'2025-02-04 10:02:16',4,0),(1210,7,1210,'2025-02-04 10:02:16',4,0),(1211,7,1211,'2025-02-04 10:02:16',4,0),(1212,7,1212,'2025-02-04 10:02:16',4,0),(1213,7,1213,'2025-02-04 10:02:16',4,0),(1214,7,1214,'2025-02-04 10:02:16',4,0),(1215,7,1215,'2025-02-04 10:02:17',4,0),(1216,7,1216,'2025-02-04 10:02:17',4,0),(1217,7,1217,'2025-02-04 10:02:17',4,0),(1218,7,1218,'2025-02-04 10:02:17',4,0),(1219,7,1219,'2025-02-04 10:02:17',4,0),(1220,7,1220,'2025-02-04 10:02:17',4,0),(1221,7,1221,'2025-02-04 10:02:17',4,0),(1222,7,1222,'2025-02-04 10:02:17',4,0),(1223,7,1223,'2025-02-04 10:02:17',4,0),(1224,7,1224,'2025-02-04 10:02:17',4,0),(1225,7,1225,'2025-02-04 10:02:17',4,0),(1226,7,1226,'2025-02-04 10:02:17',4,0),(1227,7,1227,'2025-02-04 10:02:17',4,0),(1228,7,1228,'2025-02-04 10:02:17',4,0),(1229,7,1229,'2025-02-04 10:02:17',4,0),(1230,7,1230,'2025-02-04 10:02:17',4,0),(1231,7,1231,'2025-02-04 10:02:17',4,0),(1232,7,1232,'2025-02-04 10:02:17',4,0),(1233,7,1233,'2025-02-04 10:02:17',4,0),(1234,7,1234,'2025-02-04 10:02:17',4,0),(1235,7,1235,'2025-02-04 10:02:17',4,0),(1236,7,1236,'2025-02-04 10:02:17',4,0),(1237,7,1237,'2025-02-04 10:02:17',4,0),(1238,7,1238,'2025-02-04 10:02:17',4,0),(1239,7,1239,'2025-02-04 10:02:17',4,0),(1240,7,1240,'2025-02-04 10:02:17',4,0),(1241,7,1241,'2025-02-04 10:02:17',4,0),(1242,7,1242,'2025-02-04 10:02:17',4,0),(1243,7,1243,'2025-02-04 10:02:17',4,0),(1244,7,1244,'2025-02-04 10:02:17',4,0),(1245,7,1245,'2025-02-04 10:02:17',4,0),(1246,7,1246,'2025-02-04 10:02:17',4,0),(1247,7,1247,'2025-02-04 10:02:17',4,0),(1248,7,1248,'2025-02-04 10:02:17',4,0),(1249,7,1249,'2025-02-04 10:02:17',4,0),(1250,7,1250,'2025-02-04 10:02:17',4,0),(1251,7,1251,'2025-02-04 10:02:17',4,0),(1252,7,1252,'2025-02-04 10:02:17',4,0),(1253,7,1253,'2025-02-04 10:02:17',4,0),(1254,7,1254,'2025-02-04 10:02:17',4,0),(1255,7,1255,'2025-02-04 10:02:17',4,0),(1256,7,1256,'2025-02-04 10:02:17',4,0),(1257,7,1257,'2025-02-04 10:02:17',4,0),(1258,7,1258,'2025-02-04 10:02:18',4,0),(1259,7,1259,'2025-02-04 10:02:18',4,0),(1260,7,1260,'2025-02-04 10:02:18',4,0),(1261,7,1261,'2025-02-04 10:02:18',4,0),(1262,7,1262,'2025-02-04 10:02:18',4,0),(1263,7,1263,'2025-02-04 10:02:18',4,0),(1264,7,1264,'2025-02-04 10:02:18',4,0),(1265,7,1265,'2025-02-04 10:02:18',4,0),(1266,7,1266,'2025-02-04 10:02:18',4,0),(1267,7,1267,'2025-02-04 10:02:18',4,0),(1268,7,1268,'2025-02-04 10:02:18',4,0),(1269,7,1269,'2025-02-04 10:02:18',4,0),(1270,7,1270,'2025-02-04 10:02:18',4,0),(1271,7,1271,'2025-02-04 10:02:18',4,0),(1272,7,1272,'2025-02-04 10:02:18',4,0),(1273,7,1273,'2025-02-04 10:02:18',4,0),(1274,7,1274,'2025-02-04 10:02:18',4,0),(1275,7,1275,'2025-02-04 10:02:18',4,0),(1276,7,1276,'2025-02-04 10:02:18',4,0),(1277,7,1277,'2025-02-04 10:02:18',4,0),(1278,7,1278,'2025-02-04 10:02:18',4,0),(1279,7,1279,'2025-02-04 10:02:18',4,0),(1280,7,1280,'2025-02-04 10:02:18',4,0),(1281,7,1281,'2025-02-04 10:02:18',4,0),(1282,7,1282,'2025-02-04 10:02:18',4,0),(1283,7,1283,'2025-02-04 10:02:18',4,0),(1284,7,1284,'2025-02-04 10:02:18',4,0),(1285,7,1285,'2025-02-04 10:02:18',4,0),(1286,7,1286,'2025-02-04 10:02:18',4,0),(1287,7,1287,'2025-02-04 10:02:18',4,0),(1288,7,1288,'2025-02-04 10:02:18',4,0),(1289,7,1289,'2025-02-04 10:02:18',4,0),(1290,7,1290,'2025-02-04 10:02:18',4,0),(1291,7,1291,'2025-02-04 10:02:18',4,0),(1292,7,1292,'2025-02-04 10:02:18',4,0),(1293,7,1293,'2025-02-04 10:02:18',4,0),(1294,7,1294,'2025-02-04 10:02:18',4,0),(1295,7,1295,'2025-02-04 10:02:18',4,0),(1296,7,1296,'2025-02-04 10:02:18',4,0),(1297,7,1297,'2025-02-04 10:02:18',4,0),(1298,7,1298,'2025-02-04 10:02:19',4,0),(1299,7,1299,'2025-02-04 10:02:19',4,0),(1300,7,1300,'2025-02-04 10:02:19',4,0),(1301,7,1301,'2025-02-04 10:02:19',4,0),(1302,7,1302,'2025-02-04 10:02:19',4,0),(1303,7,1303,'2025-02-04 10:02:19',4,0),(1304,7,1304,'2025-02-04 10:02:19',4,0),(1305,7,1305,'2025-02-04 10:02:19',4,0),(1306,7,1306,'2025-02-04 10:02:19',4,0),(1307,7,1307,'2025-02-04 10:02:19',4,0),(1308,7,1308,'2025-02-04 10:02:19',4,0),(1309,7,1309,'2025-02-04 10:02:19',4,0),(1310,7,1310,'2025-02-04 10:02:19',4,0),(1311,7,1311,'2025-02-04 10:02:19',4,0),(1312,7,1312,'2025-02-04 10:02:19',4,0),(1313,7,1313,'2025-02-04 10:02:19',4,0),(1314,7,1314,'2025-02-04 10:02:19',4,0),(1315,7,1315,'2025-02-04 10:02:19',4,0),(1316,7,1316,'2025-02-04 10:02:19',4,0),(1317,7,1317,'2025-02-04 10:02:19',4,0),(1318,7,1318,'2025-02-04 10:02:19',4,0),(1319,7,1319,'2025-02-04 10:02:19',4,0),(1320,7,1320,'2025-02-04 10:02:19',4,0),(1321,7,1321,'2025-02-04 10:02:19',4,0),(1322,7,1322,'2025-02-04 10:02:19',4,0),(1323,7,1323,'2025-02-04 10:02:19',4,0),(1324,7,1324,'2025-02-04 10:02:19',4,0),(1325,7,1325,'2025-02-04 10:02:19',4,0),(1326,7,1326,'2025-02-04 10:02:19',4,0),(1327,7,1327,'2025-02-04 10:02:19',4,0),(1328,7,1328,'2025-02-04 10:02:19',4,0),(1329,7,1329,'2025-02-04 10:02:19',4,0),(1330,7,1330,'2025-02-04 10:02:19',4,0),(1331,7,1331,'2025-02-04 10:02:19',4,0),(1332,7,1332,'2025-02-04 10:02:19',4,0),(1333,7,1333,'2025-02-04 10:02:19',4,0),(1334,7,1334,'2025-02-04 10:02:19',4,0),(1335,7,1335,'2025-02-04 10:02:20',4,0),(1336,7,1336,'2025-02-04 10:02:20',4,0),(1337,7,1337,'2025-02-04 10:02:20',4,0),(1338,7,1338,'2025-02-04 10:02:20',4,0),(1339,7,1339,'2025-02-04 10:02:20',4,0),(1340,7,1340,'2025-02-04 10:02:20',4,0),(1341,7,1341,'2025-02-04 10:02:20',4,0),(1342,7,1342,'2025-02-04 10:02:20',4,0),(1343,7,1343,'2025-02-04 10:02:20',4,0),(1344,7,1344,'2025-02-04 10:02:20',4,0),(1345,7,1345,'2025-02-04 10:02:20',4,0),(1346,7,1346,'2025-02-04 10:02:20',4,0),(1347,7,1347,'2025-02-04 10:02:20',4,0),(1348,7,1348,'2025-02-04 10:02:20',4,0),(1349,7,1349,'2025-02-04 10:02:20',4,0),(1350,7,1350,'2025-02-04 10:02:20',4,0),(1351,7,1351,'2025-02-04 10:02:20',4,0),(1352,7,1352,'2025-02-04 10:02:21',4,0),(1353,7,1353,'2025-02-04 10:02:21',4,0),(1354,7,1354,'2025-02-04 10:02:21',4,0),(1355,7,1355,'2025-02-04 10:02:21',4,0),(1356,7,1356,'2025-02-04 10:02:21',4,0),(1357,7,1357,'2025-02-04 10:02:21',4,0),(1358,7,1358,'2025-02-04 10:02:21',4,0),(1359,7,1359,'2025-02-04 10:02:21',4,0),(1360,7,1360,'2025-02-04 10:02:21',4,0),(1361,7,1361,'2025-02-04 10:02:21',4,0),(1362,7,1362,'2025-02-04 10:02:21',4,0),(1363,7,1363,'2025-02-04 10:02:21',4,0),(1364,7,1364,'2025-02-04 10:02:21',4,0),(1365,7,1365,'2025-02-04 10:02:21',4,0),(1366,7,1366,'2025-02-04 10:02:21',4,0),(1367,7,1367,'2025-02-04 10:02:21',4,0),(1368,7,1368,'2025-02-04 10:02:21',4,0),(1369,7,1369,'2025-02-04 10:02:22',4,0),(1370,7,1370,'2025-02-04 10:02:22',4,0),(1371,7,1371,'2025-02-04 10:02:22',4,0),(1372,7,1372,'2025-02-04 10:02:22',4,0),(1373,7,1373,'2025-02-04 10:02:22',4,0),(1374,7,1374,'2025-02-04 10:02:22',4,0),(1375,7,1375,'2025-02-04 10:02:22',4,0),(1376,7,1376,'2025-02-04 10:02:22',4,0),(1377,7,1377,'2025-02-04 10:02:22',4,0),(1378,7,1378,'2025-02-04 10:02:22',4,0),(1379,7,1379,'2025-02-04 10:02:22',4,0),(1380,7,1380,'2025-02-04 10:02:22',4,0),(1381,7,1381,'2025-02-04 10:02:22',4,0),(1382,7,1382,'2025-02-04 10:02:22',4,0),(1383,7,1383,'2025-02-04 10:02:23',4,0),(1384,7,1384,'2025-02-04 10:02:23',4,0),(1385,7,1385,'2025-02-04 10:02:23',4,0),(1386,7,1386,'2025-02-04 10:02:23',4,0),(1387,7,1387,'2025-02-04 10:02:23',4,0),(1388,7,1388,'2025-02-04 10:02:23',4,0),(1389,7,1389,'2025-02-04 10:02:23',4,0),(1390,7,1390,'2025-02-04 10:02:23',4,0),(1391,7,1391,'2025-02-04 10:02:23',4,0),(1392,7,1392,'2025-02-04 10:02:23',4,0),(1393,7,1393,'2025-02-04 10:02:23',4,0),(1394,7,1394,'2025-02-04 10:02:23',4,0),(1395,7,1395,'2025-02-04 10:02:23',4,0),(1396,7,1396,'2025-02-04 10:02:23',4,0),(1397,7,1397,'2025-02-04 10:02:24',4,0),(1398,7,1398,'2025-02-04 10:02:24',4,0),(1399,7,1399,'2025-02-04 10:02:24',4,0),(1400,7,1400,'2025-02-04 10:02:24',4,0),(1401,7,1401,'2025-02-04 10:02:24',4,0),(1402,7,1402,'2025-02-04 10:02:24',4,0),(1403,7,1403,'2025-02-04 10:02:24',4,0),(1404,7,1404,'2025-02-04 10:02:24',4,0),(1405,7,1405,'2025-02-04 10:02:24',4,0),(1406,7,1406,'2025-02-04 10:02:24',4,0),(1407,7,1407,'2025-02-04 10:02:24',4,0),(1408,7,1408,'2025-02-04 10:02:24',4,0),(1409,7,1409,'2025-02-04 10:02:24',4,0),(1410,7,1410,'2025-02-04 10:02:24',4,0),(1411,7,1411,'2025-02-04 10:02:24',4,0),(1412,7,1412,'2025-02-04 10:02:24',4,0),(1413,7,1413,'2025-02-04 10:02:24',4,0),(1414,7,1414,'2025-02-04 10:02:24',4,0),(1415,7,1415,'2025-02-04 10:02:24',4,0),(1416,7,1416,'2025-02-04 10:02:25',4,0),(1417,7,1417,'2025-02-04 10:02:25',4,0),(1418,7,1418,'2025-02-04 10:02:25',4,0),(1419,7,1419,'2025-02-04 10:02:25',4,0),(1420,7,1420,'2025-02-04 10:02:25',4,0),(1421,7,1421,'2025-02-04 10:02:25',4,0),(1422,7,1422,'2025-02-04 10:02:25',4,0),(1423,7,1423,'2025-02-04 10:02:25',4,0),(1424,7,1424,'2025-02-04 10:02:25',4,0),(1425,7,1425,'2025-02-04 10:02:25',4,0),(1426,7,1426,'2025-02-04 10:02:25',4,0),(1427,7,1427,'2025-02-04 10:02:25',4,0),(1428,7,1428,'2025-02-04 10:02:25',4,0),(1429,7,1429,'2025-02-04 10:02:25',4,0),(1430,7,1430,'2025-02-04 10:02:25',4,0),(1431,7,1431,'2025-02-04 10:02:25',4,0),(1432,7,1432,'2025-02-04 10:02:25',4,0),(1433,7,1433,'2025-02-04 10:02:25',4,0),(1434,7,1434,'2025-02-04 10:02:25',4,0),(1435,7,1435,'2025-02-04 10:02:25',4,0),(1436,7,1436,'2025-02-04 10:02:25',4,0),(1437,7,1437,'2025-02-04 10:02:25',4,0),(1438,7,1438,'2025-02-04 10:02:25',4,0),(1439,7,1439,'2025-02-04 10:02:26',4,0),(1440,7,1440,'2025-02-04 10:02:26',4,0),(1441,7,1441,'2025-02-04 10:02:26',4,0),(1442,7,1442,'2025-02-04 10:02:26',4,0),(1443,7,1443,'2025-02-04 10:02:26',4,0),(1444,7,1444,'2025-02-04 10:02:26',4,0),(1445,7,1445,'2025-02-04 10:02:26',4,0),(1446,7,1446,'2025-02-04 10:02:26',4,0),(1447,7,1447,'2025-02-04 10:02:26',4,0),(1448,7,1448,'2025-02-04 10:02:26',4,0),(1449,7,1449,'2025-02-04 10:02:26',4,0),(1450,7,1450,'2025-02-04 10:02:26',4,0),(1451,7,1451,'2025-02-04 10:02:26',4,0),(1452,7,1452,'2025-02-04 10:02:26',4,0),(1453,7,1453,'2025-02-04 10:02:26',4,0),(1454,7,1454,'2025-02-04 10:02:26',4,0),(1455,7,1455,'2025-02-04 10:02:26',4,0),(1456,7,1456,'2025-02-04 10:02:26',4,0),(1457,7,1457,'2025-02-04 10:02:26',4,0),(1458,7,1458,'2025-02-04 10:02:26',4,0),(1459,7,1459,'2025-02-04 10:02:26',4,0),(1460,7,1460,'2025-02-04 10:02:26',4,0),(1461,7,1461,'2025-02-04 10:02:26',4,0),(1462,7,1462,'2025-02-04 10:02:26',4,0),(1463,7,1463,'2025-02-04 10:02:27',4,0),(1464,7,1464,'2025-02-04 10:02:27',4,0),(1465,7,1465,'2025-02-04 10:02:27',4,0),(1466,7,1466,'2025-02-04 10:02:27',4,0),(1467,7,1467,'2025-02-04 10:02:27',4,0),(1468,7,1468,'2025-02-04 10:02:27',4,0),(1469,7,1469,'2025-02-04 10:02:27',4,0),(1470,7,1470,'2025-02-04 10:02:27',4,0),(1471,7,1471,'2025-02-04 10:02:27',4,0),(1472,7,1472,'2025-02-04 10:02:27',4,0),(1473,7,1473,'2025-02-04 10:02:27',4,0),(1474,7,1474,'2025-02-04 10:02:27',4,0),(1475,7,1475,'2025-02-04 10:02:27',4,0),(1476,7,1476,'2025-02-04 10:02:27',4,0),(1477,7,1477,'2025-02-04 10:02:27',4,0),(1478,7,1478,'2025-02-04 10:02:27',4,0),(1479,7,1479,'2025-02-04 10:02:27',4,0),(1480,7,1480,'2025-02-04 10:02:27',4,0),(1481,7,1481,'2025-02-04 10:02:27',4,0),(1482,7,1482,'2025-02-04 10:02:27',4,0),(1483,7,1483,'2025-02-04 10:02:27',4,0),(1484,7,1484,'2025-02-04 10:02:27',4,0),(1485,7,1485,'2025-02-04 10:02:27',4,0),(1486,7,1486,'2025-02-04 10:02:27',4,0),(1487,7,1487,'2025-02-04 10:02:27',4,0),(1488,7,1488,'2025-02-04 10:02:27',4,0),(1489,7,1489,'2025-02-04 10:02:27',4,0),(1490,7,1490,'2025-02-04 10:02:27',4,0),(1491,7,1491,'2025-02-04 10:02:27',4,0),(1492,7,1492,'2025-02-04 10:02:27',4,0),(1493,7,1493,'2025-02-04 10:02:28',4,0),(1494,7,1494,'2025-02-04 10:02:28',4,0),(1495,7,1495,'2025-02-04 10:02:28',4,0),(1496,7,1496,'2025-02-04 10:02:28',4,0),(1497,7,1497,'2025-02-04 10:02:28',4,0),(1498,7,1498,'2025-02-04 10:02:28',4,0),(1499,7,1499,'2025-02-04 10:02:28',4,0),(1500,7,1500,'2025-02-04 10:02:28',4,0),(1501,7,1501,'2025-02-04 10:02:28',4,0),(1502,7,1502,'2025-02-04 10:02:28',4,0),(1503,7,1503,'2025-02-04 10:02:28',4,0),(1504,7,1504,'2025-02-04 10:02:28',4,0),(1505,7,1505,'2025-02-04 10:02:28',4,0),(1506,7,1506,'2025-02-04 10:02:28',4,0),(1507,7,1507,'2025-02-04 10:02:28',4,0),(1508,7,1508,'2025-02-04 10:02:28',4,0),(1509,7,1509,'2025-02-04 10:02:28',4,0),(1510,7,1510,'2025-02-04 10:02:28',4,0),(1511,7,1511,'2025-02-04 10:02:28',4,0),(1512,7,1512,'2025-02-04 10:02:28',4,0),(1513,7,1513,'2025-02-04 10:02:28',4,0),(1514,7,1514,'2025-02-04 10:02:28',4,0),(1515,7,1515,'2025-02-04 10:02:28',4,0),(1516,7,1516,'2025-02-04 10:02:28',4,0),(1517,7,1517,'2025-02-04 10:02:28',4,0),(1518,7,1518,'2025-02-04 10:02:28',4,0),(1519,7,1519,'2025-02-04 10:02:28',4,0),(1520,7,1520,'2025-02-04 10:02:28',4,0),(1521,7,1521,'2025-02-04 10:02:28',4,0),(1522,7,1522,'2025-02-04 10:02:28',4,0),(1523,7,1523,'2025-02-04 10:02:28',4,0),(1524,7,1524,'2025-02-04 10:02:28',4,0),(1525,7,1525,'2025-02-04 10:02:28',4,0),(1526,7,1526,'2025-02-04 10:02:28',4,0),(1527,7,1527,'2025-02-04 10:02:29',4,0),(1528,7,1528,'2025-02-04 10:02:29',4,0),(1529,7,1529,'2025-02-04 10:02:29',4,0),(1530,7,1530,'2025-02-04 10:02:29',4,0),(1531,7,1531,'2025-02-04 10:02:29',4,0),(1532,7,1532,'2025-02-04 10:02:29',4,0),(1533,7,1533,'2025-02-04 10:02:29',4,0),(1534,7,1534,'2025-02-04 10:02:29',4,0),(1535,7,1535,'2025-02-04 10:02:29',4,0),(1536,7,1536,'2025-02-04 10:02:29',4,0),(1537,7,1537,'2025-02-04 10:02:29',4,0),(1538,7,1538,'2025-02-04 10:02:29',4,0),(1539,7,1539,'2025-02-04 10:02:29',4,0),(1540,7,1540,'2025-02-04 10:02:29',4,0),(1541,7,1541,'2025-02-04 10:02:29',4,0),(1542,7,1542,'2025-02-04 10:02:29',4,0),(1543,7,1543,'2025-02-04 10:02:29',4,0),(1544,7,1544,'2025-02-04 10:02:29',4,0),(1545,7,1545,'2025-02-04 10:02:29',4,0),(1546,7,1546,'2025-02-04 10:02:29',4,0),(1547,7,1547,'2025-02-04 10:02:29',4,0),(1548,7,1548,'2025-02-04 10:02:29',4,0),(1549,7,1549,'2025-02-04 10:02:29',4,0),(1550,7,1550,'2025-02-04 10:02:29',4,0),(1551,7,1551,'2025-02-04 10:02:29',4,0),(1552,7,1552,'2025-02-04 10:02:29',4,0),(1553,7,1553,'2025-02-04 10:02:29',4,0),(1554,7,1554,'2025-02-04 10:02:29',4,0),(1555,7,1555,'2025-02-04 10:02:29',4,0),(1556,7,1556,'2025-02-04 10:02:29',4,0),(1557,7,1557,'2025-02-04 10:02:29',4,0),(1558,7,1558,'2025-02-04 10:02:29',4,0),(1559,7,1559,'2025-02-04 10:02:29',4,0),(1560,7,1560,'2025-02-04 10:02:29',4,0),(1561,7,1561,'2025-02-04 10:02:29',4,0),(1562,7,1562,'2025-02-04 10:02:29',4,0),(1563,7,1563,'2025-02-04 10:02:30',4,0),(1564,7,1564,'2025-02-04 10:02:30',4,0),(1565,7,1565,'2025-02-04 10:02:30',4,0),(1566,7,1566,'2025-02-04 10:02:30',4,0),(1567,7,1567,'2025-02-04 10:02:30',4,0),(1568,7,1568,'2025-02-04 10:02:30',4,0),(1569,7,1569,'2025-02-04 10:02:30',4,0),(1570,7,1570,'2025-02-04 10:02:30',4,0),(1571,7,1571,'2025-02-04 10:02:30',4,0),(1572,7,1572,'2025-02-04 10:02:30',4,0),(1573,7,1573,'2025-02-04 10:02:30',4,0),(1574,7,1574,'2025-02-04 10:02:30',4,0),(1575,7,1575,'2025-02-04 10:02:30',4,0),(1576,7,1576,'2025-02-04 10:02:30',4,0),(1577,7,1577,'2025-02-04 10:02:30',4,0),(1578,7,1578,'2025-02-04 10:02:30',4,0),(1579,7,1579,'2025-02-04 10:02:30',4,0),(1580,7,1580,'2025-02-04 10:02:30',4,0),(1581,7,1581,'2025-02-04 10:02:30',4,0),(1582,7,1582,'2025-02-04 10:02:30',4,0),(1583,7,1583,'2025-02-04 10:02:30',4,0),(1584,7,1584,'2025-02-04 10:02:30',4,0),(1585,7,1585,'2025-02-04 10:02:30',4,0),(1586,7,1586,'2025-02-04 10:02:30',4,0),(1587,7,1587,'2025-02-04 10:02:30',4,0),(1588,7,1588,'2025-02-04 10:02:30',4,0),(1589,7,1589,'2025-02-04 10:02:30',4,0),(1590,7,1590,'2025-02-04 10:02:30',4,0),(1591,7,1591,'2025-02-04 10:02:30',4,0),(1592,7,1592,'2025-02-04 10:02:30',4,0),(1593,7,1593,'2025-02-04 10:02:30',4,0),(1594,7,1594,'2025-02-04 10:02:30',4,0),(1595,7,1595,'2025-02-04 10:02:30',4,0),(1596,7,1596,'2025-02-04 10:02:31',4,0),(1597,7,1597,'2025-02-04 10:02:31',4,0),(1598,7,1598,'2025-02-04 10:02:31',4,0),(1599,7,1599,'2025-02-04 10:02:31',4,0),(1600,7,1600,'2025-02-04 10:02:31',4,0),(1601,7,1601,'2025-02-04 10:02:31',4,0),(1602,7,1602,'2025-02-04 10:02:31',4,0),(1603,7,1603,'2025-02-04 10:02:31',4,0),(1604,7,1604,'2025-02-04 10:02:31',4,0),(1605,7,1605,'2025-02-04 10:02:31',4,0),(1606,7,1606,'2025-02-04 10:02:31',4,0),(1607,7,1607,'2025-02-04 10:02:31',4,0),(1608,7,1608,'2025-02-04 10:02:31',4,0),(1609,7,1609,'2025-02-04 10:02:31',4,0),(1610,7,1610,'2025-02-04 10:02:31',4,0),(1611,7,1611,'2025-02-04 10:02:31',4,0),(1612,7,1612,'2025-02-04 10:02:31',4,0),(1613,7,1613,'2025-02-04 10:02:31',4,0),(1614,7,1614,'2025-02-04 10:02:31',4,0),(1615,7,1615,'2025-02-04 10:02:31',4,0),(1616,7,1616,'2025-02-04 10:02:31',4,0),(1617,7,1617,'2025-02-04 10:02:31',4,0),(1618,7,1618,'2025-02-04 10:02:31',4,0),(1619,7,1619,'2025-02-04 10:02:31',4,0),(1620,7,1620,'2025-02-04 10:02:31',4,0),(1621,7,1621,'2025-02-04 10:02:31',4,0),(1622,7,1622,'2025-02-04 10:02:31',4,0),(1623,7,1623,'2025-02-04 10:02:31',4,0),(1624,7,1624,'2025-02-04 10:02:31',4,0),(1625,7,1625,'2025-02-04 10:02:31',4,0),(1626,7,1626,'2025-02-04 10:02:31',4,0),(1627,7,1627,'2025-02-04 10:02:31',4,0),(1628,7,1628,'2025-02-04 10:02:31',4,0),(1629,7,1629,'2025-02-04 10:02:31',4,0),(1630,7,1630,'2025-02-04 10:02:32',4,0),(1631,7,1631,'2025-02-04 10:02:32',4,0),(1632,7,1632,'2025-02-04 10:02:32',4,0),(1633,7,1633,'2025-02-04 10:02:32',4,0),(1634,7,1634,'2025-02-04 10:02:32',4,0),(1635,7,1635,'2025-02-04 10:02:32',4,0),(1636,7,1636,'2025-02-04 10:02:32',4,0),(1637,7,1637,'2025-02-04 10:02:32',4,0),(1638,7,1638,'2025-02-04 10:02:32',4,0),(1639,7,1639,'2025-02-04 10:02:32',4,0),(1640,7,1640,'2025-02-04 10:02:32',4,0),(1641,7,1641,'2025-02-04 10:02:32',4,0),(1642,7,1642,'2025-02-04 10:02:32',4,0),(1643,7,1643,'2025-02-04 10:02:32',4,0),(1644,7,1644,'2025-02-04 10:02:32',4,0),(1645,7,1645,'2025-02-04 10:02:32',4,0),(1646,7,1646,'2025-02-04 10:02:32',4,0),(1647,7,1647,'2025-02-04 10:02:32',4,0),(1648,7,1648,'2025-02-04 10:02:32',4,0),(1649,7,1649,'2025-02-04 10:02:32',4,0),(1650,7,1650,'2025-02-04 10:02:32',4,0),(1651,7,1651,'2025-02-04 10:02:32',4,0),(1652,7,1652,'2025-02-04 10:02:32',4,0),(1653,7,1653,'2025-02-04 10:02:32',4,0),(1654,7,1654,'2025-02-04 10:02:32',4,0),(1655,7,1655,'2025-02-04 10:02:32',4,0),(1656,7,1656,'2025-02-04 10:02:32',4,0),(1657,7,1657,'2025-02-04 10:02:32',4,0),(1658,7,1658,'2025-02-04 10:02:32',4,0),(1659,7,1659,'2025-02-04 10:02:32',4,0),(1660,7,1660,'2025-02-04 10:02:32',4,0),(1661,7,1661,'2025-02-04 10:02:32',4,0),(1662,7,1662,'2025-02-04 10:02:32',4,0),(1663,7,1663,'2025-02-04 10:02:32',4,0),(1664,7,1664,'2025-02-04 10:02:32',4,0),(1665,7,1665,'2025-02-04 10:02:32',4,0),(1666,7,1666,'2025-02-04 10:02:32',4,0),(1667,7,1667,'2025-02-04 10:02:32',4,0),(1668,7,1668,'2025-02-04 10:02:32',4,0),(1669,7,1669,'2025-02-04 10:02:32',4,0),(1670,7,1670,'2025-02-04 10:02:33',4,0),(1671,7,1671,'2025-02-04 10:02:33',4,0),(1672,7,1672,'2025-02-04 10:02:33',4,0),(1673,7,1673,'2025-02-04 10:02:33',4,0),(1674,7,1674,'2025-02-04 10:02:33',4,0),(1675,7,1675,'2025-02-04 10:02:33',4,0),(1676,7,1676,'2025-02-04 10:02:33',4,0),(1677,7,1677,'2025-02-04 10:02:33',4,0),(1678,7,1678,'2025-02-04 10:02:33',4,0),(1679,7,1679,'2025-02-04 10:02:33',4,0),(1680,7,1680,'2025-02-04 10:02:33',4,0),(1681,7,1681,'2025-02-04 10:02:33',4,0),(1682,7,1682,'2025-02-04 10:02:33',4,0),(1683,7,1683,'2025-02-04 10:02:33',4,0),(1684,7,1684,'2025-02-04 10:02:33',4,0),(1685,7,1685,'2025-02-04 10:02:33',4,0),(1686,7,1686,'2025-02-04 10:02:33',4,0),(1687,7,1687,'2025-02-04 10:02:33',4,0),(1688,7,1688,'2025-02-04 10:02:33',4,0),(1689,7,1689,'2025-02-04 10:02:33',4,0),(1690,7,1690,'2025-02-04 10:02:33',4,0),(1691,7,1691,'2025-02-04 10:02:33',4,0),(1692,7,1692,'2025-02-04 10:02:33',4,0),(1693,7,1693,'2025-02-04 10:02:33',4,0),(1694,7,1694,'2025-02-04 10:02:33',4,0),(1695,7,1695,'2025-02-04 10:02:33',4,0),(1696,7,1696,'2025-02-04 10:02:33',4,0),(1697,7,1697,'2025-02-04 10:02:33',4,0),(1698,7,1698,'2025-02-04 10:02:33',4,0),(1699,7,1699,'2025-02-04 10:02:33',4,0),(1700,7,1700,'2025-02-04 10:02:33',4,0),(1701,7,1701,'2025-02-04 10:02:33',4,0),(1702,7,1702,'2025-02-04 10:02:33',4,0),(1703,7,1703,'2025-02-04 10:02:33',4,0),(1704,7,1704,'2025-02-04 10:02:34',4,0),(1705,7,1705,'2025-02-04 10:02:34',4,0),(1706,7,1706,'2025-02-04 10:02:34',4,0),(1707,7,1707,'2025-02-04 10:02:34',4,0),(1708,7,1708,'2025-02-04 10:02:34',4,0),(1709,7,1709,'2025-02-04 10:02:34',4,0),(1710,7,1710,'2025-02-04 10:02:34',4,0),(1711,7,1711,'2025-02-04 10:02:34',4,0),(1712,7,1712,'2025-02-04 10:02:34',4,0),(1713,7,1713,'2025-02-04 10:02:34',4,0),(1714,7,1714,'2025-02-04 10:02:34',4,0),(1715,7,1715,'2025-02-04 10:02:34',4,0),(1716,7,1716,'2025-02-04 10:02:34',4,0),(1717,7,1717,'2025-02-04 10:02:34',4,0),(1718,7,1718,'2025-02-04 10:02:34',4,0),(1719,7,1719,'2025-02-04 10:02:34',4,0),(1720,7,1720,'2025-02-04 10:02:34',4,0),(1721,7,1721,'2025-02-04 10:02:34',4,0),(1722,7,1722,'2025-02-04 10:02:34',4,0),(1723,7,1723,'2025-02-04 10:02:34',4,0),(1724,7,1724,'2025-02-04 10:02:34',4,0),(1725,7,1725,'2025-02-04 10:02:34',4,0),(1726,7,1726,'2025-02-04 10:02:34',4,0),(1727,7,1727,'2025-02-04 10:02:34',4,0),(1728,7,1728,'2025-02-04 10:02:34',4,0),(1729,7,1729,'2025-02-04 10:02:34',4,0),(1730,7,1730,'2025-02-04 10:02:34',4,0),(1731,7,1731,'2025-02-04 10:02:34',4,0),(1732,7,1732,'2025-02-04 10:02:34',4,0),(1733,7,1733,'2025-02-04 10:02:34',4,0),(1734,7,1734,'2025-02-04 10:02:34',4,0),(1735,7,1735,'2025-02-04 10:02:34',4,0),(1736,7,1736,'2025-02-04 10:02:34',4,0),(1737,7,1737,'2025-02-04 10:02:34',4,0),(1738,7,1738,'2025-02-04 10:02:34',4,0),(1739,7,1739,'2025-02-04 10:02:35',4,0),(1740,7,1740,'2025-02-04 10:02:35',4,0),(1741,7,1741,'2025-02-04 10:02:35',4,0),(1742,7,1742,'2025-02-04 10:02:35',4,0),(1743,7,1743,'2025-02-04 10:02:35',4,0),(1744,7,1744,'2025-02-04 10:02:35',4,0),(1745,7,1745,'2025-02-04 10:02:35',4,0),(1746,7,1746,'2025-02-04 10:02:35',4,0),(1747,7,1747,'2025-02-04 10:02:35',4,0),(1748,7,1748,'2025-02-04 10:02:35',4,0),(1749,7,1749,'2025-02-04 10:02:35',4,0),(1750,7,1750,'2025-02-04 10:02:35',4,0),(1751,7,1751,'2025-02-04 10:02:35',4,0),(1752,7,1752,'2025-02-04 10:02:35',4,0),(1753,7,1753,'2025-02-04 10:02:35',4,0),(1754,7,1754,'2025-02-04 10:02:35',4,0),(1755,7,1755,'2025-02-04 10:02:35',4,0),(1756,7,1756,'2025-02-04 10:02:35',4,0),(1757,7,1757,'2025-02-04 10:02:35',4,0),(1758,7,1758,'2025-02-04 10:02:35',4,0),(1759,7,1759,'2025-02-04 10:02:35',4,0),(1760,7,1760,'2025-02-04 10:02:35',4,0),(1761,7,1761,'2025-02-04 10:02:35',4,0),(1762,7,1762,'2025-02-04 10:02:35',4,0),(1763,7,1763,'2025-02-04 10:02:35',4,0),(1764,7,1764,'2025-02-04 10:02:35',4,0),(1765,7,1765,'2025-02-04 10:02:35',4,0),(1766,7,1766,'2025-02-04 10:02:35',4,0),(1767,7,1767,'2025-02-04 10:02:35',4,0),(1768,7,1768,'2025-02-04 10:02:35',4,0),(1769,7,1769,'2025-02-04 10:02:35',4,0),(1770,7,1770,'2025-02-04 10:02:35',4,0),(1771,7,1771,'2025-02-04 10:02:35',4,0),(1772,7,1772,'2025-02-04 10:02:35',4,0),(1773,7,1773,'2025-02-04 10:02:35',4,0),(1774,7,1774,'2025-02-04 10:02:36',4,0),(1775,7,1775,'2025-02-04 10:02:36',4,0),(1776,7,1776,'2025-02-04 10:02:36',4,0),(1777,7,1777,'2025-02-04 10:02:36',4,0),(1778,7,1778,'2025-02-04 10:02:36',4,0),(1779,7,1779,'2025-02-04 10:02:36',4,0),(1780,7,1780,'2025-02-04 10:02:36',4,0),(1781,7,1781,'2025-02-04 10:02:36',4,0),(1782,7,1782,'2025-02-04 10:02:36',4,0),(1783,7,1783,'2025-02-04 10:02:36',4,0),(1784,7,1784,'2025-02-04 10:02:36',4,0),(1785,7,1785,'2025-02-04 10:02:36',4,0),(1786,7,1786,'2025-02-04 10:02:36',4,0),(1787,7,1787,'2025-02-04 10:02:36',4,0),(1788,7,1788,'2025-02-04 10:02:36',4,0),(1789,7,1789,'2025-02-04 10:02:36',4,0),(1790,7,1790,'2025-02-04 10:02:36',4,0),(1791,7,1791,'2025-02-04 10:02:36',4,0),(1792,7,1792,'2025-02-04 10:02:36',4,0),(1793,7,1793,'2025-02-04 10:02:36',4,0),(1794,7,1794,'2025-02-04 10:02:36',4,0),(1795,7,1795,'2025-02-04 10:02:36',4,0),(1796,7,1796,'2025-02-04 10:02:36',4,0),(1797,7,1797,'2025-02-04 10:02:36',4,0),(1798,7,1798,'2025-02-04 10:02:36',4,0),(1799,7,1799,'2025-02-04 10:02:36',4,0),(1800,7,1800,'2025-02-04 10:02:36',4,0),(1801,7,1801,'2025-02-04 10:02:36',4,0),(1802,7,1802,'2025-02-04 10:02:36',4,0),(1803,7,1803,'2025-02-04 10:02:36',4,0),(1804,7,1804,'2025-02-04 10:02:36',4,0),(1805,7,1805,'2025-02-04 10:02:36',4,0),(1806,7,1806,'2025-02-04 10:02:36',4,0),(1807,7,1807,'2025-02-04 10:02:36',4,0),(1808,7,1808,'2025-02-04 10:02:37',4,0),(1809,7,1809,'2025-02-04 10:02:37',4,0),(1810,7,1810,'2025-02-04 10:02:37',4,0),(1811,7,1811,'2025-02-04 10:02:37',4,0),(1812,7,1812,'2025-02-04 10:02:37',4,0),(1813,7,1813,'2025-02-04 10:02:37',4,0),(1814,7,1814,'2025-02-04 10:02:37',4,0),(1815,7,1815,'2025-02-04 10:02:37',4,0),(1816,7,1816,'2025-02-04 10:02:37',4,0),(1817,7,1817,'2025-02-04 10:02:37',4,0),(1818,7,1818,'2025-02-04 10:02:37',4,0),(1819,7,1819,'2025-02-04 10:02:37',4,0),(1820,7,1820,'2025-02-04 10:02:37',4,0),(1821,7,1821,'2025-02-04 10:02:37',4,0),(1822,7,1822,'2025-02-04 10:02:37',4,0),(1823,7,1823,'2025-02-04 10:02:37',4,0),(1824,7,1824,'2025-02-04 10:02:37',4,0),(1825,7,1825,'2025-02-04 10:02:37',4,0),(1826,7,1826,'2025-02-04 10:02:37',4,0),(1827,7,1827,'2025-02-04 10:02:37',4,0),(1828,7,1828,'2025-02-04 10:02:37',4,0),(1829,7,1829,'2025-02-04 10:02:37',4,0),(1830,7,1830,'2025-02-04 10:02:37',4,0),(1831,7,1831,'2025-02-04 10:02:37',4,0),(1832,7,1832,'2025-02-04 10:02:37',4,0),(1833,7,1833,'2025-02-04 10:02:37',4,0),(1834,7,1834,'2025-02-04 10:02:37',4,0),(1835,7,1835,'2025-02-04 10:02:37',4,0),(1836,7,1836,'2025-02-04 10:02:37',4,0),(1837,7,1837,'2025-02-04 10:02:37',4,0),(1838,7,1838,'2025-02-04 10:02:37',4,0),(1839,7,1839,'2025-02-04 10:02:37',4,0),(1840,7,1840,'2025-02-04 10:02:37',4,0),(1841,7,1841,'2025-02-04 10:02:37',4,0),(1842,7,1842,'2025-02-04 10:02:37',4,0),(1843,7,1843,'2025-02-04 10:02:37',4,0),(1844,7,1844,'2025-02-04 10:02:37',4,0),(1845,7,1845,'2025-02-04 10:02:37',4,0),(1846,7,1846,'2025-02-04 10:02:38',4,0),(1847,7,1847,'2025-02-04 10:02:38',4,0),(1848,7,1848,'2025-02-04 10:02:38',4,0),(1849,7,1849,'2025-02-04 10:02:38',4,0),(1850,7,1850,'2025-02-04 10:02:38',4,0),(1851,7,1851,'2025-02-04 10:02:38',4,0),(1852,7,1852,'2025-02-04 10:02:38',4,0),(1853,7,1853,'2025-02-04 10:02:38',4,0),(1854,7,1854,'2025-02-04 10:02:38',4,0),(1855,7,1855,'2025-02-04 10:02:38',4,0),(1856,7,1856,'2025-02-04 10:02:38',4,0),(1857,7,1857,'2025-02-04 10:02:38',4,0),(1858,7,1858,'2025-02-04 10:02:38',4,0),(1859,7,1859,'2025-02-04 10:02:38',4,0),(1860,7,1860,'2025-02-04 10:02:38',4,0),(1861,7,1861,'2025-02-04 10:02:38',4,0),(1862,7,1862,'2025-02-04 10:02:38',4,0),(1863,7,1863,'2025-02-04 10:02:38',4,0),(1864,7,1864,'2025-02-04 10:02:38',4,0),(1865,7,1865,'2025-02-04 10:02:38',4,0),(1866,7,1866,'2025-02-04 10:02:38',4,0),(1867,7,1867,'2025-02-04 10:02:38',4,0),(1868,7,1868,'2025-02-04 10:02:38',4,0),(1869,7,1869,'2025-02-04 10:02:38',4,0),(1870,7,1870,'2025-02-04 10:02:38',4,0),(1871,7,1871,'2025-02-04 10:02:38',4,0),(1872,7,1872,'2025-02-04 10:02:38',4,0),(1873,7,1873,'2025-02-04 10:02:38',4,0),(1874,7,1874,'2025-02-04 10:02:38',4,0),(1875,7,1875,'2025-02-04 10:02:38',4,0),(1876,7,1876,'2025-02-04 10:02:38',4,0),(1877,7,1877,'2025-02-04 10:02:38',4,0),(1878,7,1878,'2025-02-04 10:02:38',4,0),(1879,7,1879,'2025-02-04 10:02:38',4,0),(1880,7,1880,'2025-02-04 10:02:38',4,0),(1881,7,1881,'2025-02-04 10:02:38',4,0),(1882,7,1882,'2025-02-04 10:02:38',4,0),(1883,7,1883,'2025-02-04 10:02:38',4,0),(1884,7,1884,'2025-02-04 10:02:38',4,0),(1885,7,1885,'2025-02-04 10:02:39',4,0),(1886,7,1886,'2025-02-04 10:02:39',4,0),(1887,7,1887,'2025-02-04 10:02:39',4,0),(1888,7,1888,'2025-02-04 10:02:39',4,0),(1889,7,1889,'2025-02-04 10:02:39',4,0),(1890,7,1890,'2025-02-04 10:02:39',4,0),(1891,7,1891,'2025-02-04 10:02:39',4,0),(1892,7,1892,'2025-02-04 10:02:39',4,0),(1893,7,1893,'2025-02-04 10:02:39',4,0),(1894,7,1894,'2025-02-04 10:02:39',4,0),(1895,7,1895,'2025-02-04 10:02:39',4,0),(1896,7,1896,'2025-02-04 10:02:39',4,0),(1897,7,1897,'2025-02-04 10:02:39',4,0),(1898,7,1898,'2025-02-04 10:02:39',4,0),(1899,7,1899,'2025-02-04 10:02:39',4,0),(1900,7,1900,'2025-02-04 10:02:39',4,0),(1901,7,1901,'2025-02-04 10:02:39',4,0),(1902,7,1902,'2025-02-04 10:02:39',4,0),(1903,7,1903,'2025-02-04 10:02:39',4,0),(1904,7,1904,'2025-02-04 10:02:39',4,0),(1905,7,1905,'2025-02-04 10:02:39',4,0),(1906,7,1906,'2025-02-04 10:02:39',4,0),(1907,7,1907,'2025-02-04 10:02:39',4,0),(1908,7,1908,'2025-02-04 10:02:39',4,0),(1909,7,1909,'2025-02-04 10:02:39',4,0),(1910,7,1910,'2025-02-04 10:02:39',4,0),(1911,7,1911,'2025-02-04 10:02:39',4,0),(1912,7,1912,'2025-02-04 10:02:39',4,0),(1913,7,1913,'2025-02-04 10:02:39',4,0),(1914,7,1914,'2025-02-04 10:02:39',4,0),(1915,7,1915,'2025-02-04 10:02:39',4,0),(1916,7,1916,'2025-02-04 10:02:39',4,0),(1917,7,1917,'2025-02-04 10:02:39',4,0),(1918,7,1918,'2025-02-04 10:02:39',4,0),(1919,7,1919,'2025-02-04 10:02:39',4,0),(1920,7,1920,'2025-02-04 10:02:39',4,0),(1921,7,1921,'2025-02-04 10:02:39',4,0),(1922,7,1922,'2025-02-04 10:02:39',4,0),(1923,7,1923,'2025-02-04 10:02:40',4,0),(1924,7,1924,'2025-02-04 10:02:40',4,0),(1925,7,1925,'2025-02-04 10:02:40',4,0),(1926,7,1926,'2025-02-04 10:02:40',4,0),(1927,7,1927,'2025-02-04 10:02:40',4,0),(1928,7,1928,'2025-02-04 10:02:40',4,0),(1929,7,1929,'2025-02-04 10:02:40',4,0),(1930,7,1930,'2025-02-04 10:02:40',4,0),(1931,7,1931,'2025-02-04 10:02:40',4,0),(1932,7,1932,'2025-02-04 10:02:40',4,0),(1933,7,1933,'2025-02-04 10:02:40',4,0),(1934,7,1934,'2025-02-04 10:02:40',4,0),(1935,7,1935,'2025-02-04 10:02:40',4,0),(1936,7,1936,'2025-02-04 10:02:40',4,0),(1937,7,1937,'2025-02-04 10:02:40',4,0),(1938,7,1938,'2025-02-04 10:02:40',4,0),(1939,7,1939,'2025-02-04 10:02:40',4,0),(1940,7,1940,'2025-02-04 10:02:40',4,0),(1941,7,1941,'2025-02-04 10:02:40',4,0),(1942,7,1942,'2025-02-04 10:02:40',4,0),(1943,7,1943,'2025-02-04 10:02:40',4,0),(1944,7,1944,'2025-02-04 10:02:40',4,0),(1945,7,1945,'2025-02-04 10:02:40',4,0),(1946,7,1946,'2025-02-04 10:02:40',4,0),(1947,7,1947,'2025-02-04 10:02:40',4,0),(1948,7,1948,'2025-02-04 10:02:40',4,0),(1949,7,1949,'2025-02-04 10:02:40',4,0),(1950,7,1950,'2025-02-04 10:02:40',4,0),(1951,7,1951,'2025-02-04 10:02:40',4,0),(1952,7,1952,'2025-02-04 10:02:40',4,0),(1953,7,1953,'2025-02-04 10:02:40',4,0),(1954,7,1954,'2025-02-04 10:02:40',4,0),(1955,7,1955,'2025-02-04 10:02:40',4,0),(1956,7,1956,'2025-02-04 10:02:40',4,0),(1957,7,1957,'2025-02-04 10:02:40',4,0),(1958,7,1958,'2025-02-04 10:02:40',4,0),(1959,7,1959,'2025-02-04 10:02:40',4,0),(1960,7,1960,'2025-02-04 10:02:40',4,0),(1961,7,1961,'2025-02-04 10:02:40',4,0),(1962,7,1962,'2025-02-04 10:02:40',4,0),(1963,7,1963,'2025-02-04 10:02:40',4,0),(1964,7,1964,'2025-02-04 10:02:40',4,0),(1965,7,1965,'2025-02-04 10:02:41',4,0),(1966,7,1966,'2025-02-04 10:02:41',4,0),(1967,7,1967,'2025-02-04 10:02:41',4,0),(1968,7,1968,'2025-02-04 10:02:41',4,0),(1969,7,1969,'2025-02-04 10:02:41',4,0),(1970,7,1970,'2025-02-04 10:02:41',4,0),(1971,7,1971,'2025-02-04 10:02:41',4,0),(1972,7,1972,'2025-02-04 10:02:41',4,0),(1973,7,1973,'2025-02-04 10:02:41',4,0),(1974,7,1974,'2025-02-04 10:02:41',4,0),(1975,7,1975,'2025-02-04 10:02:41',4,0),(1976,7,1976,'2025-02-04 10:02:41',4,0),(1977,7,1977,'2025-02-04 10:02:41',4,0),(1978,7,1978,'2025-02-04 10:02:41',4,0),(1979,7,1979,'2025-02-04 10:02:41',4,0),(1980,7,1980,'2025-02-04 10:02:41',4,0),(1981,7,1981,'2025-02-04 10:02:41',4,0),(1982,7,1982,'2025-02-04 10:02:41',4,0),(1983,7,1983,'2025-02-04 10:02:41',4,0),(1984,7,1984,'2025-02-04 10:02:41',4,0),(1985,7,1985,'2025-02-04 10:02:41',4,0),(1986,7,1986,'2025-02-04 10:02:41',4,0),(1987,7,1987,'2025-02-04 10:02:41',4,0),(1988,7,1988,'2025-02-04 10:02:41',4,0),(1989,7,1989,'2025-02-04 10:02:41',4,0),(1990,7,1990,'2025-02-04 10:02:41',4,0),(1991,7,1991,'2025-02-04 10:02:41',4,0),(1992,7,1992,'2025-02-04 10:02:41',4,0),(1993,7,1993,'2025-02-04 10:02:41',4,0),(1994,7,1994,'2025-02-04 10:02:41',4,0),(1995,7,1995,'2025-02-04 10:02:41',4,0),(1996,7,1996,'2025-02-04 10:02:41',4,0),(1997,7,1997,'2025-02-04 10:02:41',4,0),(1998,7,1998,'2025-02-04 10:02:41',4,0),(1999,7,1999,'2025-02-04 10:02:41',4,0),(2000,7,2000,'2025-02-04 10:02:41',4,0),(2001,7,2001,'2025-02-04 10:02:41',4,0),(2002,7,2002,'2025-02-04 10:02:41',4,0),(2003,7,2003,'2025-02-04 10:02:41',4,0),(2004,7,2004,'2025-02-04 10:02:41',4,0),(2005,7,2005,'2025-02-04 10:02:41',4,0),(2006,7,2006,'2025-02-04 10:02:42',4,0),(2007,7,2007,'2025-02-04 10:02:42',4,0),(2008,7,2008,'2025-02-04 10:02:42',4,0),(2009,7,2009,'2025-02-04 10:02:42',4,0),(2010,7,2010,'2025-02-04 10:02:42',4,0),(2011,7,2011,'2025-02-04 10:02:42',4,0),(2012,7,2012,'2025-02-04 10:02:42',4,0),(2013,7,2013,'2025-02-04 10:02:42',4,0),(2014,7,2014,'2025-02-04 10:02:42',4,0),(2015,7,2015,'2025-02-04 10:02:42',4,0),(2016,7,2016,'2025-02-04 10:02:42',4,0),(2017,7,2017,'2025-02-04 10:02:42',4,0),(2018,7,2018,'2025-02-04 10:02:42',4,0),(2019,7,2019,'2025-02-04 10:02:42',4,0),(2020,7,2020,'2025-02-04 10:02:42',4,0),(2021,7,2021,'2025-02-04 10:02:42',4,0),(2022,7,2022,'2025-02-04 10:02:42',4,0),(2023,7,2023,'2025-02-04 10:02:42',4,0),(2024,7,2024,'2025-02-04 10:02:42',4,0),(2025,7,2025,'2025-02-04 10:02:42',4,0),(2026,7,2026,'2025-02-04 10:02:42',4,0),(2027,7,2027,'2025-02-04 10:02:42',4,0),(2028,7,2028,'2025-02-04 10:02:42',4,0),(2029,7,2029,'2025-02-04 10:02:42',4,0),(2030,7,2030,'2025-02-04 10:02:42',4,0),(2031,7,2031,'2025-02-04 10:02:42',4,0),(2032,7,2032,'2025-02-04 10:02:42',4,0),(2033,7,2033,'2025-02-04 10:02:42',4,0),(2034,7,2034,'2025-02-04 10:02:42',4,0),(2035,7,2035,'2025-02-04 10:02:42',4,0),(2036,7,2036,'2025-02-04 10:02:42',4,0),(2037,7,2037,'2025-02-04 10:02:42',4,0),(2038,7,2038,'2025-02-04 10:02:42',4,0),(2039,7,2039,'2025-02-04 10:02:42',4,0),(2040,7,2040,'2025-02-04 10:02:42',4,0),(2041,7,2041,'2025-02-04 10:02:42',4,0),(2042,7,2042,'2025-02-04 10:02:42',4,0),(2043,7,2043,'2025-02-04 10:02:42',4,0),(2044,7,2044,'2025-02-04 10:02:43',4,0),(2045,7,2045,'2025-02-04 10:02:43',4,0),(2046,7,2046,'2025-02-04 10:02:43',4,0),(2047,7,2047,'2025-02-04 10:02:43',4,0),(2048,7,2048,'2025-02-04 10:02:43',4,0),(2049,7,2049,'2025-02-04 10:02:43',4,0),(2050,7,2050,'2025-02-04 10:02:43',4,0),(2051,7,2051,'2025-02-04 10:02:43',4,0),(2052,7,2052,'2025-02-04 10:02:43',4,0),(2053,7,2053,'2025-02-04 10:02:43',4,0),(2054,7,2054,'2025-02-04 10:02:43',4,0),(2055,7,2055,'2025-02-04 10:02:43',4,0),(2056,7,2056,'2025-02-04 10:02:43',4,0),(2057,7,2057,'2025-02-04 10:02:43',4,0),(2058,7,2058,'2025-02-04 10:02:43',4,0),(2059,7,2059,'2025-02-04 10:02:43',4,0),(2060,7,2060,'2025-02-04 10:02:43',4,0),(2061,7,2061,'2025-02-04 10:02:43',4,0),(2062,7,2062,'2025-02-04 10:02:43',4,0),(2063,7,2063,'2025-02-04 10:02:43',4,0),(2064,7,2064,'2025-02-04 10:02:43',4,0),(2065,7,2065,'2025-02-04 10:02:43',4,0),(2066,7,2066,'2025-02-04 10:02:43',4,0),(2067,7,2067,'2025-02-04 10:02:43',4,0),(2068,7,2068,'2025-02-04 10:02:43',4,0),(2069,7,2069,'2025-02-04 10:02:43',4,0),(2070,7,2070,'2025-02-04 10:02:43',4,0),(2071,7,2071,'2025-02-04 10:02:43',4,0),(2072,7,2072,'2025-02-04 10:02:43',4,0),(2073,7,2073,'2025-02-04 10:02:43',4,0),(2074,7,2074,'2025-02-04 10:02:43',4,0),(2075,7,2075,'2025-02-04 10:02:43',4,0),(2076,7,2076,'2025-02-04 10:02:43',4,0),(2077,7,2077,'2025-02-04 10:02:43',4,0),(2078,7,2078,'2025-02-04 10:02:43',4,0),(2079,7,2079,'2025-02-04 10:02:43',4,0),(2080,7,2080,'2025-02-04 10:02:44',4,0),(2081,7,2081,'2025-02-04 10:02:44',4,0),(2082,7,2082,'2025-02-04 10:02:44',4,0),(2083,7,2083,'2025-02-04 10:02:44',4,0),(2084,7,2084,'2025-02-04 10:02:44',4,0),(2085,7,2085,'2025-02-04 10:02:44',4,0),(2086,7,2086,'2025-02-04 10:02:44',4,0),(2087,7,2087,'2025-02-04 10:02:44',4,0),(2088,7,2088,'2025-02-04 10:02:44',4,0),(2089,7,2089,'2025-02-04 10:02:44',4,0),(2090,7,2090,'2025-02-04 10:02:44',4,0),(2091,7,2091,'2025-02-04 10:02:44',4,0),(2092,7,2092,'2025-02-04 10:02:44',4,0),(2093,7,2093,'2025-02-04 10:02:44',4,0),(2094,7,2094,'2025-02-04 10:02:44',4,0),(2095,7,2095,'2025-02-04 10:02:44',4,0),(2096,7,2096,'2025-02-04 10:02:44',4,0),(2097,7,2097,'2025-02-04 10:02:44',4,0),(2098,7,2098,'2025-02-04 10:02:44',4,0),(2099,7,2099,'2025-02-04 10:02:44',4,0),(2100,7,2100,'2025-02-04 10:02:44',4,0),(2101,7,2101,'2025-02-04 10:02:44',4,0),(2102,7,2102,'2025-02-04 10:02:44',4,0),(2103,7,2103,'2025-02-04 10:02:44',4,0),(2104,7,2104,'2025-02-04 10:02:44',4,0),(2105,7,2105,'2025-02-04 10:02:44',4,0),(2106,7,2106,'2025-02-04 10:02:44',4,0),(2107,7,2107,'2025-02-04 10:02:44',4,0),(2108,7,2108,'2025-02-04 10:02:44',4,0),(2109,7,2109,'2025-02-04 10:02:44',4,0),(2110,7,2110,'2025-02-04 10:02:44',4,0),(2111,7,2111,'2025-02-04 10:02:44',4,0),(2112,7,2112,'2025-02-04 10:02:44',4,0),(2113,7,2113,'2025-02-04 10:02:44',4,0),(2114,7,2114,'2025-02-04 10:02:44',4,0),(2115,7,2115,'2025-02-04 10:02:44',4,0),(2116,7,2116,'2025-02-04 10:02:44',4,0),(2117,7,2117,'2025-02-04 10:02:44',4,0),(2118,7,2118,'2025-02-04 10:02:45',4,0),(2119,7,2119,'2025-02-04 10:02:45',4,0),(2120,7,2120,'2025-02-04 10:02:45',4,0),(2121,7,2121,'2025-02-04 10:02:45',4,0),(2122,7,2122,'2025-02-04 10:02:45',4,0),(2123,7,2123,'2025-02-04 10:02:45',4,0),(2124,7,2124,'2025-02-04 10:02:45',4,0),(2125,7,2125,'2025-02-04 10:02:45',4,0),(2126,7,2126,'2025-02-04 10:02:45',4,0),(2127,7,2127,'2025-02-04 10:02:45',4,0),(2128,7,2128,'2025-02-04 10:02:45',4,0),(2129,7,2129,'2025-02-04 10:02:45',4,0),(2130,7,2130,'2025-02-04 10:02:45',4,0),(2131,7,2131,'2025-02-04 10:02:45',4,0),(2132,7,2132,'2025-02-04 10:02:45',4,0),(2133,7,2133,'2025-02-04 10:02:45',4,0),(2134,7,2134,'2025-02-04 10:02:45',4,0),(2135,7,2135,'2025-02-04 10:02:45',4,0),(2136,7,2136,'2025-02-04 10:02:45',4,0),(2137,7,2137,'2025-02-04 10:02:45',4,0),(2138,7,2138,'2025-02-04 10:02:45',4,0),(2139,7,2139,'2025-02-04 10:02:45',4,0),(2140,7,2140,'2025-02-04 10:02:45',4,0),(2141,7,2141,'2025-02-04 10:02:45',4,0),(2142,7,2142,'2025-02-04 10:02:45',4,0),(2143,7,2143,'2025-02-04 10:02:45',4,0),(2144,7,2144,'2025-02-04 10:02:45',4,0),(2145,7,2145,'2025-02-04 10:02:45',4,0),(2146,7,2146,'2025-02-04 10:02:45',4,0),(2147,7,2147,'2025-02-04 10:02:45',4,0),(2148,7,2148,'2025-02-04 10:02:45',4,0),(2149,7,2149,'2025-02-04 10:02:45',4,0),(2150,7,2150,'2025-02-04 10:02:45',4,0),(2151,7,2151,'2025-02-04 10:02:45',4,0),(2152,7,2152,'2025-02-04 10:02:45',4,0),(2153,7,2153,'2025-02-04 10:02:45',4,0),(2154,7,2154,'2025-02-04 10:02:45',4,0),(2155,7,2155,'2025-02-04 10:02:46',4,0),(2156,7,2156,'2025-02-04 10:02:46',4,0),(2157,7,2157,'2025-02-04 10:02:46',4,0),(2158,7,2158,'2025-02-04 10:02:46',4,0),(2159,7,2159,'2025-02-04 10:02:46',4,0),(2160,7,2160,'2025-02-04 10:02:46',4,0),(2161,7,2161,'2025-02-04 10:02:46',4,0),(2162,7,2162,'2025-02-04 10:02:46',4,0),(2163,7,2163,'2025-02-04 10:02:46',4,0),(2164,7,2164,'2025-02-04 10:02:46',4,0),(2165,7,2165,'2025-02-04 10:02:46',4,0),(2166,7,2166,'2025-02-04 10:02:46',4,0),(2167,7,2167,'2025-02-04 10:02:46',4,0),(2168,7,2168,'2025-02-04 10:02:46',4,0),(2169,7,2169,'2025-02-04 10:02:46',4,0),(2170,7,2170,'2025-02-04 10:02:46',4,0),(2171,7,2171,'2025-02-04 10:02:46',4,0),(2172,7,2172,'2025-02-04 10:02:46',4,0),(2173,7,2173,'2025-02-04 10:02:46',4,0),(2174,7,2174,'2025-02-04 10:02:46',4,0),(2175,7,2175,'2025-02-04 10:02:46',4,0),(2176,7,2176,'2025-02-04 10:02:46',4,0),(2177,7,2177,'2025-02-04 10:02:46',4,0),(2178,7,2178,'2025-02-04 10:02:46',4,0),(2179,7,2179,'2025-02-04 10:02:46',4,0),(2180,7,2180,'2025-02-04 10:02:46',4,0),(2181,7,2181,'2025-02-04 10:02:47',4,0),(2182,7,2182,'2025-02-04 10:02:47',4,0),(2183,7,2183,'2025-02-04 10:02:47',4,0),(2184,7,2184,'2025-02-04 10:02:47',4,0),(2185,7,2185,'2025-02-04 10:02:47',4,0),(2186,7,2186,'2025-02-04 10:02:47',4,0),(2187,7,2187,'2025-02-04 10:02:47',4,0),(2188,7,2188,'2025-02-04 10:02:47',4,0),(2189,7,2189,'2025-02-04 10:02:47',4,0),(2190,7,2190,'2025-02-04 10:02:47',4,0),(2191,7,2191,'2025-02-04 10:02:47',4,0),(2192,7,2192,'2025-02-04 10:02:47',4,0),(2193,7,2193,'2025-02-04 10:02:47',4,0),(2194,7,2194,'2025-02-04 10:02:47',4,0),(2195,7,2195,'2025-02-04 10:02:47',4,0),(2196,7,2196,'2025-02-04 10:02:47',4,0),(2197,7,2197,'2025-02-04 10:02:47',4,0),(2198,7,2198,'2025-02-04 10:02:48',4,0),(2199,7,2199,'2025-02-04 10:02:48',4,0),(2200,7,2200,'2025-02-04 10:02:48',4,0),(2201,7,2201,'2025-02-04 10:02:48',4,0),(2202,7,2202,'2025-02-04 10:02:48',4,0),(2203,7,2203,'2025-02-04 10:02:48',4,0),(2204,7,2204,'2025-02-04 10:02:48',4,0),(2205,7,2205,'2025-02-04 10:02:48',4,0),(2206,7,2206,'2025-02-04 10:02:48',4,0),(2207,7,2207,'2025-02-04 10:02:48',4,0),(2208,7,2208,'2025-02-04 10:02:48',4,0),(2209,7,2209,'2025-02-04 10:02:48',4,0),(2210,7,2210,'2025-02-04 10:02:48',4,0),(2211,7,2211,'2025-02-04 10:02:48',4,0),(2212,7,2212,'2025-02-04 10:02:48',4,0),(2213,7,2213,'2025-02-04 10:02:48',4,0),(2214,7,2214,'2025-02-04 10:02:48',4,0),(2215,7,2215,'2025-02-04 10:02:49',4,0),(2216,7,2216,'2025-02-04 10:02:49',4,0),(2217,7,2217,'2025-02-04 10:02:49',4,0),(2218,7,2218,'2025-02-04 10:02:49',4,0),(2219,7,2219,'2025-02-04 10:02:49',4,0),(2220,7,2220,'2025-02-04 10:02:49',4,0),(2221,7,2221,'2025-02-04 10:02:49',4,0),(2222,7,2222,'2025-02-04 10:02:49',4,0),(2223,7,2223,'2025-02-04 10:02:49',4,0),(2224,7,2224,'2025-02-04 10:02:49',4,0),(2225,7,2225,'2025-02-04 10:02:49',4,0),(2226,7,2226,'2025-02-04 10:02:49',4,0),(2227,7,2227,'2025-02-04 10:02:49',4,0),(2228,7,2228,'2025-02-04 10:02:49',4,0),(2229,7,2229,'2025-02-04 10:02:49',4,0),(2230,7,2230,'2025-02-04 10:02:50',4,0),(2231,7,2231,'2025-02-04 10:02:50',4,0),(2232,7,2232,'2025-02-04 10:02:50',4,0),(2233,7,2233,'2025-02-04 10:02:50',4,0),(2234,7,2234,'2025-02-04 10:02:50',4,0),(2235,7,2235,'2025-02-04 10:02:50',4,0),(2236,7,2236,'2025-02-04 10:02:50',4,0),(2237,7,2237,'2025-02-04 10:02:50',4,0),(2238,7,2238,'2025-02-04 10:02:50',4,0),(2239,7,2239,'2025-02-04 10:02:50',4,0),(2240,7,2240,'2025-02-04 10:02:50',4,0),(2241,7,2241,'2025-02-04 10:02:50',4,0),(2242,7,2242,'2025-02-04 10:02:50',4,0),(2243,7,2243,'2025-02-04 10:02:50',4,0),(2244,7,2244,'2025-02-04 10:02:50',4,0),(2245,7,2245,'2025-02-04 10:02:50',4,0),(2246,7,2246,'2025-02-04 10:02:50',4,0),(2247,7,2247,'2025-02-04 10:02:50',4,0),(2248,7,2248,'2025-02-04 10:02:51',4,0),(2249,7,2249,'2025-02-04 10:02:51',4,0),(2250,7,2250,'2025-02-04 10:02:51',4,0),(2251,7,2251,'2025-02-04 10:02:51',4,0),(2252,7,2252,'2025-02-04 10:02:51',4,0),(2253,7,2253,'2025-02-04 10:02:51',4,0),(2254,7,2254,'2025-02-04 10:02:51',4,0),(2255,7,2255,'2025-02-04 10:02:51',4,0),(2256,7,2256,'2025-02-04 10:02:51',4,0),(2257,7,2257,'2025-02-04 10:02:51',4,0),(2258,7,2258,'2025-02-04 10:02:51',4,0),(2259,7,2259,'2025-02-04 10:02:51',4,0),(2260,7,2260,'2025-02-04 10:02:51',4,0),(2261,7,2261,'2025-02-04 10:02:51',4,0),(2262,7,2262,'2025-02-04 10:02:51',4,0),(2263,7,2263,'2025-02-04 10:02:51',4,0),(2264,7,2264,'2025-02-04 10:02:51',4,0),(2265,7,2265,'2025-02-04 10:02:51',4,0),(2266,7,2266,'2025-02-04 10:02:51',4,0),(2267,7,2267,'2025-02-04 10:02:51',4,0),(2268,7,2268,'2025-02-04 10:02:51',4,0),(2269,7,2269,'2025-02-04 10:02:51',4,0),(2270,7,2270,'2025-02-04 10:02:51',4,0),(2271,7,2271,'2025-02-04 10:02:51',4,0),(2272,7,2272,'2025-02-04 10:02:52',4,0),(2273,7,2273,'2025-02-04 10:02:52',4,0),(2274,7,2274,'2025-02-04 10:02:52',4,0),(2275,7,2275,'2025-02-04 10:02:52',4,0),(2276,7,2276,'2025-02-04 10:02:52',4,0),(2277,7,2277,'2025-02-04 10:02:52',4,0),(2278,7,2278,'2025-02-04 10:02:52',4,0),(2279,7,2279,'2025-02-04 10:02:52',4,0),(2280,7,2280,'2025-02-04 10:02:52',4,0),(2281,7,2281,'2025-02-04 10:02:52',4,0),(2282,7,2282,'2025-02-04 10:02:52',4,0),(2283,7,2283,'2025-02-04 10:02:52',4,0),(2284,7,2284,'2025-02-04 10:02:52',4,0),(2285,7,2285,'2025-02-04 10:02:52',4,0),(2286,7,2286,'2025-02-04 10:02:52',4,0),(2287,7,2287,'2025-02-04 10:02:52',4,0),(2288,7,2288,'2025-02-04 10:02:52',4,0),(2289,7,2289,'2025-02-04 10:02:52',4,0),(2290,7,2290,'2025-02-04 10:02:52',4,0),(2291,7,2291,'2025-02-04 10:02:52',4,0),(2292,7,2292,'2025-02-04 10:02:52',4,0),(2293,7,2293,'2025-02-04 10:02:52',4,0),(2294,7,2294,'2025-02-04 10:02:52',4,0),(2295,7,2295,'2025-02-04 10:02:52',4,0),(2296,7,2296,'2025-02-04 10:02:52',4,0),(2297,7,2297,'2025-02-04 10:02:52',4,0),(2298,7,2298,'2025-02-04 10:02:52',4,0),(2299,7,2299,'2025-02-04 10:02:52',4,0),(2300,7,2300,'2025-02-04 10:02:52',4,0),(2301,7,2301,'2025-02-04 10:02:53',4,0),(2302,7,2302,'2025-02-04 10:02:53',4,0),(2303,7,2303,'2025-02-04 10:02:53',4,0),(2304,7,2304,'2025-02-04 10:02:53',4,0),(2305,7,2305,'2025-02-04 10:02:53',4,0),(2306,7,2306,'2025-02-04 10:02:53',4,0),(2307,7,2307,'2025-02-04 10:02:53',4,0),(2308,7,2308,'2025-02-04 10:02:53',4,0),(2309,7,2309,'2025-02-04 10:02:53',4,0),(2310,7,2310,'2025-02-04 10:02:53',4,0),(2311,7,2311,'2025-02-04 10:02:53',4,0),(2312,7,2312,'2025-02-04 10:02:53',4,0),(2313,7,2313,'2025-02-04 10:02:53',4,0),(2314,7,2314,'2025-02-04 10:02:53',4,0),(2315,7,2315,'2025-02-04 10:02:53',4,0),(2316,7,2316,'2025-02-04 10:02:53',4,0),(2317,7,2317,'2025-02-04 10:02:53',4,0),(2318,7,2318,'2025-02-04 10:02:53',4,0),(2319,7,2319,'2025-02-04 10:02:53',4,0),(2320,7,2320,'2025-02-04 10:02:53',4,0),(2321,7,2321,'2025-02-04 10:02:53',4,0),(2322,7,2322,'2025-02-04 10:02:53',4,0),(2323,7,2323,'2025-02-04 10:02:53',4,0),(2324,7,2324,'2025-02-04 10:02:53',4,0),(2325,7,2325,'2025-02-04 10:02:53',4,0),(2326,7,2326,'2025-02-04 10:02:53',4,0),(2327,7,2327,'2025-02-04 10:02:53',4,0),(2328,7,2328,'2025-02-04 10:02:53',4,0),(2329,7,2329,'2025-02-04 10:02:53',4,0),(2330,7,2330,'2025-02-04 10:02:53',4,0),(2331,7,2331,'2025-02-04 10:02:53',4,0),(2332,7,2332,'2025-02-04 10:02:53',4,0),(2333,7,2333,'2025-02-04 10:02:53',4,0),(2334,7,2334,'2025-02-04 10:02:54',4,0),(2335,7,2335,'2025-02-04 10:02:54',4,0),(2336,7,2336,'2025-02-04 10:02:54',4,0),(2337,7,2337,'2025-02-04 10:02:54',4,0),(2338,7,2338,'2025-02-04 10:02:54',4,0),(2339,7,2339,'2025-02-04 10:02:54',4,0),(2340,7,2340,'2025-02-04 10:02:54',4,0),(2341,7,2341,'2025-02-04 10:02:54',4,0),(2342,7,2342,'2025-02-04 10:02:54',4,0),(2343,7,2343,'2025-02-04 10:02:54',4,0),(2344,7,2344,'2025-02-04 10:02:54',4,0),(2345,7,2345,'2025-02-04 10:02:54',4,0),(2346,7,2346,'2025-02-04 10:02:54',4,0),(2347,7,2347,'2025-02-04 10:02:54',4,0),(2348,7,2348,'2025-02-04 10:02:54',4,0),(2349,7,2349,'2025-02-04 10:02:54',4,0),(2350,7,2350,'2025-02-04 10:02:54',4,0),(2351,7,2351,'2025-02-04 10:02:54',4,0),(2352,7,2352,'2025-02-04 10:02:54',4,0),(2353,7,2353,'2025-02-04 10:02:54',4,0),(2354,7,2354,'2025-02-04 10:02:54',4,0),(2355,7,2355,'2025-02-04 10:02:54',4,0),(2356,7,2356,'2025-02-04 10:02:54',4,0),(2357,7,2357,'2025-02-04 10:02:54',4,0),(2358,7,2358,'2025-02-04 10:02:54',4,0),(2359,7,2359,'2025-02-04 10:02:54',4,0),(2360,7,2360,'2025-02-04 10:02:54',4,0),(2361,7,2361,'2025-02-04 10:02:54',4,0),(2362,7,2362,'2025-02-04 10:02:54',4,0),(2363,7,2363,'2025-02-04 10:02:54',4,0),(2364,7,2364,'2025-02-04 10:02:54',4,0),(2365,7,2365,'2025-02-04 10:02:54',4,0),(2366,7,2366,'2025-02-04 10:02:54',4,0),(2367,7,2367,'2025-02-04 10:02:54',4,0),(2368,7,2368,'2025-02-04 10:02:55',4,0),(2369,7,2369,'2025-02-04 10:02:55',4,0),(2370,7,2370,'2025-02-04 10:02:55',4,0),(2371,7,2371,'2025-02-04 10:02:55',4,0),(2372,7,2372,'2025-02-04 10:02:55',4,0),(2373,7,2373,'2025-02-04 10:02:55',4,0),(2374,7,2374,'2025-02-04 10:02:55',4,0),(2375,7,2375,'2025-02-04 10:02:55',4,0),(2376,7,2376,'2025-02-04 10:02:55',4,0),(2377,7,2377,'2025-02-04 10:02:55',4,0),(2378,7,2378,'2025-02-04 10:02:55',4,0),(2379,7,2379,'2025-02-04 10:02:55',4,0),(2380,7,2380,'2025-02-04 10:02:55',4,0),(2381,7,2381,'2025-02-04 10:02:55',4,0),(2382,7,2382,'2025-02-04 10:02:55',4,0),(2383,7,2383,'2025-02-04 10:02:55',4,0),(2384,7,2384,'2025-02-04 10:02:55',4,0),(2385,7,2385,'2025-02-04 10:02:55',4,0),(2386,7,2386,'2025-02-04 10:02:55',4,0),(2387,7,2387,'2025-02-04 10:02:55',4,0),(2388,7,2388,'2025-02-04 10:02:55',4,0),(2389,7,2389,'2025-02-04 10:02:55',4,0),(2390,7,2390,'2025-02-04 10:02:55',4,0),(2391,7,2391,'2025-02-04 10:02:55',4,0),(2392,7,2392,'2025-02-04 10:02:55',4,0),(2393,7,2393,'2025-02-04 10:02:55',4,0),(2394,7,2394,'2025-02-04 10:02:55',4,0),(2395,7,2395,'2025-02-04 10:02:55',4,0),(2396,7,2396,'2025-02-04 10:02:55',4,0),(2397,7,2397,'2025-02-04 10:02:55',4,0),(2398,7,2398,'2025-02-04 10:02:55',4,0),(2399,7,2399,'2025-02-04 10:02:55',4,0),(2400,7,2400,'2025-02-04 10:02:55',4,0),(2401,7,2401,'2025-02-04 10:02:55',4,0),(2402,7,2402,'2025-02-04 10:02:55',4,0),(2403,7,2403,'2025-02-04 10:02:55',4,0),(2404,7,2404,'2025-02-04 10:02:55',4,0),(2405,7,2405,'2025-02-04 10:02:55',4,0),(2406,7,2406,'2025-02-04 10:02:55',4,0),(2407,7,2407,'2025-02-04 10:02:56',4,0),(2408,7,2408,'2025-02-04 10:02:56',4,0),(2409,7,2409,'2025-02-04 10:02:56',4,0),(2410,7,2410,'2025-02-04 10:02:56',4,0),(2411,7,2411,'2025-02-04 10:02:56',4,0),(2412,7,2412,'2025-02-04 10:02:56',4,0),(2413,7,2413,'2025-02-04 10:02:56',4,0),(2414,7,2414,'2025-02-04 10:02:56',4,0),(2415,7,2415,'2025-02-04 10:02:56',4,0),(2416,7,2416,'2025-02-04 10:02:56',4,0),(2417,7,2417,'2025-02-04 10:02:56',4,0),(2418,7,2418,'2025-02-04 10:02:56',4,0),(2419,7,2419,'2025-02-04 10:02:56',4,0),(2420,7,2420,'2025-02-04 10:02:56',4,0),(2421,7,2421,'2025-02-04 10:02:56',4,0),(2422,7,2422,'2025-02-04 10:02:56',4,0),(2423,7,2423,'2025-02-04 10:02:56',4,0),(2424,7,2424,'2025-02-04 10:02:56',4,0),(2425,7,2425,'2025-02-04 10:02:56',4,0),(2426,7,2426,'2025-02-04 10:02:56',4,0),(2427,7,2427,'2025-02-04 10:02:56',4,0),(2428,7,2428,'2025-02-04 10:02:56',4,0),(2429,7,2429,'2025-02-04 10:02:56',4,0),(2430,7,2430,'2025-02-04 10:02:56',4,0),(2431,7,2431,'2025-02-04 10:02:56',4,0),(2432,7,2432,'2025-02-04 10:02:56',4,0),(2433,7,2433,'2025-02-04 10:02:56',4,0),(2434,7,2434,'2025-02-04 10:02:56',4,0),(2435,7,2435,'2025-02-04 10:02:56',4,0),(2436,7,2436,'2025-02-04 10:02:56',4,0),(2437,7,2437,'2025-02-04 10:02:56',4,0),(2438,7,2438,'2025-02-04 10:02:56',4,0),(2439,7,2439,'2025-02-04 10:02:56',4,0),(2440,7,2440,'2025-02-04 10:02:56',4,0),(2441,7,2441,'2025-02-04 10:02:56',4,0),(2442,7,2442,'2025-02-04 10:02:56',4,0),(2443,7,2443,'2025-02-04 10:02:56',4,0),(2444,7,2444,'2025-02-04 10:02:57',4,0),(2445,7,2445,'2025-02-04 10:02:57',4,0),(2446,7,2446,'2025-02-04 10:02:57',4,0),(2447,7,2447,'2025-02-04 10:02:57',4,0),(2448,7,2448,'2025-02-04 10:02:57',4,0),(2449,7,2449,'2025-02-04 10:02:57',4,0),(2450,7,2450,'2025-02-04 10:02:57',4,0),(2451,7,2451,'2025-02-04 10:02:57',4,0),(2452,7,2452,'2025-02-04 10:02:57',4,0),(2453,7,2453,'2025-02-04 10:02:57',4,0),(2454,7,2454,'2025-02-04 10:02:57',4,0),(2455,7,2455,'2025-02-04 10:02:57',4,0),(2456,7,2456,'2025-02-04 10:02:57',4,0),(2457,7,2457,'2025-02-04 10:02:57',4,0),(2458,7,2458,'2025-02-04 10:02:57',4,0),(2459,7,2459,'2025-02-04 10:02:57',4,0),(2460,7,2460,'2025-02-04 10:02:57',4,0),(2461,7,2461,'2025-02-04 10:02:57',4,0),(2462,7,2462,'2025-02-04 10:02:57',4,0),(2463,7,2463,'2025-02-04 10:02:57',4,0),(2464,7,2464,'2025-02-04 10:02:57',4,0),(2465,7,2465,'2025-02-04 10:02:57',4,0),(2466,7,2466,'2025-02-04 10:02:57',4,0),(2467,7,2467,'2025-02-04 10:02:57',4,0),(2468,7,2468,'2025-02-04 10:02:57',4,0),(2469,7,2469,'2025-02-04 10:02:57',4,0),(2470,7,2470,'2025-02-04 10:02:57',4,0),(2471,7,2471,'2025-02-04 10:02:57',4,0),(2472,7,2472,'2025-02-04 10:02:57',4,0),(2473,7,2473,'2025-02-04 10:02:57',4,0),(2474,7,2474,'2025-02-04 10:02:57',4,0),(2475,7,2475,'2025-02-04 10:02:57',4,0),(2476,7,2476,'2025-02-04 10:02:57',4,0),(2477,7,2477,'2025-02-04 10:02:57',4,0),(2478,7,2478,'2025-02-04 10:02:57',4,0),(2479,7,2479,'2025-02-04 10:02:57',4,0),(2480,7,2480,'2025-02-04 10:02:57',4,0),(2481,7,2481,'2025-02-04 10:02:57',4,0),(2482,7,2482,'2025-02-04 10:02:57',4,0),(2483,7,2483,'2025-02-04 10:02:57',4,0),(2484,7,2484,'2025-02-04 10:02:57',4,0),(2485,7,2485,'2025-02-04 10:02:57',4,0),(2486,7,2486,'2025-02-04 10:02:58',4,0),(2487,7,2487,'2025-02-04 10:02:58',4,0),(2488,7,2488,'2025-02-04 10:02:58',4,0),(2489,7,2489,'2025-02-04 10:02:58',4,0),(2490,7,2490,'2025-02-04 10:02:58',4,0),(2491,7,2491,'2025-02-04 10:02:58',4,0),(2492,7,2492,'2025-02-04 10:02:58',4,0),(2493,7,2493,'2025-02-04 10:02:58',4,0),(2494,7,2494,'2025-02-04 10:02:58',4,0),(2495,7,2495,'2025-02-04 10:02:58',4,0),(2496,7,2496,'2025-02-04 10:02:58',4,0),(2497,7,2497,'2025-02-04 10:02:58',4,0),(2498,7,2498,'2025-02-04 10:02:58',4,0),(2499,7,2499,'2025-02-04 10:02:58',4,0),(2500,7,2500,'2025-02-04 10:02:58',4,0),(2501,7,2501,'2025-02-04 10:02:58',4,0),(2502,7,2502,'2025-02-04 10:02:58',4,0),(2503,7,2503,'2025-02-04 10:02:58',4,0),(2504,7,2504,'2025-02-04 10:02:58',4,0),(2505,7,2505,'2025-02-04 10:02:58',4,0),(2506,7,2506,'2025-02-04 10:02:58',4,0),(2507,7,2507,'2025-02-04 10:02:58',4,0),(2508,7,2508,'2025-02-04 10:02:58',4,0),(2509,7,2509,'2025-02-04 10:02:58',4,0),(2510,7,2510,'2025-02-04 10:02:58',4,0),(2511,7,2511,'2025-02-04 10:02:58',4,0),(2512,7,2512,'2025-02-04 10:02:58',4,0),(2513,7,2513,'2025-02-04 10:02:58',4,0),(2514,7,2514,'2025-02-04 10:02:58',4,0),(2515,7,2515,'2025-02-04 10:02:58',4,0),(2516,7,2516,'2025-02-04 10:02:58',4,0),(2517,7,2517,'2025-02-04 10:02:58',4,0),(2518,7,2518,'2025-02-04 10:02:58',4,0),(2519,7,2519,'2025-02-04 10:02:58',4,0),(2520,7,2520,'2025-02-04 10:02:58',4,0),(2521,7,2521,'2025-02-04 10:02:58',4,0),(2522,7,2522,'2025-02-04 10:02:58',4,0),(2523,7,2523,'2025-02-04 10:02:58',4,0),(2524,7,2524,'2025-02-04 10:02:58',4,0),(2525,7,2525,'2025-02-04 10:02:58',4,0),(2526,7,2526,'2025-02-04 10:02:59',4,0),(2527,7,2527,'2025-02-04 10:02:59',4,0),(2528,7,2528,'2025-02-04 10:02:59',4,0),(2529,7,2529,'2025-02-04 10:02:59',4,0),(2530,7,2530,'2025-02-04 10:02:59',4,0),(2531,7,2531,'2025-02-04 10:02:59',4,0),(2532,7,2532,'2025-02-04 10:02:59',4,0),(2533,7,2533,'2025-02-04 10:02:59',4,0),(2534,7,2534,'2025-02-04 10:02:59',4,0),(2535,7,2535,'2025-02-04 10:02:59',4,0),(2536,7,2536,'2025-02-04 10:02:59',4,0),(2537,7,2537,'2025-02-04 10:02:59',4,0),(2538,7,2538,'2025-02-04 10:02:59',4,0),(2539,7,2539,'2025-02-04 10:02:59',4,0),(2540,7,2540,'2025-02-04 10:02:59',4,0),(2541,7,2541,'2025-02-04 10:02:59',4,0),(2542,7,2542,'2025-02-04 10:02:59',4,0),(2543,7,2543,'2025-02-04 10:02:59',4,0),(2544,7,2544,'2025-02-04 10:02:59',4,0),(2545,7,2545,'2025-02-04 10:02:59',4,0),(2546,7,2546,'2025-02-04 10:02:59',4,0),(2547,7,2547,'2025-02-04 10:02:59',4,0),(2548,7,2548,'2025-02-04 10:02:59',4,0),(2549,7,2549,'2025-02-04 10:02:59',4,0),(2550,7,2550,'2025-02-04 10:02:59',4,0),(2551,7,2551,'2025-02-04 10:02:59',4,0),(2552,7,2552,'2025-02-04 10:02:59',4,0),(2553,7,2553,'2025-02-04 10:02:59',4,0),(2554,7,2554,'2025-02-04 10:02:59',4,0),(2555,7,2555,'2025-02-04 10:02:59',4,0),(2556,7,2556,'2025-02-04 10:02:59',4,0),(2557,7,2557,'2025-02-04 10:02:59',4,0),(2558,7,2558,'2025-02-04 10:02:59',4,0),(2559,7,2559,'2025-02-04 10:02:59',4,0),(2560,7,2560,'2025-02-04 10:02:59',4,0),(2561,7,2561,'2025-02-04 10:02:59',4,0),(2562,7,2562,'2025-02-04 10:03:00',4,0),(2563,7,2563,'2025-02-04 10:03:00',4,0),(2564,7,2564,'2025-02-04 10:03:00',4,0),(2565,7,2565,'2025-02-04 10:03:00',4,0),(2566,7,2566,'2025-02-04 10:03:00',4,0),(2567,7,2567,'2025-02-04 10:03:00',4,0),(2568,7,2568,'2025-02-04 10:03:00',4,0),(2569,7,2569,'2025-02-04 10:03:00',4,0),(2570,7,2570,'2025-02-04 10:03:00',4,0),(2571,7,2571,'2025-02-04 10:03:00',4,0),(2572,7,2572,'2025-02-04 10:03:00',4,0),(2573,7,2573,'2025-02-04 10:03:00',4,0),(2574,7,2574,'2025-02-04 10:03:00',4,0),(2575,7,2575,'2025-02-04 10:03:00',4,0),(2576,7,2576,'2025-02-04 10:03:00',4,0),(2577,7,2577,'2025-02-04 10:03:00',4,0),(2578,7,2578,'2025-02-04 10:03:00',4,0),(2579,7,2579,'2025-02-04 10:03:00',4,0),(2580,7,2580,'2025-02-04 10:03:00',4,0),(2581,7,2581,'2025-02-04 10:03:00',4,0),(2582,7,2582,'2025-02-04 10:03:00',4,0),(2583,7,2583,'2025-02-04 10:03:00',4,0),(2584,7,2584,'2025-02-04 10:03:00',4,0),(2585,7,2585,'2025-02-04 10:03:00',4,0),(2586,7,2586,'2025-02-04 10:03:00',4,0),(2587,7,2587,'2025-02-04 10:03:00',4,0),(2588,7,2588,'2025-02-04 10:03:00',4,0),(2589,7,2589,'2025-02-04 10:03:00',4,0),(2590,7,2590,'2025-02-04 10:03:00',4,0),(2591,7,2591,'2025-02-04 10:03:00',4,0),(2592,7,2592,'2025-02-04 10:03:00',4,0),(2593,7,2593,'2025-02-04 10:03:00',4,0),(2594,7,2594,'2025-02-04 10:03:00',4,0),(2595,7,2595,'2025-02-04 10:03:00',4,0),(2596,7,2596,'2025-02-04 10:03:00',4,0),(2597,7,2597,'2025-02-04 10:03:01',4,0),(2598,7,2598,'2025-02-04 10:03:01',4,0),(2599,7,2599,'2025-02-04 10:03:01',4,0),(2600,7,2600,'2025-02-04 10:03:01',4,0),(2601,7,2601,'2025-02-04 10:03:01',4,0),(2602,7,2602,'2025-02-04 10:03:01',4,0),(2603,7,2603,'2025-02-04 10:03:01',4,0),(2604,7,2604,'2025-02-04 10:03:01',4,0),(2605,7,2605,'2025-02-04 10:03:01',4,0),(2606,7,2606,'2025-02-04 10:03:01',4,0),(2607,7,2607,'2025-02-04 10:03:01',4,0),(2608,7,2608,'2025-02-04 10:03:01',4,0),(2609,7,2609,'2025-02-04 10:03:01',4,0),(2610,7,2610,'2025-02-04 10:03:01',4,0),(2611,7,2611,'2025-02-04 10:03:01',4,0),(2612,7,2612,'2025-02-04 10:03:01',4,0),(2613,7,2613,'2025-02-04 10:03:01',4,0),(2614,7,2614,'2025-02-04 10:03:01',4,0),(2615,7,2615,'2025-02-04 10:03:01',4,0),(2616,7,2616,'2025-02-04 10:03:01',4,0),(2617,7,2617,'2025-02-04 10:03:01',4,0),(2618,7,2618,'2025-02-04 10:03:01',4,0),(2619,7,2619,'2025-02-04 10:03:01',4,0),(2620,7,2620,'2025-02-04 10:03:01',4,0),(2621,7,2621,'2025-02-04 10:03:01',4,0),(2622,7,2622,'2025-02-04 10:03:01',4,0),(2623,7,2623,'2025-02-04 10:03:01',4,0),(2624,7,2624,'2025-02-04 10:03:01',4,0),(2625,7,2625,'2025-02-04 10:03:01',4,0),(2626,7,2626,'2025-02-04 10:03:01',4,0),(2627,7,2627,'2025-02-04 10:03:01',4,0),(2628,7,2628,'2025-02-04 10:03:01',4,0),(2629,7,2629,'2025-02-04 10:03:01',4,0),(2630,7,2630,'2025-02-04 10:03:01',4,0),(2631,7,2631,'2025-02-04 10:03:01',4,0),(2632,7,2632,'2025-02-04 10:03:01',4,0),(2633,7,2633,'2025-02-04 10:03:01',4,0),(2634,7,2634,'2025-02-04 10:03:02',4,0),(2635,7,2635,'2025-02-04 10:03:02',4,0),(2636,7,2636,'2025-02-04 10:03:02',4,0),(2637,7,2637,'2025-02-04 10:03:02',4,0),(2638,7,2638,'2025-02-04 10:03:02',4,0),(2639,7,2639,'2025-02-04 10:03:02',4,0),(2640,7,2640,'2025-02-04 10:03:02',4,0),(2641,7,2641,'2025-02-04 10:03:02',4,0),(2642,7,2642,'2025-02-04 10:03:02',4,0),(2643,7,2643,'2025-02-04 10:03:02',4,0),(2644,7,2644,'2025-02-04 10:03:02',4,0),(2645,7,2645,'2025-02-04 10:03:02',4,0),(2646,7,2646,'2025-02-04 10:03:02',4,0),(2647,7,2647,'2025-02-04 10:03:02',4,0),(2648,7,2648,'2025-02-04 10:03:02',4,0),(2649,7,2649,'2025-02-04 10:03:02',4,0),(2650,7,2650,'2025-02-04 10:03:02',4,0),(2651,7,2651,'2025-02-04 10:03:02',4,0),(2652,7,2652,'2025-02-04 10:03:02',4,0),(2653,7,2653,'2025-02-04 10:03:02',4,0),(2654,7,2654,'2025-02-04 10:03:02',4,0),(2655,7,2655,'2025-02-04 10:03:02',4,0),(2656,7,2656,'2025-02-04 10:03:02',4,0),(2657,7,2657,'2025-02-04 10:03:02',4,0),(2658,7,2658,'2025-02-04 10:03:02',4,0),(2659,7,2659,'2025-02-04 10:03:02',4,0),(2660,7,2660,'2025-02-04 10:03:02',4,0),(2661,7,2661,'2025-02-04 10:03:02',4,0),(2662,7,2662,'2025-02-04 10:03:02',4,0),(2663,7,2663,'2025-02-04 10:03:02',4,0),(2664,7,2664,'2025-02-04 10:03:02',4,0),(2665,7,2665,'2025-02-04 10:03:02',4,0),(2666,7,2666,'2025-02-04 10:03:02',4,0),(2667,7,2667,'2025-02-04 10:03:02',4,0),(2668,7,2668,'2025-02-04 10:03:03',4,0),(2669,7,2669,'2025-02-04 10:03:03',4,0),(2670,7,2670,'2025-02-04 10:03:03',4,0),(2671,7,2671,'2025-02-04 10:03:03',4,0),(2672,7,2672,'2025-02-04 10:03:03',4,0),(2673,7,2673,'2025-02-04 10:03:03',4,0),(2674,7,2674,'2025-02-04 10:03:03',4,0),(2675,7,2675,'2025-02-04 10:03:03',4,0),(2676,7,2676,'2025-02-04 10:03:03',4,0),(2677,7,2677,'2025-02-04 10:03:03',4,0),(2678,7,2678,'2025-02-04 10:03:03',4,0),(2679,7,2679,'2025-02-04 10:03:03',4,0),(2680,7,2680,'2025-02-04 10:03:03',4,0),(2681,7,2681,'2025-02-04 10:03:03',4,0),(2682,7,2682,'2025-02-04 10:03:03',4,0),(2683,7,2683,'2025-02-04 10:03:03',4,0),(2684,7,2684,'2025-02-04 10:03:03',4,0),(2685,7,2685,'2025-02-04 10:03:03',4,0),(2686,7,2686,'2025-02-04 10:03:03',4,0),(2687,7,2687,'2025-02-04 10:03:03',4,0),(2688,7,2688,'2025-02-04 10:03:03',4,0),(2689,7,2689,'2025-02-04 10:03:03',4,0),(2690,7,2690,'2025-02-04 10:03:03',4,0),(2691,7,2691,'2025-02-04 10:03:03',4,0),(2692,7,2692,'2025-02-04 10:03:03',4,0),(2693,7,2693,'2025-02-04 10:03:03',4,0),(2694,7,2694,'2025-02-04 10:03:03',4,0),(2695,7,2695,'2025-02-04 10:03:03',4,0),(2696,7,2696,'2025-02-04 10:03:03',4,0),(2697,7,2697,'2025-02-04 10:03:03',4,0),(2698,7,2698,'2025-02-04 10:03:03',4,0),(2699,7,2699,'2025-02-04 10:03:03',4,0),(2700,7,2700,'2025-02-04 10:03:03',4,0),(2701,7,2701,'2025-02-04 10:03:03',4,0),(2702,7,2702,'2025-02-04 10:03:03',4,0),(2703,7,2703,'2025-02-04 10:03:03',4,0),(2704,7,2704,'2025-02-04 10:03:03',4,0),(2705,7,2705,'2025-02-04 10:03:03',4,0),(2706,7,2706,'2025-02-04 10:03:03',4,0),(2707,7,2707,'2025-02-04 10:03:03',4,0),(2708,7,2708,'2025-02-04 10:03:04',4,0),(2709,7,2709,'2025-02-04 10:03:04',4,0),(2710,7,2710,'2025-02-04 10:03:04',4,0),(2711,7,2711,'2025-02-04 10:03:04',4,0),(2712,7,2712,'2025-02-04 10:03:04',4,0),(2713,7,2713,'2025-02-04 10:03:04',4,0),(2714,7,2714,'2025-02-04 10:03:04',4,0),(2715,7,2715,'2025-02-04 10:03:04',4,0),(2716,7,2716,'2025-02-04 10:03:04',4,0),(2717,7,2717,'2025-02-04 10:03:04',4,0),(2718,7,2718,'2025-02-04 10:03:04',4,0),(2719,7,2719,'2025-02-04 10:03:04',4,0),(2720,7,2720,'2025-02-04 10:03:04',4,0),(2721,7,2721,'2025-02-04 10:03:04',4,0),(2722,7,2722,'2025-02-04 10:03:04',4,0),(2723,7,2723,'2025-02-04 10:03:04',4,0),(2724,7,2724,'2025-02-04 10:03:04',4,0),(2725,7,2725,'2025-02-04 10:03:04',4,0),(2726,7,2726,'2025-02-04 10:03:04',4,0),(2727,7,2727,'2025-02-04 10:03:04',4,0),(2728,7,2728,'2025-02-04 10:03:04',4,0),(2729,7,2729,'2025-02-04 10:03:04',4,0),(2730,7,2730,'2025-02-04 10:03:04',4,0),(2731,7,2731,'2025-02-04 10:03:04',4,0),(2732,7,2732,'2025-02-04 10:03:04',4,0),(2733,7,2733,'2025-02-04 10:03:04',4,0),(2734,7,2734,'2025-02-04 10:03:04',4,0),(2735,7,2735,'2025-02-04 10:03:04',4,0),(2736,7,2736,'2025-02-04 10:03:04',4,0),(2737,7,2737,'2025-02-04 10:03:04',4,0),(2738,7,2738,'2025-02-04 10:03:04',4,0),(2739,7,2739,'2025-02-04 10:03:04',4,0),(2740,7,2740,'2025-02-04 10:03:04',4,0),(2741,7,2741,'2025-02-04 10:03:04',4,0),(2742,7,2742,'2025-02-04 10:03:04',4,0),(2743,7,2743,'2025-02-04 10:03:04',4,0),(2744,7,2744,'2025-02-04 10:03:04',4,0),(2745,7,2745,'2025-02-04 10:03:04',4,0),(2746,7,2746,'2025-02-04 10:03:05',4,0),(2747,7,2747,'2025-02-04 10:03:05',4,0),(2748,7,2748,'2025-02-04 10:03:05',4,0),(2749,7,2749,'2025-02-04 10:03:05',4,0),(2750,7,2750,'2025-02-04 10:03:05',4,0),(2751,7,2751,'2025-02-04 10:03:05',4,0),(2752,7,2752,'2025-02-04 10:03:05',4,0),(2753,7,2753,'2025-02-04 10:03:05',4,0),(2754,7,2754,'2025-02-04 10:03:05',4,0),(2755,7,2755,'2025-02-04 10:03:05',4,0),(2756,7,2756,'2025-02-04 10:03:05',4,0),(2757,7,2757,'2025-02-04 10:03:05',4,0),(2758,7,2758,'2025-02-04 10:03:05',4,0),(2759,7,2759,'2025-02-04 10:03:05',4,0),(2760,7,2760,'2025-02-04 10:03:05',4,0),(2761,7,2761,'2025-02-04 10:03:05',4,0),(2762,7,2762,'2025-02-04 10:03:05',4,0),(2763,7,2763,'2025-02-04 10:03:05',4,0),(2764,7,2764,'2025-02-04 10:03:05',4,0),(2765,7,2765,'2025-02-04 10:03:05',4,0),(2766,7,2766,'2025-02-04 10:03:05',4,0),(2767,7,2767,'2025-02-04 10:03:05',4,0),(2768,7,2768,'2025-02-04 10:03:05',4,0),(2769,7,2769,'2025-02-04 10:03:05',4,0),(2770,7,2770,'2025-02-04 10:03:05',4,0),(2771,7,2771,'2025-02-04 10:03:05',4,0),(2772,7,2772,'2025-02-04 10:03:05',4,0),(2773,7,2773,'2025-02-04 10:03:05',4,0),(2774,7,2774,'2025-02-04 10:03:05',4,0),(2775,7,2775,'2025-02-04 10:03:05',4,0),(2776,7,2776,'2025-02-04 10:03:05',4,0),(2777,7,2777,'2025-02-04 10:03:05',4,0),(2778,7,2778,'2025-02-04 10:03:05',4,0),(2779,7,2779,'2025-02-04 10:03:05',4,0),(2780,7,2780,'2025-02-04 10:03:05',4,0),(2781,7,2781,'2025-02-04 10:03:05',4,0),(2782,7,2782,'2025-02-04 10:03:05',4,0),(2783,7,2783,'2025-02-04 10:03:06',4,0),(2784,7,2784,'2025-02-04 10:03:06',4,0),(2785,7,2785,'2025-02-04 10:03:06',4,0),(2786,7,2786,'2025-02-04 10:03:06',4,0),(2787,7,2787,'2025-02-04 10:03:06',4,0),(2788,7,2788,'2025-02-04 10:03:06',4,0),(2789,7,2789,'2025-02-04 10:03:06',4,0),(2790,7,2790,'2025-02-04 10:03:06',4,0),(2791,7,2791,'2025-02-04 10:03:06',4,0),(2792,7,2792,'2025-02-04 10:03:06',4,0),(2793,7,2793,'2025-02-04 10:03:06',4,0),(2794,7,2794,'2025-02-04 10:03:06',4,0),(2795,7,2795,'2025-02-04 10:03:06',4,0),(2796,7,2796,'2025-02-04 10:03:06',4,0),(2797,7,2797,'2025-02-04 10:03:06',4,0),(2798,7,2798,'2025-02-04 10:03:06',4,0),(2799,7,2799,'2025-02-04 10:03:06',4,0),(2800,7,2800,'2025-02-04 10:03:06',4,0),(2801,7,2801,'2025-02-04 10:03:06',4,0),(2802,7,2802,'2025-02-04 10:03:06',4,0),(2803,7,2803,'2025-02-04 10:03:06',4,0),(2804,7,2804,'2025-02-04 10:03:06',4,0),(2805,7,2805,'2025-02-04 10:03:06',4,0),(2806,7,2806,'2025-02-04 10:03:06',4,0),(2807,7,2807,'2025-02-04 10:03:06',4,0),(2808,7,2808,'2025-02-04 10:03:06',4,0),(2809,7,2809,'2025-02-04 10:03:06',4,0),(2810,7,2810,'2025-02-04 10:03:06',4,0),(2811,7,2811,'2025-02-04 10:03:06',4,0),(2812,7,2812,'2025-02-04 10:03:06',4,0),(2813,7,2813,'2025-02-04 10:03:06',4,0),(2814,7,2814,'2025-02-04 10:03:06',4,0),(2815,7,2815,'2025-02-04 10:03:06',4,0),(2816,7,2816,'2025-02-04 10:03:06',4,0),(2817,7,2817,'2025-02-04 10:03:06',4,0),(2818,7,2818,'2025-02-04 10:03:06',4,0),(2819,7,2819,'2025-02-04 10:03:06',4,0),(2820,7,2820,'2025-02-04 10:03:06',4,0),(2821,7,2821,'2025-02-04 10:03:06',4,0),(2822,7,2822,'2025-02-04 10:03:07',4,0),(2823,7,2823,'2025-02-04 10:03:07',4,0),(2824,7,2824,'2025-02-04 10:03:07',4,0),(2825,7,2825,'2025-02-04 10:03:07',4,0),(2826,7,2826,'2025-02-04 10:03:07',4,0),(2827,7,2827,'2025-02-04 10:03:07',4,0),(2828,7,2828,'2025-02-04 10:03:07',4,0),(2829,7,2829,'2025-02-04 10:03:07',4,0),(2830,7,2830,'2025-02-04 10:03:07',4,0),(2831,7,2831,'2025-02-04 10:03:07',4,0),(2832,7,2832,'2025-02-04 10:03:07',4,0),(2833,7,2833,'2025-02-04 10:03:07',4,0),(2834,7,2834,'2025-02-04 10:03:07',4,0),(2835,7,2835,'2025-02-04 10:03:07',4,0),(2836,7,2836,'2025-02-04 10:03:07',4,0),(2837,7,2837,'2025-02-04 10:03:07',4,0),(2838,7,2838,'2025-02-04 10:03:07',4,0),(2839,7,2839,'2025-02-04 10:03:07',4,0),(2840,7,2840,'2025-02-04 10:03:07',4,0),(2841,7,2841,'2025-02-04 10:03:07',4,0),(2842,7,2842,'2025-02-04 10:03:07',4,0),(2843,7,2843,'2025-02-04 10:03:07',4,0),(2844,7,2844,'2025-02-04 10:03:07',4,0),(2845,7,2845,'2025-02-04 10:03:07',4,0),(2846,7,2846,'2025-02-04 10:03:07',4,0),(2847,7,2847,'2025-02-04 10:03:07',4,0),(2848,7,2848,'2025-02-04 10:03:07',4,0),(2849,7,2849,'2025-02-04 10:03:07',4,0),(2850,7,2850,'2025-02-04 10:03:07',4,0),(2851,7,2851,'2025-02-04 10:03:07',4,0),(2852,7,2852,'2025-02-04 10:03:07',4,0),(2853,7,2853,'2025-02-04 10:03:07',4,0),(2854,7,2854,'2025-02-04 10:03:07',4,0),(2855,7,2855,'2025-02-04 10:03:07',4,0),(2856,7,2856,'2025-02-04 10:03:07',4,0),(2857,7,2857,'2025-02-04 10:03:07',4,0),(2858,7,2858,'2025-02-04 10:03:07',4,0),(2859,7,2859,'2025-02-04 10:03:07',4,0),(2860,7,2860,'2025-02-04 10:03:07',4,0),(2861,7,2861,'2025-02-04 10:03:07',4,0),(2862,7,2862,'2025-02-04 10:03:08',4,0),(2863,7,2863,'2025-02-04 10:03:08',4,0),(2864,7,2864,'2025-02-04 10:03:08',4,0),(2865,7,2865,'2025-02-04 10:03:08',4,0),(2866,7,2866,'2025-02-04 10:03:08',4,0),(2867,7,2867,'2025-02-04 10:03:08',4,0),(2868,7,2868,'2025-02-04 10:03:08',4,0),(2869,7,2869,'2025-02-04 10:03:08',4,0),(2870,7,2870,'2025-02-04 10:03:08',4,0),(2871,7,2871,'2025-02-04 10:03:08',4,0),(2872,7,2872,'2025-02-04 10:03:08',4,0),(2873,7,2873,'2025-02-04 10:03:08',4,0),(2874,7,2874,'2025-02-04 10:03:08',4,0),(2875,7,2875,'2025-02-04 10:03:08',4,0),(2876,7,2876,'2025-02-04 10:03:08',4,0),(2877,7,2877,'2025-02-04 10:03:08',4,0),(2878,7,2878,'2025-02-04 10:03:08',4,0),(2879,7,2879,'2025-02-04 10:03:08',4,0),(2880,7,2880,'2025-02-04 10:03:08',4,0),(2881,7,2881,'2025-02-04 10:03:08',4,0),(2882,7,2882,'2025-02-04 10:03:08',4,0),(2883,7,2883,'2025-02-04 10:03:08',4,0),(2884,7,2884,'2025-02-04 10:03:08',4,0),(2885,7,2885,'2025-02-04 10:03:08',4,0),(2886,7,2886,'2025-02-04 10:03:08',4,0),(2887,7,2887,'2025-02-04 10:03:08',4,0),(2888,7,2888,'2025-02-04 10:03:08',4,0),(2889,7,2889,'2025-02-04 10:03:08',4,0),(2890,7,2890,'2025-02-04 10:03:08',4,0),(2891,7,2891,'2025-02-04 10:03:08',4,0),(2892,7,2892,'2025-02-04 10:03:08',4,0),(2893,7,2893,'2025-02-04 10:03:08',4,0),(2894,7,2894,'2025-02-04 10:03:08',4,0),(2895,7,2895,'2025-02-04 10:03:08',4,0),(2896,7,2896,'2025-02-04 10:03:08',4,0),(2897,7,2897,'2025-02-04 10:03:09',4,0),(2898,7,2898,'2025-02-04 10:03:09',4,0),(2899,7,2899,'2025-02-04 10:03:09',4,0),(2900,7,2900,'2025-02-04 10:03:09',4,0),(2901,7,2901,'2025-02-04 10:03:09',4,0),(2902,7,2902,'2025-02-04 10:03:09',4,0),(2903,7,2903,'2025-02-04 10:03:09',4,0),(2904,7,2904,'2025-02-04 10:03:09',4,0),(2905,7,2905,'2025-02-04 10:03:09',4,0),(2906,7,2906,'2025-02-04 10:03:09',4,0),(2907,7,2907,'2025-02-04 10:03:09',4,0),(2908,7,2908,'2025-02-04 10:03:09',4,0),(2909,7,2909,'2025-02-04 10:03:09',4,0),(2910,7,2910,'2025-02-04 10:03:09',4,0),(2911,7,2911,'2025-02-04 10:03:10',4,0),(2912,7,2912,'2025-02-04 10:03:10',4,0),(2913,7,2913,'2025-02-04 10:03:10',4,0),(2914,7,2914,'2025-02-04 10:03:10',4,0),(2915,7,2915,'2025-02-04 10:03:10',4,0),(2916,7,2916,'2025-02-04 10:03:10',4,0),(2917,7,2917,'2025-02-04 10:03:10',4,0),(2918,7,2918,'2025-02-04 10:03:10',4,0),(2919,7,2919,'2025-02-04 10:03:10',4,0),(2920,7,2920,'2025-02-04 10:03:10',4,0),(2921,7,2921,'2025-02-04 10:03:10',4,0),(2922,7,2922,'2025-02-04 10:03:10',4,0),(2923,7,2923,'2025-02-04 10:03:10',4,0),(2924,7,2924,'2025-02-04 10:03:10',4,0),(2925,7,2925,'2025-02-04 10:03:10',4,0),(2926,7,2926,'2025-02-04 10:03:10',4,0),(2927,7,2927,'2025-02-04 10:03:11',4,0),(2928,7,2928,'2025-02-04 10:03:11',4,0),(2929,7,2929,'2025-02-04 10:03:11',4,0),(2930,7,2930,'2025-02-04 10:03:11',4,0),(2931,7,2931,'2025-02-04 10:03:11',4,0),(2932,7,2932,'2025-02-04 10:03:11',4,0),(2933,7,2933,'2025-02-04 10:03:11',4,0),(2934,7,2934,'2025-02-04 10:03:11',4,0),(2935,7,2935,'2025-02-04 10:03:11',4,0),(2936,7,2936,'2025-02-04 10:03:11',4,0),(2937,7,2937,'2025-02-04 10:03:11',4,0),(2938,7,2938,'2025-02-04 10:03:11',4,0),(2939,7,2939,'2025-02-04 10:03:11',4,0),(2940,7,2940,'2025-02-04 10:03:11',4,0),(2941,7,2941,'2025-02-04 10:03:11',4,0),(2942,7,2942,'2025-02-04 10:03:11',4,0),(2943,7,2943,'2025-02-04 10:03:11',4,0),(2944,7,2944,'2025-02-04 10:03:11',4,0),(2945,7,2945,'2025-02-04 10:03:12',4,0),(2946,7,2946,'2025-02-04 10:03:12',4,0),(2947,7,2947,'2025-02-04 10:03:12',4,0),(2948,7,2948,'2025-02-04 10:03:12',4,0),(2949,7,2949,'2025-02-04 10:03:12',4,0),(2950,7,2950,'2025-02-04 10:03:12',4,0),(2951,7,2951,'2025-02-04 10:03:12',4,0),(2952,7,2952,'2025-02-04 10:03:12',4,0),(2953,7,2953,'2025-02-04 10:03:12',4,0),(2954,7,2954,'2025-02-04 10:03:12',4,0),(2955,7,2955,'2025-02-04 10:03:12',4,0),(2956,7,2956,'2025-02-04 10:03:12',4,0),(2957,7,2957,'2025-02-04 10:03:12',4,0),(2958,7,2958,'2025-02-04 10:03:12',4,0),(2959,7,2959,'2025-02-04 10:03:12',4,0),(2960,7,2960,'2025-02-04 10:03:12',4,0),(2961,7,2961,'2025-02-04 10:03:13',4,0),(2962,7,2962,'2025-02-04 10:03:13',4,0),(2963,7,2963,'2025-02-04 10:03:13',4,0),(2964,7,2964,'2025-02-04 10:03:13',4,0),(2965,7,2965,'2025-02-04 10:03:13',4,0),(2966,7,2966,'2025-02-04 10:03:13',4,0),(2967,7,2967,'2025-02-04 10:03:13',4,0),(2968,7,2968,'2025-02-04 10:03:13',4,0),(2969,7,2969,'2025-02-04 10:03:13',4,0),(2970,7,2970,'2025-02-04 10:03:13',4,0),(2971,7,2971,'2025-02-04 10:03:13',4,0),(2972,7,2972,'2025-02-04 10:03:13',4,0),(2973,7,2973,'2025-02-04 10:03:13',4,0),(2974,7,2974,'2025-02-04 10:03:13',4,0),(2975,7,2975,'2025-02-04 10:03:13',4,0),(2976,7,2976,'2025-02-04 10:03:13',4,0),(2977,7,2977,'2025-02-04 10:03:13',4,0),(2978,7,2978,'2025-02-04 10:03:13',4,0),(2979,7,2979,'2025-02-04 10:03:13',4,0),(2980,7,2980,'2025-02-04 10:03:13',4,0),(2981,7,2981,'2025-02-04 10:03:14',4,0),(2982,7,2982,'2025-02-04 10:03:14',4,0),(2983,7,2983,'2025-02-04 10:03:14',4,0),(2984,7,2984,'2025-02-04 10:03:14',4,0),(2985,7,2985,'2025-02-04 10:03:14',4,0),(2986,7,2986,'2025-02-04 10:03:14',4,0),(2987,7,2987,'2025-02-04 10:03:14',4,0),(2988,7,2988,'2025-02-04 10:03:14',4,0),(2989,7,2989,'2025-02-04 10:03:14',4,0),(2990,7,2990,'2025-02-04 10:03:14',4,0),(2991,7,2991,'2025-02-04 10:03:14',4,0),(2992,7,2992,'2025-02-04 10:03:14',4,0),(2993,7,2993,'2025-02-04 10:03:14',4,0),(2994,7,2994,'2025-02-04 10:03:14',4,0),(2995,7,2995,'2025-02-04 10:03:14',4,0),(2996,7,2996,'2025-02-04 10:03:14',4,0),(2997,7,2997,'2025-02-04 10:03:14',4,0),(2998,7,2998,'2025-02-04 10:03:14',4,0),(2999,7,2999,'2025-02-04 10:03:14',4,0),(3000,7,3000,'2025-02-04 10:03:14',4,0),(3001,7,3001,'2025-02-04 10:03:14',4,0),(3002,7,3002,'2025-02-04 10:03:14',4,0),(3003,7,3003,'2025-02-04 10:03:14',4,0),(3004,7,3004,'2025-02-04 10:03:14',4,0),(3005,7,3005,'2025-02-04 10:03:14',4,0),(3006,7,3006,'2025-02-04 10:03:14',4,0),(3007,7,3007,'2025-02-04 10:03:14',4,0),(3008,7,3008,'2025-02-04 10:03:14',4,0),(3009,7,3009,'2025-02-04 10:03:14',4,0),(3010,7,3010,'2025-02-04 10:03:15',4,0),(3011,7,3011,'2025-02-04 10:03:15',4,0),(3012,7,3012,'2025-02-04 10:03:15',4,0),(3013,7,3013,'2025-02-04 10:03:15',4,0),(3014,7,3014,'2025-02-04 10:03:15',4,0),(3015,7,3015,'2025-02-04 10:03:15',4,0),(3016,7,3016,'2025-02-04 10:03:15',4,0),(3017,7,3017,'2025-02-04 10:03:15',4,0),(3018,7,3018,'2025-02-04 10:03:15',4,0),(3019,7,3019,'2025-02-04 10:03:15',4,0),(3020,7,3020,'2025-02-04 10:03:15',4,0),(3021,7,3021,'2025-02-04 10:03:15',4,0),(3022,7,3022,'2025-02-04 10:03:15',4,0),(3023,7,3023,'2025-02-04 10:03:15',4,0),(3024,7,3024,'2025-02-04 10:03:15',4,0),(3025,7,3025,'2025-02-04 10:03:15',4,0),(3026,7,3026,'2025-02-04 10:03:15',4,0),(3027,7,3027,'2025-02-04 10:03:15',4,0),(3028,7,3028,'2025-02-04 10:03:15',4,0),(3029,7,3029,'2025-02-04 10:03:15',4,0),(3030,7,3030,'2025-02-04 10:03:15',4,0),(3031,7,3031,'2025-02-04 10:03:15',4,0),(3032,7,3032,'2025-02-04 10:03:15',4,0),(3033,7,3033,'2025-02-04 10:03:15',4,0),(3034,7,3034,'2025-02-04 10:03:15',4,0),(3035,7,3035,'2025-02-04 10:03:15',4,0),(3036,7,3036,'2025-02-04 10:03:15',4,0),(3037,7,3037,'2025-02-04 10:03:15',4,0),(3038,7,3038,'2025-02-04 10:03:15',4,0),(3039,7,3039,'2025-02-04 10:03:15',4,0),(3040,7,3040,'2025-02-04 10:03:15',4,0),(3041,7,3041,'2025-02-04 10:03:16',4,0),(3042,7,3042,'2025-02-04 10:03:16',4,0),(3043,7,3043,'2025-02-04 10:03:16',4,0),(3044,7,3044,'2025-02-04 10:03:16',4,0),(3045,7,3045,'2025-02-04 10:03:16',4,0),(3046,7,3046,'2025-02-04 10:03:16',4,0),(3047,7,3047,'2025-02-04 10:03:16',4,0),(3048,7,3048,'2025-02-04 10:03:16',4,0),(3049,7,3049,'2025-02-04 10:03:16',4,0),(3050,7,3050,'2025-02-04 10:03:16',4,0),(3051,7,3051,'2025-02-04 10:03:16',4,0),(3052,7,3052,'2025-02-04 10:03:16',4,0),(3053,7,3053,'2025-02-04 10:03:16',4,0),(3054,7,3054,'2025-02-04 10:03:16',4,0),(3055,7,3055,'2025-02-04 10:03:16',4,0),(3056,7,3056,'2025-02-04 10:03:16',4,0),(3057,7,3057,'2025-02-04 10:03:16',4,0),(3058,7,3058,'2025-02-04 10:03:16',4,0),(3059,7,3059,'2025-02-04 10:03:16',4,0),(3060,7,3060,'2025-02-04 10:03:16',4,0),(3061,7,3061,'2025-02-04 10:03:16',4,0),(3062,7,3062,'2025-02-04 10:03:16',4,0),(3063,7,3063,'2025-02-04 10:03:16',4,0),(3064,7,3064,'2025-02-04 10:03:16',4,0),(3065,7,3065,'2025-02-04 10:03:16',4,0),(3066,7,3066,'2025-02-04 10:03:16',4,0),(3067,7,3067,'2025-02-04 10:03:16',4,0),(3068,7,3068,'2025-02-04 10:03:16',4,0),(3069,7,3069,'2025-02-04 10:03:16',4,0),(3070,7,3070,'2025-02-04 10:03:16',4,0),(3071,7,3071,'2025-02-04 10:03:16',4,0),(3072,7,3072,'2025-02-04 10:03:16',4,0),(3073,7,3073,'2025-02-04 10:03:16',4,0),(3074,7,3074,'2025-02-04 10:03:17',4,0),(3075,7,3075,'2025-02-04 10:03:17',4,0),(3076,7,3076,'2025-02-04 10:03:17',4,0),(3077,7,3077,'2025-02-04 10:03:17',4,0),(3078,7,3078,'2025-02-04 10:03:17',4,0),(3079,7,3079,'2025-02-04 10:03:17',4,0),(3080,7,3080,'2025-02-04 10:03:17',4,0),(3081,7,3081,'2025-02-04 10:03:17',4,0),(3082,7,3082,'2025-02-04 10:03:17',4,0),(3083,7,3083,'2025-02-04 10:03:17',4,0),(3084,7,3084,'2025-02-04 10:03:17',4,0),(3085,7,3085,'2025-02-04 10:03:17',4,0),(3086,7,3086,'2025-02-04 10:03:17',4,0),(3087,7,3087,'2025-02-04 10:03:17',4,0),(3088,7,3088,'2025-02-04 10:03:17',4,0),(3089,7,3089,'2025-02-04 10:03:17',4,0),(3090,7,3090,'2025-02-04 10:03:17',4,0),(3091,7,3091,'2025-02-04 10:03:17',4,0),(3092,7,3092,'2025-02-04 10:03:17',4,0),(3093,7,3093,'2025-02-04 10:03:17',4,0),(3094,7,3094,'2025-02-04 10:03:17',4,0),(3095,7,3095,'2025-02-04 10:03:17',4,0),(3096,7,3096,'2025-02-04 10:03:17',4,0),(3097,7,3097,'2025-02-04 10:03:17',4,0),(3098,7,3098,'2025-02-04 10:03:17',4,0),(3099,7,3099,'2025-02-04 10:03:17',4,0),(3100,7,3100,'2025-02-04 10:03:17',4,0),(3101,7,3101,'2025-02-04 10:03:17',4,0),(3102,7,3102,'2025-02-04 10:03:17',4,0),(3103,7,3103,'2025-02-04 10:03:17',4,0),(3104,7,3104,'2025-02-04 10:03:17',4,0),(3105,7,3105,'2025-02-04 10:03:17',4,0),(3106,7,3106,'2025-02-04 10:03:17',4,0),(3107,7,3107,'2025-02-04 10:03:17',4,0),(3108,7,3108,'2025-02-04 10:03:17',4,0),(3109,7,3109,'2025-02-04 10:03:18',4,0),(3110,7,3110,'2025-02-04 10:03:18',4,0),(3111,7,3111,'2025-02-04 10:03:18',4,0),(3112,7,3112,'2025-02-04 10:03:18',4,0),(3113,7,3113,'2025-02-04 10:03:18',4,0),(3114,7,3114,'2025-02-04 10:03:18',4,0),(3115,7,3115,'2025-02-04 10:03:18',4,0),(3116,7,3116,'2025-02-04 10:03:18',4,0),(3117,7,3117,'2025-02-04 10:03:18',4,0),(3118,7,3118,'2025-02-04 10:03:18',4,0),(3119,7,3119,'2025-02-04 10:03:18',4,0),(3120,7,3120,'2025-02-04 10:03:18',4,0),(3121,7,3121,'2025-02-04 10:03:18',4,0),(3122,7,3122,'2025-02-04 10:03:18',4,0),(3123,7,3123,'2025-02-04 10:03:18',4,0),(3124,7,3124,'2025-02-04 10:03:18',4,0),(3125,7,3125,'2025-02-04 10:03:18',4,0),(3126,7,3126,'2025-02-04 10:03:18',4,0),(3127,7,3127,'2025-02-04 10:03:18',4,0),(3128,7,3128,'2025-02-04 10:03:18',4,0),(3129,7,3129,'2025-02-04 10:03:18',4,0),(3130,7,3130,'2025-02-04 10:03:18',4,0),(3131,7,3131,'2025-02-04 10:03:18',4,0),(3132,7,3132,'2025-02-04 10:03:18',4,0),(3133,7,3133,'2025-02-04 10:03:18',4,0),(3134,7,3134,'2025-02-04 10:03:18',4,0),(3135,7,3135,'2025-02-04 10:03:18',4,0),(3136,7,3136,'2025-02-04 10:03:18',4,0),(3137,7,3137,'2025-02-04 10:03:18',4,0),(3138,7,3138,'2025-02-04 10:03:18',4,0),(3139,7,3139,'2025-02-04 10:03:18',4,0),(3140,7,3140,'2025-02-04 10:03:18',4,0),(3141,7,3141,'2025-02-04 10:03:18',4,0),(3142,7,3142,'2025-02-04 10:03:18',4,0),(3143,7,3143,'2025-02-04 10:03:18',4,0),(3144,7,3144,'2025-02-04 10:03:18',4,0),(3145,7,3145,'2025-02-04 10:03:18',4,0),(3146,7,3146,'2025-02-04 10:03:18',4,0),(3147,7,3147,'2025-02-04 10:03:19',4,0),(3148,7,3148,'2025-02-04 10:03:19',4,0),(3149,7,3149,'2025-02-04 10:03:19',4,0),(3150,7,3150,'2025-02-04 10:03:19',4,0),(3151,7,3151,'2025-02-04 10:03:19',4,0),(3152,7,3152,'2025-02-04 10:03:19',4,0),(3153,7,3153,'2025-02-04 10:03:19',4,0),(3154,7,3154,'2025-02-04 10:03:19',4,0),(3155,7,3155,'2025-02-04 10:03:19',4,0),(3156,7,3156,'2025-02-04 10:03:19',4,0),(3157,7,3157,'2025-02-04 10:03:19',4,0),(3158,7,3158,'2025-02-04 10:03:19',4,0),(3159,7,3159,'2025-02-04 10:03:19',4,0),(3160,7,3160,'2025-02-04 10:03:19',4,0),(3161,7,3161,'2025-02-04 10:03:19',4,0),(3162,7,3162,'2025-02-04 10:03:19',4,0),(3163,7,3163,'2025-02-04 10:03:19',4,0),(3164,7,3164,'2025-02-04 10:03:19',4,0),(3165,7,3165,'2025-02-04 10:03:19',4,0),(3166,7,3166,'2025-02-04 10:03:19',4,0),(3167,7,3167,'2025-02-04 10:03:19',4,0),(3168,7,3168,'2025-02-04 10:03:19',4,0),(3169,7,3169,'2025-02-04 10:03:19',4,0),(3170,7,3170,'2025-02-04 10:03:19',4,0),(3171,7,3171,'2025-02-04 10:03:19',4,0),(3172,7,3172,'2025-02-04 10:03:19',4,0),(3173,7,3173,'2025-02-04 10:03:19',4,0),(3174,7,3174,'2025-02-04 10:03:19',4,0),(3175,7,3175,'2025-02-04 10:03:19',4,0),(3176,7,3176,'2025-02-04 10:03:19',4,0),(3177,7,3177,'2025-02-04 10:03:19',4,0),(3178,7,3178,'2025-02-04 10:03:19',4,0),(3179,7,3179,'2025-02-04 10:03:19',4,0),(3180,7,3180,'2025-02-04 10:03:19',4,0),(3181,7,3181,'2025-02-04 10:03:20',4,0),(3182,7,3182,'2025-02-04 10:03:20',4,0),(3183,7,3183,'2025-02-04 10:03:20',4,0),(3184,7,3184,'2025-02-04 10:03:20',4,0),(3185,7,3185,'2025-02-04 10:03:20',4,0),(3186,7,3186,'2025-02-04 10:03:20',4,0),(3187,7,3187,'2025-02-04 10:03:20',4,0),(3188,7,3188,'2025-02-04 10:03:20',4,0),(3189,7,3189,'2025-02-04 10:03:20',4,0),(3190,7,3190,'2025-02-04 10:03:20',4,0),(3191,7,3191,'2025-02-04 10:03:20',4,0),(3192,7,3192,'2025-02-04 10:03:20',4,0),(3193,7,3193,'2025-02-04 10:03:20',4,0),(3194,7,3194,'2025-02-04 10:03:20',4,0),(3195,7,3195,'2025-02-04 10:03:20',4,0),(3196,7,3196,'2025-02-04 10:03:20',4,0),(3197,7,3197,'2025-02-04 10:03:20',4,0),(3198,7,3198,'2025-02-04 10:03:20',4,0),(3199,7,3199,'2025-02-04 10:03:20',4,0),(3200,7,3200,'2025-02-04 10:03:20',4,0),(3201,7,3201,'2025-02-04 10:03:20',4,0),(3202,7,3202,'2025-02-04 10:03:20',4,0),(3203,7,3203,'2025-02-04 10:03:20',4,0),(3204,7,3204,'2025-02-04 10:03:20',4,0),(3205,7,3205,'2025-02-04 10:03:20',4,0),(3206,7,3206,'2025-02-04 10:03:20',4,0),(3207,7,3207,'2025-02-04 10:03:20',4,0),(3208,7,3208,'2025-02-04 10:03:20',4,0),(3209,7,3209,'2025-02-04 10:03:20',4,0),(3210,7,3210,'2025-02-04 10:03:20',4,0),(3211,7,3211,'2025-02-04 10:03:20',4,0),(3212,7,3212,'2025-02-04 10:03:20',4,0),(3213,7,3213,'2025-02-04 10:03:20',4,0),(3214,7,3214,'2025-02-04 10:03:20',4,0),(3215,7,3215,'2025-02-04 10:03:20',4,0),(3216,7,3216,'2025-02-04 10:03:20',4,0),(3217,7,3217,'2025-02-04 10:03:20',4,0),(3218,7,3218,'2025-02-04 10:03:20',4,0),(3219,7,3219,'2025-02-04 10:03:20',4,0),(3220,7,3220,'2025-02-04 10:03:20',4,0),(3221,7,3221,'2025-02-04 10:03:21',4,0),(3222,7,3222,'2025-02-04 10:03:21',4,0),(3223,7,3223,'2025-02-04 10:03:21',4,0),(3224,7,3224,'2025-02-04 10:03:21',4,0),(3225,7,3225,'2025-02-04 10:03:21',4,0),(3226,7,3226,'2025-02-04 10:03:21',4,0),(3227,7,3227,'2025-02-04 10:03:21',4,0),(3228,7,3228,'2025-02-04 10:03:21',4,0),(3229,7,3229,'2025-02-04 10:03:21',4,0),(3230,7,3230,'2025-02-04 10:03:21',4,0),(3231,7,3231,'2025-02-04 10:03:21',4,0),(3232,7,3232,'2025-02-04 10:03:21',4,0),(3233,7,3233,'2025-02-04 10:03:21',4,0),(3234,7,3234,'2025-02-04 10:03:21',4,0),(3235,7,3235,'2025-02-04 10:03:21',4,0),(3236,7,3236,'2025-02-04 10:03:21',4,0),(3237,7,3237,'2025-02-04 10:03:21',4,0),(3238,7,3238,'2025-02-04 10:03:21',4,0),(3239,7,3239,'2025-02-04 10:03:21',4,0),(3240,7,3240,'2025-02-04 10:03:21',4,0),(3241,7,3241,'2025-02-04 10:03:21',4,0),(3242,7,3242,'2025-02-04 10:03:21',4,0),(3243,7,3243,'2025-02-04 10:03:21',4,0),(3244,7,3244,'2025-02-04 10:03:21',4,0),(3245,7,3245,'2025-02-04 10:03:21',4,0),(3246,7,3246,'2025-02-04 10:03:21',4,0),(3247,7,3247,'2025-02-04 10:03:21',4,0),(3248,7,3248,'2025-02-04 10:03:21',4,0),(3249,7,3249,'2025-02-04 10:03:21',4,0),(3250,7,3250,'2025-02-04 10:03:21',4,0),(3251,7,3251,'2025-02-04 10:03:21',4,0),(3252,7,3252,'2025-02-04 10:03:21',4,0),(3253,7,3253,'2025-02-04 10:03:21',4,0),(3254,7,3254,'2025-02-04 10:03:21',4,0),(3255,7,3255,'2025-02-04 10:03:21',4,0),(3256,7,3256,'2025-02-04 10:03:21',4,0),(3257,7,3257,'2025-02-04 10:03:21',4,0),(3258,7,3258,'2025-02-04 10:03:21',4,0),(3259,7,3259,'2025-02-04 10:03:22',4,0),(3260,7,3260,'2025-02-04 10:03:22',4,0),(3261,7,3261,'2025-02-04 10:03:22',4,0),(3262,7,3262,'2025-02-04 10:03:22',4,0),(3263,7,3263,'2025-02-04 10:03:22',4,0),(3264,7,3264,'2025-02-04 10:03:22',4,0),(3265,7,3265,'2025-02-04 10:03:22',4,0),(3266,7,3266,'2025-02-04 10:03:22',4,0),(3267,7,3267,'2025-02-04 10:03:22',4,0),(3268,7,3268,'2025-02-04 10:03:22',4,0),(3269,7,3269,'2025-02-04 10:03:22',4,0),(3270,7,3270,'2025-02-04 10:03:22',4,0),(3271,7,3271,'2025-02-04 10:03:22',4,0),(3272,7,3272,'2025-02-04 10:03:22',4,0),(3273,7,3273,'2025-02-04 10:03:22',4,0),(3274,7,3274,'2025-02-04 10:03:22',4,0),(3275,7,3275,'2025-02-04 10:03:22',4,0),(3276,7,3276,'2025-02-04 10:03:22',4,0),(3277,7,3277,'2025-02-04 10:03:22',4,0),(3278,7,3278,'2025-02-04 10:03:22',4,0),(3279,7,3279,'2025-02-04 10:03:22',4,0),(3280,7,3280,'2025-02-04 10:03:22',4,0),(3281,7,3281,'2025-02-04 10:03:22',4,0),(3282,7,3282,'2025-02-04 10:03:22',4,0),(3283,7,3283,'2025-02-04 10:03:22',4,0),(3284,7,3284,'2025-02-04 10:03:22',4,0),(3285,7,3285,'2025-02-04 10:03:22',4,0),(3286,7,3286,'2025-02-04 10:03:22',4,0),(3287,7,3287,'2025-02-04 10:03:22',4,0),(3288,7,3288,'2025-02-04 10:03:22',4,0),(3289,7,3289,'2025-02-04 10:03:22',4,0),(3290,7,3290,'2025-02-04 10:03:22',4,0),(3291,7,3291,'2025-02-04 10:03:22',4,0),(3292,7,3292,'2025-02-04 10:03:22',4,0),(3293,7,3293,'2025-02-04 10:03:22',4,0),(3294,7,3294,'2025-02-04 10:03:22',4,0),(3295,7,3295,'2025-02-04 10:03:23',4,0),(3296,7,3296,'2025-02-04 10:03:23',4,0),(3297,7,3297,'2025-02-04 10:03:23',4,0),(3298,7,3298,'2025-02-04 10:03:23',4,0),(3299,7,3299,'2025-02-04 10:03:23',4,0),(3300,7,3300,'2025-02-04 10:03:23',4,0),(3301,7,3301,'2025-02-04 10:03:23',4,0),(3302,7,3302,'2025-02-04 10:03:23',4,0),(3303,7,3303,'2025-02-04 10:03:23',4,0),(3304,7,3304,'2025-02-04 10:03:23',4,0),(3305,7,3305,'2025-02-04 10:03:23',4,0),(3306,7,3306,'2025-02-04 10:03:23',4,0),(3307,7,3307,'2025-02-04 10:03:23',4,0),(3308,7,3308,'2025-02-04 10:03:23',4,0),(3309,7,3309,'2025-02-04 10:03:23',4,0),(3310,7,3310,'2025-02-04 10:03:23',4,0),(3311,7,3311,'2025-02-04 10:03:23',4,0),(3312,7,3312,'2025-02-04 10:03:23',4,0),(3313,7,3313,'2025-02-04 10:03:23',4,0),(3314,7,3314,'2025-02-04 10:03:23',4,0),(3315,7,3315,'2025-02-04 10:03:23',4,0),(3316,7,3316,'2025-02-04 10:03:23',4,0),(3317,7,3317,'2025-02-04 10:03:23',4,0),(3318,7,3318,'2025-02-04 10:03:23',4,0),(3319,7,3319,'2025-02-04 10:03:23',4,0),(3320,7,3320,'2025-02-04 10:03:23',4,0),(3321,7,3321,'2025-02-04 10:03:23',4,0),(3322,7,3322,'2025-02-04 10:03:23',4,0),(3323,7,3323,'2025-02-04 10:03:23',4,0),(3324,7,3324,'2025-02-04 10:03:23',4,0),(3325,7,3325,'2025-02-04 10:03:23',4,0),(3326,7,3326,'2025-02-04 10:03:23',4,0),(3327,7,3327,'2025-02-04 10:03:23',4,0),(3328,7,3328,'2025-02-04 10:03:23',4,0),(3329,7,3329,'2025-02-04 10:03:23',4,0),(3330,7,3330,'2025-02-04 10:03:23',4,0),(3331,7,3331,'2025-02-04 10:03:23',4,0),(3332,7,3332,'2025-02-04 10:03:23',4,0),(3333,7,3333,'2025-02-04 10:03:23',4,0),(3334,7,3334,'2025-02-04 10:03:24',4,0),(3335,7,3335,'2025-02-04 10:03:24',4,0),(3336,7,3336,'2025-02-04 10:03:24',4,0),(3337,7,3337,'2025-02-04 10:03:24',4,0),(3338,7,3338,'2025-02-04 10:03:24',4,0),(3339,7,3339,'2025-02-04 10:03:24',4,0),(3340,7,3340,'2025-02-04 10:03:24',4,0),(3341,7,3341,'2025-02-04 10:03:24',4,0),(3342,7,3342,'2025-02-04 10:03:24',4,0),(3343,7,3343,'2025-02-04 10:03:24',4,0),(3344,7,3344,'2025-02-04 10:03:24',4,0),(3345,7,3345,'2025-02-04 10:03:24',4,0),(3346,7,3346,'2025-02-04 10:03:24',4,0),(3347,7,3347,'2025-02-04 10:03:24',4,0),(3348,7,3348,'2025-02-04 10:03:24',4,0),(3349,7,3349,'2025-02-04 10:03:24',4,0),(3350,7,3350,'2025-02-04 10:03:24',4,0),(3351,7,3351,'2025-02-04 10:03:24',4,0),(3352,7,3352,'2025-02-04 10:03:24',4,0),(3353,7,3353,'2025-02-04 10:03:24',4,0),(3354,7,3354,'2025-02-04 10:03:24',4,0),(3355,7,3355,'2025-02-04 10:03:24',4,0),(3356,7,3356,'2025-02-04 10:03:24',4,0),(3357,7,3357,'2025-02-04 10:03:24',4,0),(3358,7,3358,'2025-02-04 10:03:24',4,0),(3359,7,3359,'2025-02-04 10:03:24',4,0),(3360,7,3360,'2025-02-04 10:03:24',4,0),(3361,7,3361,'2025-02-04 10:03:24',4,0),(3362,7,3362,'2025-02-04 10:03:24',4,0),(3363,7,3363,'2025-02-04 10:03:24',4,0),(3364,7,3364,'2025-02-04 10:03:24',4,0),(3365,7,3365,'2025-02-04 10:03:24',4,0),(3366,7,3366,'2025-02-04 10:03:24',4,0),(3367,7,3367,'2025-02-04 10:03:24',4,0),(3368,7,3368,'2025-02-04 10:03:24',4,0),(3369,7,3369,'2025-02-04 10:03:24',4,0),(3370,7,3370,'2025-02-04 10:03:25',4,0),(3371,7,3371,'2025-02-04 10:03:25',4,0),(3372,7,3372,'2025-02-04 10:03:25',4,0),(3373,7,3373,'2025-02-04 10:03:25',4,0),(3374,7,3374,'2025-02-04 10:03:25',4,0),(3375,7,3375,'2025-02-04 10:03:25',4,0),(3376,7,3376,'2025-02-04 10:03:25',4,0),(3377,7,3377,'2025-02-04 10:03:25',4,0),(3378,7,3378,'2025-02-04 10:03:25',4,0),(3379,7,3379,'2025-02-04 10:03:25',4,0),(3380,7,3380,'2025-02-04 10:03:25',4,0),(3381,7,3381,'2025-02-04 10:03:25',4,0),(3382,7,3382,'2025-02-04 10:03:25',4,0),(3383,7,3383,'2025-02-04 10:03:25',4,0),(3384,7,3384,'2025-02-04 10:03:25',4,0),(3385,7,3385,'2025-02-04 10:03:25',4,0),(3386,7,3386,'2025-02-04 10:03:25',4,0),(3387,7,3387,'2025-02-04 10:03:25',4,0),(3388,7,3388,'2025-02-04 10:03:25',4,0),(3389,7,3389,'2025-02-04 10:03:25',4,0),(3390,7,3390,'2025-02-04 10:03:25',4,0),(3391,7,3391,'2025-02-04 10:03:25',4,0),(3392,7,3392,'2025-02-04 10:03:25',4,0),(3393,7,3393,'2025-02-04 10:03:25',4,0),(3394,7,3394,'2025-02-04 10:03:25',4,0),(3395,7,3395,'2025-02-04 10:03:25',4,0),(3396,7,3396,'2025-02-04 10:03:25',4,0),(3397,7,3397,'2025-02-04 10:03:25',4,0),(3398,7,3398,'2025-02-04 10:03:25',4,0),(3399,7,3399,'2025-02-04 10:03:25',4,0),(3400,7,3400,'2025-02-04 10:03:25',4,0),(3401,7,3401,'2025-02-04 10:03:25',4,0),(3402,7,3402,'2025-02-04 10:03:25',4,0),(3403,7,3403,'2025-02-04 10:03:25',4,0),(3404,7,3404,'2025-02-04 10:03:25',4,0),(3405,7,3405,'2025-02-04 10:03:25',4,0),(3406,7,3406,'2025-02-04 10:03:26',4,0),(3407,7,3407,'2025-02-04 10:03:26',4,0),(3408,7,3408,'2025-02-04 10:03:26',4,0),(3409,7,3409,'2025-02-04 10:03:26',4,0),(3410,7,3410,'2025-02-04 10:03:26',4,0),(3411,7,3411,'2025-02-04 10:03:26',4,0),(3412,7,3412,'2025-02-04 10:03:26',4,0),(3413,7,3413,'2025-02-04 10:03:26',4,0),(3414,7,3414,'2025-02-04 10:03:26',4,0),(3415,7,3415,'2025-02-04 10:03:26',4,0),(3416,7,3416,'2025-02-04 10:03:26',4,0),(3417,7,3417,'2025-02-04 10:03:26',4,0),(3418,7,3418,'2025-02-04 10:03:26',4,0),(3419,7,3419,'2025-02-04 10:03:26',4,0),(3420,7,3420,'2025-02-04 10:03:26',4,0),(3421,7,3421,'2025-02-04 10:03:26',4,0),(3422,7,3422,'2025-02-04 10:03:26',4,0),(3423,7,3423,'2025-02-04 10:03:26',4,0),(3424,7,3424,'2025-02-04 10:03:26',4,0),(3425,7,3425,'2025-02-04 10:03:26',4,0),(3426,7,3426,'2025-02-04 10:03:26',4,0),(3427,7,3427,'2025-02-04 10:03:26',4,0),(3428,7,3428,'2025-02-04 10:03:26',4,0),(3429,7,3429,'2025-02-04 10:03:26',4,0),(3430,7,3430,'2025-02-04 10:03:26',4,0),(3431,7,3431,'2025-02-04 10:03:26',4,0),(3432,7,3432,'2025-02-04 10:03:26',4,0),(3433,7,3433,'2025-02-04 10:03:26',4,0),(3434,7,3434,'2025-02-04 10:03:26',4,0),(3435,7,3435,'2025-02-04 10:03:26',4,0),(3436,7,3436,'2025-02-04 10:03:26',4,0),(3437,7,3437,'2025-02-04 10:03:26',4,0),(3438,7,3438,'2025-02-04 10:03:26',4,0),(3439,7,3439,'2025-02-04 10:03:26',4,0),(3440,7,3440,'2025-02-04 10:03:26',4,0),(3441,7,3441,'2025-02-04 10:03:27',4,0),(3442,7,3442,'2025-02-04 10:03:27',4,0),(3443,7,3443,'2025-02-04 10:03:27',4,0),(3444,7,3444,'2025-02-04 10:03:27',4,0),(3445,7,3445,'2025-02-04 10:03:27',4,0),(3446,7,3446,'2025-02-04 10:03:27',4,0),(3447,7,3447,'2025-02-04 10:03:27',4,0),(3448,7,3448,'2025-02-04 10:03:27',4,0),(3449,7,3449,'2025-02-04 10:03:27',4,0),(3450,7,3450,'2025-02-04 10:03:27',4,0),(3451,7,3451,'2025-02-04 10:03:27',4,0),(3452,7,3452,'2025-02-04 10:03:27',4,0),(3453,7,3453,'2025-02-04 10:03:27',4,0),(3454,7,3454,'2025-02-04 10:03:27',4,0),(3455,7,3455,'2025-02-04 10:03:27',4,0),(3456,7,3456,'2025-02-04 10:03:27',4,0),(3457,7,3457,'2025-02-04 10:03:27',4,0),(3458,7,3458,'2025-02-04 10:03:27',4,0),(3459,7,3459,'2025-02-04 10:03:27',4,0),(3460,7,3460,'2025-02-04 10:03:27',4,0),(3461,7,3461,'2025-02-04 10:03:27',4,0),(3462,7,3462,'2025-02-04 10:03:27',4,0),(3463,7,3463,'2025-02-04 10:03:27',4,0),(3464,7,3464,'2025-02-04 10:03:27',4,0),(3465,7,3465,'2025-02-04 10:03:27',4,0),(3466,7,3466,'2025-02-04 10:03:27',4,0),(3467,7,3467,'2025-02-04 10:03:27',4,0),(3468,7,3468,'2025-02-04 10:03:27',4,0),(3469,7,3469,'2025-02-04 10:03:27',4,0),(3470,7,3470,'2025-02-04 10:03:27',4,0),(3471,7,3471,'2025-02-04 10:03:27',4,0),(3472,7,3472,'2025-02-04 10:03:27',4,0),(3473,7,3473,'2025-02-04 10:03:27',4,0),(3474,7,3474,'2025-02-04 10:03:27',4,0),(3475,7,3475,'2025-02-04 10:03:27',4,0),(3476,7,3476,'2025-02-04 10:03:27',4,0),(3477,7,3477,'2025-02-04 10:03:27',4,0),(3478,7,3478,'2025-02-04 10:03:28',4,0),(3479,7,3479,'2025-02-04 10:03:28',4,0),(3480,7,3480,'2025-02-04 10:03:28',4,0),(3481,7,3481,'2025-02-04 10:03:28',4,0),(3482,7,3482,'2025-02-04 10:03:28',4,0),(3483,7,3483,'2025-02-04 10:03:28',4,0),(3484,7,3484,'2025-02-04 10:03:28',4,0),(3485,7,3485,'2025-02-04 10:03:28',4,0),(3486,7,3486,'2025-02-04 10:03:28',4,0),(3487,7,3487,'2025-02-04 10:03:28',4,0),(3488,7,3488,'2025-02-04 10:03:28',4,0),(3489,7,3489,'2025-02-04 10:03:28',4,0),(3490,7,3490,'2025-02-04 10:03:28',4,0),(3491,7,3491,'2025-02-04 10:03:28',4,0),(3492,7,3492,'2025-02-04 10:03:28',4,0),(3493,7,3493,'2025-02-04 10:03:28',4,0),(3494,7,3494,'2025-02-04 10:03:28',4,0),(3495,7,3495,'2025-02-04 10:03:28',4,0),(3496,7,3496,'2025-02-04 10:03:28',4,0),(3497,7,3497,'2025-02-04 10:03:28',4,0),(3498,7,3498,'2025-02-04 10:03:28',4,0),(3499,7,3499,'2025-02-04 10:03:28',4,0),(3500,7,3500,'2025-02-04 10:03:28',4,0),(3501,7,3501,'2025-02-04 10:03:28',4,0),(3502,7,3502,'2025-02-04 10:03:28',4,0),(3503,7,3503,'2025-02-04 10:03:28',4,0),(3504,7,3504,'2025-02-04 10:03:28',4,0),(3505,7,3505,'2025-02-04 10:03:28',4,0),(3506,7,3506,'2025-02-04 10:03:28',4,0),(3507,7,3507,'2025-02-04 10:03:28',4,0),(3508,7,3508,'2025-02-04 10:03:28',4,0),(3509,7,3509,'2025-02-04 10:03:28',4,0),(3510,7,3510,'2025-02-04 10:03:28',4,0),(3511,7,3511,'2025-02-04 10:03:28',4,0),(3512,7,3512,'2025-02-04 10:03:28',4,0),(3513,7,3513,'2025-02-04 10:03:28',4,0),(3514,7,3514,'2025-02-04 10:03:29',4,0),(3515,7,3515,'2025-02-04 10:03:29',4,0),(3516,7,3516,'2025-02-04 10:03:29',4,0),(3517,7,3517,'2025-02-04 10:03:29',4,0),(3518,7,3518,'2025-02-04 10:03:29',4,0),(3519,7,3519,'2025-02-04 10:03:29',4,0),(3520,7,3520,'2025-02-04 10:03:29',4,0),(3521,7,3521,'2025-02-04 10:03:29',4,0),(3522,7,3522,'2025-02-04 10:03:29',4,0),(3523,7,3523,'2025-02-04 10:03:29',4,0),(3524,7,3524,'2025-02-04 10:03:29',4,0),(3525,7,3525,'2025-02-04 10:03:29',4,0),(3526,7,3526,'2025-02-04 10:03:29',4,0),(3527,7,3527,'2025-02-04 10:03:29',4,0),(3528,7,3528,'2025-02-04 10:03:29',4,0),(3529,7,3529,'2025-02-04 10:03:29',4,0),(3530,7,3530,'2025-02-04 10:03:29',4,0),(3531,7,3531,'2025-02-04 10:03:29',4,0),(3532,7,3532,'2025-02-04 10:03:29',4,0),(3533,7,3533,'2025-02-04 10:03:29',4,0),(3534,7,3534,'2025-02-04 10:03:29',4,0),(3535,7,3535,'2025-02-04 10:03:29',4,0),(3536,7,3536,'2025-02-04 10:03:29',4,0),(3537,7,3537,'2025-02-04 10:03:29',4,0),(3538,7,3538,'2025-02-04 10:03:29',4,0),(3539,7,3539,'2025-02-04 10:03:29',4,0),(3540,7,3540,'2025-02-04 10:03:29',4,0),(3541,7,3541,'2025-02-04 10:03:29',4,0),(3542,7,3542,'2025-02-04 10:03:29',4,0),(3543,7,3543,'2025-02-04 10:03:29',4,0),(3544,7,3544,'2025-02-04 10:03:29',4,0),(3545,7,3545,'2025-02-04 10:03:29',4,0),(3546,7,3546,'2025-02-04 10:03:29',4,0),(3547,7,3547,'2025-02-04 10:03:29',4,0),(3548,7,3548,'2025-02-04 10:03:29',4,0),(3549,7,3549,'2025-02-04 10:03:29',4,0),(3550,7,3550,'2025-02-04 10:03:29',4,0),(3551,7,3551,'2025-02-04 10:03:29',4,0),(3552,7,3552,'2025-02-04 10:03:30',4,0),(3553,7,3553,'2025-02-04 10:03:30',4,0),(3554,7,3554,'2025-02-04 10:03:30',4,0),(3555,7,3555,'2025-02-04 10:03:30',4,0),(3556,7,3556,'2025-02-04 10:03:30',4,0),(3557,7,3557,'2025-02-04 10:03:30',4,0),(3558,7,3558,'2025-02-04 10:03:30',4,0),(3559,7,3559,'2025-02-04 10:03:30',4,0),(3560,7,3560,'2025-02-04 10:03:30',4,0),(3561,7,3561,'2025-02-04 10:03:30',4,0),(3562,7,3562,'2025-02-04 10:03:30',4,0),(3563,7,3563,'2025-02-04 10:03:30',4,0),(3564,7,3564,'2025-02-04 10:03:30',4,0),(3565,7,3565,'2025-02-04 10:03:30',4,0),(3566,7,3566,'2025-02-04 10:03:30',4,0),(3567,7,3567,'2025-02-04 10:03:30',4,0),(3568,7,3568,'2025-02-04 10:03:30',4,0),(3569,7,3569,'2025-02-04 10:03:30',4,0),(3570,7,3570,'2025-02-04 10:03:30',4,0),(3571,7,3571,'2025-02-04 10:03:30',4,0),(3572,7,3572,'2025-02-04 10:03:30',4,0),(3573,7,3573,'2025-02-04 10:03:30',4,0),(3574,7,3574,'2025-02-04 10:03:30',4,0),(3575,7,3575,'2025-02-04 10:03:30',4,0),(3576,7,3576,'2025-02-04 10:03:30',4,0),(3577,7,3577,'2025-02-04 10:03:30',4,0),(3578,7,3578,'2025-02-04 10:03:30',4,0),(3579,7,3579,'2025-02-04 10:03:30',4,0),(3580,7,3580,'2025-02-04 10:03:30',4,0),(3581,7,3581,'2025-02-04 10:03:30',4,0),(3582,7,3582,'2025-02-04 10:03:30',4,0),(3583,7,3583,'2025-02-04 10:03:30',4,0),(3584,7,3584,'2025-02-04 10:03:30',4,0),(3585,7,3585,'2025-02-04 10:03:30',4,0),(3586,7,3586,'2025-02-04 10:03:30',4,0),(3587,7,3587,'2025-02-04 10:03:30',4,0),(3588,7,3588,'2025-02-04 10:03:31',4,0),(3589,7,3589,'2025-02-04 10:03:31',4,0),(3590,7,3590,'2025-02-04 10:03:31',4,0),(3591,7,3591,'2025-02-04 10:03:31',4,0),(3592,7,3592,'2025-02-04 10:03:31',4,0),(3593,7,3593,'2025-02-04 10:03:31',4,0),(3594,7,3594,'2025-02-04 10:03:31',4,0),(3595,7,3595,'2025-02-04 10:03:31',4,0),(3596,7,3596,'2025-02-04 10:03:31',4,0),(3597,7,3597,'2025-02-04 10:03:31',4,0),(3598,7,3598,'2025-02-04 10:03:31',4,0),(3599,7,3599,'2025-02-04 10:03:31',4,0),(3600,7,3600,'2025-02-04 10:03:31',4,0),(3601,7,3601,'2025-02-04 10:03:31',4,0),(3602,7,3602,'2025-02-04 10:03:31',4,0),(3603,7,3603,'2025-02-04 10:03:31',4,0),(3604,7,3604,'2025-02-04 10:03:31',4,0),(3605,7,3605,'2025-02-04 10:03:31',4,0),(3606,7,3606,'2025-02-04 10:03:31',4,0),(3607,7,3607,'2025-02-04 10:03:31',4,0),(3608,7,3608,'2025-02-04 10:03:31',4,0),(3609,7,3609,'2025-02-04 10:03:31',4,0),(3610,7,3610,'2025-02-04 10:03:31',4,0),(3611,7,3611,'2025-02-04 10:03:31',4,0),(3612,7,3612,'2025-02-04 10:03:31',4,0),(3613,7,3613,'2025-02-04 10:03:31',4,0),(3614,7,3614,'2025-02-04 10:03:31',4,0),(3615,7,3615,'2025-02-04 10:03:31',4,0),(3616,7,3616,'2025-02-04 10:03:31',4,0),(3617,7,3617,'2025-02-04 10:03:32',4,0),(3618,7,3618,'2025-02-04 10:03:32',4,0),(3619,7,3619,'2025-02-04 10:03:32',4,0),(3620,7,3620,'2025-02-04 10:03:32',4,0),(3621,7,3621,'2025-02-04 10:03:32',4,0),(3622,7,3622,'2025-02-04 10:03:32',4,0),(3623,7,3623,'2025-02-04 10:03:32',4,0),(3624,7,3624,'2025-02-04 10:03:32',4,0),(3625,7,3625,'2025-02-04 10:03:32',4,0),(3626,7,3626,'2025-02-04 10:03:32',4,0),(3627,7,3627,'2025-02-04 10:03:32',4,0),(3628,7,3628,'2025-02-04 10:03:32',4,0),(3629,7,3629,'2025-02-04 10:03:32',4,0),(3630,7,3630,'2025-02-04 10:03:32',4,0),(3631,7,3631,'2025-02-04 10:03:32',4,0),(3632,7,3632,'2025-02-04 10:03:32',4,0),(3633,7,3633,'2025-02-04 10:03:33',4,0),(3634,7,3634,'2025-02-04 10:03:33',4,0),(3635,7,3635,'2025-02-04 10:03:33',4,0),(3636,7,3636,'2025-02-04 10:03:33',4,0),(3637,7,3637,'2025-02-04 10:03:33',4,0),(3638,7,3638,'2025-02-04 10:03:33',4,0),(3639,7,3639,'2025-02-04 10:03:33',4,0),(3640,7,3640,'2025-02-04 10:03:33',4,0),(3641,7,3641,'2025-02-04 10:03:33',4,0),(3642,7,3642,'2025-02-04 10:03:33',4,0),(3643,7,3643,'2025-02-04 10:03:33',4,0),(3644,7,3644,'2025-02-04 10:03:33',4,0),(3645,7,3645,'2025-02-04 10:03:33',4,0),(3646,7,3646,'2025-02-04 10:03:33',4,0),(3647,7,3647,'2025-02-04 10:03:33',4,0),(3648,7,3648,'2025-02-04 10:03:34',4,0),(3649,7,3649,'2025-02-04 10:03:34',4,0),(3650,7,3650,'2025-02-04 10:03:34',4,0),(3651,7,3651,'2025-02-04 10:03:34',4,0),(3652,7,3652,'2025-02-04 10:03:34',4,0),(3653,7,3653,'2025-02-04 10:03:34',4,0),(3654,7,3654,'2025-02-04 10:03:34',4,0),(3655,7,3655,'2025-02-04 10:03:34',4,0),(3656,7,3656,'2025-02-04 10:03:34',4,0),(3657,7,3657,'2025-02-04 10:03:34',4,0),(3658,7,3658,'2025-02-04 10:03:34',4,0),(3659,7,3659,'2025-02-04 10:03:34',4,0),(3660,7,3660,'2025-02-04 10:03:34',4,0),(3661,7,3661,'2025-02-04 10:03:34',4,0),(3662,7,3662,'2025-02-04 10:03:34',4,0),(3663,7,3663,'2025-02-04 10:03:34',4,0),(3664,7,3664,'2025-02-04 10:03:34',4,0),(3665,7,3665,'2025-02-04 10:03:35',4,0),(3666,7,3666,'2025-02-04 10:03:35',4,0),(3667,7,3667,'2025-02-04 10:03:35',4,0),(3668,7,3668,'2025-02-04 10:03:35',4,0),(3669,7,3669,'2025-02-04 10:03:35',4,0),(3670,7,3670,'2025-02-04 10:03:35',4,0),(3671,7,3671,'2025-02-04 10:03:35',4,0),(3672,7,3672,'2025-02-04 10:03:35',4,0),(3673,7,3673,'2025-02-04 10:03:35',4,0),(3674,7,3674,'2025-02-04 10:03:35',4,0),(3675,7,3675,'2025-02-04 10:03:35',4,0),(3676,7,3676,'2025-02-04 10:03:35',4,0),(3677,7,3677,'2025-02-04 10:03:35',4,0),(3678,7,3678,'2025-02-04 10:03:35',4,0),(3679,7,3679,'2025-02-04 10:03:36',4,0),(3680,7,3680,'2025-02-04 10:03:36',4,0),(3681,7,3681,'2025-02-04 10:03:36',4,0),(3682,7,3682,'2025-02-04 10:03:36',4,0),(3683,7,3683,'2025-02-04 10:03:36',4,0),(3684,7,3684,'2025-02-04 10:03:36',4,0),(3685,7,3685,'2025-02-04 10:03:36',4,0),(3686,7,3686,'2025-02-04 10:03:36',4,0),(3687,7,3687,'2025-02-04 10:03:36',4,0),(3688,7,3688,'2025-02-04 10:03:36',4,0),(3689,7,3689,'2025-02-04 10:03:36',4,0),(3690,7,3690,'2025-02-04 10:03:36',4,0),(3691,7,3691,'2025-02-04 10:03:36',4,0),(3692,7,3692,'2025-02-04 10:03:36',4,0),(3693,7,3693,'2025-02-04 10:03:36',4,0),(3694,7,3694,'2025-02-04 10:03:36',4,0),(3695,7,3695,'2025-02-04 10:03:36',4,0),(3696,7,3696,'2025-02-04 10:03:36',4,0),(3697,7,3697,'2025-02-04 10:03:37',4,0),(3698,7,3698,'2025-02-04 10:03:37',4,0),(3699,7,3699,'2025-02-04 10:03:37',4,0),(3700,7,3700,'2025-02-04 10:03:37',4,0),(3701,7,3701,'2025-02-04 10:03:37',4,0),(3702,7,3702,'2025-02-04 10:03:37',4,0),(3703,7,3703,'2025-02-04 10:03:37',4,0),(3704,7,3704,'2025-02-04 10:03:37',4,0),(3705,7,3705,'2025-02-04 10:03:37',4,0),(3706,7,3706,'2025-02-04 10:03:37',4,0),(3707,7,3707,'2025-02-04 10:03:37',4,0),(3708,7,3708,'2025-02-04 10:03:37',4,0),(3709,7,3709,'2025-02-04 10:03:37',4,0),(3710,7,3710,'2025-02-04 10:03:37',4,0),(3711,7,3711,'2025-02-04 10:03:37',4,0),(3712,7,3712,'2025-02-04 10:03:37',4,0),(3713,7,3713,'2025-02-04 10:03:37',4,0),(3714,7,3714,'2025-02-04 10:03:37',4,0),(3715,7,3715,'2025-02-04 10:03:37',4,0),(3716,7,3716,'2025-02-04 10:03:37',4,0),(3717,7,3717,'2025-02-04 10:03:37',4,0),(3718,7,3718,'2025-02-04 10:03:37',4,0),(3719,7,3719,'2025-02-04 10:03:37',4,0),(3720,7,3720,'2025-02-04 10:03:37',4,0),(3721,7,3721,'2025-02-04 10:03:37',4,0),(3722,7,3722,'2025-02-04 10:03:37',4,0),(3723,7,3723,'2025-02-04 10:03:37',4,0),(3724,7,3724,'2025-02-04 10:03:38',4,0),(3725,7,3725,'2025-02-04 10:03:38',4,0),(3726,7,3726,'2025-02-04 10:03:38',4,0),(3727,7,3727,'2025-02-04 10:03:38',4,0),(3728,7,3728,'2025-02-04 10:03:38',4,0),(3729,7,3729,'2025-02-04 10:03:38',4,0),(3730,7,3730,'2025-02-04 10:03:38',4,0),(3731,7,3731,'2025-02-04 10:03:38',4,0),(3732,7,3732,'2025-02-04 10:03:38',4,0),(3733,7,3733,'2025-02-04 10:03:38',4,0),(3734,7,3734,'2025-02-04 10:03:38',4,0),(3735,7,3735,'2025-02-04 10:03:38',4,0),(3736,7,3736,'2025-02-04 10:03:38',4,0),(3737,7,3737,'2025-02-04 10:03:38',4,0),(3738,7,3738,'2025-02-04 10:03:38',4,0),(3739,7,3739,'2025-02-04 10:03:38',4,0),(3740,7,3740,'2025-02-04 10:03:38',4,0),(3741,7,3741,'2025-02-04 10:03:38',4,0),(3742,7,3742,'2025-02-04 10:03:38',4,0),(3743,7,3743,'2025-02-04 10:03:38',4,0),(3744,7,3744,'2025-02-04 10:03:38',4,0),(3745,7,3745,'2025-02-04 10:03:38',4,0),(3746,7,3746,'2025-02-04 10:03:38',4,0),(3747,7,3747,'2025-02-04 10:03:38',4,0),(3748,7,3748,'2025-02-04 10:03:38',4,0),(3749,7,3749,'2025-02-04 10:03:38',4,0),(3750,7,3750,'2025-02-04 10:03:38',4,0),(3751,7,3751,'2025-02-04 10:03:38',4,0),(3752,7,3752,'2025-02-04 10:03:38',4,0),(3753,7,3753,'2025-02-04 10:03:38',4,0),(3754,7,3754,'2025-02-04 10:03:38',4,0),(3755,7,3755,'2025-02-04 10:03:39',4,0),(3756,7,3756,'2025-02-04 10:03:39',4,0),(3757,7,3757,'2025-02-04 10:03:39',4,0),(3758,7,3758,'2025-02-04 10:03:39',4,0),(3759,7,3759,'2025-02-04 10:03:39',4,0),(3760,7,3760,'2025-02-04 10:03:39',4,0),(3761,7,3761,'2025-02-04 10:03:39',4,0),(3762,7,3762,'2025-02-04 10:03:39',4,0),(3763,7,3763,'2025-02-04 10:03:39',4,0),(3764,7,3764,'2025-02-04 10:03:39',4,0),(3765,7,3765,'2025-02-04 10:03:39',4,0),(3766,7,3766,'2025-02-04 10:03:39',4,0),(3767,7,3767,'2025-02-04 10:03:39',4,0),(3768,7,3768,'2025-02-04 10:03:39',4,0),(3769,7,3769,'2025-02-04 10:03:39',4,0),(3770,7,3770,'2025-02-04 10:03:39',4,0),(3771,7,3771,'2025-02-04 10:03:39',4,0),(3772,7,3772,'2025-02-04 10:03:39',4,0),(3773,7,3773,'2025-02-04 10:03:39',4,0),(3774,7,3774,'2025-02-04 10:03:39',4,0),(3775,7,3775,'2025-02-04 10:03:39',4,0),(3776,7,3776,'2025-02-04 10:03:39',4,0),(3777,7,3777,'2025-02-04 10:03:39',4,0),(3778,7,3778,'2025-02-04 10:03:39',4,0),(3779,7,3779,'2025-02-04 10:03:39',4,0),(3780,7,3780,'2025-02-04 10:03:39',4,0),(3781,7,3781,'2025-02-04 10:03:39',4,0),(3782,7,3782,'2025-02-04 10:03:39',4,0),(3783,7,3783,'2025-02-04 10:03:39',4,0),(3784,7,3784,'2025-02-04 10:03:39',4,0),(3785,7,3785,'2025-02-04 10:03:39',4,0),(3786,7,3786,'2025-02-04 10:03:39',4,0),(3787,7,3787,'2025-02-04 10:03:39',4,0),(3788,7,3788,'2025-02-04 10:03:39',4,0),(3789,7,3789,'2025-02-04 10:03:40',4,0),(3790,7,3790,'2025-02-04 10:03:40',4,0),(3791,7,3791,'2025-02-04 10:03:40',4,0),(3792,7,3792,'2025-02-04 10:03:40',4,0),(3793,7,3793,'2025-02-04 10:03:40',4,0),(3794,7,3794,'2025-02-04 10:03:40',4,0),(3795,7,3795,'2025-02-04 10:03:40',4,0),(3796,7,3796,'2025-02-04 10:03:40',4,0),(3797,7,3797,'2025-02-04 10:03:40',4,0),(3798,7,3798,'2025-02-04 10:03:40',4,0),(3799,7,3799,'2025-02-04 10:03:40',4,0),(3800,7,3800,'2025-02-04 10:03:40',4,0),(3801,7,3801,'2025-02-04 10:03:40',4,0),(3802,7,3802,'2025-02-04 10:03:40',4,0),(3803,7,3803,'2025-02-04 10:03:40',4,0),(3804,7,3804,'2025-02-04 10:03:40',4,0),(3805,7,3805,'2025-02-04 10:03:40',4,0),(3806,7,3806,'2025-02-04 10:03:40',4,0),(3807,7,3807,'2025-02-04 10:03:40',4,0),(3808,7,3808,'2025-02-04 10:03:40',4,0),(3809,7,3809,'2025-02-04 10:03:40',4,0),(3810,7,3810,'2025-02-04 10:03:40',4,0),(3811,7,3811,'2025-02-04 10:03:40',4,0),(3812,7,3812,'2025-02-04 10:03:40',4,0),(3813,7,3813,'2025-02-04 10:03:40',4,0),(3814,7,3814,'2025-02-04 10:03:40',4,0),(3815,7,3815,'2025-02-04 10:03:40',4,0),(3816,7,3816,'2025-02-04 10:03:40',4,0),(3817,7,3817,'2025-02-04 10:03:40',4,0),(3818,7,3818,'2025-02-04 10:03:40',4,0),(3819,7,3819,'2025-02-04 10:03:40',4,0),(3820,7,3820,'2025-02-04 10:03:40',4,0),(3821,7,3821,'2025-02-04 10:03:40',4,0),(3822,7,3822,'2025-02-04 10:03:41',4,0),(3823,7,3823,'2025-02-04 10:03:41',4,0),(3824,7,3824,'2025-02-04 10:03:41',4,0),(3825,7,3825,'2025-02-04 10:03:41',4,0),(3826,7,3826,'2025-02-04 10:03:41',4,0),(3827,7,3827,'2025-02-04 10:03:41',4,0),(3828,7,3828,'2025-02-04 10:03:41',4,0),(3829,7,3829,'2025-02-04 10:03:41',4,0),(3830,7,3830,'2025-02-04 10:03:41',4,0),(3831,7,3831,'2025-02-04 10:03:41',4,0),(3832,7,3832,'2025-02-04 10:03:41',4,0),(3833,7,3833,'2025-02-04 10:03:41',4,0),(3834,7,3834,'2025-02-04 10:03:41',4,0),(3835,7,3835,'2025-02-04 10:03:41',4,0),(3836,7,3836,'2025-02-04 10:03:41',4,0),(3837,7,3837,'2025-02-04 10:03:41',4,0),(3838,7,3838,'2025-02-04 10:03:41',4,0),(3839,7,3839,'2025-02-04 10:03:41',4,0),(3840,7,3840,'2025-02-04 10:03:41',4,0),(3841,7,3841,'2025-02-04 10:03:41',4,0),(3842,7,3842,'2025-02-04 10:03:41',4,0),(3843,7,3843,'2025-02-04 10:03:41',4,0),(3844,7,3844,'2025-02-04 10:03:41',4,0),(3845,7,3845,'2025-02-04 10:03:41',4,0),(3846,7,3846,'2025-02-04 10:03:41',4,0),(3847,7,3847,'2025-02-04 10:03:41',4,0),(3848,7,3848,'2025-02-04 10:03:41',4,0),(3849,7,3849,'2025-02-04 10:03:41',4,0),(3850,7,3850,'2025-02-04 10:03:41',4,0),(3851,7,3851,'2025-02-04 10:03:41',4,0),(3852,7,3852,'2025-02-04 10:03:41',4,0),(3853,7,3853,'2025-02-04 10:03:41',4,0),(3854,7,3854,'2025-02-04 10:03:41',4,0),(3855,7,3855,'2025-02-04 10:03:42',4,0),(3856,7,3856,'2025-02-04 10:03:42',4,0),(3857,7,3857,'2025-02-04 10:03:42',4,0),(3858,7,3858,'2025-02-04 10:03:42',4,0),(3859,7,3859,'2025-02-04 10:03:42',4,0),(3860,7,3860,'2025-02-04 10:03:42',4,0),(3861,7,3861,'2025-02-04 10:03:42',4,0),(3862,7,3862,'2025-02-04 10:03:42',4,0),(3863,7,3863,'2025-02-04 10:03:42',4,0),(3864,7,3864,'2025-02-04 10:03:42',4,0),(3865,7,3865,'2025-02-04 10:03:42',4,0),(3866,7,3866,'2025-02-04 10:03:42',4,0),(3867,7,3867,'2025-02-04 10:03:42',4,0),(3868,7,3868,'2025-02-04 10:03:42',4,0),(3869,7,3869,'2025-02-04 10:03:42',4,0),(3870,7,3870,'2025-02-04 10:03:42',4,0),(3871,7,3871,'2025-02-04 10:03:42',4,0),(3872,7,3872,'2025-02-04 10:03:42',4,0),(3873,7,3873,'2025-02-04 10:03:42',4,0),(3874,7,3874,'2025-02-04 10:03:42',4,0),(3875,7,3875,'2025-02-04 10:03:42',4,0),(3876,7,3876,'2025-02-04 10:03:42',4,0),(3877,7,3877,'2025-02-04 10:03:42',4,0),(3878,7,3878,'2025-02-04 10:03:42',4,0),(3879,7,3879,'2025-02-04 10:03:42',4,0),(3880,7,3880,'2025-02-04 10:03:42',4,0),(3881,7,3881,'2025-02-04 10:03:42',4,0),(3882,7,3882,'2025-02-04 10:03:42',4,0),(3883,7,3883,'2025-02-04 10:03:42',4,0),(3884,7,3884,'2025-02-04 10:03:42',4,0),(3885,7,3885,'2025-02-04 10:03:42',4,0),(3886,7,3886,'2025-02-04 10:03:42',4,0),(3887,7,3887,'2025-02-04 10:03:42',4,0),(3888,7,3888,'2025-02-04 10:03:42',4,0),(3889,7,3889,'2025-02-04 10:03:42',4,0),(3890,7,3890,'2025-02-04 10:03:42',4,0),(3891,7,3891,'2025-02-04 10:03:42',4,0),(3892,7,3892,'2025-02-04 10:03:42',4,0),(3893,7,3893,'2025-02-04 10:03:43',4,0),(3894,7,3894,'2025-02-04 10:03:43',4,0),(3895,7,3895,'2025-02-04 10:03:43',4,0),(3896,7,3896,'2025-02-04 10:03:43',4,0),(3897,7,3897,'2025-02-04 10:03:43',4,0),(3898,7,3898,'2025-02-04 10:03:43',4,0),(3899,7,3899,'2025-02-04 10:03:43',4,0),(3900,7,3900,'2025-02-04 10:03:43',4,0),(3901,7,3901,'2025-02-04 10:03:43',4,0),(3902,7,3902,'2025-02-04 10:03:43',4,0),(3903,7,3903,'2025-02-04 10:03:43',4,0),(3904,7,3904,'2025-02-04 10:03:43',4,0),(3905,7,3905,'2025-02-04 10:03:43',4,0),(3906,7,3906,'2025-02-04 10:03:43',4,0),(3907,7,3907,'2025-02-04 10:03:43',4,0),(3908,7,3908,'2025-02-04 10:03:43',4,0),(3909,7,3909,'2025-02-04 10:03:43',4,0),(3910,7,3910,'2025-02-04 10:03:43',4,0),(3911,7,3911,'2025-02-04 10:03:43',4,0),(3912,7,3912,'2025-02-04 10:03:43',4,0),(3913,7,3913,'2025-02-04 10:03:43',4,0),(3914,7,3914,'2025-02-04 10:03:43',4,0),(3915,7,3915,'2025-02-04 10:03:43',4,0),(3916,7,3916,'2025-02-04 10:03:43',4,0),(3917,7,3917,'2025-02-04 10:03:43',4,0),(3918,7,3918,'2025-02-04 10:03:43',4,0),(3919,7,3919,'2025-02-04 10:03:43',4,0),(3920,7,3920,'2025-02-04 10:03:43',4,0),(3921,7,3921,'2025-02-04 10:03:43',4,0),(3922,7,3922,'2025-02-04 10:03:43',4,0),(3923,7,3923,'2025-02-04 10:03:43',4,0),(3924,7,3924,'2025-02-04 10:03:43',4,0),(3925,7,3925,'2025-02-04 10:03:43',4,0),(3926,7,3926,'2025-02-04 10:03:43',4,0),(3927,7,3927,'2025-02-04 10:03:43',4,0),(3928,7,3928,'2025-02-04 10:03:43',4,0),(3929,7,3929,'2025-02-04 10:03:43',4,0),(3930,7,3930,'2025-02-04 10:03:44',4,0),(3931,7,3931,'2025-02-04 10:03:44',4,0),(3932,7,3932,'2025-02-04 10:03:44',4,0),(3933,7,3933,'2025-02-04 10:03:44',4,0),(3934,7,3934,'2025-02-04 10:03:44',4,0),(3935,7,3935,'2025-02-04 10:03:44',4,0),(3936,7,3936,'2025-02-04 10:03:44',4,0),(3937,7,3937,'2025-02-04 10:03:44',4,0),(3938,7,3938,'2025-02-04 10:03:44',4,0),(3939,7,3939,'2025-02-04 10:03:44',4,0),(3940,7,3940,'2025-02-04 10:03:44',4,0),(3941,7,3941,'2025-02-04 10:03:44',4,0),(3942,7,3942,'2025-02-04 10:03:44',4,0),(3943,7,3943,'2025-02-04 10:03:44',4,0),(3944,7,3944,'2025-02-04 10:03:44',4,0),(3945,7,3945,'2025-02-04 10:03:44',4,0),(3946,7,3946,'2025-02-04 10:03:44',4,0),(3947,7,3947,'2025-02-04 10:03:44',4,0),(3948,7,3948,'2025-02-04 10:03:44',4,0),(3949,7,3949,'2025-02-04 10:03:44',4,0),(3950,7,3950,'2025-02-04 10:03:44',4,0),(3951,7,3951,'2025-02-04 10:03:44',4,0),(3952,7,3952,'2025-02-04 10:03:44',4,0),(3953,7,3953,'2025-02-04 10:03:44',4,0),(3954,7,3954,'2025-02-04 10:03:44',4,0),(3955,7,3955,'2025-02-04 10:03:44',4,0),(3956,7,3956,'2025-02-04 10:03:44',4,0),(3957,7,3957,'2025-02-04 10:03:44',4,0),(3958,7,3958,'2025-02-04 10:03:44',4,0),(3959,7,3959,'2025-02-04 10:03:44',4,0),(3960,7,3960,'2025-02-04 10:03:44',4,0),(3961,7,3961,'2025-02-04 10:03:44',4,0),(3962,7,3962,'2025-02-04 10:03:44',4,0),(3963,7,3963,'2025-02-04 10:03:44',4,0),(3964,7,3964,'2025-02-04 10:03:44',4,0),(3965,7,3965,'2025-02-04 10:03:44',4,0),(3966,7,3966,'2025-02-04 10:03:44',4,0),(3967,7,3967,'2025-02-04 10:03:44',4,0),(3968,7,3968,'2025-02-04 10:03:44',4,0),(3969,7,3969,'2025-02-04 10:03:44',4,0),(3970,7,3970,'2025-02-04 10:03:45',4,0),(3971,7,3971,'2025-02-04 10:03:45',4,0),(3972,7,3972,'2025-02-04 10:03:45',4,0),(3973,7,3973,'2025-02-04 10:03:45',4,0),(3974,7,3974,'2025-02-04 10:03:45',4,0),(3975,7,3975,'2025-02-04 10:03:45',4,0),(3976,7,3976,'2025-02-04 10:03:45',4,0),(3977,7,3977,'2025-02-04 10:03:45',4,0),(3978,7,3978,'2025-02-04 10:03:45',4,0),(3979,7,3979,'2025-02-04 10:03:45',4,0),(3980,7,3980,'2025-02-04 10:03:45',4,0),(3981,7,3981,'2025-02-04 10:03:45',4,0),(3982,7,3982,'2025-02-04 10:03:45',4,0),(3983,7,3983,'2025-02-04 10:03:45',4,0),(3984,7,3984,'2025-02-04 10:03:45',4,0),(3985,7,3985,'2025-02-04 10:03:45',4,0),(3986,7,3986,'2025-02-04 10:03:45',4,0),(3987,7,3987,'2025-02-04 10:03:45',4,0),(3988,7,3988,'2025-02-04 10:03:45',4,0),(3989,7,3989,'2025-02-04 10:03:45',4,0),(3990,7,3990,'2025-02-04 10:03:45',4,0),(3991,7,3991,'2025-02-04 10:03:45',4,0),(3992,7,3992,'2025-02-04 10:03:45',4,0),(3993,7,3993,'2025-02-04 10:03:45',4,0),(3994,7,3994,'2025-02-04 10:03:45',4,0),(3995,7,3995,'2025-02-04 10:03:45',4,0),(3996,7,3996,'2025-02-04 10:03:45',4,0),(3997,7,3997,'2025-02-04 10:03:45',4,0),(3998,7,3998,'2025-02-04 10:03:45',4,0),(3999,7,3999,'2025-02-04 10:03:45',4,0),(4000,7,4000,'2025-02-04 10:03:45',4,0),(4001,7,4001,'2025-02-04 10:03:45',4,0),(4002,7,4002,'2025-02-04 10:03:45',4,0),(4003,7,4003,'2025-02-04 10:03:45',4,0),(4004,7,4004,'2025-02-04 10:03:45',4,0),(4005,7,4005,'2025-02-04 10:03:45',4,0),(4006,7,4006,'2025-02-04 10:03:46',4,0),(4007,7,4007,'2025-02-04 10:03:46',4,0),(4008,7,4008,'2025-02-04 10:03:46',4,0),(4009,7,4009,'2025-02-04 10:03:46',4,0),(4010,7,4010,'2025-02-04 10:03:46',4,0),(4011,7,4011,'2025-02-04 10:03:46',4,0),(4012,7,4012,'2025-02-04 10:03:46',4,0),(4013,7,4013,'2025-02-04 10:03:46',4,0),(4014,7,4014,'2025-02-04 10:03:46',4,0),(4015,7,4015,'2025-02-04 10:03:46',4,0),(4016,7,4016,'2025-02-04 10:03:46',4,0),(4017,7,4017,'2025-02-04 10:03:46',4,0),(4018,7,4018,'2025-02-04 10:03:46',4,0),(4019,7,4019,'2025-02-04 10:03:46',4,0),(4020,7,4020,'2025-02-04 10:03:46',4,0),(4021,7,4021,'2025-02-04 10:03:46',4,0),(4022,7,4022,'2025-02-04 10:03:46',4,0),(4023,7,4023,'2025-02-04 10:03:46',4,0),(4024,7,4024,'2025-02-04 10:03:46',4,0),(4025,7,4025,'2025-02-04 10:03:46',4,0),(4026,7,4026,'2025-02-04 10:03:46',4,0),(4027,7,4027,'2025-02-04 10:03:46',4,0),(4028,7,4028,'2025-02-04 10:03:46',4,0),(4029,7,4029,'2025-02-04 10:03:46',4,0),(4030,7,4030,'2025-02-04 10:03:46',4,0),(4031,7,4031,'2025-02-04 10:03:46',4,0),(4032,7,4032,'2025-02-04 10:03:46',4,0),(4033,7,4033,'2025-02-04 10:03:46',4,0),(4034,7,4034,'2025-02-04 10:03:46',4,0),(4035,7,4035,'2025-02-04 10:03:46',4,0),(4036,7,4036,'2025-02-04 10:03:46',4,0),(4037,7,4037,'2025-02-04 10:03:46',4,0),(4038,7,4038,'2025-02-04 10:03:46',4,0),(4039,7,4039,'2025-02-04 10:03:46',4,0),(4040,7,4040,'2025-02-04 10:03:46',4,0),(4041,7,4041,'2025-02-04 10:03:47',4,0),(4042,7,4042,'2025-02-04 10:03:47',4,0),(4043,7,4043,'2025-02-04 10:03:47',4,0),(4044,7,4044,'2025-02-04 10:03:47',4,0),(4045,7,4045,'2025-02-04 10:03:47',4,0),(4046,7,4046,'2025-02-04 10:03:47',4,0),(4047,7,4047,'2025-02-04 10:03:47',4,0),(4048,7,4048,'2025-02-04 10:03:47',4,0),(4049,7,4049,'2025-02-04 10:03:47',4,0),(4050,7,4050,'2025-02-04 10:03:47',4,0),(4051,7,4051,'2025-02-04 10:03:47',4,0),(4052,7,4052,'2025-02-04 10:03:47',4,0),(4053,7,4053,'2025-02-04 10:03:47',4,0),(4054,7,4054,'2025-02-04 10:03:47',4,0),(4055,7,4055,'2025-02-04 10:03:47',4,0),(4056,7,4056,'2025-02-04 10:03:47',4,0),(4057,7,4057,'2025-02-04 10:03:47',4,0),(4058,7,4058,'2025-02-04 10:03:47',4,0),(4059,7,4059,'2025-02-04 10:03:47',4,0),(4060,7,4060,'2025-02-04 10:03:47',4,0),(4061,7,4061,'2025-02-04 10:03:47',4,0),(4062,7,4062,'2025-02-04 10:03:47',4,0),(4063,7,4063,'2025-02-04 10:03:47',4,0),(4064,7,4064,'2025-02-04 10:03:47',4,0),(4065,7,4065,'2025-02-04 10:03:47',4,0),(4066,7,4066,'2025-02-04 10:03:47',4,0),(4067,7,4067,'2025-02-04 10:03:47',4,0),(4068,7,4068,'2025-02-04 10:03:47',4,0),(4069,7,4069,'2025-02-04 10:03:47',4,0),(4070,7,4070,'2025-02-04 10:03:47',4,0),(4071,7,4071,'2025-02-04 10:03:47',4,0),(4072,7,4072,'2025-02-04 10:03:47',4,0),(4073,7,4073,'2025-02-04 10:03:47',4,0),(4074,7,4074,'2025-02-04 10:03:47',4,0),(4075,7,4075,'2025-02-04 10:03:47',4,0),(4076,7,4076,'2025-02-04 10:03:47',4,0),(4077,7,4077,'2025-02-04 10:03:47',4,0),(4078,7,4078,'2025-02-04 10:03:47',4,0),(4079,7,4079,'2025-02-04 10:03:48',4,0),(4080,7,4080,'2025-02-04 10:03:48',4,0),(4081,7,4081,'2025-02-04 10:03:48',4,0),(4082,7,4082,'2025-02-04 10:03:48',4,0),(4083,7,4083,'2025-02-04 10:03:48',4,0),(4084,7,4084,'2025-02-04 10:03:48',4,0),(4085,7,4085,'2025-02-04 10:03:48',4,0),(4086,7,4086,'2025-02-04 10:03:48',4,0),(4087,7,4087,'2025-02-04 10:03:48',4,0),(4088,7,4088,'2025-02-04 10:03:48',4,0),(4089,7,4089,'2025-02-04 10:03:48',4,0),(4090,7,4090,'2025-02-04 10:03:48',4,0),(4091,7,4091,'2025-02-04 10:03:48',4,0),(4092,7,4092,'2025-02-04 10:03:48',4,0),(4093,7,4093,'2025-02-04 10:03:48',4,0),(4094,7,4094,'2025-02-04 10:03:48',4,0),(4095,7,4095,'2025-02-04 10:03:48',4,0),(4096,7,4096,'2025-02-04 10:03:48',4,0),(4097,7,4097,'2025-02-04 10:03:48',4,0),(4098,7,4098,'2025-02-04 10:03:48',4,0),(4099,7,4099,'2025-02-04 10:03:48',4,0),(4100,7,4100,'2025-02-04 10:03:48',4,0),(4101,7,4101,'2025-02-04 10:03:48',4,0),(4102,7,4102,'2025-02-04 10:03:48',4,0),(4103,7,4103,'2025-02-04 10:03:48',4,0),(4104,7,4104,'2025-02-04 10:03:48',4,0),(4105,7,4105,'2025-02-04 10:03:48',4,0),(4106,7,4106,'2025-02-04 10:03:48',4,0),(4107,7,4107,'2025-02-04 10:03:48',4,0),(4108,7,4108,'2025-02-04 10:03:48',4,0),(4109,7,4109,'2025-02-04 10:03:48',4,0),(4110,7,4110,'2025-02-04 10:03:48',4,0),(4111,7,4111,'2025-02-04 10:03:48',4,0),(4112,7,4112,'2025-02-04 10:03:48',4,0),(4113,7,4113,'2025-02-04 10:03:48',4,0),(4114,7,4114,'2025-02-04 10:03:48',4,0),(4115,7,4115,'2025-02-04 10:03:48',4,0),(4116,7,4116,'2025-02-04 10:03:48',4,0),(4117,7,4117,'2025-02-04 10:03:48',4,0),(4118,7,4118,'2025-02-04 10:03:48',4,0),(4119,7,4119,'2025-02-04 10:03:48',4,0),(4120,7,4120,'2025-02-04 10:03:49',4,0),(4121,7,4121,'2025-02-04 10:03:49',4,0),(4122,7,4122,'2025-02-04 10:03:49',4,0),(4123,7,4123,'2025-02-04 10:03:49',4,0),(4124,7,4124,'2025-02-04 10:03:49',4,0),(4125,7,4125,'2025-02-04 10:03:49',4,0),(4126,7,4126,'2025-02-04 10:03:49',4,0),(4127,7,4127,'2025-02-04 10:03:49',4,0),(4128,7,4128,'2025-02-04 10:03:49',4,0),(4129,7,4129,'2025-02-04 10:03:49',4,0),(4130,7,4130,'2025-02-04 10:03:49',4,0),(4131,7,4131,'2025-02-04 10:03:49',4,0),(4132,7,4132,'2025-02-04 10:03:49',4,0),(4133,7,4133,'2025-02-04 10:03:49',4,0),(4134,7,4134,'2025-02-04 10:03:49',4,0),(4135,7,4135,'2025-02-04 10:03:49',4,0),(4136,7,4136,'2025-02-04 10:03:49',4,0),(4137,7,4137,'2025-02-04 10:03:49',4,0),(4138,7,4138,'2025-02-04 10:03:49',4,0),(4139,7,4139,'2025-02-04 10:03:49',4,0),(4140,7,4140,'2025-02-04 10:03:49',4,0),(4141,7,4141,'2025-02-04 10:03:49',4,0),(4142,7,4142,'2025-02-04 10:03:49',4,0),(4143,7,4143,'2025-02-04 10:03:49',4,0),(4144,7,4144,'2025-02-04 10:03:49',4,0),(4145,7,4145,'2025-02-04 10:03:49',4,0),(4146,7,4146,'2025-02-04 10:03:49',4,0),(4147,7,4147,'2025-02-04 10:03:49',4,0),(4148,7,4148,'2025-02-04 10:03:49',4,0),(4149,7,4149,'2025-02-04 10:03:49',4,0),(4150,7,4150,'2025-02-04 10:03:49',4,0),(4151,7,4151,'2025-02-04 10:03:49',4,0),(4152,7,4152,'2025-02-04 10:03:49',4,0),(4153,7,4153,'2025-02-04 10:03:49',4,0),(4154,7,4154,'2025-02-04 10:03:49',4,0),(4155,7,4155,'2025-02-04 10:03:49',4,0),(4156,7,4156,'2025-02-04 10:03:50',4,0),(4157,7,4157,'2025-02-04 10:03:50',4,0),(4158,7,4158,'2025-02-04 10:03:50',4,0),(4159,7,4159,'2025-02-04 10:03:50',4,0),(4160,7,4160,'2025-02-04 10:03:50',4,0),(4161,7,4161,'2025-02-04 10:03:50',4,0),(4162,7,4162,'2025-02-04 10:03:50',4,0),(4163,7,4163,'2025-02-04 10:03:50',4,0),(4164,7,4164,'2025-02-04 10:03:50',4,0),(4165,7,4165,'2025-02-04 10:03:50',4,0),(4166,7,4166,'2025-02-04 10:03:50',4,0),(4167,7,4167,'2025-02-04 10:03:50',4,0),(4168,7,4168,'2025-02-04 10:03:50',4,0),(4169,7,4169,'2025-02-04 10:03:50',4,0),(4170,7,4170,'2025-02-04 10:03:50',4,0),(4171,7,4171,'2025-02-04 10:03:50',4,0),(4172,7,4172,'2025-02-04 10:03:50',4,0),(4173,7,4173,'2025-02-04 10:03:50',4,0),(4174,7,4174,'2025-02-04 10:03:50',4,0),(4175,7,4175,'2025-02-04 10:03:50',4,0),(4176,7,4176,'2025-02-04 10:03:50',4,0),(4177,7,4177,'2025-02-04 10:03:50',4,0),(4178,7,4178,'2025-02-04 10:03:50',4,0),(4179,7,4179,'2025-02-04 10:03:50',4,0),(4180,7,4180,'2025-02-04 10:03:50',4,0),(4181,7,4181,'2025-02-04 10:03:50',4,0),(4182,7,4182,'2025-02-04 10:03:50',4,0),(4183,7,4183,'2025-02-04 10:03:50',4,0),(4184,7,4184,'2025-02-04 10:03:50',4,0),(4185,7,4185,'2025-02-04 10:03:50',4,0),(4186,7,4186,'2025-02-04 10:03:50',4,0),(4187,7,4187,'2025-02-04 10:03:50',4,0),(4188,7,4188,'2025-02-04 10:03:50',4,0),(4189,7,4189,'2025-02-04 10:03:50',4,0),(4190,7,4190,'2025-02-04 10:03:50',4,0),(4191,7,4191,'2025-02-04 10:03:50',4,0),(4192,7,4192,'2025-02-04 10:03:50',4,0),(4193,7,4193,'2025-02-04 10:03:50',4,0),(4194,7,4194,'2025-02-04 10:03:51',4,0),(4195,7,4195,'2025-02-04 10:03:51',4,0),(4196,7,4196,'2025-02-04 10:03:51',4,0),(4197,7,4197,'2025-02-04 10:03:51',4,0),(4198,7,4198,'2025-02-04 10:03:51',4,0),(4199,7,4199,'2025-02-04 10:03:51',4,0),(4200,7,4200,'2025-02-04 10:03:51',4,0),(4201,7,4201,'2025-02-04 10:03:51',4,0),(4202,7,4202,'2025-02-04 10:03:51',4,0),(4203,7,4203,'2025-02-04 10:03:51',4,0),(4204,7,4204,'2025-02-04 10:03:51',4,0),(4205,7,4205,'2025-02-04 10:03:51',4,0),(4206,7,4206,'2025-02-04 10:03:51',4,0),(4207,7,4207,'2025-02-04 10:03:51',4,0),(4208,7,4208,'2025-02-04 10:03:51',4,0),(4209,7,4209,'2025-02-04 10:03:51',4,0),(4210,7,4210,'2025-02-04 10:03:51',4,0),(4211,7,4211,'2025-02-04 10:03:51',4,0),(4212,7,4212,'2025-02-04 10:03:51',4,0),(4213,7,4213,'2025-02-04 10:03:51',4,0),(4214,7,4214,'2025-02-04 10:03:51',4,0),(4215,7,4215,'2025-02-04 10:03:51',4,0),(4216,7,4216,'2025-02-04 10:03:51',4,0),(4217,7,4217,'2025-02-04 10:03:51',4,0),(4218,7,4218,'2025-02-04 10:03:51',4,0),(4219,7,4219,'2025-02-04 10:03:51',4,0),(4220,7,4220,'2025-02-04 10:03:51',4,0),(4221,7,4221,'2025-02-04 10:03:51',4,0),(4222,7,4222,'2025-02-04 10:03:51',4,0),(4223,7,4223,'2025-02-04 10:03:51',4,0),(4224,7,4224,'2025-02-04 10:03:51',4,0),(4225,7,4225,'2025-02-04 10:03:51',4,0),(4226,7,4226,'2025-02-04 10:03:51',4,0),(4227,7,4227,'2025-02-04 10:03:51',4,0),(4228,7,4228,'2025-02-04 10:03:51',4,0),(4229,7,4229,'2025-02-04 10:03:51',4,0),(4230,7,4230,'2025-02-04 10:03:51',4,0),(4231,7,4231,'2025-02-04 10:03:52',4,0),(4232,7,4232,'2025-02-04 10:03:52',4,0),(4233,7,4233,'2025-02-04 10:03:52',4,0),(4234,7,4234,'2025-02-04 10:03:52',4,0),(4235,7,4235,'2025-02-04 10:03:52',4,0),(4236,7,4236,'2025-02-04 10:03:52',4,0),(4237,7,4237,'2025-02-04 10:03:52',4,0),(4238,7,4238,'2025-02-04 10:03:52',4,0),(4239,7,4239,'2025-02-04 10:03:52',4,0),(4240,7,4240,'2025-02-04 10:03:52',4,0),(4241,7,4241,'2025-02-04 10:03:52',4,0),(4242,7,4242,'2025-02-04 10:03:52',4,0),(4243,7,4243,'2025-02-04 10:03:52',4,0),(4244,7,4244,'2025-02-04 10:03:52',4,0),(4245,7,4245,'2025-02-04 10:03:52',4,0),(4246,7,4246,'2025-02-04 10:03:52',4,0),(4247,7,4247,'2025-02-04 10:03:52',4,0),(4248,7,4248,'2025-02-04 10:03:52',4,0),(4249,7,4249,'2025-02-04 10:03:52',4,0),(4250,7,4250,'2025-02-04 10:03:52',4,0),(4251,7,4251,'2025-02-04 10:03:52',4,0),(4252,7,4252,'2025-02-04 10:03:52',4,0),(4253,7,4253,'2025-02-04 10:03:52',4,0),(4254,7,4254,'2025-02-04 10:03:52',4,0),(4255,7,4255,'2025-02-04 10:03:52',4,0),(4256,7,4256,'2025-02-04 10:03:52',4,0),(4257,7,4257,'2025-02-04 10:03:52',4,0),(4258,7,4258,'2025-02-04 10:03:52',4,0),(4259,7,4259,'2025-02-04 10:03:52',4,0),(4260,7,4260,'2025-02-04 10:03:52',4,0),(4261,7,4261,'2025-02-04 10:03:52',4,0),(4262,7,4262,'2025-02-04 10:03:52',4,0),(4263,7,4263,'2025-02-04 10:03:52',4,0),(4264,7,4264,'2025-02-04 10:03:52',4,0),(4265,7,4265,'2025-02-04 10:03:52',4,0),(4266,7,4266,'2025-02-04 10:03:53',4,0),(4267,7,4267,'2025-02-04 10:03:53',4,0),(4268,7,4268,'2025-02-04 10:03:53',4,0),(4269,7,4269,'2025-02-04 10:03:53',4,0),(4270,7,4270,'2025-02-04 10:03:53',4,0),(4271,7,4271,'2025-02-04 10:03:53',4,0),(4272,7,4272,'2025-02-04 10:03:53',4,0),(4273,7,4273,'2025-02-04 10:03:53',4,0),(4274,7,4274,'2025-02-04 10:03:53',4,0),(4275,7,4275,'2025-02-04 10:03:53',4,0),(4276,7,4276,'2025-02-04 10:03:53',4,0),(4277,7,4277,'2025-02-04 10:03:53',4,0),(4278,7,4278,'2025-02-04 10:03:53',4,0),(4279,7,4279,'2025-02-04 10:03:53',4,0),(4280,7,4280,'2025-02-04 10:03:53',4,0),(4281,7,4281,'2025-02-04 10:03:53',4,0),(4282,7,4282,'2025-02-04 10:03:53',4,0),(4283,7,4283,'2025-02-04 10:03:53',4,0),(4284,7,4284,'2025-02-04 10:03:53',4,0),(4285,7,4285,'2025-02-04 10:03:53',4,0),(4286,7,4286,'2025-02-04 10:03:53',4,0),(4287,7,4287,'2025-02-04 10:03:53',4,0),(4288,7,4288,'2025-02-04 10:03:53',4,0),(4289,7,4289,'2025-02-04 10:03:53',4,0),(4290,7,4290,'2025-02-04 10:03:53',4,0),(4291,7,4291,'2025-02-04 10:03:53',4,0),(4292,7,4292,'2025-02-04 10:03:53',4,0),(4293,7,4293,'2025-02-04 10:03:53',4,0),(4294,7,4294,'2025-02-04 10:03:53',4,0),(4295,7,4295,'2025-02-04 10:03:53',4,0),(4296,7,4296,'2025-02-04 10:03:53',4,0),(4297,7,4297,'2025-02-04 10:03:53',4,0),(4298,7,4298,'2025-02-04 10:03:53',4,0),(4299,7,4299,'2025-02-04 10:03:53',4,0),(4300,7,4300,'2025-02-04 10:03:53',4,0),(4301,7,4301,'2025-02-04 10:03:53',4,0),(4302,7,4302,'2025-02-04 10:03:53',4,0),(4303,7,4303,'2025-02-04 10:03:53',4,0),(4304,7,4304,'2025-02-04 10:03:54',4,0),(4305,7,4305,'2025-02-04 10:03:54',4,0),(4306,7,4306,'2025-02-04 10:03:54',4,0),(4307,7,4307,'2025-02-04 10:03:54',4,0),(4308,7,4308,'2025-02-04 10:03:54',4,0),(4309,7,4309,'2025-02-04 10:03:54',4,0),(4310,7,4310,'2025-02-04 10:03:54',4,0),(4311,7,4311,'2025-02-04 10:03:54',4,0),(4312,7,4312,'2025-02-04 10:03:54',4,0),(4313,7,4313,'2025-02-04 10:03:54',4,0),(4314,7,4314,'2025-02-04 10:03:54',4,0),(4315,7,4315,'2025-02-04 10:03:54',4,0),(4316,7,4316,'2025-02-04 10:03:54',4,0),(4317,7,4317,'2025-02-04 10:03:54',4,0),(4318,7,4318,'2025-02-04 10:03:54',4,0),(4319,7,4319,'2025-02-04 10:03:54',4,0),(4320,7,4320,'2025-02-04 10:03:54',4,0),(4321,7,4321,'2025-02-04 10:03:54',4,0),(4322,7,4322,'2025-02-04 10:03:54',4,0),(4323,7,4323,'2025-02-04 10:03:54',4,0),(4324,7,4324,'2025-02-04 10:03:54',4,0),(4325,7,4325,'2025-02-04 10:03:54',4,0),(4326,7,4326,'2025-02-04 10:03:54',4,0),(4327,7,4327,'2025-02-04 10:03:54',4,0),(4328,7,4328,'2025-02-04 10:03:54',4,0),(4329,7,4329,'2025-02-04 10:03:54',4,0),(4330,7,4330,'2025-02-04 10:03:54',4,0),(4331,7,4331,'2025-02-04 10:03:54',4,0),(4332,7,4332,'2025-02-04 10:03:54',4,0),(4333,7,4333,'2025-02-04 10:03:54',4,0),(4334,7,4334,'2025-02-04 10:03:54',4,0),(4335,7,4335,'2025-02-04 10:03:54',4,0),(4336,7,4336,'2025-02-04 10:03:54',4,0),(4337,7,4337,'2025-02-04 10:03:54',4,0),(4338,7,4338,'2025-02-04 10:03:55',4,0),(4339,7,4339,'2025-02-04 10:03:55',4,0),(4340,7,4340,'2025-02-04 10:03:55',4,0),(4341,7,4341,'2025-02-04 10:03:55',4,0),(4342,7,4342,'2025-02-04 10:03:55',4,0),(4343,7,4343,'2025-02-04 10:03:55',4,0),(4344,7,4344,'2025-02-04 10:03:55',4,0),(4345,7,4345,'2025-02-04 10:03:55',4,0),(4346,7,4346,'2025-02-04 10:03:55',4,0),(4347,7,4347,'2025-02-04 10:03:55',4,0),(4348,7,4348,'2025-02-04 10:03:55',4,0),(4349,7,4349,'2025-02-04 10:03:55',4,0),(4350,7,4350,'2025-02-04 10:03:55',4,0),(4351,7,4351,'2025-02-04 10:03:55',4,0),(4352,7,4352,'2025-02-04 10:03:55',4,0),(4353,7,4353,'2025-02-04 10:03:56',4,0),(4354,7,4354,'2025-02-04 10:03:56',4,0),(4355,7,4355,'2025-02-04 10:03:56',4,0),(4356,7,4356,'2025-02-04 10:03:56',4,0),(4357,7,4357,'2025-02-04 10:03:56',4,0),(4358,7,4358,'2025-02-04 10:03:56',4,0),(4359,7,4359,'2025-02-04 10:03:56',4,0),(4360,7,4360,'2025-02-04 10:03:56',4,0),(4361,7,4361,'2025-02-04 10:03:56',4,0),(4362,7,4362,'2025-02-04 10:03:56',4,0),(4363,7,4363,'2025-02-04 10:03:56',4,0),(4364,7,4364,'2025-02-04 10:03:56',4,0),(4365,7,4365,'2025-02-04 10:03:56',4,0),(4366,7,4366,'2025-02-04 10:03:56',4,0),(4367,7,4367,'2025-02-04 10:03:56',4,0),(4368,7,4368,'2025-02-04 10:03:56',4,0),(4369,7,4369,'2025-02-04 10:03:56',4,0),(4370,7,4370,'2025-02-04 10:03:57',4,0),(4371,7,4371,'2025-02-04 10:03:57',4,0),(4372,7,4372,'2025-02-04 10:03:57',4,0),(4373,7,4373,'2025-02-04 10:03:57',4,0),(4374,7,4374,'2025-02-04 10:03:57',4,0),(4375,7,4375,'2025-02-04 10:03:57',4,0),(4376,7,4376,'2025-02-04 10:03:57',4,0),(4377,7,4377,'2025-02-04 10:03:57',4,0),(4378,7,4378,'2025-02-04 10:03:57',4,0),(4379,7,4379,'2025-02-04 10:03:57',4,0),(4380,7,4380,'2025-02-04 10:03:57',4,0),(4381,7,4381,'2025-02-04 10:03:57',4,0),(4382,7,4382,'2025-02-04 10:03:57',4,0),(4383,7,4383,'2025-02-04 10:03:57',4,0),(4384,7,4384,'2025-02-04 10:03:57',4,0),(4385,7,4385,'2025-02-04 10:03:57',4,0),(4386,7,4386,'2025-02-04 10:03:57',4,0),(4387,7,4387,'2025-02-04 10:03:57',4,0),(4388,7,4388,'2025-02-04 10:03:58',4,0),(4389,7,4389,'2025-02-04 10:03:58',4,0),(4390,7,4390,'2025-02-04 10:03:58',4,0),(4391,7,4391,'2025-02-04 10:03:58',4,0),(4392,7,4392,'2025-02-04 10:03:58',4,0),(4393,7,4393,'2025-02-04 10:03:58',4,0),(4394,7,4394,'2025-02-04 10:03:58',4,0),(4395,7,4395,'2025-02-04 10:03:58',4,0),(4396,7,4396,'2025-02-04 10:03:58',4,0),(4397,7,4397,'2025-02-04 10:03:58',4,0),(4398,7,4398,'2025-02-04 10:03:58',4,0),(4399,7,4399,'2025-02-04 10:03:58',4,0),(4400,7,4400,'2025-02-04 10:03:58',4,0),(4401,7,4401,'2025-02-04 10:03:58',4,0),(4402,7,4402,'2025-02-04 10:03:58',4,0),(4403,7,4403,'2025-02-04 10:03:58',4,0),(4404,7,4404,'2025-02-04 10:03:58',4,0),(4405,7,4405,'2025-02-04 10:03:58',4,0),(4406,7,4406,'2025-02-04 10:03:58',4,0),(4407,7,4407,'2025-02-04 10:03:59',4,0),(4408,7,4408,'2025-02-04 10:03:59',4,0),(4409,7,4409,'2025-02-04 10:03:59',4,0),(4410,7,4410,'2025-02-04 10:03:59',4,0),(4411,7,4411,'2025-02-04 10:03:59',4,0),(4412,7,4412,'2025-02-04 10:03:59',4,0),(4413,7,4413,'2025-02-04 10:03:59',4,0),(4414,7,4414,'2025-02-04 10:03:59',4,0),(4415,7,4415,'2025-02-04 10:03:59',4,0),(4416,7,4416,'2025-02-04 10:03:59',4,0),(4417,7,4417,'2025-02-04 10:03:59',4,0),(4418,7,4418,'2025-02-04 10:03:59',4,0),(4419,7,4419,'2025-02-04 10:03:59',4,0),(4420,7,4420,'2025-02-04 10:03:59',4,0),(4421,7,4421,'2025-02-04 10:03:59',4,0),(4422,7,4422,'2025-02-04 10:03:59',4,0),(4423,7,4423,'2025-02-04 10:03:59',4,0),(4424,7,4424,'2025-02-04 10:03:59',4,0),(4425,7,4425,'2025-02-04 10:03:59',4,0),(4426,7,4426,'2025-02-04 10:03:59',4,0),(4427,7,4427,'2025-02-04 10:03:59',4,0),(4428,7,4428,'2025-02-04 10:03:59',4,0),(4429,7,4429,'2025-02-04 10:03:59',4,0),(4430,7,4430,'2025-02-04 10:04:00',4,0),(4431,7,4431,'2025-02-04 10:04:00',4,0),(4432,7,4432,'2025-02-04 10:04:00',4,0),(4433,7,4433,'2025-02-04 10:04:00',4,0),(4434,7,4434,'2025-02-04 10:04:00',4,0),(4435,7,4435,'2025-02-04 10:04:00',4,0),(4436,7,4436,'2025-02-04 10:04:00',4,0),(4437,7,4437,'2025-02-04 10:04:00',4,0),(4438,7,4438,'2025-02-04 10:04:00',4,0),(4439,7,4439,'2025-02-04 10:04:00',4,0),(4440,7,4440,'2025-02-04 10:04:00',4,0),(4441,7,4441,'2025-02-04 10:04:00',4,0),(4442,7,4442,'2025-02-04 10:04:00',4,0),(4443,7,4443,'2025-02-04 10:04:00',4,0),(4444,7,4444,'2025-02-04 10:04:00',4,0),(4445,7,4445,'2025-02-04 10:04:00',4,0),(4446,7,4446,'2025-02-04 10:04:00',4,0),(4447,7,4447,'2025-02-04 10:04:00',4,0),(4448,7,4448,'2025-02-04 10:04:00',4,0),(4449,7,4449,'2025-02-04 10:04:00',4,0),(4450,7,4450,'2025-02-04 10:04:00',4,0),(4451,7,4451,'2025-02-04 10:04:00',4,0),(4452,7,4452,'2025-02-04 10:04:00',4,0),(4453,7,4453,'2025-02-04 10:04:00',4,0),(4454,7,4454,'2025-02-04 10:04:00',4,0),(4455,7,4455,'2025-02-04 10:04:00',4,0),(4456,7,4456,'2025-02-04 10:04:00',4,0),(4457,7,4457,'2025-02-04 10:04:00',4,0),(4458,7,4458,'2025-02-04 10:04:01',4,0),(4459,7,4459,'2025-02-04 10:04:01',4,0),(4460,7,4460,'2025-02-04 10:04:01',4,0),(4461,7,4461,'2025-02-04 10:04:01',4,0),(4462,7,4462,'2025-02-04 10:04:01',4,0),(4463,7,4463,'2025-02-04 10:04:01',4,0),(4464,7,4464,'2025-02-04 10:04:01',4,0),(4465,7,4465,'2025-02-04 10:04:01',4,0),(4466,7,4466,'2025-02-04 10:04:01',4,0),(4467,7,4467,'2025-02-04 10:04:01',4,0),(4468,7,4468,'2025-02-04 10:04:01',4,0),(4469,7,4469,'2025-02-04 10:04:01',4,0),(4470,7,4470,'2025-02-04 10:04:01',4,0),(4471,7,4471,'2025-02-04 10:04:01',4,0),(4472,7,4472,'2025-02-04 10:04:01',4,0),(4473,7,4473,'2025-02-04 10:04:01',4,0),(4474,7,4474,'2025-02-04 10:04:01',4,0),(4475,7,4475,'2025-02-04 10:04:01',4,0),(4476,7,4476,'2025-02-04 10:04:01',5,1),(4477,7,4477,'2025-01-31 14:48:27',2,0),(4478,7,4478,'2025-01-31 14:48:27',2,0),(4479,7,4479,'2025-01-31 14:48:27',2,0),(4480,7,4480,'2025-01-31 14:48:27',2,0),(4481,7,4481,'2025-01-31 14:48:27',2,0),(4482,7,4482,'2025-01-31 14:48:27',2,0),(4483,7,4483,'2025-01-31 14:48:28',2,0),(4484,7,4484,'2025-01-31 14:48:28',2,0),(4485,7,4485,'2025-01-31 14:48:28',2,0),(4486,7,4486,'2025-01-31 14:48:28',2,0),(4487,7,4487,'2025-01-31 14:48:28',2,0),(4488,7,4488,'2025-01-31 14:48:28',2,0),(4489,7,4489,'2025-01-31 14:48:28',2,0),(4490,7,4490,'2025-01-31 14:48:28',2,0),(4491,7,4491,'2025-01-31 14:48:28',2,0),(4492,7,4492,'2025-01-31 14:48:28',2,0),(4493,7,4493,'2025-01-31 14:48:28',2,0),(4494,7,4494,'2025-01-31 14:48:28',2,0),(4495,7,4495,'2025-01-31 14:48:28',2,0),(4496,7,4496,'2025-01-31 14:48:28',2,0),(4497,7,4497,'2025-01-31 14:48:28',2,0),(4498,7,4498,'2025-01-31 14:48:28',2,0),(4499,7,4499,'2025-01-31 14:48:28',2,0),(4500,7,4500,'2025-01-31 14:48:29',2,0),(4501,7,4501,'2025-01-31 14:48:29',2,0),(4502,7,4502,'2025-01-31 14:48:29',2,0),(4503,7,4503,'2025-01-31 14:48:29',2,0),(4504,7,4504,'2025-01-31 14:48:29',2,0),(4505,7,4505,'2025-01-31 14:48:29',2,0),(4506,7,4506,'2025-01-31 14:48:29',2,0),(4507,7,4507,'2025-01-31 14:48:29',2,0),(4508,7,4508,'2025-01-31 14:48:29',2,0),(4509,7,4509,'2025-01-31 14:48:29',2,0),(4510,7,4510,'2025-01-31 14:48:29',2,0),(4511,7,4511,'2025-01-31 14:48:29',2,0),(4512,7,4512,'2025-01-31 14:48:29',2,0),(4513,7,4513,'2025-01-31 14:48:29',2,0),(4514,7,4514,'2025-01-31 14:48:29',2,0),(4515,7,4515,'2025-01-31 14:48:29',2,0),(4516,7,4516,'2025-01-31 14:48:29',2,0),(4517,7,4517,'2025-01-31 14:48:29',2,0),(4518,7,4518,'2025-01-31 14:48:29',2,0),(4519,7,4519,'2025-01-31 14:48:30',2,0),(4520,7,4520,'2025-01-31 14:48:30',2,0),(4521,7,4521,'2025-01-31 14:48:30',2,0),(4522,7,4522,'2025-01-31 14:48:30',2,0),(4523,7,4523,'2025-01-31 14:48:30',2,0),(4524,7,4524,'2025-01-31 14:48:30',2,0),(4525,7,4525,'2025-01-31 14:48:30',2,0),(4526,7,4526,'2025-01-31 14:48:30',2,0),(4527,7,4527,'2025-01-31 14:48:30',2,0),(4528,7,4528,'2025-01-31 14:48:30',2,0),(4529,7,4529,'2025-01-31 14:48:30',2,0),(4530,7,4530,'2025-01-31 14:48:30',2,0),(4531,7,4531,'2025-01-31 14:48:30',2,0),(4532,7,4532,'2025-01-31 14:48:30',2,0),(4533,7,4533,'2025-01-31 14:48:30',2,0),(4534,7,4534,'2025-01-31 14:48:30',2,0),(4535,7,4535,'2025-01-31 14:48:30',2,0),(4536,7,4536,'2025-01-31 14:48:30',2,0),(4537,7,4537,'2025-01-31 14:48:30',2,0),(4538,7,4538,'2025-01-31 14:48:30',2,0),(4539,7,4539,'2025-01-31 14:48:30',2,0),(4540,7,4540,'2025-01-31 14:48:30',2,0),(4541,7,4541,'2025-01-31 14:48:30',2,0),(4542,7,4542,'2025-01-31 14:48:31',2,0),(4543,7,4543,'2025-01-31 14:48:31',2,0),(4544,7,4544,'2025-01-31 14:48:31',2,0),(4545,7,4545,'2025-01-31 14:48:31',2,0),(4546,7,4546,'2025-01-31 14:48:31',2,0),(4547,7,4547,'2025-01-31 14:48:31',2,0),(4548,7,4548,'2025-01-31 14:48:31',2,0),(4549,7,4549,'2025-01-31 14:48:31',2,0),(4550,7,4550,'2025-01-31 14:48:31',2,0),(4551,7,4551,'2025-01-31 14:48:31',2,0),(4552,7,4552,'2025-01-31 14:48:31',2,0),(4553,7,4553,'2025-01-31 14:48:31',2,0),(4554,7,4554,'2025-01-31 14:48:31',2,0),(4555,7,4555,'2025-01-31 14:48:31',2,0),(4556,7,4556,'2025-01-31 14:48:31',2,0),(4557,7,4557,'2025-01-31 14:48:31',2,0),(4558,7,4558,'2025-01-31 14:48:31',2,0),(4559,7,4559,'2025-01-31 14:48:31',2,0),(4560,7,4560,'2025-01-31 14:48:31',2,0),(4561,7,4561,'2025-01-31 14:48:31',2,0),(4562,7,4562,'2025-01-31 14:48:31',2,0),(4563,7,4563,'2025-01-31 14:48:31',2,0),(4564,7,4564,'2025-01-31 14:48:31',2,0),(4565,7,4565,'2025-01-31 14:48:31',2,0),(4566,7,4566,'2025-01-31 14:48:31',2,0),(4567,7,4567,'2025-01-31 14:48:31',2,0),(4568,7,4568,'2025-01-31 14:48:31',2,0),(4569,7,4569,'2025-01-31 14:48:31',2,0),(4570,7,4570,'2025-01-31 14:48:31',2,0),(4571,7,4571,'2025-01-31 14:48:31',2,0),(4572,7,4572,'2025-01-31 14:48:31',2,0),(4573,7,4573,'2025-01-31 14:48:31',2,0),(4574,7,4574,'2025-01-31 14:48:31',2,0),(4575,7,4575,'2025-01-31 14:48:31',2,0),(4576,7,4576,'2025-01-31 14:48:32',2,0),(4577,7,4577,'2025-01-31 14:48:32',2,0),(4578,7,4578,'2025-01-31 14:48:32',2,0),(4579,7,4579,'2025-01-31 14:48:32',2,0),(4580,7,4580,'2025-01-31 14:48:32',2,0),(4581,7,4581,'2025-01-31 14:48:32',2,0),(4582,7,4582,'2025-01-31 14:48:32',2,0),(4583,7,4583,'2025-01-31 14:48:32',2,0),(4584,7,4584,'2025-01-31 14:48:32',2,0),(4585,7,4585,'2025-01-31 14:48:32',2,0),(4586,7,4586,'2025-01-31 14:48:32',2,0),(4587,7,4587,'2025-01-31 14:48:32',2,0),(4588,7,4588,'2025-01-31 14:48:32',2,0),(4589,7,4589,'2025-01-31 14:48:32',2,0),(4590,7,4590,'2025-01-31 14:48:32',2,0),(4591,7,4591,'2025-01-31 14:48:32',2,0),(4592,7,4592,'2025-01-31 14:48:32',2,0),(4593,7,4593,'2025-01-31 14:48:32',2,0),(4594,7,4594,'2025-01-31 14:48:32',2,0),(4595,7,4595,'2025-01-31 14:48:32',2,0),(4596,7,4596,'2025-01-31 14:48:32',2,0),(4597,7,4597,'2025-01-31 14:48:32',2,0),(4598,7,4598,'2025-01-31 14:48:32',2,0),(4599,7,4599,'2025-01-31 14:48:32',2,0),(4600,7,4600,'2025-01-31 14:48:32',2,0),(4601,7,4601,'2025-01-31 14:48:32',2,0),(4602,7,4602,'2025-01-31 14:48:32',2,0),(4603,7,4603,'2025-01-31 14:48:32',2,0),(4604,7,4604,'2025-01-31 14:48:32',2,0),(4605,7,4605,'2025-01-31 14:48:32',2,0),(4606,7,4606,'2025-01-31 14:48:32',2,0),(4607,7,4607,'2025-01-31 14:48:32',2,0),(4608,7,4608,'2025-01-31 14:48:32',2,0),(4609,7,4609,'2025-01-31 14:48:32',2,0),(4610,7,4610,'2025-01-31 14:48:32',2,0),(4611,7,4611,'2025-01-31 14:48:32',2,0),(4612,7,4612,'2025-01-31 14:48:33',2,0),(4613,7,4613,'2025-01-31 14:48:33',2,0),(4614,7,4614,'2025-01-31 14:48:33',2,0),(4615,7,4615,'2025-01-31 14:48:33',2,0),(4616,7,4616,'2025-01-31 14:48:33',2,0),(4617,7,4617,'2025-01-31 14:48:33',2,0),(4618,7,4618,'2025-01-31 14:48:33',2,0),(4619,7,4619,'2025-01-31 14:48:33',2,0),(4620,7,4620,'2025-01-31 14:48:33',2,0),(4621,7,4621,'2025-01-31 14:48:33',2,0),(4622,7,4622,'2025-01-31 14:48:33',2,0),(4623,7,4623,'2025-01-31 14:48:33',2,0),(4624,7,4624,'2025-01-31 14:48:33',2,0),(4625,7,4625,'2025-01-31 14:48:33',2,0),(4626,7,4626,'2025-01-31 14:48:33',2,0),(4627,7,4627,'2025-01-31 14:48:33',2,0),(4628,7,4628,'2025-01-31 14:48:33',2,0),(4629,7,4629,'2025-01-31 14:48:33',2,0),(4630,7,4630,'2025-01-31 14:48:33',2,0),(4631,7,4631,'2025-01-31 14:48:33',2,0),(4632,7,4632,'2025-01-31 14:48:33',2,0),(4633,7,4633,'2025-01-31 14:48:33',2,0),(4634,7,4634,'2025-01-31 14:48:33',2,0),(4635,7,4635,'2025-01-31 14:48:33',2,0),(4636,7,4636,'2025-01-31 14:48:33',2,0),(4637,7,4637,'2025-01-31 14:48:33',2,0),(4638,7,4638,'2025-01-31 14:48:33',2,0),(4639,7,4639,'2025-01-31 14:48:33',2,0),(4640,7,4640,'2025-01-31 14:48:33',2,0),(4641,7,4641,'2025-01-31 14:48:33',2,0),(4642,7,4642,'2025-01-31 14:48:33',2,0),(4643,7,4643,'2025-01-31 14:48:33',2,0),(4644,7,4644,'2025-01-31 14:48:33',2,0),(4645,7,4645,'2025-01-31 14:48:33',2,0),(4646,7,4646,'2025-01-31 14:48:33',2,0),(4647,7,4647,'2025-01-31 14:48:34',2,0),(4648,7,4648,'2025-01-31 14:48:34',2,0),(4649,7,4649,'2025-01-31 14:48:34',2,0),(4650,7,4650,'2025-01-31 14:48:34',2,0),(4651,7,4651,'2025-01-31 14:48:34',2,0),(4652,7,4652,'2025-01-31 14:48:34',2,0),(4653,7,4653,'2025-01-31 14:48:34',2,0),(4654,7,4654,'2025-01-31 14:48:34',2,0),(4655,7,4655,'2025-01-31 14:48:34',2,0),(4656,7,4656,'2025-01-31 14:48:34',2,0),(4657,7,4657,'2025-01-31 14:48:34',2,0),(4658,7,4658,'2025-01-31 14:48:34',2,0),(4659,7,4659,'2025-01-31 14:48:34',2,0),(4660,7,4660,'2025-01-31 14:48:34',2,0),(4661,7,4661,'2025-01-31 14:48:34',2,0),(4662,7,4662,'2025-01-31 14:48:34',2,0),(4663,7,4663,'2025-01-31 14:48:34',2,0),(4664,7,4664,'2025-01-31 14:48:34',2,0),(4665,7,4665,'2025-01-31 14:48:34',2,0),(4666,7,4666,'2025-01-31 14:48:34',2,0),(4667,7,4667,'2025-01-31 14:48:34',2,0),(4668,7,4668,'2025-01-31 14:48:34',2,0),(4669,7,4669,'2025-01-31 14:48:34',2,0),(4670,7,4670,'2025-01-31 14:48:34',2,0),(4671,7,4671,'2025-01-31 14:48:34',2,0),(4672,7,4672,'2025-01-31 14:48:34',2,0),(4673,7,4673,'2025-01-31 14:48:34',2,0),(4674,7,4674,'2025-01-31 14:48:34',2,0),(4675,7,4675,'2025-01-31 14:48:34',2,0),(4676,7,4676,'2025-01-31 14:48:34',2,0),(4677,7,4677,'2025-01-31 14:48:34',2,0),(4678,7,4678,'2025-01-31 14:48:34',2,0),(4679,7,4679,'2025-01-31 14:48:34',2,0),(4680,7,4680,'2025-01-31 14:48:34',2,0),(4681,7,4681,'2025-01-31 14:48:34',2,0),(4682,7,4682,'2025-01-31 14:48:35',2,0),(4683,7,4683,'2025-01-31 14:48:35',2,0),(4684,7,4684,'2025-01-31 14:48:35',2,0),(4685,7,4685,'2025-01-31 14:48:35',2,0),(4686,7,4686,'2025-01-31 14:48:35',2,0),(4687,7,4687,'2025-01-31 14:48:35',2,0),(4688,7,4688,'2025-01-31 14:48:35',2,0),(4689,7,4689,'2025-01-31 14:48:35',2,0),(4690,7,4690,'2025-01-31 14:48:35',2,0),(4691,7,4691,'2025-01-31 14:48:35',2,0),(4692,7,4692,'2025-01-31 14:48:35',2,0),(4693,7,4693,'2025-01-31 14:48:35',2,0),(4694,7,4694,'2025-01-31 14:48:35',2,0),(4695,7,4695,'2025-01-31 14:48:35',2,0),(4696,7,4696,'2025-01-31 14:48:35',2,0),(4697,7,4697,'2025-01-31 14:48:35',2,0),(4698,7,4698,'2025-01-31 14:48:35',2,0),(4699,7,4699,'2025-01-31 14:48:35',2,0),(4700,7,4700,'2025-01-31 14:48:35',2,0),(4701,7,4701,'2025-01-31 14:48:35',2,0),(4702,7,4702,'2025-01-31 14:48:35',2,0),(4703,7,4703,'2025-01-31 14:48:35',2,0),(4704,7,4704,'2025-01-31 14:48:35',2,0),(4705,7,4705,'2025-01-31 14:48:35',2,0),(4706,7,4706,'2025-01-31 14:48:35',2,0),(4707,7,4707,'2025-01-31 14:48:35',2,0),(4708,7,4708,'2025-01-31 14:48:35',2,0),(4709,7,4709,'2025-01-31 14:48:35',2,0),(4710,7,4710,'2025-01-31 14:48:35',2,0),(4711,7,4711,'2025-01-31 14:48:35',2,0),(4712,7,4712,'2025-01-31 14:48:35',2,0),(4713,7,4713,'2025-01-31 14:48:35',2,0),(4714,7,4714,'2025-01-31 14:48:35',2,0),(4715,7,4715,'2025-01-31 14:48:35',2,0),(4716,7,4716,'2025-01-31 14:48:35',2,0),(4717,7,4717,'2025-01-31 14:48:35',2,0),(4718,7,4718,'2025-01-31 14:48:35',2,0),(4719,7,4719,'2025-01-31 14:48:35',2,0),(4720,7,4720,'2025-01-31 14:48:35',2,0),(4721,7,4721,'2025-01-31 14:48:36',2,0),(4722,7,4722,'2025-01-31 14:48:36',2,0),(4723,7,4723,'2025-01-31 14:48:36',2,0),(4724,7,4724,'2025-01-31 14:48:36',2,0),(4725,7,4725,'2025-01-31 14:48:36',2,0),(4726,7,4726,'2025-01-31 14:48:36',2,0),(4727,7,4727,'2025-01-31 14:48:36',2,0),(4728,7,4728,'2025-01-31 14:48:36',2,0),(4729,7,4729,'2025-01-31 14:48:36',2,0),(4730,7,4730,'2025-01-31 14:48:36',2,0),(4731,7,4731,'2025-01-31 14:48:36',2,0),(4732,7,4732,'2025-01-31 14:48:36',2,0),(4733,7,4733,'2025-01-31 14:48:36',2,0),(4734,7,4734,'2025-01-31 14:48:36',2,0),(4735,7,4735,'2025-01-31 14:48:36',2,0),(4736,7,4736,'2025-01-31 14:48:36',2,0),(4737,7,4737,'2025-01-31 14:48:36',2,0),(4738,7,4738,'2025-01-31 14:48:36',2,0),(4739,7,4739,'2025-01-31 14:48:36',2,0),(4740,7,4740,'2025-01-31 14:48:36',2,0),(4741,7,4741,'2025-01-31 14:48:36',2,0),(4742,7,4742,'2025-01-31 14:48:36',2,0),(4743,7,4743,'2025-01-31 14:48:36',2,0),(4744,7,4744,'2025-01-31 14:48:36',2,0),(4745,7,4745,'2025-01-31 14:48:36',2,0),(4746,7,4746,'2025-01-31 14:48:36',2,0),(4747,7,4747,'2025-01-31 14:48:36',2,0),(4748,7,4748,'2025-01-31 14:48:36',2,0),(4749,7,4749,'2025-01-31 14:48:36',2,0),(4750,7,4750,'2025-01-31 14:48:36',2,0),(4751,7,4751,'2025-01-31 14:48:36',2,0),(4752,7,4752,'2025-01-31 14:48:36',2,0),(4753,7,4753,'2025-01-31 14:48:36',2,0),(4754,7,4754,'2025-01-31 14:48:36',2,0),(4755,7,4755,'2025-01-31 14:48:36',2,0),(4756,7,4756,'2025-01-31 14:48:36',2,0),(4757,7,4757,'2025-01-31 14:48:36',2,0),(4758,7,4758,'2025-01-31 14:48:36',2,0),(4759,7,4759,'2025-01-31 14:48:36',2,0),(4760,7,4760,'2025-01-31 14:48:36',2,0),(4761,7,4761,'2025-01-31 14:48:37',2,0),(4762,7,4762,'2025-01-31 14:48:37',2,0),(4763,7,4763,'2025-01-31 14:48:37',2,0),(4764,7,4764,'2025-01-31 14:48:37',2,0),(4765,7,4765,'2025-01-31 14:48:37',2,0),(4766,7,4766,'2025-01-31 14:48:37',2,0),(4767,7,4767,'2025-01-31 14:48:37',2,0),(4768,7,4768,'2025-01-31 14:48:37',2,0),(4769,7,4769,'2025-01-31 14:48:37',2,0),(4770,7,4770,'2025-01-31 14:48:37',2,0),(4771,7,4771,'2025-01-31 14:48:37',2,0),(4772,7,4772,'2025-01-31 14:48:37',2,0),(4773,7,4773,'2025-01-31 14:48:37',2,0),(4774,7,4774,'2025-01-31 14:48:37',2,0),(4775,7,4775,'2025-01-31 14:48:37',2,0),(4776,7,4776,'2025-01-31 14:48:37',2,0),(4777,7,4777,'2025-01-31 14:48:37',2,0),(4778,7,4778,'2025-01-31 14:48:37',2,0),(4779,7,4779,'2025-01-31 14:48:37',2,0),(4780,7,4780,'2025-01-31 14:48:37',2,0),(4781,7,4781,'2025-01-31 14:48:37',2,0),(4782,7,4782,'2025-01-31 14:48:37',2,0),(4783,7,4783,'2025-01-31 14:48:37',2,0),(4784,7,4784,'2025-01-31 14:48:37',2,0),(4785,7,4785,'2025-01-31 14:48:37',2,0),(4786,7,4786,'2025-01-31 14:48:37',2,0),(4787,7,4787,'2025-01-31 14:48:37',2,0),(4788,7,4788,'2025-01-31 14:48:37',2,0),(4789,7,4789,'2025-01-31 14:48:37',2,0),(4790,7,4790,'2025-01-31 14:48:37',2,0),(4791,7,4791,'2025-01-31 14:48:37',2,0),(4792,7,4792,'2025-01-31 14:48:37',2,0),(4793,7,4793,'2025-01-31 14:48:37',2,0),(4794,7,4794,'2025-01-31 14:48:37',2,0),(4795,7,4795,'2025-01-31 14:48:37',2,0),(4796,7,4796,'2025-01-31 14:48:37',2,0),(4797,7,4797,'2025-01-31 14:48:37',2,0),(4798,7,4798,'2025-01-31 14:48:37',2,0),(4799,7,4799,'2025-01-31 14:48:37',2,0),(4800,7,4800,'2025-01-31 14:48:37',2,0),(4801,7,4801,'2025-01-31 14:48:37',2,0),(4802,7,4802,'2025-01-31 14:48:37',2,0),(4803,7,4803,'2025-01-31 14:48:38',2,0),(4804,7,4804,'2025-01-31 14:48:38',2,0),(4805,7,4805,'2025-01-31 14:48:38',2,0),(4806,7,4806,'2025-01-31 14:48:38',2,0),(4807,7,4807,'2025-01-31 14:48:38',2,0),(4808,7,4808,'2025-01-31 14:48:38',2,0),(4809,7,4809,'2025-01-31 14:48:38',2,0),(4810,7,4810,'2025-01-31 14:48:38',2,0),(4811,7,4811,'2025-01-31 14:48:38',2,0),(4812,7,4812,'2025-01-31 14:48:38',2,0),(4813,7,4813,'2025-01-31 14:48:38',2,0),(4814,7,4814,'2025-01-31 14:48:38',2,0),(4815,7,4815,'2025-01-31 14:48:38',2,0),(4816,7,4816,'2025-01-31 14:48:38',2,0),(4817,7,4817,'2025-01-31 14:48:38',2,0),(4818,7,4818,'2025-01-31 14:48:38',2,0),(4819,7,4819,'2025-01-31 14:48:38',2,0),(4820,7,4820,'2025-01-31 14:48:38',2,0),(4821,7,4821,'2025-01-31 14:48:38',2,0),(4822,7,4822,'2025-01-31 14:48:38',2,0),(4823,7,4823,'2025-01-31 14:48:38',2,0),(4824,7,4824,'2025-01-31 14:48:38',2,0),(4825,7,4825,'2025-01-31 14:48:38',2,0),(4826,7,4826,'2025-01-31 14:48:38',2,0),(4827,7,4827,'2025-01-31 14:48:38',2,0),(4828,7,4828,'2025-01-31 14:48:38',2,0),(4829,7,4829,'2025-01-31 14:48:38',2,0),(4830,7,4830,'2025-01-31 14:48:38',2,0),(4831,7,4831,'2025-01-31 14:48:38',2,0),(4832,7,4832,'2025-01-31 14:48:38',2,0),(4833,7,4833,'2025-01-31 14:48:38',2,0),(4834,7,4834,'2025-01-31 14:48:38',2,0),(4835,7,4835,'2025-01-31 14:48:38',2,0),(4836,7,4836,'2025-01-31 14:48:38',2,0),(4837,7,4837,'2025-01-31 14:48:38',2,0),(4838,7,4838,'2025-01-31 14:48:38',2,0),(4839,7,4839,'2025-01-31 14:48:38',2,0),(4840,7,4840,'2025-01-31 14:48:38',2,0),(4841,7,4841,'2025-01-31 14:48:38',2,0),(4842,7,4842,'2025-01-31 14:48:38',2,0),(4843,7,4843,'2025-01-31 14:48:39',2,0),(4844,7,4844,'2025-01-31 14:48:39',2,0),(4845,7,4845,'2025-01-31 14:48:39',2,0),(4846,7,4846,'2025-01-31 14:48:39',2,0),(4847,7,4847,'2025-01-31 14:48:39',2,0),(4848,7,4848,'2025-01-31 14:48:39',2,0),(4849,7,4849,'2025-01-31 14:48:39',2,0),(4850,7,4850,'2025-01-31 14:48:39',2,0),(4851,7,4851,'2025-01-31 14:48:39',2,0),(4852,7,4852,'2025-01-31 14:48:39',2,0),(4853,7,4853,'2025-01-31 14:48:39',2,0),(4854,7,4854,'2025-01-31 14:48:39',2,0),(4855,7,4855,'2025-01-31 14:48:39',2,0),(4856,7,4856,'2025-01-31 14:48:39',2,0),(4857,7,4857,'2025-01-31 14:48:39',2,0),(4858,7,4858,'2025-01-31 14:48:39',2,0),(4859,7,4859,'2025-01-31 14:48:39',2,0),(4860,7,4860,'2025-01-31 14:48:39',2,0),(4861,7,4861,'2025-01-31 14:48:39',2,0),(4862,7,4862,'2025-01-31 14:48:39',2,0),(4863,7,4863,'2025-01-31 14:48:39',2,0),(4864,7,4864,'2025-01-31 14:48:39',2,0),(4865,7,4865,'2025-01-31 14:48:39',2,0),(4866,7,4866,'2025-01-31 14:48:39',2,0),(4867,7,4867,'2025-01-31 14:48:39',2,0),(4868,7,4868,'2025-01-31 14:48:39',2,0),(4869,7,4869,'2025-01-31 14:48:39',2,0),(4870,7,4870,'2025-01-31 14:48:39',2,0),(4871,7,4871,'2025-01-31 14:48:39',2,0),(4872,7,4872,'2025-01-31 14:48:39',2,0),(4873,7,4873,'2025-01-31 14:48:39',2,0),(4874,7,4874,'2025-01-31 14:48:39',2,0),(4875,7,4875,'2025-01-31 14:48:39',2,0),(4876,7,4876,'2025-01-31 14:48:39',2,0),(4877,7,4877,'2025-01-31 14:48:39',2,0),(4878,7,4878,'2025-01-31 14:48:39',2,0),(4879,7,4879,'2025-01-31 14:48:39',2,0),(4880,7,4880,'2025-01-31 14:48:39',2,0),(4881,7,4881,'2025-01-31 14:48:39',2,0),(4882,7,4882,'2025-01-31 14:48:40',2,0),(4883,7,4883,'2025-01-31 14:48:40',2,0),(4884,7,4884,'2025-01-31 14:48:40',2,0),(4885,7,4885,'2025-01-31 14:48:40',2,0),(4886,7,4886,'2025-01-31 14:48:40',2,0),(4887,7,4887,'2025-01-31 14:48:40',2,0),(4888,7,4888,'2025-01-31 14:48:40',2,0),(4889,7,4889,'2025-01-31 14:48:40',2,0),(4890,7,4890,'2025-01-31 14:48:40',2,0),(4891,7,4891,'2025-01-31 14:48:40',2,0),(4892,7,4892,'2025-01-31 14:48:40',2,0),(4893,7,4893,'2025-01-31 14:48:40',2,0),(4894,7,4894,'2025-01-31 14:48:40',2,0),(4895,7,4895,'2025-01-31 14:48:40',2,0),(4896,7,4896,'2025-01-31 14:48:40',2,0),(4897,7,4897,'2025-01-31 14:48:40',2,0),(4898,7,4898,'2025-01-31 14:48:40',2,0),(4899,7,4899,'2025-01-31 14:48:40',2,0),(4900,7,4900,'2025-01-31 14:48:40',2,0),(4901,7,4901,'2025-01-31 14:48:40',2,0),(4902,7,4902,'2025-01-31 14:48:40',2,0),(4903,7,4903,'2025-01-31 14:48:40',2,0),(4904,7,4904,'2025-01-31 14:48:40',2,0),(4905,7,4905,'2025-01-31 14:48:40',2,0),(4906,7,4906,'2025-01-31 14:48:40',2,0),(4907,7,4907,'2025-01-31 14:48:40',2,0),(4908,7,4908,'2025-01-31 14:48:40',2,0),(4909,7,4909,'2025-01-31 14:48:40',2,0),(4910,7,4910,'2025-01-31 14:48:40',2,0),(4911,7,4911,'2025-01-31 14:48:40',2,0),(4912,7,4912,'2025-01-31 14:48:40',2,0),(4913,7,4913,'2025-01-31 14:48:40',2,0),(4914,7,4914,'2025-01-31 14:48:40',2,0),(4915,7,4915,'2025-01-31 14:48:40',2,0),(4916,7,4916,'2025-01-31 14:48:40',2,0),(4917,7,4917,'2025-01-31 14:48:40',2,0),(4918,7,4918,'2025-01-31 14:48:40',2,0),(4919,7,4919,'2025-01-31 14:48:40',2,0),(4920,7,4920,'2025-01-31 14:48:41',2,0),(4921,7,4921,'2025-01-31 14:48:41',2,0),(4922,7,4922,'2025-01-31 14:48:41',2,0),(4923,7,4923,'2025-01-31 14:48:41',2,0),(4924,7,4924,'2025-01-31 14:48:41',2,0),(4925,7,4925,'2025-01-31 14:48:41',2,0),(4926,7,4926,'2025-01-31 14:48:41',2,0),(4927,7,4927,'2025-01-31 14:48:41',2,0),(4928,7,4928,'2025-01-31 14:48:41',2,0),(4929,7,4929,'2025-01-31 14:48:41',2,0),(4930,7,4930,'2025-01-31 14:48:41',2,0),(4931,7,4931,'2025-01-31 14:48:41',2,0),(4932,7,4932,'2025-01-31 14:48:41',2,0),(4933,7,4933,'2025-01-31 14:48:41',2,0),(4934,7,4934,'2025-01-31 14:48:41',2,0),(4935,7,4935,'2025-01-31 14:48:41',2,0),(4936,7,4936,'2025-01-31 14:48:41',2,0),(4937,7,4937,'2025-01-31 14:48:41',2,0),(4938,7,4938,'2025-01-31 14:48:41',2,0),(4939,7,4939,'2025-01-31 14:48:41',2,0),(4940,7,4940,'2025-01-31 14:48:41',2,0),(4941,7,4941,'2025-01-31 14:48:41',2,0),(4942,7,4942,'2025-01-31 14:48:41',2,0),(4943,7,4943,'2025-01-31 14:48:41',2,0),(4944,7,4944,'2025-01-31 14:48:41',2,0),(4945,7,4945,'2025-01-31 14:48:41',2,0),(4946,7,4946,'2025-01-31 14:48:41',2,0),(4947,7,4947,'2025-01-31 14:48:41',2,0),(4948,7,4948,'2025-01-31 14:48:41',2,0),(4949,7,4949,'2025-01-31 14:48:41',2,0),(4950,7,4950,'2025-01-31 14:48:41',2,0),(4951,7,4951,'2025-01-31 14:48:41',2,0),(4952,7,4952,'2025-01-31 14:48:41',2,0),(4953,7,4953,'2025-01-31 14:48:41',2,0),(4954,7,4954,'2025-01-31 14:48:41',2,0),(4955,7,4955,'2025-01-31 14:48:41',2,0),(4956,7,4956,'2025-01-31 14:48:42',2,0),(4957,7,4957,'2025-01-31 14:48:42',2,0),(4958,7,4958,'2025-01-31 14:48:42',2,0),(4959,7,4959,'2025-01-31 14:48:42',2,0),(4960,7,4960,'2025-01-31 14:48:42',2,0),(4961,7,4961,'2025-01-31 14:48:42',2,0),(4962,7,4962,'2025-01-31 14:48:42',2,0),(4963,7,4963,'2025-01-31 14:48:42',2,0),(4964,7,4964,'2025-01-31 14:48:42',2,0),(4965,7,4965,'2025-01-31 14:48:42',2,0),(4966,7,4966,'2025-01-31 14:48:42',2,0),(4967,7,4967,'2025-01-31 14:48:42',2,0),(4968,7,4968,'2025-01-31 14:48:42',2,0),(4969,7,4969,'2025-01-31 14:48:42',2,0),(4970,7,4970,'2025-01-31 14:48:42',2,0),(4971,7,4971,'2025-01-31 14:48:42',2,0),(4972,7,4972,'2025-01-31 14:48:42',2,0),(4973,7,4973,'2025-01-31 14:48:42',2,0),(4974,7,4974,'2025-01-31 14:48:42',2,0),(4975,7,4975,'2025-01-31 14:48:42',2,0),(4976,7,4976,'2025-01-31 14:48:42',2,0),(4977,7,4977,'2025-01-31 14:48:42',2,0),(4978,7,4978,'2025-01-31 14:48:42',2,0),(4979,7,4979,'2025-01-31 14:48:42',2,0),(4980,7,4980,'2025-01-31 14:48:42',2,0),(4981,7,4981,'2025-01-31 14:48:42',2,0),(4982,7,4982,'2025-01-31 14:48:42',2,0),(4983,7,4983,'2025-01-31 14:48:42',2,0),(4984,7,4984,'2025-01-31 14:48:42',2,0),(4985,7,4985,'2025-01-31 14:48:42',2,0),(4986,7,4986,'2025-01-31 14:48:42',2,0),(4987,7,4987,'2025-01-31 14:48:42',2,0),(4988,7,4988,'2025-01-31 14:48:42',2,0),(4989,7,4989,'2025-01-31 14:48:42',2,0),(4990,7,4990,'2025-01-31 14:48:42',2,0),(4991,7,4991,'2025-01-31 14:48:42',2,0),(4992,7,4992,'2025-01-31 14:48:42',2,0),(4993,7,4993,'2025-01-31 14:48:42',2,0),(4994,7,4994,'2025-01-31 14:48:42',2,0),(4995,7,4995,'2025-01-31 14:48:42',2,0),(4996,7,4996,'2025-01-31 14:48:42',2,0),(4997,7,4997,'2025-01-31 14:48:43',2,0),(4998,7,4998,'2025-01-31 14:48:43',2,0),(4999,7,4999,'2025-01-31 14:48:43',2,0),(5000,7,5000,'2025-01-31 14:48:43',2,0),(5001,7,5001,'2025-01-31 14:48:43',2,0),(5002,7,5002,'2025-01-31 14:48:43',2,0),(5003,7,5003,'2025-01-31 14:48:43',2,0),(5004,7,5004,'2025-01-31 14:48:43',2,0),(5005,7,5005,'2025-01-31 14:48:43',2,0),(5006,7,5006,'2025-01-31 14:48:43',2,0),(5007,7,5007,'2025-01-31 14:48:43',2,0),(5008,7,5008,'2025-01-31 14:48:43',2,0),(5009,7,5009,'2025-01-31 14:48:43',2,0),(5010,7,5010,'2025-01-31 14:48:43',2,0),(5011,7,5011,'2025-01-31 14:48:43',2,0),(5012,7,5012,'2025-01-31 14:48:43',2,0),(5013,7,5013,'2025-01-31 14:48:43',2,0),(5014,7,5014,'2025-01-31 14:48:43',2,0),(5015,7,5015,'2025-01-31 14:48:43',2,0),(5016,7,5016,'2025-01-31 14:48:43',2,0),(5017,7,5017,'2025-01-31 14:48:43',2,0),(5018,7,5018,'2025-01-31 14:48:43',2,0),(5019,7,5019,'2025-01-31 14:48:43',2,0),(5020,7,5020,'2025-01-31 14:48:43',2,0),(5021,7,5021,'2025-01-31 14:48:43',2,0),(5022,7,5022,'2025-01-31 14:48:43',2,0),(5023,7,5023,'2025-01-31 14:48:43',2,0),(5024,7,5024,'2025-01-31 14:48:43',2,0),(5025,7,5025,'2025-01-31 14:48:43',2,0),(5026,7,5026,'2025-01-31 14:48:43',2,0),(5027,7,5027,'2025-01-31 14:48:43',2,0),(5028,7,5028,'2025-01-31 14:48:43',2,0),(5029,7,5029,'2025-01-31 14:48:43',2,0),(5030,7,5030,'2025-01-31 14:48:43',2,0),(5031,7,5031,'2025-01-31 14:48:43',2,0),(5032,7,5032,'2025-01-31 14:48:43',2,0),(5033,7,5033,'2025-01-31 14:48:43',2,0),(5034,7,5034,'2025-01-31 14:48:43',2,0),(5035,7,5035,'2025-01-31 14:48:43',2,0),(5036,7,5036,'2025-01-31 14:48:43',2,0),(5037,7,5037,'2025-01-31 14:48:43',2,0),(5038,7,5038,'2025-01-31 14:48:43',2,0),(5039,7,5039,'2025-01-31 14:48:43',2,0),(5040,7,5040,'2025-01-31 14:48:43',2,0),(5041,7,5041,'2025-01-31 14:48:44',2,0),(5042,7,5042,'2025-01-31 14:48:44',2,0),(5043,7,5043,'2025-01-31 14:48:44',2,0),(5044,7,5044,'2025-01-31 14:48:44',2,0),(5045,7,5045,'2025-01-31 14:48:44',2,0),(5046,7,5046,'2025-01-31 14:48:44',2,0),(5047,7,5047,'2025-01-31 14:48:44',2,0),(5048,7,5048,'2025-01-31 14:48:44',2,0),(5049,7,5049,'2025-01-31 14:48:44',2,0),(5050,7,5050,'2025-01-31 14:48:44',2,0),(5051,7,5051,'2025-01-31 14:48:44',2,0),(5052,7,5052,'2025-01-31 14:48:44',2,0),(5053,7,5053,'2025-01-31 14:48:44',2,0),(5054,7,5054,'2025-01-31 14:48:44',2,0),(5055,7,5055,'2025-01-31 14:48:44',2,0),(5056,7,5056,'2025-01-31 14:48:44',2,0),(5057,7,5057,'2025-01-31 14:48:44',2,0),(5058,7,5058,'2025-01-31 14:48:44',2,0),(5059,7,5059,'2025-01-31 14:48:44',2,0),(5060,7,5060,'2025-01-31 14:48:44',2,0),(5061,7,5061,'2025-01-31 14:48:44',2,0),(5062,7,5062,'2025-01-31 14:48:44',2,0),(5063,7,5063,'2025-01-31 14:48:44',2,0),(5064,7,5064,'2025-01-31 14:48:44',2,0),(5065,7,5065,'2025-01-31 14:48:44',2,0),(5066,7,5066,'2025-01-31 14:48:44',2,0),(5067,7,5067,'2025-01-31 14:48:44',2,0),(5068,7,5068,'2025-01-31 14:48:44',2,0),(5069,7,5069,'2025-01-31 14:48:44',2,0),(5070,7,5070,'2025-01-31 14:48:44',2,0),(5071,7,5071,'2025-01-31 14:48:44',2,0),(5072,7,5072,'2025-01-31 14:48:44',2,0),(5073,7,5073,'2025-01-31 14:48:44',2,0),(5074,7,5074,'2025-01-31 14:48:44',2,0),(5075,7,5075,'2025-01-31 14:48:44',2,0),(5076,7,5076,'2025-01-31 14:48:44',2,0),(5077,7,5077,'2025-01-31 14:48:44',2,0),(5078,7,5078,'2025-01-31 14:48:44',2,0),(5079,7,5079,'2025-01-31 14:48:44',2,0),(5080,7,5080,'2025-01-31 14:48:44',2,0),(5081,7,5081,'2025-01-31 14:48:44',2,0),(5082,7,5082,'2025-01-31 14:48:44',2,0),(5083,7,5083,'2025-01-31 14:48:44',2,0),(5084,7,5084,'2025-01-31 14:48:44',2,0),(5085,7,5085,'2025-01-31 14:48:44',2,0),(5086,7,5086,'2025-01-31 14:48:44',2,0),(5087,7,5087,'2025-01-31 14:48:45',2,0),(5088,7,5088,'2025-01-31 14:48:45',2,0),(5089,7,5089,'2025-01-31 14:48:45',2,0),(5090,7,5090,'2025-01-31 14:48:45',2,0),(5091,7,5091,'2025-01-31 14:48:45',2,0),(5092,7,5092,'2025-01-31 14:48:45',2,0),(5093,7,5093,'2025-01-31 14:48:45',2,0),(5094,7,5094,'2025-01-31 14:48:45',2,0),(5095,7,5095,'2025-01-31 14:48:45',2,0),(5096,7,5096,'2025-01-31 14:48:45',2,0),(5097,7,5097,'2025-01-31 14:48:45',2,0),(5098,7,5098,'2025-01-31 14:48:45',2,0),(5099,7,5099,'2025-01-31 14:48:45',2,0),(5100,7,5100,'2025-01-31 14:48:45',2,0),(5101,7,5101,'2025-01-31 14:48:45',2,0),(5102,7,5102,'2025-01-31 14:48:45',2,0),(5103,7,5103,'2025-01-31 14:48:45',2,0),(5104,7,5104,'2025-01-31 14:48:45',2,0),(5105,7,5105,'2025-01-31 14:48:45',2,0),(5106,7,5106,'2025-01-31 14:48:45',2,0),(5107,7,5107,'2025-01-31 14:48:45',2,0),(5108,7,5108,'2025-01-31 14:48:45',2,0),(5109,7,5109,'2025-01-31 14:48:45',2,0),(5110,7,5110,'2025-01-31 14:48:45',2,0),(5111,7,5111,'2025-01-31 14:48:45',2,0),(5112,7,5112,'2025-01-31 14:48:45',2,0),(5113,7,5113,'2025-01-31 14:48:45',2,0),(5114,7,5114,'2025-01-31 14:48:45',2,0),(5115,7,5115,'2025-01-31 14:48:45',2,0),(5116,7,5116,'2025-01-31 14:48:45',2,0),(5117,7,5117,'2025-01-31 14:48:45',2,0),(5118,7,5118,'2025-01-31 14:48:45',2,0),(5119,7,5119,'2025-01-31 14:48:45',2,0),(5120,7,5120,'2025-01-31 14:48:45',2,0),(5121,7,5121,'2025-01-31 14:48:45',2,0),(5122,7,5122,'2025-01-31 14:48:45',2,0),(5123,7,5123,'2025-01-31 14:48:45',2,0),(5124,7,5124,'2025-01-31 14:48:45',2,0),(5125,7,5125,'2025-01-31 14:48:45',2,0),(5126,7,5126,'2025-01-31 14:48:45',2,0),(5127,7,5127,'2025-01-31 14:48:45',2,0),(5128,7,5128,'2025-01-31 14:48:45',2,0),(5129,7,5129,'2025-01-31 14:48:45',2,0),(5130,7,5130,'2025-01-31 14:48:45',2,0),(5131,7,5131,'2025-01-31 14:48:45',2,0),(5132,7,5132,'2025-01-31 14:48:45',2,0),(5133,7,5133,'2025-01-31 14:48:46',2,0),(5134,7,5134,'2025-01-31 14:48:46',2,0),(5135,7,5135,'2025-01-31 14:48:46',2,0),(5136,7,5136,'2025-01-31 14:48:46',2,0),(5137,7,5137,'2025-01-31 14:48:46',2,0),(5138,7,5138,'2025-01-31 14:48:46',2,0),(5139,7,5139,'2025-01-31 14:48:46',2,0),(5140,7,5140,'2025-01-31 14:48:46',2,0),(5141,7,5141,'2025-01-31 14:48:46',2,0),(5142,7,5142,'2025-01-31 14:48:46',2,0),(5143,7,5143,'2025-01-31 14:48:46',2,0),(5144,7,5144,'2025-01-31 14:48:46',2,0),(5145,7,5145,'2025-01-31 14:48:46',2,0),(5146,7,5146,'2025-01-31 14:48:46',2,0),(5147,7,5147,'2025-01-31 14:48:46',2,0),(5148,7,5148,'2025-01-31 14:48:46',2,0),(5149,7,5149,'2025-01-31 14:48:46',2,0),(5150,7,5150,'2025-01-31 14:48:46',2,0),(5151,7,5151,'2025-01-31 14:48:46',2,0),(5152,7,5152,'2025-01-31 14:48:46',2,0),(5153,7,5153,'2025-01-31 14:48:46',2,0),(5154,7,5154,'2025-01-31 14:48:46',2,0),(5155,7,5155,'2025-01-31 14:48:46',2,0),(5156,7,5156,'2025-01-31 14:48:46',2,0),(5157,7,5157,'2025-01-31 14:48:46',2,0),(5158,7,5158,'2025-01-31 14:48:46',2,0),(5159,7,5159,'2025-01-31 14:48:46',2,0),(5160,7,5160,'2025-01-31 14:48:46',2,0),(5161,7,5161,'2025-01-31 14:48:46',2,0),(5162,7,5162,'2025-01-31 14:48:46',2,0),(5163,7,5163,'2025-01-31 14:48:46',2,0),(5164,7,5164,'2025-01-31 14:48:46',2,0),(5165,7,5165,'2025-01-31 14:48:46',2,0),(5166,7,5166,'2025-01-31 14:48:46',2,0),(5167,7,5167,'2025-01-31 14:48:46',2,0),(5168,7,5168,'2025-01-31 14:48:46',2,0),(5169,7,5169,'2025-01-31 14:48:46',2,0),(5170,7,5170,'2025-01-31 14:48:46',2,0),(5171,7,5171,'2025-01-31 14:48:46',2,0),(5172,7,5172,'2025-01-31 14:48:46',2,0),(5173,7,5173,'2025-01-31 14:48:46',2,0),(5174,7,5174,'2025-01-31 14:48:47',2,0),(5175,7,5175,'2025-01-31 14:48:47',2,0),(5176,7,5176,'2025-01-31 14:48:47',2,0),(5177,7,5177,'2025-01-31 14:48:47',2,0),(5178,7,5178,'2025-01-31 14:48:47',2,0),(5179,7,5179,'2025-01-31 14:48:47',2,0),(5180,7,5180,'2025-01-31 14:48:47',2,0),(5181,7,5181,'2025-01-31 14:48:47',2,0),(5182,7,5182,'2025-01-31 14:48:47',2,0),(5183,7,5183,'2025-01-31 14:48:47',2,0),(5184,7,5184,'2025-01-31 14:48:47',2,0),(5185,7,5185,'2025-01-31 14:48:47',2,0),(5186,7,5186,'2025-01-31 14:48:47',2,0),(5187,7,5187,'2025-01-31 14:48:47',2,0),(5188,7,5188,'2025-01-31 14:48:47',2,0),(5189,7,5189,'2025-01-31 14:48:47',2,0),(5190,7,5190,'2025-01-31 14:48:47',2,0),(5191,7,5191,'2025-01-31 14:48:47',2,0),(5192,7,5192,'2025-01-31 14:48:47',2,0),(5193,7,5193,'2025-01-31 14:48:47',2,0),(5194,7,5194,'2025-01-31 14:48:47',2,0),(5195,7,5195,'2025-01-31 14:48:47',2,0),(5196,7,5196,'2025-01-31 14:48:47',2,0),(5197,7,5197,'2025-01-31 14:48:47',2,0),(5198,7,5198,'2025-01-31 14:48:47',2,0),(5199,7,5199,'2025-01-31 14:48:47',2,0),(5200,7,5200,'2025-01-31 14:48:47',2,0),(5201,7,5201,'2025-01-31 14:48:47',2,0),(5202,7,5202,'2025-01-31 14:48:47',2,0),(5203,7,5203,'2025-01-31 14:48:47',2,0),(5204,7,5204,'2025-01-31 14:48:47',2,0),(5205,7,5205,'2025-01-31 14:48:47',2,0),(5206,7,5206,'2025-01-31 14:48:47',2,0),(5207,7,5207,'2025-01-31 14:48:47',2,0),(5208,7,5208,'2025-01-31 14:48:47',2,0),(5209,7,5209,'2025-01-31 14:48:47',2,0),(5210,7,5210,'2025-01-31 14:48:47',2,0),(5211,7,5211,'2025-01-31 14:48:47',2,0),(5212,7,5212,'2025-01-31 14:48:47',2,0),(5213,7,5213,'2025-01-31 14:48:47',2,0),(5214,7,5214,'2025-01-31 14:48:47',2,0),(5215,7,5215,'2025-01-31 14:48:47',2,0),(5216,7,5216,'2025-01-31 14:48:47',2,0),(5217,7,5217,'2025-01-31 14:48:47',2,0),(5218,7,5218,'2025-01-31 14:48:47',2,0),(5219,7,5219,'2025-01-31 14:48:47',2,0),(5220,7,5220,'2025-01-31 14:48:47',2,0),(5221,7,5221,'2025-01-31 14:48:48',2,0),(5222,7,5222,'2025-01-31 14:48:48',2,0),(5223,7,5223,'2025-01-31 14:48:48',2,0),(5224,7,5224,'2025-01-31 14:48:48',2,0),(5225,7,5225,'2025-01-31 14:48:48',2,0),(5226,7,5226,'2025-01-31 14:48:48',2,0),(5227,7,5227,'2025-01-31 14:48:48',2,0),(5228,7,5228,'2025-01-31 14:48:48',2,0),(5229,7,5229,'2025-01-31 14:48:48',2,0),(5230,7,5230,'2025-01-31 14:48:48',2,0),(5231,7,5231,'2025-01-31 14:48:48',2,0),(5232,7,5232,'2025-01-31 14:48:48',2,0),(5233,7,5233,'2025-01-31 14:48:48',2,0),(5234,7,5234,'2025-01-31 14:48:48',2,0),(5235,7,5235,'2025-01-31 14:48:49',2,0),(5236,7,5236,'2025-01-31 14:48:49',2,0),(5237,7,5237,'2025-01-31 14:48:49',2,0),(5238,7,5238,'2025-01-31 14:48:49',2,0),(5239,7,5239,'2025-01-31 14:48:49',2,0),(5240,7,5240,'2025-01-31 14:48:49',2,0),(5241,7,5241,'2025-01-31 14:48:49',2,0),(5242,7,5242,'2025-01-31 14:48:49',2,0),(5243,7,5243,'2025-01-31 14:48:49',2,0),(5244,7,5244,'2025-01-31 14:48:49',2,0),(5245,7,5245,'2025-01-31 14:48:49',2,0),(5246,7,5246,'2025-01-31 14:48:49',2,0),(5247,7,5247,'2025-01-31 14:48:49',2,0),(5248,7,5248,'2025-01-31 14:48:50',2,0),(5249,7,5249,'2025-01-31 14:48:50',2,0),(5250,7,5250,'2025-01-31 14:48:50',2,0),(5251,7,5251,'2025-01-31 14:48:50',2,0),(5252,7,5252,'2025-01-31 14:48:50',2,0),(5253,7,5253,'2025-01-31 14:48:50',2,0),(5254,7,5254,'2025-01-31 14:48:50',2,0),(5255,7,5255,'2025-01-31 14:48:50',2,0),(5256,7,5256,'2025-01-31 14:48:50',2,0),(5257,7,5257,'2025-01-31 14:48:50',2,0),(5258,7,5258,'2025-01-31 14:48:50',2,0),(5259,7,5259,'2025-01-31 14:48:50',2,0),(5260,7,5260,'2025-01-31 14:48:50',2,0),(5261,7,5261,'2025-01-31 14:48:50',2,0),(5262,7,5262,'2025-01-31 14:48:50',2,0),(5263,7,5263,'2025-01-31 14:48:50',2,0),(5264,7,5264,'2025-01-31 14:48:50',2,0),(5265,7,5265,'2025-01-31 14:48:50',2,0),(5266,7,5266,'2025-01-31 14:48:50',2,0),(5267,7,5267,'2025-01-31 14:48:51',2,0),(5268,7,5268,'2025-01-31 14:48:51',2,0),(5269,7,5269,'2025-01-31 14:48:51',2,0),(5270,7,5270,'2025-01-31 14:48:51',2,0),(5271,7,5271,'2025-01-31 14:48:51',2,0),(5272,7,5272,'2025-01-31 14:48:51',2,0),(5273,7,5273,'2025-01-31 14:48:51',2,0),(5274,7,5274,'2025-01-31 14:48:51',2,0),(5275,7,5275,'2025-01-31 14:48:51',2,0),(5276,7,5276,'2025-01-31 14:48:51',2,0),(5277,7,5277,'2025-01-31 14:48:51',2,0),(5278,7,5278,'2025-01-31 14:48:51',2,0),(5279,7,5279,'2025-01-31 14:48:51',2,0),(5280,7,5280,'2025-01-31 14:48:51',2,0),(5281,7,5281,'2025-01-31 14:48:51',2,0),(5282,7,5282,'2025-01-31 14:48:51',2,0),(5283,7,5283,'2025-01-31 14:48:52',2,0),(5284,7,5284,'2025-01-31 14:48:52',2,0),(5285,7,5285,'2025-01-31 14:48:52',2,0),(5286,7,5286,'2025-01-31 14:48:52',2,0),(5287,7,5287,'2025-01-31 14:48:52',2,0),(5288,7,5288,'2025-01-31 14:48:52',2,0),(5289,7,5289,'2025-01-31 14:48:52',2,0),(5290,7,5290,'2025-01-31 14:48:52',2,0),(5291,7,5291,'2025-01-31 14:48:52',2,0),(5292,7,5292,'2025-01-31 14:48:52',2,0),(5293,7,5293,'2025-01-31 14:48:52',2,0),(5294,7,5294,'2025-01-31 14:48:52',2,0),(5295,7,5295,'2025-01-31 14:48:52',2,0),(5296,7,5296,'2025-01-31 14:48:52',2,0),(5297,7,5297,'2025-01-31 14:48:52',2,0),(5298,7,5298,'2025-01-31 14:48:52',2,0),(5299,7,5299,'2025-01-31 14:48:52',2,0),(5300,7,5300,'2025-01-31 14:48:52',2,0),(5301,7,5301,'2025-01-31 14:48:53',2,0),(5302,7,5302,'2025-01-31 14:48:53',2,0),(5303,7,5303,'2025-01-31 14:48:53',2,0),(5304,7,5304,'2025-01-31 14:48:53',2,0),(5305,7,5305,'2025-01-31 14:48:53',2,0),(5306,7,5306,'2025-01-31 14:48:53',2,0),(5307,7,5307,'2025-01-31 14:48:53',2,0),(5308,7,5308,'2025-01-31 14:48:53',2,0),(5309,7,5309,'2025-01-31 14:48:53',2,0),(5310,7,5310,'2025-01-31 14:48:53',2,0),(5311,7,5311,'2025-01-31 14:48:53',2,0),(5312,7,5312,'2025-01-31 14:48:53',2,0),(5313,7,5313,'2025-01-31 14:48:53',2,0),(5314,7,5314,'2025-01-31 14:48:53',2,0),(5315,7,5315,'2025-01-31 14:48:53',2,0),(5316,7,5316,'2025-01-31 14:48:53',2,0),(5317,7,5317,'2025-01-31 14:48:53',2,0),(5318,7,5318,'2025-01-31 14:48:53',2,0),(5319,7,5319,'2025-01-31 14:48:53',2,0),(5320,7,5320,'2025-01-31 14:48:53',2,0),(5321,7,5321,'2025-01-31 14:48:53',2,0),(5322,7,5322,'2025-01-31 14:48:54',2,0),(5323,7,5323,'2025-01-31 14:48:54',2,0),(5324,7,5324,'2025-01-31 14:48:54',2,0),(5325,7,5325,'2025-01-31 14:48:54',2,0),(5326,7,5326,'2025-01-31 14:48:54',2,0),(5327,7,5327,'2025-01-31 14:48:54',2,0),(5328,7,5328,'2025-01-31 14:48:54',2,0),(5329,7,5329,'2025-01-31 14:48:54',2,0),(5330,7,5330,'2025-01-31 14:48:54',2,0),(5331,7,5331,'2025-01-31 14:48:54',2,0),(5332,7,5332,'2025-01-31 14:48:54',2,0),(5333,7,5333,'2025-01-31 14:48:54',2,0),(5334,7,5334,'2025-01-31 14:48:54',2,0),(5335,7,5335,'2025-01-31 14:48:54',2,0),(5336,7,5336,'2025-01-31 14:48:54',2,0),(5337,7,5337,'2025-01-31 14:48:54',2,0),(5338,7,5338,'2025-01-31 14:48:54',2,0),(5339,7,5339,'2025-01-31 14:48:54',2,0),(5340,7,5340,'2025-01-31 14:48:54',2,0),(5341,7,5341,'2025-01-31 14:48:54',2,0),(5342,7,5342,'2025-01-31 14:48:54',2,0),(5343,7,5343,'2025-01-31 14:48:54',2,0),(5344,7,5344,'2025-01-31 14:48:54',2,0),(5345,7,5345,'2025-01-31 14:48:54',2,0),(5346,7,5346,'2025-01-31 14:48:54',2,0),(5347,7,5347,'2025-01-31 14:48:54',2,0),(5348,7,5348,'2025-01-31 14:48:54',2,0),(5349,7,5349,'2025-01-31 14:48:54',2,0),(5350,7,5350,'2025-01-31 14:48:54',2,0),(5351,7,5351,'2025-01-31 14:48:55',2,0),(5352,7,5352,'2025-01-31 14:48:55',2,0),(5353,7,5353,'2025-01-31 14:48:55',2,0),(5354,7,5354,'2025-01-31 14:48:55',2,0),(5355,7,5355,'2025-01-31 14:48:55',2,0),(5356,7,5356,'2025-01-31 14:48:55',2,0),(5357,7,5357,'2025-01-31 14:48:55',2,0),(5358,7,5358,'2025-01-31 14:48:55',2,0),(5359,7,5359,'2025-01-31 14:48:55',2,0),(5360,7,5360,'2025-01-31 14:48:55',2,0),(5361,7,5361,'2025-01-31 14:48:55',2,0),(5362,7,5362,'2025-01-31 14:48:55',2,0),(5363,7,5363,'2025-01-31 14:48:55',2,0),(5364,7,5364,'2025-01-31 14:48:55',2,0),(5365,7,5365,'2025-01-31 14:48:55',2,0),(5366,7,5366,'2025-01-31 14:48:55',2,0),(5367,7,5367,'2025-01-31 14:48:55',2,0),(5368,7,5368,'2025-01-31 14:48:55',2,0),(5369,7,5369,'2025-01-31 14:48:55',2,0),(5370,7,5370,'2025-01-31 14:48:55',2,0),(5371,7,5371,'2025-01-31 14:48:55',2,0),(5372,7,5372,'2025-01-31 14:48:55',2,0),(5373,7,5373,'2025-01-31 14:48:55',2,0),(5374,7,5374,'2025-01-31 14:48:55',2,0),(5375,7,5375,'2025-01-31 14:48:55',2,0),(5376,7,5376,'2025-01-31 14:48:55',2,0),(5377,7,5377,'2025-01-31 14:48:55',2,0),(5378,7,5378,'2025-01-31 14:48:55',2,0),(5379,7,5379,'2025-01-31 14:48:55',2,0),(5380,7,5380,'2025-01-31 14:48:55',2,0),(5381,7,5381,'2025-01-31 14:48:55',2,0),(5382,7,5382,'2025-01-31 14:48:55',2,0),(5383,7,5383,'2025-01-31 14:48:55',2,0),(5384,7,5384,'2025-01-31 14:48:55',2,0),(5385,7,5385,'2025-01-31 14:48:55',2,0),(5386,7,5386,'2025-01-31 14:48:55',2,0),(5387,7,5387,'2025-01-31 14:48:56',2,0),(5388,7,5388,'2025-01-31 14:48:56',2,0),(5389,7,5389,'2025-01-31 14:48:56',2,0),(5390,7,5390,'2025-01-31 14:48:56',2,0),(5391,7,5391,'2025-01-31 14:48:56',2,0),(5392,7,5392,'2025-01-31 14:48:56',2,0),(5393,7,5393,'2025-01-31 14:48:56',2,0),(5394,7,5394,'2025-01-31 14:48:56',2,0),(5395,7,5395,'2025-01-31 14:48:56',2,0),(5396,7,5396,'2025-01-31 14:48:56',2,0),(5397,7,5397,'2025-01-31 14:48:56',2,0),(5398,7,5398,'2025-01-31 14:48:56',2,0),(5399,7,5399,'2025-01-31 14:48:56',2,0),(5400,7,5400,'2025-01-31 14:48:56',2,0),(5401,7,5401,'2025-01-31 14:48:56',2,0),(5402,7,5402,'2025-01-31 14:48:56',2,0),(5403,7,5403,'2025-01-31 14:48:56',2,0),(5404,7,5404,'2025-01-31 14:48:56',2,0),(5405,7,5405,'2025-01-31 14:48:56',2,0),(5406,7,5406,'2025-01-31 14:48:56',2,0),(5407,7,5407,'2025-01-31 14:48:56',2,0),(5408,7,5408,'2025-01-31 14:48:56',2,0),(5409,7,5409,'2025-01-31 14:48:56',2,0),(5410,7,5410,'2025-01-31 14:48:56',2,0),(5411,7,5411,'2025-01-31 14:48:56',2,0),(5412,7,5412,'2025-01-31 14:48:56',2,0),(5413,7,5413,'2025-01-31 14:48:56',2,0),(5414,7,5414,'2025-01-31 14:48:56',2,0),(5415,7,5415,'2025-01-31 14:48:56',2,0),(5416,7,5416,'2025-01-31 14:48:56',2,0),(5417,7,5417,'2025-01-31 14:48:56',2,0),(5418,7,5418,'2025-01-31 14:48:56',2,0),(5419,7,5419,'2025-01-31 14:48:56',2,0),(5420,7,5420,'2025-01-31 14:48:56',2,0),(5421,7,5421,'2025-01-31 14:48:56',2,0),(5422,7,5422,'2025-01-31 14:48:56',2,0),(5423,7,5423,'2025-01-31 14:48:56',2,0),(5424,7,5424,'2025-01-31 14:48:56',2,0),(5425,7,5425,'2025-01-31 14:48:56',2,0),(5426,7,5426,'2025-01-31 14:48:57',2,0),(5427,7,5427,'2025-01-31 14:48:57',2,0),(5428,7,5428,'2025-01-31 14:48:57',2,0),(5429,7,5429,'2025-01-31 14:48:57',2,0),(5430,7,5430,'2025-01-31 14:48:57',2,0),(5431,7,5431,'2025-01-31 14:48:57',2,0),(5432,7,5432,'2025-01-31 14:48:57',2,0),(5433,7,5433,'2025-01-31 14:48:57',2,0),(5434,7,5434,'2025-01-31 14:48:57',2,0),(5435,7,5435,'2025-01-31 14:48:57',2,0),(5436,7,5436,'2025-01-31 14:48:57',2,0),(5437,7,5437,'2025-01-31 14:48:57',2,0),(5438,7,5438,'2025-01-31 14:48:57',2,0),(5439,7,5439,'2025-01-31 14:48:57',2,0),(5440,7,5440,'2025-01-31 14:48:57',2,0),(5441,7,5441,'2025-01-31 14:48:57',2,0),(5442,7,5442,'2025-01-31 14:48:57',2,0),(5443,7,5443,'2025-01-31 14:48:57',2,0),(5444,7,5444,'2025-01-31 14:48:57',2,0),(5445,7,5445,'2025-01-31 14:48:57',2,0),(5446,7,5446,'2025-01-31 14:48:57',2,0),(5447,7,5447,'2025-01-31 14:48:57',2,0),(5448,7,5448,'2025-01-31 14:48:57',2,0),(5449,7,5449,'2025-01-31 14:48:57',2,0),(5450,7,5450,'2025-01-31 14:48:57',2,0),(5451,7,5451,'2025-01-31 14:48:57',2,0),(5452,7,5452,'2025-01-31 14:48:57',2,0),(5453,7,5453,'2025-01-31 14:48:57',2,0),(5454,7,5454,'2025-01-31 14:48:57',2,0),(5455,7,5455,'2025-01-31 14:48:57',2,0),(5456,7,5456,'2025-01-31 14:48:57',2,0),(5457,7,5457,'2025-01-31 14:48:57',2,0),(5458,7,5458,'2025-01-31 14:48:57',2,0),(5459,7,5459,'2025-01-31 14:48:57',2,0),(5460,7,5460,'2025-01-31 14:48:57',2,0),(5461,7,5461,'2025-01-31 14:48:57',2,0),(5462,7,5462,'2025-01-31 14:48:57',2,0),(5463,7,5463,'2025-01-31 14:48:58',2,0),(5464,7,5464,'2025-01-31 14:48:58',2,0),(5465,7,5465,'2025-01-31 14:48:58',2,0),(5466,7,5466,'2025-01-31 14:48:58',2,0),(5467,7,5467,'2025-01-31 14:48:58',2,0),(5468,7,5468,'2025-01-31 14:48:58',2,0),(5469,7,5469,'2025-01-31 14:48:58',2,0),(5470,7,5470,'2025-01-31 14:48:58',2,0),(5471,7,5471,'2025-01-31 14:48:58',2,0),(5472,7,5472,'2025-01-31 14:48:58',2,0),(5473,7,5473,'2025-01-31 14:48:58',2,0),(5474,7,5474,'2025-01-31 14:48:58',2,0),(5475,7,5475,'2025-01-31 14:48:58',2,0),(5476,7,5476,'2025-01-31 14:48:58',2,0),(5477,7,5477,'2025-01-31 14:48:58',2,0),(5478,7,5478,'2025-01-31 14:48:58',2,0),(5479,7,5479,'2025-01-31 14:48:58',2,0),(5480,7,5480,'2025-01-31 14:48:58',2,0),(5481,7,5481,'2025-01-31 14:48:58',2,0),(5482,7,5482,'2025-01-31 14:48:58',2,0),(5483,7,5483,'2025-01-31 14:48:58',2,0),(5484,7,5484,'2025-01-31 14:48:58',2,0),(5485,7,5485,'2025-01-31 14:48:58',2,0),(5486,7,5486,'2025-01-31 14:48:58',2,0),(5487,7,5487,'2025-01-31 14:48:58',2,0),(5488,7,5488,'2025-01-31 14:48:58',2,0),(5489,7,5489,'2025-01-31 14:48:58',2,0),(5490,7,5490,'2025-01-31 14:48:58',2,0),(5491,7,5491,'2025-01-31 14:48:58',2,0),(5492,7,5492,'2025-01-31 14:48:58',2,0),(5493,7,5493,'2025-01-31 14:48:58',2,0),(5494,7,5494,'2025-01-31 14:48:58',2,0),(5495,7,5495,'2025-01-31 14:48:58',2,0),(5496,7,5496,'2025-01-31 14:48:58',2,0),(5497,7,5497,'2025-01-31 14:48:58',2,0),(5498,7,5498,'2025-01-31 14:48:58',2,0),(5499,7,5499,'2025-01-31 14:48:58',2,0),(5500,7,5500,'2025-01-31 14:48:58',2,0),(5501,7,5501,'2025-01-31 14:48:58',2,0),(5502,7,5502,'2025-01-31 14:48:59',2,0),(5503,7,5503,'2025-01-31 14:48:59',2,0),(5504,7,5504,'2025-01-31 14:48:59',2,0),(5505,7,5505,'2025-01-31 14:48:59',2,0),(5506,7,5506,'2025-01-31 14:48:59',2,0),(5507,7,5507,'2025-01-31 14:48:59',2,0),(5508,7,5508,'2025-01-31 14:48:59',2,0),(5509,7,5509,'2025-01-31 14:48:59',2,0),(5510,7,5510,'2025-01-31 14:48:59',2,0),(5511,7,5511,'2025-01-31 14:48:59',2,0),(5512,7,5512,'2025-01-31 14:48:59',2,0),(5513,7,5513,'2025-01-31 14:48:59',2,0),(5514,7,5514,'2025-01-31 14:48:59',2,0),(5515,7,5515,'2025-01-31 14:48:59',2,0),(5516,7,5516,'2025-01-31 14:48:59',2,0),(5517,7,5517,'2025-01-31 14:48:59',2,0),(5518,7,5518,'2025-01-31 14:48:59',2,0),(5519,7,5519,'2025-01-31 14:48:59',2,0),(5520,7,5520,'2025-01-31 14:48:59',2,0),(5521,7,5521,'2025-01-31 14:48:59',2,0),(5522,7,5522,'2025-01-31 14:48:59',2,0),(5523,7,5523,'2025-01-31 14:48:59',2,0),(5524,7,5524,'2025-01-31 14:48:59',2,0),(5525,7,5525,'2025-01-31 14:48:59',2,0),(5526,7,5526,'2025-01-31 14:48:59',2,0),(5527,7,5527,'2025-01-31 14:48:59',2,0),(5528,7,5528,'2025-01-31 14:48:59',2,0),(5529,7,5529,'2025-01-31 14:48:59',2,0),(5530,7,5530,'2025-01-31 14:48:59',2,0),(5531,7,5531,'2025-01-31 14:48:59',2,0),(5532,7,5532,'2025-01-31 14:48:59',2,0),(5533,7,5533,'2025-01-31 14:48:59',2,0),(5534,7,5534,'2025-01-31 14:48:59',2,0),(5535,7,5535,'2025-01-31 14:48:59',2,0),(5536,7,5536,'2025-01-31 14:48:59',2,0),(5537,7,5537,'2025-01-31 14:48:59',2,0),(5538,7,5538,'2025-01-31 14:48:59',2,0),(5539,7,5539,'2025-01-31 14:48:59',2,0),(5540,7,5540,'2025-01-31 14:48:59',2,0),(5541,7,5541,'2025-01-31 14:49:00',2,0),(5542,7,5542,'2025-01-31 14:49:00',2,0),(5543,7,5543,'2025-01-31 14:49:00',2,0),(5544,7,5544,'2025-01-31 14:49:00',2,0),(5545,7,5545,'2025-01-31 14:49:00',2,0),(5546,7,5546,'2025-01-31 14:49:00',2,0),(5547,7,5547,'2025-01-31 14:49:00',2,0),(5548,7,5548,'2025-01-31 14:49:00',2,0),(5549,7,5549,'2025-01-31 14:49:00',2,0),(5550,7,5550,'2025-01-31 14:49:00',2,0),(5551,7,5551,'2025-01-31 14:49:00',2,0),(5552,7,5552,'2025-01-31 14:49:00',2,0),(5553,7,5553,'2025-01-31 14:49:00',2,0),(5554,7,5554,'2025-01-31 14:49:00',2,0),(5555,7,5555,'2025-01-31 14:49:00',2,0),(5556,7,5556,'2025-01-31 14:49:00',2,0),(5557,7,5557,'2025-01-31 14:49:00',2,0),(5558,7,5558,'2025-01-31 14:49:00',2,0),(5559,7,5559,'2025-01-31 14:49:00',2,0),(5560,7,5560,'2025-01-31 14:49:00',2,0),(5561,7,5561,'2025-01-31 14:49:00',2,0),(5562,7,5562,'2025-01-31 14:49:00',2,0),(5563,7,5563,'2025-01-31 14:49:00',2,0),(5564,7,5564,'2025-01-31 14:49:00',2,0),(5565,7,5565,'2025-01-31 14:49:00',2,0),(5566,7,5566,'2025-01-31 14:49:00',2,0),(5567,7,5567,'2025-01-31 14:49:00',2,0),(5568,7,5568,'2025-01-31 14:49:00',2,0),(5569,7,5569,'2025-01-31 14:49:00',2,0),(5570,7,5570,'2025-01-31 14:49:00',2,0),(5571,7,5571,'2025-01-31 14:49:00',2,0),(5572,7,5572,'2025-01-31 14:49:00',2,0),(5573,7,5573,'2025-01-31 14:49:00',2,0),(5574,7,5574,'2025-01-31 14:49:00',2,0),(5575,7,5575,'2025-01-31 14:49:00',2,0),(5576,7,5576,'2025-01-31 14:49:00',2,0),(5577,7,5577,'2025-01-31 14:49:00',2,0),(5578,7,5578,'2025-01-31 14:49:00',2,0),(5579,7,5579,'2025-01-31 14:49:00',2,0),(5580,7,5580,'2025-01-31 14:49:00',2,0),(5581,7,5581,'2025-01-31 14:49:01',2,0),(5582,7,5582,'2025-01-31 14:49:01',2,0),(5583,7,5583,'2025-01-31 14:49:01',2,0),(5584,7,5584,'2025-01-31 14:49:01',2,0),(5585,7,5585,'2025-01-31 14:49:01',2,0),(5586,7,5586,'2025-01-31 14:49:01',2,0),(5587,7,5587,'2025-01-31 14:49:01',2,0),(5588,7,5588,'2025-01-31 14:49:01',2,0),(5589,7,5589,'2025-01-31 14:49:01',2,0),(5590,7,5590,'2025-01-31 14:49:01',2,0),(5591,7,5591,'2025-01-31 14:49:01',2,0),(5592,7,5592,'2025-01-31 14:49:01',2,0),(5593,7,5593,'2025-01-31 14:49:01',2,0),(5594,7,5594,'2025-01-31 14:49:01',2,0),(5595,7,5595,'2025-01-31 14:49:01',2,0),(5596,7,5596,'2025-01-31 14:49:01',2,0),(5597,7,5597,'2025-01-31 14:49:01',2,0),(5598,7,5598,'2025-01-31 14:49:01',2,0),(5599,7,5599,'2025-01-31 14:49:01',2,0),(5600,7,5600,'2025-01-31 14:49:01',2,0),(5601,7,5601,'2025-01-31 14:49:01',2,0),(5602,7,5602,'2025-01-31 14:49:01',2,0),(5603,7,5603,'2025-01-31 14:49:01',2,0),(5604,7,5604,'2025-01-31 14:49:01',2,0),(5605,7,5605,'2025-01-31 14:49:01',2,0),(5606,7,5606,'2025-01-31 14:49:01',2,0),(5607,7,5607,'2025-01-31 14:49:01',2,0),(5608,7,5608,'2025-01-31 14:49:01',2,0),(5609,7,5609,'2025-01-31 14:49:01',2,0),(5610,7,5610,'2025-01-31 14:49:01',2,0),(5611,7,5611,'2025-01-31 14:49:01',2,0),(5612,7,5612,'2025-01-31 14:49:01',2,0),(5613,7,5613,'2025-01-31 14:49:01',2,0),(5614,7,5614,'2025-01-31 14:49:01',2,0),(5615,7,5615,'2025-01-31 14:49:02',2,0),(5616,7,5616,'2025-01-31 14:49:02',2,0),(5617,7,5617,'2025-01-31 14:49:02',2,0),(5618,7,5618,'2025-01-31 14:49:02',2,0),(5619,7,5619,'2025-01-31 14:49:02',2,0),(5620,7,5620,'2025-01-31 14:49:02',2,0),(5621,7,5621,'2025-01-31 14:49:02',2,0),(5622,7,5622,'2025-01-31 14:49:02',2,0),(5623,7,5623,'2025-01-31 14:49:02',2,0),(5624,7,5624,'2025-01-31 14:49:02',2,0),(5625,7,5625,'2025-01-31 14:49:02',2,0),(5626,7,5626,'2025-01-31 14:49:02',2,0),(5627,7,5627,'2025-01-31 14:49:02',2,0),(5628,7,5628,'2025-01-31 14:49:02',2,0),(5629,7,5629,'2025-01-31 14:49:02',2,0),(5630,7,5630,'2025-01-31 14:49:02',2,0),(5631,7,5631,'2025-01-31 14:49:02',2,0),(5632,7,5632,'2025-01-31 14:49:02',2,0),(5633,7,5633,'2025-01-31 14:49:02',2,0),(5634,7,5634,'2025-01-31 14:49:02',2,0),(5635,7,5635,'2025-01-31 14:49:02',2,0),(5636,7,5636,'2025-01-31 14:49:02',2,0),(5637,7,5637,'2025-01-31 14:49:02',2,0),(5638,7,5638,'2025-01-31 14:49:02',2,0),(5639,7,5639,'2025-01-31 14:49:02',2,0),(5640,7,5640,'2025-01-31 14:49:02',2,0),(5641,7,5641,'2025-01-31 14:49:02',2,0),(5642,7,5642,'2025-01-31 14:49:02',2,0),(5643,7,5643,'2025-01-31 14:49:02',2,0),(5644,7,5644,'2025-01-31 14:49:02',2,0),(5645,7,5645,'2025-01-31 14:49:02',2,0),(5646,7,5646,'2025-01-31 14:49:02',2,0),(5647,7,5647,'2025-01-31 14:49:02',2,0),(5648,7,5648,'2025-01-31 14:49:02',2,0),(5649,7,5649,'2025-01-31 14:49:02',2,0),(5650,7,5650,'2025-01-31 14:49:02',2,0),(5651,7,5651,'2025-01-31 14:49:02',2,0),(5652,7,5652,'2025-01-31 14:49:03',2,0),(5653,7,5653,'2025-01-31 14:49:03',2,0),(5654,7,5654,'2025-01-31 14:49:03',2,0),(5655,7,5655,'2025-01-31 14:49:03',2,0),(5656,7,5656,'2025-01-31 14:49:03',2,0),(5657,7,5657,'2025-01-31 14:49:03',2,0),(5658,7,5658,'2025-01-31 14:49:03',2,0),(5659,7,5659,'2025-01-31 14:49:03',2,0),(5660,7,5660,'2025-01-31 14:49:03',2,0),(5661,7,5661,'2025-01-31 14:49:03',2,0),(5662,7,5662,'2025-01-31 14:49:03',2,0),(5663,7,5663,'2025-01-31 14:49:03',2,0),(5664,7,5664,'2025-01-31 14:49:03',2,0),(5665,7,5665,'2025-01-31 14:49:03',2,0),(5666,7,5666,'2025-01-31 14:49:03',2,0),(5667,7,5667,'2025-01-31 14:49:03',2,0),(5668,7,5668,'2025-01-31 14:49:03',2,0),(5669,7,5669,'2025-01-31 14:49:03',2,0),(5670,7,5670,'2025-01-31 14:49:03',2,0),(5671,7,5671,'2025-01-31 14:49:03',2,0),(5672,7,5672,'2025-01-31 14:49:03',2,0),(5673,7,5673,'2025-01-31 14:49:03',2,0),(5674,7,5674,'2025-01-31 14:49:03',2,0),(5675,7,5675,'2025-01-31 14:49:03',2,0),(5676,7,5676,'2025-01-31 14:49:03',2,0),(5677,7,5677,'2025-01-31 14:49:03',2,0),(5678,7,5678,'2025-01-31 14:49:03',2,0),(5679,7,5679,'2025-01-31 14:49:03',2,0),(5680,7,5680,'2025-01-31 14:49:03',2,0),(5681,7,5681,'2025-01-31 14:49:03',2,0),(5682,7,5682,'2025-01-31 14:49:03',2,0),(5683,7,5683,'2025-01-31 14:49:03',2,0),(5684,7,5684,'2025-01-31 14:49:03',2,0),(5685,7,5685,'2025-01-31 14:49:03',2,0),(5686,7,5686,'2025-01-31 14:49:03',2,0),(5687,7,5687,'2025-01-31 14:49:03',2,0),(5688,7,5688,'2025-01-31 14:49:03',2,0),(5689,7,5689,'2025-01-31 14:49:03',2,0),(5690,7,5690,'2025-01-31 14:49:03',2,0),(5691,7,5691,'2025-01-31 14:49:03',2,0),(5692,7,5692,'2025-01-31 14:49:03',2,0),(5693,7,5693,'2025-01-31 14:49:03',2,0),(5694,7,5694,'2025-01-31 14:49:03',2,0),(5695,7,5695,'2025-01-31 14:49:03',2,0),(5696,7,5696,'2025-01-31 14:49:04',2,0),(5697,7,5697,'2025-01-31 14:49:04',2,0),(5698,7,5698,'2025-01-31 14:49:04',2,0),(5699,7,5699,'2025-01-31 14:49:04',2,0),(5700,7,5700,'2025-01-31 14:49:04',2,0),(5701,7,5701,'2025-01-31 14:49:04',2,0),(5702,7,5702,'2025-01-31 14:49:04',2,0),(5703,7,5703,'2025-01-31 14:49:04',2,0),(5704,7,5704,'2025-01-31 14:49:04',2,0),(5705,7,5705,'2025-01-31 14:49:04',2,0),(5706,7,5706,'2025-01-31 14:49:04',2,0),(5707,7,5707,'2025-01-31 14:49:04',2,0),(5708,7,5708,'2025-01-31 14:49:04',2,0),(5709,7,5709,'2025-01-31 14:49:04',2,0),(5710,7,5710,'2025-01-31 14:49:04',2,0),(5711,7,5711,'2025-01-31 14:49:04',2,0),(5712,7,5712,'2025-01-31 14:49:04',2,0),(5713,7,5713,'2025-01-31 14:49:04',2,0),(5714,7,5714,'2025-01-31 14:49:04',2,0),(5715,7,5715,'2025-01-31 14:49:04',2,0),(5716,7,5716,'2025-01-31 14:49:04',2,0),(5717,7,5717,'2025-01-31 14:49:04',2,0),(5718,7,5718,'2025-01-31 14:49:04',2,0),(5719,7,5719,'2025-01-31 14:49:04',2,0),(5720,7,5720,'2025-01-31 14:49:04',2,0),(5721,7,5721,'2025-01-31 14:49:04',2,0),(5722,7,5722,'2025-01-31 14:49:04',2,0),(5723,7,5723,'2025-01-31 14:49:04',2,0),(5724,7,5724,'2025-01-31 14:49:04',2,0),(5725,7,5725,'2025-01-31 14:49:04',2,0),(5726,7,5726,'2025-01-31 14:49:04',2,0),(5727,7,5727,'2025-01-31 14:49:04',2,0),(5728,7,5728,'2025-01-31 14:49:04',2,0),(5729,7,5729,'2025-01-31 14:49:04',2,0),(5730,7,5730,'2025-01-31 14:49:04',2,0),(5731,7,5731,'2025-01-31 14:49:04',2,0),(5732,7,5732,'2025-01-31 14:49:04',2,0),(5733,7,5733,'2025-01-31 14:49:04',2,0),(5734,7,5734,'2025-01-31 14:49:04',2,0),(5735,7,5735,'2025-01-31 14:49:04',2,0),(5736,7,5736,'2025-01-31 14:49:04',2,0),(5737,7,5737,'2025-01-31 14:49:04',2,0),(5738,7,5738,'2025-01-31 14:49:05',2,0),(5739,7,5739,'2025-01-31 14:49:05',2,0),(5740,7,5740,'2025-01-31 14:49:05',2,0),(5741,7,5741,'2025-01-31 14:49:05',2,0),(5742,7,5742,'2025-01-31 14:49:05',2,0),(5743,7,5743,'2025-01-31 14:49:05',2,0),(5744,7,5744,'2025-01-31 14:49:05',2,0),(5745,7,5745,'2025-01-31 14:49:05',2,0),(5746,7,5746,'2025-01-31 14:49:05',2,0),(5747,7,5747,'2025-01-31 14:49:05',2,0),(5748,7,5748,'2025-01-31 14:49:05',2,0),(5749,7,5749,'2025-01-31 14:49:05',2,0),(5750,7,5750,'2025-01-31 14:49:05',2,0),(5751,7,5751,'2025-01-31 14:49:05',2,0),(5752,7,5752,'2025-01-31 14:49:05',2,0),(5753,7,5753,'2025-01-31 14:49:05',2,0),(5754,7,5754,'2025-01-31 14:49:05',2,0),(5755,7,5755,'2025-01-31 14:49:05',2,0),(5756,7,5756,'2025-01-31 14:49:05',2,0),(5757,7,5757,'2025-01-31 14:49:05',2,0),(5758,7,5758,'2025-01-31 14:49:05',2,0),(5759,7,5759,'2025-01-31 14:49:05',2,0),(5760,7,5760,'2025-01-31 14:49:05',2,0),(5761,7,5761,'2025-01-31 14:49:05',2,0),(5762,7,5762,'2025-01-31 14:49:05',2,0),(5763,7,5763,'2025-01-31 14:49:05',2,0),(5764,7,5764,'2025-01-31 14:49:05',2,0),(5765,7,5765,'2025-01-31 14:49:05',2,0),(5766,7,5766,'2025-01-31 14:49:05',2,0),(5767,7,5767,'2025-01-31 14:49:05',2,0),(5768,7,5768,'2025-01-31 14:49:05',2,0),(5769,7,5769,'2025-01-31 14:49:05',2,0),(5770,7,5770,'2025-01-31 14:49:05',2,0),(5771,7,5771,'2025-01-31 14:49:05',2,0),(5772,7,5772,'2025-01-31 14:49:05',2,0),(5773,7,5773,'2025-01-31 14:49:05',2,0),(5774,7,5774,'2025-01-31 14:49:05',2,0),(5775,7,5775,'2025-01-31 14:49:05',2,0),(5776,7,5776,'2025-01-31 14:49:05',2,0),(5777,7,5777,'2025-01-31 14:49:05',2,0),(5778,7,5778,'2025-01-31 14:49:05',2,0),(5779,7,5779,'2025-01-31 14:49:05',2,0),(5780,7,5780,'2025-01-31 14:49:05',2,0),(5781,7,5781,'2025-01-31 14:49:05',2,0),(5782,7,5782,'2025-01-31 14:49:06',2,0),(5783,7,5783,'2025-01-31 14:49:06',2,0),(5784,7,5784,'2025-01-31 14:49:06',2,0),(5785,7,5785,'2025-01-31 14:49:06',2,0),(5786,7,5786,'2025-01-31 14:49:06',2,0),(5787,7,5787,'2025-01-31 14:49:06',2,0),(5788,7,5788,'2025-01-31 14:49:06',2,0),(5789,7,5789,'2025-01-31 14:49:06',2,0),(5790,7,5790,'2025-01-31 14:49:06',2,0),(5791,7,5791,'2025-01-31 14:49:06',2,0),(5792,7,5792,'2025-01-31 14:49:06',2,0),(5793,7,5793,'2025-01-31 14:49:06',2,0),(5794,7,5794,'2025-01-31 14:49:06',2,0),(5795,7,5795,'2025-01-31 14:49:06',2,0),(5796,7,5796,'2025-01-31 14:49:06',2,0),(5797,7,5797,'2025-01-31 14:49:06',2,0),(5798,7,5798,'2025-01-31 14:49:06',2,0),(5799,7,5799,'2025-01-31 14:49:06',2,0),(5800,7,5800,'2025-01-31 14:49:06',2,0),(5801,7,5801,'2025-01-31 14:49:06',2,0),(5802,7,5802,'2025-01-31 14:49:06',2,0),(5803,7,5803,'2025-01-31 14:49:06',2,0),(5804,7,5804,'2025-01-31 14:49:06',2,0),(5805,7,5805,'2025-01-31 14:49:06',2,0),(5806,7,5806,'2025-01-31 14:49:06',2,0),(5807,7,5807,'2025-01-31 14:49:06',2,0),(5808,7,5808,'2025-01-31 14:49:06',2,0),(5809,7,5809,'2025-01-31 14:49:06',2,0),(5810,4,5810,'2025-02-04 10:01:32',4,0),(5811,7,5811,'2025-02-03 08:26:33',2,0),(5812,7,5812,'2025-02-03 08:26:33',2,0),(5813,7,5813,'2025-02-03 08:26:33',2,0),(5814,7,5814,'2025-02-03 08:26:33',2,0),(5815,7,5815,'2025-02-03 08:26:33',2,0),(5816,7,5816,'2025-02-03 08:26:33',2,0),(5817,7,5817,'2025-02-03 08:26:33',2,0),(5818,7,5818,'2025-02-03 08:26:33',2,0),(5819,7,5819,'2025-02-03 08:26:33',2,0),(5820,7,5820,'2025-02-03 08:26:33',2,0),(5821,7,5821,'2025-02-03 08:26:33',2,0),(5822,7,5822,'2025-02-03 08:26:33',2,0),(5823,7,5823,'2025-02-03 08:26:33',2,0),(5824,7,5824,'2025-02-03 08:26:33',2,0),(5825,7,5825,'2025-02-03 08:26:33',2,0),(5826,7,5826,'2025-02-03 08:26:33',2,0),(5827,7,5827,'2025-02-03 08:26:33',2,0),(5828,7,5828,'2025-02-03 08:26:33',2,0),(5829,7,5829,'2025-02-03 08:26:33',2,0),(5830,7,5830,'2025-02-03 08:26:33',2,0),(5831,7,5831,'2025-02-03 08:26:33',2,0),(5832,7,5832,'2025-02-03 08:26:33',2,0),(5833,7,5833,'2025-02-03 08:26:33',2,0),(5834,7,5834,'2025-02-03 08:26:33',2,0),(5835,7,5835,'2025-02-03 08:26:33',2,0),(5836,7,5836,'2025-02-03 08:26:33',2,0),(5837,7,5837,'2025-02-03 08:26:33',2,0),(5838,7,5838,'2025-02-03 08:26:33',2,0),(5839,7,5839,'2025-02-03 08:26:33',2,0),(5840,7,5840,'2025-02-03 08:26:33',2,0),(5841,7,5841,'2025-02-03 08:26:33',2,0),(5842,7,5842,'2025-02-03 08:26:33',2,0),(5843,7,5843,'2025-02-03 08:26:33',2,0),(5844,7,5844,'2025-02-03 08:26:33',2,0),(5845,7,5845,'2025-02-03 08:26:33',2,0),(5846,7,5846,'2025-02-03 08:26:33',2,0),(5847,7,5847,'2025-02-03 08:26:33',2,0),(5848,7,5848,'2025-02-03 08:26:34',2,0),(5849,7,5849,'2025-02-03 08:26:34',2,0),(5850,7,5850,'2025-02-03 08:26:34',2,0),(5851,7,5851,'2025-02-03 08:26:34',2,0),(5852,7,5852,'2025-02-03 08:26:34',2,0),(5853,7,5853,'2025-02-03 08:26:34',2,0),(5854,7,5854,'2025-02-03 08:26:34',2,0),(5855,7,5855,'2025-02-03 08:26:34',2,0),(5856,7,5856,'2025-02-03 08:26:34',2,0),(5857,7,5857,'2025-02-03 08:26:34',2,0),(5858,7,5858,'2025-02-03 08:26:34',2,0),(5859,7,5859,'2025-02-03 08:26:34',2,0),(5860,7,5860,'2025-02-03 08:26:34',2,0),(5861,7,5861,'2025-02-03 08:26:34',2,0),(5862,7,5862,'2025-02-03 08:26:34',2,0),(5863,7,5863,'2025-02-03 08:26:34',2,0),(5864,7,5864,'2025-02-03 08:26:34',2,0),(5865,7,5865,'2025-02-03 08:26:34',2,0),(5866,7,5866,'2025-02-03 08:26:34',2,0),(5867,7,5867,'2025-02-03 08:26:34',2,0),(5868,7,5868,'2025-02-03 08:26:34',2,0),(5869,7,5869,'2025-02-03 08:26:34',2,0),(5870,7,5870,'2025-02-03 08:26:34',2,0),(5871,7,5871,'2025-02-03 08:26:34',2,0),(5872,7,5872,'2025-02-03 08:26:34',2,0),(5873,7,5873,'2025-02-03 08:26:34',2,0),(5874,7,5874,'2025-02-03 08:26:34',2,0),(5875,7,5875,'2025-02-03 08:26:34',2,0),(5876,7,5876,'2025-02-03 08:26:34',2,0),(5877,7,5877,'2025-02-03 08:26:34',2,0),(5878,7,5878,'2025-02-03 08:26:34',2,0),(5879,7,5879,'2025-02-03 08:26:34',2,0),(5880,7,5880,'2025-02-03 08:26:34',2,0),(5881,7,5881,'2025-02-03 08:26:34',2,0),(5882,7,5882,'2025-02-03 08:26:34',2,0),(5883,7,5883,'2025-02-03 08:26:34',2,0),(5884,7,5884,'2025-02-03 08:26:34',2,0),(5885,7,5885,'2025-02-03 08:26:35',2,0),(5886,7,5886,'2025-02-03 08:26:35',2,0),(5887,7,5887,'2025-02-03 08:26:35',2,0),(5888,7,5888,'2025-02-03 08:26:35',2,0),(5889,7,5889,'2025-02-03 08:26:35',2,0),(5890,7,5890,'2025-02-03 08:26:35',2,0),(5891,7,5891,'2025-02-03 08:26:35',2,0),(5892,7,5892,'2025-02-03 08:26:35',2,0),(5893,7,5893,'2025-02-03 08:26:35',2,0),(5894,7,5894,'2025-02-03 08:26:35',2,0),(5895,7,5895,'2025-02-03 08:26:35',2,0),(5896,7,5896,'2025-02-03 08:26:35',2,0),(5897,7,5897,'2025-02-03 08:26:35',2,0),(5898,7,5898,'2025-02-03 08:26:35',2,0),(5899,7,5899,'2025-02-03 08:26:35',2,0),(5900,7,5900,'2025-02-03 08:26:35',2,0),(5901,7,5901,'2025-02-03 08:26:35',2,0),(5902,7,5902,'2025-02-03 08:26:35',2,0),(5903,7,5903,'2025-02-03 08:26:35',2,0),(5904,7,5904,'2025-02-03 08:26:35',2,0),(5905,7,5905,'2025-02-03 08:26:35',2,0),(5906,7,5906,'2025-02-03 08:26:35',2,0),(5907,7,5907,'2025-02-03 08:26:35',2,0),(5908,7,5908,'2025-02-03 08:26:35',2,0),(5909,7,5909,'2025-02-03 08:26:35',2,0),(5910,7,5910,'2025-02-03 08:26:35',2,0),(5911,7,5911,'2025-02-03 08:26:35',2,0),(5912,7,5912,'2025-02-03 08:26:35',2,0),(5913,7,5913,'2025-02-03 08:26:35',2,0),(5914,7,5914,'2025-02-03 08:26:35',2,0),(5915,7,5915,'2025-02-03 08:26:35',2,0),(5916,7,5916,'2025-02-03 08:26:35',2,0),(5917,7,5917,'2025-02-03 08:26:35',2,0),(5918,7,5918,'2025-02-03 08:26:35',2,0),(5919,7,5919,'2025-02-03 08:26:35',2,0),(5920,7,5920,'2025-02-03 08:26:35',2,0),(5921,7,5921,'2025-02-03 08:26:35',2,0),(5922,7,5922,'2025-02-03 08:26:35',2,0),(5923,7,5923,'2025-02-03 08:26:35',2,0),(5924,7,5924,'2025-02-03 08:26:35',2,0),(5925,7,5925,'2025-02-03 08:26:35',2,0),(5926,7,5926,'2025-02-03 08:26:35',2,0),(5927,7,5927,'2025-02-03 08:26:35',2,0),(5928,7,5928,'2025-02-03 08:26:35',2,0),(5929,7,5929,'2025-02-03 08:26:36',2,0),(5930,7,5930,'2025-02-03 08:26:36',2,0),(5931,7,5931,'2025-02-03 08:26:36',2,0),(5932,7,5932,'2025-02-03 08:26:36',2,0),(5933,7,5933,'2025-02-03 08:26:36',2,0),(5934,7,5934,'2025-02-03 08:26:36',2,0),(5935,7,5935,'2025-02-03 08:26:36',2,0),(5936,7,5936,'2025-02-03 08:26:36',2,0),(5937,7,5937,'2025-02-03 08:26:36',2,0),(5938,7,5938,'2025-02-03 08:26:36',2,0),(5939,7,5939,'2025-02-03 08:26:36',2,0),(5940,7,5940,'2025-02-03 08:26:36',2,0),(5941,7,5941,'2025-02-03 08:26:36',2,0),(5942,7,5942,'2025-02-03 08:26:36',2,0),(5943,7,5943,'2025-02-03 08:26:36',2,0),(5944,7,5944,'2025-02-03 08:26:36',2,0),(5945,7,5945,'2025-02-03 08:26:36',2,0),(5946,7,5946,'2025-02-03 08:26:36',2,0),(5947,7,5947,'2025-02-03 08:26:36',2,0),(5948,7,5948,'2025-02-03 08:26:36',2,0),(5949,7,5949,'2025-02-03 08:26:36',2,0),(5950,7,5950,'2025-02-03 08:26:36',2,0),(5951,7,5951,'2025-02-03 08:26:36',2,0),(5952,7,5952,'2025-02-03 08:26:36',2,0),(5953,7,5953,'2025-02-03 08:26:36',2,0),(5954,7,5954,'2025-02-03 08:26:36',2,0),(5955,7,5955,'2025-02-03 08:26:36',2,0),(5956,7,5956,'2025-02-03 08:26:36',2,0),(5957,7,5957,'2025-02-03 08:26:36',2,0),(5958,7,5958,'2025-02-03 08:26:36',2,0),(5959,7,5959,'2025-02-03 08:26:36',2,0),(5960,7,5960,'2025-02-03 08:26:36',2,0),(5961,7,5961,'2025-02-03 08:26:36',2,0),(5962,7,5962,'2025-02-03 08:26:36',2,0),(5963,7,5963,'2025-02-03 08:26:36',2,0),(5964,7,5964,'2025-02-03 08:26:36',2,0),(5965,7,5965,'2025-02-03 08:26:36',2,0),(5966,7,5966,'2025-02-03 08:26:36',2,0),(5967,7,5967,'2025-02-03 08:26:36',2,0),(5968,7,5968,'2025-02-03 08:26:36',2,0),(5969,7,5969,'2025-02-03 08:26:36',2,0),(5970,7,5970,'2025-02-03 08:26:36',2,0),(5971,7,5971,'2025-02-03 08:26:36',2,0),(5972,7,5972,'2025-02-03 08:26:36',2,0),(5973,7,5973,'2025-02-03 08:26:36',2,0),(5974,7,5974,'2025-02-03 08:26:36',2,0),(5975,7,5975,'2025-02-03 08:26:37',2,0),(5976,7,5976,'2025-02-03 08:26:37',2,0),(5977,7,5977,'2025-02-03 08:26:37',2,0),(5978,7,5978,'2025-02-03 08:26:37',2,0),(5979,7,5979,'2025-02-03 08:26:37',2,0),(5980,7,5980,'2025-02-03 08:26:37',2,0),(5981,7,5981,'2025-02-03 08:26:37',2,0),(5982,7,5982,'2025-02-03 08:26:37',2,0),(5983,7,5983,'2025-02-03 08:26:37',2,0),(5984,7,5984,'2025-02-03 08:26:37',2,0),(5985,7,5985,'2025-02-03 08:26:37',2,0),(5986,7,5986,'2025-02-03 08:26:37',2,0),(5987,7,5987,'2025-02-03 08:26:37',2,0),(5988,7,5988,'2025-02-03 08:26:37',2,0),(5989,7,5989,'2025-02-03 08:26:37',2,0),(5990,7,5990,'2025-02-03 08:26:37',2,0),(5991,7,5991,'2025-02-03 08:26:37',2,0),(5992,7,5992,'2025-02-03 08:26:37',2,0),(5993,7,5993,'2025-02-03 08:26:37',2,0),(5994,7,5994,'2025-02-03 08:26:37',2,0),(5995,7,5995,'2025-02-03 08:26:37',2,0),(5996,7,5996,'2025-02-03 08:26:37',2,0),(5997,7,5997,'2025-02-03 08:26:37',2,0),(5998,7,5998,'2025-02-03 08:26:37',2,0),(5999,7,5999,'2025-02-03 08:26:37',2,0),(6000,7,6000,'2025-02-03 08:26:37',2,0),(6001,7,6001,'2025-02-03 08:26:37',2,0),(6002,7,6002,'2025-02-03 08:26:37',2,0),(6003,7,6003,'2025-02-03 08:26:37',2,0),(6004,7,6004,'2025-02-03 08:26:37',2,0),(6005,7,6005,'2025-02-03 08:26:37',2,0),(6006,7,6006,'2025-02-03 08:26:37',2,0),(6007,7,6007,'2025-02-03 08:26:37',2,0),(6008,7,6008,'2025-02-03 08:26:37',2,0),(6009,7,6009,'2025-02-03 08:26:37',2,0),(6010,7,6010,'2025-02-03 08:26:37',2,0),(6011,7,6011,'2025-02-03 08:26:37',2,0),(6012,7,6012,'2025-02-03 08:26:37',2,0),(6013,7,6013,'2025-02-03 08:26:37',2,0),(6014,7,6014,'2025-02-03 08:26:37',2,0),(6015,7,6015,'2025-02-03 08:26:37',2,0),(6016,7,6016,'2025-02-03 08:26:38',2,0),(6017,7,6017,'2025-02-03 08:26:38',2,0),(6018,7,6018,'2025-02-03 08:26:38',2,0),(6019,7,6019,'2025-02-03 08:26:38',2,0),(6020,7,6020,'2025-02-03 08:26:38',2,0),(6021,7,6021,'2025-02-03 08:26:38',2,0),(6022,7,6022,'2025-02-03 08:26:38',2,0),(6023,7,6023,'2025-02-03 08:26:38',2,0),(6024,7,6024,'2025-02-03 08:26:38',2,0),(6025,7,6025,'2025-02-03 08:26:38',2,0),(6026,7,6026,'2025-02-03 08:26:38',2,0),(6027,7,6027,'2025-02-03 08:26:38',2,0),(6028,7,6028,'2025-02-03 08:26:38',2,0),(6029,7,6029,'2025-02-03 08:26:38',2,0),(6030,7,6030,'2025-02-03 08:26:38',2,0),(6031,7,6031,'2025-02-03 08:26:38',2,0),(6032,7,6032,'2025-02-03 08:26:38',2,0),(6033,7,6033,'2025-02-03 08:26:38',2,0),(6034,7,6034,'2025-02-03 08:26:38',2,0),(6035,7,6035,'2025-02-03 08:26:38',2,0),(6036,7,6036,'2025-02-03 08:26:38',2,0),(6037,7,6037,'2025-02-03 08:26:38',2,0),(6038,7,6038,'2025-02-03 08:26:38',2,0),(6039,7,6039,'2025-02-03 08:26:38',2,0),(6040,7,6040,'2025-02-03 08:26:38',2,0),(6041,7,6041,'2025-02-03 08:26:38',2,0),(6042,7,6042,'2025-02-03 08:26:38',2,0),(6043,7,6043,'2025-02-03 08:26:38',2,0),(6044,7,6044,'2025-02-03 08:26:38',2,0),(6045,7,6045,'2025-02-03 08:26:38',2,0),(6046,7,6046,'2025-02-03 08:26:38',2,0),(6047,7,6047,'2025-02-03 08:26:39',2,0),(6048,7,6048,'2025-02-03 08:26:39',2,0),(6049,7,6049,'2025-02-03 08:26:39',2,0),(6050,7,6050,'2025-02-03 08:26:39',2,0),(6051,7,6051,'2025-02-03 08:26:39',2,0),(6052,7,6052,'2025-02-03 08:26:39',2,0),(6053,7,6053,'2025-02-03 08:26:39',2,0),(6054,7,6054,'2025-02-03 08:26:39',2,0),(6055,7,6055,'2025-02-03 08:26:39',2,0),(6056,7,6056,'2025-02-03 08:26:39',2,0),(6057,7,6057,'2025-02-03 08:26:39',2,0),(6058,7,6058,'2025-02-03 08:26:39',2,0),(6059,7,6059,'2025-02-03 08:26:39',2,0),(6060,7,6060,'2025-02-03 08:26:39',2,0),(6061,7,6061,'2025-02-03 08:26:39',2,0),(6062,7,6062,'2025-02-03 08:26:39',2,0),(6063,7,6063,'2025-02-03 08:26:39',2,0),(6064,7,6064,'2025-02-03 08:26:40',2,0),(6065,7,6065,'2025-02-03 08:26:40',2,0),(6066,7,6066,'2025-02-03 08:26:40',2,0),(6067,7,6067,'2025-02-03 08:26:40',2,0),(6068,7,6068,'2025-02-03 08:26:40',2,0),(6069,7,6069,'2025-02-03 08:26:40',2,0),(6070,7,6070,'2025-02-03 08:26:40',2,0),(6071,7,6071,'2025-02-03 08:26:40',2,0),(6072,7,6072,'2025-02-03 08:26:40',2,0),(6073,7,6073,'2025-02-03 08:26:40',2,0),(6074,7,6074,'2025-02-03 08:26:40',2,0),(6075,7,6075,'2025-02-03 08:26:40',2,0),(6076,7,6076,'2025-02-03 08:26:40',2,0),(6077,7,6077,'2025-02-03 08:26:40',2,0),(6078,7,6078,'2025-02-03 08:26:40',2,0),(6079,7,6079,'2025-02-03 08:26:40',2,0),(6080,7,6080,'2025-02-03 08:26:41',2,0),(6081,7,6081,'2025-02-03 08:26:41',2,0),(6082,7,6082,'2025-02-03 08:26:41',2,0),(6083,7,6083,'2025-02-03 08:26:41',2,0),(6084,7,6084,'2025-02-03 08:26:41',2,0),(6085,3,6085,'2025-02-04 10:01:34',4,0);
/*!40000 ALTER TABLE `queue_message_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `queue_poison_pill`
--

DROP TABLE IF EXISTS `queue_poison_pill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `queue_poison_pill` (
  `version` varchar(255) NOT NULL COMMENT 'Poison Pill version.'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sequence table for poison pill versions';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `queue_poison_pill`
--

LOCK TABLES `queue_poison_pill` WRITE;
/*!40000 ALTER TABLE `queue_poison_pill` DISABLE KEYS */;
INSERT INTO `queue_poison_pill` VALUES ('version-67a314e74c6fd');
/*!40000 ALTER TABLE `queue_poison_pill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `quote`
--

DROP TABLE IF EXISTS `quote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `quote` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `converted_at` timestamp NULL DEFAULT NULL COMMENT 'Converted At',
  `is_active` smallint unsigned DEFAULT '1' COMMENT 'Is Active',
  `is_virtual` smallint unsigned DEFAULT '0' COMMENT 'Is Virtual',
  `is_multi_shipping` smallint unsigned DEFAULT '0' COMMENT 'Is Multi Shipping',
  `items_count` int unsigned DEFAULT '0' COMMENT 'Items Count',
  `items_qty` decimal(12,4) DEFAULT '0.0000' COMMENT 'Items Qty',
  `orig_order_id` int unsigned DEFAULT '0' COMMENT 'Orig Order ID',
  `store_to_base_rate` decimal(12,4) DEFAULT '0.0000' COMMENT 'Store To Base Rate',
  `store_to_quote_rate` decimal(12,4) DEFAULT '0.0000' COMMENT 'Store To Quote Rate',
  `base_currency_code` varchar(255) DEFAULT NULL COMMENT 'Base Currency Code',
  `store_currency_code` varchar(255) DEFAULT NULL COMMENT 'Store Currency Code',
  `quote_currency_code` varchar(255) DEFAULT NULL COMMENT 'Quote Currency Code',
  `grand_total` decimal(20,4) DEFAULT '0.0000' COMMENT 'Grand Total',
  `base_grand_total` decimal(20,4) DEFAULT '0.0000' COMMENT 'Base Grand Total',
  `checkout_method` varchar(255) DEFAULT NULL COMMENT 'Checkout Method',
  `customer_id` int unsigned DEFAULT NULL COMMENT 'Customer ID',
  `customer_tax_class_id` int unsigned DEFAULT NULL COMMENT 'Customer Tax Class ID',
  `customer_group_id` int unsigned DEFAULT '0' COMMENT 'Customer Group ID',
  `customer_email` varchar(255) DEFAULT NULL COMMENT 'Customer Email',
  `customer_prefix` varchar(40) DEFAULT NULL COMMENT 'Customer Prefix',
  `customer_firstname` varchar(255) DEFAULT NULL COMMENT 'Customer Firstname',
  `customer_middlename` varchar(40) DEFAULT NULL COMMENT 'Customer Middlename',
  `customer_lastname` varchar(255) DEFAULT NULL COMMENT 'Customer Lastname',
  `customer_suffix` varchar(40) DEFAULT NULL COMMENT 'Customer Suffix',
  `customer_dob` datetime DEFAULT NULL COMMENT 'Customer Dob',
  `customer_note` text COMMENT 'Customer Note',
  `customer_note_notify` smallint unsigned DEFAULT '1' COMMENT 'Customer Note Notify',
  `customer_is_guest` smallint unsigned DEFAULT '0' COMMENT 'Customer Is Guest',
  `remote_ip` varchar(45) DEFAULT NULL COMMENT 'Remote Ip',
  `applied_rule_ids` varchar(255) DEFAULT NULL COMMENT 'Applied Rule Ids',
  `reserved_order_id` varchar(64) DEFAULT NULL COMMENT 'Reserved Order ID',
  `password_hash` varchar(255) DEFAULT NULL COMMENT 'Password Hash',
  `coupon_code` varchar(255) DEFAULT NULL COMMENT 'Coupon Code',
  `global_currency_code` varchar(255) DEFAULT NULL COMMENT 'Global Currency Code',
  `base_to_global_rate` decimal(20,4) DEFAULT NULL COMMENT 'Base To Global Rate',
  `base_to_quote_rate` decimal(20,4) DEFAULT NULL COMMENT 'Base To Quote Rate',
  `customer_taxvat` varchar(255) DEFAULT NULL COMMENT 'Customer Taxvat',
  `customer_gender` varchar(255) DEFAULT NULL COMMENT 'Customer Gender',
  `subtotal` decimal(20,4) DEFAULT NULL COMMENT 'Subtotal',
  `base_subtotal` decimal(20,4) DEFAULT NULL COMMENT 'Base Subtotal',
  `subtotal_with_discount` decimal(20,4) DEFAULT NULL COMMENT 'Subtotal With Discount',
  `base_subtotal_with_discount` decimal(20,4) DEFAULT NULL COMMENT 'Base Subtotal With Discount',
  `is_changed` int unsigned DEFAULT NULL COMMENT 'Is Changed',
  `trigger_recollect` smallint NOT NULL DEFAULT '0' COMMENT 'Trigger Recollect',
  `ext_shipping_info` text COMMENT 'Ext Shipping Info',
  `gift_message_id` int DEFAULT NULL COMMENT 'Gift Message ID',
  `is_persistent` smallint unsigned DEFAULT '0' COMMENT 'Is Quote Persistent',
  `mp_smtp_ace_token` smallint DEFAULT NULL COMMENT 'ACE Token',
  `mp_smtp_ace_sent` smallint DEFAULT '0' COMMENT 'ACE Sent',
  `mp_smtp_ace_log_ids` text COMMENT 'ACE Log Ids',
  `mp_smtp_ace_log_data` text COMMENT 'ACE Log Data',
  `mollie_payment_fee` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  `mollie_payment_fee_tax` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  `base_mollie_payment_fee` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  `base_mollie_payment_fee_tax` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  PRIMARY KEY (`entity_id`),
  KEY `QUOTE_CUSTOMER_ID_STORE_ID_IS_ACTIVE` (`customer_id`,`store_id`,`is_active`),
  KEY `QUOTE_STORE_ID_UPDATED_AT` (`store_id`,`updated_at`),
  CONSTRAINT `QUOTE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=utf8mb3 COMMENT='quote';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `quote`
--

LOCK TABLES `quote` WRITE;
/*!40000 ALTER TABLE `quote` DISABLE KEYS */;
INSERT INTO `quote` VALUES (1,1,'2025-01-07 13:50:22','2025-01-07 13:50:22',NULL,0,0,0,0,0.0000,0,0.0000,0.0000,'USD','USD','USD',0.0000,0.0000,NULL,NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0,NULL,NULL,NULL,NULL,NULL,'USD',1.0000,1.0000,NULL,NULL,0.0000,0.0000,0.0000,0.0000,1,0,NULL,NULL,0,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000),(2,1,'2025-01-07 13:53:01','2025-01-07 13:54:09',NULL,0,0,0,0,0.0000,0,0.0000,0.0000,'USD','USD','USD',865.0000,865.0000,'guest',NULL,3,0,'zohaibmuhammad23@gmail.com',NULL,'Muhammad ',NULL,'Zohaib ',NULL,NULL,NULL,1,1,'39.37.183.204',NULL,'000000003',NULL,NULL,'USD',1.0000,1.0000,NULL,NULL,860.0000,860.0000,860.0000,860.0000,1,0,NULL,NULL,0,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000),(3,1,'2025-01-07 14:30:39','2025-01-07 15:08:10',NULL,1,0,0,0,0.0000,0,0.0000,0.0000,'USD','USD','USD',0.0000,0.0000,NULL,NULL,3,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,'39.37.183.204',NULL,NULL,NULL,NULL,'USD',1.0000,1.0000,NULL,NULL,0.0000,0.0000,0.0000,0.0000,1,0,NULL,NULL,0,26,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000),(4,1,'2025-01-18 16:07:44','2025-01-18 16:07:44',NULL,1,0,0,0,0.0000,0,0.0000,0.0000,'USD','USD','USD',349.9900,349.9900,NULL,NULL,3,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,'99.241.243.134',NULL,NULL,NULL,NULL,'USD',1.0000,1.0000,NULL,NULL,349.9900,349.9900,349.9900,349.9900,1,0,NULL,NULL,0,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000),(5,1,'2025-01-22 06:06:09','2025-01-22 06:06:09',NULL,1,0,0,0,0.0000,0,0.0000,0.0000,'USD','USD','USD',509.6100,509.6100,NULL,NULL,3,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,'49.43.143.99',NULL,NULL,NULL,NULL,'USD',1.0000,1.0000,NULL,NULL,509.6100,509.6100,509.6100,509.6100,1,0,NULL,NULL,0,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000),(6,1,'2025-01-28 08:39:16','2025-01-28 08:41:05',NULL,0,0,0,0,0.0000,0,0.0000,0.0000,'USD','USD','USD',394.9900,394.9900,'guest',NULL,3,0,'zohaibmuhammad23@gmail.com',NULL,'sadas',NULL,'sadsa',NULL,NULL,NULL,1,1,'172.70.111.80',NULL,'000000004',NULL,NULL,'USD',1.0000,1.0000,NULL,NULL,349.9900,349.9900,349.9900,349.9900,1,0,NULL,NULL,0,4,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000),(7,1,'2025-01-29 13:56:39','2025-01-29 13:58:02',NULL,1,0,0,0,0.0000,0,0.0000,0.0000,'USD','USD','USD',394.9900,394.9900,NULL,NULL,3,0,'zohaibmuhammad23@gmail.com',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,'162.158.159.50',NULL,NULL,NULL,NULL,'USD',1.0000,1.0000,NULL,NULL,349.9900,349.9900,349.9900,349.9900,1,0,NULL,NULL,0,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000),(8,1,'2025-01-29 15:39:31','2025-01-29 15:40:49',NULL,0,0,0,0,0.0000,0,0.0000,0.0000,'USD','USD','USD',394.9900,394.9900,'guest',NULL,3,0,'zohaibmuhammad23@gmail.com',NULL,'Test ',NULL,'zohaib',NULL,NULL,NULL,1,1,'172.70.230.57',NULL,'000000005',NULL,NULL,'USD',1.0000,1.0000,NULL,NULL,349.9900,349.9900,349.9900,349.9900,1,0,NULL,NULL,0,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000),(9,1,'2025-01-29 15:54:09','2025-01-29 15:54:10',NULL,0,0,0,0,0.0000,0,0.0000,0.0000,'USD','USD','USD',394.9900,394.9900,NULL,NULL,3,0,'zohaibmuhammad23@gmail.com',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,NULL,NULL,NULL,NULL,NULL,'USD',1.0000,1.0000,NULL,NULL,349.9900,349.9900,349.9900,349.9900,1,0,NULL,NULL,0,4,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000),(10,1,'2025-01-29 15:54:15','2025-01-29 15:54:15',NULL,0,0,0,0,0.0000,0,0.0000,0.0000,'USD','USD','USD',394.9900,394.9900,NULL,NULL,3,0,'zohaibmuhammad23@gmail.com',NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,NULL,NULL,NULL,NULL,NULL,'USD',1.0000,1.0000,NULL,NULL,349.9900,349.9900,349.9900,349.9900,1,0,NULL,NULL,0,2,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000),(11,1,'2025-01-29 15:54:20','2025-01-29 15:54:40',NULL,0,0,0,0,0.0000,0,0.0000,0.0000,'USD','USD','USD',394.9900,394.9900,NULL,NULL,3,0,'zohaibmuhammad23@gmail.com',NULL,'Test',NULL,'zohaib',NULL,NULL,NULL,1,1,NULL,NULL,'000000005-1',NULL,NULL,'USD',1.0000,1.0000,NULL,'0',349.9900,349.9900,349.9900,349.9900,1,0,NULL,NULL,0,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000),(12,1,'2025-01-31 08:00:58','2025-01-31 08:00:58',NULL,1,0,0,0,0.0000,0,0.0000,0.0000,'USD','USD','USD',470.2200,470.2200,NULL,NULL,3,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,'172.70.114.130',NULL,NULL,NULL,NULL,'USD',1.0000,1.0000,NULL,NULL,470.2200,470.2200,470.2200,470.2200,1,0,NULL,NULL,0,3,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000),(13,1,'2025-02-04 06:52:03','2025-02-04 06:52:03',NULL,1,0,0,1,1.0000,0,0.0000,0.0000,'USD','USD','USD',326.4000,326.4000,NULL,NULL,3,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,'172.70.111.144',NULL,NULL,NULL,NULL,'USD',1.0000,1.0000,NULL,NULL,326.4000,326.4000,326.4000,326.4000,1,0,NULL,NULL,0,3,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000);
/*!40000 ALTER TABLE `quote` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `quote_address`
--

DROP TABLE IF EXISTS `quote_address`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `quote_address` (
  `address_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Address ID',
  `quote_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Quote ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `customer_id` int unsigned DEFAULT NULL COMMENT 'Customer ID',
  `save_in_address_book` smallint DEFAULT '0' COMMENT 'Save In Address Book',
  `customer_address_id` int unsigned DEFAULT NULL COMMENT 'Customer Address ID',
  `address_type` varchar(10) DEFAULT NULL COMMENT 'Address Type',
  `email` varchar(255) DEFAULT NULL COMMENT 'Email',
  `prefix` varchar(40) DEFAULT NULL COMMENT 'Prefix',
  `firstname` varchar(255) DEFAULT NULL,
  `middlename` varchar(40) DEFAULT NULL,
  `lastname` varchar(255) DEFAULT NULL,
  `suffix` varchar(40) DEFAULT NULL COMMENT 'Suffix',
  `company` varchar(255) DEFAULT NULL COMMENT 'Company',
  `street` varchar(255) DEFAULT NULL COMMENT 'Street',
  `city` varchar(255) DEFAULT NULL,
  `region` varchar(255) DEFAULT NULL,
  `region_id` int unsigned DEFAULT NULL COMMENT 'Region ID',
  `postcode` varchar(20) DEFAULT NULL COMMENT 'Postcode',
  `country_id` varchar(30) DEFAULT NULL COMMENT 'Country ID',
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `same_as_billing` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Same As Billing',
  `collect_shipping_rates` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Collect Shipping Rates',
  `shipping_method` varchar(120) DEFAULT NULL,
  `shipping_description` varchar(255) DEFAULT NULL COMMENT 'Shipping Description',
  `weight` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Weight',
  `subtotal` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Subtotal',
  `base_subtotal` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Subtotal',
  `subtotal_with_discount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Subtotal With Discount',
  `base_subtotal_with_discount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Subtotal With Discount',
  `tax_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Tax Amount',
  `base_tax_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Tax Amount',
  `shipping_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Shipping Amount',
  `base_shipping_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Shipping Amount',
  `shipping_tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Tax Amount',
  `base_shipping_tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Tax Amount',
  `discount_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount',
  `base_discount_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Discount Amount',
  `grand_total` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Grand Total',
  `base_grand_total` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Grand Total',
  `customer_notes` text COMMENT 'Customer Notes',
  `applied_taxes` text COMMENT 'Applied Taxes',
  `discount_description` varchar(255) DEFAULT NULL COMMENT 'Discount Description',
  `shipping_discount_amount` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Discount Amount',
  `base_shipping_discount_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Discount Amount',
  `subtotal_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Subtotal Incl Tax',
  `base_subtotal_total_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Subtotal Total Incl Tax',
  `discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Discount Tax Compensation Amount',
  `base_discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Tax Compensation Amount',
  `shipping_discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Discount Tax Compensation Amount',
  `base_shipping_discount_tax_compensation_amnt` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Discount Tax Compensation Amount',
  `shipping_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Incl Tax',
  `base_shipping_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Incl Tax',
  `vat_id` text COMMENT 'Vat ID',
  `vat_is_valid` smallint DEFAULT NULL COMMENT 'Vat Is Valid',
  `vat_request_id` text COMMENT 'Vat Request ID',
  `vat_request_date` text COMMENT 'Vat Request Date',
  `vat_request_success` smallint DEFAULT NULL COMMENT 'Vat Request Success',
  `validated_country_code` text COMMENT 'Validated Country Code',
  `validated_vat_number` text COMMENT 'Validated Vat Number',
  `gift_message_id` int DEFAULT NULL COMMENT 'Gift Message ID',
  `free_shipping` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Free Shipping',
  `mollie_payment_fee` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  `mollie_payment_fee_tax` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  `base_mollie_payment_fee` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  `base_mollie_payment_fee_tax` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  PRIMARY KEY (`address_id`),
  KEY `QUOTE_ADDRESS_QUOTE_ID` (`quote_id`),
  CONSTRAINT `QUOTE_ADDRESS_QUOTE_ID_QUOTE_ENTITY_ID` FOREIGN KEY (`quote_id`) REFERENCES `quote` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=33 DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Quote Address';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `quote_address`
--

LOCK TABLES `quote_address` WRITE;
/*!40000 ALTER TABLE `quote_address` DISABLE KEYS */;
INSERT INTO `quote_address` VALUES (1,1,'2025-01-07 13:50:22','2025-01-07 13:50:22',NULL,0,NULL,'billing',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,'null',NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(2,1,'2025-01-07 13:50:22','2025-01-07 13:50:22',NULL,0,NULL,'shipping',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,'null',NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(4,2,'2025-01-07 13:53:01','2025-01-07 13:54:07',NULL,0,NULL,'shipping','zohaibmuhammad23@gmail.com',NULL,'Muhammad ',NULL,'Zohaib ',NULL,'Banyo','89/A','London','Guam',20,'12345 12345','US','+3211232193',NULL,0,0,'flatrate_flatrate','Flat Rate - Fixed',0.0000,860.0000,860.0000,860.0000,860.0000,0.0000,0.0000,5.0000,5.0000,0.0000,0.0000,0.0000,0.0000,865.0000,865.0000,NULL,'[]',NULL,0.0000,0.0000,860.0000,860.0000,0.0000,0.0000,0.0000,NULL,5.0000,5.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(5,2,'2025-01-07 13:53:55','2025-01-07 13:53:55',NULL,0,NULL,'billing','zohaibmuhammad23@gmail.com',NULL,'Muhammad ',NULL,'Zohaib ',NULL,'Banyo','89/A','London','Guam',20,'12345 12345','US','+3211232193',NULL,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,'null',NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(8,3,'2025-01-07 15:08:10','2025-01-07 15:08:10',NULL,0,NULL,'billing',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,'null',NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(9,3,'2025-01-07 15:08:10','2025-01-07 15:08:10',NULL,0,NULL,'shipping',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,1,NULL,NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,'null',NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(10,4,'2025-01-18 16:07:44','2025-01-18 16:07:44',NULL,0,NULL,'billing',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,'null',NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(11,4,'2025-01-18 16:07:44','2025-01-18 16:07:44',NULL,0,NULL,'shipping',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0,NULL,NULL,0.0000,349.9900,349.9900,349.9900,349.9900,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,349.9900,349.9900,NULL,'[]',NULL,0.0000,0.0000,349.9900,349.9900,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(12,5,'2025-01-22 06:06:09','2025-01-22 06:06:09',NULL,0,NULL,'billing',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,'null',NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(13,5,'2025-01-22 06:06:09','2025-01-22 06:06:09',NULL,0,NULL,'shipping',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0,NULL,NULL,0.0000,509.6100,509.6100,509.6100,509.6100,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,509.6100,509.6100,NULL,'[]',NULL,0.0000,0.0000,509.6100,509.6100,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(15,6,'2025-01-28 08:39:16','2025-01-28 08:40:31',NULL,0,NULL,'shipping','zohaibmuhammad23@gmail.com',NULL,'sadas',NULL,'sadsa',NULL,'Banyo','xzxz','London','California',12,'12345','US','+3211232193',NULL,0,0,'gazco_gazcofire','Van Delivery - Shipping Test',0.0000,349.9900,349.9900,349.9900,349.9900,0.0000,0.0000,45.0000,45.0000,0.0000,0.0000,0.0000,0.0000,394.9900,394.9900,NULL,'[]',NULL,0.0000,0.0000,349.9900,349.9900,0.0000,0.0000,0.0000,NULL,45.0000,45.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(16,6,'2025-01-28 08:40:27','2025-01-28 08:40:27',NULL,0,NULL,'billing','zohaibmuhammad23@gmail.com',NULL,'sadas',NULL,'sadsa',NULL,'Banyo','xzxz','London','California',12,'12345','US','+3211232193',NULL,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,'null',NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(18,7,'2025-01-29 13:56:39','2025-01-29 13:58:02',NULL,0,NULL,'shipping','zohaibmuhammad23@gmail.com',NULL,'muhammad',NULL,'zohaib',NULL,'banyo','xyz','London','Idaho',22,'12345','US','3245445454545',NULL,0,0,'gazco_gazcofire','Van Delivery - Shipping Test',0.0000,349.9900,349.9900,349.9900,349.9900,0.0000,0.0000,45.0000,45.0000,0.0000,0.0000,0.0000,0.0000,394.9900,394.9900,NULL,'[]',NULL,0.0000,0.0000,349.9900,349.9900,0.0000,0.0000,0.0000,NULL,45.0000,45.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(19,7,'2025-01-29 13:57:45','2025-01-29 13:57:45',NULL,0,NULL,'billing','zohaibmuhammad23@gmail.com',NULL,'muhammad',NULL,'zohaib',NULL,'banyo','xyz','London','Idaho',22,'12345','US','3245445454545',NULL,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,'null',NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(21,8,'2025-01-29 15:39:32','2025-01-29 15:40:28',NULL,0,NULL,'shipping','zohaibmuhammad23@gmail.com',NULL,'Test ',NULL,'zohaib',NULL,'Banyo','sasas','London','Guam',20,'123456','US','32354467814',NULL,0,0,'gazco_gazcofire','Van Delivery - Shipping Test',0.0000,349.9900,349.9900,349.9900,349.9900,0.0000,0.0000,45.0000,45.0000,0.0000,0.0000,0.0000,0.0000,394.9900,394.9900,NULL,'[]',NULL,0.0000,0.0000,349.9900,349.9900,0.0000,0.0000,0.0000,NULL,45.0000,45.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(22,8,'2025-01-29 15:40:23','2025-01-29 15:40:23',NULL,0,NULL,'billing','zohaibmuhammad23@gmail.com',NULL,'Test ',NULL,'zohaib',NULL,'Banyo','sasas','London','Guam',20,'123456','US','32354467814',NULL,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,'null',NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(23,9,'2025-01-29 15:54:09','2025-01-29 15:54:09',NULL,0,NULL,'billing','zohaibmuhammad23@gmail.com',NULL,'Test ',NULL,'zohaib',NULL,'Banyo','sasas','London','Guam',20,'123456','US','32354467814',NULL,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,'null',NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(24,9,'2025-01-29 15:54:09','2025-01-29 15:54:09',NULL,0,NULL,'shipping','zohaibmuhammad23@gmail.com',NULL,'Test ',NULL,'zohaib',NULL,'Banyo','sasas','London','Guam',20,'123456','US','32354467814',NULL,1,0,'gazco_gazcofire','Van Delivery - Shipping Test',0.0000,349.9900,349.9900,349.9900,349.9900,0.0000,0.0000,45.0000,45.0000,0.0000,0.0000,0.0000,0.0000,394.9900,394.9900,NULL,'[]',NULL,0.0000,0.0000,349.9900,349.9900,0.0000,0.0000,0.0000,NULL,45.0000,45.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(25,10,'2025-01-29 15:54:15','2025-01-29 15:54:15',NULL,0,NULL,'billing','zohaibmuhammad23@gmail.com',NULL,'Test ',NULL,'zohaib',NULL,'Banyo','sasas','London','Guam',20,'123456','US','32354467814',NULL,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,'null',NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(26,10,'2025-01-29 15:54:15','2025-01-29 15:54:15',NULL,0,NULL,'shipping','zohaibmuhammad23@gmail.com',NULL,'Test ',NULL,'zohaib',NULL,'Banyo','sasas','London','Guam',20,'123456','US','32354467814',NULL,1,0,'gazco_gazcofire','Van Delivery - Shipping Test',0.0000,349.9900,349.9900,349.9900,349.9900,0.0000,0.0000,45.0000,45.0000,0.0000,0.0000,0.0000,0.0000,394.9900,394.9900,NULL,'[]',NULL,0.0000,0.0000,349.9900,349.9900,0.0000,0.0000,0.0000,NULL,45.0000,45.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(27,11,'2025-01-29 15:54:20','2025-01-29 15:54:20',NULL,0,NULL,'billing','zohaibmuhammad23@gmail.com',NULL,'Test',NULL,'zohaib',NULL,'Banyo','sasas','London','Guam',20,'123456','US','32354467814',NULL,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,'null',NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(28,11,'2025-01-29 15:54:20','2025-01-29 15:54:20',NULL,0,0,'shipping','zohaibmuhammad23@gmail.com',NULL,'Test',NULL,'zohaib',NULL,'Banyo','sasas','London','Guam',20,'123456','US','32354467814',NULL,1,0,'gazco_gazcofire','Van Delivery - Shipping Test',0.0000,349.9900,349.9900,349.9900,349.9900,0.0000,0.0000,45.0000,45.0000,0.0000,0.0000,0.0000,0.0000,394.9900,394.9900,NULL,'[]',NULL,0.0000,0.0000,349.9900,349.9900,0.0000,0.0000,0.0000,NULL,45.0000,45.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(29,12,'2025-01-31 08:00:58','2025-01-31 08:00:58',NULL,0,NULL,'billing',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,'null',NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(30,12,'2025-01-31 08:00:58','2025-01-31 08:00:58',NULL,0,NULL,'shipping',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0,NULL,NULL,0.0000,470.2200,470.2200,470.2200,470.2200,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,470.2200,470.2200,NULL,'[]',NULL,0.0000,0.0000,470.2200,470.2200,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(31,13,'2025-02-04 06:52:03','2025-02-04 06:52:03',NULL,0,NULL,'billing',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,'null',NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000),(32,13,'2025-02-04 06:52:03','2025-02-04 06:52:03',NULL,0,NULL,'shipping',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,0,NULL,NULL,0.0000,326.4000,326.4000,326.4000,326.4000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,326.4000,326.4000,NULL,'[]',NULL,0.0000,0.0000,326.4000,326.4000,0.0000,0.0000,0.0000,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0.0000,0.0000,0.0000,0.0000);
/*!40000 ALTER TABLE `quote_address` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `quote_address_item`
--

DROP TABLE IF EXISTS `quote_address_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `quote_address_item` (
  `address_item_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Address Item ID',
  `parent_item_id` int unsigned DEFAULT NULL COMMENT 'Parent Item ID',
  `quote_address_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Quote Address ID',
  `quote_item_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Quote Item ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `applied_rule_ids` text COMMENT 'Applied Rule Ids',
  `additional_data` text COMMENT 'Additional Data',
  `weight` decimal(12,4) DEFAULT '0.0000' COMMENT 'Weight',
  `qty` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty',
  `discount_amount` decimal(20,4) DEFAULT '0.0000' COMMENT 'Discount Amount',
  `tax_amount` decimal(20,4) DEFAULT '0.0000' COMMENT 'Tax Amount',
  `row_total` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Row Total',
  `base_row_total` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Row Total',
  `row_total_with_discount` decimal(20,4) DEFAULT '0.0000' COMMENT 'Row Total With Discount',
  `base_discount_amount` decimal(20,4) DEFAULT '0.0000' COMMENT 'Base Discount Amount',
  `base_tax_amount` decimal(20,4) DEFAULT '0.0000' COMMENT 'Base Tax Amount',
  `row_weight` decimal(12,4) DEFAULT '0.0000' COMMENT 'Row Weight',
  `product_id` int unsigned DEFAULT NULL COMMENT 'Product ID',
  `super_product_id` int unsigned DEFAULT NULL COMMENT 'Super Product ID',
  `parent_product_id` int unsigned DEFAULT NULL COMMENT 'Parent Product ID',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `sku` varchar(255) DEFAULT NULL COMMENT 'Sku',
  `image` varchar(255) DEFAULT NULL COMMENT 'Image',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `description` text COMMENT 'Description',
  `is_qty_decimal` int unsigned DEFAULT NULL COMMENT 'Is Qty Decimal',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `discount_percent` decimal(12,4) DEFAULT NULL COMMENT 'Discount Percent',
  `no_discount` int unsigned DEFAULT NULL COMMENT 'No Discount',
  `tax_percent` decimal(12,4) DEFAULT NULL COMMENT 'Tax Percent',
  `base_price` decimal(20,4) DEFAULT NULL COMMENT 'Base Price',
  `base_cost` decimal(20,4) DEFAULT NULL COMMENT 'Base Cost',
  `price_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Price Incl Tax',
  `base_price_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Price Incl Tax',
  `row_total_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Row Total Incl Tax',
  `base_row_total_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Row Total Incl Tax',
  `discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Discount Tax Compensation Amount',
  `base_discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Tax Compensation Amount',
  `gift_message_id` int DEFAULT NULL COMMENT 'Gift Message ID',
  `free_shipping` int unsigned DEFAULT NULL COMMENT 'Free Shipping',
  PRIMARY KEY (`address_item_id`),
  KEY `QUOTE_ADDRESS_ITEM_QUOTE_ADDRESS_ID` (`quote_address_id`),
  KEY `QUOTE_ADDRESS_ITEM_PARENT_ITEM_ID` (`parent_item_id`),
  KEY `QUOTE_ADDRESS_ITEM_QUOTE_ITEM_ID` (`quote_item_id`),
  KEY `QUOTE_ADDRESS_ITEM_STORE_ID` (`store_id`),
  CONSTRAINT `QUOTE_ADDR_ITEM_PARENT_ITEM_ID_QUOTE_ADDR_ITEM_ADDR_ITEM_ID` FOREIGN KEY (`parent_item_id`) REFERENCES `quote_address_item` (`address_item_id`) ON DELETE CASCADE,
  CONSTRAINT `QUOTE_ADDRESS_ITEM_QUOTE_ADDRESS_ID_QUOTE_ADDRESS_ADDRESS_ID` FOREIGN KEY (`quote_address_id`) REFERENCES `quote_address` (`address_id`) ON DELETE CASCADE,
  CONSTRAINT `QUOTE_ADDRESS_ITEM_QUOTE_ITEM_ID_QUOTE_ITEM_ITEM_ID` FOREIGN KEY (`quote_item_id`) REFERENCES `quote_item` (`item_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Quote Address Item';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `quote_address_item`
--

LOCK TABLES `quote_address_item` WRITE;
/*!40000 ALTER TABLE `quote_address_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `quote_address_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `quote_id_mask`
--

DROP TABLE IF EXISTS `quote_id_mask`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `quote_id_mask` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `quote_id` int unsigned NOT NULL COMMENT 'Quote ID',
  `masked_id` varchar(32) DEFAULT NULL COMMENT 'Masked ID',
  PRIMARY KEY (`entity_id`,`quote_id`),
  KEY `QUOTE_ID_MASK_QUOTE_ID` (`quote_id`),
  KEY `QUOTE_ID_MASK_MASKED_ID` (`masked_id`),
  CONSTRAINT `QUOTE_ID_MASK_QUOTE_ID_QUOTE_ENTITY_ID` FOREIGN KEY (`quote_id`) REFERENCES `quote` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb3 COMMENT='Quote ID and masked ID mapping';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `quote_id_mask`
--

LOCK TABLES `quote_id_mask` WRITE;
/*!40000 ALTER TABLE `quote_id_mask` DISABLE KEYS */;
INSERT INTO `quote_id_mask` VALUES (7,8,'5ANkGooNJNMNQ9E0oBRzcO9elktry2NC'),(4,5,'60MFfVIik9oAWmsnQxG9kdofU57tfLKN'),(8,12,'6n41DgPsVJNdUesB2hPJFm2Ia0yKSIJ7'),(3,4,'AzmQIoWbD1o88nccjjzB9ELzN6f4YvG3'),(1,2,'HKP2OyFd9d0rEleeHj8se7KjuoUI8DNX'),(2,3,'lILOhp4FNEyxoM6nZy8MXgSzlRp6JAiC'),(5,6,'saqz8Qel6URSyGS6mz9Ac5SXT5AWvRss'),(6,7,'SdIbhoyYJqpNZLsJDrTNdt5hOdB75W0V'),(9,13,'xmtrtipZw4s2pC65JdwxZQ6QwmngSnfV');
/*!40000 ALTER TABLE `quote_id_mask` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `quote_item`
--

DROP TABLE IF EXISTS `quote_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `quote_item` (
  `item_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Item ID',
  `quote_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Quote ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `product_id` int unsigned DEFAULT NULL COMMENT 'Product ID',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `parent_item_id` int unsigned DEFAULT NULL COMMENT 'Parent Item ID',
  `is_virtual` smallint unsigned DEFAULT NULL COMMENT 'Is Virtual',
  `sku` varchar(255) DEFAULT NULL COMMENT 'Sku',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `description` text COMMENT 'Description',
  `applied_rule_ids` text COMMENT 'Applied Rule Ids',
  `additional_data` text COMMENT 'Additional Data',
  `is_qty_decimal` smallint unsigned DEFAULT NULL COMMENT 'Is Qty Decimal',
  `no_discount` smallint unsigned DEFAULT '0' COMMENT 'No Discount',
  `weight` decimal(12,4) DEFAULT '0.0000' COMMENT 'Weight',
  `qty` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty',
  `price` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Price',
  `base_price` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Price',
  `custom_price` decimal(20,4) DEFAULT NULL COMMENT 'Custom Price',
  `discount_percent` decimal(12,4) DEFAULT '0.0000' COMMENT 'Discount Percent',
  `discount_amount` decimal(20,4) DEFAULT '0.0000' COMMENT 'Discount Amount',
  `base_discount_amount` decimal(20,4) DEFAULT '0.0000' COMMENT 'Base Discount Amount',
  `tax_percent` decimal(12,4) DEFAULT '0.0000' COMMENT 'Tax Percent',
  `tax_amount` decimal(20,4) DEFAULT '0.0000' COMMENT 'Tax Amount',
  `base_tax_amount` decimal(20,4) DEFAULT '0.0000' COMMENT 'Base Tax Amount',
  `row_total` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Row Total',
  `base_row_total` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Row Total',
  `row_total_with_discount` decimal(20,4) DEFAULT '0.0000' COMMENT 'Row Total With Discount',
  `row_weight` decimal(12,4) DEFAULT '0.0000' COMMENT 'Row Weight',
  `product_type` varchar(255) DEFAULT NULL COMMENT 'Product Type',
  `base_tax_before_discount` decimal(20,4) DEFAULT NULL COMMENT 'Base Tax Before Discount',
  `tax_before_discount` decimal(20,4) DEFAULT NULL COMMENT 'Tax Before Discount',
  `original_custom_price` decimal(20,4) DEFAULT NULL COMMENT 'Original Custom Price',
  `redirect_url` varchar(255) DEFAULT NULL COMMENT 'Redirect Url',
  `base_cost` decimal(12,4) DEFAULT NULL COMMENT 'Base Cost',
  `price_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Price Incl Tax',
  `base_price_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Price Incl Tax',
  `row_total_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Row Total Incl Tax',
  `base_row_total_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Row Total Incl Tax',
  `discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Discount Tax Compensation Amount',
  `base_discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Tax Compensation Amount',
  `gift_message_id` int DEFAULT NULL COMMENT 'Gift Message ID',
  `free_shipping` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Free Shipping',
  `weee_tax_applied` text COMMENT 'Weee Tax Applied',
  `weee_tax_applied_amount` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Applied Amount',
  `weee_tax_applied_row_amount` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Applied Row Amount',
  `weee_tax_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Disposition',
  `weee_tax_row_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Row Disposition',
  `base_weee_tax_applied_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Applied Amount',
  `base_weee_tax_applied_row_amnt` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Applied Row Amnt',
  `base_weee_tax_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Disposition',
  `base_weee_tax_row_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Row Disposition',
  PRIMARY KEY (`item_id`),
  KEY `QUOTE_ITEM_PARENT_ITEM_ID` (`parent_item_id`),
  KEY `QUOTE_ITEM_PRODUCT_ID` (`product_id`),
  KEY `QUOTE_ITEM_QUOTE_ID` (`quote_id`),
  KEY `QUOTE_ITEM_STORE_ID` (`store_id`),
  CONSTRAINT `QUOTE_ITEM_PARENT_ITEM_ID_QUOTE_ITEM_ITEM_ID` FOREIGN KEY (`parent_item_id`) REFERENCES `quote_item` (`item_id`) ON DELETE CASCADE,
  CONSTRAINT `QUOTE_ITEM_QUOTE_ID_QUOTE_ENTITY_ID` FOREIGN KEY (`quote_id`) REFERENCES `quote` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `QUOTE_ITEM_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Quote Item';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `quote_item`
--

LOCK TABLES `quote_item` WRITE;
/*!40000 ALTER TABLE `quote_item` DISABLE KEYS */;
INSERT INTO `quote_item` VALUES (12,13,'2025-02-04 06:52:03','2025-02-04 06:52:03',6036,1,NULL,0,'122.0606.949','Franke Mythos MYX 110-45 Undermount Single Bowl Sink -Stainless Steel',NULL,NULL,NULL,0,0,NULL,1.0000,326.4000,326.4000,NULL,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,326.4000,326.4000,0.0000,0.0000,'simple',NULL,NULL,NULL,NULL,366.7600,326.4000,326.4000,326.4000,326.4000,0.0000,0.0000,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `quote_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `quote_item_option`
--

DROP TABLE IF EXISTS `quote_item_option`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `quote_item_option` (
  `option_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option ID',
  `item_id` int unsigned NOT NULL COMMENT 'Item ID',
  `product_id` int unsigned NOT NULL COMMENT 'Product ID',
  `code` varchar(255) NOT NULL COMMENT 'Code',
  `value` text COMMENT 'Value',
  PRIMARY KEY (`option_id`),
  KEY `QUOTE_ITEM_OPTION_ITEM_ID` (`item_id`),
  CONSTRAINT `QUOTE_ITEM_OPTION_ITEM_ID_QUOTE_ITEM_ITEM_ID` FOREIGN KEY (`item_id`) REFERENCES `quote_item` (`item_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Quote Item Option';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `quote_item_option`
--

LOCK TABLES `quote_item_option` WRITE;
/*!40000 ALTER TABLE `quote_item_option` DISABLE KEYS */;
INSERT INTO `quote_item_option` VALUES (12,12,6036,'info_buyRequest','{\"uenc\":\"aHR0cHM6Ly9oeXZhLXN0YWdpbmcuYmFueW8uY28udWsvZnJhbmtlLW15dGhvcy1teXgtMTEwLTQ1LXVuZGVybW91bnQtc2luZ2xlLWJvd2wtc2luay1zdGFpbmxlc3Mtc3RlZWwuaHRtbA~~\",\"product\":\"6036\",\"selected_configurable_option\":\"\",\"related_product\":\"\",\"item\":\"6036\",\"id\":\"6036\",\"qty\":1}');
/*!40000 ALTER TABLE `quote_item_option` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `quote_payment`
--

DROP TABLE IF EXISTS `quote_payment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `quote_payment` (
  `payment_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Payment ID',
  `quote_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Quote ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `method` varchar(255) DEFAULT NULL COMMENT 'Method',
  `cc_type` varchar(255) DEFAULT NULL COMMENT 'Cc Type',
  `cc_number_enc` varchar(255) DEFAULT NULL COMMENT 'Cc Number Enc',
  `cc_last_4` varchar(255) DEFAULT NULL COMMENT 'Cc Last 4',
  `cc_cid_enc` varchar(255) DEFAULT NULL COMMENT 'Cc Cid Enc',
  `cc_owner` varchar(255) DEFAULT NULL COMMENT 'Cc Owner',
  `cc_exp_month` varchar(255) DEFAULT NULL COMMENT 'Cc Exp Month',
  `cc_exp_year` smallint unsigned DEFAULT '0' COMMENT 'Cc Exp Year',
  `cc_ss_owner` varchar(255) DEFAULT NULL COMMENT 'Cc Ss Owner',
  `cc_ss_start_month` smallint unsigned DEFAULT '0' COMMENT 'Cc Ss Start Month',
  `cc_ss_start_year` smallint unsigned DEFAULT '0' COMMENT 'Cc Ss Start Year',
  `po_number` varchar(255) DEFAULT NULL COMMENT 'Po Number',
  `additional_data` text COMMENT 'Additional Data',
  `cc_ss_issue` varchar(255) DEFAULT NULL COMMENT 'Cc Ss Issue',
  `additional_information` text COMMENT 'Additional Information',
  `paypal_payer_id` varchar(255) DEFAULT NULL COMMENT 'Paypal Payer ID',
  `paypal_payer_status` varchar(255) DEFAULT NULL COMMENT 'Paypal Payer Status',
  `paypal_correlation_id` varchar(255) DEFAULT NULL COMMENT 'Paypal Correlation ID',
  PRIMARY KEY (`payment_id`),
  KEY `QUOTE_PAYMENT_QUOTE_ID` (`quote_id`),
  CONSTRAINT `QUOTE_PAYMENT_QUOTE_ID_QUOTE_ENTITY_ID` FOREIGN KEY (`quote_id`) REFERENCES `quote` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Quote Payment';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `quote_payment`
--

LOCK TABLES `quote_payment` WRITE;
/*!40000 ALTER TABLE `quote_payment` DISABLE KEYS */;
INSERT INTO `quote_payment` VALUES (1,1,'2025-01-07 13:50:22','2025-01-07 13:50:22','free',NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,0,0,NULL,NULL,NULL,'null',NULL,NULL,NULL),(2,2,'2025-01-07 13:54:04','2025-01-07 13:54:04','checkmo',NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,0,0,NULL,NULL,NULL,'null',NULL,NULL,NULL),(3,6,'2025-01-28 08:40:36','2025-01-28 08:40:36','checkmo',NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,0,0,NULL,NULL,NULL,'null',NULL,NULL,NULL),(4,8,'2025-01-29 15:39:32','2025-01-29 15:39:32','checkmo',NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,0,0,NULL,NULL,NULL,'null',NULL,NULL,NULL),(5,9,'2025-01-29 15:54:10','2025-01-29 15:54:10',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,0,0,NULL,NULL,NULL,'null',NULL,NULL,NULL),(6,10,'2025-01-29 15:54:15','2025-01-29 15:54:15',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,0,0,NULL,NULL,NULL,'null',NULL,NULL,NULL),(7,11,'2025-01-29 15:54:20','2025-01-29 15:54:20','adminpaymentmethod',NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,0,0,NULL,NULL,NULL,'null',NULL,NULL,NULL),(8,12,'2025-01-31 08:00:58','2025-01-31 08:00:58',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,0,0,NULL,NULL,NULL,'null',NULL,NULL,NULL),(9,13,'2025-02-04 06:52:03','2025-02-04 06:52:03',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,0,0,NULL,NULL,NULL,'null',NULL,NULL,NULL);
/*!40000 ALTER TABLE `quote_payment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `quote_shipping_rate`
--

DROP TABLE IF EXISTS `quote_shipping_rate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `quote_shipping_rate` (
  `rate_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rate ID',
  `address_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Address ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `carrier` varchar(255) DEFAULT NULL COMMENT 'Carrier',
  `carrier_title` varchar(255) DEFAULT NULL COMMENT 'Carrier Title',
  `code` varchar(255) DEFAULT NULL COMMENT 'Code',
  `method` varchar(255) DEFAULT NULL COMMENT 'Method',
  `method_description` text COMMENT 'Method Description',
  `price` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Price',
  `error_message` text COMMENT 'Error Message',
  `method_title` text COMMENT 'Method Title',
  PRIMARY KEY (`rate_id`),
  KEY `QUOTE_SHIPPING_RATE_ADDRESS_ID` (`address_id`),
  CONSTRAINT `QUOTE_SHIPPING_RATE_ADDRESS_ID_QUOTE_ADDRESS_ADDRESS_ID` FOREIGN KEY (`address_id`) REFERENCES `quote_address` (`address_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=51 DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Quote Shipping Rate';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `quote_shipping_rate`
--

LOCK TABLES `quote_shipping_rate` WRITE;
/*!40000 ALTER TABLE `quote_shipping_rate` DISABLE KEYS */;
INSERT INTO `quote_shipping_rate` VALUES (7,4,'2025-01-07 13:54:07','2025-01-07 13:54:07','flatrate','Flat Rate','flatrate_flatrate','flatrate',NULL,5.0000,NULL,'Fixed'),(8,4,'2025-01-07 13:54:07','2025-01-07 13:54:07','shipping','Example','shipping_shipping','shipping',NULL,15.0000,NULL,'MageWorx Shipping'),(22,15,'2025-01-28 08:41:05','2025-01-28 08:41:05','flatrate','Flat Rate','flatrate_flatrate','flatrate',NULL,5.0000,NULL,'Fixed'),(23,15,'2025-01-28 08:41:05','2025-01-28 08:41:05','shipping','Example','shipping_shipping','shipping',NULL,15.0000,NULL,'MageWorx Shipping'),(24,15,'2025-01-28 08:41:05','2025-01-28 08:41:05','gazco','Van Delivery','gazco_gazcofire','gazcofire',NULL,45.0000,NULL,'Shipping Test '),(31,18,'2025-01-29 13:58:02','2025-01-29 13:58:02','gazco','Van Delivery','gazco_gazcofire','gazcofire',NULL,45.0000,NULL,'Shipping Test '),(39,21,'2025-01-29 15:40:40','2025-01-29 15:40:40','flatrate','Flat Rate','flatrate_flatrate','flatrate',NULL,5.0000,NULL,'Fixed'),(40,21,'2025-01-29 15:40:40','2025-01-29 15:40:40','shipping','Example','shipping_shipping','shipping',NULL,15.0000,NULL,'MageWorx Shipping'),(41,21,'2025-01-29 15:40:40','2025-01-29 15:40:40','gazco','Van Delivery','gazco_gazcofire','gazcofire',NULL,45.0000,NULL,'Shipping Test '),(42,24,'2025-01-29 15:54:10','2025-01-29 15:54:10','flatrate','Flat Rate','flatrate_flatrate','flatrate',NULL,5.0000,NULL,'Fixed'),(43,24,'2025-01-29 15:54:10','2025-01-29 15:54:10','shipping','Example','shipping_shipping','shipping',NULL,15.0000,NULL,'MageWorx Shipping'),(44,24,'2025-01-29 15:54:10','2025-01-29 15:54:10','gazco','Van Delivery','gazco_gazcofire','gazcofire',NULL,45.0000,NULL,'Shipping Test '),(45,26,'2025-01-29 15:54:15','2025-01-29 15:54:15','flatrate','Flat Rate','flatrate_flatrate','flatrate',NULL,5.0000,NULL,'Fixed'),(46,26,'2025-01-29 15:54:15','2025-01-29 15:54:15','shipping','Example','shipping_shipping','shipping',NULL,15.0000,NULL,'MageWorx Shipping'),(47,26,'2025-01-29 15:54:15','2025-01-29 15:54:15','gazco','Van Delivery','gazco_gazcofire','gazcofire',NULL,45.0000,NULL,'Shipping Test '),(48,28,'2025-01-29 15:54:20','2025-01-29 15:54:20','flatrate','Flat Rate','flatrate_flatrate','flatrate',NULL,5.0000,NULL,'Fixed'),(49,28,'2025-01-29 15:54:20','2025-01-29 15:54:20','shipping','Example','shipping_shipping','shipping',NULL,15.0000,NULL,'MageWorx Shipping'),(50,28,'2025-01-29 15:54:20','2025-01-29 15:54:20','gazco','Van Delivery','gazco_gazcofire','gazcofire',NULL,45.0000,NULL,'Shipping Test ');
/*!40000 ALTER TABLE `quote_shipping_rate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rating`
--

DROP TABLE IF EXISTS `rating`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `rating` (
  `rating_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rating ID',
  `entity_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `rating_code` varchar(64) NOT NULL COMMENT 'Rating Code',
  `position` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Position On Storefront',
  `is_active` smallint NOT NULL DEFAULT '1' COMMENT 'Rating is active.',
  PRIMARY KEY (`rating_id`),
  UNIQUE KEY `RATING_RATING_CODE` (`rating_code`),
  KEY `RATING_ENTITY_ID` (`entity_id`),
  CONSTRAINT `RATING_ENTITY_ID_RATING_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `rating_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COMMENT='Ratings';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rating`
--

LOCK TABLES `rating` WRITE;
/*!40000 ALTER TABLE `rating` DISABLE KEYS */;
INSERT INTO `rating` VALUES (1,1,'Quality',0,1),(2,1,'Value',0,1),(3,1,'Price',0,1);
/*!40000 ALTER TABLE `rating` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rating_entity`
--

DROP TABLE IF EXISTS `rating_entity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `rating_entity` (
  `entity_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `entity_code` varchar(64) NOT NULL COMMENT 'Entity Code',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `RATING_ENTITY_ENTITY_CODE` (`entity_code`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COMMENT='Rating entities';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rating_entity`
--

LOCK TABLES `rating_entity` WRITE;
/*!40000 ALTER TABLE `rating_entity` DISABLE KEYS */;
INSERT INTO `rating_entity` VALUES (1,'product'),(2,'product_review'),(3,'review');
/*!40000 ALTER TABLE `rating_entity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rating_option`
--

DROP TABLE IF EXISTS `rating_option`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `rating_option` (
  `option_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rating Option ID',
  `rating_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Rating ID',
  `code` varchar(32) NOT NULL COMMENT 'Rating Option Code',
  `value` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Option Value',
  `position` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Ration option position on Storefront',
  PRIMARY KEY (`option_id`),
  KEY `RATING_OPTION_RATING_ID` (`rating_id`),
  CONSTRAINT `RATING_OPTION_RATING_ID_RATING_RATING_ID` FOREIGN KEY (`rating_id`) REFERENCES `rating` (`rating_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=utf8mb3 COMMENT='Rating options';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rating_option`
--

LOCK TABLES `rating_option` WRITE;
/*!40000 ALTER TABLE `rating_option` DISABLE KEYS */;
INSERT INTO `rating_option` VALUES (1,1,'1',1,1),(2,1,'2',2,2),(3,1,'3',3,3),(4,1,'4',4,4),(5,1,'5',5,5),(6,2,'1',1,1),(7,2,'2',2,2),(8,2,'3',3,3),(9,2,'4',4,4),(10,2,'5',5,5),(11,3,'1',1,1),(12,3,'2',2,2),(13,3,'3',3,3),(14,3,'4',4,4),(15,3,'5',5,5);
/*!40000 ALTER TABLE `rating_option` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rating_option_vote`
--

DROP TABLE IF EXISTS `rating_option_vote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `rating_option_vote` (
  `vote_id` bigint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Vote ID',
  `option_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Vote option ID',
  `remote_ip` varchar(16) NOT NULL COMMENT 'Customer IP',
  `remote_ip_long` bigint NOT NULL DEFAULT '0' COMMENT 'Customer IP converted to long integer format',
  `customer_id` int unsigned DEFAULT '0' COMMENT 'Customer ID',
  `entity_pk_value` bigint unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `rating_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Rating ID',
  `review_id` bigint unsigned DEFAULT NULL COMMENT 'Review ID',
  `percent` smallint NOT NULL DEFAULT '0' COMMENT 'Percent amount',
  `value` smallint NOT NULL DEFAULT '0' COMMENT 'Vote option value',
  PRIMARY KEY (`vote_id`),
  KEY `RATING_OPTION_VOTE_REVIEW_ID_REVIEW_REVIEW_ID` (`review_id`),
  KEY `RATING_OPTION_VOTE_OPTION_ID` (`option_id`),
  CONSTRAINT `RATING_OPTION_VOTE_OPTION_ID_RATING_OPTION_OPTION_ID` FOREIGN KEY (`option_id`) REFERENCES `rating_option` (`option_id`) ON DELETE CASCADE,
  CONSTRAINT `RATING_OPTION_VOTE_REVIEW_ID_REVIEW_REVIEW_ID` FOREIGN KEY (`review_id`) REFERENCES `review` (`review_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=31 DEFAULT CHARSET=utf8mb3 COMMENT='Rating option values';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rating_option_vote`
--

LOCK TABLES `rating_option_vote` WRITE;
/*!40000 ALTER TABLE `rating_option_vote` DISABLE KEYS */;
/*!40000 ALTER TABLE `rating_option_vote` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rating_option_vote_aggregated`
--

DROP TABLE IF EXISTS `rating_option_vote_aggregated`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `rating_option_vote_aggregated` (
  `primary_id` int NOT NULL AUTO_INCREMENT COMMENT 'Vote aggregation ID',
  `rating_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Rating ID',
  `entity_pk_value` bigint unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `vote_count` int unsigned NOT NULL DEFAULT '0' COMMENT 'Vote dty',
  `vote_value_sum` int unsigned NOT NULL DEFAULT '0' COMMENT 'General vote sum',
  `percent` smallint NOT NULL DEFAULT '0' COMMENT 'Vote percent',
  `percent_approved` smallint DEFAULT '0' COMMENT 'Vote percent approved by admin',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  PRIMARY KEY (`primary_id`),
  KEY `RATING_OPTION_VOTE_AGGREGATED_RATING_ID` (`rating_id`),
  KEY `RATING_OPTION_VOTE_AGGREGATED_STORE_ID` (`store_id`),
  CONSTRAINT `RATING_OPTION_VOTE_AGGREGATED_RATING_ID_RATING_RATING_ID` FOREIGN KEY (`rating_id`) REFERENCES `rating` (`rating_id`) ON DELETE CASCADE,
  CONSTRAINT `RATING_OPTION_VOTE_AGGREGATED_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=31 DEFAULT CHARSET=utf8mb3 COMMENT='Rating vote aggregated';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rating_option_vote_aggregated`
--

LOCK TABLES `rating_option_vote_aggregated` WRITE;
/*!40000 ALTER TABLE `rating_option_vote_aggregated` DISABLE KEYS */;
/*!40000 ALTER TABLE `rating_option_vote_aggregated` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rating_store`
--

DROP TABLE IF EXISTS `rating_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `rating_store` (
  `rating_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Rating ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  PRIMARY KEY (`rating_id`,`store_id`),
  KEY `RATING_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `RATING_STORE_RATING_ID_RATING_RATING_ID` FOREIGN KEY (`rating_id`) REFERENCES `rating` (`rating_id`) ON DELETE CASCADE,
  CONSTRAINT `RATING_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Rating Store';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rating_store`
--

LOCK TABLES `rating_store` WRITE;
/*!40000 ALTER TABLE `rating_store` DISABLE KEYS */;
INSERT INTO `rating_store` VALUES (1,0),(2,0),(3,0),(1,1),(2,1),(3,1);
/*!40000 ALTER TABLE `rating_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rating_title`
--

DROP TABLE IF EXISTS `rating_title`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `rating_title` (
  `rating_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Rating ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `value` varchar(255) NOT NULL COMMENT 'Rating Label',
  PRIMARY KEY (`rating_id`,`store_id`),
  KEY `RATING_TITLE_STORE_ID` (`store_id`),
  CONSTRAINT `RATING_TITLE_RATING_ID_RATING_RATING_ID` FOREIGN KEY (`rating_id`) REFERENCES `rating` (`rating_id`) ON DELETE CASCADE,
  CONSTRAINT `RATING_TITLE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Rating Title';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rating_title`
--

LOCK TABLES `rating_title` WRITE;
/*!40000 ALTER TABLE `rating_title` DISABLE KEYS */;
/*!40000 ALTER TABLE `rating_title` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `release_notification_viewer_log`
--

DROP TABLE IF EXISTS `release_notification_viewer_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `release_notification_viewer_log` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Log ID',
  `viewer_id` int unsigned NOT NULL COMMENT 'Viewer admin user ID',
  `last_view_version` varchar(16) NOT NULL COMMENT 'Viewer last view on product version',
  PRIMARY KEY (`id`),
  UNIQUE KEY `RELEASE_NOTIFICATION_VIEWER_LOG_VIEWER_ID` (`viewer_id`),
  CONSTRAINT `RELEASE_NOTIFICATION_VIEWER_LOG_VIEWER_ID_ADMIN_USER_USER_ID` FOREIGN KEY (`viewer_id`) REFERENCES `admin_user` (`user_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Release Notification Viewer Log Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `release_notification_viewer_log`
--

LOCK TABLES `release_notification_viewer_log` WRITE;
/*!40000 ALTER TABLE `release_notification_viewer_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `release_notification_viewer_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `report_compared_product_index`
--

DROP TABLE IF EXISTS `report_compared_product_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `report_compared_product_index` (
  `index_id` bigint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Index ID',
  `visitor_id` int unsigned DEFAULT NULL COMMENT 'Visitor ID',
  `customer_id` int unsigned DEFAULT NULL COMMENT 'Customer ID',
  `product_id` int unsigned NOT NULL COMMENT 'Product ID',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `added_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Added At',
  PRIMARY KEY (`index_id`),
  UNIQUE KEY `REPORT_COMPARED_PRODUCT_INDEX_VISITOR_ID_PRODUCT_ID` (`visitor_id`,`product_id`),
  UNIQUE KEY `REPORT_COMPARED_PRODUCT_INDEX_CUSTOMER_ID_PRODUCT_ID` (`customer_id`,`product_id`),
  KEY `REPORT_COMPARED_PRODUCT_INDEX_STORE_ID` (`store_id`),
  KEY `REPORT_COMPARED_PRODUCT_INDEX_ADDED_AT` (`added_at`),
  KEY `REPORT_COMPARED_PRODUCT_INDEX_PRODUCT_ID` (`product_id`),
  CONSTRAINT `REPORT_CMPD_PRD_IDX_CSTR_ID_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `REPORT_CMPD_PRD_IDX_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `REPORT_COMPARED_PRODUCT_INDEX_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Reports Compared Product Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `report_compared_product_index`
--

LOCK TABLES `report_compared_product_index` WRITE;
/*!40000 ALTER TABLE `report_compared_product_index` DISABLE KEYS */;
/*!40000 ALTER TABLE `report_compared_product_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `report_event`
--

DROP TABLE IF EXISTS `report_event`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `report_event` (
  `event_id` bigint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Event ID',
  `logged_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Logged At',
  `event_type_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Event Type ID',
  `object_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Object ID',
  `subject_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Subject ID',
  `subtype` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Subtype',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  PRIMARY KEY (`event_id`),
  KEY `REPORT_EVENT_EVENT_TYPE_ID` (`event_type_id`),
  KEY `REPORT_EVENT_SUBJECT_ID` (`subject_id`),
  KEY `REPORT_EVENT_OBJECT_ID` (`object_id`),
  KEY `REPORT_EVENT_SUBTYPE` (`subtype`),
  KEY `REPORT_EVENT_STORE_ID` (`store_id`),
  CONSTRAINT `REPORT_EVENT_EVENT_TYPE_ID_REPORT_EVENT_TYPES_EVENT_TYPE_ID` FOREIGN KEY (`event_type_id`) REFERENCES `report_event_types` (`event_type_id`) ON DELETE CASCADE,
  CONSTRAINT `REPORT_EVENT_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Reports Event Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `report_event`
--

LOCK TABLES `report_event` WRITE;
/*!40000 ALTER TABLE `report_event` DISABLE KEYS */;
/*!40000 ALTER TABLE `report_event` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `report_event_types`
--

DROP TABLE IF EXISTS `report_event_types`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `report_event_types` (
  `event_type_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Event Type ID',
  `event_name` varchar(64) NOT NULL COMMENT 'Event Name',
  `customer_login` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Login',
  PRIMARY KEY (`event_type_id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COMMENT='Reports Event Type Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `report_event_types`
--

LOCK TABLES `report_event_types` WRITE;
/*!40000 ALTER TABLE `report_event_types` DISABLE KEYS */;
INSERT INTO `report_event_types` VALUES (1,'catalog_product_view',0),(2,'sendfriend_product',0),(3,'catalog_product_compare_add_product',0),(4,'checkout_cart_add_product',0),(5,'wishlist_add_product',0),(6,'wishlist_share',0);
/*!40000 ALTER TABLE `report_event_types` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `report_viewed_product_aggregated_daily`
--

DROP TABLE IF EXISTS `report_viewed_product_aggregated_daily`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `report_viewed_product_aggregated_daily` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `product_id` int unsigned DEFAULT NULL COMMENT 'Product ID',
  `product_name` varchar(255) DEFAULT NULL COMMENT 'Product Name',
  `product_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Product Price',
  `views_num` int NOT NULL DEFAULT '0' COMMENT 'Number of Views',
  `rating_pos` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Pos',
  PRIMARY KEY (`id`),
  UNIQUE KEY `REPORT_VIEWED_PRD_AGGRED_DAILY_PERIOD_STORE_ID_PRD_ID` (`period`,`store_id`,`product_id`),
  KEY `REPORT_VIEWED_PRODUCT_AGGREGATED_DAILY_STORE_ID` (`store_id`),
  KEY `REPORT_VIEWED_PRODUCT_AGGREGATED_DAILY_PRODUCT_ID` (`product_id`),
  CONSTRAINT `REPORT_VIEWED_PRD_AGGRED_DAILY_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `REPORT_VIEWED_PRODUCT_AGGREGATED_DAILY_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Most Viewed Products Aggregated Daily';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `report_viewed_product_aggregated_daily`
--

LOCK TABLES `report_viewed_product_aggregated_daily` WRITE;
/*!40000 ALTER TABLE `report_viewed_product_aggregated_daily` DISABLE KEYS */;
/*!40000 ALTER TABLE `report_viewed_product_aggregated_daily` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `report_viewed_product_aggregated_monthly`
--

DROP TABLE IF EXISTS `report_viewed_product_aggregated_monthly`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `report_viewed_product_aggregated_monthly` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `product_id` int unsigned DEFAULT NULL COMMENT 'Product ID',
  `product_name` varchar(255) DEFAULT NULL COMMENT 'Product Name',
  `product_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Product Price',
  `views_num` int NOT NULL DEFAULT '0' COMMENT 'Number of Views',
  `rating_pos` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Pos',
  PRIMARY KEY (`id`),
  UNIQUE KEY `REPORT_VIEWED_PRD_AGGRED_MONTHLY_PERIOD_STORE_ID_PRD_ID` (`period`,`store_id`,`product_id`),
  KEY `REPORT_VIEWED_PRODUCT_AGGREGATED_MONTHLY_STORE_ID` (`store_id`),
  KEY `REPORT_VIEWED_PRODUCT_AGGREGATED_MONTHLY_PRODUCT_ID` (`product_id`),
  CONSTRAINT `REPORT_VIEWED_PRD_AGGRED_MONTHLY_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `REPORT_VIEWED_PRODUCT_AGGREGATED_MONTHLY_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Most Viewed Products Aggregated Monthly';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `report_viewed_product_aggregated_monthly`
--

LOCK TABLES `report_viewed_product_aggregated_monthly` WRITE;
/*!40000 ALTER TABLE `report_viewed_product_aggregated_monthly` DISABLE KEYS */;
/*!40000 ALTER TABLE `report_viewed_product_aggregated_monthly` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `report_viewed_product_aggregated_yearly`
--

DROP TABLE IF EXISTS `report_viewed_product_aggregated_yearly`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `report_viewed_product_aggregated_yearly` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `product_id` int unsigned DEFAULT NULL COMMENT 'Product ID',
  `product_name` varchar(255) DEFAULT NULL COMMENT 'Product Name',
  `product_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Product Price',
  `views_num` int NOT NULL DEFAULT '0' COMMENT 'Number of Views',
  `rating_pos` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Pos',
  PRIMARY KEY (`id`),
  UNIQUE KEY `REPORT_VIEWED_PRD_AGGRED_YEARLY_PERIOD_STORE_ID_PRD_ID` (`period`,`store_id`,`product_id`),
  KEY `REPORT_VIEWED_PRODUCT_AGGREGATED_YEARLY_STORE_ID` (`store_id`),
  KEY `REPORT_VIEWED_PRODUCT_AGGREGATED_YEARLY_PRODUCT_ID` (`product_id`),
  CONSTRAINT `REPORT_VIEWED_PRD_AGGRED_YEARLY_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `REPORT_VIEWED_PRODUCT_AGGREGATED_YEARLY_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Most Viewed Products Aggregated Yearly';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `report_viewed_product_aggregated_yearly`
--

LOCK TABLES `report_viewed_product_aggregated_yearly` WRITE;
/*!40000 ALTER TABLE `report_viewed_product_aggregated_yearly` DISABLE KEYS */;
/*!40000 ALTER TABLE `report_viewed_product_aggregated_yearly` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `report_viewed_product_index`
--

DROP TABLE IF EXISTS `report_viewed_product_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `report_viewed_product_index` (
  `index_id` bigint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Index ID',
  `visitor_id` int unsigned DEFAULT NULL COMMENT 'Visitor ID',
  `customer_id` int unsigned DEFAULT NULL COMMENT 'Customer ID',
  `product_id` int unsigned NOT NULL COMMENT 'Product ID',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `added_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Added At',
  PRIMARY KEY (`index_id`),
  UNIQUE KEY `REPORT_VIEWED_PRODUCT_INDEX_VISITOR_ID_PRODUCT_ID` (`visitor_id`,`product_id`),
  UNIQUE KEY `REPORT_VIEWED_PRODUCT_INDEX_CUSTOMER_ID_PRODUCT_ID` (`customer_id`,`product_id`),
  KEY `REPORT_VIEWED_PRODUCT_INDEX_STORE_ID` (`store_id`),
  KEY `REPORT_VIEWED_PRODUCT_INDEX_ADDED_AT` (`added_at`),
  KEY `REPORT_VIEWED_PRODUCT_INDEX_PRODUCT_ID` (`product_id`),
  CONSTRAINT `REPORT_VIEWED_PRD_IDX_CSTR_ID_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `REPORT_VIEWED_PRD_IDX_PRD_ID_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `REPORT_VIEWED_PRODUCT_INDEX_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Reports Viewed Product Index Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `report_viewed_product_index`
--

LOCK TABLES `report_viewed_product_index` WRITE;
/*!40000 ALTER TABLE `report_viewed_product_index` DISABLE KEYS */;
/*!40000 ALTER TABLE `report_viewed_product_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reporting_counts`
--

DROP TABLE IF EXISTS `reporting_counts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `reporting_counts` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `type` varchar(255) DEFAULT NULL COMMENT 'Item Reported',
  `count` int unsigned DEFAULT NULL COMMENT 'Count Value',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  PRIMARY KEY (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Reporting for all count related events generated via the cron job';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reporting_counts`
--

LOCK TABLES `reporting_counts` WRITE;
/*!40000 ALTER TABLE `reporting_counts` DISABLE KEYS */;
/*!40000 ALTER TABLE `reporting_counts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reporting_module_status`
--

DROP TABLE IF EXISTS `reporting_module_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `reporting_module_status` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Module ID',
  `name` varchar(255) DEFAULT NULL COMMENT 'Module Name',
  `active` varchar(255) DEFAULT NULL COMMENT 'Module Active Status',
  `setup_version` varchar(255) DEFAULT NULL COMMENT 'Module Version',
  `state` varchar(255) DEFAULT NULL COMMENT 'Module State',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  PRIMARY KEY (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Module Status Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reporting_module_status`
--

LOCK TABLES `reporting_module_status` WRITE;
/*!40000 ALTER TABLE `reporting_module_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `reporting_module_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reporting_orders`
--

DROP TABLE IF EXISTS `reporting_orders`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `reporting_orders` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `customer_id` int unsigned DEFAULT NULL COMMENT 'Customer ID',
  `total` decimal(20,4) unsigned DEFAULT NULL,
  `total_base` decimal(20,4) unsigned DEFAULT NULL,
  `item_count` int unsigned NOT NULL COMMENT 'Line Item Count',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Updated At',
  PRIMARY KEY (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Reporting for all orders';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reporting_orders`
--

LOCK TABLES `reporting_orders` WRITE;
/*!40000 ALTER TABLE `reporting_orders` DISABLE KEYS */;
/*!40000 ALTER TABLE `reporting_orders` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reporting_system_updates`
--

DROP TABLE IF EXISTS `reporting_system_updates`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `reporting_system_updates` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `type` varchar(255) DEFAULT NULL COMMENT 'Update Type',
  `action` varchar(255) DEFAULT NULL COMMENT 'Action Performed',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Updated At',
  PRIMARY KEY (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Reporting for system updates';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reporting_system_updates`
--

LOCK TABLES `reporting_system_updates` WRITE;
/*!40000 ALTER TABLE `reporting_system_updates` DISABLE KEYS */;
/*!40000 ALTER TABLE `reporting_system_updates` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reporting_users`
--

DROP TABLE IF EXISTS `reporting_users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `reporting_users` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `type` varchar(255) DEFAULT NULL COMMENT 'User Type',
  `action` varchar(255) DEFAULT NULL COMMENT 'Action Performed',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Updated At',
  PRIMARY KEY (`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Reporting for user actions';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reporting_users`
--

LOCK TABLES `reporting_users` WRITE;
/*!40000 ALTER TABLE `reporting_users` DISABLE KEYS */;
/*!40000 ALTER TABLE `reporting_users` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `review`
--

DROP TABLE IF EXISTS `review`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `review` (
  `review_id` bigint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Review ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Review create date',
  `entity_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `entity_pk_value` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `status_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Status code',
  PRIMARY KEY (`review_id`),
  KEY `REVIEW_ENTITY_ID` (`entity_id`),
  KEY `REVIEW_STATUS_ID` (`status_id`),
  KEY `REVIEW_ENTITY_PK_VALUE` (`entity_pk_value`),
  CONSTRAINT `REVIEW_ENTITY_ID_REVIEW_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `review_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `REVIEW_STATUS_ID_REVIEW_STATUS_STATUS_ID` FOREIGN KEY (`status_id`) REFERENCES `review_status` (`status_id`)
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8mb3 COMMENT='Review base information';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `review`
--

LOCK TABLES `review` WRITE;
/*!40000 ALTER TABLE `review` DISABLE KEYS */;
/*!40000 ALTER TABLE `review` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `review_detail`
--

DROP TABLE IF EXISTS `review_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `review_detail` (
  `detail_id` bigint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Review detail ID',
  `review_id` bigint unsigned NOT NULL DEFAULT '0' COMMENT 'Review ID',
  `store_id` smallint unsigned DEFAULT '0' COMMENT 'Store ID',
  `title` varchar(255) NOT NULL COMMENT 'Title',
  `detail` text NOT NULL COMMENT 'Detail description',
  `nickname` varchar(128) NOT NULL COMMENT 'User nickname',
  `customer_id` int unsigned DEFAULT NULL COMMENT 'Customer ID',
  PRIMARY KEY (`detail_id`),
  KEY `REVIEW_DETAIL_REVIEW_ID` (`review_id`),
  KEY `REVIEW_DETAIL_STORE_ID` (`store_id`),
  KEY `REVIEW_DETAIL_CUSTOMER_ID` (`customer_id`),
  CONSTRAINT `REVIEW_DETAIL_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE SET NULL,
  CONSTRAINT `REVIEW_DETAIL_REVIEW_ID_REVIEW_REVIEW_ID` FOREIGN KEY (`review_id`) REFERENCES `review` (`review_id`) ON DELETE CASCADE,
  CONSTRAINT `REVIEW_DETAIL_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8mb3 COMMENT='Review detail information';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `review_detail`
--

LOCK TABLES `review_detail` WRITE;
/*!40000 ALTER TABLE `review_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `review_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `review_entity`
--

DROP TABLE IF EXISTS `review_entity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `review_entity` (
  `entity_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Review entity ID',
  `entity_code` varchar(32) NOT NULL COMMENT 'Review entity code',
  PRIMARY KEY (`entity_id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COMMENT='Review entities';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `review_entity`
--

LOCK TABLES `review_entity` WRITE;
/*!40000 ALTER TABLE `review_entity` DISABLE KEYS */;
INSERT INTO `review_entity` VALUES (1,'product'),(2,'customer'),(3,'category');
/*!40000 ALTER TABLE `review_entity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `review_entity_summary`
--

DROP TABLE IF EXISTS `review_entity_summary`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `review_entity_summary` (
  `primary_id` bigint NOT NULL AUTO_INCREMENT COMMENT 'Summary review entity ID',
  `entity_pk_value` bigint NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `entity_type` smallint NOT NULL DEFAULT '0' COMMENT 'Entity type ID',
  `reviews_count` smallint NOT NULL DEFAULT '0' COMMENT 'Qty of reviews',
  `rating_summary` smallint NOT NULL DEFAULT '0' COMMENT 'Summarized rating',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  PRIMARY KEY (`primary_id`),
  UNIQUE KEY `REVIEW_ENTITY_SUMMARY_ENTITY_PK_VALUE_STORE_ID_ENTITY_TYPE` (`entity_pk_value`,`store_id`,`entity_type`),
  KEY `REVIEW_ENTITY_SUMMARY_STORE_ID` (`store_id`),
  KEY `REVIEW_ENTITY_SUMMARY_ENTITY_TYPE_ENTITY_PK_VALUE_STORE_ID` (`entity_type`,`entity_pk_value`,`store_id`),
  CONSTRAINT `REVIEW_ENTITY_SUMMARY_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=utf8mb3 COMMENT='Review aggregates';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `review_entity_summary`
--

LOCK TABLES `review_entity_summary` WRITE;
/*!40000 ALTER TABLE `review_entity_summary` DISABLE KEYS */;
/*!40000 ALTER TABLE `review_entity_summary` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `review_status`
--

DROP TABLE IF EXISTS `review_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `review_status` (
  `status_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Status ID',
  `status_code` varchar(32) NOT NULL COMMENT 'Status code',
  PRIMARY KEY (`status_id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COMMENT='Review statuses';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `review_status`
--

LOCK TABLES `review_status` WRITE;
/*!40000 ALTER TABLE `review_status` DISABLE KEYS */;
INSERT INTO `review_status` VALUES (1,'Approved'),(2,'Pending'),(3,'Not Approved');
/*!40000 ALTER TABLE `review_status` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `review_store`
--

DROP TABLE IF EXISTS `review_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `review_store` (
  `review_id` bigint unsigned NOT NULL COMMENT 'Review ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  PRIMARY KEY (`review_id`,`store_id`),
  KEY `REVIEW_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `REVIEW_STORE_REVIEW_ID_REVIEW_REVIEW_ID` FOREIGN KEY (`review_id`) REFERENCES `review` (`review_id`) ON DELETE CASCADE,
  CONSTRAINT `REVIEW_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Review Store';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `review_store`
--

LOCK TABLES `review_store` WRITE;
/*!40000 ALTER TABLE `review_store` DISABLE KEYS */;
/*!40000 ALTER TABLE `review_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_bestsellers_aggregated_daily`
--

DROP TABLE IF EXISTS `sales_bestsellers_aggregated_daily`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_bestsellers_aggregated_daily` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `product_id` int unsigned DEFAULT NULL COMMENT 'Product ID',
  `product_name` varchar(255) DEFAULT NULL COMMENT 'Product Name',
  `product_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Product Price',
  `qty_ordered` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty Ordered',
  `rating_pos` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Pos',
  PRIMARY KEY (`id`),
  UNIQUE KEY `SALES_BESTSELLERS_AGGREGATED_DAILY_PERIOD_STORE_ID_PRODUCT_ID` (`period`,`store_id`,`product_id`),
  KEY `SALES_BESTSELLERS_AGGREGATED_DAILY_STORE_ID` (`store_id`),
  KEY `SALES_BESTSELLERS_AGGREGATED_DAILY_PRODUCT_ID` (`product_id`),
  CONSTRAINT `SALES_BESTSELLERS_AGGREGATED_DAILY_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Bestsellers Aggregated Daily';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_bestsellers_aggregated_daily`
--

LOCK TABLES `sales_bestsellers_aggregated_daily` WRITE;
/*!40000 ALTER TABLE `sales_bestsellers_aggregated_daily` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_bestsellers_aggregated_daily` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_bestsellers_aggregated_monthly`
--

DROP TABLE IF EXISTS `sales_bestsellers_aggregated_monthly`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_bestsellers_aggregated_monthly` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `product_id` int unsigned DEFAULT NULL COMMENT 'Product ID',
  `product_name` varchar(255) DEFAULT NULL COMMENT 'Product Name',
  `product_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Product Price',
  `qty_ordered` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty Ordered',
  `rating_pos` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Pos',
  PRIMARY KEY (`id`),
  UNIQUE KEY `SALES_BESTSELLERS_AGGREGATED_MONTHLY_PERIOD_STORE_ID_PRODUCT_ID` (`period`,`store_id`,`product_id`),
  KEY `SALES_BESTSELLERS_AGGREGATED_MONTHLY_STORE_ID` (`store_id`),
  KEY `SALES_BESTSELLERS_AGGREGATED_MONTHLY_PRODUCT_ID` (`product_id`),
  CONSTRAINT `SALES_BESTSELLERS_AGGREGATED_MONTHLY_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Bestsellers Aggregated Monthly';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_bestsellers_aggregated_monthly`
--

LOCK TABLES `sales_bestsellers_aggregated_monthly` WRITE;
/*!40000 ALTER TABLE `sales_bestsellers_aggregated_monthly` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_bestsellers_aggregated_monthly` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_bestsellers_aggregated_yearly`
--

DROP TABLE IF EXISTS `sales_bestsellers_aggregated_yearly`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_bestsellers_aggregated_yearly` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `product_id` int unsigned DEFAULT NULL COMMENT 'Product ID',
  `product_name` varchar(255) DEFAULT NULL COMMENT 'Product Name',
  `product_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Product Price',
  `qty_ordered` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty Ordered',
  `rating_pos` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Pos',
  PRIMARY KEY (`id`),
  UNIQUE KEY `SALES_BESTSELLERS_AGGREGATED_YEARLY_PERIOD_STORE_ID_PRODUCT_ID` (`period`,`store_id`,`product_id`),
  KEY `SALES_BESTSELLERS_AGGREGATED_YEARLY_STORE_ID` (`store_id`),
  KEY `SALES_BESTSELLERS_AGGREGATED_YEARLY_PRODUCT_ID` (`product_id`),
  CONSTRAINT `SALES_BESTSELLERS_AGGREGATED_YEARLY_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Bestsellers Aggregated Yearly';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_bestsellers_aggregated_yearly`
--

LOCK TABLES `sales_bestsellers_aggregated_yearly` WRITE;
/*!40000 ALTER TABLE `sales_bestsellers_aggregated_yearly` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_bestsellers_aggregated_yearly` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_creditmemo`
--

DROP TABLE IF EXISTS `sales_creditmemo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_creditmemo` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `adjustment_positive` decimal(20,4) DEFAULT NULL COMMENT 'Adjustment Positive',
  `base_shipping_tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Tax Amount',
  `store_to_order_rate` decimal(20,4) DEFAULT NULL COMMENT 'Store To Order Rate',
  `base_discount_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Amount',
  `base_to_order_rate` decimal(20,4) DEFAULT NULL COMMENT 'Base To Order Rate',
  `grand_total` decimal(20,4) DEFAULT NULL COMMENT 'Grand Total',
  `base_adjustment_negative` decimal(20,4) DEFAULT NULL COMMENT 'Base Adjustment Negative',
  `base_subtotal_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Subtotal Incl Tax',
  `shipping_amount` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Amount',
  `subtotal_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Subtotal Incl Tax',
  `adjustment_negative` decimal(20,4) DEFAULT NULL COMMENT 'Adjustment Negative',
  `base_shipping_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Amount',
  `store_to_base_rate` decimal(20,4) DEFAULT NULL COMMENT 'Store To Base Rate',
  `base_to_global_rate` decimal(20,4) DEFAULT NULL COMMENT 'Base To Global Rate',
  `base_adjustment` decimal(20,4) DEFAULT NULL COMMENT 'Base Adjustment',
  `base_subtotal` decimal(20,4) DEFAULT NULL COMMENT 'Base Subtotal',
  `discount_amount` decimal(20,4) DEFAULT NULL COMMENT 'Discount Amount',
  `subtotal` decimal(20,4) DEFAULT NULL COMMENT 'Subtotal',
  `adjustment` decimal(20,4) DEFAULT NULL COMMENT 'Adjustment',
  `base_grand_total` decimal(20,4) DEFAULT NULL COMMENT 'Base Grand Total',
  `base_adjustment_positive` decimal(20,4) DEFAULT NULL COMMENT 'Base Adjustment Positive',
  `base_tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Tax Amount',
  `shipping_tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Tax Amount',
  `tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Tax Amount',
  `order_id` int unsigned NOT NULL COMMENT 'Order ID',
  `email_sent` smallint unsigned DEFAULT NULL COMMENT 'Email Sent',
  `send_email` smallint unsigned DEFAULT NULL COMMENT 'Send Email',
  `creditmemo_status` int DEFAULT NULL COMMENT 'Creditmemo Status',
  `state` int DEFAULT NULL COMMENT 'State',
  `shipping_address_id` int DEFAULT NULL COMMENT 'Shipping Address ID',
  `billing_address_id` int DEFAULT NULL COMMENT 'Billing Address ID',
  `invoice_id` int DEFAULT NULL COMMENT 'Invoice ID',
  `store_currency_code` varchar(3) DEFAULT NULL COMMENT 'Store Currency Code',
  `order_currency_code` varchar(3) DEFAULT NULL COMMENT 'Order Currency Code',
  `base_currency_code` varchar(3) DEFAULT NULL COMMENT 'Base Currency Code',
  `global_currency_code` varchar(3) DEFAULT NULL COMMENT 'Global Currency Code',
  `transaction_id` varchar(255) DEFAULT NULL COMMENT 'Transaction ID',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Discount Tax Compensation Amount',
  `base_discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Tax Compensation Amount',
  `shipping_discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Discount Tax Compensation Amount',
  `base_shipping_discount_tax_compensation_amnt` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Discount Tax Compensation Amount',
  `shipping_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Incl Tax',
  `base_shipping_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Incl Tax',
  `discount_description` varchar(255) DEFAULT NULL COMMENT 'Discount Description',
  `customer_note` text COMMENT 'Customer Note',
  `customer_note_notify` smallint unsigned DEFAULT NULL COMMENT 'Customer Note Notify',
  `mollie_payment_fee` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  `mollie_payment_fee_tax` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  `base_mollie_payment_fee` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  `base_mollie_payment_fee_tax` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `SALES_CREDITMEMO_INCREMENT_ID_STORE_ID` (`increment_id`,`store_id`),
  KEY `SALES_CREDITMEMO_STORE_ID` (`store_id`),
  KEY `SALES_CREDITMEMO_ORDER_ID` (`order_id`),
  KEY `SALES_CREDITMEMO_CREDITMEMO_STATUS` (`creditmemo_status`),
  KEY `SALES_CREDITMEMO_STATE` (`state`),
  KEY `SALES_CREDITMEMO_CREATED_AT` (`created_at`),
  KEY `SALES_CREDITMEMO_UPDATED_AT` (`updated_at`),
  KEY `SALES_CREDITMEMO_SEND_EMAIL` (`send_email`),
  KEY `SALES_CREDITMEMO_EMAIL_SENT` (`email_sent`),
  CONSTRAINT `SALES_CREDITMEMO_ORDER_ID_SALES_ORDER_ENTITY_ID` FOREIGN KEY (`order_id`) REFERENCES `sales_order` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `SALES_CREDITMEMO_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Creditmemo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_creditmemo`
--

LOCK TABLES `sales_creditmemo` WRITE;
/*!40000 ALTER TABLE `sales_creditmemo` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_creditmemo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_creditmemo_comment`
--

DROP TABLE IF EXISTS `sales_creditmemo_comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_creditmemo_comment` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `parent_id` int unsigned NOT NULL COMMENT 'Parent ID',
  `is_customer_notified` int DEFAULT NULL COMMENT 'Is Customer Notified',
  `is_visible_on_front` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Visible On Front',
  `comment` text COMMENT 'Comment',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  PRIMARY KEY (`entity_id`),
  KEY `SALES_CREDITMEMO_COMMENT_CREATED_AT` (`created_at`),
  KEY `SALES_CREDITMEMO_COMMENT_PARENT_ID` (`parent_id`),
  CONSTRAINT `SALES_CREDITMEMO_COMMENT_PARENT_ID_SALES_CREDITMEMO_ENTITY_ID` FOREIGN KEY (`parent_id`) REFERENCES `sales_creditmemo` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Creditmemo Comment';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_creditmemo_comment`
--

LOCK TABLES `sales_creditmemo_comment` WRITE;
/*!40000 ALTER TABLE `sales_creditmemo_comment` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_creditmemo_comment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_creditmemo_grid`
--

DROP TABLE IF EXISTS `sales_creditmemo_grid`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_creditmemo_grid` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment ID',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `order_id` int unsigned NOT NULL COMMENT 'Order ID',
  `order_increment_id` varchar(50) DEFAULT NULL COMMENT 'Order Increment ID',
  `order_created_at` timestamp NULL DEFAULT NULL COMMENT 'Order Created At',
  `billing_name` varchar(255) DEFAULT NULL COMMENT 'Billing Name',
  `state` int DEFAULT NULL COMMENT 'Status',
  `base_grand_total` decimal(20,4) DEFAULT NULL COMMENT 'Base Grand Total',
  `order_status` varchar(32) DEFAULT NULL COMMENT 'Order Status',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `billing_address` varchar(255) DEFAULT NULL COMMENT 'Billing Address',
  `shipping_address` varchar(255) DEFAULT NULL COMMENT 'Shipping Address',
  `customer_name` varchar(128) NOT NULL COMMENT 'Customer Name',
  `customer_email` varchar(128) DEFAULT NULL COMMENT 'Customer Email',
  `customer_group_id` smallint DEFAULT NULL COMMENT 'Customer Group ID',
  `payment_method` varchar(32) DEFAULT NULL COMMENT 'Payment Method',
  `shipping_information` varchar(255) DEFAULT NULL COMMENT 'Shipping Method Name',
  `subtotal` decimal(20,4) DEFAULT NULL COMMENT 'Subtotal',
  `shipping_and_handling` decimal(20,4) DEFAULT NULL COMMENT 'Shipping and handling amount',
  `adjustment_positive` decimal(20,4) DEFAULT NULL COMMENT 'Adjustment Positive',
  `adjustment_negative` decimal(20,4) DEFAULT NULL COMMENT 'Adjustment Negative',
  `order_base_grand_total` decimal(20,4) DEFAULT NULL COMMENT 'Order Grand Total',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `SALES_CREDITMEMO_GRID_INCREMENT_ID_STORE_ID` (`increment_id`,`store_id`),
  KEY `SALES_CREDITMEMO_GRID_ORDER_INCREMENT_ID` (`order_increment_id`),
  KEY `SALES_CREDITMEMO_GRID_CREATED_AT` (`created_at`),
  KEY `SALES_CREDITMEMO_GRID_UPDATED_AT` (`updated_at`),
  KEY `SALES_CREDITMEMO_GRID_ORDER_CREATED_AT` (`order_created_at`),
  KEY `SALES_CREDITMEMO_GRID_STATE` (`state`),
  KEY `SALES_CREDITMEMO_GRID_BILLING_NAME` (`billing_name`),
  KEY `SALES_CREDITMEMO_GRID_ORDER_STATUS` (`order_status`),
  KEY `SALES_CREDITMEMO_GRID_BASE_GRAND_TOTAL` (`base_grand_total`),
  KEY `SALES_CREDITMEMO_GRID_STORE_ID` (`store_id`),
  KEY `SALES_CREDITMEMO_GRID_ORDER_BASE_GRAND_TOTAL` (`order_base_grand_total`),
  KEY `SALES_CREDITMEMO_GRID_ORDER_ID` (`order_id`),
  FULLTEXT KEY `FTI_32B7BA885941A8254EE84AE650ABDC86` (`increment_id`,`order_increment_id`,`billing_name`,`billing_address`,`shipping_address`,`customer_name`,`customer_email`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Creditmemo Grid';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_creditmemo_grid`
--

LOCK TABLES `sales_creditmemo_grid` WRITE;
/*!40000 ALTER TABLE `sales_creditmemo_grid` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_creditmemo_grid` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_creditmemo_item`
--

DROP TABLE IF EXISTS `sales_creditmemo_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_creditmemo_item` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `parent_id` int unsigned NOT NULL COMMENT 'Parent ID',
  `base_price` decimal(20,4) DEFAULT NULL COMMENT 'Base Price',
  `tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Tax Amount',
  `base_row_total` decimal(20,4) DEFAULT NULL COMMENT 'Base Row Total',
  `discount_amount` decimal(20,4) DEFAULT NULL COMMENT 'Discount Amount',
  `row_total` decimal(20,4) DEFAULT NULL COMMENT 'Row Total',
  `base_discount_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Amount',
  `price_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Price Incl Tax',
  `base_tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Tax Amount',
  `base_price_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Price Incl Tax',
  `qty` decimal(12,4) DEFAULT NULL COMMENT 'Qty',
  `base_cost` decimal(20,4) DEFAULT NULL COMMENT 'Base Cost',
  `price` decimal(20,4) DEFAULT NULL COMMENT 'Price',
  `base_row_total_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Row Total Incl Tax',
  `row_total_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Row Total Incl Tax',
  `product_id` int DEFAULT NULL COMMENT 'Product ID',
  `order_item_id` int DEFAULT NULL COMMENT 'Order Item ID',
  `additional_data` text COMMENT 'Additional Data',
  `description` text COMMENT 'Description',
  `sku` varchar(255) DEFAULT NULL COMMENT 'Sku',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Discount Tax Compensation Amount',
  `base_discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Tax Compensation Amount',
  `tax_ratio` text COMMENT 'Ratio of tax in the creditmemo item over tax of the order item',
  `weee_tax_applied` text COMMENT 'Weee Tax Applied',
  `weee_tax_applied_amount` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Applied Amount',
  `weee_tax_applied_row_amount` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Applied Row Amount',
  `weee_tax_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Disposition',
  `weee_tax_row_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Row Disposition',
  `base_weee_tax_applied_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Applied Amount',
  `base_weee_tax_applied_row_amnt` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Applied Row Amnt',
  `base_weee_tax_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Disposition',
  `base_weee_tax_row_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Row Disposition',
  PRIMARY KEY (`entity_id`),
  KEY `SALES_CREDITMEMO_ITEM_PARENT_ID` (`parent_id`),
  CONSTRAINT `SALES_CREDITMEMO_ITEM_PARENT_ID_SALES_CREDITMEMO_ENTITY_ID` FOREIGN KEY (`parent_id`) REFERENCES `sales_creditmemo` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Creditmemo Item';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_creditmemo_item`
--

LOCK TABLES `sales_creditmemo_item` WRITE;
/*!40000 ALTER TABLE `sales_creditmemo_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_creditmemo_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_data_exporter_order_statuses`
--

DROP TABLE IF EXISTS `sales_data_exporter_order_statuses`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_data_exporter_order_statuses` (
  `status` varchar(255) NOT NULL COMMENT 'status',
  `feed_data` mediumtext NOT NULL COMMENT 'Feed Data',
  `modified_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Modified At',
  PRIMARY KEY (`status`),
  KEY `SALES_DATA_EXPORTER_ORDER_STATUSES_MODIFIED_AT` (`modified_at`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Order Statuses Feed Storage';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_data_exporter_order_statuses`
--

LOCK TABLES `sales_data_exporter_order_statuses` WRITE;
/*!40000 ALTER TABLE `sales_data_exporter_order_statuses` DISABLE KEYS */;
INSERT INTO `sales_data_exporter_order_statuses` VALUES ('canceled','{\"status\":\"canceled\",\"label\":\"Canceled\"}','2025-02-05 07:30:48'),('closed','{\"status\":\"closed\",\"label\":\"Closed\"}','2025-02-05 07:30:48'),('complete','{\"status\":\"complete\",\"label\":\"Complete\"}','2025-02-05 07:30:48'),('fraud','{\"status\":\"fraud\",\"label\":\"Suspected Fraud\"}','2025-02-05 07:30:48'),('holded','{\"status\":\"holded\",\"label\":\"On Hold\"}','2025-02-05 07:30:48'),('payment_review','{\"status\":\"payment_review\",\"label\":\"Payment Review\"}','2025-02-05 07:30:48'),('paypal_canceled_reversal','{\"status\":\"paypal_canceled_reversal\",\"label\":\"PayPal Canceled Reversal\"}','2025-02-05 07:30:48'),('paypal_reversed','{\"status\":\"paypal_reversed\",\"label\":\"PayPal Reversed\"}','2025-02-05 07:30:48'),('pending','{\"status\":\"pending\",\"label\":\"Pending\"}','2025-02-05 07:30:48'),('pending_payment','{\"status\":\"pending_payment\",\"label\":\"Pending Payment\"}','2025-02-05 07:30:48'),('pending_paypal','{\"status\":\"pending_paypal\",\"label\":\"Pending PayPal\"}','2025-02-05 07:30:48'),('processing','{\"status\":\"processing\",\"label\":\"Processing\"}','2025-02-05 07:30:48');
/*!40000 ALTER TABLE `sales_data_exporter_order_statuses` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_data_exporter_order_statuses_index_batches`
--

DROP TABLE IF EXISTS `sales_data_exporter_order_statuses_index_batches`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_data_exporter_order_statuses_index_batches` (
  `batch_number` int NOT NULL COMMENT 'Batch Number',
  `status` varchar(32) NOT NULL COMMENT 'Status',
  PRIMARY KEY (`batch_number`,`status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='sales_data_exporter_order_statuses_index_batches';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_data_exporter_order_statuses_index_batches`
--

LOCK TABLES `sales_data_exporter_order_statuses_index_batches` WRITE;
/*!40000 ALTER TABLE `sales_data_exporter_order_statuses_index_batches` DISABLE KEYS */;
INSERT INTO `sales_data_exporter_order_statuses_index_batches` VALUES (1,'canceled'),(1,'closed'),(1,'complete'),(1,'fraud'),(1,'holded'),(1,'payment_review'),(1,'paypal_canceled_reversal'),(1,'paypal_reversed'),(1,'pending'),(1,'pending_payment'),(1,'pending_paypal'),(1,'processing');
/*!40000 ALTER TABLE `sales_data_exporter_order_statuses_index_batches` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_data_exporter_order_statuses_index_sequence`
--

DROP TABLE IF EXISTS `sales_data_exporter_order_statuses_index_sequence`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_data_exporter_order_statuses_index_sequence` (
  `i` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Auto Increment ID',
  PRIMARY KEY (`i`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COMMENT='sales_data_exporter_order_statuses_index_sequence';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_data_exporter_order_statuses_index_sequence`
--

LOCK TABLES `sales_data_exporter_order_statuses_index_sequence` WRITE;
/*!40000 ALTER TABLE `sales_data_exporter_order_statuses_index_sequence` DISABLE KEYS */;
INSERT INTO `sales_data_exporter_order_statuses_index_sequence` VALUES (1),(2);
/*!40000 ALTER TABLE `sales_data_exporter_order_statuses_index_sequence` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_data_exporter_orders`
--

DROP TABLE IF EXISTS `sales_data_exporter_orders`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_data_exporter_orders` (
  `id` int unsigned NOT NULL COMMENT 'ID',
  `mode` varchar(255) NOT NULL COMMENT 'Order Payment Mode',
  `feed_data` mediumtext NOT NULL COMMENT 'Feed Data',
  `modified_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Modified At',
  PRIMARY KEY (`id`),
  KEY `SALES_DATA_EXPORTER_ORDERS_MODIFIED_AT` (`modified_at`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Orders Feed Storage';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_data_exporter_orders`
--

LOCK TABLES `sales_data_exporter_orders` WRITE;
/*!40000 ALTER TABLE `sales_data_exporter_orders` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_data_exporter_orders` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_data_exporter_orders_index_batches`
--

DROP TABLE IF EXISTS `sales_data_exporter_orders_index_batches`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_data_exporter_orders_index_batches` (
  `batch_number` int NOT NULL COMMENT 'Batch Number',
  `entity_id` int unsigned NOT NULL COMMENT 'Entity Id',
  PRIMARY KEY (`batch_number`,`entity_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='sales_data_exporter_orders_index_batches';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_data_exporter_orders_index_batches`
--

LOCK TABLES `sales_data_exporter_orders_index_batches` WRITE;
/*!40000 ALTER TABLE `sales_data_exporter_orders_index_batches` DISABLE KEYS */;
INSERT INTO `sales_data_exporter_orders_index_batches` VALUES (1,1),(1,2),(1,3),(1,4);
/*!40000 ALTER TABLE `sales_data_exporter_orders_index_batches` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_data_exporter_orders_index_sequence`
--

DROP TABLE IF EXISTS `sales_data_exporter_orders_index_sequence`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_data_exporter_orders_index_sequence` (
  `i` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Auto Increment ID',
  PRIMARY KEY (`i`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COMMENT='sales_data_exporter_orders_index_sequence';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_data_exporter_orders_index_sequence`
--

LOCK TABLES `sales_data_exporter_orders_index_sequence` WRITE;
/*!40000 ALTER TABLE `sales_data_exporter_orders_index_sequence` DISABLE KEYS */;
INSERT INTO `sales_data_exporter_orders_index_sequence` VALUES (1),(2);
/*!40000 ALTER TABLE `sales_data_exporter_orders_index_sequence` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_invoice`
--

DROP TABLE IF EXISTS `sales_invoice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_invoice` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `base_grand_total` decimal(20,4) DEFAULT NULL COMMENT 'Base Grand Total',
  `shipping_tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Tax Amount',
  `tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Tax Amount',
  `base_tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Tax Amount',
  `store_to_order_rate` decimal(20,4) DEFAULT NULL COMMENT 'Store To Order Rate',
  `base_shipping_tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Tax Amount',
  `base_discount_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Amount',
  `base_to_order_rate` decimal(20,4) DEFAULT NULL COMMENT 'Base To Order Rate',
  `grand_total` decimal(20,4) DEFAULT NULL COMMENT 'Grand Total',
  `shipping_amount` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Amount',
  `subtotal_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Subtotal Incl Tax',
  `base_subtotal_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Subtotal Incl Tax',
  `store_to_base_rate` decimal(20,4) DEFAULT NULL COMMENT 'Store To Base Rate',
  `base_shipping_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Amount',
  `total_qty` decimal(12,4) DEFAULT NULL COMMENT 'Total Qty',
  `base_to_global_rate` decimal(20,4) DEFAULT NULL COMMENT 'Base To Global Rate',
  `subtotal` decimal(20,4) DEFAULT NULL COMMENT 'Subtotal',
  `base_subtotal` decimal(20,4) DEFAULT NULL COMMENT 'Base Subtotal',
  `discount_amount` decimal(20,4) DEFAULT NULL COMMENT 'Discount Amount',
  `billing_address_id` int DEFAULT NULL COMMENT 'Billing Address ID',
  `is_used_for_refund` smallint unsigned DEFAULT NULL COMMENT 'Is Used For Refund',
  `order_id` int unsigned NOT NULL COMMENT 'Order ID',
  `email_sent` smallint unsigned DEFAULT NULL COMMENT 'Email Sent',
  `send_email` smallint unsigned DEFAULT NULL COMMENT 'Send Email',
  `can_void_flag` smallint unsigned DEFAULT NULL COMMENT 'Can Void Flag',
  `state` int DEFAULT NULL COMMENT 'State',
  `shipping_address_id` int DEFAULT NULL COMMENT 'Shipping Address ID',
  `store_currency_code` varchar(3) DEFAULT NULL COMMENT 'Store Currency Code',
  `transaction_id` varchar(255) DEFAULT NULL COMMENT 'Transaction ID',
  `order_currency_code` varchar(3) DEFAULT NULL COMMENT 'Order Currency Code',
  `base_currency_code` varchar(3) DEFAULT NULL COMMENT 'Base Currency Code',
  `global_currency_code` varchar(3) DEFAULT NULL COMMENT 'Global Currency Code',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Discount Tax Compensation Amount',
  `base_discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Tax Compensation Amount',
  `shipping_discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Discount Tax Compensation Amount',
  `base_shipping_discount_tax_compensation_amnt` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Discount Tax Compensation Amount',
  `shipping_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Incl Tax',
  `base_shipping_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Incl Tax',
  `base_total_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Base Total Refunded',
  `discount_description` varchar(255) DEFAULT NULL COMMENT 'Discount Description',
  `customer_note` text COMMENT 'Customer Note',
  `customer_note_notify` smallint unsigned DEFAULT NULL COMMENT 'Customer Note Notify',
  `mollie_payment_fee` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  `mollie_payment_fee_tax` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  `base_mollie_payment_fee` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  `base_mollie_payment_fee_tax` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `SALES_INVOICE_INCREMENT_ID_STORE_ID` (`increment_id`,`store_id`),
  KEY `SALES_INVOICE_STORE_ID` (`store_id`),
  KEY `SALES_INVOICE_GRAND_TOTAL` (`grand_total`),
  KEY `SALES_INVOICE_ORDER_ID` (`order_id`),
  KEY `SALES_INVOICE_STATE` (`state`),
  KEY `SALES_INVOICE_CREATED_AT` (`created_at`),
  KEY `SALES_INVOICE_UPDATED_AT` (`updated_at`),
  KEY `SALES_INVOICE_SEND_EMAIL` (`send_email`),
  KEY `SALES_INVOICE_EMAIL_SENT` (`email_sent`),
  CONSTRAINT `SALES_INVOICE_ORDER_ID_SALES_ORDER_ENTITY_ID` FOREIGN KEY (`order_id`) REFERENCES `sales_order` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `SALES_INVOICE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Invoice';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_invoice`
--

LOCK TABLES `sales_invoice` WRITE;
/*!40000 ALTER TABLE `sales_invoice` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_invoice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_invoice_comment`
--

DROP TABLE IF EXISTS `sales_invoice_comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_invoice_comment` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `parent_id` int unsigned NOT NULL COMMENT 'Parent ID',
  `is_customer_notified` smallint unsigned DEFAULT NULL COMMENT 'Is Customer Notified',
  `is_visible_on_front` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Visible On Front',
  `comment` text COMMENT 'Comment',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  PRIMARY KEY (`entity_id`),
  KEY `SALES_INVOICE_COMMENT_CREATED_AT` (`created_at`),
  KEY `SALES_INVOICE_COMMENT_PARENT_ID` (`parent_id`),
  CONSTRAINT `SALES_INVOICE_COMMENT_PARENT_ID_SALES_INVOICE_ENTITY_ID` FOREIGN KEY (`parent_id`) REFERENCES `sales_invoice` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Invoice Comment';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_invoice_comment`
--

LOCK TABLES `sales_invoice_comment` WRITE;
/*!40000 ALTER TABLE `sales_invoice_comment` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_invoice_comment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_invoice_grid`
--

DROP TABLE IF EXISTS `sales_invoice_grid`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_invoice_grid` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment ID',
  `state` int DEFAULT NULL COMMENT 'State',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `store_name` varchar(255) DEFAULT NULL COMMENT 'Store Name',
  `order_id` int unsigned NOT NULL COMMENT 'Order ID',
  `order_increment_id` varchar(50) DEFAULT NULL COMMENT 'Order Increment ID',
  `order_created_at` timestamp NULL DEFAULT NULL COMMENT 'Order Created At',
  `customer_name` varchar(255) DEFAULT NULL COMMENT 'Customer Name',
  `customer_email` varchar(255) DEFAULT NULL COMMENT 'Customer Email',
  `customer_group_id` int DEFAULT NULL,
  `payment_method` varchar(128) DEFAULT NULL COMMENT 'Payment Method',
  `store_currency_code` varchar(3) DEFAULT NULL COMMENT 'Store Currency Code',
  `order_currency_code` varchar(3) DEFAULT NULL COMMENT 'Order Currency Code',
  `base_currency_code` varchar(3) DEFAULT NULL COMMENT 'Base Currency Code',
  `global_currency_code` varchar(3) DEFAULT NULL COMMENT 'Global Currency Code',
  `billing_name` varchar(255) DEFAULT NULL COMMENT 'Billing Name',
  `billing_address` varchar(255) DEFAULT NULL COMMENT 'Billing Address',
  `shipping_address` varchar(255) DEFAULT NULL COMMENT 'Shipping Address',
  `shipping_information` varchar(255) DEFAULT NULL COMMENT 'Shipping Method Name',
  `subtotal` decimal(20,4) DEFAULT NULL COMMENT 'Subtotal',
  `shipping_and_handling` decimal(20,4) DEFAULT NULL COMMENT 'Shipping and handling amount',
  `grand_total` decimal(20,4) DEFAULT NULL COMMENT 'Grand Total',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `base_grand_total` decimal(20,4) DEFAULT NULL COMMENT 'Base Grand Total',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `SALES_INVOICE_GRID_INCREMENT_ID_STORE_ID` (`increment_id`,`store_id`),
  KEY `SALES_INVOICE_GRID_STORE_ID` (`store_id`),
  KEY `SALES_INVOICE_GRID_GRAND_TOTAL` (`grand_total`),
  KEY `SALES_INVOICE_GRID_ORDER_ID` (`order_id`),
  KEY `SALES_INVOICE_GRID_STATE` (`state`),
  KEY `SALES_INVOICE_GRID_ORDER_INCREMENT_ID` (`order_increment_id`),
  KEY `SALES_INVOICE_GRID_CREATED_AT` (`created_at`),
  KEY `SALES_INVOICE_GRID_UPDATED_AT` (`updated_at`),
  KEY `SALES_INVOICE_GRID_ORDER_CREATED_AT` (`order_created_at`),
  KEY `SALES_INVOICE_GRID_BILLING_NAME` (`billing_name`),
  KEY `SALES_INVOICE_GRID_BASE_GRAND_TOTAL` (`base_grand_total`),
  FULLTEXT KEY `FTI_95D9C924DD6A8734EB8B5D01D60F90DE` (`increment_id`,`order_increment_id`,`billing_name`,`billing_address`,`shipping_address`,`customer_name`,`customer_email`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Invoice Grid';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_invoice_grid`
--

LOCK TABLES `sales_invoice_grid` WRITE;
/*!40000 ALTER TABLE `sales_invoice_grid` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_invoice_grid` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_invoice_item`
--

DROP TABLE IF EXISTS `sales_invoice_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_invoice_item` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `parent_id` int unsigned NOT NULL COMMENT 'Parent ID',
  `base_price` decimal(20,4) DEFAULT NULL COMMENT 'Base Price',
  `tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Tax Amount',
  `base_row_total` decimal(20,4) DEFAULT NULL COMMENT 'Base Row Total',
  `discount_amount` decimal(20,4) DEFAULT NULL COMMENT 'Discount Amount',
  `row_total` decimal(20,4) DEFAULT NULL COMMENT 'Row Total',
  `base_discount_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Amount',
  `price_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Price Incl Tax',
  `base_tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Tax Amount',
  `base_price_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Price Incl Tax',
  `qty` decimal(12,4) DEFAULT NULL COMMENT 'Qty',
  `base_cost` decimal(20,4) DEFAULT NULL COMMENT 'Base Cost',
  `price` decimal(20,4) DEFAULT NULL COMMENT 'Price',
  `base_row_total_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Row Total Incl Tax',
  `row_total_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Row Total Incl Tax',
  `product_id` int DEFAULT NULL COMMENT 'Product ID',
  `order_item_id` int DEFAULT NULL COMMENT 'Order Item ID',
  `additional_data` text COMMENT 'Additional Data',
  `description` text COMMENT 'Description',
  `sku` varchar(255) DEFAULT NULL COMMENT 'Sku',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Discount Tax Compensation Amount',
  `base_discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Tax Compensation Amount',
  `tax_ratio` text COMMENT 'Ratio of tax invoiced over tax of the order item',
  `weee_tax_applied` text COMMENT 'Weee Tax Applied',
  `weee_tax_applied_amount` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Applied Amount',
  `weee_tax_applied_row_amount` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Applied Row Amount',
  `weee_tax_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Disposition',
  `weee_tax_row_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Row Disposition',
  `base_weee_tax_applied_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Applied Amount',
  `base_weee_tax_applied_row_amnt` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Applied Row Amnt',
  `base_weee_tax_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Disposition',
  `base_weee_tax_row_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Row Disposition',
  PRIMARY KEY (`entity_id`),
  KEY `SALES_INVOICE_ITEM_PARENT_ID` (`parent_id`),
  CONSTRAINT `SALES_INVOICE_ITEM_PARENT_ID_SALES_INVOICE_ENTITY_ID` FOREIGN KEY (`parent_id`) REFERENCES `sales_invoice` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Invoice Item';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_invoice_item`
--

LOCK TABLES `sales_invoice_item` WRITE;
/*!40000 ALTER TABLE `sales_invoice_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_invoice_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_invoiced_aggregated`
--

DROP TABLE IF EXISTS `sales_invoiced_aggregated`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_invoiced_aggregated` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `order_status` varchar(50) DEFAULT NULL COMMENT 'Order Status',
  `orders_count` int NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `orders_invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Orders Invoiced',
  `invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Invoiced',
  `invoiced_captured` decimal(20,4) DEFAULT NULL COMMENT 'Invoiced Captured',
  `invoiced_not_captured` decimal(20,4) DEFAULT NULL COMMENT 'Invoiced Not Captured',
  PRIMARY KEY (`id`),
  UNIQUE KEY `SALES_INVOICED_AGGREGATED_PERIOD_STORE_ID_ORDER_STATUS` (`period`,`store_id`,`order_status`),
  KEY `SALES_INVOICED_AGGREGATED_STORE_ID` (`store_id`),
  CONSTRAINT `SALES_INVOICED_AGGREGATED_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Invoiced Aggregated';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_invoiced_aggregated`
--

LOCK TABLES `sales_invoiced_aggregated` WRITE;
/*!40000 ALTER TABLE `sales_invoiced_aggregated` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_invoiced_aggregated` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_invoiced_aggregated_order`
--

DROP TABLE IF EXISTS `sales_invoiced_aggregated_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_invoiced_aggregated_order` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `order_status` varchar(50) NOT NULL COMMENT 'Order Status',
  `orders_count` int NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `orders_invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Orders Invoiced',
  `invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Invoiced',
  `invoiced_captured` decimal(20,4) DEFAULT NULL COMMENT 'Invoiced Captured',
  `invoiced_not_captured` decimal(20,4) DEFAULT NULL COMMENT 'Invoiced Not Captured',
  PRIMARY KEY (`id`),
  UNIQUE KEY `SALES_INVOICED_AGGREGATED_ORDER_PERIOD_STORE_ID_ORDER_STATUS` (`period`,`store_id`,`order_status`),
  KEY `SALES_INVOICED_AGGREGATED_ORDER_STORE_ID` (`store_id`),
  CONSTRAINT `SALES_INVOICED_AGGREGATED_ORDER_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Invoiced Aggregated Order';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_invoiced_aggregated_order`
--

LOCK TABLES `sales_invoiced_aggregated_order` WRITE;
/*!40000 ALTER TABLE `sales_invoiced_aggregated_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_invoiced_aggregated_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_order`
--

DROP TABLE IF EXISTS `sales_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_order` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `state` varchar(32) DEFAULT NULL COMMENT 'State',
  `status` varchar(32) DEFAULT NULL COMMENT 'Status',
  `coupon_code` varchar(255) DEFAULT NULL COMMENT 'Coupon Code',
  `protect_code` varchar(255) DEFAULT NULL COMMENT 'Protect Code',
  `shipping_description` varchar(255) DEFAULT NULL COMMENT 'Shipping Description',
  `is_virtual` smallint unsigned DEFAULT NULL COMMENT 'Is Virtual',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `customer_id` int unsigned DEFAULT NULL COMMENT 'Customer ID',
  `base_discount_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Amount',
  `base_discount_canceled` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Canceled',
  `base_discount_invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Invoiced',
  `base_discount_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Refunded',
  `base_grand_total` decimal(20,4) DEFAULT NULL COMMENT 'Base Grand Total',
  `base_shipping_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Amount',
  `base_shipping_canceled` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Canceled',
  `base_shipping_invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Invoiced',
  `base_shipping_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Refunded',
  `base_shipping_tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Tax Amount',
  `base_shipping_tax_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Tax Refunded',
  `base_subtotal` decimal(20,4) DEFAULT NULL COMMENT 'Base Subtotal',
  `base_subtotal_canceled` decimal(20,4) DEFAULT NULL COMMENT 'Base Subtotal Canceled',
  `base_subtotal_invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Base Subtotal Invoiced',
  `base_subtotal_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Base Subtotal Refunded',
  `base_tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Tax Amount',
  `base_tax_canceled` decimal(20,4) DEFAULT NULL COMMENT 'Base Tax Canceled',
  `base_tax_invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Base Tax Invoiced',
  `base_tax_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Base Tax Refunded',
  `base_to_global_rate` decimal(20,4) DEFAULT NULL COMMENT 'Base To Global Rate',
  `base_to_order_rate` decimal(20,4) DEFAULT NULL COMMENT 'Base To Order Rate',
  `base_total_canceled` decimal(20,4) DEFAULT NULL COMMENT 'Base Total Canceled',
  `base_total_invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Base Total Invoiced',
  `base_total_invoiced_cost` decimal(20,4) DEFAULT NULL COMMENT 'Base Total Invoiced Cost',
  `base_total_offline_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Base Total Offline Refunded',
  `base_total_online_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Base Total Online Refunded',
  `base_total_paid` decimal(20,4) DEFAULT NULL COMMENT 'Base Total Paid',
  `base_total_qty_ordered` decimal(12,4) DEFAULT NULL COMMENT 'Base Total Qty Ordered',
  `base_total_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Base Total Refunded',
  `discount_amount` decimal(20,4) DEFAULT NULL COMMENT 'Discount Amount',
  `discount_canceled` decimal(20,4) DEFAULT NULL COMMENT 'Discount Canceled',
  `discount_invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Discount Invoiced',
  `discount_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Discount Refunded',
  `grand_total` decimal(20,4) DEFAULT NULL COMMENT 'Grand Total',
  `shipping_amount` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Amount',
  `shipping_canceled` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Canceled',
  `shipping_invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Invoiced',
  `shipping_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Refunded',
  `shipping_tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Tax Amount',
  `shipping_tax_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Tax Refunded',
  `store_to_base_rate` decimal(12,4) DEFAULT NULL COMMENT 'Store To Base Rate',
  `store_to_order_rate` decimal(12,4) DEFAULT NULL COMMENT 'Store To Order Rate',
  `subtotal` decimal(20,4) DEFAULT NULL COMMENT 'Subtotal',
  `subtotal_canceled` decimal(20,4) DEFAULT NULL COMMENT 'Subtotal Canceled',
  `subtotal_invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Subtotal Invoiced',
  `subtotal_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Subtotal Refunded',
  `tax_amount` decimal(20,4) DEFAULT NULL COMMENT 'Tax Amount',
  `tax_canceled` decimal(20,4) DEFAULT NULL COMMENT 'Tax Canceled',
  `tax_invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Tax Invoiced',
  `tax_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Tax Refunded',
  `total_canceled` decimal(20,4) DEFAULT NULL COMMENT 'Total Canceled',
  `total_invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Total Invoiced',
  `total_offline_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Total Offline Refunded',
  `total_online_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Total Online Refunded',
  `total_paid` decimal(20,4) DEFAULT NULL COMMENT 'Total Paid',
  `total_qty_ordered` decimal(12,4) DEFAULT NULL COMMENT 'Total Qty Ordered',
  `total_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Total Refunded',
  `can_ship_partially` smallint unsigned DEFAULT NULL COMMENT 'Can Ship Partially',
  `can_ship_partially_item` smallint unsigned DEFAULT NULL COMMENT 'Can Ship Partially Item',
  `customer_is_guest` smallint unsigned DEFAULT NULL COMMENT 'Customer Is Guest',
  `customer_note_notify` smallint unsigned DEFAULT NULL COMMENT 'Customer Note Notify',
  `billing_address_id` int DEFAULT NULL COMMENT 'Billing Address ID',
  `customer_group_id` int DEFAULT NULL,
  `edit_increment` int DEFAULT NULL COMMENT 'Edit Increment',
  `email_sent` smallint unsigned DEFAULT NULL COMMENT 'Email Sent',
  `send_email` smallint unsigned DEFAULT NULL COMMENT 'Send Email',
  `forced_shipment_with_invoice` smallint unsigned DEFAULT NULL COMMENT 'Forced Do Shipment With Invoice',
  `payment_auth_expiration` int DEFAULT NULL COMMENT 'Payment Authorization Expiration',
  `quote_address_id` int DEFAULT NULL COMMENT 'Quote Address ID',
  `quote_id` int DEFAULT NULL COMMENT 'Quote ID',
  `shipping_address_id` int DEFAULT NULL COMMENT 'Shipping Address ID',
  `adjustment_negative` decimal(20,4) DEFAULT NULL COMMENT 'Adjustment Negative',
  `adjustment_positive` decimal(20,4) DEFAULT NULL COMMENT 'Adjustment Positive',
  `base_adjustment_negative` decimal(20,4) DEFAULT NULL COMMENT 'Base Adjustment Negative',
  `base_adjustment_positive` decimal(20,4) DEFAULT NULL COMMENT 'Base Adjustment Positive',
  `base_shipping_discount_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Discount Amount',
  `base_subtotal_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Subtotal Incl Tax',
  `base_total_due` decimal(20,4) DEFAULT NULL COMMENT 'Base Total Due',
  `payment_authorization_amount` decimal(20,4) DEFAULT NULL COMMENT 'Payment Authorization Amount',
  `shipping_discount_amount` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Discount Amount',
  `subtotal_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Subtotal Incl Tax',
  `total_due` decimal(20,4) DEFAULT NULL COMMENT 'Total Due',
  `weight` decimal(12,4) DEFAULT NULL COMMENT 'Weight',
  `customer_dob` datetime DEFAULT NULL COMMENT 'Customer Dob',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment ID',
  `applied_rule_ids` varchar(128) DEFAULT NULL COMMENT 'Applied Rule Ids',
  `base_currency_code` varchar(3) DEFAULT NULL COMMENT 'Base Currency Code',
  `customer_email` varchar(128) DEFAULT NULL COMMENT 'Customer Email',
  `customer_firstname` varchar(128) DEFAULT NULL COMMENT 'Customer Firstname',
  `customer_lastname` varchar(128) DEFAULT NULL COMMENT 'Customer Lastname',
  `customer_middlename` varchar(128) DEFAULT NULL COMMENT 'Customer Middlename',
  `customer_prefix` varchar(32) DEFAULT NULL COMMENT 'Customer Prefix',
  `customer_suffix` varchar(32) DEFAULT NULL COMMENT 'Customer Suffix',
  `customer_taxvat` varchar(32) DEFAULT NULL COMMENT 'Customer Taxvat',
  `discount_description` varchar(255) DEFAULT NULL COMMENT 'Discount Description',
  `ext_customer_id` varchar(32) DEFAULT NULL COMMENT 'Ext Customer ID',
  `ext_order_id` varchar(32) DEFAULT NULL COMMENT 'Ext Order ID',
  `global_currency_code` varchar(3) DEFAULT NULL COMMENT 'Global Currency Code',
  `hold_before_state` varchar(32) DEFAULT NULL COMMENT 'Hold Before State',
  `hold_before_status` varchar(32) DEFAULT NULL COMMENT 'Hold Before Status',
  `order_currency_code` varchar(3) DEFAULT NULL COMMENT 'Order Currency Code',
  `original_increment_id` varchar(50) DEFAULT NULL COMMENT 'Original Increment ID',
  `relation_child_id` varchar(32) DEFAULT NULL COMMENT 'Relation Child ID',
  `relation_child_real_id` varchar(32) DEFAULT NULL COMMENT 'Relation Child Real ID',
  `relation_parent_id` varchar(32) DEFAULT NULL COMMENT 'Relation Parent ID',
  `relation_parent_real_id` varchar(32) DEFAULT NULL COMMENT 'Relation Parent Real ID',
  `remote_ip` varchar(45) DEFAULT NULL COMMENT 'Remote Ip',
  `shipping_method` varchar(120) DEFAULT NULL,
  `store_currency_code` varchar(3) DEFAULT NULL COMMENT 'Store Currency Code',
  `store_name` varchar(255) DEFAULT NULL COMMENT 'Store Name',
  `x_forwarded_for` varchar(255) DEFAULT NULL COMMENT 'X Forwarded For',
  `customer_note` text COMMENT 'Customer Note',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `total_item_count` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Total Item Count',
  `customer_gender` int DEFAULT NULL COMMENT 'Customer Gender',
  `discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Discount Tax Compensation Amount',
  `base_discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Tax Compensation Amount',
  `shipping_discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Discount Tax Compensation Amount',
  `base_shipping_discount_tax_compensation_amnt` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Discount Tax Compensation Amount',
  `discount_tax_compensation_invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Discount Tax Compensation Invoiced',
  `base_discount_tax_compensation_invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Tax Compensation Invoiced',
  `discount_tax_compensation_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Discount Tax Compensation Refunded',
  `base_discount_tax_compensation_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Tax Compensation Refunded',
  `shipping_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Incl Tax',
  `base_shipping_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Incl Tax',
  `coupon_rule_name` varchar(255) DEFAULT NULL COMMENT 'Coupon Sales Rule Name',
  `gift_message_id` int DEFAULT NULL COMMENT 'Gift Message ID',
  `paypal_ipn_customer_notified` int DEFAULT '0' COMMENT 'Paypal Ipn Customer Notified',
  `dispute_status` varchar(45) DEFAULT NULL COMMENT 'Braintree Dispute Status',
  `mp_smtp_email_marketing_synced` smallint DEFAULT '0' COMMENT 'Mp SMTP Email Marketing synced',
  `mp_smtp_email_marketing_order_created` smallint DEFAULT '0' COMMENT 'Mp SMTP Email Marketing order created',
  `delivery_method` varchar(255) DEFAULT NULL COMMENT 'Delivery Method',
  `mollie_transaction_id` varchar(255) DEFAULT NULL COMMENT 'Mollie Transaction Id',
  `mollie_payment_fee` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  `mollie_payment_fee_tax` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  `base_mollie_payment_fee` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  `base_mollie_payment_fee_tax` decimal(12,4) DEFAULT '0.0000' COMMENT 'Mollie Payment Fee',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `SALES_ORDER_INCREMENT_ID_STORE_ID` (`increment_id`,`store_id`),
  KEY `SALES_ORDER_STATUS` (`status`),
  KEY `SALES_ORDER_STATE` (`state`),
  KEY `SALES_ORDER_STORE_ID` (`store_id`),
  KEY `SALES_ORDER_CREATED_AT` (`created_at`),
  KEY `SALES_ORDER_CUSTOMER_ID` (`customer_id`),
  KEY `SALES_ORDER_EXT_ORDER_ID` (`ext_order_id`),
  KEY `SALES_ORDER_QUOTE_ID` (`quote_id`),
  KEY `SALES_ORDER_UPDATED_AT` (`updated_at`),
  KEY `SALES_ORDER_SEND_EMAIL` (`send_email`),
  KEY `SALES_ORDER_EMAIL_SENT` (`email_sent`),
  KEY `SALES_ORDER_STORE_ID_STATE_CREATED_AT` (`store_id`,`state`,`created_at`),
  KEY `SALES_ORDER_MOLLIE_TRANSACTION_ID` (`mollie_transaction_id`),
  CONSTRAINT `SALES_ORDER_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE SET NULL,
  CONSTRAINT `SALES_ORDER_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COMMENT='sales_order';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_order`
--

LOCK TABLES `sales_order` WRITE;
/*!40000 ALTER TABLE `sales_order` DISABLE KEYS */;
INSERT INTO `sales_order` VALUES (1,'processing','processing',NULL,'da79059d728f8a3367c63d97942d2419','Flat Rate - Fixed',0,1,NULL,0.0000,NULL,NULL,NULL,865.0000,5.0000,NULL,NULL,NULL,0.0000,NULL,860.0000,NULL,NULL,NULL,0.0000,NULL,NULL,NULL,1.0000,1.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.0000,NULL,NULL,NULL,865.0000,5.0000,NULL,NULL,NULL,0.0000,NULL,0.0000,0.0000,860.0000,NULL,NULL,NULL,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1.0000,NULL,NULL,NULL,1,0,2,0,NULL,NULL,1,NULL,NULL,NULL,2,1,NULL,NULL,NULL,NULL,0.0000,860.0000,865.0000,NULL,0.0000,860.0000,865.0000,0.0000,NULL,'000000003',NULL,'USD','zohaibmuhammad23@gmail.com','Muhammad ','Zohaib ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'USD',NULL,NULL,'USD',NULL,NULL,NULL,NULL,NULL,'39.37.183.204','flatrate_flatrate','USD','Main Website\nMain Website Store\nDefault Store View',NULL,NULL,'2025-01-07 13:54:08','2025-01-14 09:42:28',1,NULL,0.0000,0.0000,0.0000,0.0000,NULL,NULL,NULL,NULL,5.0000,5.0000,NULL,NULL,0,NULL,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000),(2,'new','pending',NULL,'3ccf2cbb670a30a624a7465e1672a099','Van Delivery - Shipping Test',0,1,NULL,0.0000,NULL,NULL,NULL,394.9900,45.0000,NULL,NULL,NULL,0.0000,NULL,349.9900,NULL,NULL,NULL,0.0000,NULL,NULL,NULL,1.0000,1.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.0000,NULL,NULL,NULL,394.9900,45.0000,NULL,NULL,NULL,0.0000,NULL,0.0000,0.0000,349.9900,NULL,NULL,NULL,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1.0000,NULL,NULL,NULL,1,1,4,0,NULL,NULL,1,NULL,NULL,NULL,6,3,NULL,NULL,NULL,NULL,0.0000,349.9900,394.9900,NULL,0.0000,349.9900,394.9900,0.0000,NULL,'000000004',NULL,'USD','zohaibmuhammad23@gmail.com','sadas','sadsa',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'USD',NULL,NULL,'USD',NULL,NULL,NULL,NULL,NULL,'172.70.111.80','gazco_gazcofire','USD','Main Website\nMain Website Store\nDefault Store View','182.185.158.222',NULL,'2025-01-28 08:41:05','2025-01-28 08:41:05',1,NULL,0.0000,0.0000,0.0000,0.0000,NULL,NULL,NULL,NULL,45.0000,45.0000,NULL,NULL,0,NULL,0,0,NULL,NULL,0.0000,0.0000,0.0000,0.0000),(3,'canceled','canceled',NULL,'b5b66c905486964870ec948aae5b3228','Van Delivery - Shipping Test',0,1,NULL,0.0000,0.0000,NULL,NULL,394.9900,45.0000,45.0000,NULL,NULL,0.0000,NULL,349.9900,349.9900,NULL,NULL,0.0000,0.0000,NULL,NULL,1.0000,1.0000,394.9900,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.0000,0.0000,NULL,NULL,394.9900,45.0000,45.0000,NULL,NULL,0.0000,NULL,0.0000,0.0000,349.9900,349.9900,NULL,NULL,0.0000,0.0000,NULL,NULL,394.9900,NULL,NULL,NULL,NULL,1.0000,NULL,NULL,NULL,1,1,6,0,NULL,NULL,1,NULL,NULL,NULL,8,5,NULL,NULL,NULL,NULL,0.0000,349.9900,394.9900,NULL,0.0000,349.9900,394.9900,0.0000,NULL,'000000005',NULL,'USD','zohaibmuhammad23@gmail.com','Test ','zohaib',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'USD',NULL,NULL,'USD',NULL,'4','000000005-1',NULL,NULL,'172.70.230.57','gazco_gazcofire','USD','Main Website\nMain Website Store\nDefault Store View','182.185.158.222',NULL,'2025-01-29 15:40:47','2025-01-29 15:54:41',1,NULL,0.0000,0.0000,0.0000,0.0000,NULL,NULL,NULL,NULL,45.0000,45.0000,NULL,NULL,0,NULL,0,0,'banyo_direct',NULL,0.0000,0.0000,0.0000,0.0000),(4,'processing','processing',NULL,'b0bcb926e7abb532d4b4cf25c1f48183','Van Delivery - Shipping Test',0,1,NULL,0.0000,NULL,NULL,NULL,394.9900,45.0000,NULL,NULL,NULL,0.0000,NULL,349.9900,NULL,NULL,NULL,0.0000,NULL,NULL,NULL,1.0000,1.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0.0000,NULL,NULL,NULL,394.9900,45.0000,NULL,NULL,NULL,0.0000,NULL,0.0000,0.0000,349.9900,NULL,NULL,NULL,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1.0000,NULL,NULL,NULL,1,0,8,0,1,NULL,1,NULL,NULL,NULL,11,7,NULL,NULL,NULL,NULL,0.0000,349.9900,394.9900,NULL,0.0000,349.9900,394.9900,0.0000,NULL,'000000005-1',NULL,'USD','zohaibmuhammad23@gmail.com','Test','zohaib',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'USD',NULL,NULL,'USD','000000005',NULL,NULL,'3','000000005',NULL,'gazco_gazcofire','USD','Main Website\nMain Website Store\nDefault Store View',NULL,NULL,'2025-01-29 15:54:40','2025-01-29 15:57:53',1,0,0.0000,0.0000,0.0000,0.0000,NULL,NULL,NULL,NULL,45.0000,45.0000,NULL,NULL,0,NULL,0,0,'banyo_direct',NULL,0.0000,0.0000,0.0000,0.0000);
/*!40000 ALTER TABLE `sales_order` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_sales_order_after_insert` AFTER INSERT ON `sales_order` FOR EACH ROW BEGIN
INSERT IGNORE INTO `sales_order_data_exporter_cl` (`entity_id`) VALUES (NEW.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_sales_order_after_update` AFTER UPDATE ON `sales_order` FOR EACH ROW BEGIN
IF (NOT(NEW.`entity_id` <=> OLD.`entity_id`) OR NOT(NEW.`state` <=> OLD.`state`) OR NOT(NEW.`status` <=> OLD.`status`) OR NOT(NEW.`coupon_code` <=> OLD.`coupon_code`) OR NOT(NEW.`protect_code` <=> OLD.`protect_code`) OR NOT(NEW.`shipping_description` <=> OLD.`shipping_description`) OR NOT(NEW.`is_virtual` <=> OLD.`is_virtual`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`customer_id` <=> OLD.`customer_id`) OR NOT(NEW.`base_discount_amount` <=> OLD.`base_discount_amount`) OR NOT(NEW.`base_discount_canceled` <=> OLD.`base_discount_canceled`) OR NOT(NEW.`base_discount_invoiced` <=> OLD.`base_discount_invoiced`) OR NOT(NEW.`base_discount_refunded` <=> OLD.`base_discount_refunded`) OR NOT(NEW.`base_grand_total` <=> OLD.`base_grand_total`) OR NOT(NEW.`base_shipping_amount` <=> OLD.`base_shipping_amount`) OR NOT(NEW.`base_shipping_canceled` <=> OLD.`base_shipping_canceled`) OR NOT(NEW.`base_shipping_invoiced` <=> OLD.`base_shipping_invoiced`) OR NOT(NEW.`base_shipping_refunded` <=> OLD.`base_shipping_refunded`) OR NOT(NEW.`base_shipping_tax_amount` <=> OLD.`base_shipping_tax_amount`) OR NOT(NEW.`base_shipping_tax_refunded` <=> OLD.`base_shipping_tax_refunded`) OR NOT(NEW.`base_subtotal` <=> OLD.`base_subtotal`) OR NOT(NEW.`base_subtotal_canceled` <=> OLD.`base_subtotal_canceled`) OR NOT(NEW.`base_subtotal_invoiced` <=> OLD.`base_subtotal_invoiced`) OR NOT(NEW.`base_subtotal_refunded` <=> OLD.`base_subtotal_refunded`) OR NOT(NEW.`base_tax_amount` <=> OLD.`base_tax_amount`) OR NOT(NEW.`base_tax_canceled` <=> OLD.`base_tax_canceled`) OR NOT(NEW.`base_tax_invoiced` <=> OLD.`base_tax_invoiced`) OR NOT(NEW.`base_tax_refunded` <=> OLD.`base_tax_refunded`) OR NOT(NEW.`base_to_global_rate` <=> OLD.`base_to_global_rate`) OR NOT(NEW.`base_to_order_rate` <=> OLD.`base_to_order_rate`) OR NOT(NEW.`base_total_canceled` <=> OLD.`base_total_canceled`) OR NOT(NEW.`base_total_invoiced` <=> OLD.`base_total_invoiced`) OR NOT(NEW.`base_total_invoiced_cost` <=> OLD.`base_total_invoiced_cost`) OR NOT(NEW.`base_total_offline_refunded` <=> OLD.`base_total_offline_refunded`) OR NOT(NEW.`base_total_online_refunded` <=> OLD.`base_total_online_refunded`) OR NOT(NEW.`base_total_paid` <=> OLD.`base_total_paid`) OR NOT(NEW.`base_total_qty_ordered` <=> OLD.`base_total_qty_ordered`) OR NOT(NEW.`base_total_refunded` <=> OLD.`base_total_refunded`) OR NOT(NEW.`discount_amount` <=> OLD.`discount_amount`) OR NOT(NEW.`discount_canceled` <=> OLD.`discount_canceled`) OR NOT(NEW.`discount_invoiced` <=> OLD.`discount_invoiced`) OR NOT(NEW.`discount_refunded` <=> OLD.`discount_refunded`) OR NOT(NEW.`grand_total` <=> OLD.`grand_total`) OR NOT(NEW.`shipping_amount` <=> OLD.`shipping_amount`) OR NOT(NEW.`shipping_canceled` <=> OLD.`shipping_canceled`) OR NOT(NEW.`shipping_invoiced` <=> OLD.`shipping_invoiced`) OR NOT(NEW.`shipping_refunded` <=> OLD.`shipping_refunded`) OR NOT(NEW.`shipping_tax_amount` <=> OLD.`shipping_tax_amount`) OR NOT(NEW.`shipping_tax_refunded` <=> OLD.`shipping_tax_refunded`) OR NOT(NEW.`store_to_base_rate` <=> OLD.`store_to_base_rate`) OR NOT(NEW.`store_to_order_rate` <=> OLD.`store_to_order_rate`) OR NOT(NEW.`subtotal` <=> OLD.`subtotal`) OR NOT(NEW.`subtotal_canceled` <=> OLD.`subtotal_canceled`) OR NOT(NEW.`subtotal_invoiced` <=> OLD.`subtotal_invoiced`) OR NOT(NEW.`subtotal_refunded` <=> OLD.`subtotal_refunded`) OR NOT(NEW.`tax_amount` <=> OLD.`tax_amount`) OR NOT(NEW.`tax_canceled` <=> OLD.`tax_canceled`) OR NOT(NEW.`tax_invoiced` <=> OLD.`tax_invoiced`) OR NOT(NEW.`tax_refunded` <=> OLD.`tax_refunded`) OR NOT(NEW.`total_canceled` <=> OLD.`total_canceled`) OR NOT(NEW.`total_invoiced` <=> OLD.`total_invoiced`) OR NOT(NEW.`total_offline_refunded` <=> OLD.`total_offline_refunded`) OR NOT(NEW.`total_online_refunded` <=> OLD.`total_online_refunded`) OR NOT(NEW.`total_paid` <=> OLD.`total_paid`) OR NOT(NEW.`total_qty_ordered` <=> OLD.`total_qty_ordered`) OR NOT(NEW.`total_refunded` <=> OLD.`total_refunded`) OR NOT(NEW.`can_ship_partially` <=> OLD.`can_ship_partially`) OR NOT(NEW.`can_ship_partially_item` <=> OLD.`can_ship_partially_item`) OR NOT(NEW.`customer_is_guest` <=> OLD.`customer_is_guest`) OR NOT(NEW.`customer_note_notify` <=> OLD.`customer_note_notify`) OR NOT(NEW.`billing_address_id` <=> OLD.`billing_address_id`) OR NOT(NEW.`customer_group_id` <=> OLD.`customer_group_id`) OR NOT(NEW.`edit_increment` <=> OLD.`edit_increment`) OR NOT(NEW.`email_sent` <=> OLD.`email_sent`) OR NOT(NEW.`send_email` <=> OLD.`send_email`) OR NOT(NEW.`forced_shipment_with_invoice` <=> OLD.`forced_shipment_with_invoice`) OR NOT(NEW.`payment_auth_expiration` <=> OLD.`payment_auth_expiration`) OR NOT(NEW.`quote_address_id` <=> OLD.`quote_address_id`) OR NOT(NEW.`quote_id` <=> OLD.`quote_id`) OR NOT(NEW.`shipping_address_id` <=> OLD.`shipping_address_id`) OR NOT(NEW.`adjustment_negative` <=> OLD.`adjustment_negative`) OR NOT(NEW.`adjustment_positive` <=> OLD.`adjustment_positive`) OR NOT(NEW.`base_adjustment_negative` <=> OLD.`base_adjustment_negative`) OR NOT(NEW.`base_adjustment_positive` <=> OLD.`base_adjustment_positive`) OR NOT(NEW.`base_shipping_discount_amount` <=> OLD.`base_shipping_discount_amount`) OR NOT(NEW.`base_subtotal_incl_tax` <=> OLD.`base_subtotal_incl_tax`) OR NOT(NEW.`base_total_due` <=> OLD.`base_total_due`) OR NOT(NEW.`payment_authorization_amount` <=> OLD.`payment_authorization_amount`) OR NOT(NEW.`shipping_discount_amount` <=> OLD.`shipping_discount_amount`) OR NOT(NEW.`subtotal_incl_tax` <=> OLD.`subtotal_incl_tax`) OR NOT(NEW.`total_due` <=> OLD.`total_due`) OR NOT(NEW.`weight` <=> OLD.`weight`) OR NOT(NEW.`customer_dob` <=> OLD.`customer_dob`) OR NOT(NEW.`increment_id` <=> OLD.`increment_id`) OR NOT(NEW.`applied_rule_ids` <=> OLD.`applied_rule_ids`) OR NOT(NEW.`base_currency_code` <=> OLD.`base_currency_code`) OR NOT(NEW.`customer_email` <=> OLD.`customer_email`) OR NOT(NEW.`customer_firstname` <=> OLD.`customer_firstname`) OR NOT(NEW.`customer_lastname` <=> OLD.`customer_lastname`) OR NOT(NEW.`customer_middlename` <=> OLD.`customer_middlename`) OR NOT(NEW.`customer_prefix` <=> OLD.`customer_prefix`) OR NOT(NEW.`customer_suffix` <=> OLD.`customer_suffix`) OR NOT(NEW.`customer_taxvat` <=> OLD.`customer_taxvat`) OR NOT(NEW.`discount_description` <=> OLD.`discount_description`) OR NOT(NEW.`ext_customer_id` <=> OLD.`ext_customer_id`) OR NOT(NEW.`ext_order_id` <=> OLD.`ext_order_id`) OR NOT(NEW.`global_currency_code` <=> OLD.`global_currency_code`) OR NOT(NEW.`hold_before_state` <=> OLD.`hold_before_state`) OR NOT(NEW.`hold_before_status` <=> OLD.`hold_before_status`) OR NOT(NEW.`order_currency_code` <=> OLD.`order_currency_code`) OR NOT(NEW.`original_increment_id` <=> OLD.`original_increment_id`) OR NOT(NEW.`relation_child_id` <=> OLD.`relation_child_id`) OR NOT(NEW.`relation_child_real_id` <=> OLD.`relation_child_real_id`) OR NOT(NEW.`relation_parent_id` <=> OLD.`relation_parent_id`) OR NOT(NEW.`relation_parent_real_id` <=> OLD.`relation_parent_real_id`) OR NOT(NEW.`remote_ip` <=> OLD.`remote_ip`) OR NOT(NEW.`shipping_method` <=> OLD.`shipping_method`) OR NOT(NEW.`store_currency_code` <=> OLD.`store_currency_code`) OR NOT(NEW.`store_name` <=> OLD.`store_name`) OR NOT(NEW.`x_forwarded_for` <=> OLD.`x_forwarded_for`) OR NOT(NEW.`customer_note` <=> OLD.`customer_note`) OR NOT(NEW.`created_at` <=> OLD.`created_at`) OR NOT(NEW.`total_item_count` <=> OLD.`total_item_count`) OR NOT(NEW.`customer_gender` <=> OLD.`customer_gender`) OR NOT(NEW.`discount_tax_compensation_amount` <=> OLD.`discount_tax_compensation_amount`) OR NOT(NEW.`base_discount_tax_compensation_amount` <=> OLD.`base_discount_tax_compensation_amount`) OR NOT(NEW.`shipping_discount_tax_compensation_amount` <=> OLD.`shipping_discount_tax_compensation_amount`) OR NOT(NEW.`base_shipping_discount_tax_compensation_amnt` <=> OLD.`base_shipping_discount_tax_compensation_amnt`) OR NOT(NEW.`discount_tax_compensation_invoiced` <=> OLD.`discount_tax_compensation_invoiced`) OR NOT(NEW.`base_discount_tax_compensation_invoiced` <=> OLD.`base_discount_tax_compensation_invoiced`) OR NOT(NEW.`discount_tax_compensation_refunded` <=> OLD.`discount_tax_compensation_refunded`) OR NOT(NEW.`base_discount_tax_compensation_refunded` <=> OLD.`base_discount_tax_compensation_refunded`) OR NOT(NEW.`shipping_incl_tax` <=> OLD.`shipping_incl_tax`) OR NOT(NEW.`base_shipping_incl_tax` <=> OLD.`base_shipping_incl_tax`) OR NOT(NEW.`coupon_rule_name` <=> OLD.`coupon_rule_name`) OR NOT(NEW.`gift_message_id` <=> OLD.`gift_message_id`) OR NOT(NEW.`paypal_ipn_customer_notified` <=> OLD.`paypal_ipn_customer_notified`) OR NOT(NEW.`dispute_status` <=> OLD.`dispute_status`) OR NOT(NEW.`mp_smtp_email_marketing_synced` <=> OLD.`mp_smtp_email_marketing_synced`) OR NOT(NEW.`mp_smtp_email_marketing_order_created` <=> OLD.`mp_smtp_email_marketing_order_created`) OR NOT(NEW.`delivery_method` <=> OLD.`delivery_method`) OR NOT(NEW.`mollie_transaction_id` <=> OLD.`mollie_transaction_id`) OR NOT(NEW.`mollie_payment_fee` <=> OLD.`mollie_payment_fee`) OR NOT(NEW.`mollie_payment_fee_tax` <=> OLD.`mollie_payment_fee_tax`) OR NOT(NEW.`base_mollie_payment_fee` <=> OLD.`base_mollie_payment_fee`) OR NOT(NEW.`base_mollie_payment_fee_tax` <=> OLD.`base_mollie_payment_fee_tax`)) THEN INSERT IGNORE INTO `sales_order_data_exporter_cl` (`entity_id`) VALUES (NEW.`entity_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_sales_order_after_delete` AFTER DELETE ON `sales_order` FOR EACH ROW BEGIN
INSERT IGNORE INTO `sales_order_data_exporter_cl` (`entity_id`) VALUES (OLD.`entity_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `sales_order_address`
--

DROP TABLE IF EXISTS `sales_order_address`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_order_address` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `parent_id` int unsigned DEFAULT NULL COMMENT 'Parent ID',
  `customer_address_id` int DEFAULT NULL COMMENT 'Customer Address ID',
  `quote_address_id` int DEFAULT NULL COMMENT 'Quote Address ID',
  `region_id` int DEFAULT NULL COMMENT 'Region ID',
  `customer_id` int DEFAULT NULL COMMENT 'Customer ID',
  `fax` varchar(255) DEFAULT NULL COMMENT 'Fax',
  `region` varchar(255) DEFAULT NULL COMMENT 'Region',
  `postcode` varchar(255) DEFAULT NULL COMMENT 'Postcode',
  `lastname` varchar(255) DEFAULT NULL COMMENT 'Lastname',
  `street` varchar(255) DEFAULT NULL COMMENT 'Street',
  `city` varchar(255) DEFAULT NULL COMMENT 'City',
  `email` varchar(255) DEFAULT NULL COMMENT 'Email',
  `telephone` varchar(255) DEFAULT NULL COMMENT 'Phone Number',
  `country_id` varchar(2) DEFAULT NULL COMMENT 'Country ID',
  `firstname` varchar(255) DEFAULT NULL COMMENT 'Firstname',
  `address_type` varchar(255) DEFAULT NULL COMMENT 'Address Type',
  `prefix` varchar(255) DEFAULT NULL COMMENT 'Prefix',
  `middlename` varchar(255) DEFAULT NULL COMMENT 'Middlename',
  `suffix` varchar(255) DEFAULT NULL COMMENT 'Suffix',
  `company` varchar(255) DEFAULT NULL COMMENT 'Company',
  `vat_id` text COMMENT 'Vat ID',
  `vat_is_valid` smallint DEFAULT NULL COMMENT 'Vat Is Valid',
  `vat_request_id` text COMMENT 'Vat Request ID',
  `vat_request_date` text COMMENT 'Vat Request Date',
  `vat_request_success` smallint DEFAULT NULL COMMENT 'Vat Request Success',
  PRIMARY KEY (`entity_id`),
  KEY `SALES_ORDER_ADDRESS_PARENT_ID` (`parent_id`),
  CONSTRAINT `SALES_ORDER_ADDRESS_PARENT_ID_SALES_ORDER_ENTITY_ID` FOREIGN KEY (`parent_id`) REFERENCES `sales_order` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Order Address';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_order_address`
--

LOCK TABLES `sales_order_address` WRITE;
/*!40000 ALTER TABLE `sales_order_address` DISABLE KEYS */;
INSERT INTO `sales_order_address` VALUES (1,1,NULL,4,20,NULL,NULL,'Guam','12345 12345','Zohaib ','89/A','London','zohaibmuhammad23@gmail.com','+3211232193','US','Muhammad ','shipping',NULL,NULL,NULL,'Banyo',NULL,NULL,NULL,NULL,NULL),(2,1,NULL,5,20,NULL,NULL,'Guam','12345 12345','Zohaib ','89/A','London','zohaibmuhammad23@gmail.com','+3211232193','US','Muhammad ','billing',NULL,NULL,NULL,'Banyo',NULL,NULL,NULL,NULL,NULL),(3,2,NULL,15,12,NULL,NULL,'California','12345','sadsa','xzxz','London','zohaibmuhammad23@gmail.com','+3211232193','US','sadas','shipping',NULL,NULL,NULL,'Banyo',NULL,NULL,NULL,NULL,NULL),(4,2,NULL,16,12,NULL,NULL,'California','12345','sadsa','xzxz','London','zohaibmuhammad23@gmail.com','+3211232193','US','sadas','billing',NULL,NULL,NULL,'Banyo',NULL,NULL,NULL,NULL,NULL),(5,3,NULL,21,20,NULL,NULL,'Guam','123456','zohaib','sasas','London','zohaibmuhammad23@gmail.com','32354467814','US','Test ','shipping',NULL,NULL,NULL,'Banyo',NULL,NULL,NULL,NULL,NULL),(6,3,NULL,22,20,NULL,NULL,'Guam','123456','zohaib','sasas','London','zohaibmuhammad23@gmail.com','32354467814','US','Test ','billing',NULL,NULL,NULL,'Banyo',NULL,NULL,NULL,NULL,NULL),(7,4,0,28,20,NULL,NULL,'Guam','123456','zohaib','sasas','London','zohaibmuhammad23@gmail.com','32354467814','US','Test','shipping',NULL,NULL,NULL,'Banyo',NULL,NULL,NULL,NULL,NULL),(8,4,NULL,27,20,NULL,NULL,'Guam','123456','zohaib','sasas','London','zohaibmuhammad23@gmail.com','32354467814','US','Test','billing',NULL,NULL,NULL,'Banyo',NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `sales_order_address` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_order_aggregated_created`
--

DROP TABLE IF EXISTS `sales_order_aggregated_created`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_order_aggregated_created` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `order_status` varchar(50) NOT NULL COMMENT 'Order Status',
  `orders_count` int NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `total_qty_ordered` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Qty Ordered',
  `total_qty_invoiced` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Qty Invoiced',
  `total_income_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Income Amount',
  `total_revenue_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Revenue Amount',
  `total_profit_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Profit Amount',
  `total_invoiced_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Invoiced Amount',
  `total_canceled_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Canceled Amount',
  `total_paid_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Paid Amount',
  `total_refunded_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Refunded Amount',
  `total_tax_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Tax Amount',
  `total_tax_amount_actual` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Tax Amount Actual',
  `total_shipping_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Shipping Amount',
  `total_shipping_amount_actual` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Shipping Amount Actual',
  `total_discount_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Discount Amount',
  `total_discount_amount_actual` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Discount Amount Actual',
  PRIMARY KEY (`id`),
  UNIQUE KEY `SALES_ORDER_AGGREGATED_CREATED_PERIOD_STORE_ID_ORDER_STATUS` (`period`,`store_id`,`order_status`),
  KEY `SALES_ORDER_AGGREGATED_CREATED_STORE_ID` (`store_id`),
  CONSTRAINT `SALES_ORDER_AGGREGATED_CREATED_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Order Aggregated Created';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_order_aggregated_created`
--

LOCK TABLES `sales_order_aggregated_created` WRITE;
/*!40000 ALTER TABLE `sales_order_aggregated_created` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_order_aggregated_created` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_order_aggregated_updated`
--

DROP TABLE IF EXISTS `sales_order_aggregated_updated`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_order_aggregated_updated` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `order_status` varchar(50) NOT NULL COMMENT 'Order Status',
  `orders_count` int NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `total_qty_ordered` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Qty Ordered',
  `total_qty_invoiced` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Qty Invoiced',
  `total_income_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Income Amount',
  `total_revenue_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Revenue Amount',
  `total_profit_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Profit Amount',
  `total_invoiced_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Invoiced Amount',
  `total_canceled_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Canceled Amount',
  `total_paid_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Paid Amount',
  `total_refunded_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Refunded Amount',
  `total_tax_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Tax Amount',
  `total_tax_amount_actual` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Tax Amount Actual',
  `total_shipping_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Shipping Amount',
  `total_shipping_amount_actual` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Shipping Amount Actual',
  `total_discount_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Discount Amount',
  `total_discount_amount_actual` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Discount Amount Actual',
  PRIMARY KEY (`id`),
  UNIQUE KEY `SALES_ORDER_AGGREGATED_UPDATED_PERIOD_STORE_ID_ORDER_STATUS` (`period`,`store_id`,`order_status`),
  KEY `SALES_ORDER_AGGREGATED_UPDATED_STORE_ID` (`store_id`),
  CONSTRAINT `SALES_ORDER_AGGREGATED_UPDATED_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Order Aggregated Updated';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_order_aggregated_updated`
--

LOCK TABLES `sales_order_aggregated_updated` WRITE;
/*!40000 ALTER TABLE `sales_order_aggregated_updated` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_order_aggregated_updated` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_order_data_exporter_cl`
--

DROP TABLE IF EXISTS `sales_order_data_exporter_cl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_order_data_exporter_cl` (
  `version_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Version ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  PRIMARY KEY (`version_id`)
) ENGINE=InnoDB AUTO_INCREMENT=34 DEFAULT CHARSET=utf8mb3 COMMENT='sales_order_data_exporter_cl';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_order_data_exporter_cl`
--

LOCK TABLES `sales_order_data_exporter_cl` WRITE;
/*!40000 ALTER TABLE `sales_order_data_exporter_cl` DISABLE KEYS */;
INSERT INTO `sales_order_data_exporter_cl` VALUES (1,1),(2,1),(3,1),(4,1),(5,2),(6,2),(7,2),(8,2),(9,1),(10,1),(11,1),(12,1),(13,1),(14,1),(15,2),(16,2),(17,2),(18,2),(19,3),(20,3),(21,3),(22,3),(23,3),(24,4),(25,4),(26,4),(27,3),(28,3),(29,3),(30,4),(31,4),(32,4),(33,4);
/*!40000 ALTER TABLE `sales_order_data_exporter_cl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_order_grid`
--

DROP TABLE IF EXISTS `sales_order_grid`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_order_grid` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `status` varchar(32) DEFAULT NULL COMMENT 'Status',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `store_name` varchar(255) DEFAULT NULL COMMENT 'Store Name',
  `customer_id` int unsigned DEFAULT NULL COMMENT 'Customer ID',
  `base_grand_total` decimal(20,4) DEFAULT NULL COMMENT 'Base Grand Total',
  `base_total_paid` decimal(20,4) DEFAULT NULL COMMENT 'Base Total Paid',
  `grand_total` decimal(20,4) DEFAULT NULL COMMENT 'Grand Total',
  `total_paid` decimal(20,4) DEFAULT NULL COMMENT 'Total Paid',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment ID',
  `base_currency_code` varchar(3) DEFAULT NULL COMMENT 'Base Currency Code',
  `order_currency_code` varchar(255) DEFAULT NULL COMMENT 'Order Currency Code',
  `shipping_name` varchar(255) DEFAULT NULL COMMENT 'Shipping Name',
  `billing_name` varchar(255) DEFAULT NULL COMMENT 'Billing Name',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `billing_address` varchar(255) DEFAULT NULL COMMENT 'Billing Address',
  `shipping_address` varchar(255) DEFAULT NULL COMMENT 'Shipping Address',
  `shipping_information` varchar(255) DEFAULT NULL COMMENT 'Shipping Method Name',
  `customer_email` varchar(255) DEFAULT NULL COMMENT 'Customer Email',
  `customer_group` varchar(255) DEFAULT NULL COMMENT 'Customer Group',
  `subtotal` decimal(20,4) DEFAULT NULL COMMENT 'Subtotal',
  `shipping_and_handling` decimal(20,4) DEFAULT NULL COMMENT 'Shipping and handling amount',
  `customer_name` varchar(255) DEFAULT NULL COMMENT 'Customer Name',
  `payment_method` varchar(255) DEFAULT NULL COMMENT 'Payment Method',
  `total_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Total Refunded',
  `pickup_location_code` varchar(255) DEFAULT NULL COMMENT 'Pickup Location Code',
  `dispute_status` varchar(45) DEFAULT NULL COMMENT 'Braintree Dispute Status',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `SALES_ORDER_GRID_INCREMENT_ID_STORE_ID` (`increment_id`,`store_id`),
  KEY `SALES_ORDER_GRID_STATUS` (`status`),
  KEY `SALES_ORDER_GRID_STORE_ID` (`store_id`),
  KEY `SALES_ORDER_GRID_BASE_GRAND_TOTAL` (`base_grand_total`),
  KEY `SALES_ORDER_GRID_BASE_TOTAL_PAID` (`base_total_paid`),
  KEY `SALES_ORDER_GRID_GRAND_TOTAL` (`grand_total`),
  KEY `SALES_ORDER_GRID_TOTAL_PAID` (`total_paid`),
  KEY `SALES_ORDER_GRID_SHIPPING_NAME` (`shipping_name`),
  KEY `SALES_ORDER_GRID_BILLING_NAME` (`billing_name`),
  KEY `SALES_ORDER_GRID_CREATED_AT` (`created_at`),
  KEY `SALES_ORDER_GRID_CUSTOMER_ID` (`customer_id`),
  KEY `SALES_ORDER_GRID_UPDATED_AT` (`updated_at`),
  KEY `SALES_ORDER_GRID_PICKUP_LOCATION_CODE` (`pickup_location_code`),
  FULLTEXT KEY `FTI_65B9E9925EC58F0C7C2E2F6379C233E7` (`increment_id`,`billing_name`,`shipping_name`,`shipping_address`,`billing_address`,`customer_name`,`customer_email`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Order Grid';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_order_grid`
--

LOCK TABLES `sales_order_grid` WRITE;
/*!40000 ALTER TABLE `sales_order_grid` DISABLE KEYS */;
INSERT INTO `sales_order_grid` VALUES (1,'processing',1,'Main Website\nMain Website Store\nDefault Store View',NULL,865.0000,NULL,865.0000,NULL,'000000003','USD','USD','Muhammad  Zohaib','Muhammad  Zohaib','2025-01-07 13:54:08','2025-01-14 09:42:28','Banyo,89/A,London,Guam,12345 12345','Banyo,89/A,London,Guam,12345 12345','Flat Rate - Fixed','zohaibmuhammad23@gmail.com','0',860.0000,5.0000,'Muhammad  Zohaib','checkmo',NULL,NULL,NULL),(2,'pending',1,'Main Website\nMain Website Store\nDefault Store View',NULL,394.9900,NULL,394.9900,NULL,'000000004','USD','USD','sadas sadsa','sadas sadsa','2025-01-28 08:41:05','2025-01-28 08:41:05','Banyo,xzxz,London,California,12345','Banyo,xzxz,London,California,12345','Van Delivery - Shipping Test','zohaibmuhammad23@gmail.com','0',349.9900,45.0000,'sadas sadsa','checkmo',NULL,NULL,NULL),(3,'canceled',1,'Main Website\nMain Website Store\nDefault Store View',NULL,394.9900,NULL,394.9900,NULL,'000000005','USD','USD','Test  zohaib','Test  zohaib','2025-01-29 15:40:47','2025-01-29 15:54:41','Banyo,sasas,London,Guam,123456','Banyo,sasas,London,Guam,123456','Van Delivery - Shipping Test','zohaibmuhammad23@gmail.com','0',349.9900,45.0000,'Test  zohaib','checkmo',NULL,NULL,NULL),(4,'processing',1,'Main Website\nMain Website Store\nDefault Store View',NULL,394.9900,NULL,394.9900,NULL,'000000005-1','USD','USD','Test zohaib','Test zohaib','2025-01-29 15:54:40','2025-01-29 15:56:59','Banyo,sasas,London,Guam,123456','Banyo,sasas,London,Guam,123456','Van Delivery - Shipping Test','zohaibmuhammad23@gmail.com','0',349.9900,45.0000,'Test zohaib','adminpaymentmethod',NULL,NULL,NULL);
/*!40000 ALTER TABLE `sales_order_grid` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_order_item`
--

DROP TABLE IF EXISTS `sales_order_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_order_item` (
  `item_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Item ID',
  `order_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Order ID',
  `parent_item_id` int unsigned DEFAULT NULL COMMENT 'Parent Item ID',
  `quote_item_id` int unsigned DEFAULT NULL COMMENT 'Quote Item ID',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `product_id` int unsigned DEFAULT NULL COMMENT 'Product ID',
  `product_type` varchar(255) DEFAULT NULL COMMENT 'Product Type',
  `product_options` longtext COMMENT 'Product Options',
  `weight` decimal(12,4) DEFAULT '0.0000' COMMENT 'Weight',
  `is_virtual` smallint unsigned DEFAULT NULL COMMENT 'Is Virtual',
  `sku` varchar(255) DEFAULT NULL COMMENT 'Sku',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `description` text COMMENT 'Description',
  `applied_rule_ids` text COMMENT 'Applied Rule Ids',
  `additional_data` text COMMENT 'Additional Data',
  `is_qty_decimal` smallint unsigned DEFAULT NULL COMMENT 'Is Qty Decimal',
  `no_discount` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'No Discount',
  `qty_backordered` decimal(12,4) DEFAULT '0.0000' COMMENT 'Qty Backordered',
  `qty_canceled` decimal(12,4) DEFAULT '0.0000' COMMENT 'Qty Canceled',
  `qty_invoiced` decimal(12,4) DEFAULT '0.0000' COMMENT 'Qty Invoiced',
  `qty_ordered` decimal(12,4) DEFAULT '0.0000' COMMENT 'Qty Ordered',
  `qty_refunded` decimal(12,4) DEFAULT '0.0000' COMMENT 'Qty Refunded',
  `qty_shipped` decimal(12,4) DEFAULT '0.0000' COMMENT 'Qty Shipped',
  `base_cost` decimal(12,4) DEFAULT '0.0000' COMMENT 'Base Cost',
  `price` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Price',
  `base_price` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Price',
  `original_price` decimal(20,4) DEFAULT NULL COMMENT 'Original Price',
  `base_original_price` decimal(20,4) DEFAULT NULL COMMENT 'Base Original Price',
  `tax_percent` decimal(12,4) DEFAULT '0.0000' COMMENT 'Tax Percent',
  `tax_amount` decimal(20,4) DEFAULT '0.0000' COMMENT 'Tax Amount',
  `base_tax_amount` decimal(20,4) DEFAULT '0.0000' COMMENT 'Base Tax Amount',
  `tax_invoiced` decimal(20,4) DEFAULT '0.0000' COMMENT 'Tax Invoiced',
  `base_tax_invoiced` decimal(20,4) DEFAULT '0.0000' COMMENT 'Base Tax Invoiced',
  `discount_percent` decimal(12,4) DEFAULT '0.0000' COMMENT 'Discount Percent',
  `discount_amount` decimal(20,4) DEFAULT '0.0000' COMMENT 'Discount Amount',
  `base_discount_amount` decimal(20,4) DEFAULT '0.0000' COMMENT 'Base Discount Amount',
  `discount_invoiced` decimal(20,4) DEFAULT '0.0000' COMMENT 'Discount Invoiced',
  `base_discount_invoiced` decimal(20,4) DEFAULT '0.0000' COMMENT 'Base Discount Invoiced',
  `amount_refunded` decimal(20,4) DEFAULT '0.0000' COMMENT 'Amount Refunded',
  `base_amount_refunded` decimal(20,4) DEFAULT '0.0000' COMMENT 'Base Amount Refunded',
  `row_total` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Row Total',
  `base_row_total` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Row Total',
  `row_invoiced` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Row Invoiced',
  `base_row_invoiced` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Row Invoiced',
  `row_weight` decimal(12,4) DEFAULT '0.0000' COMMENT 'Row Weight',
  `base_tax_before_discount` decimal(20,4) DEFAULT NULL COMMENT 'Base Tax Before Discount',
  `tax_before_discount` decimal(20,4) DEFAULT NULL COMMENT 'Tax Before Discount',
  `ext_order_item_id` varchar(255) DEFAULT NULL COMMENT 'Ext Order Item ID',
  `locked_do_invoice` smallint unsigned DEFAULT NULL COMMENT 'Locked Do Invoice',
  `locked_do_ship` smallint unsigned DEFAULT NULL COMMENT 'Locked Do Ship',
  `price_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Price Incl Tax',
  `base_price_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Price Incl Tax',
  `row_total_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Row Total Incl Tax',
  `base_row_total_incl_tax` decimal(20,4) DEFAULT NULL COMMENT 'Base Row Total Incl Tax',
  `discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Discount Tax Compensation Amount',
  `base_discount_tax_compensation_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Tax Compensation Amount',
  `discount_tax_compensation_invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Discount Tax Compensation Invoiced',
  `base_discount_tax_compensation_invoiced` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Tax Compensation Invoiced',
  `discount_tax_compensation_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Discount Tax Compensation Refunded',
  `base_discount_tax_compensation_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Tax Compensation Refunded',
  `tax_canceled` decimal(12,4) DEFAULT NULL COMMENT 'Tax Canceled',
  `discount_tax_compensation_canceled` decimal(20,4) DEFAULT NULL COMMENT 'Discount Tax Compensation Canceled',
  `tax_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Tax Refunded',
  `base_tax_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Base Tax Refunded',
  `discount_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Discount Refunded',
  `base_discount_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Base Discount Refunded',
  `gift_message_id` int DEFAULT NULL COMMENT 'Gift Message ID',
  `gift_message_available` int DEFAULT NULL COMMENT 'Gift Message Available',
  `free_shipping` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Free Shipping',
  `weee_tax_applied` text COMMENT 'Weee Tax Applied',
  `weee_tax_applied_amount` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Applied Amount',
  `weee_tax_applied_row_amount` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Applied Row Amount',
  `weee_tax_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Disposition',
  `weee_tax_row_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Row Disposition',
  `base_weee_tax_applied_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Applied Amount',
  `base_weee_tax_applied_row_amnt` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Applied Row Amnt',
  `base_weee_tax_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Disposition',
  `base_weee_tax_row_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Row Disposition',
  PRIMARY KEY (`item_id`),
  KEY `SALES_ORDER_ITEM_ORDER_ID` (`order_id`),
  KEY `SALES_ORDER_ITEM_STORE_ID` (`store_id`),
  CONSTRAINT `SALES_ORDER_ITEM_ORDER_ID_SALES_ORDER_ENTITY_ID` FOREIGN KEY (`order_id`) REFERENCES `sales_order` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `SALES_ORDER_ITEM_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Order Item';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_order_item`
--

LOCK TABLES `sales_order_item` WRITE;
/*!40000 ALTER TABLE `sales_order_item` DISABLE KEYS */;
INSERT INTO `sales_order_item` VALUES (1,1,NULL,1,1,'2025-01-07 13:54:08','2025-01-14 09:42:28',4894,'simple','{\"info_buyRequest\":{\"uenc\":\"aHR0cDovLzE1Ny4yMzAuMjA5LjE3NC9pbmRleC5waHAvZnJhbmtlLTgwMC1ob29kLWZ2YXMtYTgwLWJrLTItdm9pY2UtYXBwLXJlbW90ZS1jb250cm9sLmh0bWw~\",\"product\":\"4894\",\"selected_configurable_option\":\"\",\"related_product\":\"\",\"item\":\"4894\",\"id\":\"4894\",\"qty\":1}}',NULL,0,'FVAS A80 BK Z1','Franke 800 Hood FVAS A80 BK/2 Voice, App, & Remote Control',NULL,NULL,NULL,0,0,NULL,0.0000,0.0000,1.0000,0.0000,1.0000,967.5000,860.0000,860.0000,1075.0000,1075.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,860.0000,860.0000,0.0000,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,860.0000,860.0000,860.0000,860.0000,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(2,2,NULL,5,1,'2025-01-28 08:41:05','2025-01-28 08:41:05',1162,'simple','{\"info_buyRequest\":{\"uenc\":\"aHR0cHM6Ly9oeXZhLXN0YWdpbmcuYmFueW8uY28udWsvaW5kZXgucGhwL3JlZ2lub3gtY29tZm9ydC1jb2xvcmFkby1sLWludGVncmF0ZWQtMS1ib3dsLWtpdGNoZW4tc2luay5odG1s\",\"product\":\"1162\",\"selected_configurable_option\":\"\",\"related_product\":\"\",\"item\":\"1162\",\"id\":\"1162\",\"qty\":1}}',NULL,0,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink','Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink',NULL,NULL,NULL,0,0,NULL,0.0000,0.0000,1.0000,0.0000,0.0000,NULL,349.9900,349.9900,349.9900,349.9900,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,349.9900,349.9900,0.0000,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,349.9900,349.9900,349.9900,349.9900,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(3,3,NULL,7,1,'2025-01-29 15:40:47','2025-01-29 15:54:41',1162,'simple','{\"info_buyRequest\":{\"uenc\":\"aHR0cHM6Ly9oeXZhLXN0YWdpbmcuYmFueW8uY28udWsvaW5kZXgucGhwL3JlZ2lub3gtY29tZm9ydC1jb2xvcmFkby1sLWludGVncmF0ZWQtMS1ib3dsLWtpdGNoZW4tc2luay5odG1s\",\"product\":\"1162\",\"selected_configurable_option\":\"\",\"related_product\":\"\",\"item\":\"1162\",\"id\":\"1162\",\"qty\":1}}',NULL,0,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink','Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink',NULL,NULL,NULL,0,0,NULL,1.0000,0.0000,1.0000,0.0000,0.0000,NULL,349.9900,349.9900,349.9900,349.9900,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,349.9900,349.9900,0.0000,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,349.9900,349.9900,349.9900,349.9900,0.0000,0.0000,NULL,NULL,NULL,NULL,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(4,4,NULL,10,1,'2025-01-29 15:54:40','2025-01-29 15:56:59',1162,'simple','{\"info_buyRequest\":{\"uenc\":\"aHR0cHM6Ly9oeXZhLXN0YWdpbmcuYmFueW8uY28udWsvaW5kZXgucGhwL3JlZ2lub3gtY29tZm9ydC1jb2xvcmFkby1sLWludGVncmF0ZWQtMS1ib3dsLWtpdGNoZW4tc2luay5odG1s\",\"product\":\"1162\",\"selected_configurable_option\":\"\",\"related_product\":\"\",\"item\":\"1162\",\"id\":\"1162\",\"qty\":1,\"options\":[]}}',NULL,0,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink','Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink',NULL,NULL,NULL,0,0,NULL,0.0000,0.0000,1.0000,0.0000,1.0000,NULL,349.9900,349.9900,349.9900,349.9900,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,0.0000,349.9900,349.9900,0.0000,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,349.9900,349.9900,349.9900,349.9900,0.0000,0.0000,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `sales_order_item` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_sales_order_item_after_insert` AFTER INSERT ON `sales_order_item` FOR EACH ROW BEGIN
INSERT IGNORE INTO `sales_order_data_exporter_cl` (`entity_id`) VALUES (NEW.`order_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_sales_order_item_after_update` AFTER UPDATE ON `sales_order_item` FOR EACH ROW BEGIN
IF (NOT(NEW.`item_id` <=> OLD.`item_id`) OR NOT(NEW.`order_id` <=> OLD.`order_id`) OR NOT(NEW.`parent_item_id` <=> OLD.`parent_item_id`) OR NOT(NEW.`quote_item_id` <=> OLD.`quote_item_id`) OR NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`created_at` <=> OLD.`created_at`) OR NOT(NEW.`product_id` <=> OLD.`product_id`) OR NOT(NEW.`product_type` <=> OLD.`product_type`) OR NOT(NEW.`product_options` <=> OLD.`product_options`) OR NOT(NEW.`weight` <=> OLD.`weight`) OR NOT(NEW.`is_virtual` <=> OLD.`is_virtual`) OR NOT(NEW.`sku` <=> OLD.`sku`) OR NOT(NEW.`name` <=> OLD.`name`) OR NOT(NEW.`description` <=> OLD.`description`) OR NOT(NEW.`applied_rule_ids` <=> OLD.`applied_rule_ids`) OR NOT(NEW.`additional_data` <=> OLD.`additional_data`) OR NOT(NEW.`is_qty_decimal` <=> OLD.`is_qty_decimal`) OR NOT(NEW.`no_discount` <=> OLD.`no_discount`) OR NOT(NEW.`qty_backordered` <=> OLD.`qty_backordered`) OR NOT(NEW.`qty_canceled` <=> OLD.`qty_canceled`) OR NOT(NEW.`qty_invoiced` <=> OLD.`qty_invoiced`) OR NOT(NEW.`qty_ordered` <=> OLD.`qty_ordered`) OR NOT(NEW.`qty_refunded` <=> OLD.`qty_refunded`) OR NOT(NEW.`qty_shipped` <=> OLD.`qty_shipped`) OR NOT(NEW.`base_cost` <=> OLD.`base_cost`) OR NOT(NEW.`price` <=> OLD.`price`) OR NOT(NEW.`base_price` <=> OLD.`base_price`) OR NOT(NEW.`original_price` <=> OLD.`original_price`) OR NOT(NEW.`base_original_price` <=> OLD.`base_original_price`) OR NOT(NEW.`tax_percent` <=> OLD.`tax_percent`) OR NOT(NEW.`tax_amount` <=> OLD.`tax_amount`) OR NOT(NEW.`base_tax_amount` <=> OLD.`base_tax_amount`) OR NOT(NEW.`tax_invoiced` <=> OLD.`tax_invoiced`) OR NOT(NEW.`base_tax_invoiced` <=> OLD.`base_tax_invoiced`) OR NOT(NEW.`discount_percent` <=> OLD.`discount_percent`) OR NOT(NEW.`discount_amount` <=> OLD.`discount_amount`) OR NOT(NEW.`base_discount_amount` <=> OLD.`base_discount_amount`) OR NOT(NEW.`discount_invoiced` <=> OLD.`discount_invoiced`) OR NOT(NEW.`base_discount_invoiced` <=> OLD.`base_discount_invoiced`) OR NOT(NEW.`amount_refunded` <=> OLD.`amount_refunded`) OR NOT(NEW.`base_amount_refunded` <=> OLD.`base_amount_refunded`) OR NOT(NEW.`row_total` <=> OLD.`row_total`) OR NOT(NEW.`base_row_total` <=> OLD.`base_row_total`) OR NOT(NEW.`row_invoiced` <=> OLD.`row_invoiced`) OR NOT(NEW.`base_row_invoiced` <=> OLD.`base_row_invoiced`) OR NOT(NEW.`row_weight` <=> OLD.`row_weight`) OR NOT(NEW.`base_tax_before_discount` <=> OLD.`base_tax_before_discount`) OR NOT(NEW.`tax_before_discount` <=> OLD.`tax_before_discount`) OR NOT(NEW.`ext_order_item_id` <=> OLD.`ext_order_item_id`) OR NOT(NEW.`locked_do_invoice` <=> OLD.`locked_do_invoice`) OR NOT(NEW.`locked_do_ship` <=> OLD.`locked_do_ship`) OR NOT(NEW.`price_incl_tax` <=> OLD.`price_incl_tax`) OR NOT(NEW.`base_price_incl_tax` <=> OLD.`base_price_incl_tax`) OR NOT(NEW.`row_total_incl_tax` <=> OLD.`row_total_incl_tax`) OR NOT(NEW.`base_row_total_incl_tax` <=> OLD.`base_row_total_incl_tax`) OR NOT(NEW.`discount_tax_compensation_amount` <=> OLD.`discount_tax_compensation_amount`) OR NOT(NEW.`base_discount_tax_compensation_amount` <=> OLD.`base_discount_tax_compensation_amount`) OR NOT(NEW.`discount_tax_compensation_invoiced` <=> OLD.`discount_tax_compensation_invoiced`) OR NOT(NEW.`base_discount_tax_compensation_invoiced` <=> OLD.`base_discount_tax_compensation_invoiced`) OR NOT(NEW.`discount_tax_compensation_refunded` <=> OLD.`discount_tax_compensation_refunded`) OR NOT(NEW.`base_discount_tax_compensation_refunded` <=> OLD.`base_discount_tax_compensation_refunded`) OR NOT(NEW.`tax_canceled` <=> OLD.`tax_canceled`) OR NOT(NEW.`discount_tax_compensation_canceled` <=> OLD.`discount_tax_compensation_canceled`) OR NOT(NEW.`tax_refunded` <=> OLD.`tax_refunded`) OR NOT(NEW.`base_tax_refunded` <=> OLD.`base_tax_refunded`) OR NOT(NEW.`discount_refunded` <=> OLD.`discount_refunded`) OR NOT(NEW.`base_discount_refunded` <=> OLD.`base_discount_refunded`) OR NOT(NEW.`gift_message_id` <=> OLD.`gift_message_id`) OR NOT(NEW.`gift_message_available` <=> OLD.`gift_message_available`) OR NOT(NEW.`free_shipping` <=> OLD.`free_shipping`) OR NOT(NEW.`weee_tax_applied` <=> OLD.`weee_tax_applied`) OR NOT(NEW.`weee_tax_applied_amount` <=> OLD.`weee_tax_applied_amount`) OR NOT(NEW.`weee_tax_applied_row_amount` <=> OLD.`weee_tax_applied_row_amount`) OR NOT(NEW.`weee_tax_disposition` <=> OLD.`weee_tax_disposition`) OR NOT(NEW.`weee_tax_row_disposition` <=> OLD.`weee_tax_row_disposition`) OR NOT(NEW.`base_weee_tax_applied_amount` <=> OLD.`base_weee_tax_applied_amount`) OR NOT(NEW.`base_weee_tax_applied_row_amnt` <=> OLD.`base_weee_tax_applied_row_amnt`) OR NOT(NEW.`base_weee_tax_disposition` <=> OLD.`base_weee_tax_disposition`) OR NOT(NEW.`base_weee_tax_row_disposition` <=> OLD.`base_weee_tax_row_disposition`)) THEN INSERT IGNORE INTO `sales_order_data_exporter_cl` (`entity_id`) VALUES (NEW.`order_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_sales_order_item_after_delete` AFTER DELETE ON `sales_order_item` FOR EACH ROW BEGIN
INSERT IGNORE INTO `sales_order_data_exporter_cl` (`entity_id`) VALUES (OLD.`order_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `sales_order_payment`
--

DROP TABLE IF EXISTS `sales_order_payment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_order_payment` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `parent_id` int unsigned NOT NULL COMMENT 'Parent ID',
  `base_shipping_captured` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Captured',
  `shipping_captured` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Captured',
  `amount_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Amount Refunded',
  `base_amount_paid` decimal(20,4) DEFAULT NULL COMMENT 'Base Amount Paid',
  `amount_canceled` decimal(20,4) DEFAULT NULL COMMENT 'Amount Canceled',
  `base_amount_authorized` decimal(20,4) DEFAULT NULL COMMENT 'Base Amount Authorized',
  `base_amount_paid_online` decimal(20,4) DEFAULT NULL COMMENT 'Base Amount Paid Online',
  `base_amount_refunded_online` decimal(20,4) DEFAULT NULL COMMENT 'Base Amount Refunded Online',
  `base_shipping_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Amount',
  `shipping_amount` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Amount',
  `amount_paid` decimal(20,4) DEFAULT NULL COMMENT 'Amount Paid',
  `amount_authorized` decimal(20,4) DEFAULT NULL COMMENT 'Amount Authorized',
  `base_amount_ordered` decimal(20,4) DEFAULT NULL COMMENT 'Base Amount Ordered',
  `base_shipping_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Base Shipping Refunded',
  `shipping_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Shipping Refunded',
  `base_amount_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Base Amount Refunded',
  `amount_ordered` decimal(20,4) DEFAULT NULL COMMENT 'Amount Ordered',
  `base_amount_canceled` decimal(20,4) DEFAULT NULL COMMENT 'Base Amount Canceled',
  `quote_payment_id` int DEFAULT NULL COMMENT 'Quote Payment ID',
  `additional_data` text COMMENT 'Additional Data',
  `cc_exp_month` varchar(12) DEFAULT NULL COMMENT 'Cc Exp Month',
  `cc_ss_start_year` varchar(12) DEFAULT NULL COMMENT 'Cc Ss Start Year',
  `echeck_bank_name` varchar(128) DEFAULT NULL COMMENT 'Echeck Bank Name',
  `method` varchar(128) DEFAULT NULL COMMENT 'Method',
  `cc_debug_request_body` varchar(32) DEFAULT NULL COMMENT 'Cc Debug Request Body',
  `cc_secure_verify` varchar(32) DEFAULT NULL COMMENT 'Cc Secure Verify',
  `protection_eligibility` varchar(32) DEFAULT NULL COMMENT 'Protection Eligibility',
  `cc_approval` varchar(32) DEFAULT NULL COMMENT 'Cc Approval',
  `cc_last_4` varchar(100) DEFAULT NULL COMMENT 'Cc Last 4',
  `cc_status_description` varchar(32) DEFAULT NULL COMMENT 'Cc Status Description',
  `echeck_type` varchar(32) DEFAULT NULL COMMENT 'Echeck Type',
  `cc_debug_response_serialized` varchar(32) DEFAULT NULL COMMENT 'Cc Debug Response Serialized',
  `cc_ss_start_month` varchar(128) DEFAULT NULL COMMENT 'Cc Ss Start Month',
  `echeck_account_type` varchar(255) DEFAULT NULL COMMENT 'Echeck Account Type',
  `last_trans_id` varchar(255) DEFAULT NULL COMMENT 'Last Trans ID',
  `cc_cid_status` varchar(32) DEFAULT NULL COMMENT 'Cc Cid Status',
  `cc_owner` varchar(128) DEFAULT NULL COMMENT 'Cc Owner',
  `cc_type` varchar(32) DEFAULT NULL COMMENT 'Cc Type',
  `po_number` varchar(32) DEFAULT NULL COMMENT 'Po Number',
  `cc_exp_year` varchar(4) DEFAULT NULL COMMENT 'Cc Exp Year',
  `cc_status` varchar(4) DEFAULT NULL COMMENT 'Cc Status',
  `echeck_routing_number` varchar(32) DEFAULT NULL COMMENT 'Echeck Routing Number',
  `account_status` varchar(32) DEFAULT NULL COMMENT 'Account Status',
  `anet_trans_method` varchar(32) DEFAULT NULL COMMENT 'Anet Trans Method',
  `cc_debug_response_body` varchar(32) DEFAULT NULL COMMENT 'Cc Debug Response Body',
  `cc_ss_issue` varchar(32) DEFAULT NULL COMMENT 'Cc Ss Issue',
  `echeck_account_name` varchar(32) DEFAULT NULL COMMENT 'Echeck Account Name',
  `cc_avs_status` varchar(32) DEFAULT NULL COMMENT 'Cc Avs Status',
  `cc_number_enc` varchar(128) DEFAULT NULL,
  `cc_trans_id` varchar(32) DEFAULT NULL COMMENT 'Cc Trans ID',
  `address_status` varchar(32) DEFAULT NULL COMMENT 'Address Status',
  `additional_information` text COMMENT 'Additional Information',
  PRIMARY KEY (`entity_id`),
  KEY `SALES_ORDER_PAYMENT_PARENT_ID` (`parent_id`),
  CONSTRAINT `SALES_ORDER_PAYMENT_PARENT_ID_SALES_ORDER_ENTITY_ID` FOREIGN KEY (`parent_id`) REFERENCES `sales_order` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Order Payment';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_order_payment`
--

LOCK TABLES `sales_order_payment` WRITE;
/*!40000 ALTER TABLE `sales_order_payment` DISABLE KEYS */;
INSERT INTO `sales_order_payment` VALUES (1,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,5.0000,5.0000,NULL,NULL,865.0000,NULL,NULL,NULL,865.0000,NULL,NULL,NULL,NULL,'0',NULL,'checkmo',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0',NULL,NULL,NULL,NULL,NULL,NULL,'0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'{\"method_title\":\"Check \\/ Money order\"}'),(2,2,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,45.0000,45.0000,NULL,NULL,394.9900,NULL,NULL,NULL,394.9900,NULL,NULL,NULL,NULL,'0',NULL,'checkmo',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0',NULL,NULL,NULL,NULL,NULL,NULL,'0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'{\"method_title\":\"Check \\/ Money order\"}'),(3,3,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,45.0000,45.0000,NULL,NULL,394.9900,NULL,NULL,NULL,394.9900,NULL,NULL,NULL,NULL,'0',NULL,'checkmo',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0',NULL,NULL,NULL,NULL,NULL,NULL,'0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'{\"method_title\":\"Check \\/ Money order\"}'),(4,4,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,45.0000,45.0000,NULL,NULL,394.9900,NULL,NULL,NULL,394.9900,NULL,NULL,NULL,NULL,'0',NULL,'adminpaymentmethod',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0',NULL,NULL,NULL,NULL,NULL,NULL,'0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'{\"method_title\":\"Admin Payment Method\"}');
/*!40000 ALTER TABLE `sales_order_payment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_order_status`
--

DROP TABLE IF EXISTS `sales_order_status`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_order_status` (
  `status` varchar(32) NOT NULL COMMENT 'Status',
  `label` varchar(128) NOT NULL COMMENT 'Label',
  PRIMARY KEY (`status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Order Status Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_order_status`
--

LOCK TABLES `sales_order_status` WRITE;
/*!40000 ALTER TABLE `sales_order_status` DISABLE KEYS */;
INSERT INTO `sales_order_status` VALUES ('canceled','Canceled'),('closed','Closed'),('complete','Complete'),('fraud','Suspected Fraud'),('holded','On Hold'),('payment_review','Payment Review'),('paypal_canceled_reversal','PayPal Canceled Reversal'),('paypal_reversed','PayPal Reversed'),('pending','Pending'),('pending_payment','Pending Payment'),('pending_paypal','Pending PayPal'),('processing','Processing');
/*!40000 ALTER TABLE `sales_order_status` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_sales_order_status_after_insert` AFTER INSERT ON `sales_order_status` FOR EACH ROW BEGIN
INSERT IGNORE INTO `sales_order_status_data_exporter_cl` (`entity_id`) VALUES (NEW.`status`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_sales_order_status_after_update` AFTER UPDATE ON `sales_order_status` FOR EACH ROW BEGIN
IF (NOT(NEW.`status` <=> OLD.`status`) OR NOT(NEW.`label` <=> OLD.`label`)) THEN INSERT IGNORE INTO `sales_order_status_data_exporter_cl` (`entity_id`) VALUES (NEW.`status`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_sales_order_status_after_delete` AFTER DELETE ON `sales_order_status` FOR EACH ROW BEGIN
INSERT IGNORE INTO `sales_order_status_data_exporter_cl` (`entity_id`) VALUES (OLD.`status`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `sales_order_status_data_exporter_cl`
--

DROP TABLE IF EXISTS `sales_order_status_data_exporter_cl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_order_status_data_exporter_cl` (
  `version_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Version ID',
  `entity_id` varchar(32) NOT NULL DEFAULT '' COMMENT 'Order status',
  PRIMARY KEY (`version_id`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb3 COMMENT='sales_order_status_data_exporter_cl';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_order_status_data_exporter_cl`
--

LOCK TABLES `sales_order_status_data_exporter_cl` WRITE;
/*!40000 ALTER TABLE `sales_order_status_data_exporter_cl` DISABLE KEYS */;
INSERT INTO `sales_order_status_data_exporter_cl` VALUES (1,'pending'),(2,'pending_payment'),(3,'processing'),(4,'holded'),(5,'complete'),(6,'closed'),(7,'canceled'),(8,'fraud'),(9,'payment_review'),(10,'pending_paypal'),(11,'paypal_reversed'),(12,'paypal_canceled_reversal');
/*!40000 ALTER TABLE `sales_order_status_data_exporter_cl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_order_status_history`
--

DROP TABLE IF EXISTS `sales_order_status_history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_order_status_history` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `parent_id` int unsigned NOT NULL COMMENT 'Parent ID',
  `is_customer_notified` int DEFAULT NULL COMMENT 'Is Customer Notified',
  `is_visible_on_front` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Visible On Front',
  `comment` text COMMENT 'Comment',
  `status` varchar(32) DEFAULT NULL COMMENT 'Status',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `entity_name` varchar(32) DEFAULT NULL COMMENT 'Shows what entity history is bind to.',
  PRIMARY KEY (`entity_id`),
  KEY `SALES_ORDER_STATUS_HISTORY_PARENT_ID` (`parent_id`),
  KEY `SALES_ORDER_STATUS_HISTORY_CREATED_AT` (`created_at`),
  CONSTRAINT `SALES_ORDER_STATUS_HISTORY_PARENT_ID_SALES_ORDER_ENTITY_ID` FOREIGN KEY (`parent_id`) REFERENCES `sales_order` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Order Status History';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_order_status_history`
--

LOCK TABLES `sales_order_status_history` WRITE;
/*!40000 ALTER TABLE `sales_order_status_history` DISABLE KEYS */;
INSERT INTO `sales_order_status_history` VALUES (1,1,1,1,'test','processing','2025-01-14 09:45:05','order'),(2,1,1,1,'test','processing','2025-01-14 09:45:50','order'),(3,3,1,1,'hbhu','pending','2025-01-29 15:49:03','order'),(4,3,1,1,'hbhu','pending','2025-01-29 15:49:04','order'),(5,3,1,1,'hbhu','pending','2025-01-29 15:49:10','order'),(6,3,1,1,'hbhu','pending','2025-01-29 15:49:18','order'),(7,3,1,1,'hbhu','pending','2025-01-29 15:49:19','order'),(8,3,1,1,'hbhu','pending','2025-01-29 15:49:20','order'),(9,4,0,1,'Order Placed by Store Administrator','pending','2025-01-29 15:54:40','order'),(10,4,0,0,'Order Placed by hyva Banyo using Admin Panel','pending','2025-01-29 15:54:40','order'),(11,4,1,1,'sdsdsds','processing','2025-01-29 15:57:31','order'),(12,4,0,1,'sdsdsds','processing','2025-01-29 15:57:38','order');
/*!40000 ALTER TABLE `sales_order_status_history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_order_status_label`
--

DROP TABLE IF EXISTS `sales_order_status_label`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_order_status_label` (
  `status` varchar(32) NOT NULL COMMENT 'Status',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `label` varchar(128) NOT NULL COMMENT 'Label',
  PRIMARY KEY (`status`,`store_id`),
  KEY `SALES_ORDER_STATUS_LABEL_STORE_ID` (`store_id`),
  CONSTRAINT `SALES_ORDER_STATUS_LABEL_STATUS_SALES_ORDER_STATUS_STATUS` FOREIGN KEY (`status`) REFERENCES `sales_order_status` (`status`) ON DELETE CASCADE,
  CONSTRAINT `SALES_ORDER_STATUS_LABEL_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Order Status Label Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_order_status_label`
--

LOCK TABLES `sales_order_status_label` WRITE;
/*!40000 ALTER TABLE `sales_order_status_label` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_order_status_label` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_order_status_state`
--

DROP TABLE IF EXISTS `sales_order_status_state`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_order_status_state` (
  `status` varchar(32) NOT NULL COMMENT 'Status',
  `state` varchar(32) NOT NULL COMMENT 'Label',
  `is_default` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Default',
  `visible_on_front` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Visible on front',
  PRIMARY KEY (`status`,`state`),
  CONSTRAINT `SALES_ORDER_STATUS_STATE_STATUS_SALES_ORDER_STATUS_STATUS` FOREIGN KEY (`status`) REFERENCES `sales_order_status` (`status`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Order Status Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_order_status_state`
--

LOCK TABLES `sales_order_status_state` WRITE;
/*!40000 ALTER TABLE `sales_order_status_state` DISABLE KEYS */;
INSERT INTO `sales_order_status_state` VALUES ('canceled','canceled',1,1),('closed','closed',1,1),('complete','complete',1,1),('fraud','payment_review',0,1),('fraud','processing',0,1),('holded','holded',1,1),('payment_review','payment_review',1,1),('pending','new',1,1),('pending_payment','pending_payment',1,0),('processing','processing',1,1);
/*!40000 ALTER TABLE `sales_order_status_state` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_order_tax`
--

DROP TABLE IF EXISTS `sales_order_tax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_order_tax` (
  `tax_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Tax ID',
  `order_id` int unsigned NOT NULL COMMENT 'Order ID',
  `code` varchar(255) DEFAULT NULL COMMENT 'Code',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title',
  `percent` decimal(12,4) DEFAULT NULL COMMENT 'Percent',
  `amount` decimal(20,4) DEFAULT NULL COMMENT 'Amount',
  `priority` int NOT NULL COMMENT 'Priority',
  `position` int NOT NULL COMMENT 'Position',
  `base_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Amount',
  `process` smallint NOT NULL COMMENT 'Process',
  `base_real_amount` decimal(20,4) DEFAULT NULL COMMENT 'Base Real Amount',
  PRIMARY KEY (`tax_id`),
  KEY `SALES_ORDER_TAX_ORDER_ID_PRIORITY_POSITION` (`order_id`,`priority`,`position`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Order Tax Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_order_tax`
--

LOCK TABLES `sales_order_tax` WRITE;
/*!40000 ALTER TABLE `sales_order_tax` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_order_tax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_order_tax_item`
--

DROP TABLE IF EXISTS `sales_order_tax_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_order_tax_item` (
  `tax_item_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Tax Item ID',
  `tax_id` int unsigned NOT NULL COMMENT 'Tax ID',
  `item_id` int unsigned DEFAULT NULL COMMENT 'Item ID',
  `tax_percent` decimal(12,4) NOT NULL COMMENT 'Real Tax Percent For Item',
  `amount` decimal(20,4) NOT NULL COMMENT 'Tax amount for the item and tax rate',
  `base_amount` decimal(20,4) NOT NULL COMMENT 'Base tax amount for the item and tax rate',
  `real_amount` decimal(20,4) NOT NULL COMMENT 'Real tax amount for the item and tax rate',
  `real_base_amount` decimal(20,4) NOT NULL COMMENT 'Real base tax amount for the item and tax rate',
  `associated_item_id` int unsigned DEFAULT NULL COMMENT 'Id of the associated item',
  `taxable_item_type` varchar(32) NOT NULL COMMENT 'Type of the taxable item',
  PRIMARY KEY (`tax_item_id`),
  UNIQUE KEY `SALES_ORDER_TAX_ITEM_TAX_ID_ITEM_ID` (`tax_id`,`item_id`),
  KEY `SALES_ORDER_TAX_ITEM_ASSOCIATED_ITEM_ID_SALES_ORDER_ITEM_ITEM_ID` (`associated_item_id`),
  KEY `SALES_ORDER_TAX_ITEM_ITEM_ID` (`item_id`),
  CONSTRAINT `SALES_ORDER_TAX_ITEM_ASSOCIATED_ITEM_ID_SALES_ORDER_ITEM_ITEM_ID` FOREIGN KEY (`associated_item_id`) REFERENCES `sales_order_item` (`item_id`) ON DELETE CASCADE,
  CONSTRAINT `SALES_ORDER_TAX_ITEM_ITEM_ID_SALES_ORDER_ITEM_ITEM_ID` FOREIGN KEY (`item_id`) REFERENCES `sales_order_item` (`item_id`) ON DELETE CASCADE,
  CONSTRAINT `SALES_ORDER_TAX_ITEM_TAX_ID_SALES_ORDER_TAX_TAX_ID` FOREIGN KEY (`tax_id`) REFERENCES `sales_order_tax` (`tax_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Order Tax Item';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_order_tax_item`
--

LOCK TABLES `sales_order_tax_item` WRITE;
/*!40000 ALTER TABLE `sales_order_tax_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_order_tax_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_payment_transaction`
--

DROP TABLE IF EXISTS `sales_payment_transaction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_payment_transaction` (
  `transaction_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Transaction ID',
  `parent_id` int unsigned DEFAULT NULL COMMENT 'Parent ID',
  `order_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Order ID',
  `payment_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Payment ID',
  `txn_id` varchar(100) DEFAULT NULL COMMENT 'Txn ID',
  `parent_txn_id` varchar(100) DEFAULT NULL COMMENT 'Parent Txn ID',
  `txn_type` varchar(15) DEFAULT NULL COMMENT 'Txn Type',
  `is_closed` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Is Closed',
  `additional_information` blob COMMENT 'Additional Information',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  PRIMARY KEY (`transaction_id`),
  UNIQUE KEY `SALES_PAYMENT_TRANSACTION_ORDER_ID_PAYMENT_ID_TXN_ID` (`order_id`,`payment_id`,`txn_id`),
  KEY `SALES_PAYMENT_TRANSACTION_PARENT_ID` (`parent_id`),
  KEY `SALES_PAYMENT_TRANSACTION_PAYMENT_ID` (`payment_id`),
  CONSTRAINT `FK_B99FF1A06402D725EBDB0F3A7ECD47A2` FOREIGN KEY (`parent_id`) REFERENCES `sales_payment_transaction` (`transaction_id`) ON DELETE CASCADE,
  CONSTRAINT `SALES_PAYMENT_TRANSACTION_ORDER_ID_SALES_ORDER_ENTITY_ID` FOREIGN KEY (`order_id`) REFERENCES `sales_order` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `SALES_PAYMENT_TRANSACTION_PAYMENT_ID_SALES_ORDER_PAYMENT_ENTT_ID` FOREIGN KEY (`payment_id`) REFERENCES `sales_order_payment` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Payment Transaction';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_payment_transaction`
--

LOCK TABLES `sales_payment_transaction` WRITE;
/*!40000 ALTER TABLE `sales_payment_transaction` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_payment_transaction` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_sales_payment_transaction_after_insert` AFTER INSERT ON `sales_payment_transaction` FOR EACH ROW BEGIN
INSERT IGNORE INTO `sales_order_data_exporter_cl` (`entity_id`) VALUES (NEW.`order_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_sales_payment_transaction_after_update` AFTER UPDATE ON `sales_payment_transaction` FOR EACH ROW BEGIN
IF (NOT(NEW.`transaction_id` <=> OLD.`transaction_id`) OR NOT(NEW.`parent_id` <=> OLD.`parent_id`) OR NOT(NEW.`order_id` <=> OLD.`order_id`) OR NOT(NEW.`payment_id` <=> OLD.`payment_id`) OR NOT(NEW.`txn_id` <=> OLD.`txn_id`) OR NOT(NEW.`parent_txn_id` <=> OLD.`parent_txn_id`) OR NOT(NEW.`txn_type` <=> OLD.`txn_type`) OR NOT(NEW.`is_closed` <=> OLD.`is_closed`) OR NOT(NEW.`additional_information` <=> OLD.`additional_information`) OR NOT(NEW.`created_at` <=> OLD.`created_at`)) THEN INSERT IGNORE INTO `sales_order_data_exporter_cl` (`entity_id`) VALUES (NEW.`order_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_sales_payment_transaction_after_delete` AFTER DELETE ON `sales_payment_transaction` FOR EACH ROW BEGIN
INSERT IGNORE INTO `sales_order_data_exporter_cl` (`entity_id`) VALUES (OLD.`order_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `sales_refunded_aggregated`
--

DROP TABLE IF EXISTS `sales_refunded_aggregated`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_refunded_aggregated` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `order_status` varchar(50) NOT NULL COMMENT 'Order Status',
  `orders_count` int NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `refunded` decimal(20,4) DEFAULT NULL COMMENT 'Refunded',
  `online_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Online Refunded',
  `offline_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Offline Refunded',
  PRIMARY KEY (`id`),
  UNIQUE KEY `SALES_REFUNDED_AGGREGATED_PERIOD_STORE_ID_ORDER_STATUS` (`period`,`store_id`,`order_status`),
  KEY `SALES_REFUNDED_AGGREGATED_STORE_ID` (`store_id`),
  CONSTRAINT `SALES_REFUNDED_AGGREGATED_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Refunded Aggregated';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_refunded_aggregated`
--

LOCK TABLES `sales_refunded_aggregated` WRITE;
/*!40000 ALTER TABLE `sales_refunded_aggregated` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_refunded_aggregated` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_refunded_aggregated_order`
--

DROP TABLE IF EXISTS `sales_refunded_aggregated_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_refunded_aggregated_order` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `order_status` varchar(50) DEFAULT NULL COMMENT 'Order Status',
  `orders_count` int NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `refunded` decimal(20,4) DEFAULT NULL COMMENT 'Refunded',
  `online_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Online Refunded',
  `offline_refunded` decimal(20,4) DEFAULT NULL COMMENT 'Offline Refunded',
  PRIMARY KEY (`id`),
  UNIQUE KEY `SALES_REFUNDED_AGGREGATED_ORDER_PERIOD_STORE_ID_ORDER_STATUS` (`period`,`store_id`,`order_status`),
  KEY `SALES_REFUNDED_AGGREGATED_ORDER_STORE_ID` (`store_id`),
  CONSTRAINT `SALES_REFUNDED_AGGREGATED_ORDER_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Refunded Aggregated Order';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_refunded_aggregated_order`
--

LOCK TABLES `sales_refunded_aggregated_order` WRITE;
/*!40000 ALTER TABLE `sales_refunded_aggregated_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_refunded_aggregated_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_sequence_meta`
--

DROP TABLE IF EXISTS `sales_sequence_meta`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_sequence_meta` (
  `meta_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `entity_type` varchar(32) NOT NULL COMMENT 'Prefix',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `sequence_table` varchar(64) NOT NULL COMMENT 'table for sequence',
  PRIMARY KEY (`meta_id`),
  UNIQUE KEY `SALES_SEQUENCE_META_ENTITY_TYPE_STORE_ID` (`entity_type`,`store_id`)
) ENGINE=InnoDB AUTO_INCREMENT=25 DEFAULT CHARSET=utf8mb3 COMMENT='sales_sequence_meta';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_sequence_meta`
--

LOCK TABLES `sales_sequence_meta` WRITE;
/*!40000 ALTER TABLE `sales_sequence_meta` DISABLE KEYS */;
INSERT INTO `sales_sequence_meta` VALUES (1,'order',0,'sequence_order_0'),(2,'invoice',0,'sequence_invoice_0'),(3,'creditmemo',0,'sequence_creditmemo_0'),(4,'shipment',0,'sequence_shipment_0'),(5,'order',1,'sequence_order_1'),(6,'invoice',1,'sequence_invoice_1'),(7,'creditmemo',1,'sequence_creditmemo_1'),(8,'shipment',1,'sequence_shipment_1'),(9,'order',2,'sequence_order_2'),(10,'invoice',2,'sequence_invoice_2'),(11,'creditmemo',2,'sequence_creditmemo_2'),(12,'shipment',2,'sequence_shipment_2'),(13,'order',3,'sequence_order_3'),(14,'invoice',3,'sequence_invoice_3'),(15,'creditmemo',3,'sequence_creditmemo_3'),(16,'shipment',3,'sequence_shipment_3'),(17,'order',4,'sequence_order_4'),(18,'invoice',4,'sequence_invoice_4'),(19,'creditmemo',4,'sequence_creditmemo_4'),(20,'shipment',4,'sequence_shipment_4'),(21,'order',5,'sequence_order_5'),(22,'invoice',5,'sequence_invoice_5'),(23,'creditmemo',5,'sequence_creditmemo_5'),(24,'shipment',5,'sequence_shipment_5');
/*!40000 ALTER TABLE `sales_sequence_meta` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_sequence_profile`
--

DROP TABLE IF EXISTS `sales_sequence_profile`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_sequence_profile` (
  `profile_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `meta_id` int unsigned NOT NULL COMMENT 'Meta_id',
  `prefix` varchar(32) DEFAULT NULL COMMENT 'Prefix',
  `suffix` varchar(32) DEFAULT NULL COMMENT 'Suffix',
  `start_value` int unsigned NOT NULL DEFAULT '1' COMMENT 'Start value for sequence',
  `step` int unsigned NOT NULL DEFAULT '1' COMMENT 'Step for sequence',
  `max_value` int unsigned NOT NULL COMMENT 'MaxValue for sequence',
  `warning_value` int unsigned NOT NULL COMMENT 'WarningValue for sequence',
  `is_active` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'isActive flag',
  PRIMARY KEY (`profile_id`),
  UNIQUE KEY `SALES_SEQUENCE_PROFILE_META_ID_PREFIX_SUFFIX` (`meta_id`,`prefix`,`suffix`),
  CONSTRAINT `SALES_SEQUENCE_PROFILE_META_ID_SALES_SEQUENCE_META_META_ID` FOREIGN KEY (`meta_id`) REFERENCES `sales_sequence_meta` (`meta_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=25 DEFAULT CHARSET=utf8mb3 COMMENT='sales_sequence_profile';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_sequence_profile`
--

LOCK TABLES `sales_sequence_profile` WRITE;
/*!40000 ALTER TABLE `sales_sequence_profile` DISABLE KEYS */;
INSERT INTO `sales_sequence_profile` VALUES (1,1,NULL,NULL,1,1,4294967295,4294966295,1),(2,2,NULL,NULL,1,1,4294967295,4294966295,1),(3,3,NULL,NULL,1,1,4294967295,4294966295,1),(4,4,NULL,NULL,1,1,4294967295,4294966295,1),(5,5,NULL,NULL,1,1,4294967295,4294966295,1),(6,6,NULL,NULL,1,1,4294967295,4294966295,1),(7,7,NULL,NULL,1,1,4294967295,4294966295,1),(8,8,NULL,NULL,1,1,4294967295,4294966295,1),(9,9,'2',NULL,1,1,4294967295,4294966295,1),(10,10,'2',NULL,1,1,4294967295,4294966295,1),(11,11,'2',NULL,1,1,4294967295,4294966295,1),(12,12,'2',NULL,1,1,4294967295,4294966295,1),(13,13,'3',NULL,1,1,4294967295,4294966295,1),(14,14,'3',NULL,1,1,4294967295,4294966295,1),(15,15,'3',NULL,1,1,4294967295,4294966295,1),(16,16,'3',NULL,1,1,4294967295,4294966295,1),(17,17,'4',NULL,1,1,4294967295,4294966295,1),(18,18,'4',NULL,1,1,4294967295,4294966295,1),(19,19,'4',NULL,1,1,4294967295,4294966295,1),(20,20,'4',NULL,1,1,4294967295,4294966295,1),(21,21,'5',NULL,1,1,4294967295,4294966295,1),(22,22,'5',NULL,1,1,4294967295,4294966295,1),(23,23,'5',NULL,1,1,4294967295,4294966295,1),(24,24,'5',NULL,1,1,4294967295,4294966295,1);
/*!40000 ALTER TABLE `sales_sequence_profile` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_shipment`
--

DROP TABLE IF EXISTS `sales_shipment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_shipment` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `total_weight` decimal(12,4) DEFAULT NULL COMMENT 'Total Weight',
  `total_qty` decimal(12,4) DEFAULT NULL COMMENT 'Total Qty',
  `email_sent` smallint unsigned DEFAULT NULL COMMENT 'Email Sent',
  `send_email` smallint unsigned DEFAULT NULL COMMENT 'Send Email',
  `order_id` int unsigned NOT NULL COMMENT 'Order ID',
  `customer_id` int DEFAULT NULL COMMENT 'Customer ID',
  `shipping_address_id` int DEFAULT NULL COMMENT 'Shipping Address ID',
  `billing_address_id` int DEFAULT NULL COMMENT 'Billing Address ID',
  `shipment_status` int DEFAULT NULL COMMENT 'Shipment Status',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  `packages` text COMMENT 'Packed Products in Packages',
  `shipping_label` mediumblob COMMENT 'Shipping Label Content',
  `customer_note` text COMMENT 'Customer Note',
  `customer_note_notify` smallint unsigned DEFAULT NULL COMMENT 'Customer Note Notify',
  `mollie_shipment_id` varchar(255) DEFAULT NULL COMMENT 'Mollie Shipment Id',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `SALES_SHIPMENT_INCREMENT_ID_STORE_ID` (`increment_id`,`store_id`),
  KEY `SALES_SHIPMENT_STORE_ID` (`store_id`),
  KEY `SALES_SHIPMENT_TOTAL_QTY` (`total_qty`),
  KEY `SALES_SHIPMENT_ORDER_ID` (`order_id`),
  KEY `SALES_SHIPMENT_CREATED_AT` (`created_at`),
  KEY `SALES_SHIPMENT_UPDATED_AT` (`updated_at`),
  KEY `SALES_SHIPMENT_SEND_EMAIL` (`send_email`),
  KEY `SALES_SHIPMENT_EMAIL_SENT` (`email_sent`),
  KEY `SALES_SHIPMENT_MOLLIE_SHIPMENT_ID` (`mollie_shipment_id`),
  CONSTRAINT `SALES_SHIPMENT_ORDER_ID_SALES_ORDER_ENTITY_ID` FOREIGN KEY (`order_id`) REFERENCES `sales_order` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `SALES_SHIPMENT_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Shipment';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_shipment`
--

LOCK TABLES `sales_shipment` WRITE;
/*!40000 ALTER TABLE `sales_shipment` DISABLE KEYS */;
INSERT INTO `sales_shipment` VALUES (1,1,NULL,1.0000,NULL,NULL,1,NULL,1,2,NULL,'000000001','2025-01-14 09:42:27','2025-01-14 09:42:27','[]',NULL,NULL,NULL,NULL),(2,1,NULL,1.0000,NULL,NULL,4,NULL,7,8,NULL,'000000002','2025-01-29 15:56:59','2025-01-29 15:56:59','[]',NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `sales_shipment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_shipment_comment`
--

DROP TABLE IF EXISTS `sales_shipment_comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_shipment_comment` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `parent_id` int unsigned NOT NULL COMMENT 'Parent ID',
  `is_customer_notified` int DEFAULT NULL COMMENT 'Is Customer Notified',
  `is_visible_on_front` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is Visible On Front',
  `comment` text COMMENT 'Comment',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  PRIMARY KEY (`entity_id`),
  KEY `SALES_SHIPMENT_COMMENT_CREATED_AT` (`created_at`),
  KEY `SALES_SHIPMENT_COMMENT_PARENT_ID` (`parent_id`),
  CONSTRAINT `SALES_SHIPMENT_COMMENT_PARENT_ID_SALES_SHIPMENT_ENTITY_ID` FOREIGN KEY (`parent_id`) REFERENCES `sales_shipment` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Shipment Comment';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_shipment_comment`
--

LOCK TABLES `sales_shipment_comment` WRITE;
/*!40000 ALTER TABLE `sales_shipment_comment` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_shipment_comment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_shipment_grid`
--

DROP TABLE IF EXISTS `sales_shipment_grid`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_shipment_grid` (
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment ID',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `order_increment_id` varchar(32) NOT NULL COMMENT 'Order Increment ID',
  `order_id` int unsigned NOT NULL COMMENT 'Order ID',
  `order_created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Order Increment ID',
  `customer_name` varchar(128) NOT NULL COMMENT 'Customer Name',
  `total_qty` decimal(12,4) DEFAULT NULL COMMENT 'Total Qty',
  `shipment_status` int DEFAULT NULL COMMENT 'Shipment Status',
  `order_status` varchar(32) DEFAULT NULL COMMENT 'Order',
  `billing_address` varchar(255) DEFAULT NULL COMMENT 'Billing Address',
  `shipping_address` varchar(255) DEFAULT NULL COMMENT 'Shipping Address',
  `billing_name` varchar(128) DEFAULT NULL COMMENT 'Billing Name',
  `shipping_name` varchar(128) DEFAULT NULL COMMENT 'Shipping Name',
  `customer_email` varchar(128) DEFAULT NULL COMMENT 'Customer Email',
  `customer_group_id` int DEFAULT NULL,
  `payment_method` varchar(32) DEFAULT NULL COMMENT 'Payment Method',
  `shipping_information` varchar(255) DEFAULT NULL COMMENT 'Shipping Method Name',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `SALES_SHIPMENT_GRID_INCREMENT_ID_STORE_ID` (`increment_id`,`store_id`),
  KEY `SALES_SHIPMENT_GRID_STORE_ID` (`store_id`),
  KEY `SALES_SHIPMENT_GRID_TOTAL_QTY` (`total_qty`),
  KEY `SALES_SHIPMENT_GRID_ORDER_INCREMENT_ID` (`order_increment_id`),
  KEY `SALES_SHIPMENT_GRID_SHIPMENT_STATUS` (`shipment_status`),
  KEY `SALES_SHIPMENT_GRID_ORDER_STATUS` (`order_status`),
  KEY `SALES_SHIPMENT_GRID_CREATED_AT` (`created_at`),
  KEY `SALES_SHIPMENT_GRID_UPDATED_AT` (`updated_at`),
  KEY `SALES_SHIPMENT_GRID_ORDER_CREATED_AT` (`order_created_at`),
  KEY `SALES_SHIPMENT_GRID_SHIPPING_NAME` (`shipping_name`),
  KEY `SALES_SHIPMENT_GRID_BILLING_NAME` (`billing_name`),
  KEY `SALES_SHIPMENT_GRID_ORDER_ID` (`order_id`),
  FULLTEXT KEY `FTI_086B40C8955F167B8EA76653437879B4` (`increment_id`,`order_increment_id`,`shipping_name`,`customer_name`,`customer_email`,`billing_address`,`shipping_address`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Shipment Grid';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_shipment_grid`
--

LOCK TABLES `sales_shipment_grid` WRITE;
/*!40000 ALTER TABLE `sales_shipment_grid` DISABLE KEYS */;
INSERT INTO `sales_shipment_grid` VALUES (1,'000000001',1,'000000003',1,'2025-01-07 13:54:08','Muhammad  Zohaib',1.0000,NULL,'processing','Banyo,89/A,London,Guam,12345 12345','Banyo,89/A,London,Guam,12345 12345','Muhammad  Zohaib','Muhammad  Zohaib','zohaibmuhammad23@gmail.com',0,'checkmo','Flat Rate - Fixed','2025-01-14 09:42:27','2025-01-14 09:42:27'),(2,'000000002',1,'000000005-1',4,'2025-01-29 15:54:40','Test zohaib',1.0000,NULL,'processing','Banyo,sasas,London,Guam,123456','Banyo,sasas,London,Guam,123456','Test zohaib','Test zohaib','zohaibmuhammad23@gmail.com',0,'adminpaymentmethod','Van Delivery - Shipping Test','2025-01-29 15:56:59','2025-01-29 15:56:59');
/*!40000 ALTER TABLE `sales_shipment_grid` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_shipment_item`
--

DROP TABLE IF EXISTS `sales_shipment_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_shipment_item` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `parent_id` int unsigned NOT NULL COMMENT 'Parent ID',
  `row_total` decimal(20,4) DEFAULT NULL COMMENT 'Row Total',
  `price` decimal(20,4) DEFAULT NULL COMMENT 'Price',
  `weight` decimal(12,4) DEFAULT NULL COMMENT 'Weight',
  `qty` decimal(12,4) DEFAULT NULL COMMENT 'Qty',
  `product_id` int DEFAULT NULL COMMENT 'Product ID',
  `order_item_id` int DEFAULT NULL COMMENT 'Order Item ID',
  `additional_data` text COMMENT 'Additional Data',
  `description` text COMMENT 'Description',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `sku` varchar(255) DEFAULT NULL COMMENT 'Sku',
  PRIMARY KEY (`entity_id`),
  KEY `SALES_SHIPMENT_ITEM_PARENT_ID` (`parent_id`),
  CONSTRAINT `SALES_SHIPMENT_ITEM_PARENT_ID_SALES_SHIPMENT_ENTITY_ID` FOREIGN KEY (`parent_id`) REFERENCES `sales_shipment` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Shipment Item';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_shipment_item`
--

LOCK TABLES `sales_shipment_item` WRITE;
/*!40000 ALTER TABLE `sales_shipment_item` DISABLE KEYS */;
INSERT INTO `sales_shipment_item` VALUES (1,1,NULL,860.0000,NULL,1.0000,4894,1,NULL,NULL,'Franke 800 Hood FVAS A80 BK/2 Voice, App, & Remote Control','FVAS A80 BK Z1'),(2,2,NULL,349.9900,NULL,1.0000,1162,4,NULL,NULL,'Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink','Reginox Comfort Colorado L Integrated 1 Bowl Kitchen Sink');
/*!40000 ALTER TABLE `sales_shipment_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_shipment_track`
--

DROP TABLE IF EXISTS `sales_shipment_track`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_shipment_track` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `parent_id` int unsigned NOT NULL COMMENT 'Parent ID',
  `weight` decimal(12,4) DEFAULT NULL COMMENT 'Weight',
  `qty` decimal(12,4) DEFAULT NULL COMMENT 'Qty',
  `order_id` int unsigned NOT NULL COMMENT 'Order ID',
  `track_number` text COMMENT 'Number',
  `description` text COMMENT 'Description',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title',
  `carrier_code` varchar(32) DEFAULT NULL COMMENT 'Carrier Code',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated At',
  PRIMARY KEY (`entity_id`),
  KEY `SALES_SHIPMENT_TRACK_PARENT_ID` (`parent_id`),
  KEY `SALES_SHIPMENT_TRACK_ORDER_ID` (`order_id`),
  KEY `SALES_SHIPMENT_TRACK_CREATED_AT` (`created_at`),
  CONSTRAINT `SALES_SHIPMENT_TRACK_PARENT_ID_SALES_SHIPMENT_ENTITY_ID` FOREIGN KEY (`parent_id`) REFERENCES `sales_shipment` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Shipment Track';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_shipment_track`
--

LOCK TABLES `sales_shipment_track` WRITE;
/*!40000 ALTER TABLE `sales_shipment_track` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_shipment_track` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_shipping_aggregated`
--

DROP TABLE IF EXISTS `sales_shipping_aggregated`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_shipping_aggregated` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `order_status` varchar(50) DEFAULT NULL COMMENT 'Order Status',
  `shipping_description` varchar(255) DEFAULT NULL COMMENT 'Shipping Description',
  `orders_count` int NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `total_shipping` decimal(20,4) DEFAULT NULL COMMENT 'Total Shipping',
  `total_shipping_actual` decimal(20,4) DEFAULT NULL COMMENT 'Total Shipping Actual',
  PRIMARY KEY (`id`),
  UNIQUE KEY `SALES_SHPP_AGGRED_PERIOD_STORE_ID_ORDER_STS_SHPP_DESCRIPTION` (`period`,`store_id`,`order_status`,`shipping_description`),
  KEY `SALES_SHIPPING_AGGREGATED_STORE_ID` (`store_id`),
  CONSTRAINT `SALES_SHIPPING_AGGREGATED_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Shipping Aggregated';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_shipping_aggregated`
--

LOCK TABLES `sales_shipping_aggregated` WRITE;
/*!40000 ALTER TABLE `sales_shipping_aggregated` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_shipping_aggregated` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_shipping_aggregated_order`
--

DROP TABLE IF EXISTS `sales_shipping_aggregated_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sales_shipping_aggregated_order` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `order_status` varchar(50) DEFAULT NULL COMMENT 'Order Status',
  `shipping_description` varchar(255) DEFAULT NULL COMMENT 'Shipping Description',
  `orders_count` int NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `total_shipping` decimal(20,4) DEFAULT NULL COMMENT 'Total Shipping',
  `total_shipping_actual` decimal(20,4) DEFAULT NULL COMMENT 'Total Shipping Actual',
  PRIMARY KEY (`id`),
  UNIQUE KEY `UNQ_C05FAE47282EEA68654D0924E946761F` (`period`,`store_id`,`order_status`,`shipping_description`),
  KEY `SALES_SHIPPING_AGGREGATED_ORDER_STORE_ID` (`store_id`),
  CONSTRAINT `SALES_SHIPPING_AGGREGATED_ORDER_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Shipping Aggregated Order';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_shipping_aggregated_order`
--

LOCK TABLES `sales_shipping_aggregated_order` WRITE;
/*!40000 ALTER TABLE `sales_shipping_aggregated_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_shipping_aggregated_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesrule`
--

DROP TABLE IF EXISTS `salesrule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `salesrule` (
  `rule_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `description` text COMMENT 'Description',
  `from_date` date DEFAULT NULL COMMENT 'From',
  `to_date` date DEFAULT NULL COMMENT 'To',
  `uses_per_customer` int NOT NULL DEFAULT '0' COMMENT 'Uses Per Customer',
  `is_active` smallint NOT NULL DEFAULT '0' COMMENT 'Is Active',
  `conditions_serialized` mediumtext COMMENT 'Conditions Serialized',
  `actions_serialized` mediumtext COMMENT 'Actions Serialized',
  `stop_rules_processing` smallint NOT NULL DEFAULT '1' COMMENT 'Stop Rules Processing',
  `is_advanced` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Is Advanced',
  `product_ids` text COMMENT 'Product Ids',
  `sort_order` int unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `simple_action` varchar(32) DEFAULT NULL COMMENT 'Simple Action',
  `discount_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount',
  `discount_qty` decimal(12,4) DEFAULT NULL COMMENT 'Discount Qty',
  `discount_step` int unsigned NOT NULL DEFAULT '0' COMMENT 'Discount Step',
  `apply_to_shipping` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Apply To Shipping',
  `times_used` int unsigned NOT NULL DEFAULT '0' COMMENT 'Times Used',
  `is_rss` smallint NOT NULL DEFAULT '0' COMMENT 'Is Rss',
  `coupon_type` smallint unsigned NOT NULL DEFAULT '1' COMMENT 'Coupon Type',
  `use_auto_generation` smallint NOT NULL DEFAULT '0' COMMENT 'Use Auto Generation',
  `uses_per_coupon` int NOT NULL DEFAULT '0' COMMENT 'User Per Coupon',
  `simple_free_shipping` smallint unsigned DEFAULT NULL COMMENT 'Simple Free Shipping',
  PRIMARY KEY (`rule_id`),
  KEY `SALESRULE_IS_ACTIVE_SORT_ORDER_TO_DATE_FROM_DATE` (`is_active`,`sort_order`,`to_date`,`from_date`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Salesrule';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesrule`
--

LOCK TABLES `salesrule` WRITE;
/*!40000 ALTER TABLE `salesrule` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesrule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesrule_coupon`
--

DROP TABLE IF EXISTS `salesrule_coupon`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `salesrule_coupon` (
  `coupon_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Coupon ID',
  `rule_id` int unsigned NOT NULL COMMENT 'Rule ID',
  `code` varchar(255) DEFAULT NULL COMMENT 'Code',
  `usage_limit` int unsigned DEFAULT NULL COMMENT 'Usage Limit',
  `usage_per_customer` int unsigned DEFAULT NULL COMMENT 'Usage Per Customer',
  `times_used` int unsigned NOT NULL DEFAULT '0' COMMENT 'Times Used',
  `expiration_date` datetime DEFAULT NULL COMMENT 'Expiration Date',
  `is_primary` smallint unsigned DEFAULT NULL COMMENT 'Is Primary',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Coupon Code Creation Date',
  `type` smallint DEFAULT '0' COMMENT 'Coupon Code Type',
  PRIMARY KEY (`coupon_id`),
  UNIQUE KEY `SALESRULE_COUPON_CODE` (`code`),
  UNIQUE KEY `SALESRULE_COUPON_RULE_ID_IS_PRIMARY` (`rule_id`,`is_primary`),
  KEY `SALESRULE_COUPON_RULE_ID` (`rule_id`),
  CONSTRAINT `SALESRULE_COUPON_RULE_ID_SALESRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `salesrule` (`rule_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Salesrule Coupon';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesrule_coupon`
--

LOCK TABLES `salesrule_coupon` WRITE;
/*!40000 ALTER TABLE `salesrule_coupon` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesrule_coupon` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesrule_coupon_aggregated`
--

DROP TABLE IF EXISTS `salesrule_coupon_aggregated`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `salesrule_coupon_aggregated` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date NOT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `order_status` varchar(50) DEFAULT NULL COMMENT 'Order Status',
  `coupon_code` varchar(50) DEFAULT NULL COMMENT 'Coupon Code',
  `coupon_uses` int NOT NULL DEFAULT '0' COMMENT 'Coupon Uses',
  `subtotal_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Subtotal Amount',
  `discount_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount',
  `total_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Amount',
  `subtotal_amount_actual` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Subtotal Amount Actual',
  `discount_amount_actual` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount Actual',
  `total_amount_actual` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Amount Actual',
  `rule_name` varchar(255) DEFAULT NULL COMMENT 'Rule Name',
  PRIMARY KEY (`id`),
  UNIQUE KEY `SALESRULE_COUPON_AGGRED_PERIOD_STORE_ID_ORDER_STS_COUPON_CODE` (`period`,`store_id`,`order_status`,`coupon_code`),
  KEY `SALESRULE_COUPON_AGGREGATED_STORE_ID` (`store_id`),
  KEY `SALESRULE_COUPON_AGGREGATED_RULE_NAME` (`rule_name`),
  CONSTRAINT `SALESRULE_COUPON_AGGREGATED_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Coupon Aggregated';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesrule_coupon_aggregated`
--

LOCK TABLES `salesrule_coupon_aggregated` WRITE;
/*!40000 ALTER TABLE `salesrule_coupon_aggregated` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesrule_coupon_aggregated` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesrule_coupon_aggregated_order`
--

DROP TABLE IF EXISTS `salesrule_coupon_aggregated_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `salesrule_coupon_aggregated_order` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date NOT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `order_status` varchar(50) DEFAULT NULL COMMENT 'Order Status',
  `coupon_code` varchar(50) DEFAULT NULL COMMENT 'Coupon Code',
  `coupon_uses` int NOT NULL DEFAULT '0' COMMENT 'Coupon Uses',
  `subtotal_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Subtotal Amount',
  `discount_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount',
  `total_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Amount',
  `rule_name` varchar(255) DEFAULT NULL COMMENT 'Rule Name',
  PRIMARY KEY (`id`),
  UNIQUE KEY `UNQ_1094D1FBBCBB11704A29DEF3ACC37D2B` (`period`,`store_id`,`order_status`,`coupon_code`),
  KEY `SALESRULE_COUPON_AGGREGATED_ORDER_STORE_ID` (`store_id`),
  KEY `SALESRULE_COUPON_AGGREGATED_ORDER_RULE_NAME` (`rule_name`),
  CONSTRAINT `SALESRULE_COUPON_AGGREGATED_ORDER_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Coupon Aggregated Order';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesrule_coupon_aggregated_order`
--

LOCK TABLES `salesrule_coupon_aggregated_order` WRITE;
/*!40000 ALTER TABLE `salesrule_coupon_aggregated_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesrule_coupon_aggregated_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesrule_coupon_aggregated_updated`
--

DROP TABLE IF EXISTS `salesrule_coupon_aggregated_updated`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `salesrule_coupon_aggregated_updated` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date NOT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `order_status` varchar(50) DEFAULT NULL COMMENT 'Order Status',
  `coupon_code` varchar(50) DEFAULT NULL COMMENT 'Coupon Code',
  `coupon_uses` int NOT NULL DEFAULT '0' COMMENT 'Coupon Uses',
  `subtotal_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Subtotal Amount',
  `discount_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount',
  `total_amount` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Amount',
  `subtotal_amount_actual` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Subtotal Amount Actual',
  `discount_amount_actual` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount Actual',
  `total_amount_actual` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Amount Actual',
  `rule_name` varchar(255) DEFAULT NULL COMMENT 'Rule Name',
  PRIMARY KEY (`id`),
  UNIQUE KEY `UNQ_7196FA120A4F0F84E1B66605E87E213E` (`period`,`store_id`,`order_status`,`coupon_code`),
  KEY `SALESRULE_COUPON_AGGREGATED_UPDATED_STORE_ID` (`store_id`),
  KEY `SALESRULE_COUPON_AGGREGATED_UPDATED_RULE_NAME` (`rule_name`),
  CONSTRAINT `SALESRULE_COUPON_AGGREGATED_UPDATED_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Salesrule Coupon Aggregated Updated';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesrule_coupon_aggregated_updated`
--

LOCK TABLES `salesrule_coupon_aggregated_updated` WRITE;
/*!40000 ALTER TABLE `salesrule_coupon_aggregated_updated` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesrule_coupon_aggregated_updated` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesrule_coupon_usage`
--

DROP TABLE IF EXISTS `salesrule_coupon_usage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `salesrule_coupon_usage` (
  `coupon_id` int unsigned NOT NULL COMMENT 'Coupon ID',
  `customer_id` int unsigned NOT NULL COMMENT 'Customer ID',
  `times_used` int unsigned NOT NULL DEFAULT '0' COMMENT 'Times Used',
  PRIMARY KEY (`coupon_id`,`customer_id`),
  KEY `SALESRULE_COUPON_USAGE_CUSTOMER_ID` (`customer_id`),
  CONSTRAINT `SALESRULE_COUPON_USAGE_COUPON_ID_SALESRULE_COUPON_COUPON_ID` FOREIGN KEY (`coupon_id`) REFERENCES `salesrule_coupon` (`coupon_id`) ON DELETE CASCADE,
  CONSTRAINT `SALESRULE_COUPON_USAGE_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Salesrule Coupon Usage';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesrule_coupon_usage`
--

LOCK TABLES `salesrule_coupon_usage` WRITE;
/*!40000 ALTER TABLE `salesrule_coupon_usage` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesrule_coupon_usage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesrule_customer`
--

DROP TABLE IF EXISTS `salesrule_customer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `salesrule_customer` (
  `rule_customer_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rule Customer ID',
  `rule_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Rule ID',
  `customer_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer ID',
  `times_used` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Times Used',
  PRIMARY KEY (`rule_customer_id`),
  KEY `SALESRULE_CUSTOMER_RULE_ID_CUSTOMER_ID` (`rule_id`,`customer_id`),
  KEY `SALESRULE_CUSTOMER_CUSTOMER_ID_RULE_ID` (`customer_id`,`rule_id`),
  CONSTRAINT `SALESRULE_CUSTOMER_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `SALESRULE_CUSTOMER_RULE_ID_SALESRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `salesrule` (`rule_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Salesrule Customer';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesrule_customer`
--

LOCK TABLES `salesrule_customer` WRITE;
/*!40000 ALTER TABLE `salesrule_customer` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesrule_customer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesrule_customer_group`
--

DROP TABLE IF EXISTS `salesrule_customer_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `salesrule_customer_group` (
  `rule_id` int unsigned NOT NULL COMMENT 'Rule ID',
  `customer_group_id` int unsigned NOT NULL COMMENT 'Customer Group ID',
  PRIMARY KEY (`rule_id`,`customer_group_id`),
  KEY `SALESRULE_CUSTOMER_GROUP_CUSTOMER_GROUP_ID` (`customer_group_id`),
  CONSTRAINT `SALESRULE_CSTR_GROUP_CSTR_GROUP_ID_CSTR_GROUP_CSTR_GROUP_ID` FOREIGN KEY (`customer_group_id`) REFERENCES `customer_group` (`customer_group_id`) ON DELETE CASCADE,
  CONSTRAINT `SALESRULE_CUSTOMER_GROUP_RULE_ID_SALESRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `salesrule` (`rule_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Rules To Customer Groups Relations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesrule_customer_group`
--

LOCK TABLES `salesrule_customer_group` WRITE;
/*!40000 ALTER TABLE `salesrule_customer_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesrule_customer_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesrule_label`
--

DROP TABLE IF EXISTS `salesrule_label`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `salesrule_label` (
  `label_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Label ID',
  `rule_id` int unsigned NOT NULL COMMENT 'Rule ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `label` varchar(255) DEFAULT NULL COMMENT 'Label',
  PRIMARY KEY (`label_id`),
  UNIQUE KEY `SALESRULE_LABEL_RULE_ID_STORE_ID` (`rule_id`,`store_id`),
  KEY `SALESRULE_LABEL_STORE_ID` (`store_id`),
  CONSTRAINT `SALESRULE_LABEL_RULE_ID_SALESRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `salesrule` (`rule_id`) ON DELETE CASCADE,
  CONSTRAINT `SALESRULE_LABEL_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Salesrule Label';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesrule_label`
--

LOCK TABLES `salesrule_label` WRITE;
/*!40000 ALTER TABLE `salesrule_label` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesrule_label` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesrule_product_attribute`
--

DROP TABLE IF EXISTS `salesrule_product_attribute`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `salesrule_product_attribute` (
  `rule_id` int unsigned NOT NULL COMMENT 'Rule ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  `customer_group_id` int unsigned NOT NULL COMMENT 'Customer Group ID',
  `attribute_id` smallint unsigned NOT NULL COMMENT 'Attribute ID',
  PRIMARY KEY (`rule_id`,`website_id`,`customer_group_id`,`attribute_id`),
  KEY `SALESRULE_PRODUCT_ATTRIBUTE_WEBSITE_ID` (`website_id`),
  KEY `SALESRULE_PRODUCT_ATTRIBUTE_CUSTOMER_GROUP_ID` (`customer_group_id`),
  KEY `SALESRULE_PRODUCT_ATTRIBUTE_ATTRIBUTE_ID` (`attribute_id`),
  CONSTRAINT `SALESRULE_PRD_ATTR_ATTR_ID_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `SALESRULE_PRD_ATTR_CSTR_GROUP_ID_CSTR_GROUP_CSTR_GROUP_ID` FOREIGN KEY (`customer_group_id`) REFERENCES `customer_group` (`customer_group_id`) ON DELETE CASCADE,
  CONSTRAINT `SALESRULE_PRODUCT_ATTRIBUTE_RULE_ID_SALESRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `salesrule` (`rule_id`) ON DELETE CASCADE,
  CONSTRAINT `SALESRULE_PRODUCT_ATTRIBUTE_WEBSITE_ID_STORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Salesrule Product Attribute';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesrule_product_attribute`
--

LOCK TABLES `salesrule_product_attribute` WRITE;
/*!40000 ALTER TABLE `salesrule_product_attribute` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesrule_product_attribute` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesrule_website`
--

DROP TABLE IF EXISTS `salesrule_website`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `salesrule_website` (
  `rule_id` int unsigned NOT NULL COMMENT 'Rule ID',
  `website_id` smallint unsigned NOT NULL COMMENT 'Website ID',
  PRIMARY KEY (`rule_id`,`website_id`),
  KEY `SALESRULE_WEBSITE_WEBSITE_ID` (`website_id`),
  CONSTRAINT `SALESRULE_WEBSITE_RULE_ID_SALESRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `salesrule` (`rule_id`) ON DELETE CASCADE,
  CONSTRAINT `SALESRULE_WEBSITE_WEBSITE_ID_STORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Rules To Websites Relations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesrule_website`
--

LOCK TABLES `salesrule_website` WRITE;
/*!40000 ALTER TABLE `salesrule_website` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesrule_website` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_query`
--

DROP TABLE IF EXISTS `search_query`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `search_query` (
  `query_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Query ID',
  `query_text` varchar(255) DEFAULT NULL COMMENT 'Query text',
  `num_results` int unsigned NOT NULL DEFAULT '0' COMMENT 'Num results',
  `popularity` int unsigned NOT NULL DEFAULT '0' COMMENT 'Popularity',
  `redirect` varchar(255) DEFAULT NULL COMMENT 'Redirect',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `display_in_terms` smallint NOT NULL DEFAULT '1' COMMENT 'Display in terms',
  `is_active` smallint DEFAULT '1' COMMENT 'Active status',
  `is_processed` smallint DEFAULT '0' COMMENT 'Processed status',
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Updated at',
  PRIMARY KEY (`query_id`),
  UNIQUE KEY `SEARCH_QUERY_QUERY_TEXT_STORE_ID` (`query_text`,`store_id`),
  KEY `SEARCH_QUERY_QUERY_TEXT_STORE_ID_POPULARITY` (`query_text`,`store_id`,`popularity`),
  KEY `SEARCH_QUERY_IS_PROCESSED` (`is_processed`),
  KEY `SEARCH_QUERY_STORE_ID_NUM_RESULTS_POPULARITY` (`store_id`,`num_results`,`popularity`),
  CONSTRAINT `SEARCH_QUERY_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=208 DEFAULT CHARSET=utf8mb3 COMMENT='Search query table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_query`
--

LOCK TABLES `search_query` WRITE;
/*!40000 ALTER TABLE `search_query` DISABLE KEYS */;
INSERT INTO `search_query` VALUES (1,'gear',0,2,NULL,1,1,1,0,'2024-08-15 10:04:31'),(5,'24-WG085',0,2,NULL,1,1,1,0,'2024-08-15 11:57:24'),(9,'1080-000',0,1,NULL,1,1,1,0,'2024-08-15 11:57:41'),(11,'sdfasdf',0,1,NULL,1,1,1,0,'2024-08-15 11:57:45'),(13,'zxcxc',0,1,NULL,1,1,1,0,'2024-08-15 12:00:14'),(15,'24-w',0,1,NULL,1,1,1,0,'2024-08-16 10:01:47'),(17,'hello',0,5,NULL,1,1,1,0,'2024-08-27 10:49:58'),(25,'Amur',0,2,NULL,1,1,1,0,'2024-08-22 06:44:07'),(29,'accur',0,2,NULL,1,1,1,0,'2024-08-22 06:44:24'),(31,'allur',0,1,NULL,1,1,1,0,'2024-08-22 06:44:13'),(37,'sink',488,1,NULL,1,1,1,0,'2024-08-29 06:19:47'),(39,'texa configurable',148,1,NULL,1,1,1,0,'2024-08-29 09:52:35'),(41,'test-configurable',224,1,NULL,1,1,1,0,'2024-09-02 11:59:28'),(47,'configurable',144,1,NULL,1,1,1,0,'2024-08-29 09:56:32'),(52,'xdffhh',0,1,NULL,1,1,1,0,'2024-09-04 08:21:13'),(55,'test',81,1,NULL,1,1,1,0,'2024-09-12 05:17:20'),(65,'yoga',6,1,NULL,1,1,1,0,'2024-09-21 05:55:45'),(68,'sprite',6,17,NULL,1,1,1,0,'2024-09-21 07:37:06'),(114,'test-con',81,1,NULL,1,1,1,0,'2024-09-27 11:13:49'),(116,'tey',0,2,NULL,1,1,1,0,'2024-10-09 10:30:28'),(129,'bathroom',863,1,NULL,1,1,1,0,'2024-11-05 10:38:29'),(132,'bett',149,2,NULL,1,1,1,0,'2024-11-05 11:23:17'),(135,'regionx',0,3,NULL,1,1,1,0,'2024-11-12 10:49:42'),(137,'reginox',85,2,NULL,1,1,1,0,'2024-11-06 05:28:01'),(178,'flame',424,1,NULL,1,1,1,0,'2024-12-09 12:06:50'),(181,'dru',126,1,NULL,1,1,1,0,'2025-01-06 08:54:36'),(183,'test-product',0,1,NULL,3,1,1,0,'2025-02-01 05:36:26'),(185,'Franke Mythos MYX 110-34 Undermount Single Bowl Sink -Stainless Steel',212,1,NULL,1,1,1,0,'2025-02-03 08:29:13'),(188,'122.0606.948',1,4,NULL,1,1,1,0,'2025-02-03 08:57:00'),(190,'123',1,1,NULL,1,1,1,0,'2025-02-03 08:37:39'),(196,'122.0606.948',0,1,NULL,3,1,1,0,'2025-02-03 08:41:40'),(199,'122',5,1,NULL,1,1,1,0,'2025-02-03 08:54:28'),(202,'120',5,1,NULL,1,1,1,0,'2025-02-03 08:54:33'),(206,'ZIA XL 6 S Compact',81,1,NULL,1,1,1,0,'2025-02-03 09:08:57');
/*!40000 ALTER TABLE `search_query` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_synonyms`
--

DROP TABLE IF EXISTS `search_synonyms`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `search_synonyms` (
  `group_id` bigint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Synonyms Group ID',
  `synonyms` text NOT NULL COMMENT 'list of synonyms making up this group',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID - identifies the store view these synonyms belong to',
  `website_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID - identifies the website ID these synonyms belong to',
  PRIMARY KEY (`group_id`),
  KEY `SEARCH_SYNONYMS_STORE_ID` (`store_id`),
  KEY `SEARCH_SYNONYMS_WEBSITE_ID` (`website_id`),
  FULLTEXT KEY `SEARCH_SYNONYMS_SYNONYMS` (`synonyms`),
  CONSTRAINT `SEARCH_SYNONYMS_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `SEARCH_SYNONYMS_WEBSITE_ID_STORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='table storing various synonyms groups';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_synonyms`
--

LOCK TABLES `search_synonyms` WRITE;
/*!40000 ALTER TABLE `search_synonyms` DISABLE KEYS */;
/*!40000 ALTER TABLE `search_synonyms` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sendfriend_log`
--

DROP TABLE IF EXISTS `sendfriend_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sendfriend_log` (
  `log_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Log ID',
  `ip` bigint unsigned NOT NULL DEFAULT '0' COMMENT 'Customer IP address',
  `time` int unsigned NOT NULL DEFAULT '0' COMMENT 'Log time',
  `website_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID',
  PRIMARY KEY (`log_id`),
  KEY `SENDFRIEND_LOG_IP` (`ip`),
  KEY `SENDFRIEND_LOG_TIME` (`time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Send to friend function log storage table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sendfriend_log`
--

LOCK TABLES `sendfriend_log` WRITE;
/*!40000 ALTER TABLE `sendfriend_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `sendfriend_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_creditmemo_0`
--

DROP TABLE IF EXISTS `sequence_creditmemo_0`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_creditmemo_0` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_creditmemo_0`
--

LOCK TABLES `sequence_creditmemo_0` WRITE;
/*!40000 ALTER TABLE `sequence_creditmemo_0` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_creditmemo_0` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_creditmemo_1`
--

DROP TABLE IF EXISTS `sequence_creditmemo_1`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_creditmemo_1` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_creditmemo_1`
--

LOCK TABLES `sequence_creditmemo_1` WRITE;
/*!40000 ALTER TABLE `sequence_creditmemo_1` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_creditmemo_1` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_creditmemo_2`
--

DROP TABLE IF EXISTS `sequence_creditmemo_2`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_creditmemo_2` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_creditmemo_2`
--

LOCK TABLES `sequence_creditmemo_2` WRITE;
/*!40000 ALTER TABLE `sequence_creditmemo_2` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_creditmemo_2` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_creditmemo_3`
--

DROP TABLE IF EXISTS `sequence_creditmemo_3`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_creditmemo_3` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_creditmemo_3`
--

LOCK TABLES `sequence_creditmemo_3` WRITE;
/*!40000 ALTER TABLE `sequence_creditmemo_3` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_creditmemo_3` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_creditmemo_4`
--

DROP TABLE IF EXISTS `sequence_creditmemo_4`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_creditmemo_4` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_creditmemo_4`
--

LOCK TABLES `sequence_creditmemo_4` WRITE;
/*!40000 ALTER TABLE `sequence_creditmemo_4` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_creditmemo_4` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_creditmemo_5`
--

DROP TABLE IF EXISTS `sequence_creditmemo_5`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_creditmemo_5` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_creditmemo_5`
--

LOCK TABLES `sequence_creditmemo_5` WRITE;
/*!40000 ALTER TABLE `sequence_creditmemo_5` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_creditmemo_5` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_invoice_0`
--

DROP TABLE IF EXISTS `sequence_invoice_0`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_invoice_0` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_invoice_0`
--

LOCK TABLES `sequence_invoice_0` WRITE;
/*!40000 ALTER TABLE `sequence_invoice_0` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_invoice_0` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_invoice_1`
--

DROP TABLE IF EXISTS `sequence_invoice_1`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_invoice_1` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_invoice_1`
--

LOCK TABLES `sequence_invoice_1` WRITE;
/*!40000 ALTER TABLE `sequence_invoice_1` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_invoice_1` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_invoice_2`
--

DROP TABLE IF EXISTS `sequence_invoice_2`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_invoice_2` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_invoice_2`
--

LOCK TABLES `sequence_invoice_2` WRITE;
/*!40000 ALTER TABLE `sequence_invoice_2` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_invoice_2` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_invoice_3`
--

DROP TABLE IF EXISTS `sequence_invoice_3`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_invoice_3` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_invoice_3`
--

LOCK TABLES `sequence_invoice_3` WRITE;
/*!40000 ALTER TABLE `sequence_invoice_3` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_invoice_3` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_invoice_4`
--

DROP TABLE IF EXISTS `sequence_invoice_4`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_invoice_4` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_invoice_4`
--

LOCK TABLES `sequence_invoice_4` WRITE;
/*!40000 ALTER TABLE `sequence_invoice_4` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_invoice_4` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_invoice_5`
--

DROP TABLE IF EXISTS `sequence_invoice_5`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_invoice_5` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_invoice_5`
--

LOCK TABLES `sequence_invoice_5` WRITE;
/*!40000 ALTER TABLE `sequence_invoice_5` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_invoice_5` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_order_0`
--

DROP TABLE IF EXISTS `sequence_order_0`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_order_0` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_order_0`
--

LOCK TABLES `sequence_order_0` WRITE;
/*!40000 ALTER TABLE `sequence_order_0` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_order_0` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_order_1`
--

DROP TABLE IF EXISTS `sequence_order_1`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_order_1` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_order_1`
--

LOCK TABLES `sequence_order_1` WRITE;
/*!40000 ALTER TABLE `sequence_order_1` DISABLE KEYS */;
INSERT INTO `sequence_order_1` VALUES (1),(2),(3),(4),(5);
/*!40000 ALTER TABLE `sequence_order_1` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_order_2`
--

DROP TABLE IF EXISTS `sequence_order_2`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_order_2` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_order_2`
--

LOCK TABLES `sequence_order_2` WRITE;
/*!40000 ALTER TABLE `sequence_order_2` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_order_2` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_order_3`
--

DROP TABLE IF EXISTS `sequence_order_3`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_order_3` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_order_3`
--

LOCK TABLES `sequence_order_3` WRITE;
/*!40000 ALTER TABLE `sequence_order_3` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_order_3` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_order_4`
--

DROP TABLE IF EXISTS `sequence_order_4`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_order_4` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_order_4`
--

LOCK TABLES `sequence_order_4` WRITE;
/*!40000 ALTER TABLE `sequence_order_4` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_order_4` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_order_5`
--

DROP TABLE IF EXISTS `sequence_order_5`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_order_5` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_order_5`
--

LOCK TABLES `sequence_order_5` WRITE;
/*!40000 ALTER TABLE `sequence_order_5` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_order_5` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_shipment_0`
--

DROP TABLE IF EXISTS `sequence_shipment_0`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_shipment_0` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_shipment_0`
--

LOCK TABLES `sequence_shipment_0` WRITE;
/*!40000 ALTER TABLE `sequence_shipment_0` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_shipment_0` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_shipment_1`
--

DROP TABLE IF EXISTS `sequence_shipment_1`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_shipment_1` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_shipment_1`
--

LOCK TABLES `sequence_shipment_1` WRITE;
/*!40000 ALTER TABLE `sequence_shipment_1` DISABLE KEYS */;
INSERT INTO `sequence_shipment_1` VALUES (1),(2);
/*!40000 ALTER TABLE `sequence_shipment_1` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_shipment_2`
--

DROP TABLE IF EXISTS `sequence_shipment_2`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_shipment_2` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_shipment_2`
--

LOCK TABLES `sequence_shipment_2` WRITE;
/*!40000 ALTER TABLE `sequence_shipment_2` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_shipment_2` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_shipment_3`
--

DROP TABLE IF EXISTS `sequence_shipment_3`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_shipment_3` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_shipment_3`
--

LOCK TABLES `sequence_shipment_3` WRITE;
/*!40000 ALTER TABLE `sequence_shipment_3` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_shipment_3` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_shipment_4`
--

DROP TABLE IF EXISTS `sequence_shipment_4`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_shipment_4` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_shipment_4`
--

LOCK TABLES `sequence_shipment_4` WRITE;
/*!40000 ALTER TABLE `sequence_shipment_4` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_shipment_4` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequence_shipment_5`
--

DROP TABLE IF EXISTS `sequence_shipment_5`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sequence_shipment_5` (
  `sequence_value` int unsigned NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`sequence_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequence_shipment_5`
--

LOCK TABLES `sequence_shipment_5` WRITE;
/*!40000 ALTER TABLE `sequence_shipment_5` DISABLE KEYS */;
/*!40000 ALTER TABLE `sequence_shipment_5` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `session`
--

DROP TABLE IF EXISTS `session`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `session` (
  `session_id` varchar(255) NOT NULL COMMENT 'Session Id',
  `session_expires` int unsigned NOT NULL DEFAULT '0' COMMENT 'Date of Session Expiration',
  `session_data` mediumblob NOT NULL COMMENT 'Session Data',
  PRIMARY KEY (`session_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Database Sessions Storage';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `session`
--

LOCK TABLES `session` WRITE;
/*!40000 ALTER TABLE `session` DISABLE KEYS */;
/*!40000 ALTER TABLE `session` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `setup_module`
--

DROP TABLE IF EXISTS `setup_module`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `setup_module` (
  `module` varchar(50) NOT NULL COMMENT 'Module',
  `schema_version` varchar(50) DEFAULT NULL COMMENT 'Schema Version',
  `data_version` varchar(50) DEFAULT NULL COMMENT 'Data Version',
  PRIMARY KEY (`module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Module versions registry';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `setup_module`
--

LOCK TABLES `setup_module` WRITE;
/*!40000 ALTER TABLE `setup_module` DISABLE KEYS */;
INSERT INTO `setup_module` VALUES ('Amasty_CustomTabs','1.2.0','1.2.0'),('Anees_Work','1.0.3','1.0.3'),('Apptrian_Minify','2.0.4','2.0.4'),('Bss_AdminPaymentMethod','1.0.1','1.0.1'),('Bss_AjaxCart','1.3.1','1.3.1'),('Bss_FBT','1.0.9','1.0.9'),('Bss_HyvaCompatBase','1.0.2','1.0.2'),('Bss_InfiniteScroll','1.1.7','1.1.7'),('Bss_ProductAttachment','1.1.3','1.1.3'),('Bss_ProductLabel','1.1.9','1.1.9'),('Bss_ProductLabelGraphQl','1.0.0','1.0.0'),('Cardstream_PaymentGateway','2.0.1','2.0.1'),('Cisin_Clickforprice','1.0.0','1.0.0'),('Cisin_Salesordergrid','0.0.1','0.0.1'),('Emizentech_Priceslider','0.0.2','0.0.2'),('HTCMage_FixAdminEmailTemplate','1.0.0','1.0.0'),('Hyva_BssAjaxCart','1.0.2','1.0.2'),('Hyva_BssFBT','1.0.0','1.0.0'),('Hyva_BssInfiniteScroll','1.0.1','1.0.1'),('Hyva_BssProductAttachment','1.0.0','1.0.0'),('Hyva_MirasvitAllProducts','0.0.1','0.0.1'),('Hyva_MirasvitBrand','0.0.1','0.0.1'),('Hyva_MirasvitLayeredNavigation','0.0.1','0.0.1'),('Hyva_MirasvitQuickNavigation','0.0.1','0.0.1'),('Hyva_MirasvitScroll','0.0.1','0.0.1'),('Imega_FinanceGateway','1.0.0','1.0.0'),('Imega_FinanceModule','1.0.0','1.0.0'),('Magecomp_Customshipping','1.0.1','1.0.1'),('Magecomp_Deleteorder','1.0.2','1.0.2'),('Magecomp_Matrixrate','1.0.5','1.0.5'),('Magefan_AdminUserGuide','2.0.1','2.0.1'),('Magefan_Blog','2.9.1','2.9.1'),('Magefan_Cli','2.0.1','2.0.1'),('Magefan_Community','2.1.10','2.1.10'),('Magefan_GuestToCustomer','2.0.18','2.0.18'),('Magefan_WysiwygAdvanced','2.0.12','2.0.12'),('Magento_DataExporter','42.0.1','42.0.1'),('Magento_QueryXml','42.0.0','42.0.0'),('Magento_Securitytxt','1.0.0','1.0.0'),('Magento_ServicesConnector','1.1.0','1.1.0'),('Magento_ServicesId','1.1.0','1.1.0'),('Magento_ServicesIdLayout','1.0.0','1.0.0'),('MagePal_Reindex','1.0.0','1.0.0'),('Mageplaza_Core','1.0.0','1.0.0'),('Mageplaza_CronSchedule','1.0.0','1.0.0'),('Mageplaza_FrequentlyBought','1.0.0','1.0.0'),('Mageplaza_LayeredNavigation','2.0.0','2.0.0'),('Mageplaza_Smtp','1.2.5','1.2.5'),('MageWorx_GeoIP','2.0.0','2.0.0'),('MageWorx_Info','1.0.0','1.0.0'),('MageWorx_OptionHealthChecker','1.0.0','1.0.0'),('MageWorx_ShippingCalculatorBase','1.0.0','1.0.0'),('Magiccart_Alothemes','2.0','2.0'),('Magiccart_Lookbook','2.0','2.0'),('Magiccart_Magicmenu','2.0','2.0'),('Magiccart_Magicproduct','2.0','2.0'),('Magiccart_Magicslider','2.0','2.0'),('Magiccart_Shopbrand','2.0','2.0'),('Magiccart_Testimonial','2.0','2.0'),('Mollie_Payment','1.19.0','1.19.0'),('MSP_CmsImportExport','1.1.1','1.1.1'),('Nexus_AdminPaypalMethod','1.0.1','1.0.1'),('Nexus_BookAppointment','1.0.0','1.0.0'),('Nexus_Catalog','1.0.0','1.0.0'),('Nexus_Review','1.0.0','1.0.0'),('Nexus_Sales','1.0.0','1.0.0'),('Nexus_Swiper','1.0.0','1.0.0'),('Nexus_Theme','1.0.0','1.0.0'),('OlegKoval_RegenerateUrlRewrites','1.4.3','1.4.3'),('OuterEdge_BulkActions','1.0.0','1.0.0'),('PayPal_Braintree','4.6.1','4.6.1'),('Ridha_Category','1.0.0','1.0.0'),('UdeyTech_CategoryHelper','1.0.0','1.0.0'),('Ves_All','1.0.3','1.0.3'),('Ves_Brand','1.0.4','1.0.4'),('Ves_Setup','1.0.0','1.0.0'),('Yireo_Webp2','0.4.0','0.4.0');
/*!40000 ALTER TABLE `setup_module` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shipping_matrixrate`
--

DROP TABLE IF EXISTS `shipping_matrixrate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `shipping_matrixrate` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `website_id` int NOT NULL DEFAULT '0',
  `dest_country_id` varchar(4) NOT NULL DEFAULT '' COMMENT 'Destination Post Code (Zip)',
  `dest_region_id` int NOT NULL DEFAULT '0',
  `dest_city` varchar(30) NOT NULL DEFAULT '' COMMENT 'Destination City',
  `dest_zip_to` varchar(20) NOT NULL DEFAULT '0.0000' COMMENT 'Destination Post Code To (Zip)',
  `dest_zip` varchar(20) NOT NULL DEFAULT '0.0000' COMMENT 'Destination Post Code (Zip)',
  `condition_name` varchar(20) NOT NULL DEFAULT '' COMMENT 'Destination Post Code To (Zip)',
  `condition_from_value` decimal(10,0) NOT NULL DEFAULT '0' COMMENT 'Condition From',
  `condition_to_value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Condition To',
  `delivery_type` varchar(255) NOT NULL DEFAULT '' COMMENT 'Delivery Type',
  `price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Price',
  `cost` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'cost',
  PRIMARY KEY (`id`),
  KEY `IDX_17AB318C239E4ABC4FE1275BF071CE70` (`website_id`,`dest_country_id`,`dest_region_id`,`dest_city`,`dest_zip_to`,`dest_zip`,`condition_name`,`condition_from_value`,`condition_to_value`,`delivery_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Sales Flat Quote Address';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shipping_matrixrate`
--

LOCK TABLES `shipping_matrixrate` WRITE;
/*!40000 ALTER TABLE `shipping_matrixrate` DISABLE KEYS */;
/*!40000 ALTER TABLE `shipping_matrixrate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shipping_tablerate`
--

DROP TABLE IF EXISTS `shipping_tablerate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `shipping_tablerate` (
  `pk` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary key',
  `website_id` int NOT NULL DEFAULT '0' COMMENT 'Website ID',
  `dest_country_id` varchar(4) NOT NULL DEFAULT '0' COMMENT 'Destination coutry ISO/2 or ISO/3 code',
  `dest_region_id` int NOT NULL DEFAULT '0' COMMENT 'Destination Region ID',
  `dest_zip` varchar(10) NOT NULL DEFAULT '*' COMMENT 'Destination Post Code (Zip)',
  `condition_name` varchar(30) NOT NULL COMMENT 'Rate Condition name',
  `condition_value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Rate condition value',
  `price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Price',
  `cost` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Cost',
  PRIMARY KEY (`pk`),
  UNIQUE KEY `UNQ_D60821CDB2AFACEE1566CFC02D0D4CAA` (`website_id`,`dest_country_id`,`dest_region_id`,`dest_zip`,`condition_name`,`condition_value`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Shipping Tablerate';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shipping_tablerate`
--

LOCK TABLES `shipping_tablerate` WRITE;
/*!40000 ALTER TABLE `shipping_tablerate` DISABLE KEYS */;
/*!40000 ALTER TABLE `shipping_tablerate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sitemap`
--

DROP TABLE IF EXISTS `sitemap`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sitemap` (
  `sitemap_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Sitemap ID',
  `sitemap_type` varchar(32) DEFAULT NULL COMMENT 'Sitemap Type',
  `sitemap_filename` varchar(32) DEFAULT NULL COMMENT 'Sitemap Filename',
  `sitemap_path` varchar(255) DEFAULT NULL COMMENT 'Sitemap Path',
  `sitemap_time` timestamp NULL DEFAULT NULL COMMENT 'Sitemap Time',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  PRIMARY KEY (`sitemap_id`),
  KEY `SITEMAP_STORE_ID` (`store_id`),
  CONSTRAINT `SITEMAP_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='XML Sitemap';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sitemap`
--

LOCK TABLES `sitemap` WRITE;
/*!40000 ALTER TABLE `sitemap` DISABLE KEYS */;
/*!40000 ALTER TABLE `sitemap` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `store`
--

DROP TABLE IF EXISTS `store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `store` (
  `store_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Store ID',
  `code` varchar(32) DEFAULT NULL COMMENT 'Code',
  `website_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID',
  `group_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Group ID',
  `name` varchar(255) NOT NULL COMMENT 'Store Name',
  `sort_order` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store Sort Order',
  `is_active` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store Activity',
  PRIMARY KEY (`store_id`),
  UNIQUE KEY `STORE_CODE` (`code`),
  KEY `STORE_WEBSITE_ID` (`website_id`),
  KEY `STORE_IS_ACTIVE_SORT_ORDER` (`is_active`,`sort_order`),
  KEY `STORE_GROUP_ID` (`group_id`),
  CONSTRAINT `STORE_GROUP_ID_STORE_GROUP_GROUP_ID` FOREIGN KEY (`group_id`) REFERENCES `store_group` (`group_id`) ON DELETE CASCADE,
  CONSTRAINT `STORE_WEBSITE_ID_STORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb3 COMMENT='Stores';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `store`
--

LOCK TABLES `store` WRITE;
/*!40000 ALTER TABLE `store` DISABLE KEYS */;
INSERT INTO `store` VALUES (0,'admin',0,0,'Admin',0,1),(1,'default',1,1,'Default Store View',0,1),(2,'premier',2,2,'Premier DIY',0,1),(3,'nexus_home',3,5,'nexus-home-view',0,1),(4,'premierdiy_home',4,6,'premierdiy-home',0,1),(5,'banyostore',1,4,'banyostore',0,1);
/*!40000 ALTER TABLE `store` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_store_after_insert` AFTER INSERT ON `store` FOR EACH ROW BEGIN
INSERT IGNORE INTO `store_data_exporter_cl` (`entity_id`) VALUES (NEW.`website_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_store_after_update` AFTER UPDATE ON `store` FOR EACH ROW BEGIN
IF (NOT(NEW.`store_id` <=> OLD.`store_id`) OR NOT(NEW.`code` <=> OLD.`code`) OR NOT(NEW.`website_id` <=> OLD.`website_id`) OR NOT(NEW.`group_id` <=> OLD.`group_id`) OR NOT(NEW.`name` <=> OLD.`name`) OR NOT(NEW.`sort_order` <=> OLD.`sort_order`) OR NOT(NEW.`is_active` <=> OLD.`is_active`)) THEN INSERT IGNORE INTO `store_data_exporter_cl` (`entity_id`) VALUES (NEW.`website_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_store_after_delete` AFTER DELETE ON `store` FOR EACH ROW BEGIN
INSERT IGNORE INTO `store_data_exporter_cl` (`entity_id`) VALUES (OLD.`website_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `store_data_exporter_cl`
--

DROP TABLE IF EXISTS `store_data_exporter_cl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `store_data_exporter_cl` (
  `version_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Version ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  PRIMARY KEY (`version_id`)
) ENGINE=InnoDB AUTO_INCREMENT=25 DEFAULT CHARSET=utf8mb3 COMMENT='store_data_exporter_cl';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `store_data_exporter_cl`
--

LOCK TABLES `store_data_exporter_cl` WRITE;
/*!40000 ALTER TABLE `store_data_exporter_cl` DISABLE KEYS */;
INSERT INTO `store_data_exporter_cl` VALUES (1,0),(2,1),(3,2),(4,2),(5,2),(6,2),(7,2),(8,1),(9,1),(10,3),(11,3),(12,3),(13,3),(14,3),(15,3),(16,4),(17,4),(18,4),(19,4),(20,4),(21,1),(22,1),(23,3),(24,3);
/*!40000 ALTER TABLE `store_data_exporter_cl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `store_group`
--

DROP TABLE IF EXISTS `store_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `store_group` (
  `group_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Group ID',
  `website_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID',
  `name` varchar(255) NOT NULL COMMENT 'Store Group Name',
  `root_category_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Root Category ID',
  `default_store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Default Store ID',
  `code` varchar(32) DEFAULT NULL COMMENT 'Store group unique code',
  PRIMARY KEY (`group_id`),
  UNIQUE KEY `STORE_GROUP_CODE` (`code`),
  KEY `STORE_GROUP_WEBSITE_ID` (`website_id`),
  KEY `STORE_GROUP_DEFAULT_STORE_ID` (`default_store_id`),
  CONSTRAINT `STORE_GROUP_WEBSITE_ID_STORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COMMENT='Store Groups';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `store_group`
--

LOCK TABLES `store_group` WRITE;
/*!40000 ALTER TABLE `store_group` DISABLE KEYS */;
INSERT INTO `store_group` VALUES (0,0,'Default',0,0,'default'),(1,1,'Main Website Store',2,1,'main_website_store'),(2,2,'Premier DIY',2,2,'premierdiystore'),(3,1,'Nexus',2,0,'Nexusstore'),(4,1,'Banyo',2,5,'Banyostore'),(5,3,'nexus-home',2,3,'nexus_home'),(6,4,'premierdiy-home',2,4,'premierdiy_home');
/*!40000 ALTER TABLE `store_group` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_store_group_after_insert` AFTER INSERT ON `store_group` FOR EACH ROW BEGIN
INSERT IGNORE INTO `store_data_exporter_cl` (`entity_id`) VALUES (NEW.`website_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_store_group_after_update` AFTER UPDATE ON `store_group` FOR EACH ROW BEGIN
IF (NOT(NEW.`group_id` <=> OLD.`group_id`) OR NOT(NEW.`website_id` <=> OLD.`website_id`) OR NOT(NEW.`name` <=> OLD.`name`) OR NOT(NEW.`root_category_id` <=> OLD.`root_category_id`) OR NOT(NEW.`default_store_id` <=> OLD.`default_store_id`) OR NOT(NEW.`code` <=> OLD.`code`)) THEN INSERT IGNORE INTO `store_data_exporter_cl` (`entity_id`) VALUES (NEW.`website_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_store_group_after_delete` AFTER DELETE ON `store_group` FOR EACH ROW BEGIN
INSERT IGNORE INTO `store_data_exporter_cl` (`entity_id`) VALUES (OLD.`website_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `store_website`
--

DROP TABLE IF EXISTS `store_website`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `store_website` (
  `website_id` smallint unsigned NOT NULL AUTO_INCREMENT COMMENT 'Website ID',
  `code` varchar(32) DEFAULT NULL COMMENT 'Code',
  `name` varchar(64) DEFAULT NULL COMMENT 'Website Name',
  `sort_order` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `default_group_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Default Group ID',
  `is_default` smallint unsigned DEFAULT '0' COMMENT 'Defines Is Website Default',
  PRIMARY KEY (`website_id`),
  UNIQUE KEY `STORE_WEBSITE_CODE` (`code`),
  KEY `STORE_WEBSITE_SORT_ORDER` (`sort_order`),
  KEY `STORE_WEBSITE_DEFAULT_GROUP_ID` (`default_group_id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb3 COMMENT='Websites';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `store_website`
--

LOCK TABLES `store_website` WRITE;
/*!40000 ALTER TABLE `store_website` DISABLE KEYS */;
INSERT INTO `store_website` VALUES (0,'admin','Admin',0,0,0),(1,'base','Main Website',0,1,1),(2,'premierdiy','Premier DIY',0,2,0),(3,'nexus_home','nexus-home',0,5,0),(4,'premierdiy_home','premierdiy-home',0,6,0);
/*!40000 ALTER TABLE `store_website` ENABLE KEYS */;
UNLOCK TABLES;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_store_website_after_insert` AFTER INSERT ON `store_website` FOR EACH ROW BEGIN
INSERT IGNORE INTO `store_data_exporter_cl` (`entity_id`) VALUES (NEW.`website_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_store_website_after_update` AFTER UPDATE ON `store_website` FOR EACH ROW BEGIN
IF (NOT(NEW.`website_id` <=> OLD.`website_id`) OR NOT(NEW.`code` <=> OLD.`code`) OR NOT(NEW.`name` <=> OLD.`name`) OR NOT(NEW.`sort_order` <=> OLD.`sort_order`) OR NOT(NEW.`default_group_id` <=> OLD.`default_group_id`) OR NOT(NEW.`is_default` <=> OLD.`is_default`)) THEN INSERT IGNORE INTO `store_data_exporter_cl` (`entity_id`) VALUES (NEW.`website_id`); END IF;
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb3 */ ;
/*!50003 SET character_set_results = utf8mb3 */ ;
/*!50003 SET collation_connection  = utf8mb3_general_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = '' */ ;
DELIMITER ;;
/*!50003 CREATE*/ /*!50017 DEFINER=`root`@`localhost`*/ /*!50003 TRIGGER `trg_store_website_after_delete` AFTER DELETE ON `store_website` FOR EACH ROW BEGIN
INSERT IGNORE INTO `store_data_exporter_cl` (`entity_id`) VALUES (OLD.`website_id`);
END */;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;

--
-- Table structure for table `stores_data_exporter`
--

DROP TABLE IF EXISTS `stores_data_exporter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `stores_data_exporter` (
  `id` int unsigned NOT NULL COMMENT 'ID',
  `feed_data` mediumtext NOT NULL COMMENT 'Feed Data',
  `modified_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Modified At',
  PRIMARY KEY (`id`),
  KEY `STORES_DATA_EXPORTER_MODIFIED_AT` (`modified_at`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Stores Feed Storage';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stores_data_exporter`
--

LOCK TABLES `stores_data_exporter` WRITE;
/*!40000 ALTER TABLE `stores_data_exporter` DISABLE KEYS */;
INSERT INTO `stores_data_exporter` VALUES (1,'{\"store_view_id\":\"1\",\"store_id\":1,\"website_id\":1,\"store_view_name\":\"Default Store View\",\"store_name\":\"Main Website Store\",\"website_name\":\"Main Website\"}','2025-02-05 07:30:49'),(2,'{\"store_view_id\":\"2\",\"store_id\":2,\"website_id\":2,\"store_view_name\":\"Premier DIY\",\"store_name\":\"Premier DIY\",\"website_name\":\"Premier DIY\"}','2025-02-05 07:30:49'),(3,'{\"store_view_id\":\"3\",\"store_id\":5,\"website_id\":3,\"store_view_name\":\"nexus-home-view\",\"store_name\":\"nexus-home\",\"website_name\":\"nexus-home\"}','2025-02-05 07:30:49'),(4,'{\"store_view_id\":\"4\",\"store_id\":6,\"website_id\":4,\"store_view_name\":\"premierdiy-home\",\"store_name\":\"premierdiy-home\",\"website_name\":\"premierdiy-home\"}','2025-02-05 07:30:49'),(5,'{\"store_view_id\":\"5\",\"store_id\":4,\"website_id\":1,\"store_view_name\":\"banyostore\",\"store_name\":\"Banyo\",\"website_name\":\"Main Website\"}','2025-02-05 07:30:49');
/*!40000 ALTER TABLE `stores_data_exporter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stores_data_exporter_index_batches`
--

DROP TABLE IF EXISTS `stores_data_exporter_index_batches`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `stores_data_exporter_index_batches` (
  `batch_number` int NOT NULL COMMENT 'Batch Number',
  `website_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Website Id',
  PRIMARY KEY (`batch_number`,`website_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='stores_data_exporter_index_batches';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stores_data_exporter_index_batches`
--

LOCK TABLES `stores_data_exporter_index_batches` WRITE;
/*!40000 ALTER TABLE `stores_data_exporter_index_batches` DISABLE KEYS */;
INSERT INTO `stores_data_exporter_index_batches` VALUES (1,1),(1,2),(1,3),(1,4);
/*!40000 ALTER TABLE `stores_data_exporter_index_batches` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stores_data_exporter_index_sequence`
--

DROP TABLE IF EXISTS `stores_data_exporter_index_sequence`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `stores_data_exporter_index_sequence` (
  `i` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Auto Increment ID',
  PRIMARY KEY (`i`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COMMENT='stores_data_exporter_index_sequence';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stores_data_exporter_index_sequence`
--

LOCK TABLES `stores_data_exporter_index_sequence` WRITE;
/*!40000 ALTER TABLE `stores_data_exporter_index_sequence` DISABLE KEYS */;
INSERT INTO `stores_data_exporter_index_sequence` VALUES (1),(2);
/*!40000 ALTER TABLE `stores_data_exporter_index_sequence` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax_calculation`
--

DROP TABLE IF EXISTS `tax_calculation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `tax_calculation` (
  `tax_calculation_id` int NOT NULL AUTO_INCREMENT COMMENT 'Tax Calculation ID',
  `tax_calculation_rate_id` int NOT NULL COMMENT 'Tax Calculation Rate ID',
  `tax_calculation_rule_id` int NOT NULL COMMENT 'Tax Calculation Rule ID',
  `customer_tax_class_id` smallint NOT NULL COMMENT 'Customer Tax Class ID',
  `product_tax_class_id` smallint NOT NULL COMMENT 'Product Tax Class ID',
  PRIMARY KEY (`tax_calculation_id`),
  KEY `TAX_CALCULATION_TAX_CALCULATION_RULE_ID` (`tax_calculation_rule_id`),
  KEY `TAX_CALCULATION_CUSTOMER_TAX_CLASS_ID` (`customer_tax_class_id`),
  KEY `TAX_CALCULATION_PRODUCT_TAX_CLASS_ID` (`product_tax_class_id`),
  KEY `TAX_CALC_TAX_CALC_RATE_ID_CSTR_TAX_CLASS_ID_PRD_TAX_CLASS_ID` (`tax_calculation_rate_id`,`customer_tax_class_id`,`product_tax_class_id`),
  CONSTRAINT `TAX_CALC_TAX_CALC_RATE_ID_TAX_CALC_RATE_TAX_CALC_RATE_ID` FOREIGN KEY (`tax_calculation_rate_id`) REFERENCES `tax_calculation_rate` (`tax_calculation_rate_id`) ON DELETE CASCADE,
  CONSTRAINT `TAX_CALC_TAX_CALC_RULE_ID_TAX_CALC_RULE_TAX_CALC_RULE_ID` FOREIGN KEY (`tax_calculation_rule_id`) REFERENCES `tax_calculation_rule` (`tax_calculation_rule_id`) ON DELETE CASCADE,
  CONSTRAINT `TAX_CALCULATION_CUSTOMER_TAX_CLASS_ID_TAX_CLASS_CLASS_ID` FOREIGN KEY (`customer_tax_class_id`) REFERENCES `tax_class` (`class_id`) ON DELETE CASCADE,
  CONSTRAINT `TAX_CALCULATION_PRODUCT_TAX_CLASS_ID_TAX_CLASS_CLASS_ID` FOREIGN KEY (`product_tax_class_id`) REFERENCES `tax_class` (`class_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Tax Calculation';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tax_calculation`
--

LOCK TABLES `tax_calculation` WRITE;
/*!40000 ALTER TABLE `tax_calculation` DISABLE KEYS */;
/*!40000 ALTER TABLE `tax_calculation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax_calculation_rate`
--

DROP TABLE IF EXISTS `tax_calculation_rate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `tax_calculation_rate` (
  `tax_calculation_rate_id` int NOT NULL AUTO_INCREMENT COMMENT 'Tax Calculation Rate ID',
  `tax_country_id` varchar(2) NOT NULL COMMENT 'Tax Country ID',
  `tax_region_id` int NOT NULL COMMENT 'Tax Region ID',
  `tax_postcode` varchar(21) DEFAULT NULL COMMENT 'Tax Postcode',
  `code` varchar(255) NOT NULL COMMENT 'Code',
  `rate` decimal(12,4) NOT NULL COMMENT 'Rate',
  `zip_is_range` smallint DEFAULT NULL COMMENT 'Zip Is Range',
  `zip_from` int unsigned DEFAULT NULL COMMENT 'Zip From',
  `zip_to` int unsigned DEFAULT NULL COMMENT 'Zip To',
  PRIMARY KEY (`tax_calculation_rate_id`),
  KEY `TAX_CALCULATION_RATE_TAX_COUNTRY_ID_TAX_REGION_ID_TAX_POSTCODE` (`tax_country_id`,`tax_region_id`,`tax_postcode`),
  KEY `TAX_CALCULATION_RATE_CODE` (`code`),
  KEY `IDX_CA799F1E2CB843495F601E56C84A626D` (`tax_calculation_rate_id`,`tax_country_id`,`tax_region_id`,`zip_is_range`,`tax_postcode`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8mb3 COMMENT='Tax Calculation Rate';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tax_calculation_rate`
--

LOCK TABLES `tax_calculation_rate` WRITE;
/*!40000 ALTER TABLE `tax_calculation_rate` DISABLE KEYS */;
INSERT INTO `tax_calculation_rate` VALUES (1,'US',12,'*','US-CA-*-Rate 1',8.2500,NULL,NULL,NULL),(2,'US',43,'*','US-NY-*-Rate 1',8.3750,NULL,NULL,NULL);
/*!40000 ALTER TABLE `tax_calculation_rate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax_calculation_rate_title`
--

DROP TABLE IF EXISTS `tax_calculation_rate_title`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `tax_calculation_rate_title` (
  `tax_calculation_rate_title_id` int NOT NULL AUTO_INCREMENT COMMENT 'Tax Calculation Rate Title ID',
  `tax_calculation_rate_id` int NOT NULL COMMENT 'Tax Calculation Rate ID',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `value` varchar(255) NOT NULL COMMENT 'Value',
  PRIMARY KEY (`tax_calculation_rate_title_id`),
  KEY `TAX_CALCULATION_RATE_TITLE_TAX_CALCULATION_RATE_ID_STORE_ID` (`tax_calculation_rate_id`,`store_id`),
  KEY `TAX_CALCULATION_RATE_TITLE_STORE_ID` (`store_id`),
  CONSTRAINT `FK_37FB965F786AD5897BB3AE90470C42AB` FOREIGN KEY (`tax_calculation_rate_id`) REFERENCES `tax_calculation_rate` (`tax_calculation_rate_id`) ON DELETE CASCADE,
  CONSTRAINT `TAX_CALCULATION_RATE_TITLE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Tax Calculation Rate Title';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tax_calculation_rate_title`
--

LOCK TABLES `tax_calculation_rate_title` WRITE;
/*!40000 ALTER TABLE `tax_calculation_rate_title` DISABLE KEYS */;
/*!40000 ALTER TABLE `tax_calculation_rate_title` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax_calculation_rule`
--

DROP TABLE IF EXISTS `tax_calculation_rule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `tax_calculation_rule` (
  `tax_calculation_rule_id` int NOT NULL AUTO_INCREMENT COMMENT 'Tax Calculation Rule ID',
  `code` varchar(255) NOT NULL COMMENT 'Code',
  `priority` int NOT NULL COMMENT 'Priority',
  `position` int NOT NULL COMMENT 'Position',
  `calculate_subtotal` int NOT NULL COMMENT 'Calculate off subtotal option',
  PRIMARY KEY (`tax_calculation_rule_id`),
  KEY `TAX_CALCULATION_RULE_PRIORITY_POSITION` (`priority`,`position`),
  KEY `TAX_CALCULATION_RULE_CODE` (`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Tax Calculation Rule';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tax_calculation_rule`
--

LOCK TABLES `tax_calculation_rule` WRITE;
/*!40000 ALTER TABLE `tax_calculation_rule` DISABLE KEYS */;
/*!40000 ALTER TABLE `tax_calculation_rule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax_class`
--

DROP TABLE IF EXISTS `tax_class`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `tax_class` (
  `class_id` smallint NOT NULL AUTO_INCREMENT COMMENT 'Class ID',
  `class_name` varchar(255) NOT NULL COMMENT 'Class Name',
  `class_type` varchar(8) NOT NULL DEFAULT 'CUSTOMER' COMMENT 'Class Type',
  PRIMARY KEY (`class_id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb3 COMMENT='Tax Class';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tax_class`
--

LOCK TABLES `tax_class` WRITE;
/*!40000 ALTER TABLE `tax_class` DISABLE KEYS */;
INSERT INTO `tax_class` VALUES (2,'Taxable Goods','PRODUCT'),(3,'Retail Customer','CUSTOMER');
/*!40000 ALTER TABLE `tax_class` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax_order_aggregated_created`
--

DROP TABLE IF EXISTS `tax_order_aggregated_created`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `tax_order_aggregated_created` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `code` varchar(255) NOT NULL COMMENT 'Code',
  `order_status` varchar(50) NOT NULL COMMENT 'Order Status',
  `percent` float DEFAULT NULL COMMENT 'Percent',
  `orders_count` int unsigned NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `tax_base_amount_sum` float DEFAULT NULL COMMENT 'Tax Base Amount Sum',
  PRIMARY KEY (`id`),
  UNIQUE KEY `TAX_ORDER_AGGRED_CREATED_PERIOD_STORE_ID_CODE_PERCENT_ORDER_STS` (`period`,`store_id`,`code`,`percent`,`order_status`),
  KEY `TAX_ORDER_AGGREGATED_CREATED_STORE_ID` (`store_id`),
  CONSTRAINT `TAX_ORDER_AGGREGATED_CREATED_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Tax Order Aggregation';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tax_order_aggregated_created`
--

LOCK TABLES `tax_order_aggregated_created` WRITE;
/*!40000 ALTER TABLE `tax_order_aggregated_created` DISABLE KEYS */;
/*!40000 ALTER TABLE `tax_order_aggregated_created` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax_order_aggregated_updated`
--

DROP TABLE IF EXISTS `tax_order_aggregated_updated`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `tax_order_aggregated_updated` (
  `id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `code` varchar(255) NOT NULL COMMENT 'Code',
  `order_status` varchar(50) NOT NULL COMMENT 'Order Status',
  `percent` float DEFAULT NULL COMMENT 'Percent',
  `orders_count` int unsigned NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `tax_base_amount_sum` float DEFAULT NULL COMMENT 'Tax Base Amount Sum',
  PRIMARY KEY (`id`),
  UNIQUE KEY `TAX_ORDER_AGGRED_UPDATED_PERIOD_STORE_ID_CODE_PERCENT_ORDER_STS` (`period`,`store_id`,`code`,`percent`,`order_status`),
  KEY `TAX_ORDER_AGGREGATED_UPDATED_STORE_ID` (`store_id`),
  CONSTRAINT `TAX_ORDER_AGGREGATED_UPDATED_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Tax Order Aggregated Updated';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tax_order_aggregated_updated`
--

LOCK TABLES `tax_order_aggregated_updated` WRITE;
/*!40000 ALTER TABLE `tax_order_aggregated_updated` DISABLE KEYS */;
/*!40000 ALTER TABLE `tax_order_aggregated_updated` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `theme`
--

DROP TABLE IF EXISTS `theme`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `theme` (
  `theme_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Theme identifier',
  `parent_id` int DEFAULT NULL COMMENT 'Parent ID',
  `theme_path` varchar(255) DEFAULT NULL COMMENT 'Theme Path',
  `theme_title` varchar(255) NOT NULL COMMENT 'Theme Title',
  `preview_image` varchar(255) DEFAULT NULL COMMENT 'Preview Image',
  `is_featured` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Is Theme Featured',
  `area` varchar(255) NOT NULL COMMENT 'Theme Area',
  `type` smallint NOT NULL COMMENT 'Theme type: 0:physical, 1:virtual, 2:staging',
  `code` text COMMENT 'Full theme code, including package',
  PRIMARY KEY (`theme_id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb3 COMMENT='Core theme';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `theme`
--

LOCK TABLES `theme` WRITE;
/*!40000 ALTER TABLE `theme` DISABLE KEYS */;
INSERT INTO `theme` VALUES (1,NULL,'Magento/blank','Magento Blank','preview_image_66b09988e0820.jpeg',0,'frontend',0,'Magento/blank'),(2,NULL,'Magento/backend','Magento 2 backend',NULL,0,'adminhtml',0,'Magento/backend'),(3,1,'Magento/luma','Magento Luma','preview_image_66b0998903ef4.jpeg',0,'frontend',0,'Magento/luma'),(4,NULL,'Hyva/reset','Hyvä Reset',NULL,0,'frontend',0,'Hyva/reset'),(5,4,'Hyva/default','Hyvä Default','preview_image_66b37275e1004.png',0,'frontend',0,'Hyva/default'),(6,5,'Banyo/HyvaChild','Hyva Child Theme','preview_image_66b4940036e68.png',0,'frontend',0,'Banyo/HyvaChild');
/*!40000 ALTER TABLE `theme` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `theme_file`
--

DROP TABLE IF EXISTS `theme_file`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `theme_file` (
  `theme_files_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Theme files identifier',
  `theme_id` int unsigned NOT NULL COMMENT 'Theme ID',
  `file_path` varchar(255) DEFAULT NULL COMMENT 'Relative path to file',
  `file_type` varchar(32) NOT NULL COMMENT 'File Type',
  `content` longtext NOT NULL COMMENT 'File Content',
  `sort_order` smallint NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `is_temporary` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Is Temporary File',
  PRIMARY KEY (`theme_files_id`),
  KEY `THEME_FILE_THEME_ID_THEME_THEME_ID` (`theme_id`),
  CONSTRAINT `THEME_FILE_THEME_ID_THEME_THEME_ID` FOREIGN KEY (`theme_id`) REFERENCES `theme` (`theme_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Core theme files';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `theme_file`
--

LOCK TABLES `theme_file` WRITE;
/*!40000 ALTER TABLE `theme_file` DISABLE KEYS */;
/*!40000 ALTER TABLE `theme_file` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `translation`
--

DROP TABLE IF EXISTS `translation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `translation` (
  `key_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Key ID of Translation',
  `string` varchar(255) NOT NULL DEFAULT 'Translate String' COMMENT 'Translation String',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `translate` varchar(255) DEFAULT NULL COMMENT 'Translate',
  `locale` varchar(20) NOT NULL DEFAULT 'en_US' COMMENT 'Locale',
  `crc_string` bigint NOT NULL DEFAULT '1591228201' COMMENT 'Translation String CRC32 Hash',
  PRIMARY KEY (`key_id`),
  UNIQUE KEY `TRANSLATION_STORE_ID_LOCALE_CRC_STRING_STRING` (`store_id`,`locale`,`crc_string`,`string`),
  CONSTRAINT `TRANSLATION_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Translations';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `translation`
--

LOCK TABLES `translation` WRITE;
/*!40000 ALTER TABLE `translation` DISABLE KEYS */;
/*!40000 ALTER TABLE `translation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ui_bookmark`
--

DROP TABLE IF EXISTS `ui_bookmark`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `ui_bookmark` (
  `bookmark_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Bookmark identifier',
  `user_id` int unsigned NOT NULL COMMENT 'User ID',
  `namespace` varchar(255) NOT NULL COMMENT 'Bookmark namespace',
  `identifier` varchar(255) NOT NULL COMMENT 'Bookmark Identifier',
  `current` smallint NOT NULL COMMENT 'Mark current bookmark per user and identifier',
  `title` varchar(255) DEFAULT NULL COMMENT 'Bookmark title',
  `config` longtext COMMENT 'Bookmark config',
  `created_at` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Bookmark created at',
  `updated_at` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Bookmark updated at',
  PRIMARY KEY (`bookmark_id`),
  KEY `UI_BOOKMARK_USER_ID_NAMESPACE_IDENTIFIER` (`user_id`,`namespace`,`identifier`),
  CONSTRAINT `UI_BOOKMARK_USER_ID_ADMIN_USER_USER_ID` FOREIGN KEY (`user_id`) REFERENCES `admin_user` (`user_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=106 DEFAULT CHARSET=utf8mb3 COMMENT='Bookmark';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ui_bookmark`
--

LOCK TABLES `ui_bookmark` WRITE;
/*!40000 ALTER TABLE `ui_bookmark` DISABLE KEYS */;
INSERT INTO `ui_bookmark` VALUES (1,1,'design_config_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"default\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"store_website_id\":{\"visible\":true,\"sorting\":false},\"store_group_id\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"theme_theme_id\":{\"visible\":true,\"sorting\":false}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"positions\":{\"default\":0,\"store_website_id\":1,\"store_group_id\":2,\"store_id\":3,\"theme_theme_id\":4,\"actions\":5}},\"value\":\"Default View\"}}}','2024-08-07 13:25:16','2024-08-07 13:25:16'),(2,1,'design_config_listing','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"default\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"store_website_id\":{\"visible\":true,\"sorting\":false},\"store_group_id\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"theme_theme_id\":{\"visible\":true,\"sorting\":false}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"positions\":{\"default\":0,\"store_website_id\":1,\"store_group_id\":2,\"store_id\":3,\"theme_theme_id\":4,\"actions\":5}}}','2024-08-07 13:25:17','2024-08-07 13:25:17'),(3,1,'cms_block_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"columns\":{\"block_id\":{\"visible\":true,\"sorting\":\"asc\"},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"positions\":{\"ids\":0,\"block_id\":1,\"title\":2,\"identifier\":3,\"store_id\":4,\"is_active\":5,\"creation_time\":6,\"update_time\":7,\"actions\":8}},\"value\":\"Default View\"}}}','2024-08-11 14:06:15','2024-08-11 14:06:15'),(4,1,'cms_block_listing','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"columns\":{\"block_id\":{\"visible\":true,\"sorting\":false},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":\"desc\"}},\"displayMode\":\"grid\",\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":100,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":100},\"positions\":{\"ids\":0,\"block_id\":1,\"title\":2,\"identifier\":3,\"store_id\":4,\"is_active\":5,\"creation_time\":6,\"update_time\":7,\"actions\":8}}}','2024-08-11 14:06:16','2025-01-09 21:30:32'),(5,1,'media_gallery_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"newest_first\":{\"visible\":false,\"sorting\":false},\"oldest_first\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":false,\"sorting\":false},\"path\":{\"visible\":false,\"sorting\":false},\"directory_desc\":{\"visible\":false,\"sorting\":false},\"directory_asc\":{\"visible\":false,\"sorting\":false},\"title\":{\"visible\":false,\"sorting\":false},\"name_az\":{\"visible\":false,\"sorting\":false},\"name_za\":{\"visible\":false,\"sorting\":false},\"source\":{\"visible\":false,\"sorting\":false},\"overlay\":{\"visible\":true,\"sorting\":false},\"thumbnail_url\":{\"visible\":true,\"sorting\":false}},\"paging\":{\"pageSize\":\"32\",\"current\":1,\"options\":{\"32\":{\"value\":32,\"label\":\"32\"},\"48\":{\"value\":48,\"label\":\"48\"},\"64\":{\"value\":64,\"label\":\"64\"}},\"value\":\"32\"},\"displayMode\":\"grid\",\"positions\":{\"source\":0,\"overlay\":1,\"thumbnail_url\":2,\"newest_first\":3,\"oldest_first\":4,\"created_at\":5,\"path\":6,\"directory_desc\":7,\"directory_asc\":8,\"title\":9,\"name_az\":10,\"name_za\":11}},\"value\":\"Default View\"}}}','2024-08-11 14:06:52','2024-08-11 14:06:52'),(6,1,'adobe_stock_images_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"relevance\":{\"visible\":false,\"sorting\":false},\"creation\":{\"visible\":false,\"sorting\":false},\"popularity\":{\"visible\":false,\"sorting\":false},\"nb_downloads\":{\"visible\":false,\"sorting\":false},\"undiscovered\":{\"visible\":false,\"sorting\":false},\"thumbnail_url\":{\"visible\":true,\"sorting\":false},\"overlay\":{\"visible\":true,\"sorting\":false},\"preview\":{\"visible\":true,\"sorting\":false,\"lastOpenedImage\":false}},\"paging\":{\"pageSize\":32,\"current\":1,\"value\":32},\"displayMode\":\"grid\",\"positions\":{\"overlay\":0,\"thumbnail_url\":1,\"preview\":2,\"relevance\":3,\"creation\":4,\"popularity\":5,\"nb_downloads\":6,\"undiscovered\":7}},\"value\":\"Default View\"}}}','2024-08-11 14:06:53','2024-08-11 14:06:53'),(7,1,'adobe_stock_images_listing','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"relevance\":{\"visible\":false,\"sorting\":false},\"creation\":{\"visible\":false,\"sorting\":false},\"popularity\":{\"visible\":false,\"sorting\":false},\"nb_downloads\":{\"visible\":false,\"sorting\":false},\"undiscovered\":{\"visible\":false,\"sorting\":false},\"thumbnail_url\":{\"visible\":true,\"sorting\":false},\"overlay\":{\"visible\":true,\"sorting\":false},\"preview\":{\"visible\":true,\"sorting\":false,\"lastOpenedImage\":false}},\"paging\":{\"pageSize\":32,\"current\":1,\"value\":32},\"displayMode\":\"grid\",\"positions\":{\"overlay\":0,\"thumbnail_url\":1,\"preview\":2,\"relevance\":3,\"creation\":4,\"popularity\":5,\"nb_downloads\":6,\"undiscovered\":7}}}','2024-08-11 14:06:54','2024-08-11 14:06:54'),(8,1,'media_gallery_listing','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true,\"path\":\"wysiwyg\"}},\"columns\":{\"newest_first\":{\"visible\":false,\"sorting\":false},\"oldest_first\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":false,\"sorting\":false},\"path\":{\"visible\":false,\"sorting\":false},\"directory_desc\":{\"visible\":false,\"sorting\":false},\"directory_asc\":{\"visible\":false,\"sorting\":false},\"title\":{\"visible\":false,\"sorting\":false},\"name_az\":{\"visible\":false,\"sorting\":false},\"name_za\":{\"visible\":false,\"sorting\":false},\"source\":{\"visible\":false,\"sorting\":false},\"overlay\":{\"visible\":true,\"sorting\":false},\"thumbnail_url\":{\"visible\":true,\"sorting\":false}},\"paging\":{\"pageSize\":48,\"current\":1,\"options\":{\"32\":{\"value\":32,\"label\":\"32\"},\"48\":{\"value\":48,\"label\":\"48\"},\"64\":{\"value\":64,\"label\":\"64\"}},\"value\":48},\"displayMode\":\"grid\",\"positions\":{\"source\":0,\"overlay\":1,\"thumbnail_url\":2,\"newest_first\":3,\"oldest_first\":4,\"created_at\":5,\"path\":6,\"directory_desc\":7,\"directory_asc\":8,\"title\":9,\"name_az\":10,\"name_za\":11}}}','2024-08-11 14:06:56','2024-09-03 05:54:37'),(9,1,'product_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"columns\":{\"entity_id\":{\"visible\":true,\"sorting\":false},\"name\":{\"visible\":true,\"sorting\":false},\"sku\":{\"visible\":true,\"sorting\":false},\"price\":{\"visible\":true,\"sorting\":false},\"websites\":{\"visible\":true,\"sorting\":false},\"qty\":{\"visible\":true,\"sorting\":false},\"short_description\":{\"visible\":false,\"sorting\":false},\"special_price\":{\"visible\":false,\"sorting\":false},\"cost\":{\"visible\":false,\"sorting\":false},\"weight\":{\"visible\":false,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keyword\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"url_key\":{\"visible\":false,\"sorting\":false},\"msrp\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"type_id\":{\"visible\":true,\"sorting\":false},\"attribute_set_id\":{\"visible\":true,\"sorting\":false},\"visibility\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"manufacturer\":{\"visible\":false,\"sorting\":false},\"color\":{\"visible\":false,\"sorting\":false},\"custom_design\":{\"visible\":false,\"sorting\":false},\"page_layout\":{\"visible\":false,\"sorting\":false},\"country_of_manufacture\":{\"visible\":false,\"sorting\":false},\"custom_layout\":{\"visible\":false,\"sorting\":false},\"gift_message_available\":{\"visible\":false,\"sorting\":false},\"tax_class_id\":{\"visible\":false,\"sorting\":false},\"salable_quantity\":{\"visible\":true,\"sorting\":false},\"thumbnail\":{\"visible\":true,\"sorting\":false},\"updated_at\":{\"visible\":true,\"sorting\":\"desc\"},\"special_from_date\":{\"visible\":false,\"sorting\":false},\"special_to_date\":{\"visible\":false,\"sorting\":false},\"news_from_date\":{\"visible\":false,\"sorting\":false},\"news_to_date\":{\"visible\":false,\"sorting\":false},\"custom_design_from\":{\"visible\":false,\"sorting\":false},\"custom_design_to\":{\"visible\":false,\"sorting\":false},\"whirlpool_baths\":{\"visible\":true,\"sorting\":false},\"shower_baths\":{\"visible\":true,\"sorting\":false},\"top_rated\":{\"visible\":true,\"sorting\":false},\"available_shipping_methods\":{\"visible\":true,\"sorting\":false},\"heat_output\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"search\":{\"value\":\"\"},\"positions\":{\"ids\":0,\"entity_id\":1,\"thumbnail\":2,\"name\":3,\"type_id\":4,\"attribute_set_id\":5,\"sku\":6,\"price\":7,\"qty\":8,\"salable_quantity\":9,\"visibility\":10,\"status\":11,\"websites\":12,\"short_description\":13,\"special_price\":14,\"special_from_date\":15,\"special_to_date\":16,\"cost\":17,\"weight\":18,\"manufacturer\":19,\"meta_title\":20,\"meta_keyword\":21,\"meta_description\":22,\"color\":23,\"news_from_date\":24,\"news_to_date\":25,\"custom_design\":26,\"custom_design_from\":27,\"custom_design_to\":28,\"page_layout\":29,\"country_of_manufacture\":30,\"custom_layout\":31,\"url_key\":32,\"msrp\":33,\"gift_message_available\":34,\"tax_class_id\":35,\"updated_at\":36,\"actions\":37,\"whirlpool_baths\":38,\"shower_baths\":39,\"top_rated\":40,\"available_shipping_methods\":41,\"heat_output\":42}},\"value\":\"Default View\"}}}','2024-08-12 09:05:07','2024-10-03 11:57:07'),(10,1,'product_listing','current',0,NULL,'{\"current\":{\"columns\":{\"entity_id\":{\"visible\":true,\"sorting\":false},\"name\":{\"visible\":true,\"sorting\":false},\"sku\":{\"visible\":true,\"sorting\":false},\"price\":{\"visible\":true,\"sorting\":false},\"websites\":{\"visible\":true,\"sorting\":false},\"qty\":{\"visible\":true,\"sorting\":false},\"short_description\":{\"visible\":false,\"sorting\":false},\"special_price\":{\"visible\":false,\"sorting\":false},\"cost\":{\"visible\":false,\"sorting\":false},\"weight\":{\"visible\":false,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keyword\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"url_key\":{\"visible\":false,\"sorting\":false},\"msrp\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"type_id\":{\"visible\":true,\"sorting\":false},\"attribute_set_id\":{\"visible\":true,\"sorting\":false},\"visibility\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"manufacturer\":{\"visible\":false,\"sorting\":false},\"color\":{\"visible\":false,\"sorting\":false},\"custom_design\":{\"visible\":false,\"sorting\":false},\"page_layout\":{\"visible\":false,\"sorting\":false},\"country_of_manufacture\":{\"visible\":false,\"sorting\":false},\"custom_layout\":{\"visible\":false,\"sorting\":false},\"gift_message_available\":{\"visible\":false,\"sorting\":false},\"tax_class_id\":{\"visible\":false,\"sorting\":false},\"salable_quantity\":{\"visible\":true,\"sorting\":false},\"thumbnail\":{\"visible\":true,\"sorting\":false},\"updated_at\":{\"visible\":true,\"sorting\":\"desc\"},\"special_from_date\":{\"visible\":false,\"sorting\":false},\"special_to_date\":{\"visible\":false,\"sorting\":false},\"news_from_date\":{\"visible\":false,\"sorting\":false},\"news_to_date\":{\"visible\":false,\"sorting\":false},\"custom_design_from\":{\"visible\":false,\"sorting\":false},\"custom_design_to\":{\"visible\":false,\"sorting\":false},\"whirlpool_baths\":{\"visible\":true,\"sorting\":false},\"shower_baths\":{\"visible\":true,\"sorting\":false},\"top_rated\":{\"visible\":true,\"sorting\":false},\"available_shipping_methods\":{\"visible\":true,\"sorting\":false},\"heat_output\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"search\":{\"value\":\"\"},\"positions\":{\"ids\":0,\"entity_id\":1,\"thumbnail\":2,\"name\":3,\"type_id\":4,\"attribute_set_id\":5,\"sku\":6,\"price\":7,\"qty\":8,\"salable_quantity\":9,\"visibility\":10,\"status\":11,\"websites\":12,\"short_description\":13,\"special_price\":14,\"special_from_date\":15,\"special_to_date\":16,\"cost\":17,\"weight\":18,\"manufacturer\":19,\"meta_title\":20,\"meta_keyword\":21,\"meta_description\":22,\"color\":23,\"news_from_date\":24,\"news_to_date\":25,\"custom_design\":26,\"custom_design_from\":27,\"custom_design_to\":28,\"page_layout\":29,\"country_of_manufacture\":30,\"custom_layout\":31,\"url_key\":32,\"msrp\":33,\"gift_message_available\":34,\"tax_class_id\":35,\"updated_at\":36,\"actions\":37,\"whirlpool_baths\":38,\"shower_baths\":39,\"top_rated\":40,\"available_shipping_methods\":41,\"heat_output\":42}}}','2024-08-12 09:05:08','2025-01-10 13:48:23'),(11,1,'cms_page_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"ids\":{\"visible\":true,\"sorting\":false},\"page_layout\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"custom_theme\":{\"visible\":false,\"sorting\":false},\"custom_root_template\":{\"visible\":false,\"sorting\":false},\"page_id\":{\"visible\":true,\"sorting\":\"asc\"},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keywords\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":false},\"custom_theme_from\":{\"visible\":false,\"sorting\":false},\"custom_theme_to\":{\"visible\":false,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"page_id\":1,\"title\":2,\"identifier\":3,\"page_layout\":4,\"store_id\":5,\"is_active\":6,\"creation_time\":7,\"update_time\":8,\"custom_theme_from\":9,\"custom_theme_to\":10,\"custom_theme\":11,\"custom_root_template\":12,\"meta_title\":13,\"meta_keywords\":14,\"meta_description\":15,\"actions\":16}},\"value\":\"Default View\"}}}','2024-08-12 09:21:55','2024-08-12 09:21:55'),(12,1,'cms_page_listing','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"ids\":{\"visible\":true,\"sorting\":false},\"page_layout\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"custom_theme\":{\"visible\":false,\"sorting\":false},\"custom_root_template\":{\"visible\":false,\"sorting\":false},\"page_id\":{\"visible\":true,\"sorting\":false},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keywords\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":\"desc\"},\"custom_theme_from\":{\"visible\":false,\"sorting\":false},\"custom_theme_to\":{\"visible\":false,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"page_id\":1,\"title\":2,\"identifier\":3,\"page_layout\":4,\"store_id\":5,\"is_active\":6,\"creation_time\":7,\"update_time\":8,\"custom_theme_from\":9,\"custom_theme_to\":10,\"custom_theme\":11,\"custom_root_template\":12,\"meta_title\":13,\"meta_keywords\":14,\"meta_description\":15,\"actions\":16}}}','2024-08-12 09:21:56','2025-01-09 21:11:29'),(13,1,'design_theme_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"columns\":{\"actions\":{\"visible\":true,\"sorting\":false},\"theme_id\":{\"visible\":false,\"sorting\":\"asc\"},\"theme_title\":{\"visible\":true,\"sorting\":false},\"parent_theme_title\":{\"visible\":true,\"sorting\":false},\"theme_path\":{\"visible\":true,\"sorting\":false}},\"positions\":{\"theme_id\":0,\"theme_title\":1,\"parent_theme_title\":2,\"theme_path\":3,\"actions\":4}},\"value\":\"Default View\"}}}','2024-08-12 09:23:02','2024-08-12 09:23:02'),(14,1,'design_theme_listing','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"columns\":{\"actions\":{\"visible\":true,\"sorting\":false},\"theme_id\":{\"visible\":false,\"sorting\":\"asc\"},\"theme_title\":{\"visible\":true,\"sorting\":false},\"parent_theme_title\":{\"visible\":true,\"sorting\":false},\"theme_path\":{\"visible\":true,\"sorting\":false}},\"positions\":{\"theme_id\":0,\"theme_title\":1,\"parent_theme_title\":2,\"theme_path\":3,\"actions\":4}}}','2024-08-12 09:23:04','2024-08-12 09:23:04'),(15,2,'customer_online_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"displayMode\":\"grid\",\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1},\"columns\":{\"visitor_type\":{\"visible\":true,\"sorting\":false},\"last_visit_at\":{\"visible\":true,\"sorting\":false},\"customer_id\":{\"visible\":true,\"sorting\":\"asc\"},\"firstname\":{\"visible\":true,\"sorting\":false},\"lastname\":{\"visible\":true,\"sorting\":false},\"email\":{\"visible\":true,\"sorting\":false}},\"positions\":{\"customer_id\":0,\"firstname\":1,\"lastname\":2,\"email\":3,\"last_visit_at\":4,\"visitor_type\":5}},\"value\":\"Default View\"}}}','2024-08-15 10:35:01','2024-08-15 10:35:01'),(16,2,'customer_online_grid','current',0,NULL,'{\"current\":{\"displayMode\":\"grid\",\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"visitor_type\":{\"visible\":true,\"sorting\":false},\"last_visit_at\":{\"visible\":true,\"sorting\":false},\"customer_id\":{\"visible\":true,\"sorting\":\"asc\"},\"firstname\":{\"visible\":true,\"sorting\":false},\"lastname\":{\"visible\":true,\"sorting\":false},\"email\":{\"visible\":true,\"sorting\":false}},\"positions\":{\"customer_id\":0,\"firstname\":1,\"lastname\":2,\"email\":3,\"last_visit_at\":4,\"visitor_type\":5}}}','2024-08-15 10:35:03','2024-08-15 10:35:03'),(17,2,'product_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"entity_id\":{\"visible\":true,\"sorting\":\"asc\"},\"name\":{\"visible\":true,\"sorting\":false},\"sku\":{\"visible\":true,\"sorting\":false},\"price\":{\"visible\":true,\"sorting\":false},\"websites\":{\"visible\":true,\"sorting\":false},\"qty\":{\"visible\":true,\"sorting\":false},\"short_description\":{\"visible\":false,\"sorting\":false},\"special_price\":{\"visible\":false,\"sorting\":false},\"cost\":{\"visible\":false,\"sorting\":false},\"weight\":{\"visible\":false,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keyword\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"url_key\":{\"visible\":false,\"sorting\":false},\"msrp\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"type_id\":{\"visible\":true,\"sorting\":false},\"attribute_set_id\":{\"visible\":true,\"sorting\":false},\"visibility\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"manufacturer\":{\"visible\":false,\"sorting\":false},\"color\":{\"visible\":false,\"sorting\":false},\"custom_design\":{\"visible\":false,\"sorting\":false},\"page_layout\":{\"visible\":false,\"sorting\":false},\"country_of_manufacture\":{\"visible\":false,\"sorting\":false},\"custom_layout\":{\"visible\":false,\"sorting\":false},\"gift_message_available\":{\"visible\":false,\"sorting\":false},\"tax_class_id\":{\"visible\":false,\"sorting\":false},\"salable_quantity\":{\"visible\":true,\"sorting\":false},\"thumbnail\":{\"visible\":true,\"sorting\":false},\"updated_at\":{\"visible\":true,\"sorting\":false},\"special_from_date\":{\"visible\":false,\"sorting\":false},\"special_to_date\":{\"visible\":false,\"sorting\":false},\"news_from_date\":{\"visible\":false,\"sorting\":false},\"news_to_date\":{\"visible\":false,\"sorting\":false},\"custom_design_from\":{\"visible\":false,\"sorting\":false},\"custom_design_to\":{\"visible\":false,\"sorting\":false},\"heat_output\":{\"visible\":true,\"sorting\":false},\"whirlpool_baths\":{\"visible\":true,\"sorting\":false},\"shower_baths\":{\"visible\":true,\"sorting\":false},\"top_rated\":{\"visible\":true,\"sorting\":false},\"available_shipping_methods\":{\"visible\":true,\"sorting\":false}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"search\":{\"value\":\"\"},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"entity_id\":1,\"thumbnail\":2,\"name\":3,\"type_id\":4,\"attribute_set_id\":5,\"sku\":6,\"price\":7,\"qty\":8,\"salable_quantity\":9,\"visibility\":10,\"status\":11,\"websites\":12,\"short_description\":13,\"special_price\":14,\"special_from_date\":15,\"special_to_date\":16,\"cost\":17,\"weight\":18,\"manufacturer\":19,\"meta_title\":20,\"meta_keyword\":21,\"meta_description\":22,\"color\":23,\"news_from_date\":24,\"news_to_date\":25,\"custom_design\":26,\"custom_design_from\":27,\"custom_design_to\":28,\"page_layout\":29,\"country_of_manufacture\":30,\"custom_layout\":31,\"url_key\":32,\"msrp\":33,\"gift_message_available\":34,\"tax_class_id\":35,\"updated_at\":36,\"actions\":37,\"whirlpool_baths\":38,\"shower_baths\":39,\"top_rated\":40,\"available_shipping_methods\":41,\"heat_output\":42}},\"value\":\"Default View\"}}}','2024-08-15 10:46:30','2024-10-18 08:16:24'),(18,2,'product_listing','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"entity_id\":{\"visible\":true,\"sorting\":\"asc\"},\"name\":{\"visible\":true,\"sorting\":false},\"sku\":{\"visible\":true,\"sorting\":false},\"price\":{\"visible\":true,\"sorting\":false},\"websites\":{\"visible\":true,\"sorting\":false},\"qty\":{\"visible\":true,\"sorting\":false},\"short_description\":{\"visible\":false,\"sorting\":false},\"special_price\":{\"visible\":false,\"sorting\":false},\"cost\":{\"visible\":false,\"sorting\":false},\"weight\":{\"visible\":false,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keyword\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"url_key\":{\"visible\":false,\"sorting\":false},\"msrp\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"type_id\":{\"visible\":true,\"sorting\":false},\"attribute_set_id\":{\"visible\":true,\"sorting\":false},\"visibility\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"manufacturer\":{\"visible\":false,\"sorting\":false},\"color\":{\"visible\":false,\"sorting\":false},\"custom_design\":{\"visible\":false,\"sorting\":false},\"page_layout\":{\"visible\":false,\"sorting\":false},\"country_of_manufacture\":{\"visible\":false,\"sorting\":false},\"custom_layout\":{\"visible\":false,\"sorting\":false},\"gift_message_available\":{\"visible\":false,\"sorting\":false},\"tax_class_id\":{\"visible\":false,\"sorting\":false},\"salable_quantity\":{\"visible\":true,\"sorting\":false},\"thumbnail\":{\"visible\":true,\"sorting\":false},\"updated_at\":{\"visible\":true,\"sorting\":false},\"special_from_date\":{\"visible\":false,\"sorting\":false},\"special_to_date\":{\"visible\":false,\"sorting\":false},\"news_from_date\":{\"visible\":false,\"sorting\":false},\"news_to_date\":{\"visible\":false,\"sorting\":false},\"custom_design_from\":{\"visible\":false,\"sorting\":false},\"custom_design_to\":{\"visible\":false,\"sorting\":false},\"heat_output\":{\"visible\":true,\"sorting\":false},\"whirlpool_baths\":{\"visible\":true,\"sorting\":false},\"shower_baths\":{\"visible\":true,\"sorting\":false},\"top_rated\":{\"visible\":true,\"sorting\":false},\"available_shipping_methods\":{\"visible\":true,\"sorting\":false}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"search\":{\"value\":\"\"},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"entity_id\":1,\"thumbnail\":2,\"name\":3,\"type_id\":4,\"attribute_set_id\":5,\"sku\":6,\"price\":7,\"qty\":8,\"salable_quantity\":9,\"visibility\":10,\"status\":11,\"websites\":12,\"short_description\":13,\"special_price\":14,\"special_from_date\":15,\"special_to_date\":16,\"cost\":17,\"weight\":18,\"manufacturer\":19,\"meta_title\":20,\"meta_keyword\":21,\"meta_description\":22,\"color\":23,\"news_from_date\":24,\"news_to_date\":25,\"custom_design\":26,\"custom_design_from\":27,\"custom_design_to\":28,\"page_layout\":29,\"country_of_manufacture\":30,\"custom_layout\":31,\"url_key\":32,\"msrp\":33,\"gift_message_available\":34,\"tax_class_id\":35,\"updated_at\":36,\"actions\":37,\"whirlpool_baths\":38,\"shower_baths\":39,\"top_rated\":40,\"available_shipping_methods\":41,\"heat_output\":42}}}','2024-08-15 10:46:32','2024-10-18 08:16:24'),(19,3,'product_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"columns\":{\"entity_id\":{\"visible\":true,\"sorting\":\"asc\"},\"name\":{\"visible\":true,\"sorting\":false},\"sku\":{\"visible\":true,\"sorting\":false},\"price\":{\"visible\":true,\"sorting\":false},\"websites\":{\"visible\":true,\"sorting\":false},\"qty\":{\"visible\":true,\"sorting\":false},\"short_description\":{\"visible\":false,\"sorting\":false},\"special_price\":{\"visible\":false,\"sorting\":false},\"cost\":{\"visible\":false,\"sorting\":false},\"weight\":{\"visible\":false,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keyword\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"url_key\":{\"visible\":false,\"sorting\":false},\"msrp\":{\"visible\":false,\"sorting\":false},\"type_id\":{\"visible\":true,\"sorting\":false},\"attribute_set_id\":{\"visible\":true,\"sorting\":false},\"visibility\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"manufacturer\":{\"visible\":false,\"sorting\":false},\"color\":{\"visible\":false,\"sorting\":false},\"custom_design\":{\"visible\":false,\"sorting\":false},\"page_layout\":{\"visible\":false,\"sorting\":false},\"country_of_manufacture\":{\"visible\":false,\"sorting\":false},\"custom_layout\":{\"visible\":false,\"sorting\":false},\"gift_message_available\":{\"visible\":false,\"sorting\":false},\"tax_class_id\":{\"visible\":false,\"sorting\":false},\"whirlpool_baths\":{\"visible\":true,\"sorting\":false},\"shower_baths\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"updated_at\":{\"visible\":true,\"sorting\":false},\"special_from_date\":{\"visible\":false,\"sorting\":false},\"special_to_date\":{\"visible\":false,\"sorting\":false},\"news_from_date\":{\"visible\":false,\"sorting\":false},\"news_to_date\":{\"visible\":false,\"sorting\":false},\"custom_design_from\":{\"visible\":false,\"sorting\":false},\"custom_design_to\":{\"visible\":false,\"sorting\":false},\"salable_quantity\":{\"visible\":true,\"sorting\":false},\"thumbnail\":{\"visible\":true,\"sorting\":false},\"top_rated\":{\"visible\":true,\"sorting\":false},\"available_shipping_methods\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"search\":{\"value\":\"\"},\"positions\":{\"ids\":0,\"entity_id\":1,\"thumbnail\":2,\"name\":3,\"type_id\":4,\"attribute_set_id\":5,\"sku\":6,\"price\":7,\"qty\":8,\"salable_quantity\":9,\"visibility\":10,\"status\":11,\"websites\":12,\"short_description\":13,\"special_price\":14,\"special_from_date\":15,\"special_to_date\":16,\"cost\":17,\"weight\":18,\"manufacturer\":19,\"meta_title\":20,\"meta_keyword\":21,\"meta_description\":22,\"color\":23,\"news_from_date\":24,\"news_to_date\":25,\"custom_design\":26,\"custom_design_from\":27,\"custom_design_to\":28,\"page_layout\":29,\"country_of_manufacture\":30,\"custom_layout\":31,\"url_key\":32,\"msrp\":33,\"gift_message_available\":34,\"tax_class_id\":35,\"whirlpool_baths\":36,\"shower_baths\":37,\"updated_at\":38,\"actions\":39,\"top_rated\":40,\"available_shipping_methods\":41}},\"value\":\"Default View\"}}}','2024-08-15 13:24:58','2024-09-16 14:03:29'),(20,2,'cms_block_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"ids\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"block_id\":{\"visible\":true,\"sorting\":\"asc\"},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"block_id\":1,\"title\":2,\"identifier\":3,\"store_id\":4,\"is_active\":5,\"creation_time\":6,\"update_time\":7,\"actions\":8}},\"value\":\"Default View\"}}}','2024-08-21 08:39:41','2024-08-21 08:39:41'),(21,2,'cms_block_listing','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"ids\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"block_id\":{\"visible\":true,\"sorting\":\"asc\"},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"block_id\":1,\"title\":2,\"identifier\":3,\"store_id\":4,\"is_active\":5,\"creation_time\":6,\"update_time\":7,\"actions\":8}}}','2024-08-21 08:39:43','2024-08-21 08:39:43'),(22,2,'adobe_stock_images_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":32,\"current\":1,\"value\":32},\"columns\":{\"relevance\":{\"visible\":false,\"sorting\":false},\"creation\":{\"visible\":false,\"sorting\":false},\"popularity\":{\"visible\":false,\"sorting\":false},\"nb_downloads\":{\"visible\":false,\"sorting\":false},\"undiscovered\":{\"visible\":false,\"sorting\":false},\"thumbnail_url\":{\"visible\":true,\"sorting\":false},\"overlay\":{\"visible\":true,\"sorting\":false},\"preview\":{\"visible\":true,\"sorting\":false,\"lastOpenedImage\":false}},\"displayMode\":\"grid\",\"positions\":{\"overlay\":0,\"thumbnail_url\":1,\"preview\":2,\"relevance\":3,\"creation\":4,\"popularity\":5,\"nb_downloads\":6,\"undiscovered\":7}},\"value\":\"Default View\"}}}','2024-08-21 10:15:34','2024-08-21 10:15:34'),(23,2,'media_gallery_listing','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true,\"path\":\"wysiwyg\"}},\"paging\":{\"pageSize\":\"32\",\"current\":1,\"options\":{\"32\":{\"value\":32,\"label\":\"32\"},\"48\":{\"value\":48,\"label\":\"48\"},\"64\":{\"value\":64,\"label\":\"64\"}},\"value\":\"32\"},\"columns\":{\"newest_first\":{\"visible\":false,\"sorting\":false},\"oldest_first\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":false,\"sorting\":false},\"path\":{\"visible\":false,\"sorting\":false},\"directory_desc\":{\"visible\":false,\"sorting\":false},\"directory_asc\":{\"visible\":false,\"sorting\":false},\"title\":{\"visible\":false,\"sorting\":false},\"name_az\":{\"visible\":false,\"sorting\":false},\"name_za\":{\"visible\":false,\"sorting\":false},\"source\":{\"visible\":false,\"sorting\":false},\"overlay\":{\"visible\":true,\"sorting\":false},\"thumbnail_url\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"source\":0,\"overlay\":1,\"thumbnail_url\":2,\"newest_first\":3,\"oldest_first\":4,\"created_at\":5,\"path\":6,\"directory_desc\":7,\"directory_asc\":8,\"title\":9,\"name_az\":10,\"name_za\":11}}}','2024-08-21 10:15:35','2024-08-21 11:32:24'),(24,2,'adobe_stock_images_listing','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":32,\"current\":1,\"value\":32},\"columns\":{\"relevance\":{\"visible\":false,\"sorting\":false},\"creation\":{\"visible\":false,\"sorting\":false},\"popularity\":{\"visible\":false,\"sorting\":false},\"nb_downloads\":{\"visible\":false,\"sorting\":false},\"undiscovered\":{\"visible\":false,\"sorting\":false},\"thumbnail_url\":{\"visible\":true,\"sorting\":false},\"overlay\":{\"visible\":true,\"sorting\":false},\"preview\":{\"visible\":true,\"sorting\":false,\"lastOpenedImage\":false}},\"displayMode\":\"grid\",\"positions\":{\"overlay\":0,\"thumbnail_url\":1,\"preview\":2,\"relevance\":3,\"creation\":4,\"popularity\":5,\"nb_downloads\":6,\"undiscovered\":7}}}','2024-08-21 10:15:36','2024-08-21 10:15:36'),(25,2,'cms_page_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"columns\":{\"page_id\":{\"visible\":true,\"sorting\":\"asc\"},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keywords\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"page_layout\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"custom_theme\":{\"visible\":false,\"sorting\":false},\"custom_root_template\":{\"visible\":false,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":false},\"custom_theme_from\":{\"visible\":false,\"sorting\":false},\"custom_theme_to\":{\"visible\":false,\"sorting\":false}},\"displayMode\":\"grid\",\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"positions\":{\"ids\":0,\"page_id\":1,\"title\":2,\"identifier\":3,\"page_layout\":4,\"store_id\":5,\"is_active\":6,\"creation_time\":7,\"update_time\":8,\"custom_theme_from\":9,\"custom_theme_to\":10,\"custom_theme\":11,\"custom_root_template\":12,\"meta_title\":13,\"meta_keywords\":14,\"meta_description\":15,\"actions\":16}},\"value\":\"Default View\"}}}','2024-08-23 07:54:31','2024-08-23 07:54:31'),(26,2,'cms_page_listing','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"columns\":{\"page_id\":{\"visible\":true,\"sorting\":\"asc\"},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keywords\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"page_layout\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"custom_theme\":{\"visible\":false,\"sorting\":false},\"custom_root_template\":{\"visible\":false,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":false},\"custom_theme_from\":{\"visible\":false,\"sorting\":false},\"custom_theme_to\":{\"visible\":false,\"sorting\":false}},\"displayMode\":\"grid\",\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"positions\":{\"ids\":0,\"page_id\":1,\"title\":2,\"identifier\":3,\"page_layout\":4,\"store_id\":5,\"is_active\":6,\"creation_time\":7,\"update_time\":8,\"custom_theme_from\":9,\"custom_theme_to\":10,\"custom_theme\":11,\"custom_root_template\":12,\"meta_title\":13,\"meta_keywords\":14,\"meta_description\":15,\"actions\":16}}}','2024-08-23 07:54:33','2024-08-23 07:54:33'),(27,3,'cms_block_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"block_id\":{\"visible\":true,\"sorting\":\"asc\"},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"search\":{\"value\":\"\"},\"positions\":{\"ids\":0,\"block_id\":1,\"title\":2,\"identifier\":3,\"store_id\":4,\"is_active\":5,\"creation_time\":6,\"update_time\":7,\"actions\":8}},\"value\":\"Default View\"}}}','2024-08-23 11:48:33','2024-08-23 11:48:33'),(28,3,'cms_block_listing','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"block_id\":{\"visible\":true,\"sorting\":\"asc\"},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"search\":{\"value\":\"\"},\"positions\":{\"ids\":0,\"block_id\":1,\"title\":2,\"identifier\":3,\"store_id\":4,\"is_active\":5,\"creation_time\":6,\"update_time\":7,\"actions\":8}}}','2024-08-23 11:48:34','2024-08-23 11:48:34'),(29,1,'product_attributes_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"columns\":{\"attribute_code\":{\"visible\":true,\"sorting\":\"asc\"},\"frontend_label\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"is_required\":{\"visible\":true,\"sorting\":false},\"is_user_defined\":{\"visible\":true,\"sorting\":false},\"is_visible\":{\"visible\":true,\"sorting\":false},\"is_global\":{\"visible\":true,\"sorting\":false},\"is_searchable\":{\"visible\":true,\"sorting\":false},\"is_comparable\":{\"visible\":true,\"sorting\":false},\"is_filterable\":{\"visible\":true,\"sorting\":false}},\"positions\":{\"ids\":0,\"attribute_code\":1,\"frontend_label\":2,\"is_required\":3,\"is_user_defined\":4,\"is_visible\":5,\"is_global\":6,\"is_searchable\":7,\"is_comparable\":8,\"is_filterable\":9}},\"value\":\"Default View\"}}}','2024-08-28 11:39:43','2024-08-28 11:39:43'),(30,1,'product_attributes_listing','current',0,NULL,'{\"current\":{\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"columns\":{\"attribute_code\":{\"visible\":true,\"sorting\":\"asc\"},\"frontend_label\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"is_required\":{\"visible\":true,\"sorting\":false},\"is_user_defined\":{\"visible\":true,\"sorting\":false},\"is_visible\":{\"visible\":true,\"sorting\":false},\"is_global\":{\"visible\":true,\"sorting\":false},\"is_searchable\":{\"visible\":true,\"sorting\":false},\"is_comparable\":{\"visible\":true,\"sorting\":false},\"is_filterable\":{\"visible\":true,\"sorting\":false}},\"positions\":{\"ids\":0,\"attribute_code\":1,\"frontend_label\":2,\"is_required\":3,\"is_user_defined\":4,\"is_visible\":5,\"is_global\":6,\"is_searchable\":7,\"is_comparable\":8,\"is_filterable\":9}}}','2024-08-28 11:39:45','2024-08-28 11:39:45'),(31,1,'product_attributes_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"columns\":{\"ids\":{\"visible\":true,\"sorting\":false},\"is_required\":{\"visible\":true,\"sorting\":false},\"is_user_defined\":{\"visible\":true,\"sorting\":false},\"is_visible\":{\"visible\":true,\"sorting\":false},\"is_global\":{\"visible\":true,\"sorting\":false},\"is_searchable\":{\"visible\":true,\"sorting\":false},\"is_comparable\":{\"visible\":true,\"sorting\":false},\"is_filterable\":{\"visible\":true,\"sorting\":false},\"attribute_code\":{\"visible\":true,\"sorting\":\"asc\"},\"frontend_label\":{\"visible\":true,\"sorting\":false}},\"positions\":{\"ids\":0,\"attribute_code\":1,\"frontend_label\":2,\"is_required\":3,\"is_user_defined\":4,\"is_visible\":5,\"is_global\":6,\"is_searchable\":7,\"is_comparable\":8,\"is_filterable\":9},\"displayMode\":\"grid\",\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20}},\"value\":\"Default View\"}}}','2024-08-30 09:42:29','2024-08-30 09:42:29'),(32,1,'product_attributes_grid','current',0,NULL,'{\"current\":{\"columns\":{\"ids\":{\"visible\":true,\"sorting\":false},\"is_required\":{\"visible\":true,\"sorting\":false},\"is_user_defined\":{\"visible\":true,\"sorting\":false},\"is_visible\":{\"visible\":true,\"sorting\":false},\"is_global\":{\"visible\":true,\"sorting\":false},\"is_searchable\":{\"visible\":true,\"sorting\":false},\"is_comparable\":{\"visible\":true,\"sorting\":false},\"is_filterable\":{\"visible\":true,\"sorting\":false},\"attribute_code\":{\"visible\":true,\"sorting\":\"asc\"},\"frontend_label\":{\"visible\":true,\"sorting\":false}},\"positions\":{\"ids\":0,\"attribute_code\":1,\"frontend_label\":2,\"is_required\":3,\"is_user_defined\":4,\"is_visible\":5,\"is_global\":6,\"is_searchable\":7,\"is_comparable\":8,\"is_filterable\":9},\"displayMode\":\"grid\",\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20}}}','2024-08-30 09:42:31','2024-08-30 09:42:31'),(33,3,'product_listing','current',0,NULL,'{\"current\":{\"columns\":{\"entity_id\":{\"visible\":true,\"sorting\":\"asc\"},\"name\":{\"visible\":true,\"sorting\":false},\"sku\":{\"visible\":true,\"sorting\":false},\"price\":{\"visible\":true,\"sorting\":false},\"websites\":{\"visible\":true,\"sorting\":false},\"qty\":{\"visible\":true,\"sorting\":false},\"short_description\":{\"visible\":false,\"sorting\":false},\"special_price\":{\"visible\":false,\"sorting\":false},\"cost\":{\"visible\":false,\"sorting\":false},\"weight\":{\"visible\":false,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keyword\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"url_key\":{\"visible\":false,\"sorting\":false},\"msrp\":{\"visible\":false,\"sorting\":false},\"type_id\":{\"visible\":true,\"sorting\":false},\"attribute_set_id\":{\"visible\":true,\"sorting\":false},\"visibility\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"manufacturer\":{\"visible\":false,\"sorting\":false},\"color\":{\"visible\":false,\"sorting\":false},\"custom_design\":{\"visible\":false,\"sorting\":false},\"page_layout\":{\"visible\":false,\"sorting\":false},\"country_of_manufacture\":{\"visible\":false,\"sorting\":false},\"custom_layout\":{\"visible\":false,\"sorting\":false},\"gift_message_available\":{\"visible\":false,\"sorting\":false},\"tax_class_id\":{\"visible\":false,\"sorting\":false},\"whirlpool_baths\":{\"visible\":true,\"sorting\":false},\"shower_baths\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"updated_at\":{\"visible\":true,\"sorting\":false},\"special_from_date\":{\"visible\":false,\"sorting\":false},\"special_to_date\":{\"visible\":false,\"sorting\":false},\"news_from_date\":{\"visible\":false,\"sorting\":false},\"news_to_date\":{\"visible\":false,\"sorting\":false},\"custom_design_from\":{\"visible\":false,\"sorting\":false},\"custom_design_to\":{\"visible\":false,\"sorting\":false},\"salable_quantity\":{\"visible\":true,\"sorting\":false},\"thumbnail\":{\"visible\":true,\"sorting\":false},\"top_rated\":{\"visible\":true,\"sorting\":false},\"available_shipping_methods\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"search\":{\"value\":\"25217000\"},\"positions\":{\"ids\":0,\"entity_id\":1,\"thumbnail\":2,\"name\":3,\"type_id\":4,\"attribute_set_id\":5,\"sku\":6,\"price\":7,\"qty\":8,\"salable_quantity\":9,\"visibility\":10,\"status\":11,\"websites\":12,\"short_description\":13,\"special_price\":14,\"special_from_date\":15,\"special_to_date\":16,\"cost\":17,\"weight\":18,\"manufacturer\":19,\"meta_title\":20,\"meta_keyword\":21,\"meta_description\":22,\"color\":23,\"news_from_date\":24,\"news_to_date\":25,\"custom_design\":26,\"custom_design_from\":27,\"custom_design_to\":28,\"page_layout\":29,\"country_of_manufacture\":30,\"custom_layout\":31,\"url_key\":32,\"msrp\":33,\"gift_message_available\":34,\"tax_class_id\":35,\"whirlpool_baths\":36,\"shower_baths\":37,\"updated_at\":38,\"actions\":39,\"top_rated\":40,\"available_shipping_methods\":41}}}','2024-09-03 15:07:20','2024-09-19 12:21:15'),(34,2,'sales_order_invoice_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1},\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"base_grand_total\":7,\"grand_total\":8,\"store_id\":9,\"billing_address\":10,\"shipping_address\":11,\"customer_name\":12,\"customer_email\":13,\"customer_group_id\":14,\"payment_method\":15,\"shipping_information\":16,\"subtotal\":17,\"shipping_and_handling\":18,\"actions\":19}},\"value\":\"Default View\"}}}','2024-10-04 12:03:58','2024-10-04 12:03:58'),(35,2,'login_as_customer_log_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"columns\":{\"log_id\":{\"visible\":true,\"sorting\":false},\"customer_id\":{\"visible\":true,\"sorting\":false},\"customer_email\":{\"visible\":true,\"sorting\":false},\"user_id\":{\"visible\":true,\"sorting\":false},\"user_name\":{\"visible\":true,\"sorting\":false},\"time\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1},\"positions\":{\"log_id\":0,\"customer_id\":1,\"customer_email\":2,\"user_id\":3,\"user_name\":4,\"time\":5}},\"value\":\"Default View\"}}}','2024-10-18 14:16:29','2024-10-18 14:16:29'),(36,1,'sales_order_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"shipping_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"grand_total\":{\"visible\":true,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"total_refunded\":{\"visible\":false,\"sorting\":false},\"pickup_location_code\":{\"visible\":false,\"sorting\":false},\"transaction_source\":{\"visible\":true,\"sorting\":false},\"dispute_status\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"customer_group\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"allocated_sources\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":\"desc\"},\"cost_price\":{\"visible\":true,\"sorting\":false},\"brand\":{\"visible\":true,\"sorting\":false},\"postcode\":{\"visible\":true,\"sorting\":false},\"telephone\":{\"visible\":true,\"sorting\":false},\"notes\":{\"visible\":true,\"sorting\":false},\"review_status\":{\"visible\":true,\"sorting\":false},\"login_actions\":{\"visible\":true,\"sorting\":false},\"delivery_method\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"positions\":{\"ids\":0,\"increment_id\":1,\"store_id\":2,\"created_at\":3,\"billing_name\":4,\"shipping_name\":5,\"base_grand_total\":6,\"grand_total\":7,\"status\":8,\"billing_address\":9,\"shipping_address\":10,\"shipping_information\":11,\"customer_email\":12,\"customer_group\":13,\"subtotal\":14,\"shipping_and_handling\":15,\"customer_name\":16,\"payment_method\":17,\"total_refunded\":18,\"actions\":19,\"allocated_sources\":20,\"pickup_location_code\":21,\"transaction_source\":22,\"dispute_status\":23,\"login_actions\":24}},\"value\":\"Default View\"}}}','2024-10-21 05:53:59','2025-01-11 07:09:44'),(37,1,'sales_order_grid','current',0,NULL,'{\"current\":{\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"shipping_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"grand_total\":{\"visible\":true,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"total_refunded\":{\"visible\":false,\"sorting\":false},\"pickup_location_code\":{\"visible\":false,\"sorting\":false},\"transaction_source\":{\"visible\":true,\"sorting\":false},\"dispute_status\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"customer_group\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"allocated_sources\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":\"desc\"},\"cost_price\":{\"visible\":true,\"sorting\":false},\"brand\":{\"visible\":true,\"sorting\":false},\"postcode\":{\"visible\":true,\"sorting\":false},\"telephone\":{\"visible\":true,\"sorting\":false},\"notes\":{\"visible\":true,\"sorting\":false},\"review_status\":{\"visible\":true,\"sorting\":false},\"login_actions\":{\"visible\":true,\"sorting\":false},\"delivery_method\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"positions\":{\"ids\":0,\"increment_id\":1,\"store_id\":2,\"created_at\":3,\"billing_name\":4,\"shipping_name\":5,\"base_grand_total\":6,\"grand_total\":7,\"status\":8,\"billing_address\":9,\"shipping_address\":10,\"shipping_information\":11,\"customer_email\":12,\"customer_group\":13,\"subtotal\":14,\"shipping_and_handling\":15,\"customer_name\":16,\"payment_method\":17,\"total_refunded\":18,\"actions\":19,\"allocated_sources\":20,\"pickup_location_code\":21,\"transaction_source\":22,\"dispute_status\":23,\"login_actions\":24}}}','2024-10-21 05:54:00','2025-01-11 07:09:44'),(38,1,'nexus_sales_order_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"shipping_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"grand_total\":{\"visible\":true,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"total_refunded\":{\"visible\":false,\"sorting\":false},\"name\":{\"visible\":true,\"sorting\":false},\"sku\":{\"visible\":true,\"sorting\":false},\"qty_ordered\":{\"visible\":true,\"sorting\":false},\"brand\":{\"visible\":true,\"sorting\":false},\"price_incl_tax\":{\"visible\":true,\"sorting\":false},\"price\":{\"visible\":true,\"sorting\":false},\"base_cost\":{\"visible\":true,\"sorting\":false},\"po_status\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"customer_group\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":\"desc\"}},\"positions\":{\"ids\":0,\"increment_id\":1,\"store_id\":2,\"created_at\":3,\"billing_name\":4,\"shipping_name\":5,\"base_grand_total\":6,\"grand_total\":7,\"status\":8,\"billing_address\":9,\"shipping_address\":10,\"shipping_information\":11,\"customer_email\":12,\"customer_group\":13,\"subtotal\":14,\"shipping_and_handling\":15,\"payment_method\":16,\"total_refunded\":17,\"name\":18,\"sku\":19,\"qty_ordered\":20,\"brand\":21,\"price_incl_tax\":22,\"price\":23,\"base_cost\":24,\"po_status\":25}},\"value\":\"Default View\"}}}','2024-12-03 13:42:01','2024-12-03 13:42:01'),(39,1,'nexus_sales_order_grid','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"shipping_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"grand_total\":{\"visible\":true,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"total_refunded\":{\"visible\":false,\"sorting\":false},\"name\":{\"visible\":true,\"sorting\":false},\"sku\":{\"visible\":true,\"sorting\":false},\"qty_ordered\":{\"visible\":true,\"sorting\":false},\"brand\":{\"visible\":true,\"sorting\":false},\"price_incl_tax\":{\"visible\":true,\"sorting\":false},\"price\":{\"visible\":true,\"sorting\":false},\"base_cost\":{\"visible\":true,\"sorting\":false},\"po_status\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"customer_group\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":\"desc\"}},\"positions\":{\"ids\":0,\"increment_id\":1,\"store_id\":2,\"created_at\":3,\"billing_name\":4,\"shipping_name\":5,\"base_grand_total\":6,\"grand_total\":7,\"status\":8,\"billing_address\":9,\"shipping_address\":10,\"shipping_information\":11,\"customer_email\":12,\"customer_group\":13,\"subtotal\":14,\"shipping_and_handling\":15,\"payment_method\":16,\"total_refunded\":17,\"name\":18,\"sku\":19,\"qty_ordered\":20,\"brand\":21,\"price_incl_tax\":22,\"price\":23,\"base_cost\":24,\"po_status\":25}}}','2024-12-03 13:42:02','2024-12-03 13:42:02'),(40,1,'mageworx_shippingrules_method_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"entity_id\":{\"visible\":true,\"sorting\":false},\"code\":{\"visible\":true,\"sorting\":false},\"title\":{\"visible\":true,\"sorting\":false},\"price\":{\"visible\":true,\"sorting\":false},\"min_price_threshold\":{\"visible\":true,\"sorting\":false},\"max_price_threshold\":{\"visible\":true,\"sorting\":false},\"cost\":{\"visible\":true,\"sorting\":false},\"estimated_delivery_time_min\":{\"visible\":true,\"sorting\":false},\"estimated_delivery_time_max\":{\"visible\":true,\"sorting\":false},\"estimated_delivery_time_message\":{\"visible\":true,\"sorting\":false},\"store_ids\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"carrier_code\":{\"visible\":true,\"sorting\":false},\"active\":{\"visible\":true,\"sorting\":false},\"disabled_without_valid_rates\":{\"visible\":true,\"sorting\":false},\"allow_free_shipping\":{\"visible\":true,\"sorting\":false},\"replaceable_title\":{\"visible\":true,\"sorting\":false},\"multiple_rates_price\":{\"visible\":true,\"sorting\":false},\"ignore_virtual_products_price\":{\"visible\":true,\"sorting\":false},\"use_price_with_discount\":{\"visible\":true,\"sorting\":false},\"show_estimated_delivery_time\":{\"visible\":true,\"sorting\":false},\"replaceable_estimated_delivery_time\":{\"visible\":true,\"sorting\":false},\"estimated_delivery_time_display_type\":{\"visible\":true,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"updated_at\":{\"visible\":true,\"sorting\":\"desc\"}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"entity_id\":1,\"use_price_with_discount\":2,\"ignore_virtual_products_price\":3,\"carrier_code\":4,\"code\":5,\"title\":6,\"active\":7,\"disabled_without_valid_rates\":8,\"allow_free_shipping\":9,\"replaceable_title\":10,\"multiple_rates_price\":11,\"price\":12,\"min_price_threshold\":13,\"cost\":14,\"max_price_threshold\":15,\"estimated_delivery_time_min\":16,\"estimated_delivery_time_max\":17,\"show_estimated_delivery_time\":18,\"replaceable_estimated_delivery_time\":19,\"estimated_delivery_time_display_type\":20,\"estimated_delivery_time_message\":21,\"created_at\":22,\"updated_at\":23,\"store_ids\":24,\"actions\":25}},\"value\":\"Default View\"}}}','2024-12-09 12:02:42','2024-12-09 12:02:42'),(41,1,'mageworx_shippingrules_method_listing','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"entity_id\":{\"visible\":true,\"sorting\":false},\"code\":{\"visible\":true,\"sorting\":false},\"title\":{\"visible\":true,\"sorting\":false},\"price\":{\"visible\":true,\"sorting\":false},\"min_price_threshold\":{\"visible\":true,\"sorting\":false},\"max_price_threshold\":{\"visible\":true,\"sorting\":false},\"cost\":{\"visible\":true,\"sorting\":false},\"estimated_delivery_time_min\":{\"visible\":true,\"sorting\":false},\"estimated_delivery_time_max\":{\"visible\":true,\"sorting\":false},\"estimated_delivery_time_message\":{\"visible\":true,\"sorting\":false},\"store_ids\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"carrier_code\":{\"visible\":true,\"sorting\":false},\"active\":{\"visible\":true,\"sorting\":false},\"disabled_without_valid_rates\":{\"visible\":true,\"sorting\":false},\"allow_free_shipping\":{\"visible\":true,\"sorting\":false},\"replaceable_title\":{\"visible\":true,\"sorting\":false},\"multiple_rates_price\":{\"visible\":true,\"sorting\":false},\"ignore_virtual_products_price\":{\"visible\":true,\"sorting\":false},\"use_price_with_discount\":{\"visible\":true,\"sorting\":false},\"show_estimated_delivery_time\":{\"visible\":true,\"sorting\":false},\"replaceable_estimated_delivery_time\":{\"visible\":true,\"sorting\":false},\"estimated_delivery_time_display_type\":{\"visible\":true,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"updated_at\":{\"visible\":true,\"sorting\":\"desc\"}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"entity_id\":1,\"use_price_with_discount\":2,\"ignore_virtual_products_price\":3,\"carrier_code\":4,\"code\":5,\"title\":6,\"active\":7,\"disabled_without_valid_rates\":8,\"allow_free_shipping\":9,\"replaceable_title\":10,\"multiple_rates_price\":11,\"price\":12,\"min_price_threshold\":13,\"cost\":14,\"max_price_threshold\":15,\"estimated_delivery_time_min\":16,\"estimated_delivery_time_max\":17,\"show_estimated_delivery_time\":18,\"replaceable_estimated_delivery_time\":19,\"estimated_delivery_time_display_type\":20,\"estimated_delivery_time_message\":21,\"created_at\":22,\"updated_at\":23,\"store_ids\":24,\"actions\":25}}}','2024-12-09 12:02:43','2024-12-09 12:02:43'),(42,1,'mageworx_shippingrules_carrier_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"carrier_id\":{\"visible\":true,\"sorting\":false},\"carrier_code\":{\"visible\":true,\"sorting\":false},\"name\":{\"visible\":true,\"sorting\":false},\"title\":{\"visible\":true,\"sorting\":false},\"sort_order\":{\"visible\":true,\"sorting\":false},\"store_ids\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"active\":{\"visible\":true,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"updated_at\":{\"visible\":true,\"sorting\":\"desc\"}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"carrier_id\":1,\"carrier_code\":2,\"name\":3,\"title\":4,\"active\":5,\"sort_order\":6,\"created_at\":7,\"updated_at\":8,\"store_ids\":9,\"actions\":10}},\"value\":\"Default View\"}}}','2024-12-09 12:03:00','2024-12-09 12:03:00'),(43,1,'mageworx_shippingrules_carrier_listing','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"carrier_id\":{\"visible\":true,\"sorting\":false},\"carrier_code\":{\"visible\":true,\"sorting\":false},\"name\":{\"visible\":true,\"sorting\":false},\"title\":{\"visible\":true,\"sorting\":false},\"sort_order\":{\"visible\":true,\"sorting\":false},\"store_ids\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"active\":{\"visible\":true,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"updated_at\":{\"visible\":true,\"sorting\":\"desc\"}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"carrier_id\":1,\"carrier_code\":2,\"name\":3,\"title\":4,\"active\":5,\"sort_order\":6,\"created_at\":7,\"updated_at\":8,\"store_ids\":9,\"actions\":10}}}','2024-12-09 12:03:01','2024-12-09 12:03:01'),(44,1,'mageworx_shippingrules_quote_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"rule_id\":{\"visible\":true,\"sorting\":\"desc\"},\"name\":{\"visible\":true,\"sorting\":false},\"description\":{\"visible\":true,\"sorting\":false},\"store\":{\"visible\":true,\"sorting\":false},\"sort_order\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"stop_rules_processing\":{\"visible\":true,\"sorting\":false},\"use_time\":{\"visible\":true,\"sorting\":false},\"from_date\":{\"visible\":true,\"sorting\":false},\"to_date\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"rule_id\":1,\"name\":2,\"description\":3,\"is_active\":4,\"stop_rules_processing\":5,\"store\":6,\"from_date\":7,\"to_date\":8,\"sort_order\":9,\"use_time\":10,\"actions\":11}},\"value\":\"Default View\"}}}','2024-12-09 12:04:07','2024-12-09 12:04:07'),(45,1,'mageworx_shippingrules_quote_listing','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"rule_id\":{\"visible\":true,\"sorting\":\"desc\"},\"name\":{\"visible\":true,\"sorting\":false},\"description\":{\"visible\":true,\"sorting\":false},\"store\":{\"visible\":true,\"sorting\":false},\"sort_order\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"stop_rules_processing\":{\"visible\":true,\"sorting\":false},\"use_time\":{\"visible\":true,\"sorting\":false},\"from_date\":{\"visible\":true,\"sorting\":false},\"to_date\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"rule_id\":1,\"name\":2,\"description\":3,\"is_active\":4,\"stop_rules_processing\":5,\"store\":6,\"from_date\":7,\"to_date\":8,\"sort_order\":9,\"use_time\":10,\"actions\":11}}}','2024-12-09 12:04:09','2024-12-09 12:04:09'),(46,1,'customer_listing','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"search\":{\"value\":\"\"},\"columns\":{\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"group_id\":{\"visible\":true,\"sorting\":false},\"billing_country_id\":{\"visible\":true,\"sorting\":false},\"website_id\":{\"visible\":true,\"sorting\":false},\"gender\":{\"visible\":true,\"sorting\":false},\"entity_id\":{\"visible\":true,\"sorting\":\"asc\"},\"name\":{\"visible\":true,\"sorting\":false},\"email\":{\"visible\":true,\"sorting\":false},\"billing_telephone\":{\"visible\":true,\"sorting\":false},\"billing_postcode\":{\"visible\":true,\"sorting\":false},\"billing_region\":{\"visible\":true,\"sorting\":false},\"confirmation\":{\"visible\":true,\"sorting\":false},\"created_in\":{\"visible\":true,\"sorting\":false},\"billing_full\":{\"visible\":false,\"sorting\":false},\"shipping_full\":{\"visible\":false,\"sorting\":false},\"taxvat\":{\"visible\":true,\"sorting\":false},\"billing_street\":{\"visible\":false,\"sorting\":false},\"billing_city\":{\"visible\":false,\"sorting\":false},\"billing_fax\":{\"visible\":false,\"sorting\":false},\"billing_vat_id\":{\"visible\":false,\"sorting\":false},\"billing_company\":{\"visible\":false,\"sorting\":false},\"billing_firstname\":{\"visible\":false,\"sorting\":false},\"billing_lastname\":{\"visible\":false,\"sorting\":false},\"lock_expires\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"dob\":{\"visible\":true,\"sorting\":false}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"entity_id\":1,\"name\":2,\"email\":3,\"group_id\":4,\"billing_telephone\":5,\"billing_postcode\":6,\"billing_country_id\":7,\"billing_region\":8,\"created_at\":9,\"website_id\":10,\"confirmation\":11,\"created_in\":12,\"billing_full\":13,\"shipping_full\":14,\"dob\":15,\"taxvat\":16,\"gender\":17,\"billing_street\":18,\"billing_city\":19,\"billing_fax\":20,\"billing_vat_id\":21,\"billing_company\":22,\"billing_firstname\":23,\"billing_lastname\":24,\"lock_expires\":25,\"actions\":26}}}','2024-12-11 10:38:41','2024-12-11 10:38:41'),(47,1,'customer_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"search\":{\"value\":\"\"},\"columns\":{\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"group_id\":{\"visible\":true,\"sorting\":false},\"billing_country_id\":{\"visible\":true,\"sorting\":false},\"website_id\":{\"visible\":true,\"sorting\":false},\"gender\":{\"visible\":true,\"sorting\":false},\"entity_id\":{\"visible\":true,\"sorting\":\"asc\"},\"name\":{\"visible\":true,\"sorting\":false},\"email\":{\"visible\":true,\"sorting\":false},\"billing_telephone\":{\"visible\":true,\"sorting\":false},\"billing_postcode\":{\"visible\":true,\"sorting\":false},\"billing_region\":{\"visible\":true,\"sorting\":false},\"confirmation\":{\"visible\":true,\"sorting\":false},\"created_in\":{\"visible\":true,\"sorting\":false},\"billing_full\":{\"visible\":false,\"sorting\":false},\"shipping_full\":{\"visible\":false,\"sorting\":false},\"taxvat\":{\"visible\":true,\"sorting\":false},\"billing_street\":{\"visible\":false,\"sorting\":false},\"billing_city\":{\"visible\":false,\"sorting\":false},\"billing_fax\":{\"visible\":false,\"sorting\":false},\"billing_vat_id\":{\"visible\":false,\"sorting\":false},\"billing_company\":{\"visible\":false,\"sorting\":false},\"billing_firstname\":{\"visible\":false,\"sorting\":false},\"billing_lastname\":{\"visible\":false,\"sorting\":false},\"lock_expires\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"dob\":{\"visible\":true,\"sorting\":false}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"entity_id\":1,\"name\":2,\"email\":3,\"group_id\":4,\"billing_telephone\":5,\"billing_postcode\":6,\"billing_country_id\":7,\"billing_region\":8,\"created_at\":9,\"website_id\":10,\"confirmation\":11,\"created_in\":12,\"billing_full\":13,\"shipping_full\":14,\"dob\":15,\"taxvat\":16,\"gender\":17,\"billing_street\":18,\"billing_city\":19,\"billing_fax\":20,\"billing_vat_id\":21,\"billing_company\":22,\"billing_firstname\":23,\"billing_lastname\":24,\"lock_expires\":25,\"actions\":26}},\"value\":\"Default View\"}}}','2024-12-11 10:38:58','2024-12-11 10:38:58'),(48,1,'sales_order_invoice_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"search\":{\"value\":\"\"},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"base_grand_total\":7,\"grand_total\":8,\"store_id\":9,\"billing_address\":10,\"shipping_address\":11,\"customer_name\":12,\"customer_email\":13,\"customer_group_id\":14,\"payment_method\":15,\"shipping_information\":16,\"subtotal\":17,\"shipping_and_handling\":18,\"actions\":19}},\"value\":\"Default View\"}}}','2024-12-27 14:52:58','2024-12-27 14:52:58'),(49,1,'sales_order_invoice_grid','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"search\":{\"value\":\"\"},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"base_grand_total\":7,\"grand_total\":8,\"store_id\":9,\"billing_address\":10,\"shipping_address\":11,\"customer_name\":12,\"customer_email\":13,\"customer_group_id\":14,\"payment_method\":15,\"shipping_information\":16,\"subtotal\":17,\"shipping_and_handling\":18,\"actions\":19}}}','2024-12-27 14:53:00','2024-12-27 14:53:00'),(50,1,'sales_order_creditmemo_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":false},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"adjustment_positive\":{\"visible\":false,\"sorting\":false},\"adjustment_negative\":{\"visible\":false,\"sorting\":false},\"order_base_grand_total\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"order_status\":{\"visible\":false,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"base_grand_total\":7,\"order_status\":8,\"store_id\":9,\"billing_address\":10,\"shipping_address\":11,\"customer_name\":12,\"customer_email\":13,\"customer_group_id\":14,\"payment_method\":15,\"shipping_information\":16,\"subtotal\":17,\"shipping_and_handling\":18,\"adjustment_positive\":19,\"adjustment_negative\":20,\"order_base_grand_total\":21,\"actions\":22}},\"value\":\"Default View\"}}}','2024-12-27 14:54:22','2024-12-27 14:54:22'),(51,1,'sales_order_creditmemo_grid','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":false},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"adjustment_positive\":{\"visible\":false,\"sorting\":false},\"adjustment_negative\":{\"visible\":false,\"sorting\":false},\"order_base_grand_total\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"order_status\":{\"visible\":false,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"base_grand_total\":7,\"order_status\":8,\"store_id\":9,\"billing_address\":10,\"shipping_address\":11,\"customer_name\":12,\"customer_email\":13,\"customer_group_id\":14,\"payment_method\":15,\"shipping_information\":16,\"subtotal\":17,\"shipping_and_handling\":18,\"adjustment_positive\":19,\"adjustment_negative\":20,\"order_base_grand_total\":21,\"actions\":22}}}','2024-12-27 14:54:23','2024-12-27 14:54:23'),(52,1,'url_rewrite_listing','current',0,NULL,'{\"current\":{\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"url_rewrite_id\":{\"visible\":true,\"sorting\":\"desc\"},\"store_id\":{\"visible\":true,\"sorting\":false},\"request_path\":{\"visible\":true,\"sorting\":false},\"target_path\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"redirect_type\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"url_rewrite_id\":1,\"store_id\":2,\"request_path\":3,\"target_path\":4,\"redirect_type\":5,\"actions\":6}}}','2025-01-09 09:40:45','2025-01-09 09:40:45'),(53,1,'url_rewrite_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"url_rewrite_id\":{\"visible\":true,\"sorting\":\"desc\"},\"store_id\":{\"visible\":true,\"sorting\":false},\"request_path\":{\"visible\":true,\"sorting\":false},\"target_path\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"redirect_type\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"url_rewrite_id\":1,\"store_id\":2,\"request_path\":3,\"target_path\":4,\"redirect_type\":5,\"actions\":6}},\"value\":\"Default View\"}}}','2025-01-09 09:40:52','2025-01-09 09:40:52'),(54,4,'sales_order_invoice_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"search\":{\"value\":\"\"},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"base_grand_total\":7,\"grand_total\":8,\"store_id\":9,\"billing_address\":10,\"shipping_address\":11,\"customer_name\":12,\"customer_email\":13,\"customer_group_id\":14,\"payment_method\":15,\"shipping_information\":16,\"subtotal\":17,\"shipping_and_handling\":18,\"actions\":19}},\"value\":\"Default View\"}}}','2025-01-09 10:08:02','2025-01-09 10:08:02'),(55,4,'sales_order_invoice_grid','current',0,NULL,'{\"current\":{\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"search\":{\"value\":\"\"},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"base_grand_total\":7,\"grand_total\":8,\"store_id\":9,\"billing_address\":10,\"shipping_address\":11,\"customer_name\":12,\"customer_email\":13,\"customer_group_id\":14,\"payment_method\":15,\"shipping_information\":16,\"subtotal\":17,\"shipping_and_handling\":18,\"actions\":19}}}','2025-01-09 10:08:04','2025-01-09 10:08:04'),(56,4,'sales_order_shipment_grid','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"shipping_name\":{\"visible\":true,\"sorting\":false},\"total_qty\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false},\"order_status\":{\"visible\":false,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"shipping_name\":5,\"total_qty\":6,\"order_status\":7,\"store_id\":8,\"customer_name\":9,\"customer_email\":10,\"customer_group_id\":11,\"billing_address\":12,\"shipping_address\":13,\"payment_method\":14,\"shipping_information\":15,\"actions\":16}}}','2025-01-09 10:08:15','2025-01-09 10:08:15'),(57,4,'sales_order_shipment_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"shipping_name\":{\"visible\":true,\"sorting\":false},\"total_qty\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false},\"order_status\":{\"visible\":false,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"shipping_name\":5,\"total_qty\":6,\"order_status\":7,\"store_id\":8,\"customer_name\":9,\"customer_email\":10,\"customer_group_id\":11,\"billing_address\":12,\"shipping_address\":13,\"payment_method\":14,\"shipping_information\":15,\"actions\":16}},\"value\":\"Default View\"}}}','2025-01-09 10:08:21','2025-01-09 10:08:21'),(58,1,'sales_order_view_creditmemo_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":false},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"adjustment_positive\":{\"visible\":false,\"sorting\":false},\"adjustment_negative\":{\"visible\":false,\"sorting\":false},\"order_base_grand_total\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"order_status\":{\"visible\":false,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"base_grand_total\":7,\"order_status\":8,\"store_id\":9,\"billing_address\":10,\"shipping_address\":11,\"customer_name\":12,\"customer_email\":13,\"customer_group_id\":14,\"payment_method\":15,\"shipping_information\":16,\"subtotal\":17,\"shipping_and_handling\":18,\"adjustment_positive\":19,\"adjustment_negative\":20,\"order_base_grand_total\":21,\"actions\":22}},\"value\":\"Default View\"}}}','2025-01-11 07:58:48','2025-01-11 07:58:48'),(59,1,'sales_order_view_invoice_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"grand_total\":7,\"store_id\":8,\"billing_address\":9,\"shipping_address\":10,\"customer_name\":11,\"customer_email\":12,\"customer_group_id\":13,\"payment_method\":14,\"shipping_information\":15,\"subtotal\":16,\"shipping_and_handling\":17,\"actions\":18}},\"value\":\"Default View\"}}}','2025-01-11 07:58:48','2025-01-11 07:58:48'),(60,1,'sales_order_view_shipment_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"shipping_name\":{\"visible\":true,\"sorting\":false},\"total_qty\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"order_status\":{\"visible\":false,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"shipping_name\":5,\"total_qty\":6,\"order_status\":7,\"store_id\":8,\"customer_name\":9,\"customer_email\":10,\"customer_group_id\":11,\"billing_address\":12,\"shipping_address\":13,\"payment_method\":14,\"shipping_information\":15,\"actions\":16},\"search\":{\"value\":\"\"}},\"value\":\"Default View\"}}}','2025-01-11 07:58:48','2025-01-11 07:58:48'),(61,1,'sales_order_view_invoice_grid','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"grand_total\":7,\"store_id\":8,\"billing_address\":9,\"shipping_address\":10,\"customer_name\":11,\"customer_email\":12,\"customer_group_id\":13,\"payment_method\":14,\"shipping_information\":15,\"subtotal\":16,\"shipping_and_handling\":17,\"actions\":18}}}','2025-01-11 07:58:48','2025-01-11 07:58:48'),(62,1,'sales_order_view_creditmemo_grid','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":false},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"adjustment_positive\":{\"visible\":false,\"sorting\":false},\"adjustment_negative\":{\"visible\":false,\"sorting\":false},\"order_base_grand_total\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"order_status\":{\"visible\":false,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"base_grand_total\":7,\"order_status\":8,\"store_id\":9,\"billing_address\":10,\"shipping_address\":11,\"customer_name\":12,\"customer_email\":13,\"customer_group_id\":14,\"payment_method\":15,\"shipping_information\":16,\"subtotal\":17,\"shipping_and_handling\":18,\"adjustment_positive\":19,\"adjustment_negative\":20,\"order_base_grand_total\":21,\"actions\":22}}}','2025-01-11 07:58:49','2025-01-11 07:58:49'),(63,1,'sales_order_view_shipment_grid','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"shipping_name\":{\"visible\":true,\"sorting\":false},\"total_qty\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"order_status\":{\"visible\":false,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"shipping_name\":5,\"total_qty\":6,\"order_status\":7,\"store_id\":8,\"customer_name\":9,\"customer_email\":10,\"customer_group_id\":11,\"billing_address\":12,\"shipping_address\":13,\"payment_method\":14,\"shipping_information\":15,\"actions\":16},\"search\":{\"value\":\"\"}}}','2025-01-11 07:58:49','2025-01-11 07:58:49'),(64,1,'sales_order_shipment_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"shipping_name\":{\"visible\":true,\"sorting\":false},\"total_qty\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"order_status\":{\"visible\":false,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"shipping_name\":5,\"total_qty\":6,\"order_status\":7,\"store_id\":8,\"customer_name\":9,\"customer_email\":10,\"customer_group_id\":11,\"billing_address\":12,\"shipping_address\":13,\"payment_method\":14,\"shipping_information\":15,\"actions\":16}},\"value\":\"Default View\"}}}','2025-01-14 09:40:58','2025-01-14 09:40:58'),(65,1,'sales_order_shipment_grid','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"shipping_name\":{\"visible\":true,\"sorting\":false},\"total_qty\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"order_status\":{\"visible\":false,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"shipping_name\":5,\"total_qty\":6,\"order_status\":7,\"store_id\":8,\"customer_name\":9,\"customer_email\":10,\"customer_group_id\":11,\"billing_address\":12,\"shipping_address\":13,\"payment_method\":14,\"shipping_information\":15,\"actions\":16}}}','2025-01-14 09:40:58','2025-01-14 09:40:58'),(66,5,'cms_page_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"columns\":{\"page_id\":{\"visible\":true,\"sorting\":\"asc\"},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keywords\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"page_layout\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"custom_theme\":{\"visible\":false,\"sorting\":false},\"custom_root_template\":{\"visible\":false,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":false},\"custom_theme_from\":{\"visible\":false,\"sorting\":false},\"custom_theme_to\":{\"visible\":false,\"sorting\":false}},\"displayMode\":\"grid\",\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"positions\":{\"ids\":0,\"page_id\":1,\"title\":2,\"identifier\":3,\"page_layout\":4,\"store_id\":5,\"is_active\":6,\"creation_time\":7,\"update_time\":8,\"custom_theme_from\":9,\"custom_theme_to\":10,\"custom_theme\":11,\"custom_root_template\":12,\"meta_title\":13,\"meta_keywords\":14,\"meta_description\":15,\"actions\":16}},\"value\":\"Default View\"}}}','2025-01-20 14:48:59','2025-01-20 14:48:59'),(67,5,'cms_page_listing','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"columns\":{\"page_id\":{\"visible\":true,\"sorting\":\"asc\"},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keywords\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"page_layout\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"custom_theme\":{\"visible\":false,\"sorting\":false},\"custom_root_template\":{\"visible\":false,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":false},\"custom_theme_from\":{\"visible\":false,\"sorting\":false},\"custom_theme_to\":{\"visible\":false,\"sorting\":false}},\"displayMode\":\"grid\",\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":30,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":30},\"positions\":{\"ids\":0,\"page_id\":1,\"title\":2,\"identifier\":3,\"page_layout\":4,\"store_id\":5,\"is_active\":6,\"creation_time\":7,\"update_time\":8,\"custom_theme_from\":9,\"custom_theme_to\":10,\"custom_theme\":11,\"custom_root_template\":12,\"meta_title\":13,\"meta_keywords\":14,\"meta_description\":15,\"actions\":16}}}','2025-01-20 14:49:00','2025-01-27 12:56:52'),(68,5,'product_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200},\"300\":{\"value\":300,\"label\":300,\"_value\":300,\"editable\":true}},\"value\":20},\"search\":{\"value\":\"3473-000\"},\"columns\":{\"entity_id\":{\"visible\":true,\"sorting\":\"asc\"},\"name\":{\"visible\":true,\"sorting\":false},\"sku\":{\"visible\":true,\"sorting\":false},\"price\":{\"visible\":true,\"sorting\":false},\"websites\":{\"visible\":true,\"sorting\":false},\"qty\":{\"visible\":true,\"sorting\":false},\"short_description\":{\"visible\":false,\"sorting\":false},\"special_price\":{\"visible\":false,\"sorting\":false},\"cost\":{\"visible\":false,\"sorting\":false},\"weight\":{\"visible\":false,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keyword\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"url_key\":{\"visible\":false,\"sorting\":false},\"msrp\":{\"visible\":false,\"sorting\":false},\"heat_output\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"type_id\":{\"visible\":true,\"sorting\":false},\"attribute_set_id\":{\"visible\":true,\"sorting\":false},\"visibility\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"manufacturer\":{\"visible\":false,\"sorting\":false},\"color\":{\"visible\":false,\"sorting\":false},\"custom_design\":{\"visible\":false,\"sorting\":false},\"page_layout\":{\"visible\":false,\"sorting\":false},\"country_of_manufacture\":{\"visible\":false,\"sorting\":false},\"custom_layout\":{\"visible\":false,\"sorting\":false},\"gift_message_available\":{\"visible\":false,\"sorting\":false},\"tax_class_id\":{\"visible\":false,\"sorting\":false},\"whirlpool_baths\":{\"visible\":true,\"sorting\":false},\"shower_baths\":{\"visible\":true,\"sorting\":false},\"top_rated\":{\"visible\":true,\"sorting\":false},\"available_shipping_methods\":{\"visible\":true,\"sorting\":false},\"updated_at\":{\"visible\":true,\"sorting\":false},\"special_from_date\":{\"visible\":false,\"sorting\":false},\"special_to_date\":{\"visible\":false,\"sorting\":false},\"news_from_date\":{\"visible\":false,\"sorting\":false},\"news_to_date\":{\"visible\":false,\"sorting\":false},\"custom_design_from\":{\"visible\":false,\"sorting\":false},\"custom_design_to\":{\"visible\":false,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"salable_quantity\":{\"visible\":true,\"sorting\":false},\"thumbnail\":{\"visible\":true,\"sorting\":false},\"pressure_bar\":{\"visible\":true,\"sorting\":false},\"offer\":{\"visible\":true,\"sorting\":false},\"cabinet_width\":{\"visible\":true,\"sorting\":false},\"material\":{\"visible\":true,\"sorting\":false},\"mount_type\":{\"visible\":true,\"sorting\":false},\"number_of_bowls\":{\"visible\":true,\"sorting\":false},\"products_by_category\":{\"visible\":true,\"sorting\":false},\"bath_length\":{\"visible\":true,\"sorting\":false},\"bath_style\":{\"visible\":true,\"sorting\":false},\"bath_type\":{\"visible\":true,\"sorting\":false},\"glass_thickness\":{\"visible\":true,\"sorting\":false},\"tap_style\":{\"visible\":true,\"sorting\":false},\"tap_type\":{\"visible\":true,\"sorting\":false},\"basin_width\":{\"visible\":true,\"sorting\":false},\"basin_depth\":{\"visible\":true,\"sorting\":false},\"flush_type\":{\"visible\":true,\"sorting\":false},\"toilet_width\":{\"visible\":true,\"sorting\":false},\"toilet_style\":{\"visible\":true,\"sorting\":false},\"toilet_projection\":{\"visible\":true,\"sorting\":false},\"toilet_full_height\":{\"visible\":true,\"sorting\":false},\"installation\":{\"visible\":true,\"sorting\":false},\"fuel_type\":{\"visible\":true,\"sorting\":false},\"colour\":{\"visible\":true,\"sorting\":false},\"built_type\":{\"visible\":true,\"sorting\":false},\"oven_type\":{\"visible\":true,\"sorting\":false},\"cleaning\":{\"visible\":true,\"sorting\":false},\"size\":{\"visible\":true,\"sorting\":false},\"number_of_cooking_zones\":{\"visible\":true,\"sorting\":false},\"hoods_type\":{\"visible\":true,\"sorting\":false},\"hob_type\":{\"visible\":true,\"sorting\":false},\"hoods_width_mm\":{\"visible\":true,\"sorting\":false},\"fire_width\":{\"visible\":true,\"sorting\":false},\"fire_type\":{\"visible\":true,\"sorting\":false},\"fire_style\":{\"visible\":true,\"sorting\":false},\"fire_frontage\":{\"visible\":true,\"sorting\":false},\"fit_type\":{\"visible\":true,\"sorting\":false},\"features\":{\"visible\":true,\"sorting\":false},\"height\":{\"visible\":true,\"sorting\":false},\"defrost_type\":{\"visible\":true,\"sorting\":false},\"unit_width\":{\"visible\":true,\"sorting\":false},\"configuration\":{\"visible\":true,\"sorting\":false},\"radiator_style\":{\"visible\":true,\"sorting\":false},\"output_btu\":{\"visible\":true,\"sorting\":false},\"radiator_height\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"entity_id\":1,\"thumbnail\":2,\"name\":3,\"type_id\":4,\"attribute_set_id\":5,\"sku\":6,\"price\":7,\"qty\":8,\"salable_quantity\":9,\"visibility\":10,\"status\":11,\"websites\":12,\"short_description\":13,\"special_price\":14,\"special_from_date\":15,\"special_to_date\":16,\"cost\":17,\"weight\":18,\"manufacturer\":19,\"meta_title\":20,\"meta_keyword\":21,\"meta_description\":22,\"color\":23,\"news_from_date\":24,\"news_to_date\":25,\"custom_design\":26,\"custom_design_from\":27,\"custom_design_to\":28,\"page_layout\":29,\"country_of_manufacture\":30,\"custom_layout\":31,\"url_key\":32,\"msrp\":33,\"gift_message_available\":34,\"tax_class_id\":35,\"whirlpool_baths\":36,\"shower_baths\":37,\"top_rated\":38,\"available_shipping_methods\":39,\"heat_output\":40,\"updated_at\":41,\"actions\":42,\"pressure_bar\":43,\"offer\":44,\"cabinet_width\":45,\"material\":46,\"mount_type\":47,\"number_of_bowls\":48,\"products_by_category\":49,\"bath_length\":50,\"bath_style\":51,\"bath_type\":52,\"glass_thickness\":53,\"tap_style\":54,\"tap_type\":55,\"basin_width\":56,\"basin_depth\":57,\"flush_type\":58,\"toilet_width\":59,\"toilet_style\":60,\"toilet_projection\":61,\"toilet_full_height\":62,\"installation\":63,\"fuel_type\":64,\"colour\":65,\"built_type\":66,\"oven_type\":67,\"cleaning\":68,\"size\":69,\"number_of_cooking_zones\":70,\"hoods_type\":71,\"hob_type\":72,\"hoods_width_mm\":73,\"fire_width\":74,\"fire_type\":75,\"fire_style\":76,\"fire_frontage\":77,\"fit_type\":78,\"features\":79,\"height\":80,\"defrost_type\":81,\"unit_width\":82,\"configuration\":83,\"radiator_style\":84,\"output_btu\":85,\"radiator_height\":86}},\"value\":\"Default View\"}}}','2025-01-20 14:52:26','2025-02-05 07:38:49'),(69,5,'product_listing','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200},\"300\":{\"value\":300,\"label\":300,\"_value\":300,\"editable\":true}},\"value\":20},\"search\":{\"value\":\"\"},\"columns\":{\"entity_id\":{\"visible\":true,\"sorting\":\"asc\"},\"name\":{\"visible\":true,\"sorting\":false},\"sku\":{\"visible\":true,\"sorting\":false},\"price\":{\"visible\":true,\"sorting\":false},\"websites\":{\"visible\":true,\"sorting\":false},\"qty\":{\"visible\":true,\"sorting\":false},\"short_description\":{\"visible\":false,\"sorting\":false},\"special_price\":{\"visible\":false,\"sorting\":false},\"cost\":{\"visible\":false,\"sorting\":false},\"weight\":{\"visible\":false,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keyword\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"url_key\":{\"visible\":false,\"sorting\":false},\"msrp\":{\"visible\":false,\"sorting\":false},\"heat_output\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"type_id\":{\"visible\":true,\"sorting\":false},\"attribute_set_id\":{\"visible\":true,\"sorting\":false},\"visibility\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"manufacturer\":{\"visible\":false,\"sorting\":false},\"color\":{\"visible\":false,\"sorting\":false},\"custom_design\":{\"visible\":false,\"sorting\":false},\"page_layout\":{\"visible\":false,\"sorting\":false},\"country_of_manufacture\":{\"visible\":false,\"sorting\":false},\"custom_layout\":{\"visible\":false,\"sorting\":false},\"gift_message_available\":{\"visible\":false,\"sorting\":false},\"tax_class_id\":{\"visible\":false,\"sorting\":false},\"whirlpool_baths\":{\"visible\":true,\"sorting\":false},\"shower_baths\":{\"visible\":true,\"sorting\":false},\"top_rated\":{\"visible\":true,\"sorting\":false},\"available_shipping_methods\":{\"visible\":true,\"sorting\":false},\"updated_at\":{\"visible\":true,\"sorting\":false},\"special_from_date\":{\"visible\":false,\"sorting\":false},\"special_to_date\":{\"visible\":false,\"sorting\":false},\"news_from_date\":{\"visible\":false,\"sorting\":false},\"news_to_date\":{\"visible\":false,\"sorting\":false},\"custom_design_from\":{\"visible\":false,\"sorting\":false},\"custom_design_to\":{\"visible\":false,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"salable_quantity\":{\"visible\":true,\"sorting\":false},\"thumbnail\":{\"visible\":true,\"sorting\":false},\"pressure_bar\":{\"visible\":true,\"sorting\":false},\"offer\":{\"visible\":true,\"sorting\":false},\"cabinet_width\":{\"visible\":true,\"sorting\":false},\"material\":{\"visible\":true,\"sorting\":false},\"mount_type\":{\"visible\":true,\"sorting\":false},\"number_of_bowls\":{\"visible\":true,\"sorting\":false},\"products_by_category\":{\"visible\":true,\"sorting\":false},\"bath_length\":{\"visible\":true,\"sorting\":false},\"bath_style\":{\"visible\":true,\"sorting\":false},\"bath_type\":{\"visible\":true,\"sorting\":false},\"glass_thickness\":{\"visible\":true,\"sorting\":false},\"tap_style\":{\"visible\":true,\"sorting\":false},\"tap_type\":{\"visible\":true,\"sorting\":false},\"basin_width\":{\"visible\":true,\"sorting\":false},\"basin_depth\":{\"visible\":true,\"sorting\":false},\"flush_type\":{\"visible\":true,\"sorting\":false},\"toilet_width\":{\"visible\":true,\"sorting\":false},\"toilet_style\":{\"visible\":true,\"sorting\":false},\"toilet_projection\":{\"visible\":true,\"sorting\":false},\"toilet_full_height\":{\"visible\":true,\"sorting\":false},\"installation\":{\"visible\":true,\"sorting\":false},\"fuel_type\":{\"visible\":true,\"sorting\":false},\"colour\":{\"visible\":true,\"sorting\":false},\"built_type\":{\"visible\":true,\"sorting\":false},\"oven_type\":{\"visible\":true,\"sorting\":false},\"cleaning\":{\"visible\":true,\"sorting\":false},\"size\":{\"visible\":true,\"sorting\":false},\"number_of_cooking_zones\":{\"visible\":true,\"sorting\":false},\"hoods_type\":{\"visible\":true,\"sorting\":false},\"hob_type\":{\"visible\":true,\"sorting\":false},\"hoods_width_mm\":{\"visible\":true,\"sorting\":false},\"fire_width\":{\"visible\":true,\"sorting\":false},\"fire_type\":{\"visible\":true,\"sorting\":false},\"fire_style\":{\"visible\":true,\"sorting\":false},\"fire_frontage\":{\"visible\":true,\"sorting\":false},\"fit_type\":{\"visible\":true,\"sorting\":false},\"features\":{\"visible\":true,\"sorting\":false},\"height\":{\"visible\":true,\"sorting\":false},\"defrost_type\":{\"visible\":true,\"sorting\":false},\"unit_width\":{\"visible\":true,\"sorting\":false},\"configuration\":{\"visible\":true,\"sorting\":false},\"radiator_style\":{\"visible\":true,\"sorting\":false},\"output_btu\":{\"visible\":true,\"sorting\":false},\"radiator_height\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"entity_id\":1,\"thumbnail\":2,\"name\":3,\"type_id\":4,\"attribute_set_id\":5,\"sku\":6,\"price\":7,\"qty\":8,\"salable_quantity\":9,\"visibility\":10,\"status\":11,\"websites\":12,\"short_description\":13,\"special_price\":14,\"special_from_date\":15,\"special_to_date\":16,\"cost\":17,\"weight\":18,\"manufacturer\":19,\"meta_title\":20,\"meta_keyword\":21,\"meta_description\":22,\"color\":23,\"news_from_date\":24,\"news_to_date\":25,\"custom_design\":26,\"custom_design_from\":27,\"custom_design_to\":28,\"page_layout\":29,\"country_of_manufacture\":30,\"custom_layout\":31,\"url_key\":32,\"msrp\":33,\"gift_message_available\":34,\"tax_class_id\":35,\"whirlpool_baths\":36,\"shower_baths\":37,\"top_rated\":38,\"available_shipping_methods\":39,\"heat_output\":40,\"updated_at\":41,\"actions\":42,\"pressure_bar\":43,\"offer\":44,\"cabinet_width\":45,\"material\":46,\"mount_type\":47,\"number_of_bowls\":48,\"products_by_category\":49,\"bath_length\":50,\"bath_style\":51,\"bath_type\":52,\"glass_thickness\":53,\"tap_style\":54,\"tap_type\":55,\"basin_width\":56,\"basin_depth\":57,\"flush_type\":58,\"toilet_width\":59,\"toilet_style\":60,\"toilet_projection\":61,\"toilet_full_height\":62,\"installation\":63,\"fuel_type\":64,\"colour\":65,\"built_type\":66,\"oven_type\":67,\"cleaning\":68,\"size\":69,\"number_of_cooking_zones\":70,\"hoods_type\":71,\"hob_type\":72,\"hoods_width_mm\":73,\"fire_width\":74,\"fire_type\":75,\"fire_style\":76,\"fire_frontage\":77,\"fit_type\":78,\"features\":79,\"height\":80,\"defrost_type\":81,\"unit_width\":82,\"configuration\":83,\"radiator_style\":84,\"output_btu\":85,\"radiator_height\":86}}}','2025-01-20 14:52:27','2025-02-05 07:38:54'),(70,5,'design_config_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"default\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"store_website_id\":{\"visible\":true,\"sorting\":false},\"store_group_id\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"theme_theme_id\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"default\":0,\"store_website_id\":1,\"store_group_id\":2,\"store_id\":3,\"theme_theme_id\":4,\"actions\":5}},\"value\":\"Default View\"}}}','2025-01-20 14:53:30','2025-01-20 14:53:30'),(71,5,'design_config_listing','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"default\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"store_website_id\":{\"visible\":true,\"sorting\":false},\"store_group_id\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"theme_theme_id\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"default\":0,\"store_website_id\":1,\"store_group_id\":2,\"store_id\":3,\"theme_theme_id\":4,\"actions\":5}}}','2025-01-20 14:53:31','2025-01-20 14:53:31'),(72,5,'cms_block_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"columns\":{\"block_id\":{\"visible\":true,\"sorting\":\"asc\"},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":false}},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"block_id\":1,\"title\":2,\"identifier\":3,\"store_id\":4,\"is_active\":5,\"creation_time\":6,\"update_time\":7,\"actions\":8}},\"value\":\"Default View\"}}}','2025-01-20 14:53:52','2025-01-20 14:53:52'),(73,5,'cms_block_listing','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"idea\"},\"columns\":{\"block_id\":{\"visible\":true,\"sorting\":false},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":\"desc\"},\"update_time\":{\"visible\":true,\"sorting\":false}},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":50,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":50},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"block_id\":1,\"title\":2,\"identifier\":3,\"store_id\":4,\"is_active\":5,\"creation_time\":6,\"update_time\":7,\"actions\":8}}}','2025-01-20 14:53:53','2025-02-03 16:01:57'),(74,6,'product_listing','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"search\":{\"value\":\"\"},\"columns\":{\"entity_id\":{\"visible\":true,\"sorting\":\"asc\"},\"name\":{\"visible\":true,\"sorting\":false},\"sku\":{\"visible\":true,\"sorting\":false},\"price\":{\"visible\":true,\"sorting\":false},\"websites\":{\"visible\":true,\"sorting\":false},\"qty\":{\"visible\":true,\"sorting\":false},\"short_description\":{\"visible\":false,\"sorting\":false},\"special_price\":{\"visible\":false,\"sorting\":false},\"cost\":{\"visible\":false,\"sorting\":false},\"weight\":{\"visible\":false,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keyword\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"url_key\":{\"visible\":false,\"sorting\":false},\"msrp\":{\"visible\":false,\"sorting\":false},\"heat_output\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"type_id\":{\"visible\":true,\"sorting\":false},\"attribute_set_id\":{\"visible\":true,\"sorting\":false},\"visibility\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"manufacturer\":{\"visible\":false,\"sorting\":false},\"color\":{\"visible\":false,\"sorting\":false},\"custom_design\":{\"visible\":false,\"sorting\":false},\"page_layout\":{\"visible\":false,\"sorting\":false},\"country_of_manufacture\":{\"visible\":false,\"sorting\":false},\"custom_layout\":{\"visible\":false,\"sorting\":false},\"gift_message_available\":{\"visible\":false,\"sorting\":false},\"tax_class_id\":{\"visible\":false,\"sorting\":false},\"whirlpool_baths\":{\"visible\":true,\"sorting\":false},\"shower_baths\":{\"visible\":true,\"sorting\":false},\"top_rated\":{\"visible\":true,\"sorting\":false},\"available_shipping_methods\":{\"visible\":true,\"sorting\":false},\"salable_quantity\":{\"visible\":true,\"sorting\":false},\"thumbnail\":{\"visible\":true,\"sorting\":false},\"updated_at\":{\"visible\":true,\"sorting\":false},\"special_from_date\":{\"visible\":false,\"sorting\":false},\"special_to_date\":{\"visible\":false,\"sorting\":false},\"news_from_date\":{\"visible\":false,\"sorting\":false},\"news_to_date\":{\"visible\":false,\"sorting\":false},\"custom_design_from\":{\"visible\":false,\"sorting\":false},\"custom_design_to\":{\"visible\":false,\"sorting\":false}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"entity_id\":1,\"thumbnail\":2,\"name\":3,\"type_id\":4,\"attribute_set_id\":5,\"sku\":6,\"price\":7,\"qty\":8,\"salable_quantity\":9,\"visibility\":10,\"status\":11,\"websites\":12,\"short_description\":13,\"special_price\":14,\"special_from_date\":15,\"special_to_date\":16,\"cost\":17,\"weight\":18,\"manufacturer\":19,\"meta_title\":20,\"meta_keyword\":21,\"meta_description\":22,\"color\":23,\"news_from_date\":24,\"news_to_date\":25,\"custom_design\":26,\"custom_design_from\":27,\"custom_design_to\":28,\"page_layout\":29,\"country_of_manufacture\":30,\"custom_layout\":31,\"url_key\":32,\"msrp\":33,\"gift_message_available\":34,\"tax_class_id\":35,\"whirlpool_baths\":36,\"shower_baths\":37,\"top_rated\":38,\"available_shipping_methods\":39,\"heat_output\":40,\"updated_at\":41,\"actions\":42}}}','2025-01-22 06:11:19','2025-01-22 06:11:19'),(75,6,'product_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"search\":{\"value\":\"\"},\"columns\":{\"entity_id\":{\"visible\":true,\"sorting\":\"asc\"},\"name\":{\"visible\":true,\"sorting\":false},\"sku\":{\"visible\":true,\"sorting\":false},\"price\":{\"visible\":true,\"sorting\":false},\"websites\":{\"visible\":true,\"sorting\":false},\"qty\":{\"visible\":true,\"sorting\":false},\"short_description\":{\"visible\":false,\"sorting\":false},\"special_price\":{\"visible\":false,\"sorting\":false},\"cost\":{\"visible\":false,\"sorting\":false},\"weight\":{\"visible\":false,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keyword\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"url_key\":{\"visible\":false,\"sorting\":false},\"msrp\":{\"visible\":false,\"sorting\":false},\"heat_output\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"type_id\":{\"visible\":true,\"sorting\":false},\"attribute_set_id\":{\"visible\":true,\"sorting\":false},\"visibility\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"manufacturer\":{\"visible\":false,\"sorting\":false},\"color\":{\"visible\":false,\"sorting\":false},\"custom_design\":{\"visible\":false,\"sorting\":false},\"page_layout\":{\"visible\":false,\"sorting\":false},\"country_of_manufacture\":{\"visible\":false,\"sorting\":false},\"custom_layout\":{\"visible\":false,\"sorting\":false},\"gift_message_available\":{\"visible\":false,\"sorting\":false},\"tax_class_id\":{\"visible\":false,\"sorting\":false},\"whirlpool_baths\":{\"visible\":true,\"sorting\":false},\"shower_baths\":{\"visible\":true,\"sorting\":false},\"top_rated\":{\"visible\":true,\"sorting\":false},\"available_shipping_methods\":{\"visible\":true,\"sorting\":false},\"salable_quantity\":{\"visible\":true,\"sorting\":false},\"thumbnail\":{\"visible\":true,\"sorting\":false},\"updated_at\":{\"visible\":true,\"sorting\":false},\"special_from_date\":{\"visible\":false,\"sorting\":false},\"special_to_date\":{\"visible\":false,\"sorting\":false},\"news_from_date\":{\"visible\":false,\"sorting\":false},\"news_to_date\":{\"visible\":false,\"sorting\":false},\"custom_design_from\":{\"visible\":false,\"sorting\":false},\"custom_design_to\":{\"visible\":false,\"sorting\":false}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"entity_id\":1,\"thumbnail\":2,\"name\":3,\"type_id\":4,\"attribute_set_id\":5,\"sku\":6,\"price\":7,\"qty\":8,\"salable_quantity\":9,\"visibility\":10,\"status\":11,\"websites\":12,\"short_description\":13,\"special_price\":14,\"special_from_date\":15,\"special_to_date\":16,\"cost\":17,\"weight\":18,\"manufacturer\":19,\"meta_title\":20,\"meta_keyword\":21,\"meta_description\":22,\"color\":23,\"news_from_date\":24,\"news_to_date\":25,\"custom_design\":26,\"custom_design_from\":27,\"custom_design_to\":28,\"page_layout\":29,\"country_of_manufacture\":30,\"custom_layout\":31,\"url_key\":32,\"msrp\":33,\"gift_message_available\":34,\"tax_class_id\":35,\"whirlpool_baths\":36,\"shower_baths\":37,\"top_rated\":38,\"available_shipping_methods\":39,\"heat_output\":40,\"updated_at\":41,\"actions\":42}},\"value\":\"Default View\"}}}','2025-01-22 06:11:31','2025-01-22 06:11:31'),(76,5,'url_rewrite_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"url_rewrite_id\":{\"visible\":true,\"sorting\":\"desc\"},\"store_id\":{\"visible\":true,\"sorting\":false},\"request_path\":{\"visible\":true,\"sorting\":false},\"target_path\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"redirect_type\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"url_rewrite_id\":1,\"store_id\":2,\"request_path\":3,\"target_path\":4,\"redirect_type\":5,\"actions\":6}},\"value\":\"Default View\"}}}','2025-01-27 08:39:15','2025-01-27 08:39:15'),(77,5,'url_rewrite_listing','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true,\"request_path\":\"contact\"}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"url_rewrite_id\":{\"visible\":true,\"sorting\":\"desc\"},\"store_id\":{\"visible\":true,\"sorting\":false},\"request_path\":{\"visible\":true,\"sorting\":false},\"target_path\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"redirect_type\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"url_rewrite_id\":1,\"store_id\":2,\"request_path\":3,\"target_path\":4,\"redirect_type\":5,\"actions\":6}}}','2025-01-27 08:39:17','2025-01-27 13:09:21'),(78,5,'adobe_stock_images_listing','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":32,\"current\":1,\"value\":32},\"columns\":{\"relevance\":{\"visible\":false,\"sorting\":false},\"creation\":{\"visible\":false,\"sorting\":false},\"popularity\":{\"visible\":false,\"sorting\":false},\"nb_downloads\":{\"visible\":false,\"sorting\":false},\"undiscovered\":{\"visible\":false,\"sorting\":false},\"thumbnail_url\":{\"visible\":true,\"sorting\":false},\"overlay\":{\"visible\":true,\"sorting\":false},\"preview\":{\"visible\":true,\"sorting\":false,\"lastOpenedImage\":false}},\"displayMode\":\"grid\",\"positions\":{\"overlay\":0,\"thumbnail_url\":1,\"preview\":2,\"relevance\":3,\"creation\":4,\"popularity\":5,\"nb_downloads\":6,\"undiscovered\":7}}}','2025-01-27 11:42:21','2025-01-27 11:42:25'),(79,5,'media_gallery_listing','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true,\"path\":\"wysiwyg\"}},\"paging\":{\"pageSize\":\"32\",\"current\":1,\"options\":{\"32\":{\"value\":32,\"label\":\"32\"},\"48\":{\"value\":48,\"label\":\"48\"},\"64\":{\"value\":64,\"label\":\"64\"}},\"value\":\"32\"},\"columns\":{\"newest_first\":{\"visible\":false,\"sorting\":false},\"oldest_first\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":false,\"sorting\":false},\"path\":{\"visible\":false,\"sorting\":false},\"directory_desc\":{\"visible\":false,\"sorting\":false},\"directory_asc\":{\"visible\":false,\"sorting\":false},\"title\":{\"visible\":false,\"sorting\":false},\"name_az\":{\"visible\":false,\"sorting\":false},\"name_za\":{\"visible\":false,\"sorting\":false},\"source\":{\"visible\":false,\"sorting\":false},\"overlay\":{\"visible\":true,\"sorting\":false},\"thumbnail_url\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"source\":0,\"overlay\":1,\"thumbnail_url\":2,\"newest_first\":3,\"oldest_first\":4,\"created_at\":5,\"path\":6,\"directory_desc\":7,\"directory_asc\":8,\"title\":9,\"name_az\":10,\"name_za\":11}}}','2025-01-27 11:42:24','2025-01-27 11:42:28'),(80,5,'adobe_stock_images_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":32,\"current\":1,\"value\":32},\"columns\":{\"relevance\":{\"visible\":false,\"sorting\":false},\"creation\":{\"visible\":false,\"sorting\":false},\"popularity\":{\"visible\":false,\"sorting\":false},\"nb_downloads\":{\"visible\":false,\"sorting\":false},\"undiscovered\":{\"visible\":false,\"sorting\":false},\"thumbnail_url\":{\"visible\":true,\"sorting\":false},\"overlay\":{\"visible\":true,\"sorting\":false},\"preview\":{\"visible\":true,\"sorting\":false,\"lastOpenedImage\":false}},\"displayMode\":\"grid\",\"positions\":{\"overlay\":0,\"thumbnail_url\":1,\"preview\":2,\"relevance\":3,\"creation\":4,\"popularity\":5,\"nb_downloads\":6,\"undiscovered\":7}},\"value\":\"Default View\"}}}','2025-01-27 11:42:25','2025-01-27 11:42:25'),(81,5,'media_gallery_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":\"32\",\"current\":1,\"options\":{\"32\":{\"value\":32,\"label\":\"32\"},\"48\":{\"value\":48,\"label\":\"48\"},\"64\":{\"value\":64,\"label\":\"64\"}},\"value\":\"32\"},\"columns\":{\"newest_first\":{\"visible\":false,\"sorting\":false},\"oldest_first\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":false,\"sorting\":false},\"path\":{\"visible\":false,\"sorting\":false},\"directory_desc\":{\"visible\":false,\"sorting\":false},\"directory_asc\":{\"visible\":false,\"sorting\":false},\"title\":{\"visible\":false,\"sorting\":false},\"name_az\":{\"visible\":false,\"sorting\":false},\"name_za\":{\"visible\":false,\"sorting\":false},\"source\":{\"visible\":false,\"sorting\":false},\"overlay\":{\"visible\":true,\"sorting\":false},\"thumbnail_url\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"source\":0,\"overlay\":1,\"thumbnail_url\":2,\"newest_first\":3,\"oldest_first\":4,\"created_at\":5,\"path\":6,\"directory_desc\":7,\"directory_asc\":8,\"title\":9,\"name_az\":10,\"name_za\":11}},\"value\":\"Default View\"}}}','2025-01-27 11:42:25','2025-01-27 11:42:25'),(82,5,'design_theme_listing','current',0,NULL,'{\"current\":{\"columns\":{\"theme_id\":{\"visible\":false,\"sorting\":\"asc\"},\"theme_title\":{\"visible\":true,\"sorting\":false},\"parent_theme_title\":{\"visible\":true,\"sorting\":false},\"theme_path\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"theme_id\":0,\"theme_title\":1,\"parent_theme_title\":2,\"theme_path\":3,\"actions\":4},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20}}}','2025-01-27 16:56:27','2025-01-27 16:56:30'),(83,5,'design_theme_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"columns\":{\"theme_id\":{\"visible\":false,\"sorting\":\"asc\"},\"theme_title\":{\"visible\":true,\"sorting\":false},\"parent_theme_title\":{\"visible\":true,\"sorting\":false},\"theme_path\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"theme_id\":0,\"theme_title\":1,\"parent_theme_title\":2,\"theme_path\":3,\"actions\":4},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20}},\"value\":\"Default View\"}}}','2025-01-27 16:56:30','2025-01-27 16:56:30'),(84,5,'mageworx_shippingrules_quote_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"rule_id\":{\"visible\":true,\"sorting\":\"desc\"},\"name\":{\"visible\":true,\"sorting\":false},\"description\":{\"visible\":true,\"sorting\":false},\"store\":{\"visible\":true,\"sorting\":false},\"sort_order\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"stop_rules_processing\":{\"visible\":true,\"sorting\":false},\"use_time\":{\"visible\":true,\"sorting\":false},\"from_date\":{\"visible\":true,\"sorting\":false},\"to_date\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"rule_id\":1,\"name\":2,\"description\":3,\"is_active\":4,\"stop_rules_processing\":5,\"store\":6,\"from_date\":7,\"to_date\":8,\"sort_order\":9,\"use_time\":10,\"actions\":11}},\"value\":\"Default View\"}}}','2025-01-28 08:38:40','2025-01-28 08:38:40'),(85,5,'mageworx_shippingrules_quote_listing','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"rule_id\":{\"visible\":true,\"sorting\":\"desc\"},\"name\":{\"visible\":true,\"sorting\":false},\"description\":{\"visible\":true,\"sorting\":false},\"store\":{\"visible\":true,\"sorting\":false},\"sort_order\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"stop_rules_processing\":{\"visible\":true,\"sorting\":false},\"use_time\":{\"visible\":true,\"sorting\":false},\"from_date\":{\"visible\":true,\"sorting\":false},\"to_date\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"rule_id\":1,\"name\":2,\"description\":3,\"is_active\":4,\"stop_rules_processing\":5,\"store\":6,\"from_date\":7,\"to_date\":8,\"sort_order\":9,\"use_time\":10,\"actions\":11}}}','2025-01-28 08:38:42','2025-01-28 08:38:42'),(86,7,'cms_page_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"page_layout\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"custom_theme\":{\"visible\":false,\"sorting\":false},\"custom_root_template\":{\"visible\":false,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":false},\"custom_theme_from\":{\"visible\":false,\"sorting\":false},\"custom_theme_to\":{\"visible\":false,\"sorting\":false},\"page_id\":{\"visible\":true,\"sorting\":\"asc\"},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keywords\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false}},\"positions\":{\"ids\":0,\"page_id\":1,\"title\":2,\"identifier\":3,\"page_layout\":4,\"store_id\":5,\"is_active\":6,\"creation_time\":7,\"update_time\":8,\"custom_theme_from\":9,\"custom_theme_to\":10,\"custom_theme\":11,\"custom_root_template\":12,\"meta_title\":13,\"meta_keywords\":14,\"meta_description\":15,\"actions\":16},\"displayMode\":\"grid\"},\"value\":\"Default View\"}}}','2025-01-28 13:04:27','2025-01-28 13:04:27'),(87,7,'cms_page_listing','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"page_layout\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"custom_theme\":{\"visible\":false,\"sorting\":false},\"custom_root_template\":{\"visible\":false,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":false},\"custom_theme_from\":{\"visible\":false,\"sorting\":false},\"custom_theme_to\":{\"visible\":false,\"sorting\":false},\"page_id\":{\"visible\":true,\"sorting\":\"asc\"},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"meta_title\":{\"visible\":false,\"sorting\":false},\"meta_keywords\":{\"visible\":false,\"sorting\":false},\"meta_description\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false}},\"positions\":{\"ids\":0,\"page_id\":1,\"title\":2,\"identifier\":3,\"page_layout\":4,\"store_id\":5,\"is_active\":6,\"creation_time\":7,\"update_time\":8,\"custom_theme_from\":9,\"custom_theme_to\":10,\"custom_theme\":11,\"custom_root_template\":12,\"meta_title\":13,\"meta_keywords\":14,\"meta_description\":15,\"actions\":16},\"displayMode\":\"grid\"}}','2025-01-28 13:04:28','2025-01-28 13:04:28'),(88,7,'cms_block_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":false},\"block_id\":{\"visible\":true,\"sorting\":\"asc\"},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false}},\"positions\":{\"ids\":0,\"block_id\":1,\"title\":2,\"identifier\":3,\"store_id\":4,\"is_active\":5,\"creation_time\":6,\"update_time\":7,\"actions\":8},\"displayMode\":\"grid\"},\"value\":\"Default View\"}}}','2025-01-28 13:04:30','2025-01-28 13:04:30'),(89,7,'cms_block_listing','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":50,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":50},\"columns\":{\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"is_active\":{\"visible\":true,\"sorting\":false},\"creation_time\":{\"visible\":true,\"sorting\":false},\"update_time\":{\"visible\":true,\"sorting\":false},\"block_id\":{\"visible\":true,\"sorting\":\"desc\"},\"title\":{\"visible\":true,\"sorting\":false},\"identifier\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false}},\"positions\":{\"ids\":0,\"block_id\":1,\"title\":2,\"identifier\":3,\"store_id\":4,\"is_active\":5,\"creation_time\":6,\"update_time\":7,\"actions\":8},\"displayMode\":\"grid\"}}','2025-01-28 13:04:32','2025-01-28 13:05:18'),(90,7,'adobe_stock_images_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":32,\"current\":1,\"value\":32},\"columns\":{\"relevance\":{\"visible\":false,\"sorting\":false},\"creation\":{\"visible\":false,\"sorting\":false},\"popularity\":{\"visible\":false,\"sorting\":false},\"nb_downloads\":{\"visible\":false,\"sorting\":false},\"undiscovered\":{\"visible\":false,\"sorting\":false},\"thumbnail_url\":{\"visible\":true,\"sorting\":false},\"preview\":{\"visible\":true,\"sorting\":false,\"lastOpenedImage\":false},\"overlay\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"overlay\":0,\"thumbnail_url\":1,\"preview\":2,\"relevance\":3,\"creation\":4,\"popularity\":5,\"nb_downloads\":6,\"undiscovered\":7}},\"value\":\"Default View\"}}}','2025-01-28 13:06:03','2025-01-28 13:06:03'),(91,7,'media_gallery_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"newest_first\":{\"visible\":false,\"sorting\":false},\"oldest_first\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":false,\"sorting\":false},\"path\":{\"visible\":false,\"sorting\":false},\"directory_desc\":{\"visible\":false,\"sorting\":false},\"directory_asc\":{\"visible\":false,\"sorting\":false},\"title\":{\"visible\":false,\"sorting\":false},\"name_az\":{\"visible\":false,\"sorting\":false},\"name_za\":{\"visible\":false,\"sorting\":false},\"source\":{\"visible\":false,\"sorting\":false},\"overlay\":{\"visible\":true,\"sorting\":false},\"thumbnail_url\":{\"visible\":true,\"sorting\":false}},\"paging\":{\"pageSize\":\"32\",\"current\":1,\"options\":{\"32\":{\"value\":32,\"label\":\"32\"},\"48\":{\"value\":48,\"label\":\"48\"},\"64\":{\"value\":64,\"label\":\"64\"}},\"value\":\"32\"},\"displayMode\":\"grid\",\"positions\":{\"source\":0,\"overlay\":1,\"thumbnail_url\":2,\"newest_first\":3,\"oldest_first\":4,\"created_at\":5,\"path\":6,\"directory_desc\":7,\"directory_asc\":8,\"title\":9,\"name_az\":10,\"name_za\":11}},\"value\":\"Default View\"}}}','2025-01-28 13:06:03','2025-01-28 13:06:03'),(92,7,'adobe_stock_images_listing','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":32,\"current\":1,\"value\":32},\"columns\":{\"relevance\":{\"visible\":false,\"sorting\":false},\"creation\":{\"visible\":false,\"sorting\":false},\"popularity\":{\"visible\":false,\"sorting\":false},\"nb_downloads\":{\"visible\":false,\"sorting\":false},\"undiscovered\":{\"visible\":false,\"sorting\":false},\"thumbnail_url\":{\"visible\":true,\"sorting\":false},\"preview\":{\"visible\":true,\"sorting\":false,\"lastOpenedImage\":false},\"overlay\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"overlay\":0,\"thumbnail_url\":1,\"preview\":2,\"relevance\":3,\"creation\":4,\"popularity\":5,\"nb_downloads\":6,\"undiscovered\":7}}}','2025-01-28 13:06:04','2025-01-28 13:06:04'),(93,7,'media_gallery_listing','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true,\"path\":\"wysiwyg\"}},\"columns\":{\"newest_first\":{\"visible\":false,\"sorting\":false},\"oldest_first\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":false,\"sorting\":false},\"path\":{\"visible\":false,\"sorting\":false},\"directory_desc\":{\"visible\":false,\"sorting\":false},\"directory_asc\":{\"visible\":false,\"sorting\":false},\"title\":{\"visible\":false,\"sorting\":false},\"name_az\":{\"visible\":false,\"sorting\":false},\"name_za\":{\"visible\":false,\"sorting\":false},\"source\":{\"visible\":false,\"sorting\":false},\"overlay\":{\"visible\":true,\"sorting\":false},\"thumbnail_url\":{\"visible\":true,\"sorting\":false}},\"paging\":{\"pageSize\":\"32\",\"current\":1,\"options\":{\"32\":{\"value\":32,\"label\":\"32\"},\"48\":{\"value\":48,\"label\":\"48\"},\"64\":{\"value\":64,\"label\":\"64\"}},\"value\":\"32\"},\"displayMode\":\"grid\",\"positions\":{\"source\":0,\"overlay\":1,\"thumbnail_url\":2,\"newest_first\":3,\"oldest_first\":4,\"created_at\":5,\"path\":6,\"directory_desc\":7,\"directory_asc\":8,\"title\":9,\"name_az\":10,\"name_za\":11}}}','2025-01-28 13:06:05','2025-01-28 13:29:40'),(94,5,'brand_listing','current',0,NULL,'{\"current\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"brand_id\":{\"visible\":true,\"sorting\":false},\"name\":{\"visible\":true,\"sorting\":false},\"url_key\":{\"visible\":true,\"sorting\":false},\"description\":{\"visible\":true,\"sorting\":false},\"page_title\":{\"visible\":true,\"sorting\":false},\"meta_keywords\":{\"visible\":true,\"sorting\":false},\"meta_description\":{\"visible\":true,\"sorting\":false},\"position\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"featured\":{\"visible\":true,\"sorting\":false},\"thumbnail\":{\"visible\":true,\"sorting\":false},\"image\":{\"visible\":true,\"sorting\":false}},\"search\":{\"value\":\"\"},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"name\":1,\"brand_id\":2,\"thumbnail\":3,\"image\":4,\"url_key\":5,\"description\":6,\"page_title\":7,\"meta_keywords\":8,\"featured\":9,\"status\":10,\"meta_description\":11,\"position\":12,\"actions\":13}}}','2025-01-29 10:20:00','2025-01-29 10:20:00'),(95,5,'brand_listing','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"brand_id\":{\"visible\":true,\"sorting\":false},\"name\":{\"visible\":true,\"sorting\":false},\"url_key\":{\"visible\":true,\"sorting\":false},\"description\":{\"visible\":true,\"sorting\":false},\"page_title\":{\"visible\":true,\"sorting\":false},\"meta_keywords\":{\"visible\":true,\"sorting\":false},\"meta_description\":{\"visible\":true,\"sorting\":false},\"position\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"featured\":{\"visible\":true,\"sorting\":false},\"thumbnail\":{\"visible\":true,\"sorting\":false},\"image\":{\"visible\":true,\"sorting\":false}},\"search\":{\"value\":\"\"},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"name\":1,\"brand_id\":2,\"thumbnail\":3,\"image\":4,\"url_key\":5,\"description\":6,\"page_title\":7,\"meta_keywords\":8,\"featured\":9,\"status\":10,\"meta_description\":11,\"position\":12,\"actions\":13}},\"value\":\"Default View\"}}}','2025-01-29 10:20:07','2025-01-29 10:20:08'),(96,5,'sales_order_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"shipping_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"grand_total\":{\"visible\":true,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"total_refunded\":{\"visible\":false,\"sorting\":false},\"pickup_location_code\":{\"visible\":false,\"sorting\":false},\"cost_price\":{\"visible\":true,\"sorting\":false},\"brand\":{\"visible\":true,\"sorting\":false},\"postcode\":{\"visible\":true,\"sorting\":false},\"telephone\":{\"visible\":true,\"sorting\":false},\"notes\":{\"visible\":true,\"sorting\":false},\"review_status\":{\"visible\":true,\"sorting\":false},\"transaction_source\":{\"visible\":true,\"sorting\":false},\"dispute_status\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"login_actions\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"customer_group\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"delivery_method\":{\"visible\":true,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":\"desc\"},\"ids\":{\"visible\":true,\"sorting\":false},\"allocated_sources\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"store_id\":2,\"created_at\":3,\"billing_name\":4,\"shipping_name\":5,\"brand\":6,\"cost_price\":7,\"notes\":8,\"telephone\":9,\"review_status\":10,\"postcode\":11,\"base_grand_total\":12,\"grand_total\":13,\"status\":14,\"billing_address\":15,\"shipping_address\":16,\"shipping_information\":17,\"customer_email\":18,\"customer_group\":19,\"subtotal\":20,\"shipping_and_handling\":21,\"customer_name\":22,\"payment_method\":23,\"total_refunded\":24,\"actions\":25,\"allocated_sources\":26,\"pickup_location_code\":27,\"delivery_method\":28,\"login_actions\":29,\"transaction_source\":30,\"dispute_status\":31}},\"value\":\"Default View\"}}}','2025-01-29 15:24:30','2025-01-29 15:24:31'),(97,5,'sales_order_grid','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"shipping_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"grand_total\":{\"visible\":true,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"total_refunded\":{\"visible\":false,\"sorting\":false},\"pickup_location_code\":{\"visible\":false,\"sorting\":false},\"cost_price\":{\"visible\":true,\"sorting\":false},\"brand\":{\"visible\":true,\"sorting\":false},\"postcode\":{\"visible\":true,\"sorting\":false},\"telephone\":{\"visible\":true,\"sorting\":false},\"notes\":{\"visible\":true,\"sorting\":false},\"review_status\":{\"visible\":true,\"sorting\":false},\"transaction_source\":{\"visible\":true,\"sorting\":false},\"dispute_status\":{\"visible\":true,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"login_actions\":{\"visible\":true,\"sorting\":false},\"status\":{\"visible\":true,\"sorting\":false},\"customer_group\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"delivery_method\":{\"visible\":true,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":\"desc\"},\"ids\":{\"visible\":true,\"sorting\":false},\"allocated_sources\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"store_id\":2,\"created_at\":3,\"billing_name\":4,\"shipping_name\":5,\"brand\":6,\"cost_price\":7,\"notes\":8,\"telephone\":9,\"review_status\":10,\"postcode\":11,\"base_grand_total\":12,\"grand_total\":13,\"status\":14,\"billing_address\":15,\"shipping_address\":16,\"shipping_information\":17,\"customer_email\":18,\"customer_group\":19,\"subtotal\":20,\"shipping_and_handling\":21,\"customer_name\":22,\"payment_method\":23,\"total_refunded\":24,\"actions\":25,\"allocated_sources\":26,\"pickup_location_code\":27,\"delivery_method\":28,\"login_actions\":29,\"transaction_source\":30,\"dispute_status\":31}}}','2025-01-29 15:24:36','2025-01-29 15:24:36'),(98,5,'sales_order_view_shipment_grid','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"shipping_name\":{\"visible\":true,\"sorting\":false},\"total_qty\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"order_status\":{\"visible\":false,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"shipping_name\":5,\"total_qty\":6,\"order_status\":7,\"store_id\":8,\"customer_name\":9,\"customer_email\":10,\"customer_group_id\":11,\"billing_address\":12,\"shipping_address\":13,\"payment_method\":14,\"shipping_information\":15,\"actions\":16}}}','2025-01-29 15:47:14','2025-01-29 15:47:14'),(99,5,'sales_order_view_creditmemo_grid','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":false},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"adjustment_positive\":{\"visible\":false,\"sorting\":false},\"adjustment_negative\":{\"visible\":false,\"sorting\":false},\"order_base_grand_total\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"order_status\":{\"visible\":false,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"base_grand_total\":7,\"order_status\":8,\"store_id\":9,\"billing_address\":10,\"shipping_address\":11,\"customer_name\":12,\"customer_email\":13,\"customer_group_id\":14,\"payment_method\":15,\"shipping_information\":16,\"subtotal\":17,\"shipping_and_handling\":18,\"adjustment_positive\":19,\"adjustment_negative\":20,\"order_base_grand_total\":21,\"actions\":22}}}','2025-01-29 15:47:14','2025-01-29 15:47:14'),(100,5,'sales_order_view_invoice_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"grand_total\":7,\"store_id\":8,\"billing_address\":9,\"shipping_address\":10,\"customer_name\":11,\"customer_email\":12,\"customer_group_id\":13,\"payment_method\":14,\"shipping_information\":15,\"subtotal\":16,\"shipping_and_handling\":17,\"actions\":18}},\"value\":\"Default View\"}}}','2025-01-29 15:47:15','2025-01-29 15:47:15'),(101,5,'sales_order_view_creditmemo_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":false},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"adjustment_positive\":{\"visible\":false,\"sorting\":false},\"adjustment_negative\":{\"visible\":false,\"sorting\":false},\"order_base_grand_total\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"order_status\":{\"visible\":false,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"base_grand_total\":7,\"order_status\":8,\"store_id\":9,\"billing_address\":10,\"shipping_address\":11,\"customer_name\":12,\"customer_email\":13,\"customer_group_id\":14,\"payment_method\":15,\"shipping_information\":16,\"subtotal\":17,\"shipping_and_handling\":18,\"adjustment_positive\":19,\"adjustment_negative\":20,\"order_base_grand_total\":21,\"actions\":22}},\"value\":\"Default View\"}}}','2025-01-29 15:47:16','2025-01-29 15:47:16'),(102,5,'sales_order_view_shipment_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"shipping_name\":{\"visible\":true,\"sorting\":false},\"total_qty\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"order_status\":{\"visible\":false,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"shipping_name\":5,\"total_qty\":6,\"order_status\":7,\"store_id\":8,\"customer_name\":9,\"customer_email\":10,\"customer_group_id\":11,\"billing_address\":12,\"shipping_address\":13,\"payment_method\":14,\"shipping_information\":15,\"actions\":16}},\"value\":\"Default View\"}}}','2025-01-29 15:47:16','2025-01-29 15:47:16'),(103,5,'sales_order_view_invoice_grid','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"filters\":{\"applied\":{\"placeholder\":true}},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":\"asc\"},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"grand_total\":7,\"store_id\":8,\"billing_address\":9,\"shipping_address\":10,\"customer_name\":11,\"customer_email\":12,\"customer_group_id\":13,\"payment_method\":14,\"shipping_information\":15,\"subtotal\":16,\"shipping_and_handling\":17,\"actions\":18}}}','2025-01-29 15:47:18','2025-01-29 15:47:18'),(104,5,'sales_order_creditmemo_grid','current',0,NULL,'{\"current\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":false},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"adjustment_positive\":{\"visible\":false,\"sorting\":false},\"adjustment_negative\":{\"visible\":false,\"sorting\":false},\"order_base_grand_total\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"order_status\":{\"visible\":false,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"base_grand_total\":7,\"order_status\":8,\"store_id\":9,\"billing_address\":10,\"shipping_address\":11,\"customer_name\":12,\"customer_email\":13,\"customer_group_id\":14,\"payment_method\":15,\"shipping_information\":16,\"subtotal\":17,\"shipping_and_handling\":18,\"adjustment_positive\":19,\"adjustment_negative\":20,\"order_base_grand_total\":21,\"actions\":22}}}','2025-01-29 15:57:04','2025-01-29 15:57:04'),(105,5,'sales_order_creditmemo_grid','default',1,'Default View','{\"views\":{\"default\":{\"label\":\"Default View\",\"index\":\"default\",\"editable\":false,\"data\":{\"search\":{\"value\":\"\"},\"filters\":{\"applied\":{\"placeholder\":true}},\"paging\":{\"pageSize\":20,\"current\":1,\"options\":{\"20\":{\"value\":20,\"label\":20},\"30\":{\"value\":30,\"label\":30},\"50\":{\"value\":50,\"label\":50},\"100\":{\"value\":100,\"label\":100},\"200\":{\"value\":200,\"label\":200}},\"value\":20},\"columns\":{\"increment_id\":{\"visible\":true,\"sorting\":false},\"order_increment_id\":{\"visible\":true,\"sorting\":false},\"billing_name\":{\"visible\":true,\"sorting\":false},\"base_grand_total\":{\"visible\":true,\"sorting\":false},\"store_id\":{\"visible\":false,\"sorting\":false},\"billing_address\":{\"visible\":false,\"sorting\":false},\"shipping_address\":{\"visible\":false,\"sorting\":false},\"customer_name\":{\"visible\":false,\"sorting\":false},\"customer_email\":{\"visible\":false,\"sorting\":false},\"shipping_information\":{\"visible\":false,\"sorting\":false},\"subtotal\":{\"visible\":false,\"sorting\":false},\"shipping_and_handling\":{\"visible\":false,\"sorting\":false},\"adjustment_positive\":{\"visible\":false,\"sorting\":false},\"adjustment_negative\":{\"visible\":false,\"sorting\":false},\"order_base_grand_total\":{\"visible\":false,\"sorting\":false},\"actions\":{\"visible\":true,\"sorting\":false},\"ids\":{\"visible\":true,\"sorting\":false},\"created_at\":{\"visible\":true,\"sorting\":false},\"order_created_at\":{\"visible\":true,\"sorting\":false},\"state\":{\"visible\":true,\"sorting\":false},\"order_status\":{\"visible\":false,\"sorting\":false},\"customer_group_id\":{\"visible\":false,\"sorting\":false},\"payment_method\":{\"visible\":false,\"sorting\":false}},\"displayMode\":\"grid\",\"positions\":{\"ids\":0,\"increment_id\":1,\"created_at\":2,\"order_increment_id\":3,\"order_created_at\":4,\"billing_name\":5,\"state\":6,\"base_grand_total\":7,\"order_status\":8,\"store_id\":9,\"billing_address\":10,\"shipping_address\":11,\"customer_name\":12,\"customer_email\":13,\"customer_group_id\":14,\"payment_method\":15,\"shipping_information\":16,\"subtotal\":17,\"shipping_and_handling\":18,\"adjustment_positive\":19,\"adjustment_negative\":20,\"order_base_grand_total\":21,\"actions\":22}},\"value\":\"Default View\"}}}','2025-01-29 15:57:05','2025-01-29 15:57:05');
/*!40000 ALTER TABLE `ui_bookmark` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `url_rewrite`
--

DROP TABLE IF EXISTS `url_rewrite`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `url_rewrite` (
  `url_rewrite_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rewrite ID',
  `entity_type` varchar(32) NOT NULL COMMENT 'Entity type code',
  `entity_id` int unsigned NOT NULL COMMENT 'Entity ID',
  `request_path` varchar(255) DEFAULT NULL COMMENT 'Request Path',
  `target_path` varchar(255) DEFAULT NULL COMMENT 'Target Path',
  `redirect_type` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Redirect Type',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store ID',
  `description` varchar(255) DEFAULT NULL COMMENT 'Description',
  `is_autogenerated` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Is rewrite generated automatically flag',
  `metadata` varchar(255) DEFAULT NULL COMMENT 'Meta data for url rewrite',
  PRIMARY KEY (`url_rewrite_id`),
  UNIQUE KEY `URL_REWRITE_REQUEST_PATH_STORE_ID` (`request_path`,`store_id`),
  KEY `URL_REWRITE_TARGET_PATH` (`target_path`),
  KEY `URL_REWRITE_STORE_ID_ENTITY_ID` (`store_id`,`entity_id`),
  KEY `URL_REWRITE_ENTITY_ID` (`entity_id`),
  KEY `URL_REWRITE_IS_AUTOGENERATED_METADATA` (`is_autogenerated`,`metadata`)
) ENGINE=InnoDB AUTO_INCREMENT=11387 DEFAULT CHARSET=utf8mb3 COMMENT='Url Rewrites';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `url_rewrite`
--

LOCK TABLES `url_rewrite` WRITE;
/*!40000 ALTER TABLE `url_rewrite` DISABLE KEYS */;
INSERT INTO `url_rewrite` VALUES (1,'cms-page',1,'no-route','cms/page/view/page_id/1',0,1,NULL,1,NULL),(2,'cms-page',2,'home','cms/page/view/page_id/2',0,1,NULL,1,NULL),(3,'cms-page',3,'enable-cookies','cms/page/view/page_id/3',0,1,NULL,1,NULL),(5,'category',3,'bathroom.html','catalog/category/view/id/3',0,1,NULL,1,NULL),(11,'category',7,'heating.html','catalog/category/view/id/7',0,1,NULL,1,NULL),(14,'category',10,'accessories.html','catalog/category/view/id/10',0,1,NULL,1,NULL),(15,'category',11,'sales.html','catalog/category/view/id/11',0,1,NULL,1,NULL),(16,'category',12,'brands.html','catalog/category/view/id/12',0,1,NULL,1,NULL),(35,'category',25,'bathroom/basins.html','catalog/category/view/id/25',0,1,NULL,1,NULL),(47,'category',37,'bathroom/baths.html','catalog/category/view/id/37',0,1,NULL,1,NULL),(56,'category',46,'bathroom/bathroom-furniture.html','catalog/category/view/id/46',0,1,NULL,1,NULL),(61,'category',51,'bathroom/bathroom-suites.html','catalog/category/view/id/51',0,1,NULL,1,NULL),(62,'category',52,'bathroom/bathroom-suites/cloakroom-suites.html','catalog/category/view/id/52',0,1,NULL,1,NULL),(63,'category',53,'bathroom/bathroom-suites/contemporary-suites.html','catalog/category/view/id/53',0,1,NULL,1,NULL),(64,'category',54,'bathroom/mirrors-cabinets.html','catalog/category/view/id/54',0,1,NULL,1,NULL),(65,'category',55,'bathroom/mirrors-cabinets/mirrors.html','catalog/category/view/id/55',0,1,NULL,1,NULL),(67,'category',57,'bathroom/frames-plates.html','catalog/category/view/id/57',0,1,NULL,1,NULL),(68,'category',58,'bathroom/frames-plates/bidet-frames.html','catalog/category/view/id/58',0,1,NULL,1,NULL),(69,'category',59,'bathroom/frames-plates/toilet-frames.html','catalog/category/view/id/59',0,1,NULL,1,NULL),(71,'category',61,'bathroom/frames-plates/plates.html','catalog/category/view/id/61',0,1,NULL,1,NULL),(72,'category',62,'bathroom/pvc-panels.html','catalog/category/view/id/62',0,1,NULL,1,NULL),(73,'category',63,'bathroom/pvc-panels/ceiling-panels.html','catalog/category/view/id/63',0,1,NULL,1,NULL),(74,'category',64,'bathroom/pvc-panels/wall-splash-panels.html','catalog/category/view/id/64',0,1,NULL,1,NULL),(75,'category',65,'bathroom/pvc-panels/pvc-trims.html','catalog/category/view/id/65',0,1,NULL,1,NULL),(118,'category',5,'kitchen-appliances.html','catalog/category/view/id/5',0,1,NULL,1,NULL),(1353,'category',163,'decor-product.html','catalog/category/view/id/163',0,1,NULL,1,NULL),(1406,'category',164,'comfort-product.html','catalog/category/view/id/164',0,1,NULL,1,NULL),(6596,'cms-page',4,'privacy-policy','cms/page/view/page_id/4',0,1,NULL,1,NULL),(6597,'cms-page',5,'terms-and-conditions','cms/page/view/page_id/5',0,1,NULL,1,NULL),(6598,'cms-page',6,'careers','cms/page/view/page_id/6',0,1,NULL,1,NULL),(6599,'cms-page',7,'returns','cms/page/view/page_id/7',0,1,NULL,1,NULL),(6600,'cms-page',8,'how-to-order','cms/page/view/page_id/8',0,1,NULL,1,NULL),(6601,'cms-page',9,'14-day-money-back-guarantee','cms/page/view/page_id/9',0,1,NULL,1,NULL),(6602,'cms-page',10,'visit-our-showroom','cms/page/view/page_id/10',0,1,NULL,1,NULL),(6603,'cms-page',11,'about-us','cms/page/view/page_id/11',0,1,NULL,1,NULL),(6604,'cms-page',12,'faq','cms/page/view/page_id/12',0,1,NULL,1,NULL),(6607,'cms-page',13,'finance','cms/page/view/page_id/13',0,1,NULL,1,NULL),(6608,'cms-page',14,'support','cms/page/view/page_id/14',0,1,NULL,1,NULL),(6635,'category',191,'accessories/lights.html','catalog/category/view/id/191',0,1,NULL,1,NULL),(6636,'category',192,'accessories/lights/mirror-lights.html','catalog/category/view/id/192',0,1,NULL,1,NULL),(6637,'category',193,'accessories/lights/ceiling-lights.html','catalog/category/view/id/193',0,1,NULL,1,NULL),(6638,'category',194,'accessories/kitchen-accessories.html','catalog/category/view/id/194',0,1,NULL,1,NULL),(6639,'category',195,'accessories/kitchen-accessories/bosch-accessories.html','catalog/category/view/id/195',0,1,NULL,1,NULL),(6640,'category',196,'accessories/kitchen-accessories/siemens-accessories.html','catalog/category/view/id/196',0,1,NULL,1,NULL),(6641,'category',197,'accessories/kitchen-accessories/neff-accessories.html','catalog/category/view/id/197',0,1,NULL,1,NULL),(6744,'category',219,'bathroom/toilet.html','catalog/category/view/id/219',0,1,NULL,1,NULL),(6843,'category',15,'bathroom/toilet/toilets.html','catalog/category/view/id/15',0,1,NULL,1,NULL),(6844,'category',16,'bathroom/toilet/toilets/close-coupled-toilets.html','catalog/category/view/id/16',0,1,NULL,1,NULL),(6845,'category',16,'bathroom/toilets/close-coupled-toilets.html','bathroom/toilet/toilets/close-coupled-toilets.html',301,1,NULL,0,NULL),(6846,'category',17,'bathroom/toilet/toilets/back-to-wall-toilets.html','catalog/category/view/id/17',0,1,NULL,1,NULL),(6847,'category',17,'bathroom/toilets/back-to-wall-toilets.html','bathroom/toilet/toilets/back-to-wall-toilets.html',301,1,NULL,0,NULL),(6848,'category',18,'bathroom/toilet/toilets/wall-hung-toilets.html','catalog/category/view/id/18',0,1,NULL,1,NULL),(6849,'category',18,'bathroom/toilets/wall-hung-toilets.html','bathroom/toilet/toilets/wall-hung-toilets.html',301,1,NULL,0,NULL),(6850,'category',199,'bathroom/toilet/toilets/rimless-toilets.html','catalog/category/view/id/199',0,1,NULL,1,NULL),(6851,'category',199,'bathroom/toilets/rimless-toilets.html','bathroom/toilet/toilets/rimless-toilets.html',301,1,NULL,0,NULL),(6852,'category',20,'bathroom/toilet/toilets/corner-toilets.html','catalog/category/view/id/20',0,1,NULL,1,NULL),(6853,'category',20,'bathroom/toilets/corner-toilets.html','bathroom/toilet/toilets/corner-toilets.html',301,1,NULL,0,NULL),(6854,'category',200,'bathroom/toilet/toilets/wc-unit.html','catalog/category/view/id/200',0,1,NULL,1,NULL),(6855,'category',200,'bathroom/toilets/wc-unit.html','bathroom/toilet/toilets/wc-unit.html',301,1,NULL,0,NULL),(6856,'category',201,'bathroom/toilet/toilets/smart-toilets.html','catalog/category/view/id/201',0,1,NULL,1,NULL),(6857,'category',201,'bathroom/toilets/smart-toilets.html','bathroom/toilet/toilets/smart-toilets.html',301,1,NULL,0,NULL),(6858,'category',202,'bathroom/toilet/toilets/doc-m-packs.html','catalog/category/view/id/202',0,1,NULL,1,NULL),(6859,'category',202,'bathroom/toilets/doc-m-packs.html','bathroom/toilet/toilets/doc-m-packs.html',301,1,NULL,0,NULL),(6860,'category',21,'bathroom/toilet/toilets/bidets.html','catalog/category/view/id/21',0,1,NULL,1,NULL),(6861,'category',21,'bathroom/toilets/bidets.html','bathroom/toilet/toilets/bidets.html',301,1,NULL,0,NULL),(6862,'category',22,'bathroom/toilet/toilets/urinals.html','catalog/category/view/id/22',0,1,NULL,1,NULL),(6863,'category',22,'bathroom/toilets/urinals.html','bathroom/toilet/toilets/urinals.html',301,1,NULL,0,NULL),(6866,'category',24,'bathroom/toilet/toilets/concealed-cisterns.html','catalog/category/view/id/24',0,1,NULL,1,NULL),(6867,'category',24,'bathroom/toilets/concealed-cisterns.html','bathroom/toilet/toilets/concealed-cisterns.html',301,1,NULL,0,NULL),(6868,'category',15,'bathroom/toilets.html','bathroom/toilet/toilets.html',301,1,NULL,0,NULL),(6869,'category',209,'bathroom/toilet/brands.html','catalog/category/view/id/209',0,1,NULL,1,NULL),(6870,'category',210,'bathroom/toilet/brands/rak.html','catalog/category/view/id/210',0,1,NULL,1,NULL),(6871,'category',210,'bathroom/brands/rak.html','bathroom/toilet/brands/rak.html',301,1,NULL,0,NULL),(6872,'category',210,'bathroom/toilets/brands/rak.html','bathroom/toilet/brands/rak.html',301,1,NULL,0,'[]'),(6873,'category',211,'bathroom/toilet/brands/geberit.html','catalog/category/view/id/211',0,1,NULL,1,NULL),(6874,'category',211,'bathroom/brands/geberit.html','bathroom/toilet/brands/geberit.html',301,1,NULL,0,NULL),(6875,'category',211,'bathroom/toilets/brands/geberit.html','bathroom/toilet/brands/geberit.html',301,1,NULL,0,'[]'),(6876,'category',212,'bathroom/toilet/brands/grohe.html','catalog/category/view/id/212',0,1,NULL,1,NULL),(6877,'category',212,'bathroom/brands/grohe.html','bathroom/toilet/brands/grohe.html',301,1,NULL,0,NULL),(6878,'category',212,'bathroom/toilets/brands/grohe.html','bathroom/toilet/brands/grohe.html',301,1,NULL,0,'[]'),(6879,'category',213,'bathroom/toilet/brands/hudson-reed.html','catalog/category/view/id/213',0,1,NULL,1,NULL),(6880,'category',213,'bathroom/brands/hudson-reed.html','bathroom/toilet/brands/hudson-reed.html',301,1,NULL,0,NULL),(6881,'category',213,'bathroom/toilets/brands/hudson-reed.html','bathroom/toilet/brands/hudson-reed.html',301,1,NULL,0,'[]'),(6882,'category',214,'bathroom/toilet/brands/roca.html','catalog/category/view/id/214',0,1,NULL,1,NULL),(6883,'category',214,'bathroom/brands/roca.html','bathroom/toilet/brands/roca.html',301,1,NULL,0,NULL),(6884,'category',214,'bathroom/toilets/brands/roca.html','bathroom/toilet/brands/roca.html',301,1,NULL,0,'[]'),(6885,'category',215,'bathroom/toilet/brands/vitra.html','catalog/category/view/id/215',0,1,NULL,1,NULL),(6886,'category',215,'bathroom/brands/vitra.html','bathroom/toilet/brands/vitra.html',301,1,NULL,0,NULL),(6887,'category',215,'bathroom/toilets/brands/vitra.html','bathroom/toilet/brands/vitra.html',301,1,NULL,0,'[]'),(6888,'category',216,'bathroom/toilet/brands/nuie.html','catalog/category/view/id/216',0,1,NULL,1,NULL),(6889,'category',216,'bathroom/brands/nuie.html','bathroom/toilet/brands/nuie.html',301,1,NULL,0,NULL),(6890,'category',216,'bathroom/toilets/brands/nuie.html','bathroom/toilet/brands/nuie.html',301,1,NULL,0,'[]'),(6891,'category',209,'bathroom/brands.html','bathroom/toilet/brands.html',301,1,NULL,0,NULL),(6892,'category',209,'bathroom/toilets/brands.html','bathroom/toilet/brands.html',301,1,NULL,0,'[]'),(6893,'category',203,'bathroom/toilet/toilet-accessories.html','catalog/category/view/id/203',0,1,NULL,1,NULL),(6894,'category',204,'bathroom/toilet/toilet-accessories/douche-shattafs.html','catalog/category/view/id/204',0,1,NULL,1,NULL),(6895,'category',204,'bathroom/toilet-accessories/douche-shattafs.html','bathroom/toilet/toilet-accessories/douche-shattafs.html',301,1,NULL,0,NULL),(6896,'category',204,'toilet-accessories/douche-shattafs.html','bathroom/toilet/toilet-accessories/douche-shattafs.html',301,1,NULL,0,'[]'),(6897,'category',204,'bathroom/toilets/toilet-accessories/douche-shattafs.html','bathroom/toilet/toilet-accessories/douche-shattafs.html',301,1,NULL,0,'[]'),(6898,'category',205,'bathroom/toilet/toilet-accessories/flush-buttons-plates.html','catalog/category/view/id/205',0,1,NULL,1,NULL),(6899,'category',205,'bathroom/toilet-accessories/flush-buttons-plates.html','bathroom/toilet/toilet-accessories/flush-buttons-plates.html',301,1,NULL,0,NULL),(6900,'category',205,'toilet-accessories/flush-buttons-plates.html','bathroom/toilet/toilet-accessories/flush-buttons-plates.html',301,1,NULL,0,'[]'),(6901,'category',205,'bathroom/toilets/toilet-accessories/flush-buttons-plates.html','bathroom/toilet/toilet-accessories/flush-buttons-plates.html',301,1,NULL,0,'[]'),(6910,'category',208,'bathroom/toilet/toilet-accessories/toilet-brush-and-holders.html','catalog/category/view/id/208',0,1,NULL,1,NULL),(6911,'category',208,'bathroom/toilet-accessories/toilet-brush-and-holders.html','bathroom/toilet/toilet-accessories/toilet-brush-and-holders.html',301,1,NULL,0,NULL),(6912,'category',208,'toilet-accessories/toilet-brush-and-holders.html','bathroom/toilet/toilet-accessories/toilet-brush-and-holders.html',301,1,NULL,0,'[]'),(6913,'category',208,'bathroom/toilets/toilet-accessories/toilet-brush-and-holders.html','bathroom/toilet/toilet-accessories/toilet-brush-and-holders.html',301,1,NULL,0,'[]'),(6914,'category',203,'bathroom/toilet-accessories.html','bathroom/toilet/toilet-accessories.html',301,1,NULL,0,NULL),(6915,'category',203,'toilet-accessories.html','bathroom/toilet/toilet-accessories.html',301,1,NULL,0,'[]'),(6916,'category',203,'bathroom/toilets/toilet-accessories.html','bathroom/toilet/toilet-accessories.html',301,1,NULL,0,'[]'),(6917,'category',198,'bathroom/toilet/toilets/comfort-height-toilets.html','catalog/category/view/id/198',0,1,NULL,1,NULL),(6918,'category',198,'bathroom/toilet/comfort-height-toilets.html','bathroom/toilet/toilets/comfort-height-toilets.html',301,1,NULL,0,NULL),(6919,'category',198,'bathroom/toilets/comfort-height-toilets.html','bathroom/toilet/toilets/comfort-height-toilets.html',301,1,NULL,0,'[]'),(6920,'category',221,'bathroom/basins/basins.html','catalog/category/view/id/221',0,1,NULL,1,NULL),(6921,'category',26,'bathroom/basins/basins/pedestal-basins.html','catalog/category/view/id/26',0,1,NULL,1,NULL),(6922,'category',26,'bathroom/basins/pedestal-basins.html','bathroom/basins/basins/pedestal-basins.html',301,1,NULL,0,NULL),(6923,'category',27,'bathroom/basins/basins/wall-hung-basins.html','catalog/category/view/id/27',0,1,NULL,1,NULL),(6924,'category',27,'bathroom/basins/wall-hung-basins.html','bathroom/basins/basins/wall-hung-basins.html',301,1,NULL,0,NULL),(6925,'category',222,'bathroom/basins/basins/semi-pedestal-basins.html','catalog/category/view/id/222',0,1,NULL,1,NULL),(6926,'category',33,'bathroom/basins/basins/counter-top-basins.html','catalog/category/view/id/33',0,1,NULL,1,NULL),(6927,'category',33,'bathroom/basins/counter-top-basins.html','bathroom/basins/basins/counter-top-basins.html',301,1,NULL,0,NULL),(6928,'category',32,'bathroom/basins/basins/under-counter-basins.html','catalog/category/view/id/32',0,1,NULL,1,NULL),(6929,'category',32,'bathroom/basins/under-counter-basins.html','bathroom/basins/basins/under-counter-basins.html',301,1,NULL,0,NULL),(6930,'category',223,'bathroom/basins/basins/space-saver-basins.html','catalog/category/view/id/223',0,1,NULL,1,NULL),(6931,'category',28,'bathroom/basins/basins/corner-basins.html','catalog/category/view/id/28',0,1,NULL,1,NULL),(6932,'category',28,'bathroom/basins/corner-basins.html','bathroom/basins/basins/corner-basins.html',301,1,NULL,0,NULL),(6933,'category',30,'bathroom/basins/basins/vanity-basins.html','catalog/category/view/id/30',0,1,NULL,1,NULL),(6934,'category',30,'bathroom/basins/vanity-basins.html','bathroom/basins/basins/vanity-basins.html',301,1,NULL,0,NULL),(6935,'category',31,'bathroom/basins/basins/semi-recessed-basins.html','catalog/category/view/id/31',0,1,NULL,1,NULL),(6936,'category',31,'bathroom/basins/semi-recessed-basins.html','bathroom/basins/basins/semi-recessed-basins.html',301,1,NULL,0,NULL),(6937,'category',224,'bathroom/basins/basins/freestanding-basin.html','catalog/category/view/id/224',0,1,NULL,1,NULL),(6938,'category',225,'bathroom/basins/basins/washstands.html','catalog/category/view/id/225',0,1,NULL,1,NULL),(6959,'category',34,'bathroom/basins/basins/sit-on-basins.html','catalog/category/view/id/34',0,1,NULL,1,NULL),(6960,'category',34,'bathroom/basins/sit-on-basins.html','bathroom/basins/basins/sit-on-basins.html',301,1,NULL,0,NULL),(6961,'category',29,'bathroom/basins/basins/cloakroom-basins.html','catalog/category/view/id/29',0,1,NULL,1,NULL),(6962,'category',29,'bathroom/basins/cloakroom-basins.html','bathroom/basins/basins/cloakroom-basins.html',301,1,NULL,0,NULL),(6963,'category',226,'bathroom/basins/accessories.html','catalog/category/view/id/226',0,1,NULL,1,NULL),(6964,'category',187,'bathroom/toilet/toilet-accessories/toilet-roll-holders.html','catalog/category/view/id/187',0,1,NULL,1,NULL),(6965,'category',187,'accessories/bathroom-accessories/toilet-roll-holders.html','bathroom/toilet/toilet-accessories/toilet-roll-holders.html',301,1,NULL,0,NULL),(6966,'category',23,'bathroom/toilet/toilet-accessories/toilet-seats.html','catalog/category/view/id/23',0,1,NULL,1,NULL),(6967,'category',23,'bathroom/toilet/toilets/toilet-seats.html','bathroom/toilet/toilet-accessories/toilet-seats.html',301,1,NULL,0,NULL),(6968,'category',23,'bathroom/toilets/toilet-seats.html','bathroom/toilet/toilet-accessories/toilet-seats.html',301,1,NULL,0,'[]'),(6969,'category',35,'bathroom/basins/accessories/bottle-traps.html','catalog/category/view/id/35',0,1,NULL,1,NULL),(6970,'category',35,'bathroom/basins/basins/bottle-traps.html','bathroom/basins/accessories/bottle-traps.html',301,1,NULL,0,NULL),(6971,'category',35,'bathroom/basins/bottle-traps.html','bathroom/basins/accessories/bottle-traps.html',301,1,NULL,0,'[]'),(6975,'category',36,'bathroom/basins/accessories/basin-wastes.html','catalog/category/view/id/36',0,1,NULL,1,NULL),(6976,'category',36,'bathroom/basins/basins/basin-wastes.html','bathroom/basins/accessories/basin-wastes.html',301,1,NULL,0,'[]'),(6977,'category',36,'bathroom/basins/basin-wastes.html','bathroom/basins/accessories/basin-wastes.html',301,1,NULL,0,'[]'),(6978,'category',60,'bathroom/basins/accessories/basin-frames.html','catalog/category/view/id/60',0,1,NULL,1,NULL),(6979,'category',60,'bathroom/frames-plates/basin-frames.html','bathroom/basins/accessories/basin-frames.html',301,1,NULL,0,NULL),(6982,'category',190,'bathroom/basins/accessories/soap-dishes.html','catalog/category/view/id/190',0,1,NULL,1,NULL),(6983,'category',190,'accessories/bathroom-accessories/soap-dishes.html','bathroom/basins/accessories/soap-dishes.html',301,1,NULL,0,NULL),(6984,'category',229,'bathroom/basins/accessories/towel-rails.html','catalog/category/view/id/229',0,1,NULL,1,NULL),(6985,'category',230,'bathroom/basins/brands.html','catalog/category/view/id/230',0,1,NULL,1,NULL),(6986,'category',231,'bathroom/basins/brands/rak.html','catalog/category/view/id/231',0,1,NULL,1,NULL),(6987,'category',232,'bathroom/basins/brands/geberit.html','catalog/category/view/id/232',0,1,NULL,1,NULL),(6988,'category',233,'bathroom/basins/brands/grohe.html','catalog/category/view/id/233',0,1,NULL,1,NULL),(6989,'category',234,'bathroom/basins/brands/hudson-reed.html','catalog/category/view/id/234',0,1,NULL,1,NULL),(6990,'category',235,'bathroom/basins/brands/roca.html','catalog/category/view/id/235',0,1,NULL,1,NULL),(6991,'category',236,'bathroom/basins/brands/vitra.html','catalog/category/view/id/236',0,1,NULL,1,NULL),(6992,'category',237,'bathroom/basins/brands/nuie.html','catalog/category/view/id/237',0,1,NULL,1,NULL),(6993,'category',9,'bathroom/shower-valves.html','catalog/category/view/id/9',0,1,NULL,1,NULL),(6994,'category',165,'bathroom/shower-valves/all-showers.html','catalog/category/view/id/165',0,1,NULL,1,NULL),(6995,'category',166,'bathroom/shower-valves/all-showers/showers.html','bathroom/shower-valves/all-showers/full-showers.html',301,1,NULL,0,'[]'),(6996,'category',166,'shower-valves/all-showers/showers.html','bathroom/shower-valves/all-showers/full-showers.html',301,1,NULL,0,'[]'),(6997,'category',167,'bathroom/shower-valves/all-showers/shower-panels.html','catalog/category/view/id/167',0,1,NULL,1,NULL),(6998,'category',167,'shower-valves/all-showers/shower-panels.html','bathroom/shower-valves/all-showers/shower-panels.html',301,1,NULL,0,'[]'),(6999,'category',168,'bathroom/shower-valves/all-showers/electric-showers.html','catalog/category/view/id/168',0,1,NULL,1,NULL),(7000,'category',168,'shower-valves/all-showers/electric-showers.html','bathroom/shower-valves/all-showers/electric-showers.html',301,1,NULL,0,'[]'),(7001,'category',165,'shower-valves/all-showers.html','bathroom/shower-valves/all-showers.html',301,1,NULL,0,'[]'),(7014,'category',175,'shower-valves/shower-accessories/hand-showers.html','bathroom/shower-valves/accessories/hand-showers.html',301,1,NULL,0,'[]'),(7022,'category',179,'shower-valves/shower-accessories/body-jets.html','bathroom/shower-valves/accessories/body-jets.html',301,1,NULL,0,'[]'),(7024,'category',180,'shower-valves/shower-accessories/shower-hose.html','bathroom/shower-valves/accessories/shower-hose.html',301,1,NULL,0,'[]'),(7026,'category',181,'shower-valves/shower-accessories/accessories.html','bathroom/shower-valves/accessories/accessories.html',301,1,NULL,0,'[]'),(7027,'category',169,'shower-valves/shower-accessories.html','bathroom/shower-valves/accessories.html',301,1,NULL,0,'[]'),(7028,'category',9,'shower-valves.html','bathroom/shower-valves.html',301,1,NULL,0,NULL),(7029,'category',165,'bathroom/shower-valves/showers.html','bathroom/shower-valves/all-showers.html',301,1,NULL,0,NULL),(7031,'category',167,'bathroom/shower-valves/showers/shower-panels.html','bathroom/shower-valves/all-showers/shower-panels.html',301,1,NULL,0,NULL),(7032,'category',168,'bathroom/shower-valves/showers/electric-showers.html','bathroom/shower-valves/all-showers/electric-showers.html',301,1,NULL,0,NULL),(7047,'category',176,'bathroom/shower-valves/showers/slider-kits.html','bathroom/shower-valves/all-showers/slider-kits.html',301,1,NULL,0,NULL),(7048,'category',176,'bathroom/shower-valves/shower-accessories/slider-kits.html','bathroom/shower-valves/all-showers/slider-kits.html',301,1,NULL,0,'[]'),(7049,'category',176,'shower-valves/shower-accessories/slider-kits.html','bathroom/shower-valves/all-showers/slider-kits.html',301,1,NULL,0,'[]'),(7050,'category',166,'bathroom/shower-valves/showers/full-showers.html','bathroom/shower-valves/all-showers/full-showers.html',301,1,NULL,0,NULL),(7054,'category',177,'bathroom/shower-valves/showers/shower-heads.html','bathroom/shower-valves/accessories/shower-heads.html',301,1,NULL,0,'[]'),(7055,'category',177,'shower-valves/shower-accessories/shower-heads.html','bathroom/shower-valves/accessories/shower-heads.html',301,1,NULL,0,'[]'),(7057,'category',178,'bathroom/shower-valves/showers/shower-arms.html','bathroom/shower-valves/accessories/shower-arms.html',301,1,NULL,0,'[]'),(7058,'category',178,'shower-valves/shower-accessories/shower-arms.html','bathroom/shower-valves/accessories/shower-arms.html',301,1,NULL,0,'[]'),(7059,'category',238,'bathroom/shower-valves/showers/shower-head-with-arm.html','bathroom/shower-valves/all-showers/shower-head-with-arm.html',301,1,NULL,0,NULL),(7060,'category',170,'bathroom/shower-valves/valves.html','catalog/category/view/id/170',0,1,NULL,1,NULL),(7061,'category',171,'bathroom/shower-valves/valves/exposed-valves.html','catalog/category/view/id/171',0,1,NULL,1,NULL),(7062,'category',171,'bathroom/shower-valves/shower-accessories/valves/exposed-valves.html','bathroom/shower-valves/valves/exposed-valves.html',301,1,NULL,0,NULL),(7063,'category',171,'shower-valves/shower-accessories/valves/exposed-valves.html','bathroom/shower-valves/valves/exposed-valves.html',301,1,NULL,0,'[]'),(7064,'category',172,'bathroom/shower-valves/valves/concealed-valves.html','catalog/category/view/id/172',0,1,NULL,1,NULL),(7065,'category',172,'bathroom/shower-valves/shower-accessories/valves/concealed-valves.html','bathroom/shower-valves/valves/concealed-valves.html',301,1,NULL,0,NULL),(7066,'category',172,'shower-valves/shower-accessories/valves/concealed-valves.html','bathroom/shower-valves/valves/concealed-valves.html',301,1,NULL,0,'[]'),(7067,'category',173,'bathroom/shower-valves/valves/thermostatic-valves.html','catalog/category/view/id/173',0,1,NULL,1,NULL),(7068,'category',173,'bathroom/shower-valves/shower-accessories/valves/thermostatic-valves.html','bathroom/shower-valves/valves/thermostatic-valves.html',301,1,NULL,0,NULL),(7069,'category',173,'shower-valves/shower-accessories/valves/thermostatic-valves.html','bathroom/shower-valves/valves/thermostatic-valves.html',301,1,NULL,0,'[]'),(7070,'category',174,'bathroom/shower-valves/valves/traditional-valves.html','catalog/category/view/id/174',0,1,NULL,1,NULL),(7071,'category',174,'bathroom/shower-valves/shower-accessories/valves/traditional-valves.html','bathroom/shower-valves/valves/traditional-valves.html',301,1,NULL,0,NULL),(7072,'category',174,'shower-valves/shower-accessories/valves/traditional-valves.html','bathroom/shower-valves/valves/traditional-valves.html',301,1,NULL,0,'[]'),(7073,'category',170,'bathroom/shower-valves/shower-accessories/valves.html','bathroom/shower-valves/valves.html',301,1,NULL,0,NULL),(7074,'category',170,'shower-valves/shower-accessories/valves.html','bathroom/shower-valves/valves.html',301,1,NULL,0,'[]'),(7075,'category',239,'bathroom/shower-valves/valves/bar-valves.html','catalog/category/view/id/239',0,1,NULL,1,NULL),(7076,'category',169,'bathroom/shower-valves/accessories.html','catalog/category/view/id/169',0,1,NULL,1,NULL),(7077,'category',175,'bathroom/shower-valves/accessories/hand-showers.html','catalog/category/view/id/175',0,1,NULL,1,NULL),(7078,'category',177,'bathroom/shower-valves/accessories/shower-heads.html','catalog/category/view/id/177',0,1,NULL,1,NULL),(7079,'category',178,'bathroom/shower-valves/accessories/shower-arms.html','catalog/category/view/id/178',0,1,NULL,1,NULL),(7080,'category',179,'bathroom/shower-valves/accessories/body-jets.html','catalog/category/view/id/179',0,1,NULL,1,NULL),(7081,'category',180,'bathroom/shower-valves/accessories/shower-hose.html','catalog/category/view/id/180',0,1,NULL,1,NULL),(7082,'category',181,'bathroom/shower-valves/accessories/accessories.html','catalog/category/view/id/181',0,1,NULL,1,NULL),(7092,'category',240,'bathroom/shower-valves/brands.html','catalog/category/view/id/240',0,1,NULL,1,NULL),(7093,'category',241,'bathroom/shower-valves/brands/hansgrohe.html','catalog/category/view/id/241',0,1,NULL,1,NULL),(7094,'category',242,'bathroom/shower-valves/brands/grohe.html','catalog/category/view/id/242',0,1,NULL,1,NULL),(7095,'category',243,'bathroom/shower-valves/brands/nuei.html','catalog/category/view/id/243',0,1,NULL,1,NULL),(7096,'category',244,'bathroom/shower-valves/brands/hudson-reed.html','catalog/category/view/id/244',0,1,NULL,1,NULL),(7097,'category',4,'bathroom/showering.html','catalog/category/view/id/4',0,1,NULL,1,NULL),(7098,'category',66,'bathroom/showering/shower-doors.html','catalog/category/view/id/66',0,1,NULL,1,NULL),(7099,'category',67,'bathroom/showering/shower-doors/pivot-doors.html','catalog/category/view/id/67',0,1,NULL,1,NULL),(7100,'category',67,'enclosures/shower-doors/pivot-doors.html','bathroom/showering/shower-doors/pivot-doors.html',301,1,NULL,0,'[]'),(7101,'category',67,'showering/shower-doors/pivot-doors.html','bathroom/showering/shower-doors/pivot-doors.html',301,1,NULL,0,NULL),(7102,'category',68,'bathroom/showering/shower-doors/hinged-doors.html','catalog/category/view/id/68',0,1,NULL,1,NULL),(7103,'category',68,'enclosures/shower-doors/hinged-doors.html','bathroom/showering/shower-doors/hinged-doors.html',301,1,NULL,0,'[]'),(7104,'category',68,'showering/shower-doors/hinged-doors.html','bathroom/showering/shower-doors/hinged-doors.html',301,1,NULL,0,NULL),(7105,'category',69,'bathroom/showering/shower-doors/sliding-doors.html','catalog/category/view/id/69',0,1,NULL,1,NULL),(7106,'category',69,'enclosures/shower-doors/sliding-doors.html','bathroom/showering/shower-doors/sliding-doors.html',301,1,NULL,0,'[]'),(7107,'category',69,'showering/shower-doors/sliding-doors.html','bathroom/showering/shower-doors/sliding-doors.html',301,1,NULL,0,NULL),(7108,'category',70,'bathroom/showering/shower-doors/bi-fold-doors.html','catalog/category/view/id/70',0,1,NULL,1,NULL),(7109,'category',70,'enclosures/shower-doors/bi-fold-doors.html','bathroom/showering/shower-doors/bi-fold-doors.html',301,1,NULL,0,'[]'),(7110,'category',70,'showering/shower-doors/bi-fold-doors.html','bathroom/showering/shower-doors/bi-fold-doors.html',301,1,NULL,0,NULL),(7111,'category',66,'enclosures/shower-doors.html','bathroom/showering/shower-doors.html',301,1,NULL,0,'[]'),(7112,'category',66,'showering/shower-doors.html','bathroom/showering/shower-doors.html',301,1,NULL,0,NULL),(7113,'category',71,'bathroom/showering/shower-enclosures.html','catalog/category/view/id/71',0,1,NULL,1,NULL),(7114,'category',72,'bathroom/showering/shower-enclosures/pivot-enclosures.html','catalog/category/view/id/72',0,1,NULL,1,NULL),(7115,'category',72,'enclosures/shower-enclosures/pivot-enclosures.html','bathroom/showering/shower-enclosures/pivot-enclosures.html',301,1,NULL,0,'[]'),(7116,'category',72,'showering/shower-enclosures/pivot-enclosures.html','bathroom/showering/shower-enclosures/pivot-enclosures.html',301,1,NULL,0,NULL),(7117,'category',73,'bathroom/showering/shower-enclosures/hinged-enclosures.html','catalog/category/view/id/73',0,1,NULL,1,NULL),(7118,'category',73,'enclosures/shower-enclosures/hinged-enclosures.html','bathroom/showering/shower-enclosures/hinged-enclosures.html',301,1,NULL,0,'[]'),(7119,'category',73,'showering/shower-enclosures/hinged-enclosures.html','bathroom/showering/shower-enclosures/hinged-enclosures.html',301,1,NULL,0,NULL),(7120,'category',74,'bathroom/showering/shower-enclosures/sliding-enclosures.html','catalog/category/view/id/74',0,1,NULL,1,NULL),(7121,'category',74,'enclosures/shower-enclosures/sliding-enclosures.html','bathroom/showering/shower-enclosures/sliding-enclosures.html',301,1,NULL,0,'[]'),(7122,'category',74,'showering/shower-enclosures/sliding-enclosures.html','bathroom/showering/shower-enclosures/sliding-enclosures.html',301,1,NULL,0,NULL),(7123,'category',75,'bathroom/showering/shower-enclosures/bi-fold-enclosures.html','catalog/category/view/id/75',0,1,NULL,1,NULL),(7124,'category',75,'showering/shower-enclosures/bi-fold-enclosures.html','bathroom/showering/shower-enclosures/bi-fold-enclosures.html',301,1,NULL,0,NULL),(7125,'category',76,'bathroom/showering/shower-enclosures/d-shaped-enclosures.html','catalog/category/view/id/76',0,1,NULL,1,NULL),(7126,'category',76,'showering/shower-enclosures/d-shaped-enclosures.html','bathroom/showering/shower-enclosures/d-shaped-enclosures.html',301,1,NULL,0,NULL),(7127,'category',77,'bathroom/showering/shower-enclosures/walk-in-showers.html','catalog/category/view/id/77',0,1,NULL,1,NULL),(7128,'category',77,'showering/shower-enclosures/walk-in-showers.html','bathroom/showering/shower-enclosures/walk-in-showers.html',301,1,NULL,0,NULL),(7130,'category',78,'showering/shower-enclosures/quadrant.html','bathroom/showering/shower-enclosures/quadrant.html',301,1,NULL,0,'[]'),(7132,'category',79,'showering/shower-enclosures/pentagons.html','bathroom/showering/shower-enclosures/pentagons.html',301,1,NULL,0,'[]'),(7133,'category',80,'bathroom/showering/shower-enclosures/wet-rooms.html','catalog/category/view/id/80',0,1,NULL,1,NULL),(7134,'category',80,'showering/shower-enclosures/wet-rooms.html','bathroom/showering/shower-enclosures/wet-rooms.html',301,1,NULL,0,NULL),(7135,'category',81,'bathroom/showering/shower-enclosures/corner-entry-enclosures.html','catalog/category/view/id/81',0,1,NULL,1,NULL),(7136,'category',81,'showering/shower-enclosures/corner-entry-enclosures.html','bathroom/showering/shower-enclosures/corner-entry-enclosures.html',301,1,NULL,0,NULL),(7137,'category',71,'enclosures/shower-enclosures.html','bathroom/showering/shower-enclosures.html',301,1,NULL,0,'[]'),(7138,'category',71,'showering/shower-enclosures.html','bathroom/showering/shower-enclosures.html',301,1,NULL,0,NULL),(7139,'category',82,'bathroom/showering/shower-trays.html','catalog/category/view/id/82',0,1,NULL,1,NULL),(7140,'category',83,'bathroom/showering/shower-trays/square-trays.html','catalog/category/view/id/83',0,1,NULL,1,NULL),(7141,'category',83,'showering/shower-trays/square-trays.html','bathroom/showering/shower-trays/square-trays.html',301,1,NULL,0,NULL),(7142,'category',84,'bathroom/showering/shower-trays/rectangular-trays.html','catalog/category/view/id/84',0,1,NULL,1,NULL),(7143,'category',84,'showering/shower-trays/rectangular-trays.html','bathroom/showering/shower-trays/rectangular-trays.html',301,1,NULL,0,NULL),(7144,'category',85,'bathroom/showering/shower-trays/quadrant-trays.html','catalog/category/view/id/85',0,1,NULL,1,NULL),(7145,'category',85,'showering/shower-trays/quadrant-trays.html','bathroom/showering/shower-trays/quadrant-trays.html',301,1,NULL,0,NULL),(7146,'category',86,'bathroom/showering/shower-trays/pentagon-trays.html','catalog/category/view/id/86',0,1,NULL,1,NULL),(7147,'category',86,'showering/shower-trays/pentagon-trays.html','bathroom/showering/shower-trays/pentagon-trays.html',301,1,NULL,0,NULL),(7148,'category',82,'showering/shower-trays.html','bathroom/showering/shower-trays.html',301,1,NULL,0,NULL),(7149,'category',4,'enclosures.html','bathroom/showering.html',301,1,NULL,0,'[]'),(7150,'category',4,'bathroom/enclosures.html','bathroom/showering.html',301,1,NULL,0,'[]'),(7151,'category',4,'showering.html','bathroom/showering.html',301,1,NULL,0,NULL),(7154,'category',79,'bathroom/showering/shower-enclosures/pentagon-enclosures.html','bathroom/showering/shower-enclosures/pentagons.html',301,1,NULL,0,NULL),(7156,'category',79,'bathroom/showering/shower-enclosures/pentagons.html','catalog/category/view/id/79',0,1,NULL,1,NULL),(7159,'category',78,'bathroom/showering/shower-enclosures/quadrant.html','catalog/category/view/id/78',0,1,NULL,1,NULL),(7161,'category',166,'bathroom/shower-valves/all-showers/full-showers.html','catalog/category/view/id/166',0,1,NULL,1,NULL),(7162,'category',176,'bathroom/shower-valves/all-showers/slider-kits.html','catalog/category/view/id/176',0,1,NULL,1,NULL),(7163,'category',238,'bathroom/shower-valves/all-showers/shower-head-with-arm.html','catalog/category/view/id/238',0,1,NULL,1,NULL),(7180,'category',245,'bathroom/showering/shower-enclosures/curved-enclosures.html','catalog/category/view/id/245',0,1,NULL,1,NULL),(7181,'category',246,'bathroom/showering/shower-enclosures/3-sided-enclosures.html','catalog/category/view/id/246',0,1,NULL,1,NULL),(7182,'category',247,'bathroom/showering/brands.html','catalog/category/view/id/247',0,1,NULL,1,NULL),(7183,'category',248,'bathroom/showering/brands/matki.html','catalog/category/view/id/248',0,1,NULL,1,NULL),(7184,'category',249,'bathroom/showering/brands/nuei.html','catalog/category/view/id/249',0,1,NULL,1,NULL),(7185,'category',250,'bathroom/showering/brands/ideal-stnadard.html','catalog/category/view/id/250',0,1,NULL,1,NULL),(7186,'category',251,'bathroom/showering/brands/hudson-reed.html','catalog/category/view/id/251',0,1,NULL,1,NULL),(7187,'category',252,'bathroom/showering/brands/rak.html','catalog/category/view/id/252',0,1,NULL,1,NULL),(7188,'category',253,'bathroom/baths/baths.html','catalog/category/view/id/253',0,1,NULL,1,NULL),(7189,'category',254,'bathroom/baths/baths/single-ended-baths.html','catalog/category/view/id/254',0,1,NULL,1,NULL),(7190,'category',255,'bathroom/baths/baths/double-ended-baths.html','catalog/category/view/id/255',0,1,NULL,1,NULL),(7191,'category',39,'bathroom/baths/baths/free-standing-baths.html','catalog/category/view/id/39',0,1,NULL,1,NULL),(7192,'category',39,'bathroom/baths/free-standing-baths.html','bathroom/baths/baths/free-standing-baths.html',301,1,NULL,0,NULL),(7193,'category',256,'bathroom/baths/baths/rectangular-baths.html','catalog/category/view/id/256',0,1,NULL,1,NULL),(7194,'category',42,'bathroom/baths/baths/shower-baths.html','catalog/category/view/id/42',0,1,NULL,1,NULL),(7195,'category',42,'bathroom/baths/shower-baths.html','bathroom/baths/baths/shower-baths.html',301,1,NULL,0,NULL),(7196,'category',40,'bathroom/baths/baths/corner-baths.html','catalog/category/view/id/40',0,1,NULL,1,NULL),(7197,'category',40,'bathroom/baths/corner-baths.html','bathroom/baths/baths/corner-baths.html',301,1,NULL,0,NULL),(7198,'category',41,'bathroom/baths/baths/oval-baths.html','catalog/category/view/id/41',0,1,NULL,1,NULL),(7199,'category',41,'bathroom/baths/oval-baths.html','bathroom/baths/baths/oval-baths.html',301,1,NULL,0,NULL),(7200,'category',257,'bathroom/baths/baths/space-saving-baths.html','catalog/category/view/id/257',0,1,NULL,1,NULL),(7201,'category',43,'bathroom/baths/baths/traditional-baths.html','catalog/category/view/id/43',0,1,NULL,1,NULL),(7202,'category',43,'bathroom/baths/traditional-baths.html','bathroom/baths/baths/traditional-baths.html',301,1,NULL,0,NULL),(7203,'category',38,'bathroom/baths/baths/straight-baths.html','catalog/category/view/id/38',0,1,NULL,1,NULL),(7204,'category',38,'bathroom/baths/straight-baths.html','bathroom/baths/baths/straight-baths.html',301,1,NULL,0,NULL),(7205,'category',182,'bathroom/baths/bathroom-accessories.html','catalog/category/view/id/182',0,1,NULL,1,NULL),(7206,'category',183,'bathroom/baths/bathroom-accessories/towel-rings.html','catalog/category/view/id/183',0,1,NULL,1,NULL),(7207,'category',183,'accessories/bathroom-accessories/towel-rings.html','bathroom/baths/bathroom-accessories/towel-rings.html',301,1,NULL,0,NULL),(7208,'category',184,'bathroom/baths/bathroom-accessories/bathroom-fans.html','catalog/category/view/id/184',0,1,NULL,1,NULL),(7209,'category',184,'accessories/bathroom-accessories/bathroom-fans.html','bathroom/baths/bathroom-accessories/bathroom-fans.html',301,1,NULL,0,NULL),(7210,'category',185,'bathroom/baths/bathroom-accessories/robe-hooks.html','catalog/category/view/id/185',0,1,NULL,1,NULL),(7211,'category',185,'accessories/bathroom-accessories/robe-hooks.html','bathroom/baths/bathroom-accessories/robe-hooks.html',301,1,NULL,0,NULL),(7212,'category',186,'bathroom/baths/bathroom-accessories/wire-baskets.html','catalog/category/view/id/186',0,1,NULL,1,NULL),(7213,'category',186,'accessories/bathroom-accessories/wire-baskets.html','bathroom/baths/bathroom-accessories/wire-baskets.html',301,1,NULL,0,NULL),(7214,'category',188,'bathroom/baths/bathroom-accessories/shelves.html','catalog/category/view/id/188',0,1,NULL,1,NULL),(7215,'category',188,'accessories/bathroom-accessories/shelves.html','bathroom/baths/bathroom-accessories/shelves.html',301,1,NULL,0,NULL),(7216,'category',189,'bathroom/baths/bathroom-accessories/urinal-accessories.html','catalog/category/view/id/189',0,1,NULL,1,NULL),(7217,'category',189,'accessories/bathroom-accessories/urinal-accessories.html','bathroom/baths/bathroom-accessories/urinal-accessories.html',301,1,NULL,0,NULL),(7218,'category',182,'accessories/bathroom-accessories.html','bathroom/baths/bathroom-accessories.html',301,1,NULL,0,NULL),(7219,'category',44,'bathroom/baths/bathroom-accessories/bath-screens.html','catalog/category/view/id/44',0,1,NULL,1,NULL),(7220,'category',44,'bathroom/baths/bath-screens.html','bathroom/baths/bathroom-accessories/bath-screens.html',301,1,NULL,0,NULL),(7221,'category',258,'bathroom/baths/bathroom-accessories/bath-panels.html','catalog/category/view/id/258',0,1,NULL,1,NULL),(7222,'category',45,'bathroom/baths/bathroom-accessories/bath-wastes-and-drainer.html','catalog/category/view/id/45',0,1,NULL,1,NULL),(7223,'category',45,'bathroom/baths/bath-wastes-and-drainer.html','bathroom/baths/bathroom-accessories/bath-wastes-and-drainer.html',301,1,NULL,0,NULL),(7224,'category',259,'bathroom/baths/bathroom-accessories/bath-legsets.html','catalog/category/view/id/259',0,1,NULL,1,NULL),(7225,'category',260,'bathroom/baths/bathroom-accessories/bath-grips.html','catalog/category/view/id/260',0,1,NULL,1,NULL),(7226,'category',261,'bathroom/baths/bathroom-accessories/miscellaneous.html','catalog/category/view/id/261',0,1,NULL,1,NULL),(7227,'category',262,'bathroom/baths/bette.html','catalog/category/view/id/262',0,1,NULL,1,NULL),(7228,'category',263,'bathroom/baths/bette/bette.html','catalog/category/view/id/263',0,1,NULL,1,NULL),(7231,'category',264,'bathroom/baths/bette/geberit.html','catalog/category/view/id/264',0,1,NULL,1,NULL),(7232,'category',264,'bathroom/baths/bette/bette/geberit.html','bathroom/baths/bette/geberit.html',301,1,NULL,0,NULL),(7233,'category',265,'bathroom/baths/bette/grohe.html','catalog/category/view/id/265',0,1,NULL,1,NULL),(7234,'category',265,'bathroom/baths/bette/bette/grohe.html','bathroom/baths/bette/grohe.html',301,1,NULL,0,NULL),(7235,'category',266,'bathroom/baths/bette/hasngrohe.html','catalog/category/view/id/266',0,1,NULL,1,NULL),(7236,'category',267,'bathroom/baths/bette/hudson-reed.html','catalog/category/view/id/267',0,1,NULL,1,NULL),(7237,'category',268,'bathroom/baths/bette/ideal-standard.html','catalog/category/view/id/268',0,1,NULL,1,NULL),(7238,'category',269,'bathroom/baths/bette/matki-showers.html','catalog/category/view/id/269',0,1,NULL,1,NULL),(7239,'category',270,'bathroom/baths/bette/rak-ceramics.html','catalog/category/view/id/270',0,1,NULL,1,NULL),(7240,'category',271,'bathroom/baths/bette/roca.html','catalog/category/view/id/271',0,1,NULL,1,NULL),(7241,'category',272,'bathroom/baths/bette/royce-morgan.html','catalog/category/view/id/272',0,1,NULL,1,NULL),(7242,'category',273,'bathroom/baths/bette/vitra.html','catalog/category/view/id/273',0,1,NULL,1,NULL),(7243,'category',274,'bathroom/baths/bette/nuie.html','catalog/category/view/id/274',0,1,NULL,1,NULL),(7244,'category',275,'bathroom/baths/bette/kaldewei.html','catalog/category/view/id/275',0,1,NULL,1,NULL),(7245,'category',8,'bathroom/taps.html','catalog/category/view/id/8',0,1,NULL,1,NULL),(7256,'category',150,'bathroom/taps/bathroom-taps.html','catalog/category/view/id/150',0,1,NULL,1,NULL),(7281,'category',150,'taps/bathroom-taps.html','bathroom/taps/bathroom-taps.html',301,1,NULL,0,NULL),(7282,'category',8,'taps.html','bathroom/taps.html',301,1,NULL,0,NULL),(7298,'category',159,'bathroom/taps/basin-taps.html','catalog/category/view/id/159',0,1,NULL,1,NULL),(7299,'category',160,'bathroom/taps/basin-taps/basin-mixer-taps.html','catalog/category/view/id/160',0,1,NULL,1,NULL),(7300,'category',160,'bathroom/taps/bathroom-taps/basin-taps/basin-mixer-taps.html','bathroom/taps/basin-taps/basin-mixer-taps.html',301,1,NULL,0,NULL),(7301,'category',160,'taps/bathroom-taps/basin-taps/basin-mixer-taps.html','bathroom/taps/basin-taps/basin-mixer-taps.html',301,1,NULL,0,'[]'),(7302,'category',161,'bathroom/taps/basin-taps/wall-hung-tap.html','catalog/category/view/id/161',0,1,NULL,1,NULL),(7303,'category',161,'bathroom/taps/bathroom-taps/basin-taps/wall-hung-tap.html','bathroom/taps/basin-taps/wall-hung-tap.html',301,1,NULL,0,NULL),(7304,'category',161,'taps/bathroom-taps/basin-taps/wall-hung-tap.html','bathroom/taps/basin-taps/wall-hung-tap.html',301,1,NULL,0,'[]'),(7305,'category',162,'bathroom/taps/basin-taps/sensor-tap.html','catalog/category/view/id/162',0,1,NULL,1,NULL),(7306,'category',162,'bathroom/taps/bathroom-taps/basin-taps/sensor-tap.html','bathroom/taps/basin-taps/sensor-tap.html',301,1,NULL,0,NULL),(7307,'category',162,'taps/bathroom-taps/basin-taps/sensor-tap.html','bathroom/taps/basin-taps/sensor-tap.html',301,1,NULL,0,'[]'),(7308,'category',159,'bathroom/taps/bathroom-taps/basin-taps.html','bathroom/taps/basin-taps.html',301,1,NULL,0,NULL),(7309,'category',159,'taps/bathroom-taps/basin-taps.html','bathroom/taps/basin-taps.html',301,1,NULL,0,'[]'),(7310,'category',152,'bathroom/taps/bath-taps.html','catalog/category/view/id/152',0,1,NULL,1,NULL),(7311,'category',153,'bathroom/taps/bath-taps/single-bath-taps.html','catalog/category/view/id/153',0,1,NULL,1,NULL),(7312,'category',153,'bathroom/taps/bathroom-taps/bath-taps/single-bath-taps.html','bathroom/taps/bath-taps/single-bath-taps.html',301,1,NULL,0,NULL),(7313,'category',153,'taps/bathroom-taps/bath-taps/single-bath-taps.html','bathroom/taps/bath-taps/single-bath-taps.html',301,1,NULL,0,'[]'),(7314,'category',154,'bathroom/taps/bath-taps/mixer-taps.html','catalog/category/view/id/154',0,1,NULL,1,NULL),(7315,'category',154,'bathroom/taps/bathroom-taps/bath-taps/mixer-taps.html','bathroom/taps/bath-taps/mixer-taps.html',301,1,NULL,0,NULL),(7316,'category',154,'taps/bathroom-taps/bath-taps/mixer-taps.html','bathroom/taps/bath-taps/mixer-taps.html',301,1,NULL,0,'[]'),(7317,'category',155,'bathroom/taps/bath-taps/wall-hung-taps.html','catalog/category/view/id/155',0,1,NULL,1,NULL),(7318,'category',155,'bathroom/taps/bathroom-taps/bath-taps/wall-hung-taps.html','bathroom/taps/bath-taps/wall-hung-taps.html',301,1,NULL,0,NULL),(7319,'category',155,'taps/bathroom-taps/bath-taps/wall-hung-taps.html','bathroom/taps/bath-taps/wall-hung-taps.html',301,1,NULL,0,'[]'),(7320,'category',156,'bathroom/taps/bath-taps/free-standing-taps.html','catalog/category/view/id/156',0,1,NULL,1,NULL),(7321,'category',156,'bathroom/taps/bathroom-taps/bath-taps/free-standing-taps.html','bathroom/taps/bath-taps/free-standing-taps.html',301,1,NULL,0,NULL),(7322,'category',156,'taps/bathroom-taps/bath-taps/free-standing-taps.html','bathroom/taps/bath-taps/free-standing-taps.html',301,1,NULL,0,'[]'),(7323,'category',157,'bathroom/taps/bath-taps/bath-spouts.html','catalog/category/view/id/157',0,1,NULL,1,NULL),(7324,'category',157,'bathroom/taps/bathroom-taps/bath-taps/bath-spouts.html','bathroom/taps/bath-taps/bath-spouts.html',301,1,NULL,0,NULL),(7325,'category',157,'taps/bathroom-taps/bath-taps/bath-spouts.html','bathroom/taps/bath-taps/bath-spouts.html',301,1,NULL,0,'[]'),(7326,'category',158,'bathroom/taps/bath-taps/bath-filler.html','catalog/category/view/id/158',0,1,NULL,1,NULL),(7327,'category',158,'bathroom/taps/bathroom-taps/bath-taps/bath-filler.html','bathroom/taps/bath-taps/bath-filler.html',301,1,NULL,0,NULL),(7328,'category',158,'taps/bathroom-taps/bath-taps/bath-filler.html','bathroom/taps/bath-taps/bath-filler.html',301,1,NULL,0,'[]'),(7329,'category',152,'bathroom/taps/bathroom-taps/bath-taps.html','bathroom/taps/bath-taps.html',301,1,NULL,0,NULL),(7330,'category',152,'taps/bathroom-taps/bath-taps.html','bathroom/taps/bath-taps.html',301,1,NULL,0,'[]'),(7331,'category',151,'bathroom/taps/basin-taps/bidet-mixers.html','catalog/category/view/id/151',0,1,NULL,1,NULL),(7332,'category',151,'bathroom/taps/bathroom-taps/bidet-mixers.html','bathroom/taps/basin-taps/bidet-mixers.html',301,1,NULL,0,NULL),(7333,'category',151,'taps/bathroom-taps/bidet-mixers.html','bathroom/taps/basin-taps/bidet-mixers.html',301,1,NULL,0,'[]'),(7334,'category',276,'bathroom/taps/basin-taps/high-rise-basin-taps.html','catalog/category/view/id/276',0,1,NULL,1,NULL),(7335,'category',277,'bathroom/taps/basin-taps/basin-tap-pairs.html','catalog/category/view/id/277',0,1,NULL,1,NULL),(7336,'category',278,'bathroom/taps/basin-taps/bath-basin-tap-sets.html','catalog/category/view/id/278',0,1,NULL,1,NULL),(7337,'category',279,'bathroom/taps/bath-taps/bath-tap-pairs.html','catalog/category/view/id/279',0,1,NULL,1,NULL),(7338,'category',280,'bathroom/taps/bath-taps/deck-mounted-taps.html','catalog/category/view/id/280',0,1,NULL,1,NULL),(7340,'category',282,'bathroom/taps/bath-taps/bath-basin-tap-sets.html','catalog/category/view/id/282',0,1,NULL,1,NULL),(7343,'category',283,'bathroom/mirrors-cabinets/mirrors/standard-mirrors.html','catalog/category/view/id/283',0,1,NULL,1,NULL),(7344,'category',284,'bathroom/mirrors-cabinets/mirrors/led-mirrors.html','catalog/category/view/id/284',0,1,NULL,1,NULL),(7345,'category',285,'bathroom/mirrors-cabinets/mirrors/backlit-mirrors.html','catalog/category/view/id/285',0,1,NULL,1,NULL),(7346,'category',286,'bathroom/mirrors-cabinets/mirrors/demister-mirrors.html','catalog/category/view/id/286',0,1,NULL,1,NULL),(7347,'category',287,'bathroom/mirrors-cabinets/mirrors/magnifying-mirrors.html','catalog/category/view/id/287',0,1,NULL,1,NULL),(7348,'category',288,'bathroom/mirrors-cabinets/mirrors/smart-mirrors.html','catalog/category/view/id/288',0,1,NULL,1,NULL),(7349,'category',289,'bathroom/mirrors-cabinets/brands.html','catalog/category/view/id/289',0,1,NULL,1,NULL),(7350,'category',290,'bathroom/mirrors-cabinets/brands/hib.html','catalog/category/view/id/290',0,1,NULL,1,NULL),(7351,'category',291,'bathroom/mirrors-cabinets/brands/hudson-reed.html','catalog/category/view/id/291',0,1,NULL,1,NULL),(7352,'category',292,'bathroom/mirrors-cabinets/brands/rak-ceramics.html','catalog/category/view/id/292',0,1,NULL,1,NULL),(7353,'category',293,'bathroom/mirrors-cabinets/brands/roca.html','catalog/category/view/id/293',0,1,NULL,1,NULL),(7354,'category',294,'bathroom/mirrors-cabinets/brands/nuie.html','catalog/category/view/id/294',0,1,NULL,1,NULL),(7355,'category',56,'bathroom/mirrors-cabinets/mirror-cabinets.html','catalog/category/view/id/56',0,1,NULL,1,NULL),(7356,'category',56,'bathroom/mirror-cabinets.html','bathroom/mirrors-cabinets/mirror-cabinets.html',301,1,NULL,0,NULL),(7357,'category',295,'bathroom/bathroom-furniture/bathroom-furniture.html','catalog/category/view/id/295',0,1,NULL,1,NULL),(7358,'category',47,'bathroom/bathroom-furniture/bathroom-furniture/floor-standing-units.html','catalog/category/view/id/47',0,1,NULL,1,NULL),(7359,'category',47,'bathroom/bathroom-furniture/floor-standing-units.html','bathroom/bathroom-furniture/bathroom-furniture/floor-standing-units.html',301,1,NULL,0,NULL),(7360,'category',48,'bathroom/bathroom-furniture/bathroom-furniture/wall-hung-units.html','catalog/category/view/id/48',0,1,NULL,1,NULL),(7361,'category',48,'bathroom/bathroom-furniture/wall-hung-units.html','bathroom/bathroom-furniture/bathroom-furniture/wall-hung-units.html',301,1,NULL,0,NULL),(7362,'category',49,'bathroom/bathroom-furniture/bathroom-furniture/cloakroom-units.html','catalog/category/view/id/49',0,1,NULL,1,NULL),(7363,'category',49,'bathroom/bathroom-furniture/cloakroom-units.html','bathroom/bathroom-furniture/bathroom-furniture/cloakroom-units.html',301,1,NULL,0,NULL),(7364,'category',50,'bathroom/bathroom-furniture/bathroom-furniture/wc-units.html','catalog/category/view/id/50',0,1,NULL,1,NULL),(7365,'category',50,'bathroom/bathroom-furniture/wc-units.html','bathroom/bathroom-furniture/bathroom-furniture/wc-units.html',301,1,NULL,0,NULL),(7366,'category',296,'bathroom/bathroom-furniture/bathroom-furniture/corner-vanity-units.html','catalog/category/view/id/296',0,1,NULL,1,NULL),(7367,'category',297,'bathroom/bathroom-furniture/bathroom-furniture/double-sink-vanity-units.html','catalog/category/view/id/297',0,1,NULL,1,NULL),(7368,'category',298,'bathroom/bathroom-furniture/bathroom-furniture/countertop-vanity-units.html','catalog/category/view/id/298',0,1,NULL,1,NULL),(7369,'category',299,'bathroom/bathroom-furniture/bathroom-furniture/toilet-and-sink-units.html','catalog/category/view/id/299',0,1,NULL,1,NULL),(7370,'category',300,'bathroom/bathroom-furniture/bathroom-furniture/tall-bathroom-cabinets.html','catalog/category/view/id/300',0,1,NULL,1,NULL),(7371,'category',301,'bathroom/bathroom-furniture/brands.html','catalog/category/view/id/301',0,1,NULL,1,NULL),(7372,'category',302,'bathroom/bathroom-furniture/brands/hudson-reed.html','catalog/category/view/id/302',0,1,NULL,1,NULL),(7373,'category',303,'bathroom/bathroom-furniture/brands/rak-ceramics.html','catalog/category/view/id/303',0,1,NULL,1,NULL),(7374,'category',304,'bathroom/bathroom-furniture/brands/roca.html','catalog/category/view/id/304',0,1,NULL,1,NULL),(7375,'category',305,'bathroom/bathroom-furniture/brands/vitra.html','catalog/category/view/id/305',0,1,NULL,1,NULL),(7376,'category',306,'bathroom/bathroom-furniture/brands/nuie.html','catalog/category/view/id/306',0,1,NULL,1,NULL),(7392,'category',318,'kitchen-appliances/kitchens-sinks.html','catalog/category/view/id/318',0,1,NULL,1,NULL),(7395,'category',107,'kitchen-appliances/kitchen-sinks/full-sinks.html','kitchen-appliances/kitchen-sinks/sink-type/full-sinks.html',301,1,NULL,0,'[]'),(7397,'category',109,'kitchen-appliances/kitchen-sinks/sink-tap-packages.html','kitchen-appliances/kitchen-sinks/sink-type/sink-tap-packages.html',301,1,NULL,0,'[]'),(7401,'category',307,'kitchen-appliances/kitchen-sinks/undermount.html','kitchen-appliances/kitchen-sinks/sink-type/undermount.html',301,1,NULL,0,'[]'),(7403,'category',308,'kitchen-appliances/kitchen-sinks/inset-flushmount.html','kitchen-appliances/kitchen-sinks/sink-type/inset-flushmount.html',301,1,NULL,0,'[]'),(7405,'category',309,'kitchen-appliances/kitchen-sinks/1-0-bowl-sinks.html','kitchen-appliances/kitchen-sinks/sink-type/1-0-bowl-sinks.html',301,1,NULL,0,'[]'),(7407,'category',310,'kitchen-appliances/kitchen-sinks/1-5-bowl-sinks.html','kitchen-appliances/kitchen-sinks/sink-type/1-5-bowl-sinks.html',301,1,NULL,0,'[]'),(7409,'category',311,'kitchen-appliances/kitchen-sinks/2-0-bowl-sinks.html','kitchen-appliances/kitchen-sinks/sink-type/2-0-bowl-sinks.html',301,1,NULL,0,'[]'),(7410,'category',311,'kitchen-appliances/kitchen-sinks/1-5-bowl-sinks/2-0-bowl-sinks.html','kitchen-appliances/kitchen-sinks/sink-type/2-0-bowl-sinks.html',301,1,NULL,0,'[]'),(7412,'category',312,'kitchen-appliances/kitchen-sinks/belfast-sinks.html','kitchen-appliances/kitchen-sinks/sink-type/belfast-sinks.html',301,1,NULL,0,'[]'),(7413,'category',106,'kitchen-appliances/kitchen-sinks.html','kitchen-appliances/kitchen-sinks/sink-type.html',301,1,NULL,0,'[]'),(7416,'category',108,'kitchen-appliances/sink-material/stainless-steel-sinks.html','kitchen-appliances/kitchen-sinks/sink-material/stainless-steel-sinks.html',301,1,NULL,0,'[]'),(7417,'category',108,'kitchen-appliances/kitchen-sinks/stainless-steel-sinks.html','kitchen-appliances/kitchen-sinks/sink-material/stainless-steel-sinks.html',301,1,NULL,0,'[]'),(7419,'category',314,'kitchen-appliances/sink-material/ceramic-sinks.html','kitchen-appliances/kitchen-sinks/sink-material/ceramic-sinks.html',301,1,NULL,0,'[]'),(7421,'category',315,'kitchen-appliances/sink-material/granite-sinks.html','kitchen-appliances/kitchen-sinks/sink-material/granite-sinks.html',301,1,NULL,0,'[]'),(7423,'category',316,'kitchen-appliances/sink-material/composite-sinks.html','kitchen-appliances/kitchen-sinks/sink-material/composite-sinks.html',301,1,NULL,0,'[]'),(7425,'category',317,'kitchen-appliances/sink-material/coloured-sinks.html','kitchen-appliances/kitchen-sinks/sink-material/coloured-sinks.html',301,1,NULL,0,'[]'),(7426,'category',313,'kitchen-appliances/sink-material.html','kitchen-appliances/kitchen-sinks/sink-material.html',301,1,NULL,0,'[]'),(7448,'category',106,'kitchen-appliances/kitchen-sinks/sink-type.html','catalog/category/view/id/106',0,1,NULL,1,NULL),(7449,'category',107,'kitchen-appliances/kitchen-sinks/sink-type/full-sinks.html','catalog/category/view/id/107',0,1,NULL,1,NULL),(7450,'category',109,'kitchen-appliances/kitchen-sinks/sink-type/sink-tap-packages.html','catalog/category/view/id/109',0,1,NULL,1,NULL),(7452,'category',307,'kitchen-appliances/kitchen-sinks/sink-type/undermount.html','catalog/category/view/id/307',0,1,NULL,1,NULL),(7453,'category',308,'kitchen-appliances/kitchen-sinks/sink-type/inset-flushmount.html','catalog/category/view/id/308',0,1,NULL,1,NULL),(7454,'category',309,'kitchen-appliances/kitchen-sinks/sink-type/1-0-bowl-sinks.html','catalog/category/view/id/309',0,1,NULL,1,NULL),(7455,'category',310,'kitchen-appliances/kitchen-sinks/sink-type/1-5-bowl-sinks.html','catalog/category/view/id/310',0,1,NULL,1,NULL),(7456,'category',311,'kitchen-appliances/kitchen-sinks/sink-type/2-0-bowl-sinks.html','catalog/category/view/id/311',0,1,NULL,1,NULL),(7457,'category',312,'kitchen-appliances/kitchen-sinks/sink-type/belfast-sinks.html','catalog/category/view/id/312',0,1,NULL,1,NULL),(7458,'category',313,'kitchen-appliances/kitchen-sinks/sink-material.html','catalog/category/view/id/313',0,1,NULL,1,NULL),(7459,'category',108,'kitchen-appliances/kitchen-sinks/sink-material/stainless-steel-sinks.html','catalog/category/view/id/108',0,1,NULL,1,NULL),(7460,'category',314,'kitchen-appliances/kitchen-sinks/sink-material/ceramic-sinks.html','catalog/category/view/id/314',0,1,NULL,1,NULL),(7461,'category',315,'kitchen-appliances/kitchen-sinks/sink-material/granite-sinks.html','catalog/category/view/id/315',0,1,NULL,1,NULL),(7462,'category',316,'kitchen-appliances/kitchen-sinks/sink-material/composite-sinks.html','catalog/category/view/id/316',0,1,NULL,1,NULL),(7463,'category',317,'kitchen-appliances/kitchen-sinks/sink-material/coloured-sinks.html','catalog/category/view/id/317',0,1,NULL,1,NULL),(7482,'category',319,'kitchen-appliances/kitchen-sinks/accessories.html','catalog/category/view/id/319',0,1,NULL,1,NULL),(7484,'category',321,'kitchen-appliances/kitchen-sinks/accessories/waster-sorter.html','catalog/category/view/id/321',0,1,NULL,1,NULL),(7485,'category',322,'kitchen-appliances/kitchen-sinks/accessories/plumbing-kits.html','catalog/category/view/id/322',0,1,NULL,1,NULL),(7486,'category',323,'kitchen-appliances/kitchen-sinks/brands.html','catalog/category/view/id/323',0,1,NULL,1,NULL),(7487,'category',324,'kitchen-appliances/kitchen-sinks/brands/franke.html','catalog/category/view/id/324',0,1,NULL,1,NULL),(7488,'category',325,'kitchen-appliances/kitchen-sinks/brands/reginox.html','catalog/category/view/id/325',0,1,NULL,1,NULL),(7489,'category',326,'kitchen-appliances/kitchen-sinks/brands/blanco.html','catalog/category/view/id/326',0,1,NULL,1,NULL),(7490,'category',327,'kitchen-appliances/kitchen-sinks/brands/grohe.html','catalog/category/view/id/327',0,1,NULL,1,NULL),(7491,'category',328,'kitchen-appliances/kitchen-sinks/brands/hansgrohe.html','catalog/category/view/id/328',0,1,NULL,1,NULL),(7492,'category',145,'kitchen-appliances/kitchen-taps.html','catalog/category/view/id/145',0,1,NULL,1,NULL),(7493,'category',146,'kitchen-appliances/kitchen-taps/kitchen-sink-taps.html','catalog/category/view/id/146',0,1,NULL,1,NULL),(7494,'category',146,'kitchen-taps/kitchen-sink-taps.html','kitchen-appliances/kitchen-taps/kitchen-sink-taps.html',301,1,NULL,0,NULL),(7495,'category',146,'bathroom/taps/kitchen-taps/kitchen-sink-taps.html','kitchen-appliances/kitchen-taps/kitchen-sink-taps.html',301,1,NULL,0,'[]'),(7496,'category',146,'taps/kitchen-taps/kitchen-sink-taps.html','kitchen-appliances/kitchen-taps/kitchen-sink-taps.html',301,1,NULL,0,'[]'),(7505,'category',149,'kitchen-appliances/kitchen-taps/sensor-taps.html','catalog/category/view/id/149',0,1,NULL,1,NULL),(7506,'category',149,'kitchen-taps/sensor-taps.html','kitchen-appliances/kitchen-taps/sensor-taps.html',301,1,NULL,0,NULL),(7507,'category',149,'bathroom/taps/kitchen-taps/sensor-taps.html','kitchen-appliances/kitchen-taps/sensor-taps.html',301,1,NULL,0,'[]'),(7508,'category',149,'taps/kitchen-taps/sensor-taps.html','kitchen-appliances/kitchen-taps/sensor-taps.html',301,1,NULL,0,'[]'),(7509,'category',145,'kitchen-taps.html','kitchen-appliances/kitchen-taps.html',301,1,NULL,0,NULL),(7510,'category',145,'bathroom/taps/kitchen-taps.html','kitchen-appliances/kitchen-taps.html',301,1,NULL,0,'[]'),(7511,'category',145,'taps/kitchen-taps.html','kitchen-appliances/kitchen-taps.html',301,1,NULL,0,'[]'),(7512,'category',329,'kitchen-appliances/kitchen-taps/kitchen-tap-type.html','catalog/category/view/id/329',0,1,NULL,1,NULL),(7513,'category',110,'kitchen-appliances/kitchen-sinks/accessories/kitchen-accessories.html','catalog/category/view/id/110',0,1,NULL,1,NULL),(7514,'category',110,'kitchen-appliances/kitchen-sinks/kitchen-accessories.html','kitchen-appliances/kitchen-sinks/accessories/kitchen-accessories.html',301,1,NULL,0,'[]'),(7515,'category',110,'kitchen-appliances/kitchen-sinks/sink-type/kitchen-accessories.html','kitchen-appliances/kitchen-sinks/accessories/kitchen-accessories.html',301,1,NULL,0,NULL),(7516,'category',330,'kitchen-appliances/kitchen-taps/kitchen-tap-type/kitchen-mixer-taps.html','catalog/category/view/id/330',0,1,NULL,1,NULL),(7517,'category',331,'kitchen-appliances/kitchen-taps/kitchen-tap-type/pull-out-kitchen-taps.html','catalog/category/view/id/331',0,1,NULL,1,NULL),(7518,'category',332,'kitchen-appliances/kitchen-taps/kitchen-tap-type/coloured-kitchen-taps.html','catalog/category/view/id/332',0,1,NULL,1,NULL),(7521,'category',335,'kitchen-appliances/kitchen-taps/kitchen-tap-type/sparkling-water-taps.html','catalog/category/view/id/335',0,1,NULL,1,NULL),(7522,'category',336,'kitchen-appliances/kitchen-taps/kitchen-tap-type/smart-taps.html','catalog/category/view/id/336',0,1,NULL,1,NULL),(7523,'category',148,'kitchen-appliances/kitchen-taps/kitchen-tap-type/filter-flow-taps.html','catalog/category/view/id/148',0,1,NULL,1,NULL),(7524,'category',148,'kitchen-appliances/kitchen-taps/filter-flow-taps.html','kitchen-appliances/kitchen-taps/kitchen-tap-type/filter-flow-taps.html',301,1,NULL,0,NULL),(7525,'category',148,'kitchen-taps/filter-flow-taps.html','kitchen-appliances/kitchen-taps/kitchen-tap-type/filter-flow-taps.html',301,1,NULL,0,'[]'),(7526,'category',148,'bathroom/taps/kitchen-taps/filter-flow-taps.html','kitchen-appliances/kitchen-taps/kitchen-tap-type/filter-flow-taps.html',301,1,NULL,0,'[]'),(7527,'category',148,'taps/kitchen-taps/filter-flow-taps.html','kitchen-appliances/kitchen-taps/kitchen-tap-type/filter-flow-taps.html',301,1,NULL,0,'[]'),(7528,'category',147,'kitchen-appliances/kitchen-taps/kitchen-tap-type/instant-hot-water-taps.html','catalog/category/view/id/147',0,1,NULL,1,NULL),(7529,'category',147,'kitchen-appliances/kitchen-taps/instant-hot-water-taps.html','kitchen-appliances/kitchen-taps/kitchen-tap-type/instant-hot-water-taps.html',301,1,NULL,0,NULL),(7530,'category',147,'kitchen-taps/instant-hot-water-taps.html','kitchen-appliances/kitchen-taps/kitchen-tap-type/instant-hot-water-taps.html',301,1,NULL,0,'[]'),(7531,'category',147,'bathroom/taps/kitchen-taps/instant-hot-water-taps.html','kitchen-appliances/kitchen-taps/kitchen-tap-type/instant-hot-water-taps.html',301,1,NULL,0,'[]'),(7532,'category',147,'taps/kitchen-taps/instant-hot-water-taps.html','kitchen-appliances/kitchen-taps/kitchen-tap-type/instant-hot-water-taps.html',301,1,NULL,0,'[]'),(7539,'category',343,'kitchen-appliances/appliances.html','catalog/category/view/id/343',0,1,NULL,1,NULL),(7540,'category',337,'kitchen-appliances/kitchen-taps/brands.html','catalog/category/view/id/337',0,1,NULL,1,NULL),(7541,'category',338,'kitchen-appliances/kitchen-taps/brands/franke.html','catalog/category/view/id/338',0,1,NULL,1,NULL),(7542,'category',338,'kitchen-appliances/brands/franke.html','kitchen-appliances/kitchen-taps/brands/franke.html',301,1,NULL,0,NULL),(7543,'category',339,'kitchen-appliances/kitchen-taps/brands/blanco.html','catalog/category/view/id/339',0,1,NULL,1,NULL),(7544,'category',339,'kitchen-appliances/brands/blanco.html','kitchen-appliances/kitchen-taps/brands/blanco.html',301,1,NULL,0,NULL),(7545,'category',340,'kitchen-appliances/kitchen-taps/brands/reginox.html','catalog/category/view/id/340',0,1,NULL,1,NULL),(7546,'category',340,'kitchen-appliances/brands/reginox.html','kitchen-appliances/kitchen-taps/brands/reginox.html',301,1,NULL,0,NULL),(7547,'category',341,'kitchen-appliances/kitchen-taps/brands/grohe.html','catalog/category/view/id/341',0,1,NULL,1,NULL),(7548,'category',341,'kitchen-appliances/brands/grohe.html','kitchen-appliances/kitchen-taps/brands/grohe.html',301,1,NULL,0,NULL),(7549,'category',342,'kitchen-appliances/kitchen-taps/brands/hansgrohe.html','catalog/category/view/id/342',0,1,NULL,1,NULL),(7550,'category',342,'kitchen-appliances/brands/hansgrohe.html','kitchen-appliances/kitchen-taps/brands/hansgrohe.html',301,1,NULL,0,NULL),(7551,'category',337,'kitchen-appliances/brands.html','kitchen-appliances/kitchen-taps/brands.html',301,1,NULL,0,NULL),(7552,'category',344,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories.html','catalog/category/view/id/344',0,1,NULL,1,NULL),(7553,'category',345,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/soap-dispensors.html','catalog/category/view/id/345',0,1,NULL,1,NULL),(7554,'category',346,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/filters.html','catalog/category/view/id/346',0,1,NULL,1,NULL),(7555,'category',347,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/hot-water-tanks.html','catalog/category/view/id/347',0,1,NULL,1,NULL),(7556,'category',87,'kitchen-appliances/appliances/cooking-baking.html','catalog/category/view/id/87',0,1,NULL,1,NULL),(7557,'category',88,'kitchen-appliances/appliances/cooking-baking/ovens.html','catalog/category/view/id/88',0,1,NULL,1,NULL),(7558,'category',88,'kitchen-appliances/cooking-baking/ovens.html','kitchen-appliances/appliances/cooking-baking/ovens.html',301,1,NULL,0,NULL),(7559,'category',89,'kitchen-appliances/appliances/cooking-baking/hobs.html','catalog/category/view/id/89',0,1,NULL,1,NULL),(7560,'category',89,'kitchen-appliances/cooking-baking/hobs.html','kitchen-appliances/appliances/cooking-baking/hobs.html',301,1,NULL,0,NULL),(7561,'category',90,'kitchen-appliances/appliances/cooking-baking/steam-appliances.html','catalog/category/view/id/90',0,1,NULL,1,NULL),(7562,'category',90,'kitchen-appliances/cooking-baking/steam-appliances.html','kitchen-appliances/appliances/cooking-baking/steam-appliances.html',301,1,NULL,0,NULL),(7563,'category',91,'kitchen-appliances/appliances/cooking-baking/microwaves.html','catalog/category/view/id/91',0,1,NULL,1,NULL),(7564,'category',91,'kitchen-appliances/cooking-baking/microwaves.html','kitchen-appliances/appliances/cooking-baking/microwaves.html',301,1,NULL,0,NULL),(7565,'category',92,'kitchen-appliances/appliances/cooking-baking/coffee-machine.html','catalog/category/view/id/92',0,1,NULL,1,NULL),(7566,'category',92,'kitchen-appliances/cooking-baking/coffee-machine.html','kitchen-appliances/appliances/cooking-baking/coffee-machine.html',301,1,NULL,0,NULL),(7567,'category',93,'kitchen-appliances/appliances/cooking-baking/cooker-hoods.html','catalog/category/view/id/93',0,1,NULL,1,NULL),(7568,'category',93,'kitchen-appliances/cooking-baking/cooker-hoods.html','kitchen-appliances/appliances/cooking-baking/cooker-hoods.html',301,1,NULL,0,NULL),(7569,'category',94,'kitchen-appliances/appliances/cooking-baking/warming-drawers.html','catalog/category/view/id/94',0,1,NULL,1,NULL),(7570,'category',94,'kitchen-appliances/cooking-baking/warming-drawers.html','kitchen-appliances/appliances/cooking-baking/warming-drawers.html',301,1,NULL,0,NULL),(7571,'category',95,'kitchen-appliances/appliances/cooking-baking/cooking-accessories.html','catalog/category/view/id/95',0,1,NULL,1,NULL),(7572,'category',95,'kitchen-appliances/cooking-baking/cooking-accessories.html','kitchen-appliances/appliances/cooking-baking/cooking-accessories.html',301,1,NULL,0,NULL),(7573,'category',87,'kitchen-appliances/cooking-baking.html','kitchen-appliances/appliances/cooking-baking.html',301,1,NULL,0,NULL),(7574,'category',96,'kitchen-appliances/appliances/washers-dryers.html','catalog/category/view/id/96',0,1,NULL,1,NULL),(7575,'category',97,'kitchen-appliances/appliances/washers-dryers/washing-machines.html','catalog/category/view/id/97',0,1,NULL,1,NULL),(7576,'category',97,'kitchen-appliances/washers-dryers/washing-machines.html','kitchen-appliances/appliances/washers-dryers/washing-machines.html',301,1,NULL,0,NULL),(7577,'category',96,'kitchen-appliances/washers-dryers.html','kitchen-appliances/appliances/washers-dryers.html',301,1,NULL,0,NULL),(7578,'category',98,'kitchen-appliances/appliances/dishwashers.html','catalog/category/view/id/98',0,1,NULL,1,NULL),(7579,'category',99,'kitchen-appliances/appliances/dishwashers/built-in-dishwashers.html','catalog/category/view/id/99',0,1,NULL,1,NULL),(7580,'category',99,'kitchen-appliances/dishwashers/built-in-dishwashers.html','kitchen-appliances/appliances/dishwashers/built-in-dishwashers.html',301,1,NULL,0,NULL),(7581,'category',98,'kitchen-appliances/dishwashers.html','kitchen-appliances/appliances/dishwashers.html',301,1,NULL,0,NULL),(7582,'category',100,'kitchen-appliances/appliances/fridges-freezers.html','catalog/category/view/id/100',0,1,NULL,1,NULL),(7583,'category',101,'kitchen-appliances/appliances/fridges-freezers/fridges-freezers.html','catalog/category/view/id/101',0,1,NULL,1,NULL),(7584,'category',101,'kitchen-appliances/fridges-freezers/fridges-freezers.html','kitchen-appliances/appliances/fridges-freezers/fridges-freezers.html',301,1,NULL,0,NULL),(7585,'category',102,'kitchen-appliances/appliances/fridges-freezers/fridges.html','catalog/category/view/id/102',0,1,NULL,1,NULL),(7586,'category',102,'kitchen-appliances/fridges-freezers/fridges.html','kitchen-appliances/appliances/fridges-freezers/fridges.html',301,1,NULL,0,NULL),(7587,'category',103,'kitchen-appliances/appliances/fridges-freezers/freezers.html','catalog/category/view/id/103',0,1,NULL,1,NULL),(7588,'category',103,'kitchen-appliances/fridges-freezers/freezers.html','kitchen-appliances/appliances/fridges-freezers/freezers.html',301,1,NULL,0,NULL),(7589,'category',104,'kitchen-appliances/appliances/fridges-freezers/wine-coolers.html','catalog/category/view/id/104',0,1,NULL,1,NULL),(7590,'category',104,'kitchen-appliances/fridges-freezers/wine-coolers.html','kitchen-appliances/appliances/fridges-freezers/wine-coolers.html',301,1,NULL,0,NULL),(7591,'category',105,'kitchen-appliances/appliances/fridges-freezers/american-style-fridge-freezers.html','catalog/category/view/id/105',0,1,NULL,1,NULL),(7592,'category',105,'kitchen-appliances/fridges-freezers/american-style-fridge-freezers.html','kitchen-appliances/appliances/fridges-freezers/american-style-fridge-freezers.html',301,1,NULL,0,NULL),(7593,'category',100,'kitchen-appliances/fridges-freezers.html','kitchen-appliances/appliances/fridges-freezers.html',301,1,NULL,0,NULL),(7594,'category',348,'kitchen-appliances/appliances/accessories.html','catalog/category/view/id/348',0,1,NULL,1,NULL),(7595,'category',349,'kitchen-appliances/appliances/accessories/accessories.html','catalog/category/view/id/349',0,1,NULL,1,NULL),(7596,'category',350,'kitchen-appliances/appliances/brands.html','catalog/category/view/id/350',0,1,NULL,1,NULL),(7597,'category',351,'kitchen-appliances/appliances/brands/bosch.html','catalog/category/view/id/351',0,1,NULL,1,NULL),(7598,'category',352,'kitchen-appliances/appliances/brands/neff.html','catalog/category/view/id/352',0,1,NULL,1,NULL),(7599,'category',353,'kitchen-appliances/appliances/brands/siemens.html','catalog/category/view/id/353',0,1,NULL,1,NULL),(7600,'category',354,'kitchen-appliances/appliances/brands/franke.html','catalog/category/view/id/354',0,1,NULL,1,NULL),(7601,'category',355,'kitchen-appliances/appliances/brands/elica.html','catalog/category/view/id/355',0,1,NULL,1,NULL),(7602,'category',356,'kitchen-appliances/kitchen-accessories.html','catalog/category/view/id/356',0,1,NULL,1,NULL),(7603,'category',358,'kitchen-appliances/kitchen-accessories/accessories.html','catalog/category/view/id/358',0,1,NULL,1,NULL),(7604,'category',359,'kitchen-appliances/kitchen-accessories/accessories/soap-dispensors.html','catalog/category/view/id/359',0,1,NULL,1,NULL),(7605,'category',360,'kitchen-appliances/kitchen-accessories/accessories/chopping-boards.html','catalog/category/view/id/360',0,1,NULL,1,NULL),(7606,'category',361,'kitchen-appliances/kitchen-accessories/accessories/strainers.html','catalog/category/view/id/361',0,1,NULL,1,NULL),(7607,'category',362,'kitchen-appliances/kitchen-accessories/accessories/colanders.html','catalog/category/view/id/362',0,1,NULL,1,NULL),(7608,'category',363,'kitchen-appliances/kitchen-accessories/accessories/metal-grids.html','catalog/category/view/id/363',0,1,NULL,1,NULL),(7609,'category',364,'kitchen-appliances/kitchen-accessories/accessories/cleaning-sprays.html','catalog/category/view/id/364',0,1,NULL,1,NULL),(7610,'category',365,'kitchen-appliances/kitchen-accessories/accessories/waste-and-plumbing-kits.html','catalog/category/view/id/365',0,1,NULL,1,NULL),(7614,'category',366,'heating/radiators.html','catalog/category/view/id/366',0,1,NULL,1,NULL),(7615,'category',366,'radiators.html','heating/radiators.html',301,1,NULL,0,NULL),(7616,'category',367,'heating/radiators/radiators.html','catalog/category/view/id/367',0,1,NULL,1,NULL),(7617,'category',135,'heating/radiators/radiators/designer-radiators.html','catalog/category/view/id/135',0,1,NULL,1,NULL),(7630,'category',135,'heating/designer-radiators.html','heating/radiators/radiators/designer-radiators.html',301,1,NULL,0,NULL),(7631,'category',136,'heating/radiators/radiators/vertical-designer-radiators.html','catalog/category/view/id/136',0,1,NULL,1,NULL),(7632,'category',136,'heating/radiators/radiators/designer-radiators/vertical-designer-radiators.html','heating/radiators/radiators/vertical-designer-radiators.html',301,1,NULL,0,NULL),(7633,'category',136,'heating/designer-radiators/vertical-designer-radiators.html','heating/radiators/radiators/vertical-designer-radiators.html',301,1,NULL,0,'[]'),(7634,'category',137,'heating/radiators/radiators/horizontal-designer-radiators.html','catalog/category/view/id/137',0,1,NULL,1,NULL),(7635,'category',137,'heating/radiators/radiators/designer-radiators/horizontal-designer-radiators.html','heating/radiators/radiators/horizontal-designer-radiators.html',301,1,NULL,0,NULL),(7636,'category',137,'heating/designer-radiators/horizontal-designer-radiators.html','heating/radiators/radiators/horizontal-designer-radiators.html',301,1,NULL,0,'[]'),(7637,'category',138,'heating/radiators/radiators/traditional-radiators.html','catalog/category/view/id/138',0,1,NULL,1,NULL),(7638,'category',138,'heating/radiators/radiators/designer-radiators/traditional-radiators.html','heating/radiators/radiators/traditional-radiators.html',301,1,NULL,0,NULL),(7639,'category',138,'heating/designer-radiators/traditional-radiators.html','heating/radiators/radiators/traditional-radiators.html',301,1,NULL,0,'[]'),(7640,'category',139,'heating/radiators/radiators/electric-radiators.html','catalog/category/view/id/139',0,1,NULL,1,NULL),(7641,'category',139,'heating/radiators/radiators/designer-radiators/electric-radiators.html','heating/radiators/radiators/electric-radiators.html',301,1,NULL,0,NULL),(7642,'category',139,'heating/designer-radiators/electric-radiators.html','heating/radiators/radiators/electric-radiators.html',301,1,NULL,0,'[]'),(7643,'category',140,'heating/radiators/radiators/radiator-valves.html','catalog/category/view/id/140',0,1,NULL,1,NULL),(7644,'category',140,'heating/radiators/radiators/designer-radiators/radiator-valves.html','heating/radiators/radiators/radiator-valves.html',301,1,NULL,0,NULL),(7645,'category',140,'heating/designer-radiators/radiator-valves.html','heating/radiators/radiators/radiator-valves.html',301,1,NULL,0,'[]'),(7646,'category',141,'heating/radiators/radiators/heating-elements.html','catalog/category/view/id/141',0,1,NULL,1,NULL),(7647,'category',141,'heating/radiators/radiators/designer-radiators/heating-elements.html','heating/radiators/radiators/heating-elements.html',301,1,NULL,0,NULL),(7648,'category',141,'heating/designer-radiators/heating-elements.html','heating/radiators/radiators/heating-elements.html',301,1,NULL,0,'[]'),(7649,'category',368,'heating/radiators/radiators/column-radiators.html','catalog/category/view/id/368',0,1,NULL,1,NULL),(7650,'category',369,'heating/radiators/radiators/convector-radiators.html','catalog/category/view/id/369',0,1,NULL,1,NULL),(7651,'category',370,'heating/radiators/radiators/floor-standing-radiators.html','catalog/category/view/id/370',0,1,NULL,1,NULL),(7653,'category',142,'heating/radiators/towel-rails.html','catalog/category/view/id/142',0,1,NULL,1,NULL),(7654,'category',143,'heating/radiators/towel-rails/heated-towel-rails.html','catalog/category/view/id/143',0,1,NULL,1,NULL),(7655,'category',143,'heating/towel-rails/heated-towel-rails.html','heating/radiators/towel-rails/heated-towel-rails.html',301,1,NULL,0,NULL),(7656,'category',144,'heating/radiators/towel-rails/electric-towel-rails.html','catalog/category/view/id/144',0,1,NULL,1,NULL),(7657,'category',144,'heating/towel-rails/electric-towel-rails.html','heating/radiators/towel-rails/electric-towel-rails.html',301,1,NULL,0,NULL),(7658,'category',371,'heating/radiators/towel-rails/dual-fuel-towel-rails.html','catalog/category/view/id/371',0,1,NULL,1,NULL),(7659,'category',371,'heating/towel-rails/dual-fuel-towel-rails.html','heating/radiators/towel-rails/dual-fuel-towel-rails.html',301,1,NULL,0,NULL),(7660,'category',142,'heating/towel-rails.html','heating/radiators/towel-rails.html',301,1,NULL,0,NULL),(7661,'category',372,'heating/radiators/brands.html','catalog/category/view/id/372',0,1,NULL,1,NULL),(7662,'category',373,'heating/radiators/brands/nuie.html','catalog/category/view/id/373',0,1,NULL,1,NULL),(7663,'category',374,'heating/radiators/brands/hudson-reed.html','catalog/category/view/id/374',0,1,NULL,1,NULL),(7664,'category',375,'heating/radiators/brands/carisa.html','catalog/category/view/id/375',0,1,NULL,1,NULL),(7665,'category',376,'heating/radiators/brands/zehnder.html','catalog/category/view/id/376',0,1,NULL,1,NULL),(7666,'category',377,'heating/radiators/brands/reina.html','catalog/category/view/id/377',0,1,NULL,1,NULL),(7717,'category',6,'heating/fires.html','catalog/category/view/id/6',0,1,NULL,1,NULL),(7718,'category',111,'heating/fires/gas-fires.html','catalog/category/view/id/111',0,1,NULL,1,NULL),(7719,'category',112,'heating/fires/gas-fires/front-view-gas-fires.html','catalog/category/view/id/112',0,1,NULL,1,NULL),(7720,'category',112,'fires/gas-fires/front-view-gas-fires.html','heating/fires/gas-fires/front-view-gas-fires.html',301,1,NULL,0,'[]'),(7721,'category',113,'heating/fires/gas-fires/corner-gas-fires.html','catalog/category/view/id/113',0,1,NULL,1,NULL),(7722,'category',113,'fires/gas-fires/corner-gas-fires.html','heating/fires/gas-fires/corner-gas-fires.html',301,1,NULL,0,'[]'),(7723,'category',114,'heating/fires/gas-fires/three-sided-gas-fires.html','catalog/category/view/id/114',0,1,NULL,1,NULL),(7724,'category',114,'fires/gas-fires/three-sided-gas-fires.html','heating/fires/gas-fires/three-sided-gas-fires.html',301,1,NULL,0,'[]'),(7725,'category',115,'heating/fires/gas-fires/tunnel-gas-fires.html','catalog/category/view/id/115',0,1,NULL,1,NULL),(7726,'category',115,'fires/gas-fires/tunnel-gas-fires.html','heating/fires/gas-fires/tunnel-gas-fires.html',301,1,NULL,0,'[]'),(7727,'category',116,'heating/fires/gas-fires/heaters.html','catalog/category/view/id/116',0,1,NULL,1,NULL),(7728,'category',116,'fires/gas-fires/heaters.html','heating/fires/gas-fires/heaters.html',301,1,NULL,0,'[]'),(7729,'category',117,'heating/fires/gas-fires/hole-in-the-wall-gas-fires.html','catalog/category/view/id/117',0,1,NULL,1,NULL),(7730,'category',117,'fires/gas-fires/hole-in-the-wall-gas-fires.html','heating/fires/gas-fires/hole-in-the-wall-gas-fires.html',301,1,NULL,0,'[]'),(7731,'category',118,'heating/fires/gas-fires/high-efficiency-gas-fires.html','catalog/category/view/id/118',0,1,NULL,1,NULL),(7732,'category',118,'fires/gas-fires/high-efficiency-gas-fires.html','heating/fires/gas-fires/high-efficiency-gas-fires.html',301,1,NULL,0,'[]'),(7733,'category',119,'heating/fires/gas-fires/glass-fronted-gas-fire.html','catalog/category/view/id/119',0,1,NULL,1,NULL),(7734,'category',119,'fires/gas-fires/glass-fronted-gas-fire.html','heating/fires/gas-fires/glass-fronted-gas-fire.html',301,1,NULL,0,'[]'),(7735,'category',120,'heating/fires/gas-fires/inset-gas-fires.html','catalog/category/view/id/120',0,1,NULL,1,NULL),(7736,'category',120,'fires/gas-fires/inset-gas-fires.html','heating/fires/gas-fires/inset-gas-fires.html',301,1,NULL,0,'[]'),(7737,'category',121,'heating/fires/gas-fires/wall-mounted-gas-fires.html','catalog/category/view/id/121',0,1,NULL,1,NULL),(7738,'category',121,'fires/gas-fires/wall-mounted-gas-fires.html','heating/fires/gas-fires/wall-mounted-gas-fires.html',301,1,NULL,0,'[]'),(7739,'category',122,'heating/fires/gas-fires/balanced-flue-gas-fires.html','catalog/category/view/id/122',0,1,NULL,1,NULL),(7740,'category',122,'fires/gas-fires/balanced-flue-gas-fires.html','heating/fires/gas-fires/balanced-flue-gas-fires.html',301,1,NULL,0,'[]'),(7741,'category',123,'heating/fires/gas-fires/flueless-gas-fires.html','catalog/category/view/id/123',0,1,NULL,1,NULL),(7742,'category',123,'fires/gas-fires/flueless-gas-fires.html','heating/fires/gas-fires/flueless-gas-fires.html',301,1,NULL,0,'[]'),(7743,'category',111,'fires/gas-fires.html','heating/fires/gas-fires.html',301,1,NULL,0,'[]'),(7744,'category',124,'heating/fires/stoves.html','catalog/category/view/id/124',0,1,NULL,1,NULL),(7745,'category',125,'heating/fires/stoves/wood-multifuel-stoves.html','catalog/category/view/id/125',0,1,NULL,1,NULL),(7746,'category',125,'fires/stoves/wood-multifuel-stoves.html','heating/fires/stoves/wood-multifuel-stoves.html',301,1,NULL,0,'[]'),(7747,'category',126,'heating/fires/stoves/electric-stoves.html','catalog/category/view/id/126',0,1,NULL,1,NULL),(7748,'category',126,'fires/stoves/electric-stoves.html','heating/fires/stoves/electric-stoves.html',301,1,NULL,0,'[]'),(7749,'category',127,'heating/fires/stoves/wood-burning-stoves.html','catalog/category/view/id/127',0,1,NULL,1,NULL),(7750,'category',127,'fires/stoves/wood-burning-stoves.html','heating/fires/stoves/wood-burning-stoves.html',301,1,NULL,0,'[]'),(7751,'category',128,'heating/fires/stoves/gas-stoves.html','catalog/category/view/id/128',0,1,NULL,1,NULL),(7752,'category',128,'fires/stoves/gas-stoves.html','heating/fires/stoves/gas-stoves.html',301,1,NULL,0,'[]'),(7753,'category',124,'fires/stoves.html','heating/fires/stoves.html',301,1,NULL,0,'[]'),(7754,'category',129,'heating/fires/electric-fires.html','catalog/category/view/id/129',0,1,NULL,1,NULL),(7755,'category',130,'heating/fires/electric-fires/inset-electric-fires.html','catalog/category/view/id/130',0,1,NULL,1,NULL),(7756,'category',130,'fires/electric-fires/inset-electric-fires.html','heating/fires/electric-fires/inset-electric-fires.html',301,1,NULL,0,'[]'),(7759,'category',132,'heating/fires/electric-fires/wall-mounted-electric-fires.html','catalog/category/view/id/132',0,1,NULL,1,NULL),(7760,'category',132,'fires/electric-fires/wall-mounted-electric-fires.html','heating/fires/electric-fires/wall-mounted-electric-fires.html',301,1,NULL,0,'[]'),(7761,'category',133,'heating/fires/electric-fires/electric-fires-and-surrounds.html','catalog/category/view/id/133',0,1,NULL,1,NULL),(7762,'category',133,'fires/electric-fires/electric-fires-and-surrounds.html','heating/fires/electric-fires/electric-fires-and-surrounds.html',301,1,NULL,0,'[]'),(7763,'category',129,'fires/electric-fires.html','heating/fires/electric-fires.html',301,1,NULL,0,'[]'),(7764,'category',134,'heating/fires/fires-accessories.html','catalog/category/view/id/134',0,1,NULL,1,NULL),(7765,'category',134,'fires/fires-accessories.html','heating/fires/fires-accessories.html',301,1,NULL,0,'[]'),(7766,'category',6,'fires.html','heating/fires.html',301,1,NULL,0,'[]'),(7767,'category',378,'heating/fires/gas-fires/floor-standing-fires.html','catalog/category/view/id/378',0,1,NULL,1,NULL),(7768,'category',379,'heating/fires/gas-fires/top-control-side-control-gas-fires.html','catalog/category/view/id/379',0,1,NULL,1,NULL),(7769,'category',380,'heating/fires/gas-fires/outdoor-gas-fires.html','catalog/category/view/id/380',0,1,NULL,1,NULL),(7773,'category',381,'heating/fires/electric-fires/floor-standing-electric-fires.html','catalog/category/view/id/381',0,1,NULL,1,NULL),(7774,'category',382,'heating/fires/electric-fires/hole-in-the-wall-electric-fires.html','catalog/category/view/id/382',0,1,NULL,1,NULL),(7775,'category',383,'heating/fires/stoves/flueless-gas-stoves.html','catalog/category/view/id/383',0,1,NULL,1,NULL),(7776,'category',384,'heating/fires/stoves/inset-gas-stoves.html','catalog/category/view/id/384',0,1,NULL,1,NULL),(7777,'category',385,'heating/fires/fireplase-suite.html','catalog/category/view/id/385',0,1,NULL,1,NULL),(7778,'category',386,'heating/fires/fireplase-suite/gas-fireplaces.html','catalog/category/view/id/386',0,1,NULL,1,NULL),(7779,'category',387,'heating/fires/fireplase-suite/electric-fireplaces.html','catalog/category/view/id/387',0,1,NULL,1,NULL),(7780,'category',388,'heating/fires/media-wall-electric-fires.html','catalog/category/view/id/388',0,1,NULL,1,NULL),(7781,'category',389,'heating/fires/media-wall-electric-fires/media-wall-electric-fires.html','catalog/category/view/id/389',0,1,NULL,1,NULL),(7782,'category',390,'heating/fires/brands.html','catalog/category/view/id/390',0,1,NULL,1,NULL),(7783,'category',391,'heating/fires/brands/ag-stoves.html','catalog/category/view/id/391',0,1,NULL,1,NULL),(7784,'category',392,'heating/fires/brands/dik-guerts.html','catalog/category/view/id/392',0,1,NULL,1,NULL),(7785,'category',393,'heating/fires/brands/dimplex.html','catalog/category/view/id/393',0,1,NULL,1,NULL),(7786,'category',394,'heating/fires/brands/dru.html','catalog/category/view/id/394',0,1,NULL,1,NULL),(7787,'category',395,'heating/fires/brands/ekofires.html','catalog/category/view/id/395',0,1,NULL,1,NULL),(7788,'category',396,'heating/fires/brands/element-4.html','catalog/category/view/id/396',0,1,NULL,1,NULL),(7789,'category',397,'heating/fires/brands/esse.html','catalog/category/view/id/397',0,1,NULL,1,NULL),(7790,'category',398,'heating/fires/brands/evonice-fires.html','catalog/category/view/id/398',0,1,NULL,1,NULL),(7791,'category',399,'heating/fires/brands/carron-fires.html','catalog/category/view/id/399',0,1,NULL,1,NULL),(7792,'category',400,'heating/fires/brands/flamerite-fires.html','catalog/category/view/id/400',0,1,NULL,1,NULL),(7793,'category',401,'heating/fires/brands/flavel.html','catalog/category/view/id/401',0,1,NULL,1,NULL),(7794,'category',402,'heating/fires/brands/valor.html','catalog/category/view/id/402',0,1,NULL,1,NULL),(7795,'category',403,'heating/fires/brands/gazco.html','catalog/category/view/id/403',0,1,NULL,1,NULL),(7796,'category',404,'brands/a-d.html','catalog/category/view/id/404',0,1,NULL,1,NULL),(7797,'category',405,'brands/a-d/aga-stoves.html','catalog/category/view/id/405',0,1,NULL,1,NULL),(7798,'category',406,'brands/a-d/bette.html','catalog/category/view/id/406',0,1,NULL,1,NULL),(7799,'category',407,'brands/a-d/blanco.html','catalog/category/view/id/407',0,1,NULL,1,NULL),(7800,'category',408,'brands/a-d/carisa.html','catalog/category/view/id/408',0,1,NULL,1,NULL),(7801,'category',409,'brands/a-d/dik-guerts.html','catalog/category/view/id/409',0,1,NULL,1,NULL),(7802,'category',410,'brands/a-d/dimplex.html','catalog/category/view/id/410',0,1,NULL,1,NULL),(7803,'category',411,'brands/a-d/dru.html','catalog/category/view/id/411',0,1,NULL,1,NULL),(7804,'category',412,'brands/e-i.html','catalog/category/view/id/412',0,1,NULL,1,NULL),(7805,'category',413,'brands/e-i/ekofires.html','catalog/category/view/id/413',0,1,NULL,1,NULL),(7806,'category',414,'brands/e-i/element-4.html','catalog/category/view/id/414',0,1,NULL,1,NULL),(7807,'category',415,'brands/e-i/elica.html','catalog/category/view/id/415',0,1,NULL,1,NULL),(7808,'category',416,'brands/e-i/esse.html','catalog/category/view/id/416',0,1,NULL,1,NULL),(7809,'category',417,'brands/e-i/evonic-fires.html','catalog/category/view/id/417',0,1,NULL,1,NULL),(7810,'category',418,'brands/e-i/flamerite-fires.html','catalog/category/view/id/418',0,1,NULL,1,NULL),(7811,'category',419,'brands/e-i/flavel.html','catalog/category/view/id/419',0,1,NULL,1,NULL),(7812,'category',420,'brands/e-i/franke.html','catalog/category/view/id/420',0,1,NULL,1,NULL),(7813,'category',421,'brands/e-i/gazco.html','catalog/category/view/id/421',0,1,NULL,1,NULL),(7814,'category',422,'brands/e-i/geberit.html','catalog/category/view/id/422',0,1,NULL,1,NULL),(7815,'category',423,'brands/e-i/grohe.html','catalog/category/view/id/423',0,1,NULL,1,NULL),(7816,'category',424,'brands/e-i/hansgrohe.html','catalog/category/view/id/424',0,1,NULL,1,NULL),(7817,'category',425,'brands/e-i/hib.html','catalog/category/view/id/425',0,1,NULL,1,NULL),(7818,'category',426,'brands/e-i/hudson-reed.html','catalog/category/view/id/426',0,1,NULL,1,NULL),(7819,'category',427,'brands/e-i/ideal-standard.html','catalog/category/view/id/427',0,1,NULL,1,NULL),(7820,'category',428,'brands/j-r.html','catalog/category/view/id/428',0,1,NULL,1,NULL),(7821,'category',429,'brands/j-r/kaldewei.html','catalog/category/view/id/429',0,1,NULL,1,NULL),(7822,'category',430,'brands/j-r/matki.html','catalog/category/view/id/430',0,1,NULL,1,NULL),(7823,'category',431,'brands/j-r/neff.html','catalog/category/view/id/431',0,1,NULL,1,NULL),(7824,'category',432,'brands/j-r/nuie.html','catalog/category/view/id/432',0,1,NULL,1,NULL),(7825,'category',433,'brands/j-r/rak-ceramics.html','catalog/category/view/id/433',0,1,NULL,1,NULL),(7826,'category',434,'brands/j-r/reginox.html','catalog/category/view/id/434',0,1,NULL,1,NULL),(7827,'category',435,'brands/j-r/reina.html','catalog/category/view/id/435',0,1,NULL,1,NULL),(7828,'category',436,'brands/j-r/roca.html','catalog/category/view/id/436',0,1,NULL,1,NULL),(7829,'category',437,'brands/j-r/royce-morgan.html','catalog/category/view/id/437',0,1,NULL,1,NULL),(7830,'category',438,'brands/s-z.html','catalog/category/view/id/438',0,1,NULL,1,NULL),(7831,'category',439,'brands/s-z/siemens.html','catalog/category/view/id/439',0,1,NULL,1,NULL),(7832,'category',440,'brands/s-z/spartherm.html','catalog/category/view/id/440',0,1,NULL,1,NULL),(7833,'category',441,'brands/s-z/valor.html','catalog/category/view/id/441',0,1,NULL,1,NULL),(7834,'category',442,'brands/s-z/vitra.html','catalog/category/view/id/442',0,1,NULL,1,NULL),(7835,'category',443,'brands/s-z/zehnder.html','catalog/category/view/id/443',0,1,NULL,1,NULL),(7836,'category',444,'brands/a-d/aeon.html','catalog/category/view/id/444',0,1,NULL,1,NULL),(7837,'category',445,'heating/fires/fireplase-suite/wood-burning-fireplace.html','catalog/category/view/id/445',0,1,NULL,1,NULL),(7838,'category',227,'bathroom/basins/accessories/soap-dispenser.html','catalog/category/view/id/227',0,1,NULL,1,NULL),(7839,'category',3,'bathroom.html','catalog/category/view/id/3',0,2,NULL,1,NULL),(7840,'category',219,'bathroom/toilet.html','catalog/category/view/id/219',0,2,NULL,1,NULL),(7841,'category',15,'bathroom/toilet/toilets.html','catalog/category/view/id/15',0,2,NULL,1,NULL),(7842,'category',16,'bathroom/toilet/toilets/close-coupled-toilets.html','catalog/category/view/id/16',0,2,NULL,1,NULL),(7843,'category',17,'bathroom/toilet/toilets/back-to-wall-toilets.html','catalog/category/view/id/17',0,2,NULL,1,NULL),(7844,'category',18,'bathroom/toilet/toilets/wall-hung-toilets.html','catalog/category/view/id/18',0,2,NULL,1,NULL),(7845,'category',198,'bathroom/toilet/toilets/comfort-height-toilets.html','catalog/category/view/id/198',0,2,NULL,1,NULL),(7846,'category',199,'bathroom/toilet/toilets/rimless-toilets.html','catalog/category/view/id/199',0,2,NULL,1,NULL),(7847,'category',20,'bathroom/toilet/toilets/corner-toilets.html','catalog/category/view/id/20',0,2,NULL,1,NULL),(7848,'category',200,'bathroom/toilet/toilets/wc-unit.html','catalog/category/view/id/200',0,2,NULL,1,NULL),(7849,'category',201,'bathroom/toilet/toilets/smart-toilets.html','catalog/category/view/id/201',0,2,NULL,1,NULL),(7850,'category',202,'bathroom/toilet/toilets/doc-m-packs.html','catalog/category/view/id/202',0,2,NULL,1,NULL),(7851,'category',21,'bathroom/toilet/toilets/bidets.html','catalog/category/view/id/21',0,2,NULL,1,NULL),(7852,'category',22,'bathroom/toilet/toilets/urinals.html','catalog/category/view/id/22',0,2,NULL,1,NULL),(7853,'category',24,'bathroom/toilet/toilets/concealed-cisterns.html','catalog/category/view/id/24',0,2,NULL,1,NULL),(7854,'category',203,'bathroom/toilet/toilet-accessories.html','catalog/category/view/id/203',0,2,NULL,1,NULL),(7855,'category',187,'bathroom/toilet/toilet-accessories/toilet-roll-holders.html','catalog/category/view/id/187',0,2,NULL,1,NULL),(7856,'category',204,'bathroom/toilet/toilet-accessories/douche-shattafs.html','catalog/category/view/id/204',0,2,NULL,1,NULL),(7857,'category',205,'bathroom/toilet/toilet-accessories/flush-buttons-plates.html','catalog/category/view/id/205',0,2,NULL,1,NULL),(7858,'category',208,'bathroom/toilet/toilet-accessories/toilet-brush-and-holders.html','catalog/category/view/id/208',0,2,NULL,1,NULL),(7859,'category',23,'bathroom/toilet/toilet-accessories/toilet-seats.html','catalog/category/view/id/23',0,2,NULL,1,NULL),(7860,'category',209,'bathroom/toilet/brands.html','catalog/category/view/id/209',0,2,NULL,1,NULL),(7861,'category',210,'bathroom/toilet/brands/rak.html','catalog/category/view/id/210',0,2,NULL,1,NULL),(7862,'category',211,'bathroom/toilet/brands/geberit.html','catalog/category/view/id/211',0,2,NULL,1,NULL),(7863,'category',212,'bathroom/toilet/brands/grohe.html','catalog/category/view/id/212',0,2,NULL,1,NULL),(7864,'category',213,'bathroom/toilet/brands/hudson-reed.html','catalog/category/view/id/213',0,2,NULL,1,NULL),(7865,'category',214,'bathroom/toilet/brands/roca.html','catalog/category/view/id/214',0,2,NULL,1,NULL),(7866,'category',215,'bathroom/toilet/brands/vitra.html','catalog/category/view/id/215',0,2,NULL,1,NULL),(7867,'category',216,'bathroom/toilet/brands/nuie.html','catalog/category/view/id/216',0,2,NULL,1,NULL),(7868,'category',25,'bathroom/basins.html','catalog/category/view/id/25',0,2,NULL,1,NULL),(7869,'category',221,'bathroom/basins/basins.html','catalog/category/view/id/221',0,2,NULL,1,NULL),(7870,'category',222,'bathroom/basins/basins/semi-pedestal-basins.html','catalog/category/view/id/222',0,2,NULL,1,NULL),(7871,'category',223,'bathroom/basins/basins/space-saver-basins.html','catalog/category/view/id/223',0,2,NULL,1,NULL),(7872,'category',224,'bathroom/basins/basins/freestanding-basin.html','catalog/category/view/id/224',0,2,NULL,1,NULL),(7873,'category',225,'bathroom/basins/basins/washstands.html','catalog/category/view/id/225',0,2,NULL,1,NULL),(7874,'category',26,'bathroom/basins/basins/pedestal-basins.html','catalog/category/view/id/26',0,2,NULL,1,NULL),(7875,'category',27,'bathroom/basins/basins/wall-hung-basins.html','catalog/category/view/id/27',0,2,NULL,1,NULL),(7876,'category',28,'bathroom/basins/basins/corner-basins.html','catalog/category/view/id/28',0,2,NULL,1,NULL),(7877,'category',29,'bathroom/basins/basins/cloakroom-basins.html','catalog/category/view/id/29',0,2,NULL,1,NULL),(7878,'category',30,'bathroom/basins/basins/vanity-basins.html','catalog/category/view/id/30',0,2,NULL,1,NULL),(7879,'category',31,'bathroom/basins/basins/semi-recessed-basins.html','catalog/category/view/id/31',0,2,NULL,1,NULL),(7880,'category',32,'bathroom/basins/basins/under-counter-basins.html','catalog/category/view/id/32',0,2,NULL,1,NULL),(7881,'category',33,'bathroom/basins/basins/counter-top-basins.html','catalog/category/view/id/33',0,2,NULL,1,NULL),(7882,'category',34,'bathroom/basins/basins/sit-on-basins.html','catalog/category/view/id/34',0,2,NULL,1,NULL),(7883,'category',226,'bathroom/basins/accessories.html','catalog/category/view/id/226',0,2,NULL,1,NULL),(7884,'category',190,'bathroom/basins/accessories/soap-dishes.html','catalog/category/view/id/190',0,2,NULL,1,NULL),(7885,'category',227,'bathroom/basins/accessories/soap-dispenser.html','catalog/category/view/id/227',0,2,NULL,1,NULL),(7886,'category',229,'bathroom/basins/accessories/towel-rails.html','catalog/category/view/id/229',0,2,NULL,1,NULL),(7887,'category',35,'bathroom/basins/accessories/bottle-traps.html','catalog/category/view/id/35',0,2,NULL,1,NULL),(7888,'category',36,'bathroom/basins/accessories/basin-wastes.html','catalog/category/view/id/36',0,2,NULL,1,NULL),(7889,'category',60,'bathroom/basins/accessories/basin-frames.html','catalog/category/view/id/60',0,2,NULL,1,NULL),(7890,'category',230,'bathroom/basins/brands.html','catalog/category/view/id/230',0,2,NULL,1,NULL),(7891,'category',231,'bathroom/basins/brands/rak.html','catalog/category/view/id/231',0,2,NULL,1,NULL),(7892,'category',232,'bathroom/basins/brands/geberit.html','catalog/category/view/id/232',0,2,NULL,1,NULL),(7893,'category',233,'bathroom/basins/brands/grohe.html','catalog/category/view/id/233',0,2,NULL,1,NULL),(7894,'category',234,'bathroom/basins/brands/hudson-reed.html','catalog/category/view/id/234',0,2,NULL,1,NULL),(7895,'category',235,'bathroom/basins/brands/roca.html','catalog/category/view/id/235',0,2,NULL,1,NULL),(7896,'category',236,'bathroom/basins/brands/vitra.html','catalog/category/view/id/236',0,2,NULL,1,NULL),(7897,'category',237,'bathroom/basins/brands/nuie.html','catalog/category/view/id/237',0,2,NULL,1,NULL),(7898,'category',37,'bathroom/baths.html','catalog/category/view/id/37',0,2,NULL,1,NULL),(7899,'category',182,'bathroom/baths/bathroom-accessories.html','catalog/category/view/id/182',0,2,NULL,1,NULL),(7900,'category',183,'bathroom/baths/bathroom-accessories/towel-rings.html','catalog/category/view/id/183',0,2,NULL,1,NULL),(7901,'category',184,'bathroom/baths/bathroom-accessories/bathroom-fans.html','catalog/category/view/id/184',0,2,NULL,1,NULL),(7902,'category',185,'bathroom/baths/bathroom-accessories/robe-hooks.html','catalog/category/view/id/185',0,2,NULL,1,NULL),(7903,'category',186,'bathroom/baths/bathroom-accessories/wire-baskets.html','catalog/category/view/id/186',0,2,NULL,1,NULL),(7904,'category',188,'bathroom/baths/bathroom-accessories/shelves.html','catalog/category/view/id/188',0,2,NULL,1,NULL),(7905,'category',189,'bathroom/baths/bathroom-accessories/urinal-accessories.html','catalog/category/view/id/189',0,2,NULL,1,NULL),(7906,'category',258,'bathroom/baths/bathroom-accessories/bath-panels.html','catalog/category/view/id/258',0,2,NULL,1,NULL),(7907,'category',259,'bathroom/baths/bathroom-accessories/bath-legsets.html','catalog/category/view/id/259',0,2,NULL,1,NULL),(7908,'category',260,'bathroom/baths/bathroom-accessories/bath-grips.html','catalog/category/view/id/260',0,2,NULL,1,NULL),(7909,'category',261,'bathroom/baths/bathroom-accessories/miscellaneous.html','catalog/category/view/id/261',0,2,NULL,1,NULL),(7910,'category',44,'bathroom/baths/bathroom-accessories/bath-screens.html','catalog/category/view/id/44',0,2,NULL,1,NULL),(7911,'category',45,'bathroom/baths/bathroom-accessories/bath-wastes-and-drainer.html','catalog/category/view/id/45',0,2,NULL,1,NULL),(7912,'category',253,'bathroom/baths/baths.html','catalog/category/view/id/253',0,2,NULL,1,NULL),(7913,'category',254,'bathroom/baths/baths/single-ended-baths.html','catalog/category/view/id/254',0,2,NULL,1,NULL),(7914,'category',255,'bathroom/baths/baths/double-ended-baths.html','catalog/category/view/id/255',0,2,NULL,1,NULL),(7915,'category',256,'bathroom/baths/baths/rectangular-baths.html','catalog/category/view/id/256',0,2,NULL,1,NULL),(7916,'category',257,'bathroom/baths/baths/space-saving-baths.html','catalog/category/view/id/257',0,2,NULL,1,NULL),(7917,'category',38,'bathroom/baths/baths/straight-baths.html','catalog/category/view/id/38',0,2,NULL,1,NULL),(7918,'category',39,'bathroom/baths/baths/free-standing-baths.html','catalog/category/view/id/39',0,2,NULL,1,NULL),(7919,'category',40,'bathroom/baths/baths/corner-baths.html','catalog/category/view/id/40',0,2,NULL,1,NULL),(7920,'category',41,'bathroom/baths/baths/oval-baths.html','catalog/category/view/id/41',0,2,NULL,1,NULL),(7921,'category',42,'bathroom/baths/baths/shower-baths.html','catalog/category/view/id/42',0,2,NULL,1,NULL),(7922,'category',43,'bathroom/baths/baths/traditional-baths.html','catalog/category/view/id/43',0,2,NULL,1,NULL),(7923,'category',262,'bathroom/baths/bette.html','catalog/category/view/id/262',0,2,NULL,1,NULL),(7924,'category',263,'bathroom/baths/bette/bette.html','catalog/category/view/id/263',0,2,NULL,1,NULL),(7925,'category',264,'bathroom/baths/bette/geberit.html','catalog/category/view/id/264',0,2,NULL,1,NULL),(7926,'category',265,'bathroom/baths/bette/grohe.html','catalog/category/view/id/265',0,2,NULL,1,NULL),(7927,'category',266,'bathroom/baths/bette/hasngrohe.html','catalog/category/view/id/266',0,2,NULL,1,NULL),(7928,'category',267,'bathroom/baths/bette/hudson-reed.html','catalog/category/view/id/267',0,2,NULL,1,NULL),(7929,'category',268,'bathroom/baths/bette/ideal-standard.html','catalog/category/view/id/268',0,2,NULL,1,NULL),(7930,'category',269,'bathroom/baths/bette/matki-showers.html','catalog/category/view/id/269',0,2,NULL,1,NULL),(7931,'category',270,'bathroom/baths/bette/rak-ceramics.html','catalog/category/view/id/270',0,2,NULL,1,NULL),(7932,'category',271,'bathroom/baths/bette/roca.html','catalog/category/view/id/271',0,2,NULL,1,NULL),(7933,'category',272,'bathroom/baths/bette/royce-morgan.html','catalog/category/view/id/272',0,2,NULL,1,NULL),(7934,'category',273,'bathroom/baths/bette/vitra.html','catalog/category/view/id/273',0,2,NULL,1,NULL),(7935,'category',274,'bathroom/baths/bette/nuie.html','catalog/category/view/id/274',0,2,NULL,1,NULL),(7936,'category',275,'bathroom/baths/bette/kaldewei.html','catalog/category/view/id/275',0,2,NULL,1,NULL),(7937,'category',4,'bathroom/showering.html','catalog/category/view/id/4',0,2,NULL,1,NULL),(7938,'category',247,'bathroom/showering/brands.html','catalog/category/view/id/247',0,2,NULL,1,NULL),(7939,'category',248,'bathroom/showering/brands/matki.html','catalog/category/view/id/248',0,2,NULL,1,NULL),(7940,'category',249,'bathroom/showering/brands/nuei.html','catalog/category/view/id/249',0,2,NULL,1,NULL),(7941,'category',250,'bathroom/showering/brands/ideal-stnadard.html','catalog/category/view/id/250',0,2,NULL,1,NULL),(7942,'category',251,'bathroom/showering/brands/hudson-reed.html','catalog/category/view/id/251',0,2,NULL,1,NULL),(7943,'category',252,'bathroom/showering/brands/rak.html','catalog/category/view/id/252',0,2,NULL,1,NULL),(7944,'category',66,'bathroom/showering/shower-doors.html','catalog/category/view/id/66',0,2,NULL,1,NULL),(7945,'category',67,'bathroom/showering/shower-doors/pivot-doors.html','catalog/category/view/id/67',0,2,NULL,1,NULL),(7946,'category',68,'bathroom/showering/shower-doors/hinged-doors.html','catalog/category/view/id/68',0,2,NULL,1,NULL),(7947,'category',69,'bathroom/showering/shower-doors/sliding-doors.html','catalog/category/view/id/69',0,2,NULL,1,NULL),(7948,'category',70,'bathroom/showering/shower-doors/bi-fold-doors.html','catalog/category/view/id/70',0,2,NULL,1,NULL),(7949,'category',71,'bathroom/showering/shower-enclosures.html','catalog/category/view/id/71',0,2,NULL,1,NULL),(7950,'category',245,'bathroom/showering/shower-enclosures/curved-enclosures.html','catalog/category/view/id/245',0,2,NULL,1,NULL),(7951,'category',246,'bathroom/showering/shower-enclosures/3-sided-enclosures.html','catalog/category/view/id/246',0,2,NULL,1,NULL),(7952,'category',72,'bathroom/showering/shower-enclosures/pivot-enclosures.html','catalog/category/view/id/72',0,2,NULL,1,NULL),(7953,'category',73,'bathroom/showering/shower-enclosures/hinged-enclosures.html','catalog/category/view/id/73',0,2,NULL,1,NULL),(7954,'category',74,'bathroom/showering/shower-enclosures/sliding-enclosures.html','catalog/category/view/id/74',0,2,NULL,1,NULL),(7955,'category',75,'bathroom/showering/shower-enclosures/bi-fold-enclosures.html','catalog/category/view/id/75',0,2,NULL,1,NULL),(7956,'category',76,'bathroom/showering/shower-enclosures/d-shaped-enclosures.html','catalog/category/view/id/76',0,2,NULL,1,NULL),(7957,'category',77,'bathroom/showering/shower-enclosures/walk-in-showers.html','catalog/category/view/id/77',0,2,NULL,1,NULL),(7958,'category',78,'bathroom/showering/shower-enclosures/quadrant.html','catalog/category/view/id/78',0,2,NULL,1,NULL),(7959,'category',79,'bathroom/showering/shower-enclosures/pentagons.html','catalog/category/view/id/79',0,2,NULL,1,NULL),(7960,'category',80,'bathroom/showering/shower-enclosures/wet-rooms.html','catalog/category/view/id/80',0,2,NULL,1,NULL),(7961,'category',81,'bathroom/showering/shower-enclosures/corner-entry-enclosures.html','catalog/category/view/id/81',0,2,NULL,1,NULL),(7962,'category',82,'bathroom/showering/shower-trays.html','catalog/category/view/id/82',0,2,NULL,1,NULL),(7963,'category',83,'bathroom/showering/shower-trays/square-trays.html','catalog/category/view/id/83',0,2,NULL,1,NULL),(7964,'category',84,'bathroom/showering/shower-trays/rectangular-trays.html','catalog/category/view/id/84',0,2,NULL,1,NULL),(7965,'category',85,'bathroom/showering/shower-trays/quadrant-trays.html','catalog/category/view/id/85',0,2,NULL,1,NULL),(7966,'category',86,'bathroom/showering/shower-trays/pentagon-trays.html','catalog/category/view/id/86',0,2,NULL,1,NULL),(7967,'category',46,'bathroom/bathroom-furniture.html','catalog/category/view/id/46',0,2,NULL,1,NULL),(7968,'category',295,'bathroom/bathroom-furniture/bathroom-furniture.html','catalog/category/view/id/295',0,2,NULL,1,NULL),(7969,'category',296,'bathroom/bathroom-furniture/bathroom-furniture/corner-vanity-units.html','catalog/category/view/id/296',0,2,NULL,1,NULL),(7970,'category',297,'bathroom/bathroom-furniture/bathroom-furniture/double-sink-vanity-units.html','catalog/category/view/id/297',0,2,NULL,1,NULL),(7971,'category',298,'bathroom/bathroom-furniture/bathroom-furniture/countertop-vanity-units.html','catalog/category/view/id/298',0,2,NULL,1,NULL),(7972,'category',299,'bathroom/bathroom-furniture/bathroom-furniture/toilet-and-sink-units.html','catalog/category/view/id/299',0,2,NULL,1,NULL),(7973,'category',300,'bathroom/bathroom-furniture/bathroom-furniture/tall-bathroom-cabinets.html','catalog/category/view/id/300',0,2,NULL,1,NULL),(7974,'category',47,'bathroom/bathroom-furniture/bathroom-furniture/floor-standing-units.html','catalog/category/view/id/47',0,2,NULL,1,NULL),(7975,'category',48,'bathroom/bathroom-furniture/bathroom-furniture/wall-hung-units.html','catalog/category/view/id/48',0,2,NULL,1,NULL),(7976,'category',49,'bathroom/bathroom-furniture/bathroom-furniture/cloakroom-units.html','catalog/category/view/id/49',0,2,NULL,1,NULL),(7977,'category',50,'bathroom/bathroom-furniture/bathroom-furniture/wc-units.html','catalog/category/view/id/50',0,2,NULL,1,NULL),(7978,'category',301,'bathroom/bathroom-furniture/brands.html','catalog/category/view/id/301',0,2,NULL,1,NULL),(7979,'category',302,'bathroom/bathroom-furniture/brands/hudson-reed.html','catalog/category/view/id/302',0,2,NULL,1,NULL),(7980,'category',303,'bathroom/bathroom-furniture/brands/rak-ceramics.html','catalog/category/view/id/303',0,2,NULL,1,NULL),(7981,'category',304,'bathroom/bathroom-furniture/brands/roca.html','catalog/category/view/id/304',0,2,NULL,1,NULL),(7982,'category',305,'bathroom/bathroom-furniture/brands/vitra.html','catalog/category/view/id/305',0,2,NULL,1,NULL),(7983,'category',306,'bathroom/bathroom-furniture/brands/nuie.html','catalog/category/view/id/306',0,2,NULL,1,NULL),(7984,'category',51,'bathroom/bathroom-suites.html','catalog/category/view/id/51',0,2,NULL,1,NULL),(7985,'category',52,'bathroom/bathroom-suites/cloakroom-suites.html','catalog/category/view/id/52',0,2,NULL,1,NULL),(7986,'category',53,'bathroom/bathroom-suites/contemporary-suites.html','catalog/category/view/id/53',0,2,NULL,1,NULL),(7987,'category',54,'bathroom/mirrors-cabinets.html','catalog/category/view/id/54',0,2,NULL,1,NULL),(7988,'category',289,'bathroom/mirrors-cabinets/brands.html','catalog/category/view/id/289',0,2,NULL,1,NULL),(7989,'category',290,'bathroom/mirrors-cabinets/brands/hib.html','catalog/category/view/id/290',0,2,NULL,1,NULL),(7990,'category',291,'bathroom/mirrors-cabinets/brands/hudson-reed.html','catalog/category/view/id/291',0,2,NULL,1,NULL),(7991,'category',292,'bathroom/mirrors-cabinets/brands/rak-ceramics.html','catalog/category/view/id/292',0,2,NULL,1,NULL),(7992,'category',293,'bathroom/mirrors-cabinets/brands/roca.html','catalog/category/view/id/293',0,2,NULL,1,NULL),(7993,'category',294,'bathroom/mirrors-cabinets/brands/nuie.html','catalog/category/view/id/294',0,2,NULL,1,NULL),(7994,'category',55,'bathroom/mirrors-cabinets/mirrors.html','catalog/category/view/id/55',0,2,NULL,1,NULL),(7995,'category',283,'bathroom/mirrors-cabinets/mirrors/standard-mirrors.html','catalog/category/view/id/283',0,2,NULL,1,NULL),(7996,'category',284,'bathroom/mirrors-cabinets/mirrors/led-mirrors.html','catalog/category/view/id/284',0,2,NULL,1,NULL),(7997,'category',285,'bathroom/mirrors-cabinets/mirrors/backlit-mirrors.html','catalog/category/view/id/285',0,2,NULL,1,NULL),(7998,'category',286,'bathroom/mirrors-cabinets/mirrors/demister-mirrors.html','catalog/category/view/id/286',0,2,NULL,1,NULL),(7999,'category',287,'bathroom/mirrors-cabinets/mirrors/magnifying-mirrors.html','catalog/category/view/id/287',0,2,NULL,1,NULL),(8000,'category',288,'bathroom/mirrors-cabinets/mirrors/smart-mirrors.html','catalog/category/view/id/288',0,2,NULL,1,NULL),(8001,'category',56,'bathroom/mirrors-cabinets/mirror-cabinets.html','catalog/category/view/id/56',0,2,NULL,1,NULL),(8002,'category',57,'bathroom/frames-plates.html','catalog/category/view/id/57',0,2,NULL,1,NULL),(8003,'category',58,'bathroom/frames-plates/bidet-frames.html','catalog/category/view/id/58',0,2,NULL,1,NULL),(8004,'category',59,'bathroom/frames-plates/toilet-frames.html','catalog/category/view/id/59',0,2,NULL,1,NULL),(8005,'category',61,'bathroom/frames-plates/plates.html','catalog/category/view/id/61',0,2,NULL,1,NULL),(8006,'category',62,'bathroom/pvc-panels.html','catalog/category/view/id/62',0,2,NULL,1,NULL),(8007,'category',63,'bathroom/pvc-panels/ceiling-panels.html','catalog/category/view/id/63',0,2,NULL,1,NULL),(8008,'category',64,'bathroom/pvc-panels/wall-splash-panels.html','catalog/category/view/id/64',0,2,NULL,1,NULL),(8009,'category',65,'bathroom/pvc-panels/pvc-trims.html','catalog/category/view/id/65',0,2,NULL,1,NULL),(8010,'category',8,'bathroom/taps.html','catalog/category/view/id/8',0,2,NULL,1,NULL),(8011,'category',150,'bathroom/taps/bathroom-taps.html','catalog/category/view/id/150',0,2,NULL,1,NULL),(8012,'category',152,'bathroom/taps/bath-taps.html','catalog/category/view/id/152',0,2,NULL,1,NULL),(8013,'category',153,'bathroom/taps/bath-taps/single-bath-taps.html','catalog/category/view/id/153',0,2,NULL,1,NULL),(8014,'category',154,'bathroom/taps/bath-taps/mixer-taps.html','catalog/category/view/id/154',0,2,NULL,1,NULL),(8015,'category',155,'bathroom/taps/bath-taps/wall-hung-taps.html','catalog/category/view/id/155',0,2,NULL,1,NULL),(8016,'category',156,'bathroom/taps/bath-taps/free-standing-taps.html','catalog/category/view/id/156',0,2,NULL,1,NULL),(8017,'category',157,'bathroom/taps/bath-taps/bath-spouts.html','catalog/category/view/id/157',0,2,NULL,1,NULL),(8018,'category',158,'bathroom/taps/bath-taps/bath-filler.html','catalog/category/view/id/158',0,2,NULL,1,NULL),(8019,'category',279,'bathroom/taps/bath-taps/bath-tap-pairs.html','catalog/category/view/id/279',0,2,NULL,1,NULL),(8020,'category',280,'bathroom/taps/bath-taps/deck-mounted-taps.html','catalog/category/view/id/280',0,2,NULL,1,NULL),(8021,'category',282,'bathroom/taps/bath-taps/bath-basin-tap-sets.html','catalog/category/view/id/282',0,2,NULL,1,NULL),(8022,'category',159,'bathroom/taps/basin-taps.html','catalog/category/view/id/159',0,2,NULL,1,NULL),(8023,'category',151,'bathroom/taps/basin-taps/bidet-mixers.html','catalog/category/view/id/151',0,2,NULL,1,NULL),(8024,'category',160,'bathroom/taps/basin-taps/basin-mixer-taps.html','catalog/category/view/id/160',0,2,NULL,1,NULL),(8025,'category',161,'bathroom/taps/basin-taps/wall-hung-tap.html','catalog/category/view/id/161',0,2,NULL,1,NULL),(8026,'category',162,'bathroom/taps/basin-taps/sensor-tap.html','catalog/category/view/id/162',0,2,NULL,1,NULL),(8027,'category',276,'bathroom/taps/basin-taps/high-rise-basin-taps.html','catalog/category/view/id/276',0,2,NULL,1,NULL),(8028,'category',277,'bathroom/taps/basin-taps/basin-tap-pairs.html','catalog/category/view/id/277',0,2,NULL,1,NULL),(8029,'category',278,'bathroom/taps/basin-taps/bath-basin-tap-sets.html','catalog/category/view/id/278',0,2,NULL,1,NULL),(8030,'category',9,'bathroom/shower-valves.html','catalog/category/view/id/9',0,2,NULL,1,NULL),(8031,'category',165,'bathroom/shower-valves/all-showers.html','catalog/category/view/id/165',0,2,NULL,1,NULL),(8032,'category',166,'bathroom/shower-valves/all-showers/full-showers.html','catalog/category/view/id/166',0,2,NULL,1,NULL),(8033,'category',167,'bathroom/shower-valves/all-showers/shower-panels.html','catalog/category/view/id/167',0,2,NULL,1,NULL),(8034,'category',168,'bathroom/shower-valves/all-showers/electric-showers.html','catalog/category/view/id/168',0,2,NULL,1,NULL),(8035,'category',176,'bathroom/shower-valves/all-showers/slider-kits.html','catalog/category/view/id/176',0,2,NULL,1,NULL),(8036,'category',238,'bathroom/shower-valves/all-showers/shower-head-with-arm.html','catalog/category/view/id/238',0,2,NULL,1,NULL),(8037,'category',169,'bathroom/shower-valves/accessories.html','catalog/category/view/id/169',0,2,NULL,1,NULL),(8038,'category',175,'bathroom/shower-valves/accessories/hand-showers.html','catalog/category/view/id/175',0,2,NULL,1,NULL),(8039,'category',177,'bathroom/shower-valves/accessories/shower-heads.html','catalog/category/view/id/177',0,2,NULL,1,NULL),(8040,'category',178,'bathroom/shower-valves/accessories/shower-arms.html','catalog/category/view/id/178',0,2,NULL,1,NULL),(8041,'category',179,'bathroom/shower-valves/accessories/body-jets.html','catalog/category/view/id/179',0,2,NULL,1,NULL),(8042,'category',180,'bathroom/shower-valves/accessories/shower-hose.html','catalog/category/view/id/180',0,2,NULL,1,NULL),(8043,'category',181,'bathroom/shower-valves/accessories/accessories.html','catalog/category/view/id/181',0,2,NULL,1,NULL),(8044,'category',170,'bathroom/shower-valves/valves.html','catalog/category/view/id/170',0,2,NULL,1,NULL),(8045,'category',171,'bathroom/shower-valves/valves/exposed-valves.html','catalog/category/view/id/171',0,2,NULL,1,NULL),(8046,'category',172,'bathroom/shower-valves/valves/concealed-valves.html','catalog/category/view/id/172',0,2,NULL,1,NULL),(8047,'category',173,'bathroom/shower-valves/valves/thermostatic-valves.html','catalog/category/view/id/173',0,2,NULL,1,NULL),(8048,'category',174,'bathroom/shower-valves/valves/traditional-valves.html','catalog/category/view/id/174',0,2,NULL,1,NULL),(8049,'category',239,'bathroom/shower-valves/valves/bar-valves.html','catalog/category/view/id/239',0,2,NULL,1,NULL),(8050,'category',240,'bathroom/shower-valves/brands.html','catalog/category/view/id/240',0,2,NULL,1,NULL),(8051,'category',241,'bathroom/shower-valves/brands/hansgrohe.html','catalog/category/view/id/241',0,2,NULL,1,NULL),(8052,'category',242,'bathroom/shower-valves/brands/grohe.html','catalog/category/view/id/242',0,2,NULL,1,NULL),(8053,'category',243,'bathroom/shower-valves/brands/nuei.html','catalog/category/view/id/243',0,2,NULL,1,NULL),(8054,'category',244,'bathroom/shower-valves/brands/hudson-reed.html','catalog/category/view/id/244',0,2,NULL,1,NULL),(8055,'category',5,'kitchen-appliances.html','catalog/category/view/id/5',0,2,NULL,1,NULL),(8056,'category',145,'kitchen-appliances/kitchen-taps.html','catalog/category/view/id/145',0,2,NULL,1,NULL),(8057,'category',146,'kitchen-appliances/kitchen-taps/kitchen-sink-taps.html','catalog/category/view/id/146',0,2,NULL,1,NULL),(8058,'category',149,'kitchen-appliances/kitchen-taps/sensor-taps.html','catalog/category/view/id/149',0,2,NULL,1,NULL),(8059,'category',329,'kitchen-appliances/kitchen-taps/kitchen-tap-type.html','catalog/category/view/id/329',0,2,NULL,1,NULL),(8060,'category',147,'kitchen-appliances/kitchen-taps/kitchen-tap-type/instant-hot-water-taps.html','catalog/category/view/id/147',0,2,NULL,1,NULL),(8061,'category',148,'kitchen-appliances/kitchen-taps/kitchen-tap-type/filter-flow-taps.html','catalog/category/view/id/148',0,2,NULL,1,NULL),(8062,'category',330,'kitchen-appliances/kitchen-taps/kitchen-tap-type/kitchen-mixer-taps.html','catalog/category/view/id/330',0,2,NULL,1,NULL),(8063,'category',331,'kitchen-appliances/kitchen-taps/kitchen-tap-type/pull-out-kitchen-taps.html','catalog/category/view/id/331',0,2,NULL,1,NULL),(8064,'category',332,'kitchen-appliances/kitchen-taps/kitchen-tap-type/coloured-kitchen-taps.html','catalog/category/view/id/332',0,2,NULL,1,NULL),(8065,'category',335,'kitchen-appliances/kitchen-taps/kitchen-tap-type/sparkling-water-taps.html','catalog/category/view/id/335',0,2,NULL,1,NULL),(8066,'category',336,'kitchen-appliances/kitchen-taps/kitchen-tap-type/smart-taps.html','catalog/category/view/id/336',0,2,NULL,1,NULL),(8067,'category',337,'kitchen-appliances/kitchen-taps/brands.html','catalog/category/view/id/337',0,2,NULL,1,NULL),(8068,'category',338,'kitchen-appliances/kitchen-taps/brands/franke.html','catalog/category/view/id/338',0,2,NULL,1,NULL),(8069,'category',339,'kitchen-appliances/kitchen-taps/brands/blanco.html','catalog/category/view/id/339',0,2,NULL,1,NULL),(8070,'category',340,'kitchen-appliances/kitchen-taps/brands/reginox.html','catalog/category/view/id/340',0,2,NULL,1,NULL),(8071,'category',341,'kitchen-appliances/kitchen-taps/brands/grohe.html','catalog/category/view/id/341',0,2,NULL,1,NULL),(8072,'category',342,'kitchen-appliances/kitchen-taps/brands/hansgrohe.html','catalog/category/view/id/342',0,2,NULL,1,NULL),(8073,'category',344,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories.html','catalog/category/view/id/344',0,2,NULL,1,NULL),(8074,'category',345,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/soap-dispensors.html','catalog/category/view/id/345',0,2,NULL,1,NULL),(8075,'category',346,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/filters.html','catalog/category/view/id/346',0,2,NULL,1,NULL),(8076,'category',347,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/hot-water-tanks.html','catalog/category/view/id/347',0,2,NULL,1,NULL),(8077,'category',318,'kitchen-appliances/kitchen-sinks.html','catalog/category/view/id/318',0,2,NULL,1,NULL),(8078,'category',106,'kitchen-appliances/kitchen-sinks/sink-type.html','catalog/category/view/id/106',0,2,NULL,1,NULL),(8079,'category',107,'kitchen-appliances/kitchen-sinks/sink-type/full-sinks.html','catalog/category/view/id/107',0,2,NULL,1,NULL),(8080,'category',109,'kitchen-appliances/kitchen-sinks/sink-type/sink-tap-packages.html','catalog/category/view/id/109',0,2,NULL,1,NULL),(8081,'category',307,'kitchen-appliances/kitchen-sinks/sink-type/undermount.html','catalog/category/view/id/307',0,2,NULL,1,NULL),(8082,'category',308,'kitchen-appliances/kitchen-sinks/sink-type/inset-flushmount.html','catalog/category/view/id/308',0,2,NULL,1,NULL),(8083,'category',309,'kitchen-appliances/kitchen-sinks/sink-type/1-0-bowl-sinks.html','catalog/category/view/id/309',0,2,NULL,1,NULL),(8084,'category',310,'kitchen-appliances/kitchen-sinks/sink-type/1-5-bowl-sinks.html','catalog/category/view/id/310',0,2,NULL,1,NULL),(8085,'category',311,'kitchen-appliances/kitchen-sinks/sink-type/2-0-bowl-sinks.html','catalog/category/view/id/311',0,2,NULL,1,NULL),(8086,'category',312,'kitchen-appliances/kitchen-sinks/sink-type/belfast-sinks.html','catalog/category/view/id/312',0,2,NULL,1,NULL),(8087,'category',313,'kitchen-appliances/kitchen-sinks/sink-material.html','catalog/category/view/id/313',0,2,NULL,1,NULL),(8088,'category',108,'kitchen-appliances/kitchen-sinks/sink-material/stainless-steel-sinks.html','catalog/category/view/id/108',0,2,NULL,1,NULL),(8089,'category',314,'kitchen-appliances/kitchen-sinks/sink-material/ceramic-sinks.html','catalog/category/view/id/314',0,2,NULL,1,NULL),(8090,'category',315,'kitchen-appliances/kitchen-sinks/sink-material/granite-sinks.html','catalog/category/view/id/315',0,2,NULL,1,NULL),(8091,'category',316,'kitchen-appliances/kitchen-sinks/sink-material/composite-sinks.html','catalog/category/view/id/316',0,2,NULL,1,NULL),(8092,'category',317,'kitchen-appliances/kitchen-sinks/sink-material/coloured-sinks.html','catalog/category/view/id/317',0,2,NULL,1,NULL),(8093,'category',319,'kitchen-appliances/kitchen-sinks/accessories.html','catalog/category/view/id/319',0,2,NULL,1,NULL),(8094,'category',110,'kitchen-appliances/kitchen-sinks/accessories/kitchen-accessories.html','catalog/category/view/id/110',0,2,NULL,1,NULL),(8095,'category',321,'kitchen-appliances/kitchen-sinks/accessories/waster-sorter.html','catalog/category/view/id/321',0,2,NULL,1,NULL),(8096,'category',322,'kitchen-appliances/kitchen-sinks/accessories/plumbing-kits.html','catalog/category/view/id/322',0,2,NULL,1,NULL),(8097,'category',323,'kitchen-appliances/kitchen-sinks/brands.html','catalog/category/view/id/323',0,2,NULL,1,NULL),(8098,'category',324,'kitchen-appliances/kitchen-sinks/brands/franke.html','catalog/category/view/id/324',0,2,NULL,1,NULL),(8099,'category',325,'kitchen-appliances/kitchen-sinks/brands/reginox.html','catalog/category/view/id/325',0,2,NULL,1,NULL),(8100,'category',326,'kitchen-appliances/kitchen-sinks/brands/blanco.html','catalog/category/view/id/326',0,2,NULL,1,NULL),(8101,'category',327,'kitchen-appliances/kitchen-sinks/brands/grohe.html','catalog/category/view/id/327',0,2,NULL,1,NULL),(8102,'category',328,'kitchen-appliances/kitchen-sinks/brands/hansgrohe.html','catalog/category/view/id/328',0,2,NULL,1,NULL),(8103,'category',343,'kitchen-appliances/appliances.html','catalog/category/view/id/343',0,2,NULL,1,NULL),(8104,'category',100,'kitchen-appliances/appliances/fridges-freezers.html','catalog/category/view/id/100',0,2,NULL,1,NULL),(8105,'category',101,'kitchen-appliances/appliances/fridges-freezers/fridges-freezers.html','catalog/category/view/id/101',0,2,NULL,1,NULL),(8106,'category',102,'kitchen-appliances/appliances/fridges-freezers/fridges.html','catalog/category/view/id/102',0,2,NULL,1,NULL),(8107,'category',103,'kitchen-appliances/appliances/fridges-freezers/freezers.html','catalog/category/view/id/103',0,2,NULL,1,NULL),(8108,'category',104,'kitchen-appliances/appliances/fridges-freezers/wine-coolers.html','catalog/category/view/id/104',0,2,NULL,1,NULL),(8109,'category',105,'kitchen-appliances/appliances/fridges-freezers/american-style-fridge-freezers.html','catalog/category/view/id/105',0,2,NULL,1,NULL),(8110,'category',348,'kitchen-appliances/appliances/accessories.html','catalog/category/view/id/348',0,2,NULL,1,NULL),(8111,'category',349,'kitchen-appliances/appliances/accessories/accessories.html','catalog/category/view/id/349',0,2,NULL,1,NULL),(8112,'category',350,'kitchen-appliances/appliances/brands.html','catalog/category/view/id/350',0,2,NULL,1,NULL),(8113,'category',351,'kitchen-appliances/appliances/brands/bosch.html','catalog/category/view/id/351',0,2,NULL,1,NULL),(8114,'category',352,'kitchen-appliances/appliances/brands/neff.html','catalog/category/view/id/352',0,2,NULL,1,NULL),(8115,'category',353,'kitchen-appliances/appliances/brands/siemens.html','catalog/category/view/id/353',0,2,NULL,1,NULL),(8116,'category',354,'kitchen-appliances/appliances/brands/franke.html','catalog/category/view/id/354',0,2,NULL,1,NULL),(8117,'category',355,'kitchen-appliances/appliances/brands/elica.html','catalog/category/view/id/355',0,2,NULL,1,NULL),(8118,'category',87,'kitchen-appliances/appliances/cooking-baking.html','catalog/category/view/id/87',0,2,NULL,1,NULL),(8119,'category',88,'kitchen-appliances/appliances/cooking-baking/ovens.html','catalog/category/view/id/88',0,2,NULL,1,NULL),(8120,'category',89,'kitchen-appliances/appliances/cooking-baking/hobs.html','catalog/category/view/id/89',0,2,NULL,1,NULL),(8121,'category',90,'kitchen-appliances/appliances/cooking-baking/steam-appliances.html','catalog/category/view/id/90',0,2,NULL,1,NULL),(8122,'category',91,'kitchen-appliances/appliances/cooking-baking/microwaves.html','catalog/category/view/id/91',0,2,NULL,1,NULL),(8123,'category',92,'kitchen-appliances/appliances/cooking-baking/coffee-machine.html','catalog/category/view/id/92',0,2,NULL,1,NULL),(8124,'category',93,'kitchen-appliances/appliances/cooking-baking/cooker-hoods.html','catalog/category/view/id/93',0,2,NULL,1,NULL),(8125,'category',94,'kitchen-appliances/appliances/cooking-baking/warming-drawers.html','catalog/category/view/id/94',0,2,NULL,1,NULL),(8126,'category',95,'kitchen-appliances/appliances/cooking-baking/cooking-accessories.html','catalog/category/view/id/95',0,2,NULL,1,NULL),(8127,'category',96,'kitchen-appliances/appliances/washers-dryers.html','catalog/category/view/id/96',0,2,NULL,1,NULL),(8128,'category',97,'kitchen-appliances/appliances/washers-dryers/washing-machines.html','catalog/category/view/id/97',0,2,NULL,1,NULL),(8129,'category',98,'kitchen-appliances/appliances/dishwashers.html','catalog/category/view/id/98',0,2,NULL,1,NULL),(8130,'category',99,'kitchen-appliances/appliances/dishwashers/built-in-dishwashers.html','catalog/category/view/id/99',0,2,NULL,1,NULL),(8131,'category',356,'kitchen-appliances/kitchen-accessories.html','catalog/category/view/id/356',0,2,NULL,1,NULL),(8132,'category',358,'kitchen-appliances/kitchen-accessories/accessories.html','catalog/category/view/id/358',0,2,NULL,1,NULL),(8133,'category',359,'kitchen-appliances/kitchen-accessories/accessories/soap-dispensors.html','catalog/category/view/id/359',0,2,NULL,1,NULL),(8134,'category',360,'kitchen-appliances/kitchen-accessories/accessories/chopping-boards.html','catalog/category/view/id/360',0,2,NULL,1,NULL),(8135,'category',361,'kitchen-appliances/kitchen-accessories/accessories/strainers.html','catalog/category/view/id/361',0,2,NULL,1,NULL),(8136,'category',362,'kitchen-appliances/kitchen-accessories/accessories/colanders.html','catalog/category/view/id/362',0,2,NULL,1,NULL),(8137,'category',363,'kitchen-appliances/kitchen-accessories/accessories/metal-grids.html','catalog/category/view/id/363',0,2,NULL,1,NULL),(8138,'category',364,'kitchen-appliances/kitchen-accessories/accessories/cleaning-sprays.html','catalog/category/view/id/364',0,2,NULL,1,NULL),(8139,'category',365,'kitchen-appliances/kitchen-accessories/accessories/waste-and-plumbing-kits.html','catalog/category/view/id/365',0,2,NULL,1,NULL),(8140,'category',7,'heating.html','catalog/category/view/id/7',0,2,NULL,1,NULL),(8141,'category',366,'heating/radiators.html','catalog/category/view/id/366',0,2,NULL,1,NULL),(8142,'category',142,'heating/radiators/towel-rails.html','catalog/category/view/id/142',0,2,NULL,1,NULL),(8143,'category',143,'heating/radiators/towel-rails/heated-towel-rails.html','catalog/category/view/id/143',0,2,NULL,1,NULL),(8144,'category',144,'heating/radiators/towel-rails/electric-towel-rails.html','catalog/category/view/id/144',0,2,NULL,1,NULL),(8145,'category',371,'heating/radiators/towel-rails/dual-fuel-towel-rails.html','catalog/category/view/id/371',0,2,NULL,1,NULL),(8146,'category',367,'heating/radiators/radiators.html','catalog/category/view/id/367',0,2,NULL,1,NULL),(8147,'category',135,'heating/radiators/radiators/designer-radiators.html','catalog/category/view/id/135',0,2,NULL,1,NULL),(8148,'category',136,'heating/radiators/radiators/vertical-designer-radiators.html','catalog/category/view/id/136',0,2,NULL,1,NULL),(8149,'category',137,'heating/radiators/radiators/horizontal-designer-radiators.html','catalog/category/view/id/137',0,2,NULL,1,NULL),(8150,'category',138,'heating/radiators/radiators/traditional-radiators.html','catalog/category/view/id/138',0,2,NULL,1,NULL),(8151,'category',139,'heating/radiators/radiators/electric-radiators.html','catalog/category/view/id/139',0,2,NULL,1,NULL),(8152,'category',140,'heating/radiators/radiators/radiator-valves.html','catalog/category/view/id/140',0,2,NULL,1,NULL),(8153,'category',141,'heating/radiators/radiators/heating-elements.html','catalog/category/view/id/141',0,2,NULL,1,NULL),(8154,'category',368,'heating/radiators/radiators/column-radiators.html','catalog/category/view/id/368',0,2,NULL,1,NULL),(8155,'category',369,'heating/radiators/radiators/convector-radiators.html','catalog/category/view/id/369',0,2,NULL,1,NULL),(8156,'category',370,'heating/radiators/radiators/floor-standing-radiators.html','catalog/category/view/id/370',0,2,NULL,1,NULL),(8157,'category',372,'heating/radiators/brands.html','catalog/category/view/id/372',0,2,NULL,1,NULL),(8158,'category',373,'heating/radiators/brands/nuie.html','catalog/category/view/id/373',0,2,NULL,1,NULL),(8159,'category',374,'heating/radiators/brands/hudson-reed.html','catalog/category/view/id/374',0,2,NULL,1,NULL),(8160,'category',375,'heating/radiators/brands/carisa.html','catalog/category/view/id/375',0,2,NULL,1,NULL),(8161,'category',376,'heating/radiators/brands/zehnder.html','catalog/category/view/id/376',0,2,NULL,1,NULL),(8162,'category',377,'heating/radiators/brands/reina.html','catalog/category/view/id/377',0,2,NULL,1,NULL),(8163,'category',6,'heating/fires.html','catalog/category/view/id/6',0,2,NULL,1,NULL),(8164,'category',111,'heating/fires/gas-fires.html','catalog/category/view/id/111',0,2,NULL,1,NULL),(8165,'category',112,'heating/fires/gas-fires/front-view-gas-fires.html','catalog/category/view/id/112',0,2,NULL,1,NULL),(8166,'category',113,'heating/fires/gas-fires/corner-gas-fires.html','catalog/category/view/id/113',0,2,NULL,1,NULL),(8167,'category',114,'heating/fires/gas-fires/three-sided-gas-fires.html','catalog/category/view/id/114',0,2,NULL,1,NULL),(8168,'category',115,'heating/fires/gas-fires/tunnel-gas-fires.html','catalog/category/view/id/115',0,2,NULL,1,NULL),(8169,'category',116,'heating/fires/gas-fires/heaters.html','catalog/category/view/id/116',0,2,NULL,1,NULL),(8170,'category',117,'heating/fires/gas-fires/hole-in-the-wall-gas-fires.html','catalog/category/view/id/117',0,2,NULL,1,NULL),(8171,'category',118,'heating/fires/gas-fires/high-efficiency-gas-fires.html','catalog/category/view/id/118',0,2,NULL,1,NULL),(8172,'category',119,'heating/fires/gas-fires/glass-fronted-gas-fire.html','catalog/category/view/id/119',0,2,NULL,1,NULL),(8173,'category',120,'heating/fires/gas-fires/inset-gas-fires.html','catalog/category/view/id/120',0,2,NULL,1,NULL),(8174,'category',121,'heating/fires/gas-fires/wall-mounted-gas-fires.html','catalog/category/view/id/121',0,2,NULL,1,NULL),(8175,'category',122,'heating/fires/gas-fires/balanced-flue-gas-fires.html','catalog/category/view/id/122',0,2,NULL,1,NULL),(8176,'category',123,'heating/fires/gas-fires/flueless-gas-fires.html','catalog/category/view/id/123',0,2,NULL,1,NULL),(8177,'category',378,'heating/fires/gas-fires/floor-standing-fires.html','catalog/category/view/id/378',0,2,NULL,1,NULL),(8178,'category',379,'heating/fires/gas-fires/top-control-side-control-gas-fires.html','catalog/category/view/id/379',0,2,NULL,1,NULL),(8179,'category',380,'heating/fires/gas-fires/outdoor-gas-fires.html','catalog/category/view/id/380',0,2,NULL,1,NULL),(8180,'category',124,'heating/fires/stoves.html','catalog/category/view/id/124',0,2,NULL,1,NULL),(8181,'category',125,'heating/fires/stoves/wood-multifuel-stoves.html','catalog/category/view/id/125',0,2,NULL,1,NULL),(8182,'category',126,'heating/fires/stoves/electric-stoves.html','catalog/category/view/id/126',0,2,NULL,1,NULL),(8183,'category',127,'heating/fires/stoves/wood-burning-stoves.html','catalog/category/view/id/127',0,2,NULL,1,NULL),(8184,'category',128,'heating/fires/stoves/gas-stoves.html','catalog/category/view/id/128',0,2,NULL,1,NULL),(8185,'category',383,'heating/fires/stoves/flueless-gas-stoves.html','catalog/category/view/id/383',0,2,NULL,1,NULL),(8186,'category',384,'heating/fires/stoves/inset-gas-stoves.html','catalog/category/view/id/384',0,2,NULL,1,NULL),(8187,'category',129,'heating/fires/electric-fires.html','catalog/category/view/id/129',0,2,NULL,1,NULL),(8188,'category',130,'heating/fires/electric-fires/inset-electric-fires.html','catalog/category/view/id/130',0,2,NULL,1,NULL),(8189,'category',132,'heating/fires/electric-fires/wall-mounted-electric-fires.html','catalog/category/view/id/132',0,2,NULL,1,NULL),(8190,'category',133,'heating/fires/electric-fires/electric-fires-and-surrounds.html','catalog/category/view/id/133',0,2,NULL,1,NULL),(8191,'category',381,'heating/fires/electric-fires/floor-standing-electric-fires.html','catalog/category/view/id/381',0,2,NULL,1,NULL),(8192,'category',382,'heating/fires/electric-fires/hole-in-the-wall-electric-fires.html','catalog/category/view/id/382',0,2,NULL,1,NULL),(8193,'category',134,'heating/fires/fires-accessories.html','catalog/category/view/id/134',0,2,NULL,1,NULL),(8194,'category',385,'heating/fires/fireplase-suite.html','catalog/category/view/id/385',0,2,NULL,1,NULL),(8195,'category',386,'heating/fires/fireplase-suite/gas-fireplaces.html','catalog/category/view/id/386',0,2,NULL,1,NULL),(8196,'category',387,'heating/fires/fireplase-suite/electric-fireplaces.html','catalog/category/view/id/387',0,2,NULL,1,NULL),(8197,'category',445,'heating/fires/fireplase-suite/wood-burning-fireplace.html','catalog/category/view/id/445',0,2,NULL,1,NULL),(8198,'category',388,'heating/fires/media-wall-electric-fires.html','catalog/category/view/id/388',0,2,NULL,1,NULL),(8199,'category',389,'heating/fires/media-wall-electric-fires/media-wall-electric-fires.html','catalog/category/view/id/389',0,2,NULL,1,NULL),(8200,'category',390,'heating/fires/brands.html','catalog/category/view/id/390',0,2,NULL,1,NULL),(8201,'category',391,'heating/fires/brands/ag-stoves.html','catalog/category/view/id/391',0,2,NULL,1,NULL),(8202,'category',392,'heating/fires/brands/dik-guerts.html','catalog/category/view/id/392',0,2,NULL,1,NULL),(8203,'category',393,'heating/fires/brands/dimplex.html','catalog/category/view/id/393',0,2,NULL,1,NULL),(8204,'category',394,'heating/fires/brands/dru.html','catalog/category/view/id/394',0,2,NULL,1,NULL),(8205,'category',395,'heating/fires/brands/ekofires.html','catalog/category/view/id/395',0,2,NULL,1,NULL),(8206,'category',396,'heating/fires/brands/element-4.html','catalog/category/view/id/396',0,2,NULL,1,NULL),(8207,'category',397,'heating/fires/brands/esse.html','catalog/category/view/id/397',0,2,NULL,1,NULL),(8208,'category',398,'heating/fires/brands/evonice-fires.html','catalog/category/view/id/398',0,2,NULL,1,NULL),(8209,'category',399,'heating/fires/brands/carron-fires.html','catalog/category/view/id/399',0,2,NULL,1,NULL),(8210,'category',400,'heating/fires/brands/flamerite-fires.html','catalog/category/view/id/400',0,2,NULL,1,NULL),(8211,'category',401,'heating/fires/brands/flavel.html','catalog/category/view/id/401',0,2,NULL,1,NULL),(8212,'category',402,'heating/fires/brands/valor.html','catalog/category/view/id/402',0,2,NULL,1,NULL),(8213,'category',403,'heating/fires/brands/gazco.html','catalog/category/view/id/403',0,2,NULL,1,NULL),(8214,'category',12,'brands.html','catalog/category/view/id/12',0,2,NULL,1,NULL),(8215,'category',404,'brands/a-d.html','catalog/category/view/id/404',0,2,NULL,1,NULL),(8216,'category',405,'brands/a-d/aga-stoves.html','catalog/category/view/id/405',0,2,NULL,1,NULL),(8217,'category',406,'brands/a-d/bette.html','catalog/category/view/id/406',0,2,NULL,1,NULL),(8218,'category',407,'brands/a-d/blanco.html','catalog/category/view/id/407',0,2,NULL,1,NULL),(8219,'category',408,'brands/a-d/carisa.html','catalog/category/view/id/408',0,2,NULL,1,NULL),(8220,'category',409,'brands/a-d/dik-guerts.html','catalog/category/view/id/409',0,2,NULL,1,NULL),(8221,'category',410,'brands/a-d/dimplex.html','catalog/category/view/id/410',0,2,NULL,1,NULL),(8222,'category',411,'brands/a-d/dru.html','catalog/category/view/id/411',0,2,NULL,1,NULL),(8223,'category',444,'brands/a-d/aeon.html','catalog/category/view/id/444',0,2,NULL,1,NULL),(8224,'category',412,'brands/e-i.html','catalog/category/view/id/412',0,2,NULL,1,NULL),(8225,'category',413,'brands/e-i/ekofires.html','catalog/category/view/id/413',0,2,NULL,1,NULL),(8226,'category',414,'brands/e-i/element-4.html','catalog/category/view/id/414',0,2,NULL,1,NULL),(8227,'category',415,'brands/e-i/elica.html','catalog/category/view/id/415',0,2,NULL,1,NULL),(8228,'category',416,'brands/e-i/esse.html','catalog/category/view/id/416',0,2,NULL,1,NULL),(8229,'category',417,'brands/e-i/evonic-fires.html','catalog/category/view/id/417',0,2,NULL,1,NULL),(8230,'category',418,'brands/e-i/flamerite-fires.html','catalog/category/view/id/418',0,2,NULL,1,NULL),(8231,'category',419,'brands/e-i/flavel.html','catalog/category/view/id/419',0,2,NULL,1,NULL),(8232,'category',420,'brands/e-i/franke.html','catalog/category/view/id/420',0,2,NULL,1,NULL),(8233,'category',421,'brands/e-i/gazco.html','catalog/category/view/id/421',0,2,NULL,1,NULL),(8234,'category',422,'brands/e-i/geberit.html','catalog/category/view/id/422',0,2,NULL,1,NULL),(8235,'category',423,'brands/e-i/grohe.html','catalog/category/view/id/423',0,2,NULL,1,NULL),(8236,'category',424,'brands/e-i/hansgrohe.html','catalog/category/view/id/424',0,2,NULL,1,NULL),(8237,'category',425,'brands/e-i/hib.html','catalog/category/view/id/425',0,2,NULL,1,NULL),(8238,'category',426,'brands/e-i/hudson-reed.html','catalog/category/view/id/426',0,2,NULL,1,NULL),(8239,'category',427,'brands/e-i/ideal-standard.html','catalog/category/view/id/427',0,2,NULL,1,NULL),(8240,'category',428,'brands/j-r.html','catalog/category/view/id/428',0,2,NULL,1,NULL),(8241,'category',429,'brands/j-r/kaldewei.html','catalog/category/view/id/429',0,2,NULL,1,NULL),(8242,'category',430,'brands/j-r/matki.html','catalog/category/view/id/430',0,2,NULL,1,NULL),(8243,'category',431,'brands/j-r/neff.html','catalog/category/view/id/431',0,2,NULL,1,NULL),(8244,'category',432,'brands/j-r/nuie.html','catalog/category/view/id/432',0,2,NULL,1,NULL),(8245,'category',433,'brands/j-r/rak-ceramics.html','catalog/category/view/id/433',0,2,NULL,1,NULL),(8246,'category',434,'brands/j-r/reginox.html','catalog/category/view/id/434',0,2,NULL,1,NULL),(8247,'category',435,'brands/j-r/reina.html','catalog/category/view/id/435',0,2,NULL,1,NULL),(8248,'category',436,'brands/j-r/roca.html','catalog/category/view/id/436',0,2,NULL,1,NULL),(8249,'category',437,'brands/j-r/royce-morgan.html','catalog/category/view/id/437',0,2,NULL,1,NULL),(8250,'category',438,'brands/s-z.html','catalog/category/view/id/438',0,2,NULL,1,NULL),(8251,'category',439,'brands/s-z/siemens.html','catalog/category/view/id/439',0,2,NULL,1,NULL),(8252,'category',440,'brands/s-z/spartherm.html','catalog/category/view/id/440',0,2,NULL,1,NULL),(8253,'category',441,'brands/s-z/valor.html','catalog/category/view/id/441',0,2,NULL,1,NULL),(8254,'category',442,'brands/s-z/vitra.html','catalog/category/view/id/442',0,2,NULL,1,NULL),(8255,'category',443,'brands/s-z/zehnder.html','catalog/category/view/id/443',0,2,NULL,1,NULL),(8256,'cms-page',1,'no-route','cms/page/view/page_id/1',0,2,NULL,1,NULL),(8257,'cms-page',2,'home','cms/page/view/page_id/2',0,2,NULL,1,NULL),(8258,'cms-page',3,'enable-cookies','cms/page/view/page_id/3',0,2,NULL,1,NULL),(8259,'cms-page',4,'privacy-policy','cms/page/view/page_id/4',0,2,NULL,1,NULL),(8260,'cms-page',5,'terms-and-conditions','cms/page/view/page_id/5',0,2,NULL,1,NULL),(8261,'cms-page',6,'careers','cms/page/view/page_id/6',0,2,NULL,1,NULL),(8262,'cms-page',7,'returns','cms/page/view/page_id/7',0,2,NULL,1,NULL),(8263,'cms-page',8,'how-to-order','cms/page/view/page_id/8',0,2,NULL,1,NULL),(8264,'cms-page',9,'14-day-money-back-guarantee','cms/page/view/page_id/9',0,2,NULL,1,NULL),(8265,'cms-page',10,'visit-our-showroom','cms/page/view/page_id/10',0,2,NULL,1,NULL),(8266,'cms-page',11,'about-us','cms/page/view/page_id/11',0,2,NULL,1,NULL),(8267,'cms-page',12,'faq','cms/page/view/page_id/12',0,2,NULL,1,NULL),(8268,'cms-page',13,'finance','cms/page/view/page_id/13',0,2,NULL,1,NULL),(8269,'cms-page',14,'support','cms/page/view/page_id/14',0,2,NULL,1,NULL),(8270,'cms-page',15,'cart-more-info','cms/page/view/page_id/15',0,1,NULL,1,NULL),(8271,'cms-page',15,'cart-more-info','cms/page/view/page_id/15',0,2,NULL,1,NULL),(8719,'cms-page',20,'premier/home','cms/page/view/page_id/20',0,1,NULL,1,NULL),(8741,'cms-page',29,'contact-us-nexus','cms/page/view/page_id/29',0,1,NULL,1,NULL),(8742,'cms-page',29,'contact-us-nexus','cms/page/view/page_id/29',0,2,NULL,1,NULL),(8743,'category',3,'bathroom.html','catalog/category/view/id/3',0,4,NULL,1,NULL),(8744,'category',219,'bathroom/toilet.html','catalog/category/view/id/219',0,4,NULL,1,NULL),(8745,'category',15,'bathroom/toilet/toilets.html','catalog/category/view/id/15',0,4,NULL,1,NULL),(8746,'category',16,'bathroom/toilet/toilets/close-coupled-toilets.html','catalog/category/view/id/16',0,4,NULL,1,NULL),(8747,'category',17,'bathroom/toilet/toilets/back-to-wall-toilets.html','catalog/category/view/id/17',0,4,NULL,1,NULL),(8748,'category',18,'bathroom/toilet/toilets/wall-hung-toilets.html','catalog/category/view/id/18',0,4,NULL,1,NULL),(8749,'category',198,'bathroom/toilet/toilets/comfort-height-toilets.html','catalog/category/view/id/198',0,4,NULL,1,NULL),(8750,'category',199,'bathroom/toilet/toilets/rimless-toilets.html','catalog/category/view/id/199',0,4,NULL,1,NULL),(8751,'category',20,'bathroom/toilet/toilets/corner-toilets.html','catalog/category/view/id/20',0,4,NULL,1,NULL),(8752,'category',200,'bathroom/toilet/toilets/wc-unit.html','catalog/category/view/id/200',0,4,NULL,1,NULL),(8753,'category',201,'bathroom/toilet/toilets/smart-toilets.html','catalog/category/view/id/201',0,4,NULL,1,NULL),(8754,'category',202,'bathroom/toilet/toilets/doc-m-packs.html','catalog/category/view/id/202',0,4,NULL,1,NULL),(8755,'category',21,'bathroom/toilet/toilets/bidets.html','catalog/category/view/id/21',0,4,NULL,1,NULL),(8756,'category',22,'bathroom/toilet/toilets/urinals.html','catalog/category/view/id/22',0,4,NULL,1,NULL),(8757,'category',24,'bathroom/toilet/toilets/concealed-cisterns.html','catalog/category/view/id/24',0,4,NULL,1,NULL),(8758,'category',203,'bathroom/toilet/toilet-accessories.html','catalog/category/view/id/203',0,4,NULL,1,NULL),(8759,'category',187,'bathroom/toilet/toilet-accessories/toilet-roll-holders.html','catalog/category/view/id/187',0,4,NULL,1,NULL),(8760,'category',204,'bathroom/toilet/toilet-accessories/douche-shattafs.html','catalog/category/view/id/204',0,4,NULL,1,NULL),(8761,'category',205,'bathroom/toilet/toilet-accessories/flush-buttons-plates.html','catalog/category/view/id/205',0,4,NULL,1,NULL),(8762,'category',208,'bathroom/toilet/toilet-accessories/toilet-brush-and-holders.html','catalog/category/view/id/208',0,4,NULL,1,NULL),(8763,'category',23,'bathroom/toilet/toilet-accessories/toilet-seats.html','catalog/category/view/id/23',0,4,NULL,1,NULL),(8764,'category',209,'bathroom/toilet/brands.html','catalog/category/view/id/209',0,4,NULL,1,NULL),(8765,'category',210,'bathroom/toilet/brands/rak.html','catalog/category/view/id/210',0,4,NULL,1,NULL),(8766,'category',211,'bathroom/toilet/brands/geberit.html','catalog/category/view/id/211',0,4,NULL,1,NULL),(8767,'category',212,'bathroom/toilet/brands/grohe.html','catalog/category/view/id/212',0,4,NULL,1,NULL),(8768,'category',213,'bathroom/toilet/brands/hudson-reed.html','catalog/category/view/id/213',0,4,NULL,1,NULL),(8769,'category',214,'bathroom/toilet/brands/roca.html','catalog/category/view/id/214',0,4,NULL,1,NULL),(8770,'category',215,'bathroom/toilet/brands/vitra.html','catalog/category/view/id/215',0,4,NULL,1,NULL),(8771,'category',216,'bathroom/toilet/brands/nuie.html','catalog/category/view/id/216',0,4,NULL,1,NULL),(8772,'category',25,'bathroom/basins.html','catalog/category/view/id/25',0,4,NULL,1,NULL),(8773,'category',221,'bathroom/basins/basins.html','catalog/category/view/id/221',0,4,NULL,1,NULL),(8774,'category',222,'bathroom/basins/basins/semi-pedestal-basins.html','catalog/category/view/id/222',0,4,NULL,1,NULL),(8775,'category',223,'bathroom/basins/basins/space-saver-basins.html','catalog/category/view/id/223',0,4,NULL,1,NULL),(8776,'category',224,'bathroom/basins/basins/freestanding-basin.html','catalog/category/view/id/224',0,4,NULL,1,NULL),(8777,'category',225,'bathroom/basins/basins/washstands.html','catalog/category/view/id/225',0,4,NULL,1,NULL),(8778,'category',26,'bathroom/basins/basins/pedestal-basins.html','catalog/category/view/id/26',0,4,NULL,1,NULL),(8779,'category',27,'bathroom/basins/basins/wall-hung-basins.html','catalog/category/view/id/27',0,4,NULL,1,NULL),(8780,'category',28,'bathroom/basins/basins/corner-basins.html','catalog/category/view/id/28',0,4,NULL,1,NULL),(8781,'category',29,'bathroom/basins/basins/cloakroom-basins.html','catalog/category/view/id/29',0,4,NULL,1,NULL),(8782,'category',30,'bathroom/basins/basins/vanity-basins.html','catalog/category/view/id/30',0,4,NULL,1,NULL),(8783,'category',31,'bathroom/basins/basins/semi-recessed-basins.html','catalog/category/view/id/31',0,4,NULL,1,NULL),(8784,'category',32,'bathroom/basins/basins/under-counter-basins.html','catalog/category/view/id/32',0,4,NULL,1,NULL),(8785,'category',33,'bathroom/basins/basins/counter-top-basins.html','catalog/category/view/id/33',0,4,NULL,1,NULL),(8786,'category',34,'bathroom/basins/basins/sit-on-basins.html','catalog/category/view/id/34',0,4,NULL,1,NULL),(8787,'category',226,'bathroom/basins/accessories.html','catalog/category/view/id/226',0,4,NULL,1,NULL),(8788,'category',190,'bathroom/basins/accessories/soap-dishes.html','catalog/category/view/id/190',0,4,NULL,1,NULL),(8789,'category',227,'bathroom/basins/accessories/soap-dispenser.html','catalog/category/view/id/227',0,4,NULL,1,NULL),(8790,'category',229,'bathroom/basins/accessories/towel-rails.html','catalog/category/view/id/229',0,4,NULL,1,NULL),(8791,'category',35,'bathroom/basins/accessories/bottle-traps.html','catalog/category/view/id/35',0,4,NULL,1,NULL),(8792,'category',36,'bathroom/basins/accessories/basin-wastes.html','catalog/category/view/id/36',0,4,NULL,1,NULL),(8793,'category',60,'bathroom/basins/accessories/basin-frames.html','catalog/category/view/id/60',0,4,NULL,1,NULL),(8794,'category',230,'bathroom/basins/brands.html','catalog/category/view/id/230',0,4,NULL,1,NULL),(8795,'category',231,'bathroom/basins/brands/rak.html','catalog/category/view/id/231',0,4,NULL,1,NULL),(8796,'category',232,'bathroom/basins/brands/geberit.html','catalog/category/view/id/232',0,4,NULL,1,NULL),(8797,'category',233,'bathroom/basins/brands/grohe.html','catalog/category/view/id/233',0,4,NULL,1,NULL),(8798,'category',234,'bathroom/basins/brands/hudson-reed.html','catalog/category/view/id/234',0,4,NULL,1,NULL),(8799,'category',235,'bathroom/basins/brands/roca.html','catalog/category/view/id/235',0,4,NULL,1,NULL),(8800,'category',236,'bathroom/basins/brands/vitra.html','catalog/category/view/id/236',0,4,NULL,1,NULL),(8801,'category',237,'bathroom/basins/brands/nuie.html','catalog/category/view/id/237',0,4,NULL,1,NULL),(8802,'category',37,'bathroom/baths.html','catalog/category/view/id/37',0,4,NULL,1,NULL),(8803,'category',182,'bathroom/baths/bathroom-accessories.html','catalog/category/view/id/182',0,4,NULL,1,NULL),(8804,'category',183,'bathroom/baths/bathroom-accessories/towel-rings.html','catalog/category/view/id/183',0,4,NULL,1,NULL),(8805,'category',184,'bathroom/baths/bathroom-accessories/bathroom-fans.html','catalog/category/view/id/184',0,4,NULL,1,NULL),(8806,'category',185,'bathroom/baths/bathroom-accessories/robe-hooks.html','catalog/category/view/id/185',0,4,NULL,1,NULL),(8807,'category',186,'bathroom/baths/bathroom-accessories/wire-baskets.html','catalog/category/view/id/186',0,4,NULL,1,NULL),(8808,'category',188,'bathroom/baths/bathroom-accessories/shelves.html','catalog/category/view/id/188',0,4,NULL,1,NULL),(8809,'category',189,'bathroom/baths/bathroom-accessories/urinal-accessories.html','catalog/category/view/id/189',0,4,NULL,1,NULL),(8810,'category',258,'bathroom/baths/bathroom-accessories/bath-panels.html','catalog/category/view/id/258',0,4,NULL,1,NULL),(8811,'category',259,'bathroom/baths/bathroom-accessories/bath-legsets.html','catalog/category/view/id/259',0,4,NULL,1,NULL),(8812,'category',260,'bathroom/baths/bathroom-accessories/bath-grips.html','catalog/category/view/id/260',0,4,NULL,1,NULL),(8813,'category',261,'bathroom/baths/bathroom-accessories/miscellaneous.html','catalog/category/view/id/261',0,4,NULL,1,NULL),(8814,'category',44,'bathroom/baths/bathroom-accessories/bath-screens.html','catalog/category/view/id/44',0,4,NULL,1,NULL),(8815,'category',45,'bathroom/baths/bathroom-accessories/bath-wastes-and-drainer.html','catalog/category/view/id/45',0,4,NULL,1,NULL),(8816,'category',253,'bathroom/baths/baths.html','catalog/category/view/id/253',0,4,NULL,1,NULL),(8817,'category',254,'bathroom/baths/baths/single-ended-baths.html','catalog/category/view/id/254',0,4,NULL,1,NULL),(8818,'category',255,'bathroom/baths/baths/double-ended-baths.html','catalog/category/view/id/255',0,4,NULL,1,NULL),(8819,'category',256,'bathroom/baths/baths/rectangular-baths.html','catalog/category/view/id/256',0,4,NULL,1,NULL),(8820,'category',257,'bathroom/baths/baths/space-saving-baths.html','catalog/category/view/id/257',0,4,NULL,1,NULL),(8821,'category',38,'bathroom/baths/baths/straight-baths.html','catalog/category/view/id/38',0,4,NULL,1,NULL),(8822,'category',39,'bathroom/baths/baths/free-standing-baths.html','catalog/category/view/id/39',0,4,NULL,1,NULL),(8823,'category',40,'bathroom/baths/baths/corner-baths.html','catalog/category/view/id/40',0,4,NULL,1,NULL),(8824,'category',41,'bathroom/baths/baths/oval-baths.html','catalog/category/view/id/41',0,4,NULL,1,NULL),(8825,'category',42,'bathroom/baths/baths/shower-baths.html','catalog/category/view/id/42',0,4,NULL,1,NULL),(8826,'category',43,'bathroom/baths/baths/traditional-baths.html','catalog/category/view/id/43',0,4,NULL,1,NULL),(8827,'category',262,'bathroom/baths/bette.html','catalog/category/view/id/262',0,4,NULL,1,NULL),(8828,'category',263,'bathroom/baths/bette/bette.html','catalog/category/view/id/263',0,4,NULL,1,NULL),(8829,'category',264,'bathroom/baths/bette/geberit.html','catalog/category/view/id/264',0,4,NULL,1,NULL),(8830,'category',265,'bathroom/baths/bette/grohe.html','catalog/category/view/id/265',0,4,NULL,1,NULL),(8831,'category',266,'bathroom/baths/bette/hasngrohe.html','catalog/category/view/id/266',0,4,NULL,1,NULL),(8832,'category',267,'bathroom/baths/bette/hudson-reed.html','catalog/category/view/id/267',0,4,NULL,1,NULL),(8833,'category',268,'bathroom/baths/bette/ideal-standard.html','catalog/category/view/id/268',0,4,NULL,1,NULL),(8834,'category',269,'bathroom/baths/bette/matki-showers.html','catalog/category/view/id/269',0,4,NULL,1,NULL),(8835,'category',270,'bathroom/baths/bette/rak-ceramics.html','catalog/category/view/id/270',0,4,NULL,1,NULL),(8836,'category',271,'bathroom/baths/bette/roca.html','catalog/category/view/id/271',0,4,NULL,1,NULL),(8837,'category',272,'bathroom/baths/bette/royce-morgan.html','catalog/category/view/id/272',0,4,NULL,1,NULL),(8838,'category',273,'bathroom/baths/bette/vitra.html','catalog/category/view/id/273',0,4,NULL,1,NULL),(8839,'category',274,'bathroom/baths/bette/nuie.html','catalog/category/view/id/274',0,4,NULL,1,NULL),(8840,'category',275,'bathroom/baths/bette/kaldewei.html','catalog/category/view/id/275',0,4,NULL,1,NULL),(8841,'category',4,'bathroom/showering.html','catalog/category/view/id/4',0,4,NULL,1,NULL),(8842,'category',247,'bathroom/showering/brands.html','catalog/category/view/id/247',0,4,NULL,1,NULL),(8843,'category',248,'bathroom/showering/brands/matki.html','catalog/category/view/id/248',0,4,NULL,1,NULL),(8844,'category',249,'bathroom/showering/brands/nuei.html','catalog/category/view/id/249',0,4,NULL,1,NULL),(8845,'category',250,'bathroom/showering/brands/ideal-stnadard.html','catalog/category/view/id/250',0,4,NULL,1,NULL),(8846,'category',251,'bathroom/showering/brands/hudson-reed.html','catalog/category/view/id/251',0,4,NULL,1,NULL),(8847,'category',252,'bathroom/showering/brands/rak.html','catalog/category/view/id/252',0,4,NULL,1,NULL),(8848,'category',66,'bathroom/showering/shower-doors.html','catalog/category/view/id/66',0,4,NULL,1,NULL),(8849,'category',67,'bathroom/showering/shower-doors/pivot-doors.html','catalog/category/view/id/67',0,4,NULL,1,NULL),(8850,'category',68,'bathroom/showering/shower-doors/hinged-doors.html','catalog/category/view/id/68',0,4,NULL,1,NULL),(8851,'category',69,'bathroom/showering/shower-doors/sliding-doors.html','catalog/category/view/id/69',0,4,NULL,1,NULL),(8852,'category',70,'bathroom/showering/shower-doors/bi-fold-doors.html','catalog/category/view/id/70',0,4,NULL,1,NULL),(8853,'category',71,'bathroom/showering/shower-enclosures.html','catalog/category/view/id/71',0,4,NULL,1,NULL),(8854,'category',245,'bathroom/showering/shower-enclosures/curved-enclosures.html','catalog/category/view/id/245',0,4,NULL,1,NULL),(8855,'category',246,'bathroom/showering/shower-enclosures/3-sided-enclosures.html','catalog/category/view/id/246',0,4,NULL,1,NULL),(8856,'category',72,'bathroom/showering/shower-enclosures/pivot-enclosures.html','catalog/category/view/id/72',0,4,NULL,1,NULL),(8857,'category',73,'bathroom/showering/shower-enclosures/hinged-enclosures.html','catalog/category/view/id/73',0,4,NULL,1,NULL),(8858,'category',74,'bathroom/showering/shower-enclosures/sliding-enclosures.html','catalog/category/view/id/74',0,4,NULL,1,NULL),(8859,'category',75,'bathroom/showering/shower-enclosures/bi-fold-enclosures.html','catalog/category/view/id/75',0,4,NULL,1,NULL),(8860,'category',76,'bathroom/showering/shower-enclosures/d-shaped-enclosures.html','catalog/category/view/id/76',0,4,NULL,1,NULL),(8861,'category',77,'bathroom/showering/shower-enclosures/walk-in-showers.html','catalog/category/view/id/77',0,4,NULL,1,NULL),(8862,'category',78,'bathroom/showering/shower-enclosures/quadrant.html','catalog/category/view/id/78',0,4,NULL,1,NULL),(8863,'category',79,'bathroom/showering/shower-enclosures/pentagons.html','catalog/category/view/id/79',0,4,NULL,1,NULL),(8864,'category',80,'bathroom/showering/shower-enclosures/wet-rooms.html','catalog/category/view/id/80',0,4,NULL,1,NULL),(8865,'category',81,'bathroom/showering/shower-enclosures/corner-entry-enclosures.html','catalog/category/view/id/81',0,4,NULL,1,NULL),(8866,'category',82,'bathroom/showering/shower-trays.html','catalog/category/view/id/82',0,4,NULL,1,NULL),(8867,'category',83,'bathroom/showering/shower-trays/square-trays.html','catalog/category/view/id/83',0,4,NULL,1,NULL),(8868,'category',84,'bathroom/showering/shower-trays/rectangular-trays.html','catalog/category/view/id/84',0,4,NULL,1,NULL),(8869,'category',85,'bathroom/showering/shower-trays/quadrant-trays.html','catalog/category/view/id/85',0,4,NULL,1,NULL),(8870,'category',86,'bathroom/showering/shower-trays/pentagon-trays.html','catalog/category/view/id/86',0,4,NULL,1,NULL),(8871,'category',46,'bathroom/bathroom-furniture.html','catalog/category/view/id/46',0,4,NULL,1,NULL),(8872,'category',295,'bathroom/bathroom-furniture/bathroom-furniture.html','catalog/category/view/id/295',0,4,NULL,1,NULL),(8873,'category',296,'bathroom/bathroom-furniture/bathroom-furniture/corner-vanity-units.html','catalog/category/view/id/296',0,4,NULL,1,NULL),(8874,'category',297,'bathroom/bathroom-furniture/bathroom-furniture/double-sink-vanity-units.html','catalog/category/view/id/297',0,4,NULL,1,NULL),(8875,'category',298,'bathroom/bathroom-furniture/bathroom-furniture/countertop-vanity-units.html','catalog/category/view/id/298',0,4,NULL,1,NULL),(8876,'category',299,'bathroom/bathroom-furniture/bathroom-furniture/toilet-and-sink-units.html','catalog/category/view/id/299',0,4,NULL,1,NULL),(8877,'category',300,'bathroom/bathroom-furniture/bathroom-furniture/tall-bathroom-cabinets.html','catalog/category/view/id/300',0,4,NULL,1,NULL),(8878,'category',47,'bathroom/bathroom-furniture/bathroom-furniture/floor-standing-units.html','catalog/category/view/id/47',0,4,NULL,1,NULL),(8879,'category',48,'bathroom/bathroom-furniture/bathroom-furniture/wall-hung-units.html','catalog/category/view/id/48',0,4,NULL,1,NULL),(8880,'category',49,'bathroom/bathroom-furniture/bathroom-furniture/cloakroom-units.html','catalog/category/view/id/49',0,4,NULL,1,NULL),(8881,'category',50,'bathroom/bathroom-furniture/bathroom-furniture/wc-units.html','catalog/category/view/id/50',0,4,NULL,1,NULL),(8882,'category',301,'bathroom/bathroom-furniture/brands.html','catalog/category/view/id/301',0,4,NULL,1,NULL),(8883,'category',302,'bathroom/bathroom-furniture/brands/hudson-reed.html','catalog/category/view/id/302',0,4,NULL,1,NULL),(8884,'category',303,'bathroom/bathroom-furniture/brands/rak-ceramics.html','catalog/category/view/id/303',0,4,NULL,1,NULL),(8885,'category',304,'bathroom/bathroom-furniture/brands/roca.html','catalog/category/view/id/304',0,4,NULL,1,NULL),(8886,'category',305,'bathroom/bathroom-furniture/brands/vitra.html','catalog/category/view/id/305',0,4,NULL,1,NULL),(8887,'category',306,'bathroom/bathroom-furniture/brands/nuie.html','catalog/category/view/id/306',0,4,NULL,1,NULL),(8888,'category',51,'bathroom/bathroom-suites.html','catalog/category/view/id/51',0,4,NULL,1,NULL),(8889,'category',52,'bathroom/bathroom-suites/cloakroom-suites.html','catalog/category/view/id/52',0,4,NULL,1,NULL),(8890,'category',53,'bathroom/bathroom-suites/contemporary-suites.html','catalog/category/view/id/53',0,4,NULL,1,NULL),(8891,'category',54,'bathroom/mirrors-cabinets.html','catalog/category/view/id/54',0,4,NULL,1,NULL),(8892,'category',289,'bathroom/mirrors-cabinets/brands.html','catalog/category/view/id/289',0,4,NULL,1,NULL),(8893,'category',290,'bathroom/mirrors-cabinets/brands/hib.html','catalog/category/view/id/290',0,4,NULL,1,NULL),(8894,'category',291,'bathroom/mirrors-cabinets/brands/hudson-reed.html','catalog/category/view/id/291',0,4,NULL,1,NULL),(8895,'category',292,'bathroom/mirrors-cabinets/brands/rak-ceramics.html','catalog/category/view/id/292',0,4,NULL,1,NULL),(8896,'category',293,'bathroom/mirrors-cabinets/brands/roca.html','catalog/category/view/id/293',0,4,NULL,1,NULL),(8897,'category',294,'bathroom/mirrors-cabinets/brands/nuie.html','catalog/category/view/id/294',0,4,NULL,1,NULL),(8898,'category',55,'bathroom/mirrors-cabinets/mirrors.html','catalog/category/view/id/55',0,4,NULL,1,NULL),(8899,'category',283,'bathroom/mirrors-cabinets/mirrors/standard-mirrors.html','catalog/category/view/id/283',0,4,NULL,1,NULL),(8900,'category',284,'bathroom/mirrors-cabinets/mirrors/led-mirrors.html','catalog/category/view/id/284',0,4,NULL,1,NULL),(8901,'category',285,'bathroom/mirrors-cabinets/mirrors/backlit-mirrors.html','catalog/category/view/id/285',0,4,NULL,1,NULL),(8902,'category',286,'bathroom/mirrors-cabinets/mirrors/demister-mirrors.html','catalog/category/view/id/286',0,4,NULL,1,NULL),(8903,'category',287,'bathroom/mirrors-cabinets/mirrors/magnifying-mirrors.html','catalog/category/view/id/287',0,4,NULL,1,NULL),(8904,'category',288,'bathroom/mirrors-cabinets/mirrors/smart-mirrors.html','catalog/category/view/id/288',0,4,NULL,1,NULL),(8905,'category',56,'bathroom/mirrors-cabinets/mirror-cabinets.html','catalog/category/view/id/56',0,4,NULL,1,NULL),(8906,'category',57,'bathroom/frames-plates.html','catalog/category/view/id/57',0,4,NULL,1,NULL),(8907,'category',58,'bathroom/frames-plates/bidet-frames.html','catalog/category/view/id/58',0,4,NULL,1,NULL),(8908,'category',59,'bathroom/frames-plates/toilet-frames.html','catalog/category/view/id/59',0,4,NULL,1,NULL),(8909,'category',61,'bathroom/frames-plates/plates.html','catalog/category/view/id/61',0,4,NULL,1,NULL),(8910,'category',62,'bathroom/pvc-panels.html','catalog/category/view/id/62',0,4,NULL,1,NULL),(8911,'category',63,'bathroom/pvc-panels/ceiling-panels.html','catalog/category/view/id/63',0,4,NULL,1,NULL),(8912,'category',64,'bathroom/pvc-panels/wall-splash-panels.html','catalog/category/view/id/64',0,4,NULL,1,NULL),(8913,'category',65,'bathroom/pvc-panels/pvc-trims.html','catalog/category/view/id/65',0,4,NULL,1,NULL),(8914,'category',8,'bathroom/taps.html','catalog/category/view/id/8',0,4,NULL,1,NULL),(8915,'category',150,'bathroom/taps/bathroom-taps.html','catalog/category/view/id/150',0,4,NULL,1,NULL),(8916,'category',152,'bathroom/taps/bath-taps.html','catalog/category/view/id/152',0,4,NULL,1,NULL),(8917,'category',153,'bathroom/taps/bath-taps/single-bath-taps.html','catalog/category/view/id/153',0,4,NULL,1,NULL),(8918,'category',154,'bathroom/taps/bath-taps/mixer-taps.html','catalog/category/view/id/154',0,4,NULL,1,NULL),(8919,'category',155,'bathroom/taps/bath-taps/wall-hung-taps.html','catalog/category/view/id/155',0,4,NULL,1,NULL),(8920,'category',156,'bathroom/taps/bath-taps/free-standing-taps.html','catalog/category/view/id/156',0,4,NULL,1,NULL),(8921,'category',157,'bathroom/taps/bath-taps/bath-spouts.html','catalog/category/view/id/157',0,4,NULL,1,NULL),(8922,'category',158,'bathroom/taps/bath-taps/bath-filler.html','catalog/category/view/id/158',0,4,NULL,1,NULL),(8923,'category',279,'bathroom/taps/bath-taps/bath-tap-pairs.html','catalog/category/view/id/279',0,4,NULL,1,NULL),(8924,'category',280,'bathroom/taps/bath-taps/deck-mounted-taps.html','catalog/category/view/id/280',0,4,NULL,1,NULL),(8925,'category',282,'bathroom/taps/bath-taps/bath-basin-tap-sets.html','catalog/category/view/id/282',0,4,NULL,1,NULL),(8926,'category',159,'bathroom/taps/basin-taps.html','catalog/category/view/id/159',0,4,NULL,1,NULL),(8927,'category',151,'bathroom/taps/basin-taps/bidet-mixers.html','catalog/category/view/id/151',0,4,NULL,1,NULL),(8928,'category',160,'bathroom/taps/basin-taps/basin-mixer-taps.html','catalog/category/view/id/160',0,4,NULL,1,NULL),(8929,'category',161,'bathroom/taps/basin-taps/wall-hung-tap.html','catalog/category/view/id/161',0,4,NULL,1,NULL),(8930,'category',162,'bathroom/taps/basin-taps/sensor-tap.html','catalog/category/view/id/162',0,4,NULL,1,NULL),(8931,'category',276,'bathroom/taps/basin-taps/high-rise-basin-taps.html','catalog/category/view/id/276',0,4,NULL,1,NULL),(8932,'category',277,'bathroom/taps/basin-taps/basin-tap-pairs.html','catalog/category/view/id/277',0,4,NULL,1,NULL),(8933,'category',278,'bathroom/taps/basin-taps/bath-basin-tap-sets.html','catalog/category/view/id/278',0,4,NULL,1,NULL),(8934,'category',9,'bathroom/shower-valves.html','catalog/category/view/id/9',0,4,NULL,1,NULL),(8935,'category',165,'bathroom/shower-valves/all-showers.html','catalog/category/view/id/165',0,4,NULL,1,NULL),(8936,'category',166,'bathroom/shower-valves/all-showers/full-showers.html','catalog/category/view/id/166',0,4,NULL,1,NULL),(8937,'category',167,'bathroom/shower-valves/all-showers/shower-panels.html','catalog/category/view/id/167',0,4,NULL,1,NULL),(8938,'category',168,'bathroom/shower-valves/all-showers/electric-showers.html','catalog/category/view/id/168',0,4,NULL,1,NULL),(8939,'category',176,'bathroom/shower-valves/all-showers/slider-kits.html','catalog/category/view/id/176',0,4,NULL,1,NULL),(8940,'category',238,'bathroom/shower-valves/all-showers/shower-head-with-arm.html','catalog/category/view/id/238',0,4,NULL,1,NULL),(8941,'category',169,'bathroom/shower-valves/accessories.html','catalog/category/view/id/169',0,4,NULL,1,NULL),(8942,'category',175,'bathroom/shower-valves/accessories/hand-showers.html','catalog/category/view/id/175',0,4,NULL,1,NULL),(8943,'category',177,'bathroom/shower-valves/accessories/shower-heads.html','catalog/category/view/id/177',0,4,NULL,1,NULL),(8944,'category',178,'bathroom/shower-valves/accessories/shower-arms.html','catalog/category/view/id/178',0,4,NULL,1,NULL),(8945,'category',179,'bathroom/shower-valves/accessories/body-jets.html','catalog/category/view/id/179',0,4,NULL,1,NULL),(8946,'category',180,'bathroom/shower-valves/accessories/shower-hose.html','catalog/category/view/id/180',0,4,NULL,1,NULL),(8947,'category',181,'bathroom/shower-valves/accessories/accessories.html','catalog/category/view/id/181',0,4,NULL,1,NULL),(8948,'category',170,'bathroom/shower-valves/valves.html','catalog/category/view/id/170',0,4,NULL,1,NULL),(8949,'category',171,'bathroom/shower-valves/valves/exposed-valves.html','catalog/category/view/id/171',0,4,NULL,1,NULL),(8950,'category',172,'bathroom/shower-valves/valves/concealed-valves.html','catalog/category/view/id/172',0,4,NULL,1,NULL),(8951,'category',173,'bathroom/shower-valves/valves/thermostatic-valves.html','catalog/category/view/id/173',0,4,NULL,1,NULL),(8952,'category',174,'bathroom/shower-valves/valves/traditional-valves.html','catalog/category/view/id/174',0,4,NULL,1,NULL),(8953,'category',239,'bathroom/shower-valves/valves/bar-valves.html','catalog/category/view/id/239',0,4,NULL,1,NULL),(8954,'category',240,'bathroom/shower-valves/brands.html','catalog/category/view/id/240',0,4,NULL,1,NULL),(8955,'category',241,'bathroom/shower-valves/brands/hansgrohe.html','catalog/category/view/id/241',0,4,NULL,1,NULL),(8956,'category',242,'bathroom/shower-valves/brands/grohe.html','catalog/category/view/id/242',0,4,NULL,1,NULL),(8957,'category',243,'bathroom/shower-valves/brands/nuei.html','catalog/category/view/id/243',0,4,NULL,1,NULL),(8958,'category',244,'bathroom/shower-valves/brands/hudson-reed.html','catalog/category/view/id/244',0,4,NULL,1,NULL),(8959,'category',5,'kitchen-appliances.html','catalog/category/view/id/5',0,4,NULL,1,NULL),(8960,'category',145,'kitchen-appliances/kitchen-taps.html','catalog/category/view/id/145',0,4,NULL,1,NULL),(8961,'category',146,'kitchen-appliances/kitchen-taps/kitchen-sink-taps.html','catalog/category/view/id/146',0,4,NULL,1,NULL),(8962,'category',149,'kitchen-appliances/kitchen-taps/sensor-taps.html','catalog/category/view/id/149',0,4,NULL,1,NULL),(8963,'category',329,'kitchen-appliances/kitchen-taps/kitchen-tap-type.html','catalog/category/view/id/329',0,4,NULL,1,NULL),(8964,'category',147,'kitchen-appliances/kitchen-taps/kitchen-tap-type/instant-hot-water-taps.html','catalog/category/view/id/147',0,4,NULL,1,NULL),(8965,'category',148,'kitchen-appliances/kitchen-taps/kitchen-tap-type/filter-flow-taps.html','catalog/category/view/id/148',0,4,NULL,1,NULL),(8966,'category',330,'kitchen-appliances/kitchen-taps/kitchen-tap-type/kitchen-mixer-taps.html','catalog/category/view/id/330',0,4,NULL,1,NULL),(8967,'category',331,'kitchen-appliances/kitchen-taps/kitchen-tap-type/pull-out-kitchen-taps.html','catalog/category/view/id/331',0,4,NULL,1,NULL),(8968,'category',332,'kitchen-appliances/kitchen-taps/kitchen-tap-type/coloured-kitchen-taps.html','catalog/category/view/id/332',0,4,NULL,1,NULL),(8969,'category',335,'kitchen-appliances/kitchen-taps/kitchen-tap-type/sparkling-water-taps.html','catalog/category/view/id/335',0,4,NULL,1,NULL),(8970,'category',336,'kitchen-appliances/kitchen-taps/kitchen-tap-type/smart-taps.html','catalog/category/view/id/336',0,4,NULL,1,NULL),(8971,'category',337,'kitchen-appliances/kitchen-taps/brands.html','catalog/category/view/id/337',0,4,NULL,1,NULL),(8972,'category',338,'kitchen-appliances/kitchen-taps/brands/franke.html','catalog/category/view/id/338',0,4,NULL,1,NULL),(8973,'category',339,'kitchen-appliances/kitchen-taps/brands/blanco.html','catalog/category/view/id/339',0,4,NULL,1,NULL),(8974,'category',340,'kitchen-appliances/kitchen-taps/brands/reginox.html','catalog/category/view/id/340',0,4,NULL,1,NULL),(8975,'category',341,'kitchen-appliances/kitchen-taps/brands/grohe.html','catalog/category/view/id/341',0,4,NULL,1,NULL),(8976,'category',342,'kitchen-appliances/kitchen-taps/brands/hansgrohe.html','catalog/category/view/id/342',0,4,NULL,1,NULL),(8977,'category',344,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories.html','catalog/category/view/id/344',0,4,NULL,1,NULL),(8978,'category',345,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/soap-dispensors.html','catalog/category/view/id/345',0,4,NULL,1,NULL),(8979,'category',346,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/filters.html','catalog/category/view/id/346',0,4,NULL,1,NULL),(8980,'category',347,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/hot-water-tanks.html','catalog/category/view/id/347',0,4,NULL,1,NULL),(8981,'category',318,'kitchen-appliances/kitchen-sinks.html','catalog/category/view/id/318',0,4,NULL,1,NULL),(8982,'category',106,'kitchen-appliances/kitchen-sinks/sink-type.html','catalog/category/view/id/106',0,4,NULL,1,NULL),(8983,'category',107,'kitchen-appliances/kitchen-sinks/sink-type/full-sinks.html','catalog/category/view/id/107',0,4,NULL,1,NULL),(8984,'category',109,'kitchen-appliances/kitchen-sinks/sink-type/sink-tap-packages.html','catalog/category/view/id/109',0,4,NULL,1,NULL),(8985,'category',307,'kitchen-appliances/kitchen-sinks/sink-type/undermount.html','catalog/category/view/id/307',0,4,NULL,1,NULL),(8986,'category',308,'kitchen-appliances/kitchen-sinks/sink-type/inset-flushmount.html','catalog/category/view/id/308',0,4,NULL,1,NULL),(8987,'category',309,'kitchen-appliances/kitchen-sinks/sink-type/1-0-bowl-sinks.html','catalog/category/view/id/309',0,4,NULL,1,NULL),(8988,'category',310,'kitchen-appliances/kitchen-sinks/sink-type/1-5-bowl-sinks.html','catalog/category/view/id/310',0,4,NULL,1,NULL),(8989,'category',311,'kitchen-appliances/kitchen-sinks/sink-type/2-0-bowl-sinks.html','catalog/category/view/id/311',0,4,NULL,1,NULL),(8990,'category',312,'kitchen-appliances/kitchen-sinks/sink-type/belfast-sinks.html','catalog/category/view/id/312',0,4,NULL,1,NULL),(8991,'category',313,'kitchen-appliances/kitchen-sinks/sink-material.html','catalog/category/view/id/313',0,4,NULL,1,NULL),(8992,'category',108,'kitchen-appliances/kitchen-sinks/sink-material/stainless-steel-sinks.html','catalog/category/view/id/108',0,4,NULL,1,NULL),(8993,'category',314,'kitchen-appliances/kitchen-sinks/sink-material/ceramic-sinks.html','catalog/category/view/id/314',0,4,NULL,1,NULL),(8994,'category',315,'kitchen-appliances/kitchen-sinks/sink-material/granite-sinks.html','catalog/category/view/id/315',0,4,NULL,1,NULL),(8995,'category',316,'kitchen-appliances/kitchen-sinks/sink-material/composite-sinks.html','catalog/category/view/id/316',0,4,NULL,1,NULL),(8996,'category',317,'kitchen-appliances/kitchen-sinks/sink-material/coloured-sinks.html','catalog/category/view/id/317',0,4,NULL,1,NULL),(8997,'category',319,'kitchen-appliances/kitchen-sinks/accessories.html','catalog/category/view/id/319',0,4,NULL,1,NULL),(8998,'category',110,'kitchen-appliances/kitchen-sinks/accessories/kitchen-accessories.html','catalog/category/view/id/110',0,4,NULL,1,NULL),(8999,'category',321,'kitchen-appliances/kitchen-sinks/accessories/waster-sorter.html','catalog/category/view/id/321',0,4,NULL,1,NULL),(9000,'category',322,'kitchen-appliances/kitchen-sinks/accessories/plumbing-kits.html','catalog/category/view/id/322',0,4,NULL,1,NULL),(9001,'category',323,'kitchen-appliances/kitchen-sinks/brands.html','catalog/category/view/id/323',0,4,NULL,1,NULL),(9002,'category',324,'kitchen-appliances/kitchen-sinks/brands/franke.html','catalog/category/view/id/324',0,4,NULL,1,NULL),(9003,'category',325,'kitchen-appliances/kitchen-sinks/brands/reginox.html','catalog/category/view/id/325',0,4,NULL,1,NULL),(9004,'category',326,'kitchen-appliances/kitchen-sinks/brands/blanco.html','catalog/category/view/id/326',0,4,NULL,1,NULL),(9005,'category',327,'kitchen-appliances/kitchen-sinks/brands/grohe.html','catalog/category/view/id/327',0,4,NULL,1,NULL),(9006,'category',328,'kitchen-appliances/kitchen-sinks/brands/hansgrohe.html','catalog/category/view/id/328',0,4,NULL,1,NULL),(9007,'category',343,'kitchen-appliances/appliances.html','catalog/category/view/id/343',0,4,NULL,1,NULL),(9008,'category',100,'kitchen-appliances/appliances/fridges-freezers.html','catalog/category/view/id/100',0,4,NULL,1,NULL),(9009,'category',101,'kitchen-appliances/appliances/fridges-freezers/fridges-freezers.html','catalog/category/view/id/101',0,4,NULL,1,NULL),(9010,'category',102,'kitchen-appliances/appliances/fridges-freezers/fridges.html','catalog/category/view/id/102',0,4,NULL,1,NULL),(9011,'category',103,'kitchen-appliances/appliances/fridges-freezers/freezers.html','catalog/category/view/id/103',0,4,NULL,1,NULL),(9012,'category',104,'kitchen-appliances/appliances/fridges-freezers/wine-coolers.html','catalog/category/view/id/104',0,4,NULL,1,NULL),(9013,'category',105,'kitchen-appliances/appliances/fridges-freezers/american-style-fridge-freezers.html','catalog/category/view/id/105',0,4,NULL,1,NULL),(9014,'category',348,'kitchen-appliances/appliances/accessories.html','catalog/category/view/id/348',0,4,NULL,1,NULL),(9015,'category',349,'kitchen-appliances/appliances/accessories/accessories.html','catalog/category/view/id/349',0,4,NULL,1,NULL),(9016,'category',350,'kitchen-appliances/appliances/brands.html','catalog/category/view/id/350',0,4,NULL,1,NULL),(9017,'category',351,'kitchen-appliances/appliances/brands/bosch.html','catalog/category/view/id/351',0,4,NULL,1,NULL),(9018,'category',352,'kitchen-appliances/appliances/brands/neff.html','catalog/category/view/id/352',0,4,NULL,1,NULL),(9019,'category',353,'kitchen-appliances/appliances/brands/siemens.html','catalog/category/view/id/353',0,4,NULL,1,NULL),(9020,'category',354,'kitchen-appliances/appliances/brands/franke.html','catalog/category/view/id/354',0,4,NULL,1,NULL),(9021,'category',355,'kitchen-appliances/appliances/brands/elica.html','catalog/category/view/id/355',0,4,NULL,1,NULL),(9022,'category',87,'kitchen-appliances/appliances/cooking-baking.html','catalog/category/view/id/87',0,4,NULL,1,NULL),(9023,'category',88,'kitchen-appliances/appliances/cooking-baking/ovens.html','catalog/category/view/id/88',0,4,NULL,1,NULL),(9024,'category',89,'kitchen-appliances/appliances/cooking-baking/hobs.html','catalog/category/view/id/89',0,4,NULL,1,NULL),(9025,'category',90,'kitchen-appliances/appliances/cooking-baking/steam-appliances.html','catalog/category/view/id/90',0,4,NULL,1,NULL),(9026,'category',91,'kitchen-appliances/appliances/cooking-baking/microwaves.html','catalog/category/view/id/91',0,4,NULL,1,NULL),(9027,'category',92,'kitchen-appliances/appliances/cooking-baking/coffee-machine.html','catalog/category/view/id/92',0,4,NULL,1,NULL),(9028,'category',93,'kitchen-appliances/appliances/cooking-baking/cooker-hoods.html','catalog/category/view/id/93',0,4,NULL,1,NULL),(9029,'category',94,'kitchen-appliances/appliances/cooking-baking/warming-drawers.html','catalog/category/view/id/94',0,4,NULL,1,NULL),(9030,'category',95,'kitchen-appliances/appliances/cooking-baking/cooking-accessories.html','catalog/category/view/id/95',0,4,NULL,1,NULL),(9031,'category',96,'kitchen-appliances/appliances/washers-dryers.html','catalog/category/view/id/96',0,4,NULL,1,NULL),(9032,'category',97,'kitchen-appliances/appliances/washers-dryers/washing-machines.html','catalog/category/view/id/97',0,4,NULL,1,NULL),(9033,'category',98,'kitchen-appliances/appliances/dishwashers.html','catalog/category/view/id/98',0,4,NULL,1,NULL),(9034,'category',99,'kitchen-appliances/appliances/dishwashers/built-in-dishwashers.html','catalog/category/view/id/99',0,4,NULL,1,NULL),(9035,'category',356,'kitchen-appliances/kitchen-accessories.html','catalog/category/view/id/356',0,4,NULL,1,NULL),(9036,'category',358,'kitchen-appliances/kitchen-accessories/accessories.html','catalog/category/view/id/358',0,4,NULL,1,NULL),(9037,'category',359,'kitchen-appliances/kitchen-accessories/accessories/soap-dispensors.html','catalog/category/view/id/359',0,4,NULL,1,NULL),(9038,'category',360,'kitchen-appliances/kitchen-accessories/accessories/chopping-boards.html','catalog/category/view/id/360',0,4,NULL,1,NULL),(9039,'category',361,'kitchen-appliances/kitchen-accessories/accessories/strainers.html','catalog/category/view/id/361',0,4,NULL,1,NULL),(9040,'category',362,'kitchen-appliances/kitchen-accessories/accessories/colanders.html','catalog/category/view/id/362',0,4,NULL,1,NULL),(9041,'category',363,'kitchen-appliances/kitchen-accessories/accessories/metal-grids.html','catalog/category/view/id/363',0,4,NULL,1,NULL),(9042,'category',364,'kitchen-appliances/kitchen-accessories/accessories/cleaning-sprays.html','catalog/category/view/id/364',0,4,NULL,1,NULL),(9043,'category',365,'kitchen-appliances/kitchen-accessories/accessories/waste-and-plumbing-kits.html','catalog/category/view/id/365',0,4,NULL,1,NULL),(9044,'category',7,'heating.html','catalog/category/view/id/7',0,4,NULL,1,NULL),(9045,'category',366,'heating/radiators.html','catalog/category/view/id/366',0,4,NULL,1,NULL),(9046,'category',142,'heating/radiators/towel-rails.html','catalog/category/view/id/142',0,4,NULL,1,NULL),(9047,'category',143,'heating/radiators/towel-rails/heated-towel-rails.html','catalog/category/view/id/143',0,4,NULL,1,NULL),(9048,'category',144,'heating/radiators/towel-rails/electric-towel-rails.html','catalog/category/view/id/144',0,4,NULL,1,NULL),(9049,'category',371,'heating/radiators/towel-rails/dual-fuel-towel-rails.html','catalog/category/view/id/371',0,4,NULL,1,NULL),(9050,'category',367,'heating/radiators/radiators.html','catalog/category/view/id/367',0,4,NULL,1,NULL),(9051,'category',135,'heating/radiators/radiators/designer-radiators.html','catalog/category/view/id/135',0,4,NULL,1,NULL),(9052,'category',136,'heating/radiators/radiators/vertical-designer-radiators.html','catalog/category/view/id/136',0,4,NULL,1,NULL),(9053,'category',137,'heating/radiators/radiators/horizontal-designer-radiators.html','catalog/category/view/id/137',0,4,NULL,1,NULL),(9054,'category',138,'heating/radiators/radiators/traditional-radiators.html','catalog/category/view/id/138',0,4,NULL,1,NULL),(9055,'category',139,'heating/radiators/radiators/electric-radiators.html','catalog/category/view/id/139',0,4,NULL,1,NULL),(9056,'category',140,'heating/radiators/radiators/radiator-valves.html','catalog/category/view/id/140',0,4,NULL,1,NULL),(9057,'category',141,'heating/radiators/radiators/heating-elements.html','catalog/category/view/id/141',0,4,NULL,1,NULL),(9058,'category',368,'heating/radiators/radiators/column-radiators.html','catalog/category/view/id/368',0,4,NULL,1,NULL),(9059,'category',369,'heating/radiators/radiators/convector-radiators.html','catalog/category/view/id/369',0,4,NULL,1,NULL),(9060,'category',370,'heating/radiators/radiators/floor-standing-radiators.html','catalog/category/view/id/370',0,4,NULL,1,NULL),(9061,'category',372,'heating/radiators/brands.html','catalog/category/view/id/372',0,4,NULL,1,NULL),(9062,'category',373,'heating/radiators/brands/nuie.html','catalog/category/view/id/373',0,4,NULL,1,NULL),(9063,'category',374,'heating/radiators/brands/hudson-reed.html','catalog/category/view/id/374',0,4,NULL,1,NULL),(9064,'category',375,'heating/radiators/brands/carisa.html','catalog/category/view/id/375',0,4,NULL,1,NULL),(9065,'category',376,'heating/radiators/brands/zehnder.html','catalog/category/view/id/376',0,4,NULL,1,NULL),(9066,'category',377,'heating/radiators/brands/reina.html','catalog/category/view/id/377',0,4,NULL,1,NULL),(9067,'category',6,'heating/fires.html','catalog/category/view/id/6',0,4,NULL,1,NULL),(9068,'category',111,'heating/fires/gas-fires.html','catalog/category/view/id/111',0,4,NULL,1,NULL),(9069,'category',112,'heating/fires/gas-fires/front-view-gas-fires.html','catalog/category/view/id/112',0,4,NULL,1,NULL),(9070,'category',113,'heating/fires/gas-fires/corner-gas-fires.html','catalog/category/view/id/113',0,4,NULL,1,NULL),(9071,'category',114,'heating/fires/gas-fires/three-sided-gas-fires.html','catalog/category/view/id/114',0,4,NULL,1,NULL),(9072,'category',115,'heating/fires/gas-fires/tunnel-gas-fires.html','catalog/category/view/id/115',0,4,NULL,1,NULL),(9073,'category',116,'heating/fires/gas-fires/heaters.html','catalog/category/view/id/116',0,4,NULL,1,NULL),(9074,'category',117,'heating/fires/gas-fires/hole-in-the-wall-gas-fires.html','catalog/category/view/id/117',0,4,NULL,1,NULL),(9075,'category',118,'heating/fires/gas-fires/high-efficiency-gas-fires.html','catalog/category/view/id/118',0,4,NULL,1,NULL),(9076,'category',119,'heating/fires/gas-fires/glass-fronted-gas-fire.html','catalog/category/view/id/119',0,4,NULL,1,NULL),(9077,'category',120,'heating/fires/gas-fires/inset-gas-fires.html','catalog/category/view/id/120',0,4,NULL,1,NULL),(9078,'category',121,'heating/fires/gas-fires/wall-mounted-gas-fires.html','catalog/category/view/id/121',0,4,NULL,1,NULL),(9079,'category',122,'heating/fires/gas-fires/balanced-flue-gas-fires.html','catalog/category/view/id/122',0,4,NULL,1,NULL),(9080,'category',123,'heating/fires/gas-fires/flueless-gas-fires.html','catalog/category/view/id/123',0,4,NULL,1,NULL),(9081,'category',378,'heating/fires/gas-fires/floor-standing-fires.html','catalog/category/view/id/378',0,4,NULL,1,NULL),(9082,'category',379,'heating/fires/gas-fires/top-control-side-control-gas-fires.html','catalog/category/view/id/379',0,4,NULL,1,NULL),(9083,'category',380,'heating/fires/gas-fires/outdoor-gas-fires.html','catalog/category/view/id/380',0,4,NULL,1,NULL),(9084,'category',124,'heating/fires/stoves.html','catalog/category/view/id/124',0,4,NULL,1,NULL),(9085,'category',125,'heating/fires/stoves/wood-multifuel-stoves.html','catalog/category/view/id/125',0,4,NULL,1,NULL),(9086,'category',126,'heating/fires/stoves/electric-stoves.html','catalog/category/view/id/126',0,4,NULL,1,NULL),(9087,'category',127,'heating/fires/stoves/wood-burning-stoves.html','catalog/category/view/id/127',0,4,NULL,1,NULL),(9088,'category',128,'heating/fires/stoves/gas-stoves.html','catalog/category/view/id/128',0,4,NULL,1,NULL),(9089,'category',383,'heating/fires/stoves/flueless-gas-stoves.html','catalog/category/view/id/383',0,4,NULL,1,NULL),(9090,'category',384,'heating/fires/stoves/inset-gas-stoves.html','catalog/category/view/id/384',0,4,NULL,1,NULL),(9091,'category',129,'heating/fires/electric-fires.html','catalog/category/view/id/129',0,4,NULL,1,NULL),(9092,'category',130,'heating/fires/electric-fires/inset-electric-fires.html','catalog/category/view/id/130',0,4,NULL,1,NULL),(9093,'category',132,'heating/fires/electric-fires/wall-mounted-electric-fires.html','catalog/category/view/id/132',0,4,NULL,1,NULL),(9094,'category',133,'heating/fires/electric-fires/electric-fires-and-surrounds.html','catalog/category/view/id/133',0,4,NULL,1,NULL),(9095,'category',381,'heating/fires/electric-fires/floor-standing-electric-fires.html','catalog/category/view/id/381',0,4,NULL,1,NULL),(9096,'category',382,'heating/fires/electric-fires/hole-in-the-wall-electric-fires.html','catalog/category/view/id/382',0,4,NULL,1,NULL),(9097,'category',134,'heating/fires/fires-accessories.html','catalog/category/view/id/134',0,4,NULL,1,NULL),(9098,'category',385,'heating/fires/fireplase-suite.html','catalog/category/view/id/385',0,4,NULL,1,NULL),(9099,'category',386,'heating/fires/fireplase-suite/gas-fireplaces.html','catalog/category/view/id/386',0,4,NULL,1,NULL),(9100,'category',387,'heating/fires/fireplase-suite/electric-fireplaces.html','catalog/category/view/id/387',0,4,NULL,1,NULL),(9101,'category',445,'heating/fires/fireplase-suite/wood-burning-fireplace.html','catalog/category/view/id/445',0,4,NULL,1,NULL),(9102,'category',388,'heating/fires/media-wall-electric-fires.html','catalog/category/view/id/388',0,4,NULL,1,NULL),(9103,'category',389,'heating/fires/media-wall-electric-fires/media-wall-electric-fires.html','catalog/category/view/id/389',0,4,NULL,1,NULL),(9104,'category',390,'heating/fires/brands.html','catalog/category/view/id/390',0,4,NULL,1,NULL),(9105,'category',391,'heating/fires/brands/ag-stoves.html','catalog/category/view/id/391',0,4,NULL,1,NULL),(9106,'category',392,'heating/fires/brands/dik-guerts.html','catalog/category/view/id/392',0,4,NULL,1,NULL),(9107,'category',393,'heating/fires/brands/dimplex.html','catalog/category/view/id/393',0,4,NULL,1,NULL),(9108,'category',394,'heating/fires/brands/dru.html','catalog/category/view/id/394',0,4,NULL,1,NULL),(9109,'category',395,'heating/fires/brands/ekofires.html','catalog/category/view/id/395',0,4,NULL,1,NULL),(9110,'category',396,'heating/fires/brands/element-4.html','catalog/category/view/id/396',0,4,NULL,1,NULL),(9111,'category',397,'heating/fires/brands/esse.html','catalog/category/view/id/397',0,4,NULL,1,NULL),(9112,'category',398,'heating/fires/brands/evonice-fires.html','catalog/category/view/id/398',0,4,NULL,1,NULL),(9113,'category',399,'heating/fires/brands/carron-fires.html','catalog/category/view/id/399',0,4,NULL,1,NULL),(9114,'category',400,'heating/fires/brands/flamerite-fires.html','catalog/category/view/id/400',0,4,NULL,1,NULL),(9115,'category',401,'heating/fires/brands/flavel.html','catalog/category/view/id/401',0,4,NULL,1,NULL),(9116,'category',402,'heating/fires/brands/valor.html','catalog/category/view/id/402',0,4,NULL,1,NULL),(9117,'category',403,'heating/fires/brands/gazco.html','catalog/category/view/id/403',0,4,NULL,1,NULL),(9118,'category',12,'brands.html','catalog/category/view/id/12',0,4,NULL,1,NULL),(9119,'category',404,'brands/a-d.html','catalog/category/view/id/404',0,4,NULL,1,NULL),(9120,'category',405,'brands/a-d/aga-stoves.html','catalog/category/view/id/405',0,4,NULL,1,NULL),(9121,'category',406,'brands/a-d/bette.html','catalog/category/view/id/406',0,4,NULL,1,NULL),(9122,'category',407,'brands/a-d/blanco.html','catalog/category/view/id/407',0,4,NULL,1,NULL),(9123,'category',408,'brands/a-d/carisa.html','catalog/category/view/id/408',0,4,NULL,1,NULL),(9124,'category',409,'brands/a-d/dik-guerts.html','catalog/category/view/id/409',0,4,NULL,1,NULL),(9125,'category',410,'brands/a-d/dimplex.html','catalog/category/view/id/410',0,4,NULL,1,NULL),(9126,'category',411,'brands/a-d/dru.html','catalog/category/view/id/411',0,4,NULL,1,NULL),(9127,'category',444,'brands/a-d/aeon.html','catalog/category/view/id/444',0,4,NULL,1,NULL),(9128,'category',412,'brands/e-i.html','catalog/category/view/id/412',0,4,NULL,1,NULL),(9129,'category',413,'brands/e-i/ekofires.html','catalog/category/view/id/413',0,4,NULL,1,NULL),(9130,'category',414,'brands/e-i/element-4.html','catalog/category/view/id/414',0,4,NULL,1,NULL),(9131,'category',415,'brands/e-i/elica.html','catalog/category/view/id/415',0,4,NULL,1,NULL),(9132,'category',416,'brands/e-i/esse.html','catalog/category/view/id/416',0,4,NULL,1,NULL),(9133,'category',417,'brands/e-i/evonic-fires.html','catalog/category/view/id/417',0,4,NULL,1,NULL),(9134,'category',418,'brands/e-i/flamerite-fires.html','catalog/category/view/id/418',0,4,NULL,1,NULL),(9135,'category',419,'brands/e-i/flavel.html','catalog/category/view/id/419',0,4,NULL,1,NULL),(9136,'category',420,'brands/e-i/franke.html','catalog/category/view/id/420',0,4,NULL,1,NULL),(9137,'category',421,'brands/e-i/gazco.html','catalog/category/view/id/421',0,4,NULL,1,NULL),(9138,'category',422,'brands/e-i/geberit.html','catalog/category/view/id/422',0,4,NULL,1,NULL),(9139,'category',423,'brands/e-i/grohe.html','catalog/category/view/id/423',0,4,NULL,1,NULL),(9140,'category',424,'brands/e-i/hansgrohe.html','catalog/category/view/id/424',0,4,NULL,1,NULL),(9141,'category',425,'brands/e-i/hib.html','catalog/category/view/id/425',0,4,NULL,1,NULL),(9142,'category',426,'brands/e-i/hudson-reed.html','catalog/category/view/id/426',0,4,NULL,1,NULL),(9143,'category',427,'brands/e-i/ideal-standard.html','catalog/category/view/id/427',0,4,NULL,1,NULL),(9144,'category',428,'brands/j-r.html','catalog/category/view/id/428',0,4,NULL,1,NULL),(9145,'category',429,'brands/j-r/kaldewei.html','catalog/category/view/id/429',0,4,NULL,1,NULL),(9146,'category',430,'brands/j-r/matki.html','catalog/category/view/id/430',0,4,NULL,1,NULL),(9147,'category',431,'brands/j-r/neff.html','catalog/category/view/id/431',0,4,NULL,1,NULL),(9148,'category',432,'brands/j-r/nuie.html','catalog/category/view/id/432',0,4,NULL,1,NULL),(9149,'category',433,'brands/j-r/rak-ceramics.html','catalog/category/view/id/433',0,4,NULL,1,NULL),(9150,'category',434,'brands/j-r/reginox.html','catalog/category/view/id/434',0,4,NULL,1,NULL),(9151,'category',435,'brands/j-r/reina.html','catalog/category/view/id/435',0,4,NULL,1,NULL),(9152,'category',436,'brands/j-r/roca.html','catalog/category/view/id/436',0,4,NULL,1,NULL),(9153,'category',437,'brands/j-r/royce-morgan.html','catalog/category/view/id/437',0,4,NULL,1,NULL),(9154,'category',438,'brands/s-z.html','catalog/category/view/id/438',0,4,NULL,1,NULL),(9155,'category',439,'brands/s-z/siemens.html','catalog/category/view/id/439',0,4,NULL,1,NULL),(9156,'category',440,'brands/s-z/spartherm.html','catalog/category/view/id/440',0,4,NULL,1,NULL),(9157,'category',441,'brands/s-z/valor.html','catalog/category/view/id/441',0,4,NULL,1,NULL),(9158,'category',442,'brands/s-z/vitra.html','catalog/category/view/id/442',0,4,NULL,1,NULL),(9159,'category',443,'brands/s-z/zehnder.html','catalog/category/view/id/443',0,4,NULL,1,NULL),(9160,'cms-page',1,'no-route','cms/page/view/page_id/1',0,4,NULL,1,NULL),(9161,'cms-page',2,'home','cms/page/view/page_id/2',0,4,NULL,1,NULL),(9162,'cms-page',3,'enable-cookies','cms/page/view/page_id/3',0,4,NULL,1,NULL),(9163,'cms-page',4,'privacy-policy','cms/page/view/page_id/4',0,4,NULL,1,NULL),(9164,'cms-page',5,'terms-and-conditions','cms/page/view/page_id/5',0,4,NULL,1,NULL),(9165,'cms-page',6,'careers','cms/page/view/page_id/6',0,4,NULL,1,NULL),(9166,'cms-page',7,'returns','cms/page/view/page_id/7',0,4,NULL,1,NULL),(9167,'cms-page',8,'how-to-order','cms/page/view/page_id/8',0,4,NULL,1,NULL),(9168,'cms-page',9,'14-day-money-back-guarantee','cms/page/view/page_id/9',0,4,NULL,1,NULL),(9169,'cms-page',10,'visit-our-showroom','cms/page/view/page_id/10',0,4,NULL,1,NULL),(9170,'cms-page',11,'about-us','cms/page/view/page_id/11',0,4,NULL,1,NULL),(9171,'cms-page',12,'faq','cms/page/view/page_id/12',0,4,NULL,1,NULL),(9172,'cms-page',13,'finance','cms/page/view/page_id/13',0,4,NULL,1,NULL),(9173,'cms-page',14,'support','cms/page/view/page_id/14',0,4,NULL,1,NULL),(9174,'cms-page',15,'cart-more-info','cms/page/view/page_id/15',0,4,NULL,1,NULL),(9175,'cms-page',29,'contact-us-nexus','cms/page/view/page_id/29',0,4,NULL,1,NULL),(9180,'category',449,'deals.html','catalog/category/view/id/449',0,1,NULL,1,NULL),(9182,'category',449,'deals.html','catalog/category/view/id/449',0,2,NULL,1,NULL),(9183,'category',449,'deals.html','catalog/category/view/id/449',0,4,NULL,1,NULL),(9188,'product',5760,'test-product.html','catalog/product/view/id/5760',0,1,NULL,1,NULL),(9189,'product',5760,'bathroom/test-product.html','catalog/product/view/id/5760/category/3',0,1,NULL,1,'{\"category_id\":\"3\"}'),(9190,'product',5760,'kitchen-appliances/test-product.html','catalog/product/view/id/5760/category/5',0,1,NULL,1,'{\"category_id\":\"5\"}'),(9191,'product',5760,'heating/fires/test-product.html','catalog/product/view/id/5760/category/6',0,1,NULL,1,'{\"category_id\":\"6\"}'),(9192,'product',5760,'heating/test-product.html','catalog/product/view/id/5760/category/7',0,1,NULL,1,'{\"category_id\":\"7\"}'),(9193,'product',5760,'accessories/test-product.html','catalog/product/view/id/5760/category/10',0,1,NULL,1,'{\"category_id\":\"10\"}'),(9194,'product',5760,'sales/test-product.html','catalog/product/view/id/5760/category/11',0,1,NULL,1,'{\"category_id\":\"11\"}'),(9195,'product',5760,'brands/test-product.html','catalog/product/view/id/5760/category/12',0,1,NULL,1,'{\"category_id\":\"12\"}'),(9196,'product',5760,'kitchen-appliances/kitchen-taps/test-product.html','catalog/product/view/id/5760/category/145',0,1,NULL,1,'{\"category_id\":\"145\"}'),(9198,'product',5760,'comfort-product/test-product.html','catalog/product/view/id/5760/category/164',0,1,NULL,1,'{\"category_id\":\"164\"}'),(9200,'product',5760,'kitchen-appliances/appliances/test-product.html','catalog/product/view/id/5760/category/343',0,1,NULL,1,'{\"category_id\":\"343\"}'),(9201,'product',5760,'kitchen-appliances/kitchen-accessories/test-product.html','catalog/product/view/id/5760/category/356',0,1,NULL,1,'{\"category_id\":\"356\"}'),(9202,'product',5760,'heating/radiators/test-product.html','catalog/product/view/id/5760/category/366',0,1,NULL,1,'{\"category_id\":\"366\"}'),(9203,'product',5760,'deals/test-product.html','catalog/product/view/id/5760/category/449',0,1,NULL,1,'{\"category_id\":\"449\"}'),(9478,'category',3,'bathroom.html','catalog/category/view/id/3',0,5,NULL,1,NULL),(9479,'category',219,'bathroom/toilet.html','catalog/category/view/id/219',0,5,NULL,1,NULL),(9480,'category',15,'bathroom/toilet/toilets.html','catalog/category/view/id/15',0,5,NULL,1,NULL),(9481,'category',16,'bathroom/toilet/toilets/close-coupled-toilets.html','catalog/category/view/id/16',0,5,NULL,1,NULL),(9482,'category',17,'bathroom/toilet/toilets/back-to-wall-toilets.html','catalog/category/view/id/17',0,5,NULL,1,NULL),(9483,'category',18,'bathroom/toilet/toilets/wall-hung-toilets.html','catalog/category/view/id/18',0,5,NULL,1,NULL),(9484,'category',198,'bathroom/toilet/toilets/comfort-height-toilets.html','catalog/category/view/id/198',0,5,NULL,1,NULL),(9485,'category',199,'bathroom/toilet/toilets/rimless-toilets.html','catalog/category/view/id/199',0,5,NULL,1,NULL),(9486,'category',20,'bathroom/toilet/toilets/corner-toilets.html','catalog/category/view/id/20',0,5,NULL,1,NULL),(9487,'category',200,'bathroom/toilet/toilets/wc-unit.html','catalog/category/view/id/200',0,5,NULL,1,NULL),(9488,'category',201,'bathroom/toilet/toilets/smart-toilets.html','catalog/category/view/id/201',0,5,NULL,1,NULL),(9489,'category',202,'bathroom/toilet/toilets/doc-m-packs.html','catalog/category/view/id/202',0,5,NULL,1,NULL),(9490,'category',21,'bathroom/toilet/toilets/bidets.html','catalog/category/view/id/21',0,5,NULL,1,NULL),(9491,'category',22,'bathroom/toilet/toilets/urinals.html','catalog/category/view/id/22',0,5,NULL,1,NULL),(9492,'category',24,'bathroom/toilet/toilets/concealed-cisterns.html','catalog/category/view/id/24',0,5,NULL,1,NULL),(9493,'category',203,'bathroom/toilet/toilet-accessories.html','catalog/category/view/id/203',0,5,NULL,1,NULL),(9494,'category',187,'bathroom/toilet/toilet-accessories/toilet-roll-holders.html','catalog/category/view/id/187',0,5,NULL,1,NULL),(9495,'category',204,'bathroom/toilet/toilet-accessories/douche-shattafs.html','catalog/category/view/id/204',0,5,NULL,1,NULL),(9496,'category',205,'bathroom/toilet/toilet-accessories/flush-buttons-plates.html','catalog/category/view/id/205',0,5,NULL,1,NULL),(9497,'category',208,'bathroom/toilet/toilet-accessories/toilet-brush-and-holders.html','catalog/category/view/id/208',0,5,NULL,1,NULL),(9498,'category',23,'bathroom/toilet/toilet-accessories/toilet-seats.html','catalog/category/view/id/23',0,5,NULL,1,NULL),(9499,'category',209,'bathroom/toilet/brands.html','catalog/category/view/id/209',0,5,NULL,1,NULL),(9500,'category',210,'bathroom/toilet/brands/rak.html','catalog/category/view/id/210',0,5,NULL,1,NULL),(9501,'category',211,'bathroom/toilet/brands/geberit.html','catalog/category/view/id/211',0,5,NULL,1,NULL),(9502,'category',212,'bathroom/toilet/brands/grohe.html','catalog/category/view/id/212',0,5,NULL,1,NULL),(9503,'category',213,'bathroom/toilet/brands/hudson-reed.html','catalog/category/view/id/213',0,5,NULL,1,NULL),(9504,'category',214,'bathroom/toilet/brands/roca.html','catalog/category/view/id/214',0,5,NULL,1,NULL),(9505,'category',215,'bathroom/toilet/brands/vitra.html','catalog/category/view/id/215',0,5,NULL,1,NULL),(9506,'category',216,'bathroom/toilet/brands/nuie.html','catalog/category/view/id/216',0,5,NULL,1,NULL),(9507,'category',25,'bathroom/basins.html','catalog/category/view/id/25',0,5,NULL,1,NULL),(9508,'category',221,'bathroom/basins/basins.html','catalog/category/view/id/221',0,5,NULL,1,NULL),(9509,'category',222,'bathroom/basins/basins/semi-pedestal-basins.html','catalog/category/view/id/222',0,5,NULL,1,NULL),(9510,'category',223,'bathroom/basins/basins/space-saver-basins.html','catalog/category/view/id/223',0,5,NULL,1,NULL),(9511,'category',224,'bathroom/basins/basins/freestanding-basin.html','catalog/category/view/id/224',0,5,NULL,1,NULL),(9512,'category',225,'bathroom/basins/basins/washstands.html','catalog/category/view/id/225',0,5,NULL,1,NULL),(9513,'category',26,'bathroom/basins/basins/pedestal-basins.html','catalog/category/view/id/26',0,5,NULL,1,NULL),(9514,'category',27,'bathroom/basins/basins/wall-hung-basins.html','catalog/category/view/id/27',0,5,NULL,1,NULL),(9515,'category',28,'bathroom/basins/basins/corner-basins.html','catalog/category/view/id/28',0,5,NULL,1,NULL),(9516,'category',29,'bathroom/basins/basins/cloakroom-basins.html','catalog/category/view/id/29',0,5,NULL,1,NULL),(9517,'category',30,'bathroom/basins/basins/vanity-basins.html','catalog/category/view/id/30',0,5,NULL,1,NULL),(9518,'category',31,'bathroom/basins/basins/semi-recessed-basins.html','catalog/category/view/id/31',0,5,NULL,1,NULL),(9519,'category',32,'bathroom/basins/basins/under-counter-basins.html','catalog/category/view/id/32',0,5,NULL,1,NULL),(9520,'category',33,'bathroom/basins/basins/counter-top-basins.html','catalog/category/view/id/33',0,5,NULL,1,NULL),(9521,'category',34,'bathroom/basins/basins/sit-on-basins.html','catalog/category/view/id/34',0,5,NULL,1,NULL),(9522,'category',226,'bathroom/basins/accessories.html','catalog/category/view/id/226',0,5,NULL,1,NULL),(9523,'category',190,'bathroom/basins/accessories/soap-dishes.html','catalog/category/view/id/190',0,5,NULL,1,NULL),(9524,'category',227,'bathroom/basins/accessories/soap-dispenser.html','catalog/category/view/id/227',0,5,NULL,1,NULL),(9525,'category',229,'bathroom/basins/accessories/towel-rails.html','catalog/category/view/id/229',0,5,NULL,1,NULL),(9526,'category',35,'bathroom/basins/accessories/bottle-traps.html','catalog/category/view/id/35',0,5,NULL,1,NULL),(9527,'category',36,'bathroom/basins/accessories/basin-wastes.html','catalog/category/view/id/36',0,5,NULL,1,NULL),(9528,'category',60,'bathroom/basins/accessories/basin-frames.html','catalog/category/view/id/60',0,5,NULL,1,NULL),(9529,'category',230,'bathroom/basins/brands.html','catalog/category/view/id/230',0,5,NULL,1,NULL),(9530,'category',231,'bathroom/basins/brands/rak.html','catalog/category/view/id/231',0,5,NULL,1,NULL),(9531,'category',232,'bathroom/basins/brands/geberit.html','catalog/category/view/id/232',0,5,NULL,1,NULL),(9532,'category',233,'bathroom/basins/brands/grohe.html','catalog/category/view/id/233',0,5,NULL,1,NULL),(9533,'category',234,'bathroom/basins/brands/hudson-reed.html','catalog/category/view/id/234',0,5,NULL,1,NULL),(9534,'category',235,'bathroom/basins/brands/roca.html','catalog/category/view/id/235',0,5,NULL,1,NULL),(9535,'category',236,'bathroom/basins/brands/vitra.html','catalog/category/view/id/236',0,5,NULL,1,NULL),(9536,'category',237,'bathroom/basins/brands/nuie.html','catalog/category/view/id/237',0,5,NULL,1,NULL),(9537,'category',37,'bathroom/baths.html','catalog/category/view/id/37',0,5,NULL,1,NULL),(9538,'category',182,'bathroom/baths/bathroom-accessories.html','catalog/category/view/id/182',0,5,NULL,1,NULL),(9539,'category',183,'bathroom/baths/bathroom-accessories/towel-rings.html','catalog/category/view/id/183',0,5,NULL,1,NULL),(9540,'category',184,'bathroom/baths/bathroom-accessories/bathroom-fans.html','catalog/category/view/id/184',0,5,NULL,1,NULL),(9541,'category',185,'bathroom/baths/bathroom-accessories/robe-hooks.html','catalog/category/view/id/185',0,5,NULL,1,NULL),(9542,'category',186,'bathroom/baths/bathroom-accessories/wire-baskets.html','catalog/category/view/id/186',0,5,NULL,1,NULL),(9543,'category',188,'bathroom/baths/bathroom-accessories/shelves.html','catalog/category/view/id/188',0,5,NULL,1,NULL),(9544,'category',189,'bathroom/baths/bathroom-accessories/urinal-accessories.html','catalog/category/view/id/189',0,5,NULL,1,NULL),(9545,'category',258,'bathroom/baths/bathroom-accessories/bath-panels.html','catalog/category/view/id/258',0,5,NULL,1,NULL),(9546,'category',259,'bathroom/baths/bathroom-accessories/bath-legsets.html','catalog/category/view/id/259',0,5,NULL,1,NULL),(9547,'category',260,'bathroom/baths/bathroom-accessories/bath-grips.html','catalog/category/view/id/260',0,5,NULL,1,NULL),(9548,'category',261,'bathroom/baths/bathroom-accessories/miscellaneous.html','catalog/category/view/id/261',0,5,NULL,1,NULL),(9549,'category',44,'bathroom/baths/bathroom-accessories/bath-screens.html','catalog/category/view/id/44',0,5,NULL,1,NULL),(9550,'category',45,'bathroom/baths/bathroom-accessories/bath-wastes-and-drainer.html','catalog/category/view/id/45',0,5,NULL,1,NULL),(9551,'category',253,'bathroom/baths/baths.html','catalog/category/view/id/253',0,5,NULL,1,NULL),(9552,'category',254,'bathroom/baths/baths/single-ended-baths.html','catalog/category/view/id/254',0,5,NULL,1,NULL),(9553,'category',255,'bathroom/baths/baths/double-ended-baths.html','catalog/category/view/id/255',0,5,NULL,1,NULL),(9554,'category',256,'bathroom/baths/baths/rectangular-baths.html','catalog/category/view/id/256',0,5,NULL,1,NULL),(9555,'category',257,'bathroom/baths/baths/space-saving-baths.html','catalog/category/view/id/257',0,5,NULL,1,NULL),(9556,'category',38,'bathroom/baths/baths/straight-baths.html','catalog/category/view/id/38',0,5,NULL,1,NULL),(9557,'category',39,'bathroom/baths/baths/free-standing-baths.html','catalog/category/view/id/39',0,5,NULL,1,NULL),(9558,'category',40,'bathroom/baths/baths/corner-baths.html','catalog/category/view/id/40',0,5,NULL,1,NULL),(9559,'category',41,'bathroom/baths/baths/oval-baths.html','catalog/category/view/id/41',0,5,NULL,1,NULL),(9560,'category',42,'bathroom/baths/baths/shower-baths.html','catalog/category/view/id/42',0,5,NULL,1,NULL),(9561,'category',43,'bathroom/baths/baths/traditional-baths.html','catalog/category/view/id/43',0,5,NULL,1,NULL),(9562,'category',262,'bathroom/baths/bette.html','catalog/category/view/id/262',0,5,NULL,1,NULL),(9563,'category',263,'bathroom/baths/bette/bette.html','catalog/category/view/id/263',0,5,NULL,1,NULL),(9564,'category',264,'bathroom/baths/bette/geberit.html','catalog/category/view/id/264',0,5,NULL,1,NULL),(9565,'category',265,'bathroom/baths/bette/grohe.html','catalog/category/view/id/265',0,5,NULL,1,NULL),(9566,'category',266,'bathroom/baths/bette/hasngrohe.html','catalog/category/view/id/266',0,5,NULL,1,NULL),(9567,'category',267,'bathroom/baths/bette/hudson-reed.html','catalog/category/view/id/267',0,5,NULL,1,NULL),(9568,'category',268,'bathroom/baths/bette/ideal-standard.html','catalog/category/view/id/268',0,5,NULL,1,NULL),(9569,'category',269,'bathroom/baths/bette/matki-showers.html','catalog/category/view/id/269',0,5,NULL,1,NULL),(9570,'category',270,'bathroom/baths/bette/rak-ceramics.html','catalog/category/view/id/270',0,5,NULL,1,NULL),(9571,'category',271,'bathroom/baths/bette/roca.html','catalog/category/view/id/271',0,5,NULL,1,NULL),(9572,'category',272,'bathroom/baths/bette/royce-morgan.html','catalog/category/view/id/272',0,5,NULL,1,NULL),(9573,'category',273,'bathroom/baths/bette/vitra.html','catalog/category/view/id/273',0,5,NULL,1,NULL),(9574,'category',274,'bathroom/baths/bette/nuie.html','catalog/category/view/id/274',0,5,NULL,1,NULL),(9575,'category',275,'bathroom/baths/bette/kaldewei.html','catalog/category/view/id/275',0,5,NULL,1,NULL),(9576,'category',4,'bathroom/showering.html','catalog/category/view/id/4',0,5,NULL,1,NULL),(9577,'category',247,'bathroom/showering/brands.html','catalog/category/view/id/247',0,5,NULL,1,NULL),(9578,'category',248,'bathroom/showering/brands/matki.html','catalog/category/view/id/248',0,5,NULL,1,NULL),(9579,'category',249,'bathroom/showering/brands/nuei.html','catalog/category/view/id/249',0,5,NULL,1,NULL),(9580,'category',250,'bathroom/showering/brands/ideal-stnadard.html','catalog/category/view/id/250',0,5,NULL,1,NULL),(9581,'category',251,'bathroom/showering/brands/hudson-reed.html','catalog/category/view/id/251',0,5,NULL,1,NULL),(9582,'category',252,'bathroom/showering/brands/rak.html','catalog/category/view/id/252',0,5,NULL,1,NULL),(9583,'category',66,'bathroom/showering/shower-doors.html','catalog/category/view/id/66',0,5,NULL,1,NULL),(9584,'category',67,'bathroom/showering/shower-doors/pivot-doors.html','catalog/category/view/id/67',0,5,NULL,1,NULL),(9585,'category',68,'bathroom/showering/shower-doors/hinged-doors.html','catalog/category/view/id/68',0,5,NULL,1,NULL),(9586,'category',69,'bathroom/showering/shower-doors/sliding-doors.html','catalog/category/view/id/69',0,5,NULL,1,NULL),(9587,'category',70,'bathroom/showering/shower-doors/bi-fold-doors.html','catalog/category/view/id/70',0,5,NULL,1,NULL),(9588,'category',71,'bathroom/showering/shower-enclosures.html','catalog/category/view/id/71',0,5,NULL,1,NULL),(9589,'category',245,'bathroom/showering/shower-enclosures/curved-enclosures.html','catalog/category/view/id/245',0,5,NULL,1,NULL),(9590,'category',246,'bathroom/showering/shower-enclosures/3-sided-enclosures.html','catalog/category/view/id/246',0,5,NULL,1,NULL),(9591,'category',72,'bathroom/showering/shower-enclosures/pivot-enclosures.html','catalog/category/view/id/72',0,5,NULL,1,NULL),(9592,'category',73,'bathroom/showering/shower-enclosures/hinged-enclosures.html','catalog/category/view/id/73',0,5,NULL,1,NULL),(9593,'category',74,'bathroom/showering/shower-enclosures/sliding-enclosures.html','catalog/category/view/id/74',0,5,NULL,1,NULL),(9594,'category',75,'bathroom/showering/shower-enclosures/bi-fold-enclosures.html','catalog/category/view/id/75',0,5,NULL,1,NULL),(9595,'category',76,'bathroom/showering/shower-enclosures/d-shaped-enclosures.html','catalog/category/view/id/76',0,5,NULL,1,NULL),(9596,'category',77,'bathroom/showering/shower-enclosures/walk-in-showers.html','catalog/category/view/id/77',0,5,NULL,1,NULL),(9597,'category',78,'bathroom/showering/shower-enclosures/quadrant.html','catalog/category/view/id/78',0,5,NULL,1,NULL),(9598,'category',79,'bathroom/showering/shower-enclosures/pentagons.html','catalog/category/view/id/79',0,5,NULL,1,NULL),(9599,'category',80,'bathroom/showering/shower-enclosures/wet-rooms.html','catalog/category/view/id/80',0,5,NULL,1,NULL),(9600,'category',81,'bathroom/showering/shower-enclosures/corner-entry-enclosures.html','catalog/category/view/id/81',0,5,NULL,1,NULL),(9601,'category',82,'bathroom/showering/shower-trays.html','catalog/category/view/id/82',0,5,NULL,1,NULL),(9602,'category',83,'bathroom/showering/shower-trays/square-trays.html','catalog/category/view/id/83',0,5,NULL,1,NULL),(9603,'category',84,'bathroom/showering/shower-trays/rectangular-trays.html','catalog/category/view/id/84',0,5,NULL,1,NULL),(9604,'category',85,'bathroom/showering/shower-trays/quadrant-trays.html','catalog/category/view/id/85',0,5,NULL,1,NULL),(9605,'category',86,'bathroom/showering/shower-trays/pentagon-trays.html','catalog/category/view/id/86',0,5,NULL,1,NULL),(9606,'category',46,'bathroom/bathroom-furniture.html','catalog/category/view/id/46',0,5,NULL,1,NULL),(9607,'category',295,'bathroom/bathroom-furniture/bathroom-furniture.html','catalog/category/view/id/295',0,5,NULL,1,NULL),(9608,'category',296,'bathroom/bathroom-furniture/bathroom-furniture/corner-vanity-units.html','catalog/category/view/id/296',0,5,NULL,1,NULL),(9609,'category',297,'bathroom/bathroom-furniture/bathroom-furniture/double-sink-vanity-units.html','catalog/category/view/id/297',0,5,NULL,1,NULL),(9610,'category',298,'bathroom/bathroom-furniture/bathroom-furniture/countertop-vanity-units.html','catalog/category/view/id/298',0,5,NULL,1,NULL),(9611,'category',299,'bathroom/bathroom-furniture/bathroom-furniture/toilet-and-sink-units.html','catalog/category/view/id/299',0,5,NULL,1,NULL),(9612,'category',300,'bathroom/bathroom-furniture/bathroom-furniture/tall-bathroom-cabinets.html','catalog/category/view/id/300',0,5,NULL,1,NULL),(9613,'category',47,'bathroom/bathroom-furniture/bathroom-furniture/floor-standing-units.html','catalog/category/view/id/47',0,5,NULL,1,NULL),(9614,'category',48,'bathroom/bathroom-furniture/bathroom-furniture/wall-hung-units.html','catalog/category/view/id/48',0,5,NULL,1,NULL),(9615,'category',49,'bathroom/bathroom-furniture/bathroom-furniture/cloakroom-units.html','catalog/category/view/id/49',0,5,NULL,1,NULL),(9616,'category',50,'bathroom/bathroom-furniture/bathroom-furniture/wc-units.html','catalog/category/view/id/50',0,5,NULL,1,NULL),(9617,'category',301,'bathroom/bathroom-furniture/brands.html','catalog/category/view/id/301',0,5,NULL,1,NULL),(9618,'category',302,'bathroom/bathroom-furniture/brands/hudson-reed.html','catalog/category/view/id/302',0,5,NULL,1,NULL),(9619,'category',303,'bathroom/bathroom-furniture/brands/rak-ceramics.html','catalog/category/view/id/303',0,5,NULL,1,NULL),(9620,'category',304,'bathroom/bathroom-furniture/brands/roca.html','catalog/category/view/id/304',0,5,NULL,1,NULL),(9621,'category',305,'bathroom/bathroom-furniture/brands/vitra.html','catalog/category/view/id/305',0,5,NULL,1,NULL),(9622,'category',306,'bathroom/bathroom-furniture/brands/nuie.html','catalog/category/view/id/306',0,5,NULL,1,NULL),(9623,'category',51,'bathroom/bathroom-suites.html','catalog/category/view/id/51',0,5,NULL,1,NULL),(9624,'category',52,'bathroom/bathroom-suites/cloakroom-suites.html','catalog/category/view/id/52',0,5,NULL,1,NULL),(9625,'category',53,'bathroom/bathroom-suites/contemporary-suites.html','catalog/category/view/id/53',0,5,NULL,1,NULL),(9626,'category',54,'bathroom/mirrors-cabinets.html','catalog/category/view/id/54',0,5,NULL,1,NULL),(9627,'category',289,'bathroom/mirrors-cabinets/brands.html','catalog/category/view/id/289',0,5,NULL,1,NULL),(9628,'category',290,'bathroom/mirrors-cabinets/brands/hib.html','catalog/category/view/id/290',0,5,NULL,1,NULL),(9629,'category',291,'bathroom/mirrors-cabinets/brands/hudson-reed.html','catalog/category/view/id/291',0,5,NULL,1,NULL),(9630,'category',292,'bathroom/mirrors-cabinets/brands/rak-ceramics.html','catalog/category/view/id/292',0,5,NULL,1,NULL),(9631,'category',293,'bathroom/mirrors-cabinets/brands/roca.html','catalog/category/view/id/293',0,5,NULL,1,NULL),(9632,'category',294,'bathroom/mirrors-cabinets/brands/nuie.html','catalog/category/view/id/294',0,5,NULL,1,NULL),(9633,'category',55,'bathroom/mirrors-cabinets/mirrors.html','catalog/category/view/id/55',0,5,NULL,1,NULL),(9634,'category',283,'bathroom/mirrors-cabinets/mirrors/standard-mirrors.html','catalog/category/view/id/283',0,5,NULL,1,NULL),(9635,'category',284,'bathroom/mirrors-cabinets/mirrors/led-mirrors.html','catalog/category/view/id/284',0,5,NULL,1,NULL),(9636,'category',285,'bathroom/mirrors-cabinets/mirrors/backlit-mirrors.html','catalog/category/view/id/285',0,5,NULL,1,NULL),(9637,'category',286,'bathroom/mirrors-cabinets/mirrors/demister-mirrors.html','catalog/category/view/id/286',0,5,NULL,1,NULL),(9638,'category',287,'bathroom/mirrors-cabinets/mirrors/magnifying-mirrors.html','catalog/category/view/id/287',0,5,NULL,1,NULL),(9639,'category',288,'bathroom/mirrors-cabinets/mirrors/smart-mirrors.html','catalog/category/view/id/288',0,5,NULL,1,NULL),(9640,'category',56,'bathroom/mirrors-cabinets/mirror-cabinets.html','catalog/category/view/id/56',0,5,NULL,1,NULL),(9641,'category',57,'bathroom/frames-plates.html','catalog/category/view/id/57',0,5,NULL,1,NULL),(9642,'category',58,'bathroom/frames-plates/bidet-frames.html','catalog/category/view/id/58',0,5,NULL,1,NULL),(9643,'category',59,'bathroom/frames-plates/toilet-frames.html','catalog/category/view/id/59',0,5,NULL,1,NULL),(9644,'category',61,'bathroom/frames-plates/plates.html','catalog/category/view/id/61',0,5,NULL,1,NULL),(9645,'category',62,'bathroom/pvc-panels.html','catalog/category/view/id/62',0,5,NULL,1,NULL),(9646,'category',63,'bathroom/pvc-panels/ceiling-panels.html','catalog/category/view/id/63',0,5,NULL,1,NULL),(9647,'category',64,'bathroom/pvc-panels/wall-splash-panels.html','catalog/category/view/id/64',0,5,NULL,1,NULL),(9648,'category',65,'bathroom/pvc-panels/pvc-trims.html','catalog/category/view/id/65',0,5,NULL,1,NULL),(9649,'category',8,'bathroom/taps.html','catalog/category/view/id/8',0,5,NULL,1,NULL),(9650,'category',150,'bathroom/taps/bathroom-taps.html','catalog/category/view/id/150',0,5,NULL,1,NULL),(9651,'category',152,'bathroom/taps/bath-taps.html','catalog/category/view/id/152',0,5,NULL,1,NULL),(9652,'category',153,'bathroom/taps/bath-taps/single-bath-taps.html','catalog/category/view/id/153',0,5,NULL,1,NULL),(9653,'category',154,'bathroom/taps/bath-taps/mixer-taps.html','catalog/category/view/id/154',0,5,NULL,1,NULL),(9654,'category',155,'bathroom/taps/bath-taps/wall-hung-taps.html','catalog/category/view/id/155',0,5,NULL,1,NULL),(9655,'category',156,'bathroom/taps/bath-taps/free-standing-taps.html','catalog/category/view/id/156',0,5,NULL,1,NULL),(9656,'category',157,'bathroom/taps/bath-taps/bath-spouts.html','catalog/category/view/id/157',0,5,NULL,1,NULL),(9657,'category',158,'bathroom/taps/bath-taps/bath-filler.html','catalog/category/view/id/158',0,5,NULL,1,NULL),(9658,'category',279,'bathroom/taps/bath-taps/bath-tap-pairs.html','catalog/category/view/id/279',0,5,NULL,1,NULL),(9659,'category',280,'bathroom/taps/bath-taps/deck-mounted-taps.html','catalog/category/view/id/280',0,5,NULL,1,NULL),(9660,'category',282,'bathroom/taps/bath-taps/bath-basin-tap-sets.html','catalog/category/view/id/282',0,5,NULL,1,NULL),(9661,'category',159,'bathroom/taps/basin-taps.html','catalog/category/view/id/159',0,5,NULL,1,NULL),(9662,'category',151,'bathroom/taps/basin-taps/bidet-mixers.html','catalog/category/view/id/151',0,5,NULL,1,NULL),(9663,'category',160,'bathroom/taps/basin-taps/basin-mixer-taps.html','catalog/category/view/id/160',0,5,NULL,1,NULL),(9664,'category',161,'bathroom/taps/basin-taps/wall-hung-tap.html','catalog/category/view/id/161',0,5,NULL,1,NULL),(9665,'category',162,'bathroom/taps/basin-taps/sensor-tap.html','catalog/category/view/id/162',0,5,NULL,1,NULL),(9666,'category',276,'bathroom/taps/basin-taps/high-rise-basin-taps.html','catalog/category/view/id/276',0,5,NULL,1,NULL),(9667,'category',277,'bathroom/taps/basin-taps/basin-tap-pairs.html','catalog/category/view/id/277',0,5,NULL,1,NULL),(9668,'category',278,'bathroom/taps/basin-taps/bath-basin-tap-sets.html','catalog/category/view/id/278',0,5,NULL,1,NULL),(9669,'category',9,'bathroom/shower-valves.html','catalog/category/view/id/9',0,5,NULL,1,NULL),(9670,'category',165,'bathroom/shower-valves/all-showers.html','catalog/category/view/id/165',0,5,NULL,1,NULL),(9671,'category',166,'bathroom/shower-valves/all-showers/full-showers.html','catalog/category/view/id/166',0,5,NULL,1,NULL),(9672,'category',167,'bathroom/shower-valves/all-showers/shower-panels.html','catalog/category/view/id/167',0,5,NULL,1,NULL),(9673,'category',168,'bathroom/shower-valves/all-showers/electric-showers.html','catalog/category/view/id/168',0,5,NULL,1,NULL),(9674,'category',176,'bathroom/shower-valves/all-showers/slider-kits.html','catalog/category/view/id/176',0,5,NULL,1,NULL),(9675,'category',238,'bathroom/shower-valves/all-showers/shower-head-with-arm.html','catalog/category/view/id/238',0,5,NULL,1,NULL),(9676,'category',169,'bathroom/shower-valves/accessories.html','catalog/category/view/id/169',0,5,NULL,1,NULL),(9677,'category',175,'bathroom/shower-valves/accessories/hand-showers.html','catalog/category/view/id/175',0,5,NULL,1,NULL),(9678,'category',177,'bathroom/shower-valves/accessories/shower-heads.html','catalog/category/view/id/177',0,5,NULL,1,NULL),(9679,'category',178,'bathroom/shower-valves/accessories/shower-arms.html','catalog/category/view/id/178',0,5,NULL,1,NULL),(9680,'category',179,'bathroom/shower-valves/accessories/body-jets.html','catalog/category/view/id/179',0,5,NULL,1,NULL),(9681,'category',180,'bathroom/shower-valves/accessories/shower-hose.html','catalog/category/view/id/180',0,5,NULL,1,NULL),(9682,'category',181,'bathroom/shower-valves/accessories/accessories.html','catalog/category/view/id/181',0,5,NULL,1,NULL),(9683,'category',170,'bathroom/shower-valves/valves.html','catalog/category/view/id/170',0,5,NULL,1,NULL),(9684,'category',171,'bathroom/shower-valves/valves/exposed-valves.html','catalog/category/view/id/171',0,5,NULL,1,NULL),(9685,'category',172,'bathroom/shower-valves/valves/concealed-valves.html','catalog/category/view/id/172',0,5,NULL,1,NULL),(9686,'category',173,'bathroom/shower-valves/valves/thermostatic-valves.html','catalog/category/view/id/173',0,5,NULL,1,NULL),(9687,'category',174,'bathroom/shower-valves/valves/traditional-valves.html','catalog/category/view/id/174',0,5,NULL,1,NULL),(9688,'category',239,'bathroom/shower-valves/valves/bar-valves.html','catalog/category/view/id/239',0,5,NULL,1,NULL),(9689,'category',240,'bathroom/shower-valves/brands.html','catalog/category/view/id/240',0,5,NULL,1,NULL),(9690,'category',241,'bathroom/shower-valves/brands/hansgrohe.html','catalog/category/view/id/241',0,5,NULL,1,NULL),(9691,'category',242,'bathroom/shower-valves/brands/grohe.html','catalog/category/view/id/242',0,5,NULL,1,NULL),(9692,'category',243,'bathroom/shower-valves/brands/nuei.html','catalog/category/view/id/243',0,5,NULL,1,NULL),(9693,'category',244,'bathroom/shower-valves/brands/hudson-reed.html','catalog/category/view/id/244',0,5,NULL,1,NULL),(9694,'category',5,'kitchen-appliances.html','catalog/category/view/id/5',0,5,NULL,1,NULL),(9695,'category',145,'kitchen-appliances/kitchen-taps.html','catalog/category/view/id/145',0,5,NULL,1,NULL),(9696,'category',146,'kitchen-appliances/kitchen-taps/kitchen-sink-taps.html','catalog/category/view/id/146',0,5,NULL,1,NULL),(9697,'category',149,'kitchen-appliances/kitchen-taps/sensor-taps.html','catalog/category/view/id/149',0,5,NULL,1,NULL),(9698,'category',329,'kitchen-appliances/kitchen-taps/kitchen-tap-type.html','catalog/category/view/id/329',0,5,NULL,1,NULL),(9699,'category',147,'kitchen-appliances/kitchen-taps/kitchen-tap-type/instant-hot-water-taps.html','catalog/category/view/id/147',0,5,NULL,1,NULL),(9700,'category',148,'kitchen-appliances/kitchen-taps/kitchen-tap-type/filter-flow-taps.html','catalog/category/view/id/148',0,5,NULL,1,NULL),(9701,'category',330,'kitchen-appliances/kitchen-taps/kitchen-tap-type/kitchen-mixer-taps.html','catalog/category/view/id/330',0,5,NULL,1,NULL),(9702,'category',331,'kitchen-appliances/kitchen-taps/kitchen-tap-type/pull-out-kitchen-taps.html','catalog/category/view/id/331',0,5,NULL,1,NULL),(9703,'category',332,'kitchen-appliances/kitchen-taps/kitchen-tap-type/coloured-kitchen-taps.html','catalog/category/view/id/332',0,5,NULL,1,NULL),(9704,'category',335,'kitchen-appliances/kitchen-taps/kitchen-tap-type/sparkling-water-taps.html','catalog/category/view/id/335',0,5,NULL,1,NULL),(9705,'category',336,'kitchen-appliances/kitchen-taps/kitchen-tap-type/smart-taps.html','catalog/category/view/id/336',0,5,NULL,1,NULL),(9706,'category',337,'kitchen-appliances/kitchen-taps/brands.html','catalog/category/view/id/337',0,5,NULL,1,NULL),(9707,'category',338,'kitchen-appliances/kitchen-taps/brands/franke.html','catalog/category/view/id/338',0,5,NULL,1,NULL),(9708,'category',339,'kitchen-appliances/kitchen-taps/brands/blanco.html','catalog/category/view/id/339',0,5,NULL,1,NULL),(9709,'category',340,'kitchen-appliances/kitchen-taps/brands/reginox.html','catalog/category/view/id/340',0,5,NULL,1,NULL),(9710,'category',341,'kitchen-appliances/kitchen-taps/brands/grohe.html','catalog/category/view/id/341',0,5,NULL,1,NULL),(9711,'category',342,'kitchen-appliances/kitchen-taps/brands/hansgrohe.html','catalog/category/view/id/342',0,5,NULL,1,NULL),(9712,'category',344,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories.html','catalog/category/view/id/344',0,5,NULL,1,NULL),(9713,'category',345,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/soap-dispensors.html','catalog/category/view/id/345',0,5,NULL,1,NULL),(9714,'category',346,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/filters.html','catalog/category/view/id/346',0,5,NULL,1,NULL),(9715,'category',347,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/hot-water-tanks.html','catalog/category/view/id/347',0,5,NULL,1,NULL),(9716,'category',318,'kitchen-appliances/kitchen-sinks.html','catalog/category/view/id/318',0,5,NULL,1,NULL),(9717,'category',106,'kitchen-appliances/kitchen-sinks/sink-type.html','catalog/category/view/id/106',0,5,NULL,1,NULL),(9718,'category',107,'kitchen-appliances/kitchen-sinks/sink-type/full-sinks.html','catalog/category/view/id/107',0,5,NULL,1,NULL),(9719,'category',109,'kitchen-appliances/kitchen-sinks/sink-type/sink-tap-packages.html','catalog/category/view/id/109',0,5,NULL,1,NULL),(9720,'category',307,'kitchen-appliances/kitchen-sinks/sink-type/undermount.html','catalog/category/view/id/307',0,5,NULL,1,NULL),(9721,'category',308,'kitchen-appliances/kitchen-sinks/sink-type/inset-flushmount.html','catalog/category/view/id/308',0,5,NULL,1,NULL),(9722,'category',309,'kitchen-appliances/kitchen-sinks/sink-type/1-0-bowl-sinks.html','catalog/category/view/id/309',0,5,NULL,1,NULL),(9723,'category',310,'kitchen-appliances/kitchen-sinks/sink-type/1-5-bowl-sinks.html','catalog/category/view/id/310',0,5,NULL,1,NULL),(9724,'category',311,'kitchen-appliances/kitchen-sinks/sink-type/2-0-bowl-sinks.html','catalog/category/view/id/311',0,5,NULL,1,NULL),(9725,'category',312,'kitchen-appliances/kitchen-sinks/sink-type/belfast-sinks.html','catalog/category/view/id/312',0,5,NULL,1,NULL),(9726,'category',313,'kitchen-appliances/kitchen-sinks/sink-material.html','catalog/category/view/id/313',0,5,NULL,1,NULL),(9727,'category',108,'kitchen-appliances/kitchen-sinks/sink-material/stainless-steel-sinks.html','catalog/category/view/id/108',0,5,NULL,1,NULL),(9728,'category',314,'kitchen-appliances/kitchen-sinks/sink-material/ceramic-sinks.html','catalog/category/view/id/314',0,5,NULL,1,NULL),(9729,'category',315,'kitchen-appliances/kitchen-sinks/sink-material/granite-sinks.html','catalog/category/view/id/315',0,5,NULL,1,NULL),(9730,'category',316,'kitchen-appliances/kitchen-sinks/sink-material/composite-sinks.html','catalog/category/view/id/316',0,5,NULL,1,NULL),(9731,'category',317,'kitchen-appliances/kitchen-sinks/sink-material/coloured-sinks.html','catalog/category/view/id/317',0,5,NULL,1,NULL),(9732,'category',319,'kitchen-appliances/kitchen-sinks/accessories.html','catalog/category/view/id/319',0,5,NULL,1,NULL),(9733,'category',110,'kitchen-appliances/kitchen-sinks/accessories/kitchen-accessories.html','catalog/category/view/id/110',0,5,NULL,1,NULL),(9734,'category',321,'kitchen-appliances/kitchen-sinks/accessories/waster-sorter.html','catalog/category/view/id/321',0,5,NULL,1,NULL),(9735,'category',322,'kitchen-appliances/kitchen-sinks/accessories/plumbing-kits.html','catalog/category/view/id/322',0,5,NULL,1,NULL),(9736,'category',323,'kitchen-appliances/kitchen-sinks/brands.html','catalog/category/view/id/323',0,5,NULL,1,NULL),(9737,'category',324,'kitchen-appliances/kitchen-sinks/brands/franke.html','catalog/category/view/id/324',0,5,NULL,1,NULL),(9738,'category',325,'kitchen-appliances/kitchen-sinks/brands/reginox.html','catalog/category/view/id/325',0,5,NULL,1,NULL),(9739,'category',326,'kitchen-appliances/kitchen-sinks/brands/blanco.html','catalog/category/view/id/326',0,5,NULL,1,NULL),(9740,'category',327,'kitchen-appliances/kitchen-sinks/brands/grohe.html','catalog/category/view/id/327',0,5,NULL,1,NULL),(9741,'category',328,'kitchen-appliances/kitchen-sinks/brands/hansgrohe.html','catalog/category/view/id/328',0,5,NULL,1,NULL),(9742,'category',343,'kitchen-appliances/appliances.html','catalog/category/view/id/343',0,5,NULL,1,NULL),(9743,'category',100,'kitchen-appliances/appliances/fridges-freezers.html','catalog/category/view/id/100',0,5,NULL,1,NULL),(9744,'category',101,'kitchen-appliances/appliances/fridges-freezers/fridges-freezers.html','catalog/category/view/id/101',0,5,NULL,1,NULL),(9745,'category',102,'kitchen-appliances/appliances/fridges-freezers/fridges.html','catalog/category/view/id/102',0,5,NULL,1,NULL),(9746,'category',103,'kitchen-appliances/appliances/fridges-freezers/freezers.html','catalog/category/view/id/103',0,5,NULL,1,NULL),(9747,'category',104,'kitchen-appliances/appliances/fridges-freezers/wine-coolers.html','catalog/category/view/id/104',0,5,NULL,1,NULL),(9748,'category',105,'kitchen-appliances/appliances/fridges-freezers/american-style-fridge-freezers.html','catalog/category/view/id/105',0,5,NULL,1,NULL),(9749,'category',348,'kitchen-appliances/appliances/accessories.html','catalog/category/view/id/348',0,5,NULL,1,NULL),(9750,'category',349,'kitchen-appliances/appliances/accessories/accessories.html','catalog/category/view/id/349',0,5,NULL,1,NULL),(9751,'category',350,'kitchen-appliances/appliances/brands.html','catalog/category/view/id/350',0,5,NULL,1,NULL),(9752,'category',351,'kitchen-appliances/appliances/brands/bosch.html','catalog/category/view/id/351',0,5,NULL,1,NULL),(9753,'category',352,'kitchen-appliances/appliances/brands/neff.html','catalog/category/view/id/352',0,5,NULL,1,NULL),(9754,'category',353,'kitchen-appliances/appliances/brands/siemens.html','catalog/category/view/id/353',0,5,NULL,1,NULL),(9755,'category',354,'kitchen-appliances/appliances/brands/franke.html','catalog/category/view/id/354',0,5,NULL,1,NULL),(9756,'category',355,'kitchen-appliances/appliances/brands/elica.html','catalog/category/view/id/355',0,5,NULL,1,NULL),(9757,'category',87,'kitchen-appliances/appliances/cooking-baking.html','catalog/category/view/id/87',0,5,NULL,1,NULL),(9758,'category',88,'kitchen-appliances/appliances/cooking-baking/ovens.html','catalog/category/view/id/88',0,5,NULL,1,NULL),(9759,'category',89,'kitchen-appliances/appliances/cooking-baking/hobs.html','catalog/category/view/id/89',0,5,NULL,1,NULL),(9760,'category',90,'kitchen-appliances/appliances/cooking-baking/steam-appliances.html','catalog/category/view/id/90',0,5,NULL,1,NULL),(9761,'category',91,'kitchen-appliances/appliances/cooking-baking/microwaves.html','catalog/category/view/id/91',0,5,NULL,1,NULL),(9762,'category',92,'kitchen-appliances/appliances/cooking-baking/coffee-machine.html','catalog/category/view/id/92',0,5,NULL,1,NULL),(9763,'category',93,'kitchen-appliances/appliances/cooking-baking/cooker-hoods.html','catalog/category/view/id/93',0,5,NULL,1,NULL),(9764,'category',94,'kitchen-appliances/appliances/cooking-baking/warming-drawers.html','catalog/category/view/id/94',0,5,NULL,1,NULL),(9765,'category',95,'kitchen-appliances/appliances/cooking-baking/cooking-accessories.html','catalog/category/view/id/95',0,5,NULL,1,NULL),(9766,'category',96,'kitchen-appliances/appliances/washers-dryers.html','catalog/category/view/id/96',0,5,NULL,1,NULL),(9767,'category',97,'kitchen-appliances/appliances/washers-dryers/washing-machines.html','catalog/category/view/id/97',0,5,NULL,1,NULL),(9768,'category',98,'kitchen-appliances/appliances/dishwashers.html','catalog/category/view/id/98',0,5,NULL,1,NULL),(9769,'category',99,'kitchen-appliances/appliances/dishwashers/built-in-dishwashers.html','catalog/category/view/id/99',0,5,NULL,1,NULL),(9770,'category',356,'kitchen-appliances/kitchen-accessories.html','catalog/category/view/id/356',0,5,NULL,1,NULL),(9771,'category',358,'kitchen-appliances/kitchen-accessories/accessories.html','catalog/category/view/id/358',0,5,NULL,1,NULL),(9772,'category',359,'kitchen-appliances/kitchen-accessories/accessories/soap-dispensors.html','catalog/category/view/id/359',0,5,NULL,1,NULL),(9773,'category',360,'kitchen-appliances/kitchen-accessories/accessories/chopping-boards.html','catalog/category/view/id/360',0,5,NULL,1,NULL),(9774,'category',361,'kitchen-appliances/kitchen-accessories/accessories/strainers.html','catalog/category/view/id/361',0,5,NULL,1,NULL),(9775,'category',362,'kitchen-appliances/kitchen-accessories/accessories/colanders.html','catalog/category/view/id/362',0,5,NULL,1,NULL),(9776,'category',363,'kitchen-appliances/kitchen-accessories/accessories/metal-grids.html','catalog/category/view/id/363',0,5,NULL,1,NULL),(9777,'category',364,'kitchen-appliances/kitchen-accessories/accessories/cleaning-sprays.html','catalog/category/view/id/364',0,5,NULL,1,NULL),(9778,'category',365,'kitchen-appliances/kitchen-accessories/accessories/waste-and-plumbing-kits.html','catalog/category/view/id/365',0,5,NULL,1,NULL),(9779,'category',7,'heating.html','catalog/category/view/id/7',0,5,NULL,1,NULL),(9780,'category',366,'heating/radiators.html','catalog/category/view/id/366',0,5,NULL,1,NULL),(9781,'category',142,'heating/radiators/towel-rails.html','catalog/category/view/id/142',0,5,NULL,1,NULL),(9782,'category',143,'heating/radiators/towel-rails/heated-towel-rails.html','catalog/category/view/id/143',0,5,NULL,1,NULL),(9783,'category',144,'heating/radiators/towel-rails/electric-towel-rails.html','catalog/category/view/id/144',0,5,NULL,1,NULL),(9784,'category',371,'heating/radiators/towel-rails/dual-fuel-towel-rails.html','catalog/category/view/id/371',0,5,NULL,1,NULL),(9785,'category',367,'heating/radiators/radiators.html','catalog/category/view/id/367',0,5,NULL,1,NULL),(9786,'category',135,'heating/radiators/radiators/designer-radiators.html','catalog/category/view/id/135',0,5,NULL,1,NULL),(9787,'category',136,'heating/radiators/radiators/vertical-designer-radiators.html','catalog/category/view/id/136',0,5,NULL,1,NULL),(9788,'category',137,'heating/radiators/radiators/horizontal-designer-radiators.html','catalog/category/view/id/137',0,5,NULL,1,NULL),(9789,'category',138,'heating/radiators/radiators/traditional-radiators.html','catalog/category/view/id/138',0,5,NULL,1,NULL),(9790,'category',139,'heating/radiators/radiators/electric-radiators.html','catalog/category/view/id/139',0,5,NULL,1,NULL),(9791,'category',140,'heating/radiators/radiators/radiator-valves.html','catalog/category/view/id/140',0,5,NULL,1,NULL),(9792,'category',141,'heating/radiators/radiators/heating-elements.html','catalog/category/view/id/141',0,5,NULL,1,NULL),(9793,'category',368,'heating/radiators/radiators/column-radiators.html','catalog/category/view/id/368',0,5,NULL,1,NULL),(9794,'category',369,'heating/radiators/radiators/convector-radiators.html','catalog/category/view/id/369',0,5,NULL,1,NULL),(9795,'category',370,'heating/radiators/radiators/floor-standing-radiators.html','catalog/category/view/id/370',0,5,NULL,1,NULL),(9796,'category',372,'heating/radiators/brands.html','catalog/category/view/id/372',0,5,NULL,1,NULL),(9797,'category',373,'heating/radiators/brands/nuie.html','catalog/category/view/id/373',0,5,NULL,1,NULL),(9798,'category',374,'heating/radiators/brands/hudson-reed.html','catalog/category/view/id/374',0,5,NULL,1,NULL),(9799,'category',375,'heating/radiators/brands/carisa.html','catalog/category/view/id/375',0,5,NULL,1,NULL),(9800,'category',376,'heating/radiators/brands/zehnder.html','catalog/category/view/id/376',0,5,NULL,1,NULL),(9801,'category',377,'heating/radiators/brands/reina.html','catalog/category/view/id/377',0,5,NULL,1,NULL),(9802,'category',6,'heating/fires.html','catalog/category/view/id/6',0,5,NULL,1,NULL),(9803,'category',111,'heating/fires/gas-fires.html','catalog/category/view/id/111',0,5,NULL,1,NULL),(9804,'category',112,'heating/fires/gas-fires/front-view-gas-fires.html','catalog/category/view/id/112',0,5,NULL,1,NULL),(9805,'category',113,'heating/fires/gas-fires/corner-gas-fires.html','catalog/category/view/id/113',0,5,NULL,1,NULL),(9806,'category',114,'heating/fires/gas-fires/three-sided-gas-fires.html','catalog/category/view/id/114',0,5,NULL,1,NULL),(9807,'category',115,'heating/fires/gas-fires/tunnel-gas-fires.html','catalog/category/view/id/115',0,5,NULL,1,NULL),(9808,'category',116,'heating/fires/gas-fires/heaters.html','catalog/category/view/id/116',0,5,NULL,1,NULL),(9809,'category',117,'heating/fires/gas-fires/hole-in-the-wall-gas-fires.html','catalog/category/view/id/117',0,5,NULL,1,NULL),(9810,'category',118,'heating/fires/gas-fires/high-efficiency-gas-fires.html','catalog/category/view/id/118',0,5,NULL,1,NULL),(9811,'category',119,'heating/fires/gas-fires/glass-fronted-gas-fire.html','catalog/category/view/id/119',0,5,NULL,1,NULL),(9812,'category',120,'heating/fires/gas-fires/inset-gas-fires.html','catalog/category/view/id/120',0,5,NULL,1,NULL),(9813,'category',121,'heating/fires/gas-fires/wall-mounted-gas-fires.html','catalog/category/view/id/121',0,5,NULL,1,NULL),(9814,'category',122,'heating/fires/gas-fires/balanced-flue-gas-fires.html','catalog/category/view/id/122',0,5,NULL,1,NULL),(9815,'category',123,'heating/fires/gas-fires/flueless-gas-fires.html','catalog/category/view/id/123',0,5,NULL,1,NULL),(9816,'category',378,'heating/fires/gas-fires/floor-standing-fires.html','catalog/category/view/id/378',0,5,NULL,1,NULL),(9817,'category',379,'heating/fires/gas-fires/top-control-side-control-gas-fires.html','catalog/category/view/id/379',0,5,NULL,1,NULL),(9818,'category',380,'heating/fires/gas-fires/outdoor-gas-fires.html','catalog/category/view/id/380',0,5,NULL,1,NULL),(9819,'category',124,'heating/fires/stoves.html','catalog/category/view/id/124',0,5,NULL,1,NULL),(9820,'category',125,'heating/fires/stoves/wood-multifuel-stoves.html','catalog/category/view/id/125',0,5,NULL,1,NULL),(9821,'category',126,'heating/fires/stoves/electric-stoves.html','catalog/category/view/id/126',0,5,NULL,1,NULL),(9822,'category',127,'heating/fires/stoves/wood-burning-stoves.html','catalog/category/view/id/127',0,5,NULL,1,NULL),(9823,'category',128,'heating/fires/stoves/gas-stoves.html','catalog/category/view/id/128',0,5,NULL,1,NULL),(9824,'category',383,'heating/fires/stoves/flueless-gas-stoves.html','catalog/category/view/id/383',0,5,NULL,1,NULL),(9825,'category',384,'heating/fires/stoves/inset-gas-stoves.html','catalog/category/view/id/384',0,5,NULL,1,NULL),(9826,'category',129,'heating/fires/electric-fires.html','catalog/category/view/id/129',0,5,NULL,1,NULL),(9827,'category',130,'heating/fires/electric-fires/inset-electric-fires.html','catalog/category/view/id/130',0,5,NULL,1,NULL),(9828,'category',132,'heating/fires/electric-fires/wall-mounted-electric-fires.html','catalog/category/view/id/132',0,5,NULL,1,NULL),(9829,'category',133,'heating/fires/electric-fires/electric-fires-and-surrounds.html','catalog/category/view/id/133',0,5,NULL,1,NULL),(9830,'category',381,'heating/fires/electric-fires/floor-standing-electric-fires.html','catalog/category/view/id/381',0,5,NULL,1,NULL),(9831,'category',382,'heating/fires/electric-fires/hole-in-the-wall-electric-fires.html','catalog/category/view/id/382',0,5,NULL,1,NULL),(9832,'category',134,'heating/fires/fires-accessories.html','catalog/category/view/id/134',0,5,NULL,1,NULL),(9833,'category',385,'heating/fires/fireplase-suite.html','catalog/category/view/id/385',0,5,NULL,1,NULL),(9834,'category',386,'heating/fires/fireplase-suite/gas-fireplaces.html','catalog/category/view/id/386',0,5,NULL,1,NULL),(9835,'category',387,'heating/fires/fireplase-suite/electric-fireplaces.html','catalog/category/view/id/387',0,5,NULL,1,NULL),(9836,'category',445,'heating/fires/fireplase-suite/wood-burning-fireplace.html','catalog/category/view/id/445',0,5,NULL,1,NULL),(9837,'category',388,'heating/fires/media-wall-electric-fires.html','catalog/category/view/id/388',0,5,NULL,1,NULL),(9838,'category',389,'heating/fires/media-wall-electric-fires/media-wall-electric-fires.html','catalog/category/view/id/389',0,5,NULL,1,NULL),(9839,'category',390,'heating/fires/brands.html','catalog/category/view/id/390',0,5,NULL,1,NULL),(9840,'category',391,'heating/fires/brands/ag-stoves.html','catalog/category/view/id/391',0,5,NULL,1,NULL),(9841,'category',392,'heating/fires/brands/dik-guerts.html','catalog/category/view/id/392',0,5,NULL,1,NULL),(9842,'category',393,'heating/fires/brands/dimplex.html','catalog/category/view/id/393',0,5,NULL,1,NULL),(9843,'category',394,'heating/fires/brands/dru.html','catalog/category/view/id/394',0,5,NULL,1,NULL),(9844,'category',395,'heating/fires/brands/ekofires.html','catalog/category/view/id/395',0,5,NULL,1,NULL),(9845,'category',396,'heating/fires/brands/element-4.html','catalog/category/view/id/396',0,5,NULL,1,NULL),(9846,'category',397,'heating/fires/brands/esse.html','catalog/category/view/id/397',0,5,NULL,1,NULL),(9847,'category',398,'heating/fires/brands/evonice-fires.html','catalog/category/view/id/398',0,5,NULL,1,NULL),(9848,'category',399,'heating/fires/brands/carron-fires.html','catalog/category/view/id/399',0,5,NULL,1,NULL),(9849,'category',400,'heating/fires/brands/flamerite-fires.html','catalog/category/view/id/400',0,5,NULL,1,NULL),(9850,'category',401,'heating/fires/brands/flavel.html','catalog/category/view/id/401',0,5,NULL,1,NULL),(9851,'category',402,'heating/fires/brands/valor.html','catalog/category/view/id/402',0,5,NULL,1,NULL),(9852,'category',403,'heating/fires/brands/gazco.html','catalog/category/view/id/403',0,5,NULL,1,NULL),(9853,'category',12,'brands.html','catalog/category/view/id/12',0,5,NULL,1,NULL),(9854,'category',404,'brands/a-d.html','catalog/category/view/id/404',0,5,NULL,1,NULL),(9855,'category',405,'brands/a-d/aga-stoves.html','catalog/category/view/id/405',0,5,NULL,1,NULL),(9856,'category',406,'brands/a-d/bette.html','catalog/category/view/id/406',0,5,NULL,1,NULL),(9857,'category',407,'brands/a-d/blanco.html','catalog/category/view/id/407',0,5,NULL,1,NULL),(9858,'category',408,'brands/a-d/carisa.html','catalog/category/view/id/408',0,5,NULL,1,NULL),(9859,'category',409,'brands/a-d/dik-guerts.html','catalog/category/view/id/409',0,5,NULL,1,NULL),(9860,'category',410,'brands/a-d/dimplex.html','catalog/category/view/id/410',0,5,NULL,1,NULL),(9861,'category',411,'brands/a-d/dru.html','catalog/category/view/id/411',0,5,NULL,1,NULL),(9862,'category',444,'brands/a-d/aeon.html','catalog/category/view/id/444',0,5,NULL,1,NULL),(9863,'category',412,'brands/e-i.html','catalog/category/view/id/412',0,5,NULL,1,NULL),(9864,'category',413,'brands/e-i/ekofires.html','catalog/category/view/id/413',0,5,NULL,1,NULL),(9865,'category',414,'brands/e-i/element-4.html','catalog/category/view/id/414',0,5,NULL,1,NULL),(9866,'category',415,'brands/e-i/elica.html','catalog/category/view/id/415',0,5,NULL,1,NULL),(9867,'category',416,'brands/e-i/esse.html','catalog/category/view/id/416',0,5,NULL,1,NULL),(9868,'category',417,'brands/e-i/evonic-fires.html','catalog/category/view/id/417',0,5,NULL,1,NULL),(9869,'category',418,'brands/e-i/flamerite-fires.html','catalog/category/view/id/418',0,5,NULL,1,NULL),(9870,'category',419,'brands/e-i/flavel.html','catalog/category/view/id/419',0,5,NULL,1,NULL),(9871,'category',420,'brands/e-i/franke.html','catalog/category/view/id/420',0,5,NULL,1,NULL),(9872,'category',421,'brands/e-i/gazco.html','catalog/category/view/id/421',0,5,NULL,1,NULL),(9873,'category',422,'brands/e-i/geberit.html','catalog/category/view/id/422',0,5,NULL,1,NULL),(9874,'category',423,'brands/e-i/grohe.html','catalog/category/view/id/423',0,5,NULL,1,NULL),(9875,'category',424,'brands/e-i/hansgrohe.html','catalog/category/view/id/424',0,5,NULL,1,NULL),(9876,'category',425,'brands/e-i/hib.html','catalog/category/view/id/425',0,5,NULL,1,NULL),(9877,'category',426,'brands/e-i/hudson-reed.html','catalog/category/view/id/426',0,5,NULL,1,NULL),(9878,'category',427,'brands/e-i/ideal-standard.html','catalog/category/view/id/427',0,5,NULL,1,NULL),(9879,'category',428,'brands/j-r.html','catalog/category/view/id/428',0,5,NULL,1,NULL),(9880,'category',429,'brands/j-r/kaldewei.html','catalog/category/view/id/429',0,5,NULL,1,NULL),(9881,'category',430,'brands/j-r/matki.html','catalog/category/view/id/430',0,5,NULL,1,NULL),(9882,'category',431,'brands/j-r/neff.html','catalog/category/view/id/431',0,5,NULL,1,NULL),(9883,'category',432,'brands/j-r/nuie.html','catalog/category/view/id/432',0,5,NULL,1,NULL),(9884,'category',433,'brands/j-r/rak-ceramics.html','catalog/category/view/id/433',0,5,NULL,1,NULL),(9885,'category',434,'brands/j-r/reginox.html','catalog/category/view/id/434',0,5,NULL,1,NULL),(9886,'category',435,'brands/j-r/reina.html','catalog/category/view/id/435',0,5,NULL,1,NULL),(9887,'category',436,'brands/j-r/roca.html','catalog/category/view/id/436',0,5,NULL,1,NULL),(9888,'category',437,'brands/j-r/royce-morgan.html','catalog/category/view/id/437',0,5,NULL,1,NULL),(9889,'category',438,'brands/s-z.html','catalog/category/view/id/438',0,5,NULL,1,NULL),(9890,'category',439,'brands/s-z/siemens.html','catalog/category/view/id/439',0,5,NULL,1,NULL),(9891,'category',440,'brands/s-z/spartherm.html','catalog/category/view/id/440',0,5,NULL,1,NULL),(9892,'category',441,'brands/s-z/valor.html','catalog/category/view/id/441',0,5,NULL,1,NULL),(9893,'category',442,'brands/s-z/vitra.html','catalog/category/view/id/442',0,5,NULL,1,NULL),(9894,'category',443,'brands/s-z/zehnder.html','catalog/category/view/id/443',0,5,NULL,1,NULL),(9895,'category',449,'deals.html','catalog/category/view/id/449',0,5,NULL,1,NULL),(9896,'product',5760,'test-product.html','catalog/product/view/id/5760',0,5,NULL,1,NULL),(10171,'cms-page',1,'no-route','cms/page/view/page_id/1',0,5,NULL,1,NULL),(10172,'cms-page',2,'home','cms/page/view/page_id/2',0,5,NULL,1,NULL),(10173,'cms-page',3,'enable-cookies','cms/page/view/page_id/3',0,5,NULL,1,NULL),(10174,'cms-page',4,'privacy-policy','cms/page/view/page_id/4',0,5,NULL,1,NULL),(10175,'cms-page',5,'terms-and-conditions','cms/page/view/page_id/5',0,5,NULL,1,NULL),(10176,'cms-page',6,'careers','cms/page/view/page_id/6',0,5,NULL,1,NULL),(10177,'cms-page',7,'returns','cms/page/view/page_id/7',0,5,NULL,1,NULL),(10178,'cms-page',8,'how-to-order','cms/page/view/page_id/8',0,5,NULL,1,NULL),(10179,'cms-page',9,'14-day-money-back-guarantee','cms/page/view/page_id/9',0,5,NULL,1,NULL),(10180,'cms-page',10,'visit-our-showroom','cms/page/view/page_id/10',0,5,NULL,1,NULL),(10181,'cms-page',11,'about-us','cms/page/view/page_id/11',0,5,NULL,1,NULL),(10182,'cms-page',12,'faq','cms/page/view/page_id/12',0,5,NULL,1,NULL),(10183,'cms-page',13,'finance','cms/page/view/page_id/13',0,5,NULL,1,NULL),(10184,'cms-page',14,'support','cms/page/view/page_id/14',0,5,NULL,1,NULL),(10185,'cms-page',15,'cart-more-info','cms/page/view/page_id/15',0,5,NULL,1,NULL),(10186,'cms-page',29,'contact-us-nexus','cms/page/view/page_id/29',0,5,NULL,1,NULL),(10187,'product',6035,'franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035',0,5,NULL,1,NULL),(10188,'product',6036,'franke-mythos-myx-110-45-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6036',0,5,NULL,1,NULL),(10189,'product',6037,'franke-mythos-myx-110-55-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6037',0,5,NULL,1,NULL),(10190,'product',6038,'franke-mythos-myx-110-70-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6038',0,5,NULL,1,NULL),(10191,'product',6039,'franke-mythos-myx-120-34-34-undermount-double-bowl-sink-stainless-steel.html','catalog/product/view/id/6039',0,5,NULL,1,NULL),(10192,'product',6040,'franke-arcana-ahk-651-ceramic-inset-1-5-bowl-sink.html','catalog/product/view/id/6040',0,5,NULL,1,NULL),(10193,'product',6041,'blanco-supra-160-u-undermount-stainless-steel-sink-450748.html','catalog/product/view/id/6041',0,5,NULL,1,NULL),(10194,'product',6042,'blanco-supra-340-u-undermount-stainless-steel-sink-450762.html','catalog/product/view/id/6042',0,5,NULL,1,NULL),(10195,'product',6043,'blanco-livit-45-s-salto-stainless-steel-inset-sink.html','catalog/product/view/id/6043',0,5,NULL,1,NULL),(10196,'product',6044,'blanco-livit-xl-5-s-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6044',0,5,NULL,1,NULL),(10197,'product',6045,'blanco-supra-400-u-undermount-kitchen-sink-452613.html','catalog/product/view/id/6045',0,5,NULL,1,NULL),(10198,'product',6046,'blanco-supra-450-u-undermount-kitchen-sink-452614.html','catalog/product/view/id/6046',0,5,NULL,1,NULL),(10199,'product',6047,'blanco-supra-500-u-undermount-kitchen-sink-452615.html','catalog/product/view/id/6047',0,5,NULL,1,NULL),(10200,'product',6048,'blanco-livit-xl-6-s-inset-kitchen-sink-livit-xl-6-s.html','catalog/product/view/id/6048',0,5,NULL,1,NULL),(10201,'product',6049,'blanco-essential-530-u-stainless-steel-undermount-sink.html','catalog/product/view/id/6049',0,5,NULL,1,NULL),(10202,'product',6050,'blanco-lemis-6-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6050',0,5,NULL,1,NULL),(10203,'product',6051,'blanco-lemis-xl-6-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6051',0,5,NULL,1,NULL),(10204,'product',6052,'blanco-lemis-45-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6052',0,5,NULL,1,NULL),(10205,'product',6053,'blanco-livit-ii-6-s-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6053',0,5,NULL,1,NULL),(10206,'product',6054,'blanco-rondosol-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6054',0,5,NULL,1,NULL),(10207,'product',6055,'blanco-panor-60-9-puraplus-inset-ceramic-kitchen-sink-crystal-white.html','catalog/product/view/id/6055',0,5,NULL,1,NULL),(10208,'product',6056,'blanco-rondo-sol-if-stainless-steel-inset-kitchen-sink-514647.html','catalog/product/view/id/6056',0,5,NULL,1,NULL),(10209,'product',6057,'blanco-belfast-undermount-ceramic-kitchen-sink-518497.html','catalog/product/view/id/6057',0,5,NULL,1,NULL),(10210,'product',6058,'blanco-zerox-500-u-durinox-stainless-steel-undermount-sink.html','catalog/product/view/id/6058',0,5,NULL,1,NULL),(10211,'product',6059,'blanco-zerox-700-u-durinoxr-stainless-steel-undermount-sink.html','catalog/product/view/id/6059',0,5,NULL,1,NULL),(10212,'product',6060,'blanco-claron-180-u-undermount-0-5-bowl-sink-521565.html','catalog/product/view/id/6060',0,5,NULL,1,NULL),(10213,'product',6061,'blanco-claron-340-u-undermount-sink-bl467690.html','catalog/product/view/id/6061',0,5,NULL,1,NULL),(10214,'product',6062,'blanco-claron-400-u-undermount-sink-bl467691.html','catalog/product/view/id/6062',0,5,NULL,1,NULL),(10215,'product',6063,'blanco-claron-450-u-undermount-sink-521575.html','catalog/product/view/id/6063',0,5,NULL,1,NULL),(10216,'product',6064,'blanco-claron-500-if-inset-kitchen-sink-521576.html','catalog/product/view/id/6064',0,5,NULL,1,NULL),(10217,'product',6065,'blanco-claron-500-u-undermount-sink-bl467693.html','catalog/product/view/id/6065',0,5,NULL,1,NULL),(10218,'product',6066,'blanco-claron-700-if-inset-kitchen-sink-521580.html','catalog/product/view/id/6066',0,5,NULL,1,NULL),(10219,'product',6067,'blanco-claron-700-u-undermount-sink-bl467695.html','catalog/product/view/id/6067',0,5,NULL,1,NULL),(10220,'product',6068,'blanco-zerox-500-u-undermount-sink-521589.html','catalog/product/view/id/6068',0,5,NULL,1,NULL),(10221,'product',6069,'blanco-zerox-550-u-undermount-sink-521591.html','catalog/product/view/id/6069',0,5,NULL,1,NULL),(10222,'product',6070,'blanco-zerox-700-u-stainless-steel-undermount-kitchen-sink.html','catalog/product/view/id/6070',0,5,NULL,1,NULL),(10223,'product',6071,'blanco-claron-400-400-u-stainless-steel-undermount-kitchen-sink.html','catalog/product/view/id/6071',0,5,NULL,1,NULL),(10224,'product',6072,'blanco-etagon-500-if-a-stainless-steel-inset-sink.html','catalog/product/view/id/6072',0,5,NULL,1,NULL),(10225,'product',6073,'blanco-etagon-500-if-stainless-steel-inset-sink.html','catalog/product/view/id/6073',0,5,NULL,1,NULL),(10226,'product',6074,'blanco-etagon-500-u-stainless-steel-undermount-kitchen-sink.html','catalog/product/view/id/6074',0,5,NULL,1,NULL),(10227,'product',6075,'blanco-axis-iii-5-s-if-stainless-steel-inset-sink.html','catalog/product/view/id/6075',0,5,NULL,1,NULL),(10228,'product',6076,'blanco-andano-180-if-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6076',0,5,NULL,1,NULL),(10229,'product',6077,'blanco-andano-180-u-undermount-stainless-steel-kitchen-sink.html','catalog/product/view/id/6077',0,5,NULL,1,NULL),(10230,'product',6078,'blanco-andano-340-if-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6078',0,5,NULL,1,NULL),(10231,'product',6079,'blanco-andano-340-u-undermount-stainless-steel-kitchen-sink-bl-518-305.html','catalog/product/view/id/6079',0,5,NULL,1,NULL),(10232,'product',6080,'blanco-andano-400-if-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6080',0,5,NULL,1,NULL),(10233,'product',6081,'blanco-andano-400-u-undermount-stainless-steel-kitchen-sink.html','catalog/product/view/id/6081',0,5,NULL,1,NULL),(10234,'product',6082,'blanco-andano-450-if-inset-stainless-steel-kitchen-sink-bl-519-375.html','catalog/product/view/id/6082',0,5,NULL,1,NULL),(10235,'product',6083,'blanco-andano-450-u-undermount-stainless-steel-kitchen-sink.html','catalog/product/view/id/6083',0,5,NULL,1,NULL),(10236,'product',6084,'blanco-andano-500-if-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6084',0,5,NULL,1,NULL),(10237,'product',6085,'blanco-andano-500-u-undermount-stainless-steel-kitchen-sink.html','catalog/product/view/id/6085',0,5,NULL,1,NULL),(10238,'product',6086,'blanco-andano-700-if-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6086',0,5,NULL,1,NULL),(10239,'product',6087,'blanco-andano-700-u-undermount-stainless-steel-kitchen-sink.html','catalog/product/view/id/6087',0,5,NULL,1,NULL),(10240,'product',6088,'blanco-andano-340-340-u-undermount-stainless-steel-kitchen-sink.html','catalog/product/view/id/6088',0,5,NULL,1,NULL),(10241,'product',6089,'blanco-andano-400-400-if-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6089',0,5,NULL,1,NULL),(10242,'product',6090,'blanco-andano-400-400-u-stainless-steel-undermount-sink.html','catalog/product/view/id/6090',0,5,NULL,1,NULL),(10243,'product',6091,'blanco-claron-500-u-durinox-stainless-steel-undermount-sink.html','catalog/product/view/id/6091',0,5,NULL,1,NULL),(10244,'product',6092,'blanco-claron-700-u-durinox-stainless-steel-undermount-kitchen-sink.html','catalog/product/view/id/6092',0,5,NULL,1,NULL),(10245,'product',6093,'blanco-delta-if-inset-stainless-steel-kitchen-sink-rh-bowl.html','catalog/product/view/id/6093',0,5,NULL,1,NULL),(10246,'product',6094,'blanco-subline-375-u-undermount-ceramic-kitchen-sink.html','catalog/product/view/id/6094',0,5,NULL,1,NULL),(10247,'product',6095,'blanco-subline-500-u-undermount-ceramic-kitchen-sink.html','catalog/product/view/id/6095',0,5,NULL,1,NULL),(10248,'product',6096,'blanco-subline-350-150-u-undermount-ceramic-kitchen-sink.html','catalog/product/view/id/6096',0,5,NULL,1,NULL),(10249,'product',6097,'blanco-etagon-700-u-stainless-steel-undermount-kitchen-sink.html','catalog/product/view/id/6097',0,5,NULL,1,NULL),(10250,'product',6098,'blanco-etagon-700-if-stainless-steel-inset-sink.html','catalog/product/view/id/6098',0,5,NULL,1,NULL),(10251,'product',6099,'blanco-etagon-700-if-a-stainless-steel-inset-sink.html','catalog/product/view/id/6099',0,5,NULL,1,NULL),(10252,'product',6100,'blanco-etagon-500-u-ceramic-undermount-sink-crystal-white.html','catalog/product/view/id/6100',0,5,NULL,1,NULL),(10253,'product',6101,'blanco-etagon-6-ceramic-inset-sink.html','catalog/product/view/id/6101',0,5,NULL,1,NULL),(10254,'product',6102,'blanco-villae-farmhouse-single-ceramic-inset-sink.html','catalog/product/view/id/6102',0,5,NULL,1,NULL),(10255,'product',6103,'blanco-villae-farmhouse-double-ceramic-inset-sink.html','catalog/product/view/id/6103',0,5,NULL,1,NULL),(10256,'product',6104,'blanco-villae-1-5-bowl-ceramic-inset-sink.html','catalog/product/view/id/6104',0,5,NULL,1,NULL),(10257,'product',6105,'blanco-andano-400-if-a-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6105',0,5,NULL,1,NULL),(10258,'product',6106,'blanco-andano-500-if-a-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6106',0,5,NULL,1,NULL),(10259,'product',6107,'blanco-andano-700-if-a-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6107',0,5,NULL,1,NULL),(10260,'product',6108,'blanco-andano-340-180-if-a-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6108',0,5,NULL,1,NULL),(10261,'product',6109,'blanco-andano-400-400-if-a-inset-kitchen-sink-bl467013.html','catalog/product/view/id/6109',0,5,NULL,1,NULL),(10262,'product',6110,'blanco-classimo-xl-6-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6110',0,5,NULL,1,NULL),(10263,'product',6111,'blanco-classimo-6-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6111',0,5,NULL,1,NULL),(10264,'product',6112,'blanco-classimo-45-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6112',0,5,NULL,1,NULL),(10265,'product',6113,'blanco-solis-180-u-stainless-steel-undermount-kitchen-sink.html','catalog/product/view/id/6113',0,5,NULL,1,NULL),(10266,'product',6114,'blanco-solis-340-u-stainless-steel-undermount-kitchen-sink.html','catalog/product/view/id/6114',0,5,NULL,1,NULL),(10267,'product',6115,'blanco-solis-400-u-stainless-steel-undermount-kitchen-sink.html','catalog/product/view/id/6115',0,5,NULL,1,NULL),(10268,'product',6116,'blanco-solis-450-u-stainless-steel-undermount-kitchen-sink.html','catalog/product/view/id/6116',0,5,NULL,1,NULL),(10269,'product',6117,'blanco-solis-500-u-stainless-steel-undermount-kitchen-sink.html','catalog/product/view/id/6117',0,5,NULL,1,NULL),(10270,'product',6118,'blanco-solis-700-u-stainless-steel-undermount-kitchen-sink.html','catalog/product/view/id/6118',0,5,NULL,1,NULL),(10271,'product',6119,'blanco-zerox-500-u-dark-steel-undermount-kitchen-sink.html','catalog/product/view/id/6119',0,5,NULL,1,NULL),(10272,'product',6120,'blanco-zerox-700-u-dark-steel-undermount-kitchen-sink.html','catalog/product/view/id/6120',0,5,NULL,1,NULL),(10273,'product',6121,'blanco-supra-400-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6121',0,5,NULL,1,NULL),(10274,'product',6122,'blanco-supra-500-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6122',0,5,NULL,1,NULL),(10275,'product',6123,'blanco-supra-400-if-a-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6123',0,5,NULL,1,NULL),(10276,'product',6124,'blanco-supra-500-if-a-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6124',0,5,NULL,1,NULL),(10277,'product',6125,'blanco-claron-500-u-dark-steel-undermount-kitchen-sink.html','catalog/product/view/id/6125',0,5,NULL,1,NULL),(10278,'product',6126,'blanco-claron-700-u-dark-steel-undermount-kitchen-sink.html','catalog/product/view/id/6126',0,5,NULL,1,NULL),(10279,'product',6127,'blanco-adira-45-s-silgranit-kitchen-sink.html','catalog/product/view/id/6127',0,5,NULL,1,NULL),(10280,'product',6128,'blanco-adira-6s-silgranit-kitchen-sink.html','catalog/product/view/id/6128',0,5,NULL,1,NULL),(10281,'product',6129,'blanco-adira-xl-6s-silgranit-kitchen-sink.html','catalog/product/view/id/6129',0,5,NULL,1,NULL),(10282,'product',6130,'franke-ascona-agx-611-100-inset-1-0-bowl-kitchen-sink.html','catalog/product/view/id/6130',0,5,NULL,1,NULL),(10283,'product',6131,'franke-argos-agx-611-78-inset-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6131',0,5,NULL,1,NULL),(10284,'product',6132,'franke-argos-agx-611-860-inset-1-0-bowl-kitchen-sink.html','catalog/product/view/id/6132',0,5,NULL,1,NULL),(10285,'product',6133,'franke-argos-agx-651-inset-1-5-bowl-kitchen-sink.html','catalog/product/view/id/6133',0,5,NULL,1,NULL),(10286,'product',6134,'franke-arcana-ahk-611-ceramic-1-0-bowl-kitchen-sink-white.html','catalog/product/view/id/6134',0,5,NULL,1,NULL),(10287,'product',6135,'reginox-alaska-1-5-bowl-kitchen-sink.html','catalog/product/view/id/6135',0,5,NULL,1,NULL),(10288,'product',6136,'reginox-alpha-inset-1-bowl-kitchen-sink.html','catalog/product/view/id/6136',0,5,NULL,1,NULL),(10289,'product',6137,'blanco-andano-340-180-if-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6137',0,5,NULL,1,NULL),(10290,'product',6138,'blanco-andano-340-180-u-undermount-stainless-steel-kitchen-sink.html','catalog/product/view/id/6138',0,5,NULL,1,NULL),(10291,'product',6139,'blanco-andano-500-180-u-undermount-kitchen-sink.html','catalog/product/view/id/6139',0,5,NULL,1,NULL),(10292,'product',6140,'blanco-andano-xl-6-s-if-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6140',0,5,NULL,1,NULL),(10293,'product',6141,'blanco-andano-xl-6-s-if-compact-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6141',0,5,NULL,1,NULL),(10294,'product',6142,'franke-ariane-arx-110-17-undermount-1-0-bowl-kitchen-sink.html','catalog/product/view/id/6142',0,5,NULL,1,NULL),(10295,'product',6143,'franke-ariane-arx-110-17-d-undermount-kitchen-sink-stainless-steel.html','catalog/product/view/id/6143',0,5,NULL,1,NULL),(10296,'product',6144,'franke-ariane-arx-110-33-undermount-kitchen-sink-stainless-steel.html','catalog/product/view/id/6144',0,5,NULL,1,NULL),(10297,'product',6145,'franke-ariane-arx-110-35-undermount-kitchen-sink-stainless-steel.html','catalog/product/view/id/6145',0,5,NULL,1,NULL),(10298,'product',6146,'franke-ariane-arx-160-undermount-kitchen-sink-stainless-steel.html','catalog/product/view/id/6146',0,5,NULL,1,NULL),(10299,'product',6147,'franke-ariane-arx-160-d-undermount-kitchen-sink-stainless-steel.html','catalog/product/view/id/6147',0,5,NULL,1,NULL),(10300,'product',6148,'reginox-atlantis-ops-l-integrated-1-bowl-kitchen-sink.html','catalog/product/view/id/6148',0,5,NULL,1,NULL),(10301,'product',6149,'blanco-axia-iii-6-s-silgranit-puradur-iir-inset-sink.html','catalog/product/view/id/6149',0,5,NULL,1,NULL),(10302,'product',6150,'blanco-axia-iii-xl-6-s-silgranit-puradur-iir-inset-sink.html','catalog/product/view/id/6150',0,5,NULL,1,NULL),(10303,'product',6151,'blanco-axis-iii-6-s-if-stainless-steel-inset-sink.html','catalog/product/view/id/6151',0,5,NULL,1,NULL),(10304,'product',6152,'franke-antea-azg-611-78-inset-1-0-bowl-kitchen-sink.html','catalog/product/view/id/6152',0,5,NULL,1,NULL),(10305,'product',6153,'franke-antea-azg-621-inset-2-0-bowl-kitchen-sink.html','catalog/product/view/id/6153',0,5,NULL,1,NULL),(10306,'product',6154,'franke-antea-azg-651-inset-1-5-bowl-kitchen-sink.html','catalog/product/view/id/6154',0,5,NULL,1,NULL),(10307,'product',6155,'franke-antea-azn-611-100-inset-1-bowl-kitchen-sink-stainless-steel.html','catalog/product/view/id/6155',0,5,NULL,1,NULL),(10308,'product',6156,'franke-antea-azn-611-86-stainless-steel-1-bowl-kitchen-sink.html','catalog/product/view/id/6156',0,5,NULL,1,NULL),(10309,'product',6157,'franke-antea-azn-651-inset-1-5-bowl-kitchen-sink-stainless-steel.html','catalog/product/view/id/6157',0,5,NULL,1,NULL),(10310,'product',6158,'franke-bak-710-pro-value-belfast-kitchen-sink-ceramic-white.html','catalog/product/view/id/6158',0,5,NULL,1,NULL),(10311,'product',6159,'reginox-belfast-contemporary-1-bowl-ceramic-kitchen-inset-sink.html','catalog/product/view/id/6159',0,5,NULL,1,NULL),(10312,'product',6160,'reginox-best-450-inset-2-bowl-granite-kitchen-sink.html','catalog/product/view/id/6160',0,5,NULL,1,NULL),(10313,'product',6161,'reginox-best-475-inset-1-5-bowl-granite-kitchen-sink.html','catalog/product/view/id/6161',0,5,NULL,1,NULL),(10314,'product',6162,'reginox-best-480-inset-1-bowl-granite-kitchen-sink.html','catalog/product/view/id/6162',0,5,NULL,1,NULL),(10315,'product',6163,'reginox-comfort-beta-20-inset-2-bowl-kitchen-sink.html','catalog/product/view/id/6163',0,5,NULL,1,NULL),(10316,'product',6164,'franke-basis-bfg-611-78-kitchen-sink.html','catalog/product/view/id/6164',0,5,NULL,1,NULL),(10317,'product',6165,'franke-basis-bfg-611-97-inset-1-bowl-kitchen-sink-fragranite.html','catalog/product/view/id/6165',0,5,NULL,1,NULL),(10318,'product',6166,'franke-bfg-651-basis-fragranite-kitchen-sink.html','catalog/product/view/id/6166',0,5,NULL,1,NULL),(10319,'product',6167,'franke-box-center-bwx-120-41-27-inset-stainless-steel-1-5-bowl-sink.html','catalog/product/view/id/6167',0,5,NULL,1,NULL),(10320,'product',6168,'franke-box-center-bwx-220-41-27-inset-stainless-steel-1-5-bowl-sink.html','catalog/product/view/id/6168',0,5,NULL,1,NULL),(10321,'product',6169,'franke-box-center-bwx-220-54-27-undermount-1-5-bowl-kitchen-sink-stainless-steel.html','catalog/product/view/id/6169',0,5,NULL,1,NULL),(10322,'product',6170,'franke-box-bxx-110-16-half-bowl-kitchen-sink.html','catalog/product/view/id/6170',0,5,NULL,1,NULL),(10323,'product',6171,'franke-box-bxx-110-40-undermount-1-bowl-kitchen-sink-stainless-steel.html','catalog/product/view/id/6171',0,5,NULL,1,NULL),(10324,'product',6172,'franke-box-bxx-110-50-undermount-1-bowl-kitchen-sink-stainless-steel.html','catalog/product/view/id/6172',0,5,NULL,1,NULL),(10325,'product',6173,'franke-box-bxx-110-54-undermount-1-bowl-kitchen-sink-stainless-steel.html','catalog/product/view/id/6173',0,5,NULL,1,NULL),(10326,'product',6174,'franke-bxx-110-68-box-single-bowl-undermount-kitchen-sink.html','catalog/product/view/id/6174',0,5,NULL,1,NULL),(10327,'product',6175,'franke-box-bxx-160-34-16-undermount-1-5-bowl-kitchen-sink-stainless-steel.html','catalog/product/view/id/6175',0,5,NULL,1,NULL),(10328,'product',6176,'reginox-elite-centurio-l-integrated-1-5-bowl-kitchen-sink.html','catalog/product/view/id/6176',0,5,NULL,1,NULL),(10329,'product',6177,'reginox-centurio-l10-single-bowl-kitchen-sink.html','catalog/product/view/id/6177',0,5,NULL,1,NULL),(10330,'product',6178,'reginox-elite-centurio-l20-integrated-2-bowl-kitchen-sink.html','catalog/product/view/id/6178',0,5,NULL,1,NULL),(10331,'product',6179,'reginox-elite-centurio-l30-integrated-2-bowl-kitchen-sink.html','catalog/product/view/id/6179',0,5,NULL,1,NULL),(10332,'product',6180,'blanco-claron-340-180-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6180',0,5,NULL,1,NULL),(10333,'product',6181,'blanco-claron-340-180-undermount-sink-claron-340-180-u.html','catalog/product/view/id/6181',0,5,NULL,1,NULL),(10334,'product',6182,'blanco-claron-550-u-undermount-sink-bl467694.html','catalog/product/view/id/6182',0,5,NULL,1,NULL),(10335,'product',6183,'blanco-classic-40-s-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6183',0,5,NULL,1,NULL),(10336,'product',6184,'blanco-collectis-6-s-silgranit-puradur-iir-inset-sink.html','catalog/product/view/id/6184',0,5,NULL,1,NULL),(10337,'product',6185,'reginox-comfort-colorado-l-integrated-1-bowl-kitchen-sink.html','catalog/product/view/id/6185',0,5,NULL,1,NULL),(10338,'product',6186,'blanco-codelta-ii-puradur-ii-inset-silgranit-kitchen-sink.html','catalog/product/view/id/6186',0,5,NULL,1,NULL),(10339,'product',6187,'reginox-diplomat-eco-1-5-bowl-kitchen-sink.html','catalog/product/view/id/6187',0,5,NULL,1,NULL),(10340,'product',6188,'reginox-diplomat-10-eco-single-bowl-kitchen-sink.html','catalog/product/view/id/6188',0,5,NULL,1,NULL),(10341,'product',6189,'blanco-divon-ii-5-s-if-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6189',0,5,NULL,1,NULL),(10342,'product',6190,'blanco-divon-ii-6-s-if-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6190',0,5,NULL,1,NULL),(10343,'product',6191,'blanco-divon-ii-8-s-if-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6191',0,5,NULL,1,NULL),(10344,'product',6192,'reginox-ego-400-inset-1-bowl-granite-kitchen-sink.html','catalog/product/view/id/6192',0,5,NULL,1,NULL),(10345,'product',6193,'reginox-ego-475-inset-1-5-bowl-granite-kitchen-sink.html','catalog/product/view/id/6193',0,5,NULL,1,NULL),(10346,'product',6194,'reginox-ego-800-inset-1-bowl-granite-kitchen-sink.html','catalog/product/view/id/6194',0,5,NULL,1,NULL),(10347,'product',6195,'franke-elba-elk-611-inset-1-0-bowl-kitchen-sink.html','catalog/product/view/id/6195',0,5,NULL,1,NULL),(10348,'product',6196,'blanco-elon-45-s-puradur-ii-inset-silgranit-kitchen-sink.html','catalog/product/view/id/6196',0,5,NULL,1,NULL),(10349,'product',6197,'blanco-elon-xl-6-s-puradur-ii-inset-silgranit-kitchen-sink.html','catalog/product/view/id/6197',0,5,NULL,1,NULL),(10350,'product',6198,'blanco-etagon-500-u-silgranit-puradur-iir-undermount-sink.html','catalog/product/view/id/6198',0,5,NULL,1,NULL),(10351,'product',6199,'blanco-etagon-6-puradur-reg-silgranit-inset-sink.html','catalog/product/view/id/6199',0,5,NULL,1,NULL),(10352,'product',6200,'blanco-etagon-700-u-silgranit-undermount-sink.html','catalog/product/view/id/6200',0,5,NULL,1,NULL),(10353,'product',6201,'blanco-etagon-8-puradur-reg-silgranit-inset-sink.html','catalog/product/view/id/6201',0,5,NULL,1,NULL),(10354,'product',6202,'franke-fresno-fsg-111-undermount-1-0-bowl-kitchen-sink.html','catalog/product/view/id/6202',0,5,NULL,1,NULL),(10355,'product',6203,'franke-galassia-gak-611-kitchen-sink-white.html','catalog/product/view/id/6203',0,5,NULL,1,NULL),(10356,'product',6204,'franke-galassia-gak-651-ceramic-1-5-bowl-kitchen-sink-white.html','catalog/product/view/id/6204',0,5,NULL,1,NULL),(10357,'product',6205,'reginox-galicia-1-0-bowl-reversible-stainless-steel-kitchen-sink.html','catalog/product/view/id/6205',0,5,NULL,1,NULL),(10358,'product',6206,'franke-galassia-plus-gax-611-bowl-inset-kitchen-sink-stainless-steel.html','catalog/product/view/id/6206',0,5,NULL,1,NULL),(10359,'product',6207,'franke-galassia-plus-gax-621-bowl-inset-kitchen-sink-stainless-steel.html','catalog/product/view/id/6207',0,5,NULL,1,NULL),(10360,'product',6208,'reginox-harlem-10-inset-1-bowl-granite-kitchen-sink.html','catalog/product/view/id/6208',0,5,NULL,1,NULL),(10361,'product',6209,'reginox-harlem-15-inset-1-5-bowl-granite-kitchen-sink.html','catalog/product/view/id/6209',0,5,NULL,1,NULL),(10362,'product',6210,'reginox-elegance-jumbo-inset-1-bowl-kitchen-sink.html','catalog/product/view/id/6210',0,5,NULL,1,NULL),(10363,'product',6211,'reginox-elite-kansas-l-integrated-1-bowl-kitchen-sink-40x40cm.html','catalog/product/view/id/6211',0,5,NULL,1,NULL),(10364,'product',6212,'reginox-elite-kansas-l-integrated-1-bowl-kitchen-sink-50x40cm.html','catalog/product/view/id/6212',0,5,NULL,1,NULL),(10365,'product',6213,'franke-kubus-kbk-110-40-undermount-1-0-bowl-kitchen-sink.html','catalog/product/view/id/6213',0,5,NULL,1,NULL),(10366,'product',6214,'franke-kubus-kbk-110-50-undermount-1-0-bowl-kitchen-sink.html','catalog/product/view/id/6214',0,5,NULL,1,NULL),(10367,'product',6215,'franke-kubus-kbk-160-undermount-1-5-bowl-ceramic-kitchen-sink.html','catalog/product/view/id/6215',0,5,NULL,1,NULL),(10368,'product',6216,'franke-kubus-kng-110-37-undermount-1-0-bowl-kitchen-sink.html','catalog/product/view/id/6216',0,5,NULL,1,NULL),(10369,'product',6217,'franke-kubus-kng-110-52-undermount-1-0-bowl-kitchen-sink.html','catalog/product/view/id/6217',0,5,NULL,1,NULL),(10370,'product',6218,'franke-kubus-kng-110-62-undermount-1-0-bowl-kitchen-sink.html','catalog/product/view/id/6218',0,5,NULL,1,NULL),(10371,'product',6219,'franke-kubus-kng-120-undermount-1-5-bowl-kitchen-sink.html','catalog/product/view/id/6219',0,5,NULL,1,NULL),(10372,'product',6220,'reginox-l183016-single-bowl-kitchen-sink.html','catalog/product/view/id/6220',0,5,NULL,1,NULL),(10373,'product',6221,'reginox-l183440-single-bowl-kitchen-sink.html','catalog/product/view/id/6221',0,5,NULL,1,NULL),(10374,'product',6222,'reginox-l18390-l-round-bowl-kitchen-sink.html','catalog/product/view/id/6222',0,5,NULL,1,NULL),(10375,'product',6223,'franke-largo-lax-110-45-undermount-kitchen-sink-stainless-steel.html','catalog/product/view/id/6223',0,5,NULL,1,NULL),(10376,'product',6224,'franke-largo-lax-110-50-undermount-kitchen-sink-stainless-steel.html','catalog/product/view/id/6224',0,5,NULL,1,NULL),(10377,'product',6225,'franke-largo-lax-110-50-41-undermount-kitchen-sink-stainless-steel.html','catalog/product/view/id/6225',0,5,NULL,1,NULL),(10378,'product',6226,'franke-largo-lax-120-36-36-undermount-kitchen-sink-stainless-steel.html','catalog/product/view/id/6226',0,5,NULL,1,NULL),(10379,'product',6227,'franke-largo-lax-120-45-30-undermount-kitchen-sink-stainless-steel.html','catalog/product/view/id/6227',0,5,NULL,1,NULL),(10380,'product',6228,'franke-largo-lax-160-36-16-undermount-kitchen-sink-stainless-steel.html','catalog/product/view/id/6228',0,5,NULL,1,NULL),(10381,'product',6229,'blanco-legra-45-s-silgranit-r-inset-sink.html','catalog/product/view/id/6229',0,5,NULL,1,NULL),(10382,'product',6230,'blanco-legra-6-silgranitr-inset-sink.html','catalog/product/view/id/6230',0,5,NULL,1,NULL),(10383,'product',6231,'blanco-legra-6-s-silgranit-inset-kitchen-sink.html','catalog/product/view/id/6231',0,5,NULL,1,NULL),(10384,'product',6232,'blanco-legra-xl-6-s-silgranitr-inset-sink.html','catalog/product/view/id/6232',0,5,NULL,1,NULL),(10385,'product',6233,'reginox-mataro-undermount-1-0-bowl-ceramic-kitchen-sink.html','catalog/product/view/id/6233',0,5,NULL,1,NULL),(10386,'product',6234,'blanco-metra-45-s-puradur-ii-inset-silgranit-kitchen-sink.html','catalog/product/view/id/6234',0,5,NULL,1,NULL),(10387,'product',6235,'blanco-metra-5-s-puradur-ii-inset-silgranit-kitchen-sink.html','catalog/product/view/id/6235',0,5,NULL,1,NULL),(10388,'product',6236,'blanco-metra-6-puradur-ii-inset-silgranit-kitchen-sink.html','catalog/product/view/id/6236',0,5,NULL,1,NULL),(10389,'product',6237,'blanco-metra-6-s-puradur-ii-inset-silgranit-kitchen-sink.html','catalog/product/view/id/6237',0,5,NULL,1,NULL),(10390,'product',6238,'blanco-metra-8-s-puradur-ii-inset-silgranit-kitchen-sink.html','catalog/product/view/id/6238',0,5,NULL,1,NULL),(10391,'product',6239,'blanco-metra-xl-puradur-ii-inset-silgranit-kitchen-sink.html','catalog/product/view/id/6239',0,5,NULL,1,NULL),(10392,'product',6240,'reginox-miami-40x40-single-bowl-kitchen-sink.html','catalog/product/view/id/6240',0,5,NULL,1,NULL),(10393,'product',6241,'reginox-miami-50x40-single-bowl-kitchen-sink.html','catalog/product/view/id/6241',0,5,NULL,1,NULL),(10394,'product',6242,'reginox-elegance-minister-reversible-inset-1-bowl-kitchen-sink.html','catalog/product/view/id/6242',0,5,NULL,1,NULL),(10395,'product',6243,'franke-maris-quiet-mqx-110-50-single-bowl-undermount-kitchen-sink.html','catalog/product/view/id/6243',0,5,NULL,1,NULL),(10396,'product',6244,'franke-maris-quiet-mqx-110-82-undermount-1-bowl-kitchen-sink.html','catalog/product/view/id/6244',0,5,NULL,1,NULL),(10397,'product',6245,'franke-maris-mrg-110-37-kitchen-sink.html','catalog/product/view/id/6245',0,5,NULL,1,NULL),(10398,'product',6246,'franke-maris-mrg-110-52-kitchen-sink.html','catalog/product/view/id/6246',0,5,NULL,1,NULL),(10399,'product',6247,'franke-maris-mrg-110-72-kitchen-sink.html','catalog/product/view/id/6247',0,5,NULL,1,NULL),(10400,'product',6248,'franke-maris-mrg-160-34-15-kitchen-sink.html','catalog/product/view/id/6248',0,5,NULL,1,NULL),(10401,'product',6249,'franke-maris-mrx-210-19-inset-1-bowl-kitchen-sink-stainless-steel.html','catalog/product/view/id/6249',0,5,NULL,1,NULL),(10402,'product',6250,'franke-maris-bowl-mrx-210-34-inset-1-0-bowl-kitchen-sink.html','catalog/product/view/id/6250',0,5,NULL,1,NULL),(10403,'product',6251,'franke-maris-mrx-210-45-inset-1-bowl-kitchen-sink-stainless-steel.html','catalog/product/view/id/6251',0,5,NULL,1,NULL),(10404,'product',6252,'franke-maris-bowl-mrx-210-70-inset-1-0-bowl-kitchen-sink.html','catalog/product/view/id/6252',0,5,NULL,1,NULL),(10405,'product',6253,'franke-maris-mrx-211-slim-top-bowl-inset-kitchen-sink-stainless-steel.html','catalog/product/view/id/6253',0,5,NULL,1,NULL),(10406,'product',6254,'franke-maris-mrx-220-34-34-stainless-steel-double-bowl-sink.html','catalog/product/view/id/6254',0,5,NULL,1,NULL),(10407,'product',6255,'franke-maris-mrx-251-slim-top-inset-1-5-bowl-kitchen-sink.html','catalog/product/view/id/6255',0,5,NULL,1,NULL),(10408,'product',6256,'franke-maris-mrx-260-34-19-inset-1-5-bowl-kitchen-sink-stainless-steel.html','catalog/product/view/id/6256',0,5,NULL,1,NULL),(10409,'product',6257,'franke-mtg-651-100-mythos-fragranite-kitchen-sink.html','catalog/product/view/id/6257',0,5,NULL,1,NULL),(10410,'product',6258,'reginox-multa-102-inset-single-bowl-granite-kitchen-sink.html','catalog/product/view/id/6258',0,5,NULL,1,NULL),(10411,'product',6259,'reginox-multa-105-inset-single-bowl-granite-kitchen-sink.html','catalog/product/view/id/6259',0,5,NULL,1,NULL),(10412,'product',6260,'reginox-multa-130-inset-single-bowl-granite-kitchen-sink.html','catalog/product/view/id/6260',0,5,NULL,1,NULL),(10413,'product',6261,'franke-mythos-myx-160-34-16-undermount-stainless-steel-1-5-bowl-sink.html','catalog/product/view/id/6261',0,5,NULL,1,NULL),(10414,'product',6262,'franke-mythos-myx-160-50-16-undermount-stainless-steel-1-5-bowl-sink.html','catalog/product/view/id/6262',0,5,NULL,1,NULL),(10415,'product',6263,'franke-mythos-myx-210-34-inset-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6263',0,5,NULL,1,NULL),(10416,'product',6264,'franke-mythos-myx-210-45-inset-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6264',0,5,NULL,1,NULL),(10417,'product',6265,'franke-mythos-myx-210-55-inset-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6265',0,5,NULL,1,NULL),(10418,'product',6266,'franke-mythos-myx-210-70-inset-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6266',0,5,NULL,1,NULL),(10419,'product',6267,'franke-mythos-myx-211-86-stainless-steel-kitchen-sink.html','catalog/product/view/id/6267',0,5,NULL,1,NULL),(10420,'product',6268,'franke-mythos-myx-251-86-stainless-steel-kitchen-sink.html','catalog/product/view/id/6268',0,5,NULL,1,NULL),(10421,'product',6269,'blanco-naya-6-silgranit-puradur-iir-inset-sink.html','catalog/product/view/id/6269',0,5,NULL,1,NULL),(10422,'product',6270,'blanco-naya-xl-9-inset-silgranit-puradur-iir-kitchen-sink.html','catalog/product/view/id/6270',0,5,NULL,1,NULL),(10423,'product',6271,'reginox-new-york-18x40-l-single-bowl-kitchen-sink.html','catalog/product/view/id/6271',0,5,NULL,1,NULL),(10424,'product',6272,'reginox-new-york-18x40-34x40-1-5-bowl-kitchen-sink.html','catalog/product/view/id/6272',0,5,NULL,1,NULL),(10425,'product',6273,'reginox-new-york-34x40-l-single-bowl-kitchen-sink.html','catalog/product/view/id/6273',0,5,NULL,1,NULL),(10426,'product',6274,'reginox-new-york-34x40-18x40-1-5-bowl-kitchen-sink.html','catalog/product/view/id/6274',0,5,NULL,1,NULL),(10427,'product',6275,'reginox-new-york-40x40-l-integrated-kitchen-sink.html','catalog/product/view/id/6275',0,5,NULL,1,NULL),(10428,'product',6276,'reginox-new-york-50x40-l-single-bowl-kitchen-sink.html','catalog/product/view/id/6276',0,5,NULL,1,NULL),(10429,'product',6277,'reginox-new-york-50x40-18x40-1-5-bowl-kitchen-sink.html','catalog/product/view/id/6277',0,5,NULL,1,NULL),(10430,'product',6278,'franke-neptune-nex-211-kitchen-inset-sink-stainless-steel.html','catalog/product/view/id/6278',0,5,NULL,1,NULL),(10431,'product',6279,'franke-neptune-nex-251-kitchen-inset-sink-stainless-steel.html','catalog/product/view/id/6279',0,5,NULL,1,NULL),(10432,'product',6280,'rak-laboratory-1-ceramic-kitchen-sink-single-bowl.html','catalog/product/view/id/6280',0,5,NULL,1,NULL),(10433,'product',6281,'rak-laboratory-2-ceramic-kitchen-sink-single-bowl.html','catalog/product/view/id/6281',0,5,NULL,1,NULL),(10434,'product',6282,'rak-laboratory-counter-top-single-bowl-kitchen-sink-labsink3.html','catalog/product/view/id/6282',0,5,NULL,1,NULL),(10435,'product',6283,'rak-laboratory-counter-top-single-bowl-ceramic-kitchen-sink-labsink4.html','catalog/product/view/id/6283',0,5,NULL,1,NULL),(10436,'product',6284,'reginox-elite-ohio-l-integrated-0-5-bowl-kitchen-sink-18x40cm.html','catalog/product/view/id/6284',0,5,NULL,1,NULL),(10437,'product',6285,'reginox-elite-ohio-l-integrated-1-5-bowl-kitchen-sink-18x40-50x40cm.html','catalog/product/view/id/6285',0,5,NULL,1,NULL),(10438,'product',6286,'reginox-elite-ohio-l-integrated-1-bowl-kitchen-sink-40x40cm.html','catalog/product/view/id/6286',0,5,NULL,1,NULL),(10439,'product',6287,'reginox-elite-ohio-l-integrated-1-bowl-kitchen-sink-with-tap-wing-40x40cm.html','catalog/product/view/id/6287',0,5,NULL,1,NULL),(10440,'product',6288,'reginox-elite-ohio-l-integrated-1-bowl-kitchen-sink-50x40cm.html','catalog/product/view/id/6288',0,5,NULL,1,NULL),(10441,'product',6289,'reginox-elite-ohio-l-integrated-1-bowl-kitchen-sink-with-tap-wing-50x40cm.html','catalog/product/view/id/6289',0,5,NULL,1,NULL),(10442,'product',6290,'reginox-elite-ohio-l-integrated-1-5-bowl-kitchen-sink-50x40-18x40cm.html','catalog/product/view/id/6290',0,5,NULL,1,NULL),(10443,'product',6291,'reginox-elite-ohio-l-integrated-1-bowl-kitchen-sink-80x42cm.html','catalog/product/view/id/6291',0,5,NULL,1,NULL),(10444,'product',6292,'franke-orion-oid-611-94-tectonite-kitchen-sink.html','catalog/product/view/id/6292',0,5,NULL,1,NULL),(10445,'product',6293,'franke-oid-651-tectonite-kitchen-sink.html','catalog/product/view/id/6293',0,5,NULL,1,NULL),(10446,'product',6294,'reginox-quadra-100-undermount-1-bowl-granite-kitchen-sink.html','catalog/product/view/id/6294',0,5,NULL,1,NULL),(10447,'product',6295,'reginox-quadra-105-undermount-1-bowl-granite-kitchen-sink.html','catalog/product/view/id/6295',0,5,NULL,1,NULL),(10448,'product',6296,'reginox-quadra-130-undermount-1-bowl-granite-kitchen-sink.html','catalog/product/view/id/6296',0,5,NULL,1,NULL),(10449,'product',6297,'reginox-quadra-50-undermount-0-5-bowl-granite-kitchen-sink.html','catalog/product/view/id/6297',0,5,NULL,1,NULL),(10450,'product',6298,'reginox-r18-2330-osk-single-bowl-inset-kitchen-sink.html','catalog/product/view/id/6298',0,5,NULL,1,NULL),(10451,'product',6299,'franke-rbx-610-rotondo-kitchen-sink-stainless-steel.html','catalog/product/view/id/6299',0,5,NULL,1,NULL),(10452,'product',6300,'reginox-comfort-regent10-lux-inset-1-bowl-kitchen-sink.html','catalog/product/view/id/6300',0,5,NULL,1,NULL),(10453,'product',6301,'reginox-comfort-regidrain-r-inset-1-bowl-kitchen-sink.html','catalog/product/view/id/6301',0,5,NULL,1,NULL),(10454,'product',6302,'reginox-rio-ops-l-integrated-1-bowl-kitchen-sink.html','catalog/product/view/id/6302',0,5,NULL,1,NULL),(10455,'product',6303,'reginox-rio-l-integrated-1-bowl-kitchen-sink.html','catalog/product/view/id/6303',0,5,NULL,1,NULL),(10456,'product',6304,'reginox-1-5-bowl-ceramic-kitchen-inset-sink-rl301cw.html','catalog/product/view/id/6304',0,5,NULL,1,NULL),(10457,'product',6305,'reginox-1-bowl-ceramic-kitchen-inset-sink-rl304cw.html','catalog/product/view/id/6305',0,5,NULL,1,NULL),(10458,'product',6306,'reginox-1-5-bowl-ceramic-kitchen-inset-sink-rl401cb.html','catalog/product/view/id/6306',0,5,NULL,1,NULL),(10459,'product',6307,'reginox-1-5-bowl-ceramic-kitchen-inset-sink-rl501cw.html','catalog/product/view/id/6307',0,5,NULL,1,NULL),(10460,'product',6308,'reginox-1-bowl-ceramic-kitchen-inset-sink-rl504cw.html','catalog/product/view/id/6308',0,5,NULL,1,NULL),(10461,'product',6309,'blanco-rondo-puradur-ii-inset-silgranit-kitchen-sink.html','catalog/product/view/id/6309',0,5,NULL,1,NULL),(10462,'product',6310,'franke-spark-skx-611-86-inset-1-bowl-kitchen-sink-stainless-steel.html','catalog/product/view/id/6310',0,5,NULL,1,NULL),(10463,'product',6311,'franke-spark-skx-651-inset-1-5-bowl-kitchen-sink-stainless-steel.html','catalog/product/view/id/6311',0,5,NULL,1,NULL),(10464,'product',6312,'blanco-solis-340-180-u-stainless-steel-undermount-kitchen-sink.html','catalog/product/view/id/6312',0,5,NULL,1,NULL),(10465,'product',6313,'blanco-sona-5-s-puradur-ii-inset-silgranit-kitchen-sink.html','catalog/product/view/id/6313',0,5,NULL,1,NULL),(10466,'product',6314,'blanco-sona-6-s-puradur-ii-inset-silgranit-kitchen-sink.html','catalog/product/view/id/6314',0,5,NULL,1,NULL),(10467,'product',6315,'blanco-sona-xl-6-s-puradur-ii-inset-silgranit-kitchen-sink.html','catalog/product/view/id/6315',0,5,NULL,1,NULL),(10468,'product',6316,'blanco-subline-160-u-silgranit-puradur-iir-undermount-sink.html','catalog/product/view/id/6316',0,5,NULL,1,NULL),(10469,'product',6317,'blanco-subline-320-u-silgranit-puradur-iir-undermount-sink.html','catalog/product/view/id/6317',0,5,NULL,1,NULL),(10470,'product',6318,'blanco-subline-340-160-u-undermount-silgranit-kitchen-sink.html','catalog/product/view/id/6318',0,5,NULL,1,NULL),(10471,'product',6319,'blanco-subline-350-350-u-undermount-silgranit-kitchen-sink.html','catalog/product/view/id/6319',0,5,NULL,1,NULL),(10472,'product',6320,'blanco-subline-400-u-puradur-reg-silgranit-undermount-sink.html','catalog/product/view/id/6320',0,5,NULL,1,NULL),(10473,'product',6321,'blanco-subline-430-270-u-silgranit-puradurr-undermount-sink.html','catalog/product/view/id/6321',0,5,NULL,1,NULL),(10474,'product',6322,'blanco-subline-480-320-u-undermount-silgranit-kitchen-sink.html','catalog/product/view/id/6322',0,5,NULL,1,NULL),(10475,'product',6323,'blanco-subline-500-if-steel-frame-puradur-ii-kitchen-sink.html','catalog/product/view/id/6323',0,5,NULL,1,NULL),(10476,'product',6324,'blanco-subline-500-u-silgranit-puradur-iir-undermount-sink.html','catalog/product/view/id/6324',0,5,NULL,1,NULL),(10477,'product',6325,'blanco-subline-700-u-level-silgranit-undermount-sink.html','catalog/product/view/id/6325',0,5,NULL,1,NULL),(10478,'product',6326,'blanco-subline-700-u-puradur-ii-undermount-silgranit-kitchen-sink.html','catalog/product/view/id/6326',0,5,NULL,1,NULL),(10479,'product',6327,'blanco-subline-800-u-puradur-reg-silgranit-undermount-sink.html','catalog/product/view/id/6327',0,5,NULL,1,NULL),(10480,'product',6328,'reginox-elite-texas-l-integrated-0-5-bowl-kitchen-sink-18x40cm.html','catalog/product/view/id/6328',0,5,NULL,1,NULL),(10481,'product',6329,'reginox-elite-texas-l-integrated-1-bowl-kitchen-sink-30x40cm.html','catalog/product/view/id/6329',0,5,NULL,1,NULL),(10482,'product',6330,'reginox-elite-texas-l-integrated-1-bowl-kitchen-sink-40x40cm.html','catalog/product/view/id/6330',0,5,NULL,1,NULL),(10483,'product',6331,'reginox-elite-texas-l-integrated-1-bowl-kitchen-sink-50x40cm.html','catalog/product/view/id/6331',0,5,NULL,1,NULL),(10484,'product',6332,'franke-vbk-110-21-undermount-0-5-bowl-kitchen-sink-ceramic-white.html','catalog/product/view/id/6332',0,5,NULL,1,NULL),(10485,'product',6333,'franke-vbk-110-33-undermount-1-bowl-kitchen-sink-ceramic-white.html','catalog/product/view/id/6333',0,5,NULL,1,NULL),(10486,'product',6334,'franke-vbk-110-50-kitchen-sink-ceramic.html','catalog/product/view/id/6334',0,5,NULL,1,NULL),(10487,'product',6335,'franke-vbk-160-undermount-1-5-bowl-kitchen-sink-ceramic-white.html','catalog/product/view/id/6335',0,5,NULL,1,NULL),(10488,'product',6336,'franke-belfast-vbk-710-kitchen-sink-ceramic-white.html','catalog/product/view/id/6336',0,5,NULL,1,NULL),(10489,'product',6337,'franke-belfast-vbk-720-kitchen-sink-ceramic-white.html','catalog/product/view/id/6337',0,5,NULL,1,NULL),(10490,'product',6338,'blanco-vintera-xl-9-puradur-ii-silgranit-undermount-kitchen-sink.html','catalog/product/view/id/6338',0,5,NULL,1,NULL),(10491,'product',6339,'blanco-zerox-340-180-u-undermount-kitchen-sink.html','catalog/product/view/id/6339',0,5,NULL,1,NULL),(10492,'product',6340,'blanco-zia-45-s-puradur-ii-inset-silgranit-kitchen-sink.html','catalog/product/view/id/6340',0,5,NULL,1,NULL),(10493,'product',6341,'blanco-zia-5-s-puradur-ii-inset-silgranit-kitchen-sink.html','catalog/product/view/id/6341',0,5,NULL,1,NULL),(10494,'product',6342,'blanco-zia-6-s-puradur-ii-inset-silgranit-kitchen-sink.html','catalog/product/view/id/6342',0,5,NULL,1,NULL),(10495,'product',6343,'blanco-zia-9-e-corner-silgranit-puradur-iir-inset-sink.html','catalog/product/view/id/6343',0,5,NULL,1,NULL),(10496,'product',6344,'blanco-zia-xl-6-s-silgranit-puradur-iir-inset-sink.html','catalog/product/view/id/6344',0,5,NULL,1,NULL),(10497,'product',6345,'blanco-zia-xl-6-s-compact-silgranit-inset-kitchen-sink.html','catalog/product/view/id/6345',0,5,NULL,1,NULL),(10502,'product',6035,'bathroom/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/3',0,5,NULL,1,'{\"category_id\":\"3\"}'),(10503,'product',6035,'kitchen-appliances/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/5',0,5,NULL,1,'{\"category_id\":\"5\"}'),(10504,'product',6035,'heating/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/7',0,5,NULL,1,'{\"category_id\":\"7\"}'),(10505,'product',6035,'accessories/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/10',0,5,NULL,1,'{\"category_id\":\"10\"}'),(10506,'product',6035,'sales/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/11',0,5,NULL,1,'{\"category_id\":\"11\"}'),(10507,'product',6035,'brands/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/12',0,5,NULL,1,'{\"category_id\":\"12\"}'),(10509,'product',6035,'comfort-product/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/164',0,5,NULL,1,'{\"category_id\":\"164\"}'),(10510,'product',6035,'deals/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/449',0,5,NULL,1,'{\"category_id\":\"449\"}'),(10511,'product',6035,'franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035',0,1,NULL,1,NULL),(10512,'product',6035,'bathroom/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/3',0,1,NULL,1,'{\"category_id\":\"3\"}'),(10513,'product',6035,'kitchen-appliances/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/5',0,1,NULL,1,'{\"category_id\":\"5\"}'),(10514,'product',6035,'heating/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/7',0,1,NULL,1,'{\"category_id\":\"7\"}'),(10515,'product',6035,'accessories/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/10',0,1,NULL,1,'{\"category_id\":\"10\"}'),(10516,'product',6035,'sales/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/11',0,1,NULL,1,'{\"category_id\":\"11\"}'),(10517,'product',6035,'brands/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/12',0,1,NULL,1,'{\"category_id\":\"12\"}'),(10519,'product',6035,'comfort-product/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/164',0,1,NULL,1,'{\"category_id\":\"164\"}'),(10520,'product',6035,'deals/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/449',0,1,NULL,1,'{\"category_id\":\"449\"}'),(10523,'product',6036,'franke-mythos-myx-110-45-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6036',0,1,NULL,1,NULL),(10526,'category',3,'bathroom.html','catalog/category/view/id/3',0,3,NULL,1,NULL),(10527,'category',219,'bathroom/toilet.html','catalog/category/view/id/219',0,3,NULL,1,NULL),(10528,'category',15,'bathroom/toilet/toilets.html','catalog/category/view/id/15',0,3,NULL,1,NULL),(10529,'category',16,'bathroom/toilet/toilets/close-coupled-toilets.html','catalog/category/view/id/16',0,3,NULL,1,NULL),(10530,'category',17,'bathroom/toilet/toilets/back-to-wall-toilets.html','catalog/category/view/id/17',0,3,NULL,1,NULL),(10531,'category',18,'bathroom/toilet/toilets/wall-hung-toilets.html','catalog/category/view/id/18',0,3,NULL,1,NULL),(10532,'category',198,'bathroom/toilet/toilets/comfort-height-toilets.html','catalog/category/view/id/198',0,3,NULL,1,NULL),(10533,'category',199,'bathroom/toilet/toilets/rimless-toilets.html','catalog/category/view/id/199',0,3,NULL,1,NULL),(10534,'category',20,'bathroom/toilet/toilets/corner-toilets.html','catalog/category/view/id/20',0,3,NULL,1,NULL),(10535,'category',200,'bathroom/toilet/toilets/wc-unit.html','catalog/category/view/id/200',0,3,NULL,1,NULL),(10536,'category',201,'bathroom/toilet/toilets/smart-toilets.html','catalog/category/view/id/201',0,3,NULL,1,NULL),(10537,'category',202,'bathroom/toilet/toilets/doc-m-packs.html','catalog/category/view/id/202',0,3,NULL,1,NULL),(10538,'category',21,'bathroom/toilet/toilets/bidets.html','catalog/category/view/id/21',0,3,NULL,1,NULL),(10539,'category',22,'bathroom/toilet/toilets/urinals.html','catalog/category/view/id/22',0,3,NULL,1,NULL),(10540,'category',24,'bathroom/toilet/toilets/concealed-cisterns.html','catalog/category/view/id/24',0,3,NULL,1,NULL),(10541,'category',203,'bathroom/toilet/toilet-accessories.html','catalog/category/view/id/203',0,3,NULL,1,NULL),(10542,'category',187,'bathroom/toilet/toilet-accessories/toilet-roll-holders.html','catalog/category/view/id/187',0,3,NULL,1,NULL),(10543,'category',204,'bathroom/toilet/toilet-accessories/douche-shattafs.html','catalog/category/view/id/204',0,3,NULL,1,NULL),(10544,'category',205,'bathroom/toilet/toilet-accessories/flush-buttons-plates.html','catalog/category/view/id/205',0,3,NULL,1,NULL),(10545,'category',208,'bathroom/toilet/toilet-accessories/toilet-brush-and-holders.html','catalog/category/view/id/208',0,3,NULL,1,NULL),(10546,'category',23,'bathroom/toilet/toilet-accessories/toilet-seats.html','catalog/category/view/id/23',0,3,NULL,1,NULL),(10547,'category',209,'bathroom/toilet/brands.html','catalog/category/view/id/209',0,3,NULL,1,NULL),(10548,'category',210,'bathroom/toilet/brands/rak.html','catalog/category/view/id/210',0,3,NULL,1,NULL),(10549,'category',211,'bathroom/toilet/brands/geberit.html','catalog/category/view/id/211',0,3,NULL,1,NULL),(10550,'category',212,'bathroom/toilet/brands/grohe.html','catalog/category/view/id/212',0,3,NULL,1,NULL),(10551,'category',213,'bathroom/toilet/brands/hudson-reed.html','catalog/category/view/id/213',0,3,NULL,1,NULL),(10552,'category',214,'bathroom/toilet/brands/roca.html','catalog/category/view/id/214',0,3,NULL,1,NULL),(10553,'category',215,'bathroom/toilet/brands/vitra.html','catalog/category/view/id/215',0,3,NULL,1,NULL),(10554,'category',216,'bathroom/toilet/brands/nuie.html','catalog/category/view/id/216',0,3,NULL,1,NULL),(10555,'category',25,'bathroom/basins.html','catalog/category/view/id/25',0,3,NULL,1,NULL),(10556,'category',221,'bathroom/basins/basins.html','catalog/category/view/id/221',0,3,NULL,1,NULL),(10557,'category',222,'bathroom/basins/basins/semi-pedestal-basins.html','catalog/category/view/id/222',0,3,NULL,1,NULL),(10558,'category',223,'bathroom/basins/basins/space-saver-basins.html','catalog/category/view/id/223',0,3,NULL,1,NULL),(10559,'category',224,'bathroom/basins/basins/freestanding-basin.html','catalog/category/view/id/224',0,3,NULL,1,NULL),(10560,'category',225,'bathroom/basins/basins/washstands.html','catalog/category/view/id/225',0,3,NULL,1,NULL),(10561,'category',26,'bathroom/basins/basins/pedestal-basins.html','catalog/category/view/id/26',0,3,NULL,1,NULL),(10562,'category',27,'bathroom/basins/basins/wall-hung-basins.html','catalog/category/view/id/27',0,3,NULL,1,NULL),(10563,'category',28,'bathroom/basins/basins/corner-basins.html','catalog/category/view/id/28',0,3,NULL,1,NULL),(10564,'category',29,'bathroom/basins/basins/cloakroom-basins.html','catalog/category/view/id/29',0,3,NULL,1,NULL),(10565,'category',30,'bathroom/basins/basins/vanity-basins.html','catalog/category/view/id/30',0,3,NULL,1,NULL),(10566,'category',31,'bathroom/basins/basins/semi-recessed-basins.html','catalog/category/view/id/31',0,3,NULL,1,NULL),(10567,'category',32,'bathroom/basins/basins/under-counter-basins.html','catalog/category/view/id/32',0,3,NULL,1,NULL),(10568,'category',33,'bathroom/basins/basins/counter-top-basins.html','catalog/category/view/id/33',0,3,NULL,1,NULL),(10569,'category',34,'bathroom/basins/basins/sit-on-basins.html','catalog/category/view/id/34',0,3,NULL,1,NULL),(10570,'category',226,'bathroom/basins/accessories.html','catalog/category/view/id/226',0,3,NULL,1,NULL),(10571,'category',190,'bathroom/basins/accessories/soap-dishes.html','catalog/category/view/id/190',0,3,NULL,1,NULL),(10572,'category',227,'bathroom/basins/accessories/soap-dispenser.html','catalog/category/view/id/227',0,3,NULL,1,NULL),(10573,'category',229,'bathroom/basins/accessories/towel-rails.html','catalog/category/view/id/229',0,3,NULL,1,NULL),(10574,'category',35,'bathroom/basins/accessories/bottle-traps.html','catalog/category/view/id/35',0,3,NULL,1,NULL),(10575,'category',36,'bathroom/basins/accessories/basin-wastes.html','catalog/category/view/id/36',0,3,NULL,1,NULL),(10576,'category',60,'bathroom/basins/accessories/basin-frames.html','catalog/category/view/id/60',0,3,NULL,1,NULL),(10577,'category',230,'bathroom/basins/brands.html','catalog/category/view/id/230',0,3,NULL,1,NULL),(10578,'category',231,'bathroom/basins/brands/rak.html','catalog/category/view/id/231',0,3,NULL,1,NULL),(10579,'category',232,'bathroom/basins/brands/geberit.html','catalog/category/view/id/232',0,3,NULL,1,NULL),(10580,'category',233,'bathroom/basins/brands/grohe.html','catalog/category/view/id/233',0,3,NULL,1,NULL),(10581,'category',234,'bathroom/basins/brands/hudson-reed.html','catalog/category/view/id/234',0,3,NULL,1,NULL),(10582,'category',235,'bathroom/basins/brands/roca.html','catalog/category/view/id/235',0,3,NULL,1,NULL),(10583,'category',236,'bathroom/basins/brands/vitra.html','catalog/category/view/id/236',0,3,NULL,1,NULL),(10584,'category',237,'bathroom/basins/brands/nuie.html','catalog/category/view/id/237',0,3,NULL,1,NULL),(10585,'category',37,'bathroom/baths.html','catalog/category/view/id/37',0,3,NULL,1,NULL),(10586,'category',182,'bathroom/baths/bathroom-accessories.html','catalog/category/view/id/182',0,3,NULL,1,NULL),(10587,'category',183,'bathroom/baths/bathroom-accessories/towel-rings.html','catalog/category/view/id/183',0,3,NULL,1,NULL),(10588,'category',184,'bathroom/baths/bathroom-accessories/bathroom-fans.html','catalog/category/view/id/184',0,3,NULL,1,NULL),(10589,'category',185,'bathroom/baths/bathroom-accessories/robe-hooks.html','catalog/category/view/id/185',0,3,NULL,1,NULL),(10590,'category',186,'bathroom/baths/bathroom-accessories/wire-baskets.html','catalog/category/view/id/186',0,3,NULL,1,NULL),(10591,'category',188,'bathroom/baths/bathroom-accessories/shelves.html','catalog/category/view/id/188',0,3,NULL,1,NULL),(10592,'category',189,'bathroom/baths/bathroom-accessories/urinal-accessories.html','catalog/category/view/id/189',0,3,NULL,1,NULL),(10593,'category',258,'bathroom/baths/bathroom-accessories/bath-panels.html','catalog/category/view/id/258',0,3,NULL,1,NULL),(10594,'category',259,'bathroom/baths/bathroom-accessories/bath-legsets.html','catalog/category/view/id/259',0,3,NULL,1,NULL),(10595,'category',260,'bathroom/baths/bathroom-accessories/bath-grips.html','catalog/category/view/id/260',0,3,NULL,1,NULL),(10596,'category',261,'bathroom/baths/bathroom-accessories/miscellaneous.html','catalog/category/view/id/261',0,3,NULL,1,NULL),(10597,'category',44,'bathroom/baths/bathroom-accessories/bath-screens.html','catalog/category/view/id/44',0,3,NULL,1,NULL),(10598,'category',45,'bathroom/baths/bathroom-accessories/bath-wastes-and-drainer.html','catalog/category/view/id/45',0,3,NULL,1,NULL),(10599,'category',253,'bathroom/baths/baths.html','catalog/category/view/id/253',0,3,NULL,1,NULL),(10600,'category',254,'bathroom/baths/baths/single-ended-baths.html','catalog/category/view/id/254',0,3,NULL,1,NULL),(10601,'category',255,'bathroom/baths/baths/double-ended-baths.html','catalog/category/view/id/255',0,3,NULL,1,NULL),(10602,'category',256,'bathroom/baths/baths/rectangular-baths.html','catalog/category/view/id/256',0,3,NULL,1,NULL),(10603,'category',257,'bathroom/baths/baths/space-saving-baths.html','catalog/category/view/id/257',0,3,NULL,1,NULL),(10604,'category',38,'bathroom/baths/baths/straight-baths.html','catalog/category/view/id/38',0,3,NULL,1,NULL),(10605,'category',39,'bathroom/baths/baths/free-standing-baths.html','catalog/category/view/id/39',0,3,NULL,1,NULL),(10606,'category',40,'bathroom/baths/baths/corner-baths.html','catalog/category/view/id/40',0,3,NULL,1,NULL),(10607,'category',41,'bathroom/baths/baths/oval-baths.html','catalog/category/view/id/41',0,3,NULL,1,NULL),(10608,'category',42,'bathroom/baths/baths/shower-baths.html','catalog/category/view/id/42',0,3,NULL,1,NULL),(10609,'category',43,'bathroom/baths/baths/traditional-baths.html','catalog/category/view/id/43',0,3,NULL,1,NULL),(10610,'category',262,'bathroom/baths/bette.html','catalog/category/view/id/262',0,3,NULL,1,NULL),(10611,'category',263,'bathroom/baths/bette/bette.html','catalog/category/view/id/263',0,3,NULL,1,NULL),(10612,'category',264,'bathroom/baths/bette/geberit.html','catalog/category/view/id/264',0,3,NULL,1,NULL),(10613,'category',265,'bathroom/baths/bette/grohe.html','catalog/category/view/id/265',0,3,NULL,1,NULL),(10614,'category',266,'bathroom/baths/bette/hasngrohe.html','catalog/category/view/id/266',0,3,NULL,1,NULL),(10615,'category',267,'bathroom/baths/bette/hudson-reed.html','catalog/category/view/id/267',0,3,NULL,1,NULL),(10616,'category',268,'bathroom/baths/bette/ideal-standard.html','catalog/category/view/id/268',0,3,NULL,1,NULL),(10617,'category',269,'bathroom/baths/bette/matki-showers.html','catalog/category/view/id/269',0,3,NULL,1,NULL),(10618,'category',270,'bathroom/baths/bette/rak-ceramics.html','catalog/category/view/id/270',0,3,NULL,1,NULL),(10619,'category',271,'bathroom/baths/bette/roca.html','catalog/category/view/id/271',0,3,NULL,1,NULL),(10620,'category',272,'bathroom/baths/bette/royce-morgan.html','catalog/category/view/id/272',0,3,NULL,1,NULL),(10621,'category',273,'bathroom/baths/bette/vitra.html','catalog/category/view/id/273',0,3,NULL,1,NULL),(10622,'category',274,'bathroom/baths/bette/nuie.html','catalog/category/view/id/274',0,3,NULL,1,NULL),(10623,'category',275,'bathroom/baths/bette/kaldewei.html','catalog/category/view/id/275',0,3,NULL,1,NULL),(10624,'category',4,'bathroom/showering.html','catalog/category/view/id/4',0,3,NULL,1,NULL),(10625,'category',247,'bathroom/showering/brands.html','catalog/category/view/id/247',0,3,NULL,1,NULL),(10626,'category',248,'bathroom/showering/brands/matki.html','catalog/category/view/id/248',0,3,NULL,1,NULL),(10627,'category',249,'bathroom/showering/brands/nuei.html','catalog/category/view/id/249',0,3,NULL,1,NULL),(10628,'category',250,'bathroom/showering/brands/ideal-stnadard.html','catalog/category/view/id/250',0,3,NULL,1,NULL),(10629,'category',251,'bathroom/showering/brands/hudson-reed.html','catalog/category/view/id/251',0,3,NULL,1,NULL),(10630,'category',252,'bathroom/showering/brands/rak.html','catalog/category/view/id/252',0,3,NULL,1,NULL),(10631,'category',66,'bathroom/showering/shower-doors.html','catalog/category/view/id/66',0,3,NULL,1,NULL),(10632,'category',67,'bathroom/showering/shower-doors/pivot-doors.html','catalog/category/view/id/67',0,3,NULL,1,NULL),(10633,'category',68,'bathroom/showering/shower-doors/hinged-doors.html','catalog/category/view/id/68',0,3,NULL,1,NULL),(10634,'category',69,'bathroom/showering/shower-doors/sliding-doors.html','catalog/category/view/id/69',0,3,NULL,1,NULL),(10635,'category',70,'bathroom/showering/shower-doors/bi-fold-doors.html','catalog/category/view/id/70',0,3,NULL,1,NULL),(10636,'category',71,'bathroom/showering/shower-enclosures.html','catalog/category/view/id/71',0,3,NULL,1,NULL),(10637,'category',245,'bathroom/showering/shower-enclosures/curved-enclosures.html','catalog/category/view/id/245',0,3,NULL,1,NULL),(10638,'category',246,'bathroom/showering/shower-enclosures/3-sided-enclosures.html','catalog/category/view/id/246',0,3,NULL,1,NULL),(10639,'category',72,'bathroom/showering/shower-enclosures/pivot-enclosures.html','catalog/category/view/id/72',0,3,NULL,1,NULL),(10640,'category',73,'bathroom/showering/shower-enclosures/hinged-enclosures.html','catalog/category/view/id/73',0,3,NULL,1,NULL),(10641,'category',74,'bathroom/showering/shower-enclosures/sliding-enclosures.html','catalog/category/view/id/74',0,3,NULL,1,NULL),(10642,'category',75,'bathroom/showering/shower-enclosures/bi-fold-enclosures.html','catalog/category/view/id/75',0,3,NULL,1,NULL),(10643,'category',76,'bathroom/showering/shower-enclosures/d-shaped-enclosures.html','catalog/category/view/id/76',0,3,NULL,1,NULL),(10644,'category',77,'bathroom/showering/shower-enclosures/walk-in-showers.html','catalog/category/view/id/77',0,3,NULL,1,NULL),(10645,'category',78,'bathroom/showering/shower-enclosures/quadrant.html','catalog/category/view/id/78',0,3,NULL,1,NULL),(10646,'category',79,'bathroom/showering/shower-enclosures/pentagons.html','catalog/category/view/id/79',0,3,NULL,1,NULL),(10647,'category',80,'bathroom/showering/shower-enclosures/wet-rooms.html','catalog/category/view/id/80',0,3,NULL,1,NULL),(10648,'category',81,'bathroom/showering/shower-enclosures/corner-entry-enclosures.html','catalog/category/view/id/81',0,3,NULL,1,NULL),(10649,'category',82,'bathroom/showering/shower-trays.html','catalog/category/view/id/82',0,3,NULL,1,NULL),(10650,'category',83,'bathroom/showering/shower-trays/square-trays.html','catalog/category/view/id/83',0,3,NULL,1,NULL),(10651,'category',84,'bathroom/showering/shower-trays/rectangular-trays.html','catalog/category/view/id/84',0,3,NULL,1,NULL),(10652,'category',85,'bathroom/showering/shower-trays/quadrant-trays.html','catalog/category/view/id/85',0,3,NULL,1,NULL),(10653,'category',86,'bathroom/showering/shower-trays/pentagon-trays.html','catalog/category/view/id/86',0,3,NULL,1,NULL),(10654,'category',46,'bathroom/bathroom-furniture.html','catalog/category/view/id/46',0,3,NULL,1,NULL),(10655,'category',295,'bathroom/bathroom-furniture/bathroom-furniture.html','catalog/category/view/id/295',0,3,NULL,1,NULL),(10656,'category',296,'bathroom/bathroom-furniture/bathroom-furniture/corner-vanity-units.html','catalog/category/view/id/296',0,3,NULL,1,NULL),(10657,'category',297,'bathroom/bathroom-furniture/bathroom-furniture/double-sink-vanity-units.html','catalog/category/view/id/297',0,3,NULL,1,NULL),(10658,'category',298,'bathroom/bathroom-furniture/bathroom-furniture/countertop-vanity-units.html','catalog/category/view/id/298',0,3,NULL,1,NULL),(10659,'category',299,'bathroom/bathroom-furniture/bathroom-furniture/toilet-and-sink-units.html','catalog/category/view/id/299',0,3,NULL,1,NULL),(10660,'category',300,'bathroom/bathroom-furniture/bathroom-furniture/tall-bathroom-cabinets.html','catalog/category/view/id/300',0,3,NULL,1,NULL),(10661,'category',47,'bathroom/bathroom-furniture/bathroom-furniture/floor-standing-units.html','catalog/category/view/id/47',0,3,NULL,1,NULL),(10662,'category',48,'bathroom/bathroom-furniture/bathroom-furniture/wall-hung-units.html','catalog/category/view/id/48',0,3,NULL,1,NULL),(10663,'category',49,'bathroom/bathroom-furniture/bathroom-furniture/cloakroom-units.html','catalog/category/view/id/49',0,3,NULL,1,NULL),(10664,'category',50,'bathroom/bathroom-furniture/bathroom-furniture/wc-units.html','catalog/category/view/id/50',0,3,NULL,1,NULL),(10665,'category',301,'bathroom/bathroom-furniture/brands.html','catalog/category/view/id/301',0,3,NULL,1,NULL),(10666,'category',302,'bathroom/bathroom-furniture/brands/hudson-reed.html','catalog/category/view/id/302',0,3,NULL,1,NULL),(10667,'category',303,'bathroom/bathroom-furniture/brands/rak-ceramics.html','catalog/category/view/id/303',0,3,NULL,1,NULL),(10668,'category',304,'bathroom/bathroom-furniture/brands/roca.html','catalog/category/view/id/304',0,3,NULL,1,NULL),(10669,'category',305,'bathroom/bathroom-furniture/brands/vitra.html','catalog/category/view/id/305',0,3,NULL,1,NULL),(10670,'category',306,'bathroom/bathroom-furniture/brands/nuie.html','catalog/category/view/id/306',0,3,NULL,1,NULL),(10671,'category',51,'bathroom/bathroom-suites.html','catalog/category/view/id/51',0,3,NULL,1,NULL),(10672,'category',52,'bathroom/bathroom-suites/cloakroom-suites.html','catalog/category/view/id/52',0,3,NULL,1,NULL),(10673,'category',53,'bathroom/bathroom-suites/contemporary-suites.html','catalog/category/view/id/53',0,3,NULL,1,NULL),(10674,'category',54,'bathroom/mirrors-cabinets.html','catalog/category/view/id/54',0,3,NULL,1,NULL),(10675,'category',289,'bathroom/mirrors-cabinets/brands.html','catalog/category/view/id/289',0,3,NULL,1,NULL),(10676,'category',290,'bathroom/mirrors-cabinets/brands/hib.html','catalog/category/view/id/290',0,3,NULL,1,NULL),(10677,'category',291,'bathroom/mirrors-cabinets/brands/hudson-reed.html','catalog/category/view/id/291',0,3,NULL,1,NULL),(10678,'category',292,'bathroom/mirrors-cabinets/brands/rak-ceramics.html','catalog/category/view/id/292',0,3,NULL,1,NULL),(10679,'category',293,'bathroom/mirrors-cabinets/brands/roca.html','catalog/category/view/id/293',0,3,NULL,1,NULL),(10680,'category',294,'bathroom/mirrors-cabinets/brands/nuie.html','catalog/category/view/id/294',0,3,NULL,1,NULL),(10681,'category',55,'bathroom/mirrors-cabinets/mirrors.html','catalog/category/view/id/55',0,3,NULL,1,NULL),(10682,'category',283,'bathroom/mirrors-cabinets/mirrors/standard-mirrors.html','catalog/category/view/id/283',0,3,NULL,1,NULL),(10683,'category',284,'bathroom/mirrors-cabinets/mirrors/led-mirrors.html','catalog/category/view/id/284',0,3,NULL,1,NULL),(10684,'category',285,'bathroom/mirrors-cabinets/mirrors/backlit-mirrors.html','catalog/category/view/id/285',0,3,NULL,1,NULL),(10685,'category',286,'bathroom/mirrors-cabinets/mirrors/demister-mirrors.html','catalog/category/view/id/286',0,3,NULL,1,NULL),(10686,'category',287,'bathroom/mirrors-cabinets/mirrors/magnifying-mirrors.html','catalog/category/view/id/287',0,3,NULL,1,NULL),(10687,'category',288,'bathroom/mirrors-cabinets/mirrors/smart-mirrors.html','catalog/category/view/id/288',0,3,NULL,1,NULL),(10688,'category',56,'bathroom/mirrors-cabinets/mirror-cabinets.html','catalog/category/view/id/56',0,3,NULL,1,NULL),(10689,'category',57,'bathroom/frames-plates.html','catalog/category/view/id/57',0,3,NULL,1,NULL),(10690,'category',58,'bathroom/frames-plates/bidet-frames.html','catalog/category/view/id/58',0,3,NULL,1,NULL),(10691,'category',59,'bathroom/frames-plates/toilet-frames.html','catalog/category/view/id/59',0,3,NULL,1,NULL),(10692,'category',61,'bathroom/frames-plates/plates.html','catalog/category/view/id/61',0,3,NULL,1,NULL),(10693,'category',62,'bathroom/pvc-panels.html','catalog/category/view/id/62',0,3,NULL,1,NULL),(10694,'category',63,'bathroom/pvc-panels/ceiling-panels.html','catalog/category/view/id/63',0,3,NULL,1,NULL),(10695,'category',64,'bathroom/pvc-panels/wall-splash-panels.html','catalog/category/view/id/64',0,3,NULL,1,NULL),(10696,'category',65,'bathroom/pvc-panels/pvc-trims.html','catalog/category/view/id/65',0,3,NULL,1,NULL),(10697,'category',8,'bathroom/taps.html','catalog/category/view/id/8',0,3,NULL,1,NULL),(10698,'category',150,'bathroom/taps/bathroom-taps.html','catalog/category/view/id/150',0,3,NULL,1,NULL),(10699,'category',152,'bathroom/taps/bath-taps.html','catalog/category/view/id/152',0,3,NULL,1,NULL),(10700,'category',153,'bathroom/taps/bath-taps/single-bath-taps.html','catalog/category/view/id/153',0,3,NULL,1,NULL),(10701,'category',154,'bathroom/taps/bath-taps/mixer-taps.html','catalog/category/view/id/154',0,3,NULL,1,NULL),(10702,'category',155,'bathroom/taps/bath-taps/wall-hung-taps.html','catalog/category/view/id/155',0,3,NULL,1,NULL),(10703,'category',156,'bathroom/taps/bath-taps/free-standing-taps.html','catalog/category/view/id/156',0,3,NULL,1,NULL),(10704,'category',157,'bathroom/taps/bath-taps/bath-spouts.html','catalog/category/view/id/157',0,3,NULL,1,NULL),(10705,'category',158,'bathroom/taps/bath-taps/bath-filler.html','catalog/category/view/id/158',0,3,NULL,1,NULL),(10706,'category',279,'bathroom/taps/bath-taps/bath-tap-pairs.html','catalog/category/view/id/279',0,3,NULL,1,NULL),(10707,'category',280,'bathroom/taps/bath-taps/deck-mounted-taps.html','catalog/category/view/id/280',0,3,NULL,1,NULL),(10708,'category',282,'bathroom/taps/bath-taps/bath-basin-tap-sets.html','catalog/category/view/id/282',0,3,NULL,1,NULL),(10709,'category',159,'bathroom/taps/basin-taps.html','catalog/category/view/id/159',0,3,NULL,1,NULL),(10710,'category',151,'bathroom/taps/basin-taps/bidet-mixers.html','catalog/category/view/id/151',0,3,NULL,1,NULL),(10711,'category',160,'bathroom/taps/basin-taps/basin-mixer-taps.html','catalog/category/view/id/160',0,3,NULL,1,NULL),(10712,'category',161,'bathroom/taps/basin-taps/wall-hung-tap.html','catalog/category/view/id/161',0,3,NULL,1,NULL),(10713,'category',162,'bathroom/taps/basin-taps/sensor-tap.html','catalog/category/view/id/162',0,3,NULL,1,NULL),(10714,'category',276,'bathroom/taps/basin-taps/high-rise-basin-taps.html','catalog/category/view/id/276',0,3,NULL,1,NULL),(10715,'category',277,'bathroom/taps/basin-taps/basin-tap-pairs.html','catalog/category/view/id/277',0,3,NULL,1,NULL),(10716,'category',278,'bathroom/taps/basin-taps/bath-basin-tap-sets.html','catalog/category/view/id/278',0,3,NULL,1,NULL),(10717,'category',9,'bathroom/shower-valves.html','catalog/category/view/id/9',0,3,NULL,1,NULL),(10718,'category',165,'bathroom/shower-valves/all-showers.html','catalog/category/view/id/165',0,3,NULL,1,NULL),(10719,'category',166,'bathroom/shower-valves/all-showers/full-showers.html','catalog/category/view/id/166',0,3,NULL,1,NULL),(10720,'category',167,'bathroom/shower-valves/all-showers/shower-panels.html','catalog/category/view/id/167',0,3,NULL,1,NULL),(10721,'category',168,'bathroom/shower-valves/all-showers/electric-showers.html','catalog/category/view/id/168',0,3,NULL,1,NULL),(10722,'category',176,'bathroom/shower-valves/all-showers/slider-kits.html','catalog/category/view/id/176',0,3,NULL,1,NULL),(10723,'category',238,'bathroom/shower-valves/all-showers/shower-head-with-arm.html','catalog/category/view/id/238',0,3,NULL,1,NULL),(10724,'category',169,'bathroom/shower-valves/accessories.html','catalog/category/view/id/169',0,3,NULL,1,NULL),(10725,'category',175,'bathroom/shower-valves/accessories/hand-showers.html','catalog/category/view/id/175',0,3,NULL,1,NULL),(10726,'category',177,'bathroom/shower-valves/accessories/shower-heads.html','catalog/category/view/id/177',0,3,NULL,1,NULL),(10727,'category',178,'bathroom/shower-valves/accessories/shower-arms.html','catalog/category/view/id/178',0,3,NULL,1,NULL),(10728,'category',179,'bathroom/shower-valves/accessories/body-jets.html','catalog/category/view/id/179',0,3,NULL,1,NULL),(10729,'category',180,'bathroom/shower-valves/accessories/shower-hose.html','catalog/category/view/id/180',0,3,NULL,1,NULL),(10730,'category',181,'bathroom/shower-valves/accessories/accessories.html','catalog/category/view/id/181',0,3,NULL,1,NULL),(10731,'category',170,'bathroom/shower-valves/valves.html','catalog/category/view/id/170',0,3,NULL,1,NULL),(10732,'category',171,'bathroom/shower-valves/valves/exposed-valves.html','catalog/category/view/id/171',0,3,NULL,1,NULL),(10733,'category',172,'bathroom/shower-valves/valves/concealed-valves.html','catalog/category/view/id/172',0,3,NULL,1,NULL),(10734,'category',173,'bathroom/shower-valves/valves/thermostatic-valves.html','catalog/category/view/id/173',0,3,NULL,1,NULL),(10735,'category',174,'bathroom/shower-valves/valves/traditional-valves.html','catalog/category/view/id/174',0,3,NULL,1,NULL),(10736,'category',239,'bathroom/shower-valves/valves/bar-valves.html','catalog/category/view/id/239',0,3,NULL,1,NULL),(10737,'category',240,'bathroom/shower-valves/brands.html','catalog/category/view/id/240',0,3,NULL,1,NULL),(10738,'category',241,'bathroom/shower-valves/brands/hansgrohe.html','catalog/category/view/id/241',0,3,NULL,1,NULL),(10739,'category',242,'bathroom/shower-valves/brands/grohe.html','catalog/category/view/id/242',0,3,NULL,1,NULL),(10740,'category',243,'bathroom/shower-valves/brands/nuei.html','catalog/category/view/id/243',0,3,NULL,1,NULL),(10741,'category',244,'bathroom/shower-valves/brands/hudson-reed.html','catalog/category/view/id/244',0,3,NULL,1,NULL),(10742,'category',5,'kitchen-appliances.html','catalog/category/view/id/5',0,3,NULL,1,NULL),(10743,'category',145,'kitchen-appliances/kitchen-taps.html','catalog/category/view/id/145',0,3,NULL,1,NULL),(10744,'category',146,'kitchen-appliances/kitchen-taps/kitchen-sink-taps.html','catalog/category/view/id/146',0,3,NULL,1,NULL),(10745,'category',149,'kitchen-appliances/kitchen-taps/sensor-taps.html','catalog/category/view/id/149',0,3,NULL,1,NULL),(10746,'category',329,'kitchen-appliances/kitchen-taps/kitchen-tap-type.html','catalog/category/view/id/329',0,3,NULL,1,NULL),(10747,'category',147,'kitchen-appliances/kitchen-taps/kitchen-tap-type/instant-hot-water-taps.html','catalog/category/view/id/147',0,3,NULL,1,NULL),(10748,'category',148,'kitchen-appliances/kitchen-taps/kitchen-tap-type/filter-flow-taps.html','catalog/category/view/id/148',0,3,NULL,1,NULL),(10749,'category',330,'kitchen-appliances/kitchen-taps/kitchen-tap-type/kitchen-mixer-taps.html','catalog/category/view/id/330',0,3,NULL,1,NULL),(10750,'category',331,'kitchen-appliances/kitchen-taps/kitchen-tap-type/pull-out-kitchen-taps.html','catalog/category/view/id/331',0,3,NULL,1,NULL),(10751,'category',332,'kitchen-appliances/kitchen-taps/kitchen-tap-type/coloured-kitchen-taps.html','catalog/category/view/id/332',0,3,NULL,1,NULL),(10752,'category',335,'kitchen-appliances/kitchen-taps/kitchen-tap-type/sparkling-water-taps.html','catalog/category/view/id/335',0,3,NULL,1,NULL),(10753,'category',336,'kitchen-appliances/kitchen-taps/kitchen-tap-type/smart-taps.html','catalog/category/view/id/336',0,3,NULL,1,NULL),(10754,'category',337,'kitchen-appliances/kitchen-taps/brands.html','catalog/category/view/id/337',0,3,NULL,1,NULL),(10755,'category',338,'kitchen-appliances/kitchen-taps/brands/franke.html','catalog/category/view/id/338',0,3,NULL,1,NULL),(10756,'category',339,'kitchen-appliances/kitchen-taps/brands/blanco.html','catalog/category/view/id/339',0,3,NULL,1,NULL),(10757,'category',340,'kitchen-appliances/kitchen-taps/brands/reginox.html','catalog/category/view/id/340',0,3,NULL,1,NULL),(10758,'category',341,'kitchen-appliances/kitchen-taps/brands/grohe.html','catalog/category/view/id/341',0,3,NULL,1,NULL),(10759,'category',342,'kitchen-appliances/kitchen-taps/brands/hansgrohe.html','catalog/category/view/id/342',0,3,NULL,1,NULL),(10760,'category',344,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories.html','catalog/category/view/id/344',0,3,NULL,1,NULL),(10761,'category',345,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/soap-dispensors.html','catalog/category/view/id/345',0,3,NULL,1,NULL),(10762,'category',346,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/filters.html','catalog/category/view/id/346',0,3,NULL,1,NULL),(10763,'category',347,'kitchen-appliances/kitchen-taps/kitchen-tap-accessories/hot-water-tanks.html','catalog/category/view/id/347',0,3,NULL,1,NULL),(10764,'category',318,'kitchen-appliances/kitchen-sinks.html','catalog/category/view/id/318',0,3,NULL,1,NULL),(10765,'category',106,'kitchen-appliances/kitchen-sinks/sink-type.html','catalog/category/view/id/106',0,3,NULL,1,NULL),(10766,'category',107,'kitchen-appliances/kitchen-sinks/sink-type/full-sinks.html','catalog/category/view/id/107',0,3,NULL,1,NULL),(10767,'category',109,'kitchen-appliances/kitchen-sinks/sink-type/sink-tap-packages.html','catalog/category/view/id/109',0,3,NULL,1,NULL),(10768,'category',307,'kitchen-appliances/kitchen-sinks/sink-type/undermount.html','catalog/category/view/id/307',0,3,NULL,1,NULL),(10769,'category',308,'kitchen-appliances/kitchen-sinks/sink-type/inset-flushmount.html','catalog/category/view/id/308',0,3,NULL,1,NULL),(10770,'category',309,'kitchen-appliances/kitchen-sinks/sink-type/1-0-bowl-sinks.html','catalog/category/view/id/309',0,3,NULL,1,NULL),(10771,'category',310,'kitchen-appliances/kitchen-sinks/sink-type/1-5-bowl-sinks.html','catalog/category/view/id/310',0,3,NULL,1,NULL),(10772,'category',311,'kitchen-appliances/kitchen-sinks/sink-type/2-0-bowl-sinks.html','catalog/category/view/id/311',0,3,NULL,1,NULL),(10773,'category',312,'kitchen-appliances/kitchen-sinks/sink-type/belfast-sinks.html','catalog/category/view/id/312',0,3,NULL,1,NULL),(10774,'category',313,'kitchen-appliances/kitchen-sinks/sink-material.html','catalog/category/view/id/313',0,3,NULL,1,NULL),(10775,'category',108,'kitchen-appliances/kitchen-sinks/sink-material/stainless-steel-sinks.html','catalog/category/view/id/108',0,3,NULL,1,NULL),(10776,'category',314,'kitchen-appliances/kitchen-sinks/sink-material/ceramic-sinks.html','catalog/category/view/id/314',0,3,NULL,1,NULL),(10777,'category',315,'kitchen-appliances/kitchen-sinks/sink-material/granite-sinks.html','catalog/category/view/id/315',0,3,NULL,1,NULL),(10778,'category',316,'kitchen-appliances/kitchen-sinks/sink-material/composite-sinks.html','catalog/category/view/id/316',0,3,NULL,1,NULL),(10779,'category',317,'kitchen-appliances/kitchen-sinks/sink-material/coloured-sinks.html','catalog/category/view/id/317',0,3,NULL,1,NULL),(10780,'category',319,'kitchen-appliances/kitchen-sinks/accessories.html','catalog/category/view/id/319',0,3,NULL,1,NULL),(10781,'category',110,'kitchen-appliances/kitchen-sinks/accessories/kitchen-accessories.html','catalog/category/view/id/110',0,3,NULL,1,NULL),(10782,'category',321,'kitchen-appliances/kitchen-sinks/accessories/waster-sorter.html','catalog/category/view/id/321',0,3,NULL,1,NULL),(10783,'category',322,'kitchen-appliances/kitchen-sinks/accessories/plumbing-kits.html','catalog/category/view/id/322',0,3,NULL,1,NULL),(10784,'category',323,'kitchen-appliances/kitchen-sinks/brands.html','catalog/category/view/id/323',0,3,NULL,1,NULL),(10785,'category',324,'kitchen-appliances/kitchen-sinks/brands/franke.html','catalog/category/view/id/324',0,3,NULL,1,NULL),(10786,'category',325,'kitchen-appliances/kitchen-sinks/brands/reginox.html','catalog/category/view/id/325',0,3,NULL,1,NULL),(10787,'category',326,'kitchen-appliances/kitchen-sinks/brands/blanco.html','catalog/category/view/id/326',0,3,NULL,1,NULL),(10788,'category',327,'kitchen-appliances/kitchen-sinks/brands/grohe.html','catalog/category/view/id/327',0,3,NULL,1,NULL),(10789,'category',328,'kitchen-appliances/kitchen-sinks/brands/hansgrohe.html','catalog/category/view/id/328',0,3,NULL,1,NULL),(10790,'category',343,'kitchen-appliances/appliances.html','catalog/category/view/id/343',0,3,NULL,1,NULL),(10791,'category',100,'kitchen-appliances/appliances/fridges-freezers.html','catalog/category/view/id/100',0,3,NULL,1,NULL),(10792,'category',101,'kitchen-appliances/appliances/fridges-freezers/fridges-freezers.html','catalog/category/view/id/101',0,3,NULL,1,NULL),(10793,'category',102,'kitchen-appliances/appliances/fridges-freezers/fridges.html','catalog/category/view/id/102',0,3,NULL,1,NULL),(10794,'category',103,'kitchen-appliances/appliances/fridges-freezers/freezers.html','catalog/category/view/id/103',0,3,NULL,1,NULL),(10795,'category',104,'kitchen-appliances/appliances/fridges-freezers/wine-coolers.html','catalog/category/view/id/104',0,3,NULL,1,NULL),(10796,'category',105,'kitchen-appliances/appliances/fridges-freezers/american-style-fridge-freezers.html','catalog/category/view/id/105',0,3,NULL,1,NULL),(10797,'category',348,'kitchen-appliances/appliances/accessories.html','catalog/category/view/id/348',0,3,NULL,1,NULL),(10798,'category',349,'kitchen-appliances/appliances/accessories/accessories.html','catalog/category/view/id/349',0,3,NULL,1,NULL),(10799,'category',350,'kitchen-appliances/appliances/brands.html','catalog/category/view/id/350',0,3,NULL,1,NULL),(10800,'category',351,'kitchen-appliances/appliances/brands/bosch.html','catalog/category/view/id/351',0,3,NULL,1,NULL),(10801,'category',352,'kitchen-appliances/appliances/brands/neff.html','catalog/category/view/id/352',0,3,NULL,1,NULL),(10802,'category',353,'kitchen-appliances/appliances/brands/siemens.html','catalog/category/view/id/353',0,3,NULL,1,NULL),(10803,'category',354,'kitchen-appliances/appliances/brands/franke.html','catalog/category/view/id/354',0,3,NULL,1,NULL),(10804,'category',355,'kitchen-appliances/appliances/brands/elica.html','catalog/category/view/id/355',0,3,NULL,1,NULL),(10805,'category',87,'kitchen-appliances/appliances/cooking-baking.html','catalog/category/view/id/87',0,3,NULL,1,NULL),(10806,'category',88,'kitchen-appliances/appliances/cooking-baking/ovens.html','catalog/category/view/id/88',0,3,NULL,1,NULL),(10807,'category',89,'kitchen-appliances/appliances/cooking-baking/hobs.html','catalog/category/view/id/89',0,3,NULL,1,NULL),(10808,'category',90,'kitchen-appliances/appliances/cooking-baking/steam-appliances.html','catalog/category/view/id/90',0,3,NULL,1,NULL),(10809,'category',91,'kitchen-appliances/appliances/cooking-baking/microwaves.html','catalog/category/view/id/91',0,3,NULL,1,NULL),(10810,'category',92,'kitchen-appliances/appliances/cooking-baking/coffee-machine.html','catalog/category/view/id/92',0,3,NULL,1,NULL),(10811,'category',93,'kitchen-appliances/appliances/cooking-baking/cooker-hoods.html','catalog/category/view/id/93',0,3,NULL,1,NULL),(10812,'category',94,'kitchen-appliances/appliances/cooking-baking/warming-drawers.html','catalog/category/view/id/94',0,3,NULL,1,NULL),(10813,'category',95,'kitchen-appliances/appliances/cooking-baking/cooking-accessories.html','catalog/category/view/id/95',0,3,NULL,1,NULL),(10814,'category',96,'kitchen-appliances/appliances/washers-dryers.html','catalog/category/view/id/96',0,3,NULL,1,NULL),(10815,'category',97,'kitchen-appliances/appliances/washers-dryers/washing-machines.html','catalog/category/view/id/97',0,3,NULL,1,NULL),(10816,'category',98,'kitchen-appliances/appliances/dishwashers.html','catalog/category/view/id/98',0,3,NULL,1,NULL),(10817,'category',99,'kitchen-appliances/appliances/dishwashers/built-in-dishwashers.html','catalog/category/view/id/99',0,3,NULL,1,NULL),(10818,'category',356,'kitchen-appliances/kitchen-accessories.html','catalog/category/view/id/356',0,3,NULL,1,NULL),(10819,'category',358,'kitchen-appliances/kitchen-accessories/accessories.html','catalog/category/view/id/358',0,3,NULL,1,NULL),(10820,'category',359,'kitchen-appliances/kitchen-accessories/accessories/soap-dispensors.html','catalog/category/view/id/359',0,3,NULL,1,NULL),(10821,'category',360,'kitchen-appliances/kitchen-accessories/accessories/chopping-boards.html','catalog/category/view/id/360',0,3,NULL,1,NULL),(10822,'category',361,'kitchen-appliances/kitchen-accessories/accessories/strainers.html','catalog/category/view/id/361',0,3,NULL,1,NULL),(10823,'category',362,'kitchen-appliances/kitchen-accessories/accessories/colanders.html','catalog/category/view/id/362',0,3,NULL,1,NULL),(10824,'category',363,'kitchen-appliances/kitchen-accessories/accessories/metal-grids.html','catalog/category/view/id/363',0,3,NULL,1,NULL),(10825,'category',364,'kitchen-appliances/kitchen-accessories/accessories/cleaning-sprays.html','catalog/category/view/id/364',0,3,NULL,1,NULL),(10826,'category',365,'kitchen-appliances/kitchen-accessories/accessories/waste-and-plumbing-kits.html','catalog/category/view/id/365',0,3,NULL,1,NULL),(10827,'category',7,'heating.html','catalog/category/view/id/7',0,3,NULL,1,NULL),(10828,'category',366,'heating/radiators.html','catalog/category/view/id/366',0,3,NULL,1,NULL),(10829,'category',142,'heating/radiators/towel-rails.html','catalog/category/view/id/142',0,3,NULL,1,NULL),(10830,'category',143,'heating/radiators/towel-rails/heated-towel-rails.html','catalog/category/view/id/143',0,3,NULL,1,NULL),(10831,'category',144,'heating/radiators/towel-rails/electric-towel-rails.html','catalog/category/view/id/144',0,3,NULL,1,NULL),(10832,'category',371,'heating/radiators/towel-rails/dual-fuel-towel-rails.html','catalog/category/view/id/371',0,3,NULL,1,NULL),(10833,'category',367,'heating/radiators/radiators.html','catalog/category/view/id/367',0,3,NULL,1,NULL),(10834,'category',135,'heating/radiators/radiators/designer-radiators.html','catalog/category/view/id/135',0,3,NULL,1,NULL),(10835,'category',136,'heating/radiators/radiators/vertical-designer-radiators.html','catalog/category/view/id/136',0,3,NULL,1,NULL),(10836,'category',137,'heating/radiators/radiators/horizontal-designer-radiators.html','catalog/category/view/id/137',0,3,NULL,1,NULL),(10837,'category',138,'heating/radiators/radiators/traditional-radiators.html','catalog/category/view/id/138',0,3,NULL,1,NULL),(10838,'category',139,'heating/radiators/radiators/electric-radiators.html','catalog/category/view/id/139',0,3,NULL,1,NULL),(10839,'category',140,'heating/radiators/radiators/radiator-valves.html','catalog/category/view/id/140',0,3,NULL,1,NULL),(10840,'category',141,'heating/radiators/radiators/heating-elements.html','catalog/category/view/id/141',0,3,NULL,1,NULL),(10841,'category',368,'heating/radiators/radiators/column-radiators.html','catalog/category/view/id/368',0,3,NULL,1,NULL),(10842,'category',369,'heating/radiators/radiators/convector-radiators.html','catalog/category/view/id/369',0,3,NULL,1,NULL),(10843,'category',370,'heating/radiators/radiators/floor-standing-radiators.html','catalog/category/view/id/370',0,3,NULL,1,NULL),(10844,'category',372,'heating/radiators/brands.html','catalog/category/view/id/372',0,3,NULL,1,NULL),(10845,'category',373,'heating/radiators/brands/nuie.html','catalog/category/view/id/373',0,3,NULL,1,NULL),(10846,'category',374,'heating/radiators/brands/hudson-reed.html','catalog/category/view/id/374',0,3,NULL,1,NULL),(10847,'category',375,'heating/radiators/brands/carisa.html','catalog/category/view/id/375',0,3,NULL,1,NULL),(10848,'category',376,'heating/radiators/brands/zehnder.html','catalog/category/view/id/376',0,3,NULL,1,NULL),(10849,'category',377,'heating/radiators/brands/reina.html','catalog/category/view/id/377',0,3,NULL,1,NULL),(10850,'category',6,'heating/fires.html','catalog/category/view/id/6',0,3,NULL,1,NULL),(10851,'category',111,'heating/fires/gas-fires.html','catalog/category/view/id/111',0,3,NULL,1,NULL),(10852,'category',112,'heating/fires/gas-fires/front-view-gas-fires.html','catalog/category/view/id/112',0,3,NULL,1,NULL),(10853,'category',113,'heating/fires/gas-fires/corner-gas-fires.html','catalog/category/view/id/113',0,3,NULL,1,NULL),(10854,'category',114,'heating/fires/gas-fires/three-sided-gas-fires.html','catalog/category/view/id/114',0,3,NULL,1,NULL),(10855,'category',115,'heating/fires/gas-fires/tunnel-gas-fires.html','catalog/category/view/id/115',0,3,NULL,1,NULL),(10856,'category',116,'heating/fires/gas-fires/heaters.html','catalog/category/view/id/116',0,3,NULL,1,NULL),(10857,'category',117,'heating/fires/gas-fires/hole-in-the-wall-gas-fires.html','catalog/category/view/id/117',0,3,NULL,1,NULL),(10858,'category',118,'heating/fires/gas-fires/high-efficiency-gas-fires.html','catalog/category/view/id/118',0,3,NULL,1,NULL),(10859,'category',119,'heating/fires/gas-fires/glass-fronted-gas-fire.html','catalog/category/view/id/119',0,3,NULL,1,NULL),(10860,'category',120,'heating/fires/gas-fires/inset-gas-fires.html','catalog/category/view/id/120',0,3,NULL,1,NULL),(10861,'category',121,'heating/fires/gas-fires/wall-mounted-gas-fires.html','catalog/category/view/id/121',0,3,NULL,1,NULL),(10862,'category',122,'heating/fires/gas-fires/balanced-flue-gas-fires.html','catalog/category/view/id/122',0,3,NULL,1,NULL),(10863,'category',123,'heating/fires/gas-fires/flueless-gas-fires.html','catalog/category/view/id/123',0,3,NULL,1,NULL),(10864,'category',378,'heating/fires/gas-fires/floor-standing-fires.html','catalog/category/view/id/378',0,3,NULL,1,NULL),(10865,'category',379,'heating/fires/gas-fires/top-control-side-control-gas-fires.html','catalog/category/view/id/379',0,3,NULL,1,NULL),(10866,'category',380,'heating/fires/gas-fires/outdoor-gas-fires.html','catalog/category/view/id/380',0,3,NULL,1,NULL),(10867,'category',124,'heating/fires/stoves.html','catalog/category/view/id/124',0,3,NULL,1,NULL),(10868,'category',125,'heating/fires/stoves/wood-multifuel-stoves.html','catalog/category/view/id/125',0,3,NULL,1,NULL),(10869,'category',126,'heating/fires/stoves/electric-stoves.html','catalog/category/view/id/126',0,3,NULL,1,NULL),(10870,'category',127,'heating/fires/stoves/wood-burning-stoves.html','catalog/category/view/id/127',0,3,NULL,1,NULL),(10871,'category',128,'heating/fires/stoves/gas-stoves.html','catalog/category/view/id/128',0,3,NULL,1,NULL),(10872,'category',383,'heating/fires/stoves/flueless-gas-stoves.html','catalog/category/view/id/383',0,3,NULL,1,NULL),(10873,'category',384,'heating/fires/stoves/inset-gas-stoves.html','catalog/category/view/id/384',0,3,NULL,1,NULL),(10874,'category',129,'heating/fires/electric-fires.html','catalog/category/view/id/129',0,3,NULL,1,NULL),(10875,'category',130,'heating/fires/electric-fires/inset-electric-fires.html','catalog/category/view/id/130',0,3,NULL,1,NULL),(10876,'category',132,'heating/fires/electric-fires/wall-mounted-electric-fires.html','catalog/category/view/id/132',0,3,NULL,1,NULL),(10877,'category',133,'heating/fires/electric-fires/electric-fires-and-surrounds.html','catalog/category/view/id/133',0,3,NULL,1,NULL),(10878,'category',381,'heating/fires/electric-fires/floor-standing-electric-fires.html','catalog/category/view/id/381',0,3,NULL,1,NULL),(10879,'category',382,'heating/fires/electric-fires/hole-in-the-wall-electric-fires.html','catalog/category/view/id/382',0,3,NULL,1,NULL),(10880,'category',134,'heating/fires/fires-accessories.html','catalog/category/view/id/134',0,3,NULL,1,NULL),(10881,'category',385,'heating/fires/fireplase-suite.html','catalog/category/view/id/385',0,3,NULL,1,NULL),(10882,'category',386,'heating/fires/fireplase-suite/gas-fireplaces.html','catalog/category/view/id/386',0,3,NULL,1,NULL),(10883,'category',387,'heating/fires/fireplase-suite/electric-fireplaces.html','catalog/category/view/id/387',0,3,NULL,1,NULL),(10884,'category',445,'heating/fires/fireplase-suite/wood-burning-fireplace.html','catalog/category/view/id/445',0,3,NULL,1,NULL),(10885,'category',388,'heating/fires/media-wall-electric-fires.html','catalog/category/view/id/388',0,3,NULL,1,NULL),(10886,'category',389,'heating/fires/media-wall-electric-fires/media-wall-electric-fires.html','catalog/category/view/id/389',0,3,NULL,1,NULL),(10887,'category',390,'heating/fires/brands.html','catalog/category/view/id/390',0,3,NULL,1,NULL),(10888,'category',391,'heating/fires/brands/ag-stoves.html','catalog/category/view/id/391',0,3,NULL,1,NULL),(10889,'category',392,'heating/fires/brands/dik-guerts.html','catalog/category/view/id/392',0,3,NULL,1,NULL),(10890,'category',393,'heating/fires/brands/dimplex.html','catalog/category/view/id/393',0,3,NULL,1,NULL),(10891,'category',394,'heating/fires/brands/dru.html','catalog/category/view/id/394',0,3,NULL,1,NULL),(10892,'category',395,'heating/fires/brands/ekofires.html','catalog/category/view/id/395',0,3,NULL,1,NULL),(10893,'category',396,'heating/fires/brands/element-4.html','catalog/category/view/id/396',0,3,NULL,1,NULL),(10894,'category',397,'heating/fires/brands/esse.html','catalog/category/view/id/397',0,3,NULL,1,NULL),(10895,'category',398,'heating/fires/brands/evonice-fires.html','catalog/category/view/id/398',0,3,NULL,1,NULL),(10896,'category',399,'heating/fires/brands/carron-fires.html','catalog/category/view/id/399',0,3,NULL,1,NULL),(10897,'category',400,'heating/fires/brands/flamerite-fires.html','catalog/category/view/id/400',0,3,NULL,1,NULL),(10898,'category',401,'heating/fires/brands/flavel.html','catalog/category/view/id/401',0,3,NULL,1,NULL),(10899,'category',402,'heating/fires/brands/valor.html','catalog/category/view/id/402',0,3,NULL,1,NULL),(10900,'category',403,'heating/fires/brands/gazco.html','catalog/category/view/id/403',0,3,NULL,1,NULL),(10901,'category',12,'brands.html','catalog/category/view/id/12',0,3,NULL,1,NULL),(10902,'category',404,'brands/a-d.html','catalog/category/view/id/404',0,3,NULL,1,NULL),(10903,'category',405,'brands/a-d/aga-stoves.html','catalog/category/view/id/405',0,3,NULL,1,NULL),(10904,'category',406,'brands/a-d/bette.html','catalog/category/view/id/406',0,3,NULL,1,NULL),(10905,'category',407,'brands/a-d/blanco.html','catalog/category/view/id/407',0,3,NULL,1,NULL),(10906,'category',408,'brands/a-d/carisa.html','catalog/category/view/id/408',0,3,NULL,1,NULL),(10907,'category',409,'brands/a-d/dik-guerts.html','catalog/category/view/id/409',0,3,NULL,1,NULL),(10908,'category',410,'brands/a-d/dimplex.html','catalog/category/view/id/410',0,3,NULL,1,NULL),(10909,'category',411,'brands/a-d/dru.html','catalog/category/view/id/411',0,3,NULL,1,NULL),(10910,'category',444,'brands/a-d/aeon.html','catalog/category/view/id/444',0,3,NULL,1,NULL),(10911,'category',412,'brands/e-i.html','catalog/category/view/id/412',0,3,NULL,1,NULL),(10912,'category',413,'brands/e-i/ekofires.html','catalog/category/view/id/413',0,3,NULL,1,NULL),(10913,'category',414,'brands/e-i/element-4.html','catalog/category/view/id/414',0,3,NULL,1,NULL),(10914,'category',415,'brands/e-i/elica.html','catalog/category/view/id/415',0,3,NULL,1,NULL),(10915,'category',416,'brands/e-i/esse.html','catalog/category/view/id/416',0,3,NULL,1,NULL),(10916,'category',417,'brands/e-i/evonic-fires.html','catalog/category/view/id/417',0,3,NULL,1,NULL),(10917,'category',418,'brands/e-i/flamerite-fires.html','catalog/category/view/id/418',0,3,NULL,1,NULL),(10918,'category',419,'brands/e-i/flavel.html','catalog/category/view/id/419',0,3,NULL,1,NULL),(10919,'category',420,'brands/e-i/franke.html','catalog/category/view/id/420',0,3,NULL,1,NULL),(10920,'category',421,'brands/e-i/gazco.html','catalog/category/view/id/421',0,3,NULL,1,NULL),(10921,'category',422,'brands/e-i/geberit.html','catalog/category/view/id/422',0,3,NULL,1,NULL),(10922,'category',423,'brands/e-i/grohe.html','catalog/category/view/id/423',0,3,NULL,1,NULL),(10923,'category',424,'brands/e-i/hansgrohe.html','catalog/category/view/id/424',0,3,NULL,1,NULL),(10924,'category',425,'brands/e-i/hib.html','catalog/category/view/id/425',0,3,NULL,1,NULL),(10925,'category',426,'brands/e-i/hudson-reed.html','catalog/category/view/id/426',0,3,NULL,1,NULL),(10926,'category',427,'brands/e-i/ideal-standard.html','catalog/category/view/id/427',0,3,NULL,1,NULL),(10927,'category',428,'brands/j-r.html','catalog/category/view/id/428',0,3,NULL,1,NULL),(10928,'category',429,'brands/j-r/kaldewei.html','catalog/category/view/id/429',0,3,NULL,1,NULL),(10929,'category',430,'brands/j-r/matki.html','catalog/category/view/id/430',0,3,NULL,1,NULL),(10930,'category',431,'brands/j-r/neff.html','catalog/category/view/id/431',0,3,NULL,1,NULL),(10931,'category',432,'brands/j-r/nuie.html','catalog/category/view/id/432',0,3,NULL,1,NULL),(10932,'category',433,'brands/j-r/rak-ceramics.html','catalog/category/view/id/433',0,3,NULL,1,NULL),(10933,'category',434,'brands/j-r/reginox.html','catalog/category/view/id/434',0,3,NULL,1,NULL),(10934,'category',435,'brands/j-r/reina.html','catalog/category/view/id/435',0,3,NULL,1,NULL),(10935,'category',436,'brands/j-r/roca.html','catalog/category/view/id/436',0,3,NULL,1,NULL),(10936,'category',437,'brands/j-r/royce-morgan.html','catalog/category/view/id/437',0,3,NULL,1,NULL),(10937,'category',438,'brands/s-z.html','catalog/category/view/id/438',0,3,NULL,1,NULL),(10938,'category',439,'brands/s-z/siemens.html','catalog/category/view/id/439',0,3,NULL,1,NULL),(10939,'category',440,'brands/s-z/spartherm.html','catalog/category/view/id/440',0,3,NULL,1,NULL),(10940,'category',441,'brands/s-z/valor.html','catalog/category/view/id/441',0,3,NULL,1,NULL),(10941,'category',442,'brands/s-z/vitra.html','catalog/category/view/id/442',0,3,NULL,1,NULL),(10942,'category',443,'brands/s-z/zehnder.html','catalog/category/view/id/443',0,3,NULL,1,NULL),(10943,'category',449,'deals.html','catalog/category/view/id/449',0,3,NULL,1,NULL),(10944,'product',5760,'bathroom/test-product.html','catalog/product/view/id/5760/category/3',0,5,NULL,1,'{\"category_id\":\"3\"}'),(10945,'product',5760,'kitchen-appliances/test-product.html','catalog/product/view/id/5760/category/5',0,5,NULL,1,'{\"category_id\":\"5\"}'),(10946,'product',5760,'heating/fires/test-product.html','catalog/product/view/id/5760/category/6',0,5,NULL,1,'{\"category_id\":\"6\"}'),(10947,'product',5760,'heating/test-product.html','catalog/product/view/id/5760/category/7',0,5,NULL,1,'{\"category_id\":\"7\"}'),(10948,'product',5760,'accessories/test-product.html','catalog/product/view/id/5760/category/10',0,5,NULL,1,'{\"category_id\":\"10\"}'),(10949,'product',5760,'sales/test-product.html','catalog/product/view/id/5760/category/11',0,5,NULL,1,'{\"category_id\":\"11\"}'),(10950,'product',5760,'brands/test-product.html','catalog/product/view/id/5760/category/12',0,5,NULL,1,'{\"category_id\":\"12\"}'),(10951,'product',5760,'kitchen-appliances/kitchen-taps/test-product.html','catalog/product/view/id/5760/category/145',0,5,NULL,1,'{\"category_id\":\"145\"}'),(10952,'product',5760,'comfort-product/test-product.html','catalog/product/view/id/5760/category/164',0,5,NULL,1,'{\"category_id\":\"164\"}'),(10953,'product',5760,'kitchen-appliances/appliances/test-product.html','catalog/product/view/id/5760/category/343',0,5,NULL,1,'{\"category_id\":\"343\"}'),(10954,'product',5760,'kitchen-appliances/kitchen-accessories/test-product.html','catalog/product/view/id/5760/category/356',0,5,NULL,1,'{\"category_id\":\"356\"}'),(10955,'product',5760,'heating/radiators/test-product.html','catalog/product/view/id/5760/category/366',0,5,NULL,1,'{\"category_id\":\"366\"}'),(10956,'product',5760,'deals/test-product.html','catalog/product/view/id/5760/category/449',0,5,NULL,1,'{\"category_id\":\"449\"}'),(10957,'product',5760,'test-product.html','catalog/product/view/id/5760',0,2,NULL,1,NULL),(10958,'product',5760,'bathroom/test-product.html','catalog/product/view/id/5760/category/3',0,2,NULL,1,'{\"category_id\":\"3\"}'),(10959,'product',5760,'kitchen-appliances/test-product.html','catalog/product/view/id/5760/category/5',0,2,NULL,1,'{\"category_id\":\"5\"}'),(10960,'product',5760,'heating/fires/test-product.html','catalog/product/view/id/5760/category/6',0,2,NULL,1,'{\"category_id\":\"6\"}'),(10961,'product',5760,'heating/test-product.html','catalog/product/view/id/5760/category/7',0,2,NULL,1,'{\"category_id\":\"7\"}'),(10962,'product',5760,'accessories/test-product.html','catalog/product/view/id/5760/category/10',0,2,NULL,1,'{\"category_id\":\"10\"}'),(10963,'product',5760,'sales/test-product.html','catalog/product/view/id/5760/category/11',0,2,NULL,1,'{\"category_id\":\"11\"}'),(10964,'product',5760,'brands/test-product.html','catalog/product/view/id/5760/category/12',0,2,NULL,1,'{\"category_id\":\"12\"}'),(10965,'product',5760,'kitchen-appliances/kitchen-taps/test-product.html','catalog/product/view/id/5760/category/145',0,2,NULL,1,'{\"category_id\":\"145\"}'),(10966,'product',5760,'comfort-product/test-product.html','catalog/product/view/id/5760/category/164',0,2,NULL,1,'{\"category_id\":\"164\"}'),(10967,'product',5760,'kitchen-appliances/appliances/test-product.html','catalog/product/view/id/5760/category/343',0,2,NULL,1,'{\"category_id\":\"343\"}'),(10968,'product',5760,'kitchen-appliances/kitchen-accessories/test-product.html','catalog/product/view/id/5760/category/356',0,2,NULL,1,'{\"category_id\":\"356\"}'),(10969,'product',5760,'heating/radiators/test-product.html','catalog/product/view/id/5760/category/366',0,2,NULL,1,'{\"category_id\":\"366\"}'),(10970,'product',5760,'deals/test-product.html','catalog/product/view/id/5760/category/449',0,2,NULL,1,'{\"category_id\":\"449\"}'),(10971,'product',5760,'test-product.html','catalog/product/view/id/5760',0,3,NULL,1,NULL),(10972,'product',5760,'bathroom/test-product.html','catalog/product/view/id/5760/category/3',0,3,NULL,1,'{\"category_id\":\"3\"}'),(10973,'product',5760,'kitchen-appliances/test-product.html','catalog/product/view/id/5760/category/5',0,3,NULL,1,'{\"category_id\":\"5\"}'),(10974,'product',5760,'heating/fires/test-product.html','catalog/product/view/id/5760/category/6',0,3,NULL,1,'{\"category_id\":\"6\"}'),(10975,'product',5760,'heating/test-product.html','catalog/product/view/id/5760/category/7',0,3,NULL,1,'{\"category_id\":\"7\"}'),(10976,'product',5760,'accessories/test-product.html','catalog/product/view/id/5760/category/10',0,3,NULL,1,'{\"category_id\":\"10\"}'),(10977,'product',5760,'sales/test-product.html','catalog/product/view/id/5760/category/11',0,3,NULL,1,'{\"category_id\":\"11\"}'),(10978,'product',5760,'brands/test-product.html','catalog/product/view/id/5760/category/12',0,3,NULL,1,'{\"category_id\":\"12\"}'),(10979,'product',5760,'kitchen-appliances/kitchen-taps/test-product.html','catalog/product/view/id/5760/category/145',0,3,NULL,1,'{\"category_id\":\"145\"}'),(10980,'product',5760,'comfort-product/test-product.html','catalog/product/view/id/5760/category/164',0,3,NULL,1,'{\"category_id\":\"164\"}'),(10981,'product',5760,'kitchen-appliances/appliances/test-product.html','catalog/product/view/id/5760/category/343',0,3,NULL,1,'{\"category_id\":\"343\"}'),(10982,'product',5760,'kitchen-appliances/kitchen-accessories/test-product.html','catalog/product/view/id/5760/category/356',0,3,NULL,1,'{\"category_id\":\"356\"}'),(10983,'product',5760,'heating/radiators/test-product.html','catalog/product/view/id/5760/category/366',0,3,NULL,1,'{\"category_id\":\"366\"}'),(10984,'product',5760,'deals/test-product.html','catalog/product/view/id/5760/category/449',0,3,NULL,1,'{\"category_id\":\"449\"}'),(10985,'product',5760,'test-product.html','catalog/product/view/id/5760',0,4,NULL,1,NULL),(10986,'product',5760,'bathroom/test-product.html','catalog/product/view/id/5760/category/3',0,4,NULL,1,'{\"category_id\":\"3\"}'),(10987,'product',5760,'kitchen-appliances/test-product.html','catalog/product/view/id/5760/category/5',0,4,NULL,1,'{\"category_id\":\"5\"}'),(10988,'product',5760,'heating/fires/test-product.html','catalog/product/view/id/5760/category/6',0,4,NULL,1,'{\"category_id\":\"6\"}'),(10989,'product',5760,'heating/test-product.html','catalog/product/view/id/5760/category/7',0,4,NULL,1,'{\"category_id\":\"7\"}'),(10990,'product',5760,'accessories/test-product.html','catalog/product/view/id/5760/category/10',0,4,NULL,1,'{\"category_id\":\"10\"}'),(10991,'product',5760,'sales/test-product.html','catalog/product/view/id/5760/category/11',0,4,NULL,1,'{\"category_id\":\"11\"}'),(10992,'product',5760,'brands/test-product.html','catalog/product/view/id/5760/category/12',0,4,NULL,1,'{\"category_id\":\"12\"}'),(10993,'product',5760,'kitchen-appliances/kitchen-taps/test-product.html','catalog/product/view/id/5760/category/145',0,4,NULL,1,'{\"category_id\":\"145\"}'),(10994,'product',5760,'comfort-product/test-product.html','catalog/product/view/id/5760/category/164',0,4,NULL,1,'{\"category_id\":\"164\"}'),(10995,'product',5760,'kitchen-appliances/appliances/test-product.html','catalog/product/view/id/5760/category/343',0,4,NULL,1,'{\"category_id\":\"343\"}'),(10996,'product',5760,'kitchen-appliances/kitchen-accessories/test-product.html','catalog/product/view/id/5760/category/356',0,4,NULL,1,'{\"category_id\":\"356\"}'),(10997,'product',5760,'heating/radiators/test-product.html','catalog/product/view/id/5760/category/366',0,4,NULL,1,'{\"category_id\":\"366\"}'),(10998,'product',5760,'deals/test-product.html','catalog/product/view/id/5760/category/449',0,4,NULL,1,'{\"category_id\":\"449\"}'),(10999,'product',6035,'franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035',0,2,NULL,1,NULL),(11000,'product',6035,'bathroom/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/3',0,2,NULL,1,'{\"category_id\":\"3\"}'),(11001,'product',6035,'kitchen-appliances/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/5',0,2,NULL,1,'{\"category_id\":\"5\"}'),(11002,'product',6035,'heating/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/7',0,2,NULL,1,'{\"category_id\":\"7\"}'),(11003,'product',6035,'accessories/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/10',0,2,NULL,1,'{\"category_id\":\"10\"}'),(11004,'product',6035,'sales/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/11',0,2,NULL,1,'{\"category_id\":\"11\"}'),(11005,'product',6035,'brands/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/12',0,2,NULL,1,'{\"category_id\":\"12\"}'),(11006,'product',6035,'comfort-product/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/164',0,2,NULL,1,'{\"category_id\":\"164\"}'),(11007,'product',6035,'deals/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/449',0,2,NULL,1,'{\"category_id\":\"449\"}'),(11008,'product',6035,'franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035',0,3,NULL,1,NULL),(11009,'product',6035,'bathroom/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/3',0,3,NULL,1,'{\"category_id\":\"3\"}'),(11010,'product',6035,'kitchen-appliances/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/5',0,3,NULL,1,'{\"category_id\":\"5\"}'),(11011,'product',6035,'heating/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/7',0,3,NULL,1,'{\"category_id\":\"7\"}'),(11012,'product',6035,'accessories/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/10',0,3,NULL,1,'{\"category_id\":\"10\"}'),(11013,'product',6035,'sales/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/11',0,3,NULL,1,'{\"category_id\":\"11\"}'),(11014,'product',6035,'brands/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/12',0,3,NULL,1,'{\"category_id\":\"12\"}'),(11015,'product',6035,'comfort-product/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/164',0,3,NULL,1,'{\"category_id\":\"164\"}'),(11016,'product',6035,'deals/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/449',0,3,NULL,1,'{\"category_id\":\"449\"}'),(11017,'product',6035,'franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035',0,4,NULL,1,NULL),(11018,'product',6035,'bathroom/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/3',0,4,NULL,1,'{\"category_id\":\"3\"}'),(11019,'product',6035,'kitchen-appliances/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/5',0,4,NULL,1,'{\"category_id\":\"5\"}'),(11020,'product',6035,'heating/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/7',0,4,NULL,1,'{\"category_id\":\"7\"}'),(11021,'product',6035,'accessories/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/10',0,4,NULL,1,'{\"category_id\":\"10\"}'),(11022,'product',6035,'sales/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/11',0,4,NULL,1,'{\"category_id\":\"11\"}'),(11023,'product',6035,'brands/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/12',0,4,NULL,1,'{\"category_id\":\"12\"}'),(11024,'product',6035,'comfort-product/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/164',0,4,NULL,1,'{\"category_id\":\"164\"}'),(11025,'product',6035,'deals/franke-mythos-myx-110-34-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6035/category/449',0,4,NULL,1,'{\"category_id\":\"449\"}'),(11026,'product',6036,'franke-mythos-myx-110-45-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6036',0,2,NULL,1,NULL),(11027,'product',6036,'franke-mythos-myx-110-45-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6036',0,3,NULL,1,NULL),(11028,'product',6036,'franke-mythos-myx-110-45-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6036',0,4,NULL,1,NULL),(11029,'product',6037,'franke-mythos-myx-110-55-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6037',0,1,NULL,1,NULL),(11030,'product',6037,'franke-mythos-myx-110-55-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6037',0,2,NULL,1,NULL),(11031,'product',6037,'franke-mythos-myx-110-55-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6037',0,3,NULL,1,NULL),(11032,'product',6037,'franke-mythos-myx-110-55-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6037',0,4,NULL,1,NULL),(11033,'product',6038,'franke-mythos-myx-110-70-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6038',0,1,NULL,1,NULL),(11034,'product',6038,'franke-mythos-myx-110-70-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6038',0,2,NULL,1,NULL),(11035,'product',6038,'franke-mythos-myx-110-70-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6038',0,3,NULL,1,NULL),(11036,'product',6038,'franke-mythos-myx-110-70-undermount-single-bowl-sink-stainless-steel.html','catalog/product/view/id/6038',0,4,NULL,1,NULL),(11037,'product',6039,'franke-mythos-myx-120-34-34-undermount-double-bowl-sink-stainless-steel.html','catalog/product/view/id/6039',0,1,NULL,1,NULL),(11038,'product',6039,'franke-mythos-myx-120-34-34-undermount-double-bowl-sink-stainless-steel.html','catalog/product/view/id/6039',0,2,NULL,1,NULL),(11039,'product',6039,'franke-mythos-myx-120-34-34-undermount-double-bowl-sink-stainless-steel.html','catalog/product/view/id/6039',0,3,NULL,1,NULL),(11040,'product',6039,'franke-mythos-myx-120-34-34-undermount-double-bowl-sink-stainless-steel.html','catalog/product/view/id/6039',0,4,NULL,1,NULL),(11041,'product',6040,'franke-arcana-ahk-651-ceramic-inset-1-5-bowl-sink.html','catalog/product/view/id/6040',0,1,NULL,1,NULL),(11042,'product',6040,'franke-arcana-ahk-651-ceramic-inset-1-5-bowl-sink.html','catalog/product/view/id/6040',0,2,NULL,1,NULL),(11043,'product',6040,'franke-arcana-ahk-651-ceramic-inset-1-5-bowl-sink.html','catalog/product/view/id/6040',0,3,NULL,1,NULL),(11044,'product',6040,'franke-arcana-ahk-651-ceramic-inset-1-5-bowl-sink.html','catalog/product/view/id/6040',0,4,NULL,1,NULL),(11045,'product',6041,'blanco-supra-160-u-undermount-stainless-steel-sink-450748.html','catalog/product/view/id/6041',0,1,NULL,1,NULL),(11046,'product',6041,'blanco-supra-160-u-undermount-stainless-steel-sink-450748.html','catalog/product/view/id/6041',0,2,NULL,1,NULL),(11047,'product',6041,'blanco-supra-160-u-undermount-stainless-steel-sink-450748.html','catalog/product/view/id/6041',0,3,NULL,1,NULL),(11048,'product',6041,'blanco-supra-160-u-undermount-stainless-steel-sink-450748.html','catalog/product/view/id/6041',0,4,NULL,1,NULL),(11049,'product',6042,'blanco-supra-340-u-undermount-stainless-steel-sink-450762.html','catalog/product/view/id/6042',0,1,NULL,1,NULL),(11050,'product',6042,'blanco-supra-340-u-undermount-stainless-steel-sink-450762.html','catalog/product/view/id/6042',0,2,NULL,1,NULL),(11051,'product',6042,'blanco-supra-340-u-undermount-stainless-steel-sink-450762.html','catalog/product/view/id/6042',0,3,NULL,1,NULL),(11052,'product',6042,'blanco-supra-340-u-undermount-stainless-steel-sink-450762.html','catalog/product/view/id/6042',0,4,NULL,1,NULL),(11053,'product',6043,'blanco-livit-45-s-salto-stainless-steel-inset-sink.html','catalog/product/view/id/6043',0,1,NULL,1,NULL),(11054,'product',6043,'blanco-livit-45-s-salto-stainless-steel-inset-sink.html','catalog/product/view/id/6043',0,2,NULL,1,NULL),(11055,'product',6043,'blanco-livit-45-s-salto-stainless-steel-inset-sink.html','catalog/product/view/id/6043',0,3,NULL,1,NULL),(11056,'product',6043,'blanco-livit-45-s-salto-stainless-steel-inset-sink.html','catalog/product/view/id/6043',0,4,NULL,1,NULL),(11057,'product',6044,'blanco-livit-xl-5-s-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6044',0,1,NULL,1,NULL),(11058,'product',6044,'blanco-livit-xl-5-s-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6044',0,2,NULL,1,NULL),(11059,'product',6044,'blanco-livit-xl-5-s-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6044',0,3,NULL,1,NULL),(11060,'product',6044,'blanco-livit-xl-5-s-inset-stainless-steel-kitchen-sink.html','catalog/product/view/id/6044',0,4,NULL,1,NULL),(11061,'product',6045,'blanco-supra-400-u-undermount-kitchen-sink-452613.html','catalog/product/view/id/6045',0,1,NULL,1,NULL),(11062,'product',6045,'blanco-supra-400-u-undermount-kitchen-sink-452613.html','catalog/product/view/id/6045',0,2,NULL,1,NULL),(11063,'product',6045,'blanco-supra-400-u-undermount-kitchen-sink-452613.html','catalog/product/view/id/6045',0,3,NULL,1,NULL),(11064,'product',6045,'blanco-supra-400-u-undermount-kitchen-sink-452613.html','catalog/product/view/id/6045',0,4,NULL,1,NULL),(11065,'product',6046,'blanco-supra-450-u-undermount-kitchen-sink-452614.html','catalog/product/view/id/6046',0,1,NULL,1,NULL),(11066,'product',6046,'blanco-supra-450-u-undermount-kitchen-sink-452614.html','catalog/product/view/id/6046',0,2,NULL,1,NULL),(11067,'product',6046,'blanco-supra-450-u-undermount-kitchen-sink-452614.html','catalog/product/view/id/6046',0,3,NULL,1,NULL),(11068,'product',6046,'blanco-supra-450-u-undermount-kitchen-sink-452614.html','catalog/product/view/id/6046',0,4,NULL,1,NULL),(11069,'product',6047,'blanco-supra-500-u-undermount-kitchen-sink-452615.html','catalog/product/view/id/6047',0,1,NULL,1,NULL),(11070,'product',6047,'blanco-supra-500-u-undermount-kitchen-sink-452615.html','catalog/product/view/id/6047',0,2,NULL,1,NULL),(11071,'product',6047,'blanco-supra-500-u-undermount-kitchen-sink-452615.html','catalog/product/view/id/6047',0,3,NULL,1,NULL),(11072,'product',6047,'blanco-supra-500-u-undermount-kitchen-sink-452615.html','catalog/product/view/id/6047',0,4,NULL,1,NULL),(11073,'product',6048,'blanco-livit-xl-6-s-inset-kitchen-sink-livit-xl-6-s.html','catalog/product/view/id/6048',0,1,NULL,1,NULL),(11074,'product',6048,'blanco-livit-xl-6-s-inset-kitchen-sink-livit-xl-6-s.html','catalog/product/view/id/6048',0,2,NULL,1,NULL),(11075,'product',6048,'blanco-livit-xl-6-s-inset-kitchen-sink-livit-xl-6-s.html','catalog/product/view/id/6048',0,3,NULL,1,NULL),(11076,'product',6048,'blanco-livit-xl-6-s-inset-kitchen-sink-livit-xl-6-s.html','catalog/product/view/id/6048',0,4,NULL,1,NULL),(11077,'product',6049,'blanco-essential-530-u-stainless-steel-undermount-sink.html','catalog/product/view/id/6049',0,1,NULL,1,NULL),(11078,'product',6049,'blanco-essential-530-u-stainless-steel-undermount-sink.html','catalog/product/view/id/6049',0,2,NULL,1,NULL),(11079,'product',6049,'blanco-essential-530-u-stainless-steel-undermount-sink.html','catalog/product/view/id/6049',0,3,NULL,1,NULL),(11080,'product',6049,'blanco-essential-530-u-stainless-steel-undermount-sink.html','catalog/product/view/id/6049',0,4,NULL,1,NULL),(11081,'product',6050,'blanco-lemis-6-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6050',0,1,NULL,1,NULL),(11082,'product',6050,'blanco-lemis-6-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6050',0,2,NULL,1,NULL),(11083,'product',6050,'blanco-lemis-6-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6050',0,3,NULL,1,NULL),(11084,'product',6050,'blanco-lemis-6-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6050',0,4,NULL,1,NULL),(11085,'product',6051,'blanco-lemis-xl-6-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6051',0,1,NULL,1,NULL),(11086,'product',6051,'blanco-lemis-xl-6-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6051',0,2,NULL,1,NULL),(11087,'product',6051,'blanco-lemis-xl-6-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6051',0,3,NULL,1,NULL),(11088,'product',6051,'blanco-lemis-xl-6-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6051',0,4,NULL,1,NULL),(11089,'product',6052,'blanco-lemis-45-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6052',0,1,NULL,1,NULL),(11090,'product',6052,'blanco-lemis-45-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6052',0,2,NULL,1,NULL),(11091,'product',6052,'blanco-lemis-45-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6052',0,3,NULL,1,NULL),(11092,'product',6052,'blanco-lemis-45-s-if-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6052',0,4,NULL,1,NULL),(11093,'product',6053,'blanco-livit-ii-6-s-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6053',0,1,NULL,1,NULL),(11094,'product',6053,'blanco-livit-ii-6-s-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6053',0,2,NULL,1,NULL),(11095,'product',6053,'blanco-livit-ii-6-s-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6053',0,3,NULL,1,NULL),(11096,'product',6053,'blanco-livit-ii-6-s-stainless-steel-inset-kitchen-sink.html','catalog/product/view/id/6053',0,4,NULL,1,NULL),(11149,'product',6346,'royce-morgan-balmoral-freestanding-bath-1680mm-x-730mm-balmoral.html','catalog/product/view/id/6346',0,5,NULL,1,NULL),(11150,'product',6347,'royce-morgan-bolton-freestanding-bath-1690mm-x-800mm-bolton1690.html','catalog/product/view/id/6347',0,5,NULL,1,NULL),(11151,'product',6348,'royce-morgan-bolton-freestanding-bath-1805mm-x-860mm-bolton1805.html','catalog/product/view/id/6348',0,5,NULL,1,NULL),(11152,'product',6349,'royce-morgan-chatsworth-freestanding-bath-1530mm-x-710mm-chatsworth.html','catalog/product/view/id/6349',0,5,NULL,1,NULL),(11153,'product',6350,'royce-morgan-ebony-freestanding-bath-1710mm-x-735mm-ebony.html','catalog/product/view/id/6350',0,5,NULL,1,NULL),(11154,'product',6351,'royce-morgan-hexham-freestanding-bath-1690mm-x-760mm-hexham.html','catalog/product/view/id/6351',0,5,NULL,1,NULL),(11155,'product',6352,'royce-morgan-kensington-freestanding-bath-1495mm-x-785mm-kensington1495.html','catalog/product/view/id/6352',0,5,NULL,1,NULL),(11156,'product',6353,'royce-morgan-kensington-freestanding-bath-1695mm-x-740mm-kensington1695.html','catalog/product/view/id/6353',0,5,NULL,1,NULL),(11157,'product',6354,'royce-morgan-lambeth-freestanding-bath-1665mm-x-715mm-lambeth.html','catalog/product/view/id/6354',0,5,NULL,1,NULL),(11158,'product',6355,'royce-morgan-melrose-freestanding-bath-1700mm-x-700mm-melrose.html','catalog/product/view/id/6355',0,5,NULL,1,NULL),(11159,'product',6356,'royce-morgan-melrose-freestanding-bath-1740mm-x-700mm-melrosefa.html','catalog/product/view/id/6356',0,5,NULL,1,NULL),(11160,'product',6357,'royce-morgan-onyx-freestanding-bath-1700mm-x-670mm-onyx.html','catalog/product/view/id/6357',0,5,NULL,1,NULL),(11161,'product',6358,'royce-morgan-opal-freestanding-bath-1790mm-x-820mm-opal.html','catalog/product/view/id/6358',0,5,NULL,1,NULL),(11162,'product',6359,'royce-morgan-orlando-freestanding-bath-1380mm-x-750mm-orlando1380.html','catalog/product/view/id/6359',0,5,NULL,1,NULL),(11163,'product',6360,'royce-morgan-quartz-freestanding-bath-1760mm-x-680mm-quartz.html','catalog/product/view/id/6360',0,5,NULL,1,NULL),(11164,'product',6361,'royce-morgan-ruby-freestanding-bath-1580mm-x-740mm-ruby.html','catalog/product/view/id/6361',0,5,NULL,1,NULL),(11165,'product',6362,'royce-morgan-sunstone-freestanding-bath-1590mm-x-700mm-sunstone.html','catalog/product/view/id/6362',0,5,NULL,1,NULL),(11166,'product',6363,'royce-morgan-westminster-freestanding-bath-1490mm-x-850mm-westminster1490.html','catalog/product/view/id/6363',0,5,NULL,1,NULL),(11167,'product',6364,'royce-morgan-westminster-freestanding-bath-1860mm-x-880mm-westminster1860.html','catalog/product/view/id/6364',0,5,NULL,1,NULL),(11168,'product',6365,'royce-morgan-woburn-freestanding-bath-1490mm-x-790mm-woburn1490.html','catalog/product/view/id/6365',0,5,NULL,1,NULL),(11169,'product',6366,'royce-morgan-woburn-freestanding-bath-1675mm-x-780mm-woburn1675.html','catalog/product/view/id/6366',0,5,NULL,1,NULL),(11170,'product',6367,'royce-morgan-woburn-freestanding-bath-1765mm-x-800mm-woburn1765.html','catalog/product/view/id/6367',0,5,NULL,1,NULL),(11171,'product',6368,'premier-asselby-square-acrylic-bath-with-leg-set-170-x-70cm.html','catalog/product/view/id/6368',0,5,NULL,1,NULL),(11172,'product',6369,'premier-asselby-square-acrylic-bath-with-leg-set-170cm-x-75cm.html','catalog/product/view/id/6369',0,5,NULL,1,NULL),(11173,'product',6370,'premier-asselby-square-acrylic-bath-with-leg-set-180cm-x-80cm.html','catalog/product/view/id/6370',0,5,NULL,1,NULL),(11174,'product',6371,'premier-barmby-round-acrylic-bath-150cm-x-70cm.html','catalog/product/view/id/6371',0,5,NULL,1,NULL),(11175,'product',6372,'premier-barmby-round-acrylic-bath-160cm-x-70cm.html','catalog/product/view/id/6372',0,5,NULL,1,NULL),(11176,'product',6373,'premier-barmby-round-acrylic-bath-170cm-x-70cm.html','catalog/product/view/id/6373',0,5,NULL,1,NULL),(11177,'product',6374,'premier-barmby-acrylic-bath-170cm-x-75cm.html','catalog/product/view/id/6374',0,5,NULL,1,NULL),(11178,'product',6375,'premier-barmby-acrylic-bath-180cm-x-80cm.html','catalog/product/view/id/6375',0,5,NULL,1,NULL),(11179,'product',6376,'premier-linton-square-acrylic-bath-leg-set-1500mm-x-700mm.html','catalog/product/view/id/6376',0,5,NULL,1,NULL),(11180,'product',6377,'premier-linton-square-acrylic-bath-leg-set-160-x-70cm.html','catalog/product/view/id/6377',0,5,NULL,1,NULL),(11181,'product',6378,'premier-linton-square-acrylic-bath-leg-set-170cm-x-70cm.html','catalog/product/view/id/6378',0,5,NULL,1,NULL),(11182,'product',6379,'premier-linton-square-acrylic-bath-leg-set-170cm-x-75cm.html','catalog/product/view/id/6379',0,5,NULL,1,NULL),(11183,'product',6380,'premier-linton-square-acrylic-bath-leg-set-180-x-80cm.html','catalog/product/view/id/6380',0,5,NULL,1,NULL),(11184,'product',6381,'premier-otley-round-acrylic-bath-with-leg-set-170cm-x-70cm.html','catalog/product/view/id/6381',0,5,NULL,1,NULL),(11185,'product',6382,'premier-otley-round-acrylic-bath-with-leg-set-170cm-x-75cm.html','catalog/product/view/id/6382',0,5,NULL,1,NULL),(11186,'product',6383,'premier-otley-round-acrylic-bath-with-leg-set-180cm-x-80cm.html','catalog/product/view/id/6383',0,5,NULL,1,NULL),(11187,'product',6384,'rak-dkm-double-ended-easyflow-bath-1800mm-x-800mm.html','catalog/product/view/id/6384',0,5,NULL,1,NULL),(11188,'product',6385,'rak-metropolitan-single-ended-easyflow-1800mm-x-800mm.html','catalog/product/view/id/6385',0,5,NULL,1,NULL),(11189,'product',6386,'rak-metropolitan-single-ended-bath-easyflow-1700mm-x-700mm-nmetbath.html','catalog/product/view/id/6386',0,5,NULL,1,NULL),(11190,'product',6387,'rak-orient-single-ended-easyflow-bath-1700mm-x-745mm.html','catalog/product/view/id/6387',0,5,NULL,1,NULL),(11191,'product',6388,'roca-contesa-steel-bath-170cm-x-70cm-2370j-2370k.html','catalog/product/view/id/6388',0,5,NULL,1,NULL),(11192,'product',6389,'roca-the-gap-acrylic-bath-170cm-x-70cm-no-th.html','catalog/product/view/id/6389',0,5,NULL,1,NULL),(11193,'product',6390,'roca-the-gap-acrylic-bath-170cm-x-75cm-no-th.html','catalog/product/view/id/6390',0,5,NULL,1,NULL),(11194,'product',6391,'roca-the-gap-single-ended-acrylic-bath-170cm-x-75cm-no-th.html','catalog/product/view/id/6391',0,5,NULL,1,NULL),(11195,'product',6392,'bette-classic-super-steel-single-ended-bath.html','catalog/product/view/id/6392',0,5,NULL,1,NULL),(11196,'product',6393,'bette-comodo-super-steel-bath-with-side-overflow.html','catalog/product/view/id/6393',0,5,NULL,1,NULL),(11197,'product',6394,'bette-duett-super-steel-rectangular-bath.html','catalog/product/view/id/6394',0,5,NULL,1,NULL),(11198,'product',6395,'bette-free-super-steel-double-ended-rectangular-bath.html','catalog/product/view/id/6395',0,5,NULL,1,NULL),(11199,'product',6396,'bette-ocean-lowline-super-steel-single-ended-bath.html','catalog/product/view/id/6396',0,5,NULL,1,NULL),(11200,'product',6397,'bette-one-super-steel-double-ended-bath.html','catalog/product/view/id/6397',0,5,NULL,1,NULL),(11201,'product',6398,'bette-one-relax-super-steel-single-ended-bath.html','catalog/product/view/id/6398',0,5,NULL,1,NULL),(11202,'product',6399,'bette-starlet-flair-oval-super-steel-double-ended-bath.html','catalog/product/view/id/6399',0,5,NULL,1,NULL),(11203,'product',6400,'bette-starlet-iv-silhouette-steel-double-ended-bath.html','catalog/product/view/id/6400',0,5,NULL,1,NULL),(11204,'product',6401,'bette-starlet-oval-super-steel-double-ended-bath.html','catalog/product/view/id/6401',0,5,NULL,1,NULL),(11205,'product',6402,'bette-starlet-v-silhouette-steel-double-ended-bath.html','catalog/product/view/id/6402',0,5,NULL,1,NULL),(11206,'product',6403,'roca-lun-plus-steel-bath-with-1700-x-750mm-anti-slip.html','catalog/product/view/id/6403',0,5,NULL,1,NULL),(11207,'product',6404,'roca-carla-steel-bath-with-2-tap-hole-160cm-x-70cm.html','catalog/product/view/id/6404',0,5,NULL,1,NULL),(11208,'product',6405,'bette-labette-super-steel-bath-108-x-73cm-feet-no-th.html','catalog/product/view/id/6405',0,5,NULL,1,NULL),(11209,'product',6406,'bette-labette-super-steel-bath-1180-x-730mm-no-th.html','catalog/product/view/id/6406',0,5,NULL,1,NULL),(11210,'product',6407,'bette-labette-super-steel-bath-1200-x-700mm.html','catalog/product/view/id/6407',0,5,NULL,1,NULL),(11211,'product',6408,'bette-starlet-super-steel-bath-1500-x-800mm-no-th.html','catalog/product/view/id/6408',0,5,NULL,1,NULL),(11212,'product',6409,'bette-starlet-super-steel-bath-1600-x-700mm.html','catalog/product/view/id/6409',0,5,NULL,1,NULL),(11213,'product',6410,'bette-starlet-super-steel-bath-1650-x-700mm.html','catalog/product/view/id/6410',0,5,NULL,1,NULL),(11214,'product',6411,'bette-labette-super-steel-bath-1240-x-700mm-no-th.html','catalog/product/view/id/6411',0,5,NULL,1,NULL),(11215,'product',6412,'bette-comodo-super-steel-bath-1700-750mm-no-th.html','catalog/product/view/id/6412',0,5,NULL,1,NULL),(11216,'product',6413,'bette-classic-super-steel-bath-180-x-80cm.html','catalog/product/view/id/6413',0,5,NULL,1,NULL),(11217,'product',6414,'bette-classic-super-steel-bath-180-x-70cm.html','catalog/product/view/id/6414',0,5,NULL,1,NULL),(11218,'product',6415,'bette-classic-super-steel-bath-180-x-75cm.html','catalog/product/view/id/6415',0,5,NULL,1,NULL),(11219,'product',6416,'bette-labette-super-steel-bath-1300-x-700mm.html','catalog/product/view/id/6416',0,5,NULL,1,NULL),(11220,'product',6417,'bette-starlet-super-steel-bath-170-x-75cm-feet.html','catalog/product/view/id/6417',0,5,NULL,1,NULL),(11221,'product',6418,'bette-starlet-super-steel-bath-1800-x-750mm-no-th.html','catalog/product/view/id/6418',0,5,NULL,1,NULL),(11222,'product',6419,'bette-starlet-super-steel-bath-1750-x-800mm.html','catalog/product/view/id/6419',0,5,NULL,1,NULL),(11223,'product',6420,'bette-starlet-super-steel-bath-1800-x-800mm.html','catalog/product/view/id/6420',0,5,NULL,1,NULL),(11224,'product',6421,'bette-starlet-super-steel-bath-1700-x-700mm-no-th.html','catalog/product/view/id/6421',0,5,NULL,1,NULL),(11225,'product',6422,'bette-starlet-super-steel-bath-1900-x-900mm.html','catalog/product/view/id/6422',0,5,NULL,1,NULL),(11226,'product',6423,'bette-starlet-super-steel-bath-1600-x-650mm-no-th.html','catalog/product/view/id/6423',0,5,NULL,1,NULL),(11227,'product',6424,'bette-set-super-steel-bath-150-x-75cm-feet.html','catalog/product/view/id/6424',0,5,NULL,1,NULL),(11228,'product',6425,'bette-starlet-super-steel-bath-1570-x-700mm-no-th.html','catalog/product/view/id/6425',0,5,NULL,1,NULL),(11229,'product',6426,'bette-set-super-steel-bath-170-x-75cm-feet.html','catalog/product/view/id/6426',0,5,NULL,1,NULL),(11230,'product',6427,'bette-classic-super-steel-bath-170-x-75mm-feet.html','catalog/product/view/id/6427',0,5,NULL,1,NULL),(11231,'product',6428,'bette-one-relax-super-steel-bath-180-x-80cm-no-th.html','catalog/product/view/id/6428',0,5,NULL,1,NULL),(11232,'product',6429,'bette-one-relax-super-steel-bath-1900-x-900mm-no-th.html','catalog/product/view/id/6429',0,5,NULL,1,NULL),(11233,'product',6430,'bette-one-relax-super-steel-bath-2000-900mm-no-th.html','catalog/product/view/id/6430',0,5,NULL,1,NULL),(11234,'product',6431,'bette-form-super-steel-bath-1400-x-700mm.html','catalog/product/view/id/6431',0,5,NULL,1,NULL),(11235,'product',6432,'bette-select-super-steel-bath-1600-x-700mm.html','catalog/product/view/id/6432',0,5,NULL,1,NULL),(11236,'product',6433,'bette-select-super-steel-bath-1700-x-700mm.html','catalog/product/view/id/6433',0,5,NULL,1,NULL),(11237,'product',6434,'bette-select-super-steel-bath-170-x-75cm-feet.html','catalog/product/view/id/6434',0,5,NULL,1,NULL),(11238,'product',6435,'bette-select-super-steel-bath-1800-x-800mm.html','catalog/product/view/id/6435',0,5,NULL,1,NULL),(11239,'product',6436,'bette-select-super-steel-bath-160-x-70cm-feet-no-th.html','catalog/product/view/id/6436',0,5,NULL,1,NULL),(11240,'product',6437,'bette-select-super-steel-bath-170-x-70cm-feet-no-th.html','catalog/product/view/id/6437',0,5,NULL,1,NULL),(11241,'product',6438,'bette-select-super-steel-bath-1700-x-750mm-no-th.html','catalog/product/view/id/6438',0,5,NULL,1,NULL),(11242,'product',6439,'bette-select-super-steel-bath-1800-x-800mm-no-th.html','catalog/product/view/id/6439',0,5,NULL,1,NULL),(11243,'product',6440,'bette-form-super-steel-bath-1750-x-750mm.html','catalog/product/view/id/6440',0,5,NULL,1,NULL),(11244,'product',6441,'bette-form-super-steel-bath-1700-x-800mm.html','catalog/product/view/id/6441',0,5,NULL,1,NULL),(11245,'product',6442,'bette-form-super-steel-bath-1500-x-700mm.html','catalog/product/view/id/6442',0,5,NULL,1,NULL),(11246,'product',6443,'bette-set-super-steel-bath-165-x-75cm-feet.html','catalog/product/view/id/6443',0,5,NULL,1,NULL),(11247,'product',6444,'bette-form-super-steel-bath-1600-x-700mm.html','catalog/product/view/id/6444',0,5,NULL,1,NULL),(11248,'product',6445,'bette-form-super-steel-bath-1600-x-750mm.html','catalog/product/view/id/6445',0,5,NULL,1,NULL),(11260,'product',6446,'bette-form-super-steel-bath-1650-x-750mm.html','catalog/product/view/id/6446',0,5,NULL,1,NULL),(11261,'product',6447,'bette-set-super-steel-bath-160-x-70cm-feet.html','catalog/product/view/id/6447',0,5,NULL,1,NULL),(11262,'product',6448,'bette-set-super-steel-bath-160-x-75cm.html','catalog/product/view/id/6448',0,5,NULL,1,NULL),(11263,'product',6449,'bette-form-super-steel-bath-1700-730mm.html','catalog/product/view/id/6449',0,5,NULL,1,NULL),(11264,'product',6450,'bette-form-super-steel-bath-1700-x-750mm.html','catalog/product/view/id/6450',0,5,NULL,1,NULL),(11265,'product',6451,'bette-set-super-steel-bath-170-x-80cm-feet.html','catalog/product/view/id/6451',0,5,NULL,1,NULL),(11266,'product',6452,'bette-form-super-steel-bath-1800-x-800mm.html','catalog/product/view/id/6452',0,5,NULL,1,NULL),(11267,'product',6453,'bette-set-super-steel-bath-180-x-80cm-feet.html','catalog/product/view/id/6453',0,5,NULL,1,NULL),(11268,'product',6454,'bette-starlet-flair-oval-super-steel-bath-1580-x-680mm-no-th.html','catalog/product/view/id/6454',0,5,NULL,1,NULL),(11269,'product',6455,'bette-starlet-flair-oval-super-steel-bath-1680-x-730mm-feet.html','catalog/product/view/id/6455',0,5,NULL,1,NULL),(11270,'product',6456,'bette-starlet-flair-oval-super-steel-bath-1780-x-780mm.html','catalog/product/view/id/6456',0,5,NULL,1,NULL),(11271,'product',6457,'bette-starlet-flair-oval-super-steel-bath-1880-x-880mm-no-th.html','catalog/product/view/id/6457',0,5,NULL,1,NULL),(11272,'product',6458,'bette-starlet-oval-super-steel-bath-1500-x-800mm-no-th.html','catalog/product/view/id/6458',0,5,NULL,1,NULL),(11273,'product',6459,'bette-starlet-oval-super-steel-bath-1650-x-750mm-no-th.html','catalog/product/view/id/6459',0,5,NULL,1,NULL),(11274,'product',6460,'bette-starlet-oval-super-steel-bath-1750-x-800mm-no-th.html','catalog/product/view/id/6460',0,5,NULL,1,NULL),(11275,'product',6461,'bette-starlet-oval-super-steel-bath-1850-x-850mm-no-th.html','catalog/product/view/id/6461',0,5,NULL,1,NULL),(11276,'product',6462,'bette-starlet-oval-super-steel-bath-1950-x-950mm-no-th.html','catalog/product/view/id/6462',0,5,NULL,1,NULL),(11277,'product',6463,'bette-form-super-steel-bath-1900-x-800mm.html','catalog/product/view/id/6463',0,5,NULL,1,NULL),(11278,'product',6464,'bette-form-super-steel-bath-170-x-70mm-feet.html','catalog/product/view/id/6464',0,5,NULL,1,NULL),(11279,'product',6465,'bette-starlet-iv-silhouette-steel-bath-1650-x-750mm-no-th.html','catalog/product/view/id/6465',0,5,NULL,1,NULL),(11280,'product',6466,'bette-starlet-iv-silhouette-steel-bath-1750-x-800mm-no-th.html','catalog/product/view/id/6466',0,5,NULL,1,NULL),(11281,'product',6467,'bette-starlet-iv-silhouette-steel-bath-1850-x-850mm-no-th.html','catalog/product/view/id/6467',0,5,NULL,1,NULL),(11282,'product',6468,'bette-starlet-v-silhouette-steel-bath-1650-x-750mm-no-th.html','catalog/product/view/id/6468',0,5,NULL,1,NULL),(11283,'product',6469,'bette-starlet-v-silhouette-steel-bath-1750-x-800mm-no-th.html','catalog/product/view/id/6469',0,5,NULL,1,NULL),(11284,'product',6470,'bette-starlet-v-silhouette-steel-bath-1850-x-850mm-no-th.html','catalog/product/view/id/6470',0,5,NULL,1,NULL),(11285,'product',6471,'bette-ocean-super-steel-bath-1800-x-800mm-no-th.html','catalog/product/view/id/6471',0,5,NULL,1,NULL),(11286,'product',6472,'bette-ocean-lowline-super-steel-bath-1500-x-700mm-no-th.html','catalog/product/view/id/6472',0,5,NULL,1,NULL),(11287,'product',6473,'bette-ocean-super-steel-bath-150-x-70cm-feet-no-th.html','catalog/product/view/id/6473',0,5,NULL,1,NULL),(11288,'product',6474,'bette-ocean-super-steel-bath-1600-x-700mm-no-th.html','catalog/product/view/id/6474',0,5,NULL,1,NULL),(11289,'product',6475,'bette-ocean-super-steel-bath-1700-x-800mm-no-th.html','catalog/product/view/id/6475',0,5,NULL,1,NULL),(11290,'product',6476,'bette-ocean-super-steel-bath-1700-x-700mm.html','catalog/product/view/id/6476',0,5,NULL,1,NULL),(11291,'product',6477,'bette-ocean-super-steel-bath-170-x-75cm-feet-no-th.html','catalog/product/view/id/6477',0,5,NULL,1,NULL),(11292,'product',6478,'bette-ocean-lowline-super-steel-bath-1600-x-700mm-no-th.html','catalog/product/view/id/6478',0,5,NULL,1,NULL),(11293,'product',6479,'bette-ocean-lowline-super-steel-bath-1700-x-800mm-no-th.html','catalog/product/view/id/6479',0,5,NULL,1,NULL),(11294,'product',6480,'bette-ocean-lowline-super-steel-bath-1700-x-700mm.html','catalog/product/view/id/6480',0,5,NULL,1,NULL),(11295,'product',6481,'bette-ocean-lowline-super-steel-bath-1700-x-750mm-no-th.html','catalog/product/view/id/6481',0,5,NULL,1,NULL),(11296,'product',6482,'bette-ocean-lowline-super-steel-bath-1800-x-800mm-no-th.html','catalog/product/view/id/6482',0,5,NULL,1,NULL),(11297,'product',6483,'bette-art-steel-oval-bath-1800-750mm-no-th.html','catalog/product/view/id/6483',0,5,NULL,1,NULL),(11298,'product',6484,'bette-duo-super-steel-rectangular-bath-1800-x-800mm.html','catalog/product/view/id/6484',0,5,NULL,1,NULL),(11299,'product',6485,'rak-cloud-freestanding-bath-1400-x-753mm.html','catalog/product/view/id/6485',0,5,NULL,1,NULL),(11300,'product',6486,'rak-evolution-double-ended-rectangular-bath-1750-x-750mm.html','catalog/product/view/id/6486',0,5,NULL,1,NULL),(11301,'product',6487,'rak-karla-single-ended-rectangular-bath-1700-x-700mm.html','catalog/product/view/id/6487',0,5,NULL,1,NULL),(11302,'product',6488,'rak-reserva-single-ended-rectangular-bath-1700-x-800mm.html','catalog/product/view/id/6488',0,5,NULL,1,NULL),(11303,'product',6489,'rak-washington-single-ended-bath-with-leg-set-1700-x-700mm.html','catalog/product/view/id/6489',0,5,NULL,1,NULL),(11304,'product',6490,'rak-washington-single-ended-bath-with-leg-set-1700-x-750mm.html','catalog/product/view/id/6490',0,5,NULL,1,NULL),(11305,'product',6491,'rak-washington-freestanding-bath-1560-x-810mm.html','catalog/product/view/id/6491',0,5,NULL,1,NULL),(11306,'product',6492,'hudson-reed-grace-freestanding-round-bath-1510-x-760mm.html','catalog/product/view/id/6492',0,5,NULL,1,NULL),(11307,'product',6493,'hudson-reed-rose-freestanding-bath-1510-x-760mm.html','catalog/product/view/id/6493',0,5,NULL,1,NULL),(11308,'product',6494,'hudson-reed-bella-freestanding-bath-1495-x-720mm.html','catalog/product/view/id/6494',0,5,NULL,1,NULL),(11309,'product',6495,'hudson-reed-farringdon-freestanding-bath-1555-x-740mm.html','catalog/product/view/id/6495',0,5,NULL,1,NULL),(11310,'product',6496,'hudson-reed-ascott-art-deco-bath-1700-x-700mm.html','catalog/product/view/id/6496',0,5,NULL,1,NULL),(11311,'product',6497,'hudson-reed-ascott-art-deco-bath-1700-x-750mm.html','catalog/product/view/id/6497',0,5,NULL,1,NULL),(11312,'product',6498,'hudson-reed-ascott-art-deco-bath-1800-x-800mm.html','catalog/product/view/id/6498',0,5,NULL,1,NULL),(11313,'product',6499,'hudson-reed-kenton-freestanding-bath-1700-x-750mm.html','catalog/product/view/id/6499',0,5,NULL,1,NULL),(11314,'product',6500,'hudson-reed-brockley-freestanding-bath-1500-x-750mm.html','catalog/product/view/id/6500',0,5,NULL,1,NULL),(11315,'product',6501,'hudson-reed-kingsbury-freestanding-bath-1500-x-750mm.html','catalog/product/view/id/6501',0,5,NULL,1,NULL),(11316,'product',6502,'hudson-reed-brockley-freestanding-bath-1700-x-750mm.html','catalog/product/view/id/6502',0,5,NULL,1,NULL),(11317,'product',6503,'hudson-reed-kingsbury-freestanding-bath-1700-x-750mm.html','catalog/product/view/id/6503',0,5,NULL,1,NULL),(11318,'product',6504,'hudson-reed-barnsbury-freestanding-bath-1700-x-750mm.html','catalog/product/view/id/6504',0,5,NULL,1,NULL),(11319,'product',6505,'hudson-reed-winterburn-freestanding-shower-bath-1500-x-750mm.html','catalog/product/view/id/6505',0,5,NULL,1,NULL),(11320,'product',6506,'hudson-reed-winterburn-freestanding-shower-bath-1700-x-750mm.html','catalog/product/view/id/6506',0,5,NULL,1,NULL),(11321,'product',6507,'bette-comodo-steel-single-ended-bath-1900-x-900mm.html','catalog/product/view/id/6507',0,5,NULL,1,NULL),(11322,'product',6508,'bette-select-bath-with-overflow-foot-end.html','catalog/product/view/id/6508',0,5,NULL,1,NULL),(11323,'product',6509,'bette-form-super-steel-single-ended-bath.html','catalog/product/view/id/6509',0,5,NULL,1,NULL),(11324,'product',6510,'bette-labette-super-steel-single-ended-bath.html','catalog/product/view/id/6510',0,5,NULL,1,NULL),(11325,'product',6511,'bette-ocean-single-ended-super-steel-bath.html','catalog/product/view/id/6511',0,5,NULL,1,NULL),(11326,'product',6512,'bette-set-super-steel-single-ended-bath.html','catalog/product/view/id/6512',0,5,NULL,1,NULL),(11327,'product',6513,'bette-starlet-super-steel-double-ended-bath.html','catalog/product/view/id/6513',0,5,NULL,1,NULL),(11328,'product',6514,'bette-one-steel-double-ended-bath-1600-x-700mm.html','catalog/product/view/id/6514',0,5,NULL,1,NULL),(11329,'product',6515,'bette-one-steel-double-ended-bath-1700-x-700mm.html','catalog/product/view/id/6515',0,5,NULL,1,NULL),(11330,'product',6516,'bette-one-steel-double-ended-bath-1700-x-750mm.html','catalog/product/view/id/6516',0,5,NULL,1,NULL),(11331,'product',6517,'bette-one-steel-double-ended-bath-1800-x-800mm.html','catalog/product/view/id/6517',0,5,NULL,1,NULL),(11332,'product',6518,'bette-one-steel-double-ended-bath-1900-x-900mm.html','catalog/product/view/id/6518',0,5,NULL,1,NULL),(11333,'product',6519,'bette-starlet-iv-silhouette-steel-bath-1950-x-950mm.html','catalog/product/view/id/6519',0,5,NULL,1,NULL),(11334,'product',6520,'bette-starlet-v-silhouette-steel-bath-1950-x-950mm.html','catalog/product/view/id/6520',0,5,NULL,1,NULL),(11335,'product',6521,'bette-comodo-steel-bath-with-side-overflow-1700-x-750mm.html','catalog/product/view/id/6521',0,5,NULL,1,NULL),(11336,'product',6522,'bette-comodo-steel-bath-with-side-overflow-1700-x-800mm.html','catalog/product/view/id/6522',0,5,NULL,1,NULL),(11337,'product',6523,'bette-comodo-steel-bath-with-side-overflow-1800-x-800mm.html','catalog/product/view/id/6523',0,5,NULL,1,NULL),(11338,'product',6524,'bette-comodo-steel-bath-with-side-overflow-1900-x-900mm.html','catalog/product/view/id/6524',0,5,NULL,1,NULL),(11339,'product',6525,'bette-classic-steel-bath-140-x-70cm.html','catalog/product/view/id/6525',0,5,NULL,1,NULL),(11340,'product',6526,'bette-classic-steel-bath-150-x-70cm.html','catalog/product/view/id/6526',0,5,NULL,1,NULL),(11341,'product',6527,'bette-classic-steel-bath-160-x-70cm.html','catalog/product/view/id/6527',0,5,NULL,1,NULL),(11342,'product',6528,'bette-classic-steel-bath-160-x-75cm.html','catalog/product/view/id/6528',0,5,NULL,1,NULL),(11343,'product',6529,'bette-classic-steel-bath-165-x-75cm.html','catalog/product/view/id/6529',0,5,NULL,1,NULL),(11344,'product',6530,'bette-classic-steel-bath-170-x-70cm.html','catalog/product/view/id/6530',0,5,NULL,1,NULL),(11345,'product',6531,'bette-classic-steel-bath-170-x-73cm.html','catalog/product/view/id/6531',0,5,NULL,1,NULL),(11346,'product',6532,'bette-classic-steel-bath-170-x-80cm.html','catalog/product/view/id/6532',0,5,NULL,1,NULL),(11347,'product',6533,'bette-classic-steel-bath-175-x-75cm.html','catalog/product/view/id/6533',0,5,NULL,1,NULL),(11348,'product',6534,'bette-classic-steel-bath-190-x-80cm.html','catalog/product/view/id/6534',0,5,NULL,1,NULL),(11349,'product',6535,'bette-starlet-steel-bath-1850-x-850mm.html','catalog/product/view/id/6535',0,5,NULL,1,NULL),(11350,'product',6536,'bette-select-steel-single-ended-bath.html','catalog/product/view/id/6536',0,5,NULL,1,NULL),(11351,'product',6537,'bette-comodo-steel-bath.html','catalog/product/view/id/6537',0,5,NULL,1,NULL),(11352,'product',6538,'bette-comodo-steel-bath-1700-x-800mm-no-th.html','catalog/product/view/id/6538',0,5,NULL,1,NULL),(11353,'product',6539,'bette-comodo-steel-bath-1800-x-800mm-no-th.html','catalog/product/view/id/6539',0,5,NULL,1,NULL),(11354,'product',6540,'bette-duett-super-steel-rectangular-bath-1700-x-750mm.html','catalog/product/view/id/6540',0,5,NULL,1,NULL),(11355,'product',6541,'bette-duett-super-steel-rectangular-bath-1700-x-800mm.html','catalog/product/view/id/6541',0,5,NULL,1,NULL),(11356,'product',6542,'bette-free-super-steel-double-ended-rectangular-bath-1700-x-750mm.html','catalog/product/view/id/6542',0,5,NULL,1,NULL),(11357,'product',6543,'bette-free-super-steel-double-ended-rectangular-bath-1800-x-800mm.html','catalog/product/view/id/6543',0,5,NULL,1,NULL),(11358,'product',6544,'bette-free-super-steel-double-ended-rectangular-bath-1900-x-900mm.html','catalog/product/view/id/6544',0,5,NULL,1,NULL),(11359,'product',6545,'bette-free-super-steel-double-ended-rectangular-bath-2000-x-1000mm.html','catalog/product/view/id/6545',0,5,NULL,1,NULL),(11360,'product',6546,'vitra-balance-single-ended-rectangular-bath.html','catalog/product/view/id/6546',0,5,NULL,1,NULL),(11361,'product',6547,'vitra-balance-single-ended-rectangular-1500-x-700mm-bath.html','catalog/product/view/id/6547',0,5,NULL,1,NULL),(11362,'product',6548,'vitra-balance-single-ended-rectangular-1600-x-700mm-bath.html','catalog/product/view/id/6548',0,5,NULL,1,NULL),(11363,'product',6549,'vitra-balance-single-ended-rectangular-1700-x-700mm-bath.html','catalog/product/view/id/6549',0,5,NULL,1,NULL),(11364,'product',6550,'vitra-neon-single-ended-rectangular-bath.html','catalog/product/view/id/6550',0,5,NULL,1,NULL),(11365,'product',6551,'vitra-neon-single-ended-rectangular-bath-1500-x-700mm.html','catalog/product/view/id/6551',0,5,NULL,1,NULL),(11366,'product',6552,'vitra-neonsingle-ended-rectangular-1600-x-700mm-bath.html','catalog/product/view/id/6552',0,5,NULL,1,NULL),(11367,'product',6553,'vitra-neon-single-ended-rectangular-1600-x-750mm-bath.html','catalog/product/view/id/6553',0,5,NULL,1,NULL),(11368,'product',6554,'vitra-neon-single-ended-rectangular-1700-x-700mm-bath.html','catalog/product/view/id/6554',0,5,NULL,1,NULL),(11369,'product',6555,'vitra-neon-single-ended-rectangular-1700-x-750mm-bath.html','catalog/product/view/id/6555',0,5,NULL,1,NULL),(11370,'product',6556,'vitra-neon-shower-single-ended-1700-x-850mm-bath.html','catalog/product/view/id/6556',0,5,NULL,1,NULL),(11371,'product',6557,'vitra-neon-double-ended-rectangular-1800-x-800mm-bath.html','catalog/product/view/id/6557',0,5,NULL,1,NULL),(11372,'product',6558,'vitra-optima-rectangular-single-ended-bath.html','catalog/product/view/id/6558',0,5,NULL,1,NULL),(11373,'product',6559,'vitra-optima-1500-x-700mm-single-ended-rectangular-bath.html','catalog/product/view/id/6559',0,5,NULL,1,NULL),(11374,'product',6560,'vitra-optima-rectangular-single-ended-1600-x-700mm-bath.html','catalog/product/view/id/6560',0,5,NULL,1,NULL),(11375,'product',6561,'vitra-optima-single-ended-rectangular-1700-x-700mm-bath.html','catalog/product/view/id/6561',0,5,NULL,1,NULL),(11376,'product',6562,'vitra-optima-single-ended-rectangular-1700-x-750mm-bath.html','catalog/product/view/id/6562',0,5,NULL,1,NULL),(11377,'product',6563,'vitra-silence-freestanding-bath-1700-x-900mm.html','catalog/product/view/id/6563',0,5,NULL,1,NULL),(11378,'product',6564,'nuie-square-l-shaped-shower-bath-1500-x-850mm.html','catalog/product/view/id/6564',0,5,NULL,1,NULL),(11379,'product',6565,'nuie-square-l-shaped-shower-bath-1600-x-850mm.html','catalog/product/view/id/6565',0,5,NULL,1,NULL),(11380,'product',6566,'nuie-square-l-shaped-shower-bath-1700-x-850mm.html','catalog/product/view/id/6566',0,5,NULL,1,NULL),(11381,'product',6567,'nuie-square-b-shaped-shower-bath-1500-x-900mm.html','catalog/product/view/id/6567',0,5,NULL,1,NULL),(11382,'product',6568,'nuie-square-b-shaped-shower-bath-1700-x-900mm.html','catalog/product/view/id/6568',0,5,NULL,1,NULL),(11383,'product',6569,'nuie-square-p-shaped-shower-bath-1500-x-850mm.html','catalog/product/view/id/6569',0,5,NULL,1,NULL),(11384,'product',6570,'nuie-square-p-shaped-shower-bath-1600-x-850mm.html','catalog/product/view/id/6570',0,5,NULL,1,NULL),(11385,'product',6571,'nuie-square-p-shaped-shower-bath-1700-x-850mm.html','catalog/product/view/id/6571',0,5,NULL,1,NULL),(11386,'product',6572,'bette-select-duo-rectangular-white-bath-1800-x-800mm.html','catalog/product/view/id/6572',0,5,NULL,1,NULL);
/*!40000 ALTER TABLE `url_rewrite` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `variable`
--

DROP TABLE IF EXISTS `variable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `variable` (
  `variable_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Variable ID',
  `code` varchar(255) DEFAULT NULL COMMENT 'Variable Code',
  `name` varchar(255) DEFAULT NULL COMMENT 'Variable Name',
  PRIMARY KEY (`variable_id`),
  UNIQUE KEY `VARIABLE_CODE` (`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Variables';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `variable`
--

LOCK TABLES `variable` WRITE;
/*!40000 ALTER TABLE `variable` DISABLE KEYS */;
/*!40000 ALTER TABLE `variable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `variable_value`
--

DROP TABLE IF EXISTS `variable_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `variable_value` (
  `value_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Variable Value ID',
  `variable_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Variable ID',
  `store_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `plain_value` text COMMENT 'Plain Text Value',
  `html_value` text COMMENT 'Html Value',
  PRIMARY KEY (`value_id`),
  UNIQUE KEY `VARIABLE_VALUE_VARIABLE_ID_STORE_ID` (`variable_id`,`store_id`),
  KEY `VARIABLE_VALUE_STORE_ID` (`store_id`),
  CONSTRAINT `VARIABLE_VALUE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE,
  CONSTRAINT `VARIABLE_VALUE_VARIABLE_ID_VARIABLE_VARIABLE_ID` FOREIGN KEY (`variable_id`) REFERENCES `variable` (`variable_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Variable Value';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `variable_value`
--

LOCK TABLES `variable_value` WRITE;
/*!40000 ALTER TABLE `variable_value` DISABLE KEYS */;
/*!40000 ALTER TABLE `variable_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vault_payment_token`
--

DROP TABLE IF EXISTS `vault_payment_token`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `vault_payment_token` (
  `entity_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',
  `customer_id` int unsigned DEFAULT NULL COMMENT 'Customer ID',
  `website_id` int unsigned DEFAULT NULL COMMENT 'Website ID',
  `public_hash` varchar(128) NOT NULL COMMENT 'Hash code for using on frontend',
  `payment_method_code` varchar(128) NOT NULL COMMENT 'Payment method code',
  `type` varchar(128) NOT NULL COMMENT 'Type',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `expires_at` timestamp NULL DEFAULT NULL COMMENT 'Expires At',
  `gateway_token` varchar(255) NOT NULL COMMENT 'Gateway Token',
  `details` text COMMENT 'Details',
  `is_active` tinyint(1) NOT NULL DEFAULT '1',
  `is_visible` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`entity_id`),
  UNIQUE KEY `VAULT_PAYMENT_TOKEN_PUBLIC_HASH` (`public_hash`),
  UNIQUE KEY `VAULT_PAYMENT_TOKEN_PAYMENT_METHOD_CODE_CSTR_ID_GATEWAY_TOKEN` (`payment_method_code`,`customer_id`,`gateway_token`),
  KEY `VAULT_PAYMENT_TOKEN_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` (`customer_id`),
  CONSTRAINT `VAULT_PAYMENT_TOKEN_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Vault tokens of payment';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vault_payment_token`
--

LOCK TABLES `vault_payment_token` WRITE;
/*!40000 ALTER TABLE `vault_payment_token` DISABLE KEYS */;
/*!40000 ALTER TABLE `vault_payment_token` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vault_payment_token_order_payment_link`
--

DROP TABLE IF EXISTS `vault_payment_token_order_payment_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `vault_payment_token_order_payment_link` (
  `order_payment_id` int unsigned NOT NULL COMMENT 'Order payment ID',
  `payment_token_id` int unsigned NOT NULL COMMENT 'Payment token ID',
  PRIMARY KEY (`order_payment_id`,`payment_token_id`),
  KEY `FK_4ED894655446D385894580BECA993862` (`payment_token_id`),
  CONSTRAINT `FK_4ED894655446D385894580BECA993862` FOREIGN KEY (`payment_token_id`) REFERENCES `vault_payment_token` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `FK_CF37B9D854256534BE23C818F6291CA2` FOREIGN KEY (`order_payment_id`) REFERENCES `sales_order_payment` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Order payments to vault token';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vault_payment_token_order_payment_link`
--

LOCK TABLES `vault_payment_token_order_payment_link` WRITE;
/*!40000 ALTER TABLE `vault_payment_token_order_payment_link` DISABLE KEYS */;
/*!40000 ALTER TABLE `vault_payment_token_order_payment_link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ves_all_license`
--

DROP TABLE IF EXISTS `ves_all_license`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `ves_all_license` (
  `license_id` smallint NOT NULL AUTO_INCREMENT COMMENT 'License ID',
  `extension_code` varchar(255) NOT NULL COMMENT 'Extension Code',
  `extension_name` varchar(255) NOT NULL COMMENT 'Extension Name',
  `status` smallint NOT NULL COMMENT 'Status',
  `license` text COMMENT 'License key',
  `description` text COMMENT 'module description',
  `created_at` timestamp NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'created at',
  `expired_time` timestamp NULL DEFAULT NULL COMMENT 'expired time',
  PRIMARY KEY (`license_id`),
  KEY `VES_ALL_LICENSE_LICENSE_ID` (`license_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='ves_all_license';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ves_all_license`
--

LOCK TABLES `ves_all_license` WRITE;
/*!40000 ALTER TABLE `ves_all_license` DISABLE KEYS */;
/*!40000 ALTER TABLE `ves_all_license` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ves_brand`
--

DROP TABLE IF EXISTS `ves_brand`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `ves_brand` (
  `brand_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Brand ID',
  `name` varchar(255) NOT NULL COMMENT 'Brand Name',
  `url_key` varchar(255) NOT NULL COMMENT 'Brand Url Key',
  `description` text NOT NULL COMMENT 'Brand Description',
  `group_id` int unsigned NOT NULL COMMENT 'Group ID',
  `image` varchar(255) NOT NULL COMMENT 'Brand Image',
  `thumbnail` varchar(255) NOT NULL COMMENT 'Brand Thumbnail',
  `page_title` varchar(255) NOT NULL COMMENT 'Brand Page Title',
  `meta_keywords` text NOT NULL COMMENT 'Meta Keywords',
  `meta_description` text NOT NULL COMMENT 'Meta Description',
  `creation_time` timestamp NULL DEFAULT NULL COMMENT 'Brand Creation Time',
  `update_time` timestamp NULL DEFAULT NULL COMMENT 'Brand Modification Time',
  `page_layout` varchar(255) DEFAULT NULL COMMENT 'Page Layout',
  `layout_update_xml` text COMMENT 'Page Layout Update Content',
  `status` smallint NOT NULL DEFAULT '1' COMMENT 'Status',
  `featured` smallint DEFAULT '0' COMMENT 'featured',
  `position` int NOT NULL DEFAULT '0' COMMENT 'Position',
  PRIMARY KEY (`brand_id`),
  KEY `VES_BRAND_GROUP_ID` (`group_id`),
  CONSTRAINT `VES_BRAND_GROUP_ID_VES_BRAND_GROUP_ID` FOREIGN KEY (`group_id`) REFERENCES `ves_brand_group` (`group_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Brand Information';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ves_brand`
--

LOCK TABLES `ves_brand` WRITE;
/*!40000 ALTER TABLE `ves_brand` DISABLE KEYS */;
/*!40000 ALTER TABLE `ves_brand` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ves_brand_group`
--

DROP TABLE IF EXISTS `ves_brand_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `ves_brand_group` (
  `group_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Group ID',
  `name` varchar(255) NOT NULL COMMENT 'Group Name',
  `url_key` varchar(255) NOT NULL COMMENT 'Group Url Key',
  `position` int NOT NULL DEFAULT '0' COMMENT 'Position',
  `status` smallint NOT NULL DEFAULT '1' COMMENT 'Status',
  `shown_in_sidebar` smallint NOT NULL DEFAULT '1' COMMENT 'Show In Sidebar',
  PRIMARY KEY (`group_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Brand Group';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ves_brand_group`
--

LOCK TABLES `ves_brand_group` WRITE;
/*!40000 ALTER TABLE `ves_brand_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `ves_brand_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ves_brand_product`
--

DROP TABLE IF EXISTS `ves_brand_product`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `ves_brand_product` (
  `brand_id` int unsigned NOT NULL COMMENT 'Brand ID',
  `product_id` int unsigned NOT NULL COMMENT 'Product ID',
  `position` int DEFAULT NULL COMMENT 'Position',
  PRIMARY KEY (`brand_id`,`product_id`),
  KEY `VES_BRAND_PRODUCT_PRODUCT_ID_CATALOG_PRODUCT_ENTITY_ENTITY_ID` (`product_id`),
  CONSTRAINT `VES_BRAND_PRODUCT_BRAND_ID_VES_BRAND_BRAND_ID` FOREIGN KEY (`brand_id`) REFERENCES `ves_brand` (`brand_id`) ON DELETE CASCADE,
  CONSTRAINT `VES_BRAND_PRODUCT_PRODUCT_ID_CATALOG_PRODUCT_ENTITY_ENTITY_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Ves Brand To Product Linkage Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ves_brand_product`
--

LOCK TABLES `ves_brand_product` WRITE;
/*!40000 ALTER TABLE `ves_brand_product` DISABLE KEYS */;
/*!40000 ALTER TABLE `ves_brand_product` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ves_brand_store`
--

DROP TABLE IF EXISTS `ves_brand_store`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `ves_brand_store` (
  `brand_id` int unsigned NOT NULL COMMENT 'Brand Id',
  `store_id` smallint unsigned NOT NULL COMMENT 'Store Id',
  PRIMARY KEY (`brand_id`,`store_id`),
  KEY `VES_BRAND_STORE_STORE_ID` (`store_id`),
  CONSTRAINT `VES_BRAND_STORE_BRAND_ID_VES_BRAND_BRAND_ID` FOREIGN KEY (`brand_id`) REFERENCES `ves_brand` (`brand_id`) ON DELETE CASCADE,
  CONSTRAINT `VES_BRAND_STORE_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Brand Store';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ves_brand_store`
--

LOCK TABLES `ves_brand_store` WRITE;
/*!40000 ALTER TABLE `ves_brand_store` DISABLE KEYS */;
/*!40000 ALTER TABLE `ves_brand_store` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `weee_tax`
--

DROP TABLE IF EXISTS `weee_tax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `weee_tax` (
  `value_id` int NOT NULL AUTO_INCREMENT COMMENT 'Value ID',
  `website_id` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID',
  `entity_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `country` varchar(2) DEFAULT NULL COMMENT 'Country',
  `value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Value',
  `state` int NOT NULL DEFAULT '0' COMMENT 'State',
  `attribute_id` smallint unsigned NOT NULL COMMENT 'Attribute ID',
  PRIMARY KEY (`value_id`),
  KEY `WEEE_TAX_WEBSITE_ID` (`website_id`),
  KEY `WEEE_TAX_ENTITY_ID` (`entity_id`),
  KEY `WEEE_TAX_COUNTRY` (`country`),
  KEY `WEEE_TAX_ATTRIBUTE_ID` (`attribute_id`),
  CONSTRAINT `WEEE_TAX_ATTRIBUTE_ID_EAV_ATTRIBUTE_ATTRIBUTE_ID` FOREIGN KEY (`attribute_id`) REFERENCES `eav_attribute` (`attribute_id`) ON DELETE CASCADE,
  CONSTRAINT `WEEE_TAX_COUNTRY_DIRECTORY_COUNTRY_COUNTRY_ID` FOREIGN KEY (`country`) REFERENCES `directory_country` (`country_id`) ON DELETE CASCADE,
  CONSTRAINT `WEEE_TAX_ENTITY_ID_CATALOG_PRODUCT_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `WEEE_TAX_WEBSITE_ID_STORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `store_website` (`website_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Weee Tax';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `weee_tax`
--

LOCK TABLES `weee_tax` WRITE;
/*!40000 ALTER TABLE `weee_tax` DISABLE KEYS */;
/*!40000 ALTER TABLE `weee_tax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `widget`
--

DROP TABLE IF EXISTS `widget`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `widget` (
  `widget_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Widget ID',
  `widget_code` varchar(255) DEFAULT NULL COMMENT 'Widget code for template directive',
  `widget_type` varchar(255) DEFAULT NULL COMMENT 'Widget Type',
  `parameters` text COMMENT 'Parameters',
  PRIMARY KEY (`widget_id`),
  KEY `WIDGET_WIDGET_CODE` (`widget_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Preconfigured Widgets';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `widget`
--

LOCK TABLES `widget` WRITE;
/*!40000 ALTER TABLE `widget` DISABLE KEYS */;
/*!40000 ALTER TABLE `widget` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `widget_instance`
--

DROP TABLE IF EXISTS `widget_instance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `widget_instance` (
  `instance_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Instance ID',
  `instance_type` varchar(255) DEFAULT NULL COMMENT 'Instance Type',
  `theme_id` int unsigned NOT NULL COMMENT 'Theme ID',
  `title` varchar(255) DEFAULT NULL COMMENT 'Widget Title',
  `store_ids` varchar(255) NOT NULL DEFAULT '0' COMMENT 'Store ids',
  `widget_parameters` text COMMENT 'Widget parameters',
  `sort_order` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Sort order',
  PRIMARY KEY (`instance_id`),
  KEY `WIDGET_INSTANCE_THEME_ID_THEME_THEME_ID` (`theme_id`),
  CONSTRAINT `WIDGET_INSTANCE_THEME_ID_THEME_THEME_ID` FOREIGN KEY (`theme_id`) REFERENCES `theme` (`theme_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Instances of Widget for Package Theme';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `widget_instance`
--

LOCK TABLES `widget_instance` WRITE;
/*!40000 ALTER TABLE `widget_instance` DISABLE KEYS */;
/*!40000 ALTER TABLE `widget_instance` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `widget_instance_page`
--

DROP TABLE IF EXISTS `widget_instance_page`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `widget_instance_page` (
  `page_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Page ID',
  `instance_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Instance ID',
  `page_group` varchar(25) DEFAULT NULL COMMENT 'Block Group Type',
  `layout_handle` varchar(255) DEFAULT NULL COMMENT 'Layout Handle',
  `block_reference` varchar(255) DEFAULT NULL COMMENT 'Container',
  `page_for` varchar(25) DEFAULT NULL COMMENT 'For instance entities',
  `entities` text COMMENT 'Catalog entities (comma separated)',
  `page_template` varchar(255) DEFAULT NULL COMMENT 'Path to widget template',
  PRIMARY KEY (`page_id`),
  KEY `WIDGET_INSTANCE_PAGE_INSTANCE_ID` (`instance_id`),
  CONSTRAINT `WIDGET_INSTANCE_PAGE_INSTANCE_ID_WIDGET_INSTANCE_INSTANCE_ID` FOREIGN KEY (`instance_id`) REFERENCES `widget_instance` (`instance_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Instance of Widget on Page';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `widget_instance_page`
--

LOCK TABLES `widget_instance_page` WRITE;
/*!40000 ALTER TABLE `widget_instance_page` DISABLE KEYS */;
/*!40000 ALTER TABLE `widget_instance_page` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `widget_instance_page_layout`
--

DROP TABLE IF EXISTS `widget_instance_page_layout`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `widget_instance_page_layout` (
  `page_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Page ID',
  `layout_update_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Layout Update ID',
  PRIMARY KEY (`layout_update_id`,`page_id`),
  KEY `WIDGET_INSTANCE_PAGE_LAYOUT_PAGE_ID` (`page_id`),
  CONSTRAINT `WIDGET_INSTANCE_PAGE_LAYOUT_PAGE_ID_WIDGET_INSTANCE_PAGE_PAGE_ID` FOREIGN KEY (`page_id`) REFERENCES `widget_instance_page` (`page_id`) ON DELETE CASCADE,
  CONSTRAINT `WIDGET_INSTANCE_PAGE_LYT_LYT_UPDATE_ID_LYT_UPDATE_LYT_UPDATE_ID` FOREIGN KEY (`layout_update_id`) REFERENCES `layout_update` (`layout_update_id`) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb3 COMMENT='Layout updates';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `widget_instance_page_layout`
--

LOCK TABLES `widget_instance_page_layout` WRITE;
/*!40000 ALTER TABLE `widget_instance_page_layout` DISABLE KEYS */;
/*!40000 ALTER TABLE `widget_instance_page_layout` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wishlist`
--

DROP TABLE IF EXISTS `wishlist`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `wishlist` (
  `wishlist_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Wishlist ID',
  `customer_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Customer ID',
  `shared` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'Sharing flag (0 or 1)',
  `sharing_code` varchar(32) DEFAULT NULL COMMENT 'Sharing encrypted code',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Last updated date',
  PRIMARY KEY (`wishlist_id`),
  UNIQUE KEY `WISHLIST_CUSTOMER_ID` (`customer_id`),
  KEY `WISHLIST_SHARED` (`shared`),
  CONSTRAINT `WISHLIST_CUSTOMER_ID_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`customer_id`) REFERENCES `customer_entity` (`entity_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb3 COMMENT='Wishlist main Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wishlist`
--

LOCK TABLES `wishlist` WRITE;
/*!40000 ALTER TABLE `wishlist` DISABLE KEYS */;
INSERT INTO `wishlist` VALUES (1,1,0,'St8cknpwhsEA5dguEMOsiAfu620NLKyl','2024-09-18 09:26:10');
/*!40000 ALTER TABLE `wishlist` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wishlist_item`
--

DROP TABLE IF EXISTS `wishlist_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `wishlist_item` (
  `wishlist_item_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Wishlist item ID',
  `wishlist_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Wishlist ID',
  `product_id` int unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `store_id` smallint unsigned DEFAULT NULL COMMENT 'Store ID',
  `added_at` timestamp NULL DEFAULT NULL COMMENT 'Add date and time',
  `description` text COMMENT 'Short description of wish list item',
  `qty` decimal(12,4) NOT NULL COMMENT 'Qty',
  PRIMARY KEY (`wishlist_item_id`),
  KEY `WISHLIST_ITEM_WISHLIST_ID` (`wishlist_id`),
  KEY `WISHLIST_ITEM_PRODUCT_ID` (`product_id`),
  KEY `WISHLIST_ITEM_STORE_ID` (`store_id`),
  CONSTRAINT `WISHLIST_ITEM_PRODUCT_ID_CATALOG_PRODUCT_ENTITY_ENTITY_ID` FOREIGN KEY (`product_id`) REFERENCES `catalog_product_entity` (`entity_id`) ON DELETE CASCADE,
  CONSTRAINT `WISHLIST_ITEM_STORE_ID_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `store` (`store_id`) ON DELETE SET NULL,
  CONSTRAINT `WISHLIST_ITEM_WISHLIST_ID_WISHLIST_WISHLIST_ID` FOREIGN KEY (`wishlist_id`) REFERENCES `wishlist` (`wishlist_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8mb3 COMMENT='Wishlist items';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wishlist_item`
--

LOCK TABLES `wishlist_item` WRITE;
/*!40000 ALTER TABLE `wishlist_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `wishlist_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wishlist_item_option`
--

DROP TABLE IF EXISTS `wishlist_item_option`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `wishlist_item_option` (
  `option_id` int unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option ID',
  `wishlist_item_id` int unsigned NOT NULL COMMENT 'Wishlist Item ID',
  `product_id` int unsigned NOT NULL COMMENT 'Product ID',
  `code` varchar(255) NOT NULL COMMENT 'Code',
  `value` text COMMENT 'Value',
  PRIMARY KEY (`option_id`),
  KEY `FK_A014B30B04B72DD0EAB3EECD779728D6` (`wishlist_item_id`),
  CONSTRAINT `FK_A014B30B04B72DD0EAB3EECD779728D6` FOREIGN KEY (`wishlist_item_id`) REFERENCES `wishlist_item` (`wishlist_item_id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8mb3 COMMENT='Wishlist Item Option Table';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wishlist_item_option`
--

LOCK TABLES `wishlist_item_option` WRITE;
/*!40000 ALTER TABLE `wishlist_item_option` DISABLE KEYS */;
/*!40000 ALTER TABLE `wishlist_item_option` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Final view structure for view `inventory_stock_1`
--

/*!50001 DROP VIEW IF EXISTS `inventory_stock_1`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb3 */;
/*!50001 SET character_set_results     = utf8mb3 */;
/*!50001 SET collation_connection      = utf8mb3_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`root`@`localhost` SQL SECURITY INVOKER */
/*!50001 VIEW `inventory_stock_1` AS select distinct `legacy_stock_status`.`product_id` AS `product_id`,`legacy_stock_status`.`website_id` AS `website_id`,`legacy_stock_status`.`stock_id` AS `stock_id`,`legacy_stock_status`.`qty` AS `quantity`,`legacy_stock_status`.`stock_status` AS `is_salable`,`product`.`sku` AS `sku` from (`cataloginventory_stock_status` `legacy_stock_status` join `catalog_product_entity` `product` on((`legacy_stock_status`.`product_id` = `product`.`entity_id`))) */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2025-02-05  7:58:29
